# General Information

## Contact and availability

GILDAS home page:

`https://www.iram.fr/IRAMFR/GILDAS`

The most recent GILDAS version is available in the
[INSTALL > DOWNLOAD](https://www.iram.fr/IRAMFR/GILDAS/install.html#ii---download)
section of this web page.

## Introduction

GILDAS is a collection of state-of-the-art software oriented toward
(sub-)millimeter radioastronomical applications (either single-dish or
interferometer). It is daily used to reduce all data acquired with the
[IRAM](https://iram-institute.org/)
[30m](https://iram-institute.org/science-portal/30-meter-telescope/)
telescope and the NOrthern Extended Millimeter Array
[NOEMA](https://www.iram-institute.org/science-portal/noema/) (except
VLBI observations). GILDAS is written in Fortran 2013, with a few parts
in C/C++ (mainly keyboard interaction, plotting, widgets) and others in
Python (e.g. CLASS\\WEEDS).

## Other information

Many more information may be found in:

- `CREDITS.md`   List of historical developers and current maintainers
- `INSTALL.md`   Installation guidelines
- `VERSION`      Version you are looking at
- `NEWS.md`      Last major changes commented
- `ONEWS.md`     Older changes commented
- `Tree-Structure` Description of the tree structure

Weeds
=====

What is Weeds?
--------------

Weeds is a package for the Gildas radioastronomy software which is
intented to ease the data reduction of spectral surveys or spectral
lines observations with large bandwidths. Weeds provides a command to
identify lines on a spectrum using VO-compliant spectrocopic
databases, which are accessed on-line using the SLAP protocol. In
addition, Weeds provides a command to perform a simple modelling of
the observed spectra, under the assumption of local thermodynamic
equilibrium. Together with the catalog query command, the modelling
tool allows to efficiently identify line on crowded spectrum, where
the line overlap can be important. Weeds development was inspired by
other packages, such as XCLASS and CASSIS. Both Weeds and XCLASS are
extensions of the widely used CLASS spectra reduction software, which
is part of GILDAS; this allows to reduce and analyze spectral surveys
within the same environment. However, unlike XCLASS, Weeds is
distributed with GILDAS as a contributed package, and it uses the most
recent CLASS version (CLASS90). Another difference between Weeds and
both XCLASS and CASSIS is that Weeds access to spectral catalogs
on-line. Consequently any changes in these catalogs (e.g. line
additions) are readily available in Weeds. Nevertheless, Weeds can
make a local copy of a spectral line catalog, for offline
searches. This is useful when you want to use Weeds with no (or a
slow) internet connection. All this make Weeds a lightweight,
easy-to-install and efficient alternative to other spectral line
analysis packages.

Installation
------------

Weeds is included in the standard Gildas distribution. It is installed
automatically if you have Python 2.6 and Numpy installed on your
computer.

Documentation
-------------

Weeds comes with a documentation manual. The LaTeX source of the
manual can be found in the doc/ directory.

Reporting bugs
--------------

A list of known bugs can be found in the BUGS file. If you find a bug
which is not listed in these files please report it to
<gildas@iram.fr>

# GILDAS Syntax Highlighting

This extension provides TextMate grammars and language configuration
for GILDAS scripting languages.

## Supported programs

- SIC (`.sic`, `.pro`)
- GREG (`.greg`)
- ASTRO (`.astro`)
- CUBE (`.cube`)
- CLASS (`.class`, `.class77`)
- MRTCAL (`.cal`)
- CLIC (`.clic`)
- MAPPING (`.map`)
- MRTHOLO (`.holo`)

## Features

- Syntax highlighting for commands, keywords, operators, and built-in
  functions.
- Language prefixes (e.g., `SIC\`, `GREG1\`, `ASTRO\`) are recognized.
- Abbreviated commands (3+ letters) are supported.
- Comment lines use `!`.
- Folding/indent rules for `FOR` / `NEXT`, in addition to the usual
  `IF` and `BEGIN` / `END` blocks.

## Install locally in VS Code

1. In VS Code, run **Extensions: Install from Location...**
2. Select the folder `.../gildas-src-xxx/admin/syntax/TextMate`
3. Reload the window when prompted

## Notes

- Command matching is anchored to the start of a line and requires a
  space (or end-of-line) after the command.
- Continuation lines with trailing `-` are not parsed as a single
  logical line; highlighting is line-based.

subroutine classic_file_init(file,version,reclen,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_file_init
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  !   Initialize a new Classic file. The following elements must have
  ! been set before:
  !   file%lun
  !   file%spec
  !   file%nspec
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file     !
  integer(kind=4),      intent(in)    :: version  ! File version
  integer(kind=4),      intent(in)    :: reclen   ! Record length (words)
  logical,              intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE'
  character(len=message_length) :: mess
  !
  if (.not.classic_initialized) then
    call classic_message(seve%e,rname,  &
      'Programming error: Classic library must be initialized first')
    error = .true.
    return
  endif
  !
  if (version.ne.1 .and. version.ne.2) then
    write(mess,'(A,I0)')  'Unsupported File Version ',version
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (version.eq.1) then
    if (reclen.ne.128) then
      write(mess,'(A,I0,A)')  &
        'Version 1 file must have 128-words long records (got ',reclen,')'
      call classic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  else
    write(mess,'(A,I0,A)')  'File is version 2 (record length: ',reclen,' words)'
    call classic_message(seve%d,rname,mess)
  endif
  !
  file%desc%version = version
  file%desc%reclen = reclen
  file%readwrite = .true.
  !
  ! Fortran open the (new) file
  call classic_file_fopen(file,'NEW',error)
  if (error)  return
  !
end subroutine classic_file_init
!
subroutine classic_file_open(file,readwrite,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_file_open
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  !   Open an old Classic file. The following elements must have been
  ! set before:
  !   file%lun
  !   file%spec
  !   file%nspec
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file       !
  logical,              intent(in)    :: readwrite  !
  logical,              intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE'
  !
  if (.not.classic_initialized) then
    call classic_message(seve%e,rname,  &
      'Programming error: Classic library must be initialized first')
    error = .true.
    return
  endif
  !
  file%readwrite = readwrite
  file%desc%reclen = classic_reclen_v1  ! Default size, will be reopened if
                                        ! necessary when File Descriptor is read
  !
  ! Fortran open the (new) file
  call classic_file_fopen(file,'OLD',error)
  if (error)  return
  !
end subroutine classic_file_open
!
subroutine classic_file_close(file,error)
  use classic_types
  use classic_interfaces, except_this=>classic_file_close
  !---------------------------------------------------------------------
  ! @ public
  !  Perform the needed operations to close a classic_file_t structure
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file   !
  logical,              intent(inout) :: error  !
  !
  call deallocate_aex(file%desc,error)
  ! if (error)  continue
  !
  call classic_file_fclose(file,error)
  ! if (error)  continue
  !
end subroutine classic_file_close
!
!-----------------------------------------------------------------------
!
subroutine classic_file_fopen(file,statu,error)
  use gbl_format
  use gbl_message
  use classic_types
  use classic_interfaces, except_this=>classic_file_fopen
  !---------------------------------------------------------------------
  ! @ public
  !  Fortran-open the given Classic file. The following elements must
  ! have been set before:
  !   file%lun
  !   file%spec
  !   file%nspec
  !   file%readwrite
  !   file%desc%reclen
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: file   !
  character(len=*),     intent(in)    :: statu  ! 'OLD' or 'NEW'
  logical,              intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='OPEN'
  integer(kind=4) :: ier
  character(len=9) :: actio
  !
  if (file%readwrite) then
    actio = 'READWRITE'
  else
    actio = 'READ'
  endif
  !
  open(unit=file%lun,                 &
       file=file%spec(1:file%nspec),  &
       access='DIRECT',               &
       form='UNFORMATTED',            &
       recl=facunf*file%desc%reclen,  &
       status=statu,                  &
       action=actio,                  &
       iostat=ier)
  !
  if (ier.ne.0) then
    error = .true.
    call classic_message(seve%e,rname,'Open error file '//file%spec)
    call classic_iostat(seve%e,rname,ier)
    return
  endif
  !
end subroutine classic_file_fopen
!
subroutine classic_file_fclose(file,error)
  use gbl_message
  use classic_types
  use classic_interfaces, except_this=>classic_file_fclose
  !---------------------------------------------------------------------
  ! @ public
  !  Fortran-close the given Classic file. The following elements must
  ! have been set before:
  !   file%lun
  !   file%spec
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: file   !
  logical,              intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='CLOSE'
  integer(kind=4) :: ier
  !
  close(unit=file%lun,iostat=ier)
  !
  if (ier.ne.0) then
    error = .true.
    call classic_message(seve%e,rname,'Close error file '//file%spec)
    call classic_iostat(seve%e,rname,ier)
    return
  endif
  !
end subroutine classic_file_fclose
!
subroutine classic_file_fflush(file,error)
  use gbl_message
  use classic_types
  use classic_interfaces, except_this=>classic_file_fflush
  !---------------------------------------------------------------------
  ! @ public
  ! Fortran-flush the given Classic file. According to Fortran:
  !   "Execution of a FLUSH statement causes data written to an
  !    external file to be available to other processes, or causes data
  !    placed in an external file by means other than Fortran to be
  !    available to a READ statement. These actions are processor
  !    dependent."
  ! In other words, it works on both writing and reading files.
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: file   !
  logical,              intent(inout) :: error  !
  ! Local
#if defined(FORTRAN2003)
  character(len=*), parameter :: rname='FLUSH'
  integer(kind=4) :: ier
  !
  flush(unit=file%lun,iostat=ier)
  !
  if (ier.ne.0) then
    error = .true.
    call classic_message(seve%e,rname,'Flush error file '//file%spec)
    call classic_iostat(seve%e,rname,ier)
    return
  endif
#else
  logical :: lerror  ! Local error flag
  !
  ! Close and reopen the file
  lerror = .false.
  call classic_file_fclose(file,lerror)
  if (lerror) then
    error = .true.
    return
  endif
  call classic_file_fopen(file,'OLD',error)
  if (lerror) then
    error = .true.
    return
  endif
#endif
  !
end subroutine classic_file_fflush

!c**********************************************************************
!       Takes the file  wk%%%%v%.dat  and makes the plot of the
!       projects  schedule  of two weeks and produces   output files
!       wk%%%%v%.out that contains the number of hours for each
!       project and a postscript file wk%%%%v%%.ps
!       Unix version Dec-96  M.Ruiz
!       Modified Nov-97  M.Ruiz (requested by MG)
!       Modified Mar-98  M.Ruiz (requested by CT)
!       Modified Apr-98  M.Ruiz (requested by CT)
!       /mrt-ux1_users/mrt/ruiz/biweek/biweek.f is this file
!       /thum/sched/progs/bw_01.f        ct modifications 08-apr-1998
!       bw_02.f version No. in fn; LST lines fixed.       mr 20-apr-1998
!       bw_04.f includind four-week option                mr 24-oct-1998
!       different file name for four-week.ps              ct 04-nov-1998
!       new information: sun rise and sun set             mr 02-aug-1999
!       new information: comments of projects             mr 28-aug-1999
!       modifed hsidnew: LST lines do not cross frame     ct 16-oct-1999
!       modification to reset comments                    mr 29-dec-1999
!       small modification to reset comments              mr 20-feb-2000
!       comments written left justified                   ct 20-feb-2000
!       increase no of projects 40->50                    ct 01-mar-2000
!       introduced a space before each / in greg commands ct 14-apr-2000
!       and remove .out file before creating a new one
!       new mappinf features                              mr aug-00
!       keyword=kw001 gifcoor get coordinates             mr aug-00
!       keyword=kw002 makehtml1 make page html            mr aug-00
!       keyword=kw003 makemap   make map for gif          mr aug-00
!       keyword=kw004 makehtml2 make page html            mr aug-00
!       keyword=kw005 convert file ps to gif              mr aug-00
!       comments coordinates in day, hour
!       (now again in x(0..24) y(1..15)                   mr jul-01
!       option to create only some of the html files      mr jul-01
!       compatible with linux                             mr aug-01
!       test to create html files                         mr apr-02
!       correction in version number                      mr may-02
!       error in second file name (4-week)                ct jun-02
!       change in lines width                             mr oct-02
!       change in the name of projects html files         mr oct-02
!       add copy to web page (failed)                     ct jan-03
!       ALL BACKSLASHES-> CHAR(XY)                        hw apr-03
!       reorganization of output to .out file             mr may-03
!       J.Pety version, linked to DELL GILDAS by AWS      as 10-may-04
! sched_03 master on laptop, pety/thum, exec mved to progs   08-jun-04
!       change in coord. when changing dev ps to dev eps  mr 11-jun-04
!       href to DB written html files,mod. yoff           ct 24-Jun-04
!***********************************************************************
!       change of .dat format: proposal part as second column  CT Nov-03
!       moved to RedHat 9 Gildas lib, Fort compiler            jp Feb-05
!       moved directory of html bg files                       ct Feb-05
!       added sched unit to html file names                    ct Jul 05
!       link to HTL files: year No. if sched starts in Dec     ct Nov 05
!       sched_units now have 2 digits                          ct Dec 05
!       removed hardcopy/plot                                  ct Jul 06
!       back to ps file (can now be generated again by GILDAS  ct Jul 06
!       copy to ps file to  thum/www/sched/07                  ct Aug 07
!       some modification for leap year                        mr Nov 08
!       mow copy ps files to www/sched/09                      ct Nov 08
!c**********************************************************************
!
module sched30m_common
  !---------------------------------------------------------------------
  ! Support module for commands SCHEDULE and HARDCOPY
  ! Quick solution for variables shared by both commands.
  !---------------------------------------------------------------------
  character(len=20) :: fil,fil3,fil4,fil5,fil6
  logical :: four
  !
end module sched30m_common
!
subroutine sched30m_schedule_command(line,error)
  use gbl_message
  use gkernel_interfaces
  use sched30m_interfaces, except_this=>sched30m_schedule_command
  !---------------------------------------------------------------------
  ! @ private
  !  Support subroutine for command
  !    SCHEDULE File1 [File2]
  ! Decode the command line
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SCHEDULE'
  logical :: four
  character(len=36) :: file1,file2
  integer(kind=4) :: nc
  !
  four = sic_present(0,2)
  !
  call sic_ch(line,0,1,file1,nc,.true.,error)
  if (error)  return
  !
  call sic_ch(line,0,2,file2,nc,four,error)
  if (error)  return
  !
  call sched30m_schedule(four,file1,file2,error)
  if (error)  return
  !
end subroutine sched30m_schedule_command
!
subroutine sched30m_schedule(infour,file1,file2,error)
  use gildas_def
  use gbl_message
  use sched30m_interfaces, except_this=>sched30m_schedule
  use sched30m_common
  !---------------------------------------------------------------------
  ! @ private
  !  Support subroutine for command
  !    SCHEDULE File1 [File2]
  ! Do the actual work
  !---------------------------------------------------------------------
  logical,          intent(in)    :: infour
  character(len=*), intent(in)    :: file1
  character(len=*), intent(in)    :: file2
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SCHEDULE'
  logical    recmark(15,6), found(6), prueba, lsummer,  &
              first, second, fy, algunos, splitblock
  character  name*2,upline*30,mres1*7,p(50)*15,  &
              weeks*5,texto*38,proj(50)*15,dat*11,fil2*20,  &
              author(50)*22, day(16)*2, texto1*20, ans*1,mres2*7,  &
              month(12)*3, cfyear*4,clyear*4,input*80,rxline*20,  &
              cfmes*3,clmes*3,ftuesday*11,ltuesday*11,lupline*30,  &
              cfday*2, clday*2, cdia(16)*2,filefirst*20,crise*3,  &
!                  project_a*8,author_a*22,aut(50)*22,filesecond*20,
              project_a*6,author_a*22,aut(50)*22,filesecond*20,  &
              clst1_a*4,clst2_a*4,cdia_a*2,pro(50)*15,  &
              rx(50)*20,resp*1,chain*132,summer*1,cset*3,  &
              part_a*2,part(50)*2,par(50)*2,part_id*1  !ct 10-11-03
  character  com(22)*60,comm*60,cpx(22)*5,cpy(22)*5,cfact(22)*4
  character  rmtext*60
  character  ficheros(50)*20,su*2
  character(len=commandline_length) :: command
  character(len=filename_length) :: basename
!        real       px(22),pyy(22),fact(22)
!        integer    py(22)
  real       px(22),py(22),fact(22)
  character(len=1), parameter :: blocksepar='-'  ! Block separator

  integer    i,j,t,n,fmes, lmes, fday, lday, daymax(12),jjj,  &
              fyear, lyear ,diamax, dia(16), tt, c(50),no_proj, &
              ho, lastt, m, ancho,dia_a,diap(50,15), &  !CT: (40,8)
              no_ba,no_bla,ii,jj,kk,k,modfyear,version,wk1,wk2
  real       x,y,lst1_a,lst2_a,tim_st(50,15),n_hour(50),  &
              tim_end(50,15),ultdia,n_tot,limtim,yx,yy,yz
  real       rise1,rise2,set1,set2
  real       cpolix(100), cpoliy(100)

  data day   /'  ','TU','WE','TH','FR','SA','SU','MO',  &
              'TU','WE','TH','FR','SA','SU','MO','TU'/
  data month /'JAN','FEB','MAR','APR','MAY','JUN','JUL',  &
              'AUG','SEP','OCT','NOV','DEC'/
  data daymax  /31,28,31,30,31,30,31,31,30,31,30,31/
  data cpolix     /100*0.0/
  data cpoliy     /100*0.0/
  !
        mres1 = ' '
        mres2 = ' '
        !
        if (infour) then
           call gr_exec('set plot_page landsc') !aqui porque hace clear plot
           four   = .true.
           first  = .true.
           second = .false.
        else
           call gr_exec('set plot_page port')
           four   = .false.
           first  = .true.
           second = .false.
        endif

8888    continue
        do i=1,50
           author(i) = '  '
           aut(i) = '  '
           par(i) = '  '
           proj(i) = '  '
           part(i) = '  '                    !CT 08-Dec-2010
           pro(i) = '  '
           rx(i) = '  '
           c(i) = 1
           n_hour(i)=0.0
           do j=1,15  ! antes 8
             diap(i,j)=0.0
             tim_st(i,j)=0.0
             tim_end(i,j)=0.0
           enddo
        enddo

!        do i=1,100
!         write(6,*) i, cpolix(i),cpoliy(i)
!        enddo

        limtim=10.5 ! a partir de esa hora el ultimo dia
        do i=1,15
                do j=1,6
                        recmark(i,j)=.false.
                        found(j)=.false.
                enddo
        enddo
        project_a='  '
        author_a='  '
        n_tot = 0
        no_proj = 0

        if (.not.first) goto 7777
        !
        ! Decode week number and version from file name e.g. wk12v3.dat
        call parse_file_name(file1,basename,wk1,version,error)
        if (error)  return
        fil = trim(basename)//'.dat'
        filefirst = fil
        prueba=.false.
        write (6,*) '  '

7777    continue
        if (first) goto 6666
        if (.not.four) goto 6666
        if (.not.second) goto 6666

        ! Decode week number and version from file name e.g. wk12v3.dat
        call parse_file_name(file2,basename,wk2,version,error)
        if (error)  return
        fil = trim(basename)//'.dat'
        filesecond = fil
        prueba=.false.
6666    continue

!       write (6,1850)
!1850   format(1x,' Enter P (Preview) or D (definitive) > ',$)
!       read (5,'(a)') resp
!       call sic_upper(resp)
        resp='D'
        if(resp.ne.'P') prueba=.false.

        fil = filesecond
        if (first) fil = filefirst

        open (unit=91,file=fil,status='old',err=366)
        print *,'** file opened: ', fil
        goto 469
366     print *, ' - cannot read file name:',fil,' try again.-'
        goto 8888
469     continue
        rewind(unit=91)
!       call gr_exec('set /def')
        call gr_exec('penc /def')
        call gtclal  ! CLEAR ALPHA
!       call gr_exec('clea plot')
!1011    format(a8,2x,a22,3x,a2,2x,a4,5x,a4,2x,a20)
1011    format(a6,1x,a2,1x,a22,3x,a2,2x,a4,5x,a4,2x,a20)
1013    format(a5,3x,a5,3x,a4,4x,a60)
!***********************************************************************
!c      Reading the file
!***********************************************************************
        read (91,'(a2)') name
        call sic_upper(name)
        read (91,'(a1)') summer
        call sic_upper(summer)
                if(summer.eq.'Y') then
                  lsummer=.true.
                  texto1='MEST = UT + 2 hours'
                  ho=6
                else
                  lsummer=.false.
                  texto1='MET = UT + 1 hour'
                  ho=7
                endif
        read (91,'(a11)') dat
        call sic_upper(dat)
        read (91,'(a5)') weeks
        read (91,'(i4)') fyear
        write(cfyear,'(i4)')  fyear
        modfyear = mod(fyear,4)
        read (91,'(i4)') fmes
        if(fmes.gt.12) then
          write(6,*) 'Error in month number, correct the file'
          error = .true.
          return
        endif
        read (91,'(i4)') fday
!       fyear=fyear+1900
!        if(modfyear.eq.0) daymax(2)=29        !leap year
!        if(mod(fyear,4).eq.0) daymax(2)=29              !leap year
!       fyear=fyear-1900
        write(cfday,'(i2.2)')   fday
!
      daymax(2)=28
      do i=1,12
           if (fmes.eq.i) then
             jjj=i
             if(modfyear.eq.0) daymax(2)=29        !leap year
             diamax=daymax(i)
             cfmes=month(i)
           endif
!       write (6,*) i,daymax(i),diamax, fil, fyear, modfyear
        enddo
!
!       write (6,*) 'hola'
!       write (6,*) jjj,daymax(jjj),diamax, fil, fyear, modfyear

!        pause
        if(fday.gt.diamax) then
          write(6,*) 'Error in day number, correct the file'
          error = .true.
          return
        endif
        lday=fday+14
        if(lday.gt.diamax) lday=lday-diamax
        lmes=fmes
        lyear=fyear
        if(lday.le.14) lmes = fmes+1
        if(lmes.eq.13) then
           lmes = 1
           lyear = fyear+1
        endif
        do i=1,12
           if (lmes.eq.i) clmes=month(i)
        enddo
        write(clday,'(i2.2)')   lday
        write(clyear,'(i4)')  lyear
        ftuesday=cfday//'-'//cfmes//'-'//cfyear
        ltuesday=clday//'-'//clmes//'-'//clyear
        dia(2)=fday
        dia(1)=fday-1
        write(cdia(2),'(i2.2)')  dia(2)
        write(cdia(1),'(i2.2)')  dia(1)
        do i=3,16
           dia(i)=dia(i-1)+1
           if(dia(i).eq.diamax+1) dia(i)=1
           write(cdia(i),'(i2.2)')  dia(i)
        enddo
        cdia(1) = ' '
!       write(ifyear,'(i4)') fyear
!******************************************************************
!************  getting info of set sun and set rise
!******************************************************************
        call sunpos (fyear,fmes,fday,rise1,set1)
        call sunpos (lyear,lmes,lday,rise2,set2)

        rise1=rise1+1.0         ! ut+1 winter time
        rise2=rise2+1.0
        set1=set1+1.0
        set2=set2+1.0
        if(lsummer) then
         rise1=rise1+1.0        ! ut+2 summer time
         rise2=rise2+1.0
         set1=set1+1.0
         set2=set2+1.0
        end if
!
!       print*,'fecha, rise1, set1',fyear,fmes,fday,rise1,set1
!       print*,'fecha, rise2, set2',lyear,lmes,lday,rise2,set2
!       pause
!******************************************************************
        read (91,'(a)') input ! 3 comments lines
        read (91,'(a)') input
        read (91,'(a)') input
        i = 0
        ancho  =0
        ultdia =0
        splitblock = .false.
!40      read (91,1011,END=11)  project_a,author_a,cdia_a,clst1_a,
!     1                          clst2_a,rxline
40      read (91,1011,END=11)  project_a,part_a,author_a,cdia_a,clst1_a,  &
                                clst2_a,rxline

        px(:) = 0.
        py(:) = 0.
        fact(:) = 0.
        if(project_a(1:1).eq.'!') goto 40
        if(project_a(1:1).eq.blocksepar) then
          splitblock = .true.
          goto 40
        endif
        if(project_a(1:2).eq.'**') then
           read (91,'(a)') input ! jump next 3 comm. lines !mod. CT 06-09-99
           read (91,'(a)') input
           read (91,'(a)') input
           do j=1,22
             com(j)='  '  ! new mr
           enddo
           do j=1,22
!c             read (91,1013,END=11)  cpy(j),cpx(j),cfact(j),com(j)
              read (91,1013,END=11)  cpx(j),cpy(j),cfact(j),com(j)
!             call sic_upper(cpy(j))
!             if(cpy(j)(1:4).eq.'STOP') then
              call sic_upper(cpx(j))
             if(cpx(j)(1:4).eq.'STOP') then
                com(j)=' '
                goto 11
             endif
             no_ba=0
             do t=1,60
               if(com(j)(t:t+1).eq.'  ') no_ba=no_ba+1
! !mod. CT 19-02-00
             enddo
             no_bla = int(float(no_ba)/2.)
             comm='  '
!            comm(no_bla+1:60)=com(j)
!            com(j)=comm
             comm(1:no_ba)=com(j)
!       if(cpy(j)(1:4).eq.'STOP') goto 11        !mod. CT 06-09-99
             read (cpx(j),'(f5.2)') px(j)
             read (cpy(j),'(f5.2)') py(j)

!       px is now in hours (0..24), py is in day of the date
!
             if (abs(py(j)-98.).le.0.1) then
                py(j) = fday+22.8                 !remark above left bottom
                px(j) = -1.5
             elseif (abs(py(j)-99.).le.0.1) then
                py(j) = fday+22.8                 !remark above right bottom
                px(j) = 11.8
             elseif(py(j).lt.fday) then
                py(j) = py(j) + diamax            !when py after end of month
             endif
             px(j) = (px(j)-1)/24*0.89+0.10
             py(j) = - 0.83*1./15.*(py(j)-fday+0.5) + 0.89
             read (cfact(j),'(f4.2)') fact(j)
!            print *, ' ** px,py: ', px(j), py(j)
           enddo
        endif            !end if(project_a(1:2).eq.'**') then

        i=i+1
        read (cdia_a,'(i2.2)')  dia_a
!       print *, ' dia_a:', dia_a
        read (clst1_a,'(f9.1)') lst1_a
        read (clst2_a,'(f9.1)') lst2_a
        proj(i)=project_a
        part(i)=part_a
        if (i.gt.1) then
           if (splitblock) then
              ! Force split project in a new block
              splitblock = .false.
           elseif (proj(i).eq.proj(i-1)) then
              ! Same project
              i=i-1
              c(i)=c(i)+1
              proj(i+1)= ' '
              par(i+1) = ' '
          endif
        endif
        proj(i)=project_a
        pro(i)=proj(i)
        part(i)=part_a
        par(i) =part(i)
        author(i)=author_a
        aut(i)=author(i)
        rx(i)=rxline
        diap(i,c(i))=dia_a
        tim_st(i,c(i)) =lst1_a
        tim_end(i,c(i))=lst2_a
        no_proj=i
!**********************************************************************
! MR modif. jan-94
        do k=1,no_proj-1
                if(proj(i).eq.proj(k)) then
                      n_hour(k)=n_hour(k)-lst1_a+lst2_a
                      goto 3131
                endif
        enddo
        if(diap(i,c(i)).ne.diap(i,c(i)-1)) then !do not repeat account of hours
           n_hour(i)=n_hour(i)-lst1_a+lst2_a
        endif

3131    continue
        if(dia_a.eq.float(fday)) then
                if((lst1_a.le.limtim).and.(lst2_a.le.limtim)) then
                        n_hour(k)=n_hour(k)-(lst2_a-lst1_a)
                else if((lst1_a.le.limtim).and.(lst2_a.ge.limtim)) then
                        n_hour(k)=n_hour(k)-(limtim-lst1_a)
                endif
        endif
        if(dia_a.eq.float(lday)) then
                if((lst1_a.ge.limtim).and.(lst2_a.ge.limtim)) then
                        n_hour(k)=n_hour(k)-(lst2_a-lst1_a)
                else if((lst1_a.le.limtim).and.(lst2_a.ge.limtim)) then
                        n_hour(k)=n_hour(k)-(lst2_a-limtim)
                endif
        endif
!**********************************************************************
        call sic_upper(rxline)
        upline=rxline
        do t=1,15
           if(dia(t+1).eq.dia_a) then
             lastt=t
             if(rxline.ne.'  ') then
                do m=1,6
                   found(m)=.false.
                enddo
             do j=1,20
                if(upline(j:j+3).eq.'3MM1') found(1)=.true.
                if(upline(j:j+4).eq.'230G1') found(2)=.true.
                if(upline(j:j+3).eq.'2MM1') found(3)=.true.
                if(upline(j:j+2).eq.'CON') found(4)=.true.
                if(mres1(1:5).eq.'230G2') then
                 if(upline(j:j+4).eq.mres1(1:5)) found(5)=.true.
                else if(mres1(1:3).eq.'0.8') then
                 if(upline(j:j+2).eq.mres1(1:3)) found(5)=.true.
                else if(mres1(1:3).eq.'BOL') then
                 if(upline(j:j+2).eq.mres1(1:3)) found(5)=.true.
                else
                 if(upline(j:j+3).eq.mres2(1:4)) found(5)=.true.
                endif

                if(mres2(1:5).eq.'230G2') then
                 if(upline(j:j+4).eq.mres2(1:5)) found(6)=.true.
                else if(mres2(1:3).eq.'0.8') then
                 if(upline(j:j+2).eq.mres2(1:3)) found(6)=.true.
                else if(mres2(1:3).eq.'BOL') then
                 if(upline(j:j+2).eq.mres2(1:3)) found(6)=.true.
                else
                 if(upline(j:j+3).eq.mres2(1:4)) found(6)=.true.
                endif

             enddo
                do m=1,6
                   if(found(m)) recmark(t,m)=.true.
                enddo

             endif
             if(rxline.eq.'  ') then
              if(c(i).ge.2) then
                ancho=int(dia_a-ultdia+1)
                do j=2, ancho
                   do n=1,6
                      if(found(n)) then
                        if (.not.recmark(t-ancho+j,n)) then
                           recmark(t-ancho+j,n)=recmark(t+1-ancho,n)
                        endif
                      endif
                   enddo
                enddo
              else
                do j=1,6
                   found(j)=.false.
                enddo
              endif
            endif
           endif
        enddo
        lupline=upline
        ultdia=dia_a

        goto 40        !loop reading the .dat file

11      continue       !jump to here after reading STOP in .dat file
        do i=1,no_proj
          p(i)=pro(i)
          call sic_upper(p(i))
          do j=1,4
              if((p(i)(j:j+3).eq.'mtn').or.  &
                 (p(i)(j:j+2).eq.'ptg').or.  &
                 (p(i)(j:j+2).eq.'TBA').or.  &
!                (p(i)(j:j+1).eq.'TT').or.   &
!                (p(i)(j:j+3).eq.'TECH').or. &
                 (p(i)(j:j+3).eq.'RESE').or. &
                 (p(i)(j:j+3).eq.'RX S').or. &
                 (p(i)(j:j+3).eq.'BOLO').or. &
                 (p(i)(j:j+2).eq.'mon')) then
                        pro(i)='    '
                        aut(i)='    '
                        rx(i)='    '
                        par(i)='  '
                endif
          enddo
        enddo
        do i=no_proj,1,-1
           do j=1,i-1
                if(pro(i).eq.pro(j)) then
                   pro(i)='  '
                   par(i)='  '
                   aut(i)='  '
                   rx(i)='  '
                endif
           enddo
        enddo
        do i=1,no_proj
           if(pro(i).eq.'  ') then
                do j=i+1,no_proj
                   if(pro(j).ne.'  ') then
                        pro(i) = pro(j)
                        par(i) = par(j)
                        aut(i) = aut(j)
                        rx(i)  = rx(j)
                        pro(j) = '  '
                        par(j) = '  '
                        aut(j) = '  '
                        rx(j)  = '  '
                        goto 111
                   endif
                enddo
111             continue
           endif
        enddo

        if (.not.four) then
           call gr_exec('set box 0.5 20.5 9.0 25.0 ')
        endif

        if (four) then
           if (first) then
            call gr_exec('set box 0.30 14.8 5.5 17.75 ')
           else
             call gr_exec('set box 15.40 29.9 5.5 17.75 ')
           endif
        endif

        write (6,*) '  '
        texto='OBSERVING SCHEDULE IRAM 30m TELESCOPE'
!       goto 9999 !para saltar graficas durante tests
        call gtclal

!       +++++++++++++++++++++++++++++++++++++++++++++++++++++++
!       +++                  Using Greg                     +++
!       +++++++++++++++++++++++++++++++++++++++++++++++++++++++

        call gr_exec('box n n n')
        call gr_exec('set expand 1.20')

        if (four) call gr_exec('set expand 0.90')

        call gr_exec('set font dupl')
        if(prueba) call gr_exec('set font simpl')
!       if(four) call gr_exec('set font simpl')
        call gr_exec('pencil 1')
        call gr_exec('draw text 0.50 1.18 "'//Texto//'" 8 /USER')
        call gr_exec('set expand 1.00')

        if (four) call gr_exec('set expand 0.77')
        call gr_exec('draw text 0.45 1.14 "'//ftuesday//'" 4 /USER')
        call gr_exec('draw text 0.50 1.14 " to " 5 /USER')
        call gr_exec('draw text 0.55 1.14 "'//ltuesday//'" 6 /USER')
        call gr_exec('set expand 0.85')

        if (four) call gr_exec('set expand 0.58')
        call gr_exec('draw text 0.00 1.09 "Weeks: " 6 /USER')
        call gr_exec('draw text 0.10 1.09 "'//Weeks//'" 6  /USER')
        call gr_exec('draw text 0.00 1.04 "Version:" 6 /USER')
        write(command,'(A,I0,A)') 'draw text 0.11 1.04 "',version,'" 6 /USER'
        call gr_exec(command)
        call gr_exec('draw text 0.94 1.09 "By:" 4 /USER')
        call gr_exec('draw text 1.00 1.09 "'//name//'" 4 /USER')
        call gr_exec('draw text 0.80 1.04 "Date:" 4 /USER')
        call gr_exec('draw text 1.00 1.04 "'//Dat//'" 4 /USER')

        call gr_exec('set expand 0.65')

        if (four) call gr_exec('set expand 0.50')
        call gr_exec('pencil /defa')

        call gr_exec('draw text 0.500 0.955 "'//Texto1//'" 5 /USER')
        call gr_exec('draw text 0.0390 0.94 "DAY" 5 /USER')

!c
!c      new format to write projects, authors and receiver information (CT)
!c
!c      line to separate projects

        call gr_exec('draw relocate 0.500 0.00 /USER')
        call gr_exec('draw line 0.500 -0.420 /USER')
        call gr_exec('draw relocate 0.497 0.00 /USER')
        call gr_exec('draw line 0.497 -0.420 /USER')

        call gr_exec('draw relocate 0.00 0.00 /USER')
        call gr_exec('draw line 0.00 -0.420 /USER')

        call gr_exec('draw relocate 1.00 0.00 /USER')
        call gr_exec('draw line 1.00 -0.420 /USER')

        call gr_exec('draw relocate 0.00 -0.420 /USER')
        call gr_exec('draw line 1.00 -0.420 /USER')

!       do i=13,20
!          pro(i)='999-99'
!          aut(i)='clemens thum'
!          rx(i)='2m 3m1 g2'
!          enddo

        if (four) call gr_exec('set expand 0.47250') !antes 0.475

        do i=1,19, 2
           y=-0.03-(i-1)*0.02

           x=0.005
           write(chain,1022) x,y,Pro(i)
!1022      format ('draw text' ,2(1x,f5.3),' " ',a6,' " 3 /USER')
1022       format ('draw text' ,2(1x,f5.3),' " ',a8,' " 3 /USER')  !CT 11-12-98
           call gr_exec (chain)

           x=0.090           !0.115             !0.135
           write(chain,1023) x,y,Aut(i)
1023       format ('draw text' ,2(1x,f5.3),' " ',a22,' " 3 /USER')
           call gr_exec (chain)

           x=0.280
           write(chain,1024) x,y,Rx(i)
1024       format ('draw text' ,2(1x,f5.3),' " ',a20,' " 3 /USER')
           call gr_exec (chain)
        enddo

        do i=2,20, 2
           y=-0.03-(i-2)*0.02
           x=0.510
           write(chain,1025) x,y,Pro(i)
!1025      format ('draw text' ,2(1x,f5.3),' " ',a6,' " 3 /USER')
1025       format ('draw text' ,2(1x,f5.3),' " ',a8,' " 3 /USER')   !CT 11-12-98
           call gr_exec (chain)

           x=0.595
           write(chain,1026) x,y,Aut(i)
1026       format ('draw text' ,2(1x,f5.3),' " ',a22,' " 3 /USER')
           call gr_exec (chain)

           x=0.785
           write(chain,1027) x,y,Rx(i)
1027       format ('draw text' ,2(1x,f5.3),' " ',a20,' " 3 /USER')
           call gr_exec (chain)
        enddo

!       call gr_exec('draw text 0.04 3.7E-02 "LST" 5 /USER')
!       call gr_exec('draw relocate 0.07 3.6E-02 /USER')
!       call gr_exec('draw arrow 0.09 3.7E-02 /USER')
        call gr_exec('draw text 0.03 3.7E-02 "LST" 5 /USER')
        call gr_exec('draw relocate 0.06 3.6E-02 /USER')
        call gr_exec('draw arrow 0.08 3.7E-02 /USER')

        call hsidnew(fyear,fmes,fday,0,0,-3.,-23.,-58.1,lsummer)
        call hsidnew(fyear,fmes,fday,8,0,-3.,-23.,-58.1,lsummer)
        call hsidnew(fyear,fmes,fday,16,0,-3.,-23.,-58.1,lsummer)

!******** lines of sun rise and sunset ***********
        yz=0.888
        yy=0.015
        yx=0.130
        rise1=rise1*0.037037+0.095 ! change to user coord.
        rise2=rise2*0.037037+0.095
        set1=set1*0.037037+0.095
        set2=set2*0.037037+0.095
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!c
!c      new line of the sun
!c
        call gr_exec('pencil /dash 3 /weig 1')
        write (chain,2236) rise2,yy
2236    format ('draw relo',2(1x,f7.4),' /CLIP')
        call gr_exec (chain)
        write (chain,2246) set2,yy
2246    format ('draw lin',2(1x,f7.4),' /CLIP')
        call gr_exec (chain)

        call gr_exec('pencil /dash 1 /weig 1')

!***********************************************************************
!c      sun symbol instead of characters
!        crise='0'
!        cset='0'
        crise=char(92)//'g0'  ! sun symbol
        cset =char(92)//'g0'
!        pause !ya no es necesaria la pausa, se ha arreglado al poner
!        la linea del sol antes que los simbolos
        write (chain,2247) rise2,yy,crise
2247    format ('draw text',2(1x,f7.4),' " ',a3,' " 5 /USER /CLIP')
        call gr_exec (chain)
        write (chain,2248) set2,yy,cset
2248    format ('draw text',2(1x,f7.4),' " ',a3,' " 5 /USER /CLIP')
        call gr_exec (chain)
!***********************************************************************
        call gr_exec('pencil /dash 3 /weig 1')
        do i=2,17
                x  = 1.0-(float(i)/18.0)
                t  = i-1
                tt = i-1
                call horizline(x,day(t),cdia(tt),prueba,four)
        enddo
        do i=1,25
                x = 0.095+(i-1)*0.0370834
                t = i
                call vertline(x,t,prueba,four)
        enddo
        call gr_exec('pencil /dash 1 /weig 1')
!***********************************************************************
!cc        pause !p3
!55     continue
        write(fil5,'(A,I0,A)')  's'//fil(3:4)//'v',version,'.html'  !nuevo fichero mr
        write(fil6,'(A,I0,A)')  's'//fil(3:4)//'v',version,'.gif'   !nuevo fichero mr
!        fil5='test.html'
!        print*, fil5,fil6
!        pause
!cccccccccccccccc
!        do i=1,no_proj
!c        ficheros(i)='p'//proj(i)(1:index(proj(i),' ')-1)//'.html'
!        if(proj(i)(1:3).eq.char(92)//'gD') then
!          ficheros(i)=fil5(1:5)//'_d'//proj(i)(4:5)//'.html'
!         else
!           ficheros(i)=fil5(1:5)//'_'//proj(i)(1:3)//'.html'
!        endif
!c         print*, ficheros(i)
!c         pause
!        enddo
!cccccccccccccc a continuacion cambio las lineas anteriores para
!cccccccccccccc modificar el nombre de ficheros html de cada proyecto
!cccccccccccccc para que no incluya la version
        do i=1,no_proj
!        ficheros(i)='p'//proj(i)(1:index(proj(i),' ')-1)//'.html'
!        if(proj(i)(1:3).eq.char(92)//'gD') then
!          ficheros(i)=fil5(1:3)//'_d'//proj(i)(4:5)//'.html'
!         else
!           ficheros(i)=fil5(1:3)//'_'//proj(i)(1:3)//'.html'
!        endif

!     19-Jul-2005 added scheduling unit No. to html file name
!
!        print *,proj(i),' part(i)=', part(i),'===='
!        print *,'par(i)(1:2)=', par(i)(1:2),'===='
        if (part(i)(1:1).eq.' ') then
          su = '0'//part(i)(2:2)
          if (part(i)(2:2).eq.' ') then
             su = '00'
          endif
        else
          su = part(i)(1:2)
        endif

        ficheros(i) = fil5(1:3)//'_'//trim(proj(i))//'_su'//su//'.html'

!        print*,part(i), ' - ', ficheros(i)
!         pause
        enddo

!cc     call to graphic subroutine
        do i=1,no_proj
        j=c(i)
        ii=i
        jj=j
        kk=j
        call displ_proj(proj(i),diap,tim_st,tim_end,i,j,dia,prueba,four)
        enddo  !hoy

!c**********************************************************************
!c          new comments part
!c**********************************************************************
        call gr_exec('set ori 0')
        do j=1,21
!          print*, px(j),py(j),fact(j),com(j)
!          pause 33
!          call gr_exec('set expand 1.0')
           if (four) fact(j)=0.75*fact(j)
           write (chain,2347) fact(j)
2347       format ('set expand',(1x,f4.2))
           call gr_exec (chain)
           call gr_exec('pencil /dash 1 /weig 2')
           write (chain,2348) px(j),py(j),com(j)
!           write (chain,2348) px(j),pyy(j),com(j)
!2348      format ('draw text',2(1x,f5.3),' " ',a60,' " 5 /USER')
2348       format ('draw text',2(1x,f5.3),' " ',a60,' " 6 /USER')   !CT 2-11-99
           call gr_exec (chain)
           call gr_exec ('penc /defa')
        enddo
!***********************************************************************
! file *.out with info of number of hours
!***********************************************************************
        part_id = '='          !identifies the part number in .out file
        fil2=fil(1:index(fil,'.')-1)//'.out'
!       open (unit=92,file=fil2,defaultfile='[thum.sched.planning].dat',
!     1        status='unknown')
        rmtext = 'rm -f fil2'
        call system(rmtext)
        open (unit=92,file=fil2,status='unknown')
        write (92,1318) fil2
        write (92,1314)
        write (92,1315)
        do i=1,no_proj
                n_tot=n_tot+n_hour(i)
        enddo
        write (92,1316) proj(1),part(1),part_id,n_hour(1)
        print *,proj(1),part(1),n_hour(1)
        do i=2,no_proj
                do j=1,i-1
                        if(proj(j).eq.proj(i)) then
                           goto 1322
                        else

                        endif
                enddo
                if(n_hour(i).ne.0) then
                   write (92,1316) proj(i),part(i),part_id,n_hour(i)
                   print *,proj(i),part(i),n_hour(i)
                endif
1322            continue
        enddo
        write (92,1317) n_tot,n_tot*100./336.
1314    format('!',10x,'Project ',10x,'Part',5x,'Hours ')
1315    format('!',10x,'------- ',10x,'----',5x,'----- ')
1316    format(7x,a15,7x,a2,a,7x,f5.1)
1317    format('!',10x,'Total:  ',10x,f5.1,'  Hours (=',f5.1,'%)')
1318    format('!',10x,'File:  ',a20)
        close(unit=92)

        do i=1,no_proj
        j=c(i)
        ii=i
        jj=j
        kk=j

! kw001 gifcoor
        call gifcoor(proj(i),diap,tim_st,tim_end,ii,jj,dia,cpolix,cpoliy)

! kw002 makehtml1
        if(i.eq.1) call makehtml1(i,fil5,fil6)

! kw003 makemapq
3232    continue
!        if(i.eq.1) then
!          write(6,'(1x,a,$)') 'create html file (y/n), some(s)? > '
!          we only write the main html file here; the project files
!          are now written from the DB (Jan 2005)
!          write(6,'(1x,a,$)') 'create html file (y/n) ? > '
!          read (5,'(a1)') ans
!          if (ans.eq.' ') ans = 'n'
!           write(6,*) rmtext2
!           call system(rmtext2)

!          if (ans.eq.'y') then
!            write(6,'(1x,a,$)') 'are you sure you typed y? (y/n)> '
!            read (5,'(a1)') ans
            ans = 'y'
            if (ans.ne.'y') goto 3232
!          endif
!          fy=.false.
!          algunos=.false.
!          if((ans.eq.'y').or.(ans.eq.'Y')) fy=.true.
!          if((ans.eq.'s').or.(ans.eq.'S')) algunos=.true.
!        endif
!        print *,'cfyear=',cfyear
        fy=.true.
!        print *, 'fyear=',fyear,' fmes= ',fmes
        algunos = .false.                           !CT 08-dec-2010
        call makemap(fy,algunos,i,ficheros,proj,kk,cpolix,cpoliy,fyear,fmes)

!kw004 makehtml2
        if(i.eq.no_proj) call makehtml2(i,fil5)
        enddo
        close(96)

        call gr_exec('pencil /dash 1 /weig 1')

        fil3=fil(1:index(fil,'.')-1)//'.ps '

!***********************************************************************
        close(unit=91)
        if ((four).and.(second)) goto 5151
        if (four) then
           first  = .false.
           second  = .true.
           goto 8888
        endif
5151    continue
        write(fil4,'(A,I2.2,I2.2,A)') 'tmp',wk1,wk2,'.ps'

        call gr_exec('set expand 0.90')
        call gr_exec('pencil /dash 1 /weig 2')
        call gtclal  ! CLEAR ALPHA

end subroutine sched30m_schedule
!
subroutine sched30m_hardcopy_command(line,error)
  use sched30m_interfaces, except_this=>sched30m_hardcopy_command
  !---------------------------------------------------------------------
  ! @ private
  !  Support subroutine for command
  !    HARDCOPY
  ! Decode the command line
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  !
  ! Nothing to be decoded
  call sched30m_hardcopy(error)
  if (error)  return
  !
end subroutine sched30m_hardcopy_command
!
subroutine sched30m_hardcopy(error)
  use sched30m_common
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=60) :: cptext
  character(len=27) :: defdir
  character(len=160) :: rmtext2
  character(len=36) :: webdir
  !
  if (four) then
    call gr_exec('hard "'//fil4//'" /dev eps fast /overwrite')
    !
  else
    print *, 'fil3: ', fil3
    call gr_exec('hard "'//fil3//'" /dev ps fast /overwrite')
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!          para crear fichero gif, ya funciona en Granada
!kw005 convert
!           write(6,*) fil3,fil6
!           rmtext2= 'convert '//fil3//' '//fil6
    rmtext2= 'convert +antialias -density 300 '//fil3//  &
    ' -type trueColor -resample 72 -contrast '//fil6
    write(6,*) rmtext2
    call system(rmtext2)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
  endif

!  Jan 03 modification: cp files to new web page
  webdir = '/netapp1/www/html/IRAMFR/PV/sche/03/'
  defdir = '/users/astro/thum/sched/03/'

! write(6,'(1x,a,$)') 'copy html,gif files to web? (y/n) > '
! read (5,'(a1)') ans
! if (ans.eq.' ') ans = 'n'
  if (.false.) then
!  cptext = 'newgrp web; ls'
!  write(6,*)  '- execute: ', cptext
!  call system(cptext)
!  cptext = 'cd '//webdir//'; pwd'
!  write(6,*)  '- execute: ', cptext
!  call system(cptext)
    cptext = 'cp '//defdir//fil5//' '//webdir//'.'
    write(6,*) cptext
    call system(cptext)
    cptext = 'cp '//defdir//fil6//' '//webdir//'.'
    write(6,*) cptext
    call system(cptext)
    cptext = 'ls '//webdir//' | pwd'
    write(6,*) cptext
    call system(cptext)
  endif

!  copy ps file to publicly reachable dir (for Juan) CT 22-08-07
!  This action is not required anymore so I comment it out (NB Dec. 2011)
!        webdir = '/users/astro/thum/www/sched/09/'
!        cptext = 'cp '//fil3//' '//webdir//'.'
!C       print *, 'copying:', cptext
!        write(6,*) cptext
!        call system(cptext)

end subroutine sched30m_hardcopy
!
!***********************************************************************

        subroutine horizline(t,nom,ddia,pr,ff)
        real      x, t
        character chain*80, nom*2, ddia*2
        logical   pr,ff

        t=t+0.025
        x= -0.0055

        write(chain,225) x,t,nom
225     format ('draw text',2(1x,f7.4),' "',1(1x,a2),'" 6 /USER')
        call gr_exec('set exp 0.85')
        if (ff) call gr_exec('set expand 0.635') !antes 0.65

        call gr_exec (chain)
        x=0.0780
        write(chain,226) x,t,ddia
226     format ('draw text',2(1x,f7.4),' "',1(1x,a2),'" 4 /USER')
!       call gr_exec('set exp 0.85')
        call gr_exec (chain)
        x= 0.0
        t=t-0.025
        if(pr) goto 2223
        write(chain,222) x,t
222     format ('draw rel ',2(1x,f7.4))
        call gr_exec (chain)
        x=1.0
        write(chain,223) x,t
223     format ('draw lin',2(1x,f7.4))
        call gr_exec (chain)
2223    x=0.0
        return
        end subroutine horizline

!***********************************************************************

        subroutine vertline(z,hora,pru,ff)
        real      y, z
        character chain*80, chora*2
        integer   hora
        logical   pru,ff

        hora=hora-1
!       write(chora,'(i2.2)') hora
        write(chora,'(i2)') hora
        y=0.058
        if(pru) goto 2222
        write(chain,222) z,y
222     format ('draw rel ',2(1x,f7.4))
        call gr_exec (chain)
        y= 0.91
        write(chain,223) z,y
223     format ('draw lin',2(1x,f7.4))
        call gr_exec (chain)
2222    y= 0.91
        y=y+0.005
        call gr_exec('set exp 0.50')
        if (ff) call gr_exec('set expand 0.38') !antest 0.4
        if(hora.lt.10) z=z-0.002
        write(chain,323) z,y,chora
323     format ('draw text',2(1x,f7.4),' "',a2,'" 8 /USER')
        call gr_exec (chain)
        return
        end subroutine vertline
!***********************************************************************

        subroutine displ_proj(proje,diap,tim_st,tim_end,s,t,diaa,prueba,ff)
        character  proje*15, chain*80, pr*15
        integer    i, j, s, t, p, u, diaa(16), no_b, no_bl,a1,a2
!       integer    diap(40,8)
        integer    diap(50,15)
!       real       tim_st(40,8),tim_end(40,8),corr
        real       tim_st(50,15),tim_end(50,15),corr
!        real       x(400), y(400), xave, yave, height, width,z
        real       x(100), y(100), xave, yave, height, width,z

        logical    anga,prueba,ff
!        data x     /400*0.0/
!        data y     /400*0.0/
        data x     /100*0.0/
        data y     /100*0.0/

        anga   = .false.
        corr   = 0.0033
        a1     = 0.0
        a2     = 0.0
        xave   = 0.0
        yave   = 0.0
        height = 0.0
        width  = 0.0
        u=t

!        write(6,*) t,proje
!        pause

        do j=1,t
        p = j-1
          do i=1,16
            if(diap(s,j).eq.float(diaa(i))) then
                if(j.eq.1) a1=diaa(i)
                if(j.eq.t) a2=diaa(i)
                x(2*p+1) = (tim_st(s,j))*0.0370834 + 0.095
                x(2*p+2) = x(2*p+1)
                x(4*u-2*p-1) = (tim_end(s,j))*0.0370834 + 0.095
                x(4*u-2*p) = x(4*u-2*p-1)
                y(2*p+1) = 1-(float(i)/18.)
                y(2*p+2) = 1-(float((i+1))/18.)
                y(4*u-2*p-1) = y(2*p+2)
                y(4*u-2*p) = y(2*p+1)
                p = p+1
            endif
          enddo
          width=width+tim_end(s,j)-tim_st(s,j)
        enddo
        height=float(t)
        width=width/float(t)
        do i=1,4*u
           xave=xave+x(i)
           yave=yave+y(i)
        enddo
        xave=xave/(4.*u)
        yave=yave/(4.*u)
!       print *,u
        x(4*u+1)=x(1)
        y(4*u+1)=y(1)
        call gr_exec('set ori 0')
        call gr4_give ('X',4*u+1,x) !to plot project borders
        call gr4_give ('Y',4*u+1,y)
        call gr_exec('pencil /dash 1 /weig 3')
!       habia weig 2 pero CT quiere mas gruesas para html
        if(prueba) call gr_exec('pencil /dash 1 /weig 1')
        call gr_exec('connect')
        call gr_exec('pencil /dash 1 /weig 2')
        if(prueba) call gr_exec('pencil /dash 1 /weig 1')
        no_b=0
        do i=1,15
           if(proje(i:i).eq.' ') no_b=no_b+1
        enddo
        no_bl = int(float(no_b)/2.)
        pr='  '
        pr(no_bl+1:15)=proje
        proje=pr
!       if(height.ge.1.2*width) then
        if(height.ge.1.3*width) then
           call gr_exec('set ori 90')
           z=height
           height=width
           width=z
           t=int(height)
           if(mod(no_b,2).ne.0) anga=.true.
        endif
        if(t.eq.1) then
                if(width.ge.4) then
                        call gr_exec('set exp 0.85')
                        if (ff) call gr_exec('set expand 0.63')

                else if(width.eq.3) then
                        call gr_exec('set exp 0.6')
                        if (ff) call gr_exec('set expand 0.45')

                else if(width.eq.2) then
                        call gr_exec('set exp 0.5')
                        if (ff) call gr_exec('set expand 0.385') !0.37 antes

                else
                        call gr_exec('set exp 0.43')
                        if (ff) call gr_exec('set expand 0.35') !antes 0.33

                endif
        else if(t.eq.2) then
                if(width.ge.4) then
                        call gr_exec('set exp 1.0')
                        if (ff) call gr_exec('set expand 0.75')

                else if(width.eq.3) then
                        call gr_exec('set exp 0.9')
                        if (ff) call gr_exec('set expand 0.67')

                else if(width.eq.2) then
                        call gr_exec('set exp 0.8')
                        if (ff) call gr_exec('set expand 0.6')

                else
                        call gr_exec('set exp 0.7')
                        if (ff) call gr_exec('set expand 0.55') !0.53 antes

                endif
        else if(t.eq.3) then
                if(width.ge.4) then
                        call gr_exec('set exp 1.1')
                        if (ff) call gr_exec('set expand 0.82')

                else if(width.eq.3) then
                        call gr_exec('set exp 0.8')
                        if (ff) call gr_exec('set expand 0.6')

                else if(width.eq.2) then
                        call gr_exec('set exp 0.7')
                        if (ff) call gr_exec('set expand 0.53')

                else
                        call gr_exec('set exp 0.6')
                        if (ff) call gr_exec('set expand 0.45')

                endif
        else
                if(width.ge.4) then
                        call gr_exec('set exp 1.2')
                        if (ff) call gr_exec('set expand 0.9')

                else if(width.eq.3) then
                        call gr_exec('set exp 1.1')
                        if (ff) call gr_exec('set expand 0.825')

                else if(width.eq.2) then
                        call gr_exec('set exp 1.0')
                        if (ff) call gr_exec('set expand 0.75')

                else
                        call gr_exec('set exp 0.9')
                        if (ff) call gr_exec('set expand 0.68')

                endif
        endif

        if(anga) then
!         xave = xave - 2 * corr
          xave = xave - 1 * corr
          yave = yave + 1.9 * 2 * corr
        endif
        if(mod(no_b,2).ne.0) xave = xave + corr
        write(chain,1015) xave,yave,proje
1015    format ('draw text',2(1x,f7.4),' " ',a15,' " 5 /USER')
        call gr_exec (chain)
        call gr_exec('pencil /dash 1 /weig 1')
        call gtclal  ! CLEAR ALPHA
        return
        end subroutine displ_proj

!***********************************************************************
! kw001
        subroutine gifcoor(proje,diap,tim_st,tim_end,s,t,diaa,cpolix,cpoliy)
        character  proje*15
        integer    i, j, s, p, u, t, diaa(16),a1,a2
        integer    diap(50,15)
        real       tim_st(50,15),tim_end(50,15)
        real       x(100), y(100), xave, yave, height, width
        real       centrox,centroy,ancho,alto
        real       xoff,yoff,deltax,deltay
        real       cpolix(100), cpoliy(100)
        data x     /100*0.0/
        data y     /100*0.0/
!c*************************************
!     para coordenadas esquina superior izda.
!     SB 08-apr-2011: values compatible with Greg older than january 2011
!       xoff=  64.0
!       yoff=  129.6
!       deltax=19.5
!       deltay=23.7
!
!      SB 08-apr-2011: values compatible with Greg equal or newer to january 2011
        xoff=  58.0
        yoff=  121.7
        deltax=17.8
        deltay=21.3
!
!     corrijo coordenadas al cambiar dev ps por eps
!     CT 17-Jun-04 adapt gif to the 3 day upshift of eps
!        xoff=xoff-11.75
!        yoff=yoff+38.0-3*deltay
!     back to ps 15-07-06 CT
        xoff=xoff
        yoff=yoff
!cccccccccccccccccccccccccccccccccccccc
        a1     = 0.0
        a2     = 0.0
        xave   = 0.0
        yave   = 0.0
        height = 0.0
        width  = 0.0
        ancho=0.0
        alto=0.0
        centrox=0.0
        centroy=0.0
        u=t

!        write(6,*) t,proje
!        pause

        do j=1,t
        p = j-1
          do i=1,16
            if(diap(s,j).eq.float(diaa(i))) then
                if(j.eq.1) a1=diaa(i)
                if(j.eq.t) a2=diaa(i)

                x(2*p+1) = (tim_st(s,j))*1
                x(2*p+2) = x(2*p+1)
                x(4*u-2*p-1) = (tim_end(s,j))*1
                x(4*u-2*p) = x(4*u-2*p-1)
                y(2*p+1) = (float(i)/1.)
                y(2*p+2) = (float((i+1))/1.)
                y(4*u-2*p-1) = y(2*p+2)
                y(4*u-2*p) = y(2*p+1)
                p = p+1
            endif
          enddo
          width=width+tim_end(s,j)-tim_st(s,j)
        enddo
        height=float(t)
        width=width/float(t)
        do i=1,4*u
           xave=xave+x(i)
           yave=yave+y(i)
        enddo
        xave=xave/(4.*u)
        yave=yave/(4.*u)

        centrox=xave
        centroy=yave-2.0
        ancho=width
        alto=height
!        ancho=6.0
!        alto=1.0
        ancho=ancho/2.0
        alto=alto/2.0

!c         coordenadas para poligono en vez de rectangulo

        do i=1,4*u
          cpolix(i)=xoff+deltax*x(i)
          cpoliy(i)=yoff+deltay*(y(i))
!         cpoliy(i)=yoff+deltay*(y(i)-2
        enddo
        return
        end subroutine gifcoor
!***********************************************************************
! kw002
        subroutine makehtml1(s,fichero,fichero2)
        character    fichero*20,fichero2*20
        integer      s

!        fichero2='test.gif'

        if(s.eq.1) open(unit=96,file=fichero,status='unknown')

!        write (96,1800)
!1800    format('<html>'/'<head>'/'<title>Imagen map test MR </title>')
!1800    format('<html>'/'<head>'/'<title>30m schedule MR </title>')
!        write (96,1801)
!1801    format('</head>'/'<body><center>')
        write (96,1802) fichero2
1802    format('<img src="',a10,' " usemap="#bwmap">')
!        write (96,1803)
!1803    format('</body>')

        write (96,1804)
1804    format('<map name="bwmap">')

        return
        end subroutine makehtml1
!***********************************************************************
! kw004
        subroutine makehtml2(s,fichero)
        character    fichero*20
        integer      s

!        write (96,1801)
!1801    format('</center>') !el center debe incluir el mapa

        write (96,1803)
1803    format('</map>')

!        write (96,1808)
!1808    format('</html>')

        return
        end subroutine makehtml2
!********************************************************************
! kw003
        subroutine  makemap(an,an2,s,fi,proyecto,v,cpolix,cpoliy,yy,mm)

        character(len=*), intent(in) :: fi(50)
        character    fii*20,proyecto(50)*15,bgyear*2
        character    aux*4,poolID*2
        character    href_dir*37
        character*60 text1,text2,text3,text4*50,ans*1
        integer      i,v,s,con_0,con_1,con_2,con_3,con_4,mm,yy,ww
        integer      yydir
        real         cpolix(100), cpoliy(100)
        logical      an, an2

        fii=fi(s)
!        fii='p114-99.html '  !para test
        con_0 = len_trim(fii)

!ccccccccccc elegir opcion cccccccccccccccccccccccccccccccccccc

!        text1='#" onclick="window.open('''
!        text1='#" onmouseout="window.open('''
!        text1='#" onmouseover="window.open('''
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!        text2=fii(1:con_0)//',''mr'',''height=200,'
!        text2=fii(1:con_0)//',''height=200,'
!        text3='width=200,top=200,left=500'');">'
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        text1=fii(1:con_0)//'">'
        text2=' '
        text3=' '

        con_1 = len_trim(text1)
        con_2 = len_trim(text2)
        con_3 = len_trim(text3)

!        text4=text1(1:con_1)//text2(1:con_2)//text3(1:con_3)
        text4=text1(1:con_1)

        write (96,1805) cpolix(1),cpoliy(1)
1805    format('<area shape="poly" coords="',f5.1,',',f5.1)

        do i=2,4*v-1
         write (96,1806) cpolix(i),cpoliy(i)
1806     format(' ',2(',',f5.1))
        enddo

!       special case: the first schedule of next year starts already in Dec
        if (fii(2:3).eq.'00'.and.mm.eq.12) then
           yydir = yy + 1
        else
           yydir = yy
        endif
        write(aux,'(i4)') yydir
        bgyear = aux(3:4)
        read(fii(2:3),'(i2)') ww
!        print *, 'yy= ', yy
!        print *, 'aux:',aux,' yydir= ',yydir,' bgyear:',bgyear

        poolID = text4(5:6)
        href_dir= 'bgfiles/'//bgyear//'/'
!       here poolID represents the first 2 digit of the pool project ID (as defined in the .dat file)
!       for summer semester 400-yy and 300-yy are for heterodyne and bolometer pool, respectively
!       for winter semester 440-yy and 330-yy are for heterodyne and bolometer pool, respectively
!        if (poolID.eq.'30'.or.poolID.eq.'33') then
!           text4 = 'bolopool.html">'
!        elseif (poolID.eq.'40'.or.poolID.eq.'44') then
!           text4 = 'hetepool.html">'
!        endif
!         if (poolID.eq.'30') then
!            text4 = 'bolopool-S11.html">'
!         elseif (poolID.eq.'33') then
!            text4 = 'bolopool-W11.html">'
!         elseif (poolID.eq.'40') then
!            text4 = 'hetepool-S11.html">'
!         elseif (poolID.eq.'44') then
!            text4 = 'hetepool-W11.html">'
!         endif
        con_4 = len_trim(text4)

!        print *, href_dir, text4, poolID
        write (96,1807) cpolix(4*v),cpoliy(4*v),trim(href_dir),trim(text4)
!1807    format(' ,',f5.1,',',f5.1,'" href="',a20)             !CT 24-Jun-04
!1807    format(' ,',f5.1,',',f5.1,
!     1             '" href="../../../../php/schedule/html',a20)    !CT 04-feb-2005
1807    format(' ,',f5.1,',',f5.1,'" href="',a,a)

        if (an) then
!          these files are not used anymore (CT Jan 2005)
!          individual project files are now written by DB
!          open (97,file=fii,status='unknown')
!          close(97,status='delete') !hay que borrar antes de crear otra
!          open (unit=97,file=fii,status='unknown')

!c         files html for each project

          write (97,1820)
1820      format('<html>'/'<head>'/'<title> schedule </title>')
          write (97,1821)
1821      format('</head>'/'<body>')
!          print*, proyecto(s)(4:6), fii
!          pause
          if(proyecto(s)(4:6).eq.char(92)//'gD') then
            proyecto(s)='d'//proyecto(s)(7:15)
!          endif
!          print*, proyecto(s), fii
!          pause
          endif
!          write (97,1831)
1831      format('<p> ')
          write (97,1822) proyecto(s)
1822      format('project: ',a20)
          write (97,1831)
          write (97,1823)
1823      format('PC letter: ')
          write (97,1831)
          write (97,1824)
1824      format('Observer: ')
          write (97,1831)
          write (97,1825)
1825      format('Observing mode:  PV/service/remote')
          write (97,1831)
          write (97,1833)
1833      format('</body>')
          close (unit=97)
        endif
!       option to create only some of the html files
        if(an2) then
          write(6,'(1x,a,$)') 'create ',fii(1:con_0),' (y/n)? > '
          read (5,'(a1)') ans
          if (ans.eq.' ') ans = 'n'
            if((ans.eq.'y').or.(ans.eq.'Y')) then
                open (97,file=fii,status='unknown')
                close(97,status='delete') !hay que borrar antes de crear otra
                open (unit=97,file=fii,status='unknown')
                write (97,1820)
                write (97,1821)

          if(proyecto(s)(4:6).eq.char(92)//'gD') then
            proyecto(s)='d'//proyecto(s)(7:15)
!          endif
!          print*, proyecto(s), fii
!          pause
          endif
                write (97,1822) proyecto(s)
                write (97,1831)
                write (97,1823)
                write (97,1831)
                write (97,1824)
                write (97,1831)
                write (97,1825)
                write (97,1831)
                write (97,1833)

                close (unit=97)
            endif
          endif
        return
        end subroutine makemap
!***********************************************************************

        subroutine hsidnew(ye,mo,da,sid_ho,sid_min,lon_de,lon_mi,lon_se,lsummer)

        integer*4 ye,mo,da,ho,mi,ho0,mi0,sid_ho,sid_min,k
        real*4 lon_de,lon_mi,lon_se,aa,x1,x2,x4,y1,y2,y3,y4
        real*8 dt,hs0,sec,sidtime,sidtime0,factor,sec1
        character chain*80,csid_ho*4
        logical   lsummer

        k=1
        if (mo.le.2) k=0
        aa=ye+k-1
        factor=0.997268519     ! 3m56s less every day

! *** CALCULATING NUMBER OF DAYS :
        dt=float((ye-1)*365-723910+int(aa/4.)-int(aa/100.)  &
           +int(aa/400.)+(mo-1)*31+da-1-k*int(.4*float(mo)+2.3))+1.0
!c      !+1.0day works better MR
!
! *** SIDEREAL TIME :
        hs0=.27800846065+1.002737909315*dt+((lon_se/60.+lon_mi)/60.+  &
            lon_de)/360.0

        hs0= dmod(hs0,1.0d0)*24.
        if (hs0.lt.0.) hs0=hs0+24.      ! sid time at 00:00 UT

        sidtime0=24.0-hs0*factor        ! UT at 00:00 sid time
        sec=sidtime0
        ho0=int(sec)                    ! HOURS
        sec=(sec-int(sec))*60.
        mi0=int(sec)                    ! MINUTES

        sidtime=sidtime0+(sid_ho+sid_min/60.)*factor ! UT at si.d time asked
!        CT: don't draw outside of the box
        if (sidtime.lt.0.) sidtime=sidtime+24.
        if (sidtime.gt.23.) sidtime=sidtime-24.+0.0655555    !
!       if (sidtime.lt.0.8) sidtime=sidtime+24.
!       if (sidtime.gt.23.2) sidtime=sidtime-24.+0.0655555
!cc     0.06555 is +3m56s =+1day
        sec1=sidtime
        sec=sidtime
        ho=int(sec)                     ! SIDEREAL HOURS
        sec=(sec-int(sec))*60.
        mi=int(sec)                     ! SIDEREAL MINUTES

        y1=0.888888
        y2=0.058
        y3=0.037
        write(csid_ho,'(i2.2,a)')   sid_ho,' h'

        call gr_exec('pencil /dash 2 /weig 1')
!       x1=0.095+0.037083*sec1
!       x2=0.095+0.037083*(sec1-1)
        if (lsummer) then
         x1=0.095+0.037083*(sec1+2)
         x2=0.095+0.037083*(sec1+1)
        else
         x1=0.095+0.037083*(sec1+1)
         x2=0.095+0.037083*(sec1+0)
        endif
        if (x1.le.0.115) then      !LST line goes left of UT 0 h
            x4 = 0.096
            y4 = 0.5*(y1-y2)
            write (chain,2225) x1,y1
            call gr_exec (chain)
            write (chain,2226) x4,y4
            call gr_exec (chain)
            x1 = 0.9836
            y1 = y4
            x4 = x1-0.0185
            y4 = y2
            write (chain,2225) x1,y1
            call gr_exec (chain)
            write (chain,2226) x4,y4
            call gr_exec (chain)
            call gr_exec('pencil  /dash 1 /weig 1')
            write (chain,2227) x4,y3,csid_ho
            call gr_exec (chain)
            goto 2230
         else                           !LST lines fully within UT frame
            write (chain,2225) x1,y1
            call gr_exec (chain)
            write (chain,2226) x2,y2
            call gr_exec (chain)
            call gr_exec('pencil  /dash 1 /weig 1')
            write (chain,2227) x2,y3,csid_ho
            call gr_exec (chain)
        endif

2227    format ('draw text',2(1x,f7.4),' " ',a4,'" 5 /USER /CLIP')
2226    format ('draw lin',2(1x,f7.4),' /CLIP')
2225    format ('draw relo',2(1x,f7.4))

2230    continue
        return
        end subroutine hsidnew

!***********************************************************************

        subroutine rx_mark(n,m)    ! (dia=n; receptor=m) MR FEB-91

        integer    n,m
        real       a1,b1,ia,ib,x,y
        character  chain*80

325     format ('draw mark',2(1x,f8.6),' 5 /USER')

        a1=0.814668                             ! origin x
        b1=0.91745                              ! origin y
        ia=0.028518                             ! x increment
        ib=0.05555                              ! y increment

        x=a1+m*ia
        y=b1-n*ib
        write(chain,325) x,y
        call gr_exec (chain)
        return
        end subroutine rx_mark

!       program test
!       program possol
!       integer*4   aano,ames,adia
!       real*8      horasal,horapues
!       aano=1999
!       ames=8
!       adia=1
!       call sunposi (aano,ames,adia,horasal,horapues)
!       print*, 'hora UTC salida del sol= ',horasal
!       print*, 'hora UTC puesta del sol= ',horapues
!       print*, 'del dia = ',adia,ames,aano
!       end
!
!******************POSITION OF THE SUN ****************
        subroutine sunpos (tim1,tim2,tim3,salida,puesta)
!
        integer         time(7)
        integer         tim1,tim2,tim3
        integer         ig,imi,is,iy,im,id,idt,jj
        real*8          ra,de,frday,alst,dt,gst,lst
        real*8          ajd,al_s,elev,azim,errpos,alat,sila,cola,ha
        real*8          eps,pi,ome,e,err,d,ei,am_a,t_a
        real            salida,puesta
! *** parameters :
        pi = 3.14159265359
        eps = 278.833540/180.*pi        ! ecliptic longitude at epoch 1980.0
        ome = 282.596403/180.*pi        ! ecliptic longitude of perigee
        e = 0.016718                    ! eccentricity of orbit
        errpos = 0.25                   ! error allowed in elev
!
        time(1)= tim1           ! year
        time(2)= tim2           ! month
        time(3)= tim3           ! day
        time(4)= 0              ! hour UTC
        time(5)= 0              ! min
        time(6)= 0              ! sec
        time(7)= 0              ! tenth of sec.
! *** getting days since year 1, month 1 and day 1 :
        iy=time(1)
        im=time(2)
        id=time(3)
!       do i =1,7
!         print*,i,time(i),iy,im,id
!       end do
!********************************************
!***********loop to get elev zero************
!********************************************
        call ditra (iy,im,id,idt,ajd) !dias transcurridos
        DO jj= 240,1440 !1440 !  1440min/day=24h*60min/h
!        frday=float(jj/1440.)
        frday=jj/1440.
        dt=float(idt)+frday
!       print*,'fraccion de dia transcurrida : ',frday
!       do i =1,7
!         print*,i,time(i),iy,im,id
!       end do
!       print*,'total dias transcurridos : ',dt,idt
!
!
! *** getting sidereal time :
!       dt=dt-1./24.            ! because computer time
        call getst (dt,gst,lst) ! funciona bien el tiempo sidereo
!       print*,'lst = ',lst
        alst=lst*2.*pi
        call cgms (alst,ig,imi,is,3)
!       print*,'lst = ',lst
!       print*,'doble. time : ',iy,im,id,2*iy,2*im,2*id
!       pause

! *** getting ecliptic coordinates :
!       print*,'total dias transcurridos : ',dt
        de=dt-722813.
        d=de
!       print*,de,d
        am_a = mod((2.*pi/365.2422*d+eps-ome),(2.*pi))  ! mean anomaly
        ei = am_a                                       ! eccentric anomaly
        err=1.
        do while (err.gt.1.e-10)
         err = ei-e*sin(ei)-am_a
         de = err/(1.-e*cos(ei))
         ei = ei-de
        end do
        t_a = 2.*atan(sqrt((1.+e)/(1.-e))*tan(ei/2.))   ! true anomaly
        al_s = mod((t_a+ome),(2.*pi))                   ! longitude of the sun
!

! *** getting equatorial coordinates :
        call eecc (al_s,0.d0,ra,de)       ! right ascension and declination
        call cgms (ra,ig,imi,is,3)
!       print*,'ra => ',ra,ig,imi,is
        call cgms (de,ig,imi,is,2)
!       print*,'de => ',de,ig,imi,is
!
!
! *** getting horizon coordinates :
        alat=.646962526         ! 30m radiot. latitude (37deg. 4' 5.6")
        sila=sin(alat)
        cola=cos(alat)
        ha=lst*2.*pi-ra                 ! hour angle (radians)
!       print*,'hour angle = ',ha
        elev=asin(sin(de)*sila+cos(de)*cola*cos(ha))
        azim=acos((sin(de)-sila*sin(elev))/(cola*cos(elev)))
        if ((sin(ha)).gt.0.) azim=2.*pi-azim
!       print*,'az and el = ',azim,elev
        call cgms (azim,ig,imi,is,1)
!       print*,'azimuth = ',azim,ig,imi,is
        call cgms (elev,ig,imi,is,1)
!       print*,'elevat. = ',elev,ig,imi,is
        azim=azim/pi*180.
        elev=elev/pi*180.
!       print*, azim
!       print*, elev
        if((-errpos.le.elev).and.(elev.le.errpos)) then
!          print*, 'az,el',jj,azim,elev,frday,idt
           if((240.le.jj).and.(jj.le.540))   salida=24.*frday
           if((960.le.jj).and.(jj.le.1440))  puesta=24.*frday
        end if
        END DO
!       print*,'jj,fracc de dia ,elev= ', jj,frday,elev
!       end do
        return ! end sunpos
        end subroutine sunpos
!c
        subroutine eecc (elo,ela,ra,de)
!   subroutine to make the ecliptic to equatorial coordinate conversion
!   elo = ecliptic longitude (radians)
!   ela = ecliptic latitude (radians)
!   ra = riht ascension (radians)
!   de = declination (radians)
        real*8 elo,ela,ra,de,pi,ep
        real*8 anum,den
        pi = 3.14159265359
        ep=23.441884/180.*pi    ! obliquity of the ecliptic
!
! *** calculation of the right ascension ra:
        anum=sin(elo)*cos(ep)-tan(ela)*sin(ep)
        den=cos(elo)
        ra=atan(anum/den)
        if (den.lt.0.) ra=ra+pi
        ra=mod(ra,(2.*pi))
!
! *** calculation of the declination de:
        de=asin(sin(ela)*cos(ep)+cos(ela)*sin(ep)*sin(elo))
        de=mod(de,(2*pi))
        return
        end subroutine eecc
!
!
        subroutine cgms (angi,gra,min,sec,k)
!   subroutine to make the conversion of the angle ang with the following
!   options:
!   k=1, 0 <= output angle < 360
!   k=2, -180 < output angle <= 180
!   k=3, 0 h <= output angle < 24 h
        integer gra,sec,min,k
        real*8  pi,ang,angi,amin
        pi = 3.14159265359
        ang=angi*180./pi
        ang=mod(ang,360.d00)
        if ((k.eq.3).and.(ang.lt.0.)) ang=ang+360.
        if (k.eq.2.and.ang.gt.180.) ang=ang-360.
        if (k.eq.3) ang=ang/15.
        gra=int(ang)
        amin=60.*(ang-float(gra))
        min=int(amin)
        sec=nint(60.*(amin-float(min)))
        return
        end subroutine cgms
!
!
        subroutine ditra (an,me,di,dt,jd)
!
!   subrutina para calcular los dias transcurridos desde el comienzo de nuestra
!   era. ano 1, mes 1 y dia 1 dara 0 dias transcurridos.
!
!       an = ano                        (input integer*4)
!       me = mes                        (input integer*4)
!       di = dia                        (input integer*4)
!       dt = dias transcurridos         (output integer*4)
!       jd = julian date                (output real*4)
!
        integer         k,ab,an,me,di,dt
        real*8          jd
!
        k=1
        if (me.le.2) k=0
        ab=an+k-1
        dt=(an-1)*365+int(ab/4.)-int(ab/100.)+int(ab/400.)  &
           +(me-1)*31+di-1-k*int(.4*float(me)+2.3)
        jd=float(dt)+1721425.5
        return
        end subroutine ditra
!
!
        subroutine getst (dt,gst,lst)
!
!   subrutina para obtener gst (greenwich sidereal time) y lst (local sidereal
!   time) conociendo los dt (dias transcurridos) desde el comienzo de nuestra
!   era.
!
!       dt  = dias transcurridos desde comienzo era     (input real*8)
!       gst = greenwich sidereal time (fraction of day) (output real*8)
!       lst = loca sidereal time at 30m radiotelescope  (output real*8)
!
        real*8  dt,gst,lst,dtb
!
        dtb=dt-723910.          ! dias transcurridos desde comienzo 1983
        gst=.27800846065+1.002737909315*dtb
        if (gst.lt.0.) gst=gst-int(gst)+1.
        gst=gst-int(gst)
        lst=gst-0.009442978     ! local sidereal time
        return
        end subroutine getst
!
subroutine parse_file_name(file,basename,wk,vers,error)
  !---------------------------------------------------------------------
  ! @ private
  ! Decode the file version from file name. File name must have the form
  !   wk12v3.dat  (1 or more digits for the version).
  ! Return version as an integer
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file      !
  character(len=*), intent(out)   :: basename  !
  integer(kind=4),  intent(out)   :: wk        ! Week number
  integer(kind=4),  intent(out)   :: vers      ! Version
  logical,          intent(inout) :: error     !
  ! Local
  integer :: vpos,dpos,ier
  !
  vpos = index(file,'v')+1
  dpos = index(file,'.')-1
  basename = file(1:dpos)
  !
  read(file(3:4),*,iostat=ier)  wk
  if (ier.ne.0) then
    write(6,*) 'Error getting week number from file name '//trim(file)
    error = .true.
    return
  endif
  !
  read(file(vpos:dpos),*,iostat=ier)  vers
  if (ier.ne.0) then
    write(6,*) 'Error getting version from file name '//trim(file)
    error = .true.
    return
  endif
  !
end subroutine parse_file_name

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_get
  use cubetools_parameters
  use cubetuple_format_class
  use cubeadm_messaging
  use cubedag_directory_type
  use cubeadm_cubeid_types
  use cubeadm_opened
  use cubeadm_ioloop
  !
  public :: cubeadm_get_cube
  public :: cubeadm_get_header,cubeadm_get_fheader
  public :: cubeadm_access_header,cubeadm_access_fheader
  public :: cubeadm_get_last_cube
  private
  !
  ! We have 2 main use cases here.
  ! 1) Get the header of an exact type(cube_t) or an exact type(uv_t) etc, or
  ! 2) Get the header of a class(format_t) for more generic uses (the exact
  !    type can be cube_t or uv_t, etc).
  ! Since a type(cube_t) is also a class(format_t), this is ambiguous and
  ! we can not create a generic interface for this. Must rely on 2
  ! different API names.
  !
  interface cubeadm_get_header
    module procedure get_cube_header_from_id
    module procedure get_cube_header_from_cubeid
  ! module procedure get_uv_header_from_id        ! Not yet implemented
  ! module procedure get_uv_header_from_cubeid    ! Not yet implemented
  end interface cubeadm_get_header
  !
  interface cubeadm_get_fheader
  ! module procedure get_format_header_from_id    ! Not yet implemented
    module procedure get_format_header_from_cubeid
  end interface cubeadm_get_fheader
  !
  interface cubeadm_access_header
    module procedure cubeadm_access_cube_header
  ! module procedure cubeadm_access_uv_header     ! Not yet implemented
  end interface cubeadm_access_header
  !
  interface cubeadm_access_fheader
    module procedure cubeadm_access_format_header
  end interface cubeadm_access_fheader
  !
contains
  !
  subroutine cubeadm_get_cube(id,access,action,oucube,error)
    use cubedag_parameters
    use cubeio_cube_define
    use cube_types
    !----------------------------------------------------------------------
    ! Get header + data in MEMORY only
    ! ---
    ! OBSOLESCENT DO NOT USE!
    ! To be removed when OLDLOAD /SYNTAX HGDF is gone
    !----------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: id      ! Cube ID number
    integer(kind=code_k), intent(in)    :: access
    integer(kind=code_k), intent(in)    :: action  ! Read/write/update?
    type(cube_t),         pointer       :: oucube
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>CUBE'
    integer(kind=entr_k) :: first,last
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Header
    call get_cube_header_from_id(id,access,action,oucube,error,  &
      bufferin=code_buffer_memory)
    if (error) return
    !
    ! Data: request the whole entry range to be loaded in memory
    first = 1
    last = oucube%nentry()
    call cubeadm_io_iterate(first,last,oucube,error)
    if (error) return
    !
    ! Reset the memory mode ZZZ Resetting everything is unsatisfying...
    call oucube%prog%reset(error)
    if (error) return
  end subroutine cubeadm_get_cube
  !
  !---------------------------------------------------------------------
  !
  subroutine get_cube_header_from_id(id,access,action,oucube,error,  &
    bufferin)
    use cubedag_parameters
    use cubedag_node_class
    use cubedag_dag_buffer
    use cube_types
    !----------------------------------------------------------------------
    ! Get the header of the requested cube.
    ! File access and action is declared here, as a pre-declaration of the
    ! future data access.
    ! ---
    ! With insertion in parent list.
    !----------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: id      ! Cube ID number
    integer(kind=code_k), intent(in)    :: access  ! code_access_*
    integer(kind=code_k), intent(in)    :: action  ! Read/write/update?
    type(cube_t),         pointer       :: oucube  !
    logical,              intent(inout) :: error   !
    integer(kind=code_k), intent(in), optional :: bufferin  ! OBSOLESCENT only for cubeadm_get_cube
    ! Local
    character(len=*), parameter :: rname='GET>CHEADER>FROM>ID'
    class(cubedag_node_object_t), pointer :: ounode
    !
    call cubedag_dag_get_object(id,ounode,error)
    if (error) return
    oucube => cubeformats_cube_ptr(ounode,error)
    if (error) return
    call fill_format_header(access,action,oucube,error,bufferin)
    if (error) return
    call cubeadm_parents_add(ounode,action)
  end subroutine get_cube_header_from_id
  !
  subroutine get_format_header_from_cubeid(cubearg,user,pformat,error,access,action)
    use cubedag_parameters
    use cubedag_dag_buffer
    use cubedag_node_class
    !----------------------------------------------------------------------
    ! Get a format header directly from the cubeid_user_cube_t
    ! ---
    ! With insertion in parent list.
    !----------------------------------------------------------------------
    type(cubeid_arg_t),   intent(in)           :: cubearg  ! The cube argument
    type(cubeid_user_t),  intent(in)           :: user     ! User cubeid registered
    class(format_t),      pointer              :: pformat  ! Resolved format pointer
    logical,              intent(inout)        :: error    !
    integer(kind=code_k), intent(in), optional :: access   ! Overload the cubearg access?
    integer(kind=code_k), intent(in), optional :: action   ! Overload the cubearg action?
    ! Local
    integer(kind=code_k) :: laccess,laction
    class(cubedag_node_object_t), pointer :: ounode
    integer(kind=iden_l) :: id
    character(len=*), parameter :: rname='GET>FHEADER>FROM>CUBEID'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubedag_cubeid_user2prog_one(cubearg,user%cube(cubearg%inum),id,error)
    if (error) return
    call cubedag_dag_get_object(id,ounode,error)
    if (error) return
    pformat => cubetuple_format_ptr(ounode,error)
    if (error) return
    if (present(access)) then
      ! Developer has overloaded the cubearg predeclared access.
      laccess = access
    else
      laccess = cubearg%access
    endif
    if (present(action)) then
      ! Developer has overloaded the cubearg predeclared access.
      laction = action
    else
      laction = cubearg%action
    endif
    call fill_format_header(laccess,laction,pformat,error)
    if (error) return
    call cubeadm_parents_add(cubearg,user%cube(cubearg%inum),ounode,laction)
  end subroutine get_format_header_from_cubeid
  !
  subroutine get_cube_header_from_cubeid(cubearg,user,pcube,error,access,action)
    use cube_types
    !----------------------------------------------------------------------
    ! Get a format header directly from the cubeid_user_cube_t
    ! ---
    ! With insertion in parent list.
    !----------------------------------------------------------------------
    type(cubeid_arg_t),   intent(in)           :: cubearg  ! The cube argument
    type(cubeid_user_t),  intent(in)           :: user     ! User cubeid register
    type(cube_t),         pointer              :: pcube    ! Resolved cube pointer
    logical,              intent(inout)        :: error    !
    integer(kind=code_k), intent(in), optional :: access   ! Overload the cubearg access?
    integer(kind=code_k), intent(in), optional :: action   ! Overload the cubearg action?
    !
    class(format_t), pointer :: pformat
    !
    call get_format_header_from_cubeid(cubearg,user,pformat,error,access,action)
    if (error) return
    pcube => cubeformats_cube_ptr(pformat,error)
    if (error) return
  end subroutine get_cube_header_from_cubeid
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeadm_access_cube_header(cube,access,action,error,opened)
    use cubedag_node_class
    use cube_types
    !----------------------------------------------------------------------
    ! * Same as cubeadm_get_header, without the 'find' and 'read-header'
    !   parts.
    ! * From a cube with header already in memory, (re)declare the file
    !   access and action on the cube, as a pre-declaration of the future
    !   data access.
    ! * Also reference the cube in the opened parents list, except if
    !   option 'opened' is present and .false.
    !----------------------------------------------------------------------
    type(cube_t),         pointer       :: cube    !
    integer(kind=code_k), intent(in)    :: access  ! code_access_*
    integer(kind=code_k), intent(in)    :: action  ! Read/write/update?
    logical,              intent(inout) :: error   !
    logical, optional,    intent(in)    :: opened  !
    !
    class(format_t), pointer :: format
    !
    format => cube
    call cubeadm_access_format_header(format,access,action,error,opened)
    if (error)  return
  end subroutine cubeadm_access_cube_header
  !
  subroutine cubeadm_access_format_header(cube,access,action,error,opened)
    use cubedag_node_class
    !----------------------------------------------------------------------
    ! * Same as cubeadm_get_header, without the 'find' and 'read-header'
    !   parts.
    ! * From a cube with header already in memory, (re)declare the file
    !   access and action on the cube, as a pre-declaration of the future
    !   data access.
    ! * Also reference the cube in the opened parents list, except if
    !   option 'opened' is present and .false.
    !----------------------------------------------------------------------
    class(format_t),      pointer       :: cube    !
    integer(kind=code_k), intent(in)    :: access  ! code_access_*
    integer(kind=code_k), intent(in)    :: action  ! Read/write/update?
    logical,              intent(inout) :: error   !
    logical, optional,    intent(in)    :: opened  !
    ! Local
    character(len=*), parameter :: rname='ACCESS>FORMAT>HEADER'
    class(cubedag_node_object_t), pointer :: node
    logical :: lopened
    !
    ! Sanity
    if (.not.associated(cube)) then
      call cubeadm_message(seve%e,rname,'Internal error: node pointer is null')
      error = .true.
      return
    endif
    ! ZZZ Should add sanity to check if the cube%head is available
    !
    ! The following subroutine is optimized to avoid re-filling the header
    ! if already present.
    call fill_format_header(access,action,cube,error)
    if (error) return
    !
    ! Add to the list of parents for this command
    if (present(opened)) then
      lopened = opened
    else
      lopened = .true.
    endif
    if (lopened) then
      node => cube
      call cubeadm_parents_add(node,action)
    endif
  end subroutine cubeadm_access_format_header
  !
  subroutine fill_format_header(access,action,oucube,error,buffering)
    use cubetools_access_types
    use cubeio_cube_define
    use cubetuple_get
    !----------------------------------------------------------------------
    ! Get the header in the requested order from the file whose filename is
    ! available on disk. Its action (read/update) is set at this stage of
    ! the process.
    !----------------------------------------------------------------------
    integer(kind=code_k), intent(in)           :: access     ! code_access_*
    integer(kind=code_k), intent(in)           :: action     ! Read/write/update?
    class(format_t),      intent(inout)        :: oucube     !
    logical,              intent(inout)        :: error      !
    integer(kind=code_k), intent(in), optional :: buffering  ! OBSOLESCENT only for cubeadm_get_cube
    ! Local
    character(len=*), parameter :: rname='GET>HEADER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    if (action.eq.code_read_none)  return  ! Header not requested at all
    !
    call oucube%prog%set_access(access,error)
    if (error) return
    if (access.eq.code_access_imaset .or.  &
        access.eq.code_access_speset) then
      call oucube%prog%set_order(cubetools_access2order(access),error)
      if (error) return
    else
      ! Leave unset, should not be needed.
    endif
    call oucube%prog%set_action(action,error)
    if (error) return
    if (access.eq.code_access_fullset) then
      ! Enforce memory mode
      call oucube%prog%set_buffering(code_buffer_memory,error)
      if (error) return
    elseif (present(buffering)) then
      call oucube%prog%set_buffering(buffering,error)
      if (error) return
    endif
    ! If the file is to be generated as a transposed cube, set its file name
    call oucube%prog%set_transname(cubeadm_transname(oucube%node%id,access,error),  &
                                   error)
    if (error) return
    !
    ! Fetch from memory or read from disk the header:
    call cubetuple_get_cube_header(oucube,error)
    if (error) return
    !
  end subroutine fill_format_header
  !
  function cubeadm_transname(id,taccess,error)
    use cubetools_access_types
    use cubedag_parameters
    !---------------------------------------------------------------------
    ! Return the transposed file name (path+base+extension) from the
    ! original file name.
    ! If iname has the form: ipath/ibase.iext
    !    tname is set as:    dir%tmp/id.text
    !
    ! Note that for 100% robustness, the transposed file does not use the
    ! same basename as its original file. This because we can be dealing
    ! with 2 raw files raw1/foo.lmv and raw2/foo.lmv, and both transposed
    ! would be named tmp/foo.vlm
    !---------------------------------------------------------------------
    character(len=file_l)               :: cubeadm_transname
    integer(kind=iden_l), intent(in)    :: id
    integer(kind=4),      intent(in)    :: taccess  ! code_cube_*
    logical,              intent(inout) :: error
    !
    write(cubeadm_transname,'(a,i0,a)') trim(dir%tmp),id,cubetools_access2ext(taccess)
  end function cubeadm_transname
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeadm_get_last_cube(cube,error)
    use cubedag_node_class
    use cubedag_link_type
    use cubedag_find_types
    use cube_types
    !----------------------------------------------------------------------
    ! Gets the last cube in the DAG
    !----------------------------------------------------------------------
    type(cube_t), pointer       :: cube
    logical,      intent(inout) :: error
    !
    type(dag_find_t) :: find
    type(cubedag_link_t) :: idx
    class(cubedag_node_object_t), pointer :: dno
    character(len=*), parameter :: rname='GET>LAST>CUBE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call find%ix2optx(idx,error)
    if (error) return
    dno => cubedag_node_ptr(idx%list(idx%n)%p,error)
    if (error) return
    cube => cubeformats_cube_ptr(dno,error)
    if (error) return
  end subroutine cubeadm_get_last_cube
end module cubeadm_get
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_write_command(line,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_write_command
  use wifisyn_readwrite_types
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command WRITE
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  type(readwrite_t) :: do
  character(len=*), parameter :: rname='WRITE/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_parse_readwrite(line,do,error)
  if (error) return
  call wifisyn_write_main(do,error)
  if (error) return
  !
end subroutine wifisyn_write_command
!
subroutine wifisyn_write_main(do,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_write_main
  use wifisyn_readwrite_types
  use wifisyn_sic_buffer
  use wifisyn_uv_buffer
  use wifisyn_cube_buffer
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(readwrite_t), intent(inout) :: do
  logical,           intent(inout) :: error
  !
  character(len=*), parameter :: rname = 'WRITE/MAIN'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Dispatch according to type
  if (do%buffer.eq.code_buffer_beam) then
!     call wifisyn_cube_write(do,beam,error)
     if (error) return
  else if (do%buffer.eq.code_buffer_dirty) then
!     call wifisyn_cube_write(do,dirty,error)
     if (error) return
  else if (do%buffer.eq.code_buffer_visi) then
     call wifisyn_write_visi(do,progmap,visi,error)
     if (error) return
  else if (do%buffer.eq.code_buffer_wifi) then
     call wifisyn_write_wifi(do,progmap,wifi,error)
     if (error) return
  else if (do%buffer.eq.code_buffer_uv) then
     call wifisyn_write_uv(do,uvr,error)
     if (error) return
  else
     call wifisyn_message(seve%e,'WRITE','Writing of '//do%kind//' not yet implemented')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_write_main
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_setup_command(line,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_setup_command
  use wifisyn_uv_buffer
  use wifisyn_sic_buffer
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  type(uv_t) :: uvtmp
  character(len=*), parameter :: rname='SETUP/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_setup_main(usermap,uvr,progmap,uvtmp,error)
  if (error) return
  call wifisyn_free_uv(uvtmp,error)
  if (error) return
  !
end subroutine wifisyn_setup_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_setup_main(user,uvin,map,uvout,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_setup_main
  use wifisyn_uv_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(sicmap_t), intent(in)    :: user
  type(uv_t),     intent(in)    :: uvin
  type(map_t),    intent(inout) :: map
  type(uv_t),     intent(inout) :: uvout
  logical,        intent(inout) :: error
  !
  character(len=*), parameter :: rname='SETUP/MAIN'
  !
  call wifisyn_setup_uvtmp(uvin,uvout,error)
  if (error) return
  call wifisyn_setup_map_and_shift_header(user,map,uvout%head,error)
  if (error) return
  !
end subroutine wifisyn_setup_main
!
subroutine wifisyn_setup_uvtmp(uvin,uvout,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_setup_uvtmp
  use wifisyn_uv_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(uv_t), intent(in)    :: uvin
  type(uv_t), intent(inout) :: uvout
  logical,    intent(inout) :: error
  !
  character(len=*), parameter :: rname='SETUP/UVTMP'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_reallocate_uv_header(uvout,uvin%head%type%ndata,error)
  if (error) return
  call wifisyn_copy_uv_header(uvin,uvout,error)
  if (error) return
  !
end subroutine wifisyn_setup_uvtmp
!
subroutine wifisyn_setup_map_and_shift_header(user,map,huv,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_setup_map_and_shift_header
  use wifisyn_uv_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(sicmap_t),  intent(in)    :: user
  type(map_t),     intent(inout) :: map
  type(uv_head_t), intent(inout) :: huv
  logical,         intent(inout) :: error
  !
  integer :: iaxis
  character(len=*), parameter :: rname='SETUP/MAP+SHIFT/HEAD'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_gridding_nullify_map(map)
  call wifisyn_gridding_set_huv(huv,map,error)
  if (error) return
  call wifisyn_gridding_set_tabdim(huv,map%n,error)
  if (error) return
  call wifisyn_gridding_set_rchan(huv,map%rchan,error)
  if (error) return
  call wifisyn_gridding_set_winlist(user,map%n%chan,map%win,error)
  if (error) return
  call wifisyn_gridding_set_shift(user,huv%file,map%rchan,map%shift,error)
  if (error) return
  call wifisyn_shift_uv_head(map%shift,huv,error)
  if (error) return
  call wifisyn_gridding_set_topology(huv,map%topo,error)
  if (error) return
  do iaxis=1,2
     call wifisyn_gridding_set_1d_scale(huv%file,map%rchan,map%topo(iaxis),map%scale(iaxis),error)
     if (error) return
     call wifisyn_gridding_set_1d_axis(map%rchan,map%scale(iaxis),map%axes(iaxis),error)
     if (error) return
     call wifisyn_gridding_set_1d_kernel(user,map%axes(iaxis)%u,map%kern(iaxis)%u,error)
     if (error) return
     call wifisyn_gridding_set_1d_kernel(user,map%axes(iaxis)%x,map%kern(iaxis)%x,error)
     if (error) return
  enddo ! iaxis
  call wifisyn_gridding_set_taper(user,map%taper,error)
  if (error) return
  call wifisyn_gridding_set_buffer(map,error)
  if (error) return
  call wifisyn_gridding_print(map,error)
  if (error) return
  call wifisyn_gridding_sicdef_prog(code_request_prog,error)
  if (error) return
  !
end subroutine wifisyn_setup_map_and_shift_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine astro_init(error)
  use gbl_message
  use gkernel_interfaces
  use ast_line
  use ast_astro
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !	Initialize ASTRO parameters
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Local
  character(len=10) :: chain
  character(len=16) :: varname
  character(len=10) :: rname= 'ASTRO_INIT'
  integer(kind=4) :: nv
  !
  ! Code :
  nsplot = 0
  jnow_utc = 2451545.0d0
  ! mjd = jul.date. - 2400000.5
  ! d_ut1 = 0.3290 - 0.00140*(mjd - 47184)
  d_ut1 = 0.0d0
  d_tdt = 56.184d0
  altitude = 2.560             ! in kilometers
  chain = '05:54:26.0'
  call sic_sexa (chain,10,lonlat(1),error)
  chain = '44:38:01.2'
  call sic_sexa (chain,10,lonlat(2),error)
  obs_year = 2015            ! default
  alma_cycle = 1              ! default
  !
  jnow_utc = j2000 - 12 * 365.25d0
  jnow_ut1 = jnow_utc + d_ut1 / 86400.d0
  jnow_tdt = jnow_utc + d_tdt / 86400.d0
  call ephini(error)
  if (error) then
    call astro_message(seve%f,rname,'Error in EPHINI')
    return
  else
    call astro_message(seve%i,rname,'Ephemeris opened')
  endif
  call gr_exec('SET SYSTEM UNKNOWN')
  projection = .false.
  frame = 'HORIZONTAL'
  azref = 'S'
  call gr_exec('PROJECTION 0 0 /TYPE NONE')
  call gr_exec1('LIMITS -180 180 0. 90.')
  call gr_exec1('TICKSPACE 10. 30. 5. 15.')
  call gr_exec1('BOX')
  call gr_exec1('LIMITS -pi pi 0 pi|2')
  call gr_exec1('LABEL "Azimuth (degrees)" /X')
  call gr_exec1('LABEL "Elevation  (degrees)" /Y')
  !
  ! SIC variables
  !
  ! The 4 following variables duplicate the CLASS variables
  ! and are only used for display. They may be advantageously
  ! replaced by the astro%source%  similar variables defined in object.f90
  !
  call sic_def_dble('AZIMUTH',azimuth,0,1,.true.,error)
  !! if (error) return
  call sic_def_dble('ELEVATION',elevation,0,1,.true.,error)
  !! if (error) return
  call sic_def_dble('LAMBDA',s_1(1),0,1,.true.,error)
  !! if (error) return
  call sic_def_dble('BETA',s_1(2),0,1,.true.,error)
  !! if (error) return
  !
  call sic_def_dble('RA',ra,0,1,.true.,error)
  if (error) return
  call sic_def_dble('DEC',dec,0,1,.true.,error)
  if (error) return
  call sic_def_dble('PAR_ANGLE',parallactic_angle,0,1,.true.,error)
  if (error) return
  call sic_def_dble('DOPPLER',fshift,0,1,.false.,error)
  if (error) return
  call sic_def_dble('FREQUENCY',freq,0,1,.false.,error)
  !! if (error) return
  ! No longer needed. Use Astro%Source%v_sou_lsr
  !  call sic_def_real('ASTRO_VELOCITY',velocity,0,1,.true.,error)
  !  if (error) return
  call sic_def_dble('SUN_LIMIT',slimit,0,1,.false.,error)
  if (error) return
  call sic_def_char('FRAME',frame,.true.,error)
  if (error) return
  ! No longer needed. Use Astro%Source%Name
  ! call sic_def_char('ASTRO_SOURCE',source_name,.true.,error
  ! if (error) return
  call sic_def_char('CATALOG',catalog_name(1),.true.,error)
  if (error) return
  call sic_def_char('CATALOG_ALT',catalog_name(2),.true.,error)
  if (error) return
  !
  !      CALL SIC_DEF_DBLE ('FLO1',FLO1,1,2,.TRUE.,ERROR)
  !      IF (ERROR) RETURN
  !      CALL SIC_DEF_DBLE ('FLO2',FLO2,1,2,.TRUE.,ERROR)
  !      IF (ERROR) RETURN
  !
  call sic_def_char('OBSERVATORY',obsname,.true.,error)
  if (error) return
  call sic_def_dble('OBS_LONLAT',lonlat,1,2,.true.,error)
  call sic_def_dble('OBS_ALTITUDE',altitude,0,1,.true.,error)
  !   if (error) return
  ! No longer needed. Use Astro%Planet%TMB
  !   call sic_def_real('PLANET_TMB',planet_tmb,0,1,.true.,error)
  !   if (error) return
  ! No longer needed. Use Astro%Planet%FLUX
  !   call sic_def_real('PLANET_FLUX',planet_flux,0,1,.true.,error)
  !   if (error) return
  ! No longer needed. Use Astro%Planet%SIZE
  !   call sic_def_real('PLANET_SIZE',planet_size,1,3,.true.,error)
  !   if (error) return
  call sic_def_inte('RECEIVER',recband,0,1,.false.,error)
  if (error) return
  tolerance_freq = 1 ! 1 MHz default frequency tolerance on ALMA\SPWINDOW command
  call sic_def_real('TOLERANCE_FREQ',tolerance_freq,0,1,.false.,error)
  !
  ! For OMS communication
  varname = 'OMS'
  if (.not.sic_varexist(varname)) then
      call sic_defstructure(varname,.false.,error)
      if (error) return
  endif
  nv=lenc(varname)
  call sic_def_char(varname(1:nv)//'%CALLER',oms_caller(1:lenc(oms_caller)),.false.,error)
  call sic_def_logi(varname(1:nv)//'%BUGW20',oms_bugw20,.false.,error)
  !
end subroutine astro_init

module cubedag_links_type
  use cubedag_parameters
  use cubedag_link_type
  !
  public :: cubedag_links_t
  public :: cubedag_hlinks_t
  private
  !
  ! Cross links for the DAG
  type :: cubedag_links_t
    type(cubedag_link_t), public :: parents   ! List of parent nodes
    type(cubedag_link_t), public :: children  ! List of child nodes
    type(cubedag_link_t), public :: twins     ! List of twin nodes
    integer(kind=iden_l), allocatable, private :: pids(:)  ! Parent ids for snapshot-read
    integer(kind=iden_l), allocatable, private :: cids(:)  ! Child ids for snapshot-read
    integer(kind=iden_l), allocatable, private :: tids(:)  ! Twin ids for snapshot-read
  contains
    procedure, public :: write   => cubedag_links_write
    procedure, public :: read    => cubedag_links_read
    procedure, public :: resolve => cubedag_links_resolve
    procedure, public :: final   => cubedag_links_final
  end type cubedag_links_t
  !
  ! Cross links for the history
  type :: cubedag_hlinks_t
    type(cubedag_link_t), public :: inputs   ! List of command inputs
    type(cubedag_link_t), public :: outputs  ! List of command outputs
    integer(kind=iden_l), allocatable, private :: iids(:)  ! Input ids for snapshot-read
    integer(kind=iden_l), allocatable, private :: oids(:)  ! Output ids for snapshot-read
  contains
    procedure, public :: write   => cubedag_hlinks_write
    procedure, public :: read    => cubedag_hlinks_read
    procedure, public :: resolve => cubedag_hlinks_resolve
    procedure, public :: final   => cubedag_hlinks_final
  end type cubedag_hlinks_t
  !
contains
  !
  subroutine cubedag_links_write(links,lun,error)
    class(cubedag_links_t), intent(in)    :: links
    integer(kind=4),        intent(in)    :: lun
    logical,                intent(inout) :: error
    !
    call links%parents%write(lun,'PARENTS',error)
    if (error)  return
    call links%children%write(lun,'CHILDREN',error)
    if (error)  return
    call links%twins%write(lun,'TWINS',error)
    if (error)  return
  end subroutine cubedag_links_write
  !
  subroutine cubedag_links_read(links,lun,nshift,error)
    class(cubedag_links_t), intent(inout) :: links
    integer(kind=4),        intent(in)    :: lun
    integer(kind=iden_l),   intent(in)    :: nshift  ! links ID shift
    logical,                intent(inout) :: error
    !
    call links%parents%read(lun,nshift,links%pids,error)
    if (error)  return
    call links%children%read(lun,nshift,links%cids,error)
    if (error)  return
    call links%twins%read(lun,nshift,links%tids,error)
    if (error)  return
  end subroutine cubedag_links_read
  !
  subroutine cubedag_links_resolve(links,optx,error)
    !-------------------------------------------------------------------
    ! Resolve all the cross-links (from IDs to pointer) for the given
    ! object.
    !-------------------------------------------------------------------
    class(cubedag_links_t), intent(inout) :: links
    type(cubedag_link_t),   intent(in)    :: optx
    logical,                intent(inout) :: error
    !
    call links%parents%resolve (optx,links%pids,error)
    if (error)  return
    call links%children%resolve(optx,links%cids,error)
    if (error)  return
    call links%twins%resolve   (optx,links%tids,error)
    if (error)  return
  end subroutine cubedag_links_resolve
  !
  subroutine cubedag_links_final(links,error)
    class(cubedag_links_t), intent(inout) :: links
    logical,                intent(inout) :: error
    !
    call links%parents%final(error)
    if (error)  continue
    call links%children%final(error)
    if (error)  continue
    call links%twins%final(error)
    if (error)  continue
    !
    if (allocated(links%pids)) deallocate(links%pids)
    if (allocated(links%cids)) deallocate(links%cids)
    if (allocated(links%tids)) deallocate(links%tids)
  end subroutine cubedag_links_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubedag_hlinks_write(links,lun,error)
    class(cubedag_hlinks_t), intent(in)    :: links
    integer(kind=4),         intent(in)    :: lun
    logical,                 intent(inout) :: error
    !
    call links%inputs%write(lun,'INPUTS',error)
    if (error)  return
    call links%outputs%write(lun,'OUTPUTS',error)
    if (error)  return
  end subroutine cubedag_hlinks_write
  !
  subroutine cubedag_hlinks_read(links,lun,nshift,error)
    class(cubedag_hlinks_t), intent(inout) :: links
    integer(kind=4),         intent(in)    :: lun
    integer(kind=iden_l),    intent(in)    :: nshift  ! links ID shift
    logical,                 intent(inout) :: error
    !
    call links%inputs%read(lun,nshift,links%iids,error)
    if (error)  return
    call links%outputs%read(lun,nshift,links%oids,error)
    if (error)  return
  end subroutine cubedag_hlinks_read

  subroutine cubedag_hlinks_resolve(links,optx,error)
    !-------------------------------------------------------------------
    ! Resolve all the cross-links (from IDs to pointer) for the given
    ! object.
    !-------------------------------------------------------------------
    class(cubedag_hlinks_t), intent(inout) :: links
    type(cubedag_link_t),    intent(in)    :: optx
    logical,                 intent(inout) :: error
    !
    call links%inputs%resolve(optx,links%iids,error)
    if (error)  return
    call links%outputs%resolve(optx,links%oids,error)
    if (error)  return
  end subroutine cubedag_hlinks_resolve
  !
  subroutine cubedag_hlinks_final(links,error)
    class(cubedag_hlinks_t), intent(inout) :: links
    logical,                 intent(inout) :: error
    !
    call links%inputs%final(error)
    if (error)  continue
    call links%outputs%final(error)
    if (error)  continue
    !
    if (allocated(links%iids)) deallocate(links%iids)
    if (allocated(links%oids)) deallocate(links%oids)
  end subroutine cubedag_hlinks_final
end module cubedag_links_type

subroutine solve(line,error)
!
! Called by subroutine run_mira (MIRA command "solve"). 
! Calls the appropriate subroutines and plotting procedures
! for solving cross-scan pointings, focus measurements (axial or lateral ones)
! and skydips.
!
! Input: command line from interactive MIRA session or ODP script.
! Output: error flag.
!
   use mira
   !
   implicit none
   !
   integer                :: i,idir, ifb,ibase,ipix,nbin,nc,nrecords
   integer                :: ifb1, ifb2
   integer ,dimension(2,1) :: idummy
   real*8, dimension(2,1) :: dummy
   character(len = *)     :: line
   character              :: string*17
   character(len=20)      :: tmpstring
   character(len=40)      :: string2
   character(len=80)      :: option
   character(len=200)     :: command
   logical                :: error, sic_present
   !
   command = line
   !
   tmpstring = scan%header%scantype
   call sic_upper(tmpstring)
   !
   ifb1 = 0
   ifb2 = 0
   !
   if (index(tmpstring,'POINT').ne.0) then
      option = 'POINTING'
   else if (index(tmpstring,'FOCUS').ne.0) then
      option = 'FOCUS'
   else if (index(tmpstring,'TIP').ne.0) then
      option = 'SKYDIP'
   else
      call gagout('E-SOLVE, works only for POINTING, FOCUS or TIP.')
      error = .true.
      return
   endif
   !
   call sic_upper(option)
   !
   if (.not.sic_present(0,1)) then
      ifb = 0
      do i = 1, scan%header%nfebe
         tmpstring = scan%data%febe(i)
         call sic_upper(tmpstring)
         if (index(tmpstring,'BBC').ne.0 .or. &
             index(tmpstring,'NBC').ne.0 .or. &
             index(tmpstring,'CONT').ne.0) then
            ifb = i
            exit
         endif
      enddo
      if (ifb.eq.0) then
         ifb = 1
         call gagout('W-SOLVE: using first backend in Fe/Be list.')
      endif
   else
      call sic_i4(line,0,1,ifb,.false.,error)
      if (ifb.gt.scan%header%nfebe.or.ifb.le.0) then
         call gagout('E-PLOT: Invalid backend specification.')
         error = .true.
         return
      endif
      if (sic_present(0,2)) then
         ifb1 = ifb
         call sic_i4(line,0,2,ifb2,.false.,error)
         if (ifb2.gt.scan%header%nfebe.or.ifb2.le.0) then
            call gagout('E-PLOT: Invalid backend specification.')
            error = .true.
            return
         endif
      endif
   endif
   !
   if (sic_present(1,0)) then
      call sic_i4(line,1,1,ipix,.false.,error)
   else
      ipix = febe(ifb)%data%reffeed
   endif
   if (ipix.gt.febe(ifb)%header%febefeed) then
      write(string,'(A14,I3)') 'No such pixel ',ipix
      call gagout('E-SOLVE: '//string)
      error = .true.
      return
   endif
   !
   if (.not.reduce(ifb)%calibration_done(3)) then
      nrecords = maxval(data(ifb)%data%integnum)
      if (febe(ifb)%header%febe(1:1).eq.'E') then
! No. of arguments have changed AS 11.10.2010
!         call subtract_offE(ifb,nrecords,'NONE',dummy,1,error)
         call subtract_offE(ifb,nrecords,'NONE',dummy,1,idummy,1,error)
      else
!         call subtract_off(ifb,nrecords,'NONE',dummy,1,error)
         call subtract_off(ifb,nrecords,'NONE',dummy,1,idummy,1,error)
      endif
   endif
   !
   if (.not.reduce(ifb)%calibration_done(2))   &
     call gagout('I-SOLVE: data are uncalibrated.')
   !
   tmpstring = scan%data%febe(ifb)
   call sic_upper(tmpstring)
   if (index(option,'POIN').ne.0) then
      if (reduce(ifb)%pointing_done)   &
        call gagout('I-SOLVE: Pointing already solved.')
      nbin = 0
      if (sic_present(2,0)) call sic_i4(line,2,1,nbin,.false.,error)
      if (index(tmpstring,'CONT').eq.0.and.   &
          index(tmpstring,'BBC').eq.0.and.   &
          index(tmpstring,'NBC').eq.0.and.   &
          index(tmpstring,'ABBA').eq.0) then
         call gagout('E-SOLVE: Not yet ready for line pointing.')
         error = .true.
         return
      endif
      if (sic_present(3,1)) then
         call sic_i4(line,3,1,ibase,.false.,error)
      else
         ibase = 1
      endif
      if (ibase.lt.0) then
         ibase = 0
         call gagout('W-SOLVE: baseline order has to be >= 0, '//   &
                     'reset to 0.')
      else if (ibase.gt.1) then
         ibase = 1
         call gagout('W-SOLVE: baseline order reset to 1 (maximum).')
      endif
      call solve_pointing_mira(ifb,ipix,nbin,ibase,line)
      if (ifb1.ne.0.and.ifb2.ne.0) then
         call sic_get_logi('doPause',dopause,error)
         if (dopause) call exec_program('pause')
         write(string2,'(A30,I4,I4)')   &
           '@gag_pro:p_alignment.mira yes ', ifb1, ifb2
         call exec_program(string2(1:39))
         if (.not.reduce(ifb2)%calibration_done(3)) then
            nrecords = maxval(data(ifb2)%data%integnum)
            if (febe(ifb2)%header%febe(1:1).eq.'E') then
!               call subtract_offE(ifb2,nrecords,'NONE',dummy,1,error)
               call subtract_offE(ifb2,nrecords,'NONE',dummy,1,idummy,1,error)
            else
!               call subtract_off(ifb2,nrecords,'NONE',dummy,1,error)
               call subtract_off(ifb2,nrecords,'NONE',dummy,1,idummy,1,error)
            endif
         endif
         call solve_pointing_mira(ifb2,ipix,nbin,ibase,line)
         if (dopause) call exec_program('pause')
         write(string2,'(A29,I4,I4)')   &
           '@gag_pro:p_alignment.mira no ', ifb1, ifb2
         call exec_program(string2(1:38))
      endif
   else if (index(option,'FOCUS').ne.0) then
      if (reduce(ifb)%focus_done)   &
        call gagout('I-SOLVE: Focus already solved.')
      if (index(tmpstring,'BBC').eq.0 .and.  &
          index(tmpstring,'NBC').eq.0 .and.  &
          index(tmpstring,'CONT').eq.0) then
         call gagout('E-SOLVE: Please select a continuum backend'   &
                     //' for focus.')
         error = .true.
         return
      endif
      if (raw(1)%subref(ifb)%focustransl.eq.'X') then
         idir = 1
      else if (raw(1)%subref(ifb)%focustransl.eq.'Y') then
         idir = 2
      else if (raw(1)%subref(ifb)%focustransl.eq.'Z') then
         idir = 3
      else
         call gagout('E-SOLVE: unknown focus translation direction.')
         error = .true.
         return
      endif
      call solve_xyzfocus(ifb,ipix,idir)
   else if (index(option,'SKYDIP').ne.0) then
      call solve_tip(ifb,ipix)
   else
      call gagout   &
        ('E-SOLVE: procedure either unknown or not yet done.')
      error = .true.
   endif
   !
   call sic_insert(command)
   !
   return
!
end subroutine solve
!
!
subroutine solve_pointing_mira(ifb,ipix,nbin,ibase,line)
!
! Called by subroutine SOLVE.
! solve_pointing_mira prepares (subscan or coadded Az- and
! El-subscan, after removal of linear baselines) data for
! subsequent call of telcal's subroutine fit_1d, writes
! the results into the corresponding MIRA and SIC structures,
! and calls subroutines protoResultsPointing to write an XML
! file with the results.
!
   use mira
   use fit
   use gildas_def
   use gkernel_types
   use gkernel_interfaces
   use telcal_interfaces
   use pcross_definitions
   use fit_definitions
   use linearregression
   !
   implicit none
   character(len = *) :: line
   !
   integer   :: i,ibase,idir,iend,ier,ifb,ilast,ipix,istart,isub,   &
                isub1,isub2,i1,i2,i3,i4,j,k,nbet,nbin,ndir,ndump,   &
                nlam,npar,npts,nrecords,nsubscans,nx,subscan_id
   type(sic_descriptor_t) :: desc
   integer, dimension(1)  :: imax
   real*4    :: azcorr, elcorr, data1, data2, yscale
   real*8    :: bval, dazm, delv, dx, slope, var, x1, x2, x3, x4
   real*8    :: dxmean
   real*8    :: xmaxval, xminval
   real*8    :: xend, xstart, yend, ystart
   logical   :: exist, error
   !
   integer, dimension(:), allocatable  :: indx
   real*8, dimension(:), allocatable   :: chi, xall, yall, xtmp, ytmp
   logical, dimension(:), allocatable  :: flagmask, mask, tmpmask
   logical, dimension(2)               :: overlapflag
   character(len=3)                    :: dir_string
   character(len=12)                   :: ptype
   character(len=20)                   :: tmpswtchmod
   character(len=32)                   :: tmpfebe, varname
   character(len=100)                  :: string
   !
   integer                             :: n, naver
   real*8                              :: xmax, xmin, ytest
   real*8, dimension(:), allocatable   :: ymax, ymin
   !
   type(simple_1d), dimension(2)       :: dat
   type(simple_1d), dimension(2)       :: profile
   !
   type tmppoint
      integer :: integnum
      integer :: subscan
      real*4  :: data
      real*8  :: latoff
      real*8  :: longoff
      real*8  :: lst
      real*8  :: elevatio
      real*8  :: parangle
   end type tmppoint
   !
   type(tmppoint), dimension(:), allocatable :: tmpdata
   !
   !
   tmpfebe = febe(ifb)%header%febe
   call sic_get_logi('flagBSwSpikes',flagBSwSpikes,error)
   call sic_upper(tmpfebe)
   !
   !
   tmpswtchmod = febe(ifb)%header%swtchmod
   call sic_upper(tmpswtchmod)
   if (index(tmpswtchmod,'WOB').ne.0) then
      ptype = 'DUAL'
   else
      ptype = 'SIMPLE'
   endif
   !
   !
   if (.not.reduce(ifb)%calibration_done(1).and.   &
       .not.reduce(ifb)%calibration_done(3)) then
      bval = blankingraw
   else
      bval = blankingred
   endif
   !
   !
   nrecords  = maxval(data(ifb)%data%integnum)
   nsubscans = scan%header%nobs
   !
   allocate(flagmask(nrecords),stat=ier)
   flagmask   &
     = data(ifb)%data%otfdata(ipix,1,1:nrecords).eq.bval
   !
   if (nbin.eq.0) then
      if (allocated(tmpdata)) deallocate(tmpdata,stat=ier)
      allocate(tmpdata(nrecords),stat=ier)
      if (allocated(chi)) deallocate(chi,stat=ier)
      allocate(chi(nrecords),stat=ier)
      tmpdata(1:nrecords)%integnum = data(ifb)%data%integnum
      tmpdata(1:nrecords)%subscan  = data(ifb)%data%subscan
      tmpdata(1:nrecords)%longoff  = data(ifb)%data%longoff
      tmpdata(1:nrecords)%latoff   = data(ifb)%data%latoff
      tmpdata(1:nrecords)%lst      = data(ifb)%data%lst
      tmpdata(1:nrecords)%elevatio = data(ifb)%data%elevatio
      tmpdata(1:nrecords)%parangle = data(ifb)%data%parangle
      tmpdata(1:nrecords)%data   &
        = data(ifb)%data%otfdata(ipix,1,1:nrecords)
   else
      !
      if (allocated(mask)) deallocate(mask,stat=ier)
      allocate(mask(nrecords),stat=ier)
      nrecords = 0
      do isub = 1, nsubscans
         mask = data(ifb)%data%subscan.eq.isub
         nrecords = nrecords+count(mask)/nbin
      enddo
      if (allocated(tmpdata)) deallocate(tmpdata,stat=ier)
      allocate(tmpdata(nrecords),stat=ier)
      if (allocated(chi)) deallocate(chi,stat=ier)
      allocate(chi(nrecords),stat=ier)
      iend = 0
      k = 0
      do isub = 1, nsubscans
         mask = data(ifb)%data%subscan.eq.isub
         ndump = count(mask)/nbin
         istart = iend+1
         ilast = iend+ndump*nbin
         iend = iend+count(mask)
         do j = istart, ilast, nbin
            k = k+1
            tmpdata(k)%subscan = isub
            tmpdata(k)%integnum = k
            tmpdata(k)%longoff   &
              = sum(data(ifb)%data%longoff(j:j+nbin-1))/nbin
            tmpdata(k)%latoff   &
              = sum(data(ifb)%data%latoff(j:j+nbin-1))/nbin
            tmpdata(k)%lst   &
              = sum(data(ifb)%data%lst(j:j+nbin-1))/nbin
            tmpdata(k)%elevatio   &
              = sum(data(ifb)%data%elevatio(j:j+nbin-1))/nbin
            tmpdata(k)%parangle   &
              = sum(data(ifb)%data%parangle(j:j+nbin-1))/nbin
            if (count(.not.flagmask(j:j+nbin-1)).eq.0) then
               tmpdata(k)%data = bval
            else
               tmpdata(k)%data   &
                 = sum(data(ifb)%data%otfdata(ipix,1,j:j+nbin-1),   &
                 1,.not.flagmask(j:j+nbin-1))   &
                 /count(.not.flagmask(j:j+nbin-1))
            endif
         enddo
      enddo
   !
   endif
   !
   !
   ! The following is if you want to point with the central pixel, but if
   ! the signal is in an off-center pixel.
   !      IF (INDEX(tmpFeBe,'HERA').NE.0) THEN
   !         IF (INDEX(FEBE(IFB)%HEADER%DEWRTMOD,'HORIZ').NE.0) THEN
   !            CHI = FEBE(IFB)%HEADER%DEWANG/RAD2DEG
   !            tmpData%LONGOFF = tmpData(:)%LONGOFF
   !     &                        +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*COS(CHI(:))
   !     &                        -FEBE(IFB)%DATA%FEEDOFFY(IPIX)*SIN(CHI(:))
   !            tmpData%LATOFF = tmpData(:)%LATOFF
   !     &                        +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*SIN(CHI(:))
   !     &                        +FEBE(IFB)%DATA%FEEDOFFY(IPIX)*COS(CHI(:))
   !         ELSE IF (INDEX(FEBE(IFB)%HEADER%DEWRTMOD,'CABIN').NE.0) THEN
   !            CHI = (FEBE(IFB)%HEADER%DEWANG-tmpData(:)%ELEVATIO)/RAD2DEG
   !            tmpData%LONGOFF = tmpData(:)%LONGOFF
   !     &                        +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*COS(CHI(:))
   !     &                        -FEBE(IFB)%DATA%FEEDOFFY(IPIX)*SIN(CHI(:))
   !            tmpData%LATOFF = tmpData(:)%LATOFF
   !     &                       +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*SIN(CHI(:))
   !     &                       +FEBE(IFB)%DATA%FEEDOFFY(IPIX)*COS(CHI(:))
   !         ELSE IF (INDEX(FEBE(IFB)%HEADER%DEWRTMOD,'EQUA').NE.0) THEN
   !            CHI = (FEBE(IFB)%HEADER%DEWANG+tmpData(:)%PARANGLE)/RAD2DEG
   !            tmpData%LONGOFF = tmpData(:)%LONGOFF
   !     &                        -FEBE(IFB)%DATA%FEEDOFFX(IPIX)*COS(CHI(:))
   !     &                        +FEBE(IFB)%DATA%FEEDOFFY(IPIX)*SIN(CHI(:))
   !            tmpData(:)%LATOFF = tmpData(:)%LATOFF
   !     &                       +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*SIN(CHI(:))
   !     &                       +FEBE(IFB)%DATA%FEEDOFFY(IPIX)*COS(CHI(:))
   !         ENDIF
   !      ENDIF
   !
   nrecords  = maxval(tmpdata%integnum)
   nsubscans = maxval(tmpdata%subscan)
   if (allocated(ymin)) deallocate(ymin,stat=ier)
   if (allocated(ymax)) deallocate(ymax,stat=ier)
   allocate(ymin(nsubscans),ymax(nsubscans),stat=ier)
   ymax(:) = blankingraw
   ymin(:) = -ymax(:)
! changed by hw, 2010-05-06
!   if (nsubscans.gt.7) then
!      ndir = 8
!   else if (nsubscans.gt.3) then
!      ndir = 4
!   else
!      ndir = nsubscans
!   endif
! end of change
   if (mod(nsubscans,4).eq.0) then
      ndir = 4
   else
      ndir = nsubscans
   endif
!
! Normalize in order to avoid numerical problems with telCal's fitting routine
!
   yscale = maxval(abs(tmpdata(1:nrecords)%data),1,.not.flagmask)
   where (.not.flagmask)   &
     tmpdata(1:nrecords)%data = tmpdata(1:nrecords)%data/yscale
   !
   !
   i2 = 0
   dx = 0.
   dxmean = 0.
   subscan_loop: do i = 1, nsubscans
      xstart = raw(i)%antenna(ifb)%segmentxstart
      xend = raw(i)%antenna(ifb)%segmentxend
      ystart = raw(i)%antenna(ifb)%segmentystart
      yend = raw(i)%antenna(ifb)%segmentyend
      pcross(i)%sys = 0
      if (xend.gt.xstart) pcross(i)%dir = '+LAM'
      if (xend.lt.xstart) pcross(i)%dir = '-LAM'
      if (yend.gt.ystart) pcross(i)%dir = '+BET'
      if (yend.lt.ystart) pcross(i)%dir = '-BET'
      if (allocated(mask)) deallocate(mask,stat=ier)
      allocate(mask(nrecords),stat=ier)
      mask = tmpdata(1:nrecords)%subscan.eq.i
      call null_simple_1d(pcross(i)%dat)
      ndump = count(mask,1)
      allocate(pcross(i)%dat%x(ndump),stat=ier)
      allocate(pcross(i)%dat%y(ndump),stat=ier)
      allocate(pcross(i)%dat%w(ndump),stat=ier)
      allocate(pcross(i)%dat%d(ndump),stat=ier)
      pcross(i)%dat%n = ndump
      pcross(i)%dat%x = 0.
      pcross(i)%dat%y = 0.
      pcross(i)%dat%w = 1.
      pcross(i)%dat%d = 0.
      call null_simple_1d(pcross(i)%sol)
      npts = pcross(i)%dat%n
      pcross(i)%sol%n = npts
      allocate(pcross(i)%sol%x(npts),pcross(i)%sol%y(npts),   &
               pcross(i)%sol%w(npts),pcross(i)%sol%d(npts),   &
               stat=ier)
      pcross(i)%sol%x = 0.
      pcross(i)%sol%y = 0.
      pcross(i)%sol%w = 1.
      pcross(i)%sol%d = 0.
      i1 = i2+1
      i2 = i2+pcross(i)%dat%n
      allocate(indx(pcross(i)%dat%n),xtmp(pcross(i)%dat%n),   &
               ytmp(pcross(i)%dat%n),tmpmask(pcross(i)%dat%n),   &
               stat=ier)
      ytmp(:) = tmpdata(i1:i2)%data
      tmpmask(:) = flagmask(i1:i2)
      if (index(pcross(i)%dir,'LAM').ne.0) then
         xtmp(:) = tmpdata(i1:i2)%longoff*3600.
         if (index(pcross(i)%dir,'+').ne.0) then
            call indexx(pcross(i)%dat%n,xtmp,indx)
         else
            call indexx(pcross(i)%dat%n,-xtmp,indx)
         endif
      else if (index(pcross(i)%dir,'BET').ne.0) then
         xtmp(:) = tmpdata(i1:i2)%latoff*3600.
         if (index(pcross(i)%dir,'+').ne.0) then
            call indexx(pcross(i)%dat%n,xtmp,indx)
         else
            call indexx(pcross(i)%dat%n,-xtmp,indx)
         endif
      endif
      do j = 1, pcross(i)%dat%n
         pcross(i)%dat%x(j) = xtmp(indx(j))
      enddo
      !
      do j = 1, pcross(i)%dat%n
         if (.not.tmpmask(indx(j))) then
            pcross(i)%dat%y(j) = ytmp(indx(j))
         else
            pcross(i)%dat%y(j) = bval
            pcross(i)%dat%w = 0.0
         endif
      enddo
      deallocate(indx,xtmp,ytmp,tmpmask,stat=ier)
      !
      dx = max(dx,abs(maxval(pcross(i)%dat%x(2:npts)   &
                            -pcross(i)%dat%x(1:npts-1))))
      dxmean = dxmean+abs(sum(pcross(i)%dat%x(2:npts)   &
                             -pcross(i)%dat%x(1:npts-1)))   &
                      /(npts-1)
      !
      call null_function(pcross(i)%fun)
      pcross(i)%fun%method = 'SLATEC'
      if (ptype.eq.'SIMPLE'.or.index(pcross(i)%dir,'BET').ne.0) then
         pcross(i)%fun%name = 'GAUSSIAN+BASE'
         pcross(i)%fun%npar = 5
         npar = pcross(i)%fun%npar
         allocate (pcross(i)%fun%par(npar),stat=ier)
         do j = 1, npar
            call null_parameter(pcross(i)%fun%par(j))
         enddo
         pcross(i)%fun%par(5)%guess = 0.
         pcross(i)%fun%par(1)%guess = 1.-pcross(i)%fun%par(4)%guess
         if (array(ifb)%header(1)%restfreq.lt.1.2d11) then
            pcross(i)%fun%par(3)%guess   &
              = 27.5*0.88d+11/array(ifb)%header(1)%restfreq
         else if (array(ifb)%header(1)%restfreq.lt.1.9d11) then
            pcross(i)%fun%par(3)%guess   &
              = 16.0*1.5d+11/array(ifb)%header(1)%restfreq
         else if (array(ifb)%header(1)%restfreq.lt.4.0d11) then
            pcross(i)%fun%par(3)%guess   &
              = 10.5*2.3d+11/array(ifb)%header(1)%restfreq
         endif
         pcross(i)%fun%par(1)%guess =pcross(i)%fun%par(3)%guess  &
                                     *sqrt(pi/log(2.d0))/2.
         !
         ! MINI, MAXI not yet used by telCal
         !
       ! PCROSS(I)%FUN%PAR(1)%MINI = 0.
       ! PCROSS(I)%FUN%PAR(1)%MAXI = 1.E23
         pcross(i)%fun%flag = 2
         pcross(i)%fun%par(1)%name = 'AREA1'
         pcross(i)%fun%par(2)%name = 'POSITION1'
         pcross(i)%fun%par(3)%name = 'WIDTH1'
         pcross(i)%fun%par(4)%name = 'OFFSET'
         pcross(i)%fun%par(5)%name = 'SLOPE'
         if (ibase.eq.1) then
            pcross(i)%fun%par(1:5)%fixed = .false.
         else if (ibase.eq.0) then
            pcross(i)%fun%par(1:4)%fixed = .false.
            pcross(i)%fun%par(5)%fixed = .true.
         endif
         naver = pcross(i)%fun%par(3)%guess/dx
         xmax = maxval(pcross(i)%dat%x)
         xmin = minval(pcross(i)%dat%x)
         n = 0
         if (index(pcross(i)%dir,'+').ne.0) then
            do j = 1, pcross(i)%dat%n
               if (pcross(i)%dat%x(j)+pcross(i)%fun%par(3)%guess   &
                 .gt.xmax) exit
               n = n+1
            enddo
         else if (index(pcross(i)%dir,'-').ne.0) then
            do j = pcross(i)%dat%n,1,-1
               if (pcross(i)%dat%x(j)+pcross(i)%fun%par(3)%guess   &
                 .gt.xmax) exit
               n = n+1
            enddo
         endif
         if (n.eq.0) then
            naver = pcross(i)%dat%n
            n = 1
         endif
         i3 = 0
         do j = 1, n
            i4 = i3+naver
            i3 = i3+1
            ytest = sum(pcross(i)%dat%y(i3:i4))/(i4-i3+1)
            if (ytest.le.ymin(i)) then
               pcross(i)%fun%par(4)%guess = ytest
               ymin(i) = ytest
            endif
         enddo
         i3 = 0
         do j = 1, n
            i4 = i3+naver
            i3 = i3+1
            ytest = sum(pcross(i)%dat%y(i3:i4))/(i4-i3+1)-ymin(i)
            if (ytest.ge.ymax(i)) then
               pcross(i)%fun%par(2)%guess   &
                 = sum(pcross(i)%dat%x(i3:i4))/(i4-i3+1)
               ymax(i) = ytest
            endif
         enddo
      !
      else if (ptype.eq.'DUAL') then
         pcross(i)%fun%name = '2*GAUSSIAN+BASE'
         pcross(i)%fun%npar = 8
         npar = pcross(i)%fun%npar
         allocate (pcross(i)%fun%par(npar),stat=ier)
         do j = 1, npar
            call null_parameter(pcross(i)%fun%par(j))
         enddo
         pcross(i)%fun%par(7)%guess = 0.5*(minval(pcross(i)%dat%y)   &
                                          +maxval(pcross(i)%dat%y))
         pcross(i)%fun%par(8)%guess = 0.
         pcross(i)%fun%par(1)%guess = 1.-pcross(i)%fun%par(7)%guess
         imax = maxloc(pcross(i)%dat%y)
         pcross(i)%fun%par(2)%guess = pcross(i)%dat%x(imax(1))
         if (array(ifb)%header(1)%restfreq.lt.1.2d11) then
            pcross(i)%fun%par(3)%guess   &
              = 27.5*0.88d+11/array(ifb)%header(1)%restfreq
         else if (array(ifb)%header(1)%restfreq.lt.1.9d11) then
            pcross(i)%fun%par(3)%guess   &
              = 16.0*1.5d+11/array(ifb)%header(1)%restfreq
         else if (array(ifb)%header(1)%restfreq.lt.4.0d11) then
            pcross(i)%fun%par(3)%guess   &
              = 10.5*2.3d+11/array(ifb)%header(1)%restfreq
         endif
         pcross(i)%fun%par(1)%guess =pcross(i)%fun%par(3)%guess   &
                                    *sqrt(pi/log(2.d0))/2.
         pcross(i)%fun%par(4)%guess = -1
         pcross(i)%fun%par(5)%guess =scan%header%wobthrow*3600.
         pcross(i)%fun%par(6)%guess = 1
         pcross(i)%fun%flag = 2
         !
         ! MINI, MAXI not yet used by telCal
         !
         !            PCROSS(I)%FUN%PAR(1)%MINI = 0.
         !            PCROSS(I)%FUN%PAR(1)%MAXI = 1.E23
         pcross(i)%fun%par(1)%name = 'AREA1'
         pcross(i)%fun%par(2)%name = 'POSITION1'
         pcross(i)%fun%par(3)%name = 'WIDTH1'
         pcross(i)%fun%par(4)%name = 'AREA2/AREA1'
         !
         ! MINI, MAXI not yet used by telCal
         !
         !            PCROSS(I)%FUN%PAR(4)%MINI = -10.
         !            PCROSS(I)%FUN%PAR(4)%MAXI = 10.
         pcross(i)%fun%par(5)%name = 'POSITION2-POSITION1'
         pcross(i)%fun%par(6)%name = 'WIDTH2/WIDTH1'
         pcross(i)%fun%par(7)%name = 'OFFSET'
         pcross(i)%fun%par(8)%name = 'SLOPE'
         if (ibase.eq.1) then
            pcross(i)%fun%par(1:8)%fixed = .false.
         else if (ibase.eq.0) then
            pcross(i)%fun%par(1:7)%fixed = .false.
            pcross(i)%fun%par(8)%fixed = .true.
         endif
      endif
   enddo subscan_loop
   !
   dxmean = dxmean/nsubscans
   if (dx/dxmean.gt.3) dx = dxmean
   !
   !if (ndir.ge.2) then
      call sic_descriptor('PCROSS',desc,exist)
      if (.not.exist) call sic_defstructure('PCROSS',.true.,error)
      do i = 1, nsubscans
         write(varname,'(A10,I0)') 'PCROSS%SUB',i
         call define_sic_pointing(pcross(i),trim(varname),error)
         call fit_1d(pcross(i)%dat,pcross(i)%fun,.false.)
         pcross(i)%sol%x = pcross(i)%dat%x(:)
         call get_profile(pcross(i)%fun,pcross(i)%sol)
         npar = pcross(i)%fun%npar
         where (pcross(i)%dat%y.ne.bval)   &
           pcross(i)%dat%y = pcross(i)%dat%y*yscale
         pcross(i)%sol%y = pcross(i)%sol%y*yscale
         pcross(i)%fun%par(1)%value   &
           = pcross(i)%fun%par(1)%value*yscale
         pcross(i)%fun%par(1)%error   &
           = pcross(i)%fun%par(1)%error*yscale
         pcross(i)%fun%par(npar-1)%value   &
           = pcross(i)%fun%par(npar-1)%value*yscale
         pcross(i)%fun%par(npar-1)%error   &
           = pcross(i)%fun%par(npar-1)%error*yscale
         pcross(i)%fun%par(npar)%value   &
           = pcross(i)%fun%par(npar)%value*yscale
         pcross(i)%fun%par(npar)%error   &
           = pcross(i)%fun%par(npar)%error*yscale
         pcross(i)%fun%par(1)%guess   &
           = pcross(i)%fun%par(1)%guess*yscale
         pcross(i)%fun%par(npar-1)%guess   &
           = pcross(i)%fun%par(npar-1)%guess*yscale
         pcross(i)%fun%par(npar)%guess   &
           = pcross(i)%fun%par(npar)%guess*yscale
         ymin(i) = ymin(i)*yscale
         ymax(i) = ymax(i)*yscale
      enddo
      !
      !
      do i = 1, nsubscans, 4
         write(varname,'(A10,I0)') 'PCROSS%SUB',i
         write(string,'(A36,1X,I2,1X,I2)')   &
           '@ gag_pro:p_plot_pointBySubscan.mira', ifb, i
         call exec_program(string(1:43))
         do j = 1, ndir
            k = j+i-1
            if (k.gt.nsubscans) then
               call gagout('W-SOLVE: incomplete pointing')
               return
            endif
            npar = pcross(k)%fun%npar
            if (ptype.ne.'DUAL'.and.                   &
                (pcross(k)%fun%par(npar-1)%value.lt.   &
                 ymin(k)-abs(ymax(k)).or.              &
                 pcross(k)%fun%par(npar-1)%value.gt.   &
                 ymin(k)+2*abs(ymax(k))                &
                )) then
               if (j.le.2) then
                  write(string,'(A20,F4.1,A7)')'g\draw relocate -13 ',   &
                    -1.7-(j-1)*0.5, ' /box 1'
               else
                  write(string,'(A20,F4.1,A7)') 'g\draw relocate 0 ',   &
                    -1.7-(j-3)*0.5, ' /box 1'
               endif
               call exec_program(string)
               call exec_program('g\pen /col 1')
               write(string,'(A41,I0,A47)')   &
                 'label "Ambigeous baseline fit in subscan ',k,   &
                 '" /center 6'
               call exec_program(string)
               call exec_program('g\pen /def')
               write(string,'(A43,I0,A35)')   &
                 'W-SOLVE: Ambigeous baseline fit in subscan ',k,   &
                 ', only 0 order baseline subtracted.'
               call gagout(string)
            endif
            if (mod(k,4).eq.0) then
               call sic_get_logi('doPause',dopause,error)
               if (dopause) then
                  call exec_program('pause')
               else
                  call exec_program('sic wait 1')
               endif
               if (trim(line).eq.'SIC\QUIT') return
            endif
            if (mod(k,4).eq.0.) call exec_program('clear')
         enddo
      enddo
      !
      if (nsubscans.lt.scan%header%nobstotal) then
         call gagout('W-SOLVE: incomplete pointing')
         if (mod(nsubscans,4).ne.0) return
      endif
      !
      ! now remove fitted baseline before proceeding to final fit
      !
      do i = 1, nsubscans
         npar = pcross(i)%fun%npar
         if (ptype.ne.'DUAL'.and.                   &
             (pcross(i)%fun%par(npar-1)%value.lt.   &
              ymin(i)-abs(ymax(i)).or.              &
              pcross(i)%fun%par(npar-1)%value.gt.   &
              ymin(i)+2*abs(ymax(i))                &
             )) then
            pcross(i)%dat%y = pcross(i)%dat%y   &
              -pcross(i)%fun%par(npar-1)%guess
         else
            where (pcross(i)%dat%y.ne.bval)   &
              pcross(i)%dat%y = pcross(i)%dat%y   &
                               -pcross(i)%fun%par(npar-1)%value   &
                               -pcross(i)%fun%par(npar)%value*pcross(i)%dat%x
         endif
      enddo
   !
   !endif
   !
   !
   overlapflag(:) = .true.
   ndir = 2
   az_el_loop: do idir = 1, 2
      if (idir.eq.1) then
         dir_string = 'LAM'
      else
         dir_string = 'BET'
      endif
      x1 = +1.d23
      x2 = -1.d23
      x3 = -1.d23
      x4 = +1.d23
      nx = 0
      do i = 1, nsubscans
         if (index(pcross(i)%dir,dir_string).ne.0) then
            xminval = minval(pcross(i)%dat%x)
            xmaxval = maxval(pcross(i)%dat%x)
            x1 = min(x1,xminval)
            x2 = max(x2,xmaxval)
            x3 = max(x3,xminval)
            x4 = min(x4,xmaxval)
            nx = nx+pcross(i)%dat%n
         endif
      enddo
      !
      if (abs(x1).lt.1.d23.and.abs(x2).lt.1.d23.and.abs(x3).lt.1.d23   &
        .and.abs(x4).lt.1.d23) then
         if ((x4-x3)/(x2-x1).lt.0.5) then
            if (dir_string.eq.'LAM') then
               overlapflag(1) = .false.
            else if (dir_string.eq.'BET') then
               overlapflag(2) = .false.
            endif
         endif
      endif
      !
      if (allocated(mask)) deallocate(mask,stat=ier)
      if (allocated(xall)) deallocate(xall,stat=ier)
      if (allocated(yall)) deallocate(yall,stat=ier)
      !
      allocate(mask(nx),xall(nx),yall(nx),stat=ier)
      i2 = 0
      do i = 1, nsubscans
         if (index(pcross(i)%dir,dir_string).ne.0) then
            i1 = i2+1
            i2 = i2+pcross(i)%dat%n
            xall(i1:i2) = pcross(i)%dat%x
            if (abs(xall(i2)-xall(i1))/(x2-x1).lt.0.5.or.   &
              pcross(i)%fun%flag.ne.0) then
               yall(i1:i2) = bval
            else
               yall(i1:i2) = pcross(i)%dat%y
            endif
         endif
      enddo
      call null_simple_1d(dat(idir))
      dat(idir)%n = nint(abs(x2-x1)/dx)+1
      allocate(dat(idir)%x(dat(idir)%n),   &
               dat(idir)%y(dat(idir)%n),   &
               dat(idir)%w(dat(idir)%n),   &
               stat=ier)
      do i = 1, dat(idir)%n
         dat(idir)%x(i) = x1+(i-1)*dx
         mask = .false.
         where(abs(xall-dat(idir)%x(i)).lt.dx) mask = .true.
         where(yall.eq.bval) mask = .false.
         if (count(mask).ne.0) then
            dat(idir)%y(i) = sum(yall,1,mask)/count(mask)
            dat(idir)%w(i) = 1.d0
         else
            dat(idir)%y(i) = bval
            dat(idir)%w(i) = 0.
         endif
      enddo
      !
      ! normalize to maximum in order to avoid numerical problems in telCal's
      ! fitting routine
      !
      yscale = maxval(abs(dat(idir)%y),1,dat(idir)%y.ne.bval)
      where (dat(idir)%y.ne.bval)   &
             dat(idir)%y = dat(idir)%y/yscale
      !
      call null_function(fun(idir))
      fun(idir)%method = 'SLATEC'
      if (ptype.eq.'SIMPLE'.or.dir_string.eq.'BET') then
         fun(idir)%npar   = 5
      else if (ptype.eq.'DUAL') then
         fun(idir)%npar   = 8
      endif
      allocate (fun(idir)%par(fun(idir)%npar),stat=ier)
      call null_parameter(fun(idir)%par(1))
      fun(idir)%par(1)%name = 'AREA1'
      call null_parameter(fun(idir)%par(2))
      fun(idir)%par(2)%name = 'POSITION1'
      call null_parameter(fun(idir)%par(3))
      fun(idir)%par(3)%name = 'WIDTH1'
      !
      if (array(ifb)%header(1)%restfreq.lt.1.2d+11) then
         fun(idir)%par(3)%guess   &
           = 27.5*.88d+11/array(ifb)%header(1)%restfreq
      else if (array(ifb)%header(1)%restfreq.lt.1.9d+11) then
         fun(idir)%par(3)%guess   &
           = 16.0*1.5d+11/array(ifb)%header(1)%restfreq
      else if (array(ifb)%header(1)%restfreq.lt.4.0d+11) then
         fun(idir)%par(3)%guess   &
           = 10.5*2.3d+11/array(ifb)%header(1)%restfreq
      endif
      fun(idir)%par(1)%guess = fun(idir)%par(3)%guess   &
        *sqrt(pi/log(2.d0))/2.
      !
      ! MINI, MAXI not yet used by telCal
      !
      !         FUN(IDIR)%PAR(1)%MINI = 0.
      !         FUN(IDIR)%PAR(1)%MAXI = 1.E23
      if (ptype.eq.'SIMPLE'.or.dir_string.eq.'BET') then
         fun(idir)%name   = 'GAUSSIAN+BASE'
         call null_parameter(fun(idir)%par(4))
         fun(idir)%par(4)%name = 'OFFSET'
         call null_parameter(fun(idir)%par(5))
         fun(idir)%par(5)%name = 'SLOPE'
         fun(idir)%par(4)%guess = 0.
         fun(idir)%par(5)%guess = 0.
         if (ibase.eq.1) then
            fun(idir)%par(1:5)%fixed = .false.
         else if (ibase.eq.0) then
            fun(idir)%par(1:4)%fixed = .false.
            fun(idir)%par(5)%fixed = .true.
         endif
         naver = fun(idir)%par(3)%guess/dx
         xmax = maxval(dat(idir)%x)
         n = 0
         do j = 1, dat(idir)%n
            if (dat(idir)%x(j)+fun(idir)%par(3)%guess.gt.xmax) exit
            n = n+1
         enddo
         if (n.eq.0) then
            naver = dat(idir)%n
            n = 1
         endif
         ymax(idir) = blankingraw
         ymin(idir) = -blankingraw
         i1 = 0
         do j = 1, n
            i2 = i1+naver
            i1 = i1+1
            ytest = sum(dat(idir)%y(i1:i2))/(i2-i1+1)
            if (ytest.le.ymin(idir)) then
               fun(idir)%par(4)%guess = ytest
               ymin(idir) = ytest
            endif
         enddo
         i1 = 0
         do j = 1, n
            i2 = i1+naver
            i1 = i1+1
            ytest = sum(dat(idir)%y(i1:i2))/(i2-i1+1)-ymin(idir)
            if (ytest.ge.ymax(idir)) then
               !
               ! MINI, MAXI not yet used by telCal
               !
               !                  FUN(IDIR)%PAR(2)%MINI = MIN(DAT(IDIR)%X(I1),
               !     &                                        DAT(IDIR)%X(I2))
               !                  FUN(IDIR)%PAR(2)%MAXI = MAX(DAT(IDIR)%X(I1),
               !     &                                        DAT(IDIR)%X(I2))
               fun(idir)%par(2)%guess   &
                 = sum(dat(idir)%x(i1:i2))/(i2-i1+1)
               ymax(idir) = ytest
            endif
         enddo
      !
      else if (ptype.eq.'DUAL') then
         fun(idir)%name   = '2*GAUSSIAN+BASE'
         call null_parameter(fun(idir)%par(4))
         fun(idir)%par(4)%name = 'AREA2/AREA1'
         !
         ! MINI, MAXI not yet used by telCal
         !
         !            FUN(IDIR)%PAR(4)%MINI = -10.
         !            FUN(IDIR)%PAR(4)%MAXI = +10.
         call null_parameter(fun(idir)%par(5))
         fun(idir)%par(5)%name = 'POSITION2-POSITION1'
         call null_parameter(fun(idir)%par(6))
         fun(idir)%par(6)%name = 'WIDTH2/WIDTH1'
         call null_parameter(fun(idir)%par(7))
         fun(idir)%par(7)%name = 'OFFSET'
         call null_parameter(fun(idir)%par(8))
         fun(idir)%par(8)%name = 'SLOPE'
         fun(idir)%par(4)%guess = -1
         fun(idir)%par(5)%guess = scan%header%wobthrow*3600.
         fun(idir)%par(6)%guess = 1
         fun(idir)%par(7)%guess = 0.
         fun(idir)%par(8)%guess = 0.
         fun(idir)%par(2)%guess = -scan%header%wobthrow*1800.
         if (ibase.eq.1) then
            fun(idir)%par(1:8)%fixed = .false.
         else
            fun(idir)%par(1:7)%fixed = .false.
            fun(idir)%par(8)%fixed = .true.
         endif
      endif
      !
      call fit_1d(dat(idir),fun(idir),.false.)
      !         IF (ABS(FUN(IDIR)%PAR(5)%VALUE).GT.0.01) THEN
      !            FUN(IDIR)%PAR(5)%GUESS = 0.
      !            FUN(IDIR)%PAR(5)%FIXED = .true.
      !            CALL FIT_1D(DAT(IDIR),FUN(IDIR),.FALSE.)
      !            CALL GAGOUT(' ')
      !            IF (IDIR.EQ.1) THEN
      !               CALL GAGOUT('W-SOLVE: Baseline order for coadded azimuth'
      !     &                     //' data reset to 0.')
      !            ELSE IF (IDIR.EQ.2) THEN
      !               CALL GAGOUT('W-SOLVE: Baseline order for coadded'
      !     &                     //' elevation data reset to 0.')
      !            ENDIF
      !            CALL GAGOUT(' ')
      !         ENDIF
      !
      ! remove normalization
      !
      where (dat(idir)%y.ne.bval)   &
        dat(idir)%y = dat(idir)%y*yscale
      npar = fun(idir)%npar
      fun(idir)%par(1)%value = fun(idir)%par(1)%value*yscale
      fun(idir)%par(1)%error = fun(idir)%par(1)%error*yscale
      fun(idir)%par(1)%guess = fun(idir)%par(1)%guess*yscale
      fun(idir)%par(npar-1)%value =fun(idir)%par(npar-1)%value*yscale
      fun(idir)%par(npar-1)%error =fun(idir)%par(npar-1)%error*yscale
      fun(idir)%par(npar-1)%guess =fun(idir)%par(npar-1)%guess*yscale
      fun(idir)%par(npar)%value = fun(idir)%par(npar)%value*yscale
      fun(idir)%par(npar)%error = fun(idir)%par(npar)%error*yscale
      fun(idir)%par(npar)%guess = fun(idir)%par(npar)%guess*yscale
      ymin(idir) = ymin(idir)*yscale
      ymax(idir) = ymax(idir)*yscale
   enddo az_el_loop
   !
   do idir = 1, ndir
      call null_simple_1d(profile(idir))
      allocate(profile(idir)%x(dat(idir)%n),   &
               profile(idir)%y(dat(idir)%n),   &
               profile(idir)%w(dat(idir)%n),   &
               profile(idir)%d(dat(idir)%n),   &
               stat=ier)
      profile(idir)%n = dat(idir)%n
      profile(idir)%x = dat(idir)%x
      call get_profile(fun(idir),profile(idir))
      var = 0.
      do j = 1, dat(idir)%n
         var = var+(dat(idir)%y(j)-profile(idir)%y(j))**2
      enddo
      var = var/(dat(idir)%n-1)
      fun(idir)%rms = sqrt(var)
   !
   enddo
   if (ptype.eq.'DUAL') fun(1)%par(2)%value    &
                        =fun(1)%par(2)%value+scan%header%wobthrow*1.8d+3
   !
   ! remove baseline for plotting
   !
   do idir = 1, ndir
      if (fun(idir)%flag.ne.0) cycle
      npar = fun(idir)%npar
      if (ptype.ne.'DUAL'.and.           &
          (fun(idir)%par(npar-1)%value.lt.   &
           ymin(idir)-abs(ymax(idir)).or.   &
           fun(idir)%par(npar-1)%value.gt.   &
           ymin(idir)+2*abs(ymax(idir)))) then
         profile(idir)%y = profile(idir)%y   &
                          -fun(idir)%par(npar-1)%guess

         where (dat(idir)%y.ne.bval)   &
           dat(idir)%y = dat(idir)%y-fun(idir)%par(npar-1)%guess
         if (idir.eq.1) then
            call gagout('W-SOLVE: ambigeous baseline fit in azimuth,'   &
                        //' only 0 order baseline subtracted.')
         else if (idir.eq.2) then
            call gagout('W-SOLVE: ambigeous baseline fit in elevation,'   &
                        //' only 0 order baseline subtracted.')
         endif
      else
         profile(idir)%y = profile(idir)%y   &
                          -fun(idir)%par(npar-1)%value   &
                          -fun(idir)%par(npar)%value*profile(idir)%x
         where (dat(idir)%y.ne.bval)   &
           dat(idir)%y = dat(idir)%y-fun(idir)%par(npar-1)%value   &
                        -fun(idir)%par(npar)%value*profile(idir)%x
      endif
   enddo

   call pointing_to_sic(dat,fun,profile,error)
   write(string,'(A30,1X,I2)') '@ gag_pro:p_plot_pointing.mira',   &
                               ifb
   call exec_program(string(1:34))
   call sic_get_logi('writeXML',writexml,error)
   if (writexml) then
      call protoresultspointing(ifb,ipix,error)
      if (error) call gagout('E-SOLVE: Error in XML file writing.')
   endif
   !
   call gagout(' ')
   call gagout(' Corrections to be entered in PaKo (for angleUnit '//   &
               'arcsec):')
   azcorr = nint((mon(ifb)%header%iaobs_caobs_ieobs(2)*3.6d+3   &
                  +fun(1)%par(2)%value)*10)/10.
   elcorr = nint((mon(ifb)%header%iaobs_caobs_ieobs(3)*3.6d+3   &
                  +fun(2)%par(2)%value)*10)/10.
   write (string,'(A14,2(F6.1,1X))') ' SET POINTING ',azcorr, elcorr
   call gagout(' ')
   call gagout(string)
   call gagout(' ')
   do idir = 1, ndir
      npar = fun(idir)%npar
      if (ptype.ne.'DUAL'.and.                                         &
          (fun(idir)%par(npar-1)%value.lt.ymin(idir)-abs(ymax(idir))   &
           .or.fun(idir)%par(npar-1)%value.gt.                         &
           ymin(idir)+2*abs(ymax(idir))                                &
          )) then
         call exec_program('g\pen /col 1')
         if (idir.eq.1) then
            call exec_program('g\draw relocate -13 -2 /box 1')
            string ='label "Ambigeous baseline fit in azimuth, only'   &
                  //' 0 order baseline subtracted." /center 6'
            call exec_program(string)
         else if (idir.eq.2) then
            call exec_program('g\draw relocate -13 -3 /box 1')
            string ='label "Ambigeous baseline fit in elevation,'   &
                  //' only 0 order baseline subtracted." /center 6'
            call exec_program(string)
         endif
         call exec_program('g\pen /default')
      endif
   enddo
   if (.not.overlapflag(1)) then
      call gagout(' W-SOLVE: overlap of azimuth subscans < 60%')
      if (ibase.eq.1) then
         call gagout('          In case of doubts consider repeat '//   &
                     'or try SOLVE /BASE 0.')
      else
         call gagout('          In case of doubts consider repeat.')
      endif
      call gagout(' ')
      call exec_program('g\pen /col 1')
      call exec_program('g\draw relocate -13 -4 /box 1')
      string ='label "Overlap of azimuth subscans < 60%, " /center 6'
      call exec_program(string)
      string = 'label "in case of doubts consider repeat." /center 6'
      call exec_program(string)
      call exec_program('g\pen /def')
   endif
   if (.not.overlapflag(2)) then
      call gagout(' W-SOLVE: overlap of elevation subscans < 60%')
      if (ibase.eq.1) then
         call gagout('          In case of doubts consider repeat '//   &
                     'or try SOLVE /BASE 0.')
      else
         call gagout('          In case of doubts consider repeat.')
      endif
      call gagout(' ')
      call exec_program('g\pen /col 1')
      call exec_program('g\draw relocate -13 -5 /box 1')
      string   &
        = 'label "Overlap of elevation subscans < 60%, " /center 6'
      call exec_program(string)
      string = 'label "in case of doubts consider repeat." /center 6'
      call exec_program(string)
      call exec_program('g\pen /def')
   endif
   !
   reduce(ifb)%pointing_done = .true.
   !
   ! Cleaning
   call null_simple_1d(profile(1))
   call null_simple_1d(profile(2))
   call null_simple_1d(dat(1))
   call null_simple_1d(dat(2))
   !
   return
end subroutine solve_pointing_mira
!
!
!
subroutine pointing_to_sic(dat,fun,profile,error)
!
! Creates a SIC copy of Mira structure PNT (pointing results for
! co-added azimuth and elevation data). Results from individual
! pointing subscans are in telcal/sic structure PCROSS.
!
   use gildas_def
   use gkernel_types
   use gkernel_interfaces
   use telcal_interfaces
   use fit_definitions
   !
   implicit none
   !
   type(simple_1d), dimension(2) :: dat
   type(simple_1d), dimension(2) :: profile
   type(fit_fun), dimension(2)   :: fun
   !
   type(sic_descriptor_t) :: desc
   logical error, exist
   !
   call sic_descriptor('PNT',desc,exist)
   if (exist) call sic_delvariable('PNT',.false.,error)
   !
   call sic_defstructure('PNT',.true.,error)
   call sic_defstructure('PNT%AZM',.true.,error)
   call sic_defstructure('PNT%AZM%DATA',.true.,error)
   call sic_defstructure('PNT%AZM%FIT',.true.,error)
   call sic_defstructure('PNT%AZM%PROFILE',.true.,error)
   call sic_defstructure('PNT%ELV',.true.,error)
   call sic_defstructure('PNT%ELV%DATA',.true.,error)
   call sic_defstructure('PNT%ELV%GUESS',.true.,error)
   call sic_defstructure('PNT%ELV%FIT',.true.,error)
   call sic_defstructure('PNT%ELV%PROFILE',.true.,error)
   !
   call sic_defstructure('PNT%AZM%ERROR',.true.,error)
   call sic_defstructure('PNT%ELV%ERROR',.true.,error)
   !
   call sic_def_inte('PNT%AZM%DATA%N',dat(1)%n,0,0,.true.,error)
   call sic_def_dble('PNT%AZM%DATA%X',dat(1)%x,1,dat(1)%n,   &
                    .true.,error)
   call sic_def_dble('PNT%AZM%DATA%Y',dat(1)%y,1,dat(1)%n,   &
                     .true.,error)
   call sic_def_inte('PNT%ELV%DATA%N',dat(2)%n,0,0,.true.,error)
   call sic_def_dble('PNT%ELV%DATA%X',dat(2)%x,1,dat(2)%n,   &
                     .true.,error)
   call sic_def_dble('PNT%ELV%DATA%Y',dat(2)%y,1,dat(2)%n,   &
                     .true.,error)
   !
   call sic_def_inte('PNT%AZM%FIT%FLAG',fun(1)%flag,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%AREA',fun(1)%par(1)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%POSITION',fun(1)%par(2)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%WIDTH',fun(1)%par(3)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%OFFSET',fun(1)%par(4)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%SLOPE',fun(1)%par(5)%value,   &
                     0,0,.true.,error)
   call sic_def_inte('PNT%ELV%FIT%FLAG',fun(2)%flag,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%AREA',fun(2)%par(1)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%POSITION',fun(2)%par(2)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%WIDTH',fun(2)%par(3)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%OFFSET',fun(2)%par(4)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%SLOPE',fun(2)%par(5)%value,   &
                     0,0,.true.,error)
   !
   call sic_def_dble('PNT%AZM%GUESS%AREA',fun(1)%par(1)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%GUESS%POSITION',fun(1)%par(2)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%GUESS%WIDTH',fun(1)%par(3)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%GUESS%OFFSET',fun(1)%par(4)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%GUESS%SLOPE',fun(1)%par(5)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%AREA',fun(2)%par(1)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%POSITION',fun(2)%par(2)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%WIDTH',fun(2)%par(3)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%OFFSET',fun(2)%par(4)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%SLOPE',fun(2)%par(5)%guess,   &
                     0,0,.true.,error)
   !
   call sic_def_dble('PNT%AZM%PROFILE%X',profile(1)%x,1,profile(1)%n,   &
                     .true.,error)
   call sic_def_dble('PNT%AZM%PROFILE%Y',profile(1)%y,1,profile(1)%n,   &
                     .true.,error)
   call sic_def_dble('PNT%ELV%PROFILE%X',profile(2)%x,1,profile(2)%n,   &
                     .true.,error)
   call sic_def_dble('PNT%ELV%PROFILE%Y',profile(2)%y,1,profile(2)%n,   &
                     .true.,error)
   !
   call sic_def_dble('PNT%AZM%ERROR%AREA',fun(1)%par(1)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%ERROR%POSITION',fun(1)%par(2)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%ERROR%WIDTH',fun(1)%par(3)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%ERROR%OFFSET',fun(1)%par(4)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%ERROR%SLOPE',fun(1)%par(5)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%AREA',fun(2)%par(1)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%POSITION',fun(2)%par(2)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%WIDTH',fun(2)%par(3)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%OFFSET',fun(2)%par(4)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%SLOPE',fun(2)%par(5)%error,   &
                     0,0,.true.,error)
   !
   return
end subroutine pointing_to_sic

subroutine solve_xyzfocus(ifb,ipix,idir)
!
! Called by subroutine SOLVE.
! solve_xyzfocus prepares the data of a focus scan
! subsequent call of telcal's subroutine fit_1d, writes
! the results into the corresponding MIRA and SIC structures,
! and calls subroutines protoResultsFocus to write an XML
! file with the results.
!
   use mira
   use gildas_def
   use gkernel_types
   use gkernel_interfaces
   use telcal_interfaces
   use fit_definitions
   use focus_definitions
   !
   implicit none
   !
   character(len=40)                  :: string
   integer                            :: i,idir,ier,ifb,ipix,j,n,   &
                                         npar,nrecords,nsol,nsubscans
   type(sic_descriptor_t)             :: desc
   real*4                             :: dz,focusnew,min,max
   real*8                             :: val,var
   real*8, dimension(:), allocatable  :: offset
   logical                            :: error,exist
   logical, dimension(:), allocatable :: mask,offsetflag
   !
   type (focus)                       :: tmp
   !
   nrecords = maxval(data(ifb)%data%integnum)
   nsubscans = maxval(data(ifb)%data%subscan )
   !
   npar = 3   ! Parabola, Lorentzian or Gaussian fitting
   nsol = 100
   !
   if (allocated(mask)) deallocate(mask,stat=ier)
   allocate(mask(nrecords),stat=ier)
   if (allocated(offsetflag)) deallocate(offsetflag,stat=ier)
   allocate(offsetflag(nrecords),stat=ier)
   !
   n = 0
   offsetflag = .false.
   mask = .true.
   do i = 1, nsubscans
      mask = .not.offsetflag.and.mask
      if (count(mask).eq.0) exit
      n = n+1
      val =minval(data(ifb)%data%dfocus_x_y_z(1:nrecords,idir),   &
        1,mask)
      offsetflag = data(ifb)%data%dfocus_x_y_z(1:nrecords,idir)   &
        .eq.val
   enddo
   !
   if (allocated(offset)) deallocate(offset,stat=ier)
   allocate(offset(n),stat=ier)
   !
   n = 0
   offsetflag = .false.
   mask = .true.
   do i = 1, nsubscans
      mask = .not.offsetflag.and.mask
      if (count(mask).eq.0) exit
      n = n+1
      offset(n) =minval(data(ifb)%data%dfocus_x_y_z(1:nrecords,idir),   &
        1,mask)
      offsetflag = data(ifb)%data%dfocus_x_y_z(1:nrecords,idir)   &
        .eq.offset(n)
   enddo
   !
   !
   zfocus%sys = 0
   !
   call null_simple_1d(zfocus%dat(1))
   zfocus%dat(1)%n = n
   allocate(zfocus%dat(1)%x(zfocus%dat(1)%n),   &
            zfocus%dat(1)%y(zfocus%dat(1)%n),   &
            zfocus%dat(1)%w(zfocus%dat(1)%n),   &
            stat=ier)
   zfocus%dat(1)%x = 0.d0
   zfocus%dat(1)%x = 0.d0
   zfocus%dat(1)%w = 1.d0
   !
   call null_simple_1d(zfocus%sol(1))
   zfocus%sol(1)%n = nsol
   allocate(zfocus%sol(1)%x(nsol),zfocus%sol(1)%y(nsol),   &
            zfocus%sol(1)%w(nsol),zfocus%sol(1)%d(nsol),   &
            stat=ier)
   zfocus%sol(1)%x = 0.
   zfocus%sol(1)%y = 0.
   zfocus%sol(1)%w = 1.
   zfocus%sol(1)%d = 0.
   !
   call null_function(zfocus%fun(1))
   zfocus%fun(1)%name = 'POLYNOMIAL'
   zfocus%fun(1)%method = 'SLATEC'
   zfocus%fun(1)%npar = npar
   zfocus%fun(1)%flag = 0
   allocate(zfocus%fun(1)%par(npar),stat=ier)
   do i = 1, npar
      call null_parameter(zfocus%fun(1)%par(i))
      write(string,'(a12,i2)') 'COEFFICIENT ', i-1
      zfocus%fun(1)%par(i)%name = string
   enddo
   !
   mask = .false.
   do i = 1, zfocus%dat(1)%n
      mask = data(ifb)%data%dfocus_x_y_z(1:nrecords,idir)   &
        .eq.offset(i)
      zfocus%dat(1)%x(i) =   &
        maxval(data(ifb)%data%dfocus_x_y_z(1:nrecords,idir),mask)
      zfocus%dat(1)%y(i) =   &
        sum(data(ifb)%data%otfdata(ipix,1,1:nrecords),mask)   &
        /count(mask)
   enddo
   !
   if (idir.eq.1) then
      zfocus%dir(1) = '+FCX'
   else if (idir.eq.2) then
      zfocus%dir(1) = '+FCY'
   else if (idir.eq.3) then
      zfocus%dir(1) = '+FCZ'
   endif
   !
   call sic_descriptor('ZFOCUS',desc,exist)
   if (exist) call sic_delvariable('ZFOCUS',.false.,error)
   call define_sic_focus
   !
   min = minval(zfocus%dat(1)%x)
   max = maxval(zfocus%dat(1)%x)
   dz = max-min
   min = min-0.1*dz
   max = max+0.1*dz
   do i = 1, zfocus%sol(1)%n
      zfocus%sol(1)%x(i) = min+(max-min)*(i-1)/(zfocus%sol(1)%n-1)
   enddo
   !
   call exec_program('clear')
   !
   tmp%dat(1)%n = zfocus%dat(1)%n
   allocate(tmp%dat(1)%x(tmp%dat(1)%n),tmp%dat(1)%y(tmp%dat(1)%n),   &
            tmp%dat(1)%w(tmp%dat(1)%n),stat=ier)
   tmp%dat(1)%x = zfocus%dat(1)%x
   tmp%dat(1)%w = zfocus%dat(1)%w
   tmp%dat(1)%y = zfocus%dat(1)%y
   tmp%dat(1)%y = zfocus%dat(1)%y
   !
   call fit_1d(tmp%dat(1),zfocus%fun(1),.false.)
   call get_profile(zfocus%fun(1),zfocus%sol(1))
   !
   var = 0.d0
   do i = 1, 3
      val= zfocus%fun(1)%par(1)%value   &
          +zfocus%dat(1)%x(i)*(zfocus%fun(1)%par(2)%value   &
                              +zfocus%dat(1)%x(i)   &
                              *zfocus%fun(1)%par(3)%value)
      zfocus%fun(1)%rms = var+(val-zfocus%dat(1)%y(i))**2
   enddo
   zfocus%fun(1)%rms = sqrt(zfocus%fun(1)%rms)/2.d0
   call sic_get_logi('writeXML',writexml,error)
   if (writexml) then
      call protoresultsfocus(ifb,ipix,zfocus%fun,error)
      if (error) call gagout('E-SOLVE: Error in XML file writing.')
   endif
   !
   write(string,'(A28,I2,I3)') '@gag_pro:p_plot_focus.mira ',ifb,   &
     ipix
   call exec_program(string(1:34))
   !
   if (error) call gagout('E-SOLVE: Error in XML file writing.')
   !
   if (idir.eq.3) then
      call gagout(' ')
      call gagout(' Corrections to be entered in PaKo [mm]: ')
      focusnew = nint((-zfocus%fun(1)%par(2)%value   &
                       /(2.*zfocus%fun(1)%par(3)%value))*100)/100.
      write (string,'(A11,F6.2)') ' SET FOCUS ',focusnew
      call gagout(' ')
      call gagout(string)
      call gagout(' ')
   endif
   !
   reduce(ifb)%focus_done = .true.
   return
end subroutine solve_xyzfocus
!
!
!
subroutine solve_tip(ifb,ipix)
!
! Called from run_mira (MIRA command SOLVE if current scan is a 
! skytip). This subroutine is merely an interface to SIC routine
! where the skydip is solved (in mira/pro/p_plot_tip.mira).
!
!
   integer           :: ifb, ipix
   character(len=40) :: string
   !
   write(string,'(A25,I0,I3)') '@gag_pro:p_plot_tip.mira ',ifb, ipix
   call exec_program(string)
   !
   return
end subroutine solve_tip
!
subroutine linregress(basedata,basepar,bval)
   !
   use linearregression
   !
   implicit none
   !
   type(lg)                         :: basepar
   type(base), dimension(basepar%n) :: basedata
   real*8                           :: bval
   !
   real*8                           :: sumx, sumxx, sumxy, sumy,sumyy
   integer                          :: n
   type(base), dimension(basepar%n) :: squareddata
   logical, dimension(basepar%n)    :: mask
   !
   n = basepar%n
   squareddata(1:n)%x = basedata(1:n)%x*basedata(1:n)%x
   squareddata(1:n)%y = basedata(1:n)%y*basedata(1:n)%y
   mask = basedata(1:n)%y.ne.bval
   sumx = sum(basedata(1:n)%x,mask)
   sumy = sum(basedata(1:n)%y,mask)
   sumxx = sum(squareddata(1:n)%x,mask)
   sumyy = sum(squareddata(1:n)%y,mask)
   sumxy = sum(basedata(1:n)%x*basedata(1:n)%y,mask)
   !
   basepar%det = count(mask)*sumxx-sumx*sumx
   basepar%a = (sumxx*sumy-sumx*sumxy)/basepar%det
   basepar%b = (count(mask)*sumxy-sumx*sumy)/basepar%det
!
end subroutine linregress

subroutine sic_analyse(command,line,nline,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_analyse
  use sic_expressions
  use sic_structures
  !---------------------------------------------------------------------
  ! @ public
  ! SIC command line analyser. First entry point:
  ! SIC_ANALYSE     Look for all languages including "library"
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: command  ! The command found, if any
  character(len=*), intent(inout) :: line     ! The line to be analysed (updated)
  integer(kind=4),  intent(inout) :: nline    ! Length of LINE (updated)
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=commandline_length) :: order
  !
  ! Reset argument counters (see sic_desc_inca)
  next_arg = 0
  next_st = 0
  !
  library_mode = .true.
  call sic_parse_line(line,nline,.false.,sic_quiet,ccomm,order,error)
  command = ccomm%command
  call sic_upper(command)
end subroutine sic_analyse
!
subroutine sic_find(command,line,nline,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_find
  use sic_expressions
  use sic_structures
  !---------------------------------------------------------------------
  ! @ public
  ! SIC command line analyser. Second entry point:
  ! SIC_FIND        Look only for interactive languages.
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: command  ! The command found, if any
  character(len=*), intent(inout) :: line     ! The line to be analysed (updated)
  integer(kind=4),  intent(inout) :: nline    ! Length of LINE (updated)
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=commandline_length) :: order
  !
  ! Reset argument counters (see sic_desc_inca)
  next_arg = 0
  next_st = 0
  !
  call sic_parse_line(line,nline,.true.,sic_quiet,ccomm,order,error)
  command = ccomm%command
  !
  ! The number of options of this command would be NOPT(CCOMM%ICOM)
end subroutine sic_find
!
subroutine sic_parse_line(line,nline,library,quiet,command,ordre,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_parse_line
  use sic_types
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !  SIC command line analyser
  !  IBEG    pointer in LINE
  !  M       pointer in ORDRE
  !  JOPT    Option number   (0=command)
  !  JARG    Argument number (0=option or command)
  !  COMM%POPT(Jopt)               Pointer of option in argument list
  !  COMM%IBEG(POPT(Jopt)+Jarg)    Start pointer of argument
  !  COMM%IEND(POPT(Jopt)+Jarg)    End pointer of argument
  !
  !  The character string describing an argument is thus
  !   LINE(COMM%IBEG(COMM%POPT(Jopt)+Jarg):COMM%IEND(COMM%POPT(Jopt)+Jarg))
  ! provided COMM%JOPT < 10 and Ipoint(Jopt)+Jarg < 100 . More arguments
  ! may exist, but a special procedure is required to find them, as no
  ! pointers are defined for these. The language is included in the
  ! command line on return.
  !  Argument 'COMMAND' is inout so that it is not fully reset (for
  ! efficiency purpose) since it has been done on first call. From your
  ! side you may consider SAVing the input variable in order to enable
  ! this optimisation.
  !---------------------------------------------------------------------
  character(len=*),    intent(inout) :: line     ! The line to be analysed (updated)
  integer(kind=4),     intent(inout) :: nline    ! Length of line (updated)
  logical,             intent(in)    :: library  ! Library mode
  logical,             intent(in)    :: quiet    !
  type(sic_command_t), intent(inout) :: command  ! The parsed command line
  character(len=*)                   :: ordre    ! Work buffer
  logical,             intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PARSE'
  logical :: inchain,inarg
  integer(kind=4) :: jopt,jarg,icha,m,ibeg,iquiet
  !
  if (quiet) then
    iquiet = 1
  else
    iquiet = 0
  endif
  !
  ! Setup pointers
  command%aline = locstr(line)
  command%icom = 0
  command%command = ' '
  if (command%initialized) then
    ! If already initialized, reset only the elements which were used
    ! before, for efficiency purpose
    command%narg(0:command%mopt) = -1
    command%popt(0:command%mopt) = 0
    command%ibeg(1:command%nword) = 0
    command%iend(1:command%nword) = 0
  else
    ! Not initialized: reset everything
    command%narg(:) = -1
    command%popt(:) = 0
    command%ibeg(:) = 0  ! ibeg(iarg).eq.0 => argument not present (see sic_present)
    command%iend(:) = 0
    command%initialized = .true.
  endif
  command%mopt = 0
  command%nword = 0
  !
  m = 0
  inchain = .false.
  inarg = .false.
  !
  ! Parse the line
  do icha=1,nline
    !
    ! Check the character strings
    if (line(icha:icha).eq.'"') then
      if (.not.inarg)  call start_argument()
      inchain = .not.inchain
      cycle  ! icha
    endif
    if (inchain) cycle  ! icha
    !
    if (line(icha:icha).eq.' ') then
      ! Found a blank
      if (icha.eq.1) then
        if (.not.quiet)  call sic_message(seve%e,rname,'No command on line')
        error = .true.
        nline = 1
        return
      endif
      if (inarg) then
        ! An argument was being traversed. The blank marks its end.
        call stop_argument(error)
        if (error)  return
      endif
    else
      ! Found something not a blank
      if (.not.inarg)  call start_argument()
    endif
    !
  enddo  ! icha
  !
  if (inchain) then
    if (.not.quiet)  call sic_message(seve%e,rname,'Unbalanced quote count')
    error = .true.
    return
  endif
  !
  ! Terminate last argument
  if (inarg) then
    call stop_argument(error)
    if (error)  return
  endif
  !
  ! Restore the expanded line
  line = ordre(1:m)
  nline = m-1 ! Remove trailing blank
  !
contains
  !
  subroutine start_argument()
    !-------------------------------------------------------------------
    ! Set up some of the variables when a new argument begins
    !-------------------------------------------------------------------
    ibeg = icha
    if (command%icom.eq.0) then
      ! Command not yet found: this must be the command
      jarg = 0
    elseif (line(ibeg:ibeg).ne.'/' .or. hasopt(command%icom).eq.-1) then
      ! New argument is a standard argument: increment current counter
      jarg = jarg+1
    else
      ! Next argument is an option
      jarg = 0
    endif
    inarg = .true.
  end subroutine start_argument
  !
  subroutine stop_argument(error)
    !-------------------------------------------------------------------
    ! Set up the remaining variables when a new argument ends
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    ! Local
    integer(kind=4), parameter :: isig=1  ! Skip leading "/" for options (old value ISIG=2)
    character(len=1), parameter :: backslash=char(92)
    character(len=command_length) :: name
    character(len=language_length+command_length) :: tempo
    integer(kind=4) :: iopt,nl,ocode
    !
    if (command%nword.eq.mword) then
      call sic_message(seve%e,rname,'Too many words in line')
      error = .true.
      return
    endif
    command%nword = command%nword+1
    !
    if (jarg.eq.0) then
      ! Argument is the command or an option
      tempo = line(ibeg:icha-1)
      call sic_upper(tempo)
      if (command%icom.eq.0) then
        ! Search for the command
        call sic_parse_command(tempo,icha-ibeg,iquiet,library,command%ilang,  &
          command%icom,ocode,error)
        if (error)  return
        jopt = 0  ! Option #0 is command
        command%lang = languages(command%ilang)%name
        command%command = vocab(command%icom)(2:)  ! Command name
        name = command%command
        command%mopt = nopt(command%icom)
        ! Prefix with the language name:
        m = languages(command%ilang)%lname  ! Stored for optimisation
        ordre = languages(command%ilang)%name(1:m)//backslash
        m = m+1
      else
        ! Search for an option
        call sic_parse_option(tempo,icha-ibeg,iquiet,command%icom,iopt,error)
        if (error)  return
        jopt = iopt-command%icom  ! Relative number from command (1 to N)
        name = vocab(iopt)(isig:)  ! Option name
      endif
      if (command%popt(jopt).ne.0) then
        call sic_message(seve%e,rname,'Option '//trim(name)//' is specified twice')
        error = .true.
        return
      endif
      command%popt(jopt) = command%nword  ! jopt==0: command, else option
      nl = len_trim(name)
      ordre(m+1:m+nl+1) = name(1:nl)
    else
      ! Argument is a standard argument
      ordre(m+1:m+1-ibeg+icha) = line(ibeg:icha)
      nl = icha-ibeg
    endif
    !
    ! Set the pointers for previous argument
    command%ibeg(command%nword) = m+1
    command%iend(command%nword) = m+nl
    command%narg(jopt) = jarg
    m = m+nl+1
    inarg = .false.
  end subroutine stop_argument
  !
end subroutine sic_parse_line
!
subroutine sic_parse_command(line,nline,iquiet,library,ilang,icom,ocode,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_parse_command
  use sic_dictionaries
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !  Parse the input string of the form:
  !    LANG\COMMAND
  ! and decode the language and command.
  ! No global variable modified here
  !
  ! - IQUIET behaviour:
  !    IQUIET = 0: Verbose
  !    IQUIET = 1: Quiet
  !    IQUIET = 2: Verbose on ambiguity
  !
  ! - OCODE is used to return a thiner information on error than the
  !   on/off ERROR flag:
  !    OCODE = 0: no error
  !    OCODE = 1: Unknown command
  !    OCODE = 2: No options allowed for command
  !    OCODE = 3: Name is fully ambiguous
  !    OCODE = 4: Name is partially ambiguous
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: line     ! String to parse
  integer(kind=4),     intent(in)    :: nline    ! Length of string
  integer(kind=4),     intent(in)    :: iquiet   ! Verbosity
  logical,             intent(in)    :: library  ! Library mode?
  integer(kind=4),     intent(out)   :: ilang    ! Language found
  integer(kind=4),     intent(out)   :: icom     ! Command found
  integer(kind=4),     intent(out)   :: ocode    ! Error code
  logical,             intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PARSE'
  integer(kind=4) :: il,nmatch,nfull,iprio,jlang,i,j,nc,nlan,mcom,n
  integer(kind=4) :: width,nperline,tt_width
  character(len=1), parameter :: backslash=char(92)
  character(len=language_length) :: lang
  character(len=message_length) :: chain,mess
  integer(kind=4) :: sever(0:2)
  ! Data
  data sever /seve%e,seve%w,seve%w/
  !
  ! NOPT(0) is the actual vocabulary length
  if (hasopt(0).eq.0) then
    if (iquiet.eq.0)  &
      call sic_message(seve%e,rname,'No language loaded, no command found')
    error = .true.
    ocode = 2
    return
  endif
  !
  ocode = 0
  !
  ! Max width used to print language + command (on ambiguity):
  ! Might truncate command if needed.
  width = language_length+command_length-6 ! 12+12-6 = 18
  ! Reserve 1 blank between each, keep floor value:
  tt_width = sic_ttyncol()
  nperline = tt_width/(width+1)    ! 76/(18+1) = 4
  !
  chain = ' '
  nc = 1
  nmatch = 0
  nfull = 0
  !
  ! Language specified, examine all the vocabulary of which the language
  ! field is an abbreviation
  il = index(line(1:nline),backslash)
  !
  do iprio=1,nprio
    do jlang = 1,klang(iprio)
      i = olang(jlang,iprio)
      ! the above 4 lines
      ! OR the next 1 line
      ! Avoid languages not specified
      if (il.ne.0) then
        if (line(1:il-1).ne.languages(i)%name(1:il-1)) cycle ! JLANG
      endif
      !
      ! "LIBRARY" flag set : avoid "library only" or sleeping
      ! languages unless the full language name is specified
      !
      if (library) then
        if (languages(i)%asleep .or. languages(i)%libmod) then
          if (il.ne.0) then
            if (line(1:il-1).ne.languages(i)%name) cycle ! JLANG
          else
            cycle              ! JLANG
          endif
        endif
      endif
      !
      ! Setup the language to be examined
      j = mbuilt(i-1)
      mcom = mbuilt(i)
      lang = languages(i)%name
      nlan = languages(i)%lname  ! Stored for optimisation
      if (nline-il.gt.command_length-1) then   ! -ISIG?
        if (iquiet.eq.0) then
          n = min(il+command_length-1,nline)
          write(mess,107) line(1:n),'...'
          call sic_message(seve%e,rname,mess)
        endif
        ocode = 1
        goto 99
      endif
      !
      ! Now loop over the commands
400   j = j+1
      !
      if (line(il+1:nline).eq.vocab(j)(2:)) then
        ! Full match:
        if (nfull.ne.0) then
          ocode = 3
          if (nfull.eq.1) then
            call sic_message(seve%e,rname,'Fully ambiguous name. Use '//  &
            'language to distinguish.')
          endif
          if (nmatch.eq.1) then
            ! Previous match, even partial (look in previously saved ILANG and ICOM)
            chain(1:width) = languages(ilang)%name(1:languages(ilang)%lname)//  &
              backslash//vocab(icom)(2:)
            nc = width+2       ! Pointer position (keep a blank)
          endif
          if (nc+width-1.gt.tt_width) then ! Need flush?
            if (nmatch.le.nperline) then
              call sic_message(sever(iquiet),rname,  &
                'Ambiguous command could be :')
            endif
            call sicmsg(chain(1:nc-2))
            nc = 1
            chain = ' '
          endif
          ! Append current full match
          ! NC = 1st char position; NC+WIDTH-1 = last char position; total width = WIDTH
          chain(nc:nc+width-1) = lang(1:nlan)//backslash//vocab(j)(2:)
          nc = nc+width+1
        endif
        nfull = nfull+1
        nmatch = nmatch+1
        icom = j
        ilang = i
        !
      elseif (line(il+1:nline).eq.vocab(j)(2:nline-il+1)) then
        ! Partial match:
        if (nmatch.eq.0) then
          nmatch = 1
          icom = j
          ilang = i
        else
          ocode = 4
          if (iquiet.ne.1) then
            if (nmatch.eq.1) then
              ! Previous match (look in previously saved ILANG and ICOM)
              chain(1:width) =  &
                languages(ilang)%name(1:languages(ilang)%lname)//  &
                backslash//vocab(icom)(2:)
              nc = width+2
            endif
            if (nc+width-1.gt.tt_width) then   ! Need flush?
              if (nmatch.le.nperline) then
                ! Buffer is full, need to flush. Assume there will be 0
                ! or 2+ full ambiguity besides this partial ambiguity.
                call sic_message(sever(iquiet),rname,  &
                  'Ambiguous command could be :')
              endif
              call sicmsg(chain(1:nc-2))
              nc = 1
              chain = ' '
            endif
            chain(nc:nc+width-1) = lang(1:nlan)//backslash//vocab(j)(2:)
            nc = nc+width+1
          endif
          nmatch = nmatch+1
        endif
      endif
      !
      ! Skip over options
      j = j+nopt(j)
      if (j.lt.mcom) goto 400
      ! or the next 2 lines
    enddo  ! jlang
    if (nmatch.ne.0)  exit
  enddo  ! iprio
  !
  ! End of analysis
  if (nc.gt.1 .and. nfull.ne.1) then ! Is there any command pending?
    if (nmatch.le.nperline) then
      call sic_message(sever(iquiet),rname,'Ambiguous command could be :')
    endif
    call sicmsg(chain(1:nc-2))
    nc = 1
    chain = ' '
  endif
  if (nmatch.eq.0) then
    if (iquiet.eq.0) then
      write(mess,107) line(1:min(il+command_length-1,nline))
      call sic_message(seve%e,rname,mess)
    endif
    ocode = 1
    goto 99
  endif
  if (nfull.eq.1) nmatch = 1 ! If just one complete match, this is OK...
  if (nmatch.ne.1) goto 99
  !
  return
  !
99 error = .true.
  return
  !
107 format ('Unknown command ',10(a))
end subroutine sic_parse_command
!
subroutine sic_parse_option(line,nline,iquiet,jcom,iopt,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_parse_option
  use sic_dictionaries
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !  Analyse an option of the /OPTION.
  ! No global variable modified here.
  !
  ! - IQUIET behaviour:
  !    IQUIET = 0: Verbose
  !    IQUIET = 1: Quiet
  !    IQUIET = 2: Verbose on ambiguity
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! String to parse
  integer(kind=4),  intent(in)    :: nline    ! Length of string
  integer(kind=4),  intent(in)    :: iquiet   ! Verbosity
  integer(kind=4),  intent(in)    :: jcom     ! Parent command
  integer(kind=4),  intent(out)   :: iopt     ! Option found
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PARSE'
  integer(kind=4) :: j,nmatch
  integer(kind=4), parameter :: isig=1  ! Skip leading "/" for options (old value ISIG=2)
  character(len=message_length) :: mess
  integer(kind=4) :: sever(0:2)
  integer(kind=4) :: ikeys(30)  ! At most 30 ambiguous options
  ! Data
  data sever /seve%e,seve%w,seve%w/
  !
  ! Check if there are any options to this command
  if (hasopt(jcom).eq.0) then
    ! No option declared, no option allowed
    if (iquiet.eq.0) then
      write(mess,'(A,A)') 'No options allowed for command ',vocab(jcom)(2:)
      call sic_message(seve%e,rname,mess)
    endif
    error = .true.
    return
  endif
  !
  iopt = 0
  nmatch = 0
  if (nline.gt.command_length+1-isig) then
    if (iquiet.eq.0) then
      write(mess,209) line(1:command_length+1-isig),vocab(jcom)(isig:)
      call sic_message(seve%e,rname,mess)
    endif
    error = .true.
    return
  endif
  !
  ! Now loop over the options
  do j=jcom+1,jcom+nopt(jcom)
    if (line(1:nline).eq.vocab(j)(1:nline)) then
      if (nmatch.eq.0) then
        nmatch = 1
        iopt = j
      else
        if (iquiet.ne.1) then
          ! Keep list of ambiguous matching options
          if (nmatch.eq.1)  ikeys(nmatch) = iopt  ! First match
          ikeys(nmatch+1) = j                     ! New match
        endif
        nmatch = nmatch+1
      endif
    endif
  enddo
  !
  ! End of analysis
  if (nmatch.eq.0) then
    if (iquiet.eq.0) then
      write(mess,109) line(1:min(command_length+1-isig,nline)),vocab(jcom)(isig:)
      call sic_message(seve%e,rname,mess)
    endif
    error = .true.
  elseif (nmatch.gt.1)  then
    if (iquiet.ne.1) then
      ! Print list of ambiguous matching options
      call sic_ambigs_list(rname,sever(iquiet),  &
        'Ambiguous option for command '//trim(vocab(jcom)(2:))//' could be :',  &
        vocab,ikeys(1:nmatch))
    endif
    error = .true.
  endif
  !
109 format ('Unknown option ',a,' for command ',a)
209 format ('Unknown option ',a,'... for command ',a)
end subroutine sic_parse_option
!
subroutine sic_lang(current_language)
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  !  Returns the language of the current command
  !---------------------------------------------------------------------
  character(len=*) :: current_language  !
  current_language = ccomm%lang
end subroutine sic_lang
!
subroutine sic_ilang(ilang,language)
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  !  Returns the name of the i-th language
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: ilang
  character(len=*), intent(out) :: language
  language = languages(ilang)%name
end subroutine sic_ilang
!
subroutine sic_comm(current_command)
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  !  Return the current command number (number in language, options
  ! excluded).
  !---------------------------------------------------------------------
  integer(kind=4) :: current_command
  ! Local
  integer(kind=4) :: jcomm
  !
  ! The internal buffers do not store directly this information. Start
  ! from the beginning of the current language, and run through commands
  ! to find the correct one.
  !
  current_command = 1
  jcomm = mbuilt(ccomm%ilang-1)+1  ! Command position in the mbuilt vocabulary
  do
    if (jcomm.eq.ccomm%icom)  exit
    jcomm = jcomm+nopt(jcomm)+1  ! Skip over options
    current_command = current_command+1
  enddo
  !
end subroutine sic_comm

* DECK icamax.f
      integer function icamax(n,cx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      complex cx(*)
      real smax
      integer i,incx,ix,n
      complex zdum
      real cabs1
      cabs1(zdum) = abs(real(zdum)) + abs(aimag(zdum))
c
      icamax = 0
      if( n.lt.1 .or. incx.le.0 ) return
      icamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = cabs1(cx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(cabs1(cx(ix)).le.smax) go to 5
         icamax = i
         smax = cabs1(cx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = cabs1(cx(1))
      do 30 i = 2,n
         if(cabs1(cx(i)).le.smax) go to 30
         icamax = i
         smax = cabs1(cx(i))
   30 continue
      return
      end
* DECK idamax.f
      integer function idamax(n,dx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dmax
      integer i,incx,ix,n
c
      idamax = 0
      if( n.lt.1 .or. incx.le.0 ) return
      idamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      dmax = dabs(dx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(dabs(dx(ix)).le.dmax) go to 5
         idamax = i
         dmax = dabs(dx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 dmax = dabs(dx(1))
      do 30 i = 2,n
         if(dabs(dx(i)).le.dmax) go to 30
         idamax = i
         dmax = dabs(dx(i))
   30 continue
      return
      end
* DECK isamax.f
      integer function isamax(n,sx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),smax
      integer i,incx,ix,n
c
      isamax = 0
      if( n.lt.1 .or. incx.le.0 ) return
      isamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = abs(sx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(abs(sx(ix)).le.smax) go to 5
         isamax = i
         smax = abs(sx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = abs(sx(1))
      do 30 i = 2,n
         if(abs(sx(i)).le.smax) go to 30
         isamax = i
         smax = abs(sx(i))
   30 continue
      return
      end
* DECK izamax.f
      integer function izamax(n,zx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, 1/15/85.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double complex zx(*)
      double precision smax
      integer i,incx,ix,n
      double precision dcabs1
c
      izamax = 0
      if( n.lt.1 .or. incx.le.0 )return
      izamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = dcabs1(zx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(dcabs1(zx(ix)).le.smax) go to 5
         izamax = i
         smax = dcabs1(zx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = dcabs1(zx(1))
      do 30 i = 2,n
         if(dcabs1(zx(i)).le.smax) go to 30
         izamax = i
         smax = dcabs1(zx(i))
   30 continue
      return
      end

subroutine syncData(ifb,nfb,subscanRange,error)
!
! Called by subroutines getfits and getfitsNew.
! Interpolates antenna and subreflector data at backend timestamp
! (linear between preceeding and following antenna and subreflector dump).
! Results are written into Mira structures DATA(ifb) (where ifb is the frontend-
! backend number).
!
! syncData checks the consistency of the timing (e.g., that each backend time
! stamp between imbfits data header entries dateObs and dateEnd is framed by
! antenna and subreflector data points at either side).
!
!
  use mira
  use gildas_def

  implicit none

  integer :: ifb , nfb
  integer, dimension(2) :: subscanRange
  logical :: error

  integer :: i, ier, ilo, isub, iup, i1, i2, i3, i4, j, k, l, locate,       &
     &       nbd, nchan, newchan, nfebe, nphases, npix 
  integer :: ndumpAntenna, ndumpAntennaNew, ndumpAntennaFast,               &
     &       ndumpAntennaFastNew, ndumpBackend, ndumpBackendNew,            &
     &       ndumpCryo, ndumpFrontend, ndumpSubref, ndumpSubrefNew
  real*4  :: meanCounts
  real*8  :: dTime1, dTime2, gainMax1, gainMax2, slope, trackingCutoff
 
  real*8, dimension(nsubscan)       :: subScanEnd, subScanStart

  integer(kind=address_length),dimension(9) :: desc
  character(len=20)                    :: tmpScanType, tmpSwitchMode
  character(len=32)                    :: tmpFrontend
  logical                              :: doShift, exist, scanStart, trackFlag
  logical, dimension(:,:), allocatable :: mask,tmpMask
  logical, dimension(:), allocatable   :: maskFSW,tmpMaskFSW
  logical, dimension(:), allocatable   :: subScanFastMask, subScanMask,    &
      &                                   subScanSubrefMask


  ndumpBackend = size(dt(ifb)%data%mjd)
  ndumpAntenna = size(mnt(ifb)%data%lst,1)
  ndumpAntennaFast = size(mnt(ifb)%data%encoder_az_el,1)
  ndumpSubref = size(mnt(ifb)%data%focus_x_y_z,1)
  ndumpFrontend = size(mnt(ifb)%data%tamb_p_humid,1)
!
!
!
  nfebe = scan%header%nfebe
  nbd = febe(ifb)%header%febeband
  nchan = ar(ifb)%header(1)%channels 
  newchan = dt(ifb)%header%channels
  npix = febe(ifb)%header%febefeed
  nphases = febe(ifb)%header%nphases
!
! 
!
  trackingCutoff = raw(1)%antenna(ifb)%trackingError
  do isub = 1, nsubscan
     if (isub.gt.1) trackingCutoff                                         &
 &   = min(trackingCutoff,raw(isub)%antenna(ifb)%trackingError)
     subScanStart(isub) = raw(isub)%antenna(ifb)%subScanStart
     if (index(tmpScanType,'FOCUS').ne.0)                                  &
 &      subScanStart(isub) = max(subScanStart(isub),                       &
 &                               raw(isub)%subref(ifb)%subScanStart)
     subScanStart(isub) = max(subScanStart(isub),                          &
 &                            raw(isub)%backend(ifb)%subScanStart)
     subScanEnd(isub) = raw(isub)%antenna(ifb)%subScanEnd 
     if (index(tmpScanType,'FOCUS').ne.0)                                  &
 &      subScanEnd(isub) = min(subScanEnd(isub),raw(isub)%subref(ifb)%subScanEnd)
     subScanStart(isub) = raw(isub)%antenna(ifb)%subScanStart
     subScanEnd(isub) = raw(isub)%antenna(ifb)%subScanEnd 
  enddo 
!
  do i = 1, ndumpAntenna-1
     if (mnt(ifb)%data%mjd(i).eq.mnt(ifb)%data%mjd(i+1))                   &
 &       mnt(ifb)%data%subScan(i) = mnt(ifb)%data%subScan(i+1)
  enddo
!
  do i = 1, ndumpAntennaFast-1
     if (mnt(ifb)%data%encoder_az_el(i,3)                                  &
 &       .eq.mnt(ifb)%data%encoder_az_el(i+1,3)) &
 &       mnt(ifb)%data%subScanFast(i) = mnt(ifb)%data%subScanFast(i+1)
  enddo 
!
  do i = 1, ndumpSubref-1
     if (mnt(ifb)%data%focus_x_y_z(i,4).eq.mnt(ifb)%data%focus_x_y_z(i+1,4)) &
 &       mnt(ifb)%data%subScanSubref(i) = mnt(ifb)%data%subScanSubref(i+1)
  enddo
!
!
! now remove the second data point of a pair of identical data points, and 
! count dumps again (new number of dumps = New appended to variable name)
!
  ilo = 0
  do i = 1, ndumpAntenna
     isub = mnt(ifb)%data%subScan(i)
     i1 = isub-subscanRange(1)+1
     if (mnt(ifb)%data%mjd(i).lt.subScanStart(i1).or.                &
  &      mnt(ifb)%data%mjd(i).gt.subScanEnd(i1)) then
        cycle
     else if (i.eq.1) then
        ilo = 1
     else if (mnt(ifb)%data%mjd(i).ne.mnt(ifb)%data%mjd(i-1)) then
        ilo = ilo+1 
     endif
  enddo
  ndumpAntennaNew = ilo

  ilo = 0
  do i = 1, ndumpAntennaFast
     isub = mnt(ifb)%data%subScanFast(i)
     i1 = isub-subscanRange(1)+1
     if (mnt(ifb)%data%encoder_az_el(i,3).lt.subScanStart(i1).or.    &
  &      mnt(ifb)%data%encoder_az_el(i,3).gt.subScanEnd(i1)) then
        cycle
     else if (i.eq.1) then
        ilo = 1
     else if (mnt(ifb)%data%encoder_az_el(i,3)                         &
  &           .ne.mnt(ifb)%data%encoder_az_el(i-1,3)) then
        ilo = ilo+1
     endif
   enddo
   ndumpAntennaFastNew = ilo

  ilo = 0
  do i = 1, ndumpSubref
     isub = mnt(ifb)%data%subScanSubref(i)
     i1 = isub-subscanRange(1)+1
     if (mnt(ifb)%data%focus_x_y_z(i,4).lt.subScanStart(i1).or.      &
  &      mnt(ifb)%data%focus_x_y_z(i,4).gt.subScanEnd(i1)) then
        cycle
     else if (i.eq.1) then
        ilo = 1
     else if (mnt(ifb)%data%focus_x_y_z(i,4)                           &
&            .ne.mnt(ifb)%data%focus_x_y_z(i-1,4)) then
        ilo = ilo+1
     endif
  enddo
  if (ilo.ne.0) then
     ndumpSubrefNew = ilo
  else if (index(tmpScanType,'FOCUS').eq.0) then
     call gagout('W-SYNC: Subreflector data not synchronized.')
     ndumpSubrefNew = 1
  else
     call gagout('E-SYNC: Subreflector data not synchronized.')
     error = .true.
     return
  endif


  if (ifb.eq.1) allocate(monBuf(nfebe))
  monBuf(ifb)%header = mnt(ifb)%header
!
  allocate(monBuf(ifb)%data%subScan(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%subScanFast(ndumpAntennaFastNew),      &
     &     monBuf(ifb)%data%subScanSubref(ndumpSubrefNew),         &
     &     monBuf(ifb)%data%mjd(ndumpAntennaNew),                  &
     &     monBuf(ifb)%data%lst(ndumpAntennaNew),                  &
     &     monBuf(ifb)%data%encoder_az_el(ndumpAntennaFastNew,3),  &
     &     monBuf(ifb)%data%tracking_az_el(ndumpAntennaFastNew,2), &
     &     monBuf(ifb)%data%longoff(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%latoff(ndumpAntennaNew),               &
     &     monBuf(ifb)%data%baslong(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%baslat(ndumpAntennaNew),               &
     &     monBuf(ifb)%data%parangle(ndumpAntennaNew),             &
     &     monBuf(ifb)%data%antenna_az_el(2),                      &
     &     monBuf(ifb)%data%tamb_p_humid(ndumpFrontend,3),         &
     &     monBuf(ifb)%data%wind_dir_vavg_vmax(ndumpFrontend,3),   &
     &     monBuf(ifb)%data%thotcold(ndumpFrontend,2),             &
     &     monBuf(ifb)%data%refractio(ndumpFrontend),              &
     &     monBuf(ifb)%data%focus_x_y_z(ndumpSubrefNew,4),         &
     &     monBuf(ifb)%data%dfocus_x_y_z(ndumpSubrefNew,3),        &
     &     monBuf(ifb)%data%phi_x_y_z(ndumpSubrefNew,3),           &
     &     monBuf(ifb)%data%dphi_x_y_z(ndumpSubrefNew,3),          &
     &     stat = ier)
  allocate(subScanSubrefMask(ndumpSubrefNew),                 &
     &     subScanMask(ndumpAntenna),                         &
     &     subScanFastMask(ndumpAntennaFastNew),stat = ier)
  monBuf(ifb)%data%antenna_az_el = mnt(ifb)%data%antenna_az_el
  monBuf(ifb)%data%tamb_p_humid = mnt(ifb)%data%tamb_p_humid
  monBuf(ifb)%data%wind_dir_vavg_vmax = mnt(ifb)%data%wind_dir_vavg_vmax
  monBuf(ifb)%data%thotcold  = mnt(ifb)%data%thotcold
  ilo = 0
  do i = 1, ndumpAntenna
     isub = mnt(ifb)%data%subScan(i)
     i1 = isub-subscanRange(1)+1
     if (mnt(ifb)%data%mjd(i).lt.subScanStart(i1).or.                &
  &      mnt(ifb)%data%mjd(i).gt.subScanEnd(i1)) then
        cycle
     else if (i.eq.1) then
        ilo = 1
     else if (mnt(ifb)%data%mjd(i).ne.mnt(ifb)%data%mjd(i-1)) then
        ilo = ilo+1 
     endif
     monBuf(ifb)%data%subScan(ilo) = mnt(ifb)%data%subScan(i)
     monBuf(ifb)%data%mjd(ilo) = mnt(ifb)%data%mjd(i)
     monBuf(ifb)%data%lst(ilo) = mnt(ifb)%data%lst(i)
     monBuf(ifb)%data%longoff(ilo) = mnt(ifb)%data%longoff(i)
     monBuf(ifb)%data%latoff(ilo) =  mnt(ifb)%data%latoff(i)
     monBuf(ifb)%data%baslong(ilo) = mnt(ifb)%data%baslong(i)
     monBuf(ifb)%data%baslat(ilo) = mnt(ifb)%data%baslat(i)
     monBuf(ifb)%data%parangle(ilo) = mnt(ifb)%data%parangle(i)
  enddo
   
  ilo = 0
  do i = 1, ndumpAntennaFast
     isub = mnt(ifb)%data%subScanFast(i)
     i1 = isub-subscanRange(1)+1
     if (mnt(ifb)%data%encoder_az_el(i,3).lt.subScanStart(i1).or.     & 
  &      mnt(ifb)%data%encoder_az_el(i,3).gt.subScanEnd(i1)) then
        cycle
     else if (i.eq.1) then
        ilo = 1
     else if (mnt(ifb)%data%encoder_az_el(i,3)                          &
  &           .ne.mnt(ifb)%data%encoder_az_el(i-1,3)) then
        ilo = ilo+1
     endif
     monBuf(ifb)%data%subScanFast(ilo) = mnt(ifb)%data%subScanFast(i)
     monBuf(ifb)%data%encoder_az_el(ilo,1:3)                            &
   & = mnt(ifb)%data%encoder_az_el(i,1:3)
     monBuf(ifb)%data%tracking_az_el(ilo,1:2)                           &
   & = mnt(ifb)%data%tracking_az_el(i,1:2)
  enddo

  ilo = 0
  do i = 1, ndumpSubref
     isub = mnt(ifb)%data%subScanSubref(i)
     i1 = isub-subscanRange(1)+1
     if (mnt(ifb)%data%focus_x_y_z(i,4).lt.subScanStart(i1).or.         &
  &      mnt(ifb)%data%focus_x_y_z(i,4).gt.subScanEnd(i1)) then
        cycle
     else if (i.eq.1) then
        ilo = 1
     else if (mnt(ifb)%data%focus_x_y_z(i,4)                              &
  &           .ne.mnt(ifb)%data%focus_x_y_z(i-1,4)) then
        ilo = ilo+1
     endif
     monBuf(ifb)%data%subScanSubref(ilo) = mnt(ifb)%data%subScanSubref(i)
     monBuf(ifb)%data%focus_x_y_z(ilo,1:4) = mnt(ifb)%data%focus_x_y_z(i,1:4)
     monBuf(ifb)%data%dfocus_x_y_z(ilo,1:3) = mnt(ifb)%data%dfocus_x_y_z(i,1:3)
     monBuf(ifb)%data%phi_x_y_z(ilo,1:3) = mnt(ifb)%data%phi_x_y_z(i,1:3)
     monBuf(ifb)%data%dphi_x_y_z(ilo,1:3) = mnt(ifb)%data%dphi_x_y_z(i,1:3)
  enddo
  ndumpAntenna = ndumpAntennaNew
  ndumpAntennaFast = ndumpAntennaFastNew
  ndumpSubref = ndumpSubrefNew
  ilo = 0
  k = 0
  scanStart = .true.
  do i = 1 , ndumpBackend
     isub = dt(ifb)%data%subScan(i)
     i1 = isub-subscanRange(1)+1
!     if (dt(ifb)%data%mjd(i).lt.subScanStart(isub).or.                &
!  &      dt(ifb)%data%mjd(i).gt.subScanEnd(isub)) then
!
! changed by HW as follows: (2007-06-22)
     if (dt(ifb)%data%mjd(i)-dt(ifb)%data%integtim(i)*sec2day.lt.    &
  &      subScanStart(i1).or.dt(ifb)%data%mjd(i).gt.subScanEnd(i1)) then
        k = k+nphases
        cycle
     else if (scanStart) then
        ilo = 1
        k = k+nphases
        scanStart = .false.
     else 
        doShift = .false.
        do j = 1, nphases 
           k = k+1
           if (ar(ifb)%data(1)%mjd(k).eq.ar(ifb)%data(1)%mjd(k-1)) &
  &          doShift = .true. 
        enddo
        if (.not.doShift) ilo = ilo+1
     endif
  enddo
  ndumpBackendNew = ilo

  if (ifb.eq.1) allocate(dataBuf(nfebe),stat=ier)

  dataBuf(ifb)%header = dt(ifb)%header
  allocate(dataBuf(ifb)%data%subscan(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mjd(ndumpBackendNew),                    &
  &        dataBuf(ifb)%data%integnum(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%nints(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%lst(ndumpBackendNew),                    &
  &        dataBuf(ifb)%data%midtime(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%integtim(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%longoff(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%latoff(ndumpBackendNew),                 &
  &        dataBuf(ifb)%data%azimuth(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%elevatio(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%cbaslong(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%cbaslat(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%baslong(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%baslat(ndumpBackendNew),                 &
  &        dataBuf(ifb)%data%parangle(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%pc_11(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_12(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_21(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_22(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%mcrval1(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mcrval2(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mlonpole(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%mlatpole(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%dfocus_x_y_z(ndumpBackendNew,3),         &
  &        dataBuf(ifb)%data%focus_x_y_z(ndumpBackendNew,3),          &
  &        dataBuf(ifb)%data%dphi_x_y_z(ndumpBackendNew,3),           &
  &        dataBuf(ifb)%data%phi_x_y_z(ndumpBackendNew,3),            &
  &        dataBuf(ifb)%data%otfdata(npix,newchan,ndumpBackendNew),   &    
  &        dataBuf(ifb)%data%rdata(npix,newchan),                     &
  &        dataBuf(ifb)%data%cr4K1(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%cr4K2(ndumpBackendNew),                  &
  &        stat = ier)
  if (ifb.eq.1) allocate(arrayBuf(nfebe),stat=ier)
  allocate(arrayBuf(ifb)%data(nbd),arrayBuf(ifb)%header(nbd),stat=ier)
  arrayBuf(ifb)%header(1:nbd) = ar(ifb)%header(1:nbd)
  do i = 1, nbd
     allocate(arrayBuf(ifb)%data(i)%data(npix,nchan,ndumpBackendNew,nphases), &
  &           arrayBuf(ifb)%data(i)%iswitch(ndumpBackendNew,nphases),         &
  &           arrayBuf(ifb)%data(i)%mjd(ndumpBackendNew*nphases),             &
  &           arrayBuf(ifb)%data(i)%integtim(ndumpBackendNew*nphases),        &
  &           stat=ier)
  enddo
  ilo = 0
  k = 0 
  scanStart = .true.
  do i = 1, ndumpBackend
     isub = dt(ifb)%data%subScan(i)
     i1 = isub-subscanRange(1)+1
!     if (dt(ifb)%data%mjd(i).lt.subScanStart(isub).or.              &
!  &      dt(ifb)%data%mjd(i).gt.subScanEnd(isub)) then
!
! changed by HW as follows: (2007-06-22)
     if (dt(ifb)%data%mjd(i)-dt(ifb)%data%integtim(i)*sec2day.lt.    &
  &      subScanStart(i1).or.dt(ifb)%data%mjd(i).gt.subScanEnd(i1)) then
        k = k+nphases
        cycle
     else if (scanStart) then
        k = k+nphases
        ilo = 1
        scanStart = .false.
     else 
        doShift = .false.
        do j = 1, nphases
           k = k+1
           if (ar(ifb)%data(1)%mjd(k).eq.ar(ifb)%data(1)%mjd(k-1)) &
  &           doShift = .true.
        enddo 
        if (.not.doShift) ilo = ilo+1
     endif
     dataBuf(ifb)%data%subscan(ilo) = dt(ifb)%data%subscan(i)
     dataBuf(ifb)%data%mjd(ilo) = dt(ifb)%data%mjd(i)
     dataBuf(ifb)%data%integnum(ilo) = ilo
     dataBuf(ifb)%data%nints(ilo) = dt(ifb)%data%nints(i)
     dataBuf(ifb)%data%lst(ilo) = dt(ifb)%data%lst(i)
     dataBuf(ifb)%data%midtime(ilo) = dt(ifb)%data%midtime(i)
     dataBuf(ifb)%data%integtim(ilo) = dt(ifb)%data%integtim(i)
     dataBuf(ifb)%data%longoff(ilo) = dt(ifb)%data%longoff(i)
     dataBuf(ifb)%data%latoff(ilo) = dt(ifb)%data%latoff(i)
     dataBuf(ifb)%data%azimuth(ilo) = dt(ifb)%data%azimuth(i)
     dataBuf(ifb)%data%elevatio(ilo) = dt(ifb)%data%elevatio(i)
     dataBuf(ifb)%data%cbaslong(ilo) = dt(ifb)%data%cbaslong(i)
     dataBuf(ifb)%data%cbaslat(ilo) = dt(ifb)%data%cbaslat(i)
     dataBuf(ifb)%data%baslong(ilo) = dt(ifb)%data%baslong(i)
     dataBuf(ifb)%data%baslat(ilo) = dt(ifb)%data%baslat(i)
     dataBuf(ifb)%data%parangle(ilo) = dt(ifb)%data%parangle(i)
     dataBuf(ifb)%data%pc_11(ilo) = dt(ifb)%data%pc_11(i)
     dataBuf(ifb)%data%pc_12(ilo) = dt(ifb)%data%pc_12(i)
     dataBuf(ifb)%data%pc_21(ilo) = dt(ifb)%data%pc_21(i)
     dataBuf(ifb)%data%pc_22(ilo) = dt(ifb)%data%pc_22(i)
     dataBuf(ifb)%data%cr4K1(ilo) = dt(ifb)%data%cr4K1(i)
     dataBuf(ifb)%data%cr4K2(ilo) = dt(ifb)%data%cr4K2(i)
     dataBuf(ifb)%data%mcrval1(ilo) = dt(ifb)%data%mcrval1(i)
     dataBuf(ifb)%data%mcrval2(ilo) = dt(ifb)%data%mcrval2(i)
     dataBuf(ifb)%data%mlonpole(ilo) = dt(ifb)%data%mlonpole(i)
     dataBuf(ifb)%data%mlatpole(ilo) = dt(ifb)%data%mlatpole(i)
     dataBuf(ifb)%data%otfdata(npix,1:newchan,ilo) = &
  &                                  dt(ifb)%data%otfdata(npix,1:newchan,i)
     dataBuf(ifb)%data%rdata(npix,1:newchan) = dt(ifb)%data%rdata(npix,1:newchan) 

     i1 = (ilo-1)*nphases+1
     i2 = ilo*nphases
     i3 = (i-1)*nphases+1
     i4 = i*nphases
     do j = 1, nbd
        arrayBuf(ifb)%data(j)%data(1:npix,1:nchan,ilo,1:nphases)     &
  &     = ar(ifb)%data(j)%data(1:npix,1:nchan,i,1:nphases)
        arrayBuf(ifb)%data(j)%iswitch(ilo,1:nphases)     &
  &     = ar(ifb)%data(j)%iswitch(i,1:nphases)
        arrayBuf(ifb)%data(j)%mjd(i1:i2) = ar(ifb)%data(j)%mjd(i3:i4)
        arrayBuf(ifb)%data(j)%integtim(i1:i2) = ar(ifb)%data(j)%integtim(i3:i4)
     enddo
  enddo

  ndumpBackend = ndumpBackendNew
! 
! now interpolate monitor data at sampling of backend data
!
  do i = 1, ndumpBackend
     
     ilo = locate(monBuf(ifb)%data%mjd,dataBuf(ifb)%data%midtime(i),ndumpAntenna)

     if (ilo.eq.0) then
        ilo = 1
     else if (ilo.eq.ndumpAntenna) then
        ilo = ndumpAntenna-1
     endif

     iup = ilo+1

     if (monBuf(ifb)%data%subscan(ilo).ne.monBuf(ifb)%data%subscan(iup)) then 
        if (dataBuf(ifb)%data%subscan(i).eq.monBuf(ifb)%data%subscan(ilo)) then
           ilo = ilo-1
           iup = iup-1
        else
           ilo = ilo+1
           iup = iup+1
        endif
     endif

     dTime1 = monBuf(ifb)%data%mjd(iup)-monBuf(ifb)%data%mjd(ilo)
     dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%mjd(ilo)

     slope = (monBuf(ifb)%data%lst(iup)-monBuf(ifb)%data%lst(ilo))/dTime1 
     dataBuf(ifb)%data%lst(i) = monBuf(ifb)%data%lst(ilo)+dTime2*slope
 
     slope = (monBuf(ifb)%data%longoff(iup)-monBuf(ifb)%data%longoff(ilo))/dTime1 
     dataBuf(ifb)%data%longoff(i) = monBuf(ifb)%data%longoff(ilo)+dTime2*slope

     slope = (monBuf(ifb)%data%latoff(iup)-monBuf(ifb)%data%latoff(ilo))/dTime1 
     dataBuf(ifb)%data%latoff(i) = monBuf(ifb)%data%latoff(ilo)+dTime2*slope

     slope = (monBuf(ifb)%data%baslong(iup)-monBuf(ifb)%data%baslong(ilo))/dTime1 
     dataBuf(ifb)%data%baslong(i) = monBuf(ifb)%data%baslong(ilo)+dTime2*slope

     slope = (monBuf(ifb)%data%baslat(iup)-monBuf(ifb)%data%baslat(ilo))/dTime1 
     dataBuf(ifb)%data%baslat(i) = monBuf(ifb)%data%baslat(ilo)+dTime2*slope

     slope = (monBuf(ifb)%data%parangle(iup)-monBuf(ifb)%data%parangle(ilo))/dTime1 
     dataBuf(ifb)%data%parangle(i) = monBuf(ifb)%data%parangle(ilo)+dTime2*slope

     ilo = locate(monBuf(ifb)%data%encoder_az_el(1:ndumpAntennaFast,3),          &
   &              dataBuf(ifb)%data%midtime(i),ndumpAntennaFast)

     if (ilo.eq.0) then
        ilo = 1
     else if (ilo.eq.ndumpAntennaFast) then
        ilo = ndumpAntennaFast-1
     endif

     iup = ilo+1

     if (monBuf(ifb)%data%subScanFast(ilo).ne.monBuf(ifb)%data%subScanFast(iup)) then
        if (dataBuf(ifb)%data%subscan(i).eq.monBuf(ifb)%data%subScanFast(ilo)) then
           ilo = ilo-1
           iup = iup-1
        else
           ilo = ilo+1
           iup = iup+1
        endif
     endif
 
     dTime1 = monBuf(ifb)%data%encoder_az_el(iup,3)                            &
 &            -monBuf(ifb)%data%encoder_az_el(ilo,3)
     dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%encoder_az_el(ilo,3)

     slope = (monBuf(ifb)%data%encoder_az_el(iup,1)                            &
 &           -monBuf(ifb)%data%encoder_az_el(ilo,1))                           &
 &           /dTime1 
     dataBuf(ifb)%data%azimuth(i) = monBuf(ifb)%data%encoder_az_el(ilo,1)+dTime2*slope

     slope = (monBuf(ifb)%data%encoder_az_el(iup,2)                            &
 &            -monBuf(ifb)%data%encoder_az_el(ilo,2))                          &
 &          /dTime1 
     dataBuf(ifb)%data%elevatio(i) = monBuf(ifb)%data%encoder_az_el(ilo,2)     &
 &                                +dTime2*slope
     if (associated(cryo)) then
        ndumpCryo = size(cryo%mjd)
        if (ndumpCryo.gt.1) then
           ilo = locate(                                                     &
   &                    cryo%mjd(1:ndumpCryo),dataBuf(ifb)%data%midtime(i),     &
   &                    ndumpCryo)
           if (ilo.eq.0) ilo = ilo+1
           if (ilo.lt.ndumpCryo) then
               iup = ilo+1
           else
               iup = ilo
           endif
        else
           ilo = 1
           iup = 1
        endif
        if (ilo.eq.iup) then
           dataBuf(ifb)%data%cr4K1(i) = cryo%cr4K1(ilo)
           dataBuf(ifb)%data%cr4K2(i) = cryo%cr4K2(ilo)
        else
           dTime2 = dataBuf(ifb)%data%midtime(i)-cryo%mjd(ilo)
           dTime1 = cryo%mjd(iup)-cryo%mjd(ilo)
           slope = (cryo%cr4K1(iup)-cryo%cr4K1(ilo))/dTime1 
           dataBuf(ifb)%data%cr4K1(i) = cryo%cr4K1(ilo)+dTime2*slope
           slope = (cryo%cr4K2(iup)-cryo%cr4K2(ilo))/dTime1 
           dataBuf(ifb)%data%cr4K2(i) = cryo%cr4K2(ilo)+dTime2*slope
        endif
     endif

     trackFlag = .false.
     if (abs(monBuf(ifb)%data%antenna_az_el(1)-130.5).lt.1.0.and.                &
   &     mod(3.6d+2,monBuf(ifb)%data%antenna_az_el(2)).lt.1.0) then
        trackFlag = .false.  ! use data with crazy tracking errors if antenna in stow position
     else if (abs(monBuf(ifb)%data%tracking_az_el(ilo,1)).gt.trackingCutoff.or.  &
   &     abs(monBuf(ifb)%data%tracking_az_el(ilo,2)).gt.trackingCutoff.or.       &
   &     abs(monBuf(ifb)%data%tracking_az_el(iup,1)).gt.trackingCutoff.or.       &
   &     abs(monBuf(ifb)%data%tracking_az_el(iup,2)).gt.trackingCutoff) then
         do j = 1, nbd
            i1 = (i-1)*nphases+1
            i2 = i*nphases
            arrayBuf(ifb)%data(j)%data(1:npix,1:nchan,i1:i2,1:nphases) =blankingRaw
            trackFlag = .true.
         enddo
     endif
     if (trackFlag) call gagout('W-SYNC: Data flagged due to large tracking errors.')
     if (ndumpSubref.gt.1) then 
        ilo = locate(monBuf(ifb)%data%focus_x_y_z(1:ndumpSubref,4),              &
   &                 dataBuf(ifb)%data%midtime(i),ndumpSubref)

        if (ilo.eq.0) then
           ilo = 1
        else if (ilo.eq.ndumpSubref) then
           ilo = ndumpSubref-1
        endif

        iup = ilo+1

        if (monBuf(ifb)%data%subScanSubref(ilo)                                 &
   &        .ne.monBuf(ifb)%data%subScanSubref(iup)) then
           if (dataBuf(ifb)%data%subscan(i).eq.monBuf(ifb)%data%subScanSubref(ilo)) &
   &       then
              ilo = ilo-1
              iup = iup-1
           else
              ilo = ilo+1
              iup = iup+1
           endif
        endif

        dTime1 = monBuf(ifb)%data%focus_x_y_z(iup,4)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,4)
        dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%focus_x_y_z(ilo,4)

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,1)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,1))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,1) = monBuf(ifb)%data%focus_x_y_z(ilo,1)  &
   &                                      +dTime2*slope

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,2)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,2))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,2) = monBuf(ifb)%data%focus_x_y_z(ilo,2)  &
   &                                      +dTime2*slope

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,3)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,3))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,3) = monBuf(ifb)%data%focus_x_y_z(ilo,3)  &
   &                                      +dTime2*slope

        dataBuf(ifb)%data%dfocus_x_y_z(i,1)=monBuf(ifb)%data%dfocus_x_y_z(ilo,1)
        dataBuf(ifb)%data%dfocus_x_y_z(i,2)=monBuf(ifb)%data%dfocus_x_y_z(ilo,2)
        dataBuf(ifb)%data%dfocus_x_y_z(i,3)=monBuf(ifb)%data%dfocus_x_y_z(ilo,3)

        slope = (monBuf(ifb)%data%phi_x_y_z(iup,3)                            &
   &             -monBuf(ifb)%data%phi_x_y_z(ilo,3))                          &
   &            /dTime1 
        dataBuf(ifb)%data%phi_x_y_z(i,3) = monBuf(ifb)%data%phi_x_y_z(ilo,3)     &
   &                                    +dTime2*slope
     else
        dataBuf(ifb)%data%focus_x_y_z(i,1:3)=monBuf(ifb)%data%focus_x_y_z(1,1:3)
        dataBuf(ifb)%data%dfocus_x_y_z(i,3) = monBuf(ifb)%data%dfocus_x_y_z(1,3)
        dataBuf(ifb)%data%phi_x_y_z(i,3) = monBuf(ifb)%data%phi_x_y_z(1,3)
     endif
  enddo

  tmpScanType = scan%header%scantype
  call sic_upper(tmpScanType)
  tmpSwitchMode = febe(ifb)%header%swtchmod
  call sic_upper(tmpSwitchMode)

  if (index(tmpScanType,'CAL').ne.0.and.index(tmpSwitchMode,'FREQ').eq.0) then

     gn(ifb)%psky(:,:,:) = blankingRaw
     gn(ifb)%phot(:,:,:) = blankingRaw
     gn(ifb)%pcold(:,:,:) = blankingRaw

     if (allocated(mask)) deallocate(mask,stat=ier)
     allocate(mask(ndumpBackend,nphases),stat=ier)
     if (allocated(tmpMask)) deallocate(tmpMask,stat=ier)
     allocate(tmpMask(ndumpBackend,nphases),stat=ier)

     do i = subscanRange(1), subscanRange(2) 
        i1 = i-subscanRange(1)+1
        do j = 1, nphases
          mask(1:ndumpBackend,j) = dataBuf(ifb)%data%subscan.eq.i
        enddo
        if (index(raw(i1)%antenna(ifb)%subScanType,'Sky').ne.0.or.              &
   &        index(raw(i1)%subRef(ifb)%subScanType,'Sky').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan 
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%psky(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%psky(j,k,:))/nchan
                 where(gn(ifb)%psky(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%psky(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%psky(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Ambient').ne.0.or.     &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Ambient').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%phot(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%phot(j,k,:))/nchan
                 where(gn(ifb)%phot(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%phot(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%phot(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Cold').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Cold').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%pcold(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%pcold(j,k,:))/nchan
                 where(gn(ifb)%pcold(j,k,:).lt.meanCounts/badLevel.or.         &
   &                   gn(ifb)%pcold(j,k,:).gt.meanCounts*badLevel)            &
   &                   gn(ifb)%pcold(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Grid').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Grid').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%pgrid(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = abs(sum(gn(ifb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.    &
   &                   abs(gn(ifb)%pgrid(j,k,:)).gt.meanCounts*badLevel)       &
   &                   gn(ifb)%pgrid(j,k,:) = blankingRaw
              enddo
           enddo

        else 
           
           call gagout('W-SYNC: Subscan type unknown. Cannot attribute '       &
   &                   //' mean calibration counts.')

        endif

     enddo
 
     tmpFrontend = febe(ifb)%header%febe
     call sic_upper(tmpFrontend)
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        where (gn(ifb)%phot.ne.blankingRaw.and.gn(ifb)%psky.ne.blankingRaw)
           gn(ifb)%gainarray = gn(ifb)%phot-gn(ifb)%psky
        else where
           gn(ifb)%gainarray = blankingRaw 
        end where
     endif

  else if (index(tmpScanType,'CAL').ne.0.and.index(tmpSwitchMode,'FREQ').ne.0) &
 &then

     gn(ifb)%psky(:,:,:) = blankingRaw
     gn(ifb)%phot(:,:,:) = blankingRaw
     gn(ifb)%pcold(:,:,:) = blankingRaw
     gn(ifb+nfb)%psky(:,:,:) = blankingRaw
     gn(ifb+nfb)%phot(:,:,:) = blankingRaw
     gn(ifb+nfb)%pcold(:,:,:) = blankingRaw

     if (allocated(maskFSW)) deallocate(maskFSW,stat=ier)
     allocate(maskFSW(ndumpBackend),stat=ier)
     if (allocated(tmpMaskFSW)) deallocate(tmpMaskFSW,stat=ier)
     allocate(tmpMaskFSW(ndumpBackend),stat=ier)

     do i = subscanRange(1), subscanRange(2) 
        i1 = i-subscanRange(1)+1
        maskFSW(1:ndumpBackend) = dataBuf(ifb)%data%subscan.eq.i

        if (index(raw(i1)%antenna(ifb)%subScanType,'Sky').ne.0.or.              &
   &        index(raw(i1)%subRef(ifb)%subScanType,'Sky').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan 
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%psky(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%psky(j,k,l)                                    &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%psky(j,k,:))/nchan
                 where(gn(ifb)%psky(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%psky(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%psky(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%psky(j,k,:))/nchan
                 where(gn(ifb+nfb)%psky(j,k,:).lt.meanCounts/badLevel.or.      &
   &                   gn(ifb+nfb)%psky(j,k,:).gt.meanCounts*badLevel)         &
   &                   gn(ifb+nfb)%psky(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Ambient').ne.0.or.     &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Ambient').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%phot(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%phot(j,k,l)                                    &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%phot(j,k,:))/nchan
                 where(gn(ifb)%phot(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%phot(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%phot(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%phot(j,k,:))/nchan
                 where(gn(ifb+nfb)%phot(j,k,:).lt.meanCounts/badLevel.or.      &
   &                   gn(ifb+nfb)%phot(j,k,:).gt.meanCounts*badLevel)         &
   &                   gn(ifb+nfb)%phot(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Cold').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Cold').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%pcold(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%pcold(j,k,l)                                   &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%pcold(j,k,:))/nchan
                 where(gn(ifb)%pcold(j,k,:).lt.meanCounts/badLevel.or.         &
   &                   gn(ifb)%pcold(j,k,:).gt.meanCounts*badLevel)            &
   &                   gn(ifb)%pcold(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%pcold(j,k,:))/nchan
                 where(gn(ifb+nfb)%pcold(j,k,:).lt.meanCounts/badLevel.or.     &
   &                   gn(ifb+nfb)%pcold(j,k,:).gt.meanCounts*badLevel)        &
   &                   gn(ifb+nfb)%pcold(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Grid').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Grid').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%pgrid(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%pgrid(j,k,l)                                   &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = abs(sum(gn(ifb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.    &
   &                   abs(gn(ifb)%pgrid(j,k,:)).gt.meanCounts*badLevel)       &
   &                   gn(ifb)%pgrid(j,k,:) = blankingRaw
                 meanCounts = abs(sum(gn(ifb+nfb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb+nfb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.&
   &                   abs(gn(ifb+nfb)%pgrid(j,k,:)).gt.meanCounts*badLevel)   &
   &                   gn(ifb+nfb)%pgrid(j,k,:) = blankingRaw
              enddo
           enddo

        else 
           
           call gagout('W-SYNC: Subscan type unknown. Cannot attribute '       &
   &                   //' mean calibration counts.')

        endif

     enddo
 
     tmpFrontend = febe(ifb)%header%febe
     call sic_upper(tmpFrontend)
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        where (gn(ifb)%phot.ne.blankingRaw.and.gn(ifb)%psky.ne.blankingRaw)
           gn(ifb)%gainarray = gn(ifb)%phot-gn(ifb)%psky
        else where
           gn(ifb)%gainarray = blankingRaw 
        end where
     endif
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        
        where (gn(ifb+nfb)%phot.ne.blankingRaw.and.gn(ifb+nfb)%psky.ne.       &
  &            blankingRaw)
           gn(ifb+nfb)%gainarray = gn(ifb+nfb)%phot-gn(ifb+nfb)%psky
        else where
           gn(ifb+nfb)%gainarray = blankingRaw 
        end where
     endif
    
  endif

  if (index(tmpSwitchMode,'WOB').ne.0.and.index(tmpScantype,'POINT').eq.0) then
     do i = 1, ndumpBackend
        isub = dataBuf(ifb)%data%subscan(i)
        if (raw(isub)%antenna(ifb)%subScanXOff.lt.0) then
          dataBuf(ifb)%data%longoff(i) = dataBuf(ifb)%data%longoff(i)      &
 &                                 +0.5*scan%header%wobthrow
        else
          dataBuf(ifb)%data%longoff(i) = dataBuf(ifb)%data%longoff(i)      &
 &                                 -0.5*scan%header%wobthrow
        endif
     enddo
  endif

end subroutine syncData



FUNCTION locate(xx,x,n)
IMPLICIT NONE
INTEGER n
REAL*8, DIMENSION(n) :: xx
REAL*8 :: x
INTEGER :: LOCATE
INTEGER :: jl,jm,ju
LOGICAL :: ascnd

! ADDED BY HW: returns 1 or n if x below xx(1), respectively
!              above xx(n).
!
if (x.lt.xx(1)) then
   locate = 0
   return
else if (x.gt.xx(n)) then
   locate = n
   return
endif
!
!
ascnd = (xx(n) >= xx(1))
jl = 0
ju = n+1
do
     if (ju-jl <= 1) exit
     jm=(ju+jl)/2
     if (ascnd .eqv. (x >= xx(jm))) then
         jl=jm
     else
         ju=jm
     end if
end do
if (x == xx(1)) then
    locate=1
else if (x == xx(n)) then
    locate=n-1
else
    locate=jl
endif
END FUNCTION locate

  
subroutine miraPolfit(n,n2,y1,y2,error)

   use mira

   implicit none

   integer                  :: n, n2
   real*8, dimension(n)     :: y1,y2
   logical                  :: error

   integer                  :: i, j, k, l, m
   integer                  :: nmax
   real*8                   :: chisq,chisqr,free,delta1,delta2,xterm,xx,yterm
   real*8, dimension(2*n2-1)  :: sumx
   real*8, dimension(n)     :: w
   real*8, dimension(n2)    :: coef,sumy
   real*8, dimension(n2,n2) :: a

   nmax = 2*n2-1
   sumx = 0.
   sumy = 0.
   chisq = 0.

   w = 1.
   where (y1.eq.blankingRaw) w = 0.
   do i = 1, n 
      xterm = w(i)
      do j = 1, nmax
         sumx(j) = sumx(j)+xterm
         xterm = xterm*i*1.d-3
      enddo
      yterm = w(i)*y1(i)
      do j = 1, n2
         sumy(j) = sumy(j)+yterm
         yterm = yterm*i*1.d-3
      enddo
      chisq = chisq+w(i)*y1(i)*y1(i)
   enddo
   
   do j = 1, n2
      do k = 1, n2
         m = j+k-1
         a(j,k) = sumx(m)
      enddo
   enddo

   call determ(n2,a,delta1,error)
   if (error) return 
   if (delta1.eq.0) then
       chisqr = 0.
       coef(1:n2) = 0.
       return
   else
       do l = 1, n2
          do j = 1, n2
             do k = 1, n2
                m = j+k-1
                a(j,k) = sumx(m)
             enddo
             a(j,l) = sumy(j)
          enddo
          call determ(n2,a,delta2,error)
          coef(l) = delta2/delta1
       enddo
   endif

   do j = 1, n2
      chisq = chisq-2.*coef(j)*sumy(j)
      do k = 1, n2
         m = j+k-1
         chisq = chisq+coef(j)*coef(k)*sumx(m)
      enddo
   enddo
   free = n-n2
   chisqr = chisq/free
   
   do i = 1, n
      y2(i) = coef(1) 
      xx = 1.d0*i*1.d-3
      do j = 2, n2
         y2(i) = y2(i)+coef(j)*xx**(j-1)
      enddo
   enddo
 
   return

end subroutine miraPolfit

subroutine determ(n,array,delta,error)

   implicit none
   integer                :: n
   real*8                 :: delta
   real*8, dimension(n,n) :: array
   logical                :: error

   integer                :: i, imax, j, k
   real*8                 :: aamax, dum, sum
   real*8, dimension(n)   :: vv
   real*8, dimension(n,n) :: a
   real*8, parameter      :: tiny = 1.0d-20

   delta = 1.d0
   a     = array

   do i = 1, n
      aamax = maxval(abs(a(i,1:n)))
      if (aamax.eq.0) then
        call gagout('E-GET: singular matrix in subroutine DETERM')
        error = .true.
        return
      else
        vv(i) = 1./aamax
      endif
   enddo

   do j = 1, n
      do i = 1, j-1
         sum = a(i,j)
         do k = 1, i-1
            sum = sum-a(i,k)*a(k,j)
         enddo    
         a(i,j) = sum
      enddo
      aamax = 0.
      do i = j, n
         sum = a(i,j)
         do k = 1, j-1
            sum = sum-a(i,k)*a(k,j)
         enddo
         a(i,j) = sum
         dum = vv(i)*abs(sum)
         if (dum.ge.aamax) then
            imax = i
            aamax = dum
         endif
      enddo

      if (j.ne.imax) then
         do k = 1, n
            dum = a(imax,k)
            a(imax,k) = a(j,k)
            a(j,k) = dum
         enddo
         delta = -delta
         vv(imax) = vv(j)
      endif
      if (a(j,j).eq.0) a(j,j) = tiny
      if (j.ne.n) then
         dum = 1./a(j,j)
         do i = j+1, n
            a(i,j) = a(i,j)*dum
         enddo
      endif
   enddo

   do j = 1, n
      delta = delta*a(j,j)
   enddo

   return

end subroutine determ

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_pipe_command(line,error)
  use mrtcal_messaging
  use gkernel_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_pipe_command
  use mrtcal_parameters
  use mrtcal_buffers
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  ! PIPELINE
  ! 1. /SHOW [*|NONE|DONE|FAILED]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  logical :: myerror,show,dupl
  integer(kind=4), parameter :: ishow = 1
  integer(kind=entry_length) :: icaluser,ientuser,cent,ient,num
  integer(kind=4) :: nerror,nsuccess
  type(user_calib_t) :: select
  character(len=message_length) :: mess
  type(cputime_t) :: time
  integer(kind=4), allocatable :: lastversion(:)
  character(len=*), parameter :: rname='PIPE>COMMAND'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Parsing first
  show = sic_present(ishow,0)
  if (show) then
     call mrtcal_pipe_parse(line,ishow,select,error)
     if (error) return
  endif
  !
  if (cx%next.le.1) then
     call mrtcal_message(seve%e,rname,'Current index is empty')
     error = .true.
     return
  endif
  !
  call gag_cputime_init(time)
  !
  call mrtcal_separator(seve%r,rname,2,error)
  if (error) return
  call mrtcal_message(seve%r,rname,'Welcome to the MRTCAL pipeline!')
  call mrtcal_separator(seve%r,rname,2,error)
  if (error) return
  call mrtcal_setup_print(rsetup,error)
  if (error) return
  call mrtcal_separator(seve%r,rname,2,error)
  if (error) return
  call mrtcal_message(seve%r,rname,'Working on current index')
  call mrtindex_list(cx,'UPDATED IDX',(/0/),6,.false.,error)
  if (error) return
  write(mess,'(I0,A)') cx%next-1,' entries in selection, iterating'
  call mrtcal_message(seve%r,rname,mess)
  !
  ! Save the latest known version in IX of all entries in CX
  allocate(lastversion(cx%next-1))
  do cent=1,cx%next-1
    num = cx%num(cent)
    call mrtindex_numver2ent(rname,ix,num,0,ient,dupl,error)
    if (error)  return
    lastversion(cent) = ix%version(ient)
  enddo
  !
  ! Loop on entries
  myerror = .false.
  nerror = 0
  nsuccess = 0
  do cent=1,cx%next-1
     ! User can interrupt the pipeline
     if (sic_ctrlc_status()) exit
     !
     ! Skip entries which were implicitly calibrated by a previous entry within
     ! the same PIPELINE call. Typical sequence is:
     !   1 SCIENCE
     !   2 CALIBRATION
     !   3 SCIENCE
     ! Iteration #1 calibrates both 1 SCIENCE with implicit new 2 CALIBRATION
     ! Iteration #2 calibrates 2 CALIBRATION (again!)
     ! Iteration #3 calibrates 3 SCIENCE with old 2 CALIBRATION
     ! We have to avoid calibrating 2 CALIBRATION twice with the same PIPELINE
     ! command. But be careful it is valid to calibrate several times an entry
     ! (several calls to CALIBRATE or PIPELINE commands) with e.g. different
     ! MSET tuning. The proper solution is to check if a new version has
     ! appeared in the meantime.
     num = cx%num(cent)
     call mrtindex_numver2ent(rname,ix,num,0,ient,dupl,error)
     if (error)  return
     if (lastversion(cent).ne.ix%version(ient)) then
       call mrtcal_separator(seve%r,rname,2,error)
       if (error) return
       call mrtindex_list_one_default(cx,cent,mess,error)
       if (error) return
       mess = 'Skip already calibrated '//mess
       call mrtcal_message(seve%w,rname,mess)  ! Or debug?
       cycle
     endif
     !
     ! Calibrate next entry
     icaluser = 0
     ientuser = cx%mnum(cent)
     call mrtcal_calib_or_solve_ix_entry(&
          code_command_pipe,&
          rsetup,ix,ientuser,icaluser,&
          rfile,rcalib,rscience,myerror)
     if (myerror) then
       nerror = nerror+1
     else
       nsuccess = nsuccess+1
     endif
     if (myerror .and. .not.rsetup%pipeline) then
        ! Interactive mode => Stop as soon as possible
        error = .true.
        return
     else
        ! True pipeline mode => Continue as long as possible
        myerror = .false.
        continue 
     endif
  enddo ! cent
  deallocate(lastversion)
  !
  call gag_cputime_get(time)
  !
  if (show) then
     call mrtcal_pipe_feedback(select,ix,cx,error)
     if (error) return
  endif
  call mrtcal_separator(seve%r,rname,2,error)
  if (error) return
  write(mess,'(A,I0,A,I0,A,I0,A)')  'Successfully processed ',nsuccess,  &
    ' entries, ',nerror,' errors (total ',cx%next-1,' in index)'
  call mrtcal_message(seve%r,rname,mess)
  if (time%curr%elapsed.lt.6.d1) then
    write(mess,'(A,F0.2,A)')  'Pipeline executed in ',time%curr%elapsed,' seconds'
  elseif (time%curr%elapsed.lt.3.6d3) then
    write(mess,'(A,F0.2,A)')  'Pipeline executed in ',time%curr%elapsed/6.d1,' minutes'
  else
    write(mess,'(A,F0.2,A)')  'Pipeline executed in ',time%curr%elapsed/3.6d3,' hours'
  endif
  call mrtcal_message(seve%r,rname,mess)
  call mrtcal_message(seve%r,rname,'The MRTCAL pipeline wishes you a pleasant day!')
  call mrtcal_separator(seve%r,rname,2,error)
  if (error) return
  !
end subroutine mrtcal_pipe_command
!
subroutine mrtcal_pipe_parse(line,iopt,select,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this => mrtcal_pipe_parse
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),   intent(in)    :: line
  integer(kind=4),    intent(in)    :: iopt
  type(user_calib_t), intent(out)   :: select
  logical,            intent(inout) :: error
  ! Local
  integer(kind=4) :: nchar
  character(len=*), parameter :: rname='PIPE>PARSE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  select%cback = '*'
  select%cobst = '*'
  select%cswit = '*'
  select%csour = '*'
  select%cproj = '*'
  select%cfron = '*'
  select%ccomp = 'READABLE'
  select%ccali = '*'
  call sic_ke(line,iopt,1,select%ccali,nchar,.false.,error)
  if (error)  return
  !
end subroutine mrtcal_pipe_parse
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_pipe_feedback(select,ix,cx,error)
  use mrtcal_messaging
  use mrtindex_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_pipe_feedback
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! User feedback: Update CX according to user choice
  !---------------------------------------------------------------------
  type(user_calib_t),        intent(in)    :: select
  type(mrtindex_optimize_t), intent(in)    :: ix
  type(mrtindex_optimize_t), intent(inout) :: cx
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='PIPE>FEEDBACK'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_pipe_update_cx(ix,cx,error)
  if (error) return
  call mrtcal_pipe_filter_cx(select,cx,error)
  if (error) return
  if (cx%next.gt.1) then
     call mrtcal_separator(seve%r,rname,2,error)
     if (error) return
     call mrtcal_message(seve%r,rname,'Results:')
     call mrtindex_list(cx,'UPDATED IDX',(/0/),6,.false.,error)
     if (error) return
  endif
  !
end subroutine mrtcal_pipe_feedback
!
subroutine mrtcal_pipe_update_cx(ix,cx,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_pipe_update_cx
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Update CX with latest version of the IX entries
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: ix
  type(mrtindex_optimize_t), intent(inout) :: cx
  logical,                   intent(inout) :: error
  ! Local
  logical :: duplicated
  integer(kind=4), parameter :: newest = 0
  integer(kind=entry_length) :: cent,ientuser,ientnewest
  character(len=*), parameter :: rname='PIPE>UPDATE>CX'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do cent=1,cx%next-1
     ientuser = cx%mnum(cent)
     call mrtindex_numver2ent(rname,ix,ix%num(ientuser),newest,ientnewest,&
          duplicated,error)
     if (error) return
     call mrtindex_optimize_to_optimize(ix,ientnewest,cx,cent,error)
     if (error) return
  enddo ! ient
  !
end subroutine mrtcal_pipe_update_cx
!
subroutine mrtcal_pipe_filter_cx(select,cx,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_pipe_filter_cx
  use mrtindex_types
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Filter CX according to user choice
  !---------------------------------------------------------------------
  type(user_calib_t),        intent(in)    :: select
  type(mrtindex_optimize_t), intent(inout) :: cx
  logical,                   intent(inout) :: error
  ! Local
  type(mrtindex_optimize_t) :: subidx
  character(len=*), parameter :: rname='PIPE>FILTER>CX'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtindex_find(select,cx,subidx,error)
  if (error) goto 100
  call mrtindex_optimize_to_optimize(subidx,cx,error)
  if (error) goto 100
  !
100 continue
  call deallocate_mrtoptimize(subidx,error)
  !
end subroutine mrtcal_pipe_filter_cx
!
subroutine mrtcal_separator(severity,rname,nline,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this => mrtcal_separator
  !---------------------------------------------------------------------
  ! @ private
  ! Print nline white lines as entry separators
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: severity
  character(len=*), intent(in)    :: rname
  integer(kind=4),  intent(in)    :: nline
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: iline
  !
  if (nline.le.0) then
     call mrtcal_message(seve%e,rname,'Negative number of white lines!')
     error = .true.
     return
  else
     do iline=1,nline
        call mrtcal_message(severity,rname,'')
     enddo ! iline
  endif
  !
end subroutine mrtcal_separator
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_which_data
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubeedit_messaging
  !
  public :: which_comm_t,which_user_t
  private
  !
  type which_comm_t
     type(option_t),      pointer :: opt      
     type(keywordlist_comm_t), pointer :: access
     logical                      :: fixed
     logical                      :: active
   contains
     procedure :: register  => cubeedit_which_data_register
     procedure :: parse     => cubeedit_which_data_parse
     procedure :: user2prog => cubeedit_which_data_user2prog
  end type which_comm_t
  !
  type which_user_t
     character(len=argu_l) :: access
     logical               :: do
  end type which_user_t
  !
contains
  !
  subroutine cubeedit_which_data_register(opt,name,abstract,fixed,active,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(which_comm_t), intent(out)   :: opt
    character(len=*),    intent(in)    :: name
    character(len=*),    intent(in)    :: abstract
    logical,             intent(in)    :: fixed
    logical,             intent(in)    :: active
    logical,             intent(inout) :: error
    !
    character(len=32) :: syntax
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: accesses(2) = (/ 'IMAGE   ','SPECTRUM' /)
    character(len=*), parameter :: rname='WHICH>DATA>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    opt%active = active
    if (.not.active) return
    opt%fixed = fixed 
    if (fixed) then
       syntax = ''
    else
       syntax = '[Access]'
    endif
    call cubetools_register_option(&
         name,syntax,&
         abstract,&
         strg_emp,&
         opt%opt,&
         error)
    if (error) return
    if (.not.fixed) then
       call keyarg%register(&
            'Access',&
            'In which order the cube should be accessed',&
            strg_emp,&
            code_arg_optional,&
            accesses,&
            .not.flexible,&
            opt%access,&
            error)
       if (error) return
    endif
  end subroutine cubeedit_which_data_register
  !
  subroutine cubeedit_which_data_parse(opt,line,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(which_comm_t), intent(in)    :: opt
    character(len=*),    intent(in)    :: line
    type(which_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='WHICH>DATA>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (opt%active) then
       call opt%opt%present(line,user%do,error)
       if (error) return
       if (user%do.and..not.opt%fixed) then
          user%access = 'IMAGE'
          call cubetools_getarg(line,opt%opt,1,user%access,.not.mandatory,error)
          if (error) return
       else
          user%access = 'FIXED'
       endif
    else
       user%do = .false.
    endif
    !
  end subroutine cubeedit_which_data_parse
  !
  subroutine cubeedit_which_data_user2prog(opt,user,doaccess,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(which_comm_t),  intent(in)    :: opt
    type(which_user_t),   intent(in)    :: user
    integer(kind=code_k), intent(out)   :: doaccess
    logical,              intent(inout) :: error
    !
    character(len=8) :: access
    integer(kind=4) :: ikey
    character(len=*), parameter :: rname='WHICH>DATA>USER2PROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    !
    call cubetools_keywordlist_user2prog(opt%access,user%access,ikey,access,error)
    if (error) return
    !
    select case (access)
    case('IMAGE')
      doaccess = code_access_imaset
    case('SPECTRUM')
      doaccess = code_access_speset
    case default
      call cubeedit_message(seve%e,rname,'Unsupported access mode: '//trim(user%access))
      error = .true.
      return
    end select
  end subroutine cubeedit_which_data_user2prog
end module cubeedit_which_data
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeset_index
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubesyntax_key_types
  use cubetools_setup_types
  use cubeset_messaging
  !
  public :: index
  private
  !
  type :: index_comm_t
    type(option_t), pointer :: comm
    type(keywordlist_comm_t), pointer :: index_arg
    type(key_comm_t) :: default
   contains
    procedure, public  :: register => cubeset_index_register
    procedure, private :: parse    => cubeset_index_parse
    procedure, private :: main     => cubeset_index_main
  end type index_comm_t
  type(index_comm_t) :: index
  !
  type :: index_user_t
    logical :: list
    character(len=argu_l) :: name = strg_unk
    type(key_user_t) :: default
  contains
    procedure, private :: toprog => cubeset_index_user_toprog
  end type index_user_t
  !
  type :: index_prog_t
    logical :: list
    integer(kind=code_k) :: index = code_index_dag
    type(key_prog_t) :: default
  contains
    procedure, private :: act => cubeset_index_prog_act
  end type index_prog_t
  !
contains
  !
  subroutine cubeset_index_command(line,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(index_user_t) :: user
    character(len=*), parameter :: rname='INDEX>COMMAND'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call index%parse(line,user,error)
    if (error) return
    call index%main(user,error)
    if (error) return
  end subroutine cubeset_index_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeset_index_register(index,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(index_comm_t), intent(inout) :: index
    logical,             intent(inout) :: error
    !
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='INDEX>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'INDEX','[DAG|CURRENT]',&
         'Set which index should be used when searching for cubes',&
         'No argument shows current value. Default is DAG. Use /DEFAULT&
         & to reset index settings. When /DEFAULT is combined with an&
         & argument on the same command line, reset is applied first.',&
         cubeset_index_command,&
         index%comm,&
         error)
    if (error) return
    call keyarg%register(&
         'name',&
         'Name of the index to be used',&
         strg_emp,&
         code_arg_optional,&
         indexname,&
         .not.flexible,&
         index%index_arg,&
         error)
    if (error) return
    !
    call index%default%register(&
         'DEFAULT',&
         'Reset settings',&
         'Reset index settings before applying command arguments from the&
         & same command line.',&
         error)
    if (error) return
  end subroutine cubeset_index_register
  !
  subroutine cubeset_index_parse(index,line,user,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(index_comm_t), intent(in)    :: index
    character(len=*),    intent(in)    :: line
    type(index_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='INDEX>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    user%list = cubetools_nopt().eq.0 .and. index%comm%getnarg().eq.0
    !
    if (user%list) then
      ! nothing to do
    else
      if (index%comm%getnarg().gt.0) then
        call cubetools_getarg(line,index%comm,1,user%name,mandatory,error)
        if (error) return
      endif
      call index%default%parse(line,user%default,error)
      if (error) return
    endif
  end subroutine cubeset_index_parse
  !
  subroutine cubeset_index_main(comm,user,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(index_comm_t), intent(inout) :: comm
    type(index_user_t),  intent(in)    :: user
    logical,             intent(inout) :: error
    !
    type(index_prog_t) :: prog
    character(len=*), parameter :: rname='INDEX>MAIN'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubeset_index_main
  !
  subroutine cubeset_index_user_toprog(user,comm,prog,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(index_user_t), intent(in)    :: user
    type(index_comm_t),  intent(in)    :: comm
    type(index_prog_t),  intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    character(len=16) :: keyword
    character(len=*), parameter :: rname='INDEX>USER>TOPROG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    prog%list = user%list
    if (user%name.ne.strg_unk) then
      call cubetools_keywordlist_user2prog(comm%index_arg,user%name,prog%index,keyword,error)
      if (error) return
    endif
    call user%default%toprog(comm%default,prog%default,error)
    if (error) return
  end subroutine cubeset_index_user_toprog
  !
  subroutine cubeset_index_prog_act(prog,error)
    use cubetools_setup_types
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(index_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    type(cube_setup_api_t) :: setup
    integer(kind=code_k) :: default_index
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='INDEX>PROG>ACT'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (prog%default%act)  call setup%index%reset()
    if (.not.prog%list) then
      call setup%index%default%set(prog%index,error)
      if (error) return
    endif
    if (prog%list) then
      call cubeset_message(seve%r,rname,'  Index')
      call setup%index%default%get(default_index)
      write(mess,'(a,a)') '    Default: ',indexname(default_index)
      call cubeset_message(seve%r,rname,mess)
    endif
  end subroutine cubeset_index_prog_act
end module cubeset_index

subroutine las_setdef(set,error)
  use gildas_def
  use gbl_constant
  use phys_const
  use classcore_interfaces, except_this=>las_setdef
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  !  Setup default parameters
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  real(kind=4) :: any
  integer(kind=4), parameter :: mini2=-32768
  integer(kind=4), parameter :: maxi2=32767
  integer(kind=4), parameter :: maxi4=2147483647_4
  integer(kind=8), parameter :: maxi8=9223372036854775807_8
  !
  call chtoby('ANY ',any,4)
  !
  set%method  = 'GAUSS'
  set%action  = 'O'
  set%align   = 'C'
  set%alig2   = 'I'
  set%offs1   = any
  set%offs2   = any
  set%offl1   = any
  set%offl2   = any
  set%obse1   = mini2
  set%obse2   = maxi2
  set%redu1   = mini2
  set%redu2   = maxi2
  set%match   = .true.
  set%fft     = .false.
  set%coord   = 0                   ! Automatic
  set%veloc   = vel_aut
  set%equinox = 2000.0
  set%line    = '*'
  set%heade   = 'L'
  set%plot    = 'H'
  set%sourc   = '*'
  set%modex   = 'A'
  set%modey   = 'A'
  set%modez   = 'T'
  set%teles   = '*'
  set%tole    = 2.e0*rad_per_sec
  set%qual1   = 0
  set%qual2   = 8
  set%posa1   = -1e7
  set%posa2   = +1e7
  set%freqmin = -1.d0
  set%freqmax = -1.d0
  set%freqsig = .true.
  set%weigh   = 'T'
  set%unitx(1) = 'F'
  set%unitx(2) = 'V'
  set%entr1 = 0
  set%entr2 = maxi8
  set%nume1 = 0
  set%nume2 = maxi8
  set%scan1 = 0
  set%scan2 = maxi8
  set%sub1  = 0
  set%sub2  = maxi4
  set%base = 1
  set%lbase = -2  ! BASE LAST (-2: invalid, -1: sinus, 0+: poly)
  set%nwind = setnwind_default
  set%bad = 'O'
  set%defext = '.30m'
  set%sort_name = 'NONE'
  set%do_sort = .false.
  set%do_scan = .false.
  set%slev = 1
  set%flev = 0
  set%scale = yunit_unknown  ! Unknown = do nothing
  set%write_r8 = .false.
  set%fupda = .false.
  set%uniqueness = .false.
  set%title%position = .true.
  set%title%quality = .true.
  set%title%spectral = .true.
  set%title%calibration = .false.
  set%title%atmosphere = .false.
  set%title%continuum = .true.
  set%title%origin = .false.
  set%origin = .false.
  set%beamt = 0.02
  set%gaint = 0
  set%obs_name = '*'   ! compute_doppler guess observatory from TELESCOPE name
  set%obs_long = 0.d0  ! Unused if name is *
  set%obs_lati = 0.d0  ! Unused if name is *
  set%obs_alti = 0.d0  ! Unused if name is *
  set%check%sou = .true.
  set%check%pos = .true.
  set%check%off = .true.
  set%check%lin = .true.
  set%check%spe = .true.
  set%check%cal = .true.
  set%check%swi = .true.
  set%varpresec(:) = setvar_off
  !
  ! Initialisation du Terminal Graphique
  gvx1 = -1.0
  gvx2 =  1.0
  gcx1 = -1.0
  gcx2 =  1.0
  gfx1 = -1.0
  gfx2 =  1.0
  gfxo =  0.d0
  gix1 = -1.0
  gix2 =  1.0
  gixo =  0.d0
  gux1 = -1.0
  gux2 =  1.0
  guy1 = -1.0
  guy2 =  1.0
  guy  =  1.0
  gux  =  1.0
  gcx  =  1.0
  gvx  =  1.0
  gfx  =  1.0
  gix  =  1.0
  gx1 = 3.
  gx2 = 28.0
  gy1 = 2.5
  gy2 = 15.5
  call gr_exec1('SET VIEWPORT 0.10 0.90 0.10 0.70')
  !
  error = .false.
end subroutine las_setdef
!
subroutine las_setup(set,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>las_setup
  use class_common
  use class_fits
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Called only once at startup
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  logical,             intent(inout) :: error  !
  !
  filein%nspec = 1
  fileout%nspec = 1
  !
  ! Initialize the Classic library
  call classic_init(error)
  if (error)  call sysexi(fatale)
  ! Initialize the FILE IN|OUT conversion routines to something (actually
  ! we want to call these routines to fill a Class user section even if
  ! no file is opened...)
  filein%conv%code = 0    ! No conversion
  call classic_conv(filein%conv,error)
  fileout%conv%code = 0    ! No conversion
  call classic_conv(fileout%conv,error)
  !
  ! Initialize the CURS01 common.
  !  xcurs = 16.
  !  ycurs = 9.
  !
  fits_mode = 'NONE'
  snbit = 32
  !
  call las_setdef(set,error)
  !
end subroutine las_setup

!-----------------------------------------------------------------------
! The following transposition engine is based on the idea that many
! transpositions can be re-written as permutation of the 2nd and 4th
! dimensions of a 5D array. The most "difficult" part is to find how
! to remap the input array on such a 5D array, by repacking contiguous
! dimensions and inserting others which are degenerated.
!
! Examples:
! - 21:       a(n1,n2) <= b(1, n1, 1, n2, 1)
!             tr(a) = tr(b) = c(1,n2,1,n1,1)
! - 321:      a(n1,n2,n3) <= b(1, n1, n2, n3, 1)
!             tr(a) = tr(b) = c(1,n3,n2,n1,1)
! - 312:      a(n1,n2,n3) <= b(1, n1*n2, 1, n3, 1)
!             tr(a) = tr(b) = c(1,n3,1,n1*n2,1)
! - 1567423:  a(n1,n2,n3,n4,n5,n6,n7) <= b(n1, n2*n3, n4, n5*n6*n7, 1)
!             tr(a) = tr(b) = c(n1,n5*n6*n7,n4,n2*n3,1)
!
! Pros:
!  - since we always swap the 2nd and 4th dimension of the 5D array,
!    there is no need of a permutation array in the transposition loop.
!  - up to now all the transpositions needed in the Gildas context are
!    supported in a single pass.
!  - such an approach allows the calling programs to loop on the 5th
!    dimension of the 5D array, i.e. allocate only a working buffer
!    of dimensions m1*m2*m3*m4. This is particularly useful when
!    transposing disk images.
! Cons:
!  - all the transpositions are not supported. Some of them imply
!    executing several times the 5D transposition loop to achieve a
!    goal. If the problem fits in memory, a general (7D) transposition
!    loop with a permutation array should be prefered since the result
!    is achieved in a single pass.
!-----------------------------------------------------------------------
module gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  No need to share the code 'tr_maxdims': the transposition engine
  ! is able to deal with a number of dimensions lower or equal, or
  ! to complain for larger numbers.
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: tr_maxdims=7
end module gmath_transpose
!
subroutine transpose_getcode(strin,strout,code,error)
  use gmath_interfaces, except_this=>transpose_getcode
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  !  Convert a dimension string into a transposition code, e.g.
  !   'VLM' transposed to 'LMV'  <=>  transposition code '231'
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: strin   !
  character(len=*), intent(in)    :: strout  !
  character(len=*), intent(out)   :: code    !
  logical,          intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: ni,no,nc,i
  character(len=tr_maxdims) :: in,out
  !
  ni = len_trim(strin)
  no = len_trim(strout)
  nc = len(code)
  !
  ! Sanity check
  if (ni.ne.no)  goto 100
  if (no.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Transposition supported up to 7 dimensions')
    goto 100
  endif
  if (no.gt.nc) then
    call gmath_message(seve%e,rname,'Programming error, string for code too short')
    goto 100
  endif
  !
  ! Case-insensitive work
  in = strin
  call sic_upper(in)
  out = strout
  call sic_upper(out)
  !
  code = ''
  do i=1,no
    code(i:i) = char(ichar('0')+index(in,out(i:i)))
  enddo
  !
  call transpose_check(code,error)
  if (error)  goto 100
  return
  !
  ! Error
100 continue
  call gmath_message(seve%e,rname,  &
    'Could not transpose '//trim(strin)//' to '//strout)
  error = .true.
  return
  !
end subroutine transpose_getcode
!
subroutine transpose_getorder(code,itr,mdims,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>transpose_getorder
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  ! Decode transposition code into an index of axis orders
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: code        ! Transposition code
  integer(kind=4),  intent(in)    :: mdims       ! Maximum number of dimensions
  integer(kind=4),  intent(out)   :: itr(mdims)  ! Transposition index array
  logical,          intent(inout) :: error       ! Error flag
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: n
  !
  if (mdims.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Unsupported number of dimensions')
    error = .true.
    return
  endif
  !
  call transpose_check(code,error)
  if (error)  return
  !
  ! Find transposition code
  itr(:) = 0
  read (code,'(7I1)',iostat=n) itr(1:len_trim(code))
  if (n.ne.0) then
    call gmath_message(seve%e,rname,'Invalid transposition '//code)
    call putios('E-TRANSPOSE,  ',n)
    error = .true.
    return
  endif
  !
end subroutine transpose_getorder
!
subroutine transpose_check(code,error)
  use gmath_interfaces, except_this=>transpose_check
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  ! Check that the input code is correct, i.e. check:
  !  - code too large (unsupported number of dimensions)
  !  - illegal characters (e.g. letters)
  !  - correct numbering (each dimension must be present once and only
  !    once)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: code   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: nc,ic,p1,p2
  !
  nc = len_trim(code)
  if (nc.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Too many dimensions in transposition code '//code)
    error = .true.
    return
  endif
  !
  p1 = 1
  p2 = 1
  do ic=1,nc
    p1 = p1*ic
    p2 = p2*index(code,char(ic+ichar('0')))
  enddo
  !
  if (p1.ne.p2) then
    call gmath_message(seve%e,rname,'Invalid transposition code '//code)
    error = .true.
    return
  endif
  !
end subroutine transpose_check
!
subroutine transpose_getblock(idim,ndims,code,block,error)
  use gildas_def
  use gmath_interfaces, except_this=>transpose_getblock
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  !  Repack the transposition order into a general case of the following form:
  !      unchanged, swap1,  unchanged, swap2,   unchanged
  !      Nelems,    Nfirst, Nmiddle,   Nsecond, Nlast
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndims        ! Effective or maximum number of dimensions
  integer(kind=index_length), intent(in)    :: idim(ndims)  ! Array dimensions
  character(len=*),           intent(in)    :: code         ! Transposition code
  integer(kind=index_length), intent(out)   :: block(5)     ! Resulting transposition pack
  logical,                    intent(inout) :: error        ! Error flag
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: repack(5),id,fd
  integer(kind=index_length) :: dims(tr_maxdims)
  integer(kind=index_length) :: nelems,nfirst,nmiddle,nsecon,nlast
  character(len=tr_maxdims) :: start,goal
  !
  if (ndims.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Unsupported number of dimensions')
    error = .true.
    return
  endif
  !
  do id=1,ndims
    dims(id) = max(1,idim(id))
  enddo
  do id = ndims+1,tr_maxdims
    dims(id) = 1
  enddo
  !
  start = '1234567'
  goal  = start
  goal(1:len_trim(code)) = trim(code)
  if (start.eq.goal) then
    ! The subsequent optimizations will only perform a r4tor4
    call gmath_message(seve%w,rname,'No transposition here: '//code)
  endif
  !
  call transpose_repack(start,goal,repack)
  !
  if (start.ne.goal) then
    ! 'start' has been updated on return but does not yet match the goal
    ! Several permutations are not yet implemented
    call gmath_message(seve%e,rname,  &
      'Not implemented: more than 1 permutation needed for '//code)
    call transpose_guess(code)
    error = .true.
    return
  endif
  !
  nelems = 1
  fd = 1
  do id=fd,fd+repack(1)-1
    nelems = nelems*dims(id)
  enddo
  !
  nfirst = 1
  fd = fd+repack(1)
  do id=fd,fd+repack(2)-1
    nfirst = nfirst*dims(id)
  enddo
  !
  nmiddle = 1
  fd = fd+repack(2)
  do id=fd,fd+repack(3)-1
    nmiddle = nmiddle*dims(id)
  enddo
  !
  nsecon = 1
  fd = fd+repack(3)
  do id=fd,fd+repack(4)-1
    nsecon = nsecon*dims(id)
  enddo
  !
  nlast = 1
  fd = fd+repack(4)
  do id=fd,fd+repack(5)-1
    nlast = nlast*dims(id)
  enddo
  !
  block(1) = nelems
  block(2) = nfirst
  block(3) = nmiddle
  block(4) = nsecon
  block(5) = nlast
  !
end subroutine transpose_getblock
!
subroutine transpose_repack(start,goal,repack)
  use gmath_interfaces, except_this=>transpose_repack
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !   Compute the repack array for the 'goal' starting from 'start'
  !   Note that there is no assumption on the order of the start code
  ! (in particular you can not assume it is '1234567'). This is a
  ! desired feature to call consecutively this subroutine to achieve the
  ! goal in several steps.
  !   Note also that there no assumption on the characters it contains,
  ! e.g. if you plan to modify this code, think on what should be done
  ! if start='baefdcg' and goal='bedgafc'
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: start      ! Updated on return
  character(len=*), intent(in)    :: goal       !
  integer(kind=4),  intent(out)   :: repack(5)  ! How the dimensions should be packed
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  character(len=tr_maxdims) :: before,swap1,middle,swap2,after
  integer(kind=4) :: poss,posg,l1,l2
  character(len=message_length) :: mess
  !
  ! If no permutation, repack everything in the 1st (unchanged) group
  repack(:) = (/ tr_maxdims,0,0,0,0 /)
  !
  ! Find where the difference starts
  do posg=1,tr_maxdims
    if (goal(posg:posg).ne.start(posg:posg))  exit
  enddo
  if (posg.ge.tr_maxdims)  return  ! start == goal, nothing to do
  !
  ! Find the pattern to swap (swap2), its length, and its position in 'start'
  swap2 = goal(posg:)
  do
    l2 = len_trim(swap2)
    poss = index(start,swap2(1:l2))
    if (poss.ne.0)  exit
    swap2(l2:l2) = ' '
  enddo
  !
  ! Find swap1 and middle
  swap1  = start(posg:poss-1)  ! This is swap1+middle: we have to separate them cleverly...
  middle = ''
  do
    l1 = len_trim(swap1)
    if (index(goal(posg+l2:),swap1(1:l1)).ne.0)  exit
    middle = swap1(l1:l1)//middle
    swap1(l1:l1) = ' '
  enddo
  !
  ! And finally find the boundaries
  before = start(1:posg-1)
  after  = start(poss+l2:)
  !
  write(mess,100)  &
    trim(before),trim(swap1),trim(middle),trim(swap2),trim(after),  &
    ' -> ',                                                         &
    trim(before),trim(swap2),trim(middle),trim(swap1),trim(after)
  call gmath_message(seve%d,rname,mess)
  !
  start = trim(before)//trim(swap2)//trim(middle)//trim(swap1)//trim(after)
  !
  ! Set the repack array
  repack(1) = len_trim(before)
  repack(2) = len_trim(swap1)
  repack(3) = len_trim(middle)
  repack(4) = len_trim(swap2)
  repack(5) = len_trim(after)
  ! write(*,'(5(I2))')  repack(:)
  !
100 format( 2 ('(',A,')', '[',A,']', '(',A,')', '[',A,']', '(',A,')', A))
end subroutine transpose_repack
!
subroutine transpose_guess(code)
  use gmath_interfaces, except_this=>transpose_guess
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  Give users the serie of permutations needed to achieve the goal.
  ! Note that each user permutation must be given from '1234567' to
  ! 'intermediate-goal', e.g. 2143 = 2134 + 1243
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: code
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  character(len=tr_maxdims) :: start,goal,interm
  integer(kind=4) :: nt,nd,repack(5)
  character(len=message_length) :: mess
  !
  nd = len_trim(code)
  start = '1234567'
  goal  = start
  goal(1:nd) = trim(code)
  nt = 0
  !
  call gmath_message(seve%i,rname,'Transpositions needed to achieve '//trim(code)//':')
  do while (start.ne.goal)
    nt = nt+1
    call transpose_repack(start,goal,repack)
    !
    call transposition_repack_to_code(repack,interm)
    write(mess,'(A,I0,A,A)')  '  #',nt,': ',interm(1:nd)
    call gmath_message(seve%r,rname,mess)
  enddo
  !
end subroutine transpose_guess
!
subroutine transposition_repack_to_code(repack,code)
  use gmath_interfaces, except_this=>transposition_repack_to_code
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  Generate the transposition code from the repack array
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: repack(5)  !
  character(len=*), intent(out) :: code       !
  ! Local
  integer(kind=4) :: id,fd
  character(len=tr_maxdims) :: before,swap1,middle,swap2,after
  !
  before = ''
  fd = 1
  do id=fd,fd+repack(1)-1
    before = trim(before)//char(id+ichar('0'))
  enddo
  !
  swap1 = ''
  fd = fd+repack(1)
  do id=fd,fd+repack(2)-1
    swap1 = trim(swap1)//char(id+ichar('0'))
  enddo
  !
  middle = ''
  fd = fd+repack(2)
  do id=fd,fd+repack(3)-1
    middle = trim(middle)//char(id+ichar('0'))
  enddo
  !
  swap2 = ''
  fd = fd+repack(3)
  do id=fd,fd+repack(4)-1
    swap2 = trim(swap2)//char(id+ichar('0'))
  enddo
  !
  after = ''
  fd = fd+repack(4)
  do id=fd,fd+repack(5)-1
    after = trim(after)//char(id+ichar('0'))
  enddo
  !
  code = trim(before)//trim(swap2)//trim(middle)//trim(swap1)//trim(after)
  !
end subroutine transposition_repack_to_code
!
subroutine trans4all(x,y,nb,n1,nm,n2,nl)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Swap the 2nd and 4th dimension among the 5 ones.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nb                 !
  integer(kind=index_length), intent(in)  :: n1                 !
  integer(kind=index_length), intent(in)  :: nm                 !
  integer(kind=index_length), intent(in)  :: n2                 !
  integer(kind=index_length), intent(in)  :: nl                 !
  real(kind=4),               intent(out) :: x(nb,n2,nm,n1,nl)  !
  real(kind=4),               intent(in)  :: y(nb,n1,nm,n2,nl)  !
  ! Local
  integer(kind=index_length) :: i,j,k,l,m
  !
  do k=1,nl
    do j=1,n2
      do m=1,nm
        do i=1,n1
          do l=1,nb
            x(l,j,m,i,k) = y(l,i,m,j,k)
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine trans4all
!
subroutine trans4(in,ou,nelems,nx,nm,ny)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Swap the 2nd and 4th dimension among the 4 ones.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nelems               !
  integer(kind=index_length), intent(in)  :: nx                   !
  integer(kind=index_length), intent(in)  :: nm                   !
  integer(kind=index_length), intent(in)  :: ny                   !
  real(kind=4),               intent(in)  :: in(nelems,nx,nm,ny)  !
  real(kind=4),               intent(out) :: ou(nelems,ny,nm,nx)  !
  ! Local
  integer(kind=index_length) :: i,j,l,m
  !
  do j=1,ny
    do m=1,nm
      do i=1,nx
        do l=1,nelems
          ou(l,j,m,i) = in(l,i,m,j)
        enddo
      enddo
    enddo
  enddo
end subroutine trans4
!
subroutine trans4slice(nelems,nfirst,nmiddl,nsecon,in,kin,lin,ou,kou,lou)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Swap the 2nd and 4th dimension among the 4 ones, for the slices
  ! [kin:lin] in 'nsecon' and [kou:lou] in 'nfirst'.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nelems                      !
  integer(kind=index_length), intent(in)  :: nfirst                      !
  integer(kind=index_length), intent(in)  :: nmiddl                      !
  integer(kind=index_length), intent(in)  :: nsecon                      !
  integer(kind=index_length), intent(in)  :: kin,lin                     !
  integer(kind=index_length), intent(in)  :: kou,lou                     !
  real(kind=4),               intent(in)  :: in(nelems,nfirst,nmiddl,*)  !
  real(kind=4),               intent(out) :: ou(nelems,nsecon,nmiddl,*)  !
  ! Local
  integer(kind=index_length) :: ibig,jbig,iou,jin,l,m
  !
  do iou=1,lou-kou+1           ! Size of output array
    ibig = iou+kou-1
    do jin=1,lin-kin+1         ! Size of input array
      jbig = jin+kin-1
      do m=1,nmiddl
        do l=1,nelems
          ou(l,jbig,m,iou) = in(l,ibig,m,jin)
        enddo
      enddo
    enddo
  enddo
end subroutine trans4slice
!
subroutine trans8all(x,y,nb,n1,nm,n2,nl)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Swap the 2nd and 4th dimension among the 5 ones.
  ! This version for 8-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nb                 !
  integer(kind=index_length), intent(in)  :: n1                 !
  integer(kind=index_length), intent(in)  :: nm                 !
  integer(kind=index_length), intent(in)  :: n2                 !
  integer(kind=index_length), intent(in)  :: nl                 !
  real(kind=8),               intent(out) :: x(nb,n2,nm,n1,nl)  !
  real(kind=8),               intent(in)  :: y(nb,n1,nm,n2,nl)  !
  ! Local
  integer(kind=index_length) :: i,j,k,l,m
  !
  do k=1,nl
    do j=1,n2
      do m=1,nm
        do i=1,n1
          do l=1,nb
            x(l,j,m,i,k) = y(l,i,m,j,k)
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine trans8all

module astro_pfx_types
  !
  public
  private :: pfx_reallocate,pfx_free
  !
  integer(kind=4), parameter :: m_backmodes=10  !max number of units for a given backend
  integer(kind=4), parameter :: m_ch=128        !max number of chunks (fix or flexible)
  integer(kind=4), parameter :: m_chtypes=10    !max number of chunk types
  integer(kind=4), parameter :: m_typecol=3
  !
  type pfx_type_t
    character(len=50)   :: typename
    character(len=16)   :: itypecol(m_typecol)      ! color name (1=filled, 2 =hatched, 3 =border)
    logical(kind=4)     :: move_chunk   !
    integer(kind=4)     :: n_chunks     ! number of existing chunks of this type / unit
    integer(kind=4)     :: use_chunks     ! number of chunks that can be used/ unit
    integer(kind=4)     :: usage ! number of chunks configured
    real(kind=8)        :: df_chunks    ! resolution of chunks
    real(kind=8)        :: width_chunk  ! spacing of the chunks
    real(kind=8)        :: if2ch0      ! first position in grid of chunks
    integer(kind=4)     :: chunks(m_ch) !chunk usage (=0 => unused, >0 => used)
  end type pfx_type_t
  !
  type pfx_mode_t
    !describe a polyfix mode
    character(len=50)   :: backname             ! backend name
    character(len=50)   :: modename             ! mode name
    integer(kind=4)     :: n_types          ! number of type of chunks (e.g. hi and low res = 2)
    type(pfx_type_t)    :: chtype(m_chtypes)
  end type pfx_mode_t
  !
  type pfx_unit_t
    integer(kind=4)     :: iband    ! receiver processed by unit
    integer(kind=4)     :: sb_code   ! sideband processed by unit
    integer(kind=4)     :: bb_code   ! baseband processed by unit
    integer(kind=4)     :: pol_code  ! polar processed by unit
    character(len=5)    :: label     !
    integer(kind=4)     :: n_modes   ! number of existing modes
    integer(kind=4)     :: imode      ! used mode
    type(pfx_mode_t)    :: mode(m_backmodes)
  end type pfx_unit_t
  !
  type pfx_t
    character(len=50) :: name
    real(kind=8)      :: if2lim(2) ! IF2 limits of the signal processed by the unit
    integer(kind=4)   :: n_units
    type(pfx_unit_t), allocatable  :: unit(:)
  contains
    procedure, public :: free => pfx_free
    procedure, public :: reallocate => pfx_reallocate
    procedure, public :: getmode => pfx_getmode
  end type pfx_t
  !
contains
  subroutine pfx_reallocate(pfx,n_units,error)
    use gkernel_interfaces
    ! Reallocate pfx%unit if needed
    class(pfx_t), intent(inout) :: pfx
    integer(kind=4), intent(in) :: n_units
    logical, intent(inout)      :: error
    !
    character(len=*), parameter :: rname='PFX>REALLOCATE'
    integer(kind=4) :: ier
    ! First deallocate if needed
    call pfx%free(error)
    if (error) return
    ! Allocate to right size
    allocate(pfx%unit(n_units),stat=ier)
    if (failed_allocate(rname,'PFX units',ier,error))  return
    !
    pfx%n_units=n_units
    !
  end subroutine pfx_reallocate
  !
  subroutine pfx_free(pfx,error)
    ! Deallocate pfx%unit
    class(pfx_t), intent(inout) :: pfx
    logical, intent(inout)      :: error
    !
    if (allocated(pfx%unit)) deallocate(pfx%unit)
    !
  end subroutine pfx_free
  !
  subroutine pfx_getmode(pfx,amode,error)
    use gbl_message
    ! Get the mode of pfx
    class(pfx_t), intent(inout) :: pfx
    character(len=*), intent(inout) :: amode
    logical, intent(inout)      :: error
    ! Local
    character(len=*), parameter :: rname='PFX>GETMODE'
    integer(kind=4) :: iu,im,nm,modes(m_backmodes)
    !
    nm=0
    do im=1,m_backmodes
      modes(im)=0
    enddo
    do iu=1,pfx%n_units
      if (pfx%unit(iu)%imode.eq.-1) cycle
      im=pfx%unit(iu)%imode
      modes(im)=modes(im)+1
    enddo
    !
    do im=1,m_backmodes
      if (modes(im).eq.0) cycle
      nm=nm+1
    enddo
    im=0
    if (nm.le.0) then
      call astro_message(seve%e,rname,'No mode defined')
      error=.true.
      return
    else if (nm.eq.1) then
      do iu=1,pfx%n_units
        if (pfx%unit(iu)%imode.gt.0) then
          im=pfx%unit(iu)%imode
          amode=pfx%unit(iu)%mode(im)%modename
          exit
        endif
      enddo
    else
      amode='MultiMode'
    endif
    !
  end subroutine pfx_getmode
  !
end module astro_pfx_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_parameters
  !--- Type lengths ---------------------------------------------------
  use gildas_def
  use gbl_message
  integer(kind=4), parameter :: inte_k=4            ! [integer] Generic integer*4
  integer(kind=4), parameter :: long_k=8            ! [integer] Generic integer*8
  integer(kind=4), parameter :: argu_k=4            ! [integer] Argument
  integer(kind=4), parameter :: code_k=4            ! [integer] Codes
  integer(kind=4), parameter :: ndim_k=4            ! [integer] Number of dimensions
  integer(kind=4), parameter :: wind_k=4            ! [integer] Number of windows
  integer(kind=4), parameter :: rang_k=4            ! [integer] Number of ranges
  integer(kind=4), parameter :: indx_k=index_length ! [integer] Index (either pixel or channel)
  integer(kind=4), parameter :: entr_k=indx_k       ! [integer] Entry
  integer(kind=4), parameter :: chan_k=indx_k       ! [integer] Channel
  integer(kind=4), parameter :: pixe_k=indx_k       ! [integer] Pixel
  integer(kind=4), parameter :: data_k=size_length  ! [integer] Data
  !
  integer(kind=4), parameter :: real_k=4 ! [real] Generic real*4
  integer(kind=4), parameter :: dble_k=8 ! [real] Generic real*8
  integer(kind=4), parameter :: sign_k=4 ! [real] Signal
  integer(kind=4), parameter :: equi_k=4 ! [real] Equinox
  integer(kind=4), parameter :: beam_k=4 ! [real] Resolution
  integer(kind=4), parameter :: coor_k=8 ! [real] Coordinate
  integer(kind=4), parameter :: tole_k=8 ! [real] Consistency tolerance
  !
  integer(kind=4), parameter :: strg_l=64                 ! [character] For string arrays
  integer(kind=4), parameter :: clin_l=commandline_length ! [character] Command line
  integer(kind=4), parameter :: varn_l=varname_length     ! [character] Variable name
  integer(kind=4), parameter :: mess_l=message_length     ! [character] Message
  integer(kind=4), parameter :: file_l=filename_length    ! [character] Directory or full path to files
  integer(kind=4), parameter :: base_l=128                ! [character] File base name or name+extension (w/o path)
  integer(kind=4), parameter :: exte_l=32                 ! [character] File name extension
  integer(kind=4), parameter :: argu_l=64                 ! [character] Argument
  integer(kind=4), parameter :: unit_l=12                 ! [character] Unit 
  integer(kind=4), parameter :: line_l=12                 ! [character] Line 
  integer(kind=4), parameter :: fram_l=12                 ! [character] Spatial or spectral Frame 
  integer(kind=4), parameter :: sour_l=12                 ! [character] Source
  integer(kind=4), parameter :: tele_l=12                 ! [character] Telescope name
  integer(kind=4), parameter :: sexa_l=12                 ! [character] Sexagesimal length
  integer(kind=4), parameter :: conv_l=12                 ! [character] Convention length
  integer(kind=4), parameter :: tagn_l=12                 ! [character] tagname length
  integer(kind=4), parameter :: name_l=16                 ! [character] array name
  integer(kind=4), parameter :: trop_l=3                  ! [character] Transposition operator
  !
  ! --- unknown -------------------------------------------------------
  character(len=*), parameter :: blankstr = ''
  character(len=*), parameter :: strg_unk = 'Unknown'
  character(len=*), parameter :: strg_emp = 'Empty'
  character(len=1), parameter :: strg_cr = char(10)  ! ASCII carriage return
  character(len=*), parameter :: strg_bl = strg_cr//strg_cr  ! Blank line helper
  integer(kind=code_k),  parameter :: code_unk = 0
  integer(kind=code_k),  parameter :: code_abs = -1
  !
  ! --- Velocity convention ------------------------------------------
  integer(kind=code_k), parameter :: code_rad = 1
  integer(kind=code_k), parameter :: code_opt = 2  
  !
  ! --- Dimensions ----------------------------------------------------
  integer(kind=ndim_k), parameter :: maxdim = 7
  integer(kind=indx_k), parameter :: code_indx_auto = huge(0_indx_k)  ! Flag for uninitialized/automatic index
  !
  ! --- Convert orders ------------------------------------------------
  integer(kind=code_k), parameter :: code_ref = 1
  integer(kind=code_k), parameter :: code_val = 2
  integer(kind=code_k), parameter :: code_inc = 3
  !
  ! --- Axis types -----------------------------------------------------
  integer(kind=code_k), parameter :: code_spa = 1
  integer(kind=code_k), parameter :: code_vel = 2
  integer(kind=code_k), parameter :: code_fre = 3
  !
  ! --- Cube orders (intrinsic data order) -----------------------------
  integer(code_k), parameter :: code_cube_unkset=100   ! Unknown cube set
  integer(code_k), parameter :: code_cube_imaset=101   ! e.g. .lmv
  integer(code_k), parameter :: code_cube_speset=102   ! e.g. .vlm
  integer(code_k), parameter :: code_table_imaset=103  ! e.g. .bat
  integer(code_k), parameter :: code_table_speset=104  ! e.g. .tab
  !
  ! --- Access modes (programmer requested accesses) -------------------
  integer(code_k), parameter :: code_access_imaset=code_cube_imaset
  integer(code_k), parameter :: code_access_speset=code_cube_speset
  integer(code_k), parameter :: code_access_subset=203            ! Sub-cubes (order does not matter)
  integer(code_k), parameter :: code_access_blobset=204           ! Collection of bits (order does not matter)
  integer(code_k), parameter :: code_access_fullset=205           ! Full cubes (order does not matter)
  ! Aliases resolved depending on the cube or user at runtime:
  integer(code_k), parameter :: code_access_imaset_or_speset=206  ! Any of the 2 unambiguous orders (imaset/speset)
  integer(code_k), parameter :: code_access_any=207               ! Any of the 3 basic orders (imaset/speset/unkset)
  integer(code_k), parameter :: code_access_user=208              ! Access resolved from context e.g. user inputs
  !
  ! --- Actions --------------------------------------------------------
  ! Read codes (for old cubes). Order matters.
  integer(code_k), parameter :: code_read_none = 10  ! Nothing needed
  integer(code_k), parameter :: code_read_head = 11  ! Header only
  integer(code_k), parameter :: code_read      = 12  ! Header + data
  integer(code_k), parameter :: code_update    = 13  ! Header + data in read-write
  ! Write codes (for new cubes)
  integer(code_k), parameter :: code_write     = 20  ! Header + data
  !
  ! --- Data buffering -------------------------------------------------
  integer(kind=4), parameter :: mbuffering = 4
  character(len=*), parameter :: buffering(mbuffering) =  &
    (/ 'AUTO  ','NONE  ','MEMORY','DISK  ' /)
  integer(code_k), parameter :: code_buffer_auto   = 1
  integer(code_k), parameter :: code_buffer_none   = 2
  integer(code_k), parameter :: code_buffer_memory = 3
  integer(code_k), parameter :: code_buffer_disk   = 4
  !
  ! --- Patch Bval/Eval to NaN -----------------------------------------
  integer(kind=4), parameter :: mpatchblank=2
  character(len=*), parameter :: patchblank(mpatchblank) =  &
    (/ 'ERROR     ','ONTHEFLY  ' /)
  integer(code_k), parameter :: code_patchblank_err = 1
  integer(code_k), parameter :: code_patchblank_otf = 2
  !
  ! --- Default index --------------------------------------------------
  integer(kind=4), parameter :: mindex=2
  character(len=*), parameter :: indexname(mindex) =  &
    (/ 'DAG    ','CURRENT' /)
  integer(code_k), parameter :: code_index_dag     = 1
  integer(code_k), parameter :: code_index_current = 2
  !
  ! --- Arguments ------------------------------------------------------
  logical, parameter ::   flexible = .true.
  logical, parameter :: inflexible = .false.
  logical, parameter :: mandatory = .true.
  logical, parameter :: optional  = .false.
  integer(kind=code_k), parameter :: code_arg_mandatory = 1  ! Argument must appear 1 time
  integer(kind=code_k), parameter :: code_arg_optional  = 2  ! Argument can appear 0 or 1 time
  integer(kind=code_k), parameter :: code_arg_unlimited = 3  ! Argument can appear 0 or more times
                                               ! We could add: Argument can appear 1 or more times
  character(len=*), parameter :: arg_status(3) =  &
    (/ 'mandatory','optional ','unlimited' /)
  !
  ! --- Flag modes -----------------------------------------------------
  integer(kind=code_k), parameter :: keep_none=1
  integer(kind=code_k), parameter :: keep_prod=2
  integer(kind=code_k), parameter :: keep_acti=3
  integer(kind=code_k), parameter :: keep_all =4
  !
  ! --- Parsing utility ------------------------------------------------
  logical, parameter :: verbose = .true.
  logical, parameter :: quiet = .true.
  logical, parameter :: overwrite = .true.
  logical, parameter :: global = .true.
  logical, parameter :: local = .true.
  logical, parameter :: readonly = .true.
  integer(kind=4), parameter :: icomm = 0
  character(len=*), parameter :: strg_star  = '*'  ! smart choice
  character(len=*), parameter :: strg_equal = '='  ! Keep previous value
  integer(kind=code_k), parameter :: code_unresolved = -1
  character(len=*), parameter :: strg_unresolved = "UNRESOLVED"
  !
  ! --- Help utility ---------------------------------------------------
  character(len=*), parameter :: strg_id  = 'idem'
  integer(kind=4), parameter :: stdout=6
  !
  integer(kind=code_k), parameter :: help_format_term =0
  integer(kind=code_k), parameter :: help_format_tex  =1
  integer(kind=code_k), parameter :: help_format_flags=2
  integer(kind=4),  parameter :: help_nformats=2
  character(len=*), parameter :: help_formats(help_nformats) = (/ 'TEX  ','FLAGS' /)
  character(len=*), parameter :: help_extensions(help_nformats) = (/ '.tex','.flg' /)
  !
contains
  !
  function access_status(iaccess)
    !-------------------------------------------------------------------
    ! Translate an access code to string
    !-------------------------------------------------------------------
    character(len=13) :: access_status
    integer(kind=code_k), intent(in) :: iaccess
    !
    select case (iaccess)
    case (code_access_imaset)
      access_status = 'imaset'
    case (code_access_speset)
      access_status = 'speset'
    case (code_access_subset)
      access_status = 'subset'
    case (code_access_blobset)
      access_status = 'blobset'
    case (code_access_fullset)
      access_status = 'fullset'
    case (code_access_imaset_or_speset)
      access_status = 'imaset/speset'
    case (code_access_any)
      access_status = 'anyset'
    case (code_access_user)
      ! Most likely it will be solved as imaset or speset at runtime
      access_status = 'imaset/speset'
    case default
      access_status = '???'
    end select
  end function access_status
  !
  function action_status(iaction)
    !-------------------------------------------------------------------
    ! Translate an action code to string
    !-------------------------------------------------------------------
    character(len=6) :: action_status
    integer(kind=code_k), intent(in) :: iaction
    !
    select case (iaction)
    case (code_read_none)
      action_status = 'none'
    case (code_read_head)
      action_status = 'header'
    case (code_read)
      action_status = 'read'
    case (code_write)
      action_status = 'write'
    case (code_update)
      action_status = 'update'
    case default
      action_status = '???'
    end select
  end function action_status
  !
  function cube_dev_mode()
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Return .true. if CUBE is dev mode. Dynamic check as this is not a
    ! compilation-time constant.
    !-------------------------------------------------------------------
    logical :: cube_dev_mode
    character(len=12) :: status
    !
    call sic_getenv('GAG_CUBE_DEV',status)
    cube_dev_mode = status.eq."YES" .or. status.eq."yes"
    !
    ! Could also check for a command-line option or a user variable?
  end function cube_dev_mode
end module cubetools_parameters
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine mrtindex_file_old_byname(indexfile,directory,rw,fileid,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_file_old_byname
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private-generic mrtindex_file_old
  !  Open an 'old' (already existing) index file in the Input indeX
  ! Open or reuse a pre-opened file, and return its identifier in the
  ! list of opened files
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: indexfile  !
  character(len=*), intent(in)    :: directory  !
  logical,          intent(in)    :: rw         ! Open in RW mode?
  integer(kind=4),  intent(out)   :: fileid     !
  logical,          intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='FILE>OLD'
  integer(kind=4) :: lun,ifile,ier
  logical :: fopened
  !
  inquire(file=indexfile,opened=fopened,number=lun,iostat=ier)
  if (ier.ne.0) then
    call putios('E-FILE>OLD,  ',ier)
    error = .true.
    return
  endif
  !
  if (fopened) then
    ! File is Fortran-opened: find it in the index file list
    ! Do not rely on the file name, which is not perfect (case
    ! insensitive filesystems, sym- or hard-links, etc). Use its
    ! logical unit instead (Fortran guarantees it is unique)
    if (ix_opened.eq.0 .or. ix_files(ix_opened)%lun.ne.lun) then
      call mrtindex_message(seve%e,rname,  &
        'Lost my mind: file '//trim(indexfile)//' is Fortran-opened but not in IX')
      error = .true.
      return
    endif
    !
    fileid = ix_opened
    call mrtindex_file_old_byid(fileid,rw,error)
    return  ! Always
    !
  else
    ! File is not Fortran-opened. No better solution than looping on the
    ! file list and comparing their names.
    ! ZZZ Can we improve this file search? e.g. a dichotomic search?
    do ifile=1,ix_ndir
      if (indexfile.eq.ix_files(ifile)%spec) then
        ! We already know this one in our list, just open it
        fileid = ifile
        call mrtindex_file_old_byid(fileid,rw,error)
        return  ! Always
      endif
    enddo
  endif
  !
  ! Else, have to allocate a new one. Make room for referencing (at least)
  ! 1 more file
  call reallocate_ix_dirs(ix_ndir+1,error)
  if (error)  return
  !
  ix_ndir = ix_ndir+1
  fileid = ix_ndir
  ix_dirs(fileid) = directory
  ix_files(fileid)%spec = indexfile
  ix_files(fileid)%nspec = len_trim(indexfile)
  !
  call mrtindex_file_classic_old(fileid,rw,error)
  if (error)  return
  !
end subroutine mrtindex_file_old_byname
!
subroutine mrtindex_file_old_byid(fileid,rw,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_file_old_byid
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private-generic mrtindex_file_old
  !  Open an 'old' (already existing) index file in the Input indeX
  ! Reuse a pre-opened file given its identifier
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: fileid   !
  logical,          intent(in)    :: rw       ! Open in RW mode?
  logical,          intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='FILE>OLD'
  !
  ! Sanity check
  if (fileid.le.0 .or. fileid.gt.ix_ndir) then
    call mrtindex_message(seve%e,rname,'Internal error: no such file')
    error = .true.
    return
  endif
  !
  if (fileid.eq.ix_opened) then
    ! This file is the one currently Fortran-opened
    if (ix_files(fileid)%readwrite .or. .not.rw) then
      ! File is opened in correct mode, nothing to do
      return
    else
      ! Current mode is not enough: must close and reopen it
      continue
    endif
  endif
  !
  ! ZZZ Should we do a full Classic open or just a Fortran open (classic_file_fopen)?
  call mrtindex_file_classic_old(fileid,rw,error)
  if (error)  return
  !
end subroutine mrtindex_file_old_byid
!
subroutine mrtindex_file_update(indexfile,directory,pattern,overwrite,  &
  present,error)
  use gildas_def
  use gbl_message
  use classic_api
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_file_update
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Build/Update (according to overwrite flag) the index file
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: indexfile  !
  character(len=*),     intent(in)    :: directory  !
  type(user_pattern_t), intent(in)    :: pattern    ! Pattern(s) for file(s) to be indexed
  logical,              intent(in)    :: overwrite  !
  logical,              intent(in)    :: present    ! Is it expected to find FITS files?
  logical,              intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='FILE>UPDATE'
  integer(kind=4) :: mfile,nfile,nfile2,ier,fileid,j,gagdate
  character(len=fitsname_length), allocatable :: filelist(:),filelist2(:)
  character(len=imbfits_pattern_length) :: string
  !
  ! Build a single file list
  if (pattern%bylist) then  ! By list of dates
    ! A bit complicated as we have to iterate several file patterns
    !
    ! Need to guess an upper limit for the max number of files in the final
    ! list:
    call gag_directory_num(directory,mfile,error)
    if (error)  return
    allocate(filelist(mfile),stat=ier)
    if (failed_allocate(rname,'file list',ier,error)) return
    !
    nfile = 0
    do j=1,pattern%datelist%nlist
      do gagdate=pattern%datelist%i1(j),pattern%datelist%i2(j),pattern%datelist%i3(j)
        call gag_toyyyymmdd(gagdate,string,error)
        if (error)  return
        call gag_directory(directory,imbfits_name(string),filelist2,nfile2,error)
        if (error)  return
        if (nfile2.gt.0) then
          filelist(nfile+1:nfile+nfile2) = filelist2(1:nfile2)
          nfile = nfile+nfile2
        endif
      enddo
    enddo
  else
    ! Single file pattern
    call gag_directory(directory,pattern%custom,filelist,nfile,error)
    if (error)  return
  endif
  !
  ! And now build the index
  if (nfile.le.0 .and. .not.present) then
    ! Do not create the index file. We want to create it if this directory
    ! is explicitely searched in, but not e.g. in a recursive search.
    return
  endif
  !
  call mrtindex_file_new(indexfile,overwrite,directory,fileid,error)
  if (error)  return
  !
  call mrtindex_index_write(ix_files(fileid),directory,filelist,nfile,error)
  if (error)  continue
  !
  ! Do not keep opened this file, we may be building|updating a large
  ! number
  call mrtindex_file_close(ix_files(fileid),error)
  if (error)  continue
  !
end subroutine mrtindex_file_update
!
subroutine mrtindex_file_new(indexfile,overwrite,directory,fileid,error)
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_file_new
  !---------------------------------------------------------------------
  ! @ private
  !  Open the index file. Create new one if requested or if it does
  ! not exists. Also return its memory identifier.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: indexfile  !
  logical,          intent(in)    :: overwrite  !
  character(len=*), intent(in)    :: directory  ! The directory indexed by the index file
  integer(kind=4),  intent(out)   :: fileid     !
  logical,          intent(inout) :: error      !
  ! Local
  logical :: new
  integer(kind=4) :: nspec
  !
  ! Define the output file
  new = .true.
  nspec = len_trim(indexfile)
  !
  if (gag_inquire(indexfile,nspec).eq.0) then
    ! File exists
    if (overwrite) then
      ! Create a new one from scratch
      call gag_filrm(indexfile)
    else
      new = .false.
    endif
  endif
  !
  if (new) then
    ! File does not exist
    call mrtindex_file_classic_new(indexfile,error)
    if (error)  return
  endif
  !
  ! Update the existing file
  call mrtindex_file_old(indexfile,directory,.true.,fileid,error)
  if (error)  return
  !
end subroutine mrtindex_file_new
!
subroutine mrtindex_file_classic_new(filename,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_file_classic_new
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Create (from a Classic point of view) a new index file
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: filename  !
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE>NEW'
  type(classic_file_t) :: fileout
  integer(kind=entry_length) :: lsize
  logical :: lover,lsingle
  !
  fileout%lun = ox_lun
  fileout%spec = filename
  fileout%nspec = len_trim(filename)
  !
  ! Remove it if requested by user
  lover = .true.
  if (lover .and. gag_inquire(fileout%spec,fileout%nspec).eq.0)  &
    call gag_filrm(fileout%spec(1:fileout%nspec))
  !
  call classic_file_init(fileout,2,8*mrtindex_indx_length,error)
  if (error)  return
  !
  lsingle = .true.
  lsize = 1  ! Ignored if version 2
  call classic_filedesc_init(fileout,classic_kind_mrtcal,lsingle,lsize,  &
    mrtcal_indx_version,mrtindex_indx_length,2.0,error)
  if (error)  return
  !
  call mrtindex_file_close(fileout,error)
  if (error)  return
  !
end subroutine mrtindex_file_classic_new
!
subroutine mrtindex_file_classic_old(fileid,readwrite,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_file_classic_old
  use mrtindex_messaging
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: fileid     !
  logical,          intent(in)    :: readwrite  !
  logical,          intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='FILE>OLD'
  !
  if (fileid.le.0 .or. fileid.gt.ix_ndir) then
    call mrtindex_message(seve%e,rname,'Internal error: no such file')
    error = .true.
    return
  endif
  !
  ! Close the one which is opened (we ensure there is only one, by design)
  if (ix_opened.ne.0) then
    ! NB: ix_opened and fileid may be equal. In this case, this means we
    ! close and reopen the same file, but maybe with a different access
    ! (e.g. read -> readwrite) mode.
    call mrtindex_file_close(ix_files(ix_opened),error)
    if (error)  return
  endif
  !
  ix_files(fileid)%lun = ix_lun
  call classic_file_open(ix_files(fileid),readwrite,error)
  if (error)  return
  !
  ix_opened = fileid
  !
  call classic_filedesc_open(ix_files(fileid),error)
  if (error)  return
  !
  ! As of today there is only one version supported
  if (ix_files(fileid)%desc%vind.gt.mrtcal_indx_version) then
    call mrtindex_message(seve%e,rname,'This version of index.mrt is too recent')
    call mrtindex_message(seve%e,rname,'Please update your version of Mrtcal')
    error = .true.
    return
  endif
  !
  ! Resize input buffers for this Classic file records
  ! ZZZ One set of buffers per file?
  call reallocate_index_ibuf(ix_files(fileid),error)
  if (error)  return
  if (readwrite) then
    ! Also for output buffers in this case
    call reallocate_index_obuf(ix_files(fileid),error)
    if (error)  return
  endif
  !
  call mrtindex_message(iseve%others,rname,  &
    trim(ix_files(fileid)%spec)//' successfully opened')
  !
end subroutine mrtindex_file_classic_old
!
subroutine mrtindex_file_close(file,error)
  use gkernel_interfaces
  use classic_api
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file
  logical,              intent(inout) :: error
  !
  call classic_file_close(file,error)
  if (error)  continue
  !
  if (ix_opened.ne.0) then
    if (ix_files(ix_opened)%lun.eq.file%lun)  ix_opened = 0
  endif
  !
  file%lun = 0
  !
end subroutine mrtindex_file_close

module classic_interfaces_public
  interface
    subroutine classic_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: id         !
    end subroutine classic_message_set_id
  end interface
  !
  interface
    subroutine classic_init(error)
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      !  Initialize the Classic library. This should be done only once at
      ! startup. The library will refuse opening a Classic file as long
      ! as this has not been done.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine classic_init
  end interface
  !
  interface
    subroutine classic_entry_init(file,xnum,maxsec,version,full,ed,error)
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      ! Initialize the Entry for a new observation
      !---------------------------------------------------------------------
      type(classic_file_t),       intent(inout) :: file     !
      integer(kind=entry_length), intent(in)    :: xnum     ! The corresponding Entry number
      integer(kind=4),            intent(in)    :: maxsec   ! Maximum number of sections the ed can describe
      integer(kind=4),            intent(in)    :: version  ! Observation version
      logical,                    intent(out)   :: full     ! File is full?
      type(classic_entrydesc_t),  intent(out)   :: ed       ! The new Entry Descriptor
      logical,                    intent(inout) :: error    ! Logical error flag
    end subroutine classic_entry_init
  end interface
  !
  interface
    subroutine classic_entry_section_read(isec,lsec,sec,ed,buf,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Read a section from an entry
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: isec    ! Section id
      integer(kind=data_length), intent(inout) :: lsec    ! Length of section (updated on return)
      integer(kind=4),           intent(inout) :: sec(*)  ! Section buffer
      type(classic_entrydesc_t), intent(in)    :: ed      ! The Entry Descriptor
      type(classic_recordbuf_t), intent(inout) :: buf     ! Working buffer
      logical,                   intent(inout) :: error   ! Logical error flag
    end subroutine classic_entry_section_read
  end interface
  !
  interface
    subroutine classic_entry_data_read(array,ndata,ed,buf,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Read the 'data' block from the entry
      !---------------------------------------------------------------------
      integer(kind=data_length), intent(inout) :: ndata         ! Length in 32_bit words (updated)
      real(kind=4),              intent(out)   :: array(ndata)  ! Data itself
      type(classic_entrydesc_t), intent(in)    :: ed            ! The Entry Descriptor
      type(classic_recordbuf_t), intent(inout) :: buf           ! Working buffer
      logical,                   intent(inout) :: error         ! Logical error flag
    end subroutine classic_entry_data_read
  end interface
  !
  interface
    subroutine classic_entry_data_readsub(array,ndata,first,last,ed,buf,error)
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Read a subset of the 'data' block from the entry
      !---------------------------------------------------------------------
      integer(kind=data_length), intent(inout) :: ndata         ! Length in 32_bit words (updated)
      real(kind=4),              intent(out)   :: array(ndata)  ! Data itself
      integer(kind=data_length), intent(in)    :: first         ! First data word to read
      integer(kind=data_length), intent(in)    :: last          ! Last data word to read
      type(classic_entrydesc_t), intent(in)    :: ed            ! The Entry Descriptor
      type(classic_recordbuf_t), intent(inout) :: buf           ! Working buffer
      logical,                   intent(inout) :: error         ! Logical error flag
    end subroutine classic_entry_data_readsub
  end interface
  !
  interface
    subroutine classic_entry_section_add(isec,lsec,sec,ed,buf,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Add a new section to an entry. Must not exist before.
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: isec    ! Section id
      integer(kind=data_length), intent(in)    :: lsec    ! Length of section
      integer(kind=4),           intent(in)    :: sec(*)  ! Section buffer
      type(classic_entrydesc_t), intent(inout) :: ed      ! The Entry Descriptor
      type(classic_recordbuf_t), intent(inout) :: buf     ! Working buffer
      logical,                   intent(inout) :: error   ! Logical error flag
    end subroutine classic_entry_section_add
  end interface
  !
  interface
    subroutine classic_entry_section_update(isec,lsec,sec,ed,buf,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Update an old section in an entry. Must exist before.
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: isec    ! Section id
      integer(kind=data_length), intent(in)    :: lsec    ! Length of section
      integer(kind=4),           intent(in)    :: sec(*)  ! Section buffer
      type(classic_entrydesc_t), intent(in)    :: ed      ! The Entry Descriptor
      type(classic_recordbuf_t), intent(inout) :: buf     ! Working buffer
      logical,                   intent(inout) :: error   ! Logical error flag
    end subroutine classic_entry_section_update
  end interface
  !
  interface
    subroutine classic_entry_data_add(array,ndata,ed,buf,error)
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Write the 'data' block to the entry. Must not exist before.
      !---------------------------------------------------------------------
      integer(kind=data_length), intent(in)    :: ndata         ! Length in 32_bit words
      real(kind=4),              intent(in)    :: array(ndata)  ! Data itself
      type(classic_entrydesc_t), intent(inout) :: ed            ! The Entry Descriptor
      type(classic_recordbuf_t), intent(inout) :: buf           ! Working buffer
      logical,                   intent(inout) :: error         ! Logical error flag
    end subroutine classic_entry_data_add
  end interface
  !
  interface
    subroutine classic_entry_data_update(array,ndata,ed,buf,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Update the 'data' block to the entry. Must exist before.
      !---------------------------------------------------------------------
      integer(kind=data_length), intent(in)    :: ndata         ! Length in 32_bit words
      real(kind=4),              intent(in)    :: array(ndata)  ! Data itself
      type(classic_entrydesc_t), intent(inout) :: ed            ! The Entry Descriptor
      type(classic_recordbuf_t), intent(inout) :: buf           ! Working buffer
      logical,                   intent(inout) :: error         ! Logical error flag
    end subroutine classic_entry_data_update
  end interface
  !
  interface
    subroutine classic_entry_close(file,buf,error)
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Perform the needed operations when all the entry elements have
      ! been written.
      !---------------------------------------------------------------------
      type(classic_file_t),      intent(inout) :: file   !
      type(classic_recordbuf_t), intent(in)    :: buf    !
      logical,                   intent(inout) :: error  !
    end subroutine classic_entry_close
  end interface
  !
  interface
    subroutine classic_entrydesc_read(file,buf,ed,error)
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      !   Read the Entry Descriptor
      !---------------------------------------------------------------------
      type(classic_file_t),      intent(in)    :: file   !
      type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
      type(classic_entrydesc_t), intent(inout) :: ed     ! The Entry Descriptor read
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine classic_entrydesc_read
  end interface
  !
  interface
    subroutine classic_entrydesc_write(file,buf,ed,error)
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      !   Write the input Entry Descriptor
      !---------------------------------------------------------------------
      type(classic_file_t),      intent(inout) :: file   !
      type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
      type(classic_entrydesc_t), intent(in)    :: ed     ! The Entry Descriptor to be written
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine classic_entrydesc_write
  end interface
  !
  interface
    function classic_entrydesc_seclen(ed,iden)
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      ! Return the length of the identified section (or 0 if missing).
      ! Unefficient if you call each section one by one.
      !---------------------------------------------------------------------
      integer(kind=4) :: classic_entrydesc_seclen
      type(classic_entrydesc_t), intent(in)  :: ed    ! The Entry Descriptor
      integer(kind=4),           intent(in)  :: iden  ! The section identifier
    end function classic_entrydesc_seclen
  end interface
  !
  interface
    subroutine classic_entrydesc_secfind_one(ed,iden,found,num)
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Find if 1 section is present in the input Entry Descriptor.
      ! Inefficient if you test each section one by one.
      !---------------------------------------------------------------------
      type(classic_entrydesc_t), intent(in)  :: ed     ! The Entry Descriptor
      integer(kind=4),           intent(in)  :: iden   ! The section identifier
      logical,                   intent(out) :: found  ! Section was found or not?
      integer(kind=4),           intent(out) :: num    ! The section number (if found)
    end subroutine classic_entrydesc_secfind_one
  end interface
  !
  interface
    subroutine classic_entrydesc_secfind_all(ed,found,first,error)
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !   Fill a 'found' array for all sections present or not. This assumes
      ! that the section identifiers (seciden(:) values) can be used as
      ! position index (maybe with an offset) in the 'found' array.
      !---------------------------------------------------------------------
      type(classic_entrydesc_t), intent(in)    :: ed        ! The Entry Descriptor
      logical,                   intent(out)   :: found(:)  ! Sections were found or not?
      integer(kind=4),           intent(in)    :: first     ! First index in the array (offset)
      logical,                   intent(inout) :: error     ! Logical error flag
    end subroutine classic_entrydesc_secfind_all
  end interface
  !
  interface
    subroutine classic_entrydesc_dump(ed)
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Dump the input Entry Descriptor
      !---------------------------------------------------------------------
      type(classic_entrydesc_t), intent(in) :: ed  ! The Entry Descriptor
    end subroutine classic_entrydesc_dump
  end interface
  !
  interface
    subroutine classic_filedesc_init(file,fkind,lsingle,lsize,vind,lind,gex,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      !   Initialize a new File Descriptor.
      !   The following elements must have been set before:
      !       file%lun, file%spec, file%nspec
      !   On return, those are set:
      !       file%desc, file%conv
      !---------------------------------------------------------------------
      type(classic_file_t),       intent(inout) :: file     !
      integer(kind=4),            intent(in)    :: fkind    ! File kind
      logical,                    intent(in)    :: lsingle  ! Single or multiple
      integer(kind=entry_length), intent(in)    :: lsize    ! Total number of entries (linear growth)
      integer(kind=4),            intent(in)    :: vind     ! Index version
      integer(kind=4),            intent(in)    :: lind     ! Index length (words)
      real(kind=4),               intent(in)    :: gex      ! Extension growth
      logical,                    intent(inout) :: error    ! Logical error flag
    end subroutine classic_filedesc_init
  end interface
  !
  interface
    subroutine classic_filedesc_open(file,error)
      use gbl_message
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      ! Open and read the File Descriptor, namely:
      ! - Get the File Code and set the File-Data-Type-to-System-Data-Type
      !   conversion code,
      ! - Read the File Descriptor from the file, and take care of the
      !   possible conversion.
      ! Fortran-open the file itself if needed.
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file   !
      logical,              intent(out)   :: error  ! Logical error flag
    end subroutine classic_filedesc_open
  end interface
  !
  interface
    subroutine classic_filedesc_read(file,error)
      use gbl_message
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      !   Read the File Descriptor from the file, and take care of the
      ! possible conversion. The file itself must have been opened before.
      ! The conversion code is not reevaluated.
      !   It may be useful to re-read a File Descriptor because another
      ! program might have updated it since last classic_filedesc_open or
      ! classic_filedesc_read.
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file   !
      logical,              intent(inout) :: error  ! Logical error flag
    end subroutine classic_filedesc_read
  end interface
  !
  interface
    subroutine classic_filedesc_write(file,error)
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      ! Write the File Descriptor to the file.
      ! The file itself must have been opened before
      !---------------------------------------------------------------------
      type(classic_file_t), intent(in)    :: file   !
      logical,              intent(inout) :: error  ! Logical error flag
    end subroutine classic_filedesc_write
  end interface
  !
  interface
    subroutine classic_filedesc_dump(fdesc,name)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      ! Dump the content of the File Descriptor
      !---------------------------------------------------------------------
      type(classic_filedesc_t), intent(in) :: fdesc  ! The File Descriptor
      character(len=*),         intent(in) :: name   ! The File Descriptor name (some prefix)
    end subroutine classic_filedesc_dump
  end interface
  !
  interface
    subroutine reallocate_recordbuf(buf,len,error)
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Allocate or reallocate the input working buffer
      !---------------------------------------------------------------------
      type(classic_recordbuf_t), intent(inout) :: buf    !
      integer(kind=4),           intent(in)    :: len    ! New length required
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine reallocate_recordbuf
  end interface
  !
  interface
    subroutine deallocate_recordbuf(buf,error)
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Deallocate the input working buffer
      !---------------------------------------------------------------------
      type(classic_recordbuf_t), intent(inout) :: buf    !
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine deallocate_recordbuf
  end interface
  !
  interface
    subroutine classic_file_loss(file,unused,error)
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      ! Parse the input file and search for unused (lost) bytes
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file    !
      integer(kind=4),      intent(in)    :: unused  ! Number of unused bytes per Index
      logical,              intent(inout) :: error   !
    end subroutine classic_file_loss
  end interface
  !
  interface
    subroutine classic_file_copy(in,ou,error)
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Copy the input classic_file_t into the output one, taking care
      ! of some special elements like pointers and allocatables.
      !---------------------------------------------------------------------
      type(classic_file_t), intent(in)    :: in     !
      type(classic_file_t), intent(inout) :: ou     !
      logical,              intent(inout) :: error  ! Logical error flag
    end subroutine classic_file_copy
  end interface
  !
  interface
    function classic_file_size(file)
      use gildas_def
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      ! Return the file size (according to its descriptor) in bytes
      !---------------------------------------------------------------------
      integer(kind=size_length) :: classic_file_size
      type(classic_file_t), intent(in) :: file
    end function classic_file_size
  end interface
  !
  interface
    subroutine classic_file_init(file,version,reclen,error)
      use gbl_message
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      !   Initialize a new Classic file. The following elements must have
      ! been set before:
      !   file%lun
      !   file%spec
      !   file%nspec
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file     !
      integer(kind=4),      intent(in)    :: version  ! File version
      integer(kind=4),      intent(in)    :: reclen   ! Record length (words)
      logical,              intent(inout) :: error    ! Logical error flag
    end subroutine classic_file_init
  end interface
  !
  interface
    subroutine classic_file_open(file,readwrite,error)
      use gbl_message
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ public
      !   Open an old Classic file. The following elements must have been
      ! set before:
      !   file%lun
      !   file%spec
      !   file%nspec
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file       !
      logical,              intent(in)    :: readwrite  !
      logical,              intent(inout) :: error      ! Logical error flag
    end subroutine classic_file_open
  end interface
  !
  interface
    subroutine classic_file_close(file,error)
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Perform the needed operations to close a classic_file_t structure
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file   !
      logical,              intent(inout) :: error  !
    end subroutine classic_file_close
  end interface
  !
  interface
    subroutine classic_file_fopen(file,statu,error)
      use gbl_format
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Fortran-open the given Classic file. The following elements must
      ! have been set before:
      !   file%lun
      !   file%spec
      !   file%nspec
      !   file%readwrite
      !   file%desc%reclen
      !---------------------------------------------------------------------
      type(classic_file_t), intent(in)    :: file   !
      character(len=*),     intent(in)    :: statu  ! 'OLD' or 'NEW'
      logical,              intent(inout) :: error  !
    end subroutine classic_file_fopen
  end interface
  !
  interface
    subroutine classic_file_fclose(file,error)
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Fortran-close the given Classic file. The following elements must
      ! have been set before:
      !   file%lun
      !   file%spec
      !---------------------------------------------------------------------
      type(classic_file_t), intent(in)    :: file   !
      logical,              intent(inout) :: error  !
    end subroutine classic_file_fclose
  end interface
  !
  interface
    subroutine classic_file_fflush(file,error)
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      ! Fortran-flush the given Classic file. According to Fortran:
      !   "Execution of a FLUSH statement causes data written to an
      !    external file to be available to other processes, or causes data
      !    placed in an external file by means other than Fortran to be
      !    available to a READ statement. These actions are processor
      !    dependent."
      ! In other words, it works on both writing and reading files.
      !---------------------------------------------------------------------
      type(classic_file_t), intent(in)    :: file   !
      logical,              intent(inout) :: error  !
    end subroutine classic_file_fflush
  end interface
  !
  interface
    subroutine classic_entryindex_read(file,entry_num,data,buf,error)
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  Read an entry in the given file, and return its Entry Index in the
      ! 'data(*)' buffer
      !---------------------------------------------------------------------
      type(classic_file_t),       intent(in)    :: file       !
      integer(kind=entry_length), intent(in)    :: entry_num  ! Entry number
      integer(kind=4),            intent(out)   :: data(*)    !
      type(classic_recordbuf_t),  intent(inout) :: buf        ! Working buffer
      logical,                    intent(inout) :: error      ! Logical errror flag
    end subroutine classic_entryindex_read
  end interface
  !
  interface
    subroutine classic_entryindex_write(file,entry_num,data,buf,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !   Write the given Entry Index ('data(*)' buffer) for the given entry
      ! in the given file. There must be room already provisioned for the
      ! entry in the Extension Index.
      !---------------------------------------------------------------------
      type(classic_file_t),       intent(in)    :: file       !
      integer(kind=entry_length), intent(in)    :: entry_num  ! Entry number
      integer(kind=4),            intent(in)    :: data(*)    !
      type(classic_recordbuf_t),  intent(inout) :: buf        ! Working buffer
      logical,                    intent(inout) :: error      ! Logical errror flag
    end subroutine classic_entryindex_write
  end interface
  !
  interface
    subroutine classic_recordbuf_open(file,rstart,wstart,buf,error)
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      ! Open the buffer for reading a new object
      !---------------------------------------------------------------------
      type(classic_file_t),      intent(in)    :: file    !
      integer(kind=8),           intent(in)    :: rstart  ! First record of the object
      integer(kind=4),           intent(in)    :: wstart  ! First word in this record
      type(classic_recordbuf_t), intent(inout) :: buf     !
      logical,                   intent(inout) :: error   !
    end subroutine classic_recordbuf_open
  end interface
  !
  interface
    subroutine classic_recordbuf_nullify(buf)
      use classic_types
      !---------------------------------------------------------------------
      ! @ public
      !  "Nullify" the input buffer i.e. reset its record positions so that
      ! recordbuf_read/write won't assume something useful is stored in the
      ! data buffer.
      !---------------------------------------------------------------------
      type(classic_recordbuf_t), intent(inout) :: buf  !
    end subroutine classic_recordbuf_nullify
  end interface
  !
  interface
    subroutine toc_init_pointers(toc,error)
      use toc_types
      !---------------------------------------------------------------------
      ! @ public
      !  Initialize the pointers arrays
      !---------------------------------------------------------------------
      type(toc_t), intent(inout), target :: toc    ! Table-Of-Content description
      logical,     intent(inout)         :: error  !
    end subroutine toc_init_pointers
  end interface
  !
  interface
    subroutine toc_clean(toc,error)
      use toc_types
      !---------------------------------------------------------------------
      ! @ public
      !  Clean all the TOC structure
      !---------------------------------------------------------------------
      type(toc_t), intent(inout) :: toc    ! Table-Of-Content description
      logical,     intent(inout) :: error  !
    end subroutine toc_clean
  end interface
  !
  interface
    subroutine toc_getkeys(line,iopt,toc,keys,error)
      use gbl_message
      use toc_types
      !---------------------------------------------------------------------
      ! @ public
      !  Get arguments of option /TOC from command line. 'keys' is unchanged
      ! if no argument is present.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line     ! Command line
      integer(kind=4),  intent(in)    :: iopt     ! Option number
      type(toc_t),      intent(in)    :: toc      ! Table-Of-Content description
      integer(kind=4),  intent(inout) :: keys(:)  ! List of key identifiers retrieved
      logical,          intent(inout) :: error    ! Error flag
    end subroutine toc_getkeys
  end interface
  !
  interface
    subroutine toc_main(rname,toc,nentry,keywords,sname,olun,p_format,error,dobak)
      use gbl_message
      use classic_params
      use toc_types
      !---------------------------------------------------------------------
      ! @ public
      !  Main Table-Of-Contents engine
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: rname        ! Calling routine name
      type(toc_t),                intent(inout) :: toc          !
      integer(kind=entry_length), intent(in)    :: nentry       ! Size of index (can be 0)
      integer(kind=4),            intent(in)    :: keywords(:)  ! Selection
      character(len=*),           intent(in)    :: sname        ! Sic structure name (none if empty)
      integer(kind=4),            intent(in)    :: olun         ! Output logical unit
      interface
        subroutine p_format(key,ival,output)  ! Formatting subroutine
        use classic_params
        use toc_types
        type(toc_descriptor_t),     intent(in)  :: key
        integer(kind=entry_length), intent(in)  :: ival
        character(len=*),           intent(out) :: output
        end subroutine p_format
      end interface
      logical,                    intent(inout) :: error        ! Logical error flag
      logical, optional,          intent(in)    :: dobak        ! Also generate the back pointers?
    end subroutine toc_main
  end interface
  !
  interface
    subroutine toc_select_all(rname,toc,nentry,keywords,dobak,p_format,error)
      use toc_types
      !---------------------------------------------------------------------
      ! @ public
      !  Compute the equivalence classes for all (combined) keywords
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: rname
      type(toc_t),                intent(inout) :: toc
      integer(kind=entry_length), intent(in)    :: nentry       ! Size of index
      integer(kind=4),            intent(in)    :: keywords(:)  ! Selection (key identifiers)
      logical,                    intent(in)    :: dobak        ! Also generate the back pointers (key%select%bak)?
      interface
        subroutine p_format(key,ival,output)  ! Formatting subroutine
        use classic_params
        use toc_types
        type(toc_descriptor_t),     intent(in)  :: key
        integer(kind=entry_length), intent(in)  :: ival
        character(len=*),           intent(out) :: output
        end subroutine p_format
      end interface
      logical,                    intent(inout) :: error
    end subroutine toc_select_all
  end interface
  !
  interface
    function toc_generic_eq(ptrs,m,l)
      use classic_params
      use toc_types
      !---------------------------------------------------------------------
      ! @ public
      ! TOC support routine
      !---------------------------------------------------------------------
      logical :: toc_generic_eq  ! Function value on return
      type(toc_pointers_t),       intent(in) :: ptrs  ! Pointers to data arrays
      integer(kind=entry_length), intent(in) :: m     ! Observation number
      integer(kind=entry_length), intent(in) :: l     ! Observation number
    end function toc_generic_eq
  end interface
  !
  interface
    subroutine toc_format(key,ival,output)
      use toc_types
      !---------------------------------------------------------------------
      ! @ public
      ! TOC support routine: generic formatting routine
      !---------------------------------------------------------------------
      type(toc_descriptor_t),     intent(in)  :: key     !
      integer(kind=entry_length), intent(in)  :: ival    !
      character(len=*),           intent(out) :: output  !
    end subroutine toc_format
  end interface
  !
end module classic_interfaces_public

subroutine conpdv (xd,yd,zd,ndp,gwrite)
  !---------------------------------------------------------------------
  ! @ private
  !	Plot the data values on the contour map
  !	currently up to 10 characters for each value are displayed
  ! Arguments :
  !	XD	R*4 (*)	Array of X coordinates		Input
  !	YD	R*4 (*)	Array of Y coordinates		Input
  !	ZD	R*4 (*)	Array of values			Input
  !	NDP	I	Number of values		Input
  !	GWRITE	Ext	Label drawing routine		Input
  ! Subroutines :
  !	GWRITE
  !---------------------------------------------------------------------
  real :: xd(1)                     !
  real :: yd(1)                     !
  real :: zd(1)                     !
  integer :: ndp                    !
  external :: gwrite                !
  ! Local
  integer :: k
  !
  !  Loop and plot all values
  do k=1,ndp
    call gwrite(zd(k),xd(k),yd(k))
  enddo
end subroutine conpdv

program list
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  ! Local
  integer :: iline,jline,icol,jcol,ier
  logical :: error
  character(len=filename_length) :: namex,namey,file
  type(gildas) :: x
  !
  call gildas_open
  call gildas_char('FILE$',namex)
  call gildas_char('LIST$',namey)
  call gildas_inte('FIRST_LINE$',iline,1)
  call gildas_inte('LAST_LINE$',jline,1)
  call gildas_inte('FIRST_COLUMN$',icol,1)
  call gildas_inte('LAST_COLUMN$',jcol,1)
  call gildas_close
  !
  call gildas_null(x, type = 'TABLE')
  x%gil%form = 0  ! Prepare to accept any format
  call gdf_read_gildas (x,namex,'.tab',error, data=.false.)
  if (error) then
    write(6,*) 'E-LIST,  Cannot read input table'
    goto 100
  endif
 
  !
  call sic_parsef(namey,file,' ','.dat')
  ier = sic_open (1,file,'NEW',.false.)
  if (ier.ne.0) then
    write(6,*) 'E-LIST,  Cannot create output file'
    call putios('E-LIST,  ',ier)
    goto 100
  endif
  write(6,*) 'I-LIST,  Input file has ',x%gil%dim(2), &
    &   ' columns and ',x%gil%dim(1),' lines'
  !
  iline = max(1,min(iline,x%gil%dim(1)))
  jline = min(jline,x%gil%dim(1))
  if (jline.le.0) jline = x%gil%dim(1)
  !
  icol = max(1,min(icol,x%gil%dim(2)))
  jcol = min(jcol,x%gil%dim(2))
  if (jcol.le.0) jcol = x%gil%dim(2)
  !
  x%blc(2) = icol
  x%trc(2) = jcol
  ! Trick here: we will allocate only the minimum size needed
  jcol = jcol-icol+1
  icol = 1
  if (x%gil%form.eq.fmt_r4) then
    allocate(x%r2d(x%gil%dim(1),jcol),stat=ier)
    call gdf_read_data(x,x%r2d,error)
    call list_r4(x%r2d,x%gil%dim(1),jcol,iline,jline,icol,jcol)
  elseif (x%gil%form.eq.fmt_r8) then
    allocate(x%d2d(x%gil%dim(1),jcol),stat=ier)
    call gdf_read_data(x,x%d2d,error)
    call list_r8(x%d2d,x%gil%dim(1),jcol,iline,jline,icol,jcol)
  elseif (x%gil%form.eq.fmt_i4) then
    allocate(x%i2d(x%gil%dim(1),jcol),stat=ier)
    call gdf_read_data(x,x%i2d,error)
    call list_i4(x%i2d,x%gil%dim(1),jcol,iline,jline,icol,jcol)
  endif
  call gagout ('S-LIST,  Successful completion')
  call sysexi (1)
100 call sysexi (fatale)
end program list
!
subroutine list_r4(x,n,m,ifirst,ilast,ic,lc)
  use gildas_def
  integer(kind=index_length), intent(in) :: n             ! Number of lines
  integer(kind=4),            intent(in) :: m             ! Number of columns
  real(kind=4),               intent(in) :: x(n,m)        ! The array
  integer(kind=4),            intent(in) :: ifirst,ilast  ! Line range
  integer(kind=4),            intent(in) :: ic,lc         ! Column range
  ! Local
  character(len=20) :: forma
  integer(kind=4) :: i,j
  !
  ! "-1.234567E-12" => 13 chars, 6 digits
  write(forma,'(A,I0,A)')  '(',lc-ic+1,'(1X,1PG13.6))'
  !
  do i=ifirst,ilast
    write(1,forma) (x(i,j),j=ic,lc)
  enddo
end subroutine list_r4
!
subroutine list_r8(x,n,m,ifirst,ilast,ic,lc)
  use gildas_def
  integer(kind=index_length), intent(in) :: n             ! Number of lines
  integer(kind=4),            intent(in) :: m             ! Number of columns
  real(kind=8),               intent(in) :: x(n,m)        ! The array
  integer(kind=4),            intent(in) :: ifirst,ilast  ! Line range
  integer(kind=4),            intent(in) :: ic,lc         ! Column range
  ! Local
  character(len=20) :: forma
  integer(kind=4) :: i,j
  !
  ! "-1.234567890123E-123" => 20 chars, 12 digits
  write(forma,'(A,I0,A)')  '(',lc-ic+1,'(1X,1PG20.12))'
  !
  do i=ifirst,ilast
    write(1,forma) (x(i,j),j=ic,lc)
  enddo
end subroutine list_r8
!
subroutine list_i4(x,n,m,ifirst,ilast,ic,lc)
  use gildas_def
  integer(kind=index_length), intent(in) :: n             ! Number of lines
  integer(kind=4),            intent(in) :: m             ! Number of columns
  integer(kind=4),            intent(in) :: x(n,m)        ! The array
  integer(kind=4),            intent(in) :: ifirst,ilast  ! Line range
  integer(kind=4),            intent(in) :: ic,lc         ! Column range
  ! Local
  character(len=20) :: forma
  integer(kind=4) :: i,j
  !
  ! -2**32 = -2147483648 => 11 chars
  write(forma,'(A,I0,A)')  '(',lc-ic+1,'(1X,I11))'
  !
  do i=ifirst,ilast
    write(1,forma) (x(i,j),j=ic,lc)
  enddo
end subroutine list_i4

subroutine set_attributs(output,attr_v)
  use gtv_interfaces, except_this=>set_attributs
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Mise en place des differents attributs de trace.
  !---------------------------------------------------------------------
  type(gt_display),      intent(inout) :: output  ! Output instance
  type(gt_segment_attr), intent(in)    :: attr_v  !
  call set_dash (output,attr_v%dash)
  call set_weigh(output,attr_v%weight)
  call set_color(output,attr_v%colour)
end subroutine set_attributs
!
subroutine set_dash(output,z_dash)
  use gtv_interfaces, except_this=>set_dash
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Fixe le parametre de pointille, pour les protocoles capables de le
  ! faire tous seuls.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! Output instance
  integer*4,        intent(in)    :: z_dash  !
  ! Local
  logical :: z_flag_dash
  real*4 :: z_xy_scale
  integer(kind=4) :: z_pix_dash_style(4)
  integer :: i
  real*4 :: z_ps_dash_style(4),sizex,sizey,gsclx,gscly
  !
  output%idashe=z_dash
  !
  if (output%dev%protocol.eq.p_x) then
    ! je calcule un rapport valable en x et y pour les longueurs
    ! des piti traits diagonaux. Ce n'est utile que lorsqu'une
    ! diagonale de pixels m'est pas exactement a 45' sur l'ecran,
    ! sinon gsclx et gscly etant egaux, l'un des deux suffit.
    !
    sizex = cw_directory%phys_size(1)
    sizey = cw_directory%phys_size(2)
    call get_scale_awd(output,gsclx,gscly)
    z_xy_scale = (abs(gsclx)*sizex+abs(gscly)*sizey) / (sizex+sizey)
    !
    ! calcul du dash_style, les piti points sont au moins de longueur 1
    ! ds le cas ou HARDW_LINE_DASH est .FALSE., on CONSERVE IDASH  (ce qui
    ! force GTX_CHOPPE a travailler, mais on FORCE le dash hardware a
    ! "pas de dash pattern".
    if (output%idashe.eq.1 .or.  &
        .not.(user_hardw_line.and.output%dev%hardw_line_dash)) then
      z_flag_dash=.false.
    else
      z_flag_dash=.true.
      do i=1,4
        z_pix_dash_style(i)=z_xy_scale*onoff(i,output%idashe)
        if (z_pix_dash_style(i).lt.1) then
          z_pix_dash_style(i)=1
        endif
      enddo
    endif
    call x_dash(output%x%graph_env,z_flag_dash,z_pix_dash_style)
    !
  elseif (output%dev%protocol.eq.p_postscript) then
    if (output%idashe.eq.1) then
      z_flag_dash=.false.
    else
      z_flag_dash=.true.
      do i=1,4
        z_ps_dash_style(i)=onoff(i,output%idashe)
      enddo
    endif
    call ps_dash(z_flag_dash,z_ps_dash_style)
    !
  elseif (output%dev%protocol.eq.p_svg) then
    if (output%idashe.eq.1) then
      z_flag_dash=.false.
    else
      z_flag_dash=.true.
      do i=1,4
        z_ps_dash_style(i)=onoff(i,output%idashe)
      enddo
    endif
    call svg_dash(output,z_flag_dash,z_ps_dash_style)
  endif
  !
end subroutine set_dash
!
subroutine set_weigh(output,z_weigh)
  use gtv_interfaces, except_this=>set_weigh
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! fixe le parametre de graisse, pour les protocoles capables de le
  ! faire tous seuls.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output   ! Output instance
  real(kind=4),     intent(in)    :: z_weigh  !
  !
  output%iweigh = z_weigh
  !
  if (output%dev%protocol.eq.p_x) then
    call x_weigh(output%x%graph_env,set_weight_pixel(output))
    !
  elseif (output%dev%protocol.eq.p_postscript) then
    call ps_weigh(output%iweigh)
    !
  elseif (output%dev%protocol.eq.p_svg) then
    call svg_weigh(output,output%iweigh)
    !
  elseif (output%dev%protocol.eq.p_png) then
    call png_weigh(output,set_weight_pixel(output))
  endif
  !
end subroutine set_weigh
!
function set_weight_pixel(output)
  use gtv_interfaces, except_this=>set_weight_pixel
  use gtv_buffers
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Convert the line width from physical size (cm) to pixel
  !---------------------------------------------------------------------
  integer(kind=4) :: set_weight_pixel  ! Function value on return
  type(gt_display), intent(in) :: output  ! Output instance
  ! Local
  real(kind=4) :: z_xy_scale,sizex,sizey,gsclx,gscly
  !
  ! If weigh is 0 ou 1, we do not enlarge the line, else zooms won't
  ! help! Note that 0 ("hairline") gives better result than 1 on X
  ! devices (!!!)
  if (output%iweigh.le.graisse(1)) then
    set_weight_pixel = 0
    return
  endif
  !
  ! je calcule un rapport valable en x et y pour les longueurs
  ! des piti traits diagonaux. Ce n'est utile que lorsqu'une
  ! diagonale de pixels n'est pas exactement a 45' sur l'ecran,
  ! sinon gsclx et gscly etant egaux, l'un des deux suffit.
  sizex = cw_directory%phys_size(1)  ! Global dependency here!!!
  sizey = cw_directory%phys_size(2)  ! Global dependency here!!!
  call get_scale_awd(output,gsclx,gscly)
  z_xy_scale = (abs(gsclx)*sizex+abs(gscly)*sizey) / (sizex+sizey)
  !
  ! Calcul de l'epaisseur en pixel, limite au moins a 1
  set_weight_pixel = output%iweigh*z_xy_scale
  if (set_weight_pixel.lt.2)  set_weight_pixel = 0
  !
end function set_weight_pixel
!
subroutine set_color(output,z_color)
  use gtv_interfaces, except_this=>set_color
  use gtv_types
  use gtv_graphic
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ private
  ! fixe le parametre de couleur
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output   ! Output instance
  integer*4,        intent(in)    :: z_color  !
  !
  output%icolou = z_color
  call gtx_pen(output,output%icolou,gbl_pen)
end subroutine set_color

program compute_gravitation_file
  use gkernel_interfaces
  implicit none
  !
  include 'clic_panels.inc'
  include 'gbl_pi.inc'
  !
  integer   :: lun1, lun2, i, iradnode, iaznode, iscrew, ir, ip,ipz
  integer   :: ir1, ir2, ircurrent, ipanel, nsector, is
  integer   :: ip1, ip2, ip3, ip4, k, nm, im, nmod
  real      :: x, y, z, dz1, dz2, az, r1, r0, t0, phi, r
  real      :: xoscr(5,7), yoscr(5,7), xx, yy, fmode, zpan, epan
  real*8    :: a1(mm,mm),a2(mm,mm), b1(mm), b2(mm), sig
  real      :: am1(mm,mring,mpan),am2(mm,mring,mpan)
  real      :: xpanel, ypanel,ae(mm,mring,mpan)
  real, allocatable :: def1(:,:,:), def2(:,:,:)
  character :: infile*256, file*256, chain*256, cpanel*5
  logical   :: error
  data xoscr/ &
       0.058, 0.058, -0.061, -0.061, 0., &
       0.037, 0.037, -0.035, -0.035, 0., &
       0.030, 0.030, -0.034, -0.034, 0., &
       0.031, 0.031, -0.043, -0.043, 0., &
       0.043, 0.043, -0.044, -0.044, 0., &
       0.032, 0.032, -0.034, -0.034, 0., &
       0.034, 0.034, -0.067, -0.067, 0./
  data yoscr/ &
       0.027, -0.027, 0.045, -0.045, 0., &
       0.025, -0.025, 0.048, -0.048, 0., &
       0.043, -0.043, 0.058, -0.058, 0., &
       0.024, -0.024, 0.031, -0.031, 0., &
       0.031, -0.031, 0.038, -0.038, 0., &
       0.038, -0.038, 0.045, -0.045, 0., &
       0.045, -0.045, 0.051, -0.051, 0./
  !
  ! set 30m defaults
  allocate(def1(mring,mpan,mm))
  allocate(def2(mring,mpan,mm))
  call set_panels(type_iram30m)
  !
  ! Open two deformation files
  error = sic_getlun(lun1).ne.1
  error = sic_getlun(lun2).ne.1
  if (error) then
    print *,'Get_rigging','No logical unit left'
    stop
  endif
  !
  ! Horizon file
  infile = 'graverr0.dat'
  if (.not.sic_query_file(infile,'data#dir:','',file)) then
    print *, 'Get_rigging','Deformation file not found'
    error = .true.
    stop
  endif
  open (lun1, file=file(1:lenc(file)))
  !
  ! Zenith file
  infile = 'graverr90.dat'
  if (.not.sic_query_file(infile,'data#dir:','',file)) then
    print *, 'Get_rigging','Deformation file not found'
    error = .true.
    stop
  endif
  open (lun2, file=file(1:lenc(file)))
!  read(lun,'(a)', err=20) chain
!  read(lun,'(a)', err=20) chain
  i = 1
  ircurrent = 1
  ipanel = 1
10 read (lun1, *, end=30, err=20) iradnode, iaznode, az, x, y, z, dz1
30 read (lun2, *, end=20, err=20) iradnode, iaznode, az, x, y, z, dz2
  if (iradnode.ne.ircurrent) then
    ipanel = 1
    ircurrent = iradnode
  endif
  dz1 = dz1 *1000.
  dz2 = dz2 *1000.
!  call xypanel(x,y,ir,ip,xpanel,ypanel)
  ir1 = iradnode-1
  ir2 = iradnode
  if (ir2.ge.1.and.ir2.le.nring) then
    ! Screw 2 on panel ipanel
    ip1 = ipanel
    def1(ir2,ip1,1) = dz1
    def2(ir2,ip1,1) = dz2
    ! Screw 1 on panel ipnanel-1
    ip3 = ipanel-1
    if (ip3.lt.1) ip3 = ip3 +npan(ir2)
    def1(ir2,ip3,2) = dz1
    def2(ir2,ip3,2) = dz2
  endif
  if (ir1.ge.1.and.ir1.lt.nring) then
    nsector = npan(ir2)/npan(ir1)
    if (mod(ipanel+1,nsector).eq.0) then
      ip2 = ipanel/nsector
      ip4 = ipanel/nsector-1
      if (ip4.le.0) ip4 = ip4+npan(ir1)
      def1(ir1,ip2,4) = dz1
      def1(ir1,ip4,3) = dz1
      def2(ir1,ip2,3) = dz2
      def2(ir1,ip4,3) = dz2 
    endif
  elseif(ir1.eq.nring) then
    nsector = 1 
    ip2 = ipanel/nsector
    ip4 = ipanel/nsector-1
    if (ip4.le.0) ip4 = ip4+npan(ir1)
    def1(ir1,ip2,3) = dz1
    def1(ir1,ip4,4) = dz1
    def2(ir1,ip2,3) = dz2
    def2(ir1,ip4,4) = dz2
  endif
  !
  
  ! Now assign deformation to "screws"
  !
  i = i+1
  ipanel = ipanel + 1
  goto 10
  !
  ! Close files
20  close(lun1)
  close(lun2)
  call sic_frelun(lun1)
  call sic_frelun(lun2)
  !
  ! Compute support position (optionnaly)
  do ir = 1, nring
    nscr(ir) = 4      ! 4 corners
    r1 = (ray(ir)-ray(ir-1))/2
    r0 = (ray(ir)+ray(ir-1))/2
    t0 = r0 / 2 / focus
    do is = 1, nscr(ir)
       ! coordinates of corner (or center if offset is zero)
       r = r0
       phi = 0
       if (xoscr(is,ir).lt.0) then
         r = ray(ir)
       elseif (xoscr(is,ir).gt.0) then
         r = ray(ir-1)
       endif
       if (yoscr(is,ir).lt.0) then
         phi = pi/npan(ir)
       elseif (yoscr(is,ir).gt.0) then
         phi = -pi/npan(ir)
       endif
       xscr(is,ir) = (r*cos(phi)-r0+(r**2-r0**2)/4/focus*t0)   &
         /sqrt(1+t0**2) !+ xoscr(is,ir)
       yscr(is,ir) = r*sin(phi) !+ yoscr(is,ir)
1999    format (a,i1,a,i1,a,f10.6)
    enddo
  enddo
  ! 
  ! Fit mode to derived panels
  nmod = 4
  do ir = 1, nring
    do ip=1,npan(ir)
      do is = 1, nscr(ir)
        xx = xscr(is,ir)
        yy = yscr(is,ir)       
        nm = nmod
        do im=1, nm
          a1(is,im) = fmode(im,ir,xx,yy)
          a2(is,im) = fmode(im,ir,xx,yy)
        enddo
        b1(is) = def1(ir, ip, is)
        b2(is) = def2(ir, ip, is)
      enddo
      call mth_fitlin ('MODE',nscr(ir),nm,a1,b1,mm,sig)
      call mth_fitlin ('MODE',nscr(ir),nm,a2,b2,mm,sig)
      do k=1,nm
        am1(k,ir,ip) = b1(k)
        am2(k,ir,ip) = b2(k)
      enddo
    enddo
  enddo
  !
  ! Now compute deformation at actual position
  call set_panels(type_iram30m)
  do ir = 1, nring
    do ip = 1, npan(ir)
      do is = 1, nscr(ir)
        call zpanel(xscr(is,ir),yscr(is,ir),ir,ip,am1,ae,zpan,epan,nmod)
        def1(ir,ip,is) = zpan
        call zpanel(xscr(is,ir),yscr(is,ir),ir,ip,am2,ae,zpan,epan,nmod)       
        def2(ir,ip,is) = zpan

      enddo
    enddo
  enddo
  error = sic_getlun(lun1).ne.1
  !
  ! Now write correctly formatted file
  open(lun1, file='gravDef_30m.dat',status='UNKNOWN')
  write(lun1,*) "! computed with compute_gravitation_file"
  write(lun1,*) "! iring ipanel iscrew x y dz0 dz90"
  do ir = 1, nring
    do ip = 1, npan(ir)
      do is = 1, nscr(ir)
        write(lun1,'(i2,1x,i3,1x,i1,1x,1pg3.1,1x,1pg3.1,1x,1pg11.3,1x,1pg11.3)') ir, ip, is, 1, 1, def1(ir,ip,is), def2(ir,ip,is)
      enddo
    enddo 
  enddo
  close(lun1)
  call sic_frelun(lun1)
  stop
end program

module astro_register_type
  use astro_types
  !
  public
  private :: register_reallocate,register_free,register_add_febe
  !
  integer(kind=4), parameter :: m_register_alloc=16
  !
  type noema_febe_register_t
    !
    integer(kind=4) :: m_saved=0
    integer(kind=4) :: n_saved=0
    integer(kind=4) :: n_index=0
    type(noema_febe_t), allocatable :: saved_febe(:) 
    !
    contains
      procedure, public :: free => register_free
      procedure, public :: reallocate => register_reallocate
      procedure, public :: add => register_add_febe
      procedure, public :: save => register_save_febe
      procedure, public :: clear => register_clear
      procedure, public :: list => register_list
      procedure, public :: load => register_load_febe
      procedure, public :: remove => register_remove_febe
  end type noema_febe_register_t
  !
contains
  subroutine register_reallocate(register,m_febe,error)
    use gkernel_interfaces
    ! Reallocate register%n_saved_febe if needed
    class(noema_febe_register_t), intent(inout) :: register
    integer(kind=4), intent(in) :: m_febe
    logical, intent(inout)      :: error
    !
    character(len=*), parameter :: rname='REGISTER>REALLOCATE'
    integer(kind=4) :: ier
    logical :: alloc
    !
    alloc=.true.
    ! First check if alloc already
    if (allocated(register%saved_febe)) then
      if (register%m_saved.eq.m_febe) then
        ! Already allocated at the right size
        alloc = .false.
      else
        ! Not the right size: deallocate
        call register%free(error)
        if (error) return
        alloc=.true.
      endif
    endif
    if (alloc) then
      ! Allocate to right size
      allocate(register%saved_febe(m_febe),stat=ier)
      if (failed_allocate(rname,'REGISTER saved FEBE',ier,error))  return
      register%m_saved=m_febe
    endif
    !
  end subroutine register_reallocate
  !
  subroutine register_free(register,error)
    ! Deallocate pfx%unit
    class(noema_febe_register_t), intent(inout) :: register
    logical, intent(inout)      :: error
    !
    if (allocated(register%saved_febe)) deallocate(register%saved_febe)
    !
  end subroutine register_free
  !
  subroutine register_add_febe(register,lfebe,error)
    use gbl_message
    !-----------------------------------------------------------------------
    ! add current freq setup to the multifreq list
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    type(noema_febe_t), intent(inout) :: lfebe
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>ADD'
    integer(kind=4) :: i,idx,inum
    character(len=256) :: mess
    !
    ! Check that there is at least 1 spectral window
    if (lfebe%spw%out%n_spw.eq.0) then
      call astro_message(seve%e,rname,'Current FEBE does not contain any SPW, nothing done')
      error=.true.
      return
    endif
    ! Get the first free slot
    idx=-1
    do i=1,register%m_saved
      if (.not.register%saved_febe(i)%defined) then
        idx=i
        exit
      endif
    enddo
    ! 
    if (idx.eq.-1) then
      call astro_message(seve%e,rname, &
           'No space left in register, remove some FEBE before trying to add new ones')
      error=.true.
      return
    endif
    ! Get the number -  always increase to keep a kind of history, even if some FEBE are removed in between
    inum=register%n_index+1
    call register%saved_febe(idx)%pfx%reallocate(lfebe%pfx%n_units,error)
    if (error) return
    register%saved_febe(idx)=lfebe
    register%saved_febe(idx)%id=inum
    register%saved_febe(idx)%defined=.true.
    register%saved_febe(idx)%loaded=.false.
    ! 
    register%n_saved=register%n_saved+1
    register%n_index=inum
    !
    write (mess,'(a,1x,i0.0)') 'Current frontend-backend settings saved to register under number',inum
    call astro_message(seve%i,rname,mess)
    !
    lfebe%loaded=.false.
    !
  end subroutine register_add_febe
  !
  subroutine register_save_febe(register,lfebe,error)
    use gbl_message
    !-----------------------------------------------------------------------
    ! save current freq setup to the multifreq list (at the place of the loaded febe)
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    type(noema_febe_t), intent(inout) :: lfebe
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>SAVE'
    integer(kind=4) :: i,idx
    character(len=256) :: mess
    !
    ! Get the slot of the loaded FEBE
    idx=-1
    do i=1,register%m_saved
      if (register%saved_febe(i)%id.ne.lfebe%id) cycle
      idx=i
    enddo
    ! 
    if (idx.eq.-1) then
      call astro_message(seve%e,rname, &
           'Index of the loaded FEBE is not found')
      error=.true.
      return
    endif
    if (.not.lfebe%loaded) then
      call astro_message(seve%e,rname, &
           'Need to load a FEBE before saving')
      error=.true.
      return
    endif
    call register%saved_febe(idx)%pfx%reallocate(lfebe%pfx%n_units,error)
    if (error) return
    register%saved_febe(idx)=lfebe
    register%saved_febe(idx)%defined=.true.
    register%saved_febe(idx)%loaded=.false.
    !
    write (mess,'(a,1x,i0.0)') 'Current frontend-backend saved in number',lfebe%id
    call astro_message(seve%i,rname,mess)
    !
    lfebe%loaded=.false.
    !
  end subroutine register_save_febe
  !
  subroutine register_clear(register,error)
    !-----------------------------------------------------------------------
    ! reset the register to 0
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>CLEAR'
    integer(kind=4) :: i
    !
    do i=1,register%m_saved
      register%saved_febe(i)%defined=.false.
      register%saved_febe(i)%id=0
      register%saved_febe(i)%name=''
    enddo
    register%n_saved=0
    register%n_index=0
    !
  end subroutine register_clear
  !
  subroutine register_list(register,recdesc,error)
    use gbl_message
    use ast_astro
    !-----------------------------------------------------------------------
    ! list current freq setups in the register
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    type(receiver_desc_t), intent(in) :: recdesc
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>LIST'
    integer(kind=4) :: i,j,dband,imode
    character(len=256) :: mess,vmess
    real(kind=8) :: dfreq
    character(len=32) :: dbandname,dmodename,vtype
    logical :: found
    !
    if (register%n_saved.eq.0) then
      call astro_message(seve%r,rname,'The register does not contain any FEBE')
      return
    endif
    if (soukind.ne.soukind_none) then
      if (source_invtype(1:2).eq.'LS') then
        vtype='LSR'
        write (vmess,'(a,1x,f0.3,1x,a)') trim(vtype),source_vlsr,'km/s'
      else if (source_invtype(1:2).eq.'RE') then
        vtype='REDSHIFT'
        write (vmess,'(a,1x,f0.3)') trim(vtype),source_redshift
      else
        vtype=''
        vmess=''
      endif
      if (soukind.eq.soukind_full) then
        write (mess,'(a,1x,a,1x,a)')  'List of tunings defined for current source:', &
                                            trim(astro_source_name),trim(vmess)
      else if (soukind.eq.soukind_vlsr.or.soukind.eq.soukind_red) then
        write (mess,'(a,1x,a)')  'List of tunings defined for',trim(vmess)
      endif
      call astro_message(seve%r,rname,mess)
    endif
    !
    do i=1,register%n_index ! loop on the idx numbers
      found=.false.
      do j=1,register%m_saved ! Find the corresponding saved FEBE in the register
        if (.not.register%saved_febe(j)%defined) cycle
        if (register%saved_febe(j)%id.ne.i) cycle
        dband=register%saved_febe(j)%rectune%iband
        dbandname=recdesc%bandname(dband)
        call register%saved_febe(j)%pfx%getmode(dmodename,error)
        if (error) return
        dfreq=register%saved_febe(j)%rectune%frest*ghzpermhz ! displayed freq in GHz
        found=.true.
        exit ! quit loop when found
      enddo
      if (found) then
        write (mess,'(a,i0.0,1x,a,1x,f0.3,1x,a,1x,a)') &
            'Saved #',i,trim(dbandname),dfreq,'GHz - PFX Mode:',trim(dmodename)
      else
        write (mess,'(a,i0.0,1x,a)')  'Saved #',i,'not defined'
      endif
      call astro_message(seve%r,rname,mess)
    enddo
    !
  end subroutine register_list
  !
  subroutine register_load_febe(register,il,setup,error)
    use gbl_message
    !-----------------------------------------------------------------------
    ! copy one setup from the register to the current one
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    integer(kind=4), intent(in) :: il
    type(noema_febe_t), intent(inout) :: setup
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>LOAD'
    character(len=256) :: mess
    integer(kind=4) :: i,idx,isel,iu
    !
    ! Get the idx
    idx=0
    do i=1,register%m_saved
      if (register%saved_febe(i)%id.ne.il) cycle
      idx=i
      exit
    enddo
    if (idx.eq.0) then
      call astro_message(seve%e,rname,'The setup to load is not found')
      error=.true.
      return
    endif
    if (.not.register%saved_febe(idx)%defined) then
      call astro_message(seve%e,rname,'The setup to load is not defined')
      error=.true.
      return
    endif
    setup=register%saved_febe(idx)
    setup%id=register%saved_febe(idx)%id
    setup%name='LOADED'
    setup%loaded=.true.
    !
    ! After load, do a baseband selection (take all) so that user can define SPW
    isel=0
    do iu=1,setup%pfx%n_units
      isel=isel+1
      setup%i_f%selunit%usel(isel)=iu
    enddo
    setup%i_f%selunit%n_ifsel=isel
    setup%i_f%selunit%polmode='B'
    !
    write (mess,'(a,1x,i0.0,1x,a)') 'Setup',il,'loaded to current'
    call astro_message(seve%i,rname,mess)
    !
  end subroutine register_load_febe
  !
  subroutine register_remove_febe(register,ir,error)
    use gbl_message
    !-----------------------------------------------------------------------
    ! remove 1 tuning from the register
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    integer(kind=4), intent(in) :: ir  ! febe to remove
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>REMOVE'
    character(len=256) :: mess
    integer(kind=4) :: i,idx
    !
    ! Get the idx
    idx=0
    do i=1,register%m_saved
      if (register%saved_febe(i)%id.ne.ir) cycle
      idx=i
      exit
    enddo
    if (idx.eq.0) then
      call astro_message(seve%e,rname,'The setup to remove is not found')
      error=.true.
      return
    endif
    register%saved_febe(idx)%defined=.false.
    register%saved_febe(idx)%name='DELETED'
    register%n_saved=register%n_saved-1 ! n_saved is changed, N_index not to get a kind of history
    !
    write (mess,'(a,1x,i0.0,1x,a)') 'Setup',ir,'removed from saved list'
    call astro_message(seve%i,rname,mess)
    !
  end subroutine register_remove_febe
  !
end module astro_register_type

!
!--------------------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoDIYlist.f90">
!   <VERSION>
!                Id: modulePakoDIYlist.f90,v 1.3.0  2017-10-05    Hans Ungerechts  !! obsolete setPrivilege%GISMO
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-12-15    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-10-21    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-09-29    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-07-11    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-05-19    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-11-06    Hans Ungerechts  !!  allow Lissajous segment without ramp
!                                                                                  !!  depending variable %doNextSubscan
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-10-29    Hans Ungerechts  !!  make next (new)subscan optional
!                                                                                  !!  depending variable %doNextSubscan
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-09-05    Hans Ungerechts  !!  internal ramp
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-06-25,26 Hans Ungerechts  !!  internal ramp
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-06-24,25 Hans Ungerechts  !!  ramp down
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-06-20,24 Hans Ungerechts  !!  very loose
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-05-02 Hans Ungerechts
!                Id: modulePakoDIYlist.f90,v 1.2.2  2013-02-08 Hans Ungerechts
!                Id: modulePakoDIYlist.f90,v 1.2.2  2013-01-24 Hans Ungerechts
!                based on:
!                Id: modulePakoDIYlist.f90,v 1.1.14 2012-11-20 Hans Ungerechts
!   </VERSION>
!   <HISTORY>
!                2010-04-08 HU: force safe limit on maximum elevation
!                          for GISMO run, based on TT-NCS           
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>

!   </SIBLINGS>        
!
!   Pako module for command: DIY SUBSCAN
!
! </DOCUMENTATION> <!-- name="modulePakoDIYlist.f90" -->
!
!--------------------------------------------------------------------------------
!
Module modulePakoDIYlist
  !
  Use modulePakoMessages
  Use modulePakoTypes
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
!!$  Use modulePakoSwBeam
!!$  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  !
  Public :: DIYlist
  Public :: Subscan
  Public :: saveSubscan
  Public :: saveDIYlist
  Public :: startDIYlist
  Public :: displayDIYlist
  Public :: listDIYlist
  Public :: plotDIYlist
  !     
  ! *** Variables for DIYlist ***
  Include 'inc/variables/variablesDIYlist.inc'
!!!   
!!!   
Contains
!!!
!!!
  Subroutine DIYlist(programName, line, command, error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
!!OLD
!!OLD    Logical               :: isConnected   = .False.
!!OLD    Character (len=lenCh) :: bolometerName
!!OLD
!!OLD    Integer                :: iQuery
!!OLD    Character(len=lenCh)   :: nameQuery
!!OLD    Logical                :: isSet
!!OLD    Type(xyPointType)      :: pointResult
    !
    Include 'inc/ranges/rangesDIYlist.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &    " module DIYlist, 1.2.3 2013-07-11 ---> SR: DIYlist ")             ! trace execution
    !
    !D    Write (6,*) " module DIYlist ---> SR: DIYlist "
    !D    Write (6,*) "                          "
    !
    ! *** initialize ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    !     read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    Call checkNofParameters(command,                                             &
         &     0, 0,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    Call queryReceiver(rec%Bolo, isConnected, bolometerName = bolometerName)
    !
    !D     Write (6,*) "      rec%Bolo, isConnected: ", rec%Bolo, isConnected
    !D     Write (6,*) "      bolometerName:         ", bolometerName
    !D     Write (6,*) "      bolo%NIKA:             ", bolo%NIKA
    !
    If (   .Not.                                                                 &
         & (                                                                     &
!!$         &       GV%privilege.Eq.setPrivilege%GISMO                              &
         &       GV%privilege.Eq.setPrivilege%ncsTeam                            &
         &  .Or. isConnected.And.bolometerName.Eq.bolo%GISMO                     &
         &  .Or. isConnected.And.bolometerName.Eq.bolo%NIKA                      &
         & )    ) Then                                                           !
       ERROR = .True.
       Write (messageText, *) " requires privilege"
       Call pakoMessage(priorityE,severityE,command,                             &
            &           messageText)                                             !
    End If
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/options/readOptionsDIYlist.inc'
    End If
    !
    ! *** set defaults ***
    Include 'inc/options/optionDefaults.inc'
    !
    ! *** read Parameters, Options (again, after defaults!) ***
    !     and check for validity and ranges 
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/options/readOptionsDIYlist.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    !D     Write (6,*) "      vars(iIn)%hasPurpose:   ", vars(iIn)%hasPurpose
    !D     Write (6,*) "      vars(iIn)%purpose:    ->", vars(iIn)%purpose,     "<-"
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.error) Then
       !
       errorInconsistent = .False.
       !
    End If
    !
    If (.Not. errorInconsistent) Then
       vars(iTemp) = vars(iIn)
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)    = vars(iTemp)
    End If
    !
    !D     Write (6,*) "      vars(iValue)%hasPurpose:   ", vars(iValue)%hasPurpose
    !D     Write (6,*) "      vars(iValue)%purpose:    ->", vars(iValue)%purpose,     "<-"
    !
    If (.Not.error) Then
       GV%observingMode     = OM%DIY
       GV%observingModePako = OMpako%DIY
       GV%purpose           = vars(iValue)%purpose
       GV%purposeIsSet      = vars(iValue)%hasPurpose
       !D        Write (6,*) "   GV%observingMode:     ", GV%observingMode
       !D        Write (6,*) "   GV%observingModePako: ", GV%observingModePako
       !D        Write (6,*) "   GV%purposeIsSet:   ", GV%purposeIsSet
       !D        Write (6,*) "   GV%purpose:      ->", GV%purpose, "<-"
    End If
    !
!!$!!OLD    !
!!$!!OLD    ! *** set "selected" observing mode & plot ***
!!$!!OLD    If (.Not.error) Then
!!$!!OLD       GV%observingMode     = OM%DIYlist
!!$!!OLD       GV%observingModePako = OMpako%DIYlist
!!$!!OLD       GV%omSystemName      = vars(iValue)%systemName 
!!$!!OLD       GV%notReadySWafterOM = .False.
!!$!!OLD       GV%notReadySecondaryRafterOM = .False.
!!$!!OLD       !D       Write (6,*) '      GV%notReadySecondaryRafterOM: ',                       &
!!$!!OLD       !D            &             GV%notReadySecondaryRafterOM
!!$!!OLD       GV%notReadyOffsetsAfterDIYlist  = .False.
!!$!!OLD       GV%notReadyDIYlist     = .False.
!!$!!OLD       DIYlistCommand         = line(1:lenc(line))
!!$!!OLD       Call analyzeDIYlist (errorA)
!!$!!OLD       Call listSegmentList (errorA)
!!$!!OLD       Call plotOMDIYlist (errorP)
!!$!!OLD    End If
!!$    !
!!$!!OLD    Call printSegmentList (error)
    !
    Call getCountSegments(nSegments)
    !
    ! *** display values ***
    ! 
    If (.Not. ERROR) Then
       Call displayDIYlist
       Call listDIYlist (error)
       Call plotDIYlist (error)
    End If
    !
    Return
  End Subroutine DIYlist
!!!
!!!
  Subroutine Subscan(programName, line, command, error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    ! *** special working variables:   ***
    Logical               :: optionSpeedIsPresent, optionTotfIsPresent
    Logical, Dimension(3) :: alternative
    Real                  :: vIn, vStdMin, vStdMax, vLimitMin, vLimitMax
    !
    Real                  :: vLissMaxX,   vLissMaxY,   aLissMaxX,   aLissMaxY,   vLissLimit, aLissLimit
    Real                  :: vLissFacX,   vLissFacY,   aLissFacX,   aLissFacY
    Real                  :: vLissMaxXel, vLissMaxYel, aLissMaxXel, aLissMaxYel, lissMaxEl
    !
    Real                  :: vMaxX,   vMaxY,   vLimit
    Real                  ::                                     vLimitAz, vLimitEl
    Real                  :: vMaxXel, vMaxYel, MaxEl
    !
    Character(len=lenCh)   ::  sysName  = GPnone
    !
!!OLD    Type(conditionMinMax)  ::  condElevation                                         &
!!OLD         &                     = conditionMinMax("elevation",                        &
!!OLD         &                                        0.0, Pi/2.0,                       &
!!OLD         &                                       "rad",                              &
!!OLD         &                                       .False.         )                   ! 
    !
    Integer               :: iErr
    !
    optionSpeedIsPresent = .False.
    optionTotfIsPresent  = .False.
    alternative          = .False.
    !
    Include 'inc/ranges/rangesDIYlist.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &    " module DIYlist, 1.2.3 2013-06-25 ---> SR: Subscan ")             ! trace execution
    !
    !D     Write (6,*) " module DIYlist ---> SR: Subscan "
    !D     Write (6,*) "                          "
    !
    ! *** initialize ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    !     read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    Call checkNofParameters(command,                                             &
         &     0, 8,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    Call queryReceiver(rec%Bolo, isConnected, bolometerName = bolometerName)
    !
    If (   .Not.                                                                 &
         & (                                                                     &
!!$         &       GV%privilege.Eq.setPrivilege%GISMO                              &
         &       GV%privilege.Eq.setPrivilege%ncsTeam                            &
         &  .Or. isConnected.And.bolometerName.Eq.bolo%GISMO                     &
         &  .Or. isConnected.And.bolometerName.Eq.bolo%NIKA                      &
         & )    ) Then                                                           !
       ERROR = .True.
       Write (messageText, *) " requires privilege"
       Call pakoMessage(priorityE,severityE,command,                             &
            &           messageText)                                             !
    End If
    !
    ! *** check for alternative Options   ***
    If (.Not. ERROR) Then
       Include 'inc/options/alternativeSpeedTotf.inc'
    End If
    !
    Include 'inc/options/optionSubscanType.inc'
    !
    !D     Write (6,*) "   after optionSubscanType: "
    !D     Write (6,*) "         vars(iIn)%doTrack         ", vars(iIn)%doTrack        
    !D     Write (6,*) "         vars(iIn)%doLinearOtf     ", vars(iIn)%doLinearOtf    
    !D     Write (6,*) "         vars(iIn)%doLissajousOtf  ", vars(iIn)%doLissajousOtf 
    !D     Write (6,*) "         vars(iIn)%segType         ", vars(iIn)%segType
    !D     !
    !D     Write (6,*) "      nArguments: ", nArguments
    !D     Write (6,*) " "
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/parameters/parametersSegment.inc'
       Include 'inc/options/readOptionsSubscan.inc'
    End If
    !
    ! *** set defaults ***
    Include 'inc/options/optionDefaults.inc'
    !
    ! *** read Parameters, Options (again, after defaults!) ***
    !     and check for validity and ranges 
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/parameters/parametersSegment.inc'
       Include 'inc/options/readOptionsSubscan.inc'
       Include 'inc/options/alternativeSpeedTotfSet.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    !D     Write (6,*) "        -> vars(iIn)%doTune:   ", vars(iIn)%doTune
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.error) Then                                                           !! check consistency
       !
       !! condition for linear OTF, compare POINTING, OTFAMP. <-- 2012-10-30
       !
       errorInconsistent = .False.
       !
       !D        Write (6,*) "              vars(iIn)%doTrack:         ", vars(iIn)%doTrack
       !D        Write (6,*) "              vars(iIn)%doLinearOtf:     ", vars(iIn)%doLinearOtf
       !D        Write (6,*) "              vars(iIn)%doLissajousOtf:  ", vars(iIn)%doLissajousOtf
       !D        Write (6,*) "              vars(iIn)%doTune:          ", vars(iIn)%doTune
       !
       If      (      (vars(iIn)%doLinearOtf .Or. vars(iIn)%doLissajousOtf)      &
            &    .And. vars(iIn)%doTune                                          &
            &  ) Then                                                            !
          !
          errorInconsistent = .True.
          !
          Write (messageText, *) "/Tune only works with track subscans "
          Call pakoMESSAGE(priorityE,severityE,command,messageText)
          !
       End If
       !
       If (vars(iIn)%doLissajousOtf) Then
          !
          vLissMaxX  =   vars(iIn)%xAmplitude*GV%angleUnit * vars(iIn)%omegaX
          vLissMaxY  =   vars(iIn)%yAmplitude*GV%angleUnit * vars(iIn)%omegay
          !
          aLissMaxX  =   vars(iIn)%xAmplitude*GV%angleUnit * vars(iIn)%omegaX**2
          aLissMaxY  =   vars(iIn)%yAmplitude*GV%angleUnit * vars(iIn)%omegay**2
          !
          vLissLimit = 300.0*arcsec
          aLissLimit = 108.0*arcsec
          !
          !D           Write (6,*) "      vLissMaxX:  ", vLissMaxX
          !D           Write (6,*) "      vLissMaxY:  ", vLissMaxY
          !D           Write (6,*) "      aLissMaxX:  ", aLissMaxX
          !D           Write (6,*) "      aLissMaxY:  ", aLissMaxY
          !D           Write (6,*) "      vLissLimit: ", vLissLimit
          !D           Write (6,*) "      aLissLimit: ", aLissLimit
          !
          vLissFacX  = vLissMaxX/vLissLimit
          vLissFacY  = vLissMaxY/vLissLimit
          aLissFacX  = aLissMaxX/aLissLimit
          aLissFacY  = aLissMaxY/aLissLimit
          !
          !!          vLissLimit = Min(vLissLimit,300.0*arcsec)
          !!          aLissLimit = Min(aLissLimit,108.0*arcsec)
          !
          If (vLissMaxX.Gt.vLissLimit) Then
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("x max. speed = xAmplitude [",    F12.1,                  &
                  &    " ] * frequencyX [",            F12.4,                    &
                  &    " ] is too large by factor: ",  F12.3 )' )                &
                  & vars(iIn)%xAmplitude,                                        &
                  & vars(iIn)%frequencyX,                                        &
                  & vLissFacX                                                    !
             Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("to correct his, try: frequencyX  ", F12.4                &
                  &                                          )' )                &
                  & 0.999*vars(iIn)%frequencyX/(vLissFacX)                       !
             Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
             errorInconsistent = .True.
          End If
          !
          If (vLissMaxY.Gt.vLissLimit) Then
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("y max. speed = yAmplitude [",    F12.1,                  &
                  &    " ] * frequencyY [",            F12.4,                    &
                  &    " ] is too large by factor: ",  F12.3 )' )                &
                  & vars(iIn)%yAmplitude,                                        &
                  & vars(iIn)%frequencyY,                                        &
                  & vLissFacY                                                    !
             Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("to correct his, try: frequencyY  ", F12.4                &
                  &                                          )' )                &
                  & 0.999*vars(iIn)%frequencyY/(vLissFacY)                       !
             Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
             errorInconsistent = .True.
          End If
          !
          If (aLissMaxX.Gt.aLissLimit) Then
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("x max. acceleration = xAmplitude [",  F12.1,             &
                  &    " ] * frequencyX [",                 F12.4,               &
                  &    " ] ^2 is too large by factor: ",    F12.3 )' )           &
                  & vars(iIn)%xAmplitude,                                        &
                  & vars(iIn)%frequencyX,                                        &
                  & aLissFacX                                                    !
             Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("to correct his, try: frequencyX  ", F12.4                &
                  &                                          )' )                &
                  & 0.999*vars(iIn)%frequencyX/sqrt(aLissFacX)                   !
             Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
             errorInconsistent = .True.
          End If
          !
          If (aLissMaxY.Gt.aLissLimit) Then
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("y max. acceleration = yAmplitude [",  F12.1,             &
                  &    " ] * frequencyY [",                 F12.4,               &
                  &    " ] ^2 is too large by factor ",     F12.3 )' )           &
                  & vars(iIn)%yAmplitude,                                        &
                  & vars(iIn)%frequencyY,                                        &
                  & aLissFacY                                                    !
             Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("to correct his, try: frequencyY  ", F12.4                &
                  &                                          )' )                &
                  & 0.999*vars(iIn)%frequencyY/sqrt(aLissFacY)                   !
             Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
             errorInconsistent = .True.
          End If
          !
          !D   Write (6,*) "   vars(iIn)%doRampUp   ", vars(iIn)%doRampUp
          !D   Write (6,*) "   vars(iIn)%doRampDown ", vars(iIn)%doRampDown
          !
          If (.Not.vars(iIn)%doRampUp) Then
             Write (messageText,*) "/ramp up [tRamp] is RECOMMENDED for Lissajous"
             Call pakoMESSAGE(priorityW,severityW,"SUBSCAN",messageText)
!!$             errorInconsistent = .True.
          End If
!!$          If (.Not.vars(iIn)%doRampUp) Then
!!$             Write (messageText,*) "/ramp up [tRamp] is REQUIRED for Lissajous"
!!$             Call pakoMESSAGE(priorityE,severityE,"SUBSCAN",messageText)
!!$             errorInconsistent = .True.
!!$          End If
          !
          !  ** calculate maximum allowed elevation:
          !
          If (.Not.errorInconsistent) Then
             !
             vLissMaxXel = Acos(vLissMaxX/(2*vLissLimit))
             vLissMaxYel = Acos(vLissMaxY/(2*vLissLimit))
             !
             aLissMaxXel = Acos(aLissMaxX/(2*aLissLimit))  
             aLissMaxYel = Acos(aLissMaxY/(2*aLissLimit))  
             !
             If (         vars(iIn)%systemName.Eq.offsPako%tru                   &
                  &  .Or. vars(iIn)%systemName.Eq.offsPako%hor) Then             !
                lissMaxEl   = min(vLissMaxXel,aLissMaxXel)                         !! use only "x" offsets (Azimuth) for el. condition
             Else
                lissMaxEl   = min(vLissMaxXel,vLissMaxYel,                       &
                     &            aLissMaxXel,aLissMaxYel)                       !
             End If
             !
             !D              Write (6,*) " max el vLissMaxXel: ", vLissMaxXel/deg
             !D              Write (6,*) " max el vLissMaxYel: ", vLissMaxYel/deg
             !D              Write (6,*) " max el aLissMaxXel: ", aLissMaxXel/deg
             !D              Write (6,*) " max el aLissMaxYel: ", aLissMaxYel/deg
             !                                                                            
             !D              Write (6,*) " max el  lissMaxEl:  ", lissMaxEl/deg
             !
             ! 2010-04-08 HU: force safe limit on maximum elevation
             !                for GISMO run, based on TT-NCS
!!OLD             If      (GV%limitCheck.eq.setLimitCheck%loose) Then                 !! loose:   beyond limits for good tracking
!!OLD                lissMaxEl = lissMaxEl+5.0*deg
!!OLD             Else 
!!OLD             If (GV%limitCheck.eq.setLimitCheck%relaxed) Then                    !! relaxed: limits for good tracking
!!OLD                lissMaxEl = lissMaxEl
!!OLD             Else                                                                !! strict:  safe
             lissMaxEl = lissMaxEl-2.0*deg
!!OLD             End If
             !
             lissMaxEl   = min(lissMaxEl,85.0*deg)
             !D              Write (6,*) "  "
             !D              Write (6,*) " max el  lissMaxEl:  ", lissMaxEl/deg
             !
             !!             If (lissMaxEl.Ge.60.0*deg) Then
             !
             If (condElevation%isSet) Then                                         !! maximum elevation: minimum over subsans
                condElevation%maximum   = min(condElevation%maximum,lissMaxEl)
             Else
                condElevation%isSet     = .True.
                condElevation%maximum   = lissMaxEl
             End If
             !
             !D  Write (6,*) " condElevation%isSet:   ", condElevation%isSet
             !D  Write (6,*) " condElevation%maximum: ", condElevation%maximum/deg
             !
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("WARNING--CONDITION: Elevation must be less than ",       &
                  &     F10.2,                                                   &
                  &    " [deg] ")' )                                             &
                  & condElevation%maximum/deg                                    !
             Call pakoMESSAGE(priorityE+4,severityW,"DIY-SUBSCAN",messageText)
             !
          End If
             !
       End If   !!   vars(iIn)%doLissajousOtf
       !
       !
    End If   !!   .Not.error
    !
    If (.Not. errorInconsistent) Then
       vars(iTemp) = vars(iIn)
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** conclude alternative options   ***
    If (.Not.error) Then
       Include 'inc/options/alternativeSpeedTotfEnd.inc'
    End If
    !
    !D     Write (6,*) "   after alternativeSpeedTotfEnd.inc: "
    !D     Write (6,*) "         vars(iTemp)%doTrack         ", vars(iTemp)%doTrack        
    !D     Write (6,*) "         vars(iTemp)%doLinearOtf     ", vars(iTemp)%doLinearOtf    
    !D     Write (6,*) "         vars(iTemp)%doLissajousOtf  ", vars(iTemp)%doLissajousOtf 
    !D     Write (6,*) "         vars(iTemp)%segType         ", vars(iTemp)%segType
    !
    If (.Not. error) Then
       !
       errorInconsistent = .False.
       !
       If (vars(iIn)%doLinearOtf) Then
          !
          !D Write (6,*) "         -> will determine conditions for Linear OTF "
          !
          !! --> 2012-03-25:
          !
          If (         vars(iTemp)%systemName.Eq.offsPako%tru                    &
               &  .Or. vars(iTemp)%systemName.Eq.offsPako%hor) Then              !
             !
             vMaxX  =   Abs(vars(iTemp)%pEnd%x-vars(iTemp)%pStart%x)             &
                  &        /vars(iTemp)%tOtf                                     !
             vMaxY  =   Abs(vars(iTemp)%pEnd%y-vars(iTemp)%pStart%y)             &
                  &        /vars(iTemp)%tOtf                                     !
             !
          Else
             vMaxX  =   max(vars(iTemp)%speedStart, vars(iTemp)%speedEnd)
             vMaxY  =   max(vars(iTemp)%speedStart, vars(iTemp)%speedEnd)
          End If
          !
          !! NOTE:  code from here --> copied on 2012-05-30 from OTFMAP (2012-03-28)
          !! TBD:   extract this code, also use in OTFMAP, SUBSCAN OTF LINEAR
          !!        --> define / use local variable sysName in OTFMAP, SUBSCAN OTF LINEAR
          !! TBD:   long-term: ramp-up!
          !                        !!  speed limit az. axis, el. axis
          vLimit   = 200.0         !!  based on tests 2012-03-15 to -20
          !                                 
          !
          If      (     GV%privilege.Eq.setPrivilege%ncsTeam                     &
               &  .Or.  GV%userLevel.Eq.setUserLevel%experienced                 &
               &  ) Then                                                         !
             If (GV%limitCheck.Eq.setLimitCheck%relaxed) vLimit = 220.0
          End If
          If      (     GV%privilege.Eq.setPrivilege%ncsTeam                     &
               &  ) Then                                                         !
             If (GV%limitCheck.Eq.setLimitCheck%loose)   vLimit = 1200.0           !!  for tests 2013
!!normal:    If (GV%limitCheck.Eq.setLimitCheck%loose)   vLimit =  300.0           !!  normal
             If (GV%limitCheck.Eq.setLimitCheck%relaxed) vLimit =  220.0
          End If
          !
          vLimitAz = vLimit        !!  speed limit az axis
          vLimitEl = vLimit        !!  speed limit el axis
          !
          !! aLimit = 108.0*arcsec
          !
          If (GV%doDebugMessages) Then
             Write (6,*) " vMaxX:     ", vMaxX
             Write (6,*) " vMaxY:     ", vMaxY
             Write (6,*) " vLimit:    ", vLimit
             Write (6,*) " vLimitAz:  ", vLimitAz
             Write (6,*) " vLimitEl:  ", vLimitEl
          End If
          !
          sysName = vars(iTemp)%systemName
          !
          !! NOTE: using local variable sysName instead of vars(iTemp)%systemName:
          If (         sysName.Eq.offsPako%tru                                   &  
               &  .Or. sysName.Eq.offsPako%hor) Then                             !
             !
             If (vMaxX.Le.vLimitAz) Then
                vMaxXel = Acos(vMaxX/(vLimitAz))
             Else
                errorInconsistent = .true.
                Write (messageText,*) "Azimuth speed ", vMaxX,                   &
                     &                " too large for safe tracking"             !
                Call PakoMessage(priorityE,severityE,command,messageText)
             End If
             !
             If (vMaxY.Le.vLimitEl) Then
                vMaxYel = 90.0*deg
             Else
                errorInconsistent = .true.
                Write (messageText,*) "Elevation speed ", vMaxY,                 &
                     &                " too large for safe tracking"             !
                Call PakoMessage(priorityE,severityE,command,messageText)
             End If
             !
          Else
             !
             If (vMaxX.Le.vLimit .And. vMaxY.Le.vLimit) Then
                vMaxXel = Acos(vMaxX/(vLimit))
                vMaxYel = Acos(vMaxY/(vLimit))
             Else
                errorInconsistent = .true.
                Write (messageText,*) "Speed ", max(vMaxX,vMaxY),                &
                     &                " too large for safe tracking"             !
                Call PakoMessage(priorityE,severityE,command,messageText)
             End If
             !
          End If
          !
          If (GV%doDebugMessages) Then
             Write (6,*) " max el vMaxXel: ", vMaxXel/deg
             Write (6,*) " max el vMaxYel: ", vMaxYel/deg
          End If
          !
          !! <<-- 2012-03-25
          !
          !! aMaxXel = Acos(aMaxX/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
          !! aMaxYel = Acos(aMaxY/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
          !
          !D           Write (6,*) " max el  MaxEl:  ", MaxEl/deg
          !
          ! 2010-04-08 HU: force safe limit on maximum elevation
          !                for GISMO run, based on TT-NCS
          !
          If      (     GV%privilege.Eq.setPrivilege%ncsTeam                     & !! very loose for tests 2013
               &   .And.                                                         &
               &        GV%limitCheck.Eq.setLimitCheck%loose) Then               !
             !
             MaxEl  =  min(vMaxXel,vMaxYel)
             MaxEl  =  MaxEl-0.0*deg
             MaxEl  =  max(0.0*deg,MaxEl) 
             MaxEl  =  min(MaxEl,89.0*deg)
             !
          Else                                                                     !! normal limits
             !
             MaxEl = min(vMaxXel,vMaxYel)
             MaxEl  =  MaxEl-2.0*deg
             MaxEl  =  max(0.0*deg,MaxEl) 
             MaxEl  =  min(MaxEl,85.0*deg)
             !
          End If
          !
          Write (6,*) " max el  MaxEl:  ", MaxEl/deg
          !
          !
          !!             If (MaxEl.Ge.60.0*deg) Then
          !
          If (condElevation%isSet) Then                                            !! maximum elevation: minimum over subsans
             condElevation%maximum   = min(condElevation%maximum,MaxEl)
          Else
             condElevation%isSet     = .True.
             condElevation%maximum   = MaxEl
          End If
          !
          If (GV%doDebugMessages) Then
             Write (6,*) " condElevation%isSet:   ", condElevation%isSet
             Write (6,*) " condElevation%maximum: ", condElevation%maximum/deg
          End If
          !
          !! NOTE =: <-- copied on 2012-05-30 from OTFMAP (2012-03-28)
          !
          Write (messageText, fmt =                                              &
               &  '("WARNING--CONDITION: Elevation must be less than ",          &
               &     F10.2,                                                      &
               &    " [deg] ")' )                                                &
               & condElevation%maximum/deg                                       !
          Call pakoMESSAGE(priorityE+4,severityW,"POINTING",messageText)
          !
       End If   !!   vars(iIn)%doLinearOtf
       !
    End If   !!   .Not. error
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)    = vars(iTemp)
    End If
    !
    !D     Write (6,*) "        -> vars(iValue)%doTune:   ", vars(iValue)%doTune
    !
    ! *** display values ***
    ! 
    ! *** 
    If (.Not.error) Then
       !
       If (vars(iValue)%doLinearOtf) Then
          If (vars(iValue)%doRampUp) Then
             Write (messageText,*)  "Up ", vars(iValue)%tRampUp, " [sec]"
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
          If (vars(iValue)%doRampDown) Then
             Write (messageText,*)  "Down ", vars(iValue)%tRampDown, " [sec]"
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
          If (.Not.(vars(iValue)%doRampUp.Or.vars(iValue)%doRampDown)) Then
             Write (messageText,*)  ramp%none
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
       End If
       !
       If (vars(iValue)%doLissajousOtf) Then
          If (vars(iValue)%doRampUp) Then
             Write (messageText,*)  "Up ", vars(iValue)%tRampUp, " [sec]"
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
          If (vars(iValue)%doRampDown) Then
             Write (messageText,*)  "Down ", vars(iValue)%tRampDown, " [sec]"
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
          If (.Not.(vars(iValue)%doRampUp.Or.vars(iValue)%doRampDown)) Then
             Write (messageText,*)  ramp%none
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
       End If
       !
       GV%condElevation     = condElevation
       !D        Write (6,*) "GV%condElevation: ", GV%condElevation
       !
       GV%omSystemName      = vars(iValue)%systemName 
       GV%notReadySWafterOM = .False.
       GV%notReadySecondaryRafterOM = .False.
       SubscanCommand         = line(1:lenc(line))
       Call analyzeSubscan (errorA)
       error = error.Or.errorA
    End If
    !
    If (.Not. error) Then
       Call displaySubscan
    End If
    !
    Return
  End Subroutine Subscan
!!!
!!!
  Subroutine analyzeSubscan (errorA)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer                :: nScan 
    Character (len=lenCh)  :: aUnit, sUnit
    Integer                :: iSS           = 0     ! counts subcans/segment
    !
    Integer                :: iQuery
    Character(len=lenCh)   :: nameQuery
    Logical                :: isSet
    Type(xyPointType)      :: pointResult
    !
    Real                   :: delta = 0.1499850     !!
    !
    Integer                :: nSub, nSeg
    !
    errorA    = .False.
    !
!!$    Call pako_message(seve%t,'paKo',                                             &
!!$         &    " module DIYlist, 1.2.2 2013-01-22 ---> SR: analyzeSubscan ")      ! trace execution
!!$    Call pako_message(seve%t,'paKo',                                             &
!!$         &    " module DIYlist, 1.2.3 2013-04-29 ---> SR: analyzeSubscan ")      ! trace execution
    Call pako_message(seve%t,'paKo',                                             &
         &    " module DIYlist, 1.2.3 2013-10-29 ---> SR: analyzeSubscan ")      ! trace execution
    !
    ii        = 0
    jj        = 0
    iSS       = 1
    nScan     = 1111
    aUnit     = GV%angleUnitC                        ! 
    sUnit     = GV%speedUnitC                        ! 
    !
    Call getCountSubscans(nSub)
    !D     Write (6,*) "     nSub:   ", nSub
    If (nSub.Ge.99) Then
       errorA    = .True.
       Write (messageText,*)  " too many subscans. maximum: ", 99
       Call pakoMESSAGE(priorityE,severityE,"Subscan",messageText)
    End If
    !
    !D     Write (6,*) "     nLissajous:   ", nLissajous
    !
    Call getCountSegments(nSeg)
    !D     Write (6,*) "     nSeg:   ", nSeg
    !
    If (vars(iValue)%segType.Eq.seg%lissajous) Then
       !
       If (   .Not.                                                              &
            &      (     .False.                                                 &
!! Test     &       .Or. GV%privilege.Eq.setPrivilege%GISMO                      &
            &       .Or. GV%privilege.Eq.setPrivilege%ncsTeam                    &
            &      )                                                             &
            & .And.                                                              &
            &      nLissajous.Ge.1 ) Then                                        !
          errorA = .True.
          Write (messageText, *)                                                 &
               &       "more than 1 Lissajous subscan requires privilege"        !
          Call pakoMessage(priorityE,severityE,"Subscan",messageText)
          Write (messageText, *)                                                 &
               &       "enter DIY /CLEAR first "                                 !
          Call pakoMessage(priorityI,severityI,"Subscan",messageText)
       End If
       !
       If (nSegments.Ge.99-1) Then   !!  99-1 because Lissajous makes 2 segments
          errorA    = .True.
          Write (messageText,*)  " too many segments. maximum: ", 99
          Call pakoMESSAGE(priorityE,severityE,"Subscan",messageText)
       End If
       !
    Else
       ! 
       If (nSegments.Ge.99) Then
          errorA    = .True.
          Write (messageText,*)  " too many segments. maximum: ", 99
          Call pakoMESSAGE(priorityE,severityE,"Subscan",messageText)
       End If
       !
    End If
    !
    If (vars(iValue)%segType.Eq.seg%linear) Then
       !
       If (   .Not.                                                              &
            &      (     .False.                                                 &
!!OLD       &       .Or. GV%privilege.Eq.setPrivilege%GISMO                      &
            &       .Or. GV%privilege.Eq.setPrivilege%ncsTeam                    &
            &       .Or. isConnected.And.bolometerName.Eq.bolo%NIKA              &
!!OLD       &       .Or. GV%privilege.Eq.setPrivilege%staff                      &
            &      )                                                             &
            &      ) Then                                                        !
          errorA = .True.
          Write (messageText, *)                                                 &
               &       ss%otf , " ", seg%linear, " subscan requires privilege"   !
          Call pakoMessage(priorityE,severityE,"Subscan",messageText)
       End If
       !
    End If
    !
    If (.Not. errorA) Then
       !
       !!  ** 
       Call countSubscans(ii)
!!$       Call countSegments(jj)
       !
       !D        Write (6,*) "       ii: ", ii
       !D        Write (6,*) "       jj: ", jj
       !D        Write (6,*) "  segType: ", vars(iValue)%segType
       !
       ! TBD: calibrate subscans 
       !
       ! TBD: segment parameters to defaults
       !
       If (vars(iValue)%segType.Eq.seg%track) Then
          !
          Call countSegments(jj)
          !
          segList(jj)%newSubscan =  .True.
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  1
          segList(jj)%ssType     =  ss%track
          segList(jj)%segType    =  seg%track
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
          If      (vars(iValue)%croFlag.Eq."O") Then
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          Else If (vars(iValue)%croFlag.Eq."R") Then
             segList(jj)%flagOn     =  .False.
             segList(jj)%flagRef    =  .True.
          Else
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          End If
          !
          segList(jj)%flagDropin    =  .False.
          !
          segList(jj)%flagTune      =  vars(iIn)%doTune
          !
          segList(jj)%pStart     =  vars(iValue)%offset
          segList(jj)%pEnd       =  segList(jj)%pStart
          segList(jj)%speedStart =  0.0
          segList(jj)%speedEnd   =  0.0
          segList(jj)%systemName =  vars(iValue)%systemName
          segList(jj)%altOption  =  'tSegment'
          segList(jj)%tSegment   =  vars(iValue)%tSubscan
          segList(jj)%tRecord    =  0.1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !
          If (jj.Eq.1) Then
             segList(jj)%updateDoppler = .True.
             If (vars(iValue)%systemName.Eq.offs%pro) Then
                segList(jj)%pDoppler      = vars(iValue)%offset
                segList(jj)%pDoppler      = xyPointType(0.0,0.0)        !  TBD: this is only a quick fix
             Else
                segList(jj)%pDoppler      = xyPointType(0.0,0.0)
             End If
             If (isSet .And. vars(iValue)%systemName.Ne.offs%pro) Then  !  OFFSETS /SYS PROJ
                segList(jj)%pDoppler      = pointResult
             End If
          Else If (GV%doDopplerUpdates) Then
             segList(jj)%updateDoppler = .True.
             If (vars(iValue)%systemName.Eq.offs%pro) Then
                segList(jj)%pDoppler      = vars(iValue)%offset
             Else
                segList(jj)%pDoppler      = xyPointType(0.0,0.0)
             End If
             If (isSet .And. vars(iValue)%systemName.Ne.offs%pro) Then  !  OFFSETS /SYS PROJ
                segList(jj)%pDoppler      = pointResult
             End If
          End If
          !
          !D       Write (6,*) "jj, GV%doDopplerUpdates:  ", jj, GV%doDopplerUpdates
          !D       Write (6,*) "jj, segList(jj)%pDoppler: ", jj, segList(jj)%pDoppler
          !
       Else If (vars(iValue)%segType.Eq.seg%linear) Then
          !
          !D           Write (6,*) "      -> OTF linear "
          !
          If (vars(ivalue)%doRampUp) Then     !!     determine details for RampUp
             !
             !D              Write (6,*) " "
             !D              Write (6,*) "            doRampUp                  ", vars(ivalue)%doRampUp  
             !D              Write (6,*) "            tRampUp                   ", vars(ivalue)%tRampUp
             !D              Write (6,*) "            doInternal                ", vars(ivalue)%doInternal
             !D              !
             !D              Write (6,*) "            vars(iValue)%pStart       ", vars(iValue)%pStart 
             !D              Write (6,*) "            vars(iValue)%pEnd         ", vars(iValue)%pEnd      
             !D              Write (6,*) "            vars(iValue)%lengthOtf    ", vars(iValue)%lengthOtf
             !D              Write (6,*) "            vars(iValue)%speedStart   ", vars(iValue)%speedStart 
             !
             pStart = vars(iValue)%pStart
             vStart%x = vars(iValue)%speedStart                                  &
                  &        * (vars(iValue)%pEnd%x-vars(iValue)%pStart%x)         &
                  &        / vars(iValue)%lengthOtf                              !
             vStart%y = vars(iValue)%speedStart                                  &
                  &        * (vars(iValue)%pEnd%y-vars(iValue)%pStart%y)         &
                  &        / vars(iValue)%lengthOtf                              !
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             !D              Write (6,*) "            pStart    ", pStart
             !D              Write (6,*) "            vStart    ", vStart
             !
             !
             accelMax = 0.03*degree                                       !  maximum aceleration in [rad/s^2]
             tAccel   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If (tAccel.Lt.vars(ivalue)%tRampUp) Then
                !D                 Write (6,*) "             tAccel:    ", tAccel,                  &
                !D                      &      " will be increased to ", vars(ivalue)%tRampUp       !
                tAccel = vars(ivalue)%tRampUp
             End If
             !
!!$             If (tAccel.Lt.5) Then
!!$                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to 5 [sec]"
!!$                tAccel = 5
!!$             End If
             !
             If (vars(ivalue)%doInternal) Then 
                pAccel%x = pStart%x +0.5*vstart%x*tAccel
                pAccel%y = pStart%y +0.5*vstart%y*tAccel
             Else
                pAccel%x = pStart%x -0.5*vstart%x*tAccel
                pAccel%y = pStart%y -0.5*vstart%y*tAccel
             End If
             !
             !D              Write (6,*) "            tAccel   ", tAccel
             !D              Write (6,*) "            pAccel   ", pAccel
             !
             lAccel = sqrt((pStart%x-pAccel%x)**2 + (pStart%y-pAccel%y)**2 )
             !
             !D              Write (6,*) "            lAccel   ", lAccel
             !
          End If     !!     (vars(ivalue)%doRampUp) 
          !
          If (vars(ivalue)%doRampDown) Then     !!     determine details for RampDown
             !
             !D              Write (6,*) " "
             !D              Write (6,*) "            doRampDown                ", vars(ivalue)%doRampDown  
             !D              Write (6,*) "            tRampDown                 ", vars(ivalue)%tRampDown
             !D              Write (6,*) "            doInternal                ", vars(ivalue)%doInternal
             !D              !
             !D              Write (6,*) "            vars(iValue)%pStart       ", vars(iValue)%pStart 
             !D              Write (6,*) "            vars(iValue)%pEnd         ", vars(iValue)%pEnd      
             !D              Write (6,*) "            vars(iValue)%lengthOtf    ", vars(iValue)%lengthOtf
             !D              Write (6,*) "            vars(iValue)%speedEnd     ", vars(iValue)%speedEnd 
             !
             pEnd = vars(iValue)%pEnd
             vEnd%x = vars(iValue)%speedEnd                                      &
                  &        * (vars(iValue)%pEnd%x-vars(iValue)%pStart%x)         &
                  &        / vars(iValue)%lengthOtf                              !
             vEnd%y = vars(iValue)%speedEnd                                      &
                  &        * (vars(iValue)%pEnd%y-vars(iValue)%pStart%y)         &
                  &        / vars(iValue)%lengthOtf                              !
             vEnd%speed = sqrt(vEnd%x**2+vEnd%y**2)
             !
             !D              Write (6,*) "            pEnd    ", pEnd
             !D              Write (6,*) "            vEnd    ", vEnd
             !
             !
             accelMax = 0.03*degree                                      !  maximum aceleration in [rad/s^2]
             tStop   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If (tStop.Lt.vars(ivalue)%tRampDown) Then
                !D                 Write (6,*) "             tStop:    ", tStop,                    &
                !D                      &      " will be increased to ", vars(ivalue)%tRampDown     !
                tStop = vars(ivalue)%tRampDown
             End If
             !
!!$             If (tStop.Lt.5) Then
!!$                !D              Write (6,*) "             tStop:    ", tStop, " will be increased to 5 [sec]"
!!$                tStop = 5
!!$             End If
             !
             If (vars(ivalue)%doInternal) Then 
                pStop%x = pEnd%x -0.5*vEnd%x*tStop
                pStop%y = pEnd%y -0.5*vEnd%y*tStop
             Else
                pStop%x = pEnd%x +0.5*vEnd%x*tStop
                pStop%y = pEnd%y +0.5*vEnd%y*tStop
             End If
             !
             !D              Write (6,*) "            tStop   ", tStop
             !D              Write (6,*) "            pStop   ", pStop
             !
             lStop = sqrt((pEnd%x-pStop%x)**2 + (pEnd%y-pStop%y)**2 )
             !
             !D              Write (6,*) "            lStop   ", lStop
             !
          End If     !!     vars(ivalue)%doRampDown)
          !
          !
          If (vars(ivalue)%doRampUp) Then     !!     add RampUp to segment list
             !
             Call countSegments(jj)
             !
             If (jj.Eq.1) Then
                segList(jj)%newSubscan =  .True.                                 
             Else 
                If (vars(ivalue)%doNextSubscan) Then
                   segList(jj)%newSubscan =  .True.                              
                Else
                   segList(jj)%newSubscan =  .False.                             
                End If
             End If
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "      "
                Write (6,*) "      jj :                         ", jj
                Write (6,*) "      vars(ivalue)%doRampUp :      ", vars(ivalue)%doRampUp
                Write (6,*) "      vars(ivalue)%doNextSubscan : ", vars(ivalue)%doNextSubscan
                Write (6,*) "      segList(jj)%newSubscan :     ", segList(jj)%newSubscan
                Write (6,*) "      "
             End If
             !
             segList(jj)%scanNumber =  nScan
             segList(jj)%ssNumber   =  jj
             segList(jj)%segNumber  =  1
             segList(jj)%ssType     =  ss%otf
             segList(jj)%segType    =  seg%linear
             segList(jj)%angleUnit  =  aUnit
             segList(jj)%speedUnit  =  sUnit
             !
             If      (vars(iValue)%croFlag.Eq."O") Then
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             Else If (vars(iValue)%croFlag.Eq."R") Then
                segList(jj)%flagOn     =  .False.
                segList(jj)%flagRef    =  .True.
             Else
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             End If
             !
             segList(jj)%flagDropin    =  .True.
             !
             segList(jj)%lengthOtf  =  lAccel
             !
             If (vars(ivalue)%doInternal) Then
                segList(jj)%pStart     =  vars(iValue)%pStart
                segList(jj)%pEnd       =  pAccel 
             Else
                segList(jj)%pStart     =  pAccel
                segList(jj)%pEnd       =  vars(iValue)%pStart
             End If
             !
             segList(jj)%speedStart =  0.0
             segList(jj)%speedEnd   =  1.0001*vStart%speed      !!  IMPORTANT: needed to get smoothly "into" linear OTF ??
             !                                                  !!  TBD:       check /optimize
             segList(jj)%systemName =  vars(iValue)%systemName
             segList(jj)%altOption  =  'SPEED'                  !!  TBD:       debug/generalize
             segList(jj)%tSegment   =  tAccel
             segList(jj)%tRecord    =  0.1
             !
          End If     !!    (vars(ivalue)%doRampUp)
          !
          !                              !!     add OTF segment to list
          Call countSegments(jj)
          !
          If (vars(ivalue)%doRampUp) Then                                        
             segList(jj)%newSubscan =  .False.                                   
          Else                                                                   
             If (vars(ivalue)%doNextSubscan) Then
                segList(jj)%newSubscan =  .True.                              
             Else
                segList(jj)%newSubscan =  .False.                             
             End If
          End If                                                                 
          !
          If (GV%doDebugMessages) Then
             Write (6,*) "      "
             Write (6,*) "      jj :                         ", jj
             Write (6,*) "      vars(ivalue)%doRampUp :      ", vars(ivalue)%doRampUp
             Write (6,*) "      vars(ivalue)%doNextSubscan : ", vars(ivalue)%doNextSubscan
             Write (6,*) "      segList(jj)%newSubscan :     ", segList(jj)%newSubscan
             Write (6,*) "      "
          End If
          !
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  1
          segList(jj)%ssType     =  ss%otf
          segList(jj)%segType    =  seg%linear
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
          If      (vars(iValue)%croFlag.Eq."O") Then
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          Else If (vars(iValue)%croFlag.Eq."R") Then
             segList(jj)%flagOn     =  .False.
             segList(jj)%flagRef    =  .True.
          Else
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          End If
          !
          segList(jj)%flagDropin    =  .False.
          !
          segList(jj)%pStart     =  vars(iValue)%pStart
          segList(jj)%pEnd       =  vars(iValue)%pEnd
          !
          segList(jj)%tSegment   =  vars(iValue)%tOtf
          !
          If ( vars(ivalue)%doRampUp .And. vars(ivalue)%doInternal ) Then
             segList(jj)%pStart     =  pAccel
!!$             segList(jj)%tSegment   =  segList(jj)%tSegment-tAccel
          End If
          !
          If ( vars(ivalue)%doRampDown .And. vars(ivalue)%doInternal ) Then
             segList(jj)%pEnd       =  pStop
!!$             segList(jj)%tSegment   =  segList(jj)%tSegment-tStop
          End If
          !
          segList(jj)%lengthOtf  =  sqrt(                                        &
               &                 (segList(jj)%pEnd%x-segList(jj)%pStart%x)**2    &
               &               + (segList(jj)%pEnd%y-segList(jj)%pStart%y)**2    &
               &                        )                                        !
          segList(jj)%speedStart =  vars(iValue)%speedStart
          segList(jj)%speedEnd   =  vars(iValue)%speedEnd
          segList(jj)%tSegment   =  segList(jj)%lengthOtf /                      &
               &         (0.5 * (segList(jj)%speedStart+segList(jj)%speedEnd) )  !
          !
          segList(jj)%systemName =  vars(iValue)%systemName
          segList(jj)%altOption  =  'TOTF'
          segList(jj)%tRecord    =  0.1
          !
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !
          !
          If (vars(ivalue)%doRampDown) Then     !!     add RampDown to segment list
             !
             Call countSegments(jj)
             !
             segList(jj)%newSubscan =  .False.
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "      "
                Write (6,*) "      jj :                         ", jj
                Write (6,*) "      vars(ivalue)%doRampDown :    ", vars(ivalue)%doRampDown
                Write (6,*) "      vars(ivalue)%doNextSubscan : ", vars(ivalue)%doNextSubscan
                Write (6,*) "      segList(jj)%newSubscan :     ", segList(jj)%newSubscan
                Write (6,*) "      "
             End If
             !
             segList(jj)%scanNumber =  nScan
             segList(jj)%ssNumber   =  jj
             segList(jj)%segNumber  =  1
             segList(jj)%ssType     =  ss%otf
             segList(jj)%segType    =  seg%linear
             segList(jj)%angleUnit  =  aUnit
             segList(jj)%speedUnit  =  sUnit
             !
             If      (vars(iValue)%croFlag.Eq."O") Then
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             Else If (vars(iValue)%croFlag.Eq."R") Then
                segList(jj)%flagOn     =  .False.
                segList(jj)%flagRef    =  .True.
             Else
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             End If
             !
             segList(jj)%flagDropin    =  .True.
             !
             segList(jj)%lengthOtf  =  lStop
             !
             If (vars(ivalue)%doInternal) Then
                segList(jj)%pStart     =  pStop
                segList(jj)%pEnd       =  vars(iValue)%pEnd
             Else
                segList(jj)%pStart     =  vars(iValue)%pEnd
                segList(jj)%pEnd       =  pStop
             End If
             !
             segList(jj)%speedStart =  0.9999*vEnd%Speed        !!  IMPORTANT: needed to get smoothly "into" linear OTF ?? GUESS ??
             segList(jj)%speedEnd   =  0.0+delta                !!  do NOT slow down to 0.0 to avoid bug in antennaMD 
             !                                                  !!  cp TT NCS 2013-08-09 scans 167 168 169
             !                                                  !!  TBD:       check /optimize
             segList(jj)%systemName =  vars(iValue)%systemName  
             segList(jj)%altOption  =  'SPEED'                  !!  TBD:       debug/generalize
             segList(jj)%tSegment   =  tStop
             segList(jj)%tRecord    =  0.1
             !
          End If     !!    (vars(ivalue)%doRampDown)
          !
          !
       Else If (vars(iValue)%segType.Eq.seg%lissajous) Then
          !
          !D        Write (6,*) "      -> OTF Lissajous "
          !
          ! derived parameters positions in GV%angleUnit, speeds in GV%angleUnit/[s]
          ! derived parameters all other in [s], [rad], [rad/s], [rad/s^2]
          !
          !D        Write (6,*) "            doRampUp   ", vars(ivalue)%doRampUp
          !D        Write (6,*) "            doRampDown ", vars(ivalue)%doRampDown
          !
          If (vars(ivalue)%doRampUp) Then
             !
             !D           Write (6,*) "            tRampUp   ", vars(ivalue)%tRampUp
             !D           Write (6,*) "            tRampDown ", vars(ivalue)%tRampDown
             !
             pStart%x = vars(iValue)%pCenter%x + vars(iValue)%xAmplitude * sin(vars(iValue)%phiX)
             pStart%y = vars(iValue)%pCenter%y + vars(iValue)%yAmplitude * sin(vars(iValue)%phiY)
             vStart%x = vars(iValue)%omegaX    * vars(iValue)%xAmplitude * cos(vars(iValue)%phiX)
             vStart%y = vars(iValue)%omegaY    * vars(iValue)%yAmplitude * cos(vars(iValue)%phiY)
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             accelMax = 0.03*degree                                       !  maximum aceleration in [rad/s^2]
             tAccel   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If (tAccel.Lt.vars(ivalue)%tRampUp) Then
                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to ", vars(ivalue)%tRampUp
                tAccel = vars(ivalue)%tRampUp
             End If
             !
             If (tAccel.Lt.5) Then
                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to 5 [sec]"
                tAccel = 5
             End If
             !
             pAccel%x = pStart%x -0.5*vstart%x*tAccel
             pAccel%y = pStart%y -0.5*vstart%y*tAccel
             !
             Call countSegments(jj)
             !
             segList(jj)%newSubscan =  .True.
             segList(jj)%scanNumber =  nScan
             segList(jj)%ssNumber   =  jj
             segList(jj)%segNumber  =  1
             segList(jj)%ssType     =  ss%otf
             segList(jj)%segType    =  seg%linear
             segList(jj)%angleUnit  =  aUnit
             segList(jj)%speedUnit  =  sUnit
             !
             If      (vars(iValue)%croFlag.Eq."O") Then
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             Else If (vars(iValue)%croFlag.Eq."R") Then
                segList(jj)%flagOn     =  .False.
                segList(jj)%flagRef    =  .True.
             Else
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             End If
             !
             segList(jj)%flagDropin    =  .True.
             !
             segList(jj)%lengthOtf  =  vars(iValue)%lengthOtf    !!! FIX ME !!!
             segList(jj)%pStart     =  pAccel
             segList(jj)%pEnd       =  pStart
             segList(jj)%speedStart =  0.0
             segList(jj)%speedEnd   =  1.0001*vStart%speed      !!  IMPORTANT: needed to get smoothly "into" Lissajous
             !                                                  !!  TBD:       check /optimize
             segList(jj)%systemName =  vars(iValue)%systemName
             segList(jj)%altOption  =  'SPEED'                  !!  TBD:       debug/generalize
             segList(jj)%tSegment   =  tAccel
             segList(jj)%tRecord    =  0.1
             !
          End If     !!    If (vars(ivalue)%doRampUp) Then
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !D       Write (6,*) "       jj: ", jj
          !
          !D       Write (6,*) "             Lissajous Segment"
          !
          Call countSegments(jj)
          !
          segList(jj)%newSubscan =  .False.                      !!  TBD: handle case no ramp --> newSubscan .True.
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  2
          segList(jj)%ssType     =  ss%otf
          segList(jj)%segType    =  seg%lissajous
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
          If      (vars(iValue)%croFlag.Eq."O") Then
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          Else If (vars(iValue)%croFlag.Eq."R") Then
             segList(jj)%flagOn     =  .False.
             segList(jj)%flagRef    =  .True.
          Else
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          End If
          !
          segList(jj)%flagDropin    =  .False.
          !
          segList(jj)%pCenter    =  vars(iValue)%pCenter
          segList(jj)%xAmplitude =  vars(iValue)%xAmplitude
          segList(jj)%yAmplitude =  vars(iValue)%yAmplitude
          segList(jj)%omegaX     =  vars(iValue)%omegaX    
          segList(jj)%omegaY     =  vars(iValue)%omegaY    
          segList(jj)%phiX       =  vars(iValue)%phiX      
          segList(jj)%phiY       =  vars(iValue)%phiY      
          !
          segList(jj)%systemName =  vars(iValue)%systemName
          segList(jj)%altOption  =  'TOTF'
          segList(jj)%tSegment   =  vars(iValue)%tOtf
          segList(jj)%tRecord    =  0.1
          !
          nLissajous = nLissajous+1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !
       End If
       !
    End If
    !
    Call getCountSegments(nSegments)
    !
    !D     Write (6,*) "         nSegments:   ", nSegments
    !D     Write (6,*) "         segList(jj): "
    !D     Write (6,*)                          segList(jj)
    !
    Return 
    !
  End Subroutine analyzeSubscan
!!!
!!!
  Subroutine displayDIYlist
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Include 'inc/display/commandDisplayDIYlist.inc'
    !
  End Subroutine displayDIYlist
!!!
!!!
  Subroutine displaySubscan
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Include 'inc/display/commandDisplaySubscan.inc'
    !
  End Subroutine displaySubscan
!!!
!!!
  Subroutine listDIYlist(error)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical            :: error
    Integer            :: ierr
    !
    Real               :: fX, fY
    ! 
    Call getCountSegments(nSegments)
    !
    Call pako_message(seve%t,'paKo',                                             &
         &    " module DIYlist, 1.2.3.2 2014-12-04 ---> SR: listDIYlist ")       ! !! Trace execution
    !
    If (nSegments.Ge.1) Then
       Write (messageText,*)  "  segments #: 1 to ", nSegments
       l = Len_trim(GV%observingMode)    
       !! Call pakoMESSAGE(priorityI,severityI,GV%observingMode(1:l),messageText)  !!  TBD: recover!
       Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
    End If
    !
    If (nSegments.Ge.1) Then
       !
       Do ii = 1, nSegments, 1
          !
          If (segList(ii)%ssType .Eq. ss%otf                                     &
               &   .And. segList(ii)%segType .Eq. seg%lissajous) Then            ! !!  Lissajous
             !
             ierr = 1
             If (segList(ii)%flagOn) Then
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3, " ",A, " ",A, " Amplitude ",2F12.1, " ",2A)' )     &
                     &  ii,                                                      &
                     &  segList(ii)%segType,     traceflag%on,                   &
                     &  segList(ii)%xAmplitude,                                  &  
                     &  segList(ii)%yAmplitude,                                  &  
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName                                   !
             Else If (segList(ii)%flagRef) Then
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3, " ",A, " ",A, " Amplitude ",2F12.1, " ",2A)' )     &
                     &  ii,                                                      &
                     &  segList(ii)%segType,     traceflag%ref,                  &
                     &  segList(ii)%xAmplitude,                                  &  
                     &  segList(ii)%yAmplitude,                                  &  
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName                                   !
             End If
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
             fX = segList(ii)%omegaX/(2*Pi)
             fY = segList(ii)%omegaY/(2*Pi)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("___",  " Frequency ", 2F12.5, " [Hz] ",                  &
                  &            " Omega ",     2F12.5, " [rad/s] ",               &
                  &                            F12.5, " [s] " ) ' )              &
                  &  fX, fY,                                                     &
                  &  segList(ii)%omegaX    ,                                     &  
                  &  segList(ii)%omegaY    ,                                     &  
                  &  segList(ii)%tsegment                                        !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("___",  " Center ", 2F12.1, " ", A, " Phi ",              &
                  &                        2F12.5, " [rad] " ) ' )               &
                  &  segList(ii)%pCenter%x/GV%angleFactorR,                      &
                  &  segList(ii)%pCenter%y/GV%angleFactorR,                      &
                  &  GV%angleUnitSetC   ,                                        &
                  &  segList(ii)%phiX   ,                                        &  
                  &  segList(ii)%phiY                                            !
             Call pakoMESSAGE(max(1,priorityI-1),severityI,'DIY',messageText)
             !
          Else If (segList(ii)%ssType .Eq. ss%otf) Then                          !  !!  OTF 
             !
!!$             Write (6,*) " ii :                     ", ii
!!$             Write (6,*) " segList(ii)%newSubscan : ", segList(ii)%newSubscan
             If (segList(ii)%newSubscan) Then
                !                                                                 
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '( A                                                     &
                     &  )'  )                                                    &
                     &  "new SUBSCAN : "                                         !
                Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
                !                
             End If
             !
             If (.Not.segList(ii)%flagDropin) Then
                !
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3," ",  A, 2F12.1," to ", 2F12.1, " ", A," ", A       &
                     &  )'  )                                                    &
                     &  ii,                                                      &
                     &  segList(ii)%ssType,                                      &
                     &  segList(ii)%pStart%x/GV%angleFactorR,                    &
                     &  segList(ii)%pStart%y/GV%angleFactorR,                    &
                     &  segList(ii)%pEnd%x/GV%angleFactorR,                      &
                     &  segList(ii)%pEnd%y/GV%angleFactorR,                      &
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName                                   !
                !
             Else
                !
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3," ",  A, 2F12.1," to ", 2F12.1, " ", A," ", A       &
                     &       " drop-in "                                         &
                     &  )'  )                                                    &
                     &  ii,                                                      &
                     &  segList(ii)%ssType,                                      &
                     &  segList(ii)%pStart%x/GV%angleFactorR,                    &
                     &  segList(ii)%pStart%y/GV%angleFactorR,                    &
                     &  segList(ii)%pEnd%x/GV%angleFactorR,                      &
                     &  segList(ii)%pEnd%y/GV%angleFactorR,                      &
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName                                   !
                !
             End If
             !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("___",                                                    &
                  &    " tOtf ",   F12.5, " [s]",                                &
                  &    " speed ", 2F12.5, " [", A, "/s]"                         &
                  &  )'  )                                                       &
                  &  segList(ii)%tsegment,                                       &
                  &  segList(ii)%speedStart,                                     &
                  &  segList(ii)%speedEnd,                                       &
                  &  GV%angleUnitSetC                                            !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
             If (ierr.Ne.0) Then
                Write (messageText, *)                                           &
                     &  ii,                                                      &
                     &  segList(ii)%ssType,                                      &
                     &  segList(ii)%pStart%x/GV%angleFactorR,                    &
                     &  segList(ii)%pStart%y/GV%angleFactorR,                    &
                     &  segList(ii)%pEnd%x/GV%angleFactorR,                      &
                     &  segList(ii)%pEnd%y/GV%angleFactorR,                      &
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName,                                  &
                     &  segList(ii)%tsegment                                     !
                Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             End If                                        !
             !
          Else If (segList(ii)%ssType .Eq. ss%cs) Then                           !  !!  CS
             Write (messageText,*)  "  subscan #:   ", ii," ",                   &
                  &  segList(ii)%ssType," ",                                     &
                  &  "at ",   segList(ii)%pStart%x/GV%angleFactorR," ",          &
                  &           segList(ii)%pStart%y/GV%angleFactorR," ",          &
                  &  GV%angleUnitSetC                                            !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
          Else If (segList(ii)%ssType.Eq.ss%ca .Or.                              & !!  CA, CC
               &   segList(ii)%ssType .Eq. ss%cc) Then                           !
             If (segList(ii)%sideBand.Ne.GPnone) Then
                Write (messageText,*)  "  subscan #:   ", ii," ",                &
                     &  segList(ii)%ssType," ",                                  &
                     &  segList(ii)%sideBand                                     !
             Else
                Write (messageText,*)  "  subscan #:   ", ii," ",                &
                     &  segList(ii)%ssType                                       !
             End If
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
!!$          Else If (segList(ii)%ssType .Eq. ss%track) Then                     
          Else If (     segList(ii)%ssType .Eq. ss%track                         &   !!  TRACK
               &   .Or. segList(ii)%ssType .Eq. ss%ref                           &   !!  REF
               &   .Or. segList(ii)%ssType .Eq. ss%tune                          &   !!  TUNE
               &  ) Then                                                         !   
             !
             If (segList(ii)%flagTune) Then                                      !   !!     -> NIKA tune
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3," ", A,A, "at ", 2F12.1, " [", A,"] ",              &
                     &   A, F12.5," [s] ", A)   '                                &
                     &  )                                                        &
                     &           ii,                                             &
                     &           segList(ii)%ssType,traceflag%on,                &
                     &           segList(ii)%pStart%x/GV%angleFactorR,           &
                     &           segList(ii)%pStart%y/GV%angleFactorR,           &
                     &           GV%angleUnitSetC,                               &
                     &           segList(ii)%systemName,                         &
                     &           segList(ii)%tsegment,                           &
                     &           " /Tune "                                       !
                Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
                !
             Else If (.Not.segList(ii)%flagTune) Then                            !  !!     -> not NIKA tune
                !
                If (segList(ii)%flagOn) Then                                     !  !!     -> ON
                   Write (messageText, iostat=ierr, fmt =                        &
                        &  '(I3," ", A,A, "at ", 2F12.1," [", A,"] ",            &
                        &   A, F12.5," [s]")   '                                 &
                        &  )                                                     &
                        &           ii,                                          &
                        &           segList(ii)%ssType,traceflag%on,             &
                        &           segList(ii)%pStart%x/GV%angleFactorR,        &
                        &           segList(ii)%pStart%y/GV%angleFactorR,        &
                        &           GV%angleUnitSetC,                            &
                        &           segList(ii)%systemName,                      &
                        &           segList(ii)%tsegment                         !
                   Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
                Else If (segList(ii)%flagRef) Then                               !  !!       -> REF
                   Write (messageText, iostat=ierr, fmt =                        &
                        &  '(I3," ", A,A, "at ", 2F12.1," [", A,"] ",            &
                        &   A, F12.5," [s]")   '                                 &
                        &  )                                                     &
                        &           ii,                                          &
                        &           segList(ii)%ssType,traceflag%ref,            &
                        &           segList(ii)%pStart%x/GV%angleFactorR,        &
                        &           segList(ii)%pStart%y/GV%angleFactorR,        &
                        &           GV%angleUnitSetC,                            &
                        &           segList(ii)%systemName,                      &
                        &           segList(ii)%tsegment                         !
                   Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
                End If
                !
             End If                                                              ! !!     <- flagTune or else
             !
          Else                                                                   ! !!  <-- TRACK  
             !
             Write (messageText,*)  "  subscan #:   ", ii," ",                   &
                  &  segList(ii)%ssType                                          !
             !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
          End If
          !
       End Do  !!  loop over segments
       !
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'DIY',messageText)
       !
    End If     !!  nSegments.Ge.1 or else
    !
    Return
    !
  End Subroutine listDIYlist
!!!
!!!
  Subroutine plotDIYlist (errorP)
    !
    !**   Variables  for Plots   ***
    Include 'inc/variables/headerForPlotMethods.inc'
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    errorP = .False.
    !
    Call pako_message(seve%t,"DIY",                                              &
         &    " module DIYlist, 1.2.3 2014-12-15 ---> SR: plotDIYlist ")         ! trace execution
    !
    Call configurePlots
    !
    Call getCountSegments(nSegments)
    !
    !D     Write (6,*) '        nSegments: ',  nSegments
    !D     Write (messageText,*)  "  subscans #: 1 to ", nSegments
    !
    If (nSegments.Ge.1) Then
       !
       Do ii = 1, nSegments, 1
          !
          !D           Write (6,*) ii, segList(ii)%ssType, segList(ii)%segType,               &
          !D                &          segList(ii)%flagOn, segList(ii)%flagRef,               &
          !D                &          segList(ii)%flagTune                                   !
          !
          If      (segList(ii)%ssType.Eq.ss%otf                                  &
               &   .And. segList(ii)%segType.Eq.seg%linear) Then                 !  !!  OTF linear
             !
             If (segList(ii)%flagDropin) Then                                       !!  drop-in
                Call plotOtfLinearP(                                             &
                     &  segList(ii)%pStart,                                      &
                     &  segList(ii)%pEnd,                                        &
                     &  errorP,                                                  &
                     &  speedStart= segList(ii)%speedStart,                      &
                     &  speedEnd  = segList(ii)%speedEnd,                        &
                     &  tSegment  = segList(ii)%tSegment,                        &
                     &  tSample   = 1/GV%slowRateAMD,                            &
                     &  number    = ii,                                          &
                     &  Type      = "dropin"                                     &
                     &  )                                                        !
             Else
                Call plotOtfLinearP(                                             &
                     &  segList(ii)%pStart,                                      &
                     &  segList(ii)%pEnd,                                        &
                     &  errorP,                                                  &
                     &  speedStart= segList(ii)%speedStart,                      &
                     &  speedEnd  = segList(ii)%speedEnd,                        &
                     &  tSegment  = segList(ii)%tSegment,                        &
                     &  tSample   = 1/GV%slowRateAMD,                            &
                     &  number    = ii)                                          !
             End If
             !
          Else If      (segList(ii)%ssType.Eq.ss%otf                             &
               &   .And. segList(ii)%segType.Eq.seg%lissajous) Then              !  !!  OTF Lisajous
             !
             !D              Write (6,*) "   --> plotDIYlist: about to call plotOtfLissajous"
             !D              Write (6,*) "                GV%slowRateAMD: ", GV%slowRateAMD
             !
             Call plotOtfLissajousP(                                             &
                  &  segList(ii)%pCenter,                                        &
                  &  segList(ii)%xAmplitude,                                     &
                  &  segList(ii)%yAmplitude,                                     &
                  &  segList(ii)%omegaX,                                         &
                  &  segList(ii)%omegaY,                                         &
                  &  segList(ii)%phiX,                                           &
                  &  segList(ii)%phiY,                                           &
                  &  segList(ii)%tSegment,                                       &
                  &  errorP,                                                     &
                  &  tSample=1/GV%slowRateAMD,                                   &
                  &  number=ii)                                                  !
             !
          Else If (segList(ii)%ssType .Eq.ss%track                               &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagTune) Then                              !  !!  TRACK tune
             !!D  Write (6,*) "      ii: ", ii, " -> plot Track /Tune "
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%tune)                                      !
             !
          Else If (segList(ii)%ssType .Eq.ss%tune                                &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagTune) Then                              !  !!  TRACK tune
             !!D  Write (6,*) "      ii: ", ii, " -> plot Track /Tune "
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%tune)                                      !
             !
          Else If (segList(ii)%ssType .Eq.ss%track                               &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagOn) Then                                !  !!  TRACK On
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%on)                                        !
             !
          Else If (segList(ii)%ssType .Eq.ss%track                               &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagRef) Then                               !  !!  TRACK Reference
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%ref)                                       !
             !
          End If
          !
       End Do
       !
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'DIY',messageText)
       !
    End If
    !
    If (errorP)                                                                  &
         &        Call pakoMessage(priorityE,severityE,                          &
         &        'DIYlist',' could not plot ')                                  !
    !
    Return
  End Subroutine plotDIYlist
!!!
!!!
  Subroutine saveDIYlist(programName,LINE,commandToSave,iUnit, ERROR)
    !
    !**   Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !      
    Character(len=lenLine)             ::  messageText
    !
    ERROR = .False.
    !
    !D     Write (6,*) '      ---> modulePakoDIYlist SR: saveDIYlist '
    !
    Include 'inc/commands/saveDIYlist.inc'
    !
    Return
  End Subroutine saveDIYlist
!!!
!!!
  Subroutine saveSubscan(programName,LINE,commandToSave,iUnit, ERROR)
    !
    !**   Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !      
    Character(len=lenLine)             ::  messageText
    !
    ERROR = .False.
    !
    !D     Write (6,*) '      ---> modulePakoDIYlist SR: saveSubscan '
    !
    Include 'inc/commands/saveSubscan.inc'
    !
    Return
  End Subroutine saveSubscan
!!!
!!!
  Subroutine startDIYlist(programName,LINE,commandToSave, iUnit, ERROR)
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    ERROR = .False.
    !
    !D     Write (6,*) " ---> modulePakoDIYlist: SR startDIYlist "
    !
    Call startSubscanList(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Return
  End Subroutine startDIYlist
!!!
!!!
  Subroutine writeXMLDIYlist(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    ERROR = .False.
    !
    Return
  End Subroutine writeXMLDIYlist
!!!
!!!
End Module modulePakoDIYlist
!!!
!!!

!
module gio_section32
  !--------------------------------------------------------------------
  ! GIO global parameters for header sections support
  !--------------------------------------------------------------------
  integer(kind=4), parameter :: mvoc=11
  character(len=12), parameter :: vocab(mvoc) =  (/  &
       'GENERAL     ',  &
       'BLANKING    ',  &
       'EXTREMA     ',  &
       'DESCRIPTION ',  &
       'POSITION    ',  &
       'PROJECTION  ',  &
       'SPECTROSCOPY',  &
       'RESOLUTION  ',  &
       'NOISE       ',  &
       'PROPERMOTION',  &
       'TABLE       ' /)
  integer(kind=4), parameter :: address_32(mvoc) = & 
         & (/ 11,41,44,55,74,87,97,110,114,117,11 /)
  integer(kind=4), parameter :: length_32(mvoc) = &
         & (/ 29,2,10,18,12,9,12,3,2,5,5 /)
end module gio_section32
!
!
subroutine gio_whsec32(ibuf32,type,array,size,error)
  use gio_dependencies_interfaces
  use gio_image
  use gio_section32
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF   Stand-Alone routine
  !       Write a descriptor in Header of file, in "old" 32 bit
  !           format.
  !----------------------------------------------------------------------
  !
  !       Greg Data Frame structure
  !       Fixed length 512-bytes Records
  !
  ! First Record  : Header
  ! Others        : Data
  ! After data (if needed) : Comments
  !
  ! Basic Header for data checks
  !       'GILDAS_IMAGE  '                        ! C*12
  !       Type (Real, Real*8, Integer)
  !       Data Length (Blocks)                    !
  !       Additional Information (blocks)         !
  !                                               ! 10  Words reserved
  !
  ! KEY = GENERAL                 (1)
  !       LENGTH
  !       NDIM (<4)               1       2
  !       DIM(4)                  4       6
  !       XREF,XVAL,XINC (4 fois) 3*8     30
  !       Length = 30     Words                   ! 40
  !
  ! KEY = TABLE                   (8)
  !       LENGTH
  !       NDIM                    1       2
  !       DIM(4)                  1       6
  !       Length = 6      Words
  !
  ! KEY = BLANKING                (2)
  !       LENGTH
  !       BVAL,EVAL               2       3
  !       Length = 3      Words                   ! 43
  !
  ! KEY = EXTREMA                 (3)
  !       LENGTH
  !       RMIN,RMAX, MIN1,MAX1, MIN2,MAX2, MIN3,MAX3, MIN4,MAX4
  !       Length = 11     Words                   ! 54
  !
  ! KEY = DESCRIPTION             (4)
  !       LENGTH
  !       UNIT C*12       Map unit  3     4
  !       CODE C*12(4)    Axis type 4*3   16
  !       SYST C*12       Coord. Sy.3     19
  !       Length = 16     Words                   ! 73
  !
  ! KEY = POSITION                (5)
  !       LENGTH
  !       RSOURC C*12             3       4       ! Source name
  !       REPOCH R*4              1       5       ! Epoch of observation
  !       RRA,   R*8              2       7       ! R.A. of center position
  !       RDEC,  R*8              2       9       ! Declination ----
  !       RL,    R*8              2       11      ! Galactic longitude
  !       RB     R*8              2       13      ! Galactic latitude
  !       Length = 13     Words                   ! 86
  !
  ! KEY = PROJECTION              (6)
  !       LENGTH
  !       TYPE,A0,D0,ANGLE        1+3*2   8
  !       AXIS1,AXIS2             2*1     10      ! Projected axis
  !       Length = 10     Words                   ! 96
  !
  ! KEY = SPECTROSCOPY            (7)
  !       LENGTH
  !       RLINE  C*12             ! Line name
  !       RFRES, R*8              ! Frequency resolution
  !       RFIMA, R*8              ! Image Frequency
  !       RVRES, R*4              ! Velocity resolution
  !       RVOFF  R*4              ! Velocity offset
  !       RRESTF R*8              ! Rest frequency of transition
  !       RFAXI  I*4              ! Frequency axis
  !       Length = 13             ! 109
  !
  ! KEY = RESOLUTION              (8)
  !       LENGTH
  !       MAJOR                   ! Major axis
  !       MINOR                   ! Minor axis
  !       POSITION_ANGLE          !
  !       Length = 4              ! 113
  !---------------------------------------------------------------------
  integer, intent(inout) :: ibuf32(*)         ! Buffer where sections must be stored
  character(len=*), intent(in) :: type        ! Section name
  integer, intent(in) :: array(*)             ! Section array values
  integer, intent(in) :: size                 ! Section size
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='GDF_Whsec32'
  character(len=12) :: keywor
  integer :: nkey
  integer :: azero(128),k,ia,l,i
  data azero/128*0/
  !
!  if (islot(is).eq.empty_gio) then
!    call gio_message(seve%e,rname,'Image slot is empty')
!    error = .true.
!    return
!  endif
  !
  ! Find section
  error = .false.
  call sic_ambigs('GDF_Whsec32',type,keywor,nkey,vocab,mvoc,error)
  if (error) return
  !
  ! Put at appropriate location
  k = length_32(nkey)-size
  if (k.lt.0) then
    if (nkey.gt.1) then
      call gio_message(seve%w,rname,'Section '//trim(keywor)//' too long')
    endif
    l = length_32(nkey)
  else
    l = size
  endif
  !
  ia = address_32(nkey)
  ibuf32 (ia) = 4*l
  do i=1,l
    ibuf32(ia+i) = array(i)
  enddo
  do i=1,k
    ibuf32(ia+l+i) = 0
  enddo
end subroutine gio_whsec32
!
subroutine gio_rhsec32(ibuf32,type,array,size,error)
  use gio_dependencies_interfaces
  use gio_image
  use gio_section32
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GREG  Stand-alone routine
  !       Find information Greg Data Frame header
  !---------------------------------------------------------------------
  integer, intent(inout) :: ibuf32(*)         ! Buffer from which section must be fetched
  character(len=*), intent(in) :: type        ! Section name
  integer, intent(inout) :: array(*)          ! Section data
  integer, intent(inout) :: size              ! Section size
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='GDF_Rhsec32'
  character(len=12) :: keywor
  integer :: nkey
  integer :: i,ia,l
  !
!  if (islot(is).eq.empty_gio) then
!    call gio_message(seve%e,rname,'Image slot is empty')
!    error = .true.
!    return
!  endif
  !
  ! Find section
  error = .false.
  call sic_ambigs('GDF_Rhsec32',type,keywor,nkey,vocab,mvoc,error)
  if (error) return
  !
  ! Get from appropriate location
  ia = address_32(nkey)
  l = ibuf32(ia) / 4
  if (l.le.0) then
    size = 0
    call gio_message(seve%d,rname,'Absent section '//keywor)
    return
  endif
  if (size.lt.l) then
    l = size
    ! Ignore message for TABLE section
    if (nkey.ne.mvoc .and. nkey.ne.1) then
      call gio_message(seve%w,rname,'Section '//trim(keywor)//' too long')
    endif
  endif
  !
  ! Table section : verify there is no more than 2 dimension
  if (nkey.eq.mvoc) then
    ibuf32(ia+1) = 0
    do i=2,5
      if (ibuf32(ia+i).gt.1)  ibuf32(ia+1) = ibuf32(ia+1)+1
    enddo
  endif
  do i=1,l
    array(i) = ibuf32(ia+i)
  enddo
  size = l
end subroutine gio_rhsec32
!
!
subroutine gio_cvhd32 (len,inhead,ouhead,r8,r4,i4)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer, intent(in)  :: len       ! Length of buffer
  integer, intent(in)  :: inhead(*) ! Input values in file format
  integer, intent(out) :: ouhead(*) ! Converted values in machine format
  external :: r8                    ! Real*8 conversion routine
  external :: r4                    ! Real*4 conversion routine
  external :: i4                    ! Integer*4 conversion routine
  ! Local
  integer :: i
  !
  real(4) :: intmp(8),outmp(8)
  !
  do i=1,len
    ouhead(i) = inhead(i)
  enddo
  call i4 (inhead(4),ouhead(4),2)      ! X_FORM, ndb
  call i4 (inhead(11),ouhead(11),6)    ! X_gene, Ndim, Dim
  call r8 (inhead(17),ouhead(17),12)   ! Conversion formula
  call i4 (inhead(41),ouhead(41),1)    ! X_blan
  call r4 (inhead(42),ouhead(42),2)    ! Blanking
  call i4 (inhead(44),ouhead(44),1)    ! X_extr
  call r4 (inhead(45),ouhead(45),2)    ! Values at extrema
  call i4 (inhead(47),ouhead(47),8)    ! Position of extrema
  call i4 (inhead(55),ouhead(55),1)    ! X_desc
  call i4 (inhead(74),ouhead(74),1)    ! X_posi
  call r4tor4(inhead(78),intmp,8)      ! Mis-aligned stuff
  call r8 (intmp,outmp,4)              ! RA,Dec,lII,bII
  call r4tor4(outmp,ouhead(78),8)      !
  call r4 (inhead(86),ouhead(86),1)    ! Epoch
  ! print *,'Inhead 87-88 ',inhead(87), inhead(88)
  call i4 (inhead(87),ouhead(87),2)    ! X_proj, X_Ptyp
  ! print *,'Inhead 87-88 ',ouhead(87), ouhead(88)
  call r8 (inhead(89),ouhead(89),3)    ! Projection
  call i4 (inhead(95),ouhead(95),3)    ! X_Xaxi, X_Yaxi, X_spec
  call r8 (inhead(101),ouhead(101),3)  ! Spectro (frequency)
  call r4 (inhead(107),ouhead(107),2)  ! Spectro (velocity)
  call i4 (inhead(109),ouhead(109),2)  ! X_Faxi, X_reso
  call r4 (inhead(111),ouhead(111),3)  ! Resolution
  call i4 (inhead(114),ouhead(114),1)  ! X_Sigma
  call r4 (inhead(115),ouhead(115),2)  ! Noise, Rms
end subroutine gio_cvhd32
!!
subroutine gio_read32header(hd32,ibuf32,error)
  use gio_headers
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GIO / GDF Internal routine
  !       Read an image header from the requested slot ISLO
  !       The slot must have been properly opened before
  !---------------------------------------------------------------------
  type (gildas_header_v1), intent(out) :: hd32   ! GILDAS image structure
  integer(kind=4), intent(inout) :: ibuf32(*)    ! Buffer of data
  logical, intent(inout) :: error                ! Error flag
  ! Local
  integer :: ilen
  !
  hd32%ijtyp = ibuf32(1:3)
  call bytoby (ibuf32,hd32%ijtyp,12)
  hd32%ndb = ibuf32(4)
  hd32%form = ibuf32(5)
  ilen = 29
  call gio_rhsec32(ibuf32,'GENERAL',hd32%ndim,ilen,error)
  hd32%gene = ilen
  ilen = 2
  call gio_rhsec32(ibuf32,'BLANKING',hd32%bval,ilen,error)
  hd32%blan = ilen
  ilen = 10
  call gio_rhsec32(ibuf32,'EXTREMA',hd32%rmin,ilen,error)
  hd32%extr = ilen
  ilen = 18
  call gio_rhsec32(ibuf32,'DESCRIPTION',hd32%ijuni,ilen,error)
  hd32%desc = ilen
  ilen = 12
  call gio_rhsec32(ibuf32,'POSITION',hd32%ijsou,ilen,error)
  hd32%posi = ilen
  ilen = 9
  call gio_rhsec32(ibuf32,'PROJECTION',hd32%ptyp,ilen,error)
  hd32%proj = ilen
  ilen = 12
  call gio_rhsec32(ibuf32,'SPECTROSCOPY',hd32%ijlin,ilen,error)
  hd32%spec = ilen
  ilen = 3
  call gio_rhsec32(ibuf32,'RESOLUTION',hd32%majo,ilen,error)
  hd32%reso = ilen
  ilen = 2
  call gio_rhsec32(ibuf32,'NOISE',hd32%noise,ilen,error)
  hd32%sigm = ilen
  ilen = 4
  call gio_rhsec32(ibuf32,'PROPERMOTION',hd32%mura,ilen,error)
  hd32%prop = ilen
  !
  !
  !!write(99,*) 'Tested gio_read_header'
  !!call gdf_dump(imag) ! To debug...
end subroutine gio_read32header
!
subroutine gio_write32header(hd32,ibuf32,error)
  use gio_headers
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF / GIO Internal routine
  !       Update an image header on a specified image slot
  !           The slot must have been opened before
  !---------------------------------------------------------------------
  type (gildas_header_v1), intent(inout) :: hd32   ! GILDAS type output structure
  integer(kind=4), intent(out) :: ibuf32(*)  ! Working buffer
  logical, intent(out) :: error             ! Logical error flag
  ! Local
  integer :: i
  !
  error = .false.
  do i=1,4
    hd32%dim(i)=max(1,hd32%dim(i))
  enddo
  !
  call gio_whsec32(ibuf32,'GENERAL',     hd32%ndim, hd32%gene,error)
  call gio_whsec32(ibuf32,'BLANKING',    hd32%bval, hd32%blan,error)
  call gio_whsec32(ibuf32,'EXTREMA',     hd32%rmin, hd32%extr,error)
  call gio_whsec32(ibuf32,'DESCRIPTION', hd32%ijuni, hd32%desc,error)
  call gio_whsec32(ibuf32,'POSITION',    hd32%ijsou, hd32%posi,error)
  call gio_whsec32(ibuf32,'PROJECTION',  hd32%ptyp, hd32%proj,error)
  call gio_whsec32(ibuf32,'SPECTROSCOPY',hd32%ijlin, hd32%spec,error)
  call gio_whsec32(ibuf32,'RESOLUTION',  hd32%majo, hd32%reso,error)
  call gio_whsec32(ibuf32,'NOISE',       hd32%noise,hd32%sigm,error)
  call gio_whsec32(ibuf32,'PROPERMOTION',hd32%mura, hd32%prop,error)
  !
  !!write(99,*) 'Tested gio_write_header'
end subroutine gio_write32header
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
function eclass_inte_eq(a,b)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two integers
  !---------------------------------------------------------------------
  logical :: eclass_inte_eq
  integer(kind=4), intent(in) :: a
  integer(kind=4), intent(in) :: b
  !
  eclass_inte_eq = a.eq.b
  !
end function eclass_inte_eq
!
function eclass_2inte_eq(i1,i2,j1,j2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of integers
  !---------------------------------------------------------------------
  logical :: eclass_2inte_eq
  integer(kind=4), intent(in) :: i1,i2
  integer(kind=4), intent(in) :: j1,j2
  !
  eclass_2inte_eq = i1.eq.i2 .and. j1.eq.j2
  !
end function eclass_2inte_eq
!
function eclass_2inte1char_eq(i1,i2,j1,j2,k1,k2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of integers + 1 pair of chars
  !---------------------------------------------------------------------
  logical :: eclass_2inte1char_eq
  integer(kind=4),  intent(in) :: i1,i2
  integer(kind=4),  intent(in) :: j1,j2
  character(len=*), intent(in) :: k1,k2
  !
  eclass_2inte1char_eq = i1.eq.i2 .and. j1.eq.j2 .and. k1.eq.k2
  !
end function eclass_2inte1char_eq
!
function eclass_2inte2char_eq(i1,i2,j1,j2,k1,k2,l1,l2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of integers + 2 pairs of chars
  !---------------------------------------------------------------------
  logical :: eclass_2inte2char_eq
  integer(kind=4),  intent(in) :: i1,i2
  integer(kind=4),  intent(in) :: j1,j2
  character(len=*), intent(in) :: k1,k2
  character(len=*), intent(in) :: l1,l2
  !
  eclass_2inte2char_eq = i1.eq.i2 .and. j1.eq.j2 .and.   &
                         k1.eq.k2 .and. l1.eq.l2
  !
end function eclass_2inte2char_eq
!
function eclass_dble_eq(a,b)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two real*8
  ! WARNING: there is no tolerance here, because we assume we compare
  ! values which we know must be equal
  !---------------------------------------------------------------------
  logical :: eclass_dble_eq
  real(kind=8), intent(in) :: a
  real(kind=8), intent(in) :: b
  !
  eclass_dble_eq = a.eq.b
  !
end function eclass_dble_eq
!
function eclass_2dble_eq(x1,x2,y1,y2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of real*8 (e.g. coordinates)
  ! WARNING: there is no tolerance here, because we assume we compare
  ! values which we know must be equal
  !---------------------------------------------------------------------
  logical :: eclass_2dble_eq
  real(kind=8), intent(in) :: x1,x2
  real(kind=8), intent(in) :: y1,y2
  !
  eclass_2dble_eq = x1.eq.x2 .and. y1.eq.y2
  !
end function eclass_2dble_eq
!
function eclass_2dble3inte_eq(x1,x2,y1,y2,i1,i2,j1,j2,k1,k2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of real*8 and two triplets of
  ! integer*4
  !---------------------------------------------------------------------
  logical :: eclass_2dble3inte_eq
  real(kind=8),    intent(in) :: x1,x2
  real(kind=8),    intent(in) :: y1,y2
  integer(kind=4), intent(in) :: i1,i2
  integer(kind=4), intent(in) :: j1,j2
  integer(kind=4), intent(in) :: k1,k2
  !
  eclass_2dble3inte_eq = x1.eq.x2 .and. y1.eq.y2 .and.  &
                         i1.eq.i2 .and. j1.eq.j2 .and. k1.eq.k2
  !
end function eclass_2dble3inte_eq
!
function eclass_char_eq(a,b)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two characters
  !---------------------------------------------------------------------
  logical :: eclass_char_eq
  character(len=*), intent(in) :: a
  character(len=*), intent(in) :: b
  !
  eclass_char_eq = a.eq.b
  !
end function eclass_char_eq
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine eclass_inte(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,             external      :: equiv   ! l = equiv(i1,i2)
  type(eclass_inte_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val(eclass%nequ) = eclass%val(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val(ival),eclass%val(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val(eclass%nequ) = eclass%val(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_inte
!
subroutine eclass_2inte(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,              external      :: equiv   !
  type(eclass_2inte_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2inte
!
subroutine eclass_2inte1char(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2inte1char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,                   external      :: equiv   !
  type(eclass_2inte1char_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%val3(eclass%nequ) = eclass%val3(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ),  &
                eclass%val3(ival),eclass%val3(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%val3(eclass%nequ) = eclass%val3(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2inte1char
!
subroutine eclass_2inte2char(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2inte2char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,                   external      :: equiv   !
  type(eclass_2inte2char_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%val3(eclass%nequ) = eclass%val3(1)
  ! eclass%val4(eclass%nequ) = eclass%val4(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ),  &
                eclass%val3(ival),eclass%val3(iequ),  &
                eclass%val4(ival),eclass%val4(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%val3(eclass%nequ) = eclass%val3(ival)
      eclass%val4(eclass%nequ) = eclass%val4(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2inte2char
!
subroutine eclass_dble(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_dble
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,             external      :: equiv   !
  type(eclass_dble_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val(eclass%nequ) = eclass%val(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val(ival),eclass%val(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val(eclass%nequ) = eclass%val(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_dble
!
subroutine eclass_2dble(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2dble
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,              external      :: equiv   !
  type(eclass_2dble_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2dble
!
subroutine eclass_2dble1char(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2dble1char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,                   external      :: equiv   !
  type(eclass_2dble1char_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%val3(eclass%nequ) = eclass%val3(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ),  &
                eclass%val3(ival),eclass%val3(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%val3(eclass%nequ) = eclass%val3(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2dble1char
!
subroutine eclass_2dble3inte(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2dble3inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,                   external      :: equiv   !
  type(eclass_2dble3inte_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%val3(eclass%nequ) = eclass%val3(1)
  ! eclass%val4(eclass%nequ) = eclass%val4(1)
  ! eclass%val5(eclass%nequ) = eclass%val5(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ),  &
                eclass%val3(ival),eclass%val3(iequ),  &
                eclass%val4(ival),eclass%val4(iequ),  &
                eclass%val5(ival),eclass%val5(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%val3(eclass%nequ) = eclass%val3(ival)
      eclass%val4(eclass%nequ) = eclass%val4(ival)
      eclass%val5(eclass%nequ) = eclass%val5(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2dble3inte
!
subroutine eclass_char(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,             external      :: equiv   ! l = equiv(c1,c2)
  type(eclass_char_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val(eclass%nequ) = eclass%val(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val(ival),eclass%val(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val(eclass%nequ) = eclass%val(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_char
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reallocate_eclass_inte(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_inte
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_inte_t), intent(inout) :: eclass
  integer(kind=4),     intent(in)    :: nval
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>INTE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_inte(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val(nval),eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_inte(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_inte
!
subroutine reallocate_eclass_2inte(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_2inte
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte_t), intent(inout) :: eclass
  integer(kind=4),      intent(in)    :: nval
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2INTE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2inte(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%cnt(nval),eclass%bak(nval),  &
       stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2inte(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2inte
!
subroutine reallocate_eclass_2inte1char(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_2inte1char
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte1char_t), intent(inout) :: eclass
  integer(kind=4),           intent(in)    :: nval
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2INTE1CHAR'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2inte1char(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%val3(nval),  &
              eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2inte1char(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2inte1char
!
subroutine reallocate_eclass_2inte2char(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_2inte2char
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte2char_t), intent(inout) :: eclass
  integer(kind=4),           intent(in)    :: nval
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2INTE2CHAR'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2inte2char(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),  &
              eclass%val3(nval),eclass%val4(nval),  &
              eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2inte2char(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2inte2char
!
subroutine reallocate_eclass_dble(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_dble
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_dble_t), intent(inout) :: eclass
  integer(kind=4),     intent(in)    :: nval
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>DBLE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_dble(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val(nval),eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_dble(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_dble
!
subroutine reallocate_eclass_2dble(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_2dble
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble_t), intent(inout) :: eclass
  integer(kind=4),      intent(in)    :: nval
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2DBLE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2dble(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%cnt(nval),eclass%bak(nval),  &
       stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2dble(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2dble
!
subroutine reallocate_eclass_2dble1char(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_2dble1char
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble1char_t), intent(inout) :: eclass
  integer(kind=4),           intent(in)    :: nval
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2DBLE1CHAR'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2dble1char(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%val3(nval),  &
              eclass%cnt(nval),eclass%bak(nval),  &
              stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2dble1char(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2dble1char
!
subroutine reallocate_eclass_2dble3inte(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_2dble3inte
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble3inte_t), intent(inout) :: eclass
  integer(kind=4),           intent(in)    :: nval
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2DBLE3INTE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2dble3inte(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%val3(nval),  &
              eclass%val4(nval),eclass%val5(nval),eclass%cnt(nval),   &
              eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2dble3inte(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2dble3inte
!
subroutine reallocate_eclass_char(eclass,nval,error)
  use gmath_interfaces, except_this=>reallocate_eclass_char
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_char_t), intent(inout) :: eclass
  integer(kind=4),     intent(in)    :: nval
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>CHAR'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_char(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val(nval),eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_char(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_char
!
subroutine free_eclass_inte(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_inte
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_inte_t), intent(inout) :: eclass
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>INTE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val))  return
  !
  eclass%nval = 0
  if (associated(eclass%val))  deallocate(eclass%val)
  if (associated(eclass%cnt))  deallocate(eclass%cnt)
  if (associated(eclass%bak))  deallocate(eclass%bak)
  !
end subroutine free_eclass_inte
!
subroutine free_eclass_2inte(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_2inte
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte_t), intent(inout) :: eclass
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2INTE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2inte
!
subroutine free_eclass_2inte1char(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_2inte1char
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte1char_t), intent(inout) :: eclass
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2INTE1CHAR'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%val3))  deallocate(eclass%val3)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2inte1char
!
subroutine free_eclass_2inte2char(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_2inte2char
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte2char_t), intent(inout) :: eclass
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2INTE2CHAR'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%val3))  deallocate(eclass%val3)
  if (associated(eclass%val4))  deallocate(eclass%val4)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2inte2char
!
subroutine free_eclass_dble(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_dble
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_dble_t), intent(inout) :: eclass
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>DBLE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val))  return
  !
  eclass%nval = 0
  if (associated(eclass%val))  deallocate(eclass%val)
  if (associated(eclass%cnt))  deallocate(eclass%cnt)
  if (associated(eclass%bak))  deallocate(eclass%bak)
  !
end subroutine free_eclass_dble
!
subroutine free_eclass_2dble(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_2dble
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble_t), intent(inout) :: eclass
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2DBLE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2dble
!
subroutine free_eclass_2dble1char(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_2dble1char
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble1char_t), intent(inout) :: eclass
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2DBLE1CHAR'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%val3))  deallocate(eclass%val3)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2dble1char
!
subroutine free_eclass_2dble3inte(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_2dble3inte
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble3inte_t), intent(inout) :: eclass
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2DBLE3INTE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%val3))  deallocate(eclass%val3)
  if (associated(eclass%val4))  deallocate(eclass%val4)
  if (associated(eclass%val5))  deallocate(eclass%val5)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2dble3inte
!
subroutine free_eclass_char(eclass,error)
  use gmath_interfaces, except_this=>free_eclass_char
  use gmath_messaging
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_char_t), intent(inout) :: eclass
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>CHAR'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val))  return
  !
  eclass%nval = 0
  if (associated(eclass%val))  deallocate(eclass%val)
  if (associated(eclass%cnt))  deallocate(eclass%cnt)
  if (associated(eclass%bak))  deallocate(eclass%bak)
  !
end subroutine free_eclass_char
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine eclass_getnext(eclass,iclass,ielem,found,error)
  use eclass_types
  use gmath_interfaces, except_this=>eclass_getnext
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Utility routine: get the index of the next element which is in the
  ! iclass-th class.
  !---------------------------------------------------------------------
  class(eclass_common_t), intent(in)    :: eclass  ! The equivalence classes
  integer(kind=4),        intent(in)    :: iclass  ! The ith equivalence class we search into
  integer(kind=4),        intent(inout) :: ielem   ! Starting point (can be 0) and next (output) value found
  logical,                intent(out)   :: found   ! Found a new element?
  logical,                intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ECLASS>GET>NEXT'
  integer(kind=4) :: ival
  !
  if (iclass.le.0 .or. iclass.gt.eclass%nequ) then
    call gmath_message(seve%e,rname,'Invalid class number')
    error = .true.
    return
  endif
  !
  found = .false.
  do ival=ielem+1,eclass%nval
    if (eclass%bak(ival).eq.iclass) then
      ielem = ival
      found = .true.
      return
    endif
  enddo
  !
end subroutine eclass_getnext
!
subroutine eclass_getprev(eclass,iclass,ielem,found,error)
  use eclass_types
  use gmath_interfaces, except_this=>eclass_getprev
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Utility routine: get the index of the previous element which is in
  ! the iclass-th class.
  !---------------------------------------------------------------------
  class(eclass_common_t), intent(in)    :: eclass  ! The equivalence classes
  integer(kind=4),        intent(in)    :: iclass  ! The ith equivalence class we search into
  integer(kind=4),        intent(inout) :: ielem   ! Starting point (can be N+1) and previous (output) value found
  logical,                intent(out)   :: found   ! Found a new element?
  logical,                intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ECLASS>GET>PREV'
  integer(kind=4) :: ival
  !
  if (iclass.le.0 .or. iclass.gt.eclass%nequ) then
    call gmath_message(seve%e,rname,'Invalid class number')
    error = .true.
    return
  endif
  !
  found = .false.
  do ival=ielem-1,1,-1
    if (eclass%bak(ival).eq.iclass) then
      ielem = ival
      found = .true.
      return
    endif
  enddo
  !
end subroutine eclass_getprev

subroutine write_sdm_execblock(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Write the Source ExecBlock  table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_ExecBlock
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (ExecBlockKey) :: ebKey
  type (ExecBlockRow) :: ebRow
  real*8 :: releaseDays, lonlat(2), altitude
  integer :: numObservingLog, numSchedulerMode, ia, l
  character, parameter :: sdmTable*12 = 'ExecBlock'
  save ebRow
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ebRow%numAntenna = r_nant
  numObservingLog = 1
  !numSchedulerMode = 1
!!!   call allocExecBlockRow(ebRow, ebRow%numAntenna, numObservingLog,   &
!!!     numSchedulerMode, error)
  call allocExecBlockRow(ebRow, error)
  if (error) return
  do ia=1, r_nant
    ebRow%antennaId(ia) = antenna_Id(ia)
  enddo
  !!!!! TEMPORARY !!!!! MUST HANDLE THE SB SUMMARY
  ebRow%sbSummaryId = sbsummary_Id
  ebRow%startTime = eb_startTime
  ebRow%endTime = eb_endTime
  ebRow%sessionReference = 'Plateau de Bure ObservingSession'

  
  !
  ! This has to be IRAM_PDB for casa.
  !ebRow%telescopeName = r_teles
  ebRow%telescopeName = 'IRAM_PDB'
  if (r_nant.gt.1) then
    ebRow%configName = r_config(1:lenc(r_config))
    call get_config(ebRow%baseRangeMin, ebRow%baseRangeMax,   &
      ebRow%baseRmsMinor,ebRow%baseRmsMajor, ebRow%basePa)
  else
    ebRow%configName = 'Single Dish'
    ebRow%baseRangeMin = 0
    ebRow%baseRangeMax = 0
    ebRow%baseRmsMinor = 0
    ebRow%baseRmsMajor = 0
    ebRow%basePa = 0
  endif
  ebRow%observerName = 'N.N., Astronomer.'
!  ebRow%observingLog(1) = 'nn.log'
  ebRow%observingLog = 'nn.log'
  ebRow%schedulerMode = 'testMe'
  l = lenc(project_uid)
  ebRow%projectId= '<EntityRef '// 'entityId="' //   &
    project_uid(1:l)//   &
    '" partId="X00000000" entityTypeName="ObsProject" '//   &
    'documentVersion="1"/>'//char(0)
  l = lenc(execBlock_uid)
  ebRow%execBlockUID = '<EntityRef entityId="' //   &
    execBlock_uid(1:l)//   &
    '" partId="X00000000" entityTypeName="ExecBlock" '//   &
    'documentVersion="1"/>'//char(0)
  ebRow%sbSummary = '<EntityRef entityId="' //   &
    execBlock_uid(1:l)//   &
    '" partId="X00000000" entityTypeName="SchedBlock" '//   &
    'documentVersion="1"/>'//char(0)
  !
  ! Make this into a subroutine ?
  if (r_teles.eq.'VTX-ALMATI') then
    call sic_sexa ('-107:37:10.02',10,lonlat(1),error)
    call sic_sexa ('34:04:29.8',8,lonlat(2),error)
    altitude = 2.13542d0*1000d0
  elseif (r_teles.eq.'AEC-ALMATI') then
    call sic_sexa ('-107:37:10.02',10,lonlat(1),error)
    call sic_sexa ('34:04:29.8',8,lonlat(2),error)
    altitude = 2.13542d0*1000.d0
  else
    call sic_sexa ('05:54:28.5',10,lonlat(1),error)
    call sic_sexa ('44:38:02.0',10,lonlat(2),error)
    altitude = 2.560d0*1000.d0
  endif
  !
  ebRow%siteLongitude = lonlat(1)*pi/180d0
  ebRow%siteLatitude = lonlat(2)*pi/180d0
  ebRow%siteAltitude = altitude
  !
  ! OPTIONAL in SS2 ... releaseDays = time_interval(1)/1.d9/84600.+365.*1.5
  ! OPTIONAL in SS2 ... ebRow%releaseDate = int(releaseDays)
  ! OPTIONAL in SS2 ... ebRow%releaseDate = ebRow%releaseDate *84600 *1000000000
!!!   ebRow%flagRow = .false.
  !
  call addExecBlockRow(ebKey, ebRow, error)
  if (error) return
  !
  ExecBlock_Id = ebKey%execBlockId
  deallocate(ebRow%antennaId)
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_execblock
!---------------------------------------------------------------------
subroutine get_sdm_execblock(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Read  the ExecBlock  table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_ExecBlock
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_pi.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (ExecBlockKey) :: ebKey
  type (ExecBlockRow) :: ebRow
  real*8 :: releaseDays
  integer :: numObservingLog, numSchedulerMode, ia, lenz, l1,   &
    l2, l
  character, parameter :: sdmTable*12 = 'ExecBlock'
  integer, parameter :: maxObservingLog = 10, maxSchedulerMode = 10
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  numObservingLog = maxObservingLog
  !numSchedulerMode = maxSchedulerMode
  call allocExecBlockRow(ebRow, error)
  if (error) return
  ebKey%execBlockId = execBlock_Id
  call getExecBlockRow(ebKey, ebRow, error)
  if (error) return
  r_alti = ebRow%siteAltitude/1000.
  r_config = ebRow%configName
  r_teles = ebRow%telescopeName
  l = lenz(ebRow%execBlockUID)
  l1 = index(ebRow%execBlockUID,'"uid://')
  l2 = index(ebRow%execBlockUID(l1+1:),'"')
  r_execBlock = ebRow%execBlockUID(l1+1:l1+l2-1)
  ExecBlock_uid = r_execBlock
  call unslash(r_execBlock,'/')
  call unslash(r_execBlock,':')
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_execblock
!---------------------------------------------------------------------
subroutine unslash(chain,c)
  use gkernel_interfaces
  character*(*) chain, c
  integer l
  l = index(chain,c)
  do while (l.ne.0)
    chain(l:l) = '_'
    l = index(chain,c)
  enddo
  l = lenc(chain)
end subroutine unslash
!---------------------------------------------------------------------
subroutine  get_config(baseRangeMin, baseRangeMax, baseRmsMinor,   &
    baseRmsMajor, basePa)
  !---------------------------------------------------------------------
  use gildas_def
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Dummy
  real*8 baseRangeMin, baseRangeMax, baseRmsMinor, baseRmsMajor,   &
    basePa
  ! Local
  real*8 length, lat, sx2, sxy, sy2, s, xx, yy
  parameter (lat=44.63389D0*pi/180d0)
  integer ib, k
  baseRangeMin = 1d10
  baseRangeMax = 0
  sx2 = 0
  sy2 = 0
  sxy = 0
  s = 0
  if (r_nbas.gt.1) then
    do ib = 1, r_nbas
      length = 0
      do k = 1, 3
        length = length + r_bas(k,ib)**2
      enddo
      length = sqrt(length)
      !     horizontal component
      xx = r_bas(1,ib)*sin(lat)-r_bas(3,ib)*cos(lat)
      yy = r_bas(2,ib)
      sx2 = sx2 + xx**2
      sxy = sy2 + yy**2
      sxy = sxy + xx*yy
      s = s + 1
      baseRangeMin = min(baseRangeMin, length)
      baseRangeMax = max(baseRangeMax, length)
    enddo
    sx2 = sx2 / s
    sy2 = sy2 / s
    sxy = sxy / s
  else
    baseRangeMin = 0
    baseRangeMax = 1
  endif
! compute rms values and pa using TBD formula
end subroutine get_config
!---------------------------------------------------------------------
!!! subroutine allocExecBlockRow(row, numAntenna, numObservingLog,   &
!!!     numSchedulerMode, error)
!!!   !---------------------------------------------------------------------
!!!   !     integer, allocatable :: antennaId(:)
!!!   !     character*256, allocatable :: observingLog(:)
!!!   !     character*256, allocatable :: schedulerMode(:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_ExecBlock
!!!   type(ExecBlockRow) :: row
!!!   integer :: ier, numAntenna, numObservingLog, numSchedulerMode
!!!   logical :: error
!!!   character, parameter :: sdmTable*12 = 'ExecBlock'
!!!   !
!!!   ! antennaId(numAntenna)
!!!   if (allocated(row%antennaId)) then
!!!     deallocate(row%antennaId, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%antennaId(numAntenna), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! ObservingLog(numObservingLog)
!!!   if (allocated(row%ObservingLog)) then
!!!     deallocate(row%ObservingLog, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%ObservingLog(numObservingLog), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! SchedulerMode(numSchedulerMode)
!!!   if (allocated(row%SchedulerMode)) then
!!!     deallocate(row%SchedulerMode, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%SchedulerMode(numSchedulerMode), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!!! !---------------------------------------------------------------------

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_sort_codes
  integer(kind=4), parameter :: code_sort_bt=1     ! BASE then TIME
  integer(kind=4), parameter :: code_sort_tb=2     ! TIME then BASE
  integer(kind=4), parameter :: code_sort_ubtf=3   ! UNIQUE-BASE then TIME then FREQ
  integer(kind=4), parameter :: code_sort_ft=4     ! FREQ then TIME
  integer(kind=4), parameter :: code_sort_field=5  ! FIELD
  !
  integer(kind=4), parameter :: ncode_sort=5
  character(len=8), parameter :: sort_names(ncode_sort) = &
    (/ 'BASE    ','TIME    ','UNIQUE  ','FREQTIME','FIELD   ' /)
end module uv_sort_codes
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_sort
  use gbl_message
  use gmath_quicksort_types
  !
  public :: uv_sort_comm
  public :: uv_tri,uv_findtb
  private
  !
  ! Type for sorting first by unique baseline, then by time and frequency
  type, extends(gi4_quicksort_t) :: uv_sort_ubtf_t
    real(kind=4), pointer :: uv(:,:)
    real(kind=8), pointer :: freq(:)
  contains
    procedure, public :: compare => uv_sort_compare_ubtf
  end type uv_sort_ubtf_t
  !
  ! Type for sorting first by frequency, then by time
  type, extends(gi4_quicksort_t) :: uv_sort_ft_t
    real(kind=4), pointer :: uv(:,:)
    real(kind=8), pointer :: freq(:)
  contains
    procedure, public :: compare => uv_sort_compare_ft
  end type uv_sort_ft_t
  !
contains
  !
  function uv_sort_compare_ubtf(self,m,l)
    !-------------------------------------------------------------------
    ! Compare first by unique baseline, then by time and frequency
    !-------------------------------------------------------------------
    integer(kind=4) :: uv_sort_compare_ubtf
    class(uv_sort_ubtf_t), intent(in) :: self
    integer(kind=4),       intent(in) :: m,l
    ! Local
    integer(kind=4), parameter :: datecol=4
    integer(kind=4), parameter :: timecol=5
    integer(kind=4), parameter :: anticol=6
    integer(kind=4), parameter :: antjcol=7
    integer(kind=4) :: antmi,antmj,antli,antlj
    integer(kind=4) :: antmmin,antmmax,antlmin,antlmax
    !
    antmi = nint(self%uv(anticol,m))
    antmj = nint(self%uv(antjcol,m))
    antli = nint(self%uv(anticol,l))
    antlj = nint(self%uv(antjcol,l))
    if (antmi.lt.antmj) then
      antmmin = antmi
      antmmax = antmj
    else
      antmmin = antmj
      antmmax = antmi
    endif
    if (antli.lt.antlj) then
      antlmin = antli
      antlmax = antlj
    else
      antlmin = antlj
      antlmax = antli
    endif
    if (antmmin.ne.antlmin) then
      if (antmmin.gt.antlmin) then
        uv_sort_compare_ubtf = 1
      else
        uv_sort_compare_ubtf = -1
      endif
      return
    endif
    if (antmmax.ne.antlmax) then
      if (antmmax.gt.antlmax) then
        uv_sort_compare_ubtf = 1
      else
        uv_sort_compare_ubtf = -1
      endif
      return
    endif
    if (self%uv(datecol,m).ne.self%uv(datecol,l)) then
      if (self%uv(datecol,m).gt.self%uv(datecol,l)) then
        uv_sort_compare_ubtf = 1
      else
        uv_sort_compare_ubtf = -1
      endif
      return
    endif
    if (self%uv(timecol,m).ne.self%uv(timecol,l)) then
      if (self%uv(timecol,m).gt.self%uv(timecol,l)) then
        uv_sort_compare_ubtf = 1
      else
        uv_sort_compare_ubtf = -1
      endif
      return
    endif
    if (self%freq(m).eq.self%freq(l)) then
      uv_sort_compare_ubtf = 0
    elseif (self%freq(m).gt.self%freq(l)) then
      uv_sort_compare_ubtf = 1
    else
      uv_sort_compare_ubtf = -1
    endif
  end function uv_sort_compare_ubtf
  !
  function uv_sort_compare_ft(self,m,l)
    !-------------------------------------------------------------------
    ! Compare first by frequency, then by time
    !-------------------------------------------------------------------
    integer(kind=4) :: uv_sort_compare_ft
    class(uv_sort_ft_t), intent(in) :: self
    integer(kind=4),     intent(in) :: m,l
    ! Local
    integer(kind=4), parameter :: datecol=4
    integer(kind=4), parameter :: timecol=5
    !
    if (self%freq(m).ne.self%freq(l)) then
      if (self%freq(m).gt.self%freq(l)) then
        uv_sort_compare_ft = 1
      else
        uv_sort_compare_ft = -1
      endif
      return
    endif
    if (self%uv(datecol,m).ne.self%uv(datecol,l)) then
      if (self%uv(datecol,m).gt.self%uv(datecol,l)) then
        uv_sort_compare_ft = 1
      else
        uv_sort_compare_ft = -1
      endif
      return
    endif
    if (self%uv(timecol,m).eq.self%uv(timecol,l)) then
      uv_sort_compare_ft = 0
    elseif (self%uv(timecol,m).gt.self%uv(timecol,l)) then
      uv_sort_compare_ft = 1
    else
      uv_sort_compare_ft = -1
    endif
  end function uv_sort_compare_ft
  !
  subroutine uv_sort_comm(line,error)
    use gkernel_interfaces
    use uv_sort_codes
    !----------------------------------------------------------------------
    ! UVSORT [TIME|BASE|FIELD]
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: code,na
    character(len=6) :: argu,vvoc
    !
    ! Parse input line. Default argument is TIME
    argu = 'TIME'
    call sic_ke(line,0,1,argu,na,.false.,error)
    if (error) return
    call sic_ambigs('UV_SORT',argu,vvoc,code,sort_names,ncode_sort,error)
    if (error) return
    !
    ! Sort uv buffer
    if (code.eq.code_sort_field) then
       call uv_fsort(error)
    else
       call uv_tri(code,error)
    endif
    if (error) return
  end subroutine uv_sort_comm
  !
  subroutine uv_fsort(error)
    use image_def
    use gkernel_interfaces
    use uvmosaic_tool, only: loadfiuv
    use uv_rotate_shift_and_sort_tool, only: sortuv,loaduv
    use uv_buffers
    use uvmap_buffers, only: uvmap_prog
    !-----------------------------------------------------------------
    ! Allows for sorting for fields using mosaic uv sorting routines
    !-----------------------------------------------------------------
    logical, intent(inout) :: error
    !
    logical :: warning,sorted
    logical, allocatable :: signv(:)
    integer(kind=4) :: ier,ncol,nv,nf,xoff,yoff,loff,moff,ixcol,iycol
    integer(kind=index_length) :: iv,ifi,fsize(1)
    integer(kind=4), allocatable :: it(:)
    real(kind=4) :: cs(2),uvmax,uvmin,xy(2)
    real(kind=4), allocatable :: uarr(:),varr(:),foff(:,:),newv(:)
    real(kind=8), allocatable :: farr(:)
    character(len=*), parameter :: rname='UV_SORT'
    !
    if (.not.associated(duv)) then
       call map_message(seve%e,rname,'No UV data')
       error = .true.
       return
    endif
    ! Do we find pointing offsets?
    xoff = huv%gil%column_pointer(code_uvt_xoff)
    yoff = huv%gil%column_pointer(code_uvt_yoff)
    if ((xoff.ne.0).or.(yoff.ne.0)) then
       ! Yes => This is a mosaic
       if (yoff.ne.xoff+1) then
          ! Ill-defined mosaic
          call map_message(seve%e,rname,'Mosaic Y column does not follow the X column')
          error = .true.
          return
       endif
       ixcol = xoff
       iycol = yoff
    else
       ! No => Do we find phase offsets?
       loff = huv%gil%column_pointer(code_uvt_loff)
       moff = huv%gil%column_pointer(code_uvt_moff)
       if ((loff.ne.0).or.(moff.ne.0)) then
          ! Yes => This is a mosaic
          if (moff.ne.loff+1) then
             ! Ill-defined mosaic
             call map_message(seve%e,rname,'Mosaic M column does not follow the L column')
             error = .true.
             return
          endif
          ixcol = loff
          iycol = moff
       else
          ! No => This is a single-field
          error = .true.
          call map_message(seve%e,rname,'UV table contains a single field, cannot sort it by field')
          return
       endif
    endif
    !
    ! Create Sorted UV data
    call sic_delvariable('UVS',.false.,warning)
    !
    ! Check if new UV Table (uvtb%data) is already allocated
    if (allocated(uvtb%data))  deallocate (uvtb%data)
    !
    ! Copy header information
    call gildas_null(uvtb%head)
    call gdf_copy_header(huv,uvtb%head,error)
    if (error) return
    !
    ! Allocate duvt
    allocate(uvtb%data(uvtb%head%gil%dim(1),uvtb%head%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Error allocating secondary UV buffer')
       error = .true.
       return
    endif
    call sic_def_real('UVS',uvtb%data,uvtb%head%gil%ndim,uvtb%head%gil%dim,.false.,error)
    if (error) return
    !
    ! Start sorting using routines from Mosaic mode
    !
    nv = huv%gil%dim(2)
    ncol = huv%gil%dim(1)
    cs(1) = 1.0 ! no UV shift
    cs(2) = 0.0 ! no UV shift
    xy(1) = 0.0 ! no UV shift
    xy(2) = 0.0 ! no UV shift
    !
    allocate(uarr(nv), varr(nv), signv(nv), farr(nv), it(nv), stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Error allocating work arrays')
       error = .true.
       return
    endif
    call loaduv(duv, ncol, nv, cs, uarr, varr, signv, uvmax, uvmin)
    ! Loading field numbers
    call loadfiuv(duv, ncol, nv, farr, it, sorted, ixcol, iycol, varr, nf, foff)
    !
    ! Proceed to sorting
    if (.not.sorted) then
       call gr8_trie (farr,it,nv,error) ! Actual sorting using quicksort
       deallocate (farr, stat=ier) ! Deallocate farr to save some memory
       allocate (newv(nv), stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Error allocating work arrays')
          error = .true.
          return
       endif
       !
       ! v is sorted here so sortuv can be used later
       do iv=1,nv
          newv(iv) = varr(it(iv))
       enddo
       varr(:) = newv(:)
       deallocate (newv,stat=ier) ! Deallocate newv to save some memory
    else
       deallocate (farr,stat=ier) ! if data is already sorted dealocate farr since it will not be used
    endif
    ! Apply sorting to output visibilities
    call sortuv (duv, uvtb%data, ncol, nv, huv%gil%ntrail, xy, uarr, varr, signv, it)
    !
    ! Deallocate reamining arrays to avoid leaks
    deallocate(uarr, varr, signv, it)
    !
    ! Adding field start and end info to Fields variable
    if (allocated(uvmap_prog%ifields)) deallocate(uvmap_prog%ifields)
    allocate(uvmap_prog%ifields(nf+1))
    ifi = 1
    uvmap_prog%ifields(ifi) = 1
    do iv=1,nv
       if ( (foff(1,ifi).ne.uvtb%data(ixcol,iv)) .or. &
            &  (foff(2,ifi).ne.uvtb%data(iycol,iv)) ) then
          ifi = ifi+1
          uvmap_prog%ifields(ifi) = iv
       endif
    enddo
    uvmap_prog%ifields(nf+1) = nv+1
    fsize(1) = nf+1  
    call sic_def_inte("FIELDS%ifields",uvmap_prog%ifields,1,fsize,.true.,error)
    deallocate(foff)
    !
    error = .false.
  end subroutine uv_fsort
  !
  subroutine uv_tri(code,error)
    use gkernel_interfaces
    use uv_buffers
    !----------------------------------------------------------------------
    ! UVSORT [TIME|BASE|UNIQUE]
    !----------------------------------------------------------------------
    integer(kind=4), intent(in)    :: code  ! Sorting code
    logical,         intent(inout) :: error
    !
    integer(kind=4) :: ier,nd,nv,id,iv
    integer(kind=4), allocatable :: it(:),ot(:)
    real(kind=8), allocatable :: order(:)
    logical :: sorted, warning, alloc
    character(len=*), parameter :: rname='UV_SORT'
    !
    if (.not.associated(duv)) then
       call map_message(seve%e,rname,'No UV data')
       error = .true.
       return
    endif
    !
    ! Create Sorted UV data
    call sic_delvariable('UVS',.false.,warning)
    !
    ! Check first if UVT is already matching UV
    alloc = .false.
    if (allocated(uvtb%data)) then
       if ( (huv%gil%dim(2).ne.uvtb%head%gil%dim(1)) .or. &
            & (huv%gil%dim(1)+3.ne.uvtb%head%gil%dim(2)) ) then
          deallocate (uvtb%data)
       else
          alloc = .true.
       endif
    endif
    !
    call gildas_null (uvtb%head, type = 'TUV')
    call gdf_transpose_header(huv,uvtb%head,'21  ',error)
    if (error)  return
    nd = uvtb%head%gil%dim(2)
    nv = uvtb%head%gil%dim(1)
    uvtb%head%gil%dim(2) = nd+3
    !
    if (.not.alloc) then
       allocate(uvtb%data(uvtb%head%gil%dim(1),uvtb%head%gil%dim(2)),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Error getting UV memory ')
          error = .true.
          return
       endif
    endif
    call sic_def_real('UVS',uvtb%data,uvtb%head%gil%ndim,uvtb%head%gil%dim,.false.,error)
    if (error) return
    !
    allocate(order(nv),it(nv),ot(nv),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Error getting memory ')
       error = .true.
       return
    endif
    !
    call uv_findtb(code,duv,nv,nd,order,it,ot,sorted,error)
    if (error)  return
    if (sorted) then
       print *,'****  SHOW UV -- already sorted for code ',code
       do id=1,nd
          do iv=1,nv
             uvtb%data(iv,id) = duv(id,iv)
          enddo
       enddo
    else
       do id=1,nd
          do iv=1,nv
             uvtb%data(iv,id) = duv(id,it(iv))
          enddo
       enddo
    endif
    do iv=1,nv
       uvtb%data(iv,nd+1) = 1.0
    enddo
    deallocate(order,it,ot)
  end subroutine uv_tri
  !
  subroutine uv_findtb(code,uv,nv,nd,order,it,ot,sorted,error,freq)
    use gkernel_interfaces
    use uv_sort_codes
    !---------------------------------------------------------------
    ! Support for SHOW UV
    !---------------------------------------------------------------
    integer(kind=4),        intent(in)    :: code       ! Code for sort operation
    integer(kind=4),        intent(in)    :: nd,nv      ! Size of visibility table
    real(kind=4),           intent(in)    :: uv(nd,nv)  ! Input UV data
    real(kind=8),           intent(out)   :: order(nv)  ! Sorting array buffer (do not use)
    integer(kind=4),        intent(out)   :: it(nv)     ! Sort index
    integer(kind=4),        intent(out)   :: ot(nv)     ! Reverse order
    logical,                intent(out)   :: sorted     ! Is already sorted
    logical,                intent(inout) :: error      ! Logical error flag
    real(kind=8), optional, intent(in)    :: freq(nv)   ! [MHz] Freq. at visibility center
    !
    integer(kind=4), parameter :: datecol=4
    integer(kind=4), parameter :: timecol=5
    integer(kind=4), parameter :: anticol=6
    integer(kind=4), parameter :: antjcol=7
    real(kind=4) :: rdate
    real(kind=8) :: olast
    integer(kind=4) :: iv
    character(len=*), parameter :: rname='UV_SORT'
    !
    select case (code)
    case (code_sort_bt)
       ! Order BASE(primary) then TIME(secondary). Build float list as:
       !   Antenna I   x  100*10000*86400 [pseudo-sec]
       ! + Antenna J   x      10000*86400 [pseudo-sec]
       ! + OffsetDate  x            86400 [sec]
       ! + Time                           [sec]
       ! This assumes 'OffsetDate' is less then 10000, and 'Antenna J' is less
       ! than 100.
       rdate = uv(datecol,1)
       do iv=1,nv
          order(iv) = 10000.d0*86400.0d0*(100.d0*uv(anticol,iv)+uv(antjcol,iv)) +  &
               (uv(datecol,iv)-rdate)*86400.d0 + uv(timecol,iv)
       enddo
       !
    case (code_sort_ubtf)
      ! Order by UNIQUE-BASE then TIME then FREQ
      if (.not.present(freq)) then
        call map_message(seve%e,rname,'Internal error: frequency array missing')
        error = .true.
        return
      endif
      call uv_findtb_ubtf(uv,nv,nd,freq,it,ot,sorted,error)
      return  ! Always, subsequent code not needed.
      !
    case (code_sort_ft)
      ! Order by FREQ then TIME
      if (.not.present(freq)) then
        call map_message(seve%e,rname,'Internal error: frequency array missing')
        error = .true.
        return
      endif
      call uv_findtb_ft(uv,nv,nd,freq,it,ot,sorted,error)
      return  ! Always, subsequent code not needed.
      !
    case (code_sort_tb)
       ! Order TIME(primary) then BASE(secondary). Build float list as:
       !   OffsetDate  x  86400  [sec]
       ! + Time                  [sec]
       ! + Antenna I   x  0.01   [pseudo-sec]
       ! + Antenna J   x  0.0001 [pseudo-sec]
       ! This assumes 'Antenna I' and 'Antenna J' are less than 100.
       rdate = uv(datecol,1)
       do iv=1,nv
          order(iv) = (uv(datecol,iv)-rdate)*86400.d0 + uv(timecol,iv) +   &
               (100.0d0*uv(anticol,iv)+uv(antjcol,iv))*1.0d-4
       enddo
       !
    case default
       call map_message(seve%e,rname,'Code is not implemented')
       error = .true.
       return
    end select
    !
    ! Check order... This is for dummy UV Tables produced by e.g. UV_CIRCLE
    ! which have no unique ordering...
    olast = order(1)
    sorted = .true.
    do iv=1,nv
       if (order(iv).lt.olast) then
          sorted = .false.
          exit
       endif
       olast = order(iv)
    enddo
    if (sorted) then
       do iv=1,nv
          it(iv) = iv
          ot(iv) = iv
       enddo
    else
       call gr8_trie(order,it,nv,error)
       if (error) return
       do iv=1,nv
          ot(it(iv)) = iv
       enddo
    endif
  end subroutine uv_findtb
  !
  subroutine uv_findtb_ubtf(uv,nv,nd,freq,it,ot,sorted,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Sort by:
    !  min-antenna, then
    !  max-antenna, then
    !  date, then
    !  time, then
    !  frequency
    !---------------------------------------------------------------------
    integer(kind=4),      intent(in)    :: nd,nv      ! Size of visibility table
    real(kind=4), target, intent(in)    :: uv(nd,nv)  ! Input UV data
    real(kind=8), target, intent(in)    :: freq(nv)   ! [MHz] Center frequency
    integer(kind=4),      intent(out)   :: it(nv)     ! Sort index
    integer(kind=4),      intent(out)   :: ot(nv)     ! Reverse order
    logical,              intent(out)   :: sorted     ! Is already sorted?
    logical,              intent(inout) :: error      ! Logical error flag
    ! Local
    integer(kind=4) :: iv,vlast
    type(uv_sort_ubtf_t) :: sorter
    !
    do iv=1,nv
      it(iv) = iv
    enddo
    !
    sorter%uv => uv
    sorter%freq => freq
    call sorter%sort(it,nv,error)
    if (error)  return
    !
    ! Set the already 'sorted' flag
    vlast = it(1)
    sorted = .true.
    do iv=1,nv
      if (it(iv).lt.vlast) then
        sorted = .false.
        exit
      endif
      vlast = it(iv)
    enddo
    !
    ! Set the reverse sorting array
    do iv=1,nv
      ot(it(iv)) = iv
    enddo
  end subroutine uv_findtb_ubtf
  !
  subroutine uv_findtb_ft(uv,nv,nd,freq,it,ot,sorted,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Sort by:
    !  frequency, then
    !  date, then
    !  time
    !---------------------------------------------------------------------
    integer(kind=4),      intent(in)    :: nd,nv      ! Size of visibility table
    real(kind=4), target, intent(in)    :: uv(nd,nv)  ! Input UV data
    real(kind=8), target, intent(in)    :: freq(nv)   ! [MHz] Center frequency
    integer(kind=4),      intent(out)   :: it(nv)     ! Sort index
    integer(kind=4),      intent(out)   :: ot(nv)     ! Reverse order
    logical,              intent(out)   :: sorted     ! Is already sorted?
    logical,              intent(inout) :: error      ! Logical error flag
    ! Local
    integer(kind=4) :: iv,vlast
    type(uv_sort_ft_t) :: sorter
    !
    do iv=1,nv
      it(iv) = iv
    enddo
    !
    sorter%uv => uv
    sorter%freq => freq
    call sorter%sort(it,nv,error)
    if (error)  return
    !
    ! Set the already 'sorted' flag
    vlast = it(1)
    sorted = .true.
    do iv=1,nv
      if (it(iv).lt.vlast) then
        sorted = .false.
        exit
      endif
      vlast = it(iv)
    enddo
    !
    ! Set the reverse sorting array
    do iv=1,nv
      ot(it(iv)) = iv
    enddo
  end subroutine uv_findtb_ft
  !
end module uv_sort
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesimulate_coverage
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubesimulate_messaging
  use cubesimulate_configuration
  use cubesimulate_observatory
  use cubesimulate_tuning
  !
  public :: coverage
  private
  !
  type :: coverage_comm_t
     type(option_t),    pointer :: comm
     type(cube_prod_t), pointer :: cover
     type(tuning_comm_t),        pointer :: tuning => null()
     type(observatory_comm_t),   pointer :: observ => null()
     type(configuration_comm_t), pointer :: config => null()
   contains
     procedure, private :: init     => cubesimulate_coverage_comm_init
     procedure, public  :: register => cubesimulate_coverage_comm_register
     procedure, private :: parse    => cubesimulate_coverage_comm_parse
     procedure, private :: main     => cubesimulate_coverage_comm_main
  end type coverage_comm_t
  type(coverage_comm_t) :: coverage
  !
  type coverage_user_t
     type(cubeid_user_t) :: cubeids
   contains
     procedure, private :: toprog => cubesimulate_coverage_user_toprog
  end type coverage_user_t
  !
  type coverage_prog_t
     type(tuning_prog_t),        pointer :: tuning => null()
     type(observatory_prog_t),   pointer :: observ => null()
     type(configuration_prog_t), pointer :: config => null()
     type(cube_t),               pointer :: cover
   contains
     procedure, private :: init   => cubesimulate_coverage_prog_init
     procedure, private :: header => cubesimulate_coverage_prog_header
     procedure, private :: data   => cubesimulate_coverage_prog_data
     procedure, private :: loop   => cubesimulate_coverage_prog_loop
     procedure, private :: act    => cubesimulate_coverage_prog_act
  end type coverage_prog_t
  !
contains
  !
  subroutine cubesimulate_coverage_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(coverage_user_t) :: user
    character(len=*), parameter :: rname='COVERAGE>COMMAND'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call coverage%parse(line,user,error)
    if (error) return
    call coverage%main(user,error)
    if (error) continue
  end subroutine cubesimulate_coverage_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubesimulate_coverage_comm_init(comm,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>COMM>INIT'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    comm%tuning => tuning_comm
    comm%observ => observatory_comm
    comm%config => configuration_comm
  end subroutine cubesimulate_coverage_comm_init
  !
  subroutine cubesimulate_coverage_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='COVERAGE>COMM>REGISTER'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Initialize pointers
    call comm%init(error)
    if (error) return
    !
    ! Syntax
    call cubetools_register_command(&
         'COVERAGE','',&
         'Report the current coverage-simulation setup',&
         'Report the current tuning, observatory, and configuration setup&
         & used for coverage simulation. The COVERAGE product remains&
         & declared in help, but the synthesis path is currently disabled&
         & and no coverage cube is written yet.',&
         cubesimulate_coverage_command,&
         comm%comm,&
         error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'COVERAGE',&
         'Coverage product placeholder',&
         strg_emp,&
         [flag_coverage],&
         comm%cover,&
         error)
    if (error)  return
  end subroutine cubesimulate_coverage_comm_register
  !
  subroutine cubesimulate_coverage_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! COVERAGE
    !----------------------------------------------------------------------
    class(coverage_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(coverage_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>COMM>PARSE'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Nothing to do right now.
  end subroutine cubesimulate_coverage_comm_parse
  !
  subroutine cubesimulate_coverage_comm_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_comm_t), intent(in)    :: comm
    type(coverage_user_t),  intent(inout) :: user
    logical,                intent(inout) :: error
    !
    type(coverage_prog_t) :: prog
    character(len=*), parameter :: rname='COVERAGE>COMM>MAIN'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
!!$    call prog%header(comm,error)
!!$    if (error) return
!!$    call cubeadm_timing_prepro2process()
!!$    call prog%data(error)
!!$    if (error) return
!!$    call cubeadm_timing_process2postpro()
  end subroutine cubesimulate_coverage_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_coverage_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_user_t), intent(in)    :: user
    type(coverage_comm_t),  intent(in)    :: comm    
    type(coverage_prog_t),  intent(out)   :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>USER>TOPROG'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Initialize pointers
    call prog%init(error)
    if (error) return
    !
    ! User feedback
    call prog%tuning%list(comm%tuning,error)
    if (error) return
    call prog%observ%list(comm%observ,error)
    if (error) return
    call prog%config%list(comm%config,error)
    if (error) return
  end subroutine cubesimulate_coverage_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_coverage_prog_init(prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>PROG>INIT'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    prog%tuning => tuning_prog
    prog%observ => observatory_prog
    prog%config => configuration_prog
  end subroutine cubesimulate_coverage_prog_init
  !
  subroutine cubesimulate_coverage_prog_header(prog,comm,error)
    use cubedag_allflags
    use cubeadm_create
    !----------------------------------------------------------------------
    ! Create a cube header from scratch and initialize it
    !----------------------------------------------------------------------
    class(coverage_prog_t), intent(inout) :: prog
    type(coverage_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>PROG>HEADER'
    !
    integer(kind=ndim_k) :: ndim
    integer(kind=data_k) :: dims(maxdim)
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ndim = 3
    dims(1:3) = [7,1,1]
    dims(4:maxdim) = 0
    call cubeadm_create_header(&
         [flag_uv,flag_coverage],code_access_speset,ndim,dims,prog%cover,error)
    if (error) return
    !***JP: Why the family name is not an input of the
    !***JP: cubeadm_create_header subroutine?
    !***SB: Because there are many properties we would like to set
    call prog%cover%set_value('FAMILY','coucou',error)
    if (error) return
    ! Prepare extrema processing. Assume no parallel put involved (1 pseudo-task)
!    call cover%proc%allocate_extrema(buffer%cube%head,1,error)
!    if (error)  return
  end subroutine cubesimulate_coverage_prog_header
  !
  subroutine cubesimulate_coverage_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(coverage_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='COVERAGE>PROG>DATA'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubesimulate_coverage_prog_data
  !   
  subroutine cubesimulate_coverage_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: cover
    character(len=*), parameter :: rname='COVERAGE>PROG>LOOP'
    !
    call cover%allocate('cover',prog%cover,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,cover,error)
      if (error) return
    enddo ! ie
  end subroutine cubesimulate_coverage_prog_loop
  !   
  subroutine cubesimulate_coverage_prog_act(prog,ie,cover,error)
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(spectrum_t),       intent(inout) :: cover
    logical,                intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    character(len=*), parameter :: rname='COVERAGE>PROG>ACT'
    !
    do ic=1,cover%n
       cover%y%val(ic) = 1.0
    enddo ! ic
    call cover%put(ie,error)
    if (error) return
  end subroutine cubesimulate_coverage_prog_act
end module cubesimulate_coverage
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_getheader_tool
  use cubetools_parameters
  use cubelist_types
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetuple_format_class
  use cubeedit_messaging
  use cubetools_userspace
  use cubetools_uservar
  use cubetools_userstruct
  !
  public :: getheader_comm_t,getheader_user_t,getheader_prog_t
  private
  !
  character(len=*), parameter :: axes(7) = &
       ['VELOCITY  ','FREQUENCY ','REDSHIFT  ','WAVELENGTH','IMAGEFREQ ','L         ','M         ']
  !
  integer(kind=code_k), parameter :: inoaction      = 0
  integer(kind=code_k), parameter :: iaxis          = inoaction+1
  !
  integer(kind=code_k), parameter :: ishape         = iaxis+1
  integer(kind=code_k), parameter :: iunit          = ishape+1
  integer(kind=code_k), parameter :: iextrema       = iunit+1
  integer(kind=code_k), parameter :: inoise         = iextrema+1
  !
  integer(kind=code_k), parameter :: ispatialframe  = inoise+1
  integer(kind=code_k), parameter :: isource        = ispatialframe+1
  integer(kind=code_k), parameter :: iptype         = isource+1
  integer(kind=code_k), parameter :: ipcenter       = iptype+1
  integer(kind=code_k), parameter :: ipangle        = ipcenter+1
  integer(kind=code_k), parameter :: ibeam          = ipangle+1
  !
  integer(kind=code_k), parameter :: ispectralframe = ibeam+1
  integer(kind=code_k), parameter :: ivelocity      = ispectralframe+1
  integer(kind=code_k), parameter :: iredshift      = ivelocity+1
  integer(kind=code_k), parameter :: iline          = iredshift+1
  integer(kind=code_k), parameter :: ifrequency     = iline+1
  integer(kind=code_k), parameter :: iwavelength    = ifrequency+1
  !
  integer(kind=code_k), parameter :: iobservatory   = iwavelength+1
  !
  integer(kind=code_k), parameter :: iid            = iobservatory+1
  integer(kind=code_k), parameter :: ituple         = iid+1
  integer(kind=code_k), parameter :: iparents       = ituple+1
  integer(kind=code_k), parameter :: ichildren      = iparents+1
  integer(kind=code_k), parameter :: itwins         = ichildren+1
  !
  integer(kind=code_k), parameter :: naction        = itwins
  !
  character(len=*), parameter :: options(naction) = [&
       'AXIS         ','SHAPE        ','UNIT         ','EXTREMA      ','NOISE        ',&
       'SPATIALFRAME ','SOURCE       ','PTYPE        ','PCENTER      ','PANGLE       ',&
       'BEAM         ','SPECTRALFRAME','VELOCITY     ','REDSHIFT     ','LINE         ',&
       'FREQUENCY    ','WAVELENGTH   ','OBSERVATORY  ','ID           ','TUPLE        ',&
       'PARENTS      ','CHILDREN     ','TWINS        ']
  character(len=*), parameter :: names(naction) = [&
       'Axis          ','Shape         ','Unit          ','Extrema       ','Noise         ',&
       'Spatial frame ','Source        ','Proj. Type    ','Proj. Center  ','Proj. Angle   ',&
       'Beam          ','Spectral frame','Velocity      ','Redshift      ','Line          ',&
       'Frequency     ','Wavelength    ','Observatory   ','Id            ','Tuple         ',&
       'Parents       ','Children      ','Twins         ']
  !
  type action_comm_t
     type(option_t), pointer :: p
  end type action_comm_t
  !
  type :: getheader_comm_t
     type(option_t),            pointer :: getheader
     type(action_comm_t)                :: actions(naction)
     type(keywordlist_comm_t),  pointer :: axtype
     type(keywordlist_comm_t),  pointer :: coortype
     type(userspace_opt_t),     pointer :: into
   contains
     procedure :: register => cubeedit_getheader_comm_register
     procedure :: parse    => cubeedit_getheader_comm_parse
  end type getheader_comm_t
  !
  type getheader_user_t
     type(userspace_user_t), pointer :: userspace
     character(len=argu_l)           :: axtype    ! Axis name
     character(len=argu_l)           :: coortype  ! Coordinate type
     character(len=argu_l)           :: axunit    ! Axis unit
     integer(kind=4)                 :: nact      ! Number of actions chosen by user
     logical                         :: which(naction) = .false.
     logical                         :: present = .false.
   contains
     procedure, public :: toprog => cubeedit_getheader_user_toprog
  end type getheader_user_t
  !
  type getheader_prog_t
     class(format_t),    pointer     :: cube
     class(userspace_t), allocatable :: userspace
     character(len=unit_l)           :: unit     ! axis  unit
     character(len=12)               :: axtype   ! Resolved axis name
     logical                         :: absolute ! Coordinate is absolute?
     logical                         :: issub    ! Load information on substructure
     logical                         :: which(naction) = .false.
     logical                         :: doget = .false.
   contains
     procedure :: get  => cubeedit_getheader_prog_act_get
     procedure :: list => cubeedit_getheader_prog_act_list
  end type getheader_prog_t
  !
  type, extends(userspace_t) :: getheader_buffer_t
     character(len=32) :: type
     integer(kind=4)   :: id
  end type getheader_buffer_t
  type(list_t) :: bookkeeping ! List of getheader_buffer_t
  !
contains
  !
  subroutine cubeedit_getheader_comm_register(comm,topstruct,into,error)
    !-------------------------------------------------------------------
    ! Register EDIT\HEADER and GO\LOAD header related options
    !-------------------------------------------------------------------
    class(getheader_comm_t), intent(out)   :: comm
    character(len=*),        intent(in)    :: topstruct
    type(userspace_opt_t),   target        :: into
    logical,                 intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t) :: keyarg
    integer(kind=4) :: iwhich
    character(len=*), parameter :: coortype(2)  = ['RELATIVE','ABSOLUTE']
    character(len=*), parameter :: rname='GETHEADER>COMM>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'AXIS','axtype relative|absolute [unit]',&
         'Define axis to be fetched from the cube',&
         strg_emp,&
         comm%actions(iaxis)%p,error)
    if (error) return
    call keyarg%register(&
         'axtype',&
         'Axis type',&
         strg_emp,&
         code_arg_mandatory,&
         axes,&
         flexible,&
         comm%axtype,&
         error)
    if (error) return
    call keyarg%register(&
         'coortype',&
         'Coordinate type, relative or absolute',&
         strg_emp,&
         code_arg_mandatory,&
         coortype,&
         .not.flexible,&
         comm%coortype,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'Unit for axis',&
         'available units vary with axis type',&
         code_arg_optional,&
         error)
    if (error) return
    !
    do iwhich=ishape,naction
       call cubetools_register_option(&
            options(iwhich),'',&
            'Fetch '//trim(names(iwhich))//' of a cube into a variable',&
            'The default variable name of the /INTO key will be '//trim(topstruct)//'%'//options(iwhich),&
            comm%actions(iwhich)%p,&
            error)
       if (error) return
    enddo
    !
    comm%into => into
  end subroutine cubeedit_getheader_comm_register
  !
  subroutine cubeedit_getheader_comm_parse(comm,line,userspace,user,error)
    !-------------------------------------------------------------------
    ! Parse for the getheader keys, and return flag indicating if
    ! something relevant here is to be done
    !-------------------------------------------------------------------
    class(getheader_comm_t), intent(in)    :: comm
    character(len=*),        intent(in)    :: line
    type(userspace_user_t),  target        :: userspace
    type(getheader_user_t),  intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    integer(kind=4) :: iwhich
    character(len=*), parameter :: rname='GETHEADER>COMM>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_array_update(bookkeeping,error)
    if (error) return
    !
    call cubeedit_getheader_comm_parse_axis(comm,line,user,error)
    if (error) return
    !
    do iwhich=ishape,naction
       call comm%actions(iwhich)%p%present(line,user%which(iwhich),error)
       if (error) return
    enddo
    !
    user%nact = count(user%which)
    user%present = (user%nact.gt.0)
    user%userspace => userspace
  end subroutine cubeedit_getheader_comm_parse
  !
  subroutine cubeedit_getheader_comm_parse_axis(comm,line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(getheader_comm_t), intent(in)    :: comm
    character(len=*),        intent(in)    :: line
    type(getheader_user_t),  intent(inout) :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='GETHEADER>COMM>PARSE>AXIS'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call comm%actions(iaxis)%p%present(line,user%which(iaxis),error)
    if (error) return
    user%axunit = strg_equal
    if (user%which(iaxis)) then
       call cubetools_getarg(line,comm%actions(iaxis)%p,1,user%axtype,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%actions(iaxis)%p,2,user%coortype,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%actions(iaxis)%p,3,user%axunit,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_comm_parse_axis
  !
!!$  subroutine cubeedit_getheader_comm_main(comm,user,error)
!!$    !----------------------------------------------------------------------
!!$    !
!!$    !----------------------------------------------------------------------
!!$    class(getheader_comm_t), intent(in)    :: comm
!!$    type(getheader_user_t),  intent(inout) :: user
!!$    logical,                 intent(inout) :: error
!!$    !
!!$    type(image2image_prog_t) :: prog
!!$    character(len=*), parameter :: rname='GETHEADER>COMM>MAIN'
!!$    !
!!$    call cubeedit_message(templateseve%trace,rname,'Welcome')
!!$    !
!!$    call user%toprog(comm,prog,error)
!!$    if (error) return
!!$    call prog%header(comm,error)
!!$    if (error) return
!!$    call cubeadm_timing_prepro2process()
!!$    call prog%data(error)
!!$    if (error) return
!!$    call cubeadm_timing_process2postpro()
!!$  end subroutine cubeedit_getheader_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_getheader_user_toprog(user,comm,defname,dodata,prog,error)
    use gkernel_interfaces, only: failed_allocate
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(getheader_user_t), intent(in)    :: user
    type(getheader_comm_t),  intent(in)    :: comm
    character(len=*),        intent(in)    :: defname
    logical,                 intent(in)    :: dodata
    type(getheader_prog_t),  intent(inout) :: prog
    logical,                 intent(inout) :: error
    !
    integer(kind=4) :: ikey,ier
    character(len=10) :: coortype
    logical, parameter :: local=.false., overwrite = .true. 
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>USER>TOPROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    prog%doget = user%present
    !
    if (dodata) then ! If also doing data, always a member of a parent structure
       allocate(userstruct_t::prog%userspace,stat=ier)
       if (failed_allocate(rname,'userspace',ier,error)) return
       prog%issub = .true. 
    else
       if (user%nact.gt.1) then ! More than one option, main structure obligatory
          allocate(userstruct_t::prog%userspace,stat=ier)
          if (failed_allocate(rname,'userspace',ier,error)) return
          prog%issub = .true. ! Data will be split on substructures
       else ! Only one option, structure or variable depending on the case
          if (user%userspace%do) then ! User has specified a name for userspace
             prog%issub = .false. ! Data will be loaded on a single level structure
             if (user%which(iunit).or.user%which(isource) .or.& ! Single field information with a specific name
                  user%which(iptype).or.user%which(iline) .or.& ! SIC object is a variable
                  user%which(ispectralframe)) then
                allocate(uservar_t::prog%userspace,stat=ier)
                if (failed_allocate(rname,'userspace',ier,error)) return
             else ! More than one field for info, struct obligatory
                allocate(userstruct_t::prog%userspace,stat=ier)
                if (failed_allocate(rname,'userspace',ier,error)) return
             endif
          else ! information loaded as a subfield of parent structure
             prog%issub = .true.
             allocate(userstruct_t::prog%userspace,stat=ier)
             if (failed_allocate(rname,'userspace',ier,error)) return
          endif
       endif
    endif
    !
    if (user%userspace%do) then
       call comm%into%user2prog(user%userspace,prog%userspace,error)
       if (error) return
       if (prog%issub) then
          userstruct => cubetools_userstruct_ptr(prog%userspace,error)
          if (error)  return
          call userstruct%def(error)
          if (error) return
       endif
    else
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%create(defname,local,overwrite_user,error)
       if (error) return
    endif                      
    !
    prog%which(:) = user%which(:)
    !
    if (prog%which(iaxis)) then
       call cubetools_keywordlist_user2prog(comm%axtype,user%axtype,ikey,prog%axtype,error)
       if (error) return
       if (prog%axtype.eq.strg_unresolved) prog%axtype = user%axtype
       call cubetools_keywordlist_user2prog(comm%coortype,user%coortype,ikey,coortype,error)
       if (error) return
       prog%absolute = coortype.eq.'ABSOLUTE'
       prog%unit = user%axunit
    endif
  end subroutine cubeedit_getheader_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_getheader_prog_act_list(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(getheader_prog_t), intent(in)    :: prog
    logical,                 intent(inout) :: error
    !
    integer(kind=4) :: ibuf
    class(list_object_t), pointer :: buffer
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>LIST'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    write(mess,'(a,i0)') 'Loaded header buffers: ',bookkeeping%n
    call cubeedit_message(seve%r,rname,mess)
    !
    if (bookkeeping%n.gt.0) then
       write(mess,'(4x,a,4x,a,x,a,18x,a)') '#','Id', 'Type', 'Variable'
       call cubeedit_message(seve%r,rname,mess)
       do ibuf=1,bookkeeping%n
          buffer => bookkeeping%list(ibuf)%p
          select type (buffer)
          type is (getheader_buffer_t)
            write(mess,'(2x,i3,x,i5,x,a20,2x,a)') ibuf,buffer%id,buffer%type,trim(buffer%name)
          class is (userspace_t)
            write(mess,'(2x,i3,x,a5,x,a20,2x,a)') ibuf,'TBD','TBD',trim(buffer%name)
          class default
            write(mess,'(2x,i3,x,a5,x,a20,2x,a)') ibuf,'TBD','TBD','TBD'
          end select
          call cubeedit_message(seve%r,rname,mess)
       enddo
    endif
    call cubeedit_message(seve%r,rname,'')
  end subroutine cubeedit_getheader_prog_act_list
  !
  subroutine cubeedit_getheader_prog_act_get(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(getheader_prog_t), intent(inout) :: prog
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (.not.prog%doget) return
    !
    if (prog%which(iaxis)) then
       call cubeedit_getheader_prog_act_get_axis(prog,error)
       if (error) return
    endif
    if (prog%which(ishape)) then
       call cubeedit_getheader_prog_act_get_shape(prog,error)
       if (error) return
    endif
    if (prog%which(iunit)) then
       call cubeedit_getheader_prog_act_get_unit(prog,error)
       if (error) return  
    endif
    if (prog%which(iextrema)) then
       call cubeedit_getheader_prog_act_get_extrema(prog,error)
       if (error) return
    endif
    if (prog%which(inoise)) then
       call cubeedit_getheader_prog_act_get_noise(prog,error)
       if (error) return
    endif
    if (prog%which(ispatialframe)) then
       call cubeedit_getheader_prog_act_get_spatialframe(prog,error)
       if (error) return
    endif
    if (prog%which(isource)) then
       call cubeedit_getheader_prog_act_get_source(prog,error)
       if (error) return
    endif
    if (prog%which(iptype)) then
       call cubeedit_getheader_prog_act_get_ptype(prog,error)
       if (error) return
    endif
    if (prog%which(ipcenter)) then
       call cubeedit_getheader_prog_act_get_pcenter(prog,error)
       if (error) return
    endif
    if (prog%which(ipangle)) then
       call cubeedit_getheader_prog_act_get_pangle(prog,error)
       if (error) return
    endif
    if (prog%which(ibeam)) then
       call cubeedit_getheader_prog_act_get_beam(prog,error)
       if (error) return
    endif
    if (prog%which(ispectralframe)) then
       call cubeedit_getheader_prog_act_get_spectralframe(prog,error)
       if (error) return
    endif
    if (prog%which(ivelocity)) then
       call cubeedit_getheader_prog_act_get_velocity(prog,error)
       if (error) return
    endif
    if (prog%which(iredshift)) then
       call cubeedit_getheader_prog_act_get_redshift(prog,error)
       if (error) return
    endif
    if (prog%which(iline)) then
       call cubeedit_getheader_prog_act_get_line(prog,error)
       if (error) return
    endif
    if (prog%which(ifrequency)) then
       call cubeedit_getheader_prog_act_get_frequency(prog,error)
       if (error) return
    endif
    if (prog%which(iwavelength)) then
       call cubeedit_getheader_prog_act_get_wavelength(prog,error)
       if (error) return
    endif
    if (prog%which(iobservatory)) then
       call cubeedit_getheader_prog_act_get_observatory(prog,error)
       if (error) return
    endif
    if (prog%which(iid)) then
       call cubeedit_getheader_prog_act_get_id(prog,error)
       if (error) return
    endif
    if (prog%which(ituple)) then
       call cubeedit_getheader_prog_act_get_tuple(prog,error)
       if (error) return
    endif
    if (prog%which(iparents)) then
       call cubeedit_getheader_prog_act_get_parents(prog,error)
       if (error) return
    endif
    if (prog%which(ichildren)) then
       call cubeedit_getheader_prog_act_get_children(prog,error)
       if (error) return
    endif
    if (prog%which(itwins)) then
       call cubeedit_getheader_prog_act_get_twins(prog,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get
  !
  subroutine cubeedit_getheader_prog_act_get_axis(prog,error)
    use gkernel_interfaces, only: failed_allocate
    ! use cubetools_spapro_types
    ! use gkernel_types, except_this=>axis_t
    use cubetools_disambiguate
    use cubetools_unit
    use cubetools_axis_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) ::substruct
    logical      :: isspat, laxis
    integer(kind=4) :: naxis,jaxis,ier
    type(axis_t) :: axis
    type(unit_user_t) :: axunit
    type(userstruct_t), pointer :: userstruct
    ! type(projection_t) :: proj
    ! real(kind=coor_k), allocatable :: xin(:),xou(:),yin(:),you(:)
    character(len=unit_l), allocatable :: axnames(:)
    character(len=unit_l) :: axname
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>AXIS'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    select case(prog%axtype)
    case('VELOCITY')
       call cubetools_axis_copy(prog%cube%head%spe%v,axis,error)
       if (error) return
       isspat = .false.
    case('FREQUENCY')
       call cubetools_axis_copy(prog%cube%head%spe%f,axis,error)
       if (error) return
       isspat = .false.
    case('REDSHIFT')
       call cubetools_axis_copy(prog%cube%head%spe%z,axis,error)
       if (error) return
       isspat = .false.
    case('WAVELENGTH')
       call cubetools_axis_copy(prog%cube%head%spe%l,axis,error)
       if (error) return
       isspat = .false.
    case('IMAGEFREQ')
       call cubetools_axis_copy(prog%cube%head%spe%i,axis,error)
       if (error) return
       isspat = .false.
    case('L')
       call cubetools_axis_copy(prog%cube%head%spa%l,axis,error)
       if (error) return
       isspat = .true.
       laxis  = .true.
    case('M')
       call cubetools_axis_copy(prog%cube%head%spa%m,axis,error)
       if (error) return
       isspat = .true.
       laxis =  .false.
    case default ! Search in axset
       naxis = prog%cube%head%set%n
       allocate(axnames(naxis),stat=ier)
       if (failed_allocate(rname,'axnames',ier,error)) return
       do jaxis=1,naxis
          axnames(jaxis) = prog%cube%head%set%axis(jaxis)%name
       enddo ! iaxis
       call cubetools_disambiguate_flexible(prog%axtype,axnames,jaxis,axname,error)
       if (error) return
       if (axname.eq.strg_unresolved) then
          call cubeedit_message(seve%e,rname,'Axis '//trim(prog%axtype)//' not found in cube')
          error = .true.
          return
       else
          call cubetools_axis_copy(prog%cube%head%set%axis(jaxis),axis,error)
          if (error) return
          isspat = .false.
       endif
    end select
    !
    if (isspat) then
       if (prog%absolute) then
          call cubeedit_message(seve%e,rname,'Not yet implemented')
          error = .true.
          return
          ! Complicated
          ! call axunit%get(prog%unit,code_unit_pang,error)
          ! if (error) return
          ! call transformation_magic
          !    call prog%cube%head%spa%pro%gwcs(proj,error)
          !    if (error) return
          !    allocate(xin(axis%n),xou(axis%n),yin(axis%n),you(axis%n),stat=ier)
          !    if (failed_allocate(rname,'work arrays',ier,error)) return
          !    if (laxis) then
          !       xin(:) = axis%coord(:)
          !       yin(:) = 0d0
          !    else
          !       xin(:) = 0d0
          !       yin(:) = axis%coord(:)
          !    endif
          !    call rel_to_abs_1dn4(proj,xin,yin,xou,you,int(axis%n,4))
          !    if (laxis) then
          !       axis%coord(:) = xou(:)
          !    else
          !       axis%coord(:) = you(:)
          !    endif
          !    axis%coord(:) = axis%coord(:)*axunit%user_per_prog
          !    axis%val = L0*axunit%user_per_prog ! L0 or M0
          !    axis%inc = NaN
          !    axis%regulier = .false.
       else
          call axunit%get_from_name_for_code(prog%unit,axis%kind,error)
          if (error) return
          axis%coord(:) = (axis%coord(:)-axis%val)*axunit%user_per_prog
          axis%val = axis%val*axunit%user_per_prog
          axis%inc = axis%inc*axunit%user_per_prog
          axis%unit = axunit%name
       endif
    else
       call axunit%get_from_name_for_code(prog%unit,axis%kind,error)
       if (error) return
       if (prog%absolute) then
          axis%coord(:) = axis%coord(:)*axunit%user_per_prog
       else
          axis%coord(:) = (axis%coord(:)-axis%val)*axunit%user_per_prog
       endif
       axis%val  = axis%val*axunit%user_per_prog
       axis%inc  = axis%inc*axunit%user_per_prog
       axis%unit = axunit%name
    endif
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(trim(prog%axtype)//'_'//options(iaxis),substruct,error)
       if (error) return
       call cubetools_axis_axis2userstruct(axis,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,trim(prog%axtype)//' axis',substruct,error)
       if (error) return
    else
       call cubetools_axis_axis2userstruct(axis,userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,trim(prog%axtype)//' axis',prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_axis
  !
  subroutine cubeedit_getheader_prog_act_get_shape(prog,error)
    use cubetools_shape_types
    use cubetools_header_methods
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(shape_t) :: n
    type(userstruct_t) ::substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>SHAPE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_array_shape(prog%cube%head,n,error)
    if (error) return
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(ishape),substruct,error)
       if (error) return
       call cubetools_shape_shape2userstruct(n,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ishape),substruct,error)
       if (error) return
    else
       call cubetools_shape_shape2userstruct(n,userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ishape),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_shape
  !
  subroutine cubeedit_getheader_prog_act_get_extrema(prog,error)
    use cubetools_header_array_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) ::substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>EXTREMA'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(iextrema),substruct,error)
       if (error) return
       call cubetools_array_extrema2userstruct(prog%cube%head%arr,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iextrema),substruct,error)
       if (error) return
    else
       call cubetools_array_extrema2userstruct(prog%cube%head%arr,userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iextrema),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_extrema
  !
  subroutine cubeedit_getheader_prog_act_get_unit(prog,error)
    use cubetools_header_array_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(uservar_t) :: membervar
    type(userstruct_t), pointer :: userstruct
    type(uservar_t), pointer :: uservar
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>UNIT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%issub) then
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%create_member(options(iunit),membervar,error)
       if (error) return
       call cubetools_array_unit2uservar(prog%cube%head%arr,membervar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iunit),membervar,error)
       if (error) return
    else
       uservar => cubetools_uservar_ptr(prog%userspace,error)
       if (error)  return
       call cubetools_array_unit2uservar(prog%cube%head%arr,uservar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iunit),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_unit
  !
  subroutine cubeedit_getheader_prog_act_get_noise(prog,error)
    use cubetools_noise_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>NOISE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(inoise),substruct,error)
       if (error) return
       call cubetools_array_noise2userstruct(prog%cube%head%arr%noi,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(inoise),substruct,error)
       if (error) return
    else
       call cubetools_array_noise2userstruct(prog%cube%head%arr%noi,userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(inoise),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_noise
  !
  subroutine cubeedit_getheader_prog_act_get_spatialframe(prog,error)
    use cubetools_spafra_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>SPATIAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(ispatialframe),substruct,error)
       if (error) return
       call cubetoools_spafra_spafra2userstruct(prog%cube%head%spa%fra,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ispatialframe),substruct,error)
       if (error) return
    else
       call cubetoools_spafra_spafra2userstruct(prog%cube%head%spa%fra,userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ispatialframe),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_spatialframe
  !
  subroutine cubeedit_getheader_prog_act_get_source(prog,error)
    use cubetools_spatial_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(uservar_t) :: membervar
    type(userstruct_t), pointer :: userstruct
    type(uservar_t), pointer :: uservar
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>SOURCE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%issub) then
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%create_member(options(isource),membervar,error)
       if (error) return
       call cubetools_spatial_source2uservar(prog%cube%head%spa,membervar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(isource),membervar,error)
       if (error) return
    else
       uservar => cubetools_uservar_ptr(prog%userspace,error)
       if (error)  return
       call cubetools_spatial_source2uservar(prog%cube%head%spa,uservar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(isource),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_source
  !
  subroutine cubeedit_getheader_prog_act_get_ptype(prog,error)
    use cubetools_spapro_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(uservar_t) :: membervar
    type(userstruct_t), pointer :: userstruct
    type(uservar_t), pointer :: uservar
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>PTYPE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%issub) then
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%create_member(options(iptype),membervar,error)
       if (error) return
       call cubetools_spapro_type2uservar(prog%cube%head%spa%pro,membervar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iptype),membervar,error)
       if (error) return
    else
       uservar => cubetools_uservar_ptr(prog%userspace,error)
       if (error)  return
       call cubetools_spapro_type2uservar(prog%cube%head%spa%pro,uservar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iptype),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_ptype
  !
  subroutine cubeedit_getheader_prog_act_get_pcenter(prog,error)
    use cubetools_spapro_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) ::substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>PCENTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(ipcenter),substruct,error)
       if (error) return
       call cubetools_spapro_center2userstruct(prog%cube%head%spa%fra,prog%cube%head%spa%pro,&
         substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ipcenter),substruct,error)
       if (error) return
    else
       call cubetools_spapro_center2userstruct(prog%cube%head%spa%fra,prog%cube%head%spa%pro,&
            userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ipcenter),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_pcenter
  !
  subroutine cubeedit_getheader_prog_act_get_pangle(prog,error)
    use cubetools_spapro_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) ::substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>PANGLE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(ipangle),substruct,error)
       if (error) return
       call cubetools_spapro_angle2userstruct(prog%cube%head%spa%pro,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ipangle),substruct,error)
       if (error) return
    else
       call cubetools_spapro_angle2userstruct(prog%cube%head%spa%pro,userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ipangle),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_pangle
  !
  subroutine cubeedit_getheader_prog_act_get_beam(prog,error)
    use cubetools_beam_types
    use cubetools_header_methods
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) ::substruct
    type(userstruct_t), pointer :: userstruct
    type(beam_t) :: beam
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>BEAM'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_spabeam(prog%cube%head,beam,error)
    if (error) return
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(ibeam),substruct,error)
       if (error) return
       call cubetools_beam_beam2userstruct(beam,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ibeam),substruct,error)
       if (error) return
    else
       call cubetools_beam_beam2userstruct(beam,userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ibeam),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_beam
  !
  subroutine cubeedit_getheader_prog_act_get_spectralframe(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(uservar_t) :: membervar
    type(userstruct_t), pointer :: userstruct
    type(uservar_t), pointer :: uservar
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>SPECTRALFRAME'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%issub) then
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%create_member(options(ispectralframe),membervar,error)
       if (error) return
       call prog%cube%head%spe%load_frame_into(membervar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ispectralframe),membervar,error)
       if (error) return
    else
       uservar => cubetools_uservar_ptr(prog%userspace,error)
       if (error)  return
       call prog%cube%head%spe%load_frame_into(uservar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ispectralframe),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_spectralframe
  !
  subroutine cubeedit_getheader_prog_act_get_velocity(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>VELOCITY'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(ivelocity),substruct,error)
       if (error) return
       call prog%cube%head%spe%load_velocity_into(substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ivelocity),substruct,error)
       if (error) return
    else
       call prog%cube%head%spe%load_velocity_into(userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ivelocity),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_velocity
  !
  subroutine cubeedit_getheader_prog_act_get_redshift(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>REDSHIFT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(iredshift),substruct,error)
       if (error) return
       call prog%cube%head%spe%load_redshift_into(substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iredshift),substruct,error)
       if (error) return
    else
       call prog%cube%head%spe%load_redshift_into(userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iredshift),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_redshift
  !
  subroutine cubeedit_getheader_prog_act_get_line(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(uservar_t) :: membervar
    type(userstruct_t), pointer :: userstruct
    type(uservar_t), pointer :: uservar
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>LINE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%issub) then
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%create_member(options(iline),membervar,error)
       if (error) return
       call prog%cube%head%spe%load_line_into(membervar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iline),membervar,error)
       if (error) return
    else
       uservar => cubetools_uservar_ptr(prog%userspace,error)
       if (error)  return
       call prog%cube%head%spe%load_line_into(uservar,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iline),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_line
  !
  subroutine cubeedit_getheader_prog_act_get_frequency(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>FREQUENCY'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(ifrequency),substruct,error)
       if (error) return
       call prog%cube%head%spe%load_frequency_into(substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ifrequency),substruct,error)
       if (error) return
    else
       call prog%cube%head%spe%load_frequency_into(userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ifrequency),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_frequency
  !
  subroutine cubeedit_getheader_prog_act_get_wavelength(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>WAVELENGTH'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(iwavelength),substruct,error)
       if (error) return
       call prog%cube%head%spe%load_wavelength_into(substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iwavelength),substruct,error)
       if (error) return
    else
       call prog%cube%head%spe%load_wavelength_into(userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iwavelength),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_wavelength
  !
  subroutine cubeedit_getheader_prog_act_get_observatory(prog,error)
    use cubetools_observatory_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>OBSERVATORY'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    userstruct => cubetools_userstruct_ptr(prog%userspace,error)
    if (error)  return
    if (prog%issub) then
       call userstruct%def_substruct(options(iobservatory),substruct,error)
       if (error) return
       call cubetools_observatory_obs2userstruct(prog%cube%head%obs,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iobservatory),substruct,error)
       if (error) return
    else
       call cubetools_observatory_obs2userstruct(prog%cube%head%obs,userstruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iobservatory),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_observatory
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeedit_getheader_prog_act_get_id(prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>ID'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%issub) then
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%def_substruct(options(iid),substruct,error)
       if (error) return
       call id_to_struct(prog%cube,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iid),substruct,error)
       if (error) return
    else
       call id_to_struct(prog%cube,prog%userspace,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(iid),prog%userspace,error)
       if (error) return
    endif
  contains
    subroutine id_to_struct(cube,userspace,error)
!      use gkernel_interfaces
      use cubetools_flag_types
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      class(format_t),    intent(in)    :: cube
      class(userspace_t), intent(inout) :: userspace
      logical,            intent(inout) :: error
      !
      integer(kind=4) :: nc
      character(len=dag_flagl), allocatable :: flags(:)
      character(len=argu_l) :: concatenated
      type(userstruct_t), pointer :: struct
      character(len=*), parameter :: rname='GETHEADER>ID>TOSTRUCT'
      !
      call cubeedit_message(edseve%trace,rname,'Welcome')
      !
      struct => cubetools_userstruct_ptr(userspace,error)
      if (error)  return
      call struct%def(error)
      if (error) return
      !
      call struct%set_member('id',cube%node%id,error)
      if (error) return
      call struct%set_member('family',cube%node%family,error)
      if (error) return
      call struct%set_member('nflag',cube%node%flag%n,error)
      if (error) return
      !
      call cube%node%flag%export(flags,error)
      if (error)  return
      call struct%set_member('flags',flags,error)
      if (error) return
      !
      call cube%node%flag%repr(strflag=concatenated,lstrflag=nc,error=error)
      if (error)  return
      if (concatenated(nc-1:nc).eq.'..') then
        call cubeedit_message(seve%w,rname,&
          trim(struct%name)//'%FLAGSTRING variable truncated')
      endif
      call struct%set_member('flagstring',concatenated,error)
      if (error) return
    end subroutine id_to_struct
  end subroutine cubeedit_getheader_prog_act_get_id
  !
  subroutine cubeedit_getheader_prog_act_get_tuple(prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>TUPLE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%issub) then
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%def_substruct(options(ituple),substruct,error)
       if (error) return
       call prog%cube%node%tuple%to_struct(substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ituple),substruct,error)
       if (error) return
    else
       call prog%cube%node%tuple%to_struct(prog%userspace,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,options(ituple),prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_tuple
  !
  subroutine cubeedit_getheader_prog_act_get_parents(prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    call cubeedit_getheader_prog_act_get_links(prog,options(iparents),&
      prog%cube%node%links%parents,error)
    if (error)  return
  end subroutine cubeedit_getheader_prog_act_get_parents
  !
  subroutine cubeedit_getheader_prog_act_get_children(prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    call cubeedit_getheader_prog_act_get_links(prog,options(ichildren),&
      prog%cube%node%links%children,error)
    if (error)  return
  end subroutine cubeedit_getheader_prog_act_get_children
  !
  subroutine cubeedit_getheader_prog_act_get_twins(prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    call cubeedit_getheader_prog_act_get_links(prog,options(itwins),&
      prog%cube%node%links%twins,error)
    if (error)  return
  end subroutine cubeedit_getheader_prog_act_get_twins
  !
  subroutine cubeedit_getheader_prog_act_get_links(prog,optname,link,error)
    use cubedag_link_type
    !-------------------------------------------------------------------
    ! Generic for
    !   cubeedit_getheader_prog_act_get_parents
    !   cubeedit_getheader_prog_act_get_children
    !   cubeedit_getheader_prog_act_get_twins
    !-------------------------------------------------------------------
    type(getheader_prog_t), intent(inout) :: prog
    character(len=*),       intent(in)    :: optname
    type(cubedag_link_t),   intent(in)    :: link
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: substruct
    type(userstruct_t), pointer :: userstruct
    character(len=*), parameter :: rname='GETHEADER>PROG>ACT>GET>LINKS'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%issub) then
       userstruct => cubetools_userstruct_ptr(prog%userspace,error)
       if (error)  return
       call userstruct%def_substruct(optname,substruct,error)
       if (error) return
       call link_to_struct(link,substruct,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,optname,substruct,error)
       if (error) return
    else
       call link_to_struct(link,prog%userspace,error)
       if (error) return
       call cubeedit_getheader_newbuffer(prog%cube%node%id,optname,prog%userspace,error)
       if (error) return
    endif
  end subroutine cubeedit_getheader_prog_act_get_links
  !
  subroutine link_to_struct(link,userspace,error)
    use gkernel_interfaces, only: failed_allocate
    use cubedag_parameters
    use cubedag_link_type
    use cubedag_node_class
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cubedag_link_t), intent(in)    :: link
    class(userspace_t),   intent(inout) :: userspace
    logical,              intent(inout) :: error
    !
    type(userstruct_t), pointer :: struct
    character(len=128), allocatable :: cubeids(:)
    integer(kind=iden_l), allocatable :: ids(:)
    integer(kind=4) :: ier,ilink
    class(cubedag_node_object_t), pointer :: this
    character(len=*), parameter :: rname='GETHEADER>ID>TOSTRUCT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    struct => cubetools_userstruct_ptr(userspace,error)
    if (error)  return
    call struct%def(error)
    if (error) return
    !
    call struct%set_member('n',link%n,error)
    if (error) return
    !
    if (link%n.le.0)  return
    !
    allocate(cubeids(link%n),ids(link%n),stat=ier)
    if (failed_allocate(rname,'cubeids',ier,error)) return
    do ilink=1,link%n
      this => cubedag_node_ptr(link%list(ilink)%p,error)
      if (error)  return
      ids(ilink) = this%node%id
      cubeids(ilink) = this%node%cubeid(error)
      if (error)  return
    enddo
    call struct%set_member('id',ids,error)
    if (error) return
    call struct%set_member('cubeid',cubeids,error)
    if (error) return
  end subroutine link_to_struct
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_getheader_newbuffer(id,type,space,error)
    !------------------------------------------------------------------------
    ! Reallocates buffers for bookeeping
    !------------------------------------------------------------------------
    integer(kind=4),    intent(in)    :: id
    character(len=*),   intent(in)    :: type
    class(userspace_t), intent(in)    :: space
    logical,            intent(inout) :: error
    !
    type(getheader_buffer_t), pointer :: buffer
    type(getheader_buffer_t) :: template
    class(list_object_t), pointer :: lot
    character(len=*), parameter :: rname='GETHEADER>NEWBUFFER'
    !
    call cubeedit_message(edseve%trace,rname,'welcome')
    !
    ! First remove any conflicting buffer. NB: SIC variables have
    ! already been removed-and-replaced, we just have to remove
    ! the buffers associated to the removed SIC variable.
    call cubetools_userspace_array_remove(bookkeeping,space,error)
    if (error) return
    !
    ! Insert new buffer associated to new SIC variable
    call bookkeeping%allocate(template,lot,error)
    if (error)  return
    ! Save in list
    buffer => getheader_buffer_ptr(lot,error)
    if (error)  return
    buffer%userspace_t = space
    buffer%type        = type
    buffer%id          = id
  end subroutine cubeedit_getheader_newbuffer
  !
  function getheader_buffer_ptr(buffer,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(getheader_buffer_t), and
    ! return a pointer to it if yes.
    !-------------------------------------------------------------------
    type(getheader_buffer_t), pointer :: getheader_buffer_ptr  ! Function value on return
    class(list_object_t),     pointer       :: buffer
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='GETHEADER>BUFFER>PTR'
    !
    select type(buffer)
    type is (getheader_buffer_t)
      getheader_buffer_ptr => buffer
    class default
      getheader_buffer_ptr => null()
      call cubeedit_message(seve%e,rname,&
        'Internal error: object is not a getheader_buffer_t type')
      error = .true.
      return
    end select
  end function getheader_buffer_ptr
end module cubeedit_getheader_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_wifi2visi_command(line,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi2visi_command
  use wifisyn_sic_buffer
  use wifisyn_cube_buffer
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  character(len=*), parameter :: rname='WIFI2VISI/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_wifi2visi_main(progmap,wifi,visi,error)
  if (error) return
  !
end subroutine wifisyn_wifi2visi_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_wifi2visi_main(map,wifi,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi2visi_main
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(map_t),     intent(in)    :: map
  type(wifi_t),    intent(in)    :: wifi
  type(visi_t),    intent(inout) :: visi
  logical,         intent(inout) :: error
  !
  integer :: na,nb,nc
  character(len=*), parameter :: rname='WIFI2VISI/MAIN'
  !
  nc = wifi%cub%nc
  na = map%axes(1)%a%uvp%n
  nb = map%axes(2)%a%uvp%n
  call wifisyn_reallocate_complex_xyc('visi%cub',na,nb,nc,visi%cub,error)
  if (error) return
  call wifisyn_visi_wei_header(map,visi,error)
  if (error) return
  call wifisyn_cube_reallocate_r2d('visi%wei',visi%wei,error)
  if (error) return
  visi%uvkind = .true.
  call wifisyn_cube_sicdef(code_readonly,'visiwei',visi%wei,error)
  if (error) return
  !
!  call wifisyn_wifi2visi_average(map%axes,wifi,visi,error)
!  if (error) return
!  call wifisyn_wifi2visi_average_and_symmetry(map%axes,wifi,visi,error)
!  if (error) return
  call wifisyn_wifi2visi_shift_and_sum(map%axes,wifi,visi,error)
  if (error) return
!  call wifisyn_wifi2visi_sum(map%axes,wifi,visi,error)
!  if (error) return
  call wifisyn_cube_minmax_r2d(code_linscale,visi%wei,error)
  if (error) return
  !
end subroutine wifisyn_wifi2visi_main
!
subroutine wifisyn_visi_wei_header(map,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_visi_wei_header
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  ! This one should be merged with wifisyn_wifi_header *** JP
  !----------------------------------------------------------------------
  type(map_t),     intent(in)    :: map
  type(visi_t),    intent(inout) :: visi
  logical,         intent(inout) :: error
  !
  character(len=*), parameter :: rname='VISI/WEI/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_common_header(map,visi%wei,error)
  if (error) return
  visi%wei%gil%faxi = 0
  if (visi%uvkind) then
     ! 1st axis
     visi%wei%char%code(1) = 'U'
     visi%wei%gil%dim(1) = map%axes(1)%a%uvp%n
     visi%wei%gil%ref(1) = map%axes(1)%a%uvp%ref
     visi%wei%gil%val(1) = map%axes(1)%a%uvp%val
     visi%wei%gil%inc(1) = map%axes(1)%a%uvp%inc
     visi%wei%gil%xaxi = 0
     ! 2nd axis
     visi%wei%char%code(2) = 'V'
     visi%wei%gil%dim(2) = map%axes(2)%a%uvp%n
     visi%wei%gil%ref(2) = map%axes(2)%a%uvp%ref
     visi%wei%gil%val(2) = map%axes(2)%a%uvp%val
     visi%wei%gil%inc(2) = map%axes(2)%a%uvp%inc
     visi%wei%gil%yaxi = 0
  else
     ! 1st axis
     visi%wei%char%code(1) = 'RA'
     visi%wei%gil%dim(1) = map%axes(1)%a%sky%n
     visi%wei%gil%ref(1) = map%axes(1)%a%sky%ref
     visi%wei%gil%val(1) = map%axes(1)%a%sky%val
     visi%wei%gil%inc(1) = map%axes(1)%a%sky%inc
     visi%wei%gil%xaxi = 1
     ! 2nd axis
     visi%wei%char%code(2) = 'DEC'
     visi%wei%gil%dim(2) = map%axes(2)%a%sky%n
     visi%wei%gil%ref(2) = map%axes(2)%a%sky%ref
     visi%wei%gil%val(2) = map%axes(2)%a%sky%val
     visi%wei%gil%inc(2) = map%axes(2)%a%sky%inc
     visi%wei%gil%yaxi = 2
  endif
  !
end subroutine wifisyn_visi_wei_header
!
subroutine wifisyn_wifi2visi_average(axes,wifi,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi2visi_average
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(axis_t), intent(in)    :: axes(2)
  type(wifi_t), intent(in)    :: wifi
  type(visi_t), intent(inout) :: visi
  logical,      intent(inout) :: error
  !
  integer :: nout,uf_per_up,vf_per_vp
  integer :: nup,mup,iup,jup
  integer :: nvp,mvp,ivp,jvp
  integer :: nus,mus,ius
  integer :: nvs,mvs,ivs
  integer :: nuf,muf,iuf
  integer :: nvf,mvf,ivf
  character(len=80) :: mess
  character(len=*), parameter :: rname='WIFI2VISI/AVERAGE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Initialization
  visi%wei%r2d = 0.0
  visi%cub%val = (0.0,0.0)
  !
  nup = axes(1)%u%uvp%n
  nvp = axes(2)%u%uvp%n
  nus = axes(1)%x%uvp%n
  nvs = axes(2)%x%uvp%n
  nuf = axes(1)%a%uvp%n
  nvf = axes(2)%a%uvp%n
  !
  uf_per_up = axes(1)%dup_per_duf
  vf_per_vp = axes(2)%dup_per_duf
  !
  mus = nus/2
  mvs = nvs/2
  mup = nup/2
  mvp = nvp/2
  muf = nuf/2
  mvf = nvf/2
  !
do ivp=1,nvp
   jvp = mvf + (ivp-mvp-1)*vf_per_vp
   do ivs=1,nvs
      ivf = jvp + (ivs-mvs)
      write(mess,*) ivp,jvp,ivs,ivf,nvf
      call wifisyn_message(seve%i,rname,mess)
   enddo
enddo
  !
  ! Summation
  nout = 0
  do ivp=1,nvp
     jvp = mvf + (ivp-mvp-1)*vf_per_vp
     do iup=1,nup
        jup = muf + (iup-mup-1)*uf_per_up
        do ivs=1,nvs
           ivf = jvp + (ivs-mvs)
           if ((1.le.ivf).and.(ivf.le.nvf)) then
              do ius=1,nus
                 iuf = jup + (ius-mus)
                 if ((1.le.iuf).and.(iuf.le.nuf)) then
                    visi%wei%r2d(iuf,ivf) = visi%wei%r2d(iuf,ivf)+1.0
                    visi%cub%val(iuf,ivf,:) = visi%cub%val(iuf,ivf,:)+wifi%cub%val(:,ius,ivs,iup,ivp)
                 else
                    nout = nout+1
                 endif ! ((1.le.iuf).and.(iuf.le.nuf))
              enddo ! ius
           else
              nout = nout + nus
           endif ! ((1.le.ivf).and.(ivf.le.nvf))
        enddo ! ivs
     enddo ! iup
  enddo ! ivp
  write(mess,'(a,i0,a,i0)') 'Number of frequencies falling outside: ',nout,' over ',nus*nvs*nup*nvp
  call wifisyn_message(seve%i,rname,mess)
  !
end subroutine wifisyn_wifi2visi_average
!
subroutine wifisyn_wifi2visi_average_and_symmetry(axes,wifi,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi2visi_average_and_symmetry
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(axis_t), intent(in)    :: axes(2)
  type(wifi_t), intent(in)    :: wifi
  type(visi_t), intent(inout) :: visi
  logical,      intent(inout) :: error
  !
  integer :: nout,uf_per_up,vf_per_vp
  integer :: nup,mup,iup,jup
  integer :: nvp,mvp,ivp,jvp
  integer :: nus,mus,ius
  integer :: nvs,mvs,ivs
  integer :: nuf,muf,iuf,juf
  integer :: nvf,mvf,ivf,jvf
  character(len=80) :: mess
  character(len=*), parameter :: rname='WIFI2VISI/AVERAGE+SYMMETRY'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Initialization
  visi%wei%r2d = 0.0
  visi%cub%val = (0.0,0.0)
  !
  uf_per_up = axes(1)%dup_per_duf
  nup = axes(1)%u%uvp%n
  nus = axes(1)%x%uvp%n
  nuf = axes(1)%a%uvp%n
  mus = nus/2
  mup = nup/2
  muf = nuf/2
  !
  vf_per_vp = axes(2)%dup_per_duf
  nvp = axes(2)%u%uvp%n
  nvs = axes(2)%x%uvp%n
  nvf = axes(2)%a%uvp%n
  mvs = nvs/2
  mvp = nvp/2
  mvf = nvf/2
  !
  ! Summation
  nout = 0
  do ivp=1,mvp+1
     jvp = mvf+1 + (ivp-mvp-1)*vf_per_vp
     do iup=1,nup
        jup = muf+1 + (iup-mup-1)*uf_per_up
        do ivs=1,nvs
           ivf = jvp + (ivs-mvs-1)
           if ((1.le.ivf).and.(ivf.le.nvf)) then
              do ius=1,nus
                 iuf = jup + (ius-mus-1)
                 if ((1.le.iuf).and.(iuf.le.nuf)) then
                    visi%wei%r2d(iuf,ivf) = visi%wei%r2d(iuf,ivf)+1.0
                    visi%cub%val(iuf,ivf,:) = visi%cub%val(iuf,ivf,:)+wifi%cub%val(:,ius,ivs,iup,ivp)
                 else
                    nout = nout+1
                 endif ! ((1.le.iuf).and.(iuf.le.nuf))
              enddo ! ius
           else
              nout = nout + nus
           endif ! ((1.le.ivf).and.(ivf.le.nvf))
           ! Symmetrical part
           jvf = nvf+2-ivf
           if ((1.le.jvf).and.(jvf.le.nvf)) then
              do ius=1,nus
                 iuf = jup + (ius-mus-1)
                 juf = nuf+2-iuf
                 if ((1.le.juf).and.(juf.le.nuf)) then
                    visi%wei%r2d(juf,jvf) = visi%wei%r2d(juf,jvf)+1.0
                    visi%cub%val(juf,jvf,:) = visi%cub%val(juf,jvf,:)+conjg(wifi%cub%val(:,ius,ivs,iup,ivp))
                 else
                    nout = nout+1
                 endif ! ((1.le.juf).and.(juf.le.nuf))
              enddo ! ius
           else
              nout = nout + nus
           endif ! ((1.le.jvf).and.(jvf.le.nvf))
        enddo ! ivs
     enddo ! iup
  enddo ! ivp
  write(mess,'(a,i0,a,i0)') 'Number of frequencies falling outside: ',nout,' over ',nus*nvs*nup*nvp
  call wifisyn_message(seve%i,rname,mess)
  !
end subroutine wifisyn_wifi2visi_average_and_symmetry
!
subroutine wifisyn_wifi2visi_shift_and_sum(axes,wifi,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi2visi_shift_and_sum
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(axis_t), intent(in)    :: axes(2)
  type(wifi_t), intent(in)    :: wifi
  type(visi_t), intent(inout) :: visi
  logical,      intent(inout) :: error
  !
  real(kind=8) :: uf_per_up,vf_per_vp
  integer :: nusout,nvsout
  integer :: nup,mup,iup,jup,iupmin,iupmax,iupzero,kupmin,kupmax
  integer :: nvp,mvp,ivp,jvp,ivpmin,ivpmax,ivpzero,kvpmin,kvpmax
  integer :: nus,mus,ius,jus,iusmin,iusmax,iuszero
  integer :: nvs,mvs,ivs,jvs,ivsmin,ivsmax,ivszero
  integer :: nuf,muf,iuf,juf,iufmin,iufmax,iufzero,kuf
  integer :: nvf,mvf,ivf,jvf,ivfmin,ivfmax,ivfzero,kvf
  character(len=80) :: mess
  character(len=*), parameter :: rname='WIFI2VISI/SHIFT&SUM'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  uf_per_up = axes(1)%dup_per_duf
  nup = axes(1)%u%uvp%n
  nus = axes(1)%x%uvp%n
  nuf = axes(1)%a%uvp%n
  mus = nus/2
  mup = nup/2
  muf = nuf/2
  iupmin = -mup
  iusmin = -mus
  iufmin = -muf
  iupmax = mup-1
  iusmax = mus-1
  iufmax = muf-1
  iupzero = mup+1
  iuszero = mus+1
  iufzero = muf+1
  !
  vf_per_vp = axes(2)%dup_per_duf
  nvp = axes(2)%u%uvp%n
  nvs = axes(2)%x%uvp%n
  nvf = axes(2)%a%uvp%n
  mvs = nvs/2
  mvp = nvp/2
  mvf = nvf/2
  ivpmin = -mvp
  ivsmin = -mvs
  ivfmin = -mvf
  ivpmax = mvp-1
  ivsmax = mvs-1
  ivfmax = mvf-1
  ivpzero = mvp+1
  ivszero = mvs+1
  ivfzero = mvf+1
  !
  ! Initialization
  nusout = 0
  nvsout = 0
  visi%wei%r2d = 0.0
  visi%cub%val = (0.0,0.0)
  ! Summation
  do ivf=ivfmin,0
     jvf = ivf+ivfzero
     kvpmin = max(1+floor  ((ivf-ivsmax)/vf_per_vp),ivpmin)
     kvpmax = min(1+ceiling((ivf-ivsmin)/vf_per_vp),ivpmax)
     do ivp=kvpmin,kvpmax
        ivs = ivf-ivp*vf_per_vp
        jvp = ivp+ivpzero
        jvs = ivs+ivszero
        if ((ivsmin.le.ivs).and.(ivs.le.ivsmax)) then
           do iuf=iufmin,iufmax
              juf = iuf+iufzero
              kupmin = max(1+floor  ((iuf-iusmax)/uf_per_up),iupmin)
              kupmax = min(1+ceiling((iuf-iusmin)/uf_per_up),iupmax)
              do iup=kupmin,kupmax
                 ius = iuf-iup*uf_per_up
                 jup = iup+iupzero
                 jus = ius+iuszero
                 if ((iusmin.le.ius).and.(ius.le.iusmax)) then
                    visi%wei%r2d(juf,jvf) = visi%wei%r2d(juf,jvf)+1.0
                    visi%cub%val(juf,jvf,:) = visi%cub%val(juf,jvf,:)+wifi%cub%val(:,jus,jvs,jup,jvp)
                 else
                    nusout = nusout+1
                 endif !
              enddo ! iup
           enddo ! iuf
        else
           nvsout = nvsout+1
        endif !
     enddo ! ivp
  enddo ! ivf
  write(mess,'(a,i0,a,i0)') 'Number of frequencies falling outside: ',nusout,' and ',nvsout
  call wifisyn_message(seve%i,rname,mess)
  ! Symmetrical part
  do ivf=1,ivfmax
     jvf = ivfzero-ivf
     kvf = ivfzero+ivf
     do iuf=iufmin,iufmax
        juf = iufzero-iuf
        kuf = iufzero+iuf
        visi%wei%r2d(kuf,kvf) = visi%wei%r2d(juf,jvf)
        visi%cub%val(kuf,kvf,:) = conjg(visi%cub%val(juf,jvf,:))
     enddo ! iuf
  enddo ! ivf
  do iuf=1,iufmax
     juf = iufzero-iuf
     kuf = iufzero+iuf
     visi%wei%r2d(kuf,ivfzero) = visi%wei%r2d(juf,ivfzero)
     visi%cub%val(kuf,ivfzero,:) = conjg(visi%cub%val(juf,ivfzero,:))
  enddo ! iuf
  if (any(visi%cub%val(iufzero,ivfzero,:).ne.0.0)) then
     print *,visi%cub%val(iufzero,ivfzero,:)
     visi%cub%val(iufzero,ivfzero,:) = cmplx(real(visi%cub%val(iufzero,ivfzero,:)),0.0)
     call wifisyn_message(seve%i,rname,'Setting zero spacing imaginary part to 0')
  endif
  !
end subroutine wifisyn_wifi2visi_shift_and_sum
!
subroutine wifisyn_wifi2visi_sum(axes,wifi,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi2visi_sum
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  ! *** JP This requires the same us and uf axes to actually work...
  !----------------------------------------------------------------------
  type(axis_t), intent(in)    :: axes(2)
  type(wifi_t), intent(in)    :: wifi
  type(visi_t), intent(inout) :: visi
  logical,      intent(inout) :: error
  !
  integer :: nusout,nvsout
  integer :: nup,mup,iup,jup,iupmin,iupmax,iupzero
  integer :: nvp,mvp,ivp,jvp,ivpmin,ivpmax,ivpzero
  integer :: nus,mus,ius,jus,iusmin,iusmax,iuszero
  integer :: nvs,mvs,ivs,jvs,ivsmin,ivsmax,ivszero
  integer :: nuf,muf,iuf,juf,iufmin,iufmax,iufzero,kuf
  integer :: nvf,mvf,ivf,jvf,ivfmin,ivfmax,ivfzero,kvf
  character(len=80) :: mess
  character(len=*), parameter :: rname='WIFI2VISI/SUM'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nup = axes(1)%u%uvp%n
  nus = axes(1)%x%uvp%n
  nuf = axes(1)%a%uvp%n
  mus = nus/2
  mup = nup/2
  muf = nuf/2
  iupmin = -mup
  iusmin = -mus
  iufmin = -muf
  iupmax = mup-1
  iusmax = mus-1
  iufmax = muf-1
  iupzero = mup+1
  iuszero = mus+1
  iufzero = muf+1
  !
  nvp = axes(2)%u%uvp%n
  nvs = axes(2)%x%uvp%n
  nvf = axes(2)%a%uvp%n
  mvs = nvs/2
  mvp = nvp/2
  mvf = nvf/2
  ivpmin = -mvp
  ivsmin = -mvs
  ivfmin = -mvf
  ivpmax = mvp-1
  ivsmax = mvs-1
  ivfmax = mvf-1
  ivpzero = mvp+1
  ivszero = mvs+1
  ivfzero = mvf+1
  !
  ! Initialization
  nusout = 0
  nvsout = 0
  visi%wei%r2d = 0.0
  visi%cub%val = (0.0,0.0)
  ! Summation
  do ivf=ivfmin,0
     jvf = ivfzero+ivf
     jvs = ivszero+ivf
     if ((1.le.jvs).and.(jvs.le.nvs)) then
        do ivp=ivpmin,ivpmax
           jvp = ivpzero+ivp
           do iuf=iufmin,iufmax
              juf = iufzero+iuf
              jus = iuszero+iuf
              if ((1.le.jus).and.(jus.le.nus)) then
                 do iup=iupmin,iupmax
                    jup = iupzero+iup
                    visi%wei%r2d(juf,jvf) = visi%wei%r2d(juf,jvf)+1.0
                    visi%cub%val(juf,jvf,:) = visi%cub%val(juf,jvf,:)+wifi%cub%val(:,jus,jvs,jup,jvp)
                 enddo ! iup
              else
                 nusout = nusout+1
              endif !
           enddo ! iuf
        enddo ! ivp
     else
        nvsout = nvsout+1
     endif !
  enddo ! ivf
  write(mess,'(a,i0,a,i0)') 'Number of frequencies falling outside: ',nusout,' and ',nvsout
  call wifisyn_message(seve%i,rname,mess)
  ! Symmetrical part
  do ivf=1,ivfmax
     jvf = ivfzero-ivf
     kvf = ivfzero+ivf
     do iuf=iufmin,iufmax
        juf = iufzero-iuf
        kuf = iufzero+iuf
        visi%wei%r2d(kuf,kvf) = visi%wei%r2d(juf,jvf)
        visi%cub%val(kuf,kvf,:) = conjg(visi%cub%val(juf,jvf,:))
     enddo ! iuf
  enddo ! ivf
  do iuf=1,iufmax
     juf = iufzero-iuf
     kuf = iufzero+iuf
     visi%wei%r2d(kuf,ivfzero) = visi%wei%r2d(juf,ivfzero)
     visi%cub%val(kuf,ivfzero,:) = conjg(visi%cub%val(juf,ivfzero,:))
  enddo ! iuf
  if (any(visi%cub%val(iufzero,ivfzero,:).ne.0.0)) then
     print *,visi%cub%val(iufzero,ivfzero,:)
     visi%cub%val(iufzero,ivfzero,:) = cmplx(real(visi%cub%val(iufzero,ivfzero,:)),0.0)
     call wifisyn_message(seve%i,rname,'Setting zero spacing imaginary part to 0')
  endif
  !
end subroutine wifisyn_wifi2visi_sum
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeadm_flag
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetools_flag_types
  use cubeadm_messaging
  !
  public :: flag
  private
  !
  type flag_comm_t
     type(option_t), pointer :: comm
     type(option_t), pointer :: add
     type(option_t), pointer :: debug
   contains
     procedure, public  :: register => cubeadm_flag_register
     procedure, private :: parse    => cubeadm_flag_parse
     procedure, private :: main     => cubeadm_flag_main
  end type flag_comm_t
  type(flag_comm_t) :: flag
  !
  type flag_user_t
    logical               :: add_do
    character(len=argu_l) :: add_name
    logical               :: debug_do
  contains
    procedure, private :: toprog => cubeadm_flag_user_toprog
  end type flag_user_t
  !
  type flag_prog_t
    logical               :: add_do
    character(len=argu_l) :: add_name
    logical               :: debug_do
  contains
    procedure, public :: do => cubeadm_flag_do
  end type flag_prog_t
  !
contains
  !
  subroutine cubeadm_flag_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(flag_user_t) :: user
    character(len=*), parameter :: rname='FLAG>COMMAND'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call flag%parse(line,user,error)
    if (error) return
    call flag%main(user,error)
    if (error) return
  end subroutine cubeadm_flag_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeadm_flag_register(flag,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_comm_t), intent(inout) :: flag
    logical,            intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='FLAG>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'FLAG','',&
         'List, add, or debug available flags',&
         'Without options, list the currently registered flags. With options,&
         & execute the requested flag-management action.',&
         cubeadm_flag_command,&
         flag%comm,error)
    if (error) return
    !
    call cubetools_register_option(&
         'ADD','Name',&
         'Add a new user-defined flag',&
         strg_emp,&
         flag%add,error)
    if (error) return
    call stdarg%register(&
         'Name', &
         'Flag name',&
         'The new flag name must be unambiguous with all other flag names.',&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'DEBUG','',&
         'List all flags ind debug format',&
         strg_emp,&
         flag%debug,error)
    if (error) return
  end subroutine cubeadm_flag_register
  !
  subroutine cubeadm_flag_parse(flag,line,user,error)
    !-------------------------------------------------------------------
    ! Parsing facility for command FLAG
    !-------------------------------------------------------------------
    class(flag_comm_t), intent(inout) :: flag
    character(len=*),   intent(in)    :: line
    type(flag_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAG>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call flag%add%present(line,user%add_do,error)
    if (error) return
    call flag%debug%present(line,user%debug_do,error)
    if (error) return
    !
    if (user%add_do) then
      call cubetools_getarg(line,flag%add,1,user%add_name,mandatory,error)
      if (error) return
    endif
  end subroutine cubeadm_flag_parse
  !
  subroutine cubeadm_flag_main(flag,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(flag_comm_t), intent(in)    :: flag
    type(flag_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(flag_prog_t) :: prog
    character(len=*), parameter :: rname='FLAG>MAIN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubeadm_flag_main
  !
  subroutine cubeadm_flag_user_toprog(user,prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(flag_user_t), intent(in)    :: user
    type(flag_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAG>USER2PROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    prog%add_do   = user%add_do
    prog%debug_do = user%debug_do
    !
    if (prog%add_do) then
      prog%add_name = user%add_name
    endif
  end subroutine cubeadm_flag_user_toprog
  !
  subroutine cubeadm_flag_do(prog,error)
    !---------------------------------------------------------------------
    ! Support for command ADM\FLAG
    !---------------------------------------------------------------------
    class(flag_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAG>DO'
    !
    if (prog%add_do) then
      call cubetools_flag_register_user(prog%add_name,error)
      if (error) return
    elseif (prog%debug_do) then
      call cubetools_flag_debug(error)
      if (error) return
    else
      call cubetools_flaglist_list_all(error)
      if (error) return
      call cubeadm_message(seve%r,rname,blankstr)
    endif
  end subroutine cubeadm_flag_do
  !
end module cubeadm_flag

        
        SUBROUTINE CHARGEL(UEL,UDEL,UELB,UDELB,UELB1,UDELB1)
C fills parameters UEL,UDEL with either UELB,UDELB or UELB1,UDELB1
        REAL*8 UEL,UDEL
        REAL UELB,UDELB,UELB1,UDELB1
*
        IF (UELB.NE.0.) THEN
           UEL=UELB
           UDEL=UDELB
        ELSE
           UEL=UELB1
           UDEL=UDELB1
        ENDIF
        END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_chebyshev_tool
  use cubetools_parameters
  use cubemain_messaging
  use cubemain_svd_tool
  !
  public :: chebyshev_t,svd_t
  private
  !
  integer(kind=4), parameter :: coef_k = inte_k
  integer(kind=4), parameter :: degr_k = inte_k
  !
  type chebyshev_t
     integer(kind=degr_k),  private :: n = 0              ! Polynomial degree
     real(kind=4), pointer, private :: coeff(:) => null() ! Coefficients
     real(kind=4), pointer, private :: cheby(:) => null() ! Chebyshev polynomial values
     real(kind=coor_k),     private :: xcur = 0.0 ! X current value where Chebyshev polynomial values are computed
     real(kind=coor_k),     private :: xmin = 0.0 ! Minimum value of the x-axis computation interval
     real(kind=coor_k),     private :: xmax = 0.0 ! Maximum value of the x-axis computation interval
     real(kind=coor_k),     private :: xcen = 0.0 ! Its center 
     real(kind=coor_k),     private :: xsiz = 0.0 ! Its size
   contains
     procedure, private :: reallocate => cubemain_chebyshev_reallocate
     procedure, private :: free       => cubemain_chebyshev_free
     procedure, public  :: fit        => cubemain_chebyshev_fit
     procedure, public  :: subtract   => cubemain_chebyshev_subtract
     procedure, public  :: list       => cubemain_chebyshev_list
     final :: cubemain_chebyshev_final
  end type chebyshev_t
  !
contains
  !
  subroutine cubemain_chebyshev_reallocate(poly,degree,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(chebyshev_t),   intent(inout) :: poly
    integer(kind=degr_k), intent(in)    :: degree
    logical,              intent(inout) :: error
    !
    logical :: alloc
    integer(kind=4) :: ier
    integer(kind=coef_k)  :: ncoeff
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='CHEBYSHEV>REALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Sanity check
    ncoeff = degree+1
    if (ncoeff.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of channels')
       error = .true.
       return
    endif
    alloc = .true.
    if (associated(poly%coeff)) then
       if (poly%n.eq.ncoeff) then
          write(mess,'(a,i0)')  &
               'Chebishev coefficients already associated at the right size: ',ncoeff
          call cubemain_message(mainseve%alloc,rname,mess)
          alloc = .false.
       else
          write(mess,'(a)') &
               'Chebishev coefficients already associated but with a different size => Freeing it first'
          call cubemain_message(mainseve%alloc,rname,mess)
          call poly%free(error)
          if (error) return
       endif
    endif
    if (alloc) then
       allocate(poly%coeff(ncoeff),poly%cheby(ncoeff),stat=ier)
       if (failed_allocate(rname,'Chebyshev coefficients',ier,error)) return
    endif
    ! Allocation success => poly%n may be updated
    poly%n = ncoeff
  end subroutine cubemain_chebyshev_reallocate
  !
  subroutine cubemain_chebyshev_free(poly,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(chebyshev_t), intent(inout) :: poly
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='CHEBYSHEV>FREE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    poly%n = 0
    if (associated(poly%coeff)) deallocate(poly%coeff)
    if (associated(poly%cheby)) deallocate(poly%cheby)
  end subroutine cubemain_chebyshev_free
  !
  subroutine cubemain_chebyshev_final(poly)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(chebyshev_t), intent(inout) :: poly
    !
    logical :: error
    character(len=*), parameter :: rname='CHEBYSHEV>FINAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call poly%free(error)
  end subroutine cubemain_chebyshev_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubemain_chebyshev_polynomials(x,t,np)
    !---------------------------------------------------------------------
    ! Compute the first NP-1 Chebyshev polynomial of first kind at x
    !    T_n(x), n=0...np-1
    ! Recurrence relation : T_(n+1)(x) - 2xT_(n)(x) + T_(n-1)(x) = 0
    ! Initialization      : T_0 = 1
    !                     : T_1 = x
    !---------------------------------------------------------------------
    real(kind=coor_k),    intent(in)  :: x      ! Variable value
    integer(kind=degr_k), intent(in)  :: np     ! Polynomial degree
    real(kind=sign_k),    intent(out) :: t(np)  ! NP values of Chebyshev polynomial
    !
    integer(kind=degr_k) :: ip
    !
    t(1) = 1.
    if (np.gt.1) then
       t(2) = x
       do ip=3,np
          t(ip)=2*t(ip-1)*x-t(ip-2)
       enddo
    endif
  end subroutine cubemain_chebyshev_polynomials
  !
  function cubemain_chebyshev_approximation(poly,x) result(val)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    type(chebyshev_t), intent(in) :: poly
    real(kind=coor_k), intent(in) :: x
    real(kind=sign_k)             :: val
    !
    integer(kind=coef_k) :: icoeff
    !
    call cubemain_chebyshev_polynomials(x,poly%cheby,poly%n)
    val = 0
    do icoeff=1,poly%n
       val = val+poly%coeff(icoeff)*poly%cheby(icoeff)
    enddo ! icoeff
  end function cubemain_chebyshev_approximation
  !
  subroutine cubemain_chebyshev_check_degree(rname,svd)
    use cubemain_svd_tool
    !---------------------------------------------------------------------
    ! *** JP: Not used anywhere anymore but could be used in the future
    !---------------------------------------------------------------------
    character,   intent(in) :: rname
    type(svd_t), intent(in) :: svd
    !
    integer(kind=degr_k)  :: imin
    character(len=mess_l) :: mess
    !
    if (svd%minloc_w_lt_np()) then
       write(mess,'(A,I2,A)') 'Degree ',imin-1,' would be even better'
       call cubemain_message(seve%i,rname,mess)
    endif
  end subroutine cubemain_chebyshev_check_degree
  !
  subroutine cubemain_chebyshev_fit(poly,degree,spec,svd,error)
    use cubeadm_spectrum_types
    use cubemain_svd_tool
    !---------------------------------------------------------------------
    ! Fit a Chebyshev polynomial baseline using singular value decomposition
    ! This one assumes that spec does not contain blanked values
    !---------------------------------------------------------------------
    class(chebyshev_t),   intent(inout) :: poly
    integer(kind=degr_k), intent(in)    :: degree
    type(spectrum_t),     intent(in)    :: spec
    type(svd_t),          intent(inout) :: svd
    logical,              intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    real(kind=sign_k) :: chisq
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='CHEBYSHEV>FIT'
    !
    ! Check that we have enough data points
    ! Note: polynomial degree >= 0 implies nchan > 0
    if (spec%n.le.degree) then
       error = .true.
       write(mess,*) 'Not enough channels to fit baseline: ',spec%n,degree
       call cubemain_message(seve%e,rname,mess)
       return
    endif
    !
    call poly%reallocate(degree,error)
    if (error) return
    ! Normalize range to [-1,1]
    ! *** JP: What happens when npoint = 1 is unclear... *** JP
    poly%xmin = spec%x%val(1)
    poly%xmax = spec%x%val(spec%n)
    poly%xcen = 0.5*(poly%xmax+poly%xmin)
    poly%xsiz = 0.5*(poly%xmax-poly%xmin)
    do ic=1,spec%n
       spec%x%val(ic) = (spec%x%val(ic)-poly%xcen)/poly%xsiz
    enddo ! ic
    !
    call svd%reallocate(spec%n,poly%n,error)
    if (error) return
    call svd%fit(spec,poly%coeff,poly%n,&
         chisq,cubemain_chebyshev_polynomials,&
         error)
    if (error) return
  end subroutine cubemain_chebyshev_fit
  !
  subroutine cubemain_chebyshev_subtract(poly,spec,ifirst,ilast,base,resi,error)
    use cubeadm_spectrum_types
    !---------------------------------------------------------------------
    ! Subtract a Chebyshev approximation of the baseline to the spectrum
    !---------------------------------------------------------------------
    class(chebyshev_t),   intent(in)    :: poly
    type(spectrum_t),     intent(in)    :: spec
    integer(kind=chan_k), intent(in)    :: ifirst
    integer(kind=chan_k), intent(in)    :: ilast
    type(spectrum_t),     intent(inout) :: base
    type(spectrum_t),     intent(inout) :: resi
    logical,              intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    real(kind=coor_k)    :: xic
    real(kind=sign_k) :: yic,ymin,ymax
    character(len=*), parameter :: rname='CHEBYSHEV>SUBTRACT'
    !
    ! Compute baseline value
    ! First at interval edges
    ymin = cubemain_chebyshev_approximation(poly,-1d0)
    ymax = cubemain_chebyshev_approximation(poly,+1d0)
    ! Then everywhere
    if (poly%n.gt.2) then
       ! Degree > 1 => poly%n.gt.2
       ! Compute polynomial inside fitting range and constant or zero outside
       do ic=ifirst,ilast
          xic = (spec%x%val(ic)-poly%xcen) /poly%xsiz
          if (xic.le.-1.0) then
             yic = ymin
          else if (xic.ge.1.0) then
             yic = ymax
          else
             yic = cubemain_chebyshev_approximation(poly,xic)
          endif
          base%y%val(ic) = yic
          resi%y%val(ic) = spec%y%val(ic)-yic
       enddo ! ic
    else
       ! Degree 0 or 1: compute polynomial everywhere (including
       ! extrapolation beyond edges)
       do ic=ifirst,ilast
          xic = (spec%x%val(ic)-poly%xcen) /poly%xsiz
          yic = ymin + (xic+1.0)*(ymax-ymin)/2.0
          base%y%val(ic) = yic
          resi%y%val(ic) = spec%y%val(ic)-yic
       enddo ! ic
    endif
  end subroutine cubemain_chebyshev_subtract
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_chebyshev_list(poly,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(chebyshev_t), intent(in)    :: poly
    logical,            intent(inout) :: error
    !
    integer(kind=degr_k) :: ip
    character(len=*), parameter :: rname='CHEBYSHEV>LIST'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    print *,'Chebyshev Polynomial'
    print *,'   x current value  ',poly%xcur
    print *,'   x range mininum  ',poly%xmin
    print *,'   x range maxinum  ',poly%xmax
    print *,'   x range center   ',poly%xcen
    print *,'   x range size     ',poly%xsiz
    print *,'   Degree           ',poly%n
    print *,'   Coefficients and values'
    do ip=1,poly%n
       print *,'       ',ip,poly%coeff(ip),poly%cheby(ip)
    enddo ! id
  end subroutine cubemain_chebyshev_list
end module cubemain_chebyshev_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_baseline
  use gbl_message
  !
  public :: uv_baseline_comm
  private
  !
contains
  !
  subroutine uv_baseline_comm(line,error)
    use gildas_def
    use uv_filter
    !----------------------------------------------------------
    ! Command line interaction for UV_BASELINE command
    !----------------------------------------------------------
    character(len=*), intent(inout) :: line 
    logical,          intent(inout) :: error
    !
    integer                    :: degree           ! degree of the baseline to subtract
    integer, allocatable       :: channellist(:,:) ! list of ranges of channels to exclude
    integer(kind=size_length)  :: nelem            ! Number of excluded ranges
    character(len=*), parameter :: rname='UV_BASELINE'
    !
    degree = 0
    call sic_i4(line,0,1,degree,.false.,error)
    if (error) return
    if (degree.ne.0 .and. degree.ne.1) then
       call map_message(seve%e,rname,'Only degree 0 or 1 supported')
       error = .true.
       return
    endif
    !
    ! Call UV Filter to do the parsing
    call uv_filter_channel_parsing(rname,line,channellist,nelem,error)
    if (error) return
    !
    ! Now do the work
    call uv_baseline_sub(degree,channellist,nelem,error)
  end subroutine uv_baseline_comm
  !
  subroutine uv_baseline_sub(degree,channellist,nelem,error)
    use gildas_def
    use gkernel_interfaces
    use uv_buffers
    !----------------------------------------------------------
    ! Coordinates baseline fitting and subtraction
    !----------------------------------------------------------
    integer, intent(in)                   :: degree           ! Polynomial degree of baseline
    integer, allocatable,intent(in)       :: channellist(:,:) ! list of ranges of channels to exclude
    integer(kind=size_length),intent(in)  :: nelem            ! Number of excluded ranges
    logical, intent(out)                  :: error            ! Error flag
    !
    integer(kind=size_length)              :: nvisi         ! Number of visibilities
    integer(kind=index_length)             :: ivisi         ! visibility index
    integer(kind=index_length)             :: iranges       ! spectral ranges index
    integer(kind=index_length)             :: ichan         ! channel index
    integer(kind=index_length)             :: ivalid        ! valid channel index
    integer(kind=index_length),allocatable :: rindexes(:)   ! indexes for valid real channels
    integer(kind=index_length),allocatable :: iindexes(:)   ! indexes for valid imaginary channels
    integer(kind=index_length),allocatable :: cnumbers(:)   ! valid channels
    real,allocatable                       :: rdata(:)      ! valid real channels
    real,allocatable                       :: idata(:)      ! valid imaginary channels
    integer(kind=4),allocatable            :: notflagged(:)
    integer(kind=size_length)              :: nchan         ! number of channels
    integer                                :: ier
    integer                                :: nvalid        ! NUmber of valid channels
    integer                                :: fchan, lchan  ! First and last channels in a range of channels
    character(len=50)                      :: warning       ! Warning message
    integer(kind=index_length)             :: cols(3)       ! Columns for a specific channel
    integer(kind=1), parameter             :: bit=1         ! 1 in i1
    real                                   :: areal,breal   ! Fit parameters for real part
    real                                   :: aimag,bimag   ! Fit parameters for imaginary part
    character(len=*), parameter :: rname='UV_BASELINE'
    !
    nchan = huv%gil%nchan
    nvisi = huv%gil%nvisi
    allocate(notflagged(nchan),stat=ier)
    if (failed_allocate(rname,'Flagged list',ier,error))  return
    notflagged(:) = 1
    !
    ! Getting the flagged ranges
    do iranges=1, nelem
       fchan = channellist(1,iranges)
       lchan = channellist(2,iranges)
       if (lchan.lt.1.or.fchan.gt.huv%gil%nchan) then
          write(warning,1000) iranges,"-th spectral range is outside UV table"
          call map_message(seve%w,rname, trim(warning))
       else
          if (lchan.gt.nchan) lchan = nchan
          if (fchan.lt.1)     fchan = 1
          notflagged(fchan:lchan) = 0
       endif
    enddo
    nvalid = sum(notflagged)
    allocate(rindexes(nvalid),iindexes(nvalid),rdata(nvalid),idata(nvalid),cnumbers(nvalid),stat=ier)
    if (failed_allocate(rname,'Real and imaginary arrays',ier,error))  return
    ivalid=1
    do ichan=1,nchan
       if (notflagged(ichan).eq.bit) then
          call uv_spectral_getcols(ichan,cols)
          rindexes(ivalid) = cols(1)
          iindexes(ivalid) = cols(2)
          cnumbers(ivalid) = ichan
          ivalid = ivalid+1
       endif
    end do
    deallocate(notflagged)
    do ivisi=1, nvisi
       do ivalid=1,nvalid
          rdata(ivalid) = duv(rindexes(ivalid),ivisi)
          idata(ivalid) = duv(iindexes(ivalid),ivisi)
       enddo
       call uv_baseline_baseline(cnumbers,rdata,nvalid,degree,areal,breal,error)
       call uv_baseline_baseline(cnumbers,idata,nvalid,degree,aimag,bimag,error)
       do ichan=1,nchan
          call uv_spectral_getcols(ichan,cols)
          duv(cols(1),ivisi) =  duv(cols(1),ivisi)-(areal*ichan+breal)
          duv(cols(2),ivisi) =  duv(cols(2),ivisi)-(aimag*ichan+bimag)
       enddo
    enddo
1000 format(i4,a38) 
  end subroutine uv_baseline_sub
  !
  subroutine uv_baseline_baseline(xdata,ydata,npoints,degree,acoeff,bcoeff,error)
    use gkernel_interfaces
    use gildas_def
    !----------------------------------------------------------
    ! Computes baseline from input arrays
    !----------------------------------------------------------
    integer(kind=index_length), allocatable, intent(in)  :: xdata(:)
    real,                       allocatable, intent(in)  :: ydata(:)
    integer,                                 intent(in)  :: npoints
    integer,                                 intent(in)  :: degree
    real,                                    intent(out) :: acoeff
    real,                                    intent(out) :: bcoeff
    logical,                                 intent(out) :: error
    !
    real              :: sumx  ! Sum of xdata
    real              :: sumy  ! Sum of y data
    real              :: sumxy ! Sum of x*y
    real              :: sumxx ! Sum of x^2
    real              :: delta ! midway coefficient
    real, allocatable :: warr(:) ! allocatable workhorse array
    integer           :: ier   ! error flag
    character(len=*), parameter :: rname='UV_BASELINE'
    !
    if (degree.eq.0) then
       acoeff = 0.0
       bcoeff = sum(ydata)/npoints
    else if (degree.eq.1)then
       allocate(warr(npoints),stat=ier)
       if (failed_allocate(rname,'Work array',ier,error))  return
       sumx = sum(xdata)
       sumy = sum(ydata)
       warr = xdata**2
       sumxx = sum(warr)
       warr = xdata*ydata
       sumxy = sum(warr)
       delta = (npoints*sumxx-sumx**2)
       bcoeff = (sumxx*sumy-sumx*sumxy)/delta
       acoeff = (npoints*sumxy-sumx*sumy)/delta
       deallocate(warr)
    endif
  end subroutine uv_baseline_baseline
end module uv_baseline
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
!  Id: modulePakoTypes.f90,v 1.1.2 2010-02-25 Hans Ungerechts
!     
!----------------------------------------------------------------------
!     PAKO 
!
! <DOCUMENTATION name="moduleTypes">
!
! </DOCUMENTATION> <!-- name="moduleTypes" -->
!
Module modulePakoTypes
  !
  Implicit None
  Save
  Private
  !
  Public :: xyPointType, varOffsets, xyVelocityType, conditionMinMax
  !
  Include 'inc/parameters/sizes.inc'
  !
  ! ***   type for xy offset points
  Type    :: xyPointType
     Real              :: x = 0.0
     Real              :: y = 0.0
  End Type xyPointType
  !
  Type :: varOffsets
     !
     Logical                :: isSet        = .False.      ! flag if this offset is set
     Character(len=lenCh)   :: systemName   = "none"       ! system 
     Type(xyPointType)      :: point                       !
     Integer                :: channel      =  0           ! of multibeam
     Real                   :: elevation    = 0.0          ! for NASMYTH
     !
  End Type varOffsets
  !
  ! ***   type for xy offset velocity and speed
  Type    :: xyVelocityType
     Real              :: x     = 0.0
     Real              :: y     = 0.0
     Real              :: speed = 0.0
  End Type xyVelocityType
  !
  !  ***  type for "conditions" (pre-conditions for execution)
  !
  Type     ::  conditionMinMax
     Character(len=lenCh)    ::   parameter  =  " "      !  name of parameter
     Real(kind=4)            ::   minimum    =  0.0
     Real(kind=4)            ::   maximum    =  0.0
     Character(len=lenCh)    ::   unit       =  "--"     !  unit for XML
     Logical                 ::   isSet      = .False.   !  flag if this condition is set (required)
  End Type conditionMinMax
!
!!!
End Module modulePakoTypes

subroutine flag_ti(n,timin,timax)
  integer :: n                      !
  real :: timin                     !
  real :: timax                     !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    if (tiem(i).ge.timin .and. tiem(i).le.timax) then
      badti(i) = .true.
    endif
  enddo
end
!<FF>
subroutine get_ti(n,timin,timax)
  integer :: n                      !
  real :: timin                     !
  real :: timax                     !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    if (tiem(i).ge.timin .and. tiem(i).le.timax) then
      badti(i) = .false.
    endif
  enddo
end
!<FF>
subroutine get_all(n)
  integer :: n                      !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    badus(i) = .false.
  enddo
end
!<FF>
subroutine flag_el(n,elmin,elmax)
  integer :: n                      !
  real :: elmin                     !
  real :: elmax                     !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    if (eles(i).ge.elmin .and. eles(i).le.elmax) then
      badel(i) = .false.
    else
      badel(i) = .true.
    endif
  enddo
end
!<FF>
subroutine flag_rm (n,rmsmax)
  integer :: n                      !
  real :: rmsmax                    !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    if (rms(i).ge.rmsmax) then
      badrm(i) = .true.
    else
      badrm(i) = .false.
    endif
  enddo
end
!<FF>
subroutine flag_re (n,res)
  integer :: n                      !
  real :: res                       !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  real :: r2
  !
  r2 = res**2
  do i=1,n
    if (resaz(i)**2+resel(i)**2 .gt. r2) then
      badre(i) = .true.
      badre(i+n) = .true.
    else
      badre(i) = .false.
      badre(i+n) = .false.
    endif
  enddo
end
!<FF>
subroutine flag_source (n,object)
  integer :: n                      !
  character(len=*) :: object        !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    if (source(i).eq.object) then
      badus(i) = .true.
    endif
  enddo
end
!<FF>
subroutine flag_scan (n,jscan)
  integer :: n                      !
  integer :: jscan                  !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    if (scan(i).eq.jscan) then
      badus(i) = .true.
    endif
  enddo
end
!<FF>
subroutine get_source (n,object)
  integer :: n                      !
  character(len=*) :: object        !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    if (source(i).eq.object) then
      badus(i) = .false.
    endif
  enddo
end
!<FF>
subroutine get_scan (n,jscan)
  integer :: n                      !
  integer :: jscan                  !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  do i=1,n
    if (scan(i).eq.jscan) then
      badus(i) = .false.
    endif
  enddo
end
!<FF>
subroutine get_good (n,ngood)
  integer :: n                      !
  integer :: ngood                  !
  ! Global
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: i
  !
  ngood = 0
  do i=1,n
    if (badus(i).or.badel(i).or.badrm(i).or.badre(i)   &
     &      .or.badti(i) ) then
      good(i) = .false.
    else
      good(i) = .true.
      ngood = ngood+1
    endif
  enddo
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetopology_spasamp_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_unit_arg
  use cubetools_unit
  use cubetopology_messaging
  !
  public :: spasamp_opt_t,spasamp_user_t,spasamp_prog_t
  private
  !
  type spasamp_opt_t
     type(option_t),   pointer :: opt
     type(unit_arg_t), pointer :: unit
   contains
     procedure :: register  => cubetopology_spasamp_register
     procedure :: parse     => cubetopology_spasamp_parse
  end type spasamp_opt_t
  !
  type spasamp_user_t
     logical               :: do = .false.
     character(len=argu_l) :: x = strg_star
     character(len=argu_l) :: y = strg_star
     character(len=argu_l) :: unit = strg_star
   contains
     procedure :: init   => cubetopology_spasamp_user_init
     procedure :: toprog => cubetopology_spasamp_user_toprog 
     procedure :: list   => cubetopology_spasamp_user_list
  end type spasamp_user_t
  !
  type spasamp_prog_t
     real(kind=coor_k) :: x = 0d0
     real(kind=coor_k) :: y = 0d0
     integer(kind=code_k) :: unit = code_unit_unk
  end type spasamp_prog_t
  !
contains
  !
  subroutine cubetopology_spasamp_register(samp,name,abstract,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spasamp_opt_t), intent(out)   :: samp
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: abstract
    logical,              intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(unit_arg_t) :: unitarg
    character(len=*), parameter :: rname='SAMPLING>REGISTER'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'xsampling [ysampling [unit]]',&
         abstract,&
         strg_emp,&
         samp%opt,&
         error)
    if (error) return
    call stdarg%register(&
         'xsampling','Sampling along the X coordinate',&
         'Depending on the unit, sampling step or number of samples across&
         & the active range along the X axis. "*" uses the default&
         & sampling along this axis.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'ysampling','Sampling along the Y coordinate',&
         'Depending on the unit, sampling step or number of samples across&
         & the active range along the Y axis. If omitted or "*", use the&
         & default sampling along this axis.',&
         & code_arg_optional,&
         error)
    if (error) return
    call unitarg%register(&
         'unit',&
         'Sampling unit',&
         '"*" or "=" uses current FOV unit. "BOX" changes the&
         & interpretation of xsampling and ysampling to the number&
         & of samples along the active range of the axis. The default&
         & is to sample every beam width for FOV unit and to get 10 boxes&
         & along the axis when the BOX token is used.',&
         code_arg_optional,&
         code_unit_fov,&
         samp%unit,&
         error)
    if (error) return
  end subroutine cubetopology_spasamp_register
  !
  subroutine cubetopology_spasamp_parse(samp,line,user,error)
    !----------------------------------------------------------------------
    ! /SAMPLING x y [unit]
    !----------------------------------------------------------------------
    class(spasamp_opt_t), intent(in)    :: samp  
    character(len=*),     intent(in)    :: line
    type(spasamp_user_t), intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPASAMP>PARSE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    user%x = strg_star
    user%y = strg_star
    user%unit = strg_star
    !
    call samp%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,samp%opt,1,user%x,mandatory,error)
       if (error) return
       call cubetools_getarg(line,samp%opt,2,user%y,.not.mandatory,error)
       if (error) return
       call cubetools_getarg(line,samp%opt,3,user%unit,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubetopology_spasamp_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetopology_spasamp_user_init(sampling,error)
    !----------------------------------------------------------------------
    ! Initialize by setting the intent of sampling to out
    !----------------------------------------------------------------------
    class(spasamp_user_t), intent(out)   :: sampling 
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPASAMP>USER>INIT'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
  end subroutine cubetopology_spasamp_user_init
  !
  subroutine cubetopology_spasamp_user_toprog(user,cube,prog,error)
    use cubetools_user2prog
    use cubetools_header_methods
    use cube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spasamp_user_t), intent(in)    :: user
    type(cube_t),          intent(in)    :: cube
    type(spasamp_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    type(unit_user_t) :: unit
    real(kind=beam_k) :: radius
    real(kind=coor_k) :: default
    character(len=*), parameter :: rname='SPASAMP>USER>TOPROG'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    ! *** JP Some disambiguization would be needed here
    call sic_upper(user%unit)
    if (user%unit.eq.'BOX') then
       prog%unit = code_unit_pixe
       call unit%get_from_code(code_unit_pixe,error)
       if (error) return
       default = 10 ! boxes
       prog%x = 10
       prog%y = 10
    else
       prog%unit = code_unit_fov
       call unit%get_from_name_for_code(user%unit,code_unit_fov,error)
       if (error) return
       call cubetools_header_beamradius(cube%head,radius,error)
       if (error) return
       default = radius
       prog%x = radius
       prog%y = radius
    endif
    call cubetools_user2prog_resolve_star(user%x,unit,default,prog%x,error)
    if (error) return
    call cubetools_user2prog_resolve_star(user%y,unit,default,prog%y,error)
    if (error) return
  end subroutine cubetopology_spasamp_user_toprog
  !
  subroutine cubetopology_spasamp_user_list(samp,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spasamp_user_t), intent(in)    :: samp 
    logical,               intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPASAMP>USER>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    write(mess,'(6a)') &
         'Sampling  : (',trim(samp%x),',',trim(samp%y),') ',samp%unit
    call cubetopology_message(seve%r,rname,mess)
  end subroutine cubetopology_spasamp_user_list
end module cubetopology_spasamp_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE COVSUM(MFIT,MA,ALPHA,BETA,B,LISTA,DY,
     +     CHISQ,SIG2I,QUIET,ERROR)
      INTEGER MFIT,MA
      INTEGER LISTA(MFIT)
      REAL ALPHA(MA,MA),BETA(MA),B(MA),CHISQ,SIG2I,DY
      LOGICAL QUIET,ERROR
*
      INTEGER J,K
      REAL WT
*
      DO J=1,MFIT
         
         WT=B(LISTA(J))*SIG2I
         DO K=1,J
            ALPHA(J,K)=ALPHA(J,K)+WT*B(LISTA(K))
         ENDDO
         BETA(J)=BETA(J)+DY*WT
      ENDDO
      CHISQ=CHISQ+DY*DY*SIG2I
      IF (CHISQ.NE.CHISQ) THEN
         IF (.NOT.QUIET) THEN
            WRITE(6,*) 'NaN in COVSUM',DY,(B(LISTA(J)),J=1,MFIT)
         ENDIF
         ERROR = .TRUE.
         RETURN
      ENDIF
      RETURN
      END

module gio_interfaces_private
  interface
    subroutine gio_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gio_message
  end interface
  !
  interface
    subroutine gio_hd32_to_gildas_v2(hd32,v2)
      use gio_headers
      use gio_uv
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GIO/GDF
      !     Transfer a 32-bit "old" Data File Header to
      !     the "new" type(gildas)
      !---------------------------------------------------------------------
      type(gildas_header_v1), intent(in) :: hd32
      type(gildas), intent(inout) :: v2   ! Must be (inout) as initiliazed before
    end subroutine gio_hd32_to_gildas_v2
  end interface
  !
  interface
    subroutine gio_gildas_v2_to_hd32(v2,hd32)
      use gio_headers
      use image_def
      !---------------------------------------------------------------------
      ! @ private
      !     Transfer the "old" type(gildas)
      !     to a new 64-bit Data File Header
      !---------------------------------------------------------------------
      type(gildas_header_v1), intent(inout) :: hd32
      type(gildas), intent(inout) :: v2
    end subroutine gio_gildas_v2_to_hd32
  end interface
  !
  interface
    subroutine gio_hd64_to_gildas_v2 (hd64,v2,error)
      use gio_uv
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GIO/GDF
      !     Transfer a new 64-bit Data File Header to
      !     the "new" type(gildas)
      !---------------------------------------------------------------------
      type (gildas_header_v2), intent(in) :: hd64
      type (gildas), intent(inout) :: v2   ! Must be (inout) because initialized before
      logical, intent(out) :: error
    end subroutine gio_hd64_to_gildas_v2
  end interface
  !
  interface
    subroutine gio_gildas_v2_to_hd64 (v2,hd64,error)
      use image_def
      use gio_params
      use gio_headers
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !     Transfer the "new" type(gildas)
      !     to a new 64-bit Data File Header
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: v2
      type (gildas_header_v2), intent(out) :: hd64
      logical, intent(out) :: error
    end subroutine gio_gildas_v2_to_hd64
  end interface
  !
  interface
    subroutine gio_setuv (hd64,error)
      use image_def
      use gbl_message
      !
      ! @ private-mandatory (because symbol is used elsewhere)
      ! Define the UV section consistently.
      ! It could also define the column_types and column_codes if needed
      !
      type(gildas_header_v2), intent(inout) :: hd64
      logical, intent(out) :: error
    end subroutine gio_setuv
  end interface
  !
  interface
    subroutine gio_setuv_freq(hd64,error)
      use image_def
      use gbl_message
      !
      ! @ private-mandatory (because symbol is used elsewhere)
      ! Define the UV section consistently.
      ! It could also define the column_types and column_codes if needed
      !
      type(gildas_header_v2), intent(inout) :: hd64
      logical, intent(out) :: error
    end subroutine gio_setuv_freq
  end interface
  !
  interface
    subroutine gio_hd32_to_gildas_v1(hd32,v1)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer, intent(in) :: hd32
      integer, intent(in) :: v1
    end subroutine gio_hd32_to_gildas_v1
  end interface
  !
  interface
    subroutine gio_gildas_v1_to_hd32(v1,hd32)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer, intent(in) :: hd32
      integer, intent(in) :: v1
    end subroutine gio_gildas_v1_to_hd32
  end interface
  !
  interface
    subroutine gio_gildas_v1_to_hd64(v1,hd64)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer, intent(in) :: hd64
      integer, intent(in) :: v1
    end subroutine gio_gildas_v1_to_hd64
  end interface
  !
  interface
    subroutine gio_hd64_to_gildas_v1(v1,hd64)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer, intent(in) :: hd64
      integer, intent(in) :: v1
    end subroutine gio_hd64_to_gildas_v1
  end interface
  !
  interface
    function gio_riox (lun,ibl,buf,size)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !       Read one direct acess block
      !       The file must have been opened with the appropriate block size
      !---------------------------------------------------------------------
      integer(kind=4) :: gio_riox  !
      integer(kind=4),             intent(in)  :: lun        ! Logical unit number
      integer(kind=record_length), intent(in)  :: ibl        ! Block number
      integer(kind=4),             intent(in)  :: size       ! Block size
      integer(kind=4),             intent(out) :: buf(size)  ! Buffer to be read
    end function gio_riox
  end interface
  !
  interface
    function gio_wiox (lun,ibl,buf,size)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !       Write one direct acess block
      !       The file must have been opened with the appropriate block size
      !---------------------------------------------------------------------
      integer(kind=4) :: gio_wiox  !
      integer(kind=4),             intent(in) :: lun        ! Logical unit number
      integer(kind=record_length), intent(in) :: ibl        ! Block number
      integer(kind=4),             intent(in) :: size       ! Block size
      integer(kind=4),             intent(in) :: buf(size)  ! Buffer to be read
    end function gio_wiox
  end interface
  !
  interface
    subroutine gio_form (inform,ouform)
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      !       Determine machine dependent data format from image
      !       data format
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: inform                 ! Input Format
      integer(kind=4), intent(out) :: ouform                ! Output Format
    end subroutine gio_form
  end interface
  !
  interface
    function gio_block (form,size)
      use gildas_def
      use gio_params
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      !       Compute number of blocks from image size
      !---------------------------------------------------------------------
      integer(kind=record_length) :: gio_block  !
      integer(kind=4),           intent(in) :: form  ! Input format
      integer(kind=size_length), intent(in) :: size  ! Array  size
    end function gio_block
  end interface
  !
  interface
    subroutine gdf_style (is,gtype)
      use gio_image
      !---------------------------------------------------------------------
      ! @ private
      !       Returns image type
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: is             ! Image Slot
      character(len=*), intent(out) :: gtype        ! Image type
    end subroutine gdf_style
  end interface
  !
  interface
    subroutine gio_idim (is,size)
      use gio_params
      use gio_image
      !---------------------------------------------------------------------
      ! @ private
      !  Define image dimensions and compute image size
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)  :: is    ! Image Slot
      integer(kind=size_length), intent(out) :: size  ! Array  size
    end subroutine gio_idim
  end interface
  !
  interface
    subroutine convgcod (sycode,imcode,conver,mess,isev)
      use gio_convert
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !       SYCODE system code
      !       '-'    IEEE
      !       '.'    EEEI (IBM like)
      !       '_'    VAX
      !       IMCODE file code
      !       '<'    IEEE  64 bits    (Little Endian, 99.9 % of recent computers)
      !       '>'    EEEI  64 bits    (Big Endian, HPUX, IBM-RISC, and SPARC ...)
      !---------------------------------------------------------------------
      character(len=1), intent(in) :: sycode        !  System code
      character(len=1), intent(inout) :: imcode     !  File code
      integer, intent(out)  :: conver               !  Conversion code number
      character(len=*), intent(out) :: mess         !  Message trailer
      integer, intent(out)  :: isev                 !  Severity of message (D or I)
    end subroutine convgcod
  end interface
  !
  interface
    function gio_rih (is,gtype,form,lndb)
      use gildas_def
      use gio_image
      use gio_convert
      use gio_headers
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GDF / GIO  Internal routine
      !       Read full header from internal buffer, with format conversion
      !     GIO_RIH / GIO_WIH / GIO_EIH are the only routine addressing
      !             the data format of the header
      !---------------------------------------------------------------------
      integer(kind=4) :: gio_rih  !
      integer(kind=4),             intent(in)  :: is     ! Image Slot
      character(len=*),            intent(out) :: gtype  ! Image type
      integer(kind=4),             intent(out) :: form   ! Data format
      integer(kind=record_length), intent(out) :: lndb   ! Number of 512 byte blocks
    end function gio_rih
  end interface
  !
  interface
    function gio_wih (is,gtype,form,lndb)
      use gildas_def
      use gbl_message
      use gio_image
      use gio_convert
      use gio_headers
      !---------------------------------------------------------------------
      ! @ private
      ! GDF / GIO  Internal routine
      !       Write full header to internal buffer, with format conversion
      !     GIO_RIH / GIO_WIH / GIO_EIH are the only routine addressing
      !             the data format of the header
      !---------------------------------------------------------------------
      integer(kind=4) :: gio_wih  !
      integer(kind=4),             intent(in) :: is     ! Image Slot
      character(len=*),            intent(in) :: gtype  ! Image type
      integer(kind=4),             intent(in) :: form   ! Data format
      integer(kind=record_length), intent(in) :: lndb   ! Number of 512 byte blocks
    end function gio_wih
  end interface
  !
  interface
    function gio_eih (is,gtype,form,lndb)
      use gildas_def
      use gbl_message
      use gio_image
      use gio_convert
      !---------------------------------------------------------------------
      ! @ private
      !  GDF        API routine
      !             Read partial header to prepare an update
      !             Return the Type, the data format and the number of blocks
      !     GIO_RIH / GIO_WIH / GIO_EIH are the only routine addressing
      !             the data format of the header
      !---------------------------------------------------------------------
      integer(kind=4) :: gio_eih
      integer(kind=4),             intent(in)    :: is     ! Image Slot
      character(len=*),            intent(inout) :: gtype  ! Image type
      integer(kind=4),             intent(inout) :: form   ! Data format
      integer(kind=record_length), intent(inout) :: lndb   ! Number of 512 byte blocks
    end function gio_eih
  end interface
  !
  interface
    subroutine gio_buffer_to_hd64 (len,inbuf,outhd64,r8,r4,i4,i8,error)
      use gbl_message
      use gio_headers
      use gio_uv
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4),        intent(in)    :: len       ! Length of buffer
      integer(kind=4),        intent(in)    :: inbuf(*)  ! Input values in file format
      type(gildas_header_v2), intent(out)   :: outhd64   ! Converted values in machine format
      external                              :: r8        ! Real*8 conversion routine
      external                              :: r4        ! Real*4 conversion routine
      external                              :: i4        ! Integer*4 conversion routine
      external                              :: i8        ! Integer*8 conversion routine
      logical,                intent(inout) :: error     !
    end subroutine gio_buffer_to_hd64
  end interface
  !
  interface
    subroutine gio_hd64_to_buffer (len,inhd64,outbuf,r8,r4,i4,i8)
      use gio_headers
      use gio_uv
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4), intent(inout)  :: len    ! Length of buffer
      integer(kind=4), intent(out) :: outbuf(*) ! Input values in file format
      type (gildas_header_v2), intent(inout) :: inhd64  ! Converted values in machine format
      external :: r8                    ! Real*8 conversion routine
      external :: r4                    ! Real*4 conversion routine
      external :: i4                    ! Integer*4 conversion routine
      external :: i8                    ! Integer*8 conversion routine
    end subroutine gio_hd64_to_buffer
  end interface
  !
  interface
    function gio_gdfbuf(rname,iblock)
      use gio_image
      use gbl_message
      ! @ private
      !
      integer :: gio_gdfbuf
      character(len=*), intent(in) :: rname
      integer, intent(in) :: iblock
    end function gio_gdfbuf
  end interface
  !
  interface
    subroutine gio_syscod (sycode)
      !---------------------------------------------------------------------
      ! @ private
      !   Return the GILDAS "System" code, '-', '_', or '.'
      !---------------------------------------------------------------------
      character(len=1), intent(out) :: sycode   ! Returned code
    end subroutine gio_syscod
  end interface
  !
  interface
    subroutine gio_cdim (is,ndims,dims)
      use gio_image
      !---------------------------------------------------------------------
      ! @ private
      ! GDF
      !       Change DIM of an Image Slot
      !       Change the dimensions of a pre-defined image slot
      !       This can be useful to reshape an image slot, and
      !               allow reading by blocks regardless of the actual
      !       underlying data structure. Typical applications include
      !       computing extrema, transposition, FITS interface...
      !
      !             It is used by GDF_READ_DATA and GDF_WRITE_DATA which can
      !         thus specify whatever shape they want for their data.
      !---------------------------------------------------------------------
      integer, intent(in) :: is                         ! Image Slot
      integer(4), intent(in) :: ndims                   ! Number of dimensions
      integer(kind=size_length), intent(in) :: dims(:)  ! Dimensions
    end subroutine gio_cdim
  end interface
  !
  interface
    subroutine gio_dams (ms,is,blc,trc,array,form,error)
      use gildas_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GDF
      !       Data Associated Memory Slot
      !       Associate pre-defined array ARRAY to (sub)-set BLC,TRC of
      !       image IS, at slot MS.
      !---------------------------------------------------------------------
      integer(kind=4),            intent(out) :: ms        ! Memory slot
      integer(kind=4),            intent(in)  :: is        ! Image slot
      integer(kind=index_length), intent(in)  :: blc(:)    ! Bottom left corner
      integer(kind=index_length), intent(in)  :: trc(:)    ! Top right corner
      real(kind=4),               intent(in)  :: array(*)  ! Data array
      integer(kind=4),            intent(in)  :: form      ! Image format
      logical,                    intent(out) :: error     ! Flag
    end subroutine gio_dams
  end interface
  !
  interface
    subroutine gio_rems (ms,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GDF   REad Memory Slot
      !---------------------------------------------------------------------
      integer, intent(in)  :: ms         ! Memory slot
      logical, intent(out) :: error      ! Flag
    end subroutine gio_rems
  end interface
  !
  interface
    subroutine gio_rmslot (ms,lun,error)
      use gildas_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! Read Memory SLOT
      !       Direct access solution
      !---------------------------------------------------------------------
      integer, intent(in)  :: ms         ! Memory slot
      integer, intent(in)  :: lun        ! Logical Unit Number
      logical, intent(out) :: error      ! Flag
    end subroutine gio_rmslot
  end interface
  !
  interface
    subroutine gio_pums (ms,is,blc,trc,addr,form,error)
      use gildas_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GDF
      !       Put Memory Slot
      !       Associate pre-defined area ADDR to (sub)-set BLC,TRC of
      !       image IS, at slot MS.
      !---------------------------------------------------------------------
      integer, intent(out) :: ms         ! Memory slot
      integer, intent(in)  :: is         ! Image slot
      integer(kind=index_length), intent(in)  :: blc(:) ! Bottom left corner
      integer(kind=index_length), intent(in)  :: trc(:) ! Top right corner
      integer(kind=address_length), intent(in) :: addr  ! Input address
      integer, intent(in)  :: form       ! Image format
      logical, intent(out) :: error      ! Flag
    end subroutine gio_pums
  end interface
  !
  interface
    subroutine gio_lnslot (ms,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GDF   Get a free memory slot
      !---------------------------------------------------------------------
      integer, intent(out) :: ms                     ! Memory slot number
      logical, intent(out) :: error                  !
    end subroutine gio_lnslot
  end interface
  !
  interface
    subroutine gdf_deis (is,error)
      use gio_image
      !---------------------------------------------------------------------
      ! @ private
      ! GDF DElete Image Slot
      !             whatever the consequences...
      !             Close the unit, and free it
      !
      ! In case of success, error flag (T/F) is preserved on return. Code is
      ! insensitive to error=T on input.
      !---------------------------------------------------------------------
      integer, intent(in)    :: is     ! Image slot
      logical, intent(inout) :: error  ! Error flag
    end subroutine gdf_deis
  end interface
  !
  interface
    subroutine gio_gemsco (ms, is, blc, trc, addr, form, error)
      use gildas_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GDF
      !     GEt Memory Slot COntiguous
      !     Restricted version for contiguous subsets
      !---------------------------------------------------------------------
      integer, intent(out) :: ms                         ! Memory slot
      integer, intent(in)  :: is                         ! Image slot
      integer(kind=index_length), intent(in)  :: blc(gdf_maxdims)    ! Bottom left corner
      integer(kind=index_length), intent(in)  :: trc(gdf_maxdims)    ! Top right corner
      integer(kind=address_length), intent(out) :: addr  ! Returned address
      integer, intent(in)  :: form                       ! Image format
      logical, intent(out) :: error                      ! Flag
    end subroutine gio_gemsco
  end interface
  !
  interface
    subroutine gdf_sub4 (blc, n1,n2,n3,n4,in, m1,m2,m3,m4,out)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=index_length) :: blc(4)                 !
      integer(kind=index_length) :: n1                     !
      integer(kind=index_length) :: n2                     !
      integer(kind=index_length) :: n3                     !
      integer(kind=index_length) :: n4                     !
      integer(4) :: in(n1,n2,n3,n4)     !
      integer(kind=index_length) :: m1                     !
      integer(kind=index_length) :: m2                     !
      integer(kind=index_length) :: m3                     !
      integer(kind=index_length) :: m4                     !
      integer(4) :: out(m1,m2,m3,m4)    !
    end subroutine gdf_sub4
  end interface
  !
  interface
    subroutine gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
      use gio_image
      !---------------------------------------------------------------------
      ! @ private
      ! GDF / GIO
      !     Determine if a slot is contiguous in memory
      !---------------------------------------------------------------------
      integer, intent(in)  :: is                         ! Image slot
      integer, intent(out) :: ndim                       ! Number of dimensions
      integer(kind=index_length), intent(in)  :: blc(:)  ! Bottom left corner
      integer(kind=index_length), intent(in)  :: trc(:)  ! Top right corner
      integer(kind=index_length), intent(out) :: iblc(:) ! Bottom left corner
      integer(kind=index_length), intent(out) :: itrc(:) ! Top right corner
      integer(kind=size_length), intent(out) :: isize    ! Size of memory region
      logical, intent(out) :: icont                      ! Contiguous flag
    end subroutine gio_cont
  end interface
  !
  interface
    subroutine gio_gmslot (offs, size, form, ms, big, stablo, error)
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private 
      ! GDF   Get a free memory slot.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: offs          ! Offset from start of image, in "pixel"
      integer(kind=size_length), intent(inout)  :: size       ! Required size (in pixels), and allocated size (in WOrds)
      integer, intent(in)  :: form          ! Type of image
      integer, intent(out) :: ms            ! Memory slot number
      integer, intent(in)  :: big           ! Are big blocks being used ?
      integer, intent(in)  :: stablo        ! Number of Starting Blocks
      logical, intent(out) :: error         ! Logical error flag
    end subroutine gio_gmslot
  end interface
  !
  interface
    subroutine gio_mmslot (offs,leng,form,ms,addr,error)
      use gildas_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GDF / GIO
      !             Map Memory SLOT
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: offs     ! Offset from start of image, in "pixel"
      integer(kind=size_length), intent(in)  :: leng     ! Required size (in Words)
      integer, intent(in)  :: form                       ! Type of image
      integer, intent(in)  :: ms                         ! Memory slot number
      integer(kind=address_length), intent(out) :: addr  ! Returned address
      logical, intent(out) :: error                      ! Logical error flag
    end subroutine gio_mmslot
  end interface
  !
  interface
    subroutine gio_wmslot (ms,lun,error)
      use gildas_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! Write Memory SLOT.
      ! Direct access solution, contiguous data only.
      !
      ! In case of success, error flag (T/F) is preserved on return. Code is
      ! insensitive to error=T on input.
      !---------------------------------------------------------------------
      integer, intent(in)    :: ms     ! Memory slot number
      integer, intent(in)    :: lun    ! Logical Unit Number
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine gio_wmslot
  end interface
  !
  interface
    subroutine gio_buffs_vm(big,ioffs,size,ikbfi,ikbla,sizbuf,stablo)
      use gildas_def
      use gio_image
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: big ! Blocking factor
      integer(kind=size_length),   intent(inout) :: ioffs   ! Memory offset
      integer(kind=size_length),   intent(inout) :: size    ! Effective size in words
      integer(kind=record_length), intent(out)   :: ikbfi   ! First block
      integer(kind=record_length), intent(out)   :: ikbla   ! Last block
      integer(kind=4),             intent(out)   :: sizbuf  ! Buffer Size in words (output)
      integer(kind=4),             intent(in)    :: stablo  ! Number of Starting Blocks
    end subroutine gio_buffs_vm
  end interface
  !
  interface
    subroutine gio_umps (ms,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GDF   UPdate Memory Slot
      !             Write it to file if needed
      !
      ! THIS ROUTINE IS NOW OBSOLETE (Apr 2014)
      ! and the code code_gdf_dumpi  also
      !---------------------------------------------------------------------
      integer, intent(in)  :: ms                     ! Memory slot
      logical, intent(out) :: error                  ! Error flag
    end subroutine gio_umps
  end interface
  !
  interface
    subroutine gio_zams (ms,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GDF   ZAp Memory Slot
      !                     Just delete it, don't do anything else
      !---------------------------------------------------------------------
      integer, intent(in)  :: ms                     ! Memory slot
      logical, intent(out) :: error                  ! Error flag
    end subroutine gio_zams
  end interface
  !
  interface
    subroutine gildas_fatale(name)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: name
    end subroutine gildas_fatale
  end interface
  !
  interface
    subroutine gio_whsec32(ibuf32,type,array,size,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GDF   Stand-Alone routine
      !       Write a descriptor in Header of file, in "old" 32 bit
      !           format.
      !----------------------------------------------------------------------
      !
      !       Greg Data Frame structure
      !       Fixed length 512-bytes Records
      !
      ! First Record  : Header
      ! Others        : Data
      ! After data (if needed) : Comments
      !
      ! Basic Header for data checks
      !       'GILDAS_IMAGE  '                        ! C*12
      !       Type (Real, Real*8, Integer)
      !       Data Length (Blocks)                    !
      !       Additional Information (blocks)         !
      !                                               ! 10  Words reserved
      !
      ! KEY = GENERAL                 (1)
      !       LENGTH
      !       NDIM (<4)               1       2
      !       DIM(4)                  4       6
      !       XREF,XVAL,XINC (4 fois) 3*8     30
      !       Length = 30     Words                   ! 40
      !
      ! KEY = TABLE                   (8)
      !       LENGTH
      !       NDIM                    1       2
      !       DIM(4)                  1       6
      !       Length = 6      Words
      !
      ! KEY = BLANKING                (2)
      !       LENGTH
      !       BVAL,EVAL               2       3
      !       Length = 3      Words                   ! 43
      !
      ! KEY = EXTREMA                 (3)
      !       LENGTH
      !       RMIN,RMAX, MIN1,MAX1, MIN2,MAX2, MIN3,MAX3, MIN4,MAX4
      !       Length = 11     Words                   ! 54
      !
      ! KEY = DESCRIPTION             (4)
      !       LENGTH
      !       UNIT C*12       Map unit  3     4
      !       CODE C*12(4)    Axis type 4*3   16
      !       SYST C*12       Coord. Sy.3     19
      !       Length = 16     Words                   ! 73
      !
      ! KEY = POSITION                (5)
      !       LENGTH
      !       RSOURC C*12             3       4       ! Source name
      !       REPOCH R*4              1       5       ! Epoch of observation
      !       RRA,   R*8              2       7       ! R.A. of center position
      !       RDEC,  R*8              2       9       ! Declination ----
      !       RL,    R*8              2       11      ! Galactic longitude
      !       RB     R*8              2       13      ! Galactic latitude
      !       Length = 13     Words                   ! 86
      !
      ! KEY = PROJECTION              (6)
      !       LENGTH
      !       TYPE,A0,D0,ANGLE        1+3*2   8
      !       AXIS1,AXIS2             2*1     10      ! Projected axis
      !       Length = 10     Words                   ! 96
      !
      ! KEY = SPECTROSCOPY            (7)
      !       LENGTH
      !       RLINE  C*12             ! Line name
      !       RFRES, R*8              ! Frequency resolution
      !       RFIMA, R*8              ! Image Frequency
      !       RVRES, R*4              ! Velocity resolution
      !       RVOFF  R*4              ! Velocity offset
      !       RRESTF R*8              ! Rest frequency of transition
      !       RFAXI  I*4              ! Frequency axis
      !       Length = 13             ! 109
      !
      ! KEY = RESOLUTION              (8)
      !       LENGTH
      !       MAJOR                   ! Major axis
      !       MINOR                   ! Minor axis
      !       POSITION_ANGLE          !
      !       Length = 4              ! 113
      !---------------------------------------------------------------------
      integer, intent(inout) :: ibuf32(*)         ! Buffer where sections must be stored
      character(len=*), intent(in) :: type        ! Section name
      integer, intent(in) :: array(*)             ! Section array values
      integer, intent(in) :: size                 ! Section size
      logical :: error                  !
    end subroutine gio_whsec32
  end interface
  !
  interface
    subroutine gio_rhsec32(ibuf32,type,array,size,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG  Stand-alone routine
      !       Find information Greg Data Frame header
      !---------------------------------------------------------------------
      integer, intent(inout) :: ibuf32(*)         ! Buffer from which section must be fetched
      character(len=*), intent(in) :: type        ! Section name
      integer, intent(inout) :: array(*)          ! Section data
      integer, intent(inout) :: size              ! Section size
      logical :: error                  !
    end subroutine gio_rhsec32
  end interface
  !
  interface
    subroutine gio_cvhd32 (len,inhead,ouhead,r8,r4,i4)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer, intent(in)  :: len       ! Length of buffer
      integer, intent(in)  :: inhead(*) ! Input values in file format
      integer, intent(out) :: ouhead(*) ! Converted values in machine format
      external :: r8                    ! Real*8 conversion routine
      external :: r4                    ! Real*4 conversion routine
      external :: i4                    ! Integer*4 conversion routine
    end subroutine gio_cvhd32
  end interface
  !
  interface
    subroutine gio_read32header(hd32,ibuf32,error)
      use gio_headers
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GIO / GDF Internal routine
      !       Read an image header from the requested slot ISLO
      !       The slot must have been properly opened before
      !---------------------------------------------------------------------
      type (gildas_header_v1), intent(out) :: hd32   ! GILDAS image structure
      integer(kind=4), intent(inout) :: ibuf32(*)    ! Buffer of data
      logical, intent(inout) :: error                ! Error flag
    end subroutine gio_read32header
  end interface
  !
  interface
    subroutine gio_write32header(hd32,ibuf32,error)
      use gio_headers
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GDF / GIO Internal routine
      !       Update an image header on a specified image slot
      !           The slot must have been opened before
      !---------------------------------------------------------------------
      type (gildas_header_v1), intent(inout) :: hd32   ! GILDAS type output structure
      integer(kind=4), intent(out) :: ibuf32(*)  ! Working buffer
      logical, intent(out) :: error             ! Logical error flag
    end subroutine gio_write32header
  end interface
  !
  interface
    subroutine gio_rewris(rdonly,is,gtype,name,form,size,error)
      use gildas_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GDF   REad or WRite Image Slot. Common part for gio_reis and
      !       gio_wris, do not use directly.
      !---------------------------------------------------------------------
      logical,                   intent(in)  :: rdonly  ! Read or Write mode?
      integer(kind=4),           intent(in)  :: is      ! Image Slot
      character(len=*),          intent(out) :: gtype   ! Image type
      character(len=*),          intent(in)  :: name    ! File name
      integer(kind=4),           intent(out) :: form    ! Data type
      integer(kind=size_length), intent(out) :: size    ! Data size
      logical,                   intent(out) :: error   ! Error flag
    end subroutine gio_rewris
  end interface
  !
  interface
    subroutine gdf_modify_resolution(old_freq,new_freq,majo,mino,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Modify the resolution according to old and new frequencies
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: old_freq  !
      real(kind=8), intent(in)    :: new_freq  !
      real(kind=4), intent(inout) :: majo      !
      real(kind=4), intent(inout) :: mino      !
      logical,      intent(inout) :: error     !
    end subroutine gdf_modify_resolution
  end interface
  !
  interface
    integer function gio_word_length(header)
      use image_def
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GDF / GIO Internal routine
      !       Return the word length (in Bytes) of a GILDAS image
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: header           !
    end function gio_word_length
  end interface
  !
  interface
    subroutine gio_init_gildas(hx, caller)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GDF API
      !   Initialize a Gildas structure: set the required pointers
      !---------------------------------------------------------------------
      type(gildas), intent(inout), target :: hx ! Gildas structure
      character(len=*), intent(in) :: caller    ! Caller's name
    end subroutine gio_init_gildas
  end interface
  !
  interface
    subroutine gio_zero_gildas(header)
      use image_def
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GDF API routine
      !    Initialize a Gildas header content to default values
      !---------------------------------------------------------------------
      type (gildas), intent(inout) :: header           !
    end subroutine gio_zero_gildas
  end interface
  !
  interface
    subroutine gio_dump_header (imag)
      use image_def
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: imag                !
    end subroutine gio_dump_header
  end interface
  !
  interface
    subroutine gdf_transpose4(in,ou,code,iblock,space_gildas,isfits,error)
      use image_def
      use gbl_message
      use gsys_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(gildas),               intent(inout) :: in            !
      type(gildas),               intent(inout) :: ou            !
      character(len=*),           intent(in)    :: code          !
      integer(kind=index_length), intent(in)    :: iblock(5)     !
      integer(kind=4),            intent(in)    :: space_gildas  ! Useable memory size (MB)
      logical,                    intent(in)    :: isfits        !
      logical,                    intent(inout) :: error         !
    end subroutine gdf_transpose4
  end interface
  !
  interface
    subroutine gdf_transpose4_disk(in,ou,iblock,space_gildas,isfits,error)
      use image_def
      use gbl_message
      use gsys_types
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! Perform the transposition on disk
      !---------------------------------------------------------------------
      type(gildas),               intent(inout) :: in            !
      type(gildas),               intent(inout) :: ou            !
      integer(kind=index_length), intent(in)    :: iblock(5)     !
      integer(kind=4),            intent(in)    :: space_gildas  ! Useable memory (MB)
      logical,                    intent(in)    :: isfits        !
      logical,                    intent(inout) :: error         !
    end subroutine gdf_transpose4_disk
  end interface
  !
  interface
    subroutine gdf_transpose4_memory(in,ou,iblock,isfits,error)
      use image_def
      use gbl_message
      use gsys_types
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! Problem does fit in memory. Loop on the last dimension
      !---------------------------------------------------------------------
      type(gildas),               intent(inout) :: in         !
      type(gildas),               intent(inout) :: ou         !
      integer(kind=index_length), intent(in)    :: iblock(5)  !
      logical,                    intent(in)    :: isfits     !
      logical,                    intent(inout) :: error      !
    end subroutine gdf_transpose4_memory
  end interface
  !
  interface
    subroutine gdf_transpose_uvcolumn8(ou,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Transpose the REAL*8 (2 words) columns which have been misordered
      ! by a previous transposition.
      !  GDF UV tables specific, because only GDF UV tables have data
      ! columns spread over several columns.
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: ou     !
      logical,      intent(inout) :: error  !
    end subroutine gdf_transpose_uvcolumn8
  end interface
  !
  interface
    function gdf_2gelems(h)
      use image_def
      !---------------------------------------------------------------------
      ! @ private
      ! Return .true. if the data has more than 2 giga-elements
      !---------------------------------------------------------------------
      logical :: gdf_2gelems  ! Function value on return
      type(gildas), intent(in) :: h
    end function gdf_2gelems
  end interface
  !
  interface
    function gdf_2gbytes(h)
      use image_def
      !---------------------------------------------------------------------
      ! @ private
      ! Return .true. if the data is larger than 2 GB (bytes, not 4-bytes
      ! words)
      !---------------------------------------------------------------------
      logical :: gdf_2gbytes  ! Function value on return
      type(gildas), intent(in) :: h
    end function gdf_2gbytes
  end interface
  !
  interface
    subroutine fits2gdf(name,error)
      use gbl_message
      use gio_params
      !---------------------------------------------------------------------
      ! @ private
      ! Automatic FITS to GDF converion
      !---------------------------------------------------------------------
      character(len=*), intent(inout)  :: name       ! File name (modified)
      logical, intent(out) :: error                  ! Error flag
    end subroutine fits2gdf
  end interface
  !
  interface
    subroutine fits2gdf_wpr(chain,answer)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      character(len=*) :: chain         !
      character(len=*) :: answer        !
    end subroutine fits2gdf_wpr
  end interface
  !
  interface
    subroutine fitscube2gdf_check_naxis(fhdict,ihdu,ndim,dims,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read and check the NAXIS* values
      !---------------------------------------------------------------------
      type(gfits_hdict_t),        intent(in)    :: fhdict   !
      integer(kind=4),            intent(in)    :: ihdu     !
      integer(kind=4),            intent(out)   :: ndim     !
      integer(kind=index_length), intent(out)   :: dims(:)  !
      logical,                    intent(inout) :: error    !
    end subroutine fitscube2gdf_check_naxis
  end interface
  !
  interface
    subroutine fitscube2gdf_check_convert(fhdict,convert,rota,unit,error)
      use image_def
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Translate all the CRVALi, CRPIXi, CDELTi, CTYPEi, CROTAi
      !---------------------------------------------------------------------
      type(gfits_hdict_t),  intent(in)    :: fhdict        !
      real(kind=8),         intent(out)   :: convert(:,:)  !
      real(kind=8),         intent(out)   :: rota(:)       !
      character(len=*),     intent(out)   :: unit(:)       !
      logical,              intent(inout) :: error         !
    end subroutine fitscube2gdf_check_convert
  end interface
  !
  interface
    subroutine fitscube2gdf_check_cdmatrix(fhdict,convert,rota,error)
      use phys_const
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Apply the CD or PC matrix to the convert/rota arrays
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fhdict        !
      real(kind=8),        intent(inout) :: convert(:,:)  !
      real(kind=8),        intent(inout) :: rota(:)       !
      logical,             intent(inout) :: error         !
    end subroutine fitscube2gdf_check_cdmatrix
  end interface
  !
  interface
    subroutine fitscube2gdf_check_array(fhdict,fd,ghead,error)
      use gbl_message
      use image_def
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Get the binary array description
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fhdict   !
      type(gfits_hdesc_t), intent(inout) :: fd       !
      type(gildas),        intent(inout) :: ghead    !
      logical,             intent(inout) :: error    !
    end subroutine fitscube2gdf_check_array
  end interface
  !
  interface
    subroutine fitscube2gdf_check_minmax(fhdict,nwords,datamin,datamax,error)
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Get the binary array description
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fhdict    !
      integer(kind=4),     intent(out)   :: nwords    !
      real(kind=4),        intent(out)   :: datamin   !
      real(kind=4),        intent(out)   :: datamax   !
      logical,             intent(inout) :: error     !
    end subroutine fitscube2gdf_check_minmax
  end interface
  !
  interface
    subroutine fitscube2gdf_check_system(fhdict,rota,ghead,error)
      use phys_const
      use gbl_message
      use image_def
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fhdict    !
      real(kind=8),        intent(in)    :: rota(:)   !
      type(gildas),        intent(inout) :: ghead     !
      logical,             intent(inout) :: error     !
    end subroutine fitscube2gdf_check_system
  end interface
  !
  interface
    subroutine fitscube2gdf_check_spec(fhdict,unit,ghead,error)
      use phys_const
      use gbl_message
      use image_def
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fhdict    !
      character(len=*),    intent(in)    :: unit(:)   !
      type(gildas),        intent(inout) :: ghead     !
      logical,             intent(inout) :: error     !
    end subroutine fitscube2gdf_check_spec
  end interface
  !
  interface
    subroutine fitscube2gdf_check_resolution(fhdict,ghead,error)
      use phys_const
      use image_def
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fhdict  !
      type(gildas),        intent(inout) :: ghead   !
      logical,             intent(inout) :: error   !
    end subroutine fitscube2gdf_check_resolution
  end interface
  !
  interface
    subroutine fitscube2gdf_check_telescope(fhdict,ghead,error)
      use phys_const
      use image_def
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fhdict  !
      type(gildas),        intent(inout) :: ghead   !
      logical,             intent(inout) :: error   !
    end subroutine fitscube2gdf_check_telescope
  end interface
  !
  interface
    subroutine fits2gdf_guess_style(style,error)
      use gbl_message
      use gio_params
      use gfits_types
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      !  Guess the style of the extension currently opened in GFITS
      !---------------------------------------------------------------------
      integer(kind=4), intent(out)   :: style
      logical,         intent(inout) :: error
    end subroutine fits2gdf_guess_style
  end interface
  !
  interface
    subroutine fitscube2gdf_import_sfl_as_radio(fhdict,ghead,error)
      use phys_const
      use gbl_constant
      use gbl_message
      use image_def
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! If possible, convert back the SFL projection to the usual radio
      ! projection. This patch is symetric to what is done at export time,
      ! but the export patch puts the reference on the Equator, which is a
      ! bit annoying.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fhdict
      type(gildas),        intent(inout) :: ghead
      logical,             intent(inout) :: error
    end subroutine fitscube2gdf_import_sfl_as_radio
  end interface
  !
  interface
    subroutine read_all(fits,error,eot)
      use gildas_def
      use gbl_format
      use gbl_message
      use image_def
      use gsys_types
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! Read all the input FITS image
      !
      ! Should be re-written by using a block mode operation, with say a
      ! few Mbyte buffer, or even less...
      ! Slot re-shaping can be used for this
      ! Extrema should be carried on through, not in a separate pass...
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: fits   !
      logical,      intent(out)   :: error  ! Error flag
      logical,      intent(inout) :: eot    ! End of Tape flag
    end subroutine read_all
  end interface
  !
  interface
    subroutine read_sub(fits,error,eot,blc,trc)
      use gildas_def
      use gbl_format
      use gbl_message
      use image_def
      use gio_params
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! FITS  Support routine for command
      !
      !       READ [/BLC Nx1 Nx2 Nx3 Nx4] [/TRC Ny1 Ny2 Ny3 Ny4]
      ! Arguments :
      !       ERROR   L       Logical error flag      Output
      !---------------------------------------------------------------------
      type(gildas),          intent(inout) :: fits    !
      logical,               intent(out)   :: error   ! Error flag
      logical,               intent(inout) :: eot     ! End of Tape flag
      integer(index_length), intent(in)    :: blc(:)  !
      integer(index_length), intent(in)    :: trc(:)  !
    end subroutine read_sub
  end interface
  !
  interface
    subroutine tofits(fits,check,error)
      use gbl_message
      use image_def
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! GFITS
      !     Write GILDAS data set to FITS tape
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: fits   !
      logical,      intent(in)    :: check  ! Verbose flag
      logical,      intent(out)   :: error  ! Error flag
    end subroutine tofits
  end interface
  !
  interface
    subroutine to_uvfits(fits,check,error)
      use gildas_def
      use gbl_message
      use image_def
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! FITS        Internal routine.
      !     Write current UV data on tape.
      !---------------------------------------------------------------------
      type(gildas), intent(in)  :: fits   !
      logical,      intent(in)  :: check  ! Verbose flag
      logical,      intent(out) :: error  ! Error flag
    end subroutine to_uvfits
  end interface
  !
  interface
    subroutine wr_fitshead(fits,rmin,rmax,umin,umax,vmin,vmax,wmin,wmax,jmin,  &
      ps,telescop,check,error)
      use phys_const
      use gbl_message
      use image_def
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! UVFITS
      !     Write the FITS header for a visibility set.
      !---------------------------------------------------------------------
      type(gildas),     intent(in)  :: fits       !
      real(kind=4),     intent(in)  :: rmin,rmax  !
      real(kind=4),     intent(in)  :: umin,umax  !
      real(kind=4),     intent(in)  :: vmin,vmax  !
      real(kind=4),     intent(in)  :: wmin,wmax  !
      real(kind=4),     intent(in)  :: jmin       !
      real(kind=4),     intent(in)  :: ps         ! Weight scaling factor
      character(len=*), intent(in)  :: telescop   !
      logical,          intent(in)  :: check      !
      logical,          intent(out) :: error      !
    end subroutine wr_fitshead
  end interface
  !
  interface
    subroutine write_antenna_extension(telescop,diam,nant,check,error)
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: telescop  ! Array name
      real(kind=4),     intent(in)    :: diam      ! Antenna diameters (same for all)
      integer(kind=4),  intent(in)    :: nant      ! Number of antennas
      logical,          intent(in)    :: check     ! Verbose flag
      logical,          intent(inout) :: error     ! Error flag
    end subroutine write_antenna_extension
  end interface
  !
  interface
    subroutine to_imfits(fits,check,error)
      use gildas_def
      use phys_const
      use gbl_message
      use image_def
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! FITS
      !       Write a GDF-image onto FITS tape
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: fits   !
      logical,      intent(in)    :: check  ! Verbose flag
      logical,      intent(inout) :: error  ! Error flag
    end subroutine to_imfits
  end interface
  !
  interface
    subroutine write_axis(fits,axis_number,check,error)
      use phys_const
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! FITS
      ! Try to write a sensible output axis name and units, according to
      ! standard FITS (stupid) conventions which requires degrees instead
      ! of Radians...
      !---------------------------------------------------------------------
      type(gildas),    intent(in)    :: fits         !
      integer(kind=4), intent(in)    :: axis_number  ! Axis number
      logical,         intent(in)    :: check        ! Verbose flag
      logical,         intent(inout) :: error        ! Error flag
    end subroutine write_axis
  end interface
  !
  interface
    subroutine touvt(fits,istyle,what,check,error,pcount,getsymbol)
      use gbl_message
      use phys_const
      use image_def
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      ! Read a UVFITS file from tape and convert it to GDF format in virtual
      ! memory.
      !---------------------------------------------------------------------
      type(gildas),    intent(inout) :: fits       !
      integer(kind=4), intent(in)    :: istyle     ! A cryptic style code, 1,2 or something else
      logical,         intent(in)    :: what       ! Prompt on unknown axis types ?
      logical,         intent(in)    :: check      ! Verbose flag
      logical,         intent(out)   :: error      ! Error flag
      integer(kind=4), intent(out)   :: pcount     ! Parameter count
      external                       :: getsymbol  ! FITS Keyword translation routine
    end subroutine touvt
  end interface
  !
  interface
    subroutine read_uvfits(fits,astoke,error,eot,pcount)
      use image_def
      use gbl_format
      use gbl_message
      use image_def
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ private
      !   Read all the input FITS UV table
      !---------------------------------------------------------------------
      type(gildas),    intent(inout) :: fits    !
      integer(kind=4), intent(in)    :: astoke  ! Stokes parameter
      logical,         intent(out)   :: error   ! Error flag
      logical,         intent(out)   :: eot     ! End ot Tape flag
      integer(kind=4), intent(in)    :: pcount  ! Daps count
    end subroutine read_uvfits
  end interface
  !
  interface
    subroutine key_order(pcount,syst)
      use gio_fitsdef
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !    Define the scaling factors for each parameter
      !    and find out the ordering of the required Daps
      !---------------------------------------------------------------------
      integer, intent(in) :: pcount         ! Parameter count
      character(len=*), intent(in) :: syst  ! Coordinate system
    end subroutine key_order
  end interface
  !
  interface
    subroutine gio_setistbl(is,stbl)
      use gio_image
      !--------------------------------------------------------
      ! @ private
      ! Temporary routine to set the Number of Header blocks
      ! Use by FITS interface to support Ntsokes > 1.
      !--------------------------------------------------------
      integer, intent(in) :: is     ! Image slot number
      integer, intent(in) :: stbl   ! Number of header blocks
    end subroutine gio_setistbl
  end interface
  !
  interface
    subroutine uvfits_stokes_select(inarray,inchan,outarray,onchan, &
      & nstokes,in_stokes,out_stokes,stokes_order)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !
      !   GIO   perform the appropriate Stokes conversion
      !---------------------------------------------------------------------
      integer, intent(in) :: inchan             ! Input number of channels
      real, intent(in) :: inarray(3,inchan)     ! Input visibilitiees
      integer, intent(in) :: onchan             ! Output number of channels
      real, intent(out) :: outarray(3,onchan)   ! Output visibilities
      integer, intent(in) :: nstokes            ! Number of input Stokes
      integer, intent(in) :: in_stokes(nstokes) ! Input Stokes codes
      integer, intent(in) :: out_stokes         ! Output Stokes
      integer, intent(in) :: stokes_order       ! Stokes ordering
    end subroutine uvfits_stokes_select
  end interface
  !
end module gio_interfaces_private

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_package
  use cubetools_parameters
  use cubesyntax_messaging
  use cubelist_types
  use cubetools_terminal_tool
  use cubetools_language
  !
  public :: lang_k
  public :: package_t
  private
  !
  integer(kind=4), parameter :: lang_k =  4 ! [integer] Languages
  integer(kind=4), parameter :: pack_l = 16
  integer(kind=4), parameter :: help_l = 80
  !
  type package_t
     character(len=pack_l) :: name = strg_unk
     character(len=help_l) :: help = strg_emp
     type(list_t)          :: lang
   contains
     ! General
     procedure :: init             => cubetools_package_init
     procedure :: final            => cubetools_package_final
     procedure :: free             => cubetools_package_free
     !
     ! Registering
     procedure :: put              => cubetools_package_put
     !
     ! Execution
     procedure :: get_language_id  => cubetools_package_get_language_id
     !
     ! Print and Help
     procedure :: abstract         => cubetools_package_abstract
     procedure :: list             => cubetools_package_list
     procedure :: help_iterate     => cubetools_package_help_iterate
  end type package_t
  !
contains
  !
  !---General------------------------------------------------------------
  !
  subroutine cubetools_package_init(pack,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(out)   :: pack
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_package_init
  !
  subroutine cubetools_package_final(pack,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(inout) :: pack
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>FINAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_package_free(pack,error)
    if (error) return
  end subroutine cubetools_package_final
  !
  subroutine cubetools_package_free(pack,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(inout) :: pack
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>FREE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%lang%final(error)
    if (error) return
  end subroutine cubetools_package_free
  !
  !---Registering--------------------------------------------------------
  !
  subroutine cubetools_package_put(pack,name,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t),     intent(inout) :: pack
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: help
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%final(error)
    if (error) return
    call pack%init(error)
    if (error) return
    pack%name = name
    pack%help = help
    pack%lang%n = 0
  end subroutine cubetools_package_put
  !
  !---Execution----------------------------------------------------------
  !
  subroutine cubetools_package_get_language_id(pack,langname,langid,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t),     intent(in)    :: pack
    character(len=*),     intent(in)    :: langname
    integer(kind=lang_k), intent(out)   :: langid
    logical,              intent(inout) :: error
    !
    integer(kind=lang_k) :: ilang
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='PACKAGE>GET>LANGUAGE>ID'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    do ilang = 1,pack%lang%n
      lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
      if (error) return
      if (lang%name.eq.langname) then
        langid = ilang
        return
      endif
    enddo ! ilang
    !
    ! Not found
    langid = 0
    call cubesyntax_message(seve%e,rname,'Unknown language '//trim(langname)//' in package '//trim(pack%name))
    error = .true.
    return
  end subroutine cubetools_package_get_language_id
  !
  !---Print-and-Help-------------------------------------------------------
  !
  subroutine cubetools_package_help_iterate(pack,forma,error)
    use cubetools_parameters
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(package_t),     intent(in)    :: pack
    integer(kind=code_k), intent(in)    :: forma
    logical,              intent(inout) :: error
    !
    integer(kind=lang_k) :: ilang
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='PACKAGE>HELP>ITERATE'
    !
    select case (forma)
    case (help_format_tex)
      call cubetools_package_help_iterate_tex(pack,error)
      if (error)  return
    case default
      call cubesyntax_message(seve%e,rname,'Help format not implemented')
      error = .true.
      return
    end select
    !
    do ilang=1,pack%lang%n
      lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
      if (error) return
      call lang%help_iterate(forma,error)
      if (error) return
    enddo
  end subroutine cubetools_package_help_iterate
  !
  subroutine cubetools_package_help_iterate_tex(pack,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(package_t), intent(in)    :: pack
    logical,         intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>HELP>ITERATE>TEX'
    !
    call cubesyntax_message(syntaxseve%help,rname,'\chapter{'//trim(pack%name)//' On-Line Help}')
    call cubesyntax_message(syntaxseve%help,rname,'\label{sec:'//trim(pack%name)//':package}')
    call cubesyntax_message(syntaxseve%help,rname,'\section{List of '//trim(pack%name)//' languages}')
    call cubesyntax_message(syntaxseve%help,rname,'\label{sec:'//trim(pack%name)//':languages}')
    call cubesyntax_message(syntaxseve%help,rname,'\index{Language list}')
    !
    call cubesyntax_message(syntaxseve%help,rname,'\begin{PlusVerbatim}')
    call pack%list(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,'\end{PlusVerbatim}')
    call cubesyntax_message(syntaxseve%help,rname,'\newpage{}')
  end subroutine cubetools_package_help_iterate_tex
  !
  subroutine cubetools_package_abstract(pack,error)
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(inout) :: pack
    logical,          intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PACKAGE>ABSTRACT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  '//cubetools_format_stdkey_boldval(pack%name,pack%help,terminal%width())
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubetools_package_abstract
  !
  subroutine cubetools_package_list(pack,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(in)    :: pack
    logical,          intent(inout) :: error
    !
    integer(kind=lang_k) :: ilang
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='PACKAGE>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    do ilang = 1,pack%lang%n
      lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
      if (error) return
      call lang%print_abstract(error)
      if (error) return
    enddo ! ilang
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_package_list
  !
end module cubetools_package
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine copyrt(user_function,key)
  use class_interfaces, except_this=>copyrt
  use class_rt
  !----------------------------------------------------------------------
  ! @ private
  ! Copy R memory to T memory
  !----------------------------------------------------------------------
  logical,          external   :: user_function  !
  character(len=*), intent(in) :: key            !
  ! Local
  logical :: ll,error
  !
  if (r%head%xnum.eq.0)  return  ! Nothing to copy yet (copy_obs would raise an error)
  !
  call copy_obs(r,t,error)
  ll = user_function('COPY')
  !
end subroutine copyrt
!
subroutine copy2r(obs,error)
  use class_interfaces, except_this=>copy2r
  use class_rt
  use class_setup
  !-------------------------------------------------------------------
  ! @ private
  ! Copy the observation into R memory
  !-------------------------------------------------------------------
  type(observation), intent(in)  :: obs    ! Current observation
  logical,           intent(out) :: error  ! Error flag
  !
  error = .false.
  call copy_obs(obs,r,error)
  if (error)  return
  !
  call newdat(set,r,error)
  call newdat_assoc(set,r,error)
  call newdat_user(set,r,error)
end subroutine copy2r

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
program uvshort_program
  use image_def
  use gkernel_interfaces
  !------------------------------------------------------------------------
  ! Task  UV_SHORT
  !
  !   Compute a short spacings uv table from a single-dish table
  !   by gridding, extending to 0, filtering in uv plane, multiplication
  !   by interferometer primary beam, and sampling in uv plane.
  !
  ! input:  a single-dish table or image, and optionally a mosaic UV Table
  ! output: a UV table
  !------------------------------------------------------------------------
  !
  type uvshort_user_t
     character(len=12)              :: action = "all"
     character(len=filename_length) :: name
     !
     real(kind=4)      :: postol = 0.10         ! [---|sec] Pointing tolerance (fraction of beam on input, arcsec on output)
     real(kind=8)      :: spetol = 0.01         ! [-------] Spectral tolerance (fraction of channel, velocity, frequency)
     !
     real(kind=4)      :: ipfac = 1.0           ! [-------] Multiplicative factor for interferometric data. Normally 1
     !
     character(len=12) :: sdunit = "*"          ! [-------] * means to try "K (Tmb) to Jy/Beam" or "Jy/Beam to Jy/Beam".
     real(kind=4)      :: sdfac = 1.0           ! [-------] Multiplicative factor for single dish data. Normally 1
     real(kind=4)      :: sdwei = 1.0           ! [-------] Single dish  weight factor. Normally 1
     !
     real(kind=4)      :: uvtrunc  = 0.0        ! [      m] Truncation radius. If zero, it will be set to sd_beam - ip_beam
     real(kind=4)      :: sdbeamin = 0.0        ! [sec|rad] Single dish beam of the input table of cube (sec on input, rad internally)
     real(kind=4)      :: sdbeamou = 0.0        ! [sec|rad] Single dish beam of the output cube         (sec on input, rad internally)
     real(kind=4)      :: sddiam   = 0.0        ! [      m] Single dish diameter
     real(kind=4)      :: ipbeam   = 0.0        ! [sec|rad] Interf. primary beam (sec on input, rad internally)
     real(kind=4)      :: ipdiam   = 0.0        ! [      m] Interf. primary diameter
     real(kind=4)      :: uvstep   = 0.0        ! [      m] Step in the UV plane for weight density bins
  end type uvshort_user_t
  !
  type uvshort_sdwei_state_t
     real(kind=4)              :: user = 1.0   ! Raw SDWEI$ user input; zero means automatic
     real(kind=4), allocatable :: field(:)  ! Automatic short-spacing weight estimate per field
     real(kind=4), allocatable :: factor(:) ! Effective factor per field after user correction
     real(kind=4)              :: min = 1.0
     real(kind=4)              :: med = 1.0
     real(kind=4)              :: max = 1.0
  end type uvshort_sdwei_state_t
  !
  type uvshort_prog_t
     character(len=12)              :: action = "all"
     character(len=filename_length) :: name
     !
     real(kind=4)      :: postol = 0.10         ! [---|sec] Pointing tolerance (fraction of beam on input, arcsec on output)
     real(kind=8)      :: spetol = 0.01         ! [-------] Spectral tolerance (fraction of channel, velocity, frequency)
     !
     real(kind=4)      :: ipfac = 1.0           ! [-------] Multiplicative factor for interferometric data. Normally 1
     !
     character(len=12) :: sdunit = "*"          ! [-------] * means to try "K (Tmb) to Jy/Beam" or "Jy/Beam to Jy/Beam".
     real(kind=4)      :: sdfac = 1.0           ! [-------] Multiplicative factor for single dish data. Normally 1
     type(uvshort_sdwei_state_t) :: sdwei       ! [-------] Automatic short-spacing weight state
     !
     real(kind=4)      :: uvtrunc  = 0.0        ! [      m] Truncation radius. If zero, it will be set to sd_beam - ip_beam
     real(kind=4)      :: sdbeamin = 0.0        ! [sec|rad] Single dish beam of the input table of cube (sec on input, rad internally)
     real(kind=4)      :: sdbeamou = 0.0        ! [sec|rad] Single dish beam of the output cube         (sec on input, rad internally)
     real(kind=4)      :: sddiam   = 0.0        ! [      m] Single dish diameter
     real(kind=4)      :: ipbeam   = 0.0        ! [sec|rad] Interf. primary beam (sec on input, rad internally)
     real(kind=4)      :: ipdiam   = 0.0        ! [      m] Interf. primary diameter
     real(kind=4)      :: uvstep   = 0.0        ! [      m] Step in the UV plane for weight density bins
  end type uvshort_prog_t
  !
  type uvshort_action_t
     logical           :: break  = .true.       ! Break running flow on error
     logical           :: all    = .false.      !
     logical           :: setup  = .false.      !
     logical           :: grid   = .false.      ! Grid single dish data
     logical           :: pseudo = .false.      !
     logical           :: merge  = .false.      !
     character(len=12) :: wei = 'natural'       ! Normally UN or NA, but little effect
     logical           :: zero = .false.        ! Zero or short-spacings?
     logical           :: deconv_sd = .true.    ! Deconvolve single dish beam
     logical           :: apply_ip = .true.     ! Apply interferometer primary beam
     logical           :: write_sdou = .true.   ! 
     logical           :: write_uvps = .true.   ! 
  end type uvshort_action_t
  !
  type uvshort_sddata_t
     type(gildas) :: in ! Input single dish table
     type(gildas) :: ou ! (Output) single dish data cube in LMV order
     type(gildas) :: we ! (Output) gridded weights in LM plane
     !
     logical :: islmv = .false. ! TAB or LMV input file?
     real(kind=4)    :: xmin = 0.0
     real(kind=4)    :: xmax = 0.0
     real(kind=4)    :: ymin = 0.0
     real(kind=4)    :: ymax = 0.0
     integer(kind=4) :: xcol = 1
     integer(kind=4) :: ycol = 2
     integer(kind=4) :: wcol = 3
     integer(kind=4) :: mcol(2) = (4,0)
     integer(kind=4) :: nchan = 0
  end type uvshort_sddata_t
  !
  type uvshort_uvdata_t
     type(gildas) :: in ! Input  uv table when used to append
     type(gildas) :: ou ! Output uv table
     type(gildas) :: ps ! Computed pseudo visibilities
     !
     type(gildas) :: inbeam
     type(gildas) :: oubeam
     !
     logical                   :: ismos = .true.      ! Mosaic or single field?
     logical                   :: islm  = .true.      ! LM or XY type UV table?
     integer(kind=4)           :: ocol(2) = 0         ! Table columns where field offsets are stored
     integer(kind=4)           :: wcol = 0            ! Table column where the weights will be taken
     integer(kind=4)           :: ivisi = 0           ! Current number of visibility copied or written
     integer(kind=4)           :: nvisi_per_field = 0 ! Number of pseudo-visibility per field
     integer(kind=4)           :: ifield = 0          ! 
     integer(kind=4)           :: nfield = 0          ! Number of fields
     real(kind=4), allocatable :: raoff(:)            ! Field RA  offsets
     real(kind=4), allocatable :: deoff(:)            ! Field Dec offsets
     real(kind=4)              :: ipdatfac = 1.0      ! User correction to Interferometer calibration
     real(kind=4)              :: sddatfac = 1.0 ! = user%sdfac * prog%sdfac (ie, user correction * unit conversion)
     real(kind=4)              :: sdweifac = 1.0 ! Non-authoritative summary of field-dependent SD weight factors
  end type uvshort_uvdata_t
  !
  type uvshort_buffer_t
     integer(kind=4) :: ndim = 2
     integer(kind=4) :: dim(2) = 0
     integer(kind=4) :: nx = 0
     integer(kind=4) :: ny = 0
     integer(kind=4) :: nf = 0
     real(kind=8),    allocatable :: xy(:,:)        ! [ 2,nf] Position shift per channel
     real(kind=4),    allocatable :: uvwei(:,:)     ! [nx,ny] Gridded weights in UV plane
     real(kind=4),    allocatable :: sdlobe_uv(:,:) ! [nx,ny] Single dish beam in UV plane
     real(kind=4),    allocatable :: iplobe_lm(:,:) ! [nx,ny] Interferometer primary beam in LM plane
     complex(kind=4), allocatable :: iplobe_uv(:,:) ! [nx,ny] Interferometer beam in UV plane
     complex(kind=4), allocatable :: visi(:,:,:)    ! [nx,ny,nf] Cube of pseudo visilibities
     real(kind=4),    allocatable :: fftws(:)       ! [2*max(nx,ny)] FFT work space
  end type uvshort_buffer_t
  !
  logical :: break,error
  real(kind=4) :: ubias,vbias,ubuff(8192),vbuff(8192)
  !
  call uvshort_main(break,error)
  if (error.and.break) call sysexi(fatale)
  !
contains
  !
  subroutine uvshort_main(break,error)
    !------------------------------------------------------------------------
    ! Main subroutine
    !------------------------------------------------------------------------
    logical, intent(out) :: break
    logical, intent(out) :: error
    !
    type(uvshort_user_t) :: user
    type(uvshort_prog_t) :: prog
    type(uvshort_action_t) :: do
    type(uvshort_sddata_t) :: sd
    type(uvshort_uvdata_t) :: uv
    character(len=*), parameter :: rname='UV_SHORT'
    !
    break = .true.
    error = .false.
    call uvshort_user_get(user)
    call uvshort_user_toprog(user,prog)
    call uvshort_check_action(rname,user,prog,do,error)
    if (error) return
    break = do%break
    if (do%all.or.do%setup) then
       call uvshort_check_sd(rname,user,prog,do,sd,error)
       if (error) goto 10
       call uvshort_check_uv(rname,user,prog,do,uv,error)
       if (error) goto 10
       call uvshort_check_spectral_consistency(rname,prog,uv,sd,error)
       if (error) goto 10
       call uvshort_check_uvtrunc(rname,user,uv,sd,prog,do,error)    
       if (error) goto 10
       call uvshort_check_uvstep(rname,user,prog,error)
       if(error) goto 10
       call uvshort_user_feedback(rname,user,prog,do,sd,uv,error)
       if (error) goto 10
    endif
    if (do%all.or.do%pseudo) then
       call uvshort_sd_get(rname,prog,uv,sd,error)
       if (error) goto 10
       call uvshort_pseudo(rname,prog,do,sd,uv,error)
       if (error) goto 10
       !!$    if (do_zero) then
!!$       call uvshort_uvzero(rname,user,uvdat%in,error)
!!$       if (error) return
!!$    endif
    endif
!!$ Logic needs to be refined if we want to separate gridding from
!!$ computation of pseudo-visibilities
!!$    if (do%all.or.do%grid) then
!!$       call uvshort_sd_get(rname,prog,uv,sd,error)
!!$       if (error) return
!!$    endif
!!$    if (do%all.or.do%pseudo) then
!!$       call uvshort_pseudo(rname,prog,do,sd,uv,error)
!!$       if (error) return
!!$    endif
    if (do%all.or.do%merge) then
       if (.not.do%all) then
          !load uv%ps%gil
       endif
       call uvshort_merge(rname,prog,uv,error)
       if (error) return
    endif
    !
    ! Cleaning
10  continue
    call uvshort_sd_free(sd)
    call uvshort_uv_free(uv)
    !
  end subroutine uvshort_main
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Routines to get an analysis input parameters
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! 
  subroutine uvshort_user_get(user)
    !------------------------------------------------------------------------
    ! Put task inputs into user structure
    !------------------------------------------------------------------------
    type(uvshort_user_t), intent(inout) :: user
    !
    call gildas_open
    call gildas_char('ACTION$',user%action)
    call gildas_char('NAME$',user%name)
    !
    call gildas_dble('SPETOL$',user%spetol,1)
    call gildas_real('POSTOL$',user%postol,1)
    !
    call gildas_real('IPFAC$',user%ipfac,1)
    !
    call gildas_char('SDUNIT$',user%sdunit)
    call gildas_real('SDFAC$',user%sdfac,1)
    call gildas_real('SDWEI$',user%sdwei,1)
    !
    call gildas_real('UVTRUNC$',user%uvtrunc,1)
    call gildas_real('SDBEAM$',user%sdbeamin,1)         
    call gildas_real('SDDIAM$',user%sddiam,1)         
    call gildas_real('IPBEAM$',user%ipbeam,1)         
    call gildas_real('IPDIAM$',user%ipdiam,1)
    call gildas_real('UVSTEP$',user%uvstep,1)
    call gildas_close
    !
  end subroutine uvshort_user_get
  !
  subroutine uvshort_user_toprog(user,prog)
    !------------------------------------------------------------------------
    ! Initialize the internal program state from task inputs.
    !
    ! This routine only copies safe pass-through values whose meaning is the
    ! same in user and prog at initialization time. It must not validate
    ! inputs, derive internal values, allocate field-dependent arrays, or copy
    ! user scale/sentinel values whose prog counterpart has a different
    ! meaning.
    !------------------------------------------------------------------------
    type(uvshort_user_t), intent(in)    :: user
    type(uvshort_prog_t), intent(inout) :: prog
    !
    prog%action = user%action
    prog%name   = user%name
    prog%spetol = user%spetol
    prog%ipfac  = user%ipfac
    prog%sdunit = user%sdunit
    prog%sdwei%user = user%sdwei
    !
    ! Do not copy:
    !   user%sdfac -> prog%sdfac, because prog%sdfac is a unit conversion.
    !   user%sdwei -> prog%sdwei%field/factor/min/med/max, because those are derived per-field state.
    !   user%postol -> prog%postol, because prog%postol is derived later.
    !   user%uvtrunc -> prog%uvtrunc, because zero means automatic until checked.
    !   user%uvstep -> prog%uvstep, because zero means automatic until checked.
    !   user%sddiam/user%sdbeamin/user%sdbeamou -> prog, because beam
    !     values are validated or derived by the check routines.
    !   user%ipdiam/user%ipbeam -> prog, because beam values are validated
    !     or derived by the check routines.
  end subroutine uvshort_user_toprog
  !    
  subroutine uvshort_check_action(rname,user,prog,do,error)
    use gbl_message
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Analysis action input
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_action_t), intent(inout) :: do
    logical,                intent(inout) :: error
    !
    integer(kind=4), parameter :: maction=5
    integer :: iaction
    character(len=12) :: actions(maction),myaction
    data actions /'ALL','SETUP','GRID','PSEUDO','MERGE'/
    !
    prog%action = user%action
    call sic_upper(prog%action)
    call sic_ambigs(rname,prog%action,myaction,iaction,actions,maction,error)
    if (error)  return
    !
    do%break  = .true. ! Default is to break running flow on error
    do%all    = .false.
    do%setup  = .true. ! Setup is required in all cases
    do%grid   = .false.
    do%pseudo = .false.
    do%merge  = .false.
    if (myaction.eq.'ALL') then
       do%all = .true.
    else if (myaction.eq.'SETUP') then
       do%setup = .true.
       do%break = .false. ! When the action is only setup an error is considered just a warning
    else if (myaction.eq.'GRID') then
       do%grid = .true.
    else if (myaction.eq.'PSEUDO') then
       do%pseudo = .true.
    else if (myaction.eq.'MERGE') then
       do%merge = .true.
    else
       call map_message(seve%e,rname,'Unknown action'''//trim(myaction))
       error = .true.
       return
    endif
    !
  end subroutine uvshort_check_action
  !
  subroutine uvshort_check_sd(rname,user,prog,do,sd,error)
    use phys_const
    use image_def
    use gbl_message
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Analysis single-dish input
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_action_t), intent(inout) :: do
    type(uvshort_sddata_t), intent(inout) :: sd
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: iaxis
    character(len=12) :: unit
    character(len=filename_length) :: filename,name,dir,ext
    !
    ! Initialization
    call gildas_null(sd%in)
    call gildas_null(sd%ou)
    !
    ! Does the .tab or .lmv corresponding file exist?
    filename = trim(user%name)
    call sic_parse_file(filename,' ','.tab',sd%in%file)
    call gdf_read_header(sd%in,error)
    if (error) then
       call map_message(seve%w,rname,'Input single dish table '//trim(sd%in%file)//' not found')
       error = .false.
       call sic_parse_file(filename,' ','-short.lmv',sd%in%file)
       call gdf_read_header(sd%in,error)
       if (error) then
          call map_message(seve%e,rname,'Input single dish cube '//trim(sd%in%file)//' not found either')
          return
       endif
       call uvshort_check_sd_reproject(sd%in,error)
       if (error)  return
    endif
    !
    ! Is it a TAB or LMV file?
    if (sd%in%gil%ndim.eq.2) then
       ! *** JP: The table command should set the code code_gdf_xyt
       ! *** JP: and that's what we should check here.
       ! *** JP: How can a user change the code_gdf_xyt for backward compatibility?
       !
       ! Check existence of xcol, ycol, and wcol columns
       if ((sd%xcol.lt.1).or.(sd%in%gil%dim(1).lt.sd%xcol)) then
          call map_message(seve%e,rname,'X column does not exist')
          error = .true.
          return
       endif
       if ((sd%ycol.lt.1).or.(sd%in%gil%dim(1).lt.sd%ycol)) then
          call map_message(seve%e,rname,'Y column does not exist')
          error = .true.
          return
       endif
       if ((sd%wcol.lt.1).or.(sd%in%gil%dim(1).lt.sd%wcol)) then
          call map_message(seve%e,rname,'W column does not exist')
          error = .true.
          return
       endif
       sd%islmv=.false.
       do%grid=.true.
       sd%nchan = sd%in%gil%dim(1)-3
       sd%mcol(1) = 4
       sd%mcol(2) = sd%in%gil%dim(1)
    else if (sd%in%gil%ndim.eq.3) then
       if ((sd%in%gil%xaxi.ne.1).or.(sd%in%gil%yaxi.ne.2).or.(sd%in%gil%faxi.ne.3)) then
          call map_message(seve%e,rname,'Input single dish '//trim(sd%in%file)//' is not an LMV cube')
          error = .true.
          return
       else
          sd%islmv=.true.
          do%grid=.false.
          sd%nchan = sd%in%gil%dim(3)
          sd%mcol(1) = 1
          sd%mcol(2) = sd%in%gil%dim(3)
       endif
    else
       call map_message(seve%e,rname,'Input single dish '//trim(sd%in%file)//' dimension is neither 2 (table) or 3 (cube)')
       error = .true.
       return
    endif
    call gdf_copy_header(sd%in,sd%ou,error)
    if (error) return
    if (do%grid) then
       call sic_parse_name(filename,name,ext,dir)
       if (dir.ne."") then
          filename = trim(dir)//'/'//trim(name)//'-short'
       else
          filename = trim(name)//'-short'
       endif
       call sic_parse_file(filename,' ','.lmv',sd%ou%file)
    else
       sd%ou%file = trim(sd%in%file)
       do iaxis = 1,2
          call uvshort_check_sd_new_axis(sd%in%gil%ref(iaxis),sd%in%gil%dim(iaxis),  &
                                         sd%ou%gil%ref(iaxis),sd%ou%gil%dim(iaxis),  &
                                         error)
          if (error)  return
       enddo ! iaxis
    endif
    !
    ! Get telescope diameter and beam
    call uvshort_check_diambeam(rname,sd%in,&
         user%sddiam,user%sdbeamin,&
         prog%sddiam,prog%sdbeamin,error)
    if (error) return
    if (do%grid) then
       ! Takes into account beam smoothing by gridding
       ! 9.0 assumes a Gaussian gridding kernel of 1/3 the single-dish natural HPBW
       prog%sdbeamou = prog%sdbeamin*sqrt(1.0+1.0/9.0)
    else
       prog%sdbeamou = prog%sdbeamin
    endif
    !
    ! Get the unit conversion factor to go to Jy/Beam
    if (user%sdunit.eq."*") then
       ! Searched for recognized units in header
       prog%sdunit = sd%in%char%unit
       unit = prog%sdunit
       call sic_lower(unit)
       if (unit.eq."jy/beam") then
          ! Right unit => Nothing to do!
          prog%sdfac = 1.0
       else if ((unit.eq."k (tmb)").or.(unit.eq."k (ta*)")) then
          prog%sdfac = 2.0*kbolt*1d26*pi*prog%sdbeamou**2/(4.d0*log(2.d0))*(sd%in%gil%freq/clight_mhz)**2
          if ((unit.eq."k (ta*)").and.(user%sdfac.eq.1.0)) then
             call map_message(seve%e,rname,'Unit is K (Ta*) and not K (Tmb)')
             call map_message(seve%e,rname,&
                  'Please set the unit conversion factor from K (Ta*) to K (Tmb) into the sdfac factor')
             error = .true.
             return
          endif
       else
          call map_message(seve%e,rname,'Unknown file unit: '//sd%in%char%unit)
          call map_message(seve%e,rname,&
               'Convert to K (Tmb), or Jy/Beam or enforce the right unit in input')
          error = .true.
          return
       endif
    else
       ! User defined unit
       prog%sdunit = user%sdunit
       unit = prog%sdunit
       call sic_lower(unit)
       if (unit.eq."jy/beam") then
          prog%sdfac = 1.0
       else if (unit.eq."k") then
          prog%sdfac = 2.0*kbolt*1d26*pi*prog%sdbeamou**2/(4.d0*log(2.d0))*(sd%in%gil%freq/clight_mhz)**2
       else if ((unit.eq."k (tmb)").or.(unit.eq."k (ta*)")) then
          prog%sdfac = 2.0*kbolt*1d26*pi*prog%sdbeamou**2/(4.d0*log(2.d0))*(sd%in%gil%freq/clight_mhz)**2
          if ((unit.eq."k (ta*)").and.(user%sdfac.eq.1.0)) then
             call map_message(seve%e,rname,'Unit is K (Ta*) and not K (Tmb)')
             call map_message(seve%e,rname,&
                  'Please set the unit conversion factor from K (Ta*) to K (Tmb) into the sdfac factor')
             error = .true.
             return
          endif
       else
          call map_message(seve%e,rname,'Unknown input unit: '//user%sdunit)
          call map_message(seve%e,rname,' Only K or Jy/Beam is recognised')
          error = .true.
          return
       endif
    endif
    !
    ! Get gridding position tolerance
    prog%postol = prog%sdbeamin*user%postol   
  end subroutine uvshort_check_sd  
  !
  subroutine uvshort_check_sd_reproject(in,error)
    use gbl_message
    !-------------------------------------------------------------------
    ! Check if the spatial axes are well-formed, so that the data can
    ! be plunged into a power-of-two surset without resampling in the
    ! uvshort_sd_read_lmv subroutine. In practice this implies the
    ! reference should be at the center of a pixel. If not, propose to
    ! the user a reprojection with proper inputs.
    !-------------------------------------------------------------------
    type(gildas), intent(in)    :: in
    logical,      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='UV_SHORT'
    real(kind=8), parameter :: tole=1.d-2  ! [pixel] Alignment tolerance
    integer(kind=index_length) :: ref1,ref2,dim1,dim2
    real(kind=8) :: conv1(3),conv2(3)
    logical :: good1,good2
    character(len=message_length) :: mess
    !
    ref1 = nint(in%gil%ref(1))
    ref2 = nint(in%gil%ref(2))
    good1 = abs(in%gil%ref(1)-ref1).lt.tole
    good2 = abs(in%gil%ref(2)-ref2).lt.tole
    if (good1 .and. good2)  return   ! Below the tolerance => leave
    !
    call map_message(seve%e,rname,  'The reference pixel of the SD map ('//  &
      trim(in%file)//') must be at the center of a pixel.')
    !
    write(mess,'(3(A,F0.2))')  &
      'Current center is at (',in%gil%ref(1),',',in%gil%ref(2),') (pixel unit)'
    call map_message(seve%e,rname,mess)
    !
    call map_message(seve%e,rname,  &
      'Use the RUN REPROJECT task to reproject the SD map with everything unchanged except:')
    !
    if (good1) then
      dim1 = in%gil%dim(1)
      conv1(:) = 0.d0  ! Means unchanged
    else
      dim1 = in%gil%dim(1)+1  ! No loss of data at boundaries
      conv1(1) = ceiling(in%gil%ref(1))
      conv1(2) = in%gil%val(1)
      conv1(3) = in%gil%inc(1)
    endif
    !
    if (good2) then
      dim2 = in%gil%dim(2)
      conv2(:) = 0.d0  ! Means unchanged
    else
      dim2 = in%gil%dim(2)+1  ! No loss of data at boundaries
      conv2(1) = ceiling(in%gil%ref(2))
      conv2(2) = in%gil%val(2)
      conv2(3) = in%gil%inc(2)
    endif
    !
    write(mess,'(A,I0,1X,I0)')  &
      'Dimensions of output image: ',dim1,dim2
    call map_message(seve%e,rname,mess)
    !
    write(mess,'(A,3(1X,1PG25.18))')  &
      'First axis conversion formula: ',conv1(1),conv1(2),conv1(3)
    call map_message(seve%e,rname,mess)
    !
    write(mess,'(A,3(1X,1PG25.18))')  &
      'Second axis conversion formula: ',conv2(1),conv2(2),conv2(3)
    call map_message(seve%e,rname,mess)
    !
    error = .true.
    return
    !
  end subroutine uvshort_check_sd_reproject
  !
  subroutine uvshort_check_sd_new_axis(iref,inpix,oref,onpix,error)
    !-------------------------------------------------------------------
    ! Compute the new output axis from the input axis, so that:
    !  - the number of pixels is a power of 2,
    !  - the reference pixel is at the "middle" (npix/2+1) of the axis
    ! The input reference pixel must be at the middle of a pixel, but
    ! not necessarily the central one.
    !-------------------------------------------------------------------
    real(kind=8),               intent(in)    :: iref
    integer(kind=index_length), intent(in)    :: inpix
    real(kind=8),               intent(out)   :: oref
    integer(kind=index_length), intent(out)   :: onpix
    logical,                    intent(inout) :: error
    ! Local
    integer(kind=index_length) :: intref,nleft,nright,nmax
    !
    ! Nota: the algorithm below preserves ref and npix if they already
    ! meet the requirements.
    !
    intref = nint(iref)         ! Already checked: should be very near a pixel center
    nleft  = intref-1           ! Number of pixels to the left of iref (excluded)
    nright = inpix-intref+1     ! Number of pixels to the right of iref (included)
    nmax   = max(nleft,nright)  ! Largest one
    onpix  = 2**ceiling(log(real(nmax))/log(2.0))  ! Ceiling() troubles if nmax is already a power of 2?
    onpix  = onpix*2            ! As we considered only one half of the axis
    oref   = real(onpix/2+1,kind=8)
  end subroutine uvshort_check_sd_new_axis
  !
  subroutine uvshort_check_uv(rname,user,prog,do,uv,error)
    use image_def
    use gbl_message
    use gkernel_interfaces
    use mapping_interfaces
    use mapping_read, only: mosaic_getfields
    !------------------------------------------------------------------------
    ! Analysis user inputs
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_action_t), intent(inout) :: do
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=4) :: xoff,yoff,loff,moff,nvis,ncol
    real(kind=4), allocatable :: duv(:,:),offxy(:,:)
    character(len=filename_length) :: filename,name,ext,dir
    !
    call gildas_null(uv%in,type='UVT')
    call gildas_null(uv%ps,type='UVT')
    call gildas_null(uv%ou,type='UVT')
    !
    ! Does the .uvt corresponding file exist?
    filename  = trim(user%name)
    call sic_parse_file(filename,' ','.uvt',uv%in%file)
    ! Yes => Read the corresponding header
    call gdf_read_header(uv%in,error)
    if (error) return
    ! Create the associated uv table used to compute the beam
    call gdf_copy_header(uv%in,uv%inbeam,error)
    if (error) return
    filename = trim(user%name)//'-beam'
    call sic_parse_file(filename,' ','.uvt',uv%inbeam%file)
    ! Create the pseudo-visibility header
    call gdf_copy_header(uv%in,uv%ps,error)
    if (error) return
    filename  = trim(user%name)
    call sic_parse_name(filename,name,ext,dir)
    if (dir.ne."") then
       filename = trim(dir)//'/'//trim(name)//'-short'
    else
       filename = trim(name)//'-short'
    endif
    call sic_parse_file(filename,' ','.uvt',uv%ps%file)
    ! Create the merged header
    call gdf_copy_header(uv%in,uv%ou,error)
    if (error) return
    filename  = trim(user%name)
    call sic_parse_name(filename,name,ext,dir)
    if (dir.ne."") then
       filename = trim(dir)//'/'//trim(name)//'-merged'
    else
       filename = trim(name)//'-merged'
    endif
    call sic_parse_file(filename,' ','.uvt',uv%ou%file)
    ! Create the associated uv table used to compute the beam
    call gdf_copy_header(uv%ou,uv%oubeam,error)
    if (error) return
    filename = trim(filename)//'-beam'
    call sic_parse_file(filename,' ','.uvt',uv%oubeam%file)
    ! Is it a mosaic?
    ! Do we find phase offsets?
    loff = uv%in%gil%column_pointer(code_uvt_loff)
    moff = uv%in%gil%column_pointer(code_uvt_moff)
    if ((loff.ne.0).or.(moff.ne.0)) then
       ! Yes.
       if (moff.ne.loff+1) then
          call map_message(seve%e,rname,'Mosaic M column does not follow the L column')
          error = .true.
          return
       endif
       uv%in%blc(1:2) = [loff,0]
       uv%in%trc(1:2) = [moff,0]
       uv%ocol(1) = loff
       uv%ocol(2) = moff 
       uv%islm = .true.
       uv%ismos = .true.
    else
       ! No => Do we find pointing offsets?
       xoff = uv%in%gil%column_pointer(code_uvt_xoff)
       yoff = uv%in%gil%column_pointer(code_uvt_yoff)
       if ((xoff.ne.0).or.(yoff.ne.0)) then
          ! Yes.
          if (yoff.ne.xoff+1) then
             call map_message(seve%e,rname,'Mosaic Y column does not follow the X column')
             error = .true.
             return
          endif
          uv%in%blc(1:2) = [xoff,0]
          uv%in%trc(1:2) = [yoff,0]
          uv%ocol(1) = xoff
          uv%ocol(2) = yoff
          uv%islm = .false.
          uv%ismos = .true.
       else
          ! No
          uv%ismos = .false.
          uv%islm  = .true.  ! Programming convention to simplify things later on
          uv%ocol(1) = 0
          uv%ocol(2) = 0
       endif
    endif
    !
    ! Get field offsets
    if (uv%ismos) then
       ! Read the corresponding columns only
       ncol = 2
       nvis = uv%in%gil%nvisi
       allocate(duv(ncol,nvis),stat=ier)
       if (failed_allocate(rname,'Field columns',ier,error)) return
       call gdf_read_data(uv%in,duv,error)
       if (error) return
       ! Sort offsets into equivalence classes
       !   => nf: number of fields
       !   => offxy(2,nf): field offsets
       call mosaic_getfields(duv,ncol,nvis,1,2,uv%nfield,offxy)
       deallocate(duv)
       ! Keep memory of offset information
       uv%nfield = max(uv%nfield,1)
       allocate(uv%raoff(uv%nfield),uv%deoff(uv%nfield),stat=ier)
       if (failed_allocate(rname,'Field offsets',ier,error)) return
       uv%raoff(:) = offxy(1,:)
       uv%deoff(:) = offxy(2,:)
    else
       uv%nfield = 1
       allocate(uv%raoff(uv%nfield),uv%deoff(uv%nfield),stat=ier)
       if (failed_allocate(rname,'Field offsets',ier,error)) return
       uv%raoff = 0.0
       uv%deoff = 0.0
    endif
    !
    ! Get telescope diameter and beam
    call uvshort_check_diambeam(rname,uv%in,&
         user%ipdiam,user%ipbeam,&
         prog%ipdiam,prog%ipbeam,error)
    if (error) return
    !
    ! Multiply unit conversion factor with user multiplicative correction
    uv%sddatfac = user%sdfac*prog%sdfac
    !
    ! Initialize per-field automatic short-spacing weight state.  The
    ! prog%sdwei%user scalar stores the SDWEI$ input: zero means automatic,
    ! non-zero means a multiplicative correction to the automatic estimate.
    if (allocated(prog%sdwei%field))  deallocate(prog%sdwei%field)
    if (allocated(prog%sdwei%factor)) deallocate(prog%sdwei%factor)
    allocate(prog%sdwei%field(uv%nfield),prog%sdwei%factor(uv%nfield),stat=ier)
    if (failed_allocate(rname,'Field SD weight state',ier,error)) return
    prog%sdwei%field(:)  = 1.0
    prog%sdwei%factor(:) = 1.0
    prog%sdwei%min = 1.0
    prog%sdwei%med = 1.0
    prog%sdwei%max = 1.0
    uv%sdweifac = 1.0
    ! Get uv table weight column
    uv%wcol = (uv%in%gil%nchan+2)/3
    uv%wcol = uv%in%gil%fcol+3*uv%wcol-1
    !
    if (user%ipfac.ge.1e-7) then
       prog%ipfac = user%ipfac
    else
       call map_message(seve%e,rname,"Interferometer calibration factor cannot be zero or negative")
       error = .true.
       return
    endif
    !
    uv%ipdatfac = prog%ipfac
    !
  end subroutine uvshort_check_uv
  !
  subroutine uvshort_check_uvstep(rname,user,prog,error)
    use gbl_message
    !------------------------------------------------------------------------
    ! Analysis of uvstep
    !------------------------------------------------------------------------
    character(len=*),      intent(in)    :: rname
    type(uvshort_user_t),  intent(in)    :: user
    type(uvshort_prog_t),  intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    if (user%uvstep.eq.0) then
       prog%uvstep = 1.25*prog%ipdiam
    else if (user%uvstep.le.0) then
       call map_message(seve%e,rname,"UVSTEP cannot be negative")
       error = .true.
       return
    else if (user%uvstep.le.prog%uvtrunc) then
       call map_message(seve%e,rname,"UVSTEP cannot be smaller than the UV truncation Radius")
       error = .true.
       return
    else
       prog%uvstep = user%uvstep
    endif
    !
  end subroutine uvshort_check_uvstep
  !
  subroutine uvshort_check_diambeam(rname,head,userdiam,userbeam,progdiam,progbeam,error)
    use phys_const
    use image_def
    use gbl_message
    use mapping_primary
    !------------------------------------------------------------------------
    ! Analysis antenna diameter and associated beamwidth
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type(gildas),     intent(in)    :: head
    real(kind=4),     intent(in)    :: userdiam
    real(kind=4),     intent(in)    :: userbeam
    real(kind=4),     intent(inout) :: progdiam
    real(kind=4),     intent(inout) :: progbeam
    logical,          intent(inout) :: error
    !
    character(len=message_length) :: mess
    logical, parameter :: fromressection=.true.
    !
    ! Diameter
    if (userdiam.eq.0) then
       ! It should be automatically defined from the input file.
       if (head%gil%nteles.eq.1) then
          progdiam = head%gil%teles(1)%diam          
       else if(head%gil%nteles.eq.0) then
          write(mess,'(A,A)') 'No telescope section in ',trim(head%file)
          error = .true.
       else
          write(mess,'(A,A)') 'More than 1 telescope defined in ',trim(head%file)
          error = .true.
          return
       endif
       if (error) then
          call map_message(seve%e,rname,mess)
          return
       endif
    else
       ! User defined => No more checks...
       progdiam = userdiam
    endif
    !
    ! Beam
    if (userbeam.eq.0.0) then
       ! It should be automatically defined from the input file.
       progbeam = primary_beam(rname,head,fromressection)
    else
       progbeam = userbeam*rad_per_sec
    endif    
  end subroutine uvshort_check_diambeam
  !
  subroutine uvshort_check_spectral_consistency(rname,prog,uv,sd,error)
    use gbl_message
    !------------------------------------------------------------------------
    ! Check spectral axis consistency
    ! On purpose, return only when all checks are done
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(uvshort_sddata_t), intent(in)    :: sd
    logical,                intent(inout) :: error
    !
    real(kind=8) :: velo
    real(kind=8) :: freq
    character(len=message_length) :: mess
    !
    ! Number of channels
    if (uv%in%gil%nchan.ne.sd%nchan) then
       write(mess,'(A,I0,A,I0,A)') 'Inconsistent number of channels (UVT: ',uv%in%gil%nchan,', SD: ',sd%nchan,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
    ! Velocity resolution
    if (abs(uv%in%gil%vres-sd%in%gil%vres).gt.abs(uv%in%gil%vres*prog%spetol)) then
       write(mess,'(A,F0.8,A,F0.8,A)') 'Inconsitent velocity resolution (UVT: ',uv%in%gil%vres,', SD: ',sd%in%gil%vres,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
    ! Frequency resolution
    if (abs(uv%in%gil%fres-sd%in%gil%fres).gt.abs(uv%in%gil%fres*prog%spetol)) then
       write(mess,'(A,F0.8,A,F0.8,A)') 'Inconsitent velocity resolution (UVT: ',uv%in%gil%fres,', SD: ',sd%in%gil%fres,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
    ! Systemic velocity and rest frequency
    if (sd%islmv) then
       velo = (uv%in%gil%ref(1) - sd%in%gil%ref(3))*sd%in%gil%vres + sd%in%gil%voff
       freq = (uv%in%gil%ref(1) - sd%in%gil%ref(3))*sd%in%gil%fres + sd%in%gil%freq
    else
       velo = (uv%in%gil%ref(1) - sd%in%gil%ref(1) + 3)*sd%in%gil%vres + sd%in%gil%voff
       freq = (uv%in%gil%ref(1) - sd%in%gil%ref(1) + 3)*sd%in%gil%fres + sd%in%gil%freq
    endif
    if (abs(uv%in%gil%voff-velo).gt.abs(uv%in%gil%vres*prog%spetol)) then
       write(mess,'(A,F0.8,A,F0.8,A)') 'Inconsistent velocity axis (UVT: ',uv%in%gil%voff,', SD: ',velo,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
    if (abs(uv%in%gil%freq-freq).gt.abs(uv%in%gil%fres*prog%spetol)) then
       write(mess,'(A,F0.8,A,F0.8,A)') 'Inconsistent frequency axis (UVT: ',uv%in%gil%freq,', SD: ',freq,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
  end subroutine uvshort_check_spectral_consistency
  !
  subroutine uvshort_check_uvtrunc(rname,user,uv,sd,prog,do,error)
    use gbl_message
    !------------------------------------------------------------------------
    ! Check UV truncation radius
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_action_t), intent(inout) :: do
    logical,                intent(inout) :: error
    !
    real(kind=4), parameter :: tol=0.001
    !
    ! Zero or short-spacings?
    if (abs(prog%sddiam-prog%ipdiam).le.tol*prog%ipdiam) then
       do%zero = .true.
       prog%uvtrunc = 0
    else if (prog%sddiam.gt.prog%ipdiam) then
       do%zero = .false.
       if (user%uvtrunc.eq.0.0) then
          ! Automatic
          prog%uvtrunc = prog%sddiam-prog%ipdiam
       else
          ! User defined
          prog%uvtrunc = user%uvtrunc
       endif
    else  
       call map_message(seve%e,rname,'Single dish diameter smaller than interferometer diameter')
       error = .true.
       return
    endif
    !
  end subroutine uvshort_check_uvtrunc
  !
  subroutine uvshort_user_feedback(rname,user,prog,do,sd,uv,error)
    use phys_const
    use image_def
    use gbl_message
    use mapping_interfaces
    !------------------------------------------------------------------------
    ! User feedback
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_action_t), intent(in)    :: do
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_uvdata_t), intent(in)    :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: if
    character(len=message_length) :: mess,kind
    !
    ! Interferometric data
    call map_message(seve%r,rname,"---------------------------------------------------------------------------")
    write(mess,'(A,A)') 'Interferometer - Input         file: ',trim(uv%in%file)
    call map_message(seve%r,rname,mess)
!!$    write(mess,'(A,A)') '               - Input beam    file: ',trim(uv%inbeam%file)
!!$    call map_message(seve%r,rname,mess)
    if (do%all.or.do%pseudo) then
       write(mess,'(A,A,x,A)') '               - Short-spacing file: ',trim(uv%ps%file)
       call map_message(seve%r,rname,mess)
    endif
    if (do%all.or.do%merge) then
       write(mess,'(A,A,x,A)') '               - Merged        file: ',trim(uv%ou%file)
       call map_message(seve%r,rname,mess)
!!$       write(mess,'(A,A,x,A)') '               - Merged beam   file: ',trim(uv%oubeam%file)
!!$       call map_message(seve%r,rname,mess)
    endif
    call map_message(seve%r,rname,"")
    ! Mosaic or single-field
    if (uv%islm) then
       write(mess,'(I0,A,I0,A,I0,A)') &
            uv%nfield,'-field mosaic with phase offset columns at (Lcol,Mcol) = (',uv%ocol(1),',',uv%ocol(2),')'
    else
       write(mess,'(I0,A,I0,A,I0,A)') &
            uv%nfield,'-field mosaic with pointing offset columns at (Xcol,Ycol) = (',uv%ocol(1),',',uv%ocol(2),')'
    endif
    call map_message(seve%r,rname,mess)
    do if = 1,uv%nfield
       write(mess,'(A,f8.2,a,F8.2,A)') ' &
            [',uv%raoff(if)*sec_per_rad,',',uv%deoff(if)*sec_per_rad,'] '
       call map_message(seve%r,rname,mess)
    enddo ! if
    call map_message(seve%r,rname,"")
    ! Frequency, diameter, and HPBW
    write(mess,'(A30,F11.6,A)') 'Observed frequency ',uv%in%gil%freq/1d3,' GHz'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Diameter ',prog%ipdiam,' m'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Half primary beam width ',prog%ipbeam*sec_per_rad,'"'
    call map_message(seve%r,rname,mess)
    !
    ! Single dish data
    call map_message(seve%r,rname,"---------------------------------------------------------------------------")
    if (sd%islmv) then
       kind = 'LMV'
    else
       kind = 'TAB'
    endif
    write(mess,'(A,A,x,A,A,A)') 'Single dish - Input  file: ',trim(sd%in%file),'(',trim(kind),')'
    call map_message(seve%r,rname,mess)
    if (do%all.or.do%grid) then
       write(mess,'(A,A,x,A)') '            - Output file: ',trim(sd%ou%file),'(LMV)'
       call map_message(seve%r,rname,mess)
    endif
    call map_message(seve%r,rname,"")
    ! Frequency, diameter, and HPBW
    write(mess,'(A30,F11.6,A)') 'Observed frequency ',sd%in%gil%freq/1d3,' GHz'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Diameter ',prog%sddiam,' m'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Half primary beam width (LMV)',prog%sdbeamou*sec_per_rad,'"'
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"")
    write(mess,'(A30,F6.1)') 'Interferometer Data factor ',uv%ipdatfac
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"")
    write(mess,'(A30,F6.1,A)') 'Single Dish Data conversion factor ',prog%sdfac,' (from '//trim(prog%sdunit)//' to Jy/Beam)'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1)') 'Single Dish Data user factor ',user%sdfac
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Single Dish Data final factor ',uv%sddatfac,' (= conversion * user)'
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"")
    write(mess,'(A30,F6.1,A)') 'Single Dish Weight user factor ',user%sdwei
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"")
    if (.not.sd%islmv) then
       write(mess,'(A30,F6.1,A,F7.4,A)') 'Gridding position tolerance ',prog%postol*sec_per_rad,'" (HPBW * ',user%postol,')'
       call map_message(seve%r,rname,mess)
    else
       write(mess,'(A30,I0,A,I0,A)') 'Image cube lmv with ',sd%in%gil%dim(1),' by ',sd%in%gil%dim(2),' pixels'
       call map_message(seve%i,rname,mess)
       write(mess,'(A30,F0.2,A,F0.2,A)') 'Pixel size is ',sd%in%gil%inc(1)*sec_per_rad,' x ', sd%in%gil%inc(2)*sec_per_rad,'"'
       call map_message(seve%i,rname,mess)
    endif
    call map_message(seve%r,rname,"---------------------------------------------------------------------------")
    call map_message(seve%r,rname,'Interferometer and Single-dish data have consistent spectral axes')
    call map_message(seve%r,rname,"")
    write(mess,'(A30,F7.2,A,F6.2,A)') 'UV truncation radius: ',prog%uvtrunc,' m (Useful range = [0.00,',prog%sddiam-prog%ipdiam,'])'
    call map_message(seve%r,rname,mess)
    write(mess,'(a,f8.3,a)') 'UV step: ',prog%uvstep,' m '
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"---------------------------------------------------------------------------")
    !
  end subroutine uvshort_user_feedback
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Routines to read or make single LMV cube
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_sd_get(rname,prog,uv,sd,error)
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Reads Single dish data into sd data structure
    ! If SD already in lmv format: reads file.
    ! Else: Create and fill lmv file from info in .tab file.
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(uvshort_sddata_t), intent(inout) :: sd
    logical,                intent(inout) :: error
    !
    if (sd%islmv) then
       call uvshort_sd_read_lmv(rname,sd%in,sd%ou,sd%we,error)
       if (error) return
       ! *** JP: Is the beam resolution section filled and up-to-date?
    else
       call uvshort_sd_create_lmv(rname,prog,uv,sd,error)
       if (error) return
       call gdf_create_image(sd%ou,error)
       if (error) return
       call gdf_write_data(sd%ou,sd%ou%r3d,error)
       if (error) return
       call gdf_close_image(sd%ou,error)
       if (error) return
    endif
  end subroutine uvshort_sd_get
  !
  subroutine uvshort_sd_read_lmv(rname,lmvin,lmvou,wei,error)
    use gbl_message
    use image_def
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Read an existing LMV data cube to be used to compute the short spacings
    !------------------------------------------------------------------------
    character(len=*),  intent(in)    :: rname
    type(gildas),      intent(inout) :: lmvin
    type(gildas),      intent(inout) :: lmvou
    type(gildas),      intent(inout) :: wei
    logical,           intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=4) :: ix,iy,if,idx,idy
    integer(kind=4) :: jx,jy
    real(kind=4) :: val
    !
    allocate(lmvin%r3d(lmvin%gil%dim(1),lmvin%gil%dim(2),lmvin%gil%dim(3)),stat=ier)
    if (failed_allocate(rname,'Input LMV cube',ier,error)) return
    call gdf_read_data(lmvin,lmvin%r3d,error)
    if (error) return
    allocate(lmvou%r3d(lmvou%gil%dim(1),lmvou%gil%dim(2),lmvou%gil%dim(3)),stat=ier)
    if (failed_allocate(rname,'Output LMV cube',ier,error)) return
    allocate(wei%r2d(lmvou%gil%dim(1),lmvou%gil%dim(2)),stat=ier)
    if (failed_allocate(rname,'Weight of LMV cube',ier,error)) return
    lmvou%r3d = 0.0
    ! Compute shifts in number of pixels (integer). The ref values have
    ! checked for (in), and made as (out), integers
    idx = nint(lmvou%gil%ref(1)-lmvin%gil%ref(1))
    idy = nint(lmvou%gil%ref(2)-lmvin%gil%ref(2))
    do if = 1, lmvin%gil%dim(3)
       do iy = 1, lmvin%gil%dim(2)
          jy = iy+idy
          do ix = 1, lmvin%gil%dim(1)
             val = lmvin%r3d(ix,iy,if)
             if (abs(val-lmvin%gil%bval).gt.lmvin%gil%eval) then
                jx = ix+idx
                lmvou%r3d(jx,jy,if) = val
             endif
          enddo ! ix
       enddo ! iy
    enddo ! if
    wei%r2d = 1.0
  end subroutine uvshort_sd_read_lmv
  !
  subroutine uvshort_sd_create_lmv(rname,prog,uv,sd,error)
    use phys_const
    use gbl_message
    use image_def
    use gkernel_interfaces
    use mapping_interfaces
    !------------------------------------------------------------------------
    ! Creates a "well behaved" Single Dish map from a Single Dish table
    ! for derivation of the short spacings of an interferometer mosaic
    !
    ! Use convolution by a fraction of the beam, and smooth extrapolation
    ! to zero beyond the mosaic edge
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(uvshort_sddata_t), intent(inout) :: sd
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nc,nd,nf,nx,ny
    integer(kind=4) :: ier
    real(kind=8) :: xconv(3),yconv(3)
    real(kind=4), allocatable :: sdwei(:)       ! weights table
    real(kind=4), allocatable :: vlmcube(:,:,:) ! work space for sdin gridded values
    !
    nc = sd%in%gil%dim(1)
    nd = sd%in%gil%dim(2)
    allocate(sd%in%r2d(nc,nd),stat=ier)
    if (failed_allocate(rname,'Input single-dish table',ier,error)) return
    call gdf_read_data(sd%in,sd%in%r2d,error)
    call uvshort_define_lmv(rname,prog,uv,nc,nd,sd,sdwei,nf,nx,ny,xconv,yconv,error)
    if (error) return
    !
    allocate(sd%ou%r3d(nx,ny,nf),stat=ier)
    if (failed_allocate(rname,'Output LMV cube',ier,error)) return
    allocate(vlmcube(nf,nx,ny),stat=ier)
    if (failed_allocate(rname,'Output VLM cube',ier,error)) return
    allocate(sd%we%r2d(nx,ny),stat=ier)
    if (failed_allocate(rname,'Output LM weights',ier,error)) return
    !
    call uvshort_sd_grid(rname,prog,nc,nd,nf,nx,ny,xconv,yconv,sdwei,sd,vlmcube)
    call map_message(seve%i,rname,'Done Single Dish table gridding')
    call uvshort_sd_apodize(rname,prog,nf,nx,ny,xconv,yconv,sd,vlmcube)
    call map_message(seve%i,rname,'Done Single Dish apodisation')
    call uvshort_sd_transpose(vlmcube,sd%ou%r3d,nf,nx*ny)
    call map_message(seve%i,rname,'Done transposition to lmv order')
    !
    deallocate(sdwei,vlmcube)
  end subroutine uvshort_sd_create_lmv
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_define_lmv(rname,prog,uv,nc,nd,sd,sdwei,nf,nx,ny,&
       xconv,yconv,error)
    use phys_const
    use gbl_message
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Creates the lmv file to be used to store single image
    !------------------------------------------------------------------------
    character(len=*),          intent(in)    :: rname
    type(uvshort_prog_t),      intent(in)    :: prog
    type(uvshort_uvdata_t),    intent(in)    :: uv
    integer(kind=4),           intent(in)    :: nc,nd
    integer(kind=4),           intent(out)   :: nf,nx,ny
    type(uvshort_sddata_t),    intent(inout) :: sd
    real(kind=4), allocatable, intent(inout) :: sdwei(:)
    real(kind=8),              intent(inout) :: xconv(3),yconv(3)
    logical,                   intent(inout) :: error
    !
    integer(kind=4) ::nxmore,nymore,i
    character(len=message_length) :: mess
    !
    call uvshort_reproject_offsets(rname,uv,nd,sd,error)
    if (error) return
    call uvshort_sort_by_increasing_y(rname,sd%in%r2d,nc,nd,sd%ycol,error)
    if (error) return
    call uvshort_get_weight_column(rname,sd%in%r2d,nc,nd,sdwei,sd%wcol,error)
    if (error) return
    !
    ! Field of view and pixel size
    call uvshort_find_size(sd%in%r2d,nc,nd,sd%xcol,sd%ycol,sdwei,sd%xmin,sd%xmax,sd%ymin,sd%ymax)
    xconv(3) = -prog%sdbeamin/4.0
    yconv(3) = +prog%sdbeamin/4.0
    !
    ! Number of pixels
    nx = 2 * max ( nint(abs(sd%xmax/xconv(3))+1),nint(abs(sd%xmin/xconv(3))+1) )
    ny = 2 * max ( nint(abs(sd%ymax/yconv(3))+1),nint(abs(sd%ymin/yconv(3))+1) )
    nxmore = nint(4*prog%sdbeamin/abs(xconv(3)))+1
    nymore = nint(4*prog%sdbeamin/abs(yconv(3)))+1
    nx = nx+2*nxmore
    ny = ny+2*nymore
    !
    ! Extend nx,ny to nearest power of two
    i = 32
    do while(i.lt.nx)
       i = i*2
    enddo
    nx = i
    i = 32
    do while(i.lt.ny)
       i = i*2
    enddo
    ny = i
    !
    ! Reference position for lmv cube header
    xconv(1) = nx/2+1
    xconv(2) = 0.0
    yconv(1) = ny/2+1
    yconv(2) = 0.0
    !
    ! User feedback
    write(mess,'(A,I0,A,I0,A)') 'Creating a cube with ',nx,' by ',ny,' pixels'
    call map_message(seve%i,rname,mess)
    write(mess,'(A,F8.3,A)') 'Pixel size: ',0.1*nint(yconv(3)*10*sec_per_rad),' arcsec'
    call map_message(seve%i,rname,mess)
    !
    ! Warn for big images
    if (nx.gt.512 .or. ny.gt.512) then
       if (nx.gt.8192 .or. ny.gt.8192) then
          call map_message(seve%e,rname,'More than 8192 pixels in X or Y')
          error = .true.
       else
          call map_message(seve%w,rname,'More than 512 pixels in X or Y')
       endif
       write(mess,*) 'Offset extrema are: ',sd%xmin,sd%xmax,sd%ymin,sd%ymax
       call map_message(seve%i,rname,mess)
       write(mess,*) 'Pixel sizes are',xconv(3),yconv(3)
       call map_message(seve%i,rname,mess)
       if (error) return
    endif
    !
    ! Number of channels
    nf = sd%mcol(2)-sd%mcol(1)+1
    write(mess,'(A,I0,A,I0,A,I0,A)') 'Creating ',nf,' channels from [',sd%mcol(1),',',sd%mcol(2),']'
    call map_message(seve%i,rname,mess)
    !
    ! Fill output cube header in LMV order
    call map_message(seve%i,rname,'Creating map file '//trim(sd%ou%file))
    sd%ou%gil%ndim = 3
    sd%ou%gil%dim(1) = nx
    sd%ou%gil%dim(2) = ny
    sd%ou%gil%dim(3) = nf
    sd%ou%gil%dim(4) = 1
    sd%ou%loca%size = nx*ny*nf
    sd%ou%gil%ref(3) = sd%in%gil%ref(1)-sd%mcol(1)+1
    sd%ou%gil%val(3) = sd%ou%gil%voff
    sd%ou%gil%inc(3) = sd%ou%gil%vres
    sd%ou%gil%convert(:,1) = xconv
    sd%ou%gil%convert(:,2) = yconv
    sd%ou%char%code(1) = sd%in%char%code(2)
    sd%ou%char%code(2) = sd%in%char%code(3)
    ! Patch a bug in Header transmission: the table has only 2 dimensions,so the 3rd axis is undefined
    if (len_trim(sd%ou%char%code(2)).eq.0) sd%ou%char%code(2)='DEC'
    sd%ou%char%code(3) = sd%in%char%code(1)
    sd%ou%gil%coor_words = 6*gdf_maxdims       ! not a table
    sd%ou%gil%extr_words = 0                   ! extrema not computed
    sd%ou%gil%xaxi = 1
    sd%ou%gil%yaxi = 2
    sd%ou%gil%faxi = 3
    sd%ou%gil%form = fmt_r4
    ! Take into account gridding kernel
    sd%ou%gil%reso_words = 3
    sd%ou%gil%majo = prog%sdbeamou
    sd%ou%gil%mino = prog%sdbeamou
    sd%ou%gil%posa = 0.0
  end subroutine uvshort_define_lmv
  !
  subroutine uvshort_reproject_offsets(rname,uv,nd,sd,error)
    use gbl_message
    use gkernel_types
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Reproject the single-dish table offsets to the UV table reference
    ! position. SD offsets are replaced in-place. SD header is also
    ! updated to ensure consistency.
    !-------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_uvdata_t), intent(in)    :: uv
    integer(kind=4),        intent(in)    :: nd
    type(uvshort_sddata_t), intent(inout) :: sd
    logical,                intent(inout) :: error
    !
    type(projection_t) :: uvproj,sdproj
    integer(kind=4) :: ioff
    real(kind=8) :: rxoff,ryoff,axoff,ayoff
    !
    ! Setup the projections
    call gwcs_projec(uv%in%gil%a0,uv%in%gil%d0,&
                     uv%in%gil%pang,uv%in%gil%ptyp,&
                     uvproj,error)
    if (error) return
    call gwcs_projec(sd%in%gil%a0,sd%in%gil%d0,&
                     sd%in%gil%pang,sd%in%gil%ptyp,&
                     sdproj,error)
    if (error) return
    !
    if (uv%in%gil%a0.eq.sd%in%gil%a0 .and.  &
        uv%in%gil%d0.eq.sd%in%gil%d0 .and.  &
        uv%in%gil%pang.eq.sd%in%gil%pang .and.  &
        uv%in%gil%ptyp.eq.sd%in%gil%ptyp)  return
    !
    call map_message(seve%i,rname,  &
      'Reprojecting single-dish offsets to UV table projection')
    !
    ! New header (for table AND lmv)
    sd%in%gil%a0 = uv%in%gil%a0
    sd%in%gil%d0 = uv%in%gil%d0
    sd%in%gil%pang = uv%in%gil%pang
    sd%in%gil%ptyp = uv%in%gil%ptyp
    !
    sd%ou%gil%a0 = uv%in%gil%a0
    sd%ou%gil%d0 = uv%in%gil%d0
    sd%ou%gil%pang = uv%in%gil%pang
    sd%ou%gil%ptyp = uv%in%gil%ptyp
    !
    ! New offsets
    do ioff=1,nd
       rxoff = sd%in%r2d(sd%xcol,ioff)
       ryoff = sd%in%r2d(sd%ycol,ioff)
       call rel_to_abs(sdproj,rxoff,ryoff,axoff,ayoff,1)
       call abs_to_rel(uvproj,axoff,ayoff,rxoff,ryoff,1)
       sd%in%r2d(sd%xcol,ioff) = rxoff
       sd%in%r2d(sd%ycol,ioff) = ryoff
    enddo
    !
  end subroutine uvshort_reproject_offsets
  !
  subroutine uvshort_sort_by_increasing_y(rname,data,nc,nd,iy,error)
    use gbl_message
    use gkernel_interfaces
    use mapping_interfaces
    !------------------------------------------------------------------------
    ! Output visi(nc,nd) will contain iy column values in increasing order
    ! In other words, data(iy,*) is the sorting key
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    integer(kind=4),  intent(in)    :: nc,nd
    integer(kind=4),  intent(in)    :: iy
    real(kind=4),     intent(inout) :: data(nc,nd)
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: i,ier
    real(kind=4), allocatable :: ws(:) ! Work space
    !
    do i=1,nd-1
       if (data(iy,i).gt.data(iy,i+1)) then
          call map_message(seve%i,rname,'Sorting input table')
          allocate(ws(nc),stat=ier)
          if (failed_allocate(rname,'Sorting work space',ier,error)) return
          ier = trione (data,nc,nd,iy,ws)
          if (ier.ne.1) then
             call map_message(seve%e,rname,'Insufficient sorting space')
             error = .true.
          endif
          deallocate(ws)
          return
       endif
    enddo
    call map_message(seve%i,rname,'Input table is sorted')
  end subroutine uvshort_sort_by_increasing_y
  !
  function trione(x,nd,n,ix,work)
    !------------------------------------------------------------------------
    ! sorting program that uses a quicksort algorithm.
    ! sort on one row
    !------------------------------------------------------------------------
    integer(kind=4), intent(in)    :: nd,n
    real(kind=4),    intent(inout) :: x(nd,n)   ! Array to be sorted
    integer(kind=4), intent(in)    :: ix        ! x(ix,*) is the sorting key
    real(kind=4),    intent(inout) :: work(nd)  ! Work space for exchange
    !
    integer(kind=4), parameter :: maxstack=1000
    integer(kind=4), parameter :: nstop=15
    integer(kind=4) :: trione
    integer(kind=4) :: i,j,k,l1,r1,l,r,m
    integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
    real(kind=4) :: key
    logical :: mgtl,lgtr,rgtm
    !
    trione = 1
    if (n.le.nstop) goto 50
    sp = 0
    sp = sp + 1
    lstack(sp) = 1
    rstack(sp) = n
    !
    ! Sort a subrecord off the stack
    ! set key = median of x(l),x(m),x(r)
    ! no! this is not reasonable,as systematic very inequal partitioning will
    ! occur in some cases (especially for nearly already sorted files)
    ! to fix this problem,i found (but i cannot prove it) that it is best to
    ! select the estimation of the median value from intermediate records. p.v.
    !
1   l = lstack(sp)
    r = rstack(sp)
    sp = sp - 1
    m = (l + r) / 2
    l1=(2*l+r)/3
    r1=(l+2*r)/3
    !
    mgtl = x(ix,m) .gt. x(ix,l)
    rgtm = x(ix,r) .gt. x(ix,m)
    !
    ! Algorithm to select the median key. the original one from mongo
    ! was completely wrong. p. valiron,24-jan-84 .
    !
    !       mgtl  rgtm  lgtr  mgtl.eqv.lgtr median_key
    !
    ! kl < km < kr  t t * *   km
    ! kl > km > kr  f f * *   km
    !
    ! kl < km > kr  t f f f   kr
    ! kl < km > kr  t f t t   kl
    !
    ! kl > km < kr  f t f t   kl
    ! kl > km < kr  f t t f   kr
    !
    if (mgtl .eqv. rgtm) then
       key = x(ix,m)
    else
       lgtr = x(ix,l) .gt. x(ix,r)
       if (mgtl .eqv. lgtr) then
          key = x(ix,l)
       else
          key = x(ix,r)
       endif
    endif
    i = l
    j = r
    !
    ! Find a big record on the left
    !
10  if (x(ix,i).ge.key) goto 11
    i = i + 1
    goto 10
11  continue
    !
    ! Find a small record on the right
    !
20  if (x(ix,j).le.key) goto 21
    j = j - 1
    goto 20
21  continue
    if (i.ge.j) goto 2
    !
    ! Exchange records
    !
    call r4tor4 (x(1,i),work,nd)
    call r4tor4 (x(1,j),x(1,i),nd)
    call r4tor4 (work,x(1,j),nd)
    i = i + 1
    j = j - 1
    goto 10
    !
    ! Subfile is partitioned into two halves,left .le. right
    ! push the two halves on the stack
    !
2   continue
    if (j-l+1 .gt. nstop) then
       sp = sp + 1
       if (sp.gt.maxstack) then
          write(6,*) 'E-UV_SHORT,Stack overflow ',sp
          trione = 0
          return
       endif
       lstack(sp) = l
       rstack(sp) = j
    endif
    if (r-j .gt. nstop) then
       sp = sp + 1
       if (sp.gt.maxstack) then
          write(6,*) 'E-UV_SHORT,Stack overflow ',sp
          trione = 0
          return
       endif
       lstack(sp) = j+1
       rstack(sp) = r
    endif
    !
    ! anything left to process?
    !
    if (sp.gt.0) goto 1
    !
50  continue
    !
    do 110 j = n-1,1,-1
       k = j
       do i = j+1,n
          if (x(ix,j).le.x(ix,i)) goto 121
          k = i
       enddo
121    continue
       if (k.eq.j) goto 110
       call r4tor4 (x(1,j),work,nd)
       do i = j+1,k
          call r4tor4 (x(1,i),x(1,i-1),nd)
       enddo
       call r4tor4 (work,x(1,k),nd)
110 continue
    !
  end function trione
  !
  subroutine uvshort_get_weight_column(rname,data,nc,nd,we,iw,error)
    !------------------------------------------------------------------------
    ! Fill in weights array from the input table
    !------------------------------------------------------------------------    
    character(len=*),          intent(in)    :: rname
    integer(kind=4),           intent(in)    :: nc
    integer(kind=4),           intent(in)    :: nd
    integer(kind=4),           intent(in)    :: iw          ! Weight column
    real(kind=4),              intent(in)    :: data(nc,nd)
    real(kind=4), allocatable, intent(inout) :: we(:)
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    allocate(we(nd),stat=ier)
    if (failed_allocate(rname,'Single-dish weights',ier,error)) return
    !
    if (iw.le.0 .or. iw.gt.nc) then
       ! Weight column does not exist...
       we(1:nd) = 1.0
    else
       ! Weight colum do exist
       we(1:nd) = data(iw,1:nd)
    endif
  end subroutine uvshort_get_weight_column
  !
  subroutine uvshort_find_size(x,nc,nd,ix,iy,we,xmin,xmax,ymin,ymax)
    !------------------------------------------------------------------------
    ! Find extrema xmin,xmax in ix column values
    !          and ymin,ymax in iy column values,
    ! in table x(nd,nd) for points where weight is not null
    ! taking in account that table x is ordered on iy column values.
    !------------------------------------------------------------------------
    integer(kind=4), intent(in)  :: nc,nd       ! Table size
    integer(kind=4), intent(in)  :: ix,iy       ! X and Y column pointers
    real(kind=4),    intent(in)  :: x(nc,nd)    ! Table data
    real(kind=4),    intent(in)  :: we(nd)      ! Weights
    real(kind=4),    intent(out) :: xmin,xmax,ymin,ymax  ! Min-Max
    !
    integer(kind=4) :: i,j
    !
    i = 1
    ! Loop to start after null weights measurements
    do while (we(i).eq.0)
       i = i+1
    enddo
    ! ymin is first y value with weight not null
    ymin = x(iy,i)
    ! initialize xmin and xmax for searching loop
    xmin = x(ix,i)
    xmax = x(ix,i)
    ! Loop on table lines to find xmin and xmax
    i = i+1
    do j=i,nd
       if (we(j).ne.0) then
          if (x(ix,j).lt.xmin) then
             xmin = x(ix,j)
          elseif (x(ix,j).gt.xmax) then
             xmax = x(ix,j)
          endif
       endif
    enddo
    ! Loop to find ymax = last y values with weight not null
    i = nd
    do while (we(i).eq.0)
       i = i-1
    enddo
    ymax = x(iy,i)
  end subroutine uvshort_find_size
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_sd_grid(rname,prog,nc,nd,nf,nx,ny,xconv,yconv,sdwei,sd,vlmcube)
    use mapping_interfaces
    !-----------------------------------------------------------------------
    ! Grid the SD data: Resample in space of the original spectra on a
    ! regular grid, using a convolution kernel
    !
    ! Compute gridding function: a small (1/3 of SD beam) gaussian
    ! Note: since xconv and yconv depends on SD beam, all gridding
    ! parameters do depend on SD beam value...
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    integer(kind=4),        intent(in)    :: nc,nd,nf,nx,ny
    real(kind=8),           intent(in)    :: xconv(3),yconv(3)
    real(kind=4),           intent(in)    :: sdwei(nd)
    type(uvshort_sddata_t), intent(inout) :: sd
    real(kind=4),           intent(inout) :: vlmcube(nf,nx,ny)
    !
    integer(kind=4) :: ctypx,ctypy,ix,iy,ier
    real(kind=4) :: smooth,xparm(10),yparm(10),support(2),cell(2)
    real(kind=4), allocatable :: xcoord(:),ycoord(:)
    !
    ! Define X and Y convolution functions
    smooth = prog%sdbeamin/3.0
    ctypx = 2
    ctypy = 2
    support(1) = 5*smooth
    support(2) = 5*smooth
    xparm(1) = support(1)/abs(xconv(3))
    yparm(1) = support(2)/abs(yconv(3))
    xparm(2) = smooth/(2*sqrt(log(2.0)))/abs(xconv(3))
    yparm(2) = smooth/(2*sqrt(log(2.0)))/abs(yconv(3))
    xparm(3) = 2
    yparm(3) = 2
    call convfn(ctypx,xparm,ubuff,ubias)
    call convfn(ctypy,yparm,vbuff,vbias)
    cell(1) = xconv(3)
    cell(2) = yconv(3)
    ! Grid coordinates
    allocate(xcoord(nx),ycoord(ny),stat=ier)
    if (failed_allocate(rname,'L or M axis',ier,error)) return
    xcoord(:) = (/(real((dble(ix)-sd%ou%gil%ref(1))*sd%ou%gil%inc(1)+sd%ou%gil%val(1)),ix=1,nx)/)
    ycoord(:) = (/(real((dble(iy)-sd%ou%gil%ref(2))*sd%ou%gil%inc(2)+sd%ou%gil%val(2)),iy=1,ny)/)
    ! Do the actual work
    call uvshort_sd_conv(nc,nd,sd%in%r2d,sd%xcol,sd%ycol,sd%mcol(1),&
         sdwei,sd%we%r2d,nf,nx,ny,vlmcube,xcoord,ycoord,support,cell)
    deallocate(xcoord,ycoord)
  end subroutine uvshort_sd_grid
  !
  subroutine uvshort_sd_conv(nd,np,visi,jx,jy,jo,we,gwe,&
      nf,nx,ny,map,mapx,mapy,sup,cell)
    !------------------------------------------------------------------------
    ! Convolution of 'map' by function defined by vbuff & vbias
    ! (via subroutine uvshort_convol, available by CONTAIN association).
    !------------------------------------------------------------------------
    integer(kind=4), intent(in)  :: np                ! number of visibilities
    integer(kind=4), intent(in)  :: nd                ! visibility size
    integer(kind=4), intent(in)  :: nf                ! number of channels
    integer(kind=4), intent(in)  :: nx,ny             ! map size
    integer(kind=4), intent(in)  :: jx,jy             ! x and y columns in visi
    real(kind=4),    intent(in)  :: we(np)            ! weights
    integer(kind=4), intent(in)  :: jo                ! offset for data in visi
    real(kind=4),    intent(in)  :: visi(nd,np)       ! values
    real(kind=4),    intent(out) :: gwe(nx,ny)        ! gridded weights
    real(kind=4),    intent(out) :: map(nf,nx,ny)     ! gridded values
    real(kind=4),    intent(in)  :: mapx(nx),mapy(ny) ! coordinates of grid
    real(kind=4),    intent(in)  :: sup(2)            ! support of convolving function in user units
    real(kind=4),    intent(in)  :: cell(2)           ! cell size in user units
    !
    integer(kind=4) :: ifirs,ilast ! range to be considered
    integer(kind=4) :: ix,iy,i
    real(kind=4) :: result,weight
    real(kind=4) :: u,v,du,dv,um,up,vm,vp
    !
    gwe = 0.0
    ! Loop on Y
    ifirs = 1
    do iy=1,ny
       v = mapy(iy)
       ! sup is the support of the gridding function
       vm = v-sup(2)
       vp = v+sup(2)
       ! Find points to be considered
       call uvshort_find_point(np,nd,jy,visi,vm,ifirs)
       ilast = ifirs
       call uvshort_find_point(np,nd,jy,visi,vp,ilast)
       ilast = ilast-1
       ! Initialize x column
       map(1:nf,1:nx,iy) = 0.0
       if (ilast.ge.ifirs) then
          ! Loop on x cells
          do ix=1,nx
             u = mapx(ix)
             um = u-sup(1)
             up = u+sup(1)
             weight = 0.0
             ! Loop on relevant data points
             do i=ifirs,ilast
                ! Test if X position is within the range to be
                ! considered
                if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
                   ! Compute convolving factor
                   du = (u-visi(jx,i))/cell(1)
                   dv = (v-visi(jy,i))/cell(2)
                   call uvshort_convol(du,dv,result)
                   if (result.ne.0.0) then
                      ! Do the convolution: map(pixel) = sum of
                      ! relevant values * convolving factor * weight
                      result = result*we(i)
                      weight = weight + result
                      map (1:nf,ix,iy) = map (1:nf,ix,iy) + visi((jo):(nf+jo-1),i)*result
                   endif
                endif
             enddo
             ! gwe is the sum of the (convolving factor * weight) ie
             ! the sum of the weighting factors applied to the data
             gwe(ix,iy) = weight
             ! Normalization (only in cells where some data exists)
             if (weight.ne.0) then
                map (1:nf,ix,iy) = map(1:nf,ix,iy)/weight
             endif
          enddo
       endif
    enddo
  end subroutine uvshort_sd_conv
  !
  subroutine uvshort_find_point(nv,nc,ic,xx,xlim,nlim)
    !-----------------------------------------------------------------------
    ! Optimized dichotomic search of nlim such as
    !   xx(ic,nlim-1) < xlim < xx(ic,nlim)
    ! It assumes that the input data is ordered, and that nlim is already
    ! preset so that xx(ic,nlim-1) < xlim
    !-----------------------------------------------------------------------
    integer(kind=4), intent(in)    :: nv       ! Number of visibilities
    integer(kind=4), intent(in)    :: nc       ! Size of a visibility
    integer(kind=4), intent(in)    :: ic       ! Column to be tested
    integer(kind=4), intent(inout) :: nlim
    real(kind=4),    intent(in)    :: xx(nc,nv),xlim
    !
    integer(kind=4) :: ninf,nsup,nmid
    !
    if (nlim.gt.nv) return
    ! Define limits of searching area in the table
    if (xx(ic,nlim).gt.xlim) then
       return
    elseif (xx(ic,nv).lt.xlim) then
       nlim = nv+1
       return
    endif
    ninf = nlim
    nsup = nv
    ! Dichotomic search for input data ordered
    do while(nsup.gt.ninf+1)
       ! Define middle of the searching area on the table
       nmid = (nsup + ninf)/2
       ! If it's not in the last part,it's in the first one...
       ! then defined new searching limits area
       if (xx(ic,nmid).lt.xlim) then
          ninf = nmid
       else
          nsup = nmid
       endif
    enddo
    ! Output
    nlim = nsup
  end subroutine uvshort_find_point
  !
  subroutine uvshort_convol(du,dv,resu)
    !-----------------------------------------------------------------------
    ! Compute convolving factor resu
    ! resu is the result of the multiplication of the convolution functions,
    ! for u and v axes,at point (du,dv)
    !
    ! Convolution function is defined in ubuff ubias and in vbuff & vbias,
    ! by CONTAIN association in the main program
    !-----------------------------------------------------------------------
    real(kind=4), intent(in)  :: du,dv
    real(kind=4), intent(out) :: resu
    !
    integer(kind=4) :: iu,iv
    !
    ! convolving functions values are tabulated every 1/100 cell
    iu = nint(100.0*du+ubias)
    iv = nint(100.0*dv+vbias)
    !
    ! Participation of u and v axes convolution functions
    resu = ubuff(iu)*vbuff(iv)
    if (resu.lt.1e-20) resu = 0.0
  end subroutine uvshort_convol
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_sd_apodize(rname,prog,nf,nx,ny,xconv,yconv,sd,vlmcube)
    use gbl_message
    use mapping_interfaces
    !-----------------------------------------------------------------------  
    ! Extrapolate to zero outside the convex hull of the mapped region
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    integer(kind=4),        intent(in)    :: nf,nx,ny
    real(kind=8),           intent(in)    :: xconv(3),yconv(3)
    type(uvshort_sddata_t), intent(inout) :: sd
    real(kind=4),           intent(inout) :: vlmcube(nf,nx,ny)
    !
    integer(kind=4) :: ctypx,ctypy,ix,iy,ier
    real(kind=4) :: xparm(10),yparm(10),support(2),cell(2),minwei
    real(kind=4), allocatable :: xcoord(:),ycoord(:)
    !
    ! Define X and Y convolution functions = SD primary beam
    ctypx = 2
    ctypy = 2
    support(1) = 3*prog%sdbeamin
    support(2) = 3*prog%sdbeamin
    xparm(1) = support(1)/abs(xconv(3))
    yparm(1) = support(2)/abs(yconv(3))
    xparm(2) = prog%sdbeamin/(2*sqrt(log(2.0)))/abs(xconv(3))
    yparm(2) = prog%sdbeamin/(2*sqrt(log(2.0)))/abs(yconv(3))
    xparm(3) = 2
    yparm(3) = 2
    call convfn(ctypx,xparm,ubuff,ubias)
    call convfn(ctypy,yparm,vbuff,vbias)
    cell(1) = xconv(3)
    cell(2) = yconv(3)
    ! Grid coordinates
    allocate(xcoord(nx),ycoord(ny),stat=ier)
    if (failed_allocate(rname,'L or M axis',ier,error)) return
    xcoord(:) = (/(real((dble(ix)-sd%ou%gil%ref(1))*sd%ou%gil%inc(1)+sd%ou%gil%val(1)),ix=1,nx)/)
    ycoord(:) = (/(real((dble(iy)-sd%ou%gil%ref(2))*sd%ou%gil%inc(2)+sd%ou%gil%val(2)),iy=1,ny)/)
    !
    call uvshort_sd_analyze_wei(rname,sd%we%r2d,nx,ny,(/sd%we%gil%bval,sd%we%gil%eval/),minwei,error)
    if (error) return
    ! Actual work...
    ! in: vlmcube, out: sd%ou%r3d
    call uvshort_sd_smooth(vlmcube,sd%we%r2d,nf,nx,ny,sd%ou%r3d,&
      xcoord,ycoord,support,cell)
    call map_message(seve%i,rname,'Done image smoothing')
    ! in: sd%ou%r3d, out: vlmcube
!!$ *** JP
!!$    call uvshort_sd_extrapolate(sd%xmin,sd%xmax,sd%ymin,sd%ymax,prog%postol,prog%sdbeam,&
!!$      nf,nx,ny,sd%ou%r3d,vlmcube,xcoord,ycoord,sd%we%r2d,minwei)
!!$ *** JP
    call uvshort_sd_extrapolate(sd%xmin,sd%xmax,sd%ymin,sd%ymax,prog%postol,prog%sdbeamin,&
      nf,nx,ny,sd%ou%r3d,vlmcube,xcoord,ycoord)
    call map_message(seve%i,rname,'Done image extrapolation')
    !
    deallocate(xcoord,ycoord)
  end subroutine uvshort_sd_apodize
  !
  subroutine uvshort_sd_analyze_wei(rname,weiimg,nx,ny,blank,minwei,error)
    use gkernel_interfaces
    use gbl_message
    !-----------------------------------------------------------------------
    ! Analyze a weight image and determine a lower weight cutoff.
    ! MINWEI is the low-percentile cutoff of the valid weight distribution.
    ! Blank, zero, and negative weights are ignored.
    !-----------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    integer(kind=4),  intent(in)    :: nx,ny
    real(kind=4),     intent(in)    :: blank(2)
    real(kind=4),     intent(in)    :: weiimg(nx,ny)
    real(kind=4),     intent(out)   :: minwei
    logical,          intent(inout) :: error
    !
    real(kind=4), parameter :: cutoff_fraction = 0.01
    !
    integer(kind=4), allocatable :: nind(:)
    real(kind=4), allocatable :: locwei(:)
    !
    integer(kind=4) :: nw,ier,ix,iy
    integer(kind=4) :: nvalid,irank
    real(kind=4) :: w
    !
    ! Default returned value in case of failure
    minwei = -1.0
    ! Allocate work arrays
    if (nx.gt.huge(nw)/ny) then
       ! => Overflows
       call map_message(seve%e,rname,'Weight image is too large')
       error = .true.
       return
    endif
    nw = nx*ny
    allocate(locwei(nw),nind(nw),stat=ier)
    if (failed_allocate(rname,'Sorted weight arrays',ier,error)) then
       if (allocated(locwei)) deallocate(locwei)
       if (allocated(nind))   deallocate(nind)
       return
    endif
    ! Compact list of usable weights: only strictly positive, non-blank
    ! weights are retained
    nvalid = 0
    do iy=1,ny
       do ix=1,nx
          w = weiimg(ix,iy)
          if (abs(w-blank(1)).lt.blank(2)) cycle
          if (w.le.0.0) cycle
          nvalid = nvalid + 1
          locwei(nvalid) = w
       enddo ! ix
    enddo ! iy
    if (nvalid.le.0) then
       call map_message(seve%e,rname,'No valid positive weights found')
       deallocate(locwei,nind)
       error = .true.
       return
    endif
    ! Sort the valid weights only.
    call gr4_trie(locwei,nind,nvalid,error)
    if (error) then
       call map_message(seve%e,rname,'Sorting of weights has failed')
       deallocate(locwei,nind)
       return
    endif
    ! Select the low percentile of the valid positive weights.
    !
    ! Since LOCWEI is sorted in increasing order, this is a direct rank
    ! selection.  With CUTOFF_FRACTION = 0.01, the selected rank is the
    ! first one strictly above the 1 percent cumulative fraction.
    irank = int(cutoff_fraction*real(nvalid,kind=4))+1
    if (irank.lt.1) irank = 1
    if (irank.gt.nvalid) irank = nvalid
    minwei = locwei(irank)
    !
    deallocate(locwei,nind)
  end subroutine uvshort_sd_analyze_wei
  !
  subroutine uvshort_sd_smooth(raw,we,nf,nx,ny,map,mapx,mapy,sup,cell)
    !-----------------------------------------------------------------------
    ! Smooth an input data cube raw in vlm along l and m by convolution
    ! by a gaussian function defined in vbuff & vbias via subroutine
    ! uvshort_convol (available by CONTAIN association)
    !-----------------------------------------------------------------------
    integer(kind=4), intent(in)  :: nf,nx,ny          ! map size
    real(kind=4),    intent(in)  :: we(nx,ny)         ! weights
    real(kind=4),    intent(in)  :: raw(nf,nx,ny)     ! raw map
    real(kind=4),    intent(out) :: map(nf,nx,ny)     ! smoothed map
    real(kind=4),    intent(in)  :: mapx(nx),mapy(ny) ! coordinates of grid
    real(kind=4),    intent(in)  :: sup(2)            ! support of convolving function in user units
    real(kind=4),    intent(in)  :: cell(2)           ! cell size in user units
    !
    integer(kind=4) :: yfirs,ylast ! range to be considered
    integer(kind=4) :: xfirs,xlast ! range to be considered
    integer(kind=4) :: ix,iy
    integer(kind=4) :: jx,jy       ! x coord, y coord location in raw
    real(kind=4) :: result,weight
    real(kind=4) :: u,v,du,dv,um,up,vm,vp,dx,dy
    !
    dx = abs(mapx(2)-mapx(1))
    dy = abs(mapy(2)-mapy(1))
    ! Loop on y rows
    do iy=1,ny
       ! Compute extrema positions on axe y
       ! of gaussian function centered on map(1:nf,ix,iy)
       v = mapy(iy)
       vm = v-sup(2)
       vp = v+sup(2)
       ! Compute extrema positions on axe y
       ! of relevant data points for map(1:nf,ix,iy) convolution
       yfirs = max(1,nint((iy-sup(2)/dy)))
       ylast = min(ny,nint((iy+sup(2)/dy)))
       ! Initialize x colum
       map(1:nf,1:nx,iy) = 0.0
       ! Loop on x cells
       if (yfirs.le.ylast) then
          do ix=1,nx
             ! Compute extrema positions on axe x,idem y
             u = mapx(ix)
             um = u-sup(1)
             up = u+sup(1)
             weight = 0.0
             xfirs = max(1,nint(ix-sup(1)/dx))
             xlast = min(nx,nint(ix+sup(1)/dx))
             ! Loop on relevant data points
             if (xfirs.le.xlast) then
                do jy=yfirs,ylast
                   dv = (v-mapy(jy))/cell(2)
                   do jx=xfirs,xlast
                      du = (u-mapx(jx))/cell(1)
                      ! Compute convolving factor
                      call uvshort_convol (du,dv,result)
                      if (result.ne.0.0) then
                         ! Do the convolution: map(pixel) = sum of
                         ! relevant values * convolving factor
                         weight = weight + result
                         map (1:nf,ix,iy) = map (1:nf,ix,iy) + raw(1:nf,jx,jy)*result
                      endif
                   enddo
                enddo
                ! Normalize weight only in cells where some data exists...
                if (weight.ne.0) then
                   map (1:nf,ix,iy) = map(1:nf,ix,iy)/weight
                endif
             endif
          enddo
       endif
    enddo
  end subroutine uvshort_sd_smooth
  !
  subroutine uvshort_sd_extrapolate(xmin,xmax,ymin,ymax,tole,beam,&
       nf,nx,ny,map,raw,mapx,mapy)
    !-----------------------------------------------------------------------
    ! Replace map edges of raw input data cube with smoothed values
    ! contains in mapx data cube
    !
    ! Map edges corresponding to the part of the map between
    ! max SD observations locations xmin,xmax,ymin,ymax, and map size nx,ny
    !-----------------------------------------------------------------------
    real(kind=4),    intent(in)  :: xmin,xmax,ymin,ymax,tole,beam
    integer(kind=4), intent(in)  :: nf,nx,ny
    real(kind=4),    intent(in)  :: mapx(nx),mapy(ny)
    real(kind=4),    intent(in)  :: map(nf,nx,ny)
    real(kind=4),    intent(out) :: raw(nf,nx,ny)
    !
    integer(kind=4) :: ix,iy
    real(kind=4) :: lobe,apod,disty,distx
    !
    ! Apodisation by a gaussian, twice as large than the SD beam
    lobe = log(2.0)/beam**2
    ! Loop on pixels
    do iy=1,ny
       ! Compute disty: distance between map size ny
       ! and ymin or ymax SD observations limits
       if (mapy(iy).le.ymin-tole) then
          disty = ymin-mapy(iy)
       elseif (mapy(iy).ge.ymax+tole) then
          disty = mapy(iy)-ymax
       else
          disty = 0.0
       endif
       do ix=1,nx
          ! Idem on X, compute distx
          if (mapx(ix).le.xmin-tole) then
             distx = xmin-mapx(ix)
          elseif (mapx(ix).ge.xmax+tole) then
             distx = mapx(ix)-xmax
          else
             distx = 0.0
          endif
          ! Apodisation factor
          apod = (distx**2+disty**2)*lobe
          ! 'raw' is replaced by something else only in two cases
          if (apod.gt.80) then
             ! Map edges
             raw(1:nf,ix,iy) = 0.0
          elseif (apod.ne.0.0) then
             ! Map edges
             apod = exp(-apod)
             raw(1:nf,ix,iy) = map(1:nf,ix,iy)*apod
          endif
       enddo ! ix
    enddo ! iy
    !
  end subroutine uvshort_sd_extrapolate
  !
  subroutine uvshort_sd_transpose(a,b,n,m)
    !-----------------------------------------------------------------------
    ! Output table "b" is table "a" transposed in line/column order
    !-----------------------------------------------------------------------
    integer(kind=4), intent(in)  :: n,m
    real(kind=4),    intent(in)  :: a(n,m)
    real(kind=4),    intent(out) :: b(m,n)
    !
    integer(kind=4) :: i,j
    !
    do i=1,m
       do j=1,n
          b(i,j) = a(j,i)
       enddo
    enddo
  end subroutine uvshort_sd_transpose
  !
  subroutine uvshort_sd_free(sd)
    !-------------------------------------------------------------------
    ! Clean up a 'uvshort_sddata_t' structure
    !-------------------------------------------------------------------
    type(uvshort_sddata_t), intent(inout) :: sd
    !
    if (associated(sd%in%r2d))  deallocate(sd%in%r2d)
    if (associated(sd%in%r3d))  deallocate(sd%in%r3d)
    if (associated(sd%we%r2d))  deallocate(sd%we%r2d)
    if (associated(sd%ou%r3d))  deallocate(sd%ou%r3d)
    !
  end subroutine uvshort_sd_free
  !
  subroutine uvshort_uv_free(uv)
    !-------------------------------------------------------------------
    ! Clean up a 'uvshort_uvdata_t' structure
    !-------------------------------------------------------------------
    type(uvshort_uvdata_t), intent(inout) :: uv
    !
    if (associated(uv%ps%r2d))  deallocate(uv%ps%r2d)
    if (associated(uv%inbeam%r2d))  deallocate(uv%inbeam%r2d)
    if (associated(uv%oubeam%r2d))  deallocate(uv%oubeam%r2d)
    !
  end subroutine uvshort_uv_free
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_pseudo(rname,prog,do,sd,uv,error)
    use gbl_message
    !$ use omp_lib
    !-----------------------------------------------------------------------
    !
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_action_t), intent(in)    :: do
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ifield
    type(uvshort_buffer_t) :: buf
    character(len=message_length) :: mess
    !
    !$ integer(kind=4) :: ompkind, dochunksize, ompcounter, threadid
    !
    call uvshort_pseudo_header(rname,prog,sd,uv)
    call map_message(seve%i,rname,'Done definition of pseudo-visibility header')
    !
    !$OMP PARALLEL &
    !$OMP DEFAULT(none) &
    !$OMP SHARED(rname,do,prog,uv,sd,error,ompkind,ompcounter,dochunksize) &
    !$OMP FIRSTPRIVATE(buf) &
    !$OMP PRIVATE(ifield,mess,threadid)
    !$ ompcounter = 0
    call uvshort_pseudo_buffer_allocate(rname,&
         sd%ou%gil%dim(1),sd%ou%gil%dim(2),sd%ou%gil%dim(3),&
         buf,error)
    if (.not.error) then
       call map_message(seve%i,rname,'Done buffer memory allocation')
       call uvshort_pseudo_get_sdlobe_uv(prog%sddiam,sd%ou,buf,error)
       if (.not.error) then
          call map_message(seve%i,rname,'Done single-dish lobe definition')
          !
          ! Loop on mosaic field
          !$OMP DO
          do ifield=1,uv%nfield
             if (error)  cycle
             !$ threadid = omp_get_thread_num();
             !$ if (threadid.eq.0) then
             !$    call OMP_GET_SCHEDULE(ompkind, dochunksize)
             !$    if (OMP_IN_PARALLEL()) then
             !$       ompcounter = ompcounter +1
             !$       write(mess,'(A,i0,A,i0)') 'Computing chunk: ',ompcounter,' / ',dochunksize
             !$    else
                      write(mess,'(A,i0,A,i0)') 'Computing field ',ifield,' / ',uv%nfield
             !$    end if
                   call map_message(seve%i,rname,mess)
             !$ end if          
             call uvshort_pseudo_get_iplobe(prog%ipdiam,prog%ipbeam,uv,sd%ou,ifield,buf)
             call uvshort_pseudo_compute_visi(do,sd,buf)
             call uvshort_pseudo_compute_wei(do,sd,buf)
             call uvshort_pseudo_fill_uvt(rname,prog%uvtrunc,sd%ou,ifield,buf,uv,error)
          enddo ! ifield
          !$OMP END DO
       endif
    endif
    call uvshort_pseudo_buffer_deallocate(rname,buf,error)
    !$OMP END PARALLEL
    if (error) return ! This is not allowed inside parallel session, moved out
    !
    ! Write pseudo-visibility table
    call gdf_create_image(uv%ps,error)
    if (error) return
    call gdf_write_data(uv%ps,uv%ps%r2d,error)
    if (error) return
    call gdf_close_image(uv%ps,error)
    if (error) return
    ! *** JP => Should clean up memory
  end subroutine uvshort_pseudo
  !
  subroutine uvshort_pseudo_header(rname,prog,sd,uv)
    use gbl_message
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    !
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_uvdata_t), intent(inout) :: uv
    !
    integer(kind=4) :: nvis,ncol,ier
    !
    call map_message(seve%i,rname,'Creating UV table '//trim(uv%ps%file))
    call uvshort_pseudo_count_visi(sd%ou,prog%uvtrunc,uv%nvisi_per_field)
    nvis = uv%nvisi_per_field*uv%nfield
    ! Initialize the header
    uv%ps%gil%nvisi = nvis
    uv%ps%gil%dim(2) = nvis
    uv%ps%blc(2) = 1
    uv%ps%trc(2) = nvis
    ncol = uv%ps%gil%dim(1)
    allocate(uv%ps%r2d(ncol,nvis),stat=ier)
    if (failed_allocate(rname,'pseudo visibility table',ier,error)) return
  end subroutine uvshort_pseudo_header
  !
  subroutine uvshort_pseudo_count_visi(lmv,uvmax,nvisi)
    use phys_const
    use image_def
    !-----------------------------------------------------------------------
    ! Compute number of visibilities nvisi sampled on a regular grid of
    ! steps dx, dy inside the disk of radius uvmax for one mosaic field
    ! -----------------------------------------------------------------------
    type(gildas),    intent(in)  :: lmv
    real(kind=4),    intent(in)  :: uvmax
    integer(kind=4), intent(out) :: nvisi
    !
    integer(kind=4) :: i,j,ii,jj,nx,ny
    real(kind=4) :: uu,vv,uvmax2
    real(kind=8) :: dx,dy
    !
    dx = clight_mhz/lmv%gil%freq/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dy = clight_mhz/lmv%gil%freq/(lmv%gil%inc(2)*lmv%gil%dim(2))
    uvmax2 = uvmax**2
    ! Count number of visilibity for one mosaic field
    nx = lmv%gil%dim(1)
    ny = lmv%gil%dim(2)
    nvisi = 0
    do j = 1,ny
       jj = mod(j-1+ny/2,ny)-ny/2
       vv = jj*dy
       do i = 1,nx/2
          ii = mod(i-1+nx/2,nx)-nx/2
          uu = ii*dx
          if (uu*uu+vv*vv.le.uvmax2) then
             nvisi = nvisi + 1
          endif
       enddo ! i
    enddo ! j
  end subroutine uvshort_pseudo_count_visi
  !
  subroutine uvshort_pseudo_buffer_allocate(rname,nx,ny,nf,buf,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    !
    !-----------------------------------------------------------------------
    character(len=*),           intent(in)    :: rname
    integer(kind=index_length), intent(in)    :: nx,ny,nf
    type(uvshort_buffer_t),     intent(inout) :: buf
    logical,                    intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    allocate(buf%xy(2,nf),stat=ier)
    if (failed_allocate(rname,'phase shift memory',ier,error)) return
    allocate(buf%sdlobe_uv(nx,ny),stat=ier)
    if (failed_allocate(rname,'single dish beam',ier,error)) return
    allocate(buf%iplobe_uv(nx,ny),stat=ier)
    if (failed_allocate(rname,'interferometer primary beam',ier,error)) return
    allocate(buf%iplobe_lm(nx,ny),stat=ier)
    if (failed_allocate(rname,'interferometer primary beam',ier,error)) return
    allocate(buf%visi(nx,ny,nf),stat=ier)
    if (failed_allocate(rname,'work space',ier,error)) return
    allocate(buf%uvwei(nx,ny),stat=ier)
    if (failed_allocate(rname,'uv weights',ier,error)) return
    allocate(buf%fftws(2*max(nx,ny)),stat=ier)
    if (failed_allocate(rname,'FFT work space',ier,error)) return
    ! Successful allocation
    buf%nx = nx
    buf%ny = ny
    buf%nf = nf
    buf%ndim = 2
    buf%dim(1) = nx
    buf%dim(2) = ny
  end subroutine uvshort_pseudo_buffer_allocate
  !
  subroutine uvshort_pseudo_buffer_deallocate(rname,buf,error)
    use gkernel_interfaces
    use gbl_message
    !-----------------------------------------------------------------------
    ! 
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_buffer_t), intent(inout) :: buf
    logical,                intent(inout) :: error
    !
    buf%nx = 0
    buf%ny = 0
    buf%nf = 0
    buf%ndim = 0
    buf%dim(1) = 0
    buf%dim(2) = 0
    !
    if (allocated(buf%xy)) deallocate(buf%xy)
    if (allocated(buf%sdlobe_uv)) deallocate(buf%sdlobe_uv)
    if (allocated(buf%iplobe_uv)) deallocate(buf%iplobe_uv)
    if (allocated(buf%iplobe_lm)) deallocate(buf%iplobe_lm)
    if (allocated(buf%visi)) deallocate(buf%visi)
    if (allocated(buf%uvwei)) deallocate(buf%uvwei)
    if (allocated(buf%fftws)) deallocate(buf%fftws)
  end subroutine uvshort_pseudo_buffer_deallocate
  !
  subroutine uvshort_pseudo_get_sdlobe_uv(diam,lmv,buf,error)
    use gbl_message
    use phys_const
    use image_def
    !-----------------------------------------------------------------------
    ! Compute the single-dish beam directly in the uv plane, i.e., a
    ! Gaussian truncated at dish size
    !-----------------------------------------------------------------------
    real(kind=4),           intent(in)    :: diam
    type(gildas),           intent(in)    :: lmv
    type(uvshort_buffer_t), intent(inout) :: buf
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='UV_SHORT'
    integer(kind=4) :: i,j,ii,jj,nx,ny
    real(kind=4) :: a,b,xx,yy
    real(kind=4) :: beam
    real(kind=8) :: dx,dy
    !
    ! Sanity check
    if (lmv%gil%majo.le.0. .or.  &
        lmv%gil%majo.ne.lmv%gil%majo) then  ! 0 or NaN
      ! ZZZ Shouldn't we use the telescope diameter as fallback (as other
      ! ZZZ parts of the code)? See where the function primary_beam() is
      ! ZZZ used.
      call map_message(seve%e,rname,'Single dish beam is not defined')
      error = .true.
      return
    endif
    !
    ! Equivalent beam area in square pixels
    beam = lmv%gil%majo ! *** JP is it what we actually want?
    dx = clight_mhz/lmv%gil%freq/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dy = clight_mhz/lmv%gil%freq/(lmv%gil%inc(2)*lmv%gil%dim(2))
    a = abs(4*alog(2.)/pi/beam**2*lmv%gil%inc(2)*lmv%gil%inc(1))
    b = (pi*beam/2/clight_mhz*lmv%gil%freq)**2/alog(2.)
! *** JP
!    print *,'sdlobe',beam,a,b
!    print *,'sdlobe: freq,dx,dy',lmv%gil%freq,dx,dy
! *** JP
    ! Loop on pixels
    nx = buf%nx
    ny = buf%ny
    do j = 1,ny
       ! Loop on Y, pixels locations on Fourier plane
       jj = mod(j-1+ny/2,ny)-ny/2
       yy = ( jj*dy )**2
       do i = 1,nx
          ! Loop on X, pixels locations on Fourier plane
          ii = mod(i-1+nx/2,nx)-nx/2
          xx = ( ii*dx )**2
          ! Truncation of the gaussian at diam
          if (xx+yy.le.diam**2) then
             buf%sdlobe_uv(i,j) = exp(b*(xx+yy))*a
          else
             buf%sdlobe_uv(i,j) = 0.0
          endif
       enddo ! i
    enddo ! j
  end subroutine uvshort_pseudo_get_sdlobe_uv
  !
  subroutine uvshort_pseudo_get_iplobe(diam,beam,uv,lmv,ifield,buf)
    use phys_const
    use image_def
    !-----------------------------------------------------------------------
    ! 1. Compute the interferometric primary beam directly in the uv plane, i.e.,
    !    Gaussian truncated at dish size
    ! 2. UV shift the beam at (uv%raoff(ifield),uv%deoff(ifield)) in the uv plane
    ! 3. And inverse Fourier Transform it to get the interferometric primary
    !    beam in the LM plane
    !----------------------------------------------------------------------
    real(kind=4),           intent(in)    :: diam
    real(kind=4),           intent(in)    :: beam
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(gildas),           intent(in)    :: lmv
    integer(kind=4),        intent(in)    :: ifield
    type(uvshort_buffer_t), intent(inout) :: buf
    !
    integer(kind=4) :: i,j,ii,jj,nx,ny
    real(kind=4) :: a,b,xx,yy
    real(kind=8) :: dx,dy
    !
    ! Equivalent beam area in square pixels...
    dx = clight_mhz/lmv%gil%freq/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dy = clight_mhz/lmv%gil%freq/(lmv%gil%inc(2)*lmv%gil%dim(2))
    a = abs(4*alog(2.)/pi/beam**2*lmv%gil%inc(2)*lmv%gil%inc(1))
    b = (pi*beam/2/clight_mhz*lmv%gil%freq)**2/alog(2.)
! *** JP
!    print *,'iplobe: beam,a,b',beam,a,b
!    print *,'iplobe: freq,dx,dy',lmv%gil%freq,dx,dy
! *** JP
    ! Loop on pixels
    nx = buf%nx
    ny = buf%ny
    do j = 1,ny
       ! Loop on Y, pixels locations on Fourier plane
       jj = mod(j-1+ny/2,ny)-ny/2
       yy = ( jj*dy )**2
       do i = 1,nx
          ! Loop on X, pixels locations on Fourier plane
          ii = mod(i-1+nx/2,nx)-nx/2
          xx = ( ii*dx )**2
          ! Truncation of the gaussian at diam
          if (xx+yy.le.diam**2) then
             buf%iplobe_uv(i,j) = cmplx(exp(-b*(xx+yy))*a)
          else
             buf%iplobe_uv(i,j) = cmplx(0.0)
          endif
       enddo ! i
    enddo ! j
    ! UV shift
    call uvshort_pseudo_uvshift_iplobe(&
         uv%raoff(ifield),uv%deoff(ifield),lmv,buf)
    ! Inverse Fourier Transform
    call fourt(buf%iplobe_uv,buf%dim,buf%ndim,1,1,buf%fftws)
    call cmtore(buf%iplobe_uv,buf%iplobe_lm,buf%nx,buf%ny)
    ! Normalize peak to 1
    buf%iplobe_lm(:,:) = buf%iplobe_lm/maxval(buf%iplobe_lm)
  end subroutine uvshort_pseudo_get_iplobe
  !
  subroutine uvshort_pseudo_uvshift_iplobe(offra,offde,lmv,buf)
    use phys_const
    use image_def
    !-----------------------------------------------------------------------
    ! Center in uv plane interferometer beam of a mosaic field
    ! at its right position (offra,offdec)
    !-----------------------------------------------------------------------
    real(kind=4),           intent(in)    :: offra,offde
    type(gildas),           intent(in)    :: lmv
    type(uvshort_buffer_t), intent(inout) :: buf
    !
    integer(kind=4) :: i,j,ii,jj,nx,ny
    real(kind=4) :: phi,sp,cp,xx,yy,re,im
    real(kind=8) :: du,dv
    !
    du = 1.d0/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dv = 1.d0/(lmv%gil%inc(2)*lmv%gil%dim(2))
    ! Loop on pixels
    nx = buf%nx
    ny = buf%ny
    do j = 1,ny
       ! Loop on Y,pixels locations on Fourier plane
       jj = mod(j-1+ny/2,ny)-ny/2
       yy = jj*dv
       do i = 1,nx
          ! Loop on X,pixels locations on Fourier plane
          ii = mod(i-1+nx/2,nx)-nx/2
          xx = ii*du
          !
          phi = -2.d0*pi*(offra*xx + offde*yy)
          cp = cos(phi)
          sp = sin(phi)
          !
          re = real(buf%iplobe_uv(i,j))*cp - imag(buf%iplobe_uv(i,j))*sp
          im = real(buf%iplobe_uv(i,j))*sp + imag(buf%iplobe_uv(i,j))*cp
          buf%iplobe_uv(i,j) = cmplx(re,im)
       enddo ! i
    enddo ! j
  end subroutine uvshort_pseudo_uvshift_iplobe
  !
  subroutine uvshort_pseudo_compute_visi(do,sd,buf)
    !-----------------------------------------------------------------------
    ! 1 - Computes the direct fourrier transform of the SD data onto the UV plane
    ! 2 - Deconvolves it from the SD beam.
    ! 3 - Convolves it with the Interferometer primary beam uv shifted to the
    ! current offset.
    !-----------------------------------------------------------------------
    type(uvshort_action_t), intent(in)    :: do
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_buffer_t), intent(inout) :: buf
    !
    integer(kind=4) :: if
    !
    ! Loop on frequencies
    do if=1,buf%nf
       ! DFT of SD data
       call retocm(sd%ou%r3d(:,:,if),buf%visi(:,:,if),buf%nx,buf%ny)
       call fourt(buf%visi(:,:,if),buf%dim,buf%ndim,1,1,buf%fftws)
       if (do%deconv_sd) then
          ! Deconvolve SD beam in uv plane
          buf%visi(:,:,if) = buf%visi(:,:,if)*buf%sdlobe_uv
       endif
       if (do%apply_ip) then
          ! Apply interferometer primary beam in image plane
          call fourt(buf%visi(:,:,if),buf%dim,buf%ndim,-1,1,buf%fftws)
          call uvshort_pseudo_multiply_by_iplobe_lm(buf%nx,buf%ny,buf%iplobe_lm,buf%visi(:,:,if))
          call fourt(buf%visi(:,:,if),buf%dim,buf%ndim,1,1,buf%fftws)
          buf%visi(:,:,if) = buf%visi(:,:,if)/(buf%nx*buf%ny)
       endif
    enddo ! if
  end subroutine uvshort_pseudo_compute_visi
  !
  subroutine uvshort_pseudo_multiply_by_iplobe_lm(nx,ny,f,z)
    !-----------------------------------------------------------------------
    ! z = z*f => used to multiply by interferometer primary beam in image plane
    !-----------------------------------------------------------------------
    integer(kind=4), intent(in)    :: nx,ny    ! Problem size
    real(kind=4),    intent(in)    :: f(nx,ny) ! Multiplication function
    complex(kind=4), intent(inout) :: z(nx,ny) ! Complex values
    !
    integer(kind=4) :: i,j,ii,jj
    !
    do j = 1,ny
       jj = mod(j+ny/2-1,ny)+1
       do i = 1,nx
          ii = mod(i+nx/2-1,nx)+1
          z(ii,jj) = z(ii,jj) * f(i,j)
       enddo
    enddo
  end subroutine uvshort_pseudo_multiply_by_iplobe_lm
  !
  subroutine uvshort_pseudo_compute_wei(do,sd,buf)
    !-----------------------------------------------------------------------
    ! Computes weights for single dish data in the UV plane
    !-----------------------------------------------------------------------
    type(uvshort_action_t), intent(in)    :: do
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_buffer_t), intent(inout) :: buf
    !
    if (do%wei.eq.'natural') then
       ! *** JP Something to be done here.
       buf%uvwei = 1.
    else
       buf%uvwei = 1.
    endif
    if (do%deconv_sd) then
       where (buf%sdlobe_uv.ne.0)
          buf%uvwei = 1.0/buf%sdlobe_uv**2
       else where
          buf%uvwei = 0.0
       end where
    endif
  end subroutine uvshort_pseudo_compute_wei
  !  
  subroutine uvshort_pseudo_fill_uvt(rname,uvmax,lmv,ifield,buf,uv,error)
    use phys_const
    use image_def
    use gbl_message
    use uv_shift, only: uv_shift_data
    !-----------------------------------------------------------------------    
    ! Tabulate the visibilities
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    real(kind=4),           intent(in)    :: uvmax
    type(gildas),           intent(in)    :: lmv
    integer(kind=4),        intent(in)    :: ifield
    type(uvshort_buffer_t), intent(inout) :: buf
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: i,j,k,kk,ii,jj,kvis,kstart,if
    integer(kind=4) :: nc,nv,nf,nx,ny,ifirst,ilast,mv
    integer(kind=4) :: gdate
    real(kind=4) :: sddatfac,sdweifac,offra,offde
    real(kind=4) :: uu,vv,weisum,we,duv,uvmax2
    real(kind=8) :: dx,dy,freq
    real(kind=4) :: cs(2)
    !
    dx = clight_mhz/lmv%gil%freq/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dy = clight_mhz/lmv%gil%freq/(lmv%gil%inc(2)*lmv%gil%dim(2))
    uvmax2 = uvmax**2
    !
    sddatfac = uv%sddatfac
    sdweifac = 1/(sddatfac**2) ! *** JP probably could be done before...
    !
    call sic_gagdate(gdate)
    !
    nc = uv%ps%gil%dim(1)
    nv = uv%ps%gil%dim(2)
    nf = buf%nf
    nx = buf%nx
    ny = buf%ny
    !
    ! Loop on pixels of the visibility map
    kstart = (ifield-1)*uv%nvisi_per_field
    kvis = kstart
    weisum = 0.0
    do j = 1,ny
       jj = mod(j-1+ny/2,ny)-ny/2
       vv = jj*dy
       do i = 1,nx/2
          ii = mod(i-1+nx/2,nx)-nx/2
          uu = ii*dx
          duv = uu**2+vv**2
          ! Keep only points inside circle defined by uvmax
          if (duv.le.uvmax2) then
             kvis = kvis + 1
             if (kvis.gt.nv) then
                call map_message(seve%e,rname,'Try to write outside space allocated for short-spacing table')
                error = .true.
                return
             endif
             uv%ps%r2d(1,kvis) = uu
             uv%ps%r2d(2,kvis) = vv
             uv%ps%r2d(3,kvis) = 0
             uv%ps%r2d(4,kvis) = gdate   ! Current date
             uv%ps%r2d(5,kvis) = 0
             uv%ps%r2d(6:7,kvis) = -1.0  ! Convention: Antenna # -1 for Short spacings
             kk = 7
             ! Weight
             we = buf%uvwei(i,j)*sdweifac
             if (i.eq.1 .and. j.ne.1) then
                we = we*0.5
             endif
!!$             if (we.lt.0) we = -we   ! *** JP
!!$             ! u=0 v=0 point
!!$             if (duv.eq.0) k00 = kvis
             ! Extract visibilities
             do k=1,nf
                uv%ps%r2d(kk+1,kvis) = real(buf%visi(i,j,k))*sddatfac
                uv%ps%r2d(kk+2,kvis) = imag(buf%visi(i,j,k))*sddatfac
                uv%ps%r2d(kk+3,kvis) = we
                kk = kk + 3
             enddo
             weisum = weisum+we
          endif
       enddo ! i
    enddo ! j
    ! Sanity check
    if ((kvis-kstart).ne.uv%nvisi_per_field) then
       call map_message(seve%e,rname,'Inconsistent number of visibilities')
       error = .true.
       return
    endif
    ifirst = kstart+1
    ilast = kvis
    mv = ilast-ifirst+1
!!$    ! Normalize the weights *** JP ***
!!$    if (weisum.ne.0.) then
!!$       weisum = 1/weisum
!!$       do i=1,nvis
!!$          do k=1,nf
!!$             uv%ps%r2d(7+k*3,i) = uv%ps%r2d(7+k*3,i)*weisum
!!$          enddo ! k
!!$       enddo ! i 
!!$    endif
    !
    if (uv%ismos) then
       offra = uv%raoff(ifield)
       offde = uv%deoff(ifield)
       if (uv%islm) then
          ! Unshift phase center to current pointing center
          ! => Hence the minus sign when computing buf%xy
          cs = [1.0,0.0] ! cos/sin of rotation
                         ! Rotation has already been taken care of before => 1.0,0.0
          do if=1,buf%nf
             freq = gdf_uv_frequency(uv%ps,dble(if))
             buf%xy(1,if) = - freq * f_to_k * offra
             buf%xy(2,if) = - freq * f_to_k * offde
          enddo
          ! Initialize the loff & moff columns to 0 (no shift yet!)
          uv%ps%r2d(uv%ocol(1),ifirst:ilast) = 0
          uv%ps%r2d(uv%ocol(2),ifirst:ilast) = 0
          ! Then shift the UV data set
          call uv_shift_data(uv%ps,nc,mv,uv%ps%r2d(:,ifirst:ilast),&
               cs,buf%nf,buf%xy)
          ! And only ultimately put the final loff & moff values
       endif
       uv%ps%r2d(uv%ocol(1),ifirst:ilast) = offra
       uv%ps%r2d(uv%ocol(2),ifirst:ilast) = offde
    endif
  end subroutine uvshort_pseudo_fill_uvt
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_merge(rname,prog,uv,error)
    use gbl_message
    use gkernel_interfaces
    use mapping_interfaces
    !-------------------------------------------------------------------
    ! Merge interferometric (uv%in) and short-spacing uv (uv%ps) tables
    !-------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    ! If uv%ps is not loaded load it here before it is used that is
    ! why it is the first thing done here
    if (.not.associated(uv%ps%r2d)) then
      ! Read all pseudo-visibilities at once from disk
      call gdf_read_header(uv%ps,error)
      if (error)  goto 10
      allocate(uv%ps%r2d(uv%ps%gil%dim(1),uv%ps%gil%dim(2)),stat=ier)
      if (failed_allocate(rname,'pseudo-visibility table',ier,error)) goto 10
      call gdf_read_data(uv%ps,uv%ps%r2d,error)
      if (error)  goto 10
      call gdf_close_image(uv%ps,error)
      if (error)  goto 10
    endif
    ! Header set and written to its final size
    uv%ou%gil%dim(2) = uv%in%gil%nvisi+uv%ps%gil%nvisi
    uv%ou%gil%nvisi  = uv%ou%gil%dim(2)
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    call gdf_create_image(uv%ou,error)
    if (error) return
    ! Prepare weight adjustment
    allocate(uv%inbeam%r2d(4,uv%in%gil%dim(2)),stat=ier)
    if (failed_allocate(rname,'Input weight table',ier,error)) return
    allocate(uv%oubeam%r2d(4,uv%ou%gil%dim(2)),stat=ier)
    if (failed_allocate(rname,'Output weight table',ier,error)) return
    !
    uv%ivisi = 0
    call map_message(seve%i,rname,'Copying interferometric data to output table')
    call uvshort_merge_copy_uvin_fromdisk(rname,uv,error)
    if (error)  goto 10
    call gag_message(seve%i,rname,'Appending short-spacing data to output table')
    
    call uvshort_merge_append_uvps(rname,prog,uv,error)
    if (error)  goto 10
    !
    ! Clean up
10  continue
    call gdf_close_image(uv%ou,error)
    if (error)  return
    !
  end subroutine uvshort_merge
  !
  subroutine uvshort_merge_copy_uvin_fromdisk(rname,uv,error)
    !-------------------------------------------------------------------
    ! Copy the uv%in table into the uv%ou table (both must be already
    ! GDF-opened). Input data is read from disk.
    !-------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nvisiperblock,ier,ivisi,jvisi,kvisi,ichan,icol
    real(kind=4), allocatable :: din(:,:)
    real(kind=4) :: uvdist
    !
    ! Copy input table by blocks of SPACE_GILDAS
    call gdf_nitems('SPACE_GILDAS',nvisiperblock,uv%in%gil%dim(1))
    nvisiperblock = min(nvisiperblock,uv%in%gil%nvisi)
    !
    allocate(din(uv%in%gil%dim(1),nvisiperblock),stat=ier)
    if (failed_allocate(rname,'UV reading buffer',ier,error))  return
    !
    uv%in%blc(:) = 0
    uv%in%trc(:) = 0
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    do ivisi=1,uv%in%gil%nvisi,nvisiperblock
       uv%in%blc(2) = ivisi
       uv%in%trc(2) = min(ivisi+nvisiperblock-1,uv%in%gil%nvisi)
       call gdf_read_data(uv%in,din,error)
       if (error)  return
       do jvisi=uv%in%blc(2),uv%in%trc(2)
          kvisi = jvisi-ivisi+1
          if (uv%ismos) then
             uv%inbeam%r2d(1:2,jvisi) = din(uv%ocol(1):uv%ocol(2),kvisi)
          else
             uv%inbeam%r2d(1:2,jvisi) = 0.0
          endif
          uvdist = sqrt(din(1,kvisi)**2+din(2,kvisi)**2)
          uv%inbeam%r2d(3,jvisi) = uvdist
          uv%inbeam%r2d(4,jvisi) = din(uv%wcol,kvisi)
          ! Multiplication by the interferometer calibration factor
          do ichan=1,uv%in%gil%nchan
             icol = 7+(ichan-1)*3+1
             din(icol,kvisi) = din(icol,kvisi)*uv%ipdatfac
             icol = icol+1
             din(icol,kvisi) = din(icol,kvisi)*uv%ipdatfac
             icol = icol+1
             din(icol,kvisi) = din(icol,kvisi)*(1/uv%ipdatfac**2)
          enddo
       enddo ! jvisi
       uv%ou%blc(2) = uv%ivisi+ivisi
       uv%ou%trc(2) = uv%ivisi+uv%in%trc(2)
       call gdf_write_data(uv%ou,din,error)
       if (error)  return
    enddo ! ivisi
    uv%in%blc(:) = 0
    uv%in%trc(:) = 0
    deallocate(din)
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    uv%ivisi = uv%ivisi+uv%in%gil%nvisi
    !
  end subroutine uvshort_merge_copy_uvin_fromdisk
  !
  subroutine uvshort_merge_append_uvps(rname,prog,uv,error)
    use phys_const
    use gbl_message
    use mapping_interfaces
    !-------------------------------------------------------------------
    ! Append the pseudo-visibility table to the output table. The
    ! pseudo-visibility table is already loaded in memory and the output
    ! table is already GDF-opened.
    ! -------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ivisi,jvisi,icol,ibin,nbin,ier
    integer(kind=4) :: ifield,ips,ips_first,ips_last,jps
    real(kind=4) :: uvdist,uvmin,uvmax,alpha,beta,pseudo_density,ip_density
    real(kind=4), allocatable :: psdens(:),ipdens(:)
    character(len=message_length) :: mess
    !
    uv%oubeam%r2d(:,1:uv%ivisi) = uv%inbeam%r2d(:,1:uv%ivisi)
    uvmax = maxval(uv%oubeam%r2d(3,1:uv%ivisi))
    jvisi = uv%ivisi
    do ivisi=1,uv%ps%gil%nvisi
       jvisi = jvisi+1
       if (uv%ismos) then
          uv%oubeam%r2d(1:2,jvisi) = uv%ps%r2d(uv%ocol(1):uv%ocol(2),ivisi)
       else
          uv%oubeam%r2d(1:2,jvisi) = 0.0
       endif
       uvdist = sqrt(uv%ps%r2d(1,ivisi)**2+uv%ps%r2d(2,ivisi)**2)
       uv%oubeam%r2d(3,jvisi) = uvdist
       uv%oubeam%r2d(4,jvisi) = uv%ps%r2d(uv%wcol,ivisi)
    enddo ! ivisi
    uv%oubeam%gil%dim(2) = jvisi
    !
    uvmax = maxval(uv%oubeam%r2d(3,1:jvisi))
    uvmin = minval(uv%oubeam%r2d(3,1:uv%ivisi))
    nbin = ceiling(uvmax/prog%uvstep)
    if (nbin.lt.2) then
       call map_message(seve%e,rname,'Not enough UV bins to compute short-spacing weight density')
       error = .true.
       return
    endif
    allocate(psdens(nbin),ipdens(nbin),stat=ier)
    if (failed_allocate(rname,'Field weight densities',ier,error))  return
    if (.not.allocated(prog%sdwei%field)) then
       allocate(prog%sdwei%field(uv%nfield),prog%sdwei%factor(uv%nfield),stat=ier)
       if (failed_allocate(rname,'Field SD weight state',ier,error))  return
    endif
    if (size(prog%sdwei%field).ne.uv%nfield) then
       call map_message(seve%e,rname,'Inconsistent field SD weight state size')
       error = .true.
       return
    endif
    alpha = (nbin-0.5)/uvmax
    beta = 0.5
    !
    do ifield=1,uv%nfield
       psdens = 0.0
       ipdens = 0.0
       !
       ! Interferometric density for this field.  The field offsets stored
       ! in uv%inbeam are the same columns that were previously classified
       ! by mosaic_getfields in uvshort_check_uv; no new tolerance matcher is
       ! introduced here.
       do ivisi=1,uv%ivisi
          if (.not.uvshort_visibility_in_field(uv,ivisi,ifield)) cycle
          call uvshort_weight_density_bin(rname,uv%oubeam%r2d(3,ivisi),alpha,beta,nbin,ibin,error)
          if (error) return
          ipdens(ibin) = ipdens(ibin)+uv%oubeam%r2d(4,ivisi)
       enddo ! ivisi
       !
       ! Pseudo-visibility density for this field.  Pseudo-visibilities are
       ! produced field by field, with uv%nvisi_per_field entries per field.
       ips_first = (ifield-1)*uv%nvisi_per_field+1
       ips_last  = ifield*uv%nvisi_per_field
       do ips=ips_first,ips_last
          jps = uv%ivisi+ips
          call uvshort_weight_density_bin(rname,uv%oubeam%r2d(3,jps),alpha,beta,nbin,ibin,error)
          if (error) return
          psdens(ibin) = psdens(ibin)+uv%oubeam%r2d(4,jps)
       enddo ! ips
       !
       psdens(1) = psdens(1)/(pi*prog%uvstep**2)
       ipdens(2:nbin) = ipdens(2:nbin)/(3.0*pi*prog%uvstep**2*uv%ipdatfac**2)
       pseudo_density = psdens(1)
       ip_density = ipdens(2)
       !
       if (uvshort_invalid_density(pseudo_density)) then
          write(mess,'(a,i0,a)') 'Invalid pseudo-visibility weight density for field ',ifield,'.'
          call map_message(seve%e,rname,mess)
          error = .true.
          return
       endif
       if (uvshort_invalid_density(ip_density)) then
          if (uvmin.ge.2*prog%uvstep) then
             write(mess,'(a,i0,a)') 'No matching between single-dish and interferometric visibilities for field ',ifield,'.'
             call map_message(seve%e,rname,mess)
             call map_message(seve%e,rname,'Increase UV step to make matching possible')
             write (mess,'(a,f8.3,a,f8.3)') 'UV step should be in the range ',uvmin/2.,':',uvmin
             call map_message(seve%e,rname,mess)
          else
             write(mess,'(a,i0,a)') 'Invalid interferometric weight density for field ',ifield,'.'
             call map_message(seve%e,rname,mess)
          endif
          error = .true.
          return
       endif
       !
       prog%sdwei%field(ifield) = ip_density/pseudo_density
       if (prog%sdwei%user.eq.0.0) then
          prog%sdwei%factor(ifield) = prog%sdwei%field(ifield)
       else
          prog%sdwei%factor(ifield) = prog%sdwei%user*prog%sdwei%field(ifield)
       endif
       !
       write(mess,'(a,i0,a,i0,a,1pe12.4,a,1pe12.4)') &
            'Field ',ifield,' / ',uv%nfield,': weight density pseudo=',pseudo_density, &
            ' interferometer=',ip_density
       call map_message(seve%i,rname,mess)
       write(mess,'(a,1pe12.4,a,1pe12.4,a,1pe12.4)') &
            'Weight factors: applied=',prog%sdwei%factor(ifield), &
            ' user=',prog%sdwei%user,' auto=',prog%sdwei%field(ifield)
       call map_message(seve%i,rname,mess)
    enddo ! ifield
    !
    prog%sdwei%min = minval(prog%sdwei%field(:))
    prog%sdwei%med = uvshort_median_real4(prog%sdwei%field)
    prog%sdwei%max = maxval(prog%sdwei%field(:))
    uv%sdweifac = uvshort_median_real4(prog%sdwei%factor)
    write(mess,'(a,1pe12.4,a,1pe12.4,a,1pe12.4)') &
         'Automatic SD weight summary: min=',prog%sdwei%min, &
         ' median=',prog%sdwei%med,' max=',prog%sdwei%max
    call map_message(seve%i,rname,mess)
    !
    do ifield=1,uv%nfield
       ips_first = (ifield-1)*uv%nvisi_per_field+1
       ips_last  = ifield*uv%nvisi_per_field
       do ivisi=ips_first,ips_last
          do icol=uv%ps%gil%fcol+2,uv%ps%gil%lcol,3
             uv%ps%r2d(icol,ivisi) = uv%ps%r2d(icol,ivisi)*prog%sdwei%factor(ifield)
          enddo ! icol
       enddo ! ivisi
    enddo ! ifield
    !
    ! Input table is entirely in memory => copy all at once
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    uv%ou%blc(2) = uv%ivisi+1
    uv%ou%trc(2) = uv%ivisi+uv%ps%gil%nvisi
    call gdf_write_data(uv%ou,uv%ps%r2d,error)
    if (error)  return
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    uv%ivisi = uv%ivisi+uv%ps%gil%nvisi
    !
  end subroutine uvshort_merge_append_uvps
  !
  logical function uvshort_visibility_in_field(uv,ivisi,ifield)
    !------------------------------------------------------------------------
    ! Tell whether a visibility belongs to a field, using the field columns
    ! already classified by mosaic_getfields.  This deliberately uses exact
    ! stored field values and introduces no new tolerance-based matcher.
    !------------------------------------------------------------------------
    type(uvshort_uvdata_t), intent(in) :: uv
    integer(kind=4),        intent(in) :: ivisi,ifield
    !
    if (.not.uv%ismos) then
       uvshort_visibility_in_field = .true.
    else
       uvshort_visibility_in_field = &
            uv%inbeam%r2d(1,ivisi).eq.uv%raoff(ifield) .and. &
            uv%inbeam%r2d(2,ivisi).eq.uv%deoff(ifield)
    endif
    !
  end function uvshort_visibility_in_field
  !
  subroutine uvshort_weight_density_bin(rname,uvdist,alpha,beta,nbin,ibin,error)
    use gbl_message
    !------------------------------------------------------------------------
    ! Existing bin-numbering logic factored out so the same computation can
    ! be applied independently to pseudo and interferometric densities.
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    real(kind=4),     intent(in)    :: uvdist,alpha,beta
    integer(kind=4),  intent(in)    :: nbin
    integer(kind=4),  intent(out)   :: ibin
    logical,          intent(inout) :: error
    !
    ibin = nint(uvdist*alpha+beta)
    if (ibin.eq.0) then
       ibin = 1
    else if ((ibin.lt.0).or.(ibin.gt.nbin)) then
       call map_message(seve%e,rname,'Problem when computing weight density')
       error = .true.
       return
    endif
    !
  end subroutine uvshort_weight_density_bin
  !
  logical function uvshort_invalid_density(value)
    !------------------------------------------------------------------------
    ! Invalid means not finite enough for safe division in this code path.
    ! The value.ne.value test catches NaNs without introducing dependencies.
    !------------------------------------------------------------------------
    real(kind=4), intent(in) :: value
    !
    uvshort_invalid_density = (value.ne.value).or.(value.le.0.0)
    !
  end function uvshort_invalid_density
  !
  real(kind=4) function uvshort_median_real4(values)
    !------------------------------------------------------------------------
    ! Small local median helper for the SD-weight summary only.
    !------------------------------------------------------------------------
    real(kind=4), intent(in) :: values(:)
    !
    real(kind=4), allocatable :: work(:)
    real(kind=4) :: tmp
    integer(kind=4) :: i,j,n,ier
    !
    n = size(values)
    if (n.le.0) then
       uvshort_median_real4 = 1.0
       return
    endif
    allocate(work(n),stat=ier)
    if (ier.ne.0) then
       uvshort_median_real4 = 1.0
       return
    endif
    work(:) = values(:)
    do i=2,n
       tmp = work(i)
       j = i-1
       do while (j.ge.1.and.work(j).gt.tmp)
          work(j+1) = work(j)
          j = j-1
       enddo
       work(j+1) = tmp
    enddo
    if (mod(n,2).eq.1) then
       uvshort_median_real4 = work((n+1)/2)
    else
       uvshort_median_real4 = 0.5*(work(n/2)+work(n/2+1))
    endif
    deallocate(work)
    !
  end function uvshort_median_real4
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_uvzero(rname,user,uvin,error)
    character(*),          intent(in)    :: rname
    type(uvshort_user_t),  intent(in)    :: user
    type(gildas),          intent(inout) :: uvin
    logical,               intent(inout) :: error
    !------------------------------------------------------------------------
    ! Does nothing anymore for the moment...
    !------------------------------------------------------------------------
!!$    type(projection_t) :: uv_proj,lm_proj  
!!$    real(8) :: alpha,delta,dx,dy
!!$    integer :: ix,iy,is,icol,ocol,jf
!!$    integer :: gdate,last,ixcol,iycol
!!$    real, allocatable :: zero_uvdata(:,:)
!!$    real, allocatable :: sddat%in%r2d(:,:)
!!$    real, allocatable :: spectrum(:)
!!$    real :: ws,dist,dmin,total_weight
!!$    !
!!$    ! We already have the reference UV table header here
!!$    ! Allocate some work space
!!$    !
!!$    call gwcs_projec(uvin%gil%a0,uvin%gil%d0,-uvin%gil%pang,uvin%gil%ptyp,uv_proj,error)
!!$    call sic_gagdate(gdate)
!!$    ! ...
!!$    last = uvin%gil%fcol + uvin%gil%natom * uvin%gil%nchan - 1
!!$    ixcol = last+1
!!$    iycol = last+2
!!$    !
!!$    if (sddat%islmv) then
!!$       ! Read LMV file
!!$       ! Input file is a lmv cube
!!$       call uvshort_sd_read_lmv(rname,user%sdin_name,lmv,sddat%ou%r3d,buf%imwei,error)
!!$       !
!!$       ! We can get the weight from the Noise in the map
!!$       weight = user%sdfac*max(sddat%ou%gil%rms,sddat%ou%gil%noise)
!!$       if (weight.ne.0.0) then
!!$          weight = 1d-6/weight**2
!!$          ! weight = user%sdwei * weight ! Is that useful ?...
!!$       else
!!$          call map_message(seve%w,rname,'No weight in LMV file')
!!$          weight = 1.0
!!$       endif
!!$       !
!!$       nc=sddat%ou%gil%dim(3)
!!$       call uvshort_consistency(rname,nc,uvin,lmv,user%postol,error)
!!$       if (error) return
!!$       !
!!$       allocate(zero_uvdata(uvin%gil%dim(1),nf),spectrum(nc),stat=ier)
!!$       if (ier.ne.0) then
!!$          call map_message(seve%e,rname,'Zero spacing Memory allocation failure')
!!$          error = .true.
!!$          return
!!$       endif
!!$       !
!!$       ! Extract appropriate directions from it: loop on fields
!!$       call gwcs_projec(sddat%ou%gil%a0,sddat%ou%gil%d0,-sddat%ou%gil%pang,sddat%ou%gil%ptyp,lm_proj,error)
!!$       do if=1,nf
!!$          call rel_to_abs(uv_proj,dble(raoff(if)),dble(deoff(if)),alpha,delta,1)
!!$          call abs_to_rel(lm_proj,alpha,delta,dx,dy,1)
!!$          ix = nint((dx-sddat%ou%gil%val(1))/sddat%ou%gil%inc(1)+sddat%ou%gil%ref(1))
!!$          iy = nint((dy-sddat%ou%gil%val(2))/sddat%ou%gil%inc(2)+sddat%ou%gil%ref(2))
!!$          if (ix.lt.1 .or. ix.gt.nx .or. iy.lt.1 .or. iy.gt.ny) then
!!$             write(mess,*) 'Field ',if,' is out of map ',ix,iy
!!$             call map_message(seve%e,rname,mess)
!!$             error = .true.
!!$             return
!!$          endif
!!$          !
!!$          ! Put it in place...
!!$          spectrum(:) = user%sdfac * sddat%ou%r3d(ix,iy,:) 
!!$          call spectrum_to_zero(nc,spectrum,zero_uvdata(:,if),gdate,weight)
!!$          zero_uvdata(ixcol,if) = raoff(if)
!!$          zero_uvdata(iycol,if) = deoff(if)        
!!$       enddo
!!$       !
!!$       total_weight = nf*weight
!!$    else
!!$       !
!!$       nc = uvin%gil%nchan
!!$       !
!!$       call uvshort_read_class_table(rname,user%sdin_name,sddat%in,sddat%in%r2d,error)
!!$       if (error) return
!!$       !      
!!$       ! Set valid defaults for Class Tables
!!$       if (sddat%xcol.eq.0) sddat%xcol = 1
!!$       if (sddat%ycol.eq.0) sddat%ycol = 2
!!$       if (sddat%wcol.eq.0) sddat%wcol = 3
!!$       if (sddat%mcol(1).eq.0) sddat%mcol(1) = 4
!!$       icol = sddat%mcol(1)
!!$       if (sddat%mcol(2).ne.0) then
!!$          ocol = sddat%mcol(2)
!!$          if (ocol-icol+1.ne.nc) then
!!$             print *,'MCOL ',sddat%mcol,' ICOL OCOL ',icol,ocol,' NC ',nc
!!$             call map_message(seve%e,rname,'Number of channels mismatch')
!!$             error = .true.
!!$             return
!!$          endif
!!$       else
!!$          ocol = icol+nc-1
!!$          if (ocol.gt.sddat%in%gil%dim(1)) then
!!$             print *,'MCOL ',sddat%mcol,' ICOL OCOL ',icol,ocol,' Sddat%In ',sddat%in%gil%dim(1)
!!$             call map_message(seve%e,rname,'Number of channels mismatch')
!!$             error = .true.
!!$             return
!!$          endif
!!$       endif
!!$       !
!!$       allocate(zero_uvdata(uvin%gil%dim(1),nf),spectrum(nc),stat=ier)
!!$       if (ier.ne.0) then
!!$          call map_message(seve%e,rname,'Zero spacing Memory allocation failure')
!!$          error = .true.
!!$          return
!!$       endif!
!!$       !
!!$       ! Find all spectra towards the appropriate directions,
!!$       ! with the specified tolerance
!!$       total_weight =0.0
!!$       call gwcs_projec(sddat%in%gil%a0,sddat%in%gil%d0,-sddat%in%gil%pang,sddat%in%gil%ptyp,lm_proj,error)
!!$       do if=1,nf
!!$          spectrum(:) = 0.0
!!$          weight = 0.0
!!$          jf = 0
!!$          dmin = 1e36
!!$          !
!!$          call rel_to_abs(uv_proj,dble(raoff(if)),dble(deoff(if)),alpha,delta,1)
!!$          call abs_to_rel(lm_proj,alpha,delta,dx,dy,1)
!!$          !
!!$          do is=1,sddat%in%gil%nvisi
!!$             dist = (sddat%in%r2d(sddat%xcol,is)-dx)**2+(sddat%in%r2d(sddat%ycol,is)-dy)**2
!!$             if (dist .le. user%postol**2) then
!!$                jf = jf+1
!!$                !         print *,'Field ',if,' X',(sddat%in%r2d(sddat%xcol,is)-dx)*sec_per_rad,  
!!$                !         '  Y',(sddat%in%r2d(ycol,is)-dy)*sec_per_rad,     &
!!$                !         ' user%Postol ',user%postol*sec_per_rad
!!$                ws = sddat%in%r2d(sddat%wcol,is)
!!$                weight = weight + ws
!!$                spectrum(:) = spectrum(:) + ws * sddat%in%r2d(icol:ocol,is)
!!$                dmin = min(dmin,dist)
!!$             endif
!!$          enddo
!!$          dmin = sqrt(dmin)*sec_per_rad
!!$          if (weight.eq.0) then
!!$             write(mess,'(A,I0,A,1PG10.2)') 'Field ',if,' has no Zero spacing' &
!!$                  //' Min distance ',dmin
!!$             call map_message(seve%e,rname,mess)
!!$             error = .true.
!!$          else
!!$             write(mess,'(I0,A,I0,A,1PG10.2)') jf,' spectra added to Field ',if &
!!$                  ,'; Min distance ',dmin
!!$             call map_message(seve%i,rname,mess)
!!$             total_weight = total_weight + weight
!!$          endif
!!$          !
!!$          ! Put it in place...
!!$          spectrum = spectrum/weight
!!$          call spectrum_to_zero(nc,spectrum,zero_uvdata(:,if),gdate,weight)
!!$          zero_uvdata(ixcol,if) = raoff(if)
!!$          zero_uvdata(iycol,if) = deoff(if)        
!!$       enddo
!!$    endif
!!$    if (error) return
!!$    !
!!$    ! Now concatenate the Zero spacing data to the Mosaic UV Table
!!$    ! or Create a Zero spacing UV table
!!$    if (do%detect.lt.0) then
!!$       ! short_mode < 0
!!$       !   Here we create a single UV table containing only
!!$       !   the short spacings  for all fields
!!$       name = trim(user%uvin_name)//"-short"
!!$       call sic_parsef(name,uvin%file,' ','.uvt')
!!$       call map_message(seve%i,rname,'Creating UV table '//trim(uvin%file))
!!$       uvin%gil%nvisi = nf
!!$       uvin%gil%nvisi = nf
!!$       call gdf_create_image(uvin,error)
!!$       uvin%blc = 0
!!$       uvin%trc = 0
!!$    else
!!$       ! short_mode > 0
!!$       !   Here we create a UV table containing the short spacings
!!$       !   for all fields appended to the previous UV table
!!$       call gildas_null(uvdat%in)
!!$       name = trim(user%uvin_name)
!!$       call sic_parsef(name,uvdat%in%file,' ','.uvt')
!!$       call gdf_read_header(uvdat%in,error)
!!$       if (error) return
!!$       !
!!$       name = trim(user%uvin_name)//"-merged"
!!$       call sic_parsef(name,uvin%file,' ','.uvt')
!!$       call map_message(seve%i,rname,'UV Table to be appended is '//trim(uvin%file))
!!$       wcol = (nc+2)/3
!!$       ! Copy UV table and get Total weight up to UMAX
!!$       umax = 2.0*user%sddiam  ! Here user%sddiam = user%ipdiam
!!$       call uvshort_copy_uvtable(rname,uvdat%in,uvt,umax,wcol,weight,error)
!!$       if (error) return
!!$       !
!!$       ! Scaling factor for Weights
!!$       call map_message(seve%i,rname,'Appending UV table '//trim(uvin%file))
!!$       string = 'appended'
!!$       uvin%blc(2) = uvin%gil%nvisi+1
!!$       mvis = uvin%gil%nvisi+nf      ! Add NF visibilities
!!$       uvin%trc(2) = mvis
!!$       call gdf_extend_image(uvt,mvis,error)
!!$       uvin%gil%nvisi = uvin%gil%nvisi
!!$       !
!!$       ! Re-normalize the Weight to have a nice beam,including
!!$       ! User-specified Weight factor USER%SDWEI
!!$       scale_weight = weight*user%sdwei/4.0/total_weight
!!$       do if=1,nf
!!$          do is = 10,7+3*nc,3
!!$             zero_uvdata(is,if) = zero_uvdata(is,if) * scale_weight
!!$          enddo
!!$       enddo
!!$    endif
!!$    !
!!$    ! Write the Zero spacings in place now
!!$    call gdf_write_data(uvt,zero_uvdata,error)
!!$    if (error) then
!!$       call map_message(seve%e,rname,'Error writing UV data ')
!!$       return
!!$    endif
!!$    write(mess,'(I0,A)') nf,' Zero spacings added'
!!$    call map_message(seve%i,rname,mess)
!!$    !
!!$    ! Finish the job. Update the number of visibilities
!!$    call gdf_update_header(uvt,error)
!!$    call gdf_close_image(uvt,error)
  end subroutine uvshort_uvzero
  !
  subroutine spectrum_to_zero(nc,spectrum,uvdata,date,weight)
    !
    ! Convert a spectrum into a Zero spacing
    integer,intent(in) :: nc
    real,intent(in) :: spectrum(nc) 
    real,intent(out) :: uvdata(:)
    integer,intent(in) :: date
    real,intent(in) :: weight
    !
    integer :: ic
    !
    uvdata = 0
    uvdata(4) = date
    uvdata(6:7) = -1.0      ! Conventional antenna number
    do ic=1,nc
       uvdata(5+3*ic) = spectrum(ic)
       uvdata(7+3*ic) = weight
    enddo
  end subroutine spectrum_to_zero
  !
end program uvshort_program
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtindex_sort_types
  use gmath_dicho_types
  use gmath_quicksort_types
  use mrtindex_types
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  ! Type for sorting an optimized index
  type, extends(gi8_quicksort_t) :: mrtindex_setsort_t
    type(mrtindex_optimize_t), pointer :: optx
  contains
    procedure, public :: compare => mrtindex_compare_entries
  end type mrtindex_setsort_t
  !
  ! Type for searching in an optimized index by observation number
  type, extends(gi8_dicho_t) :: mrtindex_num_dicho_t
    type(mrtindex_optimize_t), pointer :: optx
    integer(kind=8) :: searched_num = 0
  contains
    procedure, public :: compare       => mrtindex_compare_nums
    procedure, public :: compare_value => mrtindex_compare_entry_to_num
  end type mrtindex_num_dicho_t
  !
contains
  !
  function mrtindex_compare_entries(self,m,l)
    !-------------------------------------------------------------------
    ! Compare first by DOBS then by UT. Then by SCAN for safety, then by
    ! BACKEND for cosmetics, then by VERSION.
    !-------------------------------------------------------------------
    integer(kind=4) :: mrtindex_compare_entries
    class(mrtindex_setsort_t), intent(in) :: self
    integer(kind=8),           intent(in) :: m,l
    if (self%optx%dobs(m).ne.self%optx%dobs(l)) then
      if (self%optx%dobs(m).gt.self%optx%dobs(l)) then
        mrtindex_compare_entries = 1
      else
        mrtindex_compare_entries = -1
      endif
      return
    endif
    if (self%optx%ut(m).ne.self%optx%ut(l)) then
      ! If one is NaN, skip this test
      if (self%optx%ut(m).eq.self%optx%ut(m) .and.  &
          self%optx%ut(l).eq.self%optx%ut(l)) then
        if (self%optx%ut(m).gt.self%optx%ut(l)) then
          mrtindex_compare_entries = 1
        else
          mrtindex_compare_entries = -1
        endif
        return
      endif
    endif
    if (self%optx%scan(m).ne.self%optx%scan(l)) then
      if (self%optx%scan(m).gt.self%optx%scan(l)) then
        mrtindex_compare_entries = 1
      else
        mrtindex_compare_entries = -1
      endif
      return
    endif
    if (self%optx%backend(m).ne.self%optx%backend(l)) then
      if (self%optx%backend(m).gt.self%optx%backend(l)) then
        mrtindex_compare_entries = 1
      else
        mrtindex_compare_entries = -1
      endif
      return
    endif
    if (self%optx%version(m).eq.self%optx%version(l)) then
      mrtindex_compare_entries = 0
    elseif (self%optx%version(m).gt.self%optx%version(l)) then
      mrtindex_compare_entries = 1
    else
      mrtindex_compare_entries = -1
    endif
  end function mrtindex_compare_entries
  !
  function mrtindex_compare_nums(self,m,l)
    !-------------------------------------------------------------------
    ! Compare the observation numbers of the m-th and l-th entries
    !-------------------------------------------------------------------
    integer(kind=4) :: mrtindex_compare_nums
    class(mrtindex_num_dicho_t), intent(in) :: self
    integer(kind=8),             intent(in) :: m,l
    if (self%optx%num(m).eq.self%optx%num(l)) then
      mrtindex_compare_nums = 0
    elseif (self%optx%num(m).gt.self%optx%num(l)) then
      mrtindex_compare_nums = 1
    else
      mrtindex_compare_nums = -1
    endif
  end function mrtindex_compare_nums
  !
  function mrtindex_compare_entry_to_num(self,m)
    !-------------------------------------------------------------------
    ! Compare the m-th entry number to the searched number
    !-------------------------------------------------------------------
    integer(kind=4) :: mrtindex_compare_entry_to_num
    class(mrtindex_num_dicho_t), intent(in) :: self
    integer(kind=8),             intent(in) :: m
    if (self%optx%num(m).eq.self%searched_num) then
      mrtindex_compare_entry_to_num = 0
    elseif (self%optx%num(m).gt.self%searched_num) then
      mrtindex_compare_entry_to_num = 1
    else
      mrtindex_compare_entry_to_num = -1
    endif
  end function mrtindex_compare_entry_to_num
end module mrtindex_sort_types
!
subroutine mrtindex_code2sic(error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_parameters
  use mrtindex_interfaces, except_this=>mrtindex_code2sic
  !---------------------------------------------------------------------
  ! @ public
  ! Create the MRT% Sic structure mapping the index codes.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='INDEX>CODE2SIC'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Create structure if needed
  if (.not.sic_varexist('mrt')) then
     call sic_defstructure('mrt%',.true.,error)
     if (error) return
  endif
  !
  ! *** JP why UNKNOWN is not a kind of obstypes as any other? This calls for troubles...
  call sic_def_charn('mrt%backend',   backends_mrtcal,   1,nbackends_mrtcal+1,.false.,error)
  call sic_def_charn('mrt%obstype',   obstypes_mrtcal,   1,nobstypes_mrtcal+1,.false.,error)
  call sic_def_charn('mrt%switchmode',switchmodes_mrtcal,1,nswitchmodes+1,    .false.,error)
  call sic_def_charn('mrt%filstatus', completenesses,    1,ncompleteness,     .false.,error)
  call sic_def_charn('mrt%calstatus', calstatus,         1,ncalstatus,        .false.,error)
  call sic_def_charn('mrt%solstatus', solstatus,         1,nsolstatus,        .false.,error)
  ! If there is an error, the user/developer wants to know... => no resetting
  !
end subroutine mrtindex_code2sic
!
subroutine mrtindex_cx2sic(cx,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_cx2sic
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Create the MDX% Sic structure mapping the CX arrays (always available)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: cx
  logical,                   intent(inout) :: error
  ! Local
  integer(kind=index_length) :: dim(4)
  character(len=*), parameter :: rname='INDEX>CX2SIC'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Create structure if needed
  if (.not.sic_varexist('mdx')) then
     call sic_defstructure('mdx%',.true.,error)
     if (error) return
  endif
  !
  ! Removed previously defined structure variable
  call sic_delvariable('mdx%curr',        .false.,error)
  call sic_delvariable('mdx%mnum',        .false.,error)
  call sic_delvariable('mdx%fnum',        .false.,error)
  call sic_delvariable('mdx%num',         .false.,error)
  call sic_delvariable('mdx%ver',         .false.,error)
  call sic_delvariable('mdx%telescope',   .false.,error)
  call sic_delvariable('mdx%projid',      .false.,error)
  call sic_delvariable('mdx%source',      .false.,error)
  call sic_delvariable('mdx%dobs',        .false.,error)
  call sic_delvariable('mdx%ut',          .false.,error)
  call sic_delvariable('mdx%lst',         .false.,error)
  call sic_delvariable('mdx%scan',        .false.,error)
  call sic_delvariable('mdx%backend',     .false.,error)
  call sic_delvariable('mdx%obstype',     .false.,error)
  call sic_delvariable('mdx%switchmode',  .false.,error)
  call sic_delvariable('mdx%polarimetry', .false.,error)
  call sic_delvariable('mdx%filstatus',   .false.,error)
  call sic_delvariable('mdx%calstatus',   .false.,error)
  call sic_delvariable('mdx%solstatus',   .false.,error)
  call sic_delvariable('mdx%filename',    .false.,error)
  error = .false.
  !
  if (cx%next.gt.1) then
     dim(1) = cx%next-1
     call sic_def_long ('mdx%mnum',        cx%mnum,        1,dim,.false.,error)
     call sic_def_long ('mdx%fnum',        cx%fnum,        1,dim,.false.,error)
     call sic_def_long ('mdx%num',         cx%num,         1,dim,.false.,error)
     call sic_def_inte ('mdx%ver',         cx%version,     1,dim,.false.,error)
     call sic_def_inte ('mdx%telescope',   cx%telescope,   1,dim,.false.,error)
     call sic_def_charn('mdx%projid',      cx%projid,      1,dim,.false.,error)
     call sic_def_charn('mdx%source',      cx%source,      1,dim,.false.,error)
     call sic_def_inte ('mdx%dobs',        cx%dobs,        1,dim,.false.,error)
     call sic_def_dble ('mdx%ut',          cx%ut,          1,dim,.false.,error)
     call sic_def_dble ('mdx%lst',         cx%lst,         1,dim,.false.,error)
     call sic_def_inte ('mdx%scan',        cx%scan,        1,dim,.false.,error)
     call sic_def_inte ('mdx%backend',     cx%backend,     1,dim,.false.,error)
     call sic_def_inte ('mdx%obstype',     cx%obstype,     1,dim,.false.,error)
     call sic_def_inte ('mdx%switchmode',  cx%switchmode,  1,dim,.false.,error)
     call sic_def_inte ('mdx%polarimetry', cx%polstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%filstatus',   cx%filstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%calstatus',   cx%calstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%solstatus',   cx%solstatus,   1,dim,.false.,error)
     call sic_def_charn('mdx%filename',    cx%filename,    1,dim,.false.,error)
     error = .false.
  endif
  !
end subroutine mrtindex_cx2sic
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtindex_index_to_optimize_inplace(indx,fileid,fnum,mnum,num,  &
  sort,islast,optx,ioptx,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Write the indx at the given position, overwriting the previous
  ! element, if any
  !---------------------------------------------------------------------
  type(mrtindex_indx_t),        intent(in)    :: indx    ! The entry index on disk
  integer(kind=4),            intent(in)    :: fileid  ! Index file associated to the entry
  integer(kind=entry_length), intent(in)    :: fnum    ! Position in associated file
  integer(kind=entry_length), intent(in)    :: mnum    ! Position in memory (IX)
  integer(kind=entry_length), intent(in)    :: num     ! "Observation" number
  integer(kind=entry_length), intent(in)    :: sort    ! Position in the sorted index
  logical,                    intent(in)    :: islast  ! "is-last-version" status
  type(mrtindex_optimize_t),  intent(inout) :: optx    !
  integer(kind=entry_length), intent(in)    :: ioptx   ! Position in output optx
  logical,                    intent(inout) :: error   !
  !
  ! Memory only elements
  optx%idir(ioptx)         = fileid
  optx%fnum(ioptx)         = fnum
  optx%mnum(ioptx)         = mnum
  optx%num(ioptx)          = num
  optx%sort(ioptx)         = sort
  optx%islast(ioptx)       = islast
  ! Disk elements
  optx%bloc(ioptx)         = indx%bloc
  optx%word(ioptx)         = indx%word
  optx%version(ioptx)      = indx%version
  optx%telescope(ioptx)    = indx%telescope
  optx%source(ioptx)       = indx%source
  optx%projid(ioptx)       = indx%projid
  optx%ut(ioptx)           = indx%ut
  optx%lst(ioptx)          = indx%lst
  optx%az(ioptx)           = indx%az
  optx%el(ioptx)           = indx%el
  optx%lon(ioptx)          = indx%lon
  optx%lat(ioptx)          = indx%lat
  optx%system(ioptx)       = indx%system
  optx%equinox(ioptx)      = indx%equinox
  optx%frontend(:,ioptx)   = indx%frontend(:)
  optx%dobs(ioptx)         = indx%dobs
  optx%scan(ioptx)         = indx%scan
  optx%backend(ioptx)      = indx%backend
  optx%obstype(ioptx)      = indx%obstype
  optx%switchmode(ioptx)   = indx%switchmode
  optx%polstatus(ioptx)    = indx%polstatus
  optx%filstatus(ioptx)    = indx%filstatus
  optx%calstatus(ioptx)    = indx%calstatus
  optx%solstatus(ioptx)    = indx%solstatus
  optx%filename(ioptx)     = indx%filename
  optx%itime(ioptx)        = indx%itime
  !
end subroutine mrtindex_index_to_optimize_inplace
!
subroutine mrtindex_index_to_key(indx,key,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_indx_t), intent(in)    :: indx   !
  type(mrtindex_key_t),  intent(inout) :: key    !
  logical,             intent(inout) :: error  !
  !
  key%version      = indx%version
  key%telescope    = indx%telescope
  key%projid       = indx%projid
  key%source       = indx%source
  key%dobs         = indx%dobs
  key%ut           = indx%ut
  key%lst          = indx%lst
  key%az           = indx%az
  key%el           = indx%el
  key%lon          = indx%lon
  key%lat          = indx%lat
  key%system       = indx%system
  key%equinox      = indx%equinox
  key%frontend(:)  = indx%frontend(:)
  key%scan         = indx%scan
  key%backend      = indx%backend
  key%obstype      = indx%obstype
  key%switchmode   = indx%switchmode
  key%polstatus    = indx%polstatus
  key%filstatus    = indx%filstatus
  key%calstatus    = indx%calstatus
  key%solstatus    = indx%solstatus
  key%filename     = indx%filename
  !
end subroutine mrtindex_index_to_key
!
subroutine mrtindex_key_to_index(key,indx,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_key_t),  intent(in)    :: key    !
  type(mrtindex_indx_t), intent(inout) :: indx   !
  logical,             intent(inout) :: error  !
  !
  ! indx%bloc = not relevant in key
  ! indx%word = not relevant in key
  indx%version     = key%version
  indx%telescope   = key%telescope
  indx%projid      = key%projid
  indx%source      = key%source
  indx%dobs        = key%dobs
  indx%ut          = key%ut
  indx%lst         = key%lst
  indx%az          = key%az
  indx%el          = key%el
  indx%lon         = key%lon
  indx%lat         = key%lat
  indx%system      = key%system
  indx%equinox     = key%equinox
  indx%frontend(:) = key%frontend(:)
  indx%scan        = key%scan
  indx%backend     = key%backend
  indx%obstype     = key%obstype
  indx%switchmode  = key%switchmode
  indx%polstatus   = key%polstatus
  indx%filstatus   = key%filstatus
  indx%calstatus   = key%calstatus
  indx%solstatus   = key%solstatus
  indx%filename    = key%filename
  ! indx%itime = not relevant in key
  !
end subroutine mrtindex_key_to_index
!
subroutine mrtindex_optimize_to_key(optx,ient,key,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  type(mrtindex_key_t),         intent(out)   :: key    !
  logical,                    intent(inout) :: error  !
  !
  key%version      = optx%version(ient)
  key%telescope    = optx%telescope(ient)
  key%projid       = optx%projid(ient)
  key%source       = optx%source(ient)
  key%dobs         = optx%dobs(ient)
  key%ut           = optx%ut(ient)
  key%lst          = optx%lst(ient)
  key%az           = optx%az(ient)
  key%el           = optx%el(ient)
  key%lon          = optx%lon(ient)
  key%lat          = optx%lat(ient)
  key%system       = optx%system(ient)
  key%equinox      = optx%equinox(ient)
  key%frontend(:)  = optx%frontend(:,ient)
  key%scan         = optx%scan(ient)
  key%backend      = optx%backend(ient)
  key%obstype      = optx%obstype(ient)
  key%switchmode   = optx%switchmode(ient)
  key%polstatus    = optx%polstatus(ient)
  key%filstatus    = optx%filstatus(ient)
  key%calstatus    = optx%calstatus(ient)
  key%solstatus    = optx%solstatus(ient)
  key%filename     = optx%filename(ient)
  !
end subroutine mrtindex_optimize_to_key
!
subroutine mrtindex_optimize_to_entry(optx,ient,entry,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  "GET" the full entry (header+sections), read from disk
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  type(mrtindex_entry_t),       intent(inout) :: entry  !
  logical,                    intent(inout) :: error  !
  ! Local
  integer(kind=4) :: fileid
  integer(kind=entry_length) :: jent
  !
  ! Open file if not already opened:
  fileid = optx%idir(ient)
  call mrtindex_file_old(fileid,.false.,error)
  if (error)  return
  !
  ! Read the whole entry from disk
  jent = optx%fnum(ient)
  call mrtindex_entry_read(ix_files(fileid),jent,entry,error)
  if (error)  return
  !
end subroutine mrtindex_optimize_to_entry
!
subroutine mrtindex_optimize_to_optimize_1d(in,out,error)
  use gbl_message
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_optimize_1d
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: in
  type(mrtindex_optimize_t), intent(inout) :: out
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=entry_length) :: ient,nent
  character(len=*), parameter :: rname='OPTIMIZE>TO>OPTIMIZE>1D'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Reallocate without keeping the data
  nent = in%next-1
  call reallocate_mrtoptimize(out,nent,.false.,error)
  if (error)  return
  ! Copy
  out%next = 1
  do ient=1,nent
    call mrtindex_optimize_to_optimize(in,ient,out,error)
    if (error)  return
  enddo ! ient
  !
end subroutine mrtindex_optimize_to_optimize_1d
!
subroutine mrtindex_optimize_to_optimize_next(in,i,out,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_optimize_next
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  ! Copy the i-th element of the input optimize to the next available
  ! position in output optimize. It does not check if the optimize
  ! index is correctly allocated.
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: in
  integer(kind=entry_length), intent(in)    :: i
  type(mrtindex_optimize_t),    intent(inout) :: out
  logical,                    intent(inout) :: error
  !
  call mrtindex_optimize_to_optimize_inplace(in,i,out,out%next,error)
  if (error)  return
  out%next = out%next+1
  !
end subroutine mrtindex_optimize_to_optimize_next
!
subroutine mrtindex_optimize_to_optimize_inplace(in,i,out,j,error)
  use classic_api
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  ! Copy the i-th element of the input optimize to the j-th position
  ! in output optimize. It does not check if the optimize index is
  ! correctly allocated.
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: in
  integer(kind=entry_length), intent(in)    :: i
  type(mrtindex_optimize_t),    intent(inout) :: out
  integer(kind=entry_length), intent(in)    :: j
  logical,                    intent(inout) :: error
  !
  out%bloc(j)         = in%bloc(i)
  out%word(j)         = in%word(i)
  out%version(j)      = in%version(i)
  out%telescope(j)    = in%telescope(i)
  out%projid(j)       = in%projid(i)
  out%source(j)       = in%source(i)
  out%dobs(j)         = in%dobs(i)
  out%ut(j)           = in%ut(i)
  out%lst(j)          = in%lst(i)
  out%az(j)           = in%az(i)
  out%el(j)           = in%el(i)
  out%lon(j)          = in%lon(i)
  out%lat(j)          = in%lat(i)
  out%system(j)       = in%system(i)
  out%equinox(j)      = in%equinox(i)
  out%frontend(:,j)   = in%frontend(:,i)
  out%scan(j)         = in%scan(i)
  out%backend(j)      = in%backend(i)
  out%obstype(j)      = in%obstype(i)
  out%switchmode(j)   = in%switchmode(i)
  out%polstatus(j)    = in%polstatus(i)
  out%filstatus(j)    = in%filstatus(i)
  out%calstatus(j)    = in%calstatus(i)
  out%solstatus(j)    = in%solstatus(i)
  out%filename(j)     = in%filename(i)
  out%itime(j)        = in%itime(i)
  out%num(j)          = in%num(i)
  out%mnum(j)         = in%mnum(i)
  out%fnum(j)         = in%fnum(i)
  out%sort(j)         = j  ! Yes!
  out%idir(j)         = in%idir(i)
  out%islast(j)       = in%islast(i)
  !
end subroutine mrtindex_optimize_to_optimize_inplace
!
subroutine mrtindex_optimize_to_filename(optx,ient,filename,error)
  use mrtindex_types
  use mrtindex_vars
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_filename
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx
  integer(kind=entry_length), intent(in)    :: ient
  character(len=*),           intent(out)   :: filename
  logical,                    intent(inout) :: error
  !
  filename = trim(ix_dirs(optx%idir(ient)))//'/'//optx%filename(ient)
  !
end subroutine mrtindex_optimize_to_filename
!
subroutine mrtindex_optimize_setsort(in,error)
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_setsort
  use mrtindex_sort_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the sorting list of the input index (in%sort)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), target, intent(inout) :: in     !
  logical,                           intent(inout) :: error  !
  ! Local
  integer(kind=entry_length) :: nelem
  type(mrtindex_setsort_t) :: setsort
  !
  ! Remark: in%sort() must contain the unsorted element before
  ! entering setsort%sort()
  nelem = in%next-1
  setsort%optx => in
  call setsort%sort(in%sort,nelem,error)
  if (error)  return
end subroutine mrtindex_optimize_setsort
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_zindx(indx,error)
  use gbl_constant
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'mrtindex_indx_t' structure. Default can not be in
  ! in the structure definition because of the 'sequence' statement
  !---------------------------------------------------------------------
  type(mrtindex_indx_t), intent(out)   :: indx
  logical,             intent(inout) :: error
  !
  indx%bloc = 0
  indx%word = 0
  indx%version = 0
  indx%telescope = telescope_unknown
  indx%source = ''
  indx%projid = ''
  call gag_notanum(indx%ut)
  call gag_notanum(indx%lst)
  call gag_notanum(indx%az)
  call gag_notanum(indx%el)
  call gag_notanum(indx%lon)
  call gag_notanum(indx%lat)
  indx%system = type_un
  indx%equinox = equinox_null
  indx%frontend(:) = ''
  indx%dobs = -32768
  indx%scan = 0
  indx%backend = backend_unknown
  indx%obstype = obstype_unknown
  indx%switchmode = switchmode_unk
  indx%polstatus = 0
  indx%filstatus = complete_unreadable
  indx%calstatus = calstatus_none
  indx%solstatus = solstatus_none
  indx%filename = ''
  indx%itime = 0
  !
end subroutine mrtindex_entry_zindx
!
subroutine mrtindex_entry_zkey(key,error)
  use gbl_constant
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'mrtindex_key_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_key_t), intent(out)   :: key
  logical,            intent(inout) :: error
  !
  key%version = 0
  key%telescope = telescope_unknown
  key%projid = ''
  key%source = ''
  key%dobs = -32768
  call gag_notanum(key%ut)
  call gag_notanum(key%lst)
  call gag_notanum(key%az)
  call gag_notanum(key%el)
  call gag_notanum(key%lon)
  call gag_notanum(key%lat)
  key%system = type_un
  key%equinox = equinox_null
  key%frontend(:) = ''
  key%scan = 0
  key%backend = backend_unknown
  key%obstype = obstype_unknown
  key%switchmode = switchmode_unk
  key%polstatus = 0
  key%filstatus = complete_unreadable
  key%calstatus = calstatus_none
  key%solstatus = solstatus_none
  key%filename = ''
  !
end subroutine mrtindex_entry_zkey
!
subroutine mrtindex_entry_zprim(prim,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'sec_primary_t' structure
  !---------------------------------------------------------------------
  type(sec_primary_t), intent(out)   :: prim
  logical,             intent(inout) :: error
  !
  prim%imbfvers = 0.0
! prim%lam      = 0.d0
! prim%bet      = 0.d0
! prim%timegoal = 0.d0
! prim%nsubgoal = 0
! prim%nsub     = 0
  !
end subroutine mrtindex_entry_zprim
!
subroutine mrtindex_entry_zcalib(calib,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'sec_calib_t' structure
  !---------------------------------------------------------------------
  type(sec_calib_t), intent(inout) :: calib
  logical,           intent(inout) :: error
  !
  calib%nfreq = 0
  calib%nset  = 0
  calib%npix  = 0
  if (allocated(calib%frontend))  deallocate(calib%frontend)
  if (allocated(calib%freq))      deallocate(calib%freq)
  if (allocated(calib%atsys))     deallocate(calib%atsys)
  if (allocated(calib%ztau))      deallocate(calib%ztau)
  !
end subroutine mrtindex_entry_zcalib
!
subroutine mrtindex_entry_zscience(sci,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Zero-ify an 'sec_science_t' structure
  !---------------------------------------------------------------------
  type(sec_science_t), intent(out)   :: sci
  logical,             intent(inout) :: error
  !
  sci%caldobs = -32768
  sci%calscan = 0
  sci%calback = backend_unknown
  sci%calvers = 0
  !
end subroutine mrtindex_entry_zscience
!
subroutine mrtindex_entry_zheader(head,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_zheader
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Zero-ify an 'mrtindex_header_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(inout) :: head
  logical,               intent(inout) :: error
  !
  head%presec(:) = .false.
  !
  call mrtindex_entry_zkey(head%key,error)
  if (error)  return
  call mrtindex_entry_zprim(head%pri,error)
  if (error)  return
  call mrtindex_entry_zcalib(head%cal,error)
  if (error)  return
  call mrtindex_entry_zscience(head%sci,error)
  if (error)  return
  call head%poi%zero(error)
  if (error)  return
end subroutine mrtindex_entry_zheader
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_fheader(head,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_fheader
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Free an 'mrtindex_header_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(inout) :: head
  logical,               intent(inout) :: error
  !
  ! key: nothing to destroy
  !
  ! pri: nothing to destroy
  !
  ! cal:
  call free_calib_section(head%cal,error)
  if (error)  continue
  !
  ! sci: nothing to destroy
  !
  ! poi:
  call head%poi%free(error)
  if (error)  continue
  !
end subroutine mrtindex_entry_fheader
!
subroutine mrtindex_entry_free(entry,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_free
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Free an 'mrtindex_entry_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_entry_t), intent(inout) :: entry
  logical,              intent(inout) :: error
  !
  ! indx: nothing to destroy
  !
  ! desc: nothing to destroy
  !
  ! head:
  call mrtindex_entry_fheader(entry%head,error)
  if (error)  continue
  !
end subroutine mrtindex_entry_free
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_lcalib(head,string,error)
  use gildas_def
  use gkernel_interfaces
  use class_parameter
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the calibration section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),        intent(out)   :: string
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='ENTRY>LCALIB'
  integer(kind=size_length) :: ndata
  real(kind=4) :: medval
  integer(kind=4) :: ier,ifreq,iset,ipix,nc
  real(kind=4), allocatable :: atsys(:,:)
  character(len=64) :: tmpstring
  !
  string = ''
  if (.not.head%presec(sec_calib_id))  return
  !
  allocate(atsys(head%cal%nfreq,head%cal%npix),stat=ier)
  if (failed_allocate(rname,'atsys',ier,error))  return
  !
  nc = 1
  ndata = head%cal%nfreq * head%cal%npix
  do iset=1,head%cal%nset
    ! Fill temporary (contiguous) buffer
    do ipix=1,head%cal%npix
      do ifreq=1,head%cal%nfreq
        atsys(ifreq,ipix) = head%cal%atsys(ifreq,iset,ipix)
      enddo
    enddo
    ! Compute the median along the Freq and Pix dimensions
    call gr4_median(atsys,ndata,0.,-1.,medval,error)
    if (error)  return
    !
    ! Write in temporary string
    if (medval.eq.class_bad) then
      write(tmpstring,'(A,A,A)')   trim(head%cal%frontend(iset)),':','--'
    else
      write(tmpstring,'(A,A,I0)')  trim(head%cal%frontend(iset)),':',nint(medval)
    endif
    !
    if (truncate_and_return(nc,string))  return  ! Detect if at least 1 char available at 'nc'
    string(nc:) = tmpstring                      ! Possibly truncated
    nc = nc+len_trim(tmpstring)-1                ! Trimmed length
    if (truncate_and_return(nc,string))  return  ! Detect if truncation happened
    nc = nc+2  ! Room for a blank space (not evaluated in truncate_and_return if last loop)
  enddo
  !
  deallocate(atsys)
  !
contains
  !
  function truncate_and_return(nc,string)
    logical :: truncate_and_return
    integer(kind=4),  intent(in)    :: nc
    character(len=*), intent(inout) :: string
    ! Local
    integer(kind=4) :: mc
    !
    truncate_and_return = nc.gt.len(string)
    if (truncate_and_return) then
      mc = len(string)
      string(mc-2:mc) = '...'
    endif
  end function truncate_and_return
  !
end subroutine mrtindex_entry_lcalib
!
subroutine mrtindex_entry_lpointing(head,string,error)
  use gildas_def
  use gkernel_interfaces
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the pointing section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),        intent(out)   :: string
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: nc,isol
  !
  string = ''
  if (.not.head%presec(sec_pointing_id))  return
  !
  nc = 0
  do isol=1,head%poi%nsol
    ! Produce some mean result for the user
!     write(string(nc+2:),'(A,A,F4.1)')  &
!           head%poi%sol(isol)%val(1),':',  &
!           head%poi%sol(isol)%nfit(2)
!     nc = len_trim(string)
  enddo
  !
  ! ZZZ Dummy results for the time being (the section needs to be redefined)
  write(string,'(A)')  'Az:N/A  El:N/A'
end subroutine mrtindex_entry_lpointing
!
subroutine mrtindex_entry_lscience(head,string,nc,error)
  use gildas_def
  use mrtindex_dependencies_interfaces
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the science section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),      intent(out)   :: string
  integer(kind=4),       intent(out)   :: nc
  logical,               intent(inout) :: error
  !
  string = ''
  nc = 19+backname_length  ! 11+1 + 3+1 + backname_length+1 + 2
  !
  if (.not.head%presec(sec_science_id))  return
  !
  call gag_todate(head%sci%caldobs,string,error)
  if (error)  return
  !
  write(string(13:),'(I3,1X,A,1X,I2)')  &
    head%sci%calscan,                   &
    backends_mrtcal(head%sci%calback),  &
    head%sci%calvers
  !
end subroutine mrtindex_entry_lscience
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_append_entry(entry,ient,oent,ix,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_append_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Append a NEW entry, with a new version number (automatically set
  ! to a new available value) in the file (on disk) and in IX (in
  ! memory). CX is NOT updated (this is a feature)
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Old entry position in IX
  integer(kind=entry_length), intent(out)   :: oent   ! New entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>APPEND>ENTRY'
  character(len=message_length) :: mess
  integer(kind=4) :: over,fileid
  integer(kind=entry_length) :: ifound,onum,osort
  logical :: dupl,olast
  !
  if (ient.le.0 .or. ient.ge.ix%next) then
    write(mess,'(A,I0,A)') 'No such entry number #',ient,' in IX'
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Set the new version value
  onum = ix%num(ient)  ! Keep same observation number
  over = 0             ! i.e. find the last version
  call mrtindex_numver2ent(rname,ix,onum,over,ifound,dupl,error)
  if (error)  return
  entry%indx%version = ix%version(ifound)+1  ! New available version
  !
  ! In which file?
  if (ox_fileid.ne.0) then
    ! Use a custom output file (INDEX OUTPUT)
    fileid = ox_fileid
    ! For safety, check if the directory associated to the output index is
    ! the same as the input index. Else, this means the user is mixing
    ! several directories and this becomes very complicated...
    if (ix_dirs(ox_fileid).ne.ix_dirs(ix%idir(ient))) then
      call mrtindex_message(seve%e,rname,  &
        'Directories mismatch for input and output indexes')
      error = .true.
      return
    endif
  else
    ! Use the original index file
    fileid = ix%idir(ient)
  endif
  !
  ! Open file if not already opened
  call mrtindex_file_old(fileid,.true.,error)
  if (error)  return
  call mrtindex_entry_write(ix_files(fileid),entry,error)
  if (error)  return
  ! Update the File Descriptor on disk (in particular desc%xnext)
  call classic_filedesc_write(ix_files(fileid),error)
  if (error)  return
  ! Input file has been modified, nullify the reading buffers
  call classic_recordbuf_nullify(ibufbi)
  call classic_recordbuf_nullify(ibufobs)
  !
  ! Also append IX
  ! Make room for 1 more entry
  call reallocate_mrtoptimize(ix,ix%next,.true.,error)
  if (error)  return
  !
  oent = ix%next
  onum = ix%num(ient)  ! Keep same observation number
  osort = oent  ! Declare it at last position in the sorted index, the
                ! re-sorting is done just after
  olast = .true.  ! Is-last-version
  call mrtindex_index_to_optimize_inplace(entry%indx,fileid,entry%desc%xnum,  &
    oent,onum,osort,olast,ix,oent,error)
  if (error)  return
  ix%next = ix%next+1
  !
  ! And keep the sort array sorted!
  call mrtindex_optimize_setsort(ix,error)
  if (error)  return
  !
  ix%islast(ifound) = .false.  ! This is not the last version anymore
  !
end subroutine mrtindex_append_entry
!
subroutine mrtindex_update_entry(entry,ient,ix,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_update_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Update an old entry in the file (on disk) and in IX (in memory).
  ! CX is NOT updated, this is a feature.
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UPDATE>ENTRY'
  character(len=message_length) :: mess
  !
  call mrtindex_modify_entry(mrtindex_entry_update,entry,ient,ix,error)
  if (error) then
    write(mess,'(A,I0,A,A)')  'Could not update entry #',entry%desc%xnum,  &
      ' in file ',ix_files(ix%idir(ient))%spec
    call mrtindex_message(seve%e,rname,mess)
    return
  endif
  !
end subroutine mrtindex_update_entry
!
subroutine mrtindex_extend_entry(entry,ient,ix,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_extend_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Extend the LAST entry in the file (on disk, in particular, add the
  ! new sections) and update in IX (in memory).
  !  CX is NOT updated, this is a feature.
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='EXTEND>ENTRY'
  character(len=message_length) :: mess
  !
  call mrtindex_modify_entry(mrtindex_entry_extend,entry,ient,ix,error)
  if (error) then
    write(mess,'(A,I0,A,A)')  'Could not extend entry #',entry%desc%xnum,  &
      ' in file ',ix_files(ix%idir(ient))%spec
    call mrtindex_message(seve%e,rname,mess)
    return
  endif
  !
end subroutine mrtindex_extend_entry
!
subroutine mrtindex_modify_entry(mrtindex_entry_modify,entry,ient,ix,error)
  use gbl_message
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_modify_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !  UPDATE or EXTEND an old entry in the file (on disk) and update in
  ! IX (in memory). CX is NOT updated, this is a feature.
  !  To be called by mrtindex_update_entry or mrtindex_extend_entry only!!!
  !---------------------------------------------------------------------
  interface
    subroutine mrtindex_entry_modify(fileout,entry,error)
    use classic_api
    use mrtindex_types
    type(classic_file_t),   intent(inout) :: fileout
    type(mrtindex_entry_t), intent(inout) :: entry
    logical,                intent(inout) :: error
    end subroutine mrtindex_entry_modify
  end interface
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>MODIFY>ENTRY'
  character(len=message_length) :: mess
  integer(kind=4) :: fileid
  integer(kind=entry_length) :: inum,isort
  logical :: ilast
  !
  if (ient.le.0 .or. ient.ge.ix%next) then
    write(mess,'(A,I0,A)') 'No such entry number #',ient,' in IX'
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! In which file? Always in the same file as before
  fileid = ix%idir(ient)
  !
  ! Open file if not already opened
  call mrtindex_file_old(fileid,.true.,error)
  if (error)  return
  call mrtindex_entry_modify(ix_files(fileid),entry,error)
  if (error)  return
  ! Update the File Descriptor on disk (in particular desc%next because
  ! EXTEND mode may enlarge the file)
  call classic_filedesc_write(ix_files(fileid),error)
  if (error)  return
  call classic_file_fflush(ix_files(fileid),error)
  if (error)  return
  ! Input file has been modified, nullify the reading buffers
  call classic_recordbuf_nullify(ibufbi)
  call classic_recordbuf_nullify(ibufobs)
  !
  ! Update the entry in IX
  inum = ix%num(ient)
  isort = ix%sort(ient)  ! Its position in the sorted index does not change
  ilast = ix%islast(ient)
  call mrtindex_index_to_optimize_inplace(entry%indx,fileid,entry%desc%xnum,  &
    ient,inum,isort,ilast,ix,ient,error)
  if (error)  return
  !
end subroutine mrtindex_modify_entry
!
subroutine mrtindex_numver2ent(rname,ix,num,ver,ient,dupl,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_numver2ent
  use mrtindex_sort_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Convert an observation number and version to the entry position
  ! in IX. ver<0 means to choose the newest version.
  !---------------------------------------------------------------------
  character(len=*),                  intent(in)    :: rname  ! Calling routine name
  type(mrtindex_optimize_t), target, intent(in)    :: ix     !
  integer(kind=entry_length),        intent(in)    :: num    ! Observation number
  integer(kind=4),                   intent(in)    :: ver    ! Version number
  integer(kind=entry_length),        intent(out)   :: ient   ! Entry found
  logical,                           intent(inout) :: dupl   ! Error because of multiple match?
  logical,                           intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: found
  character(len=message_length) :: mess
  integer(kind=entry_length) :: jent,kent,lent
  integer(kind=4) :: iver
  type(mrtindex_num_dicho_t) :: dicho
  !
  found = .false.
  dupl = .false.
  ient = 0
  !
  dicho%optx => ix
  dicho%searched_num = num
  call dicho%dicho(ix%sort,ix%next-1,.true.,jent)
  if (jent.eq.0)  goto 100  ! Not found
  ! In return jent is the observation lower or equal to the request
  ! in the sorted array (ix%sort)
  !
  if (ver.le.0) then
    iver = 0
    do kent=jent,ix%next-1
      lent = ix%sort(kent)
      if (ix%num(lent).eq.num) then
        if (found .and. ix%version(lent).eq.iver)  goto 101
        found = .true.
        ient = lent
        iver = ix%version(lent)
        ! Continue until we reach the last version
      else
        exit
      endif
    enddo
  else
    do kent=jent,ix%next-1
      lent = ix%sort(kent)
      if (ix%num(lent).eq.num) then
        if (ix%version(lent).eq.ver) then
          if (found)  goto 101
          found = .true.
          ient = lent
          ! Continue until we reach last version, in order to check
          ! if there are multiple match
        endif
      else
        exit
      endif
    enddo
  endif
  if (found)  return
  !
100 continue
  if (ver.le.0) then
    write(mess,'(A,I0)') 'No such observation #',num
  else
    write(mess,'(A,I0,A,I0)') 'No such observation #',num,'.',ver
  endif
  call mrtindex_message(seve%e,rname,mess)
  error = .true.
  return
  !
101 continue
  dupl = .true.
  write(mess,'(A,4(I0,A))') 'Multiple match for observation ',  &
    num,'.',ver,' (entries ',ient,' and ',lent,')'
  call mrtindex_message(seve%e,rname,mess)
  error = .true.
  return
end subroutine mrtindex_numver2ent
!
subroutine mrtindex_mjd2gagut(scandate,mjd,dobs,ut,error)
  use phys_const
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_mjd2gagut
  !---------------------------------------------------------------------
  ! @ public
  ! Split MJD into DATE + UT, but taking care to respect the scan date
  ! which could have been set before midnight. In such a case, UT will
  ! go beyond 2*pi
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: scandate  ! [gag]
  real(kind=8),    intent(in)    :: mjd       ! [day]
  integer(kind=4), intent(out)   :: dobs      ! [gag]
  real(kind=8),    intent(out)   :: ut        ! [rad]
  logical,         intent(inout) :: error     !
  !
  character(len=*), parameter :: rname='MJD2GAGUT'
  character(len=message_length) :: mess
  character(len=8) :: datestring
  !
  call gag_mjd2gagut(mjd,dobs,ut,error)
  if (error)  return
  !
  if (scandate.eq.-32768) then
    call mrtindex_message(seve%w,rname,'Scan date is not set')
    return
  endif
  if (dobs.eq.scandate)  return  ! No midnight overlap
  !
  ! Tolerate 2h=pi/6 forward on next day (1h = max scan length)
  if (dobs.eq.scandate+1 .and. ut.lt.pi/6.d0) then
    ! Keep DOBS as scan date, set UT beyond 24h
    dobs = scandate
    ut = ut+2.d0*pi
  else
    call gag_toyyyymmdd(scandate,datestring,error)
    write(mess,'(a,a8,a,1pg25.16)')  &
      'Inconsistent date in filename (',datestring,') and MJD ',mjd
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
end subroutine mrtindex_mjd2gagut
!
subroutine datelist_decode(line,optdate,string,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>datelist_decode
  !---------------------------------------------------------------------
  ! @ private
  !  Re-encode a Sic-list of dates for the CURRENT line as known and
  ! parsed by Sic, into a string of GAG dates (much easier to parse
  ! afterwards).
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     !
  integer(kind=4),  intent(in)    :: optdate  ! Option /DATE identifier
  character(len=*), intent(out)   :: string   ! Decoded as GAG dates
  logical,          intent(inout) :: error    !
  ! Local
  integer(kind=4) :: oc,iarg,nc,gagdate
  character(len=32) :: argum
  !
  string = ''
  oc = 1
  do iarg=1,sic_narg(optdate)
    call sic_ke(line,optdate,iarg,argum,nc,.true.,error)
    if (error)  return
    !
    if (argum.eq.'TO') then
      ! Date1 TO Date2 (keep "TO" as is)
      ! NB: "BY" not yet recognized, probably useless in this context
      write(string(oc:),'(A)')  'TO'
      oc = oc+3
    else
      call date_decode(argum,gagdate,error)
      if (error)  return
      write(string(oc:),'(I0)')  gagdate
      oc = len_trim(string)+2
    endif
  enddo
  !
end subroutine datelist_decode
!
subroutine date_decode(string,dobs,error)
  use gbl_message
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>date_decode
  !---------------------------------------------------------------------
  ! @ private
  ! Decode a string date in any supported format into a gag date.
  ! Supported formats are:
  !  - DD-MMM-YYYY
  !  - YYYYMMDD
  !  - Keywords "TODAY" and "YESTERDAY"
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: string  !
  integer(kind=4),  intent(out)   :: dobs    !
  logical,          intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='DATE>DECODE'
  integer(kind=4) :: ikey
  integer(kind=4), parameter :: mkeys=2
  character(len=11) :: date
  character(len=9) :: datekeys(mkeys),keyword
  ! Data
  data datekeys / 'TODAY','YESTERDAY' /
  !
  ! Search for a keyword
  date = string
  call sic_upper(date)
  call sic_ambigs_sub(rname,date,keyword,ikey,datekeys,mkeys,error)
  if (error)  return
  !
  if (ikey.ne.0) then
    call sic_gagdate(dobs)  ! Today
    if (ikey.eq.2)  dobs = dobs-1  ! Yesterday
    return
  endif
  !
  ! Not TODAY or YESTERDAY, try other formats
  if (index(string,'-').gt.0) then  ! DD-MMM-YYYY
    call gag_fromdate(date,dobs,error)
  else                              ! YYYYMMDD
    call gag_fromyyyymmdd(date,dobs,error)
  endif
  if (error) then
    call mrtindex_message(seve%e,rname,'Could not decode date '//string)
    return
  endif
  !
end subroutine date_decode
!
function imbfits_name(date)
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !   Build an IMB-FITS file name according to the IRAM 30m standard.
  ! This function factorizes this standard at a unique place
  !---------------------------------------------------------------------
  character(len=imbfits_pattern_length) :: imbfits_name  ! Function value on return
  character(len=*), intent(in) :: date   ! The date string, can be '*'
  !
  imbfits_name = 'iram30m-*-'//trim(date)//'s*-imb.fits'
  !
end function imbfits_name
!
!-----------------------------------------------------------------------
!
function mrtindex_telescope(itel)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the telescope name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=telescope_length) :: mrtindex_telescope
  integer(kind=4), intent(in) :: itel
  !
  mrtindex_telescope = telescopes(itel)
  !
end function mrtindex_telescope
!
function mrtindex_backend(iback)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the backend name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=backname_length) :: mrtindex_backend
  integer(kind=4), intent(in) :: iback
  !
  mrtindex_backend = backends_mrtcal(iback)
  !
end function mrtindex_backend
!
function mrtindex_obstype_decode(name,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_obstype_decode
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Decode the IMBFIST obstype name and return the corresponding
  ! MRTCAL code
  !---------------------------------------------------------------------
  integer(kind=4) :: mrtindex_obstype_decode
  character(len=*), intent(in)    :: name
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='OBSTYPE>DECODE'
  character(len=obstype_length) :: obsin,obsfound
  !
  obsin = name
  call sic_upper(obsin)
  call sic_ambigs_sub(rname,obsin,obsfound,mrtindex_obstype_decode,obstypes_imbfits,  &
    nobstypes_imbfits+1,error)
  mrtindex_obstype_decode = mrtindex_obstype_decode-1  ! Because obstypes_imbfits numbering starts at 0
  if (mrtindex_obstype_decode.eq.-1) then
    call mrtindex_message(seve%w,rname,'Observation type '''//trim(obsin)//  &
      ''' not supported')
    mrtindex_obstype_decode = obstype_unknown
    ! Not an error, continue
  elseif (mrtindex_obstype_decode.eq.obstype_onoff) then
    mrtindex_obstype_decode = obstype_tracked
  endif
  !
end function mrtindex_obstype_decode
!
function mrtindex_obstype_imbfits(itype)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the observation type name (IMBFITS) given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=obstype_length) :: mrtindex_obstype_imbfits
  integer(kind=4), intent(in) :: itype
  !
  mrtindex_obstype_imbfits = obstypes_imbfits(itype)
  !
end function mrtindex_obstype_imbfits
!
function mrtindex_obstype(itype)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the observation type name (MRTCAL) given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=obstype_length) :: mrtindex_obstype
  integer(kind=4), intent(in) :: itype
  !
  mrtindex_obstype = obstypes_mrtcal(itype)
  !
end function mrtindex_obstype
!
function mrtindex_swmode_imbfits(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode_imbfits
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode_imbfits = switchmodes_imbfits(imode)
  !
end function mrtindex_swmode_imbfits
!
function mrtindex_swmode(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode = switchmodes_mrtcal(imode)
  !
end function mrtindex_swmode
!
function mrtindex_swmode_voxml(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode_voxml
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode_voxml = switchmodes_voxml(imode)
  !
end function mrtindex_swmode_voxml

module sic_interpreter
  use sic_structures
  !---------------------------------------------------------------------
  !  Support variables for the SIC interpreter. Variables local to this
  ! file only.
  !---------------------------------------------------------------------
  !
  logical :: freelet           ! Is a free syntax assignment suspected?
  logical :: sic_quiet_proced  !
  logical :: do_log            !
  integer :: ifllev(mcloop)    !
  integer :: lire              !
  integer :: liro              !
  integer(kind=4) :: nliro     !
  character(len=commandline_length) :: oline  !
  integer(kind=4) :: nolin                    !
  logical, save :: ignore_if = .false.  ! Default at startup
  logical, save :: lenter = .false.  ! Default at startup
  !
end module sic_interpreter
!
subroutine sic_run(line,lang,command,error,icode,ocode)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use sic_interpreter
  use sic_interfaces, except_this=>sic_run
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public (but private in the context of new language initialization)
  !       Read next command and interprets it, then return
  !       control to the caller.
  !
  ! Arguments:
  ! LINE:  Command line. On input: text to be stored in stack and log
  !        file. On output: new command line
  ! ERROR: Logical error flag, indicating whether last command was
  !        successfully executed.
  !
  ! Note on labels in the code
  !       10      Error handling after command execution
  !       20      Read new command
  !       30      Check for error in command reading and level changes
  !       40      Substitute symbols and analyse line
  !       50      Log file after command execution
  !       70      DO WHILE in QUIT ALL
  !       80      DO WHILE in RETURN BASE
  !       90      DO WHILE in EXIT
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line     ! Input/output command line
  character(len=*), intent(out)   :: lang     ! Language found
  character(len=*), intent(out)   :: command  ! Command found
  logical,          intent(inout) :: error    ! Logical error flag
  integer,          intent(in)    :: icode    ! Input code
  integer,          intent(out)   :: ocode    ! Output code
  ! Local
  integer(kind=4) :: nline,ier,n,goto_code,recall,ntmp
  logical :: err,suite,nolog
  character(len=4) :: ans
  character(len=message_length) :: mess,tmp
  !
  ! Output code: get next command.
  ocode = code_next
  !
  ! SIC_ENTER
  if (icode.eq.code_enter) then
    !----------------------------------------------------------------------
    !       Enter SIC
    !----------------------------------------------------------------------
    if (.not.loaded) then
      call sic_message(seve%f,'SIC','SIC is not loaded')
      call sysexi(fatale)
    endif
    if (lenter) then
      call sic_message(seve%f,'SIC','Programming error: recursive call to SIC')
      call sysexi(fatale)
    endif
    nlire = 1
    nliro = 1
    mlire(nlire)=0
    lenter = .true.
    error = .false.
    goto 20
    !
    ! SIC_PLAY
  elseif (icode.eq.code_play) then
    !----------------------------------------------------------------------
    !       Enter SIC and Execute a first SIC command, which may be @.
    !----------------------------------------------------------------------
    if (.not.loaded) then
      call sic_message(seve%f,'SIC','SIC is not loaded')
      call sysexi(fatale)
    endif
    if (lenter) then
      call sic_message(seve%f,'SIC','Programming error: recursive call to SIC')
      call sysexi(fatale)
    endif
    lenter = .true.
    nlire = 1
    mlire(nlire) = 0
    error = .false.
    nline = lenc(line)
    suite = .false.
    call sblanc(line,nline,suite,ier)
    if (ier.ne.1) then
      error = .true.
    else
      call aroba(line,nline,error)
    endif
    goto 30
    !
    ! SIC_EXEC
  elseif (icode.eq.code_exec) then
    !----------------------------------------------------------------------
    !       Execute a single SIC command, which may be @.
    !       Upon completion return to the caller.
    !----------------------------------------------------------------------
    if (.not.loaded) then
      call sic_message(seve%f,'SIC','SIC is not loaded')
      call sysexi(fatale)
    endif
    !
    ! Increment execution depth
    nlire = nlire+1
    mlire(nlire) = -1
    lire = -1
    if_depth(nlire) = if_current+1
    error = .false.
    nline = lenc(line)
    suite = .false.
    call sblanc(line,nline,suite,ier)
    if (ier.ne.1) then
      error = .true.
    else
      call aroba(line,nline,error)
    endif
    goto 30
  endif
  !
  ! Restore interactive mode: moved to label 20...
  !      LIBRARY_MODE = .FALSE.
  !
  ! Store in log file
50 nline=lenc(line)
  if (nline.eq.0) goto 10
  if (.not.error .and. vocab(ccomm%icom)(1:1).ne.'*') then
    call sic_log (line,nline,lire)
    if (do_log) then
      if (nlire.ge.1 .and. liro.eq.0    .and.  &  ! LIRO here
          vocab(ccomm%icom)(1:1).ne.'#' .and.  &
          vocab(ccomm%icom)(1:1).ne.'$')  &
         call insert(oline,nolin)
      !  call insert(line,nline)
    endif
    do_log = logbuf
  endif
  !
  ! Handle errors and Control_C trapping
10 continue
  call ctrlc_check(error)
  !
  ! Get the original command line again
  line = oline
  nline = nolin
  !
  call erreur(error,line,nline,lire,err)
  if (err) then
    ! SYSTEM call or SIC call?
    if (sic_format_system_token(line,nline)) then
      goto 31
    else
      suite = .false.
      call sblanc(line,nline,suite,ier)
      if (ier.ne.1) then
        error = .true.
        goto 30                  ! Yes, not 40 in this case
      else
        call aroba(line,nline,error)
        goto 40
      endif
    endif
  endif
  !
  if (nlire.eq.0) then
    ! If NLIRE=0, exit from SIC. This happens in not-interactive mode, e.g.
    ! shell> sic < foo.sic
    call gmaster_on_exit(error)
    lenter = .false.
    ocode  = code_exit
    return
    !
  elseif (mlire(nlire).eq.-1) then
    ! Decrease the level and stop execution of the current one (code_end)
    nlire = nlire-1
    if (nlire.ne.0) then
      lire = mlire(nlire)
    else
      lire = 0
    endif
    call reset_if (err)
    ocode = code_end           ! End CODE_EXEC loop
    return
  endif
  !
  ! Read a new command
20 error = .false.
  library_mode = .false.       ! Restore interactive mode
  lire=mlire(nlire)
  !
  call bldprt(nlire)           ! Build prompt
  !D print *,'TEST Calling GETCOM ',error
  call getcom(line,nline,lire,gprompt,lgprompt,error)
  !D print *,'TEST GetCom error ',error,line(1:nline)
  ! Save command line
  !      OLINE = LINE(1:NLINE)
  !      NOLIN = NLINE
  !
  ! Command processing
30 continue
  if (error) then
    if (sic_quiet) goto 20
    goto 10
  endif
  !
  ! System call
31 continue
  !
  ! The $ is only allowed interactively. Use SYSTEM command otherwise
  if (line(1:1).eq.'$' .and. .not.compil) then
    if (mlire(nlire).eq.0) then
      ier = gag_system (line(2:nline))
      if (do_log) call insert (line,nline)
      goto 20
    else
      call sic_message(seve%e,'SIC','$ is only valid at the interactive prompt')
      call sic_translate_system_token(line,nline,tmp,ntmp)
      call sic_message(seve%e,'SIC','Use instead: '//tmp(1:ntmp))
      error = .true.
      ! Save line for proper error prompt
      oline = line(1:nline)
      nolin = nline
      goto 10
    endif
  endif
  !
  ! End of level execution
  if (nline.eq.0) then
    if (compil) then
      call sic_message(seve%e,'SIC','Incorrect nesting of loops and macros')
      error = .true.
      goto 10
    endif
    nlire=nlire-1
    call reset_if (error)
    if (error) then
      call sic_message(seve%e,'SIC','Incorrect nesting of IF blocks')
    endif
    if (lire.gt.0) then
      call endmac
    elseif (lire.eq.-1) then
      if (nlire.ne.0) then
        lire = mlire(nlire)
      else
        lire = 0
      endif
      ocode = code_end         ! End CODE_EXEC loop
      return
      !
      ! This can happen if an ENDIF command is missing...
    elseif (lire.eq.-2) then
      mess = 'Invalid nesting of loop # and IF blocks'
      mess(25:25) = char(cloop+ichar('0'))
      call sic_message(seve%e,'SIC',mess)
      call finloo
      error = .true.
    endif
    goto 10
  endif
  !
40 continue
  ! Save command line
  oline = line(1:nline)
  nolin = nline
  !
  ! Translate symbols
  call replace_symbol(line,nline,error)
  if (error) then
    if (sic_quiet) goto 20
    goto 10
  endif
  !
  ! Translate Logical Names
  call replace_logical(line,nline,error)
  if (error) then
    if (sic_quiet) goto 20
    goto 10
  endif
  !
  ! Check for alternate syntax A = Something
100 continue
  freelet = .false.
  if (lsynt.gt.1) then
    call setlet(line,nline,freelet,error)
    if (error) then
      if (sic_quiet) goto 20
      goto 10
    endif
  endif
  !
  ! Find the command
  if (line(1:1).eq.' ')  goto 10
  !
  if (line(1:nline).eq.'C '.or.line(1:nline).eq.'c ') then
    ! Single letter 'C' assumed to be unambiguous reference to 'CONTINUE'.
    line = 'CONTINUE'
    nline= 8
  endif
  !
  if (proced .or. compil) then
    continue  ! Do nothing at this stage
    !
  else
    !
    ! Debug macros if requested
    if (lire.gt.0) then
      if (sic_stepin.gt.0 .and. nline.gt.1) then
        if (.not.lverif) call sic_wprn(line(1:nline)//' ? ',ans,n)
      endif
    endif
    !
    ! Interpret
    call sic_find(command,line,nline,error)
    if (error) then
      if (sic_quiet) goto 20
      goto 10
    endif
    lang = ccomm%lang
    !
    ! Patch for user commands
    if (languages(ccomm%ilang)%user) then
      if (logbuf .and. nlire.ge.1 .and. lire.eq.0)  call insert(line,nline)
      do_log = .false.
      call replace_usercom(languages(ccomm%ilang),command,line,nline,error)
      ! Reprocess the command by GETCOM: it may contain several
      ! commands in one line:
      ! print *,'TEST PUTCOM ',Line(1:nline)
      call putcom(line,nline,error)
      ! print *,'TEST ',Line(1:nline)
      goto 100
    endif
  endif
  !
  liro=lire
  !
  ! Procedure definition
  if (proced) then
    call sic_proced(line,nline,error)
    goto 10
  endif
  !
  if (compil) then
    ! Compilation of loop
    call sic_compil(line,nline,goto_code,error)
    !
    select case (goto_code)
    case(20)
      goto 20
    case(40)
      goto 40
    case default
      goto 10
    end select
    !
  elseif (nlire.gt.0 .and. if_current.ge.if_depth(nlire)) then
    ! Exploration of an IF block
    call sic_ifblock(line,nline,command,goto_code,error)
    !
    select case (goto_code)
    case(10)
      goto 10
    case(20)
      goto 20
    case(50)
      goto 50
    end select
    ! Default => continue
  endif
  !
  ! Execution : User commands
  if (ccomm%icom.gt.mbuilt_sic_inter) return  ! Command is not a basic SIC\ one.
  ! This assumes that SIC\ is the first language loaded and that the
  ! commands below are the first in this language.
  call sic_run_comm(command,line,nline,ocode,recall,nolog,error)
  ! Take care of some commands which can return with ERROR true AND
  ! OCODE.NE.0  (QUIT [ALL], RETURN ERROR). OCODE has precedence in this
  ! case (we should not retrieve more command lines before leaving
  ! 'sic_run', else they could be ignored by caller).
  if (ocode.ne.0)  return
  if (error)  goto 10
  if (recall.eq.1)  goto 40  ! Sic call
  if (nolog) goto 10
  !
  ! Handle log file and stack
  goto 50
  !
end subroutine sic_run
!
subroutine sic_if(case)
  use sic_interpreter
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(in) :: case  !
  ignore_if = case
end subroutine sic_if
!
subroutine sic_run_comm(command,line,nline,ocode,recall,nolog,error)
  use sic_dependencies_interfaces
  use gbl_message
  use sic_interfaces, except_this=>sic_run_comm
  use sic_interactions
  use sic_interpreter
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Execute a basic SIC\ command. A "basic" SIC command is one of these
  ! SIC\ commands which is deeply bound with the SIC interpreter, i.e.
  ! which can not be executed out of it.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: command  ! Command
  character(len=*), intent(inout) :: line     ! Command line
  integer(kind=4),  intent(inout) :: nline    ! Length of command line
  integer(kind=4),  intent(out)   :: ocode    ! Output code
  integer(kind=4),  intent(out)   :: recall   ! Execute a new command?
  logical,          intent(out)   :: nolog    ! Log it or not on return?
  logical,          intent(inout) :: error    ! Logical error flag (intent(out)?)
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: goto_code,nc
  character(len=132) :: comarg
  logical :: all,err,logi,ifconstruct
  integer(kind=4) :: lstart,lend
  character(len=message_length) :: mess
  !
  ! Do not log all these commands: control-flow like IF ENDIF would
  ! fill up the message file:
  ! call sic_message(seve%c,rname,line(1:nline))
  !
  recall = 0       ! No command to execute on return
  nolog = .false.  ! By default, log the command on return
  !
  ! SIC Commands
  select case (command)
  !
  ! IF logical test processing
  case('IF')
    if (ignore_if) then
      nolog = .true.
      return
    endif
    !
    if (if_current.ge.mcif) then
      call sic_message(seve%e,rname,'Too many IF blocks')
      error = .true.
      return
    elseif (lire.eq.0) then
      mess = 'Command '//trim(command)//' is invalid in this context'
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    else
      call sic_ifconstruct('IF',line,2,.true.,ifconstruct,error)
      if (error)  return
    endif
    !
    ! Evaluate logical expression
    call sic_l4 (line,0,1,logi,.true.,error)
    if (error)  return
    if (ifconstruct) then
      ! IF block construst
      if_current = if_current + 1
      if_last = if_current
      if (logi) then
        if_active(if_current) = .true.
        if_elsefound(if_current) = .false.
        if_finished(if_current) = .false.
      elseif (.not.error) then
        sic_quiet = .true.
        if_active(if_current) = .false.
        if_elsefound(if_current) = .false.
        if_finished(if_current) = .false.
      endif
    else
      ! Logical IF statement (single line)
      if (logi) then
        lstart = sic_start(0,2)
        lend = sic_end(0,sic_narg(0))
        line = line(lstart:lend)
        nline = lend-lstart+1
        recall = 1
      endif
    endif
  !
  ! @ Start procedure execution
  case('@')
    call sic_message(seve%c,rname,line(1:nline))
    if (nliro.ne.-42) nliro = nlire
    liro  = lire
    call exemac (line,error)
    if (error)  return
    if_depth(nlire) = if_current+1 ! Set start depth level
    call sic_log (line,nline,liro)
    if (do_log .and. nliro.ge.1 .and. liro.eq.0) then
      call insert(oline,nolin)
    endif
    nolog = .true.
  !
  ! BEGIN Procedure/Data/Help
  case('BEGIN')
    sic_quiet_proced = sic_quiet
    call begin_area (line,error)
    nolog = .true.
  !
  ! EDIT : Calls stack or file editor
  case('EDIT')
    if (.not.sic_present(0,1)) then
      call edit_stack(error,.true.)
      nolog = .true.
    else
      call sic_ch (line,0,1,comarg,nc,.true.,error)
      if (error)  return
      call sic_parsef(comarg,mess,' ',sicext(1))
      call editor (mess,error)
    endif
  !
  ! EXIT : end SIC keyboard execution (not necessarily program execution)
  case('EXIT')
    call sic_message(seve%c,rname,line(1:nline))
    if (gmaster_get_ismaster().eq.1) then  ! SIC master
      call sic_run_exit(line,ocode,error)
      if (error)  return
#if defined(GAG_USE_PYTHON)
    else  ! Python master
      ! In this case (EXIT or CTRL-D), we only go back to Python prompt.
      ! This seems however a poor man solution, we should probably leave
      ! properly the current execution levels.
      call gpy_interact()
#endif
    endif
  !
  ! FOR : Start Loop execution or compilation
  case('FOR')
    call iniloo (line,nline,error)
    if (error)  return
    gprompt_nlire_old = -10
    if (compil) then
      ifllev (cloop) =  if_last
    else
      call exeloo (error)
      if (error)  return
      call sic_log (line,nline,liro)
      nolog = .true.
    endif
  !
  ! HELP : Display HELP text
  case('HELP')
    call sic_help(line,error)
    if (do_log .and. nliro.ge.1 .and. liro.eq.0) then
      call insert(oline,nolin)
    endif
    nolog = .true.
  !
  ! NEXT : Loop on FOR command
  case('NEXT')
    if (sic_narg(0).gt.1) then
       call sic_message(seve%e,'NEXT','Invalid number of arguments')
       error = .true.
       return
    endif
    if (nlire.eq.1) then
      nolog = .true.
      return
    endif
    if (mlire(nlire).eq.0) then
      if (mlire(nlire-1).eq.-2) then
        nlire=nlire-1
      else
        nolog = .true.
        return
      endif
    elseif (mlire(nlire).ne.-2) then
      nolog = .true.
      return
    endif
    call exeloo (error)
    if (error)  return
    call sic_log (line,nline,liro)
    nolog = .true.
  !
  ! ON : Handle error recovery command
  case('ON')
    call sic_message(seve%c,rname,line(1:nline))
    call sic_on(line,error)
    if (do_log .and. nliro.ge.1 .and. liro.eq.0) then
      call insert(oline,nolin)
    endif
    call sic_log (line,nline,lire)
    nolog = .true.
  !
  ! PAUSE : Interrupt procedure or loop execution
  case('PAUSE')
    if ((lire.lt.0 .or. lire.gt.0).and..not.lverif) then
      mess = ''
      call sic_ch(line,0,1,mess,nc,.false.,error)
      if (error)  continue
      mess = gprompt(1:lgprompt)//trim(command)//"  "//mess(1:nc)
      write (*,'(A)') trim(mess)
    endif
    nliro = nlire
    call break
    if (do_log .and. nliro.ge.1 .and. liro.eq.0) then
      call insert(line,nline)
    endif
    call sic_log (line,nline,lire)
    nolog = .true.
  !
  ! QUIT : Abort (with error) Loop or Procedure execution
  case('QUIT')
    if (nlire.lt.2) then
      nolog = .true.
      return
    endif
    comarg = ' '
    call sic_ke (line,0,1,comarg,nc,.false.,error)
    if (error)  return
    all = comarg.eq.'ALL'
    if (mlire(nlire).ne.0) then
      ! This is probably wrong
      nolog = .true.
      return
    endif
    nlire = nlire-1            ! Leave error processing level
    ! DO ... UNTIL (NLIRE.EQ.1 .OR. .NOT.ALL)
70  error = .true.
    ! Loop
    if (mlire(nlire).le.-2) then
      call finloo
      ! Program
    elseif (mlire(nlire).eq.-1) then
      nlire = nlire-1
      lire = mlire(nlire)
      call reset_if (err)
      ocode = code_end         ! End CODE_EXEC loop
      write(mess,'(A,L)') 'Quitting with error ',error
      call sic_message(seve%i,'QUIT',mess)
      return
      ! Procedure
    elseif (mlire(nlire).ne.0) then
      call endmac
      nlire = nlire-1
      call reset_if (err)
      ! Interactive input
    else
      ! The following line is ABSOLUTELY necessary. It MUST be executed
      ! when one has called interactively a procedure from a PAUSE level, to
      ! ensure that QUIT ALL returns at this interactive level. If this
      ! line is not present, SIC loops forever...
      return
    endif
    ! DO 70 UNTIL (NLIRE.EQ.1 .OR. .NOT.ALL)
    if (all.and.nlire.gt.1) goto 70
  !
  ! BREAK : Abort (without error) Loop execution
  case('BREAK')
    if (mlire(nlire).le.-2) then
      call finloo
    else
      nolog = .true.
    endif
  !
  ! RETURN : Abort (without error) current procedure execution, unless argument
  ! BASE is present. In the latter case, abort all nested procedures.
  case('RETURN')
    call sic_message(seve%c,rname,line(1:nline))
    comarg = ' '
    call sic_ke (line,0,1,comarg,nc,.false.,error)
    if (error)  return
    all = comarg.eq.'BASE'
    error = comarg.eq.'ERROR'
    !
    ! First abort loops from this level if the previous one is a macro
    ! DO 80 ... UNTIL .NOT.(ALL.AND.NLIRE.GT.1)
80  continue
    if (mlire(nlire).eq.0) then
      nolog = .true.
      return
    elseif (mlire(nlire).eq.-2 .and. nlire.gt.2) then
      if (mlire(nlire-1).eq.0) then
        nolog = .true.
        return
      else
        do while (mlire(nlire).eq.-2)
          call finloo
        enddo
      endif
    endif
    if (mlire(nlire).eq.-1) then
      nlire = nlire-1
      lire = mlire(nlire)
      call reset_if (err)
      ocode = code_end         ! End CODE_EXEC loop
      write(mess,'(A,L)') 'Returning with error ',error
      call sic_message(seve%i,'RETURN',mess)
      return
    else
      call endmac
    endif
    nlire = nlire-1
    call reset_if (err)
    ! DO 80 ... UNTIL .NOT.(ALL.AND.NLIRE.GT.1)
    if (all.and.nlire.gt.1) goto 80
  !
  ! TYPE : List stack or file
  case('TYPE')
    call sic_type(line,.true.,goto_code,error)
    if (goto_code.ne.50) then
      ! Do not put in stack
      nolog = .true.
    endif
  !
  ! CONTINUE : Resume interrupted execution
  case('CONTINUE')
    nolog = .true.
    if (lire.ne.0)  return
    if (nlire.eq.1)  return
    nlire = nlire-1
    lire = mlire(nlire)
    call sic_log (line,nline,lire)
  !
  ! PYTHON
  case('PYTHON')
    call sic_message(seve%c,rname,line(1:nline))
    call sic_run_python(line,.true.,error)
    !
  case default
    !
    if (ignore_if) then
      if (command.eq.'ELSE' .or. command.eq.'END') then
        nolog = .true.
        return
      endif
    endif
    call sic_message(seve%e,rname,'Command '//trim(command)//' is invalid in this context')
    error = .true.
    !
  end select
  !
end subroutine sic_run_comm
!
function sic_format_system_token(line,nline)
  use sic_interfaces, except_this=>sic_format_system_token
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Detect $ token and reformat the line properly before execution.
  !---------------------------------------------------------------------
  logical :: sic_format_system_token
  character(len=*), intent(inout) :: line
  integer(kind=4),  intent(inout) :: nline
  !
  integer(kind=4) :: idollar
  !
  sic_format_system_token = .false.
  if (compil)  return
  idollar = index(line,'$')
  if (idollar.le.0)  return
  !
  if (idollar.eq.1) then
    sic_format_system_token = .true.
  elseif (line(1:idollar-1).eq.' ') then
    sic_format_system_token = .true.
    line(1:nline) = line(idollar:nline)
    nline = nline-idollar+1
  else
    ! There are other characters before the $ token, so it is not a
    ! system token. Do nothing.
  endif
end function sic_format_system_token
!
subroutine sic_run_exit(line,ocode,error)
  use sic_interfaces, except_this=>sic_run_exit
  use sic_interactions
  use sic_interpreter
  !---------------------------------------------------------------------
  ! @ private
  ! Perform proper actions for the EXIT command
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(inout) :: ocode
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: exit_code,i
  logical :: all,err
  !
  ! Command line parsing
  ! Set the 'noprompt' flag according to EXIT /NOPROMPT:
  call gmaster_set_exitnoprompt(sic_present(1,0))
  ! Set the exit code
  exit_code = 0
  call sic_i4(line,0,1,exit_code,.false.,error)
  if (error)  continue  ! ?
  call gmaster_set_exitcode(exit_code)
  !
  all = .false.
  do i=1,nlire
    if (mlire(i).eq.-1) all = .true.
  enddo
  if (.not.all) then
    call gmaster_on_exit(error)
    if (error)  return
    lenter = .false.
    ocode = code_exit        ! Final EXIT for program
    return
  else
90  continue
    ! Loop
    if (mlire(nlire).le.-2) then
      call finloo
      ! Program : return
    elseif (mlire(nlire).eq.-1) then
      nlire = nlire-1
      lire = mlire(nlire)
      call reset_if (err)
      ocode = code_end       ! End CODE_EXEC loop
      return
      ! Procedure
    elseif (mlire(nlire).ne.0) then
      call endmac
      nlire = nlire-1
      call reset_if (err)
    else
      nlire = nlire-1
    endif
    if (nlire.gt.1) goto 90
    lire = 0
    nlire = 0
    call reset_if (err)
    ocode = code_end         ! End CODE_EXEC loop
    return
  endif
  !
end subroutine sic_run_exit
!
subroutine sic_proced(line,nline,error)
  use sic_interfaces, except_this=>sic_proced
  use sic_dependencies_interfaces
  use sic_dictionaries
  use sic_interpreter
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Compilation mode for BEGIN PROC/END PROC blocks
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Input command line
  integer,          intent(inout) :: nline  ! Line length
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=command_length) :: command
  character(len=132) :: comarg
  integer :: nc
  integer, parameter :: mvoc_end=4
  character(len=16) :: vocab_end(mvoc_end),keyword
  ! Data
  data vocab_end /'IF','PROCEDURE','HELP','DATA'/
  !
  if (freelet) then
    ! If 'freelet' is .true., we suspect the command line to be a
    ! FREE SYNTAX assignment. This implies to skip the BEGIN/END
    ! recognition hereafter. The command line written in the
    ! procedure in not translated.
    command = ' '
    !
  else
    call sic_find(command,line,nline,error)
    if (error) then
      call sic_message(seve%d,'SIC','Ignoring error in procedure definition')
      error = .false.
    endif
    !
    if (command.eq.'BEGIN') then
      call sic_message(seve%e,'END','Invalid nested BEGIN/END block')
      error = .true.
      return
      !
    elseif (command.eq.'END') then
      call sic_ke(line,0,1,comarg,nc,.true.,error)
      if (error)  return
      call sic_ambigs('END',comarg,keyword,nc,vocab_end,mvoc_end,error)
      if (error)  return
      !
      if (keyword.eq.'PROCEDURE') then
        call close_procedure(command,line,nline,error)
        sic_quiet = sic_quiet_proced
        return
      elseif (keyword.ne.'IF') then
        call sic_message(seve%e,'END','Invalid END '//trim(keyword)//  &
        ' statement in procedure definition')
        error = .true.
        return
      endif
    endif
  endif
  !
  ! Any command, including END IF
  call write_procedure(command,line,nline,error)
  if (error) then
    call close_procedure(command,line,nline,error)
    sic_quiet = sic_quiet_proced
  endif
  !
end subroutine sic_proced
!
subroutine sic_compil(line,nline,goto_code,error)
  use sic_dependencies_interfaces
  use sic_interpreter
  use sic_dictionaries
  use sic_interactions
  use sic_interfaces, except_this=>sic_compil
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Compilation mode for FOR/NEXT blocks
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line       ! Input command line
  integer,          intent(inout) :: nline      ! Line length
  integer,          intent(out)   :: goto_code  ! Where to go on return?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=command_length) :: command
  character(len=132) :: comarg
  integer :: nc
  character(len=message_length) :: mess
  logical :: ifconstruct
  !
  goto_code = 10
  !
  if (freelet) then
    command = ' '
  else
    call sic_find(command,line,nline,error)
    if (error) then
      command = ' '
      error = .false.
      if (mlire(nlire).eq.0) then
        call sic_message(seve%e,'SIC','Ignoring error in FOR block')
        return  ! Interactive level 0: do not save erroneous command in
                ! the FOR/NEXT block
      endif  ! Else, save it and raise an error at execution for safety
    endif
  endif
  !
  if (command.eq.'BEGIN' ) then
    call sic_message(seve%e,'SIC','Command '//trim(command)//' is invalid in this context')
    error = .true.
    return
  elseif (command.eq.'END') then
    call sic_ke(line,0,1,comarg,nc,.true.,error)
    if (error) then
      return
    elseif  (comarg.ne.'IF') then
      call sic_message(seve%e,'END','Command '//trim(command)//' is invalid in this context')
      error = .true.
      return
    endif
  elseif (command.eq.'QUIT') then
    call aboloo
    gprompt_nlire_old = -10
    mess = 'SIC'//backslash//'QUIT'
    if (do_log) call sic_insert(mess)
    call sic_log(mess,8,liro)
    return
  elseif (command.eq.'HELP'.and.mlire(nlire).eq.0) then
    call sic_help(line,error)
    goto 20
  elseif (command.eq.'TYPE'.and.mlire(nlire).eq.0) then
    call sic_type(line,.false.,goto_code,error)
    goto 20
  endif
  !
  if (ccomm%icom.gt.0 .and. vocab(ccomm%icom)(1:1).eq.'#') then
    call sic_message(seve%w,'FOR','Line not valid in this context, ignored')
    return
  elseif (command.eq.'NEXT') then
    if (ifllev(cloop).ne.if_last) then
      call sic_message(seve%e,'SIC','Invalid nesting of loops and IF')
      error = .true.
      return
    endif
  endif
  !
  if (command.eq.'FOR') then
    call iniloo(line,nline,error)
    if (error) return
    ifllev (cloop) = if_last
  else
    call insloo(line,nline,error)
    if (error) return
    if (command.eq.'IF') then
      call sic_ifconstruct('IF',line,2,.true.,ifconstruct,error)
      if (error)  return
      ! Increment the IF deepness only in case of IF block construct
      ! (as opposed to single-line logical IF statement)
      if (ifconstruct)  if_last = if_last+1
    elseif (command.eq.'END') then   ! END IF checked before
  ! elseif (command.eq.'ENDIF') then
      if_last = if_last-1
    endif
  endif
  !
  call sic_log (line,nline,liro)
  if (do_log) then
    if (nlire.ge.1 .and. lire.eq.0 .and. vocab(ccomm%icom)(1:1).ne.'#')  &
      call insert(line,nline)
  endif
  if (error) return
  !
  if (command.eq.'NEXT') then
    if (sic_narg(0).eq.1) then
      call verify_loop_variable (cloop,line,error)
      if (error) return
    else if (sic_narg(0).gt.1) then
      call gag_message(seve%e,'NEXT','Wrong number of arguments')
      error = .true.
      return
    endif
    if (cloop.eq.ifloop(nlire+1)+1) then
      indice(cloop) = 0.0
      nlire = nlire + 1
      mlire(nlire) = -2
      if_depth(nlire) = if_current+1
      compil = .false.
      lasllo (cloop) = loolen
      lasblo (cloop) = bulend
      call exeloo (error)
      gprompt_nlire_old = -10
    else
      call delete_loop_variable (cloop)
      lasllo (cloop) = loolen
      lasblo (cloop) = bulend
      cloop = ploop(cloop)
    endif
  endif
  !
  return
  !
20 goto_code = 20
  return
end subroutine sic_compil
!
subroutine sic_ifblock(line,nline,command,goto_code,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_ifblock
  use sic_interactions
  use sic_interpreter
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! IF block exploration
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       ! Command line
  integer(kind=4),  intent(in)    :: nline      ! Length of command line
  character(len=*), intent(in)    :: command    !
  integer(kind=4),  intent(out)   :: goto_code  !
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=32) :: comarg
  integer(kind=4) :: nc
  logical :: ifconstruct,dolog
  !
  goto_code = 10  ! Default: error handling
  !
  ! If exploring an IF block, look for special commands
  if (command.eq.'BEGIN') then
    call sic_message(seve%e,'SIC','Command '//trim(command)//' is invalid in this context')
    error = .true.
    return
  elseif (command.eq.'END') then
    call sic_ke(line,0,1,comarg,nc,.true.,error)
    if (error) then
      return
    elseif (comarg.ne.'IF') then
      call sic_message(seve%e,'END','Command '//trim(command)//' is invalid in this context')
      error = .true.
      return
    endif
  endif
  !
  if (.not.if_active(if_current)) then
    ! The active part of the IF block was not yet found. Check for IF,
    ! ELSE[IF] or ENDIF, and activate the coming part if relevant.
    if (command.eq.'IF') then
      call sic_ifconstruct('IF',line,2,.true.,ifconstruct,error)
      if (error)  return
      ! Increment the IF deepness only in case of IF block construct
      ! (as opposed to single-line logical IF statement)
      if (ifconstruct)  if_last = if_last+1
    elseif (if_last.eq.if_current) then
      call sic_ifblock_elseend(line,nline,command,dolog,error)
      if (error)  return
      if (dolog)  goto 50
    elseif (command.eq.'END') then
      if_last = if_last-1
    endif
    ! Skip all other commands
    goto 20
    !
  elseif (.not.if_finished(if_current)) then
    ! The active part of the IF block was already found (if_active(if_current)
    ! == .true.) but it is not yet finished (if_finished(if_current) ==
    ! .false.). In other words, we are currently executing it. Check for ELSE[IF]
    ! or ENDIF, and deactivate the current part if relevant. Otherwise execute
    ! the command since we are in the active block.
    !
    ! Looking for ELSE, ELSE IF, or ENDIF
    call sic_ifblock_elseend(line,nline,command,dolog,error)
    if (error)  return
    if (dolog)  goto 50
    ! Execute all other commands
    !
  else
    ! The active part of the IF block was already found (if_active(if_current)
    ! == .true.) and it is already finished (if_finished(if_current) ==
    ! .true.). Check for new IF subblock (inactive since this part is inactive),
    ! ELSE[IF] or ENDIF, and leave the current IF block if relevant.
    !
    if (command.eq.'IF') then
      call sic_ifconstruct('IF',line,2,.true.,ifconstruct,error)
      if (error)  return
      ! Increment the IF deepness only in case of IF block construct
      ! (as opposed to single-line logical IF statement)
      if (ifconstruct)  if_last = if_last+1
      !
    elseif (if_last.eq.if_current) then
      call sic_ifblock_elseend(line,nline,command,dolog,error)
      if (error)  return
      if (dolog)  goto 50
      !
  ! elseif (command.eq.'ENDIF') then
    elseif (command.eq.'END') then
      if_last = if_last-1
    endif
    ! Skip all other commands. Skip in particular ELSE and ELSE IF statements
    ! in non active IF subblocks.
    goto 20
  endif
  goto_code = 0
  return
  !
20 goto_code = 20
  return
50 goto_code = 50  ! Same as goto_code 0 except command line is logged
  return
  !
end subroutine sic_ifblock
!
subroutine sic_ifblock_elseend(line,nline,command,dolog,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_ifblock_elseend
  use sic_interactions
  use sic_interpreter
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Parsing of END or ELSE [IF] in an IF block
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: nline
  character(len=*), intent(in)    :: command
  logical,          intent(out)   :: dolog
  logical,          intent(inout) :: error
  ! Local
  character(len=32) :: comarg
  integer(kind=4) :: nc
  logical :: ifconstruct,logi
  !
  ! NB: THIS MAKES SENSE ONLY IF if_last == if_current
  !
  dolog = .false.
  if (command.eq.'END') then  ! Caller checked this is a END IF
    sic_quiet = .false.
    if_active(if_current) = .false.
    if_elsefound(if_current) = .false.
    if_finished(if_current) = .true.
    if_current = if_current-1
    if_last = if_current
    if (lverif .and. lire.ne.0)  &
      call sic_echo (gprompt,lgprompt,line,nline)
    dolog = .true.
    !
  elseif (command.eq.'ELSE') then
    !
    comarg = ' '
    call sic_ke(line,0,1,comarg,nc,.false.,error)
    if (error) return
    !
    if (comarg.eq.' ') then
      ! ELSE (no argument)
      if (if_elsefound(if_current)) then
        call sic_message(seve%e,'ELSE','Duplicate ELSE statements in IF-ENDIF block')
        error = .true.
        return
      endif
      if_elsefound(if_current) = .true.
      if (.not.if_active(if_current)) then
        ! The active part of the IF block was not yet found. This ELSE part
        ! becomes the active one:
        sic_quiet = .false.
        if_active(if_current) = .true.
        if_finished(if_current) = .false.
      else
        ! The active part of the IF block was already found. Finish it (may be
        ! it was already finished earlier, harmless doing it twice)
        sic_quiet = .true.
        if_finished (if_current) = .true.
      endif
      !
    elseif (comarg.eq.'IF') then
      ! ELSE IF: check syntax
      if (if_elsefound(if_current)) then
        call sic_message(seve%e,'ELSE','ELSE IF statement cannot follow ELSE statement')
        error = .true.
        return
      endif
      call sic_ifconstruct('ELSEIF',line,3,.false.,ifconstruct,error)
      if (error)  return
      if (.not.ifconstruct) then
        call sic_message(seve%e,'ELSEIF','Invalid IF statement for an ELSEIF')
        error = .true.
        return
      endif
      if (.not.if_active(if_current)) then
        ! The active part of the IF block was not yet found. Is this ELSEIF active?
        call sic_l4 (line,0,2,logi,.true.,error)
        if (error)  return
        if (logi) then
          sic_quiet = .false.
          if_active(if_current) = .true.
          if_finished(if_current) = .false.
        endif
      else
        ! The active part of the IF block was already found. Finish it (may be
        ! it was already finished earlier, harmless doing it twice)
        sic_quiet = .true.
        if_finished (if_current) = .true.
      endif
      !
    else
      call sic_message(seve%e,'ELSE','Invalid argument '//comarg(1:12))
      error = .true.
      return
    endif
    if (lverif .and. lire.ne.0)  &
      call sic_echo (gprompt,lgprompt,line,nline)
    !
    dolog = .true.
  endif
  ! Do nothing here for all other commands
  !
end subroutine sic_ifblock_elseend
!
subroutine reset_if(error)
  use sic_interfaces, except_this=>reset_if
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(out) :: error  !
  ! Local
  integer :: i,ifgood
  !
  ! New corrected logic
  ifgood = if_depth(nlire+1)-1
  !
  if (if_current.gt.ifgood) then
    error = .true.
    do i=ifgood+1,if_current
      if_active(i) = .false.
      if_elsefound(i) = .false.
      if_finished(i) = .true.
    enddo
    if_current = ifgood
    if_last = ifgood
  else
    error = .false.
  endif
  sic_quiet = .false.
end subroutine reset_if
!
subroutine sic_ifconstruct(rname,iline,iarg,allowed,ifconstruct,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>sic_ifconstruct
  use sic_structures
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Detect if command line "[ELSE] IF (Logi) ..." is an IF statement
  ! or an IF construct
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname        ! Calling routine name
  character(len=*), intent(in)    :: iline        ! Input command line
  integer(kind=4),  intent(in)    :: iarg         !
  logical,          intent(in)    :: allowed      ! IF statement allowed or not?
  logical,          intent(out)   :: ifconstruct  ! Is an IF construct or not?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=5) :: cthen  ! Length 5 on purpose (i.e. typo THENN would be a syntax error)
  integer(kind=4) :: nc
  character(len=commandline_length) :: line,buff
  type(sic_command_t), save :: command  ! Save'd to enable the optimization in sic_parse_line
  !
  cthen = 'THEN'
  call sic_ke(iline,0,iarg,cthen,nc,.false.,error)
  if (error)  return
  ifconstruct = cthen.eq.'THEN'
  if (ifconstruct) then
    if (sic_narg(0).gt.iarg) then
      call sic_message(seve%e,rname,'Trailing arguments after THEN')
      error = .true.
    endif
    return
  endif
  !
  ! Found a candidate IF statement
  if (allowed) then
    ! Check if it is a valid command line
    line = iline(sic_start(0,iarg):)
    nc = len_trim(line)
    call replace_symbol(line,nc,error)
    if (error) return
    call sic_parse_line(line,nc,.true.,sic_quiet,command,buff,error)
    if (error)  return
  else
    ! Forbidden => syntax error
    call sic_message(seve%e,rname,'Invalid syntax')
    error = .true.
    return
  endif
  !
end subroutine sic_ifconstruct
!
subroutine setlet(line,nline,freelet,error)
  use sic_interfaces, except_this=>setlet
  use sic_interactions
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Check if input line is a free syntax assignment (e.g "A = 1"). If
  ! yes, add a "SIC\LET" command at the beginning of the line.
  ! If not in execution mode (i.e. COMPIL and PROCED), we cannot check
  ! if variable really exists.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line     ! Modified on return
  integer,          intent(inout) :: nline    !
  logical,          intent(inout) :: freelet  ! Can possibly be a free syntax assignment?
  logical,          intent(inout) :: error    !
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=256) :: var
  character(len=2048) :: line1
  integer :: i,j,k,mcom,jline
  logical :: found
  !
  i = index(line(1:nline),' ')
  if ((i.eq.0).or.(i+2.ge.nline)) return
  if (line(i:i+2).ne.' = ') return
  !
  ! \ is present, must be a command
  if (index(line(1:i),backslash).ne.0) return
  !
  ! In procedure mode and compilation of loop, we can not rely on
  ! variable existence test. The line must be translated later on.
  if (proced .or. compil) then
    freelet = .true.
    return
  endif
  !
  ! Check if it is a known variable. Do not bother checking
  ! validity of subarrays.
  var = line(1:i-1)
  jline = index(var,'[')
  if (jline.eq.0) then
    jline = i-1
  else
    jline = jline-1
  endif
  !
  ! Check if variable exist
  found = sic_level(var(1:jline)).ge.0
  if (.not.found) return
  !
  ! Known variable
  !
  ! Check if it is a known command
  if (jline.lt.len(vocab(1))) then
    do k=1,nlang
      if (.not. (languages(k)%asleep.or.languages(k)%libmod) ) then
        j = mbuilt(k-1)
        mcom = mbuilt(k)
        do while (j.lt.mcom)
          j = j+1
          !
          ! Return an error if exact match: syntax is ambigous
          if (sic_eqchain(var(1:jline),vocab(j)(2:))) then
            call sic_message(seve%e,'INTER',var(1:jline)//' is ambiguous: '//  &
            'command or variable ?')
            error = .true.
            return
          endif
          j = j+nopt(j)
        enddo
      endif
    enddo
  endif
  !
  ! A true variable: assume assignment...
  line1 = 'SIC'//backslash//'LET '//line
  nline = min(len(line),nline+8)
  line = line1
end subroutine setlet

module mapping_interfaces_none
  interface
    subroutine big_wait(n,b)
      real, intent(inout) :: b
      integer, intent(in) :: n
    end subroutine big_wait
  end interface
  !
  interface
    subroutine map_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine map_message_set_id
  end interface
  !
  interface
    subroutine mapping_pack_set(pack)
      use gpack_def
      !----------------------------------------------------------------------
      ! Can not be in a module as it is called by mapping-pyimport.c and
      ! mapping-sicimport.c
      !----------------------------------------------------------------------
      type(gpack_info_t), intent(out) :: pack
    end subroutine mapping_pack_set
  end interface
  !
end module mapping_interfaces_none

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CLASSIC messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module classic_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer(kind=4) :: classic_message_id = gpack_global_id  ! Default value for startup message
  !
end module classic_message_private
!
subroutine classic_message_set_id(id)
  use gbl_message
  use classic_interfaces, except_this=>classic_message_set_id
  use classic_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: id         !
  ! Local
  character(len=message_length) :: mess
  !
  classic_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',classic_message_id
  call classic_message(seve%d,'classic_message_set_id',mess)
  !
end subroutine classic_message_set_id
!
subroutine classic_message(mkind,procname,message)
  use gkernel_interfaces
  use classic_message_private
  !---------------------------------------------------------------------
  ! @ private
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(classic_message_id,mkind,procname,message)
  !
end subroutine classic_message
!
subroutine classic_iostat(mkind,procname,ier)
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>classic_iostat
  !---------------------------------------------------------------------
  ! @ private
  ! Output system message corresponding to IO error code IER, and
  ! using the MESSAGE routine
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message severity
  character(len=*), intent(in) :: procname  ! Calling routine name
  integer,          intent(in) :: ier       ! IO error number
  ! Local
  character(len=message_length) :: msg
  !
  if (ier.eq.0) return
  call gag_iostat(msg,ier)
  call classic_message(mkind,procname,msg)
  !
end subroutine classic_iostat
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine load_map(error)
  use gkernel_interfaces
  use xymap_def
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! MAP initialization routine:
  ! MAP language is loaded.
  !---------------------------------------------------------------------
  logical, intent(out) :: error     ! Error status
  ! Local
  integer(kind=4), parameter :: mmap=3 ! MAP Language
  character(len=12) :: vocab_map(mmap)
  character(len=76) :: version
  !
  external :: run_map
  !
  data version /'0.2 22-Oct-2008 J.P.'/
  data vocab_map / &
       ' XY_MAP', '/NOGRID','/TYPE' /
!      ' APODISE', &
!      ' DECONVOLVE'/
  !
  error = gterrtst()
  call sic_begin('MAP','GAG_HELP_MAP',mmap,vocab_map,version,run_map,gterrtst)
  !
  call init_xymap_struct(sic_xymap_user)
  call define_sic_xymap(error)
  !
end subroutine load_map
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine run_map(line,comm,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! MAP Main library entry point
  !     Call appropriate subroutine according to COMM
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  character(len=*), intent(in)  :: comm   ! Command name
  logical,          intent(out) :: error  ! Error status
  ! Local
  character(len=80) :: mess
  !
  call class_message(seve%c,'MAP',line)
  !
  if (comm.eq.'XY_MAP') then
     call xymap(line,error)
!!$  elseif (comm.eq.'APODISE') then
!!$     !
!!$  elseif (comm.eq.'DECONVOLVE') then
!!$     !
  else
     mess = 'MAP'//char(92)//comm//' Unknown command'
     call class_message(seve%e,'MAP',mess)
     error = .true.
  endif
  !
end subroutine run_map
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemask_language
  use cubetools_parameters
  use cubetools_structure
  use cubemask_messaging
  !
  use cubemask_cube
  use cubemask_erode
  use cubemask_invert
  use cubemask_poly2mask
  use cubemask_velocity
  !
  public :: cubemask_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubemask_register_language(error)
    !----------------------------------------------------------------------
    ! Register the MASK\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'MASK',&
         'J.Pety, S.Bardeau',&
         'Commands to interact with masks',&
         'MASK helps you define where emission is trusted before running&
         & science measurements.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- POLY2MASK turns polygon selections into reusable mask&
         & cubes.'//strg_cr//&
         '- CUBE and VELOCITY apply mask logic so downstream analysis&
         & keeps only selected voxels.'//strg_cr//&
         '- ERODE and INVERT refine mask boundaries or invert selection&
         & logic when needed.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> MASK\POLY2MASK [cubid]'//strg_cr//&
         'CUBE> MASK\ERODE [maskid]'//strg_cr//&
         'CUBE> MASK\CUBE [cubid]',&
         'gag_doc:hlp/cube-help-mask.hlp',&
         cubemask_execute_command,&
         langid,&
         error)
    if (error) return
    !----------------------------------------------------------------------
    !
    call cube%register(error)
    if (error) return
    call cubemask_erode_register(error)
    if (error) return
    call cubemask_invert_register(error)
    if (error) return
    call poly2mask%register(error)
    if (error) return
    call velocity%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubemask_register_language
  !
  subroutine cubemask_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the MASK\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'MASK?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubeadm_finish_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubemask_execute_command
end module cubemask_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine get_resu (form,dimr,noper,ioper,operand,iresul,error)
  use sic_interfaces, except_this=>get_resu
  use gildas_def
  use sic_dependencies_interfaces
  use sic_expressions
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !  Get a new pointer to descriptor of result.
  !---------------------------------------------------------------------
  integer :: form                           ! Format of result (R4, R8, L)
  integer(kind=size_length) :: dimr         ! Dimension of result
  integer :: noper                          ! Number of operands
  integer :: ioper(noper)                   ! Pointer to operand descriptors
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands
  integer :: iresul                         ! Pointer to result descriptor
  logical :: error                          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer :: i,ier
  integer(kind=size_length) :: size
  !
  error = .false.
  size = dimr
  if (form.eq.fmt_r8 .or. form.eq.fmt_i8) size=2*size
  !
  ! In final result if possible
  if (operand(0)%type.eq.form .and. operand(0)%size.eq.size) then
    if (operand(0)%status.eq.free_operand) then
      iresul = 0
      operand(0)%status = interm_operand
      return
    endif
    !
    ! Then among operands (of this operation) that point to the final result
    do i=1,noper
      if (operand(ioper(i))%status.eq.interm_operand) then
        iresul = ioper(i)
        return
      endif
    enddo
  endif
  !
  ! Then among the other operands of this operation.
  do i=1,noper
    if (operand(ioper(i))%status.eq.scratch_operand .and.  &
        size.eq.operand(ioper(i))%size) then
      iresul = ioper(i)
      return
    endif
  enddo
  !
  ! Then among remaining free operands
  do i=1,maxoper
    if (operand(i)%status.eq.free_operand .and. size.eq.operand(i)%size) then
      iresul = i
      operand(i)%status = scratch_operand
      return
    endif
  enddo
  ! Allocate memory if nothing else works
  do i=1,maxoper
    if (operand(i)%status.eq.empty_operand) then
      ier = sic_getvm (size,operand(i)%addr)
      if (ier.ne.1) then
        call sic_message(seve%e,rname,'Memory allocation failure')
        error = .true.
        return
      endif
      operand(i)%type = form
      operand(i)%readonly = .false.
      operand(i)%ndim = 1
      operand(i)%dims(1) = dimr
      operand(i)%size = size
      operand(i)%status = scratch_operand
      iresul = i
      return
    endif
  enddo
  !
  ! Else apologize
  call sic_message(seve%e,rname,'Too many operands')
  error = .true.
end subroutine get_resu
!
subroutine free_oper (form,dimr,noper,ioper,operand,iresul,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>free_oper
  use gildas_def
  use sic_expressions
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Free useless operands and move pointers to current result.
  !---------------------------------------------------------------------
  integer :: form                           ! Format of result (R4, R8, L)
  integer(kind=size_length) :: dimr         ! Dimension of result
  integer :: noper                          ! Number of operands
  integer :: ioper(noper)                   ! Pointer to operand descriptors
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands
  integer :: iresul                         ! Pointer to result descriptor
  logical :: error                          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FREE_OPER'
  integer :: i
  character(len=message_length) :: mess
  !
  do i=1,noper
    if (operand(ioper(i))%status.eq.scratch_operand) then
      if (ioper(i).ne.iresul) then
        operand(ioper(i))%status = free_operand
        ! write (6,*) 'Freed operand ',IOPER(I)
      endif
    elseif (operand(ioper(i))%status.eq.empty_operand) then
      write (mess,*) 'Operand ',ioper(i),'was EMPTY'
      call sic_message(seve%u,rname,mess)
      write (mess,*) 'Operand ',ioper(i),'was READ'
      call sic_message(seve%u,rname,mess)
      ! Used result array a intermediate storage, nothing wrong with that
    elseif (operand(ioper(i))%status.eq.interm_operand) then
      continue
      ! Static operand, do nothing for this one
    elseif (operand(ioper(i))%status.eq.user_defined     .or.  &
            operand(ioper(i))%status.eq.readonly_operand .or.  &
            operand(ioper(i))%status.eq.program_defined) then
      continue
    else
      write (mess,*) 'Unknown operand status',operand(ioper(i))%status, &
        ' for ',ioper(i)
      call sic_message(seve%u,rname,mess)
    endif
  enddo
  !
  ! Assign result : Free IOPER(2) descriptor and
  ! move result descriptor in IOPER(2). Could be optimised
  ! by transmitting back pointers, or at least pushing
  ! the descriptor to an EMPTY place to avoid wasting memory.
  !
  operand(iresul)%type = form
  operand(iresul)%readonly = .false.
  if (ioper(1).ne.iresul) then
    if ( operand(ioper(1))%status.eq.free_operand ) then
      call free_vm (operand(ioper(1))%size,operand(ioper(1))%addr)
      ! write(6,*) 'Deleted FREE operand ',IOPER(1)
      ! Should never happen given the above code...
    elseif (operand(ioper(1))%status.eq.scratch_operand) then
      call free_vm (operand(ioper(1))%size,operand(ioper(1))%addr)
      write(mess,*) 'Deleted SCRATCH operand ',ioper(1)
      call sic_message(seve%u,rname,mess)
    endif
    operand(ioper(1)) = operand(iresul)
    if (iresul.ne.0) then
      operand(iresul)%type = 0
      operand(iresul)%readonly = .false.
      operand(iresul)%addr = 0
      operand(iresul)%ndim = 0
      operand(iresul)%dims(:) = 0
      operand(iresul)%size = 0
      operand(iresul)%status = empty_operand
    endif
  endif
  ! write(6,*) 'Called FREE_OPER'
end subroutine free_oper

!
!----------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoOnOff">
!   <VERSION>
!                Id: modulePakoOnOff.f90,v 1.2.4 2015-07-15 Hans Ungerechts
!                Id: modulePakoOnOff.f90,v 1.2.3 2014-10-27 Hans Ungerechts
!                Id: modulePakoOnOff.f90,v 1.2.3 2014-02-10 Hans Ungerechts
!                Id: modulePakoOnOff.f90,v 1.2.3 2014-02-03 Hans Ungerechts
!                                          1.2.0 2012-08-16 Hans Ungerechts
!                based on
!                Id: modulePakoOnOff.f90,v 1.1.0 2009-03-25 Hans Ungerechts
!   </VERSION>
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>
!                Calibrate
!                Focus
!                OnOff
!                OtfMap
!                Pointing
!                Tip
!                Track
!                VLBI
!   </SIBLINGS>        
!
!   Pako module for command: ONOFF
!
! </DOCUMENTATION> <!-- name="modulePakoOnOff" -->
!
!----------------------------------------------------------------------
!
Module modulePakoOnOff
  !
  Use modulePakoMessages
  Use modulePakoTypes
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  !
  Public :: onOff
  Public :: displayOnOff
  Public :: saveOnOff
  Public :: startOnOff
  Public :: plotOMOnOff
  !     
  ! *** Variables for OnOff ***
  Include 'inc/variables/variablesOnOff.inc'
!!!   
!!!   
Contains
!!!
!!!
  Subroutine OnOff(programName, line, command, error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer                :: iQuery
    Character(len=lenCh)   :: nameQuery
    Logical                :: isSet
    Type(xyPointType)      :: pointResult
    !
    Logical               :: isConnected   = .False.
    !
    Include 'inc/ranges/rangesOnOff.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module OnOff, v 1.2.4 2015-07-15  --> SR: OnOff ")                 ! trace execution
    !
    ! *** initialize ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    !     read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    Call checkNofParameters(command,                                             &
         &     0, 2,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       !
       Include 'inc/parameters/parametersOffsetsSourceName.inc'
       Include 'inc/options/readOptionsOnOff.inc'
       !
       ! NB: swWobbler gets evaluated last, so that
       !     it  overrules other parameters and options 
       Include 'inc/options/optionSwWobbler.inc'
       !
    End If
    !
    ! *** set defaults ***
    Include 'inc/options/optionDefaults.inc'
    !
    ! *** read Parameters, Options (again, after defaults!) ***
    !     and check for validity and ranges 
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       !
       Include 'inc/parameters/parametersOffsetsSourceName.inc'
       Include 'inc/options/readOptionsOnOff.inc'
       !
       ! NB: swWobbler gets evaluated last, so that
       !     it  overrules other parameters and options 
       Include 'inc/options/optionSwWobbler.inc'
       !
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.error) Then
       !
       errorInconsistent = .False.
       !
       l = Len_trim(command)
       !
       If (.Not. vars(iIn)%doReference) Then
          errorInconsistent = .True.
          Write (messageText,*) "is required for ONOFF"
          Call pakoMessage(priorityE,severityE,                                  &
               &           command(1:l)//"/"//"REFERENCE",messageText)           !
       End If
       !
       If (vars(iIn)%doReference                                                 &
            &  .And. vars(iIn)%systemNameRef.Ne.vars(iIn)%systemName) Then       !
          errorInconsistent = .True.
          GV%notReadyOnOff  = .True.
          Write (messageText,*) "different values for /SYSTEM ",                 &  
               &  "and /REFERENCE are not yet allowed "                          !
          Call pakoMessage(priorityE,severityE,                                  &
               &           command(1:l)//"/"//"REFERENCE",messageText)           !
       End If
       !
       If (vars(iIn)%tSubscan .Lt. 5*GV%tRecord) Then
          If (vars(iIn)%tSubscan .Lt. 3*GV%tRecord) Then
             errorInconsistent = .True.
             Write (messageText,*)    "must be at least 3 times "                &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityE,severityE,                               &
                  &           command(1:l)//"/"//"tSubscan",messageText)         !
          Else
             Write (messageText,*)    "should be at least 5 times "              &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityW,severityW,                               &
                  &           command(1:l)//"/"//"tSubscan",messageText)         !
          End If
       End If
       !
       If (Mod(vars(iIn)%nSubscans,2).Ne.0) Then
          errorInconsistent = .True.
          Write (messageText,*) "nSubscans must be a multiple of 2"
          Call pakoMessage(priorityE,severityE,                                  &
               &           command(1:l)//"/"//"nSubscans",messageText)           !
       End If
       !
       If (vars(iIn)%doSymmetric .And. Mod(vars(iIn)%nSubscans,4).Ne.0) Then
          errorInconsistent = .True.
          Write (messageText,*) "for option /SYMMETRIC yes, "//                  &
               &                "/nSubscans must be a multiple of 4"             !
          Call pakoMessage(priorityE,severityE,                                  &
               &           command(1:l),messageText)                             !
       End If
       !
       If (GV%switchingMode.Eq.swMode%Beam) Then
          errorInconsistent = .True.
          GV%notReadyOnOff  = .True.
          Write (messageText,*)  "will not work with switching mode ",           &
               &                 swModePako%Beam                                 !
          Call PakoMessage(priorityE,severityE,command(1:l),messageText)
       End If
       !
       If (GV%switchingMode.Eq.swMode%Freq) Then
          errorInconsistent = .True.
          GV%notReadyOnOff  = .True.
          Write (messageText,*)  "will not work with switching mode ",           &
               &                 swModePako%Freq                                 !
          Call PakoMessage(priorityE,severityE,command(1:l),messageText)
       End If
       !
       If      (       GV%switchingMode.Ne.swMode%Wobb                           &
            &    .And. (      vars(iIn)%doSwWobbler                              &
            &            .Or. vars(iIn)%doSwWobbler )                            &
            &  )                                                                 &
            &  Then                                                              !
          errorInconsistent = .True.
          GV%notReadyOnOff  = .True.
          Write (messageText,*)  "can not use /swWobbler with switching mode ",  &
               &                 GV%switchingMode                                !
          Call PakoMessage(priorityE,severityE,command(1:l),messageText)
          Write (messageText,*)  "first set ",                                   &            
               &                 COMpako%swWobbler                               !
          Call PakoMessage(priorityI,severityI,command(1:l),messageText)
       End If
       !
       Call queryReceiver(rec%bolo, isConnected)
       If (isConnected .And. GV%switchingMode.Eq.swMode%Wobb                     &
            &          .And. Abs(GV%secondaryRotation).GT.0.005) Then            !
          errorInconsistent = .True.
          GV%notReadyOnOff  = .True.
          Write (messageText,*)                                                  &
               &   "does not (yet) work with SWWOBBLER and SET 2ndRotation ",    &
               &                 GV%secondaryRotation                            !
          Call PakoMessage(priorityE,severityE,command(1:l),messageText)
       End If
       !
       iQuery    = vars(iIn)%iSystem
       nameQuery = GPnone
       Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
       !D              Write (6,*)    "     vars(iIn)%iSystem:   ", vars(iIn)%iSystem
       !D              Write (6,*)    "     isSet:               ", isSet
       If (isSet) Then
          doWarnOffsets = .True.
          Write (messageText,*)  " NOTE: the offsets set with OFFSETS /system "  &
               &                   //vars(iIn)%SystemName//                      &
                                 " will be ignored!"                             !
          Call PakoMessage(priorityW,severityW,command(1:l)//" /SYSTEM",         &
               &                               messageText)                      !
          Write (messageText,*)                                                  &
               &    " -- i.e., they are not added to those of the "              &
               &    //"observing mode ONOFF"                                     !
          Call PakoMessage(priorityW,severityW,                                  &
               &    command(1:l)//" /SYSTEM",                                    &
               &    messageText)                                                 !
       Else
          doWarnOffsets = .False.
       End If
       !
       If (.Not. errorInconsistent) Then
          vars(iTemp) = vars(iIn)
       End If
       !
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)    = vars(iTemp)
    End If
    !
    ! *** display values ***
    If (.Not. ERROR) Then
       Call displayOnOff
    End If
    !
    ! *** set "selected" observing mode & plot ***
    If (.Not.error) Then
       GV%observingMode     = OM%onOff
       GV%observingModePako = OMpako%onOff
       GV%omSystemName      = vars(iValue)%systemName 
       GV%notReadySWafterOM = .False.
       GV%notReadySecondaryRafterOM = .False.
       GV%notReadyOffsetsAfterOnOff  = .False.
       GV%notReadyOnOff     = .False.
       OnOffCommand         = line(1:lenc(line))
       Call analyzeOnOff (errorA)
       Call listSegmentList (errorA)
       Call plotOMOnOff (errorP)
    End If
    !
    Return
  End Subroutine OnOff
!!!
!!!
  Subroutine analyzeOnOff (errorA)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer                :: nScan 
    Character (len=lenCh)  :: aUnit, sUnit
    Integer                :: iSS           = 0     ! counts subcans/segment
    !
    Integer                :: iQuery
    Character(len=lenCh)   :: nameQuery
    Logical                :: isSet
    Type(xyPointType)      :: pointResult
    !
    errorA    = .False.
    iSS       = 0
    nScan     = 1111
    aUnit     = GV%angleUnitC                        ! 
    sUnit     = GV%speedUnitC                        ! 
    !
    ! TBD: calibrate subscans 
    !
    segList(:) = segDefault
    !
    Call countSubscans(value=0)
    Call countSegments(value=0)
    !
    Do kk = 1, vars(iValue)%nSubscans, 1
       !
       Call countSubscans(ii)
       Call countSegments(jj)
       !
       If      (                                                                 &
            &       .Not.vars(iValue)%doSymmetric .And. Mod(kk,2) .Eq. 0         &
            &   .Or.     vars(iValue)%doSymmetric .And. Mod(kk,4) .Eq. 2         &
            &   .Or.     vars(iValue)%doSymmetric .And. Mod(kk,4) .Eq. 3         &
            &  ) Then                                                            !
          !!  ** ON-source 
          segList(ii)%newSubscan =  .True.
          segList(ii)%scanNumber =  nScan
          segList(ii)%ssNumber   =  ii
          segList(ii)%segNumber  =  1
          segList(ii)%ssType     =  ss%track
          segList(ii)%segType    =  seg%track
          segList(ii)%angleUnit  =  aUnit
          segList(ii)%speedUnit  =  sUnit
          segList(ii)%flagOn     =  .True.
          segList(ii)%flagRef    =  .False.
          segList(ii)%pStart     =  vars(iValue)%offset
          segList(ii)%pEnd       =  segList(ii)%pStart
          segList(ii)%speedStart =  0.0
          segList(ii)%speedEnd   =  0.0
          segList(ii)%systemName =  vars(iValue)%systemName
          segList(ii)%altOption  =  'tSegment'
          segList(ii)%tSegment   =  vars(iValue)%tSubscan
          segList(ii)%tRecord    =  0.1
       Else If (                                                                 &
            &        .Not.vars(iValue)%doSymmetric .And. Mod(kk,2) .Eq. 1        &
            &   .Or.      vars(iValue)%doSymmetric .And. Mod(kk,4) .Eq. 1        &
            &   .Or.      vars(iValue)%doSymmetric .And. Mod(kk,4) .Eq. 0        &
            &  ) Then                                                            !
          !!  ** OFF-source Reference
          segList(ii)%newSubscan =  .True.
          segList(ii)%scanNumber =  nScan
          segList(ii)%ssNumber   =  ii
          segList(ii)%segNumber  =  1
          segList(ii)%ssType     =  ss%track
          segList(ii)%segType    =  seg%track
          segList(ii)%angleUnit  =  aUnit
          segList(ii)%speedUnit  =  sUnit
          segList(ii)%flagOn     =  .False.
          segList(ii)%flagRef    =  .True.
          segList(ii)%pStart     =  vars(iValue)%offsetR
          segList(ii)%pEnd       =  segList(ii)%pStart
          segList(ii)%speedStart =  0.0
          segList(ii)%speedEnd   =  0.0
          segList(ii)%systemName =  vars(iValue)%systemNameRef
          segList(ii)%altOption  =  'tSegment'
          segList(ii)%tSegment   =  vars(iValue)%tSubscan
          segList(ii)%tRecord    =  0.1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !
          If (ii.Eq.1) Then
             segList(ii)%updateDoppler = .True.
             If (vars(iValue)%systemName.Eq.offs%pro) Then
                segList(ii)%pDoppler      = vars(iValue)%offset
             Else
                segList(ii)%pDoppler      = xyPointType(0.0,0.0)
             End If
             If (isSet .And. vars(iValue)%systemName.Ne.offs%pro) Then  !  OFFSETS /SYS PROJ
                segList(ii)%pDoppler      = pointResult
             End If
          Else If (GV%doDopplerUpdates) Then
             segList(ii)%updateDoppler = .True.
             If (vars(iValue)%systemName.Eq.offs%pro) Then
                segList(ii)%pDoppler      = vars(iValue)%offset
             Else
                segList(ii)%pDoppler      = xyPointType(0.0,0.0)
             End If
             If (isSet .And. vars(iValue)%systemName.Ne.offs%pro) Then  !  OFFSETS /SYS PROJ
                segList(ii)%pDoppler      = pointResult
             End If
          End If
          !
       End If
       !
    End Do
    !
    Call getCountSegments(nSegments)
    !
   Return 
    !
  End Subroutine analyzeOnOff
!!!
!!!
  Subroutine displayOnOff
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Include 'inc/display/commandDisplayOnOff.inc'
    !
  End Subroutine displayOnOff
!!!
!!!
  Subroutine plotOMOnOff (errorP)
    !
    !**   Variables  for Plots   ***
    Include 'inc/variables/headerForPlotMethods.inc'
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    errorP = .False.
    !
    Call configurePlots
    !
    Call plotOnOffStart(errorP)
    !
    Call plotSegmentList(errorP)
    !
    If (errorP)                                                                  &
         &        Call pakoMessage(priorityE,severityE,                          &
         &        'OnOff',' could not plot ')                                    !
    !
    Return
  End Subroutine plotOMOnOff
!!!
!!!
  Subroutine saveOnOff(programName,LINE,commandToSave,                           &
       &        iUnit, ERROR)                                                    !
    !
    !**   Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !      
    contC = contNN
    !
    Include 'inc/commands/saveCommand.inc'
    !
    contC = contCC
    !
    Include 'inc/parameters/saveOffsets.inc'
    !
    !TBD:      Include 'inc/options/saveBalance.inc'
    !TBD:      Include 'inc/options/saveCalibrate.inc'
    Include 'inc/options/saveNsubscans.inc'
    Include 'inc/options/saveReference.inc'
    Include 'inc/options/saveSymmetric.inc'
    Include 'inc/options/saveSystem.inc'
    !
    contC = contCN
    !
    Include 'inc/options/saveTsubscan.inc'
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveOnOff
!!!
!!!
  Subroutine startOnOff(programName,LINE,commandToSave,iUnit, ERROR)
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: messageText
    Logical                 :: errorL, errorXML
    !
    Call pakoXMLsetOutputUnit(iunit=iunit)
    Call pakoXMLsetIndent(iIndent=2)
    !
    Include 'inc/startXML/generalHead.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module OnOff, v 1.2.0  --> SR: startOnOff ")                       ! trace execution
    !
    Call writeXMLset(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call pakoXMLwriteStartElement("RESOURCE","pakoScript",                       &
         &                         comment="save from pako",                     &
         &                         error=errorXML)                               !
    Call pakoXMLwriteStartElement("DESCRIPTION",                                 &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/savePakoScriptFirst.inc'
    !
    Call saveOnOff        (programName,LINE,commandToSave, iUnit, errorL)
    !                                                                       
    Call pakoXMLwriteEndElement("DESCRIPTION",                                   &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    Call pakoXMLwriteEndElement  ("RESOURCE","pakoScript",                       &
         &                         space="after",                                &
         &                         error=errorXML)                               !
    !
    Call writeXMLantenna(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call writeXMLreceiver(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call writeXMLbackend(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Include 'inc/startXML/switchingMode.inc'
    !
    Call writeXMLsource(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Include 'inc/startXML/generalScanHead.inc'
    !
    ! **  Observing Mode to XML
    If (gv%doXMLobservingMode) Then
       messageText = "writing observing mode in XML format"
       Call PakoMessage(priorityI,severityI,                                     &
               &           commandToSave,messageText)                            !
       Call writeXMLonOff(programName,LINE,commandToSave,                        &
         &         iUnit, ERROR)                                                 !
    End If
    !
    ! **  subscan list to XML
    Call writeXMLsubscanList(programName,LINE,commandToSave,iUnit, ERROR)
    !   
    Include 'inc/startXML/generalTail.inc'
    !
    Return
  End Subroutine startOnOff
!!!
!!!
  Subroutine writeXMLonOff(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: iMatch, nMatch, len1, len2
    Character (len=lenCh)   :: valueC, errorCode
    Character (len=lenLine) :: valueComment
    Logical                 :: errorM, errorXML
    !
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module OnOff, v 1.2.3  --> SR: writeXMLOnOff 2014-10-27")          ! trace execution
    !
    ERROR = .False.
    !
    Call pakoXMLwriteStartElement("RESOURCE","observingMode",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    valueC = GV%observingMode
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/parametersOffsetsXML.inc'
    !
    Include 'inc/startXML/optionSystemXML.inc'
    Include 'inc/startXML/optionReferenceXML.inc'
    Include 'inc/startXML/optionNsubscansXML.inc'
    Include 'inc/startXML/optionTsubscanXML.inc'
    Include 'inc/startXML/optionSymmetricXML.inc'
    Include 'inc/startXML/optionSwWobblerXML.inc'
    !
    Include 'inc/startXML/annotationsXML.inc'
    !
    Call pakoXMLwriteEndElement("RESOURCE","observingMode",                      &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLonOff
!!!
!!!
End Module modulePakoOnOff

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage GWCS messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gwcs_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: gwcs_message_id = gpack_global_id  ! Default value for startup message
  !
end module gwcs_message_private
!
subroutine gwcs_message_set_id(id)
  use gwcs_message_private
  use gbl_message
  use gwcs_interfaces, except_this=>gwcs_message_set_id
  !---------------------------------------------------------------------
  ! @ public
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  gwcs_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',gwcs_message_id
  call gwcs_message(seve%d,'gwcs_message_set_id',mess)
  !
end subroutine gwcs_message_set_id
!
subroutine gwcs_message(mkind,procname,message)
  use gwcs_dependencies_interfaces
  use gwcs_message_private
  use gbl_message
  use gwcs_interfaces, except_this=>gwcs_message
  !---------------------------------------------------------------------
  ! @ private
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(gwcs_message_id,mkind,procname,message)
  !
end subroutine gwcs_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module greg_axes
  !--------------------------------------------------------------------
  ! Variables and parameters used for plotting axes
  !--------------------------------------------------------------------
  logical, parameter :: jclock(8) =  &
    (/ .true.,.false.,.false.,.true.,.false.,.true.,.true.,.false. /)
  integer(4), parameter :: just(8) = (/ 0,0,2,2,2,2,0,0 /)
  real(8) :: smallx,smally              ! Minor tick spaces
  real(8) :: bigx,bigy                  ! Major tick spaces
  !
  ! Axes variables for 3D perspective plots
  real(4) :: xl1,xl2                    ! X-axis limits
  real(4) :: yl1,yl2                    ! Y-axis limits
  real(4) :: zmin,zmax                  ! Z level limits
  real(4) :: xposx,xposy                ! X label position
  real(4) :: yposx,yposy                ! Y label position
  logical :: doaxes                     !
end module greg_axes
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module greg_pen
  !--------------------------------------------------------------------
  ! Virtual pencils attributes
  !--------------------------------------------------------------------
  !
  integer(kind=4), parameter :: maxpen=15     ! Pen numbered from 0 to 15
  ! ZZZ
  integer(kind=4), parameter :: mincolour=-1  !
  integer(kind=4), parameter :: maxcolour=23  !
  integer(kind=4), parameter :: minusercolour=8
  integer(kind=4), parameter :: maxusercolour=maxcolour
  integer(kind=4), parameter :: mindashed=1   !
  integer(kind=4), parameter :: maxdashed=8   ! Same as max_dash in GTV
  integer(kind=4), parameter :: minweight=1   !
  integer(kind=4), parameter :: maxweight=5   !
  !
  ! Default pen number and attributes (PEN /DEF). NB: the last (15th) pen
  ! is used (by default) for negative contouring by RGMAP
  integer(kind=4), parameter :: defpen = 0
  ! Default color for each pen:
  character(len=10), parameter :: defcolname(0:maxpen) =  (/           &
    'FOREGROUND',                                                      &
    'RED       ','GREEN     ','BLUE      ','CYAN      ','YELLOW    ',  &
    'MAGENTA   ','BACKGROUND','FOREGROUND','FOREGROUND','FOREGROUND',  &
    'FOREGROUND','FOREGROUND','FOREGROUND','FOREGROUND','BLUE      '   /)
  ! Placeholder for colors id, resolved from above names once at startup
  integer(kind=4) :: defcolid(0:maxpen)
  !
  integer(kind=4), parameter :: defdashe(0:maxpen) =  &
                    (/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3 /)
  !
  ! Default weight for each pen (Greg number)
  integer(kind=4), parameter :: defweinum(0:maxpen) =  &
                    (/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 /)
  ! Placeholder for actual weights, resolved from above numbers once at startup
  real(kind=4) :: defweival(0:maxpen)
  !
  ! Current pen attributes (all pens)
  real(kind=4)    :: lweigh(0:maxpen)  ! [cm] Weights for all pens
  integer(kind=4) :: ldashe(0:maxpen)  ! Dashes for all pens
  integer(kind=4) :: lcolou(0:maxpen)  ! Colours for all pens
  !
  ! Current pen attributes (current pen)
  integer(kind=4) :: cpen = defpen  ! Current pencil number
  real(kind=4)    :: cweigh         ! [cm] Current weight factor
  integer(kind=4) :: cdashe         ! Current dash style
  integer(kind=4) :: ccolou         ! Current colour
  logical         :: penupd         ! Does GTV internal pen attributes
                                    ! need update at next segment creation?
  !
end module greg_pen
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module greg_xyz
  use gildas_def
  !--------------------------------------------------------------------
  ! X,Y,Z data arrays description
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !--------------------------------------------------------------------
  !
  real(kind=8), allocatable, target, save :: column_xyz(:,:)
  real(kind=8), pointer                   :: column_x(:)=>null()
  real(kind=8), pointer                   :: column_y(:)=>null()
  real(kind=8), pointer                   :: column_z(:)=>null()
  !
  integer(kind=4), save :: nxy  ! Number of data points
  integer(kind=4) :: maxxy      ! Current size of X,Y,Z allocation
  !
end module greg_xyz
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gdf_transpose (nameou,namein,code,space_gildas,error)
  use gsys_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_transpose
  use image_def
  use gbl_message
  use gio_params
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API routine
  !  Transpose a GILDAS image
  !  Disk version when needed
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: nameou        ! Output transposed file name
  character(len=*), intent(in)    :: namein        ! Input file name
  character(len=*), intent(inout) :: code          ! Transposition code
  integer(kind=4),  intent(in)    :: space_gildas  ! Useable memory size
  logical,          intent(inout) :: error         ! Error flag
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  type(gildas) :: in,ou
  integer(kind=index_length) :: nfirst,nsecon,nmiddl,iblock(5)
  logical :: isfits
  !
  call gildas_null (in)
  in%file = namein
  call sic_parse_file(namein,' ','.gdf',in%file)
  !
  call gdf_read_gdforfits_header(in%file,isfits,in,fd,error)
  if (error) return
  !
  call gdf_toobig(in,error)
  if (error)  goto 100
  !
  call gdf_transpose_header(in,ou,code,error)
  if (error) goto 100          ! Free the IN image...
  ou%file = nameou
  call sic_parse_file(nameou,' ','.gdf',ou%file)
  !
  ! Determine chunk sizes from code and dimensions.
  call transpose_getblock(in%gil%dim,gdf_maxdims,code,iblock,error)
  if (error) goto 100
  nfirst = iblock(2)
  nmiddl = iblock(3)
  nsecon = iblock(4)
  !
  if ((nfirst*nmiddl.eq.1 .or. nmiddl*nsecon.eq.1) .and. .not.isfits) then
    ! Degenerate transposition:
    ! Only the header is transposed in this case
    if (gag_filcopy(in%file,ou%file).ne.0) then
      call gio_message(seve%e,rname,  &
        'Failed to copy '//trim(in%file)//' into '//trim(ou%file))
      error = .true.
      return
    endif
    !
    ! Open the output file in Write mode, and update the header
    call gdf_open_image(ou,error)
    call gdf_update_header(ou,error)
    call gdf_close_image(ou,error)
    !
  elseif (gio_word_length(in).eq.4) then
    call gdf_transpose4(in,ou,code,iblock,space_gildas,isfits,error)
    !
  else
    call gio_message(seve%e,rname,'Format not yet supported')
    error = .true.
  endif
  if (error) goto 100
  !
100 continue
  if (.not.isfits)  call gdf_close_image(in,error)
  return
end subroutine gdf_transpose
!
subroutine gdf_transpose4(in,ou,code,iblock,space_gildas,isfits,error)
  use image_def
  use gbl_message
  use gsys_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_transpose4
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gildas),               intent(inout) :: in            !
  type(gildas),               intent(inout) :: ou            !
  character(len=*),           intent(in)    :: code          !
  integer(kind=index_length), intent(in)    :: iblock(5)     !
  integer(kind=4),            intent(in)    :: space_gildas  ! Useable memory size (MB)
  logical,                    intent(in)    :: isfits        !
  logical,                    intent(inout) :: error         !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=index_length) :: dimo(gdf_maxdims)
  integer(kind=index_length) :: nfirst,nsecon,nlast,nmiddl,nelems
  integer(kind=size_length) :: size
  real(kind=4) :: ratio
  !
  ! Create the image
  call gdf_create_image(ou,error)
  if (error)  return
  !
  dimo(:) = ou%gil%dim(:)  ! Save the dimensions
  !
  nelems = iblock(1)
  nfirst = iblock(2)
  nmiddl = iblock(3)
  nsecon = iblock(4)
  nlast  = iblock(5)
  !
  ! Remap the IN% and OU% headers to a 5-D array shape
  in%gil%ndim = 5
  in%gil%dim(1:5) = (/nelems,nfirst,nmiddl,nsecon,nlast/)
  ou%gil%ndim = 5
  ou%gil%dim(1:5) = (/nelems,nsecon,nmiddl,nfirst,nlast/)
  !
  ! This is a real transposition of Real*4 arrays
  size = nelems*nfirst*nmiddl*nsecon    ! Words
  ! Number of blocks required to read the 2 tables...
  ratio = 8.*size/space_gildas/1024./1024.
  !
  if (ratio.gt.1.) then
    ! The first 4 dimensions of the input and output tables do not
    ! fit in SPACE_GILDAS.
    call gdf_transpose4_disk(in,ou,iblock,space_gildas,isfits,error)
  else
    call gdf_transpose4_memory(in,ou,iblock,isfits,error)
  endif
  if (error)  goto 200
  !
  ! Restore the dimensions...
  ou%gil%dim(:) = dimo(:)
  !
  if (code.eq.'21' .and. (abs(ou%gil%type_gdf).eq.code_gdf_uvt)) then
    ! Treat the special case of UV Tables with Real*8 Data
    call gdf_transpose_uvcolumn8(ou,error)
  endif
  !
200 continue
  call gdf_close_image(ou,error)
  !
end subroutine gdf_transpose4
!
subroutine gdf_transpose4_disk(in,ou,iblock,space_gildas,isfits,error)
  use image_def
  use gbl_message
  use gsys_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_transpose4_disk
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! Perform the transposition on disk
  !---------------------------------------------------------------------
  type(gildas),               intent(inout) :: in            !
  type(gildas),               intent(inout) :: ou            !
  integer(kind=index_length), intent(in)    :: iblock(5)     !
  integer(kind=4),            intent(in)    :: space_gildas  ! Useable memory (MB)
  logical,                    intent(in)    :: isfits        !
  logical,                    intent(inout) :: error         !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  real(kind=4), allocatable :: din(:,:,:,:), dou(:,:,:,:)
  integer(kind=index_length) :: ilast, instep, oustep, lin, kin, lou, kou
  integer(kind=index_length) :: nfirst,nsecon,nlast,nmiddl,nelems
  integer(kind=4) :: ier,nloop,nslicein,nsliceou
  real(kind=4) :: nblock,fracin,fracou
  integer(kind=index_length), parameter :: zero=0
  type(time_t) :: time
  character(len=message_length) :: mess
  integer(kind=size_length) :: ndata,nblank
  integer(kind=record_length) :: datarec
  !
  call gio_message(seve%w,rname,'Arrays do not fit in memory, using disk')
  !
  nelems = iblock(1)
  nfirst = iblock(2)
  nmiddl = iblock(3)
  nsecon = iblock(4)
  nlast  = iblock(5)
  !
  ! Which fraction of SPACE_GILDAS for reading/writing IN and OU?
  ! Big question: do we divide the Input and Output evenly or not ?
  ! Answer: no. It is faster to traverse the input file a few times
  ! in small contiguous slices, rather than many times in large
  ! contiguous slices (see debug message below). So we allocate more
  ! memory to the output file, which means less contiguous output
  ! slices, which means traversing theinput file less times.
  fracin = .25
  fracou = .75
  write(mess,'(3(A,F0.2))')  'Input buffer: ',space_gildas*fracin,  &
    ' MB, output buffer: ',space_gildas*fracou,' MB'
  call gio_message(seve%d,rname,mess)
  !
  ! Compute the block size
  nblock = 4.*nelems*nfirst*nmiddl*nsecon/(space_gildas*1024.*1024.)  ! Float computations!
  instep = min(nsecon,ceiling(nsecon/nblock*fracin))
  oustep = min(nfirst,ceiling(nfirst/nblock*fracou))
  !
  allocate(din(nelems,nfirst,nmiddl,instep),  &
           dou(nelems,nsecon,nmiddl,oustep),stat=ier)
  if (ier.ne.0) then
    call gio_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    goto 200
  endif
  !
  nsliceou = 1+(nfirst-1)/oustep
  nslicein = 1+(nsecon-1)/instep
  write(mess,'(4(A,I0))')  'Writing output file in ',nsliceou,  &
    ' slices, reading input ',nsliceou,' times in ',nslicein,' slices'
  call gio_message(seve%d,rname,mess)
  !
  ! Keep memory of data starting position
  if (isfits)  call gfits_getrecnum(datarec)
  !
  ! Computing time statistics
  nloop = nlast*nsliceou*nslicein
  call gtime_init(time,nloop,error)
  if (error)  return
  !
  do ilast=1,nlast
    ! Loop on the 5th dimension, i.e. reduce the problem to 4D below:
    do kou=1,nfirst,oustep
      ! Select a slice of 'ou' in the 4th dimension [kou:kou+oustep[
      ou%blc(1:5) = (/zero,zero,zero,kou,ilast/)
      lou = min(kou+oustep-1,nfirst)
      ou%trc(1:5) = (/zero,zero,zero,lou,ilast/)
      if (isfits) then
        ! Make sure the FITS file is at the right position each time we
        ! restart reading from start
        call gfits_setrecnum(datarec)
        call gfits_flush_data(error)
        if (error)  goto 200
      endif
      do kin=1,nsecon,instep
        ! We have to read as many 'in' slices as needed to fill the 'ou'
        ! slice.
        in%blc(1:5) = (/zero,zero,zero,kin,ilast/)
        lin = min(kin+instep-1,nsecon)
        in%trc(1:5) = (/zero,zero,zero,lin,ilast/)
        ! !!Print *,'BLC ',in%blc
        ! !!Print *,'TRC ',in%trc
        if (isfits) then
          ndata = product(in%gil%dim(1:3))*(lin-kin+1)
          call gfits_getreal(fd,ndata,din,fd%bscal,fd%bzero,error)
          if (error) goto 200
          call fitscube2gdf_patch_bval(fd,in,din,ndata,nblank,error)
          if (error) goto 200
        else
          call gdf_read_data(in,din,error)
          if (error) goto 200
        endif
        call trans4slice(nelems,nfirst,nmiddl,nsecon,din,kin,lin,dou,kou,lou)
        call gtime_current(time)
      enddo
      call gdf_write_data(ou,dou,error)
      if (error) goto 200
    enddo
  enddo
  !
200 continue
  deallocate(din,dou)
  !
end subroutine gdf_transpose4_disk
!
subroutine gdf_transpose4_memory(in,ou,iblock,isfits,error)
  use image_def
  use gbl_message
  use gsys_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_transpose4_memory
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! Problem does fit in memory. Loop on the last dimension
  !---------------------------------------------------------------------
  type(gildas),               intent(inout) :: in         !
  type(gildas),               intent(inout) :: ou         !
  integer(kind=index_length), intent(in)    :: iblock(5)  !
  logical,                    intent(in)    :: isfits     !
  logical,                    intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  real(kind=4), allocatable :: din(:,:,:,:), dou(:,:,:,:)
  integer(kind=index_length) :: i
  integer(kind=index_length) :: nfirst,nsecon,nlast,nmiddl,nelems
  integer(kind=4) :: ier
  integer(kind=index_length), parameter :: zero=0
  type(time_t) :: time
  integer(kind=size_length) :: ndata,nblank
  !
  nelems = iblock(1)
  nfirst = iblock(2)
  nmiddl = iblock(3)
  nsecon = iblock(4)
  nlast  = iblock(5)
  !
  allocate(din(nelems,nfirst,nmiddl,nsecon),  &
           dou(nelems,nsecon,nmiddl,nfirst),stat=ier)
  if (ier.ne.0) then
    call gio_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    goto 200
  endif
  !
  ! Computing time statistics
  call gtime_init(time,int(nlast,kind=4),error)
  if (error)  return
  !
  ndata = product(in%gil%dim(1:4))  ! Total number of elements per slice
  do i=1,nlast
    in%blc(1:5) = (/zero,zero,zero,zero,i/)
    in%trc(1:5) = (/zero,zero,zero,zero,i/)
    ou%blc = in%blc
    ou%trc = in%trc
    if (isfits) then
      call gfits_getreal(fd,ndata,din,fd%bscal,fd%bzero,error)
      if (error) goto 200
      call fitscube2gdf_patch_bval(fd,in,din,ndata,nblank,error)
      if (error) goto 200
    else
      call gdf_read_data(in,din,error)
      if (error) goto 200
    endif
    call trans4(din,dou,nelems,nfirst,nmiddl,nsecon)
    call gdf_write_data(ou,dou,error)
    if (error) goto 200
    call gtime_current(time)
  enddo
  !
200 continue
  deallocate(din,dou)
  !
end subroutine gdf_transpose4_memory
!
subroutine gdf_transpose_uvcolumn8(ou,error)
  use image_def
  use gbl_message
  use gio_interfaces, except_this=>gdf_transpose_uvcolumn8
  !---------------------------------------------------------------------
  ! @ private
  !  Transpose the REAL*8 (2 words) columns which have been misordered
  ! by a previous transposition.
  !  GDF UV tables specific, because only GDF UV tables have data
  ! columns spread over several columns.
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: ou     !
  logical,      intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: iaxis,ier,i
  real(kind=4), allocatable :: tin(:,:), tou(:,:)
  !
  if (any(ou%gil%column_size.eq.2)) then 
    call gio_message(seve%w,rname,'UV Table with Real*8 columns')
    ou%blc = 0
    ou%trc = 0
    if (ou%gil%type_gdf.eq.code_gdf_tuv) then
      iaxis = 2
      allocate(tou(2,ou%gil%dim(1)), tin(ou%gil%dim(1),2), stat=ier)
    else
      iaxis = 1
      allocate(tin(2,ou%gil%dim(1)), tou(ou%gil%dim(1),2), stat=ier)
    endif
    if (ier.ne.0) then
      call gio_message(seve%w,rname,'Memory allocation error')
      error = .true.
      return
    endif
    do i=1,code_uvt_last
      if (ou%gil%column_size(i).eq.2) then
        ou%blc(iaxis) = ou%gil%column_pointer(i)
        ou%trc(iaxis) = ou%gil%column_pointer(i)+1
        !!Print *,'Reading code ',i,iaxis
        !!Print *,'OU dim ',ou%gil%dim(1:3)
        !!Print *,'BLC ',ou%blc(1:3)
        !!Print *,'TRC ',ou%trc(1:3)
        call gdf_read_data(ou, tin, error)
        !!Print *,'Done Reading  ',ERROR
        !!Print *,'Transposing '
        tou(:,:) = transpose (tin)
        !!Print *,'Done Transpose '
        !!Print *,'OU dim ',ou%gil%dim(1:3)
        !!Print *,'BLC ',ou%blc(1:3)
        !!Print *,'TRC ',ou%trc(1:3)
        call gdf_write_data (ou, tou, error)
        !!Print *,'Done wRITING  ',ERROR
      endif
    enddo
    deallocate (tin, tou, stat=ier)
  endif
  !
end subroutine gdf_transpose_uvcolumn8
!
subroutine gdf_nitems_4(logname,nitems,asize)
  use gio_dependencies_interfaces
  use gio_interfaces, only: gdf_nitems_8
  !---------------------------------------------------------------------
  ! @ public-generic gdf_nitems
  !   Return the number of items of size ASIZE in a block size specified
  !   by LOGNAME (typically SPACE_GILDAS)
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: logname
  integer(kind=4),  intent(out) :: nitems
  integer(kind=4),  intent(in)  :: asize

  call gdf_nitems_8(logname,nitems,int(asize,kind=8))
end subroutine gdf_nitems_4
!
subroutine gdf_nitems_8(logname,nitems,asize)
  use gio_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public-generic gdf_nitems
  !   Return the number of items of size ASIZE in a block size specified
  !   by LOGNAME (typically SPACE_GILDAS)
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: logname
  integer(kind=4),  intent(out) :: nitems
  integer(kind=8),  intent(in)  :: asize
  ! Local
  real(kind=4) :: rmega
  integer(kind=4) :: ier
  !
  rmega = 128  ! Default if logical is not defined
  ier = sic_ramlog(logname,rmega)
  nitems = (rmega*1024.*1024.)/real(asize)/4.  
end subroutine gdf_nitems_8

subroutine cdaten(cdate,ndate,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>cdaten
  !---------------------------------------------------------------------
  ! @ public
  !  Convert the date '01-JAN-1984' in integers for year, month, and day
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: cdate     ! String date
  integer(kind=4),  intent(out)   :: ndate(3)  ! Integer values
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=40) :: kdate
  character(len=3) :: m
  integer(kind=4) :: id, iy, im, idate(7), i, idx1, idx2, iend
  ! Data
  character(len=3), parameter :: cm(0:12) = (/ '***','JAN','FEB','MAR',  &
    'APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC' /)
  integer(kind=4), parameter :: cd(0:12) = (/0,31,29,31,30,31,30,31,31, 30,31,30,31/)
  !
  kdate = cdate
  call sic_upper(kdate)
  iend = lenc(kdate)
  call sic_blanc(kdate, iend)
  if (kdate(1:1) .eq. '*') then
    call utc(idate)
    do i=1, 3
      ndate(i) = idate(i)
    enddo
    return
  endif
  do i=1, iend
    if ((kdate(i:i).lt.'0' .and. kdate(i:i).ne.' ') .or. (kdate(i:i).gt.'9'  &
        .and. kdate(i:i).lt.'A') .or. kdate(i:i).gt.'Z') then
      kdate(i:i) = '-'
    endif
  enddo
  idx1 = index(kdate,'-')
  if (idx1 .le. 1) then
    goto 900
  else
    read(kdate(1:idx1-1),*,err=900) id
    idx2 = idx1 + index(kdate(idx1+1:iend),'-')
    if (idx2.le.idx1+1 .or. idx2.eq.iend) then
      goto 900
    else
      m = kdate(idx1+1:idx2-1)
      do im=1,12
        if (cm(im).eq.m) then
          goto 100
        endif
      enddo
      read(kdate(idx1+1:idx2-1),*,err=900) im
      100         read(kdate(idx2+1:iend),*,err=900) iy
    endif
    if (id.gt.cd(im)) goto 900
  endif
  ndate(1) = iy
  ndate(2) = im
  ndate(3) = id
  return
  !
  ! Wrong date
900  call astro_message(seve%e,'CDATEN','Date conversion error')
  error = .true.
  return
end subroutine cdaten
!
subroutine ndatec(ndate,cdate,error)
  use gbl_message
  use astro_interfaces, except_this=>ndatec
  !------------------------------------------------------------------------
  ! @ private
  !  Convert the integers for year, month, and day into date '01-JAN-1984'
  !------------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: ndate(3)  !
  character(len=*), intent(out)   :: cdate     !
  logical,          intent(inout) :: error     !
  ! Local
  integer(kind=4) :: ier
  character(len=3), parameter :: cm(0:12) = (/ '***','JAN','FEB','MAR',  &
    'APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC' /)
  !
  write(cdate,1001,iostat=ier) ndate(3), cm(ndate(2)), ndate(1)
  if (ier.ne.0) then
    call astro_message(seve%e,'NDATEC','Date conversion error')
    error = .true.
    return
  endif
  !
1001  format(i2.2,'-',a3,'-',i4.4)
end subroutine ndatec
!
subroutine ctimen(ctime,ntime,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>ctimen
  !---------------------------------------------------------------------
  ! @ public
  ! Converts the TIME '12:34:56.1234' in integers for Hours, Minutes,
  ! Seconds, and milliSeconds
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: ctime     !
  integer(kind=4),  intent(out)   :: ntime(4)  !
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=4) :: i, ndate(7), ltime
  real(kind=8) :: tt
  character(len=32) :: chain
  !
  ltime = len_trim(ctime)
  if (ctime(1:ltime).eq.'*') then
    call utc(ndate)            ! get current time
    do i = 1, 4
      ntime(i) = ndate(i+3)
    enddo
    return
  endif
  call sic_sexa (ctime,ltime,tt,error) ! TT in hours
  if (error) then
    call astro_message(seve%e,'CTIMEN','TIME conversion error')
    return
  endif
  if (tt.lt.0 .or. tt.gt.24d0) then
    write(chain,*) tt
    call astro_message(seve%e,'CTIMEN','Invalid time '//ctime(1:ltime)//' = '//chain)
    return
  endif
  ntime(1) = tt
  tt = (tt-ntime(1)) * 60.d0
  ntime(2) = tt
  tt = (tt-ntime(2)) * 60.d0
  ntime(3) = tt
  ntime(4) = (tt - ntime(3)) * 1000.d0
end subroutine ctimen
  !
subroutine ntimec(ntime,ctime,error)
  use gbl_message
  use astro_interfaces, except_this=>ntimec
  !---------------------------------------------------------------------
  ! @ private
  ! Converts the integers for Hours, Minutes, Seconds, milliSeconds to
  ! formatted TIME
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: ctime     !
  integer(kind=4),  intent(in)    :: ntime(4)  !
  logical,          intent(inout) :: error     !
  ! Local
  integer(kind=4) :: ier
  !
  write(ctime,1001,iostat=ier) ntime
  if (ier.ne.0) then
    call astro_message(seve%e,'NTIMEC','TIME conversion error')
    error = .true.
    return
  endif
1001  format(i2.2,':',i2.2,':',i2.2,'.',i3.3)
end subroutine ntimec
!
subroutine utc(date)
  use gbl_message
  use astro_interfaces, except_this=>utc
  !---------------------------------------------------------------------
  ! @ public
  !  Lecture de l'heure du systeme par appel des routines systeme
  ! SIC_DATE en sortie : DATE date gregorienne (year, month, day, hour,
  ! minute, second)
  !---------------------------------------------------------------------
  integer(kind=4), intent(out) :: date(7)  !
  ! Local
  character(len=*), parameter :: rname='UTC'
  logical :: error
  character(len=30) :: date_chain
  !
  date(:) = 0
  call sic_date(date_chain)
  !
  error = .false.
  call cdaten (date_chain,date(1:3),error)
  if (error)  goto 10
  call ctimen (date_chain(13:),date(4:7),error)
  if (error)  goto 10
  !
  return
  !
10 continue
  call astro_message(seve%e,rname,'Error decoding '''//trim(date_chain)//'''')
end subroutine utc
!
subroutine jdate_to_datetime(jdate,datetime,error)
  use astro_interfaces, except_this=>jdate_to_datetime
  !---------------------------------------------------------------------
  ! @ private
  ! Convert input Julian date to Astro's specific date-time formatted
  ! string e.g.:
  !    18-JAN-2018 11:03:33.400
  ! At least 24 characters are needed for the full output string.
  ! However, shorter strings are accepted. Result will be truncated,
  ! this may be useful to get e.g. the leading date part.
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)    :: jdate     !
  character(len=*), intent(out)   :: datetime  !
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=4) :: code(7),nd
  character(len=32) :: chain
  !
  ! Split date into 7 integers
  call jjdate(jdate,code)
  !
  ! Date part
  call ndatec(code(1:3),chain,error)
  if (error)  return
  nd = len_trim(chain)
  ! call sic_blanc(chain,nd)  ! Is this useful?
  !
  ! Time part
  call ntimec(code(4:7),chain(nd+2:),error)
  if (error)  return
  ! nt = len_trim(chain)
  ! call sic_blanc(chain,nt)  ! Is this useful?
  !
  datetime = chain  ! Copy/truncate here
  !
end subroutine jdate_to_datetime

subroutine sic_delvariable (var,user,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_delvariable
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (as calls with named arguments are used)
  !   Delete Variable VAR (any kind)
  !   If variable does not exist and request comes from user, an error
  ! is raised. If variable does not exist and request comes from
  ! program, no error is raised.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: var    ! Name of variable
  logical,          intent(in) :: user   ! User (TRUE) or Program request
  logical                      :: error  ! Return error code               Output
  ! Local
  character(len=*), parameter :: rname='DELETE'
  type(sic_identifier_t) :: varfound
  integer :: in,ier
  integer(kind=4) :: status
  logical :: local,luser,found
  character(len=message_length) :: mess
  !
  ! Locate the variable at current level
  varfound%name = var
  call sic_upper(varfound%name)
  varfound%lname = len_trim(var)
  varfound%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varfound,in)
  if (ier.ne.1) then
    ! Local variable not found: check for a global one if possible
    if (var_level.eq.0) then
      ! We are already at global level
      found = .false.
    else
      varfound%level = 0
      ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varfound,in)
      found = ier.eq.1
      local = .false.       ! Found a Global variable
    endif
  else
    found = .true.
    local = var_level.ne.0  ! Found a Local variable if level non zero
  endif
  if (.not.found) then
    if (user) then
      error = .true.
      call sic_message(seve%e,rname,'No such variable '//var)
    endif
    return
  endif
  !
  ! Delete variable according to its Status
  ! First delete the possible associated python SicVar instance
#if defined(GAG_USE_PYTHON)
  call gpy_delvar(varfound%name,varfound%level)
#endif
  !
  ! Second free the associated memory (or variables if it is a structure) after
  ! flushing to disk if needed
  luser = user
  status = dicvar(in)%desc%status
  !
  if (status.eq.alias_defined) then  ! It is an alias, just delete it from the list
    call zap_alias(in)
    luser = .true.  ! Aliases always considered as user-defined (see symetric
                    ! comment in sic_def_alias)
    !
  elseif (status.eq.user_defined) then ! Interactively defined by user
    call del_alias(in,local)  ! Delete its aliases
    if (dicvar(in)%desc%type.eq.0) then    ! User-def structure...
      call sic_delstructure(varfound,user,error)
      if (error)  call sic_message(seve%f,rname,'Error deleting structure '//  &
      var)
    else
      call free_vm(dicvar(in)%desc%size,dicvar(in)%desc%addr)
    endif
    !
  elseif (status.gt.0) then   ! Image variable mapped on a GIO slot, unmap
    call del_alias(in,local)  ! Delete the aliases
    call sic_delstructure(varfound,user,error)
    if (.not.dicvar(in)%desc%readonly) then    ! A writeable image/header
      ! Warn if Nvisi is lower than visibility axis
      if (gdf_check_nvisi(status,mess).lt.0)  call sic_message(seve%w,rname,mess)
      call gdf_flih (status,.false.,error)
    endif
    call gio_fris (status,error)
    !
  elseif (status.eq.program_defined) then
    if (user) then
      call sic_message(seve%e,rname,'Program defined variable '//trim(var)//' is protected')
      error = .true.
      return
    endif
    if (associated(dicvar(in)%desc%head)) then
      ! Variable provides a header and it is not mapped on a GIO slot
      call sic_delstructure(varfound,user,error)
      error = .false.               ! Make sure in this case no error
    endif
    if (dicvar(in)%desc%type.eq.0) then    ! Program-def structure...
      call sic_delstructure(varfound,user,error)
      if (error)  call sic_message(seve%f,rname,'Error deleting structure '//  &
      var)
    endif
    !
  elseif (status.eq.scratch_operand  .or.  &  ! Should not happen...
          status.eq.free_operand     .or.  &
          status.eq.readonly_operand .or.  &
          status.eq.interm_operand   .or.  &
          status.eq.empty_operand) then      ! Not an image variable
    call sic_message(seve%e,rname,'Unexpected variable status on delete')
    write(mess,*) status,in,var
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
    !
  else                         ! Code not in list...
    call sic_message(seve%e,rname,'Unknown variable status code on delete')
    write(mess,*) status,in
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Now delete the variable from the list
  call sic_zapvariable(in,luser,local,error)
  if (error) return
  !
end subroutine sic_delvariable
!
subroutine sic_zapvariable(in,user,local,error)
  use sic_interfaces, except_this=>sic_zapvariable
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Delete Variable number IN from variable list
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: in     ! Variable number
  logical,         intent(in)    :: user   ! Is variable User defined?
  logical,         intent(in)    :: local  ! Is variable Local or Global
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: ier,i,ivar,ntot
  !
  dicvar(in)%desc%status = empty_operand
  ier = sic_hasdel(maxvar,pfvar,pnvar,dicvar,dicvar(in)%id)
  if (ier.ne.1) then
    call sic_message(seve%e,'VARIABLE','No such variable '//trim(dicvar(in)%id%name))
    error = .true.
    return
  endif
  if (.not.user) return
  !
  ! Locate the back pointer
  if (local) then
    do i=1,var_n
      if (var_pointer(i).eq.in) then
        ivar = i
        goto 80
      endif
    enddo
  else
    do i=var_g,maxvar
      if (var_pointer(i).eq.in) then
        ivar = i
        goto 80
      endif
    enddo
  endif
  call sic_message(seve%e,'VARIABLE','Internal error, no back pointer')
  error =.true.
  return
  !
  ! Decrement the back pointers from this one
80 continue
  if (local) then
    ntot = ivar+1
    do i=ntot,var_n
      var_pointer(i-1) = var_pointer(i)
    enddo
    var_pointer(var_n) = 0
    var_n = var_n-1
  else
    ntot = ivar-1
    do i=ntot,var_g,-1
      var_pointer(i+1) = var_pointer(i)
    enddo
    var_pointer(var_g) = 0
    var_g = var_g+1
  endif
end subroutine sic_zapvariable
!
subroutine sic_delstructure(structvar,user,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_delstructure
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Delete a Structure and all its members. It assumes the variable is a
  ! structure, not a header.
  ! This routine is called when input variable is already checked as a TRUE
  ! structure.
  !---------------------------------------------------------------------
  type(sic_identifier_t), intent(in)    :: structvar  ! Structure name to delete
  logical,                intent(in)    :: user       ! User or Program request
  logical,                intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DELETE'
  integer(kind=4) :: nvar,nn,ivar,list(maxvar),ik,status
  character(len=varname_length) :: sname,varname
  integer :: structlev,varlev
  logical :: local,luser
  character(len=message_length) :: mess
  !
  ! Determine the variable level
  structlev = structvar%level  ! NOT the current level VAR_LEVEL, since it
  local = structlev.ne.0       ! may be asked to delete a Global structure
  !
  ! Build the prefix of all the structure members
  sname = structvar%name         ! Say, MYOLD
  nn = len_trim(sname)
  if (sname(nn:nn).ne.'%') then
    nn = nn+1
    sname(nn:nn) = '%'           ! MYOLD%
  endif
  !
  ! Delete everything left under MYOLD%
  call gag_haslis(maxvar,pfvar,pnvar,list,nvar)
  do ivar=1,nvar
    ik = list(ivar)
    !
    ! Jump to next variable if name is not correct
    varname=dicvar(ik)%id%name
    if (index(varname,sname(:nn)).ne.1)  cycle  ! ivar
    !
    ! Jump to next variable if level is not correct
    varlev=dicvar(ik)%id%level
    if (varlev.ne.structlev)  cycle  ! ivar
    !
    ! Skip the current structure itself, it will be zapped by the calling routine
    if (varname.eq.sname)  cycle  ! ivar
    !
    ! Ok, found an attribute, delete it
    !
    ! Cannot use the simple SIC_HASDEL
    !   IER=SIC_HASDEL(MAXVAR,PFVAR,PNVAR,DICVAR,FOUND)
    ! because it does not reset VAR_N properly...
    !
    ! Instead, one should use SIC_ZAPVARIABLE, but
    !   - take care of not deleting space of program defined variable  S.Guilloteau
    !   - deleting space of the other                                  G.Duvert
    !   - only if it has not been deleted before                       S.Guilloteau
    !   - and only if that variable is not a Structure itself          S.Guilloteau
    !
    status = dicvar(ik)%desc%status
    luser = user .and. status.ne.program_defined
    ! This part mostly duplicated from sic_delvariable!
    if (status.eq.alias_defined) then  ! It is an alias, just delete it from the list
      call zap_alias(ik)
      luser = .true.  ! Aliases always considered as user-defined (see symetric
                      ! comment in sic_def_alias)
      !
    elseif (luser) then          ! Interactively defined by user
      if (status.eq.empty_operand) then
        ! Has already been deleted (should not happen?)
        continue
        !
      elseif (status.eq.user_defined) then
        ! Interactively defined by user
        call del_alias(ik,local)  ! Delete its aliases
        if (dicvar(ik)%desc%type.ne.0) then  ! Not a structure
          ! print *,'Zapping ',ik,dicvar(ik)%desc%status,program_defined,  &
          !  dicvar(ik)%desc%type,dicvar(ik)%desc%size,dicvar(ik)%desc%addr
          call free_vm(dicvar(ik)%desc%size,dicvar(ik)%desc%addr)
        endif
        !
      elseif (status.gt.0) then
        ! Image variable, unmap
        call del_alias(ik,local)      ! Delete the aliases
        if (.not.dicvar(ik)%desc%readonly) then ! A writeable image/header
          ! Warn if Nvisi is lower than visibility axis
          if (gdf_check_nvisi(status,mess).lt.0)  call sic_message(seve%w,rname,mess)
          call gdf_flih (status,.false.,error)
        endif
        call gio_fris (status,error)
        !
      endif
    endif
    !
    ! Now delete the variable from the list
    call sic_zapvariable(ik,luser,local,error)
    if (error) then
      call sic_message(seve%e,rname,'Error ZAP in sic_delstructure for '//varname)
    endif
    !
  enddo
  !
end subroutine sic_delstructure
!
subroutine erase_variables
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>erase_variables
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Delete and reset to zero all local variables at level
  !       VAR_LEVEL, and decrement VAR_LEVEL
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  integer(kind=4) :: i,in,ier,status
  logical :: error,user
  character(len=message_length) :: mess
  !
  !!Print *,'Start makeERASE_VARIABLES'
  user = .true.
  error = .false.
  !
  ! Loop BACKWARDS to delete structure items BEFORE the structure,
  ! and also to delete aliases BEFORE their pointees.
  do i=var_n,var_macro(var_level)+1,-1
    in = var_pointer (i)
    if (in.ne.0) status = dicvar(in)%desc%status
    !!Print *,'Treating ',in,status,dicvar(in)%id%name, alias_defined
    !
    if (in.eq.0) then
      ! This could happen if a STRUCTURE was deleted before its components
      call sic_message(seve%e,rname,'Lost variable in ERASE_VARIABLES')
      !
    elseif (status.eq.alias_defined) then
      !!Print *,'Found an ALIAS_DEFINED at ',in
      call zap_alias(in)    ! In this case, calls to del_alias become useless
      ! or
      ! cycle               ! Aliases will be deleted when deleting the pointee
      !                       by the calls to del_alias
    elseif (status.eq.user_defined) then  ! Interactively defined by user
      ! call del_alias(in,.true.)  ! Delete the aliases. No need! Because
      !   we are rewinding the events, all aliases should have been
      !   deleted before the pointees.
      if (dicvar(in)%desc%type.eq.0) then  ! User-def structure...
        call sic_delstructure(dicvar(in)%id,user,error)
        if (error)  call sic_message(seve%f,rname,'Error deleting '//  &
                    'structure '//dicvar(in)%id%name)
      else
        call free_vm (dicvar(in)%desc%size,dicvar(in)%desc%addr)
      endif
      !
    elseif (status.gt.0) then  ! Image or Header variable mapped on a GIO slot, unmap
      ! call del_alias(in,.true.)  ! Delete the aliases. No need! Because
      !   we are rewinding the events, all aliases should have been
      !   deleted before the pointees.
      call sic_delstructure(dicvar(in)%id,user,error)
      if (.not.dicvar(in)%desc%readonly) then
        ! Warn if Nvisi is lower than visibility axis
        if (gdf_check_nvisi(dicvar(in)%desc%status,mess).lt.0)  call sic_message(seve%w,rname,mess)
       call gdf_flih (dicvar(in)%desc%status,.false.,error)
      endif
      call gio_fris (dicvar(in)%desc%status,error)
      !
    elseif (status.eq.program_defined) then
      call sic_message(seve%e,rname,'Program defined variables are global')
      write(mess,*) status,dicvar(in)%id%name,in
      call sic_message(seve%e,rname,mess)
      error = .true.
    elseif (status.eq.empty_operand) then
      continue
    elseif (status.eq.scratch_operand  .or.  &  ! Should not happen...
            status.eq.free_operand     .or.  &
            status.eq.readonly_operand .or.  &
            status.eq.interm_operand) then
      call sic_message(seve%e,rname,'Unexpected variable status on delete')
      write(mess,*) status,dicvar(in)%id%name,in
      call sic_message(seve%e,rname,mess)
      error = .true.
    else                       ! Code not in list...
      call sic_message(seve%e,rname,'Unknown variable status code '//  &
      'on return')
      write(mess,*) status
      call sic_message(seve%e,rname,mess)
      error = .true.
    endif
    dicvar(in)%desc%status = empty_operand
#if defined(GAG_USE_PYTHON)
    call gpy_delvar(dicvar(in)%id%name,dicvar(in)%id%level)
#endif
    ier = sic_hasdel(maxvar,pfvar,pnvar,dicvar,dicvar(in)%id)
  enddo
  var_n = var_macro(var_level)
  var_level = var_level-1
  !!Print *,'Finished ERASE_VARIABLES'
end subroutine erase_variables
!
subroutine del_ima_var
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>del_ima_var
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Delete all image variables. This is called upon Program exit to
  !       ensure updating (when the mapping mechanism cannot be used).
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  integer :: i,in,status
  logical :: error,user
  character(len=message_length) :: mess
  !
  user = .false.               ! This is a Program Request !
  !
  ! Go FORWARD to delete structure items before the structure header
  do i=var_g,maxvar
    error = .false.    ! Reset error
    in = var_pointer (i)
    status = dicvar(in)%desc%status
    !!Print *,'DEL_IMA_VAR ',in, status, TRIM(DICVAR(IN)%id%name),DICVAR(IN)%id%LEVEL
    if (status.eq.user_defined) then   ! Interactively defined by user
      if (dicvar(in)%desc%type.eq.0) then  ! User-def structure...
        call sic_delstructure(dicvar(in)%id,user,error)
        if (error)  call sic_message(seve%f,rname,'Error deleting '//  &
                    'structure '//dicvar(in)%id%name)
      else
        call free_vm (dicvar(in)%desc%size,dicvar(in)%desc%addr)
      endif
    elseif (status.gt.0) then  ! Image variable, unmap
      call sic_delstructure(dicvar(in)%id,user,error)
      if (.not.dicvar(in)%desc%readonly) then      ! Means it is not readonly: Flush header
        ! Warn if Nvisi is lower than visibility axis
        if (gdf_check_nvisi(dicvar(in)%desc%status,mess).lt.0)  call sic_message(seve%w,rname,mess)
        call gdf_flih (dicvar(in)%desc%status,.false.,error)
      endif
      call gio_fris (dicvar(in)%desc%status,error)  ! Free image slot and do all writing if needed...
      if (error)  call sic_message(seve%f,rname,'Error deleting '//  &
                  'image '//dicvar(in)%id%name)
    elseif (status.eq.program_defined) then
      !call sic_message(seve%w,rname,'Program defined variable '//  &
      !  trim(dicvar(in)%id%name)//' is global')
      !error = .true.
      continue
    elseif (status.eq.empty_operand .or. status.eq.alias_defined) then
      continue
    elseif (status.eq.scratch_operand  .or.  &  ! Should not happen...
            status.eq.free_operand     .or.  &
            status.eq.readonly_operand .or.  &
            status.eq.empty_operand) then
      call sic_message(seve%e,rname,'Unexpected variable status on delete')
      write(mess,*) status,in,trim(dicvar(in)%id%name),' at level ',dicvar(in)%id%level
      call sic_message(seve%e,rname,mess)
      error = .true.
    else                       ! Code not in list...
      call sic_message(seve%e,rname,'Unknown variable status code on exit')
      write(mess,*) status
      call sic_message(seve%e,rname,mess)
      error = .true.
    endif
    dicvar(in)%desc%status = empty_operand
  enddo
end subroutine del_ima_var
!
subroutine sic_free_variable
  use sic_interfaces, except_this=>sic_free_variable
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Release the variable structure list at exit time
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='FREE_VARIABLE'
  integer :: ier
  !
  ! Deallocate variable arrays
  deallocate(dicvar,pnvar,var_pointer,alias,dicali,pointee,stat=ier)
  if (ier.ne.0) then
     call sic_message(seve%e,rname,'Dictionary deallocation error')
  endif
  !
end subroutine sic_free_variable

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module greg_types
  !---------------------------------------------------------------------
  ! Greg types
  !---------------------------------------------------------------------
  !
  integer, parameter :: mgon=1000     ! Maximum number of summits
  type :: polygon_t
    real(8) :: xgon(mgon)            ! X Coordinates of summits
    real(8) :: ygon(mgon)            ! Y Coordinates of summits
    real(8) :: dxgon(mgon)           ! XGON(I+1)-XGON(I)
    real(8) :: dygon(mgon)           ! YGON(I+1)-YGON(I)
    real(8) :: xout                  ! X coordinate of a point outside
    real(8) :: xgon1                 ! Lower X value
    real(8) :: xgon2                 ! Upper X value
    real(8) :: ygon1                 ! Lower Y value
    real(8) :: ygon2                 ! Upper Y value
    real(8) :: yeps                  ! Epsilon value on Y axis
    integer :: ngon                  ! Number of summits
  end type polygon_t
  !
  ! Type describing the labeling rules of an axis (axis_t)
  type :: axis_label_t
    integer(kind=4) :: justif     ! Label justification (left, center, right). Contains
                                  ! implicitly the label orientation (1 => Parallel to axis)
    real(kind=4)    :: offset     ! Label offset (?)
    integer(kind=4) :: format     ! Decimal (0) or sexagesimal (>0) labels?
    integer(kind=4) :: format_nd  ! Number of decimals if sexagesimal label
    logical         :: brief      ! All but one label abbreviated?
    logical         :: expo       ! Prefer exponential notation (when possible)?
  end type axis_label_t
  !
  ! Type describing an "axis" in GreG, in a large sense. Grid cans also
  ! be described with this type, with grid lines as special ticks.
  type :: axis_t
    ! General rules
    logical      :: doline       ! Draw the axis line or not
    logical      :: dolabel      ! Draw the labels or not
    real(kind=8) :: angle        ! Axis orientation (radians)
    logical      :: loga         ! Is it a log axis?
    ! Ticks rules
    logical      :: tdirect      ! Tick direction: direct: up/right, indirect: down,left
    ! Label rules
    type(axis_label_t) :: label  !
    ! Grid rules
    real(kind=4) :: glength      ! Length of grid line
    logical      :: gmajor       ! Draw grid on major ticks only or minor ticks only?
    logical      :: ghoriz       ! Horizontal or vertical grid
  end type axis_t
  !
  ! Type describing a single tick in GreG, in a large sense.
  type :: tick_t
    logical      :: major    ! Is the tick major or minor?
    real(kind=4) :: x        ! Tick X reference position (in world coordinates)
    real(kind=4) :: y        ! Tick Y reference position (in world coordinates)
    real(kind=8) :: value    ! Associated value at tick position (in user coordinates)
    ! Label rules
    logical      :: lbrief   ! Abbreviate the label?
    real(kind=8) :: loffval  ! Abbreviation offset
  end type tick_t
  !
  type :: polygon_drawing_t
    logical         :: contoured  ! Should the polygon be contoured?
    integer(kind=4) :: cpen       ! Pen for contouring
    !
    logical         :: filled     ! Should the polygon be color-filled?
    integer(kind=4) :: fcolor     ! Color to be used
    !
    logical         :: hatched    ! Should the polygon be hatch-filled?
    integer(kind=4) :: hpen       ! Pen for hatching
    real(kind=4)    :: hangle     ! Line orientation (radians)
    real(kind=4)    :: hsepar     ! Line separation (physical units)
    real(kind=4)    :: hphase     ! Line start (0. to 1.)
  end type polygon_drawing_t
  !
end module greg_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module greg_error
  !--------------------------------------------------------------------
  ! Error support
  !--------------------------------------------------------------------
  character(len=80) :: message  ! Error message
  logical :: errorg             !
end module greg_error
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module greg_kernel
  !--------------------------------------------------------------------
  ! GREG general variables
  ! For portability, SAVE Fortran variables (or their common) which are
  ! target of SIC variables.
  !--------------------------------------------------------------------
  real(8) :: gux1, gux2             ! Users X-limit
  real(8) :: guy1, guy2             ! Users Y-limit
  real(8) :: gux, guy               ! Conversion factor
  real(8) :: lux, luy               ! Logarithmique conversion offset
  real(8), save :: ucurse(2)        ! Cursor in user coordinates
  real(8) :: tangle                 ! Position angle for texts
  real(8) :: sangle                 ! Position angle for symbols
  real(8) :: cblank                 ! Blanking value
  real(8) :: eblank                 !
  !
  ! Default values
  real(4), parameter :: lxs_d=30.0  ! X physical size (cm)
  real(4), parameter :: lys_d=21.0  ! Y physical size (cm)
  real(4), parameter :: gx1_d=4.0   ! Left X coordinate of the box (cm)
  real(4), parameter :: gx2_d=28.0  ! Right X coordinate of the box (cm)
  real(4), parameter :: gy1_d=2.5   ! Lower Y coordinate of the box (cm)
  real(4), parameter :: gy2_d=19.5  ! Upper Y coordinate of the box (cm)
  !
  ! Current values
  real(4) :: lx1, lx2               ! Pen X physical limits
  real(4) :: ly1, ly2               ! Pen Y physical limits
  real(4) :: gx1, gx2               ! X coordinates of the box
  real(4) :: gy1, gy2               ! Y coordinates of the box
  real(4), save :: xp,yp            ! Position of the pen
  real(4) :: gxp,gyp                ! Position after clipping
  real(4) :: xcurse, ycurse         ! Position of the cursor
  real(4) :: expand=1.0             ! Expansion factor
  real(4) :: accurd                 ! Plot accuracy (cm)
  real(4) :: cheight, cwidth        ! Height and width of the characters
  real(4), save :: cdef=0.6         ! Character size
  real(4), save :: csymb=0.3        ! Marker size
  real(4), save :: ctick=0.4        ! Major tick size
  real(4), save :: cmtick           ! Minor tick size
  !
  integer :: i_font                 ! Pointeur des caracteres (0/1)
  integer :: icente                 ! Option de centrage
  integer, save :: nsides, istyle   ! Type de symbole
  integer :: iboxd                  ! Unites BOX (0) ou USER (1)
  integer :: h_mode                 ! Type de Hardcopy
  integer, save :: pixcurse(2)      !
  character(len=1), save :: cursor_code
  !
  logical :: noclip=.false.         ! Logique de clipping
  logical :: axis_xlog=.false.      ! X axis scale is log or linear?
  logical :: axis_ylog=.false.      ! Y axis scale is log or linear?
  !
  logical :: axis_xdecim_brief
  logical :: axis_ydecim_brief
  logical :: axis_xsexag_brief
  logical :: axis_ysexag_brief
  logical :: axis_xexpo
  logical :: axis_yexpo
  logical :: axis_zexpo
  integer(kind=4), parameter :: format_decimal=0
  integer(kind=4), parameter :: format_sexage_none=1
  integer(kind=4), parameter :: format_sexage_hour=2
  integer(kind=4), parameter :: format_sexage_degree=3
  integer(kind=4) :: xsixty,ysixty     !
  integer(kind=4) :: ndecimx, ndecimy  ! Idem pour X et Y en sexagesimal
  real(kind=4) :: label_xoff=2.0       ! Offset in characters for X Label
  real(kind=4) :: label_yoff=6.0       ! Offset in characters for Y Label
  !
  integer, parameter :: h_nonstandard=0
  integer, parameter :: h_landscape=1
  integer, parameter :: h_portrait=2
  !
  common /greg01/                         &
    gux1,gux2,guy1,guy2,gux,guy,lux,luy,  &  ! These 8 ones must be contiguous
    cblank,eblank,                        &  ! These 2 ones must be contiguous
    lx1,lx2,ly1,ly2,                      &  ! These 4 ones must be contiguous
    gx1,gx2,gy1,gy2,                      &  ! These 4 ones must be contiguous
    xcurse,ycurse                            ! These 2 ones must be contiguous
  save /greg01/  ! because it contains variables which are target of SIC variables
  !
  ! IO units
  integer(kind=4) :: jtmp=0     ! Logical Unit Number for Closed operation
  integer(kind=4) :: lung=0     ! Logical Unit Number for GTV terminal
  integer(kind=4) :: lunh=0     ! Logical Unit Number for GTV hardcopy
  logical         :: library    ! Is language loaded as library only?
end module greg_kernel
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine greg_kernel_init
  use greg_kernel
  !--------------------------------------------------------------------
  ! @ private
  ! Initialization routine for greg_kernel module.
  ! It must be called once and only once, otherwise an error will
  ! raise and program will exit.
  !--------------------------------------------------------------------
  !
  logical, save :: done=.false.
  ! call sic_c_assert(.not.done, 'E-GREG_KERNEL,  Multiple call of module initialization')
  if (done) return
  !
  gux1 = 0.
  gux2 = 1.
  guy1 = 0.
  guy2 = 1.
  lx1  = 0.
  lx2  = 30.
  ly1  = 0.
  ly2  = 21.
  gx1  = gx1_d
  gx2  = gx2_d
  gy1  = gy1_d
  gy2  = gy2_d
  !
  done = .true.
end subroutine greg_kernel_init
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine greg_mod_init
  !--------------------------------------------------------------------
  ! @ private
  ! Call to initialization routines for GREG modules.
  ! It must be called once and only once, otherwise an error will
  ! raise and program will exit.
  !--------------------------------------------------------------------
  call greg_kernel_init
end subroutine greg_mod_init
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mrtholo_interfaces_none
  interface
    subroutine mrtholo_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine mrtholo_message_set_id
  end interface
  !
  interface
    subroutine mrtholo_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine mrtholo_message
  end interface
  !
  interface
    subroutine dummyConvert(i,j,n)
      integer :: i,n,j
    end subroutine dummyConvert
  end interface
  !
end module mrtholo_interfaces_none

subroutine write_sdm_main(uid, integration, totalpower, error)
  use gkernel_interfaces
  !---------------------------------------------------------------------I
  !
  !     Write the Main SDM table; these lines for correlator data.
  !     at this point one line per integration or subintegration
  !
  !     holodata not used...
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_main
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  include 'gbl_pi.inc'
  ! Dummy
  logical :: error, integration, totalpower
  character*(*) uid
  ! Local
  type (MainRow) :: mRow
  type (MainKey) :: mKey
  !      type (MainOpt) :: mOpt
  !     there are up to 4 polarization products  (e.g. XX, YY, XY, YX).
  integer :: correlationMode, ib, ia, luid
  character, parameter ::  sdmTable*4='Main'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !     binary writing process -> bitsize, scaleFactor, dataOid may be
  !     allocated in the binary data routine...
  !
  !     In the current model (2005-12-01) the dimensions of bitsize and
  !     scalefactor are (CorrelationMode, numBaseBand)
  !     for bure there is allways either auto or corr (CorrelationMode = 1)
  !
  !     note that scalefactor and bitsize will not be used for
  !     autocorrelations
  !     note also that bitzise is one number for each integration (not
  !     dependent on baseband).
  !
  if (r_lmode.eq.1) then       ! correlation
    correlationMode = 1
  elseif (r_lmode.eq.2) then   ! auto correlation only
    correlationMode = 1
  elseif (r_lmode.eq.3) then   ! auto correlation and correlation (some day),
    !  ... or ALMA data
    correlationMode = 2
  endif
  mRow%numAntenna = r_nant
  !!call  allocMainRow(mRow, r_nant, error)
  call  allocMainRow(mRow, error)
  if (error) return
  !      call  allocMainOpt(mOpt, mRow%numIntegration, r_nant, r_lband,
  !     &     num_corr, error)
  !      if (error) return
  !!mRow%flagRow = .false.
  mKey%time = time_Interval(1) + time_Interval(2)/2.
  mRow%interval = time_Interval(2)
  !
  !     I expect all Bure data to have the same state for all connected antennas.
  do ia = 1, r_nant
    mRow%stateId(ia) = state_Id
  enddo
  luid = lenc(uid)
  mRow%dataOId= '<EntityRef '//   &
    'entityId="'//uid(1:luid)//   &
    '" partId="X00000002" '//   &
    'entityTypeName="Main" '//   &
    'documentVersion="1"/>'
  !
  ! *TBD* Need to fill in the flags...
  !
  ! May be better pass an argument for this test...
  if (totalpower) then
    mKey%configDescriptionId = TotPowConfigDescription_Id
    mRow%timeSampling = TimeSampling_SUBINTEGRATION
    if (r_nswitch.gt.0) then
      mRow%numIntegration = r_ndump/r_nswitch
    else
      mRow%numIntegration = r_ndump
    endif
  elseif (integration) then
    mKey%configDescriptionId = configDescription_Id
    mRow%timeSampling = TimeSampling_INTEGRATION
    mRow%numIntegration = 1
  else
    mKey%configDescriptionId = COntconfigDescription_Id
    mRow%timeSampling = TimeSampling_SUBINTEGRATION
    mRow%numIntegration = r_ndump
  endif
  mKey%fieldId = field_Id
  mRow%execBlockId = execBlock_Id
  mRow%scanNumber = Scan_Number
  mRow%subScanNumber = subScan_Number
  call addMainRow(mKey, mRow, error)
  if (error) return
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
!
end subroutine write_sdm_main
!---------------------------------------------------------------------
! Deprecated
subroutine write_sdm_mainTP(uid, error)
  !---------------------------------------------------------------------I
  !
  !     Write the Main SDM table; these lines for total power  data.
  !     at this point one line per Subscan...
  !     holodata not used...
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_main
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  include 'gbl_pi.inc'
  ! Dummy
  logical :: error
  character*(*) uid
  ! Local
  type (MainRow) :: mRow
  type (MainKey) :: mKey
  !      type (MainOpt) :: mOpt
  !     there are up to 4 polarization products  (e.g. XX, YY, XY, YX).
  integer :: correlationMode, ib, ia
  character, parameter ::  sdmTable*6='MainTP'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  !
  mRow%numAntenna = r_nant
  call  allocMainRow(mRow, error)
  if (r_nswitch.gt.1) then
    mRow%numIntegration = r_ndump / r_nswitch
  endif
  !      call  allocMainOpt(mOpt, mRow%numIntegration, r_nant, r_lband,
  !     &     r_npol_rec, error)
  !      if (error) return
  !!mRow%flagRow = .false.
  mKey%time = time_Interval(1) + time_Interval(2)/2.
  mRow%interval = time_Interval(2)
  !
  !     I expect all Bure data to have the same state for all connected antennas.
  do ia = 1, r_nant
    mRow%stateId(ia) = state_Id
  enddo
  mRow%dataOId= '<EntityRef '//   &
    'entityId="'//uid(1:33)//   &
    '" partId="X00000002" '//   &
    'entityTypeName="Main" '//   &
    'documentVersion="1"/>'
  !
  ! *TBD* Need to fill in the flags...
  !
  mKey%configDescriptionId = TotPowConfigDescription_Id
  mKey%fieldId = field_Id
  mRow%execBlockId = execBlock_Id
  mRow%scanNumber = Scan_Number
  mRow%subScanNumber = subScan_Number
  mRow%timeSampling = TimeSampling_INTEGRATION
  call addMainRow(mKey, mRow, error)
  if (error) return
  !
  ! uvw now optional, do not write it here.
  ! do not write exposure and time centroid, nor flags....
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
!
end subroutine write_sdm_mainTP
!---------------------------------------------------------------------
subroutine get_sdm_main(uid, error)
  !---------------------------------------------------------------------
  !
  !     Read the Main SDM table.
  !
  !     Key: (configDescriptionId, fieldId, time)
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_main
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  include 'gbl_pi.inc'
  ! Dummy
  logical error
  character*(*) uid
  ! Local
  type (MainRow) :: mRow
  type (MainKey) :: mKey
  !      type (MainOpt) :: mOpt
  integer :: ia, ib, l, lenz, k, k2, mcorr, minteg
  logical :: present
  character, parameter ::  sdmTable*4='Main'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  mcorr = 4
  minteg = 1
  mRow%numAntenna = mnant
  call  allocMainRow(mRow, error)
  if (error) return
  ! optional stuff
  !      call  allocMainOpt(mOpt, minteg, mnant,
  !     &     mrlband, mCorr, error)
  !      if (error) return
  mKey%configDescriptionId = configDescription_Id
  mKey%fieldId = field_Id
  mKey%time = time_interval(1) + time_interval(2)/2
  !
  call getMainRow(mKey, mRow, error)
  if (error) then
    print *, 'mKey ',mKey
    return
  endif
  execBlock_Id = mRow%execBlockId
  Scan_Number = mRow%scanNumber
  subScan_Number  = mRow%subScanNumber
  state_Id = mRow%stateId(1)
  do ia = 1, r_nant
     if(state_Id.ne.mRow%stateId(ia)) then
      error = .true.
      call sdmmessageI(8,4,sdmTable ,'Unexpected State_Id '   &
        ,mRow%stateId(ia))
      return
    endif
  enddo
  !
  l = lenz(mRow%DataOid)
  k = index(mRow%DataOid(1:l),'"uid:')
  k2 = index(mRow%DataOid(k+1:),'"')
  uid =  mRow%DataOid(k+1:k+k2-1)
  !cc   Other reading to do I guess...
  !
  ! get the uvw
  !      call getMainUvw(mKey, mOpt, present, error)
  !      if (present .and. r_nbas.gt.0) then
  !         do ib = 1, r_nbas
  !            if (r_iant(ib).eq.1) then
  !               dh_uvm(1,ib) = mOpt%uvw(1,r_jant(ib))
  !               dh_uvm(2,ib) = mOpt%uvw(2,r_jant(ib))
  !            endif
  !         enddo
  !      else
  !cc **** NEED TO CALCULATE THIS HERE ***
  dh_uvm = 0
  !      endif
  !
  !     Get the subintegration number: Not there any mode.
  ! Must be calculated somewhat using the time and the subscan time.
  !     Or just counted?
  !c      dh_dump = dh_dump + 1
  !      call getMainSubintegNum(mKey, mOpt, present, error)
  !      if (error) return
  !      if (present) then
  !         dh_dump = mOpt%subintegNum
  !      endif
  !
  !$$$      call getMainSubintegrationNumber(mKey, mOpt, present, error)
  !$$$      if (error) return
  !$$$      if (present) then
  !$$$         dh_dump = mOpt%subintegrationNumber
  !$$$      endif
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
!
!$$$ 99   error = .true.
end subroutine get_sdm_main
!---------------------------------------------------------------------
!---------------------------------------------------------------------
subroutine get_sdm_mainTP(uid, error)
  !---------------------------------------------------------------------
  !
  !     Read the Main SDM table for TP OID
  !
  !     Key: (configDescriptionId, fieldId, time)
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_main
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  include 'gbl_pi.inc'
  ! Dummy
  logical error
  character*(*) uid
  ! Local
  type (MainRow) :: mRow
  type (MainKey) :: mKey
  !      type (MainOpt) :: mOpt
  integer :: ia, ib, l, lenz, k, k2, mcorr, minteg
  logical :: present
  character, parameter ::  sdmTable*8='Main(TP)'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  mcorr = 4
  minteg = 1
  call  allocMainRow(mRow, mnant, error)
  if (error) return
  !      call  allocMainOpt(mOpt, minteg, mnant,
  !     &     mrlband, mCorr, error)
  !      if (error) return
  mKey%configDescriptionId = configDescription_Id
  mKey%fieldId = field_Id
  mKey%time = time_interval(1) + time_interval(2)/2
  call getMainRow(mKey, mRow, error)
  if (error) return
  !
  execBlock_Id = mRow%execBlockId
  Scan_Number = mRow%scanNumber
  subScan_Number  = mRow%subScanNumber
  !$$$      scale_Factor = mRow%scaleFactor
  !$$$      bit_Size = mRow%bitSize
  state_Id = mRow%stateId(1)
  do ia = 1, r_nant
    if(state_Id.ne.mRow%stateId(ia)) then
      error = .true.
      call sdmmessageI(8,4,sdmTable ,'Unexpected State_Id '   &
        ,mRow%stateId(ia))
      return
    endif
  enddo
  !
  l = lenz(mRow%DataOid)
  k = index(mRow%DataOid(1:l),'"uid:')
  k2 = index(mRow%DataOid(k+1:),'"')
  uid =  mRow%DataOid(k+1:k+k2-1)
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
!
!$$$ 99   error = .true.
end subroutine get_sdm_mainTP
!---------------------------------------------------------------------
!!! subroutine allocMainRow(row, numAntenna, error)
!!!   !---------------------------------------------------------------------
!!!   !    integer, allocatable :: stateId(:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_Main
!!!   type(MainRow) :: row
!!!   integer :: numAntenna, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*8 = 'Main'
!!!   !
!!!   ! stateId (numAntenna)
!!!   if (allocated(row%stateId)) then
!!!     deallocate(row%stateId, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%stateId(numAntenna), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!---------------------------------------------------------------------
!$$$      subroutine allocMainOpt(opt, numIntegration, numAntenna,
!$$$     &     numBaseband, numCorr,  error)
!$$$C---------------------------------------------------------------------
!$$$c    real*8, allocatable :: uvw(:,:,:)
!$$$c    integer*8, allocatable :: exposure(:,:,:)
!$$$c    integer*8, allocatable :: timeCentroid(:,:,:)
!$$$c    integer, allocatable :: flagAnt(:)
!$$$c    integer, allocatable :: flagPol(:,:,:)
!$$$c    integer, allocatable :: flagBaseband(:,:,:,:)
!$$$C---------------------------------------------------------------------
!$$$      use sdm_Main
!$$$      type(MainOpt) :: opt
!$$$      integer :: numIntegration, numAntenna,
!$$$     &     numBaseband, numCorr, ier
!$$$      logical :: error
!$$$      character, parameter :: sdmTable*8 = 'Main'
!$$$c
!$$$c uvw (3, numAntenna)
!$$$      if (allocated(opt%uvw)) then
!$$$         deallocate(opt%uvw, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(opt%uvw(3, numAntenna), stat=ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$c exposure (numBaseband, numAntenna)
!$$$      if (allocated(opt%exposure)) then
!$$$         deallocate(opt%exposure, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(opt%exposure(numBaseband, numAntenna),
!$$$     &     stat=ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$c timeCentroid (numBaseband, numAntenna)
!$$$      if (allocated(opt%timeCentroid)) then
!$$$         deallocate(opt%timeCentroid, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(opt%timeCentroid(numBaseband, numAntenna), stat=ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$c flagAnt (numAntenna)
!$$$      if (allocated(opt%flagAnt)) then
!$$$         deallocate(opt%flagAnt, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(opt%flagAnt(numAntenna), stat=ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$c flagPol (numCorr, numAntenna)
!$$$      if (allocated(opt%flagPol)) then
!$$$         deallocate(opt%flagPol, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(opt%flagPol(numCorr, numAntenna), stat
!$$$     &     =ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$c flagBaseband (numBaseband, numCorr, numAntenna)
!$$$      if (allocated(opt%flagBaseband)) then
!$$$         deallocate(opt%flagBaseband, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(opt%flagBaseband(numBaseband, numCorr, numAntenna), stat
!$$$     &     =ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$      return
!$$$c
!$$$ 98   call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!$$$      error = .true.
!$$$      return
!$$$c
!$$$ 99   call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!$$$      error = .true.
!$$$      return
!$$$      end
!$$$

subroutine excess_path (f_ghz, p_atm, p_vap, t, dh,   &
     &    z, path, c_snell, n_index)
  !--------------------------------------------------------------------------
  !
  ! Calculation of the excess path length (path length difference between
  ! vacuum and atmospheric propagation) for a parallel medium of
  ! constant refraction index.
  ! Source for the path length formula: Thompson, Moran, Swenson (1986),
  !                     Interferometry and Synthesis in Radio Astronomy, p 407
  !
  ! Input:  real*4 f_ghz   frequency in GHz
  !                p_atm   total atmospherical pressure in millibar
  !                p_vap   partial pressure of water vapor in millibar
  !                t       temperature in kelvin
  !                z       Zenith distance angle (radians)
  ! Output: real*8 c_snell : Constant of Snell's law
  !                n_index : refraction index
  !         real*4 path    : path length difference in units of dh.
  !
  ! Author: 25-Jan-1994  Michael Bremer, IRAM
  !-------------------------------------------------------------------------
  real refract_total, f_ghz, p_atm, p_vap, t, dh, z, path, refr
  real*8 sin_z, cos_z,  c_snell, n_index
  !----------------------------------------------
  !
  refr    = refract_total( f_ghz, p_atm, p_vap, t)
  !
  ! Apply the definition of refractivity to get the refraction index :
  !
  n_index = 1.0d+00 + refr * 1.0d-06
  !
  ! c_snell stays constant along the line of sight (Snell's law) and
  ! is calculated if the given value is .lt. 0. This should make life
  ! easier when dealing with multiple layers.
  !
  if (c_snell .lt. 0) c_snell = sin( z ) * n_index
  sin_z   = c_snell / n_index
  cos_z   = sqrt(1.d+00 - sin_z * sin_z)
  !
  path = refr * 1.0d-06 * dh / cos_z
  !
end subroutine excess_path
!
function refract_total (f_ghz, p_atm, p_vap, t )
  !-------------------------------------------------------------------
  !
  ! Calculation of the total atmospheric refractivity (dry component and
  ! water vapor), taking into account the dependences from
  ! frequency, pressure, temperature
  ! Source of formulae: Hill and Cliffort (1981), Radio Science 16, pp. 77-82
  !                and  Thompson, Moran, Swenson (1986),
  !                     Interferometry and Synthesis in Radio Astronomy, p 407
  !
  ! Input: real*4 f_ghz  frequency in GHz
  !               p_atm  total atmospherical pressure in millibar
  !               p_vap  partial pressure of water vapor in millibar
  !               t      temperature in kelvin
  !
  ! Author: 25-Jan-1994  Michael Bremer, IRAM
  !
  !-------------------------------------------------------------------
  real refract_total, f_ghz, p_atm, p_vap, t
  real ref_dry, ref_vap,  sc, refract_vapor
  !
  !--------------------------------------------
  !
  ! sc = scaling factor for the wavelenght dependent part of the wet refration
  ! (normal conditions 300K, 1013mbar, 80% humidity -> partial pressure of
  !  water vapor 28.2mbar ):
  !
  sc      = (p_vap / 28.2) * (300./t)**2
  ref_dry = 77.493 * p_atm / t
  ref_vap = - 12.8 * p_vap / t + refract_vapor( f_ghz ) * sc
  refract_total = ref_dry + ref_vap
end function refract_total
!
function refract_vapor (f_ghz)
  !-----------------------------------------------------------------------
  !
  ! Function to calculate the refractivity of water vapor 0-480 GHz, under
  ! conditions T=300K, P=1atm, 80% rel. humidity (i.e. partial pressure of
  ! water vapor 28.2 mbar).
  !
  ! Source: Hill and Clifford (1981), Radio Science 16, curve p. 80
  ! Method of digitalisation: zoomed copy to a transparency,
  !                           points read by cursor.
  !                           Approx. errors: F +-1.5 GHz, R +-0.1
  !
  ! Author: 24-Jan-1993 Michael Bremer, IRAM
  !------------------------------------------------------------------------
  real refract_vapor, f_ghz
  integer npoint, i
  parameter (npoint = 53)
  real freq(npoint), refr(npoint), u
  !
  data freq /  &
      0.00 ,  18.00 ,  22.53 ,  47.95 ,  &
     59.41 ,  79.04 ,  98.67 , 115.85 ,  &
    133.03 , 152.66 , 167.39 , 181.70 ,  &
    183.57 , 185.66 , 188.11 , 195.47 ,  &
    215.65 , 235.29 , 250.83 , 271.28 ,  &
    288.28 , 305.46 , 315.27 , 321.64 ,  &
    323.50 , 327.18 , 328.82 , 336.18 ,  &
    348.45 , 358.27 , 366.45 , 371.35 ,  &
    374.63 , 377.90 , 379.53 , 378.72 ,  &
    381.35 , 382.99 , 387.90 , 393.44 ,  &
    405.71 , 427.26 , 431.07 , 437.80 ,  &
    441.07 , 446.16 , 448.80 , 449.62 ,  &
    456.98 , 469.07 , 472.97 , 476.43 ,  &
    480.01 /
  data refr /  &
    115.64 , 115.68 , 115.59 , 115.69 ,  &
    115.76 , 115.88 , 116.07 , 116.25 ,  &
    116.50 , 116.81 , 117.24 , 118.08 ,  &
    117.80 , 116.25 , 116.38 , 117.00 ,  &
    117.65 , 118.21 , 118.71 , 119.39 ,  &
    120.07 , 120.87 , 121.53 , 122.26 ,  &
    122.45 , 121.33 , 121.33 , 122.20 ,  &
    123.38 , 124.37 , 125.61 , 126.91 ,  &
    128.27 , 129.85 , 125.73 , 121.89 ,  &
    119.29 , 119.29 , 121.89 , 123.30 ,  &
    125.70 , 129.18 , 129.87 , 132.29 ,  &
    132.42 , 134.90 , 129.51 , 125.30 ,  &
    129.07 , 133.47 , 134.59 , 134.24 ,  &
    134.96 /
  ! -------------------------------
  !
  ! negative frequencies are NOT accepted (not even in jest):
  !
  if (f_ghz .lt. 0) then
    write(6,*) 'E-ATM,  Error from refract_vapor: frequency < 0'
    stop
  endif
  !
  ! Find the frequency interval (i-1,i) of the input frequency:
  i = 2
  !
  10    continue
  if (freq(i) .gt. f_ghz) goto 20
  i = i + 1
  !
  if (i .le. npoint) goto 10
  !
  !     Print an error message, if the frequency range has been checked and the
  !     requested frequency lies beyond, and give the last data range value:
  !      PRINT *,'Error from refract_vapor: ',F_GHZ,' outside 0-480 GHz.'
  !
  refract_vapor = refr(npoint)
  return
  !
  20    continue
  !
  ! Perform linear interpolation between the interval borders:
  !
  u = (f_ghz - freq(i-1)) / (freq(i) - freq(i-1))
  refract_vapor = refr(i-1) + (refr(i) - refr(i-1)) * u
end function refract_vapor

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_subcube2subcube
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetemplate_factor_types
  use cubetopology_cuberegion_types
  use cubetemplate_messaging
  !
  public :: subcube2subcube
  private
  !
  type :: subcube2subcube_comm_t
     type(option_t), pointer :: comm
     type(factor_comm_t)     :: factor
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube     
   contains
     procedure, public  :: register => cubetemplate_subcube2subcube_comm_register
     procedure, private :: parse    => cubetemplate_subcube2subcube_comm_parse
     procedure, private :: main     => cubetemplate_subcube2subcube_comm_main
  end type subcube2subcube_comm_t
  type(subcube2subcube_comm_t) :: subcube2subcube  
  !
  type subcube2subcube_user_t
     type(cubeid_user_t)     :: cubeids
     type(factor_user_t)     :: factor
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubetemplate_subcube2subcube_user_toprog
  end type subcube2subcube_user_t
  !
  type subcube2subcube_prog_t
     type(cuberegion_prog_t) :: region
     type(factor_prog_t)     :: factor
     type(cube_t), pointer   :: incube
     type(cube_t), pointer   :: oucube
   contains
     procedure, private :: header => cubetemplate_subcube2subcube_prog_header
     procedure, private :: data   => cubetemplate_subcube2subcube_prog_data
     procedure, private :: loop   => cubetemplate_subcube2subcube_prog_loop
     procedure, private :: act    => cubetemplate_subcube2subcube_prog_act
  end type subcube2subcube_prog_t
  !
contains
  !
  subroutine cubetemplate_subcube2subcube_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(subcube2subcube_user_t) :: user
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call subcube2subcube%parse(line,user,error)
    if (error) return
    call subcube2subcube%main(user,error)
    if (error) continue
  end subroutine cubetemplate_subcube2subcube_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_subcube2subcube_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_comm_t), intent(inout) :: comm
    logical,                       intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'SUBCUBE2SUBCUBE','[cubeid]',&
         'Template command for per-subcube input and output access',&
         'Input cube must be real and output cube will be real.',&
         cubetemplate_subcube2subcube_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'INPUT',&
         'Input cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         comm%incube,&
         error)
    if (error) return
    call comm%factor%register(error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'OUTPUT',&
         'Output cube',&
         strg_emp,&
         [flag_template],&
         comm%oucube,&
         error)
    if (error)  return
  end subroutine cubetemplate_subcube2subcube_comm_register
  !
  subroutine cubetemplate_subcube2subcube_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! SUBCUBE2SUBCUBE cubname
    !----------------------------------------------------------------------
    class(subcube2subcube_comm_t), intent(in)    :: comm
    character(len=*),              intent(in)    :: line
    type(subcube2subcube_user_t),  intent(out)   :: user
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
    call comm%factor%parse(line,user%factor,error)
    if (error) return
  end subroutine cubetemplate_subcube2subcube_comm_parse
  !
  subroutine cubetemplate_subcube2subcube_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_comm_t), intent(in)    :: comm
    type(subcube2subcube_user_t),  intent(inout) :: user
    logical,                       intent(inout) :: error
    !
    type(subcube2subcube_prog_t) :: prog
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_subcube2subcube_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_subcube2subcube_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_user_t), intent(in)    :: user
    type(subcube2subcube_comm_t),  intent(in)    :: comm
    type(subcube2subcube_prog_t),  intent(out)   :: prog
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call user%factor%toprog(prog%factor,error)
    if (error) return
    call user%region%toprog(prog%incube,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%factor%list(error)
    if (error) return
    call prog%region%list(error)
    if (error) return
  end subroutine cubetemplate_subcube2subcube_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_subcube2subcube_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_prog_t), intent(inout) :: prog
    type(subcube2subcube_comm_t),  intent(in)    :: comm
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header_with_region(comm%oucube,  &
      prog%incube,prog%region,prog%oucube,error)
    if (error) return
    call prog%factor%header(prog%oucube,error)
    if (error) return
  end subroutine cubetemplate_subcube2subcube_prog_header
  !
  subroutine cubetemplate_subcube2subcube_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(subcube2subcube_prog_t), intent(inout) :: prog
    logical,                       intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>DATA'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubetemplate_subcube2subcube_prog_data
  !   
  subroutine cubetemplate_subcube2subcube_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_subcube_types
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),      intent(inout) :: iter
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>LOOP'
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter,error)
      if (error) return
    enddo
  end subroutine cubetemplate_subcube2subcube_prog_loop
  !   
  subroutine cubetemplate_subcube2subcube_prog_act(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),      intent(in)    :: iter
    logical,                       intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    type(subcube_t) :: insub,ousub
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>ACT'
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube to another.
    call insub%associate('insub',prog%incube,iter,error)
    if (error) return
    call ousub%allocate('ousub',prog%oucube,iter,error)
    if (error) return
    !
    call insub%get(error)
    if (error) return
    do iz=1,insub%nz
       do iy=1,insub%ny
          do ix=1,insub%nx
             ousub%val(ix,iy,iz) = prog%factor%val*insub%val(ix,iy,iz)
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call ousub%put(error)
    if (error) return
  end subroutine cubetemplate_subcube2subcube_prog_act
end module cubetemplate_subcube2subcube
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program histo_cloud
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Main program for making a "Cloud of Points" Histogram from two maps
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namez,namey,namex
  logical :: error
  integer :: ier
  integer(kind=size_length) :: n, npoin, nmax
  type(gildas) :: x,y,z
  real, allocatable :: work(:,:)
  !
  call gildas_open
  call gildas_char('Z_NAME$',namez)
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_close
  !
  ! Map first image
  !
  call gildas_null(z)
  call gdf_read_gildas(z,namez,'.gdf',error,rank=0)
  if (error) goto 100
  !
  ! y%gil%form = fmt_r4 ! This is the default
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error,rank=0)
  if (error) goto 100
  !
  ! How many points will be put in the table ? 
  ! (i.e. the dimension of the table)
  if (y%gil%blan_words.eq.0) y%gil%eval=-1.0
  if (z%gil%blan_words.eq.0) z%gil%eval=-1.0
  nmax = y%gil%dim(1)*y%gil%dim(2)
  if (nmax.ne.z%gil%dim(1)*z%gil%dim(2)) then
    call gagout('F-HISTO_CLOUD,  Images are not coincident')
    goto 100
  endif
  allocate(work(y%loca%size,2), stat=ier)
  if (ier.ne.0) then
    call gagout('F-HISTO_CLOUD,  Memory allocation error')
    goto 100
  endif
  call cloud001(z%r1d, y%r1d,  &
     &    y%loca%size, y%gil%bval,y%gil%eval,z%gil%bval,z%gil%eval,   &
     &    work,nmax,npoin)
  if (npoin.eq.0) then
    call gagout('F-HISTO_CLOUD,  No Point in Table')
    goto 100
  endif
  !
  ! Open output table (2columns)
  n = len_trim(namex)
  if (n.eq.0) goto 100
  call gildas_null(x, type= 'TABLE') 
  call sic_parsef(namex(1:n),x%file,' ','.tab')
  x%gil%dim(1) = npoin
  x%gil%dim(2) = 2
  x%gil%ndim = 2
  allocate (x%r2d(npoin,2), stat=ier)
  x%r2d(:,1) = work(1:npoin, 1)
  x%r2d(:,2) = work(1:npoin, 2)
  call gdf_write_image(x, x%r2d, error)
  call gagout('S-HISTO_CLOUD,  Successful completion')
  call sysexi(1)
  !
100 call sysexi(fatale)
end program histo_cloud
!
subroutine cloud001 (z,y,nxy,bvaly,evaly,bvalz,evalz,h,   &
     &    nmax,nin)
  use gildas_def
  !---------------------------------------------------------------------
  ! GDF	Computes a table containing the values of each pixel
  !	of the 2 input images (i.e., the cross histogram is
  !	represented by a scatter of points)
  !
  ! Arguments :
  !	Z	R*4(*)	First input image
  !	Y	R*4(*)	Second input image
  !	NX	I	First dimension of input images
  !	NY	I	Second dimension of input images
  !	BVALY	R*4	Blanking value of input Y image
  !	EVALY	R*4	Tolerance on blanking value
  !	BVALZ	R*4	Blanking value of input Z image
  !	EVALZ	R*4	Tolerance on blanking value
  !	H	R*4(*)	Result Table
  !---------------------------------------------------------------------
  integer(kind=size_length) :: nxy    !
  real*4 :: z(nxy)                   !
  real*4 :: y(nxy)                  !
  real*4 :: bvaly                   !
  real*4 :: evaly                   !
  real*4 :: bvalz                   !
  real*4 :: evalz                   !
  integer(kind=size_length), intent(in)  :: nmax  ! Maximum size of table
  real*4 :: h(nmax,2)               !
  integer(kind=size_length), intent(out) :: nin   ! Current size of table
  ! Local
  integer(kind=size_length) :: i
  !
  nin=0
  if (evalz.ge.0.0) then
    if (evaly.ge.0.0) then
      do i=1,nxy
        if (abs(z(i)-bvalz).gt.evalz .and.   &
   &            abs(y(i)-bvaly).gt.evaly) then
          nin = nin+1
          h(nin,1)=z(i)
          h(nin,2)=y(i)
        endif
      enddo
    else
      do i=1,nxy
        if (abs(z(i)-bvalz).gt.evalz) then
          nin = nin+1
          h(nin,1)=z(i)
          h(nin,2)=y(i)
        endif
      enddo
    endif
  else
    if (evaly.ge.0.0) then
      do i=1,nxy
        if (abs(y(i)-bvaly).gt.evaly) then
          nin = nin+1
          h(nin,1)=z(i)
          h(nin,2)=y(i)
        endif
      enddo
    else
      do i=1,nxy
        nin = nin+1
        h(nin,1)=z(i)
        h(nin,2)=y(i)
      enddo
    endif
  endif
end subroutine cloud001

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module imaging_fit
  use gbl_message
  !
  public :: fit_comm
  private
  !
contains
  !  
  subroutine fit_comm(line,error)
    use gkernel_interfaces
    use clean_beam_tool, only: beam_for_channel
    use uvmap_buffers
    use clean_buffers, only: clean_prog
    !---------------------------------------------------------------------------
    ! Support routine for command FIT [ifield]
    !---------------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ifield
    character(len=message_length) :: chain
    character(len=*), parameter :: rname='FIT>COMM'
    !
    if (hbeam%loca%size.eq.0) then
       call map_message(seve%e,rname,'No Dirty Beam')
       error = .true.
       return
    endif
    clean_prog%ibeam = beam_for_channel(clean_prog%iplane,dirty%head,hbeam)
    ifield = 1
    call sic_i4(line,0,1,ifield,.false.,error)
    if (error) return
    ifield = min(hbeam%gil%dim(3),max(1,ifield))
    if (hbeam%gil%dim(3).gt.1) then
       write(chain,'(A,I4,A,I4)') 'Fitting beam # ',ifield,' /',hbeam%gil%dim(3)
       call map_message(seve%i,rname,chain)
    endif
    if (hbeam%gil%dim(4).gt.1) then
       write(chain,'(A,I4,A,I4)') 'Fitting plane # ',clean_prog%ibeam,' /',hbeam%gil%dim(4)
       call map_message(seve%i,rname,chain)
    endif
    clean_prog%major = 0.0
    clean_prog%minor = 0.0
    clean_prog%angle = 0.0
    clean_prog%thresh = 0.30
    call sic_get_real('THRESHOLD',clean_prog%thresh,error)
    !
    call clean_prog%fit_beam(hbeam,dbeam(:,:,ifield,clean_prog%ibeam),error)
    if (error) return
  end subroutine fit_comm
end module imaging_fit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE ORBIT_OPTIMISE(LINE,ERROR)
      USE GKERNEL_INTERFACES
      CHARACTER LINE*(*)
      LOGICAL ERROR
*      
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
      INCLUDE 'pi.inc'
*     
!      INCLUDE 'interface.inc'
*
      INTEGER MVOCAB,ID
      PARAMETER (MVOCAB=4)
      CHARACTER*12 VOCAB(MVOCAB),ARGUM,DATE
      CHARACTER NAME,OUT_FILE*80
      INTEGER NKEY,NCH,OUTLUN,NF,STATUS
      REAL DURATION
*
      INTEGER NVSB1,NVSB2,NXY
      REAL JDMIN,JDMAX,SIGVSB1,SIGVSB2A,SIGVSB2B,SIGXY
      CHARACTER TARGET*16
      REAL XBEST(MVR+MOBS),YBEST
      LOGICAL STORE
*
      DATA VOCAB /'MASS_A','MASS_B','MASS_TOT','PARALLAX'/
* Determine requested action type from command line
      ERROR = .FALSE.
      ARGUM = 'MASS_B'
      CALL SIC_CH (LINE,0,1,ARGUM,NCH,.FALSE.,ERROR)
      IF (ERROR) RETURN
      CALL SIC_AMBIGS('OPTIMISE',ARGUM,TARGET,NKEY,VOCAB,
     +     MVOCAB,ERROR)
      IF (ERROR) RETURN
* Should simulated data be kept in data arrays?
      STORE = SIC_PRESENT(6,0)
* Determine observing interval limits
      CALL SIC_R4 (LINE,1,1,DURATION,.TRUE.,ERROR) ! Could default to period??
      IF (ERROR) RETURN
      IF (DURATION.LE.0) THEN
         WRITE(6,*) 'E-OPTIMISE, Invalid duration of observing period.',
     +        ' Must be positive.',DURATION
         GOTO 100
      ENDIF
      IF (.NOT.SIC_PRESENT(1,2)) THEN ! Default to current date
         CALL SIC_DATE(DATE)
         CALL CDATE(DATE,ID,ERROR)
         JDMIN = ID+60549.5D0
      ELSE 
         CALL SIC_R4 (LINE,1,2,JDMIN,.TRUE.,ERROR)
      ENDIF
      JDMAX = JDMIN+DURATION
* Retrieve number of radial velocity measurements and their accuracy
      NVSB1 = 0
      IF (SIC_PRESENT(2,0)) THEN
         CALL SIC_I4 (LINE,2,1,NVSB1,.TRUE.,ERROR)
         IF (ERROR) GOTO 100
         IF (NVSB1.LT.0) THEN
            WRITE(6,*) 'E-OPTIMISE, Invalid number of single ',
     +           'line radial velocity measurements. ',
     +           'Must be positive.', NVSB1
            GOTO 100
         ENDIF
         CALL SIC_R4 (LINE,2,2,SIGVSB1,.TRUE.,ERROR)
         IF (ERROR) GOTO 100
         IF (SIGVSB1.LE.0) THEN
            WRITE(6,*) 'E-OPTIMISE, Invalid standard error for ',
     +           'single line radial velocities. Must be positive.'
     +           , SIGVSB1
            GOTO 100
         ENDIF
      ENDIF
      NVSB2 = 0
      IF (SIC_PRESENT(3,0)) THEN
         CALL SIC_I4 (LINE,3,1,NVSB2,.TRUE.,ERROR)
         IF (ERROR) GOTO 100
         IF (NVSB2.LT.0) THEN
            WRITE(6,*) 'E-OPTIMISE, Invalid number of double ',
     +           'line radial velocity measurements. ',
     +           'Must be positive.', NVSB2
            GOTO 100
         ENDIF
         CALL SIC_R4 (LINE,3,3,SIGVSB2B,.TRUE.,ERROR)
         IF (ERROR) RETURN
         CALL SIC_R4 (LINE,3,2,SIGVSB2A,.TRUE.,ERROR)
         IF (ERROR) RETURN
         IF (SIGVSB2A.LE.0.OR.SIGVSB2B.LE.0) THEN
            WRITE(6,*) 'E-OPTIMISE, Invalid standard error for ',
     +           'double line radial velocities. Must both be positive.'
     +           , SIGVSB2A, SIGVSB2B
            GOTO 100
         ENDIF
      ENDIF
      IF ((NVSB1+2*NVSB2+NVR).GT.MVR) THEN
         WRITE(6,*) 'E-OPTIMISE,  Too many radial velocities for ',
     +        'current program dimensions'
         GOTO 100
      ENDIF
* Retrieve number of angular separation measurements and their accuracy
      NXY = 0
      IF (SIC_PRESENT(4,0)) THEN
         CALL SIC_I4 (LINE,4,1,NXY,.TRUE.,ERROR)
         IF (ERROR) RETURN
         IF ((NXY+NN).GT.MOBS) THEN
            WRITE(6,*) 'E-OPTIMISE,  Too many visual measurements for ',
     +           'current program dimensions'
            GOTO 100
         ELSEIF (NXY.LT.0) THEN
            WRITE(6,*) 'E-OPTIMISE,  Invalid number of visual ',
     +           'measurements. Must be positive ',NXY
            GOTO 100
         ELSE
            CALL SIC_R4 (LINE,4,2,SIGXY,.TRUE.,ERROR)
            IF (ERROR) RETURN
         ENDIF
      ENDIF
* Ouput listing name (default to stdout)
      IF (SIC_PRESENT(5,0)) THEN
         CALL SIC_CH(LINE,5,1,NAME,NF,.TRUE.,ERROR)
         IF (ERROR) GOTO 100
         STATUS= SIC_GETLUN(OUTLUN)
         IF (STATUS.NE.0) THEN
            WRITE(6,*) 'E-OPTIMISE,  Cannot open file ',
     +           OUT_FILE(1:LENC(OUT_FILE))
            CALL SIC_FRELUN(OUTLUN)
            GOTO 100
         ENDIF
         CALL SIC_PARSEF(NAME(1:NF),OUT_FILE,' ','.LIS')
         OPEN(UNIT=OUTLUN,FILE=OUT_FILE,STATUS='UNKNOWN',
     +        IOSTAT=STATUS)
         IF (STATUS.NE.0) THEN
            WRITE(6,*) 'E-LIST,  Cannot open file ',
     +           OUT_FILE(1:LENC(OUT_FILE))
            CALL SIC_FRELUN(OUTLUN)
            GOTO 100
         ENDIF
      ELSE
         OUTLUN = 6
      ENDIF
*
      WRITE(6,*) 'W-OPTIMISE,  Work on this command is still ',
     +     'going on. Not yet fully tested. '
*
* Command line has been decoded, call the subroutine that makes the actual
* work.
      CALL DO_OPTIMISE(TARGET,JDMIN,JDMAX,NVSB1,NVSB2,NXY,SIGVSB1,
     +     SIGVSB2A,SIGVSB2B,SIGXY,XBEST,YBEST,ERROR)
      IF (ERROR) GOTO 90
* Printout the optimised schedule, and resulting errors on all parameters
      CALL PRINT_BEST_SCHEDULE(OUTLUN,NVSB1,NVSB2,NXY,
     +     TARGET,YBEST,XBEST,ERROR)
      IF (ERROR) GOTO 100
*
* Cleanup
 90   CONTINUE
      IF (OUTLUN.NE.6) THEN
         CLOSE(OUTLUN)
         CALL SIC_FRELUN(OUTLUN)
      ENDIF
      IF (.NOT.ERROR.AND.STORE) THEN
         NN  = NN+NXY
         NVR = NVR+NVSB1+2*NVSB2
      ENDIF
      RETURN
*
 100  ERROR = .TRUE.
      RETURN
      END

      SUBROUTINE DO_OPTIMISE(TARGET,JDMIN,JDMAX,NVSB1,NVSB2,NXY,SIGVSB1,
     +     SIGVSB2A,SIGVSB2B,SIGXY,XBEST,YBEST,ERROR)
C-----------------------------------------------------------------------------
C Orbit:
C   Observing schedule optimisation. Make the actual work.
C Arguments:
C   TARGET  C     Minimised function
C   JDMIN   R     Start of observing interval
C   JDMAX   R     End of observing interval
C   NVSB1   R     Number of single line radial velocity measurements
C   NVSB2   R     Number of double line radial velocity measurements
C   NXY     R     Number of visual measurements
C   SIGVSB1 R     Standard error of single line radial velocity measurements
C   SIGVSB2A R    Standard error for first component in double line measurements
C   SIGVSB2B R    Standard error for second component in double line measurements
C   SIGXY   R     Standard error for angular separation measurements
C   XBEST   R(*)  Optimal set of additional observing dates
C   YBEST   R     Optimal value of parameter
C   ERROR   L     Error flag
C-----------------------------------------------------------------------------
      REAL JDMIN,JDMAX,SIGVSB1,SIGVSB2A,SIGVSB2B,SIGXY
      INTEGER NVSB1,NVSB2,NXY
      REAL XBEST(*),YBEST
      CHARACTER*(*) TARGET
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
      INCLUDE 'optimise.inc'
      INCLUDE 'elements.inc'
      INCLUDE 'pi.inc'
*
      REAL SIMPLEX(MVR+MOBS,MVR+MOBS+1),Y(MVR+MOBS+1)
      REAL TEMPTR,FTOL
      INTEGER ITER,MITER
      REAL GAG_RANDOM,DURATION
      INTEGER I,J
      REAL ERREUR_FUNCT
      EXTERNAL ERREUR_FUNCT
* 
* Initialise internal set of orbital elements
      CALL INIT_KEPLER(EL,.TRUE.)
* Copy control parameters to internal common block, for use by optimised
* function.
      OPT_TARGET = TARGET
      OPT_JDMIN = JDMIN
      OPT_JDMAX = JDMAX
      OPT_NV_SB1 = NVSB1
      OPT_NV_SB2 = NVSB2
      OPT_NXY = NXY
      OPT_SIGV_SB1 = SIGVSB1
      OPT_SIGV_SB2A = SIGVSB2A
      OPT_SIGV_SB2B = SIGVSB2B
      OPT_SIGXY = SIGXY
* Initialise the schedule simplex with a random distribution.
      NDIM = OPT_NV_SB1+OPT_NV_SB2+OPT_NXY
      DURATION = OPT_JDMAX-OPT_JDMIN
      DO J=1,NDIM+1
         DO I=1,NDIM
            SIMPLEX(I,J) = OPT_JDMIN+DURATION*GAG_RANDOM()
         ENDDO
         Y(J) = ERREUR_FUNCT(SIMPLEX(1,J))
      ENDDO
      DO I=1,NDIM
         XBEST(I) = SIMPLEX(I,1) 
      ENDDO
      YBEST = Y(1)
      MITER = 500
      TEMPTR = 0   ! No annealing for the time being
      FTOL = 1.E-2 ! Assume this means practical convergence
*
      ITER = MITER
      CALL AMEBSA(SIMPLEX,Y,MVR+MOBS,MVR+MOBS+1,NDIM,XBEST,
     +     YBEST,FTOL,ERREUR_FUNCT,ITER,TEMPTR,ERROR)
*
      RETURN
* Reset orbital elements??? Looks weird, never reached.
!      CALL INIT_KEPLER(EL,.FALSE.)
      END

      SUBROUTINE PRINT_BEST_SCHEDULE(LUN,NSB1,NSB2,NXY,TARGET,
     +     YBEST,PBEST,ERROR)
      USE GKERNEL_INTERFACES
C--------------------------------------------------------------------------
C Orbit:
c   Readable printout of the optimised observing schedule.
C Arguments:
C     LUN     I       Logical unit for output
C     NSB1    I       Number of single line radial velocity measurements
C     NSB2    I       Number of double line radial velocity measurements
C     NXY     I       Number of angular separation measurements
C     TARGET  C*(*)   Optimised parameter
C     YBEST   R       Best error on target parameter
C     PBEST   R*4()   Observing dates of the optimal schedule
C--------------------------------------------------------------------------
      INTEGER LUN,NSB1,NSB2,NXY
      CHARACTER*(*) TARGET
      REAL YBEST
      REAL PBEST(NSB1+NSB2+NXY)
*
      INCLUDE 'constant.inc'
      INCLUDE 'elements.inc'
      INCLUDE 'pi.inc'
      INTEGER IT(MVR+MOBS)

      INTEGER I
      REAL PHASE
      REAL*8 TT
      LOGICAL ERROR
      CHARACTER CHAIN*17
*
      REAL Mtot,M_A,M_B,dMtot,dM_A,dM_B 
      REAL a1Sini, a2Sini   ! Projected semi major axes
      REAL f1m, f2m         ! Mass functions
      REAL M1sin3i, M2sin3i   ! "projected masses"
      REAL dM1sin3i, dM2sin3i ! and their standard errors
      REAL Orb_Par,dOrb_Par ! Orbital parallax and probable error
      REAL V1,V2,dV1,dV2
      REAL RHO,THETA,dRHO,dTHETA
      REAL B(MA)
      REAL ERREUR_FUNCT, DUMMY
*
      WRITE(LUN,90) 'Best error on ',TARGET(1:LENC(TARGET)),
     +     ' was:',100*YBEST,'%'
 90   FORMAT(1X,A,A,A,1X,F4.1,A)
* Reset orbital elements to compute ephemerid
      CALL INIT_KEPLER(EL,.FALSE.)
*
* Single line spectroscopic observations
      IF (NSB1.GT.0) THEN
         CALL GR4_TRIE(PBEST(1:),IT,NSB1,ERROR)  ! Sort by observing date
         WRITE(LUN,*) 'For SB1 observations on '
         DO I=1,NSB1
            TT = PBEST(I)
            CALL FORMAT_DATE(TT,CHAIN,ERROR)
            CALL SET_TIME(1,IORB0,TT,PHASE)
            CALL GRAD_V1(1,V1,B)  ! Assume main velocity referential
            CALL EVAL_ERROR(dV1,B)
            WRITE(LUN,100) PBEST(I),CHAIN,PHASE,V1,dV1
         ENDDO
      ENDIF
  100  FORMAT(1X,F9.3,1X,A,1X,F5.3,(F7.1,'(',F4.1,')'))
*
* Double line spectroscopic observations
      IF (NSB2.GT.0) THEN
         CALL GR4_TRIE(PBEST(NSB1+1:),IT,NSB2,ERROR)  ! Sort by observing date
         WRITE(LUN,*) 'For SB2 observations on '
         DO I=NSB1+1,NSB1+NSB2
            TT = PBEST(I)
            CALL FORMAT_DATE(TT,CHAIN,ERROR)
            CALL SET_TIME(1,IORB0,TT,PHASE)
            CALL GRAD_V1(1,V1,B)
            CALL EVAL_ERROR(dV1,B)
            CALL GRAD_V2(1,V2,B)
            CALL EVAL_ERROR(dV2,B)
            WRITE(LUN,110) PBEST(I),CHAIN,PHASE,V1,dV1,V2,dV2
         ENDDO
      ENDIF
 110  FORMAT(1X,F9.3,1X,A,1X,F5.3,2(F7.1,'(',F4.1,')'))
*
* Visual observations
      IF (NXY.GT.0) THEN
         CALL GR4_TRIE(PBEST(NSB1+NSB2+1:),IT,NXY,ERROR) ! Sort 
         WRITE(LUN,*) 'For visual observations on '
         DO I=NSB1+NSB2+1,NSB1+NSB2+NXY
            TT = PBEST(I)
            CALL FORMAT_DATE(TT,CHAIN,ERROR)
            CALL SET_TIME(1,IORB0,TT,PHASE)
            CALL GRAD_RHO(RHO,B)
            CALL EVAL_ERROR(dRHO,B)
            CALL GRAD_THETA(THETA,B)
            CALL EVAL_ERROR(dTHETA,B)
            dTHETA = dTHETA*GR  ! Convert standard error to degrees
            WRITE(LUN,120) PBEST(I),CHAIN,PHASE,RHO,dRHO,THETA,dTHETA
         ENDDO
      ENDIF
 120  FORMAT(1X,F9.3,1X,A,1X,F5.3,(F5.3,'(',F4.3,')'), 
     +        (F6.1,'(',F3.1,')'))
      WRITE(LUN,*) ' '
* Make sure that the covariance matrix does corresponds to the observing
* schedule. This is important when the optimisation isn't fully converged.
      DUMMY = ERREUR_FUNCT(PBEST) 
*
* Print standard errors on all parameters
      CALL COMPUTE_MASSES(EL,MA,.TRUE.,
     +     a1sini,a2sini,f1m,f2m,
     +     M1sin3i,dM1sin3i,M2sin3i,dM2sin3i,
     +     Mtot,dMtot,M_A,dM_A,M_B,dM_B,
     +     Orb_Par,dOrb_Par,ERROR)
      IF (ERROR) GOTO 99
* Total mass
      WRITE(LUN,400) 'Total Mass =',Mtot,dMtot,100*dMtot/Mtot
 400  FORMAT(A,1X,F6.3,1X,'+-',F6.3,1X,
     +     'Solar masses',1X,'(',F4.1,'%',')')
*     Individual masses
      WRITE(LUN,400) 'Mass A =',M_A,dM_A,100*dM_A/M_A
      WRITE(LUN,400) 'Mass B =',M_B,dM_B,100*dM_B/M_B
*     Orbital parallax
      write(LUN,410) 'Parallax is ',Orb_Par,dOrb_Par,
     +     100*dOrb_Par/Orb_Par
 410  FORMAT(A,F6.4,1X,'+-',F5.4,'"',1X,'(',F4.1,'%)')
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeio_header_interface
  use cubetools_parameters
  use cubetools_header_interface
  use cubeio_messaging
  !---------------------------------------------------------------------
  ! Support module for IO-specific actions on cube_header_interface_t
  !---------------------------------------------------------------------
  !
  public :: cubeio_header_interface_derive_xyc
  public :: cubeio_header_interface_transpose
  public :: cubeio_header_interface_truncate
  private
  !
contains
  !
  subroutine cubeio_header_interface_derive_xyc(interface,ndim,  &
    ix,nx,iy,ny,ic,nc,error)
    use cubetools_unit
    !-------------------------------------------------------------------
    ! Simplified overlay to interface%derive_xyc(), returning the only
    ! elements relevant in the IO context.
    !-------------------------------------------------------------------
    type(cube_header_interface_t), intent(in)    :: interface
    integer(kind=ndim_k),          intent(out)   :: ndim
    integer(kind=ndim_k),          intent(out)   :: ix,iy,ic
    integer(kind=data_k),          intent(out)   :: nx,ny,nc
    logical,                       intent(inout) :: error
    !
    integer(kind=code_k) :: kind(maxdim)
    integer(kind=data_k) :: dim(maxdim)
    character(len=unit_l) :: name(maxdim),unit(maxdim)
    !
    ndim    = interface%axset_ndim
    dim(:)  = interface%axset_dim(:)
    name(:) = strg_unk  ! Unused
    unit(:) = strg_unk  ! Unused
    kind(:) = code_unit_unk  ! Unused
    call interface%derive_xyc(ix,nx,  &
                              iy,ny,  &
                              ic,nc,  &
                              ndim,dim,name,unit,kind,error)
    if (error)  return
  end subroutine cubeio_header_interface_derive_xyc
  !
  subroutine cubeio_header_interface_transpose(interface,oorder,error)
    !-------------------------------------------------------------------
    ! Ensure the interface is converted to the desired order. The
    ! interface_t usually comes from an header_t and it can be in
    ! whatever order. We need to sort it as wanted, which may include
    ! a transposition.
    !
    ! This piece of code is probably not 100% satisfying if the original
    ! order is not well recognized, i.e. if IX/IY/IC are missing. To be
    ! improved!
    !-------------------------------------------------------------------
    type(cube_header_interface_t), intent(inout) :: interface
    integer(kind=code_k),          intent(in)    :: oorder   ! Requested order
    logical,                       intent(inout) :: error
    !
    integer(kind=code_k) :: iorder  ! Current order
    integer(kind=ndim_k) :: ix,iy,ic
    integer(kind=data_k) :: nx,ny,nc
    integer(kind=ndim_k) :: idim,odim,ndim,tr(maxdim)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='HEADER>INTERFACE>TRANSPOSE'
    !
    if (oorder.eq.code_access_any)  return  ! No particular access requested
    !
    iorder = cubeio_header_interface_order(interface)
    if (iorder.eq.oorder)  return  ! Already in correct access
    !
    if (oorder.eq.code_access_imaset_or_speset) then
      if (iorder.eq.code_cube_imaset .or.  &
          iorder.eq.code_cube_speset) then
        return  ! Already a correct access
      endif
    endif
    !
    ! Need to go to another order: we have to be coherent with
    ! cubeio_iodesc_import calling derive_xyc, which has the responsibility
    ! to decide what dimension is IX, IY, IC, in particular when one is
    ! missing.
    call cubeio_header_interface_derive_xyc(interface,ndim,  &
                                            ix,nx,  &
                                            iy,ny,  &
                                            ic,nc,error)
    if (error)  return
    !
    ! Note that this code does not need to know which access it comes from
    ! (could be unknown). It only needs to know where it goes to.
    select case (oorder)
    case (code_cube_speset)
      ! Put C dimension first
      tr(1) = ic
      odim = 1
      do idim=1,maxdim
        if (idim.eq.ic)  cycle
        odim = odim+1
        tr(odim) = idim
      enddo
      !
    case (code_cube_imaset)
      ! Put XY dimensions first
      tr(1) = ix
      tr(2) = iy
      odim = 2
      do idim=1,maxdim
        if (idim.eq.ix .or. idim.eq.iy)  cycle
        odim = odim+1
        tr(odim) = idim
      enddo
      !
    case default
      write(mess,'(A,I0,A,I0)')  &
        'Do not know how to go from order ',iorder,' to order ',oorder
      call cubeio_message(seve%e,rname,mess)
      error = .true.
      return
    end select
    !
    ! Note that this transposition may insert zero-sized dimensions
    ! between other ones.
    call interface%transpose(tr(1:ndim),error)
    if (error)  return
  end subroutine cubeio_header_interface_transpose
  !
  function cubeio_header_interface_order(interface)
    integer(kind=code_k) :: cubeio_header_interface_order
    type(cube_header_interface_t), intent(in) :: interface
    !
    ! ZZZ This code should also rely on derive_xyc to guess the cube order,
    ! in particular when IX, IY, or IC are missing
    if (interface%axset_ix.eq.1 .and. &
        interface%axset_iy.eq.2) then
      cubeio_header_interface_order = code_cube_imaset
    elseif (interface%axset_ic.eq.1) then
      cubeio_header_interface_order = code_cube_speset
    else
      cubeio_header_interface_order = code_cube_unkset
    endif
  end function cubeio_header_interface_order
  !
  subroutine cubeio_header_interface_truncate(interface,dim3,error)
    !-------------------------------------------------------------------
    ! Truncate the 3rd (i.e. iterated) dimension to the given value,
    ! including sanity checks.
    !
    ! This API is relevant e.g. when writing output files on disk. They
    ! are written with slices, and the header (dimensions) is updated
    ! accordingly at each increase of the data block, so that it remains
    ! consistent.
    !-------------------------------------------------------------------
    type(cube_header_interface_t), intent(inout) :: interface
    integer(kind=data_k),          intent(in)    :: dim3
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>INTERFACE>TRUNCATE'
    !
    ! ZZZ This code should not modify interface%axset_dim(3), but
    !     interface%axset_dim(cube%desc%i3) instead!
    !
    ! Sanity check
    select case (interface%axset_ndim)
    case (1,2)
      if (dim3.gt.1) then
        call cubeio_message(seve%e,rname,  &
          'Internal error: can not truncate 3rd dimension while data is 1D or 2D')
        error = .true.
        return
      endif
    case (3)
      if (dim3.gt.interface%axset_dim(3)) then
        call cubeio_message(seve%e,rname,  &
          'Internal error: can not truncate beyond the 3rd dimension')
        error = .true.
        return
      endif
      interface%axset_dim(3) = dim3
    case default
      ! Reject only if some other dimension is non-degenerate
      if (any(interface%axset_dim(4:interface%axset_ndim).gt.1)) then
        call cubeio_message(seve%e,rname,  &
          'Not implemented: truncating last dimension of 4D (or more) data')
        error = .true.
        return
      endif
    end select
  end subroutine cubeio_header_interface_truncate
end module cubeio_header_interface
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module class_interfaces
  !---------------------------------------------------------------------
  ! CLASS interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use class_interfaces_public
  use class_interfaces_private
  !
end module class_interfaces
!
module class_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  use gkernel_interfaces
  use astro_interfaces_public
  use classcore_interfaces_public
  use classfit_interfaces_public
end module class_dependencies_interfaces
!
module class_api
  !---------------------------------------------------------------------
  ! @ public
  !   CLASS public interfaces, parameters, and types. Can be used by
  ! external programs
  !---------------------------------------------------------------------
  !
  use classic_api  ! This helps to hide the libclassic to programs using
                   ! the libclass
  !
  ! use class_parameters
  use class_types
  use classcore_interfaces_public
  use class_interfaces_public
  !
end module class_api
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_structure_main
  use cubetools_parameters
  use cubelist_types
  use cubesyntax_messaging
  use cubetools_package
  use cubetools_terminal_tool
  use cubetools_language
  use cubetools_command
  use cubetools_primitive_opt
  use cubetools_primitive_arg
  use cubetools_primitive_prod
  !
  public :: cubetools_register_package,cubetools_list_package_languages
  public :: cubetools_register_language,cubetools_list_language_commands
  public :: cubetools_register_primitive_comm
  public :: cubetools_register_primitive_opt
  public :: cubetools_register_primitive_arg
  public :: cubetools_register_primitive_prod
  public :: cubetools_register_dict
  public :: cubetools_execute_command,cubetools_show_command
  public :: cubetools_getarg
  public :: cubetools_nopt
  public :: cubetools_pack_has_language,cubetools_structure_help_iterate
  public :: pack
  !
  private
  !
  interface cubetools_getarg
     module procedure cubetools_getarg_r4
     module procedure cubetools_getarg_r8
     module procedure cubetools_getarg_i4
     module procedure cubetools_getarg_i8
     module procedure cubetools_getarg_st
  end interface cubetools_getarg
  !
  type(package_t), target :: pack
  !
contains
  !
  subroutine cubetools_register_package(name,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: help
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='REGISTER>PACKAGE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%put(name,help,error)
    if (error) return
  end subroutine cubetools_register_package
  !
  subroutine cubetools_register_language(name,authors,abstract,help,helpfile,run,langid,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: authors
    character(len=*),     intent(in)    :: abstract
    character(len=*),     intent(in)    :: help
    character(len=*),     intent(in)    :: helpfile
    external                            :: run
    integer(kind=lang_k), intent(out)   :: langid
    logical,              intent(inout) :: error
    !
    type(language_t) :: template
    class(list_object_t), pointer :: lot
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='REGISTER>LANGUAGE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%lang%allocate(template,lot,error)
    if (error)  return
    lang => cubetools_language_ptr(lot,error)
    if (error) return
    call lang%put(name,authors,abstract,help,helpfile,run,error)
    if (error) return
    langid = pack%lang%n
  end subroutine cubetools_register_language
  !
  subroutine cubetools_register_primitive_comm(template,otemplate,  &
    name,syntax,abstract,help,run,popt,error,allowopt)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(command_t),        intent(in)    :: template   ! Command template
    class(primitive_opt_t), intent(in)    :: otemplate  ! Option template
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: syntax
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    external                              :: run
    class(primitive_opt_t), pointer       :: popt       ! Return pointer to registered 'option'
    logical,                intent(inout) :: error
    logical, optional,      intent(in)    :: allowopt
    !
    type(language_t), pointer :: lang
    class(list_object_t), pointer :: lot
    type(command_t), pointer :: comm
    integer(kind=comm_k) :: ncomm
    character(len=*), parameter :: rname='REGISTER>COMMAND'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    !
    call lang%comm%allocate(template,lot,error)
    if (error)  return
    ncomm = lang%comm%n
    lang%ndict = lang%ndict+1
    comm => cubetools_command_ptr(lot,error)
    if (error) return
    call comm%put(ncomm,name,abstract,help,run,error)
    if (error) return
    if (present(allowopt))  comm%allowopt = allowopt
    ! The numbering of options to this command start at 0 (command==0)
    call comm%opt%lbound(0_list_k,error)
    if (error)  return
    !
    ! Register 0-eth option that contains command's syntax and a copy
    ! of its help and abstract
    call cubetools_register_primitive_opt(otemplate,name,syntax,abstract,help,popt,error)
    if (error) return
  end subroutine cubetools_register_primitive_comm
  !
  subroutine cubetools_register_primitive_opt(template,name,syntax,abstract,help,popt,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: template
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: syntax
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    class(primitive_opt_t), pointer       :: popt  ! Return pointer to registered option
    logical,                intent(inout) :: error
    !
    type(language_t), pointer :: lang
    type(command_t), pointer :: comm
    class(list_object_t), pointer :: lot
    integer(kind=opti_k) :: nopt
    character(len=*), parameter :: rname='REGISTER>OPTION'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    comm => cubetools_command_ptr(lang%comm%list(lang%comm%n)%p,error)
    if (error) return
    !
    call comm%opt%allocate(template,lot,error)
    if (error) return
    nopt = comm%opt%n
    if (nopt.gt.0) lang%ndict = lang%ndict+1
    popt => cubetools_primitive_opt_ptr(lot,error)
    if (error) return
    call popt%put(nopt,name,syntax,abstract,help,error)
    if (error) return
  end subroutine cubetools_register_primitive_opt
  !
  subroutine cubetools_register_primitive_arg(template,name,abstract,help,  &
    mandat,parg,error)
    !----------------------------------------------------------------------
    ! Register any argument of class primitive_arg_t in the global 'pack'
    !----------------------------------------------------------------------
    class(primitive_arg_t), intent(in)    :: template
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    integer(kind=code_k),   intent(in)    :: mandat
    class(primitive_arg_t), pointer       :: parg  ! Return pointer to actual arg
    logical,                intent(inout) :: error
    !
    type(language_t), pointer :: lang
    type(command_t), pointer :: comm
    class(primitive_opt_t), pointer :: opt
    class(list_object_t), pointer :: lot
    integer(kind=narg_k) :: iarg
    integer(kind=4), parameter :: narginfinite=huge(1_4)
    character(len=*), parameter :: rname='REGISTER>ARGUMENT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    parg => null()
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    comm => cubetools_command_ptr(lang%comm%list(lang%comm%n)%p,error)
    if (error) return
    opt  => cubetools_primitive_opt_ptr(comm%opt%list(comm%opt%n)%p,error)
    if (error) return
    iarg = opt%arg%n
    !
    ! Sanity: compare with previous registered argument
    if (iarg.gt.0) then
      parg => cubetools_primitive_arg_ptr(opt%arg%list(iarg)%p,error)
      if (error) return
      if (parg%mandatory.ne.code_arg_mandatory .and. mandat.eq.code_arg_mandatory) then
        call cubesyntax_message(seve%e,rname,'A mandatory argument can not follow an optional one')
        error = .true.
        return
      endif
    endif
    !
    ! Now insert new argument in option structure
    select case (mandat)
    case (code_arg_mandatory)
      opt%nargmin = opt%nargmin+1
      opt%nargmax = opt%nargmax+1
    case (code_arg_optional)
      if (opt%nargmax.ne.narginfinite)  opt%nargmax = opt%nargmax+1
    case (code_arg_unlimited)
      opt%nargmax = narginfinite
    end select
    !
    call opt%arg%allocate(template,lot,error)
    if (error)  return
    parg => cubetools_primitive_arg_ptr(lot,error)
    if (error) return
    iarg = opt%arg%n
    call parg%put(iarg,name,abstract,help,mandat,error)
    if (error) return
  end subroutine cubetools_register_primitive_arg
  !
  subroutine cubetools_register_primitive_prod(template,name,abstract,help,  &
    pprod,error)
    !----------------------------------------------------------------------
    ! Register any product of class primitive_prod_t in the global 'pack'
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(in)    :: template
    character(len=*),        intent(in)    :: name
    character(len=*),        intent(in)    :: abstract
    character(len=*),        intent(in)    :: help
    class(primitive_prod_t), pointer       :: pprod  ! Return pointer to actual product
    logical,                 intent(inout) :: error
    !
    type(language_t), pointer :: lang
    type(command_t), pointer :: comm
    class(list_object_t), pointer :: lot
    integer(kind=prod_k) :: iprod
    integer(kind=4), parameter :: narginfinite=huge(1_4)
    character(len=*), parameter :: rname='REGISTER>PRODUCT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    pprod => null()
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    comm => cubetools_command_ptr(lang%comm%list(lang%comm%n)%p,error)
    if (error) return
    iprod = comm%prod%n
    !
    call comm%prod%allocate(template,lot,error)
    if (error) return
    pprod => cubetools_primitive_prod_ptr(lot,error)
    if (error) return
    iprod = comm%prod%n
    call pprod%put(iprod,name,abstract,help,error)
    if (error) return
  end subroutine cubetools_register_primitive_prod
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_get_command_id(ilang,commname,commid,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=lang_k), intent(in)    :: ilang
    character(len=*),     intent(in)    :: commname
    integer(kind=comm_k), intent(out)   :: commid
    logical,              intent(inout) :: error
    !
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='GET>COMMAND>ID'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (ilang.gt.pack%lang%n .or. ilang.le.0) then
       call cubesyntax_message(seve%e,rname,'Unknown language ID')
       error = .true.
       return
    endif
    !
    lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
    if (error) return
    call lang%get_command_id(commname,commid,error)
    if (error) return
  end subroutine cubetools_get_command_id
  !
  subroutine cubetools_execute_command(line,ilang,comm,error)
    use cubetools_cmessaging
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    integer(kind=lang_k), intent(in)    :: ilang
    character(len=*),     intent(in)    :: comm
    logical,              intent(inout) :: error
    !
    integer(kind=comm_k) :: icomm
    type(language_t), pointer :: plang
    type(command_t), pointer :: pcomm
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_get_command_id(ilang,comm,icomm,error)
    if (error) return
    call cubesyntax_message(seve%c,rname,line)
    plang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
    if (error) return
    pcomm => cubetools_command_ptr(plang%comm%list(icomm)%p,error)
    if (error) return
    call cubetools_cmessaging_command(pcomm%name,error)
    if (error) return
    call pcomm%check(plang%name,line,error)
    if (error) return
    call pcomm%run(line,error)
    if (error) return
    call cubetools_cmessaging_nocommand(error)
    if (error) return
  end subroutine cubetools_execute_command
  !
  subroutine cubetools_show_command(lang,comm,error)
    use gkernel_interfaces
    use sic_def
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: lang
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    integer(kind=comm_k) :: ilang
    integer(kind=comm_k) :: icomm
    type(language_t), pointer :: plang
    type(command_t), pointer :: pcomm
    character(len=12) :: solved
    character(len=12), allocatable :: cnames(:)
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='SHOW>COMMAND'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%get_language_id(lang,ilang,error)
    if (error) return
    plang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
    if (error) return
    allocate(cnames(plang%comm%n),stat=ier)
    if (failed_allocate(rname,'cnames',ier,error)) return
    do icomm=1,plang%comm%n
      pcomm => cubetools_command_ptr(plang%comm%list(icomm)%p,error)
      if (error) return
      cnames(icomm) = pcomm%name
    enddo
    call cubetools_disambiguate_strict(comm,cnames,icomm,solved,error)
    if (error) return
    pcomm => cubetools_command_ptr(plang%comm%list(icomm)%p,error)
    if (error) return
    !
    call pcomm%show_minimum(lang,error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    call cubesyntax_message(syntaxseve%help,rname,'For a more complete help please type:')
    call cubesyntax_message(syntaxseve%help,rname,trim(lang)//backslash//trim(solved)//' ?')
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_show_command
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_present(line,iopt,iarg,present,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    integer(kind=opti_k), intent(in)    :: iopt
    integer(kind=argu_k), intent(in)    :: iarg
    logical,              intent(out)   :: present
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: narg
    character(len=argu_l) :: arg
    character(len=*), parameter :: rname='CUBETOOLS>PRESENT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (iarg.eq.0) then
       present = sic_present(iopt,iarg)
    else if (iarg.gt.0) then
       call sic_ch(line,iopt,iarg,arg,narg,mandatory,error)
       if (error) return
       if (arg.eq.strg_quest) then
          call cubesyntax_message(seve%r,rname,'Clever help')
          present = .false.
          error = .true.
          return
       else
          present = sic_present(iopt,iarg)
       endif
    else
       call cubesyntax_message(seve%r,rname,'Argument number must >= 0')
        present = .false.
        error = .true.
        return
    endif
  end subroutine cubetools_present
  !
  subroutine cubetools_getarg_i4(line,opt,iarg,value,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    integer(kind=4),        intent(inout) :: value
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>ARG>I4'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_i4(line,opt%inum,iarg,value,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_i4
  !
  subroutine cubetools_getarg_i8(line,opt,iarg,value,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    integer(kind=8),        intent(inout) :: value
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>ARG>I8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_i8(line,opt%inum,iarg,value,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_i8
  !
  subroutine cubetools_getarg_r4(line,opt,iarg,value,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    real(kind=4),           intent(inout) :: value
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>ARG>R4'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_r4(line,opt%inum,iarg,value,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_r4
  !
  subroutine cubetools_getarg_r8(line,opt,iarg,value,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    real(kind=8),           intent(inout) :: value
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>ARG>R8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_r8(line,opt%inum,iarg,value,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_r8
  !
  subroutine cubetools_getarg_st(line,opt,iarg,string,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    character(len=*),       intent(inout) :: string
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: narg
    character(len=*), parameter :: rname='GET>ARG>R8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_ch(line,opt%inum,iarg,string,narg,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_st
  !
  function cubetools_nopt()
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=opti_k) :: cubetools_nopt
    !
    cubetools_nopt = sic_nopt()
  end function cubetools_nopt
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_list_package_languages(error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='LIST>PACKAGE>LANGUAGES'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%list(error)
    if (error) return
  end subroutine cubetools_list_package_languages
  !
  subroutine cubetools_list_language_commands(ilang,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=lang_k), intent(in)    :: ilang
    logical,              intent(inout) :: error
    !
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='LIST>LANGUAGE>COMMANDS'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (ilang.gt.pack%lang%n .or. ilang.le.0) then
       call cubesyntax_message(seve%e,rname,'Unknown language ID')
       error = .true.
       return
    endif
    !
    lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
    if (error) return
    call lang%list(error)
    if (error) return
  end subroutine cubetools_list_language_commands
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_register_dict(error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='REGISTER>DICT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    call lang%build_dict(error)
    if (error) return
  end subroutine cubetools_register_dict
  !
  function cubetools_pack_has_language(lang)
    !-------------------------------------------------------------------
    ! Return .true. if package provides the named language
    !-------------------------------------------------------------------
    logical :: cubetools_pack_has_language
    character(len=*), intent(in) :: lang
    !
    type(language_t), pointer :: plang
    integer(kind=4) :: ilang
    logical :: error
    !
    cubetools_pack_has_language = .false.
    error = .false.
    do ilang=1,pack%lang%n
      plang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
      if (error) return
      if (plang%name.eq.lang) then
        cubetools_pack_has_language = .true.
        return
      endif
    enddo
    !
  end function cubetools_pack_has_language
  !
  subroutine cubetools_structure_help_iterate(forma,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: forma
    logical,              intent(inout) :: error
    !
    call pack%help_iterate(forma,error)
    if (error) return
  end subroutine cubetools_structure_help_iterate
  !
end module cubetools_structure_main
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_fill
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  use cubetopology_sperange_types
  use cubetopology_sparange_types
  use cubetopology_spapos_types
  use cubetopology_spasize_types
  !
  public :: fill
  private
  !
  !***JP: We probably should replace range,center,size with a cube region
  type :: fill_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(sperange_opt_t)        :: range
     type(spapos_comm_t)         :: center
     type(spasize_opt_t)         :: size
     type(cube_prod_t),  pointer :: filled
   contains
     procedure, public  :: register => cubemain_fill_register
     procedure, private :: parse    => cubemain_fill_parse
     procedure, private :: main     => cubemain_fill_main
  end type fill_comm_t
  type(fill_comm_t) :: fill
  !
  type fill_user_t
     type(cubeid_user_t)  :: cubeids
     type(sperange_user_t):: range   ! Spectral range to be filled
     type(spapos_user_t)  :: center  ! Center of the region to be filled
     type(spasize_user_t) :: size    ! Size of the region to be filled
   contains
     procedure, private :: toprog => cubemain_fill_user_toprog
  end type fill_user_t
  !
  type fill_prog_t
     type(cube_t), pointer :: cube
     type(cube_t), pointer :: filled
     type(sperange_user_t) :: sperange
     integer(kind=indx_k)  :: imin(3)
     integer(kind=indx_k)  :: imax(3)
   contains
     procedure, private :: header => cubemain_fill_prog_header
     procedure, private :: data   => cubemain_fill_prog_data     
     procedure, private :: loop   => cubemain_fill_prog_loop
     procedure, private :: act    => cubemain_fill_prog_act
  end type fill_prog_t
  !
contains
  !
  subroutine cubemain_fill_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(fill_user_t) :: user
    character(len=*), parameter :: rname='FILL>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    call fill%parse(line,user,error)
    if (error) return
    call fill%main(user,error)
    if (error) return
  end subroutine cubemain_fill_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_fill_register(fill,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fill_comm_t), intent(inout) :: fill
    logical,            intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    !
    character(len=*), parameter :: rname='FILL>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'FILL','[cubeid]',&
         'Fill a subcube',&
         'FILL writes NaN values in a selected cube subregion.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /RANGE selects the spectral interval to fill.'//strg_cr//&
         '- /CENTER and /SIZE select a spatial region; /SIZE is mandatory when&
         & /CENTER is provided.'//strg_cr//&
         '- Without options, FILL stops with an error.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> FILL 12co10:cube /RANGE -3 5 km/s'//strg_cr//&
         'CUBE> FILL 12co10:cube /CENTER 0 0 relative /SIZE 30 30 arcsec'//strg_cr//&
         'CUBE> FILL 12co10:cube /RANGE 10 20 /CENTER 12 8 pixel /SIZE 6 6',&
         cubemain_fill_command,&
         fill%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Input cube identifier',&
         'If omitted, use the last matching cube (cube flag) in the default&
         & index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_subset,&
         fill%cube,&
         error)
    if (error) return
    call fill%range%register('RANGE',&
         'Spectral range to be filled',&
         error)
    if (error) return
    call fill%center%register('CENTER',&
         'Spatial center of the filled region',&
         error)
    if (error) return
    call fill%size%register(&
         'Spatial size of the filled region',&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'FILLED',&
         'Filled cube',&
         strg_emp,&
         [flag_fill,flag_cube],&
         fill%filled,&
         error)
    if (error) return
  end subroutine cubemain_fill_register
  !
  subroutine cubemain_fill_parse(fill,line,user,error)
    !----------------------------------------------------------------------
    ! FILL [cubeid]
    ! /RANGE first last [unit]
    ! /CENTER xpos ypos type [unit]
    ! /SIZE sx [sy [unit]]
    !----------------------------------------------------------------------
    class(fill_comm_t), intent(in)    :: fill
    character(len=*),   intent(in)    :: line
    type(fill_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FILL>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,fill%comm,user%cubeids,error)
    if (error) return
    call fill%range%parse(line,user%range,error)
    if (error) return
    call fill%center%parse(line,user%center,error)
    if (error) return
    call fill%size%parse(line,user%size,error)
    if (error) return
    if (user%center%present.and..not.user%size%do) then
       call cubemain_message(seve%e,rname,'A size must be specified when giving a new center')
       error = .true.
       return
    endif
    !
    ! *** JP: Is this an error?
    if (cubetools_nopt().eq.0) then
       call cubemain_message(seve%e,rname,'No options given, nothing to do')
       error = .true.
       return
    endif
  end subroutine cubemain_fill_parse
  !
  subroutine cubemain_fill_main(fill,user,error)
    use cubeadm_timing
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fill_comm_t), intent(in)    :: fill
    type(fill_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(fill_prog_t) :: prog
    character(len=*), parameter :: rname='FILL>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%header(fill,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_fill_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_fill_user_toprog(user,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fill_user_t), intent(in)    :: user
    type(fill_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    integer(kind=chan_k) :: stride
    integer(kind=ndim_k)  :: jx,jy,jc
    real(kind=coor_k) :: offset(2)
    type(sperange_prog_t) :: crange
    type(sparange_prog_t) :: lrange,mrange
    type(spapos_prog_t) :: center
    integer(kind=ndim_k), parameter :: ix=1,iy=2
    character(len=*), parameter :: rname='FILL>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(fill%cube,user%cubeids,prog%cube,error)
    if (error) return
    !
    select case (prog%cube%order())
    case (code_cube_imaset)
       jx = 1
       jy = 2
       jc = 3
    case (code_cube_speset)
       jx = 2
       jy = 3
       jc = 1
    case default
       call cubemain_message(seve%e,rname,'Order not supported')
       error = .true.
       return
    end select
    !
    call user%center%toprog(prog%cube,center,error)
    if (error) return
    call center%offset(offset,error)
    if (error) return
    call lrange%fromuser(code_sparange_truncated,prog%cube%head%set%il,prog%cube,offset(ix),&
         user%size%x,user%size%unit,prog%cube%head%spa%l%inc,&
         prog%cube%head%spa%l%kind,error)
    if (error) return
    call lrange%to_pixe_k(prog%imin(jx),prog%imax(jx),stride,error)
    if (error) return
    call mrange%fromuser(code_sparange_truncated,prog%cube%head%set%im,prog%cube,offset(iy),&
         user%size%y,user%size%unit,prog%cube%head%spa%m%inc,&
         prog%cube%head%spa%m%kind,error)
    if (error) return
    call mrange%to_pixe_k(prog%imin(jy),prog%imax(jy),stride,error)
    if (error) return
    !
    call user%range%toprog(prog%cube,code_sperange_truncated,crange,error)
    if (error) return
    call crange%to_chan_k(prog%imin(jc),prog%imax(jc),stride,error)
    if (error) return
  end subroutine cubemain_fill_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_fill_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fill_prog_t), intent(inout) :: prog
    type(fill_comm_t),  intent(in)    :: comm
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FILL>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%filled,prog%cube,prog%filled,error)
    if (error) return
  end subroutine cubemain_fill_prog_header
  !
  subroutine cubemain_fill_prog_data(prog,error)
    use cubeadm_opened
    use cubetools_header_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fill_prog_t), intent(inout) :: prog
    logical,            intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: itertask
    character(len=*), parameter :: rname='FILL>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(itertask,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(itertask)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(itertask,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(itertask)
       if (.not.error) then
          call prog%loop(itertask,error)
       endif
       !$OMP END TASK
    enddo ! itertask
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_fill_prog_data
  !
  subroutine cubemain_fill_prog_loop(prog,itertask,error)
    use cubeadm_taskloop
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(fill_prog_t),       intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='FILL>PROG>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    do while (itertask%iterate_entry(error))
      call prog%act(itertask,error)
      if (error) return
    enddo  ! ientry
  end subroutine cubemain_fill_prog_loop
  !
  subroutine cubemain_fill_prog_act(prog,iter,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !-------------------------------------------------------------------
    ! Fill one subcube
    !-------------------------------------------------------------------
    class(fill_prog_t),       intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: iter
    logical,                  intent(inout) :: error
    !
    logical :: zfill,yzfill,xyzfill
    type(subcube_t) :: in,ou
    integer(kind=indx_k) :: ix,iy,iz,jz
    character(len=*), parameter :: rname='FILL>PROG>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call in%associate('in',prog%cube,iter,error)
    if (error) return
    call ou%allocate('ou',prog%filled,iter,error)
    if (error) return
    !
    call in%get(error)
    if (error) return
    do iz=1,in%nz
       jz = in%range3(1)+iz-1
       zfill = (prog%imin(3).le.jz).and.(jz.le.prog%imax(3))
       do iy=1,in%ny
          yzfill = zfill.and.(prog%imin(2).le.iy).and.(iy.le.prog%imax(2))
          do ix=1,in%nx
             xyzfill = yzfill.and.(prog%imin(1).le.ix).and.(ix.le.prog%imax(1))
             if (xyzfill) then
                ou%val(ix,iy,iz) = gr4nan
             else
                ou%val(ix,iy,iz) = in%val(ix,iy,iz)
             endif
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call ou%put(error)
    if (error) return
  end subroutine cubemain_fill_prog_act
end module cubemain_fill
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_window
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  use cubemain_windowing
  use cubemain_range
  !
  public :: window
  private
  !
  type :: window_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(option_t),     pointer :: niter
     type(range_opt_t)           :: range
     type(cube_prod_t),  pointer :: wlocal
   contains
     procedure, public  :: register => cubemain_window_register
     procedure, private :: parse    => cubemain_window_parse
     procedure, private :: main     => cubemain_window_main
  end type window_comm_t
  type(window_comm_t) :: window
  !
  type window_user_t
     type(cubeid_user_t)   :: cubeids
     character(len=argu_l) :: niter             ! Number of iterations
     type(range_array_t)   :: range             ! Spectral range to be used
     logical               :: dorange = .false. ! do a range
   contains
     procedure, private :: toprog => cubemain_window_user_toprog
  end type window_user_t
  !
  type window_prog_t
     integer(kind=wind_k)  :: niter = 1  ! Number of iterations
     type(window_array_t)  :: wglobal    ! Initial window guess for all spectra
     type(cube_t), pointer :: cube       ! Input cube
     type(cube_t), pointer :: wlocal     ! Output window per spectrum
   contains
     procedure, private :: header => cubemain_window_prog_header
     procedure, private :: data   => cubemain_window_prog_data
     procedure, private :: loop   => cubemain_window_prog_loop
     procedure, private :: act    => cubemain_window_prog_act
  end type window_prog_t
  !
contains
  !
  subroutine cubemain_window_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(window_user_t) :: user
    type(window_prog_t) :: prog
    character(len=*), parameter :: rname='WINDOW>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call window%parse(line,user,error)
    if (error) return
    call window%main(user,prog,error)
    if (error) continue
  end subroutine cubemain_window_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_window_register(window,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(window_comm_t), intent(inout) :: window
    logical,              intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='WINDOW>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'WINDOW','[signalid]',&
         'Find the signal windows of each spectrum of a cube',&
         'WINDOW finds signal windows for each spectrum in a cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- A window is a contiguous channel interval that reaches the&
         & zero level from the spectrum maximum.'//strg_cr//&
         '- /RANGE constrains where windows are searched in each&
         & spectrum.'//strg_cr//&
         '- /NITER controls how many windows are found per input&
         & global range.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> WINDOW mycube /RANGE -20 20 km/s'//strg_cr//&
         'CUBE> WINDOW mycube /RANGE -20 20 km/s /NITER 2.',&
         cubemain_window_command,&
         window%comm,error)
    if (error) return
    call cubearg%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         window%cube,&
         error)
    if (error) return
    !
    call window%range%register(&
         'RANGE',&
         'Define the velocity range(s) containing signal',&
         range_is_multiple,error)
    if (error) return
    !
    call cubetools_register_option(&
         'NITER','number',&
         'Set the number of windows to be found',&
         strg_emp,&
         window%niter,error)
    if (error) return
    call stdarg%register(&
         'niter',&
         'Number of windows',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'WINDOW',&
         'Cube of windows',&
         strg_emp,&
         [flag_window],&
         window%wlocal,&
         error)
    if (error) return
  end subroutine cubemain_window_register
  !
  subroutine cubemain_window_parse(window,line,user,error)
    !----------------------------------------------------------------------
    ! WINDOW [cubeid]
    ! /RANGE v11 v12 [... [vn1 vn2]] [unit]
    ! /NITER niter
    !----------------------------------------------------------------------
    class(window_comm_t), intent(inout) :: window
    character(len=*),     intent(in)    :: line
    type(window_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='WINDOW>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,window%comm,user%cubeids,error)
    if (error) return
    call window%range%parse(line,user%dorange,user%range,error)
    if (error) return
    call cubemain_window_parse_nwind(line,window%niter,user%niter,error)
    if (error) return
  end subroutine cubemain_window_parse
  !
  subroutine cubemain_window_parse_nwind(line,opt,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    type(option_t),   intent(in)    :: opt
    character(len=*), intent(out)   :: user
    logical,          intent(inout) :: error
    !
    logical :: present
    integer(kind=4), parameter :: iarg=1
    character(len=*), parameter :: rname='WINDOW>PARSE>NWIND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call opt%present(line,present,error)
    if (error) return
    if (present) then
       call cubetools_getarg(line,opt,iarg,user,mandatory,error)
       if (error) return
    else
       user = strg_star
    endif
  end subroutine cubemain_window_parse_nwind
  !
  subroutine cubemain_window_main(comm,user,prog,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(window_comm_t), intent(in)    :: comm
    type(window_user_t),  intent(inout) :: user
    type(window_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='WINDOW>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_window_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_window_user_toprog(user,prog,error)
    use cubetools_user2prog
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(window_user_t), intent(inout) :: user
    type(window_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    integer(kind=wind_k) :: default
    character(len=*), parameter :: rname='WINDOW>USER>TOPROG'
    !    
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(window%cube,user%cubeids,&
         prog%cube,error)
    if (error) return
    call window%range%user2prog(prog%cube,user%range,prog%wglobal,error)
    if (error) return
    default = 1
    call cubetools_user2prog_resolve_star(user%niter,default,prog%niter,error)
    if (error) return
  end subroutine cubemain_window_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_window_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(window_prog_t), intent(inout) :: prog
    type(window_comm_t),  intent(in)    :: comm
    logical,              intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='WINDOW>PROG>HEADER'
    !    
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%wlocal,prog%cube,prog%wlocal,error)
    if (error) return
    call cubetools_header_get_axis_head_c(prog%wlocal%head,axis,error)
    if (error) return
    axis%name = 'SpecWind'
    axis%n = 2*(prog%wglobal%n*prog%niter)
    axis%ref = 0d0
    axis%val = 0d0
    axis%inc = 1d0
    call cubetools_header_update_axset_c(axis,prog%wlocal%head,error)
    if (error) return
    call cubetools_header_put_nchan(axis%n,prog%wlocal%head,error)
    if (error) return
  end subroutine cubemain_window_prog_header
  !
  subroutine cubemain_window_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(window_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='WINDOW>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! ie
    !$OMP END SINGLE
    !$OMP END PARALLEL
    !
  end subroutine cubemain_window_prog_data
  
  subroutine cubemain_window_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(window_prog_t),     intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: spec,good,sorted,wlocal
    integer(kind=wind_k) :: iw
    integer(kind=chan_k) :: nchan
    character(len=*), parameter :: rname='WINDOW>PROG>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    nchan = 0
    do iw=1,prog%wglobal%n
       if (nchan.lt.prog%wglobal%val(iw)%nc) nchan = prog%wglobal%val(iw)%nc
    enddo
    call good%reallocate('good',nchan,iter,error)
    if (error) return
    call sorted%reallocate('sorted',nchan,iter,error)
    if (error) return
    call wlocal%reallocate('wlocal',prog%wlocal%head%arr%n%c,iter,error)
    if (error) return
    call spec%reallocate_and_init(prog%cube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,spec,good,sorted,wlocal,error)
      if (error) return
    enddo
  end subroutine cubemain_window_prog_loop
  !
  subroutine cubemain_window_prog_act(prog,ie,spec,good,sorted,wlocal,error)
    use cubetools_nan
    use cubemain_spectrum_real
    use cubemain_spectrum_blanking
    use cubemain_spectrum_moment_tool
    use cubemain_spectrum_operations
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(window_prog_t), intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(spectrum_t),     intent(inout) :: spec
    type(spectrum_t),     intent(inout) :: good
    type(spectrum_t),     intent(inout) :: sorted
    type(spectrum_t),     intent(inout) :: wlocal
    logical,              intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    integer(kind=wind_k) :: jw,iiter
    integer(kind=chan_k) :: first,last
    type(window_scalar_t) :: wfound
    type(spectrum_tpeak_t) :: tpeak
    type(spectrum_t) :: line
    character(len=*), parameter :: rname='WINDOW>PROG>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%get(prog%cube,ie,error)
    if (error) return
    jw = 1
    do iw=1,prog%wglobal%n
       if (prog%wglobal%val(iw)%nc.le.0) cycle
       first = prog%wglobal%val(iw)%o(1)
       last  = prog%wglobal%val(iw)%o(2)
       call line%point_to(spec,first,last,1.0,error)
       if (error) return
       do iiter=1,prog%niter
          call cubemain_spectrum_unblank(line,good,error)
          if (error) return
          if (good%n.gt.0) then
             call tpeak%compute(good,error)
             if (error) return
             call cubemain_spectrum_sort(tpeak%ic,good,sorted,error)
             if (error) return
             call cubemain_spectrum_wind(sorted,wfound,error)
             if (error) return
             wlocal%t(jw)   = sorted%v(wfound%o(1))
             wlocal%t(jw+1) = sorted%v(wfound%o(2))
             line%t(wfound%o(1)-first+1:wfound%o(2)-first+1) = gr4nan
             jw = jw+2
          else
             wlocal%t(jw:jw+1) = gr4nan
          endif
       enddo ! iiter
    enddo ! iw
    call wlocal%put(prog%wlocal,ie,error)
    if (error) return
  end subroutine cubemain_window_prog_act
end module cubemain_window
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
module gio_params
  use gildas_def
  !
  !--------------------------------------------------------------------
  ! GIO parameters for image I/O support
  !--------------------------------------------------------------------
  !
  integer(kind=4), parameter :: gdf_maxdims=7  ! Maximum number of dimensions.
  !
  ! These ones are returned as img%status by the GIO lbrary
  integer, parameter :: code_read_data     =-1
  integer, parameter :: code_read_header   =-2
  integer, parameter :: code_update_header =-3
  integer, parameter :: code_write_header  =-4
  integer, parameter :: code_write_data    =-5
  integer, parameter :: code_read_image    =-6
  integer, parameter :: code_free_image    =-7
  integer, parameter :: code_create_image  =-8
  ! Missng or extra Columns in "Tables"
  integer(kind=4), parameter :: code_gio_miscol=-9    ! Missing UV column
  integer(kind=4), parameter :: code_gio_extcol=-10   ! Extra UV column
  !
  !
  ! Do not change the order and value of these integers
  integer(kind=4), parameter :: code_gio_empty=0
  ! The EMPTY state is attributed to any non-associated image slot,
  ! as well as any non-associated memory slot.
  !
  integer(kind=4), parameter :: code_gio_reado=1
  ! The READO state is attributed to any Read-Only image slot whose memory is
  ! handled by the Image library, through SIC_GETVM.
  !
  integer(kind=4), parameter :: code_gio_full=2
  ! The FULL state is attributed to an image slot which still has
  ! usefull information, but is not associated to data memory.
  ! It is typically used to update an image header, for example.
  !
  integer(kind=4), parameter :: code_gio_write=3
  ! The WRITE state is attributed to any Read-Write image slot whose memory is
  ! handled by the Image library, through SIC_GETVM. It indicates that the
  ! output file must be updated when closed
  !
  integer(kind=4), parameter :: code_gio_dumpi=4
  ! The DUMPI state is temporarily attributed to a Read-Write image slot
  ! to force update of the output file. It avoids Closing and Re-opening
  ! the file, and thus saves some I/O. In practice, only used by
  ! CLASS SUB_GRID routine so far.
  !
  integer(kind=4), parameter :: code_gio_dumpe=5
  ! The DUMPE state is attributed to Read-Write image slot whose memory is
  ! not handled by the Image library, but associated to the slot through
  ! call to GDF_PUMS. It indicates the output file should be written, but the
  ! memory area preserved.
  !
  integer(kind=4), parameter :: code_gio_reade=6
  ! The READE state is attributed to Read-Only image slot whose memory is
  ! not handled by the Image library, but associated to the slot through
  ! call to GDF_DAMS. It indicates the memory area should be preserved.
  !
  !
  ! Kind of GDF: The following codes imply a minimum number of available
  ! information. There may be more
  !
  ! Normal data, i.e. IMAGE...
  integer(kind=4), parameter :: code_gdf_image = 0
  ! Old UV Data with wrong weight
  integer(kind=4), parameter :: code_gdf_uvold = 1
  ! UV Data in "visibility" order
  integer(kind=4), parameter :: code_gdf_uvt =  10
  ! The transposed way (channel order)...
  integer(kind=4), parameter :: code_gdf_tuv = -code_gdf_uvt
  ! A simple Table, with no information
  integer(kind=4), parameter :: code_gdf_table = 20
  ! Virtual Observatory (VO) Tables are ordered in the transposed way...
  integer(kind=4), parameter :: code_gdf_vo = -code_gdf_table
  ! A specific CLASS table (by symmetry with code_gdf_uvt)
  integer(kind=4), parameter :: code_gdf_xyt = 40
  ! A specific CLASS table (by symmetry with code_gdf_uvt)
  integer(kind=4), parameter :: code_gdf_txy = -code_gdf_xyt
  ! A spread sheet for the SIC Tabler...
  integer(kind=4), parameter :: code_gdf_sheet = 50
  !
  ! Polarimetry parameters
  integer(kind=4), parameter :: code_polar_h = 1
  integer(kind=4), parameter :: code_polar_v = 2
  integer(kind=4), parameter :: code_polar_x = 3
  integer(kind=4), parameter :: code_polar_y = 4
  integer(kind=4), parameter :: code_polar_r = 5
  integer(kind=4), parameter :: code_polar_l = 6
  integer(kind=4), parameter :: code_polar_d = 7
  integer(kind=4), parameter :: code_polar_s = 8
  character(len=1), parameter :: gio_polar_names(1:8) =  &
    (/ 'H','V','X','Y','R','L','D','S' /)
  !
  integer(kind=4), parameter :: code_stokes_none = 0
  integer(kind=4), parameter :: code_stokes_all  = 10  ! Not in data format
  integer(kind=4), parameter :: code_stokes_any  = 20  ! Not in data format
  integer(kind=4), parameter :: code_stokes_i  = 1
  integer(kind=4), parameter :: code_stokes_q  = 2
  integer(kind=4), parameter :: code_stokes_u  = 3
  integer(kind=4), parameter :: code_stokes_v  = 4
  integer(kind=4), parameter :: code_stokes_rr = -1
  integer(kind=4), parameter :: code_stokes_ll = -2
  integer(kind=4), parameter :: code_stokes_rl = -3
  integer(kind=4), parameter :: code_stokes_lr = -4
  integer(kind=4), parameter :: code_stokes_xx = -5
  integer(kind=4), parameter :: code_stokes_yy = -6
  integer(kind=4), parameter :: code_stokes_xy = -7
  integer(kind=4), parameter :: code_stokes_yx = -8
  integer(kind=4), parameter :: code_stokes_dd = -9
  integer(kind=4), parameter :: code_stokes_ss = -10
  integer(kind=4), parameter :: code_stokes_ds = -11
  integer(kind=4), parameter :: code_stokes_sd = -12
  integer(kind=4), parameter :: code_stokes_hh = -13
  integer(kind=4), parameter :: code_stokes_vv = -14
  integer(kind=4), parameter :: code_stokes_hv = -15
  integer(kind=4), parameter :: code_stokes_vh = -16
  character(len=4), parameter :: gio_stokes_names(-16:4) =  &
    (/ 'VH  ','HV  ','VV  ','HH  ',  &  ! -16 -13
       'SD  ','DS  ','SS  ','DD  ',  &  ! -12  -9
       'YX  ','XY  ','YY  ','XX  ',  &  !  -8  -5
       'LR  ','RL  ','LL  ','RR  ',  &  !  -4  -1
       'NONE',                       &  !   0
       'I   ','Q   ','U   ','V   ' /)   !   1   4
  !
  ! Channel / Stokes ordering Must be out of range of the Stokes values
  integer(kind=4), parameter :: code_stok_chan = 100  ! Stokes/Channel order
  integer(kind=4), parameter :: code_chan_stok = -100 ! Channel/Stokes order
  !
  ! Visibility atom description
  integer(kind=4), parameter :: code_atom_real = 1
  integer(kind=4), parameter :: code_atom_imag = 2
  integer(kind=4), parameter :: code_atom_weig = 3
  !
  ! Sorting order
  integer(kind=4), parameter :: code_sort_none     = 1
  integer(kind=4), parameter :: code_sort_timebase = 2
  integer(kind=4), parameter :: code_sort_minus_v  = 3
  !
  ! Column kind of the uv tables
  integer(kind=4), parameter :: code_type_r4 = 1 ! Real number
  integer(kind=4), parameter :: code_type_r8 = 2 ! Double precision number
  !
  integer(kind=4), parameter :: code_follow   = -1 ! Column is a follower of the previous one
  integer(kind=4), parameter :: code_uvt_u    =  1 ! u
  integer(kind=4), parameter :: code_uvt_v    =  2 ! v
  integer(kind=4), parameter :: code_uvt_w    =  3 ! w
  integer(kind=4), parameter :: code_uvt_date =  4 ! Date
  integer(kind=4), parameter :: code_uvt_time =  5 ! Time
  integer(kind=4), parameter :: code_uvt_anti =  6 ! Antenna i
  integer(kind=4), parameter :: code_uvt_antj =  7 ! Antenna j
  integer(kind=4), parameter :: code_uvt_scan =  8 ! Scan number
  integer(kind=4), parameter :: code_uvt_topo =  9 ! Topocentric to System Doppler effect
  integer(kind=4), parameter :: code_uvt_loff = 10 ! Phase center Offset
  integer(kind=4), parameter :: code_uvt_moff = 11 ! Phase center Offset
  integer(kind=4), parameter :: code_uvt_xoff = 12 ! Pointing Offset
  integer(kind=4), parameter :: code_uvt_yoff = 13 ! Pointing Offset
  integer(kind=4), parameter :: code_uvt_stok = 14 ! Polarisation state
  integer(kind=4), parameter :: code_uvt_el   = 15 ! Elevation
  integer(kind=4), parameter :: code_uvt_ha   = 16 ! Hour angle
  integer(kind=4), parameter :: code_uvt_para = 17 ! Parallactic angle
  integer(kind=4), parameter :: code_uvt_int  = 18 ! Integration time
  integer(kind=4), parameter :: code_uvt_weig = 19 ! Weight column for SD
  integer(kind=4), parameter :: code_uvt_xofi = 20 ! Pointing error Ant I
  integer(kind=4), parameter :: code_uvt_yofi = 21 ! Pointing error Ant I
  integer(kind=4), parameter :: code_uvt_xofj = 22 ! Pointing error Ant J
  integer(kind=4), parameter :: code_uvt_yofj = 23 ! Pointing error Ant J
  integer(kind=4), parameter :: code_uvt_ra   = 24 ! RA of reference
  integer(kind=4), parameter :: code_uvt_dec  = 25 ! DEC of reference
  integer(kind=4), parameter :: code_uvt_if   = 26 ! VLA IF identification
  integer(kind=4), parameter :: code_uvt_tele = 27 ! Telescope pair ID
  integer(kind=4), parameter :: code_uvt_id   = 28 ! Any counter (e.g. source ID from UVFITS)
  integer(kind=4), parameter :: code_uvt_freq = 29 ! Frequency offset from Reference frequency
  integer(kind=4), parameter :: code_uvt_last = 29 ! Last uvt code
  ! currently up to code_uvt_last = 29 can fit in a single block
  !
  character(len=12), parameter :: gio_column_names(code_uvt_last) = (/  &
    'U           ','V           ','W           ','DATE        ',  &  !  1- 4
    'TIME        ','IANT        ','JANT        ','SCAN        ',  &  !  5- 8
    'DOPPLER     ','L_PHASE_OFF ','M_PHASE_OFF ','X_POINT_OFF ',  &  !  9-12
    'Y_POINT_OFF ','STOKES      ','ELEVATION   ','HOUR_ANGLE  ',  &  ! 13-16
    'PARA_ANGLE  ','ON_TIME     ','WEIGHT      ','X_POINT_IANT',  &  ! 17-20
    'Y_POINT_IANT','X_POINT_JANT','Y_POINT_JANT','RA          ',  &  ! 21-24
    'DEC         ','CASA_IF     ','TELESCOPE   ','SOURCE_ID   ',  &  ! 25-28
    'FREQUENCY   '  /)  ! 29
  !
  integer(kind=4), parameter :: gio_block1 = 16  ! Blocking factor for "big" blocks
  integer(kind=4), parameter :: gio_block2 = 16  ! Super Blocking factor for "huge" blocks
end module gio_params
!
module gio_headers
  use gbl_format
  use gio_params
  use gbl_constant
  !
  integer(kind=4), parameter :: code_version_gdf_v10 = 10 !  1.0 in fact...
  integer(kind=4), parameter :: code_version_gdf_v20 = 20 !  2.0 in fact...
  integer(kind=4), parameter :: code_version_gdf_current = code_version_gdf_v20
  !
  ! An historic bug made this value equal to 20 in data files...
  integer(kind=4), parameter :: code_version_uvt_v20 = 20 !
  integer(kind=4), parameter :: code_version_uvt_freq = code_version_uvt_v20
  integer(kind=4), parameter :: code_version_uvt_v21 = 21 ! > previous value
  integer(kind=4), parameter :: code_version_uvt_dopp = code_version_uvt_v21
  integer(kind=4), parameter :: code_version_uvt_v22 = 22 ! > previous value
  integer(kind=4), parameter :: code_version_uvt_syst = code_version_uvt_v22
  integer(kind=4), parameter :: code_version_uvt_default = code_version_uvt_syst
  !
  integer(kind=4), parameter :: gdf_startdim = 17  ! Must be odd and > 12.
  !  17 is the maximum allowed to hold 8 dimensions in the first block
  !  Increasing this number and/or the number of dimensions beyond these
  !  values would require re-coding in the gio library..
  !
  ! First header block
  integer(kind=4) , parameter :: def_dim_words   = 2*gdf_maxdims+2  ! Dimension section length
  integer(kind=4) , parameter :: def_blan_words = 2    ! Blanking section length
  integer(kind=4) , parameter :: def_extr_words = 6    ! Extrema section length
  integer(kind=4) , parameter :: def_coor_words  = 6*gdf_maxdims     ! at s_coor  Section length
  integer(kind=4) , parameter :: def_desc_words  = 3*(gdf_maxdims+1) ! at s_desc, Description section length
  !
  ! Second header block
  ! Padding must NOT be included in the section length, as the actual section length is
  ! written to the data, so only available information should be written
  !
  integer(kind=4) , parameter :: def_posi_words = 15   ! Position section length 15 used 1 padding
  integer(kind=4) , parameter :: def_proj_words = 9    ! Projection section length 9 used 1 padding
  integer(kind=4) , parameter :: def_spec_words = 14   ! Spectroscopy section length 14 used
  integer(kind=4) , parameter :: def_reso_words = 3    ! Resolution section length 3 used 1 padding
  integer(kind=4) , parameter :: def_nois_words = 2    ! Noise section length
  integer(kind=4) , parameter :: def_astr_words = 3    ! Proper motion section length 3 used 1 padding
  integer(kind=4) , parameter :: def_uvda_words = 18+2*code_uvt_last ! UV data section
  ! currently up to 25 code_uvt_... can fit in a single block
  integer(kind=4) , parameter :: def_tele_words = 8    ! Telescope section length
  !
  ! Just as a convenience for tests...
  integer(kind=4) , parameter :: second_words = def_posi_words+2 + def_proj_words+2 + &
    &   def_reso_words+2 + def_nois_words+2 + def_astr_words+2
  !
  ! /XIPAR/
  type :: location
    sequence
    integer(kind=address_length) :: addr = 0  ! Address of image
    integer(kind=size_length) :: size = 0     ! Size of image
    integer :: islo         = 0               ! Image Slot number
    integer :: mslo         = 0               ! Memory Slot number
    logical :: read         = .true.          ! ReadOnly status
    logical :: getvm        = .false.         ! Memory / File indicator
    integer(kind=size_length) :: al64 = 0     ! Padding required for alignment
  end type location
  !
  ! /XCPAR/
  type :: strings
    sequence
    character(len=12) :: type    = 'GILDAS_IMAGE'  !     Image Type (see ITYP)
    character(len=12) :: unit    = ' '             !     Data Units (see IUNI)
    character(len=12) :: code(gdf_maxdims) = ' '         ! 59  Axis codes (see ICOD)
    character(len=12) :: syst    = ' '             ! 71  Coordinate system (see ISYS)
    character(len=12) :: name    = ' '             ! 75  Source name (see ISOU)
    character(len=12) :: line    = ' '             !     Line name (see ILIN)
    !For Even GDF_MAXDIMS only ! character(len=4)  :: pad_char
  end type strings
  !
  type :: telesco
    sequence
     ! Then for each telescope
     real(kind=8) :: lon=0     ! Longitude (radians)
     real(kind=8) :: lat=0     ! Latitude  (radians)
     real(kind=4) :: alt=0     ! Altitude (m)
     real(kind=4) :: diam=0    ! Diameter
     character(len=12) :: ctele=' '  ! Telescope name
     integer(kind=4) :: pad    ! Padding for alignment
     !
  end type telesco
  !
  ! Version 1.0  OLD File Format
  !
  type :: gildas_header_v1
     sequence
     integer(kind=4) :: ijtyp(3) = 0       !  1  Image Type
     integer(kind=4) :: form    = fmt_r4   !  4  Data format (FMT_xx)
     integer(kind=4) :: ndb     = 0        !  5  Number of data blocks
     integer(kind=4) :: type_gdf = code_null  ! 6
     integer(kind=4) :: fill(4) = 0        !  7  Reserved space
     ! GENERAL SECTION
     integer(kind=4) :: gene    = 29       ! 11  General section length
     integer(kind=4) :: ndim    = 0        ! 12  Number of dimensions
     integer(kind=4) :: dim(4)  = 0        ! 13  Dimensions
     real(kind=8) :: ref1 = 1.d0           ! 17  Reference pixel
     real(kind=8) :: val1 = 1.d0           ! 19  Value at reference pixel
     real(kind=8) :: inc1 = 1.d0           ! 21  Increment per pixel
     real(kind=8) :: ref2 = 1.d0           ! 23  idem for axis 2
     real(kind=8) :: val2 = 1.d0           ! 25
     real(kind=8) :: inc2 = 1.d0           ! 27
     real(kind=8) :: ref3 = 1.d0           ! 29  idem for axis 3
     real(kind=8) :: val3 = 1.d0           ! 31
     real(kind=8) :: inc3 = 1.d0           ! 33
     real(kind=8) :: ref4 = 1.d0           ! 35  idem for axis 4
     real(kind=8) :: val4 = 1.d0           ! 37
     real(kind=8) :: inc4 = 1.d0           ! 39
     ! BLANKING
     integer(kind=4) :: blan = 2           ! 41  Blanking section length
     real(kind=4) :: bval = +1.23456e+34   ! 42  Blanking value
     real(kind=4) :: eval = -1.0           ! 43  Tolerance
     ! EXTREMA
     integer(kind=4) :: extr = 0           ! 44  Extrema section length
     real(kind=4) :: rmin    = 0.0         ! 45  Minimum
     real(kind=4) :: rmax    = 0.0         ! 46  Maximum
     integer(kind=4) :: min1 = 0           ! 47  Pixel of min on axis 1
     integer(kind=4) :: max1 = 0           ! 48  Pixel of max ......
     integer(kind=4) :: min2 = 0           ! 49  idem for axis 2
     integer(kind=4) :: max2 = 0           ! 50
     integer(kind=4) :: min3 = 0           ! 51           axis 3
     integer(kind=4) :: max3 = 0           ! 52
     integer(kind=4) :: min4 = 0           ! 53           axis 4
     integer(kind=4) :: max4 = 0           ! 54
     ! DESCRIPTION
     integer(kind=4) :: desc      = 18     ! 55  Description section length
     integer(kind=4) :: ijuni(3)   = 0     ! 56  Data Unit
     integer(kind=4) :: ijcod(3,4) = 0     ! 59  Axis names
     integer(kind=4) :: ijsys(3)   = 0     ! 71  Coordinate System
     integer(kind=4) :: dum1      = 0      ! Void for padding
     ! POSITION
     integer(kind=4) :: posi    = 12       ! 74  Position section length
     integer(kind=4) :: ijsou(3) = 0       ! 75  Source name
     real(kind=8) :: ra         = 0.d0     ! 78  Right Ascension
     real(kind=8) :: dec        = 0.d0     ! 80  Declination
     real(kind=8) :: lii        = 0.d0     ! 82  Galactic longitude
     real(kind=8) :: bii        = 0.d0     ! 84           latitude
     real(kind=4) :: epoc       = 0.0      ! 86  Epoch of coordinates
     integer(kind=4) :: dum2    = 0        ! Void for padding
     ! PROJECTION
     integer(kind=4) :: proj = 9           ! 87  Projection section length
     integer(kind=4) :: ptyp = p_none      ! 88  Projection type (see p_... codes)
     real(kind=8) :: a0      = 0.d0        ! 89  X of projection center
     real(kind=8) :: d0      = 0.d0        ! 91  Y of projection center
     real(kind=8) :: pang    = 0.d0        ! 93  Projection angle
     integer(kind=4) :: xaxi = 0           ! 95  X axis
     integer(kind=4) :: yaxi = 0           ! 96  Y axis
     ! SPECTROSCOPY
     integer(kind=4) :: spec    = 12       ! 97  Spectroscopy section length
     integer(kind=4) :: ijlin(3) = 0       ! 98  Line name
     real(kind=8) :: fres       = 0.d0     !101  Frequency resolution
     real(kind=8) :: fima       = 0.d0     !103  Image frequency
     real(kind=8) :: freq       = 0.d0     !105  Rest Frequency
     real(kind=4) :: vres       = 0.0      !107  Velocity resolution
     real(kind=4) :: voff       = 0.0      !108  Velocity offset
     integer(kind=4) :: faxi    = 0        !109  Frequency axis
     ! RESOLUTION
     integer(kind=4) :: reso = 0           !110  Resolution section length
     real(kind=4) :: majo    = 0.0         !111  Major axis
     real(kind=4) :: mino    = 0.0         !112  Minor axis
     real(kind=4) :: posa    = 0.0         !113  Position angle
     ! NOISE
     integer(kind=4) :: sigm = 0           ! 114 Noise section length
     real(kind=4) :: noise   = 0.0         ! 115 Theoretical noise
     real(kind=4) :: rms     = 0.0         ! 116 Actual noise
     ! ASTROMETRY
     integer(kind=4) :: prop  = 0          ! 117 Proper motion section length
     real(kind=4) :: mura     = 0.0        ! 118 along RA, in mas/yr
     real(kind=4) :: mudec    = 0.0        ! 119 along Dec, in mas/yr
     real(kind=4) :: parallax = 0.0        ! 120 in mas
     ! real(kind=4) :: pepoch   = 2000.0     ! 121 in yrs ?
     !
     ! These are not in data, but useful for further reference
     ! For UV Data
     integer(kind=4) :: nchan = 0
     integer(kind=4) :: nvisi = 0
     integer(kind=4) :: nstokes = 1
     integer(kind=4) :: natom = 3
     real(kind=4)    :: basemin = 0.
     real(kind=4)    :: basemax = 0.
  end type gildas_header_v1
  !
  ! NEW File Format
  !
  ! Notes:
  !  1) Total array size will always be stored in INTEGER(8), even on 32-bit machines,
  !     as the mini and maxi indicators.
  !  2) Dimensions are Integer*8 in the data format
  !     Internally, Dimensions, blc, trc, will be typed INTEGER(index_length)
  ! with index_length=4 on 32-bit machines and 8 on 64 bit machines.
  !  3) Actual extrema location per dimension are derived from MINI and MAXI and
  ! the current dimensions. They can be available in the internal description,
  !     without being written on file.
  !
  type :: gildas_header_v2
     !
     ! Spread on two blocks
     !
     ! Block 1: Basic Header and Dimension information
     sequence
     !
     ! Trailer:
     integer(kind=4) :: ijtyp(3) = 0       !  1  Image Type
     integer(kind=4) :: form    = fmt_r4   !  4  Data format (FMT_xx)
     integer(kind=8) :: ndb     = 0        !  5  Number of blocks
     integer(kind=4) :: nhb     = 2        !  7  Number of header blocks
     integer(kind=4) :: ntb     = 0        !  8  Number of trailing blocks
     integer(kind=4) :: version_gdf = code_version_gdf_current !  9  Data format Version number
     integer(kind=4) :: type_gdf =  code_gdf_image  !  10 code_gdf_image or code_null
     integer(kind=4) :: dim_start = gdf_startdim    !  11  Start offset for DIMENSION, should be odd, >12
     integer(kind=4) :: pad_trail
     ! The maximum value would be 17 to hold up to 8 dimensions.
     !
     ! DIMENSION Section. Caution about alignment...
     integer(kind=4) :: dim_words   = 2*gdf_maxdims+2  ! at s_dim=17  Dimension section length
     integer(kind=4) :: blan_start !! = dim_start + dim_lenth + 2   ! 18  Pointer to next section
     integer(kind=4) :: mdim    = 4        !or > ! 19  Maximum number of dimensions in this data format
     integer(kind=4) :: ndim    = 0        ! 20  Number of dimensions
     integer(kind=index_length) :: dim(gdf_maxdims) = 0     ! 21  Dimensions
     !
     ! BLANKING
     integer(kind=4) :: blan_words = 2     ! Blanking section length
     integer(kind=4) :: extr_start         ! Pointer to next section
     real(kind=4) :: bval = +1.23456e+38   ! Blanking value
     real(kind=4) :: eval = -1.0           ! Tolerance
     !
     ! EXTREMA
     integer(kind=4) :: extr_words = 6    ! Extrema section length
     integer(kind=4) :: coor_start !! = extr_start + extr_words +2     !
     real(kind=4) :: rmin    = 0.0         ! Minimum
     real(kind=4) :: rmax    = 0.0         ! Maximum
     integer(kind=index_length) :: minloc(gdf_maxdims) = 0 ! Pixel of minimum
     integer(kind=index_length) :: maxloc(gdf_maxdims) = 0 ! Pixel of maximum
! in file:     integer(kind=8) :: mini = 0           ! Rank 1 pixel of minimum
! in file:     integer(kind=8) :: maxi = 0           ! Rank 1 pixel of maximum
     !
     ! COORDINATE Section
     integer(kind=4) :: coor_words  = 6*gdf_maxdims   ! at s_coor  Section length
     integer(kind=4) :: desc_start  !! = coord_start + coord_words +2     !
     real(kind=8)    :: convert(3,gdf_maxdims)   !  Ref, Val, Inc for each dimension
     !
     ! DESCRIPTION Section
     integer(kind=4) :: desc_words  = 3*(gdf_maxdims+1) ! at s_desc, Description section length
     integer(kind=4) :: null_start  !! = desc_start + desc_words +2     !
     integer(kind=4) :: ijuni(3)   = 0        ! Data Unit
     integer(kind=4) :: ijcod(3,gdf_maxdims) = 0    ! Axis names
     integer(kind=4) :: pad_desc              ! For Odd gdf_maxdims only
     !
     !
     ! The first block length is thus
     !  s_dim-1 + (2*mdim+4) + (4) + (8) +  (6*mdim+2) + (3*mdim+5)
     ! = s_dim-1 + mdim*(2+6+3) + (4+4+2+5+8)
     ! = s_dim-1 + 11*mdim + 23
     ! With mdim = 7, s_dim=11, this is 110 spaces
     ! With mdim = 8, s_dim=11, this is 121 spaces
     ! MDIM > 8 would NOT fit in one block...
     !
     ! Block 2: Ancillary information
     !
     ! The same logic of Length + Pointer is used there too, although the
     ! length are fixed. Note rounding to even number for the pointer offsets
     ! in order to preserve alignement...
     !
     integer(kind=4) :: posi_start  = 1
     !
     ! POSITION
     integer(kind=4) :: posi_words = 15    ! Position section length: 15 used + 1 padding
     integer(kind=4) :: proj_start         !! = s_posi + 16     ! Pointer to next section
     integer(kind=4) :: ijsou(3) = 0       ! 75  Source name
     integer(kind=4) :: ijsys(3) = 0       ! 71  Coordinate System (moved from Description section)
     real(kind=8) :: ra         = 0.d0     ! 78  Right Ascension
     real(kind=8) :: dec        = 0.d0     ! 80  Declination
     real(kind=8) :: lii        = 0.d0     ! 82  Galactic longitude
     real(kind=8) :: bii        = 0.d0     ! 84           latitude
     real(kind=4) :: epoc       = 0.0      ! 86  Epoch of coordinates
     real(kind=4) :: pad_posi
     !
     ! PROJECTION
     integer(kind=4) :: proj_words = 9     ! Projection length: 9 used + 1 padding
     integer(kind=4) :: spec_start !! = proj_start + 12
     real(kind=8) :: a0      = 0.d0        ! 89  X of projection center
     real(kind=8) :: d0      = 0.d0        ! 91  Y of projection center
     real(kind=8) :: pang    = 0.d0        ! 93  Projection angle
     integer(kind=4) :: ptyp = p_none      ! 88  Projection type (see p_... codes)
     integer(kind=4) :: xaxi = 0           ! 95  X axis
     integer(kind=4) :: yaxi = 0           ! 96  Y axis
     integer(kind=4) :: pad_proj
     !
     ! SPECTROSCOPY
     integer(kind=4) :: spec_words  = 14   ! Spectroscopy length: 14 used
     integer(kind=4) :: reso_start  !! = spec_words + 16
     real(kind=8) :: fres       = 0.d0     !101  Frequency resolution
     real(kind=8) :: fima       = 0.d0     !103  Image frequency
     real(kind=8) :: freq       = 0.d0     !105  Rest Frequency
     real(kind=4) :: vres       = 0.0      !107  Velocity resolution
     real(kind=4) :: voff       = 0.0      !108  Velocity offset
     real(kind=4) :: dopp       = -1.0     !     Doppler factor
     integer(kind=4) :: faxi    = 0        !109  Frequency axis
     integer(kind=4) :: ijlin(3) = 0       ! 98  Line name
     integer(kind=4) :: vtyp    = vel_unk  ! Velocity type (see vel_... codes)
     !
     ! RESOLUTION
     integer(kind=4) :: reso_words = 3     ! Resolution length: 3 used + 1 padding
     integer(kind=4) :: nois_start !! = reso_words + 6
     real(kind=4) :: majo    = 0.0         !111  Major axis
     real(kind=4) :: mino    = 0.0         !112  Minor axis
     real(kind=4) :: posa    = 0.0         !113  Position angle
     real(kind=4) :: pad_reso
     !
     ! NOISE
     integer(kind=4) :: nois_words = 2     ! Noise section length: 2 used
     integer(kind=4) :: astr_start !! = s_nois + 4
     real(kind=4) :: noise   = 0.0         ! 115 Theoretical noise
     real(kind=4) :: rms     = 0.0         ! 116 Actual noise
     !
     ! ASTROMETRY
     integer(kind=4) :: astr_words = 3    ! Proper motion section length: 3 used + 1 padding
     integer(kind=4) :: uvda_start !! = s_astr + 4
     real(kind=4) :: mura     = 0.0        ! 118 along RA, in mas/yr
     real(kind=4) :: mudec    = 0.0        ! 119 along Dec, in mas/yr
     real(kind=4) :: parallax = 0.0        ! 120 in mas
     real(kind=4) :: pad_astr
     ! real(kind=4) :: pepoch   = 2000.0     ! 121 in yrs ?
     !
     ! TELESCOPE information section, normally after the UV Data section
     integer(kind=4) :: tele_words  = 2    ! Length of section: 8 used
     integer(kind=4) :: void_start  !! = s_tele + l_tele + 2
     ! Added for UV version V2.2
     integer(kind=4) :: nteles = 0        ! Number of telescopes
     integer(kind=4) :: magic  = 1000     ! Magic offset to code telescope pairs
     !
     !
     ! UV_DATA information
     integer(kind=4) :: uvda_words  = 18+2*code_uvt_last ! Length of section: 14 used
     integer(kind=4) :: tele_start  !! = s_uvda + l_uvda + 2
     integer(kind=4) :: version_uv = code_version_uvt_default  ! 1 version number. Will allow us to change the data format
     integer(kind=4) :: nchan = 0         ! 2 Number of channels
     integer(kind=8) :: nvisi = 0         ! 3-4 Independent of the transposition status
     integer(kind=4) :: nstokes = 0       ! 5 Number of polarizations
     integer(kind=4) :: natom = 0         ! 6. 3 for real, imaginary, weight. 1 for real.
     real(kind=4)    :: basemin = 0.      ! 7 Minimum Baseline
     real(kind=4)    :: basemax = 0.      ! 8 Maximum Baseline
     integer(kind=4) :: fcol              ! 9 Column of first channel
     integer(kind=4) :: lcol              ! 10 Column of last  channel
     ! The number of information per channel can be obtained by
     !       (lcol-fcol+1)/(nchan*natom)
     ! so this could allow to derive the number of Stokes parameters
     ! Leading data at start of each visibility contains specific information
     integer(kind=4) :: nlead = 7           ! 11 Number of leading informations (at lest 7)
     ! Trailing data at end of each visibility may hold additional information
     integer(kind=4) :: ntrail = 0          ! 12 Number of trailing informations
     !
     ! Leading / Trailing information codes have been specified before
     integer(kind=4) :: column_pointer(code_uvt_last) = code_null ! Back pointer to the columns...
     integer(kind=4) :: column_size(code_uvt_last) = 0  ! Number of columns for each
     ! In the data, we instead have the codes for each column
     ! integer(kind=4) :: column_codes(nlead+ntrail)         ! Start column for each ...
     ! integer(kind=4) :: column_types(nlead+ntrail) /0,1,2/ ! Number of columns for each: 1 real*4, 2 real*8
     ! Leading / Trailing information codes
     !
     integer(kind=4) :: order = 0          ! 13  Stoke/Channel ordering
     integer(kind=4) :: nfreq = 0          ! 14  ! 0 or = nchan*nstokes
     integer(kind=4) :: atoms(4)           ! 15-18 Atom description
     !
     ! Then for each telescope
     !   real(kind=8) :: lon     ! Longitude (radians)
     !   real(kind=8) :: lat     ! Latitude  (radians)
     !   real(kind=4) :: alt     ! Altitude (m)
     !   real(kind=4) :: diam    ! Diameter
     !   integer(4)   :: ijtele(3)  ! Telescope name
     !   integer(4)   :: pad     ! Padding for alignment
     !
     type(telesco), allocatable :: teles(:)  !
     !
     real(kind=8), pointer :: freqs(:) => null()     ! (nchan*nstokes) = 0d0
     integer(kind=4), pointer :: stokes(:) => null() ! (nchan*nstokes) or (nstokes) = code_stoke
     !
     ! Only in code
     real(kind=8), pointer :: ref(:) => null()
     real(kind=8), pointer :: val(:) => null()
     real(kind=8), pointer :: inc(:) => null()
  end type gildas_header_v2
  !
  type :: gildas_v1
     sequence
     !
     character(len=256)   :: file = ' '  ! File name
     type (strings)       :: char        !
     type (location)      :: loca        !
     type (gildas_header_v1) :: gil      !
     integer(kind=index_length) :: blc(4) = 0  ! Bottom left corner
     integer(kind=index_length) :: trc(4) = 0  ! Top right corner
     integer(kind=4) :: version = 0      ! = %header 1 = Defined / 0 = Undefined
     integer(kind=4) :: status = 0       ! Last error code
  end type gildas_v1
  !
  type :: gildas_v2
     sequence
     type (gildas_header_v2) :: gil      !
     type (location)      :: loca        !
     type (strings)       :: char        !
     integer(kind=index_length) :: blc(gdf_maxdims) = 0   ! Bottom left corner
     integer(kind=index_length) :: trc(gdf_maxdims) = 0   ! Top right corner
     integer(kind=4) :: version = 0      ! 0 = Undefined / # 0 = Version number
     integer(kind=4) :: status = 0       ! Last error code
     character(len=filename_length) :: file = ' '  ! File name
  end type gildas_v2
  !
end module gio_headers
!
module image_def
  use gildas_def
  use gbl_format
  use gio_headers
  !
  !
  type :: gildas
    sequence
    character(len=256)   :: file = ' '  ! File name
    type (strings)       :: char        !
    type (location)      :: loca        !
    type (gildas_header_v2) :: gil      !
    integer(kind=index_length) :: blc(gdf_maxdims) = 0       ! Bottom left corner
    integer(kind=index_length) :: trc(gdf_maxdims) = 0       ! Top right corner
    integer(kind=4) :: header = 0       ! Defined / Undefined
    integer(kind=4) :: status = 0       ! Last error code
    real,         pointer :: r1d(:)       => null()  ! Pointer to 1D data
    real(kind=8), pointer :: d1d(:)       => null()
    integer,      pointer :: i1d(:)       => null()
    real,         pointer :: r2d(:,:)     => null()  ! Pointer to 2D data
    real(kind=8), pointer :: d2d(:,:)     => null()
    integer,      pointer :: i2d(:,:)     => null()
    real,         pointer :: r3d(:,:,:)   => null()  ! Pointer to 3D data
    real(kind=8), pointer :: d3d(:,:,:)   => null()
    integer,      pointer :: i3d(:,:,:)   => null()
    real,         pointer :: r4d(:,:,:,:) => null()  ! Pointer to 4D data
    real(kind=8), pointer :: d4d(:,:,:,:) => null()
    integer,      pointer :: i4d(:,:,:,:) => null()
  end type gildas
  !
end module image_def
!
function uv_column_name(code)
  use gio_params
  !---------------------------------------------------------------------
  ! @ public
  ! As it is not portable to share a character array between libraries,
  ! this function returns the UV column name given its code.
  !---------------------------------------------------------------------
  character(len=12) :: uv_column_name
  integer(kind=4), intent(in) :: code
  !
  if (code.le.0 .or. code.gt.code_uvt_last) then
    uv_column_name = 'Unknown'
  else
    ! UV column names must match UV column codes
    uv_column_name = gio_column_names(code)
  endif
  !
end function uv_column_name
!
subroutine uv_column_names(list)
  use gio_params
  !---------------------------------------------------------------------
  ! @ public
  ! As it is not portable to share a character array between libraries,
  ! this function returns the UV column name list.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: list(:)
  ! Local
  integer(kind=4) :: icol
  !
  do icol=1,min(size(list),code_uvt_last)  ! List may be truncated, that's a desired feature
    list(icol) = gio_column_names(icol)
  enddo
end subroutine uv_column_names
!
function gdf_polar_name(code)
  use gio_params
  !---------------------------------------------------------------------
  ! @ public
  ! Return the polarization name given its code
  !---------------------------------------------------------------------
  character(len=1) :: gdf_polar_name
  integer(kind=4), intent(in) :: code
  !
  if (code.ge.lbound(gio_polar_names,1) .and.  &
      code.le.ubound(gio_polar_names,1)) then
    gdf_polar_name = gio_polar_names(code)
  else
    gdf_polar_name = '?'
  endif
  !
end function gdf_polar_name
!
subroutine gdf_polar_code(name,code,error)
  use gio_params
  !---------------------------------------------------------------------
  ! @ public
  ! This function returns the polarization code given its name (must be
  ! upcased)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name
  integer(kind=4),  intent(out)   :: code
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: icode
  !
  do icode=lbound(gio_polar_names,1),ubound(gio_polar_names,1)
    if (name.eq.gio_polar_names(icode)) then
      code = icode
      return
    endif
  enddo
  !
  code = -1000
  error = .true.
  !
end subroutine gdf_polar_code
!
function gdf_stokes_name(code)
  use gio_params
  !---------------------------------------------------------------------
  ! @ public
  ! Return the Stokes name given its code
  !---------------------------------------------------------------------
  character(len=4) :: gdf_stokes_name
  integer(kind=4),  intent(in)    :: code
  !
  if (code.ge.lbound(gio_stokes_names,1) .and.  &
      code.le.ubound(gio_stokes_names,1)) then
    gdf_stokes_name = gio_stokes_names(code)
  else if (code.eq.code_stokes_all) then
    gdf_stokes_name = 'ALL'
  else if (code.eq.code_stokes_any) then
    gdf_stokes_name = 'ANY'
  else  
    gdf_stokes_name = 'UNKNOWN'
  endif
  !
end function gdf_stokes_name
!
subroutine gdf_stokes_code(name,code,error)
  use gio_params
  !---------------------------------------------------------------------
  ! @ public
  ! This function returns the Stokes code given its name (must be
  ! upcased)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name
  integer(kind=4),  intent(out)   :: code
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: icode
  !
  select case (name)
  case ('ALL')
    code = code_stokes_all
  case ('ANY')
    code = code_stokes_any
  case default
    do icode=lbound(gio_stokes_names,1),ubound(gio_stokes_names,1)
      if (name.eq.gio_stokes_names(icode)) then
        code = icode
        return
      endif
    enddo
    code = -1000
    error = .true.
  end select
  !
end subroutine gdf_stokes_code

subroutine mrtindex_copy_index(filename,optx,error)
  use gbl_message
  use classic_api
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_copy_index
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Copy the memory index into the disk index
  !---------------------------------------------------------------------
  character(len=*),        intent(in)    :: filename
  type(mrtindex_optimize_t), intent(in)    :: optx
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='MCOPY'
  character(len=filename_length) :: newfile
  integer(kind=entry_length) :: ient
  type(mrtindex_entry_t) :: entry
  type(classic_file_t) :: fileout
  integer(kind=4) :: oldnum,fileid,iid,nids,ids(ix_ndir)  ! Automatic
  logical :: oldopened
  !
  call sic_parse_file(filename,'','.mrt',newfile)
  !
  ! --- Sanity check: must not overwrite one of the input files! ---
  ! Build a list of input file ids to check (it may be a restricted
  ! list compared to the full IX).
  nids = 0
ENTRIES: do ient=1,optx%next-1
    fileid = optx%idir(ient)
    do iid=1,nids
      if (fileid.eq.ids(iid))  cycle ENTRIES
    enddo
    nids = nids+1
    ids(nids) = fileid
  enddo ENTRIES
  !
  ! Check that the MCOPY output file is not one of the inputs!
  do iid=1,nids
    if (ids(iid).eq.ix_opened) then
      ! This input file is the one in memory, just compare it with
      ! the new file we want to write
      inquire(file=newfile,opened=oldopened,number=oldnum)
      if (oldopened .and. oldnum.eq.ix_files(ix_opened)%lun) then
        call mrtindex_message(seve%e,rname,'Output file is one of the IX files')
        error = .true.
        return
      endif
    else
      ! This file is not opened: we should open it temporarily and
      ! compare it. Remember file names can not be compared correctly
      continue
    endif
  enddo
  !
  call mrtindex_file_classic_new(newfile,error)
  if (error)  return
  !
  ! Work on our custom 'fileout' instance, instead of the global
  ! 'ix_files', because
  !   1) we build a new file, it is certainly not already in the
  !      ix_files list,
  !   2) we want to leave it opened while we read the input file(s)
  !      (and not closing and reopening the input and output files
  !      for each entry)
  fileout%spec = newfile
  fileout%nspec = len_trim(newfile)
  if (sic_getlun(fileout%lun).ne.1) then
    error = .true.
    return
  endif
  call classic_file_open(fileout,.true.,error)
  if (error)  goto 100
  !
  call classic_filedesc_open(fileout,error)
  if (error)  goto 100
  !
  ! Reallocate the output buffers
  call reallocate_index_obuf(fileout,error)
  if (error)  return
  !
  do ient=1,optx%next-1
    call mrtindex_optimize_to_entry(optx,ient,entry,error)
    if (error)  exit
    !
    call mrtindex_entry_write(fileout,entry,error)
    if (error)  exit
    !
  enddo
  !
  ! Update the File Descriptor on disk (in particular desc%xnext)
  call classic_filedesc_write(fileout,error)
  if (error)  continue
  !
  call classic_file_close(fileout,error)
  if (error)  continue
  !
100 continue
  call sic_frelun(fileout%lun)
  !
  call mrtindex_entry_free(entry,error)
  if (error)  continue
  !
end subroutine mrtindex_copy_index

module mira_interfaces_none
  interface
       subroutine calibrate(line,error)
    !
    ! Called by subroutine RUN, command CALIBRATE [ifb|all].
    !
    ! Input:
    ! LINE (character) : command line
    !
    ! Output:
    ! ERROR (logical)  : error return flag
    ! Calibration parameters in structure GAINS(1:NFB)%TAUZEN etc. where
    ! NFB is the number of frontend/backend combinations.
    ! For details see See module mira in mira_use.f90 and the MIRA manual,
    ! section 5.
    !
       use mira
       use gildas_def
       use gkernel_types
       !
    end subroutine calibrate
  end interface
  !
  interface
    subroutine apply_tcal(ifb,jfb,changefebecal,nrecords,error)
    !
    ! Called by subroutine CALIBRATE. Applies the calibration temperature
    ! to the raw data (after division by the channel gains in APPLY_GAINS).
    ! A separate calibration temperature is applied to each spectral
    ! baseband or to each spectral channel (if calByChannel = .true.,
    ! interactively set by the user by "let calByChannel yes"). The logical
    ! SIC variable calByChannel is read by MIRA in subroutine getFits.
    !
    ! Input:
    ! IFB (integer)           : frontend-backend unit to be calibrated
    ! JFB (integer)           : frontend-backedn unit containing the
    !                           calibration parameters to be applied here.
    ! changeFebeCal (logical) :
    ! NRECORDS (integer)      : number of records in scan
    !
    ! Output:
    ! ERROR (logical)         : error return flag
    !
    ! Input/output:
    !
    ! ARRAY(1:NFB)%DATA(1:NBD)%DATA (double), where NFB is the number of
    ! frontend-backend combinations, and NBD is the number of spectral
    ! basebands. For details, see module mira in mira_use.f90 and the MIRA
    ! manual, section 5.
    !
    ! On successful execution, the logical flag
    ! REDUCE(IFB)%CALIBRATION_DONE(2) is set to .true. (IFB as on input).
    !
       use mira
       use gildas_def
       use chopper_def
       !
    end subroutine apply_tcal
  end interface
  !
  interface
    subroutine apply_tcal_fsw(ifb,jfb,changefebecal,nrecords,error)
    !
    ! Same as subroutine APPLY_TCAL but for calibrations done in switch mode
    ! frequency. The calibration parameters for the phase 1 (lower frequency)
    ! are in structure gains(1:nfb), those for phase 2 (upper frequency) are
    ! in gains(nfb+1:2*nfb), where nfb is the number of frontend-backend
    ! units.
    !
       use mira
       use gildas_def
       use chopper_def
       !
    end subroutine apply_tcal_fsw
  end interface
  !
  interface
    subroutine apply_gains(ifb,jfb,changefebecal,nrecords,error)
    !
    ! Called by subroutine CALIBRATE. Applies the channel gains
    ! in GAINS(JFB)%GAINARRAY (= count rate on hot load - count rate on sky)
    ! to the raw data in ARRAY(IFB)%DATA%DATA. The gainarray is allocated in
    ! subroutine getFits, and written in subroutine syncData or syncDataNew.
    !
    ! Input:
    ! IFB (integer)           : frontend-backend unit to be calibrated
    ! JFB (integer)           : frontend-backedn unit containing the
    !                           calibration parameters to be applied here.
    ! changeFebeCal (logical) :
    ! NRECORDS (integer)      : number of records in scan
    !
    ! Output:
    ! ERROR (logical)         : error return flag
    !
    ! Input/output:
    ! ARRAY(1:NFB)%DATA(1:NBD)%DATA (double), where NFB is the number of
    ! frontend-backend combinations, and NBD is the number of spectral
    ! basebands. For details, see module mira in mira_use.f90 and the MIRA
    ! manual, section 5.
    !
    ! On successful execution, the logical flag
    ! REDUCE(IFB)%CALIBRATION_DONE(1) is set to .true. (IFB as on input).
    !
       use mira
       use gildas_def
       !
    end subroutine apply_gains
  end interface
  !
  interface
    subroutine apply_gains_fsw(ifb,jfb,changefebecal,nrecords,error)
    !
    ! Same as subroutine APPLY_GAINS_FSW, but for the calibration taken
    ! in switch mode frequency (i.e. channel gains for frequency switching
    ! phase 1 are applied to the raw data of frequency switching phase 1,
    ! respectively the gains of phase 2 to the raw data of phase 2).
    !
       use mira
       use gildas_def
       !
    end subroutine apply_gains_fsw
  end interface
  !
  interface
    subroutine subtract_off(ifb,nrecords,wmode,window,nwin,   &
         mask,nmask,error)
    !
    ! Called by subroutine CALIBRATE. Performs the subtraction ON-OFF
    ! for multiple-phase data, and concatenates adjacent spectral basebands
    ! to a single output spectrum (to be written to the outputfile for
    ! CLASS).
    !
    ! Also called by subroutine SOLVE for uncalibrated pointings and for
    ! focus measurements.
    !
    ! Input:
    ! ifb           integer         number of frontend/backend unit
    ! nrecords      integer         number of backend data records
    ! wmode         character       weight mode for total power subtraction
    !                               from on-the-fly scans.
    ! window        double          lower and upper boundary of spectral region
    !                               to be avoided for evaluation of total power
    !                               (only for weight mode TOTAL)
    ! nwin          integer         number of such windows
    ! mask          integer         If total power reference comes from the OTF map
    !                               itself: first and last dump number of an OTF
    !                               subscan framing the emission region
    ! nmask         integer         number of such masks
    !
    ! ARRAY(1:NFB)%DATA(1:NBD)%DATA (double), where NFB is the number of
    ! spectral frontend-backend units, and NBD is the number of spectral
    ! basebands.
    !
    ! Output:
    ! ERROR (logical)               : error return flag
    ! DATA(IFB)%DATA%RDATA (double) : the spectrum of frontend-backend unit
    !                                 IFB (observing modi TRACK and ONOFF).
    ! DATA(IFB)%DATA%OTFDATA (double) : same as above, but for the o
    !
    !
    ! On successful execution, the logical flag
    ! REDUCE(IFB)%CALIBRATION_DONE(3) is set to .true. (IFB as on input).
    !
    !
       use mira
       use gildas_def
       use linearregression
       !
    end subroutine subtract_off
  end interface
  !
  interface
    subroutine subtract_offE(ifb,nrecords,wmode,window,nwin,   &
         mask,nmask,error)
    !
    ! Called by subroutine CALIBRATE. Performs the subtraction ON-OFF
    ! for multiple-phase data, and concatenates adjacent spectral basebands
    ! to a single output spectrum (to be written to the outputfile for
    ! CLASS).
    !
    ! Also called by subroutine SOLVE for uncalibrated pointings and for
    ! focus measurements.
    !
    ! Input:
    ! ifb           integer         number of frontend/backend unit
    ! nrecords      integer         number of backend data records
    ! wmode         character       weight mode for total power subtraction
    !                               from on-the-fly scans.
    ! window        double          lower and upper boundary of spectral region
    !                               to be avoided for evaluation of total power
    !                               (only for weight mode TOTAL)
    ! nwin          integer         number of such windows
    ! mask          integer         If total power reference comes from the OTF map
    !                               itself: first and last dump number of an OTF
    !                               subscan framing the emission region
    ! nmask         integer         number of such masks
    !
    ! ARRAY(1:NFB)%DATA(1:NBD)%DATA (double), where NFB is the number of
    ! spectral frontend-backend units, and NBD is the number of spectral
    ! basebands.
    !
    ! Output:
    ! ERROR (logical)               : error return flag
    ! DATA(IFB)%DATA%RDATA (double) : the spectrum of frontend-backend unit
    !                                 IFB (observing modi TRACK and ONOFF).
    ! DATA(IFB)%DATA%OTFDATA (double) : same as above, but for the o
    !
    !
    ! On successful execution, the logical flag
    ! REDUCE(IFB)%CALIBRATION_DONE(3) is set to .true. (IFB as on input).
    !
       use mira
       use gildas_def
       use linearregression
       !
    end subroutine subtract_offE
  end interface
  !
  interface
    subroutine do_tcal(ifb,nfreq,nrecords,fixopacity,opac,   &
         fixpwv,pwv0,error)
    !
    ! Called by subroutine getmira (source code of call is in file mira/lib/get.f90)
    ! if reading a calibration scan, and by subroutine OVERRIDE (i.e., if Tcal needs
    ! to be re-evaluated after a manual change of calibration parameters, see
    ! HELP OVERRIDE or user's manual). Updates MIRA structure GAINS.
    !
    ! Input:
    ! ifb           integer         number of frontend/backend combination
    ! nfreq         integer         number of frequency points to be evaluated
    !                               simultaneously (so far always nfreq = 1 because
    !                               subroutine mira_chopper is called separately for
    !                               each frequency band or, if opted for, spectral
    !                               channel.
    ! nrecords      integer         number of backend dumps in this scan
    ! fixopacity    logical         .true. if Tsys and Tcal are to be evaluated for 
    !                               a given opacity (at a given frequency).
    ! opac          double          Value of that opacity.
    ! fixpwv        logical         .true. if pwv is kept fixed, and opacities,
    !                               Tsys and Tcal are evaluated for that pwv.
    !                               Used e.g. for channel-wise calibration with pwv 
    !                               obtained from a wide spectral band.
    ! pwv0          double          Value of that opacity.
    !
    ! Output: 
    ! error         logical         .false. upon successful completion.
    !
       use mira
       use gildas_def
       use chopper_def
       !
    end subroutine do_tcal
  end interface
  !
  interface
    subroutine do_tcal_fsw(ifb,nfreq,nrecords,fixopacity,opac,   &
         fixpwv,pwv0,error)
    !
    ! As for subroutine do_tcal, but for calibrations taken with frequency 
    ! switching (in order to calibrate the FLO and FHI phases separately).
    ! Experimental.
    !
       use mira
       use gildas_def
       use chopper_def
       !
    end subroutine do_tcal_fsw
  end interface
  !
  interface
    subroutine do_xpol(ifb,nrecords,error)
    !
    ! Called by subroutine getfits.f90
    ! For calibration scans with pako option "/grid yes" and
    ! VESPA in XPOL mode, calculates the differential phase
    ! between the horizontal and vertical polarization of the
    ! EMIR band in frontend-backend-unit ifb, and writes the 
    ! result into gains(ifb)%phasearray.
    !
    ! Input: 
    ! ifb           integer         number of frontend/backend combination
    ! nrecords      integer         number of dumps for this scan and backend.
    !
    ! Output:
    ! error         logical         .false. upon succesful completion
    !
       use mira
    end subroutine do_xpol
  end interface
  !
  interface
    subroutine apply_xpol(ifb,nrecords,error)
    !
    ! For polarization observations only (i.e., VESPA in XPOL mode).
    ! Applies the phase correction measured with a "cal /grid yes"
    ! measurement to the real and imaginary part of the complex
    ! cross correlation (such that they become, after calibration,
    ! Stokes U and V in the Nasmyth reference system). Update
    ! array(ifb)%data(j)%data with j=1 to number of basebands.
    !
    ! Input:
    ! ifb           integer         number of frontend/backend combination
    !                               to be phase-calibrated
    ! nrecords      integer         number of dumps in this backend and scan
    !
    ! Output:
    ! error         logical         .false. upon successful completion
    !
       use mira
    end subroutine apply_xpol
  end interface
  !
  interface
    function airmdry(elev)
    !
    ! Calculates the airmass as a function of elevation
    ! (input variable "elev"), taking into account the
    ! curvature of the atmosphere (therefore, the atmospheric
    ! scale height is needed, and the function needs to
    ! distinguish between the dry and wet atmosphere.
    !
    !
       use mira
    end function airmdry
  end interface
  !
  interface
    function airmwet(elev)
    !
    ! Calculates the airmass as a function of elevation
    ! (input variable "elev"), taking into account the
    ! curvature of the atmosphere (therefore, the
    ! atmospheric scale height is needed, and the function
    ! needs to distinguish between the dry and wet atmosphere.
    !
       use mira
    end function airmwet
  end interface
  !
  interface
    subroutine mira_chopper(search,fixOpacity,opac,fixPWV,pwv0,tel,nfreq,freqs, &
    &                       loads,recs,atms,tcals,tsyss,quiet,errors)
    !
    ! Called by MIRA subroutine do_tcal (in mira/lib/calibrate.f90).
    ! Replaces telcal's subroutine chopper. Calls gildas interface
    ! to ATM at packages/atm (which in turn calls legacy/atm/lib).
    !
    !
      use chopper_def
      type (chop_mode), intent(in)    :: search        ! search criteria
      type (telescope), intent(in)    :: tel           ! telescope data
      integer,          intent(in)    :: nfreq         ! number of frequency points
      type (dsb_value), intent(in)    :: freqs(nfreq)  ! signa/image frequencies
      type (chop_meas), intent(in)    :: loads(nfreq)  ! cal counts (sky,hot,cold)
      type (mixer),     intent(inout) :: recs(nfreq)   ! rx efficiencies and gains
      type (atm_prop),  intent(inout) :: atms(nfreq)   ! atmspheric data
      type (dsb_value), intent(out)   :: tcals(nfreq)  ! calibration temperatures
      type (dsb_value), intent(out)   :: tsyss(nfreq)  ! system temperatures
      logical,          intent(out)   :: errors(nfreq) ! error flags
      logical,          intent(in)    :: quiet         ! suppress verbose output
      logical,          intent(in)    :: fixOpacity    ! if fixOpacity: no iterations, but
                                                       ! get Tcal,Tsys for fixed opacity
      real(8),          intent(in)    :: opac          ! value of that opacity
      logical,          intent(in)    :: fixPWV        ! if fixPWD: no iterations, but
                                                       ! get Tcal,Tsys, and taus for fixed pwv 
      real(8),          intent(in)    :: pwv0          ! value of that pwv 
    end subroutine mira_chopper
  end interface
  !
  interface
    function mira_airmass(el,quiet,error)
      ! EXPORT
      !----------------------------------------------------------------------
      ! Compute airmass number corresponding to elevation EL
      ! Use a curved atmosphere, equivalent height 5.5 km
      !----------------------------------------------------------------------
      real(8), intent(in)  :: el      ! Elevation [radian]
      logical, intent(out) :: error   ! Error flag
      logical, intent(in)  :: quiet   ! suppresses error messages
      real(8)              :: mira_airmass ! Airmass
    end function mira_airmass
  end interface
  !
  interface
    subroutine mira_atm_dsb_transmission(tel,ier)
      ! EXPORT
      use chopper_def
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      type (telescope), intent(in)    :: tel  !
      integer,          intent(inout) :: ier  ! Error flag
    end subroutine mira_atm_dsb_transmission
  end interface
  !
  interface
          SUBROUTINE mnbrak(ax,bx,cx,fa,fb,fc,func)
    !
    ! Subroutine from Numerical Recipes for bracketing
    ! a minimum using the golde rule.
    !
    ! Input:
    !
          end subroutine mnbrak
  end interface
  !
  interface
          FUNCTION brent(ax,bx,cx,f,tol,xmin,error)
          end function brent
  end interface
  !
  interface
          FUNCTION chiSquaredAtm(pwv)
          use chopper_def
          real(8), intent(in) :: pwv
          integer :: ier
          real(8) :: chiSquaredAtm, temi
          END FUNCTION chiSquaredAtm
  end interface
  !
  interface
          FUNCTION chiSquaredTau(pwv)
          use chopper_def
          real(8), intent(in) :: pwv
          integer :: ier
          real(8) :: chiSquaredTau, tau
          END FUNCTION chiSquaredTau
  end interface
  !
  interface
    SUBROUTINE DESPIKE(LINE,ERROR)
    !
    ! Called by subroutine RUN_MIRA (source code is in mira/lib/run.f90).
    ! Used for despiking of data. See online help or user's guide for options.
    !
    ! Input: command line from interactive MIRA session.
    ! Output: error flag.
    !
      USE mira
      USE gildas_def
      use gkernel_types
    end subroutine despike
  end interface
  !
  interface
    subroutine directory(line,error)
    !
    ! Defines the directory containing the imbfits raw data.
    ! Checks whether the directory exists and whether there are
    ! data in it.
    !
    ! Called by: load_mira (in load.f90, MIRA command "file in")
    ! Input: command line from Mira (see "help file")
    ! Output: error flag.
    !
    !
       use mira
       use gildas_def
       use gkernel_types
       !
    end subroutine directory
  end interface
  !
  interface
    subroutine findmira(line,error)
    !
    ! Searches the input directory for imbfits raw data, and calls
    ! subroutine getattributes to assign values to MIRA structure
    ! list(iobs), where iobs is the number of the observation in the
    ! index list.
    !
    ! Called by MIRA command "find" (see subroutine run_mira, in mira/lib/run.f90).
    ! See online help or user's ! guide for earch options.
    ! Input: command line from Mira (see "help find")
    ! Output: error flag.
    !
       !
       use       mira
       use       gildas_def
       use       gkernel_types
       !
    end subroutine findmira
  end interface
  !
  interface
    subroutine getattributes(directory,option,nfile,filelist,   &
         lastnumfound,lastdatefound,   &
         nobs,error)
    !
    ! Called by subroutine findmira. Opens fits files found for extracting
    ! information needed to attribute values to structure LIST.
    !
    !
       use mira
       !
    end subroutine getattributes
  end interface
  !
  interface
    subroutine indexx(n,arr,indx)
    !
    ! Called by subroutines findmira, getfits, getfitsNew, mira_list, 
    ! solve_pointing_mira, syncDataNew.
    !
    ! Returns an index list "indx" for sorting array "arr" in ascending order.
    ! (i.e., indx(1) yields the element number of arr with the smallest value,
    !  indx(n) that of the element of arr with the largest value.
    !
    ! Input:        n       integer         number of elements of vector arr
    !               arr     double          n-element vector to be sorted
    !               indx    integer         n-element vector with sort index
    !
    ! Source code is from Numerical Recipes.
    !
       integer n,indx(n),m,nstack
       real*8 arr(n)
    end subroutine indexx
  end interface
  !
  interface
    subroutine rank(n,indx,irank)
    !
    ! Called by subroutines getfits and getfitsNew.
    ! Yields a ranking list, i.e. says which position a given element of
    ! vector "arr" has in a listing of elementes in ascending order.
    !
    ! Input:        n       integer         number of elements of vector indx
    !               indx    integer         index list for sorting in ascending order
    !                                       (output from subroutine indexx)
    !               irank   integer         n-element vector  
    !
    ! Source code is from Numerical Recipes.
    !
       integer n,indx(n),irank(n)
    end subroutine rank
  end interface
  !
  interface
    subroutine renBand(n,indx,outdx)
    !
    ! If band numbers are non-consecutive
    ! rename them consecutively
    !
        integer n, indx(n), outdx(n)
    end subroutine renBand
  end interface
  !
  interface
    subroutine flagData(line,error)
    !
    ! Used for attributing the blanking value of raw data (blankingRaw), 
    ! respectively calibrated data (blankingRed) for a given spectral
    ! channel, receiver pixel, record, or spectral baseband.
    !
    ! Called by run_mira (interactive command: FLAG, see online help or 
    ! users' manual for options).
    !
    ! Input:        line    character       command line in interactive MIRA session
    ! Output:       error   logical         error flag
    !
    !
     USE mira
    end subroutine flagData
  end interface
  !
  interface
    subroutine getmira(line,error)
    !
    ! Searches the input directory for imbfits raw data.
    !
    ! Called by: load_mira (in load.f90, MIRA command "SCAN", accepts several search options).)
    ! Input: command line from Mira. For help about options: "MIRA\help find")
    ! Output: error flag.
    !
       !
       use mira
       use gildas_def
       use gkernel_types
       !
    end subroutine getmira
  end interface
  !
  interface
    subroutine getfitsNew(filename,tmpbackend,stepcompress,   &
         cryoextension,derotextension,trackingcutoff,         &
         currentindex,firstifb,ncf,nfb,subscanRange,nosky,error)
    !
    ! Reads the imbfits file (version >= 2.0) into MIRA's data structures (define in mira_use.f90).
    ! Called by subroutine getmira. See "MIRA\help get" for possible options.
    !
    ! Input: character(len=200) :: filename       ! with full path
    !        character(len=23)  :: tmpbackend     ! backend name (converted to upper case) as appearing in imbfits
    !        real*8             :: stepcompress   ! Elementary integration time for data compression.
    !        logical            :: cryoextension  ! Flag indicating whether imbfits has a binary extension for the
    !                                             ! HERA cryostat (one per subscan).
    !        logical            :: derotextension ! Idem for HERA derotator extension (one per subscan).
    !        real*8             :: trackingcutoff ! Backend data framed by antenna data with
    !                                             ! tracking errors > trackingcutoff [degree] are assigned the 
    !                                             ! blanking value (in subroutine syncData.f90, respectively 
    !                                             ! syncDataNew.f90). 
    ! 
    ! Overwrite hot load from receiver table if available 2011-04-14 AS
    !
       use mira
       use gbl_constant
       use cfitsio_status
       use fit_definitions
       use pcross_definitions
       use focus_definitions
       !
    end subroutine getfitsNew
  end interface
  !
  interface
    subroutine dateobstomjd(timestring,mjd,ier)
       !
    end subroutine dateobstomjd
  end interface
  !
  interface
    subroutine sla_cldj (iy, im, id, djm, j)
       !+
       !     - - - - -
       !      C L D J
       !     - - - - -
       !
       !  Gregorian Calendar to Modified Julian Date
       !
       !  Given:
       !     IY,IM,ID     int    year, month, day in Gregorian calendar
       !
       !  Returned:
       !     DJM          dp     modified Julian Date (JD-2400000.5) for 0 hrs
       !     J            int    status:
       !                           0 = OK
       !                           1 = bad year   (MJD not computed)
       !                           2 = bad month  (MJD not computed)
       !                           3 = bad day    (MJD computed)
       !
       !  The year must be -4699 (i.e. 4700BC) or later.
       !
       !  The algorithm is derived from that of Hatcher 1984
       !  (QJRAS 25, 53-55).
       !
       !  P.T.Wallace   Starlink   11 March 1998
       !
       !  Copyright (C) 1998 Rutherford Appleton Laboratory
       !-
    end subroutine sla_cldj
  end interface
  !
  interface
    subroutine medianinteger(x,n,out)
       !
       integer i, n
       integer indx(n),x(n)
       real*4 out
    end subroutine medianinteger
  end interface
  !
  interface
    subroutine mediandouble(x,n,out)
       !
       integer i, n
       integer indx(n)
       real*8  out, x(n)
    end subroutine mediandouble
  end interface
  !
  interface
    subroutine computeoffset(nfb,noff,nrecords,sysoff,scantype,   &
         switchmode,nosky,error)
       use mira
    end subroutine computeoffset
  end interface
  !
  interface
    subroutine convertCoord(xoff,yoff,sysoff,isign,error)
       use      mira
    end subroutine convertCoord
  end interface
  !
  interface
    subroutine freescan(var,error)
       use mira
    end subroutine freescan
  end interface
  !
  interface
    subroutine freefebe(var,error)
       use mira
    end subroutine freefebe
  end interface
  !
  interface
    subroutine freedata(var,error)
       use mira
    end subroutine freedata
  end interface
  !
  interface
    subroutine freearray(var,error)
       use mira
    end subroutine freearray
  end interface
  !
  interface
    subroutine freemon(var,error)
       use mira
    end subroutine freemon
  end interface
  !
  interface
    subroutine freegains(var,error)
       use mira
    end subroutine freegains
  end interface
  !
  interface
    subroutine freeraw(var,error)
       use mira
    end subroutine freeraw
  end interface
  !
  interface
    subroutine freecryo(var,error)
       use mira
    end subroutine freecryo
  end interface
  !
  interface
    subroutine freederot(var,error)
       use mira
    end subroutine freederot
  end interface
  !
  interface
    subroutine freelist(var,error)
       use mira
    end subroutine freelist
  end interface
  !
  interface
    subroutine getfits(filename,tmpbackend,stepcompress,   &
         cryoextension,derotextension,trackingcutoff,   &
         currentindex,firstifb,ncf,nfb,subscanRange,nosky,error)
    !
    ! Reads the imbfits file (version < 2.0) into MIRA's data structures (define in
    ! mira_use.f90). Called by subroutine getmira. See "MIRA\help get" for possible options.
    !
       !
       use mira
       use gbl_constant
       use cfitsio_status
       use fit_definitions
       use pcross_definitions
       use focus_definitions
       !
    end subroutine getfits
  end interface
  !
  interface
    subroutine init
    !
    ! called by load_mira
    !
       !
       use mira
       !
    end subroutine init
  end interface
  !
  interface
    subroutine exit_mira
       use mira
    end subroutine exit_mira
  end interface
  !
  interface
    subroutine mira_list(line,error)
    !
    ! Called by MIRA subroutine run_mira (source code in mira/lib/run.f90), command LIST,
    ! and SUBROUTINE FINDMIRA (see source code in find.f90).
    ! See interactive HELP or user's guide for options.
    !
    ! Input: command line from interactive Mira session
    ! Output: error flag.
    !
       use mira
       use pcross_definitions
       !
    end subroutine mira_list
  end interface
  !
  interface
    subroutine fluxfill(lun,freq,iyear,imon,iday,month,   &
         format,receiver,tau,tsys,trec,ifb,doflag,flagFebe,flagSubscan,nFlagSubscan)
    !
    ! Called by mira_list. Creates an output ASCII file with flux densities from
    ! monitoring sessions.
    !
       use mira
       use pcross_definitions
    end subroutine fluxfill
  end interface
  !
  interface
    subroutine fluxBackend(lun,freq,iyear,imon,iday,month,ifb,nbd,nchan, &
                           tau,pwv,tsys,trec,fluxCorr)
    !
    ! Same as fluxfill but for on-offs of continuum souces observed with a
    ! spectrometer and wobbler switch mode. Needs to be debugged ?
    !
       use mira
       use pcross_definitions
    end subroutine fluxBackend
  end interface
  !
  interface
    subroutine load_mira
    !
    ! Called by driver routine mira/main/mira.f90 
    !
       !
       use mira
       !
    end subroutine load_mira
  end interface
  !
  interface
    subroutine plot(line,error)
       !
       use mira
       use gildas_def
       use gkernel_types
       !
    end subroutine plot
  end interface
  !
  interface
    subroutine run_mira(line,comm,error)
       !
       use mira
       !
    end subroutine run_mira
  end interface
  !
  interface
    subroutine show(line,error)
    !
    ! Unused (command is not defined in subroutine load_mira).
    !
       !
       use mira
       !
       integer            :: nc
       character(len = *) :: line
       character          :: ch*72
       logical            :: case_array, case_febe, case_general,   &
       !
    end subroutine show
  end interface
  !
  interface
    subroutine solve(line,error)
    !
    ! Called by subroutine run_mira (MIRA command "solve"). 
    ! Calls the appropriate subroutines and plotting procedures
    ! for solving cross-scan pointings, focus measurements (axial or lateral ones)
    ! and skydips.
    !
    ! Input: command line from interactive MIRA session or ODP script.
    ! Output: error flag.
    !
       use mira
       !
    end subroutine solve
  end interface
  !
  interface
    subroutine solve_pointing_mira(ifb,ipix,nbin,ibase,line)
    !
    ! Called by subroutine SOLVE.
    ! solve_pointing_mira prepares (subscan or coadded Az- and
    ! El-subscan, after removal of linear baselines) data for
    ! subsequent call of telcal's subroutine fit_1d, writes
    ! the results into the corresponding MIRA and SIC structures,
    ! and calls subroutines protoResultsPointing to write an XML
    ! file with the results.
    !
       use mira
       use fit
       use gildas_def
       use gkernel_types
       use pcross_definitions
       use fit_definitions
       use linearregression
       !
    end subroutine solve_pointing_mira
  end interface
  !
  interface
    subroutine pointing_to_sic(dat,fun,profile,error)
    !
    ! Creates a SIC copy of Mira structure PNT (pointing results for
    ! co-added azimuth and elevation data). Results from individual
    ! pointing subscans are in telcal/sic structure PCROSS.
    !
       use gildas_def
       use gkernel_types
       use fit_definitions
       !
    end subroutine pointing_to_sic
  end interface
  !
  interface
    subroutine solve_xyzfocus(ifb,ipix,idir)
    !
    ! Called by subroutine SOLVE.
    ! solve_xyzfocus prepares the data of a focus scan
    ! subsequent call of telcal's subroutine fit_1d, writes
    ! the results into the corresponding MIRA and SIC structures,
    ! and calls subroutines protoResultsFocus to write an XML
    ! file with the results.
    !
       use mira
       use gildas_def
       use gkernel_types
       use fit_definitions
       use focus_definitions
       !
    end subroutine solve_xyzfocus
  end interface
  !
  interface
    subroutine solve_tip(ifb,ipix)
    !
    ! Called from run_mira (MIRA command SOLVE if current scan is a 
    ! skytip). This subroutine is merely an interface to SIC routine
    ! where the skydip is solved (in mira/pro/p_plot_tip.mira).
    !
    !
       integer           :: ifb, ipix
    end subroutine solve_tip
  end interface
  !
  interface
    subroutine linregress(basedata,basepar,bval)
       !
       use linearregression
       !
    end subroutine linregress
  end interface
  !
  interface
    subroutine syncData(ifb,nfb,subscanRange,error)
    !
    ! Called by subroutines getfits and getfitsNew.
    ! Interpolates antenna and subreflector data at backend timestamp
    ! (linear between preceeding and following antenna and subreflector dump).
    ! Results are written into Mira structures DATA(ifb) (where ifb is the frontend-
    ! backend number).
    !
    ! syncData checks the consistency of the timing (e.g., that each backend time
    ! stamp between imbfits data header entries dateObs and dateEnd is framed by
    ! antenna and subreflector data points at either side).
    !
    !
      use mira
      use gildas_def
    end subroutine syncData
  end interface
  !
  interface
    FUNCTION locate(xx,x,n)
    END FUNCTION locate
  end interface
  !
  interface
    subroutine miraPolfit(n,n2,y1,y2,error)
       use mira
    end subroutine miraPolfit
  end interface
  !
  interface
    subroutine determ(n,array,delta,error)
    end subroutine determ
  end interface
  !
  interface
    subroutine syncDataNew(ifb,nfb,subscanRange,error)
    !
    ! Called by subroutines getfits and getfitsNew.
    ! Interpolates antenna and subreflector data at backend timestamp
    ! (linear between preceeding and following antenna and subreflector dump).
    ! Results are written into Mira structures DATA(ifb) (where ifb is the frontend-
    ! backend number).
    !
    ! Unlike subroutine syncData, does not apply any timing check.
    !
      use mira
      use gildas_def
    end subroutine syncDataNew
  end interface
  !
  interface
    subroutine mira_variable(line,error)
    !
    ! Called by MIRA command VARIABLE (see online help and users' manual
    ! for options). Calling subroutine mira_to_sic.
    !
    ! Input:  line      character      command line from interactive MIRA session
    ! Output: error    logical        error flag
    !
       use mira
       !
    end subroutine mira_variable
  end interface
  !
  interface
    subroutine mira_to_sic
    !
    ! Contains the following entries:
    ! prim_to_sic, scan_to_sic, febe_to_sic, data_to_sic, array_to_sic,
    ! mon_to_sic, gains_to_sic, choice_to_sic, reduce_to_sic, raw_to_sic,
    ! cryo_to_sic, derot_to_sic, list_to_sic.
    !
    ! Called by the following subroutines:
    !
    ! subroutine            comments
    ! calibrate             if SIC structure GAINS or REDUCE already declared
    ! despike               if SIC structure REDUCE already declared
    ! findmira              if SIC structures CHOICE and LIST already declared
    ! getmira               for update of already declared SIC structures
    !
    ! Note: the subroutine pointing_to_sic (source code in mira/lib/solve.f90) for declaring
    ! and attributing the SIC structure PNT for coadded pointing subscans is called
    ! by solve_pointing_mira.
    !
       use mira
       use gildas_def
       use gkernel_types
       !
    end subroutine mira_to_sic
  end interface
  !
  interface
    subroutine mira_write(line,error)
    !
    ! Called by subroutine run_mira (interactively by MIRA command WRITE).
    ! Prepares things for call to subroutine writeClass.
    !
    ! Input: MIRA command line.
    ! Output: error flag (if .not.error then data of the current scan are
    !         written into the output class file.
    !
       use mira
    !
    end subroutine mira_write
  end interface
  !
  interface
    subroutine writeClass(ifb,ipix,subscan,irec,init,error)
    !
    ! Called by subroutine mira_write.
    ! 
    ! Input:
    ! ifb       integer     input   Number of frontend-backend combination to be
    !                               written to CLASS output file.
    ! ipix      integer     input   Number of pixel (of HERA, otherwise ipix = 1)
    !                               to be written to CLASS output file.
    ! init      logical     input   Set to .true. if all CLASS header entries are 
    !                               to be determined. For the records of an OTF map
    !                               whose CLASS spectra have many identical header
    !                               entries.
    ! error     logical     output  error flag
    !
    !
       use mira
       use fit
       use class_api
       use class_RT
       use class_setup
       use gildas_def
       use gbl_constant
       use pcross_definitions
       use fit_definitions
       use gbl_format
    end subroutine writeClass
  end interface
  !
  interface
    subroutine writeMbfits(error)
    !
    ! Yet to be done. Was thought to convert IMBFITS (IRAM 30m) to MBFITS (MPIfR
    ! Apex).
    ! 
    !
       use mira
    !
    end subroutine writeMbfits
  end interface
  !
  interface
    SUBROUTINE protoResultsFocus(ifb,ipix,fun,error)
    !
    ! Writes result from a focus scans (evaluated by MIRA with command
    ! SOLVE) into an XML file to be used by the NCS for monitoring and feedback
    ! of the focus correction.
    !
       Use mira
       Use modulePakoXML
       Use moduleResultsToNCS
       Use fit_definitions
       Use focus_definitions
       Use gbl_format
    END SUBROUTINE protoResultsFocus
  end interface
  !
  interface
    SUBROUTINE protoResultsPointing(ifb,ipix,error)
    !
    ! Writes results from pointing cross scans (evaluated by MIRA with command
    ! SOLVE) into an XML file to be used by the NCS for monitoring and feedback
    ! of pointing corrections.
    !
       Use mira
       Use modulePakoXML
       Use moduleResultsToNCS
       Use fit_definitions
       USe pcross_definitions
       Use fit 
       Use gbl_format
    END SUBROUTINE protoResultsPointing
  end interface
  !
  interface
    SUBROUTINE protoResultsCalibration(error)
       Use mira
       Use modulePakoXML
       Use moduleResultsToNCS
       Use gbl_format
    END SUBROUTINE protoResultsCalibration
  end interface
  !
  interface
    SUBROUTINE OVERRIDE(LINE,ERROR)
      USE mira
    END SUBROUTINE OVERRIDE
  end interface
  !
  interface
    subroutine freeNewpar(var,error)
      use mira
    end subroutine freeNewpar
  end interface
  !
  interface
    subroutine do_trx(ifb,error)
      USE mira
    end subroutine do_trx
  end interface
  !
end module mira_interfaces_none

subroutine atm_init(error)
  use gbl_message
  use gkernel_interfaces
  use atm_params
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! ATM
  !
  ! One time instantiation of the ASTRO variables which are used (as
  ! input and output) by the command ASTRO\ATM. These variables and
  ! their startup values are not needed if the programmer does want
  ! to make use of the command ASTRO\ATM.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ATM_INIT'
  !
  if (atm_initdone) return
  !
  call atm_sicvariables(error)
  if (error) then
    call astro_message(seve%e,rname,'Error creating ATM% variables')
    return
  endif
  !
  ! Default values of input parameters
  t0 = 273.0
  p0 = 1013.0
  water = 1.0
  airmass = 1.414
  feff = 0.95
  freqs = 110.0
  freqi = 113.0
  gim = 1.0
  trec = 60
  !
  ! Input parameters
  call sic_def_real ('TEMPERATURE',t0,0,1,.false.,error)
  if (error) return
  call sic_def_real ('TRUE_PRESSURE',p1,0,1,.true.,error)
  if (error) return
  call sic_def_real ('ZERO_PRESSURE',p0,0,1,.false.,error)
  if (error) return
  call sic_def_dble ('ALTITUDE',altitude,0,1,.true.,error)
  if (error) return
  call sic_def_real ('WATER',water,0,1,.false.,error)
  !! if (error) return
  call sic_def_real ('AIRMASS',airmass,0,1,.false.,error)
  if (error) return
  call sic_def_real ('FORWARD_EFF',feff,0,1,.false.,error)
  !! if (error) return
  call sic_def_real ('FREQ_SIG',freqs,0,1,.false.,error)
  if (error) return
  call sic_def_real ('FREQ_IMA',freqi,0,1,.false.,error)
  if (error) return
  call sic_def_real ('GAIN_IMAGE',gim,0,1,.false.,error)
  !! if (error) return
  call sic_def_real ('TREC',trec,0,1,.false.,error)
  if (error) return
  !
  ! Output parameters
  call sic_def_real ('TSYS',tsys,0,1,.true.,error)
  !! if (error) return
  call sic_def_real ('TAU_O2',tauox,0,1,.true.,error)
  if (error) return
  call sic_def_real ('TAU_H2O',tauw,0,1,.true.,error)
  if (error) return
  call sic_def_real ('TAU_TOT',taut,0,1,.true.,error)
  if (error) return
  call sic_def_real ('EMIS_SIG',temis,0,1,.true.,error)
  if (error) return
  call sic_def_real ('EMIS_IMA',temii,0,1,.true.,error)
  if (error) return
  call sic_def_real ('PATH_SIG',paths,0,1,.true.,error)
  if (error) return
  call sic_def_real ('PATH_IMA',pathi,0,1,.true.,error)
  if (error) return
  call sic_def_real ('ATM_SIG',tatms,0,1,.true.,error)
  if (error) return
  call sic_def_real ('ATM_IMA',tatmi,0,1,.true.,error)
  if (error) return
  call sic_def_real ('TANT',tant,0,1,.true.,error)
  if (error) return
  !
  call astro_message(seve%d,rname,'ATM-ASTRO interface initialized')
  atm_initdone = .true.
  !
end subroutine atm_init
!
subroutine astro_atm(line,error)
  use gildas_def
  use gkernel_interfaces
  use atm_params
  use atm_interfaces_public
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! ATM
  !
  ! Purpose: compute atmospheric properties
  !     from a full set of SIC variables
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4), parameter :: optprint=1
  integer(kind=4), parameter :: optfrequ=2
  integer(kind=4) :: ier,nfile,nf
  real(kind=4) :: frequ,fmin,fmax
  character(len=filename_length) :: file
  integer(kind=4), parameter :: mact=3
  integer(kind=4) :: nact,nname
  character(len=11) :: actions(mact) = (/'INTERPOLATE','MAKE       ','SAVE       '/)
  character(len=16) :: action,name
  logical, save :: first
  ! Data
  data first /.true./
  !
  ! Optionally print ATM status before the actions below
  if (sic_present(optprint,0))  call astro_atm_print(error)
  !
  h0 = altitude
  if (.not.sic_present(0,1)) then
    !
    p1 = p0*2.0**(-h0/5.5)     ! Pressure at altitude H0
    call atm_atmosp(t0,p1,h0)
    !
    if (sic_present(optfrequ,0)) then
      call astro_atm_compute_1d(line,error)
    else
      call astro_atm_compute_0d(line,error)
    endif
    if (error)  return
    !
  else
    ! Read binary file once.
    if (first) then
      call atm_i(error)
      first = .false.
    endif
    ! Retrieve and analyze first argument
    call sic_ke(line,0,1,name,nname,.true.,error)
    if (error) return
    call sic_ambigs('ATMOSPHERE',name(1:nname),action,nact,actions,mact,error)
    if (error) return
    !
    if (action.eq.'INTERPOLATE') then
      ! Interpolate from file:
      call atm_atmosp_i(t0,p1,h0)
      !
      frequ = freqi
      call atm_transm_i(water,airmass,frequ,temii,tatmi,tauox,tauw,taut,ier)
      call atm_path_i(water,airmass,frequ,pathi,ier)
      pathi = pathi*10         ! -> mm
      !
      frequ = freqs
      call atm_transm_i(water,airmass,frequ,temis,tatms,tauox,tauw,taut,ier)
      call atm_path_i(water,airmass,frequ,paths,ier)
      paths = paths*10         ! -> mm
      !
      tant = (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
             (feff*temis+(1.0-feff)*t0 + trec) ) / (1.0+gim)
      tsys = exp(taut*airmass) * (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
             (feff*temis+(1.0-feff)*t0 + trec) ) / feff
      !
    elseif (action.eq.'MAKE') then
      ! Make a file: ATM Make filename nf fmin fmax
      file = ' '
      call sic_ch(line,0,2,file,nfile,.true.,error)
      if (error) return
      nf = 200
      fmin = 75.
      fmax = 300.
      call sic_i4(line,0,3,nf,.false.,error)
      if (error) return
      call sic_r4(line,0,4,fmin,.false.,error)
      if (error) return
      call sic_r4(line,0,5,fmax,.false.,error)
      if (error) return
      call atmos_i_table(.true.,file,nfile,nf,fmin,fmax,h0,error)
      !
    elseif (action.eq.'SAVE') then
      ! Save on file previously loaded table: ATM Save filename
      ! This one may be used to save with the current machine byte order a
      ! table previously loaded whose byte order was different.
      file = ' '
      call sic_ch(line,0,2,file,nfile,.true.,error)
      if (error) return
      nf = 200
      fmin = 75.
      fmax = 300.
      call atmos_i_table(.false.,file,nfile,nf,fmin,fmax,h0,error)
      !
    endif
  endif
  !
end subroutine astro_atm
!
subroutine astro_atm_print(error)
  use gbl_message
  use atm_params
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! ATM
  !
  ! Support routine for command:
  !   ASTRO\ATM /PRINT
  !---------------------------------------------------------------------
  logical, intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ATM_PRINT'
  character(len=message_length) :: mess
  !
  call astro_message(seve%r,rname,'Current status of ATM is')
  !
  ! Print ATM internal parameters
  call atm_print(error)
  !
  ! Print ASTRO_ATM internal parameters
  write(mess,101) 'TEMPERATURE',t0,'[K]','Ground temperature'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'ZERO_PRESSURE',p0,'[hPa]','Pressure at sea level'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'ALTITUDE',altitude,'[km]','Altitude of the observatory'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'WATER',water,'[mm]','Precipitable water vapor'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'AIRMASS',airmass,'[]','Number of airmasses'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'FORWARD_EFF',feff,'[]','Forward efficiency'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'FREQ_SIG',freqs,'[GHz]','Signal frequency'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'FREQ_IMA',freqi,'[GHz]','Image frequency'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'GAIN_IMAGE',gim,'[]','Gain image'
  call astro_message(seve%r,rname,mess)
  !
  write(mess,101) 'TREC',trec,'[K]','Receiver temperature'
  call astro_message(seve%r,rname,mess)
  !
101 format(A,T23,F12.3,T36,A6,T43,A)
  !
end subroutine astro_atm_print
!
subroutine astro_atm_compute_0d(line,error)
  use atm_interfaces_public
  use atm_params
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   ASTRO\ATM
  ! i.e. compute (direct call to libatm) the atmosphere according to
  ! user inputs found in Sic variables (scalar version)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: ier
  !
  call atm_transm(water,airmass,freqi,temii,tatmi,tauox,tauw,taut,ier)
  call atm_path(water,airmass,freqi,pathi,ier)
  pathi = pathi*10  ! -> mm
  !
  call atm_transm(water,airmass,freqs,temis,tatms,tauox,tauw,taut,ier)
  call atm_path(water,airmass,freqs,paths,ier)
  paths = paths*10  ! -> mm
  !
  tant = (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
         (feff*temis+(1.0-feff)*t0 + trec) ) / (1.0+gim)
  tsys = exp(taut*airmass) * (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
                             (feff*temis+(1.0-feff)*t0 + trec) ) / feff
  !
end subroutine astro_atm_compute_0d
!
subroutine astro_atm_compute_1d(line,error)
  use gildas_def
  use gbl_message
  use gkernel_types
  use gkernel_interfaces
  use atm_interfaces_public
  use atm_params
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   ASTRO\ATM /FREQ SIGNAL IMAGE
  ! i.e. compute (direct call to libatm) the atmosphere according to
  ! user inputs found in Sic variables, and to the frequency arrays
  ! passed to the option (1D version)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ATM'
  integer(kind=4), parameter :: optfrequ=2
  type(sic_descriptor_t) :: sdesc
  real(kind=4) :: intfreq
  integer(kind=4) :: ier
  integer(kind=size_length) :: ifreq,nfreq
  real(kind=4), allocatable :: sig(:),ima(:)  ! R*4 for atm_transm
  real(kind=4), allocatable :: mytemii(:),mytatmi(:),mytemis(:),mytatms(:)
  real(kind=4), allocatable :: mytauox(:),mytauw(:),mytaut(:),mytant(:),mytsys(:)
  integer(kind=4), allocatable :: myier(:)
  !
  ! First: do not leave ambiguous products if the command needs to stop
  ! before the end.
  call delete_variables()
  !
  ! Retrieve user inputs: signal frequencies can be scalar explicit value,
  ! scalar variable, or array variable:
  call sic_de(line,optfrequ,1,sdesc,.true.,error)  ! Signal
  if (error)  return
  intfreq = 0.  ! Default 0 means image freq == signal freq
  call sic_r4(line,optfrequ,2,intfreq,.false.,error)
  if (error)  goto 10
  !
  ! Incarnate the frequency arrays from user inputs
  nfreq = desc_nelem(sdesc)
  allocate(sig(nfreq),ima(nfreq),stat=ier)
  if (failed_allocate(rname,'freq. arrays',ier,error))  goto 10
  call sic_descriptor_getval(sdesc,sig,error)
10 continue
  call sic_volatile(sdesc)  ! Not needed anymore
  if (error)  return
  if (intfreq.le.0.) then
    ima(:) = sig(:)
  else
    do ifreq=1,nfreq
      ima(ifreq) = 2.*intfreq-sig(ifreq)
    enddo
  endif
  !
  ! Temporary arrays: we could avoid them if one day we will be able
  ! to get a Fortran R*4 pointer to the Sic variable allocated memory...
  allocate(mytemii(nfreq),mytatmi(nfreq),mytemis(nfreq),mytatms(nfreq),  &
           mytauox(nfreq),mytauw(nfreq),mytaut(nfreq),myier(nfreq),      &
           mytant(nfreq),mytsys(nfreq),stat=ier)
  if (failed_allocate(rname,'output arrays',ier,error))  return
  !
  ! Actual ATM computations:
  call atm_transm(water,airmass,ima,mytemii,mytatmi,mytauox,mytauw,mytaut,myier)
  call atm_transm(water,airmass,sig,mytemis,mytatms,mytauox,mytauw,mytaut,myier)
  mytant(:) = (gim * (feff*mytemii+(1.0-feff)*t0 + trec) +  &
                     (feff*mytemis+(1.0-feff)*t0 + trec) ) / (1.0+gim)
  mytsys(:) = exp(mytaut*airmass) * (gim * (feff*mytemii+(1.0-feff)*t0 + trec) +  &
                                           (feff*mytemis+(1.0-feff)*t0 + trec) ) / feff
  !
  ! Save the products in Sic variables
  call define_variables(nfreq,error)
  if (error)  return
  call fill_variables(error)
  if (error)  return
  !
  ! Cleaning: let Fortran deallocate the allocatable arrays
  !
contains
  !
  subroutine delete_variables()
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    call sic_delvariable('ATM%EMIS_IMA',.false.,error)
    error = .false.
    call sic_delvariable('ATM%ATM_IMA',.false.,error)
    error = .false.
    call sic_delvariable('ATM%EMIS_SIG',.false.,error)
    error = .false.
    call sic_delvariable('ATM%ATM_SIG',.false.,error)
    error = .false.
    call sic_delvariable('ATM%TAU_O2',.false.,error)
    error = .false.
    call sic_delvariable('ATM%TAU_H2O',.false.,error)
    error = .false.
    call sic_delvariable('ATM%TAU_TOT',.false.,error)
    error = .false.
    call sic_delvariable('ATM%IER',.false.,error)
    error = .false.
    call sic_delvariable('ATM%TANT',.false.,error)
    error = .false.
    call sic_delvariable('ATM%TSYS',.false.,error)
    error = .false.
  end subroutine delete_variables
  !
  subroutine define_variables(nfreq,error)
    !-------------------------------------------------------------------
    ! Create Sic variables which will hold the results
    !-------------------------------------------------------------------
    integer(kind=size_length), intent(in)    :: nfreq
    logical,                   intent(inout) :: error
    ! Local
    character(len=8) :: dims
    !
    write(dims,'(A,I0,A)') '[',nfreq,']'
    call sic_defvariable(fmt_r4,'ATM%EMIS_IMA'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_r4,'ATM%ATM_IMA'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_r4,'ATM%EMIS_SIG'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_r4,'ATM%ATM_SIG'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_r4,'ATM%TAU_O2'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_r4,'ATM%TAU_H2O'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_r4,'ATM%TAU_TOT'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_i4,'ATM%IER'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_r4,'ATM%TANT'//dims,.true.,error)
    if (error)  return
    call sic_defvariable(fmt_r4,'ATM%TSYS'//dims,.true.,error)
    if (error)  return
  end subroutine define_variables
  !
  subroutine fill_variables(error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call sic_variable_fill(rname,'ATM%EMIS_IMA',mytemii,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%ATM_IMA',mytatmi,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%EMIS_SIG',mytemis,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%ATM_SIG',mytatms,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%TAU_O2',mytauox,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%TAU_H2O',mytauw,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%TAU_TOT',mytaut,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%IER',myier,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%TANT',mytant,nfreq,error)
    if (error)  return
    call sic_variable_fill(rname,'ATM%TSYS',mytsys,nfreq,error)
    if (error)  return
  end subroutine fill_variables
  !
end subroutine astro_atm_compute_1d

      FUNCTION GAMMQ(A,X,ERROR)
      REAL*4 GAMMQ
      REAL*4 A,X
      LOGICAL ERROR
*
      REAL*4 GAMSER,GLN,GAMMCF
*
      IF(X.LT.0..OR.A.LE.0.) THEN
         ERROR = .TRUE.
         RETURN
      ENDIF
      IF(X.LT.A+1.)THEN
        CALL GSER(GAMSER,A,X,GLN,ERROR)
        GAMMQ=1.-GAMSER
      ELSE
        CALL GCF(GAMMCF,A,X,GLN,ERROR)
        GAMMQ=GAMMCF
      ENDIF
      RETURN
      END
C<FF>
      SUBROUTINE GCF(GAMMCF,A,X,GLN,ERROR)
      REAL*4 GAMMCF,A,X,GLN
      LOGICAL ERROR
*
      INTEGER ITMAX
      REAL*4 EPS
      PARAMETER (EPS=3.E-7)
      REAL*4 GOLD,A0,A1,B0,B1,FAC,AN,ANF,ANA,GAMMLN,G
      INTEGER N
*
      ITMAX = 10*SQRT(A)
      GLN=GAMMLN(A)
      GOLD=0.
      A0=1.
      A1=X
      B0=0.
      B1=1.
      FAC=1.
      DO 11 N=1,ITMAX
        AN=FLOAT(N)
        ANA=AN-A
        A0=(A1+A0*ANA)*FAC
        B0=(B1+B0*ANA)*FAC
        ANF=AN*FAC
        A1=X*A0+ANF*A1
        B1=X*B0+ANF*B1
        IF(A1.NE.0.)THEN
          FAC=1./A1
          G=B1*FAC
          IF(ABS((G-GOLD)/G).LT.EPS) GO TO 1
          GOLD=G
        ENDIF
11    CONTINUE
!      PAUSE 'A too large, ITMAX too small'
      ERROR = .TRUE.
      RETURN
1     GAMMCF=EXP(-X+A*ALOG(X)-GLN)*G
      RETURN
      END
C<FF>
      SUBROUTINE GSER(GAMSER,A,X,GLN,ERROR)
      REAL*4 GAMSER,A,X,GLN
      LOGICAL ERROR
*
      INTEGER ITMAX,N
      REAL*4 EPS
      PARAMETER (EPS=3.E-7)
      REAL*4 GAMMLN,SUM,DEL,AP
*
      ITMAX = 10*SQRT(A)
      GLN=GAMMLN(A)
      IF(X.LE.0.)THEN
        IF(X.LT.0.) THEN
           ERROR = .TRUE.
           RETURN
        ENDIF
        GAMSER=0.
        RETURN
      ENDIF
      AP=A
      SUM=1./A
      DEL=SUM
      DO 11 N=1,ITMAX
        AP=AP+1.
        DEL=DEL*X/AP
        SUM=SUM+DEL
        IF(ABS(DEL).LT.ABS(SUM)*EPS)GO TO 1
11    CONTINUE
!      PAUSE 'A too large, ITMAX too small'
      ERROR = .TRUE.
      RETURN
1     GAMSER=SUM*EXP(-X+A*LOG(X)-GLN)
      RETURN
      END
C<FF>
      FUNCTION GAMMLN(XX)
      REAL*4 GAMMLN,XX
*
      INTEGER J
      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER
      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*LOG(TMP)-TMP
      SER=ONE
      DO 11 J=1,6
        X=X+ONE
        SER=SER+COF(J)/X
11    CONTINUE
      GAMMLN=TMP+LOG(STP*SER)
      RETURN
      END
C<FF>
      FUNCTION ERFCC(X)
      REAL*4 ERFCC,X
*
      REAL*4 Z,T
*
      Z=ABS(X)      
      T=1./(1.+0.5*Z)
      ERFCC=T*EXP(-Z*Z-1.26551223+T*(1.00002368+T*(.37409196+
     *    T*(.09678418+T*(-.18628806+T*(.27886807+T*(-1.13520398+
     *    T*(1.48851587+T*(-.82215223+T*.17087277)))))))))
      IF (X.LT.0.) ERFCC=2.-ERFCC
      RETURN
      END

subroutine gtl_clear(line,error)
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_clear
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command CLEAR
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  integer, parameter :: nvocab=8
  character(len=12) :: vocab(nvocab),to_check,comm
  integer :: ncom,nc,sever,usernum,cnum
  character(len=gtvpath_length) :: name
  !
  data vocab /'ALPHA','DIRECTORY','GRAPHIC','PLOT','SEGMENT','TREE',  &
    'WINDOW','WHOLE'/
  !
  if (sic_present(0,1)) then
    call sic_ke (line,0,1,to_check,nc,.true.,error)
    if (error) return
    call sic_upper(to_check)
    if (to_check.eq.'ALL') then
      ! Non-standard detection of 'ALL' as long as CLEAR ALPHA (often
      ! invoked with "CL AL" in procedures) exists, to avoid ambiguities.
      comm = 'ALL'
    else
      call sic_ambigs(rname,to_check,comm,ncom,vocab,nvocab,error)
      if (error)  return
    endif
  else
    comm = 'ALL'  ! Default is CLEAR ALL
  endif
  !
  if (strict2011) then
    sever = seve%e
  else
    sever = seve%w
  endif
  !
  select case (comm)
  case ('ALL')  ! Clear the content of all top directories
    call gtv_clear_all(error)
    call gtview('Update')
    !
  case ('ALPHA')  ! Lower alpha window
    ! Obsolete since 23-sep-2010
    call gtv_message(sever,rname,'CLEAR ALPHA is obsolete')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call gtv_clear_alpha(cw_output)
    !
  case('TREE')  ! Clear "current tree" e.g. GREG and its subdirectories
    ! Obsolete since 11-oct-2010
    call gtv_message(sever,rname,'CLEAR TREE is obsolete')
    call gtv_message(sever,rname,'Use CLEAR DIRECTORY [Name] instead')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    name = ' '
    call sic_ch(line,0,2,name,nc,.false.,error)
    if (error) return
    call gtv_clear_tree(name,error)
    if (error)  return
    call gtview('Update')
    return
    !
  case ('WHOLE')  ! All plots
    ! Obsolete since 11-oct-2010
    call gtv_message(sever,rname,'CLEAR WHOLE is obsolete')
    call gtv_message(sever,rname,'Use DESTROY ALL instead')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call gtv_destroy_all(error)
    return
    !
  case ('DIRECTORY')  ! Clear directory
    call gtl_clear_directory(line,error)
    if (error)  return
    !
  case ('GRAPHIC')  ! Raise alpha window
    ! Obsolete since 23-sep-2010
    call gtv_message(sever,rname,'CLEAR GRAPHIC is obsolete')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call gtv_clear_graphic(cw_output)
    !
  case ('PLOT')  ! Clear whole plot
    call gtv_message(sever,rname,'CLEAR PLOT is obsolete. If you want to (see HELP for details):')
    call gtv_message(sever,rname,'- clear the content of all the windows, use CLEAR [ALL]')
    call gtv_message(sever,rname,'- destroy all the directories and windows, use DESTROY ALL')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call gtv_destroy_all(error)
    return
    !
  case ('SEGMENT')  ! Clear segment
    if (sic_present(0,2)) then
      ! Clear named segment
      call gtl_clear_segment(line,error)
    else
      ! Clear last segment
      call gtdls  ! Write-protected
      call gtview('Update')
    endif
    !
  case ('WINDOW')
    call gtv_message(sever,rname,'CLEAR WINDOW is obsolete. If you want to (see HELP for details):')
    call gtv_message(sever,rname,'- destroy a window, use DESTROY WINDOW [DirName [WinNum]]')
    call gtv_message(sever,rname,'- clear the content of a window, use CLEAR DIRECTORY [DirName]')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    ! Clear named window
    !
    call gtv_open_segments_for_writing_from_main()
    !
    if (sic_present(0,2)) then
      call sic_i4(line,0,2,usernum,.true.,error)
      cnum = get_window_cnum(cw_directory,usernum,error)
      call win_destroy_one(cw_directory,cnum,error)
    else
      ! Current window
      call win_destroy_one(cw_directory,cw_directory%x%curwin,error)
    endif
    !
    call gtv_close_segments_for_writing_from_main()
    !
  case default
    call gtv_message(seve%e,rname,''''//trim(comm)//''' not yet implemented.')
    error = .true.
    return
  end select
  !
end subroutine gtl_clear
!
subroutine gtl_clear_segment(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_clear_segment
  use gtv_buffers
  !---------------------------------------------------------------------
  ! @ private
  !  Cleanly destroy named segment(s) from the GTV tree, reading name
  ! from the command line.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line  ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=gtvpath_length) :: argum
  integer :: nc
  !
  ! Get segment name
  call sic_ch(line,0,2,argum,nc,.true.,error)
  if (error) return
  !
  call gt_clear_segment(argum,.true.,error)
  if (error)  return
  !
end subroutine gtl_clear_segment
!
subroutine gt_clear_segment(argum_in,present,error)
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_clear_segment
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !  Destroy the input segment(s) given its(their) name. They can have
  ! an absolute path. Argument 'present' indicates if the segment(s)
  ! must exist i.e. if it should be an error if it(they) is(are) not
  ! found.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: argum_in  ! Segment name
  logical,          intent(in)    :: present   ! Must the segment exist?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  character(len=gtvpath_length) :: argum
  integer :: ia,la,iseg,isegstep,iseg1,iseg2
  logical :: isdir,found,done
  type(gt_directory), pointer :: workdir,father
  type(gt_segment), pointer :: segm
  !
  argum = argum_in
  call sic_upper(argum)
  !
  call decode_chemin(argum,cw_directory,workdir,isdir,segm,found)
  if (isdir) then
    call gtv_message(seve%e,rname,  &
      'Input segment is a directory, use CLEAR DIRECTORY [Name] instead')
    error = .true.
    return
  endif
  !
  ! Found or not found: assume it represents a segment. Parse wildcards,
  ! range and so on
  call gtl_segment_parse(argum,iseg1,iseg2,error)
  if (error) return
  la = len_trim(argum)
  ia = index(argum,':')
  isegstep=1
  if (iseg1.ge.iseg2) isegstep=-1
  !
  done = .false.
  !
  do iseg=iseg1,iseg2,isegstep
    if (iseg.ne.0) then
      write(argum(ia+1:),'(I6)') iseg
      la = ia+6
      call sic_black(argum,la)
      call decode_chemin(argum,cw_directory,workdir,isdir,segm,found)
    else
      found = .false.
    endif
    if (found.and..not.isdir) then
      father => segm%father
      if (associated(segm,father%leaf_last)) then
        ! We will destroy the last segment in the directory. We can
        ! decrease its number of segment used.
        father%segn = father%segn - 1
      endif
      !
      call clear_segment_elem(segm,error)
      if (error)  exit  ! iseg
      done = .true.
    endif
  enddo
  !
  if (error) then
    return
    !
  elseif (done) then
    call gtview('Update')
    !
  elseif (present) then
    call gtv_message(seve%e,rname,'No such segment '//argum_in)
    error = .true.
    return
  endif
  !
end subroutine gt_clear_segment
!
subroutine clear_segment_elem(segm,error)
  use gtv_interfaces, except_this=>clear_segment_elem
  use gtv_buffers
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Cleanly clear the input segment, taking care of the surrounding
  ! chain and pointers in the GTV tree.
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  type(gt_segment), pointer :: segm   ! Segment to clear
  logical,    intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_segment), pointer :: othersegm,previous
  type(gt_directory), pointer :: father
  !
  if (associated(segm,co_segment)) then
    co_segment => null()
    co_segment_data => null()
  endif
  !
  ! Search for the previous segment in the linked list
  father => segm%father
  previous => null()
  othersegm => father%leaf_first
  do while (.not.associated(othersegm,segm))
    previous => othersegm
    othersegm => othersegm%nextseg
  enddo
  !
  call gtv_open_segments_for_writing_from_main()
  !
  ! Update the chain of segments
  if (.not.associated(previous)) then
    ! Segment to destroy is the first in the directory
    father%leaf_first => segm%nextseg  ! ... which can be null()
  else
    previous%nextseg => segm%nextseg ! ... which can be null()
  endif
  !
  ! Update the pointers of the parent directory
  if (associated(father%leaf_last,segm)) then
    ! Segment to destroy is the last in the directory
    father%leaf_last => previous ! ... which can be null()
  endif
  !
  ! Update the limits of the parent directory
  call gtv_limits(father,error)
  !
  call gtv_close_segments_for_writing_from_main()
  !
  ! Free the segment: put it in the stack for later deletion
  segm%nextseg => null()  ! Do not delete its brother
  if (associated(segm))  &
    call x_destroy_segment(segm)  ! will call gtv_delsegments(segm)
  !
end subroutine clear_segment_elem
!
subroutine gtv_clear_all(error)
  use gtv_buffers
  use gtv_interfaces, except_this=>gtv_clear_all
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command:
  !    CLEAR ALL
  ! Clean (i.e. destroy the content of) all the top directories,
  ! leaving them alive, with all their windows.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: keepall
  type(gt_directory), pointer :: brother
  !
  keepall = .true.  ! Keep all window of the cleared directory
  brother => root%son_first
  do while (associated(brother))
    call gt_clear_directory(brother,keepall,error)
    if (error)  return
    !
    brother => brother%brother
  enddo
  !
end subroutine gtv_clear_all
!
subroutine gtv_clear_tree(name_in,error)
  use gildas_def
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtv_clear_tree
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Erases the current tree only. If the current tree is alone,
  ! erases the whole plot, which saves space for the images...
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name_in  ! Tree name
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR TREE'
  character(len=64) :: dirname
  logical :: isdir,found,keepall
  type(gt_directory), pointer :: workdir
  type(gt_segment), pointer :: segm
  integer :: win_num
  !
  if (name_in.eq.' ') then
    workdir => cw_directory
    !
  else
    ! Get the directory
    dirname = name_in
    call sic_upper(dirname)
    call decode_chemin(dirname,cw_directory,workdir,isdir,segm,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,'No such directory '//dirname)
      error = .true.
      return
    endif
    if (.not.isdir) then
      call gtv_message(seve%e,rname,  &
        'Input segment is not a directory, use CLEAR SEGMENT [Name] instead')
      error = .true.
      return
    endif
    ! Protect root
    if (associated(workdir,root)) then
      call gtv_message(seve%e,rname,'Can not delete root directory <')
      error = .true.
      return
    endif
  endif
  !
  ! We will work from the ancestor (i.e. the whole tree)
  workdir => workdir%ancestor
  !
  ! Implicitely move to the ancestor
  win_num = 0
  call gtv_open_segments_for_writing_from_main()
  call cd_by_adr(workdir,win_num,error)
  call gtv_close_segments_for_writing_from_main()
  if (error)  return
  !
  keepall = .false.
  call gt_clear_directory(workdir,keepall,error)  ! Thread-safe
  if (error)  return
  !
end subroutine gtv_clear_tree
!
subroutine gtl_clear_directory(line,error)
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_clear_directory
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command CLEAR DIRECTORY [Name]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=gtvpath_length) :: dirname
  integer(kind=4) :: nc
  logical :: keepall
  !
  if (sic_present(0,2)) then
    ! Clear the named directory
    call sic_ch(line,0,2,dirname,nc,.true.,error)
    if (error) return
    call gtv_clear_directory(dirname,error)
    if (error)  return
  else
    ! Clear current working directory
    keepall = .true.  ! Keep all windows
    call gt_clear_directory(cw_directory,keepall,error)  ! Thread-safe
    if (error)  return
  endif
  !
end subroutine gtl_clear_directory
!
subroutine gtv_clear_directory(name,error)
  use gbl_message
  use gtv_interfaces, except_this=>gtv_clear_directory
  use gtv_buffers
  use gtv_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support for CLEAR DIRECTORY, using a name as input argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  character(len=gtvpath_length) :: uname
  logical :: isdir,found,keepall
  type(gt_directory), pointer :: workdir
  type(gt_segment), pointer :: segm
  !
  ! Get the directory
  uname = name
  call sic_upper(uname)
  call decode_chemin(uname,cw_directory,workdir,isdir,segm,found)
  if (.not.found) then
    call gtv_message(seve%e,rname,'No such directory '//name)
    error = .true.
    return
  endif
  if (.not.isdir) then
    call gtv_message(seve%e,rname,  &
      'Input segment is not a directory, use CLEAR SEGMENT [Name] instead')
    error = .true.
    return
  endif
  !
  keepall = .true.  ! Keep all windows
  call gt_clear_directory(workdir,keepall,error)  ! Thread-safe
  if (error)  return
  !
end subroutine gtv_clear_directory
!
subroutine gt_clear_directory(dir,keepall,error)
  use gbl_message
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>gt_clear_directory
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Cleanly destroy the content of the input directory, taking care of
  ! the surrounding elements in the GTV tree. The top directory and its
  ! first window is kept.
  !---------------------------------------------------------------------
  type(gt_directory), pointer :: dir      ! Directory to destroy
  logical,      intent(in)    :: keepall  ! Keep all the windows, or only one?
  logical,      intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  type(gt_directory), pointer :: son_first,father,nextdir
  type(gt_segment), pointer :: leaf_first
  integer(kind=address_length) :: genv
  !
  ! 1) Check if we do not attempt to clear the root <
  if (associated(dir,root)) then
    call gtv_message(seve%e,rname,'Can not clear root directory')
    error = .true.
    return
  endif
  !
  call gtv_open_segments_for_writing_from_main()
  !
  ! 2) Check if the current working directory has to be destroyed.
  father => cw_directory%father
  do while (associated(father))
    if (associated(father,dir)) then
      ! One of the fathers is the directory to be *cleaned*, i.e. we will
      ! *destroy* the current directory. Switch to the directory to be
      ! cleaned.
      call cd_by_adr(dir,dir%x%curwin,error)
      if (error)  return
      exit
    endif
    father => father%father
  enddo
  !
  ! 3) Which windows keep at first level?
  if (.not.keepall) then
    ! Delete all but 1 window
    call win_destroy_almost(dir,genv,error)
    if (error)  return
    if (genv.ne.0) then
      ! There was actually a window to save
      dir%x%genv_array = c_new_genv_array(mwindows)
      dir%x%genv = genv
      call c_set_win_genv(dir%x%genv_array,0,dir%x%genv)
    endif
  endif
  !
  ! 4) Destroy the windows of all the subdirectories (because these
  !    directories will be destroyed)
  nextdir => dir%son_first
  do while (associated(nextdir))
    call win_destroy_all_recursive(nextdir,error)
    if (error)  return
    nextdir => nextdir%brother
  enddo
  !
  ! 5) Update the pointers in the GTV tree, i.e. forget about the son
  !    directories and leaves
  son_first => dir%son_first  ! Keep track before forgetting it
  dir%son_first => null()
  dir%son_last => null()
  leaf_first => dir%leaf_first  ! Keep track before forgetting it
  dir%leaf_first => null()
  dir%leaf_last => null()
  dir%segn = 0
  !
  ! 6) Update the limits of the parents directory
  call gtv_limits(dir,error)
  !
  call gtv_close_segments_for_writing_from_main()
  !
  ! 7) Effectively destroy the list of son directories. This can be done
  !  out of the threads protection since nobody knows that the input
  !  directory had children one day.
  if (associated(son_first))  &
    call x_destroy_directory(son_first)  ! will call gtv_deldirectories(son_first)
  !
  ! 8) Effectively destroy the list of segments. This can be done out of the
  !  threads protection since nobody knows that the input directory had
  ! segments one day.
  if (associated(leaf_first))  &
    call x_destroy_segment(leaf_first)  ! will call gtv_delsegments(leaf_first)
  !
  ! 9) Update the plot. Only needed from the ancestor cleared directory
  !  (no need to refresh all directories)
  call gtview_update(dir%ancestor,error)
  !
end subroutine gt_clear_directory
!
subroutine exit_clear
  use gtv_interfaces, except_this=>exit_clear
  use gtv_bitmap
  use gtv_buffers
  use gtv_plot
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public
  !  This function exists solely to prevent all the wild machinations
  ! that 'gtv_destroy_all' does in recreating the x graphical
  ! environment, when all you are really trying to do is exit the
  ! program so you can go home. It is therefore only called by program
  ! GreG before calling GTCLOS
  !---------------------------------------------------------------------
  ! Local
  logical :: error
  !
  error = .false.
  !
  ! Flush the stack (it contains the tree destruction, so call it
  ! whatever the device is).
  call x_flush(1)
  !
  if (cw_device%protocol.eq.p_x) then
    ! Clear all the directories (and the allocated data in each:
    ! polylines, images, etc). Put it in the stack to ensure that all the
    ! remaining drawing instructions have been performed.
    if (associated(root))  &
      call x_destroy_directory(root)  ! will call gtv_deldirectories(root)
  else
    call gtv_destroy_all(error)
  endif
  !
  ! Free memory allocated in global variables
  call gt_lut_dealloc(gbl_pen,error)
  call gt_lut_dealloc(gbl_colormap,error)
  !
  if (allocated(eqlev))  deallocate(eqlev,eqbin)
  !
end subroutine exit_clear
!
subroutine gti_clear(output)
  use gtv_interfaces, except_this=>gti_clear
  use gtv_types
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! - Erase the graphic screen only
  ! - Erase all bit planes
  ! - Reset most device features, and should normally be used to be sure
  !   that the initialisation is correct.
  ! - Rewinds the viewing pointers
  !---------------------------------------------------------------------
  type(gt_display) :: output  ! Output instance
  !
  if (.not.awake .or. error_condition) return
  !
  ! Return if no output device
  if (output%dev%protocol.eq.p_null) then
    return
    !
  elseif (output%dev%protocol.eq.p_x) then
    ! X protocol
    if (output%x%graph_env.ne.0)  call x_clear(output%x%graph_env)
    !
  endif
  !
end subroutine gti_clear

subroutine robs(obs,entry_num,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>robs
  use class_common
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Read file header into internal buffer. Then fill into the
  ! observation header the presec section and part of the general
  ! sections, namely the elements coming from the Entry Index:
  !     obs%head%gen%num
  !     obs%head%gen%ver
  !     obs%head%pos%sourc
  !     obs%head%spe%line/obs%head%sky%line
  !     obs%head%gen%teles
  !     obs%head%gen%dobs
  !     obs%head%gen%dred
  !     obs%head%pos%lamof
  !     obs%head%pos%betof
  !     obs%head%pos%system
  !     obs%head%gen%kind
  !     obs%head%gen%qual
  !     obs%head%gen%scan
  !     obs%head%dri%apos
  !     obs%head%gen%subscan
  !----------------------------------------------------------------------
  type(observation),          intent(inout) :: obs        ! Observation header
  integer(kind=entry_length), intent(in)    :: entry_num  ! Index number of observation
  logical,                    intent(out)   :: error      !
  ! Local
  type(indx_t) :: ind
  !
  outobs_modify = .false.
  error = .false.
  !
  ! Read the Entry Title, transfer it in observation
  call rix(entry_num,ind,error)
  if (error) return
  call index_toobs(ind,obs%head,error)
  if (error)  return
  obs%head%gen%ver = abs(obs%head%gen%ver)
  !
  if (filein_isvlm) then
    ! Mimic the entry descriptor
    obs%desc%xnum = entry_num
    obs%desc%ldata = filein_vlmhead%gil%dim(1)
    !
    ! Fill obs%head%presec(:) for VLM
    obs%head%presec(:) = .false.
    obs%head%presec(class_sec_gen_id) = .true.
    obs%head%presec(class_sec_pos_id) = .true.
    obs%head%presec(class_sec_spe_id) = .true.
    obs%head%presec(class_sec_res_id) = filein_vlmhead%gil%reso_words.gt.0
    !
  else
    ! Read the Entry Descriptor
    call class_entrydesc_read('ROBS',filein,ix,entry_num,obs%desc,ibufobs,error)
    if (error)  return
    !
    ! Fill obs%head%presec(:)
    call classic_entrydesc_secfind_all(obs%desc,obs%head%presec,-mx_sec,error)
    if (error)  return
  endif
  !
end subroutine robs
!
subroutine class_entrydesc_read(rname,file,idx,entry_num,ed,bufobs,error)
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_entrydesc_read
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Read the entry descriptor. Class overlay to the Classic subroutine
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: rname      ! Calling routine name
  type(classic_file_t),       intent(in)    :: file       ! Class file
  type(optimize),             intent(in)    :: idx        ! Associated index
  integer(kind=entry_length), intent(in)    :: entry_num  ! Entry number
  type(classic_entrydesc_t),  intent(out)   :: ed         ! Entry descriptor
  type(classic_recordbuf_t),  intent(inout) :: bufobs     ! Working buffer
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=message_length) :: mess
  integer(kind=4) :: ier,vobs_allowed
  !
  if (entry_num.le.0 .or. entry_num.ge.file%desc%xnext) then
    error = .true.
    write(mess,'(A,I0)') 'Non-existant index entry ',entry_num
    call class_message(seve%e,rname,mess)
    return
  endif
  !
  call classic_recordbuf_open(file,idx%bloc(entry_num),idx%word(entry_num),  &
    bufobs,error)
  if (error)  return
  !
  call classic_entrydesc_read(file,bufobs,ed,error)
  if (error)  return
  !
  if (file%desc%version.ne.1 .and. ed%xnum.ne.entry_num) then
    ! Check that xnum in entry descriptor is consistant with the requested
    ! entry number. NB: this has never been checked in V1 files, avoid
    ! rejecting V1 files which were accepted before.
    ! Should we have a way to enforce reading?
    write(mess,'(A,I0,A,I0)')  'Entry number mismatch (malformed file): got ',  &
      ed%xnum,' in entry descriptor, expected ',entry_num
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  vobs_allowed = vobs_stable
  ier = sic_getlog('CLASS_OBS_VERSION',vobs_allowed)
  if (ed%version.gt.vobs_allowed) then
    write (mess,'(A,I0,A)')  &
      'Observation revision number #',ed%version,' not supported'
    call class_message(seve%e,rname,mess)
    call class_message(seve%e,rname,'Your CLASS version is too old to read this spectrum')
    call class_message(seve%e,rname,'Please update CLASS to the latest release')
    error = .true.
    return
  endif
  !
end subroutine class_entrydesc_read
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mobs(obs,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>mobs
  use class_types
  use class_common
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  !  Open an observation of the output file to modify it. The length of
  ! each section modified must be smaller than the length of the
  ! corresponding section already present.
  !  Find the latest version of this obs. in this file
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs    ! Observation header
  logical,           intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MOBS'
  integer(kind=entry_length) :: ifind(10),nf
  !
  if (obs%head%gen%ver.lt.0) then
     call class_message(seve%e,'UPDATE','Can only update last versions')
     error = .true.
     return
  endif
  !
  error = .false.
  !
  call fox(obs%head%gen%num,ifind(1))
  nf = ifind(1)
  if (nf.eq.0) then
     error = .true.
     call class_message(seve%e,rname,'Observation to be modified was not found')
     return
  endif
  !
  ! Read the Entry Descriptor
  call class_entrydesc_read(rname,fileout,ox,ifind(1),obs%desc,obufobs,error)
  if (error)  return
  !
  outobs_modify = .true.
end subroutine mobs
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine cobs(set,obs,error)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>cobs
  use class_common
  use class_index
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  !  Ends the writing of the output observation.
  !  Find the latest version of this observation in the file and
  ! decrease its version number by 32768
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(observation),   intent(inout) :: obs    ! Observation header
  logical,             intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='COBS'
  integer(kind=entry_length) :: ifind(10),nf
  integer(kind=4) :: hver
  character(len=80) :: mess
  type(indx_t) :: ind
  logical :: dupl
  !
  if (obufobs%lun.ne.fileout%lun) then
     error = .true.
     call class_message(seve%e,rname,'Observation not open for write nor modify')
     return
  endif
  !
  if (.not.outobs_modify) then
     if (obs%head%gen%num.lt.0) then
        write(mess,'(A,I0)')  'Invalid observation number ',obs%head%gen%num
        call class_message(seve%e,rname,mess)
        error = .true.
        return
        !
     elseif (obs%head%gen%num.eq.0) then
        ! No specified number, use automatic numbering. Find next one (unused
        ! yet) available.
        call fox_next(obs%head%gen%num)
        !
     elseif (fileout%desc%single) then
        ! ObsNumber must be unique. Find if it is already used
        call fox(obs%head%gen%num,ifind(1))
        if (ifind(1).ne.0) then
          write(mess,'(A,I0,A)') 'Observation #',obs%head%gen%num,' already exists'
          call class_message(seve%e,rname,mess)
          error = .true.
          return
        endif
        !
     else
        ! Multiple versions allowed
        call fox(obs%head%gen%num,ifind(1))
        nf = ifind(1)
        if (nf.ne.0) then
           ! Found a previous observation with the same number
           hver = ox%ver(ifind(1))
           if (hver.gt.0) ox%ver(ifind(1)) = -hver  ! Mark it as "old" if it exists
           call rox(ifind(1),ind,error)
           if (error) return
           ind%ver = ox%ver(ifind(1))
           call mox(ifind(1),ind,error)
           if (hver.lt.0) hver = -hver
           if (error) return
           obs%head%gen%ver = hver
        endif
     endif
     obs%head%gen%ver = abs(obs%head%gen%ver)+1  ! The version number must
       ! increase: each WRITE assumes a difference between the original spectrum
       ! and the one written. Do not reset the number to avoid losing history.
  endif
  !
  ! Set up the Index 'ind'
  call sic_gagdate(obs%head%gen%dred)
  !
  call index_fromobs(obs%head,ind,error)
  if (error)  return
  ind%bloc = obufobs%rstart
  ind%word = obufobs%wstart
  !
  ! Write the Index entry
  if (outobs_modify) then
     call mox(obs%desc%xnum,ind,error)
     ! if (error)... we should have ensured that obufobs is flushed to
     ! the file, else we would have an entry partially updated i.e.
     ! inconsistent. But how can we have an error in mox and not before?
     ! Should never happen.
     if (error)  &
       call class_message(seve%e,rname,'Observation may be incompletely updated')
  else
     call wox(ind,error)
     ! if (error)... not so dramatic since as long the entry index and
     ! the file descriptor are not written/updated, the entry has no
     ! real existence.
     if (.not.error) then
       ! Take care of the sorting arrays
       call ox_sort_add(set,obs,dupl,error)
       if (dupl) then
         ! Undo what WOX has done
         fileout%desc%xnext = fileout%desc%xnext-1
         ox%next = ox%next-1
         if (filein_is_fileout())  ix%next = ix%next-1
       endif
     endif
  endif
  if (error) return
  !
  ! Write the observation header. Must be last since it contains the
  ! observation description e.g. number of blocks.
  if (obs%desc%version.gt.vobs_stable) then
    write (mess,'(A,I0,A)')  &
      'Observation revision number #',obs%desc%version,' is experimental'
    call class_message(seve%w,rname,mess)
  endif
  call classic_entrydesc_write(fileout,obufobs,obs%desc,error)
  if (error)  return
  !
  call classic_entry_close(fileout,obufobs,error)
  if (error)  return
  !
  ! FILE BOTH case
  if (filein_is_fileout()) then
    ! Must force "forgetting" the record currently buffered in ibufobs,
    ! because the same record may have changed on disk
    call classic_recordbuf_nullify(ibufobs)
  endif
  !
  ! Update the file header
  call cox(error)
  !
end subroutine cobs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uvmap_buffers
  use image_def
  use mapping_types
  use uvmap_types
  !------------------------------------------------------------------------
  ! Imaging buffers
  !------------------------------------------------------------------------
  !
  public :: uvmap_buffer
  public :: uvmap_prog,uvmap_default,uvmap_old,uvmap_saved
  public :: selected_fieldsize,selected_fields
  !
  public :: d_min,d_max
  public :: dirty,primbeam,fields
  public :: hbeam
  public :: dbeam
  public :: weight,g_weight,g_v,do_weig
  private
  !
  ! User part
  type(uvmap_par), save :: uvmap_prog,uvmap_default,uvmap_old,uvmap_saved
  !
  ! List of selected fields in UV_MAP (used for UV_RESTORE and
  ! also for SHOW FIELDS)
  integer :: selected_fieldsize=0
  integer, allocatable :: selected_fields(:)
  !
  type uvmap_buffer_user_t
   contains
     procedure, public :: init   => uvmap_buffer_user_init
     procedure, public :: sicdef => uvmap_buffer_user_sicdef
  end type uvmap_buffer_user_t
  type(uvmap_buffer_user_t) :: uvmap_buffer
  !
  ! Prog part
  real :: d_min,d_max ! min max of dirty image
  !
  type(gildas), target, save :: hbeam
  type(mapping_3d_t), target, save :: dirty    ! Dirty cube
  type(mapping_4d_t), target, save :: primbeam ! Primary beam
  type(mapping_4d_t), target, save :: fields   ! Mosaic fields
  !  
  real, allocatable, target, save :: dbeam(:,:,:,:)   ! 4-D
  real, allocatable, target, save :: weight(:,:,:)    ! Mosaic weights 3-D
  !
  real, allocatable, save :: g_weight(:)  ! UV weights
  real, allocatable, save :: g_v(:)       ! V values
  logical, save :: do_weig                ! Optimization of weight computing
  !
contains
  !
  subroutine uvmap_buffer_user_init(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(uvmap_buffer_user_t), intent(out)   :: user
    logical,                    intent(inout) :: error
    !
    call gildas_null(hbeam)
    call gildas_null(dirty%head)
    call gildas_null(primbeam%head)
    call gildas_null(fields%head)
  end subroutine uvmap_buffer_user_init
  !
  subroutine uvmap_buffer_user_sicdef(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(uvmap_buffer_user_t), intent(inout) :: user
    logical,                    intent(inout) :: error
    !
    integer(kind=index_length) :: dim(4) = 0
    !
    ! Initialize
    call uvmap_default%init(error)
    if (error) return
    call uvmap_default%sicdef(error)
    if (error) return
    uvmap_old = uvmap_default
    uvmap_saved = uvmap_old
    !
    ! Dirty Min/Max
    call sic_def_real('D_MAX',d_max,0,0,.false.,error)
    if (error) return
    call sic_def_real('D_MIN',d_min,0,0,.false.,error)
    if (error) return
    !
    ! Old names for compatibility
    !   define logical uv_shift /global
    !   define integer convolution /global
    !   define double uv_cell[2] uv_taper[3] taper_expo /global
    call sic_def_inte('CONVOLUTION',uvmap_old%ctype,0,0,.false.,error)
    if (error) return
    call sic_def_logi('UV_SHIFT',uvmap_old%shift,.false.,error)
    if (error) return
    call sic_def_char('WEIGHT_MODE',uvmap_old%mode,.false.,error)
    if (error) return
    dim = [2,0,0,0]
    call sic_def_real('UV_CELL',uvmap_old%uniform(1),1,dim,.false.,error)
    if (error) return
    dim = [3,0,0,0]
    call sic_def_real('UV_TAPER',uvmap_old%taper,1,dim,.false.,error)
    if (error) return
    call sic_def_real('TAPER_EXPO',uvmap_old%taper(4),0,0,.false.,error)    
  end subroutine uvmap_buffer_user_sicdef
end module uvmap_buffers
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine mrtindex_init(error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_init
  use mrtindex_vars
  !----------------------------------------------------------------------
  ! @ public
  ! MRTINDEX Initialization
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  ! Pre-reserved logical units for index files
  if (sic_getlun(ix_lun).ne.1) then
    error = .true.
    return
  endif
  if (sic_getlun(ox_lun).ne.1) then
    error = .true.
    return
  endif
  !
  call classic_init(error)
  if (error)  return
  !
end subroutine mrtindex_init
!
subroutine mrtindex_exit(error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_exit
  use mrtindex_vars
  !----------------------------------------------------------------------
  ! @ public
  ! MRTINDEX Cleaning on exit
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  ! LIST /TOC support structure:
  call mrtindex_toc_clean(error)
  !
  ! Deallocate read-write buffers used for Index file
  call mrtindex_ix_close(error)  ! Before free_ix_dirs
  call sic_frelun(ix_lun)
  call sic_frelun(ox_lun)
  call free_ix_dirs(error)
  !
  call deallocate_recordbuf(obufobs,error)
  call deallocate_recordbuf(obufbi,error)
  call deallocate_recordbuf(ibufobs,error)
  call deallocate_recordbuf(ibufbi,error)
  !
end subroutine mrtindex_exit

subroutine clic_monitor(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_index
  !---------------------------------------------------------------------
  ! Command MONITOR
  ! It processes CAL scans as encountered, to deduce the atmospheric
  ! parameters from the monitor at 230 GHz (receiver 2, in fact).
  ! Monitor time 0|1
  ! time defaults to 1 h ; 0 means each interval is one scan
  ! 0 for constant, 1 for linear fit to the atm power data.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: end, do_write
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length)    :: ldata_in 
  integer(kind=entry_length)   :: k,kx,kxsave,kx1,kx2
  integer :: ia,izero, it
  integer :: save_mon(matmon), s_scan
  character(len=12) :: source1,ch
  real*8 :: interval, mininterval, t_old, t_now, dt
  !      PARAMETER (MININTERVAL=55.0D0)
  parameter (mininterval=10.0d0)
  integer :: chop, cold, sky, mes, i
  parameter (chop=1, cold=2, sky=3)
  real*8 :: st(3), st2(3), sw(3), t0(3,mnant), t1(3,mnant), dn
  real*8 :: sy(3,mnant), syt(3,mnant)
  real*8 :: times(m_cx)
  real :: test
  !
  ! probably not useful here 18-oct-1999
  save save_mon, s_scan
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  do_write = .not.sic_present(3,0)
  if (do_write) then
    call check_output_file(error)
    if (error) return
    call check_equal_file(error)
    if (error) return
  endif
  !
  ! default 1 hour
  ! Monitor 0 : use average of scan as reference
  !
  interval = 3600.0d0
  call sic_r8(line,0,1,interval,.false.,error)
  interval = max(mininterval,interval)
  !
  ideg = 0
  call sic_i4(line,0,2,ideg,.false.,error)
  ideg = max(0,ideg)
  ideg = min(1,ideg)
  !
  ! Loop on current index
  call get_first(.true.,error)
  if (error) return
  do i=1, mnant
    r_ccold_mon(i) = 0
    r_cchop_mon(i) = 0
    r_csky_mon(i) = 0
  enddo
  call r4tor4(r_nrec_mon,save_mon,matmon)
  !
  ! Get storage and data
  call get_data (ldata_in,data_in,error)
  if (error) return
  ! Decode average data record header:
  kin = gag_pointer(data_in,memory) + r_ndump*r_ldump
  call decode_header (memory(kin))
  source1 = r_sourc
  do i=1, 3
    sw(i) = 0
    st(i) = 0
    st2(i) = 0
  enddo
  do ia = 1, r_nant
    do i=1, 3
      sy(i,ia) = 0
      syt(i,ia) = 0
    enddo
  enddo
  izero = dh_obs
  t_now = mod(dh_utc+86400d0-dh_integ/2.d0,86400d0)
  t_old = t_now
  times(knext) = 0
  kx1 = knext
  kx2 = knext
  end = .false.
  do while (.not.end)
    !
    ! Process
    mes = 0
    if (r_proc.eq.p_cal .and. r_scaty.eq.4) then
      mes = chop
    elseif (r_proc.eq.p_cal .and. r_scaty.eq.7) then
      mes = cold
    elseif (r_proc.ne.p_pass) then
      mes = sky
    endif
    if (mes.ne.0) then
      dt = t_now-t_old
      do ia=1, r_nant
        sy(mes,ia) = sy(mes,ia)+dh_test1(2,ia)*dh_integ
        syt(mes,ia) = syt(mes,ia)+dh_test1(2,ia)*dt*dh_integ
      enddo
      st(mes) = st(mes)+dt*dh_integ
      st2(mes) = st2(mes)+dt**2*dh_integ
      sw(mes) = sw(mes)+dh_integ
    endif
    !
    ! Next observation
    if (sic_ctrlc()) then
      error = .true.
      return
    endif
    kx2 = knext
    error = .false.
    s_scan = r_scan
    call get_next(end, error)
    if (error) return
    !
    ! Get storage and data
    call get_data (ldata_in,data_in,error)
    if (error) return
    kin = gag_pointer(data_in,memory) + r_ndump*r_ldump
    call decode_header (memory(kin))
    it = dh_obs-izero
    t_now = dble(it)*86400d0   &
      +mod(dh_utc-dh_integ/2.+86400d0,86400d0)
    times(knext) = t_now-t_old
    !
    ! Write the data if period has elapsed:
    if (end .or. (r_scan.ne.s_scan .and. ((r_sourc.ne.source1)   &
      .or. (dabs(t_old-t_now).ge.interval)))) then
      !
      ! Compute the regression coefficients
      do i=1, 3
        dn = st2(i)*sw(i)-st(i)**2
        if (dn.ne.0 .and. ideg.eq.1) then
          do ia = 1,r_nant
            t1(i,ia)=(syt(i,ia)*sw(i)-sy(i,ia)*st(i))/dn
            t0(i,ia)=-(syt(i,ia)*st(i)-sy(i,ia)*st2(i))/dn
          enddo
        elseif (sw(i).ne.0) then
          do ia = 1,r_nant
            t1(i,ia)=0
            t0(i,ia)=sy(i,ia)/sw(i)
          enddo
        else
          do ia = 1,r_nant
            t1(i,ia)=0
            t0(i,ia)=0
          enddo
        endif
      enddo
      !
      if (sw(chop).eq.0 .and. interval.gt.mininterval) then
        write(ch,'(i4,a4,i4)')   &
          ix_scan(cx_ind(kx1)),' to ',ix_scan(cx_ind(kx2))
        call message(8,2,'MONITOR   ',   &
          'Uncalibrated monitor data scans '//ch(1:12))
      endif
      !
      ! reset the counters
      do i=1, 3
        sw(i) = 0
        st(i) = 0
        st2(i) = 0
      enddo
      do ia = 1, r_nant
        do i=1, 3
          sy(i,ia) = 0
          syt(i,ia) = 0
        enddo
      enddo
      kxsave = r_xnum
      do k = kx1, kx2
        kx = cx_ind(k)
        call get_it(kx, error)
        if (r_proc.eq.p_cal .and. r_scaty.eq.5) then
          do ia=1,r_nant
            test  = t1(chop,ia)*times(k)+t0(chop,ia)
            if (test.gt.0) r_cchop_mon(ia)=test
            r_ccold_mon(ia) = t1(cold,ia)*times(k)+t0(cold,ia)
          enddo
          error = .false.
          call do_monitor (.false.,error)
          do i=1, mnant
            r_ccold_mon(i) = 0
          enddo
          if (.not.error)   &
            call r4tor4(r_nrec_mon,save_mon,matmon)
        else
          call r4tor4(save_mon,r_nrec_mon,matmon)
        endif
        do ia=1,r_nant
          r_csky_mon(ia)=t1(sky,ia)*times(k)+t0(sky,ia)
        enddo
        if (do_write) then
          call write_scan (.false.,error)
          if (error) return
        endif
      enddo
      ! after writing, reload the next scan
      if (.not.end) then
        call get_it(kxsave, error)
        kx1 = knext
        kx2 = knext
        t_old = t_now
        times(knext) = 0
        source1 = r_sourc
      endif
    endif
  enddo
  !
  return
end subroutine clic_monitor
!
subroutine do_monitor (again,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! The chopper standard program is called for each antenna,
  ! in the mode selected in OBS.
  !---------------------------------------------------------------------
  logical :: again                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_proc_par.inc'
  ! Local
  integer :: ia, ntrec
  real :: frs, fri, fro, awater, prec_water
  character(len=160) :: ch
  integer :: mode_au, mode_tr, ilevel
  character(len=4) :: cmode(mnant)
  character(len=2) :: chcode
  !------------------------------------------------------------------------
  ! Code:
  call chtoby('AU  ',mode_au,4)
  call chtoby('TR  ',mode_tr,4)
  ! Force input values if desired
  ilevel = 1
  if (r_proc.eq.p_cal) ilevel=6
  do ia = 1, r_nant
    !
    ! Water
    if (atm_mode(ia).eq.'AUTO') then
      if (atm_water.eq.0) then
        r_h2o_mon(ia) =  prec_water(r_tamb,r_humid)
      elseif (atm_water.gt.0) then
        r_h2o_mon(ia) = atm_water
      endif
      r_cmode_mon(ia) = mode_au
    elseif (atm_mode(ia).eq.'TREC') then
      if (atm_trec(ia).gt.0) then
        r_trec_mon(ia) = atm_trec(ia)
      endif
      r_cmode_mon(ia) = mode_tr
    endif
    !
    ! Gain Image
    if (atm_gim(ia).gt.0) then
      r_gim_mon(ia) = atm_gim(ia)
    endif
    write(cmode(ia),'(a2)')  chcode(r_cmode_mon(ia))
  enddo
  ! Get continuum measurement
  frs = r_frs_mon/1000.
  fri = r_fri_mon/1000.
  fro = r_flo1/1000.
  !
  ! TREC antennas
  ntrec = 0
  awater = 0
  do ia=1, r_nant
    !         print *, 'ia, cmode(ia), R_CMODE_MON(IA)',
    !     $        ia, cmode(ia), R_CMODE_MON(IA)
    if (cmode(ia).eq.'TR') then
      error = .false.
      call chopper_mon (cmode(ia), r_el, frs, fri, r_tamb,   &
        r_pamb, r_alti, r_feff_mon(ia),   &
        r_tchop_mon(ia), r_tcold_mon(ia), r_trec_mon(ia),   &
        r_gim_mon(ia), r_csky_mon(ia), r_cchop_mon(ia),   &
        r_ccold_mon(ia), r_tsys_mon(ia), r_tem_mon(ia),   &
        r_h2o_mon(ia), r_tatms_mon(ia), r_tatmi_mon(ia),   &
        r_taus_mon(ia), r_taui_mon(ia),   &
        again,fro, r_path_mon(ia), r_dpath_mon(ia), error)
      if (.not.again) then
        write(ch,1000) r_kant(ia),   &
          chcode(r_cmode_mon(ia)), r_h2o_mon(ia),   &
          r_trec_mon(ia), r_tsys_mon(ia), r_tem_mon(ia),   &
          r_dpath_mon(ia)
        call message(ilevel,1,'MONITOR   ',ch(1:lenc(ch)))
      endif
      if (.not.error) then
        awater = awater+r_h2o_mon(ia)
        ntrec = ntrec+1
      endif
    endif
  enddo
  if (ntrec.gt.0) awater = awater / ntrec
  !
  ! Then other modes
  do ia = 1, r_nant
    if (r_cmode_mon(ia).eq.mode_au) then
      if (ntrec.gt.0) r_h2o_mon(ia) = awater
    endif
    if (cmode(ia).ne.'TR' .and. cmode(ia).ne.'NO') then
      error = .false.
      call chopper_mon (cmode(ia), r_el, frs, fri, r_tamb,   &
        r_pamb, r_alti, r_feff_mon(ia),   &
        r_tchop_mon(ia), r_tcold_mon(ia), r_trec_mon(ia),   &
        r_gim_mon(ia), r_csky_mon(ia), r_cchop_mon(ia),   &
        r_ccold_mon(ia), r_tsys_mon(ia), r_tem_mon(ia),   &
        r_h2o_mon(ia), r_tatms_mon(ia), r_tatmi_mon(ia),   &
        r_taus_mon(ia), r_taui_mon(ia),   &
        again,fro, r_path_mon(ia), r_dpath_mon(ia), error)
      if (.not.again) then
        write(ch,1000) r_kant(ia),   &
          chcode(r_cmode_mon(ia)), r_h2o_mon(ia),   &
          r_trec_mon(ia), r_tsys_mon(ia), r_tem_mon(ia),   &
          r_dpath_mon(ia)
        call message(ilevel,1,'MONITOR   ',ch(1:lenc(ch)))
      endif
    endif
  enddo
  !
  return
1000 format('A',i1,1x,a2,' H2O=',f6.2,' Tr=',f5.1,   &
    ' Tsys=',f5.1,' Tem=',f5.1,' Dpath=',f6.3)
end subroutine do_monitor
!
subroutine chopper_mon (cmode, el, frs, fri, tamb, pamb, alti,   &
    feff, tchop, tcold, trec, gim, csky, cchop, ccold,   &
    tsysd, tem, h2o, tatms, tatmi, taus, taui,   &
    again, fro, path, dpath, error)
  use gkernel_interfaces
  use atm_interfaces_public
  !---------------------------------------------------------------------
  ! CLIC
  !	compute TCAL, TSYS, TREC, from the chop and atm values observed
  !	according to the usual chopper method (Ulich and Haas)
  !
  !	Double side band operation
  !
  !	_ If cmode is 'AU' and a cold load is available, or if cmode
  !	is 'TR', derive the sky emission TEMI from the receiver
  !	temperature TREC, and then H2O from the best model fitting.
  !	_ Else, if cmode is 'AU', the sky emission is computed from
  !	the given H2O,
  !       _ if cmode is 'MA', the sky emission is computed from the
  !       given opacities and atmospheric temperatures.
  !
  !  	Uses a curved atmosphere, equivalent height 5.5 KM
  !
  !	FRS, FRI   I	R Frequencies signal image in GHz (!!!)
  !       tamb       I    R Ambient temperature (K)
  !       pamb       I    R Ambient pressure (mbar)
  !       alti       I    R altitude in km
  !       FEFF       I    R Forward Eff
  !       BEFF       I    R Beam Eff
  !       TCHOP      I    R Ambient Load Temperature (K)
  !       TCOLD      I    R Cold  Load Temperature (K)
  !       GIM        I    R Image/Signal Gain ratio
  !       CCHOP      I    R Ambient Load Counts
  !       CSKY       I    R Sky Counts
  !       CCOLD      I    R Cold  Load Counts
  !	TREC       I/O  R Receiver dsb temperature (K)
  !	TSYSD 	   O    R DSB system temperature (K)
  !       H2O        O    R Water vapor content (mm)
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  !
  character(len=2) :: cmode         !
  real :: el                        !
  real :: frs                       !
  real :: fri                       !
  real :: tamb                      !
  real :: pamb                      !
  real :: alti                      !
  real :: feff                      !
  real :: tchop                     !
  real :: tcold                     !
  real :: trec                      !
  real :: gim                       !
  real :: csky                      !
  real :: cchop                     !
  real :: ccold                     !
  real :: tsysd                     !
  real :: tem                       !
  real :: h2o                       !
  real :: tatms                     !
  real :: tatmi                     !
  real :: taus                      !
  real :: taui                      !
  logical :: again                  !
  real :: fro                       !
  real :: path                      !
  real :: dpath                     !
  logical :: error                  !
  ! Global
  real*8 :: air_mass
  ! Local
  real :: dtem, airmas, tatm, taut, dwater, err, deltaw
  real :: temis, temii, tsky, temi, t1, t2, h2o1, path1
  real :: h2o2, path2, tem1, tem2, t3, t4
  integer :: k, ier, lc
  character(len=80) :: chain
  !------------------------------------------------------------------------
  error = .false.
  ier = 0
  airmas = air_mass(el)
  !
  if (again) goto 500
  !
  ! Check for Really bad atmosphere
  if (csky.ge.cchop) then
    write(chain,1000) csky, cchop
1000 format('Bad Atmosphere: SKY=',1pg11.4,'; CHOP=',1pg11.4)
    lc = lenc(chain)
    call message (8,3,'CHOPPER_MON',chain(1:lc))
    error = .true.
    return
  endif
  if (ccold.ge.cchop) then
    call message (8,3,'CHOPPER_MON',   &
      'Signal stronger on COLD than on CHOPPER')
    error = .true.
    return
  endif
  !
  ! AUTO mode with cold load or fixed TREC : minimize for water vapor
  ! content
  if ((cmode.eq.'AU' .and. ccold.gt.0)   &
    .or. cmode.eq.'TR') then
    if (atm_interpolate) then
      call atm_atmosp_i (tamb, pamb, alti)   ! press at 2550m
    else
      call atm_atmosp (tamb, pamb, alti)   ! press at 2550m
    endif
    ! use a reasonable starting value
    h2o = min(10.,max(0.5,h2o))
    !
    ! cold load available: compute TREC
    if (ccold.ne.0) then
      trec = (tcold*cchop - tchop*ccold ) / (ccold-cchop)
    endif
    !
    ! Compute TSKY: antenna temperature on sky
    tsky = (tchop+trec) *csky/cchop-trec
    !
    ! And TEMI: brightness temperature of sky
    temi = (tsky - (1.-feff)*tamb) / feff
    err = 1e10
    dwater = .02
    k = 0
10  continue
    k = k + 1
    if (atm_interpolate) then
      call atm_transm_i (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      taus = t1 + t2
      call atm_transm_i (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
      taui = t1 + t2
      tem = (temis + temii*gim) / (1.+gim)
      call atm_transm_i (h2o+dwater,airmas,frs,temis,   &
        tatm, t1, t2, taut,ier)
      call atm_transm_i (h2o+dwater, airmas, fri,temii,   &
        tatm, t1, t2, taut,ier)
    else
      call atm_transm (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      taus = t1 + t2
      call atm_transm (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
      taui = t1 + t2
      tem = (temis + temii*gim) / (1.+gim)
      call atm_transm (h2o+dwater,airmas,frs,temis,   &
        tatm, t1, t2, taut,ier)
      call atm_transm (h2o+dwater, airmas, fri,temii,   &
        tatm, t1, t2, taut,ier)
    endif
    dtem = (temis + temii*gim) / (1.+gim) - tem
    err = tem - temi
    if (abs(err) .ge. 0.1 .and. dtem.ne.0 .and. k.le.10) then
      deltaw = dwater * err / dtem
      if(abs(dwater).ge.abs(deltaw/10.)) dwater = deltaw/10.
      ! limit optical depth to [0.01,~20]
      h2o = max(0.01,min(h2o-deltaw,   &
        20.*h2o/max(taus,taui)/airmas))
      goto 10
    endif
    if (atm_interpolate) then
      call atm_transm_i  (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      call atm_transm_i  (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
    else
      call atm_transm  (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      call atm_transm  (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
    endif
    taus = t1 + t2
    taui = t1 + t2
    tem = (temis + temii*gim) / (1.+gim)
  elseif (cmode .eq. 'AU') then
    !
    ! Auto Mode without cold load, or when the water vapor content is known
    if (atm_interpolate) then
      call atm_atmosp_i (tamb, pamb, alti)   ! press at 2550m
      call atm_transm_i (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      call atm_transm_i (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
    else
      call atm_atmosp (tamb, pamb, alti)   ! press at 2550m
      call atm_transm (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      call atm_transm (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
    endif
    taus = t1 + t2
    taui = t1 + t2
    tem = (temis + temii*gim) / (1.+gim)
    tsky = (1.-feff)*tamb + feff*tem
  !
  ! Manual Mode
  elseif (cmode.eq.'MA') then
    temis = tatms * (1.-exp(-taus*airmas))
    temii = tatmi * (1.-exp(-taui*airmas))
    tem = (temis + temii*gim) / (1.+gim)
    tsky = (1.-feff)*tamb + feff*tem
  else
    call message(8,4,'CHOPPER_MON','Invalid mode '//cmode)
    error = .true.
    return
  endif
  !
  ! Compute TREC
  if (cmode.ne.'TR') then
    trec = (csky*tchop - tsky*cchop) / (cchop-csky)
  endif
  !
  ! Compute TSYSD
  tsysd = (trec+tsky)/feff
  tsysd = max(min(1e10,tsysd),0.)
  !
  ! Get pathlength (in mm.)  and difference at observing frequency
  !
500 call atm_atmosp_i (tamb, pamb, alti)
  call atm_path_i(h2o,airmas,fro,path,ier)
  path = path*10.
  !
  h2o1 = h2o-0.1
  call atm_path_i(h2o1,airmas,fro,path1,ier)
  path1 = path1*10.
  call atm_transm_i (h2o1,airmas,frs,temis,t3,t1,t2,t4,ier)
  call atm_transm_i (h2o1,airmas,fri,temii,t3,t1,t2,t4,ier)
  tem1 = (temis + temii*gim)/(1.+gim)
  !
  h2o2 = h2o+0.1
  call atm_path_i(h2o2,airmas,fro,path2,ier)
  path2 = path2*10.
  call atm_transm_i (h2o2,airmas,frs,temis,t3,t1,t2,t4,ier)
  call atm_transm_i (h2o2,airmas,fri,temii,t3,t1,t2,t4,ier)
  tem2 = (temis + temii*gim)/(1.+gim)
  !
  dtem = tem2 - tem1
  if (dtem.ne.0) then
    dpath = (path2-path1) / dtem
  else
    dpath = path
  endif
  return
end subroutine chopper_mon

subroutine class_set_command(set,line,r,error)
  use phys_const
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces
  use class_setup_new
  use class_index
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ no-interface (intent IN/INOUT problems)
  ! SET Something [value1, value2, ...] [/NOCURSOR] [/DEFAULT] [/POLYGON]
  !
  !     ACTION      I[ndex]     O[bservation]
  !     ALIGN       V[elocity]  C[omposite]
  !                 F[requency] I[ntersect]
  !                 C[hannel]
  !                 P[osition]
  !     ANGLE       DEG[re]
  !                 MIN[ute]
  !                 SEC[ond]
  !                 MAS[econd]
  !                 RAD[ian]
  !     BAD         A[nd]
  !                 O[r]
  !     BASE        degree
  !                 S[inus]
  !     BOX         L[andscape]
  !                 P[ortrait]
  !                 S[quare]
  !                 Xmin Xmax Ymin Ymax
  !     CALIBRATION Tolerance
  !     CHARACTER   size                    **
  !     CHASE_NAN   ON|OFF
  !     [NO]CHECK   [SOURCE|POSITION|OFFSET|LINE|SPECTROSCOPY|CALIBRATION|SWITCHING]
  !     DEFAULT     [Filename]
  !     DROP        LowEnd  HighEnd
  !     ENTRY       First Last
  !     EXTENSION   chain
  !     FIND        UPDATE | NOUPDATE
  !     FITS        BITS | MODE  Value
  !     FONT        S[implex]               **
  !                 D[uplex]
  !     FORMAT      L[ong]
  !                 B[rief]
  !                 F[ull]
  !     FREQUENCY   Value1 [Value2] [SIGNAL|IMAGE]
  !     LEVEL       level  (OBSOLETE, SB 02-jun-2008)
  !     LINE        NAME
  !     MASK        N[one]
  !                 Vmin1,Vmax1,Vmin2,Vmax2,....
  !     [NO]MATCH   tolerance
  !     MODE        X | Y | Z | BOTH [ T[otal] | A[uto] ] AMIN,AMAX
  !     NUMBER      MIN,MAX
  !     OBSERVATORY Observatory [Longitude Latitude Altitude]
  !     OBSERVED    OMIN,OMAX
  !     OFFSET      OFF1,OFF2
  !     PAGE        L[andscape]
  !                 P[ortrait]
  !                 S[quare]
  !                 Xmin Xmax Ymin Ymax
  !     POSANGLE    Amin Amax
  !     PLOT        N[ormal]  H[istogram]  P[oint]
  !     RANGE       W[est] E[ast] S[outh] N[orth]
  !     REDUCED     RMIN,RMAX
  !     SCALE       *|Code
  !     SCAN        scan1 scan2
  !     SUBSCAN     sub1 sub2
  !     SIZE        X LENGTH
  !                 Y LENGTH
  !     SORT        keywords
  !     SOURCE      NAME
  !     SYSTEM      E[quatorial] [Equinox]
  !                 G[alactic]
  !                 A[uto]
  !     TELESCOPE   NAME
  !     TICK        size
  !     TYPE        Continuum
  !                 Spectroscopy
  !     UNIQUENESS  YES|NO
  !     UNIT        Xlow Xup
  !                (C[hannel] V[elocity] F[requency] I[mage] A[ngle])
  !     VARIABLE    Section [READ|WRITE|OFF]
  !     VELOCITY    L[sr]
  !                 H[eliocentric]
  !                 A[utomatic]
  !     WEIGHT      T[emps]
  !                 S[igma]
  !                 E[qual]
  !     WINDOW      N[one]
  !                 A[uto]
  !                 Vmin1,Vmax1,Vmin2,Vmax2,....
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(inout) :: line   ! Input command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: proc='SET'
  character(len=256) :: line2
  character(len=*), parameter :: backslash=char(92)
  integer(kind=4), parameter :: mini2=-32768
  integer(kind=4), parameter :: maxi2=32767
  real(kind=4), parameter :: epsr4=1e-7
  logical :: found
  integer(kind=4) :: dummy,i,nkey,nl,long,na,n1,n2,nc
  real(kind=4) :: xx,any,dummyr4
  real(kind=8) :: dummyr8,lonlat(2),fangle
  character(len=40) :: argum,argum1,argum2
  character(len=12) :: keyword,angle
  character(len=80) :: mess
  ! Command line
  integer(kind=4), parameter :: optnocur=1
  integer(kind=4), parameter :: optdefau=2
  integer(kind=4), parameter :: optpolyg=3
  integer(kind=4), parameter :: optvaria=4
  integer(kind=4), parameter :: optassoc=5
  logical :: dodefault,dopolygon,dovariable,doassoc
  ! Data
  integer(kind=4), parameter :: mvocab=55  ! Size of SET vocabulary
  integer(kind=4), parameter :: ntype=6    ! Size of TYPE vocabulary
  character(len=12) :: vocab(mvocab),vocab_type(ntype)
  character(len=3) :: vocab_yesno(2)
  data vocab / &
    'ACTION',      'ALIGN',      'ANGLE',     'BAD',        'BASELINE',  &
    'BOX_LOCATION','CALIBRATION','CHARACTER', 'CHASE_NAN',  'CHECK',     &
    'DEFAULT',     'DROP',       'ENTRY',     'EXTENSION',  'FIND',      &
    'FITS',        'FONT',       'FORMAT',    'FREQUENCY',  'LEVEL',     &
    'LINE',        'MAP',        'MASK',      'MATCH',      'MODE',      &
    'NOCHECK',     'NOMATCH',    'NUMBER',    'OBSERVATORY','OBSERVED',  &
    'OFFSET',      'ORIENTATION','PAGE',      'PLOT',       'POSANGLE',  &
    'QUALITY',     'RANGE',      'REDUCED',   'SCALE',      'SCAN',      &
    'SORT',        'SOURCE',     'SUBSCAN',   'SYSTEM',     'TELESCOPE', &
    'TICKSIZE',    'TYPE',       'UNIQUENESS','UNIT',       'VARIABLE',  &
    'VELOCITY',    'VERBOSE',    'VIRTUAL',   'WEIGHT',     'WINDOW'/
  data vocab_type /'ANY','CONTINUUM','LINE','ONOFF','SPECTROSCOPY','SKYDIP'/
  data vocab_yesno / 'YES','NO' /
  character(len=9), parameter :: data_plot(3) =   &
    (/ 'NORMAL   ','HISTOGRAM','POINT    ' /)
  character(len=*), parameter :: none='NONE'
  character(len=*), parameter :: auto='AUTO'
  !
  ! Decode command line
  !
  call chtoby('ANY ',any,4)
  dodefault  = sic_present(optdefau,0)
  dopolygon  = sic_present(optpolyg,0)
  dovariable = sic_present(optvaria,0)
  doassoc    = sic_present(optassoc,0)
  if (dopolygon.and.dovariable .or.  &
      dopolygon.and.doassoc    .or.  &
      doassoc.and.dovariable) then
     call class_message(seve%e,proc,'/POLYGON, /VARIABLE and /ASSOCIATED are incompatible')
     error = .true.
     return
  endif
  !
  call sic_ke (line,0,1,argum,nc,.true.,error)
  if (error) return
  i = 1
  found = .false.
  do while(.not.found)
     if (argum(1:nc).eq.vocab(i)(1:nc)) then
        found = .true.
     elseif (i.eq.mvocab.and..not.found) then
        ! Search a GREG command
        nc = index(line,'SET')
        ! command line sent to GreG
        call gr_exec1(line(nc:))
        error = gr_error()
        return
     endif
     i = i+1
     if (i.gt.mvocab) found = .true.
  enddo
  nc = index(line,'SET')
  call sic_ambigs('SET',argum,keyword,nkey,vocab,mvocab,error)
  if (error) return
  !
  select case (keyword)
  case('ALIGN')
     set%align = 'C'
     call sic_ke (line,0,2,set%align,nc,.false.,error)
     if (error) return
     set%alig2 = 'I'
     call sic_ke (line,0,3,set%alig2,nc,.false.,error)
     if (error) return
     if (set%kind.eq.kind_spec) then
       error = set%align.ne.'C' .and. set%align.ne.'F' .and.  &
               set%align.ne.'V'
     elseif (set%kind.eq.kind_cont) then
       error = set%align.ne.'C'.and.set%align.ne.'P'
     else
       call class_message(seve%e,'SET ALIGN','Unsupported kind of data')
       error = .true.
       return
     endif
     error = error .or. set%alig2.ne.'I'.and.set%alig2.ne.'C'
     if (error) then
        mess = 'Invalid align type '//set%align//' '//set%alig2
        call class_message(seve%w,proc,mess)
        set%align = 'C'
        set%alig2 = 'I'
     endif
     !
  case('ANGLE')
     argum1 = 'SEC'
     call sic_ke(line,0,2,argum1,nc,.false.,error)
     if (error) return
     call set_angle_factor('SET ANGLE',argum1,angle,fangle,error)
     if (error)  return
     call class_setup_put_angle(angle,error)
     if (error)  return
     call class_setup_put_fangle(fangle,error)
     if (error)  return
     call set_angle(set,r%head)  ! Apply new conversion factor where needed
     !
  case('BASELINE')
     argum1 = '1'
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     if (argum1(1:1).eq.'S') then
        set%base  = -1
     else
        call sic_i4 (line,0,2,set%base,.false.,error)
        if (error) return
        if (set%base.gt.mdeg) then
          write(mess,'(A,I0,A,I0,A)')  &
            'Degree ',set%base,' truncated to ',mdeg,' (maximum allowed)'
          call class_message(seve%w,proc,mess)
          set%base = mdeg
        elseif (set%base.lt.0) then
          write(mess,'(A,I0,A)')  'Degree ',set%base,' forced to 0'
          call class_message(seve%w,proc,mess)
          set%base = 0
        endif
     endif
     !
  case('SYSTEM')
     argum1 = 'A'
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     if (argum1(1:1).eq.'A') then
        set%coord = 0
     elseif (argum1(1:1).eq.'E') then
        set%coord = type_eq
        call sic_r4(line,0,3,set%equinox,.false.,error)
        if (error) then
          call class_message(seve%e,proc,'Invalid equinox')
          return
        endif
     elseif (argum1(1:1).eq.'G') then
        set%coord = type_ga
     else
        mess = 'Invalid system '//argum1
        call class_message(seve%w,proc,mess)
        set%coord = 0
     endif
     if (r%head%xnum.ne.0) then
       ! Convert current R spectrum, if any
       call convert_pos(set,r%head,error)
       if (error)  return
     endif
     !
  case('DEFAULT')
     call las_setdef(set,error)
     !
  case('ENTRY')
     call parse_minmax8(line,set%entr1,set%entr2,error)
     if (error)  return
     !
  case('FORMAT')
     call setfor(set,line,error)
     !
  case('FREQUENCY')
     call setfrequency('SET FREQUENCY',line,0,2,set%freqmin,set%freqmax,  &
       set%freqsig,error)
     !
  case('LINE')
     set%line = '*'
     call sic_ch(line,0,2,set%line,nc,.false.,error)
     if (error) return
     call sic_upper(set%line)
     !
  case('MASK')
     set%nmask = 0
     argum1 = ' '
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     if (argum1(1:1).ne.'N') then
       call setregion(set,line,mmask1,set%nmask,set%mask1,set%mask2,'MASK',error)
       if (error)  return
     endif
     !
  case('MATCH')  ! SET MATCH [Tol [Unit]]
     argum1 = ' '
     call sic_ch(line,0,2,argum1,nc,.false.,error)
     if (error) return
     argum2 = ' '  ! Default current angle unit
     call sic_ke(line,0,3,argum2,nc,.false.,error)
     if (error)  return
     !
     if (argum1.eq.' ') then
       set%tole = 2.e0*rad_per_sec  ! Same as in 'setdef'
     else
       call coffse(set,'SET MATCH',argum1,argum2,set%tole,error)
       set%tole = abs(set%tole)
     endif
     set%match = .true.
     cx%cons%off%done = .false.  ! Reset Offset consistency of index
     !
  case('MODE')
     call setmod(set,line,r,error)
     return
     !
  case('NOMATCH')
     set%match = .false.
     cx%cons%off%done = .false.  ! Reset Offset consistency of index
     !
  case('NUMBER')
     call parse_minmax8(line,set%nume1,set%nume2,error)
     if (error)  return
     !
  case('OBSERVATORY')
     call sic_ke(line,0,2,set%obs_name,nc,.true.,error)
     if (error)  return
     if (set%obs_name.eq.'*') then
       set%obs_long = 0.d0  ! Unused if name is *
       set%obs_lati = 0.d0  ! Unused if name is *
       set%obs_alti = 0.d0  ! Unused if name is *
     elseif (sic_present(0,3)) then
       ! Explicit lon-lat-alti values
       call sic_ch(line,0,3,argum1,nc,.true.,error)
       if (error)  return
       call sic_sexa(argum1,nc,set%obs_long,error)
       if (error)  return
       call sic_ch(line,0,4,argum2,nc,.true.,error)
       if (error)  return
       call sic_sexa(argum2,nc,set%obs_lati,error)
       if (error)  return
       call sic_r8(line,0,5,set%obs_alti,.true.,error)
       if (error)  return
     else
       ! Implicit lon-lat-alti values taken from observatories known by Gildas
       call gwcs_observatory(set%obs_name,lonlat,set%obs_alti,dummyr8,dummyr4,error)
       if (error)  return
       set%obs_long = lonlat(1)
       set%obs_lati = lonlat(2)
     endif
     !
  case('OBSERVED')
     argum1 = '*'
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     argum2 = '*'
     call sic_ke (line,0,3,argum2,nc,.false.,error)
     if (error) return
     set%obse1 = mini2
     call gag_fromdate(argum1,set%obse1,error)
     set%obse2 = maxi2
     call gag_fromdate(argum2,set%obse2,error)
     !
  case('OFFSET')
     argum1  = '*'
     call sic_ch(line,0,2,argum1,n1,.false.,error)
     if (error) return
     argum2 = '*'
     call sic_ch(line,0,3,argum2,n2,.false.,error)
     if (error) return
     argum = ' '  ! Default current angle unit
     call sic_ke(line,0,4,argum,nc,.false.,error)
     if (error)  return
     !
     set%offs1 = any
     call coffse(set,'SET OFFSET',argum1(1:n1),argum,set%offs1,error)
     set%offl1  = set%offs1
     set%offs2 = any
     call coffse(set,'SET OFFSET',argum2(1:n2),argum,set%offs2,error)
     set%offl2  = set%offs2
     !
  case('PLOT')
     argum = 'NORMAL'  ! Default
     call sic_ke(line,0,2,argum,nc,.false.,error)
     if (error) return
     call sic_ambigs('SET PLOT',argum,keyword,nkey,data_plot,3,error)
     if (error)  return
     set%plot = keyword
     !
  case('RANGE')
     argum = ' '  ! Default current angle unit
     call sic_ke(line,0,6,argum,nc,.false.,error)
     if (error)  return
     !
     argum1 = '*'
     call sic_ch(line,0,2,argum1,n1,.false.,error)
     if (error) return
     set%offs1=any
     call coffse(set,'SET RANGE',argum1,argum,set%offs1,error)
     if (error)  return
     !
     argum2 = '*'
     call sic_ch(line,0,3,argum2,n2,.false.,error)
     if (error) return
     set%offl1=any
     call coffse(set,'SET RANGE',argum2,argum,set%offl1,error)
     if (error)  return
     !
     argum1 = '*'
     call sic_ch(line,0,4,argum1,n1,.false.,error)
     if (error) return
     set%offs2=any
     call coffse(set,'SET RANGE',argum1,argum,set%offs2,error)
     if (error)  return
     !
     argum2 = '*'
     call sic_ch(line,0,5,argum2,n2,.false.,error)
     if (error) return
     set%offl2=any
     call coffse(set,'SET RANGE',argum2,argum,set%offl2,error)
     if (error)  return
     !
  case('REDUCED')
     argum1  = '*'
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     argum2 = '*'
     call sic_ke (line,0,3,argum2,nc,.false.,error)
     if (error) return
     set%redu1 = mini2
     call gag_fromdate(argum1,set%redu1,error)
     set%redu2 = maxi2
     call gag_fromdate(argum2,set%redu2,error)
     !
  case('SOURCE')
     set%sourc = '*'
     call sic_ch(line,0,2,set%sourc,nc,.false.,error)
     if (error) return
     call sic_upper(set%sourc)
     !
  case('TELESCOPE')
     set%teles = '*'
     call sic_ch(line,0,2,set%teles,nc,.false.,error)
     if (error) return
     call sic_upper(set%teles)
     !
  case('UNIQUENESS')
     if (sic_present(0,2)) then
        call sic_ke(line,0,2,argum,nc,.true.,error)
        if (error) return
        call sic_ambigs(proc,argum,keyword,nkey,vocab_yesno,2,error)
        if (error) return
        set%uniqueness = keyword.eq.'YES'
        if (set%uniqueness) then
          call optimize_sort_set_dtt(ox,error)
          if (error)  return
        endif
     endif
     if (set%uniqueness) then
        call class_message(seve%i,proc,'UNIQUENESS is YES')
     else
        call class_message(seve%i,proc,'UNIQUENESS is NO')
     endif
     !
  case('UNIT')
     argum1 = 'V'
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     if (argum1.ne.'C' .and. argum1.ne.'V' .and. argum1.ne.'F' .and.  &
         argum1.ne.'I' .and. argum1.ne.'A' .and. argum1.ne.'T') then
        mess = 'Invalid X unit '//trim(argum1)//' reset to '//set%unitx(1)
        call class_message(seve%w,proc,mess)
        argum1 = set%unitx(1)
     endif
     argum2 = set%unitx(1)
     call sic_ke (line,0,3,argum2,nc,.false.,error)
     if (error) return
     if (argum2.ne.'C' .and. argum2.ne.'V' .and. argum2.ne.'F' .and.  &
         argum2.ne.'I' .and. argum2.ne.'A' .and. argum2.ne.'T') then
        mess = 'Invalid upper X unit '//trim(argum2)//  &
                   ' reset to '//set%unitx(1)
        call class_message(seve%w,proc,mess)
        argum2 = set%unitx(1)
     endif
     call seunitx(set,r,argum1,argum2,error)
     if (error)  return
     call gelimx(dummyr8,gux1,gux2,gux,set%unitx(1))
     !
  case('WEIGHT')
    call setweight('SET WEIGHT',line,0,2,set%weigh,error)
    if (error)  return
     !
  case('WINDOW')
     set%nwind = setnwind_default
     set%wind1(:) = 0.
     set%wind2(:) = 0.
     argum1 = ' '
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     nc = max(nc,1)
     nc = min(nc,4)
     if (dodefault) then  ! /DEFAULT
       set%nwind = setnwind_default
     elseif (argum1(1:nc).eq.none(1:nc)) then
       set%nwind = 0  ! 0 windows is valid for baselining
     elseif (argum1(1:nc).eq.auto(1:nc)) then
       set%nwind = setnwind_auto
     elseif (doassoc) then
       set%nwind = setnwind_assoc
     elseif (dopolygon) then
       call setwindow_polygon(set,line,error)
       if (error)  return
       set%nwind = setnwind_polygon
     else
       call setregion(set,line,mwind1,set%nwind,set%wind1,set%wind2,'WINDOW',error)
       if (error)  return
     endif
     !
  case('BAD')
     set%bad = 'O'
     call sic_ke (line,0,2,set%bad,nc,.false.,error)
     if (error) return
     if (set%bad.ne.'O'.and.set%bad.ne.'A') then
        mess = 'Invalid bad channel checking '//set%bad
        call class_message(seve%w,proc,mess)
        set%bad = 'O'
     endif
     !
  case('DROP')
     set%drop(:) = 0
     call sic_i4 (line,0,2,set%drop(1),.false.,error)
     if (error)  return
     call sic_i4 (line,0,3,set%drop(2),.false.,error)
     if (error)  return
     if (set%drop(1).lt.0) set%drop(1) = 0
     if (set%drop(2).lt.0) set%drop(2) = 0
     write(mess,'(A,I4,I4)') 'Dropped channels ',set%drop(1),set%drop(2)
     call class_message(seve%i,proc,mess)
     !
     if (r%head%xnum.ne.0) then  ! Convert current R spectrum, if any
       call convert_drop(set,r,error)
       if (error)  return
     endif
     !
  case('EXTENSION')
     argum1 = '.30m'
     call sic_ch (line,0,2,argum1,nc,.false.,error)
     if (error) return
     if (argum1(1:1).ne.'.') then
        set%defext = '.'//argum1
     else
        set%defext = argum1
     endif
     mess = 'Default file extension set to '//set%defext
     call class_message(seve%i,proc,mess)
     !
  case('LEVEL')
     call class_message(seve%e,proc,"SET LEVEL is obsolete. See HELP for details.")
     error = .true.
     !
  case('PAGE','CHARACTER','FONT','TICKSIZE','ORIENTATION')
     ! command line sent to GreG
     call gr_exec1(line(nc:))
     error = gr_error()
     return
     !
  case('BOX_LOCATION')
     if (dodefault) then
        set%box = "D"
     else
        if (sic_narg(0).gt.1) then
           call sic_ke(line,0,2,set%box,nc,.true.,error)
        else
           call class_message(seve%e,proc,'Wrong number of parameters')
           error = .true.
           return
        endif
        call setbox(set,error)
        return
     endif
     !
  case('CALIBRATION')
     ! CALIBRATION OFF or CALIBRATION [Beam_Tolerance [Gain_Tolerance]]
     if (sic_present(0,2)) then
        call sic_ke (line,0,2,argum1,nc,.true.,error)
        if (error) return
        if (argum1(1:2).eq.'OF') then
           set%beamt = 0.0
           set%gaint = 0.0
        else
           call sic_r4 (line,0,2,set%beamt,.true.,error)
           if (error) return
           call sic_r4 (line,0,3,set%gaint,.true.,error)
           if (error) return
        endif
     else
        set%beamt = 0.01
        set%gaint = 0
     endif
     cx%cons%cal%done = .false.  ! Reset Calibration consistency of index
     !
  case('TYPE')
     ! SET TYPE Any|Continum|Spectroscopy|Line|Skydip|Onoff
     call sic_ke (line,0,2,argum1,nc,.true.,error)
     if (error) return
     call sic_ambigs('SET TYPE',argum1,argum2,nkey,vocab_type,ntype,error)
     if (error) return
     if (argum2.eq.'ANY') then
        set%kind = kind_any
        call gprompt_set('AAS')
        ! set%method   => leave unchanged
        ! set%align    => leave unchanged
        ! set%unitx(:) => leave unchanged
     elseif (argum2.eq.'CONTINUUM') then
        set%kind = kind_cont
        call gprompt_set('CAS')
        if (set%method.ne.'GAUSS' .and. &
            set%method.ne.'CONTINUUM' .and.  &
            set%method.ne.'BASECONT') then
           call class_message(seve%w,proc,'METHOD reset to CONTINUUM')
           set%method = 'CONTINUUM'
        endif
        if (set%align.ne.'C' .and. set%align.ne.'P') then
           call class_message(seve%w,proc,'ALIGN reset to Position')
           set%align = 'P'
        endif
        set%unitx(:) = 'A'
     elseif (argum2.eq.'SPECTROSCOPY'.or.argum2.eq.'LINE') then
        set%kind = kind_spec
        call gprompt_set('LAS')
        if (set%method.eq.'CONTINUUM' .or. set%method.eq.'BASECONT') then
           call class_message(seve%w,proc,'METHOD reset to GAUSS')
           set%method = 'GAUSS'
        endif
        if (set%align.eq.'P') then
           call class_message(seve%w,proc,'ALIGN reset to Velocity')
           set%align = 'V'
        endif
        set%unitx(1) = 'F'
        set%unitx(2) = 'V'
     elseif (argum2.eq.'SKYDIP') then
        set%kind = kind_sky
        call gprompt_set('SAS')
     elseif (argum2.eq.'ONOFF') then
        set%kind = kind_onoff
        call gprompt_set('OAS')
     else
        call class_message(seve%e,proc,'Invalid Type '//argum1)
        error = .true.
        return
     endif
     !
  case('QUALITY')
     if (sic_present(0,3)) then   ! Quality range
        call sic_i4 (line,0,2,long,.false.,error)
        if (error) return
        if (long.ge.0 .and. long.le.9) then
           set%qual1 = long
        else
           call class_message(seve%w,proc,'Quality flag out of range 0-9')
        endif
        call sic_i4 (line,0,3,long,.false.,error)
        if (error) return
        if (long.ge.0 .and. long.le.9) then
           set%qual2 = long
        else
           call class_message(seve%w,proc,'Quality flag out of range 0-9')
        endif
     else
        long = set%qual2
        call sic_i4 (line,0,2,long,.false.,error)
        if (error) return
        if (long.ge.0 .and. long.le.9) then
           set%qual2 = long
        else
           call class_message(seve%w,proc,'Quality flag out of range 0-9')
        endif
     endif
     !
  case('VELOCITY')
     argum1 = 'A'
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     if (argum1(1:1).eq.'A') then
        set%veloc = vel_aut
     elseif (argum1(1:1).eq.'L') then
        set%veloc = vel_lsr
     elseif (argum1(1:1).eq.'H') then
        set%veloc = vel_hel
     else
        mess = 'Invalid system '//argum1
        call class_message(seve%w,proc,mess)
        error = .true.
        return
     endif
     if (r%head%xnum.ne.0) then
       ! Convert current R spectrum, if any
       call convert_vtype(set,r%head,error)
       call newdat(set,r,error)
     endif
     !
  case('SCAN')
     call parse_minmax8(line,set%scan1,set%scan2,error)
     if (error)  return
     !
  case('SUBSCAN')
     call parse_minmax4(line,set%sub1,set%sub2,error)
     if (error)  return
     !
  case('VARIABLE')
     call las_setvar(set,line,r,error)
     !
  case('POSANGLE')
     if (sic_present(0,3)) then
        call sic_ke (line,0,2,argum1,nc,.false.,error)
        if (error) return
        if (argum1(1:1).eq.'*') then
           set%posa1=-1e7
        else
           call sic_r4 (line,0,2,set%posa1,.false.,error)
           if (error) return
        endif
        call sic_ke (line,0,3,argum2,nc,.false.,error)
        if (error) return
        if (argum2(1:1).eq.'*') then
           set%posa2=+1e7
        else
           call sic_r4 (line,0,3,set%posa2,.false.,error)
           if (error) return
        endif
     else
        argum1 = '*'
        call sic_ke (line,0,2,argum1,nc,.false.,error)
        if (error) return
        if (argum1(1:1).eq.'*') then
           set%posa1=-1e7
           set%posa2=+1e7
        else
           call sic_r4 (line,0,2,xx,.false.,error)
           if (error) return
           set%posa1=xx-epsr4
           set%posa2=xx+epsr4
        endif
     endif
     !
  case('FIND')
     call sic_ke (line,0,2,argum1,nc,.true.,error)
     if (error) return
     if (argum1(1:1).eq.'U') then
        set%fupda = .true.
     elseif (argum1(1:1).eq.'N') then
        set%fupda = .false.
     else
        mess = 'Invalid FIND mode  '//argum1
        call class_message(seve%w,proc,mess)
        error = .true.
     endif
     !
  case('MAP')
     call sic_ke (line,0,2,argum1,nc,.true.,error)
     if (error) return
     if (argum1(1:1).eq.'C') then
        set%mapcl = .true.
     elseif (argum1(1:1).eq.'N') then
        set%mapcl = .false.
     else
        mess = 'Invalid MAP mode  '//argum1
        call class_message(seve%w,proc,mess)
        error = .true.
     endif
     !
  case('SORT')
     call set_sort(set,line,error)
     !
  case('FITS')
     call fits_select(line,error)
     !
  case('VERBOSE')
     argum1='ON'
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     if (argum1(1:2).eq.'OF') then
        set%verbose = .false.
     elseif (argum1(1:2).eq.'ON') then
        if (sic_inter_state(dummy)) then
           set%verbose = .true.
        else
           set%verbose = .false.
        endif
     else
        mess = 'VERBOSE must be ON or OFF, no change made'
        call class_message(seve%w,proc,mess)
     endif
     !
  case('ACTION')
     set%action = 'O'
     call sic_ke(line,0,2,set%action,nc,.false.,error)
     if (error) return
     !
  case('VIRTUAL')
     call class_message(seve%e,proc,'SET VIRTUAL is obsolete')
     error = .true.
     return
     !
  case('CHASE_NAN')
     argum1='OFF'
     call sic_ke (line,0,2,argum1,nc,.false.,error)
     if (error) return
     if (argum1(1:2).eq.'OF') then      ! OFF
        set%chase_nan = .false.
     elseif (argum1.eq.'ON') then  ! ON
        set%chase_nan = .true.
     endif
     !
  case('CHECK','NOCHECK')
     call setcheck(set,line,keyword.eq.'CHECK',error)
     if (error)  return
     !
  case('SCALE')
    call sic_ch(line,0,2,argum,nc,.true.,error)
    if (error)  return
    call sic_upper(argum)
    call sic_ambigs(proc,argum,argum1,i,yunit_keys,1+myunit,error)
    if (error) return
    set%scale = i-1  ! Because yunit_keys(:) numbering starts at 0
    if (r%head%xnum.ne.0) then  ! Convert current R spectrum
      call convert_scale(set,r,.true.,error)
    endif
    !
  case default
     mess = keyword//' not implemented'
     call class_message(seve%e,proc,mess)
     error = .true.
     return
  end select
  !
  nl=sic_start(0,2)
  keyword=vocab(nkey)
  na=lenc(keyword)
  if (nl.gt.0) then
     line2 = 'LAS'//backslash//'SET '//keyword(1:na)//' '//line(nl:)
  else
     line2 = 'LAS'//backslash//'SET '//keyword(1:na)
  endif
  line=line2
  !
contains
  subroutine parse_minmax4(line,vmin,vmax,error)
    !-------------------------------------------------------------------
    ! Parse arguments for command
    !   SET SOMETHING Min Max
    ! I*4 version
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    integer(kind=4),  intent(out)   :: vmin,vmax
    logical,          intent(inout) :: error
    ! Local
    integer(kind=4), parameter :: maxi4=2147483647_4
    character(len=40) :: argum
    integer(kind=4) :: nc
    !
    argum = '*'
    call sic_ke(line,0,2,argum,nc,.false.,error)
    if (error) return
    if (argum(1:2).eq.'*') then
      vmin = 0
    else
      call sic_i4(line,0,2,vmin,.false.,error)
      if (error) return
    endif
    !
    argum = '*'
    call sic_ke(line,0,3,argum,nc,.false.,error)
    if (error) return
    if (argum(1:2).eq.'*') then
      vmax = maxi4
    else
      call sic_i4(line,0,3,vmax,.false.,error)
      if (error) return
    endif
  end subroutine parse_minmax4
  !
  subroutine parse_minmax8(line,vmin,vmax,error)
    !-------------------------------------------------------------------
    ! Parse arguments for command
    !   SET SOMETHING Min Max
    ! I*8 version
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    integer(kind=8),  intent(out)   :: vmin,vmax
    logical,          intent(inout) :: error
    ! Local
    integer(kind=8), parameter :: maxi8=9223372036854775807_8
    character(len=40) :: argum
    integer(kind=4) :: nc
    !
    argum = '*'
    call sic_ke(line,0,2,argum,nc,.false.,error)
    if (error) return
    if (argum(1:2).eq.'*') then
      vmin = 0
    else
      call sic_i8(line,0,2,vmin,.false.,error)
      if (error) return
    endif
    !
    argum = '*'
    call sic_ke(line,0,3,argum,nc,.false.,error)
    if (error) return
    if (argum(1:2).eq.'*') then
      vmax = maxi8
    else
      call sic_i8(line,0,3,vmax,.false.,error)
      if (error) return
    endif
  end subroutine parse_minmax8
  !
end subroutine class_set_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine setwindow_polygon(set,line,error)
  use gildas_def
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>setwindow_polygon
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  SET WINDOW /POLYGON [N] [filename1...filenameN]
  ! Define the windows from 1 or several polygons.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SET WINDOW'
  integer(kind=4), parameter :: optpolygon=3
  character(len=filename_length) :: filename
  integer(kind=4) :: i,nc,npoly
  character(len=message_length) :: mess
  character(len=40) :: argum,argum1
  type(polygon_t) :: poly
  character(len=filename_length) :: winpol_name(mwind1)
  !
  ! Number of polygon(s)
  npoly = 1  ! Default is 1 polygon if no argument
  call sic_i4 (line,optpolygon,1,npoly,.false.,error)
  if (error) return
  if (npoly.gt.mwind1) then
    write(mess,'(a,i0)') 'Too many polygons. Max number is ',mwind1
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (sic_narg(optpolygon).le.1) then
    ! No filename(s): Define the polygon(s) with cursor
    if (gtg_curs()) then
      do i=1,npoly
        write(mess,'(A,I0,A,I0)') 'Draw polygon #',i,'/',npoly
        call class_message(seve%i,rname,mess)
        call greg_poly_cursor(rname,poly,error)
        if (error)  return
        write(argum,'(a,i0)') 'window-',i
        call sic_parse_file(adjustl(argum),'','.pol',winpol_name(i))
        call greg_poly_write(rname,poly,winpol_name(i),error)
        if (error)  return
      enddo
    else
      call class_message(seve%e,rname,'No cursor available')
      error = .true.
      return
    endif
  else if (sic_narg(optpolygon)-1.ne.npoly) then
    ! Some but not all filenames given
    call class_message(seve%e,rname,'Please enter ALL filenames')
    error = .true.
    return
  else
    ! All polygons from filenames
    do i=1,npoly
      call sic_ch (line,optpolygon,i+1,argum1,nc,.false.,error)
      if (error) return
      call sic_parse_file(argum1,' ','.pol',filename)
      winpol_name(i) = filename
      if (.not.sic_findfile(winpol_name(i),winpol_name(i),'','.pol')) then
        call class_message(seve%e,rname,'No such file '//winpol_name(i))
        error = .true.
        return
      endif
      write(mess,'(A,I0,A,A)') 'Read polygon #',i,' from file ',trim(filename)
      call class_message(seve%i,rname,mess)
    enddo
  endif
  !
  call polygon2window(set,winpol_name,npoly,error)
  if (error)  return
  !
end subroutine setwindow_polygon
!
subroutine polygon2window(set,file,nfile,error)
  use gildas_def
  use gbl_message
  use gbl_constant
  use gbl_format
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>polygon2window
  use class_data
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set          !
  integer(kind=4),     intent(in)    :: nfile        ! Number of polygon files
  character(len=*),    intent(in)    :: file(nfile)  ! Polygon files
  logical,             intent(inout) :: error        !
  ! Local
  character(len=*), parameter :: rname='POLYGON2WINDOW'
  integer(kind=4) :: box(4),ier,i1,iwind,nwind,maxwind,ichan
  integer(kind=entry_length) :: iobs
  integer(kind=index_length) :: dim(4)
  real(kind=4) :: dummy
  logical, allocatable :: m2d(:,:)
  !
  ! Check index
  if (cx%next.le.1) then
     call class_message(seve%e,rname,'Index is empty')
     error = .true.
     return
  endif
  ! Check if any 2D image loaded
  if (.not.associated(p%data2)) then
     call class_message(seve%e,rname,'No index loaded')
     error = .true.
     return
  endif
  !
  ! Compute the mask from polygon
  allocate(m2d(p%head%spe%nchan,p%head%des%ndump),stat=ier)
  if (failed_allocate(rname,'m2d',ier,error))  return
  call polygon2mask(file,nfile,m2d,box,p%head%spe%nchan,p%head%des%ndump,error)
  if (error) return
  !
  ! Count the maximum number of windows (i.e. a single polygon can result
  ! in several windows for one record). This is a simplified duplicate of the
  ! main loop.
  maxwind = 0
  do iobs=1,cx%next-1
    i1 = max(2,box(1))
    nwind = 0
    ! Left boundary condition
    if (box(1).eq.1 .and. m2d(1,iobs))  nwind = 1  ! Open the first window
    ! Middle channels
    do ichan=i1,box(3)
      if (m2d(ichan,iobs).and.(.not.m2d(ichan-1,iobs)))  nwind = nwind + 1
    enddo
    maxwind = max(maxwind,nwind)
  enddo
  if (maxwind.le.0) then
    ! Only a warning: since we allow 0 windows for some, we should allow 0
    ! windows for all...
    call class_message(seve%w,rname,  &
      'Polygons are completely off the index: 0 window defined')
  endif
  !
  dim(:) = (/p%head%des%ndump,1+2*maxwind,0,0/)
  if (allocated(set%window_polygon)) deallocate(set%window_polygon)
  allocate(set%window_polygon(dim(1),dim(2)),stat=ier)
  if (failed_allocate('BASE','window_polygon',ier,error))  return
  !
  ! Loop on observations
  do iobs=1,cx%next-1
     i1 = max(2,box(1))
     nwind = 0
     set%window_polygon(iobs,:) = 0.0
     ! Left boundary condition
     if (box(1).eq.1 .and. m2d(1,iobs)) then
        ! Open the first window
        nwind = 1
        set%window_polygon(iobs,2*nwind) = p%datax(1)
     endif
     ! Middle channels
     do ichan=i1,box(3)
        if (m2d(ichan,iobs).and.(.not.m2d(ichan-1,iobs))) then
           nwind = nwind + 1
           if (nwind.gt.maxwind) then
              call class_message(seve%e,rname,'Internal problem on number of windows (1)')
              error = .true.
              return
           endif
           set%window_polygon(iobs,2*nwind) = p%datax(ichan)
        else if (m2d(ichan-1,iobs).and.(.not.m2d(ichan,iobs))) then
           set%window_polygon(iobs,2*nwind+1) = p%datax(ichan-1)
        endif
     enddo
     ! Right boundary condition
     if (box(3).eq.p%head%spe%nchan .and. m2d(p%head%spe%nchan,iobs)) then
       ! Close the last window
       set%window_polygon(iobs,2*nwind+1) = p%datax(p%head%spe%nchan)
     endif
     ! Number of windows for this observation
     set%window_polygon(iobs,1) = real(nwind)
  enddo
  !
  ! Put window velocities in increasing order if needed
  if (p%datax(p%head%spe%nchan).lt.p%datax(1)) then
     do iwind=1,maxwind
        do iobs=1,cx%next-1
           dummy = set%window_polygon(iobs,2*iwind+1)
           set%window_polygon(iobs,2*iwind+1) = set%window_polygon(iobs,2*iwind)
           set%window_polygon(iobs,2*iwind)   = dummy
        enddo
     enddo
  endif
  !
  ! Define the GLOBAL variable WINDOW with the right number of spectral windows
  !
  dim(3) = maxval(set%window_polygon(:,1))
  if (dim(3).ne.maxwind) then
     call class_message(seve%e,rname,'Internal problem on number of windows (2)')
     error = .true.
     return
  endif
  if (.not.sic_varexist('SET')) then
     call sic_defstructure('SET%',.true.,error)
     if (error)  return
  else
     call sic_delvariable('SET%WINDOW',.false.,error)
     if (error)  return
  endif
  call sic_def_real('SET%WINDOW',set%window_polygon,2,dim,.true.,error)
  if (error)  return
  !
  ! Clean
  deallocate(m2d)
end subroutine polygon2window
!
subroutine polygon2mask(file,nfile,m2d,poly_lim,nx,ny,error)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>polygon2mask
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  !   Defines a logical mask from a list of polygon files
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: nfile        ! Number of polygon files
  character(len=*), intent(in)    :: file(nfile)  ! Polygon files
  integer(kind=4),  intent(in)    :: nx,ny        ! Dimensions of 2D array
  logical,          intent(out)   :: m2d(nx,ny)   ! Resulting logical mask
  integer(kind=4),  intent(out)   :: poly_lim(4)  ! Polygon limit (for fast search)
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='POLYGON2MASK'
  real(kind=8) :: xconv(3),yconv(3)
  integer(kind=4) :: i,box(4),ier
  logical, allocatable :: w2d(:,:)
  type(polygon_t) :: poly
  !
  ! Get conversion formula
  xconv(1) = gcx1
  xconv(2) = gux1
  xconv(3) = (gux2-gux1)/(gcx2-gcx1)
  yconv(1) = 0
  yconv(2) = 0
  yconv(3) = 1
  ! blc
  box(1) = gcx1
  box(2) = 1
  ! trc
  box(3) = gcx2
  box(4) = ny
  !
  ! Allocating and building the mask
  allocate(w2d(nx,ny),stat=ier)
  if (failed_allocate(rname,'w2d',ier,error)) return
  m2d(:,:) = .false.
  w2d(:,:) = .false.
  !
  ! Builds the mask from the current polygon(s)
  poly_lim = (/nx,ny,1,1/)
  do i=1,nfile
     !
     call greg_poly_load(rname,.true.,file(i),poly,error)
     if (error)  return
     !
     call gr8_glmsk(poly,w2d,nx,ny,xconv,yconv,box)
     m2d = m2d.or.w2d
     ! Avoid exploring all the Map by storing imin,imax,jmin,jmax
     poly_lim(1) = min(poly_lim(1),box(1),box(3))
     poly_lim(3) = max(poly_lim(3),box(1),box(3))
     poly_lim(2) = min(poly_lim(2),box(2))
     poly_lim(4) = max(poly_lim(4),box(4))
  enddo
  deallocate(w2d)
end subroutine polygon2mask
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine setbox(set,error)
  use classcore_dependencies_interfaces
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! LAS support routine for command
  ! SET BOX L[andscape] P[ortrait]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  logical,             intent(inout) :: error  ! Error flag
  !
  select case(set%box)
  case("L")
     call gr_exec1('SET PLOT LANDSCAPE')
     call gr_exec1('SET VIEW 0.1 0.9 0.15 0.70')
  case("P")
     call gr_exec1('SET PLOT PORTRAIT')
     call gr_exec1('SET VIEWPORT 0.15 0.85 0.10 0.80')
  case default
     gx1 = 3.
     gx2 = 28.0
     gy1 = 2.5
     gy2 = 15.5
     call gr_exec1('SET PLOT LANDSCAPE')
     call gr_exec1('SET VIEWPORT 0.10 0.90 0.10 0.70')
  end select
  error = gr_error()
end subroutine setbox
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine setregion(set,line,mw,nw,w1,w2,wtype,error)
  use gildas_def
  use gbl_constant
  use gbl_format
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>setregion
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for SET WINDOW|MASK [/VARIABLE]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set     !
  character(len=*),    intent(inout) :: line    ! Command line
  integer(kind=4),     intent(in)    :: mw      ! Maximum number of regions
  integer(kind=4),     intent(out)   :: nw      ! Actual number of regions
  real(kind=4),        intent(out)   :: w1(mw)  ! Lower bounds of regions
  real(kind=4),        intent(out)   :: w2(mw)  ! Upper bounds of regions
  character(len=*),    intent(in)    :: wtype   ! Type of regions (Window or Mask)
  logical,             intent(inout) :: error   ! Logical error flag
  ! Local
  integer(kind=4), parameter :: optnocursor=1
  integer(kind=4), parameter :: optvariable=4
  character(len=12) :: rname
  type(sic_descriptor_t) :: desc,inca
  integer(kind=address_length) :: ipi
  integer(kind=4) :: memory(1),form,i,nl,nc
  real(kind=4) :: window_array(1+2*mw)
  logical :: docursor,found
  character(len=40) :: argum
  character(len=message_length) :: mess
  !
  rname = 'SET '//wtype
  docursor = .not.sic_present(optnocursor,0)
  !
  if (.not.sic_present(optvariable,0)) then
    ! Not from a variable array
    if (sic_narg(0).ge.2) then
      if ((sic_narg(0)-1).gt.2*mw) then
        write(mess,*) 'Too many values, truncated to ',mw,' pairs'
        call class_message(seve%w,rname,mess)
        nw = mw
      else
        nw = int((sic_narg(0)-1)/2)  ! Truncate
      endif
      if (2*nw.ne.sic_narg(0)-1) then
        call class_message(seve%e,rname,'Odd number of arguments (expected lower-upper pairs)')
        error = .true.
        return
      endif
      do i=1,nw
        call sic_r4(line,0,2*i,w1(i),.true.,error)
        if (error) return
        call sic_r4(line,0,2*i+1,w2(i),.true.,error)
        if (error) return
      enddo
      !
    elseif (docursor) then
      if (gtg_curs()) then
        call wincur(set,mw,nw,w1,w2,wtype)
      else
        call class_message(seve%e,rname,'No cursor available')
        error = .true.
        return
      endif
      !
    else
      call class_message(seve%e,rname,  &
        'Missing values or cursor not enabled')
      error = .true.
      return
    endif
    !
    if (set%kind.eq.kind_cont) then
      do i=1,nw
        w1(i) = w1(i)/class_setup_get_fangle()
        w2(i) = w2(i)/class_setup_get_fangle()
      enddo
    endif
    !
    ! Update the command line
    nl = index(line,' ')+1
    line(nl:) = trim(wtype)//' '
    nl = nl+7
    do i=1,nw
      write(line(nl:),'(1PG11.4)') w1(i)
      nl = nl+12
      write(line(nl:),'(1PG11.4)') w2(i)
      nl = nl+12
    enddo
    !
  else
    ! From a variable array
    window_array = 0.
    call sic_ch(line,optvariable,1,argum,nc,.true.,error)
    if (error) return
    !
    call sic_descriptor(argum,desc,found)
    if (.not.found) then
      call class_message(seve%e,rname,'No such variable')
      error = .true.
      return
    endif
    !
    form = fmt_r4
    call sic_incarnate(form,desc,inca,error)
    if (error) return
    !
    ! Check the variable is a rank-1 array.
    if (inca%ndim.ne.1) then
      call class_message(seve%e,rname,'Invalid number of dimensions')
      error = .true.
      return
    endif
    !
    if (mod(inca%dims(1),2_address_length).eq.0) then
      call class_message(seve%e,rname,'Invalid dimension 1')
      error = .true.
      return
    endif
    ipi = gag_pointer(inca%addr,memory)
    call r4tor4(memory(ipi),window_array,inca%dims(1))
    !
    ! Check if the number of boundaries declared matches the number
    ! of boundaries provided by the array
    if (window_array(1).gt.((inca%dims(1)-1.)/2.)) then
      call class_message(seve%e,rname,  &
        'First element does not match the number of pairs found')
      error = .true.
      return
    else
      nw = window_array(1)
    endif
    !
    if (nw.gt.mw) then
      write(mess,*) 'Too many values, truncated to ',mw,' pairs'
      call class_message(seve%w,rname,mess)
      nw = mw
    endif
    !
    do i=1,nw
      w1(i) = window_array(2*i)
      w2(i) = window_array(2*i+1)
    enddo
    !
    if (set%kind.eq.kind_cont) then
      do i=1,nw
        w1(i) = w1(i)/class_setup_get_fangle()
        w2(i) = w2(i)/class_setup_get_fangle()
      enddo
    endif
  endif
  !
end subroutine setregion
!
subroutine setfrequency(rname,line,optnum,argnum,freqmin,freqmax,freqsig,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for commands:
  !   SET FREQUENCY Freq1 [Freq2] [SIGNAL|IMAGE]
  ! and
  !   FIND /FREQUENCY Freq1 [Freq2] [SIGNAL|IMAGE]
  !   Parse the command line to set the frequency values which will be
  ! used for the later FIND selection.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname    ! Calling routine name
  character(len=*), intent(in)    :: line     ! Command line
  integer,          intent(in)    :: optnum   ! Option number for command line parsing
  integer,          intent(in)    :: argnum   ! First argument number in the option
  real(kind=8),     intent(out)   :: freqmin  ! Minimum value found
  real(kind=8),     intent(out)   :: freqmax  ! Maximum value found
  logical,          intent(out)   :: freqsig  ! Signal or image frequency?
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=40) :: argum1,argum2,argum3,keyword
  integer :: nc,nkey
  integer, parameter :: nfreq=2
  character(len=*), parameter :: vocab_freq(nfreq) = (/ 'SIGNAL','IMAGE ' /)
  !
  ! First argument: must be first value
  argum1 = '*'
  call sic_ke(line,optnum,argnum,argum1,nc,.true.,error)
  if (error) return
  if (argum1(1:1).eq.'*') then
    freqmin = -1.d0
  else
    call sic_r8(line,optnum,argnum,freqmin,.true.,error)
    if (error) return
  endif
  !
  ! Second argument: can be a value or a keyword
  argum2 = argum1  ! Default is same as argum1
  freqmax = freqmin  ! Default is same as freqmin
  call sic_ke(line,optnum,argnum+1,argum2,nc,.false.,error)
  if (error) return
  !
  if (sic_narg(optnum).eq.argnum+1) then
    ! Argument is the last of the option
    call sic_upper(argum2)
    if (argum2(1:nc).eq.vocab_freq(1)(1:nc)) then
      freqsig = .true.
      return
    elseif (argum2(1:nc).eq.vocab_freq(2)(1:nc)) then
      freqsig = .false.
      return
    endif
  endif
  !
  if (argum2(1:1).eq.'*') then
    freqmax = -1.d0
  else
    call sic_r8(line,optnum,argnum+1,freqmax,.false.,error)
    if (error) return
  endif
  !
  ! Third argument: can be the frequency kind
  freqsig = .true.
  if (sic_present(optnum,argnum+2)) then
    call sic_ke(line,optnum,argnum+2,argum3,nc,.false.,error)
    if (error) return
    !
    call sic_ambigs(rname,argum3,keyword,nkey,vocab_freq,nfreq,error)
    if (error)  return
    !
    if (keyword.eq.'IMAGE')  freqsig = .false.
  endif
  !
end subroutine setfrequency
!
subroutine setfor(set,line,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>setfor
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS support routine for command
  ! SET FORMAT
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(in)    :: line   !
  logical,             intent(inout) :: error  !
  ! Local
  integer(kind=4), parameter :: mvoc=10
  integer(kind=4) :: nkey,nc
  character(len=12) :: argum,keywor,vocab(mvoc)
  character(len=80) :: mess
  logical :: lflag
  ! Data
  data vocab/'BRIEF','LONG','FULL','POSITION','QUALITY','SPECTRAL',  &
             'CALIBRATION','ATMOSPHERE','ORIGIN','CONTINUUM'/
  ! Code
  call sic_ke (line,0,2,argum,nc,.true.,error)
  if (error) return
  call sic_ambigs('SET FORMAT',argum,keywor,nkey,vocab,mvoc,error)
  if (error) return
  !
  select case (keywor)
  !
  case ('BRIEF')
     set%heade = 'B'
  case ('LONG')
     set%heade = 'L'
     set%title%origin = set%origin
  case ('FULL')
     set%heade = 'F'
     set%title%origin = .true.
  case default
     argum = 'ON'
     call sic_ke (line,0,3,argum,nc,.false.,error)
     if (error) return
     if (argum.eq.'ON') then
        lflag = .true.
     elseif (argum.eq.'OFF') then
        lflag = .false.
     else
        mess = 'Invalid argument '//argum
        call class_message(seve%e,'SET FORMAT',mess)
        error = .true.
        return
     endif
     !
     select case (keywor)
     case ('POSITION')
        set%title%position = lflag
     case ('QUALITY')
        set%title%quality = lflag
     case ('SPECTRAL')
        set%title%spectral = lflag
     case ('CALIBRATION')
        set%title%calibration = lflag
     case ('ATMOSPHERE')
        set%title%atmosphere = lflag
     case ('ORIGIN')
        set%title%origin = lflag
        set%origin = lflag
     case ('CONTINUUM')
        set%title%continuum = lflag
     end select
  end select
end subroutine setfor
!
subroutine setcheck(set,line,check,error)
  use classcore_dependencies_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !   SET  [NO]CHECK  [SOURCE|POSITION|OFFSET|LINE|SPECTROSCOPY|CALIBRATION|SWITCHING]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(in)    :: line   !
  logical,             intent(in)    :: check  !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=7) :: rname
  integer(kind=4) :: iarg,nc,ikey
  character(len=13) :: argum,key
  integer(kind=4), parameter :: nkey=7
  character(len=*), parameter :: keys(nkey) = (/                  &
    'SOURCE      ','POSITION    ','OFFSET      ','LINE        ',  &
    'SPECTROSCOPY','CALIBRATION ','SWITCHING   ' /)
  !
  if (check) then
    rname = 'CHECK'
  else
    rname = 'NOCHECK'
  endif
  !
  if (sic_narg(0).eq.1) then
    ! No argument: (de)activate everything and return
    set%check%sou = check
    set%check%pos = check
    set%check%off = check
    set%check%lin = check
    set%check%spe = check
    set%check%cal = check
    set%check%swi = check
    return
  endif
  !
  do iarg=2,sic_narg(0)
    call sic_ke(line,0,iarg,argum,nc,.true.,error)
    if (error)  return
    call sic_ambigs(rname,argum,key,ikey,keys,nkey,error)
    if (error)  return
    select case (key)
    case ('SOURCE')
      set%check%sou = check
    case ('POSITION')
      set%check%pos = check
    case ('OFFSET')
      set%check%off = check
    case ('LINE')
      set%check%lin = check
    case ('SPECTROSCOPY')
      set%check%spe = check
    case ('CALIBRATION')
      set%check%cal = check
    case ('SWITCHING')
      set%check%swi = check
    end select
  enddo
  !
end subroutine setcheck
!
subroutine setweight(rname,line,iopt,iarg,weight,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>setweight
  !---------------------------------------------------------------------
  ! @ private
  !  Parse command line for TIME|SIGMA|EQUAL, and return value in a
  ! 1-character string.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname   ! Calling routine name
  character(len=*), intent(in)    :: line    ! Command line
  integer(kind=4),  intent(in)    :: iopt    ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg    ! Argument number
  character(len=*), intent(inout) :: weight  ! Value, unchanged in case of error
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=16) :: argum
  integer(kind=4) :: nc,ikey
  character(len=5) :: key
  ! Data
  integer(kind=4), parameter :: mw=4
  character(len=5), parameter :: cw(mw) = (/ 'TIME ','SIGMA','EQUAL','ASSOC' /)
  !
  call sic_ke(line,iopt,iarg,argum,nc,.true.,error)
  if (error) return
  !
  call sic_ambigs(rname,argum,key,ikey,cw,mw,error)
  if (error)  return
  !
  weight = key(1:1)
  !
end subroutine setweight
!
subroutine set_angle_factor(rname,argum,angle,fangle,error)
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>set_angle_factor
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the angle conversion factor between 'unit' and radians.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname   ! Caller name
  character(len=*), intent(in)    :: argum   ! Argument to be resolved
  character(len=*), intent(inout) :: angle   ! Resolved angle
  real(kind=8),     intent(inout) :: fangle  ! Conversion factor
  logical,          intent(inout) :: error   !
  ! Local
  integer(kind=4), parameter :: nangle=5   ! Size of ANGLE vocabulary
  character(len=3) :: vocab_angle(nangle) = (/ 'RAD','DEG','MIN','SEC','MAS' /)
  character(len=3) :: key
  integer(kind=4) :: ikey
  !
  call sic_ambigs(rname,argum,key,ikey,vocab_angle,nangle,error)
  if (error) return  ! Nothing modified in case of error
  !
  angle = key
  select case (ikey)
  case (1)
    fangle = 1.d0
  case (2)
    fangle = 180.d0/pi
  case (3)
    fangle = 180.d0*60.d0/pi
  case (4)
    fangle = 180.d0*60.d0*60.d0/pi
  case (5)
    fangle = 180.d0*60.d0*60.d0*1.d3/pi
  end select
  !
end subroutine set_angle_factor

!     
!     $Id$
!     
! TBD:  error handling
! TBD:  for the lists: use linked lists instead of arrays
!
Module moduleResultsToNCS
  !     
  Use modulePakoXML
  !
  Implicit None
  Save
  Private
  !
  ! *** Subroutines:
  !
  Public   ::  resultsToNCSwriteProlog
  Public   ::  resultsToNCSsetOdpHeader
  Public   ::  resultsToNCSwriteOdpHeader
  Public   ::  resultsToNCSsetMeasurementHeader
  Public   ::  resultsToNCSsetScanId
  Public   ::  resultsToNCSwriteMeasurementHeader
  Public   ::  resultsToNCSsetReceiver
  Public   ::  resultsToNCSwriteReceivers
  Public   ::  resultsToNCSsetBackend
  Public   ::  resultsToNCSwriteBackends
  Public   ::  resultsToNCSsetFocusResults
  Public   ::  resultsToNCSwriteFocusResults
  Public   ::  resultsToNCSsetPointingResults
  Public   ::  resultsToNCSwritePointingResults
  Public   ::  resultsToNCSsetCalibrationResults
  Public   ::  resultsToNCSwriteCalibrationResults
  Public   ::  resultsToNCSwriteMeasurementEnd
  Public   ::  resultsToNCSwriteEnd
  !
  ! *** Derived Types:
  !
  Public   ::  resultT
  !
  ! *** values representing "not set":
  !
  Character(len=8), Parameter  :: cNone = 'none'
  Integer,          Parameter  :: iNone = 0
  Real,             Parameter  :: rNone = 0.0
  Real*8,           Parameter  :: dNone = 0.0D0
  ! TBD: lNone = .False.
  !
  !
  ! *** for ODP Header in XML file:
  !
  Type     ::  odpHeaderT
     Character(len=128) ::  telescope   = cNone
     Character(len=128) ::  observatory = cNone
     Character(len=128) ::  odpSoftware = cNone
     ! ...
  End Type odpHeaderT
  Type(odpHeaderT)      ::  odpHeader, odpHeaderDefault
  !
  ! *** for "measurement Header in XML file:
  !     
  ! first: list of scanID or scan numbers
  !
  Type :: scanIdT       
     Character(len=24)  :: scanId              = cNone
     Integer            :: scanN               = iNone
  End Type scanIdT
  Integer, Parameter    :: nDimScans           = 99
  Integer               :: nScans              = 0
  Type(scanIdT), Dimension(nDimScans) :: scans
  Type(scanIdT)                       :: scanDefault
  !
  Type     ::  measurementHeaderT
     Character(len=128) :: measurement         =  cNone
     Character(len=128) :: sourceName          =  cNone
     Character(len=128) :: timeStamp           =  cNone
     Real               :: azimuth             =  rNone
     Real               :: elevation           =  rNone
     Real               :: refraction          =  rNone
     Real               :: pressureAmbient     =  rNone
     Real               :: temperatureAmbient  =  rNone
     Real               :: humidityAmbient     =  rNone
     Logical            :: lAzimuth            = .False.
     Logical            :: lElevation          = .False.
     Logical            :: lRefraction         = .False.
     Logical            :: lPressureAmbient    = .False.
     Logical            :: lTemperatureAmbient = .False.
     Logical            :: lHumidityAmbient    = .False.
     Character(len=128) :: switchingMode       =  cNone
     Character(len=128) :: observingMode       =  cNone
     Character(len=128) :: method              =  cNone
     Character(len=128) :: focusDirection      =  cNone
     Real               :: focusLength         =  rNone
     Real               :: focusCurrent        =  rNone
     Logical            :: lFocusLength        = .False.
     Logical            :: lFocusCurrent       = .False.
     Real               :: pointingLength      =  rNone
     Real               :: pointingP1          =  rNone
     Real               :: pointingP2          =  rNone
     Real               :: pointingP7          =  rNone
     Logical            :: lPointingLength     = .False.
     Logical            :: lPointingP1         = .False.
     Logical            :: lPointingP2         = .False.
     Logical            :: lPointingP7         = .False.
     ! ...
  End Type measurementHeaderT
  Type(measurementHeaderT) ::  mHead
  Type(measurementHeaderT) ::  mHeadDefault
  !
  ! *** list of receivers 
  !      consistent with paKo --> some extra variables
  ! 
  Type :: receiverFrequency
     Character(len=12)       :: name           = cNone
     Character(len=12)       :: kind           = cNone
     Character(len=12)       :: unit           = cNone
     Character(len=12)       :: doppler        = cNone         
     Real*8                  :: value          = dNone
  End Type receiverFrequency
  !
  Type :: gainRatio
     Character(len=12)       :: name           = cNone
     Character(len=12)       :: kind           = cNone
     Character(len=12)       :: unit           = cNone
     Real*4                  :: value          = dNone
     Real*4                  :: db             = dNone
  End Type gainRatio
  !
  Type :: varReceiverT
     !
     Character(len=13)       :: name           = cNone
     Logical                 :: isConnected    = .False.
     Logical                 :: gunnOn         = .False.
     Type(receiverFrequency) :: frequency
     Type(receiverFrequency) :: frequencyImage
     Type(receiverFrequency) :: offset
     Type(receiverFrequency) :: centerIF       
     !
     Character(len=100)      :: lineName       = cNone         
     !
     Character(len=12)       :: sideBand       = cNone         
     Character(len=12)       :: doppler        = cNone         
     Character(len=12)       :: width          = cNone
     !
     Real*4                  :: effForward     = rNone
     Real*4                  :: effBeam        = rNone
     Character(len=12)       :: scale          = cNone
     Type(gainRatio)         :: gainImage
     Real*4                  :: tempAmbient    = rNone
     Real*4                  :: tempCold       = rNone
     Real*4                  :: xOffsetNasmyth = rNone
     Real*4                  :: yOffsetNasmyth = rNone
     Real*4                  :: lcalof         = rNone
     Real*4                  :: bcalof         = rNone
     Real*4                  :: h2omm          = rNone
     Real*4                  :: trx            = rNone
     Real*4                  :: tsys           = rNone
     Real*4                  :: tcal           = rNone
     Real*4                  :: tatms          = rNone
     Real*4                  :: tatmi          = rNone
     Real*4                  :: tauzen         = rNone
     Real*4                  :: tauzenImage    = rNone
     Real*4                  :: pcold          = rNone
     Real*4                  :: phot           = rNone
     Real*4                  :: psky           = rNone
     !
     Integer                 :: iPixel         = iNone
     !
  End Type varReceiverT
  !
  Integer, Parameter         :: nDimReceivers  = 18
  Integer                    :: nRec           = 0
  Type(varReceiverT), Dimension(nDimReceivers) :: receivers
  Type(varReceiverT)                           :: receiverDefault
  !
  ! *** list of backends
  !      consistent with paKo --> some extra variables
  !
  Type :: varBackendT
     !
     Character(len=12)       :: name           = cNone
     Logical                 :: wasConnected   = .False.
     Logical                 :: isConnected    = .False.
     Integer                 :: nPart          = iNone
     !
     Real*4                  :: resolution     = rNone
     Real*4                  :: bandWidth      = rNone
     Real*4                  :: fShift         = rNone
     !
     Character(len=13)       :: receiverName   = cNone         
     !
     Integer                 :: nChannels      = iNone
     !
  End Type varBackendT
  !
  Integer, Parameter         :: nDimBackends   = 99
  Integer                    :: nBack          = 0
  Type(varBackendT), Dimension(nDimBackends)   :: backends
  Type(varBackendT)                            :: backendDefault
  !
  ! *** list of pointing results
  !      
  ! most results have a value and an error:
  !
  Type :: resultT
     Real*4                  :: value          = rNone
     Real*4                  :: error          = rNone
  End Type resultT
  !
  Type :: focusResultsT
     Character(len=12)       :: backendName    = cNone
     Integer                 :: nPart          = iNone
     Type(resultT)           :: focus
     Type(resultT)           :: offset       
     Real*4                  :: rmsResidual    = rNone
  End Type focusResultsT
  !
  Integer, Parameter         :: nDimResults      = 99
  Integer                    :: nFocusResults = 0
  Type(focusResultsT), Dimension(nDimResults) :: FocusResults
  Type(focusResultsT)                         :: FocusResultDefault
  !
  Type :: pointingResultsT
     Character(len=12)       :: backendName    = cNone
     Integer                 :: nPart          = iNone
     Character(len=12)       :: direction      = cNone
     Type(resultT)           :: correction   
     Type(resultT)           :: peak         
     Type(resultT)           :: integral     
     Type(resultT)           :: offset       
     Type(resultT)           :: width        
     Real*4                  :: rmsResidual    = rNone
  End Type pointingResultsT
  !
!!$  Integer, Parameter         :: nDimResults      = 99
  Integer                    :: nPointingResults = 0
  Type(pointingResultsT), Dimension(nDimResults) :: PointingResults
  Type(pointingResultsT)                         :: PointingResultDefault
  !
Contains
!!!
!!!
  Subroutine resultsToNCSwriteProlog(                             &
       &                                       error,             &
       &                                       errorC             &
       &                            )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Character(len=256) :: c1
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    c1 = ".xml file generated by moduleResultsToNCS.f90 (author: Hans Ungerechts)"
    !
    Call pakoXMLwriteStartXML("1.0",                              &
         &                    "VOTABLE", "VOTable.dtd", "1.0",    &
         &                    comment=c1(1:Len_trim(c1)),         & 
         &                    error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteProlog
!!!
!!!
  Subroutine resultsToNCSsetOdpHeader(                            &
       &                                       telescope        , &
       &                                       observatory      , &
       &                                       odpSoftware      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                             )
    !
    Character(len=*), Intent(IN), Optional  :: telescope
    Character(len=*), Intent(IN), Optional  :: observatory
    Character(len=*), Intent(IN), Optional  :: odpSoftware
    !
    Logical         , Intent(IN), Optional  :: default            ! set default values
    Logical         , Intent(IN), Optional  :: reset              ! re-set values to undefined
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       odpHeader = odpHeaderDefault
    End If
    !
    If (Present(reset).And.reset) Then
       odpHeader = odpHeaderDefault
    End If
    !
    If (Present(telescope))   odpHeader%telescope   = telescope
    If (Present(observatory)) odpHeader%observatory = observatory
    If (Present(odpSoftware)) odpHeader%odpSoftware = odpSoftware
    !
    Return
    !
  End Subroutine resultsToNCSsetOdpHeader
!!!
!!!
  Subroutine resultsToNCSwriteOdpHeader(                          &
       &                                       error,             &
       &                                       errorC             &
       &                               )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'odpHeader',                    &
         &              error   = errorXML)
    !
    If (odpHeader%telescope.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'telescope',                 &
            &              value   = odpHeader%telescope,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (odpHeader%observatory.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'observatory',               &
            &              value   = odpHeader%observatory,       &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (odpHeader%odpSoftware.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'odpSoftware',               &
            &              value   = odpHeader%odpSoftware,       &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'odpHeader',                    &
         &              error   = errorXML)          
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteOdpHeader
!!!
!!!
  Subroutine resultsToNCSsetMeasurementHeader(                     &
       &                                       measurement       , &
       &                                       sourceName        , &
       &                                       timeStamp         , &
       &                                       azimuth           , &
       &                                       elevation         , &
       &                                       refraction        , &
       &                                       pressureAmbient   , &
       &                                       temperatureAmbient, &
       &                                       humidityAmbient   , &
       &                                       switchingMode     , &
       &                                       observingMode     , &
       &                                       method            , &
       &                                       focusDirection    , &
       &                                       focusLength       , &
       &                                       focusCurrent      , &
       &                                       pointingLength    , &
       &                                       pointingP1        , &
       &                                       pointingP2        , &
       &                                       pointingP7        , &
       &                                       default           , &
       &                                       reset             , &
       &                                       error             , &
       &                                       errorC              &                        
       &                                     ) 
    !
    Character(len=*), Intent(IN), Optional  :: measurement        
    Character(len=*), Intent(IN), Optional  :: sourceName         
    Character(len=*), Intent(IN), Optional  :: timeStamp          
    Real            , Intent(IN), Optional  :: azimuth            
    Real            , Intent(IN), Optional  :: elevation          
    Real            , Intent(IN), Optional  :: refraction         
    Real            , Intent(IN), Optional  :: pressureAmbient    
    Real            , Intent(IN), Optional  :: temperatureAmbient 
    Real            , Intent(IN), Optional  :: humidityAmbient    
    Character(len=*), Intent(IN), Optional  :: switchingMode      
    Character(len=*), Intent(IN), Optional  :: observingMode      
    Character(len=*), Intent(IN), Optional  :: method             
    Character(len=*), Intent(IN), Optional  :: focusDirection
    Real            , Intent(IN), Optional  :: focusLength     
    Real            , Intent(IN), Optional  :: focusCurrent     
    Real            , Intent(IN), Optional  :: pointingLength     
    Real            , Intent(IN), Optional  :: pointingP1         
    Real            , Intent(IN), Optional  :: pointingP2         
    Real            , Intent(IN), Optional  :: pointingP7         
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       mHead = mHeadDefault
    End If
    !
    If (Present(reset).And.reset) Then
       mHead = mHeadDefault
    End If
    !
    If (Present(measurement )) mHead%measurement = measurement        
    If (Present(sourceName  )) mHead%sourceName  = sourceName         
    If (Present(timeStamp   )) mHead%timeStamp   = timeStamp          
    If (Present(azimuth     )) mHead%azimuth     = azimuth            
    !
    If (Present(azimuth           )) Then
       mHead%azimuth            = azimuth            
       mHead%lAzimuth           = .True.
    End If
    !
    If (Present(elevation         )) Then
       mHead%elevation          = elevation          
       mHead%lElevation         = .True.
    End If
    !
    If (Present(refraction        )) Then
       mHead%refraction         = refraction         
       mHead%lRefraction        = .True.
    End If
    !
    If (Present(pressureAmbient   )) Then
       mHead%pressureAmbient    = pressureAmbient    
       mHead%lPressureAmbient   = .True.
    End If
    !
    If (Present(temperatureAmbient)) Then
       mHead%temperatureAmbient = temperatureAmbient 
       mHead%lTemperatureAmbient= .True.
    End If
    !
    If (Present(humidityAmbient   )) Then
       mHead%humidityAmbient    = humidityAmbient    
       mHead%lHumidityAmbient   = .True.
    End If
    !
    If (Present(switchingMode)) mHead%switchingMode = trim(switchingMode)
    If (Present(observingMode)) mHead%observingMode = observingMode      
    If (Present(method       )) mHead%method        = method             
    !
    If (Present(focusDirection)) mHead%focusDirection = focusDirection      
!
    If (Present(focusLength    )) Then
       mHead%focusLength     = focusLength     
       mHead%lFocusLength    = .True.
    End If
    !
    If (Present(focusCurrent    )) Then
       mHead%focusCurrent     = focusCurrent     
       mHead%lFocusCurrent    = .True.
    End If
    !
    If (Present(pointingLength    )) Then
       mHead%pointingLength     = pointingLength     
       mHead%lPointingLength    = .True.
    End If
    !
    If (Present(pointingP1        )) Then
       mHead%pointingP1         = pointingP1         
       mHead%lPointingP1        = .True.
    End If
    !
    If (Present(pointingP2        )) Then
       mHead%pointingP2         = pointingP2         
       mHead%lPointingP2        = .True.
    End If
    !
    If (Present(pointingP7        )) Then
       mHead%pointingP7         = pointingP7         
       mHead%lPointingP7        = .True.
    End If
    !
    Return
    !
  End Subroutine resultsToNCSsetMeasurementHeader
!!!
!!!
  Subroutine resultsToNCSsetScanId(                               &
       &                                       scanId           , &
       &                                       scanN            , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &                        
       &                          )
    !
    Character(len=*), Intent(IN), Optional  :: scanId
    Integer         , Intent(IN), Optional  :: scanN
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nScans = 0
       scans(:) = scanDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nScans = 0 
       scans(:) = scanDefault
    End If
    !
    If ((Present(scanId).Or.Present(scanN)) .And. nScans.Lt.nDimScans) Then
       nScans = nScans+1
    End If
    !
    ! TBD: could do a consistency check to ensure that ther is no
    !      "mixed" scan list, i.e., shoud be all Ids OR numbers!
    !
    If (Present(scanId))      scans(nScans)%scanId = scanId
    If (Present(scanN))       scans(nScans)%scanN  = scanN
    !
    Return
    !
  End Subroutine resultsToNCSsetScanId
!!!
!!!
  Subroutine resultsToNCSwriteMeasurementHeader(                  &
       &                                       error,             &
       &                                       errorC             &
       &                                       )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurement',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurementHeader',            &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    If (mHead%measurement.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'measurement',               &
            &              value   = mHead%measurement,           &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%sourceName.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'sourceName',                &
            &              value   = mHead%sourceName,            &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    ! TBD: timeStamp could be generated internally
    !
    If (mHead%timeStamp.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'timeStamp',                 &
            &              value   = mHead%timeStamp,             &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%lAzimuth) Then
       Write (valueC,*) mHead%azimuth
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'azimuth',                  &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'deg',                      &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lElevation) Then
       Write (valueC,*) mHead%elevation
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'elevation',                &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'deg',                      &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lRefraction) Then
       Write (valueC,*) mHead%refraction
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'refraction',               &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'arcsec',                   &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lTemperatureAmbient) Then
       Write (valueC,*) mHead%temperatureAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'temperatureAmbient',       &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'K',                        &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lPressureAmbient) Then
       Write (valueC,*) mHead%pressureAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'pressureAmbient',          &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = '10+2Pa',                   &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lHumidityAmbient) Then
       Write (valueC,*) mHead%humidityAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'humidityAmbient',          &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = '%',                        &
            &              error    =  errorXML)
    End If
    !
    If (mHead%switchingMode.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'switchingMode',             &
            &              value   = mHead%switchingMode,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%observingMode.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'observingMode',             &
            &              value   = mHead%observingMode,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%method.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'method',                    &
            &              value   = mHead%method,                &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    ! ***
    !
    ! TBD: parameters for specific mesurements, depending on 
    !      "measurement" and "observingMode"
    !
    valueC = mHead%measurement
    Call pakoXMLupper(valueC)
    !
    If (valueC.Eq.'FOCUS') Then                                   ! parameters for FOCUS
       !
       If (mHead%focusDirection.Ne.cNone) Then
          Call  pakoXMLwriteElement(                              &
               &              element = 'PARAM',                  &
               &              name    = 'focusDirection',         &
               &              value   = mHead%focusDirection,     &
               &              dataType = 'char',                  &
               &              error   = errorXML)
       End If
       !
       If (mHead%lFocusLength) Then
          Write (valueC,*) mHead%focusLength
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'focusLength',           &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'mm',                    &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lFocusCurrent) Then
          Write (valueC,*) mHead%focusCurrent
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'focusCurrent',          &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'mm',                    &
               &              error    =  errorXML)
       End If
       !
    End If                                                        ! end of Focus
    ! ***
    !
    If (valueC.Eq.'POINTING') Then                                ! parameters for POINTING
       !          
       If (mHead%lPointingLength) Then
          Write (valueC,*) mHead%pointingLength
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingLength',        &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'arcsec',                &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP1) Then
          Write (valueC,*) mHead%pointingP1
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP1',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP2) Then
          Write (valueC,*) mHead%pointingP2
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP2',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP7) Then
          Write (valueC,*) mHead%pointingP7
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP7',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                &
               &              error    =  errorXML)
       End If
       !
    End If                                                        ! end of Pointing
    ! ***
    !
    Call pakoXMLwriteStartElement("RESOURCE","scanList",          &
         &                         error=errorXML)
       !
    Call pakoXMLwriteStartElement("TABLE","scanList",             &
         &                         error=errorXML)
    !
    If (scans(1)%scanId .Ne. cNone) then
       Call pakoXMLwriteElement("FIELD","scanId",                 &
            &                         dataType="char",            &
            &                         error=errorXML)
    End If
    !
    If (scans(1)%scanN .Ne. iNone) Then
       Call pakoXMLwriteElement("FIELD","scanNumber",             &
            &                         dataType="int",             &
            &                         error=errorXML)
    End If
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    ! **
    Do ii = 1,nScans,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       If (scans(ii)%scanId .Ne. cNone) then
          valueC = scans(ii)%scanId
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
       End If
       !
       If (scans(ii)%scanN .Ne. iNone) then
          Write (valueC,*)                                        &
               &                  scans(ii)%scanN
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
       End If
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
       !
    End Do
    ! **
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","scanList",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","scanList",          &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurementHeader',            &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteMeasurementHeader
!!!
!!!
  Subroutine resultsToNCSwriteMeasurementEnd(                     &
       &                                       error,             &
       &                                       errorC             &
       &                                    )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurement',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)          
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteMeasurementEnd
!!!
!!!
  Subroutine resultsToNCSsetReceiver(                             &
       &                                       name             , &
       &                                       frequency        , &
       &                                       frequencyImage   , &
       &                                       offset           , &
       &                                       centerIF         , &
       &                                       lineName         , &
       &                                       sideBand         , &
       &                                       doppler          , &
       &                                       width            , &
       &                                       effForward       , &
       &                                       effBeam          , &
       &                                       scale            , &
       &                                       gainImage        , &
       &                                       tempAmbient      , &
       &                                       tempCold         , &
       &                                       xOffsetNasmyth   , &
       &                                       yOffsetNasmyth   , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                            )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Real*8          , Intent(IN), Optional  :: frequency      
    Real*8          , Intent(IN), Optional  :: frequencyImage     
    Real*8          , Intent(IN), Optional  :: offset        
    Real*8          , Intent(IN), Optional  :: centerIF
    Character(len=*), Intent(IN), Optional  :: lineName
    Character(len=*), Intent(IN), Optional  :: sideBand
    Character(len=*), Intent(IN), Optional  :: doppler
    Character(len=*), Intent(IN), Optional  :: width
    Real            , Intent(IN), Optional  :: effForward
    Real            , Intent(IN), Optional  :: effBeam
    Character(len=*), Intent(IN), Optional  :: scale
    Real            , Intent(IN), Optional  :: gainImage
    Real            , Intent(IN), Optional  :: tempAmbient
    Real            , Intent(IN), Optional  :: tempCold
    !
    Real            , Intent(IN), Optional  :: xOffsetNasmyth
    Real            , Intent(IN), Optional  :: yOffsetNasmyth
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nRec = 0
       receivers(:) = receiverDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nRec = 0
       receivers(:) = receiverDefault
    End If
    !
    If (Present(name) .And. nRec.Lt.nDimReceivers) Then
       nRec = nRec+1
       receivers(nRec)%name        = name
       receivers(nRec)%isConnected = .True.
    End If
    !
    If (Present(frequency))      receivers(nRec)%frequency%value      = frequency      
    If (Present(frequencyImage)) receivers(nRec)%frequencyImage%value = frequencyImage
    If (Present(offset))         receivers(nRec)%offset%value         = offset         
    If (Present(centerIF))       receivers(nRec)%centerIF%value       = centerIF       
    If (Present(lineName))       receivers(nRec)%lineName             = lineName       
    If (Present(sideBand))       receivers(nRec)%sideBand             = sideBand       
    If (Present(doppler))        receivers(nRec)%doppler              = doppler       
    If (Present(width))          receivers(nRec)%width                = width          
    If (Present(effForward))     receivers(nRec)%effForward           = effForward     
    If (Present(effBeam))        receivers(nRec)%effBeam              = effBeam        
    If (Present(scale))          receivers(nRec)%scale                = scale          
    If (Present(gainImage))      receivers(nRec)%gainImage%value      = gainImage      
    If (Present(tempAmbient))    receivers(nRec)%tempAmbient          = tempAmbient    
    If (Present(tempCold))       receivers(nRec)%tempCold             = tempCold       
    If (Present(xOffsetNasmyth)) receivers(nRec)%xOffsetNasmyth       = xOffsetNasmyth
    If (Present(yOffsetNasmyth)) receivers(nRec)%yOffsetNasmyth       = yOffsetNasmyth
    !
    Return
    !
  End Subroutine resultsToNCSsetReceiver
!!!
!!!
  Subroutine resultsToNCSsetCalibrationResults(                   &
       &                                       name             , &
       &                                       frequency        , &
       &                                       frequencyImage   , &
       &                                       lineName         , &
       &                                       sideBand         , &
       &                                       effForward       , &
       &                                       effBeam          , &
       &                                       gainImage        , &
       &                                       tempAmbient      , &
       &                                       tempCold         , &
       &                                       xOffsetNasmyth   , &
       &                                       yOffsetNasmyth   , &
       &                                       lcalof           , &
       &                                       bcalof           , &
       &                                       h2omm            , &
       &                                       trx              , &
       &                                       tsys             , &
       &                                       tcal             , &
       &                                       tatms            , &
       &                                       tatmi            , &
       &                                       tauzen           , &
       &                                       tauzenImage      , &
       &                                       pcold            , &
       &                                       phot             , &
       &                                       psky             , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &             
       &                            )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Real*8          , Intent(IN), Optional  :: frequency      
    Real*8          , Intent(IN), Optional  :: frequencyImage     
    Character(len=*), Intent(IN), Optional  :: lineName
    Character(len=*), Intent(IN), Optional  :: sideBand
    Real            , Intent(IN), Optional  :: effForward
    Real            , Intent(IN), Optional  :: effBeam
    Real            , Intent(IN), Optional  :: gainImage
    Real            , Intent(IN), Optional  :: tempAmbient
    Real            , Intent(IN), Optional  :: tempCold
    Real            , Intent(IN), Optional  :: xOffsetNasmyth
    Real            , Intent(IN), Optional  :: yOffsetNasmyth
    !
    Real            , Intent(IN), Optional  :: lcalof
    Real            , Intent(IN), Optional  :: bcalof
    Real            , Intent(IN), Optional  :: h2omm
    Real            , Intent(IN), Optional  :: trx
    Real            , Intent(IN), Optional  :: tsys
    Real            , Intent(IN), Optional  :: tcal
    Real            , Intent(IN), Optional  :: tatms
    Real            , Intent(IN), Optional  :: tatmi
    Real            , Intent(IN), Optional  :: tauzen
    Real            , Intent(IN), Optional  :: tauzenImage
    Real            , Intent(IN), Optional  :: pcold
    Real            , Intent(IN), Optional  :: phot
    Real            , Intent(IN), Optional  :: psky
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nRec = 0
       receivers(:) = receiverDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nRec = 0
       receivers(:) = receiverDefault
    End If
    !
    If (Present(name) .And. nRec.Lt.nDimReceivers) Then
       nRec = nRec+1
       receivers(nRec)%name        = name
       receivers(nRec)%isConnected = .True.
    End If
    !
    If (Present(frequency))      receivers(nRec)%frequency%value      = frequency      
    If (Present(frequencyImage)) receivers(nRec)%frequencyImage%value = frequencyImage
    If (Present(lineName))       receivers(nRec)%lineName             = lineName       
    If (Present(sideBand))       receivers(nRec)%sideBand             = sideBand       
    If (Present(effForward))     receivers(nRec)%effForward           = effForward     
    If (Present(effBeam))        receivers(nRec)%effBeam              = effBeam        
    If (Present(gainImage))      receivers(nRec)%gainImage%value      = gainImage      
    If (Present(tempAmbient))    receivers(nRec)%tempAmbient          = tempAmbient    
    If (Present(tempCold))       receivers(nRec)%tempCold             = tempCold       
    If (Present(xOffsetNasmyth)) receivers(nRec)%xOffsetNasmyth       = xOffsetNasmyth
    If (Present(yOffsetNasmyth)) receivers(nRec)%yOffsetNasmyth       = yOffsetNasmyth
    If (Present(lcalof))         receivers(nRec)%lcalof          = lcalof
    If (Present(bcalof))         receivers(nRec)%bcalof          = bcalof
    If (Present(h2omm))          receivers(nRec)%h2omm           = h2omm 
    If (Present(trx))            receivers(nRec)%trx             = trx
    If (Present(tsys))           receivers(nRec)%tsys            = tsys
    If (Present(tcal))           receivers(nRec)%tcal            = tcal
    If (Present(tatms))          receivers(nRec)%tatms           = tatms
    If (Present(tatmi))          receivers(nRec)%tatmi           = tatmi
    If (Present(tauzen))         receivers(nRec)%tauzen          = tauzen
    If (Present(tauzenImage))    receivers(nRec)%tauzenImage     = tauzenImage
    If (Present(pcold))          receivers(nRec)%pcold           = pcold
    If (Present(phot))           receivers(nRec)%phot            = phot 
    If (Present(psky))           receivers(nRec)%psky            = psky 

    !
    Return
    !
  End Subroutine resultsToNCSsetCalibrationResults
!!!
!!!
  Subroutine resultsToNCSwriteReceivers(                          &
       &                                       error,             &
       &                                       errorC             &
       &                               )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'receivers',                    &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'TABLE',                        &
         &              name    = 'receivers',                    &
         &              error   = errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiverName",              &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","lineName",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequency",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","sideBand",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","doppler",                   &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","width",                     &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","gainImage",                 &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tempCold",                  &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tempAmbient",               &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","effForward",                &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","effBeam",                   &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","scale",                     &
         &                         dataType="char",               &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","centerIF",                  &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequencyImage",            &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","xOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","yOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)                          
    !                                                                       
    ! **                                                                    
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimReceivers,1
       If (receivers(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%name
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%lineName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%frequency%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%sideBand
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%doppler
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%width
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%gainImage%value
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%tempCold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%tempAmbient
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%effForward
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%effBeam
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%scale
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%offset%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%centerIF%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &        receivers(ii)%frequencyImage%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%xOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%yOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","receivers",            &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","receivers",         &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteReceivers
!!!
!!!
  Subroutine resultsToNCSwriteCalibrationResults(                 &
       &                                       error,             &
       &                                       errorC             &
       &                                 )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'calibration',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'TABLE',                        &
         &              name    = 'calibration',                  &
         &              error   = errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiverName",              &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","lineName",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequency",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","sideBand",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","gainImage",                 &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tempCold",                  &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tempAmbient",               &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","effForward",                &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","effBeam",                   &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","frequencyImage",            &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","xOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","yOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","lcalof",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","bcalof",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","h2omm",                     &
         &                         dataType="double",             &
         &                         unit="mm",                     &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","trx",                       &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tsys",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tcal",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tatms",                     &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tatmi",                     &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tauzen",                    &
         &                         dataType="double",             &
         &                         unit="Neper",                  &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","tauzenImage",               &
         &                         dataType="double",             &
         &                         unit="Neper",                  &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","pcold",                     &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","phot",                      &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteElement("FIELD","psky",                      &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)                          
    !                                                                       
    ! **                                                                    
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)                          
    !                                                                       
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimReceivers,1
       If (receivers(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%name
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%lineName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%frequency%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%sideBand
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%gainImage%value
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%tempCold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%tempAmbient
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%effForward
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%effBeam
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &        receivers(ii)%frequencyImage%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%xOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%yOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%lcalof   
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%bcalof   
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%h2omm
          valueComment = 'mm'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%trx
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%tsys
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%tcal
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%tatms
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%tatmi
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%tauzen
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%tauzenImage
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%pcold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%phot
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  receivers(ii)%psky
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","calibration",          &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","calibration",       &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteCalibrationResults
!!!
!!!
  Subroutine resultsToNCSsetBackend(                              &
       &                                       name             , &
       &                                       nPart            , &
       &                                       resolution       , &
       &                                       bandwidth        , &
       &                                       fShift           , &
       &                                       receiver         , &
       &                                       nChannels        , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                           )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Integer         , Intent(IN), Optional  :: nPart
    Real            , Intent(IN), Optional  :: resolution
    Real            , Intent(IN), Optional  :: bandwidth          
    Real            , Intent(IN), Optional  :: fShift        
    Character(len=*), Intent(IN), Optional  :: receiver
    Integer         , Intent(IN), Optional  :: nChannels
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nBack = 0
       backends(:) = backendDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nBack = 0 
       backends(:) = backendDefault
    End If
    !
    If (Present(name) .And. nBack.Lt.nDimBackends) Then
       nBack = nBack+1
       backends(nBack)%name        = name
       backends(nBack)%isConnected = .True.
    End If
    !
    If (Present(nPart))      backends(nBack)%nPart        = nPart
    If (Present(resolution)) backends(nBack)%resolution   = resolution
    If (Present(bandwidth))  backends(nBack)%bandwidth    = bandwidth
    If (Present(fShift))     backends(nBack)%fShift       = fShift
    If (Present(receiver))   backends(nBack)%receiverName = receiver
    If (Present(nChannels))  backends(nBack)%nChannels    = nChannels
    !
    Return
    !
  End Subroutine resultsToNCSsetBackend
!!!
!!!
  Subroutine resultsToNCSwriteBackends(                           &
       &                                       error,             &
       &                                       errorC             &
       &                              )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","backends",          &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","backends",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","resolution",                &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","bandwidth",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","fShift",                    &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiver",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nChannels",                 &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimBackends,1
       If (backends(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = backends(ii)%name
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,*)                                        &
               &                  backends(ii)%nPart
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%resolution/1.0D3
          Write (valueComment,*) backends(ii)%resolution,'MHz' 
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%bandwidth/1.0D3
          Write (valueComment,*) backends(ii)%bandwidth,'MHz' 
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%fShift/1.0D3
          Write (valueComment,*) backends(ii)%fShift,'MHz' 
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = backends(ii)%receiverName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,*)                                        &
               &                  backends(ii)%nChannels
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    ! ***
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","backends",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","backends",          &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteBackends
!!!
!!!
  Subroutine resultsToNCSsetFocusResults(                         &
       &                                       backendName      , &
       &                                       nPart            , &
       &                                       focus            , &
       &                                       offset           , &
       &                                       rmsResidual      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &                        
       &                                   )
    !
    Character(len=*), Intent(IN), Optional  :: backendName  
    Integer         , Intent(IN), Optional  :: nPart        
    Type(resultT)   , Intent(IN), Optional  :: focus
    Type(resultT)   , Intent(IN), Optional  :: offset       
    Real*4          , Intent(IN), Optional  :: rmsResidual  
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical         , Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Integer :: ii
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nFocusResults = 0
       FocusResults(:) = FocusResultDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nFocusResults = 0
       FocusResults(:) = FocusResultDefault
    End If
    !
    If (Present(backendName) .And. nFocusResults.Lt.nDimResults) Then
       nFocusResults = nFocusResults+1
       ii               = nFocusResults
       focusResults(ii)%backendName = backendName
    End If
    !
    If (Present(nPart))       focusResults(ii)%nPart        = nPart
    If (Present(focus))       focusResults(ii)%focus        = focus
    If (Present(offset))      focusResults(ii)%offset       = offset
    If (Present(rmsResidual)) focusResults(ii)%rmsResidual  = rmsResidual
    !
!!$    write (6,*) '  focusResults(ii)%nPart    ',  focusResults(ii)%nPart
!!$    write (6,*) '  focusResults(ii)%focus    ',  focusResults(ii)%focus
!!$    write (6,*) '  focusResults(ii)%offset   ',  focusResults(ii)%offset 
!!$    write (6,*) '  focusResults(ii)%rmsResidual   ', focusResults(ii)%rmsResidual
    !
    Return
    !
  End Subroutine resultsToNCSsetFocusResults
!!!
!!!
  Subroutine resultsToNCSwriteFocusResults(                       &
       &                                       error,             &
       &                                       errorC             &
       &                                     )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","results",           &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","focus",                &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","focusError",           &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offsetError",               &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","rmsResidual",               &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nFocusResults,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       valueC = focusResults(ii)%backendName
       Call pakoXMLcase(valueC,error=errorXML)
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,*)                                           &
            &                  focusResults(ii)%nPart
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%focus%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%focus%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%offset%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%offset%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%rmsResidual
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
    End Do
    ! **
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","results",           &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteFocusResults
!!!
!!!
  Subroutine resultsToNCSsetPointingResults(                      &
       &                                       backendName      , &
       &                                       nPart            , &
       &                                       direction        , & 
       &                                       correction       , &
       &                                       peak             , &
       &                                       integral         , &
       &                                       offset           , &
       &                                       width            , &
       &                                       rmsResidual      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &                        
       &                                   )
    !
    Character(len=*), Intent(IN), Optional  :: backendName  
    Integer         , Intent(IN), Optional  :: nPart        
    Character(len=*), Intent(IN), Optional  :: direction    
    Type(resultT)   , Intent(IN), Optional  :: correction   
    Type(resultT)   , Intent(IN), Optional  :: peak         
    Type(resultT)   , Intent(IN), Optional  :: integral     
    Type(resultT)   , Intent(IN), Optional  :: offset       
    Type(resultT)   , Intent(IN), Optional  :: width        
    Real*4          , Intent(IN), Optional  :: rmsResidual  
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical         , Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Integer :: ii
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nPointingResults = 0
       PointingResults(:) = PointingResultDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nPointingResults = 0
       PointingResults(:) = PointingResultDefault
    End If
    !
    If (Present(backendName) .And. nPointingResults.Lt.nDimResults) Then
       nPointingResults = nPointingResults+1
       ii               = nPointingResults
       pointingResults(ii)%backendName = backendName
    End If
    !
    If (Present(nPart))       pointingResults(ii)%nPart        = nPart
    If (Present(direction))   pointingResults(ii)%direction    = direction
    If (Present(correction))  pointingResults(ii)%correction   = correction
    If (Present(peak))        pointingResults(ii)%peak         = peak
    If (Present(integral))    pointingResults(ii)%integral     = integral
    If (Present(offset))      pointingResults(ii)%offset       = offset
    If (Present(width))       pointingResults(ii)%width        = width
    If (Present(rmsResidual)) pointingResults(ii)%rmsResidual  = rmsResidual
    !
    Return
    !
  End Subroutine resultsToNCSsetPointingResults
!!!
!!!
  Subroutine resultsToNCSwritePointingResults(                    &
       &                                       error,             &
       &                                       errorC             &
       &                                     )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","results",           &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","direction",                 &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","correction",                &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","correctionError",           &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","peak",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","peakError",                 &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","integral",                  &
         &                         dataType="double",             &
         &                         unit="K.arcsec",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","integralError",             &
         &                         dataType="double",             &
         &                         unit="K.arcsec",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offsetError",               &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","width",                     &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","widthError",                &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","rmsResidual",               &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nPointingResults,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       valueC = pointingResults(ii)%backendName
       Call pakoXMLcase(valueC,error=errorXML)
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,*)                                           &
            &                  pointingResults(ii)%nPart
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       valueC = pointingResults(ii)%direction
       Call pakoXMLcase(valueC,error=errorXML)
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &         pointingResults(ii)%correction%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &         pointingResults(ii)%correction%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%peak%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%peak%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%integral%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%integral%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%offset%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%offset%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%width%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%width%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%rmsResidual
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
    End Do
    ! **
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","results",           &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwritePointingResults
!!!
!!!
  Subroutine resultsToNCSwriteEnd(                                &
       &                                       error,             &
       &                                       errorC             &
       &                         )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'VOTABLE',                      &
         &              space   = 'before',                       &
         &              error   = errorXML)          
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine resultsToNCSwriteEnd
!!!
!!!
End Module moduleResultsToNCS
!!!

subroutine fits_class(set,line,r,error,user_function)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_class
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support for command FITS
  !
  ! GILDAS Syntax
  !     FITS File.fits FROM File.gdf /STYLE [/XTENSION Number]
  !     FITS File.gdf TO File.fits /STYLE /BITS
  ! Launches the FITS_GILDAS or GILDAS_FITS task to do the job.
  !
  ! CLASS Syntax
  !     FITS READ File.fits  [/CHECK]
  !     FITS WRITE File.fits [/BITS Nbits] [/MODE SPECTRUM|INDEX] [/CHECK]
  !
  ! Option sequence
  !     /BITS
  !     /STYLE
  !     /XTENSION
  !     /MODE
  !     /CHECK
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Command line
  type(observation),   intent(inout) :: r              !
  logical,             intent(inout) :: error          ! Error status
  logical,             external      :: user_function  ! intent(in)
  ! Local
  integer            :: n, nkey
  integer, parameter :: mstyle=5
  integer, parameter :: mact=2
  character(len=filename_length) :: argum
  character(len=12) :: key,action(mact)
  data action/'READ','WRITE'/
  !
  ! Check GILDAS syntax
  call sic_ch(line,0,2,argum,n,.true.,error)
  if (error) return
  call sic_upper(argum)
  if (argum.eq.'FROM' .or. argum.eq.'TO') then
     call fits_gildas(line,error)
     return
  endif
  !
  ! Else, use CLASS syntax
  call sic_ke(line,0,1,argum,n,.true.,error)
  call sic_ambigs('FITS',argum,key,nkey,action,mact,error)
  if (error) return
  !
  if (key.eq.'READ') then
     call fits_class_read(set,line,r,user_function,error)
  elseif (key.eq.'WRITE') then
     call fits_class_write(set,line,r,user_function,error)
  else
     call class_message(seve%e,'FITS_CLASS',key//' not yet supported')
     error = .true.
  endif
  !
end subroutine fits_class
!
subroutine fits_class_read(set,line,r,user_function,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_class_read
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS FITS Support routine for command FITS READ
  ! Read current FITS file
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Command line
  type(observation),   intent(inout) :: r              !
  logical,             external      :: user_function  !
  logical,             intent(inout) :: error          ! Error status
  ! Local
  character(len=*), parameter :: proc='FITS_CLASS_READ'
  character(len=256) :: argum
  logical :: check
  integer :: n
  !
  error = .false.
  check = sic_present(5,0) ! Is /CHECK option present?
  argum = ' '
  call sic_ch (line,0,2,argum,n,.false.,error)
  if (error) return
  if (argum.ne.'*') then
     ! READ Fits_file
     call gfits_open(argum,'IN',error)
     if (error) return
     call toclass(set,r,check,user_function,error)
     call gfits_close(error)
  else
     ! READ *
     call class_message(seve%e,proc,'FITS READ * not yet implemented.')
  endif
end subroutine fits_class_read
!
subroutine fits_class_write(set,line,r,user_function,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_class_write
  use class_fits
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS
  ! Support routine for command
  !   FITS WRITE File.fits [/BITS Nbits] [/MODE SPECTRUM|INDEX] [/CHECK]
  ! Option sequence
  !   1  /BITS
  !   2  /STYLE
  !   3  /XTENSION
  !   4  /MODE
  !   5  /CHECK
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Command line
  type(observation),   intent(inout) :: r              !
  logical,             external      :: user_function  !
  logical,             intent(inout) :: error          ! Error status
  ! Local
  character(len=*), parameter :: proc='FITS_CLASS_WRITE'
  logical :: check
  integer :: n,nkey
  character(len=256) :: argum
  character(len=message_length) :: mess
  integer, parameter :: mvocab=3
  character(len=12) :: vocab(mvocab),the_fits_mode
  data vocab/'SPECTRUM','INDEX','NONE'/
  !
  ! Decode input line arguments
  !
  ! /BITS option
  fits%head%desc%nbit = snbit
  if (sic_present(1,0)) then
    call sic_ch (line,1,1,argum,n,.true.,error)
    if (error) return
    if (argum.eq.'I*2') then
      fits%head%desc%nbit = 16
    elseif (argum.eq.'I*4') then
      fits%head%desc%nbit = 32
    elseif (argum.eq.'R*4') then
      fits%head%desc%nbit = -32
    else
      call sic_i4(line,1,1,fits%head%desc%nbit,.true.,error)
      if (error) return
      if (fits%head%desc%nbit.ne.16 .and.  &
          fits%head%desc%nbit.ne.32 .and.  &
          fits%head%desc%nbit.ne.-32) then
        call class_message(seve%e,proc,'Invalid number of bits')
        error = .true.
        return
      endif
    endif
  endif
  !
  ! /MODE option
  argum = fits_mode
  if (sic_present(4,0)) then
     call sic_ke (line,4,1,argum,nkey,.false.,error)
     call sic_ambigs('FITS',argum,the_fits_mode,nkey,vocab,mvocab,error)
  else
     call class_message(seve%e,proc,'Mode is undefined')
     error = .true.
     return
  endif
  !
  check = sic_present(5,0)
  !
  if (the_fits_mode.eq.'INDEX') then !
     ! Write all spectra as a Binary Table
     call sic_ch(line,0,2,argum,n,.true.,error)
     if (error) return
     !
     call gfits_open(argum,'OUT',error)
     if (error)  return
     call fits_save_index(set,check, user_function, error)
     call gfits_close(error)
     !
  elseif (the_fits_mode.eq.'SPECTRUM') then
     ! Write current spectrum
     if (r%head%xnum.eq.0) then
        call class_message(seve%e,proc,'No spectrum in memory.')
        error = .true.
        return
     endif
     ! Get the output file name
     call sic_ch (line,0,2,argum,n,.false.,error)
     if (error)  return
     !
     call gfits_open(argum,'OUT',error)
     if (error)  return
     call las_tofits(set,r,check,error)
     if (error) then
        write(mess,'(A,A,A)') 'File ',trim(argum),' incomplete'
        call class_message(seve%e,proc,mess)
        goto 99
     endif
     call gfits_close(error)
     !
  else
     ! Undefined
     call class_message(seve%e,proc,'Mode is undefined')
     error = .true.
  endif
  return
  !
99 error = .false.
  call gfits_close(error)       ! Just in case
  error = .true.
end subroutine fits_class_write
!
subroutine fits_select (line,error)
  use gkernel_interfaces
  use gbl_message
  use class_fits
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS Support routine for command SELECT.
  !     SET FITS BITS Nbits
  !     SET FITS MODE Spectrum|Index|None
  !		Define optional parameters for writing
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  logical,          intent(out) :: error  ! Error status
  ! Local
  character(len=message_length) :: mess
  integer(kind=4) :: n,nkey,nbit
  integer(kind=4), parameter :: mact=2
  integer(kind=4), parameter :: mode=3
  character(len=12) :: argum,key,action(mact),modes(mode)
  ! Data
  data action/'BITS','MODE'/
  data modes/'SPECTRUM','INDEX','NONE'/
  !
  call sic_ke(line,0,2,argum,n,.true.,error)
  call sic_ambigs('FITS',argum,key,nkey,action,mact,error)
  if (error) return
  !
  if (key.eq.'BITS') then
     argum = ' '
     call sic_ch (line,0,3,argum,n,.false.,error)
     if (error) return
     if (argum.eq.'I*2') then
        nbit = 16
     elseif (argum.eq.'I*4') then
        nbit = 32
     elseif (argum.eq.'R*4') then
        nbit = -32
     else
        nbit = snbit
        call sic_i4(line,0,3,nbit,.false.,error)
        if (error) return
     endif
     if (nbit.eq.16 .or. nbit.eq.32 .or. nbit.eq.-32) then
        snbit = nbit
        write(mess,'(A,I4)') 'Number of bits ',snbit
        call class_message(seve%i,'FITS_SELECT',mess)
     else
        call class_message(seve%e,'FITS_SELECT','Invalid number of bits')
        error = .true.
     endif
     !
  elseif (key.eq.'MODE') then
     argum = fits_mode
     call sic_ke (line,0,3,argum,n,.false.,error)
     if (error) return
     call sic_ambigs('FITS',argum,key,nkey,modes,mode,error)
     if (error) return
     fits_mode = key
     call class_message(seve%i,'FITS_SELECT','Mode is '//fits_mode)
     !
  else
     call class_message(seve%e,'FITS_SELECT','Unknown keyword '//argum)
     error = .true.
  endif
end subroutine fits_select

module mira 
!
  type primary_header
     integer naxis
     logical simple
     integer bitpix
     logical extend
     character telescop*13
     character origin*32
     character creator*32
     character mbftsver*11
  end type primary_header
!
  type scan_header
     character telescop*13
     real*8    sitelong
     real*8    sitelat
     real*4    siteelev
     character projid*12
     character obsid*12
     integer   scannum
     character date_obs*23
     real*8    mjd
     real*8    lst
     integer   nobs
     integer   nobstotal
     real*8    ut1utc
     real*8    taiutc
     real*8    etutc
     real*8    gpstai
     character ctype1*8
     character ctype2*8
     character radecsys*32
     real*4    equinox
     real*8    crval1
     real*8    crval2
     real*8    lonpole
     real*8    latpole
     character object*20
     real*8    longobj
     real*8    latobj
     real*8    longoff
     real*8    latoff
     character calcode*4
     logical   movefram
     real*8    peridate
     real*8    peridist
     real*8    longasc
     real*8    omega
     real*8    inclinat
     real*8    eccentr
     real*8    orbepoch
     real*8    orbeqnox
     real*8    distance
     character scantype*20
     character scanmode*20
     character scangeom*20
     character scandir*4
     integer   scanline
     integer   scanrpts
     real*8    scanlen
     real*8    scanxvel
     real*8    scantime
     real*8    scanxspc
     real*8    scanyspc
     real*8    scanskew
     real*8    scanpar1
     real*8    scanpar2
     character crocycle*20
     logical   zigzag
     integer   trandist
     integer   tranfreq
     integer   tranfocu
     logical   wobused
     real*8    wobthrow
     character wobdir*4
     real*4    wobcycle
     character wobmode*20
     integer   nfebe
     real*4    ia
     real*4    ca
     real*4    npae
     real*4    an
     real*4    aw
     real*4    ie
     real*4    ecec
     real*4    zflx 
  end type scan_header
!
  type scan_data
     real*8, dimension(:), pointer              :: longoff => null()
     real*8, dimension(:), pointer              :: latoff => null()
     character(len=32), dimension(:), pointer   :: febe => null()
  end type scan_data
!
  type febepar_header
     character   :: veloconv*8
     character   :: febe*32
     integer     :: scannum
     character   :: date_obs*23
     character   :: dewcabin*10
     character   :: dewrtmod*5
     real*4      :: dewang
     integer     :: febeband
     integer     :: febefeed 
     integer     :: nusefeed
     character   :: swtchmod*20
     character   :: widenar*6
     integer     :: nphases 
     real*4      :: frqoff1
     real*4      :: frqoff2
     real*4      :: frqthrow
     real*4      :: iarx
     real*4      :: carx
     real*4      :: ierx
     real*4      :: ifcenter
     real*4      :: ececrx
     real*4      :: zflxrx
  end type febepar_header
!
  type febepar_data
     integer, dimension(:),  pointer  :: usefeed => null()
     character, dimension(:), pointer :: feedtype => null()
     real*8, dimension(:), pointer    :: feedoffx => null()
     real*8, dimension(:), pointer    :: feedoffy => null()
     integer                          :: reffeed
     character, dimension(:), pointer :: polty => null()
     real*4, dimension(:), pointer    :: pola => null()
     real*4, dimension(:,:), pointer  :: apereff => null()
     real*4, dimension(:,:), pointer  :: beameff => null()
     real*4, dimension(:,:), pointer  :: etafss => null()
     real*4, dimension(:,:), pointer  :: hpbw => null()
     real*4, dimension(:,:), pointer  :: antgain  => null()
     real*4, dimension(:), pointer    :: bolcalfc => null()
     real*4, dimension(:,:), pointer  :: flatfiel => null()
     real*4, dimension(:,:), pointer  :: gainimag => null()
     real*4, dimension(:), pointer    :: gainele1  => null()
     real*4, dimension(:), pointer    :: gainele2 => null()
  end type febepar_data
!
  type arraydata_header
     character febe*32
     integer   baseband
     integer   scannum
     integer   obsnum
     character date_obs*23
     integer   channels
     integer   usedchan
     integer   dropchan
     real*8    freqres
     real*8    bandwid
     character molecule*20
     character transiti*20
     real*8    restfreq
     character sideband*3
     real*8    sbsep
     character ctyp4_1*8
     integer   crpx4_1
     integer   crvl4_1
     integer   cd3a_11
     character wcsnm4f*8
     character ctyp4f_2*8
     real*4    crpx4f_2
     real*8    crvl4f_2
     real*8    cd4f_21
     character cuni4f_2*8
     character spec4f_2*8
     character sobs4f_2*8
     character wcsnm4r*8
     character ctyp4r_2*8
     real*4    crpx4r_2
     real*8    crvl4r_2
     real*8    cd4r_21
     character cuni4r_2*8
     character spec4r_2*8
     character sobs4r_2*8
     real*4    vsou4r_2
     real*4    vsys4r_2
     real*8    restfreqO
  end type arraydata_header
!
  type arraydata_data
     real*8, dimension(:), pointer           :: mjd => null()
     real*8, dimension(:), pointer           :: integtim => null()
                                                         ! in MBFITS v.1.54 
                                                         ! removed from this
                                                         ! section (now in 
                                                         ! DATAPAR)
     character(len=4), dimension(:,:),pointer :: iswitch => null()
                                                         ! is in DATAPAR in 
                                                         ! MBFITS, for MIRA
                                                         ! more practical here
     real*8, dimension(:,:,:,:), pointer     :: data => null()
  end type arraydata_data
!
  type monitor_header
     integer                             :: scannum
     integer                             :: obsnum
     real*8, dimension(3)                :: iaobs_caobs_ieobs
     real*8, dimension(3)                :: focobs_x_y_z
     real*8, dimension(3)                :: phiobs_x_y_z
     character(len=23)                   :: date_obs
  end type monitor_header
!
  type monitor_data
     integer, dimension(:), pointer         :: subScan => null()
     integer, dimension(:), pointer         :: subScanFast => null()
     integer, dimension(:), pointer         :: subScanSubref => null()
     real*8, dimension(:), pointer          :: mjd => null()
     real*8, dimension(:), pointer          :: lst => null()
     character(len=30), dimension(:), pointer :: monpoint => null()
     real*8, dimension(:), pointer          :: monvalue => null()
     character(len=8), dimension(:), pointer:: monunits => null()
     real*8, dimension(:,:), pointer        :: antennadata => null()
     real*8, dimension(:,:), pointer        :: encoder_az_el => null()
     real*8, dimension(:,:), pointer        :: tracking_az_el => null()
     real*8, dimension(:), pointer          :: antenna_az_el => null()
     real*8, dimension(:), pointer          :: parangle => null()
     real*8, dimension(:), pointer          :: baslat => null()
     real*8, dimension(:), pointer          :: baslong  => null()
     real*8, dimension(:), pointer          :: longoff => null()
     real*8, dimension(:), pointer          :: latoff => null()
     real*8, dimension(:,:), pointer        :: tamb_p_humid => null()
     real*8, dimension(:,:), pointer        :: wind_dir_vavg_vmax => null()
     real*8, dimension(:,:), pointer        :: thotcold => null()
     real*8, dimension(:), pointer          :: refractio => null()
     real*8, dimension(:,:), pointer        :: focus_x_y_z => null()
     real*8, dimension(:,:), pointer        :: dfocus_x_y_z => null()
     real*8, dimension(:,:), pointer        :: phi_x_y_z => null()
     real*8, dimension(:,:), pointer        :: dphi_x_y_z => null()
  end type monitor_data
!
  type antenna_data
     real*8, dimension(:,:), allocatable    :: encoder_az_el
     real*8, dimension(:,:), allocatable    :: tracking_az_el
     real*8, dimension(:,:), allocatable    :: slowtrace
  end type antenna_data
!
  type calibration
     character*32                        :: febe
     integer, dimension(:), pointer      :: channels => null()
     real*8                              :: lcalof, bcalof ! offsets for 
                                                           ! sky subscan of 
                                                           ! a calibration,
     real*8, dimension(:), pointer       :: crvl4f_2 => null()
     real*8, dimension(:), pointer       :: cd4f_21 => null()
     real*8, dimension(:,:,:), pointer   :: gainarray => null()
     real*8, dimension(:,:,:), pointer   :: gainimage => null()
     real*8, dimension(:,:,:), pointer   :: phasearray => null()
     real*8, dimension(:,:,:), pointer   :: tcal => null()
     real*8, dimension(:,:,:), pointer   :: tauzen => null()
     real*8, dimension(:,:,:), pointer   :: tauzenImage => null()
     real*8, dimension(:,:,:), pointer   :: tauzenDry => null()
     real*8, dimension(:,:,:), pointer   :: tauzenImageDry => null()
     real*8, dimension(:,:,:), pointer   :: tauzenWet => null()
     real*8, dimension(:,:,:), pointer   :: tauzenImageWet => null()
     real*8, dimension(:,:,:), pointer   :: tatms => null()
     real*8, dimension(:,:,:), pointer   :: tatmi => null()
     real*8, dimension(:,:,:), pointer   :: temis => null()
     real*8, dimension(:,:,:), pointer   :: temii => null()
     real*8, dimension(:,:,:), pointer   :: tsys => null()
     real*8, dimension(:,:,:), pointer   :: trx => null()
     real*8, dimension(:,:,:), pointer   :: h2omm => null()
     real*8, dimension(:,:,:), pointer   :: psky       => null()
     real*8, dimension(:,:,:), pointer   :: phot       => null()
     real*8, dimension(:,:,:), pointer   :: pcold      => null()
     real*8, dimension(:,:,:), pointer   :: pgrid      => null()
  end type calibration 
!
  type datapar_header
     integer   scannum
     integer   obsnum
     integer   channels
     real*4    crpx4f_2         ! reference pixel for frequency scale
     real*4    crpx4r_2         ! reference pixel for velocity scale
     real*8    crvl4f_2         ! frequency [Hz] at reference pixel
     real*8    crvl4r_2         ! rest velocity [km/s] at reference pixel
     real*8    cd4f_21          ! frequency channel spacing [Hz]
     real*8    cd4r_21          ! velocity channel spacing [Hz]
     character date_obs*23
     character febe*32
     real*8    lst
     character obstype
     logical   dpblock
     character obstatus*10
  end type datapar_header
!
  type datapar_data
     integer, dimension(:), pointer      :: integnum => null()
     integer, dimension(:), pointer      :: subscan => null()
     integer, dimension(:), pointer      :: nints => null()
     real*8, dimension(:), pointer       :: mjd => null()
     real*8, dimension(:), pointer       :: lst => null()
     real*8, dimension(:), pointer       :: midtime => null()
     real*8, dimension(:), pointer       :: integtim => null()
     real*8, dimension(:), pointer       :: longoff => null()
     real*8, dimension(:), pointer       :: latoff => null()
     real*8, dimension(:), pointer       :: azimuth => null()
     real*8, dimension(:), pointer       :: elevatio => null()
     real*8, dimension(:), pointer       :: cbaslong => null()
     real*8, dimension(:), pointer       :: cbaslat => null()
     real*8, dimension(:), pointer       :: baslong => null()
     real*8, dimension(:), pointer       :: baslat => null()
     real*8, dimension(:), pointer       :: parangle => null()
     real*8, dimension(:), pointer       :: pc_11 => null()
     real*8, dimension(:), pointer       :: pc_12 => null()
     real*8, dimension(:), pointer       :: pc_21 => null()
     real*8, dimension(:), pointer       :: pc_22 => null()
     real*8, dimension(:), pointer       :: mcrval1 => null()
     real*8, dimension(:), pointer       :: mcrval2 => null()
     real*8, dimension(:), pointer       :: mlonpole => null()
     real*8, dimension(:), pointer       :: mlatpole => null()
     real*4, dimension(:), pointer       :: cr4K1 => null()
     real*4, dimension(:), pointer       :: cr4K2 => null()
!     real*8, dimension(:,:), pointer     :: dfocus => null()
     real*8, dimension(:,:), pointer     :: focus_x_y_z => null()
     real*8, dimension(:,:), pointer     :: dfocus_x_y_z => null()
     real*8, dimension(:,:), pointer     :: dphi_x_y_z => null()
     real*8, dimension(:,:), pointer     :: phi_x_y_z => null()
     real*4, dimension(:,:,:), pointer   :: otfdata => null()
     real*4, dimension(:,:), pointer     :: rdata => null()
  end type datapar_data
!
  type heraDerot
     real*8, dimension(:), pointer      :: mjd => null()
     real*4, dimension(:), pointer      :: actFrame => null()
  end type heraDerot
!
  type heraTemp
     real*8, dimension(:), pointer      :: mjd => null()
     real*4, dimension(:), pointer      :: cr4K1 => null()
     real*4, dimension(:), pointer      :: cr4K2 => null()
  end type heraTemp
!
  type imbFitsAntenna
     character(len=8)  :: sbCalRec
     character(len=20) :: systemOff
     character(len=40) :: subScanType
     real*8            :: dateObs
     real*8            :: dateEnd
     real*8            :: dopplerCorr
     real*8            :: obsVelRf
     real*8            :: subScanStart
     real*8            :: subScanEnd
     real*8            :: subScanXOff
     real*8            :: subScanYOff
     real*8            :: segmentXStart
     real*8            :: segmentXEnd
     real*8            :: segmentYStart
     real*8            :: segmentYEnd
     real*8            :: trackingError
  end type imbFitsAntenna
!
  type imbFitsSubreflector
     character(len=1)  :: focusTransl
     character(len=40) :: subScanType
     real*8            :: subScanStart
     real*8            :: subScanEnd
     real*8            :: segmentXStart
     real*8            :: segmentXEnd
     real*8            :: segmentYStart
     real*8            :: segmentYEnd
  end type imbFitsSubreflector
!
  type imbFitsBackend
     real*8 :: subScanStart
     real*8 :: subScanEnd
  end type imbFitsBackend
!
  type selection
     character(len=8), dimension(:), allocatable  :: backend
     character(len=23), dimension(2)              :: date_obs
     character(len=8), dimension(:), allocatable  :: frontend
     character(len=20), dimension(:), allocatable :: object
     character(len=8), dimension(:), allocatable  :: procedure
     character(len=8), dimension(:), allocatable  :: switchmode
     character(len=4), dimension(2)               :: scan
     character(len=13), dimension(:), allocatable :: telescope
     character(len=20), dimension(:), allocatable :: transition 
     character(len=6), dimension(:), allocatable  :: project
  end type selection
!
  type flag 
     logical, dimension(5) :: calibration_done 
     logical               :: base_done
     logical               :: despike_done
     logical               :: focus_done
     logical               :: pointing_done
  end type flag 
!
  type stack 
     integer                                  :: indx
     integer                                  :: ncfe
     integer                                  :: scan
     character(len=20)                        :: object
     character(len=13)                        :: telescope
     character(len=8)                         :: procedure
     character(len=20)                        :: switchmode
     character(len=8), dimension(:), pointer  :: backend => null()
     character(len=8), dimension(:), pointer  :: frontend => null()
     character(len=20), dimension(:), pointer :: transition => null()
     character(len=23)                        :: dateObs
     character(len=6)                         :: project
  end type stack 
!
  type primary
     type(primary_header)    header
  end type primary
!
  type scanpar
     type (scan_header)      header
     type (scan_data)        data 
  end type scanpar
!
  type febepar 
     type (febepar_header)   header
     type (febepar_data)     data 
  end type febepar
!
  type arraydata
     type (arraydata_header), dimension(:), pointer :: header => null()
     type (arraydata_data), dimension(:), pointer   :: data  => null()
  end type arraydata
!
  type monitor
     type (monitor_header)                       :: header
     type (monitor_data)                         :: data 
  end type monitor
!
  type datapar
     type (datapar_header) :: header
     type (datapar_data)   :: data 
  end type datapar
!
!
  type imbFits
     type (imbFitsAntenna), dimension(:), pointer      :: antenna => null()
     type (imbFitsSubreflector), dimension(:), pointer :: subRef => null()
     type (imbFitsBackend), dimension(:), pointer      :: backend => null()
  end type imbFits
!
!
  type override_data
     real*4, dimension(:,:), allocatable               :: beameff
     real*4, dimension(:,:), allocatable               :: etafss
     real*4, dimension(:,:), allocatable               :: gainimag
     real*8, dimension(:,:), allocatable               :: thotcold
     real*8, dimension(:,:), allocatable               :: tamb_p_humid 
  end type override_data
!
!
  type switch
     character(len=4), dimension(:,:), allocatable     :: switch
  end type switch
!
!
  INTEGER, PUBLIC               :: IPC, NCALCHAN, NMXOFF, NSUBSCAN, OBSNUMBER
  CHARACTER*5, PUBLIC, PARAMETER:: miraVersion = 'v2.6'
  REAL*4, PUBLIC                :: blankingRaw, blankingRed, badLevel
  REAL*8, PUBLIC                :: CLIGHT, PI, RAD2ASEC, RAD2DEG, SEC2RAD, TWOPI
  REAL*8, PUBLIC                :: DAY2RAD, SEC2DAY
  CHARACTER*256, PUBLIC         :: ncsData, visData
  CHARACTER*4, PUBLIC           :: atmVersion
  CHARACTER*20, PUBLIC          :: atmType
  LOGICAL, PUBLIC               :: calByChannel, classOption, doPause,      & 
 &                                 writeXML, searchTrec, calCheck,          &
 &                                 ignoreTraceflag, flagBSwSpikes,          &
 &                                 timingCheck, traceExtrapolation
  LOGICAL, DIMENSION(7), PUBLIC :: overrideFlag
!
  REAL*8, DIMENSION(9), PARAMETER  :: xHera = &
 &                                      (/-24.,-24.,-24.,0.,0.,0.,24.,24.,24./)
  REAL*8, DIMENSION(9), PARAMETER  :: yHera = &
 &                                      (/-24.,0.,24.,-24.,0.,24.,-24.,0.,24./)
!
  TYPE(PRIMARY), POINTER, PUBLIC                     :: PRIM => NULL()
  TYPE(SCANPAR), POINTER, PUBLIC                     :: SCAN => NULL()
  TYPE(FEBEPAR), DIMENSION(:), POINTER, PUBLIC       :: FEBE => NULL()
  TYPE(ARRAYDATA), DIMENSION(:), POINTER, PUBLIC     :: ARRAY => NULL()
  TYPE(DATAPAR), DIMENSION(:), POINTER, PUBLIC       :: DATA => NULL()
  TYPE(MONITOR), DIMENSION(:), POINTER, PUBLIC       :: MON => NULL()
  TYPE(CALIBRATION), DIMENSION(:), POINTER, PUBLIC   :: GAINS => NULL()
  TYPE(CALIBRATION), DIMENSION(:),ALLOCATABLE,PUBLIC :: IGAINS
  TYPE(imbFits), DIMENSION(:), ALLOCATABLE, PUBLIC   :: RAW
  TYPE(override_data), DIMENSION(:), ALLOCATABLE, PUBLIC :: NEWPAR
  TYPE(ANTENNA_DATA), PUBLIC                         :: ANTDATA
  TYPE(SELECTION), PUBLIC                            :: CHOICE
  TYPE(FLAG), DIMENSION(:), ALLOCATABLE, PUBLIC      :: REDUCE
  TYPE(HERADEROT), POINTER, PUBLIC                   :: DEROT => NULL()
  TYPE(HERATEMP), POINTER, PUBLIC                    :: CRYO => NULL()
  TYPE(STACK), DIMENSION(:), POINTER, PUBLIC         :: LIST  => NULL()
!
  TYPE(PRIMARY), TARGET, PUBLIC, SAVE                                :: PR
  TYPE(SCANPAR), TARGET, PUBLIC, SAVE                                :: SC
  TYPE(FEBEPAR), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE     :: FB
  TYPE(ARRAYDATA), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE   :: AR
  TYPE(DATAPAR), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE     :: DT
  TYPE(MONITOR), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE     :: MNT
  TYPE(HERADEROT), TARGET, PUBLIC, SAVE                              :: DRT 
  TYPE(HERATEMP), TARGET, PUBLIC, SAVE                               :: CRX
  TYPE(CALIBRATION), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE :: GN
  TYPE(STACK), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE       :: myList
!
  TYPE(ARRAYDATA), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE   :: arrayBuf
  TYPE(DATAPAR), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE     :: dataBuf
  TYPE(MONITOR), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE     :: monBuf
!
  TYPE(SWITCH), DIMENSION(:), ALLOCATABLE, TARGET, PUBLIC, SAVE      :: INTEGTYP
  INTEGER, DIMENSION(:,:), ALLOCATABLE, TARGET, PUBLIC, SAVE         :: IFLAG
!
end module mira
!
!
module linearRegression

      TYPE base
         REAL*4  :: Y
         REAL*8  :: X
      END TYPE BASE

      TYPE lg
         INTEGER :: N
         REAL*8  :: A, B, DET
      END Type lg

end module linearRegression

!
module fit
  use point_definitions
  type(fit_fun), dimension(2), public :: fun
end module fit
!
module chopper_def
  !----------------------------------------------------------------------
  ! TELCAL support module for chopper wheel calibration (MIRA version)
  !----------------------------------------------------------------------
  !
  type :: chop_mode ! 
     logical :: water ! Search for water?
     logical :: atm   ! Compute opacities?
     logical :: trec  ! Compute trec?
     logical :: tcal  ! Compute tcal?
     logical :: tsys  ! Compute tsys?
  end type chop_mode
  !
  type :: telescope !
     real (8) :: alti ! [  km] Telescope altitude
     real (8) :: lati ! [ rad] Telescope latitude    
     real (8) :: elev ! [ rad] Telescope elevation
     real (8) :: hwat ! [  km] Water scale height
     real (8) :: tout ! [   K] Outside temperature
     real (8) :: tcab ! [   K] Cabin   temperature 
     real (8) :: pres ! [mbar] Ambient pressure
  end type telescope
  !
  type :: dsb_value ! (e.g. frequency, temperature)
     real (8) :: s ! Signal value   
     real (8) :: i ! Image  value
  end type dsb_value
  !
  type :: mixer ! Comment: feff+fout+fcab = 1.0 
     real (8) :: sbgr  ! [   ] Sideband gain ratio
     real (8) :: beff  ! [   ] Beam efficiency    
     real (8) :: feff  ! [   ] Forward efficiency 
     real (8) :: fout  ! [   ] Coupling to ground 
     real (8) :: fcab  ! [   ] Coupling to cabin  
     real (8) :: temp  ! [  K] Noise temperature
  end type mixer
  !
  type :: chop_load ! Load description
     real (8) :: count ! [ ] Power expressed in counts
     real (8) :: temp  ! [K] Power expressed in Rayleigh-Jeans temperature
     real (8) :: ceff  ! [ ] Coupling. Comment: 1-coupling = sky coupling
  end type chop_load
  !
  type :: chop_meas ! Measurements to perform a "chopper" calibration
     real (8)         :: dark_count ! [ ] Dark power expressed in counts
     real (8)         ::  sky_count ! [ ] Sky  power expressed in counts
     type (chop_load) :: cold       ! [ ] Cold load description
     type (chop_load) :: hot        ! [ ] Hot  load description
  end type chop_meas
  !
  type :: opacity !
     real (8) :: wat ! [neper] Opacity due to water
     real (8) :: oth ! [neper] Opacity due to other components
     real (8) :: tot ! [neper] Total opacity
  end type opacity
  !
  type :: atm_prop ! Atmospheric properties
     real (8) :: airmass      ! [     ] Air mass number (about 1/sin(elev))
     real (8) :: h2omm        ! [   mm] Zenith water vapor content
     type (opacity)   :: taus ! [neper] Zenith opacities at signal frequency
     type (opacity)   :: taui ! [neper] Zenith opacities at image  frequency
     type (dsb_value) :: temp ! [    K] Sky mean     temperatures (signal and image)
     type (dsb_value) :: temi ! [    K] Sky emission temperatures (signal and image)
  end type atm_prop
  !
  type(dsb_value), public :: freq
  type(atm_prop),  public :: atm
  type(telescope), public :: telNumRec
  type(mixer),     public :: rec
  real(8),         public :: temi0, tau0
  !
end module chopper_def
!
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_fft
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubecompute_messaging
  use cubecompute_fft_visi_tool
  !
  public :: fft
  private
  !
  type :: fft_comm_t
     type(option_t),     pointer :: comm
     type(fft_visi_opt_t)        :: direction
     type(cuberegion_comm_t)     :: region
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube  ! Approx cube prod registered at start-up
   contains
     procedure, public  :: register => cubecompute_fft_register
     procedure, private :: parse    => cubecompute_fft_parse
     procedure, private :: ima      => cubecompute_fft_ima
  end type fft_comm_t
  type(fft_comm_t) :: fft
  !
  type fft_user_t
     type(fft_visi_user_t)   :: direction
     type(cuberegion_user_t) :: region
     type(cubeid_user_t)     :: cubeids
   contains
     procedure, private :: toprog => cubecompute_fft_user_toprog
  end type fft_user_t
  !
  type fft_prog_t
     integer(kind=code_k)    :: fftdirection
     type(cube_prod_t)       :: ouprod  ! Exact cube prod evaluated at run time
     type(cuberegion_prog_t) :: region
     type(cube_t), pointer   :: incube
     type(cube_t), pointer   :: oucube
     !
     procedure(cubecompute_fft_prog_image2visi_loop), private, pointer :: loop => null()
     procedure(cubecompute_fft_prog_image2visi_act),  private, pointer :: act  => null()
   contains
     procedure, private :: header => cubecompute_fft_prog_header
     procedure, private :: data   => cubecompute_fft_prog_data
  end type fft_prog_t
  !
contains
  !
  subroutine cubecompute_fft_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(fft_user_t) :: user
    character(len=*), parameter :: rname='FFT>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    call fft%parse(line,user,error)
    if (error) return
    call fft%ima(user,error)
    if (error) continue
  end subroutine cubecompute_fft_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_fft_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_comm_t), intent(inout) :: comm
    logical,           intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='FFT>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'FFT','[cubeid]',&
         'Fourier transform a real or complex cube',&
         'Perform a direct or inverse FFT on the selected region of a real or&
         & complex cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- If neither /DIRECT nor /INVERSE is given, real input defaults to&
         & /DIRECT and complex input defaults to /INVERSE.'//strg_cr//&
         '- Spatial axes must be even before the transform can run.'//&
         strg_cr//&
         '- Direct FFT converts a real image cube to a complex visibility&
         & cube. Inverse FFT converts a complex visibility cube back to a&
         & real image cube.'//strg_cr//&
         '- Output flags and headers are updated to match the chosen&
         & transform direction.'//strg_bl//&
         'Examples:'//strg_cr//&
         '- CUBE> FFT cube.'//strg_cr//&
         '- CUBE> FFT cube /DIRECT.'//strg_cr//&
         '- CUBE> FFT viscube /INVERSE.',&
         cubecompute_fft_command,&
         comm%comm,error)
    if (error) return
    call incube%register(&
         'CUBE',&
         'Input data',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset,&
         comm%incube,&
         error)
    if (error) return
    call comm%direction%register(error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'FFT',&
         'FFT cube',&
         strg_emp,&
         [flag_any,flag_fft],&! flag_any resolved at run time
         fft%oucube,&
         error)
    if (error)  return
  end subroutine cubecompute_fft_register
  !
  subroutine cubecompute_fft_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(fft_comm_t), intent(in)    :: comm
    character(len=*),  intent(in)    :: line
    type(fft_user_t),  intent(out)   :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='FFT>PARSE'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
    call comm%direction%parse(line,user%direction,error)
    if (error) return
  end subroutine cubecompute_fft_parse
  !
  subroutine cubecompute_fft_ima(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_comm_t), intent(in)    :: comm
    type(fft_user_t),  intent(in)    :: user
    logical,           intent(inout) :: error
    !
    type(fft_prog_t) :: prog
    character(len=*), parameter :: rname='FFT>IMA'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubecompute_fft_ima
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_fft_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_user_t), intent(in)    :: user
    type(fft_comm_t),  intent(in)    :: comm
    type(fft_prog_t),  intent(out)   :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='FFT>USER>TOPROG'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call user%direction%toprog(prog%incube,prog%fftdirection,error)
    if (error) return
    call user%region%toprog(prog%incube,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%region%list(error)
    if (error) return    
  end subroutine cubecompute_fft_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_fft_prog_header(prog,comm,error)
    use cubedag_allflags
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_prog_t), intent(inout) :: prog
    type(fft_comm_t),  intent(in)    :: comm
    logical,           intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='FFT>PROG>HEADER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    ! Sanity
    if (mod(prog%incube%head%spa%l%n,2).ne.0 .or.  &
        mod(prog%incube%head%spa%m%n,2).ne.0) then
      write(mess,'(a,i0,a,i0,a)')  &
        'Spatial axes must be even (shape is ',  &
        prog%incube%head%spa%l%n,'x',prog%incube%head%spa%m%n,')'
      call cubecompute_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    ! Create output cube with proper flags
    call comm%oucube%copy(prog%ouprod,error)
    if (error)  return
    if (prog%fftdirection.eq.code_fft_direct) then
      call prog%ouprod%flag_to_flag(flag_any,flag_direct,error)
      if (error)  return
    else
      call prog%ouprod%flag_to_flag(flag_any,flag_inverse,error)
      if (error)  return
    endif
    call cubeadm_clone_header(prog%ouprod,prog%incube,prog%oucube,error)
    if (error) return
    !
    call prog%region%header(prog%oucube,error)
    if (error) return
    ! *** JP I only code two cases making the assumption that visi is hermitian.
    ! *** JP To be generic, we should also considers the cases where visi is not!
    if (prog%incube%iscplx()) then
       prog%loop => cubecompute_fft_prog_visi2image_loop
       prog%act  => cubecompute_fft_prog_visi2image_act
       call cubecompute_fft_visi_prog_header_visi2image(prog%oucube%head,prog%oucube%head,error)
       if (error) return
    else
       prog%loop => cubecompute_fft_prog_image2visi_loop
       prog%act  => cubecompute_fft_prog_image2visi_act
       call cubecompute_fft_visi_prog_header_image2visi(prog%oucube%head,prog%oucube%head,error)
       if (error) return
    endif
  end subroutine cubecompute_fft_prog_header
  !
  subroutine cubecompute_fft_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='FFT>PROG>DATA'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! ie
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubecompute_fft_prog_data
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_fft_prog_image2visi_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_prog_t),        intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(visi_t) :: visi
    type(image_t) :: image
    type(fft_visi_prog_t) :: fft
    character(len=*), parameter :: rname='FFT>PROG>IMAGE2VISI>LOOP'
    !
    call image%associate('image',prog%incube,iter,error)
    if (error) return
    call visi%allocate('visi',prog%oucube,iter,error)
    if (error) return
    call fft%init(prog%fftdirection,image,visi,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,fft,error)
      if (error) return
    enddo
  end subroutine cubecompute_fft_prog_image2visi_loop
  !
  subroutine cubecompute_fft_prog_image2visi_act(prog,ie,fft,error)
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_prog_t),     intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(fft_visi_prog_t), intent(inout) :: fft
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='FFT>PROG>IMAGE2VISI>ACT'
    !
    call fft%image%get(ie,error)
    if (error) return
    call fft%image2visi(error)
    if (error) return
    call fft%compute(error)
    if (error) return
    call fft%normalize(error)
    if (error) return
    call fft%visi%put(ie,error)
    if (error) return
  end subroutine cubecompute_fft_prog_image2visi_act
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_fft_prog_visi2image_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_prog_t),        intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(visi_t) :: visi
    type(image_t) :: image
    type(fft_visi_prog_t) :: fft
    character(len=*), parameter :: rname='FFT>PROG>VISI2IMAGE>LOOP'
    !
    call visi%associate('visi',prog%incube,iter,error)
    if (error) return
    call image%allocate('image',prog%oucube,iter,error)
    if (error) return
    call fft%init(prog%fftdirection,image,visi,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,fft,error)
      if (error) return
    enddo
  end subroutine cubecompute_fft_prog_visi2image_loop
  !
  subroutine cubecompute_fft_prog_visi2image_act(prog,ie,fft,error)
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fft_prog_t),     intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(fft_visi_prog_t), intent(inout) :: fft
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='FFT>PROG>VISI2IMAGE>ACT'
    !
    call fft%visi%get(ie,error)
    if (error) return
    call fft%compute(error)
    if (error) return
    call fft%normalize(error)
    if (error) return
    call fft%visi2image(error)
    if (error) return
    call fft%image%put(ie,error)
    if (error) return
  end subroutine cubecompute_fft_prog_visi2image_act
end module cubecompute_fft
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine listpo(line,error)
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  integer :: sic_open
  logical :: sic_present
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  ! PI is defined with more digits than necessary to avoid losing
  ! the last few bits in the decimal to binary conversion
  real*8 :: pi
  parameter (pi=3.14159265358979323846d0)
  real*4 :: secpi,degpi
  parameter (secpi = 3600.*180./pi)
  parameter (degpi = 180./pi)
  integer :: i,lun,iscan,ier
  character(len=80) :: ofile,name
  !
  if (ndata.eq.0 .or. npt.eq.0) return
  lun = 6
  if (sic_present(1,0)) then
    call sic_ch (line,1,1,ofile,i,.true.,error)
    if (error) return
    lun = 1
    name = ofile
    call sic_parsef(name,ofile,' ','.lis')
    ier = sic_open (lun,ofile,'NEW',.false.)
  endif
  !
  iscan = 0
  call sic_i4 (line,0,1,iscan,.false.,error)
  if (error) return
  call get_good (npt,kp)
  write(lun,102)
  do i=1,npt
    if (iscan.eq.0 .or. scan(i).eq.iscan) then
      if (good(i)) then
        write(lun,100) scan(i),nint(x(3,i)),   &
     &          x(1,i)*degpi,x(2,i)*degpi,tiem(i),   &
     &          fobs(i)*secpi,rms(i),source(i)
      else
        write(lun,101) scan(i),nint(x(3,i)),   &
     &          x(1,i)*degpi,x(2,i)*degpi,tiem(i),   &
     &          fobs(i)*secpi,rms(i),source(i)
      endif
    endif
  enddo
  if (lun.ne.6) close(lun)
  !
  100   format(1x,i6,i3,5(1x,f10.3),1x,a)
  101   format(1x,'!',i5,i3,5(1x,f10.3),1x,a)
  102   format(1x,'  Scan Code',   &
     &    '    Az         El         Time       Error      Rms')
end

subroutine gtl_zoom(line,error)
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_zoom
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Support for command:
  ! GTVL\ZOOM [Off|Ax Bx Ay By]
  !
  !   Map mouse button events (^, &, and * are returned by x_curs()) to
  ! keyboard events (" ", "Z", and "E", respectively).
  ! ---
  !  Thread status: safe for reading from main thread
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   !
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ZOOM'
  real :: ax,ay,bx,by
  integer*4 :: nc,n,nd,sever
  integer, parameter :: nwhat=2
  character(len=*), parameter :: what(nwhat) = (/ 'OFF    ','REFRESH' /)
  character(len=12) :: keyw,argum
  character(len=80) :: gpname
  type(gt_display), pointer :: main_output
  type(gt_directory), pointer :: dir_zoom
  !
  ! Non-sense if protocol is other than X
  if (cw_device%protocol.ne.p_x) then
    call gtv_message(seve%e,rname,'Available only with X device')
    error = .true.
    return
  endif
  !
  error = gterrtst()
  error = .false.
  !
  call gtv_open_segments_for_reading_from_main()
  !
  if (cw_directory%x%nbwin.eq.0) then
    ! No window here, zoom in first window of grand-pere
    dir_zoom => cw_directory%ancestor
    call cree_chemin_dir(dir_zoom,gpname,nd)
    call gtv_message(seve%i,rname,'Zooming in directory '//gpname)
    !
    if (dir_zoom%x%nbwin.eq.0) then
      call gtv_message(seve%e,rname,'No window found')
      error = .true.
      goto 100
    endif
  else
    ! Zoom in first window of current working directory
    dir_zoom => cw_directory
  endif
  !
  ! Get the instance of the window we zoom in
  call get_slot_output_by_num(dir_zoom,dir_zoom%x%curwin,main_output,error)
  ! Do not return here
  !
100 continue
  !
  call gtv_close_segments_for_reading_from_main()
  !
  if (error)  return
  !
  if (sic_narg(0).eq.4) then
    ! ZOOM X1 X2 Y1 Y2  Defines the viewing window by its corners
    call sic_r4 (line,0,1,ax,.false.,error)
    if (error) return
    call sic_r4 (line,0,2,bx,.false.,error)
    if (error) return
    call sic_r4 (line,0,3,ay,.false.,error)
    if (error) return
    call sic_r4 (line,0,4,by,.false.,error)
    if (error) return
    !
    call new_zoom_window(dir_zoom,main_output,0,0,ax,bx,ay,by,error)
    if (error)  return
    return
    !
  elseif (sic_present(0,1)) then
    ! ZOOM OFF
    call sic_ke (line,0,1,argum,nc,.false.,error)
    if (error) return
    call sic_ambigs('ZOOM',argum,keyw,n,what,nwhat,error)
    if (error) return
    !
    if (keyw.eq.'OFF') then
      ! ZOOM OFF
      call clear_zoom_win(dir_zoom,error)
      !
    elseif (keyw.eq.'REFRESH') then
      ! ZOOM REFRESH
      if (strict2011) then
        sever = seve%e
      else
        sever = seve%w
      endif
      call gtv_message(sever,rname,'ZOOM REFRESH is obsolete, use REFRESH instead')
      call gtv_message(sever,rname,'Windows usually know by themselves when refresh is needed')
      if (strict2011) then
        error = .true.
        return
      endif
    endif
    return
    !
  else
    ! Interactive zoom with cursor
    call gti_zoom_interactive(dir_zoom,main_output,error)
    if (error)  return
    !
  endif
  !
end subroutine gtl_zoom
!
subroutine gti_zoom_interactive(dir,main_output,error)
  use gildas_def
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gti_zoom_interactive
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Create the ZOOM window with the cursor
  !---------------------------------------------------------------------
  type(gt_directory)             :: dir          ! Directory where we perform the zoom
  type(gt_display), intent(in)   :: main_output  ! Window where we perform the zoom
  logical,         intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ZOOM'
  real*4 :: ax,ay,bx,by,sx,sy,xcurse,ycurse,zoom
  character(len=1) :: c
  real, parameter :: f=1.414
  real*4 :: rect_xw,rect_yw
  character(len=commandline_length) :: line
  character(len=1), parameter :: backslash=char(92)
  !
  save xcurse,ycurse
  data xcurse/0.0/, ycurse/0.0/
  !
  if (.not.gtg_curs_sub(main_output%dev)) then
    call gtv_message(seve%e,rname,'No cursor available')
    error = .true.
    return
  endif
  !
  if (main_output%x%is_zoom) then
    call gtv_message(seve%e,rname,'Can not zoom in a zoom window')
    error = .true.
    return
  endif
  !
  ! Loop over commands
  call gtg_screen_sub(main_output,ax,bx,ay,by)
  error = gterrtst()
  if (error) return
  !
  zoom = 1.
  sx = (bx-ax)*0.5
  sy = (by-ay)*0.5
  !
  do
    rect_xw = sx*zoom  ! Rectangle X half-width (world units)
    rect_yw = sy*zoom  ! Rectangle Y half-width (world units)
    call gicurs_sub(main_output,xcurse,ycurse,rect_xw,rect_yw,c)
    error = gterrtst()
    if (error) return
    !
    call sic_upper(c)
    if (c.eq.'0') then
      ! Restore original plot
      call gtwindow(main_output,0.,dir%phys_size(1),0.,dir%phys_size(2))
      call gtg_screen_sub(main_output,ax,bx,ay,by)
      sx = (bx-ax)*0.5
      sy = (by-ay)*0.5
      zoom = 1.0
      !
    elseif (c.eq.'Z' .or. c.eq.'&') then
      ! Zooming
      zoom = zoom/f
      !
    elseif (c.eq.'-') then
      ! Unzoom
      zoom = zoom*f
      !
    elseif (c.eq.' ' .or. c.eq.'^') then
      ! Execute buffered commands
      ax = xcurse - sx*zoom
      bx = xcurse + sx*zoom
      ay = ycurse - sy*zoom
      by = ycurse + sy*zoom
      !
      ! Define clipping area and loop on next command
      call new_zoom_window(dir,main_output,0,0,ax,bx,ay,by,error)
      if (error)  return
      !
    elseif (c.eq.'H') then
      ! HELP ZOOM
      line = 'SIC'//backslash//'HELP ZOOM'
      call exec_command(line,error)
      if (error)  return
      !
    elseif (c.eq.'E' .or. c.eq.'*') then
      exit
      !
    endif
    !
  enddo
  !
end subroutine gti_zoom_interactive
!
subroutine new_zoom_window(dir,main_output,width,height,px1,px2,py1,py2,error)
  use gtv_buffers
  use gtv_interfaces, except_this=>new_zoom_window
  use gtv_protocol
  use gtv_types
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Open or reuse a zoom window attached to the input directory.
  ! Default size is 2/3 of the window we zoom in.
  ! ---
  !  Thread status: safe to call from main thread.
  !---------------------------------------------------------------------
  type(gt_directory)              :: dir          ! Directory where we attach the zoom window
  type(gt_display), intent(in)    :: main_output  ! Number of the window we zoom in
  integer(kind=4),  intent(in)    :: width        ! Zoom window width (0 if default)
  integer(kind=4),  intent(in)    :: height       ! Zoom window height (0 if default)
  real(kind=4),     intent(in)    :: px1,px2      ! X range for zoom window (world unit)
  real(kind=4),     intent(in)    :: py1,py2      ! Y range for zoom window (world unit)
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ZOOM'
  logical :: reuse,new,found
  integer :: larg,haut,zoom_win_num
  type(gt_display), pointer :: zoom_output
  !
  found = .false. !
  reuse = .true.  ! Currently it is not possible to define more than 1 zoom
                  ! window per directory. May be customized some day.
  new = .true.    ! By default zoom window will be another one added at end
                  ! of list
  !
  if (reuse) then
    call gtv_open_segments_for_writing_from_main()
    !
    call get_zoom_win(dir,zoom_win_num,found)
    if (found) then
      ! Reuse the previous zoom window
      call get_slot_output_by_num(dir,zoom_win_num,zoom_output,error)
      if (.not.error)  new = .false.
    endif
    !
    call gtv_close_segments_for_writing_from_main()
  endif
  !
  if (new) then
    ! No previous window reused, create a new one.
    !
    ! Size?
    if (height.eq.0 .or. width.eq.0) then
      call x_size(main_output%x%graph_env,larg,haut)
      larg = (2*larg)/3
      haut = (2*haut)/3
    else
      larg = width
      haut = height
    endif
    !
    ! Create. The zoom window will be attached to the output instances list:
    call get_free_slot_output(zoom_output,error)
    if (error)  return
    !
    zoom_output%dev => main_output%dev  ! Point on the shared X-protocol instance
    zoom_output%color = .true.
    zoom_output%background = main_output%background  ! Use the main window color
    call x_display_reset(zoom_output%x)  ! Default values
    zoom_output%x%geometry%x = larg
    zoom_output%x%geometry%unitx = 'p'
    zoom_output%x%geometry%y = haut
    zoom_output%x%geometry%unity = 'p'
    zoom_output%x%name = 'ZOOM'
    call create_window(zoom_output,.false.,dir,.false.,.true.,error)
    zoom_output%x%is_zoom = .true.
    !
  endif
  !
  if (error) then
    call gtv_message(seve%e,rname,'Cannot create or reuse zoom window')
    return
  endif
  !
  call gtwindow(zoom_output,px1,px2,py1,py2)  ! Set clipping area and redraw
  !
end subroutine new_zoom_window
!
subroutine get_zoom_win(dir,win_num,zoomfound)
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>get_zoom_win
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Get the last zoom window number of input directory.
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for reading.
  !---------------------------------------------------------------------
  type(gt_directory)           :: dir        ! Input directory
  integer(kind=4), intent(out) :: win_num    ! Zoom window number
  logical,         intent(out) :: zoomfound  ! Found one zoom window?
  ! Local
  integer(kind=address_length) :: graph_env
  integer :: iwin
  logical :: error,found
  type(gt_display), pointer :: output
  !
  error = .false.
  zoomfound = .false.
  !
  do iwin=dir%x%nbwin-1,0,-1
    graph_env = c_get_win_genv(dir%x%genv_array,iwin)
    call get_slot_output_by_genv(graph_env,output,.true.,found,error)
    if (error)  exit  ! iwin loop
    if (output%x%is_zoom) then
      win_num = iwin
      zoomfound = .true.
      exit  ! iwin loop
    endif
  enddo
  !
end subroutine get_zoom_win
!
subroutine clear_zoom_win(dir,error)
  use gtv_interfaces, except_this=>clear_zoom_win
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Clear the last zoom window of input directory. Nothing done if
  ! no zoom window is attached.
  !---------------------------------------------------------------------
  type(gt_directory)                :: dir    ! Input directory
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ZOOM'
  integer*4 :: win_num
  logical :: found
  !
  call gtv_open_segments_for_writing_from_main()
  !
  call get_zoom_win(dir,win_num,found)
  !
  if (found) then
    call win_destroy_one(dir,win_num,error)
  else
    call gtv_message(seve%w,rname,'No zoom window found, nothing done')
  endif
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine clear_zoom_win

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_spectrum_types
  use cubetools_parameters
  use cubetools_array_types
  use cubetools_axis_types
  use cube_types
  use cubeadm_messaging
  use cubeadm_taskloop
  use cubeadm_taskloop_iteration
  !
  public :: spectrum_t
  private
  !
  type :: spectrum_t
     type(cube_t),               private, pointer :: cube => null() ! Associated cube
     type(cubeadm_iterator_t),   private, pointer :: task => null() ! Associated task iteration
     integer(kind=indx_k),       private          :: crange(2)      ! Min-max range of channels
     character(len=name_l), private :: name = strg_unk ! spectrum name
     integer(kind=chan_k),  private :: m = 0 ! Allocated number of channels
     integer(kind=chan_k),  public  :: n = 0 ! Current number of valid channels
     type(real_1d_t),       public  :: y ! Brightness
     type(real_1d_t),       public  :: w ! Weight
     type(dble_1d_t),       public  :: x ! Spectral  axis
!     type(axis_t),         public  :: v ! Velocity  axis
!     type(axis_t),         public  :: f ! Frequency axis
!     type(axis_t),         public  :: c ! Channel   axis
     real(kind=sign_k) :: noi  = 0.0
     real(kind=coor_k) :: inc = 0d0
     real(kind=coor_k) :: val = 0d0
     real(kind=coor_k) :: ref = 0d0
     ! *** JP The following two fields are used only in mean-spectrum right now
     real(kind=coor_k) :: xoff = 0d0
     real(kind=coor_k) :: yoff = 0d0
   contains
     generic,   public  :: allocate          => allocate_iter,allocate_noiter
     generic,   public  :: associate         => associate_iter,associate_noiter
     procedure, public  :: allocate_y        => spectrum_allocate_y
     procedure, public  :: allocate_w        => spectrum_allocate_w
     procedure, public  :: allocate_xw       => spectrum_allocate_xw
     procedure, public  :: associate_x       => spectrum_associate_x
     procedure, public  :: get_header        => spectrum_get_header
     procedure, public  :: get               => spectrum_get_data
     procedure, public  :: put               => spectrum_put_data
     procedure, public  :: put_in            => spectrum_put_data_in
     procedure, public  :: point_to          => spectrum_point_to
     procedure, public  :: unblank           => spectrum_unblank
     procedure, public  :: mask              => spectrum_mask
     procedure, public  :: list              => spectrum_list
     !
     procedure, public  :: set_line_channels => spectrum_set_line_channels
     procedure, public  :: set_base_channels => spectrum_set_base_channels
!     procedure, public  :: set_line_channels_from_mask => spectrum_set_line_channels_from_mask
     procedure, public  :: set_base_channels_from_mask => spectrum_set_base_channels_from_mask
     !
     procedure, private :: tasknum          => spectrum_task_num
     procedure, private :: allocate_iter    => spectrum_allocate_iter
     procedure, private :: allocate_noiter  => spectrum_allocate_noiter
     procedure, private :: associate_iter   => spectrum_associate_iter
     procedure, private :: associate_noiter => spectrum_associate_noiter
     procedure, private :: prepare          => spectrum_prepare
  end type spectrum_t
  !
contains
  !
  subroutine spectrum_allocate_iter(spec,name,cube,iterator,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(spectrum_t),                intent(inout) :: spec
    character(len=*),                 intent(in)    :: name
    type(cube_t),                     intent(in)    :: cube
    type(cubeadm_iterator_t), target, intent(in)    :: iterator
    logical,                          intent(inout) :: error
    !
    spec%task => iterator
    call spectrum_allocate_noiter(spec,name,cube,error)
    if (error)  return
  end subroutine spectrum_allocate_iter
  !
  subroutine spectrum_allocate_noiter(spec,name,cube,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(spectrum_t), intent(inout) :: spec
    character(len=*),  intent(in)    :: name
    type(cube_t),      intent(in)    :: cube
    logical,           intent(inout) :: error
    !
    integer(kind=chan_k) :: n
    character(len=*), parameter :: rname='SPECTRUM>ALLOCATE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call spec%prepare(name,cube,n,error)
    if (error)  return
    ! Allocate
    call spec%y%reallocate('Y',n,error)
    if (error) return
    ! Success => Complete the object
    spec%n = n
    spec%m = n
  end subroutine spectrum_allocate_noiter
  !
  subroutine spectrum_associate_iter(spec,name,cube,iterator,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(spectrum_t),                intent(inout) :: spec
    character(len=*),                 intent(in)    :: name
    type(cube_t),                     intent(in)    :: cube
    type(cubeadm_iterator_t), target, intent(in)    :: iterator
    logical,                          intent(inout) :: error
    !
    spec%task => iterator
    call spectrum_associate_noiter(spec,name,cube,error)
    if (error)  return
  end subroutine spectrum_associate_iter
  !
  subroutine spectrum_associate_noiter(spec,name,cube,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(spectrum_t), intent(inout) :: spec
    character(len=*),  intent(in)    :: name
    type(cube_t),      intent(in)    :: cube
    logical,           intent(inout) :: error
    !
    integer(kind=chan_k) :: n
    character(len=*), parameter :: rname='SPECTRUM>ASSOCIATE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call spec%prepare(name,cube,n,error)
    if (error)  return
    ! Associate
    call spec%y%prepare_association('Y',n,error)
    if (error) return
    ! Success => Complete the object
    spec%n = n
    spec%m = n
  end subroutine spectrum_associate_noiter
  !
  subroutine spectrum_prepare(spec,name,cube,n,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(spectrum_t),    intent(inout) :: spec
    character(len=*),     intent(in)    :: name
    type(cube_t), target, intent(in)    :: cube
    integer(kind=chan_k), intent(out)   :: n
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM>PREPARE'
    !
    ! Sanity check
    if (cube%iscplx()) then
       call cubeadm_message(seve%e,rname,&
            'Invalid attempt to get a R*4 spectrum from a C*4 cube')
       error = .true.
       return
    endif
    if (cube%access().ne.code_access_speset) then
       call cubeadm_message(seve%e,rname,  &
            'Can not get a spectrum from a cube with other access declared')
       error = .true.
       return
    endif
    if (.not.cube%iter%ready(rname,error)) then
       call cubeadm_message(seve%e,rname,  &
         'Failed to associate or allocate the '''//name//''' spectrum on its cube')
       error = .true.
       return
    endif
    !
    spec%name = name
    spec%cube => cube
    call cube%iter%spectrum_region(spec%crange,error)
    if (error)  return
    call cube%iter%spectrum_size(n,error)
    if (error)  return
  end subroutine spectrum_prepare
  !
  !------------------------------------------------------------------------
  !
  subroutine spectrum_allocate_y(spec,name,nc,error)
    !----------------------------------------------------------------------
    ! Allocate the y array to the right dimension. Contrary to the
    ! associate method, no cube is associated here to the spectrum!  This
    ! allocation is only required by some algorithms. Values are not set!
    !----------------------------------------------------------------------
    class(spectrum_t),    intent(inout) :: spec
    integer(kind=chan_k), intent(in)    :: nc
    character(len=*),     intent(in)    :: name
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM>ALLOCATE>Y'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    spec%name = name
    call spec%y%reallocate('Y',nc,error)
    if (error) return
    spec%n = nc
    spec%m = nc
    spec%cube => null()
    spec%task => null()
  end subroutine spectrum_allocate_y
  !
  subroutine spectrum_allocate_w(spec,error)
    !----------------------------------------------------------------------
    ! Allocate the weight array to the right dimension. This allocation is
    ! only required by some algorithms. Values are not set!
    !----------------------------------------------------------------------
    class(spectrum_t), intent(inout) :: spec
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM>ALLOCATE>W'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (.not.associated(spec%cube)) then
      call cubeadm_message(seve%e,rname,'Internal error: cube pointer is null')
      error = .true.
      return
    endif
    !
    call spec%w%reallocate('W',spec%n,error)
    if (error) return
  end subroutine spectrum_allocate_w
  !
  subroutine spectrum_allocate_xw(spec,error)
    !----------------------------------------------------------------------
    ! Allocate the x-axis and weight arrays to the right dimension
    ! These allocations are only required by some algorithms.
    ! Values are not set!
    !----------------------------------------------------------------------
    class(spectrum_t), intent(inout) :: spec
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM>ALLOCATE>XW'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (.not.associated(spec%cube)) then
      call cubeadm_message(seve%e,rname,'Internal error: cube pointer is null')
      error = .true.
      return
    endif
    !
    call spec%x%reallocate('X',spec%n,error)
    if (error) return
    call spec%w%reallocate('W',spec%n,error)
    if (error) return
  end subroutine spectrum_allocate_xw
  !
  subroutine spectrum_associate_x(spec,error)
    use cubetools_header_methods
    !----------------------------------------------------------------------
    ! Associate the X axis to the velocity spectral axis when it is genuine
    ! and to the channel axis else.  This association is only required by
    ! some algorithms.
    !
    ! *** JP The kind of axis (velocity/frequency) should be selectable with a code
    !----------------------------------------------------------------------
    class(spectrum_t), intent(inout) :: spec
    logical,           intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='SPECTRUM>ASSOCIATE>X'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (.not.associated(spec%cube)) then
      call cubeadm_message(seve%e,rname,'Internal error: cube pointer is null')
      error = .true.
      return
    endif
    !
    call cubetools_header_get_axis_head_v(spec%cube%head,axis,error)
    if (error) return
    if (axis%genuine) then
       call spec%x%prepare_association('X => V',axis%n,error)
       if (error) return
    else
       call cubetools_header_get_axis_head_c(spec%cube%head,axis,error)
       if (error) return
       call spec%x%prepare_association('X => C',axis%n,error)
       if (error) return
    endif
    call spec%x%get(axis%coord,error)
    if (error) return
    spec%inc = axis%inc
    spec%val = axis%val
    spec%ref = axis%ref
  end subroutine spectrum_associate_x
  !
  !------------------------------------------------------------------------
  !
  subroutine spectrum_get_header(spec,error)
    use cubetools_header_methods
    !---------------------------------------------------------------------
    ! Get spectrum header from the cube
    !
    ! *** JP The kind of axis (velocity/frequency) should be selectable with a code
    !---------------------------------------------------------------------
    class(spectrum_t), intent(inout) :: spec
    logical,           intent(inout) :: error
    ! 
    type(axis_t) :: axis
    character(len=*), parameter :: rname='SPECTRUM>GET>HEADER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_axis_head_v(spec%cube%head,axis,error)
    if (error) return
    spec%inc = axis%inc
    spec%val = axis%val
    spec%ref = axis%ref
  end subroutine spectrum_get_header
  !
  subroutine spectrum_get_data(spec,oent,error)
    use cubeio_pix
    use cubetuple_entry
    !---------------------------------------------------------------------
    ! Get the ient spectrum from the cube
    ! When spec%y%val is an allocated pointer, we make a copy.
    ! In all other cases (associated or null), we make it point to the data.
    !---------------------------------------------------------------------
    class(spectrum_t),    intent(inout) :: spec   !
    integer(kind=entr_k), intent(in)    :: oent   ! Output entry number
    logical,              intent(inout) :: error  !
    ! 
    type(cubeio_pix_t) :: entry
    integer(kind=indx_k) :: xpix,ypix
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPECTRUM>GET>DATA'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call spec%cube%iter%spectrum_number(oent,xpix,ypix,error)
    if (error)  return
    call cubetuple_get_pix(spec%cube%user,  &
                           spec%cube%prog,  &
                           spec%cube,  &
                           xpix,ypix,  &
                           entry,error)
    if (error) return
    !
    ! Sanity check
    if (spec%crange(1).lt.1 .or. spec%crange(2).gt.entry%nc) then
      write(mess,'(5(A,I0))')  &
        'Region overlaps spectrum range. Region: [',  &
        spec%crange(1),':',spec%crange(2),'], spectrum: [',  &
        1,':',entry%nc,']'
      call cubeadm_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    call spec%y%get(entry%r4(spec%crange(1):spec%crange(2)),error)
    if (error) return
    ! *** JP: Why do we have to repeatedly allocate and free the entry
    ! *** JP: while the number of channels should always be the same?
    call cubeio_free_pix(entry,error)
    if (error) return
  end subroutine spectrum_get_data
  !
  subroutine spectrum_put_data(spec,oent,error)
    !---------------------------------------------------------------------
    ! Put the oent spectrum to the cube
    !---------------------------------------------------------------------
    class(spectrum_t),    intent(inout) :: spec   !
    integer(kind=entr_k), intent(in)    :: oent   ! Output entry number
    logical,              intent(inout) :: error  !
    !
    call spectrum_put_data_in(spec,spec%cube,oent,error)
    if (error)  return
  end subroutine spectrum_put_data
  !
  subroutine spectrum_put_data_in(spec,cube,oent,error)
    use cubeio_pix
    use cubetuple_entry
    !---------------------------------------------------------------------
    ! Put the oent spectrum to the cube.
    ! Only use pointers => Nothing to free.
    !
    ! This flavor, which explicitely states the output cube, should be used
    ! when the input spectrum needs to be written in another cube without
    ! copy. See, eg, the copy tool. This should an exotic use compare to
    ! spectrum_put.
    !---------------------------------------------------------------------
    class(spectrum_t),    intent(inout) :: spec   !
    type(cube_t),         intent(inout) :: cube   !
    integer(kind=entr_k), intent(in)    :: oent   ! Output entry number
    logical,              intent(inout) :: error  !
    !
    type(cubeio_pix_t) :: entry
    integer(kind=indx_k) :: xpix,ypix
    character(len=*), parameter :: rname='SPECTRUM>PUT>DATA>IN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    entry%allocated = code_pointer_associated
    entry%nc = spec%n
    entry%r4 => spec%y%val
    entry%iscplx = .false.
    !
    call spec%cube%iter%spectrum_number(oent,xpix,ypix,error)
    if (error)  return
    call cubetuple_put_pix(cube%user,      &
                           cube%prog,      &
                           cube,           &
                           spec%tasknum(), &
                           xpix,ypix,      &
                           entry,          &
                           error)
    if (error) return
  end subroutine spectrum_put_data_in
  !
  !------------------------------------------------------------------------
  !
  subroutine spectrum_point_to(ou,in,ifirst,ilast,noise,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum_t),        intent(inout) :: ou
    type(spectrum_t), target, intent(in)    :: in
    integer(kind=chan_k),     intent(in)    :: ifirst
    integer(kind=chan_k),     intent(in)    :: ilast
    real(kind=sign_k),        intent(in)    :: noise
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM>POINT>TO'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call ou%y%point_to(in%y,ifirst,ilast,error)
    if (error) return
    if (in%w%associated()) call ou%w%point_to(in%w,ifirst,ilast,error)
    if (error) return
    if (in%x%associated()) call ou%x%point_to(in%x,ifirst,ilast,error)
    if (error) return
    ou%ref = in%ref
    ou%val = in%val
    ou%inc = in%inc
    ou%noi = noise
    ou%n = ou%y%n
    ou%m = in%m
  end subroutine spectrum_point_to
  !
  subroutine spectrum_unblank(ou,in,error)
    !----------------------------------------------------------------------
    ! Return a compressed spectrum without NaN
    !----------------------------------------------------------------------
    class(spectrum_t),        intent(inout) :: ou
    type(spectrum_t), target, intent(in)    :: in
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM>UNBLANK'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call ou%y%unblank(in%y,error)
    if (error) return
    if (in%x%associated().and.ou%x%associated()) call ou%x%unblank_as(in%x,in%y,error)
    if (error) return
    ou%n = ou%y%n
    ou%ref = in%ref
    ou%val = in%val
    ou%inc = in%inc
    ou%noi = in%noi
  end subroutine spectrum_unblank
  !
  !------------------------------------------------------------------------
  !
  subroutine spectrum_set_line_channels(spec,lineset,error)
    use cubetopology_firstlaststride_types
    use cubetopology_sperange_set_types
    use cubetopology_sperange_types
    !---------------------------------------------------------------------
    ! Set the spectrum weights of the spectra to 1 where the lines are
    ! located and zero elsewhere.
    !---------------------------------------------------------------------
    class(spectrum_t),         intent(inout) :: spec
    type(sperange_set_prog_t), intent(in)    :: lineset
    logical,                   intent(inout) :: error
    !
    integer(kind=wind_k) :: il
    type(firstlaststride_t) :: ic
    type(sperange_prog_t) :: line
    character(len=*), parameter :: rname='SET>LINE>CHANNELS'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (spec%w%unallocated(error)) return
    !
    spec%w%val = 0.0
    do il=1,lineset%n
       call lineset%get_into(il,line,error)
       if (error) return
       call line%to_axis_channel(ic,error)
       if (error) return
       spec%w%val(ic%first:ic%last) = 0.0
    enddo ! il
  end subroutine spectrum_set_line_channels
  !
  subroutine spectrum_set_base_channels(spec,lineset,error)
    use cubetopology_firstlaststride_types
    use cubetopology_sperange_set_types
    use cubetopology_sperange_types
    !---------------------------------------------------------------------
    ! Set the spectrum weights of the spectra to 1 where the baselines are
    ! located and zero elsewhere.
    !---------------------------------------------------------------------
    class(spectrum_t),         intent(inout) :: spec
    type(sperange_set_prog_t), intent(in)    :: lineset
    logical,                   intent(inout) :: error
    !
    integer(kind=wind_k) :: il
    type(firstlaststride_t) :: ic
    type(sperange_prog_t) :: line
    character(len=*), parameter :: rname='SET>BASE>CHANNELS'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (spec%w%unallocated(error)) return
    !
    spec%w%val = 1.0
    do il=1,lineset%n
       call lineset%get_into(il,line,error)
       if (error) return
       call line%to_axis_channel(ic,error)
       if (error) return
       spec%w%val(ic%first:ic%last) = 0.0
    enddo ! il
  end subroutine spectrum_set_base_channels
  !
  subroutine spectrum_set_base_channels_from_mask(spec,mask,error)
    use cubetools_nan
    !---------------------------------------------------------------------
    ! Set the spectrum weights of the spectra to 1 where the baselines are
    ! located and zero elsewhere.
    !---------------------------------------------------------------------
    class(spectrum_t), intent(inout) :: spec
    type(spectrum_t),  intent(in)    :: mask
    logical,           intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    character(len=*), parameter :: rname='SET>BASE>CHANNELS>FROM>MASK'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (spec%w%unallocated(error)) return
    if (mask%y%unallocated(error)) return
    if (mask%y%n.ne.spec%w%n) then
       call cubeadm_message(admseve%trace,rname,'Welcome')
       error = .true.
       return
    endif
    !
    spec%w%val = 1.0
    do ic=1,mask%y%n
       if ((mask%y%val(ic).le.0.0).or.(ieee_is_nan(mask%y%val(ic)))) cycle
       spec%w%val(ic) = 0.0
    enddo ! il
  end subroutine spectrum_set_base_channels_from_mask
  !
  subroutine spectrum_mask(ou,in,error)
    use cubetools_nan
    !----------------------------------------------------------------------
    ! Return a compressed spectrum without NaN or part of the spectrum whose
    ! weights are <= 0.0
    !----------------------------------------------------------------------
    class(spectrum_t), intent(inout) :: ou
    type(spectrum_t),  intent(in)    :: in
    logical,           intent(inout) :: error
    !
    integer(kind=chan_k) :: ichan,jchan    
    character(len=*), parameter :: rname='SPECTRUM>MASK'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (in%x%unallocated(error)) return
    if (in%w%unallocated(error)) return
    if (ou%x%unallocated(error)) return
    if (ou%w%unallocated(error)) return
    !
    jchan = 1
    do ichan=1,in%n
       if ((in%w%val(ichan).le.0.0).or.(ieee_is_nan(in%y%val(ichan)))) cycle
       ou%x%val(jchan) = in%x%val(ichan)
       ou%y%val(jchan) = in%y%val(ichan)
       ou%w%val(jchan) = in%w%val(ichan)
       jchan = jchan+1
    enddo ! ichan
    ou%n = jchan-1
    ou%ref = in%ref
    ou%val = in%val
    ou%inc = in%inc
    ou%noi = in%noi
  end subroutine spectrum_mask
  !
  function spectrum_task_num(spe)
    !-------------------------------------------------------------------
    ! Return the task number this spectrum_t is running with
    !-------------------------------------------------------------------
    integer(kind=entr_k) :: spectrum_task_num
    class(spectrum_t), intent(in) :: spe
    !
    if (associated(spe%task)) then
      spectrum_task_num = spe%task%num
    else
      ! Assume single thread
      spectrum_task_num = 1
    endif
  end function spectrum_task_num
  !
  !------------------------------------------------------------------------
  !
  subroutine spectrum_list(spe,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum_t), intent(in)    :: spe
    logical,           intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    character(len=*), parameter :: rname='SPECTRUM>LIST'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    print *,spe%name
    print *,''
    print *,'noi: ',spe%noi
    print *,'inc: ',spe%inc
    print *,'val: ',spe%val
    print *,'ref: ',spe%ref
    print *,'xoff: ',spe%xoff
    print *,'yoff: ',spe%yoff
    print *,''
    print *,'nchan:',spe%n,' <= ',spe%m
    print *,''
    if (spe%x%associated()) then
       if (spe%y%associated()) then
          if (spe%w%associated()) then
             print *,'ic, x(ic), y(ic), w(ic)'
             do ic=1,spe%n
                print *,ic,spe%x%val(ic),spe%y%val(ic),spe%w%val(ic)
             enddo ! ic
             print *,'***************************************************************************'
             do ic=spe%n+1,spe%m
                print *,ic,spe%x%val(ic),spe%y%val(ic),spe%w%val(ic)
             enddo ! ic
          else
             print *,'ic, x(ic), y(ic)'
             do ic=1,spe%n
                print *,ic,spe%x%val(ic),spe%y%val(ic)
             enddo ! ic
             print *,'***************************************************************************'
             do ic=spe%n+1,spe%m
                print *,ic,spe%x%val(ic),spe%y%val(ic)
             enddo ! ic
          endif
       else
          if (spe%w%associated()) then
             print *,'ic, x(ic), w(ic)'
             do ic=1,spe%n
                print *,ic,spe%x%val(ic),spe%w%val(ic)
             enddo ! ic
             print *,'***************************************************************************'
             do ic=spe%n+1,spe%m
                print *,ic,spe%x%val(ic),spe%w%val(ic)
             enddo ! ic
          else
             print *,'ic, x(ic)'
             do ic=1,spe%n
                print *,ic,spe%x%val(ic)
             enddo ! ic
             print *,'***************************************************************************'
             do ic=spe%n+1,spe%m
                print *,ic,spe%x%val(ic)
             enddo ! ic
          endif
       endif
    else
       if (spe%y%associated()) then
          if (spe%w%associated()) then
             print *,'ic, y(ic), w(ic)'
             do ic=1,spe%n
                print *,ic,spe%y%val(ic),spe%w%val(ic)
             enddo ! ic
             print *,'***************************************************************************'
             do ic=spe%n+1,spe%m
                print *,ic,spe%y%val(ic),spe%w%val(ic)
             enddo ! ic
          else
             print *,'ic, y(ic)'
             do ic=1,spe%n
                print *,ic,spe%y%val(ic)
             enddo ! ic
             print *,'***************************************************************************'
             do ic=spe%n+1,spe%m
                print *,ic,spe%y%val(ic)
             enddo ! ic
          endif
       else
          if (spe%w%associated()) then
             print *,'ic, w(ic)'
             do ic=1,spe%n
                print *,ic,spe%w%val(ic)
             enddo ! ic
             print *,'***************************************************************************'
             do ic=spe%n+1,spe%m
                print *,ic,spe%w%val(ic)
             enddo ! ic
          else
             print *,'Unassociated X, Y, and W'
          endif
       endif
    endif
  end subroutine spectrum_list
end module cubeadm_spectrum_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_browse
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_cubeid_types
  use cubesyntax_keyval_strg_types
  use cubetools_switch_types
  use cubetopology_spapos_types
  use cubego_messaging
  !
  public :: browse
  private
  !
  type :: browse_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(spapos_comm_t)         :: pixel
     type(keyval_strg_comm_t)    :: catalog
     type(switch_comm_t)         :: interactive
   contains
     procedure, public  :: register => cubego_browse_register
     procedure, private :: parse    => cubego_browse_parse
     procedure, private :: main     => cubego_browse_main
  end type browse_comm_t
  type(browse_comm_t) :: browse
  !
  type :: browse_user_t
     type(cubeid_user_t)      :: cubeids
     type(spapos_user_t)      :: pixel
     type(keyval_strg_user_t) :: catalog
     type(switch_user_t)      :: interactive
   contains
     procedure, private :: toprog => cubego_browse_user_toprog
  end type browse_user_t
  !
  type browse_prog_t
     type(cube_t), pointer :: cube
     type(cubeid_prog_t)   :: cubeids
     type(spapos_prog_t)   :: pixel
     character(len=file_l) :: catalog
     type(switch_prog_t)   :: interactive
   contains
     procedure, private :: header => cubego_browse_prog_header
     procedure, private :: data   => cubego_browse_prog_data
  end type browse_prog_t
  !
contains
  !
  subroutine cubego_browse_command(line,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(browse_user_t) :: user
    character(len=*),parameter :: rname='BROWSE>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call browse%parse(line,user,error)
    if (error) return
    call browse%main(user,error)
    if (error) return
    ! Force insertion in SIC stack ! *** JP Why?
    if (sic_lire().eq.0) call sic_insert(line)
  end subroutine cubego_browse_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_register(comm,error)
    use cubedag_allflags
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(inout) :: comm
    logical,              intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    character(len=*), parameter :: rname='BROWSE>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'BROWSE','[cubeid]',&
         'Interactive browse of a cube spectrum',&
         'Open the spectrum browser for one cube.',&
         cubego_browse_command,&
         comm%comm,&
         error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Identity of the cube to be browsed',&
         'If omitted, use the last matching cube (any family/flags) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&! Indicative: data access done by procedure
         code_access_imaset_or_speset,&! Indicative: data access done by procedure
         comm%cube,&
         error)
    if (error) return
    !
    call comm%pixel%register(&
         'PIXEL',&
         'Define the position of the pixel to be browsed',&
         error)
    if (error) return
    call comm%catalog%register(&
         'CATALOG',&
         'Supersede the default line catalog filename',&
         'The file format is an ASCII table with frequencies [GHz] in first&
         & column and line names in second column. Protect names with single&
         & quotes if needed.',&
         strg_star,&
         strg_emp,&
         error)
    if (error) return
    call comm%interactive%register(&
         'INTERACTIVE',&
         'the interactive mode',&
         'ON',&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubego_browse_register
  !
  subroutine cubego_browse_parse(comm,line,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(inout) :: comm
    character(len=*),     intent(in)    :: line
    type(browse_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>PARSE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%pixel%parse(line,user%pixel,error)
    if (error) return
    call comm%catalog%parse(line,user%catalog,error)
    if (error) return
    call comm%interactive%parse(line,user%interactive,error)
    if (error) return
  end subroutine cubego_browse_parse
  !
  subroutine cubego_browse_main(comm,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(in)    :: comm
    type(browse_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(browse_prog_t) :: prog
    character(len=*), parameter :: rname='BROWSE>MAIN'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(error)
    if (error) return
    call prog%data(error)
    if (error) return
  end subroutine cubego_browse_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(browse_user_t), intent(in)    :: user
    type(browse_comm_t),  intent(in)    :: comm    
    type(browse_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>USER>TOPROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call cubeadm_cubeid_user2prog(comm%comm,user%cubeids,prog%cubeids,error)
    if (error) return
    call user%pixel%toprog(prog%cube,prog%pixel,error)
    if (error) return
    call user%catalog%toprog(comm%catalog,prog%catalog,error)
    if (error) return
    call prog%interactive%init(comm%interactive,error)
    if (error) return
    call user%interactive%toprog(comm%interactive,prog%interactive,error)
    if (error) return
  end subroutine cubego_browse_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_prog_header(prog,error)
    use cubego_buffer
    use cubetools_userspace
    use cubetools_userstruct
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(browse_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(userstruct_t) :: userstruct
    character(len=*), parameter :: rname='BROWSE>PROG>HEADER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call prog%cubeids%defstruct(cubego,error)
    if (error) return
    call prog%pixel%userstruct('cubego%pixel',error)
    if (error) return
    ! catalog
    call userstruct%create('cubego%catalog',global,overwrite_prog,error)
    if (error) return
    call userstruct%set_member('file',prog%catalog,error)
    if (error) return
  end subroutine cubego_browse_prog_header
  !
  subroutine cubego_browse_prog_data(prog,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(browse_prog_t), intent(in)    :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>PROG>DATA'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call exec_program('@ q-browse.cube')
    if (prog%interactive%act) call exec_program('@ l-ctrl-master-loop')
  end subroutine cubego_browse_prog_data
end module cubego_browse
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine ini_base(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY BASELINE  b1 x1 y1 x1 b2 x2 y2 z2 ...[/OFFSET]
  !                          [FITTED]
  ! Command MODIFY ANTENNA a1 x1 y1 x1 a2 x2 y2 z2 .. [/OFFSET]
  !                          [FITTED]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  integer :: base_number
  logical :: fbnew(mnbas), fanew(mnant)
  logical :: antenna, offset
  real*8 :: bnew(3,mnbas), anew(3,mnant)
  real*8 :: bnew0(3,mnbas), anew0(3,mnant)
  integer(kind=address_length) :: data_in, kin, ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: i, j, k, nch
  character(len=12) :: argum
  character(len=256) :: chain
  !      CHARACTER*1 ARG1
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  real :: x(mnbas)
  integer :: kb, ibas, ia, ja, id
  !
  integer :: mvoc1, nkey
  parameter (mvoc1=2)
  character(len=12) :: kw, voc1(mvoc1)
  data voc1/'BASELINE','ANTENNA'/
  data antenna/.false./, offset/.false./
  save antenna, offset, anew, anew0, fanew, bnew, bnew0, fbnew, id
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  kw = 'ANTENNA'
  call clic_kw(line,iopt,1,kw,nkey,voc1,mvoc1,.false.,error,.true.)
  antenna = kw.eq.'ANTENNA'
  offset = sic_present(3,0)
  !
  ! Mandatory argument (89 or 96 or 99 or 25)
  if (offset) then
    call sic_i4(line,3,1,id,.true.,error)
    if (id.ne.89 .and. id.ne.96 .and. id.ne.99 .and. id.ne.25) then
      call message(8,3,'MODIFY',   &
        '/OFFSET 89 or /OFFSET 96 or /OFFSET 99 or /OFFSET 25, please')
      error = .true.
      return
    endif
  else
    id = 0
  endif
  error = .false.
  do i=1, mnbas
    fbnew(i) = .false.
  enddo
  do i=1, mnant
    fanew(i) = .false.
  enddo
  call sic_ke(line,iopt,2,argum,nch,.true.,error)
  if (error) return
  if (argum(1:2) .eq. 'FITTED') then
    do i=1, r_nbas
      if (f_bfit(i)) then
        do j=1,3
          bnew0(j,i) = b_fit(j,i)
        enddo
        fbnew(i) = .true.
      elseif (f_afit(r_iant(i)) .and.   &
        f_afit(r_jant(i))) then
        do j=1,3
          bnew0(j,i) = a_fit(j,r_jant(i))-   &
            a_fit(j,r_iant(i))
        enddo
        fbnew(i) = .true.
      endif
    enddo
  elseif (.not.antenna) then
    i = 2
    do while(sic_present(iopt,i))
      call sic_ke(line,iopt,i,argum,nch,.true.,error)
      if (error) return
      call base_to_n(argum,j,error)
      if (error) then
        call message(8,4,'INI_BASE','Invalid baseline '//argum)
        error = .true.
        return
      endif
      fbnew(j) = .true.
      do k=1, 3
        call sic_r8(line,iopt,i+k,bnew0(k,j),.true.,error)
        if (error) return
      enddo
      i = i+4
    enddo
  elseif (antenna) then
    i = 2
    do while(sic_present(iopt,i))
      call sic_i4(line,iopt,i,j,.true.,error)
      if (error) return
      fanew(j) = .true.
      do k=1, 3
        call sic_r8(line,iopt,i+k,anew0(k,j),.true.,error)
        if (error) return
      enddo
      i = i+4
    enddo
  endif
  if (.not.antenna) then
    call message(6,1,'INI_BASE','Modifying baselines to :')
    do i=1, mnbas
      if (fbnew(i)) then
        write(chain,'(1x,a2,3f15.6)') cbas(i),(bnew0(j,i),j=1,3)
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      else
        write(chain,'(1x,a2,a)') cbas(i), ' is not modified'
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      endif
    enddo
  else
    call message(6,1,'INI_BASE','Modifying antennas to :')
    do i=1, mnant
      if (fanew(i)) then
        write(chain,'(1x,i0,3f15.6)') i,(anew0(j,i),j=1,3)
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      else
        write(chain,'(1x,i0,a)') i,' is not modified'
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      endif
    enddo
  endif
  if (offset) then
    write(chain,'(a,i2,a)') '(Offset relative to `',id,' values)'
    call message (6,1,'INI_BASE',chain(1:lenc(chain)))
  endif
  return
  !
entry mod_base(do_write,do_data,error)
  ! Get storage and data
  call get_data (ndata,data_in,error)
  kin = gag_pointer(data_in,memory)
  if (error) return
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf) goto 500
  if (r_lmode.ne.1) goto 500
  !
  ! Add station offsets if needed
  if (antenna) then
    do i=1, r_nant
      if (fanew(i)) then
        do j=1, 3
          anew(j,i) = anew0(j,i)
          if (offset) then
            if(id.eq.89) then
              anew(j,i) = anew(j,i)+dble(stat89(j,r_istat(i)))
            elseif(id.eq.96) then
              anew(j,i) = anew(j,i)+dble(stat96(j,r_istat(i)))
            elseif(id.eq.99) then
              anew(j,i) = anew(j,i)+dble(stat99(j,r_istat(i)))
            elseif(id.eq.25) then
              anew(j,i) = anew(j,i)+dble(stat25(j,r_istat(i)))
            endif
          endif
        enddo
      endif
    enddo
  else
    do i=1, r_nbas
      if (fbnew(i)) then
        do j=1, 3
          bnew(j,i) = bnew0(j,i)
          if (offset) then
            if(id.eq.89) then
              bnew(j,i) = bnew(j,i)   &
                +dble(stat89(j,r_istat(r_jant(i)))   &
                -stat89(j,r_istat(r_iant(i))))
            elseif(id.eq.96) then
              bnew(j,i) = bnew(j,i)   &
                +dble(stat96(j,r_istat(r_jant(i)))   &
                -stat96(j,r_istat(r_iant(i))))
            elseif(id.eq.99) then
              bnew(j,i) = bnew(j,i)   &
                +dble(stat99(j,r_istat(r_jant(i)))   &
                -stat99(j,r_istat(r_iant(i))))
            elseif(id.eq.25) then
              bnew(j,i) = bnew(j,i)   &
                +dble(stat25(j,r_istat(r_jant(i)))   &
                -stat25(j,r_istat(r_iant(i))))
            endif
          endif
        enddo
      endif
    enddo
  endif
  !
  ! load data header from average record:
  ipk = kin + h_offset(r_ndump+1)
  call decode_header (memory(ipk))
  !
  ! Compute phase factors
  do i = 1, r_nbas
    x(i) = 0
    !
    ! in antenna mode, use antenna data to compute baseline data:
    if (antenna) then
      ia = r_iant(i)
      ja = r_jant(i)
      fbnew(i) = .true.
      if (fanew(ja)) then
        do k=1, 3
          bnew(k,i) = anew(k,ja)
        enddo
      elseif (r_ant(1,ja).ne.0) then
        do k=1, 3
          bnew(k,i) = r_ant(k,ja)
        enddo
      else
        fbnew(i) = .false.
      endif
      if (fbnew(i) .and. fanew(ia)) then
        do k=1, 3
          bnew(k,i) = bnew(k,i)-anew(k,ia)
        enddo
      elseif (fbnew(i) .and. r_ant(1,ia).ne.0) then
        do k=1, 3
          bnew(k,i) = bnew(k,i)-r_ant(k,ia)
        enddo
      else
        fbnew(i) = .false.
      endif
    endif
    if (fbnew(i)) then
      do k=1, 3
        x(i) = x(i)   &
          - dh_svec(k)*(bnew(k,i)-r_bas(k,i))*f_to_k
      enddo
    endif
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)
  !
  ! Update baselines
  do ibas = 1, r_nbas
    kb = base_number (r_iant(ibas), r_jant(ibas))
    if (fbnew(kb)) then
      do i=1, 3
        r_bas(i,ibas) = bnew(i,kb)
      enddo
    endif
  enddo
  if (antenna) then
    do i=1, r_nant
      if (fanew(i)) then
        do k=1, 3
          r_ant(k,i) = anew(k,i)
        enddo
      endif
    enddo
  endif
  do_data = .true.
500 return
!
end subroutine ini_base
!
subroutine ini_delay(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY DELAY a1 d1 ... a2 x2 ... [/OFFSET] [INSTRUMENTAL]
  !         [/ALL] [/POL H|V] [/SWITCH DIRECT|CROSSED] [/BB bb] [/IF if] 
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  logical :: fanew(mnbb,mnant), process
  logical :: offset, new, rf, direct, crossed
  real*8 :: anew(mnbb,mnant),newval
  integer(kind=address_length) :: data_in, kin, ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: i, j, ia, ja, nch, is, ipa, jpa, k, l, m
  integer :: ir, ibas, ibb, iif, jbb(mnbb), nbb, ipol
  integer :: mvoc,mvoc1,nkey
  parameter (mvoc = 3, mvoc1 = 2)
  character(len=12) :: voc(mvoc)
  character(len=12) :: voc1(mvoc1)
  character(len=12) :: argum,kw
  character(len=256) :: chain
  character(len=1) :: arg1
  real*8 :: f_to_k
  parameter (f_to_k = 2*pi/1000.)
  real :: x(mnbas), new_delay(mnbb,mnant)
  !
  save offset, anew, fanew, rf, direct, crossed
  !
  data offset/.false./, rf/.true./, direct/.false./, crossed/.false./
  data voc/'HORIZONTAL','VERTICAL','BOTH'/
  data voc1/'DIRECT','CROSSED'/
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  call sic_ke(line,iopt,1,arg1,nch,.false.,error)
  if (error) return
  if (arg1.ne.'D') then
    error = .true.
    return
  endif
  !
  ! /OFFSET option
  offset = sic_present(3,0)
  error = .false.
  do i=1, mnant
    do j = 1, mnbb
      fanew(j,i) = .false.
    enddo
  enddo
  !
  ! /INSTRUMENTAL option
  rf = .not.sic_present(9,0)
  !
  ! /ALL option
  if (sic_present(10,0)) then
    nbb = r_nbb
    do i=1, r_nbb
      jbb(i) = i
    enddo
  !
  ! /BBAND option
  elseif (sic_present(7,0)) then
    call sic_i4(line,7,1,ibb,.true.,error)
    nbb = 1
    jbb(nbb) = ibb 
  !
  ! /IF option
  elseif (sic_present(8,0)) then
    call sic_i4(line,8,1,iif,.true.,error)
    nbb=0
    do i=1, r_lband
      if (r_if(i).eq.iif) then
        new = .true.
        if (nbb.ge.1) then
          do j=1,nbb
            if (r_bb(i).eq.jbb(j)) new = .false.
          enddo
        endif
        if (new) then
          nbb = nbb+1
          jbb(nbb) = r_bb(i)
        endif
      endif
    enddo
  !
  ! /POLARISATION option
  elseif (sic_present(5,0)) then
     call sic_ke(line,5,1,argum,nch,.true.,error)
     if (error) return
     call sic_ambigs('MODIFY DELAY /POLARISATION',argum,kw,nkey,voc,   &
       mvoc,error)
     if (error) return
     if (kw.eq.'HORIZONTAL') then
       ipol = 1
     elseif (kw.eq.'VERTICAL') then
       ipol = 2
     elseif (kw.eq.'BOTH') then
       ipol = 3
     else
       call message(6,3,'MODIFY','Invalid polarisation '//argum)
       error = .true.
       return
     endif
     nbb=0
     do i=1, r_lband
       if (r_lpolentry(1,i).eq.ipol.or.ipol.eq.3) then
         new = .true.
         if (nbb.ge.1) then
           do j=1,nbb
             if (r_bb(i).eq.jbb(j)) new = .false.
           enddo
         endif
         if (new) then
           nbb = nbb+1
           jbb(nbb) = r_bb(i)
         endif
       endif
     enddo
  endif
  !
  ! /SWITCH option
  crossed = .false.
  direct = .false.
  if (sic_present(12,0)) then
    call sic_ke(line,12,1,argum,nch,.true.,error)
    if (error) return
    call sic_ambigs('MODIFY DELAY /SWITCH',argum,kw,nkey,voc1,mvoc1,error)
    if (error) return
    if (kw.eq.'DIRECT') then
      direct = .true.
      call message(6,1,'MODIFY', &
        'Selecting polarisation switch in '//kw//' mode')
    elseif (kw.eq.'CROSSED') then
      crossed = .true.
      call message(6,1,'MODIFY', &
        'Selecting polarisation switch in '//kw//' mode')
    else
      call message(6,3,'MODIFY','Invalid switch status '//argum)
      error = .true.
      return     
    endif
  endif
  if (nbb.le.0) then
      call message(6,3,'MODIFY','No valid baseband found')
      error = .true.
      return
  endif
  call sic_ke(line,iopt,2,argum,nch,.true.,error)
  if (error) return
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    if (j.le.0 .or. j.gt.mnant) then
      write(argum,'(i6)')
      call message(8,4,'INI_DELAY',   &
        'Invalid antenna '//argum(1:lenc(argum)))
      error = .true.
      return
    endif
    call sic_r8(line,iopt,i+1,newval,.true.,error)
    if (error) return
    i = i+2
    do k=1, nbb
      ibb = jbb(k)
      fanew(ibb,j) = .true.
      anew(ibb,j) = newval
    enddo
  enddo
  call message(6,1,'INI_DELAY','Modifying antenna delays to :')
  do i=1, mnant
    if (fanew(ibb,i)) then
      write(chain,'(1x,i0,f15.6)') i,anew(ibb,i)
      call message(6,1,'INI_DELAY',chain(1:lenc(chain)))
    else
      write(chain,'(1x,i0,a)') i,' is not modified'
      call message(6,1,'INI_DELAY',chain(1:lenc(chain)))
    endif
  enddo
  write(chain,'(1x,8i2)'),(jbb(i),i=1,nbb)
  call message(6,1,'INI_DELAY','For basebands'//chain(1:lenc(chain)))
  if (offset) then
    call message (6,1,'INI_DELAY','(Offset values)')
  endif
  return
  !
entry mod_delay(do_write,do_data,error)
  !
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf .and. r_proc.ne.p_pass) goto 500
  if (r_lmode.ne.1) goto 500
  kin = gag_pointer(data_in,memory)
  !
  ! load data header from average record:
  ipk = kin + h_offset(r_ndump+1)
  call decode_header (memory(ipk))
  do i=1, r_nant
    do  j = 1, r_nbb
      l = r_mapbb(j)
      process = fanew(l,i)
      m=(3-r_sb(l))/2
      if (direct) process = process.and.(r_polswitch(i,m).eq.0)
      if (crossed) process = process.and.(r_polswitch(i,m).ne.0)
      if (process) then
        if (offset) then
          new_delay(l,i) = dh_delay(l,i) + anew(l,i)
        else
          new_delay(l,i) = anew(l,i)
        endif
      else
        new_delay(l,i) = dh_delay(l,i)
      endif
      r_dmdelay(l,i) = new_delay(l,i)
    enddo
  enddo
  !
  ! Compute phase factors per subband (for crossed pol case)
  do is  = 1, lband_original
    do ibas = 1, r_nbas
      ia = r_iant(ibas)
      ja = r_jant(ibas)
      ipa = r_bb(is)
      jpa = r_bb(is)
      x(ibas) = f_to_k*((dh_delay(jpa,ja)-new_delay(jpa,ja))   &
        - (dh_delay(ipa,ia)-new_delay(ipa,ia)))
    enddo
    !
    ! Actually modify data:
    if (any(x.ne.0)) call modify_ph(memory(kin),x,is,rf)
  enddo
  !
  ! Save the new delays in the data headers:
  do ir = 1, r_ndump + max(1,r_ndatl)
    ipk = kin + h_offset(ir)
    call decode_header(memory(ipk))
    do ia = 1, r_nant
        call r4tor4(new_delay(1,ia),dh_delay(1,ia),1)
        call r4tor4(new_delay(2,ia),dh_delay(2,ia),1)
    enddo
    call encode_header(memory(ipk))
  enddo
  !
  do_data = .true.
500 return
end subroutine ini_delay
!
subroutine ini_position (line,iopt,error)
  use gkernel_interfaces
  use gbl_constant
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY POSITION Ra Dec
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  integer :: lra,lde
  real*4 :: epoch
  real*8 :: lambda,beta,svec(3),snvec(3),sovec(3),dop,lsr
  character(len=20) :: cra,cde
  character(len=2) :: cs(7),cv(4)
  real*8 :: s_2(2), s_3(3), x_0(3), ut, xx, parang
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  integer :: ibas,i
  integer(kind=address_length) :: data_in,kin,ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: itypec,dobs
  real :: x(mnbas)
  !
  integer :: mvoc1, nkey
  parameter (mvoc1=2)
  character(len=12) :: kw, voc1(mvoc1)
  data voc1/'EQUATORIAL','GALACTIC'/
  data cs /'UN','EQ','GA','HO','BD','EC','DA'/
  data cv /'LS','HE','EA','NU'/
  !------------------------------------------------------------------------
  save lambda,beta,epoch,itypec
  ! Code:
  call check_equal_file(error)
  if (error) return
  !
  ! Assume EQ with given epoch
  kw = 'EQUATORIAL'
  call clic_kw(line,iopt,2,kw,nkey,voc1,mvoc1,.false.,error,.true.)
  if (error) then
    call message(7,3,'INI_POSITION',   &
      'Only Equatorial or Galactic coordinates')
    return
  endif
  if (kw.eq.'EQUATORIAL') then
    itypec = type_eq
  elseif (kw.eq.'GALACTIC') then
    itypec = type_ga
  endif
  call sic_r4(line,iopt,3,epoch,.true.,error)
  if (error) return
  call sic_ke(line,iopt,4,cra,lra,.true.,error)
  if (error) return
  call sic_ke(line,iopt,5,cde,lde,.true.,error)
  if (error) return
  !
  call sic_sexa(cra,lra,lambda,error)
  if (error) return
  lambda = lambda*pi/12.0d0
  call sic_sexa(cde,lde,beta,error)
  if (error) return
  beta = beta*pi/180.0d0
  !
  call message (6,1,'INI_POSITION',   &
    'Modifying position to '   &
    //cra(1:lra)//' '//cde(1:lde))
  return
  !
entry mod_position(do_write,do_data,error)
  ! Test
  do_write = .false.
  do_data = .false.
  !
  ! Set time
  dobs = mod(r_dobs+32768,65536)-32768
  ut = dobs+2460549.5d0+r_ut/2d0/pi
  !
  ! new subroutine calls from astro
  call do_astro_time(ut, 0.0d0, 56.184d0, error)
  !      CALL CLIC_TIME(DOBS,R_UT,ERROR)
  if (error) return
  !
  call do_object(cs(r_typec), r_epoch, r_lam, r_bet,   &
    s_2, s_3, dop, lsr, sovec, x_0, parang, error)
  call do_object(cs(itypec), epoch, lambda, beta,   &
    s_2, s_3, dop, lsr, snvec, x_0, parang, error)
  !
  xx = 0
  do i=1,3
    svec(i) = snvec(i)-sovec(i)
    xx = xx+svec(i)**2
  enddo
  xx = sqrt(xx)*180d0*3600d0/pi
  if (abs(xx).lt.0.001) goto 500
  !
  r_lam = lambda
  r_bet = beta
  r_epoch = epoch
  r_typec = itypec
  !
  ! Modify observation
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf) then 
    goto 500
  endif
  if (r_lmode.ne.1) then
    goto 500
  endif
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in,memory)
  !
  ! load data header from average record:
  ipk = kin + h_offset(r_ndump+1)
  call decode_header (memory(ipk))
  !
  ! Compute phase factors
  do ibas = 1, r_nbas
    x(ibas) = 0
    do i=1,3
      x(ibas) = x(ibas) - svec(i)*r_bas(i,ibas) * f_to_k
    enddo
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)
  !
  ! Real life
  do_data = .true.
  do_write = .true.
500 continue
  return
end subroutine ini_position
!
subroutine ini_time (line,iopt,error)
  use gkernel_interfaces
  use gbl_constant
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY TIME Dut1
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  real*8 :: dut1
  real*8 :: svec(3),snvec(3),sovec(3),dop,lsr, parang
  character(len=80) :: chain
  character(len=2) :: cs(7),cv(4)
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  integer :: ibas,i
  integer(kind=address_length) :: data_in,kin,ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: dobs
  real*8 :: s_2(2), s_3(3), x_0(3), ut, xx
  real :: x(mnbas)
  !
  save dut1
  !
  data cs /'UN','EQ','GA','HO','BD','EC','DA'/
  data cv /'LS','HE','EA','NU'/
  !------------------------------------------------------------------------
  ! Code:
  call check_equal_file(error)
  if (error) return
  !
  call sic_r8(line,iopt,2,dut1,.true.,error)
  if (error) return
  write(chain,'(F8.3)') dut1
  call message (6,1,'INI_TIME',   &
    'Modifying DUT1 by '//chain)
  dut1 = dut1*pi/12.d0/3600d0  ! In radians
  return
  !
entry mod_time (do_write,do_data,error)
  ! Test
  do_write = .false.
  do_data = .false.
  !
  ! Set time
  dobs = mod(r_dobs+32768,65536)-32768
  ut = dobs+2460549.5d0+r_ut/2d0/pi
  !
  ! new subroutine calls from astro
  call do_astro_time(ut, 0.0d0, 56.184d0, error)
  !      CALL CLIC_TIME(DOBS,R_UT,ERROR)
  if (error) return
  !
  ! new subroutine calls from astro
  call do_object(cs(r_typec), r_epoch, r_lam, r_bet,   &
    s_2, s_3, dop, lsr, sovec, x_0, parang, error)
  !
  ! Now correct the UT time
  r_ut = r_ut+dut1
  ut = mod(r_dobs+32768,65536)-32768+2460549.5d0+r_ut/2d0/pi
  call do_astro_time(ut, 0.0d0, 56.184d0, error)
  !      CALL CLIC_TIME(DOBS,R_UT,ERROR)
  if (error) return
  call do_object(cs(r_typec), r_epoch, r_lam, r_bet,   &
    s_2, s_3, dop, lsr, snvec, x_0, parang, error)
  !
  xx = 0
  do i=1,3
    svec(i) = snvec(i)-sovec(i)
    xx = xx+svec(i)**2
  enddo
  xx = sqrt(xx)*180d0*3600d0/pi
  if (abs(xx).lt.0.01) goto 500
  !
  ! Modify observation
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf) then 
    goto 500
  endif
  if (r_lmode.ne.1) then
    goto 500
  endif
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in, memory)
  !
  ! load data header from average record:
  ipk = kin + h_offset(r_ndump+1)
  call decode_header (memory(ipk))
  !
  ! Compute phase factors
  do ibas = 1, r_nbas
    x(ibas) = 0
    do i=1,3
      x(ibas) = x(ibas) - svec(i)*r_bas(i,ibas) * f_to_k
    enddo
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)
  !
  ! Real life
  do_data = .true.
  do_write = .true.
500 continue
  return
end subroutine ini_time
!
subroutine ini_axes(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY AXES_OFFSET  a1 x1 a2 x2 a3 x3 ...
  ! correct the phases of antenna ai for the offset xi (in mm) between
  ! the qazimuth and elevation axes.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  logical :: fanew(mnant)
  real*8 :: anew(mnant)
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length)    :: ndata
  integer :: i, j
  character(len=256) :: chain
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  real*8 :: bdiff
  real :: x(mnbas)
  integer :: i1, i2
  !
  save anew, fanew
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  do i=1, mnant
    fanew(i) = .false.
  enddo
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    fanew(j) = .true.
    call sic_r8(line,iopt,i+1,anew(j),.true.,error)
    if (error) return
    i = i+2
  enddo
  call message(6,1,'INI_BASE','Modifying axes offsets to :')
  do i=1, mnant
    if (fanew(i)) then
      write(chain,'(1x,i0,f12.6)') i,anew(i)
      call message(6,1,'INI_BASE',chain(1:lenc(chain)))
    else
      write(chain,'(1x,i0,a)') i,' is not modified'
      call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      anew(i) = 0d0
    endif
  enddo
  return
  !
entry mod_axes(do_write,do_data,error)
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in,memory)
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf) goto 500
  if (r_lmode.ne.1) goto 500
  !
  ! Compute baseline based axes offsets changes:
  do i = 1, r_nbas
    i1 = r_iant(i)
    i2 = r_jant(i)
    bdiff = 0
    if (fanew(i2)) bdiff = bdiff - (anew(i2)-r_axes(i2))
    if (fanew(i1)) bdiff = bdiff + (anew(i1)-r_axes(i1))
    x(i) = cos(r_el)*bdiff*f_to_k
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)
  !
  ! Update header
  do i=1, r_nant
    if (fanew(i)) then
      r_axes(i) = anew(i)
    endif
  enddo
  do_data = .true.
500 return
!
end subroutine ini_axes
!
subroutine ini_focus(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY FOCUS ...
  ! correct the phases of antenna ai for the offset in focus
  ! if not (correctly) applied in real time:
  !
  ! if  DATE_OBS is before 29-may-1996 :
  !        focus offset was actually logged
  ! if  DATE_OBS is before 29-nov-1996 :
  !        no correction applied to phase from focus offset
  ! if  DATE_OBS is before 02-apr-1998 and if HIGH LOCK:
  !       the focus correction was wrong sign
  ! ->
  ! MODIFY FOCUS:
  !   - between 29-may-1996 and 29-nov-1996: apply correction in header
  !   - between 29-nov-1996 and 02-apr-1998: change sign of corr.in head.
  ! MODIFY FOCUS  a1 x1 a2 x2 a3 x3 :
  !   - any date: modify phases for the focus change and log value in head.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  logical :: fanew(mnant)
  logical :: auto
  real*8 :: anew(mnant)
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length)    :: ndata
  integer :: i, j
  character(len=256) :: chain
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  real*8 :: bdiff
  real :: x(mnbas)
  integer :: i1, i2, autod(3)
  !
  save auto, anew, fanew
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  do i=1, mnant
    fanew(i) = .false.
  enddo
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    fanew(j) = .true.
    call sic_r8(line,iopt,i+1,anew(j),.true.,error)
    if (error) return
    i = i+2
  enddo
  if (i.gt.2) then
    auto = .false.
    call message(6,1,'INI_FOCUS',   &
      'Modifying focus phase offsets to :')
    do i=1, mnant
      if (fanew(i)) then
        write(chain,'(1x,i0,f12.6)') i,anew(i)
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      else
        write(chain,'(1x,i0,a)') i,' is not modified'
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
        anew(i) = 0d0
      endif
    enddo
  else
    auto = .true.
    call message(6,1,'INI_FOCUS',   &
      'Modifying focus phase offsets according to header')
    call cdate('29-may-1996',autod(1),error)
    call cdate('29-nov-1996',autod(2),error)
    call cdate('02-apr-1998',autod(3),error)
  endif
  return
  !
entry mod_focus(do_write,do_data,error)
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in,memory)
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux  &
    .and. r_proc.ne.p_otf) goto 500
  if (r_lmode.ne.1) goto 500
  !
  ! Compute baseline based axes offsets changes:
  do i = 1, r_nbas
    i1 = r_iant(i)
    i2 = r_jant(i)
    bdiff = 0
    if (auto) then
      if (r_dobs.ge.autod(1).and.r_dobs.lt.autod(2)) then
        ! It was not applied ...
        bdiff = bdiff - 2*r_corfoc(i2)
        bdiff = bdiff + 2*r_corfoc(i1)
      elseif (r_dobs.ge.autod(2).and.r_dobs.lt.autod(3)) then
        if (r_lock.gt.0) then
          ! Apply twice: it was wrong way for HIGH LOCK ...
          bdiff = bdiff - 4*r_corfoc(i2)
          bdiff = bdiff + 4*r_corfoc(i1)
        endif
      endif
    else
      if (fanew(i2)) bdiff = bdiff - (anew(i2)-r_corfoc(i2))
      if (fanew(i1)) bdiff = bdiff + (anew(i1)-r_corfoc(i1))
    endif
    ! bdiff was in millimeters.
    x(i) = -bdiff*f_to_k*0.001
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)  ! Could implement a differential
  ! correction here to account for
  ! different focuses. Has to know
  ! the differences in some way.
  !
  ! Update header
  if (.not.auto) then
    do i=1, r_nant
      if (fanew(i)) then
        r_corfoc(i) = anew(i)
      endif
    enddo
  endif
  do_data = .true.
500 return
!
end subroutine ini_focus
!
subroutine modify_ph(data,x,iunit,rf)
  use classic_api
  !---------------------------------------------------------------------
  ! Actually modify the data and keep track of the modify factors.
  ! X is a baseline dependent phase to frequency ratio (in radians/MHz)
  ! Add the possibility only one spectral unit
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  real :: data(*)                   !
  real :: x(mnbas)                  !
  integer :: iunit                  ! <= 0 means all, else unit to modify
  logical :: rf
  ! Global
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer(kind=data_length) :: c_offset, l_offset
  integer :: k, k1, ir, ib, isb, is, i, isign
  integer :: iu1, iu2
  real :: x0, x1, cpha(2,mnbas,mcch), lpha(2,mnbas,mrlband)
  real :: ldph(2,mnbas,mrlband)
  real*8 ::  xph
  !-----------------------------------------------------------------------
  !
  ! Store data modifiers for LR+HR in all cases.
  if (iunit.le.0) then
    iu1 = 1
    iu2 = lband_original
  elseif (iunit.gt.r_nband.or.iunit.gt.lband_original) then
    call message(8,3,'MODIFY_PH','Spectral unit not in data')
    return
  else
    iu1 = iunit
    iu2 = iu1
  endif 
  do ib = 1, r_nbas
    do isb = 1, r_lnsb 
      do is = iu1, iu2
        isign = 3-2*r_lsband(isb,is)
        if (rf) then
          xph = x(ib)*(r_flo1+isign*(r_flo2(is)   &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_cfcen(is))))
        else
          xph = x(ib)*isign*(r_flo2(is)   &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_cfcen(is)))
        endif
        cpha(isb,ib,is) = xph
        r_dmcpha(isb,ib,is) = r_dmcpha(isb,ib,is)+xph
        if (rf) then
          x0 = x(ib)*(r_flo1+isign*(r_flo2(is)   &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_lfcen(is))))
        else
          x0 = x(ib)*isign*(r_flo2(is) &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_lfcen(is)))
        endif
        if (rf) then
          x1 = x(ib)*isign*r_band2(is)*r_band2bis(is)*r_lfres(is)
        else
          x1 = x(ib)*isign*r_band2(is)*r_band2bis(is)*r_lfres(is)
        endif
        lpha(isb,ib,is) = x0
        ldph(isb,ib,is) = x1
        r_dmlpha(isb,ib,is) = r_dmlpha(isb,ib,is) + x0
        r_dmldph(isb,ib,is) = r_dmldph(isb,ib,is) + x1
      enddo
    enddo
  enddo
  !
  ! In lowres mode, modify only LR data
  r_presec(modify_sec) = .true.
  if (lowres.and.iunit.gt.r_lband) return
  if (lowres.and.iunit.eq.0) iu2 = r_nbb
  !
  do ir = 1, r_ndump + max(1,r_ndatl)
    k = c_offset(ir) + 1
    ! Continuum
    do ib = 1, r_nbas
      do isb = 1, r_nsb
        k = k+ (iu1-1)*2
        do is = iu1, iu2
          xph = cpha(isb,ib,is)
          call rotate(data(k),xph)
          k = k+2
        enddo
        k = k + (r_nband-iu2)*2
      enddo
    enddo
    ! Line
    if (ir.gt.r_ndump) then
      k = l_offset(ir) + 1
      do ib = 1, r_nbas
        do isb = 1, r_lnsb
          do is = iu1, iu2
            k1 = k+2*r_lich(is)
            x0 = lpha(isb,ib,is)
            x1 = ldph(isb,ib,is)
            do i = 1, r_lnch(is)
              xph = x0+(i-r_lcench(is))*x1
              call rotate(data(k1),xph)
              k1 = k1+2
            enddo
          enddo
          k = k+2*r_lntch
        enddo
      enddo
    endif
  enddo
  return
end subroutine modify_ph
!
subroutine rotate(c,phi)
  !---------------------------------------------------------------------
  ! Rotate Phase of complex number C by PHI radians
  !---------------------------------------------------------------------
  complex :: c                      !
  real*8 :: phi                     !
  ! Local
  real*8 :: pi
  parameter (pi=3.141592653589d0)
  !------------------------------------------------------------------------
  ! Code:
  phi = mod(phi,2.*pi)
  c = c *cmplx(cos(phi), sin(phi))
  return
end subroutine rotate
!
subroutine clic_kw(line,iopt,iarg,kw,nkey,voc,mvoc,present,error,verbose)
  use gkernel_interfaces
  character(len=*) :: line          !
  integer :: iopt                   !
  integer :: iarg                   !
  character(len=*) :: kw            !
  integer :: nkey                   !
  integer :: mvoc                   !
  character(len=*) :: voc(mvoc)     !
  logical :: present                !
  logical :: error, verbose         !
  ! Local
  character(len=12) :: arg
  integer :: narg
  !-----------------------------------------------------------------------
  arg = kw
  call sic_ke(line,iopt,iarg,arg,narg,present,error)
  if (error.or.iarg.eq.0) return
  if (verbose) then
     call sic_ambigs('CLIC_KW',arg,kw,nkey,voc,mvoc,error)
  else
     call sic_ambigs('',arg,kw,nkey,voc,mvoc,error)
  endif
  return
end subroutine clic_kw
!
subroutine ini_phase(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_index
  use clic_virtual
  !---------------------------------------------------------------------
  ! Command MODIFY PHASE a1 d1 ... a2 x2 ... [/SWITCH DIRECT|CROSSED]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data, crossed, direct
  logical :: fanew(mnbb,mnant), process
  logical :: new
  real*8 :: anew(mnbb,mnant),newval
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length) :: ndata
  integer :: i, j, ia, ja, nch, is, ipa, jpa, k, l, m
  integer :: ibas, ibb, iif, jbb(mnbb), nbb, ipol
  integer :: mvoc,nkey, mvoc1
  parameter (mvoc = 3, mvoc1 = 2)
  character(len=12) :: voc(mvoc),voc1(mvoc1)
  character(len=12) :: argum,kw
  character(len=256) :: chain
  character(len=1) :: arg1
  real*8 :: f_to_k
  parameter (f_to_k = 2*pi/1000.)
  real :: x(mnbas), new_phase(mnbb,mnant)
  !
  save  anew, fanew, direct, crossed
  !
  data voc/'HORIZONTAL','VERTICAL','BOTH'/
  data voc1/'DIRECT','CROSSED'/
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  call sic_ke(line,iopt,1,arg1,nch,.false.,error)
  if (error) return
  if (arg1.ne.'P') then
    error = .true.
    return
  endif
  error = .false.
  do i=1, mnant
    do j = 1, mnbb
      fanew(j,i) = .false.
    enddo
  enddo
  !
  ! /ALL option
  if (sic_present(10,0)) then
    nbb = r_nbb
    do i=1, r_nbb
      jbb(i) = i
    enddo
  !
  ! /BBAND option
  elseif (sic_present(7,0)) then
    call sic_i4(line,7,1,ibb,.true.,error)
    nbb = 1
    jbb(nbb) = ibb 
  !
  ! /IF option
  elseif (sic_present(8,0)) then
    call sic_i4(line,8,1,iif,.true.,error)
    nbb=0
    do i=1, r_lband
      if (r_if(i).eq.iif) then
        new = .true.
        if (nbb.ge.1) then
          do j=1,nbb
            if (r_bb(i).eq.jbb(j)) new = .false.
          enddo
        endif
        if (new) then
          nbb = nbb+1
          jbb(nbb) = r_bb(i)
        endif
      endif
    enddo
  endif
  !
  ! /POLARISATION option
  if (sic_present(5,0)) then
    call sic_ke(line,5,1,argum,nch,.true.,error)
    if (error) return
    call sic_ambigs('MODIFY PHASE /POLARISATION',argum,kw,nkey,voc,   &
     mvoc,error)
    if (error) return
    if (kw.eq.'HORIZONTAL') then
      ipol = 1
    elseif (kw.eq.'VERTICAL') then
      ipol = 2
    elseif (kw.eq.'BOTH') then
      ipol = 3
    else
      call message(6,3,'MODIFY','Invalid polarisation '//argum)
      error = .true.
      return
    endif
    nbb=0
    do i=1, r_lband
      if (r_lpolentry(1,i).eq.ipol.or.ipol.eq.3) then
        new = .true.
        if (nbb.ge.1) then
          do j=1,nbb
            if (r_bb(i).eq.jbb(j)) new = .false.
          enddo
        endif
        if (new) then
          nbb = nbb+1
          jbb(nbb) = r_bb(i)
        endif
      endif
    enddo
  endif
  !
  ! /SWITCH option
  crossed = .false.
  direct = .false.
  if (sic_present(12,0)) then
    call sic_ke(line,12,1,argum,nch,.true.,error)
    if (error) return
    call sic_ambigs('MODIFY PHASE /SWITCH',argum,kw,nkey,voc1,mvoc1,error)
    if (error) return
    if (kw.eq.'DIRECT') then
      direct = .true.
      call message(6,1,'MODIFY', &
        'Selecting polarisation switch in '//kw//' mode')
    elseif (kw.eq.'CROSSED') then
      crossed = .true.
      call message(6,1,'MODIFY', &
        'Selecting polarisation switch in '//kw//' mode')
    else
      call message(6,3,'MODIFY','Invalid switch status '//argum)
      error = .true.
      return     
    endif
  endif
!
! Now code
  if (nbb.le.0) then
      call message(6,3,'MODIFY','No valid baseband found')
      error = .true.
      return
  endif
  call sic_ke(line,iopt,2,argum,nch,.true.,error)
  if (error) return
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    if (j.le.0 .or. j.gt.mnant) then
      write(argum,'(i6)')
      call message(8,4,'INI_PHASE',   &
        'Invalid antenna '//argum(1:lenc(argum)))
      error = .true.
      return
    endif
    call sic_r8(line,iopt,i+1,newval,.true.,error)
    if (error) return
    i = i+2
    do k=1, nbb
      ibb = jbb(k)
      fanew(ibb,j) = .true.
      anew(ibb,j) = newval
    enddo
  enddo
  call message(6,1,'INI_PHASE','Modifying antenna phases by :')
  do i=1, mnant
    if (fanew(ibb,i)) then
      write(chain,'(1x,i0,f15.6)') i,anew(ibb,i)
      call message(6,1,'INI_PHASE',chain(1:lenc(chain)))
    else
      write(chain,'(1x,i0,a)') i,' is not modified'
      call message(6,1,'INI_PHASE',chain(1:lenc(chain)))
    endif
  enddo
  write(chain,'(1x,8i2)'),(jbb(i),i=1,nbb)
  call message(6,1,'INI_PHASE','For basebands'//chain(1:lenc(chain)))
  return
  !
entry mod_phase(do_write,do_data,error)
  !
  do_data = .false.
  if (error) return
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf .and. r_proc.ne.p_pass) goto 500
  if (r_lmode.ne.1) goto 500
  !
  do i=1, r_nant
    do  j = 1, r_nbb
      l = r_mapbb(j)
      process = fanew(l,i)
      m=(3-r_sb(l))/2    
      if (direct)  process = process.and.(r_polswitch(i,m).eq.0)
      if (crossed) process = process.and.(r_polswitch(i,m).ne.0)
      if (process) then
        new_phase(l,i) = anew(l,i)
      else
        new_phase(l,i) = 0.0
      endif
    enddo
  enddo
  !
  ! Compute phase factors per subband (for crossed pol case)
  do is  = 1, lband_original
    do ibas = 1, r_nbas
      ia = r_iant(ibas)
      ja = r_jant(ibas)
      ipa = r_bb(is)
      jpa = r_bb(is)
      x(ibas) = new_phase(ipa,ia)-new_phase(jpa,ja)
      if (degrees) x(ibas) = x(ibas)*pi/180.
    enddo
    !
    ! Actually modify data:
    if (got_data(r_xnum)) then
      call get_data(ndata,data_in,error)
      kin = gag_pointer(data_in,memory)
    else
      kin = 0
    endif
    if (any(x.ne.0)) call modify_phase(memory(kin),x,is)
  enddo
  if (.not.got_data(r_xnum)) goto 500
  !
  do_data = .true.
500 return
end subroutine ini_phase
!
subroutine modify_phase(data,x,iunit)
  use classic_api
  use clic_index
  use clic_virtual
  !---------------------------------------------------------------------
  ! Actually modify the data and keep track of the modify factors.
  ! X is a baseline dependent phase offset.
  ! Add the possibility only one spectral unit.
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  real :: data(*)                   !
  real :: x(mnbas)                  !
  integer :: iunit                  ! <= 0 means all, else unit to modify
  ! Global
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer(kind=data_length) :: c_offset, l_offset
  integer :: k, k1, ir, ib, isb, is, i, isign
  integer :: iu1, iu2
  real :: cpha(2,mnbas,mcch), lpha(2,mnbas,mrlband)
  real*8 ::  xph
  !-----------------------------------------------------------------------
  !
  ! Store data modifiers for LR+HR in all cases.
  if (iunit.le.0) then
    iu1 = 1
    iu2 = lband_original
  elseif (iunit.gt.r_nband.or.iunit.gt.lband_original) then
    call message(8,3,'MODIFY_PH','Spectral unit not in data')
    return
  else
    iu1 = iunit
    iu2 = iu1
  endif 
  do ib = 1, r_nbas
    do isb = 1, r_lnsb 
      do is = iu1, iu2
        isign = 3-2*r_lsband(isb,is)
        cpha(isb,ib,is) = x(ib)
        r_dmcpha(isb,ib,is) = r_dmcpha(isb,ib,is)+x(ib)
        lpha(isb,ib,is) = x(ib)
        r_dmlpha(isb,ib,is) = r_dmlpha(isb,ib,is) + x(ib)
      enddo
    enddo
  enddo
  !
  ! In lowres mode, modify only LR data
  r_presec(modify_sec) = .true.
  if (lowres.and.iunit.gt.r_lband) return
  if (lowres.and.iunit.eq.0) iu2 = r_nbb
  !
  ! Only modify data in memory
  if (.not.got_data(r_xnum)) return
  !
  do ir = 1, r_ndump + max(1,r_ndatl)
    k = c_offset(ir) + 1
    ! Continuum
    do ib = 1, r_nbas
      do isb = 1, r_nsb
        k = k+ (iu1-1)*2
        do is = iu1, iu2
          xph = cpha(isb,ib,is)
          call rotate(data(k),xph)
          k = k+2
        enddo
        k = k + (r_nband-iu2)*2
      enddo
    enddo
    ! Line
    if (ir.gt.r_ndump) then
      k = l_offset(ir) + 1
      do ib = 1, r_nbas
        do isb = 1, r_lnsb
          do is = iu1, iu2
            k1 = k+2*r_lich(is)
            xph = lpha(isb,ib,is)
            do i = 1, r_lnch(is)
              call rotate(data(k1),xph)
              k1 = k1+2
            enddo
          enddo
          k = k+2*r_lntch
        enddo
      enddo
    endif
  enddo
  return
end subroutine modify_phase

module gtv_interfaces_public
  interface
    function gtexist(name)
      use gtv_buffers
      use gtv_types
      !---------------------------------------------------------------------
      ! @ public
      ! Logical function indicating wether a segment/directory exists
      !---------------------------------------------------------------------
      logical :: gtexist                    ! Function value on return
      character(len=*), intent(in) :: name  ! Name to search for
    end function gtexist
  end interface
  !
  interface
    subroutine gtchar(nchars,string,size,slength,xp,yp,co,si,ic,ifont,  &
      doclip,gpoly_clip)
      use phys_const
      use gtv_tree
      use gtv_buffers
      use gtv_graphic
      use gtv_protocol
      !---------------------------------------------------------------------
      ! @ public
      !   Plots a character string according to current line attributes.
      ! Indices, subscripts, and special fonts are selected using the escape
      ! character \ (C.f. GREG and VSTRIN routine in CHARSHR).
      !
      !   The hard font line attribute is incompatible with the handling of
      ! the escape character \ . The argument IFONT indicates which font
      ! should be taken into account: 0 = Hardware, 1 Simplex, 2 Duplex. If
      ! the hardware generator cannot reasonably match (CO,SI) and SIZE, the
      ! SIMPLEX font is used.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)  :: nchars      ! Number of characters
      character(len=*), intent(in)  :: string      ! Character string
      real(kind=4),     intent(in)  :: size        ! Character width (plot page units)
      real(kind=4),     intent(out) :: slength     ! String length (plot page units)
      real(kind=4),     intent(in)  :: xp          ! Position where to write the string
      real(kind=4),     intent(in)  :: yp          !
      real(kind=4),     intent(in)  :: co          ! Cosine of angle
      real(kind=4),     intent(in)  :: si          ! Sine of angle
      integer(kind=4),  intent(in)  :: ic          ! Centering option according to GREG conventions
      integer(kind=4),  intent(in)  :: ifont       ! Font type (0 Simplex, 1 Duplex)
      logical,          intent(in)  :: doclip      ! Clip with current Greg box?
      external                      :: gpoly_clip  !
      interface
        subroutine gpoly_clip(nq,xq,yq)
          use gildas_def
          integer(kind=size_length), intent(in) :: nq     ! Number of points
          real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
          real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
        end subroutine gpoly_clip
      end interface
    end subroutine gtchar
  end interface
  !
  interface
    subroutine gtg_charlen (nchars,string,size,slength,ifont)
      use gtv_tree
      use gtv_graphic
      !---------------------------------------------------------------------
      ! @ public
      !   Returns the length of a character string according to current
      ! font attributes. No action on the plot. See also GTCHAR
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)  :: nchars   ! Number of characters
      character(len=*), intent(in)  :: string   ! Character string
      real(kind=4),     intent(in)  :: size     ! Character size (plot page units)
      real(kind=4),     intent(out) :: slength  ! String length (plot page units)
      integer(kind=4),  intent(in)  :: ifont    ! Font type
    end subroutine gtg_charlen
  end interface
  !
  interface
    subroutine gtclal
      use gtv_protocol
      !---------------------------------------------------------------------
      ! @ public obsolescent 22-sep-2009
      ! Obsolete entry point to 'gtv_clear_alpha'. To be removed from
      ! official documentation before.
      !---------------------------------------------------------------------
    end subroutine gtclal
  end interface
  !
  interface
    subroutine gt_clear_segment(argum_in,present,error)
      use gtv_buffers
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Destroy the input segment(s) given its(their) name. They can have
      ! an absolute path. Argument 'present' indicates if the segment(s)
      ! must exist i.e. if it should be an error if it(they) is(are) not
      ! found.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: argum_in  ! Segment name
      logical,          intent(in)    :: present   ! Must the segment exist?
      logical,          intent(inout) :: error     ! Logical error flag
    end subroutine gt_clear_segment
  end interface
  !
  interface
    subroutine gtv_clear_directory(name,error)
      use gbl_message
      use gtv_buffers
      use gtv_types
      !---------------------------------------------------------------------
      ! @ public
      ! Support for CLEAR DIRECTORY, using a name as input argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: name   !
      logical,          intent(inout) :: error  !
    end subroutine gtv_clear_directory
  end interface
  !
  interface
    subroutine exit_clear
      use gtv_bitmap
      use gtv_buffers
      use gtv_plot
      use gtv_protocol
      !---------------------------------------------------------------------
      ! @ public
      !  This function exists solely to prevent all the wild machinations
      ! that 'gtv_destroy_all' does in recreating the x graphical
      ! environment, when all you are really trying to do is exit the
      ! program so you can go home. It is therefore only called by program
      ! GreG before calling GTCLOS
      !---------------------------------------------------------------------
      ! Local
    end subroutine exit_clear
  end interface
  !
  interface
    subroutine gtg_screen(qx1,qx2,qy1,qy2)
      use gtv_protocol
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the coordinates of the end pixels of the physical screen
      ! (world units). Very useful for interactive zooming. Works on the
      ! Current Working Output.
      !---------------------------------------------------------------------
      real, intent(out) :: qx1,qx2  !
      real, intent(out) :: qy1,qy2  !
    end subroutine gtg_screen
  end interface
  !
  interface
    function gtg_curs()
      use gtv_protocol
      !---------------------------------------------------------------------
      ! @ public
      !   Informs if a cursor is available on the current device
      !---------------------------------------------------------------------
      logical :: gtg_curs  ! Function value on return
    end function gtg_curs
  end interface
  !
  interface
    subroutine gtcurs(xcm,ycm,ch,error)
      use gbl_message
      use gtv_buffers
      use gtv_protocol
      !---------------------------------------------------------------------
      ! @ public
      ! Same as gtcurs_sub but works on the Current Working Output
      !---------------------------------------------------------------------
      real,             intent(inout) :: xcm,ycm  !
      character(len=*), intent(out)   :: ch       !
      logical,          intent(inout) :: error    !
    end subroutine gtcurs
  end interface
  !
  interface
    subroutine gicurs(xcm,ycm,rect_xw_cm,rect_yw_cm,ch,error)
      use gbl_message
      use gtv_buffers
      use gtv_protocol
      !---------------------------------------------------------------------
      ! @ public
      ! Same as gicurs_sub but works on the Current Working Output
      !---------------------------------------------------------------------
      real(kind=4),     intent(inout) :: xcm,ycm                !
      real(kind=4),     intent(in)    :: rect_xw_cm,rect_yw_cm  !
      character(len=*), intent(out)   :: ch                     !
      logical,          intent(inout) :: error                  !
    end subroutine gicurs
  end interface
  !
  interface
    subroutine gtv_destroy_directory(name,error)
      use gbl_message
      use gtv_buffers
      use gtv_types
      !---------------------------------------------------------------------
      ! @ public
      ! Support for DESTROY DIRECTORY, using a name as input argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: name   !
      logical,          intent(inout) :: error  !
    end subroutine gtv_destroy_directory
  end interface
  !
  interface
    subroutine gtv_destroy_all(error)
      use gildas_def
      use gtv_tree
      use gtv_buffers
      use gtv_graphic
      use gtv_protocol
      use gtv_plot
      use gtv_segatt
      use gtv_types
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Destroy all the trees and windows.
      !   Since it is forbidden to user to be in root (<) and to create
      ! segments in it, he would have first to create a new top-directory
      ! and go in it. So we do it implicitely for him.
      !   In practice, destroy all the trees and windows EXCEPT the first
      ! window of the first child under root (normally, <GREG). This avoids
      ! to destroy and recreate a new window which could be moved to another
      ! place by the window manager.
      ! ---
      !  Thread status: safe to call from main thread.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine gtv_destroy_all
  end interface
  !
  interface
    subroutine gtclear
      !---------------------------------------------------------------------
      ! @ public obsolete
      ! Obsolete entry point to 'gtv_destroy_all'. To be removed from
      ! some packages and official documentation before.
      ! SB, 22-09-2009
      !---------------------------------------------------------------------
    end subroutine gtclear
  end interface
  !
  interface
    subroutine gtv_image(nx,ny,data,location,limits,convert,scaling,cuts,extrema,  &
      blank,is_visible,is_curima,error)
      use gbl_message
      use gtv_bitmap
      use gtv_buffers
      use gtv_plot
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Allocate a new GTVIRT image slot. Image numbers may not be
      ! continuous, search for one from start.
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: nx   ! Image size in X
      integer(kind=index_length), intent(in) :: ny   ! Image size in Y
      real(kind=4),    intent(in)    :: data(nx,ny)  ! Image values
      real(kind=4),    intent(in)    :: location(4)  ! Position in Paper coordinates
      real(kind=4),    intent(in)    :: limits(4)    ! User limits
      real(kind=4),    intent(in)    :: convert(6)   ! Image pixel to User conversion formula
      integer(kind=4), intent(in)    :: scaling      ! Scaling mode (1=Lin, 2=Log, 3=Equ)
      real(kind=4),    intent(in)    :: cuts(2)      ! Low and High cut
      real(kind=4),    intent(in)    :: extrema(2)   ! Low and High extrema
      real(kind=4),    intent(in)    :: blank(3)     ! Blanking value
      logical,         intent(in)    :: is_visible   ! Always Visible ?
      logical,         intent(in)    :: is_curima    ! Update the SIC structure CURIMA% ?
      logical,         intent(inout) :: error        ! Logical error flag
    end subroutine gtv_image
  end interface
  !
  interface
    subroutine gtv_rgbimage(nx,ny,    &
        rdata,rblank,rcuts,rextrema,  &
        gdata,gblank,gcuts,gextrema,  &
        bdata,bblank,bcuts,bextrema,  &
        scaling,scaling_lup_b,        &
        location,limits,convert,is_visible,error)
      use gbl_message
      use gtv_bitmap
      use gtv_buffers
      use gtv_plot
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Allocate a new GTVIRT image slot. Image numbers may not be
      ! continuous, search for one from start.
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: nx         ! RGB image size in X
      integer(kind=index_length), intent(in) :: ny         ! RGB image size in Y
      real(kind=4),    intent(in)    :: rdata(nx,ny)       ! R image values
      real(kind=4),    intent(in)    :: rblank(3)          ! R blanking value
      real(kind=4),    intent(in)    :: rcuts(2)           ! R low and high cut
      real(kind=4),    intent(in)    :: rextrema(2)        ! R low and high extrema
      real(kind=4),    intent(in)    :: gdata(nx,ny)       ! G image values
      real(kind=4),    intent(in)    :: gblank(3)          ! G blanking value
      real(kind=4),    intent(in)    :: gcuts(2)           ! G low and high cut
      real(kind=4),    intent(in)    :: gextrema(2)        ! G low and high extrema
      real(kind=4),    intent(in)    :: bdata(nx,ny)       ! B image values
      real(kind=4),    intent(in)    :: bblank(3)          ! B blanking value
      real(kind=4),    intent(in)    :: bcuts(2)           ! B low and high cut
      real(kind=4),    intent(in)    :: bextrema(2)        ! B low and ligh extrema
      integer(kind=4), intent(in)    :: scaling            ! RGB scaling mode
      real(kind=4),    intent(in)    :: scaling_lup_b      ! Beta parameter for Lupton scaling mode
      real(kind=4),    intent(in)    :: location(4)        ! Position in Paper coordinates
      real(kind=4),    intent(in)    :: limits(4)          ! User limits
      real(kind=4),    intent(in)    :: convert(6)         ! Image pixel to User conversion formula
      logical,         intent(in)    :: is_visible         ! Always Visible ?
      logical,         intent(inout) :: error              ! Logical error flag
    end subroutine gtv_rgbimage
  end interface
  !
  interface
    subroutine gtv_fillpoly(n,x,y,vert,error)
      use gtv_tree
      use gtv_buffers
      use gtv_graphic
      use gtv_plot
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !     Plot a filled polygon. Filling based on Horizontal scanning.
      !     or Vertical scanning if VERT = .TRUE.
      ! ---
      !   Threads status: thread safe
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n      ! Number of points
      real(kind=4),    intent(in)    :: x(n)   !
      real(kind=4),    intent(in)    :: y(n)   !
      logical,         intent(in)    :: vert   ! Horizontal or vertical polygon?
      logical,         intent(inout) :: error  ! Logical error flag
    end subroutine gtv_fillpoly
  end interface
  !
  interface
    subroutine gr8_bltlis(lpoly,llv,npoly,nvert,xv,yv,iy,lnx,ixl,ixu)
      !---------------------------------------------------------------------
      ! @ public
      ! From a list of polygons, BLTLIS makes a list of horizontal line
      ! segments included in the polygons. There might several segments
      ! to fill for a row crossed by a single polygon.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: lpoly      ! Beginning polygon number
      integer(kind=4), intent(in)  :: llv        ! Beginning vertex number
      integer(kind=4), intent(in)  :: npoly      ! Number of polygons
      integer(kind=4), intent(in)  :: nvert(2)   ! Number of vertices in each polygon
      real(kind=8),    intent(in)  :: xv(1024)   ! X position of vertices
      real(kind=8),    intent(in)  :: yv(1024)   ! Y position of vertices
      real(kind=8),    intent(in)  :: iy         ! Row number
      integer(kind=4), intent(out) :: lnx        ! Number of segments
      real(kind=8),    intent(out) :: ixl(1024)  ! Low x index of segments
      real(kind=8),    intent(out) :: ixu(1024)  ! High x index of segments
    end subroutine gr8_bltlis
  end interface
  !
  interface
    subroutine gr4_bltlis(lpoly,llv,npoly,nvert,xv,yv,iy,lnx,ixl,ixu)
      !---------------------------------------------------------------------
      ! @ public
      ! From a list of polygons, BLTLIS makes a list of horizontal line
      ! segments included in the polygons. There might several segments
      ! to fill for a row crossed by a single polygon.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: lpoly      ! Beginning polygon number
      integer(kind=4), intent(in)  :: llv        ! Beginning vertex number
      integer(kind=4), intent(in)  :: npoly      ! Number of polygons
      integer(kind=4), intent(in)  :: nvert(2)   ! Number of vertices in each polygon
      real(kind=4),    intent(in)  :: xv(1024)   ! X position of vertices
      real(kind=4),    intent(in)  :: yv(1024)   ! Y position of vertices
      real(kind=4),    intent(in)  :: iy         ! Row number
      integer(kind=4), intent(out) :: lnx        ! Number of segments
      real(kind=4),    intent(out) :: ixl(1024)  ! Low x index of segments
      real(kind=4),    intent(out) :: ixu(1024)  ! High x index of segments
    end subroutine gr4_bltlis
  end interface
  !
  interface
    subroutine gtv_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gtv_message_set_id
  end interface
  !
  interface
    subroutine gtview(acha)
      use gtv_protocol
      use gtv_graphic
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Plot to the interactive graphic device
      !
      ! 'Append'   Plot from last vector drawn
      ! 'Rewind'   Clear the screen, and plot from first vector
      ! 'Update'   Update the screens (Clear + Redraw)
      ! 'Color'    Update the screens (Redraw only)
      !
      ! Does not modify the virtuel pen position and the immediate pen
      ! position. P. Valiron
      !
      ! Modifiee pour parcourir une arborescence par R.Gras. (Octobre 1992)
      ! Modifiee par S.Guilloteau pour tracer les images AVANT les
      ! segments graphiques en cas de Rewind. Bigrement modifiee par GD, pendant
      ! qu'on y est...
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: acha  ! Key character of the required mode
    end subroutine gtview
  end interface
  !
  interface
    subroutine gtinit(sx,sy,lunt,lunh,main,greg_user,error)
      use gildas_def
      use gbl_message
      use gtv_bitmap
      use gtv_buffers
      use gtv_colors
      use gtv_graphic
      use gtv_plot
      use gtv_protocol
      use gtv_segatt
      use gtv_tree
      !---------------------------------------------------------------------
      ! @ public
      ! Initializes the GTVIRT on a blank world space
      !---------------------------------------------------------------------
      real(kind=4),     intent(in)    :: sx     ! World space in X [0...SX]
      real(kind=4),     intent(in)    :: sy     ! World space in Y [0...SY]
      integer(kind=4),  intent(in)    :: lunt   ! Logical unit number for terminal
      integer(kind=4),  intent(in)    :: lunh   ! Logical unit number for hardcopy. Unused.
      character(len=*), intent(in)    :: main   ! Main directory name
      external :: greg_user  ! Address of a routine to get user coordinates transformation
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gtinit
  end interface
  !
  interface
    subroutine gt_setphysical(sx,sy,error)
      use gtv_buffers
      use gtv_graphic
      use gtv_protocol
      use gtv_types
      !---------------------------------------------------------------------
      !  @ public
      !  Reset the physical size of the current tree (only): top directory
      ! must be emptied and use the new values before storing anything. Next
      ! top directories will also use these values.
      !  In practice, this is done like this:
      !   1) go to top directory
      !   2) empty top directory
      !   3) set new physical size of top directory in GTV
      !   4) store new physical size of top directory in GREG (callback)
      !---------------------------------------------------------------------
      real(kind=4), intent(in)    :: sx     ! World space in X [0...SX]
      real(kind=4), intent(in)    :: sy     ! World space in X [0...SX]
      logical,      intent(inout) :: error  ! Logical error flag
    end subroutine gt_setphysical
  end interface
  !
  interface
    subroutine gtreloc(x,y)
      use gtv_tree
      use gtv_buffers
      use gtv_graphic
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !
      !	Relocates the virtual pen to (X,Y)
      !	X,Y	World coordinates			Real*4
      !---------------------------------------------------------------------
      real*4 :: x                       !
      real*4 :: y                       !
    end subroutine gtreloc
  end interface
  !
  interface
    subroutine gtdraw(x,y)
      use gtv_tree
      use gtv_buffers
      use gtv_graphic
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !
      !	Draws to (X,Y)
      !	X,Y	World coordinates			Real*4
      !---------------------------------------------------------------------
      real*4 :: x                       !
      real*4 :: y                       !
    end subroutine gtdraw
  end interface
  !
  interface
    subroutine gtsegm(name,error)
      use gtv_tree
      use gtv_buffers
      use gtv_graphic
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Initialise a new segment with the current line attributes. No
      ! action if the current segment is empty (except making the
      ! Attribute(4) positive, i.e. visible).
      ! ---
      !   Threads status: thread safe
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name   ! Name of the new segment
      logical,          intent(out) :: error  ! Logical error flag
    end subroutine gtsegm
  end interface
  !
  interface
    subroutine gtsegm_close(error)
      use gbl_message
      use gtv_buffers
      use gtv_graphic
      !---------------------------------------------------------------------
      ! @ public?
      !  Close the segment currently opened. It is harmless to close several
      ! time the same segment.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine gtsegm_close
  end interface
  !
  interface
    subroutine gtedit(dashed,weight,colour,level,visible)
      use gbl_message
      use gtv_buffers
      use gtv_graphic
      use gtv_tree
      use gtv_types
      !---------------------------------------------------------------------
      ! @ public
      !   Edit the current segment with the current line attributes
      ! ---
      !   Threads status: thread safe
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: dashed   ! Line Type
      real(kind=4),    intent(in) :: weight   ! [cm] Line width
      integer(kind=4), intent(in) :: colour   ! Colour index
      integer(kind=4), intent(in) :: level    ! Display Depth
      logical,         intent(in) :: visible  ! Visible segment attribute
    end subroutine gtedit
  end interface
  !
  interface
    subroutine gtdls
      use gtv_buffers
      use gtv_graphic
      use gtv_segatt
      use gtv_tree
      use gtv_types
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Deletes the last segment in the current directory, taking care
      ! of the chain and pointers in the tree.
      !
      ! Does not modify:
      !  - the virtuel pen position,
      !  - the immediate pen position,
      !  - the pen attributes. Those from the previous segment might not be
      !    consistent with the current pen exposed in GreG.
      ! ---
      !   Threads status: thread safe
      !---------------------------------------------------------------------
      ! Local
    end subroutine gtdls
  end interface
  !
  interface
    subroutine gtl_corner(error)
      use gtv_buffers
      !---------------------------------------------------------------------
      ! @ public
      ! GTVIRT support routine for command
      !   CORNERS
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine gtl_corner
  end interface
  !
  interface
    subroutine run_gtvl(line,comm,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (public but should not) (mandatory because
      ! symbol is used elsewhere)
      !---------------------------------------------------------------------
      character(len=*)              :: line   !
      character(len=*)              :: comm   !
      logical,          intent(out) :: error  !
    end subroutine run_gtvl
  end interface
  !
  interface
    subroutine gtv_lut(error)
      use gtv_tree
      use gtv_buffers
      use gtv_plot
      use gtv_graphic
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Save the current bitmap color Look Up Table into the METACODE
      ! ---
      !   Threads status: thread safe
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine gtv_lut
  end interface
  !
  interface
    subroutine gterflag(flag)
      use gtv_graphic
      !---------------------------------------------------------------------
      ! @ public
      !
      !	Controls whether fatal errors cause an Abort or just set an
      !	error condition that can be sensed using the GTERRGTO or
      !	GTERRTST routines.
      !
      !	This is the only routine that you can call BEFORE the first call
      !	to GTINIT.
      !
      ! Argument :
      !	FLAG	.FALSE.	Errors are fatal (Default behaviour)
      !		.TRUE.  Errors are not fatal and can be sensed using
      !			the routine GTERRTST
      !---------------------------------------------------------------------
      logical :: flag                   !
    end subroutine gterflag
  end interface
  !
  interface
    function gterrtst()
      use gtv_graphic
      !---------------------------------------------------------------------
      ! @ public
      !
      !	Logical function. Senses the ERROR_CONDITION switch.
      !
      !	Returns the value of the ERROR_CONDITION flag.
      !	Resets the ERROR_CONDITION flag.
      !---------------------------------------------------------------------
      logical :: gterrtst               !
    end function gterrtst
  end interface
  !
  interface
    subroutine gtv_pencol_arg2id(rname,line,iopt,iarg,icol,error)
      use gbl_message
      use gtv_colors
      !---------------------------------------------------------------------
      ! @ public
      ! Decode the a color argument and return the GTV internal identifier
      ! for this color. Input can be:
      !  - A color name, e.g. RED, BLUE, FOREST_GREEN,...
      !  - A Greg color number (1=RED, ..., 23=user custom color)
      !  - An integer variable providing a Greg color number
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname
      character(len=*), intent(in)    :: line
      integer(kind=4),  intent(in)    :: iopt
      integer(kind=4),  intent(in)    :: iarg
      integer(kind=4),  intent(out)   :: icol
      logical,          intent(inout) :: error
    end subroutine gtv_pencol_arg2id
  end interface
  !
  interface
    subroutine gtv_pencol_name2id(rname,colname,icol,error)
      use gtv_colors
      !---------------------------------------------------------------------
      ! @ public
      ! Return the color identifier given its name. Input must be
      ! uppercased. A full name is not ambiguous. Error if not found.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname
      character(len=*), intent(in)    :: colname
      integer(kind=4),  intent(out)   :: icol
      logical,          intent(inout) :: error
    end subroutine gtv_pencol_name2id
  end interface
  !
  interface
    subroutine gtv_pencol_num2id(rname,colnum,colid,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Translate Greg color number [-1:23] to GTV color identifier
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname
      integer(kind=4),  intent(in)    :: colnum
      integer(kind=4),  intent(out)   :: colid
      logical,          intent(inout) :: error
    end subroutine gtv_pencol_num2id
  end interface
  !
  interface
    function gtv_pencol_id2name(icol)
      use gtv_colors
      !---------------------------------------------------------------------
      ! @ public
      ! Return the color name given its identifier. No error, returns ???
      ! if not found.
      !---------------------------------------------------------------------
      character(len=colname_length) :: gtv_pencol_id2name  ! Function value on return
      integer(kind=4), intent(in) :: icol
    end function gtv_pencol_id2name
  end interface
  !
  interface
    subroutine gtv_pendash_arg2id(rname,line,iopt,iarg,idash,error)
      use gbl_message
      use gtv_segatt
      !---------------------------------------------------------------------
      ! @ public
      ! Decode the dash argument and return the corresponding code
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname
      character(len=*), intent(in)    :: line
      integer(kind=4),  intent(in)    :: iopt
      integer(kind=4),  intent(in)    :: iarg
      integer(kind=4),  intent(out)   :: idash
      logical,          intent(inout) :: error
    end subroutine gtv_pendash_arg2id
  end interface
  !
  interface
    subroutine gtv_penwei_arg2val(rname,line,iopt,iarg,wei,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Decode the weight argument and return the width (cm) for this
      ! weight. Input can be:
      !  - A Greg weight number (1 to 5 according to 'graisse()' predefined
      !    weights) and possible formulas or variable
      !  - A value of the form "1.23mm" (mm are used for user interface)
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname
      character(len=*), intent(in)    :: line
      integer(kind=4),  intent(in)    :: iopt
      integer(kind=4),  intent(in)    :: iarg
      real(kind=4),     intent(out)   :: wei
      logical,          intent(inout) :: error
    end subroutine gtv_penwei_arg2val
  end interface
  !
  interface
    subroutine gtv_penwei_num2val(rname,iwei,wei,error)
      use gbl_message
      use gtv_segatt
      !---------------------------------------------------------------------
      ! @ public
      ! Decode the Greg weight number as the actual width (cm)
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname
      integer(kind=4),  intent(in)    :: iwei
      real(kind=4),     intent(out)   :: wei
      logical,          intent(inout) :: error
    end subroutine gtv_penwei_num2val
  end interface
  !
  interface
    function gtv_penwei_tostr(wei)
      use gtv_segatt
      !---------------------------------------------------------------------
      ! @ public
      !  Convert the input weight value (cm) to a user friendly output (mm),
      ! e.g.
      !   "1 0.15mm" for predefined weights, or
      !   "  1.23mm" for custom weights
      !---------------------------------------------------------------------
      character(len=8) :: gtv_penwei_tostr  ! Function value on return
      real(kind=4), intent(in) :: wei  ! [cm]
    end function gtv_penwei_tostr
  end interface
  !
  interface
    subroutine gtv_points(n,x,y,error)
      use gbl_message
      use gtv_tree
      use gtv_buffers
      use gtv_graphic
      use gtv_plot
      !---------------------------------------------------------------------
      ! @ public
      !  Store a list of dotted points in the GTV tree. For larger points,
      ! polylines (one per point) must be used.
      ! ---
      !   Threads status: thread safe
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n      ! Number of points
      real(kind=4),    intent(in)    :: x(n)   !
      real(kind=4),    intent(in)    :: y(n)   !
      logical,         intent(inout) :: error  ! Logical error flag
    end subroutine gtv_points
  end interface
  !
end module gtv_interfaces_public

!-----------------------------------------------------------------------
! Support file for PYCLASS extensions, Fortran part
!-----------------------------------------------------------------------
!  Always compile this file, even if Python binding is disabled. This
! avoids different interface files when Python is enabled or not, and
! subsequent troubles when compiling in this 2 modes with the same
! sources.
!-----------------------------------------------------------------------
subroutine pyclass_rx_val(ival,iunitin,oval,ounitin,error)
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces, except_this=>pyclass_rx_val
  use class_rt
  !---------------------------------------------------------------------
  ! @ private
  !
  ! ---
  ! Entry point which can be called from Python. In particular the
  ! 'observation' is shared through a module.
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)  :: ival     ! Input value
  character(len=*), intent(in)  :: iunitin  ! Input unit
  real(kind=8),     intent(out) :: oval     ! Output value
  character(len=*), intent(in)  :: ounitin  ! Output unit
  logical,          intent(out) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RX_VAL'
  !
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No R spectrum in memory')
    error = .true.
    return
  endif
  !
  call pyclass_obsx_val(r,ival,iunitin,oval,ounitin,error)
  if (error)  return
  !
end subroutine pyclass_rx_val
!
subroutine pyclass_rx_minmax(unitin,mini,maxi,error)
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces, except_this=>pyclass_rx_minmax
  use class_rt
  use class_setup
  !---------------------------------------------------------------------
  ! @ private
  !
  ! ---
  ! Entry point which can be called from Python. In particular the
  ! 'observation' is shared through a module.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: unitin  ! Unit for returning values. Blank means current unit
  real(kind=8),     intent(out) :: mini    !
  real(kind=8),     intent(out) :: maxi    !
  logical,          intent(out) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RX_MINMAX'
  !
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No R spectrum in memory')
    error = .true.
    return
  endif
  !
  call pyclass_obsx_minmax(set,r,unitin,mini,maxi,error)
  if (error)  return
  !
end subroutine pyclass_rx_minmax
!
subroutine pyclass_px_minmax(unitin,mini,maxi,error)
  use class_dependencies_interfaces
  use class_interfaces, except_this=>pyclass_px_minmax
  use class_setup
  !---------------------------------------------------------------------
  ! @ private
  ! Return the X range of the plot
  ! NB: the subroutine returns actually the SET MODE X range, not
  ! the effective PLOT range (they are the same AFTER the command PLOT).
  ! But the command ANA\DRAW has the same bug-feature, and since the
  ! cursor is used by Weeds to identify lines, we are consistent...
  ! ---
  ! Entry point which can be called from Python. In particular the
  ! 'class_setup_t' is shared through a module.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: unitin  ! Unit for returning values. Blank means current unit
  real(kind=8),     intent(out) :: mini    !
  real(kind=8),     intent(out) :: maxi    !
  logical,          intent(out) :: error   ! Logical error flag
  !
  call pyclass_plotx_minmax(set,unitin,mini,maxi,error)
  if (error)  return
  !
end subroutine pyclass_px_minmax

* DECK cbdsqr.f
      SUBROUTINE CBDSQR( UPLO, N, NCVT, NRU, NCC, D, E, VT, LDVT, U,
     $                   LDU, C, LDC, RWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDC, LDU, LDVT, N, NCC, NCVT, NRU
*     ..
*     .. Array Arguments ..
      REAL               D( * ), E( * ), RWORK( * )
      COMPLEX            C( LDC, * ), U( LDU, * ), VT( LDVT, * )
*     ..
*
*  Purpose
*  =======
*
*  CBDSQR computes the singular value decomposition (SVD) of a real
*  N-by-N (upper or lower) bidiagonal matrix B:  B = Q * S * P' (P'
*  denotes the transpose of P), where S is a diagonal matrix with
*  non-negative diagonal elements (the singular values of B), and Q
*  and P are orthogonal matrices.
*
*  The routine computes S, and optionally computes U * Q, P' * VT,
*  or Q' * C, for given complex input matrices U, VT, and C.
*
*  See "Computing  Small Singular Values of Bidiagonal Matrices With
*  Guaranteed High Relative Accuracy," by J. Demmel and W. Kahan,
*  LAPACK Working Note #3 (or SIAM J. Sci. Statist. Comput. vol. 11,
*  no. 5, pp. 873-912, Sept 1990) and
*  "Accurate singular values and differential qd algorithms," by
*  B. Parlett and V. Fernando, Technical Report CPAM-554, Mathematics
*  Department, University of California at Berkeley, July 1992
*  for a detailed description of the algorithm.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  B is upper bidiagonal;
*          = 'L':  B is lower bidiagonal.
*
*  N       (input) INTEGER
*          The order of the matrix B.  N >= 0.
*
*  NCVT    (input) INTEGER
*          The number of columns of the matrix VT. NCVT >= 0.
*
*  NRU     (input) INTEGER
*          The number of rows of the matrix U. NRU >= 0.
*
*  NCC     (input) INTEGER
*          The number of columns of the matrix C. NCC >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the n diagonal elements of the bidiagonal matrix B.
*          On exit, if INFO=0, the singular values of B in decreasing
*          order.
*
*  E       (input/output) REAL array, dimension (N)
*          On entry, the elements of E contain the
*          offdiagonal elements of of the bidiagonal matrix whose SVD
*          is desired. On normal exit (INFO = 0), E is destroyed.
*          If the algorithm does not converge (INFO > 0), D and E
*          will contain the diagonal and superdiagonal elements of a
*          bidiagonal matrix orthogonally equivalent to the one given
*          as input. E(N) is used for workspace.
*
*  VT      (input/output) COMPLEX array, dimension (LDVT, NCVT)
*          On entry, an N-by-NCVT matrix VT.
*          On exit, VT is overwritten by P' * VT.
*          VT is not referenced if NCVT = 0.
*
*  LDVT    (input) INTEGER
*          The leading dimension of the array VT.
*          LDVT >= max(1,N) if NCVT > 0; LDVT >= 1 if NCVT = 0.
*
*  U       (input/output) COMPLEX array, dimension (LDU, N)
*          On entry, an NRU-by-N matrix U.
*          On exit, U is overwritten by U * Q.
*          U is not referenced if NRU = 0.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U.  LDU >= max(1,NRU).
*
*  C       (input/output) COMPLEX array, dimension (LDC, NCC)
*          On entry, an N-by-NCC matrix C.
*          On exit, C is overwritten by Q' * C.
*          C is not referenced if NCC = 0.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C.
*          LDC >= max(1,N) if NCC > 0; LDC >=1 if NCC = 0.
*
*  RWORK   (workspace) REAL array, dimension
*            2*N  if only singular values wanted (NCVT = NRU = NCC = 0)
*            max( 1, 4*N-4 ) otherwise
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  If INFO = -i, the i-th argument had an illegal value
*          > 0:  the algorithm did not converge; D and E contain the
*                elements of a bidiagonal matrix which is orthogonally
*                similar to the input matrix B;  if INFO = i, i
*                elements of E have not converged to zero.
*
*  Internal Parameters
*  ===================
*
*  TOLMUL  REAL, default = max(10,min(100,EPS**(-1/8)))
*          TOLMUL controls the convergence criterion of the QR loop.
*          If it is positive, TOLMUL*EPS is the desired relative
*             precision in the computed singular values.
*          If it is negative, abs(TOLMUL*EPS*sigma_max) is the
*             desired absolute accuracy in the computed singular
*             values (corresponds to relative accuracy
*             abs(TOLMUL*EPS) in the largest singular value.
*          abs(TOLMUL) should be between 1 and 1/EPS, and preferably
*             between 10 (for fast convergence) and .1/EPS
*             (for there to be some accuracy in the results).
*          Default is to lose at either one eighth or 2 of the
*             available decimal digits in each computed singular value
*             (whichever is smaller).
*
*  MAXITR  INTEGER, default = 6
*          MAXITR controls the maximum number of passes of the
*          algorithm through its inner loop. The algorithms stops
*          (and so fails to converge) if the number of passes
*          through the inner loop exceeds MAXITR*N**2.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E0 )
      REAL               ONE
      PARAMETER          ( ONE = 1.0E0 )
      REAL               NEGONE
      PARAMETER          ( NEGONE = -1.0E0 )
      REAL               HNDRTH
      PARAMETER          ( HNDRTH = 0.01E0 )
      REAL               TEN
      PARAMETER          ( TEN = 10.0E0 )
      REAL               HNDRD
      PARAMETER          ( HNDRD = 100.0E0 )
      REAL               MEIGTH
      PARAMETER          ( MEIGTH = -0.125E0 )
      INTEGER            MAXITR
      PARAMETER          ( MAXITR = 6 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ROTATE
      INTEGER            I, IDIR, IROT, ISUB, ITER, IUPLO, J, LL, LLL,
     $                   M, MAXIT, NM1, NM12, NM13, OLDLL, OLDM
      REAL               ABSE, ABSS, COSL, COSR, CS, EPS, F, G, H, MU,
     $                   OLDCS, OLDSN, R, SHIFT, SIGMN, SIGMX, SINL,
     $                   SINR, SLL, SMAX, SMIN, SMINL, SMINLO, SMINOA,
     $                   SN, THRESH, TOL, TOLMUL, UNFL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLASR, CSROT, CSSCAL, CSWAP, SLARTG, SLAS2,
     $                   SLASQ1, SLASV2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, REAL, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IUPLO = 0
      IF( LSAME( UPLO, 'U' ) )
     $   IUPLO = 1
      IF( LSAME( UPLO, 'L' ) )
     $   IUPLO = 2
      IF( IUPLO.EQ.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NCVT.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRU.LT.0 ) THEN
         INFO = -4
      ELSE IF( NCC.LT.0 ) THEN
         INFO = -5
      ELSE IF( ( NCVT.EQ.0 .AND. LDVT.LT.1 ) .OR.
     $         ( NCVT.GT.0 .AND. LDVT.LT.MAX( 1, N ) ) ) THEN
         INFO = -9
      ELSE IF( LDU.LT.MAX( 1, NRU ) ) THEN
         INFO = -11
      ELSE IF( ( NCC.EQ.0 .AND. LDC.LT.1 ) .OR.
     $         ( NCC.GT.0 .AND. LDC.LT.MAX( 1, N ) ) ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CBDSQR', -INFO )
         RETURN
      END IF
      IF( N.EQ.0 )
     $   RETURN
      IF( N.EQ.1 )
     $   GO TO 150
*
*     ROTATE is true if any singular vectors desired, false otherwise
*
      ROTATE = ( NCVT.GT.0 ) .OR. ( NRU.GT.0 ) .OR. ( NCC.GT.0 )
*
*     If no singular vectors desired, use qd algorithm
*
      IF( .NOT.ROTATE ) THEN
         CALL SLASQ1( N, D, E, RWORK, INFO )
         RETURN
      END IF
*
      NM1 = N - 1
      NM12 = NM1 + NM1
      NM13 = NM12 + NM1
*
*     Get machine constants
*
      EPS = SLAMCH( 'Epsilon' )
      UNFL = SLAMCH( 'Safe minimum' )
*
*     If matrix lower bidiagonal, rotate to be upper bidiagonal
*     by applying Givens rotations on the left
*
      IF( IUPLO.EQ.2 ) THEN
         DO 10 I = 1, N - 1
            CALL SLARTG( D( I ), E( I ), CS, SN, R )
            D( I ) = R
            E( I ) = SN*D( I+1 )
            D( I+1 ) = CS*D( I+1 )
            RWORK( I ) = CS
            RWORK( NM1+I ) = SN
   10    CONTINUE
*
*        Update singular vectors if desired
*
         IF( NRU.GT.0 )
     $      CALL CLASR( 'R', 'V', 'F', NRU, N, RWORK( 1 ), RWORK( N ),
     $                  U, LDU )
         IF( NCC.GT.0 )
     $      CALL CLASR( 'L', 'V', 'F', N, NCC, RWORK( 1 ), RWORK( N ),
     $                  C, LDC )
      END IF
*
*     Compute singular values to relative accuracy TOL
*     (By setting TOL to be negative, algorithm will compute
*     singular values to absolute accuracy ABS(TOL)*norm(input matrix))
*
      TOLMUL = MAX( TEN, MIN( HNDRD, EPS**MEIGTH ) )
      TOL = TOLMUL*EPS
*
*     Compute approximate maximum, minimum singular values
*
      SMAX = ABS( D( N ) )
      DO 20 I = 1, N - 1
         SMAX = MAX( SMAX, ABS( D( I ) ), ABS( E( I ) ) )
   20 CONTINUE
      SMINL = ZERO
      IF( TOL.GE.ZERO ) THEN
*
*        Relative accuracy desired
*
         SMINOA = ABS( D( 1 ) )
         IF( SMINOA.EQ.ZERO )
     $      GO TO 40
         MU = SMINOA
         DO 30 I = 2, N
            MU = ABS( D( I ) )*( MU / ( MU+ABS( E( I-1 ) ) ) )
            SMINOA = MIN( SMINOA, MU )
            IF( SMINOA.EQ.ZERO )
     $         GO TO 40
   30    CONTINUE
   40    CONTINUE
         SMINOA = SMINOA / SQRT( REAL( N ) )
         THRESH = MAX( TOL*SMINOA, MAXITR*N*N*UNFL )
      ELSE
*
*        Absolute accuracy desired
*
         THRESH = MAX( ABS( TOL )*SMAX, MAXITR*N*N*UNFL )
      END IF
*
*     Prepare for main iteration loop for the singular values
*     (MAXIT is the maximum number of passes through the inner
*     loop permitted before nonconvergence signalled.)
*
      MAXIT = MAXITR*N*N
      ITER = 0
      OLDLL = -1
      OLDM = -1
*
*     M points to last element of unconverged part of matrix
*
      M = N
*
*     Begin main iteration loop
*
   50 CONTINUE
*
*     Check for convergence or exceeding iteration count
*
      IF( M.LE.1 )
     $   GO TO 150
      IF( ITER.GT.MAXIT )
     $   GO TO 190
*
*     Find diagonal block of matrix to work on
*
      IF( TOL.LT.ZERO .AND. ABS( D( M ) ).LE.THRESH )
     $   D( M ) = ZERO
      SMAX = ABS( D( M ) )
      SMIN = SMAX
      DO 60 LLL = 1, M
         LL = M - LLL
         IF( LL.EQ.0 )
     $      GO TO 80
         ABSS = ABS( D( LL ) )
         ABSE = ABS( E( LL ) )
         IF( TOL.LT.ZERO .AND. ABSS.LE.THRESH )
     $      D( LL ) = ZERO
         IF( ABSE.LE.THRESH )
     $      GO TO 70
         SMIN = MIN( SMIN, ABSS )
         SMAX = MAX( SMAX, ABSS, ABSE )
   60 CONTINUE
   70 CONTINUE
      E( LL ) = ZERO
*
*     Matrix splits since E(LL) = 0
*
      IF( LL.EQ.M-1 ) THEN
*
*        Convergence of bottom singular value, return to top of loop
*
         M = M - 1
         GO TO 50
      END IF
   80 CONTINUE
      LL = LL + 1
*
*     E(LL) through E(M-1) are nonzero, E(LL-1) is zero
*
      IF( LL.EQ.M-1 ) THEN
*
*        2 by 2 block, handle separately
*
         CALL SLASV2( D( M-1 ), E( M-1 ), D( M ), SIGMN, SIGMX, SINR,
     $                COSR, SINL, COSL )
         D( M-1 ) = SIGMX
         E( M-1 ) = ZERO
         D( M ) = SIGMN
*
*        Compute singular vectors, if desired
*
         IF( NCVT.GT.0 )
     $      CALL CSROT( NCVT, VT( M-1, 1 ), LDVT, VT( M, 1 ), LDVT,
     $                  COSR, SINR )
         IF( NRU.GT.0 )
     $      CALL CSROT( NRU, U( 1, M-1 ), 1, U( 1, M ), 1, COSL, SINL )
         IF( NCC.GT.0 )
     $      CALL CSROT( NCC, C( M-1, 1 ), LDC, C( M, 1 ), LDC, COSL,
     $                  SINL )
         M = M - 2
         GO TO 50
      END IF
*
*     If working on new submatrix, choose shift direction
*     (from larger end diagonal element towards smaller)
*
      IF( LL.GT.OLDM .OR. M.LT.OLDLL ) THEN
         IF( ABS( D( LL ) ).GE.ABS( D( M ) ) ) THEN
*
*           Chase bulge from top (big end) to bottom (small end)
*
            IDIR = 1
         ELSE
*
*           Chase bulge from bottom (big end) to top (small end)
*
            IDIR = 2
         END IF
      END IF
*
*     Apply convergence tests
*
      IF( IDIR.EQ.1 ) THEN
*
*        Run convergence test in forward direction
*        First apply standard test to bottom of matrix
*
         IF( ABS( E( M-1 ) ).LE.ABS( TOL )*ABS( D( M ) ) .OR.
     $       ( TOL.LT.ZERO .AND. ABS( E( M-1 ) ).LE.THRESH ) ) THEN
            E( M-1 ) = ZERO
            GO TO 50
         END IF
*
         IF( TOL.GE.ZERO ) THEN
*
*           If relative accuracy desired,
*           apply convergence criterion forward
*
            MU = ABS( D( LL ) )
            SMINL = MU
            DO 90 LLL = LL, M - 1
               IF( ABS( E( LLL ) ).LE.TOL*MU ) THEN
                  E( LLL ) = ZERO
                  GO TO 50
               END IF
               SMINLO = SMINL
               MU = ABS( D( LLL+1 ) )*( MU / ( MU+ABS( E( LLL ) ) ) )
               SMINL = MIN( SMINL, MU )
   90       CONTINUE
         END IF
*
      ELSE
*
*        Run convergence test in backward direction
*        First apply standard test to top of matrix
*
         IF( ABS( E( LL ) ).LE.ABS( TOL )*ABS( D( LL ) ) .OR.
     $       ( TOL.LT.ZERO .AND. ABS( E( LL ) ).LE.THRESH ) ) THEN
            E( LL ) = ZERO
            GO TO 50
         END IF
*
         IF( TOL.GE.ZERO ) THEN
*
*           If relative accuracy desired,
*           apply convergence criterion backward
*
            MU = ABS( D( M ) )
            SMINL = MU
            DO 100 LLL = M - 1, LL, -1
               IF( ABS( E( LLL ) ).LE.TOL*MU ) THEN
                  E( LLL ) = ZERO
                  GO TO 50
               END IF
               SMINLO = SMINL
               MU = ABS( D( LLL ) )*( MU / ( MU+ABS( E( LLL ) ) ) )
               SMINL = MIN( SMINL, MU )
  100       CONTINUE
         END IF
      END IF
      OLDLL = LL
      OLDM = M
*
*     Compute shift.  First, test if shifting would ruin relative
*     accuracy, and if so set the shift to zero.
*
      IF( TOL.GE.ZERO .AND. N*TOL*( SMINL / SMAX ).LE.
     $    MAX( EPS, HNDRTH*TOL ) ) THEN
*
*        Use a zero shift to avoid loss of relative accuracy
*
         SHIFT = ZERO
      ELSE
*
*        Compute the shift from 2-by-2 block at end of matrix
*
         IF( IDIR.EQ.1 ) THEN
            SLL = ABS( D( LL ) )
            CALL SLAS2( D( M-1 ), E( M-1 ), D( M ), SHIFT, R )
         ELSE
            SLL = ABS( D( M ) )
            CALL SLAS2( D( LL ), E( LL ), D( LL+1 ), SHIFT, R )
         END IF
*
*        Test if shift negligible, and if so set to zero
*
         IF( SLL.GT.ZERO ) THEN
            IF( ( SHIFT / SLL )**2.LT.EPS )
     $         SHIFT = ZERO
         END IF
      END IF
*
*     Increment iteration count
*
      ITER = ITER + M - LL
*
*     If SHIFT = 0, do simplified QR iteration
*
      IF( SHIFT.EQ.ZERO ) THEN
         IF( IDIR.EQ.1 ) THEN
*
*           Chase bulge from top to bottom
*           Save cosines and sines for later singular vector updates
*
            CS = ONE
            OLDCS = ONE
            CALL SLARTG( D( LL )*CS, E( LL ), CS, SN, R )
            CALL SLARTG( OLDCS*R, D( LL+1 )*SN, OLDCS, OLDSN, D( LL ) )
            RWORK( 1 ) = CS
            RWORK( 1+NM1 ) = SN
            RWORK( 1+NM12 ) = OLDCS
            RWORK( 1+NM13 ) = OLDSN
            IROT = 1
            DO 110 I = LL + 1, M - 1
               CALL SLARTG( D( I )*CS, E( I ), CS, SN, R )
               E( I-1 ) = OLDSN*R
               CALL SLARTG( OLDCS*R, D( I+1 )*SN, OLDCS, OLDSN, D( I ) )
               IROT = IROT + 1
               RWORK( IROT ) = CS
               RWORK( IROT+NM1 ) = SN
               RWORK( IROT+NM12 ) = OLDCS
               RWORK( IROT+NM13 ) = OLDSN
  110       CONTINUE
            H = D( M )*CS
            D( M ) = H*OLDCS
            E( M-1 ) = H*OLDSN
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL CLASR( 'L', 'V', 'F', M-LL+1, NCVT, RWORK( 1 ),
     $                     RWORK( N ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL CLASR( 'R', 'V', 'F', NRU, M-LL+1, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL CLASR( 'L', 'V', 'F', M-LL+1, NCC, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( M-1 ) ).LE.THRESH )
     $         E( M-1 ) = ZERO
*
         ELSE
*
*           Chase bulge from bottom to top
*           Save cosines and sines for later singular vector updates
*
            CS = ONE
            OLDCS = ONE
            CALL SLARTG( D( M )*CS, E( M-1 ), CS, SN, R )
            CALL SLARTG( OLDCS*R, D( M-1 )*SN, OLDCS, OLDSN, D( M ) )
            RWORK( M-LL ) = CS
            RWORK( M-LL+NM1 ) = -SN
            RWORK( M-LL+NM12 ) = OLDCS
            RWORK( M-LL+NM13 ) = -OLDSN
            IROT = M - LL
            DO 120 I = M - 1, LL + 1, -1
               CALL SLARTG( D( I )*CS, E( I-1 ), CS, SN, R )
               E( I ) = OLDSN*R
               CALL SLARTG( OLDCS*R, D( I-1 )*SN, OLDCS, OLDSN, D( I ) )
               IROT = IROT - 1
               RWORK( IROT ) = CS
               RWORK( IROT+NM1 ) = -SN
               RWORK( IROT+NM12 ) = OLDCS
               RWORK( IROT+NM13 ) = -OLDSN
  120       CONTINUE
            H = D( LL )*CS
            D( LL ) = H*OLDCS
            E( LL ) = H*OLDSN
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL CLASR( 'L', 'V', 'B', M-LL+1, NCVT, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL CLASR( 'R', 'V', 'B', NRU, M-LL+1, RWORK( 1 ),
     $                     RWORK( N ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL CLASR( 'L', 'V', 'B', M-LL+1, NCC, RWORK( 1 ),
     $                     RWORK( N ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( LL ) ).LE.THRESH )
     $         E( LL ) = ZERO
         END IF
      ELSE
*
*        Use nonzero shift
*
         IF( IDIR.EQ.1 ) THEN
*
*           Chase bulge from top to bottom
*           Save cosines and sines for later singular vector updates
*
            F = ( ABS( D( LL ) )-SHIFT )*
     $          ( SIGN( ONE, D( LL ) )+SHIFT / D( LL ) )
            G = E( LL )
            CALL SLARTG( F, G, COSR, SINR, R )
            F = COSR*D( LL ) + SINR*E( LL )
            E( LL ) = COSR*E( LL ) - SINR*D( LL )
            G = SINR*D( LL+1 )
            D( LL+1 ) = COSR*D( LL+1 )
            CALL SLARTG( F, G, COSL, SINL, R )
            D( LL ) = R
            F = COSL*E( LL ) + SINL*D( LL+1 )
            D( LL+1 ) = COSL*D( LL+1 ) - SINL*E( LL )
            G = SINL*E( LL+1 )
            E( LL+1 ) = COSL*E( LL+1 )
            RWORK( 1 ) = COSR
            RWORK( 1+NM1 ) = SINR
            RWORK( 1+NM12 ) = COSL
            RWORK( 1+NM13 ) = SINL
            IROT = 1
            DO 130 I = LL + 1, M - 2
               CALL SLARTG( F, G, COSR, SINR, R )
               E( I-1 ) = R
               F = COSR*D( I ) + SINR*E( I )
               E( I ) = COSR*E( I ) - SINR*D( I )
               G = SINR*D( I+1 )
               D( I+1 ) = COSR*D( I+1 )
               CALL SLARTG( F, G, COSL, SINL, R )
               D( I ) = R
               F = COSL*E( I ) + SINL*D( I+1 )
               D( I+1 ) = COSL*D( I+1 ) - SINL*E( I )
               G = SINL*E( I+1 )
               E( I+1 ) = COSL*E( I+1 )
               IROT = IROT + 1
               RWORK( IROT ) = COSR
               RWORK( IROT+NM1 ) = SINR
               RWORK( IROT+NM12 ) = COSL
               RWORK( IROT+NM13 ) = SINL
  130       CONTINUE
            CALL SLARTG( F, G, COSR, SINR, R )
            E( M-2 ) = R
            F = COSR*D( M-1 ) + SINR*E( M-1 )
            E( M-1 ) = COSR*E( M-1 ) - SINR*D( M-1 )
            G = SINR*D( M )
            D( M ) = COSR*D( M )
            CALL SLARTG( F, G, COSL, SINL, R )
            D( M-1 ) = R
            F = COSL*E( M-1 ) + SINL*D( M )
            D( M ) = COSL*D( M ) - SINL*E( M-1 )
            IROT = IROT + 1
            RWORK( IROT ) = COSR
            RWORK( IROT+NM1 ) = SINR
            RWORK( IROT+NM12 ) = COSL
            RWORK( IROT+NM13 ) = SINL
            E( M-1 ) = F
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL CLASR( 'L', 'V', 'F', M-LL+1, NCVT, RWORK( 1 ),
     $                     RWORK( N ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL CLASR( 'R', 'V', 'F', NRU, M-LL+1, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL CLASR( 'L', 'V', 'F', M-LL+1, NCC, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( M-1 ) ).LE.THRESH )
     $         E( M-1 ) = ZERO
*
         ELSE
*
*           Chase bulge from bottom to top
*           Save cosines and sines for later singular vector updates
*
            F = ( ABS( D( M ) )-SHIFT )*( SIGN( ONE, D( M ) )+SHIFT /
     $          D( M ) )
            G = E( M-1 )
            CALL SLARTG( F, G, COSR, SINR, R )
            F = COSR*D( M ) + SINR*E( M-1 )
            E( M-1 ) = COSR*E( M-1 ) - SINR*D( M )
            G = SINR*D( M-1 )
            D( M-1 ) = COSR*D( M-1 )
            CALL SLARTG( F, G, COSL, SINL, R )
            D( M ) = R
            F = COSL*E( M-1 ) + SINL*D( M-1 )
            D( M-1 ) = COSL*D( M-1 ) - SINL*E( M-1 )
            G = SINL*E( M-2 )
            E( M-2 ) = COSL*E( M-2 )
            RWORK( M-LL ) = COSR
            RWORK( M-LL+NM1 ) = -SINR
            RWORK( M-LL+NM12 ) = COSL
            RWORK( M-LL+NM13 ) = -SINL
            IROT = M - LL
            DO 140 I = M - 1, LL + 2, -1
               CALL SLARTG( F, G, COSR, SINR, R )
               E( I ) = R
               F = COSR*D( I ) + SINR*E( I-1 )
               E( I-1 ) = COSR*E( I-1 ) - SINR*D( I )
               G = SINR*D( I-1 )
               D( I-1 ) = COSR*D( I-1 )
               CALL SLARTG( F, G, COSL, SINL, R )
               D( I ) = R
               F = COSL*E( I-1 ) + SINL*D( I-1 )
               D( I-1 ) = COSL*D( I-1 ) - SINL*E( I-1 )
               G = SINL*E( I-2 )
               E( I-2 ) = COSL*E( I-2 )
               IROT = IROT - 1
               RWORK( IROT ) = COSR
               RWORK( IROT+NM1 ) = -SINR
               RWORK( IROT+NM12 ) = COSL
               RWORK( IROT+NM13 ) = -SINL
  140       CONTINUE
            CALL SLARTG( F, G, COSR, SINR, R )
            E( LL+1 ) = R
            F = COSR*D( LL+1 ) + SINR*E( LL )
            E( LL ) = COSR*E( LL ) - SINR*D( LL+1 )
            G = SINR*D( LL )
            D( LL ) = COSR*D( LL )
            CALL SLARTG( F, G, COSL, SINL, R )
            D( LL+1 ) = R
            F = COSL*E( LL ) + SINL*D( LL )
            D( LL ) = COSL*D( LL ) - SINL*E( LL )
            IROT = IROT - 1
            RWORK( IROT ) = COSR
            RWORK( IROT+NM1 ) = -SINR
            RWORK( IROT+NM12 ) = COSL
            RWORK( IROT+NM13 ) = -SINL
            E( LL ) = F
*
*           Test convergence
*
            IF( ABS( E( LL ) ).LE.THRESH )
     $         E( LL ) = ZERO
*
*           Update singular vectors if desired
*
            IF( NCVT.GT.0 )
     $         CALL CLASR( 'L', 'V', 'B', M-LL+1, NCVT, RWORK( NM12+1 ),
     $                     RWORK( NM13+1 ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL CLASR( 'R', 'V', 'B', NRU, M-LL+1, RWORK( 1 ),
     $                     RWORK( N ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL CLASR( 'L', 'V', 'B', M-LL+1, NCC, RWORK( 1 ),
     $                     RWORK( N ), C( LL, 1 ), LDC )
         END IF
      END IF
*
*     QR iteration finished, go back and check convergence
*
      GO TO 50
*
*     All singular values converged, so make them positive
*
  150 CONTINUE
      DO 160 I = 1, N
         IF( D( I ).LT.ZERO ) THEN
            D( I ) = -D( I )
*
*           Change sign of singular vectors, if desired
*
            IF( NCVT.GT.0 )
     $         CALL CSSCAL( NCVT, NEGONE, VT( I, 1 ), LDVT )
         END IF
  160 CONTINUE
*
*     Sort the singular values into decreasing order (insertion sort on
*     singular values, but only one transposition per singular vector)
*
      DO 180 I = 1, N - 1
*
*        Scan for smallest D(I)
*
         ISUB = 1
         SMIN = D( 1 )
         DO 170 J = 2, N + 1 - I
            IF( D( J ).LE.SMIN ) THEN
               ISUB = J
               SMIN = D( J )
            END IF
  170    CONTINUE
         IF( ISUB.NE.N+1-I ) THEN
*
*           Swap singular values and vectors
*
            D( ISUB ) = D( N+1-I )
            D( N+1-I ) = SMIN
            IF( NCVT.GT.0 )
     $         CALL CSWAP( NCVT, VT( ISUB, 1 ), LDVT, VT( N+1-I, 1 ),
     $                     LDVT )
            IF( NRU.GT.0 )
     $         CALL CSWAP( NRU, U( 1, ISUB ), 1, U( 1, N+1-I ), 1 )
            IF( NCC.GT.0 )
     $         CALL CSWAP( NCC, C( ISUB, 1 ), LDC, C( N+1-I, 1 ), LDC )
         END IF
  180 CONTINUE
      GO TO 210
*
*     Maximum number of iterations exceeded, failure to converge
*
  190 CONTINUE
      INFO = 0
      DO 200 I = 1, N - 1
         IF( E( I ).NE.ZERO )
     $      INFO = INFO + 1
  200 CONTINUE
  210 CONTINUE
      RETURN
*
*     End of CBDSQR
*
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_userstruct
  use gkernel_interfaces
  use gbl_format
  use cubesyntax_messaging
  use cubetools_parameters
  use cubetools_uservar
  use cubetools_userspace
  !
  public :: userstruct_t
  public :: cubetools_userstruct_ptr
  private
  !
  type, extends(userspace_t) :: userstruct_t
   contains
     procedure, public :: has_member    => cubetools_sicdef_has_member
     procedure         :: create        => cubetools_sicdef_struct_create
     procedure         :: def           => cubetools_sicdef_struct
     procedure         :: def_substruct => cubetools_sicdef_substruct
     procedure         :: get_substruct => cubetools_sicget_substruct
     procedure         :: create_member => cubetools_sicdef_create_member
     ! procedure       :: has_changed   => method to check if structure has been changed
     !
     generic   :: set_member    => def_r4_0d,def_r4_1d,def_r4_2d,def_r4_3d,&
                                   def_r8_0d,def_r8_1d,def_r8_2d,def_r8_3d,&
                                   def_c4_0d,def_c4_1d,def_c4_2d,def_c4_3d,&
                                   def_i4_0d,def_i4_1d,def_i4_2d,def_i4_3d,&
                                   def_i8_0d,def_i8_1d,def_i8_2d,def_i8_3d,&
                                   def_st_0d,def_st_1d,&
                                   def_lg_0d
     !
     generic   :: get_member    => get_r4_0d,get_r4_1d,get_r4_2d,get_r4_3d,&
                                   get_r8_0d,get_r8_1d,get_r8_2d,get_r8_3d,&
                                   get_c4_0d,get_c4_1d,get_c4_2d,get_c4_3d,&
                                   get_i4_0d,get_i4_1d,get_i4_2d,get_i4_3d,&
                                   get_i8_0d,get_i8_1d,get_i8_2d,get_i8_3d,&
                                   get_st_0d,&
                                   get_lg_0d
     !
     procedure :: def_r4_0d => cubetools_sicdef_member_r4_0d
     procedure :: def_r4_1d => cubetools_sicdef_member_r4_1d
     procedure :: def_r4_2d => cubetools_sicdef_member_r4_2d
     procedure :: def_r4_3d => cubetools_sicdef_member_r4_3d
     ! 
     procedure :: def_r8_0d => cubetools_sicdef_member_r8_0d
     procedure :: def_r8_1d => cubetools_sicdef_member_r8_1d
     procedure :: def_r8_2d => cubetools_sicdef_member_r8_2d
     procedure :: def_r8_3d => cubetools_sicdef_member_r8_3d
     !
     procedure :: def_c4_0d => cubetools_sicdef_member_c4_0d
     procedure :: def_c4_1d => cubetools_sicdef_member_c4_1d
     procedure :: def_c4_2d => cubetools_sicdef_member_c4_2d
     procedure :: def_c4_3d => cubetools_sicdef_member_c4_3d
     !
     procedure :: def_i4_0d => cubetools_sicdef_member_i4_0d
     procedure :: def_i4_1d => cubetools_sicdef_member_i4_1d
     procedure :: def_i4_2d => cubetools_sicdef_member_i4_2d
     procedure :: def_i4_3d => cubetools_sicdef_member_i4_3d
     !
     procedure :: def_i8_0d => cubetools_sicdef_member_i8_0d
     procedure :: def_i8_1d => cubetools_sicdef_member_i8_1d
     procedure :: def_i8_2d => cubetools_sicdef_member_i8_2d
     procedure :: def_i8_3d => cubetools_sicdef_member_i8_3d
     !
     procedure :: def_st_0d => cubetools_sicdef_member_st_0d
     procedure :: def_st_1d => cubetools_sicdef_member_st_1d
     !
     procedure :: def_lg_0d => cubetools_sicdef_member_lg_0d
     !
     !----------------------------------------------------------------------
     !
     procedure :: get_r4_0d => cubetools_sicget_member_r4_0d
     procedure :: get_r4_1d => cubetools_sicget_member_r4_1d
     procedure :: get_r4_2d => cubetools_sicget_member_r4_2d
     procedure :: get_r4_3d => cubetools_sicget_member_r4_3d
     ! 
     procedure :: get_r8_0d => cubetools_sicget_member_r8_0d
     procedure :: get_r8_1d => cubetools_sicget_member_r8_1d
     procedure :: get_r8_2d => cubetools_sicget_member_r8_2d
     procedure :: get_r8_3d => cubetools_sicget_member_r8_3d
     !
     procedure :: get_c4_0d => cubetools_sicget_member_c4_0d
     procedure :: get_c4_1d => cubetools_sicget_member_c4_1d
     procedure :: get_c4_2d => cubetools_sicget_member_c4_2d
     procedure :: get_c4_3d => cubetools_sicget_member_c4_3d
     !
     procedure :: get_i4_0d => cubetools_sicget_member_i4_0d
     procedure :: get_i4_1d => cubetools_sicget_member_i4_1d
     procedure :: get_i4_2d => cubetools_sicget_member_i4_2d
     procedure :: get_i4_3d => cubetools_sicget_member_i4_3d
     !
     procedure :: get_i8_0d => cubetools_sicget_member_i8_0d
     procedure :: get_i8_1d => cubetools_sicget_member_i8_1d
     procedure :: get_i8_2d => cubetools_sicget_member_i8_2d
     procedure :: get_i8_3d => cubetools_sicget_member_i8_3d
     !
     procedure :: get_st_0d => cubetools_sicget_member_st_0d
     !
     procedure :: get_lg_0d => cubetools_sicget_member_lg_0d
  end type userstruct_t
  !
  ! Useful
  character(len=*), parameter :: link = '%'
  !
contains
  !
  function cubetools_userstruct_ptr(userspace,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(userstruct_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    type(userstruct_t), pointer :: cubetools_userstruct_ptr  ! Function value on return
    class(userspace_t), target        :: userspace
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='USERSTRUCT>PTR'
    !
    select type(userspace)
    type is (userstruct_t)
      cubetools_userstruct_ptr => userspace
    class default
      cubetools_userstruct_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: user space is not a userstruct_t type')
      error = .true.
      return
    end select
  end function cubetools_userstruct_ptr
  !
  function cubetools_sicdef_has_member(userstruct,name)
    !------------------------------------------------------------------------
    ! Tests if a member with that name exists in the structure
    !------------------------------------------------------------------------
    logical :: cubetools_sicdef_has_member
    class(userstruct_t), intent(in) :: userstruct
    character(len=*),    intent(in) :: name
    !
    character(len=*), parameter :: rname='SICDEF>HAS>MEMBER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! Note: we could improve this test by checking if the member descriptor
    ! matches a known one.
    cubetools_sicdef_has_member = cubetools_userspace_query(trim(userstruct%name)//link//name)
  end function cubetools_sicdef_has_member
  !
  subroutine cubetools_sicdef_struct_create(userstruct,name,scope,overwrite,error)
    !------------------------------------------------------------------------
    ! Define a sic from name, scope and overwrite status
    !------------------------------------------------------------------------
    class(userstruct_t),  intent(out)   :: userstruct
    character(len=*),     intent(in)    :: name
    logical,              intent(in)    :: scope
    integer(kind=code_k), intent(in)    :: overwrite
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>STRUCT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    userstruct%name = name
    userstruct%scope = scope
    userstruct%overwrite = overwrite
    call userstruct%def(error)
    if (error) return
  end subroutine cubetools_sicdef_struct_create
  !
  subroutine cubetools_sicdef_struct(userstruct,error)
    !------------------------------------------------------------------------
    ! Define a sic structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(inout) :: userstruct
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>STRUCT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%delete(error)
    if (error) return
    call sic_crestructure(userstruct%name,userstruct%scope,error)
    if (error) return
    call userstruct%fetch_desc(error)
    if (error) return
  end subroutine cubetools_sicdef_struct
  !
  subroutine cubetools_sicdef_substruct(userstruct,name,substruct,error)
    !------------------------------------------------------------------------
    ! Define a substructure to the current structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    type(userstruct_t),  intent(out)   :: substruct
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>STRUCT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    substruct = userstruct
    substruct%overwrite = overwrite_user
    substruct%name = trim(userstruct%name)//link//name
    !
    call substruct%def(error)
    if (error) return
  end subroutine cubetools_sicdef_substruct
  !
  subroutine cubetools_sicdef_create_member(userstruct,name,uservar,error)
    !------------------------------------------------------------------------
    ! Properly initializes a uservar_t to be a member of a struct
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    type(uservar_t),     intent(out)   :: uservar
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>CREATE>MEMBER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    uservar%name      = trim(userstruct%name)//link//name
    uservar%scope     = userstruct%scope
    uservar%overwrite = userstruct%overwrite
  end subroutine cubetools_sicdef_create_member
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_member_r4_0d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a r4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=4),        intent(in)    :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>R4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_r4_0d
  !
  subroutine cubetools_sicdef_member_r4_1d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a r4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=4),        intent(in)    :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>R4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_r4_1d
  !
  subroutine cubetools_sicdef_member_r4_2d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a r4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=4),        intent(in)    :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>R4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_r4_2d
  !
  subroutine cubetools_sicdef_member_r4_3d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a r4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=4),        intent(in)    :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>R4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_r4_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_member_r8_0d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a r8 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=8),        intent(in)    :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>R8>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_r8_0d
  !
  subroutine cubetools_sicdef_member_r8_1d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a r8 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=8),        intent(in)    :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>R8>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_r8_1d
  !
  subroutine cubetools_sicdef_member_r8_2d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a r8 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=8),        intent(in)    :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>R8>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_r8_2d
  !
  subroutine cubetools_sicdef_member_r8_3d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a r8 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=8),        intent(in)    :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>R8>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_r8_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_member_c4_0d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a c4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    complex(kind=4),     intent(in)    :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>C4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_c4_0d
  !
  subroutine cubetools_sicdef_member_c4_1d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a c4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    complex(kind=4),     intent(in)    :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>C4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_c4_1d
  !
  subroutine cubetools_sicdef_member_c4_2d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a c4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    complex(kind=4),     intent(in)    :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>C4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_c4_2d
  !
  subroutine cubetools_sicdef_member_c4_3d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a c4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    complex(kind=4),     intent(in)    :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>C4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_c4_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_member_i4_0d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a i4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=4),     intent(in)    :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>I4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_i4_0d
  !
  subroutine cubetools_sicdef_member_i4_1d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a i4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=4),     intent(in)    :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>I4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_i4_1d
  !
  subroutine cubetools_sicdef_member_i4_2d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a i4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=4),     intent(in)    :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>I4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_i4_2d
  !
  subroutine cubetools_sicdef_member_i4_3d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a i4 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=4),     intent(in)    :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>I4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_i4_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_member_i8_0d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a i8 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=8),     intent(in)    :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>I8>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_i8_0d
  !
  subroutine cubetools_sicdef_member_i8_1d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a i8 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=8),     intent(in)    :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>I8>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_i8_1d
  !
  subroutine cubetools_sicdef_member_i8_2d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a i8 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=8),     intent(in)    :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>I8>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_i8_2d
  !
  subroutine cubetools_sicdef_member_i8_3d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a i8 sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=8),     intent(in)    :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>I8>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_i8_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_member_st_0d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a string sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    character(len=*),    intent(in)    :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>ST>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_st_0d
  !
  subroutine cubetools_sicdef_member_st_1d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a string sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    character(len=*),    intent(in)    :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>ST>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_st_1d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_member_lg_0d(userstruct,name,data,error)
    !------------------------------------------------------------------------
    ! Define a logical sic variable as a member of a userstruct and fills
    ! it with data
    ! ------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    logical,             intent(in)    :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICDEF>MEMBER>LG>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call userstruct%create_member(name,member,error)
    if (error) return
    call member%set(data,error)
    if (error) return
  end subroutine cubetools_sicdef_member_lg_0d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_substruct(userstruct,name,substruct,error)
    !----------------------------------------------------------------------
    ! Gets a substruct of name
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    type(userstruct_t),  intent(out)   :: substruct
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>MEMBER>R4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),substruct,error)
    if (error) return
  end subroutine cubetools_sicget_substruct
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_member_r4_0d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an R4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=4),        intent(out)   :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>R4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_r4_0d
  !
  subroutine cubetools_sicget_member_r4_1d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an R4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=4),        intent(out)   :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>R4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_r4_1d
  !
  subroutine cubetools_sicget_member_r4_2d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an R4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=4),        intent(out)   :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>R4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_r4_2d
  !
  subroutine cubetools_sicget_member_r4_3d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an R4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=4),        intent(out)   :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>R4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_r4_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_member_r8_0d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an R8 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=8),        intent(out)   :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>R8>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_r8_0d
  !
  subroutine cubetools_sicget_member_r8_1d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an R8 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=8),        intent(out)   :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>R8>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_r8_1d
  !
  subroutine cubetools_sicget_member_r8_2d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an R8 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=8),        intent(out)   :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>R8>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_r8_2d
  !
  subroutine cubetools_sicget_member_r8_3d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an R8 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    real(kind=8),        intent(out)   :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>R8>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_r8_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_member_c4_0d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an C4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    complex(kind=4),     intent(out)   :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>C4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_c4_0d
  !
  subroutine cubetools_sicget_member_c4_1d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an C4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    complex(kind=4),     intent(out)   :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>C4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_c4_1d
  !
  subroutine cubetools_sicget_member_c4_2d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an C4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    complex(kind=4),     intent(out)   :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>C4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_c4_2d
  !
  subroutine cubetools_sicget_member_c4_3d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an C4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    complex(kind=4),     intent(out)   :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>C4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_c4_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_member_i4_0d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an I4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=4),     intent(out)   :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>I4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_i4_0d
  !
  subroutine cubetools_sicget_member_i4_1d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an I4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=4),     intent(out)   :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>I4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_i4_1d
  !
  subroutine cubetools_sicget_member_i4_2d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an I4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=4),     intent(out)   :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>I4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_i4_2d
  !
  subroutine cubetools_sicget_member_i4_3d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an I4 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=4),     intent(out)   :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>I4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_i4_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_member_i8_0d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an I8 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=8),     intent(out)   :: data
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>I8>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_i8_0d
  !
  subroutine cubetools_sicget_member_i8_1d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an I8 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=8),     intent(out)   :: data(:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>I8>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_i8_1d
  !
  subroutine cubetools_sicget_member_i8_2d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an I8 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=8),     intent(out)   :: data(:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>I8>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_i8_2d
  !
  subroutine cubetools_sicget_member_i8_3d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an I8 member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t), intent(in)    :: userstruct
    character(len=*),    intent(in)    :: name
    integer(kind=8),     intent(out)   :: data(:,:,:)
    logical,             intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>I8>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_i8_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_member_st_0d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an string member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t),   intent(in)    :: userstruct
    character(len=*),      intent(in)    :: name
    character(len=argu_l), intent(out)   :: data
    logical,               intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>ST>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_st_0d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_member_lg_0d(userstruct,name,data,error)
    !----------------------------------------------------------------------
    ! Gets the value of an string member of the structure
    !------------------------------------------------------------------------
    class(userstruct_t),   intent(in)    :: userstruct
    character(len=*),      intent(in)    :: name
    logical,               intent(out)   :: data
    logical,               intent(inout) :: error
    !
    type(uservar_t) :: member
    character(len=*), parameter :: rname='SICGET>MEMBER>LG>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(trim(userstruct%name)//'%'//trim(name),member,error)
    if (error) return
    call member%get(data,error)
    if (error) return
  end subroutine cubetools_sicget_member_lg_0d
end module cubetools_userstruct
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine merge(set,all,error,user_function)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>merge
  use class_index
  use class_types
  !----------------------------------------------------------------------
  ! @ public
  ! Support routine for command MERGE.
  ! Gather observations in the index into a single observations
  !
  ! * No consistency check is done
  ! * The resulting R buffer is labeled as "irregularly sampled"
  ! * time is sum(time)
  ! * Tsys is <Tsys> weighted by time
  ! * tau  is <tau>  weighted by time
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: all
  logical,             intent(inout) :: error
  logical,             external      :: user_function
  ! Local
  character(len=*), parameter :: proc='MERGE'
  type (observation) :: obs
  integer(kind=4) :: ier,npoin_final
  integer(kind=entry_length) :: iobs,i1,i2
  real(xdata_kind), allocatable :: wx(:)
  real(kind=4), allocatable :: wy(:),w4(:)
  integer(kind=4), allocatable :: wint(:)
  real(kind=4) :: total_time,newtsys,newtau
  !
  ! Verify if any input file
  if (.not.filein_opened(proc,error))  return
  if (cx%next.le.1) then
     call class_message(seve%e,proc,'Index is empty')
     error = .true.
     return
  endif
  !
  !
  knext= 1
  call init_obs(obs)
  !
  ! Read the first observation into OBS
  call get_first(set,obs,user_function,error)
  if (error) return
  !
  !
  if (obs%head%gen%kind.ne.kind_cont) then
     call class_message(seve%e,proc,'Only for continuum drifts')
     error = .true.
     return
  endif
  !
  ! if only one spectrum, make a copy
  if (cx%next.eq.2) then
     call class_message(seve%w,proc,'Only one spectrum in index!')
     call copy_obs(obs,all,error)
     if (error) then
        call class_message(seve%e,proc,'Could not copy input spectrum')
        return
     endif
  else
     !
     ! Compute final number of points
     i1 = 1
     i2 = obs%head%dri%npoin
     npoin_final = obs%head%dri%npoin
     do iobs = 2,cx%next-1
        call get_it(set,obs,cx%ind(iobs),user_function,error)
        if (error) return
        npoin_final = npoin_final + obs%head%dri%npoin
     enddo
     !
     ! Allocate working arrays
     allocate(wx(npoin_final),wy(npoin_final),wint(npoin_final),w4(npoin_final),stat=ier)
     if (failed_allocate(proc,'WX,WY,WINT,WW',ier,error)) return
     !
     ! Allocate ALL observation
     all%head  = obs%head
     call reallocate_obs(all,npoin_final,error)
     if (error) return
     all%head%dri%npoin = npoin_final
     !
     ! Loop over index
     i2 = 0
     total_time = 0.
     newtsys    = 0.
     newtau     = 0.
     do iobs = 1,cx%next-1
        call get_it(set,obs,cx%ind(iobs),user_function,error)
        if (error) exit
        call abscissa(set,obs,error)   ! Compute X arrays according to type and unit
        if (error) exit
        i1 = i2+1
        i2 = i1+obs%head%dri%npoin-1
        wx(i1:i2) = obs%datax
        wy(i1:i2) = obs%data1
        !
        ! Compute new header variables
        total_time = total_time + obs%head%gen%time
        newtsys    = newtsys + obs%head%gen%tsys*obs%head%gen%time
        newtau     = newtau  + obs%head%gen%tau*obs%head%gen%time
        call class_controlc(proc,error)
        if (error) return
     enddo
     !
     ! Sort arrays
     call gr8_trie(wx,wint,npoin_final,error)
     if (error) then
        call class_message(seve%e,proc,'Could not sort arrays')
        return
     endif
     call gr4_sort(wy,w4,wint,npoin_final)
     !
     all%datax = wx
     all%data1 = wy
  endif
  !
  ! Finalize the output observation
  if (.not.error) then
    !
    ! History will be used to keep list of summed spectra
    all%head%presec(class_sec_his_id) = .true.
    !
    ! The summed spectrum is generated by program:
    all%head%xnum = -1
    !
    ! Update header (calibration parameters)
    all%head%gen%time = total_time
    all%head%gen%tsys = newtsys / total_time
    all%head%gen%tau  = newtau / total_time
    !
    all%head%presec(class_sec_xcoo_id) = .true.
    call abscissa(set,all,error)
    if (error) return
    call newdat(set,all,error)
    call newdat_assoc(set,all,error)
    call newdat_user(set,all,error)
  endif
  !
  ! Free memory
  call free_obs(obs)
  deallocate(wx,wy,wint,w4)
end subroutine merge

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_consistency_methods
  use cubetools_header_types
  use cubeheader_messaging
  !
  public :: cubetools_consistency_failed,cubetools_consistency_shape
  public :: cubetools_consistency_grid,cubetools_consistency_spatial,cubetools_consistency_spectral
  public :: cubetools_consistency_observatory,cubetools_consistency_signal_noise
  private
  !
contains
  !
  subroutine cubetools_consistency_check(cons,name1,head1,name2,head2,problem,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(cube_header_cons_t), intent(inout) :: cons
    character(len=*),         intent(in)    :: name1
    type(cube_header_t),      intent(in)    :: head1
    character(len=*),         intent(in)    :: name2
    type(cube_header_t),      intent(in)    :: head2
    logical,                  intent(inout) :: problem
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_header_consistency_check(cons,head1,head2,error)
    if (error) return
    problem = cons%prob .or. problem
    if (cons%prob) then
       call cubetools_header_consistency_list(cons,head1,head2,error)
       if (error) return
       call cubeheader_message(seve%w,rname,trim(name1)//' is inconsistent with '//trim(name2))
    endif
    call cubetools_header_consistency_final(cons,error)
    if (error) return
  end subroutine cubetools_consistency_check
  !
  subroutine cubetools_consistency_shape(name1,head1,name2,head2,problem,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),    intent(in)    :: name1
    type(cube_header_t), intent(in)    :: head1
    character(len=*),    intent(in)    :: name2
    type(cube_header_t), intent(in)    :: head2
    logical,             intent(inout) :: problem
    logical,             intent(inout) :: error
    !
    type(cube_header_cons_t) :: cons
    character(len=*), parameter :: rname='CONSISTENCY>GRID'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_header_consistency_init(cons,error)
    if (error) return
    cons%spa%check = .false.
    cons%spe%do = .false.
    cons%obs%check = .false.
    !
    cons%arr%noi%check   = .false.
    cons%arr%unit%check  = .false.
    cons%arr%min%check   = .false.
    cons%arr%max%check   = .false.
    cons%arr%n%nan%check = .false.
    ! *** JP The next one is a work around 2D vs degenerate 3D cubes
    cons%arr%n%dim%check = .false.
    ! *** JP The previous one is a work around 2D vs degenerate 3D cubes
    !
    call cubetools_consistency_check(cons,name1,head1,name2,head2,problem,error)
    if (error) return
  end subroutine cubetools_consistency_shape
  !
  subroutine cubetools_consistency_grid(name1,head1,name2,head2,problem,error)
    !------------------------------------------------------------------------
    ! Only check the shape of the array, including the number of data, and
    ! does not check the consistency of blanked (NaN) values.
    !------------------------------------------------------------------------
    character(len=*),    intent(in)    :: name1
    type(cube_header_t), intent(in)    :: head1
    character(len=*),    intent(in)    :: name2
    type(cube_header_t), intent(in)    :: head2
    logical,             intent(inout) :: problem
    logical,             intent(inout) :: error
    !
    type(cube_header_cons_t) :: cons
    character(len=*), parameter :: rname='CONSISTENCY>GRID'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_header_consistency_init(cons,error)
    if (error) return
    cons%obs%check       = .false.
    cons%arr%min%check   = .false.
    cons%arr%max%check   = .false.
    cons%arr%n%nan%check = .false.
    cons%spa%bea%check   = .false.
    !
    call cubetools_consistency_check(cons,name1,head1,name2,head2,problem,error)
    if (error) return
  end subroutine cubetools_consistency_grid
  !
  subroutine cubetools_consistency_spectral(name1,head1,name2,head2,problem,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),    intent(in)    :: name1
    type(cube_header_t), intent(in)    :: head1
    character(len=*),    intent(in)    :: name2
    type(cube_header_t), intent(in)    :: head2
    logical,             intent(inout) :: problem
    logical,             intent(inout) :: error
    !
    type(cube_header_cons_t) :: cons
    character(len=*), parameter :: rname='CONSISTENCY>SPECTRAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_header_consistency_init(cons,error)
    if (error) return
    cons%obs%check = .false.
    cons%arr%check = .false.
    cons%spa%check = .false.
    !
    call cubetools_consistency_check(cons,name1,head1,name2,head2,problem,error)
    if (error) return
  end subroutine cubetools_consistency_spectral
  !
  subroutine cubetools_consistency_spatial(name1,head1,name2,head2,problem,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),    intent(in)    :: name1
    type(cube_header_t), intent(in)    :: head1
    character(len=*),    intent(in)    :: name2
    type(cube_header_t), intent(in)    :: head2
    logical,             intent(inout) :: problem
    logical,             intent(inout) :: error
    !
    type(cube_header_cons_t) :: cons
    character(len=*), parameter :: rname='CONSISTENCY>SPATIAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_header_consistency_init(cons,error)
    if (error) return
    cons%obs%check = .false.
    cons%arr%check = .false.
    cons%spe%do = .false.
    ! *** JP Work-around the fact that we have not yet a way to nocheck the beam
    ! *** JP consistency as this is not stricto-censu needed to avoid segmentation
    ! *** JP faults.
    cons%spa%bea%check = .false.
    ! *** JP
    !
    call cubetools_consistency_check(cons,name1,head1,name2,head2,problem,error)
    if (error) return
  end subroutine cubetools_consistency_spatial
  !
  subroutine cubetools_consistency_observatory(name1,head1,name2,head2,problem,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),    intent(in)    :: name1
    type(cube_header_t), intent(in)    :: head1
    character(len=*),    intent(in)    :: name2
    type(cube_header_t), intent(in)    :: head2
    logical,             intent(inout) :: problem
    logical,             intent(inout) :: error
    !
    type(cube_header_cons_t) :: cons
    character(len=*), parameter :: rname='CONSISTENCY>OBSERVATORY'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_header_consistency_init(cons,error)
    if (error) return
    cons%arr%check = .false.
    cons%spe%do = .false.
    cons%spa%check = .false.
    !
    call cubetools_consistency_check(cons,name1,head1,name2,head2,problem,error)
    if (error) return
  end subroutine cubetools_consistency_observatory
  !
  subroutine cubetools_consistency_signal_noise(name1,head1,name2,head2,problem,error)
    use cubetools_header_interface
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),    intent(in)    :: name1
    type(cube_header_t), intent(in)    :: head1
    character(len=*),    intent(in)    :: name2
    type(cube_header_t), intent(in)    :: head2
    logical,             intent(inout) :: problem
    logical,             intent(inout) :: error
    !
    type(cube_header_cons_t) :: cons
    character(len=*), parameter :: rname='CONSISTENCY>SIGNAL>NOISE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (head1%spe%code.ne.head2%spe%code) then
       call cubeheader_message(seve%e,rname,'Inconsistent spectral codes')
       error = .true.
       return
    endif
    !
    call cubetools_header_consistency_init(cons,error)
    if (error) return
    !
    ! Do not check anything
    cons%arr%check  = .false.
    cons%obs%check  = .false.
    cons%spa%bea%check = .false.
    !
    cons%spe%line%check  = .false.
    cons%spe%c%check     = .false.
    cons%spe%ref%c%check = .false.
    !
    cons%spe%f%check     = .false.
    cons%spe%ref%f%check = .false.
    cons%spe%i%check     = .false.
    cons%spe%ref%i%check = .false.
    cons%spe%l%check     = .false.
    cons%spe%ref%l%check = .false.
    !
    cons%spe%v%check     = .false.
    cons%spe%ref%v%check = .false.
    cons%spe%z%check     = .false.
    cons%spe%ref%z%check = .false.
    !
    ! Some axes must be checked except for their size, genuinity and increments
    select case (head1%spe%code)
    case (code_spectral_frequency)
       cons%spe%f%check = .true.
       cons%spe%ref%f%check = .true.
       cons%spe%f%n%check       = .false.
       cons%spe%f%inc%check     = .false.
       cons%spe%f%genuine%check = .false.
       !
       cons%spe%i%check = .true.
       cons%spe%ref%i%check = .true.
       cons%spe%i%n%check       = .false.
       cons%spe%i%inc%check     = .false.
       cons%spe%i%genuine%check = .false.
    case (code_spectral_wavelength)
       cons%spe%l%check = .true.
       cons%spe%ref%l%check = .true.
       cons%spe%l%n%check       = .false.
       cons%spe%l%inc%check     = .false.
       cons%spe%l%genuine%check = .false.
    case default
       ! Do nothing more!
    end select
    !
    !***JP: Here I should do a distinction between velocity and redshift!
    cons%spe%v%check = .true.
    cons%spe%ref%v%check = .true.
    cons%spe%v%n%check       = .false.
    cons%spe%v%inc%check     = .false.
    cons%spe%v%genuine%check = .false.
    !
    call cubetools_consistency_check(cons,name1,head1,name2,head2,problem,error)
    if (error) return
  end subroutine cubetools_consistency_signal_noise
  !
  function cubetools_consistency_failed(rname,prob,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    logical,          intent(in)    :: prob
    logical,          intent(inout) :: error
    !
    logical :: cubetools_consistency_failed
    !
    cubetools_consistency_failed = .false.
    if (prob) then
       call cubeheader_message(seve%e,rname,'There are inconsistencies between input cubes')
       cubetools_consistency_failed = .true.
       error = .true.
    endif
  end function cubetools_consistency_failed
end module cubetools_consistency_methods
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mapping_interfaces_public
  interface
    subroutine dofft (np,nv,visi,jx,jy,jo   &
         &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv   &
         &    ,ubias,vbias,ubuff,vbuff,ctype)
      use gildas_def
      use omp_buffers
      !----------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS  UV_MAP
      !   Compute FFT of image by gridding UV data
      !   Operational version using the fastest method.
      !----------------------------------------------------------------------
      integer, intent(in) :: nv                   ! number of values
      integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
      real, intent(in) :: visi(np,nv)             ! values
      integer, intent(in) :: nc                   ! number of channels
      integer, intent(in) :: jx                   ! X coord location in VISI
      integer, intent(in) :: jy                   ! Y coord location in VISI
      integer, intent(in) :: jo                   ! first channel to map
      integer, intent(in) :: nx                   ! X map size
      integer, intent(in) :: ny                   ! Y map size
      complex, intent(out) :: map(nc+1,nx,ny)     ! gridded visibilities
      real, intent(in) :: mapx(nx)                ! X Coordinates of grid
      real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
      real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
      real, intent(in) :: cell(2)                 ! cell size in Meters
      real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
      real, intent(in) :: we(nv)                  ! Weight array
      real, intent(in) :: vv(nv)                  ! V Values
      real, intent(in) :: ubias                   ! U gridding offset
      real, intent(in) :: vbias                   ! V gridding offset
      real, intent(in) :: ubuff(4096)             ! U gridding buffer
      real, intent(in) :: vbuff(4096)             ! V gridding buffer
      integer, intent(in) :: ctype                ! type of gridding
    end subroutine dofft
  end interface
  !
  interface
    subroutine doself (model,resul,itype,self,weight)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Compute self calibraton factor
      !---------------------------------------------------------------------
      complex, intent(in) :: model   ! Model visibility
      complex, intent(in) :: resul   ! Actual observation
      integer, intent(in) :: itype   ! Type of self calibration
      complex, intent(out) :: self   ! Self calibration factor
      real, intent(out) :: weight    ! Weight scaling factor
    end subroutine doself
  end interface
  !
  interface
    subroutine doscal (nc,visi,cosi,sinu,sreel,simag,weight)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Apply the self-calibration factor to the current visibility
      !	  Set weight to zero if no self-cal factor
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
      real, intent(in) :: sreel           !  Real part to subtract
      real, intent(in) :: simag           !  Imaginary part to subtract
      real, intent(in) :: cosi            !  Phase rotation cos
      real, intent(in) :: sinu            !  Phase rotation sin
      real, intent(in) :: weight          !  Scaling factor of weight
    end subroutine doscal
  end interface
  !
  interface
    subroutine dosubt (nc,visi,sreel,simag)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Subtract a continuum value from a line visibility
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
      real, intent(in) :: sreel           !  Real part
      real, intent(in) :: simag           !  Imaginary part
    end subroutine dosubt
  end interface
  !
  interface
    subroutine doflag (nc,visi)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Flag (by zero) a line visibility
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
    end subroutine doflag
  end interface
  !
  interface
    subroutine getiba (visi,stime,time,base,uv)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Get baseline and time information
      !---------------------------------------------------------------------
      real, intent(in)  :: visi(*)                   ! Visibility
      real(8), intent(in) :: stime                   ! Reference time
      real(8), intent(out) :: time                   ! Time offset
      real, intent(out)  :: base(2)                  ! First and Last antenna
      real, intent(out)  :: uv(2)                    ! U and V
    end subroutine getiba
  end interface
  !
  interface
    subroutine dotime (mv,nv,visi,wtime,it,stime)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Compute the observing times of the data, 
      !	  sort it and return sorting index
      !---------------------------------------------------------------------
      integer, intent(in) :: mv           ! Size of visibility
      integer, intent(in) :: nv           ! Number of visibilities
      real, intent(in) :: visi(mv,nv)     ! Visibilities
      real(8), intent(out) :: wtime(nv)   ! Sorted times
      integer, intent(inout) :: it(nv)    ! Sorting index
      real(8), intent(out) :: stime       ! Reference time
    end subroutine dotime
  end interface
  !
  interface
    subroutine geself (mv,nv,iw,visi,time,ftime,wtime,it,   &
         &    rbase,complx,uv)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Compute the Observed Visibility of the "model source"
      !---------------------------------------------------------------------
      integer, intent(in) :: mv           ! Size of visibility
      integer, intent(in) :: nv           ! Number of visibilities
      real, intent(in) :: visi(mv,nv)     ! Visibilities
      real(8), intent(out) :: wtime(nv)   ! Sorted times
      integer, intent(in) :: iw(2)        ! First and Last channel
      real(8), intent(in) :: time         ! Time of observation
      real(8), intent(in) :: ftime        ! Tolerance on time +/-
      integer, intent(in) :: it(nv)       ! Ordering of visibilities
      real, intent(in) :: rbase(2)        ! Antennas
      real, intent(in) :: uv(2)           ! U and V
      complex, intent(out) :: complx      ! Result
    end subroutine geself
  end interface
  !
  interface
    subroutine findr (np,x,xlim,nlim)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Find NLIM such as
      !	 	    X(NLIM-1) < XLIM <= X(NLIM)
      !	  for input data ordered.
      !	  Use a dichotomic search for that
      !---------------------------------------------------------------------
      integer, intent(in) :: np          ! Number of data points
      real(8), intent(in) :: x(np)       ! Data values
      real(8), intent(in) :: xlim        ! Value to be localized
      integer, intent(out) :: nlim       ! Found position
    end subroutine findr
  end interface
  !
  interface
    subroutine extracs (np,nx,ny,ip,in,out,lx,ly)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !     Extract a Fourier plane from the FFT cube
      !     Plane and Cube may have different X,Y dimensions
      !----------------------------------------------------------------------
      integer,intent(in) :: np  ! Number of planes
      integer,intent(in) :: nx  ! output FFT X plane size
      integer,intent(in) :: ny  ! output FFT Y plane size
      integer,intent(in) :: ip  ! Plane to be extracted
      integer,intent(in) :: lx  ! input FFT cube X plane size
      integer,intent(in) :: ly  ! input FFT cube Y plane size
      complex,intent(in) :: in(np,lx,ly) ! Input FFT cube
      complex,intent(out) :: out(nx,ny)  ! Output 2-D FFT
    end subroutine extracs
  end interface
  !
  interface
    subroutine extrac (np,nx,ny,ip,in,out)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !     Extract a Fourier plane from an FFT cube
      !     Plane and Cube must have same X,Y dimensions
      !----------------------------------------------------------------------
      integer,intent(in) :: np  ! Number of planes
      integer,intent(in) :: nx  ! FFT X plane size
      integer,intent(in) :: ny  ! FFT Y plane size
      integer,intent(in) :: ip  ! Plane to be extracted
      complex,intent(in) :: in(np,nx,ny) ! Input FFT cube
      complex,intent(out) :: out(nx,ny)  ! Output 2-D FFT
    end subroutine extrac
  end interface
  !
  interface
    subroutine dovisi (np,nv,visi,vv,ww,jw)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Extract V coordinate and Weight value
      !----------------------------------------------------------------------
      integer, intent(in) :: np        ! Size of visibilities
      integer, intent(in) :: nv        ! Number of visibilities
      real, intent(in) :: visi(np,nv)  ! Visibilities
      real, intent(out) :: vv(nv)      ! V values
      real, intent(out) :: ww(nv)      ! Weight values
      integer, intent(in) :: jw        ! Weight column
    end subroutine dovisi
  end interface
  !
  interface
    subroutine dogrid (corr,corx,cory,nx,ny,beam)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Compute grid correction array, with normalisation
      !   of beam to 1.0 at maximum pixel
      !----------------------------------------------------------------------
      integer, intent(in) :: nx     ! X size
      integer, intent(in) :: ny     ! Y size
      real, intent(in) :: beam(nx,ny) ! Denormalized beam
      real, intent(in) :: corx(nx)    ! X grid correction
      real, intent(in) :: cory(ny)    ! Y Grid correction
      real, intent(out) :: corr(nx,ny) ! Final grid correction and beam normalization
    end subroutine dogrid
  end interface
  !
  interface
    subroutine docorr (map,corr,nd)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Apply grid correction to map
      !----------------------------------------------------------------------
      integer, intent(in) :: nd
      real, intent(inout) :: map(nd)
      real, intent(in) :: corr(nd)
    end subroutine docorr
  end interface
  !
  interface
    subroutine docoor (n,xinc,x)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Compute FFT grid coordinates in U or V
      !----------------------------------------------------------------------
      integer,intent(in) :: n
      real, intent(out) :: x(n)
      real, intent(in) :: xinc
    end subroutine docoor
  end interface
  !
  interface
    subroutine findp (nv,xx,xlim,nlim)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Find NLIM such as
      !   XX(NLIM-1) < XLIM < XX(NLIM)
      !   for input data ordered, retrieved from memory
      !   Assumes NLIM already preset so that XX(NLIM-1) < XLIM
      !----------------------------------------------------------------------
      integer, intent(in) :: nv       ! Number of values
      integer, intent(inout) :: nlim  ! Preset Position
      real, intent(in) :: xx(nv)  ! Input order value
      real, intent(in) :: xlim    ! Value to be located
    end subroutine findp
  end interface
  !
  interface
    subroutine findm (nv,xx,xlim,nlim)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Find NLIM such as
      !     XX(NLIM-1) < XLIM < XX(NLIM)
      !   for input data ordered, retrieved from memory
      !   Assumes NLIM already preset so that XLIM < XX(NLIM)
      !----------------------------------------------------------------------
      integer, intent(in) :: nv       ! Number of values
      integer, intent(inout) :: nlim  ! Preset Position
      real, intent(in) :: xx(nv)  ! Input order value
      real, intent(in) :: xlim    ! Value to be located
    end subroutine findm
  end interface
  !
  interface
    subroutine grdtab (n, buff, bias, corr)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Compute fourier transform of gridding function
      !----------------------------------------------------------------------
      integer, intent(in) :: n     ! Number of pixels, assuming center on N/2+1
      real, intent(in) :: buff(*)  ! Gridding function, tabulated every 1/100 cell
      real, intent(in) :: bias     ! Center of gridding function
      real, intent(out) :: corr(n) ! Gridding correction FT
    end subroutine grdtab
  end interface
  !
  interface
    subroutine retocm(r,z,nx,ny)
      !------------------------------------------------------------------------
      ! @  public
      ! MAPPING
      !   Convert real to complex, with Shifting in corners for FFT
      !------------------------------------------------------------------------
      integer, intent(in) :: nx, ny         ! Problem size
      real, intent(in) :: r(nx,ny)          ! Real values
      complex, intent(out) :: z(nx, ny)     ! Complex shifted values
    end subroutine retocm
  end interface
  !
  interface
    subroutine cmtore (in,out,nx,ny)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING Utility
      !   Extract Real image from Fourier Transform of its complex FFT
      !   with appropriate recentering
      !----------------------------------------------------------------------
      integer, intent(in) :: nx         ! Size of map
      integer, intent(in) :: ny         ! Size of map
      complex, intent(in) :: in(nx,ny)  ! Complex FFT
      real, intent(out) :: out(nx,ny)   ! Extracted real image
    end subroutine cmtore
  end interface
  !
  interface
    subroutine convfn (ctype, parm, buffer, bias)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! MAPPING
      !   CONVFN computes the convolving functions and stores them in
      !   the supplied buffer. Values are tabulated every 1/100 cell.
      !----------------------------------------------------------------------
      integer, intent(inout) :: ctype
      real(4), intent(inout) :: parm(10)
      real(4), intent(out)   :: buffer(:)
      real(4), intent(out)   :: bias
    end subroutine convfn
  end interface
  !
  interface
    subroutine grdflt (ctypx, ctypy, xparm, yparm)
      !----------------------------------------------------------------------
      ! @ public
      !
      !     GRDFLT determines default parameters for the convolution functions
      !     If no convolving type is chosen, an Spheroidal is picked.
      !     Otherwise any unspecified values ( = 0.0) will be set to some
      !     value.
      ! Arguments:
      !     CTYPX,CTYPY           I  Convolution types for X and Y direction
      !                                1 = pill box
      !                                2 = exponential
      !                                3 = sinc
      !                                4 = expontntial * sinc
      !                                5 = spheroidal function
      !     XPARM(10),YPARM(10)   R*4  Parameters for the convolution fns.
      !                                (1) = support radius (cells)
      !
      !----------------------------------------------------------------------
      integer, intent(inout) :: ctypx,ctypy
      real(4), intent(inout) :: xparm(10), yparm(10)
    end subroutine grdflt
  end interface
  !
  interface
    subroutine uvgmax(huv,visi,uvmax,uvmin)
      use image_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING Support for UV_MAP
      !       Get the Min Max of UV distances
      !----------------------------------------------------------------------
      type (gildas), intent(inout) :: huv
      real, intent(in) ::  visi(:,:) ! Visibilities
      real, intent(out) :: uvmax ! Max baseline
      real, intent(out) :: uvmin ! Min baseline
    end subroutine uvgmax
  end interface
  !
  interface
    function sump(n,a)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   Support for UV_MAP
      !       Return the sum of positive values in array
      !----------------------------------------------------------------------
      real :: sump    ! Return value, intent(out)
      integer, intent(in) :: n   ! Number of values
      real, intent(in) :: a(n)   ! Values
    end function sump
  end interface
  !
  interface
    subroutine dotape (jc,nv,visi,jx,jy,taper,we)
      use gildas_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Support for UV_MAP
      !     Apply taper to the weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) :: nv          ! number of values
      integer, intent(in) :: jc          ! Size of a visibility
      integer, intent(in) :: jx          ! X coord location in VISI
      integer, intent(in) :: jy          ! Y coord location in VISI
      real, intent(in) :: visi(jc,nv)    ! Visibilities
      real, intent(in) :: taper(4)       ! Taper definition
      real, intent(inout) :: we(nv)      ! Weights
    end subroutine dotape
  end interface
  !
  interface
    subroutine doweig (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! MAPPING   Support for UV_MAP
      !     Compute weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          ! number of values
      integer, intent(in) ::  jc          ! Number of "visibilities"
      integer, intent(in) ::  jx          ! X coord location in VISI
      integer, intent(in) ::  jy          ! Y coord location in VISI
      integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    ! Visibilities
      real, intent(in) ::  unif           ! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      ! Weight array
      real, intent(in) ::  wm             ! on input: % of uniformity
      real, intent(in) ::  vv(nv)         ! V values, pre-sorted
      logical, intent(inout) :: error
      integer, intent(in), optional :: code
    end subroutine doweig
  end interface
  !
  interface
    subroutine doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   Support for UV_MAP
      !     Compute weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          ! number of values
      integer, intent(in) ::  jc          ! Number of "visibilities"
      integer, intent(in) ::  jx          ! X coord location in VISI
      integer, intent(in) ::  jy          ! Y coord location in VISI
      integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    ! Visibilities
      real, intent(in) ::  unif           ! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      ! Weight array
      real, intent(in) ::  wm             ! on input: % of uniformity
      real, intent(in) ::  vv(nv)         ! V values, pre-sorted
      logical, intent(inout) :: error
      integer, intent(in), optional :: code  ! Number of sub-cells per UV uniform cell size
    end subroutine doweig_sph
  end interface
  !
  interface
    subroutine scawei (nv,uni,ori,wall)
      !---------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Scale the weights
      !---------------------------------------------------------
      integer, intent(in) :: nv     ! Number of visibilities
      real, intent(out) :: uni(nv)  ! Re-weighted weights
      real, intent(in)  :: ori(nv)  ! Original weights
      real, intent(out) :: wall     ! Sum of weights
    end subroutine scawei
  end interface
  !
  interface
    subroutine map_message(mkind,procname,message)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Messaging facility for the current library. Calls the low-level
      !   (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine map_message
  end interface
  !
end module mapping_interfaces_public

subroutine solve_gain(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  !---------------------------------------------------------------------
  !     CLIC
  !     Support routine for command
  !     SOLVE GAIN [SCAN]
  !     [/output /plot /Store /Reset /Offset /Closure /Search] :
  !     Not relevant here
  !     SOLVE GAIN SCAN = reduction scan by scan; otherwise average of scans.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: last
  logical :: end, scan
  integer :: i, j, ier, qlun, k, narg
  complex :: mean_visi(2,mnant,mnrec)
  real :: mean_wisi(2,mnant,mnrec)
  complex :: mean_visi_bas(2,mnbas,mnrec)
  real :: mean_wisi_bas(2,mnbas,mnrec)
  character(len=132) :: filnam, snam
  character(len=2) :: rece(4)
  !
  integer :: mvoc1, nk, ibb, bb, isolve
  integer:: i_solve(mnbb), n_solve
  logical :: saved_bb_select, saved_if_select
  logical :: crossed, reference
  parameter (mvoc1=2)
  character(len=12) :: argum, kw, voc1(mvoc1)
  data voc1/'NOSCAN','SCAN'/
  data rece/'-1','-2','-3','-4'/
  !------------------------------------------------------------------------
  qlun = 0
  !     Code:
  save_amplitude = do_amplitude
  save_flux = do_flux
  do_amplitude = .false.
  do_flux = .false.
  do_raw = .true.
  argum = 'NOSCAN'
  last = .false.
  !
  ! Reset saved phase differences.
  do i = 1, mnant
    ph_pol_saved = 0
  enddo
  !
  call sic_ke(line,0,2,argum,narg,.false.,error)
  if (error) return
  call sic_ambigs('SOLVE GAIN',argum,kw,nk,voc1,mvoc1,error)
  if (error) return
  scan = kw.eq.'SCAN'
  !
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  !
  !     Do it for both polarization
  call get_first(.true.,error)
  if (.not.scan) then
    if (sic_present(10,0)) then
      ier = sic_getlun(qlun)
      filnam = 'gain'//rece(r_nrec)
      snam = filnam
      call sic_parsef(snam,filnam,'INTER_OBS:','.obs')
      ier = sic_open (qlun,filnam(1:lenc(filnam)),'NEW',   &
        .false.)
      if (ier.ne.0) then
        call message(6,3,'SOLVE GAIN',   &
          'Cannot open INTER_OBS:gain.obs')
        call messios(6,3,'SOLVE GAIN',ier)
        goto 999
      endif
      !            WRITE(QLUN,1005) 'DEFINE LOGICAL UPH'
      if (.not.bb_select.and..not.if_select.and..not.sic_present(5,0)) then
         write (qlun,'(a)') "You should think DROIT AU BUT"
         goto 999
       endif
      call check_scan(qlun,r_scan,'Gain')
    endif
  elseif (sic_present(10,0)) then
    call message(6,2,'SOLVE_GAIN',   &
      'No gain.obs produced with SCAN argument')
  endif
  !
  ! Save status and initialize everything
  saved_bb_select = bb_select
  saved_if_select = if_select
  all_subb = .false.
  each_subb = .false.
  !
  if (.not.sic_present(5,0)) then !!!!!!!!!!!!!
    !
    ! First derive receiver rejection per "input"
    !
    do ibb = 1, r_nbb
      bb = r_mapbb(ibb)
      n_baseband = 1
      l_baseband(1) = 1
      i_baseband(1,1) = bb
      call select_bb
      call set_bb_subbands(error)
      call show_display('SUB_BANDS',.false.,error)
      do j=1,mnrec
        do i=1,mnant
          do k=1,2
            mean_visi(k,i,j) = 0.0
            mean_wisi(k,i,j) = 0.0
          enddo
        enddo
      enddo
      !
      !     Loop on current index
call get_first(.true.,error)
      if (error) goto 999
      end = .false.
      do while (.not.end)
        if (r_nsb.ne.2) then
          call message(6,3,'SOLVE_GAIN','Scan has only one sideband')
          error = .true.
          goto 999
        else
          if (r_lmode.eq.1) then
            call sub_gain(mnant,mean_visi(1,1,r_nrec),   &
              mean_wisi(1,1,r_nrec),bb, error)
            if (error) goto 999
            if (scan) then
              call sub_solve_gain(qlun,r_nrec,mean_visi,mean_wisi,   &
                bb,error)
            endif
          else
            call message(8,1,'SOLVE_GAIN','Observation is not correlation')
          endif
        endif
        !
        !     Next observation
        call get_next(end, error)
        if (error) goto 999
      enddo
      if (.not.scan) then
        if (new_receivers) then
          if (r_nsb.ne.2) then
            call message(6,3,'SOLVE_GAIN','Scan has only one sideband')      
            error = .true.
            goto 999
          else
            if (r_lmode.eq.1) then
              call sub_solve_gain(qlun,r_nrec,mean_visi,mean_wisi,   &
                 bb,error)
            endif
          endif
        else
          call sub_solve_gain(qlun,1,mean_visi,mean_wisi,bb,error)
          call sub_solve_gain(qlun,2,mean_visi,mean_wisi,bb,error)
        endif
      endif
    enddo
  endif
  !
  ! Then derive horizontal and vertical polarizations.
  !
  bb_select = saved_bb_select
  if_select = saved_if_select
  !
  if (r_nbb.lt.2) goto 998 ! No need to phase if single polar
  !
  if (bb_select) then
    call message (6,1,'SOLVE_GAIN','Solving phases per basebands')
    n_solve = r_nbb
    do isolve = 1, n_solve
      i_solve(isolve) = r_mapbb(isolve)
    enddo
  elseif (saved_if_select) then
    call message (6,1,'SOLVE_GAIN','Solving phases per IF')
    n_solve = r_nif
  else
    call message (6,4,'SOLVE_GAIN','Select either basebands or IF')
    error = .true.
    return
  endif
  do isolve = 1, n_solve
    if (bb_select) then
      n_baseband = 1
      l_baseband(1) = 1
      i_baseband(1,1) = i_solve(isolve)
      call set_bb_subbands(error)
    elseif (if_select) then
      n_if = 1
      l_if(1) = 1
      i_if(1,1) = isolve
      call set_if_subbands(error)
    endif
    !
    do j=1,mnrec
      do i=1,mnant
        do k=1,2
          mean_visi(k,i,j) = 0.0
          mean_wisi(k,i,j) = 0.0
        enddo
      enddo
    enddo
    !
    !     Loop on current index
call get_first(.true.,error)
    if (error) goto 999
    end = .false.
    do while (.not.end)
      crossed = .false.
      reference = .false.
      if (all(r_polswitch(1:r_nant,1).eq.1)) then
        crossed = .true.
        call message(6,2,'SOLVE_GAIN',   &
                  'Solving for all switches crossed phases')
      else
        if (any((r_polswitch(1:r_nant,1).eq.1))) then
          reference = .true.
          call message(6,3,'SOLVE_GAIN',   &
                           'Solving for V-H phase')
      endif

      endif
      if (r_lmode.eq.1) then
        if (.not.reference) then
          call sub_gain(mnant,mean_visi(1,1,r_nrec),   &
            mean_wisi(1,1,r_nrec),1, error)
          if (error) goto 999
        else
          call sub_data(mnbas,mean_visi_bas(1,1,r_nrec),   &
            mean_wisi_bas(1,1,r_nrec),1, error)
        endif
        if (scan) then
          if (reference) then
            call sub_solve_ref(qlun,r_nrec,mean_visi_bas,mean_wisi_bas, &
                               isolve,error)
          elseif (crossed) then
            call sub_solve_cross(qlun,r_nrec,mean_visi,mean_wisi,isolve,error)
          else
            call sub_solve_pha(qlun,r_nrec,mean_visi,mean_wisi,isolve,error)
          endif
        endif
      endif
      !
      !     Next observation
      call get_next(end, error)
      if (error) goto 999
    enddo
    if (.not.scan) then
      if (r_lmode.eq.1) then
        if (reference) then
          call sub_solve_ref(qlun,r_nrec,mean_visi_bas,mean_wisi_bas, &
                             isolve,error)
        elseif (crossed) then
          call sub_solve_cross(qlun,r_nrec,mean_visi,mean_wisi,isolve,error)
        else
          call sub_solve_pha(qlun,r_nrec,mean_visi,mean_wisi,isolve,error)
        endif
      endif
    endif
  enddo
  !
998 do_raw = .false.
  do_amplitude = save_amplitude
  do_flux = save_flux
  !
  if (all_base) call set_all_baselines
  if (all_subb) call set_all_subbands
  if (each_subb) call set_each_subband
  if (all_base .or. all_subb .or. each_subb ) then   
    call set_display(error)
  endif 
  if (qlun.ne.0) then
    write(qlun,1005) '! '
    close(unit=qlun)
    call sic_frelun(qlun)
  endif
  return
999 error = .true.
  goto 998
  !
1005 format(a)
end subroutine solve_gain
!
subroutine sub_gain (m,mean_visi,mean_wisi,ibb,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC
  !	Measure the receiver gain ratios
  !       M number of antennas
  !---------------------------------------------------------------------
  integer :: m                      !
  complex :: mean_visi(2,m)         !
  real ::    mean_wisi(2,m)         !
  integer :: ibb                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_sba.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_xy_code.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: i, jw1, jw2, ix, iy, iband, ipol, kr, isb1, isb2, kb, kif
  integer(kind=address_length) :: data_in, ipk, ipkc,ipkl
  integer(kind=address_length) :: kin
  integer(kind=data_length)    :: ldata_in, h_offset, c_offset, l_offset
  real :: vt(4,3), wt(4,3)
  real*8 :: air_mass
  integer :: iv, imm
  ! Code:
  !
  ipol = 1 ! Dummy
  kb = 1 
  kif = 1
  if (r_nsb.eq.2) then
    isb1 = 1
    isb2 = 2
  else
    isb1 = (3-r_isb)/2 
    isb2 = isb1
  endif
  ! Two antenna case
  if (r_nant.le.2) then
    call message(6,3,'SUB_GAIN', 'At least 3 antennas required')
    error = .true.
    return
  endif
  !
  call get_data (ldata_in,data_in,error)
  if (error) goto 999
  !
  ! Select subbands and channels to be averaged
  call check_subb(1,.true.,error)
  if (error) goto 999
  jw1 = iw1(1)
  jw2 = iw2(1)
  iy = xy_ampli                ! Amplitude
  ix = xy_time
  !
  if (do_pass) then
    call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, passc, passl, error)
    if (error) goto 999
  endif
  ! Get average record
  kin = gag_pointer(data_in, memory)
  call spectral_dump(kr,0,0)
  ipk = kin + h_offset(kr)
  call decode_header (memory(ipk))
  call set_scaling(error)
  if (error) return
  do i = 1, r_nant
    call spectral_dump(kr,i,0)
    ipkc = kin + c_offset(kr)
    ipkl = kin + l_offset(kr)
    do iband = isb1, isb2
      do iv=1,4
        do imm=1,3
          vt(iv,imm) = 0
          wt(iv,imm) = 0
        enddo
      enddo
      ! Read antenna average over subbands:
      call arecord (   &
        r_nsb, r_nband, r_nbas, r_lntch,   &
        memory(ipkc), memory(ipkl), passc, passl,   &
        i, iband,ipol,kb, kif, l_subb(1),i_subb(1,1),jw1,jw2,ix,iy,   &
        vt,wt,.false.,error)
      if (error) goto 999
      if (wt(2,2).gt.0) then
        mean_wisi(iband,i) = mean_wisi(iband,i) + wt(2,2)
        ! Correct for differential atmospheric absorption
        ! signal band:
        if (r_sb(ibb) .eq. 3-2*iband) then
          mean_visi(iband,i) = mean_visi(iband,i)   &
            + cmplx(vt(3,2),vt(4,2))   &
            * exp((r_taus(1,ibb)) * air_mass(r_el))
        ! image band:
        else
          mean_visi(iband,i) = mean_visi(iband,i)   &
            + cmplx(vt(3,2),vt(4,2))   &
            * exp((r_taui(1,ibb)) * air_mass(r_el))
        endif
      endif
    enddo
  enddo
  return
  !
999 error = .true.
  return
  !
end subroutine sub_gain
!
subroutine sub_data (m,mean_visi,mean_wisi,ibb,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC
  !	Load data in buffer for baseline based phase determination
  !       M number of antennas
  !---------------------------------------------------------------------
  integer :: m                      !
  complex :: mean_visi(2,m)         !
  real ::    mean_wisi(2,m)         !
  integer :: ibb                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_sba.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_xy_code.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: i, jw1, jw2, ix, iy, iband, ipol, kr, isb1, isb2, kb, kif
  integer(kind=address_length) :: data_in, ipk, ipkc,ipkl
  integer(kind=address_length) :: kin
  integer(kind=data_length)    :: ldata_in, h_offset, c_offset, l_offset
  real :: vt(4,3), wt(4,3)
  real*8 :: air_mass
  integer :: iv, imm
  ! Code:
  !
  ipol = 1 ! Dummy
  kb = 1 
  kif = 1
  if (r_nsb.eq.2) then
    isb1 = 1
    isb2 = 2
  else
    isb1 = (3-r_isb)/2 
    isb2 = isb1
  endif
  !
  call get_data (ldata_in,data_in,error)
  if (error) goto 999
  !
  ! Select subbands and channels to be averaged
  call check_subb(1,.true.,error)
  if (error) goto 999
  jw1 = iw1(1)
  jw2 = iw2(1)
  iy = xy_ampli                ! Amplitude
  ix = xy_time
  !
  if (do_pass) then
    call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, passc, passl, error)
    if (error) goto 999
  endif
  ! Get average record
  kin = gag_pointer(data_in, memory)
  call spectral_dump(kr,0,0)
  ipk = kin + h_offset(kr)
  call decode_header (memory(ipk))
  call set_scaling(error)
  if (error) return
  do i = 1, r_nbas
    call spectral_dump(kr,0,i)
    ipkc = kin + c_offset(kr)
    ipkl = kin + l_offset(kr)
    do iband = isb1, isb2
      do iv=1,4
        do imm=1,3
          vt(iv,imm) = 0
          wt(iv,imm) = 0
        enddo
      enddo
      ! Read antenna average over subbands:
      call brecord (   &
        r_nsb, r_nband, r_nbas+r_ntri, r_lntch,   &
        memory(ipkc), memory(ipkl), passc, passl,   &
        i, iband,ipol,kb, kif, l_subb(1),i_subb(1,1),jw1,jw2,ix,iy,   &
        vt,wt,error)
      if (error) goto 999
      if (wt(2,2).gt.0) then
        mean_wisi(iband,i) = mean_wisi(iband,i) + wt(2,2)
        ! Correct for differential atmospheric absorption
        ! signal band:
        if (r_sb(ibb) .eq. 3-2*iband) then
          mean_visi(iband,i) = mean_visi(iband,i)   &
            + cmplx(vt(3,2),vt(4,2))   &
            * exp((r_taus(1,ibb)) * air_mass(r_el))
        ! image band:
        else
          mean_visi(iband,i) = mean_visi(iband,i)   &
            + cmplx(vt(3,2),vt(4,2))   &
            * exp((r_taui(1,ibb)) * air_mass(r_el))
        endif
      endif
    enddo
  enddo
  return
  !
999 error = .true.
  return
  !
end subroutine sub_data
!
subroutine sub_solve_pha(qlun, ir, mean_visi, mean_wisi, ibb, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  include 'clic_parameter.inc'
  integer :: qlun                      !
  integer :: ir                        !
  complex :: mean_visi(2,mnant,mnrec)  !
  real    :: mean_wisi(2,mnant,mnrec)  !
  integer :: ibb                       !
  logical :: error                     !
  ! Global
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: ok(mnant), do_rec
  integer :: i, ig, im
  complex :: av(2)
  real :: ph_pol(mnant), faz
  character(len=132) :: ch
  character(len=1) :: backslash
  character(len=1) :: pol(2)
  data pol/'H','V'/
  !-----------------------------------------------------------------------
  backslash=char(92)
  av(1) = 1.0
  av(2) = 1.0
  if (r_sb(ibb).eq.1) then
    ig = 1                     ! Upper sideband
    im = 2
  else
    ig = 2                     ! Lower sideband
    im = 1
  endif
  !
  do_rec  = .false.
  do i=1, r_nant
    ok(i) = mean_wisi(ig,i,ir).gt.0
    do_rec = do_rec .or. ok(i)
  enddo
  if (.not. do_rec) return
  !
  do i=1, r_nant
    if (ok(i)) then
      mean_visi(ig,i,ir) = mean_visi(ig,i,ir)/mean_wisi(ig,i,ir)
      !
      ! Mean phase for polarization phasing
      ph_pol(i) = faz(mean_visi(ig,i,ir))*180/pi
      ph_pol(i) = mod(ph_pol(i)+540.,360.)-180
    else
      write(ch,'(a,i0,a,i1)') 'No signal for antenna ',   &
        r_kant(i),' rec. ',ir
      call message(6,2,'SOLVE_GAIN',ch(1:lenc(ch)))
    endif
  enddo
  !
  ! Deal with Phases
  if (qlun.ne.0) then
    do i=1, r_nant
      if (ok(i)) then
        if (bb_select) then
          if (i.ne.ref_ant) then
            write(qlun,1009)backslash, ph_pol(i), r_kant(i),ir,   &
              r_bbname(i_baseband(1,1))
          else
            write(qlun,1009)backslash, 0.0, r_kant(i),ir,   &
              r_bbname(i_baseband(1,1))
          endif
        elseif (if_select) then
          if (i.ne.ref_ant) then
            write(qlun,1010)backslash, ph_pol(i), r_kant(i),ir,   &
              r_ifname(i_if(1,1))
          else
            write(qlun,1010)backslash, 0.0, r_kant(i),ir,   &
              r_ifname(i_if(1,1))
          endif
        endif
      endif
    enddo
  endif
  return
1009 format('  SET',a1,'PHASE BASEBAND ',f6.1,   &
    ' /ANTENNA ',i0,' /RECEIVER ',i1,' /BASEBAND ',a)
1010 format('  SET',a1,'PHASE POL ',f6.1,   &
    ' /ANTENNA ',i0,' /RECEIVER ',i1,' /IF ',a)
end subroutine sub_solve_pha
!
subroutine sub_solve_cross(qlun, ir, mean_visi, mean_wisi, ibb, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  include 'clic_parameter.inc'
  integer :: qlun                      !
  integer :: ir                        !
  complex :: mean_visi(2,mnant,mnrec)  !
  real    :: mean_wisi(2,mnant,mnrec)  !
  integer :: ibb                       !
  logical :: error                     !
  ! Global
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: ok(mnant), do_rec
  integer :: i, ig, im
  complex :: av(2)
  real :: ph_pol(mnant), faz
  character(len=132) :: ch
  character(len=1) :: backslash
  character(len=1) :: pol(2)
  data pol/'H','V'/
  !-----------------------------------------------------------------------
  backslash=char(92)
  av(1) = 1.0
  av(2) = 1.0
  if (r_sb(ibb).eq.1) then
    ig = 1                     ! Upper sideband
    im = 2
  else
    ig = 2                     ! Lower sideband
    im = 1
  endif
  !
  do_rec  = .false.
  do i=1, r_nant
    ok(i) = mean_wisi(ig,i,ir).gt.0
    do_rec = do_rec .or. ok(i)
  enddo
  if (.not. do_rec) return
  !
  do i=1, r_nant
    if (ok(i)) then
      mean_visi(ig,i,ir) = mean_visi(ig,i,ir)/mean_wisi(ig,i,ir)
      !
      ! Mean phase for polarization phasing
      ph_pol(i) = faz(mean_visi(ig,i,ir))*180/pi
      ph_pol(i) = mod(ph_pol(i)+540.,360.)-180
    else
      write(ch,'(a,i0,a,i1)') 'No signal for antenna ',   &
        r_kant(i),' rec. ',ir
      call message(6,2,'SOLVE_GAIN',ch(1:lenc(ch)))
    endif
  enddo
  !
  ! Deal with Phases
  if (qlun.ne.0) then
    do i=1, r_nant
      if (ok(i)) then
        if (bb_select) then
          if (i.ne.ref_ant) then
            write(qlun,1009)backslash, ph_pol(i), r_kant(i),ir,   &
              r_bbname(i_baseband(1,1))
          else
            write(qlun,1009)backslash, 0.0, r_kant(i),ir,   &
              r_bbname(i_baseband(1,1))
          endif
        elseif (if_select) then
          if (i.ne.ref_ant) then
            write(qlun,1010)backslash, ph_pol(i), r_kant(i),ir,   &
              r_ifname(i_if(1,1))
          else
            write(qlun,1010)backslash, 0.0, r_kant(i),ir,   &
              r_ifname(i_if(1,1))
          endif
        endif
      endif
    enddo
  endif
  return
1009 format('  SET',a1,'PHASE BASEBAND ',f6.1,   &
    ' /ANTENNA ',i0,' /RECEIVER ',i1,' /BASEBAND ',a,'/CROSSED')
1010 format('  SET',a1,'PHASE POL ',f6.1,   &
    ' /ANTENNA ',i0,' /RECEIVER ',i1,' /IF ',a,'/CROSSED')
end subroutine sub_solve_cross
!
subroutine sub_solve_ref(qlun, ir, mean_visi, mean_wisi, ibb, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  include 'clic_parameter.inc'
  integer :: qlun                      !
  integer :: ir                        !
  complex :: mean_visi(2,mnbas,mnrec)  !
  real    :: mean_wisi(2,mnbas,mnrec)  !
  integer :: ibb                       !
  logical :: error                     !
  ! Global
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: ok(mnbas), do_rec
  integer :: i, ig, im, ia, ja, k
  complex :: av(2)
  real :: ph_pol(mnbas), faz, ph_ref
  character(len=132) :: ch
  character(len=1) :: backslash
  character(len=1) :: pol(2)
  data pol/'H','V'/
  !-----------------------------------------------------------------------
  ph_pol = 0 
  backslash=char(92)
  av(1) = 1.0
  av(2) = 1.0
  if (r_sb(ibb).eq.1) then
    ig = 1                     ! Upper sideband
    im = 2
  else
    ig = 2                     ! Lower sideband
    im = 1
  endif
  !
  do_rec  = .false.
  do i=1, r_nbas
    ia = r_iant(i)
    ja = r_jant(i)
    ok(i) = mean_wisi(ig,i,ir).gt.0.and.(r_polswitch(ia,1).ne.r_polswitch(ja,1))
    do_rec = do_rec .or. ok(i)
  enddo
  if (.not. do_rec) return
  !
  do i=1, r_nbas
    if (ok(i)) then
      mean_visi(ig,i,ir) = mean_visi(ig,i,ir)/mean_wisi(ig,i,ir)
      !
      ! Mean phase for polarization phasing
      ph_pol(i) = faz(mean_visi(ig,i,ir))*180/pi
      ph_pol(i) = mod(ph_pol(i)+540.,360.)-180
    else
      write(ch,'(a,i0)') 'Ignoring baseline ',i
      call message(6,1,'SOLVE_GAIN',ch(1:lenc(ch)))
    endif
  enddo
  !
  ! Deal with Phases
  if (qlun.ne.0) then
    ph_ref = 0
    k = 0
    do i=1, r_nbas
      if (ok(i)) then
        ph_ref = ph_ref + ph_pol(i)
        k = k+1
      endif
    enddo
    if (k.gt.0) then
      write(ch,'(a,i0,a)') 'Averaging ',k,' baselines'
      call message(6,1,'SOLVE_GAIN',ch(1:lenc(ch)))
      ph_ref = ph_ref/k
    else
      write(ch,'(a,i0,a)') 'Found no valid baseline'
      call message(6,3,'SOLVE_GAIN',ch(1:lenc(ch)))
      return
    endif
    if (bb_select) then
      write(qlun,1009)backslash, ph_ref, ir,   &
            r_bbname(i_baseband(1,1))
    elseif (if_select) then
      write(qlun,1010)backslash, ph_ref, ir,   &
            r_ifname(i_if(1,1))
    endif    
  endif
  return
1009 format('  SET',a1,'PHASE BASEBAND ',f6.1,   &
    ' /RECEIVER ',i1,' /BASEBAND ',a,'/REFERENCE')
1010 format('  SET',a1,'PHASE POL ',f6.1,   &
    ' /RECEIVER ',i1,' /IF ',a,'/REFERENCE')
end subroutine sub_solve_ref
!
subroutine sub_solve_gain(qlun, ir, mean_visi, mean_wisi, bb,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  include 'clic_parameter.inc'
  integer :: qlun                      !
  integer :: ir                        !
  complex :: mean_visi(2,mnant,mnrec)  !
  real    :: mean_wisi(2,mnant,mnrec)  !
  integer :: bb
  logical :: error                     !
  ! Global
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_display.inc'
  ! Local
  logical :: ok(mnant), do_rec
  integer :: i, inp
  integer(kind=index_length) :: dim(2)
  complex :: av(2), ratio
  real :: wratio
  real :: solved_gain_1(mnant), solved_gain_1_err(mnant)
  real :: solved_gain_2(mnant), solved_gain_2_err(mnant)
  real :: solved_gain_3(mnant), solved_gain_3_err(mnant)
  real :: solved_gain_4(mnant), solved_gain_4_err(mnant)
  real :: solved_gain_5(mnant), solved_gain_5_err(mnant)
  real :: solved_gain_6(mnant), solved_gain_6_err(mnant)
  real,save :: solved_gain(mnant,mnbb), solved_gain_err(mnant,mnbb)
  character(len=132) :: ch
  logical, save :: sic_variable_defined = .false.
  !-----------------------------------------------------------------------
  error = .false.
  if (.not.sic_variable_defined) then
    dim(1) = mnant
    dim(2) = mnbb
    call sic_def_real ('SOLVED_GAIN',solved_gain,2,dim,   &
      .false.,error)
    sic_variable_defined = .true.
  endif
  av(1) = 1.0
  av(2) = 1.0
  !
  ! Deal with Side band ratios
  do_rec  = .false.
  do i=1, r_nant
    ok(i) = mean_wisi(1,i,ir).gt.0.and.mean_wisi(2,i,ir).gt.0
    do_rec = do_rec .or. ok(i)
  enddo
  if (.not. do_rec) return
  !
  do i=1, r_nant
    if (ok(i)) then
      mean_visi(1,i,ir) = mean_visi(1,i,ir)/mean_wisi(1,i,ir)
      mean_visi(2,i,ir) = mean_visi(2,i,ir)/mean_wisi(2,i,ir)
      !
      ! Compute ratio (=4): (AV here is set to 1)
      call mixband(4,r_sb(bb),mean_visi(1,i,ir),   &
        mean_wisi(1,i,ir),av,ratio,wratio)
      !
      write (ch,1004) ir,r_kant(i),abs(ratio),0.001/sqrt(wratio)
1004  format('R',i1,' A',i0,' I/S = ',f6.3,' +- ',f5.3)
      call message(6,1,'SOLVE_GAIN',ch(1:lenc(ch)))
      !
      ! Output values of gain
      inp = bb
      if (qlun.ne.0) then
        if (new_receivers) then
          write(qlun,1002) max(0.001,abs(ratio)) ,r_kant(i),   &
            ir,r_bbname(inp),0.001/sqrt(wratio)
        else
           write(qlun,1001) max(0.001,abs(ratio)) ,r_kant(i),   &
            ir,0.001/sqrt(wratio)
        endif
      endif
    else
      write(ch,'(a,i0,a,i1)') 'No signal for antenna ',   &
        r_kant(i),' rec. ',ir
      call message(6,2,'SOLVE_GAIN',ch(1:lenc(ch)))
    endif
    solved_gain(i,inp) = max(0.001,abs(ratio))
    solved_gain_err(i,inp) = 0.001/sqrt(wratio)
    if (inp.eq.1) then
      solved_gain_1(i) = max(0.001,abs(ratio))
      solved_gain_1_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.2) then
      solved_gain_2(i) = max(0.001,abs(ratio))
      solved_gain_2_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.3) then
      solved_gain_3(i) = max(0.001,abs(ratio))
      solved_gain_3_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.4) then
      solved_gain_4(i) = max(0.001,abs(ratio))
      solved_gain_4_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.5) then
      solved_gain_5(i) = max(0.001,abs(ratio))
      solved_gain_5_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.6) then
      solved_gain_6(i) = max(0.001,abs(ratio))
      solved_gain_6_err(i) = 0.001/sqrt(wratio)
    endif
  enddo
  if (inp.eq.1) then
    call sic_delvariable ('SOLVED_GAIN_1',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_1_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_1',solved_gain_1,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_1_ERR',solved_gain_1_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.2) then
    call sic_delvariable ('SOLVED_GAIN_2',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_2_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_2',solved_gain_2,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_2_ERR',solved_gain_2_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.3) then
    call sic_delvariable ('SOLVED_GAIN_3',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_3_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_3',solved_gain_3,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_3_ERR',solved_gain_3_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.4) then
    call sic_delvariable ('SOLVED_GAIN_4',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_4_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_4',solved_gain_4,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_4_ERR',solved_gain_4_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.5) then
    call sic_delvariable ('SOLVED_GAIN_5',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_5_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_5',solved_gain_5,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_5_ERR',solved_gain_5_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.6) then
    call sic_delvariable ('SOLVED_GAIN_6',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_6_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_6',solved_gain_6,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_6_ERR',solved_gain_6_err,1,dim,   &
      .false.,error)
    error = .false.
  endif
  return
1001 format('SET GAIN ',f6.3,' /ANTENNA ',i0,   &
    ' /RECEIVER ',i1,'     ! +/- ',f5.3)
1002 format('SET GAIN ',f6.3,' /ANTENNA ',i0,   &
    ' /RECEIVER ',i1,' /BASEBAND ',a,'     ! +/- ',f5.3)
end subroutine sub_solve_gain

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_structure
  use cubetools_package
  use cubetools_language
  use cubetools_standard_comm
  use cubetools_standard_opt
  use cubetools_obsolete_opt
  use cubetools_primitive_arg
  use cubetools_standard_arg
  use cubetools_keywordlist_types
  use cubetools_unit_arg
  use cubetools_structure_main
  !---------------------------------------------------------------------
  ! Provide the high level API (types, procedures) to programmers who
  ! design commands or options.
  !---------------------------------------------------------------------
  !
  ! Package
  public :: pack  ! ZZZ Should not be public, provide API to interact with it instead.
  public :: cubetools_register_package
  public :: cubetools_list_package_languages
  public :: cubetools_structure_help_iterate
  !
  ! Languages
  public :: lang_k
  public :: language_t
  public :: cubetools_register_language
  public :: cubetools_list_language_commands
  public :: cubetools_register_dict
  public :: cubetools_pack_has_language
  !
  ! Commands
  public :: comm_k
  public :: command_t
  public :: cubetools_register_command
  public :: cubetools_execute_command
  public :: cubetools_show_command
  !
  ! Options
  public :: opti_k
  public :: option_t,obsolete_opt_t
  public :: cubetools_register_option
  public :: cubetools_nopt
  !
  ! Arguments
  public :: narg_k
  public :: primitive_arg_t,standard_arg_t,keywordlist_comm_t,unit_arg_t
  public :: cubetools_register_primitive_arg
  public :: cubetools_keywordlist_user2prog
  public :: cubetools_getarg
  !
  ! Products
  public :: cubetools_register_primitive_prod
  !
  private
  !
end module cubetools_structure
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module sic_macros_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces
  use sic_structures
  !---------------------------------------------------------------------
  ! Support module for macros
  ! ---
  ! Note on the module name: the suffix '_interfaces' allows to ignore
  ! the 'use sic_macros_interfaces' line in all subroutines using this
  ! statement. This solves a false positive circular dependency:
  ! the sic_interfaces module is compiled first, then the current module.
  !---------------------------------------------------------------------
  !
  public :: macnam,macarg,manarg,mac1,mac2
  public :: sic_macros_variables,sic_macros_replace_args
  public :: sic_macros_parse,sic_macros_parse_reset
  private
  !
  character(len=filename_length)    :: macnam(maxlev)            ! Name of all macros
  character(len=commandline_length) :: macarg(0:maxlev)          ! Arguments (command-line) of all macros
  integer(kind=4), save             :: manarg(0:maxlev)          ! Number of arguments of all macros
  integer(kind=4)                   :: mac1(0:maxlev,maxmacarg)  ! Pointer to beginning of macro argument in macarg
  integer(kind=4)                   :: mac2(0:maxlev,maxmacarg)  ! Pointer to end       of macro argument in macarg
  character(len=256), save          :: macstr(maxmacarg)         ! Placeholder for arguments of CURRENT LEVEL macro (PRO%ARG[])
  !
  ! PRO%PARSE support
  type :: pro_parse_t  ! Support type for 1 macro command-line parsing
    logical                       :: do=.false.            ! Parsing enabled for this macro
    integer(kind=4)               :: nopt                  ! Number of options parsed
    character(len=command_length) :: optname(0:maxmacarg)  ! Parsed option names
    integer(kind=4)               :: optnarg(0:maxmacarg)  ! Number of options passed
    integer(kind=4)               :: optfirst(0:maxmacarg) ! Location of first argument of each option
  end type pro_parse_t
  !
  character(len=*), parameter :: parse_struct='PRO%PARSE'
  type(pro_parse_t), save     :: parse(maxlev)
  !
contains
  !
  subroutine sic_macros_variables
    !---------------------------------------------------------------------
    ! Define the current macro arguments in PRO%
    !---------------------------------------------------------------------
    logical :: error
    integer :: i
    !
    error = .false.
    call sic_delvariable ('PRO',.false.,error)
    if (nmacro.eq.0) return
    !
    ! This is a "Program Defined" structure
    error = .false.
    call sic_defstructure('PRO',.true.,error)
    !
    ! And now the associated program-defined variables.
    call sic_def_char('PRO%NAME',macnam(nmacro),.true.,error)
    call sic_def_inte('PRO%NARG',manarg(nmacro),0,0,.true.,error)
    if (manarg(nmacro) .lt.1) return
    call sic_def_charn('PRO%ARG',macstr,1,manarg(nmacro),.true.,error)
    do i = 1,manarg(nmacro)
      macstr(i) = macarg(nmacro)(mac1(nmacro,i):mac2(nmacro,i))
    enddo
    !
    ! The parse substructure (if relevant)
    call sic_macros_parse_variables(parse(nmacro),error)
    if (error)  return
  end subroutine sic_macros_variables
  !
  subroutine sic_macros_parse(line,error)
    !---------------------------------------------------------------------
    ! Support routine for command:
    !  SIC\PARSE [/OPT1 [Nargmin [Nargmax]]] [/OPT2 ...] ... [/OPTN ...]
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line   ! Input command line
    logical,          intent(inout) :: error  ! Logical error flag
    !
    call sic_macros_parse_level(line,parse(nmacro),error)
    if (error)  return
    call sic_macros_parse_variables(parse(nmacro),error)
    if (error)  return
  end subroutine sic_macros_parse
  !
  subroutine sic_macros_parse_reset(imacro,error)
    !-------------------------------------------------------------------
    ! SIC\PARSE: reset the parse structure for the i-th macro
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: imacro
    logical,         intent(inout) :: error
    !
    parse(imacro)%do = .false.
    ! No more: the other components will be overwritten next time this
    ! level is used.
  end subroutine sic_macros_parse_reset
  !
  subroutine sic_macros_parse_level(line,p,error)
    !-------------------------------------------------------------------
    ! SIC\PARSE: parse and check the macros arguments for the current
    ! level
    !-------------------------------------------------------------------
    character(len=*),  intent(in)    :: line   ! Input command line
    type(pro_parse_t), intent(out)   :: p      !
    logical,           intent(inout) :: error  ! Logical error flag
    ! Local
    character(len=*), parameter :: rname='PARSE'
    integer(kind=4) :: nc,iopt,iarg,narg,curr_opt,spos
    character(len=command_length) :: imacstr,option
    integer(kind=4) :: nargmin(0:maxmacarg),nargmax(0:maxmacarg)
    character(len=32) :: mess1,mess2
    character(len=message_length) :: mess
    !
    ! --- Fetch the options list ---------------------------------------
    p%nopt = 0
    p%optname(p%nopt) = '/COMMAND'
    nargmin(p%nopt) = -1  ! No minimum provided yet
    nargmax(p%nopt) = -1  ! No maximum provided yet
    !
    do iarg=1,sic_narg(0)
      call sic_ch(line,0,iarg,option,nc,.true.,error)
      if (error)  return
      if (option(1:1).eq."/") then
        ! This is a new option declaration
        ! Finish previous option declaring
        if (nargmax(p%nopt).eq.-1)  nargmax(p%nopt) = nargmin(p%nopt)
        ! Start new option declaration
        call sic_upper(option)
        p%nopt = p%nopt+1
        p%optname(p%nopt) = option
        nargmin(p%nopt) = -1  ! No minimum provided yet
        nargmax(p%nopt) = -1  ! No maximum provided yet
        !
      elseif (nargmin(p%nopt).eq.-1) then
        call sic_i4(line,0,iarg,nargmin(p%nopt),.true.,error)
        if (error)  return
        if (nargmin(p%nopt).le.-1) then
          call sic_message(seve%e,rname,'Invalid option declaration, should have 0 <= Nargmin <= Nargmax')
          error = .true.
          return
        endif
        !
      elseif (nargmax(p%nopt).eq.-1) then
        call sic_i4(line,0,iarg,nargmax(p%nopt),.true.,error)
        if (error)  return
        if (nargmax(p%nopt).lt.nargmin(p%nopt)) then
          call sic_message(seve%e,rname,'Invalid option declaration, should have 0 <= Nargmin <= Nargmax')
          error = .true.
          return
        endif
        !
      else
        call sic_message(seve%e,rname,'Invalid option declaration. Syntax is:')
        call sic_message(seve%e,rname,'SIC\PARSE [Nargmin [Nargmax]] /OPT1  [Nargmin [Nargmax]] /OPT2...')
        error = .true.
        return
      endif
    enddo
    !
    ! --- Parse PRO%ARG --------------------------------------------------
    !
    p%optnarg(:) = -1  ! i.e. none of the options is present
    p%optnarg(0) = 0   ! i.e. command is present, with 0 argument yet
    p%optfirst(:) = 0  !
    p%optfirst(0) = 1  ! 1st argument of command is 1st element of PRO%ARG[:]
    curr_opt = 0
    do iarg=1,manarg(nmacro)
      spos = index(macstr(iarg),'/',back=.true.)
      if (macstr(iarg)(1:1).eq.'/' .and. spos.eq.1) then
        ! Argument starts with a slash and has no other slash =>
        ! must be an option to be compared with the PARSE ones.
        imacstr = macstr(iarg)
        call sic_upper(imacstr)
        call sic_ambigs(rname,imacstr,option,curr_opt,p%optname(1),p%nopt,error)
        if (error)  return
        p%optnarg(curr_opt) = 0
        p%optfirst(curr_opt) = iarg+1
      else
        ! Standard argument (including argument with several slashes,
        ! assumed to be paths): increment arguments counter for this option.
        p%optnarg(curr_opt) = p%optnarg(curr_opt)+1
      endif
    enddo
    !
    ! --- Check for correct number of arguments --------------------------
    !
    do iopt=0,p%nopt
      !
      if (p%optnarg(iopt).eq.-1)  cycle  ! Option is absent, nothing to check
      !
      if (nargmin(iopt).ne.-1 .and. nargmin(iopt).ne.nargmax(iopt)) then
        ! A minimum number is required
        if (p%optnarg(iopt).lt.nargmin(iopt)) then
          error = .true.
          mess2 = 'at least'
          narg = nargmin(iopt)
        endif
        !
      elseif (nargmax(iopt).ne.-1 .and. nargmin(iopt).ne.nargmax(iopt)) then
        ! A maximum number required
        if (p%optnarg(iopt).gt.nargmax(iopt)) then
          error = .true.
          mess2 = 'at most'
          narg = nargmax(iopt)
        endif
        !
      elseif (nargmin(iopt).ne.-1 .and. nargmin(iopt).eq.nargmax(iopt)) then
        ! An exact number is required
        if (p%optnarg(iopt).ne.nargmin(iopt)) then
          error = .true.
          mess2 = 'exactly'
          narg = nargmin(iopt)
        endif
      endif
      !
      if (error) then
        if (iopt.eq.0) then
          mess1 = 'Command'
        else
          mess1 = 'Option '//p%optname(iopt)
        endif
        write(mess,10)  trim(mess1),trim(mess2),narg
        call sic_message(seve%e,rname,mess)
        return
      endif
    enddo
    !
    ! --- Success ------------------------------------------------------
    ! Enable PRO%PARSE structure
    p%do = .true.
    !
  10 format(A,' takes ',A,1X,I0,' argument(s)')
  end subroutine sic_macros_parse_level
  !
  subroutine sic_macros_parse_variables(p,error)
    !-------------------------------------------------------------------
    ! SIC\PARSE: create the PRO%PARSE% structure
    !-------------------------------------------------------------------
    type(pro_parse_t), intent(in)    :: p
    logical,           intent(inout) :: error
    !
    integer(kind=4) :: iopt
    character(len=varname_length) :: varname1,varname2
    logical, parameter :: global=.true.,ro=.true.
    !
    call sic_delvariable(parse_struct,.false.,error)
    if (error)  return
    !
    if (.not.p%do)  return
    !
    call sic_defstructure(parse_struct,global,error)
    if (error)  return
    !
    do iopt=0,p%nopt
      !
      ! PRO%PARSE%<OPTNAME>%
      write(varname1,'(A,A,A)')  trim(parse_struct),'%',p%optname(iopt)(2:)  ! Strip the leading /
      call sic_defstructure(varname1,global,error)
      if (error)  return
      !
      ! PRO%PARSE%<OPTNAME>%NARG
      varname2 = trim(varname1)//'%NARG'
      call sic_def_inte(varname2,p%optnarg(iopt),0,0,ro,error)
      if (error)  return
      !
      ! PRO%PARSE%<OPTNAME>%ARG
      if (p%optnarg(iopt).gt.0) then
        ! Note: this assumes 'macstr' was updated by subroutine 'sic_macros_variables'
        varname2 = trim(varname1)//'%ARG'
        call sic_def_charn(varname2,macstr(p%optfirst(iopt)),1,p%optnarg(iopt),ro,error)
        if (error)  return
      endif
      !
    enddo
  end subroutine sic_macros_parse_variables
  !
  subroutine sic_macros_replace_args(line,nl,l,error)
    !---------------------------------------------------------------------
    !  Substitute the Macro Arguments invoked as tokens &1 ... &9
    !---------------------------------------------------------------------
    character(len=*), intent(inout) :: line   ! Line to be expanded
    integer(kind=4),  intent(inout) :: nl     ! Length of line
    integer(kind=4),  intent(in)    :: l      ! Macro number (0 == stack)
    logical,          intent(out)   :: error  ! Logical error flag
    ! Local
    integer(kind=4) :: nlm1,i,j,k,lv,ml,mv
    !
    error=.false.
    nlm1=nl-1
    ml = len(line)
    do i=nlm1,1,-1
      if (line(i:i).ne.'&') cycle    ! I
      ! This would no longer work if number of macro arguments is increased beyond 9
      k = ichar(line(i+1:i+1)) - ichar('0')
      if (k.lt.1 .or. k.gt.9) cycle  ! I
      if (mac1(l,k).eq.0 .or. len_trim(macarg(l)(mac1(l,k):mac2(l,k))).le.0) then
        ! No argument. Suppress &i
        if (line(i-1:i-1).eq.' '.and.line(i+2:i+2).eq.' ') then
          lv = -3                ! Was -3
        else
          lv = -2                ! Was -2
        endif
        !               line = line(1:i+lv+1) // line(i+2:)
        do j=i+2,nl,1
          line(j+lv:j+lv) = line(j:j)
        enddo
        line(nl+lv+1:nl) = ' '
        ! print *,"Line [",line(1:nl),"]",lv
      else                       ! Argument exists. Substitute
        lv = mac2(l,k)-mac1(l,k)-1
        !           line = line(1:i-1) // macarg(l)(mac1(l,k):mac2(l,k))
        !     +     // line(i+2:)
        if (lv.eq.0) then
          line(i:i+1) = macarg(l)(mac1(l,k):mac2(l,k))
        elseif (lv.lt.0) then
          line(i:i) = macarg(l)(mac1(l,k):mac2(l,k))
          do j=i+2,nl,1
            line(j+lv:j+lv) = line(j:j)
          enddo
          line(nl+lv+1:nl) = ' '
        else
          do j=nl,i+2,-1
            line(j+lv:j+lv) = line(j:j)
          enddo
          mv = min(i+lv+1,ml)
          line(i:mv) = macarg(l)(mac1(l,k):mac2(l,k))
        endif
      endif
      nl = nl+lv
      if (nl.gt.ml) then
        error=.true.
        return
      endif
    enddo                        ! I
  end subroutine sic_macros_replace_args
  !
end module sic_macros_interfaces
!
subroutine exemac(line,error)
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>exemac
  use sic_macros_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Execute a macro
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MACRO'
  character(len=filename_length) :: name,fich
  integer :: i,n,ier,ipt,nc
  character(len=message_length) :: mess
  character(len=4) ::ans
  logical :: found
  !
  ! Increase execution level
  if (nlire.ge.maxlev-1) then
    call sic_message(seve%e,rname,'Input level too deep')
    error = .true.
    return
  endif
  !
  ! Find the macro name and setup the arguments
  error = .false.
  call sic_ch (line,0,1,name,nc,.true.,error)
  if (error) return
  call find_procedure(name,fich,found)
  if (.not.found) then
    call sic_message(seve%e,rname,'No such procedure '//name)
    error = .true.
    return
  endif
  !
  ! Check for recursive calls
  do i=1,nmacro
    if (macnam(i).eq.fich) then
      call sic_message(seve%e,rname,'Recursive call to macro '//fich)
      error = .true.
      return
    endif
  enddo
  !
  ! Get LUN
  call sic_lunmac_get(nmacro+1,error)
  if (error) return
  !
  ! Increment levels
  nlire   = nlire + 1
  nmacro  = nmacro + 1
  mlire(nlire) = nmacro
  !
  ! Open the file and proceed
  macnam(nmacro) = fich
  ier = sic_open(lunmac(nmacro),macnam(nmacro),'OLD',.true.)
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Unable to open macro '//fich)
    call putios('          ',ier)
    goto 70
  endif
  !
  ! Define the macro arguments
  call sic_macros_parse_reset(nmacro,error)
  if (error)  return
  ipt = 1
  macarg(nmacro) = ' '
  if (sic_present(0,maxmacarg+2)) then
    write (mess,'(A,I2,A)') 'Too many macro arguments. Only ',maxmacarg,  &
    ' will be used'
    call sic_message(seve%w,rname,mess)
  endif
  manarg(nmacro) = 0
  do i=1,maxmacarg
    if (sic_present(0,i+1)) then
      mac1(nmacro,i) = ipt
      call sic_ch (line,0,i+1,macarg(nmacro)(ipt:),nc,.true.,error)
      if (error) then
         close(unit=lunmac(nmacro))
         goto 70
      endif
      mac2(nmacro,i) = ipt + nc -1
      if (mac2(nmacro,i).lt.mac1(nmacro,i)) then
        mac2(nmacro,i) = mac1(nmacro,i)+sic_len(0,i+1)
      endif
      ipt = mac2(nmacro,i)+2
      manarg(nmacro) = i
    else
      mac1(nmacro,i) = 0
      mac2(nmacro,i) = 0
    endif
  enddo
  var_level = nmacro
  var_macro(var_level) = var_n
  jmac (nmacro) = 0
  nerr(var_level) = nerr(0)
  errcom(var_level) = errcom(0)
  !
  ! Define the arguments as SIC Variables
  call sic_macros_variables
  !
  if (sic_stepin.ne.0) then
    if (.not.lverif) then
      print *,'---- Executing @ '//trim(macnam(nmacro))
      print *,'----',manarg(nmacro),' arguments'
      print *,'----'//trim(macarg(nmacro))
      if (sic_stepin.lt.0) call sic_wprn('Continue ? ',ans,n)
    endif
  endif
  error = .false.
  return
  !
  ! Error : reset the execution level and number of active macros
  !
70 call sic_lunmac_free(nmacro)
  nmacro = nmacro - 1
  nlire = nlire -1
  error = .true.
end subroutine exemac
!
subroutine endmac
  use sic_macros_interfaces
  use sic_interfaces, except_this=>endmac
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! End of macro execution
  !-----------------------------------------------------------------------
  !
  ! Close the unit and reset the active macro number
  close (unit=lunmac(nmacro))
  call sic_lunmac_free(nmacro)
  if (sic_stepin.ne.0) then
    print *,'---- Leaving @ '//trim(macnam(nmacro))
  endif
  errcom(nmacro) = ' '
  nerr  (nmacro) = 0
  nmacro = nmacro - 1
  !
  ! Delete all local variables :
  call erase_variables
  !
  ! Reset Arguments
  call sic_macros_variables
end subroutine endmac

module cubeio_readwrite_iterator
  use cubetools_parameters
  use cubetools_setup_types
  use cubeio_messaging
  use cubeio_cube
  use cubeio_range
  !---------------------------------------------------------------------
  ! Small utility which allows reading/writing data blocks to/from
  ! memory from/to file, by parts. Doing this by parts has some
  ! advantages (like trapping CTRL-C) with limited overheads.
  !
  ! Note: as of today this is implemented when reading the whole file
  ! from disk to memory (i.e. first touch in memory mode). On the other
  ! hand, we have no use case which writes the whole memory buffer to
  ! disk all at once. In particular, the EXPORT command is implemented
  ! by forcing the disk mode and iterating entries, which flushes
  ! blocks at regular intervals.
  !---------------------------------------------------------------------
  !
  type :: readwrite_iterator_t
    character(len=8),     private :: action
    integer(kind=data_k), private :: n3perblock
    integer(kind=data_k), private :: tf3,tl3     ! 3rd dimension total range to read
    integer(kind=data_k), public  :: first,last  ! 3rd dimension current range to read
    type(cubeio_range_t), public  :: range
  contains
    procedure, public :: init    => readwrite_iterator_init
    procedure, public :: iterate => readwrite_iterator_iterate
  end type readwrite_iterator_t

contains

  subroutine readwrite_iterator_init(iter,cubset,cube,action,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(readwrite_iterator_t), intent(inout) :: iter
    type(cube_setup_t),          intent(in)    :: cubset
    type(cubeio_cube_t),         intent(in)    :: cube
    character(len=*),            intent(in)    :: action
    logical,                     intent(inout) :: error
    !
    iter%action = action
    !
    call cube%plane_per_block(cubset%buff%block,'SET\BUFFER /BLOCK',  &
                              iter%n3perblock,error)
    if (error)  return
    !
    ! Note: it could also be possible to read a range on 3rd dimension
    ! instead of the whole cube
    iter%tf3 = 1
    iter%tl3 = cube%desc%n3
    !
    ! Prepare first iteration
    iter%range%blc(:) = 0
    iter%range%trc(:) = 0
    iter%last = iter%tf3-1
  end subroutine readwrite_iterator_init
  !
  function readwrite_iterator_iterate(iter,cube,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    logical :: readwrite_iterator_iterate
    class(readwrite_iterator_t), intent(inout) :: iter
    type(cubeio_cube_t),         intent(in)    :: cube
    logical,                     intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='READWRITE>ITERATOR'
    !
    readwrite_iterator_iterate = .false.
    if (iter%last.ge.iter%tl3)  return
    if (sic_ctrlc()) then
       call cubeio_message(seve%w,rname,trim(iter%action)//' aborted by user CTRL-C')
       error = .true.
       return
    endif
    !
    readwrite_iterator_iterate = .true.
    iter%first = iter%last+1
    iter%last  = min(iter%last+iter%n3perblock,iter%tl3)
    iter%range%blc(cube%desc%i3) = iter%first
    iter%range%trc(cube%desc%i3) = iter%last
    !
    write(mess,'(3(a,i0))')  &
      trim(iter%action)//' planes ',iter%first,' to ',iter%last,' over ',cube%desc%n3
    call cubeio_message(ioseve%others,rname,mess)
  end function readwrite_iterator_iterate
  !
end module cubeio_readwrite_iterator

  	subroutine curfit (y,npts,nterms,a,sigmaa,flambda,
     1 yfit,chisqr,eps,itmax,x,conv,weight,ipt,s0,wsum)
c
c assymmetric parabola in chi-square to keep fit below image
c
	common /termpointer/ lista,peak,cent,wid
	dimension lista(11),cent(3),wid(3)
	real*4 peak
      dimension y(1),a(11),sigmaa(11),yfit(1),x(3,1)
      dimension alpha(11,11),beta(11),deriv(11)
     1,b(11)
	real*4 tau(11)
	real*4 weight(1)
	integer ipt(1)
      real*8 array(11,11),det
	logical conv,bigger
	integer termou
	dimension s0(3)
	data tau /3*0.,0.003,2*1.e-2,1.,2*10.,.1,1./
	data termou/2/

	tau(8)=sqrt(wid(1))
	tau(9)=sqrt(wid(2))
	tau(10)=sqrt(wid(3))

	conv=.true.
  	chisqr=0.
      free=wsum-float(nterms)
      if(free) 110,110,20
c
c
20	s00=s0(1)
	sm=s0(2)/2.*free
	sc=s0(3)/2.*free
c	
      iter = 0
      fnu = 10.
      go to 34
c
c     test for convergence
c
   31 continue
	ddel=abs(a(1)-a(2))*(a(1)+a(2))/
     &       (wid(1)+wid(2)+0.5*(a(1)+a(2))**2)
	do 32 i=1,nterms
	 li=lista(i)
         del = abs(a(li)-b(li))
	if (li.le.3) then
	 del = del/abs(a(li)) / (1.+wid(li)/a(li)**2)
	else if (li.eq.4) then
	 del = del/(tau(li)+abs(a(li)))*ddel
	else if (li.eq.7 .or. li.eq.11) then
	 del = 2.*abs(a(li))*del/(1.+a(li)**2)
	else
         del = del/(tau(li)+abs(a(li)))
	endif
   32    if(del.gt.eps)iflag = 1
      if(iflag.eq.0)go to 101
      iflag = 0
      iter = iter + 1
      if(iter.gt.itmax)go to 101
      flambda=flambda/fnu
      do 33 j = 1,11
   33    a(j) = b(j)
c
c    evaluate alpha and beta matrices.
c
   34 continue
	do 35 j=1,nterms
	lj=lista(j)
	if (lj.eq.11) then
	  beta(j)=4.*sm*(peak-a(11)**2-a(7)**2)*a(11)
	else if (lj.eq.7) then
	  beta(j)=4.*sm*(peak-a(11)**2-a(7)**2)*a(7)
	else if(lj.ge.8) then
	  beta(j)=2.*sc*4.*(cent(lj-7)-a(lj))/wid(lj-7)
	else
          beta(j) = 0.
	endif
       do 35 k=1,j
	lk=lista(k)
	if ( (lk.eq.11 .or. lk.eq.7) .and. 
     &       (lj.eq.11 .or. lj.eq.7) ) then
	  alpha(j,k)=8.*sm*a(lk)*a(lj)
	else if (lk.ge.8 .and. lj.eq.lk) then
	  alpha(j,k)=2.*4.*sc/wid(lj-7)
	else
          alpha(j,k) = 0.
	endif
   35 continue
	call quadini (a)
      do 50 i=1,npts
      ix = ipt(i)
      call fderiv (ix,a,deriv,x,nterms,fff)
	yfit(ix)=fff
      res = (y(ix)-yfit(ix))
	rr=1.
	if (res.le.0.) rr=1.+s00
      do 46 j=1,nterms
	lj=lista(j)
      beta(j)=beta(j)+deriv(lj)*(res*weight(ix)*rr)
      do 46 k=1,j
	lk=lista(k)
   46 alpha(j,k)=
     &    alpha(j,k)+deriv(lj)*deriv(lk)*(weight(ix)*rr)
   50 continue
      do 53 j=1,nterms
      do 53 k=1,j
   53 alpha(k,j)=alpha(j,k)
c
c     evaluate chi square at starting point.
c
	if (chisqr.eq.0.) then
	  chisq1=
     &   fchisq(y,npts,free,yfit,weight,ipt,1.e30,bigger,s0,a)
	else
	      chisq1=chisqr
	endif
	write (termou,'(1x,a,1p,8g9.2)') 
     &    'chisqr ',chisq1,a(1),a(2),a(4),a(3),a(5),a(6)
c
c     invert modified curvature matrix to find new parameters.
c
      int = 0
   71 int = int + 1
ccc	if (flambda.gt.2390.) goto 116
      if(int-25)72,116,116
   72 do 74 j=1,nterms
      do 73 k=1,nterms
      if(alpha(j,j)*alpha(k,k).eq.0.0)go to 116
   73 array(j,k)=alpha(j,k)/sqrt(alpha(j,j)*alpha(k,k))
   74 array(j,j)=1.+flambda
      call matinv(array,nterms,det)
	do 85 j=1,11
85	b(j)=a(j)
      do 84 j=1,nterms
      lj=lista(j)
      do 83 k=1,nterms
   83 b(lj)=b(lj)+beta(k)*array(j,k)/sqrt(alpha(j,j)*alpha(k,k))
   84 continue

	d4=b(4)-a(4)
	d4=0.6*tanh(d4/0.6)
	b(4)=a(4)+d4

	do 22 i=1,3
	dd=b(i)-a(i)
	if (dd.lt.0.) then
		dd=0.5*a(i)*tanh(dd/a(i)/0.5)
		if (a(i).le.1.e-6) dd=0.
	endif
	b(i)=a(i)+dd
22	continue

	dd=b(11)-a(11)
	if (dd.lt.0.) then
		if (a(11).le.1.e-6) then
			dd=0.
		else
			dd=0.5*a(11)*tanh(dd/a(11)/0.5)
		endif
	endif
	b(11)=a(11)+dd

	dd=b(7)-a(7)
	if (dd.lt.0.) then
		if (a(7).le.1.e-6) then
			dd=0.
		else 
			dd=0.5*a(7)*tanh(dd/a(7)/0.5)
		endif
	endif
	b(7)=a(7)+dd

c
c
c     if chi square increased, increase flambda and try again.
	call quadini(b)
      do 92 i=1,npts
      ix = ipt(i)
   92 yfit(ix)=functn(ix,b,x,nterms)
      chisqr=
     &  fchisq(y,npts,free,yfit,weight,ipt,chisq1,bigger,s0,b)
	if (.not.bigger) goto 31
96   	flambda=flambda*fnu
      go to 71
c
  101 if(iter-itmax)103,102,102
  102 write(termou,111)iter
	conv=.false.
      go to 100
  103 write(termou,112)iter
c
c     compute error matrix
c
100	continue
c
c     evaluate the standard deviations of the parameters.
c
      do 105 j=1,nterms
  105    sigmaa(lista(j))=sqrt(array(j,j)/ alpha(j,j)*chisqr)
	do 106 j=1,11
106	a(j)=b(j)
  110 return
  111 format(/1x,'W-CURFIT, not converged after ',i3,' iterations',/)
  112 format(/1x,'I-CURFIT, converged after ',i3,' iterations ',/)
  115 format(1x,'W-CURFIT, no convergence in inner loop, or zero element
     *(s) in curvature matrix       =>bad initial guesses.')
  116 write(termou,115)
	write (termou,*) ' int ',int,' flambda ',flambda
	write (termou,*) ' a ',a
	write (termou,*) ' b ',b
	conv=.false.
      go to 110
	end
c       
 	subroutine matinv(array,norder,det)
	dimension array(11,11),ik(11),jk(11)
        real*8 array,amax,save,det
	det=1.0
	do 100 k=1,norder
c
c	find largest element in array
c 
	   amax=0.0
   21	   do 30 i=k,norder
		do 30 j=k,norder
		if(abs(amax)-abs(array(i,j)))24,24,30
   24           amax=array(i,j)
	        ik(k)=i
		jk(k)=j
   30      continue
c 
c	interchange rows and columns to put amax in array(k,k)
c
	   if(amax)41,32,41
   32      det=0.0
	   go to 140
   41      i=ik(k)
	   if(i-k)21,51,43
   43	   do 50 j=1,norder
	      save=array(k,j)
	      array(k,j)=array(i,j)
   50	   array(i,j)=-save
   51	   j=jk(k)
	   if(j-k)21,61,53
   53	   do 60 i=1,norder
	      save=array(i,k)
	      array(i,k)=array(i,j)
   60	   array(i,j)=-save
c
c	accumulate elements of inverse matrix
c
   61	   do 70 i=1,norder
	      if(i-k)63,70,63
   63	      array(i,k)=-array(i,k)/amax
   70	   continue
	   do 80 i=1,norder
	      do 80 j=1,norder
	         if(i-k)74,80,74
   74	         if(j-k)75,80,75
   75	         array(i,j)=array(i,j)+array(i,k)*array(k,j)
   80	   continue
	   do 90 j=1,norder
	      if(j-k)83,90,83
   83	      array(k,j)=array(k,j)/amax
   90	   continue
	   array(k,k)=1.0/amax
  100	det=det*amax
c
c	restore ordering of matrix
c
	do 130 l=1,norder
	   k=norder-l+1
	   j=ik(k)
	   if(j-k)111,111,105
  105	   do 110 i=1,norder
	      save=array(i,k)
	      array(i,k)=-array(i,j)
  110	   array(i,j)=save
  111	   i=jk(k)
	   if(i-k)130,130,113
  113	   do 120 j=1,norder
	      save=array(k,j)
	      array(k,j)=-array(i,j)
  120	   array(i,j)=save
  130	continue
  140	return
	end

	function 
     &   fchisq (y,npts,free,yfit,weight,ipt,chiold,bigger,s0,a)
	common /termpointer/ lista,peak,cent,wid
	dimension lista(11),cent(3),wid(3)
	real*4 peak
	dimension a(11)
	dimension y(1), yfit(1), weight(1), ipt(1)
	logical bigger
	dimension s0(3)
	bigger=.false.
	old=chiold
	chisq = 0.
	fchisq = 0.
	if (free) 13, 13, 20
13	fchisq = 0.
	goto 40
c
c	accumulate chi square
c
20	continue
	s00=s0(1)
	chisq=s0(2)*(peak-a(11)**2-a(7)**2)**2
	do 21 i=1,3
21	chisq=chisq+s0(3)*4.*(cent(i)-a(7+i))**2/wid(i)
	do 30 i=1,npts
	ip=ipt(i)
	res=y(ip)-yfit(ip)
	rr=1.
	if (res.le.0.) rr=1.+s00
	chisq=chisq+res**2*weight(ip)/free*rr
	if (chisq.gt.old) then
		bigger=.true.
		goto 40
	endif
30	continue
c
c	divide by number of degrees of freedom
c
32	fchisq = chisq
40	return
	end

subroutine sub_alma (   &
     &    l_method,l_hdirty,l_hresid,l_hclean,   &
     &    l_hbeam,l_hprim,l_tfbeam,l_list,   &
     &    c_method,c_hdirty,c_hresid,c_hclean,   &
     &    c_hbeam,c_hprim,c_tfbeam,c_list,   &
     &    error,tcc)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_alma
  use clean_def
  use image_def
  use gbl_message
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the Multi Resolution which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: l_method, c_method
  type (gildas), intent(inout)  :: l_hdirty, l_hbeam, l_hresid, l_hprim
  type (gildas), intent(inout)  :: l_hclean
  type (gildas), intent(inout)  :: c_hdirty, c_hbeam, c_hresid, c_hprim
  type (gildas), intent(inout)  :: c_hclean
  real, intent(inout) :: l_tfbeam(l_hbeam%gil%dim(2),l_hbeam%gil%dim(3),l_hbeam%gil%dim(1))
  real, intent(inout) :: c_tfbeam(c_hbeam%gil%dim(2),c_hbeam%gil%dim(3),c_hbeam%gil%dim(1))
  logical, intent(inout) :: error
  type (cct_par), intent(inout) :: tcc(l_method%m_iter)
  integer, intent(in) :: l_list(:)
  integer, intent(in) :: c_list(:)
  !
  real, pointer :: c_dirty(:,:)    ! Dirty map
  real, pointer :: c_resid(:,:)    ! Iterated residual
  real, pointer :: c_clean(:,:)    ! Clean Map
  real, pointer :: c_dprim(:,:,:)  ! Primary beam
  real, pointer :: c_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: c_weight(:,:)
  !
  real, pointer :: l_dirty(:,:)    ! Dirty map
  real, pointer :: l_resid(:,:)    ! Iterated residual
  real, pointer :: l_clean(:,:)    ! Clean Map
  real, pointer :: l_beam(:,:) ! Beam for fit
  real, pointer :: l_dprim(:,:,:)  ! Primary beam
  real, pointer :: l_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: l_weight(:,:)
  !
  real, allocatable :: w_fft(:) ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  complex, allocatable :: c_work(:,:)  ! Expansion of residual
  real, allocatable :: r_work(:,:) ! Expansion of residual
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable, target :: sc_beam(:,:,:)
  real, allocatable :: w_resid(:,:)
  !
  character(len=*), parameter :: rname='SUB_ALMA'
  !
  integer iplane,ibeam
  integer nx,ny,np,mx,my,mp,nc,kx,ky
  integer ip, ier
  real l_max, c_max
  logical do_fft, ok
  character(len=80) :: chain
  character(len=2) ans
  integer nker,mker
  parameter (mker=11)
  real smooth
  real, allocatable :: kernel(:,:),kernels(:,:,:)
  real noise,value,scale,fhat,long,compact
  !
  error = .false.
  do_fft = .true.
  !
  ! Local variables
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  np = l_hprim%gil%dim(1)
  mx = c_hbeam%gil%dim(1)
  my = c_hbeam%gil%dim(2)
  mp = c_hprim%gil%dim(1)
  nc = nx*ny
  !
  allocate (w_work(nx,ny),r_work(nx,ny),c_work(mx,my), &
       & w_fft(max(nx,ny)),w_comp(nc), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on ALMA arrays')
    error = .true.
    return
  endif
  !
  ! Smoothed version of the Compact images
  allocate (sc_beam(mx,my,mp),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on ACA arrays')
    error = .true.
    return
  endif
  ! Global residuals
  allocate (w_resid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on residuals')
    error = .true.
    return
  endif
   !
  ! Some global pointers
  l_dprim => l_hprim%r3d
  l_dbeam => l_hbeam%r3d
  l_weight=> l_method%weight(:,:,1)
  c_dprim => c_hprim%r3d
  c_dbeam => c_hbeam%r3d       ! To begin with
  c_weight=> c_method%weight(:,:,1)
  !
  ! Relative noise contributions
  long = l_hdirty%gil%noise**2
  compact = c_hdirty%gil%noise**2
  scale = long+compact
  long = long/scale
  compact = compact/scale
  !
  ! Initialize the kernel
  smooth = c_method%smooth
  if (smooth.eq.0) then
     nker = 1
  else
     nker = mker
  endif
  allocate (kernels(nker,nker,mp),kernel(nker,nker),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on Kernels')
    error = .true.
    return
  endif
  call init_kernel(kernel,nker,nker,smooth)
  !
  ! Initialize smoothed beams
  do ip=1,mp
     call smooth_kernel (c_dbeam(:,:,ip),sc_beam(:,:,ip),   &
          &      mx,my,nker,nker,kernel)
  enddo
  !
  ! Renormalize the beams. Have some difficulty here, because the
  ! factor isn't quite the same for each primary beam...
  !
  kx = mx/2+1
  ky = my/2+1
  noise = 0.0
  do ip=1,mp
    value = 1.0/sc_beam(kx,ky,ip)
    noise = noise + value
    sc_beam(:,:,ip) = sc_beam(:,:,ip) * value
    kernels(:,:,ip) = kernel*value
  enddo
  scale = noise/float(mp)      ! Kernel scaling factor
  kernel= kernel * scale       ! Mean smoothing kernel ...
  noise = sqrt(scale*compact/long) ! Mean noise RATIO
  !!
  !!      CALL SMOOTH_MASK (SC_MASK,C_METHOD%MASK,MX,MY,KERNEL,NKER)
  !
  ! Move pointer towards the Smoothed Compact Beams
  ! This allow to perform a "normal" deconvolution with the Smoothed
  ! Compact Beam
  c_hbeam%r3d => sc_beam
  !
  ! Loop here if needed
  do iplane = l_method%first, l_method%last
    l_method%flux = 0.0
    c_method%flux = 0.0
    l_method%n_iter= 0
    c_method%n_iter= 0
    !
    l_method%iplane = iplane
    c_method%iplane = iplane
    call beam_plane(l_method,l_hbeam,l_hdirty)
    ibeam = l_method%ibeam
    !
    ! Local aliases
    l_dirty => l_hdirty%r3d(:,:,iplane)
    l_resid => l_hresid%r3d(:,:,iplane)
    l_clean => l_hclean%r3d(:,:,iplane)
    l_beam  => l_hbeam%r3d(:,:,ibeam)
    !
    c_dirty => c_hdirty%r3d(:,:,iplane)
    c_resid => c_hresid%r3d(:,:,iplane)
    c_clean => c_hclean%r3d(:,:,iplane)
    !
    ! Initialize to Dirty map
    l_resid = l_dirty
    !
    ! C_RESID is now the Smoothed Compact Residual
    call smooth_kernel(c_dirty,c_resid,mx,my,nker,nker,kernel)
    !NO!         CALL SMOOTH_MASKED(C_DIRTY,C_RESID,MX,MY,KERNEL,
    !!     $   NKER,C_METHOD%MASK)
    !
    ! Prepare beam parameters
    call get_clean (l_method, l_hbeam, l_beam, error)
    if (error) return
    call get_beam (l_method,l_hbeam,l_hresid,l_hprim,   &
        &        l_tfbeam,w_work,w_fft,fhat,error)
    if (error) return
    !
    call get_beam (c_method,c_hbeam,c_hresid,c_hprim,   &
        &        c_tfbeam,w_work,w_fft,fhat,error)
    if (error) return
    !
    ! Apply the Weight
    l_resid = l_resid * l_weight
    c_resid = c_resid * c_weight
    call mrc_plot(c_weight,mx,my,1,'Weight')
    !
    ! Performs decomposition into components:
    ! Only one major cycle per iteration, with a limited number
    ! of components ?
    !
    l_method%ngoal = 1000
    c_method%ngoal = 100
    call sic_get_inte ('C_GOAL',c_method%ngoal,error)
    !
    ! Locate the maximum of the Compact & Normal images
    l_max = amaxlst (l_method,l_list,l_resid,nx,ny)
    c_max = amaxlst (c_method,c_list,c_resid,mx,my)
    ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
    do while (ok)
      !
      ! Plot for debug
      if (l_method%pcycle) then
        call mrc_plot(c_resid,mx,my,2,'Compact')
        call mrc_plot(l_resid,nx,ny,3,'Long')
      endif
      !
      ! NOISE is the Noise RATIO (mean value over the beams)
      !
      if (l_max.gt.c_max/noise) then
        write(chain,*) 'LONG baselines ',   &
            &          l_max,c_max/noise,noise
        call gagout(chain)
        if (l_method%qcycle) then
          call sic_wpr('WAIT ? ',ans)
        endif
        !
        ! Find components in LONG baseline image
        call one_cycle90 (l_method,l_hclean,   &   !
            &          l_clean,   &   ! Final CLEAN image
            &          l_dbeam,   &   ! Dirty beams
            &          l_resid,nx,ny,   & ! Residual and size
            &          l_tfbeam, w_work,   &  ! FT of dirty beam + Work area
            &          w_comp, nc,         &  ! Component storage + Size
            &          l_method%beam0(1),l_method%beam0(2),   &   ! Beam center
            &          l_method%patch(1),l_method%patch(2),   &
            &          l_method%bgain,l_method%box,   &
            &          w_fft,   &     ! Work space for FFTs
            &          tcc,   &       ! Component table
            &          l_list, l_method%nlist,   & ! Search list
            &          np,   &        ! Number of fields
            &          l_dprim,   &   ! Primary beams
            &          l_weight,   &  ! Weight
            &          l_max)
        !
        ! Define component type
        tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
        ! Remove from COMPACT baselines
        call remove_inother(c_method,c_resid,mx,my,   &
            &          c_tfbeam, w_fft,mp,c_dprim,c_weight,   &
            &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny,   &
            &          kernel, nker)
        ! Define number of iterations
        c_method%n_iter = l_method%n_iter
        c_method%flux = l_method%flux
      else
        write (chain,*) 'COMPACT baselines ',   &
            &          l_max,c_max/noise,noise
        call gagout(chain)
        if (l_method%qcycle) then
          call sic_wpr('WAIT ? ',ans)
        endif
        !
        ! Find components in COMPACT baseline image
        call one_cycle90 (c_method,c_hclean,   &   !
            &          c_clean,   &   ! Final CLEAN image
            &          sc_beam,   &   ! (Smoothed) Dirty beams
            &          c_resid,mx,my,          &    ! Residual and size
            &          c_tfbeam, w_work,       &    ! FT of dirty beam + Work area
            &          w_comp, nc,             &    ! Component storage + Size
            &          c_method%beam0(1),c_method%beam0(2),   &   ! Beam center
            &          c_method%patch(1),c_method%patch(2),   &   ! Patch
            &          c_method%bgain,c_method%box,   &
            &          w_fft,    &    ! Work space for FFTs
            &          tcc,      &     ! Component table
            &          c_list, c_method%nlist,   & ! Search list
            &          mp,       &    ! Number of fields
            &          c_dprim,  &    ! Primary beams
            &          c_weight, &    ! Weight
            &          c_max)
        ! Define component type
        tcc(l_method%n_iter+1:c_method%n_iter)%type = 1
        ! Remove from LONG baselines
        call remove_inother(l_method,l_resid,nx,ny,   &
            &          l_tfbeam, w_fft, np,l_dprim,l_weight,   &
            &          tcc,l_method%n_iter+1,c_method%n_iter,mx,my,   &
            &          kernel, nker)
        ! Define number of components
        l_method%n_iter = c_method%n_iter
        l_method%flux = c_method%flux
      endif
      ! Stop if done
      l_max = amaxlst (l_method,l_list,l_resid,nx,ny)
      c_max = amaxlst (c_method,c_list,c_resid,mx,my)
      ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
      if (l_method%n_iter.ge.l_method%m_iter) ok = .false.
    enddo
    !
    ! Add clean components and residuals to produce clean map
    ! Note that the Kernel is still scaled in the same way as before
    if (l_method%n_iter.ne.0) then
      call alma_make90 (l_method, l_hclean, c_hclean,   &
           &        tcc, kernel, nker)
    else
      l_clean = 0
    endif
    !
    ! Which residual should be added ?...
    ! We don't want to add noise, but to combine it properly...
    ! We may need to go to the full combined gridding business here...
    l_clean = l_clean + l_resid * l_weight * long
    c_clean = c_resid * c_weight * compact
    call expand (nx,ny,r_work,w_work,mx,my,c_clean,c_work,w_fft)
    l_clean = l_clean + r_work
  enddo
end subroutine sub_alma
!
function amaxlst (method,list,resid,nx,ny)
  use clean_def
  use mapping_interfaces, only : maxlst
  !-----------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !-----------------------------------------------------
  real amaxlst      ! intent(out)
  type (clean_par), intent(inout) :: method
  integer, intent(in) :: nx,ny
  integer, intent(in) :: list(:)
  real, intent(in) :: resid(nx,ny)
  !
  real maxc, minc, maxabs
  integer imin,imax,jmin,jmax
  !
  call maxlst (resid,nx,ny,list,method%nlist,   &
       &    maxc,imax,jmax,minc,imin,jmin)
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
  else
    maxabs=abs(maxc)
  endif
  amaxlst = maxabs
end function amaxlst
!
subroutine one_cycle90 (method,head,   &
     &    clean,beam,resid,nx,ny,tfbeam,fcomp,   &
     &    wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,   &
     &    box, work, tcc, list, nl, nf, primary, weight, maxabs)
  use clean_def
  use image_def
  use gbl_message
  use mapping_interfaces, except_this=>one_cycle90
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Major cycle loop according to B.Clark idea
  !----------------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: head
  !
  integer, intent(in) ::  nf,nx,ny,mcl,nl
  real, intent(inout) ::  clean(nx,ny)
  real, intent(inout) ::  resid(nx,ny)
  real, intent(in) ::     beam(nx,ny,nf)
  real, intent(inout) ::  tfbeam(nx,ny,nf)     ! T.F. du beam  Complex ?
  complex, intent(inout) :: fcomp(nx,ny)       ! T.F. du vecteur modification
  type(cct_par), intent(inout) ::  wcl(mcl)
  real, intent(in) ::  bgain                   ! Maximum sidelobe level
  integer, intent(in) ::  ixbeam, iybeam       ! Beam maximum position
  integer, intent(in) ::  ixpatch, iypatch     ! Beam patch radius
  integer, intent(in) ::  box(4)               ! Cleaning box
  real, intent(inout) ::  work(*)                 ! Work space for FFT
  type(cct_par), intent(inout) :: tcc(method%m_iter) ! Clean components array
  integer, intent(in) ::  list(nl)
  !
  real, intent(in) ::  primary(nf,nx,ny)       ! Primary beams
  real, intent(in) ::  weight (nx,ny)
  !
  real    maxabs               !max et min de la carte, absolute
  real    borne                !fraction de la carte initiale
  real    limite               !intensite minimum des pts retenus
  real    clarkl
  !!      REAL FLUX                          !Total clean flux density
  integer ncl                  !nb de pts reellement retenus
  logical fini                 !critere d'arret
  logical converge             ! Indique la conv par acc de flux
  integer kcl
  character(len=message_length) :: chain
  character(len=*), parameter :: rname = 'CLARK'
  !
  ! Maximum residual is already located, MAXABS
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  !
  ! ONE Major cycle
  !
  ! Define minor cycle limit
  limite = max(maxabs*bgain,0.8*borne)
  clarkl = maxabs*bgain
  !!      PRINT *,'Limits ',MAXABS,LIMITE,CLARKL
  !
  kcl = mcl
  !
  ! Select points of maximum strength and load them in
  call choice (   &
       &    resid,   &           ! Current residuals
       &    nx,ny,   &           ! image size
       &    list, nl,   &        ! Search list
       &    limite,   &          ! Detection threshold
       &    kcl,   &             ! Maximum number of candidates
       &    wcl,   &             ! Selected candidate components
       &    ncl,   &             ! Selected Number of components
       &    maxabs, method%ngoal)
  !
  if (ncl.gt.0) then
     write(chain,100) 'Selected ',ncl,' points above ',limite
     call map_message(seve%i,rname,chain)
     !
     ! Make minor cycles
     call minor_cycle90 (method,   &
          &      wcl,          &    ! Original candidate components
          &      ncl,          &    ! Number of candidates
          &      beam,nx,ny,   &    ! Dirty beams and Size
          &      ixbeam,iybeam,   & ! Beam center
          &      ixpatch,iypatch,   &   ! Beam patch
          &      clarkl,limite,   &
          &      converge,   &      !
          &      tcc,   &           ! Cumulated components
          &      nf, primary, weight, method%trunca,   &
          &      method%flux,   &   ! Total Flux
          &      method%pflux, next_flux90)
     !
     ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
     call remisajour (nx*ny,   &    ! Total size
          &      clean,   &         ! CLEAN map used as work space
          &      resid,   &         ! Updated residuals
          &      tfbeam,   &        ! Beam TF
          &      fcomp,   &         ! Work space for Component TF
          &      wcl,     &         ! Clean flux values
          &      ncl,   &           ! Number of Clean Components
          &      nx,ny,   &         ! Map size
          &      work,   &          ! FFT work space
          &      nf, primary, weight, method%trunca)
     write (chain,101)  'Cleaned ',method%flux,' Jy with ',   &
          &      method%n_iter,' clean components'
     call map_message(seve%i,rname,chain)
  else
     ! No component found: finish...
     write(chain,101) 'No points selected above ',limite
     call map_message(seve%i,rname,chain)
  endif
  write(chain,102)  'CLEAN found ',method%flux,' Jy in ',   &
       &    method%n_iter,' clean components'
  call map_message(seve%i,'CLEAN',chain)
  !
100 format (a,i6,a,1pg10.3,a)
101 format (a,1pg10.3,a,i7,a)
102 format (a,1pg10.3,a,i7,a)
end subroutine one_cycle90
!
subroutine remove_inother(method,resid,nx,ny,tfbeam,wfft,   &
     &    np,primary,weight,   &
     &    tcc,first,last,mx,my,kernel,nker)
  use clean_def
  use gkernel_interfaces, only : fourt
  use mapping_interfaces, except_this=>remove_inother
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for ALMA deconvolution
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  !
  integer, intent(in) ::  np,nx,ny,mx,my,nker,first,last
  real, intent(inout) ::  resid(nx,ny)
  real, intent(inout) ::  tfbeam(nx,ny,np)     ! T.F. du beam  Complex ?
  real, intent(in) :: primary(np,nx,ny)
  real, intent(in) :: weight(nx,ny)
  real, intent(inout) :: kernel(nker,nker)
  real, intent(inout) :: wfft(*)
  type(cct_par), intent(inout) :: tcc(last)
  !
  complex, allocatable :: icomp(:,:), ocomp(:,:)
  real, allocatable :: clean(:,:), prim(:,:), sky(:,:)
  real, allocatable :: ricomp(:,:),rocomp(:,:)
  real wtrun,val,fact
  integer k,ndim,nn(2),ip,ix,iy,ier
  integer jx,jy,xfact,yfact,firstx,lastx,firsty,lasty
  logical comp
  character(len=2) :: ans
  !
  wtrun = method%trunca
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  allocate (ocomp(nx,ny),stat=ier)
  allocate (icomp(mx,my),stat=ier)
  allocate (clean(nx,ny),stat=ier)
  allocate (ricomp(mx,my),stat=ier)
  allocate (rocomp(nx,ny),stat=ier)
  allocate (sky(nx,ny),stat=ier)
  allocate (prim(nx,ny),stat=ier)
  !
  comp = mx.gt.nx
  fact = float(mx*my)/float(nx*ny)
  xfact = nx/mx
  yfact = ny/my
  !
  ! Optimized by using CLEAN to store sum of components before multiplying
  ! by the weights to subtract from the Residuals
  clean = 0.0
  ricomp = 0.0
  do k=first,last
    ix = tcc(k)%ix
    iy = tcc(k)%iy
    val = tcc(k)%value * fact
    if (tcc(k)%type.eq.0) then
      ricomp(ix,iy) = ricomp(ix,iy) + val
    else
      call add_kernel (ricomp,mx,my,val,ix,iy,nker,nker,kernel)
    endif
  enddo
  !
  ! Add compression and/or expansion
  if (comp) then
    call compress(mx,my,ricomp,icomp,nx,ny,rocomp,ocomp,wfft)
  else
    !
    ! Expand by XFACT & YFACT
    rocomp = 0.0
    do k=first,last
      ix = tcc(k)%ix
      iy = tcc(k)%iy
      val = tcc(k)%value * fact
      lastx = xfact*ix
      lasty = yfact*iy
      firstx = lastx-xfact+1
      firsty = lasty-yfact+1
      do jy=firsty,lasty
        do jx=firstx,lastx
          rocomp(jx,jy) = rocomp(jx,jy)+val
        enddo
      enddo
      !!            CALL ADD_KERNEL (RICOMP,MX,MY,VAL,IX,IY,KERNEL,NKER)
    enddo
  endif
  sky = rocomp
  if (method%pcycle) then
    call mrc_plot(weight,nx,ny,1,'Weight')
    call mrc_plot(resid,nx,ny,2,'Resid')
    call mrc_plot(sky,nx,ny,3,'Sky')
    !         if (method%qcycle) call sic_wpr('Continue',ans)
  endif
  !
  ! Loop on the fields
  do ip=np,1,-1
    prim = primary(ip,:,:)
    if (method%pcycle) call mrc_plot(prim,nx,ny,1,'Primary')
    !
    ! Multiply by Complete Primary beam...
    rocomp = sky*prim
    !
    ! Convolve with dirty beam
    ocomp = cmplx(rocomp,0.0)
    call fourt(ocomp,nn,ndim,-1,0,wfft)
    rocomp = tfbeam(:,:,ip)
    ocomp = ocomp*rocomp
    call fourt(ocomp,nn,ndim,1,1,wfft)
    rocomp = real(ocomp)
    !
    ! Multiply by Truncated Primary beam now
    where (prim.lt.wtrun)
      prim = 0
    end where
    rocomp = rocomp*prim
    if (method%pcycle) call mrc_plot(rocomp,nx,ny,3,'Comp...')
    clean(:,:) = clean + rocomp
  enddo
  if (method%pcycle) then
    !         if (method%qcycle) call sic_wpr('Continue',ans)
    call mrc_plot(clean,nx,ny,3,'Clean')
    call mrc_plot(resid,nx,ny,1,'Residu')
  endif
  resid(:,:) = resid - clean*weight
end subroutine remove_inother
!
subroutine add_primker (clean,nx,ny,np,prim,value,kx,ky,kp,ker,nk)
  !-----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Smooth an array using a kernel, with Primary Beams
  !   For ALMA deconvolution
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx,ny,np             ! Image size
  real, intent(in) :: value                   ! Input value
  real, intent(inout) :: clean(nx,ny)         ! Summed output array
  real, intent(in) :: prim(np,nx,ny)
  integer, intent(in) :: kp                   ! Field
  integer, intent(in) :: kx,ky                ! Center of value
  integer, intent(in) :: nk                   ! Kernel size
  real, intent(in) :: ker(nk,nk)
  !
  integer i,j,lk,li,lj
  !
  if (nk.eq.1) then
    clean(kx,ky) = clean(kx,ky) + prim(kp,kx,ky)*value
  else
    lk = (nk-1)/2
    do j=ky-lk,ky+lk
      lj = j-ky+lk+1
      do i=kx-lk,kx+lk
        li = i-kx+lk+1
        clean(i,j) = clean(i,j) + prim(kp,i,j) *   &
              &          ker (li,lj) * value
      enddo
    enddo
  endif
end subroutine add_primker
!
subroutine alma_make90 (method, l_hclean, c_hclean,   &
     &    tcc, kernel,nker)
  use gkernel_interfaces, only : fourt
  use clean_def
  use image_def
  use mapping_gaussian_tool
  !-------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Make clean map
  !-------------------------------------------------------------
  integer, intent(in) :: nker
  real, intent(in) :: kernel(nker,nker)
  type (clean_par), intent(inout) :: method
  type (gildas), intent(inout) :: l_hclean, c_hclean
  type (cct_par), intent(in) :: tcc(method%n_iter)
  !
  real(8), parameter :: pi=3.141592653589793d0
  integer nx,ny,ix,iy,ic,ndim,nn(2),ier, iplane,mx,my
  real xinc, yinc,fact,val
  real, pointer :: l_clean(:,:), c_clean(:,:)
  real, allocatable :: wfft(:)
  complex, allocatable :: fcomp(:,:), c_work(:,:)
  !
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  mx = c_hclean%gil%dim(1)
  my = c_hclean%gil%dim(2)
  iplane = method%iplane
  l_clean => l_hclean%r3d(:,:,iplane)
  c_clean => c_hclean%r3d(:,:,iplane)
  !
  allocate (wfft(2*max(nx,ny)),stat=ier)
  allocate (fcomp(nx,ny),stat=ier)
  allocate (c_work(mx,my),stat=ier)
  xinc = l_hclean%gil%convert(3,1)
  yinc = l_hclean%gil%convert(3,2)
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  ! First pass for Compact Baselines
  c_clean = 0.0
  fact = float(nx*ny)/float(mx*my)
  do ic=1,method%n_iter
    if (tcc(ic)%type.ne.0) then
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      val = tcc(ic)%value * fact
      call add_kernel (c_clean,mx,my,val,ix,iy,   &
           &        nker,nker,kernel)
    endif
  enddo
  !
  ! Expand the Compact Clean Components
  call expand (nx,ny,l_clean,fcomp,mx,my,c_clean,c_work,wfft)
  !
  ! Add the Long Baseline components
  do ic=1,method%n_iter
    if (tcc(ic)%type.eq.0) then
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      val = tcc(ic)%value
      l_clean(ix,iy) = l_clean(ix,iy) + val
    endif
  enddo
  !
  ! Convolve by Gaussian
  fcomp = cmplx(l_clean,0.0)
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  fact = method%major*method%minor*pi/(4.0*log(2.0))   &
       &    /abs(xinc*yinc)/(nx*ny)
  call mulgau(fcomp,nx,ny,   &
       &    method%major,method%minor,method%angle,   &
       &    fact,xinc,yinc)
  call fourt(fcomp,nn,ndim,1,1,wfft)
  l_clean = real(fcomp)
end subroutine alma_make90

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_timing
  use cubetools_structure
  use cubesyntax_key_types
  use cubetools_switch_types
  use cubeset_messaging
  !
  public :: timing
  private
  !
  type :: timing_comm_t
     type(option_t), pointer :: comm
     type(switch_comm_t) :: io
     type(switch_comm_t) :: execution
     type(key_comm_t)    :: default
   contains
     procedure, public  :: register => cubeset_timing_register
     procedure, private :: parse    => cubeset_timing_parse
     procedure, private :: main     => cubeset_timing_main
  end type timing_comm_t
  type(timing_comm_t) :: timing
  !
  type :: timing_user_t
     logical :: list
     type(switch_user_t) :: io
     type(switch_user_t) :: execution
     type(key_user_t)    :: default
   contains
     procedure, private :: toprog => cubeset_timing_user_toprog
  end type timing_user_t
  !
  type :: timing_prog_t
     logical :: list
     type(switch_prog_t) :: io
     type(switch_prog_t) :: execution
     type(key_prog_t)    :: default
   contains
     procedure, private :: act => cubeset_timing_prog_act
  end type timing_prog_t
  !
contains
  !
  subroutine cubeset_timing_command(line,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(timing_user_t) :: user
    character(len=*), parameter :: rname='TIMING>COMMAND'    
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call timing%parse(line,user,error)
    if (error) return
    call timing%main(user,error)
    if (error) return
  end subroutine cubeset_timing_command
  !  
  !----------------------------------------------------------------------
  !
  subroutine cubeset_timing_register(timing,error)
    use cubetools_parameters
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(timing_comm_t), intent(inout) :: timing
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TIMING>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'TIMING','',&
         'Enable or disable timing feedback at the end of processing',&
         'Default is OFF. Two topics are available: /EXECUTION for&
         & execution times, and /IO for data Input and Output,&
         & Default values can be reset with option /DEFAULT. TIMING&
         & without any options displays the current timing setup.&
         & When /DEFAULT is combined with other keys on the same command&
         & line, reset is applied first.',&
         cubeset_timing_command,&
         timing%comm,&
         error)
    if (error) return
    !
    call timing%io%register(&
         'IO',&
         'IO timing',&
         'OFF',&
         strg_emp,&
         error)
    if (error) return
    !
    call timing%execution%register(&
         'EXECUTION',&
         'execution timing',&
         'OFF',&
         strg_emp,&
         error)
    if (error) return
    !
    call timing%default%register(&
         'DEFAULT',&
         'Reset settings',&
         'Reset timing settings before applying other keys from the same&
         & command line.',&
         error)
    if (error) return
  end subroutine cubeset_timing_register
  !
  subroutine cubeset_timing_parse(comm,line,user,error)
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(timing_comm_t), intent(inout) :: comm
    character(len=*),     intent(in)    :: line
    type(timing_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TIMING>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    user%list = cubetools_nopt().eq.0
    !
    if (user%list) then
       ! nothing to do
    else
       call comm%io%parse(line,user%io,error)
       if (error) return
       call comm%execution%parse(line,user%execution,error)
       if (error) return
       call comm%default%parse(line,user%default,error)
       if (error) return
    endif
  end subroutine cubeset_timing_parse
  !
  subroutine cubeset_timing_main(comm,user,error)
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(timing_comm_t), intent(inout) :: comm
    type(timing_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(timing_prog_t) :: prog
    character(len=*), parameter :: rname='TIMING>MAIN'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubeset_timing_main
  !
  !-----------------------------------------------------------------------
  !
  subroutine cubeset_timing_user_toprog(user,comm,prog,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(timing_user_t), intent(in)    :: user
    type(timing_comm_t),  intent(in)    :: comm
    type(timing_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TIMING>USER>TOPROG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    prog%list = user%list
    call user%io%toprog(comm%io,prog%io,error)
    if (error) return
    call user%execution%toprog(comm%execution,prog%execution,error)
    if (error) return
    call user%default%toprog(comm%default,prog%default,error)
    if (error) return
  end subroutine cubeset_timing_user_toprog
  !
  !-----------------------------------------------------------------------
  !
  subroutine cubeset_timing_prog_act(prog,error)
    use cubetools_setup_types
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(timing_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TIMING>PROG>ACT'
    type(cube_setup_api_t) :: setup
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (prog%default%act)   call setup%timing%reset()
    if (prog%io%act)        call setup%timing%io%set(prog%io%enabled,error)
    if (prog%execution%act) call setup%timing%command%set(prog%execution%enabled,error)
    if (prog%list) then
       call cubeset_message(seve%r,rname,'  Timing')
       prog%io%action = 'IO'
       call setup%timing%io%get(prog%io%enabled)
       call prog%io%list(error)
       if (error) return
       prog%execution%action = 'EXECUTION'
       call setup%timing%command%get(prog%execution%enabled)
       call prog%execution%list(error)
       if (error) return       
    endif    
  end subroutine cubeset_timing_prog_act
end module cubeset_timing
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_aperture
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubesyntax_keyval_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubetopology_spaelli_types
  use cubemain_messaging
  use cubemain_stack_spectra_tool
  !
  public :: aperture
  private
  !
  type :: aperture_comm_t
     type(option_t), pointer     :: comm
     type(cuberegion_comm_t)     :: region
     type(spaelli_comm_t)        :: ellipse
     type(stack_spectra_comm_t)  :: stack
     type(keyval_dble_comm_t)    :: background
     type(cubeid_arg_t), pointer :: cube
     type(cube_prod_t),  pointer :: spectrum
   contains
     procedure, public  :: register => cubemain_aperture_comm_register
     procedure, private :: parse    => cubemain_aperture_comm_parse
     procedure, private :: main     => cubemain_aperture_comm_main
  end type aperture_comm_t
  type(aperture_comm_t) :: aperture
  !
  type aperture_user_t
     type(cubeid_user_t)        :: cubeids
     type(cuberegion_user_t)    :: region
     type(spaelli_user_t)       :: ellipse
     type(stack_spectra_user_t) :: stack
     type(keyval_dble_user_t)   :: background
   contains
     procedure, private :: toprog => cubemain_aperture_user_toprog
  end type aperture_user_t
  !
  type aperture_prog_t
     type(cuberegion_prog_t)    :: region             ! Cube region of interest
     type(spaelli_prog_t)       :: ellipse            ! Aperture geometry and position
     type(stack_spectra_prog_t) :: stack              ! Stacking options
     real(kind=coor_k)          :: backdiamfact = 0d0 ! Background diameter factor
     type(cube_t), pointer      :: cube               ! Input cube
     type(cube_t), pointer      :: spectrum           ! Output spectrum
   contains
     procedure, private :: header => cubemain_aperture_prog_header
     procedure, private :: data   => cubemain_aperture_prog_data
     procedure, private :: loop   => cubemain_aperture_prog_loop
     procedure, private :: act    => cubemain_aperture_prog_act
  end type aperture_prog_t
  !
contains
  !
  subroutine cubemain_aperture_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(aperture_user_t) :: user
    character(len=*), parameter :: rname='APERTURE>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call aperture%parse(line,user,error)
    if (error) return
    call aperture%main(user,error)
    if (error) continue
  end subroutine cubemain_aperture_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_aperture_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='APERTURE>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'APERTURE','[cubeid]',&
         'Stack spectra within a given aperture',&
         'APERTURE stacks spectra inside a user-defined spatial aperture.'&
         //strg_bl//&
         'Behavior:'//strg_cr//&
         '- Default aperture geometry is beam-driven and centered on the&
         & projection center.'//strg_cr//&
         '- Spatial and spectral selection is controlled by /SIZE, /CENTER,&
         & and /RANGE.'//strg_cr//&
         '- Stacking mode and local background handling are controlled by&
         & /SUM, /MEAN, and /BACKGROUND.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> APERTURE cube:co'//strg_cr//&
         'CUBE> APERTURE cube:co /DIAMETER 30 arcsec /MEAN'//strg_cr//&
         'CUBE> APERTURE cube:co /CENTER 0 0 relative /RANGE -5 5 km/s',&
         cubemain_aperture_command,&
         comm%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    !
    call comm%ellipse%register(&
         'DIAMETER',&
         'Define the aperture ellipse axis diameters and position angle',&
         'POSITION',&
         'Define the aperture position',&
         error)
    if (error) return
    call comm%stack%register(error)
    if (error) return
    call comm%background%register(&
         'BACKGROUND',&
         'Set annulus scale for local background subtraction',&
         'Set the multiplicative factor applied to aperture diameters when&
         & defining the background annulus. Use "*" to keep the default&
         & factor (2.0).',&
         2d0,&
         error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'APERTURE',&
         'The aperture spectrum',&
         'Stacked output spectrum for the selected aperture.',&
         [flag_aperture,flag_spectrum],&
         comm%spectrum,&
         error,&
         access=code_access_imaset)
    if (error) return
  end subroutine cubemain_aperture_comm_register
  !
  subroutine cubemain_aperture_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! APERTURE [cubeid]
    !----------------------------------------------------------------------
    class(aperture_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(aperture_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='APERTURE>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
    call comm%ellipse%parse(line,user%ellipse,error)
    if (error) return
    call comm%stack%parse(line,user%stack,error)
    if (error) return
    call comm%background%parse(line,user%background,error)
    if (error) return
  end subroutine cubemain_aperture_comm_parse
  !
  subroutine cubemain_aperture_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_comm_t), intent(in)    :: comm
    type(aperture_user_t),  intent(in)    :: user
    logical,                intent(inout) :: error
    !
    type(aperture_prog_t) :: prog
    character(len=*), parameter :: rname='APERTURE>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_aperture_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_aperture_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_user_t), intent(in)    :: user
    type(aperture_comm_t),  intent(in)    :: comm
    type(aperture_prog_t),  intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(keyval_dble_prog_t) :: keyval
    character(len=*), parameter :: rname='APERTURE>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call user%region%toprog(prog%cube,prog%region,error)
    if (error) return
    call user%ellipse%toprog(prog%cube,prog%ellipse,error)
    if (error) return
    call user%stack%toprog(prog%cube,prog%stack,error)
    if (error) return
    call user%background%toprog(comm%background,prog%backdiamfact,error)
    if (error) return
    ! User feedback
    call prog%region%list(error)
    if (error) return
    call prog%ellipse%list(error)
    if (error) return
    call prog%stack%list(error)
    if (error) return
    if (user%background%do) then
       call keyval%list(comm%background,prog%backdiamfact,error)
       if (error) return
    endif
  end subroutine cubemain_aperture_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_aperture_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubetools_axis_types
    use cubetools_beam_types
    use cubetools_spapro_types
    use cubeadm_clone
    !----------------------------------------------------------------------
    ! The following code aproximates the header to describe a shape similar
    ! to the aperture. L axis is aligned with aperture major axis, m axis
    ! with the minor axis, projection angle is the aperture position
    ! angle. This is only an approximation as the projection effects are
    ! not taken into account.
    !----------------------------------------------------------------------
    class(aperture_prog_t), intent(inout) :: prog
    type(aperture_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    real(kind=coor_k) :: absolute(2)
    type(axis_t) :: axis
    type(beam_t) :: beam
    type(spapro_t) :: spapro
    integer(kind=ndim_k), parameter :: ix = 1
    integer(kind=ndim_k), parameter :: iy = 2
    character(len=*), parameter :: rname='APERTURE>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header_with_region(comm%spectrum,  &
      prog%cube,prog%region,prog%spectrum,error)
    if (error) return
    call prog%stack%set_unit(prog%spectrum,error)
    if (error) return
    !
    ! l axis
    call cubetools_header_get_axis_head_l(prog%spectrum%head,axis,error)
    if (error) return
    axis%ref = 0.0
    axis%val = 0.0
    axis%inc = sign(max(prog%ellipse%diameter%major,abs(axis%inc)),axis%inc)
    axis%n = 1_pixe_k
    call cubetools_header_update_axset_l(axis,prog%spectrum%head,error)
    if (error) return
    !
    ! m axis
    call cubetools_header_get_axis_head_m(prog%spectrum%head,axis,error)
    if (error) return
    axis%ref = 0.0
    axis%val = 0.0
    axis%inc = sign(max(prog%ellipse%diameter%minor,abs(axis%inc)),axis%inc)
    axis%n = 1_pixe_k
    call cubetools_header_update_axset_m(axis,prog%spectrum%head,error)
    if (error) return
    !
    ! Projection
    call cubetools_header_get_spapro(prog%spectrum%head,spapro,error)
    if (error) return
    call prog%ellipse%center%absolute(absolute,error)
    if (error) return
    spapro%l0 = absolute(ix)
    spapro%m0 = absolute(iy)
    spapro%pa = prog%ellipse%diameter%pang
    call cubetools_header_put_spapro(spapro,prog%spectrum%head,error)
    if (error) return
    !
    ! Beam
    call cubetools_header_get_spabeam(prog%spectrum%head,beam,error)
    if (error) return
    ! VVV is this the correct choice for the output beam?
    if (beam%major*beam%minor.lt.prog%ellipse%diameter%major*prog%ellipse%diameter%minor) then
       beam%major = prog%ellipse%diameter%major
       beam%minor = prog%ellipse%diameter%minor
       beam%pang  = prog%ellipse%diameter%pang
       call cubetools_header_update_spabeam(beam,prog%spectrum%head,error)
       if (error) return
    endif
  end subroutine cubemain_aperture_prog_header
  !
  subroutine cubemain_aperture_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(aperture_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='APERTURE>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_aperture_prog_data
  !   
  subroutine cubemain_aperture_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: image,mask,weight,spectrum
    character(len=*), parameter :: rname='APERTURE>PROG>LOOP'
    !
    call image%associate('image',prog%cube,iter,error)
    if (error) return
    call mask%allocate('mask',prog%cube,error) !***JP: Is this correct with respect to the region?
    if (error) return
    call mask%associate_xy(error)
    if (error) return
    if (prog%backdiamfact.le.0.0) then
       call ellipse2mask1(prog%ellipse,mask,error)
       if (error) return
    else
       call ellipse2mask2(prog%ellipse,prog%backdiamfact,mask,error)
       if (error) return
    endif
    call weight%allocate('weight',prog%cube,error) !***JP: Is this correct with respect to the region?
    if (error) return
    call weight%set(1.0,error) ! => This means uniform weighting
    if (error) return
    call spectrum%allocate('spectrum',prog%spectrum,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%act(iter%ie,image,mask,weight,spectrum,error)
       if (error) return
    enddo ! ie
    !
  contains
    !
    subroutine ellipse2mask1(ellipse,mask,error)
      use cubetools_nan
      use cubetopology_spatial_coordinates
      !--------------------------------------------------------------------
      ! Compute a mask from an ellipse definition. If a pixel is outside
      ! the aperture but it is less than half a pixel from the ellipse
      ! center then it includes it in the mask.
      !
      !***JP: This codes does not takes into account projection effects.
      !--------------------------------------------------------------------
      type(spaelli_prog_t), intent(in)    :: ellipse
      type(image_t),        intent(in)    :: mask
      logical,              intent(inout) :: error
      !
      logical :: inside
      integer(kind=pixe_k) :: ix,iy
      real(kind=coor_k) :: centeroffset(2)
      real(kind=coor_k) :: rmajor,rminor
      real(kind=coor_k) :: angle,cosang,sinang
      real(kind=coor_k) :: xpix,xcoord,xcos,xsin
      real(kind=coor_k) :: ypix,ycoord,ycos,ysin
      !
      xpix = 0.5*abs(mask%x%inc) ! Half pixel size along x
      ypix = 0.5*abs(mask%y%inc) ! Half pixel size along y
      rmajor = 0.5*ellipse%diameter%major ! Major radius
      rminor = 0.5*ellipse%diameter%minor ! Minor radius
      call cubetopology_spatial_pang_to_fortran(prog%cube,ellipse%diameter%pang,angle,error)
      if (error) return
      cosang = cos(angle)
      sinang = sin(angle)
      call ellipse%center%offset(centeroffset,error)
      if (error) return
      !
      do iy=1,mask%ny
         ycoord = mask%y%coord(iy)-centeroffset(2)
         ycos = ycoord*cosang
         ysin = ycoord*sinang
         do ix=1,mask%nx
            xcoord = mask%x%coord(ix)-centeroffset(1)
            xcos = xcoord*cosang
            xsin = xcoord*sinang
            inside = ( ((xcos+ysin)/rmajor)**2 + ((xsin-ycos)/rminor)**2 ).le.1d0
            inside = inside.or.((abs(xcoord).le.xpix).and.abs(ycoord).le.ypix)
            if (inside) then
               mask%val(ix,iy) = 1.0
            else
               mask%val(ix,iy) = gr4nan
            endif
         enddo ! iy
      enddo ! ix
    end subroutine ellipse2mask1
    !
    subroutine ellipse2mask2(ellipse,bgfact,mask,error)
      use cubetools_nan
      use cubetopology_spatial_coordinates
      !--------------------------------------------------------------------
      ! Compute a mask from an ellipse definition. If a pixel is outside
      ! the aperture but it is less than half a pixel from the ellipse
      ! center then it includes it in the mask.
      !
      !***JP: This codes does not takes into account projection effects.
      !--------------------------------------------------------------------
      type(spaelli_prog_t), intent(in)    :: ellipse
      real(kind=coor_k),    intent(in)    :: bgfact
      type(image_t),        intent(in)    :: mask
      logical,              intent(inout) :: error
      !
      logical :: insidesig,insidebg
      integer(kind=pixe_k) :: ix,iy
      real(kind=coor_k) :: centeroffset(2)
      real(kind=coor_k) :: rmajorsig,rminorsig
      real(kind=coor_k) :: rmajorbg, rminorbg
      real(kind=coor_k) :: angle,cosang,sinang
      real(kind=coor_k) :: xpix,xcoord,xcos,xsin
      real(kind=coor_k) :: ypix,ycoord,ycos,ysin
      !
      xpix = 0.5*abs(mask%x%inc)             ! Half pixel size along x
      ypix = 0.5*abs(mask%y%inc)             ! Half pixel size along y
      rmajorsig = 0.5*ellipse%diameter%major ! Major radius of signal region
      rminorsig = 0.5*ellipse%diameter%minor ! Minor radius of signal region
      rmajorbg = rmajorsig*bgfact            ! Major radius of background region
      rminorbg = rminorsig*bgfact            ! Minor radius of background region
      call cubetopology_spatial_pang_to_fortran(prog%cube,ellipse%diameter%pang,angle,error)
      if (error) return
      cosang = cos(angle)
      sinang = sin(angle)
      call ellipse%center%offset(centeroffset,error)
      if (error) return
      !
      do iy=1,mask%ny
         ycoord = mask%y%coord(iy)-centeroffset(2)
         ycos = ycoord*cosang
         ysin = ycoord*sinang
         do ix=1,mask%nx
            xcoord = mask%x%coord(ix)-centeroffset(1)
            xcos = xcoord*cosang
            xsin = xcoord*sinang
            insidebg = ( ((xcos+ysin)/rmajorbg)**2 + ((xsin-ycos)/rminorbg)**2 ).le.1d0
            insidebg = insidebg.or.((abs(xcoord).le.xpix).and.abs(ycoord).le.ypix)
            if (insidebg) then
               insidesig = ( ((xcos+ysin)/rmajorsig)**2 + ((xsin-ycos)/rminorsig)**2 ).le.1d0
               insidesig = insidesig.or.((abs(xcoord).le.xpix).and.abs(ycoord).le.ypix)
               if (insidesig) then               
                  mask%val(ix,iy) = signal
               else
                  mask%val(ix,iy) = background
               endif
            else
               mask%val(ix,iy) = gr4nan
            endif
         enddo ! iy
      enddo ! ix
    end subroutine ellipse2mask2
  end subroutine cubemain_aperture_prog_loop
  !
  subroutine cubemain_aperture_prog_act(prog,ie,image,mask,weight,spectrum,error)
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(image_t),          intent(inout) :: image
    type(image_t),          intent(inout) :: mask
    type(image_t),          intent(inout) :: weight
    type(image_t),          intent(inout) :: spectrum
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='APERTURE>PROG>ACT'
    !
    call image%get(ie,error)
    if (error) return
    if (prog%backdiamfact.le.0.0) then
       call prog%stack%with_mask(image,weight,mask,spectrum,error)
       if (error) return
    else
       call prog%stack%backsubtract(image,weight,mask,spectrum,error)
       if (error) return
    endif
    call spectrum%put(ie,error)
    if (error) return
  end subroutine cubemain_aperture_prog_act  
end module cubemain_aperture
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_language
  use cubetools_parameters
  use cubetools_structure
  use cubefield_messaging
  !
  use cubefield_divergence
  use cubefield_gradient
  use cubefield_gradthin
  use cubefield_hessian
  use cubefield_incline
  use cubefield_minmax
  use cubefield_observe
  use cubefield_sht
  use cubefield_rotate
  !
  public :: cubefield_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubefield_register_language(error)
    !----------------------------------------------------------------------
    ! Register the FIELD\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'FIELD',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Analyze, transform, and project scalar or vector fields',&
         'FIELD lets you derive, transform, and project scalar or vector&
         & fields stored in images or cubes.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- GRADIENT writes DF_DX, DF_DY, AMPLITUDE, and ANGLE from a&
         & 2D field, then DIVERGENCE and HESSIAN turn those gradient&
         & products into second-order diagnostics.'//strg_cr//&
         '- GRADTHIN and SHT consume gradient amplitude/angle products&
         & to build thinned-edge masks and Hough-transform&
         & accumulators.'//strg_cr//&
         '- INCLINE and OBSERVE operate on the same 3D density/velocity&
         & cube quartet: INCLINE rotates the state cubes and OBSERVE&
         & projects them into COLDENS and VCENTROID maps.'//strg_cr//&
         '- MINMAX detects strict local minima/maxima in image slices,&
         & and ROTATE applies a local angle-field rotation to 2D vector&
         & components.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> FIELD\GRADIENT field'//strg_cr//&
         'CUBE> FIELD\GRADTHIN gradamp gradang'//strg_cr//&
         'CUBE> FIELD\SHT gradamp gradang'//strg_cr//&
         'CUBE> FIELD\INCLINE voldens vx vy vz /ANGLE 30deg'//strg_cr//&
         'CUBE> FIELD\OBSERVE voldens vx vy vz'//strg_bl//&
         'Note:'//strg_cr//&
         ' Shared region help is available on /SIZE ?, /CENTER ?, and&
         & /RANGE ? where supported.',&
         'gag_doc:hlp/cube-help-field.hlp',&
         cubefield_execute_command,&
         langid,&
         error)
    if (error) return
    !----------------------------------------------------------------------
    !
    call divergence%register(error)
    if (error) return
    call gradient%register(error)
    if (error) return
    call gradthin%register(error)
    if (error) return
    call hessian%register(error)
    if (error) return
    call incline%register(error)
    if (error) return
    call cubefield_minmax_register(error)
    if (error) return
    call observe%register(error)
    if (error) return
    call sht%register(error)
    if (error) return
    call rotate%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubefield_register_language
  !
  subroutine cubefield_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the FIELD\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'FIELD?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubeadm_finish_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubefield_execute_command
end module cubefield_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_list
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubedag_parameters
  use cubedag_link_type
  use cubedag_list_columns
  use cubedag_list_types
  use cubedag_toc_types
  use cubedag_messaging
  use cubeadm_cubeid_types
  !
  public :: list
  private
  !
  type :: list_comm_t
    type(option_t),           pointer :: comm
    type(cubeid_arg_t),       pointer :: commarg
    type(option_t),           pointer :: index
    type(keywordlist_comm_t), pointer :: index_arg
    type(option_t),           pointer :: file
    ! Specific to LIST
    type(option_t),           pointer :: columns
    type(keywordlist_comm_t), pointer :: column_arg
    type(option_t),           pointer :: page
    ! Specific to LIST /TOC
    type(option_t),           pointer :: toc
    type(keywordlist_comm_t), pointer :: toctopic_arg
    type(option_t),           pointer :: variable
  contains
    procedure, public  :: register => cubedag_list_register
    procedure, private :: parse    => cubedag_list_parse
    procedure, private :: main     => cubedag_list_main
  end type list_comm_t
  type(list_comm_t) :: list
  !
  type :: list_user_t
    ! Common parts
    type(cubeid_user_cube_t) :: ucube  ! CubeID pattern, if any
    integer(kind=code_k)     :: index
    logical                  :: dofile
    character(len=file_l)    :: file
    logical                  :: dotoc
    ! Specific to LIST
    type(cubedag_list_user_t) :: def
    ! Specific to LIST /TOC
    type(cubedag_toc_user_t) :: toc
  contains
    procedure, private :: toprog => cubedag_list_user_toprog
  end type list_user_t
  !
  type :: list_prog_t
    type(cubedag_link_t) :: optx
    character(len=16)    :: optname
    integer(kind=4)      :: olun
    logical              :: dotoc
    ! Specific to LIST
    type(cubedag_list_prog_t) :: def
    ! Specific to LIST /TOC
    type(cubedag_toc_prog_t) :: toc
  contains
    procedure, private :: do => cubedag_list_do
  end type list_prog_t
  !
contains
  !
  subroutine cubedag_list_command(line,error)
    !---------------------------------------------------------------------
    ! Support for command
    !  DAG\LIST
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(list_user_t) :: user
    !
    call list%parse(line,user,error)
    if (error) return
    call list%main(user,line,error)
    if (error) return
  end subroutine cubedag_list_command
  !
  subroutine cubedag_list_register(list,error)
    use cubetools_setup_types
    use cubedag_allflags
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(list_comm_t), intent(inout) :: list
    logical,            intent(inout) :: error
    !
    type(cubeid_arg_t)   :: cubearg
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: rname='LIST>REGISTER'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'LIST','[cube]',&
         'List the cubes in the default index or the given index',&
         'LIST is used for a quick look to cube headers, in a more or&
         & less detailed format. A medium-sized format is used by&
         & default, this can be changed with option /COLUMNS. If the&
         & list is too large it can be displayed page by page with&
         & option /PAGE. The list can be output to an ASCII file with&
         & option /FILE.',&
         cubedag_list_command,&
         list%comm,error)
    if (error) return
    call cubearg%register( &
         'CUBE', &
         'Cube identifier pattern',  &
         strg_emp,&
         code_arg_optional,  &
         [flag_any], &
         code_read_none, &
         code_access_any,&
         list%commarg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'INDEX','IndexName',&
         'Override the default index to be listed',&
         strg_emp,&
         list%index,error)
    if (error) return
    call keyarg%register( &
         'IndexName',  &
         'Name of the index to be listed', &
         strg_emp,&
         code_arg_mandatory, &
         indexname, &
         .not.flexible, &
         list%index_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'TOC','topic',&
         'Table Of Contents of the index',&
         'A summary of the different values of each topic is made&
         &, plus a final summary of all the combinations (setups).&
         By default, all topics are used. The table of contents is also&
         & saved in a SIC structure. The default name for the&
         & structure is TOC%, this can be changed by using the option&
         & /VARIABLE. The content of the structure is updated after&
         & each call to the command LIST /TOC. One must take care&
         & that subsequent calls to FIND can lead to values in TOC%&
         & that are inconsistent with the actual index.',&
         list%toc,error)
    if (error) return
    call keyarg%register(&
         'topic', &
         'Topic(s) over which build TOC',&
         strg_emp, &
         code_arg_unlimited,&
         cubedag_list_toc_keys, &
         .not.flexible, &
         list%toctopic_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'PAGE','',&
         'Page through the list',&
         strg_emp,&
         list%page,error)
    if (error) return
    !
    call cubetools_register_option(&
         'COLUMNS','col1 col2 ... coln',&
         'Define columns to be listed',&
         strg_emp,&
         list%columns,error)
    if (error) return
    call keyarg%register( &
         'column',  &
         'Column(s) to be listed', &
         strg_emp,&
         code_arg_unlimited, &
         list_column_names, &
         .not.flexible, &
         list%column_arg, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'FILE','OutputFile',&
         'Define an output file for the list',&
         strg_emp,&
         list%file,error)
    if (error) return
    call stdarg%register( &
         'OutputFile',  &
         'Name of the file to store the list', &
         strg_emp,&
         code_arg_mandatory, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'VARIABLE','varname',&
         'Define the name of the SIC variable containing the TOC',&
         strg_emp,&
         list%variable,error)
    if (error) return
    call stdarg%register( &
         'varname',  &
         'Name of the SIC variable to store the TOC', &
         strg_emp,&
         code_arg_mandatory, &
         error)
    if (error) return
  end subroutine cubedag_list_register
  !
  subroutine cubedag_list_parse(list,line,user,error)
    use cubetools_setup_types
    use cubetools_disambiguate
    !---------------------------------------------------------------------
    ! Parsing for DAG\LIST
    !   LIST [CubeID]
    !     [/INDEX DAG|CURRENT]
    !     [/TOC]
    !     [/PAGE]
    !     [/COLUMNS List]
    !     [/FILE OutputFile]
    !     [/VARIABLE VarName]
    !---------------------------------------------------------------------
    class(list_comm_t),       intent(in)    :: list
    character(len=*), target, intent(in)    :: line
    type(list_user_t),        intent(out)   :: user
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: narg,ncol,iarg
    character(len=argu_l) :: argu,key
    type(cubeid_user_t) :: cubeid
    type(cube_setup_api_t) :: setup
    character(len=*), parameter :: rname='LIST>PARSE'
    !
    ! Command argument. Build the user%find structure to restrict
    ! the search
    narg = list%comm%getnarg()
    if (narg.ge.1) then
      ! Remark 1: we should be able to list several IDs at once, but I
      ! miss a dedicated filter for this (user%ucube can only search
      ! for a scalar pattern).
      ! Remark 2: might have to double-check what happens for
      !  LIST 3   ! List Id #3, should it be in CX or not
      !  LIST -1  ! From the end of CX or IX???
      call cubeadm_cubeid_parse(line,list%comm,cubeid,error)
      if (error) return
      user%ucube = cubeid%cube(1)  ! e.g. 1, 13co10:cube, 13co10*, etc
    else
      ! ZZZ Should have a dedicated method for this
      user%ucube%family = strg_star
      user%ucube%flags = strg_star
      user%ucube%pos = strg_star
      user%ucube%id = strg_star
    endif
    !
    ! /INDEX
    narg = list%index%getnarg()
    if (narg.ge.1) then
       call cubetools_getarg(line,list%index,1,argu,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(list%index_arg,argu,user%index,key,error)
       if (error) return
    else
       call setup%index%default%get(user%index)
    endif
    !
    ! /FILE
    call list%file%present(line,user%dofile,error)
    if (error) return
    if (user%dofile) then
       call cubetools_getarg(line,list%file,1,user%file,mandatory,error)
       if (error) return
    endif
    !
    ! /TOC
    call list%toc%present(line,user%dotoc,error)
    if (error) return
    if (user%dotoc) then
       user%toc%iopt = list%toc%inum
       user%toc%var = 'TOC'
       call cubetools_getarg(line,list%variable,1,user%toc%var,.not.mandatory,error)
       if (error) return
    else ! /COLUMN, /PAGE
       narg = list%columns%getnarg()
       ncol = size(user%def%ucols)
       if (narg.gt.ncol) then
          call cubedag_message(seve%w,rname,'/COLUMNS list too long, truncated')
       endif
       user%def%ncol = max(1,min(narg,ncol))
       do iarg = 1,user%def%ncol
          user%def%ucols(iarg) = 'DEFAULT'
          call cubetools_getarg(line,list%columns,iarg,user%def%ucols(iarg),.not.mandatory,error)
          if (error) return
       enddo
       call list%page%present(line,user%def%dopage,error)
       if (error) return
    endif
  end subroutine cubedag_list_parse
  !
  subroutine cubedag_list_main(list,user,line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(list_comm_t), intent(in)    :: list
    type(list_user_t),  intent(in)    :: user
    character(len=*),   intent(in)    :: line
    logical,            intent(inout) :: error
    !
    type(list_prog_t) :: prog
    character(len=*), parameter :: rname='LIST>MAIN'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call user%toprog(line,prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubedag_list_main
  !
  subroutine cubedag_list_user_toprog(user,line,prog,error)
    use gkernel_interfaces
    use cubedag_cubeid_find_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(list_user_t), intent(in)    :: user
    character(len=*),   intent(in)    :: line
    type(list_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    type(cubeid_find_t) :: find
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='LIST>USER2PROG'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call cubedag_cubeid_user2find(list%commarg,user%ucube,find,error)
    if (error)  return
    !
    select case (user%index)
    case (code_index_dag)
      prog%optname = 'DAG'
      call find%filter%ix2optx(prog%optx,error)
      if (error)  return
    case (code_index_current)
      prog%optname = 'Current'
      call find%filter%cx2optx(prog%optx,error)
      if (error)  return
    case default
      call cubedag_message(seve%e,rname,'Default index is not supported')
      error = .true.
      return
    end select
    !
    ! Output to STDOUT or file?
    if (user%dofile) then  ! /FILE
      ier = sic_getlun(prog%olun)
      if (ier.ne.1) then
        call cubedag_message(seve%e,rname,'No logical unit left')
        error = .true.
        return
      endif
      ier = sic_open(prog%olun,user%file,'NEW',.false.)
      if (ier.ne.0) then
        call cubedag_message(seve%e,rname,'Cannot open file '//user%file)
        error = .true.
        call sic_frelun(prog%olun)
        return
      endif
    else
      prog%olun = stdout
    endif
    !
    prog%dotoc = user%dotoc
    if (prog%dotoc) then
      call user%toc%toprog(line,prog%toc,error)
    else
      call user%def%toprog(prog%def,error)
    endif
  end subroutine cubedag_list_user_toprog
  !
  subroutine cubedag_list_do(prog,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(list_prog_t), intent(inout) :: prog
    logical,            intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    if (prog%dotoc) then
      call prog%toc%do(prog%optx,prog%olun,error)
    else
      call prog%def%do(prog%optx,prog%optname,prog%olun,error)
    endif
    if (error) continue
    !
    if (prog%olun.ne.stdout) then
      ier = sic_close(prog%olun)
      call sic_frelun(prog%olun)
    endif
  end subroutine
end module cubedag_list
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_value_real_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: value_real_comm_t
  private
  !
  type value_real_comm_t
     type(standard_arg_t) :: value
     real(kind=real_k)    :: default
   contains
     procedure, public :: register => cubesyntax_value_real_comm_register
  end type value_real_comm_t
  !
contains
  !
  subroutine cubesyntax_value_real_comm_register(comm,name,default,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_real_comm_t), intent(inout) :: comm
    character(len=*),         intent(in)    :: name
    real(kind=real_k),        intent(in)    :: default
    character(len=*),         intent(in)    :: help
    logical,                  intent(inout) :: error
    !
    character(len=:), allocatable :: fullhelp
    character(len=*), parameter :: rname='VALUE>REAL>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%default = default
    fullhelp = 'Default to ???'
    if (help.ne.strg_emp) fullhelp = help
    call comm%value%register(&
         'VALUE',&
         trim(name)//' value',&
         fullhelp,&
         code_arg_mandatory,&
         error)
    if (error) return
  end subroutine cubesyntax_value_real_comm_register
end module cubesyntax_value_real_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_value_dble_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: value_dble_comm_t
  private
  !
  type value_dble_comm_t
     type(standard_arg_t) :: value
     real(kind=dble_k)    :: default
   contains
     procedure, public :: register => cubesyntax_value_dble_comm_register
  end type value_dble_comm_t
  !
contains
  !
  subroutine cubesyntax_value_dble_comm_register(comm,name,default,help,error)
    use cubetools_format, only: cubetools_format_value2string,fsimple,nsimple
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_dble_comm_t), intent(inout) :: comm
    character(len=*),         intent(in)    :: name
    real(kind=dble_k),        intent(in)    :: default
    character(len=*),         intent(in)    :: help
    logical,                  intent(inout) :: error
    !
    character(len=:), allocatable :: fullhelp
    character(len=:), allocatable :: defstr
    character(len=*), parameter :: rname='VALUE>DBLE>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%default = default
    if (help.ne.strg_emp) then
       fullhelp = help
    else
       defstr = trim(adjustl(cubetools_format_value2string(default,fsimple,nsimple)))
       fullhelp = 'Default to '//defstr
    endif
    call comm%value%register(&
         'VALUE',&
         trim(name)//' value',&
         fullhelp,&
         code_arg_mandatory,&
         error)
    if (error) return
  end subroutine cubesyntax_value_dble_comm_register
end module cubesyntax_value_dble_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_value_strg_types
  !------------------------------------------------------------------------
  ! This one is special in order to be able to propose the "COMMAND strg"
  ! syntax. ***JP: This one may bring trouble when going to python
  !------------------------------------------------------------------------
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: value_strg_comm_t,value_strg_user_t
  private
  !
  type value_strg_comm_t
     type(standard_arg_t)  :: value
     character(len=argu_l) :: default
     logical               :: mandatory
   contains
     procedure, public :: register => cubesyntax_value_strg_comm_register
     procedure, public :: parse    => cubesyntax_value_strg_comm_parse
  end type value_strg_comm_t
  !
  type value_strg_user_t
     logical               :: present = .false.
     character(len=argu_l) :: val     = strg_star
   contains
     procedure, public :: toprog => cubesyntax_value_strg_user_toprog
     procedure, public :: list   => cubesyntax_value_strg_user_list
  end type value_strg_user_t
  !
contains
  !
  subroutine cubesyntax_value_strg_comm_register(comm,name,abstract,default,mandatory,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_strg_comm_t), intent(inout) :: comm
    character(len=*),         intent(in)    :: name
    character(len=*),         intent(in)    :: abstract
    character(len=*),         intent(in)    :: default
    integer(kind=code_k),     intent(in)    :: mandatory
    character(len=*),         intent(in)    :: help
    logical,                  intent(inout) :: error
    !
    character(len=:), allocatable :: fullhelp
    character(len=*), parameter :: rname='VALUE>STRG>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%default = default
    comm%mandatory = mandatory.eq.code_arg_mandatory
    fullhelp = 'Default to '//trim(default)
    if (help.ne.strg_emp) fullhelp = trim(help)//strg_cr//fullhelp
    call comm%value%register(&
         name,&
         abstract,&
         fullhelp,&
         mandatory,&
         error)
    if (error) return
  end subroutine cubesyntax_value_strg_comm_register
  !
  subroutine cubesyntax_value_strg_comm_parse(comm,line,key,user,error)
    use cubetools_structure
    use cubetools_primitive_opt
    !----------------------------------------------------------------------
    ! value
    !----------------------------------------------------------------------
    class(value_strg_comm_t), intent(in)    :: comm
    character(len=*),         intent(in)    :: line
    class(primitive_opt_t),   intent(in)    :: key
    type(value_strg_user_t),  intent(out)   :: user ! => Initialized!
    logical,                  intent(inout) :: error
    !
    !logical :: mandatory
    integer(kind=argu_k), parameter :: ival=1
    character(len=*), parameter :: rname='VALUE>STRG>COMM>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    !***JP: Why isn't the following working?
    ! mandatory = comm%value%mandatory.eq.code_arg_mandatory
    !call cubetools_getarg(line,key,ival,user%val,mandatory,error)
    call cubetools_getarg(line,key,ival,user%val,comm%mandatory,error)
    if (error) return
  end subroutine cubesyntax_value_strg_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_value_strg_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_strg_user_t), intent(in)    :: user
    type(value_strg_comm_t),  intent(in)    :: comm
    character(len=*),         intent(inout) :: prog
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='VALUE>STRG>USER>TOPROG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
!***JP: Something like the following could/would be desirable
!    call comm%value%present(line,user%present,error)
!    if (error) return
    call cubetools_user2prog_resolve_star(user%val,comm%default,prog,error)
    if (error) return
  end subroutine cubesyntax_value_strg_user_toprog
  !
  subroutine cubesyntax_value_strg_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging purpose
    !----------------------------------------------------------------------
    class(value_strg_user_t), intent(in)    :: user 
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='VALUE>STRG>USER>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    print *,'PRESENT: ',user%present
    print *,'VALUE:   ',user%val
  end subroutine cubesyntax_value_strg_user_list
end module cubesyntax_value_strg_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_value_keywordlist_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: value_keywordlist_comm_t
  private
  !
  type value_keywordlist_comm_t
     type(keywordlist_comm_t), pointer :: value
     character(len=argu_l)             :: default
   contains
     procedure, public :: register => cubesyntax_value_keywordlist_comm_register
  end type value_keywordlist_comm_t
  !
contains
  !
  subroutine cubesyntax_value_keywordlist_comm_register(comm,name,default, &
    list,flexibl,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_keywordlist_comm_t), intent(inout) :: comm
    character(len=*),                intent(in)    :: name
    character(len=*),                intent(in)    :: default
    character(len=*),                intent(in)    :: list(:)
    logical,                         intent(in)    :: flexibl
    logical,                         intent(inout) :: error
    !
    type(keywordlist_comm_t) :: tool  ! Registering tool
    character(len=*), parameter :: rname='VALUE>KEYWORDLIST>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%default = default
    call tool%register(&
         'KEYWORD',&
         trim(name)//' value',&
         'Default to '//trim(default),&
         code_arg_mandatory,&
         list,&
         flexibl,&
         comm%value,& ! Pointer to the registered keywordlist_comm_t
         error)
    if (error) return
  end subroutine cubesyntax_value_keywordlist_comm_register
end module cubesyntax_value_keywordlist_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_extract
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  use cubemain_windowing
  use cubemain_ancillary_refhead_types
  use cubetopology_speline_types
  use cubetopology_sperange_types
  use cubetopology_sparange_types
  use cubetopology_spapos_types
  use cubetopology_spasize_types
  use cubetopology_cuberegion_types
  !
  public :: extract
  private
  !
  type :: extract_comm_t
     type(option_t),     pointer    :: comm
     type(cubeid_arg_t), pointer    :: cube
     type(sperange_opt_t)           :: range
     type(speline_opt_t)            :: freq
     type(spapos_comm_t)            :: center
     type(spasize_opt_t)            :: size
     type(ancillary_refhead_comm_t) :: reference  ! Support for /LIKE
     type(cube_prod_t),  pointer    :: extracted
   contains
     procedure, public  :: register => cubemain_extract_register
     procedure, private :: parse    => cubemain_extract_parse
     procedure, private :: main     => cubemain_extract_main
  end type extract_comm_t
  type(extract_comm_t) :: extract
  !
  type extract_user_t
     type(cubeid_user_t)            :: cubeids
     type(speline_user_t)           :: line       ! Optional new line name and freq
     type(sperange_user_t)          :: range      ! Spectral range to be extracted
     type(spapos_user_t)            :: center     ! [absolute|relative] Center of the region to be extracted
     type(spasize_user_t)           :: size       ! Size of the region to be extracted
     type(ancillary_refhead_user_t) :: reference
   contains
     procedure, private :: toprog => cubemain_extract_user_toprog
  end type extract_user_t
  !
  type extract_prog_t
     type(cube_t), pointer          :: cube       ! Input cube
     type(cube_t), pointer          :: extracted  ! Extracted cube
     logical                        :: doline
     type(speline_prog_t)           :: line
     type(sperange_user_t)          :: sperange
     integer(kind=ndim_k)           :: ix,iy,ic
     integer(kind=data_k)           :: range(3,2) ! Extracted ranges
     type(cuberegion_prog_t)        :: region     !
     type(ancillary_refhead_prog_t) :: reference
   contains
     procedure, private :: header          => cubemain_extract_prog_header
     procedure, private :: header_spectral => cubemain_extract_prog_header_spectral
     procedure, private :: header_spatial  => cubemain_extract_prog_header_spatial
     procedure, private :: create_region   => cubemain_extract_create_region
     procedure, private :: data            => cubemain_extract_prog_data     
     procedure, private :: loop            => cubemain_extract_prog_loop
     procedure, private :: act             => cubemain_extract_prog_act
  end type extract_prog_t
  !
contains
  !
  subroutine cubemain_extract_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(extract_user_t) :: user
    character(len=*), parameter :: rname='EXTRACT>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    call extract%parse(line,user,error)
    if (error) return
    call extract%main(user,error)
    if (error) return
  end subroutine cubemain_extract_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_extract_register(extract,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_comm_t), intent(inout) :: extract
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    !
    character(len=*), parameter :: rname='EXTRACT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'EXTRACT','[cube]',&
         'Extract a subcube',&
         'Extract a subcube from the input cube using spectral and spatial selectors.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /FREQUENCY changes velocity-axis interpretation by setting&
         & the source systemic velocity at the user-provided line rest&
         & frequency.'//strg_cr//&
         '- /LIKE copies extraction geometry from a reference cube and is exclusive with /RANGE, /CENTER, and /SIZE.'//strg_cr//&
         '- After option checks, EXTRACT reads only the minimum input&
         & cube subset needed for the requested region and range. This&
         & is especially important for huge input cubes.'//strg_cr//&
         '- At least one option must be provided.'//strg_cr//&
         '- /CENTER requires /SIZE in the same command line.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> EXTRACT cubeA /RANGE -10 10 km/s'//strg_cr//&
         'CUBE> EXTRACT cubeA /CENTER 0 0 relative /SIZE 60 60 /RANGE&
         & -5 5 km/s'//strg_cr//&
         'CUBE> EXTRACT cubeA /LIKE refcube',&
         cubemain_extract_command,&
         extract%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBE',&
         'Signal cube',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_subset,&
         extract%cube,&
         error)
    if (error) return
    !
    call extract%range%register('RANGE',&
         'Spectral range of the extracted region',&
         error)
    if (error) return
    !
    call extract%freq%register(&
         'Line name & rest frequency of the extracted region',&
         error)
    if (error) return
    !
    call extract%center%register('CENTER',&
         'Spatial center of the extracted region',&
         error)
    if (error) return
    !
    call extract%size%register(&
         'Spatial size of the extracted region',&
         error)
    if (error) return
    !
    call extract%reference%register('EXTRACT',error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'EXTRACTED',&
         'Extracted cube',&
         strg_emp,&
         [flag_extract,flag_cube],&
         extract%extracted,&
         error)
    if (error) return
  end subroutine cubemain_extract_register
  !
  subroutine cubemain_extract_parse(extract,line,user,error)
    !----------------------------------------------------------------------
    ! EXTRACT [cubeid]
    ! /RANGE first last [unit]
    ! /FREQUENCY line frequency [unit]
    ! /CENTER xpos ypos type [unit]
    ! /SIZE sx [sy [unit]]
    ! /LIKE [refcube]
    !----------------------------------------------------------------------
    class(extract_comm_t), intent(in)    :: extract
    character(len=*),      intent(in)    :: line
    type(extract_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXTRACT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,extract%comm,user%cubeids,error)
    if (error) return
    call extract%range%parse(line,user%range,error)
    if (error) return
    call extract%freq%parse(line,user%line,error)
    if (error) return
    call extract%center%parse(line,user%center,error)
    if (error) return
    call extract%size%parse(line,user%size,error)
    if (error) return
    call extract%reference%parse(line,user%reference,error)
    if (error) return
    !
    ! Sanity
    if (cubetools_nopt().eq.0) then
       call cubemain_message(seve%e,rname,'No options given, nothing to do')
       error = .true.
       return
    endif
    if (user%center%present.and..not.user%size%do) then
       call cubemain_message(seve%e,rname,'A size must be specified when giving a new center')
       error = .true.
       return
    endif
    if (user%reference%present .and. &
        (user%center%present .or. user%size%do .or. user%range%do)) then
       call cubemain_message(seve%e,rname,'/LIKE is exclusive with /RANGE /CENTER /SIZE')
       error = .true.
       return
    endif
  end subroutine cubemain_extract_parse
  !
  subroutine cubemain_extract_main(extract,user,error)
    use cubeadm_timing
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_comm_t), intent(in)    :: extract
    type(extract_user_t),  intent(in)    :: user
    logical,               intent(inout) :: error
    !
    type(extract_prog_t) :: prog
    character(len=*), parameter :: rname='EXTRACT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(extract,prog,error)
    if (error) return
    call prog%header(extract,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_extract_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_extract_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_user_t), intent(in)    :: user
    type(extract_comm_t),  intent(in)    :: comm
    type(extract_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    integer(kind=chan_k) :: stride
    real(kind=coor_k) :: offset(2)
    type(sparange_prog_t) :: lrange,mrange
    type(spapos_prog_t) :: center
    integer(kind=ndim_k), parameter :: ix=1,iy=2
    character(len=*), parameter :: rname='EXTRACT>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(extract%cube,user%cubeids,prog%cube,error)
    if (error) return
    !
    select case (prog%cube%order())
    case (code_cube_imaset)
       prog%ix = 1
       prog%iy = 2
       prog%ic = 3
    case (code_cube_speset)
       prog%ix = 2
       prog%iy = 3
       prog%ic = 1
    case default
       call cubemain_message(seve%e,rname,'Order not supported')
       error = .true.
       return
    end select
    !
    prog%doline = user%line%do
    if (prog%doline) then
       call user%line%toprog(prog%cube,prog%line,error)
       if (error) return
    endif
    !
    if (user%reference%present) then
      call cubemain_extract_user_toprog_reference(user,comm,prog, &
           prog%sperange,lrange,mrange,error)
      if (error)  return
    else
      ! User range is just copied because range resolution has to be done
      ! after frequency modification
      prog%sperange = user%range
      !
      ! Spatial center
      call user%center%toprog(prog%cube,center,error)
      if (error) return
      call center%offset(offset,error)
      if (error) return
      !
      ! Spatial ranges
      call lrange%fromuser(code_sparange_truncated,prog%cube%head%set%il,prog%cube,offset(ix),&
           user%size%x,user%size%unit,prog%cube%head%spa%l%inc,&
           prog%cube%head%spa%l%kind,error)
      if (error) return
      call mrange%fromuser(code_sparange_truncated,prog%cube%head%set%im,prog%cube,offset(iy),&
           user%size%y,user%size%unit,prog%cube%head%spa%m%inc,&
           prog%cube%head%spa%m%kind,error)
      if (error) return
    endif
    !
    call lrange%to_pixe_k(prog%range(prog%ix,1),prog%range(prog%ix,2),stride,error)
    if (error) return
    call mrange%to_pixe_k(prog%range(prog%iy,1),prog%range(prog%iy,2),stride,error)
    if (error) return
  end subroutine cubemain_extract_user_toprog
  !
  subroutine cubemain_extract_user_toprog_reference(user,comm,prog, &
    crange,lrange,mrange,error)
    use gkernel_interfaces
    use gkernel_types
    use cubetools_spapro_types
    !-------------------------------------------------------------------
    ! From the reference (/LIKE) cube provided by the user, fill the
    ! equivalent user* types
    !-------------------------------------------------------------------
    class(extract_user_t), intent(in)    :: user
    type(extract_comm_t),  intent(in)    :: comm
    type(extract_prog_t),  intent(inout) :: prog
    type(sperange_user_t), intent(out)   :: crange
    type(sparange_prog_t), intent(out)   :: lrange,mrange
    logical,               intent(inout) :: error
    !
    integer(kind=ndim_k) :: ref_ic,ref_il,ref_im
    real(kind=coor_k) :: lmin,lmax,loff(4),labs(4)
    real(kind=coor_k) :: mmin,mmax,moff(4),mabs(4)
    type(projection_t) :: gproj
    character(len=*), parameter :: rname='EXTRACT>USER>TOPROG>REFERENCE'
    !
    ! Fetch the reference header
    call user%reference%toprog(comm%reference,prog%reference,error)
    if (error) return
    !
    ! Spectral range
    ref_ic = prog%reference%cube%head%set%ic
    write(crange%val(1),'(1pg25.16)') prog%reference%cube%head%set%axis(ref_ic)%get_min()
    write(crange%val(2),'(1pg25.16)') prog%reference%cube%head%set%axis(ref_ic)%get_max()
    crange%unit =                     prog%reference%cube%head%set%axis(ref_ic)%unit
    !
    ! Spatial range: define 4 absolute positions at the middle of each
    ! side (not the corners to limit projection effects):
    !           2
    !         1   3
    !           4
    !
    ! Reference ranges (relative coordinates)
    ! ZZZ Should ensure in radians!
    ! ZZZ We ask for min/max but we should actually pick left/right, and respect
    !     the order in lrange%fromrange()
    ref_il = prog%reference%cube%head%set%il
    lmin = prog%reference%cube%head%set%axis(ref_il)%get_min()
    lmax = prog%reference%cube%head%set%axis(ref_il)%get_max()
    ref_im = prog%reference%cube%head%set%im
    mmin = prog%reference%cube%head%set%axis(ref_im)%get_min()
    mmax = prog%reference%cube%head%set%axis(ref_im)%get_max()
    !
    ! The 4 reference points in relative coordinates:
    loff(1) = lmin
    loff(2) = (lmin+lmax)/2.d0
    loff(3) = lmax
    loff(4) = (lmin+lmax)/2.d0
    moff(1) = (mmin+mmax)/2.d0
    moff(2) = mmax
    moff(3) = (mmin+mmax)/2.d0
    moff(4) = mmin
    !
    ! Convert from relative to absolute with the reference cube:
    call prog%reference%cube%head%spa%pro%gwcs(gproj,error)
    if (error) return
    call rel_to_abs(gproj,loff,moff,labs,mabs,4)
    !
    ! Convert the spherical coordinates from ref system to output system:
    ! ZZZ Don't we have a utility for this???
    if (prog%reference%cube%head%spa%fra%code .ne. &
                  prog%cube%head%spa%fra%code) then
      call cubemain_message(seve%e,rname,  &
        'Input and output cubes do not have the same coordinate system (not implemented)')
      error = .true.
      return
    endif
    !
    ! Convert back from absolute to relative in the extracted cube system:
    call prog%cube%head%spa%pro%gwcs(gproj,error)
    if (error) return
    call abs_to_rel(gproj,labs,mabs,loff,moff,4)
    !
    ! Fill the range types
    call lrange%fromrela(prog%cube%head%set%il,prog%cube,loff(1),loff(3),error)
    if (error)  return
    call mrange%fromrela(prog%cube%head%set%im,prog%cube,moff(4),moff(2),error)
    if (error)  return
  end subroutine cubemain_extract_user_toprog_reference
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_extract_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    type(extract_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXTRACT>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%extracted,prog%cube,prog%extracted,error)
    if (error) return
    call prog%header_spectral(error)
    if (error) return
    call prog%header_spatial(error)
    if (error) return
    call prog%create_region(error)
    if (error) return
  end subroutine cubemain_extract_prog_header
  !
  subroutine cubemain_extract_create_region(prog,error)
    !-----------------------------------------------------------------
    ! Ad-hoc subroutine which converts the 3 ranges to a region type,
    ! for later use by cubeadm_datainit_all.
    !
    ! We allow here the 3rd range to overlap the cube boundaries (no
    ! truncation) because the iterator knows how to deal with this
    ! case.
    !
    ! On the other hand, the 2 first dimensions are kept full (no
    ! subset, no surset), because the subcube%get() API is not able
    ! to get a subcube overlapping the boundaries. This is treated
    ! locally with special care in cubemain_extract_prog_act.
    !-----------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    ! Default full dimensions:
    ! - 'code_indx_auto' stand for the dimensions of the cube associated
    !   cube to the entry. Remember that in the current command,
    !   dimensions of the input and output cubes might differ in all
    !   directions.
    ! - explicit values would be used explicitly. This is not what we
    !   want as our input subcubes and output subcubes might differ
    !   in size.
    prog%region%ix%first = code_indx_auto
    prog%region%ix%last = code_indx_auto
    prog%region%iy%first = code_indx_auto
    prog%region%iy%last = code_indx_auto
    prog%region%iz%first = code_indx_auto
    prog%region%iz%last = code_indx_auto
    !
    ! Then subset/surset for the last dimension
    if (prog%ix.eq.3) then
      prog%region%ix%first = prog%range(3,1)
      prog%region%ix%last  = prog%range(3,2)
    elseif (prog%iy.eq.3) then
      prog%region%iy%first = prog%range(3,1)
      prog%region%iy%last  = prog%range(3,2)
    elseif (prog%ic.eq.3) then
      prog%region%iz%first = prog%range(3,1)
      prog%region%iz%last  = prog%range(3,2)
    endif
  end subroutine cubemain_extract_create_region
  !
  subroutine cubemain_extract_prog_header_spectral(prog,error)
    use cubetools_unit
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    ! *** JP *** Think twice before modifying this one!
    !----------------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(axis_t) :: axis
    integer(kind=chan_k) :: stride
    type(sperange_prog_t) :: sperange
    character(len=*), parameter :: rname='EXTRACT>PROG>HEADER>SPECTRAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Everything below is needed!
    if (prog%doline) then
       call cubetools_header_modify_rest_frequency(prog%line%freq,prog%extracted%head,error)
       if (error) return
       call cubetools_header_put_line(prog%line%name,prog%extracted%head,error)
       if (error) return
       call cubetools_header_get_axis_head_f(prog%extracted%head,axis,error)
       if (error) return
       call cubetools_header_update_frequency_from_axis(axis,prog%extracted%head,error)
       if (error) return
    endif
    !
    ! This part of the code has to be executed after the frequency
    ! modification otherwise the range of velocities is wrong!
    call prog%sperange%toprog(prog%extracted,code_sperange_truncated,sperange,error)
    if (error) return
    call sperange%to_chan_k(prog%range(prog%ic,1),prog%range(prog%ic,2),stride,error)
    if (error) return
    !
    call cubetools_header_get_axis_head_c(prog%extracted%head,axis,error)
    if (error) return
    axis%n = prog%range(prog%ic,2)-prog%range(prog%ic,1)+1
    axis%ref = axis%ref-prog%range(prog%ic,1)+1
    !
    ! This snippet of code was copied from: lib/edit/type-cube-buffer.f90:cubeedit_cube_buffer_resize
    ! This points to the necessity of factorizing this piece of code in lib/tools/header-methods.f90x
    if (axis%kind.eq.code_unit_freq) then
       call cubetools_header_update_frequency_from_axis(axis,prog%extracted%head,error)
       if (error) return
    else if (axis%kind.eq.code_unit_velo) then
       call cubetools_header_update_velocity_from_axis(axis,prog%extracted%head,error)
       if (error) return
    else
       call cubetools_header_update_axset_c(axis,prog%extracted%head,error)
       if (error) return
       call cubemain_message(seve%w,rname,'Unknown kind of Spectral axis')
    endif
  end subroutine cubemain_extract_prog_header_spectral
  !
  subroutine cubemain_extract_prog_header_spatial(prog,error)
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(axis_t) :: laxis, maxis
    character(len=*), parameter :: rname='EXTRACT>PROG>HEADER>SPATIAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_axis_head_l(prog%extracted%head,laxis,error)
    if (error) return
    laxis%n = prog%range(prog%ix,2)-prog%range(prog%ix,1)+1
    laxis%ref = laxis%ref-1d0*prog%range(prog%ix,1)+1d0
    call cubetools_header_update_axset_l(laxis,prog%extracted%head,error)
    if (error) return
    !
    call cubetools_header_get_axis_head_m(prog%extracted%head,maxis,error)
    if (error) return
    maxis%n = prog%range(prog%iy,2)-prog%range(prog%iy,1)+1
    maxis%ref = maxis%ref-1d0*prog%range(prog%iy,1)+1d0
    call cubetools_header_update_axset_m(maxis,prog%extracted%head,error)
    if (error) return
  end subroutine cubemain_extract_prog_header_spatial
  !
  subroutine cubemain_extract_prog_data(prog,error)
    use cubeadm_opened
    use cubetools_header_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: itertask
    character(len=*), parameter :: rname='EXTRACT>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(itertask,prog%region,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(itertask)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(itertask,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(itertask)
       if (.not.error) then
          call prog%loop(itertask,error)
       endif
       !$OMP END TASK
    enddo ! itertask
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_extract_prog_data
  !
  subroutine cubemain_extract_prog_loop(prog,itertask,error)
    use cubeadm_taskloop
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(extract_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXTRACT>PROG>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    do while (itertask%iterate_entry(error))
      call prog%act(itertask,error)
      if (error) return
    enddo  ! ientry
  end subroutine cubemain_extract_prog_loop
  !
  subroutine cubemain_extract_prog_act(prog,itertask,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !-------------------------------------------------------------------
    ! Extract from 1 subcube
    !-------------------------------------------------------------------
    class(extract_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: itertask
    logical,                  intent(inout) :: error
    !
    type(subcube_t) :: insub,ousub
    integer(kind=indx_k) :: ix,jx,ixmin,ixmax,ixoff
    integer(kind=indx_k) :: iy,jy,iymin,iymax,iyoff
    integer(kind=indx_k) :: iz,jz,izmin,izmax,izoff
    logical :: overlap
    character(len=*), parameter :: rname='EXTRACT>PROG>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube to another.
    call insub%associate('insub',prog%cube,itertask,error)
    if (error) return
    call ousub%allocate('ousub',prog%extracted,itertask,error)
    if (error) return
    !
    call insub%get(error)
    if (error) return
    !
    overlap = .false.
    !
    ! 1st dimension
    ixoff = prog%range(1,1)-1
    ixmin = prog%range(1,1)
    if (ixmin.lt.1) then
      overlap = .true.
      ixmin = 1
    endif
    ixmax = prog%range(1,2)
    if (ixmax.gt.insub%nx) then
      overlap = .true.
      ixmax = insub%nx
    endif
    !
    ! 2nd dimension
    iyoff = prog%range(2,1)-1
    iymin = prog%range(2,1)
    if (iymin.lt.1) then
      overlap = .true.
      iymin = 1
    endif
    iymax = prog%range(2,2)
    if (iymax.gt.insub%ny) then
      overlap = .true.
      iymax = insub%ny
    endif
    !
    ! 3rd dimension: subcubes
    izoff = insub%v3shift
    izmin = 1
    izmax = insub%nz
    if (izmax.gt.insub%nvalid3) then
      overlap = .true.
      izmax = insub%nvalid3
    endif
    !
    ! In case of surset extraction, initialize the new bits to NaN.
    ! For simplicity, initialize everything. NaN will be overwritten by
    ! valid values afterwards.
    if (overlap) then
      call ousub%set(gr4nan,error)
      if (error) return
    else
       continue ! No overlap cube boundaries, no init
    endif
    !
    do iz=izmin,izmax
      jz = iz-izoff
      do iy=iymin,iymax
        jy = iy-iyoff
        do ix=ixmin,ixmax
          jx = ix-ixoff
          ousub%val(jx,jy,jz) = insub%val(ix,iy,iz)
        enddo ! ix
      enddo ! iy
    enddo ! iz
    !
    call ousub%put(error)
    if (error) return
  end subroutine cubemain_extract_prog_act
end module cubemain_extract
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine dosmoo(raw,gwe,nc,nx,ny,map,mapx,mapy,sup,cell)
  !---------------------------------------------------------------------
  ! @ private
  ! Smooth an input data cube in VLM along L and M by convolution
  ! with a gaussian...
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: nc,nx,ny       ! Cube size
  real(kind=4),    intent(in)  :: raw(nc,nx,ny)  ! Raw cube
  real(kind=4),    intent(in)  :: gwe(nx,ny)     ! Gridded weights Not used ???? JP
  real(kind=4),    intent(out) :: map(nc,nx,ny)  ! Smoothed cube
  real(kind=4),    intent(in)  :: mapx(nx)       ! Arrays of gridded coordinates
  real(kind=4),    intent(in)  :: mapy(ny)       ! Arrays of gridded coordinates
  real(kind=4),    intent(in)  :: sup(2)         ! Convolving function support size in user unit
  real(kind=4),    intent(in)  :: cell(2)        ! Pixel size in user unit
  ! Local
  integer :: yfirs,ylast          ! Range to be considered
  integer :: xfirs,xlast          ! Range to be considered
  integer :: ix,iy,ic
  integer :: jx,jy                ! X coord, Y coord location in RAW
  real :: result,weight
  real :: u,v,du,dv,um,up,vm,vp,dx,dy
  !
  dx = abs(mapx(2)-mapx(1))
  dy = abs(mapy(2)-mapy(1))
  !
  ! Loop on Y rows
  do iy=1,ny
     v = mapy(iy)
     vm = v-sup(2)
     vp = v+sup(2)
     yfirs = max(1,nint((iy-sup(2)/dy)))
     ylast = min(ny,nint((iy+sup(2)/dy)))
     !
     ! Initialize X column
     do ix=1,nx
        do ic=1,nc
           map(ic,ix,iy) = 0.0
        enddo
     enddo
     !
     ! Loop on X cells
     if (yfirs.le.ylast) then
        do ix=1,nx
           u = mapx(ix)
           um = u-sup(1)
           up = u+sup(1)
           weight = 0.0
           xfirs = max(1,nint(ix-sup(1)/dx))
           xlast = min(nx,nint(ix+sup(1)/dx))
           !
           ! Do while in X cell
           if (xfirs.le.xlast) then
              do jy=yfirs,ylast
                 dv = (v-mapy(jy))/cell(2)
                 do jx=xfirs,xlast
                    du = (u-mapx(jx))/cell(1)
                    call convol(du,dv,result)
                    if (result.ne.0.0) then
                       weight = weight + result
                       do ic=1,nc
                          map(ic,ix,iy) = map(ic,ix,iy) + raw(ic,jx,jy)*result
                       enddo
                    endif
                 enddo
              enddo
              !
              ! Normalize weight only in cells where some data exists...
              if (weight.ne.0.0) then
                 weight = 1.0/weight
                 do ic=1,nc
                    map (ic,ix,iy) = map(ic,ix,iy)*weight
                 enddo
              endif
           endif
        enddo
     endif
  enddo
end subroutine dosmoo
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine doapod(xmin,xmax,ymin,ymax,tole,beam, &
     nc,nx,ny,map,raw,mapx,mapy,gweight,wmin)
  !---------------------------------------------------------------------
  ! @ private
  ! Replace the original (RAW) data by an apodized version
  !   - outside of the sampled region (map edges to smoothly go to zero)
  !   - and where the weight is below the minimum value (bad data points)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: xmin,xmax       ! Boundary of sampled region
  real(kind=4),    intent(in)    :: ymin,ymax       ! Boundary of sampled region
  real(kind=4),    intent(in)    :: tole            ! X-Y position tolerance
  real(kind=4),    intent(in)    :: beam            ! Beam size
  integer(kind=4), intent(in)    :: nc,nx,ny        ! Cube size
  real(kind=4),    intent(in)    :: map(nc,nx,ny)   ! Smoothed cube
  real(kind=4),    intent(inout) :: raw(nc,nx,ny)   ! Original cube
  real(kind=4),    intent(in)    :: mapx(nx)        ! Arrays of gridded coordinates
  real(kind=4),    intent(in)    :: mapy(ny)        ! Arrays of gridded coordinates
  real(kind=4),    intent(in)    :: gweight(nx,ny)  ! Gridded weights
  real(kind=4),    intent(in)    :: wmin            ! Minimum weight
  ! Local
  integer :: ic,ix,iy
  real :: lobe,apod,disty,distx,pi
  !
  pi = acos(-1.0)
  write(6,*) 'Min-Max ',xmin,xmax,ymin,ymax
  write(6,*) 'Beam, Tolerance, Increment ',beam*180*3600/pi,tole*180*3600/pi   &
       &    ,(mapx(1)-mapx(2))*180*3600/pi,'"'
  ! Use a beam size twice larger
  lobe = log(2.0)/beam**2
  do iy=1,ny
     if (mapy(iy).le.ymin-tole) then
        disty = ymin-mapy(iy)
     elseif (mapy(iy).ge.ymax+tole) then
        disty = mapy(iy)-ymax
     else
        disty = 0.0
     endif
     do ix=1,nx
        if (mapx(ix).le.xmin-tole) then
           distx = xmin-mapx(ix)
        elseif (mapx(ix).ge.xmax+tole) then
           distx = mapx(ix)-xmax
        else
           distx = 0.0
        endif
        apod = (distx**2+disty**2)*lobe
        if (apod.gt.80) then
           do ic=1,nc
              raw(ic,ix,iy) = 0.0
           enddo
        elseif  (apod.ne.0.0) then
           apod = exp(-apod)
           do ic=1,nc
              raw(ic,ix,iy) = map(ic,ix,iy)*apod
           enddo
        elseif (gweight(ix,iy).lt.wmin) then
           do ic=1,nc
              raw(ic,ix,iy) = map(ic,ix,iy)
           enddo
        endif
     enddo
  enddo
end subroutine doapod
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
function nearest_power_of_two(n)
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  integer(kind=4) :: nearest_power_of_two  ! Function value on return
  integer(kind=4), intent(in) :: n          !
  ! Local
  real(kind=4) :: r
  integer(kind=4) :: i
  !
  r = real(n)
  r = log(r)/log(2.0)
  i = int(r)
  if (i.ne.r) i = i+1
  nearest_power_of_two = 2**i
end function nearest_power_of_two
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mapping_specify
  use gbl_message
  !
  public :: specify_comm
  private
  !
contains
  !
  subroutine specify_comm(line,error)
    use gkernel_interfaces
    use phys_const
    use file_buffers
    use uv_buffers
    use uvmap_buffers
    use clean_buffers
    !-----------------------------------------------------
    ! SPECIFY KeyWord Value
    !-----------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    real(8) :: freq,freq_a,freq_b,value(3)
    real(4) :: velo
    integer :: i,iterm,narg,nc
    integer, parameter :: nterm=3
    character(len=12) :: term(nterm),chain,key
    data term/'FREQUENCY','TELESCOPE','VELOCITY'/
    character(len=*), parameter :: rname='SPECIFY'
    !
    if (huv%loca%size.ne.0) then
       freq = huv%gil%freq
       velo = huv%gil%voff
    endif
    if (dirty%head%loca%size.ne.0) then
       freq = dirty%head%gil%freq
       velo = dirty%head%gil%voff
    endif
    if (clean%head%loca%size.ne.0) then
       freq = clean%head%gil%freq
       velo = clean%head%gil%voff
    endif
    !
    narg = sic_narg(0)
    do i = 1,narg,2
       call sic_ke(line,0,i,chain,nc,.true.,error)
       if (error) return
       call sic_ambigs(rname,chain,key,iterm,term,nterm,error)
       if (error) return
       !
       select case (key)
       case ('FREQUENCY')
          ! Modify velocity scale according to new rest frequency [MHz]
          call sic_r8(line,0,i+1,freq,.true.,error)
       case ('VELOCITY')
          ! Modify Frequency scale according to new velocity (km/s)
          call sic_r4(line,0,i+1,velo,.true.,error)
       case ('TELESCOPE')
          call sic_ke(line,0,i+1,chain,nc,.true.,error)
          if (error) return
          !
          ! Update current UV and Initial UV data set
          if (huv%loca%size.ne.0) then
             if (huv%gil%nteles.ge.1) then
                if (huv%gil%teles(1)%ctele .ne. chain(1:nc)) then
                   call map_message(seve%i,rname,'Telescope ' &
                        & //trim(huv%gil%teles(1)%ctele) &
                        & //' in UV data overwritten by /TELESCOPE '//chain(1:nc)) 
                   ! Undefine the telescope so that all characteristics
                   ! are re-defined by gdf_addteles after
                   huv%gil%teles(1)%ctele = ' '
                   uvi%head%gil%teles(1)%ctele = ' '
                endif
             endif
             call gdf_addteles(huv,'TELE',chain(1:nc),value,error)
             call gdf_addteles(uvi%head,'TELE',chain(1:nc),value,error)
          endif
       end select
       if (error) return
    enddo
    !
    ! Now which ones ...
    if (huv%loca%size.ne.0) then
       freq_b = gdf_uv_frequency(huv,1.d0)
       call gdf_modify(huv,velo,freq,error=error)
       freq_a = gdf_uv_frequency(huv,1.d0)
       if (abs(freq_a-freq_b).gt.10.0) then
          print *,'Frequency Before ',freq_b
          print *,'Frequency After ',freq_a
          print *,'Frequency Difference ',freq_a-freq_b
       endif
    endif
    if (dirty%head%loca%size.ne.0) then
       call gdf_modify(dirty%head,velo,freq,error=error)
    endif
    if (clean%head%loca%size.ne.0) then
       call gdf_modify(clean%head,velo,freq,error=error)
    endif
  end subroutine specify_comm
end module mapping_specify
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_station(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Write the Station SDM table.
  !
  !     int sdm_addStationRow (char * name, int * nameDim, double *
  !     position, int * positionDim, char * type, int * typeDim)
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_station
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  include 'clic_stations.inc'
  include 'gbl_pi.inc'
  ! Dummy
  logical error
  ! Local
  type(StationRow) :: sRow
  type(StationKey) :: sKey
  integer ia, is, k, l, ier
  real*8 weather(3)
  CHARACTER*1 ARM(3)
  DATA ARM/'N','W','E'/
  character sdmTable*12
  parameter (sdmTable='Station')
  real*8 :: lonlat(2), altitude, s_5(2), x_5(3), x_2(3), s_2(2),   &
    trfm_52(3,3), psi, the, phi
  real*8, parameter :: radius=6367.435d3   ! the Earth radius
  !     approximately at center of interferometer
  data weather/3*0d0/
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  error = .false.
  !
  ! Weather station relocated at interferometer center...
  CALL SIC_SEXA ('05:54:28.5',10,LONLAT(1),ERROR)
  CALL SIC_SEXA ('44:38:02.0',10,LONLAT(2),ERROR)
  ALTITUDE = 2.560*1000.
  lonlat = lonlat*pi/180d0
  !
  ! Euler angles to go from horiz (2) to geocentric (5)
  psi = pi/2                   ! 90 degrees
  the = pi/2-lonlat(2)         ! 90 degrees minus latitude
  phi = pi/2-lonlat(1)         ! 90 degrees minus longitude
  call eulmat (psi, the, phi,trfm_52)
  !     center of Observatory in horizontal coordinates
  x_2 = (/0d0, 0d0, radius+altitude/)
  call matvec (x_2, trfm_52, x_5)
  weather = x_5
  !      do k=1, 3
  !         weather(k) = x_5(k)
  !      enddo
  !
  !
  call allocStationRow(srow, error)
  if (error) return
  sRow%name = 'PdB-WeatherStation'
  sRow%type = StationType_WEATHER_STATION
  sRow%position = weather
  !
  call addStationRow(sKey, sRow, error)
  if (error) return
  Weather_Station_Id = sKey%stationId
  !
  if (r_teles.eq.'VTX-ALMATI') then
    CALL SIC_SEXA ('-107:37:10.02',10,LONLAT(1),ERROR)
    CALL SIC_SEXA ('34:04:29.8',8,LONLAT(2),ERROR)
    ALTITUDE = 2.13542*1000.
    do ia = 1, r_nant
      sRow%name = 'Vertex ATF Pad'
      sRow%position = 0
      sRow%type = StationType_ANTENNA_PAD
      call addStationRow(sKey, sRow, error)
      if (error) return
      station_id(ia) = sKey%stationId
    enddo
  elseif (r_teles.eq.'AEC-ALMATI') then
    CALL SIC_SEXA ('-107:37:10.02',10,LONLAT(1),ERROR)
    CALL SIC_SEXA ('34:04:29.8',8,LONLAT(2),ERROR)
    ALTITUDE = 2.13542*1000.
    do ia = 1, r_nant
      sRow%name = 'AEC ATF Pad'
      sRow%position = 0
      sRow%type = StationType_ANTENNA_PAD
      call addStationRow(sKey, sRow, error)
      if (error) return
      station_id(ia) = sKey%stationId
    enddo
  else
    CALL SIC_SEXA ('05:54:28.5',10,LONLAT(1),ERROR)
    CALL SIC_SEXA ('44:38:02.0',10,LONLAT(2),ERROR)
    ALTITUDE = 2.560*1000.
    lonlat = lonlat*pi/180d0
    !     These coordinates are in the Bure system,
    !     we thus  rotate/translate  them to geocentric...
    do ia = 1, r_nant
      is = r_istat(ia)
      write (sRow%name,'(a5,i2.2)') 'PdB-'//arm(is/100), mod(is   &
        ,100)
      !     Now add the station local coordinates given in the Bure system: Z
      !     to N pole, X to south
      !
      !     Euler angles to go from hour angle system (Bure) to geocentric (5)
      psi = 0                  ! 90 degrees
      the = 0                  ! z axes are parallel
      phi = -lonlat(1)         ! 90 degrees minus longitude
      call eulmat (psi, the, phi,trfm_52)
      do k=1, 3
        x_2(k) = stat99(k,is)
      enddo
      call matvec (x_2, trfm_52, x_5)
      !            do k=1, 3
      !               sRow%position(k) = weather(k) + x_5(k)
      !            enddo
      sRow%position = weather + x_5
      do k=1, 3
        r_antgeo(k,ia) = sRow%position(k)
      enddo
      sRow%type = StationType_ANTENNA_PAD
      call addStationRow(sKey, sRow, error)
      if (error) return
      station_id(ia) = sKey%stationId
    enddo
  endif
  call sdmMessage(1,1,sdmTable ,'Written.')
!
end subroutine write_sdm_station
!---------------------------------------------------------------------
subroutine Get_sdm_station(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Read the Station SDM table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_station
  logical error
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  include 'clic_stations.inc'
  ! Dummy
  ! Local
  type(StationRow) :: sRow
  type(StationKey) :: sKey
  type(StationKey), allocatable :: sKeyList(:)
  integer ia, is, k, l, ier, stationSize, i
  character*12 name
  real*8 distance, mindist
  CHARACTER*1 ARM(3), carm
  DATA ARM/'N','W','E'/
  character sdmTable*12
  parameter (sdmTable='Station')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  call allocStationRow(srow, error)
  if (error) return
  !
  !     These coordinates are assumed to be in the Bure system,
  !     may be rotate/translate  them from geocentric...
  do ia = 1, r_nant
    sKey%stationId = station_id(ia)
    call getStationRow(sKey, sRow, error)
    if (error) return
    if (sRow%name(1:4).eq.'PdB-') then
      read (sRow%name,'(4x,a1,i2.2)') carm, is
      is = mod(is,100)
      do k=1, 3
        if (carm.eq.arm(k)) then
          r_istat(ia) = k*100+ia
        endif
      enddo
    else
      !c            print *, 'ia, sRow%position ', ia, sRow%position
      do k=1, 3
        r_antgeo(k,ia) = sRow%position(k)
      enddo
      is = 0
    endif
  !
  !     Note: we do not keep track of stations positions in CLIC.
  enddo

  call getStationTableSize(stationSize, error)
  if (error) return
  if (stationSize.gt.0) then
    if (allocated(sKeyList)) then
      deallocate(sKeyList, stat=ier)
      if (ier.ne.0) then
        call sdmmessageI(8,4,sdmTable   &
          ,'Deallocation error, ier= ',ier)
        error = .true.
        return
      endif
    endif
    allocate (sKeyList(stationSize), stat=ier)
    if (ier.ne.0) then
      call sdmmessageI(8,4,sdmTable   &
        ,'Allocation error, ier= ',ier)
      error = .true.
      return
    endif
    call getStationKeys(stationSize, sKeyList, error)
    if (error) return
  endif
  mindist = 1e6 ! 1000 km
  do i=1, stationSize
    call getStationRow(sKeyList(i), sRow, error)
    if (error) return
    distance = 0
    do k=1, 3
      distance = distance + (r_antgeo(k,1)-sRow%position(k))**2
    enddo
    if (sqrt(distance).lt.mindist) then
      name = sRow%name
      Weather_Station_Id = sKeyList(i)%stationId
    endif
  enddo
  ! print *, name, Weather_Station_Id
  !     (but we have tothing to use there...)
  call sdmMessage(1,1,sdmTable ,'Read.')
!
end subroutine Get_sdm_station
!---------------------------------------------------------------------
!!! subroutine allocStationRow(row, error)
!!!   !---------------------------------------------------------------------
!!!   !     real*8, allocatable :: position(:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_Station
!!!   type(StationRow) :: row
!!!   integer :: ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*8 = 'Station'
!!!   !
!!!   ! position(3)
!!!   if (allocated(row%position)) then
!!!     deallocate(row%position, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%position(3), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!---------------------------------------------------------------------
subroutine charcpp(chain,chainDim)
  use gkernel_interfaces
  integer chainDim(2), l, i
  !
  !     add a null, returns the useful length
  !
  !     truncate if too long
  !
  character*(*) chain
  l = lenc(chain)
  if (l.eq.len(chain)) then
    l = l-1
  endif
  chain = chain(1:l)//char(0)
  chainDim(1) = l+1
  chainDim(2) = len(chain)
end subroutine charcpp

subroutine gtl_change(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_change
  use gtv_graphic
  use gtv_tree
  use gtv_buffers
  use gtv_protocol
  use gtv_plot
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    CHANGE Item SegName Value [Val2 [Val3]]
  !    CHANGE Behaviour Value
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='CHANGE'
  integer, parameter :: nvocab=14,nlut=2,nhard=2
  character(len=12) :: vocab(nvocab),vlut(nlut),vhard(nhard),to_check,comm
  integer :: ncom,mode,nc
  character(len=gtvpath_length) :: argum
  integer :: win_num,cnum,npixx,npixy,sever
  logical :: active
  ! Data
  data vocab /'BLANKING','COLOUR','DASH','DEPTH','DIRECTORY','DRAW',    &
    'PENCIL','PIXEL','POSITION','LUT','SCALING','VISIBILITY','WEIGHT',  &
    'WINDOW'/
  data vlut /'STATIC','DYNAMIC'/
  data vhard /'HARD','SOFT'/
  !
  call sic_ke (line,0,1,to_check,nc,.true.,error)
  if (error) return
  !
  ! Check if type of variable is known
  call sic_ambigs('CHANGE',to_check,comm,ncom,vocab,nvocab,error)
  if (error)  return
  !
  select case (comm)
  case('DIRECTORY')
    ! CHANGE DIRECTORY Name [Window]
    ! Directory name
    argum = dir_top
    call sic_ch (line,0,2,argum,nc,.false.,error)
    if (error) return
    call sic_upper(argum)
    ! Window number
    if (sic_present(0,3)) then
      ! Rely on the window number given by user
      active = .false.
      call sic_i4(line,0,3,win_num,.true.,error)
      if (error) return
    else
      ! Use the active window
      active = .true.
      win_num = 0  ! Dummy value
    endif
    call cd_by_name(argum,active,win_num,error)
    !
  case('WINDOW')
    ! CHANGE WINDOW Num: change to named window
    !
    call gtv_open_segments_for_writing_from_main()
    !
    cnum = get_window_cnum_byname(cw_directory,rname,line,0,2,error)
    !
    call cd_by_win(cw_directory,cnum,error)
    !
    call gtv_close_segments_for_writing_from_main()
    !
  case('DRAW')
    ! CHANGE DRAW ON|OFF
    if (strict2011) then
      sever = seve%e
    else
      sever = seve%w
    endif
    call gtv_message(sever,rname,'CHANGE DRAW is obsolete. GTVirt is always awake.')
    if (strict2011) then
      error = .true.
      return
    endif
    !
  case('PENCIL')
    ! CHANGE PENCIL HARD|SOFT
    if (sic_present(0,2)) then
      call sic_ke(line,0,2,to_check,nc,.true.,error)
      if (error)  return
      call sic_ambigs('PENCIL',to_check,comm,mode,vhard,nhard,error)
      if (error)  return
      if (comm.eq.'HARD') then
        user_hardw_line=.true.
      else
        user_hardw_line=.false.
      endif
    endif
    if (user_hardw_line) then
      call gtv_message(seve%i,rname,'Pencil uses hardware generator (if available)')
    else
      call gtv_message(seve%i,rname,'Pencil uses GTV generator')
    endif
    !
  case('POSITION')
    call gtl_change_position(line,error)
    if (error)  return
    !
  case('LUT')
    ! CHANGE LUT STATIC|DYNAMIC
    if (sic_present(0,2)) then
      call sic_ke (line,0,2,to_check,nc,.true.,error)
      if (error) return
      call sic_ambigs('LUT',to_check,comm,mode,vlut,nlut,error)
      if (error) return
      lut_static = comm.eq.'STATIC'
      !
      call exec_images_recurs(root,change_image_lut)
      call exec_poly_recurs(root,change_poly_penlut)
      call gtview('Update')
    endif
    if (lut_static) then
      call gtv_message(seve%i,rname,'LUT behaviour is STATIC')
    else
      call gtv_message(seve%i,rname,'LUT behaviour is DYNAMIC')
    endif
    !
  case('PIXEL')
    ! CHANGE PIXEL NX NY. Work on the current window only
    if (cw_output%dev%protocol.ne.p_x) then
      call gtv_message(seve%e,rname,'Command is available only for X windows')
      error = .true.
      return
      !
    elseif (cw_output%x%graph_env.eq.0) then
      call gtv_message(seve%w,rname,'No active window, nothing done')
      return
      !
    else
      call sic_i4(line,0,2,npixx,.true.,error)
      if (error) return
      call sic_i4(line,0,3,npixy,.true.,error)
      if (error) return
      call x_resize_window(cw_output%x%graph_env,npixx,npixy)
    endif
    !
  case default
    ! CHANGE SCALING|BLANKING|COLOUR|DASH|DEPTH|VISIBILITY|WEIGHT SegName Value
    call gtl_change_attr(line,comm,error)
    if (error)  return
    !
  end select
  !
end subroutine gtl_change
!
subroutine gtl_change_position(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_change_position
  use gbl_message
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  CHANGE POSITION Num
  !  CHANGE POSITION Posx[Unitx] Posy[Unity]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CHANGE'
  character(len=12) :: argx,argy
  integer(kind=4) :: icode,nc,posx,posy
  !
  if (cw_device%protocol.ne.p_x)  return
  !
  if (cw_output%x%graph_env.eq.0) then
    call gtv_message(seve%w,rname,'No active window, nothing done')
    return
  endif
  !
  if (sic_present(0,3)) then
    call sic_ch(line,0,2,argx,nc,.true.,error)
    if (error)  return
    call sic_ch(line,0,3,argy,nc,.true.,error)
    if (error)  return
    call decode_coordinates(cw_output%x%position,argx,argy,error)
    if (error)  return
    !
    call compute_coordinates_position(cw_output,posx,posy,error)
    if (error)  return
    ! And finally move
    call x_move_window(cw_output%x%graph_env,posx,posy)
    !
  else
    call sic_i4(line,0,2,icode,.true.,error)
    if (error) return
    if (icode.le.0 .or. icode.ge.10) return
    call x_corner(cw_output%x%graph_env,icode)
  endif
  !
end subroutine gtl_change_position
!
subroutine gtl_change_attr(line,comm,error)
  use gbl_message
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_change_attr
  use gtv_protocol
  use gtv_plot
  use gtv_segatt
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   CHANGE SCALING|BLANKING|COLOUR|DASH|DEPTH|VISIBILITY|WEIGHT SegName Value
  ! Modify (macro)segment attributes
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  character(len=*), intent(in)    :: comm   ! Attribute (already resolved)
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CHANGE'
  real(kind=4) :: cutvalue(6),wei
  logical :: cutreset(6)
  integer :: att_code,att_val_in,att_val
  character(len=12) :: to_check,keyw
  character(len=gtvpath_length) :: argum_in,argum
  logical :: isdir,found,done
  integer :: ia,la,iseg,iseg1,iseg2,i,nc,mode,scaling
  character(len=message_length) :: mess
  type(gt_directory), pointer :: workdir,father
  type(gt_segment), pointer :: segm
  !
  integer, parameter :: nscale=4
  integer, parameter :: nvisi=2
  character(len=12) :: vscal(nscale),vvisi(nvisi)
  data vscal /'SAME','LINEAR','LOGARITHMIC','EQUALIZATION'/
  data vvisi /'ON','OFF'/
  !
  ! Get (macro)segment name
  call sic_ch(line,0,2,argum_in,nc,.false.,error)
  if (error) return
  call sic_upper(argum_in)
  !
  argum = argum_in
  call decode_chemin(argum,cw_directory,workdir,isdir,segm,found)
  if (.not.found .or. .not.isdir) then
    ! Not a known macrosegment: assume it represents a segment
    ! Parse wildcards, range and so on
    call gtl_segment_parse(argum,iseg1,iseg2,error)
    if (error) return
    la = len_trim(argum)
    ia = index(argum,':')
    iseg=1
    if (iseg1.ge.iseg2) iseg=-1
  endif
  !
  done = .false.
  !
  ! CHANGE VISIBILITY SegName ON|OFF|CLEAR
  if (comm.eq.'VISIBILITY') then
    call sic_ke (line,0,3,to_check,nc,.true.,error)
    if (error) return
    call sic_ambigs('VISIBILITY',to_check,keyw,nc,vvisi,nvisi,error)
    if (error) return
    !
    if (keyw.eq.'ON') then
      att_val = 1
    else  ! 'OFF' or 'CLEAR'
      att_val = -1
    endif
    !
    if (isdir) then
      call gtv_open_segments_for_writing_from_main()
      call change_attr_dir(workdir,att_vis,att_val)
      call gtv_close_segments_for_writing_from_main()
      father => workdir%father
      done = .true.
    else
      do i=iseg1,iseg2,iseg
        if (i.ne.0) then
          write(argum(ia+1:),'(I6)') i
          la = ia+6
          call sic_black(argum,la)
          call decode_chemin(argum,cw_directory,workdir,isdir,segm,found)
        endif
        if (found) then
          if (isdir) then
            call gtv_open_segments_for_writing_from_main()
            call change_attr_dir(workdir,att_vis,att_val)
            call gtv_close_segments_for_writing_from_main()
            ! Need to know the parent directory of all the affected
            ! segments, because we have to update its minmax limits
            ! at the end.
            father => workdir%father
          else
            call gtv_open_segments_for_writing_from_main()
            call change_attr_seg(segm,att_vis,att_val)
            call gtv_close_segments_for_writing_from_main()
            father => workdir
          endif
          !
          done = .true.
        endif
      enddo
    endif
    !
    ! Recompute parent directory limits.
    if (done) then
      call gtv_limits(father,error)
      if (error) then
        call gtv_message(seve%e,rname,'Updating the parent directory limits')
        return
      endif
    endif
  !
  ! CHANGE BLANKING SegName Value
  elseif (comm.eq.'BLANKING') then
    ! TBD : To be defined,  but the blanking colour is a window attribute ?
    call sic_i4(line,0,3,att_val_in,.true.,error)
    if (error) return
    call gtv_message(seve%w,rname,'BLANKING action is not yet implemented')
  !
  ! CHANGE SCALING Segments NEW_MODE NEW_LCUT NEW_HCUT
  elseif (comm.eq.'SCALING') then
    call sic_ke (line,0,3,to_check,nc,.true.,error)
    if (error) return
    call sic_ambigs('SCALING',to_check,keyw,mode,vscal,nscale,error)
    if (error)  return
    !
    ! More sophisticated logic with * used when going back to automatic
    ! Low and High cuts
    call gtl_change_parse(line,4,cutreset(1),cutvalue(1),error)
    if (error)  return
    call gtl_change_parse(line,5,cutreset(2),cutvalue(2),error)
    if (error)  return
    call gtl_change_parse(line,6,cutreset(3),cutvalue(3),error)
    if (error)  return
    call gtl_change_parse(line,7,cutreset(4),cutvalue(4),error)
    if (error)  return
    call gtl_change_parse(line,8,cutreset(5),cutvalue(5),error)
    if (error)  return
    call gtl_change_parse(line,9,cutreset(6),cutvalue(6),error)
    if (error)  return
    !
    ! Set the new mode
    scaling = mode-1
    if (isdir) then
      done = .true.
      call change_scaling_dir(workdir,scaling,cutreset,cutvalue,error)
      if (error)  return
    else
      do i=iseg1,iseg2
        if (i.ne.0) then
          write(argum(ia+1:),'(I6)') i
          la = ia+6
          call sic_black(argum,la)
          call decode_chemin(argum,cw_directory,workdir,isdir,segm,found)
        endif
        if (found) then
          done = .true.
          call change_scaling_image(segm,scaling,cutreset,cutvalue,.true.,error)
          if (error)  return
        endif
      enddo
    endif
    !
    ! Force bitmap refresh on X-Window (GTVIEW is too clever...)
    if (done .and. cw_device%protocol.eq.p_x)  &
      call gti_xforceupdate(cw_output)
  !
  ! CHANGE COLOUR|DASH|DEPTH|WEIGHT SegName Value
  else
    if (comm.eq.'COLOUR') then
      att_code = att_colour
      call gtv_pencol_arg2id(rname,line,0,3,att_val,error)
      if (error)  return
    elseif (comm.eq.'DASH') then
      att_code = att_dash
      call gtv_pendash_arg2id(rname,line,0,3,att_val,error)
      if (error)  return
    elseif (comm.eq.'WEIGHT') then
      att_code = att_weight
      call gtv_penwei_arg2val(rname,line,0,3,wei,error)
      if (error) return
      ! Because change_attr_seg requires an int value, and for
      ! simplicity we just multiply and later divide the value
      ! by 10000
      att_val = 10000*wei
    elseif (comm.eq.'DEPTH') then
      att_code = att_depth
      call sic_i4(line,0,3,att_val_in,.true.,error)
      if (error) return
      att_val = max(1,min(att_val_in,max_depth))
      if (att_val.ne.att_val_in) then
        write(mess,'(A,I2,A)') 'Corrected input depth value to ',att_val,  &
        ' before setting'
        call gtv_message(seve%w,rname,mess)
      endif
      if (att_val.gt.cdepth)  cdepth = att_val
    endif
    !
    if (isdir) then
      done = .true.
      call gtv_open_segments_for_writing_from_main()
      call change_attr_dir(workdir,att_code,att_val)
      call gtv_close_segments_for_writing_from_main()
    else
      do i=iseg1,iseg2,iseg
        if (i.ne.0) then
          write(argum(ia+1:),'(I6)') i
          la = ia+6
          call sic_black(argum,la)
          call decode_chemin(argum,cw_directory,workdir,isdir,segm,found)
        endif
        if (found) then
          done = .true.
          call gtv_open_segments_for_writing_from_main()
          if (isdir) then
            call change_attr_dir(workdir,att_code,att_val)
          else
            call change_attr_seg(segm,att_code,att_val)
          endif
          call gtv_close_segments_for_writing_from_main()
        endif
      enddo
    endif
    !
  endif
  !
  if (done) then
    call gtview('Update')
  else
    call gtv_message(seve%e,rname,'No such segment '//argum_in)
    error = .true.
    return
  endif
  !
end subroutine gtl_change_attr
!
subroutine gtl_change_parse(line,iarg,reset,value,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_change_parse
  !---------------------------------------------------------------------
  ! @ private
  !  Retrieve the iarg-th argument of the command. Return reset=.true.
  ! (i.e. use internal default) if argument is wildcard '*', else
  ! reset=.false. and value is filled.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  integer(kind=4),  intent(in)    :: iarg   ! Argument number
  logical,          intent(out)   :: reset  !
  real(kind=4),     intent(out)   :: value  !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: nc
  character(len=8) :: arg
  !
  arg = '*'
  call sic_ch(line,0,iarg,arg,nc,.false.,error)
  if (error)  return
  !
  if (arg.eq.'*') then
    reset = .true.
    value = 0.  ! Unused
  else
    reset = .false.
    call sic_r4(line,0,iarg,value,.true.,error)
    if (error) return
  endif
  !
end subroutine gtl_change_parse
!
subroutine gtl_segment_parse(argum,iseg1,iseg2,error)
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>gtl_segment_parse
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Parse segment name given in input, return segments number (min and
  ! max) to search in
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: argum  ! Segment name to parse
  integer,          intent(out)   :: iseg1  ! Lower segment number
  integer,          intent(out)   :: iseg2  ! Upper segment number
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='SEGMENT'
  integer :: ia,ka,la,ier,isep
  character(len=*), parameter :: wildcard='********'
  character(len=gtvpath_length) :: dirname
  type(gt_directory), pointer :: workdir
  type(gt_segment), pointer :: segm
  logical :: isdir,found
  !
  ! Find what is the parent
  isep = index(argum,dir_sep,.true.)
  if (isep.eq.0) then
    workdir => cw_directory
  elseif (isep.eq.1) then
    workdir => root
  else
    dirname = argum(:isep-1)
    call decode_chemin(dirname,cw_directory,workdir,isdir,segm,found)
    if (.not.found .or. .not.isdir) then
      call gtv_message(seve%e,rname,'No such directory '//dirname)
      error = .true.
      return
    endif
  endif
  !
  la = len_trim(argum)
  ia = index(argum,':')
  ka = index(argum(ia:),'-')
  !
  if (ia.eq.la) then
    ! Form is "xxx:" corresponds to whole range
    iseg1 = 1
    iseg2 = workdir%segn
    !
  elseif (ia.eq.0 .and. ka.eq.0) then
    ! No ':', no '-'
    read(argum(1:la),'(I20)',iostat=ier) iseg1
    if (ier.eq.0) then
      ! argum is one or more digits
      iseg2=iseg1
      argum='*:'
    elseif (argum(1:la).eq.wildcard(1:min(8,la))) then
      ! argum is one or more stars
      iseg1 = 1
      iseg2 = workdir%segn
      argum = '*:'
    else
      ! argum should be a segment name
      iseg1 = 1
      iseg2 = workdir%segn
      ia=la+1
      argum(ia:ia) = ':'
    endif
    !
  elseif (ia.gt.0.and.ka.eq.0) then
    ! ':' but no '-'
    read(argum(ia+1:la),*,iostat=ier) iseg1
    if (ier.eq.0) then
      iseg2=iseg1
    elseif (argum(ia+1:la).eq.wildcard(1:min(8,la-ia))) then
      iseg1 = 1
      iseg2 = workdir%segn
    else
      call gtv_message(seve%e,rname,'Invalid segment name(s)')
      error = .true.
      return
    endif
    !
  else
    ! Range given?
    ka = ia-1+ka
    read(argum(ia+1:ka-1),*,iostat=ier) iseg1
    if (ier.eq.0) read(argum(ka+1:la),*,iostat=ier) iseg2
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Invalid segment range')
      error = .true.
      return
    endif
    if (ia.le.1) then
      ia = 2
      argum(1:ia) = '*:'
    endif
  endif
  !
end subroutine gtl_segment_parse
!
subroutine change_attr_seg(segm,att_code,att_val)
  use gtv_interfaces, except_this=>change_attr_seg
  use gtv_buffers
  use gtv_segatt
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Elemental routine which modifies the ATT_CODE-th attribute and
  ! assigns it ATT_VAl. Work on a single segment only.
  !---------------------------------------------------------------------
  type(gt_segment)            :: segm      ! Segment instance
  integer(kind=4), intent(in) :: att_code  ! Attribute code
  integer(kind=4), intent(in) :: att_val   ! Attribute value
  !
  select case (att_code)
  case (att_vis)
    segm%head%gen%visible = att_val.ge.0
  case (att_dash)
    segm%head%attr%dash = att_val
  case (att_weight)
    segm%head%attr%weight = att_val/1e4
  case (att_colour)
    segm%head%attr%colour = att_val
  case (att_depth)
    segm%head%attr%depth = att_val
    vdepth(att_val) = .true.
  end select
  !
end subroutine change_attr_seg
!
recursive subroutine change_attr_dir(dir,att_code,att_val)
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>change_attr_dir
  use gtv_protocol
  use gtv_segatt
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Routine which modifies the ATT_CODE-th attribute and assigns it
  ! ATT_VAl. Work on the input directory and its elements.
  !---------------------------------------------------------------------
  type(gt_directory)          :: dir       ! Directory
  integer(kind=4), intent(in) :: att_code  ! Attribute code
  integer(kind=4), intent(in) :: att_val   ! Attribute value
  ! Local
  type(gt_segment), pointer :: segm
  type(gt_directory), pointer :: son
  !
  ! Modification de l'attribut 'visible' du macrosegment donne
  if (att_code.eq.att_vis)  dir%gen%visible = att_val.ge.0
  !
  ! 1) Run on the current directory segments
  segm => dir%leaf_first
  do while (associated(segm))
    call change_attr_seg(segm,att_code,att_val)
    !
    ! Next segment
    segm => segm%nextseg
  enddo
  !
  ! 2) Run on the subdirectories
  son => dir%son_first
  do while (associated(son))
    call change_attr_dir(son,att_code,att_val)
    !
    ! Next directory
    son => son%brother
  enddo
  !
end subroutine change_attr_dir
!
subroutine change_scaling_image(segm,scaling,reset,value,strict,error)
  use gtv_bitmap
  use gtv_buffers
  use gtv_interfaces, except_this=>change_scaling_image
  use gtv_plot
  use gtv_segatt
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Modifie la valeur des attributs SCALING et CUTS
  !---------------------------------------------------------------------
  type(gt_segment), intent(inout) :: segm      ! Segment
  integer,          intent(in)    :: scaling   ! Scaling code (0 = do not change)
  logical,          intent(in)    :: reset(6)  ! Reset the cut limits?
  real(kind=4),     intent(in)    :: value(6)  ! Cut value, if reset
  logical,          intent(in)    :: strict    ! Is it an error that the segment is not an image?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CHANGE'
  type(gt_segment_data), pointer :: segdata
  type(gt_image), pointer :: image
  logical :: done
  !
  done = .false.
  segdata => segm%data
  do while (associated(segdata))
    if (segdata%kind.eq.seg_image) then
      !
      ! Il s'agit d'un segment-image
      image => segdata%image
      !
      ! Compute new range, resetting default if needed
      if (image%isrgb) then
        if (reset(1)) then
          image%r%cuts(1) = image%r%extrema(1)
        else
          image%r%cuts(1) = value(1)
        endif
        if (reset(2)) then
          image%r%cuts(2) = image%r%extrema(2)
        else
          image%r%cuts(2) = value(2)
        endif
        if (reset(3)) then
          image%g%cuts(1) = image%g%extrema(1)
        else
          image%g%cuts(1) = value(3)
        endif
        if (reset(4)) then
          image%g%cuts(2) = image%g%extrema(2)
        else
          image%g%cuts(2) = value(4)
        endif
        if (reset(5)) then
          image%b%cuts(1) = image%b%extrema(1)
        else
          image%b%cuts(1) = value(5)
        endif
        if (reset(6)) then
          image%b%cuts(2) = image%b%extrema(2)
        else
          image%b%cuts(2) = value(6)
        endif
      else
        if (reset(1)) then
          image%r%cuts(1) = image%r%extrema(1)
        else
          image%r%cuts(1) = value(1)
        endif
        if (reset(2)) then
          image%r%cuts(2) = image%r%extrema(2)
        else
          image%r%cuts(2) = value(2)
        endif
      endif
      !
      ! Put in place
      if (scaling.ne.0)  image%scaling = scaling
      !
      if (image%scaling.eq.scale_equ) then
        ! (New) scale is EQUAL: (re)compute the bins
        if (image%isrgb) then
          call gtv_image_equalize(image%r,error)
          if (error)  return
          call gtv_image_equalize(image%g,error)
          if (error)  return
          call gtv_image_equalize(image%b,error)
          if (error)  return
        else
          call gtv_image_equalize(image%r,error)
          if (error) return
        endif
      else
        ! Other scaling mode: eqvalues not needed, free memory
        if (allocated(image%r%eqvalues))  deallocate(image%r%eqvalues)
        if (allocated(image%g%eqvalues))  deallocate(image%g%eqvalues)
        if (allocated(image%b%eqvalues))  deallocate(image%b%eqvalues)
      endif
      !
      call gtv_image_variables(image,.true.,error)
      if (error)  return
      !
      done = .true.
    endif
    !
    ! Next data
    segdata => segdata%nextdata
    !
  enddo
  !
  if (.not.done .and. strict) then
    call gtv_message(seve%e,rname,'This is not an image segment')
    error = .true.
    return
  endif
  !
end subroutine change_scaling_image
!
recursive subroutine change_scaling_dir(dir,scaling,reset,value,error)
  use gtv_interfaces, except_this=>change_scaling_dir
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_directory), intent(in)    :: dir       ! Directory
  integer,            intent(in)    :: scaling   ! Scaling code
  logical,            intent(in)    :: reset(6)  ! Reset the cut limits?
  real(kind=4),       intent(in)    :: value(6)  ! Cut value, if reset
  logical,            intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CHANGE'
  type(gt_segment), pointer :: segm
  type(gt_directory), pointer :: son
  !
  ! 1) Run on the current directory segments
  segm => dir%leaf_first
  do while (associated(segm))
    call change_scaling_image(segm,scaling,reset,value,.false.,error)
    if (error)  return
    !
    ! Next segment
    segm => segm%nextseg
  enddo
  !
  ! 2) Run on the subdirectories
  son => dir%son_first
  do while (associated(son))
    call change_scaling_dir(son,scaling,reset,value,error)
    if (error)  return
    !
    ! Next directory
    son => son%brother
  enddo
  !
end subroutine change_scaling_dir
!
subroutine change_image_lut(head,image)
  use gtv_interfaces, except_this=>change_image_lut
  use gtv_bitmap
  use gtv_buffers
  use gtv_plot
  use gtv_segatt
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Change the input image LUT according to the current status of
  ! 'lut_static' flag
  !---------------------------------------------------------------------
  type(gt_segment_head), intent(in) :: head   ! Segment header
  type(gt_image)                    :: image  ! Image instance
  !
  image%lut => head%lut  ! Which can be null()
  !
end subroutine change_image_lut
!
subroutine change_poly_penlut(head,poly)
  use gtv_interfaces, except_this=>change_poly_penlut
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Change the input polyline/polygon PENLUT according to the current
  ! status of 'lut_static' flag
  !---------------------------------------------------------------------
  type(gt_segment_head), intent(in) :: head  ! Segment header
  type(gt_polyline)                 :: poly  ! Polyline instance
  !
  poly%penlut => head%lut  ! Which can be null()
  !
end subroutine change_poly_penlut

subroutine gio_crws (is,gtype,form,size,error)
  use gio_interfaces, except_this=>gio_crws
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF CReate Work Slot
  !     This is a pure virtual memory slot
  !     Used by SIC only
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: is     ! Image slot
  character(len=*),          intent(in)  :: gtype  ! Image type (GILDAS_vwxyz)
  integer(kind=4),           intent(in)  :: form   ! Data format
  integer(kind=size_length), intent(in)  :: size   ! Data size
  logical,                   intent(out) :: error  ! Error flag
  ! Local
  integer(kind=size_length) :: jsize
  integer(kind=record_length) :: leng
  character(len=*), parameter :: rname='GIO_CRWS'
  integer :: ier
  !
  jsize = size ! Test maximum size here
  !
  error = .true.
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    return
  elseif (islot(is).ne.code_gio_full) then
    call gio_message(seve%e,rname,'Image slot is already mapped')
    return
  endif
  leng = gio_block(form,jsize)
  !
  if (leng.eq.0) then
    ! This is actually acceptable for DEFINE HEADER A *
    ! but the Header must be initialized here, while
    ! it has already been initialized otherwise.
    if (gtype(1:9).eq.'GILDAS_UV') then
      call gildas_null(gheads(is),type='UVT')
    else
      call gildas_null(gheads(is))
    endif
  endif
  !
  ! Write header
  iconv(is) = 0
  ier = gio_wih (is,gtype,form,leng)
  if (ier.eq.0) return
  !
  ! Now set the proper dimensions
  call gio_idim (is,jsize)
  iform(is) = form
  ichan(is) = 0
  islot(is) = code_gio_write
  error = .false.
end subroutine gio_crws

module cubetools_datasize
  use cubetools_parameters
  use cubetools_messaging
  !
  integer(kind=4), parameter :: size_k = 4
  !
  real(kind=size_k), parameter :: kiB=1.024e3    ! Number of bytes in 1 kiB (1024**1)
  real(kind=size_k), parameter :: MiB=1.048576e6 ! Number of bytes in 1 MiB (1024**2)
  real(kind=size_k), parameter :: GiB=1.07374e9  ! Number of bytes in 1 GiB (1024**3)
  !
  integer(kind=4), parameter :: ikiB = 1
  integer(kind=4), parameter :: iMiB = 2
  integer(kind=4), parameter :: iGiB = 3
  !
  integer(kind=4), parameter :: ndataunit = 3
  character(len=*), parameter :: dataunit(ndataunit) =  ['kiB','MiB','GiB']
  real(kind=size_k), parameter :: dataconv(ndataunit) = [ kiB,  MiB,  GiB]
  !
  public :: size_k,kiB,MiB,GiB,dataunit,ikiB,iMiB,iGiB
  public :: cubetools_datasize_user2prog
  private
  !
contains
  subroutine cubetools_datasize_user2prog(user,unit,defsize,prog,error)
    use cubetools_disambiguate
    !------------------------------------------------------------------------
    ! Transforms an user size from user unit to a value in bytes
    !------------------------------------------------------------------------
    character(len=*),  intent(in)    :: user
    character(len=*),  intent(in)    :: unit
    real(kind=size_k), intent(in)    :: defsize
    real(kind=size_k), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    integer(kind=4) :: nc,ikey
    character(len=argu_l) :: key
    real(kind=size_k) :: tmp
    character(len=*), parameter :: rname='DATASIZE>USER2PROG'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    select case(user)
    case (strg_unk)
       call cubetools_message(seve%e,rname,'String is unknown, maybe&
            & uninitialized?')
       error = .true.
       return
    case (strg_star)
       prog = defsize
    case (strg_equal)
       return
    case default
       nc = len_trim(user)
       call sic_math_real(user,nc,tmp,error)
       if (error) then
          call cubetools_message(seve%e,rname,'Cannot convert '//trim(user)//' to a data size' )
          return
       endif
       if (tmp.le.0) then
          call cubetools_message(seve%e,rname,'Data size must be positive' )
          error = .true.
          return
       endif
       call cubetools_disambiguate_strict(unit,dataunit,ikey,key,error)
       if (error) return
       prog = tmp*dataconv(ikey)
    end select
  end subroutine cubetools_datasize_user2prog
end module cubetools_datasize

module sic_define_status
  logical :: strict_define = .true.
  integer(kind=4), parameter :: code_header=0        ! Header of any kind
  integer(kind=4), parameter :: code_image=1         !
  integer(kind=4), parameter :: code_uv=2            !
  integer(kind=4), parameter :: code_table=3         !
  integer(kind=4), parameter :: code_header_image=4  ! Header for a GDF image
  integer(kind=4), parameter :: code_header_uv=5     ! Header for a GDF UV table
end module sic_define_status
!
subroutine sic_define (line,nline,error)
  use gildas_def
  use gbl_message
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_define
  use sic_dictionaries
  use sic_interactions
  use sic_structures
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Support routine for command
  !       DEFINE Type Variable1 [Variable2 [...]]] 
  !         [/GLOBAL] [/LIKE Other] [/TRIM]
  !       Defines new variables, local or global
  !       DEFINE CHARACTER*Length  is now supported
  !---------------------------------------------------------------------
  character(len=*)                :: line   ! Command line          Input
  integer(kind=4)                 :: nline  ! Length of line        Input
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer, parameter :: nwhat=17
  character(len=12) :: status,what(nwhat),keyw
  character(len=6) :: ext(nwhat)
  character(len=filename_length) :: chain,filename
  character(len=132) :: name,cast,like
  character(len=commandline_length) :: trans
  integer :: ntype,i,nc,nn,nt,dtype(nwhat),itype,nlike,list(maxvar),in
  type(sic_descriptor_t) :: lkdesc
  logical :: global,do_like,found
  integer(kind=4) :: therank,istar,isize
  character(len=24) :: type,clength
  !
  ! CAUTION: The ordering cannot be changed in the following definitions.
  !
  ! Problem: fmt_r4 is -1 on VAX
  integer, parameter :: unused = 1000 ! > 10
  data dtype /fmt_r4,fmt_r8,fmt_i4,fmt_i8,fmt_l,0,  &
              fmt_c4,8,9,10,11,unused,unused, &
              unused,fmt_r4,unused,unused/
              ! ,fmt_r4, fmt_r4, fmt_r4, fmt_r4, unused/
  !
  data what /'REAL','DOUBLE','INTEGER','LONG','LOGICAL','CHARACTER',      &
    'COMPLEX','TABLE','STRUCTURE','IMAGE','HEADER','FUNCTION','COMMAND',  &
    'FITS','UVTABLE','ALIAS','LANGUAGE'/
  data ext /' ', ' ', ' ', ' ', ' ', ' ', &
    ' ','.tab', ' ', '.gdf', '.gdf', ' ', ' ', &
    '.fits', '.uvt', ' ', ' '/
  ! ,'VO_TABLE', 'TUV_TABLE', 'CLASS_TABLE', 'CLASS_VO', 'SPREADSHEET' /
  ! Code ----------------------------------------------------------------
  call sic_ke (line,0,1,type,nn,.true.,error)
  if (error) return
  !
  ! Set default character length if present...
  istar = index(type,'*')
  if (istar.ne.0) then
     clength = type(istar:nn)
     type(istar:) = ' '
  endif
  !
  ! Check if type of variable is known
  call sic_ambigs('DEFINE',type,keyw,ntype,what,nwhat,error)
  if (error) return
  if (istar.ne.0 .and. ntype.ne.6) then
     call sic_message(seve%e,'DEFINE '//keyw,' *Length not supported')
     error = .true.
     return
  endif
  !
  ! /GLOBAL option
  if (sic_present(1,0)) then
    global = .true.
  else
    ! If current level is non 0, variable is Local
    global = (var_level.le.0)
  endif
  !
  select case (keyw)
  case ('FUNCTION')
    call sic_ke (line,0,2,chain,nc,.true.,error)
    if (error) return
    call sic_ch (line,0,3,name,nn,.true.,error)
    if (error) return
    call sic_upper(name)
    call sic_def_expr(chain,nc,name,nn,error)
    return
    !
  case ('LANGUAGE')
    call sic_ke (line,0,2,chain,nc,.true.,error)
    if (error) return
    filename = ' '
    call sic_ch(line,0,3,filename,nn,.false.,error)
    if (error) return
    call sic_define_language(chain,filename,error)
    if (error)  return
    return
    !
  case ('COMMAND')
    call sic_ke(line,0,2,chain,nc,.true.,error)
    if (error) return
    call sic_ch(line,0,3,trans,nn,.true.,error)
    if (error) return
    filename = ' '
    call sic_ch(line,0,4,filename,nn,.false.,error)
    if (error) return
    !
    ! Insert in appropriate language and resolve language on return
    call sic_loadcom(filename,chain,trans,1,error)
    if (error)  return
    !
    return
    !
  case ('ALIAS')
    call sic_alias(line,global,error)
    return
    !
  case ('FITS')
    call sic_fits(line,global,error)
    return
  end select
  !
  ! /LIKE
  do_like = sic_present(2,0)
  if (do_like) then
    call sic_ke (line,2,1,like,nlike,.true.,error)
    if (error) return
  endif
  !
  ! Structures
  if (keyw.eq.'STRUCTURE') then
    do i=2,sic_narg(0)
      call sic_ke (line,0,i,name,nn,.true.,error)
      if (error) return
      call sic_crestructure(name,global,error)
      if (error) return
      !
      if (do_like) then  ! Fill the structure
        call gag_haslis(maxvar,pfvar,pnvar,list,in)
        call sic_define_likestruct(name,like,list,in,global,error)
        if (error) return
      endif
    enddo
    return
  endif
  !
  ! /LIKE
  cast = ' '
  if (do_like) then
    found = .true.
    call sic_materialize (like,lkdesc,found) ! Checked, but could be changed
    if (.not.found) then
      call sic_message(seve%e,'DEFINE /LIKE','No such variable '//like)
      error = .true.
      return
    endif
    !
    if (lkdesc%type.eq.0) then
      like = trim(like)//'%DATA'
      call sic_materialize(like,lkdesc,found)
      if (.not.found) then
        call sic_message(seve%e,'DEFINE /LIKE','No variable '//like)
        error = .true.
        return
      endif
    endif
    !
    call sic_define_likevar(lkdesc,cast)  ! Retrieve dimensions in 'cast'
    !
    call sic_volatile(lkdesc)    ! If it had been transposed...
  endif
  !
  ! Array-able variables (i.e. numerics and strings)
  if (ntype.le.7) then
    if (ntype.eq.3) then  ! DEFINE INTEGER
      itype = sicinteger
    else
      itype = dtype(ntype)
    endif
    do i=2,sic_narg(0)
      call sic_ke (line,0,i,name,nn,.true.,error)
      if (error) return
      !
      ! Insert default length if needed
      if (istar.ne.0) then
         isize = index(name,'*')
         if (isize.eq.0) then
            isize = index(name,'[')
            if (isize.ne.0) then
               name = name(1:isize-1)//trim(clength)//name(isize:)
            else
               name = trim(name)//trim(clength)
            endif
         endif
      endif
      !
      name = trim(name)//cast
      call sic_defvariable(itype,name,global,error)
      if (error) return
    enddo
  !
  ! Image, Headers and Tables
  elseif (ntype.ge.8) then
    if (sic_present(3,1)) then
      call sic_i4(line,3,1,therank,.false.,error)
      if (error) return
      if (therank.eq.0 .or. abs(therank).gt.sic_maxdims) then
        write(cast,'(A,I0,A,I0,A)') & 
        & 'Invalid trim value, must be in range [-', &
        & sic_maxdims,',-1] or [1,',sic_maxdims,']'
        call sic_message(seve%e,'DEFINE /TRIM',cast)
        error = .true.
        return
      endif
    else if (sic_present(3,0)) then
      therank = -10  ! Trim all dimensions
    else
      therank = 0  ! Option /TRIM was absent
    endif
    i = 2
    do while (i.le.sic_narg(0))
      ! Variable name
      call sic_ke (line,0,i,name,nn,.true.,error)
      if (error) return
      ! Add like-dimensions (if any)
      name(nn+1:) = cast
      ! Associated filename
      call sic_ch (line,0,i+1,chain,nt,.true.,error)
      if (error) return
      if (chain(1:nt).ne.'*') then
        call sic_parse_file(chain,' ',ext(ntype),filename)
      else
        filename = '*'
      endif
      ! Status
      call sic_ke (line,0,i+2,status,nt,.true.,error)
      if (error) return
      i = i+3
      !
      if (ntype.eq.8) then
        call sic_define_table (name,filename,status,global,2,error)
      elseif (ntype.eq.11) then
        call sic_define_header (name,filename,status,global,therank,error)
      elseif (ntype.eq.10) then
        call sic_define_image (name,filename,status,global,therank,error)
      elseif (ntype.eq.15) then
        call sic_define_uvtable (name,filename,status,global,0,error)
      endif
      if (error) return
    enddo
  endif
  !
end subroutine sic_define
!
subroutine sic_define_likevar(desc,cast)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_define_likevar
  use gildas_def
  use sic_types
  !---------------------------------------------------------------------
  ! @private
  ! Return the dimensions (if any) of variable described by the input
  ! descriptor. Return an empty string if this variable is a scalar.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)  :: desc  ! Variable descriptor
  character(len=*),       intent(out) :: cast  ! Dimensions as string
  ! Local
  integer :: i,nc
  !
  if (desc%ndim.ge.1) then
    write (cast,1010) (desc%dims(i),i=1,desc%ndim)
    nc = len_trim(cast)
    cast(nc:nc) = ']'
  else
    cast=' '
  endif
  !
1010 format('[',10(i0,','))  ! Support up to 10 dimensions
end subroutine sic_define_likevar
!
recursive subroutine sic_define_likestruct(newvar,like,inlist,nelem,global,error)
  use sic_interfaces, except_this=>sic_define_likestruct
  use gildas_def
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    DEFINE STRUCTURE MYNEW /LIKE MYOLD
  ! Fill a (just defined) structure with the same tree as the other
  ! (already existing) structure given with option /LIKE.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: newvar         ! Name of structure to be filled
  character(len=*), intent(in)    :: like           ! Name of structure used like
  integer,          intent(in)    :: nelem          ! Number of variables to check
  integer,          intent(in)    :: inlist(nelem)  ! List of variable to check
  logical,          intent(in)    :: global         ! Will new variable be global?
  logical,          intent(inout) :: error          ! Error flag
  ! Local
  integer, allocatable :: list(:)
  integer :: ielem,ik,sl,vtype,selected,ier
  character(len=varname_length) :: varname,structname,newvarsub
  character(len=132) :: cast
  !
  sl = len_trim(like)
  if (like(sl:sl).eq.'%') then
    structname = like
  else
    structname = trim(like)//'%'  ! MYOLD%
    sl = sl+1
  endif
  !
  ! 1/ Search structure elements
  allocate(list(nelem),stat=ier)
  selected = 0
  do ielem=1,nelem
    ik = inlist(ielem)
    varname = dicvar(ik)%id%name
    if (index(varname,structname(:sl)).eq.1) then  ! Begins with 'MYOLD%'
       selected = selected+1
       list(selected) = ik
    endif
  enddo
  !
  ! 2/ Loop over selected elements
  do ielem=1,selected
    ik = list(ielem)
    varname = dicvar(ik)%id%name
    if (index(varname(sl+1:),'%').eq.0) then  ! MYOLD%FOO
      ! Bind only variable at this level. Sub-elements in sub-structures will
      ! be bound in a recursion call.
      vtype = dicvar(ik)%desc%type
      newvarsub = trim(newvar)//'%'//varname(sl+1:)  ! MYNEW%FOO
      !
      if (vtype.eq.0) then
        ! A structure
        call sic_crestructure(newvarsub,global,error)
        if (error) exit  ! ielem
        call sic_define_likestruct(newvarsub,varname,list,selected,global,error)
      else
        ! Something else
        call sic_define_likevar(dicvar(ik)%desc,cast)
        call sic_defvariable(vtype,trim(newvarsub)//cast,global,error)
      endif
      if (error) exit  ! ielem
    endif
  enddo
  !
  deallocate(list)
  !
end subroutine sic_define_likestruct
!
function sic_checkstruct(namein,global)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>sic_checkstruct
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Check wether the name NAMEIN is a structure member. It is normally
  ! forbidden to attach a new element under a header/image, except for
  ! aliases.
  !
  ! Return values
  !     1        The parent structure exists
  !     0        There is no parent structure
  !     -1       This is not a structure member
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_checkstruct      ! Function value on return
  character(len=*), intent(in) :: namein  ! Variable name
  logical,          intent(in) :: global  ! Input variable status
  ! Local
  character(len=*), parameter :: rname='CHECK'
  integer(kind=4) :: in,n,i,ier
  type(sic_identifier_t) :: parent
  logical :: isheader,allowed
  !
  sic_checkstruct = 0
  n = len_trim(namein)
  if (namein(n:n).eq.'%') then
    call sic_message(seve%e,rname,'Invalid structure member name '//  &
    namein(1:n-1))
    sic_checkstruct = 0
    return                     ! on error
  endif
  do i=n,2,-1
    if (namein(i:i).eq.'%') then ! seems to be a structure
      parent%name = namein(1:i-1)
      parent%lname = i-1
      ! Add the last Byte according to the parent structure status
      if (global) then
        parent%level = 0
      else
        parent%level = var_level
      endif
      ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,parent,in)
      if (ier.ne.1) then
        if (global) then
          call sic_message(seve%e,rname,  &
            'Global structure '//trim(parent%name)//' does not exist')
        else
          call sic_message(seve%e,rname,  &
            'Structure '//trim(parent%name)//' does not exist')
        endif
        sic_checkstruct = 0
        ! was a structure member of an unknown variable/struct
        return
      endif
      ! Check if it is a structure or a header
      isheader = associated(dicvar(in)%desc%head)
      if (dicvar(in)%desc%type.ne.0 .and. .not.isheader) then
        call sic_message(seve%e,rname,trim(parent%name)//' is not a structure')
        sic_checkstruct = 0
        return
      endif
      allowed = dicvar(in)%desc%status.eq.user_defined .or.  &
                dicvar(in)%desc%status.eq.program_defined .or.  &
                isheader
      if (.not.allowed) then
        call sic_message(seve%e,rname,'Not allowed on the structure '//parent%name)
        sic_checkstruct = 0
        return                 ! not a structure
      endif
      sic_checkstruct = 1
      return                   !good structure
    endif
  enddo
  sic_checkstruct = -1
  return                       !not a structure member
end function sic_checkstruct
!
subroutine sic_defvariable (type,namein,global,error)
  use sic_interfaces, except_this=>sic_defvariable
  use gildas_def
  use sic_dependencies_interfaces
  use sic_structures
  use sic_dictionaries
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public (for Python port)
  !  Define a new user-defined variable (usually from command DEFINE).
  ! Variable necessarily has Read-Write access
  !---------------------------------------------------------------------
  integer                         :: type    ! Data type code          Input
  character(len=*)                :: namein  ! Variable name
  logical                         :: global  ! Is variable global?     Input
  logical,          intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer :: in,i,blank,zero,nchar,ier
  integer(kind=8) :: ntot
  integer(kind=8), parameter :: maxi4=2147483647_8 ! 2**31-1
  integer(kind=1) :: bblank(4)
  equivalence (blank,bblank)
  type(sic_identifier_t) :: var
  integer(kind=address_length) :: ipnt
  type(sic_dimensions_t) :: spec
  logical :: verbose,lglobal
  character(len=132) :: cast
  ! Data
  save blank
  data bblank /32,32,32,32/
  data zero /0/
  !
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .false.  ! A[2:4] forbidden
  spec%do%subset   = .false.  ! A[2,]  forbidden
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .false.  ! e.g. A[i][j:k] forbidden
  verbose = .true.
  if (type.eq.0) then
    call sic_parse_char(namein,var,nchar,spec,verbose,error)
  else
    call sic_parse_dim (namein,var,      spec,verbose,error)
  endif
  if (.not.error) call sic_validname(var%name,error)
  if (error) then
    ! Invalid variable name, probably too long.
    call sic_message(seve%e,rname,'Invalid variable name '//namein)
    return
  endif
  !
  if (var_level.eq.0) then
    lglobal = .true.
  else
    lglobal = global
  endif
  !
  ! Check variable size
  ntot = 1
  do i=1,spec%done(1)%ndim
    ntot = ntot*spec%done(1)%dims(i,1)
  enddo
  if (ntot.gt.maxi4) then
    if (index_length.eq.4) then
      call sic_message(seve%e,rname,  &
      'Arrays of more than 2**31-1 elements not supported')
       error = .true.
    endif
  endif
  !
  ! Check if variable is already defined. First, variable must be either
  ! a true variable or a component of an existing structure.
  if (sic_checkstruct(var%name,lglobal).eq.0) then
    error = .true.
    return
  endif
  if (lglobal) then
    var%level = 0
  else
    var%level = var_level
  endif
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.1) then
    !  the actual size of the already-defined variable
    call sic_define_likevar(dicvar(in)%desc,cast)
    call sic_message(seve%e,rname,'Variable '//trim(var%name)//trim(cast)//' already exists')
    error = .true.
    return
  endif
  ier = sic_hasins(rname,maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.0 .or. ier.eq.2) then
    error = .true.
    return
  endif
  !
  ! Fill the descriptor
  dicvar(in)%desc%ndim = spec%done(1)%ndim
  dicvar(in)%desc%dims(:) = spec%done(1)%dims(:,1)
  dicvar(in)%desc%status = user_defined
  dicvar(in)%desc%head => null()
  !
  ! Character variable
  if (type.eq.0) then
    dicvar(in)%desc%type = nchar
    dicvar(in)%desc%readonly = .false.
    ! Round up to an integer number of word
    dicvar(in)%desc%size = (ntot*nchar+3)/4
  elseif (type.gt.0) then
    dicvar(in)%desc%type = type
    dicvar(in)%desc%readonly = .false.
    dicvar(in)%desc%size = (ntot*type+3)/4
  else
    dicvar(in)%desc%type = type
    dicvar(in)%desc%readonly = .false.
    if (type.eq.fmt_r8) then
      dicvar(in)%desc%size = 2*ntot
    elseif (type.eq.fmt_c4) then
      dicvar(in)%desc%size = 2*ntot
    elseif (type.eq.fmt_i8) then
      dicvar(in)%desc%size = 2*ntot
    else
      dicvar(in)%desc%size = ntot
    endif
  endif
  ier = sic_getvm (dicvar(in)%desc%size,dicvar(in)%desc%addr)
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'Memory allocation failure')
    ier = sic_hasdel(maxvar,pfvar,pnvar,dicvar,var)
    error = .true.
    return
  endif
  ipnt = gag_pointer(dicvar(in)%desc%addr,memory)
  !
  ! Initialize characters to blanks, and all others to zero
  if (type.ge.0) then
    call gdf_fill (dicvar(in)%desc%size,memory(ipnt),blank)
  else
    call gdf_fill (dicvar(in)%desc%size,memory(ipnt),zero)
  endif
  if (lglobal) then
    var_g = var_g-1
    var_pointer (var_g) = in
  else
    var_n = var_n+1
    var_pointer (var_n) = in
  endif
  error = .false.
  !
  ! Write into LUNSAV file if in SAVE mode
  if (lunsav.ne.0) then
    write(lunsav,'(A,1X,A)') savcom(1:lsavcom),trim(var%name)
  endif
  !
#if defined(GAG_USE_PYTHON)
  call gpy_getvar(var%name,var%level)
#endif
end subroutine sic_defvariable
!
subroutine sic_inivariable
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_inivariable
  use sic_dictionaries
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC
  !     Initialize the variable structure list
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='INIVAR'
  integer :: ier
  character(len=message_length) :: mess
  !
  ! Check if user have customized its SIC_MAXVAR
  maxvar = maxvardef
  ier = sic_getlog('SIC_MAXVAR',maxvar)
  if (ier.eq.0) then
    write(mess,'(A,I0)')  'User-defined SIC_MAXVAR is ',maxvar
    call sic_message(seve%d,rname,mess)
  elseif (ier.eq.2) then
    call sic_message(seve%f,rname,  &
      'Could not decode user-defined SIC_MAXVAR logical variable')
    call sysexi(fatale)
  endif
  !
  ! Allocate variable arrays
  allocate(dicvar(maxvar),pnvar(maxvar),var_pointer(maxvar),    &
  &  alias(maxvar),dicali(maxvar),pointee(maxvar),stat=ier)
  if (ier.ne.0) then
     call sic_message(seve%f,rname,'Insufficient memory for Dictionary')
     call sysexi(fatale)
  endif
  !
  ! Initialize arrays
  call gag_hasini(maxvar,pfvar,pnvar)
  var_g = maxvar+1
  var_n = 0
  nalias = 0
  !
end subroutine sic_inivariable
!
subroutine sic_define_image(namein,file,status,global,therank,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_structures
  use sic_dictionaries
  use sic_define_status
  use sic_interfaces, except_this=>sic_define_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !     Define a new variable associated to an image file from command
  !     DEFINE IMAGE Variable File Read|Write|Integer|Real|Double|Extend
  !     Variable may have ReadOnly protection.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: namein   ! Variable name
  character(len=*), intent(in)    :: file     ! Associated file name
  character(len=*), intent(in)    :: status   ! Variable type / status
  logical,          intent(in)    :: global   ! Global or Local variable
  integer(kind=4),  intent(in)    :: therank  ! Trim degenerate dimensions
  logical,          intent(inout) :: error    ! Return error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer(kind=4) :: in,istat,ier,actual_rank
  integer(kind=address_length) :: ipnt
  type(sic_identifier_t) :: var
  type(sic_descriptor_t) :: desc
  integer(kind=4), parameter :: mstates=8
  character(len=8) :: keyw,states(mstates)
  logical :: do_header,rdonly
  character(len=132) :: mess
  type(sic_dimensions_t) :: spec
  logical :: verbose
  ! EXTEND must be the last one
  data states/'READ','WRITE','INTEGER','LONG','REAL','DOUBLE','COMPLEX','EXTEND'/
  integer :: code
  !
  code = code_image  ! Need IMAGE data
  do_header = .true.
  goto 10
  !
entry sic_define_uvtable (namein,file,status,global,therank,error)
  code = code_uv
  do_header = .true.
  goto 10
  !
entry sic_define_table (namein,file,status,global,therank,error)
  code = code_table
  do_header = .false.
  !
10 continue
  !
  ! Check STATUS
  call sic_ambigs('IMAGE',status,keyw,istat,states,mstates,error)
  if (error) return
  !
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .false.  ! A[2:4] forbidden
  spec%do%subset   = .false.  ! A[2,]  forbidden
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .false.  ! e.g. A[i][j:k] forbidden
  verbose = .true.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error)  return
  call sic_validname(var%name,error)
  if (error) return
  if (istat.le.2 .and. spec%done(1)%ndim.ne.0) then
    call sic_message(seve%e,rname,'Cannot specify dimension for existing '//  &
    'image')
    error = .true.
    return
  elseif (istat.ge.3 .and. spec%done(1)%ndim.eq.0) then
    call sic_message(seve%e,rname,'Missing dimension of new image')
    error = .true.
    return
  elseif (istat.eq.mstates .and. spec%done(1)%ndim.ne.1) then
    call sic_message(seve%e,rname,'Only last dimension can be extended')
    error = .true.
    return
  endif
  !
  ! Check if variable is already defined. First, variable must be either
  ! a true variable or a component of an existing structure.
  if (sic_checkstruct(var%name,global).eq.0) then
    error = .true.
    return
  endif
  if (var%lname.gt.varname_length-12) then
    write(mess,1001) 'IMAGE names must be at most ',varname_length-12,' char'
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  if (global) then
    var%level = 0
  else
    var%level = var_level
  endif
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,'Variable '//trim(var%name)//  &
      ' already exists')
    error = .true.
    return
  endif
  !
  ! Readonly Status
  rdonly = istat.eq.1
  !
  if (istat.eq.mstates) then
    call sic_define_extend_file(file,spec%done(1)%dims(1,1),desc,error)
    actual_rank = desc%ndim
    !
  elseif (istat.gt.2) then  ! Create a new file
    if (code.eq.code_uv) then
      ! How to check table size?
      call sic_define_new_uvtable(file,spec%done(1)%ndim,spec%done(1)%dims,desc,istat,error)
    else
      call sic_define_new_file(file,spec%done(1)%ndim,spec%done(1)%dims,desc,istat,code,error)
    endif
    actual_rank = desc%ndim
    !
  else  ! READ or WRITE: reopen an old file
    actual_rank = therank
    call sic_define_old_file(file,code,rdonly,actual_rank,desc,error)
  endif
  if (error) return
  !
  ier = sic_hasins(rname,maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.0 .or. ier.eq.2) then
    error = .true.
    return
  endif
  !
  if (global) then
    var_g = var_g-1
    var_pointer (var_g) = in
  else
    var_n = var_n+1
    var_pointer (var_n) = in
  endif
  dicvar(in)%desc = desc
  !
  ! Header if required
  if (do_header) then
    call sub_def_header(var,'%',desc%head,rdonly,actual_rank,error)
    ! Define Var%RDONLY to be able to access the Read Status.
    call sub_def_logi(trim(var%name)//'%RDONLY',dicvar(in)%desc%readonly, &
      .true.,var%level,error)
#if defined(GAG_USE_PYTHON)
    call gpy_getvar(var%name,var%level)
#endif
    !
    ! And extra data if required & possible
    if (code.eq.code_uv) then
      call sic_def_uvcoor(var,memory(ipnt),desc,rdonly,error)
    endif
  endif
  !
#if defined(GAG_USE_PYTHON)
  call gpy_getvar(var%name,var%level)
#endif
  !
1001 format(a,i2,a)
end subroutine sic_define_image
!
subroutine sic_define_old_file(filename,code,rdonly,rank,desc,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_define_old_file
  use sic_define_status
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support subroutine for
  !   DEFINE HEADER
  !   DEFINE IMAGE
  !   DEFINE TABLE
  !   DEFINE UVTABLE
  ! Open an old (already existing) file and fill the corresponding Sic
  ! structure, mapped on a GIO slot
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: filename  !
  integer(kind=4),        intent(in)    :: code      ! Kind of object (header, image, uv...)
  logical,                intent(in)    :: rdonly    !
  integer(kind=4),        intent(inout) :: rank      ! Desired rank (in) / actual rank (out)
  type(sic_descriptor_t), intent(out)   :: desc      !
  logical,                intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer(kind=4) :: filekind
  !
  if (filename.eq.'*') then
    filekind = 1  ! GDF
  else
    call gag_file_guess(rname,filename,filekind,error)
    if (error)  return
  endif
  !
  if (filekind.eq.2 .and. (code.eq.code_header .or. code.eq.code_image)) then
    ! DEFINE IMAGE|HEADER on a FITS file
    if (.not.rdonly) then
      call sic_message(seve%e,rname,'FITS file can only be opened with READ status')
      error = .true.
      return
    endif
    call sic_define_map_fits(filename,code,desc,rank,error)
    if (error)  return
    rank = desc%head%gil%ndim
    !
  else
    ! A GDF file, or a FITS UV or table
    call sic_define_map_file(filename,desc,rdonly,code,rank,error)
    if (error)  return
  endif
  !
end subroutine sic_define_old_file
!
subroutine sic_define_map_file(file,desc,rdonly,code,therank,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_define_map_file
  use gildas_def
  use image_def
  use gbl_format
  use gbl_message
  use sic_define_status
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Map an existing image, or a virtual buffer, in a gio image slot, in
  ! ReadOnly or ReadWrite.
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: file     ! Image name
  type(sic_descriptor_t), intent(out)   :: desc     ! Descriptor
  logical,                intent(in)    :: rdonly   ! Open in Read Only
  integer(kind=4),        intent(in)    :: code     ! Kind of object (header, image, uv...)
  integer(kind=4),        intent(inout) :: therank  ! Trim trailing dimensions
  logical,                intent(inout) :: error    ! Error flag
  ! Local
  integer(kind=4) :: is,form,ms,myseve
  integer(kind=size_length) :: size
  integer(kind=index_length) :: whole(gdf_maxdims) = 0
  integer(kind=address_length) :: addr
  character(len=12) :: gtype
  character(len=60) :: mess
  character(len=14) :: rname
  !
  call gio_geis (is,error)
  if (error) return
  !
  if (rdonly) then
    call gio_reis (is,gtype,file,form,size,error)
    desc%type = form
  else
    if (file.eq.'*') then
      if (code.eq.code_header_uv) then
        gtype = 'GILDAS_UVFIL'
      else
        gtype = 'GILDAS_IMAGE'
      endif
      call gio_crws (is,gtype,form,size,error)
    else
      call gio_wris (is,gtype,file,form,size,error)
    endif
    desc%type = form
  endif
  if (error) goto 99
  !
  desc%readonly = rdonly
  !
  !!Print *,'After GDF_REIS or WRIS Form ',form
  !
  if (form.eq.fmt_r8 .or. form.eq.fmt_i8 .or. form.eq.fmt_c4)  size = 2*size
  !
  if (code.eq.code_header       .or.  &
      code.eq.code_header_image .or.  &
      code.eq.code_header_uv) then
    rname = 'DEFINE HEADER'
    !
    ! option /RANK checking, although the job is done later in some case
    call gdf_dims(is,desc%ndim,desc%dims)
    call trim_rank(rname,desc%ndim,desc%dims,therank,error)
    if (error) goto 99
    !
    desc%type = 0
    desc%addr = ptr_null
    desc%ndim = 0
    desc%dims(:) = 0
    desc%size = 0
    desc%status = 0
  else
    if (code.eq.code_image) then
      rname = 'DEFINE IMAGE'
      if (gtype.ne.'GILDAS_IMAGE') then
        mess = 'Mismatch '//gtype//' for Image'
        error = .true.
      endif
    else if (code.eq.code_uv) then
      rname = 'DEFINE UVTABLE'
      if (gtype.ne.'GILDAS_UVFIL') then
        mess = 'Mismatch '//gtype//' for UV data'
        error = .true.
      endif
    endif
    if (error) then
      if (strict_define) then
        myseve = seve%e
      else
        myseve = seve%w
        error = .false.
      endif
      call sic_message(myseve,rname,mess)
      if (error) then
         call sic_message(seve%i,rname,'You can turn off checking with '// &
           'SIC%DEFINE_STRICT = NO')
         goto 99
      endif
    endif
    !
    call gio_gems (ms,is,whole,whole,addr,form,error)
    !!Print *,'After GDF_GEMS'
    !!call gio_dump_slot(is) ! Test
    if (error) goto 99
    call adtoad(addr,desc%addr,1) ! Copy to C_PTR if needed
    call gdf_dims(is,desc%ndim,desc%dims)
    !
    ! Check image size
    call desc_toobig(desc,error)
    if (error)  goto 98
    !
    ! option /RANK: adjust array rank to desired shape
    call trim_rank(rname,desc%ndim,desc%dims,therank,error)
    if (error) goto 98
    !
    desc%size = size
  endif
  !
  desc%status = is
  call gdf_geih(desc%status,desc%head,error)
  if (error)  goto 98
  return
  !
98 call gio_frms (ms,error)
99 call gio_fris (is,error)
  error = .true.
end subroutine sic_define_map_file
!
subroutine sic_define_map_fits(file,code,desc,rank,error)
  use gildas_def
  use gbl_message
  use image_def
  use gfits_types
  use sic_dependencies_interfaces, no_interface=>fitscube2gdf_patch_bval
  use sic_interfaces, except_this=>sic_define_map_fits
  use sic_dictionaries
  use sic_types
  use sic_define_status
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  DEFINE IMAGE|HEADER Var FitsFile READ
  ! i.e. fill (memory-only) a FITS file to a GDF image structure and map
  ! it on a GIO slot
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: file   !
  integer(kind=4),        intent(in)    :: code   ! Kind of object (header, image, uv...)
  type(sic_descriptor_t), intent(out)   :: desc   !
  integer(kind=4),        intent(inout) :: rank   ! Desired rank (in) / actual rank (out)
  logical,                intent(inout) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer(kind=4) :: is,ms,fdata
  integer(kind=4), parameter :: khdu=1  ! Desired HDU. 1 is Primary HDU.
  integer(kind=size_length) :: nfill,ndata,sdata,nblank
  type(gildas) :: fits
  integer(kind=index_length) :: whole(gdf_maxdims)
  integer(kind=address_length) :: ipnt
  character(len=12) :: gtype
  type(gfits_hdesc_t) :: fd
  character(len=message_length) :: mess
  !
  if (code.eq.code_uv .or. code.eq.code_table) then
    ! Early exit in this case
    call sic_message(seve%e,rname,'Reading FITS file as TABLE or UVTABLE is not implemented')
    error = .true.
    return
  endif
  !
  ! Open FITS file, including basic sanity checks
  call gfits_open(file,'IN',error)
  if (error)  return
  call gfits_goto_hdu(fd,khdu,error)
  if (error)  goto 10
  !
  ! --- Read the header (always) ---
  call gildas_null(fits)
  !
  call fitscube2gdf_header(file,khdu,fd,fits,sic_getsymbol,error)
  if (error)  goto 10
  !
  ! --- Trim image rank if needed ---
  call trim_rank(rname,fits%gil%ndim,fits%gil%dim,rank,error)
  if (error)  goto 10
  !
  ! --- Data description (useful even in case of code_header) ---
  ndata = product(fits%gil%dim(1:fits%gil%ndim))  ! Number of elements
  sdata = ndata   ! Size of data. This assumes R*4 data (i.e. should be twice for R*8)
  fdata = fmt_r4  ! Format of data
  !
  ! --- Descriptor (first part) ---
  if (code.eq.code_header) then
    ! Data is not requested
    desc%type = 0     ! A pure header with no data associated
    desc%size = 0     ! Yes, the header variable has no data size associated
    desc%ndim = 0     ! Yes, the header variable has no data dimensions associated
    desc%dims(:) = 0  !
    gtype = 'GILDAS_IMAGE'
    !
  else if (code.eq.code_image) then
    ! Read and store data in a permanent place
    desc%type = fdata
    desc%ndim = fits%gil%ndim
    desc%dims(:) = fits%gil%dim(:)
    desc%size = sdata
    gtype = 'GILDAS_IMAGE'
    !
  else
    call sic_message(seve%e,rname,'Not implemented')
    error = .true.
    goto 10
  endif
  !
  ! --- GIO image slot ---
  !
  ! Prepare slot in gio
  ms = 0  ! Just in case of error recovery
  call gio_geis(is,error)
  if (error)  goto 10
  !
  call gio_write_header(fits,is,error)
  if (error)  goto 20
  !
  ! Now declare properly the gio image slot (CREate Work Slot)
  call gio_crws(is,gtype,fdata,sdata,error)
  if (error)  goto 20
  !
  ! --- Data? ---
  if (code.eq.code_header) then
    desc%addr = ptr_null  ! Data address: none
    !
  elseif (code.eq.code_image) then
    whole(:) = 0
    call gio_gems(ms,is,whole,whole,desc%addr,desc%type,error)
    if (error) goto 20
    !
    ! Make sure the FITS file is at the right position
    nfill = 0
    call gfits_flush_data(error)
    if (error)  goto 20
    !
    ! Read all data at once, as DEFINE IMAGE needs all the data loaded in memory
    ipnt = gag_pointer(desc%addr,memory)
    call read_allmap(fd,memory(ipnt),ndata,nfill,fits%gil%bval,error)
    if (nfill.lt.ndata)  &
      call sic_message(seve%w,rname,'FITS data file is incomplete')
    if (error)  goto 20
    !
    nblank = 0
    call fitscube2gdf_patch_bval(fd,fits,memory(ipnt),ndata,nblank,error)
    if (error)  goto 20
    if (nblank.eq.0) then
      call sic_message(seve%d,rname,'No blank data in FITS file')
      fits%gil%eval = -1.0
      call gio_write_header(fits,is,error)  ! Update image header in GIO
      if (error)  goto 20
    else
      write(mess,'(A,I0,A)') 'Patched ',nblank,' blank data'
      call sic_message(seve%d,rname,mess)
    endif
    !
  endif
  !
  ! --- Descriptor (remaining parts) ---
  call gdf_geih(is,desc%head,error)  ! Get pointer to header in GIO
  if (error)  goto 20
  desc%head%file = file  ! Save origin in GIO header slot, just for consistency
  desc%status = is
  desc%readonly = .true.
  !
  ! At this stage the descriptor describes where to find the data, if
  ! any (desc%addr). Now we give hand back to subroutine
  ! 'sic_define_image' which will:
  !  - insert the new variable in the dictionary, given the
  !    descriptor above,
  !  - build all the header variables thanks to the type(gildas) in desc%head
  !
  ! Error recovery
20 continue
   if (error) then
     if (ms.ne.0)  call gio_frms(ms,error)
     call gio_fris(is,error)
   endif
10 continue
  call gfits_close(error)
  !
end subroutine sic_define_map_fits
!
subroutine sic_define_new_file (file,ndim,dim,desc,istat,code,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_define_new_file
  use image_def
  use gbl_format
  use gbl_message
  use sic_dictionaries
  use sic_types
  use sic_define_status
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Internal routine
  !     Creates a new image of specified dimensions. The
  !     increments along each axis are initialized to 1.
  !---------------------------------------------------------------------
  character(len=*) :: file              ! Image file name       Input
  integer :: ndim                       ! Number of dimensions  Input
  integer(kind=index_length), intent(in) :: dim(ndim)  ! Dimensions
  type(sic_descriptor_t) :: desc        ! Returned descriptor   Output
  integer(kind=4), intent(in) :: istat  ! Code for format
  integer(kind=4), intent(in) :: code   ! Code for type of image
  logical :: error                      ! Logical error flag    Output
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer(kind=4) :: is,form,ms
  integer(kind=size_length) :: size
  integer(kind=index_length) :: whole(gdf_maxdims) = 0
  integer(kind=address_length) :: addr
  integer(kind=address_length) :: ipnt
  integer :: i
  type (gildas) :: x
  character(len=message_length) :: mess
  !
  if (ndim.gt.gdf_maxdims) then
    write (mess,'(A,I0,A,I0,A)')  &
      'Gildas images can have at most ',gdf_maxdims,' dimensions (',ndim,' given)'
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! This is a patch for creation of Old GILDAS data format...
  if (ndim.gt.4) then
    if (gdf_stbl_get().eq.1) then
      write (mess,'(A,I0,A)')  &
      'Old Format Gildas images can have at most 4 dimensions (',ndim,' given)'
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  endif
  !
  call gildas_null(x)
  !
  if (istat.eq.3) then
    desc%size = 1
    form = fmt_i4
  elseif (istat.eq.4) then
    desc%size = 2
    form = fmt_i8
  elseif (istat.eq.5) then
    desc%size = 1
    form = fmt_r4
  elseif (istat.eq.6) then
    desc%size = 2
    form = fmt_r8
  elseif (istat.eq.7) then
    desc%size = 2
    form = fmt_c4
  endif
  !
  desc%ndim = ndim
  desc%dims = 0  ! To initialize all SIC dimensions
  x%gil%ndim = ndim
  do i=1,ndim
    desc%dims(i) = dim(i)
    desc%size = desc%size*dim(i)
    x%gil%dim(i) = dim(i)
    x%gil%convert(:,i) = 1.d0
  enddo
  do i=ndim+1,gdf_maxdims
    desc%dims(i) = 1
    x%gil%dim(i) = 1
    x%gil%convert(:,i) = 0.d0
  enddo
  !
  ! Check image size
  call desc_toobig(desc,error)
  if (error)  return
  !
  if (code.eq.code_table) then
    ! For TABLES, could reset section lengths to zero...
    x%gil%type_gdf = code_gdf_table
    x%gil%dim_words = 2*gdf_maxdims+2
  else
    x%gil%type_gdf = code_gdf_image
    x%gil%dim_words = 2*gdf_maxdims+2
  endif
  !
  error = .false.
  call gio_geis (is,error)
  if (error) return
  !
  call gio_write_header (x,is,error)
  !
  if (error) return
  if (form.eq.fmt_r8 .or. form.eq.fmt_i8) then
    size = desc%size/2
  else
    size = desc%size
  endif
  if (file.eq.'*') then
    call gio_crws (is,'GILDAS_IMAGE',form,size,error)
  else
    call gio_cris (is,'GILDAS_IMAGE',file,form,size,error)
  endif
  if (error) return
  call gio_gems (ms,is,whole,whole,addr,form,error)
  if (error) return
  ipnt = gag_pointer(addr,memory)
  call gdf_fill (desc%size,memory(ipnt),0.0)
  desc%type = form
  desc%readonly = .false.
  call adtoad(addr,desc%addr,1)
  desc%status = is
  call gdf_geih(desc%status,desc%head,error)
  if (error)  return
  !
end subroutine sic_define_new_file
!
subroutine sic_define_new_uvtable(file,ndim,dim,desc,istat,error)
  use image_def
  use gbl_message
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_define_new_uvtable
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Creates a new image of specified dimensions. The increments along
  ! each axis are initialized to 1.
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: file       ! Image file name
  integer(kind=4),            intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length), intent(in)    :: dim(ndim)  ! Dimensions
  type(sic_descriptor_t)                    :: desc       ! Returned decriptor
  integer(kind=4),            intent(in)    :: istat      ! Code for format
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer(kind=address_length) :: ipnt,addr
  integer(kind=4) :: i,is,form,ms,vaxi,saxi,nf
  integer(kind=size_length) :: size
  integer(kind=index_length) :: whole(gdf_maxdims) = 0
  type(gildas) :: x
  character(len=message_length) :: mess
  character(len=3) :: ttype
  !
  if (ndim.gt.gdf_maxdims) then
    write (mess,'(A,I0,A,I0,A)')  &
      'Gildas UV tables can have at most ',gdf_maxdims,' dimensions (',ndim,' given)'
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Try to guess if we are creating an UVT or transposed TUV
  nf = len_trim(file)
  if (file(nf-3:nf).eq.'.tuv') then
    ! TUV order
    vaxi = 1       ! Visibility axis
    saxi = 2       ! Stokes axis
    ttype = 'TUV'  ! Table type
  else
    ! UVT order
    vaxi = 2
    saxi = 1
    ttype = 'UVT'
  endif
  !
  error = .false.
  if (istat.ne.5) then
    call sic_message(seve%e,rname,'Only REAL format for UV Tables')
    error = .true.
  endif
  if (ndim.ne.2) then
    call sic_message(seve%e,rname,'UV Tables must have 2 dimensions')
    error = .true.
  endif
  if (dim(saxi).lt.10) then
    call sic_message(seve%e,rname,'UV tables Stokes dimension must be at least 10')
    error = .true.
  endif
  if (error) return
  !
  call gio_geis (is,error)
  if (error) return
  !
  ! The GIO now has a better initialization routine
  call gildas_null(x, type=ttype)
  desc%size = 1
  form = fmt_r4
  desc%ndim = ndim
  desc%dims = 0   ! To initialize all dimensions
  x%gil%ndim = ndim
  do i=1,ndim
    desc%dims(i) = dim(i)
    desc%size = desc%size*dim(i)
    x%gil%dim(i) = dim(i)
    x%gil%convert(:,i) = 1.d0
  enddo
  do i=ndim+1,gdf_maxdims
    desc%dims(i) = 1
    x%gil%dim(i) = 1
    x%gil%convert(:,i) = 0.d0
  enddo
  x%gil%dim_words = 2*gdf_maxdims+2
  x%gil%nchan = (x%gil%dim(saxi)-7)/3
  x%gil%nvisi = x%gil%dim(vaxi)
  !
  error = .false.
  call gio_write_header (x,is,error)
  if (error) return
  if (form.eq.fmt_r8 .or. form.eq.fmt_i8) then
    size = desc%size/2
  else
    size = desc%size
  endif
  call gio_cris (is,'GILDAS_UVFIL',file,form,size,error)
  if (error) return
  call gio_gems (ms,is,whole,whole,addr,form,error)
  if (error) return
  ipnt = gag_pointer(addr,memory)
  call gdf_fill (desc%size,memory(ipnt),0.0)
  desc%type = form
  desc%readonly = .false.
  call adtoad(addr,desc%addr,1)
  desc%status = is
  call gdf_geih(desc%status,desc%head,error)
  if (error)  return
  !
end subroutine sic_define_new_uvtable
!
subroutine sic_define_extend_file (file,newdim,desc,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_define_extend_file
  use image_def
  use gbl_format
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Internal routine
  !  Extend an existing image by increasing its LAST dimension
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: file    ! Image file name
  integer(kind=index_length), intent(in)    :: newdim  ! New value of last dimension
  type(sic_descriptor_t),     intent(out)   :: desc    ! Returned descriptor
  logical,                    intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ipnt,addr
  integer(kind=index_length) :: whole(gdf_maxdims)=0
  character(len=12) :: gtype
  integer(kind=4) :: is,form,ms
  integer(kind=size_length) :: osize,nsize
  integer(kind=index_length) :: olddim
  type(gildas) :: x
  !
  call gildas_null(x)
  !
  call gio_geis (is,error)
  if (error) return
  call gio_wris (is,gtype,file,form,osize,error)
  if (error) return
  desc%type = form
  desc%readonly = .false.
  call gio_read_header(x,is,error)
  if (error) return
  !
  ! Now extend it if needed
  if (x%gil%ndim.lt.1) then
    x%gil%ndim = 1
    x%gil%dim = 1
    x%gil%convert = 1.d0
  endif
  olddim = x%gil%dim(x%gil%ndim)
  !
  if (newdim.gt.olddim) then
    ! Actual extension
    nsize = osize / olddim * newdim
    !
    x%gil%dim(x%gil%ndim) = newdim
    call gio_write_header(x,is,error)
    if (error) return
    call gio_clis (is,error)  ! Close image slot
    !
    call gio_exis (is,gtype,file,form,nsize,error)
    if (error) return
  else
    ! Already large enough, nothing to be done
    nsize = osize
  endif
  call gio_gems (ms,is,whole,whole,addr,form,error)
  if (error) return
  !
  ! Define descriptor
  if (form.eq.fmt_r8) then
    osize = 2*osize
    nsize = 2*nsize
  endif
  call adtoad(addr,desc%addr,1)
  desc%ndim = x%gil%ndim
  desc%dims(:) = 0
  desc%dims(1:desc%ndim) = x%gil%dim(1:x%gil%ndim)
  desc%size = nsize
  desc%status = is
  call gdf_geih(desc%status,desc%head,error)
  if (error)  return
  !
  if (nsize.gt.osize) then
    ! Zero fill the extended part
    ipnt = gag_pointer(addr,memory)
    call gdf_fill (nsize-osize,memory(ipnt+osize),0.0)
  endif
end subroutine sic_define_extend_file
!
subroutine sic_crestructure(namein,global,error)
  use sic_interfaces, except_this=>sic_crestructure
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public (for Python port)
  !     Define a new structure from command
  !     DEFINE STRUCT Variable Read|Write
  !     Variable may have ReadOnly protection.
  !---------------------------------------------------------------------
  character(len=*)                :: namein  ! Structure name
  logical                         :: global  ! Local / Global flag        Input
  logical,          intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer(kind=4) :: in,ier
  type(sic_identifier_t) :: var
  character(len=132) :: mess
  type(sic_dimensions_t) :: spec
  logical :: verbose,lglobal
  !
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .false.  ! A[2:4] forbidden
  spec%do%subset   = .false.  ! A[2,]  forbidden
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .false.  ! e.g. A[i][j:k] forbidden
  verbose = .true.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error)  return
  if (spec%done(1)%ndim.ne.0) then
    call sic_message(seve%e,rname,'Structure cannot have Dimensionality')
    error = .true.
    return
  endif
  ! Here NAMEIN has no dimensionality:
  ! Strip off the superfluous % at the end.
  if (var%name(var%lname:var%lname).eq.'%') then
    var%name(var%lname:var%lname) = ' '
    var%lname = var%lname-1
  endif
  ! Save 12 char at the end as a strict minimum for structure members
  if (var%lname.gt.varname_length-12) then
    write(mess,1001) 'STRUCTURE names must be at most ',varname_length-12,' char'
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (var_level.eq.0) then
    lglobal = .true.
  else
    lglobal = global
  endif
  !
  ! Check if variable is already defined.
  ! As a component of an existing structure.
  if (sic_checkstruct(var%name,lglobal).eq.0) then
    error = .true.
    return
  endif
  ! or as a simple variable
  if (lglobal) then
    var%level = 0
  else
    var%level = var_level
  endif
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,'Variable '//trim(var%name)//' already exists')
    error = .true.
    return
  endif
  !
  ! Define the "generic" structure name
  ier = sic_hasins(rname,maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.0 .or. ier.eq.2) then
    error = .true.
    return
  endif
  !
  ! Setup the back pointer
  if (lglobal) then
    var_g = var_g-1
    var_pointer (var_g) = in
  else
    var_n = var_n+1
    var_pointer (var_n) = in
  endif
  dicvar(in)%desc%type = 0
  dicvar(in)%desc%readonly = .false.
  dicvar(in)%desc%head => null()
  dicvar(in)%desc%addr = ptr_null
  dicvar(in)%desc%ndim = 0
  dicvar(in)%desc%dims(:) = 0
  dicvar(in)%desc%size = 0
  dicvar(in)%desc%status = user_defined
  !
#if defined(GAG_USE_PYTHON)
  call gpy_getvar(var%name,var%level)
#endif
  return
  !
1001 format(a,i2,a)
end subroutine sic_crestructure
!
subroutine sic_defstructure(namein,global,error)
  use sic_interfaces, except_this=>sic_defstructure
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !     Define a new structure from program.
  !     Variable may have ReadOnly protection ?
  !---------------------------------------------------------------------
  character(len=*) :: namein        ! Structure name
  logical :: global                 ! Local / Global flag        Input
  logical :: error                  ! Logical error flag         Output
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer(kind=4) :: in,ier
  type(sic_identifier_t) :: var
  character(len=132) :: mess
  type(sic_dimensions_t) :: spec
  logical :: verbose
  !
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .false.  ! A[2:4] forbidden
  spec%do%subset   = .false.  ! A[2,]  forbidden
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .false.  ! e.g. A[i][j:k] forbidden
  verbose = .true.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error)  return
  if (spec%done(1)%ndim.ne.0) then
    call sic_message(seve%e,rname,'Structure cannot have Dimensionality')
    error = .true.
    return
  endif
  ! Here NAMEIN has no dimensionality:
  ! Strip off the superfluous % at the end.
  if (var%name(var%lname:var%lname).eq.'%') then
    var%name(var%lname:var%lname)= ' '
    var%lname = var%lname-1
  endif
  ! Save 12 char at the end as a strict minimum for structure members
  if (var%lname.gt.varname_length-12) then
    write(mess,1001) 'STRUCTURE names must be at most ',varname_length-12,' char'
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Check if variable is already defined.
  ! As a component of an existing structure.
  if (sic_checkstruct(var%name,global).eq.0) then
    error = .true.
    return
  endif
  ! or as a simple variable
  if (global) then
    var%level = 0
  else
    var%level = var_level
  endif
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,'Variable '//trim(var%name)//' already exists')
    error = .true.
    return
  endif
  !
  ! Define the "generic" structure name
  ier = sic_hasins(rname,maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.0 .or. ier.eq.2) then
    error = .true.
    return
  endif
  !
  ! Setup the program defined indicator
  dicvar(in)%desc%type = 0
  dicvar(in)%desc%readonly = .false.
  dicvar(in)%desc%head => null()
  dicvar(in)%desc%addr = ptr_null
  dicvar(in)%desc%ndim = 0
  dicvar(in)%desc%dims(:) = 0
  dicvar(in)%desc%size = 0
  dicvar(in)%desc%status = program_defined
  !
#if defined(GAG_USE_PYTHON)
  call gpy_getvar(var%name,var%level)
#endif
  return
  !
1001 format(a,i2,a)
end subroutine sic_defstructure
!
subroutine sic_define_header(namein,file,status,global,therank,error)
  use gildas_def
  use sic_dependencies_interfaces 
  use sic_interfaces, except_this=>sic_define_header
  use sic_structures
  use sic_dictionaries
  use gbl_message
  use sic_define_status
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Internal routine
  !     Define a new variable associated to an image header, from command
  !     DEFINE HEADER Variable File Read|Write  /TRIM [Rank]
  ! and
  !     DEFINE HEADER Variable * Image|UVData [/LIKE Other]
  !     Variable may have ReadOnly protection.
  !---------------------------------------------------------------------
  character(len=*)                :: namein  ! Variable name
  character(len=*)                :: file    ! Associated file name
  character(len=*)                :: status  ! Variable type / status
  logical, intent(in)             :: global  ! Global or Local variable
  integer(4), intent(in)          :: therank ! Desired Output Rank
  logical,          intent(inout) :: error   ! Return error flag
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  integer(kind=4) :: in,istat,ier,actual_rank,code
  type(sic_identifier_t) :: var
  character(len=132) :: mess
  integer(kind=4), parameter :: mstates=8
  character(len=8) :: keyw,states(mstates),vstate(2)
  type(sic_descriptor_t) :: desc
  type(sic_dimensions_t) :: spec
  logical :: rdonly,virtuel,verbose
  ! Data
  data states/'READ','WRITE','INTEGER','LONG','REAL','DOUBLE','COMPLEX','EXTEND'/
  data vstate/'IMAGE','UVDATA'/
  !
  ! Check STATUS
  virtuel = file.eq.'*'
  if (virtuel) then
    call sic_ambigs('HEADER',status,keyw,istat,vstate,2,error)
    if (istat.eq.1) then
      code = code_header_image
    else
      code = code_header_uv
    endif
  else
    code = code_header
    call sic_ambigs('HEADER',status,keyw,istat,states,mstates,error)
  endif
  if (error) return
  !
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .false.  ! A[2:4] forbidden
  spec%do%subset   = .false.  ! A[2,]  forbidden
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .false.  ! e.g. A[i][j:k] forbidden
  verbose = .true.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error)  return
  if (virtuel) then
    if (spec%done(1)%ndim.eq.0) then
      call sic_message(seve%e,rname,'Missing dimension of new header')
      error = .true.
      return
    endif
    istat = 2
  elseif (istat.le.2 .and. spec%done(1)%ndim.ne.0) then
    call sic_message(seve%e,rname,'Cannot specify dimension for existing image')
    error = .true.
    return
  elseif (istat.ge.3 .and. spec%done(1)%ndim.eq.0) then
    call sic_message(seve%e,rname,'Missing dimension of new image')
    error = .true.
    return
  elseif (istat.eq.mstates .and. spec%done(1)%ndim.ne.1) then
    call sic_message(seve%e,rname,'Only last dimension can be extended')
    error = .true.
    return
  endif
  !
  ! Check if variable is already defined
  if (var%lname.gt.varname_length-12) then
    write(mess,1001) 'IMAGE names must be at most ',varname_length-12,' char'
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Check if variable is already defined. First, variable must be either
  ! a true variable or a component of an existing structure.
  if (sic_checkstruct(var%name,global).eq.0) then
    error = .true.
    return
  endif
  if (global) then
    var%level = 0
  else
    var%level = var_level
  endif
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,'Variable '//trim(namein)//' already exists')
    error = .true.
    return
  endif
  !
  if (istat.eq.1) then
    rdonly = .true.
  elseif (istat.eq.2) then
    rdonly = .false.
  else
    call sic_message(seve%e,'DEFINE HEADER','Invalid status '//keyw)
    error = .true.
    return
  endif
  !
  ! Get the header parameter
  if (virtuel) then
    actual_rank = 0  ! Do not worry for Virtual header
  else
    actual_rank = therank
  endif
  !
  call sic_define_old_file(file,code,rdonly,actual_rank,desc,error)
  !! Print *,'THERANK ',therank,' actual rank ',actual_rank
  if (error) return
  !
  ! Check the dimensions in case of Virtual header
  if (virtuel .and. therank.ne.0) then
    actual_rank = therank
    desc%ndim = spec%done(1)%ndim
    desc%dims = spec%done(1)%dims(1:sic_maxdims,1)
    call trim_rank(rname,desc%ndim,desc%dims,actual_rank,error)
    spec%done(1)%ndim = desc%ndim
    if (error) return
  endif
  !
  ! Define the "generic" variable name
  ier = sic_hasins('DEFINE',maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.0 .or. ier.eq.2) then
    error = .true.
    return
  endif
  !
  if (global) then
    var_g = var_g-1
    var_pointer (var_g) = in
  else
    var_n = var_n+1
    var_pointer (var_n) = in
  endif
  dicvar(in)%desc = desc
  !
  call sub_def_header(var,'%',desc%head,rdonly,actual_rank,error)
  !!Print *,'Done sub_def_header ACTUAL_RANK ',actual_rank
  ! Define Var%RDONLY to be able to access the Read Status.
  call sub_def_logi(trim(var%name)//'%RDONLY',dicvar(in)%desc%readonly, &
    & .true.,var%level,error)
#if defined(GAG_USE_PYTHON)
  if (.not.error) call gpy_getvar(var%name,var%level)
#endif
  !
  ! Fill the dimensions in case of new header
  if (virtuel) then
    call sub_dim_header(desc%head,spec%done(1))
  endif
  !
  return
  !
1001 format(a,i2,a)
end subroutine sic_define_header
!
subroutine sub_dim_header(head,subdims)
  use image_def
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the dimensions in case of new header
  !---------------------------------------------------------------------
  type(gildas),                intent(inout) :: head     ! Target header
  type(sic_dimensions_done_t), intent(in)    :: subdims  !
  !
  head%gil%ndim = subdims%ndim
  head%gil%dim(1:sic_maxdims) = subdims%dims(1:sic_maxdims,1)
end subroutine sub_dim_header
!
subroutine sic_def_header(name,head,readonly,error)
  use image_def
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !   Public entry point which allows to fill a SIC structure mapping
  ! the input image header. The structure is always global. Input object
  ! must be the whole 'gildas' type because we map head%gil% and
  ! head%char% elements.
  !   NB: if missing, the blanking section is enabled to default values
  ! (with eval<0). Because of this the input target header is
  ! intent(inout).
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name      ! Structure name
  type(gildas),     intent(inout) :: head      ! Target header
  logical,          intent(in)    :: readonly  ! Readonly status
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  type(sic_identifier_t) :: var
  logical, save :: yes=.true.
  logical, save :: no=.false.
  !
  ! Warning:  
  !   subroutine sic_mapheader 
  ! apparently provides a similar functionality.  
  ! The main differences are
  !   1)  readonly attribute is possible here
  !   2)  However, there does not seem  to be any simple mechanism 
  !       to delete variables implicitely created by sic_def_header,
  !       while a simple call to sic_delvariable can delete
  !       the whole structure created by sic_mapheader
  !
  var%name = name
  var%lname = len_trim(name)
  var%level = 0
  call sub_def_header(var,'%',head,readonly,-1,error)
  if (error)  return
  ! Define Var%RDONLY to be able to access the Read Status.
  if (readonly) then
    call sub_def_logi(trim(var%name)//'%RDONLY',yes,.true.,var%level,error)
  else
    call sub_def_logi(trim(var%name)//'%RDONLY',no,.true.,var%level,error)
  endif
  !
end subroutine sic_def_header
!
subroutine sub_def_header(varin,sep,h,rd,therank,error)
  use image_def
  use sic_interfaces, except_this=>sub_def_header
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Define all variables associated to an image header. Input object
  ! must be the whole 'gildas' type because we map head%gil% and
  ! head%char% elements.
  !   NB: if missing, the blanking section is enabled to default values
  ! (with eval<0). Because of this the input target header is
  ! intent(inout).
  !---------------------------------------------------------------------
  type(sic_identifier_t), intent(in)    :: varin  ! Parent structure
  character(len=*),       intent(in)    :: sep    ! Separator between parent structure and its components (1 char)
  type(gildas),           intent(inout) :: h      ! Target header
  logical,                intent(in)    :: rd     ! Readonly status
  integer(4),             intent(in)    :: therank ! Trim degenerate trailing dims
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=index_length) :: dim(2)
  integer(kind=4) :: nn,n2,lev,itel
  character(len=varname_length) :: pre,pretel
  !
  lev = varin%level
  nn = min(varin%lname+1,varname_length-12)
  pre = varin%name
  pre(nn:nn) = sep(1:1)
  !
  ! Basic header information
  error = .false.
  call sub_def_inte(pre(1:nn)//'VERSION_GDF',h%gil%version_gdf,0,dim,rd,lev,error)
  if (error)  return
  call sub_def_inte(pre(1:nn)//'TYPE_GDF',h%gil%type_gdf,0,dim,rd,lev,error)
  if (error)  return
  !
  ! GENERAL section
  call sub_def_inte(pre(1:nn)//'GENE',h%gil%dim_words,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'NDIM',h%gil%ndim,0,dim,.true.,lev,error)
  dim(1) = gdf_maxdims
#if defined(INDEX4) || !defined(BITS64)
  call sub_def_inte(pre(1:nn)//'DIM',h%gil%dim,1,dim,.true.,lev,error)
#else
  call sub_def_long(pre(1:nn)//'DIM',h%gil%dim(1),1,dim,.true.,lev,error)
#endif
  dim(1) = 3
  dim(2) = gdf_maxdims
  call sub_def_dble(pre(1:nn)//'CONVERT',h%gil%convert(1,1),2,dim,rd,lev,error)
  ! Blanking section
  call sub_def_inte(pre(1:nn)//'BLAN',h%gil%blan_words,0,dim,rd,lev,error)
  if (h%gil%blan_words.eq.0) then
    h%gil%blan_words = 2
    h%gil%eval = -1
  endif
  !
  ! Probably not at the right place: Make the Blanking # NaN
  if (h%gil%bval.ne.h%gil%bval) h%gil%bval = 1.23456e+34
  dim(1) = 2
  call sub_def_real(pre(1:nn)//'BLANK',h%gil%bval,1,dim,rd,lev,error)
  !
  ! Extrema
  call sub_def_inte(pre(1:nn)//'EXTREMA',h%gil%extr_words,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'MIN',    h%gil%rmin,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'MAX',    h%gil%rmax,0,dim,rd,lev,error)
  !
  dim(1) = gdf_maxdims
#if defined(INDEX4) || !defined(BITS64)
  call sub_def_inte(pre(1:nn)//'MINLOC',h%gil%minloc(1),1,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'MAXLOC',h%gil%maxloc(1),1,dim,rd,lev,error)
#else
  call sub_def_long(pre(1:nn)//'MINLOC',h%gil%minloc(1),1,dim,rd,lev,error)
  call sub_def_long(pre(1:nn)//'MAXLOC',h%gil%maxloc(1),1,dim,rd,lev,error)
#endif
  !
  ! Units and coordinate system
  call sub_def_inte(pre(1:nn)//'DESC',h%gil%desc_words,0,dim,rd,lev,error)
  call sub_def_char(pre(1:nn)//'UNIT',  h%char%unit,rd,lev,error)
  call sub_def_char(pre(1:nn)//'UNIT1', h%char%code(1),rd,lev,error)
  call sub_def_char(pre(1:nn)//'UNIT2', h%char%code(2),rd,lev,error)
  call sub_def_char(pre(1:nn)//'UNIT3', h%char%code(3),rd,lev,error)
  call sub_def_char(pre(1:nn)//'UNIT4', h%char%code(4),rd,lev,error)
  call sub_def_char(pre(1:nn)//'UNIT5', h%char%code(5),rd,lev,error)
  call sub_def_char(pre(1:nn)//'UNIT6', h%char%code(6),rd,lev,error)
  call sub_def_char(pre(1:nn)//'UNIT7', h%char%code(7),rd,lev,error)
  call sub_def_char(pre(1:nn)//'SYSTEM', h%char%syst,rd,lev,error)
  !
  ! Astronomical position
  call sub_def_inte(pre(1:nn)//'POSI',h%gil%posi_words,0,dim,rd,lev,error)
  call sub_def_char(pre(1:nn)//'SOURCE',h%char%name,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'RA',   h%gil%ra,0,dim,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'DEC',  h%gil%dec, 0,dim,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'LII',  h%gil%lii, 0,dim,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'BII',  h%gil%bii, 0,dim,rd,lev,error)
  !
  call sub_def_real(pre(1:nn)//'EQUINOX',h%gil%epoc, 0,dim,rd,lev,error)
  !
  ! Projection
  call sub_def_inte(pre(1:nn)//'PROJ',  h%gil%proj_words,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'PTYPE', h%gil%ptyp,0,dim,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'A0',    h%gil%a0,0,dim,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'D0',    h%gil%d0,0,dim,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'ANGLE', h%gil%pang,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'X_AXIS',h%gil%xaxi,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'Y_AXIS',h%gil%yaxi,0,dim,rd,lev,error)
  !
  ! Spectroscopy
  call sub_def_inte(pre(1:nn)//'SPEC',   h%gil%spec_words,0,dim,rd,lev,error)
  call sub_def_char(pre(1:nn)//'LINE',   h%char%line,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'FREQRES',h%gil%fres,0,dim,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'IMAGFRE',h%gil%fima,0,dim,rd,lev,error)
  call sub_def_dble(pre(1:nn)//'RESTFRE',h%gil%freq,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'VELRES', h%gil%vres,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'VELOFF', h%gil%voff,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'F_AXIS', h%gil%faxi,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'DOPPLER',h%gil%dopp,0,dim,rd,lev,error)  !
  call sub_def_inte(pre(1:nn)//'VTYPE',  h%gil%vtyp,0,dim,rd,lev,error)  !
  !
  ! Beam size
  call sub_def_inte(pre(1:nn)//'BEAM', h%gil%reso_words,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'MAJOR',h%gil%majo,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'MINOR',h%gil%mino,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'PA',   h%gil%posa,0,dim,rd,lev,error)
  !
  ! Noise
  call sub_def_inte(pre(1:nn)//'SIGMA',h%gil%nois_words,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'NOISE',h%gil%noise,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'RMS',  h%gil%rms,0,dim,rd,lev,error)
  !
  ! Proper Motion
  call sub_def_inte(pre(1:nn)//'PROPER',  h%gil%astr_words,0,dim,rd,lev,error)
  dim(1) = 2
  call sub_def_real(pre(1:nn)//'MU',      h%gil%mura,1,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'PARALLAX',h%gil%parallax,0,dim,rd,lev,error)
  !
  if (abs(h%gil%type_gdf).eq.code_gdf_uvt) then
    call sic_def_uvhead(varin,h,rd,error)
  endif
  !
  ! Telescope
  call sub_def_inte(pre(1:nn)//'TELE_SEC',h%gil%tele_words,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'NTEL',    h%gil%nteles,    0,dim,.true.,lev,error)  ! Read-only
  do itel=1,h%gil%nteles
    write(pretel,'(A,A,I0)')  pre(1:nn),'TEL',itel
    n2 = len_trim(pretel)
    call sic_defstructure(pretel(1:n2),lev.eq.0,error)
    if (error)  return
    n2 = n2+1
    pretel(n2:n2) = '%'
    call sub_def_dble(pretel(1:n2)//'LON', h%gil%teles(itel)%lon, 0,dim,rd,lev,error)
    call sub_def_dble(pretel(1:n2)//'LAT', h%gil%teles(itel)%lat, 0,dim,rd,lev,error)
    call sub_def_real(pretel(1:n2)//'ALT', h%gil%teles(itel)%alt, 0,dim,rd,lev,error)
    call sub_def_real(pretel(1:n2)//'DIAM',h%gil%teles(itel)%diam,0,dim,rd,lev,error)
    call sub_def_char(pretel(1:n2)//'NAME',h%gil%teles(itel)%ctele,     rd,lev,error)
  enddo
  !
  ! Trim trick
  if (therank.ge.0) h%gil%ndim = therank
end subroutine sub_def_header
!
subroutine rename_variable(namein,nameout,error)
  use gbl_message
  use sic_interfaces, except_this=>rename_variable
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !   Rename a Sic variable
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: namein   ! Original name
  character(len=*), intent(in)    :: nameout  ! New name
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LET /REPLACE'
  type(sic_identifier_t) :: varin,varout,tmp
  integer(kind=4) :: in,ou,ier,list(maxvar),ielem,nelem,ik,il,ol,rpos
  logical :: global,domany
  character(len=varname_length) :: iname,oname
  !
  if (namein.eq.' ') then
    call sic_message(seve%e,rname,'Empty input variable name')
    error = .true.
    return
  endif
  !
  ! Drop trailing %, if any
  il = len_trim(namein)
  if (namein(il:il).eq.'%')  il = il-1
  iname = namein(1:il)
  ol = len_trim(nameout)
  if (nameout(ol:ol).eq.'%')  ol = ol-1
  oname = nameout(1:ol)
  !
  ! Find variable and determine if local or global
  global = .false.
  varin%name = iname
  varin%lname = il
  varin%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varin,in)
  if (ier.ne.1) then
    varin%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varin,in)
    if (ier.ne.1) then
      call sic_message(seve%e,rname,'No such variable '//namein)
      error = .true.
      return
    endif
    global = .true.
  endif
  !
  ! Sanity check
  if (dicvar(in)%desc%status.eq.program_defined) then
    call sic_message(seve%e,rname,'Program-defined variables can not be renamed')
    error = .true.
    return
  endif
  ! if (dicvar(in)%desc%readonly): this is allowed, e.g. for DEFINE IMAGE ... READ
  !
  ! Check alternate name
  varout%name = oname
  varout%lname = ol
  varout%level = varin%level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varout,ou)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,'Variable '//trim(nameout)//  &
    ' already exists')
    error = .true.
    return
  endif
  !
  ! If new name is under a structure, check it exists!
  rpos = index(oname,'%',back=.true.)
  if (rpos.gt.0) then
    tmp%name = oname(1:rpos-1)
    tmp%lname = rpos-1
    tmp%level = varout%level
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,tmp,ou)
    if (ier.ne.1) then
      call sic_message(seve%e,rname,  &
        'Structure '//nameout(1:rpos-1)//' does not exist')
      error = .true.
      return
    endif
  endif
  !
  if (dicvar(in)%desc%status.eq.user_defined .and.  &
      dicvar(in)%desc%type.eq.0) then
    ! User defined structure
    domany = .true.
  elseif (dicvar(in)%desc%status.gt.0) then
    ! Images or Headers
    domany = .true.
  elseif (dicvar(in)%desc%status.eq.alias_defined) then
    ! Aliases. Not implemented
    call sic_message(seve%e,rname,'Aliases can not be renamed')
    error = .true.
    return
  else
    domany = .false.
  endif
  !
  call do_rename_variable(varin,in,varout,global,error)
  if (error)  return
  !
  if (domany) then
    ! The parent structure has been renamed: rename also its elements
    il = il+1
    iname(il:il) = '%'
    call gag_haslis(maxvar,pfvar,pnvar,list,nelem)
    do ielem=1,nelem
      ik = list(ielem)
      if (dicvar(ik)%id%level.ne.varin%level)  cycle
      if (index(dicvar(ik)%id%name,iname(1:il)).ne.1)  cycle
      !
      varin = dicvar(ik)%id
      !
      varout%name = trim(oname)//'%'//dicvar(ik)%id%name(il+1:)
      varout%lname = len_trim(varout%name)
      ! varout%level = unchanged
      !
      call do_rename_variable(varin,ik,varout,global,error)
      if (error)  return
      !
    enddo
  endif
  !
contains
  subroutine do_rename_variable(varin,in,varout,global,error)
    use sic_dictionaries
    type(sic_identifier_t), intent(inout) :: varin
    integer(kind=4),        intent(in)    :: in
    type(sic_identifier_t), intent(inout) :: varout
    logical,                intent(in)    :: global
    logical,                intent(inout) :: error
    ! Local
    integer(kind=4) :: ier,i,ou
    !
    ! Define the output variable in dictionary:
    ier = sic_hasins(rname,maxvar,pfvar,pnvar,dicvar,varout,ou)
    if (ier.eq.0 .or. ier.eq.2) then
      error = .true.
      return
    endif
    !
    ! Copy descriptor
    dicvar(ou)%desc = dicvar(in)%desc
    !
    ! Delete entry IN
    ier = sic_hasdel(maxvar,pfvar,pnvar,dicvar,varin)
    !
    ! Reset back pointers
    if (.not.global) then
      do i=1,var_n
        if (var_pointer(i).eq.in) then
          var_pointer(i) = ou
          return
        endif
      enddo
    else
      do i=var_g,maxvar
        if (var_pointer(i).eq.in) then
          var_pointer(i) = ou
          return
        endif
      enddo
    endif
  end subroutine do_rename_variable
  !
end subroutine rename_variable
!
subroutine sub_def_real(symb,rel,ndim,dim,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sub_def_real
  !---------------------------------------------------------------------
  ! @ private
  ! Defines global variables by program
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb       ! Variable name
  real(kind=4),               intent(in)    :: rel        ! Real array
  integer(kind=4),            intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length), intent(in)    :: dim(ndim)  ! Dimensions
  logical,                    intent(in)    :: readonly   ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev        ! Variable level
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,i
  integer(kind=size_length) :: size
  !
  vaddr = locwrd (rel)
  vtype = fmt_r4
  size = 1
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_real
!
subroutine sub_def_dble(symb,dble,ndim,dim,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sub_def_dble
  !---------------------------------------------------------------------
  ! @ private
  ! Defines global variables by program
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb       ! Variable name
  real(kind=8),               intent(in)    :: dble       ! REAL*8 array
  integer(kind=4),            intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length), intent(in)    :: dim(ndim)  ! Dimensions
  logical,                    intent(in)    :: readonly   ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev        ! Variable level
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,i
  integer(kind=size_length) :: size
  !
  vaddr = locwrd(dble)
  vtype = fmt_r8
  size = 2
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_dble
!
subroutine sub_def_inte(symb,inte,ndim,dim,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument rank mismatch)
  ! Defines global variables by program
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb       ! Variable name
  integer(kind=4),            intent(in)    :: inte       ! Integer array
  integer(kind=4),            intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length), intent(in)    :: dim(ndim)  ! Dimensions
  logical,                    intent(in)    :: readonly   ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev        ! Variable level
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,i
  integer(kind=size_length) :: size
  !
  vaddr = locwrd(inte)
  vtype = fmt_i4
  size = 1
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_inte
!
subroutine sub_def_long(symb,long,ndim,dim,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sub_def_long
  !---------------------------------------------------------------------
  ! @ private
  ! Defines global variables by program
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb       ! Variable name
  integer(kind=8),            intent(in)    :: long       ! Long integer array
  integer(kind=4),            intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length), intent(in)    :: dim(ndim)  ! Dimensions
  logical,                    intent(in)    :: readonly   ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev        ! Variable level
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,i
  integer(kind=size_length) :: size
  !
  vaddr = locwrd(long)
  vtype = fmt_i8
  size = 2
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_long
!
subroutine sub_def_logi (symb,logi,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sub_def_logi
  !---------------------------------------------------------------------
  ! @ private
  ! Defines global variables by program
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb      ! Variable name
  logical,                    intent(in)    :: logi      ! Logical scalar
  logical,                    intent(in)    :: readonly  ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev       ! Variable level
  logical,                    intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,ndim
  integer(kind=size_length) :: size
  integer(kind=index_length) :: dim(sic_maxdims)
  !
  vaddr = locwrd(logi)
  vtype = fmt_l
  size = 1
  ndim = 0
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_logi
!
subroutine sub_def_login(symb,logi,ndim,dim,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sub_def_login
  !---------------------------------------------------------------------
  ! @ private
  ! Defines global variables by program
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb       ! Variable name
  logical,                    intent(in)    :: logi       ! Logical array
  integer(kind=4),            intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length), intent(in)    :: dim(ndim)  ! Dimensions
  logical,                    intent(in)    :: readonly   ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev        ! Variable level
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,i
  integer(kind=size_length) :: size
  !
  vaddr = locwrd(logi)
  vtype = fmt_l
  size = 1
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_login
!
subroutine sub_def_char(symb,chain,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sub_def_char
  !---------------------------------------------------------------------
  ! @ private
  ! Defines global variables by program
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb      ! Variable name
  character(len=*),           intent(in)    :: chain     ! Character string
  logical,                    intent(in)    :: readonly  ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev       ! Variable level
  logical,                    intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,ndim
  integer(kind=size_length) :: size
  integer(kind=index_length) :: dim(sic_maxdims)
  !
  vaddr = locstr(chain)
  vtype = len(chain)
  size = (vtype+3)/4
  ndim = 0
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_char
!
subroutine sub_def_strn(symb,string,ns,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Defines global variables by program
  ! Added for HEADERCHAR
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb       ! Variable name
  integer(kind=1),            intent(in)    :: string(*)  !
  integer(kind=4),            intent(in)    :: ns         !
  logical,                   intent(in)    :: readonly   ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev        ! Variable level
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,ndim
  integer(kind=size_length) :: size
  integer(kind=index_length) :: dim(sic_maxdims)
  !
  vaddr = locwrd(string)
  vtype = ns
  size = (vtype+3)/4
  ndim = 0
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_strn
!
subroutine sub_def_charn(symb,chain,ndim,dim,readonly,lev,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sub_def_charn
  !---------------------------------------------------------------------
  ! @ private
  ! Defines global variables by program
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: symb       ! Variable name
  character(len=*),           intent(in)    :: chain      ! Character string
  integer(kind=4),            intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length), intent(in)    :: dim(ndim)  ! Dimensions
  logical,                    intent(in)    :: readonly   ! ReadOnly flag
  integer(kind=4),            intent(in)    :: lev        ! Variable level
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=address_length) :: vaddr
  integer(kind=4) :: vtype,i
  integer(kind=size_length) :: size
  !
  vaddr = locstr(chain)
  vtype = len(chain)
  size = vtype
  do i = 1,ndim
    size = size*dim(i)
  enddo
  size = (size+3)/4  ! Convert to words
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,lev,error)
end subroutine sub_def_charn
!
subroutine sic_changevariable(namin,rdonly,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_changevariable
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! Change the status of an IMAGE variable (HEADER or TABLE) to
  ! Read or Write
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: namin  ! Variable name
  logical, intent(in) :: rdonly          !
  logical, intent(out) :: error          !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LET /STATUS'
  integer :: vtype,in,ier
  type(sic_identifier_t) :: varin
  character(len=132) :: message
  !
  ! Locate the variable name
  !
  ! Check syntax and analyse dimensions.
  error = .true.
  if (namin.eq.' ') return
  !
  ! Find variable
  varin%name = namin
  varin%lname = len_trim(namin)
  varin%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varin,in)
  if (ier.ne.1) then
    varin%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varin,in)
    if (ier.ne.1) return
  endif
  !
  vtype = dicvar(in)%desc%status
  !
  if (vtype.eq.program_defined) then 
    call sic_message(seve%e,rname,'Program defined variables are protected')
    error =.true.
  else if (vtype.eq.user_defined .and. dicvar(in)%desc%type.eq.0) then
    call sic_message(seve%e,rname,'Structures invalid in this context')
    error = .true.             ! User defined structure
  else
    error = .false.
  endif
  if (error) return
  !
  ! The readonly  status is always defined in the same way
  if (dicvar(in)%desc%readonly) then
    if (rdonly) then
      message = trim(namin)//' is already ReadOnly'
      call sic_message(seve%w,rname,message)
    else
      ! Set it to Write Status
      ! Easy for the normal variables or image data
      dicvar(in)%desc%readonly = .false.
      if (vtype.gt.0) then
        ! More difficult for the header
        call sic_changeheader(varin,in,.false.,error)
        ier = gio_chis(vtype,.false.)
      endif
    endif
  else
    if (rdonly) then
      ! Set it to Read Status
      ! Easy for the normal variables or image data
      dicvar(in)%desc%readonly = .true.
      if (vtype.gt.0) then
        ! More difficult for the header
        call sic_changeheader(varin,in,.false.,error)
        ier = gio_chis(vtype,.false.)
      endif
    else
      message = trim(namin)//' is already Writeable'
      call sic_message(seve%w,rname,message)
    endif
  endif
  !
end subroutine sic_changevariable
!
subroutine sic_changeheader(headvar,jn,rdonly,error)
  use sic_interfaces, except_this=>sic_changeheader
  use gildas_def
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Change the status of an HEADER variable to Read or Write
  !---------------------------------------------------------------------
  type(sic_identifier_t), intent(in)    :: headvar  ! SIC variable
  integer,                intent(in)    :: jn       ! Variable number DUMMY ...
  logical,                intent(in)    :: rdonly   ! Read-only status
  logical,                intent(inout) :: error    ! Error flag
  ! Local
  integer :: in,nn,ier
  type(sic_identifier_t) :: var
  !
  var%name = headvar%name
  var%lname = len_trim(var%name)+1
  var%name(var%lname:var%lname) = '%'
  nn = var%lname
  !
  ! Check there is a header
  var%level = headvar%level
  var%name(nn+1:) = 'GENE'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  ! Return if not
  if (ier.ne.1) return
  ! Change if yes
  dicvar(in)%desc%readonly = rdonly
  !
  ! GENERAL section
  var%name(nn+1:) = 'NDIM'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'DIM'
  var%lname = nn+3
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'CONVERT'
  var%lname = nn+7
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  ! Blanking section
  var%name(nn+1:) = 'BLAN'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'BLANK'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'EXTREMA'
  var%lname = nn+7
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'MAX'
  var%lname = nn+3
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'MIN'
  var%lname = nn+3
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'MINLOC'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'MAXLOC'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  ! Units and coordinate system
  var%name(nn+1:) = 'DESC'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'UNIT'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'UNIT1'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'UNIT2'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'UNIT3'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'UNIT4'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'UNIT5'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'UNIT6'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'UNIT7'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'SYSTEM'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  ! Astronomical position
  var%name(nn+1:) = 'POSI'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'SOURCE'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'RA'
  var%lname = nn+2
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'DEC'
  var%lname = nn+3
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'LII'
  var%lname = nn+3
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'BII'
  var%lname = nn+3
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'EQUINOX'
  var%lname = nn+7
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  ! Projection
  var%name(nn+1:) = 'PROJ'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'PTYPE'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'A0'
  var%lname = nn+2
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'D0'
  var%lname = nn+2
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'ANGLE'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'X_AXIS'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'Y_AXIS'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  ! Spectroscopy
  var%name(nn+1:) = 'SPEC'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'LINE'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'FREQRES'
  var%lname = nn+7
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'IMAGFRE'
  var%lname = nn+7
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'RESTFRE'
  var%lname = nn+7
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'VELRES'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'VELOFF'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'F_AXIS'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'DOPPLER'
  var%lname = nn+7
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'VTYPE'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  ! Beam size
  var%name(nn+1:) = 'BEAM'
  var%lname = nn+4
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'MAJOR'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'MINOR'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'PA'
  var%lname = nn+2
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  ! Noise
  var%name(nn+1:) = 'SIGMA'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'NOISE'
  var%lname = nn+5
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'RMS'
  var%lname = nn+3
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  ! Proper
  var%name(nn+1:) = 'PROPER'
  var%lname = nn+6
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'MU'
  var%lname = nn+2
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
  var%name(nn+1:) = 'PARALLAX'
  var%lname = nn+8
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  dicvar(in)%desc%readonly = rdonly
  !
end subroutine sic_changeheader
!
subroutine sic_def_uvhead(var,h,rd,error)
  use sic_interfaces
  use image_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! SIC Internal routine
  !     Define all Header variables associated to a UV table
  !---------------------------------------------------------------------
  type(sic_identifier_t), intent(in)    :: var    ! SIC variable
  type(gildas),           intent(inout) :: h      ! Gildas Header
  logical,                intent(in)    :: rd     ! ReadOnly flag
  logical,                intent(inout) :: error  ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=index_length) :: dim(1)
  integer :: nn,lev
  character(len=varname_length) :: pre
  !
  lev = var%level
  nn = min(index(var%name,' '),varname_length-12)
  pre = var%name
  pre(nn:nn) = '%'
  !
  dim(1) = 0
  call sub_def_inte(pre(1:nn)//'NCHAN',h%gil%nchan,0,dim,rd,lev,error)
  call sub_def_long(pre(1:nn)//'NVISI',h%gil%nvisi,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'NSTOKES',h%gil%nstokes,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'NATOM',h%gil%natom,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'BASEMIN',h%gil%basemin,0,dim,rd,lev,error)
  call sub_def_real(pre(1:nn)//'BASEMAX',h%gil%basemax,0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'VERSION_UV',h%gil%version_uv,0,dim,rd,lev,error)
  !
  if (h%gil%nfreq.ne.0) then
    dim(1) = h%gil%nfreq
    call sub_def_dble(pre(1:nn)//'FREQUENCIES',h%gil%freqs(1),1,dim,rd,lev,error)
    call sub_def_inte(pre(1:nn)//'STOKES',h%gil%stokes(1),1,dim,rd,lev,error)
  endif
  !
  ! Column pointers
  pre = pre(1:nn)//'DAPS%'
  nn = nn+5
  call sic_defstructure(pre(1:nn),lev.eq.0,error)
  if (error)  return
  dim(1) = 0
  call sub_def_inte(pre(1:nn)//'IU',   h%gil%column_pointer(code_uvt_u),   0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IV',   h%gil%column_pointer(code_uvt_v),   0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IW',   h%gil%column_pointer(code_uvt_w),   0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IDATE',h%gil%column_pointer(code_uvt_date),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'ITIME',h%gil%column_pointer(code_uvt_time),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IANTI',h%gil%column_pointer(code_uvt_anti),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IANTJ',h%gil%column_pointer(code_uvt_antj),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'ISCAN',h%gil%column_pointer(code_uvt_scan),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IXOFF',h%gil%column_pointer(code_uvt_xoff),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IYOFF',h%gil%column_pointer(code_uvt_yoff),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'ILOFF',h%gil%column_pointer(code_uvt_loff),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IMOFF',h%gil%column_pointer(code_uvt_moff),0,dim,rd,lev,error)
  call sub_def_inte(pre(1:nn)//'IFREQ',h%gil%column_pointer(code_uvt_freq),0,dim,rd,lev,error)
end subroutine sic_def_uvhead
!
subroutine sic_def_uvcoor(var,h,desc,rd,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use image_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! SIC Internal routine
  !     Define U and V variables for a TUV Table
  !---------------------------------------------------------------------
  type(sic_identifier_t), intent(in)    :: var    ! SIC variable
  type(gildas),           intent(inout) :: h      ! Gildas Header
  type(sic_descriptor_t), intent(in)    :: desc   ! Variable descriptor
  logical,                intent(in)    :: rd     ! ReadOnly flag
  logical,                intent(inout) :: error  ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=index_length) :: dim(1)
  integer(kind=address_length) :: vaddr,oaddr
  integer(kind=size_length) :: vsize
  integer :: nn,np,lev,vtype
  character(len=varname_length) :: pre
  !
  lev = var%level
  nn = min(index(var%name,' '),varname_length-12)
  np = nn+1
  pre = var%name(1:nn)
  !
  if (h%gil%type_gdf.eq.code_gdf_tuv) then
     ! Define U and V
     dim = 0
     dim(1) = desc%dims(1)
     vtype = fmt_r4
     vsize = dim(1)
     call adtoad(desc%addr,oaddr,1)
     vaddr = oaddr + 4*dim(1)*(h%gil%column_pointer(code_uvt_u)-1)
     pre(nn:np) = '%U'
     call sic_def_avar(pre,vaddr,vtype,vsize,1,dim,rd,lev,error)
     vaddr = oaddr + 4*dim(1)*(h%gil%column_pointer(code_uvt_v)-1)
     pre(nn:np) = '%V'
     call sic_def_avar(pre,vaddr,vtype,vsize,1,dim,rd,lev,error)
     !
     if (h%gil%column_size(code_uvt_ra).eq.2) then
       vtype = fmt_r8
       vsize = 2*dim(1)
       vaddr = oaddr + 4*dim(1)*(h%gil%column_pointer(code_uvt_ra)-1)
       np = nn+4
       pre(nn:np) = '%E_RA'
       call sic_def_avar(pre,vaddr,vtype,vsize,1,dim,rd,lev,error)
     endif
     if (h%gil%column_size(code_uvt_dec).eq.2) then
       vtype = fmt_r8
       vsize = 2*dim(1)
       vaddr = oaddr + 4*dim(1)*(h%gil%column_pointer(code_uvt_dec)-1)
       np = nn+5
       pre(nn:np) = '%E_DEC'
       call sic_def_avar(pre,vaddr,vtype,vsize,1,dim,rd,lev,error)
     endif
  endif
end subroutine sic_def_uvcoor
!
subroutine trim_rank(rname,ndim,dims,therank,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>trim_rank
  use gildas_def
  use image_def
  use gbl_format
  use gbl_message
  use sic_define_status
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Trim the rank of an Image or Header
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: rname    !
  integer(kind=4),            intent(inout) :: ndim     !
  integer(kind=index_length), intent(inout) :: dims(:)  !
  integer(kind=4),            intent(inout) :: therank  ! Desired rank
  logical,                    intent(inout) :: error    !
  ! Local
  integer(kind=4) :: i
  !
  if (therank.eq.0) then
    therank = -1 ! Code to use the true dimensions
    !
  else if (therank.le.-10) then
    !!Print *,'Trim all degenerate trailing dimensions'
    do while (dims(ndim).eq.1)
      ndim = ndim-1
      if (ndim.eq.0) exit
    enddo
    therank = ndim
    !
  else if (therank.lt.0) then
    !
    !!Print *,'Reduce to at least ',-therank,' more if possible'
    therank = -therank
    do i=therank+1,ndim
      if (dims(i).gt.1) then
        call sic_message(seve%e,rname,'Cannot reduce array rank')
        error = .true.
        return
      endif
    enddo
    ndim = therank
    do while (dims(ndim).eq.1)
      ndim = ndim-1
      if (ndim.eq.0) exit
    enddo
    therank = ndim
    !
  else if (therank.lt.ndim) then
    !!Print *,'Reduce to ',therank
    do i=therank+1,ndim
      if (dims(i).gt.1) then
        call sic_message(seve%e,rname,'Cannot reduce array rank')
        error = .true.
        return
      endif
    enddo
    ndim = therank
    !
  else if (therank.gt.ndim) then
    !!Print *,'Extend to ',therank,' by adding trailing degenerate dimensions'
    do i=ndim+1,therank
      dims(i) = 1
    enddo
    ndim = therank
  endif
  !
end subroutine trim_rank
!
subroutine sic_mapheader(name,head,error)
  use image_def
  use sic_interfaces, except_this=>sic_mapheader
  !---------------------------------------------------------------------
  ! @ public
  !   Create a HEADER SIC variable from an existing Header structure.
  ! It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name   ! Header name
  type(gildas), target, intent(inout) :: head   ! Header
  logical(kind=4),      intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = ptr_null
  call sub_mapgildas(name,head,0,addr,error)
end subroutine sic_mapheader
!
subroutine sic_mapgildas_r41d(name,head,error,data)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_mapgildas_r41d
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data. It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name     ! Header name
  type(gildas), target, intent(inout) :: head     ! Header
  logical(kind=4),      intent(inout) :: error    ! Logical error flag
  real(kind=4),         intent(in)    :: data(:)  !
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = locwrd(data(1))
  call sub_mapgildas(name,head,fmt_r4,addr,error)
end subroutine sic_mapgildas_r41d
!
subroutine sic_mapgildas_r42d(name,head,error,data)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_mapgildas_r42d
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data. It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name     ! Header name
  type(gildas), target, intent(inout) :: head     ! Header
  logical(kind=4),      intent(inout) :: error    ! Logical error flag
  real(kind=4),         intent(in)    :: data(:,:)  !
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = locwrd(data(1,1))
  call sub_mapgildas(name,head,fmt_r4,addr,error)
end subroutine sic_mapgildas_r42d
!
subroutine sic_mapgildas_r43d(name,head,error,data)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_mapgildas_r43d
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data. It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name     ! Header name
  type(gildas), target, intent(inout) :: head     ! Header
  logical(kind=4),      intent(inout) :: error    ! Logical error flag
  real(kind=4),         intent(in)    :: data(:,:,:)  !
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = locwrd(data(1,1,1))
  call sub_mapgildas(name,head,fmt_r4,addr,error)
end subroutine sic_mapgildas_r43d
!
subroutine sic_mapgildas_r44d(name,head,error,data)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_mapgildas_r44d
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data. It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name     ! Header name
  type(gildas), target, intent(inout) :: head     ! Header
  logical(kind=4),      intent(inout) :: error    ! Logical error flag
  real(kind=4),         intent(in)    :: data(:,:,:,:)  !
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = locwrd(data(1,1,1,1))
  call sub_mapgildas(name,head,fmt_r4,addr,error)
end subroutine sic_mapgildas_r44d
!
subroutine sic_mapgildas_r81d(name,head,error,data)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_mapgildas_r81d
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data. It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name     ! Header name
  type(gildas), target, intent(inout) :: head     ! Header
  logical(kind=4),      intent(inout) :: error    ! Logical error flag
  real(kind=8),         intent(in)    :: data(:)  !
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = locwrd(data(1))
  call sub_mapgildas(name,head,fmt_r8,addr,error)
end subroutine sic_mapgildas_r81d
!
subroutine sic_mapgildas_r82d(name,head,error,data)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_mapgildas_r82d
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data. It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name     ! Header name
  type(gildas), target, intent(inout) :: head     ! Header
  logical(kind=4),      intent(inout) :: error    ! Logical error flag
  real(kind=8),         intent(in)    :: data(:,:)  !
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = locwrd(data(1,1))
  call sub_mapgildas(name,head,fmt_r8,addr,error)
end subroutine sic_mapgildas_r82d
!
subroutine sic_mapgildas_r83d(name,head,error,data)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_mapgildas_r83d
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data. It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name     ! Header name
  type(gildas), target, intent(inout) :: head     ! Header
  logical(kind=4),      intent(inout) :: error    ! Logical error flag
  real(kind=8),         intent(in)    :: data(:,:,:)  !
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = locwrd(data(1,1,1))
  call sub_mapgildas(name,head,fmt_r8,addr,error)
end subroutine sic_mapgildas_r83d
!
subroutine sic_mapgildas_r84d(name,head,error,data)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_mapgildas_r84d
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data. It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: name     ! Header name
  type(gildas), target, intent(inout) :: head     ! Header
  logical(kind=4),      intent(inout) :: error    ! Logical error flag
  real(kind=8),         intent(in)    :: data(:,:,:,:)  !
  ! Local
  integer(kind=address_length) :: addr
  !
  addr = locwrd(data(1,1,1,1))
  call sub_mapgildas(name,head,fmt_r8,addr,error)
end subroutine sic_mapgildas_r84d
!
subroutine sub_mapgildas(name,head,fmt,address,error)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sub_mapgildas
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_mapgildas
  !   Create an IMAGE SIC variable from an existing Header structure
  ! and data (specified by its address and size). 
  ! It is global and program_defined.
  !---------------------------------------------------------------------
  character(len=*),             intent(in)    :: name     ! Header name
  type(gildas), target,         intent(inout) :: head     ! Header
  integer(kind=4),              intent(in)    :: fmt      ! Data type (fmt_r4,...)
  integer(kind=address_length), intent(in)    :: address  ! Address of data
  logical(kind=4),              intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  type(sic_identifier_t) :: var
  integer(kind=4) :: in,ier,lf
  !
  ! Warning:  
  !   A combination of SIC_DEF_REAL and SIC_DEF_HEADER apparently
  ! provides a similar functionality, but would be different.
  ! The main differences are
  !   1)  readonly attribute is NOT possible here
  !   2)  a simple call to sic_delvariable can delete
  !       the whole structure created by sic_mapgildas
  !
  var%name = name
  lf = len_trim(var%name)
  var%lname = lf
  var%level = 0                         ! Global of course
  ier = sic_hasins('DEFINE',maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.0 .or. ier.eq.2) then
    error = .true.
    return
  endif
  !
  if (address.eq.ptr_null) then  ! Header only
    desc%type = 0
    desc%addr = ptr_null
    desc%head => head
    desc%ndim = 0
    desc%dims(:) = 0
    desc%size = 0
  else                 ! Header and data
    desc%type = fmt
    desc%addr = address 
    desc%head => head
    desc%ndim = head%gil%ndim
    desc%dims(:) = head%gil%dim
    desc%size = desc_nword(desc)
  endif
  desc%readonly = .true.
  desc%status = program_defined
  !
  ! "Program defined" global variable are not tracked
  ! by the VAR_G - VAR_N stuff
  !
  ! Set the descriptor
  dicvar(in)%desc = desc
  ! and only after that, define the associated Header 
  call sub_def_header(var,'%',head,.false.,-1,error)
end subroutine sub_mapgildas

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_help_tool
  use gbl_message
  use cubetools_parameters
  use cubetools_cmessaging
  !---------------------------------------------------------------------
  ! This module provides methods to display help lines, i.e. lines
  ! with severity xxxseve%help. This is usually trigerred by a command
  ! help (e.g. VIEW ?) or the COLLECT command. Such lines can go either
  ! to screen or to a file (may be with a specific format like Tex or
  ! Markdown)
  !---------------------------------------------------------------------
  !
  type :: help_tool_t
  contains
    procedure, public, nopass :: message    => cubetools_help_message
    procedure, public, nopass :: open_file  => cubetools_help_open_file
    procedure, public, nopass :: close_file => cubetools_help_close_file
  end type help_tool_t
  !
  integer(kind=code_k), parameter :: sevehelp=999  ! Value must not clash with the other seve%
  integer(kind=4) :: help_lun = 0
  !
  public :: help_tool_t,sevehelp
  private
  !
contains
  !
  subroutine cubetools_help_message(message_id,procname,message)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in) :: message_id
    character(len=*), intent(in) :: procname
    character(len=*), intent(in) :: message
    !
    if (help_lun.ne.0) then
      write(help_lun,'(A)')  trim(message)
    else
      call cubetools_cmessage(message_id,seve%r,procname,message)
    endif
  end subroutine cubetools_help_message
  !
  subroutine cubetools_help_open_file(file,error)
    use gkernel_interfaces
    use gpack_def
    !-------------------------------------------------------------------
    ! Open the file where toolseve%help messages will be redirected
    ! as long as the file is not closed.
    ! If the file is closed, these messages go to the terminal.
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: file
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='HELP>OPEN>FILE'
    !
    ier = sic_getlun(help_lun)
    if (ier.ne.1) then
      call cubetools_cmessage(gpack_global_id,seve%e,rname,'No logical unit left')
      error = .true.
      return
    endif
    ier = sic_open(help_lun,file,'NEW',.false.)
    if (ier.ne.0) then
      call cubetools_cmessage(gpack_global_id,seve%e,rname,'Cannot open file '//file)
      error = .true.
      call sic_frelun(help_lun)
      return
    endif
  end subroutine cubetools_help_open_file
  !
  subroutine cubetools_help_close_file(error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='HELP>CLOSE>FILE'
    !
    ier = sic_close(help_lun)
    call sic_frelun(help_lun)
    help_lun = 0
  end subroutine cubetools_help_close_file
end module cubetools_help_tool

subroutine write_sdm_field(error)
  !---------------------------------------------------------------------
  ! Write the Source Field  table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_Field
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (FieldRow) :: fRow
  type (FieldKey) :: fKey
  type (FieldOpt) :: fOpt
  integer :: i, ier, numAssocFieldId, k, l
  integer , parameter  :: mPoly=3
  real*8 :: dir(2)
  character sdmTable*12, chain*80
  parameter (sdmTable='Field')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  fRow%numPoly = 1
!!  call allocFieldRow(fRow, fRow%numPoly,  error)
  call allocFieldRow(fRow, error)
  if (error) return
  if (r_lamof.eq.0.0 .and. r_betof.eq.0.0) then
    fRow%fieldName = r_sourc
  else
    write (chain,1000) r_sourc, r_lamof, r_betof
1000 format(a,'(',f6.1,',',f6.1,')')
    call noir(chain, fRow%fieldName, 256)
  endif
  ! save for scan table
  field_Name = fRow%fieldName
  fRow%code = '-'
  ! now optional ! fRow%time = 0
  !
  ! By default at Bure we keep the phase center on the pointing center.
  dir(2) = r_bet + r_betof
  dir(1) = r_lam + r_lamof/cos(dir(2))
  do k = 1, fRow%numPoly
    do l = 1, 2
      fRow%delayDir(l, k) = dir(l)
    enddo
  enddo
  fRow%phaseDir = fRow%delayDir
  fRow%referenceDir = fRow%delayDir
  !     *TBD* the actual way this is specified (put in the actual 2000
  !     ra and dec coordinates?)
  ! deleted ! fRow%flagRow = .false.
  !
  call addFieldRow(fKey, fRow, error)
  if (error) return
  Field_Id = fKey%FieldId
  !
  ! add optional parameters (sourceId)
  !
  fOpt%sourceId = source_Id
  call addFieldSourceId(fKey, fOpt, error)
  if (error) return
  call sdmMessage(1,1,sdmTable ,'Written.')
  !
  return
end subroutine write_sdm_field
!---------------------------------------------------------------------
subroutine get_sdm_field(error)
  !---------------------------------------------------------------------
  ! Read the Source Field  table.
  !
  ! Key: fieldId
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_Field
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (FieldRow) :: fRow
  type (FieldKey) :: fKey
  type (FieldOpt) :: fOpt
  logical :: present
  integer :: ier
  integer , parameter  :: mPoly=3
  character sdmTable*12
  parameter (sdmTable='Field')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  call allocFieldRow(fRow, mPoly,  error)
  if (error) return
  !
  fKey%FieldId = Field_Id
  call getFieldRow(fKey, fRow, error)
  if (error) return
  ! Note the offsets must be in phaseDir ???
  !
  ! add optional parameters (sourceId)
  call getFieldSourceId(fKey, fOpt, present, error)
  if (error) return
  !c      print *, 'fOpt%sourceId ', fOpt%sourceId
  source_Id = fOpt%sourceId
  call sdmMessage(1,1,sdmTable ,'Read.')
  !
  return
end subroutine get_sdm_field
!---------------------------------------------------------------------
!!! subroutine allocFieldRow(row, numPoly,  error)
!!!   !---------------------------------------------------------------------
!!!   !$$$    real*8, allocatable :: delayDir(:,:)
!!!   !$$$    real*8, allocatable :: phaseDir(:,:)
!!!   !$$$    real*8, allocatable :: referenceDir(:,:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_Field
!!!   type(FieldRow) :: row
!!!   integer :: numPoly, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*8 = 'Field'
!!!   !
!!!   ! delayDir
!!!   if (allocated(row%delayDir)) then
!!!     deallocate(row%delayDir, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%delayDir(2,numPoly+1), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! phaseDir
!!!   if (allocated(row%phaseDir)) then
!!!     deallocate(row%phaseDir, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%phaseDir(2,numPoly+1), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! referenceDir
!!!   if (allocated(row%referenceDir)) then
!!!     deallocate(row%referenceDir, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%referenceDir(2,numPoly+1), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!!! !---------------------------------------------------------------------
!!! subroutine allocFieldOpt(opt, numAssocFieldId,  error)
!!!   !---------------------------------------------------------------------
!!!   !     integer, allocatable :: assocFieldId(:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_Field
!!!   type(FieldOpt) :: opt
!!!   integer :: numAssocFieldId, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*8 = 'Field'
!!!   !
!!!   ! assocFieldId
!!!   if (allocated(opt%assocFieldId)) then
!!!     deallocate(opt%assocFieldId, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(opt%assocFieldId(numAssocFieldId), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end

subroutine write_sdm_focusModel(error)
  !---------------------------------------------------------------------
  ! Write the Focus Model SDM table.
  ! (very much TBD at present)
  !     int sdm_addFocusModelRow ()
  !---------------------------------------------------------------------
  use gildas_def
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  !type(FocusModelRow) :: fmRow
  !type(FocusModelKey) :: fmKey
  integer ia
  integer sdm_addfocusModelrow, ireturn
  character sdmTable*12
  parameter (sdmTable='FocusModel')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !!fmRow%numCoeff = 1
  !call allocFocusModelRow(fmrow, error)
  if (error) return
  !
  do ia = 1, r_nant
    !ireturn = sdm_addfocusModelrow(fmrow, error)
    if (ireturn.lt.0) then
      call sdmMessageI(8,3,sdmTable   &
        ,'Error in sdm_addFocusModelRow',ireturn)
      goto 99
    endif
    FocusModel_Id(ia) = ireturn
  enddo
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_focusModel
!---------------------------------------------------------------------

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage GFITS messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gfits_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: gfits_message_id = gpack_global_id  ! Default value for startup message
  !
end module gfits_message_private
!
subroutine gfits_message_set_id(id)
  use gfits_interfaces, except_this=>gfits_message_set_id
  use gfits_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  gfits_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',gfits_message_id
  call gfits_message(seve%d,'gfits_message_set_id',mess)
  !
end subroutine gfits_message_set_id
!
subroutine gfits_message(mkind,procname,message)
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_message
  use gfits_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(gfits_message_id,mkind,procname,message)
  !
end subroutine gfits_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
!     $Id$
!
! TBD:  error handling
! TBD:  for the lists: use linked lists instead of arrays
!
Module results_to_vo
  !
  Use pako_xml
  !
  Implicit None
  Save
  Private
  !
  ! *** Subroutines:
  !
  Public   ::  results_to_VO_writeProlog
  Public   ::  results_to_VO_setOdpHeader
  Public   ::  results_to_VO_writeOdpHeader
  Public   ::  results_to_VO_setMeasurementHeader
  Public   ::  results_to_VO_setScanId
  Public   ::  results_to_VO_writeMeasurementHeader
  Public   ::  results_to_VO_setReceiver
  Public   ::  results_to_VO_writeReceivers
  Public   ::  results_to_VO_setBackend
  Public   ::  results_to_VO_writeBackends
  Public   ::  results_to_VO_setFocusResults
  Public   ::  results_to_VO_writeFocusResults
  Public   ::  results_to_VO_setPointingResults
  Public   ::  results_to_VO_writePointingResults
  Public   ::  results_to_VO_setCalibrationResults
  Public   ::  results_to_VO_writeCalibrationResults
  Public   ::  results_to_VO_writeMeasurementEnd
  Public   ::  results_to_VO_writeEnd
  !
  ! *** Derived Types:
  !
  Public   ::  resultT
  !
  ! *** values representing "not set":
  !
  Character(len=8), Parameter  :: cNone = 'none'
  Integer,          Parameter  :: iNone = 0
  Real,             Parameter  :: rNone = 0.0
  Real*8,           Parameter  :: dNone = 0.0D0
  ! TBD: lNone = .False.
  !
  !
  ! *** for ODP Header in XML file:
  !
  Type     ::  odpHeaderT
     Character(len=128) ::  telescope   = cNone
     Character(len=128) ::  observatory = cNone
     Character(len=128) ::  odpSoftware = cNone
     ! ...
  End Type odpHeaderT
  Type(odpHeaderT)      ::  odpHeader, odpHeaderDefault
  !
  ! *** for "measurement Header in XML file:
  !
  ! first: list of scanID or scan numbers
  !
  Type :: scanIdT
     Character(len=24)  :: scanId              = cNone
     Integer            :: scanN               = iNone
  End Type scanIdT
  Integer, Parameter    :: nDimScans           = 99
  Integer               :: nScans              = 0
  Type(scanIdT), Dimension(nDimScans) :: scans
  Type(scanIdT)                       :: scanDefault
  !
  Type     ::  measurementHeaderT
     Character(len=128) :: measurement         =  cNone
     Character(len=128) :: sourceName          =  cNone
     Character(len=128) :: timeStamp           =  cNone
     Real               :: azimuth             =  rNone
     Real               :: elevation           =  rNone
     Real               :: refraction          =  rNone
     Real               :: pressureAmbient     =  rNone
     Real               :: temperatureAmbient  =  rNone
     Real               :: humidityAmbient     =  rNone
     Logical            :: lAzimuth            = .False.
     Logical            :: lElevation          = .False.
     Logical            :: lRefraction         = .False.
     Logical            :: lPressureAmbient    = .False.
     Logical            :: lTemperatureAmbient = .False.
     Logical            :: lHumidityAmbient    = .False.
     Character(len=128) :: switchingMode       =  cNone
     Character(len=128) :: observingMode       =  cNone
     Character(len=128) :: method              =  cNone
     Character(len=128) :: focusDirection      =  cNone
     Real               :: focusLength         =  rNone
     Real               :: focusCurrent        =  rNone
     Logical            :: lFocusLength        = .False.
     Logical            :: lFocusCurrent       = .False.
     Real               :: pointingLength      =  rNone
     Real               :: pointingP1          =  rNone
     Real               :: pointingP2          =  rNone
     Real               :: pointingP7          =  rNone
     Logical            :: lPointingLength     = .False.
     Logical            :: lPointingP1         = .False.
     Logical            :: lPointingP2         = .False.
     Logical            :: lPointingP7         = .False.
     ! ...
  End Type measurementHeaderT
  Type(measurementHeaderT) ::  mHead
  Type(measurementHeaderT) ::  mHeadDefault
  !
  ! *** list of receivers
  !      consistent with paKo --> some extra variables
  !
  Type :: receiverFrequency
     Character(len=12)       :: name           = cNone
     Character(len=12)       :: kind           = cNone
     Character(len=12)       :: unit           = cNone
     Character(len=12)       :: doppler        = cNone
     Real*8                  :: value          = dNone
  End Type receiverFrequency
  !
  Type :: gainRatio
     Character(len=12)       :: name           = cNone
     Character(len=12)       :: kind           = cNone
     Character(len=12)       :: unit           = cNone
     Real*4                  :: value          = dNone
     Real*4                  :: db             = dNone
  End Type gainRatio
  !
  Type :: varReceiverT
     !
     Character(len=13)       :: name           = cNone
     Logical                 :: isConnected    = .False.
     Logical                 :: gunnOn         = .False.
     Type(receiverFrequency) :: frequency
     Type(receiverFrequency) :: frequencyImage
     Type(receiverFrequency) :: offset
     Type(receiverFrequency) :: centerIF
     !
     Character(len=100)      :: lineName       = cNone
     !
     Character(len=12)       :: sideBand       = cNone
     Character(len=12)       :: doppler        = cNone
     Character(len=12)       :: width          = cNone
     !
     Real*4                  :: effForward     = rNone
     Real*4                  :: effBeam        = rNone
     Character(len=12)       :: scale          = cNone
     Type(gainRatio)         :: gainImage
     Real*4                  :: tempAmbient    = rNone
     Real*4                  :: tempCold       = rNone
     Real*4                  :: xOffsetNasmyth = rNone
     Real*4                  :: yOffsetNasmyth = rNone
     Real*4                  :: lcalof         = rNone
     Real*4                  :: bcalof         = rNone
     Real*4                  :: h2omm          = rNone
     Real*4                  :: trx            = rNone
     Real*4                  :: tsys           = rNone
     Real*4                  :: tcal           = rNone
     Real*4                  :: tatms          = rNone
     Real*4                  :: tatmi          = rNone
     Real*4                  :: tauzen         = rNone
     Real*4                  :: tauzenImage    = rNone
     Real*4                  :: pcold          = rNone
     Real*4                  :: phot           = rNone
     Real*4                  :: psky           = rNone
     !
     Integer                 :: iPixel         = iNone
     !
  End Type varReceiverT
  !
  Integer, Parameter :: nDimReceivers  = 18
  Integer            :: nRec           = 0
  integer            :: ncal           = 0
  Type(varReceiverT) :: receiverDefault  ! Default instance for this type
  Type(varReceiverT) :: receivers(nDimReceivers)   ! Support for setReceiver and writeReceivers
  Type(varReceiverT) :: calresults(nDimReceivers)  ! Support for setCalibrationResults and writeCalibrationResults
  !
  ! *** list of backends
  !      consistent with paKo --> some extra variables
  !
  Type :: varBackendT
     !
     Character(len=12)       :: name           = cNone
     Logical                 :: wasConnected   = .False.
     Logical                 :: isConnected    = .False.
     Integer                 :: nPart          = iNone
     !
     Real*4                  :: resolution     = rNone
     Real*4                  :: bandWidth      = rNone
     Real*4                  :: fShift         = rNone
     !
     Character(len=13)       :: receiverName   = cNone
     !
     Integer                 :: nChannels      = iNone
     !
  End Type varBackendT
  !
  Integer, Parameter         :: nDimBackends   = 99
  Integer                    :: nBack          = 0
  Type(varBackendT), Dimension(nDimBackends)   :: backends
  Type(varBackendT)                            :: backendDefault
  !
  ! *** list of pointing results
  !
  ! most results have a value and an error:
  !
  Type :: resultT
     Real*4                  :: value          = rNone
     Real*4                  :: error          = rNone
  End Type resultT
  !
  Type :: focusResultsT
     Character(len=12)       :: backendName    = cNone
     Integer                 :: backendPart    = iNone
     Type(resultT)           :: focus
     Type(resultT)           :: offset
     Real*4                  :: rmsResidual    = rNone
  End Type focusResultsT
  !
  Integer, Parameter         :: nDimResults      = 99
  Integer                    :: nFocusResults = 0
  Type(focusResultsT), Dimension(nDimResults) :: FocusResults
  Type(focusResultsT)                         :: FocusResultDefault
  !
  Type :: pointingResultsT
     Character(len=12)       :: backendName    = cNone
     Integer                 :: backendPart    = iNone
     character(len=8)        :: recName        = cNone
     Real*4                  :: direction      = rNone
     Type(resultT)           :: correction
     Type(resultT)           :: peak
     Type(resultT)           :: integral
     Type(resultT)           :: offset
     Type(resultT)           :: width
     Real*4                  :: rmsResidual    = rNone
  End Type pointingResultsT
  !
!!$  Integer, Parameter         :: nDimResults      = 99
  Integer                    :: nPointingResults = 0
  Type(pointingResultsT), Dimension(nDimResults) :: PointingResults
  Type(pointingResultsT)                         :: PointingResultDefault
  !
Contains
!!!
!!!
  Subroutine results_to_VO_writeProlog(                             &
       &                                       error,             &
       &                                       errorC             &
       &                            )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Character(len=256) :: c1,c2
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    c1 = ".xml file generated by results_to_vo.f90 (author: Hans Ungerechts)"
    call gag_release(c2)
    !
    Call pakoXMLwriteStartXML("1.0",                              &
                              "VOTABLE", "VOTable.dtd", "1.0",    &
                              comment1=c1,                        &
                              comment2=c2,                        &
                              error=errorXML)
    !
    If (Present(error) .And. errorXML) then
      error=errorXML
      return
    endif
    !
  End Subroutine results_to_VO_writeProlog
!!!
!!!
  Subroutine results_to_VO_setOdpHeader(                            &
       &                                       telescope        , &
       &                                       observatory      , &
       &                                       odpSoftware      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                             )
    !
    Character(len=*), Intent(IN), Optional  :: telescope
    Character(len=*), Intent(IN), Optional  :: observatory
    Character(len=*), Intent(IN), Optional  :: odpSoftware
    !
    Logical         , Intent(IN), Optional  :: default            ! set default values
    Logical         , Intent(IN), Optional  :: reset              ! re-set values to undefined
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       odpHeader = odpHeaderDefault
    End If
    !
    If (Present(reset).And.reset) Then
       odpHeader = odpHeaderDefault
    End If
    !
    If (Present(telescope))   odpHeader%telescope   = telescope
    If (Present(observatory)) odpHeader%observatory = observatory
    If (Present(odpSoftware)) odpHeader%odpSoftware = odpSoftware
    !
    Return
    !
  End Subroutine results_to_VO_setOdpHeader
!!!
!!!
  Subroutine results_to_VO_writeOdpHeader(                          &
       &                                       error,             &
       &                                       errorC             &
       &                               )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'odpHeader',                    &
         &              error   = errorXML)
    !
    If (odpHeader%telescope.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'telescope',                 &
            &              value   = odpHeader%telescope,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (odpHeader%observatory.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'observatory',               &
            &              value   = odpHeader%observatory,       &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (odpHeader%odpSoftware.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'odpSoftware',               &
            &              value   = odpHeader%odpSoftware,       &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'odpHeader',                    &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeOdpHeader
!!!
!!!
  Subroutine results_to_VO_setMeasurementHeader(                     &
       &                                       measurement       , &
       &                                       sourceName        , &
       &                                       timeStamp         , &
       &                                       azimuth           , &
       &                                       elevation         , &
       &                                       refraction        , &
       &                                       pressureAmbient   , &
       &                                       temperatureAmbient, &
       &                                       humidityAmbient   , &
       &                                       switchingMode     , &
       &                                       observingMode     , &
       &                                       method            , &
       &                                       focusDirection    , &
       &                                       focusLength       , &
       &                                       focusCurrent      , &
       &                                       pointingLength    , &
       &                                       pointingP1        , &
       &                                       pointingP2        , &
       &                                       pointingP7        , &
       &                                       default           , &
       &                                       reset             , &
       &                                       error             , &
       &                                       errorC              &
       &                                     )
    !
    Character(len=*), Intent(IN), Optional  :: measurement
    Character(len=*), Intent(IN), Optional  :: sourceName
    Character(len=*), Intent(IN), Optional  :: timeStamp
    Real            , Intent(IN), Optional  :: azimuth
    Real            , Intent(IN), Optional  :: elevation
    Real            , Intent(IN), Optional  :: refraction
    Real            , Intent(IN), Optional  :: pressureAmbient
    Real            , Intent(IN), Optional  :: temperatureAmbient
    Real            , Intent(IN), Optional  :: humidityAmbient
    Character(len=*), Intent(IN), Optional  :: switchingMode
    Character(len=*), Intent(IN), Optional  :: observingMode
    Character(len=*), Intent(IN), Optional  :: method
    Character(len=*), Intent(IN), Optional  :: focusDirection
    Real            , Intent(IN), Optional  :: focusLength
    Real            , Intent(IN), Optional  :: focusCurrent
    Real            , Intent(IN), Optional  :: pointingLength
    Real            , Intent(IN), Optional  :: pointingP1
    Real            , Intent(IN), Optional  :: pointingP2
    Real            , Intent(IN), Optional  :: pointingP7
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       mHead = mHeadDefault
    End If
    !
    If (Present(reset).And.reset) Then
       mHead = mHeadDefault
    End If
    !
    If (Present(measurement )) mHead%measurement = measurement
    If (Present(sourceName  )) mHead%sourceName  = sourceName
    If (Present(timeStamp   )) mHead%timeStamp   = timeStamp
    If (Present(azimuth     )) mHead%azimuth     = azimuth
    !
    If (Present(azimuth           )) Then
       mHead%azimuth            = azimuth
       mHead%lAzimuth           = .True.
    End If
    !
    If (Present(elevation         )) Then
       mHead%elevation          = elevation
       mHead%lElevation         = .True.
    End If
    !
    If (Present(refraction        )) Then
       mHead%refraction         = refraction
       mHead%lRefraction        = .True.
    End If
    !
    If (Present(pressureAmbient   )) Then
       mHead%pressureAmbient    = pressureAmbient
       mHead%lPressureAmbient   = .True.
    End If
    !
    If (Present(temperatureAmbient)) Then
       mHead%temperatureAmbient = temperatureAmbient
       mHead%lTemperatureAmbient= .True.
    End If
    !
    If (Present(humidityAmbient   )) Then
       mHead%humidityAmbient    = humidityAmbient
       mHead%lHumidityAmbient   = .True.
    End If
    !
    If (Present(switchingMode)) mHead%switchingMode = trim(switchingMode)
    If (Present(observingMode)) mHead%observingMode = observingMode
    If (Present(method       )) mHead%method        = method
    !
    If (Present(focusDirection)) mHead%focusDirection = focusDirection
!
    If (Present(focusLength    )) Then
       mHead%focusLength     = focusLength
       mHead%lFocusLength    = .True.
    End If
    !
    If (Present(focusCurrent    )) Then
       mHead%focusCurrent     = focusCurrent
       mHead%lFocusCurrent    = .True.
    End If
    !
    If (Present(pointingLength    )) Then
       mHead%pointingLength     = pointingLength
       mHead%lPointingLength    = .True.
    End If
    !
    If (Present(pointingP1        )) Then
       mHead%pointingP1         = pointingP1
       mHead%lPointingP1        = .True.
    End If
    !
    If (Present(pointingP2        )) Then
       mHead%pointingP2         = pointingP2
       mHead%lPointingP2        = .True.
    End If
    !
    If (Present(pointingP7        )) Then
       mHead%pointingP7         = pointingP7
       mHead%lPointingP7        = .True.
    End If
    !
    Return
    !
  End Subroutine results_to_VO_setMeasurementHeader
!!!
!!!
  Subroutine results_to_VO_setScanId(                               &
       &                                       scanId           , &
       &                                       scanN            , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                          )
    !
    Character(len=*), Intent(IN), Optional  :: scanId
    Integer         , Intent(IN), Optional  :: scanN
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nScans = 0
       scans(:) = scanDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nScans = 0
       scans(:) = scanDefault
    End If
    !
    If ((Present(scanId).Or.Present(scanN)) .And. nScans.Lt.nDimScans) Then
       nScans = nScans+1
    End If
    !
    ! TBD: could do a consistency check to ensure that ther is no
    !      "mixed" scan list, i.e., shoud be all Ids OR numbers!
    !
    If (Present(scanId))      scans(nScans)%scanId = scanId
    If (Present(scanN))       scans(nScans)%scanN  = scanN
    !
    Return
    !
  End Subroutine results_to_VO_setScanId
!!!
!!!
  Subroutine results_to_VO_writeMeasurementHeader(                  &
       &                                       error,             &
       &                                       errorC             &
       &                                       )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurement',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurementHeader',            &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    If (mHead%measurement.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'measurement',               &
            &              value   = mHead%measurement,           &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%sourceName.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'sourceName',                &
            &              value   = mHead%sourceName,            &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    ! TBD: timeStamp could be generated internally
    !
    If (mHead%timeStamp.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'timeStamp',                 &
            &              value   = mHead%timeStamp,             &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%lAzimuth) Then
       Write (valueC,*) mHead%azimuth
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'azimuth',                  &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'deg',                      &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lElevation) Then
       Write (valueC,*) mHead%elevation
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'elevation',                &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'deg',                      &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lRefraction) Then
       Write (valueC,*) mHead%refraction
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'refraction',               &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'arcsec',                   &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lTemperatureAmbient) Then
       Write (valueC,*) mHead%temperatureAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'temperatureAmbient',       &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'K',                        &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lPressureAmbient) Then
       Write (valueC,*) mHead%pressureAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'pressureAmbient',          &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = '10+2Pa',                   &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lHumidityAmbient) Then
       Write (valueC,*) mHead%humidityAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'humidityAmbient',          &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = '%',                        &
            &              error    =  errorXML)
    End If
    !
    If (mHead%switchingMode.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'switchingMode',             &
            &              value   = mHead%switchingMode,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%observingMode.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'observingMode',             &
            &              value   = mHead%observingMode,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%method.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'method',                    &
            &              value   = mHead%method,                &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    ! ***
    !
    ! TBD: parameters for specific mesurements, depending on
    !      "measurement" and "observingMode"
    !
    valueC = mHead%measurement
    Call pakoXMLupper(valueC)
    !
    If (valueC.Eq.'FOCUS') Then                                   ! parameters for FOCUS
       !
       If (mHead%focusDirection.Ne.cNone) Then
          Call  pakoXMLwriteElement(                              &
               &              element = 'PARAM',                  &
               &              name    = 'focusDirection',         &
               &              value   = mHead%focusDirection,     &
               &              dataType = 'char',                  &
               &              error   = errorXML)
       End If
       !
       If (mHead%lFocusLength) Then
          Write (valueC,*) mHead%focusLength
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'focusLength',           &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'mm',                    &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lFocusCurrent) Then
          Write (valueC,*) mHead%focusCurrent
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'focusCurrent',          &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'mm',                    &
               &              error    =  errorXML)
       End If
       !
    End If                                                        ! end of Focus
    ! ***
    !
    If (valueC.Eq.'POINTING') Then                                ! parameters for POINTING
       !
       If (mHead%lPointingLength) Then
          Write (valueC,*) mHead%pointingLength
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingLength',        &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'arcsec',                &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP1) Then
          Write (valueC,*) mHead%pointingP1
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP1',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                   &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP2) Then
          Write (valueC,*) mHead%pointingP2
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP2',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                   &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP7) Then
          Write (valueC,*) mHead%pointingP7
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP7',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                   &
               &              error    =  errorXML)
       End If
       !
    End If                                                        ! end of Pointing
    ! ***
    !
    Call pakoXMLwriteStartElement("RESOURCE","scanList",          &
         &                         error=errorXML)
       !
    Call pakoXMLwriteStartElement("TABLE","scanList",             &
         &                         error=errorXML)
    !
    If (scans(1)%scanId .Ne. cNone) then
       Call pakoXMLwriteElement("FIELD","scanId",                 &
            &                         dataType="char",            &
            &                         error=errorXML)
    End If
    !
    If (scans(1)%scanN .Ne. iNone) Then
       Call pakoXMLwriteElement("FIELD","scanNumber",             &
            &                         dataType="int",             &
            &                         error=errorXML)
    End If
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    ! **
    Do ii = 1,nScans,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       If (scans(ii)%scanId .Ne. cNone) then
          valueC = scans(ii)%scanId
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
       End If
       !
       If (scans(ii)%scanN .Ne. iNone) then
          Write (valueC,*)                                        &
               &                  scans(ii)%scanN
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
       End If
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
       !
    End Do
    ! **
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","scanList",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","scanList",          &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurementHeader',            &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeMeasurementHeader
!!!
!!!
  Subroutine results_to_VO_writeMeasurementEnd(                     &
       &                                       error,             &
       &                                       errorC             &
       &                                    )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurement',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeMeasurementEnd
!!!
!!!
  Subroutine results_to_VO_setReceiver(                             &
       &                                       name             , &
       &                                       frequency        , &
       &                                       frequencyImage   , &
       &                                       offset           , &
       &                                       centerIF         , &
       &                                       lineName         , &
       &                                       sideBand         , &
       &                                       doppler          , &
       &                                       width            , &
       &                                       effForward       , &
       &                                       effBeam          , &
       &                                       scale            , &
       &                                       gainImage        , &
       &                                       tempAmbient      , &
       &                                       tempCold         , &
       &                                       xOffsetNasmyth   , &
       &                                       yOffsetNasmyth   , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                            )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Real*8          , Intent(IN), Optional  :: frequency
    Real*8          , Intent(IN), Optional  :: frequencyImage
    Real*8          , Intent(IN), Optional  :: offset
    Real*8          , Intent(IN), Optional  :: centerIF
    Character(len=*), Intent(IN), Optional  :: lineName
    Character(len=*), Intent(IN), Optional  :: sideBand
    Character(len=*), Intent(IN), Optional  :: doppler
    Character(len=*), Intent(IN), Optional  :: width
    Real            , Intent(IN), Optional  :: effForward
    Real            , Intent(IN), Optional  :: effBeam
    Character(len=*), Intent(IN), Optional  :: scale
    Real            , Intent(IN), Optional  :: gainImage
    Real            , Intent(IN), Optional  :: tempAmbient
    Real            , Intent(IN), Optional  :: tempCold
    !
    Real            , Intent(IN), Optional  :: xOffsetNasmyth
    Real            , Intent(IN), Optional  :: yOffsetNasmyth
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nRec = 0
       receivers(:) = receiverDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nRec = 0
       receivers(:) = receiverDefault
    End If
    !
    If (Present(name) .And. nRec.Lt.nDimReceivers) Then
       nRec = nRec+1
       receivers(nRec)%name        = name
       receivers(nRec)%isConnected = .True.
    End If
    !
    If (Present(frequency))      receivers(nRec)%frequency%value      = frequency
    If (Present(frequencyImage)) receivers(nRec)%frequencyImage%value = frequencyImage
    If (Present(offset))         receivers(nRec)%offset%value         = offset
    If (Present(centerIF))       receivers(nRec)%centerIF%value       = centerIF
    If (Present(lineName))       receivers(nRec)%lineName             = lineName
    If (Present(sideBand))       receivers(nRec)%sideBand             = sideBand
    If (Present(doppler))        receivers(nRec)%doppler              = doppler
    If (Present(width))          receivers(nRec)%width                = width
    If (Present(effForward))     receivers(nRec)%effForward           = effForward
    If (Present(effBeam))        receivers(nRec)%effBeam              = effBeam
    If (Present(scale))          receivers(nRec)%scale                = scale
    If (Present(gainImage))      receivers(nRec)%gainImage%value      = gainImage
    If (Present(tempAmbient))    receivers(nRec)%tempAmbient          = tempAmbient
    If (Present(tempCold))       receivers(nRec)%tempCold             = tempCold
    If (Present(xOffsetNasmyth)) receivers(nRec)%xOffsetNasmyth       = xOffsetNasmyth
    If (Present(yOffsetNasmyth)) receivers(nRec)%yOffsetNasmyth       = yOffsetNasmyth
    !
    Return
    !
  End Subroutine results_to_VO_setReceiver
!!!
!!!
  Subroutine results_to_VO_setCalibrationResults(                   &
       &                                       name             , &
       &                                       frequency        , &
       &                                       frequencyImage   , &
       &                                       lineName         , &
       &                                       sideBand         , &
       &                                       effForward       , &
       &                                       effBeam          , &
       &                                       gainImage        , &
       &                                       tempAmbient      , &
       &                                       tempCold         , &
       &                                       xOffsetNasmyth   , &
       &                                       yOffsetNasmyth   , &
       &                                       lcalof           , &
       &                                       bcalof           , &
       &                                       h2omm            , &
       &                                       trx              , &
       &                                       tsys             , &
       &                                       tcal             , &
       &                                       tatms            , &
       &                                       tatmi            , &
       &                                       tauzen           , &
       &                                       tauzenImage      , &
       &                                       pcold            , &
       &                                       phot             , &
       &                                       psky             , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                            )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Real*8          , Intent(IN), Optional  :: frequency
    Real*8          , Intent(IN), Optional  :: frequencyImage
    Character(len=*), Intent(IN), Optional  :: lineName
    Character(len=*), Intent(IN), Optional  :: sideBand
    Real            , Intent(IN), Optional  :: effForward
    Real            , Intent(IN), Optional  :: effBeam
    Real            , Intent(IN), Optional  :: gainImage
    Real            , Intent(IN), Optional  :: tempAmbient
    Real            , Intent(IN), Optional  :: tempCold
    Real            , Intent(IN), Optional  :: xOffsetNasmyth
    Real            , Intent(IN), Optional  :: yOffsetNasmyth
    !
    Real            , Intent(IN), Optional  :: lcalof
    Real            , Intent(IN), Optional  :: bcalof
    Real            , Intent(IN), Optional  :: h2omm
    Real            , Intent(IN), Optional  :: trx
    Real            , Intent(IN), Optional  :: tsys
    Real            , Intent(IN), Optional  :: tcal
    Real            , Intent(IN), Optional  :: tatms
    Real            , Intent(IN), Optional  :: tatmi
    Real            , Intent(IN), Optional  :: tauzen
    Real            , Intent(IN), Optional  :: tauzenImage
    Real            , Intent(IN), Optional  :: pcold
    Real            , Intent(IN), Optional  :: phot
    Real            , Intent(IN), Optional  :: psky
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       ncal = 0
       calresults(:) = receiverDefault
    End If
    !
    If (Present(reset).And.reset) Then
       ncal = 0
       calresults(:) = receiverDefault
    End If
    !
    If (Present(name) .And. nCal.Lt.nDimReceivers) Then
       ncal = ncal+1
       calresults(ncal)%name        = name
       calresults(ncal)%isConnected = .True.
    End If
    !
    If (Present(frequency))      calresults(nCal)%frequency%value      = frequency
    If (Present(frequencyImage)) calresults(nCal)%frequencyImage%value = frequencyImage
    If (Present(lineName))       calresults(nCal)%lineName             = lineName
    If (Present(sideBand))       calresults(nCal)%sideBand             = sideBand
    If (Present(effForward))     calresults(nCal)%effForward           = effForward
    If (Present(effBeam))        calresults(nCal)%effBeam              = effBeam
    If (Present(gainImage))      calresults(nCal)%gainImage%value      = gainImage
    If (Present(tempAmbient))    calresults(nCal)%tempAmbient          = tempAmbient
    If (Present(tempCold))       calresults(nCal)%tempCold             = tempCold
    If (Present(xOffsetNasmyth)) calresults(nCal)%xOffsetNasmyth       = xOffsetNasmyth
    If (Present(yOffsetNasmyth)) calresults(nCal)%yOffsetNasmyth       = yOffsetNasmyth
    If (Present(lcalof))         calresults(nCal)%lcalof          = lcalof
    If (Present(bcalof))         calresults(nCal)%bcalof          = bcalof
    If (Present(h2omm))          calresults(nCal)%h2omm           = h2omm
    If (Present(trx))            calresults(nCal)%trx             = trx
    If (Present(tsys))           calresults(nCal)%tsys            = tsys
    If (Present(tcal))           calresults(nCal)%tcal            = tcal
    If (Present(tatms))          calresults(nCal)%tatms           = tatms
    If (Present(tatmi))          calresults(nCal)%tatmi           = tatmi
    If (Present(tauzen))         calresults(nCal)%tauzen          = tauzen
    If (Present(tauzenImage))    calresults(nCal)%tauzenImage     = tauzenImage
    If (Present(pcold))          calresults(nCal)%pcold           = pcold
    If (Present(phot))           calresults(nCal)%phot            = phot
    If (Present(psky))           calresults(nCal)%psky            = psky

    !
    Return
    !
  End Subroutine results_to_VO_setCalibrationResults
!!!
!!!
  Subroutine results_to_VO_writeReceivers(                          &
       &                                       error,             &
       &                                       errorC             &
       &                               )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'receivers',                    &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'TABLE',                        &
         &              name    = 'receivers',                    &
         &              error   = errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiverName",              &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","lineName",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequency",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","sideBand",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","doppler",                   &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","width",                     &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","gainImage",                 &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tempCold",                  &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tempAmbient",               &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","effForward",                &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","effBeam",                   &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","scale",                     &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","centerIF",                  &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequencyImage",            &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","xOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","yOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    ! **
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimReceivers,1
       If (receivers(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%name
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%lineName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%frequency%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%sideBand
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%doppler
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%width
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%gainImage%value
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%tempCold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%tempAmbient
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%effForward
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%effBeam
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%scale
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%offset%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%centerIF%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &        receivers(ii)%frequencyImage%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%xOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%yOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","receivers",            &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","receivers",         &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeReceivers
!!!
!!!
  Subroutine results_to_VO_writeCalibrationResults(                 &
       &                                       error,             &
       &                                       errorC             &
       &                                 )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'calibration',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'TABLE',                        &
         &              name    = 'calibration',                  &
         &              error   = errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiverName",              &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","lineName",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequency",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","sideBand",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","gainImage",                 &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tempCold",                  &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tempAmbient",               &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","effForward",                &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","effBeam",                   &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequencyImage",            &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","xOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","yOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","lcalof",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","bcalof",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","h2omm",                     &
         &                         dataType="double",             &
         &                         unit="mm",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","trx",                       &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tsys",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tcal",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tatms",                     &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tatmi",                     &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tauzen",                    &
         &                         dataType="double",             &
         &                         unit="Neper",                  &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tauzenImage",               &
         &                         dataType="double",             &
         &                         unit="Neper",                  &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","pcold",                     &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","phot",                      &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","psky",                      &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)
    !
    ! **
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimReceivers,1
       If (calresults(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = calresults(ii)%name
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = calresults(ii)%lineName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%frequency%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = calresults(ii)%sideBand
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%gainImage%value
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%tempCold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%tempAmbient
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%effForward
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%effBeam
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &        calresults(ii)%frequencyImage%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%xOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%yOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%lcalof
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%bcalof
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%h2omm
          valueComment = 'mm'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%trx
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tsys
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tcal
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tatms
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tatmi
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tauzen
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tauzenImage
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%pcold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%phot
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%psky
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","calibration",          &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","calibration",       &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeCalibrationResults
!!!
!!!
  Subroutine results_to_VO_setBackend(                              &
       &                                       name             , &
       &                                       nPart            , &
       &                                       resolution       , &
       &                                       bandwidth        , &
       &                                       fShift           , &
       &                                       receiver         , &
       &                                       nChannels        , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                           )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Integer         , Intent(IN), Optional  :: nPart
    Real            , Intent(IN), Optional  :: resolution  ! MHz
    Real            , Intent(IN), Optional  :: bandwidth   ! MHz
    Real            , Intent(IN), Optional  :: fShift      ! MHz
    Character(len=*), Intent(IN), Optional  :: receiver
    Integer         , Intent(IN), Optional  :: nChannels
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nBack = 0
       backends(:) = backendDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nBack = 0
       backends(:) = backendDefault
    End If
    !
    If (Present(name) .And. nBack.Lt.nDimBackends) Then
       nBack = nBack+1
       backends(nBack)%name        = name
       backends(nBack)%isConnected = .True.
    End If
    !
    If (Present(nPart))      backends(nBack)%nPart        = nPart
    If (Present(resolution)) backends(nBack)%resolution   = resolution
    If (Present(bandwidth))  backends(nBack)%bandwidth    = bandwidth
    If (Present(fShift))     backends(nBack)%fShift       = fShift
    If (Present(receiver))   backends(nBack)%receiverName = receiver
    If (Present(nChannels))  backends(nBack)%nChannels    = nChannels
    !
    Return
    !
  End Subroutine results_to_VO_setBackend
!!!
!!!
  Subroutine results_to_VO_writeBackends(                           &
       &                                       error,             &
       &                                       errorC             &
       &                              )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","backends",          &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","backends",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","resolution",                &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","bandwidth",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","fShift",                    &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiver",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nChannels",                 &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimBackends,1
       If (backends(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = backends(ii)%name
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,*)                                        &
               &                  backends(ii)%nPart
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%resolution/1.0D3
          Write (valueComment,*) backends(ii)%resolution,'MHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%bandwidth/1.0D3
          Write (valueComment,*) backends(ii)%bandwidth,'MHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%fShift/1.0D3
          Write (valueComment,*) backends(ii)%fShift,'MHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = backends(ii)%receiverName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,*)                                        &
               &                  backends(ii)%nChannels
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    ! ***
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","backends",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","backends",          &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeBackends
!!!
!!!
  Subroutine results_to_VO_setFocusResults(                         &
       &                                       backendName      , &
       &                                       nPart            , &
       &                                       focus            , &
       &                                       offset           , &
       &                                       rmsResidual      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                                   )
    !
    Character(len=*), Intent(IN), Optional  :: backendName
    Integer         , Intent(IN), Optional  :: nPart
    Type(resultT)   , Intent(IN), Optional  :: focus
    Type(resultT)   , Intent(IN), Optional  :: offset
    Real*4          , Intent(IN), Optional  :: rmsResidual
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical         , Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Integer :: ii
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nFocusResults = 0
       FocusResults(:) = FocusResultDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nFocusResults = 0
       FocusResults(:) = FocusResultDefault
    End If
    !
    If (Present(backendName) .And. nBack.Lt.nDimBackends) Then
       nFocusResults = nFocusResults+1
       ii               = nFocusResults
       focusResults(ii)%backendName = backendName
    End If
    !
    If (Present(nPart))       focusResults(ii)%backendPart  = nPart
    If (Present(focus))       focusResults(ii)%focus        = focus
    If (Present(offset))      focusResults(ii)%offset       = offset
    If (Present(rmsResidual)) focusResults(ii)%rmsResidual  = rmsResidual
    !
!!$    write (6,*) '  focusResults(ii)%backendPart   ',  focusResults(ii)%backendPart
!!$    write (6,*) '  focusResults(ii)%focus    ',  focusResults(ii)%focus
!!$    write (6,*) '  focusResults(ii)%offset   ',  focusResults(ii)%offset
!!$    write (6,*) '  focusResults(ii)%rmsResidual   ', focusResults(ii)%rmsResidual
    !
    Return
    !
  End Subroutine results_to_VO_setFocusResults
!!!
!!!
  Subroutine results_to_VO_writeFocusResults(                       &
       &                                       error,             &
       &                                       errorC             &
       &                                     )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","results",           &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","focus",                &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","focusError",           &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offsetError",               &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","rmsResidual",               &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nFocusResults,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       valueC = focusResults(ii)%backendName
       Call pakoXMLcase(valueC,error=errorXML)
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,*)                                           &
            &                  focusResults(ii)%backendPart
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%focus%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%focus%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%offset%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%offset%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%rmsResidual
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
    End Do
    ! **
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","results",           &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeFocusResults
!!!
!!!
  Subroutine results_to_VO_setPointingResults(                      &
       &                                       backendName      , &
       &                                       nPart            , &
       &                                       recName          , &
       &                                       direction        , &
       &                                       correction       , &
       &                                       peak             , &
       &                                       integral         , &
       &                                       offset           , &
       &                                       width            , &
       &                                       rmsResidual      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                                   )
    !
    use cal2vo_messaging
    Character(len=*), Intent(IN), Optional  :: backendName
    Integer         , Intent(IN), Optional  :: nPart
    Character(len=*), Intent(IN), Optional  :: recName
    Real*4          , Intent(IN), Optional  :: direction
    Type(resultT)   , Intent(IN), Optional  :: correction
    Type(resultT)   , Intent(IN), Optional  :: peak
    Type(resultT)   , Intent(IN), Optional  :: integral
    Type(resultT)   , Intent(IN), Optional  :: offset
    Type(resultT)   , Intent(IN), Optional  :: width
    Real*4          , Intent(IN), Optional  :: rmsResidual
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical         , Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Integer :: ii
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nPointingResults = 0
       PointingResults(:) = PointingResultDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nPointingResults = 0
       PointingResults(:) = PointingResultDefault
    End If
    !
    If (Present(backendName) .And. nBack.Lt.nDimBackends) Then
      if (nPointingResults.Lt.nDimResults) Then
        nPointingResults = nPointingResults+1
      else
        ! This is non-sense to write more than 99 results in XML.
        ! => nothing clever done here, overwrite last one
        call cal2vo_message(seve%i,'VOXML',  &
          'Number of pointing results exceeds limit')
      endif
      ii = nPointingResults
      pointingResults(ii)%backendName = backendName
    End If
    !
    If (Present(nPart))       pointingResults(ii)%backendPart  = nPart
    If (Present(recName))     pointingResults(ii)%recName      = recName
    If (Present(direction))   pointingResults(ii)%direction    = direction
    If (Present(correction))  pointingResults(ii)%correction   = correction
    If (Present(peak))        pointingResults(ii)%peak         = peak
    If (Present(integral))    pointingResults(ii)%integral     = integral
    If (Present(offset))      pointingResults(ii)%offset       = offset
    If (Present(width))       pointingResults(ii)%width        = width
    If (Present(rmsResidual)) pointingResults(ii)%rmsResidual  = rmsResidual
    !
    Return
    !
  End Subroutine results_to_VO_setPointingResults
!!!
!!!
  Subroutine results_to_VO_writePointingResults(                    &
       &                                       error,             &
       &                                       errorC             &
       &                                     )
    Use phys_const
    Use mrtindex_sec_pointing
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","results",           &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","direction",                 &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","correction",                &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","correctionError",           &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","peak",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","peakError",                 &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","integral",                  &
         &                         dataType="double",             &
         &                         unit="K.arcsec",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","integralError",             &
         &                         dataType="double",             &
         &                         unit="K.arcsec",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offsetError",               &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","width",                     &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","widthError",                &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","rmsResidual",               &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nPointingResults,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       valueC = pointingResults(ii)%backendName
       Call pakoXMLcase(valueC,error=errorXML)
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,*)                                           &
            &                  pointingResults(ii)%backendPart
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment=trim(pointingResults(ii)%recName), &
            &                         error=errorXML)
       !
       Write (valueComment,'(f6.2,a)') pointingResults(ii)%direction*deg_per_rad,' deg'
       select case (pointing_direction(pointingResults(ii)%direction))
       case (code_pointing_azimuth)
          valueC = 'azimuth'
       case (code_pointing_elevation)
          valueC = 'elevation'
       case default
          valueC = valueComment
       end select
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment=valueComment,       &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &         pointingResults(ii)%correction%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='correction',       &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &         pointingResults(ii)%correction%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%peak%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='peak',             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%peak%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%integral%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='integral',         &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%integral%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%offset%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='offset',           &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%offset%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%width%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='width',            &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%width%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%rmsResidual
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='rmsResidual',      &
            &                         error=errorXML)
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
    End Do
    ! **
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","results",           &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writePointingResults
!!!
!!!
  Subroutine results_to_VO_writeEnd(                                &
       &                                       error,             &
       &                                       errorC             &
       &                         )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'VOTABLE',                      &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeEnd
!!!
!!!
End Module results_to_vo
!!!

*DECK I1MACH
      INTEGER FUNCTION I1MACH (I)
C***BEGIN PROLOGUE  I1MACH
C***PURPOSE  Return integer machine dependent constants.
C***LIBRARY   SLATEC
C***CATEGORY  R1
C***TYPE      INTEGER (I1MACH-I)
C***KEYWORDS  MACHINE CONSTANTS
C***AUTHOR  Fox, P. A., (Bell Labs)
C           Hall, A. D., (Bell Labs)
C           Schryer, N. L., (Bell Labs)
C***DESCRIPTION
C
C   I1MACH can be used to obtain machine-dependent parameters for the
C   local machine environment.  It is a function subprogram with one
C   (input) argument and can be referenced as follows:
C
C        K = I1MACH(I)
C
C   where I=1,...,16.  The (output) value of K above is determined by
C   the (input) value of I.  The results for various values of I are
C   discussed below.
C
C   I/O unit numbers:
C     I1MACH( 1) = the standard input unit.
C     I1MACH( 2) = the standard output unit.
C     I1MACH( 3) = the standard punch unit.
C     I1MACH( 4) = the standard error message unit.
C
C   Words:
C     I1MACH( 5) = the number of bits per integer storage unit.
C     I1MACH( 6) = the number of characters per integer storage unit.
C
C   Integers:
C     assume integers are represented in the S-digit, base-A form
C
C                sign ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C                where 0 .LE. X(I) .LT. A for I=0,...,S-1.
C     I1MACH( 7) = A, the base.
C     I1MACH( 8) = S, the number of base-A digits.
C     I1MACH( 9) = A**S - 1, the largest magnitude.
C
C   Floating-Point Numbers:
C     Assume floating-point numbers are represented in the T-digit,
C     base-B form
C                sign (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C                where 0 .LE. X(I) .LT. B for I=1,...,T,
C                0 .LT. X(1), and EMIN .LE. E .LE. EMAX.
C     I1MACH(10) = B, the base.
C
C   Single-Precision:
C     I1MACH(11) = T, the number of base-B digits.
C     I1MACH(12) = EMIN, the smallest exponent E.
C     I1MACH(13) = EMAX, the largest exponent E.
C
C   Double-Precision:
C     I1MACH(14) = T, the number of base-B digits.
C     I1MACH(15) = EMIN, the smallest exponent E.
C     I1MACH(16) = EMAX, the largest exponent E.
C
C   To alter this function for a particular environment, the desired
C   set of DATA statements should be activated by removing the C from
C   column 1.  Also, the values of I1MACH(1) - I1MACH(4) should be
C   checked for consistency with the local operating system.
C
C***REFERENCES  P. A. Fox, A. D. Hall and N. L. Schryer, Framework for
C                 a portable library, ACM Transactions on Mathematical
C                 Software 4, 2 (June 1978), pp. 177-188.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   891012  Added VAX G-floating constants.  (WRB)
C   891012  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900618  Added DEC RISC constants.  (WRB)
C   900723  Added IBM RS 6000 constants.  (WRB)
C   901009  Correct I1MACH(7) for IBM Mainframes. Should be 2 not 16.
C           (RWC)
C   910710  Added HP 730 constants.  (SMR)
C   911114  Added Convex IEEE constants.  (WRB)
C   920121  Added SUN -r8 compiler option constants.  (WRB)
C   920229  Added Touchstone Delta i860 constants.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C   920625  Added Convex -p8 and -pd8 compiler option constants.
C           (BKS, WRB)
C   930201  Added DEC Alpha and SGI constants.  (RWC and WRB)
C   930618  Corrected I1MACH(5) for Convex -p8 and -pd8 compiler
C           options.  (DWL, RWC and WRB).
C***END PROLOGUE  I1MACH
C
      INTEGER IMACH(16),OUTPUT
      SAVE IMACH
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT COMPILER
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE APOLLO
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        129 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1025 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM
C
C     DATA IMACH( 1) /          7 /
C     DATA IMACH( 2) /          2 /
C     DATA IMACH( 3) /          2 /
C     DATA IMACH( 4) /          2 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         33 /
C     DATA IMACH( 9) / Z1FFFFFFFF /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -256 /
C     DATA IMACH(13) /        255 /
C     DATA IMACH(14) /         60 /
C     DATA IMACH(15) /       -256 /
C     DATA IMACH(16) /        255 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         48 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /          8 /
C     DATA IMACH(11) /         13 /
C     DATA IMACH(12) /        -50 /
C     DATA IMACH(13) /         76 /
C     DATA IMACH(14) /         26 /
C     DATA IMACH(15) /        -50 /
C     DATA IMACH(16) /         76 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         48 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /          8 /
C     DATA IMACH(11) /         13 /
C     DATA IMACH(12) /        -50 /
C     DATA IMACH(13) /         76 /
C     DATA IMACH(14) /         26 /
C     DATA IMACH(15) /     -32754 /
C     DATA IMACH(16) /      32780 /
C
C     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -4095 /
C     DATA IMACH(13) /       4094 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -4095 /
C     DATA IMACH(16) /       4094 /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /    6LOUTPUT/
C     DATA IMACH( 5) /         60 /
C     DATA IMACH( 6) /         10 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         48 /
C     DATA IMACH( 9) / 00007777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /       -929 /
C     DATA IMACH(13) /       1070 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /       -929 /
C     DATA IMACH(16) /       1069 /
C
C     MACHINE CONSTANTS FOR THE CELERITY C1260
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / Z'7FFFFFFF' /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fn COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fi COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -p8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1023 /
C     DATA IMACH(13) /       1023 /
C     DATA IMACH(14) /        113 /
C     DATA IMACH(15) /     -16383 /
C     DATA IMACH(16) /      16383 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -pd8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1023 /
C     DATA IMACH(13) /       1023 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CRAY
C     USING THE 46 BIT INTEGER COMPILER OPTION
C
C     DATA IMACH( 1) /        100 /
C     DATA IMACH( 2) /        101 /
C     DATA IMACH( 3) /        102 /
C     DATA IMACH( 4) /        101 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         46 /
C     DATA IMACH( 9) / 1777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -8189 /
C     DATA IMACH(13) /       8190 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -8099 /
C     DATA IMACH(16) /       8190 /
C
C     MACHINE CONSTANTS FOR THE CRAY
C     USING THE 64 BIT INTEGER COMPILER OPTION
C
C     DATA IMACH( 1) /        100 /
C     DATA IMACH( 2) /        101 /
C     DATA IMACH( 3) /        102 /
C     DATA IMACH( 4) /        101 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 777777777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -8189 /
C     DATA IMACH(13) /       8190 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -8099 /
C     DATA IMACH(16) /       8190 /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C
C     DATA IMACH( 1) /         11 /
C     DATA IMACH( 2) /         12 /
C     DATA IMACH( 3) /          8 /
C     DATA IMACH( 4) /         10 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /         16 /
C     DATA IMACH(11) /          6 /
C     DATA IMACH(12) /        -64 /
C     DATA IMACH(13) /         63 /
C     DATA IMACH(14) /         14 /
C     DATA IMACH(15) /        -64 /
C     DATA IMACH(16) /         63 /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING G_FLOAT
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING IEEE_FLOAT
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE DEC RISC
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING D_FLOATING
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING G_FLOATING
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE ELXSI 6400
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         32 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         24 /
C     DATA IMACH( 6) /          3 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         23 /
C     DATA IMACH( 9) /    8388607 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         38 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /         43 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         63 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 730
C
      DATA IMACH( 1) /          5 /
      DATA IMACH( 2) /          6 /
      DATA IMACH( 3) /          6 /
      DATA IMACH( 4) /          6 /
      DATA IMACH( 5) /         32 /
      DATA IMACH( 6) /          4 /
      DATA IMACH( 7) /          2 /
      DATA IMACH( 8) /         31 /
      DATA IMACH( 9) / 2147483647 /
      DATA IMACH(10) /          2 /
      DATA IMACH(11) /         24 /
      DATA IMACH(12) /       -125 /
      DATA IMACH(13) /        128 /
      DATA IMACH(14) /         53 /
      DATA IMACH(15) /      -1021 /
      DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     3 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          4 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         39 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     4 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          4 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         55 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 9000
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          7 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         32 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1015 /
C     DATA IMACH(16) /       1017 /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86, AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) /  Z7FFFFFFF /
C     DATA IMACH(10) /         16 /
C     DATA IMACH(11) /          6 /
C     DATA IMACH(12) /        -64 /
C     DATA IMACH(13) /         63 /
C     DATA IMACH(14) /         14 /
C     DATA IMACH(15) /        -64 /
C     DATA IMACH(16) /         63 /
C
C     MACHINE CONSTANTS FOR THE IBM PC
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE IBM RS 6000
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE INTEL i860
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR)
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          5 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         54 /
C     DATA IMACH(15) /       -101 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR)
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          5 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         62 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE SILICON GRAPHICS
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE SUN
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE SUN
C     USING THE -r8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1021 /
C     DATA IMACH(13) /       1024 /
C     DATA IMACH(14) /        113 /
C     DATA IMACH(15) /     -16381 /
C     DATA IMACH(16) /      16384 /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES FTN COMPILER
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          1 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         60 /
C     DATA IMACH(15) /      -1024 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE Z80 MICROPROCESSOR
C
C     DATA IMACH( 1) /          1 /
C     DATA IMACH( 2) /          1 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C***FIRST EXECUTABLE STATEMENT  I1MACH
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 10
C
      I1MACH = IMACH(I)
      RETURN
C
   10 CONTINUE
      WRITE (UNIT = OUTPUT, FMT = 9000)
 9000 FORMAT ('1ERROR    1 IN I1MACH - I OUT OF BOUNDS')
C
C     CALL FDUMP
C
      STOP
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine set_sort(set,line,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>set_sort
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! SET SORT NONE
  ! SET SORT Para1
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=4), parameter :: msort=15
  character(len=12) :: csort(msort),asort
  character(len=12) :: argum
  integer(kind=4) :: nc,n
  data csort /'NONE', &
    'NUMBER','VERSION','SCAN','LAMBDA','BETA','SUBSCAN','OBSERVED', &
    'KIND','QUALITY','BLOC','SOURCE','LINE','TELESCOPE','TOC'/
  !
  call sic_ke (line,0,2,argum,nc,.true.,error)
  if (error) return
  call sic_ambigs('SET SORT',argum,asort,n,csort,msort,error)
  if (error) return
  if (asort.eq.'NONE') then
    set%do_sort = .false.
  else
    set%do_sort = .false.
    nc = sic_narg(0)-1
    if (nc.gt.1) then
      call class_message(seve%e,'SET SORT','Too many sort keys')
      error = .true.
      return
    endif
    set%do_sort = .true.
  endif
  set%sort_name = asort
  !
end subroutine set_sort
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine quicksort(set,x,n,gtt,gte,error)
  use gbl_message
  use classic_api
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Sorting program that uses a quicksort algorithm. Apply for an input
  ! array of integer values, which are SORTED
  !---------------------------------------------------------------------
  type(class_setup_t),        intent(in)    :: set    !
  integer(kind=entry_length), intent(in)    :: n      ! Length of array
  integer(kind=entry_length), intent(inout) :: x(n)   ! Index array to be sorted
  logical,                    external      :: gtt    ! Greater than
  logical,                    external      :: gte    ! Greater than or equal
  logical,                    intent(out)   :: error  ! Error status
  ! Local
  character(len=*), parameter :: rname='SORT'
  integer(kind=4), parameter :: maxstack=1000
  integer(kind=4), parameter :: nstop=15
  integer(kind=entry_length) :: i,j,k,l,r,l1,r1,m,sp
  integer(kind=entry_length) :: lstack(maxstack),rstack(maxstack)
  integer(kind=entry_length) :: temp,key
  logical :: mgtl,lgtr,rgtm
  character(len=message_length) :: mess
  !
  if (n.le.nstop) goto 50
  sp = 0
  sp = sp + 1
  lstack(sp) = 1
  rstack(sp) = n
  !
  ! Sort a subrecord off the stack
  ! Set KEY = median of X(L), X(M), X(R)
  ! No! This is not reasonable, as systematic very inequal partitioning will
  ! occur in some cases (especially for nearly already sorted files)
  ! To fix this problem, I found (but I cannot prove it) that it is best to
  ! select the estimation of the median value from intermediate records. P.V.
1 l = lstack(sp)
  r = rstack(sp)
  sp = sp - 1
  m = (l + r) / 2
  l1=(2*l+r)/3
  r1=(l+2*r)/3
  !
  !   MGTL = X(M) .GT. X(L)
  !   RGTM = X(R) .GT. X(M)
  !
  mgtl = gtt (x(m),x(l))
  rgtm = gtt (x(r),x(m))
  !
  ! Algorithm to select the median key. The original one from MONGO
  ! was completely wrong. P. Valiron, 24-Jan-84 .
  !
  !		   	MGTL	RGTM	LGTR	MGTL.EQV.LGTR	MEDIAN_KEY
  !
  !	KL < KM < KR	T	T	*	*		KM
  !	KL > KM > KR	F	F	*	*		KM
  !
  !	KL < KM > KR	T	F	F	F		KR
  !	KL < KM > KR	T	F	T	T		KL
  !
  !	KL > KM < KR	F	T	F	T		KL
  !	KL > KM < KR	F	T	T	F		KR
  !
  if (mgtl .eqv. rgtm) then
     key = x(m)
  else
     !         LGTR = X(L) .GT. X(R)
     lgtr = gtt (x(l),x(r))
     if (mgtl .eqv. lgtr) then
        key = x(l)
     else
        key = x(r)
     endif
  endif
  i = l
  j = r
  !
  ! Find a big record on the left
10 if (gte(x(i),key)) goto 11
  i = i + 1
  goto 10
11 continue
  ! Find a small record on the right
  !!20 if (gtt(key,x(j))) goto 21  ! No, that was WRONG...
20 if (gte(key,x(j))) goto 21
  if (j.eq.l) call gte_p(key,x(j))
  j = j - 1
  goto 20
21 continue
  if (i.ge.j) goto 2
  !
  ! Exchange records
  temp = x(i)
  x(i) = x(j)
  x(j) = temp
  i = i + 1
  j = j - 1
  goto 10
  !
  ! Subfile is partitioned into two halves, left .le. right
  ! Push the two halves on the stack
2 continue
  if (j-l+1 .gt. nstop) then
     sp = sp + 1
     if (sp.gt.maxstack) then
        write(mess,*) 'Stack overflow ',sp
        call class_message(seve%e,rname,mess)
        error = .true.
        return
     endif
     lstack(sp) = l
     rstack(sp) = j
  endif
  if (r-j .gt. nstop) then
     sp = sp + 1
     if (sp.gt.maxstack) then
        write(mess,*) 'Stack overflow ',sp
        call class_message(seve%e,rname,mess)
        error = .true.
        return
     endif
     lstack(sp) = j+1
     rstack(sp) = r
  endif
  !
  ! Anything left to process?
  if (sp.gt.0) goto 1
  !
50 continue
  !
  do j = n-1,1,-1
     k = j
     do i = j+1,n
        if (gtt(x(i),x(j))) exit
        k = i
     enddo
     if (k.eq.j) cycle
     temp = x(j)
     do i = j+1,k
        x(i-1) = x(i)
     enddo
     x(k) = temp
  enddo
  !
contains
  subroutine gte_p (m,l)
    use class_index
    use gbl_message
    !---------------------------------------------------------------------
    ! TRUE if observation m is greater than observation l
    ! Sorting arrays:
    !    %dobs
    !    %scan
    !    %num
    !    %ver
    !---------------------------------------------------------------------
    integer(kind=entry_length), intent(in) :: m  ! Observation number
    integer(kind=entry_length), intent(in) :: l  ! Observation number
    ! Local
    logical :: gte_i
    character(len=12) :: ksort
    !
    ksort = set%sort_name
    Print *,'Final sort ',ksort
    select case (ksort)
    case ('BLOC')
      gte_i = ix%bloc(m).ge.ix%bloc(l)
    case ('NUMBER')
      gte_i = ix%num(m).ge.ix%num(l)
    case ('VERSION')
      gte_i = abs(ix%ver(m)).ge.abs(ix%ver(l))
    case ('OBSERVED')
      gte_i = ix%dobs(m).ge.ix%dobs(l)
    case ('LAMBDA')
      gte_i = ix%off1(m).ge.ix%off1(l)
    case ('BETA')
      gte_i = ix%off2(m).ge.ix%off2(l)
    case ('SCAN')
      gte_i = ix%scan(m).ge.ix%scan(l)
    case ('SUBSCAN')
      gte_i = ix%subscan(m).ge.ix%subscan(l)
    case ('KIND')
      gte_i = ix%kind(m).ge.ix%kind(l)
    case ('QUALITY')
      gte_i = ix%qual(m).ge.ix%qual(l)
    ! case ('TYPE')
    !   gte_i = ix%type(m).ge.ix%type(l)
    ! case ('REDUCED')
    !   gte_i = ix%dred(m).ge.ix%dred(l)
    case ('SOURCE')
      gte_i = ix%csour(m).ge.ix%csour(l)
    case ('LINE')
      gte_i = ix%cline(m).ge.ix%cline(l)
    case ('TELESCOPE')
      gte_i = ix%ctele(m).ge.ix%ctele(l)
    ! case ('ANGLE')
    !   gte_i = ix%posa(m).ge.ix%posa(l)
    case default
      call class_message(seve%w,'GTE_P','There is sort of a problem')
    end select
    if (gte_i) then
      print *,m,ix%scan(m),' >= ',ix%scan(l),l
      print *,m,ix%subscan(m),' >= ',ix%subscan(l),l
    else
      print *,m,ix%scan(m),' < ',ix%scan(l),l
      print *,m,ix%subscan(m),' >= ',ix%subscan(l),l
    endif
  end subroutine gte_p
  !
end subroutine quicksort
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! ********************************************************************
!
! IX index Greater than: TRUE if observation m is greater than observation l
!
! ********************************************************************
!
logical function ix_csour_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_csour_gt = ix%csour(m).gt.ix%csour(l)
end function ix_csour_gt
!
logical function ix_cline_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_cline_gt = ix%cline(m).gt.ix%cline(l)
end function ix_cline_gt
!
logical function ix_ctele_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_ctele_gt = ix%ctele(m).gt.ix%ctele(l)
end function ix_ctele_gt
!
logical function ix_bloc_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_bloc_gt = ix%bloc(m).gt.ix%bloc(l)
end function ix_bloc_gt
!
logical function ix_num_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_num_gt = ix%num(m).gt.ix%num(l)
end function ix_num_gt
!
logical function ix_ver_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_ver_gt = ix%ver(m).gt.ix%ver(l)
end function ix_ver_gt
!
logical function ix_dobs_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! Sorting arrays (by precedence order):
  !    %dobs
  !    %scan
  !    %num
  !    %ver
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_dobs_gt = .false.
  if (ix%dobs(m).gt.ix%dobs(l)) then
     ix_dobs_gt=.true.
  else if (ix%dobs(m).eq.ix%dobs(l)) then
     if (ix%scan(m) .gt. ix%scan(l)) then
        ix_dobs_gt = .true.
     elseif (ix%scan(m) .eq. ix%scan(l)) then
        if (ix%num(m) .gt. ix%num(l)) then
           ix_dobs_gt = .true.
        elseif  (ix%num(m) .eq. ix%num(l)) then
           if (ix%ver(m) .gt. ix%ver(l)) ix_dobs_gt = .true.
        endif
     endif
  endif
end function ix_dobs_gt
!
logical function ix_off1_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_off1_gt = ix%off1(m).gt.ix%off1(l)
end function ix_off1_gt
!
logical function ix_off2_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_off2_gt = ix%off2(m).gt.ix%off2(l)
end function ix_off2_gt
!
logical function ix_scan_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_scan_gt = ix%scan(m).gt.ix%scan(l)
end function ix_scan_gt
!
logical function ix_subscan_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_subscan_gt = ix%subscan(m).gt.ix%subscan(l)
end function ix_subscan_gt
!
logical function ix_kind_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_kind_gt = ix%kind(m).gt.ix%kind(l)
end function ix_kind_gt
!
logical function ix_qual_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_qual_gt = ix%qual(m).gt.ix%qual(l)
end function ix_qual_gt
!
logical function ix_toc_default_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = ix%csour(m)//ix%cline(m)//ix%ctele(m)
  ch2 = ix%csour(l)//ix%cline(l)//ix%ctele(l)
  ix_toc_default_gt = ch1.gt.ch2
end function ix_toc_default_gt
!
! ********************************************************************
!
! IX index Greater Equal: TRUE if observation m is greater or equal than observation l
!
! ********************************************************************
!
logical function ix_csour_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_csour_ge = ix%csour(m).ge.ix%csour(l)
end function ix_csour_ge
!
logical function ix_cline_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_cline_ge = ix%cline(m).ge.ix%cline(l)
end function ix_cline_ge
!
logical function ix_ctele_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_ctele_ge = ix%ctele(m).ge.ix%ctele(l)
end function ix_ctele_ge
!
logical function ix_bloc_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_bloc_ge = ix%bloc(m).ge.ix%bloc(l)
end function ix_bloc_ge
!
logical function ix_num_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_num_ge = ix%num(m).ge.ix%num(l)
end function ix_num_ge
!
logical function ix_ver_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_ver_ge = ix%ver(m).ge.ix%ver(l)
end function ix_ver_ge
!
logical function ix_dobs_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! Sorting arrays (by precedence order):
  !    %dobs
  !    %scan
  !    %num
  !    %ver
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_dobs_ge = .false.
  if (ix%dobs(m).gt.ix%dobs(l)) then
     ix_dobs_ge=.true.
  else if (ix%dobs(m).eq.ix%dobs(l)) then
     if (ix%scan(m) .gt. ix%scan(l)) then
        ix_dobs_ge = .true.
     elseif (ix%scan(m) .eq. ix%scan(l)) then
        if (ix%num(m) .gt. ix%num(l)) then
           ix_dobs_ge = .true.
        elseif  (ix%num(m) .eq. ix%num(l)) then
           if (ix%ver(m) .ge. ix%ver(l)) ix_dobs_ge = .true.
        endif
     endif
  endif
end function ix_dobs_ge
!
logical function ix_off1_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_off1_ge = ix%off1(m).ge.ix%off1(l)
end function ix_off1_ge
!
logical function ix_off2_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_off2_ge = ix%off2(m).ge.ix%off2(l)
end function ix_off2_ge
!
logical function ix_scan_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_scan_ge = ix%scan(m).ge.ix%scan(l)
end function ix_scan_ge
!
logical function ix_subscan_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_subscan_ge = ix%subscan(m).ge.ix%subscan(l)
end function ix_subscan_ge
!
logical function ix_kind_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_kind_ge = ix%kind(m).ge.ix%kind(l)
end function ix_kind_ge
!
logical function ix_qual_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_qual_ge = ix%qual(m).ge.ix%qual(l)
end function ix_qual_ge
!
logical function ix_toc_default_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = ix%csour(m)//ix%cline(m)//ix%ctele(m)
  ch2 = ix%csour(l)//ix%cline(l)//ix%ctele(l)
  ix_toc_default_ge = ch1.ge.ch2
end function ix_toc_default_ge
!
! ********************************************************************
!
! IX index Equal: TRUE if observation m is equal to observation l
!
! ********************************************************************
!
logical function ix_csour_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_csour_eq = ix%csour(m).eq.ix%csour(l)
end function ix_csour_eq
!
logical function ix_cline_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_cline_eq = ix%cline(m).eq.ix%cline(l)
end function ix_cline_eq
!
logical function ix_ctele_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_ctele_eq = ix%ctele(m).eq.ix%ctele(l)
end function ix_ctele_eq
!
logical function ix_bloc_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_bloc_eq = ix%bloc(m).eq.ix%bloc(l)
end function ix_bloc_eq
!
logical function ix_num_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_num_eq = ix%num(m).eq.ix%num(l)
end function ix_num_eq
!
logical function ix_ver_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_ver_eq = ix%ver(m).eq.ix%ver(l)
end function ix_ver_eq
!
logical function ix_dobs_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_dobs_eq = ix%dobs(m).eq.ix%dobs(l)
end function ix_dobs_eq
!
logical function ix_off1_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_off1_eq = ix%off1(m).eq.ix%off1(l)
end function ix_off1_eq
!
logical function ix_off2_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_off2_eq = ix%off2(m).eq.ix%off2(l)
end function ix_off2_eq
!
logical function ix_scan_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_scan_eq = ix%scan(m).eq.ix%scan(l)
end function ix_scan_eq
!
logical function ix_subscan_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_subscan_eq = ix%subscan(m).eq.ix%subscan(l)
end function ix_subscan_eq
!
logical function ix_kind_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_kind_eq = ix%kind(m).eq.ix%kind(l)
end function ix_kind_eq
!
logical function ix_qual_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  ix_qual_eq = ix%qual(m).eq.ix%qual(l)
end function ix_qual_eq
!
logical function ix_toc_default_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = ix%csour(m)//ix%cline(m)//ix%ctele(m)
  ch2 = ix%csour(l)//ix%cline(l)//ix%ctele(l)
  ix_toc_default_eq = ch1.eq.ch2
end function ix_toc_default_eq
!
logical function ix_toc_date_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = ix%csour(m)//ix%cline(m)//ix%ctele(m)
  ch2 = ix%csour(l)//ix%cline(l)//ix%ctele(l)
  ix_toc_date_eq = (ch1.eq.ch2) .and. (ix%dobs(m).eq.ix%dobs(l))
end function ix_toc_date_eq
!
logical function ix_toc_scan_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = ix%csour(m)//ix%cline(m)//ix%ctele(m)
  ch2 = ix%csour(l)//ix%cline(l)//ix%ctele(l)
  ix_toc_scan_eq = (ch1.eq.ch2) .and. (ix%dobs(m).eq.ix%dobs(l)) .and.(ix%scan(m).eq.ix%scan(l))
end function ix_toc_scan_eq
!
! ********************************************************************
!
! CX index Greater than
!
! ********************************************************************
!
logical function cx_csour_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_csour_gt = cx%csour(m).gt.cx%csour(l)
end function cx_csour_gt
!
logical function cx_cline_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_cline_gt = cx%cline(m).gt.cx%cline(l)
end function cx_cline_gt
!
logical function cx_ctele_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_ctele_gt = cx%ctele(m).gt.cx%ctele(l)
end function cx_ctele_gt
!
logical function cx_bloc_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_bloc_gt = cx%bloc(m).gt.cx%bloc(l)
end function cx_bloc_gt
!
logical function cx_num_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_num_gt = cx%num(m).gt.cx%num(l)
end function cx_num_gt
!
logical function cx_ver_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_ver_gt = cx%ver(m).gt.cx%ver(l)
end function cx_ver_gt
!
logical function cx_dobs_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_dobs_gt = cx%dobs(m).gt.cx%dobs(l)
end function cx_dobs_gt
!
logical function cx_off1_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_off1_gt = cx%off1(m).gt.cx%off1(l)
end function cx_off1_gt
!
logical function cx_off2_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_off2_gt = cx%off2(m).gt.cx%off2(l)
end function cx_off2_gt
!
logical function cx_scan_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_scan_gt = cx%scan(m).gt.cx%scan(l)
end function cx_scan_gt
!
logical function cx_subscan_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_subscan_gt = cx%subscan(m).gt.cx%subscan(l)
end function cx_subscan_gt
!
logical function cx_kind_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_kind_gt = cx%kind(m).gt.cx%kind(l)
end function cx_kind_gt
!
logical function cx_qual_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_qual_gt = cx%qual(m).gt.cx%qual(l)
end function cx_qual_gt
!
logical function cx_toc_default_gt(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = cx%csour(m)//cx%cline(m)//cx%ctele(m)
  ch2 = cx%csour(l)//cx%cline(l)//cx%ctele(l)
  cx_toc_default_gt = ch1.gt.ch2
end function cx_toc_default_gt
!
! ********************************************************************
!
! CX index Greater Equal
!
! ********************************************************************
!
logical function cx_csour_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_csour_ge = cx%csour(m).ge.cx%csour(l)
end function cx_csour_ge
!
logical function cx_cline_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_cline_ge = cx%cline(m).ge.cx%cline(l)
end function cx_cline_ge
!
logical function cx_ctele_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_ctele_ge = cx%ctele(m).ge.cx%ctele(l)
end function cx_ctele_ge
!
logical function cx_bloc_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_bloc_ge = cx%bloc(m).ge.cx%bloc(l)
end function cx_bloc_ge
!
logical function cx_num_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_num_ge = cx%num(m).ge.cx%num(l)
end function cx_num_ge
!
logical function cx_ver_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_ver_ge = cx%ver(m).ge.cx%ver(l)
end function cx_ver_ge
!
logical function cx_dobs_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_dobs_ge = cx%dobs(m).ge.cx%dobs(l)
end function cx_dobs_ge
!
logical function cx_off1_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_off1_ge = cx%off1(m).ge.cx%off1(l)
end function cx_off1_ge
!
logical function cx_off2_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_off2_ge = cx%off2(m).ge.cx%off2(l)
end function cx_off2_ge
!
logical function cx_scan_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_scan_ge = cx%scan(m).ge.cx%scan(l)
end function cx_scan_ge
!
logical function cx_subscan_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_subscan_ge = cx%subscan(m).ge.cx%subscan(l)
end function cx_subscan_ge
!
logical function cx_kind_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_kind_ge = cx%kind(m).ge.cx%kind(l)
end function cx_kind_ge
!
logical function cx_qual_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_qual_ge = cx%qual(m).ge.cx%qual(l)
end function cx_qual_ge
!
logical function cx_toc_default_ge(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = cx%csour(m)//cx%cline(m)//cx%ctele(m)
  ch2 = cx%csour(l)//cx%cline(l)//cx%ctele(l)
  cx_toc_default_ge = ch1.ge.ch2
end function cx_toc_default_ge
!
! ********************************************************************
!
! CX index Equal
!
! ********************************************************************
!
logical function cx_csour_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_csour_eq = cx%csour(m).eq.cx%csour(l)
end function cx_csour_eq
!
logical function cx_cline_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_cline_eq = cx%cline(m).eq.cx%cline(l)
end function cx_cline_eq
!
logical function cx_ctele_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  ! TRUE if observation m is greater than observation l
  ! Comparison is done according to one keyword
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_ctele_eq = cx%ctele(m).eq.cx%ctele(l)
end function cx_ctele_eq
!
logical function cx_bloc_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_bloc_eq = cx%bloc(m).eq.cx%bloc(l)
end function cx_bloc_eq
!
logical function cx_num_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_num_eq = cx%num(m).eq.cx%num(l)
end function cx_num_eq
!
logical function cx_ver_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_ver_eq = cx%ver(m).eq.cx%ver(l)
end function cx_ver_eq
!
logical function cx_dobs_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_dobs_eq = cx%dobs(m).eq.cx%dobs(l)
end function cx_dobs_eq
!
logical function cx_off1_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_off1_eq = cx%off1(m).eq.cx%off1(l)
end function cx_off1_eq
!
logical function cx_off2_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_off2_eq = cx%off2(m).eq.cx%off2(l)
end function cx_off2_eq
!
logical function cx_scan_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_scan_eq = cx%scan(m).eq.cx%scan(l)
end function cx_scan_eq
!
logical function cx_subscan_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_subscan_eq = cx%subscan(m).eq.cx%subscan(l)
end function cx_subscan_eq
!
logical function cx_kind_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_kind_eq = cx%kind(m).eq.cx%kind(l)
end function cx_kind_eq
!
logical function cx_qual_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  !
  cx_qual_eq = cx%qual(m).eq.cx%qual(l)
end function cx_qual_eq
!
logical function cx_toc_default_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = cx%csour(m)//cx%cline(m)//cx%ctele(m)
  ch2 = cx%csour(l)//cx%cline(l)//cx%ctele(l)
  cx_toc_default_eq = ch1.eq.ch2
end function cx_toc_default_eq
!
logical function cx_toc_date_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = cx%csour(m)//cx%cline(m)//cx%ctele(m)
  ch2 = cx%csour(l)//cx%cline(l)//cx%ctele(l)
  cx_toc_date_eq = (ch1.eq.ch2) .and. (cx%dobs(m).eq.cx%dobs(l))
end function cx_toc_date_eq
!
logical function cx_toc_scan_eq(m,l)
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! LAS internal routine
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in) :: m  ! Observation number
  integer(kind=entry_length), intent(in) :: l  ! Observation number
  ! Local
  character(len=36) :: ch1,ch2
  !
  ch1 = cx%csour(m)//cx%cline(m)//cx%ctele(m)
  ch2 = cx%csour(l)//cx%cline(l)//cx%ctele(l)
  cx_toc_scan_eq = (ch1.eq.ch2) .and. (cx%dobs(m).eq.cx%dobs(l)) .and. (cx%scan(m).eq.cx%scan(l))
end function cx_toc_scan_eq
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_consistency_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_format
  use cubetools_consistency_colors
  !
  public  :: consistency_desc_t
  public  :: notol,check,mess,strict,tenper
  public  :: cubetools_consistency_init,cubetools_consistency_final
  public  :: cubetools_consistency_real_check,cubetools_consistency_real_relative_check
  public  :: cubetools_consistency_angle_check,cubetools_consistency_real_print
  public  :: cubetools_consistency_angle_print
  public  :: cubetools_consistency_integer_check,cubetools_consistency_integer_print
  public  :: cubetools_consistency_string_check,cubetools_consistency_string_print
  public  :: cubetools_consistency_logical_check,cubetools_consistency_logical_print
  public  :: cubetools_consistency_title
  private
  !
  ! Formats
  integer(kind=4),  parameter :: ident  = 5  ! Ident for value print
  integer(kind=4),  parameter :: tab    = 20 ! Tabulation for values
  integer(kind=4),  parameter :: fsize  = 15 ! field size for values
  character(len=*), parameter :: rlfmt  = '1pg15.5'
  character(len=*), parameter :: rsfmt  = '1pg10.3'
  character(len=*), parameter :: ilfmt  = 'i15'
  !
  ! Initializations
  real(kind=tole_k), parameter :: notol  = 0d0
  real(kind=tole_k), parameter :: strict = 1d-7
  real(kind=tole_k), parameter :: tenper = 5d-2
  logical,      parameter :: check  = .true.
  logical,      parameter :: mess   = .true.
  !
  type consistency_desc_t
     logical         :: check=.true.  ! Check this section?
     logical         :: prob=.false.  ! Inconsistent?
     logical         :: mess=.true.   ! Output message for this section?
     real(kind=tole_k)    :: tol =0d0      ! Default tolerance  
  end type consistency_desc_t
  !
  interface cubetools_consistency_real_check
     module procedure cubetools_consistency_r8_check
     module procedure cubetools_consistency_r4_check
  end interface cubetools_consistency_real_check
  !
  interface cubetools_consistency_real_relative_check
     module procedure cubetools_consistency_r8_relative_check
     module procedure cubetools_consistency_r4_relative_check
  end interface cubetools_consistency_real_relative_check
  !
  interface cubetools_consistency_angle_check
     module procedure cubetools_consistency_r8_angle_check
     module procedure cubetools_consistency_r4_angle_check
  end interface cubetools_consistency_angle_check
  !
  interface cubetools_consistency_angle_print
     module procedure cubetools_consistency_r8_angle_print
     module procedure cubetools_consistency_r4_angle_print
  end interface cubetools_consistency_angle_print  
  !
  interface cubetools_consistency_real_print
     module procedure cubetools_consistency_r8_print
     module procedure cubetools_consistency_r4_print
     module procedure cubetools_consistency_r8_print_unit
     module procedure cubetools_consistency_r4_print_unit
     module procedure cubetools_consistency_r8_print_2unit
     module procedure cubetools_consistency_r4_print_2unit
  end interface cubetools_consistency_real_print
  !
  interface cubetools_consistency_integer_check
     module procedure cubetools_consistency_i8_check
     module procedure cubetools_consistency_i4_check
  end interface cubetools_consistency_integer_check
  !
  interface cubetools_consistency_integer_print
     module procedure cubetools_consistency_i8_print
     module procedure cubetools_consistency_i4_print
  end interface cubetools_consistency_integer_print
  !
contains
  subroutine cubetools_consistency_init(tol,check,mess,cons,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Init consistency
    !----------------------------------------------------------------------
    real(kind=tole_k),        intent(in)    :: tol
    type(consistency_desc_t), intent(out)   :: cons
    logical,                  intent(in)    :: check
    logical,                  intent(in)    :: mess
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    cons%tol   = tol
    cons%check = check
    cons%mess  = mess
  end subroutine cubetools_consistency_init
  !
  subroutine cubetools_consistency_final(cons,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Final consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(out)   :: cons
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
  end subroutine cubetools_consistency_final
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_r8_check(cons,dble1,dble2,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Check r8 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = .not.nearly_equal(dble1,dble2,cons%tol)
  end subroutine cubetools_consistency_r8_check
  !
  subroutine cubetools_consistency_r4_check(cons,real1,real2,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Check r4 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = .not.nearly_equal(real1,real2,real(cons%tol))
  end subroutine cubetools_consistency_r4_check
  !
  subroutine cubetools_consistency_r8_relative_check(cons,inc1,dble1,inc2,dble2,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Check r8 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=8),             intent(in)    :: inc1
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: inc2
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>RELATIVE>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = .false.
    cons%prob = (.not.nearly_equal(dble1/inc1,dble2/inc1,cons%tol)).or.&
         (.not.nearly_equal(dble1/inc2,dble2/inc2,cons%tol))
  end subroutine cubetools_consistency_r8_relative_check
  !
  subroutine cubetools_consistency_r4_relative_check(cons,inc1,real1,inc2,real2,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Check r4 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=4),             intent(in)    :: inc1
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: inc2
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>RELATIVE>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = (.not.nearly_equal(real1/inc1,real2/inc1,real(cons%tol))).or.&
         (.not.nearly_equal(real1/inc2,real2/inc2,real(cons%tol)))
  end subroutine cubetools_consistency_r4_relative_check
  !
  subroutine cubetools_consistency_r8_angle_check(cons,angle1,angle2,error)
    use gkernel_interfaces
    use phys_const
    !----------------------------------------------------------------------
    ! Check r8 angle consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=8),             intent(in)    :: angle1
    real(kind=8),             intent(in)    :: angle2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>ANGLE>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    ! VVV This is a poor solution as it does not test for angles > pi,
    ! or equal angles with oposing signs
    cons%prob = abs(angle1-angle2).gt.cons%tol*pi
  end subroutine cubetools_consistency_r8_angle_check
  !
  subroutine cubetools_consistency_r4_angle_check(cons,angle1,angle2,error)
    use gkernel_interfaces
    use phys_const
    !----------------------------------------------------------------------
    ! Check r4 angle consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=4),             intent(in)    :: angle1
    real(kind=4),             intent(in)    :: angle2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>ANGLE>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    ! VVV This is a poor solution as it does not test for angles > pi,
    ! or equal angles with oposing signs
    cons%prob = abs(angle1-angle2).gt.cons%tol*pi
  end subroutine cubetools_consistency_r4_angle_check
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_r8_print(label,cons,dble1,dble2,error)
    !----------------------------------------------------------------------
    ! Print i8 consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(dble1,dble2,rlfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(dble1,dble2,rlfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r8_print
  !
  subroutine cubetools_consistency_r4_print(label,cons,real1,real2,error)
    !----------------------------------------------------------------------
    ! Print r4 consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(real1,real2,rlfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(real1,real2,rlfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r4_print
  !
  subroutine cubetools_consistency_r8_print_unit(label,unit,cons,dble1,dble2,error)
    !----------------------------------------------------------------------
    ! Print r8 consistency with unit
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    character(len=*),         intent(in)    :: unit
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>LIST>UNIT'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(dble1,dble2,rlfmt,fsize,unit)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(dble1,dble2,rlfmt,fsize,unit)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r8_print_unit
  !
  subroutine cubetools_consistency_r4_print_unit(label,unit,cons,real1,real2,error)
    !----------------------------------------------------------------------
    ! Print r4 consistency with unit
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    character(len=*),         intent(in)    :: unit
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>LIST>UNIT'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(real1,real2,rlfmt,fsize,unit)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(real1,real2,rlfmt,fsize,unit)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r4_print_unit
  !
  subroutine cubetools_consistency_r8_print_2unit(label,unit1,unit2,cons,dble1,dble2,error)
    !----------------------------------------------------------------------
    ! Print r8 consistency with unit
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    character(len=*),         intent(in)    :: unit1
    character(len=*),         intent(in)    :: unit2
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>LIST>2UNIT'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(dble1,unit1,dble2,unit2,rlfmt,fsize)
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r8_print_2unit
  !
  subroutine cubetools_consistency_r4_print_2unit(label,unit1,unit2,cons,real1,real2,error)
    !----------------------------------------------------------------------
    ! Print r4 consistency with unit
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    character(len=*),         intent(in)    :: unit1
    character(len=*),         intent(in)    :: unit2
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>LIST>2UNIT'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(real1,unit1,real2,unit2,rlfmt,fsize)
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r4_print_2unit
  !
  subroutine cubetools_consistency_r4_angle_print(label,cons,angle1,angle2,error)
    use phys_const
    !----------------------------------------------------------------------
    ! Print angle consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=4),             intent(in)    :: angle1
    real(kind=4),             intent(in)    :: angle2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>ANGLE>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(angle1/rad_per_deg,angle2/rad_per_deg,&
         rlfmt,fsize,'degrees')
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else       
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r4_angle_print
  !
  subroutine cubetools_consistency_r8_angle_print(label,cons,angle1,angle2,error)
    use phys_const
    !----------------------------------------------------------------------
    ! Print angle consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=8),             intent(in)    :: angle1
    real(kind=8),             intent(in)    :: angle2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>ANGLE>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(angle1/rad_per_deg,angle2/rad_per_deg,&
         rlfmt,fsize,'degrees')
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else       
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r8_angle_print
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_i8_check(cons,long1,long2,error)
    !----------------------------------------------------------------------
    ! Check i8 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    integer(kind=8),          intent(in)    :: long1
    integer(kind=8),          intent(in)    :: long2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>I8>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = long1.ne.long2
  end subroutine cubetools_consistency_i8_check
  !
  subroutine cubetools_consistency_i4_check(cons,inte1,inte2,error)
    !----------------------------------------------------------------------
    ! Check i4 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    integer(kind=4),          intent(in)    :: inte1
    integer(kind=4),          intent(in)    :: inte2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>I4>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = inte1.ne.inte2
  end subroutine cubetools_consistency_i4_check
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_i8_print(label,cons,long1,long2,error)
    !----------------------------------------------------------------------
    ! Print i8 consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    integer(kind=8),          intent(in)    :: long1
    integer(kind=8),          intent(in)    :: long2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>I8>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(long1,long2,ilfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(long1,long2,ilfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_i8_print
  !
  subroutine cubetools_consistency_i4_print(label,cons,inte1,inte2,error)
    !----------------------------------------------------------------------
    ! Print i4 consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    integer(kind=4),          intent(in)    :: inte1
    integer(kind=4),          intent(in)    :: inte2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>I4>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(inte1,inte2,ilfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(inte1,inte2,ilfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_i4_print
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_string_check(cons,string1,string2,error)
    !-------------------------------------------------------------------
    ! Check the consistency between two strings
    !-------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    character(len=*),         intent(in)    :: string1
    character(len=*),         intent(in)    :: string2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSITENCY>STRING>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = string1.ne.string2
  end subroutine cubetools_consistency_string_check
  !
  subroutine cubetools_consistency_string_print(label,cons,string1,string2,error)
    !-------------------------------------------------------------------
    ! List the consistency between two strings
    !-------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    character(len=*),         intent(in)    :: string1
    character(len=*),         intent(in)    :: string2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSITENCY>STRING>LIST>1LABEL'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(string1,string2,fsize)
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else       
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_string_print
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_logical_check(cons,logi1,logi2,error)
    !-------------------------------------------------------------------
    ! Check the consistency between two logicals
    !-------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    logical,                  intent(in)    :: logi1
    logical,                  intent(in)    :: logi2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSITENCY>LOGICAL>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = logi1.neqv.logi2
  end subroutine cubetools_consistency_logical_check
  !
  subroutine cubetools_consistency_logical_print(label,cons,logi1,logi2,error)
    !-------------------------------------------------------------------
    ! List the consistency between two logicals
    !-------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    logical,                  intent(in)    :: logi1
    logical,                  intent(in)    :: logi2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSITENCY>LOGICAL>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(logi1,logi2,fsize)
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else       
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_logical_print
  !
  subroutine cubetools_consistency_title(title,level,check,prob,error,short)
    !-------------------------------------------------------------------
    ! Prints the title of a section
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: title
    integer(kind=4),  intent(in)    :: level
    logical,          intent(in)    :: check
    logical,          intent(in)    :: prob
    logical,          intent(inout) :: error
    logical, optional,intent(in)    :: short
    !
    character(len=*), parameter :: rname='CONSITENCY>TITLE'
    character(len=mess_l) :: mess
    character(len=form_l) :: format
    logical :: myshort
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.present(short)) then
       myshort = .false.
    else
       myshort = short
    endif
    if (level.lt.1) then
       call cubeheader_message(seve%e,rname,'Level must be positive')
       error = .true.
       return
    else if (level.eq.1) then
       write(format,'(a,a,a)') '(a)'
    else
       write(format,'(a,i0,a)') '(',2*(level-1),'x,a)'
    endif
    if (check) then
       if (prob) then
          if (myshort) then
             write(mess,format) trim(cubetools_format_color('Inconsistent '//title,colors%incons))
          else
             write(mess,format) trim(cubetools_format_color('Inconsistent '//title//':',colors%incons))
          endif
       else
          write(mess,format) trim(cubetools_format_color('Consistent '//title,colors%cons))
       endif
    else
       write(mess,format) trim(cubetools_format_color(title//' not checked',colors%notche))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_title
  !
  function cubetools_consistency_write_format() result(fmt)
    !-------------------------------------------------------------------
    ! Produce the printing format
    !-------------------------------------------------------------------
    character(len=form_l) :: fmt
    !
    write(fmt,'(2(a,i0),a)') '(',ident,'x,a,":",t',tab,',a)'
  end function cubetools_consistency_write_format
end module cubetools_consistency_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module clic_file
  use classic_params
  use classic_types   
  !
  ! Classic objects
  type(classic_file_t), save :: i, o, d              ! File objects
  type(classic_recordbuf_t)  :: ibuff, obuff, dbuff  ! Observation buffers
  type(classic_recordbuf_t)  :: ibufi, obufi, dbufi  ! Index buffers
  type(classic_entrydesc_t)  :: e, de                ! Entry descriptor
  !
  ! File variables
  integer(kind=4) :: number_trys   ! Number of try before time out in NEW_DATA
  real(kind=4)    :: interval      ! Interval between tries in NEW_DATA
  logical         :: modify        ! Current observation opened for modify
  integer(kind=8) :: old_ixnext    ! Last known data in input file
  !
  ! Observation version
  integer(kind=4),save :: version_current = 6 ! Current observation number
  integer(kind=4) :: version_last = 6 ! Latest observation version number
  integer(kind=4) :: max_rf_file = 20 ! Max number of RF solutions in file
  integer(kind=4) :: scan_offset = 1000000 ! Offset in scan number for RF
end module clic_file
!
module clic_title
  !
  ! Version 1 of observation title
  integer(kind=4), parameter :: vind_v1 =  1 ! Title version
  integer(kind=4), parameter :: lind_v1 = 32 ! Title length     [4-bytes]
  type title_v1_t
    sequence
    integer(kind=4)  :: bloc       !  1   : observation address [records]
    integer(kind=4)  :: num        !  2   : observation number
    integer(kind=4)  :: ver        !  3   : observation version  
    integer(kind=4)  :: sourc(3)   !  4- 6: source name
    integer(kind=4)  :: line(3)    !  7- 9: line name
    integer(kind=4)  :: teles(3)   ! 10-12: telescope name
    integer(kind=4)  :: dobs       ! 13   : observation date    [class_date]
    integer(kind=4)  :: dred       ! 14   : reduction date      [class_date]
    real(kind=4)     :: off1       ! 15   : lambda offset       [radian]
    real(kind=4)     :: off2       ! 16   : beta offset         [radian]
    integer(kind=4)  :: typec      ! 17   : coordinates types
    integer(kind=4)  :: kind       ! 18   : data kind
    integer(kind=4)  :: qual       ! 19   : data quality
    integer(kind=4)  :: scan       ! 20   : scan number
    integer(kind=4)  :: proc       ! 21   : procedure type
    integer(kind=4)  :: itype      ! 22   : observation type
    real(kind=4)     :: houra      ! 23   : hour angle          [radian]
    integer(kind=4)  :: project    ! 24   : project name
    integer(kind=4)  :: pad1       ! 25   : unused word
    integer(kind=4)  :: bpc        ! 26   : baseline bandpass cal status
    integer(kind=4)  :: ic         ! 27   : instrumental cal status
    integer(kind=4)  :: recei      ! 28   : receiver number
    real(kind=4)     :: ut         ! 29   : UT                  [s] 
    integer(kind=4)  :: pad2(3)    ! 30-32: padding to 32 4-bytes word
  end type title_v1_t
  !
  ! Version 2 of observation title
  integer(kind=4), parameter :: vind_v2 =  2 ! Title version
  integer(kind=4), parameter :: lind_v2 = 32 ! Title length     [4-bytes]
  type title_v2_t
    sequence
    integer(kind=8)  :: bloc       !  1- 2: observation address [records]
    integer(kind=4)  :: word       !  3   : address offset      [4-bytes]
    integer(kind=4)  :: ver        !  4   : observation version  
    integer(kind=8)  :: num        !  5- 6: observation number
    integer(kind=4)  :: sourc(3)   !  7- 9: source name
    integer(kind=4)  :: line(3)    ! 10-12: line name
    integer(kind=4)  :: teles(3)   ! 13-15: telescope name
    integer(kind=4)  :: dobs       ! 16   : observation date    [class_date]
    integer(kind=4)  :: dred       ! 17   : reduction date      [class_date]
    real(kind=4)     :: off1       ! 18   : lambda offset       [radian]
    real(kind=4)     :: off2       ! 19   : beta offset         [radian]
    integer(kind=4)  :: typec      ! 20   : coordinates types
    integer(kind=4)  :: kind       ! 21   : data kind
    integer(kind=4)  :: qual       ! 22   : data quality
    integer(kind=4)  :: scan       ! 23   : scan number
    integer(kind=4)  :: proc       ! 24   : procedure type
    integer(kind=4)  :: itype      ! 25   : observation type
    real(kind=4)     :: houra      ! 26   : hour angle          [radian]
    integer(kind=4)  :: project(2) ! 27   : project name
    integer(kind=4)  :: bpc        ! 29   : baseline bandpass cal status
    integer(kind=4)  :: ic         ! 30   : instrumental cal status
    integer(kind=4)  :: recei      ! 31   : receiver number
    real(kind=4)     :: ut         ! 32   : UT                  [s] 
  end type title_v2_t
  !
  ! Index in memory is v2
  type(title_v2_t):: title         ! Observation title format v2 in memory
  integer(kind=4) :: tbuf(lind_v2) ! Buffer in which CLASSIC reads titles.
  ! 
  ! '    ' chain
  integer(kind=4) :: fourblanks    ! To verify project(2) if writing v1
end module clic_title
!
module clic_index
  use classic_params
  !
  ! Index sizes
  integer,parameter          :: m_ix = 1000000
  integer,parameter          :: m_ox = 1000000
  integer,parameter          :: m_dx = 1000000
  integer,parameter          :: m_cx = 1000000
  !
  ! Input observation title index 
  integer(kind=entry_length) :: ix_num  (m_ix) ! Observation number
  integer(kind=8)            :: ix_bloc (m_ix) ! Record where entry starts
  integer(kind=4)            :: ix_word (m_ix) ! First word in record
  integer(kind=4)            :: ix_ver  (m_ix) ! Observation version
  integer(kind=4)            :: ix_kind (m_ix) ! Data kind
  integer(kind=4)            :: ix_qual (m_ix) ! Data quality
  integer(kind=4)            :: ix_itype(m_ix) ! Object type
  integer(kind=4)            :: ix_scan (m_ix) ! Scan number
  integer(kind=4)            :: ix_rece (m_ix) ! Receiver number
  integer(kind=4)            :: ix_proc (m_ix) ! Procedure type
  integer(kind=4), allocatable   :: ix_aflag(:,:) ! Memory flags
  integer(kind=4), allocatable   :: ix_bflag(:,:) ! Memory flags
  !
  ! Output observation title index
  integer(kind=entry_length) :: ox_num  (m_ox) ! Observation number
  integer(kind=8)            :: ox_bloc (m_ox) ! Record where entry starts
  integer(kind=4)            :: ox_word (m_ox) ! First word in record
  integer(kind=4)            :: ox_ver  (m_ox) ! Observation version
  integer(kind=4)            :: ox_scan (m_ox) ! Scan number
  integer(kind=4)            :: ox_rece (m_ox) ! Receiver number
  real(kind=4)               :: ox_ut   (m_ox) ! UT
  !
  ! Data observation title index
  integer(kind=8)            :: dx_bloc (m_dx) ! Record where entry starts
  integer(kind=4)            :: dx_word (m_dx) ! First word in record
  integer(kind=4)            :: dx_scan (m_dx) ! Scan number 
  integer(kind=4)            :: dx_dobs (m_dx) ! Observation date
  integer(kind=4)            :: dx_rece (m_dx) ! Receiver number
  real(kind=4)               :: dx_ut   (m_dx) ! UT
  !
  ! Current observation title index
  integer(kind=entry_length) :: cx_num  (m_cx) ! Observation number
  integer(kind=entry_length) :: cx_ind  (m_cx) ! Input index entry number
  integer(kind=8)            :: cx_bloc (m_cx) ! Record where entry starts
  integer(kind=4)            :: cx_word (m_cx) ! First word in record
  integer(kind=4)            :: cx_ver  (m_cx) ! Observation version
  !
  !
  integer(kind=entry_length) :: cxnext         ! Next free current index entry
  integer(kind=entry_length) :: knext          ! Current obs. for GET
  integer(kind=entry_length) :: nindex         ! Current index length
end module clic_index
!
module clic_find
  !
  ! Search flags
  logical                    :: last       ! Search observation last version
  logical                    :: fnum       ! Search by observation number 
  logical                    :: fver       ! Search by observation version
  logical                    :: fsourc     ! Search by source name
  logical                    :: fline      ! Search by line name
  logical                    :: fteles     ! Search by telescope name
  logical                    :: fdobs      ! Search by observation date
  logical                    :: fdred      ! Search by reduction date
  logical                    :: foff1      ! Search by lambda offset
  logical                    :: foff2      ! Search by beta offset
  logical                    :: fscan      ! Search by scan number
  logical                    :: fproc      ! Search by procedure type
  logical                    :: fexcl      ! Exclude procedure type
  logical                    :: fitype     ! Search by object type (O,P)
  logical                    :: fhoura     ! Search by hour angle
  logical                    :: fut        ! Search by UT time
  logical                    :: fproject   ! Search by project name
  logical                    :: fbpc       ! Search by passband cal status
  logical                    :: fic        ! Search by time cal status
  logical                    :: fpol       ! Search by polar type
  logical                    :: fmod       ! Search by correlator mode
  logical                    :: fload      ! Search by load type
  logical                    :: fskip      ! Skip the autocorrelations
  logical                    :: fcorr      ! Search by correlator
  !
  ! Procedures
  integer,parameter          :: m_proc=10      ! Max for procedures
  integer,parameter          :: m_excl=10      ! Idem for exclusions
  ! For command SET PROCEDURE / SET EXCLUDE
  integer*4                  :: nproc          ! Number of procedure
  integer*4                  :: ssproc(m_proc) ! Procedure id 
  integer*4                  :: nexcl          ! Number of procedure
  integer*4                  :: ssexcl(m_excl) ! Procedure id 
  ! For command FIND /PROCEDURE /EXCLUDE
  integer*4                  :: xnproc         ! Number of procedure
  integer*4                  :: xsproc(m_proc) ! Procedure id 
  integer*4                  :: xnexcl         ! Number of procedure
  integer*4                  :: xsexcl(m_excl) ! Procedure id 
  !
  ! Sources
  integer,parameter          :: m_sour=20      ! Max for procedures
  ! For command SET SOURCE
  integer*4                  :: nsour          ! Number of sources 
  integer*4                  :: sisour(m_sour) ! Source name length 
  character*12               :: sssour(m_sour) ! Source name 
  ! For command FIND /SOURCE
  integer*4                  :: xnsour         ! Number of sources 
  integer*4                  :: xisour(m_sour) ! Source name length 
  character*12               :: xssour(m_sour) ! Source name 
  !
  ! Observation date
  integer*4                  :: xdobs          ! Starting obs. date
  integer*4                  :: ydobs          ! Ending obs. date
  !
  ! Reduction date        
  integer*4                  :: xdred          ! Starting red. date
  integer*4                  :: ydred          ! Ending red. date
  !
  ! Observation number
  integer*4                  :: xnum           ! Starting obs. number
  integer*4                  :: ynum           ! Ending obs. number
  !
  ! Observation version (not implemented)
  integer*4                  :: xver           ! Starting obs. version
  integer*4                  :: yver           ! Ending obs. version
  !
  ! Hour angle
  real*4                     :: xhoura         ! Starting hour angle
  real*4                     :: yhoura         ! Ending hour angle
  !
  ! UT
  real*4                     :: xut            ! Starting UT
  real*4                     :: yut            ! Ending UT
  !
  ! Observation kind
  integer*4                  :: xkind          ! Starting kind
  integer*4                  :: ykind          ! Ending kind
  !
  ! Data quality
  integer*4                  :: xqual          ! Maximum data quality
  !
  ! Scan number
  integer,parameter          :: m_scan = 100    ! Maximum number of scan ranges
  ! For FIND /SCAN command
  integer*4                  :: xnscan          ! Actual number of scan ranges
  integer*4                  :: xscan(m_scan)   ! Starting scan number
  integer*4                  :: yscan(m_scan)   ! Ending scan number
  ! For SET SCAN command
  integer*4                  :: snscan          ! Actual number of scan ranges
  integer*4                  :: sscan1(m_scan)  ! Starting scan number
  integer*4                  :: sscan2(m_scan)  ! Ending scan number
  !
  ! Type
  integer*4                  :: xitype          ! Researched type (O/P/R)
  !
  ! Bandpass calibration status
  integer*4                  :: xbpc            ! BP calibration status
  !
  ! Instrumental calibration status
  integer*4                  :: xic             ! Instr. cal. status
  !
  ! Receiver band number
  integer*4                  :: xrecei          ! Receiver band number
  !
  ! Polarisation
  integer,parameter          :: xmpol = 17      ! Maximum number of pol states
  ! For FIND /POL command
  integer*4                  :: xnpol           ! Actual number of pol states
  integer*4                  :: xpol(xmpol)     ! Polarisation keyword index
  ! For SET FINDPOL command
  integer*4                  :: snpol           ! Actual number of pol states
  integer*4                  :: spol(xmpol)     ! Polarisation keyword index
  !
  ! Correlator mode (auto/cross)
  integer*4                  :: xmod            ! Correlator mode
  !
  ! Load type (HOT/COLD/SKY)
  integer*4                  :: xload           ! Load type
  !
  ! Position offsets
  real*4                     :: xoff1           ! starting lambda ofset
  real*4                     :: yoff1           ! ending lambda ofset
  real*4                     :: xoff2           ! starting beta ofset
  real*4                     :: yoff2           ! ending lambda ofset
  ! 
  ! Line name
  integer*4                  :: iline           ! Line name length
  character*12               :: xcline          ! Line name
  ! 
  ! Telescope name
  integer*4                  :: iteles          ! Telescope name length
  character*12               :: xctele          ! Telescope name
  ! 
  ! Project name
  integer*4                  :: iproject        ! Project name length
  character*8                :: xcproject       ! Project name
  !
  ! for SET SKIP ON|OFF
  integer*4                  :: iskip           ! Skip auto in corr
  !
  ! Correlator
  integer*4                  :: xcorr           ! Correlator number
end module clic_find

module clic_virtual
  use gildas_def
  use clic_index
  ! Headers
  logical,allocatable :: got_header(:)                        ! the header has been read
  integer(kind=address_length),allocatable :: v_header(:)     ! address of data header
  integer(kind=data_length),allocatable :: v_header_length(:) ! length of data header
  ! data
  logical,allocatable :: got_data(:)                          ! the data has been read
  integer(kind=address_length),allocatable :: v_data(:)       ! address of the data section
  integer(kind=data_length),allocatable ::   v_data_length(:) ! length of data section
  ! memory regions
  integer*4 :: m_region                 ! max number of regions
  parameter (m_region = 8)
  integer*4 :: n_regions =0             ! number of regions
  integer*4 :: current_region           ! current region
  integer(kind=address_length) :: region(m_region)  ! region addresses
  integer(kind=address_length) :: region_length(m_region)  ! region lengths
  integer(kind=address_length) :: next_offset    ! next offset in current region
end module clic_virtual

program classic_read
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use classic_api, no_interface=>classic_entry_data_read
  !---------------------------------------------------------------------
  ! Read a Class file. 3 modes:
  !  1) index only
  !  2) same + entry descriptor (i.e. no header, no data)
  !  3) same + header only
  !  4) same + data (i.e. all the entry)
  !---------------------------------------------------------------------
  logical :: error
  type(classic_file_t) :: file
  integer(kind=4), parameter :: file_lun=50  ! Arbitrary value
  integer(kind=entry_length) :: ientry
  type(classic_recordbuf_t) :: rbufind,rbufobs
  integer(kind=4), allocatable :: bufind(:)  ! Buffer for byte-swapping one index
  integer(kind=4), allocatable :: bufsec(:)  ! Buffer for byte-swapping one section
  integer(kind=4), allocatable :: bufdat(:)  ! Buffer for byte-swapping one section
  integer(kind=8) :: ind_rstart
  integer(kind=4) :: ind_wstart
  integer(kind=data_length) :: ldata
  type(classic_entrydesc_t) :: edesc
  integer(kind=4) :: isec,arg_count,mode
  type(cputime_t) :: time
  character(len=8) :: cmode
  integer(kind=8) :: nwords,nrec,pirec,porec
  !
  error = .false.
  !
  ! Command line arguments
  arg_count = sic_get_arg_count()
  if (arg_count.lt.2) then
    call classic_read_usage
    stop 1
  endif
  !
  call sic_get_arg(1,file%spec)
  !
  call sic_get_arg(2,cmode)
  read(cmode,*) mode
  if (mode.lt.1 .or. mode.gt.4) then
    write(*,'(A)')  'Mode must be between 1 and 4'
    stop 2
  endif
  !
  ! Initialize the Classic library
  call classic_init(error)
  if (error)  stop 3
  file%lun = file_lun
  file%nspec = len_trim(file%spec)
  file%update = .false.
  call classic_file_open(file,.false.,error)
  if (error)  stop 4
  !
  call classic_filedesc_open(file,error)
  if (error)  stop 5
  !
  call reallocate_recordbuf(rbufind,file%desc%reclen,error)
  if (error)  stop 6
  call reallocate_recordbuf(rbufobs,file%desc%reclen,error)
  if (error)  stop 7
  call reallocate_buffer(bufind,int(file%desc%lind,kind=8),error)
  if (error)  stop 8
  !
  nwords = 0
  nrec = 0
  pirec = 0  ! Previous index record
  porec = 0  ! Previous observation record
  call gag_cputime_init(time)
  do ientry=1,file%desc%xnext-1  ! Read all entries
    !
    ! Read the Entry Index
    call classic_entryindex_read(file,ientry,bufind,rbufind,error)
    if (error)  stop 9
    nwords = nwords + file%desc%lind
    if (rbufind%rstart+rbufind%roff.ne.pirec) then
      nrec = nrec+1
      pirec = rbufind%rstart+rbufind%roff
    endif
    !
    if (mode.eq.1)  cycle
    !
    call classic_read_buf2ind(bufind,ind_rstart,ind_wstart,file%conv)
    if (error)  stop 10
    !
    ! Set the working buffer
    call classic_recordbuf_open(file,ind_rstart,ind_wstart,rbufobs,error)
    if (error)  stop 11
    ! Read the Entry Descriptor
    call classic_entrydesc_read(file,rbufobs,edesc,error)
    if (error)  stop 12
    !
    nwords = nwords + entrydescv2_nw1+entrydescv2_nw2*edesc%nsec
    if (rbufobs%rstart+rbufobs%roff.ne.porec) then
      nrec = nrec+rbufobs%roff+1
      porec = rbufobs%rstart+rbufobs%roff
    endif
    !
    if (mode.eq.2)  cycle
    !
    do isec=1,edesc%nsec
      !
      call reallocate_buffer(bufsec,edesc%secleng(isec),error)
      if (error)  stop 13
      call classic_entry_section_read(edesc%seciden(isec),edesc%secleng(isec),  &
        bufsec,edesc,rbufobs,error)
      if (error)  stop 14
      !
      nwords = nwords + edesc%secleng(isec)
      if (rbufobs%rstart+rbufobs%roff.ne.porec) then
        nrec = nrec + (rbufobs%rstart+rbufobs%roff) - porec
        porec = rbufobs%rstart+rbufobs%roff
      endif
    enddo
    !
    if (mode.eq.3)  cycle
    !
    ! Also read the data
    ldata = edesc%ldata
    call reallocate_buffer(bufdat,ldata,error)
    if (error)  stop 15
    call classic_entry_data_read(bufdat,ldata,edesc,rbufobs,error)
    if (error)  stop 16
    !
    nwords = nwords + edesc%ldata
    if (rbufobs%rstart+rbufobs%roff.ne.porec) then
      nrec = nrec + (rbufobs%rstart+rbufobs%roff) - porec
      porec = rbufobs%rstart+rbufobs%roff
    endif
    !
  enddo
  !
  call gag_cputime_get(time)
  write(*,'(A,3(1X,F8.3))')  'System, user, elapsed: ',  &
    time%diff%system,time%diff%user,time%diff%elapsed
  write(*,'(A,2(1X,F8.2))')  'Gross and net rates [MB/sec]: ',  &
    nrec*file%desc%reclen/1024.d0/256.d0/time%diff%elapsed,  &
    nwords/1024.d0/256.d0/time%diff%elapsed
  !
  ! Cleaning
  call deallocate_recordbuf(rbufind,error)
  if (error)  stop 17
  call deallocate_recordbuf(rbufobs,error)
  if (error)  stop 18
  if (allocated(bufind)) deallocate(bufind)
  if (allocated(bufsec)) deallocate(bufsec)
  if (allocated(bufdat)) deallocate(bufdat)
  !
  call classic_file_close(file,error)
  if (error)  stop 19
  !
contains
  subroutine classic_read_usage
    write(*,'(A)')  'Usage:'
    write(*,'(A)')  '  classic-read file mode'
    write(*,'(A)')  ''
    write(*,'(A)')  '  Read (part of) the contents of any kind of Classic file'
    write(*,'(A)')  '  and return statistics.'
    write(*,'(A)')  ''
    write(*,'(A)')  '  Mode can be:'
    write(*,'(A)')  '  1: read the index for all entries,'
    write(*,'(A)')  '  2: same as 1 + entry descriptors'
    write(*,'(A)')  '  3: same as 2 + entry headers'
    write(*,'(A)')  '  4: same as 3 + entry data'
    write(*,'(A)')  ''
  end subroutine classic_read_usage
  !
  subroutine classic_read_buf2ind(buf,rec,word,conv)
    use gildas_def
    use gkernel_interfaces
    use classic_api
    !---------------------------------------------------------------------
    ! Copy the Entry Index into the given buffer, swap bytes if needed
    !---------------------------------------------------------------------
    integer(kind=4),          intent(in)  :: buf(*)
    integer(kind=8),          intent(out) :: rec
    integer(kind=4),          intent(out) :: word
    type(classic_fileconv_t), intent(in)  :: conv
    ! Local
    integer(kind=4) :: addr4
    !
    if (file%desc%version.eq.1) then
      call conv%read%i4(buf(1),addr4,1)  !   1: record
      rec = addr4
      word = 1
    else
      call conv%read%i8(buf(1),rec, 1)  ! 1-2: record
      call conv%read%i4(buf(3),word,1)  !   3: word
    endif
  end subroutine classic_read_buf2ind
  !
  subroutine reallocate_buffer(buf,l,error)
    integer(kind=4), allocatable   :: buf(:)
    integer(kind=8), intent(in)    :: l
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    !
    if (allocated(buf)) then
      if (size(buf).ge.l) then
        return
      else
        deallocate(buf)
      endif
    endif
    allocate(buf(l),stat=ier)
    if (failed_allocate('DUMP','buffer',ier,error))  return
    !
  end subroutine reallocate_buffer
  !
end program classic_read

function concom (xq,yq,xd,yd,zd,ndp,wk,iwk,loc)
  use gcont_interfaces, except_this=>concom
  use gcont_contour
  !---------------------------------------------------------------------
  ! @ private
  !	Interpolate the values at a given point.
  ! Arguments :
  !	XQ	R*4	X coordinate of point			Input
  !	YQ	R*4	Y coordinate of point			Input
  !	XD	R*4 (*)	Array of X coordinates of points	Input
  !	YD	R*4 (*)	Array of Y coordinates of points	Input
  !	ZD	R*4 (*)	Array of values				Input
  !	NDP	I	Number of data points			Input
  !	WK	R*4 (*)	Work space				Input
  !	IWK	I (*)	Pointer space				Input
  !	LOC	I	Position of point			Output
  !	CONCOM	R*4	Interpolated value			Output
  ! Subroutines :
  !	CONLOC
  !	CONCAL
  !---------------------------------------------------------------------
  real :: concom                    !
  real :: xq                        !
  real :: yq                        !
  real :: xd(1)                     !
  real :: yd(1)                     !
  real :: zd(1)                     !
  integer :: ndp                    !
  real :: wk(1)                     !
  integer :: iwk(1)                 !
  integer :: loc                    !
  ! Local
  !  Interpolate a given X,Y pair and return its location
  !
  real :: temp
  !
  ! Locate proper triangle
  call conloc(ndp,xd,yd,nt,iwk(jwipt),nl,iwk(jwipl),xq,yq,loc,iwk(jwiwl),wk)
  !
  !  Interpolate the location
  call concal(xd,yd,zd,nt,iwk(jwipt),nl,iwk(jwipl),wk(ipr),loc,xq,yq,temp,itpv)
  concom = temp
end function concom

program transpose
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS	Transpose a cube
  !     Uses the generic subroutine
  !     GDF_TRANSPOSE
  !     Memory usage can be controlled by logical name SPACE_GILDAS
  !     (on Fortran-90 at least, Fortran-77 version is memory only)
  !---------------------------------------------------------------------
  character(len=filename_length) :: namex,namey
  character(len=4) :: code
  logical :: error
  integer :: space_gildas,ier
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_char('ORDER$',code)
  call gildas_close
  !
  space_gildas = 256
  ier = sic_getlog('SPACE_GILDAS',space_gildas)
  error = .false.
  call gdf_transpose(namex,namey,code,space_gildas,error)
  if (error) call sysexi(fatale)
  call sysexi(1)
end program transpose

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_apodize_command(line,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_apodize_command
  use wifisyn_transform_types
  !----------------------------------------------------------------------
  ! Support routine for command
  !     APODIZE WIFI|VISI
  !       1 /DIRECT
  !       2 /INVERSE
  !       3 /UV
  !       4 /XY
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  type(action_t) :: do
  character(len=*), parameter :: rname='APODIZE/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_parse_transform(line,do,error)
  if (error) return
  call wifisyn_apodize_main(do,error)
  if (error) return
  !
end subroutine wifisyn_apodize_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_apodize_main(do,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_apodize_main
  use wifisyn_transform_types
  use wifisyn_sic_buffer
  use wifisyn_cube_buffer
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(action_t), intent(in)    :: do
  logical,        intent(inout) :: error
  !
  character(len=*), parameter :: rname='APODIZE/MAIN'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (do%cube.eq.code_cube_visi) then
     call wifisyn_message(seve%e,rname,'Not yet implemented')
     error = .true.
     return
  else if (do%cube.eq.code_cube_wifi) then
     if (do%space.eq.code_space_uv) then
        call wifisyn_apodize_wifi_uv(do%dire,progmap,wifi,error)
        if (error) return
     else if (do%space.eq.code_space_xy) then
        call wifisyn_apodize_wifi_xy(do%dire,progmap,wifi,error)
        if (error) return
     else
        call wifisyn_message(seve%e,rname,'Unknown plane')
        error = .true.
        return
     endif
  else
     call wifisyn_message(seve%e,rname,'Unknown cube type')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_apodize_main
!
subroutine wifisyn_apodize_wifi_uv(idir,map,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_apodize_wifi_uv
  use wifisyn_transform_types
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,             intent(in)    :: idir
  type(map_t), target, intent(in)    :: map
  type(wifi_t),        intent(inout) :: wifi
  logical,             intent(inout) :: error
  !
  integer :: ix,iy,iu,iv
  real(kind=4) :: vkernftval,uvkernftval
  type(kernel_1d_t), pointer :: ukern,vkern
  character(len=*), parameter :: rname='APODIZE/WIFI/UV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (wifi%uvkind) then
     call wifisyn_message(seve%e,rname,'WIFICUB UV space must be of type SKY => Use first FFT /INV')
     error = .true.
     return
  endif
  ukern => map%kern(1)%u
  vkern => map%kern(2)%u
  if (idir.eq.code_direct) then
     do iv=1,wifi%cub%nv
        vkernftval = vkern%ft%val(iv)
        do iu=1,wifi%cub%nu
           uvkernftval = vkernftval*ukern%ft%val(iu)
           do iy=1,wifi%cub%ny
              do ix=1,wifi%cub%nx
                 wifi%cub%val(:,ix,iy,iu,iv) = wifi%cub%val(:,ix,iy,iu,iv)*uvkernftval
              enddo ! ix
           enddo ! iy
        enddo ! iu
     enddo ! iv
  else if (idir.eq.code_inverse) then
     do iv=1,wifi%cub%nv
        vkernftval = vkern%ft%val(iv)
        do iu=1,wifi%cub%nu
           uvkernftval = vkernftval*ukern%ft%val(iu)
           do iy=1,wifi%cub%ny
              do ix=1,wifi%cub%nx
                 wifi%cub%val(:,ix,iy,iu,iv) = wifi%cub%val(:,ix,iy,iu,iv)/uvkernftval
              enddo ! ix
           enddo ! iy
        enddo ! iu
     enddo ! iv
  else
     call wifisyn_message(seve%e,rname,'Unknown direction')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_apodize_wifi_uv
!
subroutine wifisyn_apodize_wifi_xy(idir,map,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_apodize_wifi_xy
  use wifisyn_transform_types
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,             intent(in)    :: idir
  type(map_t), target, intent(in)    :: map
  type(wifi_t),        intent(inout) :: wifi
  logical,             intent(inout) :: error
  !
  integer :: ix,iy,iu,iv
  type(kernel_1d_t), pointer :: xkern,ykern
  character(len=*), parameter :: rname='APODIZE/WIFI/XY'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (wifi%xykind) then
     call wifisyn_message(seve%e,rname,'WIFICUB XY space must be of type UVP => Use first FFT /DIR')
     error = .true.
     return
  endif
  xkern => map%kern(1)%x
  ykern => map%kern(2)%x
  if (idir.eq.code_direct) then
     do iv=1,wifi%cub%nv
        do iu=1,wifi%cub%nu
           do iy=1,wifi%cub%ny
              do ix=1,wifi%cub%nx
                 wifi%cub%val(:,ix,iy,iu,iv) = wifi%cub%val(:,ix,iy,iu,iv)*(xkern%ft%val(ix)*ykern%ft%val(iy))
              enddo ! ix
           enddo ! iy
        enddo ! iu
     enddo ! iv
  else if (idir.eq.code_inverse) then
     do iv=1,wifi%cub%nv
        do iu=1,wifi%cub%nu
           do iy=1,wifi%cub%ny
              do ix=1,wifi%cub%nx
                 wifi%cub%val(:,ix,iy,iu,iv) = wifi%cub%val(:,ix,iy,iu,iv)/(xkern%ft%val(ix)*ykern%ft%val(iy))
              enddo ! ix
           enddo ! iy
        enddo ! iu
     enddo ! iv
  else
     call wifisyn_message(seve%e,rname,'Unknown direction')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_apodize_wifi_xy
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
! Simplified TABLE in LINE mode only, but with elaborate
! polarization capabilities.
!
subroutine sg_table(line,error)
  use image_def
  use gio_params
  use gkernel_interfaces
  use classic_api
  use clic_xypar
  use clic_index
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC  Internal routine.
  ! Prepare a UV Table (GILDAS Format)
  ! Command :
  !   TABLE file_name OLD|NEW
  ! 1   /ADD Item
  ! 2   /DROP n1 n2
  ! 3   /FFT  Fourier Transform resampling algorithm
  ! 4   /FREQUENCY name frest
  ! 5   /NOCHECK [SOURCE|POINTING|EPOCH|PHASE|SCAN]
  ! 6   /RESAMPLE nchan rchan res VELOCITY|FREQUENCY
  ! 7   /POLARIZATION SPLIT|AVERAGE|JOINT
  !
  ! Code currently handles dual-polarization in 3 different ways
  !   SPLIT:   A different visibility for each polarization
  !     AVERAGE: averaged polarizations before writing
  !     JOINT:   All channels Polar 1, then All channels polar 2 in visibility
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: mfvoc, mfilvoc, nkey, mshavoc, mchavoc, nk
  parameter (mfvoc=2, mfilvoc=2, mshavoc=4, mchavoc=5)
  logical :: lcheck(mchavoc)
  integer :: tnchan, ndrop(2), nvis, nfl, new_scans(m_cx), nchan
  integer :: new_dates(m_cx), n_new
  integer(kind=address_length) :: ipk, ipkl
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length) :: ldata_in, h_offset, l_offset
  integer :: ib, kr, ia, ja
  integer :: n_vis, isb, narg, is, nch, nd1, nd2
  integer :: ifirst, ilast, i
  integer :: n_visi(mnbb)
  integer :: isid_auto(mnbb)
  logical :: myend, ok, down_baseline, flagged, positions
  logical :: append, frequency, warning, warned
  logical :: check, scan, noloop, resample, fft, skip, initialized
  logical :: do_select
  real :: trchan, tfres, tvres, tvoff
  real :: width
  real(8) :: newfreq, tfoff, clight, ff, f1, fn
  character(len=256) :: chain,file
  character(len=12) :: key, fvoc(mfvoc), filvoc(mfilvoc)
  character(len=12) :: shavoc(mshavoc), chavoc(mchavoc)
  character(len=12) :: newname, shape, cpolar(3), ctele
  parameter (clight=299792.458d0)
  !
  ! test coordinates to specific precision ..
  real(8), parameter :: sec=pi/180D0/3600.D0
  ! Source, Pointing, Phase_Center, Epoch, Scan, Frequency
  real(8) :: tolerance(6) = (/0.d0 ,0.05d0*sec,0.005d0*sec,1d-5, 0.d0, 1.d-7/)
  logical :: setup=.true.
  character(len=*), parameter :: strnam = 'TOLE_SG%'
  !
  ! It is saved, but not the same as in command TABLE
  !
  integer, save :: file_uv_version
  !
  logical newuvt_format, treat_polar, add_scan, new_pola
  integer :: o_vis, ki
  integer :: ier, js, dvis, stokes, n_pol_scan, current_entry, iseq, pol_scan
  logical :: pol_flagged(mnbas)
  real, allocatable :: dima(:,:), temp(:,:)
  integer, allocatable :: pol_scan_list(:), pol_num_num(:),pol_num_list(:,:)
  integer :: npola, pola(4)
  integer :: extra(code_uvt_last)
  integer :: nextra, pcode(3), polcode
  real(8) :: xang(5)  ! Descriptive angles
  real(8) :: value(3) ! Dummy XYZ for telescope coordinates
  integer :: ipol, ibb
  complex :: est_i, prod
  !
  data shavoc/'TBOX','TPARABOLA','FBOX','FTRIANGLE'/
  data fvoc/'FREQUENCY','VELOCITY'/
  data filvoc/'NEW','OLD'/
  data chavoc/'SOURCE','POINTING','PHASE','EPOCH','SCAN'/
  data cpolar/'SPLIT','AVERAGE','JOINT'/
  data pcode /-1,0,1/
  !
  ! Only FILE should be saved ?
  save file
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  if (setup) then
    call sic_defstructure(strnam,.true.,error)
    call sic_def_dble(strnam//'POINT',tolerance(2),0,0,.false.,error)
    call sic_def_dble(strnam//'PHASE',tolerance(3),0,0,.false.,error)
    call sic_def_dble(strnam//'EPOCH',tolerance(4),0,0,.false.,error)
    call sic_def_dble(strnam//'FREQUENCY',tolerance(6),0,0,.false.,error)
    setup = .false.
  endif
  !
  if (.not.new_receivers) then
    call message(6,3, 'TABLE', 'This version does not process old data')
    error = .true.
    return
  endif
  !
  if (cont_select) then
    call message(6,3, 'TABLE', 'This version does not produce Continuum tables')
    error = .true.
    return
  endif
  !
  ! Verify if any input file
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  !
  ! /NOCHECK  (Option 5)
  lcheck(1:mchavoc) = .true.
  if (sic_present(5,0)) then
    do i=1,sic_narg(5)
      call clic_kw (line,5,i,key,nkey,chavoc,mchavoc,.false.,error,.true.)
      lcheck(nkey) = .false.
    enddo
  endif
  lcheck = lcheck.and.table_check
  check = any(lcheck)
  !
  scan = .true.
  resample = .false.
  !
  ! FFT Option (3)
  fft = sic_present(3,0)
  !
  ! /ADD Columns: Scan, Position, etc...
  if (sic_present(1,0)) then
    nextra = code_uvt_last
    call uvt_extra_cols(line,nextra, extra, error)
    if (error) return
    Print *,'extra ',extra(1:nextra)
  else
    nextra = 0
  endif
  !
  ! /POLARIZATION Key
  polcode = 0
  if (sic_present(7,0)) then
    call clic_kw (line,7,1,key,nkey,cpolar,4,.false.,error,.true.)
    if (error) return
    polcode = pcode(nkey)
    Print *,'Handling polarization ',polcode,key
    npola = 0
    pola = 0
  endif
  !
  ! /STOKES Key
  stokes =  code_stokes_none
  if (sic_present(8,0)) then
    call clic_kw (line,8,1,key,nkey,gio_stokes_names,21,.false.,error,.true.)
    if (error) return
    stokes = nkey-17
    Print *,'Handling stokes number',stokes,gio_stokes_names(stokes)
    if (stokes.gt.0) then
      allocate (pol_scan_list(nindex), stat=ier)
      allocate (pol_num_num(nindex), stat=ier)
      allocate (pol_num_list(nindex,16), stat=ier)
      n_pol_scan = 0
      pol_num_num = 0
      pol_num_list = 0
    endif
  endif
  !
  ! Decode Command Line ----------------------------------------------------
  ! Get file name
  if (sic_present(0,1)) then
    file = ' '  ! Reset file name to protect against errors
    ! New name
    call sic_ch (line,0,1,chain,narg,.true.,error)
    if (error) return
    call sic_parsef(chain,file,' ','.uvt')
    key = 'OLD'
    call clic_kw (line,0,2,key,nkey,filvoc,mfilvoc,.false.,error,.true.)
    if (error) return
    if (key.eq.'NEW') then
      append = .false.
      initialized = .false.
      ! A new table will be created in X image: initialize
      call gildas_null(xima, type= 'UVT')
      xima%gil%column_pointer = 0
      xima%gil%column_size = 0
      !
    elseif (key.eq.'OLD') then
      append = .true.
      call gildas_null(xima, type= 'UVT')
      ! this puts the table header in X and Y buffers.
      call newuvt_open(xima,file,file_uv_version,error)
      if (error) return
      ! Copy to Y buffer (Y buffer is used when reading scan headers and comparing to X)
      call gdf_copy_header(xima,yima,error)
      call newuvt_close (xima) ! Free the image slot, as newuvt_extend will be called
    endif
  elseif (len_trim(file).ne.0)  then
    ! No name, use current table
    append = .true.
    !! call gdf_copy_header(xima,yima, error) ! Just in case ?
    ! No "call gildas_null(xima)" here, since its header has to be
    ! remembered from one call to another.
  else
    ! No name, no current image
    call message(6,3, 'TABLE','No table to append to ...')
    error = .true.
    return
  endif
  !
  n_vis = 0
  warned = .false.
  !
  ! Target sampling : /RESAMPLE
  tnchan = 0
  trchan = 0
  tfres = 0.
  tvres = 0.
  tfoff = 0.
  tvoff = 0.
  shape = 'TPAR'
  width = 1.0
  !
  ! /RESAMPLE
  if (sic_present(6,0)) then
    if (append) then
      call message(8,2,'TABLE','OLD Table: /RESAMPLE ignored')
    else
      call sic_i4(line,6,1,tnchan,.true.,error)
      if (error) return
      call sic_r4(line,6,2,trchan,.false.,error)
      if (error) return
      key = 'FREQUENCY'
      call clic_kw(line,6,5,key,nkey,fvoc,mfvoc,.false.,error,.true.)
      if (error) return
      if (key.eq.'FREQUENCY') then
        call sic_r8(line,6,3,tfoff,.false.,error)
        call sic_r4(line,6,4,tfres,.false.,error)
      elseif (key.eq.'VELOCITY') then
        call sic_r4(line,6,3,tvoff,.false.,error)
        call sic_r4(line,6,4,tvres,.false.,error)
      endif
      if (error) return
      call clic_kw(line,6,6,shape,nk,shavoc,mshavoc,.false.,error,.true.)
      if (error) return
      call sic_r4(line,6,7,width,.false.,error)
      if (error) return
      resample = .true.
    endif
  endif
  !
  ! Drop end channels (2)
  ndrop(1) = 0
  ndrop(2) = 0
  if (sic_present(2,0)) then
    call sic_i4(line,2,2,ndrop(2),.true.,error)
    call sic_i4(line,2,1,ndrop(1),.false.,error)
    if (error) return
  endif
  !
  ! Frequency option (4)
  frequency = sic_present(4,0)
  if (frequency) then
    if (append) then
      call message(8,2,'TABLE','OLD Table: /FREQUENCY ignored')
      newfreq = 0
    else
      call sic_ch(line,4,1,newname,narg,.true.,error)
      call sic_r8(line,4,2,newfreq,.true.,error)
      if (error) return
    endif
  else
    newfreq = 0
  endif
  ! -------------------------------------------------------------------------
  ! First loop on current index to check consistency
  n_new = 0
  myend = .false.
  call get_first(.true.,error)
  if (error) return
  !
  ! Select ALL - default are spectral bands
  if (all_select) then
    lsubb_out = max(1,r_lband)
    do is=1, lsubb_out
      isubb_out(is) = is+mbands
    enddo
    do_select = .true.
  else
    do_select = .false.
  endif
  !
  ! No loop on records if spectral bands are to be written OR if scan average
  noloop = (isubb_out(1).gt.mbands) .or. (i_average.eq.1)
  if (.not.noloop) then
    ! No loop on records anymore
    call message(6,3, 'TABLE','Only SCAN average allowed')
    error = .true.
    return
  endif
  !
  ! cut_header updates the Y image in the loop hereafter: initialize it
  ! (only once, out of the loop for efficiency reasons)
  call gildas_null(yima, type = 'UVT')
  !
  do while (.not.myend)
    ! Reset the Frequency
    if (frequency) call vel_scale_3 (newname,newfreq)
    ! Cut_header update the YIMA buffer according to scan header,
    ! in order to compare it with the XIMA buffer corresponding to the current Table.
    call cut_header (ndrop,newfreq,positions,error)
    if (error) return
    !
    ! We use the first scan header to initialise the table header,
    ! if not in append mode.
    if (.not.append .and. .not.initialized) then
      ! Use the truncate scan header to initialize the Table header
      call gdf_copy_header(yima,xima,error)
      ! We use the line command optional parameters, if any.
      ! 7 daps + (real, imag, weight)*nchannels
      if (tnchan .ne. 0) then
        !!Print *,'Setting number of channels ',tnchan
        xima%gil%nchan = tnchan
        !
        if (trchan .ne. 0) then
          xima%gil%ref(1) = trchan
        else
          xima%gil%ref(1) = xima%gil%ref(1) + nint(0.5*(tnchan+1)-xima%gil%ref(1))
        endif
        if (tfres .ne. 0) then
          xima%gil%inc(1) = tfres*xima%gil%val(1)/xima%gil%freq
          xima%gil%vres = -tfres*clight/xima%gil%freq
          xima%gil%fres = tfres
        elseif (tvres .ne. 0) then
          xima%gil%vres = tvres
          xima%gil%inc(1) = -tvres*xima%gil%val(1)/clight
          xima%gil%fres = -tvres*xima%gil%freq/clight
        endif
        ! Make velocity or frequency  change possible :
        if (tvoff.ne.0) then
          xima%gil%voff = tvoff
        elseif (tfoff.ne.0) then
          tvoff = xima%gil%voff-tfoff/xima%gil%freq*clight
          xima%gil%voff = tvoff
        endif
        ! or even frequency offset ...
      else
        continue
        !! Print *,'TNCHAN is 0 ', xima%gil%nchan
      endif
      xima%gil%vtyp = r_typev ! Velocity type
      !
      ! Extra columns
      xima%gil%fcol = 8
      if (polcode.gt.0) then  ! JOINT mode
! Do not need column_pointer(code_uvt_stok) here. This is defined
! in the %gil%stokes array
        if (stokes.ne.code_stokes_none) then
          Print *,'JOINT: Handling 4 Polarization per visibility'
          xima%gil%nstokes = 4
          xima%gil%dim(1) = 3*xima%gil%nchan*4+7
          xima%gil%lcol = xima%gil%dim(1)
        else
          Print *,'JOINT: Handling 2 Polarization per visibility'
          xima%gil%nstokes = 2
          xima%gil%dim(1) = 3*xima%gil%nchan*2+7
          xima%gil%lcol = xima%gil%dim(1)
        endif
      else if (polcode.eq.0) then ! AVERAGE mode
        xima%gil%dim(1) = 3*xima%gil%nchan+7
        xima%gil%lcol = xima%gil%dim(1)
      else if (polcode.lt.0) then ! SPLIT mode
        Print *,'SPLIT: Handling changing Polarization state'
! Need column_pointer(code_uvt_stok) here to store the information.
        xima%gil%dim(1) = 3*xima%gil%nchan+7
        xima%gil%lcol = xima%gil%dim(1)
        xima%gil%dim(1) =  xima%gil%dim(1)+1
        xima%gil%column_pointer(code_uvt_stok) = xima%gil%dim(1)
      endif
      !
      ! Add the other extra columns, avoiding duplication
      do i=1,nextra
        if (xima%gil%column_pointer(extra(i)).eq.0) then
          xima%gil%dim(1) = xima%gil%dim(1)+1
          xima%gil%column_pointer(extra(i)) = xima%gil%dim(1)
          if (extra(i).eq.code_uvt_ra .or. extra(i).eq.code_uvt_dec) then
            xima%gil%dim(1) = xima%gil%dim(1)+1
            xima%gil%column_size(extra(i)) = 2
          endif
        endif
      enddo
      !
      ! Define the primary beam size
      xima%gil%majo = 56.0*(90.0e3/xima%gil%freq)
      print *,'I-CLIC,  Primary beam size ',xima%gil%majo,'"'
      xima%gil%majo = xima%gil%majo*pi/180.0/3600.0
      !
      if (r_teles(1:4).ne.'ALMA' .and. r_teles(1:3).ne.'SMA') then
        ctele = 'NOEMA'
      else
        ctele = r_teles
      endif
      call gdf_addteles(xima,'TELE',ctele,value,error)
      ! We could finalize the UV header here...
      ! call gdf_setuv(xima,error)
      !
      ok = .true.
      warning = .false.
      warned = .false.
      initialized = .true.
    else
      ! Append to an existing table (X) - check consistency
      warning = .false.
      call check_consistency (lcheck,xima,yima,tolerance,r_num,r_scan,error)
      nchan = max(xima%gil%nchan,int(abs(xima%gil%ref(1))))
      warning = warning   &
           .or. abs(yima%gil%freq-xima%gil%freq).gt.tolerance(6)*xima%gil%freq   &
           .or. abs(yima%gil%fres-xima%gil%fres)*nchan.gt.0.1   &
           .or. yima%gil%dim(1) .ne. xima%gil%dim(1)   &
           .or. abs(yima%gil%ref(1)-xima%gil%ref(1)).gt.tolerance(6)*xima%gil%freq/yima%gil%fres
      !
      ! Force resampling for multiple line subbands.
      warning = warning .or.   &
           (lsubb_out.gt.1) .and. (isubb_out(1).gt.mbands)
    endif
    !
    ! First check for inconsistent headers : This is an error.
    !
    if (check.and. .not.ok) then
      call check_consistency (lcheck,xima,yima,tolerance,r_num,r_scan,error)
      if (error) return
    endif
    !
    ! Warning if different frequency parameters, which must force resampling.
    !
    if (warning .and. .not.warned) then
      resample = .true.
      write (chain,'(A,I5,A,I5)')   &
           'Spectrum resampling is needed, obs. # ',r_num,   &
           ' Scan ',r_scan
      call message(6,2,'TABLE',chain)
      if (yima%gil%freq.ne. xima%gil%freq) then
        write(chain,*) 'Rest frequencies :',yima%gil%freq,   &
              xima%gil%freq
        call message(6,2,'TABLE',chain)
      endif
      if (yima%gil%voff.ne. xima%gil%voff) then
        write(chain,*) 'Velocities :',yima%gil%voff,   &
              xima%gil%voff
        call message(6,2,'TABLE',chain)
      endif
      if (yima%gil%fres .ne. xima%gil%fres) then
        write(chain,*) 'Frequency resolutions :',yima%gil%fres,   &
              xima%gil%fres
        call message(6,2,'TABLE',chain)
      endif
      if (yima%gil%ref(1) .ne. xima%gil%ref(1)) then
        write(chain,*) 'Reference channels :',yima%gil%ref(1),   &
              xima%gil%ref(1)
        call message(6,2,'TABLE',chain)
      endif
      warned = .true.
      !
      ! Test here the extra columns
    endif
    !
    ! Count polarizations status
    if (new_receivers) then
      do js=1, lsubb_out
        is = isubb_out(js)-mbands
        do ib=1, r_nbas
          new_pola = .true.
          if (npola.gt.0) then
            do i=1, npola
              if (r_code_stokes(ib,is).eq.pola(i)) &
                new_pola = .false.
            enddo
          endif
          if (new_pola) then
            npola = npola+1
            pola(npola) = r_code_stokes(ib,is)
          endif
        enddo 
      enddo
!      hpola = 0
!      lpola = 10 ! Arbitrary number > 4
!      do js = 1, lsubb_out
!        lpol = minval(r_lpolentry(1:r_nant,is))
!        hpol = maxval(r_lpolentry(1:r_nant,is))
!        lpola = min(lpola,lpol)
!        hpola = max(hpola,hpol)
!      enddo
!      npola = hpola-lpola+1
      if (polcode.lt.0) npola = 2
    else
      npola = 1
    endif
    !
    ! Check that data are complete for stokes parameter evaluation
    if (npola.eq.4) then
      add_scan = .true.
      if (n_pol_scan.gt.0) then
        do i=1,n_pol_scan
          if (pol_scan_list(i).eq.r_scan) then
            add_scan = .false.
            current_entry = i
          endif
        enddo
      endif
      if (add_scan) then
        n_pol_scan=n_pol_scan+1
        pol_scan_list(n_pol_scan) = r_scan
        current_entry = n_pol_scan
        n_vis = n_vis + r_nbas 
      endif
      if (pol_num_num(current_entry)+1.gt.16) then
        call message(6,4,'TABLE_STOKES',&
          'More than 16 sub-scans in polarisation scan')
        error = .true.
        return
      else
        pol_num_num(current_entry) = pol_num_num(current_entry)+1
        pol_num_list(current_entry, pol_num_num(current_entry)) = r_xnum
      endif
    else  
      !
      ! Not good here if polcode > 0
      if (polcode.lt.0) then
        n_vis = n_vis + r_nbas * npola
      else
        n_vis = n_vis + r_nbas 
      endif
    endif    
    !
    if (sic_ctrlc()) then
      error = .true.
      goto 200
    endif
    !
    ! Some extra counters
    n_new = n_new+1
    new_scans(n_new) = r_scan
    new_dates(n_new) = r_dobs
    call get_next(myend,error)
    if (error) return
  enddo
  !
  if (npola.eq.4) then
    do i=1,n_pol_scan
      print *," Polarisation scan ",pol_scan_list(i),", ", pol_num_num(i),&
              " sub-scans"
      print *,"       Sub-scan obs number:",pol_num_list(i,1:pol_num_num(i))
    enddo
  endif
  !
  n_visi(1:mnbb) = 1
  !
  ! Automatic sideband determination
  if (isideb_out.eq.5) then
    isid_auto(1:mnbb) = (3-r_isb)/2
  endif
  !
  ! Select all: refine the choice of subbands, depending on the
  ! table spectral parameters.
  if (all_select) then
    lsubb_out=0
    do is = 1, r_lband
      nch = r_lnch(is)
      nd1 = max(ndrop(1),nint(fdrop(1)*nch))
      nd2 = max(ndrop(2),nint(fdrop(2)*nch))
      ok = .false.
      if (abs(xima%gil%fres).ge.abs(r_lrfres(1,is))) then
        do isb=1,2
          ff = r_lrfoff(isb,is)-xima%gil%freq   &
               -(r_lvoff(isb,is)-xima%gil%voff)/299792.458d0*xima%gil%freq
          f1 = ff+(nd1+0.5-r_lrch(isb,is))*r_lrfres(isb,is)
          fn = ff+(nch-nd2+0.5-r_lrch(isb,is))*r_lrfres(isb,is)
          if (r_lrfres(isb,is)*xima%gil%fres.gt.0) then
             ifirst = nint(f1/xima%gil%fres+xima%gil%ref(1))
             ilast  = nint(fn/xima%gil%fres+xima%gil%ref(1))
          else
             ilast = nint(f1/xima%gil%fres+xima%gil%ref(1))
             ifirst  = nint(fn/xima%gil%fres+xima%gil%ref(1))
          endif
          ok = ok .or. ((ilast.ge.1) .and. (ifirst.le.xima%gil%nchan))
        enddo
      endif
      if (ok) then
        lsubb_out = lsubb_out + 1
        isubb_out(lsubb_out) = is+mbands
      endif
    enddo
    if (lsubb_out.gt.0) then
      write(chain,*) (csub(isubb_out(is))//' ',is=1,lsubb_out)
      call message(6,1,'TABLE','Using '//chain)
    else
      call message(8,3,'TABLE','No matching subband')
      error = .true.
      return
    endif
  endif
  !
  n_vis = n_vis * n_visi(1)
  call message(6,1,'TABLE', 'Table parameters for '//trim(file)//':')
  write(chain,'(A,A12,2(A,F12.3))')   &
       'X_LINE = ',xima%char%line ,' X_FREQ = ',xima%gil%freq,' X_VAL1 = ',xima%gil%val(1)
  call message(6,1,'TABLE',chain)
  write(chain,'(3(A,F12.3))')  'X_FRES = ',xima%gil%fres,   &
       ' X_VRES = ',xima%gil%vres,' X_VOFF = ',xima%gil%voff
  call message(6,1,'TABLE',chain)
  write(chain,'(A,I12,A,F12.4,A)')   &
       ' NCHAN = ',xima%gil%nchan ,' X_REF1 = ',xima%gil%ref(1)
  call message(6,1,'TABLE',chain)
  !
  ! Create new file or append to existing one
  if (append) then
    !!Print *,'Calling newuvt_extend'
    call gdf_setuv(xima,error) ! Test
    call newuvt_extend(xima,file,n_vis,n_new,new_dates,new_scans,   &
          error,lcheck(5))
    o_vis = xima%gil%nvisi
    !!Print *,'FCOL ', xima%gil%fcol , xima%gil%lcol
    !!Print *,' VTYPE ',xima%gil%vtyp
  else
    Print *,'Calling NEWUVT_INIT ',xima%gil%vtyp
    ! POLCODE indicates if %nstokes is > 1
    ! We also need an option to set the %freqs array here
    ! for further processing of non-contiguous frequency bands
    call newuvt_create(xima,file,n_vis,npola,polcode,error)
    !!Print *,' VTYPE ',xima%gil%vtyp
    o_vis = 0
    call gdf_copy_header(xima,yima, error)
  endif
  !
  ! Here, allocate the data space, only new region
  allocate (dima(xima%gil%dim(1),n_vis), stat=ier)
  dima = 0.0
  if (npola.eq.4) then
    allocate (temp(xima%gil%dim(1),r_nbas), stat=ier)
    temp = 0
    iseq = 0
    pol_flagged = .false.
  endif
  !
  ! Loop on current index to write the visibilities
  myend = .false.
  nfl = 0
  if (npola.eq.4) then
    call get_first(.true.,error)
  else
    call get_first(.false.,error)
  endif
  if (error) goto 98
  nvis = 0
  skip = .false.
  !
  do while (.not.myend)
    if (frequency) call vel_scale_3 (newname,newfreq)
    call get_data (ldata_in,data_in,error)
    if (error) goto 98
    if (npola.eq.4) then
      iseq = iseq+1
      if (iseq.eq.1) then
        pol_scan=r_scan
        pol_flagged = .false.
      endif
      if (r_scan.ne.pol_scan) then
        write(chain,'(a,i0,a,i0,a,i0,a)') 'Scan ',r_scan,' (num ',r_num,  &
                                ') does not match polarisation scan (',  &
                                pol_scan,')'
        call message(6,3,'READ_DATA',chain(1:lenc(chain)))
        error = .true.
        return
      endif
    endif
    !
    call check_cal(skip)
    if (skip) then
      skip = .false.
      goto 180
    endif
    if (do_pass) then
      call set_pass (r_nsb,r_nband,r_nbas+r_ntri,r_lntch, passc, passl, error)
      if (error) goto 98
    endif
    call set_corr(error)
    !
    kin = gag_pointer(data_in, memory)
    kr = 1 ! Only the Header information, Scan averaged
    call spectral_dump(kr,0,0)
    ipk = kin + h_offset(kr)
    call decode_header (memory(ipk))
    call set_scaling(error)
    if (error) return
    !
    ! Get the required angles
    call get_angles(xang)
    !
    flagged = .false.
    if (isideb_out.le.2) then
      isb = isideb_out
    elseif (isideb_out.ge.3) then
      ! find the good sideband if declared LINE DSB
      isb = nint(3-(xima%gil%freq-r_flo1)/r_fif1)/2
      isb = min(2,max(1,isb))
    endif
    !
    kr = 1 ! Always, Scan averaged
    do ib = 1, r_nbas
      if (down_baseline(ib)) then
        flagged = .true.
        pol_flagged(ib) = .true.
        cycle
      endif
      !
      ! Take corrected or uncorrected
      call spectral_dump(kr,0,ib)
      ipkl = kin + l_offset(kr)
      !
      ! Do it for the accepted SideBand
      dvis = 1
      if (npola.eq.4) then
        call add_visiline (xima,npola,temp(1,ib), r_nsb, r_nband, r_nbas, r_lntch,   &
            ib, isb, xima%gil%val(1), memory(ipkl), passl, ndrop, &
            width, shape, resample, fft, error, dvis, polcode, xang)
      else
        call add_visiline (xima,npola,dima(1,nvis+1), r_nsb, r_nband, r_nbas, r_lntch,   &
            ib, isb, xima%gil%val(1), memory(ipkl), passl, ndrop, &
            width, shape, resample, fft, error, dvis, polcode, xang)
      endif
      if (error) goto 98
      ! NVIS is used to increment
      if (npola.ne.4)  then
        nvis = nvis + dvis ! Number of added visibilities found by add_visiline
      else
        if (iseq.eq.16)  then
          dvis = 1
!          if (stokes.lt.0) then
            !
            ! Native Stokes: normalize daps
            do i=1, xima%gil%nlead
              temp(i,ib) = temp(i,ib)/16.
            enddo    
            do i=xima%gil%dim(1), xima%gil%dim(1)-xima%gil%ntrail,-1
              temp(i,ib) = temp(i,ib)/16.
            enddo
            !
            ! and visibilities
            do i=1, xima%gil%nchan*xima%gil%nstokes
              ki = xima%gil%fcol+(i-1)*xima%gil%natom
              if (temp(ki+2,ib).ne.0) then
                temp(ki,ib) = temp(ki,ib)/temp(ki+2,ib)
                temp(ki+1,ib) = temp(ki+1,ib)/temp(ki+2,ib)
              else
                temp(ki,ib) = 0. 
                temp(ki+1,ib) = 0. 
              endif
            enddo
            !
            ! Dterm correction if needed
            if (do_corrected.and.polcode.gt.0) then
            ia = r_iant(ib)
            ja = r_jant(ib)
            ibb = r_bb(isubb_out(1)-mbands)
            do i=1, xima%gil%nchan
              do ipol=1, xima%gil%nstokes
                ki=xima%gil%fcol + xima%gil%natom*(i-1)+xima%gil%natom*xima%gil%nchan*(ipol-1)  
                select case (ipol)
                !
                ! First estimate complex I
                ! I=(HH+VV)/2
                case(1)   ! vv
                  est_i = cmplx(temp(ki,ib),temp(ki+1,ib))      
                case(2)   ! hh
                  est_i = (est_i+ cmplx(temp(ki,ib),temp(ki+1,ib)))/2
                !
                ! Then correct cross-products from D-terms
                case(3)   ! vh
                  prod = (r_dx(ia,ibb)+conjg(r_dy(ja,ibb)))*est_i
                  temp(ki,ib) = temp(ki,ib)-real(prod)
                  temp(ki+1,ib) = temp(ki+1,ib)-aimag(prod)
                case(4)   ! hv
                  prod = (r_dy(ia,ibb)+conjg(r_dx(ja,ibb)))*est_i
                  temp(ki,ib) = temp(ki,ib)-real(prod)
                  temp(ki+1,ib) = temp(ki+1,ib)-aimag(prod)
                end select
              enddo
            enddo
            endif
!          else
            !
            ! Derived Stokes
!          endif
          if (.not.pol_flagged(ib)) then
            call r4tor4(temp(1,ib),dima(1,nvis+1),xima%gil%dim(1))
            nvis = nvis + dvis
          endif
          temp(:,ib) = 0
        endif
      endif
      if (dvis.eq.0) flagged = .true.
    enddo
    if (iseq.eq.16) iseq=0
    if (flagged) nfl = nfl + 1
    !
    ! End of scan
180 if (sic_ctrlc()) goto 98
    if (nfl.ne.0) then
      write(chain,'(I6,A)') nfl,' records flagged or unused'
      call message(4,2,'TABLE',chain(1:lenc(chain)))
      nfl = 0
    endif
    call get_next(myend,error)
    if (error) goto 98
  enddo
  !
  ! The table is now fnished
  write(chain,'(I6,A,I6,A)') nvis,   &
       ' visibilities written (out of ',n_vis,' possible)'
  call message(6,1,'TABLE', chain(1:lenc(chain)))
  call gdf_write_data (xima, dima, error)
  Print *,'Calling newuvt_cut ',nvis, nvis+o_vis, error
  Print *,' VTYPE ',xima%gil%vtyp
  nvis = nvis+o_vis
  if (.not.append) then
    ! Write a new file with current header version
    call gdf_get_uvt_version(file_uv_version)  ! Get code_version_uvt_current
  endif
  call newuvt_cut(xima,nvis,file_uv_version,error)
  Print *,'Trying to deallocate '
  Print *,' VTYPE ',xima%gil%vtyp
!
200 continue
  deallocate (dima, stat=ier)
  Print *,'Done deallocation '
  call newuvt_close(xima)
  Print *,' VTYPE ',xima%gil%vtyp
  return
  ! Error return
98 continue
  deallocate (dima, stat=ier)
  if (.not.append) then
    ! Write a new file with current header version
    call gdf_get_uvt_version(file_uv_version)  ! Get code_version_uvt_current
  endif
  call newuvt_cut(xima,nvis+o_vis,file_uv_version,error)
  call newuvt_close(xima)
  error = .true.
  return
end subroutine sg_table
!
subroutine uvt_extra_cols(line,nextra,extra,error)
  use gio_params
  use gkernel_interfaces
  use gbl_message
  !
  character(len=*), intent(in) :: line
  integer, intent(inout) :: nextra
  integer, intent(out) :: extra(*)
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='SG_TABLE /ADD'
  character(len=12) :: argum, kw
  character(len=12), save :: items(code_uvt_last)
  logical, save :: first = .true.
  integer :: i, narg, nkey
  !
  if (first) then
    call uv_column_names(items)
    first = .false.
  endif

  !
  if (sic_narg(1).gt.nextra) then
    call clic_message(seve%e,rname,'Too many extra items')
    error = .true.
    return
  endif
  extra(1:nextra) = 0
  !
  error = .false.
  do i=1,sic_narg(1)
    call sic_ke (line,1,i,argum,narg,.true.,error)
    if (error) return
    call sic_ambigs('TABLE /ADD',argum,kw,nkey,items, code_uvt_last, error)
    if (error) return
    nextra = i
    extra(nextra) = nkey
  enddo
end subroutine uvt_extra_cols
!
subroutine newuvt_create (xima,name,nvis,npola,polcode,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Creates the output table header in X (the significant header parameters
  ! have already been defned in clic_table)
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  integer, intent(in) :: npola          ! Number of polarisation
  integer, intent(in) :: polcode        ! Polarization treatment
  logical, intent(out) :: error         ! Error flag
  ! Local
  integer :: ier
  !
  ! Do not nullify X header here: it has already been partly computed before.
  !
  error = .false.
  !
  xima%file = name
  xima%gil%blan_words = def_blan_words
  xima%gil%extr_words = 0
  xima%gil%desc_words = def_desc_words
  xima%gil%posi_words = def_posi_words
  xima%gil%proj_words = def_proj_words
  xima%gil%spec_words = def_spec_words
  xima%gil%reso_words = def_reso_words
  xima%gil%uvda_words = 2 ! Not Zero is enough
  !
  xima%gil%eval = 0.
  xima%gil%dim(2) = nvis              ! +1 ! = add the dummy uv = 7.5 m point
  xima%gil%ref(2) = 0.
  xima%gil%inc(2) = 1.                  ! needed to avoid crash in GRAPHIC
  xima%gil%val(2) = 0.
  xima%gil%ndim = 2
  xima%char%unit = 'Jy'
  xima%char%syst = 'EQUATORIAL'
  xima%gil%ptyp = p_azimuthal
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%gil%faxi = 1
  xima%gil%form = fmt_r4
  !
  ! Here define the order of the basic "columns". The "extra"
  ! ones have been set outside already
  xima%gil%column_pointer(code_uvt_u) = 1
  xima%gil%column_pointer(code_uvt_v) = 2
  xima%gil%column_pointer(code_uvt_w) = 3
  xima%gil%column_pointer(code_uvt_date) = 4
  xima%gil%column_pointer(code_uvt_time) = 5
  xima%gil%column_pointer(code_uvt_anti) = 6
  xima%gil%column_pointer(code_uvt_antj) = 7
  where (xima%gil%column_pointer.ne.0)
    xima%gil%column_size = max(1,xima%gil%column_size)
  end where
  !
  xima%gil%natom = 3
  if (polcode.gt.0) then
    if (npola.eq.4) then
      xima%gil%nstokes = 4 
      xima%gil%order = code_chan_stok ! Channel / Stokes order
      allocate (xima%gil%stokes(xima%gil%nstokes), stat=ier)
      xima%gil%stokes(1) = code_stokes_vv
      xima%gil%stokes(2) = code_stokes_hh
      xima%gil%stokes(3) = code_stokes_vh
      xima%gil%stokes(4) = code_stokes_hv
    else
      xima%gil%nstokes = 2
      xima%gil%order = code_chan_stok ! Channel / Stokes order
      allocate (xima%gil%stokes(xima%gil%nstokes), stat=ier)
      xima%gil%stokes(1) = code_stokes_vv
      xima%gil%stokes(2) = code_stokes_hh
    endif
  else
    xima%gil%nstokes = 1
  endif
  xima%gil%nvisi = nvis
  xima%gil%type_gdf = code_gdf_uvt
  !
  call gdf_setuv (xima,error)
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2)
  print *, 'Into newuvt_init ',xima%gil%nvisi, xima%gil%nchan, xima%gil%dim(1:2)
  print *, 'Into newuvt_init UVDA_WORDS', xima%gil%uvda_words
  print *, 'Into newuvt_init Lead, Trail ', xima%gil%nlead, xima%gil%ntrail
  call gdf_create_image (xima,error)
  print *, 'Done newuvt_init '
end subroutine newuvt_create
!
subroutine check_consistency(lcheck,xima,yima,tolerance,r_num,r_scan,error)
  use gkernel_interfaces
  use image_def
  use classic_api
  include 'gbl_pi.inc'
  logical, intent(in) :: lcheck(4)
  real(8),  intent(in) :: tolerance(4)
  type(gildas), intent(in) :: xima
  type(gildas), intent(in) :: yima
  integer(kind=entry_length), intent(in) :: r_num
  integer, intent(in) :: r_scan
  logical, intent(out) :: error
  !
  character(len=72) :: chain
  character(len=13) :: xch, ych
  real(8), parameter :: sec=pi/180D0/3600.D0
  !
  error = .false.
  if (lcheck(1) .and. yima%char%name .ne. xima%char%name) then
     write(6,*) 'Source :',yima%char%name, xima%char%name
     error = .true.
  endif
  if (lcheck(2) .and. abs(yima%gil%ra-xima%gil%ra).gt.tolerance(2)) then
     call sexag(xch,xima%gil%ra,24)
     call sexag(ych,yima%gil%ra,24)
     write(6,*) 'Pointing RA :',ych,xch
     error = .true.
  endif
  if (lcheck(2) .and. abs(yima%gil%dec-xima%gil%dec).gt.tolerance(2)) then
     call sexag(xch,xima%gil%dec,360)
     call sexag(ych,yima%gil%dec,360)
     write(6,*) 'Pointing DEC :',ych,xch
     error = .true.
  endif
  if (lcheck(3) .and. abs(yima%gil%a0-xima%gil%a0).gt.tolerance(3)) then
     call sexag(xch,xima%gil%a0,24)
     call sexag(ych,yima%gil%a0,24)
     write(6,*) 'Phase A0 :',ych,xch,abs(xima%gil%a0-yima%gil%a0)/sec
     error = .true.
  endif
  if (lcheck(3) .and. abs(yima%gil%d0-xima%gil%d0).gt.tolerance(3)) then
     call sexag(xch,xima%gil%d0,360)
     call sexag(ych,yima%gil%d0,360)
     write(6,*) 'Phase D0 :',ych,xch,abs(xima%gil%d0-yima%gil%d0)/sec
     error = .true.
  endif
  if (lcheck(4) .and. abs(yima%gil%epoc-xima%gil%epoc).gt.tolerance(4)) then
     write(6,*) 'Epoch :',yima%gil%epoc, xima%gil%epoc
     error = .true.
  endif
  if (error) then
     write (chain,'(A,I5,A,I5)')   &
          'Inconsistent observation set, obs. # ',r_num,   &
          ' Scan ',r_scan
     call message(6,3,'TABLE',trim(chain))
  endif
end subroutine check_consistency
!
!      call add_visiline (xima,dima(1,nvis+1), r_nsb, r_nband, r_nbas, r_lntch,   &
!            ib, isb, xima%gil%val(1), &
!            memory(ipkc), memory(ipkl), passl, ndrop, &
!            width, shape, resample, fft, error, dvis, polcode, xang)
!
subroutine add_visiline (xima,npola,visi,qsb,qband,qbas,qntch,   &
    ibase,isb,frout,datal,passl,   &
    ndrop, width, shape, resample, fft, error, dvis, polcode, xang)
  use image_def
  use phys_const
  use classic_api
  !---------------------------------------------------------------------
  ! Called by SG_TABLE
  !
  ! creates one visibility point (i.e. one baseline and one band for a
  ! given scan), but many channels if in line mode.
  !
  ! Average Polarisations if needed, or split them, or concatenate them
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  !
  integer, intent(in) :: npola      ! Number of requested polarization
  real, intent(out) :: visi(xima%gil%dim(1),npola)      ! Current visibilities
  integer :: qsb                    !
  integer :: qband                  !
  integer :: qbas                   !
  integer :: qntch                  !
  integer :: ibase                  ! Baseline number
  integer :: isb                    ! Sideband indicator
  real(8) :: frout                  !
  complex :: datal(qntch,qsb,qbas)  !
  complex :: passl(qntch,qsb,qbas)  !
  integer :: ndrop(2)               !
  real(4) :: width                  !
  character(len=*) :: shape         !
  logical :: resample               !
  logical :: fft                    !
  logical :: error                  !
  integer, intent(out) :: dvis      ! Number of visibilities added
  integer, intent(in) :: polcode    ! Code to handle polarizations
  real(8), intent(in) :: xang(5)    ! HA, Dec, Az, El, Parallactic Angle
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  !
  logical, external :: down_channel
  ! Local
  !
  integer :: inbc                   ! Sub-band indicator...
  complex :: zin(mlch), zout(mlch), zscale
  real :: wout(mlch),toto
  real :: w, tsys(2), ri, afac, factor, save_res, rchan, fresf
  integer :: is, i, j, nw, k, ni, js, i1, i2, nd1, nd2, nch
  integer :: ifirst, ilast, nchan, ia, ja, npol, ipol
  integer :: ibdata
  logical :: good
  real(8) :: f1, fn, fo1, fon, ff
  character(len=128) :: chain
  !
  integer ki, ioff
  integer ipola, jpola, opola
  !------------------------------------------------------------------------
  ! Code:
  rchan = xima%gil%ref(1)
  nchan = xima%gil%nchan
  !
  ! Here are the possibilities
  ! 1) Only one polarization
  ! 2) Two polarization, averaged for unpolarized signal
  !     a) equal
  !     b) with Tsys weighting
  ! 3) Two polarization, stored independently sequentially,
  !    in two separate visibilities, each with its Polarization flag
  ! 4) Mixed polarization status, stored in the same visibility, with
  !   possible holes, as some polarization stages can be void.
  !
  ! 5) Non contiguous frequencies (not yet available)
  !
  ! Code is only for Case 1,2,3 in this example...
  !
  dvis = 0      ! Reset number of written visibilities
  !
  !
  ia = r_iant(ibase)
  ja = r_jant(ibase)
  !
  if (dobs_0 .eq.0) then
    dobs_0 = mod(dh_obs+32768,65536)-32768
  endif
  !
  ! Initialize
!  visi(:,1:npola) = 0.0
  !
  ! U,V,W scaling factor
  ! Actually should be computed from the Doppler factor and other stuff..
  factor = 1.0
  !
  visi(xima%gil%column_pointer(code_uvt_u),1) = dh_uvm(1,ibase)*factor &
                           + visi(xima%gil%column_pointer(code_uvt_u),1) 
  visi(xima%gil%column_pointer(code_uvt_v),1) = dh_uvm(2,ibase)*factor &
                           + visi(xima%gil%column_pointer(code_uvt_v),1) 
  !! visi(xima%gil%column_pointer(code_uvt_w)) = 0.0
  visi(xima%gil%column_pointer(code_uvt_date),1) = dh_obs &
                           + visi(xima%gil%column_pointer(code_uvt_date),1) 
  visi(xima%gil%column_pointer(code_uvt_time),1) = dh_utc &
                           + visi(xima%gil%column_pointer(code_uvt_time),1) 
  visi(xima%gil%column_pointer(code_uvt_anti),1) = r_iant(ibase) &
                           + visi(xima%gil%column_pointer(code_uvt_anti),1) 
  visi(xima%gil%column_pointer(code_uvt_antj),1) = r_jant(ibase) &
                           + visi(xima%gil%column_pointer(code_uvt_antj),1) 
  !
  ! Extra Columns if specified...
  if (xima%gil%column_pointer(code_uvt_scan).ne.0) visi(xima%gil%column_pointer(code_uvt_scan),1) = r_scan  &
                           + visi(xima%gil%column_pointer(code_uvt_scan),1) 
  !
  ! There is an ambiguity between Pointing and Phase center. What happens in a MODIFY POSITION ?...
  if (xima%gil%column_pointer(code_uvt_loff).ne.0) visi(xima%gil%column_pointer(code_uvt_loff),1) = dh_offlam(1)*rad_per_sec 
  if (xima%gil%column_pointer(code_uvt_moff).ne.0) visi(xima%gil%column_pointer(code_uvt_moff),1) = dh_offbet(1)*rad_per_sec 
  if (xima%gil%column_pointer(code_uvt_xoff).ne.0) visi(xima%gil%column_pointer(code_uvt_xoff),1) = dh_offlam(1)*rad_per_sec 
  if (xima%gil%column_pointer(code_uvt_yoff).ne.0) visi(xima%gil%column_pointer(code_uvt_yoff),1) = dh_offbet(1)*rad_per_sec 
  !
  ! Doppler shift (for the baselines length...)
  ! This ones needs to filled SG
  if (xima%gil%column_pointer(code_uvt_topo).ne.0) then
    ! Conventions:
    ! we follow "frame-radio-redshift" convention where
    !    Obs = Rest * (1 + Doppler - Velocity/C)
    ! which is followed in all our codes (ASTRJ, RDI, CLASS)
    ! as the conversion between frequency is defined in cut_header.f90
    !    yima%gil%freq = yima%gil%val(1) / (1 + r_doppl)
    !
    ! However, until further notice, Doppler computed by MODIFY Doppler
    ! has the wrong sign
    !    r_doppl = (corr + r_veloc)/c    ! in clic_modify.f90
    !
    ! We should only put the topocentric to system velocity correction,
    ! not the local source velocity in its system
    visi(xima%gil%column_pointer(code_uvt_topo),1) = r_doppl - r_veloc/clight_kms &
                           + visi(xima%gil%column_pointer(code_uvt_topo),1) 
  endif
  ! Elevation and other angles
  if (xima%gil%column_pointer(code_uvt_el).ne.0) visi(xima%gil%column_pointer(code_uvt_el),1) = xang(4) &
                           + visi(xima%gil%column_pointer(code_uvt_el),1) 
  if (xima%gil%column_pointer(code_uvt_ha).ne.0) visi(xima%gil%column_pointer(code_uvt_ha),1) = xang(1) &
                           + visi(xima%gil%column_pointer(code_uvt_ha),1) 
  if (xima%gil%column_pointer(code_uvt_para).ne.0) visi(xima%gil%column_pointer(code_uvt_para),1) = xang(5) &
                           + visi(xima%gil%column_pointer(code_uvt_para),1) 
  if (xima%gil%column_pointer(code_uvt_int).ne.0) visi(xima%gil%column_pointer(code_uvt_int),1) = dh_integ &
                           + visi(xima%gil%column_pointer(code_uvt_int),1) 
  !
  ! Set the polarisation  / stokes column if needed
  ! Polarization codes have been chosen to verify the following equation.
  !   if (xima%gil%column_pointer(code_uvt_stok).ne.0) visi(xima%gil%column_pointer(code_uvt_stok),1) = &
  !   & = - (10*code_polar(ia) + code_polar(ja))
  ! but "code_polar" is not defined simply.  See r_lpolentry array, and debug conventions here...
  ! For the time being, put HH first, VV next
  if (xima%gil%column_pointer(code_uvt_stok).ne.0) visi(xima%gil%column_pointer(code_uvt_stok),1) = code_stokes_hh
  !
  ! Other extra columns could be added here...
  !
  if (xima%gil%column_size(code_uvt_ra).eq.1) then
    visi(xima%gil%column_pointer(code_uvt_ra),1) = r_lam &
                           + visi(xima%gil%column_pointer(code_uvt_ra),1) 
  elseif (xima%gil%column_size(code_uvt_ra).eq.2) then
    call r8tor8(r_lam, visi(xima%gil%column_pointer(code_uvt_ra),1), 1)
  endif
  if (xima%gil%column_size(code_uvt_dec).eq.1) then
    visi(xima%gil%column_pointer(code_uvt_dec),1) = r_bet &
                           + visi(xima%gil%column_pointer(code_uvt_dec),1) 
  elseif (xima%gil%column_size(code_uvt_dec).eq.2) then
    call r8tor8(r_bet, visi(xima%gil%column_pointer(code_uvt_dec),1), 1)
  endif
  !
  ! Spectrum out
  nw = 0
  !
  ! Spectrum from Continuum backend
  if (isubb_out(1).le.mbands) then
    call message(8,3,'FILL_VISI', 'Invalid selection : Continuum backend')
    error = .true.
    return
  endif
  !
  ! Spectrum from Line backend
  save_res = xima%gil%fres
  !
  opola = 0
  if (npola.eq.4) then
    npol = 1        ! Loop on polarisation done at higher level
  else
    npol = npola
  endif
  !
  ! Loop on polarisations.
  ! We assume here the polarization index gives the value of the polarization state.
  do ipola = 1,npol
    !
    good = .false.
    !
    ! Loop over all subbands, and see if their global polarization state matches
    do js = 1, lsubb_out
      !
      ! The band name
      is = isubb_out(js)-mbands
      if (qsb.eq.1) then ! Check available sideband
        if (r_sband(1,is).ne.isb) then
          call message(6,3,'TABLE','Sideband unavailable')
          error = .true.
          return
        endif
        ibdata = 1
      else
        ibdata = isb
      endif
      !
      ! Is there any valid data ?
      if (is.gt.r_lband .or. down_channel(ibase,is+mbands)) cycle
      !
      ! Scaling and Tsys, possibly for dual-polarization receivers
      if ((npola.eq.4)) then
        select case (r_code_stokes(ibase,is))
        case (code_stokes_vv)
          ipol = 1  
        case (code_stokes_hh)
          ipol = 2  
        case (code_stokes_vh)
          ipol = 3  
        case (code_stokes_hv)
          ipol = 4  
        end select
      else
        if (ipola.ne.r_lpolentry(ia,is)) cycle
        ipol = ipola
      endif
      !
      inbc = r_bb(is)
      if (inbc.eq.0) cycle
      ! Compute scaling and Tsys if not already done
      if (ipola.ne.opola) then
        if (weight_tsys) then
          if (r_sb(is).eq.1) then
            tsys(1) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja)   &
                      /dh_integ
            tsys(2) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja)   &
                      /dh_integ
           else
             tsys(2) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja)   &
                      /dh_integ
             tsys(1) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja)   &
                      /dh_integ
           endif
          where (tsys.eq.0.) tsys = 300.0**2
        else
          tsys = 300.0**2
        endif
        afac = 1.
        zscale = 1.
        call scaling (is,isb,ibase,zscale,afac,error)
        opola = ipola
      endif
      !
      !
      fresf = r_lrfres(isb,is)/(1+r_doppl)
      nch = r_lnch(is)
      ! Drop edge channels and unnecessary channels.
      nd1 = max(ndrop(1),nint(fdrop(1)*nch))
      nd2 = max(ndrop(2),nint(fdrop(2)*nch))
      ff = r_lrfoff(isb,is)-xima%gil%freq   &
        -(r_lvoff(isb,is)-xima%gil%voff)/299792.458d0*xima%gil%freq
      f1 = ff+(nd1+0.5-r_lrch(isb,is))*fresf
      fn = ff+(nch-nd2+0.5-r_lrch(isb,is))*fresf
      !
      ! Here one would put code to handle the non-contiguous frequency
      ! channels -- a little tricky though, so only a special mode
      ! will be needed.  TO BE DONE
      !
      ! Find out edge channels. Guard band for FFT
      if (fft) then
        ioff = 1
      else
        ioff = 0
      endif
      if (r_lrfres(isb,is)*xima%gil%fres.gt.0) then
        ifirst = nint(f1/xima%gil%fres+rchan+ioff)
        ilast  = nint(fn/xima%gil%fres+rchan-ioff)
      else
        ilast = nint(f1/xima%gil%fres+rchan-ioff)
        ifirst  = nint(fn/xima%gil%fres+rchan+ioff)
      endif
      !
      ! sub-band does not intersect current frequency window
      if ((ilast.lt.1) .or. (ifirst.gt.nchan)) then
        write(chain,2000) csub(is+mbands), ifirst, ilast
        call message(6,3,'FILL_VISI',trim(chain))
        cycle
      endif
      !
      ! First & Last definition depend on resampling method
      if (fft) then
        ifirst = max(ifirst,1)
        ilast = min(ilast,nchan)
        fo1 = 1d-3*nint(1d3*(ifirst-0.5-rchan)*xima%gil%fres)
        fon = 1d-3*nint(1d3*(ilast+0.5-rchan)*xima%gil%fres)
        do while ((f1-fo1)*(f1-fon).gt.0 .and. nd1.lt.nch)
          f1 = f1+fresf
          nd1 = nd1 + 1
        enddo
        ni = nint((ilast-ifirst+1)*abs(xima%gil%fres/fresf))
      else
        ni = nch-nd1-nd2
        ifirst = max(ifirst,1)
        ilast = min(ilast,nchan)
        ilast = min(ilast,ifirst+ni-1)
      endif
      print *,"ifirst",ifirst,"ilast",ilast
      !
      ri = r_lrch(isb,is)-nd1
      do i=1, ni
        j = i+r_lich(is)+nd1
        if (ipol.ne.5) then
          zin(i) = datal(j,ibdata,ibase)  * zscale
        else
          zin(i) = (1.,0.)
          toto =real(i,kind=4)/real(ni,kind=4)
          zin(i) = toto*(1,0.)
        endif
        if (do_pass) then
          if (passl(j,isb,ibase).eq.blankc) then
            zin(i) = 0
          else
            zin(i) = zin(i)*passl(j,isb,ibase)
          endif
        endif
      enddo
      !
      ! Interpolate Gibbs-affected channels:
      if (ngibbs.gt.0 .and. abs(r_lfres(is)).gt.0.1) then
        i1 = nch/2-ngibbs - nd1
        i2 = nch/2+ngibbs+1 - nd1
        do i=i1+1,i2-1
          zin(i) = (zin(i1)*(i2-i)+zin(i2)*(i-i1))/(i2-i1)
        enddo
      endif
      !
      ! Resample with appropriate method
      if (resample) then
        ff = (r_lvoff(isb,is)-xima%gil%voff)/299792.458d0*xima%gil%freq
        if (ifirst.le.ilast-4 .and. fft) then
          call fft_interpolate (zout(ifirst),   &
            ilast-ifirst+1, xima%gil%fres,   &
            rchan-ifirst+1, xima%gil%freq+ff,   &
            width, shape,   &
            wout(ifirst), zin, ni, fresf,   &
            ri, r_lrfoff(isb,is),   &
            1., 'TPAR', error)
          if (error) cycle
        else
          call interpolate_2 (zout(ifirst),   &
            ilast-ifirst+1, xima%gil%fres,   &
            rchan-ifirst+1, xima%gil%freq+ff,   &
            wout(ifirst), zin, ni, fresf,   &
            ri, r_lrfoff(isb,is))
        endif
      else
        !
        ! Re-order in proper direction
        if (r_lrfres(isb,is)*xima%gil%fres.gt.0) then
          k = 1
          do i=ifirst, ilast
            zout(i) = zin(k)
            k = k+1
          enddo
        else
          k = 1
          do i=ilast, ifirst, -1
            zout(i) = zin(k)
            k = k+1
          enddo
        endif
        wout(ifirst:ilast) = 1.0
      endif
      !
      xima%gil%vres = -xima%gil%fres*299792.458d0/xima%gil%freq
      !
      ! Zout now contains the valid visibilities
      ! Wout have the valid relative weights, but not weighted
      ! time, Tsys or calibration factor yet
      !
      ! WEIGHT = 2 DELTA_NU DELTA_T / TSYS^2
      !
      if (weight_cal) then
        w = 2. / abs(zscale)**2 * abs(xima%gil%fres)
      else
        w = 2. * abs(xima%gil%fres)
      endif
      !
      ! zscale does not contains the Tsys and Integration time here ?
      w = w / tsys(isb) ! Tsys variable is actually Tsys^2/dh_integ
      !
      ! Now the weights are properly set
      wout = wout*w
      !
      ! Now fill the data by adding to the visibility
      !
      if (polcode.eq.0) then
        ! This code is for averaging the visibilities...
        do i=ifirst, ilast
          ki = xima%gil%fcol + xima%gil%natom*(i-1)
          visi(ki,1) =  visi(ki,1)+real(zout(i))*wout(i)
          visi(ki+1,1) = visi(ki+1,1)+aimag(zout(i))*wout(i)
          visi(ki+2,1) = visi(ki+2,1)+wout(i)
        enddo
      else if (polcode.lt.0) then
        !
        ! This code is for separating the visibilities...
        do i=ifirst, ilast
          ki = xima%gil%fcol + xima%gil%natom*(i-1)
          visi(ki,ipola) =  visi(ki,ipola)+real(zout(i))*wout(i)
          visi(ki+1,ipola) = visi(ki+1,ipola)+aimag(zout(i))*wout(i)
          visi(ki+2,ipola) = visi(ki+2,ipola)+wout(i)
        enddo
        !
        ! Put here the Polarization status ...
        ! Polarization codes have been chosen to verify the following equation.
        !   code_stoke = - (10*code_polar(ia) + code_polar(ja))
        ! but "code_polar" is not defined simply.
        ! See r_lpolentry array, and debug conventions here...
        !
        ! For the time being, by  construction, we have
        !  ipola = r_lpolentry(ia,is)
        ! so, by analogy
        jpola = r_lpolentry(ja,is)
        visi(xima%gil%column_pointer(code_uvt_stok),ipola) = - (10*ipola+jpola)
        !
      else if (polcode.gt.0) then
        ! This code is concatenating the visibilities with 2 Stokes...
        do i=ifirst, ilast
          ki = xima%gil%fcol + xima%gil%natom*(i-1) + xima%gil%natom*xima%gil%nchan*(ipol-1)
          visi(ki,1) =  visi(ki,1)+real(zout(i))*wout(i)
          visi(ki+1,1) = visi(ki+1,1)+aimag(zout(i))*wout(i)
          visi(ki+2,1) = visi(ki+2,1)+wout(i)
        enddo
      endif
      good = .true.
      !
    enddo ! Sub-bands
    !
    ! Increment if anything written
    if (good) then
      if (polcode.ge.0) then
        dvis = 1
      else
        dvis = dvis+1
      endif
    endif
    !
  enddo ! Polarisation
  !
  ! Renormalize ...
  !
!!  do j = 1,dvis
!!    do i = 1,xima%gil%nchan*xima%gil%nstokes
!!      ki = xima%gil%fcol + xima%gil%natom*(i-1)
!!      if (visi(ki+2,j).ne.0.0) then
!!        visi(ki,j) =  visi(ki,j)/visi(ki+2,j)
!!        visi(ki+1,j) = visi(ki+1,j)/visi(ki+2,j)
!!      else
!!        visi(ki,j) =  0.0
!!        visi(ki+1,j) = 0.0
!!      endif
!!    enddo
!!  enddo
  !
  ! Set header of all visibilities if needed
!!  do j = 2,dvis
!!    visi(1:xima%gil%fcol-1,j) = visi(1:xima%gil%fcol-1,1)
!!    do i = xima%gil%lcol+1,xima%gil%dim(1)
!!      if (xima%gil%column_pointer(code_uvt_stok).ne.i) then
!!        visi(i,j) = visi(i,1)
!!      else if (polcode.gt.0) then
!!        visi(i,j) = code_stokes_vv
!!      endif
!!    enddo
!!  enddo
  !
  ! Default weight...
  if (xima%gil%column_pointer(code_uvt_weig).ne.0) then
    do j = 1,dvis
      w = 0.0
      k = 0
      do i = 1,xima%gil%nchan*xima%gil%nstokes
        ki = xima%gil%fcol + xima%gil%natom*(i-1)
        w = w+visi(ki+2,j)
        k = k+1
      enddo
      w = w/k
      visi(xima%gil%column_pointer(code_uvt_weig),j) = w
    enddo
  endif
  !
  ! Final warning in case of rounding
  if (abs((save_res-xima%gil%fres)/xima%gil%fres).gt.1e-4) then
    write(chain,'(a,1pg13.6)')   &
      'Channel separation rounded to ',xima%gil%fres
    call message(4,1,'FILL_VISI',trim(chain))
  endif
  !
  return
2000 format('Subband ',a,' maps to output channels ',i9,' to ',i9)
end subroutine add_visiline
!
subroutine get_angles(x)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Return values of the descriptive angles
  !  Hour, Dec, Az, El, Parallactic
  !---------------------------------------------------------------------
  real(8), intent(out) :: x(5)
  ! Global
  include 'clic_parameter.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  real(8) :: psi,the,phi ! Euler angles
  real(8) :: x_2(3), v_2(3), n_4(3), n_2(3), den, p_2(3), s_2
  real(8) :: trfm_24(3,3), lat, ho(2)
  !
  ! Well, this is ONLY for PdB...  We need it for other observatories
  ! sdm_* code does this slightly differently.
  ! CLIC or RDI should do it more properly.
  parameter (lat=(44+38d0/60d0+2d0/3600d0)*pi/180d0)
  !
  ! dh_svec is the source vector in hour-angle, dec coordinates (4)
  ! n_4 is the normal to the source meridian plane
  ! TRFM_24 goes from (4) to (2)
  ! n_2 is the normal to the source meridian plane, in horiz coords.(2)
  ! x_2 is the source vector in in horiz coords.
  ! v_2 is the intersection of the vertical plane of the source and
  ! the plane of the sky
  ! p_2 is the vector product of v_2 and n_2
  ! s_2 is the scalar product of p_2 and x_2
  psi=pi/2                   ! 90 degrees
  the=pi/2-lat               ! 90 degrees minus latitude
  phi=-pi/2                  ! -90 degrees
  call eulmat (psi,the,phi,trfm_24)
  call matvec (dh_svec, trfm_24, x_2)
  call spher(x_2, ho)
  !
  ! Return all 5 angles
  ! Hour Angle
  if (dh_svec(1).ne.0) then
    x(1) = atan2(-dh_svec(2),dh_svec(1)) !! *12./pi
  else
    call message(6,3,'VALUE','Error in hour-angle')
    x(1) = blank4
  endif
  ! Declination
  if (abs(dh_svec(3)).le.1.) then
    x(1) = asin(dh_svec(3))  !! *180./pi
  else
    call message(6,3,'VALUE','Error in declination')
    x(1) = blank4
  endif
  ho(1) = mod(ho(1)+3d0*pi,2d0*pi)-pi
  x(3) = -ho(1) !! *180d0/pi  ! Azimuth
  ho(2) = mod(ho(2)+3d0*pi,2d0*pi)-pi
  x(4) = ho(2)  !! *180d0/pi   ! Elevation
  !
  den = sqrt(dh_svec(1)**2+dh_svec(2)**2)
  n_4(1) = -dh_svec(2)/den
  n_4(2) = dh_svec(1)/den
  n_4(3) = 0
  call matvec (n_4, trfm_24, n_2)
  den = sqrt(x_2(1)**2+x_2(2)**2)
  v_2(1) = x_2(1)*x_2(3) / den
  v_2(2) = x_2(2)*x_2(3) / den
  v_2(3) = -den
  p_2(1) = v_2(2)*n_2(3)-v_2(3)*n_2(2)
  p_2(2) = v_2(3)*n_2(1)-v_2(1)*n_2(3)
  p_2(3) = v_2(1)*n_2(2)-v_2(2)*n_2(1)
  s_2 = p_2(1)*x_2(1)+p_2(2)*x_2(1)+p_2(3)*x_2(3) 
  ! Parallactic Angle
  x(5) = -pi/2+sign(acos(v_2(1)*n_2(1)+v_2(2)*n_2(2)+v_2(3)*n_2(3)),s_2)
end subroutine get_angles
!
subroutine vel_scale_3 (name,freq)
  use classic_api
  !---------------------------------------------------------------------
  ! Updates frequencies in header according to last 'SET FREQUENCY' command
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name          !
  real(8), intent(in) :: freq                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! Local
  real(8) myfreq
  character(len=12) :: myname
  integer :: isb,isub
  !------------------------------------------------------------------------
  ! Code:
  ! Defaults from Input Header:
  if (name.eq.'*') then
    myname = r_line
  else
    myname = name
  endif
  if (freq.eq.0) then
    myfreq = r_restf
  else
    myfreq = freq
  endif
  ! Loop on sidebands
  do isb = 1, 2
    !
    ! Continuum
    r_crfoff(isb) = myfreq
    r_cnam(isb) = myname
    !
    ! Line
    do isub=1, r_lband
      r_lrfoff(isb,isub) = myfreq
      r_lnam(isb,isub) = myname
    enddo
  enddo
  !
  ! Reset velocity scale accordingly
  call vel_scale
end subroutine vel_scale_3
!

subroutine mingauss(npar,g,f,x,iflag,obs)
  use classfit_interfaces, except_this=>mingauss
  use class_types
  use gauss_parameter
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Function to be minimized in the gaussian fit. By using 3 hidden
  ! parameters, the method allows dependent and independent gaussians to
  ! be fitted.
  ! The computation is highly optimised, but take care of R*4 and
  ! R*8 values !... Basic parameters are Area, Position and Width.
  !----------------------------------------------------------------------
  integer(kind=4),   intent(in)  :: npar     ! Number of parameters
  real(kind=8),      intent(out) :: g(npar)  ! Array of derivatives, size 3+3*Nline (see below)
  real(kind=8),      intent(out) :: f        ! Function values
  real(kind=8),      intent(in)  :: x(npar)  ! Input parameter values, size 3+3*Nline (see midgauss)
  integer(kind=4),   intent(in)  :: iflag    ! Code operation
  type(observation), intent(in)  :: obs      !
  ! Local
  logical :: dograd, dobase
  integer(kind=4) :: i,k,kbas,krai,kline
  real(kind=4) :: tt,vv,dd,gt,gv,gd,ff
  real(kind=4) :: arg,seuil,ta,ybas,yrai,xvel
  real(kind=4), dimension(ngauspar*mgauslin) :: xg
  real(kind=4), dimension(mgauslin) :: argexp,xf,xt,xv,xd
  !
  ! Final computations
  if (iflag.eq.3) then
     ! Compute Sigma after Minimisation
     kbas=0
     ybas=0.
     krai=0
     yrai=0.
     seuil= sigbas/3.
     !
     do i=obs%cimin,obs%cimax
        if (wfit(i).ne.0) then 
           xvel = real(obs%datax(i),4)
           ta = progauss(obs,xvel,0,dobase)
           if (abs(ta).lt.seuil) then
              kbas=kbas+1
              ybas=ybas+obs%spectre(i)**2
           else
              krai=krai+1
              yrai=yrai+(ta-obs%spectre(i))**2
           endif
        endif
     enddo
     if (kbas.gt.5) then
        sigbas=sqrt(ybas/kbas)
     else
        sigbas=0.d0
     endif
     if (krai.ne.0) then
        sigrai=sqrt(yrai/krai)
     else
        sigrai=sigbas
     endif
     if (sigbas.eq.0) sigbas = sigrai
     return
  endif
  !
  dograd = iflag.eq.2
  !
  !	g1 derivee / aire
  !	g2 derivee / vlsr
  !	g3 derivee / delt
  !
  ! Compute gaussians
  f = 0.
  xg = 0.
  gt = 0.
  gv = 0.
  gd = 0.
  xt = 0.
  xv = 0.
  xd = 0.
  ! Retrieve Parameters for Major Variables
  tt = x(1)
  vv = x(2)
  dd = x(3)     
  ! Retrieve parameters for Secondary Variables
  kline = max(nline,1)
  do i=1,kline
     xt(i) = x(3*i+1) * tt
     xv(i) = x(3*i+2) + vv
     xd(i) = x(3*i+3) * dd
  enddo
  !
  do i=obs%cimin,obs%cimax
     if (wfit(i).gt.0) then 
        xvel = obs%datax(i)
        xf     = 0.
        argexp = 0.
        argexp(1:kline) = (xvel - xv(1:kline)) / xd(1:kline)
        where(argexp(1:kline).le.4.)
           xf(1:kline) = exp(-argexp(1:kline)**2)
        end where
        ff = sum(xf(1:kline)*xt(1:kline)/xd(1:kline))
        !
        ! Compute chi^2 (No ponderation, WFIT is ignored)
        ff =  (ff - obs%spectre(i))
        f = f + ff**2
        !
        ! Compute Gradients
        if (dograd) then
           ff = 2. * ff
           do k=1,kline
              if (xf(k).ne.0.) then
                 arg            = xf(k) * ff / xd(k)
                 xg(1+3*(k-1))  = xg(1+3*(k-1)) + arg
                 gt             = gt + arg*xt(k)
                 !
                 arg            = xt(k)*arg/xd(k)
                 xg(3+3*(k-1))  = xg(3+3*(k-1)) - arg
                 gd             = gd - arg*xd(k)
                 !
                 arg            = arg*argexp(k)*2.
                 xg(2+3*(k-1))  = xg(2+3*(k-1)) + arg
                 xg(3+3*(k-1))  = xg(3+3*(k-1)) + arg*argexp(k)
                 gv             = gv + arg
                 gd             = gd + arg*argexp(k)*xd(k)
              endif
           enddo
        endif
     endif
  enddo
  !
  ! Setup values and return
  g(1)=gt/tt
  g(2)=gv
  g(3)=gd/dd
  !
  do i=1,kline
     g(3*i+1) = xg(1+3*(i-1)) *tt
     g(3*i+2) = xg(2+3*(i-1))
     g(3*i+3) = xg(3+3*(i-1)) *dd
  enddo
  !
end subroutine mingauss

* DECK second.f
*      REAL             FUNCTION SECOND( )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*  Purpose
*  =======
*
*  SECOND returns the user time for a process in seconds.
*  This version gets the time from the system function ETIME.
*
* =====================================================================
*
*     .. Local Scalars ..
*      REAL               T1
*     ..
*     .. Local Arrays ..
*      REAL               TARRAY( 2 )
*     ..
*     .. External Functions ..
*      REAL               ETIME
*      EXTERNAL           ETIME
*     ..
*     .. Executable Statements ..
*
*      T1 = ETIME( TARRAY )
*      SECOND = TARRAY( 1 )
*      RETURN
*
*     End of SECOND
*
*      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gbl_message
  !---------------------------------------------------------------------
  ! @public
  ! Support for message printing to screen and message file.
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: message_length=512
  integer(kind=4), parameter :: filter_length=16    ! Filter string, e.g. "s=fewridtcu"
                                            ! There should be a link with nseve
  !
  ! Define severity type with codes in variables with same name
  type :: message_severity_t  ! Kind of message
    integer(kind=4) :: f      ! Fatal error
    integer(kind=4) :: e      ! Error
    integer(kind=4) :: w      ! Warning
    integer(kind=4) :: r      ! Result
    integer(kind=4) :: i      ! Information
    integer(kind=4) :: d      ! Debug
    integer(kind=4) :: t      ! Trace
    integer(kind=4) :: c      ! Command
    integer(kind=4) :: u      ! Unknown (reserved for error handling, should not be used)
  end type message_severity_t
  !
  ! Incarnate a severity structure:
  type(message_severity_t), parameter :: seve = message_severity_t(1,2,3,4,5,6,7,8,9)
  !
#ifdef WIN32
!MS$ATTRIBUTES DLLEXPORT :: seve
#endif /* WIN32 */
end module gbl_message
!
module gbl_ansicodes
  !---------------------------------------------------------------------
  ! @ public
  ! ANSI terminal control codes
  ! Contains only the most supported ones to colorize and emphasize
  !---------------------------------------------------------------------
  character(len=1), parameter :: c_esc = achar(27)
  character(len=2), parameter :: c_start = c_esc // '['
  character(len=1), parameter :: c_end = 'm'
  !
  character(len=5), parameter :: c_black = c_start//'30'//c_end
  character(len=5), parameter :: c_red = c_start//'31'//c_end
  character(len=5), parameter :: c_green = c_start//'32'//c_end
  character(len=5), parameter :: c_yellow = c_start//'33'//c_end
  character(len=5), parameter :: c_blue = c_start//'34'//c_end
  character(len=5), parameter :: c_magenta = c_start//'35'//c_end
  character(len=5), parameter :: c_cyan = c_start//'36'//c_end
  character(len=5), parameter :: c_white = c_start//'37'//c_end
  character(len=4), parameter :: c_clear = c_start // '0' // c_end
  character(len=4), parameter :: c_bold = c_start // '1' // c_end
  character(len=4), parameter :: c_under = c_start // '4' // c_end
  character(len=4), parameter :: c_reverse = c_start // '7' // c_end
  character(len=4), parameter :: c_blink = c_start // '5' // c_end
  !
  ! Experimental 8-bits colors (to be tested on several terminals)
  character(len=11), parameter :: c_orange = c_start//'38;5;208'//c_end
  !
end module gbl_ansicodes
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module sic_def
  use gildas_def
  !---------------------------------------------------------------------
  ! @public
  ! Useful constants that should have been in module for long
  ! We probably need to do something to merge this with gildas_def.f90...
  !---------------------------------------------------------------------
  character(len=1), parameter :: backslash = char(92)
  integer(kind=4),  parameter :: screen_line_length = 256
  !
end module sic_def
!
module gpack_def
  use sic_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @public
  ! Parameters and types used to define a package
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: gpack_max_count = 32    ! Max number of packages
  integer(kind=4), parameter :: gpack_name_length = 10  ! Max length of package name
  integer(kind=4), parameter :: gpack_ext_length = 16   ! Max length of file extensions
  integer(kind=4), parameter :: gpack_null_id = -1      ! Id of undefined packages
  integer(kind=4), parameter :: gpack_global_id = 0     ! Id of the 'global' pseudo-package
  character(len=gpack_name_length), parameter :: gpack_global_name = 'global'
  !
  ! Type providing all infos which define a package
  type gpack_info_t
     character(len=gpack_name_length)  :: name=''          ! Package name
     character(len=gpack_ext_length)   :: ext=''           ! Package extension
     character(len=gpack_ext_length)   :: pro_suffix=''    ! Suffix to add on standard procedure names (welcome, define)
     character(len=screen_line_length) :: authors=''
     character(len=filter_length)      :: toscreen=''
     character(len=filter_length)      :: tofile=''
     integer(kind=address_length)      :: depend(gpack_max_count) = 0
     integer(kind=address_length)      :: init=0            ! Build subroutine
     integer(kind=address_length)      :: exec_on_child=0   ! Hook to execute for each parent
     integer(kind=address_length)      :: on_exit=0         ! Test for exit subroutine
     integer(kind=address_length)      :: clean=0           ! Cleanup subroutine
  end type gpack_info_t
  !
  ! Package properties (with some internals) are summarized in this type:
  type gpack_prop_t
     type(gpack_info_t) :: info                            ! Package static info
     integer(kind=4)    :: id = 0                          ! Package id
     integer(kind=4)    :: depend_id(gpack_max_count) = 0  ! Package dependencies
     logical            :: init_done = .false.             ! Init done flag
  end type gpack_prop_t
  !
end module gpack_def
!
module gsys_types
  use gildas_def
  !
  ! Elemental type which describe the 3 kinds of times (private)
  type :: cputime_elem_t
    real(kind=8) :: elapsed = 0.d0
    real(kind=8) :: user = 0.d0
    real(kind=8) :: system = 0.d0
  end type cputime_elem_t
  !
  ! Type associated to the public subroutines (public)
  type :: cputime_t
    type(cputime_elem_t) :: refe  ! Reference times
    type(cputime_elem_t) :: curr  ! Current times since reference
    type(cputime_elem_t) :: diff  ! Difference since last measurement
  end type cputime_t
  !
  ! Timing type (public)
  type time_t
    type(cputime_t) :: cputime
    logical         :: cleverstart = .true.  ! Start timing with a few loops
    integer(kind=8) :: iloop       = 0       ! Current loop number
    integer(kind=8) :: nloop       = 0       ! Total number of loops
    integer(kind=4) :: nbin        = 10      ! Number of divisions in standard mode
    ! Interval between each message, in number of loops. Use a float value to
    ! avoid a remainder at the end. Printing routines perform its own nint().
    real(kind=8)    :: interval    = 0.d0    ! Actual interval in use
    real(kind=8)    :: interval0   = 0.d0    ! Natural interval in standard mode
    real(kind=8)    :: maxtime     = 10.d0   ! Threshold for total time
  end type time_t
  !
  ! Modified-file type (public)
  type mfile_t
    character(len=filename_length) :: file=''  ! File name
    ! Last modification time (to the file system granularity)
    integer(kind=8) :: mtime
    ! Last time a modification was proved (to the OS granularity)
    integer(kind=8) :: ptime
    ! Was the file modified before last evaluation?
    logical         :: modif
  end type mfile_t
  !
end module gsys_types
!
module gsys_variables
  !---------------------------------------------------------------------
  ! Global variables private to libgsys
  !---------------------------------------------------------------------
  logical :: controlc=.false.  ! ^C has been pressed
end module gsys_variables

program make_cube
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	Makes a filled cube from a possibly non-filled one,
  !	preserving sampling by duplicating pixels and then
  !	smoothing each plane using the CONJUGATE GRADIENT ALGORITHM :
  !	The smoothed image is the equilibrium state of a thin flexible plate
  !	constrained to pass near each height datum by a spring attached
  !	between it and the plate.
  !	the smoothing parameter p is the ratio :
  !	     p = ( plate stiffness) / ( springs stiffness)
  !	The convergence is obtained with about 10 iterations ...
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  integer :: i,j,n, niter, nexp, ier
  real :: p,valbi
  integer :: nx,ny,mx,my
  type(gildas) :: x,y
  real, allocatable, dimension(:,:) :: desc, grad, v, w, work
  !
  call gildas_open
  call gildas_real('P$',p,1)
  call gildas_inte('NITER$',niter,1)
  call gildas_inte('EXPANSION$',nexp,1)
  call gildas_char('IN$',namey)
  call gildas_char('OUT$',namex)
  call gildas_real('GUESS$',valbi,1)
  call gildas_close
  !
  if (nexp.lt.2. .or. nexp.gt.5) then
    write(6,*) 'E-MAKE_CUBE,  Invalid expansion ',nexp
    goto 100
  endif
  !
  ! Input file
  n = len_trim(namey)
  if (n.eq.0) goto 100
  call gildas_null(y)
  call gdf_read_gildas(y,namey(1:n),'.gdf', error, data=.false.)
  if (error) then
    write(6,*) 'F-MAKE_CUBE,  Cannot read input file'
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  !
  x%gil%dim(1) = nexp*y%gil%dim(1)
  x%gil%dim(2) = nexp*y%gil%dim(2)
  !
  ! Transform coordinates (1,1) ---> (1,1)
  x%gil%inc(1:2) = y%gil%inc(1:2)/nexp
  x%gil%ref(1:2) = 1.0d0
  x%gil%val(1:2) = (1.0d0-y%gil%ref(1:2))*y%gil%inc(1:2)+y%gil%val(1:2)
  !
  ! Create output image
  n = len_trim(namex)
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-MAKE_CUBE,  Cannot output image'
    goto 100
  endif
  !
  mx = y%gil%dim(1)
  my = y%gil%dim(2)
  nx = x%gil%dim(1)
  ny = x%gil%dim(2)
  allocate (work(mx,my), v(nx,ny), desc(nx,ny), grad(nx,ny), w(nx,ny), &
      & stat=ier)
  if (ier.ne.0) then
    call gagout('E-MAKE_CUBE,  Memory allocation error')
    goto 100
  endif
  !
  ! Now loop over planes
  do j = 1,x%gil%dim(4)
    x%trc(4) = j
    x%blc(4) = j
    do i = 1,x%gil%dim(3)
      x%trc(3) = i
      x%blc(3) = i
      !
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,y%r2d,error)
      if (error) goto 100
      !
      !
      ! Fill first work space
      call fill(mx,my,y%r2d,work,  &
     &        y%gil%bval,y%gil%eval,nexp,valbi,   &
     &        nx,ny,           &
     &        v,               & ! V
     &        x%r2d )            ! A
      !
      desc = 0
      grad = 0
      w = 0
      !
      call dgsm002(v,   &    ! V
     &        nx,ny,    &
     &        x%r2d,    &    ! A
     &        desc, grad, w,  &
     &        p,niter,y%gil%bval,y%gil%eval)
      call gdf_write_data(x, x%r2d, error)
    enddo
  enddo
  !
  call gagout('S-MAKE_CUBE,  Successful completion')
  call sysexi(1)
100 call sysexi (fatale)
end program make_cube
!
subroutine fill (nx,ny,in,work,bval,eval,nexp,valbi,   &
     &    mx,my,v,a)
  integer :: nx                     !
  integer :: ny                     !
  real :: in(nx,ny)                 !
  real :: work(nx,ny)               !
  real :: bval                      !
  real :: eval                      !
  integer :: nexp                   !
  real :: valbi                     !
  integer :: mx                     !
  integer :: my                     !
  real :: v(mx,my)                  !
  real :: a(mx,my)                  !
  ! Local
  integer :: i,j,k,ip,im,jp,jm,ii,jj,jj0
  real :: w,z,good
  !
  ! First, fill in work array, trying to fill small gaps by crude interpolation
  do j = 1,ny
    do i = 1,nx
      if (abs(in(i,j)-bval).gt.eval) then
        work(i,j) = in(i,j)
      else
        ip = max(i-1,1)
        im = min(i+1,nx)
        jp = max(j-1,1)
        jm = min(j+1,ny)
        w = 0.0
        z = 0.0
        if (abs(in(ip,j)-bval).gt.eval) then
          z = z+in(ip,j)
          w = w+1.0
        endif
        if (abs(in(im,j)-bval).gt.eval) then
          z = z+in(im,j)
          w = w+1.0
        endif
        if (abs(in(i,jp)-bval).gt.eval) then
          z = z+in(i,jp)
          w = w+1.0
        endif
        if (abs(in(i,jm)-bval).gt.eval) then
          z = z+in(i,jm)
          w = w+1.0
        endif
        if (w.gt.0) then
          work(i,j) = z/w
        else
          work(i,j) = bval
        endif
      endif
    enddo
  enddo
  !
  ! Now fill guess and Vput arrays from work array
  good = valbi
  jj = 0
  do j=1,ny
    jj = jj+1
    ii = 0
    do i=1,nx
      ii = ii+1
      v(ii,jj) = in(i,j)
      a(ii,jj) = work(i,j)
      if (abs(a(ii,jj)-bval).gt.eval) then
        good = a(ii,jj)
      endif
      do k = 2,nexp
        ii = ii+1
        v(ii,jj) = bval
        a(ii,jj) = good
      enddo
    enddo
    jj0 = jj
    do k =2,nexp
      jj = jj+1
      do ii=1,mx
        v(ii,jj) = bval
        a(ii,jj) = a(ii,jj0)
      enddo
    enddo
  enddo
end subroutine fill
!
subroutine dgsm002(v,mi,mj,a,desc,grad,w,p,itermax,bval,eval)
  !---------------------------------------------------------------------
  ! D. Girard  smoothing technique
  !---------------------------------------------------------------------
  real*4 :: v(*)                    !
  integer :: mi                     !
  integer :: mj                     !
  real*4 :: a(*)                    !
  real*4 :: desc(*)                 !
  real*4 :: grad(*)                 !
  real*4 :: w(*)                    !
  real :: p                         !
  integer :: itermax                !
  real :: bval                      !
  real :: eval                      !
  ! Global
  real*4 :: dot
  ! Local
  ! Resolution iterative par gradient conjugue
  !
  real*4 :: vij,norm2grad,norm2grad_1,beta,lambda
  integer :: i,n,iter
  !
  if (itermax.le.0) return
  n = mi*mj
  !
  ! Gradient
  call prodtd(v,mi,mj,p,a,grad,bval,eval)
  do i=1,n
    vij = v(i)
    if (abs(vij-bval).gt.eval) then
      grad(i)=grad(i)-vij
    endif
  enddo
  norm2grad = dot (grad,grad,n)
  !
  call prodtd(v,mi,mj,p,grad,w,bval,eval)
  lambda = norm2grad / dot(grad,w,n)
  !
  do i=1,n
    desc(i) = - grad(i)
  enddo
  do i=1,n
    a(i) = a(i) - lambda * grad(i)
  enddo
  norm2grad_1 = norm2grad
  do i=1,n
    grad(i)= grad(i) - lambda*w(i)
  enddo
  !
  ! Iterations
  do iter = 2, itermax
    norm2grad = dot(grad,grad,n)
    beta = norm2grad/norm2grad_1
    do i=1,n
      desc(i) = -grad(i) + beta * desc(i)
    enddo
    call prodtd(v,mi,mj,p,desc,w,bval,eval)
    lambda = norm2grad / dot(desc,w,n)
    do i=1,n
      a(i) = a(i) + lambda * desc(i)
    enddo
    norm2grad_1 = norm2grad
    do i=1,n
      grad(i) = grad(i) + lambda * w(i)
    enddo
  enddo
end subroutine dgsm002
!
subroutine prodtd(v,mi,mj,p,z,s,bval,eval)
  integer :: mi                     !
  integer :: mj                     !
  real*4 :: v(mi,mj)                !
  real*4 :: p                       !
  real*4 :: z(mi,mj)                !
  real*4 :: s(mi,mj)                !
  real*4 :: bval                    !
  real*4 :: eval                    !
  ! Local
  integer :: i,j
  real*4 :: w
  do j=1,mj
    do i=1,mi
      if (abs(v(i,j)-bval).gt.eval) then
        s(i,j) = z(i,j)
      else
        s(i,j) = 0
      endif
    enddo
  enddo
  do j=2,mj-1
    do i=2,mi-1
      w = p*(2.0*z(i,j)-z(i-1,j)-z(i+1,j))
      s(i,j)= s(i,j) +2.0*w
      s(i-1,j)=s(i-1,j) - w
      s(i+1,j) = s(i+1,j) -w
      w = p*(2.0*z(i,j)-z(i,j+1)-z(i,j-1))
      s(i,j)= s(i,j) +2.0*w
      s(i,j-1)=s(i,j-1) - w
      s(i,j+1) = s(i,j+1) -w
      w = 0.5*p*(z(i+1,j+1)+z(i-1,j-1)-z(i+1,j-1)-z(i-1,j+1))/4.0
      s(i+1,j+1)= s(i+1,j+1) +w
      s(i-1,j-1)= s(i-1,j-1) +w
      s(i+1,j-1)= s(i+1,j-1) -w
      s(i-1,j+1)= s(i-1,j+1) -w
    enddo
  enddo
end subroutine prodtd
!
function dot (z,s,n)
  real*4 :: dot                     !
  real*4 :: z(*)                    !
  real*4 :: s(*)                    !
  integer :: n                      !
  ! Local
  integer :: i
  real(8) :: ddot
  ddot=0.0
  do i=1,n
    ddot = ddot + s(i)*z(i)
  enddo
  dot = ddot
end function dot

subroutine amtinv(cmat,npar)
  !---------------------------------------------------------------------
  ! POINT
  ! 	Matrix inversion through Gauss maximum pivot
  !	Dimensionned for size MVAR, MVAR
  ! J.Cernicharo, S.Guilloteau
  !---------------------------------------------------------------------
  ! Global
  include 'size.inc'
  !
  real*8 :: cmat(mvar,mvar)         !
  integer :: npar                   !
  ! Local
  real*8 :: amat(mvar,mvar+1),resol(mvar),amax
  integer :: j,l
  !
  if (npar.eq.1) then
    cmat(1,1)=1./cmat(1,1)
    return
  endif
  amax=-1.0d10
  do j=1,npar
    do l=1,npar
      amax = max(cmat(j,l),amax)
    enddo
  enddo
  do j=1,npar
    do l=1,npar
      amat(j,l)=cmat(j,l)/amax
    enddo
  enddo
  do j=1,npar+1
    do l=1,npar
      amat(l,npar+1)=0.0d0
    enddo
    amat(j,npar+1)=1.0d0
    call gauss(amat,resol,npar)
    do l=1,npar
      cmat(l,j)=resol(l)/amax
    enddo
  enddo
end

subroutine pico_emir(line,error)
  use gbl_message
  use gildas_def
  use gkernel_interfaces
  use astro_interfaces, except_this=>pico_emir
  use astro_types
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! EMIR command to define and visualize EMIR coverage
  ! EMIR F1 SB1 F2 SB2 /CATALOG /zoom
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='EMIR'
  integer(kind=4),parameter :: optzoom=1 ! option /ZOOM
  integer(kind=4),parameter :: optpagewidth=2 ! option /PAGEWIDTH
  integer(kind=4),parameter :: optinfo=3 ! option /INFO
  integer(kind=4) :: lpar,izoom,nzmode,it
  integer(kind=4), parameter :: m_zmodes=2
  character(len=20) ::  zmodes(m_zmodes),zmode
  logical :: noarg
  real(kind=8) :: fcomm
  data zmodes/'ID','BOTH'/
  !
  error = .false.
  !
  if (obsname.ne.'PICOVELETA'.and.obsname.ne.'VELETA') then
      call astro_message(seve%e,rname,'Inconsistency between Receiver Name and Observatory')
      error = .true.
      return
  endif
  !
  !Define receiver parameters
  call astro_def_receiver(rname,'EMIR',emir%rec%desc,error)
  if (error) return
  !Define emir switchbox parameters
  call rec_define_emir_switchbox(emir%switch,error)
  if (error) return
  !
  emir%rec%desc%redshift=.true.
  call astro_def_recsource(rname,emir%rec%desc,emir%rec%source,error)
  if (error) return
  !
  !Print Receiver info in the terminal
  if (sic_present(optinfo,0)) then
    call astro_receiver_info(emir%rec%desc,rname,error)
    if (error) return
  endif
  !Decoding Line Command
  ! First tuning
  zmode='ID'
  izoom=0
  emir%comm%n_tunings = 0
  if (error) return
  if (sic_present(0,1)) then
    noarg = .false.
    call pico_reset_emir(emir,error)
    emir%comm%n_tunings = 1
    call sic_r8(line,0,1,fcomm,.true.,error)
    if (error) return
    call rec_inputtorest(rname,fcomm,freq_axis%main,emir%rec%source,emir%comm%frest(1),error)
    if (error) return
    call sic_ch(line,0,2,emir%comm%code(1),lpar,.true.,error)
    if (error) return
    ! Second tuning
    emir%comm%frest(2) = 0
    emir%comm%code(2) = ''
    if (sic_present(0,3)) then
      ! second tuning
      emir%comm%n_tunings = 2
      call sic_r8(line,0,3,fcomm,.true.,error)
      if (error) return
      call rec_inputtorest(rname,fcomm,freq_axis%main,emir%rec%source,emir%comm%frest(2),error)
      if (error) return
      call sic_ch(line,0,4,emir%comm%code(2),lpar,.true.,error)
      if (error) return
    endif
  else ! case without argument
    noarg=.true.
    call astro_message(seve%i,rname,'Showing the coverage of EMIR bands')
  endif
  ! Options
  ! Zoom parameter
  if (sic_present(optzoom,0)) then
    if (sic_present(optzoom,1)) then
      emir%comm%zoommode = 'NULL'
      call sic_ke (line,optzoom,1,emir%comm%zoommode,lpar,.false.,error)
      if (error) return
      call sic_ambigs_sub(rname,trim(emir%comm%zoommode),zmode,nzmode,zmodes,m_zmodes,error)
      if (error) return
      if (nzmode.eq.0) then !means that keyword was not recognized
        if (sic_present(optzoom,2)) then
          zmode='FREQ'
          call sic_r8(line,optzoom,1,fcomm,.true.,error)
          if (error) return
          fcomm=fcomm*mhzperghz
          call rec_inputtorest(rname,fcomm,freq_axis%main,emir%rec%source,emir%comm%fz1,error)
          if (error) return
          call sic_r8(line,optzoom,2,fcomm,.true.,error)
          if (error) return
          fcomm=fcomm*mhzperghz
          call rec_inputtorest(rname,fcomm,freq_axis%main,emir%rec%source,emir%comm%fz2,error)
          if (error) return
        else
          if (emir%comm%n_tunings.eq.0) then
            call astro_message(seve%e,rname,'Try to tune on a not tune band')
            error = .true.
            return
          endif
          zmode='SINGLE'
          call sic_i0(line,optzoom,1,izoom,.true.,error)
          if (error) return
        endif
      endif
    else
      if (emir%comm%n_tunings.eq.1) then
        izoom = 1
        zmode='SINGLE'
      else if (emir%comm%n_tunings.eq.2) then
        izoom = 0
        zmode='BOTH'
      else
        call astro_message(seve%e,rname,'/ZOOM option without argument is ambiguous in this case')
        error = .true.
        return
      endif
    endif
  endif
  ! /pagewidth option
  if (sic_present(optpagewidth,0)) then
    emir%comm%fixed_scale = .false.
  else
    emir%comm%fixed_scale = .true.
  endif
  !
  !Prepare for the plot
  call pico_emir_setup(emir,error)
  if (error) return
  !
  if (zmode.eq.'ID') then
    call rec_plot_mbands(emir%rec%desc,emir%rec%source, &
                        molecules,emir%comm%fixed_scale,cplot,freq_axis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        molecules,cplot,freq_axis,error)
        if (error) return
      enddo
    endif
  else if (zmode.eq.'BOTH') then
    if (emir%rec%n_tunings.ne.2) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_nbands(emir%rec,molecules,emir%comm%fixed_scale,cplot,freq_axis,error)
    if (error) return
  else if (zmode.eq.'SINGLE') then
    if (izoom.le.0.or.izoom.gt.emir%comm%n_tunings.or.emir%comm%n_tunings.eq.0) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_sidebands(emir%rec%desc,emir%rec%source,emir%rec%tune(izoom),cplot,molecules,freq_axis,error)
    if (error) return
  else if (zmode.eq.'FREQ') then
    call rec_zoom(molecules,emir%comm%fz1,emir%comm%fz2, &
                  emir%rec%desc,emir%rec%source,cplot,freq_axis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        molecules,cplot,freq_axis,error)
        if (error) return
      enddo
    endif
  endif
  !
  !
  if (noarg) then
    ! if no tuning was entered, reset the rec%n_tuning to 0
    ! like this ifproc/backend command will not work (need at least 1 tuning)
    emir%rec%n_tunings = 0
  endif
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine pico_emir
!
subroutine rec_define_emir(rname,rdesc,error)
  use gbl_message
  use astro_interfaces, except_this=>rec_define_emir
  use ast_line
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! fill in the receiver type according to input name
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_desc_t), intent(inout) :: rdesc ! receiver parameters
  logical, intent(inout)        :: error
  ! local
  integer(kind=4)       :: i
  real(kind=8)          :: loexplore
  real(kind=8)          :: fold_offset  
  !
  ! Handle the change of frequency implemented in 2021
  if (obs_year.eq.2016) then
    fold_offset=0d0
  else if  (obs_year.eq.2021) then
    fold_offset=320d0
  else
    call astro_message(seve%e,rname,'PICO generation not understood')
    error = .true.
    return
  endif
  !
  rdesc%name = 'EMIR'
  rdesc%defined=.true.
  rdesc%n_rbands = 4
  rdesc%bandname(1) = 'E090'
  rdesc%bandname(2) = 'E150'
  rdesc%bandname(3) = 'E230'
  rdesc%bandname(4) = 'E330'
  rdesc%rejection(1) = 10
  rdesc%rejection(2) = 10
  rdesc%rejection(3) = 10
  rdesc%rejection(4) = 10
  rdesc%n_sbands = 2
  rdesc%n_bbands = 2
  rdesc%n_polar = 2
  rdesc%n_backends = 3
  ! Use FTS wide limits because it is the wider backend
  rdesc%iflim(1) = 3950d0
  rdesc%iflim(2) = 11730d0+fold_offset
  rdesc%ifband = rdesc%iflim(2)-rdesc%iflim(1)
  !basebands
  rdesc%flo2 = 0d0 !we ignore if2 for pico
  rdesc%bbname(1) = 'OUTER'
  rdesc%bblim(1,1) = 7680d0+fold_offset
  rdesc%bblim(2,1) = 11730d0+fold_offset
  rdesc%bbref(1) = 9430d0+fold_offset !from emir doc - center of vespa region
  rdesc%bbname(2) = 'INNER'
  rdesc%bblim(1,2) = 3950d0
  rdesc%bblim(2,2) = 8000d0
  rdesc%bbref(2) = 6250d0 !from emir doc - center of vespa region
  ! Polars
  rdesc%polname(1) = 'HORIZONTAL'
  rdesc%polname(2) = 'VERTICAL'
  !LO limits deduced from EMIR Doc Observable Limits
  !Take the widest range independtly on USB/LSB, a check of feasibility is done afterwards (pico_emir_lo_call)
  rdesc%locall(1,1) = 73.0d3+rdesc%bbref(1)-fold_offset !LSB outer
  rdesc%locall(2,1) = 102d3+rdesc%bbref(2) ! LSB inner allows to go ghigher than USB (in exploration mode)
  rdesc%locall(1,2) = 125d3+rdesc%bbref(1)-fold_offset !LSB outer
  rdesc%locall(2,2) = 184d3-rdesc%bbref(1)+fold_offset  !USB outer
  rdesc%locall(1,3) = 217d3-rdesc%bbref(2) ! USB inner  allows to go lower than USB
  rdesc%locall(2,3) = 263.5d3+rdesc%bbref(2) ! LSB inner
  rdesc%locall(1,4) = 277d3+rdesc%bbref(1)-fold_offset
  rdesc%locall(2,4) = 375d3-rdesc%bbref(1)+fold_offset
  !
  ! Limits from the call to guess the band (limits of possible requested freq)
  rdesc%rfcallreq(1,1) = 72.68d3
  rdesc%rfcallreq(2,1) = 117d3
  rdesc%rfcallreq(1,2) = 125d3
  rdesc%rfcallreq(2,2) = 184d3
  rdesc%rfcallreq(1,3) = 202d3
  rdesc%rfcallreq(2,3) = 274d3
  rdesc%rfcallreq(1,4) = 277d3
  rdesc%rfcallreq(2,4) = 375d3
  !
  ! wider ranges to let the user explore the edge of the bands
  ! Arbitrarily wider by 2GHz in both sides
  ! Wider limits to let some margin to explore the edge of the bands
  loexplore=1.49d3
  do i=1,rdesc%n_rbands
    rdesc%lohard(1,i) = rdesc%locall(1,i)-loexplore
    rdesc%lohard(2,i) = rdesc%locall(2,i)+loexplore
    rdesc%rfcallreq(1,i) = rdesc%rfcallreq(1,i)-loexplore
    rdesc%rfcallreq(2,i) = rdesc%rfcallreq(2,i)+loexplore

  enddo
  ! limits to be used for tuning
  do i=1,rdesc%n_rbands
      rdesc%lolim(1,i) = min(rdesc%locall(1,i),rdesc%lohard(1,i))
      rdesc%lolim(2,i) = max(rdesc%locall(2,i),rdesc%lohard(2,i))
  enddo
  ! Tolerance for tuning close to the band edge
  rdesc%lotol = 100d0  
  ! RF limits from LO +- IFmax
  do i=1,rdesc%n_rbands
      rdesc%rflim(1,i) = rdesc%lolim(1,i)-rdesc%iflim(2)
      rdesc%rflim(2,i) = rdesc%lolim(2,i)+rdesc%iflim(2)
  enddo
  ! RF limits from Call +- IFmax
  do i=1,rdesc%n_rbands
      rdesc%rfcall(1,i) = rdesc%locall(1,i)-rdesc%iflim(2)
      rdesc%rfcall(2,i) = rdesc%locall(2,i)+rdesc%iflim(2)
  enddo
  !
  rdesc%tuninggrid = .false.
  rdesc%gridbin = 0d0 ! MHz
  rdesc%gridtol = 0d0 ! MHz
  !
end subroutine rec_define_emir
!
subroutine pico_emir_lo_call(rname,ib,flo,sb,error)
  use gbl_message
  use astro_interfaces, except_this=>pico_emir_lo_call
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! call for proposal offers different LO limits according to tuning sideband
  ! rec_define_emir takes union of LSB and USB limits, we check feasibility here
  !-----------------------------------------------------------------------
  character(len=*) , intent(in) :: rname
  integer(kind=4), intent(in) :: ib
  real(kind=8), intent(in)    :: flo
  character(len=*), intent(in)    :: sb
  logical, intent(inout)        :: error
  ! local
  integer(kind=4) :: isb
  real(kind=8) :: cmin,cmax
  !
  if (sb.eq."LSB") then
    isb=lsb_code
  else if (sb.eq."USB") then
    isb=usb_code
  else
    call astro_message(seve%e,rname,"Problem with Sideband")
    error=.true.
    return
  endif
  !
  if (ib.eq.1.and.isb.eq.lsb_code) then
    ! band 1 LSB: warning when Fcent above 97 in LSB
    if (flo.gt.103250d0.and.flo.le.108250d0) then
      call astro_message(seve%w,rname,'Tuning performance might not be optimal, consider switching to USB')
    endif
  else if (ib.eq.1.and.isb.eq.usb_code.and.flo.gt.1072500d0) then
    ! LSB LOmax B1 is higher than USB LOmax
    call astro_message(seve%e,rname,'This LO frequency is reachable only in LSB mode')
    error=.true.
    return
  else if (ib.eq.1.and.isb.eq.usb_code.and.flo.lt.82750d0) then
    ! USB LOmin B1 is higher than LSB LOmin
    call astro_message(seve%e,rname,'This LO frequency is reachable only in LSB mode')
    error=.true.
    return
  else if (ib.eq.3.and.isb.eq.usb_code.and.flo.gt.264250d0) then
    ! USB LOmax is smaller than LSB LOmax
    call astro_message(seve%e,rname,'This LO frequency is reachable only in LSB mode')
    error=.true.
    return
  else if (ib.eq.3.and.isb.eq.lsb_code.and.flo.lt.211750d0) then
    ! USB LOmin is smaller than LSB LOmmin
    call astro_message(seve%e,rname,'This LO frequency is reachable only in USB mode')
    error=.true.
    return
  else if (ib.eq.4.and.isb.eq.lsb_code.and.flo.gt.341250d0) then
    ! USB LOmax is higher than LSB LOMax
    call astro_message(seve%e,rname,'This LO frequency is reachable only in USB mode')
    error=.true.
    return
  endif
  !
end subroutine pico_emir_lo_call
!
subroutine rec_define_emir_switchbox(emirsw,error)
  use gbl_message
  use astro_interfaces, except_this=>rec_define_emir_switchbox
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! switchbox characteristics
  !-----------------------------------------------------------------------
  type(correlator_input_t), intent(inout) :: emirsw ! emir switchbox parameters
  logical, intent(inout)        :: error
  ! local
  integer(kind=4) :: i
  ! Switchbox
  emirsw%n_ifcables = 8
  emirsw%m_usercables = 4
  emirsw%mode = ''
  emirsw%defined = .false.
  do i=1,m_ifcables
    emirsw%ifc(i)%label = ''
    emirsw%ifc(i)%iband = 0
    emirsw%ifc(i)%sb_code = 0
    emirsw%ifc(i)%bb_code = 0
    emirsw%ifc(i)%pol_code = 0
  enddo
  !
end subroutine rec_define_emir_switchbox
!
subroutine pico_reset_emir(emir,error)
  use astro_interfaces, except_this=>pico_reset_emir
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! reset emir specific parameters
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout) :: emir 
  logical, intent(inout)        :: error
  ! Local
  integer(kind=4)       :: i
  !
  !Command parameters
  emir%comm%n_tunings = 0
  do i=1,m_tunings
    emir%comm%frest(i) = 0
    emir%comm%code(i) = ''
  enddo
  emir%comm%zoommode = ''
  emir%comm%fz1 = 0
  emir%comm%fz2 = 0
  emir%comm%fixed_scale = .false.
  !
  ! Setup parameters
  do i=1,m_tunings
    emir%setup%sb_code(i) = 0
    emir%setup%polar(i) = ''
    emir%setup%pol_code(i) = 0
  enddo
  emir%setup%sb_mode = ''
  emir%setup%polmode = ''
  !
  ! Switchbox
  emir%switch%mode = ''
  emir%switch%defined = .false.
  do i=1,m_ifcables
    emir%switch%ifc(i)%label = ''
    emir%switch%ifc(i)%iband = 0
    emir%switch%ifc(i)%sb_code = 0
    emir%switch%ifc(i)%bb_code = 0
    emir%switch%ifc(i)%pol_code = 0
  enddo
  !
end subroutine pico_reset_emir
!
subroutine pico_emir_setup(emir,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>pico_emir_setup
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! Check feasability and tune emir requested bands
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout) :: emir !command line parameters
  logical, intent(inout)        :: error
  ! Local
  character(len=*), parameter :: rname='EMIR'
  integer, parameter :: m_codes=4
  integer(kind=4) :: it,icode
  character(len=2) :: emircodes(m_codes),emircode
  data emircodes/'UI','LI','UO','LO'/
  !
  emir%rec%n_tunings=emir%comm%n_tunings
  do it=1,emir%rec%n_tunings 
    emir%rec%comm(it)%rec_name = 'EMIR'
    emir%rec%comm(it)%frest = emir%comm%frest(it)
    call sic_upper(emir%comm%code(it))
    call sic_ambigs(rname,emir%comm%code(it),emircode,icode,emircodes,m_codes,error)
    if (error) then
      call astro_message(seve%e,rname,'Problem decoding tuning sideband code (UI LI UO LO)')
      return
    endif
    select case (emir%comm%code(it))
      case ('UI')
         emir%rec%comm(it)%sideband = 'USB'
         emir%rec%comm(it)%fcent = emir%rec%desc%bbref(inner_code)
      case ('UO')
         emir%rec%comm(it)%sideband = 'USB'
         emir%rec%comm(it)%fcent = emir%rec%desc%bbref(outer_code)
      case ('LI')
         emir%rec%comm(it)%sideband = 'LSB'
         emir%rec%comm(it)%fcent = emir%rec%desc%bbref(inner_code)
      case ('LO')
         emir%rec%comm(it)%sideband = 'LSB'
         emir%rec%comm(it)%fcent = emir%rec%desc%bbref(outer_code)
    end select
    emir%rec%comm(it)%name = ''
    ! tune the bands
    call astro_tune_receiver(rname,emir%rec%desc,emir%rec%source,emir%rec%comm(it),emir%rec%tune(it),error)
    if (error) return
    !
    !Check compliance with call for proposal LO limits
    call pico_emir_lo_call(rname,emir%rec%tune(it)%iband,emir%rec%tune(it)%flo1,emir%rec%comm(it)%sideband,error)
    if (error) return
  enddo
  !
  !Check band combination feasability (in n_tunings>1)
  !
  if (emir%rec%n_tunings.gt.1) then
    !Band combination
    if (emir%rec%tune(1)%iband.eq.emir%rec%tune(2)%iband) then
      call astro_message(seve%e,rname,'A receiver band can be tuned at only one frequency at a time')
      call rec_display_error('A receiver band can be tuned at only one frequency at a time',error)
      if (error) return
      error = .true.
      return
    endif
    if (emir%rec%desc%bandname(emir%rec%tune(1)%iband).eq.'E090') then
      if (emir%rec%desc%bandname(emir%rec%tune(2)%iband).eq.'E330') then
        call astro_message(seve%e,rname,'Band combination is not allowed')
        call astro_message(seve%i,rname,'E090 can be combined with E150 or E230')
        call rec_display_error('Band combination is not allowed',error)
        if (error) return
        error = .true.
        return
      endif
    endif
    if (emir%rec%desc%bandname(emir%rec%tune(1)%iband).eq.'E150') then
      if (emir%rec%desc%bandname(emir%rec%tune(2)%iband).eq.'E230') then
        call astro_message(seve%e,rname,'Band combination is not allowed')
        call astro_message(seve%i,rname,'E150 can be combined with E090 or E330')
        call rec_display_error('Band combination is not allowed',error)
        if (error) return
        error = .true.
        return
      endif
    endif
    if (emir%rec%desc%bandname(emir%rec%tune(1)%iband).eq.'E230') then
      if (emir%rec%desc%bandname(emir%rec%tune(2)%iband).ne.'E090') then
        call astro_message(seve%e,rname,'Band combination is not allowed')
        call astro_message(seve%i,rname,'E230 can be combined with E090 only')
        call rec_display_error('Band combination is not allowed',error)
        if (error) return
        error = .true.
        return
      endif
    endif
    if (emir%rec%desc%bandname(emir%rec%tune(1)%iband).eq.'E330') then
      if (emir%rec%desc%bandname(emir%rec%tune(2)%iband).ne.'E150') then
        call astro_message(seve%e,rname,'Band combination is not allowed')
        call astro_message(seve%i,rname,'E330 can be combined with E150 only')
        call rec_display_error('Band combination is not allowed',error)
        if (error) return
        error = .true.
        return
      endif
    endif
  endif
  !
end subroutine pico_emir_setup
!
subroutine emir_switchbox(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>emir_switchbox
  use astro_types
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! SWITCHBOX command to define what are the basebands brought to the backends
  ! no arg = defaults =  single band or maximize FTS coverage + dual polar when possible
  ! option SINGLEPOLAR (only dual band) = maximize FTS coverage + single polar when possible
  ! with arguments : sets explicitely the content of the 1-4 if cables
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout)        :: error
  ! local
  character(len=*), parameter :: rname = 'EMIR'
  integer(kind=4), parameter :: optsingle = 1
  integer(kind=4)       :: lpar,i
  logical               :: dopchanged
  character(len=5)     :: cablecode(emir%switch%m_usercables)
  character(len=200)    :: comm
  !
  if (obsname.ne.'PICOVELETA'.and.obsname.ne.'VELETA') then
    call astro_message(seve%e,rname,'Observatory changed since last tuning - Please define a new tuning')
    error = .true.
    return
  endif
  ! Check that a tuning has been set
  if (emir%rec%n_tunings.eq.0) then
    call astro_message(seve%e,rname,'Please define a tuning (EMIR command) before setting the switchbox configuration')
    error = .true.
    return
  endif
  !
  !check that doppler did not changed since last tuning command
  call rec_check_doppler(emir%rec%source,emir%rec%desc%redshift,dopchanged,error)
  if (error) return
  if (dopchanged) then
    call astro_message(seve%e,rname,'Source properties changed since last tuning')
    call astro_message(seve%i,rname,'You should set again the tuning (EMIR command)')
    call rec_display_error('Source changed since last tuning',error)
    error = .true.
    return
  endif
  !
  !
  ! Automatic = widest possible / dual polar when possible
  ! + define all possible codes for cables
  emir%switch%mode = 'AUTO'
  if (sic_present(0,1)) then
    emir%switch%mode = 'LIST'
    do i=1,emir%switch%m_usercables
      call sic_ke(line,0,i,cablecode(i),lpar,.true.,error)
      if (error) return
    enddo
  endif
  if (sic_present(optsingle,0)) then
    if (emir%switch%mode.eq.'LIST') then
      call astro_message(seve%e,rname,'The option SINGLEPOLAR cannot be used when a list of basebands is provided')
      error = .true.
      return
    endif
    if (emir%rec%n_tunings.lt.2) then
      call astro_message(seve%e,rname,'The option /SINGLEPOLAR has no sense when using only 1 receiver band')
      error = .true.
      return
    endif
    emir%switch%mode = 'SINGLE'
  endif
  !
  !define the switch box situation corresponding to the setup
  if (emir%switch%mode.eq.'SINGLE'.or.emir%switch%mode.eq.'AUTO') then
    call emir_switch_autosetup(emir,error)
    if (error) return
  else if (emir%switch%mode.eq.'LIST') then
    call emir_switch_listsetup(emir,cablecode,error)
    if (error) return
!    call astro_message(seve%e,rname,'NOT YET IMPLEMENTED')
  else
    call astro_message(seve%e,rname,'Problem with switchbox mode')
    error = .true.
    return
  endif
  !
  do i=1,emir%switch%n_ifcables
    write (comm,'(a,1x,i0,1x,a,1x,a)') 'IF Cable #',i,'contains',emir%switch%ifc(i)%label
    call astro_message(seve%i,rname,comm)
  enddo
  !
  emir%switch%defined = .true.
  !
  call pico_switch_plot(emir,molecules,cplot,freq_axis,error)
  if (error) return
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine emir_switchbox
!
subroutine emir_switch_autosetup(emir,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>emir_switch_autosetup
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! assign the right baseband to the 8 emir if cables - default with inner and outer
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout)   :: emir
  logical, intent(inout)        :: error
  ! Local      
  character(len=*), parameter :: rname = 'EMIR'
  integer(kind=4) :: it,is,ip,ib,icable,iother, n_polar
  integer(kind =4):: sb_code(m_sideband),bbcode(m_bbands),n_sidebands,polcode(emir%rec%desc%n_polar)
  integer(kind=4), parameter :: polh_code = 1
  integer(kind=4), parameter :: polv_code = 2
  character(len=5)      :: cablecode
  character(len=1)      :: polname(emir%rec%desc%n_polar)
  !
  bbcode(1) = outer_code
  bbcode(2) = inner_code
!   if (rec%desc%n_polar.eq.1) then
!     polname(1) = rec%desc%polname(1)(1:1)
!     if (polname(1).eq.'H') then
!       polcode(1) = polh_code
!     else if (polname(1).eq.'V') then
!       polcode(1) = polv_code
!     else
!       call astro_message(seve%e,rname,'Unknown polarization type')
!       error = .true.
!       return
!     endif
!   else if 
!     polcode(1) = polh_code
!     polcode(2) = polv_code
!     polname(1) = rec%desc%polname(1)
!     polname(2) = rec%desc%polname(2)
!   else
!     call astro_message(seve%e,rname,'Problem with polarization types')
!     error = .true.
!     return
!   endif
  !
  ! sideband and polar consequences of the band combination + SINGLE POLAR OPTION
  if (emir%rec%n_tunings.eq.2) then
    if (emir%rec%tune(1)%sb_code.ne.emir%rec%tune(2)%sb_code) then
      emir%setup%polmode='SINGLE'
      emir%setup%sb_mode = '2SB'
      emir%setup%sb_code(1) = 0
      emir%setup%sb_code(2) = 0
      call astro_message(seve%i,rname,'This tuning combination provides:')
      call astro_message(seve%i,rname,'2 sidebands and only 1 polar in each band')
      call astro_message(seve%i,rname,'Single polar observations are not recommended')
      call astro_message(seve%i,rname,'(lack of cross checks for ghostlines/calibration)') 
      call astro_message(seve%i,rname,'You may tune the two bands in the same sideband (U/L)')
      call astro_message(seve%i,rname,'to get dual polar in 1 sideband only')
    else
      if (emir%switch%mode.eq.'AUTO') then
        emir%setup%polmode='DUAL'
        emir%setup%polar(1) = 'H+V'
        emir%setup%polar(2) = 'H+V'
        emir%setup%sb_mode = 'SSB'
        emir%setup%sb_code(1) = emir%rec%tune(1)%sb_code
        emir%setup%sb_code(2) = emir%rec%tune(2)%sb_code
        call astro_message(seve%i,rname,'The default configuration for this combination provides:')
        call astro_message(seve%i,rname,'only 1 sideband and 2 polars in each band')
        call astro_message(seve%i,rname,'The option /SINGLEPOLAR can be used to get:')
        call astro_message(seve%i,rname,'2 sidebands and only 1 polar in each band')
        call astro_message(seve%i,rname,'Single polar observations are not recommended')
        call astro_message(seve%i,rname,'(lack of cross checks for ghostlines/calibration)') 
     else if (emir%switch%mode.eq.'SINGLE') then
        emir%setup%polmode='SINGLE'
        emir%setup%sb_mode = '2SB'
        emir%setup%sb_code(1) = 0
        emir%setup%sb_code(2) = 0
        call astro_message(seve%i,rname,'The option /SINGLEPOLAR forces the use of')
        call astro_message(seve%i,rname,'2 sidebands and only 1 polar')
        call astro_message(seve%i,rname,'Single polar observations are not recommended')
        call astro_message(seve%i,rname,'(lack of cross checks for ghostlines/calibration)')
        call astro_message(seve%i,rname,'Without the option, this band combination would provide')
        call astro_message(seve%i,rname,'2 polars in only 1 sideband in each band')
      else
        call astro_message(seve%e,rname,'Problem with switchbox mode')
        error = .true.
        return
      endif
    endif
    if (emir%setup%polmode.eq.'SINGLE') then
      do it=1,emir%rec%n_tunings
        if (emir%rec%desc%bandname(emir%rec%tune(it)%iband).eq.'E330'.or.                 &
            emir%rec%desc%bandname(emir%rec%tune(it)%iband).eq.'E230')            then
          emir%setup%pol_code(it) = polv_code
          emir%setup%polar(it) = emir%rec%desc%polname(emir%setup%pol_code(it))(1:1)
        else if (emir%rec%desc%bandname(emir%rec%tune(it)%iband).eq.'E090') then
          emir%setup%pol_code(it) = polh_code
          emir%setup%polar(it) = emir%rec%desc%polname(emir%setup%pol_code(it))(1:1)
        else if (emir%rec%desc%bandname(emir%rec%tune(it)%iband).eq.'E150') then
          if (it.eq.1) then 
            iother = 2
          else if (it.eq.2) then
            iother = 1
          else
            call astro_message(seve%e,rname,'Problem with Band identification')
            error = .true.
            return
          endif
          if (emir%rec%desc%bandname(emir%rec%tune(iother)%iband).eq.'E330') then
            emir%setup%pol_code(it) = polh_code
            emir%setup%polar(it) = emir%rec%desc%polname(emir%setup%pol_code(it))(1:1)
          else if (emir%rec%desc%bandname(emir%rec%tune(iother)%iband).eq.'E090') then
            emir%setup%pol_code(it) = polv_code
            emir%setup%polar(it) = emir%rec%desc%polname(emir%setup%pol_code(it))(1:1)
          endif
        else
          call astro_message(seve%e,rname,'Problem with Band identification')
          error = .true.
          return
        endif
      enddo
    endif
  else if (emir%rec%n_tunings.eq.1) then
    emir%setup%polmode='DUAL'
    emir%setup%polar(1) = 'H+V'
    emir%setup%sb_mode = '2SB'
    emir%setup%sb_code(1) = 0
  else
    call astro_message(seve%e,rname,'Problem with the number of tunings')
    error = .true.
    return
  endif
  !Define what goes through the cables - default is INNER for cable 1 to 4  !
  do it=1,emir%rec%n_tunings
    if (emir%setup%sb_mode.eq.'2SB') then
      n_sidebands = 2
      sb_code(1) = usb_code
      sb_code(2) = lsb_code
    else if (emir%setup%sb_mode.eq.'SSB') then
      n_sidebands = 1
      sb_code(1) = emir%setup%sb_code(it)
    else
      call astro_message(seve%e,rname,'Problem with sidebands')
      error = .true.
      return
    endif
    if (emir%setup%polmode.eq.'DUAL') then
      n_polar = 2
      polname(1) = 'H'
      polname(2) = 'V'
      polcode(1) = polh_code
      polcode(2) = polv_code
    else if (emir%setup%polmode.eq.'SINGLE') then
      n_polar = 1
      polname(1) = emir%setup%polar(it)
      if (polname(1).eq.'H') then
        polcode(1) = polh_code
      else if (polname(1).eq.'V') then
        polcode(1) = polv_code
      else
        call astro_message(seve%e,rname,'Problem with polarization determination')
        error = .true.
        return
      endif
    else
      call astro_message(seve%e,rname,'Problem with number of polars')
      error=.true.
      return
    endif
    do is=1,n_sidebands
      do ip=1,n_polar
        do ib=1,emir%rec%desc%n_bbands
          write (cablecode,'(i0,a,i0,i0)') emir%rec%tune(it)%iband,polname(ip),sb_code(is),bbcode(ib)
          ! by default outer goes only to cable 5 to 8 - cable 1 to 4 takes inner
          select case (cablecode)
          case ('1V22','4V22','2V12','3V12')
            icable = 1
            !
          case ('1V21','4V21','2V11','3V11')
            icable = 5
            !
          case ('1V12','4V12','2V22','3V22')
            icable = 2
            !
          case ('1V11','4V11','2V21','3V21')
            icable = 6
            !
          case ('1H22','4H22','2H12','3H12')
            icable = 3
            !
          case ('1H21','4H21','2H11','3H11')
            icable = 7
            !
          case ('1H12','4H12','2H22','3H22')
            icable = 4
            !
          case ('1H11','4H11','2H21','3H21')
            icable = 8
            !
          case default
            call astro_message(seve%e,rname,'Problem defining the switch box setup')
            error = .true.
            return
          end select
          emir%switch%ifc(icable)%iband = emir%rec%tune(it)%iband
          emir%switch%ifc(icable)%sb_code = sb_code(is)
          emir%switch%ifc(icable)%bb_code = bbcode(ib)
          emir%switch%ifc(icable)%pol_code = polcode(ip)
          write (emir%switch%ifc(icable)%label,'(a,a,a,a)') emir%rec%desc%bandname(emir%rec%tune(it)%iband)(1:2),            &
                  polname(ip)(1:1),sideband(sb_code(is))(1:1),emir%rec%desc%bbname(ib)(1:1)
        enddo
      enddo
    enddo
  enddo
  !
end subroutine emir_switch_autosetup
!
subroutine emir_switch_listsetup(emir,cablecode,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>emir_switch_listsetup
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! assign user defined IF cables - user provides 4 codes, we deduce 8 IF cables
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout)   :: emir
  character(len=*), intent(inout)  :: cablecode(emir%switch%m_usercables)
  logical, intent(inout)        :: error
  ! Local
  character(len=*), parameter :: rname = 'EMIR'
  character(len=2) :: urec
  character(len=1) :: upol
  character(len=1) :: uside
  character(len=1) :: ubb
  logical :: found,assigned(emir%switch%m_usercables)
  character(len=12)      :: polname(2)
  character(len=200)      :: mess
  integer(kind=4) :: ic,it,is,ip,ib,icable,icode
  integer(kind=4) :: bbcode(emir%rec%desc%n_bbands),sb_code(m_sideband),polcode(emir%rec%desc%n_polar)
  integer(kind=4), parameter :: polh_code = 1
  integer(kind=4), parameter :: polv_code = 2
  !
  if (emir%rec%desc%n_polar.eq.2) then
    polcode(1) = polh_code
    polcode(2) = polv_code
  else
    polname(1) = emir%rec%desc%polname(1)
    if  (polname(1)(1:1).eq.'H') then
      polcode(1) = polh_code
    else if  (polname(1)(1:1).eq.'V') then
      polcode(1) = polv_code
    else
      call astro_message(seve%e,rname,'Problem with polarization determination')
      error = .true.
      return
    endif
  endif
  !
  bbcode(1) = outer_code !outer
  bbcode(2) = inner_code !inner
  !
  emir%setup%polmode = 'USER'
  emir%setup%sb_mode = ''
  !
  do ic=1,emir%switch%m_usercables
    assigned(ic) = .false.
  enddo
  do icode=1,emir%switch%m_usercables
    found = .false.
    call sic_upper(cablecode(icode))
    urec = cablecode(icode)(1:2)
    upol = cablecode(icode)(3:3)
    uside = cablecode(icode)(4:4)
    ubb = cablecode(icode)(5:5)
    do it=1,emir%rec%n_tunings
      if (urec.ne.emir%rec%desc%bandname(emir%rec%tune(it)%iband)(1:2)) cycle
      if (emir%rec%desc%n_sbands.eq.2) then
        sb_code(1) = usb_code
        sb_code(2) = lsb_code
      else
        sb_code(1) = emir%rec%tune(it)%sb_code
      endif
      do is=1,emir%rec%desc%n_sbands
        if (uside.ne.sideband(sb_code(is))(1:1)) cycle
        do ip=1,emir%rec%desc%n_polar
          if (upol.ne.emir%rec%desc%polname(ip)(1:1)) cycle
          do ib=1,emir%rec%desc%n_bbands
            if (ubb.ne.emir%rec%desc%bbname(ib)(1:1)) cycle
            select case (cablecode(icode))
            case ('E0VLI','E3VLI','E1VUI','E2VUI','E0VLO','E3VLO','E1VUO','E2VUO')
              icable = 1
              if (assigned(icable)) then
                call astro_message(seve%e,rname,'The same cable cannot be used several times')
                error = .true.
                return
              endif
              assigned(icable) = .true.
              found = .true.
            case ('E0VUI','E3VUI','E1VLI','E2VLI','E0VUO','E3VUO','E1VLO','E2VLO')
              icable = 2
              if (assigned(icable)) then
                call astro_message(seve%e,rname,'The same cable cannot be used several times')
                error = .true.
                return
              endif
              assigned(icable) = .true.
              found = .true.
            case ('E0HLI','E3HLI','E1HUI','E2HUI','E0HLO','E3HLO','E1HUO','E2HUO')
              icable = 3
              if (assigned(icable)) then
                call astro_message(seve%e,rname,'The same cable cannot be used several times')
                error = .true.
                return
              endif
              assigned(icable) = .true.
              found = .true.
            case ('E0HUI','E3HUI','E1HLI','E2HLI','E0HUO','E3HUO','E1HLO','E2HLO')
              icable = 4
              if (assigned(icable)) then
                call astro_message(seve%e,rname,'The same cable cannot be used several times')
                error = .true.
                return
              endif
              assigned(icable) = .true.
              found = .true.
            case default
              call astro_message(seve%e,rname,'Code was not understood')
              error = .true.
              return
            end select
            emir%switch%ifc(icable)%iband = emir%rec%tune(it)%iband
            emir%switch%ifc(icable)%sb_code = is
            emir%switch%ifc(icable)%bb_code = bbcode(ib)
            emir%switch%ifc(icable)%pol_code = polcode(ip)
            emir%switch%ifc(icable)%label = cablecode(icode)
            ! corresponding cable 4-8
            emir%switch%ifc(icable+emir%switch%m_usercables)%iband = emir%rec%tune(it)%iband
            emir%switch%ifc(icable+emir%switch%m_usercables)%sb_code = is
            emir%switch%ifc(icable+emir%switch%m_usercables)%bb_code = bbcode(1) !outer is forced
            emir%switch%ifc(icable+emir%switch%m_usercables)%pol_code = polcode(ip)
            write(emir%switch%ifc(icable+emir%switch%m_usercables)%label,'(a,a)')     &
                    cablecode(icode)(1:4),emir%rec%desc%bbname(1)(1:1)
          enddo ! baseband
        enddo !polar
      enddo ! sidebands
    enddo ! receivers
    if (.not.found) then
      write (mess,'(a,1x,a)') 'Code provided by the user does not match',cablecode(icode)
      call astro_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  enddo ! user input
  !
end subroutine emir_switch_listsetup
!
subroutine pico_switch_plot(emir,cata,cplot,drawaxis,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>pico_switch_plot
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! identifies the polarizations and sideband available with the current emir setup
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout) :: emir
  type(plot_molecules_t), intent(in) :: cata
  type(current_boxes_t), intent(inout) :: cplot
  type(frequency_axis_t), intent(in) :: drawaxis
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='EMIR'
  integer(kind=4) :: i,j,k,sb_code(m_sideband),ip,ib,ic,izoom,it,iband
  character(len=200) :: comm,defchar,smallchar,molchar
  character(len=5) :: cablecode
  real(kind=8) :: fif1,frf,frest,yt,l1,l2,l3,l4,b1,b2,b3,b4
  type(draw_rect_t)     :: sbrect
  type(draw_line_t)     :: linebb
  real(kind=4), parameter :: sdefchar = 0.4
  logical       :: nobb
  !
  sb_code(1) = usb_code
  sb_code(2) = lsb_code
  !
  !Clear and redraw in case the frequency axis were changed since last EMIR command
  call gr_execl('CLEAR DIRECTORY')  
  !
  select case (cplot%desc%plotmode)
  case (pm_allbands)
    call rec_plot_mbands(emir%rec%desc,emir%rec%source, &
                        cata,emir%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        cata,cplot,drawaxis,error)
        if (error) return
      enddo
    endif
  case (pm_tunedbands)
    call rec_plot_nbands(emir%rec,cata,emir%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
  case (pm_receiver)
    call rec_get_itune(emir%rec,cplot%box(1)%iband,izoom,error)
    if (error) return
    call rec_plot_sidebands(emir%rec%desc,emir%rec%source,emir%rec%tune(izoom),cplot,cata,drawaxis,error)
    if (error) return
  case (pm_zoom)
    call astro_message(seve%i,rname,'Leaving the zoom mode to show baseband coverage')
    call gr_execl('CLEAR DIRECTORY')
    call rec_plot_mbands(emir%rec%desc,emir%rec%source, &
                        cata,emir%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        cata,cplot,drawaxis,error)
        if (error) return
      enddo
    endif
  end select
  if (.not.(gtexist('<GREG<BOX1'))) then
    call gr_execl('CLEAR DIRECTORY')
    call rec_plot_mbands(emir%rec%desc,emir%rec%source, &
                        cata,emir%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        cata,cplot,drawaxis,error)
        if (error) return
      enddo
    endif
  endif
  !
  write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%defchar
  write (smallchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%smallchar
  write (molchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%molchar
  call gr_exec1(defchar)
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  !
  write (comm,'(a)') 'CHANGE DIRECTORY'
  call gr_execl(comm)
  if (gtexist('IFPROC')) then
    write (comm,'(a)') 'DESTROY DIRECTORY IFPROC'
    call gr_execl(comm)
  endif
  write (comm,'(a)') 'CREATE DIRECTORY IFPROC'
  call gr_execl(comm)
  do i=1,cplot%nbox
    if (cplot%desc%plotmode.eq.pm_receiver.and.i.eq.2) cycle
    write (comm,'(a,i0)') 'CHANGE DIRECTORY <GREG<BOX',i
    call gr_execl(comm)
    l1 = cplot%box(i)%rest%xmin
    l2 = cplot%box(i)%rest%xmax
    l3 = cplot%box(i)%rest%ymin
    l4 = cplot%box(i)%rest%ymax
    b1 = cplot%box(i)%phys%xmin
    b2 = cplot%box(i)%phys%xmax
    b3 = cplot%box(i)%phys%ymin
    b4 = cplot%box(i)%phys%ymax
    write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
    write (comm,'(a)') 'CHANGE DIRECTORY IFPROC'
    call gr_execl(comm)
    write (comm,'(a,4(1x,f0.3))') 'SET BOX_LOCATION',b1,b2,b3,b4
    call gr_exec1(comm)
    write (comm,'(a,4(1x,f0.3))') 'LIMITS',l1,l2,l3,l4
    call gr_exec1(comm)
    if (i.eq.1) then
      if (emir%switch%mode.eq.'LIST') then
        write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +5 3.5 "USER SELECTION" 5 0 /CHARACTER 7'
        call gr_exec1(comm)
      else if (emir%switch%mode.eq.'AUTO'.or.emir%switch%mode.eq.'SINGLE') then
        call gr_pen(colour=apolcol,error=error)
        if (error) return
        write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +3 3.5 "',trim(emir%setup%polmode),'" 5 0 /CHARACTER 7'
        call gr_exec1(comm)
        call gr_pen(colour=adefcol,error=error)
        if (error) return
        write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +7 3.5 "POLAR" 5 0 /CHARACTER 7'
        call gr_exec1(comm)
      else
        call astro_message(seve%e,rname,'Problem with switchbox mode')
        error = .true.
        return
      endif
    endif
    do j=1,emir%rec%n_tunings
      if (emir%rec%tune(j)%iband.ne.cplot%box(i)%iband) cycle
      iband=emir%rec%tune(j)%iband
      do k=1,emir%rec%desc%n_sbands
        ! cycle if the current box does not contain the right sideband
        if (cplot%box(i)%sb_code.ne.k.and.cplot%box(i)%sb_code.ne.0) cycle
!        if (emir%setup%sb_code(j).eq.0.or.emir%setup%sb_code(j).eq.sb_code(k)) then
          !available side band --> loop on baseband and polar
          do ib=1,emir%rec%desc%n_bbands
            nobb = .true.
            do ip=1,emir%rec%desc%n_polar
              write (cablecode,'(a,a,a,a)') emir%rec%desc%bandname(iband)(1:2),            &
                  emir%rec%desc%polname(ip)(1:1),sideband(sb_code(k))(1:1),emir%rec%desc%bbname(ib)(1:1)
              do ic=1,emir%switch%n_ifcables
                if (emir%switch%ifc(ic)%label.eq.cablecode) then
                  nobb = .false.
                  !available baseband --> write name
                  fif1 = (emir%rec%desc%bblim(2,ib)+emir%rec%desc%bblim(1,ib))/2d0
                  yt = l3+((l4-l3)/6)*ip
                  call if1torf(emir%rec%tune(j)%flo1,fif1,sb_code(k),frf,error)
                  if (error) return
                  call rftorest(emir%rec%source%dopshift,frf,frest,error)
                  if (error) return
                  call gr_pen(colour=abbifproccol,error=error)
                  if (error) return
                  call gr_exec1(smallchar)
                  write (comm,'(a,1x,f0.6,1x,f0.3,1x,a,a,1x,a)')               &
                    'DRAW TEXT',frest,yt,'"',trim(cablecode),'" 5 0 /USER /CLIP'
                  call gr_exec1(comm)
                  !draw the limit of the baseband
                  call if1torf(emir%rec%tune(j)%flo1,emir%rec%desc%bblim(1,ib),sb_code(k),frf,error)
                  if (error) return
                  call rftorest(emir%rec%source%dopshift,frf,linebb%xmin,error)
                  if (error) return
                  call if1torf(emir%rec%tune(j)%flo1,emir%rec%desc%bblim(2,ib),sb_code(k),frf,error)
                  if (error) return
                  call rftorest(emir%rec%source%dopshift,frf,linebb%xmax,error)
                  if (error) return
                  linebb%ymin = cplot%box(i)%rest%ymin+(cplot%box(i)%rest%ymax-cplot%box(i)%rest%ymin)/10
                  linebb%ymax = linebb%ymin
                  linebb%col   = abbifproccol
                  linebb%dash  = 1
                  call rec_draw_arrow(linebb,cplot%box(i)%rest,error)
                  if (error) return
                  frest = linebb%xmin
                  linebb%xmin = linebb%xmax
                  linebb%xmax = frest
                  call rec_draw_arrow(linebb,cplot%box(i)%rest,error)
                  if (error) return
                  call gr_pen(colour=adefcol,error=error)
                  if (error) return
                  call gr_exec1(defchar)
                endif
              enddo ! cable
            enddo ! polar
            !
            !unavailable base band --> filled in rectangle
            if (nobb) then
              call if1torf(emir%rec%tune(j)%flo1,emir%rec%desc%bblim(1,ib),sb_code(k),frf,error)
              if (error) return
              call rftorest(emir%rec%source%dopshift,frf,sbrect%xmin,error)
              if (error) return
              call if1torf(emir%rec%tune(j)%flo1,emir%rec%desc%bblim(2,ib),sb_code(k),frf,error)
              if (error) return
              call rftorest(emir%rec%source%dopshift,frf,sbrect%xmax,error)
              if (error) return
              sbrect%ymin=cplot%box(i)%rest%ymin
              sbrect%ymax=cplot%box(i)%rest%ymax
              sbrect%col=anotselcol
              call rec_draw_frect(sbrect,cplot%box(i)%rest,error)
              if (error) return
              !
              call rec_draw_fbox(cplot,i,drawaxis,error)
              if (error) return
              !
              if (cplot%box(i)%rest%xmin.le.emir%rec%tune(j)%frest.and.cplot%box(i)%rest%xmax.ge.emir%rec%tune(j)%frest) then
                call rec_draw_linetune(emir%rec%tune(j),cplot%box(i)%rest,error)
                if (error) return
              endif
              !plot again molecules
              call gr_exec1(molchar)
              call rec_draw_molecules(cata,cplot%box(i)%rest,error)
              if (error) return
              call gr_exec1(defchar)
            endif
          enddo !baseband
!        endif
      enddo !sideband
      write (comm,'(a)') 'CHANGE DIRECTORY'
      call gr_execl(comm)
    enddo !tuning
    write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
  enddo ! boxes
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  call gr_exec1(defchar)
  !
end subroutine pico_switch_plot

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_shape_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_consistency_types
  !
  public :: shape_t,shape_cons_t
  public :: cubetools_shape_init,cubetools_shape_get_and_derive
  public :: cubetools_shape_final,cubetools_shape_put
  public :: cubetools_shape_list,cubetools_shape_sicdef, cubetools_shape_shape2userstruct
  public :: cubetools_shape_copy
  public :: cubetools_shape_consistency_init, cubetools_shape_consistency_final
  public :: cubetools_shape_consistency_check, cubetools_shape_consistency_list
  private
  !
  integer(kind=4),parameter :: labe_l = 32
  !
  type shape_t
     integer(kind=ndim_k), private :: maxdim = maxdim  ! Number of dimensions
     integer(kind=ndim_k), public  :: dim = 0          ! Number of dimensions
     integer(kind=data_k), public  :: axis(maxdim) = 0 ! Dimension of axis(iaxis)
     integer(kind=pixe_k), public  :: l = 0            ! Number of pixels in l direction
     integer(kind=pixe_k), public  :: m = 0            ! Number of pixels in m direction
     integer(kind=chan_k), public  :: c = 0            ! Number of channels
     integer(kind=data_k), public  :: dat = 0          ! Number of data elements
     integer(kind=data_k), public  :: good = 0         ! Number of good elements
     integer(kind=data_k), public  :: nan = 0          ! Number of NaN elements
  end type shape_t
  !
  type shape_cons_t
     logical                  :: check=.true.     ! Check the section
     logical                  :: prob =.false.    ! Is there a problem
     logical                  :: mess =.true.     ! Output message for this section?
     type(consistency_desc_t) :: maxdim           ! Number of dimensions consistency
     type(consistency_desc_t) :: dim              ! Number of dimensions consistency
     type(consistency_desc_t) :: axis(maxdim)     ! All axis sizes consistency
     type(consistency_desc_t) :: l                ! Number of pixels in l direction consistency
     type(consistency_desc_t) :: m                ! Number of pixels in m direction consistency
     type(consistency_desc_t) :: c                ! Number of channels consistency
     type(consistency_desc_t) :: dat              ! Number of data elements consistency
     type(consistency_desc_t) :: nan              ! Number of NaN elements consistency
  end type shape_cons_t
  !
contains
  !
  !---------------------------------------------------------------------
  !  
  subroutine cubetools_shape_init(n,error)
    !-------------------------------------------------------------------
    ! Just initilize the type
    !-------------------------------------------------------------------
    type(shape_t), intent(out)   :: n
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_shape_init
  !
  subroutine cubetools_shape_get_and_derive(ndim,dim,nl,nm,nc,n,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    integer(kind=ndim_k), intent(in)    :: ndim
    integer(kind=data_k), intent(in)    :: dim(:)
    integer(kind=data_k), intent(in)    :: nl,nm,nc
    type(shape_t),        intent(inout) :: n
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SHAPE>GET>AND>DERIVE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (size(dim).gt.n%maxdim) then
       write(mess,'(a,i0)') 'Number of axes larger than the authorized maximum ',n%maxdim
       call cubeheader_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    n%dim = ndim
    n%axis(:) = 0
    n%axis(1:ndim) = dim(1:ndim)
    n%dat = product(dim(1:ndim))
    n%nan = 0
    n%l = nl
    n%m = nm
    n%c = nc
  end subroutine cubetools_shape_get_and_derive
  !
  subroutine cubetools_shape_put(n,ndim,dim,nl,nm,nc,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(shape_t),        intent(in)    :: n
    integer(kind=ndim_k), intent(out)   :: ndim
    integer(kind=data_k), intent(out)   :: dim(:)
    integer(kind=data_k), intent(out)   :: nl,nm,nc
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SHAPE>PUT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (size(dim).lt.n%dim) then
       write(mess,'(a,i0)') 'Number of axes larger than the size of the output dim array ',size(dim)
       call cubeheader_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    ndim = n%dim
    dim(:) = 0
    dim(1:ndim)= n%axis(1:ndim)
    nl = n%l  
    nm = n%m
    nc = n%c  
  end subroutine cubetools_shape_put
  !  
  subroutine cubetools_shape_final(n,error)
    !-------------------------------------------------------------------
    ! Just reinitilize the type
    !-------------------------------------------------------------------
    type(shape_t), intent(out)   :: n
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_shape_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_shape_list(arraytype,n,error)
    use gbl_format
    use cubetools_format
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: arraytype
    type(shape_t),        intent(in)    :: n
    logical,              intent(inout) :: error
    !
    integer(kind=code_k) :: itype
    integer, parameter :: mtype=9
    integer(kind=data_k) :: dsize
    character(len=7) :: type(mtype)
    character(len=mess_l) :: mess,size
    character(len=*), parameter :: rname='SHAPE>LIST'
    !
    data type /'REAL*4','REAL*8','INTEG*4','LOGICAL',&
         'INTEG*2','BYTE','CMPLX*4','CMPLX*8','INTEG*8'/
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    itype = hardware-arraytype ! hardware is defined in the gbl_format module
    select case (itype)
    case (1,3,4)
      dsize = 4  ! Bytes per element
    case (2,7,9)
      dsize = 8
    case (5)
      dsize = 2
    case (6)
      dsize = 1
    case (8)
      dsize = 16
    case default
       ! This should not happen
       call cubeheader_message(seve%e,rname,'Unknown data type')
       error = .true.
       return
    end select
    write(size,'(i0,a,i0,a,i0,a)') n%l,' pix x ',n%m,' pix x ',n%c,' chan'
    mess = cubetools_format_stdkey_boldval('Size',size,46)
    mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Type',type(itype),12)
    mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Mem',cubetools_format_memsize(n%dat*dsize),12)
    call cubeheader_message(seve%r,rname,mess)
    call cubeheader_message(seve%r,rname,' ')
  end subroutine cubetools_shape_list
  !
  subroutine cubetools_shape_sicdef(name,n,readonly,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    type(shape_t),    intent(in)    :: n
    logical,          intent(in)    :: readonly
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>SICDEF'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call sic_defstructure(name,global,error)
    if (error) return
    call sic_def_inte(trim(name)//'%maxdim',n%maxdim,0,0,readonly,error)
    if (error) return
    call sic_def_inte(trim(name)//'%dim',n%dim,0,0,readonly,error)
    if (error) return
    call sic_def_long(trim(name)//'%axis',n%axis,1,n%dim,readonly,error)
    if (error) return
    call sic_def_long(trim(name)//'%l',n%l,0,0,readonly,error)
    if (error) return
    call sic_def_long(trim(name)//'%m',n%m,0,0,readonly,error)
    if (error) return
    call sic_def_long(trim(name)//'%c',n%c,0,0,readonly,error)
    if (error) return
    call sic_def_long(trim(name)//'%nan',n%nan,0,0,readonly,error)
    if (error) return
    call sic_def_long(trim(name)//'%dat',n%dat,0,0,readonly,error)
    if (error) return
  end subroutine cubetools_shape_sicdef
  !
  subroutine cubetools_shape_shape2userstruct(n,userstruct,error)
    use cubetools_userspace
    use cubetools_userstruct
    !------------------------------------------------------------------------
    ! Load a shape onto a user structure
    !------------------------------------------------------------------------
    type(shape_t),      intent(in)    :: n
    type(userstruct_t), intent(inout) :: userstruct
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>SHAPE2USERSTRUCT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call userstruct%def(error)
    if (error) return
    !
    call userstruct%set_member('dim',n%dim,error)
    if (error) return
    call userstruct%set_member('axis',n%axis,error)
    if (error) return
    call userstruct%set_member('l',n%l,error)
    if (error) return
    call userstruct%set_member('m',n%m,error)
    if (error) return
    call userstruct%set_member('c',n%c,error)
    if (error) return
    call userstruct%set_member('dat',n%dat,error)
    if (error) return
  end subroutine cubetools_shape_shape2userstruct
  !
  subroutine cubetools_shape_copy(in,ou,error)
    !----------------------------------------------------------------------
    !
    ! ----------------------------------------------------------------------
    type(shape_t), intent(in)    :: in
    type(shape_t), intent(out)   :: ou
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>COPY'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    ou = in
  end subroutine cubetools_shape_copy
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_shape_consistency_init(cons,error)
    !----------------------------------------------------------------------
    ! Init array shape consistency
    !----------------------------------------------------------------------
    type(shape_cons_t), intent(out)   :: cons
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>CONSISTENCY>INIT'
    integer(kind=ndim_k) :: idim
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    ! 
    call cubetools_consistency_init(notol,.not.check,mess,cons%maxdim,error)
    if (error) return
    call cubetools_consistency_init(notol,check,mess,cons%dim,error)
    if (error) return
    do idim=1,maxdim
       call cubetools_consistency_init(notol,.not.check,mess,cons%axis(idim),error)
       if (error) return
    enddo
    call cubetools_consistency_init(notol,check,mess,cons%l,error)
    if (error) return
    call cubetools_consistency_init(notol,check,mess,cons%m,error)
    if (error) return
    call cubetools_consistency_init(notol,check,mess,cons%c,error)
    if (error) return
    call cubetools_consistency_init(notol,check,mess,cons%dat,error)
    if (error) return
    call cubetools_consistency_init(notol,check,mess,cons%nan,error)
    if (error) return
  end subroutine cubetools_shape_consistency_init
  !
  subroutine cubetools_shape_consistency_check(cons,shape1,shape2,error)
    !----------------------------------------------------------------------
    ! Check array shape consistency
    !----------------------------------------------------------------------
    type(shape_cons_t), intent(inout) :: cons
    type(shape_t),      intent(in)    :: shape1
    type(shape_t),      intent(in)    :: shape2
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>CONSISTENCY>CHECK'
    integer(kind=ndim_k) :: idim
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    call cubetools_consistency_integer_check(cons%maxdim,shape1%maxdim,shape2%maxdim,error)
    if (error) return
    call cubetools_consistency_integer_check(cons%dim,shape1%dim,shape2%dim,error)
    if (error) return
    do idim=1,maxdim
       call cubetools_consistency_integer_check(cons%axis(idim),shape1%axis(idim),shape2%axis(idim),error)
       if (error) return
    enddo
    call cubetools_consistency_integer_check(cons%l,shape1%l,shape2%l,error)
    if (error) return
    call cubetools_consistency_integer_check(cons%m,shape1%m,shape2%m,error)
    if (error) return
    call cubetools_consistency_integer_check(cons%c,shape1%c,shape2%c,error)
    if (error) return
    call cubetools_consistency_integer_check(cons%dat,shape1%dat,shape2%dat,error)
    if (error) return
    call cubetools_consistency_integer_check(cons%nan,shape1%nan,shape2%nan,error)
    if (error) return
    !
    cons%prob = cons%maxdim%prob.or.cons%dim%prob.or.cons%l%prob.or.cons%m%prob&
         .or.cons%c%prob.or.cons%dat%prob.or.cons%nan%prob
  end subroutine cubetools_shape_consistency_check
  !
  subroutine cubetools_shape_consistency_list(cons,shape1,shape2,error)
    !----------------------------------------------------------------------
    ! Print array shape consistency
    !----------------------------------------------------------------------
    type(shape_cons_t), intent(in)    :: cons
    type(shape_t),      intent(in)    :: shape1
    type(shape_t),      intent(in)    :: shape2
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>CONSISTENCY>LIST'
    character(len=labe_l) :: label
    integer(kind=ndim_k) :: idim
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_title('shapes',3,cons%check,cons%prob,error)
    if (error) return
    if (cons%check.and.cons%prob) then
       call cubetools_consistency_integer_print('Max. dim.',&
            cons%maxdim,shape1%maxdim,shape2%maxdim,error)
       if (error) return
       call cubetools_consistency_integer_print('# of dim.',&
            cons%dim,shape1%dim,shape2%dim,error)
       if (error) return
       do idim=1,maxdim
          write (label,'(a,i0)') 'Axis #',idim
          call cubetools_consistency_integer_print(label,&
               cons%axis(idim),shape1%axis(idim),shape2%axis(idim),error)
          if (error) return
       enddo
       call cubetools_consistency_integer_print('# of px. in l',&
            cons%l,shape1%l,shape2%l,error)
       if (error) return
       call cubetools_consistency_integer_print('# of px. in m',&
            cons%m,shape1%m,shape2%m,error)
       if (error) return
       call cubetools_consistency_integer_print('# of channels',&
            cons%c,shape1%c,shape2%c,error)
       if (error) return
       call cubetools_consistency_integer_print('# of data el.',&
            cons%dat,shape1%dat,shape2%dat,error)
       if (error) return
       call cubetools_consistency_integer_print('# of NaN el.',&
            cons%nan,shape1%nan,shape2%nan,error)
       if (error) return
    endif
    call cubeheader_message(seve%r,rname,'')
  end subroutine cubetools_shape_consistency_list
  !
  subroutine cubetools_shape_consistency_final(cons,error)
    !----------------------------------------------------------------------
    ! Final array shape consistency
    !----------------------------------------------------------------------
    type(shape_cons_t), intent(out)   :: cons
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='SHAPE>CONSISTENCY>FINAL'
    integer(kind=ndim_k) :: idim
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    ! 
    call cubetools_consistency_final(cons%maxdim,error)
    if (error) return
    call cubetools_consistency_final(cons%dim,error)
    if (error) return
    do idim=1,maxdim
       call cubetools_consistency_final(cons%axis(idim),error)
       if (error) return
    enddo
    call cubetools_consistency_final(cons%l,error)
    if (error) return
    call cubetools_consistency_final(cons%m,error)
    if (error) return
    call cubetools_consistency_final(cons%c,error)
    if (error) return
    call cubetools_consistency_final(cons%dat,error)
    if (error) return
    call cubetools_consistency_final(cons%nan,error)
    if (error) return
  end subroutine cubetools_shape_consistency_final
end module cubetools_shape_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_command(line,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this => mrtcal_calib_command
  use mrtcal_parameters
  use mrtcal_buffers
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  ! CALIBRATE ient
  ! 1. /WITH ical
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  !
  integer(kind=entry_length) :: ientuser,icaluser
  character(len=*), parameter :: rname='CALIB>COMMAND'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_calib_or_solve_parse(line,ientuser,icaluser,error)
  if (error) return
  call mrtcal_calib_or_solve_ix_entry(code_command_calib,&
       rsetup,ix,ientuser,icaluser,rfile,rcalib,rscience,error)
  if (error) return
end subroutine mrtcal_calib_command
!
subroutine mrtcal_solve_command(line,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this => mrtcal_solve_command
  use mrtcal_parameters
  use mrtcal_buffers
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  ! SOLVE ient
  ! 1. /WITH ical
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  !
  integer(kind=entry_length) :: ientuser,icaluser
  character(len=*), parameter :: rname='CALIB>COMMAND'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_calib_or_solve_parse(line,ientuser,icaluser,error)
  if (error) return
  call mrtcal_calib_or_solve_ix_entry(code_command_solve,&
       rsetup,ix,ientuser,icaluser,rfile,rcalib,rscience,error)
  if (error) return
end subroutine mrtcal_solve_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mrtindex_table
  use gbl_message
  !---------------------------------------------------------------------
  ! This module offers a convenient tool to declare a table, dump header
  ! and write any many lines as desired, dealing with column alignment.
  !---------------------------------------------------------------------

  public :: table_t,line_t
  private

  integer(kind=4), parameter :: mcol=50      ! Up to 50 columns
  integer(kind=4), parameter :: line_l=1024  ! Max line length
  integer(kind=4), parameter :: colu_l=20    ! Max column width
  !
  type :: column_t
    character(len=colu_l) :: name
    character(len=colu_l) :: unit
    integer(kind=4)       :: width
    character(len=10)     :: format
  end type column_t
  !
  ! Buffer for 1 line
  type :: line_t
    integer(kind=4),       private :: icol=0  ! Last column printed in buffer
    character(len=line_l), private :: line=''
    integer(kind=4),       private :: ipos=1  ! Position in line buffer
  contains
    procedure, private :: new_cc    => line_new_cc
    procedure, private :: new_i4    => line_new_i4
    procedure, private :: new_r4    => line_new_r4
    procedure, private :: new_r8    => line_new_r8
    generic,   public  :: new_value => new_cc,new_i4,new_r4,new_r8
    procedure, public  :: list      => line_list
    procedure, public  :: reset     => line_reset
  end type line_t
  !
  type :: table_t
    integer(kind=4), private :: ncol=0
    type(column_t),  private :: col(mcol)
  contains
    procedure, public :: register_column => table_register_column
    procedure, public :: header          => table_header
  end type table_t
  !
contains
  !
  subroutine table_register_column(tab,name,unit,width,format,error)
    !-------------------------------------------------------------------
    ! Register a new column
    !-------------------------------------------------------------------
    class(table_t),   intent(inout) :: tab     !
    character(len=*), intent(in)    :: name    ! e.g. "Angle"
    character(len=*), intent(in)    :: unit    ! e.g. "[deg]"
    integer(kind=4),  intent(in)    :: width   ! e.g. 12 characters
    character(len=*), intent(in)    :: format  ! e.g. "1pg12.4"
    logical,          intent(inout) :: error   !
    ! Local
    character(len=*), parameter :: rname='REGISTER>COLUMN'
    !
    if (tab%ncol.ge.mcol) then
      call mrtindex_message(seve%e,rname,'Maximum number of columns exhausted')
      error = .true.
      return
    endif
    tab%ncol = tab%ncol+1
    tab%col(tab%ncol)%name = name
    tab%col(tab%ncol)%unit = unit
    tab%col(tab%ncol)%width = width
    tab%col(tab%ncol)%format = format
  end subroutine table_register_column
  !
  subroutine table_header(tab,olun,error)
    !-------------------------------------------------------------------
    ! Display the header, i.e. several comment lines with:
    !   - column numbers
    !   - column names
    !   - column units
    !-------------------------------------------------------------------
    class(table_t),  intent(in)    :: tab
    integer(kind=4), intent(in)    :: olun
    logical,         intent(inout) :: error
    !
    character(len=line_l) :: line1,line2,line3
    character(len=colu_l) :: tmp
    integer(kind=4) :: ipos,icol,wid
    logical :: first
    !
    line1 = '!'
    line2 = '!'
    line3 = '!'
    first  = .true.
    ipos = 2
    do icol=1,tab%ncol
      wid = tab%col(icol)%width
      ! Numbering
      write(tmp,'(i0)')  icol
      line1(ipos:ipos+wid-1) = recenter(tmp,wid)
      ! Name
      line2(ipos:ipos+wid-1) = recenter(tab%col(icol)%name,wid)
      ! Name
      line3(ipos:ipos+wid-1) = recenter(tab%col(icol)%unit,wid)
      if (first) then
        ipos = ipos+wid  ! Because we shifted the alignment by 1 because of the leading '!'
        first = .false.
      else
        ipos = ipos+wid+1
      endif
    enddo
    !
    line1(1:1) = '!'
    line2(1:1) = '!'
    line3(1:1) = '!'
    !
    write(olun,'(a)')  line1(1:ipos)
    write(olun,'(a)')  line2(1:ipos)
    write(olun,'(a)')  line3(1:ipos)
  end subroutine table_header
  !
  function recenter(string,width)
    !-------------------------------------------------------------------
    ! Return a string so that the input string is centered among 'width'
    ! characters.
    !-------------------------------------------------------------------
    character(len=colu_l) :: recenter  ! Function value on return
    character(len=*), intent(in) :: string
    integer(kind=4),  intent(in) :: width
    !
    integer(kind=4) :: nc,fc
    !
    nc = len_trim(string)
    if (nc.ge.width) then
      recenter = string(1:nc)
      return
    endif
    !
    fc = (width-nc)/2+1
    recenter(1:fc-1) = ' '
    recenter(fc:) = string(1:nc)
  end function recenter
  !
  subroutine line_new_cc(line,tab,cc,error)
    !-------------------------------------------------------------------
    ! Print a new value in the line buffer
    !-------------------------------------------------------------------
    class(line_t),    intent(inout) :: line
    type(table_t),    intent(in)    :: tab
    character(len=*), intent(in)    :: cc
    logical,          intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LINE>NEW>CC'
    integer(kind=4) :: wid
    !
    if (line%icol.ge.tab%ncol) then
      call mrtindex_message(seve%e,rname,'Maximum number of values exhausted')
      error = .true.
      return
    endif
    !
    line%icol = line%icol+1
    wid = tab%col(line%icol)%width
    write(line%line(line%ipos:line%ipos+wid-1),tab%col(line%icol)%format) cc
    line%ipos = line%ipos+wid+1
  end subroutine line_new_cc
  !
  subroutine line_new_i4(line,tab,i4,error)
    !-------------------------------------------------------------------
    ! Print a new value in the line buffer
    !-------------------------------------------------------------------
    class(line_t),   intent(inout) :: line
    type(table_t),   intent(in)    :: tab
    integer(kind=4), intent(in)    :: i4
    logical,         intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LINE>NEW>I4'
    integer(kind=4) :: wid
    !
    if (line%icol.ge.tab%ncol) then
      call mrtindex_message(seve%e,rname,'Maximum number of values exhausted')
      error = .true.
      return
    endif
    !
    line%icol = line%icol+1
    wid = tab%col(line%icol)%width
    write(line%line(line%ipos:line%ipos+wid-1),tab%col(line%icol)%format) i4
    line%ipos = line%ipos+wid+1
  end subroutine line_new_i4
  !
  subroutine line_new_r4(line,tab,r4,error)
    !-------------------------------------------------------------------
    ! Print a new value in the line buffer
    !-------------------------------------------------------------------
    class(line_t), intent(inout) :: line
    type(table_t), intent(in)    :: tab
    real(kind=4),  intent(in)    :: r4
    logical,       intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LINE>NEW>R4'
    integer(kind=4) :: wid
    !
    if (line%icol.ge.tab%ncol) then
      call mrtindex_message(seve%e,rname,'Maximum number of values exhausted')
      error = .true.
      return
    endif
    !
    line%icol = line%icol+1
    wid = tab%col(line%icol)%width
    write(line%line(line%ipos:line%ipos+wid-1),tab%col(line%icol)%format) r4
    line%ipos = line%ipos+wid+1
  end subroutine line_new_r4
  !
  subroutine line_new_r8(line,tab,r8,error)
    !-------------------------------------------------------------------
    ! Print a new value in the line buffer
    !-------------------------------------------------------------------
    class(line_t), intent(inout) :: line
    type(table_t), intent(in)    :: tab
    real(kind=8),  intent(in)    :: r8
    logical,       intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LINE>NEW>R8'
    integer(kind=4) :: wid
    !
    if (line%icol.ge.tab%ncol) then
      call mrtindex_message(seve%e,rname,'Maximum number of values exhausted')
      error = .true.
      return
    endif
    !
    line%icol = line%icol+1
    wid = tab%col(line%icol)%width
    write(line%line(line%ipos:line%ipos+wid-1),tab%col(line%icol)%format) r8
    line%ipos = line%ipos+wid+1
  end subroutine line_new_r8
  !
  subroutine line_list(line,olun,error)
    !-------------------------------------------------------------------
    ! Dump the current line buffer
    !-------------------------------------------------------------------
    class(line_t),   intent(inout) :: line
    integer(kind=4), intent(in)    :: olun
    logical,         intent(inout) :: error
    !
    write(olun,'(a)') line%line(1:line%ipos)
    line%icol = 0
    line%line = ''
    line%ipos = 1
  end subroutine line_list
  !
  subroutine line_reset(line,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(line_t),   intent(out)   :: line
    logical,         intent(inout) :: error
    ! Done with intent(out)
  end subroutine line_reset
end module mrtindex_table

subroutine rix(entry_num,ind,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>rix
  use class_common
  use class_types
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Read an Entry Index in the input file
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)  :: entry_num  ! Entry number
  type(indx_t),               intent(out) :: ind        !
  logical,                    intent(out) :: error      ! Logical error flag
  !
  error = .false.
  !
  if (filein_isvlm) then
    call index_fromgdf(filein_vlmhead,entry_num,ind,error)
    if (error)  return
  else
    ! Read the index of entry_num in idatabi(:)
    call classic_entryindex_read(filein,entry_num,idatabi,ibufbi,error)
    if (error)  return
    !
    ! Fill ind% from idatabi(:), convert bytes if needed
    if (filein%desc%vind.eq.vind_v3) then
      call index_frombuf_v2orv3(idatabi,.true.,ind,filein%conv,error)
    elseif (filein%desc%vind.eq.vind_v2) then
      call index_frombuf_v2orv3(idatabi,.false.,ind,filein%conv,error)
    elseif (filein%desc%vind.eq.vind_v1) then
      call index_frombuf_v1(idatabi,ind,filein%conv,error)
    else
      call class_message(seve%e,'RIX','Index version not implemented')
      error = .true.
      return
    endif
    if (error)  return
  endif
  !
  ! No update of IX%, this was only a read access
  !
end subroutine rix
!
subroutine rox(entry_num,ind,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>rox
  use class_common
  use class_types
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Read an Entry Index in the output file
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)  :: entry_num  ! Entry number
  type(indx_t),               intent(out) :: ind        !
  logical,                    intent(out) :: error      ! Logical errror flag
  !
  error = .false.
  !
  ! Read the index of entry_num in odatabi(:)
  call classic_entryindex_read(fileout,entry_num,odatabi,obufbi,error)
  if (error)  return
  !
  ! Fill ind% from odatabi(:), convert bytes if needed
  if (fileout%desc%vind.eq.vind_v3) then
    call index_frombuf_v2orv3(odatabi,.true.,ind,fileout%conv,error)
  elseif (fileout%desc%vind.eq.vind_v2) then
    call index_frombuf_v2orv3(odatabi,.false.,ind,fileout%conv,error)
  elseif (fileout%desc%vind.eq.vind_v1) then
    call index_frombuf_v1(odatabi,ind,fileout%conv,error)
  else
    call class_message(seve%e,'ROX','Index version not implemented')
    error = .true.
    return
  endif
  if (error)  return
  !
  ! No update of OX%, this was only a read access
  !
end subroutine rox
!
subroutine wox(ind,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>wox
  use class_common
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Write a new Entry Index in the output file
  !---------------------------------------------------------------------
  type(indx_t), intent(in)    :: ind    !
  logical,      intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='WOX'
  integer(kind=entry_length) :: entry_num
  !
  entry_num = fileout%desc%xnext
  if (entry_num.gt.ox%mobs) then
    ! Enlarge the Output File Index. Use a factor 2 (NB: ox%mobs can be
    ! 0 if an old (but empty) output file was reopened)
    call reallocate_optimize(ox,max(class_idx_size,ox%mobs*2_8),.false.,  &
      .true.,error)
    if (error)  return
  endif
  if (filein_is_fileout() .and. entry_num.gt.ix%mobs) then
    ! Same if FILE BOTH
    call reallocate_optimize(ix,max(class_idx_size,ix%mobs*2_8),.true.,  &
      .true.,error)
    if (error)  return
  endif
  !
  ! Fill odatabi(:) from ind%, convert bytes if needed
  if (fileout%desc%vind.eq.vind_v3) then
    call index_tobuf_v2orv3(ind,.true.,odatabi,fileout%conv,error)
  elseif (fileout%desc%vind.eq.vind_v2) then
    call index_tobuf_v2orv3(ind,.false.,odatabi,fileout%conv,error)
  elseif (fileout%desc%vind.eq.vind_v1) then
    call index_tobuf_v1(ind,odatabi,fileout%conv,error)
  else
    call class_message(seve%e,rname,'Index version not implemented')
    error = .true.
    return
  endif
  if (error)  return
  !
  ! Write the index of entry_num stored in odatabi(:)
  call classic_entryindex_write(fileout,entry_num,odatabi,obufbi,error)
  if (error)  return
  !
  ! Update optimize'd list of Indexes
  call index_tooptimize(ind,entry_num,.false.,entry_num,ox,error)
  if (error)  return
  ox%next = entry_num+1
  if (filein_is_fileout()) then
    call index_tooptimize(ind,entry_num,.true.,entry_num,ix,error)
    if (error)  return
    ix%next = entry_num+1
    ! Must force "forgetting" the record currently buffered in ibufbi,
    ! because the same record may have changed on disk
    call classic_recordbuf_nullify(ibufbi)
  endif
  !
  fileout%desc%xnext = entry_num+1
  !
end subroutine wox
!
subroutine mox(entry_num,ind,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>mox
  use class_common
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Modify an old Entry Index in the output file
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)    :: entry_num  !
  type(indx_t),               intent(in)    :: ind        !
  logical,                    intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='MOX'
  character(len=message_length) :: mess
  !
  if (entry_num.ge.fileout%desc%xnext) then
     error = .true.
     write(mess,'(A,I0)') 'Wrong entry number #',entry_num
     call class_message(seve%e,rname,mess)
     return
  endif
  !
  ! Fill odatabi(:) from ind%, convert bytes if needed
  if (fileout%desc%vind.eq.vind_v3) then
    call index_tobuf_v2orv3(ind,.true.,odatabi,fileout%conv,error)
  elseif (fileout%desc%vind.eq.vind_v2) then
    call index_tobuf_v2orv3(ind,.false.,odatabi,fileout%conv,error)
  elseif (fileout%desc%vind.eq.vind_v1) then
    call index_tobuf_v1(ind,odatabi,fileout%conv,error)
  else
    call class_message(seve%e,rname,'Index version not implemented')
    error = .true.
    return
  endif
  if (error)  return
  !
  ! Write the index of entry_num stored in odatabi(:)
  call classic_entryindex_write(fileout,entry_num,odatabi,obufbi,error)
  if (error)  return
  !
  call index_tooptimize(ind,entry_num,.false.,entry_num,ox,error)
  if (error)  return
  if (filein_is_fileout()) then
    call index_tooptimize(ind,entry_num,.true.,entry_num,ix,error)
    if (error)  return
  endif
  !
end subroutine mox
!
subroutine cox(error)
  use gbl_convert
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>cox
  use class_common
  !---------------------------------------------------------------------
  ! @ private
  ! Close an observation in the output file index
  !---------------------------------------------------------------------
  logical, intent(out) :: error
  ! Local
  character(len=*), parameter :: rname='COX'
  !
  if (.not.fileout_opened(rname,error))  return
  !
  ! Write the updated File Index to the file (in particular desc%xnext)
  call classic_filedesc_write(fileout,error)
  ! if (error) continue
  !
  ! Disable the following line, this would kill the 'classic_recordbuf_open'
  ! optimization which does not re-read a record which is already in memory.
  ! This optimization is usefull when writing indexes since they are small
  ! block of data contiguous in the same (often) record. Since 'obufbi'
  ! is only used for this purpose, this should not add any problem.
  ! call classic_recordbuf_nullify(obufbi)
  !
  if (filein_is_fileout()) then
    ! call classic_recordbuf_nullify(ibufbi)
    filein%desc = fileout%desc
  endif
  !
end subroutine cox

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_cal_mod
  use gbl_message
  use image_def
  use gkernel_interfaces
  !
  public :: uv_cal_command
  private
  !
  type uv_daps_t
     integer(kind=4) :: iori = 0 ! Origin indice before sorting
     !
     real(kind=4)    :: u = 0
     real(kind=4)    :: v = 0
     integer(kind=4) :: iant = 0
     integer(kind=4) :: jant = 0
     integer(kind=4) :: antmin = 0
     integer(kind=4) :: antmax = 0
     integer(kind=4) :: date = 0.0
     real(kind=4)    :: time = 0.0
     !
     integer(kind=4), allocatable :: idx(:)
     integer(kind=4), allocatable :: rdx(:)
     real(kind=8),    allocatable :: key(:)
   contains
     procedure :: allocate => daps_allocate
     procedure :: get      => daps_get
  end type uv_daps_t
  !
  type uv_data_t
     integer(kind=4)           :: ncol,nchan,nvisi   ! Size of the UV buffer
     real(kind=4), pointer     :: uv(:,:) => null()  ! [ncol,nvisi] Pointer to UV buffer
     logical                   :: usevisifreq        ! Which frequency array to use?
     ! Columns which are simple pointers to UV buffer
     ! TBD
     ! Columns which can not be pointers (modified information)
     real(kind=8), allocatable :: chanfreq(:)        ! [nchan] Frequency at each channel
     real(kind=8), allocatable :: visifreq(:)        ! [nvisi] Ref. frequency for each visibility
  contains
     procedure :: get  => uv_data_get
     procedure :: copy => uv_data_copy
     procedure :: put  => uv_data_put
     procedure :: freq => uv_data_freq
  end type uv_data_t
  !
  type uv_atom_t
     complex(kind=4) :: val
     real(kind=4)    :: wei
   contains
     procedure, public :: getfrom    => uv_atom_getfrom
     procedure, public :: putinto    => uv_atom_putinto
     procedure, public :: apply_gain => uv_atom_apply_gain
  end type uv_atom_t
  !
contains
  !
  !------------------------------------------------------------------------
  !
  subroutine daps_allocate(daps,nvisi,error)
    !----------------------------------------------------------------------
    ! ***JP: Should be CUBE array types to avoid writing specific code here
    !----------------------------------------------------------------------
    class(uv_daps_t), intent(inout) :: daps
    integer(kind=4),  intent(in)    :: nvisi
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='DAPS>ALLOCATE'
    !
    if (nvisi.le.0) then
       call map_message(seve%e,rname,'Zero or negative number of visibilities')
       error = .true.
       return
    endif
    allocate(daps%idx(nvisi),daps%rdx(nvisi),daps%key(nvisi),stat=ier)
    if (failed_allocate(rname,'daps',ier,error)) return
  end subroutine daps_allocate
  !
  subroutine daps_get(daps,uvt,icur)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(uv_daps_t), intent(inout) :: daps
    type(uv_data_t),  intent(in)    :: uvt
    integer(kind=4),  intent(in)    :: icur
    !
    integer(kind=4), parameter :: ucol    = 1  ! hx%gil%column_pointer(code_uvt_u)
    integer(kind=4), parameter :: vcol    = 2  ! hx%gil%column_pointer(code_uvt_v)
    integer(kind=4), parameter :: datecol = 4  ! hx%gil%column_pointer(code_uvt_date)
    integer(kind=4), parameter :: timecol = 5  ! hx%gil%column_pointer(code_uvt_time)
    integer(kind=4), parameter :: anticol = 6  ! hx%gil%column_pointer(code_uvt_anti)
    integer(kind=4), parameter :: antjcol = 7  ! hx%gil%column_pointer(code_uvt_antj)
    !
    daps%iori = daps%idx(icur)
    daps%u = uvt%uv(ucol,daps%iori)
    daps%v = uvt%uv(vcol,daps%iori)
    daps%iant = nint(uvt%uv(anticol,daps%iori))
    daps%jant = nint(uvt%uv(antjcol,daps%iori))
    if (daps%iant.lt.daps%jant) then
       daps%antmin = daps%iant
       daps%antmax = daps%jant
    else
       daps%antmin = daps%jant
       daps%antmax = daps%iant
    endif
    daps%date = nint(uvt%uv(datecol,daps%iori))
    daps%time = uvt%uv(timecol,daps%iori)
  end subroutine daps_get
  !
  !------------------------------------------------------------------------
  !
  subroutine uv_data_get(uvd,uvt,nvisi,init,error)
    !----------------------------------------------------------------------
    ! Get a r2d UV buffer into a uv_data_t and compute the 'freq'
    ! column
    ! Note 1: the uvt%r2d buffer may contain only a subset of all the
    !         visibilities.
    ! Note 2: the uvt%r2d buffer may be larger than the actual nvisi to
    !         be used.
    !----------------------------------------------------------------------
    class(uv_data_t), intent(inout) :: uvd
    type(gildas),     intent(in)    :: uvt
    integer(kind=8),  intent(in)    :: nvisi
    logical,          intent(in)    :: init  ! Getting old or new data which needs init?
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ier,cfreq
    integer(kind=8) :: ichan,iv
    logical :: offfreqs
    character(len=*), parameter :: rname='UV>DATA>GET'
    !
    ! Pointer to UV data buffer
    uvd%ncol  = uvt%gil%dim(1)
    uvd%nchan = uvt%gil%nchan
    uvd%nvisi = nvisi
    uvd%uv => uvt%r2d(1:uvd%ncol,1:uvd%nvisi)
    if (init) then
      ! uvd%uv(:,:) = 0.  ! Useless, will be overwritten when filling visibilities
    endif
    !
    ! Compute the array of spectral channel frequencies
    if (allocated(uvd%chanfreq))  deallocate(uvd%chanfreq)
    allocate(uvd%chanfreq(uvd%nchan),stat=ier)
    if (failed_allocate(rname,'chan freq',ier,error)) return
    do ichan=1,uvd%nchan
       uvd%chanfreq(ichan) = gdf_uv_frequency(uvt,real(ichan,kind=8))
    enddo ! ichan
    !
    ! Create the reference frequency column (1 per visibility), either from
    ! the offset frequency DAPS column or from scratch.
    if (allocated(uvd%visifreq))  deallocate(uvd%visifreq)
    allocate(uvd%visifreq(uvd%nvisi),stat=ier)
    if (failed_allocate(rname,'freq array',ier,error)) return
    cfreq = uvt%gil%column_pointer(code_uvt_freq)
    offfreqs = .false.  ! Offset frequencies are not relevant
    if (init .or. cfreq.eq.0) then
      ! Fallback: header frequency is used for all visibilities
      uvd%visifreq(:) = uvt%gil%val(uvt%gil%faxi)
    else
      ! Use offset frequencies (but relevant only if non-zero)
      do iv=1,uvd%nvisi
        if (uvd%uv(cfreq,iv).ne.0.0)  offfreqs = .true.
        uvd%visifreq(iv) = uvt%gil%val(uvt%gil%faxi) + uvd%uv(cfreq,iv)  ! From offset freq to absolute freq.
      enddo
    endif
    !
    ! Guess which of the 'chanfreq' or 'visifreq' is to be used (this
    ! basically means guessing if facing a continuum or line table).
    if (offfreqs .and. uvd%nchan.gt.1) then
      call map_message(seve%e,rname,  &
        'Not implemented: line table with non-zero frequency column in DAPS')
      error = .true.
      return
    endif
    ! Note that line tables can have only one channel. The right test is
    ! the following one since line tables are never expected to provide
    ! a non-zero frequency column in DAPS.
    uvd%usevisifreq = offfreqs
  end subroutine uv_data_get
  !
  function uv_data_freq(uvd,ichan,ivisi)
    !-------------------------------------------------------------------
    ! Return the frequency associated to the given channel and given
    ! visibility.
    !-------------------------------------------------------------------
    real(kind=8) :: uv_data_freq
    class(uv_data_t), intent(in) :: uvd
    integer(kind=4),  intent(in) :: ichan
    integer(kind=4),  intent(in) :: ivisi
    if (uvd%usevisifreq) then
      uv_data_freq = uvd%visifreq(ivisi)
    else
      uv_data_freq = uvd%chanfreq(ichan)
    endif
  end function uv_data_freq
  !
  subroutine uv_data_copy(in,ou,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(uv_data_t), intent(in)    :: in
    type(uv_data_t),  intent(inout) :: ou
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='UV>DATA>COPY'
    !
    ! Sanity check
    if (in%nvisi.ne.ou%nvisi) then
      call map_message(seve%e,rname,'Incompatible number of visibilities')
      error = .true.
      return
    endif
    if (in%nchan.ne.ou%nchan) then
      call map_message(seve%e,rname,'Incompatible number of visibilities')
      error = .true.
      return
    endif
    ! DAPS:
    !  - the leading DAPS are assumed to be compatible
    !  - the input trailing DAPS are assumed to be present and
    !    compatible with the output first trailing DAPS. But there can
    !    be more trailing DAPS as output (e.g. the FREQ column which could
    !    have been added in prepare_uvt_as)
    if (ou%ncol.lt.in%ncol) then
      call map_message(seve%e,rname,'Incompatible number of columns')
      error = .true.
      return
    endif
    !
    ! Now copy:
    ou%uv(1:in%ncol,:) = in%uv(1:in%ncol,:)
    ou%visifreq(:)     = in%visifreq(:)
  end subroutine uv_data_copy
  !
  subroutine uv_data_put(uvd,uvt,error)
    !----------------------------------------------------------------------
    ! Put a uv_data_t to a r2d UV buffer and compute the 'freq'
    ! column
    ! Note 1: the uvt%r2d buffer may contain only a subset of all the
    !         visibilities.
    ! Note 2: the uvt%r2d buffer may be larger than the actual nvisi to
    !         be used.
    !----------------------------------------------------------------------
    class(uv_data_t), intent(inout) :: uvd
    type(gildas),     intent(in)    :: uvt
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: cfreq
    integer(kind=8) :: iv
    character(len=*), parameter :: rname='UV>DATA>PUT'
    !
    ! I) From uvd%uv to uvt%r2d:
    !  => nothing to be done thanks to one pointing to the other
    !
    ! II) Frequency column
    cfreq = uvt%gil%column_pointer(code_uvt_freq)
    if (cfreq.le.0) then
      call map_message(seve%e,rname,'Internal error: no frequency DAPS column')
      error = .true.
      return
    endif
    !
    do iv=1,uvd%nvisi
      uvt%r2d(cfreq,iv) = uvd%visifreq(iv)-uvt%gil%val(uvt%gil%faxi)
    enddo
  end subroutine uv_data_put
  !
  !------------------------------------------------------------------------
  !
  subroutine uv_atom_getfrom(atom,data,ivis,ichan)
    !-----------------------------------------------------------------
    !
    !-----------------------------------------------------------------
    class(uv_atom_t), intent(inout) :: atom
    type(uv_data_t),  intent(in)    :: data
    integer(kind=4),  intent(in)    :: ivis
    integer(kind=4),  intent(in)    :: ichan
    !
    integer(kind=4) :: icol
    !
    icol = 3*(ichan-1)+8
    atom%val = cmplx(data%uv(icol,ivis),data%uv(icol+1,ivis))
    atom%wei = data%uv(icol+2,ivis)
  end subroutine uv_atom_getfrom
  !
  subroutine uv_atom_putinto(atom,data,ivis,ichan)
    !-----------------------------------------------------------------
    !
    !-----------------------------------------------------------------
    class(uv_atom_t), intent(in)    :: atom
    type(uv_data_t),  intent(inout) :: data
    integer(kind=4),  intent(in)    :: ivis
    integer(kind=4),  intent(in)    :: ichan
    !
    integer(kind=4) :: icol
    !
    icol = 3*(ichan-1)+8
    data%uv(icol,  ivis) = real(atom%val)
    data%uv(icol+1,ivis) = aimag(atom%val)
    data%uv(icol+2,ivis) = atom%wei
  end subroutine uv_atom_putinto
  !
  subroutine uv_atom_apply_gain(cal,raw,zgain)
    !-----------------------------------------------------------------
    !
    !-----------------------------------------------------------------
    class(uv_atom_t), intent(inout) :: cal
    type(uv_atom_t),  intent(in)    :: raw
    complex(kind=4),  intent(in)    :: zgain
    !
    cal%val = raw%val/zgain
    cal%wei = raw%wei*abs(zgain)**2
  end subroutine uv_atom_apply_gain
  !
  !------------------------------------------------------------------------
  !
  subroutine uv_cal_command(error)
    !----------------------------------------------------------------------
    ! Apply gains from a table to another table.
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    type(gildas) :: raw,cal,gain
    logical :: doflag
    real(kind=8) :: phafactor,ampfactor
    integer(kind=4) :: ier,ncol,ivisi,mvisi,lvisi
    character(len=filename_length) :: rawname,gainname,calname
    character(len=message_length) :: mess
    type(uv_data_t) :: uvg,uvd,uvc
    character(len=*), parameter :: rname='UV>CAL>COMMAND'
    !
    ! Parse input
    call gildas_open
    call gildas_char('UVDATA$',rawname)
    call gildas_char('UVGAIN$',gainname)
    call gildas_char('UVCAL$',calname)
    call gildas_dble('AMPLI_GAIN$',ampfactor,1)
    call gildas_dble('PHASE_GAIN$',phafactor,1)
    call gildas_logi('FLAG$',doflag,1)
    call gildas_close
    !
    ! Prepare input and output
    call get_uvt(raw,'input',rawname,error)
    if (error) goto 10
    call get_uvt(gain,'gain',gainname,error,uvd=uvg)
    if (error) goto 10
    call prepare_uvt_as(cal,'calibrated',calname,raw,error)
    if (error) goto 10
    !
    ncol = raw%gil%dim(1)
    !
    ! Define the number of visibilities (mvisi) to be treated by block on
    ! the input data assuming that it is the largest one
    call gdf_nitems('SPACE_GILDAS',mvisi,ncol)
    mvisi = min(mvisi,raw%gil%nvisi)
    ! Allocate the associated space
    allocate(raw%r2d(raw%gil%dim(1),mvisi),cal%r2d(cal%gil%dim(1),mvisi),stat=ier)
    if (failed_allocate(rname,'uv table',ier,error)) goto 10
    !
    ! Loop over block of visibilities of the raw/cal table
    raw%blc = 0
    raw%trc = 0
    cal%blc = 0
    cal%trc = 0
    do ivisi=1,raw%gil%nvisi,mvisi
       write(mess,*) ivisi,' / ',raw%gil%nvisi,mvisi
       call map_message(seve%d,rname,mess)
       !
       ! Read data
       raw%blc(2) = ivisi
       raw%trc(2) = min(raw%gil%nvisi,ivisi-1+mvisi)
       cal%blc = raw%blc
       cal%trc = raw%trc
       call gdf_read_data(raw,raw%r2d,error)
       if (error) goto 10
       lvisi = raw%trc(2)-raw%blc(2)+1
       call uvd%get(raw,int(lvisi,kind=8),.false.,error)
       if (error) goto 10
       call uvc%get(cal,int(lvisi,kind=8),.true.,error)
       if (error) goto 10
       !
       ! Calibrate
       call uv_cal_main(uvd,uvc,uvg,ampfactor,phafactor,doflag,error)
       if (error) goto 10
       !
       ! Write data
       call uvc%put(cal,error)
       if (error) goto 10
       call gdf_write_data(cal,cal%r2d,error)
       if (error) goto 10
    enddo ! ivisi
    !
    ! Clean
10  call gdf_close_image(cal,error)
    call gdf_close_image(raw,error)
    if (associated(raw%r2d))  deallocate(raw%r2d)
    if (associated(cal%r2d))  deallocate(cal%r2d)
    if (associated(gain%r2d)) deallocate(gain%r2d)
    !
  contains
    !
    subroutine get_uvt(uvt,kind,name,error,uvd)
      type(gildas),              intent(inout) :: uvt
      character(len=*),          intent(in)    :: kind
      character(len=*),          intent(in)    :: name
      logical,                   intent(inout) :: error
      type(uv_data_t), optional, intent(inout) :: uvd
      !
      integer(kind=4) :: n
      character(len=filename_length) :: shortname
      !
      n = len_trim(name)
      if (n.le.0) return
      shortname = name(1:n)
      call gildas_null(uvt,type='UVT')
      call gdf_read_gildas(uvt,shortname,'.uvt',error,data=present(uvd))
      if (error) then
         call map_message(seve%e,rname,'Cannot read '//trim(kind)//'uv table')
         return
      endif
      !
      if (.not.present(uvd))  return
      call uvd%get(uvt,uvt%gil%nvisi,.false.,error)
      if (error)  return
    end subroutine get_uvt
    !
    subroutine prepare_uvt_as(ou,kind,name,in,error)
      type(gildas),     intent(inout) :: ou
      character(len=*), intent(in)    :: kind
      character(len=*), intent(in)    :: name
      type(gildas),     intent(in)    :: in
      logical,          intent(inout) :: error 
      !
      integer(kind=4) :: n
      character(len=filename_length) :: shortname
      !
      ! Set up header
      call gildas_null(ou,type='UVT')
      call gdf_copy_header(in,ou,error)
      if (error) return
      if (ou%gil%column_pointer(code_uvt_freq).gt.0) then
        ! Frequency column already present => nothing to do
      else
        call map_message(seve%i,rname,'Adding frequency offset column in DAPS')
        ! hcuv%gil%ntrail = huv%gil%ntrail+1  ! Not needed (automatic?)
        ou%gil%dim(1) = ou%gil%dim(1)+1
        ou%gil%column_pointer(code_uvt_freq) = ou%gil%dim(1)
        ou%gil%column_size(code_uvt_freq) = 1
      endif
      !
      ! Set up file
      n = len_trim(name)
      if (n.eq.0) return
      shortname = name(1:n)
      call sic_parsef(shortname,ou%file,' ','.uvt')
      call map_message(seve%i,rname,'Creating '//trim(kind)//' uv table '//trim(ou%file))
      call gdf_create_image(ou,error)
      if (error) then
         call map_message(seve%e,rname,'Cannot create '//trim(kind)//' uv table')
         return
      endif
    end subroutine prepare_uvt_as
  end subroutine uv_cal_command
  !
  subroutine uv_cal_main(raw,cal,gain,ampfactor,phafactor,doflag,error)
    use gkernel_interfaces
    use uv_sort, only: uv_findtb
    use uv_sort_codes
    !---------------------------------------------------------------------
    ! Apply phase and/or amplitude calibration to the raw uv table.  Phase
    ! and amplitudes are stored in the gain uv table, and usually come from
    ! a previous use of task UV_GAIN. This subroutine allows to apply the
    ! corrections to a spectral line table, whatever the way the gains were
    ! computed before.
    !
    ! The antenna numbers must match those of the gain table.  There is no
    ! specific verification about this.
    !
    ! ***JP: For the moment, we are sorting the gain table several times
    ! ***JP: when the problem does not fit in memory!
    !---------------------------------------------------------------------
    type(uv_data_t), intent(in)    :: raw        ! Raw visibilities
    type(uv_data_t), intent(inout) :: cal        ! Calibrated visibilities
    type(uv_data_t), intent(in)    :: gain       ! Gain array
    real(kind=8),    intent(in)    :: ampfactor  ! Amplitude factor
    real(kind=8),    intent(in)    :: phafactor  ! Phase factor
    logical,         intent(in)    :: doflag     ! Flag visibilities without good gain solution?
    logical,         intent(inout) :: error
    !
    logical :: sorted,matched,outofrange,found
    logical :: flagged(cal%nvisi)
    integer(kind=4) :: cnt
    integer(kind=4) :: igainfirst,igainlast
    integer(kind=4) :: iraw,ical
    type(uv_daps_t) :: onerawdaps,onegaindaps
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='UV>CAL>MAIN'
    !
    call onerawdaps%allocate(raw%nvisi,error)
    if (error) return
    call onegaindaps%allocate(gain%nvisi,error)
    if (error) return
    !
    ! Get the chronological order, for both input tables. Tables are
    ! ordered by UNIQUE-BASE then TIME (because time is a fuzzy argument,
    ! with a tolerance when matching), then FREQ (because continuum table
    ! might have been split into several visibilities for each BASE+TIME).
    ! This ensures that matches will be contiguous, and they can also be
    ! optimized.
    call uv_findtb(code_sort_ubtf,&
                   raw%uv,raw%nvisi,raw%ncol,&
                   onerawdaps%key,onerawdaps%idx,onerawdaps%rdx,sorted,&
                   error,&
                   freq=raw%visifreq)
    if (error) return
    call uv_findtb(code_sort_ubtf,&
                   gain%uv,gain%nvisi,gain%ncol,&
                   onegaindaps%key,onegaindaps%idx,onegaindaps%rdx,sorted,&
                   error,&
                   freq=gain%visifreq)
    if (error) return
    ! NB: oneraw%key and onegain%key can not be used hereafter because they can
    !     use different relative dates.
    !
    ! First setup CAL = RAW by default
    ! Leading DAPS + channels + trailing DAPS. Uncalibrated data will be kept
    ! or flagged as desired
    call raw%copy(cal,error)
    if (error)  return
    !
    ! The loop is done on calibration times, so there is no guarantee that
    ! a given data visibility is treated.  To handle this, we set a counter
    ! for each visibility, to check whether it has indeed been affected...
    flagged(1:cal%nvisi) = .true.
    igainfirst = 0
    igainlast  = 0
    !
    ! Loop on visibilities
    do iraw=1,raw%nvisi
       ! Get visibility daps
       call onerawdaps%get(raw,iraw)
       ! Check whether the current gain range matches base and datetime
       call does_current_gain_range_match(igainlast,gain,onerawdaps,onegaindaps,outofrange,matched)
       if (outofrange) then
          call map_message(seve%e,rname,'Programming error => Try to access gain range out of its range')
          error = .true.
          return
       endif
       if (.not.matched) then
          ! Find the next gain range that matches base and datetime
          call find_next_matching_gain_range(gain,onerawdaps,onegaindaps,igainfirst,igainlast,found)
          if (.not.found) then
             call map_message(seve%e,rname,'Did not succeed to match uv and gain tables')
             error = .true.
             return
          endif
       endif
       ! Now we need to apply the correct gain for each channel frequency
       call apply_gain_for_each_frequency_within_gain_range(onerawdaps,onegaindaps,gain,igainfirst,igainlast,&
            iraw,raw,cal,flagged)
    enddo ! iraw
    !
    ! Finish by checking what has not been calibrated
    if (any(flagged)) then
       cnt = 0
       if (doflag) then
          ! Uncalibrated data are nullified
          do ical=1,cal%nvisi
             if (flagged(ical)) then
                ! print *,ical  ! Too verbose...
                cnt = cnt+1
                cal%uv(8:3*raw%nchan+7,ical) = 0.0
             endif
          enddo ! ical
          write(mess,'(3(A,I0))') &
               'Flagged ',cnt,' uncalibrated visibilities (over ',cal%nvisi,')'
       else
          ! Uncalibrated data is left unmodified
          do ical=1,cal%nvisi
             if (flagged(ical)) then
                cnt = cnt+1
                ! print *,ical  ! Too verbose...
             endif
          enddo ! ical
          write(mess,'(3(A,I0))') &
               'Remaining ',cnt,' uncalibrated visibilities (over ',cal%nvisi,')'
       endif
       call map_message(seve%w,rname,mess)
    endif
    !
  contains
    !
    subroutine does_current_gain_range_match(ilast,gain,onerawdaps,onegaindaps,outofrange,matched)
      !-------------------------------------------------------------------
      ! 
      !-------------------------------------------------------------------
      integer(kind=4), intent(in)    :: ilast
      type(uv_data_t), intent(in)    :: gain
      type(uv_daps_t), intent(in)    :: onerawdaps
      type(uv_daps_t), intent(inout) :: onegaindaps
      logical,         intent(out)   :: outofrange
      logical,         intent(out)   :: matched
      !
      integer(kind=4) :: diff
      !
      if ((ilast.lt.0).or.(ilast.gt.gain%nvisi)) then
         outofrange = .true.
         matched = .false.
         return
      endif
      outofrange = .false.
      if (ilast.eq.0) then
         matched = .false.
      else
         ! Compare visibility and gain base and datetime of current range
         call onegaindaps%get(gain,ilast)
         call compare_base_datetime(onerawdaps,onegaindaps,diff)
         matched = (diff.eq.0)
      endif
    end subroutine does_current_gain_range_match
    !
    subroutine find_next_matching_gain_range(gain,onerawdaps,onegaindaps,ifirst,ilast,found)
      !-------------------------------------------------------------------
      ! 
      !-------------------------------------------------------------------
      type(uv_data_t), intent(in)    :: gain
      type(uv_daps_t), intent(in)    :: onerawdaps
      type(uv_daps_t), intent(inout) :: onegaindaps
      integer(kind=4), intent(inout) :: ifirst
      integer(kind=4), intent(inout) :: ilast
      logical,         intent(out)   :: found
      !
      integer(kind=4) :: diff
      !
      ! Initialize the search
      found = .false.
      !
      ! Search for first matching gains starting with the last gain in
      ! previous range
      ifirst = ilast
      ! Loop as long as possible
      do while (ifirst.lt.gain%nvisi)
         ! Get next gain daps
         ifirst = ifirst+1
         call onegaindaps%get(gain,ifirst)
         ! Compare visibility and gain base and datetime
         call compare_base_datetime(onerawdaps,onegaindaps,diff)
         if (diff.lt.0) then
            ! Gain is before current visibility => Cycle to restart from
            ! this ifirst next time
            cycle
         elseif (diff.gt.0) then
            ! Gain is after current visibility. No need to go further we
            ! won't find anything useful after this
            return
         else
            ! diff.eq.0
            !
            ! We found the first gain that matches exactly in terms of
            ! baseline and datetime!
            exit
         endif
      enddo ! (ifirst.lt.gain%nvisi)
      !
      ! Search for last matching gains starting with the previously found first gain
      ilast = ifirst
      ! Loop as long as possible
      do while (ilast.lt.gain%nvisi)
         ! Get next gain daps
         ilast = ilast+1
         call onegaindaps%get(gain,ilast)
         ! Compare visibility and gain base and datetime
         call compare_base_datetime(onerawdaps,onegaindaps,diff)
         if (diff.lt.0) then
            ! Gain is before current visibility => This should not happen
            return
         elseif (diff.gt.0) then
            ! Gain is after current visibility => last gain in current
            ! current range was the previous gain!
            ilast = ilast-1
            exit
         else
            ! diff.eq.0
            !
            ! We found another gain that matches exactly in terms of
            ! baseline and datetime => just cycle
            cycle
         endif
      enddo ! (ilast.lt.gain%nvisi)
      ! Found first and last gains in current range!
      found = .true.
    end subroutine find_next_matching_gain_range
    !
    subroutine apply_gain_for_each_frequency_within_gain_range(onerawdaps,onegaindaps,gain,ifirst,ilast,&
         iraw,raw,cal,flagged)
      !-------------------------------------------------------------------
      ! 
      !-------------------------------------------------------------------
      type(uv_daps_t), intent(in)    :: onerawdaps
      type(uv_daps_t), intent(inout) :: onegaindaps
      type(uv_data_t), intent(in)    :: gain
      integer(kind=4), intent(in)    :: ifirst
      integer(kind=4), intent(in)    :: ilast
      integer(kind=4), intent(in)    :: iraw
      type(uv_data_t), intent(in)    :: raw
      type(uv_data_t), intent(inout) :: cal
      logical,         intent(inout) :: flagged(:)
      !
      integer(kind=4) :: ichan,igain,bestvalid
      real(kind=8) :: dist,mindist
      complex(kind=4) :: zgain
      type(uv_atom_t) :: rawatom,calatom
      real(kind=8), parameter :: not_yet_defined=0
      ! For each channel, apply:
      ! - the nearest (in frequency) non-zero gain OR
      ! - the nearest (in frequency) gain, can be zero i.e. no gain applied
      ! Select here:
      logical, parameter :: allow_zero_gain=.true.
      !
      igain = ifirst
      !
      ! Loop over channels to search for the best valid gain in frequency
      do ichan=1,raw%nchan
         ! Reinitialize frequency distance for next channel with gain selected
         ! for previous channel
         bestvalid = not_yet_defined
         !
         ! Iterate gain table when possible
         do while (igain.le.ilast)
            ! Get this gain
            call onegaindaps%get(gain,igain)
            zgain = compute_gain(gain,onegaindaps%iori)
            if (allow_zero_gain .or. zgain.ne.0.) then
              ! Compute frequency distance and analyze it
              dist = abs(raw%freq(ichan,onerawdaps%iori)-gain%freq(1,onegaindaps%iori))
              if (bestvalid.eq.not_yet_defined) then
                bestvalid = igain
                mindist = dist
              elseif (dist.gt.mindist) then
                ! The distance in frequency is worse. Since the raw
                ! visibilities and gain arrays are also sorted by increasing
                ! frequency, this means we won't find nothing better after
                ! this => exit the "do while (igain.lt.ilast)" loop
                igain = bestvalid  ! Not always the previous one if there were zero-gains before
                call onegaindaps%get(gain,igain)
                zgain = compute_gain(gain,onegaindaps%iori)
                exit
              else
                ! Current gain is closer in frequency => Store it and
                ! iterate to see whether we find a gain at a closer
                ! frequency distance
                bestvalid = igain
                mindist = dist
              endif
            endif  ! zgain.ne.0
            igain = igain+1  ! Try next gain
         enddo ! (igain.le.gain%nvisi)
         ! A match has been found => it's onegaindaps%iori, with its zgain
         ! already computed
         !
         ! Debug
         if (.false.) then
            write(1,*) ">>> Matched raw(i,j,date,time,freq,ichan) = ",  &
                       onerawdaps%iant,onerawdaps%jant,  &
                       onerawdaps%date,onerawdaps%time,  &
                       raw%freq(ichan,onerawdaps%iori),ichan
            write(1,*) "       with gain(i,j,date,time,freq)      = ",  &
                       onegaindaps%iant,onegaindaps%jant,  &
                       onegaindaps%date,onegaindaps%time,  &
                       gain%freq(1,onegaindaps%iori),zgain
         endif
         !
         if (zgain.eq.0.0)  cycle  ! Gain can be 0 if all gains are 0 for this
                                   ! range. No gain to apply =>
                                   ! flagged(onerawdaps%iori) remains .true.
         !
         ! Apply the gain
         flagged(onerawdaps%iori) = .false.
         !***JP: This is the way it should be done
         !call rawatom%pointto(raw,onerawdaps%iori,ichan)
         !call calatom%pointto(raw,onerawdaps%iori,ichan)
         !if (onerawdaps%iant.eq.onegaindaps%jant) then
         !   call calatom%apply_gain(rawatom,conjg(zgain))
         !else
         !   call calatom%apply_gain(rawatom,zgain)
         !endif
         ! ***JP: But this is not easily possible. So copy!
         call rawatom%getfrom(raw,onerawdaps%iori,ichan)
         if (onerawdaps%iant.eq.onegaindaps%jant) then
           call calatom%apply_gain(rawatom,conjg(zgain))
         else
           call calatom%apply_gain(rawatom,zgain)
         endif
         call calatom%putinto(cal,onerawdaps%iori,ichan)
      enddo ! ichan
    end subroutine apply_gain_for_each_frequency_within_gain_range
    !
    function compute_gain(gain,ivis) result(zgain)
      !-----------------------------------------------------------------
      ! Compute the gain for the given visibility. Assume it is found
      ! in the first (unique) channel.
      !-----------------------------------------------------------------
      complex(kind=4) :: zgain
      type(uv_data_t), intent(in) :: gain  ! Gain array
      integer(kind=4), intent(in) :: ivis  !
      !
      real(kind=8) :: ampli,phase
      complex(kind=4) :: zg
      !
      ampli = sqrt(gain%uv(8,ivis)**2+gain%uv(9,ivis)**2)
      phase = atan2(gain%uv(9,ivis),gain%uv(8,ivis))
      if (gain%uv(10,ivis).le.0) ampli = 0.d0
      if (ampli.ne.0.d0) then
        ! Correct (a fraction of) the phase
        phase = phafactor*phase
        zg = cmplx(cos(phase),sin(phase))
        ampli = 1d0-ampfactor+ampli*ampfactor
        zgain = ampli*zg
      else
        ! Reset Zgain to 0
        zgain = 0.0
      endif
    end function compute_gain
    !
    subroutine compare_base_datetime(a,b,result)
      !-------------------------------------------------------------------
      ! Compare A and B visibilities according to their
      !  - first antenna, then
      !  - second antenna, then
      !  - date, then
      !  - time within tolerance
      ! Return -1 if A>B, 0 if A=B, +1 if A<B
      !-------------------------------------------------------------------
      type(uv_daps_t), intent(in)  :: a
      type(uv_daps_t), intent(in)  :: b
      integer(kind=4), intent(out) :: result
      !
      real(kind=8), parameter :: time_tol=1.0d0 ! [s] Tolerance on time
      real(kind=4) :: diff
      !
      ! Compare first antennas
      if (a%iant.gt.b%iant) then
         result = -1
         return
      elseif (a%iant.lt.b%iant) then
         result = +1
         return
      endif
      ! Compare second antennas
      if (a%jant.gt.b%jant) then
         result = -1
         return
      elseif (a%jant.lt.b%jant) then
         result = +1
         return
      endif
      ! Compare dates
      if (a%date.gt.b%date) then
         result = -1
         return
      elseif (a%date.lt.b%date) then
         result = +1
         return
      endif
      ! Compare times within tolerance
      diff = a%time-b%time
      if (diff.gt.time_tol) then
         result = -1
         return
      elseif (diff.lt.-time_tol) then
         result = +1
         return
      endif
      ! That's a match!
      result = 0
    end subroutine compare_base_datetime
  end subroutine uv_cal_main
end module uv_cal_mod
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
program uv_cal
  use gbl_message
  use gkernel_interfaces
  use uv_cal_mod
  !
  logical :: error=.false.
  character(len=*), parameter :: rname='UV>CAL'
  !
  call uv_cal_command(error)
  if (error) call sysexi(fatale)
  call map_message(seve%i,rname,'Successful completion')
end program uv_cal
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_spectrum2spectrum_onechan
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubetopology_cuberegion_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetemplate_factor_types
  use cubetemplate_messaging
  !---------------------------------------------------------------------
  ! This template is similar to SPECTRUM2SPECTRUM, except that the
  ! output "cube" has only one channel AND the output header has no
  ! spectroscopic axis anymore.
  !
  ! This use-case is sensitive because the access is speset but the
  ! spectroscopic axis is non-existing. This creates a header of size
  ! [0,Nx,Ny], which are not treated 100% transparently in CUBE. For
  ! example, we do not want to write such headers on disk files, which
  ! implies:
  !   - disk mode
  !   - snapshot
  !   - EXPORT /ACCESS SPECTRUM
  !
  ! Note this access is inefficient because we create a 2D image by
  ! putting single-channel spectra at each pixel position. Anyway this
  ! feature is used by e.g. FIT\PARAMETERS.
  !---------------------------------------------------------------------
  !
  public :: spectrum2spectrum_onechan
  private
  !
  type :: spectrum2spectrum_onechan_comm_t
     type(option_t), pointer :: comm
     type(factor_comm_t)     :: factor
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube
   contains
     procedure, public  :: register => cubetemplate_spectrum2spectrum_onechan_comm_register
     procedure, private :: parse    => cubetemplate_spectrum2spectrum_onechan_comm_parse
     procedure, private :: main     => cubetemplate_spectrum2spectrum_onechan_comm_main
  end type spectrum2spectrum_onechan_comm_t
  type(spectrum2spectrum_onechan_comm_t) :: spectrum2spectrum_onechan
  !
  type spectrum2spectrum_onechan_user_t
     type(cubeid_user_t)     :: cubeids
     type(factor_user_t)     :: factor
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubetemplate_spectrum2spectrum_onechan_user_toprog
  end type spectrum2spectrum_onechan_user_t
  !
  type spectrum2spectrum_onechan_prog_t
     type(cuberegion_prog_t) :: region
     type(factor_prog_t)     :: factor
     type(cube_t), pointer   :: incube
     type(cube_t), pointer   :: oucube
   contains
     procedure, private :: header => cubetemplate_spectrum2spectrum_onechan_prog_header
     procedure, private :: data   => cubetemplate_spectrum2spectrum_onechan_prog_data
     procedure, private :: loop   => cubetemplate_spectrum2spectrum_onechan_prog_loop
     procedure, private :: act    => cubetemplate_spectrum2spectrum_onechan_prog_act
  end type spectrum2spectrum_onechan_prog_t
  !
contains
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(spectrum2spectrum_onechan_user_t) :: user
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call spectrum2spectrum_onechan%parse(line,user,error)
    if (error) return
    call spectrum2spectrum_onechan%main(user,error)
    if (error) continue
  end subroutine cubetemplate_spectrum2spectrum_onechan_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum2spectrum_onechan_comm_t), intent(inout) :: comm
    logical,                                 intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'SPEC2CHAN','[cubeid]',&
         'Template command for per-spectrum input and 1-channel output access',&
         'Input cubes must be real and output cubes will be real.',&
         cubetemplate_spectrum2spectrum_onechan_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'INPUT',&
         'Signal cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_speset,&
         comm%incube,&
         error)
    if (error) return
    call comm%factor%register(error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'OUTPUT',&
         'Output cube',&
         strg_emp,&
         [flag_template],&
         comm%oucube,&
         error)
    if (error)  return
  end subroutine cubetemplate_spectrum2spectrum_onechan_comm_register
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! SPEC2SPEC cubeid
    !----------------------------------------------------------------------
    class(spectrum2spectrum_onechan_comm_t), intent(in)    :: comm
    character(len=*),                intent(in)    :: line
    type(spectrum2spectrum_onechan_user_t),  intent(out)   :: user
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
    call comm%factor%parse(line,user%factor,error)
    if (error) return
  end subroutine cubetemplate_spectrum2spectrum_onechan_comm_parse
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum2spectrum_onechan_comm_t), intent(in)    :: comm
    type(spectrum2spectrum_onechan_user_t),  intent(inout) :: user
    logical,                                 intent(inout) :: error
    !
    type(spectrum2spectrum_onechan_prog_t) :: prog
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>COMM>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_spectrum2spectrum_onechan_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum2spectrum_onechan_user_t), intent(in)    :: user
    type(spectrum2spectrum_onechan_comm_t),  intent(in)    :: comm
    type(spectrum2spectrum_onechan_prog_t),  intent(out)   :: prog
    logical,                                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call user%factor%toprog(prog%factor,error)
    if (error) return
    call user%region%toprog(prog%incube,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%factor%list(error)
    if (error) return
    call prog%region%list(error)
    if (error) return
  end subroutine cubetemplate_spectrum2spectrum_onechan_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum2spectrum_onechan_prog_t), intent(inout) :: prog
    type(spectrum2spectrum_onechan_comm_t),  intent(in)    :: comm
    logical,                                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header_with_region(comm%oucube,  &
      prog%incube,prog%region,prog%oucube,error)
    if (error) return
    ! Drop the C axis:
    call cubetools_header_nullify_axset_c(prog%oucube%head,error)
    if (error) return
    !
    call prog%factor%header(prog%oucube,error)
    if (error) return
  end subroutine cubetemplate_spectrum2spectrum_onechan_prog_header
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum2spectrum_onechan_prog_t), intent(inout) :: prog
    logical,                                 intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>PROG>DATA'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubetemplate_spectrum2spectrum_onechan_prog_data
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum2spectrum_onechan_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),                intent(inout) :: iter
    logical,                                 intent(inout) :: error
    !
    type(spectrum_t) :: input,output
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>PROG>LOOP'
    !
    call input%associate('input',prog%incube,iter,error)
    if (error) return
    call output%allocate('output',prog%oucube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,input,output,error)
      if (error) return
    enddo ! ie
  end subroutine cubetemplate_spectrum2spectrum_onechan_prog_loop
  !
  subroutine cubetemplate_spectrum2spectrum_onechan_prog_act(prog,ie,input,output,error)
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectrum2spectrum_onechan_prog_t), intent(inout) :: prog
    integer(kind=entr_k),                    intent(in)    :: ie
    type(spectrum_t),                        intent(inout) :: input
    type(spectrum_t),                        intent(inout) :: output
    logical,                                 intent(inout) :: error
    !
    integer(kind=chan_k), parameter :: ichan=1
    integer(kind=chan_k), parameter :: ochan=1
    character(len=*), parameter :: rname='SPECTRUM2SPECTRUM>ONECHAN>PROG>ACT'
    !
    call input%get(ie,error)
    if (error) return
    ! Copy one input channel into the unique output channel (it could
    ! also be an average or whatever)
    output%y%val(ochan) = prog%factor%val*input%y%val(ichan)
    call output%put(ie,error)
    if (error) return
  end subroutine cubetemplate_spectrum2spectrum_onechan_prog_act
end module cubetemplate_spectrum2spectrum_onechan
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine classic_recordbuf_open(file,rstart,wstart,buf,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_recordbuf_open
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Open the buffer for reading a new object
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: file    !
  integer(kind=8),           intent(in)    :: rstart  ! First record of the object
  integer(kind=4),           intent(in)    :: wstart  ! First word in this record
  type(classic_recordbuf_t), intent(inout) :: buf     !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='RECORDBUF'
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  logical :: same
  !
  same = file%lun.eq.buf%lun .and. rstart.eq.buf%rstart+buf%roff
  !
  buf%rstart = rstart
  buf%wstart = wstart
  buf%nrec = 1  ! ZZZ not exact for an input buffer
  !
  buf%lun = file%lun
  buf%roff = 0
  !
  if (same) then
    ! The data(:) buffer already contains a copy of the 'rstart' record
    return
  endif
  !
  if (file%desc%nextword.eq.1) then
    ! Next available space starts at the begining of the (new) record nextrec
    if (buf%rstart.ge.file%desc%nextrec) then
      buf%data(:) = 0
      return
    endif
  else
    ! Next available space starts somewhere in the (already existing) record nextrec
    if (buf%rstart.gt.file%desc%nextrec) then
      buf%data(:) = 0
      return
    endif
  endif
  !
  ! Starting record is already used in the file: load its previous content
  read(buf%lun,rec=buf%rstart,iostat=ier) buf%data
  if (ier.ne.0) then
    write(mess,'(A,I0)') 'Read error record #',buf%rstart
    call classic_message(seve%e,rname,mess)
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    ! Avoid letting incorrect bytes in this buffer. Forget the record
    ! we tried to read:
    call classic_recordbuf_nullify(buf)
    return
  endif
  !
end subroutine classic_recordbuf_open
!
subroutine recordbuf_read(addr,len,vec,buf,error)
  use gbl_message
  use classic_interfaces
  use classic_params
  use classic_types
  !----------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch), private
  !   Read the vector vec in the current observation.
  !   Working buffer is INOUT since it is not re-read when possible.
  ! 'buf%rstart' (the reference record from which we count the words)
  ! must have been correctly set before.
  !----------------------------------------------------------------------
  integer(kind=data_length), intent(in)    :: addr    ! Starting address (from beginning of object)
  integer(kind=data_length), intent(in)    :: len     ! Length of buffer
  integer(kind=4),           intent(out)   :: vec(*)  ! Buffer to be read
  type(classic_recordbuf_t), intent(inout) :: buf     ! Working buffer
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RBUF'
  character(len=message_length) :: mess
  integer(kind=8) :: add,kbufi,kbula,ikbfi,ikbla,ikb,jadd,kadd
  integer(kind=4) :: ier,len4
  !
  if (len.le.0) return
  !
  ! Convert address (from beginning of object) to address (from beginning of
  ! first record)
  add = buf%wstart+addr-1
  !
  ikbfi = (add-1)/buf%len          ! First buffer address (offset from buf%rstart, i.e. start at 0)
  kbufi = add-buf%len*ikbfi        ! First word address in this first buffer (remainder of integer division)
  ikbla = (add+len-2)/buf%len      ! Last buffer address (offset from buf%rstart, i.e. start at 0)
  kbula = add+len-1-buf%len*ikbla  ! Last word address in this last buffer (remainder of integer division)
  !
  if (ikbla+1.gt.buf%nrec) then
    write(mess,'(A,I0,A,I0,A)')  &
      'Internal error: read record #',ikbla+1,' beyond object limit (',buf%nrec,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Read first buffer if not current one
  if (ikbfi.ne.buf%roff) then
     buf%roff = ikbfi
     read(buf%lun,rec=buf%rstart+buf%roff,err=20,iostat=ier) buf%data
  endif
  !
  ! Single buffer
  if (ikbla.eq.ikbfi) then
     len4 = len
     call w4tow4(buf%data(kbufi),vec,len4)
     return
  endif
  !
  ! Move words from first buffer
  len4 = buf%len-kbufi+1
  call w4tow4(buf%data(kbufi),vec,len4)
  !
  ! Read contiguous buffers if needed
  jadd = buf%len-kbufi+2  ! First word in vec(:)
  kadd = jadd+buf%len-1   ! Last word in vec(:)
  do ikb = ikbfi+1,ikbla-1
     ! Do not waste time reading each record into data(:) and then
     ! copying it into the needed portion of vec(:). Read in vec(:)
     ! directly. We should worry about having a correct data(:)
     ! at the boundary records only (before and after this loop)
     read(buf%lun,rec=buf%rstart+ikb,err=20,iostat=ier) vec(jadd:kadd)
     jadd = jadd+buf%len
     kadd = kadd+buf%len
  enddo
  !
  ! Read last buffer
  buf%roff = ikbla
  read(buf%lun,rec=buf%rstart+buf%roff,err=20,iostat=ier) buf%data
  len4 = kbula
  call w4tow4(buf%data,vec(jadd),len4)
  return
  !
20 error = .true.
  write(mess,'(A,I0)') 'Read error record #',buf%rstart+buf%roff
  call classic_message(seve%e,rname,mess)
  call classic_iostat(seve%e,rname,ier)
  ! Avoid letting incorrect bytes in this buffer. Forget the record
  ! we tried to read:
  call classic_recordbuf_nullify(buf)
end subroutine recordbuf_read
!
subroutine recordbuf_write(addr,len,vec,buf,error)
  use gbl_message
  use classic_interfaces
  use classic_params
  use classic_types
  !----------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch), private
  !  Write the input data buffer 'VEC' to the output file. This is done
  ! by filling data blocks mirroring the file records and writing them
  ! to the file. Care is taken when 'VEC' overlaps file records.
  !----------------------------------------------------------------------
  integer(kind=data_length), intent(in)    :: addr    ! Starting address (from beginning of object)
  integer(kind=data_length), intent(in)    :: len     ! Length of buffer
  integer(kind=4),           intent(in)    :: vec(*)  ! Buffer to be written
  type(classic_recordbuf_t), intent(inout) :: buf     ! Working buffer
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WBUF'
  character(len=message_length) :: mess
  integer(kind=8) :: add,kbufi,kbula,ikbfi,ikbla,ikb,jadd,kadd
  integer(kind=4) :: ier,len4
  !
  if (len.le.0) return
  !
  ! Convert address (from beginning of object) to address (from beginning of
  ! first record)
  add = buf%wstart+addr-1
  !
  ikbfi = (add-1)/buf%len          ! First buffer address (offset from buf%rstart, i.e. start at 0)
  kbufi = add-buf%len*ikbfi        ! First word address in this first buffer (remainder of integer division)
  ikbla = (add+len-2)/buf%len      ! Last buffer address (offset from buf%rstart, i.e. start at 0)
  kbula = add+len-1-buf%len*ikbla  ! Last word address in this last buffer (remainder of integer division)
  !
  ! Write current buffer if not first one, and read first one
  if (ikbfi.ne.buf%roff) then
     ! Flush buf%data content to its buf%roff record
     write (buf%lun,rec=buf%rstart+buf%roff,err=21,iostat=ier) buf%data
     !
     buf%roff = ikbfi
     if (buf%roff+1.le.buf%nrec) then
        ! We access a record already used (totally or partially). Reload.
        ! NB: buf%roff numbered from 0 (offset), while nrec numbered from 1 (number)
        read(buf%lun,rec=buf%rstart+buf%roff,err=22,iostat=ier) buf%data
     else
        buf%data(:) = 0
     endif
  endif
  !
  ! Single buffer
  if (ikbla.eq.ikbfi) then
     ! Everything goes in the same record: fill appropriate portion of buffer
     ! 'buf%data', it will be written to file later.
     len4 = len
     call w4tow4(vec,buf%data(kbufi),len4)
     buf%nrec = max(buf%nrec,buf%roff+1)
     return
  endif
  !
  ! Move words into first buffer
  len4 = buf%len-kbufi+1
  call w4tow4(vec,buf%data(kbufi),len4)
  !
  ! Write contiguous buffers if needed
  write (buf%lun,rec=buf%rstart+buf%roff,err=21,iostat=ier) buf%data
  jadd = buf%len-kbufi+2  ! First word in vec(:)
  kadd = jadd+buf%len-1   ! Last word in vec(:)
  do ikb = ikbfi+1,ikbla-1
     ! Do not waste time copying the needed portion of vec(:) into
     ! buf%data(:), and then writing data(:). Write the portion of
     ! vec(:) directly. We should worry about having a correct data(:)
     ! at the boundary records only (before and after this loop)
     write (buf%lun,rec=buf%rstart+ikb,err=21,iostat=ier) vec(jadd:kadd)
     jadd = jadd+buf%len
     kadd = kadd+buf%len
  enddo
  !
  ! Read last buffer
  buf%roff = ikbla
  if (buf%roff+1.le.buf%nrec) then
     ! We access a record already used (totally or partially). Reload.
     ! NB: buf%roff numbered from 0 (offset), while nrec numbered from 1 (number)
     read (buf%lun,rec=buf%rstart+buf%roff,err=22,iostat=ier) buf%data
  else
     buf%data(:) = 0
  endif
  len4 = kbula
  call w4tow4(vec(jadd),buf%data,len4)
  buf%nrec = max(buf%nrec,buf%roff+1)
  return
  !
21 error = .true.
  write(mess,'(A,I0)') 'Write error record #',buf%rstart+buf%roff
  call classic_message(seve%e,rname,mess)
  call classic_iostat(seve%e,rname,ier)
  return
22 error = .true.
  write(mess,'(A,I0)') 'Read error record #',buf%rstart+buf%roff
  call classic_message(seve%e,rname,mess)
  call classic_iostat(seve%e,rname,ier)
  ! Avoid letting incorrect bytes in this buffer. Forget the record
  ! we tried to read:
  call classic_recordbuf_nullify(buf)
  return
end subroutine recordbuf_write
!
subroutine recordbuf_close(buf,error)
  use gbl_message
  use classic_interfaces, except_this=>recordbuf_close
  use classic_types
  !----------------------------------------------------------------------
  ! @ private
  !   Flush the currently opened record to the appropriate record in the
  ! output file
  !----------------------------------------------------------------------
  type(classic_recordbuf_t), intent(in)    :: buf    ! Working buffer
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CBUF'
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  write(buf%lun,rec=buf%rstart+buf%roff,iostat=ier) buf%data
  if (ier.eq.0) return
  !
  error = .true.
  write(mess,'(A,I0)') 'Write error record #',buf%rstart+buf%roff
  call classic_message(seve%e,rname,mess)
  call classic_iostat(seve%e,rname,ier)
end subroutine recordbuf_close
!
subroutine classic_recordbuf_nullify(buf)
  use classic_interfaces, except_this=>classic_recordbuf_nullify
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  "Nullify" the input buffer i.e. reset its record positions so that
  ! recordbuf_read/write won't assume something useful is stored in the
  ! data buffer.
  !---------------------------------------------------------------------
  type(classic_recordbuf_t), intent(inout) :: buf  !
  !
  buf%rstart = -1
  buf%wstart = -1
  buf%nrec = -1
  !
  buf%lun = -1
  buf%roff = -1
  ! buf%len: unchanged, record size is not involved here
  ! buf%data(:) = 0: no, because usually not needed and a waste of time.
                   ! Should be done explicitly by the calling routine if
                   ! needed.
  !
end subroutine classic_recordbuf_nullify

program header_main
  use gildas_def
  use image_def
  use gkernel_interfaces
  ! Local
  character(len=filename_length) :: file
  type (gildas) :: img
  integer :: n
  logical :: error
  !
  call gildas_open
  call gildas_char('FILE$',file)
  call gildas_close
  n = len_trim(file)
  if (n.eq.0) stop
  !
  call gildas_null(img)
  img%file = file
  call gdf_read_header(img,error)
  if (error) stop
  call gdf_print_header(img)
end program header_main

subroutine rsec(ed,ksec,lsec,sec,error)
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>rsec
  use class_common
  !----------------------------------------------------------------------
  ! @ private
  !  Read a section in the input observation
  !----------------------------------------------------------------------
  type(classic_entrydesc_t), intent(in)    :: ed      ! Entry Descriptor
  integer(kind=4),           intent(in)    :: ksec    ! Section number
  integer(kind=8),           intent(inout) :: lsec    ! Maximum and actual length of section
  integer(kind=4),           intent(out)   :: sec(*)  ! Section buffer
  logical,                   intent(out)   :: error   ! Error flag
  ! Local
  character(len=*), parameter :: rname='RSEC'
  integer(kind=4), parameter :: mnsec=18
  character(len=12) :: section(0:mnsec)
  data section /'USER CODE','COMMENT','GENERAL','POSITION','SPECTROSCOPY',       &
                'BASELINE','ORIGIN','PLOT','Freq. SWITCH','Gauss FIT',           &
                'CONTINUUM','Beam. SWITCH','Shell FIT','NH3 FIT','CALIBRATION',  &
                'Cont. FIT','SKYDIP','X Coord.','Abs. fit'/
  !
  error = .false.
  call classic_entry_section_read(ksec,lsec,sec,ed,ibufobs,error)
  if (error) then
    ! Translate section id to human readable name:
    if (ksec.le.0 .and. -ksec.le.mnsec) then
      call class_message(seve%e,rname,'Error reading section '//section(-ksec))
    endif
    return
  endif
  !
end subroutine rsec
!
subroutine wsec(ed,ksec,lsec,sec,error)
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>wsec
  use class_common
  !----------------------------------------------------------------------
  ! @ private
  !  Write a section to the output file
  !----------------------------------------------------------------------
  type(classic_entrydesc_t), intent(inout) :: ed      ! Entry Descriptor
  integer(kind=4),           intent(in)    :: ksec    ! Section number
  integer(kind=8),           intent(in)    :: lsec    ! Maximum and actual length of section
  integer(kind=4),           intent(in)    :: sec(*)  ! Section buffer
  logical,                   intent(out)   :: error   ! Error flag
  ! Local
  character(len=*), parameter :: rname='WSEC'
  integer(kind=4), parameter :: mnsec=18
  character(len=12) :: section(0:mnsec)
  data section /'USER CODE','COMMENT','GENERAL','POSITION','SPECTROSCOPY',     &
                'BASELINE','ORIGIN','PLOT','Freq. SWITCH','Gauss FIT',         &
                'CONTINUUM','PROJECTION','Shell FIT','NH3 FIT','CALIBRATION',  &
                'Cont. FIT','SKYDIP','X Coord.','Abs. fit'/
  !
  error = .false.
  !
  if (obufobs%lun.ne.fileout%lun) then
     error = .true.
     call class_message(seve%f,rname,'Observation not opened for write or modify')
     return
  endif
  !
  if (outobs_modify) then
    call classic_entry_section_update(ksec,lsec,sec,ed,obufobs,error)
  else
    call classic_entry_section_add(ksec,lsec,sec,ed,obufobs,error)
  endif
  if (error) then
    ! Translate section id to human readable name:
    if (ksec.le.0 .and. -ksec.le.mnsec) then
      call class_message(seve%e,rname,'Error writing section '//section(-ksec))
    endif
    return
  endif
  !
end subroutine wsec

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage WIFISYN messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_message_set_id(id)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_message_set_id
  use wifisyn_message_private
  !---------------------------------------------------------------------
  ! @ private
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  !
  character(len=message_length) :: mess
  !
  wifisyn_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',wifisyn_message_id
  call wifisyn_message(seve%d,'wifisyn_message_set_id',mess)
  !
end subroutine wifisyn_message_set_id
!
subroutine wifisyn_message(mkind,procname,mymessage)
  use wifisyn_interfaces, except_this=>wifisyn_message
  use wifisyn_message_private
  !---------------------------------------------------------------------
  ! @ private
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind    ! Message kind
  character(len=*), intent(in) :: procname ! Name of calling procedure
  character(len=*), intent(in) :: mymessage  ! Message string
  !
  call gmessage_write(wifisyn_message_id,mkind,procname,mymessage)
  !
end subroutine wifisyn_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeio_header_iodesc
  use cubetools_parameters
  use cubetools_header_interface
  use cubeio_header_interface
  use cubeio_desc
  use cubeio_messaging
  !
  public :: cubeio_header_put_toiodesc
  public :: cubeio_iodesc_import
  public :: cubeio_iodesc_unrecognized
  private
  !
contains
  !
  subroutine cubeio_header_put_toiodesc(dno,order,iodesc,error)
    use cubedag_node_class
    !-------------------------------------------------------------------
    ! From type(cube_header_t) to type(cubeio_desc_t) with desired order
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=code_k),         intent(in)    :: order  ! code_order_*
    type(cubeio_desc_t),          intent(inout) :: iodesc
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>PUT'
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    call dno%node%head2interf(error)
    if (error) return
    call cubeio_header_interface_transpose(dno%node%head,order,error)
    if (error) return
    call cubeio_iodesc_import(dno%node%head,iodesc,error)
    if (error) return
  end subroutine cubeio_header_put_toiodesc
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeio_iodesc_import(in,iodesc,error)
    use gbl_format
    !-------------------------------------------------------------------
    ! From type(cube_header_interface_t) to type(cubeio_desc_t)
    !-------------------------------------------------------------------
    type(cube_header_interface_t), intent(in)    :: in
    type(cubeio_desc_t),           intent(inout) :: iodesc
    logical,                       intent(inout) :: error
    !
    integer(kind=ndim_k) :: ix,iy,ic,ndim
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='IODESC>IMPORT'
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    ! Keep track of intrinsic data description
    iodesc%iscplx = in%array_type.eq.fmt_c4
    iodesc%ndim = in%axset_ndim
    iodesc%bakx = in%axset_ix
    iodesc%baky = in%axset_iy
    iodesc%bakc = in%axset_ic
    !
    ! Insert fake dimensions if relevant:
    call cubeio_header_interface_derive_xyc(in,ndim,  &
                                            ix,iodesc%nx,  &
                                            iy,iodesc%ny,  &
                                            ic,iodesc%nc,error)
    if (error)  return
    !
    if (ix.eq.1 .and. iy.eq.2) then
      iodesc%order = code_cube_imaset
      ! NB: ix/iy/ic might not be 1/2/3 if degenerate dimensions are
      !     interleaved.
      iodesc%i1 = ix
      iodesc%i2 = iy
      iodesc%i3 = ic
      iodesc%n1 = iodesc%nx
      iodesc%n2 = iodesc%ny
      iodesc%n3 = iodesc%nc
    elseif (ic.eq.1) then
      iodesc%order = code_cube_speset
      iodesc%i1 = ic
      iodesc%i2 = ix
      iodesc%i3 = iy
      iodesc%n1 = iodesc%nc
      iodesc%n2 = iodesc%nx
      iodesc%n3 = iodesc%ny
    else
      write(mess,'(4(a,i0))')  'Unrecognized order (IX=',ix,', IY=',iy,', IC=',ic,')'
      call cubeio_message(seve%d,rname,mess)
      call cubeio_iodesc_unrecognized(iodesc,error)
      if (error)  return
    endif
  end subroutine cubeio_iodesc_import
  !
  subroutine cubeio_iodesc_unrecognized(iodesc,error)
    !-------------------------------------------------------------------
    ! Set the descriptor as unrecognized order. Mostly unusable, except
    ! for basic operations like HEADER command
    !-------------------------------------------------------------------
    type(cubeio_desc_t), intent(inout) :: iodesc
    logical,             intent(inout) :: error
    !
    iodesc%order = code_cube_unkset
    iodesc%nx = 1
    iodesc%ny = 1
    iodesc%nc = 1
  end subroutine cubeio_iodesc_unrecognized
  !
end module cubeio_header_iodesc
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gr_segm(name,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_segm
  use greg_pen
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*)                :: name   !
  logical,          intent(inout) :: error  !
  !
  call gtsegm(name,error)
  if (penupd) call setpen(cpen)
  gxp = -1e10
  gyp = -1e10
end subroutine gr_segm
!
function gr_spen(new)
  use greg_interfaces, except_this=>gr_spen
  use greg_pen
  !---------------------------------------------------------------------
  ! @ public
  !  Set the new pen to be used, and return the previous pen number.
  !---------------------------------------------------------------------
  integer(kind=4) :: gr_spen  ! Function value on return
  integer(kind=4), intent(in) :: new  ! New pen to be used
  ! Local
  integer(kind=4) :: old
  !
  call inqpen(old)
  if (new.ge.0 .and. new.ne.old) then
    cpen = new
    penupd = .true.
  endif
  gr_spen = old
end function gr_spen
!
subroutine gr_out
  use greg_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  call gtview('Append')
end subroutine gr_out
!
subroutine gr_segm_close(error)
  use greg_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public
  ! GreG overlay to GTV closing routine, for symetry with 'gr_segm'.
  ! Close the segment currently opened, and draw it implicitely.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call gtsegm_close(error)
  !
end subroutine gr_segm_close

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This template reads a UV table and writes a LM (2D) cube from it, with
! CUBE capabilities as of 19-MAR-2025.
!
! - CUBE is thought to iterate entries (image or spectrum) mapping
!   leading dimensions (LM or C resp.), and iterating the trailing
!   dimension(s).
! - The real common dimension is the visibility axis. A possibility
!   could be to map the input table dimensions as:
!      C (channel axis) = 1
!      X (vis. axis) = 2
!      Y (fake) = 3
!   and the output image as
!      C (pseudo L) = 1,
!      X (pseudo M) = 2,
!      Y (fake) = 3
!   Then we should be able to use "spectrum" iteration, iterating the
!   trailing X*Y dimensions.
! - However, in practice, the current internal engines actually iterate
!   the Y dimension (i.e. buffer C*X planes) which is degenerate...
! - Because of the above remark, the command is currently coded with
!   full data access, using full-cube types. Two drawbacks:
!     1/ this means we access the 2D data with a 3D type
!     2/ full access means the data must fit in memory all at once.
!   For ease of use, the dimensions must be mapped as:
!     X = 1
!     Y = 2
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_table2cube
  use cubetools_parameters
  use cubetools_structure
  use cubetuple_format_class
  use cube_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetemplate_factor_types
  use cubetopology_cuberegion_types
  use cubetemplate_messaging
  !
  public :: table2cube
  private
  !
  type :: table2cube_comm_t
     type(option_t),     pointer :: comm
     type(factor_comm_t)         :: factor
    !type(cuberegion_comm_t)     :: region
     type(cubeid_arg_t), pointer :: intable
     type(cube_prod_t),  pointer :: oucube
   contains
     procedure, public  :: register => cubetemplate_table2cube_comm_register
     procedure, private :: parse    => cubetemplate_table2cube_comm_parse
     procedure, private :: main     => cubetemplate_table2cube_comm_main
  end type table2cube_comm_t
  type(table2cube_comm_t) :: table2cube
  !
  type table2cube_user_t
     type(cubeid_user_t)     :: cubeids
     type(factor_user_t)     :: factor
    !type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubetemplate_table2cube_user_toprog
  end type table2cube_user_t
  !
  type table2cube_prog_t
    !type(cuberegion_prog_t)  :: region
     type(factor_prog_t)      :: factor
     class(format_t), pointer :: intable
     type(cube_t),    pointer :: oucube
   contains
     procedure, private :: header => cubetemplate_table2cube_prog_header
     procedure, private :: data   => cubetemplate_table2cube_prog_data
     procedure, private :: loop   => cubetemplate_table2cube_prog_loop
     procedure, private :: act    => cubetemplate_table2cube_prog_act
  end type table2cube_prog_t
  !
contains
  !
  subroutine cubetemplate_table2cube_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(table2cube_user_t) :: user
    character(len=*), parameter :: rname='TABLE2CUBE>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call table2cube%parse(line,user,error)
    if (error) return
    call table2cube%main(user,error)
    if (error) continue
  end subroutine cubetemplate_table2cube_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_table2cube_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(table2cube_comm_t), intent(inout) :: comm
    logical,                  intent(inout) :: error
    !
    type(cubeid_arg_t) :: intable
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='TABLE2CUBE>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'TABLE2CUBE','[cubeid]',&
         'Template command for UV-table input and 2D image-cube output access',&
         'Input file must be real and output file will be real.',&
         cubetemplate_table2cube_command,&
         comm%comm,&
         error)
    if (error) return
    call intable%register(&
         'INPUT',&
         'Input UV table',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_fullset,&
         comm%intable,&
         error)
    if (error) return
    call comm%factor%register(error)
    if (error) return
   !call comm%region%register(error)
   !if (error) return
    !
    ! Products
    call oucube%register(&
         'OUTPUT',&
         'Output cube',&
         strg_emp,&
         [flag_template],&
         comm%oucube,&
         error)
    if (error)  return
  end subroutine cubetemplate_table2cube_comm_register
  !
  subroutine cubetemplate_table2cube_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! table2cube cubname
    !----------------------------------------------------------------------
    class(table2cube_comm_t), intent(in)    :: comm
    character(len=*),         intent(in)    :: line
    type(table2cube_user_t),  intent(out)   :: user
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='TABLE2CUBE>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
   !call comm%region%parse(line,user%region,error)
   !if (error) return
    call comm%factor%parse(line,user%factor,error)
    if (error) return
  end subroutine cubetemplate_table2cube_comm_parse
  !
  subroutine cubetemplate_table2cube_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(table2cube_comm_t), intent(in)    :: comm
    type(table2cube_user_t),  intent(inout) :: user
    logical,                  intent(inout) :: error
    !
    type(table2cube_prog_t) :: prog
    character(len=*), parameter :: rname='TABLE2CUBE>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_table2cube_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_table2cube_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(table2cube_user_t), intent(in)    :: user
    type(table2cube_comm_t),  intent(in)    :: comm
    type(table2cube_prog_t),  intent(out)   :: prog
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='TABLE2CUBE>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_get_fheader(comm%intable,user%cubeids,prog%intable,error)
    if (error) return
    call user%factor%toprog(prog%factor,error)
    if (error) return
   !call user%region%toprog(prog%intable,prog%region,error)
   !if (error) return
    ! User feedback about the interpretation of his command line
    call prog%factor%list(error)
    if (error) return
   !call prog%region%list(error)
   !if (error) return
  end subroutine cubetemplate_table2cube_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_table2cube_prog_header(prog,comm,error)
    use cubetools_axis_types
    use cubetools_unit_setup
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(table2cube_prog_t), intent(inout) :: prog
    type(table2cube_comm_t),  intent(in)    :: comm
    logical,                  intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='TABLE2CUBE>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    if (prog%intable%head%set%il.ne.1 .or.  &
        prog%intable%head%set%im.ne.2) then
      call cubetemplate_message(seve%e,rname,  &
        'The table dimensions must have been remapped as IX=1 and IY=2')
      error = .true.
      return
    endif
    !
    call cubeadm_clone_header(comm%oucube,prog%intable,prog%oucube,error)
    if (error) return
    !
    ! 1st axis: from the UV table frequency axis
    call cubetools_header_get_axis_head_l(prog%oucube%head,axis,error)
    if (error) return
    axis%name = 'Channels'
    axis%unit = ''
    axis%kind = code_unit_fov  ! ZZZ
    axis%genuine = .true.
    axis%regular = .true.
    ! Assume 7 leading DAPS and 3 values per atom (the header should be
    ! enriched to deal with these values)
    axis%n   = (prog%intable%head%set%axis(prog%intable%head%set%il)%n-7)/3
    axis%ref = 1.d0
    axis%val = 1.d0
    axis%inc = 1.d0
    call cubetools_header_update_axset_l(axis,prog%oucube%head,error)
    if (error)  return
    !
    ! 2nd axis: from the UV table visi axis
    call cubetools_header_get_axis_head_m(prog%oucube%head,axis,error)
    if (error) return
    axis%name = 'Visibilities'
    axis%unit = ''
    axis%kind = code_unit_fov  ! ZZZ
    axis%genuine = .true.
    axis%regular = .true.
    axis%n   = prog%intable%head%set%axis(prog%intable%head%set%im)%n
    axis%ref = 1.d0
    axis%val = 1.d0
    axis%inc = 1.d0
    call cubetools_header_update_axset_m(axis,prog%oucube%head,error)
    if (error)  return
    !
    ! 3rd axis: none
    call cubetools_header_nullify_axset_c(prog%oucube%head,error)
    if (error)  return
    !
    call prog%factor%header(prog%oucube,error)
    if (error) return
  end subroutine cubetemplate_table2cube_prog_header
  !
  subroutine cubetemplate_table2cube_prog_data(prog,error)
    use cubeadm_opened
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(table2cube_prog_t), intent(inout) :: prog
    logical,                  intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    type(fullcube_t) :: infull,oufull
    character(len=*), parameter :: rname='TABLE2CUBE>PROG>DATA'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !
    ! Prepare the input cube for getting data
    call infull%associate('infull',prog%intable,error)
    if (error) return
    ! Prepare the output cube for putting data
    call oufull%allocate('oufull',prog%oucube,error)
    if (error) return
    !
    ! Loop on task => Only one task, (i.e. one iteration) => no parallelization statements
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       if (.not.error) &
         call prog%loop(iter,infull,oufull,error)
    enddo ! itask
  end subroutine cubetemplate_table2cube_prog_data
  !
  subroutine cubetemplate_table2cube_prog_loop(prog,iter,infull,oufull,error)
    use cubeadm_taskloop
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(table2cube_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    type(fullcube_t),         intent(inout) :: infull
    type(fullcube_t),         intent(inout) :: oufull
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='TABLE2CUBE>PROG>LOOP'
    !
    do while (iter%iterate_entry(error))  ! Only 1 iteration in this case
      ! Get the input full cube
      call infull%get(error)
      if (error) return
      ! Do the computation
      call prog%act(infull,oufull,error)
      if (error) return
      ! Put the output full cube
      call oufull%put(error)
      if (error) return
    enddo  ! ientry
  end subroutine cubetemplate_table2cube_prog_loop
  !
  subroutine cubetemplate_table2cube_prog_act(prog,infull,oufull,error)
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(table2cube_prog_t), intent(inout) :: prog
    type(fullcube_t),         intent(inout) :: infull
    type(fullcube_t),         intent(inout) :: oufull
    logical,                  intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    integer(kind=indx_k) :: ox,oy,oz
    character(len=*), parameter :: rname='TABLE2CUBE>PROG>ACT'
    !
    ! print *,'Input dimensions: ',shape(infull%val),' = ',infull%nx,infull%ny,infull%nz
    ! print *,'Output dimensions: ',shape(oufull%val),' = ',oufull%nx,oufull%ny,oufull%nz
    !
    do oz=1,oufull%nz  ! 3rd dimension (should be 1)
      iz = oz
      do oy=1,oufull%ny  ! 2nd dimension (visibilities)
        iy = oy
        do ox=1,oufull%nx  ! 1st dimension (channels)
          ix = 7+ox*3
          oufull%val(ox,oy,oz) = infull%val(ix,iy,iz)
        enddo
      enddo
    enddo
  end subroutine cubetemplate_table2cube_prog_act
end module cubetemplate_table2cube
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	subroutine getpar (imafile,rms,beamfwhm,velres,fbeam,fvel,
     &               fitflag,s0,thresh,p0,ap,ap1,itmaxcl,itmaxfit,
     &               eps,flambda,blanking,tol,savres,savfit,minsum)
	character*30 imafile
	character*1 yn1,yn2,yn3,yn4,yn5
	logical savres
	logical savfit
	real*4  minsum
	integer fitflag(11)
	dimension s0(3)

	open (unit=1,file='clumps_input',status='old')
	read (1,1000,err=999,end=999) 
1000	format (1x)
1001	format (1x,a)
	read (1,*,err=999,end=999) imafile
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) rms,blanking,tol
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) beamfwhm,fbeam,velres,fvel
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) s0(1),thresh,itmaxcl,minsum
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) s0(2),s0(3)
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) p0,ap,ap1
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) yn1,yn2,yn3
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) itmaxfit,eps,flambda
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) yn4,yn5
 
	ap=ap*ap
	ap1=ap1*ap1

	do i=1,11
	fitflag(i)=1
	enddo

	if (yn1.eq.'N'.or.yn1.eq.'n') then
		fitflag(5)=0
		fitflag(6)=0
	endif
	if (yn2.eq.'N'.or.yn2.eq.'n') then
		fitflag(8)=0
		fitflag(9)=0
		fitflag(10)=0
	endif
	if (yn3.eq.'N'.or.yn3.eq.'n') then
		fitflag(7)=0
	endif
	if (yn4.eq.'N'.or.yn4.eq.'n') savres=.false.
	if (yn5.eq.'N'.or.yn5.eq.'n') savfit=.false.

	open (unit=2,file='clumps_output',status='new')
	open (unit=3,file='clumps_list',status='new')
	write (3,1020) rms,beamfwhm,fbeam,velres,fvel,
     &               thresh,p0,sqrt(ap),sqrt(ap1),s0
	write (2,1020) rms,beamfwhm,fbeam,velres,fvel,
     &               thresh,p0,sqrt(ap),sqrt(ap1),s0
	write (6,1020) rms,beamfwhm,fbeam,velres,fvel,
     &               thresh,p0,sqrt(ap),sqrt(ap1),s0
1020	format (1x,' rms: ',1p,g10.3,', beamfwhm: ',2(g10.3,1x),
     &       ', velres: ',2(g10.3,1x),/,
     &    1x,' threshhold: ',g10.3,', contrast: ',g10.3,
     &       ', weigth-aperture: ',g10.3,
     &       1x,g10.3,/,1x,' stiffness: ',3g10.3)
	close (unit=1)
	return

999	write (6,*) 'I-GETPAR: error reading clumps_inp '
	close (unit=1)
! CKr 15.7.04:
!	call exit
	stop
! CKr.
	end

subroutine mx_major (u,beam,residu,nx,ny, nz,   &
     &    fwork,wclean,mclean,box,maxiter,compon,niter,   &
     &    grid, mapu, mapv, mapx, mapy, wfft, fft, sblock, cpu0)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use mapping_interfaces
  use mx_parameters
  use cct_types
  use minmax_tool, only: maxmap
  !---------------------------------------------------------------------
  ! CLEAN
  !	Major cycle loop according to MX idea
  !---------------------------------------------------------------------
  type(gildas) :: u                 !
  integer :: nx                     !
  integer :: ny                     !
  real ::    beam(nx,ny)            !
  integer :: nz                     !
  real ::    residu(nx,ny,nz)       !
  complex :: fwork(nx,ny)           ! Work space for T.F.
  integer :: mclean                 !
  type(cct_par) :: wclean(mclean)   ! Work space for clean components
  integer :: box(4)                 ! Cleaning box
  integer :: maxiter                ! Maximum number of clean components
  real ::  compon(3,maxiter,nz)     ! Clean component table
  integer :: niter(nz)              ! Number of Clean components
  real ::    grid(nx,ny)            ! Grid correction
  real :: mapu(nx)                  ! Coordinates of UV grid
  real :: mapv(ny)                  ! Coordinates of UV grid
  real :: mapx(nx)                  ! Coordinates of XY map in 1/m
  real :: mapy(ny)                  ! Coordinates of XY map in 1/m
  real :: wfft(*)                   ! FFT work space
  complex :: fft(nz+1,nx,ny)        ! FFTs of planes
  integer :: sblock                 !
  real :: cpu0                      !
  ! Local
  real :: cpu1, a
  !
  ! Some automatic arrays
  real ::    flux(nz)             !Total clean flux density
  logical :: converge(nz)         ! Indique la conv par acc de flux
  !
  integer :: iblock,nblock,istart,kz,jz
  integer :: jc,nv,iz,nn(2),ndim
  real ::    maxcarte,mincarte,   &   !max et min de la carte
     &    maxabs               !le plus grand en absolu
  integer :: imax,jmax,imin,jmin  !leurs coordonnees
  real ::    borne                !fraction de la carte initiale
  ! Critere d'arret pour le Clean de Clark
  real ::    clarkl
  real ::    limite               !intensite minimum des pts retenus
  integer :: nclean               !nb de pts reellement retenus
  logical :: fini                 !critere d'arret
  logical :: done                 ! All planes finished
  integer :: ncycle               ! Nombres de cycles majeurs
  logical :: select               ! Select some component  in CHOICE
  integer :: jo
  !
  ! Make ONE major cycle per plane
  ncycle = 0
  done = .false.
  !
  niter(1:nz) = 0
  flux(1:nz) = 0.0
  converge(1:nz) = .false.
  !
  jc = u%gil%dim(1)
  nv = u%gil%dim(2)
  select = .true.
  !
  do ! The big loop
    done = .true.
    call gag_cpu(cpu1)
    write(6,1000) 'I-MX_MAJOR,  Start major cycle at ',cpu1-cpu0
    do iz = 1,nz
      write(6,1001) 'I-MX,  Processing plane ',iz
      !
      ! Find maximum residual
      call maxmap (residu(:,:,iz),nx,ny,box,   &
      &        maxcarte,imax,jmax,mincarte,imin,jmin)
      maxabs = max(abs(maxcarte),abs(mincarte))
      if (ncycle.eq.0)  borne  = max(frac_res*maxabs,abs_res)
      fini = (maxabs.le.borne) .or. (maxiter.le.niter(iz))   &
      &        .or. converge(iz)
      if (.not.fini) then
        !
        ! Define minor cycle limit
        clarkl = maxabs*beam_gain
        limite = max(clarkl,0.9*borne)
        write(6,1000) 'I-MX,  Using residuals higher than ',limite
        !
        ! Select points of maximum strength and load them in
        call choice_box (residu(:,:,iz),nx,ny,box,limite,   &
      &          mclean,wclean,nclean,   &
      &          maxabs,select)
        !
        ! Make minor cycles
        write(6,1001) 'I-MX,  Selected ',nclean,' points'
        call mx_minor (wclean,   &
      &          nclean,beam,nx,ny,ix_beam,iy_beam,ix_patch,iy_patch,   &
      &          gain_loop,maxiter,clarkl,limite,converge(iz),   &
      &          .not.keep_cleaning,compon(:,:,iz), niter(iz))
        write(6,1001) 'I-MX,  Found ',niter(iz),' clean components'
        !
        ! Remove all components by FT : RESIDU = RESIDU - BEAM # WCLEAN(*,4)
        !
        jo = mcol(1)-1+iz
        call mx_uvsub_loc (nx,ny,mapx,mapy,   &
      &          wclean,nclean,flux(iz),   &
      &          jc,nv,u%r2d,5+3*jo)
        write(6,1000) 'I-MX,  Total cleaned flux density ',flux(iz)
        done = .false.
      endif
    enddo
    !
    ! OK END
    if (done) then
      do iz=1,nz
        if (maxabs.le.borne) then
          write(6,1001) 'I-MX,  Plane ',iz,   &
      &            ' reached minimum flux density '
        elseif (maxiter.le.niter(iz)) then
          write(6,1001) 'I-MX,  Plane ',iz,   &
      &            ' reached maximum number of components '
        elseif (converge(iz)) then
          write(6,1001) 'I-MX,  Plane ',iz,   &
      &            ' reached minor cycle convergence'
        else
          write(6,1001) 'I-MX,  Plane ',iz,   &
      &            ' end of transcendental causes'
        endif
      enddo
      write(6,1001) 'I-MX,  Converged after ',ncycle,' cycles'
      call gag_cpu(cpu1)
      write(6,1000) 'I-MX,  Finish major cycle at ',cpu1-cpu0
      return
    endif
    !
    ! Else Compute FFT's and loop again
    call gag_cpu(cpu1)
    write(6,1000) 'I-MX,  Start FFT back at ',cpu1-cpu0
    nn(1) = nx
    nn(2) = ny
    ndim = 2
    if (sblock.le.0) then
      sblock = nz
      nblock = 1
    else
      nblock = (nz+sblock-1)/sblock
    endif
    !
    do iblock = 1,nblock
      fft = 0 ! 
      
      istart = mcol(1)+(iblock-1)*sblock
      kz = min (sblock,nz-sblock*(iblock-1))
      call dofft (jc,nv,   & ! Size of visibility array
      &        u%r2d,      & ! Visibilities
      &        1,2,        &         ! U, V pointers
      &        istart,     &      ! First channel to map
      &        kz,nx,ny,   &    ! Cube size
      &        fft,        &         ! FFT cube
      &        mapu,mapv,  &   ! U and V grid coordinates
      &        support,uv_cell,uv_taper,   &    ! Gridding parameters
      &        weight, vcoor,   &    ! Weight & V coordinates
      &        conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,ctype)
      !
      ! Make maps with grid correction
      do iz=1,kz
        jz = iz+sblock*(iblock-1)
        call extrac (kz+1,nx,ny,iz,fft,fwork)
        call fourt  (fwork,nn,ndim,-1,1,wfft)
        call cmtore (fwork,residu(:,:,jz),nx,ny)
        call docorr (residu(:,:,jz),grid,nx*ny)
      enddo
    enddo
    write(6,1000) 'I-MX,  Finished gridding again'
    ncycle = ncycle+1
  enddo ! The big loop
  !
  1000  format(a,1pg11.3)
  1001  format(a,i12,a)
end subroutine mx_major
!
subroutine mx_uvsub_loc(nx,ny,mapx,mapy,wclean,nclean,flux,jc,nv,visi,io)
  use cct_types
  !-------------------------------------------------------------------
  ! GILDAS:	CLEAN 	Internal routine
  !	Subtract last major cycle components from residual map.
  !-------------------------------------------------------------------
  integer :: nx                   !
  integer :: ny                   !
  real :: mapx(nx)                !
  real :: mapy(ny)                !
  integer :: nclean               !
  type(cct_par) :: wclean(nclean) !
  real :: flux                    !
  integer :: jc                   !
  integer :: nv                   !
  real :: visi(jc,nv)             !
  integer :: io                   !
  ! Local
  integer :: ncomp
  integer :: ic,iv
  real :: x,y,phase,rvis,ivis
  !
  ! Compress clean component list
  ncomp = 0
  do ic=1,nclean
    if (wclean(ic)%value.ne.0.0) then
      flux = flux+wclean(ic)%value 
      ncomp = ncomp+1
      wclean(ncomp) = wclean(ic)
    endif
  enddo
  !
  ! Remove clean component from UV data set
  do iv=1,nv
    do ic = 1,ncomp
      x = mapx(wclean(ic)%ix)
      y = mapy(wclean(ic)%iy)
      phase = visi(1,iv)*x+visi(2,iv)*y
      rvis = wclean(ic)%value*cos(phase)
      ivis = wclean(ic)%value*sin(phase)
      visi(io,iv) = visi(io,iv) - rvis
      visi(io+1,iv) = visi(io+1,iv) - ivis
    enddo
  enddo
end subroutine mx_uvsub_loc
!
subroutine mx_minor (wclean,nbpoint,   &
    &      beam,nx,ny,ixbeam,iybeam,ixpatch,iypatch,   &
    &      gain,maxiter,clarkmin,limite,converge,check,   &
    &      compon,niter)
  use mapping_interfaces
  use cct_types
  !-------------------------------------------------------------------
  ! MX:
  !     CLEAN    Internal routine
  !        B.Clark minor cycles
  !     Deconvolve as in standard clean a list of NBPOINT points
  !     selected in the map until the residuals is less than CLARKMIN
  !-------------------------------------------------------------------
  type(cct_par) :: wclean(*)      ! Clean component
  integer :: nbpoint              ! nombre de points retenus
  integer :: nx                   ! dimension et centre du beam
  integer :: ny                   ! dimension et centre du beam
  real :: beam(nx,ny)             ! beam
  integer :: ixbeam               ! dimension et centre du beam
  integer :: iybeam               ! dimension et centre du beam
  integer :: ixpatch              ! rayon utile du Beam
  integer :: iypatch              ! rayon utile du Beam
  real :: gain                    ! gain de clean
  integer :: maxiter              ! nombre max d'iteration
  real :: clarkmin                ! borne d'arret de clean
  real :: limite                  ! borne d'arret de clean
!  real :: cclean(*)               ! valeur des composantes
  logical :: converge             ! Controle de la convergence
  logical :: check                ! ibid.
  real :: compon(3,maxiter)       ! Effective clean components
  integer :: niter                ! Number of clean components
  ! Local
  logical :: goon
  !
  integer :: nocomp, nomin, nomax             ! No de la composante courante
  real :: rabs, sign, rmin, rmax            ! MaxAbs et Signe courant
  real :: worry, xfac, spexp    ! Conservative and speedup factor
  !
  integer :: dimcum             !Controle de la convergence
  parameter (dimcum=10)      !par accumulation de flux positif
  real :: cum, oldcum(dimcum), f
  integer :: i
  !
  oldcum = 0.0
  cum = 0.
  call absmax (wclean,nbpoint,nocomp,rabs)
  if (wclean(nocomp)%influx.gt.0) then
    sign = 1
  else
    sign = -1
  endif
  !
  worry = 1.0
  spexp = 0.5
  xfac = (clarkmin/rabs)**spexp
  goon = niter.lt.maxiter
  do while (goon)
    niter = niter + 1
    f = gain / beam(ixbeam,iybeam) * wclean(nocomp)%influx
    wclean(nocomp)%value = wclean(nocomp)%value + f
    compon(1,niter) = f
    compon(2,niter) = wclean(nocomp)%ix
    compon(3,niter) = wclean(nocomp)%iy
    call soustraire (wclean,nbpoint,   &
    &        beam,nx,ny,ixbeam,iybeam,      &
    &        ixpatch,iypatch,nocomp,gain,   &
    &        1,beam,beam,0.0)  ! These are dummies for 1 plane
    !
    ! B.CLARK Magic confidence factor
    call absmax (wclean,nbpoint,nocomp,rabs)
    worry = worry+xfac/float(niter)
    !
    ! Check convergence
     goon = (rabs.gt.worry*clarkmin) .and. (niter.lt.maxiter)   &
    &        .and. (rabs.ge.limite)
    if (check) then
      cum = cum + f
      oldcum(mod(niter,dimcum)+1) = cum
      converge = (sign*(cum-oldcum(mod(niter+1,dimcum)+1)).lt.0.)
      goon = goon .and. .not.converge
    endif
  enddo
  write(6,1000) 'I-MX,  Major cycle stops at ',   &
    &      rabs,limite,worry*clarkmin
  !
  1000  format(a,3(1x,1pg11.4))
end subroutine mx_minor
!
subroutine absmax (x,n,num,rabs)
  use cct_types
  !-------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS:	Utility routine
  ! 	Compute position and values of Min and Max of array X
  !-------------------------------------------------------------------
  integer, intent(in) :: n                    !
  type(cct_par), intent(in) :: x(n)            !
  integer, intent(out) :: num                  !
  real, intent(out) :: rabs                    !
  ! Local
  integer :: no
  !
  rabs = 0.0
  num = 1
  do no=1,n
    if (x(no)%influx.ge.rabs) then
      num = no
      rabs = x(no)%influx
    elseif  (-x(no)%influx.gt.rabs) then
      num = no
      rabs = -x(no)%influx
    endif
  enddo
end subroutine absmax
!
subroutine choice_box (r,nx,ny,box,limite,   &
     &    nclean,wclean,nbpoin,rmax,select)
  use cct_types
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAP TASKS 	Internal routine
  !	  Select possible clean components in residual map.
  !	  Components are returned ordered in increasing I and J.
  !   Uses a BOX instead of a LIST
  !   Differs from one in map/lib by using a Box 
  !   and a slightly different test to rebuild the histogram.
  !---------------------------------------------------------------------
  integer, intent(in) :: nx          ! X size
  integer, intent(in) :: ny          ! Y size
  integer, intent(in) :: nclean      ! Maximum number of components
  integer, intent(out) :: nbpoin     ! Number of components found
  real, intent(in) :: r(nx,ny)       ! Input array
  integer :: box(4)                  !
  type(cct_par), intent(inout) :: wclean(nclean)            !
  real, intent(inout) ::  limite     ! selection threshold
  real, intent(in) :: rmax           ! Maximum value
  logical, intent(in) :: select                 !
  ! Local
  integer :: i,j,nh,ngoal
  parameter (nh=64)
  parameter (ngoal=10000)
  integer :: hx(nh)
  real :: hmin, hstep
  !
  if (select) then
    !
    ! Make histogram
    hmin = 0.0
    hstep = rmax/(nh-2)
    call histos_box (r,nx,ny,box,hx,nh,hmin,hstep)
    !
    ! Locate a "reasonable" number of components
    hmin = 0.0
    do i=1,7*nh/8
      if (hmin.ne.0.0) then
        continue
      elseif  (hx(i).lt.ngoal) then
        hmin = (i-1)*hstep
      endif
    enddo
    limite = max(limite,hmin)
  endif
  !
  ! Select possible components in Clean Box
  nbpoin = 0
  do j=box(2),box(4)
    do i=box(1),box(3)
      if ( abs(r(i,j)).ge.limite ) then
        nbpoin=nbpoin+1
        wclean(nbpoin)%influx = r(i,j)
        wclean(nbpoin)%ix = i
        wclean(nbpoin)%iy = j
        wclean(nbpoin)%value = 0.0
      endif
    enddo
  enddo
end subroutine choice_box
!
subroutine histos_box (r,nx,ny, box, hx,nh,hmin,hstep)
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAP TASKS
  !	  Computes the histogram of part of an image
  !   Differs from one in map/lib: uses a box instead
  !   of a list of pixels.
  !---------------------------------------------------------------------
  integer, intent(in) :: nx        ! X size
  integer, intent(in) :: ny        ! Y size
  real, intent(in)  :: r(nx,ny)    ! Input array 
  integer, intent(in)  :: box(4)   ! Search box
  integer, intent(in) :: nh        ! Histogram size
  integer, intent(out) :: hx(nh)   ! Histogram
  real, intent(in) :: hmin         ! Min bin
  real, intent(in) :: hstep        ! Bin size
  ! Local
  real :: steph
  integer :: i,j,nin,nout,n
  !
  nin = 0
  nout = 0
  hx(1:nh) = 0
  steph = 1.0/hstep
  !
  do j = box(2),box(4)
    do i= box(1),box(3)
      n = nint((abs(r(i,j))-hmin)*steph + 1.0)
      if (n.ge.1 .and. n.le.nh) then
        hx(n) = hx(n)+1
        nin = nin+1
      else
        nout= nout+1
      endif
    enddo
  enddo
  !
  ! Convert to cumulative form
  do n=nh-1,1,-1
    hx(n) = hx(n)+hx(n+1)
  enddo
end subroutine histos_box

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_residuals
  use cube_types
  use cubetools_structure
  use cubetools_axis_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_sperange_types
  use cubefit_messaging
  use cubefit_hfs
  use cubefit_parameters
  use cubefit_selection
  !
  public :: residuals
  private
  !
  type :: residuals_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: incube
     type(cubeid_arg_t), pointer :: fitcube
     type(sperange_opt_t)        :: range
     type(option_t),     pointer :: hfs
     type(selection_opt_t)       :: select
     type(cube_prod_t),  pointer :: oucube
   contains
     procedure, public  :: register => cubefit_residuals_register
     procedure, private :: parse    => cubefit_residuals_parse
     procedure, private :: main     => cubefit_residuals_main
  end type residuals_comm_t
  type(residuals_comm_t) :: residuals
  !
  type residuals_user_t
     type(cubeid_user_t)    :: cubeids
     type(sperange_user_t)  :: range
     type(hfs_user_t)       :: hfs
     type(selection_user_t) :: sele
   contains
     procedure, private :: toprog => cubefit_residuals_user_toprog     
  end type residuals_user_t
  type residuals_prog_t
     type(sperange_prog_t)  :: range
     integer(kind=chan_k)   :: fc,lc
     type(hfs_prog_t)       :: hfs
     logical                :: found
     logical                :: overlap
     integer(kind=chan_k)   :: deltachan
     type(selection_prog_t) :: sele
     type(axis_t)           :: axis
     type(cube_t), pointer  :: incube
     type(cube_t), pointer  :: fitcube
     type(cube_t), pointer  :: oucube
   contains
     procedure, private :: header => cubefit_residuals_prog_header
     procedure, private :: data   => cubefit_residuals_prog_data
     procedure, private :: loop   => cubefit_residuals_prog_loop
     procedure, private :: act    => cubefit_residuals_prog_act
  end type residuals_prog_t
  !
contains
  !
  subroutine cubefit_residuals_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    logical,                intent(inout) :: error
    !
    type(residuals_user_t) :: user
    character(len=*), parameter :: rname='RESIDUALS>COMMAND'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call residuals%parse(line,user,error)
    if (error) return
    call residuals%main(user,error)
    if (error) return
  end subroutine cubefit_residuals_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_residuals_register(residuals,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(residuals_comm_t), intent(inout) :: residuals
    logical,                 intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='RESIDUALS>REGISTER'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'RESIDUALS','[signalid [fitid]]',&
         'Subtract fitted profiles from the data cube',&
         'Create a cube of what remains after subtracting the fitted model&
         & from the observed spectra. RESIDUALS rebuilds either the full&
         & fitted profile or one selected method/component from the&
         & fit-results cube produced by FIT\MINIMIZE, subtracts it from&
         & the input signal over the requested /RANGE, and uses the signal&
         & cube to keep the original PPV grid for the output residual&
         & cube. Spectra or channels for which no valid residual can be&
         & computed are written as NaN. Use /HFS when the fit used the HFS&
         & or ABSORPTION methods.',&
         cubefit_residuals_command,&
         residuals%comm,error)
    if (error) return
    call cubearg%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in the default&
         & index (DAG by default; see SET\INDEX). RESIDUALS subtracts the&
         & reconstructed model from this signal cube and uses it to clone&
         & the original PPV grid and header for the output residual cube.',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         residuals%incube,&
         error)
    if (error) return
    call cubearg%register(&
         'FITID',&
         'Identifier for the fit-results cube',&
         'If omitted, use the last matching cube (fit,minimize flags) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_fit,flag_minimize],&
         code_read,&
         code_access_speset,&
         residuals%fitcube,&
         error)
    if (error) return
    !
    call residuals%range%register(&
         'RANGE',&
         'Define velocity range for residuals',&
         error)
    if (error) return
    !
    call cubefit_hfs_register(residuals%hfs,error)
    if (error) return
    !
    call residuals%select%register(error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'RESIDUALS',&
         'Cube of residuals',&
         strg_emp,&
         [flag_fit,flag_residuals],&
         residuals%oucube,&
         error)
    if (error) return
  end subroutine cubefit_residuals_register
  !
  subroutine cubefit_residuals_parse(residuals,line,user,error)
    !----------------------------------------------------------------------
    ! RESIDUALS cubname
    ! /RANGE vfirst vlast [unit]
    ! /HFS file.hfs
    ! /SELECT method [ifunc]
    !----------------------------------------------------------------------
    class(residuals_comm_t), intent(in)    :: residuals
    character(len=*),        intent(in)    :: line
    type(residuals_user_t),  intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='RESIDUALS>PARSE'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,residuals%comm,user%cubeids,error)
    if (error) return
    call residuals%range%parse(line,user%range,error)
    if (error) return
    call cubefit_hfs_parse(line,residuals%hfs,user%hfs,error)
    if (error) return
    call residuals%select%parse(line,user%sele,error)
    if (error) return
  end subroutine cubefit_residuals_parse
  !
  subroutine cubefit_residuals_main(residuals,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(residuals_comm_t), intent(in)    :: residuals
    type(residuals_user_t),  intent(in)    :: user
    logical,                 intent(inout) :: error
    !
    type(residuals_prog_t) :: prog
    character(len=*), parameter :: rname='RESIDUALS>MAIN'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%header(residuals,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubefit_residuals_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_residuals_user_toprog(user,prog,error)
    use cubetools_header_methods
    use cubetools_disambiguate
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(residuals_user_t), intent(in)    :: user
    type(residuals_prog_t),  intent(out)   :: prog
    logical,                 intent(inout) :: error
    !
    integer(kind=chan_k) :: nchan,stride
    character(len=*), parameter :: rname='RESIDUALS>USER>TOPROG'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(residuals%incube,user%cubeids,&
         prog%incube,error)
    if (error) return
    call cubeadm_get_header(residuals%fitcube,user%cubeids,&
         prog%fitcube,error)
    if (error) return
    !
    call user%range%toprog(prog%incube,code_sperange_truncated,prog%range,error)
    if (error) return
    call prog%range%to_chan_k(prog%fc,prog%lc,stride,error)
    if (error) return
    call cubetools_header_get_axis_head_f(prog%incube%head,prog%axis,error)
    if (error) return
    prog%axis%n = prog%lc-prog%fc+1
    prog%axis%ref = prog%axis%ref-prog%fc+1
    prog%deltachan = prog%fc-1
    call cubetools_header_get_nchan(prog%incube%head,nchan,error)
    if (error) return
    prog%overlap = abs(prog%deltachan).lt.nchan
    !
    call cubefit_hfs_user2prog(user%hfs,prog%hfs,error)
    if (error) return
    call residuals%select%user2prog(user%sele,prog%sele,error)
    if (error) return
    !
  end subroutine cubefit_residuals_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_residuals_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(residuals_prog_t), intent(inout) :: prog
    type(residuals_comm_t),  intent(in)    :: comm
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='RESIDUALS>PROG>HEADER'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%oucube,prog%incube,prog%oucube,error)
    if (error) return
    !
    call cubetools_header_update_frequency_from_axis(prog%axis,prog%oucube%head,error)
    if (error) return
  end subroutine cubefit_residuals_prog_header
  !
  subroutine cubefit_residuals_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(residuals_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='RESIDUALS>PROG>DATA'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    ! At the start nothing has been found
    prog%found = .false.
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! ie
    !$OMP END SINGLE
    !$OMP END PARALLEL
    !
    if (.not.prog%found) then
       call cubefit_message(seve%w,rname,'No data found under current selection')
    endif
  end subroutine cubefit_residuals_prog_data
  !   
  subroutine cubefit_residuals_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(residuals_prog_t),  intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: fitspec,inspec,ouspec
    character(len=*), parameter :: rname='RESIDUALS>PROG>LOOP'
    !
    call fitspec%reassociate_and_init(prog%fitcube,iter,error)
    if (error) return
    call inspec%reassociate_and_init(prog%incube,iter,error)
    if (error) return
    call ouspec%reallocate_and_init(prog%oucube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,fitspec,inspec,ouspec,error)
      if (error) return
    enddo
  end subroutine cubefit_residuals_prog_loop
  !   
  subroutine cubefit_residuals_prog_act(prog,ie,fitspec,inspec,ouspec,error)
    use cubetools_nan
    use cubemain_spectrum_real
    use cubefit_spectral_fit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(residuals_prog_t), intent(inout) :: prog
    integer(kind=entr_k),    intent(in)    :: ie
    type(spectrum_t),        intent(inout) :: fitspec
    type(spectrum_t),        intent(inout) :: inspec
    type(spectrum_t),        intent(inout) :: ouspec
    logical,                 intent(inout) :: error
    !
    logical :: doprof
    integer(kind=chan_k) :: ichan,jchan
    type(fit_spectral_t) :: fit
    character(len=*), parameter :: rname='RESIDUALS>PROG>ACT'
    !
    if (prog%overlap) then
       call fitspec%get(prog%fitcube,ie,error)
       if (error) return
       call inspec%get(prog%incube,ie,error)
       if (error) return
       doprof = .not.(ieee_is_nan(fitspec%t(icol_status)).or.nint(fitspec%t(icol_status)).eq.code_status_diverged)
       if (prog%sele%imeth.ne.0) then
          doprof = doprof.and.(prog%sele%imeth.eq.nint(fitspec%t(icol_method)))
       endif
       doprof = doprof.and.(prog%sele%ifunc.le.nint(fitspec%t(icol_nfunc)))   
       !
       if (doprof) then
          prog%found = .true.
          call fit%spec_import(prog%hfs,fitspec,error)
          if (error) return
          call fit%profile(prog%sele%ifunc,ouspec,error)
          if (error) return
          !
          do ichan=1,ouspec%n
             jchan = ichan+prog%deltachan
             if (jchan.le.0.or.jchan.gt.inspec%n) then
                ouspec%t(ichan) = gr4nan
             else
                ouspec%t(ichan) = inspec%t(jchan)-ouspec%t(ichan)
             endif
          enddo
       else
          ouspec%t(:) = gr4nan
       endif
    else
       ouspec%t(:) = gr4nan
    endif
    call ouspec%put(prog%oucube,ie,error)
    if (error) return
  end subroutine cubefit_residuals_prog_act
end module cubefit_residuals
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uvmap_types
  use gbl_message
  !
  public :: uvmap_par
  public :: uvmap_user_weight_mode_toprog
  public :: map_power,map_rounding
  private
  !
  ! Parameters for determining image size
  integer, save :: map_power = 2        ! Max exponent of powers of 3 and 5
  real,    save :: map_rounding = 0.05  ! Tolerance for rounding to floor
  !
  type uvmap_par
     integer(kind=4) :: size(2) = 0   ! [------] Map size
     real(kind=4) :: xycell(2) = 0.0  ! [arcsec] Map cell
     real(kind=4) :: uvcell(2) = 0.0  ! [     m] UV cell
     real(kind=4) :: field(2) = 0.0   ! [arcsec] Field of view in arcsecond
     !
     character(len=8) :: mode = 'NATURAL'         ! [-----------] Weighting mode
     real(kind=4) :: uniform(2) = [0.0,1.0]       ! [m,---------] uvcell size and robustness coefficient
     real(kind=4) :: taper(4) = [0.0,0.0,0.0,2.0] ! [m,m,deg,---] UV Taper
     !
     integer(kind=4) :: wcol = 0      ! [---------] Weighting channel
     integer(kind=4) :: beam = -1     ! [---------] One beam every N channels (default to precision limit)
     real(kind=4) :: precis = 0.1     ! [chan.frac] Requested precision at map edges
     !
     integer(kind=4) :: ctype = 5     ! Convolution mode
     real(kind=4) :: support(2) = 0.0 ! Support of gridding function
     !
     real(kind=4) :: truncate = 20.0  ! Truncation level in % (for mosaic or primary)
     !
     logical :: shift = .false.       ! [---] Shift or rotate UV data
     real(kind=4) :: angle = 0.0      ! [deg] Position angle of UV data
     character(len=16) :: ra_c  = ' ' ! [---] Right ascension
     character(len=16) :: dec_c = ' ' ! [---] Declination
     !
     integer(kind=4) :: nfields = 0     ! Number and type of fields (<0 = phase, >0 = pointing)
     real,    allocatable :: offxy(:,:) ! Pointing or Phase offsets
     integer, allocatable :: ifields(:) ! start and end of fields
   contains
     procedure, public :: init   => uvmap_par_init
     procedure, public :: copyto => uvmap_par_copyto
     procedure, public :: sicdef => uvmap_par_sicdef
  end type uvmap_par
  !
contains
  !
  subroutine uvmap_par_init(prog,error)
    use gkernel_interfaces, only: gi4_round_forfft
    !-----------------------------------------------------------------------
    ! Initialize by setting the intent to out
    !-----------------------------------------------------------------------
    class(uvmap_par), intent(out)   :: prog
    logical,          intent(inout) :: error
    !
    integer :: iout
    !
    call gi4_round_forfft(64,iout,error,map_rounding,map_power)
    if (error) return
  end subroutine uvmap_par_init
  !
  subroutine uvmap_par_copyto(in,out)
    !-----------------------------------------------------------------------
    ! Copy a MAP structure to another one, but avoid erasing
    ! the number of fields in it. The result must have an intent(inout)
    ! to avoid erasing the allocatable array in the derived type.
    !-----------------------------------------------------------------------
    class(uvmap_par), intent(in)    :: in
    type(uvmap_par),  intent(inout) :: out
    !
    out%size = in%size
    out%xycell = in%xycell
    out%uvcell = in%uvcell
    out%field = in%field
    !
    out%mode = in%mode
    out%uniform = in%uniform
    out%taper = in%taper
    !
    out%wcol = in%wcol
    out%beam = in%beam
    out%precis = in%precis
    !
    out%ctype = in%ctype
    out%support = in%support
    !
    out%truncate = in%truncate
    !
    out%shift = in%shift
    out%angle = in%angle
    out%ra_c = in%ra_c
    out%dec_c = in%dec_c
  end subroutine uvmap_par_copyto
  !
  subroutine uvmap_par_sicdef(prog,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! 
    !-----------------------------------------------------------------------
    class(uvmap_par), intent(out)   :: prog
    logical,          intent(inout) :: error
    !
    integer(kind=index_length) :: dim(4) = 0
    !
    dim = [2,0,0,0]
    call sic_def_inte('MAP_SIZE',prog%size,1,dim,.false.,error)
    if (error) return
    call sic_def_real('MAP_CELL',prog%xycell,1,dim,.false.,error)
    if (error) return
    call sic_def_real('MAP_FIELD',prog%field,1,dim,.false.,error)
    if (error) return
    call sic_def_real('MAP_ROUNDING',map_rounding,0,0,.false.,error)
    if (error) return
    call sic_def_inte('MAP_POWER   ',map_power,0,0,.false.,error)
    if (error) return
    !
    call sic_def_char('MAP_WEIGHT',prog%mode,.false.,error)
    if (error) return
    call sic_def_real('MAP_ROBUST',prog%uniform(2),0,0,.false.,error)
    if (error) return
    !
    call sic_def_real('MAP_UVCELL',prog%uniform(1),0,0,.false.,error)
    if (error) return
    dim = [3,0,0,0]
    call sic_def_real('MAP_UVTAPER',prog%taper,1,dim,.false.,error)
    if (error) return
    call sic_def_real('MAP_TAPEREXPO',prog%taper(4),0,0,.false.,error)
    if (error) return
    !
    call sic_def_inte('MAP_BEAM_STEP',prog%beam,0,0,.false.,error)
    if (error) return
    call sic_def_real('MAP_PRECIS',prog%precis,0,0,.false.,error)
    if (error) return
    !
    call sic_def_inte('MAP_CONVOLUTION',prog%ctype,0,0,.false.,error)
    if (error) return
    !
    call sic_def_real('MAP_TRUNCATE',prog%truncate,0,0,.false.,error)
    if (error) return
    !
    call sic_def_logi('MAP_SHIFT',prog%shift,.false.,error)
    if (error) return
    call sic_def_char('MAP_RA',prog%ra_c,.false.,error)
    if (error) return
    call sic_def_char('MAP_DEC',prog%dec_c,.false.,error)
    if (error) return
    call sic_def_real('MAP_ANGLE',prog%angle,0,0,.false.,error)
    if (error) return
  end subroutine uvmap_par_sicdef
  !
  subroutine uvmap_user_weight_mode_toprog(rname,prog,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Decode the weighting mode
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type(uvmap_par),  intent(inout) :: prog
    logical,          intent(inout) :: error
    !
    integer :: i,n
    character(len=8) :: argum
    character(len=8) :: vweight(3)=(/'NATURAL ','UNIFORM ','ROBUST  '/)
    !
    argum = prog%mode
    call sic_get_char('MAP_WEIGHT',argum,n,error)
    call sic_upper (argum)
    call sic_ambigs (rname,argum,prog%mode,i,vweight,3,error)
    if (error) then
       call map_message(seve%e,rname,'Invalid weight mode '//argum)
    else
       call map_message(seve%i,rname,'Using '//vweight(i)//' weighting')
    endif
  end subroutine uvmap_user_weight_mode_toprog
end module uvmap_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sic_timer(line,error)
  use sic_interfaces, except_this=>sic_timer
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    TIMER
  !    TIMER ON|OFF
  !    TIMER [Time [HOURS|MINUTES|SECONDS]] [/COMMAND String]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  logical :: show
  !
  show = .true.
  if (sic_present(0,1)) then
    call sic_timer_dotime(line,1,2,error)
    if (error)  return
    show = .false.
  endif
  if (sic_present(1,0)) then
    call sic_timer_docommand(line,error)
    if (error)  return
    show = .false.
  endif
  if (show) then
    call sic_timer_show(error)
    if (error)  return
  endif
  !  
end subroutine sic_timer
!
subroutine sic_timer_show(error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_timer_show
  !---------------------------------------------------------------------
  ! @ private
  ! Show current status of the timer
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TIMER'
  character(len=message_length) :: mess
  character(len=commandline_length) :: command
  integer(kind=4) :: status,timersec
  !
  call xgag_gettimer_status(status)
  if (status.eq.0) then
    call sic_message(seve%i,rname,'Timer is OFF')
  else
    call sic_message(seve%i,rname,'Timer is ON')
  endif
  !
  call xgag_gettimer(timersec)
  if (timersec.eq.0) then
    write(mess,'(A)')         'No timer value set'
  elseif (timersec.ge.3600) then
    write(mess,'(A,F0.2,A)')  'Timer value: ',timersec/3600.,' hour(s)'
  elseif (timersec.ge.60) then
    write(mess,'(A,F0.2,A)')  'Timer value: ',timersec/60.,' minute(s)'
  else
    write(mess,'(A,I0,A)')    'Timer value: ',timersec,' second(s)'
  endif
  call sic_message(seve%i,rname,mess)
  !
  call xgag_gettimer_command(command)
  write(mess,'(A,A)')  'Timer command: ',trim(command)
  call sic_message(seve%i,rname,mess)
  !
end subroutine sic_timer_show
!
subroutine sic_timer_dotime(line,iargval,iargunit,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_timer_dotime
  !---------------------------------------------------------------------
  ! @ private
  ! Set the timer duration
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: iargval
  integer(kind=4),  intent(in)    :: iargunit
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TIMER'
  integer(kind=4), parameter :: nstatus=2
  character(len=3), parameter :: status(nstatus) = (/ 'ON ','OFF' /)
  integer(kind=4), parameter :: ntime=3
  character(len=7), parameter :: time(ntime) = (/ 'HOURS  ','MINUTES','SECONDS' /)
  character(len=7) :: key
  integer(kind=4) :: n,ikey
  character(len=40) :: argum
  integer(kind=4) :: timersec
  real(kind=4) :: timer
  !
  ! Try first ON or OFF
  call sic_ke(line,0,iargval,argum,n,.true.,error)
  if (error) return
  call sic_ambigs_sub(rname,argum,key,ikey,status,nstatus,error)
  if (error)  return
  if (ikey.ne.0) then
    ! Found a status
    if (ikey.eq.2)  ikey = 0   ! OFF => 0
    call xgag_settimer_status(ikey)
    return
  endif
  !
  ! No status keyword found, try a numeric value
  call sic_r4(line,0,iargval,timer,.true.,error)
  if (error)  return
  argum = 'HOURS'
  call sic_ke(line,0,iargunit,argum,n,.false.,error)
  if (error)  return
  call sic_ambigs(rname,argum,key,ikey,time,ntime,error)
  if (error)  return
  !
  if (ikey.eq.1) then
    timersec = timer*3600.
  elseif (ikey.eq.2) then
    timersec = timer*60.
  else
    timersec = timer
  endif
  call xgag_settimer(timersec)
  !
end subroutine sic_timer_dotime
!
subroutine sic_timer_docommand(line,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_timer_docommand
  !---------------------------------------------------------------------
  ! @ private
  ! Set the timer command
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TIMER'
  integer(kind=4), parameter :: optcommand=1
  character(len=commandline_length) :: command
  integer(kind=4) :: n
  !
  if (sic_present(optcommand,2)) then
    call sic_message(seve%e,rname,'Trailing arguments to option /COMMAND')
    call sic_message(seve%e,rname,'Command string must be given as single argument, possibly double-quoted')
    error = .true.
    return
  endif
  !
  call sic_ch(line,optcommand,1,command,n,.true.,error)
  if (error)  return
  !
  call xgag_settimer_command(trim(command))
  !
end subroutine sic_timer_docommand

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtcal_toclass_buffers
  use class_types
  type(observation) :: classobs
  real(kind=4), allocatable :: dataw(:)  ! Weight array for Associated Arrays
end module mrtcal_toclass_buffers
!
subroutine mrtcal_toclass_init(error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_toclass_buffers
  use mrtcal_interfaces, except_this=>mrtcal_toclass_init
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !  Initialize the 'toclass' buffers. This should be done only once in
  ! a session.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TOCLASS>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call class_obs_init(classobs,error)
  if (error)  return
  !
  ! Support for User Section
  call class_user_owner         ('30M','MRTCAL')              ! Owner
  call class_user_toclass       (mrtcal_toclass_user)         ! Transfer subroutine
  call class_user_dump          (mrtcal_user_dump)            ! Hook to LAS\DUMP /SECTION USER
  call class_user_setvar        (mrtcal_user_setvar)          ! Hook to LAS\SET VARIABLE USER
  call class_user_find          (mrtcal_user_find)            ! Hook to LAS\FIND /USER (command line parsing)
  call class_user_fix           (mrtcal_user_fix)             ! Hook to LAS\FIND /USER (selection)
  call class_user_varidx_fill   (mrtcal_user_varidx_fill)     ! Hook to EXP\VARIABLE /INDEX (array filling)
  call class_user_varidx_defvar (mrtcal_user_varidx_defvar)   ! Hook to EXP\VARIABLE /INDEX (vars definition)
  call class_user_varidx_realloc(mrtcal_user_varidx_realloc)  ! Hook to EXP\VARIABLE /INDEX (re/deallocation)
  !
end subroutine mrtcal_toclass_init
!
subroutine mrtcal_toclass_exit(error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_toclass_buffers
  use mrtcal_interfaces, except_this=>mrtcal_toclass_exit
  !---------------------------------------------------------------------
  ! @ private
  !  Finalize the 'toclass' buffers. This should be done only once in
  ! a session.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TOCLASS>EXIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call class_obs_clean(classobs,error)
  if (error)  return
  !
  if (allocated(dataw))  deallocate(dataw)
  !
end subroutine mrtcal_toclass_exit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_chunkset0d_to_obs(set,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset0d_to_obs
  use mrtcal_calib_types
  use mrtcal_toclass_buffers
  !---------------------------------------------------------------------
  ! @ private-generic mrtcal_chunkset_to_obs
  ! Stitch the spectra in the set and write them as a Class observation
  ! into the Class output file
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: set
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET0D>TO>OBS'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_chunkset_to_obs_ry(set,classobs,error)
  if (error)  return
  !
  call mrtcal_obs_to_class(classobs,error)
  if (error)  return
  !
end subroutine mrtcal_chunkset0d_to_obs
!
subroutine mrtcal_chunkset1d_to_obs(set,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset1d_to_obs
  use mrtcal_calib_types
  use mrtcal_toclass_buffers
  !---------------------------------------------------------------------
  ! @ private-generic mrtcal_chunkset_to_obs
  ! Convert an array of chunksets to one Class observation with
  ! Associated Arrays
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: set(:)
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET1D>TO>OBS'
  integer(kind=4) :: iobs
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Reset the observation. In particular, clean out the Associated Arrays
  ! section
  call rzero(classobs,'NULL',mrtcal_user_function)
  !
  call mrtcal_chunkset_to_obs_ry(set(1),classobs,error)
  if (error)  return
  !
  do iobs=2,size(set)
    call mrtcal_chunkset_to_obs_assoc(set(iobs),classobs,error)
    if (error)  return
  enddo
  !
  call mrtcal_obs_to_class(classobs,error)
  if (error)  return
  !
end subroutine mrtcal_chunkset1d_to_obs
!
subroutine mrtcal_chunkset_fsw_to_obs(out,set1,set2,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_fsw_to_obs
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_toclass_buffers
  !---------------------------------------------------------------------
  ! @ private
  !  Specific to FSW data
  !  Fold the pair of chunksets and produce a single class spectrum
  !---------------------------------------------------------------------
  type(mrtcal_setup_output_t), intent(in)    :: out
  type(chunkset_t),            intent(in)    :: set1
  type(chunkset_t),            intent(in)    :: set2
  logical,                     intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>FSW>TO>OBS'
  real(kind=4), pointer :: data2(:)
  !
  call mrtcal_message(seve%d,rname,'Welcome')
  !
  ! Reset the observation. In particular, clean out the Associated Arrays
  ! section
  call rzero(classobs,'NULL',mrtcal_user_function)
  !
  ! Build one observation from set #1
  call mrtcal_chunkset_to_obs_ry(set1,classobs,error)
  if (error)  return
  !
  ! Attach 'data2' as an Associated Array named "Y"
  call class_assoc_add(classobs,'Y',data2,error)
  if (error)  return
  ! In return 'data2' is a pointer to be filled, pointing to the
  ! associated array data.
  call mrtcal_reallocate_r4(dataw,obs_nchan(classobs%head),error)
  if (error)  return
  call mrtcal_chunkset_to_obs_data(set2,classobs%head,classobs%datav,data2,dataw,error)
  if (error)  return
  !
  ! At this stage the observation contains one spectrum in RY and
  ! the other in Y associated array. This is acceptable for transfering
  ! data to Class folding code which recognizes this structure, but this
  ! should be improved at the data format level before making it public.
  !
  if (out%fold) then
    classobs%cbad = classobs%head%spe%bad
    call class_fold_obs(classobs,.true.,error)
    if (error)  return
  endif
  !
  call mrtcal_obs_to_class(classobs,error)
  if (error)  return
  !
end subroutine mrtcal_chunkset_fsw_to_obs
!
subroutine mrtcal_chunkset_to_obs_ry(set,obs,error)
  use mrtcal_messaging
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_ry
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Stitch the spectra in the set and save them as the RY spectrum
  ! in the observation.
  !---------------------------------------------------------------------
  type(chunkset_t),  intent(in)    :: set
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>TO>OBS>RY'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_chunkset_check(set,error)
  if (error)  return
  call mrtcal_chunkset_to_obs_head(set,obs,error)
  if (error)  return
  call reallocate_obs(obs,obs_nchan(obs%head),error)
  if (error)  return
  call mrtcal_chunkset_to_obs_data(set,obs%head,obs%datav,obs%data1,obs%dataw,error)
  if (error)  return
  !
end subroutine mrtcal_chunkset_to_obs_ry
!
subroutine mrtcal_chunkset_to_obs_assoc(set,obs,error)
  use gbl_format
  use mrtcal_messaging
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_assoc
  use mrtcal_calib_types
  use mrtcal_toclass_buffers
  !---------------------------------------------------------------------
  ! @ private
  !  Stitch the spectra in the set and save them as a new associated
  ! array in the observation.
  !---------------------------------------------------------------------
  type(chunkset_t),  intent(in)    :: set
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>TO>OBS>ASSOC'
  real(kind=4), pointer :: data1(:)
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_chunkset_check(set,error)
  if (error)  return
  !
  if (set%chunks(1)%pos%sourc.eq.'W') then
    ! A reserved array
    call class_assoc_add(obs,set%chunks(1)%pos%sourc,data1,error)
  else
    ! A free array
    call class_assoc_add(obs,set%chunks(1)%pos%sourc,'',fmt_r4,0,class_bad,data1,error)
  endif
  if (error)  return
  !
  call mrtcal_reallocate_r4(dataw,obs_nchan(obs%head),error)
  if (error)  return
  !
  call mrtcal_chunkset_to_obs_data(set,obs%head,obs%datav,data1,dataw,error)
  if (error)  return
  !
end subroutine mrtcal_chunkset_to_obs_assoc
!
subroutine mrtcal_reallocate_r4(r4,n,error)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=4), allocatable, intent(inout) :: r4(:)
  integer(kind=4),           intent(in)    :: n
  logical,                   intent(inout) :: error
  ! Local
  logical :: realloc
  !
  if (allocated(r4)) then
    realloc = size(r4).ne.n
    if (realloc)  deallocate(r4)
  else
    realloc = .true.
  endif
  if (realloc)  allocate(r4(n))
end subroutine mrtcal_reallocate_r4
!
subroutine mrtcal_chunkset_to_obs_head(set,obs,error)
  use mrtcal_messaging
  use class_api
  use mrtcal_dependencies_interfaces
  use class_types
  use mrtcal_buffers
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_head
  !---------------------------------------------------------------------
  ! @ private
  !   This subroutine fills a Class header from a chunkset (collection
  ! of several chunks).
  !   General and position sections are assumed to be common between all
  ! the chunks of the chunkset. Should it be checked? *** JP
  !---------------------------------------------------------------------
  type(chunkset_t),  intent(in)    :: set
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>TO>OBS>HEAD'
  integer(kind=4) :: version,iuser
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  obs%head%presec(:) = .false.
  !
  ! General
  obs%head%presec(class_sec_gen_id) = .true.
  call mrtcal_chunkset_to_obs_gen(set,obs%head%gen,error)
  if (error)  return
  !
  ! Position
  obs%head%presec(class_sec_pos_id) = .true.
  obs%head%pos = set%chunks(1)%pos
  !
  if (obs%head%gen%kind.eq.kind_cont) then
    ! Continuum drift
    obs%head%presec(class_sec_dri_id) = .true.
    call mrtcal_chunkset_to_obs_con(set,obs%head%dri,obs%head%gen%time,error)
    if (error)  return
    ! X coordinate section
    obs%head%presec(class_sec_xcoo_id) = .true.
    obs%head%gen%xunit = a_angl
    ! The spectroscopic section is also filled but not activated. Only
    ! useful for the line name which is saved in the index (out of the
    ! unactive section).
    call mrtcal_chunkset_to_obs_spe(set,obs%head%spe,error)
    if (error)  return
    ! Switching
    if (set%chunks(1)%swi%swmod.ne.mod_unk) then
      obs%head%presec(class_sec_swi_id) = .true.
      obs%head%swi = set%chunks(1)%swi ! *** JP poor man's solution
    endif
  else
    ! Spectro
    obs%head%presec(class_sec_spe_id) = .true.
    call mrtcal_chunkset_to_obs_spe(set,obs%head%spe,error)
    if (error)  return
    !
    ! Switching
    if (set%chunks(1)%swi%swmod.ne.mod_unk) then
      obs%head%presec(class_sec_swi_id) = .true.
      obs%head%swi = set%chunks(1)%swi ! *** JP poor man's solution
    endif
  endif
  !
  ! Calibrate
  obs%head%presec(class_sec_cal_id) = .true.
  call mrtcal_chunkset_to_obs_cal(set,obs%head%cal,error)
  if (error)  return
  !
  ! Resolution (in agreement with obs%head%spe%restf)
  obs%head%presec(class_sec_res_id) = .true.
  obs%head%res = set%chunks(1)%res ! *** JP poor man's solution
  !
  ! User section
  if (rsetup%out%user) then
    version = 1
    obs%head%presec(class_sec_user_id) = .true.
    call class_user_exists(obs,iuser)
    if (iuser.eq.0) then
      call class_user_add(obs,version,set%chunks(1)%user,error)
      if (error)  return
    else
      call class_user_update(obs,version,set%chunks(1)%user,error)
      if (error) return
    endif
  endif
  !
end subroutine mrtcal_chunkset_to_obs_head
!
subroutine mrtcal_chunkset_to_obs_gen(set,gen,error)
  use gildas_def
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_gen
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Define the general section suited for the stitched chunks
  !---------------------------------------------------------------------
  type(chunkset_t),      intent(in)    :: set
  type(class_general_t), intent(out)   :: gen
  logical,               intent(inout) :: error
  ! Local
  integer(kind=4) :: ichunk
  integer(kind=size_length) :: nchunk
  real(kind=4) :: r4(set%n)  ! Automatic array
  !
  ! Duplicate everything from the 1st chunk...
  gen = set%chunks(1)%gen
  !
  ! ZZZ If continuum, gen%xunit should be set to a_angle
  ! ZZZ Have to introduce a_angle code in gbl_format
  !
  ! ... except Tsys which varies from one chunk to another. Take
  ! the median of all chunks instead
  do ichunk=1,set%n
    r4(ichunk) = set%chunks(ichunk)%gen%tsys
  enddo
  nchunk = set%n
  call gr4_median(r4,nchunk,class_bad,0.,gen%tsys,error)
  if (error)  return
  !
  ! ... and Tau which may have blanks in several chunks.
  do ichunk=1,set%n
    r4(ichunk) = set%chunks(ichunk)%gen%tau
  enddo
  nchunk = set%n
  call gr4_median(r4,nchunk,class_bad,0.,gen%tau,error)
  if (error)  return
  !
end subroutine mrtcal_chunkset_to_obs_gen
!
subroutine mrtcal_chunkset_to_obs_spe(set,spe,error)
  use mrtcal_messaging
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_spe
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Define the spectroscopic section suited for the stitched chunks
  !---------------------------------------------------------------------
  type(chunkset_t),      intent(in)    :: set
  type(class_spectro_t), intent(out)   :: spe
  logical,               intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>TO>OBS>SPE'
  integer(kind=4) :: ichunk
  type(chunk_t), pointer :: chunk
  real(kind=8) :: fleft,fright,fmin,fmax,cmin,cmax,dnu
  character(len=message_length) :: mess
  !
  ! NB: beware if you are willing to change restf here the resolution
  !     section must also be changed!
  !
  ! Initialize everything e.g. line name
  spe = set%chunks(1)%spe
  !
  ! Ensure that the stitched spectrum will be increasing in frequency
  if (spe%fres.lt.0.d0) then
     spe%fres = -spe%fres
     spe%vres = -spe%vres
  endif
  !
  chunk => set%chunks(1)
  call abscissa_sigabs_left(chunk%spe,fleft)
  call abscissa_sigabs_right(chunk%spe,fright)
  fmin = min(fleft,fright)
  fmax = max(fleft,fright)
  do ichunk=2,set%n
    chunk => set%chunks(ichunk)
    call abscissa_sigabs_left(chunk%spe,fleft)
    call abscissa_sigabs_right(chunk%spe,fright)
    fmin = min(fmin,min(fleft,fright))
    fmax = max(fmax,max(fleft,fright))
  enddo
  call abscissa_sigabs2chan(spe,fmin,cmin)
  call abscissa_sigabs2chan(spe,fmax,cmax)
  !
  dnu = spe%fres/(1.d0+spe%doppler)
  spe%nchan = nint(abs((fmax-fmin)/dnu))
  spe%rchan = 0.5d0-cmin+spe%rchan
!print *,fmin,fmax,cmin,cmax,abs(cmax-cmin),spe%nchan,spe%rchan
  !
  ! User feedback
  ! write(mess,'(2x,a,a)') 'Stitched frequency/velocity definition for ',gen%teles
  ! call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,i0)')   'Number of channels   ',spe%nchan
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)') 'Reference channel    ',spe%rchan
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)') 'Rest  frequency      ',spe%restf
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)') 'Image frequency      ',spe%image
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)') 'Velocity             ',spe%voff
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)') 'Frequency resolution ',spe%fres
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)') 'Velocity  resolution ',spe%vres
  call mrtcal_message(seve%d,rname,mess)
  !
end subroutine mrtcal_chunkset_to_obs_spe
!
subroutine mrtcal_chunkset_to_obs_con(set,con,time,error)
  use phys_const
  use mrtcal_messaging
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_con
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Define the continuum drift section suited for the stitched chunks
  !---------------------------------------------------------------------
  type(chunkset_t),    intent(in)    :: set    !
  type(class_drift_t), intent(out)   :: con    !
  real(kind=4),        intent(out)   :: time   ! [s] Integration time
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>TO>OBS>CON'
  character(len=message_length) :: mess
  logical :: alongx,alongy
  !
  ! Initialize everything e.g. line name
  con = set%chunks(1)%con
  !
  if (set%n.gt.1) then
    call drift_sanity1(set,error)
    if (error)  return
    call drift_sanity2(set,error)
    if (error)  return
    !
    ! Number of points
    con%npoin = set%n
    ! Position angle
    con%apos = position_angle(set,1,set%n)  ! [rad]
    !
    call drift_sanity3(con%apos,error)
    if (error)  return
    !
    ! Angular and time resolution: indicative, as the drift is irregular and
    ! we also write an X coordinate array
    call drift_resolution(set,con%ares,con%tres,error)
    if (error)  return
    if (con%apos.gt.3.d0*pi/4.d0 .or. con%apos.lt.-pi/4.d0)  &
      con%ares = -con%ares
    ! Reference point: indicative from 1st chunk
    con%rpoin = 1.0
    ! Angular offset at reference point
    alongx = set%chunks(1)%offset(2).eq.set%chunks(set%n)%offset(2)
    alongy = set%chunks(1)%offset(1).eq.set%chunks(set%n)%offset(1)
    if (alongx) then
      con%aref = set%chunks(1)%offset(1)
    elseif (alongy) then
      con%aref = set%chunks(1)%offset(2)
    else
      ! ZZZ: rejected by drift_sanity3
    endif
    ! Time value at reference point: first chunk, consistently to con%aref.
    ! Note: this assumes this tref is relative to gen%dobs (no midnight issue).
    con%tref = set%chunks(1)%con%tref
  endif
  !
  ! Total integration time of the drift
  time = sum(set%chunks(1:set%n)%gen%time)
  !
  ! User feedback
  write(mess,'(4x,a,i0)')           'Number of points     ',con%npoin
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)')         'Reference point      ',con%rpoin
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)')         'Time at reference    ',con%tref
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)')         'Angle at reference   ',con%aref
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)')         'Time resolution      ',con%tres
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8)')         'Angular resolution   ',con%ares
  call mrtcal_message(seve%d,rname,mess)
  write(mess,'(4x,a,f0.8,2x,f0.8)') 'Collimation errors   ',con%colla,con%colle
  call mrtcal_message(seve%d,rname,mess)
  !
contains
  !
  subroutine drift_sanity1(set,error)
    use mrtcal_messaging
    !-------------------------------------------------------------------
    ! Sanity check #1: is the drift straight? Obviously this should not
    ! happen, but we encountered cases where the on-track range was too
    ! including dumps where the antenna was not where it should. We also
    ! had drifts going back and forth at the beginning...
    !-------------------------------------------------------------------
    type(chunkset_t), intent(in)    :: set
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: iset
    real(kind=4) :: refapos,apos
    real(kind=4), parameter :: tolapos=1.*rad_per_deg  ! [rad] 1 degree tolerance
    !
    refapos = position_angle(set,1,2)
    do iset=3,set%n
      apos = position_angle(set,iset-1,iset)
      if (abs(apos-refapos).gt.tolapos) then
        write(mess,'(a,i0,a,2(a,f0.2,a,f0.2,a))')  &
          'Subcan ',set%chunks(1)%gen%subscan,     &
          ': drift does not go straight from ',    &
          'its first point at (',set%chunks(1)%offset(1)*sec_per_rad,              &
          ',',                   set%chunks(1)%offset(2)*sec_per_rad,    ') to ',  &
          'its last point at (', set%chunks(set%n)%offset(1)*sec_per_rad,          &
          ',',                   set%chunks(set%n)%offset(2)*sec_per_rad,') [arcsec]'
        call mrtcal_message(seve%e,rname,mess)
        error = .true.
        return
      endif
    enddo
  end subroutine drift_sanity1
  !
  subroutine drift_sanity2(set,error)
    use mrtcal_messaging
    !-------------------------------------------------------------------
    ! Sanity check #2: does the drift go through (0,0)? If not, we could
    ! support this by adding the drift main offset to
    ! (pos%lamof,pos%betof), but this requires reprojecting this
    ! horizontalTrue offset to a radio offset. This might (or not)
    ! happen in subroutine mrtcal_chunksets_from_data_1time1pix_1chunk
    !-------------------------------------------------------------------
    type(chunkset_t), intent(in)    :: set
    logical,          intent(inout) :: error
    !
    logical :: found
    integer(kind=4) :: iset
    real(kind=4) :: x0,y0,x1,y1,x2,y2,slope
    real(kind=4), parameter :: postol=0.1*rad_per_sec  ! [rad] 1 seconde tolerance
    !
    ! Do not assume this is a full straight line, but a collection of
    ! segments instead
    found = .false.
    x0 = 0.
    y0 = 0.
    do iset=2,set%n
      x1 = set%chunks(iset-1)%offset(1)
      y1 = set%chunks(iset-1)%offset(2)
      x2 = set%chunks(iset)%offset(1)
      y2 = set%chunks(iset)%offset(2)
      ! print *,"(",x1*sec_per_rad,",",y1*sec_per_rad,") to (",x2*sec_per_rad,",",y2*sec_per_rad,")"
      ! Search if this segment crosses (0,0)
      if (abs(x1-x2).le.postol) then
        ! Nearly vertical line: x = slope*y+x0
        if (y1.lt.0. .and. y2.lt.0.)  cycle
        if (y1.gt.0. .and. y2.gt.0.)  cycle
        found = .true.
        slope = (x2-x1)/(y2-y1)
        x0 = x1-slope*y1
        y0 = 0.
      else
        ! Non-vertical line: y = slope*x+y0
        if (x1.lt.0. .and. x2.lt.0.)  cycle
        if (x1.gt.0. .and. x2.gt.0.)  cycle
        found = .true.
        slope = (y2-y1)/(x2-x1)
        x0 = 0.
        y0 = y1-slope*x1
      endif
    enddo
    !
    if (.not.found) then
      ! The varying coordinate do not even get close to 0
      write(mess,'(a,i0,a)')  &
        'Subcan ',set%chunks(1)%gen%subscan,     &
        ': drift does not go through (0,0) offset. Positions are:'
      call mrtcal_message(seve%e,rname,mess)
      do iset=1,set%n
        x1 = set%chunks(iset)%offset(1)
        y1 = set%chunks(iset)%offset(2)
        write(mess,'(i3,a,2(1pg15.7,a))') iset,"  (",x1*sec_per_rad,",",y1*sec_per_rad,") [arcsec]"
        call mrtcal_message(seve%e,rname,mess)
      enddo
      error = .true.
      return
    else
      if (abs(x0).gt.postol .or. abs(y0).gt.postol) then
        write(mess,'(a,i0,a,f0.2,a,f0.2,a)')  &
          'Subcan ',set%chunks(1)%gen%subscan,     &
          ': drift does not go through (0,0) offset but (',  &
          x0*sec_per_rad,',',y0*sec_per_rad,') [arcsec] instead (not implemented)'
        call mrtcal_message(seve%e,rname,mess)
        error = .true.
        return
      endif
    endif
  end subroutine drift_sanity2
  !
  subroutine drift_sanity3(apos,error)
    use mrtcal_messaging
    !-------------------------------------------------------------------
    ! Sanity check #3: is the drift along azimuth or elevation, or not?
    ! Check how MIRA supports rotated drifts. But in this case MIRA does
    ! not use the projected angles, which is non-sense because it uses
    ! them when along X or Y.
    !-------------------------------------------------------------------
    real(kind=4), intent(in)    :: apos
    logical,      intent(inout) :: error
    !
    real(kind=4) :: ang
    real(kind=4), parameter :: pis2=pis/2.
    real(kind=4), parameter :: pis4=pis/4.
    real(kind=4), parameter :: tolapos=1.*rad_per_deg  ! [rad] 1 degree tolerance
    !
    ! We support +- azimuth and +- elevation. Check if it is a pi/2 multiple
    ! (modulo pi/2 until angle is in range [-pi/4,+pi/4]).
    ang = apos
    do
      if (ang.lt.pis4)  exit
      ang = ang-pis2
    enddo
    do
      if (ang.gt.-pis4)  exit
      ang = ang+pis2
    enddo
    !
    if (abs(ang).gt.tolapos) then
      write(mess,'(a,i0,a,f0.2,a)')  &
        'Subcan ',set%chunks(1)%gen%subscan,     &
        ': drift is rotated with angle ',apos*deg_per_rad,' deg (not implemented)'
      call mrtcal_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  end subroutine drift_sanity3
  !
  function position_angle(set,first,last)
    !-------------------------------------------------------------------
    ! Return the position angle on sky between 2 points of the drift.
    ! First/last order matters for proper (oriented) drift angle (i.e.
    ! angle +- pi).
    !-------------------------------------------------------------------
    real(kind=4) :: position_angle
    type(chunkset_t), intent(in) :: set
    integer(kind=4),  intent(in) :: first
    integer(kind=4),  intent(in) :: last
    !
    real(kind=4) :: dlam,dbet
    !
    dlam = set%chunks(last)%offset(1) - set%chunks(first)%offset(1)
    dbet = set%chunks(last)%offset(2) - set%chunks(first)%offset(2)
    position_angle = atan2(dbet,dlam)  ! [rad]
  end function position_angle
  !
  subroutine drift_resolution(set,ares,tres,error)
    !-------------------------------------------------------------------
    ! Return the median resolution on sky between the boundary points of
    ! the drift.
    !
    ! This resolution is indicative because the drift is irregular and
    ! we also write an X coordinate array, but it is used afterwards
    ! when resampling-averaging several drifts onto a common grid which
    ! reuses this resolution. In practive the drifts are almost regular
    ! so sticking to the best resolution is desirable to avoid the
    ! resampling to modify the data more than necessary.
    !
    ! We return the median and not the average because there are cases
    ! where the boundary positions are outliers (e.g. due to antenna
    ! slews at the beginning or end of the drift). See e.g.
    ! iram30m-nbc-20250124s44-imb.fits drift 30ME0HLI-N01
    !-------------------------------------------------------------------
    type(chunkset_t), intent(in)    :: set
    real(kind=4),     intent(out)   :: ares
    real(kind=4),     intent(out)   :: tres
    logical,          intent(inout) :: error
    !
    real(kind=4) :: dlam,dbet
    real(kind=4) :: areso(set%n)  ! Automatic array
    real(kind=4) :: treso(set%n)  ! Automatic array
    integer(kind=size_length) :: ichunk,nchunk
    !
    nchunk = set%n
    do ichunk=1,set%n-1
      dlam = set%chunks(ichunk+1)%offset(1) - set%chunks(ichunk)%offset(1)
      dbet = set%chunks(ichunk+1)%offset(2) - set%chunks(ichunk)%offset(2)
      areso(ichunk) = sqrt(dbet**2+dlam**2)  ! [rad]
      treso(ichunk) = (set%chunks(ichunk+1)%mjd-set%chunks(ichunk)%mjd)*twopi  ! [s]
    enddo
    call gr4_median(areso,nchunk,0.,-1.,ares,error)
    if (error)  return
    call gr4_median(treso,nchunk,0.,-1.,tres,error)
    if (error)  return
  end subroutine drift_resolution
  !
end subroutine mrtcal_chunkset_to_obs_con
!
subroutine mrtcal_chunkset_to_obs_cal(set,cal,error)
  use gildas_def
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_cal
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Define the calibration section suited for the stitched chunks
  !---------------------------------------------------------------------
  type(chunkset_t),    intent(in)    :: set
  type(class_calib_t), intent(out)   :: cal
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ichunk
  integer(kind=size_length) :: nchunk
  real(kind=4) :: r4(set%n)  ! Automatic array
  logical :: found
  !
  ! Duplicate everything from the first chunk where chopper did not
  ! fail.
  found = .false.
  do ichunk=1,set%n
    if (set%chunks(ichunk)%cal%h2omm.ne.class_bad) then
      found = .true.
      cal = set%chunks(ichunk)%cal
      exit
    endif
  enddo
  if (.not.found) then
    cal = set%chunks(1)%cal
    return
  endif
  !
  ! ... except for the parameters which vary and which are also displayed
  ! in the "calibration table". Must use the same strategy i.e. median of
  ! all valid chunks.
  !
  ! Trec
  do ichunk=1,set%n
    r4(ichunk) = set%chunks(ichunk)%cal%trec
  enddo
  nchunk = set%n
  call gr4_median(r4,nchunk,class_bad,0.,cal%trec,error)
  if (error)  return
  !
  ! atfac (Tcal)
  do ichunk=1,set%n
    r4(ichunk) = set%chunks(ichunk)%cal%atfac
    ! NB: if bad, set%chunks(ichunk)%cal%atfac is set to class_bad in
    ! mrtcal_calibrate_chopperset2loadheader
  enddo
  nchunk = set%n
  call gr4_median(r4,nchunk,class_bad,0.,cal%atfac,error)
  if (error)  return
  !
  ! h2omm
  do ichunk=1,set%n
    r4(ichunk) = set%chunks(ichunk)%cal%h2omm
  enddo
  nchunk = set%n
  call gr4_median(r4,nchunk,class_bad,0.,cal%h2omm,error)
  if (error)  return
  !
end subroutine mrtcal_chunkset_to_obs_cal
!
subroutine mrtcal_fit_to_obs_poi(fun,obs,error)
  use phys_const
  use mrtcal_messaging
  use fit_definitions
  use class_types
  use mrtcal_interfaces, except_this=>mrtcal_fit_to_obs_poi
  use mrtindex_sec_pointing
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(fit_fun),     intent(in)    :: fun
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>FIT2OBS'
  !
  if (fun%name.ne.'GAUSSIAN+BASE') then
    call mrtcal_message(seve%e,rname,'Fitted function not supported')
    error = .true.
    return
  endif
  !
  obs%head%presec(class_sec_poi_id) = .true.
  obs%head%poi%nfit(:) = 0.  ! Nullify for unused values
  obs%head%poi%nerr(:) = 0.
  !
  obs%head%poi%nline = 1
  obs%head%poi%sigba = fun%rms  ! Note that CLASS distinguishes RMS on baseline vs RMS on line
  obs%head%poi%sigra = fun%rms
  ! Note: the fit was done in arcsec, need to convert to radians
  ! Offset
  obs%head%poi%nfit(pointing_fit_offset) = fun%par(4)%value              ! [K]
  obs%head%poi%nerr(pointing_fit_offset) = fun%par(4)%error
  ! Slope
  obs%head%poi%nfit(pointing_fit_slope) = fun%par(5)%value/rad_per_sec  ! [K/rad]
  obs%head%poi%nerr(pointing_fit_slope) = fun%par(5)%error/rad_per_sec
  ! Area
  obs%head%poi%nfit(pointing_fit_area1) = fun%par(1)%value*rad_per_sec  ! [K.rad]
  obs%head%poi%nerr(pointing_fit_area1) = fun%par(1)%error*rad_per_sec
  ! Position
  obs%head%poi%nfit(pointing_fit_posi1) = fun%par(2)%value*rad_per_sec  ! [rad]
  obs%head%poi%nerr(pointing_fit_posi1) = fun%par(2)%error*rad_per_sec
  ! Width
  obs%head%poi%nfit(pointing_fit_fwhm1) = fun%par(3)%value*rad_per_sec  ! [rad]
  obs%head%poi%nerr(pointing_fit_fwhm1) = fun%par(3)%error*rad_per_sec
  !
end subroutine mrtcal_fit_to_obs_poi
!
subroutine mrtcal_chunkset_to_obs_data(set,head,datax,data1,dataw,error)
  use mrtcal_messaging
  use class_types
  use mrtcal_calib_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_data
  !---------------------------------------------------------------------
  ! @ private
  ! Merge the chunks in the chunkset to produce the CLASS observation
  ! data.
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: set
  type(header),     intent(in)    :: head
  real(kind=8),     intent(out)   :: datax(:)
  real(kind=4),     intent(out)   :: data1(:)
  real(kind=4),     intent(out)   :: dataw(:)
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>TO>OBS>DATA'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (head%gen%kind.eq.kind_spec) then
    call mrtcal_chunkset_to_obs_data_spe(set,head,data1,dataw,error)
    if (error)  return
  else
    call mrtcal_chunkset_to_obs_data_con(set,datax,data1,dataw,error)
    if (error)  return
  endif
end subroutine mrtcal_chunkset_to_obs_data
!
subroutine mrtcal_chunkset_to_obs_data_con(set,datax,data1,dataw,error)
  use mrtcal_messaging
  use class_types
  use mrtcal_calib_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_data_con
  !---------------------------------------------------------------------
  ! @ private
  ! Continuum case
  ! Merge the single-point continuum chunks into a N-points drift
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: set
  real(kind=8),     intent(out)   :: datax(:)
  real(kind=4),     intent(out)   :: data1(:)
  real(kind=4),     intent(out)   :: dataw(:)
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>TO>OBS>DATA>CON'
  type(chunk_t), pointer :: chunk
  integer(kind=4) :: ichunk,ipoin
  logical :: alongx,alongy
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  alongx = set%chunks(1)%offset(2).eq.set%chunks(set%n)%offset(2)
  alongy = set%chunks(1)%offset(1).eq.set%chunks(set%n)%offset(1)
  if ((.not.alongx) .and. (.not.alongy)) then
    call mrtcal_message(seve%e,rname,'Rotated drifts are not yet supported')
    error = .true.
    return
  endif
  !
  datax(:) = 0.d0
  data1(:) = 0.0
  dataw(:) = 0.0
  !
  do ichunk=1,set%n
    chunk => set%chunks(ichunk)
    if (chunk%ndata.ne.1) then
      call mrtcal_message(seve%e,rname,'Unexpected chunk size')
      error = .true.
      return
    endif
    !
    ! ZZZ Assume no sorting is needed
    if (alongx) then
      datax(ichunk) = chunk%offset(1)
    elseif (alongy) then
      datax(ichunk) = chunk%offset(2)
    else
      ! ZZZ MIRA for not obvious formula
    endif
    data1(ichunk) = chunk%data1(1)
    dataw(ichunk) = 1.0
  enddo ! ichunk
  ! Normalize
  do ipoin=1,set%n
     if ((dataw(ipoin).ne.0.0).and.(data1(ipoin).ne.bad)) then
        data1(ipoin) = data1(ipoin)/dataw(ipoin)
     else
        data1(ipoin) = bad
     endif
  enddo ! ipoin
  !
end subroutine mrtcal_chunkset_to_obs_data_con
!
subroutine mrtcal_chunkset_to_obs_data_spe(set,head,data1,dataw,error)
  use mrtcal_messaging
  use class_types
  use mrtcal_calib_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_to_obs_data_spe
  !---------------------------------------------------------------------
  ! @ private
  ! Simple stitching. No resampling is foreseen.
  ! However, we check that the frequency axes are aligned.
  ! A simple average is performed for channels which are present in more
  ! than one chunk (use the SET BAD OR policy of CLASS).
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: set
  type(header),     intent(in)    :: head
  real(kind=4),     intent(out)   :: data1(:)
  real(kind=4),     intent(out)   :: dataw(:)
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>TO>OBS>DATA>SPE'
  type(chunk_t), pointer :: chunk
  real(kind=4) :: cleft,cright
  integer(kind=4) :: ichunk,cmin,cmax,ichan,jchan
  character(len=message_length) :: mess
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  data1(:) = 0.0
  dataw(:) = 0.0
  !
  do ichunk=1,set%n
     chunk => set%chunks(ichunk)
     !
     cleft = head%spe%rchan +  &
          (1.d0-chunk%spe%rchan) * (chunk%spe%fres/head%spe%fres)
     cright = head%spe%rchan + &
          (chunk%spe%nchan-chunk%spe%rchan) * (chunk%spe%fres/head%spe%fres)
     !
     cmin = nint(cleft)
     if (abs(cleft-cmin).gt.spacing(cleft)) then  ! Single precision comparison
        ! Tolerate 1 epsilon, but there is no warranty we do not cumulate
        ! several epsilons in the cleft/cright computations above.
        write(mess,'(a,i0,a,i0,a,f0.10)') &
             'Left edge of chunk #',ichunk,' is not aligned on the stitched frequency axis: ',&
             cmin,' vs ',cleft
        call mrtcal_message(seve%w,rname,mess)
     endif
     !
     cmax = nint(cright)
     if (abs(cright-cmax).gt.spacing(cright)) then  ! Single precision comparison
        ! Tolerate 1 epsilon, but there is no warranty we do not cumulate
        ! several epsilons in the cleft/cright computations above.
        write(mess,'(a,i0,a,i0,a,f0.10)') &
             'Right edge of chunk #',ichunk,' is not aligned on the stitched frequency axis: ',&
             cmax,' vs ',cright
        call mrtcal_message(seve%w,rname,mess)
     endif
     !
     cmin = min(nint(cleft),nint(cright))
     cmax = max(nint(cleft),nint(cright))
     if ((cmin.lt.1).or.(head%spe%nchan.lt.cmin)) then
        write(mess,'(a,i0,a,i0,a,i0,a)') &
             'Left edge of chunk #',ichunk,' (',cmin,&
             ') is outside of authorized range (1-',&
             head%spe%nchan,')'
        call mrtcal_message(seve%e,rname,mess)
        error = .true.
        return
     endif
     if ((cmax.lt.1).or.(head%spe%nchan.lt.cmax)) then
        write(mess,'(a,i0,a,i0,a,i0,a)') &
             'Right edge of chunk #',ichunk,' (',cmax,&
             ') is outside of authorized range (1,',&
             head%spe%nchan,')'
        call mrtcal_message(seve%e,rname,mess)
        error = .true.
        return
     endif
     !
     if ((cmax-cmin+1).eq.chunk%ndata) then
        if (chunk%spe%fres.gt.0.d0) then !  ZZZ Use sign() intrinsic for comparison
           do ichan=1,chunk%ndata
              jchan=cmin+(ichan-1)
              if (chunk%data1(ichan).ne.bad) then
                 data1(jchan) = data1(jchan)+chunk%data1(ichan)
                 dataw(jchan) = dataw(jchan)+1.0
              endif
           enddo ! ichan
        else
           do ichan=1,chunk%ndata
              jchan=cmax-(ichan-1)
              if (chunk%data1(ichan).ne.bad) then
                 data1(jchan) = data1(jchan)+chunk%data1(ichan)
                 dataw(jchan) = dataw(jchan)+1.0
              endif
           enddo ! ichan
        endif
     else
        call mrtcal_message(seve%w,rname,'Incorrect number of channels')
        error = .true.
        return
     endif
  enddo ! ichunk
  ! Normalize
  do ichan=1,head%spe%nchan
     if ((dataw(ichan).ne.0.0).and.(data1(ichan).ne.bad)) then
        data1(ichan) = data1(ichan)/dataw(ichan)
     else
        data1(ichan) = bad
     endif
  enddo ! ichan
  !
end subroutine mrtcal_chunkset_to_obs_data_spe
!
subroutine mrtcal_obs_to_class(obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_obs_to_class
  use mrtcal_buffers
  !---------------------------------------------------------------------
  ! @ private
  !  Write the observation to the current Class file
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  !
  if (rsetup%out%vdirection) then
    ! Recompute the Doppler factor at actual position. Depending on
    ! the observing mode (in particular OTF), the Doppler factor
    ! found in the IMB-FITS was computed at the reference position
    ! (not the actual position)
    ! NB: this must come after header (in particular head%gen, head%pos,
    ! and head%spe) and all data are written to the observation ("all
    ! data" means all arrays, including Associated Arrays)
    call class_modify_vdirection(obs%head,error)
    if (error)  return
  endif
  !
  call class_obs_write(obs,error)
  if (error)  return
  !
end subroutine mrtcal_obs_to_class
!
function mrtcal_user_function(action)
  use mrtcal_interfaces, except_this=>mrtcal_user_function
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical :: mrtcal_user_function
  character(len=*), intent(in) :: action
  mrtcal_user_function = .false.
end function mrtcal_user_function
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_toclass_user(mydata,version,error)
  use mrtcal_messaging
  use class_api
  use mrtcal_interfaces, except_this=>mrtcal_toclass_user
  use mrtcal_chunk_types
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Transfer and order the input 'mydata' object to the internal Class
  ! data buffer.
  !---------------------------------------------------------------------
  type(mrtcal_classuser_t), intent(in)    :: mydata   !
  integer(kind=4),          intent(in)    :: version  ! The version of the data
  logical,                  intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='TOCLASS>USER'
  character(len=message_length) :: mess
  !
  if (version.ne.1) then
    write(mess,'(A,I0)')  'Unsupported data version ',version
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  call class_user_datatoclass(mydata%obstype)
  call class_user_datatoclass(mydata%noise)
  call class_user_datatoclass(mydata%backeff)
  call class_user_datatoclass(mydata%airmass)
  call class_user_datatoclass(mydata%expatau)
  !
end subroutine mrtcal_toclass_user
!
subroutine mrtcal_fromclass_user(mydata,version,error)
  use mrtcal_messaging
  use class_api
  use mrtcal_interfaces, except_this=>mrtcal_fromclass_user
  use mrtcal_chunk_types
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Transfer the data values from the Class data buffer to the 'mydata'
  ! instance.
  !---------------------------------------------------------------------
  type(mrtcal_classuser_t), intent(out)   :: mydata   !
  integer(kind=4),          intent(in)    :: version  ! The version of the data
  logical,                  intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FROMCLASS>USER'
  character(len=message_length) :: mess
  !
  if (version.ne.1) then
    write(mess,'(A,I0)')  'Unsupported data version ',version
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  call class_user_classtodata(mydata%obstype)
  call class_user_classtodata(mydata%noise)
  call class_user_classtodata(mydata%backeff)
  call class_user_classtodata(mydata%airmass)
  call class_user_classtodata(mydata%expatau)
  !
end subroutine mrtcal_fromclass_user
!
subroutine mrtcal_user_dump(version,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_user_dump
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Dump to screen the Mrtcal User Subsection
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: version ! The version of the data
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  type(mrtcal_classuser_t) :: mydata
  !
  call mrtcal_fromclass_user(mydata,version,error) ! Read the Class buffer and fill mydata
  if (error) return
  !
  ! Display to screen
  print *,"     obstype = ",mydata%obstype,' (',mrtindex_obstype(mydata%obstype),')'
  print *,"     noise   = ",mydata%noise
  print *,"     backeff = ",mydata%backeff
  print *,"     airmass = ",mydata%airmass
  print *,"     expatau = ",mydata%expatau
  !
end subroutine mrtcal_user_dump
!
subroutine mrtcal_user_setvar(version,error)
  use class_api
  use mrtcal_interfaces, except_this=>mrtcal_user_setvar
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Define SIC variables in the structure R%USER%OWNER% which map the
  ! subsection content.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: version ! The version of the data
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: ndim,dims(4)
  !
  ndim = 0
  dims(:) = 0
  call class_user_def_inte('OBSTYPE',ndim,dims,error)
  call class_user_def_real('NOISE',  ndim,dims,error)
  call class_user_def_real('BACKEFF',ndim,dims,error)
  call class_user_def_real('AIRMASS',ndim,dims,error)
  call class_user_def_real('EXPATAU',ndim,dims,error)
  if (error) return
  !
end subroutine mrtcal_user_setvar
!
subroutine mrtcal_user_fix(version,found,error)
  use mrtcal_interfaces, except_this=>mrtcal_user_fix
  use mrtcal_index_vars
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Hook to command:
  !   LAS\FIND /USER
  !  Find or not according the Mrtcal User Subsection. Called only if
  ! the observation has a user section and it matches the one
  ! declared here.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: version  ! The version of the data
  logical,         intent(out)   :: found    !
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  type(mrtcal_classuser_t) :: mydata
  !
  call mrtcal_fromclass_user(mydata,version,error) ! Read the Class buffer and fill mydata
  if (error) return
  !
  found = userfind%ltypes(mydata%obstype)
  !
end subroutine mrtcal_user_fix
!
subroutine mrtcal_user_find(arg,narg,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_user_find
  use mrtcal_index_vars
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Hook to command:
  !   LAS\FIND /USER [Arg1] ... [ArgN]
  ! Command line parsing: retrieve the arguments given to the option.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: narg       !
  character(len=*), intent(in)    :: arg(narg)  !
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND>USER'
  integer(kind=4) :: iarg,ikey
  character(len=32) :: key
  character(len=obstype_length) :: obstype
  character(len=obstype_length) :: obstypes(nobstypes_mrtcal+1)
  !
  ! ZZZ This stupid code duplicates the obstypes from lib-mrtindex!
  do ikey=0,nobstypes_mrtcal
    obstypes(ikey+1) = mrtindex_obstype(ikey)
  enddo
  !
  userfind%ltypes(:) = .false.
  do iarg=1,narg
    obstype = arg(iarg)
    call sic_upper(obstype)
    call sic_ambigs(rname,obstype,key,ikey,obstypes,nobstypes_mrtcal+1,error)
    if (error)  return
    !
    userfind%ltypes(ikey-1) = .true.
  enddo
  !
end subroutine mrtcal_user_find
!
subroutine mrtcal_user_varidx_fill(version,ient,error)
  use classic_api
  use mrtcal_interfaces, except_this=>mrtcal_user_varidx_fill
  use mrtcal_calib_types
  use mrtcal_sicidx
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Hook to command:
  !   EXP\VARIABLE USER /INDEX  (array filling part)
  ! Fill the arrays supporting the structure IDX%USER%
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: version  ! The version of the data
  integer(kind=entry_length), intent(in)    :: ient     !
  logical,                    intent(inout) :: error    ! Logical error flag
  ! Local
  type(mrtcal_classuser_t) :: mydata
  !
  call mrtcal_fromclass_user(mydata,version,error) ! Read the Class buffer and fill mydata
  if (error) return
  !
  idxuser%obstype(ient) = mydata%obstype
  idxuser%noise(ient)   = mydata%noise
  idxuser%backeff(ient) = mydata%backeff
  idxuser%airmass(ient) = mydata%airmass
  idxuser%expatau(ient) = mydata%expatau
  !
end subroutine mrtcal_user_varidx_fill
!
subroutine mrtcal_user_varidx_defvar(error)
  use classic_api
  use mrtcal_dependencies_interfaces
  use mrtcal_sicidx
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Hook to command:
  !   EXP\VARIABLE USER /INDEX  (variables definition)
  ! Define the Sic arrays in IDX%USER%30M%MRTCAL%
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call class_user_varidx_def_inte('OBSTYPE',idxuser%obstype,error)
  if (error)  return
  call class_user_varidx_def_real('NOISE',  idxuser%noise,  error)
  if (error)  return
  call class_user_varidx_def_real('BACKEFF',idxuser%backeff,error)
  if (error)  return
  call class_user_varidx_def_real('AIRMASS',idxuser%airmass,error)
  if (error)  return
  call class_user_varidx_def_real('EXPATAU',idxuser%expatau,error)
  if (error)  return
  !
end subroutine mrtcal_user_varidx_defvar
!
subroutine mrtcal_user_varidx_realloc(nent,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use mrtcal_interfaces, except_this=>mrtcal_user_varidx_realloc
  use mrtcal_sicidx
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Hook to command:
  !   EXP\VARIABLE USER /INDEX  (re/deallocation part)
  ! Re/Deallocate the support arrays. nent <= 0 means deallocation only
  ! (useful at exit time)
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)    :: nent     !
  logical,                    intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='REALLOCATE'
  logical :: realloc
  integer(kind=4) :: ier
  !
  if (allocated(idxuser%obstype)) then
    realloc = size(idxuser%obstype).lt.nent
    if (nent.le.0 .or. realloc) then
      deallocate(idxuser%obstype,idxuser%noise,idxuser%backeff)
      deallocate(idxuser%airmass,idxuser%expatau)
    endif
  else
    realloc = nent.gt.0
  endif
  !
  if (realloc .and. nent.gt.0) then
    allocate(idxuser%obstype(nent),idxuser%noise(nent),  stat=ier)
    allocate(idxuser%backeff(nent),idxuser%airmass(nent),stat=ier)
    allocate(idxuser%expatau(nent),                      stat=ier)
    if (failed_allocate(rname,'IDXUSER arrays',ier,error))  return
  endif
  !
end subroutine mrtcal_user_varidx_realloc
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubelist_object_advanced_class
  use cubelist_messaging
  use cubelist_object_class
  !---------------------------------------------------------------------
  ! An "advanced object" is the same as the basic 'list_object_t' except
  ! it has properties which can be listed (e.g. LIST), filtered (e.g.
  ! FIND), instantiated (e.g. VARIABLE).
  !
  ! The counterpart is that such object must provide get_value_*
  ! methods.
  !---------------------------------------------------------------------
  !
  public :: list_object_advanced_t
  public :: cubelist_object_advanced_ptr
  private
  !
  type, abstract, extends(list_object_t) :: list_object_advanced_t
    logical, public :: hidden = .false.  ! Hidden to LIST, FIND, etc
  contains
    procedure, public :: hide => cubelist_object_advanced_hide
    generic,   public :: get_value => get_value_i4,get_value_i8,  &
                                      get_value_r4,get_value_r8,  &
                                      get_value_cc
    procedure(get_value_i4_interface), deferred         :: get_value_i4  ! [private]
    procedure(get_value_i8_interface), deferred         :: get_value_i8  ! [private]
    procedure(get_value_r4_interface), deferred         :: get_value_r4  ! [private]
    procedure(get_value_r8_interface), deferred         :: get_value_r8  ! [private]
    procedure(get_value_cc_interface), deferred         :: get_value_cc  ! [private]
    procedure(get_lrepr_interface),    deferred, public :: get_lrepr
    procedure(get_repr_interface),     deferred, public :: get_repr
  end type list_object_advanced_t
  !
  abstract interface
    subroutine get_value_i4_interface(obj,name,found,value,error)
      import list_object_advanced_t
      !-------------------------------------------------------------------
      ! Get an I*4 property from an object.
      ! - Found is set to .false. if the named property does not exist for
      !   this object. This is not an error: you do not want LIST or FIND
      !   to fail on an heterogeneous index. Input 'value' is preserved.
      ! - Found is set to .true. if the named property exists and is
      !   indeed an I*4; value returned in 'value'.
      ! - Error is set to .true. if the named property exists but is not
      !   I*4. This is considered as a programming error (programmer
      !   mistake: he used the wrong combination of "name" and 'value'
      !   kind).
      !-------------------------------------------------------------------
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      integer(kind=4),               intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_i4_interface
    subroutine get_value_i8_interface(obj,name,found,value,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      integer(kind=8),               intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_i8_interface
    subroutine get_value_r4_interface(obj,name,found,value,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      real(kind=4),                  intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_r4_interface
    subroutine get_value_r8_interface(obj,name,found,value,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      real(kind=8),                  intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_r8_interface
    subroutine get_value_cc_interface(obj,name,found,value,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      character(len=*),              intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_cc_interface
    !
    subroutine get_lrepr_interface(obj,name,width,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      integer(kind=4),               intent(out)   :: width ! Computed column width
      logical,                       intent(inout) :: error
    end subroutine get_lrepr_interface
    subroutine get_repr_interface(obj,name,width,repr,nline,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(inout) :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      integer(kind=4),               intent(in)    :: width ! Expected column width
      character(len=*),              intent(out)   :: repr(:)
      integer(kind=4),               intent(out)   :: nline
      logical,                       intent(inout) :: error
    end subroutine get_repr_interface
  end interface
  !
contains
  !
  function cubelist_object_advanced_ptr(obj,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(list_object_advanced_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(list_object_advanced_t), pointer :: cubelist_object_advanced_ptr
    class(list_object_t), pointer       :: obj
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBJECT>ADVANCED>PTR'
    !
    select type(obj)
    class is (list_object_advanced_t)
      cubelist_object_advanced_ptr => obj
    class default
      cubelist_object_advanced_ptr => null()
      call cubelist_message(seve%e,rname,  &
        'Internal error: object is not a list_object_advanced_t type')
      error = .true.
      return
    end select
  end function cubelist_object_advanced_ptr
  !
  subroutine cubelist_object_advanced_hide(obj)
    class(list_object_advanced_t), intent(inout) :: obj
    obj%hidden = .true.
  end subroutine cubelist_object_advanced_hide
end module cubelist_object_advanced_class

subroutine init_alma_fits(unit,fich,error)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Initialise an ALMA FITS file.
  !---------------------------------------------------------------------
  integer :: unit                   !
  character(len=*) :: fich          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  ! Local
  character(len=20) :: version
  !
  integer :: status, blocksize, bitpix, naxis, naxes(2)
  logical :: simple, extend
  !------------------------------------------------------------------------
  include 'clic_version.inc'
  !
  status = 0
  !  Get an unused Logical Unit Number to use to open the FITS file.
  if (unit.eq.-999) then
    call ftgiou(unit,status)
  endif
  if (status .gt. 0) goto 99
  !  Create the new empty FITS file.  The blocksize parameter is a
  !  historical artifact and the value is ignored by FITSIO.
  blocksize = 1
  call ftinit(unit, fich, blocksize, status)
  if (status .gt. 0) goto 99
  !  Initialize parameters about the FITS image.
  simple=.true.
  bitpix=32
  naxis=2
  naxes(1) = 0
  naxes(2) = 0
  extend=.true.
  !  Write the required header keywords to the file
  call ftphpr(unit,simple,bitpix,naxis,naxes,0,0,extend,status)
  if (status .gt. 0) goto 99
  call ftpcom(unit,   &
    'This file conforms to the ALMA-TestInterferometer standard',   &
    status)
  if (status .gt. 0) goto 99
  call ftpcom(unit,   &
    'v1.0, 2001-07-03 see Lucas and Glendenning, 2001',status)
  call ftpcom(unit,   &
    'http://www.alma.nrao.edu/development/computing/docs/memos/',   &
    status)
  !
  if (status .gt. 0) goto 99
  !      CALL FTPKYJ(UNIT,'PCOUNT',0,'Size of special data area',STATUS)
  !      IF (STATUS .GT. 0) GOTO 99
  !      CALL FTPKYJ(UNIT,'GCOUNT',0,'Data groups',STATUS)
  !      CALL FTPKYL(UNIT,'GROUPS',.TRUE.,'...',STATUS)
  call ftpkys(unit,'ORIGIN','ALMA'//version,   &
    'Organization or Institution',status)
  call ftpkys(unit,'CREATOR','CLIC '//version,   &
    'Program name and version',status)
  call ftpkys(unit,'TELESCOP','(simulated)',   &
    'Telescope name',status)
  if (status .gt. 0) goto 99
  return
99 call printerror('INIT_ALMA_FITS',status)
  error = .true.
  return
end subroutine init_alma_fits

*DECK SQRDC
      SUBROUTINE SQRDC (X, LDX, N, P, QRAUX, JPVT, WORK, JOB)
C***BEGIN PROLOGUE  SQRDC
C***PURPOSE  Use Householder transformations to compute the QR
C            factorization of an N by P matrix.  Column pivoting is a
C            users option.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D5
C***TYPE      SINGLE PRECISION (SQRDC-S, DQRDC-D, CQRDC-C)
C***KEYWORDS  LINEAR ALGEBRA, LINPACK, MATRIX, ORTHOGONAL TRIANGULAR,
C             QR DECOMPOSITION
C***AUTHOR  Stewart, G. W., (U. of Maryland)
C***DESCRIPTION
C
C     SQRDC uses Householder transformations to compute the QR
C     factorization of an N by P matrix X.  Column pivoting
C     based on the 2-norms of the reduced columns may be
C     performed at the user's option.
C
C     On Entry
C
C        X       REAL(LDX,P), where LDX .GE. N.
C                X contains the matrix whose decomposition is to be
C                computed.
C
C        LDX     INTEGER.
C                LDX is the leading dimension of the array X.
C
C        N       INTEGER.
C                N is the number of rows of the matrix X.
C
C        P       INTEGER.
C                P is the number of columns of the matrix X.
C
C        JPVT    INTEGER(P).
C                JPVT contains integers that control the selection
C                of the pivot columns.  The K-th column X(K) of X
C                is placed in one of three classes according to the
C                value of JPVT(K).
C
C                   If JPVT(K) .GT. 0, then X(K) is an initial
C                                      column.
C
C                   If JPVT(K) .EQ. 0, then X(K) is a free column.
C
C                   If JPVT(K) .LT. 0, then X(K) is a final column.
C
C                Before the decomposition is computed, initial columns
C                are moved to the beginning of the array X and final
C                columns to the end.  Both initial and final columns
C                are frozen in place during the computation and only
C                free columns are moved.  At the K-th stage of the
C                reduction, if X(K) is occupied by a free column,
C                it is interchanged with the free column of largest
C                reduced norm.  JPVT is not referenced if
C                JOB .EQ. 0.
C
C        WORK    REAL(P).
C                WORK is a work array.  WORK is not referenced if
C                JOB .EQ. 0.
C
C        JOB     INTEGER.
C                JOB is an integer that initiates column pivoting.
C                If JOB .EQ. 0, no pivoting is done.
C                If JOB .NE. 0, pivoting is done.
C
C     On Return
C
C        X       X contains in its upper triangle the upper
C                triangular matrix R of the QR factorization.
C                Below its diagonal X contains information from
C                which the orthogonal part of the decomposition
C                can be recovered.  Note that if pivoting has
C                been requested, the decomposition is not that
C                of the original matrix X but that of X
C                with its columns permuted as described by JPVT.
C
C        QRAUX   REAL(P).
C                QRAUX contains further information required to recover
C                the orthogonal part of the decomposition.
C
C        JPVT    JPVT(K) contains the index of the column of the
C                original matrix that has been interchanged into
C                the K-th column, if pivoting was requested.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SDOT, SNRM2, SSCAL, SSWAP
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SQRDC
      INTEGER LDX,N,P,JOB
      INTEGER JPVT(*)
      REAL X(LDX,*),QRAUX(*),WORK(*)
C
      INTEGER J,JP,L,LP1,LUP,MAXJ,PL,PU
      REAL MAXNRM,SNRM2,TT
      REAL SDOT,NRMXL,T
      LOGICAL NEGJ,SWAPJ
C
C***FIRST EXECUTABLE STATEMENT  SQRDC
      PL = 1
      PU = 0
      IF (JOB .EQ. 0) GO TO 60
C
C        PIVOTING HAS BEEN REQUESTED.  REARRANGE THE COLUMNS
C        ACCORDING TO JPVT.
C
         DO 20 J = 1, P
            SWAPJ = JPVT(J) .GT. 0
            NEGJ = JPVT(J) .LT. 0
            JPVT(J) = J
            IF (NEGJ) JPVT(J) = -J
            IF (.NOT.SWAPJ) GO TO 10
               IF (J .NE. PL) CALL SSWAP(N,X(1,PL),1,X(1,J),1)
               JPVT(J) = JPVT(PL)
               JPVT(PL) = J
               PL = PL + 1
   10       CONTINUE
   20    CONTINUE
         PU = P
         DO 50 JJ = 1, P
            J = P - JJ + 1
            IF (JPVT(J) .GE. 0) GO TO 40
               JPVT(J) = -JPVT(J)
               IF (J .EQ. PU) GO TO 30
                  CALL SSWAP(N,X(1,PU),1,X(1,J),1)
                  JP = JPVT(PU)
                  JPVT(PU) = JPVT(J)
                  JPVT(J) = JP
   30          CONTINUE
               PU = PU - 1
   40       CONTINUE
   50    CONTINUE
   60 CONTINUE
C
C     COMPUTE THE NORMS OF THE FREE COLUMNS.
C
      IF (PU .LT. PL) GO TO 80
      DO 70 J = PL, PU
         QRAUX(J) = SNRM2(N,X(1,J),1)
         WORK(J) = QRAUX(J)
   70 CONTINUE
   80 CONTINUE
C
C     PERFORM THE HOUSEHOLDER REDUCTION OF X.
C
      LUP = MIN(N,P)
      DO 200 L = 1, LUP
         IF (L .LT. PL .OR. L .GE. PU) GO TO 120
C
C           LOCATE THE COLUMN OF LARGEST NORM AND BRING IT
C           INTO THE PIVOT POSITION.
C
            MAXNRM = 0.0E0
            MAXJ = L
            DO 100 J = L, PU
               IF (QRAUX(J) .LE. MAXNRM) GO TO 90
                  MAXNRM = QRAUX(J)
                  MAXJ = J
   90          CONTINUE
  100       CONTINUE
            IF (MAXJ .EQ. L) GO TO 110
               CALL SSWAP(N,X(1,L),1,X(1,MAXJ),1)
               QRAUX(MAXJ) = QRAUX(L)
               WORK(MAXJ) = WORK(L)
               JP = JPVT(MAXJ)
               JPVT(MAXJ) = JPVT(L)
               JPVT(L) = JP
  110       CONTINUE
  120    CONTINUE
         QRAUX(L) = 0.0E0
         IF (L .EQ. N) GO TO 190
C
C           COMPUTE THE HOUSEHOLDER TRANSFORMATION FOR COLUMN L.
C
            NRMXL = SNRM2(N-L+1,X(L,L),1)
            IF (NRMXL .EQ. 0.0E0) GO TO 180
               IF (X(L,L) .NE. 0.0E0) NRMXL = SIGN(NRMXL,X(L,L))
               CALL SSCAL(N-L+1,1.0E0/NRMXL,X(L,L),1)
               X(L,L) = 1.0E0 + X(L,L)
C
C              APPLY THE TRANSFORMATION TO THE REMAINING COLUMNS,
C              UPDATING THE NORMS.
C
               LP1 = L + 1
               IF (P .LT. LP1) GO TO 170
               DO 160 J = LP1, P
                  T = -SDOT(N-L+1,X(L,L),1,X(L,J),1)/X(L,L)
                  CALL SAXPY(N-L+1,T,X(L,L),1,X(L,J),1)
                  IF (J .LT. PL .OR. J .GT. PU) GO TO 150
                  IF (QRAUX(J) .EQ. 0.0E0) GO TO 150
                     TT = 1.0E0 - (ABS(X(L,J))/QRAUX(J))**2
                     TT = MAX(TT,0.0E0)
                     T = TT
                     TT = 1.0E0 + 0.05E0*TT*(QRAUX(J)/WORK(J))**2
                     IF (TT .EQ. 1.0E0) GO TO 130
                        QRAUX(J) = QRAUX(J)*SQRT(T)
                     GO TO 140
  130                CONTINUE
                        QRAUX(J) = SNRM2(N-L,X(L+1,J),1)
                        WORK(J) = QRAUX(J)
  140                CONTINUE
  150             CONTINUE
  160          CONTINUE
  170          CONTINUE
C
C              SAVE THE TRANSFORMATION.
C
               QRAUX(L) = X(L,L)
               X(L,L) = -NRMXL
  180       CONTINUE
  190    CONTINUE
  200 CONTINUE
      RETURN
      END
*DECK SQRSL
      SUBROUTINE SQRSL (X, LDX, N, K, QRAUX, Y, QY, QTY, B, RSD, XB,
     +   JOB, INFO)
C***BEGIN PROLOGUE  SQRSL
C***PURPOSE  Apply the output of SQRDC to compute coordinate transfor-
C            mations, projections, and least squares solutions.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D9, D2A1
C***TYPE      SINGLE PRECISION (SQRSL-S, DQRSL-D, CQRSL-C)
C***KEYWORDS  LINEAR ALGEBRA, LINPACK, MATRIX, ORTHOGONAL TRIANGULAR,
C             SOLVE
C***AUTHOR  Stewart, G. W., (U. of Maryland)
C***DESCRIPTION
C
C     SQRSL applies the output of SQRDC to compute coordinate
C     transformations, projections, and least squares solutions.
C     For K .LE. MIN(N,P), let XK be the matrix
C
C            XK = (X(JPVT(1)),X(JPVT(2)), ... ,X(JPVT(K)))
C
C     formed from columns JPVT(1), ... ,JPVT(K) of the original
C     N x P matrix X that was input to SQRDC (if no pivoting was
C     done, XK consists of the first K columns of X in their
C     original order).  SQRDC produces a factored orthogonal matrix Q
C     and an upper triangular matrix R such that
C
C              XK = Q * (R)
C                       (0)
C
C     This information is contained in coded form in the arrays
C     X and QRAUX.
C
C     On Entry
C
C        X      REAL(LDX,P)
C               X contains the output of SQRDC.
C
C        LDX    INTEGER
C               LDX is the leading dimension of the array X.
C
C        N      INTEGER
C               N is the number of rows of the matrix XK.  It must
C               have the same value as N in SQRDC.
C
C        K      INTEGER
C               K is the number of columns of the matrix XK.  K
C               must not be greater than MIN(N,P), where P is the
C               same as in the calling sequence to SQRDC.
C
C        QRAUX  REAL(P)
C               QRAUX contains the auxiliary output from SQRDC.
C
C        Y      REAL(N)
C               Y contains an N-vector that is to be manipulated
C               by SQRSL.
C
C        JOB    INTEGER
C               JOB specifies what is to be computed.  JOB has
C               the decimal expansion ABCDE, with the following
C               meaning.
C
C                    If A .NE. 0, compute QY.
C                    If B,C,D, or E .NE. 0, compute QTY.
C                    If C .NE. 0, compute B.
C                    If D .NE. 0, compute RSD.
C                    If E .NE. 0, compute XB.
C
C               Note that a request to compute B, RSD, or XB
C               automatically triggers the computation of QTY, for
C               which an array must be provided in the calling
C               sequence.
C
C     On Return
C
C        QY     REAL(N).
C               QY contains Q*Y, if its computation has been
C               requested.
C
C        QTY    REAL(N).
C               QTY contains TRANS(Q)*Y, if its computation has
C               been requested.  Here TRANS(Q) is the
C               transpose of the matrix Q.
C
C        B      REAL(K)
C               B contains the solution of the least squares problem
C
C                    minimize norm2(Y - XK*B),
C
C               if its computation has been requested.  (Note that
C               if pivoting was requested in SQRDC, the J-th
C               component of B will be associated with column JPVT(J)
C               of the original matrix X that was input into SQRDC.)
C
C        RSD    REAL(N).
C               RSD contains the least squares residual Y - XK*B,
C               if its computation has been requested.  RSD is
C               also the orthogonal projection of Y onto the
C               orthogonal complement of the column space of XK.
C
C        XB     REAL(N).
C               XB contains the least squares approximation XK*B,
C               if its computation has been requested.  XB is also
C               the orthogonal projection of Y onto the column space
C               of X.
C
C        INFO   INTEGER.
C               INFO is zero unless the computation of B has
C               been requested and R is exactly singular.  In
C               this case, INFO is the index of the first zero
C               diagonal element of R and B is left unaltered.
C
C     The parameters QY, QTY, B, RSD, and XB are not referenced
C     if their computation is not requested and in this case
C     can be replaced by dummy variables in the calling program.
C     To save storage, the user may in some cases use the same
C     array for different parameters in the calling sequence.  A
C     frequently occurring example is when one wishes to compute
C     any of B, RSD, or XB and does not need Y or QTY.  In this
C     case one may identify Y, QTY, and one of B, RSD, or XB, while
C     providing separate arrays for anything else that is to be
C     computed.  Thus the calling sequence
C
C          CALL SQRSL(X,LDX,N,K,QRAUX,Y,DUM,Y,B,Y,DUM,110,INFO)
C
C     will result in the computation of B and RSD, with RSD
C     overwriting Y.  More generally, each item in the following
C     list contains groups of permissible identifications for
C     a single calling sequence.
C
C          1. (Y,QTY,B) (RSD) (XB) (QY)
C
C          2. (Y,QTY,RSD) (B) (XB) (QY)
C
C          3. (Y,QTY,XB) (B) (RSD) (QY)
C
C          4. (Y,QY) (QTY,B) (RSD) (XB)
C
C          5. (Y,QY) (QTY,RSD) (B) (XB)
C
C          6. (Y,QY) (QTY,XB) (B) (RSD)
C
C     In any group the value returned in the array allocated to
C     the group corresponds to the last member of the group.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SCOPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SQRSL
      INTEGER LDX,N,K,JOB,INFO
      REAL X(LDX,*),QRAUX(*),Y(*),QY(*),QTY(*),B(*),RSD(*),XB(*)
C
      INTEGER I,J,JJ,JU,KP1
      REAL SDOT,T,TEMP
      LOGICAL CB,CQY,CQTY,CR,CXB
C***FIRST EXECUTABLE STATEMENT  SQRSL
C
C     SET INFO FLAG.
C
      INFO = 0
C
C     DETERMINE WHAT IS TO BE COMPUTED.
C
      CQY = JOB/10000 .NE. 0
      CQTY = MOD(JOB,10000) .NE. 0
      CB = MOD(JOB,1000)/100 .NE. 0
      CR = MOD(JOB,100)/10 .NE. 0
      CXB = MOD(JOB,10) .NE. 0
      JU = MIN(K,N-1)
C
C     SPECIAL ACTION WHEN N=1.
C
      IF (JU .NE. 0) GO TO 40
         IF (CQY) QY(1) = Y(1)
         IF (CQTY) QTY(1) = Y(1)
         IF (CXB) XB(1) = Y(1)
         IF (.NOT.CB) GO TO 30
            IF (X(1,1) .NE. 0.0E0) GO TO 10
               INFO = 1
            GO TO 20
   10       CONTINUE
               B(1) = Y(1)/X(1,1)
   20       CONTINUE
   30    CONTINUE
         IF (CR) RSD(1) = 0.0E0
      GO TO 250
   40 CONTINUE
C
C        SET UP TO COMPUTE QY OR QTY.
C
         IF (CQY) CALL SCOPY(N,Y,1,QY,1)
         IF (CQTY) CALL SCOPY(N,Y,1,QTY,1)
         IF (.NOT.CQY) GO TO 70
C
C           COMPUTE QY.
C
            DO 60 JJ = 1, JU
               J = JU - JJ + 1
               IF (QRAUX(J) .EQ. 0.0E0) GO TO 50
                  TEMP = X(J,J)
                  X(J,J) = QRAUX(J)
                  T = -SDOT(N-J+1,X(J,J),1,QY(J),1)/X(J,J)
                  CALL SAXPY(N-J+1,T,X(J,J),1,QY(J),1)
                  X(J,J) = TEMP
   50          CONTINUE
   60       CONTINUE
   70    CONTINUE
         IF (.NOT.CQTY) GO TO 100
C
C           COMPUTE TRANS(Q)*Y.
C
            DO 90 J = 1, JU
               IF (QRAUX(J) .EQ. 0.0E0) GO TO 80
                  TEMP = X(J,J)
                  X(J,J) = QRAUX(J)
                  T = -SDOT(N-J+1,X(J,J),1,QTY(J),1)/X(J,J)
                  CALL SAXPY(N-J+1,T,X(J,J),1,QTY(J),1)
                  X(J,J) = TEMP
   80          CONTINUE
   90       CONTINUE
  100    CONTINUE
C
C        SET UP TO COMPUTE B, RSD, OR XB.
C
         IF (CB) CALL SCOPY(K,QTY,1,B,1)
         KP1 = K + 1
         IF (CXB) CALL SCOPY(K,QTY,1,XB,1)
         IF (CR .AND. K .LT. N) CALL SCOPY(N-K,QTY(KP1),1,RSD(KP1),1)
         IF (.NOT.CXB .OR. KP1 .GT. N) GO TO 120
            DO 110 I = KP1, N
               XB(I) = 0.0E0
  110       CONTINUE
  120    CONTINUE
         IF (.NOT.CR) GO TO 140
            DO 130 I = 1, K
               RSD(I) = 0.0E0
  130       CONTINUE
  140    CONTINUE
         IF (.NOT.CB) GO TO 190
C
C           COMPUTE B.
C
            DO 170 JJ = 1, K
               J = K - JJ + 1
               IF (X(J,J) .NE. 0.0E0) GO TO 150
                  INFO = J
                  GO TO 180
  150          CONTINUE
               B(J) = B(J)/X(J,J)
               IF (J .EQ. 1) GO TO 160
                  T = -B(J)
                  CALL SAXPY(J-1,T,X(1,J),1,B,1)
  160          CONTINUE
  170       CONTINUE
  180       CONTINUE
  190    CONTINUE
         IF (.NOT.CR .AND. .NOT.CXB) GO TO 240
C
C           COMPUTE RSD OR XB AS REQUIRED.
C
            DO 230 JJ = 1, JU
               J = JU - JJ + 1
               IF (QRAUX(J) .EQ. 0.0E0) GO TO 220
                  TEMP = X(J,J)
                  X(J,J) = QRAUX(J)
                  IF (.NOT.CR) GO TO 200
                     T = -SDOT(N-J+1,X(J,J),1,RSD(J),1)/X(J,J)
                     CALL SAXPY(N-J+1,T,X(J,J),1,RSD(J),1)
  200             CONTINUE
                  IF (.NOT.CXB) GO TO 210
                     T = -SDOT(N-J+1,X(J,J),1,XB(J),1)/X(J,J)
                     CALL SAXPY(N-J+1,T,X(J,J),1,XB(J),1)
  210             CONTINUE
                  X(J,J) = TEMP
  220          CONTINUE
  230       CONTINUE
  240    CONTINUE
  250 CONTINUE
      RETURN
      END
*DECK SREADP
      SUBROUTINE SREADP (IPAGE, LIST, RLIST, LPAGE, IREC)
C***BEGIN PROLOGUE  SREADP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SREADP-S, DREADP-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     READ RECORD NUMBER IRECN, OF LENGTH LPG, FROM UNIT
C     NUMBER IPAGEF INTO THE STORAGE ARRAY, LIST(*).
C     READ RECORD  IRECN+1, OF LENGTH LPG, FROM UNIT NUMBER
C     IPAGEF INTO THE STORAGE ARRAY RLIST(*).
C
C     TO CONVERT THIS PROGRAM UNIT TO DOUBLE PRECISION CHANGE
C     /REAL (12 BLANKS)/ TO /DOUBLE PRECISION/.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890605  Corrected references to XERRWV.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  SREADP
      INTEGER LIST(*)
      REAL             RLIST(*)
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  SREADP
      IPAGEF=IPAGE
      LPG   =LPAGE
      IRECN=IREC
      READ(IPAGEF,REC=IRECN,ERR=100)(LIST(I),I=1,LPG)
      READ(IPAGEF,REC=IRECN+1,ERR=100)(RLIST(I),I=1,LPG)
      RETURN
C
  100 WRITE (XERN1, '(I8)') LPG
      WRITE (XERN2, '(I8)') IRECN
      CALL XERMSG ('SLATEC', 'SREADP', 'IN SPLP, LPG = ' // XERN1 //
     *   ' IRECN = ' // XERN2, 100, 1)
      RETURN
      END
*DECK SRLCAL
      SUBROUTINE SRLCAL (N, KMP, LL, MAXL, V, Q, RL, SNORMW, PROD,
     +   R0NRM)
C***BEGIN PROLOGUE  SRLCAL
C***SUBSIDIARY
C***PURPOSE  Internal routine for SGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SRLCAL-S, DRLCAL-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C         This routine calculates the scaled residual RL from the
C         V(I)'s.
C *Usage:
C      INTEGER N, KMP, LL, MAXL
C      REAL V(N,LL), Q(2*MAXL), RL(N), SNORMW, PROD, R0NORM
C
C      CALL SRLCAL(N, KMP, LL, MAXL, V, Q, RL, SNORMW, PROD, R0NRM)
C
C *Arguments:
C N      :IN       Integer
C         The order of the matrix A, and the lengths
C         of the vectors SR, SZ, R0 and Z.
C KMP    :IN       Integer
C         The number of previous V vectors the new vector VNEW
C         must be made orthogonal to. (KMP .le. MAXL)
C LL     :IN       Integer
C         The current dimension of the Krylov subspace.
C MAXL   :IN       Integer
C         The maximum dimension of the Krylov subspace.
C V      :IN       Real V(N,LL)
C         The N x LL array containing the orthogonal vectors
C         V(*,1) to V(*,LL).
C Q      :IN       Real Q(2*MAXL)
C         A real array of length 2*MAXL containing the components
C         of the Givens rotations used in the QR decomposition
C         of HES.  It is loaded in SHEQR and used in SHELS.
C RL     :OUT      Real RL(N)
C         The residual vector RL.  This is either SB*(B-A*XL) if
C         not preconditioning or preconditioning on the right,
C         or SB*(M-inverse)*(B-A*XL) if preconditioning on the
C         left.
C SNORMW :IN       Real
C         Scale factor.
C PROD   :IN       Real
C         The product s1*s2*...*sl = the product of the sines of the
C         Givens rotations used in the QR factorization of
C         the Hessenberg matrix HES.
C R0NRM  :IN       Real
C         The scaled norm of initial residual R0.
C
C***SEE ALSO  SGMRES
C***ROUTINES CALLED  SCOPY, SSCAL
C***REVISION HISTORY  (YYMMDD)
C   871001  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910506  Made subsidiary to SGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  SRLCAL
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      REAL PROD, R0NRM, SNORMW
      INTEGER KMP, LL, MAXL, N
C     .. Array Arguments ..
      REAL Q(*), RL(N), V(N,*)
C     .. Local Scalars ..
      REAL C, S, TEM
      INTEGER I, I2, IP1, K, LLM1, LLP1
C     .. External Subroutines ..
      EXTERNAL SCOPY, SSCAL
C***FIRST EXECUTABLE STATEMENT  SRLCAL
      IF (KMP .EQ. MAXL) THEN
C
C         calculate RL.  Start by copying V(*,1) into RL.
C
         CALL SCOPY(N, V(1,1), 1, RL, 1)
         LLM1 = LL - 1
         DO 20 I = 1,LLM1
            IP1 = I + 1
            I2 = I*2
            S = Q(I2)
            C = Q(I2-1)
            DO 10 K = 1,N
               RL(K) = S*RL(K) + C*V(K,IP1)
 10         CONTINUE
 20      CONTINUE
         S = Q(2*LL)
         C = Q(2*LL-1)/SNORMW
         LLP1 = LL + 1
         DO 30 K = 1,N
            RL(K) = S*RL(K) + C*V(K,LLP1)
 30      CONTINUE
      ENDIF
C
C         When KMP < MAXL, RL vector already partially calculated.
C         Scale RL by R0NRM*PROD to obtain the residual RL.
C
      TEM = R0NRM*PROD
      CALL SSCAL(N, TEM, RL, 1)
      RETURN
C------------- LAST LINE OF SRLCAL FOLLOWS ----------------------------
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
function eclass_offset_eq(x1,x2,y1,y2,t1,t2)
  use mrtcal_buffers
  !---------------------------------------------------------------------
  ! @ private
  ! Equality routine between two pairs of offset (real*8) with a
  ! tolerance ruled by MSET CALIBRATION MATCH
  !---------------------------------------------------------------------
  logical :: eclass_offset_eq
  real(kind=8),     intent(in) :: x1,x2  ! [rad]
  real(kind=8),     intent(in) :: y1,y2  ! [rad]
  character(len=*), intent(in) :: t1,t2  ! Offset type (track, onTheFly, ...)
  !
  eclass_offset_eq = abs(x1-x2).le.rsetup%cal%match .and.  &
                     abs(y1-y2).le.rsetup%cal%match .and.  &
                     t1.eq.t2
  !
end function eclass_offset_eq
!
subroutine mrtcal_subscan_list_build(switchmode,sublist,imbf,error)
  use mrtcal_messaging
  use phys_const
  use gkernel_types
  use imbfits_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_subscan_list_build
  use mrtcal_buffers
  use mrtcal_calib_types
  use mrtcal_bookkeeping_types
  !---------------------------------------------------------------------
  ! @ private
  ! 1. Class the subscans of the current scan in TRACKED or OTF, ON or OFF
  ! 2. Associate the median offset, median MJD, and the integration time
  !---------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: switchmode
  type(subscan_list_t), intent(inout) :: sublist
  type(imbfits_t),      intent(inout) :: imbf
  logical,              intent(inout) :: error
  ! Local
  integer(kind=4), parameter :: type_length = 80
  real(kind=8), allocatable :: r8buf(:)
  integer(kind=4), allocatable :: i4buf(:),key(:)
  character(len=type_length), allocatable :: chbuf(:)
  character(len=24), allocatable :: ch24buf(:)
  logical, allocatable :: lbuf(:)
  integer(kind=4) :: ier,isub,nsub,iequ
  type(range_t) :: time
  type(eclass_2dble1char_t) :: offset_eclass
  type(imbfits_subscan_t) :: subscan
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='SUBSCAN>LIST>BUILD'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Sanity check + allocation
  nsub = imbf%primary%n_obsp%val
  if (nsub.eq.0) then
     call mrtcal_message(seve%e,rname,'No available subscan')
     error = .true.
     return
  endif
  call reallocate_subscan_list(nsub,sublist,error)
  if (error) return
  !
  ! Check that only one offset position is associated to each subscan and
  ! make the list of these subscan position
  do isub=1,nsub
     subscan%isub = isub
     ! Read IMBF-antslow hdu and get on-track time range
     call imbfits_read_header_antslow(imbf,isub,rsetup%cal%antslowmjdshift,subscan%antslow,error)
     if (error)  goto 100
     ! Read IMBF-backendXXX for subscan%backdata%head%desc%naxis2%val
     ! Compress bad time dumps, so that 100% bad tables are detected as empty
     call imbfits_read_header_backdata(imbf,isub,.true.,subscan%backdata,error)
     if (error)  goto 100
     call mrtcal_get_time_range_for_antslow(subscan,time,error)
     if (error)  goto 100
     !
     sublist%isub(isub) = isub
     sublist%mjd(isub) = sum(subscan%antslow%table%mjd%val(time%first:time%last))/time%n ! *** JP maybe a median would be better here
     sublist%time(isub) = subscan%antslow%head%substime%val
     sublist%empty(isub) = subscan%backdata%head%desc%naxis2%val.le.0
     sublist%scanning%val(isub) = subscan%antslow%head%substype%val
     !
     if (subscan%antslow%head%substype%val.eq.'track') then
        ! Search for the equivalent classes of offset positions for each subscan
        call reallocate_eclass_2dble1char(offset_eclass,time%n,error)
        if (error) goto 100
        offset_eclass%val1(1:time%n) = subscan%antslow%table%longoff%val(time%first:time%last)
        offset_eclass%val2(1:time%n) = subscan%antslow%table%latoff%val(time%first:time%last)
        offset_eclass%val3(1:time%n) = subscan%antslow%head%substype%val
        offset_eclass%cnt(1:time%n) = 1
        call eclass_2dble1char(eclass_offset_eq,offset_eclass)
        ! Only 1 position expected per subscan in tracked psw
        if (offset_eclass%nequ.ne.1) then
           write(mess,'(A,I0)')  'Subscan #',isub
           call mrtcal_subscan_list_error(trim(mess),offset_eclass,time%n,'traces',"1",switchmode)
           error = .true.
           goto 100
        endif
        ! List the subscan positions
        sublist%onoff%val1(isub) = offset_eclass%val1(1)
        sublist%onoff%val2(isub) = offset_eclass%val2(1)
        sublist%onoff%val3(isub) = offset_eclass%val3(1)
     else if (subscan%antslow%head%substype%val.eq.'onTheFly') then
        ! Set arbitrary (but identical from 1 onTheFly subscan to another)
        ! values. The comparison function will distinguish track from onTheFly
        ! by comparing the subscan type.
        sublist%onoff%val1(isub) = 0.0
        sublist%onoff%val2(isub) = 0.0
        sublist%onoff%val3(isub) = subscan%antslow%head%substype%val
     else if (subscan%antslow%head%substype%val.eq.'onFocus') then
        ! Code is duplicated from the onTheFly section because it's unclear
        ! whether some modifications will be needed
        sublist%onoff%val1(isub) = 0.0
        sublist%onoff%val2(isub) = 0.0
        sublist%onoff%val3(isub) = subscan%antslow%head%substype%val        
     else 
        call mrtcal_message(seve%e,rname,'Unknown substype: '//subscan%antslow%head%substype%val)
        error = .true.
        goto 100
     endif
  enddo ! isub
  !
  ! Sort by increasing time (just a precaution...)
  allocate(key(nsub),r8buf(nsub),i4buf(nsub),chbuf(nsub),ch24buf(nsub),lbuf(nsub),stat=ier)
  if (failed_allocate(rname,'Sorting key and buffers',ier,error)) return
  call gr8_trie(sublist%mjd,key,nsub,error)
  if (error) then
     deallocate(key,r8buf,i4buf,chbuf,ch24buf,lbuf)
     return
  endif
  call gr8_sort(sublist%mjd,r8buf,key,nsub)
  call gr8_sort(sublist%time,r8buf,key,nsub)
  call gi4_sort(sublist%isub,i4buf,key,nsub)
  call gl_sort (sublist%empty,lbuf,key,nsub)
  call gr8_sort(sublist%onoff%val1,r8buf,key,nsub)
  call gr8_sort(sublist%onoff%val2,r8buf,key,nsub)
  call gch_sort(sublist%onoff%val3,ch24buf,key,24,nsub)
  call gch_sort(sublist%scanning%val,chbuf,key,type_length,nsub)
  deallocate(key,r8buf,i4buf,chbuf,ch24buf,lbuf)
  !
  ! Search for the equivalent classes of the subscan types
  call eclass_char(eclass_char_eq,sublist%scanning)
  if (sublist%scanning%nequ.eq.1 .and. sublist%scanning%val(1).eq.'onTheFly') then
    sublist%tracked = 0
    sublist%otf = 1
    sublist%focus = 0
  else if (sublist%scanning%nequ.eq.1 .and. sublist%scanning%val(1).eq.'onFocus') then
    sublist%tracked = 0
    sublist%otf = 0
    sublist%focus = 1
  else if (sublist%scanning%nequ.ge.1 .and. sublist%scanning%val(1).eq.'track') then
    sublist%tracked = 1
    sublist%otf = 2
    sublist%focus = 0
  else if (sublist%scanning%nequ.ge.2 .and. sublist%scanning%val(2).eq.'track') then
    sublist%tracked = 2
    sublist%otf = 1
    sublist%focus = 0
  else
    call mrtcal_message(seve%e,rname,'Could not figure out TRACKED vs OTF classes')
    write(mess,'(I0,A)') sublist%scanning%nequ,' subscan type(s) found:'
    call mrtcal_message(seve%e,rname,mess)
    do iequ=1,sublist%scanning%nequ
      write(mess,'(A,I0,A,A,A,I0,A)')  '  #',iequ,': ',  &
        trim(sublist%scanning%val(iequ)),' (',sublist%scanning%cnt(iequ),' subscans)'
      call mrtcal_message(seve%e,rname,mess)
    enddo
    error = .true.
    goto 100
  endif
  !
  ! Search for the equivalent classes of the subscan positions
  call eclass_2dble1char(eclass_offset_eq,sublist%onoff)
  select case (switchmode)
  case (switchmode_pos)
     if (sublist%onoff%nequ.ne.2) then
        call mrtcal_subscan_list_error("Scan",sublist%onoff,nsub,'subscans',"2: ON+OFF",switchmode)
        error = .true.
        goto 100
     endif
     ! Identifies classes as on and off classes. The first one is always
     ! assumed to be an OFF in IMBFITS v2...
     sublist%off = 1
     sublist%on  = 2
  case (switchmode_wob)
     if (sublist%onoff%nequ.ne.1 .and. sublist%onoff%nequ.ne.2) then
        call mrtcal_subscan_list_error("Scan",sublist%onoff,nsub,'subscans',"1 or 2",switchmode)
        error = .true.
        goto 100
     endif
  case (switchmode_fre,switchmode_bea)
     if (sublist%onoff%nequ.ne.1) then
        call mrtcal_subscan_list_error("Scan",sublist%onoff,nsub,'subscans',"1",switchmode)
        error = .true.
        goto 100
     endif
     ! Only ON subscans in frequency or beam switching!
     sublist%on  = 1
     sublist%off = 0
  case default
     call mrtcal_message(seve%e,rname,trim(imbf%scan%head%swtchmod%val)//' not supported')
     error = .true.
     goto 100
  end select
  !
100 continue
  call imbfits_free_header_antslow(subscan%antslow,error)
  call imbfits_free_header_backdata(subscan%backdata,error)
  call free_eclass_2dble1char(offset_eclass,error)
  !
contains
  subroutine mrtcal_subscan_list_error(what,eclass,nsource,source,expected,swmode)
    use mrtcal_messaging
    character(len=*),          intent(in) :: what
    type(eclass_2dble1char_t), intent(in) :: eclass
    integer(kind=4),           intent(in) :: nsource
    character(len=*),          intent(in) :: source
    character(len=*),          intent(in) :: expected
    integer(kind=4),           intent(in) :: swmode
    ! Local
    character(len=message_length) :: mess
    !
    write(mess,'(2A,I0,A,I0,1X,6A)')  what,' has ',eclass%nequ,  &
      ' positions through ',nsource,source,' (expected ',expected,' for ',  &
      switchmodes_mrtcal(swmode),'):'
    call mrtcal_message(seve%e,rname,mess)
    do iequ=1,eclass%nequ
      write(mess,'(3X,A,I0,A,f0.8,2x,f0.8)')  &
        'Position #',iequ,': ',eclass%val1(iequ)*sec_per_rad,eclass%val2(iequ)*sec_per_rad
      call mrtcal_message(seve%e,rname,mess)
    enddo ! iequ
  end subroutine mrtcal_subscan_list_error
  !
end subroutine mrtcal_subscan_list_build
!
subroutine mrtcal_subscan_list_print(switchmode,sublist,error)
  use mrtcal_messaging
  use phys_const
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_subscan_list_print
  !---------------------------------------------------------------------
  ! @ private
  ! List useful information about the subscans of the current scan
  !---------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: switchmode
  type(subscan_list_t), intent(in)    :: sublist
  logical,              intent(inout) :: error
  ! Local
  integer(kind=4) :: isub
  character(len=7) :: equclass
  character(len=4) :: subscan_kind
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='SUBSCAN>LIST>PRINT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (sublist%nsub.eq.0) then
     call mrtcal_message(seve%r,rname,'No available subscan')
  else
     write(mess,'(A)') '#     ObsType           Offsets          MJD         IntTime'
     call mrtcal_message(seve%r,rname,mess)
     do isub=1,sublist%nsub
        if (sublist%scanning%bak(isub).eq.sublist%tracked) then
           equclass = 'TRACKED'
        else if (sublist%scanning%bak(isub).eq.sublist%otf) then
           equclass = 'OTF    '
        else if (sublist%scanning%bak(isub).eq.sublist%focus) then
           equclass = 'Focus  '
        else
           call mrtcal_message(seve%e,rname,'Unknown equivalent class')
           error = .true.
           return
        endif
        select case (switchmode)
        case (switchmode_pos)
           if (sublist%onoff%bak(isub).eq.sublist%on) then
              subscan_kind = 'ON '
           else if (sublist%onoff%bak(isub).eq.sublist%off) then
              subscan_kind = 'OFF'
           else
              call mrtcal_message(seve%e,rname,'Unknown equivalent class')
              error = .true.
              return
           endif
        case (switchmode_wob)
           write(subscan_kind,'(A,I1)') 'WSW',sublist%onoff%bak(isub)
        case (switchmode_fre)
           write(subscan_kind,'(A)') 'FSW'
        case (switchmode_bea)
           write(subscan_kind,'(A)') 'BSW'
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode') ! *** JP Having the name of the switched mode would be good...
           error = .true.
           return
        end select
        write(mess,'(I2,2x,A,1x,A,2x,2F8.1,2x,F0.8,2x,F0.6)')  &
             isub,equclass,subscan_kind,&
             sublist%onoff%val1(isub)*sec_per_rad,&
             sublist%onoff%val2(isub)*sec_per_rad,&
             sublist%mjd(isub),&
             sublist%time(isub)
        call mrtcal_message(seve%r,rname,mess)
     enddo ! isub
  endif
  !
end subroutine mrtcal_subscan_list_print
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_switch_cycle_init(front,backdata,antslow,sublist,cycle,error)
  use phys_const
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_switch_cycle_init
  use imbfits_types
  use mrtcal_calib_types
  use mrtcal_bookkeeping_types
  !---------------------------------------------------------------------
  ! @ private
  ! Note that the frequency offset in frequency switching may depend on the
  ! frontend. This imposes that the off pointer in the switch_desc_t has 
  ! noffset x nfront dimensions, and not just noffset.
  !
  ! In wobbler switching, check that offsets are given in horizontalTrue.
  ! If true, then use the sign of the longitude offset to determine the ON and OFF
  ! phases. Indeed, the backdata%head%phaseone%val value is only indicating
  ! whether the phase corresponds to the wobbler LEFT or RIGHT, not whether
  ! it is ON or OFF (even though the value names still are ON or OFF). Yes,
  ! I know: This is confusing...
  !
  ! In frequency switching, try to use backdata%head%phaseone%val to 
  ! decide who is ON and who is OFF
  !---------------------------------------------------------------------
  type(imbfits_front_t),    intent(in)    :: front
  type(imbfits_backdata_t), intent(in)    :: backdata
  type(imbfits_antslow_t),  intent(in)    :: antslow
  type(subscan_list_t),     intent(in)    :: sublist
  type(switch_cycle_t),     intent(inout) :: cycle
  logical,                  intent(inout) :: error
  !
  integer(kind=4), parameter :: ilam = 1
  integer(kind=4), parameter :: ibet = 2
  integer(kind=4) :: ifront,nfront,npha,ndump,non,noff
  real(kind=4) :: dummy
  character(len=*), parameter :: rname='PHASE>SWITCH>CYCLE>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ndump = backdata%head%nphases%val
  nfront = front%table%frqoff1%n ! *** JP some test needed about the consistency with frqoff2?
  select case (cycle%mode)
  case (switchmode_pos)
     if (ndump.ne.1) then
        call mrtcal_message(seve%e,rname,'Position switching should only have one dump per dumpcycle')
        error = .true.
        return
     endif
     non  = 1
     noff = 1
     npha = 2 ! Convention: One ON and one OFF (they can be the average of several subscans)
     call reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
     if (error) return
     cycle%on%i(1)  = 1 ! Convention
     cycle%off%i(1) = 2 ! Convention
     cycle%desc(cycle%on%i(1))%wei(:)  = +1
     cycle%desc(cycle%off%i(1))%wei(:) = -1
     cycle%desc(cycle%on%i(1))%off(ilam,:) = sublist%onoff%val1(sublist%on)
     cycle%desc(cycle%on%i(1))%off(ibet,:) = sublist%onoff%val2(sublist%on)
     cycle%desc(cycle%off%i(1))%off(ilam,:) = sublist%onoff%val1(sublist%off)
     cycle%desc(cycle%off%i(1))%off(ibet,:) = sublist%onoff%val2(sublist%off)
  case (switchmode_wob)
     if (antslow%head%systemof%val.ne.'horizontalTrue') then
        call mrtcal_message(seve%e,rname,'Wobbler switching offsets are not given in the True Horizontal frame')
        error = .true.
        return
     endif
     non  = ndump/2
     noff = ndump/2
     npha = ndump
     call reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
     if (error) return
     call fill_switch_on_and_off_indexes(sublist%onoff%val1(sublist%on).lt.0,cycle)
     cycle%desc(cycle%on%i(1))%wei(:)  = +1
     cycle%desc(cycle%off%i(1))%wei(:) = -1
     cycle%desc(cycle%on%i(1))%off(:,:) = 0 ! It's a convention that the ON offsets are 0 valued.
     cycle%desc(cycle%off%i(1))%off(ilam,:) = sublist%onoff%val1(sublist%on)
     cycle%desc(cycle%off%i(1))%off(ibet,:) = sublist%onoff%val2(sublist%on)
  case (switchmode_fre)
     non  = ndump/2
     noff = ndump/2
     npha = ndump
     call reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
     if (error) return
     call fill_switch_on_and_off_indexes(backdata%head%phaseone%val.eq.'ON',cycle)
     do ifront=1,nfront
        ! Both weights are now +1. This comes from the fact the products
        ! which are folded are different now.
        ! In the past we used to do:
        !   F = SomeGain * (PHASE1-PHASE2)
        ! F was the usual unfolded spectrum, providing one positive and
        ! one negative shifted phases. Folding was done with:
        !   FOLDED = (+F(+shift) - F(-shift))/2
        ! which realigned the 2 phases with the shift and made them positives
        ! with the +1 and -1 weights.
        !
        ! Now we compute 2 unfolded spectra:
        !   F1 = (PHASE1-PHASE2)/PHASE2
        !   F2 = (PHASE2-PHASE1)/PHASE1
        ! In this case, PHASE1 is positive in F1, and PHASE2 is positive in F2.
        ! There is no more need to inverse F1 or F2 at folding time:
        !   FOLDED = (F1(+shift) + F2(-shift))/2
        cycle%desc(cycle%on%i(1))%wei(ifront)  = +1
        cycle%desc(cycle%off%i(1))%wei(ifront) = +1
        ! CLASS needs the frequencies in MHz
        ! But the frequency offset is in simple precision in IMBFITS while
        ! CLASS asks for a double precision. It's simpler for the end user
        ! to see -7.10000000000000 (the human double representation of a
        ! simple 7.1) than 7.10000004619360 (the correct double binary
        ! representation of a simple 7.1). NCS is passing 7.1 in a XML
        ! ASCII field. So we don't know what NCS actually does. The
        ! following trick is is thus mostly a cosmetic one.
        dummy = front%table%frqoff1%val(ifront)*1e9
        cycle%desc(cycle%on%i(1))%off(:,ifront)  = dummy*1d-6
        dummy = front%table%frqoff2%val(ifront)*1e9
        cycle%desc(cycle%off%i(1))%off(:,ifront) = dummy*1d-6
     enddo ! ifront
  case (switchmode_bea)
     non  = ndump/2
     noff = ndump/2
     npha = ndump
     call reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
     if (error) return
     call fill_switch_on_and_off_indexes(backdata%head%phaseone%val.eq.'ON',cycle)
     cycle%desc(cycle%on%i(1))%wei(:)  = +1
     cycle%desc(cycle%off%i(1))%wei(:) = -1
     cycle%desc(cycle%on%i(1))%off(:,:) = 0 ! It's a convention that the ON offsets are 0 valued.
     cycle%desc(cycle%off%i(1))%off(ilam,:) = sublist%onoff%val1(sublist%on)  ! ZZZ These are not filled properly
     cycle%desc(cycle%off%i(1))%off(ibet,:) = sublist%onoff%val2(sublist%on)  ! ZZZ These are not filled properly
  case default
     call mrtcal_message(seve%e,rname,'Unknown switch mode')
     error = .true.
     return
  end select
  !
contains
  !
  subroutine fill_switch_on_and_off_indexes(firstison,cycle)
    !---------------------------------------------------------------------
    ! If firstison = .true., then on%i = (1,3,5,...) and off%i = (2,4,6,...)
    !                        then on%i = (2,4,6,...) and off%i = (1,3,5,...)
    !---------------------------------------------------------------------
    logical,              intent(in) :: firstison
    type(switch_cycle_t), intent(inout) :: cycle
    !
    integer(kind=4) :: i
    !
    if (firstison) then
       cycle%on%i(1:non)   = (/ (1+(i-1)*2, i=1,non)  /)
       cycle%off%i(1:noff) = (/ (2+(i-1)*2, i=1,noff) /)
    else
       cycle%on%i(1:non)   = (/ (2+(i-1)*2, i=1,noff) /)
       cycle%off%i(1:noff) = (/ (1+(i-1)*2, i=1,non)  /)
    endif
  end subroutine fill_switch_on_and_off_indexes
end subroutine mrtcal_switch_cycle_init
!
subroutine mrtcal_switch_cycle_list(cycle,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_switch_cycle_list
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! List useful information about the switch cycle of the current subscan
  !---------------------------------------------------------------------
  type(switch_cycle_t), intent(in)    :: cycle
  logical,              intent(inout) :: error
  ! Local
  integer(kind=4) :: ifront,ipha
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='SWITCH>CYCLE>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  select case (cycle%mode)
  case (switchmode_pos)
     ! Print something?
  case (switchmode_wob)
     ! Print another thing?
  case (switchmode_bea)
     ! Print still another thing?
  case (switchmode_fre)
     if (cycle%npha.eq.0) then
        call mrtcal_message(seve%w,rname,'No phase found')
     else
        write(mess,'(2x,a)') 'Phase  Weight  Front  Freq. offset'
        call mrtcal_message(seve%r,rname,mess)
        do ipha=1,cycle%npha
           if (cycle%desc(ipha)%nfront.eq.0) then
              write(mess,'(2x,a)') 'No front end for this phase'
              call mrtcal_message(seve%w,rname,mess)
           else
              do ifront=1,cycle%desc(ipha)%nfront
                 write(mess,'(2x,I5,f6.1,4x,I5,2x,f12.3)') &
                      ipha,cycle%desc(ipha)%wei(ifront), &
                      ifront, cycle%desc(ipha)%off(1,ifront)
                 call mrtcal_message(seve%r,rname,mess)
              enddo ! ipha
           endif
        enddo ! ifront
     endif
  case default
     call mrtcal_message(seve%e,rname,'Unknown switch mode')
     error = .true.
     return
  end select
  !
end subroutine mrtcal_switch_cycle_list
!
subroutine mrtcal_switch_book_list(book,error)
  use mrtcal_interfaces, except_this=>mrtcal_switch_book_list
  use mrtcal_messaging
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(switch_book_t), intent(in)    :: book
  logical,             intent(inout) :: error
  ! Local
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='PHASE>SWITCH>BOOK>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! book%idump is used as loop iterator => its value is the number of 
  ! actually checked dumps plus one!
  write(mess,'(2x,A,I0,A,I0,A)') &
       "Checked ",book%idump-1," dumps (on ",book%ndump," on-track dumps) " 
  call mrtcal_message(mseve%calib%book,rname,mess)
  write(mess,'(2x,A,I0,A,I0,A)') &
       "Rejected ",book%norphan," dumps (on ",book%ndump," on-track dumps) " 
  call mrtcal_message(mseve%calib%book,rname,mess)
  write(mess,'(2x,A,I0,A,I0,A)') &
       "Read ",book%ncycle," complete cycles over ",book%ndump/book%nphase," potential cycles"
  call mrtcal_message(mseve%calib%book,rname,mess)
  !
end subroutine mrtcal_switch_book_list
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_iterate_subscancycle(mrtset,imbf,subscanbuf,  &
  backcal,backsci,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_iterate_subscancycle
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset      !
  type(imbfits_t),         intent(in)    :: imbf        !
  type(subscan_buffer_t),  intent(inout) :: subscanbuf  !
  type(calib_backend_t),   intent(in)    :: backcal     !
  type(science_backend_t), intent(inout) :: backsci     !
  logical,                 intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='ITERATE>SUBSCANCYCLE'
  ! Cycle descriptions
  integer(kind=4), parameter :: msub=4        ! Max number of subscans per cycle
  integer(kind=4), parameter :: mcycle=3      ! Number of known cycles
  integer(kind=4), parameter :: mmode=2       ! Mode 1: detection, mode 2: calibration
  type :: cycle_t
    integer(kind=4)  :: nsub        ! Number of subscans per cycle
    integer(kind=4)  :: desc(msub)  ! Cycle description
    character(len=4) :: name        ! Human friendly cycle name
  end type cycle_t
  type(cycle_t) :: det(mcycle),cal(mcycle)  ! Detection, calibration
  ! Other
  type(chunkset_3d_t) :: cumul  ! Cumulation structure in case of SCAN accumulation
  integer(kind=4) :: isub,ifirst,jcycle,ncycle
  logical :: found,initcumul
  character(len=message_length) :: mess
  !
  ! --- Cycle descriptions ---
  ! ROOR (detection ROOR)
  det(1)%nsub    = 4
  det(1)%desc(:) = (/ backsci%list%off, backsci%list%on, backsci%list%on, backsci%list%off /)
  det(1)%name    = 'ROOR'
  ! ROOR (calibration ROOR)
  cal(1)%nsub    = 4
  cal(1)%desc(:) = (/ backsci%list%off, backsci%list%on, backsci%list%on, backsci%list%off /)
  cal(1)%name    = 'ROOR'
  ! RORO (detection RORO)
  det(2)%nsub    = 4
  det(2)%desc(:) = (/ backsci%list%off, backsci%list%on, backsci%list%off, backsci%list%on /)
  det(2)%name    = 'RORO'
  ! RORO (calibration RO)
  cal(2)%nsub    = 2
  cal(2)%desc(:) = (/ backsci%list%off, backsci%list%on, 0, 0 /)
  cal(2)%name    = 'RO'
  ! RO (fallback only, detection RO)
  det(3)%nsub    = 2
  det(3)%desc(:) = (/ backsci%list%off, backsci%list%on, 0, 0 /)
  det(3)%name    = 'RO'
  ! RO (fallback only, calibration RO)
  cal(3)%nsub    = 2
  cal(3)%desc(:) = (/ backsci%list%off, backsci%list%on, 0, 0 /)
  cal(3)%name    = 'RO'
  !
  ! --- Detection ---
  call detect_cycles(det,mcycle,jcycle,error)
  if (error)  return
  !
  ! --- Calibration ---
  !
  isub = 0
  ifirst = 1-cal(jcycle)%nsub
  ncycle = 0
  initcumul = .true.
  do while (isub.lt.backsci%list%nsub)
    !
    ! Get next cycle
    call mrtcal_find_next_subscancycle(backsci%list,cal(jcycle)%desc,  &
      cal(jcycle)%nsub,.true.,found,ifirst,isub,ncycle,error)
    if (error)  goto 10
    if (.not.found)  cycle
    !
    ! Produce ON-OFF for this cycle
    call mrtcal_calib_tracked_psw_cycle(mrtset,imbf,ifirst,cal(jcycle)%nsub,  &
      subscanbuf,backcal,backsci,error)
    if (error)  goto 10
    !
    ! If requested, accumulate this result
    if (mrtset%out%accmode.eq.accmode_scan) then
      if (initcumul) then
        call mrtcal_chunkset_3d_accumulate_init(backsci%diff,cumul,error)
        if (error) goto 10
        initcumul = .false.
      endif
      ! backsci%diff has no weight yet. Give it some:
      call mrtcal_chunkset_3d_accumulate_setweight(backsci%diff,  &
        backsci%tscale,mrtset%out%weight,error)
      if (error)  goto 10
      call mrtcal_chunkset_3d_accumulate_do(backsci%diff,cumul,error)
      if (error)  goto 10
    endif
    !
  enddo
  !
  if (mrtset%out%accmode.eq.accmode_scan) then
    call mrtcal_write_toclass(cumul,mrtset%out,backsci%nobs,error)
    if (error)  goto 10
  endif
  !
  write(mess,'(A,I0,1X,A,A)')  'Calibrated ',ncycle,cal(jcycle)%name,' cycles'
  call mrtcal_message(seve%i,rname,mess)
  !
10 continue
  ! Cleaning
  call cumul%free(error)
  if (error)  continue
  !
contains
  subroutine detect_cycles(cycl,mcycl,found,error)
    use mrtcal_messaging
    !-------------------------------------------------------------------
    ! Detect which of the known cycles if used in the scan
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: mcycl
    type(cycle_t),   intent(in)    :: cycl(mcycl)
    integer(kind=4), intent(out)   :: found
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: ncycl(mcycl),icycl
    !
    ncycl(:) = 0
    found = 0
    ! Try first ROOR and RORO
    do icycl=1,mcycl-1  ! Ignore last one for now
      call count_cycles(cycl(icycl),ncycl(icycl),error)
      if (error)  return
    enddo
    ! Which one is found?
    if (all(ncycl(1:mcycl-1).gt.0)) then
      call mrtcal_message(seve%e,rname,'Ambiguous subscan cycles')
      error = .true.
      return
    endif
    if (all(ncycl(1:mcycl-1).eq.0)) then
      ! Neither ROOR nor RORO were found. Try RO as last chance.
      call count_cycles(cycl(mcycl),ncycl(mcycl),error)  ! Try last one now
      if (error)  return
    endif
    do icycl=1,mcycl
      if (ncycl(icycl).gt.0) then
        found = icycl
        exit
      endif
    enddo
    if (found.eq.0) then
      call mrtcal_message(seve%e,rname,'No supported RO cycles found')
      error = .true.
      return
    endif
    write(mess,'(A,I0,1X,A,A)')  'Detected ',ncycl(found),cycl(found)%name,' cycles'
    call mrtcal_message(seve%i,rname,mess)
    !
  end subroutine detect_cycles
  !
  subroutine count_cycles(cycl,ncycle,error)
    !-------------------------------------------------------------------
    ! Count the number of subscan cycles
    !-------------------------------------------------------------------
    type(cycle_t),   intent(in)    :: cycl
    integer(kind=4), intent(out)   :: ncycle
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: isub,ifirst
    logical :: found
    !
    isub = 0
    ifirst = 1-cycl%nsub
    ncycle = 0
    do while (isub.lt.backsci%list%nsub)
      call mrtcal_find_next_subscancycle(backsci%list,cycl%desc,  &
        cycl%nsub,.false.,found,ifirst,isub,ncycle,error)
      if (error)  return
    enddo
  end subroutine count_cycles
  !
end subroutine mrtcal_iterate_subscancycle
!
subroutine mrtcal_find_next_subscancycle(sublist,swcycle,nswitch,  &
  verbose,found,ifirst,isub,ncycle,error)
  use imbfits_types
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_find_next_subscancycle
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(subscan_list_t), intent(in)    :: sublist
  integer(kind=4),      intent(in)    :: nswitch
  integer(kind=4),      intent(in)    :: swcycle(nswitch)
  logical,              intent(in)    :: verbose
  logical,              intent(out)   :: found
  integer(kind=4),      intent(inout) :: ifirst
  integer(kind=4),      intent(inout) :: isub
  integer(kind=4),      intent(inout) :: ncycle
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FIND>NEXT>SUBSCANCYCLE'
  logical :: notyetwarned,match
  integer(kind=4) :: iswitch
  character(len=message_length) :: mess
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Iterate internal counters
  isub = isub+1
  ifirst = ifirst+nswitch
  ! Initialize next cycle search
  found = .false.
  iswitch = 1
  notyetwarned = .true.
  !
  do
     ! Incomplete last / exit condition
     if (isub.gt.sublist%nsub) then
        if (iswitch.gt.1) then
           ! That's just a warning, *not* an error
           if (verbose)  &
             call mrtcal_message(seve%w,rname,'Incomplete last switch cycle')
        endif
        found = .false.
        return
     endif
     !
     ! Check switch kind
     match = sublist%onoff%bak(isub).eq.swcycle(iswitch)
     !
     if (match) then
        notyetwarned = .true.
        ! Expected switch number
        if (iswitch.eq.nswitch) then
          ! Completed a full cycle
          found = .true.
          ncycle = ncycle+1
          if (verbose) then
            write(mess,'(A,I0)') 'Found next cycle starting at ',ifirst
            call mrtcal_message(seve%i,rname,mess)
          endif
          return
        else
          ! Not yet a full cycle => Increment iswitch and subscan counters
          iswitch = iswitch+1
          isub = isub+1
        endif
     else
        ! Unexpected switch kind => Warn only once while searching for a new start of a complete cycle
        if (verbose) then
          if (notyetwarned) then
            write(mess,'(A,I0,A)') 'Incomplete or inconsistent switch cycle starting at ',  &
                  ifirst,' => Searching for start of next cycle'
            call mrtcal_message(seve%w,rname,mess)
            notyetwarned = .false.
          endif
          write(mess,'(A,I0,A,I0,A,I0,A)') 'Subscan #',isub,&
              ' has wrong switch type (',&
              sublist%onoff%bak(isub),' vs ',swcycle(iswitch),')'
          call mrtcal_message(seve%w,rname,mess)
        endif
        if (iswitch.gt.1) then
          ! We were in the middle of a cycle
          !   => Reset switch number to find start of next cycle
          ! The current subscan could be the start of this cycle
          !   => Do not increase the position counter in the subscan list
          iswitch = 1
        else
          ! Already searching for start of cycle
          !   => Just increase the position counter in the subscan list
          isub = isub+1
          ! norphan = norphan+1
        endif
        ifirst = isub
     endif ! Is the switch kind the expected one?
  enddo ! Infinite loop on subscans
  !
end subroutine mrtcal_find_next_subscancycle
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubelist_find
  use cubetools_parameters
  use cubelist_types
  use cubelist_object_advanced_class
  use cubelist_messaging
  !---------------------------------------------------------------------
  ! Support module for generic find filters
  !---------------------------------------------------------------------
  !
  public :: find_filter_t
  public :: find_filter_list_t
  private
  !
  ! Support for 1 filter
  type, abstract, extends(list_object_t) :: find_filter_t
    logical, public :: enabled = .false.  ! Is this filter enabled?
  ! type(?)         :: refvalue  ! Desired value. Can be anything, to be
                                 ! added with an extension of this type.
                                 ! Unknown by the generic tool.
  contains
    procedure(basic_interface), deferred :: reset  ! [private]
    procedure(basic_interface), deferred :: check  ! [private]
    procedure(match_interface), deferred :: match  ! [private]
  end type find_filter_t
  !
  ! Post-filtering selection by entry range. This is not a filter
  ! as this is to be applied AFTER the selection is done with the
  ! filters (a la LAS\FIND /ENTRY 1 to 10).
  type :: find_range_t
    logical,              private :: enabled = .false.
    integer(kind=entr_k), private :: first,last
  contains
    procedure, public  :: set   => find_range_set
    procedure, private :: reset => find_range_reset
  end type find_range_t
  !
  ! The collection of filters
  type, extends(list_t) :: find_filter_list_t
    ! Collection of filters:
    !   under %list(:)%p => find_filter_t
    ! Entry range selector:
    type(find_range_t), public :: range
  contains
    procedure, public :: reset     => cubelist_find_reset
    procedure, public :: list2list => cubelist_find_list2list
  end type find_filter_list_t
  !
contains
  !
  function cubelist_filter_ptr(obj,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(find_filter_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(find_filter_t), pointer :: cubelist_filter_ptr
    class(list_object_t), pointer       :: obj
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='FILTER>PTR'
    !
    select type(obj)
    class is (find_filter_t)
      cubelist_filter_ptr => obj
    class default
      cubelist_filter_ptr => null()
      call cubelist_message(seve%e,rname,  &
        'Internal error: object is not a find_filter_t type')
      error = .true.
      return
    end select
  end function cubelist_filter_ptr
  !
  subroutine basic_interface(filter)
    !-------------------------------------------------------------------
    ! Interface for basic (1 argument) subroutines
    !-------------------------------------------------------------------
    class(find_filter_t), intent(inout) :: filter
  end subroutine basic_interface
  !
  function match_interface(filter,obj)
    !-------------------------------------------------------------------
    ! Interface for node-matching functions
    !-------------------------------------------------------------------
    logical :: match_interface
    class(find_filter_t),          intent(inout) :: filter  ! inout for find_entry%nfound
    class(list_object_advanced_t), intent(in)    :: obj
  end function match_interface
  !
  subroutine find_range_set(range,e1,e2,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(find_range_t),  intent(inout) :: range
    integer(kind=entr_k), intent(in)    :: e1,e2
    logical,              intent(inout) :: error
    !
    range%enabled = .true.
    ! Entry numbers can be negative i.e. count from the end of the
    ! selection
    if (e1.le.e2) then
      range%first = e1
      range%last  = e2
    else
      range%first = e2
      range%last  = e1
    endif
  end subroutine find_range_set
  !
  subroutine find_range_reset(range,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(find_range_t),  intent(out)   :: range
    logical,              intent(inout) :: error
    !
    ! Done with intent(out)
  end subroutine find_range_reset
  !
  subroutine cubelist_find_reset(filter,error)
    !-------------------------------------------------------------------
    ! Reset all the filters to their default (i.e. inactive value)
    !-------------------------------------------------------------------
    class(find_filter_list_t), intent(inout) :: filter
    logical,                   intent(inout) :: error
    !
    integer(kind=list_k) :: ifilter
    class(find_filter_t), pointer :: onefilter
    !
    ! Reset all the %enabled flags
    do ifilter=1,filter%n
      onefilter => cubelist_filter_ptr(filter%list(ifilter)%p,error)
      if (error)  return
      call onefilter%reset()
    enddo
    call filter%range%reset(error)
    if (error)  return
  end subroutine cubelist_find_reset
  !
  subroutine cubelist_find_list2list(filter,in,out,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(find_filter_list_t), intent(inout) :: filter  !
    class(list_t),             intent(in)    :: in      !
    class(list_t),             intent(inout) :: out     !
    logical,                   intent(inout) :: error   !
    !
    integer(kind=entr_k) :: ient,nfound,first,last
    integer(kind=list_k) :: ifilter
    type(find_filter_list_t) :: enabled
    class(find_filter_t), pointer :: onefilter
    integer(kind=entr_k) :: list(in%n) ! Automatic array (assume in%n>0)
    class(list_object_advanced_t), pointer :: obj
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='FIND'
    !
    call cubelist_find_enabled(filter,enabled,error)
    if (error)  return
    !
    nfound = 0
entries: do ient=1,in%n
      obj => cubelist_object_advanced_ptr(in%list(ient)%p,error)
      if (error)  return
      if (obj%hidden)  cycle
      !
      do ifilter=1,enabled%n
        onefilter => cubelist_filter_ptr(enabled%list(ifilter)%p,error)
        if (error)  return
        if (.not.onefilter%match(obj))  cycle entries
      enddo
      !
      nfound = nfound+1
      list(nfound) = ient
    enddo entries
    !
    if (filter%range%enabled) then
      if (filter%range%first.gt.0) then
        first = filter%range%first
        last = filter%range%last
      else
        first = nfound+filter%range%first
        last = nfound+filter%range%last
      endif
      if (first.le.0 .or. last.gt.nfound) then
        ! Error. Should we truncate instead?
        if (first.eq.last) then
          write(mess,'(a,i0)')  &
            'Invalid position ',filter%range%first
        else
          write(mess,'(2(a,i0))')  &
            'Invalid position range ',filter%range%first,' to ',filter%range%last
        endif
        call cubelist_message(seve%e,rname,mess)
        error = .true.
        return
      endif
      nfound = 0
      do ient=first,last
        nfound = nfound+1
        list(nfound) = list(ient)  ! Overwrite in-place (careful)
      enddo
    endif
    !
    call cubelist_find_byentries(in,list,nfound,out,error)
    if (error)  return
  end subroutine cubelist_find_list2list
  !
  subroutine cubelist_find_enabled(filter,enabled,error)
    !-------------------------------------------------------------------
    ! Return a new find_filter_list_t, which provides only the enabled
    ! filters.
    !
    ! This is a first level of optimization. This avoids calling
    ! cubelist_filter_ptr (i.e. "select type()") in the main find loop
    ! (the loop on -many- entries) on unused filters.
    !
    ! A second level of optimization could be to save directly the list
    ! of enabled %match() methods in a simpler list. However, Fortran
    ! does not allow (C1030 (R1040)) this:
    !   procedure(match_interface), pointer :: match_pointer
    !   match_pointer => onefilter%match
    !-------------------------------------------------------------------
    type(find_filter_list_t), intent(inout) :: filter
    type(find_filter_list_t), intent(out)   :: enabled
    logical,                  intent(inout) :: error
    !
    integer(kind=list_k) :: ifilter
    class(find_filter_t), pointer :: onefilter
    !
    do ifilter=1,filter%n
      onefilter => cubelist_filter_ptr(filter%list(ifilter)%p,error)
      if (error)  return
      call onefilter%check()  ! Compute the %enabled flag
      if (.not.onefilter%enabled)  cycle
      !
      call enabled%associate(onefilter,error)
      if (error)  return
    enddo
  end subroutine cubelist_find_enabled
  !
  subroutine cubelist_find_byentries(in,entries,nentries,out,error)
    !-------------------------------------------------------------------
    ! FIND by list of entry numbers
    !-------------------------------------------------------------------
    class(list_t),        intent(in)    :: in          !
    integer(kind=entr_k), intent(in)    :: entries(:)  ! Entry numbers
    integer(kind=entr_k), intent(in)    :: nentries    !
    class(list_t),        intent(inout) :: out         !
    logical,              intent(inout) :: error       !
    !
    integer(kind=entr_k) :: ient
    !
    call out%final(error)
    if (error)  return
    !
    do ient=1,nentries
      call out%associate(in%list(entries(ient))%p,error)
      if (error)  return
    enddo
  end subroutine cubelist_find_byentries
  !
end module cubelist_find

*DECK DLBETA
      DOUBLE PRECISION FUNCTION DLBETA (A, B)
C***BEGIN PROLOGUE  DLBETA
C***PURPOSE  Compute the natural logarithm of the complete Beta
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7B
C***TYPE      DOUBLE PRECISION (ALBETA-S, DLBETA-D, CLBETA-C)
C***KEYWORDS  FNLIB, LOGARITHM OF THE COMPLETE BETA FUNCTION,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLBETA(A,B) calculates the double precision natural logarithm of
C the complete beta function for double precision arguments
C A and B.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D9LGMC, DGAMMA, DLNGAM, DLNREL, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  DLBETA
      DOUBLE PRECISION A, B, P, Q, CORR, SQ2PIL, D9LGMC, DGAMMA, DLNGAM,
     1  DLNREL
      EXTERNAL DGAMMA
      SAVE SQ2PIL
      DATA SQ2PIL / 0.9189385332 0467274178 0329736405 62 D0 /
C***FIRST EXECUTABLE STATEMENT  DLBETA
      P = MIN (A, B)
      Q = MAX (A, B)
C
      IF (P .LE. 0.D0) CALL XERMSG ('SLATEC', 'DLBETA',
     +   'BOTH ARGUMENTS MUST BE GT ZERO', 1, 2)
C
      IF (P.GE.10.D0) GO TO 30
      IF (Q.GE.10.D0) GO TO 20
C
C P AND Q ARE SMALL.
C
      DLBETA = LOG (DGAMMA(P) * (DGAMMA(Q)/DGAMMA(P+Q)) )
      RETURN
C
C P IS SMALL, BUT Q IS BIG.
C
 20   CORR = D9LGMC(Q) - D9LGMC(P+Q)
      DLBETA = DLNGAM(P) + CORR + P - P*LOG(P+Q)
     1  + (Q-0.5D0)*DLNREL(-P/(P+Q))
      RETURN
C
C P AND Q ARE BIG.
C
 30   CORR = D9LGMC(P) + D9LGMC(Q) - D9LGMC(P+Q)
      DLBETA = -0.5D0*LOG(Q) + SQ2PIL + CORR + (P-0.5D0)*LOG(P/(P+Q))
     1  + Q*DLNREL(-P/(P+Q))
      RETURN
C
      END
*DECK DLGAMS
      SUBROUTINE DLGAMS (X, DLGAM, SGNGAM)
C***BEGIN PROLOGUE  DLGAMS
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      DOUBLE PRECISION (ALGAMS-S, DLGAMS-D)
C***KEYWORDS  ABSOLUTE VALUE OF THE LOGARITHM OF THE GAMMA FUNCTION,
C             FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLGAMS(X,DLGAM,SGNGAM) calculates the double precision natural
C logarithm of the absolute value of the Gamma function for
C double precision argument X and stores the result in double
C precision argument DLGAM.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DLNGAM
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DLGAMS
      DOUBLE PRECISION X, DLGAM, SGNGAM, DLNGAM
C***FIRST EXECUTABLE STATEMENT  DLGAMS
      DLGAM = DLNGAM(X)
      SGNGAM = 1.0D0
      IF (X.GT.0.D0) RETURN
C
      INT = MOD (-AINT(X), 2.0D0) + 0.1D0
      IF (INT.EQ.0) SGNGAM = -1.0D0
C
      RETURN
      END
*DECK DLI
      DOUBLE PRECISION FUNCTION DLI (X)
C***BEGIN PROLOGUE  DLI
C***PURPOSE  Compute the logarithmic integral.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C5
C***TYPE      DOUBLE PRECISION (ALI-S, DLI-D)
C***KEYWORDS  FNLIB, LOGARITHMIC INTEGRAL, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLI(X) calculates the double precision logarithmic integral
C for double precision argument X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DEI, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DLI
      DOUBLE PRECISION X, DEI
C***FIRST EXECUTABLE STATEMENT  DLI
      IF (X .LE. 0.D0) CALL XERMSG ('SLATEC', 'DLI',
     +   'LOG INTEGRAL UNDEFINED FOR X LE 0', 1, 2)
      IF (X .EQ. 1.D0) CALL XERMSG ('SLATEC', 'DLI',
     +   'LOG INTEGRAL UNDEFINED FOR X = 0', 2, 2)
C
      DLI = DEI (LOG(X))
C
      RETURN
      END
*DECK DLLSIA
      SUBROUTINE DLLSIA (A, MDA, M, N, B, MDB, NB, RE, AE, KEY, MODE,
     +   NP, KRANK, KSURE, RNORM, W, LW, IWORK, LIW, INFO)
C***BEGIN PROLOGUE  DLLSIA
C***PURPOSE  Solve linear least squares problems by performing a QR
C            factorization of the input matrix using Householder
C            transformations.  Emphasis is put on detecting possible
C            rank deficiency.
C***LIBRARY   SLATEC
C***CATEGORY  D9, D5
C***TYPE      DOUBLE PRECISION (LLSIA-S, DLLSIA-D)
C***KEYWORDS  LINEAR LEAST SQUARES, QR FACTORIZATION
C***AUTHOR  Manteuffel, T. A., (LANL)
C***DESCRIPTION
C
C     DLLSIA computes the least squares solution(s) to the problem AX=B
C     where A is an M by N matrix with M.GE.N and B is the M by NB
C     matrix of right hand sides.  User input bounds on the uncertainty
C     in the elements of A are used to detect numerical rank deficiency.
C     The algorithm employs a row and column pivot strategy to
C     minimize the growth of uncertainty and round-off errors.
C
C     DLLSIA requires (MDA+6)*N + (MDB+1)*NB + M dimensioned space
C
C   ******************************************************************
C   *                                                                *
C   *         WARNING - All input arrays are changed on exit.        *
C   *                                                                *
C   ******************************************************************
C     SUBROUTINE DLLSIA(A,MDA,M,N,B,MDB,NB,RE,AE,KEY,MODE,NP,
C    1   KRANK,KSURE,RNORM,W,LW,IWORK,LIW,INFO)
C
C     Input..All TYPE REAL variables are DOUBLE PRECISION
C
C     A(,)          Linear coefficient matrix of AX=B, with MDA the
C      MDA,M,N      actual first dimension of A in the calling program.
C                   M is the row dimension (no. of EQUATIONS of the
C                   problem) and N the col dimension (no. of UNKNOWNS).
C                   Must have MDA.GE.M and M.GE.N.
C
C     B(,)          Right hand side(s), with MDB the actual first
C      MDB,NB       dimension of B in the calling program. NB is the
C                   number of M by 1 right hand sides. Must have
C                   MDB.GE.M. If NB = 0, B is never accessed.
C
C   ******************************************************************
C   *                                                                *
C   *         Note - Use of RE and AE are what make this             *
C   *                code significantly different from               *
C   *                other linear least squares solvers.             *
C   *                However, the inexperienced user is              *
C   *                advised to set RE=0.,AE=0.,KEY=0.               *
C   *                                                                *
C   ******************************************************************
C     RE(),AE(),KEY
C     RE()          RE() is a vector of length N such that RE(I) is
C                   the maximum relative uncertainty in column I of
C                   the matrix A. The values of RE() must be between
C                   0 and 1. A minimum of 10*machine precision will
C                   be enforced.
C
C     AE()          AE() is a vector of length N such that AE(I) is
C                   the maximum absolute uncertainty in column I of
C                   the matrix A. The values of AE() must be greater
C                   than or equal to 0.
C
C     KEY           For ease of use, RE and AE may be input as either
C                   vectors or scalars. If a scalar is input, the algo-
C                   rithm will use that value for each column of A.
C                   The parameter key indicates whether scalars or
C                   vectors are being input.
C                        KEY=0     RE scalar  AE scalar
C                        KEY=1     RE vector  AE scalar
C                        KEY=2     RE scalar  AE vector
C                        KEY=3     RE vector  AE vector
C
C     MODE          The integer mode indicates how the routine
C                   is to react if rank deficiency is detected.
C                   If MODE = 0 return immediately, no solution
C                             1 compute truncated solution
C                             2 compute minimal length solution
C                   The inexperienced user is advised to set MODE=0
C
C     NP            The first NP columns of A will not be interchanged
C                   with other columns even though the pivot strategy
C                   would suggest otherwise.
C                   The inexperienced user is advised to set NP=0.
C
C     WORK()        A real work array dimensioned 5*N.  However, if
C                   RE or AE have been specified as vectors, dimension
C                   WORK 4*N. If both RE and AE have been specified
C                   as vectors, dimension WORK 3*N.
C
C     LW            Actual dimension of WORK
C
C     IWORK()       Integer work array dimensioned at least N+M.
C
C     LIW           Actual dimension of IWORK.
C
C     INFO          Is a flag which provides for the efficient
C                   solution of subsequent problems involving the
C                   same A but different B.
C                   If INFO = 0 original call
C                      INFO = 1 subsequent calls
C                   On subsequent calls, the user must supply A, KRANK,
C                   LW, IWORK, LIW, and the first 2*N locations of WORK
C                   as output by the original call to DLLSIA. MODE must
C                   be equal to the value of MODE in the original call.
C                   If MODE.LT.2, only the first N locations of WORK
C                   are accessed. AE, RE, KEY, and NP are not accessed.
C
C     Output..All TYPE REAL variable are DOUBLE PRECISION
C
C     A(,)          Contains the upper triangular part of the reduced
C                   matrix and the transformation information. It togeth
C                   with the first N elements of WORK (see below)
C                   completely specify the QR factorization of A.
C
C     B(,)          Contains the N by NB solution matrix for X.
C
C     KRANK,KSURE   The numerical rank of A,  based upon the relative
C                   and absolute bounds on uncertainty, is bounded
C                   above by KRANK and below by KSURE. The algorithm
C                   returns a solution based on KRANK. KSURE provides
C                   an indication of the precision of the rank.
C
C     RNORM()       Contains the Euclidean length of the NB residual
C                   vectors  B(I)-AX(I), I=1,NB.
C
C     WORK()        The first N locations of WORK contain values
C                   necessary to reproduce the Householder
C                   transformation.
C
C     IWORK()       The first N locations contain the order in
C                   which the columns of A were used. The next
C                   M locations contain the order in which the
C                   rows of A were used.
C
C     INFO          Flag to indicate status of computation on completion
C                  -1   Parameter error(s)
C                   0 - Rank deficient, no solution
C                   1 - Rank deficient, truncated solution
C                   2 - Rank deficient, minimal length solution
C                   3 - Numerical rank 0, zero solution
C                   4 - Rank .LT. NP
C                   5 - Full rank
C
C***REFERENCES  T. Manteuffel, An interval analysis approach to rank
C                 determination in linear least squares problems,
C                 Report SAND80-0655, Sandia Laboratories, June 1980.
C***ROUTINES CALLED  D1MACH, DU11LS, DU12LS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891006  Cosmetic changes to prologue.  (WRB)
C   891009  Removed unreferenced variable.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Fixed an error message.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DLLSIA
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION D1MACH
      DIMENSION A(MDA,*),B(MDB,*),RE(*),AE(*),RNORM(*),W(*)
      INTEGER IWORK(*)
C
C***FIRST EXECUTABLE STATEMENT  DLLSIA
      IF(INFO.LT.0 .OR. INFO.GT.1) GO TO 514
      IT=INFO
      INFO=-1
      IF(NB.EQ.0 .AND. IT.EQ.1) GO TO 501
      IF(M.LT.1) GO TO 502
      IF(N.LT.1) GO TO 503
      IF(N.GT.M) GO TO 504
      IF(MDA.LT.M) GO TO 505
      IF(LIW.LT.M+N) GO TO 506
      IF(MODE.LT.0 .OR. MODE.GT.3) GO TO 515
      IF(NB.EQ.0) GO TO 4
      IF(NB.LT.0) GO TO 507
      IF(MDB.LT.M) GO TO 508
      IF(IT.EQ.0) GO TO 4
      GO TO 400
    4 IF(KEY.LT.0.OR.KEY.GT.3) GO TO 509
      IF(KEY.EQ.0 .AND. LW.LT.5*N) GO TO 510
      IF(KEY.EQ.1 .AND. LW.LT.4*N) GO TO 510
      IF(KEY.EQ.2 .AND. LW.LT.4*N) GO TO 510
      IF(KEY.EQ.3 .AND. LW.LT.3*N) GO TO 510
      IF(NP.LT.0 .OR. NP.GT.N) GO TO 516
C
      EPS=10.*D1MACH(3)
      N1=1
      N2=N1+N
      N3=N2+N
      N4=N3+N
      N5=N4+N
C
      IF(KEY.EQ.1) GO TO 100
      IF(KEY.EQ.2) GO TO 200
      IF(KEY.EQ.3) GO TO 300
C
      IF(RE(1).LT.0.0D0) GO TO 511
      IF(RE(1).GT.1.0D0) GO TO 512
      IF(RE(1).LT.EPS) RE(1)=EPS
      IF(AE(1).LT.0.0D0) GO TO 513
      DO 20 I=1,N
      W(N4-1+I)=RE(1)
      W(N5-1+I)=AE(1)
   20 CONTINUE
      CALL DU11LS(A,MDA,M,N,W(N4),W(N5),MODE,NP,KRANK,KSURE,
     1            W(N1),W(N2),W(N3),IWORK(N1),IWORK(N2))
      GO TO 400
C
  100 CONTINUE
      IF(AE(1).LT.0.0D0) GO TO 513
      DO 120 I=1,N
      IF(RE(I).LT.0.0D0) GO TO 511
      IF(RE(I).GT.1.0D0) GO TO 512
      IF(RE(I).LT.EPS) RE(I)=EPS
      W(N4-1+I)=AE(1)
  120 CONTINUE
      CALL DU11LS(A,MDA,M,N,RE,W(N4),MODE,NP,KRANK,KSURE,
     1            W(N1),W(N2),W(N3),IWORK(N1),IWORK(N2))
      GO TO 400
C
  200 CONTINUE
      IF(RE(1).LT.0.0D0) GO TO 511
      IF(RE(1).GT.1.0D0) GO TO 512
      IF(RE(1).LT.EPS) RE(1)=EPS
      DO 220 I=1,N
      W(N4-1+I)=RE(1)
      IF(AE(I).LT.0.0D0) GO TO 513
  220 CONTINUE
      CALL DU11LS(A,MDA,M,N,W(N4),AE,MODE,NP,KRANK,KSURE,
     1            W(N1),W(N2),W(N3),IWORK(N1),IWORK(N2))
      GO TO 400
C
  300 CONTINUE
      DO 320 I=1,N
      IF(RE(I).LT.0.0D0) GO TO 511
      IF(RE(I).GT.1.0D0) GO TO 512
      IF(RE(I).LT.EPS) RE(I)=EPS
      IF(AE(I).LT.0.0D0) GO TO 513
  320 CONTINUE
      CALL DU11LS(A,MDA,M,N,RE,AE,MODE,NP,KRANK,KSURE,
     1            W(N1),W(N2),W(N3),IWORK(N1),IWORK(N2))
C
C     DETERMINE INFO
C
  400 IF(KRANK.NE.N) GO TO 402
          INFO=5
          GO TO 410
  402 IF(KRANK.NE.0) GO TO 404
          INFO=3
          GO TO 410
  404 IF(KRANK.GE.NP) GO TO 406
          INFO=4
          RETURN
  406 INFO=MODE
      IF(MODE.EQ.0) RETURN
  410 IF(NB.EQ.0) RETURN
C
C     SOLUTION PHASE
C
      N1=1
      N2=N1+N
      N3=N2+N
      IF(INFO.EQ.2) GO TO 420
      IF(LW.LT.N2-1) GO TO 510
      CALL DU12LS(A,MDA,M,N,B,MDB,NB,MODE,KRANK,
     1            RNORM,W(N1),W(N1),IWORK(N1),IWORK(N2))
      RETURN
C
  420 IF(LW.LT.N3-1) GO TO 510
      CALL DU12LS(A,MDA,M,N,B,MDB,NB,MODE,KRANK,
     1            RNORM,W(N1),W(N2),IWORK(N1),IWORK(N2))
      RETURN
C
C     ERROR MESSAGES
C
  501 CALL XERMSG ('SLATEC', 'DLLSIA',
     +   'SOLUTION ONLY (INFO=1) BUT NO RIGHT HAND SIDE (NB=0)', 1, 0)
      RETURN
  502 CALL XERMSG ('SLATEC', 'DLLSIA', 'M.LT.1', 2, 1)
      RETURN
  503 CALL XERMSG ('SLATEC', 'DLLSIA', 'N.LT.1', 2, 1)
      RETURN
  504 CALL XERMSG ('SLATEC', 'DLLSIA', 'N.GT.M', 2, 1)
      RETURN
  505 CALL XERMSG ('SLATEC', 'DLLSIA', 'MDA.LT.M', 2, 1)
      RETURN
  506 CALL XERMSG ('SLATEC', 'DLLSIA', 'LIW.LT.M+N', 2, 1)
      RETURN
  507 CALL XERMSG ('SLATEC', 'DLLSIA', 'NB.LT.0', 2, 1)
      RETURN
  508 CALL XERMSG ('SLATEC', 'DLLSIA', 'MDB.LT.M', 2, 1)
      RETURN
  509 CALL XERMSG ('SLATEC', 'DLLSIA', 'KEY OUT OF RANGE', 2, 1)
      RETURN
  510 CALL XERMSG ('SLATEC', 'DLLSIA', 'INSUFFICIENT WORK SPACE', 8, 1)
      INFO=-1
      RETURN
  511 CALL XERMSG ('SLATEC', 'DLLSIA', 'RE(I) .LT. 0', 2, 1)
      RETURN
  512 CALL XERMSG ('SLATEC', 'DLLSIA', 'RE(I) .GT. 1', 2, 1)
      RETURN
  513 CALL XERMSG ('SLATEC', 'DLLSIA', 'AE(I) .LT. 0', 2, 1)
      RETURN
  514 CALL XERMSG ('SLATEC', 'DLLSIA', 'INFO OUT OF RANGE', 2, 1)
      RETURN
  515 CALL XERMSG ('SLATEC', 'DLLSIA', 'MODE OUT OF RANGE', 2, 1)
      RETURN
  516 CALL XERMSG ('SLATEC', 'DLLSIA', 'NP OUT OF RANGE', 2, 1)
      RETURN
      END
*DECK DLLTI2
      SUBROUTINE DLLTI2 (N, B, X, NEL, IEL, JEL, EL, DINV)
C***BEGIN PROLOGUE  DLLTI2
C***PURPOSE  SLAP Backsolve routine for LDL' Factorization.
C            Routine to solve a system of the form  L*D*L' X = B,
C            where L is a unit lower triangular matrix and D is a
C            diagonal matrix and ' means transpose.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2E
C***TYPE      DOUBLE PRECISION (SLLTI2-S, DLLTI2-D)
C***KEYWORDS  INCOMPLETE FACTORIZATION, ITERATIVE PRECONDITION, SLAP,
C             SPARSE, SYMMETRIC LINEAR SYSTEM SOLVE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER N, NEL, IEL(NEL), JEL(NEL)
C     DOUBLE PRECISION B(N), X(N), EL(NEL), DINV(N)
C
C     CALL DLLTI2( N, B, X, NEL, IEL, JEL, EL, DINV )
C
C *Arguments:
C N      :IN       Integer
C         Order of the Matrix.
C B      :IN       Double Precision B(N).
C         Right hand side vector.
C X      :OUT      Double Precision X(N).
C         Solution to L*D*L' x = b.
C NEL    :IN       Integer.
C         Number of non-zeros in the EL array.
C IEL    :IN       Integer IEL(NEL).
C JEL    :IN       Integer JEL(NEL).
C EL     :IN       Double Precision     EL(NEL).
C         IEL, JEL, EL contain the unit lower triangular factor   of
C         the incomplete decomposition   of the A  matrix  stored in
C         SLAP Row format.   The diagonal of ones *IS* stored.  This
C         structure can be set  up  by  the DS2LT routine.  See  the
C         "Description", below for more details about the  SLAP  Row
C         format.
C DINV   :IN       Double Precision DINV(N).
C         Inverse of the diagonal matrix D.
C
C *Description:
C       This routine is supplied with  the SLAP package as a routine
C       to perform the MSOLVE operation in the SCG iteration routine
C       for  the driver  routine DSICCG.   It must be called via the
C       SLAP  MSOLVE calling sequence  convention  interface routine
C       DSLLI.
C         **** THIS ROUTINE ITSELF DOES NOT CONFORM TO THE ****
C               **** SLAP MSOLVE CALLING CONVENTION ****
C
C       IEL, JEL, EL should contain the unit lower triangular factor
C       of  the incomplete decomposition of  the A matrix  stored in
C       SLAP Row format.   This IC factorization  can be computed by
C       the  DSICS routine.  The  diagonal  (which is all one's) is
C       stored.
C
C       ==================== S L A P Row format ====================
C
C       This routine requires  that the matrix A  be  stored  in the
C       SLAP  Row format.   In this format  the non-zeros are stored
C       counting across  rows (except for the diagonal  entry, which
C       must  appear first  in each  "row")  and  are stored  in the
C       double precision  array A.  In other words, for each row  in
C       the matrix  put the diagonal  entry in A.   Then put in  the
C       other  non-zero elements  going across  the row  (except the
C       diagonal) in order.  The JA array holds the column index for
C       each non-zero.  The IA array holds the offsets  into the JA,
C       A  arrays  for  the   beginning  of  each  row.    That  is,
C       JA(IA(IROW)),A(IA(IROW)) are the first elements of the IROW-
C       th row in  JA and A,  and  JA(IA(IROW+1)-1), A(IA(IROW+1)-1)
C       are  the last elements  of the  IROW-th row.   Note  that we
C       always have  IA(N+1) = NELT+1, where N is the number of rows
C       in the matrix  and  NELT is the  number of non-zeros  in the
C       matrix.
C
C       Here is an example of the SLAP Row storage format for a  5x5
C       Matrix (in the A and JA arrays '|' denotes the end of a row):
C
C           5x5 Matrix         SLAP Row format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 12 15 | 22 21 | 33 35 | 44 | 55 51 53
C       |21 22  0  0  0|  JA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  IA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       With  the SLAP  Row format  the "inner loop" of this routine
C       should vectorize   on machines with   hardware  support  for
C       vector gather/scatter operations.  Your compiler may require
C       a  compiler directive  to  convince   it that there  are  no
C       implicit vector  dependencies.  Compiler directives  for the
C       Alliant FX/Fortran and CRI CFT/CFT77 compilers  are supplied
C       with the standard SLAP distribution.
C
C***SEE ALSO  DSICCG, DSICS
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   920511  Added complete declaration section.  (WRB)
C   921113  Corrected C***CATEGORY line.  (FNF)
C   930701  Updated CATEGORY section.  (FNF, WRB)
C***END PROLOGUE  DLLTI2
C     .. Scalar Arguments ..
      INTEGER N, NEL
C     .. Array Arguments ..
      DOUBLE PRECISION B(N), DINV(N), EL(NEL), X(N)
      INTEGER IEL(NEL), JEL(NEL)
C     .. Local Scalars ..
      INTEGER I, IBGN, IEND, IROW
C***FIRST EXECUTABLE STATEMENT  DLLTI2
C
C         Solve  L*y = b,  storing result in x.
C
      DO 10 I=1,N
         X(I) = B(I)
 10   CONTINUE
      DO 30 IROW = 1, N
         IBGN = IEL(IROW) + 1
         IEND = IEL(IROW+1) - 1
         IF( IBGN.LE.IEND ) THEN
CLLL. OPTION ASSERT (NOHAZARD)
CDIR$ IVDEP
CVD$ NOCONCUR
CVD$ NODEPCHK
            DO 20 I = IBGN, IEND
               X(IROW) = X(IROW) - EL(I)*X(JEL(I))
 20         CONTINUE
         ENDIF
 30   CONTINUE
C
C         Solve  D*Z = Y,  storing result in X.
C
      DO 40 I=1,N
         X(I) = X(I)*DINV(I)
 40   CONTINUE
C
C         Solve  L-trans*X = Z.
C
      DO 60 IROW = N, 2, -1
         IBGN = IEL(IROW) + 1
         IEND = IEL(IROW+1) - 1
         IF( IBGN.LE.IEND ) THEN
CLLL. OPTION ASSERT (NOHAZARD)
CDIR$ IVDEP
CVD$ NOCONCUR
CVD$ NODEPCHK
            DO 50 I = IBGN, IEND
               X(JEL(I)) = X(JEL(I)) - EL(I)*X(IROW)
 50         CONTINUE
         ENDIF
 60   CONTINUE
C
      RETURN
C------------- LAST LINE OF DLLTI2 FOLLOWS ----------------------------
      END
*DECK DLNGAM
      DOUBLE PRECISION FUNCTION DLNGAM (X)
C***BEGIN PROLOGUE  DLNGAM
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      DOUBLE PRECISION (ALNGAM-S, DLNGAM-D, CLNGAM-C)
C***KEYWORDS  ABSOLUTE VALUE, COMPLETE GAMMA FUNCTION, FNLIB, LOGARITHM,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLNGAM(X) calculates the double precision logarithm of the
C absolute value of the Gamma function for double precision
C argument X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, D9LGMC, DGAMMA, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  DLNGAM
      DOUBLE PRECISION X, DXREL, PI, SINPIY, SQPI2L, SQ2PIL, XMAX,
     1  Y, DGAMMA, D9LGMC, D1MACH, TEMP
      LOGICAL FIRST
      EXTERNAL DGAMMA
      SAVE SQ2PIL, SQPI2L, PI, XMAX, DXREL, FIRST
      DATA SQ2PIL / 0.9189385332 0467274178 0329736405 62 D0 /
      DATA SQPI2L / +.2257913526 4472743236 3097614947 441 D+0    /
      DATA PI / 3.1415926535 8979323846 2643383279 50 D0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DLNGAM
      IF (FIRST) THEN
         TEMP = 1.D0/LOG(D1MACH(2))
         XMAX = TEMP*D1MACH(2)
         DXREL = SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS (X)
      IF (Y.GT.10.D0) GO TO 20
C
C LOG (ABS (DGAMMA(X)) ) FOR ABS(X) .LE. 10.0
C
      DLNGAM = LOG (ABS (DGAMMA(X)) )
      RETURN
C
C LOG ( ABS (DGAMMA(X)) ) FOR ABS(X) .GT. 10.0
C
 20   IF (Y .GT. XMAX) CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'ABS(X) SO BIG DLNGAM OVERFLOWS', 2, 2)
C
      IF (X.GT.0.D0) DLNGAM = SQ2PIL + (X-0.5D0)*LOG(X) - X + D9LGMC(Y)
      IF (X.GT.0.D0) RETURN
C
      SINPIY = ABS (SIN(PI*Y))
      IF (SINPIY .EQ. 0.D0) CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'X IS A NEGATIVE INTEGER', 3, 2)
C
      IF (ABS((X-AINT(X-0.5D0))/X) .LT. DXREL) CALL XERMSG ('SLATEC',
     +   'DLNGAM',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER',
     +   1, 1)
C
      DLNGAM = SQPI2L + (X-0.5D0)*LOG(Y) - X - LOG(SINPIY) - D9LGMC(Y)
      RETURN
C
      END
*DECK DLNREL
      DOUBLE PRECISION FUNCTION DLNREL (X)
C***BEGIN PROLOGUE  DLNREL
C***PURPOSE  Evaluate ln(1+X) accurate in the sense of relative error.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C4B
C***TYPE      DOUBLE PRECISION (ALNREL-S, DLNREL-D, CLNREL-C)
C***KEYWORDS  ELEMENTARY FUNCTIONS, FNLIB, LOGARITHM
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLNREL(X) calculates the double precision natural logarithm of
C (1.0+X) for double precision argument X.  This routine should
C be used when X is small and accurate to calculate the logarithm
C accurately (in the relative error sense) in the neighborhood
C of 1.0.
C
C Series for ALNR       on the interval -3.75000E-01 to  3.75000E-01
C                                        with weighted error   6.35E-32
C                                         log weighted error  31.20
C                               significant figures required  30.93
C                                    decimal places required  32.01
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DLNREL
      DOUBLE PRECISION ALNRCS(43), X, XMIN,  DCSEVL, D1MACH
      LOGICAL FIRST
      SAVE ALNRCS, NLNREL, XMIN, FIRST
      DATA ALNRCS(  1) / +.1037869356 2743769800 6862677190 98 D+1     /
      DATA ALNRCS(  2) / -.1336430150 4908918098 7660415531 33 D+0     /
      DATA ALNRCS(  3) / +.1940824913 5520563357 9261993747 50 D-1     /
      DATA ALNRCS(  4) / -.3010755112 7535777690 3765377765 92 D-2     /
      DATA ALNRCS(  5) / +.4869461479 7154850090 4563665091 37 D-3     /
      DATA ALNRCS(  6) / -.8105488189 3175356066 8099430086 22 D-4     /
      DATA ALNRCS(  7) / +.1377884779 9559524782 9382514960 59 D-4     /
      DATA ALNRCS(  8) / -.2380221089 4358970251 3699929149 35 D-5     /
      DATA ALNRCS(  9) / +.4164041621 3865183476 3918599019 89 D-6     /
      DATA ALNRCS( 10) / -.7359582837 8075994984 2668370319 98 D-7     /
      DATA ALNRCS( 11) / +.1311761187 6241674949 1522943450 11 D-7     /
      DATA ALNRCS( 12) / -.2354670931 7742425136 6960923301 75 D-8     /
      DATA ALNRCS( 13) / +.4252277327 6034997775 6380529625 67 D-9     /
      DATA ALNRCS( 14) / -.7719089413 4840796826 1081074933 00 D-10    /
      DATA ALNRCS( 15) / +.1407574648 1359069909 2153564721 91 D-10    /
      DATA ALNRCS( 16) / -.2576907205 8024680627 5370786275 84 D-11    /
      DATA ALNRCS( 17) / +.4734240666 6294421849 1543950059 38 D-12    /
      DATA ALNRCS( 18) / -.8724901267 4742641745 3012632926 75 D-13    /
      DATA ALNRCS( 19) / +.1612461490 2740551465 7398331191 15 D-13    /
      DATA ALNRCS( 20) / -.2987565201 5665773006 7107924168 15 D-14    /
      DATA ALNRCS( 21) / +.5548070120 9082887983 0413216972 79 D-15    /
      DATA ALNRCS( 22) / -.1032461915 8271569595 1413339619 32 D-15    /
      DATA ALNRCS( 23) / +.1925023920 3049851177 8785032448 68 D-16    /
      DATA ALNRCS( 24) / -.3595507346 5265150011 1897078442 66 D-17    /
      DATA ALNRCS( 25) / +.6726454253 7876857892 1945742267 73 D-18    /
      DATA ALNRCS( 26) / -.1260262416 8735219252 0824256375 46 D-18    /
      DATA ALNRCS( 27) / +.2364488440 8606210044 9161589555 19 D-19    /
      DATA ALNRCS( 28) / -.4441937705 0807936898 8783891797 33 D-20    /
      DATA ALNRCS( 29) / +.8354659446 4034259016 2412939946 66 D-21    /
      DATA ALNRCS( 30) / -.1573155941 6479562574 8992535210 66 D-21    /
      DATA ALNRCS( 31) / +.2965312874 0247422686 1543697066 66 D-22    /
      DATA ALNRCS( 32) / -.5594958348 1815947292 1560132266 66 D-23    /
      DATA ALNRCS( 33) / +.1056635426 8835681048 1872841386 66 D-23    /
      DATA ALNRCS( 34) / -.1997248368 0670204548 3149994666 66 D-24    /
      DATA ALNRCS( 35) / +.3778297781 8839361421 0498559999 99 D-25    /
      DATA ALNRCS( 36) / -.7153158688 9081740345 0381653333 33 D-26    /
      DATA ALNRCS( 37) / +.1355248846 3674213646 5020245333 33 D-26    /
      DATA ALNRCS( 38) / -.2569467304 8487567430 0798293333 33 D-27    /
      DATA ALNRCS( 39) / +.4874775606 6216949076 4595199999 99 D-28    /
      DATA ALNRCS( 40) / -.9254211253 0849715321 1323733333 33 D-29    /
      DATA ALNRCS( 41) / +.1757859784 1760239233 2697600000 00 D-29    /
      DATA ALNRCS( 42) / -.3341002667 7731010351 3770666666 66 D-30    /
      DATA ALNRCS( 43) / +.6353393618 0236187354 1802666666 66 D-31    /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DLNREL
      IF (FIRST) THEN
         NLNREL = INITDS (ALNRCS, 43, 0.1*REAL(D1MACH(3)))
         XMIN = -1.0D0 + SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LE. (-1.D0)) CALL XERMSG ('SLATEC', 'DLNREL', 'X IS LE -1'
     +   , 2, 2)
      IF (X .LT. XMIN) CALL XERMSG ('SLATEC', 'DLNREL',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR -1', 1, 1)
C
      IF (ABS(X).LE.0.375D0) DLNREL = X*(1.D0 -
     1  X*DCSEVL (X/.375D0, ALNRCS, NLNREL))
C
      IF (ABS(X).GT.0.375D0) DLNREL = LOG (1.0D0+X)
C
      RETURN
      END
*DECK DLPDOC
      SUBROUTINE DLPDOC
C***BEGIN PROLOGUE  DLPDOC
C***PURPOSE  Sparse Linear Algebra Package Version 2.0.2 Documentation.
C            Routines to solve large sparse symmetric and nonsymmetric
C            positive definite linear systems, Ax = b, using precondi-
C            tioned iterative methods.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4, Z
C***TYPE      DOUBLE PRECISION (SLPDOC-S, DLPDOC-D)
C***KEYWORDS  BICONJUGATE GRADIENT SQUARED, DOCUMENTATION,
C             GENERALIZED MINIMUM RESIDUAL, ITERATIVE IMPROVEMENT,
C             NORMAL EQUATIONS, ORTHOMIN,
C             PRECONDITIONED CONJUGATE GRADIENT, SLAP,
C             SPARSE ITERATIVE METHODS
C***AUTHOR  Seager, Mark. K., (LLNL)
C             User Systems Division
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550
C             (FTS) 543-3141, (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C                                 The
C                    Sparse Linear Algebra Package
C                      Double Precision Routines
C
C                @@@@@@@  @            @@@    @@@@@@@@
C               @       @ @           @   @   @       @
C               @         @          @     @  @       @
C                @@@@@@@  @         @       @ @@@@@@@@
C                       @ @         @@@@@@@@@ @
C               @       @ @         @       @ @
C                @@@@@@@  @@@@@@@@@ @       @ @
C
C      @       @                            @@@@@@@        @@@@@
C      @       @                           @       @      @    @@
C      @       @  @@@@@@@  @ @@                    @     @    @  @
C      @       @ @       @ @@  @             @@@@@@      @   @   @
C       @     @  @@@@@@@@@ @                @            @  @    @
C        @   @   @         @               @         @@@  @@    @
C         @@@     @@@@@@@  @               @@@@@@@@@ @@@   @@@@@
C
C
C    =================================================================
C    ========================== Introduction =========================
C    =================================================================
C      This package was  originally derived from a set of  iterative
C      routines written by Anne Greenbaum, as announced in "Routines
C      for Solving Large Sparse Linear Systems",  Tentacle, Lawrence
C      Livermore  National  Laboratory,  Livermore  Computing Center
C      (January 1986), pp 15-21.
C
C    This document  contains the specifications for  the  SLAP Version
C    2.0 package, a Fortran 77  package  for  the  solution  of  large
C    sparse   linear systems, Ax  =  b,  via  preconditioned iterative
C    methods.   Included in  this  package are "core"  routines  to do
C    Iterative   Refinement  (Jacobi's  method),  Conjugate  Gradient,
C    Conjugate Gradient on the normal equations, AA'y = b,  (where x =
C    A'y and  A' denotes the  transpose of   A), BiConjugate Gradient,
C    BiConjugate  Gradient  Squared, Orthomin and  Generalized Minimum
C    Residual Iteration.    These "core" routines   do  not  require a
C    "fixed"   data  structure   for storing  the   matrix  A  and the
C    preconditioning   matrix  M.   The  user  is free  to  choose any
C    structure that facilitates  efficient solution  of the problem at
C    hand.  The drawback  to this approach  is that the user must also
C    supply at least two routines  (MATVEC and MSOLVE,  say).   MATVEC
C    must calculate, y = Ax, given x and the user's data structure for
C    A.  MSOLVE must solve,  r = Mz, for z (*NOT*  r) given r  and the
C    user's data  structure for  M (or its  inverse).  The user should
C    choose M so that  inv(M)*A  is approximately the identity and the
C    solution step r = Mz is "easy" to  solve.  For some of the "core"
C    routines (Orthomin,  BiConjugate Gradient and  Conjugate Gradient
C    on the  normal equations)   the user must  also  supply  a matrix
C    transpose times   vector  routine  (MTTVEC,  say)  and (possibly,
C    depending    on the "core"  method)   a  routine  that solves the
C    transpose  of   the   preconditioning    step     (MTSOLV,  say).
C    Specifically, MTTVEC is a routine which calculates y = A'x, given
C    x and the user's data structure for A (A' is the transpose of A).
C    MTSOLV is a routine which solves the system r = M'z for z given r
C    and the user's data structure for M.
C
C    This process of writing the matrix vector operations  can be time
C    consuming and error  prone.  To alleviate  these problems we have
C    written drivers   for  the  "core" methods  that  assume the user
C    supplies one of two specific data structures (SLAP Triad and SLAP
C    Column format), see  below.  Utilizing these  data structures  we
C    have augmented   each  "core" method  with   two preconditioners:
C    Diagonal  Scaling and Incomplete Factorization.  Diagonal scaling
C    is easy to implement, vectorizes very  well and for problems that
C    are  not too  ill-conditioned  reduces the  number  of iterations
C    enough   to warrant its use.  On   the other  hand, an Incomplete
C    factorization  (Incomplete  Cholesky for  symmetric systems   and
C    Incomplete LU for nonsymmetric  systems) may  take much longer to
C    calculate, but it reduces the iteration count (for most problems)
C    significantly.  Our implementations  of IC and ILU  vectorize for
C    machines with hardware gather scatter, but the vector lengths can
C    be quite short if  the  number  of non-zeros  in a column is  not
C    large.
C
C    =================================================================
C    ==================== Supplied Data Structures ===================
C    =================================================================
C    The following describes the data   structures supplied  with  the
C    package: SLAP Triad and Column formats.
C
C    ====================== S L A P Triad format =====================
C
C    In the SLAP Triad format only the non-zeros are stored.  They may
C    appear in *ANY* order.  The user supplies three  arrays of length
C    NELT, where NELT  is the   number of  non-zeros  in the   matrix:
C    (IA(NELT),  JA(NELT), A(NELT)).  If  the matrix is symmetric then
C    one need only store the lower triangle (including  the  diagonal)
C    and NELT would be the corresponding  number  of non-zeros stored.
C    For each non-zero the user puts the row and column  index of that
C    matrix  element   in the  IA  and JA  arrays.  The  value  of the
C    non-zero matrix element is placed  in  the corresponding location
C    of  the A array.   This  is an extremely  easy  data structure to
C    generate.  On the other hand, it is not very  efficient on vector
C    computers for the iterative  solution of  linear systems.  Hence,
C    SLAP changes this input data structure to  the SLAP Column format
C    for the iteration (but does not change it back).
C
C    Here  is an example   of  the  SLAP  Triad storage  format  for a
C    nonsymmetric 5x5 Matrix.  NELT=11.   Recall that the  entries may
C    appear in any order.
C
C     5x5 Matrix       SLAP Triad format for 5x5 matrix on left.
C                           1  2  3  4  5  6  7  8  9 10 11
C    |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C    |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C    | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C    | 0  0  0 44  0|
C    |51  0 53  0 55|
C
C    ====================== S L A P Column format ====================
C
C    In the SLAP Column format  the non-zeros are stored counting down
C    columns (except for the  diagonal entry,  which must appear first
C    in each "column") and are stored in the double precision array A.
C    In  other words,  for each  column  in the matrix  first put  the
C    diagonal  entry  in A.  Then  put in the other  non-zero elements
C    going  down the column  (except the  diagonal)  in order.  The IA
C    array holds the row index  for each non-zero.  The JA array holds
C    the  offsets  into the  IA, A  arrays for the  beginning of  each
C    column. That is, IA(JA(ICOL)), A(JA(ICOL)) are the first elements
C    of  the  ICOL-th  column  in  IA  and  A,  and  IA(JA(ICOL+1)-1),
C    A(JA(ICOL+1)-1) are the last elements of the ICOL-th column. Note
C    that we  always have  JA(N+1) = NELT+1, where  N is the number of
C    columns in the matrix  and NELT is the number of non-zeros in the
C    matrix.  If the matrix is symmetric one need only store the lower
C    triangle  (including the diagonal)  and NELT would be the  corre-
C    sponding number of non-zeros stored.
C
C    Here is  an  example of the  SLAP   Column storage format  for  a
C    nonsymmetric 5x5 Matrix (in the  A and  IA arrays '|' denotes the
C    end of a column):
C
C       5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                           1  2  3    4  5    6  7    8    9 10 11
C    |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C    |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C    | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C    | 0  0  0 44  0|
C    |51  0 53  0 55|
C
C    =================================================================
C    ====================== Which Method To Use ======================
C    =================================================================
C
C                          BACKGROUND
C    In solving a large sparse linear system Ax = b using an iterative
C    method, it   is  not necessary to actually   store  the matrix A.
C    Rather, what is needed is a procedure  for multiplying the matrix
C    A times a given vector y to obtain the matrix-vector product, Ay.
C    SLAP has been written to take advantage of this fact.  The higher
C    level routines in the package require storage only of the non-zero
C    elements of   A (and  their  positions), and  even this   can  be
C    avoided, if the  user  writes his own subroutine for  multiplying
C    the matrix times a vector  and   calls the lower-level  iterative
C    routines in the package.
C
C    If  the matrix A is ill-conditioned,  then most iterative methods
C    will be slow to converge (if they converge  at all!).  To improve
C    the  convergence  rate,  one  may use  a "matrix  splitting," or,
C    "preconditioning matrix," say, M.  It is then necessary to solve,
C    at each iteration, a linear system  with coefficient matrix M.  A
C    good preconditioner  M should have  two  properties: (1) M should
C    "approximate" A, in the sense that the  matrix inv(M)*A  (or some
C    variant  thereof) is better conditioned  than the original matrix
C    A; and  (2) linear  systems with coefficient  matrix M should  be
C    much easier  to solve  than  the original system with coefficient
C    matrix   A.   Preconditioning routines  in the   SLAP package are
C    separate from the  iterative   routines,  so   that any of    the
C    preconditioners provided in the package,   or one that the   user
C    codes himself, can be used with any of the iterative routines.
C
C                        CHOICE OF PRECONDITIONER
C    If you  willing   to live with   either the SLAP Triad or  Column
C    matrix data structure  you  can then  choose one  of two types of
C    preconditioners   to   use:   diagonal  scaling    or  incomplete
C    factorization.  To  choose   between these two   methods requires
C    knowing  something  about the computer you're going  to run these
C    codes on  and how well incomplete factorization  approximates the
C    inverse of your matrix.
C
C    Let us  suppose you have   a scalar  machine.   Then,  unless the
C    incomplete factorization is very,  very poor this  is *GENERALLY*
C    the method to choose.  It  will reduce the  number of  iterations
C    significantly and is not all  that expensive  to compute.  So  if
C    you have just one  linear system to solve  and  "just want to get
C    the job  done" then try  incomplete factorization first.   If you
C    are thinking of integrating some SLAP  iterative method into your
C    favorite   "production  code" then  try incomplete  factorization
C    first,  but  also check  to see that  diagonal  scaling is indeed
C    slower for a large sample of test problems.
C
C    Let us now suppose  you have  a  vector  computer  with  hardware
C    gather/scatter support (Cray X-MP, Y-MP, SCS-40 or Cyber 205, ETA
C    10,  ETA Piper,  Convex C-1,  etc.).   Then  it is much harder to
C    choose  between the  two  methods.   The  versions  of incomplete
C    factorization in SLAP do in fact vectorize, but have short vector
C    lengths and the factorization step is relatively  more expensive.
C    Hence,  for  most problems (i.e.,  unless  your  problem  is  ill
C    conditioned,  sic!)  diagonal  scaling is  faster,  with its very
C    fast    set up  time    and  vectorized  (with   long    vectors)
C    preconditioning step (even though  it  may take more iterations).
C    If you have several systems (or  right hand sides) to  solve that
C    can  utilize  the  same  preconditioner  then the   cost   of the
C    incomplete factorization can   be  amortized over these  several
C    solutions.  This situation gives more advantage to the incomplete
C    factorization methods.  If  you have  a  vector  machine  without
C    hardware  gather/scatter (Cray  1,  Cray  2  &  Cray 3) then  the
C    advantages for incomplete factorization are even less.
C
C    If you're trying to shoehorn SLAP into your  favorite "production
C    code" and can not easily generate either the SLAP Triad or Column
C    format  then  you are  left  to   your  own  devices in terms  of
C    preconditioning.  Also,  you may  find that the   preconditioners
C    supplied with SLAP are not sufficient  for your problem.  In this
C    situation we would  recommend  that you   talk  with a  numerical
C    analyst  versed in   iterative   methods   about   writing  other
C    preconditioning  subroutines (e.g.,  polynomial  preconditioning,
C    shifted incomplete factorization,  SOR  or SSOR  iteration).  You
C    can always "roll your own"  by using the "core" iterative methods
C    and supplying your own MSOLVE and MATVEC (and possibly MTSOLV and
C    MTTVEC) routines.
C
C                          SYMMETRIC SYSTEMS
C    If your matrix is symmetric then you would want to use one of the
C    symmetric system  solvers.    If  your  system  is  also positive
C    definite,   (Ax,x) (Ax dot  product  with x) is  positive for all
C    non-zero  vectors x,  then use   Conjugate Gradient (DCG,  DSDCG,
C    DSICSG).  If you're  not sure it's SPD   (symmetric and  Positive
C    Definite)  then try DCG anyway and  if it works, fine.  If you're
C    sure your matrix is not  positive definite  then you  may want to
C    try the iterative refinement   methods  (DIR)  or the  GMRES code
C    (DGMRES) if DIR converges too slowly.
C
C                         NONSYMMETRIC SYSTEMS
C    This   is currently  an  area  of  active research  in  numerical
C    analysis  and   there   are   new  strategies  being   developed.
C    Consequently take the following advice with a grain of salt.   If
C    you matrix is positive definite, (Ax,x)  (Ax  dot product  with x
C    is positive for all non-zero  vectors x), then you can use any of
C    the    methods   for   nonsymmetric   systems (Orthomin,   GMRES,
C    BiConjugate Gradient, BiConjugate Gradient  Squared and Conjugate
C    Gradient applied to the normal equations).  If your system is not
C    too ill conditioned then try  BiConjugate Gradient Squared (BCGS)
C    or GMRES (DGMRES).  Both  of  these methods converge very quickly
C    and do  not require A'  or M' ('  denotes transpose) information.
C    DGMRES  does require  some  additional storage,  though.  If  the
C    system is very  ill conditioned  or   nearly positive  indefinite
C    ((Ax,x) is positive,  but may be  very small),  then GMRES should
C    be the first choice,  but try the  other  methods  if you have to
C    fine tune  the solution process for a  "production code".  If you
C    have a great preconditioner for the normal  equations (i.e., M is
C    an approximation to the inverse of AA' rather than  just  A) then
C    this is not a bad route to travel.  Old wisdom would say that the
C    normal equations are a disaster  (since it squares the  condition
C    number of the system and DCG convergence is linked to this number
C    of    infamy), but   some     preconditioners    (like incomplete
C    factorization) can reduce the condition number back below that of
C    the original system.
C
C    =================================================================
C    ======================= Naming Conventions ======================
C    =================================================================
C    SLAP  iterative  methods,    matrix vector    and  preconditioner
C    calculation  routines   follow a naming   convention  which, when
C    understood, allows one to determine the iterative method and data
C    structure(s) used.  The  subroutine  naming convention  takes the
C    following form:
C                          P[S][M]DESC
C    where
C        P  stands for the precision (or data type) of the routine and
C           is required in all names,
C        S  denotes whether or not the routine requires the SLAP Triad
C           or Column format (it does if the second letter of the name
C           is S and does not otherwise),
C        M  stands for the type of preconditioner used (only appears
C           in drivers for "core" routines), and
C     DESC  is some number of letters describing the method or purpose
C           of the routine.  The following is a list of the "DESC"
C           fields for iterative methods and their meaning:
C             BCG,BC:       BiConjugate Gradient
C             CG:           Conjugate Gradient
C             CGN,CN:       Conjugate Gradient on the Normal equations
C             CGS,CS:       biConjugate Gradient Squared
C             GMRES,GMR,GM: Generalized Minimum RESidual
C             IR,R:         Iterative Refinement
C             JAC:          JACobi's method
C             GS:           Gauss-Seidel
C             OMN,OM:       OrthoMiN
C
C    In the double precision version of SLAP, all routine names start
C    with a D. The brackets around the S and M designate that these
C    fields are optional.
C
C    Here are some examples of the routines:
C    1) DBCG: Double precision BiConjugate Gradient "core" routine.
C       One can deduce that this is a "core" routine, because the S and
C       M fields are missing and BiConjugate Gradient is an iterative
C       method.
C    2) DSDBCG: Double precision, SLAP data structure BCG with Diagonal
C       scaling.
C    3) DSLUBC: Double precision, SLAP data structure BCG with incom-
C       plete LU factorization as the preconditioning.
C    4) DCG: Double precision Conjugate Gradient "core" routine.
C    5) DSDCG: Double precision, SLAP data structure Conjugate Gradient
C       with Diagonal scaling.
C    6) DSICCG: Double precision, SLAP data structure Conjugate Gra-
C       dient with Incomplete Cholesky factorization preconditioning.
C
C
C    =================================================================
C    ===================== USER CALLABLE ROUTINES ====================
C    =================================================================
C    The following is a list of  the "user callable" SLAP routines and
C    their one line descriptions.  The headers denote  the  file names
C    where the routines can be found, as distributed for UNIX systems.
C
C    Note:  Each core routine, DXXX, has a corresponding stop routine,
C         ISDXXX.  If the stop routine does not have the specific stop
C         test the user requires (e.g., weighted infinity norm),  then
C         the user should modify the source for ISDXXX accordingly.
C
C    ============================= dir.f =============================
C    DIR: Preconditioned Iterative Refinement Sparse Ax = b Solver.
C    DSJAC: Jacobi's Method Iterative Sparse Ax = b Solver.
C    DSGS: Gauss-Seidel Method Iterative Sparse Ax = b Solver.
C    DSILUR: Incomplete LU Iterative Refinement Sparse Ax = b Solver.
C
C    ============================= dcg.f =============================
C    DCG: Preconditioned Conjugate Gradient Sparse Ax=b Solver.
C    DSDCG: Diagonally Scaled Conjugate Gradient Sparse Ax=b Solver.
C    DSICCG: Incomplete Cholesky Conjugate Gradient Sparse Ax=b Solver.
C
C    ============================= dcgn.f ============================
C    DCGN: Preconditioned CG Sparse Ax=b Solver for Normal Equations.
C    DSDCGN: Diagonally Scaled CG Sparse Ax=b Solver for Normal Eqn's.
C    DSLUCN: Incomplete LU CG Sparse Ax=b Solver for Normal Equations.
C
C    ============================= dbcg.f ============================
C    DBCG: Preconditioned BiConjugate Gradient Sparse Ax = b Solver.
C    DSDBCG: Diagonally Scaled BiConjugate Gradient Sparse Ax=b Solver.
C    DSLUBC: Incomplete LU BiConjugate Gradient Sparse Ax=b Solver.
C
C    ============================= dcgs.f ============================
C    DCGS: Preconditioned BiConjugate Gradient Squared Ax=b Solver.
C    DSDCGS: Diagonally Scaled CGS Sparse Ax=b Solver.
C    DSLUCS: Incomplete LU BiConjugate Gradient Squared Ax=b Solver.
C
C    ============================= domn.f ============================
C    DOMN: Preconditioned Orthomin Sparse Iterative Ax=b Solver.
C    DSDOMN: Diagonally Scaled Orthomin Sparse Iterative Ax=b Solver.
C    DSLUOM: Incomplete LU Orthomin Sparse Iterative Ax=b Solver.
C
C    ============================ dgmres.f ===========================
C    DGMRES: Preconditioned GMRES Iterative Sparse Ax=b Solver.
C    DSDGMR: Diagonally Scaled GMRES Iterative Sparse Ax=b Solver.
C    DSLUGM: Incomplete LU GMRES Iterative Sparse Ax=b Solver.
C
C    ============================ dmset.f ============================
C       The following routines are used to set up preconditioners.
C
C    DSDS: Diagonal Scaling Preconditioner SLAP Set Up.
C    DSDSCL: Diagonally Scales/Unscales a SLAP Column Matrix.
C    DSD2S: Diagonal Scaling Preconditioner SLAP Normal Eqns Set Up.
C    DS2LT: Lower Triangle Preconditioner SLAP Set Up.
C    DSICS: Incomplete Cholesky Decomp. Preconditioner SLAP Set Up.
C    DSILUS: Incomplete LU Decomposition Preconditioner SLAP Set Up.
C
C    ============================ dmvops.f ===========================
C       Most of the incomplete  factorization  (LL' and LDU) solvers
C       in this  file require an  intermediate routine  to translate
C       from the SLAP MSOLVE(N, R, Z, NELT, IA,  JA, A, ISYM, RWORK,
C       IWORK) calling  convention to the calling  sequence required
C       by  the solve routine.   This generally  is  accomplished by
C       fishing out pointers to the preconditioner (stored in RWORK)
C       from the  IWORK  array and then making a call to the routine
C       that actually does the backsolve.
C
C    DSMV: SLAP Column Format Sparse Matrix Vector Product.
C    DSMTV: SLAP Column Format Sparse Matrix (transpose) Vector Prod.
C    DSDI: Diagonal Matrix Vector Multiply.
C    DSLI: SLAP MSOLVE for Lower Triangle Matrix (set up for DSLI2).
C    DSLI2: Lower Triangle Matrix Backsolve.
C    DSLLTI: SLAP MSOLVE for LDL' (IC) Fact. (set up for DLLTI2).
C    DLLTI2: Backsolve routine for LDL' Factorization.
C    DSLUI: SLAP MSOLVE for LDU Factorization (set up for DSLUI2).
C    DSLUI2: SLAP Backsolve for LDU Factorization.
C    DSLUTI: SLAP MTSOLV for LDU Factorization (set up for DSLUI4).
C    DSLUI4: SLAP Backsolve for LDU Factorization.
C    DSMMTI: SLAP MSOLVE for LDU Fact of Normal Eq (set up for DSMMI2).
C    DSMMI2: SLAP Backsolve for LDU Factorization of Normal Equations.
C
C    =========================== dlaputil.f ==========================
C       The following utility routines are useful additions to SLAP.
C
C    DBHIN: Read Sparse Linear System in the Boeing/Harwell Format.
C    DCHKW: SLAP WORK/IWORK Array Bounds Checker.
C    DCPPLT: Printer Plot of SLAP Column Format Matrix.
C    DS2Y: SLAP Triad to SLAP Column Format Converter.
C    QS2I1D: Quick Sort Integer array, moving integer and DP arrays.
C            (Used by DS2Y.)
C    DTIN: Read in SLAP Triad Format Linear System.
C    DTOUT: Write out SLAP Triad Format Linear System.
C
C
C***REFERENCES  1. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C           -----( This produced Version 2.0.1. )-----
C   891003  Rearranged list of user callable routines to agree with
C           order in source deck.  (FNF)
C   891004  Updated reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C           -----( This produced Version 2.0.2. )-----
C   910506  Minor improvements to prologue.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of reference.  (FNF)
C   921019  Improved one-line descriptions, reordering some.  (FNF)
C***END PROLOGUE  DLPDOC
C***FIRST EXECUTABLE STATEMENT  DLPDOC
C
C     This is a *DUMMY* subroutine and should never be called.
C
      RETURN
C------------- LAST LINE OF DLPDOC FOLLOWS -----------------------------
      END
*DECK DLPDP
      SUBROUTINE DLPDP (A, MDA, M, N1, N2, PRGOPT, X, WNORM, MODE, WS,
     +   IS)
C***BEGIN PROLOGUE  DLPDP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DLSEI
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LPDP-S, DLPDP-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C  **** Double Precision version of LPDP ****
C     DIMENSION A(MDA,N+1),PRGOPT(*),X(N),WS((M+2)*(N+7)),IS(M+N+1),
C     where N=N1+N2.  This is a slight overestimate for WS(*).
C
C     Determine an N1-vector W, and
C               an N2-vector Z
C     which minimizes the Euclidean length of W
C     subject to G*W+H*Z .GE. Y.
C     This is the least projected distance problem, LPDP.
C     The matrices G and H are of respective
C     dimensions M by N1 and M by N2.
C
C     Called by subprogram DLSI( ).
C
C     The matrix
C                (G H Y)
C
C     occupies rows 1,...,M and cols 1,...,N1+N2+1 of A(*,*).
C
C     The solution (W) is returned in X(*).
C                  (Z)
C
C     The value of MODE indicates the status of
C     the computation after returning to the user.
C
C          MODE=1  The solution was successfully obtained.
C
C          MODE=2  The inequalities are inconsistent.
C
C***SEE ALSO  DLSEI
C***ROUTINES CALLED  DCOPY, DDOT, DNRM2, DSCAL, DWNNLS
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR section.  (WRB)
C***END PROLOGUE  DLPDP
C
      INTEGER I, IS(*), IW, IX, J, L, M, MDA, MODE, MODEW, N, N1, N2,
     *     NP1
      DOUBLE PRECISION A(MDA,*), DDOT, DNRM2, FAC, ONE,
     *     PRGOPT(*), RNORM, SC, WNORM, WS(*), X(*), YNORM, ZERO
      SAVE ZERO, ONE, FAC
      DATA ZERO,ONE /0.0D0,1.0D0/, FAC /0.1D0/
C***FIRST EXECUTABLE STATEMENT  DLPDP
      N = N1 + N2
      MODE = 1
      IF (M .GT. 0) GO TO 20
         IF (N .LE. 0) GO TO 10
            X(1) = ZERO
            CALL DCOPY(N,X,0,X,1)
   10    CONTINUE
         WNORM = ZERO
      GO TO 200
   20 CONTINUE
C        BEGIN BLOCK PERMITTING ...EXITS TO 190
            NP1 = N + 1
C
C           SCALE NONZERO ROWS OF INEQUALITY MATRIX TO HAVE LENGTH ONE.
            DO 40 I = 1, M
               SC = DNRM2(N,A(I,1),MDA)
               IF (SC .EQ. ZERO) GO TO 30
                  SC = ONE/SC
                  CALL DSCAL(NP1,SC,A(I,1),MDA)
   30          CONTINUE
   40       CONTINUE
C
C           SCALE RT.-SIDE VECTOR TO HAVE LENGTH ONE (OR ZERO).
            YNORM = DNRM2(M,A(1,NP1),1)
            IF (YNORM .EQ. ZERO) GO TO 50
               SC = ONE/YNORM
               CALL DSCAL(M,SC,A(1,NP1),1)
   50       CONTINUE
C
C           SCALE COLS OF MATRIX H.
            J = N1 + 1
   60       IF (J .GT. N) GO TO 70
               SC = DNRM2(M,A(1,J),1)
               IF (SC .NE. ZERO) SC = ONE/SC
               CALL DSCAL(M,SC,A(1,J),1)
               X(J) = SC
               J = J + 1
            GO TO 60
   70       CONTINUE
            IF (N1 .LE. 0) GO TO 130
C
C              COPY TRANSPOSE OF (H G Y) TO WORK ARRAY WS(*).
               IW = 0
               DO 80 I = 1, M
C
C                 MOVE COL OF TRANSPOSE OF H INTO WORK ARRAY.
                  CALL DCOPY(N2,A(I,N1+1),MDA,WS(IW+1),1)
                  IW = IW + N2
C
C                 MOVE COL OF TRANSPOSE OF G INTO WORK ARRAY.
                  CALL DCOPY(N1,A(I,1),MDA,WS(IW+1),1)
                  IW = IW + N1
C
C                 MOVE COMPONENT OF VECTOR Y INTO WORK ARRAY.
                  WS(IW+1) = A(I,NP1)
                  IW = IW + 1
   80          CONTINUE
               WS(IW+1) = ZERO
               CALL DCOPY(N,WS(IW+1),0,WS(IW+1),1)
               IW = IW + N
               WS(IW+1) = ONE
               IW = IW + 1
C
C              SOLVE EU=F SUBJECT TO (TRANSPOSE OF H)U=0, U.GE.0.  THE
C              MATRIX E = TRANSPOSE OF (G Y), AND THE (N+1)-VECTOR
C              F = TRANSPOSE OF (0,...,0,1).
               IX = IW + 1
               IW = IW + M
C
C              DO NOT CHECK LENGTHS OF WORK ARRAYS IN THIS USAGE OF
C              DWNNLS( ).
               IS(1) = 0
               IS(2) = 0
               CALL DWNNLS(WS,NP1,N2,NP1-N2,M,0,PRGOPT,WS(IX),RNORM,
     *                     MODEW,IS,WS(IW+1))
C
C              COMPUTE THE COMPONENTS OF THE SOLN DENOTED ABOVE BY W.
               SC = ONE - DDOT(M,A(1,NP1),1,WS(IX),1)
               IF (ONE + FAC*ABS(SC) .EQ. ONE .OR. RNORM .LE. ZERO)
     *            GO TO 110
                  SC = ONE/SC
                  DO 90 J = 1, N1
                     X(J) = SC*DDOT(M,A(1,J),1,WS(IX),1)
   90             CONTINUE
C
C                 COMPUTE THE VECTOR Q=Y-GW.  OVERWRITE Y WITH THIS
C                 VECTOR.
                  DO 100 I = 1, M
                     A(I,NP1) = A(I,NP1) - DDOT(N1,A(I,1),MDA,X,1)
  100             CONTINUE
               GO TO 120
  110          CONTINUE
                  MODE = 2
C        .........EXIT
                  GO TO 190
  120          CONTINUE
  130       CONTINUE
            IF (N2 .LE. 0) GO TO 180
C
C              COPY TRANSPOSE OF (H Q) TO WORK ARRAY WS(*).
               IW = 0
               DO 140 I = 1, M
                  CALL DCOPY(N2,A(I,N1+1),MDA,WS(IW+1),1)
                  IW = IW + N2
                  WS(IW+1) = A(I,NP1)
                  IW = IW + 1
  140          CONTINUE
               WS(IW+1) = ZERO
               CALL DCOPY(N2,WS(IW+1),0,WS(IW+1),1)
               IW = IW + N2
               WS(IW+1) = ONE
               IW = IW + 1
               IX = IW + 1
               IW = IW + M
C
C              SOLVE RV=S SUBJECT TO V.GE.0.  THE MATRIX R =(TRANSPOSE
C              OF (H Q)), WHERE Q=Y-GW.  THE (N2+1)-VECTOR S =(TRANSPOSE
C              OF (0,...,0,1)).
C
C              DO NOT CHECK LENGTHS OF WORK ARRAYS IN THIS USAGE OF
C              DWNNLS( ).
               IS(1) = 0
               IS(2) = 0
               CALL DWNNLS(WS,N2+1,0,N2+1,M,0,PRGOPT,WS(IX),RNORM,MODEW,
     *                     IS,WS(IW+1))
C
C              COMPUTE THE COMPONENTS OF THE SOLN DENOTED ABOVE BY Z.
               SC = ONE - DDOT(M,A(1,NP1),1,WS(IX),1)
               IF (ONE + FAC*ABS(SC) .EQ. ONE .OR. RNORM .LE. ZERO)
     *            GO TO 160
                  SC = ONE/SC
                  DO 150 J = 1, N2
                     L = N1 + J
                     X(L) = SC*DDOT(M,A(1,L),1,WS(IX),1)*X(L)
  150             CONTINUE
               GO TO 170
  160          CONTINUE
                  MODE = 2
C        .........EXIT
                  GO TO 190
  170          CONTINUE
  180       CONTINUE
C
C           ACCOUNT FOR SCALING OF RT.-SIDE VECTOR IN SOLUTION.
            CALL DSCAL(N,YNORM,X,1)
            WNORM = DNRM2(N1,X,1)
  190    CONTINUE
  200 CONTINUE
      RETURN
      END
*DECK DLSEI
      SUBROUTINE DLSEI (W, MDW, ME, MA, MG, N, PRGOPT, X, RNORME,
     +   RNORML, MODE, WS, IP)
C***BEGIN PROLOGUE  DLSEI
C***PURPOSE  Solve a linearly constrained least squares problem with
C            equality and inequality constraints, and optionally compute
C            a covariance matrix.
C***LIBRARY   SLATEC
C***CATEGORY  K1A2A, D9
C***TYPE      DOUBLE PRECISION (LSEI-S, DLSEI-D)
C***KEYWORDS  CONSTRAINED LEAST SQUARES, CURVE FITTING, DATA FITTING,
C             EQUALITY CONSTRAINTS, INEQUALITY CONSTRAINTS,
C             QUADRATIC PROGRAMMING
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     Abstract
C
C     This subprogram solves a linearly constrained least squares
C     problem with both equality and inequality constraints, and, if the
C     user requests, obtains a covariance matrix of the solution
C     parameters.
C
C     Suppose there are given matrices E, A and G of respective
C     dimensions ME by N, MA by N and MG by N, and vectors F, B and H of
C     respective lengths ME, MA and MG.  This subroutine solves the
C     linearly constrained least squares problem
C
C                   EX = F, (E ME by N) (equations to be exactly
C                                       satisfied)
C                   AX = B, (A MA by N) (equations to be
C                                       approximately satisfied,
C                                       least squares sense)
C                   GX .GE. H,(G MG by N) (inequality constraints)
C
C     The inequalities GX .GE. H mean that every component of the
C     product GX must be .GE. the corresponding component of H.
C
C     In case the equality constraints cannot be satisfied, a
C     generalized inverse solution residual vector length is obtained
C     for F-EX.  This is the minimal length possible for F-EX.
C
C     Any values ME .GE. 0, MA .GE. 0, or MG .GE. 0 are permitted.  The
C     rank of the matrix E is estimated during the computation.  We call
C     this value KRANKE.  It is an output parameter in IP(1) defined
C     below.  Using a generalized inverse solution of EX=F, a reduced
C     least squares problem with inequality constraints is obtained.
C     The tolerances used in these tests for determining the rank
C     of E and the rank of the reduced least squares problem are
C     given in Sandia Tech. Rept. SAND-78-1290.  They can be
C     modified by the user if new values are provided in
C     the option list of the array PRGOPT(*).
C
C     The user must dimension all arrays appearing in the call list..
C     W(MDW,N+1),PRGOPT(*),X(N),WS(2*(ME+N)+K+(MG+2)*(N+7)),IP(MG+2*N+2)
C     where K=MAX(MA+MG,N).  This allows for a solution of a range of
C     problems in the given working space.  The dimension of WS(*)
C     given is a necessary overestimate.  Once a particular problem
C     has been run, the output parameter IP(3) gives the actual
C     dimension required for that problem.
C
C     The parameters for DLSEI( ) are
C
C     Input.. All TYPE REAL variables are DOUBLE PRECISION
C
C     W(*,*),MDW,   The array W(*,*) is doubly subscripted with
C     ME,MA,MG,N    first dimensioning parameter equal to MDW.
C                   For this discussion let us call M = ME+MA+MG.  Then
C                   MDW must satisfy MDW .GE. M.  The condition
C                   MDW .LT. M is an error.
C
C                   The array W(*,*) contains the matrices and vectors
C
C                                  (E  F)
C                                  (A  B)
C                                  (G  H)
C
C                   in rows and columns 1,...,M and 1,...,N+1
C                   respectively.
C
C                   The integers ME, MA, and MG are the
C                   respective matrix row dimensions
C                   of E, A and G.  Each matrix has N columns.
C
C     PRGOPT(*)    This real-valued array is the option vector.
C                  If the user is satisfied with the nominal
C                  subprogram features set
C
C                  PRGOPT(1)=1 (or PRGOPT(1)=1.0)
C
C                  Otherwise PRGOPT(*) is a linked list consisting of
C                  groups of data of the following form
C
C                  LINK
C                  KEY
C                  DATA SET
C
C                  The parameters LINK and KEY are each one word.
C                  The DATA SET can be comprised of several words.
C                  The number of items depends on the value of KEY.
C                  The value of LINK points to the first
C                  entry of the next group of data within
C                  PRGOPT(*).  The exception is when there are
C                  no more options to change.  In that
C                  case, LINK=1 and the values KEY and DATA SET
C                  are not referenced.  The general layout of
C                  PRGOPT(*) is as follows.
C
C               ...PRGOPT(1) = LINK1 (link to first entry of next group)
C               .  PRGOPT(2) = KEY1 (key to the option change)
C               .  PRGOPT(3) = data value (data value for this change)
C               .       .
C               .       .
C               .       .
C               ...PRGOPT(LINK1)   = LINK2 (link to the first entry of
C               .                       next group)
C               .  PRGOPT(LINK1+1) = KEY2 (key to the option change)
C               .  PRGOPT(LINK1+2) = data value
C               ...     .
C               .       .
C               .       .
C               ...PRGOPT(LINK) = 1 (no more options to change)
C
C                  Values of LINK that are nonpositive are errors.
C                  A value of LINK .GT. NLINK=100000 is also an error.
C                  This helps prevent using invalid but positive
C                  values of LINK that will probably extend
C                  beyond the program limits of PRGOPT(*).
C                  Unrecognized values of KEY are ignored.  The
C                  order of the options is arbitrary and any number
C                  of options can be changed with the following
C                  restriction.  To prevent cycling in the
C                  processing of the option array, a count of the
C                  number of options changed is maintained.
C                  Whenever this count exceeds NOPT=1000, an error
C                  message is printed and the subprogram returns.
C
C                  Options..
C
C                  KEY=1
C                         Compute in W(*,*) the N by N
C                  covariance matrix of the solution variables
C                  as an output parameter.  Nominally the
C                  covariance matrix will not be computed.
C                  (This requires no user input.)
C                  The data set for this option is a single value.
C                  It must be nonzero when the covariance matrix
C                  is desired.  If it is zero, the covariance
C                  matrix is not computed.  When the covariance matrix
C                  is computed, the first dimensioning parameter
C                  of the array W(*,*) must satisfy MDW .GE. MAX(M,N).
C
C                  KEY=10
C                         Suppress scaling of the inverse of the
C                  normal matrix by the scale factor RNORM**2/
C                  MAX(1, no. of degrees of freedom).  This option
C                  only applies when the option for computing the
C                  covariance matrix (KEY=1) is used.  With KEY=1 and
C                  KEY=10 used as options the unscaled inverse of the
C                  normal matrix is returned in W(*,*).
C                  The data set for this option is a single value.
C                  When it is nonzero no scaling is done.  When it is
C                  zero scaling is done.  The nominal case is to do
C                  scaling so if option (KEY=1) is used alone, the
C                  matrix will be scaled on output.
C
C                  KEY=2
C                         Scale the nonzero columns of the
C                         entire data matrix.
C                  (E)
C                  (A)
C                  (G)
C
C                  to have length one.  The data set for this
C                  option is a single value.  It must be
C                  nonzero if unit length column scaling
C                  is desired.
C
C                  KEY=3
C                         Scale columns of the entire data matrix
C                  (E)
C                  (A)
C                  (G)
C
C                  with a user-provided diagonal matrix.
C                  The data set for this option consists
C                  of the N diagonal scaling factors, one for
C                  each matrix column.
C
C                  KEY=4
C                         Change the rank determination tolerance for
C                  the equality constraint equations from
C                  the nominal value of SQRT(DRELPR).  This quantity can
C                  be no smaller than DRELPR, the arithmetic-
C                  storage precision.  The quantity DRELPR is the
C                  largest positive number such that T=1.+DRELPR
C                  satisfies T .EQ. 1.  The quantity used
C                  here is internally restricted to be at
C                  least DRELPR.  The data set for this option
C                  is the new tolerance.
C
C                  KEY=5
C                         Change the rank determination tolerance for
C                  the reduced least squares equations from
C                  the nominal value of SQRT(DRELPR).  This quantity can
C                  be no smaller than DRELPR, the arithmetic-
C                  storage precision.  The quantity used
C                  here is internally restricted to be at
C                  least DRELPR.  The data set for this option
C                  is the new tolerance.
C
C                  For example, suppose we want to change
C                  the tolerance for the reduced least squares
C                  problem, compute the covariance matrix of
C                  the solution parameters, and provide
C                  column scaling for the data matrix.  For
C                  these options the dimension of PRGOPT(*)
C                  must be at least N+9.  The Fortran statements
C                  defining these options would be as follows:
C
C                  PRGOPT(1)=4 (link to entry 4 in PRGOPT(*))
C                  PRGOPT(2)=1 (covariance matrix key)
C                  PRGOPT(3)=1 (covariance matrix wanted)
C
C                  PRGOPT(4)=7 (link to entry 7 in PRGOPT(*))
C                  PRGOPT(5)=5 (least squares equas.  tolerance key)
C                  PRGOPT(6)=... (new value of the tolerance)
C
C                  PRGOPT(7)=N+9 (link to entry N+9 in PRGOPT(*))
C                  PRGOPT(8)=3 (user-provided column scaling key)
C
C                  CALL DCOPY (N, D, 1, PRGOPT(9), 1)  (Copy the N
C                    scaling factors from the user array D(*)
C                    to PRGOPT(9)-PRGOPT(N+8))
C
C                  PRGOPT(N+9)=1 (no more options to change)
C
C                  The contents of PRGOPT(*) are not modified
C                  by the subprogram.
C                  The options for WNNLS( ) can also be included
C                  in this array.  The values of KEY recognized
C                  by WNNLS( ) are 6, 7 and 8.  Their functions
C                  are documented in the usage instructions for
C                  subroutine WNNLS( ).  Normally these options
C                  do not need to be modified when using DLSEI( ).
C
C     IP(1),       The amounts of working storage actually
C     IP(2)        allocated for the working arrays WS(*) and
C                  IP(*), respectively.  These quantities are
C                  compared with the actual amounts of storage
C                  needed by DLSEI( ).  Insufficient storage
C                  allocated for either WS(*) or IP(*) is an
C                  error.  This feature was included in DLSEI( )
C                  because miscalculating the storage formulas
C                  for WS(*) and IP(*) might very well lead to
C                  subtle and hard-to-find execution errors.
C
C                  The length of WS(*) must be at least
C
C                  LW = 2*(ME+N)+K+(MG+2)*(N+7)
C
C                  where K = max(MA+MG,N)
C                  This test will not be made if IP(1).LE.0.
C
C                  The length of IP(*) must be at least
C
C                  LIP = MG+2*N+2
C                  This test will not be made if IP(2).LE.0.
C
C     Output.. All TYPE REAL variables are DOUBLE PRECISION
C
C     X(*),RNORME,  The array X(*) contains the solution parameters
C     RNORML        if the integer output flag MODE = 0 or 1.
C                   The definition of MODE is given directly below.
C                   When MODE = 0 or 1, RNORME and RNORML
C                   respectively contain the residual vector
C                   Euclidean lengths of F - EX and B - AX.  When
C                   MODE=1 the equality constraint equations EX=F
C                   are contradictory, so RNORME .NE. 0.  The residual
C                   vector F-EX has minimal Euclidean length.  For
C                   MODE .GE. 2, none of these parameters is defined.
C
C     MODE          Integer flag that indicates the subprogram
C                   status after completion.  If MODE .GE. 2, no
C                   solution has been computed.
C
C                   MODE =
C
C                   0  Both equality and inequality constraints
C                      are compatible and have been satisfied.
C
C                   1  Equality constraints are contradictory.
C                      A generalized inverse solution of EX=F was used
C                      to minimize the residual vector length F-EX.
C                      In this sense, the solution is still meaningful.
C
C                   2  Inequality constraints are contradictory.
C
C                   3  Both equality and inequality constraints
C                      are contradictory.
C
C                   The following interpretation of
C                   MODE=1,2 or 3 must be made.  The
C                   sets consisting of all solutions
C                   of the equality constraints EX=F
C                   and all vectors satisfying GX .GE. H
C                   have no points in common.  (In
C                   particular this does not say that
C                   each individual set has no points
C                   at all, although this could be the
C                   case.)
C
C                   4  Usage error occurred.  The value
C                      of MDW is .LT. ME+MA+MG, MDW is
C                      .LT. N and a covariance matrix is
C                      requested, or the option vector
C                      PRGOPT(*) is not properly defined,
C                      or the lengths of the working arrays
C                      WS(*) and IP(*), when specified in
C                      IP(1) and IP(2) respectively, are not
C                      long enough.
C
C     W(*,*)        The array W(*,*) contains the N by N symmetric
C                   covariance matrix of the solution parameters,
C                   provided this was requested on input with
C                   the option vector PRGOPT(*) and the output
C                   flag is returned with MODE = 0 or 1.
C
C     IP(*)         The integer working array has three entries
C                   that provide rank and working array length
C                   information after completion.
C
C                      IP(1) = rank of equality constraint
C                              matrix.  Define this quantity
C                              as KRANKE.
C
C                      IP(2) = rank of reduced least squares
C                              problem.
C
C                      IP(3) = the amount of storage in the
C                              working array WS(*) that was
C                              actually used by the subprogram.
C                              The formula given above for the length
C                              of WS(*) is a necessary overestimate.
C                              If exactly the same problem matrices
C                              are used in subsequent executions,
C                              the declared dimension of WS(*) can
C                              be reduced to this output value.
C     User Designated
C     Working Arrays..
C
C     WS(*),IP(*)              These are respectively type real
C                              and type integer working arrays.
C                              Their required minimal lengths are
C                              given above.
C
C***REFERENCES  K. H. Haskell and R. J. Hanson, An algorithm for
C                 linear least squares problems with equality and
C                 nonnegativity constraints, Report SAND77-0552, Sandia
C                 Laboratories, June 1978.
C               K. H. Haskell and R. J. Hanson, Selected algorithms for
C                 the linearly constrained least squares problem - a
C                 users guide, Report SAND78-1290, Sandia Laboratories,
C                 August 1979.
C               K. H. Haskell and R. J. Hanson, An algorithm for
C                 linear least squares problems with equality and
C                 nonnegativity constraints, Mathematical Programming
C                 21 (1981), pp. 98-118.
C               R. J. Hanson and K. H. Haskell, Two algorithms for the
C                 linearly constrained least squares problem, ACM
C                 Transactions on Mathematical Software, September 1982.
C***ROUTINES CALLED  D1MACH, DASUM, DAXPY, DCOPY, DDOT, DH12, DLSI,
C                    DNRM2, DSCAL, DSWAP, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and extensively revised (WRB & RWC)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   900604  DP version created from SP version.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DLSEI
      INTEGER IP(3), MA, MDW, ME, MG, MODE, N
      DOUBLE PRECISION PRGOPT(*), RNORME, RNORML, W(MDW,*), WS(*), X(*)
C
      EXTERNAL D1MACH, DASUM, DAXPY, DCOPY, DDOT, DH12, DLSI, DNRM2,
     *   DSCAL, DSWAP, XERMSG
      DOUBLE PRECISION D1MACH, DASUM, DDOT, DNRM2
C
      DOUBLE PRECISION DRELPR, ENORM, FNORM, GAM, RB, RN, RNMAX, SIZE,
     *   SN, SNMAX, T, TAU, UJ, UP, VJ, XNORM, XNRME
      INTEGER I, IMAX, J, JP1, K, KEY, KRANKE, LAST, LCHK, LINK, M,
     *   MAPKE1, MDEQC, MEND, MEP1, N1, N2, NEXT, NLINK, NOPT, NP1,
     *   NTIMES
      LOGICAL COV, FIRST
      CHARACTER*8 XERN1, XERN2, XERN3, XERN4
      SAVE FIRST, DRELPR
C
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DLSEI
C
C     Set the nominal tolerance used in the code for the equality
C     constraint equations.
C
      IF (FIRST) DRELPR = D1MACH(4)
      FIRST = .FALSE.
      TAU = SQRT(DRELPR)
C
C     Check that enough storage was allocated in WS(*) and IP(*).
C
      MODE = 4
      IF (MIN(N,ME,MA,MG) .LT. 0) THEN
         WRITE (XERN1, '(I8)') N
         WRITE (XERN2, '(I8)') ME
         WRITE (XERN3, '(I8)') MA
         WRITE (XERN4, '(I8)') MG
         CALL XERMSG ('SLATEC', 'LSEI', 'ALL OF THE VARIABLES N, ME,' //
     *      ' MA, MG MUST BE .GE. 0$$ENTERED ROUTINE WITH' //
     *      '$$N  = ' // XERN1 //
     *      '$$ME = ' // XERN2 //
     *      '$$MA = ' // XERN3 //
     *      '$$MG = ' // XERN4, 2, 1)
         RETURN
      ENDIF
C
      IF (IP(1).GT.0) THEN
         LCHK = 2*(ME+N) + MAX(MA+MG,N) + (MG+2)*(N+7)
         IF (IP(1).LT.LCHK) THEN
            WRITE (XERN1, '(I8)') LCHK
            CALL XERMSG ('SLATEC', 'DLSEI', 'INSUFFICIENT STORAGE ' //
     *         'ALLOCATED FOR WS(*), NEED LW = ' // XERN1, 2, 1)
            RETURN
         ENDIF
      ENDIF
C
      IF (IP(2).GT.0) THEN
         LCHK = MG + 2*N + 2
         IF (IP(2).LT.LCHK) THEN
            WRITE (XERN1, '(I8)') LCHK
            CALL XERMSG ('SLATEC', 'DLSEI', 'INSUFFICIENT STORAGE ' //
     *         'ALLOCATED FOR IP(*), NEED LIP = ' // XERN1, 2, 1)
            RETURN
         ENDIF
      ENDIF
C
C     Compute number of possible right multiplying Householder
C     transformations.
C
      M = ME + MA + MG
      IF (N.LE.0 .OR. M.LE.0) THEN
         MODE = 0
         RNORME = 0
         RNORML = 0
         RETURN
      ENDIF
C
      IF (MDW.LT.M) THEN
         CALL XERMSG ('SLATEC', 'DLSEI', 'MDW.LT.ME+MA+MG IS AN ERROR',
     +      2, 1)
         RETURN
      ENDIF
C
      NP1 = N + 1
      KRANKE = MIN(ME,N)
      N1 = 2*KRANKE + 1
      N2 = N1 + N
C
C     Set nominal values.
C
C     The nominal column scaling used in the code is
C     the identity scaling.
C
      CALL DCOPY (N, 1.D0, 0, WS(N1), 1)
C
C     No covariance matrix is nominally computed.
C
      COV = .FALSE.
C
C     Process option vector.
C     Define bound for number of options to change.
C
      NOPT = 1000
      NTIMES = 0
C
C     Define bound for positive values of LINK.
C
      NLINK = 100000
      LAST = 1
      LINK = PRGOPT(1)
      IF (LINK.EQ.0 .OR. LINK.GT.NLINK) THEN
         CALL XERMSG ('SLATEC', 'DLSEI',
     +      'THE OPTION VECTOR IS UNDEFINED', 2, 1)
         RETURN
      ENDIF
C
  100 IF (LINK.GT.1) THEN
         NTIMES = NTIMES + 1
         IF (NTIMES.GT.NOPT) THEN
            CALL XERMSG ('SLATEC', 'DLSEI',
     +         'THE LINKS IN THE OPTION VECTOR ARE CYCLING.', 2, 1)
            RETURN
         ENDIF
C
         KEY = PRGOPT(LAST+1)
         IF (KEY.EQ.1) THEN
            COV = PRGOPT(LAST+2) .NE. 0.D0
         ELSEIF (KEY.EQ.2 .AND. PRGOPT(LAST+2).NE.0.D0) THEN
            DO 110 J = 1,N
               T = DNRM2(M,W(1,J),1)
               IF (T.NE.0.D0) T = 1.D0/T
               WS(J+N1-1) = T
  110       CONTINUE
         ELSEIF (KEY.EQ.3) THEN
            CALL DCOPY (N, PRGOPT(LAST+2), 1, WS(N1), 1)
         ELSEIF (KEY.EQ.4) THEN
            TAU = MAX(DRELPR,PRGOPT(LAST+2))
         ENDIF
C
         NEXT = PRGOPT(LINK)
         IF (NEXT.LE.0 .OR. NEXT.GT.NLINK) THEN
         CALL XERMSG ('SLATEC', 'DLSEI',
     +      'THE OPTION VECTOR IS UNDEFINED', 2, 1)
            RETURN
         ENDIF
C
         LAST = LINK
         LINK = NEXT
         GO TO 100
      ENDIF
C
      DO 120 J = 1,N
         CALL DSCAL (M, WS(N1+J-1), W(1,J), 1)
  120 CONTINUE
C
      IF (COV .AND. MDW.LT.N) THEN
         CALL XERMSG ('SLATEC', 'DLSEI',
     +      'MDW .LT. N WHEN COV MATRIX NEEDED, IS AN ERROR', 2, 1)
         RETURN
      ENDIF
C
C     Problem definition and option vector OK.
C
      MODE = 0
C
C     Compute norm of equality constraint matrix and right side.
C
      ENORM = 0.D0
      DO 130 J = 1,N
         ENORM = MAX(ENORM,DASUM(ME,W(1,J),1))
  130 CONTINUE
C
      FNORM = DASUM(ME,W(1,NP1),1)
      SNMAX = 0.D0
      RNMAX = 0.D0
      DO 150 I = 1,KRANKE
C
C        Compute maximum ratio of vector lengths. Partition is at
C        column I.
C
         DO 140 K = I,ME
            SN = DDOT(N-I+1,W(K,I),MDW,W(K,I),MDW)
            RN = DDOT(I-1,W(K,1),MDW,W(K,1),MDW)
            IF (RN.EQ.0.D0 .AND. SN.GT.SNMAX) THEN
               SNMAX = SN
               IMAX = K
            ELSEIF (K.EQ.I .OR. SN*RNMAX.GT.RN*SNMAX) THEN
               SNMAX = SN
               RNMAX = RN
               IMAX = K
            ENDIF
  140    CONTINUE
C
C        Interchange rows if necessary.
C
         IF (I.NE.IMAX) CALL DSWAP (NP1, W(I,1), MDW, W(IMAX,1), MDW)
         IF (SNMAX.GT.RNMAX*TAU**2) THEN
C
C        Eliminate elements I+1,...,N in row I.
C
            CALL DH12 (1, I, I+1, N, W(I,1), MDW, WS(I), W(I+1,1), MDW,
     +                1, M-I)
         ELSE
            KRANKE = I - 1
            GO TO 160
         ENDIF
  150 CONTINUE
C
C     Save diagonal terms of lower trapezoidal matrix.
C
  160 CALL DCOPY (KRANKE, W, MDW+1, WS(KRANKE+1), 1)
C
C     Use Householder transformation from left to achieve
C     KRANKE by KRANKE upper triangular form.
C
      IF (KRANKE.LT.ME) THEN
         DO 170 K = KRANKE,1,-1
C
C           Apply transformation to matrix cols. 1,...,K-1.
C
            CALL DH12 (1, K, KRANKE+1, ME, W(1,K), 1, UP, W, 1, MDW,
     *         K-1)
C
C           Apply to rt side vector.
C
            CALL DH12 (2, K, KRANKE+1, ME, W(1,K), 1, UP, W(1,NP1), 1,
     +         1, 1)
  170    CONTINUE
      ENDIF
C
C     Solve for variables 1,...,KRANKE in new coordinates.
C
      CALL DCOPY (KRANKE, W(1, NP1), 1, X, 1)
      DO 180 I = 1,KRANKE
         X(I) = (X(I)-DDOT(I-1,W(I,1),MDW,X,1))/W(I,I)
  180 CONTINUE
C
C     Compute residuals for reduced problem.
C
      MEP1 = ME + 1
      RNORML = 0.D0
      DO 190 I = MEP1,M
         W(I,NP1) = W(I,NP1) - DDOT(KRANKE,W(I,1),MDW,X,1)
         SN = DDOT(KRANKE,W(I,1),MDW,W(I,1),MDW)
         RN = DDOT(N-KRANKE,W(I,KRANKE+1),MDW,W(I,KRANKE+1),MDW)
         IF (RN.LE.SN*TAU**2 .AND. KRANKE.LT.N)
     *      CALL DCOPY (N-KRANKE, 0.D0, 0, W(I,KRANKE+1), MDW)
  190 CONTINUE
C
C     Compute equality constraint equations residual length.
C
      RNORME = DNRM2(ME-KRANKE,W(KRANKE+1,NP1),1)
C
C     Move reduced problem data upward if KRANKE.LT.ME.
C
      IF (KRANKE.LT.ME) THEN
         DO 200 J = 1,NP1
            CALL DCOPY (M-ME, W(ME+1,J), 1, W(KRANKE+1,J), 1)
  200    CONTINUE
      ENDIF
C
C     Compute solution of reduced problem.
C
      CALL DLSI(W(KRANKE+1, KRANKE+1), MDW, MA, MG, N-KRANKE, PRGOPT,
     +         X(KRANKE+1), RNORML, MODE, WS(N2), IP(2))
C
C     Test for consistency of equality constraints.
C
      IF (ME.GT.0) THEN
         MDEQC = 0
         XNRME = DASUM(KRANKE,W(1,NP1),1)
         IF (RNORME.GT.TAU*(ENORM*XNRME+FNORM)) MDEQC = 1
         MODE = MODE + MDEQC
C
C        Check if solution to equality constraints satisfies inequality
C        constraints when there are no degrees of freedom left.
C
         IF (KRANKE.EQ.N .AND. MG.GT.0) THEN
            XNORM = DASUM(N,X,1)
            MAPKE1 = MA + KRANKE + 1
            MEND = MA + KRANKE + MG
            DO 210 I = MAPKE1,MEND
               SIZE = DASUM(N,W(I,1),MDW)*XNORM + ABS(W(I,NP1))
               IF (W(I,NP1).GT.TAU*SIZE) THEN
                  MODE = MODE + 2
                  GO TO 290
               ENDIF
  210       CONTINUE
         ENDIF
      ENDIF
C
C     Replace diagonal terms of lower trapezoidal matrix.
C
      IF (KRANKE.GT.0) THEN
         CALL DCOPY (KRANKE, WS(KRANKE+1), 1, W, MDW+1)
C
C        Reapply transformation to put solution in original coordinates.
C
         DO 220 I = KRANKE,1,-1
            CALL DH12 (2, I, I+1, N, W(I,1), MDW, WS(I), X, 1, 1, 1)
  220    CONTINUE
C
C        Compute covariance matrix of equality constrained problem.
C
         IF (COV) THEN
            DO 270 J = MIN(KRANKE,N-1),1,-1
               RB = WS(J)*W(J,J)
               IF (RB.NE.0.D0) RB = 1.D0/RB
               JP1 = J + 1
               DO 230 I = JP1,N
                  W(I,J) = RB*DDOT(N-J,W(I,JP1),MDW,W(J,JP1),MDW)
  230          CONTINUE
C
               GAM = 0.5D0*RB*DDOT(N-J,W(JP1,J),1,W(J,JP1),MDW)
               CALL DAXPY (N-J, GAM, W(J,JP1), MDW, W(JP1,J), 1)
               DO 250 I = JP1,N
                  DO 240 K = I,N
                     W(I,K) = W(I,K) + W(J,I)*W(K,J) + W(I,J)*W(J,K)
                     W(K,I) = W(I,K)
  240             CONTINUE
  250          CONTINUE
               UJ = WS(J)
               VJ = GAM*UJ
               W(J,J) = UJ*VJ + UJ*VJ
               DO 260 I = JP1,N
                  W(J,I) = UJ*W(I,J) + VJ*W(J,I)
  260          CONTINUE
               CALL DCOPY (N-J, W(J, JP1), MDW, W(JP1,J), 1)
  270       CONTINUE
         ENDIF
      ENDIF
C
C     Apply the scaling to the covariance matrix.
C
      IF (COV) THEN
         DO 280 I = 1,N
            CALL DSCAL (N, WS(I+N1-1), W(I,1), MDW)
            CALL DSCAL (N, WS(I+N1-1), W(1,I), 1)
  280    CONTINUE
      ENDIF
C
C     Rescale solution vector.
C
  290 IF (MODE.LE.1) THEN
         DO 300 J = 1,N
            X(J) = X(J)*WS(N1+J-1)
  300    CONTINUE
      ENDIF
C
      IP(1) = KRANKE
      IP(3) = IP(3) + 2*KRANKE + N
      RETURN
      END
*DECK DLSI
      SUBROUTINE DLSI (W, MDW, MA, MG, N, PRGOPT, X, RNORM, MODE, WS,
     +   IP)
C***BEGIN PROLOGUE  DLSI
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DLSEI
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LSI-S, DLSI-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C     This is a companion subprogram to DLSEI.  The documentation for
C     DLSEI has complete usage instructions.
C
C     Solve..
C              AX = B,  A  MA by N  (least squares equations)
C     subject to..
C
C              GX.GE.H, G  MG by N  (inequality constraints)
C
C     Input..
C
C      W(*,*) contains  (A B) in rows 1,...,MA+MG, cols 1,...,N+1.
C                       (G H)
C
C     MDW,MA,MG,N
C              contain (resp) var. dimension of W(*,*),
C              and matrix dimensions.
C
C     PRGOPT(*),
C              Program option vector.
C
C     OUTPUT..
C
C      X(*),RNORM
C
C              Solution vector(unless MODE=2), length of AX-B.
C
C      MODE
C              =0   Inequality constraints are compatible.
C              =2   Inequality constraints contradictory.
C
C      WS(*),
C              Working storage of dimension K+N+(MG+2)*(N+7),
C              where K=MAX(MA+MG,N).
C      IP(MG+2*N+1)
C              Integer working storage
C
C***ROUTINES CALLED  D1MACH, DASUM, DAXPY, DCOPY, DDOT, DH12, DHFTI,
C                    DLPDP, DSCAL, DSWAP
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and extensively revised (WRB & RWC)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900604  DP version created from SP version.  (RWC)
C   920422  Changed CALL to DHFTI to include variable MA.  (WRB)
C***END PROLOGUE  DLSI
      INTEGER IP(*), MA, MDW, MG, MODE, N
      DOUBLE PRECISION PRGOPT(*), RNORM, W(MDW,*), WS(*), X(*)
C
      EXTERNAL D1MACH, DASUM, DAXPY, DCOPY, DDOT, DH12, DHFTI, DLPDP,
     *   DSCAL, DSWAP
      DOUBLE PRECISION D1MACH, DASUM, DDOT
C
      DOUBLE PRECISION ANORM, DRELPR, FAC, GAM, RB, TAU, TOL, XNORM
      INTEGER I, J, K, KEY, KRANK, KRM1, KRP1, L, LAST, LINK, M, MAP1,
     *   MDLPDP, MINMAN, N1, N2, N3, NEXT, NP1
      LOGICAL COV, FIRST, SCLCOV
C
      SAVE DRELPR, FIRST
      DATA FIRST /.TRUE./
C
C***FIRST EXECUTABLE STATEMENT  DLSI
C
C     Set the nominal tolerance used in the code.
C
      IF (FIRST) DRELPR = D1MACH(4)
      FIRST = .FALSE.
      TOL = SQRT(DRELPR)
C
      MODE = 0
      RNORM = 0.D0
      M = MA + MG
      NP1 = N + 1
      KRANK = 0
      IF (N.LE.0 .OR. M.LE.0) GO TO 370
C
C     To process option vector.
C
      COV = .FALSE.
      SCLCOV = .TRUE.
      LAST = 1
      LINK = PRGOPT(1)
C
  100 IF (LINK.GT.1) THEN
         KEY = PRGOPT(LAST+1)
         IF (KEY.EQ.1) COV = PRGOPT(LAST+2) .NE. 0.D0
         IF (KEY.EQ.10) SCLCOV = PRGOPT(LAST+2) .EQ. 0.D0
         IF (KEY.EQ.5) TOL = MAX(DRELPR,PRGOPT(LAST+2))
         NEXT = PRGOPT(LINK)
         LAST = LINK
         LINK = NEXT
         GO TO 100
      ENDIF
C
C     Compute matrix norm of least squares equations.
C
      ANORM = 0.D0
      DO 110 J = 1,N
         ANORM = MAX(ANORM,DASUM(MA,W(1,J),1))
  110 CONTINUE
C
C     Set tolerance for DHFTI( ) rank test.
C
      TAU = TOL*ANORM
C
C     Compute Householder orthogonal decomposition of matrix.
C
      CALL DCOPY (N, 0.D0, 0, WS, 1)
      CALL DCOPY (MA, W(1, NP1), 1, WS, 1)
      K = MAX(M,N)
      MINMAN = MIN(MA,N)
      N1 = K + 1
      N2 = N1 + N
      CALL DHFTI (W, MDW, MA, N, WS, MA, 1, TAU, KRANK, RNORM, WS(N2),
     +           WS(N1), IP)
      FAC = 1.D0
      GAM = MA - KRANK
      IF (KRANK.LT.MA .AND. SCLCOV) FAC = RNORM**2/GAM
C
C     Reduce to DLPDP and solve.
C
      MAP1 = MA + 1
C
C     Compute inequality rt-hand side for DLPDP.
C
      IF (MA.LT.M) THEN
         IF (MINMAN.GT.0) THEN
            DO 120 I = MAP1,M
               W(I,NP1) = W(I,NP1) - DDOT(N,W(I,1),MDW,WS,1)
  120       CONTINUE
C
C           Apply permutations to col. of inequality constraint matrix.
C
            DO 130 I = 1,MINMAN
               CALL DSWAP (MG, W(MAP1,I), 1, W(MAP1,IP(I)), 1)
  130       CONTINUE
C
C           Apply Householder transformations to constraint matrix.
C
            IF (KRANK.GT.0 .AND. KRANK.LT.N) THEN
               DO 140 I = KRANK,1,-1
                  CALL DH12 (2, I, KRANK+1, N, W(I,1), MDW, WS(N1+I-1),
     +                      W(MAP1,1), MDW, 1, MG)
  140          CONTINUE
            ENDIF
C
C           Compute permuted inequality constraint matrix times r-inv.
C
            DO 160 I = MAP1,M
               DO 150 J = 1,KRANK
                  W(I,J) = (W(I,J)-DDOT(J-1,W(1,J),1,W(I,1),MDW))/W(J,J)
  150          CONTINUE
  160       CONTINUE
         ENDIF
C
C        Solve the reduced problem with DLPDP algorithm,
C        the least projected distance problem.
C
         CALL DLPDP(W(MAP1,1), MDW, MG, KRANK, N-KRANK, PRGOPT, X,
     +             XNORM, MDLPDP, WS(N2), IP(N+1))
C
C        Compute solution in original coordinates.
C
         IF (MDLPDP.EQ.1) THEN
            DO 170 I = KRANK,1,-1
               X(I) = (X(I)-DDOT(KRANK-I,W(I,I+1),MDW,X(I+1),1))/W(I,I)
  170       CONTINUE
C
C           Apply Householder transformation to solution vector.
C
            IF (KRANK.LT.N) THEN
               DO 180 I = 1,KRANK
                  CALL DH12 (2, I, KRANK+1, N, W(I,1), MDW, WS(N1+I-1),
     +                      X, 1, 1, 1)
  180          CONTINUE
            ENDIF
C
C           Repermute variables to their input order.
C
            IF (MINMAN.GT.0) THEN
               DO 190 I = MINMAN,1,-1
                  CALL DSWAP (1, X(I), 1, X(IP(I)), 1)
  190          CONTINUE
C
C              Variables are now in original coordinates.
C              Add solution of unconstrained problem.
C
               DO 200 I = 1,N
                  X(I) = X(I) + WS(I)
  200          CONTINUE
C
C              Compute the residual vector norm.
C
               RNORM = SQRT(RNORM**2+XNORM**2)
            ENDIF
         ELSE
            MODE = 2
         ENDIF
      ELSE
         CALL DCOPY (N, WS, 1, X, 1)
      ENDIF
C
C     Compute covariance matrix based on the orthogonal decomposition
C     from DHFTI( ).
C
      IF (.NOT.COV .OR. KRANK.LE.0) GO TO 370
      KRM1 = KRANK - 1
      KRP1 = KRANK + 1
C
C     Copy diagonal terms to working array.
C
      CALL DCOPY (KRANK, W, MDW+1, WS(N2), 1)
C
C     Reciprocate diagonal terms.
C
      DO 210 J = 1,KRANK
         W(J,J) = 1.D0/W(J,J)
  210 CONTINUE
C
C     Invert the upper triangular QR factor on itself.
C
      IF (KRANK.GT.1) THEN
         DO 230 I = 1,KRM1
            DO 220 J = I+1,KRANK
               W(I,J) = -DDOT(J-I,W(I,I),MDW,W(I,J),1)*W(J,J)
  220       CONTINUE
  230    CONTINUE
      ENDIF
C
C     Compute the inverted factor times its transpose.
C
      DO 250 I = 1,KRANK
         DO 240 J = I,KRANK
            W(I,J) = DDOT(KRANK+1-J,W(I,J),MDW,W(J,J),MDW)
  240    CONTINUE
  250 CONTINUE
C
C     Zero out lower trapezoidal part.
C     Copy upper triangular to lower triangular part.
C
      IF (KRANK.LT.N) THEN
         DO 260 J = 1,KRANK
            CALL DCOPY (J, W(1,J), 1, W(J,1), MDW)
  260    CONTINUE
C
         DO 270 I = KRP1,N
            CALL DCOPY (I, 0.D0, 0, W(I,1), MDW)
  270    CONTINUE
C
C        Apply right side transformations to lower triangle.
C
         N3 = N2 + KRP1
         DO 330 I = 1,KRANK
            L = N1 + I
            K = N2 + I
            RB = WS(L-1)*WS(K-1)
C
C           If RB.GE.0.D0, transformation can be regarded as zero.
C
            IF (RB.LT.0.D0) THEN
               RB = 1.D0/RB
C
C              Store unscaled rank one Householder update in work array.
C
               CALL DCOPY (N, 0.D0, 0, WS(N3), 1)
               L = N1 + I
               K = N3 + I
               WS(K-1) = WS(L-1)
C
               DO 280 J = KRP1,N
                  WS(N3+J-1) = W(I,J)
  280          CONTINUE
C
               DO 290 J = 1,N
                  WS(J) = RB*(DDOT(J-I,W(J,I),MDW,WS(N3+I-1),1)+
     +                    DDOT(N-J+1,W(J,J),1,WS(N3+J-1),1))
  290          CONTINUE
C
               L = N3 + I
               GAM = 0.5D0*RB*DDOT(N-I+1,WS(L-1),1,WS(I),1)
               CALL DAXPY (N-I+1, GAM, WS(L-1), 1, WS(I), 1)
               DO 320 J = I,N
                  DO 300 L = 1,I-1
                     W(J,L) = W(J,L) + WS(N3+J-1)*WS(L)
  300             CONTINUE
C
                  DO 310 L = I,J
                     W(J,L) = W(J,L) + WS(J)*WS(N3+L-1)+WS(L)*WS(N3+J-1)
  310             CONTINUE
  320          CONTINUE
            ENDIF
  330    CONTINUE
C
C        Copy lower triangle to upper triangle to symmetrize the
C        covariance matrix.
C
         DO 340 I = 1,N
            CALL DCOPY (I, W(I,1), MDW, W(1,I), 1)
  340    CONTINUE
      ENDIF
C
C     Repermute rows and columns.
C
      DO 350 I = MINMAN,1,-1
         K = IP(I)
         IF (I.NE.K) THEN
            CALL DSWAP (1, W(I,I), 1, W(K,K), 1)
            CALL DSWAP (I-1, W(1,I), 1, W(1,K), 1)
            CALL DSWAP (K-I-1, W(I,I+1), MDW, W(I+1,K), 1)
            CALL DSWAP (N-K, W(I, K+1), MDW, W(K, K+1), MDW)
         ENDIF
  350 CONTINUE
C
C     Put in normalized residual sum of squares scale factor
C     and symmetrize the resulting covariance matrix.
C
      DO 360 J = 1,N
         CALL DSCAL (J, FAC, W(1,J), 1)
         CALL DCOPY (J, W(1,J), 1, W(J,1), MDW)
  360 CONTINUE
C
  370 IP(1) = KRANK
      IP(2) = N + MAX(M,N) + (MG+2)*(N+7)
      RETURN
      END
*DECK DLSOD
      SUBROUTINE DLSOD (DF, NEQ, T, Y, TOUT, RTOL, ATOL, IDID, YPOUT,
     +   YH, YH1, EWT, SAVF, ACOR, WM, IWM, DJAC, INTOUT, TSTOP, TOLFAC,
     +   DELSGN, RPAR, IPAR)
C***BEGIN PROLOGUE  DLSOD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DDEBDF
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LSOD-S, DLSOD-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   DDEBDF  merely allocates storage for  DLSOD  to relieve the user of
C   the inconvenience of a long call list.  Consequently  DLSOD  is used
C   as described in the comments for  DDEBDF .
C
C***SEE ALSO  DDEBDF
C***ROUTINES CALLED  D1MACH, DHSTRT, DINTYD, DSTOD, DVNRMS, XERMSG
C***COMMON BLOCKS    DDEBD1
C***REVISION HISTORY  (YYMMDD)
C   820301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  DLSOD
C
      INTEGER IBAND, IBEGIN, IDID, IER, IINTEG, IJAC, INIT, INTFLG,
     1      IOWNS, IPAR, IQUIT, ITOL, ITSTOP, IWM, JSTART, K, KFLAG,
     2      KSTEPS, L, LACOR, LDUM, LEWT, LSAVF, LTOL, LWM, LYH, MAXNUM,
     3      MAXORD, METH, MITER, N, NATOLP, NEQ, NFE, NJE, NQ, NQU,
     4      NRTOLP, NST
      DOUBLE PRECISION ABSDEL, ACOR, ATOL, BIG, D1MACH, DEL,
     1      DELSGN, DT, DVNRMS, EL0, EWT,
     2      H, HA, HMIN, HMXI, HU, ROWNS, RPAR, RTOL, SAVF, T, TOL,
     3      TOLD, TOLFAC, TOUT, TSTOP, U, WM, X, Y, YH, YH1, YPOUT
      LOGICAL INTOUT
      CHARACTER*8 XERN1
      CHARACTER*16 XERN3, XERN4
C
      DIMENSION Y(*),YPOUT(*),YH(NEQ,6),YH1(*),EWT(*),SAVF(*),
     1          ACOR(*),WM(*),IWM(*),RTOL(*),ATOL(*),RPAR(*),IPAR(*)
C
C
      COMMON /DDEBD1/ TOLD,ROWNS(210),EL0,H,HMIN,HMXI,HU,X,U,IQUIT,INIT,
     1                LYH,LEWT,LACOR,LSAVF,LWM,KSTEPS,IBEGIN,ITOL,
     2                IINTEG,ITSTOP,IJAC,IBAND,IOWNS(6),IER,JSTART,
     3                KFLAG,LDUM,METH,MITER,MAXORD,N,NQ,NST,NFE,NJE,NQU
C
      EXTERNAL DF, DJAC
C
C     ..................................................................
C
C       THE EXPENSE OF SOLVING THE PROBLEM IS MONITORED BY COUNTING THE
C       NUMBER OF  STEPS ATTEMPTED. WHEN THIS EXCEEDS  MAXNUM, THE
C       COUNTER IS RESET TO ZERO AND THE USER IS INFORMED ABOUT POSSIBLE
C       EXCESSIVE WORK.
      SAVE MAXNUM
C
      DATA MAXNUM /500/
C
C     ..................................................................
C
C***FIRST EXECUTABLE STATEMENT  DLSOD
      IF (IBEGIN .EQ. 0) THEN
C
C        ON THE FIRST CALL , PERFORM INITIALIZATION --
C        DEFINE THE MACHINE UNIT ROUNDOFF QUANTITY  U  BY CALLING THE
C        FUNCTION ROUTINE D1MACH. THE USER MUST MAKE SURE THAT THE
C        VALUES SET IN D1MACH ARE RELEVANT TO THE COMPUTER BEING USED.
C
         U = D1MACH(4)
C                          -- SET ASSOCIATED MACHINE DEPENDENT PARAMETER
         WM(1) = SQRT(U)
C                          -- SET TERMINATION FLAG
         IQUIT = 0
C                          -- SET INITIALIZATION INDICATOR
         INIT = 0
C                          -- SET COUNTER FOR ATTEMPTED STEPS
         KSTEPS = 0
C                          -- SET INDICATOR FOR INTERMEDIATE-OUTPUT
         INTOUT = .FALSE.
C                          -- SET START INDICATOR FOR DSTOD CODE
         JSTART = 0
C                          -- SET BDF METHOD INDICATOR
         METH = 2
C                          -- SET MAXIMUM ORDER FOR BDF METHOD
         MAXORD = 5
C                          -- SET ITERATION MATRIX INDICATOR
C
         IF (IJAC .EQ. 0 .AND. IBAND .EQ. 0) MITER = 2
         IF (IJAC .EQ. 1 .AND. IBAND .EQ. 0) MITER = 1
         IF (IJAC .EQ. 0 .AND. IBAND .EQ. 1) MITER = 5
         IF (IJAC .EQ. 1 .AND. IBAND .EQ. 1) MITER = 4
C
C                          -- SET OTHER NECESSARY ITEMS IN COMMON BLOCK
         N = NEQ
         NST = 0
         NJE = 0
         HMXI = 0.0D0
         NQ = 1
         H = 1.0D0
C                          -- RESET IBEGIN FOR SUBSEQUENT CALLS
         IBEGIN = 1
      ENDIF
C
C     ..................................................................
C
C      CHECK VALIDITY OF INPUT PARAMETERS ON EACH ENTRY
C
      IF (NEQ .LT. 1) THEN
         WRITE (XERN1, '(I8)') NEQ
         CALL XERMSG ('SLATEC', 'DLSOD',
     *      'IN DDEBDF, THE NUMBER OF EQUATIONS MUST BE A ' //
     *      'POSITIVE INTEGER.$$YOU HAVE CALLED THE CODE WITH NEQ = ' //
     *      XERN1, 6, 1)
         IDID=-33
      ENDIF
C
      NRTOLP = 0
      NATOLP = 0
      DO 60 K = 1, NEQ
         IF (NRTOLP .LE. 0) THEN
            IF (RTOL(K) .LT. 0.) THEN
               WRITE (XERN1, '(I8)') K
               WRITE (XERN3, '(1PE15.6)') RTOL(K)
               CALL XERMSG ('SLATEC', 'DLSOD',
     *            'IN DDEBDF, THE RELATIVE ERROR TOLERANCES MUST ' //
     *            'BE NON-NEGATIVE.$$YOU HAVE CALLED THE CODE WITH ' //
     *            'RTOL(' // XERN1 // ') = ' // XERN3 // '$$IN THE ' //
     *            'CASE OF VECTOR ERROR TOLERANCES, NO FURTHER ' //
     *            'CHECKING OF RTOL COMPONENTS IS DONE.', 7, 1)
               IDID = -33
               IF (NATOLP .GT. 0) GO TO 70
               NRTOLP = 1
            ELSEIF (NATOLP .GT. 0) THEN
               GO TO 50
            ENDIF
         ENDIF
C
         IF (ATOL(K) .LT. 0.) THEN
            WRITE (XERN1, '(I8)') K
            WRITE (XERN3, '(1PE15.6)') ATOL(K)
            CALL XERMSG ('SLATEC', 'DLSOD',
     *         'IN DDEBDF, THE ABSOLUTE ERROR ' //
     *         'TOLERANCES MUST BE NON-NEGATIVE.$$YOU HAVE CALLED ' //
     *         'THE CODE WITH ATOL(' // XERN1 // ') = ' // XERN3 //
     *         '$$IN THE CASE OF VECTOR ERROR TOLERANCES, NO FURTHER '
     *         // 'CHECKING OF ATOL COMPONENTS IS DONE.', 8, 1)
            IDID=-33
            IF (NRTOLP .GT. 0) GO TO 70
            NATOLP=1
         ENDIF
   50    IF (ITOL .EQ. 0) GO TO 70
   60 CONTINUE
C
   70 IF (ITSTOP .EQ. 1) THEN
         IF (SIGN(1.0D0,TOUT-T) .NE. SIGN(1.0D0,TSTOP-T) .OR.
     1      ABS(TOUT-T) .GT. ABS(TSTOP-T)) THEN
            WRITE (XERN3, '(1PE15.6)') TOUT
            WRITE (XERN4, '(1PE15.6)') TSTOP
            CALL XERMSG ('SLATEC', 'DLSOD',
     *         'IN DDEBDF, YOU HAVE CALLED THE ' //
     *         'CODE WITH TOUT = ' // XERN3 // '$$BUT YOU HAVE ' //
     *         'ALSO TOLD THE CODE NOT TO INTEGRATE PAST THE POINT ' //
     *         'TSTOP = ' // XERN4 // ' BY SETTING INFO(4) = 1.$$' //
     *         'THESE INSTRUCTIONS CONFLICT.', 14, 1)
            IDID=-33
         ENDIF
      ENDIF
C
C        CHECK SOME CONTINUATION POSSIBILITIES
C
      IF (INIT .NE. 0) THEN
         IF (T .EQ. TOUT) THEN
            WRITE (XERN3, '(1PE15.6)') T
            CALL XERMSG ('SLATEC', 'DLSOD',
     *         'IN DDEBDF, YOU HAVE CALLED THE CODE WITH T = TOUT = ' //
     *         XERN3 // '$$THIS IS NOT ALLOWED ON CONTINUATION CALLS.',
     *         9, 1)
            IDID=-33
         ENDIF
C
         IF (T .NE. TOLD) THEN
            WRITE (XERN3, '(1PE15.6)') TOLD
            WRITE (XERN4, '(1PE15.6)') T
            CALL XERMSG ('SLATEC', 'DLSOD',
     *         'IN DDEBDF, YOU HAVE CHANGED THE VALUE OF T FROM ' //
     *         XERN3 // ' TO ' // XERN4 //
     *         '  THIS IS NOT ALLOWED ON CONTINUATION CALLS.', 10, 1)
            IDID=-33
         ENDIF
C
         IF (INIT .NE. 1) THEN
            IF (DELSGN*(TOUT-T) .LT. 0.0D0) THEN
               WRITE (XERN3, '(1PE15.6)') TOUT
               CALL XERMSG ('SLATEC', 'DLSOD',
     *            'IN DDEBDF, BY CALLING THE CODE WITH TOUT = ' //
     *            XERN3 // ' YOU ARE ATTEMPTING TO CHANGE THE ' //
     *            'DIRECTION OF INTEGRATION.$$THIS IS NOT ALLOWED ' //
     *            'WITHOUT RESTARTING.', 11, 1)
               IDID=-33
            ENDIF
         ENDIF
      ENDIF
C
      IF (IDID .EQ. (-33)) THEN
         IF (IQUIT .NE. (-33)) THEN
C                       INVALID INPUT DETECTED
            IQUIT=-33
            IBEGIN=-1
         ELSE
            CALL XERMSG ('SLATEC', 'DLSOD',
     *         'IN DDEBDF, INVALID INPUT WAS DETECTED ON ' //
     *         'SUCCESSIVE ENTRIES.  IT IS IMPOSSIBLE TO PROCEED ' //
     *         'BECAUSE YOU HAVE NOT CORRECTED THE PROBLEM, ' //
     *         'SO EXECUTION IS BEING TERMINATED.', 12, 2)
         ENDIF
         RETURN
      ENDIF
C
C        ...............................................................
C
C             RTOL = ATOL = 0. IS ALLOWED AS VALID INPUT AND INTERPRETED
C             AS ASKING FOR THE MOST ACCURATE SOLUTION POSSIBLE. IN THIS
C             CASE, THE RELATIVE ERROR TOLERANCE RTOL IS RESET TO THE
C             SMALLEST VALUE 100*U WHICH IS LIKELY TO BE REASONABLE FOR
C             THIS METHOD AND MACHINE
C
      DO 180 K = 1, NEQ
         IF (RTOL(K) + ATOL(K) .GT. 0.0D0) GO TO 170
            RTOL(K) = 100.0D0*U
            IDID = -2
  170    CONTINUE
C     ...EXIT
         IF (ITOL .EQ. 0) GO TO 190
  180 CONTINUE
  190 CONTINUE
C
      IF (IDID .NE. (-2)) GO TO 200
C        RTOL=ATOL=0 ON INPUT, SO RTOL IS CHANGED TO A
C                                 SMALL POSITIVE VALUE
         IBEGIN = -1
      GO TO 460
  200 CONTINUE
C        BEGIN BLOCK PERMITTING ...EXITS TO 450
C           BEGIN BLOCK PERMITTING ...EXITS TO 430
C              BEGIN BLOCK PERMITTING ...EXITS TO 260
C                 BEGIN BLOCK PERMITTING ...EXITS TO 230
C
C                    BRANCH ON STATUS OF INITIALIZATION INDICATOR
C                           INIT=0 MEANS INITIAL DERIVATIVES AND
C                           NOMINAL STEP SIZE
C                                  AND DIRECTION NOT YET SET
C                           INIT=1 MEANS NOMINAL STEP SIZE AND
C                           DIRECTION NOT YET SET INIT=2 MEANS NO
C                           FURTHER INITIALIZATION REQUIRED
C
                     IF (INIT .EQ. 0) GO TO 210
C                 ......EXIT
                        IF (INIT .EQ. 1) GO TO 230
C              .........EXIT
                        GO TO 260
  210                CONTINUE
C
C                    ................................................
C
C                         MORE INITIALIZATION --
C                                             -- EVALUATE INITIAL
C                                             DERIVATIVES
C
                     INIT = 1
                     CALL DF(T,Y,YH(1,2),RPAR,IPAR)
                     NFE = 1
C                 ...EXIT
                     IF (T .NE. TOUT) GO TO 230
                     IDID = 2
                     DO 220 L = 1, NEQ
                        YPOUT(L) = YH(L,2)
  220                CONTINUE
                     TOLD = T
C        ............EXIT
                     GO TO 450
  230             CONTINUE
C
C                 -- COMPUTE INITIAL STEP SIZE
C                 -- SAVE SIGN OF INTEGRATION DIRECTION
C                 -- SET INDEPENDENT AND DEPENDENT VARIABLES
C                                      X AND YH(*) FOR DSTOD
C
                  LTOL = 1
                  DO 240 L = 1, NEQ
                     IF (ITOL .EQ. 1) LTOL = L
                     TOL = RTOL(LTOL)*ABS(Y(L)) + ATOL(LTOL)
                     IF (TOL .EQ. 0.0D0) GO TO 390
                     EWT(L) = TOL
  240             CONTINUE
C
                  BIG = SQRT(D1MACH(2))
                  CALL DHSTRT(DF,NEQ,T,TOUT,Y,YH(1,2),EWT,1,U,BIG,
     1                        YH(1,3),YH(1,4),YH(1,5),YH(1,6),RPAR,
     2                        IPAR,H)
C
                  DELSGN = SIGN(1.0D0,TOUT-T)
                  X = T
                  DO 250 L = 1, NEQ
                     YH(L,1) = Y(L)
                     YH(L,2) = H*YH(L,2)
  250             CONTINUE
                  INIT = 2
  260          CONTINUE
C
C              ......................................................
C
C                 ON EACH CALL SET INFORMATION WHICH DETERMINES THE
C                 ALLOWED INTERVAL OF INTEGRATION BEFORE RETURNING
C                 WITH AN ANSWER AT TOUT
C
               DEL = TOUT - T
               ABSDEL = ABS(DEL)
C
C              ......................................................
C
C                 IF ALREADY PAST OUTPUT POINT, INTERPOLATE AND
C                 RETURN
C
  270          CONTINUE
C                 BEGIN BLOCK PERMITTING ...EXITS TO 400
C                    BEGIN BLOCK PERMITTING ...EXITS TO 380
                        IF (ABS(X-T) .LT. ABSDEL) GO TO 290
                           CALL DINTYD(TOUT,0,YH,NEQ,Y,INTFLG)
                           CALL DINTYD(TOUT,1,YH,NEQ,YPOUT,INTFLG)
                           IDID = 3
                           IF (X .NE. TOUT) GO TO 280
                              IDID = 2
                              INTOUT = .FALSE.
  280                      CONTINUE
                           T = TOUT
                           TOLD = T
C        ..................EXIT
                           GO TO 450
  290                   CONTINUE
C
C                       IF CANNOT GO PAST TSTOP AND SUFFICIENTLY
C                       CLOSE, EXTRAPOLATE AND RETURN
C
                        IF (ITSTOP .NE. 1) GO TO 310
                        IF (ABS(TSTOP-X) .GE. 100.0D0*U*ABS(X))
     1                     GO TO 310
                           DT = TOUT - X
                           DO 300 L = 1, NEQ
                              Y(L) = YH(L,1) + (DT/H)*YH(L,2)
  300                      CONTINUE
                           CALL DF(TOUT,Y,YPOUT,RPAR,IPAR)
                           NFE = NFE + 1
                           IDID = 3
                           T = TOUT
                           TOLD = T
C        ..................EXIT
                           GO TO 450
  310                   CONTINUE
C
                        IF (IINTEG .EQ. 0 .OR. .NOT.INTOUT) GO TO 320
C
C                          INTERMEDIATE-OUTPUT MODE
C
                           IDID = 1
                        GO TO 370
  320                   CONTINUE
C
C                       .............................................
C
C                            MONITOR NUMBER OF STEPS ATTEMPTED
C
                        IF (KSTEPS .LE. MAXNUM) GO TO 330
C
C                          A SIGNIFICANT AMOUNT OF WORK HAS BEEN
C                          EXPENDED
                           IDID = -1
                           KSTEPS = 0
                           IBEGIN = -1
                        GO TO 370
  330                   CONTINUE
C
C                          ..........................................
C
C                             LIMIT STEP SIZE AND SET WEIGHT VECTOR
C
                           HMIN = 100.0D0*U*ABS(X)
                           HA = MAX(ABS(H),HMIN)
                           IF (ITSTOP .EQ. 1)
     1                        HA = MIN(HA,ABS(TSTOP-X))
                           H = SIGN(HA,H)
                           LTOL = 1
                           DO 340 L = 1, NEQ
                              IF (ITOL .EQ. 1) LTOL = L
                              EWT(L) = RTOL(LTOL)*ABS(YH(L,1))
     1                                 + ATOL(LTOL)
C                    .........EXIT
                              IF (EWT(L) .LE. 0.0D0) GO TO 380
  340                      CONTINUE
                           TOLFAC = U*DVNRMS(NEQ,YH,EWT)
C                 .........EXIT
                           IF (TOLFAC .LE. 1.0D0) GO TO 400
C
C                          TOLERANCES TOO SMALL
                           IDID = -2
                           TOLFAC = 2.0D0*TOLFAC
                           RTOL(1) = TOLFAC*RTOL(1)
                           ATOL(1) = TOLFAC*ATOL(1)
                           IF (ITOL .EQ. 0) GO TO 360
                              DO 350 L = 2, NEQ
                                 RTOL(L) = TOLFAC*RTOL(L)
                                 ATOL(L) = TOLFAC*ATOL(L)
  350                         CONTINUE
  360                      CONTINUE
                           IBEGIN = -1
  370                   CONTINUE
C           ............EXIT
                        GO TO 430
  380                CONTINUE
C
C                    RELATIVE ERROR CRITERION INAPPROPRIATE
  390                CONTINUE
                     IDID = -3
                     IBEGIN = -1
C           .........EXIT
                     GO TO 430
  400             CONTINUE
C
C                 ...................................................
C
C                      TAKE A STEP
C
                  CALL DSTOD(NEQ,Y,YH,NEQ,YH1,EWT,SAVF,ACOR,WM,IWM,
     1                       DF,DJAC,RPAR,IPAR)
C
                  JSTART = -2
                  INTOUT = .TRUE.
               IF (KFLAG .EQ. 0) GO TO 270
C
C              ......................................................
C
               IF (KFLAG .EQ. -1) GO TO 410
C
C                 REPEATED CORRECTOR CONVERGENCE FAILURES
                  IDID = -6
                  IBEGIN = -1
               GO TO 420
  410          CONTINUE
C
C                 REPEATED ERROR TEST FAILURES
                  IDID = -7
                  IBEGIN = -1
  420          CONTINUE
  430       CONTINUE
C
C           .........................................................
C
C                                  STORE VALUES BEFORE RETURNING TO
C                                  DDEBDF
            DO 440 L = 1, NEQ
               Y(L) = YH(L,1)
               YPOUT(L) = YH(L,2)/H
  440       CONTINUE
            T = X
            TOLD = T
            INTOUT = .FALSE.
  450    CONTINUE
  460 CONTINUE
      RETURN
      END
*DECK DLSSUD
      SUBROUTINE DLSSUD (A, X, B, N, M, NRDA, U, NRDU, IFLAG, MLSO,
     +   IRANK, ISCALE, Q, DIAG, KPIVOT, S, DIV, TD, ISFLG, SCALES)
C***BEGIN PROLOGUE  DLSSUD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBVSUP and DSUDS
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LSSUDS-S, DLSSUD-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C    DLSSUD solves the underdetermined system of equations  A Z = B,
C    where A is N by M and N .LE. M.  In particular, if rank A equals
C    IRA, a vector X and a matrix U are determined such that X is the
C    UNIQUE solution of smallest length, satisfying A X = B, and the
C    columns of U form an orthonormal basis for the null space of A,
C    satisfying A U = 0 .  Then all solutions Z are given by
C              Z = X + C(1)*U(1) + ..... + C(M-IRA)*U(M-IRA)
C    where U(J) represents the J-th column of U and the C(J) are
C    arbitrary constants.
C    If the system of equations are not compatible, only the least
C    squares solution of minimal length is computed.
C
C *********************************************************************
C   INPUT
C *********************************************************************
C
C     A -- Contains the matrix of N equations in M unknowns, A remains
C          unchanged, must be dimensioned NRDA by M.
C     X -- Solution array of length at least M.
C     B -- Given constant vector of length N, B remains unchanged.
C     N -- Number of equations, N greater or equal to 1.
C     M -- Number of unknowns, M greater or equal to N.
C     NRDA -- Row dimension of A, NRDA greater or equal to N.
C     U -- Matrix used for solution, must be dimensioned NRDU by
C          (M - rank of A).
C          (storage for U may be ignored when only the minimal length
C           solution X is desired)
C     NRDU -- Row dimension of U, NRDU greater or equal to M.
C             (if only the minimal length solution is wanted,
C              NRDU=0 is acceptable)
C     IFLAG -- Status indicator
C           =0  for the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is treated as exact
C           =-K for the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is assumed to be
C               accurate to about K digits.
C           =1  for subsequent calls whenever the matrix A has already
C               been decomposed (problems with new vectors B but
C               same matrix A can be handled efficiently).
C     MLSO -- =0 if only the minimal length solution is wanted.
C             =1 if the complete solution is wanted, includes the
C                linear space defined by the matrix U.
C     IRANK -- Variable used for the rank of A, set by the code.
C     ISCALE -- Scaling indicator
C               =-1 if the matrix A is to be pre-scaled by
C               columns when appropriate.
C               If the scaling indicator is not equal to -1
C               no scaling will be attempted.
C            For most problems scaling will probably not be necessary.
C     Q -- Matrix used for the transformation, must be dimensioned
C            NRDA by M.
C     DIAG,KPIVOT,S, -- Arrays of length at least N used for internal
C      DIV,TD,SCALES    storage (except for SCALES which is M).
C     ISFLG -- Storage for an internal variable.
C
C *********************************************************************
C   OUTPUT
C *********************************************************************
C
C     IFLAG -- Status indicator
C            =1 if solution was obtained.
C            =2 if improper input is detected.
C            =3 if rank of matrix is less than N.
C               To continue, simply reset IFLAG=1 and call DLSSUD again.
C            =4 if the system of equations appears to be inconsistent.
C               However, the least squares solution of minimal length
C               was obtained.
C     X -- Minimal length least squares solution of A Z = B
C     IRANK -- Numerically determined rank of A, must not be altered
C              on succeeding calls with input values of IFLAG=1.
C     U -- Matrix whose M-IRANK columns are mutually orthogonal unit
C          vectors which span the null space of A. This is to be ignored
C          when MLSO was set to zero or IFLAG=4 on output.
C     Q -- Contains the strictly upper triangular part of the reduced
C           matrix and transformation information.
C     DIAG -- Contains the diagonal elements of the triangular reduced
C             matrix.
C     KPIVOT -- Contains the pivotal information.  The row interchanges
C               performed on the original matrix are recorded here.
C     S -- Contains the solution of the lower triangular system.
C     DIV,TD -- Contains transformation information for rank
C               deficient problems.
C     SCALES -- Contains the column scaling parameters.
C
C *********************************************************************
C
C***SEE ALSO  DBVSUP, DSUDS
C***REFERENCES  H. A. Watts, Solving linear least squares problems
C                 using SODS/SUDS/CODS, Sandia Report SAND77-0683,
C                 Sandia Laboratories, 1977.
C***ROUTINES CALLED  D1MACH, DDOT, DOHTRL, DORTHR, J4SAVE, XERMAX,
C                    XERMSG, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DLSSUD
      INTEGER J4SAVE
      DOUBLE PRECISION DDOT, D1MACH
      INTEGER I, IFLAG, IRANK, IRP, ISCALE, ISFLG, J, JR, K, KP,
     1     KPIVOT(*), L, M, MAXMES, MJ, MLSO, N, NFAT, NFATAL, NMIR,
     2     NRDA, NRDU, NU
      DOUBLE PRECISION A(NRDA,*), B(*), DIAG(*), DIV(*), GAM, GAMMA,
     1     Q(NRDA,*), RES, S(*), SCALES(*), SS, TD(*), U(NRDU,*), URO,
     2     X(*)
C
C     ******************************************************************
C
C          MACHINE PRECISION (COMPUTER UNIT ROUNDOFF VALUE) IS DEFINED
C          BY THE FUNCTION D1MACH.
C
C     ******************************************************************
C
C     BEGIN BLOCK PERMITTING ...EXITS TO 310
C        BEGIN BLOCK PERMITTING ...EXITS TO 80
C***FIRST EXECUTABLE STATEMENT  DLSSUD
            URO = D1MACH(4)
C
            IF (N .LT. 1 .OR. M .LT. N .OR. NRDA .LT. N) GO TO 70
            IF (NRDU .NE. 0 .AND. NRDU .LT. M) GO TO 70
               IF (IFLAG .GT. 0) GO TO 60
C
                  CALL XGETF(NFATAL)
                  MAXMES = J4SAVE(4,0,.FALSE.)
                  ISFLG = -15
                  IF (IFLAG .EQ. 0) GO TO 10
                     ISFLG = IFLAG
                     NFAT = -1
                     IF (NFATAL .EQ. 0) NFAT = 0
                     CALL XSETF(NFAT)
                     CALL XERMAX(1)
   10             CONTINUE
C
C                 COPY MATRIX A INTO MATRIX Q
C
                  DO 30 K = 1, M
                     DO 20 J = 1, N
                        Q(J,K) = A(J,K)
   20                CONTINUE
   30             CONTINUE
C
C                 USE ORTHOGONAL TRANSFORMATIONS TO REDUCE Q TO LOWER
C                 TRIANGULAR FORM
C
                  CALL DORTHR(Q,N,M,NRDA,IFLAG,IRANK,ISCALE,DIAG,KPIVOT,
     1                        SCALES,DIV,TD)
C
                  CALL XSETF(NFATAL)
                  CALL XERMAX(MAXMES)
                  IF (IRANK .EQ. N) GO TO 40
C
C                    FOR RANK DEFICIENT PROBLEMS USE ADDITIONAL
C                    ORTHOGONAL TRANSFORMATIONS TO FURTHER REDUCE Q
C
                     IF (IRANK .NE. 0)
     1                  CALL DOHTRL(Q,N,NRDA,DIAG,IRANK,DIV,TD)
C     ...............EXIT
                     GO TO 310
   40             CONTINUE
C
C                 STORE DIVISORS FOR THE TRIANGULAR SOLUTION
C
                  DO 50 K = 1, N
                     DIV(K) = DIAG(K)
   50             CONTINUE
C        .........EXIT
                  GO TO 80
   60          CONTINUE
C        ......EXIT
               IF (IFLAG .EQ. 1) GO TO 80
   70       CONTINUE
C
C           INVALID INPUT FOR DLSSUD
            IFLAG = 2
            CALL XERMSG ('SLATEC', 'DLSSUD',
     +         'INVALID IMPUT PARAMETERS.', 2, 1)
C     ......EXIT
            GO TO 310
   80    CONTINUE
C
C
         IF (IRANK .GT. 0) GO TO 130
C
C           SPECIAL CASE FOR THE NULL MATRIX
            DO 110 K = 1, M
               X(K) = 0.0D0
               IF (MLSO .EQ. 0) GO TO 100
                  U(K,K) = 1.0D0
                  DO 90 J = 1, M
                     IF (J .NE. K) U(J,K) = 0.0D0
   90             CONTINUE
  100          CONTINUE
  110       CONTINUE
            DO 120 K = 1, N
               IF (B(K) .GT. 0.0D0) IFLAG = 4
  120       CONTINUE
         GO TO 300
  130    CONTINUE
C           BEGIN BLOCK PERMITTING ...EXITS TO 180
C
C              COPY CONSTANT VECTOR INTO S AFTER FIRST INTERCHANGING
C              THE ELEMENTS ACCORDING TO THE PIVOTAL SEQUENCE
C
               DO 140 K = 1, N
                  KP = KPIVOT(K)
                  X(K) = B(KP)
  140          CONTINUE
               DO 150 K = 1, N
                  S(K) = X(K)
  150          CONTINUE
C
               IRP = IRANK + 1
               NU = 1
               IF (MLSO .EQ. 0) NU = 0
C           ...EXIT
               IF (IRANK .EQ. N) GO TO 180
C
C              FOR RANK DEFICIENT PROBLEMS WE MUST APPLY THE
C              ORTHOGONAL TRANSFORMATION TO S
C              WE ALSO CHECK TO SEE IF THE SYSTEM APPEARS TO BE
C              INCONSISTENT
C
               NMIR = N - IRANK
               SS = DDOT(N,S(1),1,S(1),1)
               DO 170 L = 1, IRANK
                  K = IRP - L
                  GAM = ((TD(K)*S(K)) + DDOT(NMIR,Q(IRP,K),1,S(IRP),1))
     1                  /(TD(K)*DIV(K))
                  S(K) = S(K) + GAM*TD(K)
                  DO 160 J = IRP, N
                     S(J) = S(J) + GAM*Q(J,K)
  160             CONTINUE
  170          CONTINUE
               RES = DDOT(NMIR,S(IRP),1,S(IRP),1)
C           ...EXIT
               IF (RES
     1             .LE. SS*(10.0D0*MAX(10.0D0**ISFLG,10.0D0*URO))**2)
     2            GO TO 180
C
C              INCONSISTENT SYSTEM
               IFLAG = 4
               NU = 0
  180       CONTINUE
C
C           APPLY FORWARD SUBSTITUTION TO SOLVE LOWER TRIANGULAR SYSTEM
C
            S(1) = S(1)/DIV(1)
            IF (IRANK .LT. 2) GO TO 200
            DO 190 K = 2, IRANK
               S(K) = (S(K) - DDOT(K-1,Q(K,1),NRDA,S(1),1))/DIV(K)
  190       CONTINUE
  200       CONTINUE
C
C           INITIALIZE X VECTOR AND THEN APPLY ORTHOGONAL TRANSFORMATION
C
            DO 210 K = 1, M
               X(K) = 0.0D0
               IF (K .LE. IRANK) X(K) = S(K)
  210       CONTINUE
C
            DO 230 JR = 1, IRANK
               J = IRP - JR
               MJ = M - J + 1
               GAMMA = DDOT(MJ,Q(J,J),NRDA,X(J),1)/(DIAG(J)*Q(J,J))
               DO 220 K = J, M
                  X(K) = X(K) + GAMMA*Q(J,K)
  220          CONTINUE
  230       CONTINUE
C
C           RESCALE ANSWERS AS DICTATED
C
            DO 240 K = 1, M
               X(K) = X(K)*SCALES(K)
  240       CONTINUE
C
            IF (NU .EQ. 0 .OR. M .EQ. IRANK) GO TO 290
C
C              INITIALIZE U MATRIX AND THEN APPLY ORTHOGONAL
C              TRANSFORMATION
C
               L = M - IRANK
               DO 280 K = 1, L
                  DO 250 I = 1, M
                     U(I,K) = 0.0D0
                     IF (I .EQ. IRANK + K) U(I,K) = 1.0D0
  250             CONTINUE
C
                  DO 270 JR = 1, IRANK
                     J = IRP - JR
                     MJ = M - J + 1
                     GAMMA = DDOT(MJ,Q(J,J),NRDA,U(J,K),1)
     1                       /(DIAG(J)*Q(J,J))
                     DO 260 I = J, M
                        U(I,K) = U(I,K) + GAMMA*Q(J,I)
  260                CONTINUE
  270             CONTINUE
  280          CONTINUE
  290       CONTINUE
  300    CONTINUE
  310 CONTINUE
C
      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_unit_types
  use cubetools_parameters
  use cubetools_unit
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: unit_comm_t,unit_user_t
  private
  !
  type unit_comm_t
     type(unit_arg_t), pointer :: arg
     integer(kind=code_k)      :: code
   contains
     procedure, public :: register => cubetools_unit_comm_register
     procedure, public :: parse    => cubetools_unit_comm_parse
  end type unit_comm_t
  !
contains
  !
  subroutine cubetools_unit_comm_register(comm,name,code,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(unit_comm_t),   intent(inout) :: comm
    character(len=*),     intent(in)    :: name
    integer(kind=code_k), intent(in)    :: code
    logical,              intent(inout) :: error
    !
    type(unit_arg_t) :: unitarg
    character(len=*), parameter :: rname='UNIT>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%code = code
    call unitarg%register(&
         'UNIT',&
         trim(name)//' unit',&
         strg_emp,&
         code_arg_optional,&
         code,&
         comm%arg,&
         error)
    if (error) return
  end subroutine cubetools_unit_comm_register
  !
  subroutine cubetools_unit_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! [unit]
    !----------------------------------------------------------------------
    class(unit_comm_t), intent(in)    :: comm
    character(len=*),   intent(in)    :: line
    type(unit_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
!!$    logical :: do
!!$    character(len=unit_l) :: unitname
    character(len=*), parameter :: rname='UNIT>COMM>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    !***JP: Here is what I would like to do
!!$ call comm%present(line,do,error)
!!$ if (error) return
!!$ if (do) then
!!$    call comm%get(line,unitname,optional,error)
!!$    if (error) return
!!$    call user%unit%get_from_name(unitname,error)
!!$    if (error) return
!!$ else
!!$    call user%unit%get_from_code(comm%code,error)
!!$    if (error) return
!!$ endif
    !***JP: As I don't know how to do this, I return an error for the moment
    call cubesyntax_message(seve%e,rname,'Do not know yet how to parse a unit argument')
    error = .true.
    return
  end subroutine cubetools_unit_comm_parse  
end module cubetools_unit_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gchar_interfaces_public
  interface
    subroutine vstrin(nchar,string,drawit,slengt,xp,yp,angle,ifont,size,  &
      doclip,gpoly_noclip,gpoly_clip)
      use gildas_def
      use phys_const
      use gchar_variables
      !---------------------------------------------------------------------
      ! @ public
      !
      !	Interprets a string of character with escape sequences
      !	\P or \\P  and plots out the characters according to
      !	current font quality SIMPLEX or DUPLEX
      !
      !	If the shareable common is not initialised, VSTRING attempts
      !	to initialise it using VSINIT. Just do not forget to assign
      !	properly the CHAR_FONT logical name to your GREGFONT.BIN file
      !	when you run a non-shareable image.
      !
      !	The reference point is located at the left of the string, and
      !	at middle in height. To append a second string, just move the
      !	reference point as following before calling again VSTRING :
      !		...
      !		CO = COS(ANGLE*PI/180.)
      !		SI = SIN(ANGLE*PI/180.)
      !		CALL VSTRING (..., SLENGT, XP, YP, ANGLE, ...)
      !		XP = XP + CO*SLENGT
      !		YP = YP + SI*SLENGT
      !		CALL VSTRING (..., SLENGT, XP, YP, ANGLE, ...)
      !
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)  :: nchar         ! String length
      character(len=*), intent(in)  :: string        ! String to be drawn
      logical,          intent(in)  :: drawit        ! Draw string or compute length ?
      real(kind=4),     intent(out) :: slengt        ! Length of string in centimeters
      real(kind=4),     intent(in)  :: xp            ! Abscissa of reference point
      real(kind=4),     intent(in)  :: yp            ! Ordinate of reference point
      real(kind=4),     intent(in)  :: angle         ! Angle (Degrees)
      integer(kind=4),  intent(in)  :: ifont         ! Quality 0=Simplex 1=Duplex
      real(kind=4),     intent(in)  :: size          ! Character size
      logical,          intent(in)  :: doclip        ! Clip with current Greg box?
      external                      :: gpoly_noclip  !
      external                      :: gpoly_clip    !
      interface
        subroutine gpoly_noclip(n,vx,vy,error)
          integer, intent(in)    :: n      ! Number of points
          real*4,  intent(in)    :: vx(n)  ! Array of abscissae
          real*4,  intent(in)    :: vy(n)  ! Array of ordinates
          logical, intent(inout) :: error  ! Logical error flag
        end subroutine gpoly_noclip
        subroutine gpoly_clip(nq,xq,yq)
          use gildas_def
          integer(kind=size_length), intent(in) :: nq     ! Number of points
          real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
          real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
        end subroutine gpoly_clip
      end interface
    end subroutine vstrin
  end interface
  !
  interface
    subroutine gchar_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gchar_message_set_id
  end interface
  !
  interface
    subroutine hershey2gag(file)
      use gchar_variables
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Build of the GREG character set from the HERSHEY one
      !
      ! Organisation :
      !	2 Quality of characters
      !		1 FAST		2 DUPLEX
      !	3 Set of characters per quality
      !		1 ROMAN		2 GREEK		3 SCRIPT
      ! 	95 Characters per set
      !
      ! Addressing is based on the ASCII code of the character:
      ! INDEX = ICHAR(caractere) - ICHAR(' ') + 1 + 100*(NJEU-1) + 300*(NQUAL-1)
      !---------------------------------------------------------------------
      character(len=*) :: file          !
    end subroutine hershey2gag
  end interface
  !
end module gchar_interfaces_public

subroutine write_fits_passband(unit, nsubant, subant, error)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Write the optional passband calibration fits table.
  ! assumes NO_POL=1
  !---------------------------------------------------------------------
  integer :: unit                   !
  integer :: nsubant                !
  integer :: subant(nsubant)        ! selected antennas in table
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: naxis, naxes(4), mf, status, nrows, tfields, varidat
  integer :: i, j, r_npol, r_nfeed, r_nside, mdigit2, mdigit1, isub
  parameter(r_npol = 1, r_nfeed = 1, r_nside=2, mdigit2=13,   &
    mdigit1=8)
  parameter (mf = 4)
  character(len=16) :: ttype(mf),tform(mf),tunit(mf), extname
  data ttype/'ANTENNID',   'AMPLPASS',   'PHASPASS', 'SBAVERAG'/
  data tform/'1J',         '*E',         '*E',       '*E'/
  data tunit/' ',          'K/Jy',       'radian',        ' '/
  !---------------------------------------------------------------------
  !
  !  Append/create a new empty HDU onto the end of the file and move to it.
  status = 0
  call ftcrhd(unit,status)
  if (status .gt. 0) goto 99
  !
  !  Define parameters for the binary table (see the above data statements)
  nrows = r_nant
  tfields = mf
  extname = 'PASSBAND-ALMATI'
  varidat = 0
  ! columns in datapar
  do i = 2, 3
    call f_tform(tform(i),r_nside*(r_abpfdeg+1),'E')
  enddo
  call f_tform(tform(4),2*2,'E')
  call ftphbn(unit,nrows,tfields,ttype,tform,tunit,   &
    extname,varidat,status)
  if (status .gt. 0) goto 99
  do i=2, 3
    naxis = 2
    naxes(1) = r_nside
    naxes(2) = r_abpfdeg+1
    call ftptdm(unit, i, naxis, naxes, status)
  enddo
  naxes(1) = 2
  naxes(2) = r_nside
  call ftptdm(unit, 4, naxis, naxes, status)
  ! Other header keywords
  call ftpkys(unit,'TABLEREV','v1.0 2001-07-03',   &
    extname//' release',status)
  if (status .gt. 0) goto 99
  !      CALL FTPKYJ(UNIT,'NO_ANT',R_NANT,'Number of Antennas',STATUS)
  call ftpkyj(unit,'NO_ANT',nsubant,'Number of Antennas',status)
  if (status .gt. 0) goto 99
  call write_fits_dobs(unit,error)
  if (error) return
  call ftpkyj(unit,'NO_SIDE',r_nside,'Number of side bands',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'PASSDEGR',r_abpfdeg,'Degree of polynomial',   &
    status)
  if (status .gt. 0) goto 99
  call ftpkye(unit,'IFREQMIN',r_abpflim(1,1)*1e6,mdigit1,   &
    'Minimum IF (Hz)', status)
  call ftpkye(unit,'IFREQMAX',r_abpflim(1,2)*1e6,mdigit1,   &
    'Maximum IF (Hz)', status)
  if (status .gt. 0) goto 99
  !
  status = 0
  !
  ! Fill in the columns.
  !
  !      DO I=1, R_NANT
  do isub =1, nsubant
    i = subant(isub)
    ! ANNAME
    call ftpclj(unit,1,i,1,1,r_kant(i),status)
    if (status .gt. 0) goto 99
    ! AMPLPASS
    do j=0, r_abpfdeg
      call ftpcle(unit,2,i,1+2*j,2,r_abpfamp(1,1,i,j),status)
      if (status .gt. 0) goto 99
    enddo
    ! PHASPASS
    do j=0, r_abpfdeg
      call ftpcle(unit,3,i,1+2*j,2,r_abpfpha(1,1,i,j),status)
      if (status .gt. 0) goto 99
    enddo
    ! SBAVERAG (complex, usb/lsb)
    call ftpcle(unit,4,i,1,4,r_abpcsba(1,1,i),status)
    if (status .gt. 0) goto 99
  enddo
  r_abpc = 1
  return
  !
99 call printerror('WRITE_FITS_PASSBAND', status)
  error = .true.
end subroutine write_fits_passband

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_obstype_equal(filename,imbf,obstype,equal,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_obstype_equal
  !---------------------------------------------------------------------
  ! @ private
  ! Read the bare minimum as reading all the main hdus may take forever
  ! on large imbfitsfile.
  ! This could be a generic subroutine imbfits_equal. *** JP
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: filename
  type(imbfits_t),  intent(inout) :: imbf
  character(len=*), intent(in)    :: obstype
  logical,          intent(out)   :: equal
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='OBSTYPE>EQUAL'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  call imbfits_reopen_file(filename,imbf%file,imbf%hdus,error)
  if (error) return
  call imbfits_read_header_primary(imbf%file,imbf%primary,error)
  if (error)  return
  if (imbf%primary%obstype%val.ne.'calibrate') then
     call imbfits_message(seve%w,rname,trim(imbf%primary%obstype%val)//' is not a calibration scan')
     equal = .false.
  else
     equal = .true.
  endif
  !
end subroutine imbfits_obstype_equal
!
subroutine imbfits_check_version(version,error)
  use gbl_message
  use imbfits_parameters
  use imbfits_interfaces, except_this => imbfits_check_version
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: version
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>CHECK>VERSION'
  character(len=message_length) :: mess
  !
  if (version.lt.imbfits_version_min .or.  &
      version.ge.imbfits_version_max) then
    write(mess,'(A,F4.2,A)')  &
      'Version ',version,' of IMBFITS is not supported'
    call imbfits_message(seve%e,rname,mess)
    write(mess,'(A,F4.2,A,F4.2,A)')  &
      'Support starts at ',imbfits_version_min,  &
      ', up to ',imbfits_version_max,' (excluded)'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
end subroutine imbfits_check_version
!
subroutine imbfits_check_header_primary(file,primary,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_check_header_primary
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_file_t),    intent(in)    :: file
  type(imbfits_primary_t), intent(in)    :: primary
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHECK>HEADER>PRIMARY'
  character(len=message_length) :: mess
  !
! Computing NHDU with FTTHDU is highly unefficient => not available.
!   if (primary%n_obsp%val*3.ne.(file%nhdu-hdustart)) then
!     ! 3 extensions per subscan: backend, antenna, subreflector
!     ! Warning only?
!     write(mess,'(A,I0,A,I0)')  &
!       'File is inconsistent: found ',file%nhdu,  &
!       ' HDUs, expected ',hdustart+primary%n_obsp%val*3
!     call imbfits_message(seve%e,rname,mess)
!     error = .true.
!     return
!   endif
  !
  if (primary%n_obs%val.ne.primary%n_obsp%val) then
    ! Warning only
    write (mess,'(A,I0,A,I0,A)')  &
      'File is incomplete (',primary%n_obsp%val,'/',  &
      primary%n_obs%val,' subscans)'
    call imbfits_message(seve%w,rname,mess)
  endif
  !
end subroutine imbfits_check_header_primary
!
subroutine imbfits_check_header_scan(primary,scan,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_check_header_scan
  !---------------------------------------------------------------------
  ! @ private
  ! Check the consistency of the IMBF-scan HDU
  !---------------------------------------------------------------------
  type(imbfits_primary_t), intent(in)    :: primary
  type(imbfits_scan_t),    intent(in)    :: scan
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHECK>HEADER>SCAN'
  !
  ! Nothing relevant to be tested.
  !
end subroutine imbfits_check_header_scan
!
subroutine imbfits_check_header_backend(back,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_check_header_backend
  !---------------------------------------------------------------------
  ! @ private
  ! Check the consistency of the IMBF-backend HDU
  ! *** JP Nothing done right now because previous test was too much
  !        restrictive. It is unclear whether this function is needed.
  !        Leave it for the time being.
  !---------------------------------------------------------------------
  type(imbfits_back_t), intent(in)    :: back
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHECK>HEADER>BACKEND'
  !
end subroutine imbfits_check_header_backend
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine editor (file,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>editor
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Edit a file using one of the following editors
  !       - VI
  !       - EMACS
  !  according to SIC EDITOR TT_EDIT variable, or GAG logical name
  !  GAG_EDIT.
  !---------------------------------------------------------------------
  character(len=*) :: file          ! File to be edited
  logical :: error                  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='EDIT'
  character(len=filename_length) :: chain
  integer :: nl,nk,ier
  !
  error = .false.
  !
  if (tt_edit.eq."") then
    call sic_message(seve%e,rname,'No editor defined')
    error = .true.
    return
  endif
  !
  call sic_message(seve%i,rname,'Using "'//trim(tt_edit)//'" editor')
  nl = len_trim(tt_edit)
  nk = len_trim(file)
  if (tt_edit(nl:nl).eq.'&') then
    chain = tt_edit(1:nl-1)//' '//file(1:nk)//' &'
    nl = nl+nk+3
  else
    chain = tt_edit(1:nl)//' '//file(1:nk)
    nl = nl+nk+2
  endif
  if (nl.gt.filename_length) then
    call sic_message(seve%e,rname,'Filename too long')
    error = .true.
    return
  endif
  ier = gag_system(chain)
  error = ier.ne.0
  !
end subroutine editor

subroutine fits_gildas_sub(iname,oname,style,blc,trc,khdu,check,overwrite,error,  &
  getsymbol,wpr)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fits_gildas_sub
  use gio_params
  use gio_xy
  use gio_fitsdef
  use gbl_message
  !--------------------------------------------------------------------
  ! @ public
  ! GIO FITS interface
  ! Convert a FITS file to a GDF file
  !--------------------------------------------------------------------
  character(len=*),           intent(in)    :: iname      ! Input FITS file
  character(len=*),           intent(in)    :: oname      ! Output GILDAS file
  character(len=*),           intent(in)    :: style      ! FITS style
  integer(kind=index_length), intent(in)    :: blc(:)     ! Bottom Left Corner
  integer(kind=index_length), intent(in)    :: trc(:)     ! Top Right Corner
  integer(kind=4),            intent(in)    :: khdu       ! HDU number (1=Primary)
  logical,                    intent(in)    :: check      ! Echo keywords ?
  logical,                    intent(in)    :: overwrite  ! Overwrite existing output file?
  logical,                    intent(inout) :: error      ! Returned error code
  external                                  :: getsymbol  ! Translate FITS keyword
  external                                  :: wpr        ! Ask a question if unknown
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=filename_length) :: name
  logical :: end_of_tape,err
  integer, parameter :: mstyle=5
  character(len=16) :: styles(mstyle),comm
  integer(kind=4) :: ncom,pcount,a_stoke,nc
  ! Data
  data styles /'STANDARD','UVFITS','AIPSFITS','SORTED_AIPSFITS','CASA_UVFITS'/
  !
  call gag_notanum(fd%bval0)
  question = .false.
  gdfname = oname
  name = iname
  !
  ! Open FITS file, including basic sanity checks
  call gfits_open(name,'IN',error)
  if (error)  return
  call gfits_goto_hdu(fd,khdu,error)
  if (error)  goto 10
  !
  ! Try to read a cube or a UV FITS?
  if (style.eq.' ') then
    call fits2gdf_guess_style(a_style,error)
    if (error)  goto 10
  else
    call sic_ambigs('STYLE',style,comm,ncom,styles,mstyle,error)
    if (error)  goto 10
    a_style = ncom-1
  endif
  !
  if (a_style.lt.code_fits_uvfits) then  ! "Normal" FITS
    call gildas_null(fits)
    !
    call fitscube2gdf_header(name,khdu,fd,fits,getsymbol,error)
    if (error) then
      call gio_message(seve%e,rname,'Error reading header in file '//name)
      goto 10
    endif
    call sic_parse_file(oname,' ','.gdf',fits%file)
    nc = len_trim(fits%file)
    !
    if (overwrite .and. gag_inquire(fits%file,nc).eq.0)  &
      call gag_filrm(fits%file(1:nc))
    !
    if (any(blc.ne.0) .or. any(trc.ne.0)) then
      ! Subset only
      call read_sub(fits,error,end_of_tape,blc,trc)
    else
      ! Full data
      call read_all(fits,error,end_of_tape)
    endif
    !
  else  ! UV FITS family
    call touvt(fits,a_style,question,check,error,pcount,getsymbol)
    if (error) then
      call gio_message(seve%e,rname,'Error reading UVFITS header')
      call gfits_close(err)
      return
    endif
    if (a_style.eq.code_fits_casa) then
      a_stoke = 0   ! Get all Stokes parameters
    else
      a_stoke = 1   ! Only get unpolarized signal
    endif
    call read_uvfits(fits,a_stoke,error,end_of_tape,pcount)
    if (error) then
      call gio_message(seve%e,rname,'Error reading UVFITS data')
      goto 10
    endif
    !
  endif
  !
10 continue
  call gfits_close(error)
  !
end subroutine fits_gildas_sub

!-----------------------------------------------------------------------
! Support file adding Associated Arrays hooks to Class commands
!-----------------------------------------------------------------------
subroutine extract_assoc(assoc,extr,error)
  use gbl_message
  use classcore_interfaces, except_this=>extract_assoc
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Extract a subset of each Associated Array. Extraction is made
  ! inplace
  !---------------------------------------------------------------------
  type(class_assoc_t), intent(inout) :: assoc
  type(extract_t),     intent(in)    :: extr   ! Extraction descriptor
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='EXTRACT>ASSOC'
  integer(kind=4) :: iarray
  type(class_assoc_t) :: old
  !
  if (assoc%n.le.0)  return  ! Nothing to be done
  !
  ! Save the current arrays in the 'old' structure. For efficiency purpose
  ! allocation status is stolen to the input arrays.
  call reassociate_assoc(assoc,old,.true.,error)
  if (error)  return
  !
  do iarray=1,assoc%n
    assoc%array(iarray)%dim1 = extr%nc  ! New size of array
    call reallocate_assoc_sub(assoc%array(iarray),error)
    if (error)  exit
    !
    select case (assoc%array(iarray)%fmt)
    case (fmt_r4)
      call do_extract_data(old%array(iarray)%r4(:,1),old%array(iarray)%dim1,      &
                           assoc%array(iarray)%r4(:,1),assoc%array(iarray)%dim1,  &
                           assoc%array(iarray)%badr4,                             &
                           extr,error)
    case (fmt_i4,fmt_by,fmt_b2)
      call do_extract_data(old%array(iarray)%i4(:,1),old%array(iarray)%dim1,      &
                           assoc%array(iarray)%i4(:,1),assoc%array(iarray)%dim1,  &
                           assoc%array(iarray)%badi4,                             &
                           extr,error)
    case default
      call class_message(seve%e,rname,'Kind of data not implemented')
      error = .true.
    end select
    if (error)  exit
  enddo
  !
  call deallocate_assoc(old,error)
  !
end subroutine extract_assoc
!
subroutine smooth_assoc(assoc,skind,width,space,ushift,nx,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>smooth_assoc
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Smooth the associated array section
  !---------------------------------------------------------------------
  type(class_assoc_t), intent(inout) :: assoc   !
  character(len=*),    intent(in)    :: skind   ! SMOOTH kind
  real(kind=4),        intent(in)    :: width   ! Width (SMOOTH GAUSS|HANN)
  real(kind=4),        intent(in)    :: space   ! Channel space (SMOOTH HANN)
  real(kind=4),        intent(in)    :: ushift  ! User shift (SMOOTH HANN)
  integer(kind=4),     intent(in)    :: nx      ! Nchan per box (SMOOTH BOX)
  logical,             intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SMOOTH'
  integer(kind=4) :: iarray,dim1,ier
  real(kind=4) :: cbad
  real(kind=4), allocatable :: y1(:),y2(:)
  !
  if (assoc%n.le.0)  return  ! Nothing to be done
  !
  if (skind.eq.'NOISE') then
    call class_message(seve%w,rname,'NOISE smoothing skipped for Associated Arrays')
    return
  endif
  !
  dim1 = assoc%array(1)%dim1
  allocate(y1(dim1),y2(dim1),stat=ier)
  if (failed_allocate(rname,'y values workspace',ier,error))  return
  !
  do iarray=1,assoc%n
    call copy_assoc_sub_aator4(rname,assoc%array(iarray),y1,cbad,error)
    if (error)  exit
    !
    ! Do the job
    dim1 = assoc%array(iarray)%dim1
    select case (skind)
    case ('HANNING')
      call smhann(y1,y2,dim1,cbad,width,space,ushift,error)
    case ('GAUSS')
      call smgauss(y1,y2,dim1,cbad,width,error)
    case ('BOX')
      call smbox(y1,y2,dim1,cbad,nx,error)
    case default
      call class_message(seve%e,rname,  &
        'Smoothing kind '//trim(skind)//' not supported for Associated Arrays')
      error = .true.
    end select
    if (error)  exit
    !
    ! NB: dim1 has been updated in return
    call copy_assoc_sub_r4toaa(rname,assoc%array(iarray),y2(1:dim1),cbad,error)
    if (error)  exit
  enddo
  !
  deallocate(y1,y2)
  !
end subroutine smooth_assoc
!
subroutine resample_assoc(set,assoc,idatax,isirreg,old,new,dofft,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>resample_assoc
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for resampling Associated Arrays
  !---------------------------------------------------------------------
  type(class_setup_t),   intent(in)    :: set        !
  type(class_assoc_t),   intent(inout) :: assoc      !
  real(kind=xdata_kind), intent(in)    :: idatax(:)  ! Size old%nchan
  logical,               intent(inout) :: isirreg    !
  type(resampling),      intent(in)    :: old        ! Old X-axis sampling
  type(resampling),      intent(inout) :: new        ! New X-axis sampling
  logical,               intent(in)    :: dofft      ! In frequency or time domain
  logical,               intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='RESAMPLE>ASSOC'
  real(kind=4), allocatable :: idatay(:),odatay(:),odataw(:)
  integer(kind=4) :: ier,iarray
  real(kind=4) :: cbad
  logical :: isirreg2
  !
  if (assoc%n.le.0)  return  ! Nothing to be done
  !
  allocate(idatay(old%nchan),odatay(new%nchan),odataw(new%nchan),stat=ier)
  if (failed_allocate(rname,'y and w value workspace',ier,error))  return
  !
  do iarray=1,assoc%n
    call copy_assoc_sub_aator4(rname,assoc%array(iarray),idatay,cbad,error)
    if (error)  return
    !
    isirreg2 = isirreg  ! Always restart with correct irregular status
    call do_resample_generic(set,idatax,idatay,odatay,odataw,cbad,isirreg2,  &
      old,new,dofft,error)
    if (error)  return
    !
    call copy_assoc_sub_r4toaa(rname,assoc%array(iarray),odatay,cbad,error)
    if (error)  return
  enddo
  !
  ! Finally set irregular status
  isirreg = isirreg2
  !
  deallocate(idatay,odatay,odataw)
  !
end subroutine resample_assoc
!
subroutine resample_interpolate_regul_assoc(set,rname,in,idataw,iaxis,  &
  out,odataw,oaxis,error)
  use gbl_message
  use classcore_interfaces, except_this=>resample_interpolate_regul_assoc
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for resampling Associated Arrays in the context
  ! of AVERAGE
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set        !
  character(len=*),    intent(in)    :: rname      ! Calling routine name
  type(class_assoc_t), intent(in)    :: in         !
  real(kind=4),        intent(in)    :: idataw(:)  !
  type(resampling),    intent(in)    :: iaxis      !
  type(class_assoc_t), intent(inout) :: out        !
  real(kind=4),        intent(out)   :: odataw(:)  !
  type(resampling),    intent(in)    :: oaxis      !
  logical,             intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4) :: iarray,ismin,ismax
  real(kind=4) :: ibad
  real(kind=4), allocatable :: idatay(:)
  !
  if (in%n.le.0)  return  ! Nothing to be done
  !
  allocate(idatay(iaxis%nchan))
  !
  do iarray=1,in%n
    !
    ! In the context of AVERAGE, we should skip the W array!
    if (in%array(iarray)%name.eq.'W')  cycle
    !
    call copy_assoc_sub_aator4(rname,in%array(iarray),idatay,ibad,error)
    if (error)  return
    !
    ! We ensured that the output (resampled) arrays are R*4. Sanity check:
    if (out%array(iarray)%fmt.ne.fmt_r4) then
      call class_message(seve%e,rname,'Programming error: Associated Array should be R*4')
      error = .true.
      return
    endif
    !
    call resample_interpolate_regul(set,                               &
      idatay,                   idataw,ibad,                   iaxis,  &
      out%array(iarray)%r4(:,1),odataw,out%array(iarray)%badr4,oaxis,  &
      ismin,ismax,error)
    !
  enddo
  !
  deallocate(idatay)
  !
end subroutine resample_interpolate_regul_assoc
!
subroutine waverage_assoc(rname,one,rdataw,sumio,sdataw,schanmin,schanmax,  &
  contaminate,error)
  use gbl_message
  use classcore_interfaces, except_this=>waverage_assoc
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for averaging Associated Arrays
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: rname        ! Calling routine name
  type(class_assoc_t), intent(in)    :: one          ! Section to be added to the running sum
  real(kind=4),        intent(in)    :: rdataw(:)    ! Weight of input arrays (all the same)
  type(class_assoc_t), intent(inout) :: sumio        ! Running sum
  real(kind=4),        intent(inout) :: sdataw(:)    ! Weight of the running sum (input only, not updated here)
  integer(kind=4),     intent(in)    :: schanmin     ! First channel
  integer(kind=4),     intent(in)    :: schanmax     ! Last channel
  logical,             intent(in)    :: contaminate  ! Bad channels contaminate output or not?
  logical,             intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=4) :: nchan,iarray
  real(kind=4), allocatable :: rdatay(:)
  real(kind=4) :: rbad
  !
  if (sumio%n.le.0)  return  ! Nothing to be done
  !
  !---------------------------------------------------------------------
  ! This consistency check is here (i.e. during data processing) for
  ! now, but it should go in the consistency tools (i.e. during header
  ! processing) as soon as they support the Associated Arrays.
  if (one%n.ne.sumio%n) then
    call class_message(seve%e,rname,  &
      'Inconsistent Associated Arrays (not same number of arrays)')
    error = .true.
    return
  endif
  do iarray=1,sumio%n
    ! Compare names, knowing that:
    ! 1) 'one' may be the original arrays (original format with
    !    original names) or a resampled version (R*4 with T prefixed).
    ! 2) 'sumio' contains R*4 version with names prefixed with T.
    ! This issue will be resolved when only the original versions
    ! will be checked for consistency.
    if (one%array(iarray)%name.ne.sumio%array(iarray)%name .and.  &
        one%array(iarray)%name.ne.sumio%array(iarray)%name(2:)) then
      call class_message(seve%e,rname,  &
        'Inconsistent Associated Arrays (name or order differ)')
      error = .true.
      return
    endif
  enddo
  !---------------------------------------------------------------------
  !
  nchan = sumio%array(1)%dim1
  allocate(rdatay(nchan))
  !
  do iarray=1,sumio%n
    ! Convert arrays to R*4
    call copy_assoc_sub_aator4(rname,one%array(iarray),rdatay,rbad,error)
    if (error)  return
    !
    ! - Add rdatay to sumio. Note that we ensured that ALL the AA of sumio
    !   are R*4
    ! - Do not update sdataw in-place, this will be done when dealing with
    !   RY.
    call simple_waverage(rdatay,                     rdataw,rbad,                       &
                         sumio%array(iarray)%r4(:,1),sdataw,sumio%array(iarray)%badr4,  &
                         schanmin,schanmax,contaminate,.false.)
    !
  enddo
  !
  deallocate(rdatay)
  !
end subroutine waverage_assoc
!
subroutine wrms_assoc(rname,one,odataw,aver,adataw,rms,rdataw,  &
  chanmin,chanmax,contaminate,error)
  use classcore_interfaces, except_this=>wrms_assoc
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for weighted-rms of Associated Arrays
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: rname        ! Calling routine name
  type(class_assoc_t), intent(in)    :: one          ! Section to be added to the running RMS
  real(kind=4),        intent(in)    :: odataw(:)    ! Weight of input arrays (all arrays have the same)
  type(class_assoc_t), intent(in)    :: aver         ! Average of all sections
  real(kind=4),        intent(in)    :: adataw(:)    ! Weight of the average (all arrays have the same)
  type(class_assoc_t), intent(inout) :: rms          ! Running RMS
  real(kind=4),        intent(inout) :: rdataw(:)    ! Weight of the running RMS (input only, not updated here)
  integer(kind=4),     intent(in)    :: chanmin      ! First channel
  integer(kind=4),     intent(in)    :: chanmax      ! Last channel
  logical,             intent(in)    :: contaminate  ! Bad channels contaminate output or not?
  logical,             intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=4) :: iarray
  real(kind=4), allocatable :: odatay(:)
  real(kind=4) :: obad
  !
  if (rms%n.le.0)  return  ! Nothing to be done
  !
  allocate(odatay(rms%array(1)%dim1))
  !
  do iarray=1,rms%n
    ! Convert arrays to R*4
    call copy_assoc_sub_aator4(rname,one%array(iarray),odatay,obad,error)
    if (error)  return
    !
    ! Add rdatay to sdatay, do not update sdataw in-place, this will
    ! be done when dealing with RY.
    call simple_wrms(  &
      odatay,                    odataw,obad,                      &  ! One obs to be added
      aver%array(iarray)%r4(:,1),adataw,aver%array(iarray)%badr4,  &  ! Average of all obs
      rms%array(iarray)%r4(:,1), rdataw,rms%array(iarray)%badr4,   &  ! Current RMS, updated
      chanmin,chanmax,contaminate,.false.)
  enddo
  !
  deallocate(odatay)
  !
end subroutine wrms_assoc
!
subroutine fold_assoc(set,assoc,nphase,throw,weight,omin,omax,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fold_assoc
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for folding Associated Arrays
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set             !
  type(class_assoc_t), intent(inout) :: assoc           !
  integer(kind=4),     intent(in)    :: nphase          !
  real(kind=4),        intent(in)    :: throw(nphase)   ! [chan]
  real(kind=4),        intent(in)    :: weight(nphase)  !
  integer(kind=4),     intent(in)    :: omin            !
  integer(kind=4),     intent(in)    :: omax            !
  logical,             intent(inout) :: error           !
  ! Local
  character(len=*), parameter :: rname='FOLD>ASSOC'
  integer(kind=4) :: inchan,onchan,ier,iarray,omin2,omax2,shift
  real(kind=4) :: cbad
  real(kind=4), allocatable :: idatay(:),odatay(:),odataw(:)
  !
  if (assoc%n.le.0)  return  ! Nothing to be done
  !
  inchan = assoc%array(1)%dim1
  onchan = 2*inchan+1
  allocate(idatay(inchan),odatay(onchan),odataw(onchan),stat=ier)
  if (failed_allocate(rname,'y and w value workspace',ier,error))  return
  !
  do iarray=1,assoc%n
    call copy_assoc_sub_aator4(rname,assoc%array(iarray),idatay,cbad,error)
    if (error)  return
    !
    ! NB: keepblank forced to .true., but anyway extracted part will be the
    ! same as RY (see comments below)
    call classcore_fold_obs_sub(set,idatay,idatay,inchan,cbad,  &
                                nphase,throw(:),weight(:),      &
                               .true.,                         &
                               odatay,odataw,onchan,           &
                               omin2,omax2,shift,              &
                               error)
    if (error)  return
    !
    ! We use omin:omax (i.e. the range returned from the RY folding) and not
    ! omin2:omax2 (i.e. the range returned from the current array folding)
    ! because this range depends on the data contents (in particular in terms
    ! of blank values). But we have to ensure that the folded RY and the folded
    ! arrays cover the same channels, we have to be consistent.
    !
    call copy_assoc_sub_r4toaa(rname,assoc%array(iarray),odatay(omin:omax),cbad,error)
    if (error)  return
  enddo
  !
  deallocate(idatay,odatay,odataw)
  !
end subroutine fold_assoc
!
subroutine rzero_assoc(obs)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Reset the Associated Arrays section to default value
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs  !
  !
  obs%assoc%n = 0
  !
  !  Do not deallocate obs%assoc%array nor obs%assoc%array(:)%r4: we keep
  ! them allocated for later reuse.
  !
end subroutine rzero_assoc
!
subroutine newdat_assoc(set,obs,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>newdat_assoc
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Recompute the Associated Section related data, typically when a new
  ! observation is loaded. Code is optimized to avoid deleting or
  ! defining the Sic variables if there is no need.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='NEWDAT>ASSOC'
  integer(kind=4) :: iarray,ndim
  integer(kind=index_length) :: dims(sic_maxdims)
  logical :: delete_all,define_all,readonly,delete_one,define_one
  character(len=*), parameter :: parent='R%ASSOC'
  character(len=varname_length) :: strname,varname,badname
  type(class_assoc_t) :: R_assoc
  logical :: got_assoc,ro_assoc
  ! Saved status
  save :: got_assoc,R_assoc,ro_assoc
  ! Data
  data got_assoc /.false./
  !
  if (.not.obs%is_R)  return
  !
  readonly = set%varpresec(class_sec_assoc_id).ne.setvar_write
  !
  delete_all = got_assoc .and. (  &
               (R_assoc%n.gt.0 .and. R_assoc%n.ne.obs%assoc%n)  & ! Was defined but is resized
               .or.  &
               (ro_assoc.neqv.readonly)  &  ! RO status is changing: delete everything
               )
  if (delete_all) then
    ! Easy, no waste of time with sic_varexist
    define_all = .true.
  else
    define_all = .not.sic_varexist(parent)
  endif
  !
  if (delete_all) then
    call sic_delvariable(parent,.false.,error)
    if (error)  error = .false.  ! No error if not found
  endif
  !
  if (obs%assoc%n.eq.0) then
    ! No Associated Array to create. Save current for next calls and leave.
    call get_assoc(error)
    return
  endif
  !
  if (define_all) then
    call sic_defstructure(parent,.true.,error)
    if (error)  return
  endif
  !
  do iarray=1,obs%assoc%n
    !
    ! On which condition those elements should be redefined?
    if (delete_all) then
      delete_one = .false.
      define_one = .true.
    elseif (.not.got_assoc) then
      delete_one = .false.  ! First entering in this subroutine
      define_one = .true.
    elseif (iarray.gt.R_assoc%n) then
      delete_one = .false.  ! No such array to delete
      define_one = .true.
    elseif (R_assoc%array(iarray)%name .ne. obs%assoc%array(iarray)%name .or.  &
            R_assoc%array(iarray)%dim1 .ne. obs%assoc%array(iarray)%dim1 .or.  &
            R_assoc%array(iarray)%dim2 .ne. obs%assoc%array(iarray)%dim2) then
      delete_one = .true.
      define_one = .true.
    else
      select case (obs%assoc%array(iarray)%fmt)
      case (fmt_r4)
        define_one = .not.associated(R_assoc%array(iarray)%r4,obs%assoc%array(iarray)%r4)
      case (fmt_by,fmt_i4)
        define_one = .not.associated(R_assoc%array(iarray)%i4,obs%assoc%array(iarray)%i4)
      case default
        define_one = .false.
      end select
      delete_one = define_one
    endif
    !
    if (delete_one) then
      strname = parent//'%'//R_assoc%array(iarray)%name
      call sic_delvariable(strname,.false.,error)
      if (error)  error = .false.  ! No error if not found, but should not happen
    endif
    !
    if (define_one) then
      ! Parent structure
      strname = parent//'%'//obs%assoc%array(iarray)%name
      call sic_defstructure(strname,.true.,error)
      if (error)  return
      !
      ! Dimensions: always read-only
      varname = trim(strname)//'%DIM2'
      call sic_def_inte(varname,obs%assoc%array(iarray)%dim2,0,0,.true.,error)
      if (error)  return
      !
      ! Unit
      varname = trim(strname)//'%UNIT'
      call sic_def_char(varname,obs%assoc%array(iarray)%unit,readonly,error)
      if (error)  return
      !
      ! Data: always RW (same as RY)
      badname = trim(strname)//'%BAD'
      varname = trim(strname)//'%DATA'
      dims(1) = obs%assoc%array(iarray)%dim1
      dims(2) = obs%assoc%array(iarray)%dim2
      if (dims(2).gt.0) then
        ndim = 2
      else
        ndim = 1
      endif
      !
      select case (obs%assoc%array(iarray)%fmt)
      case (fmt_r4)
        call sic_def_real(badname,obs%assoc%array(iarray)%badr4,0,0,   readonly,error)
        call sic_def_real(varname,obs%assoc%array(iarray)%r4,ndim,dims,.false., error)
      case (fmt_i4,fmt_by,fmt_b2)
        call sic_def_inte(badname,obs%assoc%array(iarray)%badi4,0,0,   readonly,error)
        call sic_def_inte(varname,obs%assoc%array(iarray)%i4,ndim,dims,.false., error)
      case default
        call class_message(seve%e,rname,'Kind of data is not implemented')
        error = .true.
      end select
      if (error)  return
    endif
    !
  enddo
  !
  call get_assoc(error)  ! For next calls
  ro_assoc = readonly
  !
contains
  subroutine get_assoc(error)
    logical, intent(inout) :: error
    integer(kind=4) :: iarray
    call reallocate_assoc(R_assoc,obs%assoc%n,.false.,error)
    if (error)  return
    do iarray=1,R_assoc%n
      call reassociate_assoc_sub(obs%assoc%array(iarray),R_assoc%array(iarray),.false.,error)
      if (error)  return
    enddo
    got_assoc = .true.
  end subroutine get_assoc
  !
end subroutine newdat_assoc
!
subroutine class_assoc_dump(obs,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_assoc_dump
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Dump all the Associated Arrays from the input observation
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs    ! Observation
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ASSOC>DUMP'
  integer(kind=4) :: iarray,dim1,dim2
  character(len=message_length) :: mess
  character(len=80) :: badstring,datastring
  !
  if (obs%assoc%n.eq.0) then
    call class_message(seve%w,rname,'Observation has no Associated Array')
    return
  endif
  !
  write(mess,'(2X,A,1X,I0)') 'Number of associated arrays:',obs%assoc%n
  call class_message(seve%r,rname,mess)
  !
  do iarray=1,obs%assoc%n
    write(mess,'(2X,A,I0,A,A)')          &
      'Associated array #',iarray,': ',obs%assoc%array(iarray)%name
    call class_message(seve%r,rname,mess)
    !
    ! Format specific:
    dim1 = obs%assoc%array(iarray)%dim1
    dim2 = max(1,obs%assoc%array(iarray)%dim2)
    select case (obs%assoc%array(iarray)%fmt)
    case (fmt_r4)
      write(badstring,11)  obs%assoc%array(iarray)%badr4
      if (dim1*dim2.le.4) then
        write(datastring,11)  obs%assoc%array(iarray)%r4(1:dim1,1:dim2)
      else
        write(datastring,21)  obs%assoc%array(iarray)%r4(1:2,1),  &
                              obs%assoc%array(iarray)%r4(dim1-1:dim1,dim2)
      endif
    case (fmt_i4)
      write(badstring,12)  obs%assoc%array(iarray)%badi4
      if (dim1*dim2.le.4) then
        write(datastring,12)  obs%assoc%array(iarray)%i4(1:dim1,1:dim2)
      else
        write(datastring,22)  obs%assoc%array(iarray)%i4(1:2,1),  &
                              obs%assoc%array(iarray)%i4(dim1-1:dim1,dim2)
      endif
    case (fmt_by)
      write(badstring,13)  obs%assoc%array(iarray)%badi4
      if (dim1*dim2.le.8) then
        write(datastring,13)  obs%assoc%array(iarray)%i4(1:dim1,1:dim2)
      else
        write(datastring,23)  obs%assoc%array(iarray)%i4(1:4,1),  &
                              obs%assoc%array(iarray)%i4(dim1-3:dim1,dim2)
      endif
    case (fmt_b2)
      write(badstring,14)  obs%assoc%array(iarray)%badi4
      if (dim1*dim2.le.12) then
        write(datastring,14)  obs%assoc%array(iarray)%i4(1:dim1,1:dim2)
      else
        write(datastring,24)  obs%assoc%array(iarray)%i4(1:6,1),  &
                              obs%assoc%array(iarray)%i4(dim1-5:dim1,dim2)
      endif
    case default
      badstring  = 'N/A'
      datastring = '(not implemented)'
    end select
    !
    write(mess,'(4X,A,A,2X,A,I0,2X,A,A,2X,A,I0,A,I0)')  &
      'Unit: ',obs%assoc%array(iarray)%unit,        &
      'Format: ',obs%assoc%array(iarray)%fmt,       &
      'Bad: ',trim(badstring),                      &
      'Dimensions: ',obs%assoc%array(iarray)%dim1,  &
               ' x ',obs%assoc%array(iarray)%dim2
    call class_message(seve%r,rname,mess)
    !
    write(mess,'(4X,2A)')  'Data: ',trim(datastring)
    call class_message(seve%r,rname,mess)
  enddo
  !
11 format(4(1X,1PG14.7))
12 format(4(1X,I10))
13 format(8(1X,I4))
14 format(12(1X,I2))
  !
21 format(2(1X,1PG14.7),'   ...   ',2(1X,1PG14.7))
22 format(2(1X,I10),    '   ...   ',2(1X,I10))
23 format(4(1X,I4),     '   ...   ',4(1X,I4))
24 format(6(1X,I2),     '   ...   ',6(1X,I2))
  !
end subroutine class_assoc_dump
!
subroutine class_assoc_minmax(obs,aaname,rmin,rmax,error)
  use gbl_format
  use gbl_message
  use classcore_interfaces, except_this=>class_assoc_minmax
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the min max range, in the current SET MODE X, plus some
  ! MARGIN. This is suited for plotting (same as subroutine class_minmax
  ! for RY).
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs
  character(len=*),  intent(in)    :: aaname
  real(kind=4),      intent(out)   :: rmin
  real(kind=4),      intent(out)   :: rmax
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=4) :: n
  type(class_assoc_sub_t) :: array
  !
  if (.not.class_assoc_exists(obs,aaname,array)) then
    call class_message(seve%e,rname,'No such associated array '//aaname)
    error = .true.
    return
  endif
  !
  if (array%dim2.gt.1) then
    call class_message(seve%e,rname,trim(aaname)//' is 2D, can not plot')
    error = .true.
    return
  endif
  !
  n = obs%cimax-obs%cimin+1
  !
  select case (array%fmt)
  case (fmt_r4)
    call class_minmax(rmin,rmax,array%r4(obs%cimin:obs%cimax,1),n,array%badr4)
    !
  case (fmt_i4,fmt_by,fmt_b2)
    call class_minmax(rmin,rmax,array%i4(obs%cimin:obs%cimax,1),n,array%badi4)
    !
  case default
    call class_message(seve%e,rname,'Kind of data not implemented')
    error = .true.
    return
  end select
  !
end subroutine class_assoc_minmax

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mira_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack
  !
  external :: class_pack_set
  external :: mira_pack_init,mira_pack_clean
  !
  pack%name='mira'
  pack%ext='.mira'
  pack%authors="A.Sievers"
  pack%depend(1:3) = (/ locwrd(sic_pack_set), locwrd(greg_pack_set), locwrd(class_pack_set)/) ! List here dependencies
  pack%init=locwrd(mira_pack_init)
  pack%clean=locwrd(mira_pack_clean)
  !
end subroutine mira_pack_set
!
subroutine mira_pack_init(gpack_id,error)
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Activate SIC copies of structure ATM
  call atm_sicvariables(error)
  !
  ! Load local language and initialize MIRA
  call load_mira
  !
  ! Init error flag
  error = .false.
  !
end subroutine mira_pack_init
!
subroutine mira_pack_clean(error)
  !----------------------------------------------------------------------
  ! @ private
  ! Called at end of session. Might clean here for example global buffers
  ! allocated during the session
  !----------------------------------------------------------------------
  logical :: error
  !
  call exit_mira
  !
end subroutine mira_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program classic_demo_write
  use classic_api
  implicit none
  !---------------------------------------------------------------------
  !  Demonstration program which writes a Classic file version 2, with
  ! a few entries, and 1 Entry Index, 1 section, and 1 data array per
  ! entry. The output file 'foo.bin' can be read again by the reading
  ! demonstration program.
  !
  !  * Entry Index:
  !     - Entry starting record  (I*8)
  !     - Entry starting word    (I*4)
  !     - Dummy 'foo' value      (I*4)
  !  * Section:
  !     - One R*4 value
  !     - One R*8 value
  !     - One I*4 value
  !     - One I*8 value
  !     - One C*8 value
  !  * Data:
  !     - Array of 10 R*4 values
  !---------------------------------------------------------------------
  type(classic_recordbuf_t) :: rbufind,rbufobs
  integer(kind=4) :: i
  integer(kind=entry_length) :: ientry
  logical :: error,full
  ! File
  type(classic_file_t) :: file
  integer(kind=4), parameter :: file_lun=50  ! Arbitrary value
  character(len=*), parameter :: file_name='foo.bin'
  integer(kind=4), parameter :: file_version=2
  integer(kind=4), parameter :: file_reclen=64  ! Arbitrary value
  ! File Descriptor
  integer(kind=4), parameter :: fdesc_kind=classic_kind_demo
  logical, parameter :: fdesc_single=.true.
  real(kind=4), parameter :: fdesc_expo=2.0
  integer(kind=entry_length), parameter :: fdesc_size=1  ! Not relevant for exponential growth
  ! Entry Index
  integer(kind=4), parameter :: ind_version=123  ! Index version (arbitrary value)
  integer(kind=4), parameter :: ind_length=4  ! 1 I*8, 2 I*4
  integer(kind=8) :: ind_rstart
  integer(kind=4) :: ind_wstart
  integer(kind=4) :: ind_foo
  integer(kind=4) :: bufind(ind_length)  ! Buffer for byte-swapping one index
  ! Entry Descriptor
  type(classic_entrydesc_t) :: edesc
  integer(kind=4), parameter :: edesc_maxsec=1     ! Maximum number of section per entry
  integer(kind=4), parameter :: edesc_version=456  ! Observation version (arbitrary value)
  ! Section
  integer(kind=4), parameter :: sec_id=789  ! Identifier (arbitrary value)
  integer(kind=data_length), parameter :: sec_length=8  ! 1 R*4, 1 R*8, 1 I*4, 1 I*8, 1 C*8
  real(kind=4) :: sec_r4
  real(kind=8) :: sec_r8
  integer(kind=4) :: sec_i4
  integer(kind=8) :: sec_i8
  character(len=8) :: sec_c8
  integer(kind=4) :: bufsec(sec_length)  ! Buffer for byte-swapping one section
  ! Data
  integer(kind=data_length), parameter :: dat_length=10
  real(kind=4) :: data(dat_length)
  real(kind=4) :: bufdat(dat_length)  ! Buffer for byte-swapping one data block
  !
  write(*,'(A)')  '--- Welcome to the Classic demonstration writing program ---'
  !
  error = .false.
  !
  ! Initialize the Classic library
  call classic_init(error)
  if (error)  stop
  !
  file%lun = file_lun
  file%spec = file_name
  file%nspec = len_trim(file%spec)
  file%update = .false.
  call classic_file_init(file,file_version,file_reclen,error)
  if (error)  stop
  !
  call classic_filedesc_init(file,fdesc_kind,fdesc_single,fdesc_size,  &
    ind_version,ind_length,fdesc_expo,error)
  if (error)  stop
  !
  call reallocate_recordbuf(rbufind,file%desc%reclen,error)
  if (error)  stop
  call reallocate_recordbuf(rbufobs,file%desc%reclen,error)
  if (error)  stop
  !
  do ientry=1,5  ! Write 5 entries
    write(*,*) ''
    write(*,'(A,I0)') 'Writing entry #',ientry
    call classic_entry_init(file,ientry,edesc_maxsec,edesc_version,full,  &
      edesc,error)
    if (full)  write(*,*) 'Error: file is full'
    if (error)  stop
    !
    ! Set the working buffer
    call classic_recordbuf_open(file,file%desc%nextrec,file%desc%nextword,  &
      rbufobs,error)
    if (error)  stop
    !
    ! Add the Entry Index
    ind_rstart = rbufobs%rstart
    ind_wstart = rbufobs%wstart
    ind_foo = 900+ientry  ! Some dummy value to be stored in the Index
    write(*,'(A,I0,1X,I0,1X,I0)')  &
      '  INDEX: ',ind_rstart,ind_wstart,ind_foo
    ! Entry Index can be anything => byte swapping is application specific.
    call classic_demo_ind2buf(ind_rstart,ind_wstart,ind_foo,bufind,  &
      file%conv)
    if (error)  stop
    call classic_entryindex_write(file,ientry,bufind,rbufind,error)
    if (error)  stop
    !
    ! Add 1 section: 1 R*4, 1 R*8, 1 I*4, 1 I*8, 1 C*8
    sec_r4 = real(ientry,kind=4)
    sec_r8 = real(ientry,kind=8)
    sec_i4 = int(ientry,kind=4)
    sec_i8 = int(ientry,kind=8)
    write(sec_c8,'(I8)')  ientry
    write(*,'(A,F0.2,1X,F0.4,1X,I0,1X,I0,1X,A)')   &
      '  SECTION: ',sec_r4,sec_r8,sec_i4,sec_i8,sec_c8
    ! Section can be anything => byte swapping is application specific.
    call classic_demo_sec2buf(sec_r4,sec_r8,sec_i4,sec_i8,sec_c8,bufsec,  &
      file%conv)
    call classic_entry_section_add(sec_id,sec_length,bufsec,edesc,rbufobs,  &
      error)
    if (error)  stop
    !
    ! Add data
    ! Data can be anything => byte swapping is application specific.
    data(:) = (/ (ientry+i, i=1,dat_length) /)
    write(*,'(A,I0,A,10(1X,F0.2))')  &
      '  DATA (',dat_length,' values): ',data(1:dat_length)
    call classic_demo_dat2buf(int(dat_length,kind=4),data,bufdat,file%conv)
    call classic_entry_data_add(bufdat,dat_length,edesc,rbufobs,error)
    if (error)  stop
    !
    ! Write the Entry Descriptor
    write(*,'(A,I0,1X,I0,1X,I0,1X,I0)')  &
      '  DESCRIPTOR: ',edesc%nsec,edesc%nword,edesc%adata,edesc%ldata
    call classic_entrydesc_write(file,rbufobs,edesc,error)
    if (error)  stop
    !
    call classic_entry_close(file,rbufobs,error)
    if (error)  stop
    !
    ! Once the Entry and Entry Descriptor are written, update the File
    ! Descriptor on disk (in particular xnext)
    file%desc%xnext = ientry+1
    call classic_filedesc_write(file,error)
    if (error)  stop
  enddo
  !
  ! Debugging printout
  write(*,*) ''
  write(*,'(A)')  'File Descriptor:'
  call classic_filedesc_dump(file%desc,'w')
  !
  call classic_file_close(file,error)
  if (error)  stop
  !
  call deallocate_recordbuf(rbufobs,error)
  if (error)  stop
  call deallocate_recordbuf(rbufind,error)
  if (error)  stop
  !
  write(*,*) ''
  write(*,'(A,A,A)') 'File ',trim(file%spec),' successfully written'
  !
contains
  !
  subroutine classic_demo_ind2buf(rec,word,foo,buf,conv)
    use gildas_def
    use gkernel_interfaces
    use classic_api
    !---------------------------------------------------------------------
    ! Copy the Entry Index into the given buffer, swap bytes if needed
    !---------------------------------------------------------------------
    integer(kind=8),          intent(in)  :: rec
    integer(kind=4),          intent(in)  :: word
    integer(kind=4),          intent(in)  :: foo
    integer(kind=4),          intent(out) :: buf(*)
    type(classic_fileconv_t), intent(in)  :: conv
    !
    call conv%writ%i8(rec, buf(1),1)  ! 1-2: record
    call conv%writ%i4(word,buf(3),1)  !   3: word
    call conv%writ%i4(foo, buf(4),1)  !   4: foo
    !
  end subroutine classic_demo_ind2buf
  !
  subroutine classic_demo_sec2buf(r4,r8,i4,i8,c8,buf,conv)
    use gildas_def
    use gkernel_interfaces
    use classic_api
    !---------------------------------------------------------------------
    ! Copy the section values into the given buffer, swap bytes if needed
    !---------------------------------------------------------------------
    real(kind=4),             intent(in)  :: r4
    real(kind=8),             intent(in)  :: r8
    integer(kind=4),          intent(in)  :: i4
    integer(kind=8),          intent(in)  :: i8
    character(len=*),         intent(in)  :: c8
    integer(kind=4),          intent(out) :: buf(*)
    type(classic_fileconv_t), intent(in)  :: conv
    !
    call conv%writ%r4(r4,buf(1),1)  !   1: R*4
    call conv%writ%r8(r8,buf(2),1)  ! 2-3: R*8
    call conv%writ%i4(i4,buf(4),1)  !   4: I*4
    call conv%writ%i8(i8,buf(5),1)  ! 5-6: I*8
    call conv%writ%cc(c8,buf(7),2)  ! 7-8: C*8
    !
  end subroutine classic_demo_sec2buf
  !
  subroutine classic_demo_dat2buf(ldata,data,buf,conv)
    use gildas_def
    use gkernel_interfaces
    use classic_api
    !---------------------------------------------------------------------
    ! Copy the Data array into the given buffer, swap bytes if needed
    !---------------------------------------------------------------------
    integer(kind=4),          intent(in)  :: ldata
    real(kind=4),             intent(in)  :: data(ldata)
    real(kind=4),             intent(out) :: buf(ldata)
    type(classic_fileconv_t), intent(in)  :: conv
    !
    call conv%writ%r4(data,buf,ldata)
    !
  end subroutine classic_demo_dat2buf
  !
end program classic_demo_write

subroutine gtchar(nchars,string,size,slength,xp,yp,co,si,ic,ifont,  &
  doclip,gpoly_clip)
  use phys_const
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtchar
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public
  !   Plots a character string according to current line attributes.
  ! Indices, subscripts, and special fonts are selected using the escape
  ! character \ (C.f. GREG and VSTRIN routine in CHARSHR).
  !
  !   The hard font line attribute is incompatible with the handling of
  ! the escape character \ . The argument IFONT indicates which font
  ! should be taken into account: 0 = Hardware, 1 Simplex, 2 Duplex. If
  ! the hardware generator cannot reasonably match (CO,SI) and SIZE, the
  ! SIMPLEX font is used.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: nchars      ! Number of characters
  character(len=*), intent(in)  :: string      ! Character string
  real(kind=4),     intent(in)  :: size        ! Character width (plot page units)
  real(kind=4),     intent(out) :: slength     ! String length (plot page units)
  real(kind=4),     intent(in)  :: xp          ! Position where to write the string
  real(kind=4),     intent(in)  :: yp          !
  real(kind=4),     intent(in)  :: co          ! Cosine of angle
  real(kind=4),     intent(in)  :: si          ! Sine of angle
  integer(kind=4),  intent(in)  :: ic          ! Centering option according to GREG conventions
  integer(kind=4),  intent(in)  :: ifont       ! Font type (0 Simplex, 1 Duplex)
  logical,          intent(in)  :: doclip      ! Clip with current Greg box?
  external                      :: gpoly_clip  !
  ! Interfaces
  interface
    subroutine gpoly_clip(nq,xq,yq)
      use gildas_def
      integer(kind=size_length), intent(in) :: nq     ! Number of points
      real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
      real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
    end subroutine gpoly_clip
  end interface
  ! Local
  real(kind=4) :: rxp,ryp,xstart,ystart,dx,dy,angle
  integer(kind=4) :: xsign,ysign,kfont
  !
  if (.not.awake .or. error_condition)  return
  !
  if (nchars.le.0) then
    slength = 0.
    return
  endif
  !
  ! Save the current GTWHERE
  rxp = polyl%x(polyl%n)
  ryp = polyl%y(polyl%n)
  !
  ! Get the current font KFONT: 0 Simplex quality, 1 for Duplex.
  ! Compute position
  kfont = max(ifont,0)
  if (ic.ne.6) then
    xsign = mod(ic-1,3) - 1
    ysign = (ic-1)/3 - 1
    if (xsign.eq.1) then
      dx = 0
    else
      call vstrin(nchars,string,.false.,slength,0.,0.,0.,kfont,size,  &
        doclip,gtpolyl,gpoly_clip)
      dx = (xsign - 1) * 0.5 * slength
    endif
    dy = ysign * 0.5 * size
    xstart = xp + dx * co - dy * si
    ystart = yp + dy * co + dx * si
  else
    xstart = xp
    ystart = yp
  endif
  !
  ! Call the font generator
  ! We should pass CO and SI in argument of VSTRIN, not ANGLE...
  angle = atan2(si,co)
  angle = angle*180.0/pis
  ! Clipping or not clipping?
  !  - If clipping is not wanted, use directly the GTV dedicated subroutine
  !    (gtpolyl)
  !  - If clipping to the current box is wanted, use the GREG dedicated
  !    subroutine (passed as argument). This makes sense because the box
  !    is a Greg feature, not GTV.
  call vstrin(nchars,string,.true.,slength,xstart,ystart,angle,kfont,size,  &
    doclip,gtpolyl,gpoly_clip)
  !
  ! Reset the virtual pen location
  call gtreloc (rxp,ryp)
end subroutine gtchar
!
subroutine gtg_charlen (nchars,string,size,slength,ifont)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtg_charlen
  use gtv_tree
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ public
  !   Returns the length of a character string according to current
  ! font attributes. No action on the plot. See also GTCHAR
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: nchars   ! Number of characters
  character(len=*), intent(in)  :: string   ! Character string
  real(kind=4),     intent(in)  :: size     ! Character size (plot page units)
  real(kind=4),     intent(out) :: slength  ! String length (plot page units)
  integer(kind=4),  intent(in)  :: ifont    ! Font type
  ! Local
  integer(kind=4) :: kfont
  !
  if (.not.awake)  return
  !
  if (nchars.le.0) then
    slength = 0.
    return
  endif
  !
  ! Get the current font KFONT: 0 for Simplex quality, 1 for Duplex.
  ! Invoke VSTRIN to get the actual length.
  kfont = max(ifont,0)
  call vstrin(nchars,string,.false.,slength,0.,0.,0.,kfont,size,  &
    .false.,gtpolyl,dummy_clip)
  !
end subroutine gtg_charlen
!
subroutine dummy_clip(nq,xq,yq)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Unused subroutine sent to 'vstrin' (doclip = .false.)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nq     ! Number of points
  real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
  real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
end subroutine dummy_clip

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeio_interface
  use gkernel_interfaces
  use gkernel_types
  use cubetools_parameters
  use cubeio_dataformat_types
  use cubedag_node_class
  use cubeadm_timing  ! From cubedag
  use cubeio_cube_define
  use cubeio_messaging
  use cubeio_range
  use cubeio_cube
  ! Below the dataformat-specific modules
  use cubefitsio_header_read
  use cubeio_header_hgdf
  use cubeio_header_hcdf
  use cubeio_header_hfits
  use cubeio_header_iodesc
  use cubeio_cdf
  use cubeio_gdf
  use cubeio_fits
  !
  interface cubeio_header_put
    module procedure cubeio_header_put_tohgdf
    module procedure cubeio_header_put_tohcdf
    module procedure cubeio_header_put_tohfits
    module procedure cubeio_header_put_toiodesc
  end interface cubeio_header_put

  interface cubeio_cube_read_data
    module procedure cubeio_cube_read_data_r4
    module procedure cubeio_cube_read_data_c4
  end interface cubeio_cube_read_data

  interface cubeio_cube_write_data
    module procedure cubeio_cube_write_data_r4
    module procedure cubeio_cube_write_data_c4
  end interface cubeio_cube_write_data
  !
  ! Reading API
  public :: cubeio_header_get_and_derive
  public :: cubeio_cube_read_header
  public :: cubeio_cube_reload_header
  public :: cubeio_cube_read_data
  ! Writing API
  public :: cubeio_header_put
  public :: cubeio_cube_create_cube
  public :: cubeio_cube_update_header
  public :: cubeio_cube_write_cube
  public :: cubeio_cube_write_data
  private
  !
contains
  subroutine cubeio_header_get_and_derive(cube,dno,error)
    !-------------------------------------------------------------------
    ! From cube%file%h* to interface_t and header_t
    !-------------------------------------------------------------------
    type(cubeio_cube_t),          intent(in)    :: cube
    class(cubedag_node_object_t), intent(inout) :: dno
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>GET>AND>DERIVE'
    !
    select case (cube%file%kind)
    case (code_dataformat_gdf)
      call cubeio_header_get_and_derive_fromhgdf(cube%file%hgdf,dno,error)
      if (error)  return
    case (code_dataformat_cdf)
      call cubeio_header_get_and_derive_fromhcdf(cube%file%hcdf,dno,error)
      if (error)  return
    case (code_dataformat_fits)
      call cubeio_header_get_and_derive_fromhfits(cube%file%hfits,dno,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unsupported file kind')
      error = .true.
      return
    end select
  end subroutine cubeio_header_get_and_derive
  !
  subroutine cubeio_cube_read_header(cubdef,dno,cube,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cube
    logical,                      intent(inout) :: error
    !
    character(len=file_l) :: cubeid
    character(len=*), parameter :: rname='CUBE>READ>HEADER'
    !
    if (.not.cubdef%dofilename) then
      call cubeio_message(seve%e,rname,'Input cube name is not set')
      error = .true.
      return
    endif
    if (cubdef%doid) then
      cubeid = cubdef%id
    else
      cubeid = cubdef%filename
    endif
    ! Note 1: the HDU number is ignored if not a FITS file
    ! Note 2: re-reading the Primary HDU is incorrect if IMPORT /HDU was
    !         used in the first place (in the context of snapshots?)
    call cube%file%read_header(cubdef%filename,cubdef%hdu,cubeid,error)
    if (error)  return
    !
    ! Setup header
    select case (cube%file%kind)
    case (code_dataformat_fits)
      call cubeio_header_get_and_derive_fromhfits(cube%file%hfits,dno,error)
      if (error) return
    case (code_dataformat_gdf)
      call cubeio_header_get_and_derive_fromhgdf(cube%file%hgdf,dno,error)
      if (error) return
    case default
      call cubeio_message(seve%e,rname,'Data format not supported or no file on disk')
      error = .true.
      return
    end select
  end subroutine cubeio_cube_read_header
  !
  subroutine cubeio_cube_reload_header(cube,error)
    !-------------------------------------------------------------------
    ! Reload the header from disk to its proper file type. This is
    ! relevant in the case where the writing library does things out of
    ! our control (e.g. CFITSIO writing some extra entries in the header).
    ! Reloading is skipped if not relevant.
    ! This subroutine does not:
    ! - open the file,
    ! - transfer from file type to dno%node%head.
    !-------------------------------------------------------------------
    type(cubeio_cube_t), intent(inout) :: cube
    logical,             intent(inout) :: error
    !
    select case (cube%file%kind)
    case (code_dataformat_fits)
      ! We have written a FITS file. Reload its header in our
      ! dictionary. This is the best way to retrieve what is actually
      ! on disk, as CFITSIO adds its owns comments and keywords beyond
      ! our choice.
      if (cube%file%hfits%unit.gt.0) then  ! Can be zero if the file creation failed.
                                          ! ZZZ we should have a better way to
                                          ! support this case.
        call cubefitsio_header_fill(cube%file%hfits,error)
        if (error)  continue
      endif
    case default
      ! For the other file types, there is nothing new to reload.
    end select
  end subroutine cubeio_cube_reload_header
  !
  subroutine cubeio_cube_read_data_r4(cube,range,data,error)
    !---------------------------------------------------------------------
    ! Wrapper around writing data subroutines
    ! ---
    ! R*4 version
    !---------------------------------------------------------------------
    type(cubeio_cube_t),  intent(inout) :: cube
    type(cubeio_range_t), intent(in)    :: range
    real(kind=4),         intent(out)   :: data(:,:,:)
    logical,              intent(inout) :: error
    !
    type(cputime_t) :: tmp
    character(len=*), parameter :: rname='READ>CUBE>DATA>R4'
    !
    call gag_cputime_init(tmp)
    !
    ! Need to open or reopen (if not yet opened)
    call cube%open(error)
    if (error)  return
    !
    select case (cube%file%kind)
    case (code_dataformat_fits)
      call cubeio_fits_read_data(cube%file%hfits,data,range,error)
      if (error)  return
    case (code_dataformat_gdf)
      call cubeio_gdf_read_data(cube%file%hgdf,data,range,error)
      if (error)  return
    case (code_dataformat_cdf)
      call cubeio_cdf_read_data(cube%file%hcdf,data,range,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'No associated file on disk')
      error = .true.
      return
    end select
    !
    call gag_cputime_add(cube%time%read,tmp)
  end subroutine cubeio_cube_read_data_r4
  !
  subroutine cubeio_cube_read_data_c4(cube,range,data,error)
    !---------------------------------------------------------------------
    ! Wrapper around writing data subroutines
    ! ---
    ! C*4 version
    !---------------------------------------------------------------------
    type(cubeio_cube_t),  intent(inout) :: cube
    type(cubeio_range_t), intent(in)    :: range
    complex(kind=4),      intent(out)   :: data(:,:,:)
    logical,              intent(inout) :: error
    !
    type(cputime_t) :: tmp
    character(len=*), parameter :: rname='READ>CUBE>DATA>C4'
    !
    call gag_cputime_init(tmp)
    !
    ! Need to open or reopen (if not yet opened)
    call cube%open(error)
    if (error)  return
    !
    select case (cube%file%kind)
    case (code_dataformat_fits)
      call cubeio_fits_read_data(cube%file%hfits,data,range,error)
      if (error)  return
    case (code_dataformat_gdf)
      call cubeio_gdf_read_data(cube%file%hgdf,data,range,error)
      if (error)  return
    case (code_dataformat_cdf)
      call cubeio_cdf_read_data(cube%file%hcdf,data,range,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'No associated file on disk')
      error = .true.
      return
    end select
    !
    call gag_cputime_add(cube%time%read,tmp)
  end subroutine cubeio_cube_read_data_c4
  !
  subroutine cubeio_cube_create_cube(cube,cubdef,dno,dim,error)
    use cubetools_access_types
    use cubetools_system_tool
    use cubedag_node_class
    use cubecdf_image_write
    use cubefitsio_image_write
    !-------------------------------------------------------------------
    ! Create a file with dummy/minimal data area on disk. It will be
    ! extended later on by adding new blocks.
    !-------------------------------------------------------------------
    type(cubeio_cube_t),          intent(inout) :: cube
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=data_k),         intent(out)   :: dim(:)
    logical,                      intent(inout) :: error
    !
    character(len=base_l) :: cbasename
    character(len=exte_l) :: cextension,nextension
    character(len=file_l) :: cdire
    integer(kind=4) :: nch
    integer(kind=data_k), parameter :: initdim=1  ! 0 not allowed by GIO
    character(len=*), parameter :: rname='CUBE>CREATE>CUBE'
    !
    if (cubdef%dofilekind)  cube%file%kind = cubdef%filekind
    if (cubdef%dofilename)  cube%file%name = cubdef%filename
    if (cube%file%name.eq.'') then
      call cubeio_message(seve%e,rname,'Missing file name')
      error = .true.
      return
    endif
    !
    ! Parse file name for extension and directory
    call sic_parse_name(cube%file%name,cbasename,oext=cextension,odir=cdire)
    if (cdire.ne.'') then
      ! Prepare directory if needed
      call cubetools_directory_create(cdire,error)
      if (error) return
    endif
    !
    ! Prepare default extension
    nextension = ''
    select case (cube%file%kind)
    case (code_dataformat_fits) ! Accept predeclared extensions which contains 'fits'
      if (index(cextension,'fits').eq.0)  nextension = '.fits'
    case (code_dataformat_gdf)  ! Accept any predeclared extension
      if (cextension.eq.'')               nextension = cubetools_order2ext(cube%desc%order)
    case (code_dataformat_cdf)  ! Accept predeclared extensions which contains 'cdf'
      if (index(cextension,'cdf').eq.0)   nextension = '.cdf'
    case default                ! Accept any predeclared extension
      if (cextension.eq.'')               nextension = '.unk'
    end select
    if (nextension.ne.'') then
      ! Append correct extension to file name
      nch = len_trim(cube%file%name)
      cube%file%name = cube%file%name(1:nch)//nextension
    endif
    !
    ! Create a file with dummy/minimal data area:
    select case (cube%file%kind)
    case (code_dataformat_fits)
      call cubeio_create_and_truncate_hfits(dno,cubdef%order,initdim,cube%file%hfits,error)
      if (error)  return
      call cubefitsio_image_create(cube%file%hfits,cube%file%name,cubdef%dochecksum,error)
      if (error)  continue  ! Error message below
      dim(:) = cube%file%hfits%dim(:)
    case (code_dataformat_gdf)
      call gildas_null(cube%file%hgdf)
      call cubeio_create_and_truncate_hgdf(dno,cube%desc,cubdef%order,initdim,cube%file%hgdf,error)
      if (error)  return
      cube%file%hgdf%file = cube%file%name
      cube%file%hgdf%gil%extr_words = 0  ! Disable the extrema section. It will be reenabled if and when relevant
      call gdf_create_image(cube%file%hgdf,error)
      if (error)  continue  ! Error message below
      dim(:) = cube%file%hgdf%gil%dim(:)
    case (code_dataformat_cdf)
      call cubeio_create_and_truncate_hcdf(dno,cubdef%order,initdim,cube%file%hcdf,error)
      if (error)  return
      call cubecdf_image_create(cube%file%hcdf,cube%file%name,error)
      if (error)  continue  ! Error message below
      dim(:) = cube%file%hcdf%dim(:)
    case default
      call cubeio_message(seve%e,rname,'File kind not supported')
      error = .true.
    end select
    if (error) then
      call cubeio_message(seve%e,rname,'Error creating file '//cube%file%name)
      return
    endif
  end subroutine cubeio_cube_create_cube
  !
  subroutine cubeio_cube_write_cube(cube,cubdef,dno,error)
    use cubetools_system_tool
    use cubedag_node_class
    !-------------------------------------------------------------------
    ! Write the whole cube (header+data) from memory to disk
    !-------------------------------------------------------------------
    type(cubeio_cube_t),          intent(inout) :: cube
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBE>WRITE>CUBE'
    !
    ! Prepare directory if needed
    call cubetools_directory_create_for_file(cubdef%filename,error)
    if (error) return
    !
    select case (cubdef%filekind)
    case (code_dataformat_fits)
      call cubeio_create_hfits(dno,cubdef%order,cube%file%hfits,error)
      if (error)  return
      if (cube%desc%iscplx) then
        call cubeio_fits_write_cube(cube%file%hfits,cubdef%filename,cubdef%dochecksum,  &
          cube%memo%c4,error)
        if (error)  return
      else
        call cubeio_fits_write_cube(cube%file%hfits,cubdef%filename,cubdef%dochecksum,  &
          cube%memo%r4,error)
        if (error)  return
      endif
      !
    case (code_dataformat_gdf)
      call cubeio_create_hgdf(dno,cube%desc,cubdef%order,cube%file%hgdf,error)
      if (error)  return
      if (cube%desc%iscplx) then
        call cubeio_gdf_write_cube(cube%file%hgdf,cubdef%filename,cube%memo%c4,error)
        if (error)  return
      else
        call cubeio_gdf_write_cube(cube%file%hgdf,cubdef%filename,cube%memo%r4,error)
        if (error)  return
      endif
      !
    case default
      call cubeio_message(seve%e,rname,'Data format not implemented')
      error = .true.
      return
    end select
  end subroutine cubeio_cube_write_cube
  !
  subroutine cubeio_cube_update_header(cube,dno,last,error)
    use gkernel_interfaces
    use cubedag_node_class
    use cubecdf_image_write
    use cubefitsio_image_write
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cubeio_cube_t),          intent(inout) :: cube
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=index_length),   intent(in)    :: last
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBE>UPDATE>HEADER'
    !
    ! Update the header on disk (e.g. the extrema section might be updated after
    ! processing each block)
    select case (cube%file%kind)
    case (code_dataformat_fits)
      if (cube%desc%action.eq.code_write) then
        ! No need to close and extend (done at data write time)
        call cubeio_create_and_truncate_hfits(dno,cube%order(),last,cube%file%hfits,error)
        if (error)  return
      else  ! code_update
        call cubeio_create_hfits(dno,cube%order(),cube%file%hfits,error)
        if (error)  return
      endif
      call cubefitsio_image_header_update(cube%file%hfits,error)
      if (error)  return
      !
    case (code_dataformat_cdf)
      if (cube%desc%action.eq.code_write) then
        ! No need to close and extend (done at data write time)
        call cubeio_create_and_truncate_hcdf(dno,cube%order(),last,cube%file%hcdf,error)
        if (error)  return
      else  ! code_update
        call cubeio_create_hcdf(dno,cube%order(),cube%file%hcdf,error)
        if (error)  return
      endif
      call cubecdf_image_header_update(cube%file%hcdf,error)
      if (error)  return
      !
    case (code_dataformat_gdf)
      if (cube%desc%action.eq.code_write) then
        ! NB: the current header in memory is transfered to the file AFTER
        ! gdf_extend_image so that the new dimension is correctly applied by
        ! gdf_extend_image. This means the data is first added/updated (with
        ! consistent dimensions), then the header (remaining sections) is updated.
        if (cube%file%hgdf%loca%islo.gt.0) then  ! Close (if relevant) before reopening
          call gdf_close_image(cube%file%hgdf,error)
          if (error)  return
        endif
        call gdf_extend_image(cube%file%hgdf,last,error)
        if (error)  return
        call cubeio_create_and_truncate_hgdf(dno,cube%desc,cube%order(),last,cube%file%hgdf,error)
        if (error)  return
      else  ! code_update
        call cubeio_create_hgdf(dno,cube%desc,cube%order(),cube%file%hgdf,error)
        if (error)  return
      endif
      call gdf_update_header(cube%file%hgdf,error)
      if (error)  return
      !
    case default
      call cubeio_message(seve%e,rname,'No associated file on disk')
      error = .true.
      return
    end select
  end subroutine cubeio_cube_update_header
  !
  subroutine cubeio_cube_write_data_r4(cube,range,data,error)
    !---------------------------------------------------------------------
    ! Wrapper around writing data subroutines
    ! ---
    ! R*4 version
    !---------------------------------------------------------------------
    type(cubeio_cube_t),  intent(inout) :: cube
    type(cubeio_range_t), intent(in)    :: range
    real(kind=4),         intent(inout) :: data(:,:,:)
    logical,              intent(inout) :: error
    !
    type(cputime_t) :: tmp
    character(len=*), parameter :: rname='WRITE>CUBE>DATA>R4'
    !
    call gag_cputime_init(tmp)
    !
    select case (cube%file%kind)
    case (code_dataformat_fits)
      call cubeio_fits_write_data(cube%file%hfits,data,range,error)
      if (error)  return
    case (code_dataformat_gdf)
      call cubeio_gdf_write_data(cube%file%hgdf,data,range,error)
      if (error)  return
    case (code_dataformat_cdf)
      call cubeio_cdf_write_data(cube%file%hcdf,data,range,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'No associated file on disk')
      error = .true.
      return
    end select
    !
    call gag_cputime_add(cube%time%writ,tmp)
  end subroutine cubeio_cube_write_data_r4
  !
  subroutine cubeio_cube_write_data_c4(cube,range,data,error)
    !---------------------------------------------------------------------
    ! Wrapper around writing data subroutines
    ! ---
    ! C*4 version
    !---------------------------------------------------------------------
    type(cubeio_cube_t),  intent(inout) :: cube
    type(cubeio_range_t), intent(in)    :: range
    complex(kind=4),      intent(in)    :: data(:,:,:)
    logical,              intent(inout) :: error
    !
    type(cputime_t) :: tmp
    character(len=*), parameter :: rname='WRITE>CUBE>DATA>C4'
    !
    call gag_cputime_init(tmp)
    !
    select case (cube%file%kind)
    case (code_dataformat_fits)
      call cubeio_fits_write_data(cube%file%hfits,data,range,error)
      if (error)  return
    case (code_dataformat_gdf)
      call cubeio_gdf_write_data(cube%file%hgdf,data,range,error)
      if (error)  return
    case (code_dataformat_cdf)
      call cubeio_cdf_write_data(cube%file%hcdf,data,range,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'No associated file on disk')
      error = .true.
      return
    end select
    !
    call gag_cputime_add(cube%time%writ,tmp)
  end subroutine cubeio_cube_write_data_c4
  !
end module cubeio_interface
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine minshell(npar,g,f,x,iflag,obs)
  use classfit_interfaces, except_this=>minshell
  use class_types
  use gauss_parameter
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Function to be minimized in the Shell line fit.
  ! Basic parameters are Area, Width, Position, and Horn/Center ratio.
  ! Allows dependent lines to be fitted.
  !----------------------------------------------------------------------
  integer(kind=4),   intent(in)  :: npar     ! Number of parameters
  real(kind=8),      intent(out) :: g(npar)  ! Array of derivatives
  real(kind=8),      intent(out) :: f        ! Function value
  real(kind=8),      intent(in)  :: x(npar)  ! Input parameter values
  integer(kind=4),   intent(in)  :: iflag    ! Code operation
  type(observation), intent(in)  :: obs      !
  ! Local
  real(kind=4) :: gg(nshellpar*mshelllin),xx(nshellpar*mshelllin),gu(nshellpar*mshelllin)
  real(kind=4) :: g1,g2,g3,g4,aa,nn,vv,hh,ff,xvel,eps
  real(kind=4) :: dff,ybas,yrai,seuil,ta
  integer(kind=4) :: i,j,kbas,krai
  logical :: dograd,error
  !
  if (iflag.eq.3) goto 20
  !
  ! The profile is written as the sum
  ! 	f(Ai,Ni,Vi,Hi)
  ! where Vi = VV.vi, Ai = AA.ai, Ni = NN+ni and Hi = HH*hi
  !
  aa = x(1)
  nn = x(2)
  vv = x(3)
  hh = x(4)
  g1 = 0.0
  g2 = 0.0
  g3 = 0.0
  g4 = 0.0
  do i=4,4*nline,4
     xx(i-3) = x(i+1)*aa
     gg(i-3) = 0.0
     xx(i-2) = x(i+2)+nn
     gg(i-2) = 0.0
     xx(i-1) = x(i+3)*vv
     gg(i-1) = 0.0
     xx(i)   = x(i+4)*hh
     gg(i)   = 0.0
  enddo
  dograd = iflag.eq.2
  !
  f = 0.0
  eps = abs(obs%datax(obs%cimin+1) - obs%datax(obs%cimin))
  do i=obs%cimin, obs%cimax
     if (wfit(i).ne.0) then
        xvel = obs%datax(i)
        ff = 0.0
        do j=1,4*nline,4
           call fshell (xvel,eps,xx(j),ff,gu(j),dograd,error)
           if (error) return
        enddo
        dff = ff - obs%spectre(i)
        f = f + dff**2
        dff = 2.0*dff
        do j = 1, 4*nline
           gu(j) = dff*gu(j)
           gg(j) = gg(j) + gu(j)
        enddo
        do j = 1, 4*nline, 4
           g1 = g1 + gu(j)*xx(j)
           g2 = g2 + gu(j+1)
           g3 = g3 + gu(j+2)*xx(j+2)
           g4 = g4 + gu(j+3)*xx(j+3)
        enddo
     endif
  enddo
  !
  g(1) = g1
  g(2) = g2
  g(3) = g3
  g(4) = g4
  !
  do j=1,4*nline,4
     g(j+4) = gg(j)*aa
     g(j+5) = gg(j+1)
     g(j+6) = gg(j+2)*vv
     g(j+7) = gg(j+3)*hh
  enddo
  return
  !
  ! Compute the new sigma after minimisation
20 kbas=0
  ybas=0.
  krai=0
  yrai=0.
  seuil= sigbas/100.
  !
  do i=obs%cimin,obs%cimax
     if (wfit(i).ne.0) then
        ta = proshell(obs,real(obs%datax(i),4),0,error)
        if (error) return
        if (abs(ta).le.seuil) then
           kbas=kbas+1
           ybas=ybas+obs%spectre(i)**2
        else
           krai=krai+1
           yrai=yrai+(ta-obs%spectre(i))**2
        endif
     endif
  enddo
  if (kbas.ne.0) then
     sigbas=sqrt(ybas/kbas)
  else
     sigbas=0.d0
  endif
  if (krai.ne.0) then
     sigrai=sqrt(yrai/krai)
  else
     sigrai=0.d0
  endif
  !
end subroutine minshell
!
subroutine fshell(x0,dx,xp,fout,gg,dograd,error)
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  ! Computes the contribution of a Shell-like profile in the current
  ! channel to the square sum, and to the gradients relative to the
  ! parameters also if DOGRAD is .true.. Highly optimised ?
  !----------------------------------------------------------------------
  real(kind=4), intent(in)  :: x0      ! Abscissa
  real(kind=4), intent(in)  :: dx      ! Freq resolution
  real(kind=4), intent(in)  :: xp(4)   ! Input parameters
  real(kind=4), intent(out) :: fout    ! Output value of Shell function
  real(kind=4), intent(out) :: gg(4)   ! Gradients
  logical,      intent(in)  :: dograd  ! Compute contribution to gradients
  logical,      intent(out) :: error   ! Logical error flag
  ! Local
  real(kind=4) :: ff,tt,vv,dd,hh,arg,aarg,arg0,arg1,arg2,arg3,arg4
  integer(kind=4) :: i
  character(len=80) :: chain
  !
  error = .false.
  tt = xp(1)
  vv = xp(2)-x0
  dd = xp(3)
  hh = xp(4)
  if (dd.eq.0.or.tt.eq.0) then
     write(chain,*) 'Wrong Arguments :',xp
     call class_message(seve%e,'FSHELL',chain)
     error = .true.
     return
  endif
  arg = vv/dd
  arg0 = 1.-0.5*dx/dd
  arg1 = 1.+0.5*dx/dd
  aarg = abs(arg)
  if (aarg .lt. arg0) then
     arg2 = arg**2
     ff = tt*1.5/dd/(3.+hh)*(1.+hh*arg2)
     if (dograd) then
        arg3  = 1./(1.+hh*arg2)
        arg4  = arg2*arg3
        gg(1) =  ff/tt
        gg(2) = -ff*arg3*2.*hh*arg/dd
        gg(3) = -ff/dd*(1.+2.*hh*arg4)
        gg(4) =  ff*(-1./(3.+hh)+arg4)
     endif
  elseif (aarg .lt. arg1) then
     arg2 = arg0**2
     ff   = tt*1.5/dd/(3.+hh)*(1.+hh*arg2)*(aarg-arg1)/(arg0-arg1)
     if (dograd) then
        gg(1) = ff/tt
        gg(2) = - ff/(aarg-arg1)/dd
        if (arg.le.0) gg(2) = -gg(2)
        gg(3) = -ff/dd*(1.-1./(arg1-aarg)-2.*hh*arg0*(1.-arg0)/(1.+hh*arg2))
        gg(4) = ff*(-1./(3.+hh)+arg2/(1.+hh*arg2))
     endif
  else
     ff = 0.
     if (dograd) then
        do i=1,4
           gg(i) = 0.
        enddo
     endif
  endif
  fout = fout + ff
end subroutine fshell

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_setup_types
  use cubetools_parameters
  use cubetools_datasize
  !
  private
  ! These should be private when all the get/set API is implemented:
  public :: cube_setup_buffer_t
  public :: cube_setup_output_t
  public :: cube_setup_t
  ! Public set/get API
  public :: cube_setup_api_t
  !
  ! --- Setup flags ----------------------------------------------------
  ! This structure holds all the setup flags. It should be entirely
  ! private at some point, only the public API should be used.
  !
  ! Support for SETUP\BLANKING
  type :: cube_setup_blanking_t
    integer(kind=4) :: rmode = code_patchblank_otf  ! Read mode
  end type cube_setup_blanking_t
  !
  ! Support for SETUP\BUFFER
  type :: cube_setup_buffer_t
    integer(kind=code_k) :: input  = code_buffer_memory
    integer(kind=code_k) :: output = code_buffer_memory
    real(kind=size_k)    :: limit  =  2.0*GiB  ! [Bytes]
    real(kind=size_k)    :: block  = 512.*MiB  ! [Bytes] Default block size (disk mode)
    real(kind=size_k)    :: task   = 256.*kiB  ! [Bytes] Default task size (1 plane of 250x250 pixels)
  end type cube_setup_buffer_t
  !
  ! Support for SETUP\OUTPUT (cubes customization)
  type :: cube_setup_output_t
    logical          :: extrema = .true.    ! Compute and update the extrema section
    logical          :: write = .true.      ! Write the file on disk?
    logical, private :: radio2sfl = .true.  ! Convert radio to SFL projection at export time?
  end type cube_setup_output_t
  !
  ! Support for SETUP\TIMING
  type :: cube_setup_timing_t
    logical, private :: io = .false.       ! IO timing feedback
    logical, private :: command = .false.  ! Command timing feedback
  end type cube_setup_timing_t
  !
  ! Support for SETUP\INDEX
  type :: cube_setup_index_t
    integer(kind=code_k), private :: default=code_index_dag
  end type cube_setup_index_t
  !
  type :: cube_setup_t
    type(cube_setup_blanking_t)        :: blanking
    type(cube_setup_buffer_t)          :: buff
    type(cube_setup_index_t),  private :: index
    type(cube_setup_output_t)          :: output
    type(cube_setup_timing_t), private :: timing
  end type cube_setup_t
  !
  ! Internal setup flags, read and written only with the public API
  type(cube_setup_t), private :: setup
  !
  ! --- Public API -----------------------------------------------------
  ! ZZZ To be done for all components. Should consider a set/get class?
  !
  ! --- OUTPUT ---------------------------------------------------------
  type :: cube_setup_output_radio2sfl_api_t
  contains
    procedure, nopass, public :: set => setup_output_radio2sfl_set
    procedure, nopass, public :: get => setup_output_radio2sfl_get
  end type cube_setup_output_radio2sfl_api_t
  !
  type :: cube_setup_output_api_t
    type(cube_setup_output_radio2sfl_api_t), public :: radio2sfl
  contains
    procedure, nopass, public :: reset => setup_output_reset
  end type cube_setup_output_api_t
  !
  ! --- TIMING ---------------------------------------------------------
  type :: cube_setup_timing_io_api_t
  contains
    procedure, nopass, public :: set => setup_timing_io_set
    procedure, nopass, public :: get => setup_timing_io_get
  end type cube_setup_timing_io_api_t
  type :: cube_setup_timing_command_api_t
  contains
    procedure, nopass, public :: set => setup_timing_command_set
    procedure, nopass, public :: get => setup_timing_command_get
  end type cube_setup_timing_command_api_t
  !
  type :: cube_setup_timing_api_t
    type(cube_setup_timing_io_api_t),      public :: io
    type(cube_setup_timing_command_api_t), public :: command
  contains
    procedure, nopass, public :: reset => setup_timing_reset
  end type cube_setup_timing_api_t
  !
  ! --- INDEX ----------------------------------------------------------
  type :: cube_setup_index_default_api_t
  contains
    procedure, nopass, public :: set => setup_index_default_set
    procedure, nopass, public :: get => setup_index_default_get
  end type cube_setup_index_default_api_t
  !
  type :: cube_setup_index_api_t
    type(cube_setup_index_default_api_t), public :: default
  contains
    procedure, nopass, public :: reset => setup_index_reset
  end type cube_setup_index_api_t
  !
  ! --- Public API -----------------------------------------------------
  type :: cube_setup_api_t
    type(cube_setup_output_api_t), public :: output
    type(cube_setup_timing_api_t), public :: timing
    type(cube_setup_index_api_t),  public :: index
  end type cube_setup_api_t
  !
contains
  !
  ! --- OUTPUT ---------------------------------------------------------
  subroutine setup_output_radio2sfl_set(val,error)
    logical, intent(in)    :: val
    logical, intent(inout) :: error
    setup%output%radio2sfl = val
  end subroutine setup_output_radio2sfl_set
  subroutine setup_output_radio2sfl_get(val)
    logical, intent(out) :: val
    val = setup%output%radio2sfl
  end subroutine setup_output_radio2sfl_get
  !
  subroutine setup_output_reset()
    type(cube_setup_output_t) :: default
    setup%output = default
  end subroutine setup_output_reset
  !
  ! --- TIMING ---------------------------------------------------------
  subroutine setup_timing_io_set(val,error)
    logical, intent(in)    :: val
    logical, intent(inout) :: error
    setup%timing%io = val
  end subroutine setup_timing_io_set
  subroutine setup_timing_io_get(val)
    logical, intent(out) :: val
    val = setup%timing%io
  end subroutine setup_timing_io_get
  !
  subroutine setup_timing_command_set(val,error)
    logical, intent(in)    :: val
    logical, intent(inout) :: error
    setup%timing%command = val
  end subroutine setup_timing_command_set
  subroutine setup_timing_command_get(val)
    logical, intent(out) :: val
    val = setup%timing%command
  end subroutine setup_timing_command_get
  !
  subroutine setup_timing_reset()
    type(cube_setup_timing_t) :: default
    setup%timing = default
  end subroutine setup_timing_reset
  !
  ! --- INDEX ----------------------------------------------------------
  subroutine setup_index_default_set(val,error)
    integer(kind=code_k), intent(in)    :: val
    logical,              intent(inout) :: error
    setup%index%default = val
  end subroutine setup_index_default_set
  subroutine setup_index_default_get(val)
    integer(kind=code_k), intent(out) :: val
    val = setup%index%default
  end subroutine setup_index_default_get
  !
  subroutine setup_index_reset()
    type(cube_setup_index_t) :: default
    setup%index = default
  end subroutine setup_index_reset
  !
end module cubetools_setup_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gr_point(n,is)
  use gildas_def
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_point
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ public
  !  Draw 1 symbol of type N, style IS and current size
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: n   ! Number of summits
  integer(kind=4), intent(in) :: is  ! Style of polygon (0-3)
  ! Local
  real(kind=4) :: cfact  ! Half the size of the symbol in centimeters
  real(kind=4) :: dtheta, theta, stellar
  real(kind=4) :: xa,ya, xb,yb, xc,yc, xmid,ymid, xn
  integer(kind=size_length) :: j,np,nn
  logical :: doclip
  integer(kind=4), parameter :: msum=256  ! Maximum number of summits per marker
  integer(kind=4), parameter :: mpts=2*msum+1  ! Maximum size of polyline to draw the marker
  ! Buffers are SAVE'd to avoid reallocation each time entering this subroutine
  real(kind=4), save :: xwork(mpts),ywork(mpts)  ! Before clipping
  real(kind=4), save :: xworu(mpts),yworu(mpts)  ! After clipping
  !
  cfact = csymb * expand * 0.5
  !
  ! Plot a single dot if CFACT=0 or if less than 2 summits
  if (n.lt.2 .or. cfact.eq.0.) then
    np = 1
    call grdots(np,xp,yp)  ! New list of points (1 point within)
    return
  endif
  nn = min(msum,n)
  !
  ! Check clipping
  xc = xp
  yc = yp
  doclip = .not.noclip
  if (doclip) then
    if (xc+cfact.lt.gx1) then
      return
    elseif (xc-cfact.gt.gx2) then
      return
    elseif (yc+cfact.lt.gy1) then
      return
    elseif (yc-cfact.gt.gy2) then
      return
    else
      !
      ! May intersect
      if (xc-cfact.ge.gx1 .and. xc+cfact.le.gx2 .and.  &
          yc-cfact.ge.gy1 .and. yc+cfact.le.gy2) then
        doclip = .false.
      endif
    endif
  endif
  !
  dtheta = 2. * pi / nn
  theta = (3*pi + dtheta)/2 + sangle*pi/180
  !
  ! Style 0 Empty polygon
  if (is.eq.0 .or. nn.eq.2) then
    xwork(1) = cfact*cos(theta) + xc
    ywork(1) = cfact*sin(theta) + yc
    np = nn+1
    do j = 2,np
      theta = theta + dtheta
      xwork(j) = cfact*cos(theta) + xc
      ywork(j) = cfact*sin(theta) + yc
    enddo
    !
    ! Style 1 Vertex connected polygon
  elseif (is.eq.1) then
    np = 2*nn+1
    xwork(1) = xc
    ywork(1) = yc
    do j=2,np,2
      xwork(j) = cfact*cos(theta) + xc
      ywork(j) = cfact*sin(theta) + yc
      xwork(j+1) = xc
      ywork(j+1) = yc
      theta = theta + dtheta
    enddo
    !
    ! Style 2 Starred polygon, 4 Filled Star
  elseif (is.eq.2 .or. is.eq.4) then
    xa = cfact*cos(theta) + xc
    ya = cfact*sin(theta) + yc
    xwork(1) = xa
    ywork(1) = ya
    stellar = .25
    np = 2*nn+1
    do j = 2,np,2
      theta = theta + dtheta
      xb = cfact*cos(theta) + xc
      yb = cfact*sin(theta) + yc
      xmid = stellar*(xa + xb - 2*xc) + xc
      ymid = stellar*(ya + yb - 2*yc) + yc
      xwork(j) = xmid
      ywork(j) = ymid
      xwork(j+1) = xb
      ywork(j+1) = yb
      xa = xb
      ya = yb
    enddo
    !
    ! Style 3 Filled polygon
  elseif (is.eq.3) then
    !
    ! For cosmetic purposes, start plotting from a point below.
    xn = (-pi/2-theta)/dtheta
    if (xn.ge.0) then
      j = int(xn)
    else
      j = -int(-xn)-1
    endif
    theta = theta + j * dtheta
    xwork(1) = cfact*cos(theta) + xc
    ywork(1) = cfact*sin(theta) + yc
    np = nn+1
    do j = 2,np
      theta = theta + dtheta
      xwork(j) = cfact*cos(theta) + xc
      ywork(j) = cfact*sin(theta) + yc
    enddo
  endif
  !
  ! 3 and 4 are filled
  if (is.ge.3) then
    np = np+1
    xwork(np) = xwork(1)
    ywork(np) = ywork(1)
    if (doclip) then
      call clip_poly(np,xwork,ywork,xworu,yworu)
      call gr_fillpoly(np,xworu,yworu)
    else
      call gr_fillpoly(np,xwork,ywork)
    endif
  else
    if (doclip) then
      call grpoly(np,xwork,ywork)
    else
      call gtreloc(xwork(1),ywork(1))
      do j=2,np
        call gtdraw(xwork(j),ywork(j))
      enddo
      gxp = xwork(np)  ! Set the pen location after the last 'gtdraw'
      gyp = ywork(np)  !
    endif
  endif
  !
  ! Reset pen location
  call grelocate(xc,yc)
end subroutine gr_point
!
subroutine clip_poly(n,x,y,xc,yc)
  use gildas_def
  use gbl_message
  use greg_interfaces, except_this=>clip_poly
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(inout) :: n      ! Number of summits (updated, may be 0 on return, may be more)
  real(kind=4),              intent(in)    :: x(:)   !
  real(kind=4),              intent(in)    :: y(:)   !
  real(kind=4),              intent(out)   :: xc(:)  !
  real(kind=4),              intent(out)   :: yc(:)  !
  ! Local
  real(kind=4) :: x0,y0,x1,y1
  integer(kind=size_length) :: i,j,m
  logical :: ok
  !
  ! The last line has a special meaning, because it must be close properly ?
  m = size(xc)
  j = 0
  ok = .false.
  i = 1
  do while (i.lt.n .and. .not.ok)
    x0 = x(i)
    y0 = y(i)
    x1 = x(i+1)
    y1 = y(i+1)
    call clip_one (x0,y0,x1,y1,ok)
    if (ok) then
      xc(1) = x0
      yc(1) = y0
      xc(2) = x1
      yc(2) = y1
      j = 2
    endif
    i = i+1
  enddo
  !
  do while (i.lt.n)
    x0 = x(i)
    y0 = y(i)
    x1 = x(i+1)
    y1 = y(i+1)
    call clip_one (x0,y0,x1,y1,ok)
    if (ok) then
      if (x0.eq.xc(j).and.y0.eq.yc(j)) then
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x1
        yc(j) = y1
      elseif (x0.eq.xc(j) .or. y0.eq.yc(j)) then
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x0
        yc(j) = y0
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x1
        yc(j) = y1
      else
        ! Complex case
        if (xc(j).eq.gx1 .or. xc(j).eq.gx2) then
          if (j.eq.m)  goto 10
          j = j+1
          xc(j) = xc(j-1)
          yc(j) = y0
        else
          if (j.eq.m)  goto 10
          j = j+1
          xc(j) = x0
          yc(j) = yc(j-1)
        endif
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x0
        yc(j) = y0
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x1
        yc(j) = y1
      endif
    endif
    i = i+1
  enddo
  !
  if (j.ne.0) then
    ! Try to close properly
    if (xc(1).ne.xc(j) .or. yc(1).ne.yc(j)) then
      if (xc(j).eq.gx1 .or. xc(j).eq.gx2) then
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = xc(j-1)
        yc(j) = yc(1)
      else
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = xc(1)
        yc(j) = yc(j-1)
      endif
      if (j.eq.m)  goto 10
      j = j+1
      xc(j) = xc(1)
      yc(j) = yc(1)
    endif
  endif
  !
  n = j  ! Update the number of points to the remaining ones.
  return
  !
10 continue
  call greg_message(seve%w,'CLIP','Clipping buffer exhausted')
  n = j  ! Update the number of points to the remaining ones.
  !
end subroutine clip_poly
!
subroutine clip_one (x0,y0,x1,y1,ok)
  use greg_interfaces, except_this=>clip_one
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real :: x0                        !
  real :: y0                        !
  real :: x1                        !
  real :: y1                        !
  logical :: ok                     !
  ! Local
  real :: x,y
  integer :: c,c0,c1
  !
  ! Change the end-points of the line (X0,Y0) - (X1,Y1)
  ! to clip the line at the window boundary.
  ! The algorithm is that of Cohen and Sutherland (ref: Newman & Sproull)
  !
  ok = .false.
  call grclip(x0,y0,c0)
  call grclip(x1,y1,c1)
  !
  do while (c0.ne.0 .or. c1.ne.0)
    if (iand(c0,c1).ne.0) then ! line is invisible
      return
    endif
    c = c0
    if (c.eq.0) c = c1
    if (iand(c,1).ne.0) then   ! crosses GX1
      y = y0 + (y1-y0)*(gx1-x0)/(x1-x0)
      x = gx1
    elseif (iand(c,2).ne.0) then   ! crosses GX2
      y = y0 + (y1-y0)*(gx2-x0)/(x1-x0)
      x = gx2
    elseif (iand(c,4).ne.0) then   ! crosses GY1
      x = x0 + (x1-x0)*(gy1-y0)/(y1-y0)
      y = gy1
    elseif (iand(c,8).ne.0) then   ! crosses GY2
      x = x0 + (x1-x0)*(gy2-y0)/(y1-y0)
      y = gy2
    endif
    if (c.eq.c0) then
      x0 = x
      y0 = y
      call grclip(x,y,c0)
    else
      x1 = x
      y1 = y
      call grclip(x,y,c1)
    endif
  enddo
  ok = .true.
end subroutine clip_one

subroutine smooth(set,line,r,t,error,user_function)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>smooth
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  ! SMOOTH [AUTO|BOX n|HANNING|GAUSS Width]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           !
  type(observation),   intent(inout) :: r,t            !
  logical,             intent(inout) :: error          !
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='SMOOTH'
  integer(kind=4) :: nx,nkey,nc
  integer(kind=4), parameter :: mvoc=4
  character(len=12) :: vocab(mvoc),method,key
  real(kind=4) :: w,space,ushift
  real(kind=8) :: hspace,hshift
  ! Data
  data vocab/'HANNING','GAUSS','BOX','NOISE'/
  !
  ! Command line parsing
  method = 'HANNING'
  call sic_ke (line,0,1,method,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,method,key,nkey,vocab,mvoc,error)
  if (error)  return
  !
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No R spectrum in memory')
    error = .true.
    return
  endif
  !
  select case (key)
  case ('HANNING')
    ! If all parameters are absent (default 0), the default engine will
    ! be used. Else use the generic one.
    w = 0.
    call sic_r4 (line,0,2,w,.false.,error)
    if (error) return
    w = abs(w/(r%datax(2)-r%datax(1)))  ! Current X unit to channels
    !
    space = 0.
    call sic_r4 (line,0,3,space,.false.,error)
    if (error) return
    space = abs(space/(r%datax(2)-r%datax(1)))  ! Current X unit to channels
    !
    ushift = 0.
    call sic_r4 (line,0,4,ushift,.false.,error)
    if (error) return
    ushift = ushift/abs(r%datax(2)-r%datax(1))  ! Current X unit to channels
    !
  case ('GAUSS')
    call sic_r4 (line,0,2,w,.true.,error)
    if (error) return
    w = w/(r%datax(2)-r%datax(1))  ! Current X unit to channels
    !
  case ('BOX')
    call sic_i4 (line,0,2,nx,.true.,error)
    if (error) return
    if (nx.lt.2) then
      call class_message(seve%e,rname,'Box width must be larger than 1')
      error = .true.
      return
    endif
    !
  case ('NOISE')
    call sic_r4 (line,0,2,w,.true.,error)
    if (error) return
    nx = (r%head%spe%nchan+1)/2
    call sic_i4 (line,0,3,nx,.false.,error)
    if (error) return
    nx = min(nx,(r%head%spe%nchan+1)/2)
    if (nx.lt.2) then
      call class_message(seve%e,rname,'Number of points out of range')
      error = .true.
      return
    endif
    !
  end select
  !
  if (key.eq.'HANNING') then
    call smhann(t%spectre,r%spectre,r%cnchan,r%cbad,w,space,ushift,error)
  elseif (key.eq.'GAUSS') then
    call smgauss(t%spectre,r%spectre,r%cnchan,r%cbad,w,error)
  elseif (key.eq.'BOX') then
    call smbox(t%spectre,r%spectre,r%cnchan,r%cbad,nx,error)
  elseif (key.eq.'NOISE') then
    call smnois(t%spectre,r%spectre,r%cnchan,nx,w,r%head%spe%bad)
  endif
  if (error)  return
  !
  ! New header parameters:
  if (key.eq.'HANNING') then
    if (w.eq.0. .and. space.eq.0.) then
      ! Default smoothing was used
      hspace = 2.d0
      hshift = 0.d0
    else
      hspace = space
      hshift = space/2.d0-0.5d0-ushift  ! Same as subroutine smhann
    endif
    if (r%head%gen%kind.eq.kind_spec) then
      r%head%spe%nchan = r%cnchan
      r%head%spe%vres = r%head%spe%vres*hspace
      r%head%spe%fres = r%head%spe%fres*hspace
      r%head%spe%rchan= (r%head%spe%rchan+hshift)/hspace
    else
      r%head%dri%npoin = r%cnchan
      r%head%dri%ares = r%head%dri%ares*hspace
      r%head%dri%rpoin = (r%head%dri%rpoin+hshift)/hspace
    endif
  elseif (key.eq.'BOX') then
    if (r%head%gen%kind.eq.kind_spec) then
      r%head%spe%nchan = r%cnchan
      r%head%spe%vres  = r%head%spe%vres*nx
      r%head%spe%fres  = r%head%spe%fres*nx
      r%head%spe%rchan = (2.d0*r%head%spe%rchan+nx-1.d0)/2.d0/nx
    else
      r%head%dri%npoin = r%cnchan
      r%head%dri%ares  = r%head%dri%ares*nx
      r%head%dri%tres  = r%head%dri%tres*nx
      r%head%dri%rpoin = (2.*r%head%dri%rpoin+nx-1.)/2/nx
    endif
  endif
  call newdat(set,r,error)
  if (error)  return
  !
  if (r%head%presec(class_sec_assoc_id)) then
    ! Also smooth Associated Arrays
    call smooth_assoc(r%assoc,key,w,space,ushift,nx,error)
    if (error) then
      call class_message(seve%w,rname,  &
        'Section Associated Array could not be smoothed. Removed.')
      r%head%presec(class_sec_assoc_id) = .false.
      call rzero_assoc(r)
      error = .false.  ! Not fatal
    endif
    call newdat_assoc(set,r,error)
    if (error)  return
  endif
  !
end subroutine smooth
!
subroutine smnois(yin,yout,ny,nx,seuil,bad)
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS
  !	Noise cheating smoothing routine
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: ny        ! Number of pixels
  real(kind=4),    intent(in)  :: yin(ny)   ! Input spectrum
  real(kind=4),    intent(out) :: yout(ny)  ! Output spectrum
  integer(kind=4), intent(in)  :: nx        ! Maximum number of pixels smoothed
  real(kind=4),    intent(in)  :: seuil     ! Smoothing threshold
  real(kind=4),    intent(in)  :: bad       ! Blanking value
  ! Local
  integer(kind=4) :: i,k,n
  real(kind=4) :: y
  !
  do i=1,ny
    if (yin(i).eq.bad) then
      y = 0.0
      n = 0
    else
      y = yin(i)
      n = 1
    endif
    k = 1
    do while(y.lt.seuil .and. k.lt.nx)
      if (i-k.ge.1) then
        if (yin(i-k).ne.bad) then
          n = n+1
          y = y+yin(i-k)
        endif
      endif
      if (i+k.le.ny) then
        if (yin(i+k).ne.bad) then
          n = n+1
          y = y+yin(i+k)
        endif
      endif
      k = k+1
    enddo
    if (n.ne.0) then
      yout(i) = y/n
    else
      yout(i) = bad
    endif
  enddo
end subroutine smnois
!
subroutine smhann_default(ty,ry,cnchan,cbad,error)
  use gildas_def
  use gbl_message
  use classcore_interfaces, except_this=>smhann_default
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   SMOOTH HANNING (no arguments)
  ! Makes a Hanning smoothing of the input data with a window width of
  ! 4 channels.
  !---------------------------------------------------------------------
  integer(kind=4), intent(inout) :: cnchan      ! Updated in return
  real(kind=4),    intent(in)    :: ty(cnchan)  !
  real(kind=4),    intent(out)   :: ry(cnchan)  !
  real(kind=4),    intent(in)    :: cbad        !
  logical,         intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='SMOOTH'
  integer(kind=4) :: j,i,w
  character(len=message_length) :: mess
  !
  j = 0
  if (cnchan.lt.5) then
    write(mess,'(A,I0,A)')  'Too few channels (',cnchan,')'
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (ty(1).ne.cbad) then
    ry(1) = ty(1)
    w = 1
  else
    ry(1) = 0.0
    w = 0
  endif
  j = 1
  do i=2,cnchan-1,2
    if (ty(i).ne.cbad) then
      ry(j) = ry(j)+2.0*ty(i)
      w = w+2
    endif
    if (ty(i+1).ne.cbad) then
      ry(j) = ry(j)+ty(i+1)
      w = w+1
      ry(j) = ry(j)/w
      j = j+1
      ry(j) = ty(i+1)
      w = 1
    elseif (w.ne.0) then
      ry(j) = ry(j)/w
      w = 0
      j = j+1
      ry(j) = 0.0
    else
      ry(j) = cbad
      j = j+1
      ry(j) = 0.0
    endif
  enddo
  cnchan = j-1
end subroutine smhann_default
!
subroutine smhann(ty,ry,cnchan,cbad,width,space,ushift,error)
  use phys_const
  use gildas_def
  use gbl_message
  use classcore_interfaces, except_this=>smhann
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   SMOOTH HANNING
  ! Makes a Hanning smoothing of the input data
  !---------------------------------------------------------------------
  integer(kind=4), intent(inout) :: cnchan      ! Updated in return
  real(kind=4),    intent(in)    :: ty(cnchan)  !
  real(kind=4),    intent(out)   :: ry(cnchan)  !
  real(kind=4),    intent(in)    :: cbad        !
  real(kind=4),    intent(in)    :: width       ! [channels] Hann window width
  real(kind=4),    intent(in)    :: space       ! [channels] Output channel spacing
  real(kind=4),    intent(in)    :: ushift      ! [channels] User custom shift
  logical,         intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='SMOOTH'
  integer(kind=4) :: ic,ochan
  real(kind=4) :: ichan,lichan,fichan,wichan,wochan,shift
  !
  if (width.eq.0. .and. space.eq.0.) then
    call smhann_default(ty,ry,cnchan,cbad,error)
    return
  endif
  !
  ! Sanity check
  if (width.le.1.) then
    call class_message(seve%e,rname,'Hanning window must be larger than 1 channel')
    error = .true.
    return
  endif
  if (space.gt.cnchan) then
    call class_message(seve%e,rname,  &
      'Output channel width is larger than the input spectrum bandwidth')
    error = .true.
    return
  endif
  !
  ! Generic relationship between the input and output grids:
  !   ochan = (ichan+shift)/space
  ! where
  ! - 'space' is the channel spacing (number input channels per output
  !   channel)
  ! - 'shift' defines the starting point of first output channel. By default,
  !   it is chosen such that the start of the input and output spectra are
  !   aligned (namely the left boundaries of first input and output channels).
  !   In the above formula this gives: 0.5 = (0.5+shift)/space
  !   User can override this default by providing a non-zero "user-shift"
  !   (in input channel units, positive means shift to the right).
  !   Beware this shift is also to be taken into account when defining the
  !   output spectral axis description.
  shift = space/2. - 0.5 - ushift
  !
  ochan = 1
  do
    ry(ochan) = 0.
    wochan = 0.
    ichan = ochan*space-shift  ! Center of output channel (floating point)
    fichan = ichan-width/2.    ! First input channel contributing to output channel
    lichan = ichan+width/2.    ! Last  input channel contributing to output channel
    if (ichan.gt.cnchan)  exit  ! Stop criterion
    do ic=max(1,ceiling(fichan)),min(cnchan,floor(lichan))
      if (ty(ic).ne.cbad) then
        wichan = 0.5-0.5*cos(2*pi*(ic-lichan)/width)
        ry(ochan) = ry(ochan)+wichan*ty(ic)
        wochan = wochan+wichan
      endif
    enddo
    if (wochan.eq.0.) then
      ry(ochan) = cbad
    else
      ry(ochan) = ry(ochan)/wochan
    endif
    ochan = ochan+1
  enddo
  cnchan = ochan-1
end subroutine smhann
!
subroutine smgauss(ty,ry,cnchan,cbad,ax,error)
  use gildas_def
  use phys_const
  use classcore_interfaces, except_this=>smgauss
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   SMOOTH GAUSS Width
  ! Makes a Gaussian smoothing of the input data
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: cnchan      !
  real(kind=4),    intent(in)    :: ty(cnchan)  !
  real(kind=4),    intent(out)   :: ry(cnchan)  !
  real(kind=4),    intent(in)    :: cbad        !
  real(kind=4),    intent(in)    :: ax          ! [channels] Input FWHM of Gaussian
  logical,         intent(inout) :: error       !
  ! Local
  complex(kind=4), allocatable :: cmpl(:), work(:)
  integer(kind=4) :: i, nxm, ier
  real(kind=4) :: val,wx,fact
  !
  allocate (cmpl(cnchan),work(cnchan),stat=ier)
  do i=1,cnchan
    if (ty(i).ne.cbad) then
      val = ty(i)
    else
      val = obs_fillin(ty,i,1,cnchan,cbad)
    endif
    cmpl(i) = cmplx(val,0.0)
  enddo
  call fourt(cmpl,cnchan,1,1,0,work)
  wx = ax*pi/(2.*sqrt(log(2.)))/cnchan
  nxm = nint(4.5/abs(wx))+1
  do i=1,cnchan/2+1
    if (i.le.nxm) then
      fact = exp ( -((i-1)*wx)**2 )
    else
      fact = 0.0
    endif
    cmpl(i) = cmpl(i)*fact
    if (cnchan-i+1.gt.i) cmpl(cnchan-i+1)= cmpl(cnchan-i+1)*fact
  enddo
  call fourt(cmpl,cnchan,1,-1,1,work)
  do i=1,cnchan
    ry(i) = real(cmpl(i))/cnchan
  enddo
  deallocate(cmpl,work)
end subroutine smgauss
!
subroutine smbox(ty,ry,cnchan,cbad,nbox,error)
  use gbl_message
  use classcore_interfaces, except_this=>smbox
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !   SMOOTH BOX Nchan
  !---------------------------------------------------------------------
  integer(kind=4), intent(inout) :: cnchan      ! Updated in return
  real(kind=4),    intent(in)    :: ty(cnchan)  !
  real(kind=4),    intent(out)   :: ry(cnchan)  !
  real(kind=4),    intent(in)    :: cbad        !
  integer(kind=4), intent(in)    :: nbox        ! Number of channels averaged
  logical,         intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='SMOOTH'
  integer(kind=4) :: i,j,np
  real(kind=4) :: w
  !
  if (cnchan.lt.2*nbox) then
    call class_message(seve%e,rname,'Too few channels (minimum 2*Nchan)')
    error = .true.
    return
  endif
  !
  np = cnchan/nbox
  do i=1,np
    ry(i) = 0.0
    w = 0
    do j=(i-1)*nbox+1,i*nbox
      if (ty(j).ne.cbad) then
        ry(i) = ry(i)+ty(j)
        w = w+1
      endif
    enddo
    if (w.ne.0) then
      ry(i) = ry(i)/w
    else
      ry(i) = cbad
    endif
  enddo
  cnchan = np
end subroutine smbox

subroutine las_variables(set,r,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>las_variables
  use class_common
  use class_index
  use class_types
  !----------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Initialisation routine
  !  Define all SIC variables
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(in)    :: r
  logical,             intent(inout) :: error
  ! Local
  integer(kind=index_length) :: dim(4)
  !
  dim = 0
  !
  call sic_def_long ('NEXT_OBS',fileout%desc%xnext,0,0,.true.,error)
  call sic_def_long ('FOUND',nindex,0,dim,.true.,error)
  if (error)  return
  !
  call class_set_structure(set,error)
  if (error) return
  !
  call las_variables_r(set,r,error)
  if (error)  return
  !
  call las_codes(error)
  if (error)  return
  !
end subroutine las_variables
!
subroutine class_set_structure(set,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Define the SIC variables which map the internal set% values.
  ! Currently only map a few values, mostly those which are scalar,
  ! i.e. unique in the SET calling sequence (e.g. SET TYPE SPECTRO).
  ! Will have to think twice for the variable name when multiple
  ! arguments are provided in the SET calling sequence (e.g. SET ALIGN
  ! VELO INTER)
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: struct='SET%LAS'
  integer(kind=index_length) :: dims(4)
  !
  dims = 0
  !
  call sic_defstructure(struct,.true.,error)
  if (error) return
  !
  ! Character strings (scalar)
  call class_setup_sicdef_angle(struct,error)
  call sic_def_char(struct//'%BAD',      set%bad,   .true.,error)
  call sic_def_char(struct//'%EXTENSION',set%defext,.true.,error)
  call sic_def_char(struct//'%FORMAT',   set%heade, .true.,error)
  call sic_def_char(struct//'%LINE',     set%line,  .true.,error)
  call sic_def_char(struct//'%SOURCE',   set%sourc, .true.,error)
  call sic_def_char(struct//'%TELESCOPE',set%teles, .true.,error)
  call sic_def_char(struct//'%WEIGHT',   set%weigh, .true.,error)
  if (error) return
  !
  ! Character strings (array)
  dims(1) = 2
  call sic_def_charn(struct//'%UNIT',set%unitx,1,dims,.true.,error)
  if (error) return
  !
  ! Integers (scalar)
  call sic_def_inte(struct//'%BASE', set%base, 0,1,.true.,error)
  call sic_def_inte(struct//'%TYPE', set%kind, 0,1,.true.,error)
  call sic_def_inte(struct//'%NWIND',set%nwind,0,1,.true.,error)
  call sic_def_inte(struct//'%NMASK',set%nmask,0,1,.true.,error)
  if (error) return
  !
  ! Reals (arrays)
  dims(1) = mwind1
  call sic_def_real(struct//'%WIND1',set%wind1,1,dims,.true.,error)
  call sic_def_real(struct//'%WIND2',set%wind2,1,dims,.true.,error)
  dims(1) = mmask1
  call sic_def_real(struct//'%MASK1',set%mask1,1,dims,.true.,error)
  call sic_def_real(struct//'%MASK2',set%mask2,1,dims,.true.,error)
  !
  ! Logical (scalar)
  call sic_def_logi(struct//'%MATCH', set%match,.true.,error)
  call sic_def_logi(struct//'%WRITE8',set%write_r8,.false.,error)
  if (error) return
  !
end subroutine class_set_structure
!
subroutine las_variables_r(set,r,error)
  use classcore_dependencies_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Define and populate the R%HEAD structure
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(observation),   intent(in)    :: r      !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: dims
  !
  ! R structure
  call sic_defstructure('R',.true.,error)
  if (error)  return
  !
  ! R header
  call sic_defstructure('R%HEAD',.true.,error)
  dims = mx_sec+1
  call sic_def_login('R%HEAD%PRESEC',r%head%presec(-mx_sec),1,dims,.true.,error)
  if (error)  return
  !
  ! R header substructures
  call las_variables_rgen('R%HEAD',r,set%varpresec(class_sec_gen_id).ne.setvar_write,error)
  call las_variables_rpos('R%HEAD',r,set%varpresec(class_sec_pos_id).ne.setvar_write,error)
  call las_variables_rspe('R%HEAD',r,set%varpresec(class_sec_spe_id).ne.setvar_write,error)
  call las_variables_rres('R%HEAD',r,set%varpresec(class_sec_res_id).ne.setvar_write,error)
  call las_variables_rbas('R%HEAD',r,set%varpresec(class_sec_bas_id).ne.setvar_write,error)
  call las_variables_rhis('R%HEAD',r,set%varpresec(class_sec_his_id).ne.setvar_write,error)
  call las_variables_rplo('R%HEAD',r,set%varpresec(class_sec_plo_id).ne.setvar_write,error)
  call las_variables_rswi('R%HEAD',r,set%varpresec(class_sec_swi_id).ne.setvar_write,error)
  call las_variables_rcal('R%HEAD',r,set%varpresec(class_sec_cal_id).ne.setvar_write,error)
  call las_variables_rsky('R%HEAD',r,set%varpresec(class_sec_sky_id).ne.setvar_write,error)
  call las_variables_rgau('R%HEAD',r,set%varpresec(class_sec_gau_id).ne.setvar_write,error)
  call las_variables_rshe('R%HEAD',r,set%varpresec(class_sec_she_id).ne.setvar_write,error)
  call las_variables_rhfs('R%HEAD',r,set%varpresec(class_sec_hfs_id).ne.setvar_write,error)
  call las_variables_rabs('R%HEAD',r,set%varpresec(class_sec_abs_id).ne.setvar_write,error)
  call las_variables_rdri('R%HEAD',r,set%varpresec(class_sec_dri_id).ne.setvar_write,error)
  call las_variables_rbea('R%HEAD',r,set%varpresec(class_sec_bea_id).ne.setvar_write,error)
  call las_variables_rpoi('R%HEAD',r,set%varpresec(class_sec_poi_id).ne.setvar_write,error)
  call las_variables_rher('R%HEAD',r,set%varpresec(class_sec_her_id).ne.setvar_write,error)
  if (error)  return
  !
  ! Also the old shortcuts
  call las_variables_r_old(r,error)
  if (error)  return
  !
end subroutine las_variables_r
!
subroutine las_variables_rgen(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%GEN'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_long(trim(str)//'%NUM',obs%head%gen%num,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%VER',obs%head%gen%ver,0,dims,ro,error)
  call sic_def_strn(trim(str)//'%TELES',obs%head%gen%teles,12,ro,error)
  call sic_def_inte(trim(str)//'%DOBS',obs%head%gen%dobs,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%DRED',obs%head%gen%dred,0,dims,ro,error)
  call sic_def_char(trim(str)//'%CDOBS',obs%head%gen%cdobs,ro,error)
  call sic_def_char(trim(str)//'%CDRED',obs%head%gen%cdred,ro,error)
  call sic_def_inte(trim(str)//'%KIND',obs%head%gen%kind,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%QUAL',obs%head%gen%qual,0,dims,ro,error)
  call sic_def_long(trim(str)//'%SCAN',obs%head%gen%scan,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%SUBSCAN',obs%head%gen%subscan,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%UT',obs%head%gen%ut,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%ST',obs%head%gen%st,0,dims,ro,error)
  call sic_def_real(trim(str)//'%AZ',obs%head%gen%az,0,dims,ro,error)
  call sic_def_real(trim(str)//'%EL',obs%head%gen%el,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TAU',obs%head%gen%tau,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TSYS',obs%head%gen%tsys,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TIME',obs%head%gen%time,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%PARANG',obs%head%gen%parang,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%YUNIT',obs%head%gen%yunit,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%XUNIT',obs%head%gen%xunit,0,dims,ro,error)
  !
end subroutine las_variables_rgen
!
subroutine las_variables_rpos(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%POS'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_strn(trim(str)//'%SOURC',obs%head%pos%sourc,12,ro,error)
  call sic_def_inte(trim(str)//'%SYSTEM',obs%head%pos%system,0,dims,ro,error)
  call sic_def_real(trim(str)//'%EQUINOX',obs%head%pos%equinox,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%PROJ',obs%head%pos%proj,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%LAM',obs%head%pos%lam,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%BET',obs%head%pos%bet,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%PROJANG',obs%head%pos%projang,0,dims,ro,error)
  call sic_def_real(trim(str)//'%LAMOF',obs%head%pos%lamof,0,dims,ro,error)
  call sic_def_real(trim(str)//'%BETOF',obs%head%pos%betof,0,dims,ro,error)
  !
end subroutine las_variables_rpos
!
subroutine las_variables_rspe(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%SPE'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_strn(trim(str)//'%LINE',obs%head%spe%line,12,ro,error)
  call sic_def_inte(trim(str)//'%NCHAN',obs%head%spe%nchan,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%RESTF',obs%head%spe%restf,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%RCHAN',obs%head%spe%rchan,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%FRES',obs%head%spe%fres,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%VRES',obs%head%spe%vres,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%VOFF',obs%head%spe%voff,0,dims,ro,error)
  call sic_def_real(trim(str)//'%BAD',obs%head%spe%bad,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%IMAGE',obs%head%spe%image,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%VTYPE',obs%head%spe%vtype,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%VCONV',obs%head%spe%vconv,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%VDIRE',obs%head%spe%vdire,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%DOPPLER',obs%head%spe%doppler,0,dims,ro,error)
  !
end subroutine las_variables_rspe
!
subroutine las_variables_rres(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims(:) = 0
  str = trim(struct)//'%RES'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_real(trim(str)//'%MAJOR', obs%head%res%major, 0,dims,ro,error)
  call sic_def_real(trim(str)//'%MINOR', obs%head%res%minor, 0,dims,ro,error)
  call sic_def_real(trim(str)//'%POSANG',obs%head%res%posang,0,dims,ro,error)
  !
end subroutine las_variables_rres
!
subroutine las_variables_rbas(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%BAS'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_inte(trim(str)//'%DEG',obs%head%bas%deg,0,dims,ro,error)
  call sic_def_real(trim(str)//'%SIGFI',obs%head%bas%sigfi,0,dims,ro,error)
  call sic_def_real(trim(str)//'%AIRE',obs%head%bas%aire,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%NWIND',obs%head%bas%nwind,0,dims,ro,error)
  dims(1) = mwind
  call sic_def_real(trim(str)//'%W1',obs%head%bas%w1,1,dims,ro,error)
  call sic_def_real(trim(str)//'%W2',obs%head%bas%w2,1,dims,ro,error)
  dims(1) = 3
  call sic_def_real(trim(str)//'%SINUS',obs%head%bas%sinus,1,dims,ro,error)
  !
end subroutine las_variables_rbas
!
subroutine las_variables_rhis(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%HIS'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_inte(trim(str)//'%NSEQ',obs%head%his%nseq,0,dims,ro,error)
  dims(1) = mseq
  call sic_def_inte(trim(str)//'%START',obs%head%his%start,1,dims,ro,error)
  call sic_def_inte(trim(str)//'%END',obs%head%his%end,1,dims,ro,error)
  !
end subroutine las_variables_rhis
!
subroutine las_variables_rplo(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%PLO'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_real(trim(str)//'%AMIN',obs%head%plo%amin,0,dims,ro,error)
  call sic_def_real(trim(str)//'%AMAX',obs%head%plo%amax,0,dims,ro,error)
  call sic_def_real(trim(str)//'%VMIN',obs%head%plo%vmin,0,dims,ro,error)
  call sic_def_real(trim(str)//'%VMAX',obs%head%plo%vmax,0,dims,ro,error)
  !
end subroutine las_variables_rplo
!
subroutine las_variables_rswi(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%FSW'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_inte(trim(str)//'%NPHAS',obs%head%swi%nphas,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%SWMOD',obs%head%swi%swmod,0,dims,ro,error)
  dims(1) = mxphas
  call sic_def_dble(trim(str)//'%DECAL',obs%head%swi%decal,1,dims,ro,error)
  call sic_def_real(trim(str)//'%DUREE',obs%head%swi%duree,1,dims,ro,error)
  call sic_def_real(trim(str)//'%POIDS',obs%head%swi%poids,1,dims,ro,error)
  call sic_def_real(trim(str)//'%LDECAL',obs%head%swi%ldecal,1,dims,ro,error)
  call sic_def_real(trim(str)//'%BDECAL',obs%head%swi%bdecal,1,dims,ro,error)
  !
end subroutine las_variables_rswi
!
subroutine las_variables_rcal(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%CAL'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_real(trim(str)//'%BEEFF',obs%head%cal%beeff,0,dims,ro,error)
  call sic_def_real(trim(str)//'%FOEFF',obs%head%cal%foeff,0,dims,ro,error)
  call sic_def_real(trim(str)//'%GAINI',obs%head%cal%gaini,0,dims,ro,error)
  call sic_def_real(trim(str)//'%H2OMM',obs%head%cal%h2omm,0,dims,ro,error)
  call sic_def_real(trim(str)//'%PAMB',obs%head%cal%pamb,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TAMB',obs%head%cal%tamb,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TATMS',obs%head%cal%tatms,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TCHOP',obs%head%cal%tchop,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TCOLD',obs%head%cal%tcold,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TAUS',obs%head%cal%taus,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TAUI',obs%head%cal%taui,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TATMI',obs%head%cal%tatmi,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TREC',obs%head%cal%trec,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%CMODE',obs%head%cal%cmode,0,dims,ro,error)
  call sic_def_real(trim(str)//'%ATFAC',obs%head%cal%atfac,0,dims,ro,error)
  call sic_def_real(trim(str)//'%ALTI',obs%head%cal%alti,0,dims,ro,error)
  dims(1) = 3
  call sic_def_real(trim(str)//'%COUNT',obs%head%cal%count,1,dims,ro,error)
  call sic_def_real(trim(str)//'%LCALOF',obs%head%cal%lcalof,0,dims,ro,error)
  call sic_def_real(trim(str)//'%BCALOF',obs%head%cal%bcalof,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%GEOLONG',obs%head%cal%geolong,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%GEOLAT',obs%head%cal%geolat,0,dims,ro,error)
  !
end subroutine las_variables_rcal
!
subroutine las_variables_rsky(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%SKY'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_dble(trim(str)//'%SREST',obs%head%sky%restf,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%SIMAG',obs%head%sky%image,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%NSKY',obs%head%sky%nsky,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%NCHOP',obs%head%sky%nchop,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%NCOLD',obs%head%sky%ncold,0,dims,ro,error)
  dims(1) = msky
  call sic_def_real(trim(str)//'%ELEV',obs%head%sky%elev,1,dims,ro,error)
  call sic_def_real(trim(str)//'%EMISS',obs%head%sky%emiss,1,dims,ro,error)
  call sic_def_real(trim(str)//'%CHOPP',obs%head%sky%chopp,1,dims,ro,error)
  call sic_def_real(trim(str)//'%COLD',obs%head%sky%cold,1,dims,ro,error)
  !
end subroutine las_variables_rsky
!
subroutine las_variables_rgau(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%GAU'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_inte(trim(str)//'%NLINE',obs%head%gau%nline,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_BASE',obs%head%gau%sigba,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_LINE',obs%head%gau%sigra,0,dims,ro,error)
  dims(1) = mgausfit
  call sic_def_real(trim(str)//'%RESULT',obs%head%gau%nfit,1,dims,ro,error)
  call sic_def_real(trim(str)//'%ERROR',obs%head%gau%nerr,1,dims,ro,error)
  if (error)  return
  !
  ! jan12 and older names:
  call sic_def_alias(trim(str)//'%SIGBA',trim(str)//'%RMS_BASE',.true.,error)
  call sic_def_alias(trim(str)//'%SIGRA',trim(str)//'%RMS_LINE',.true.,error)
  call sic_def_alias(trim(str)//'%NFIT',trim(str)//'%RESULT',.true.,error)
  call sic_def_alias(trim(str)//'%NERR',trim(str)//'%ERROR',.true.,error)
  if (error)  return
  !
end subroutine las_variables_rgau
!
subroutine las_variables_rshe(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%SHE'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_inte(trim(str)//'%NLINE',obs%head%she%nline,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_BASE',obs%head%she%sigba,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_LINE',obs%head%she%sigra,0,dims,ro,error)
  dims(1) = mshellfit
  call sic_def_real(trim(str)//'%RESULT',obs%head%she%nfit,1,dims,ro,error)
  call sic_def_real(trim(str)//'%ERROR',obs%head%she%nerr,1,dims,ro,error)
  if (error)  return
  !
  ! jan12 and older names:
  call sic_def_alias(trim(str)//'%LSHELL',trim(str)//'%NLINE',.true.,error)
  call sic_def_alias(trim(str)//'%BSHELL',trim(str)//'%RMS_BASE',.true.,error)
  call sic_def_alias(trim(str)//'%RSHELL',trim(str)//'%RMS_LINE',.true.,error)
  call sic_def_alias(trim(str)//'%NSHELL',trim(str)//'%RESULT',.true.,error)
  call sic_def_alias(trim(str)//'%ESHELL',trim(str)//'%ERROR',.true.,error)
  if (error)  return
  !
end subroutine las_variables_rshe
!
subroutine las_variables_rhfs(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str,str2
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%HFS'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_inte(trim(str)//'%NLINE',obs%head%hfs%nline,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_BASE',obs%head%hfs%sigba,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_LINE',obs%head%hfs%sigra,0,dims,ro,error)
  dims(1) = mhfsfit
  call sic_def_real(trim(str)//'%RESULT',obs%head%hfs%nfit,1,dims,ro,error)
  call sic_def_real(trim(str)//'%ERROR',obs%head%hfs%nerr,1,dims,ro,error)
  if (error)  return
  !
  ! jan12 and older names:
  str2 = trim(struct)//'%NH3'
  call sic_delvariable(str2,userreq,error)
  call sic_defstructure(str2,.true.,error)
  call sic_def_alias(trim(str2)//'%LNH3',trim(str)//'%NLINE',.true.,error)
  call sic_def_alias(trim(str2)//'%BNH3',trim(str)//'%RMS_BASE',.true.,error)
  call sic_def_alias(trim(str2)//'%RNH3',trim(str)//'%RMS_LINE',.true.,error)
  call sic_def_alias(trim(str2)//'%NNH3',trim(str)//'%RESULT',.true.,error)
  call sic_def_alias(trim(str2)//'%ENH3',trim(str)//'%ERROR',.true.,error)
  if (error)  return
  !
end subroutine las_variables_rhfs
!
subroutine las_variables_rabs(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%ABS'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_inte(trim(str)//'%NLINE',obs%head%abs%nline,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_BASE',obs%head%abs%sigba,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_LINE',obs%head%abs%sigra,0,dims,ro,error)
  dims(1) = mabsfit
  call sic_def_real(trim(str)//'%RESULT',obs%head%abs%nfit,1,dims,ro,error)
  call sic_def_real(trim(str)//'%ERROR',obs%head%abs%nerr,1,dims,ro,error)
  if (error)  return
  !
  ! jan12 and older names:
  call sic_def_alias(trim(str)//'%LABS',trim(str)//'%NLINE',.true.,error)
  call sic_def_alias(trim(str)//'%BABS',trim(str)//'%RMS_BASE',.true.,error)
  call sic_def_alias(trim(str)//'%RABS',trim(str)//'%RMS_LINE',.true.,error)
  call sic_def_alias(trim(str)//'%NABS',trim(str)//'%RESULT',.true.,error)
  call sic_def_alias(trim(str)//'%EABS',trim(str)//'%ERROR',.true.,error)
  if (error)  return
  !
end subroutine las_variables_rabs
!
subroutine las_variables_rdri(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%DRI'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_dble(trim(str)//'%FREQ',obs%head%dri%freq,0,dims,ro,error)
  call sic_def_real(trim(str)//'%WIDTH',obs%head%dri%width,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%NPOIN',obs%head%dri%npoin,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RPOIN',obs%head%dri%rpoin,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TREF',obs%head%dri%tref,0,dims,ro,error)
  call sic_def_real(trim(str)//'%AREF',obs%head%dri%aref,0,dims,ro,error)
  call sic_def_real(trim(str)//'%TRES',obs%head%dri%tres,0,dims,ro,error)
  call sic_def_real(trim(str)//'%ARES',obs%head%dri%ares,0,dims,ro,error)
  call sic_def_real(trim(str)//'%APOS',obs%head%dri%apos,0,dims,ro,error)
  call sic_def_real(trim(str)//'%CBAD',obs%head%dri%bad,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%CTYPE',obs%head%dri%ctype,0,dims,ro,error)
  call sic_def_dble(trim(str)//'%CIMAG',obs%head%dri%cimag,0,dims,ro,error)
  call sic_def_real(trim(str)//'%COLLA',obs%head%dri%colla,0,dims,ro,error)
  call sic_def_real(trim(str)//'%COLLE',obs%head%dri%colle,0,dims,ro,error)
  !
end subroutine las_variables_rdri
!
subroutine las_variables_rbea(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%BEA'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_real(trim(str)//'%CAZIM',obs%head%bea%cazim,0,dims,ro,error)
  call sic_def_real(trim(str)//'%CELEV',obs%head%bea%celev,0,dims,ro,error)
  call sic_def_real(trim(str)//'%SPACE',obs%head%bea%space,0,dims,ro,error)
  call sic_def_real(trim(str)//'%BPOS',obs%head%bea%bpos,0,dims,ro,error)
  call sic_def_inte(trim(str)//'%BTYPE',obs%head%bea%btype,0,dims,ro,error)
  !
end subroutine las_variables_rbea
!
subroutine las_variables_rpoi(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%POI'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_inte(trim(str)//'%NLINE',obs%head%poi%nline,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_BASE',obs%head%poi%sigba,0,dims,ro,error)
  call sic_def_real(trim(str)//'%RMS_LINE',obs%head%poi%sigra,0,dims,ro,error)
  dims(1) = mpoifit
  call sic_def_real(trim(str)//'%RESULT',obs%head%poi%nfit,1,dims,ro,error)
  call sic_def_real(trim(str)//'%ERROR',obs%head%poi%nerr,1,dims,ro,error)
  if (error)  return
  !
end subroutine las_variables_rpoi
!
subroutine las_variables_rher(struct,obs,ro,error)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure to be filled
  type(observation), intent(in)    :: obs     ! Observation to be mapped
  logical,           intent(in)    :: ro      ! Should the variables be RO?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  integer(kind=index_length) :: dims(4)
  character(len=20) :: str
  !
  userreq = .false.
  dims = 0
  str = trim(struct)//'%HER'
  !
  call sic_delvariable(str,userreq,error)
  !
  call sic_defstructure(str,.true.,error)
  call sic_def_long(trim(str)//'%OBSID',     obs%head%her%obsid,     0,dims,ro,error)
  call sic_def_char(trim(str)//'%INSTRUMENT',obs%head%her%instrument,       ro,error)
  call sic_def_char(trim(str)//'%PROPOSAL',  obs%head%her%proposal,         ro,error)
  call sic_def_char(trim(str)//'%AOR',       obs%head%her%aor,              ro,error)
  call sic_def_inte(trim(str)//'%OPERDAY',   obs%head%her%operday,   0,dims,ro,error)
  call sic_def_char(trim(str)//'%DATEOBS',   obs%head%her%dateobs,          ro,error)
  call sic_def_char(trim(str)//'%DATEEND',   obs%head%her%dateend,          ro,error)
  call sic_def_char(trim(str)//'%OBSMODE',   obs%head%her%obsmode,          ro,error)
  call sic_def_real(trim(str)//'%VINFO',     obs%head%her%vinfo,     0,dims,ro,error)
  call sic_def_real(trim(str)//'%ZINFO',     obs%head%her%zinfo,     0,dims,ro,error)
  call sic_def_dble(trim(str)//'%POSANGLE',  obs%head%her%posangle,  0,dims,ro,error)
  call sic_def_dble(trim(str)//'%REFLAM',    obs%head%her%reflam,    0,dims,ro,error)
  call sic_def_dble(trim(str)//'%REFBET',    obs%head%her%refbet,    0,dims,ro,error)
  call sic_def_dble(trim(str)//'%HIFAVELAM', obs%head%her%hifavelam, 0,dims,ro,error)
  call sic_def_dble(trim(str)//'%HIFAVEBET', obs%head%her%hifavebet, 0,dims,ro,error)
  call sic_def_real(trim(str)//'%ETAMB',     obs%head%her%etamb,     0,dims,ro,error)
  call sic_def_real(trim(str)//'%ETAL',      obs%head%her%etal,      0,dims,ro,error)
  call sic_def_real(trim(str)//'%ETAA',      obs%head%her%etaa,      0,dims,ro,error)
  call sic_def_real(trim(str)//'%HPBW',      obs%head%her%hpbw,      0,dims,ro,error)
  call sic_def_char(trim(str)//'%TEMPSCAL',  obs%head%her%tempscal,         ro,error)
  call sic_def_dble(trim(str)//'%LODOPAVE',  obs%head%her%lodopave,  0,dims,ro,error)
  call sic_def_real(trim(str)//'%GIM0',      obs%head%her%gim0,      0,dims,ro,error)
  call sic_def_real(trim(str)//'%GIM1',      obs%head%her%gim1,      0,dims,ro,error)
  call sic_def_real(trim(str)//'%GIM2',      obs%head%her%gim2,      0,dims,ro,error)
  call sic_def_real(trim(str)//'%GIM3',      obs%head%her%gim3,      0,dims,ro,error)
  call sic_def_real(trim(str)//'%MIXERCURH', obs%head%her%mixercurh, 0,dims,ro,error)
  call sic_def_real(trim(str)//'%MIXERCURV', obs%head%her%mixercurv, 0,dims,ro,error)
  call sic_def_char(trim(str)//'%DATEHCSS',  obs%head%her%datehcss,         ro,error)
  call sic_def_char(trim(str)//'%HCSSVER',   obs%head%her%hcssver,          ro,error)
  call sic_def_char(trim(str)//'%CALVER',    obs%head%her%calver,           ro,error)
  call sic_def_real(trim(str)//'%LEVEL',     obs%head%her%level,     0,dims,ro,error)
  !
end subroutine las_variables_rher
!
subroutine las_variables_r_old(r,error)
  use classcore_dependencies_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  (Re)define the set of old R-related variables which are always
  ! present in Class.
  !  NB: There are yet other sets of old R-related variables, section
  ! per section, defined by the command SET VARIABLE <section>. The
  ! associated names may be different again e.g. NCHAN vs CHANNELS
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: r      !
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: userreq
  !
  userreq = .false.
  call sic_delvariable('TELESCOPE',userreq,error)
  call sic_delvariable('NUMBER',userreq,error)
  call sic_delvariable('VERSION',userreq,error)
  call sic_delvariable('SCAN',userreq,error)
  call sic_delvariable('DATATYPE',userreq,error)
  call sic_delvariable('QUALITY',userreq,error)
  call sic_delvariable('UTOBS',userreq,error)
  call sic_delvariable('LSTOBS',userreq,error)
  call sic_delvariable('AZIMUTH',userreq,error)
  call sic_delvariable('ELEVATION',userreq,error)
  call sic_delvariable('TSYS',userreq,error)
  call sic_delvariable('TIME',userreq,error)
  call sic_delvariable('SUBSCAN',userreq,error)
  call sic_delvariable('SOURCE',userreq,error)
  call sic_delvariable('LAMBDA',userreq,error)
  call sic_delvariable('BETA',userreq,error)
  call sic_delvariable('OFF_LAMBDA',userreq,error)
  call sic_delvariable('OFF_BETA',userreq,error)
  call sic_delvariable('EQUINOX',userreq,error)
  call sic_delvariable('LINE',userreq,error)
  call sic_delvariable('CHANNELS',userreq,error)
  call sic_delvariable('REFERENCE',userreq,error)
  call sic_delvariable('FREQ_STEP',userreq,error)
  call sic_delvariable('VELO_STEP',userreq,error)
  call sic_delvariable('VELOCITY',userreq,error)
  call sic_delvariable('FREQUENCY',userreq,error)
  call sic_delvariable('IMAGE',userreq,error)
  call sic_delvariable('SIGMA',userreq,error)
  call sic_delvariable('AREA',userreq,error)
  call sic_delvariable('BEAM_EFF',userreq,error)
  call sic_delvariable('FORWARD_EFF',userreq,error)
  call sic_delvariable('GAIN_IMAGE',userreq,error)
  call sic_delvariable('WATER',userreq,error)
  call sic_delvariable('PRESSURE',userreq,error)
  call sic_delvariable('AMBIANT_T',userreq,error)
  call sic_delvariable('CHOPPER_T',userreq,error)
  call sic_delvariable('COLD_T',userreq,error)
  call sic_delvariable('TAU_SIGNAL',userreq,error)
  call sic_delvariable('TAU_IMAGE',userreq,error)
  call sic_delvariable('ATM_SIGNAL',userreq,error)
  call sic_delvariable('ATM_IMAGE',userreq,error)
  call sic_delvariable('BEAM_THROW',userreq,error)
  call sic_delvariable('RAPOS',userreq,error)
  call sic_delvariable('NRECORDS',userreq,error)
  error = .false.  ! Attempt to delete non-existent variables is not an error
  !
  ! Note some are read-only, others read-write
  call sic_def_strn ('TELESCOPE',r%head%gen%teles,12,.false.,error)
  call sic_def_long ('NUMBER',r%head%gen%num,0,0,.false.,error)
  call sic_def_inte ('VERSION',r%head%gen%ver,0,0,.true.,error)
  call sic_def_long ('SCAN',r%head%gen%scan,0,0,.false.,error)
  call sic_def_inte ('DATATYPE',r%head%gen%kind,0,0,.true.,error)
  call sic_def_inte ('QUALITY',r%head%gen%qual,0,0,.true.,error)
  call sic_def_dble ('UTOBS',r%head%gen%ut,0,0,.true.,error)
  call sic_def_dble ('LSTOBS',r%head%gen%st,0,0,.true.,error)
  call sic_def_real ('AZIMUTH',r%head%gen%az,0,0,.false.,error)
  call sic_def_real ('ELEVATION',r%head%gen%el,0,0,.false.,error)
  call sic_def_real ('TSYS',r%head%gen%tsys,0,0,.false.,error)
  call sic_def_real ('TIME',r%head%gen%time,0,0,.false.,error)
  call sic_def_inte ('SUBSCAN',r%head%gen%subscan,0,0,.false.,error)
  call sic_def_strn ('SOURCE',r%head%pos%sourc,12,.false.,error)
  call sic_def_dble ('LAMBDA',r%head%pos%lam,0,0,.false.,error)
  call sic_def_dble ('BETA',r%head%pos%bet,0,0,.false.,error)
  call sic_def_real ('OFF_LAMBDA',r%head%pos%rx_off,0,0,.true.,error)
  call sic_def_real ('OFF_BETA',r%head%pos%ry_off,0,0,.true.,error)
  call sic_def_real ('EQUINOX',r%head%pos%equinox,0,0,.false.,error)
  call sic_def_strn ('LINE',r%head%spe%line,12,.false.,error)
  call sic_def_inte ('CHANNELS',r%head%spe%nchan,0,0,.true.,error)
  call sic_def_dble ('REFERENCE',r%head%spe%rchan,0,0,.false.,error)
  call sic_def_dble ('FREQ_STEP',r%head%spe%fres,0,0,.false.,error)
  call sic_def_dble ('VELO_STEP',r%head%spe%vres,0,0,.false.,error)
  call sic_def_dble ('VELOCITY',r%head%spe%voff,0,0,.false.,error)
  call sic_def_dble ('FREQUENCY',r%head%spe%restf,0,0,.false.,error)
  call sic_def_dble ('IMAGE',r%head%spe%image,0,0,.false.,error)
  call sic_def_real ('SIGMA',r%head%bas%sigfi,0,0,.true.,error)
  call sic_def_real ('AREA',r%head%bas%aire,0,0,.true.,error)
  call sic_def_real ('BEAM_EFF',r%head%cal%beeff,0,0,.false.,error)
  call sic_def_real ('FORWARD_EFF',r%head%cal%foeff,0,0,.false.,error)
  call sic_def_real ('GAIN_IMAGE',r%head%cal%gaini,0,0,.false.,error)
  call sic_def_real ('WATER',r%head%cal%h2omm,0,0,.true.,error)
  call sic_def_real ('PRESSURE',r%head%cal%pamb,0,0,.true.,error)
  call sic_def_real ('AMBIANT_T',r%head%cal%tamb,0,0,.true.,error)
  call sic_def_real ('CHOPPER_T',r%head%cal%tchop,0,0,.true.,error)
  call sic_def_real ('COLD_T',r%head%cal%tcold,0,0,.true.,error)
  call sic_def_real ('TAU_SIGNAL',r%head%cal%taus,0,0,.true.,error)
  call sic_def_real ('TAU_IMAGE',r%head%cal%taui,0,0,.true.,error)
  call sic_def_real ('ATM_SIGNAL',r%head%cal%tatms,0,0,.true.,error)
  call sic_def_real ('ATM_IMAGE',r%head%cal%tatmi,0,0,.true.,error)
  call sic_def_real ('BEAM_THROW',r%head%bea%space,0,0,.false.,error)
  call sic_def_real ('RAPOS',r%head%dri%apos,0,0,.false.,error)
  call sic_def_inte ('NRECORDS',r%head%des%ndump,0,0,.true.,error)
  !
end subroutine las_variables_r_old
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine las_codes(error)
  use gkernel_interfaces
  use classcore_interfaces, except_this=>las_codes
  !---------------------------------------------------------------------
  ! @ private
  !  Define SIC variables providing the various codes used by the Class
  ! Data Format
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call sic_defstructure('CLASSCODES',.true.,error)
  if (error) return
  !
  ! Section codes
  call las_codes_sections('CLASSCODES',error)
  if (error)  return
  call sic_defstructure('CLASSCODES%SEC',.true.,error)
  if (error) return
  call las_codes_sections('CLASSCODES%SEC',error)
  if (error)  return
  !
  ! Quality of data
  call sic_defstructure('CLASSCODES%QUAL',.true.,error)
  if (error) return
  call las_codes_qual('CLASSCODES%QUAL',error)
  if (error)  return
  !
  ! Calibration mode
  call sic_defstructure('CLASSCODES%CALIB',.true.,error)
  if (error) return
  call las_codes_calmode('CLASSCODES%CALIB',error)
  if (error)  return
  !
end subroutine las_codes
!
subroutine las_codes_sections(parent,error)
  use class_parameter
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !  Define SIC variables providing the Section codes
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: parent  ! Parent structure name
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  integer(kind=4), save :: sic_gen_sec=class_sec_gen_id+mx_sec+1
  integer(kind=4), save :: sic_pos_sec=class_sec_pos_id+mx_sec+1
  integer(kind=4), save :: sic_spe_sec=class_sec_spe_id+mx_sec+1
  integer(kind=4), save :: sic_res_sec=class_sec_res_id+mx_sec+1
  integer(kind=4), save :: sic_bas_sec=class_sec_bas_id+mx_sec+1
  integer(kind=4), save :: sic_his_sec=class_sec_his_id+mx_sec+1
  integer(kind=4), save :: sic_plo_sec=class_sec_plo_id+mx_sec+1
  integer(kind=4), save :: sic_swi_sec=class_sec_swi_id+mx_sec+1
  integer(kind=4), save :: sic_cal_sec=class_sec_cal_id+mx_sec+1
  integer(kind=4), save :: sic_sky_sec=class_sec_sky_id+mx_sec+1
  integer(kind=4), save :: sic_gau_sec=class_sec_gau_id+mx_sec+1
  integer(kind=4), save :: sic_she_sec=class_sec_she_id+mx_sec+1
  integer(kind=4), save :: sic_hfs_sec=class_sec_hfs_id+mx_sec+1
  integer(kind=4), save :: sic_abs_sec=class_sec_abs_id+mx_sec+1
  integer(kind=4), save :: sic_dri_sec=class_sec_dri_id+mx_sec+1
  integer(kind=4), save :: sic_bea_sec=class_sec_bea_id+mx_sec+1
  integer(kind=4), save :: sic_poi_sec=class_sec_poi_id+mx_sec+1
  integer(kind=4), save :: sic_her_sec=class_sec_her_id+mx_sec+1
  integer(kind=4), save :: sic_user_sec=class_sec_user_id+mx_sec+1
  !
  call sic_def_inte(trim(parent)//'%GEN',sic_gen_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%POS',sic_pos_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%SPE',sic_spe_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%RES',sic_res_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%BAS',sic_bas_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%HIS',sic_his_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%PLO',sic_plo_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%FSW',sic_swi_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%CAL',sic_cal_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%SKY',sic_sky_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%GAU',sic_gau_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%SHE',sic_she_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%HFS',sic_hfs_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%ABS',sic_abs_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%DRI',sic_dri_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%BEA',sic_bea_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%POI',sic_poi_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%HER',sic_her_sec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%USER',sic_user_sec,0,0,.true.,error)
  if (error)  return
  !
end subroutine las_codes_sections
!
subroutine las_codes_qual(parent,error)
  use gkernel_interfaces
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  !  Define SIC variables providing the Quality codes
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: parent  ! Parent structure name
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  integer(kind=4), save :: sic_qual_unknown=qual_unknown
  integer(kind=4), save :: sic_qual_excellent=qual_excellent
  integer(kind=4), save :: sic_qual_good=qual_good
  integer(kind=4), save :: sic_qual_fair=qual_fair
  integer(kind=4), save :: sic_qual_average=qual_average
  integer(kind=4), save :: sic_qual_poor=qual_poor
  integer(kind=4), save :: sic_qual_bad=qual_bad
  integer(kind=4), save :: sic_qual_awful=qual_awful
  integer(kind=4), save :: sic_qual_worst=qual_worst
  integer(kind=4), save :: sic_qual_deleted=qual_deleted
  !
  call sic_def_inte(trim(parent)//'%UNKNOWN',sic_qual_unknown,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%EXCELLENT',sic_qual_excellent,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%GOOD',sic_qual_good,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%FAIR',sic_qual_fair,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%AVERAGE',sic_qual_average,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%POOR',sic_qual_poor,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%BAD',sic_qual_bad,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%AWFUL',sic_qual_awful,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%WORST',sic_qual_worst,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%DELETED',sic_qual_deleted,0,0,.true.,error)
  if (error)  return
end subroutine las_codes_qual
!
subroutine las_codes_calmode(parent,error)
  use gkernel_interfaces
  use class_calibr
  !---------------------------------------------------------------------
  ! @ private
  !  Define SIC variables providing the Calibration mode codes
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: parent  ! Parent structure name
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  integer(kind=4), save :: sic_mode_auto=mode_auto
  integer(kind=4), save :: sic_mode_trec=mode_trec
  integer(kind=4), save :: sic_mode_humi=mode_humi
  integer(kind=4), save :: sic_mode_manu=mode_manu
  !
  call sic_def_inte(trim(parent)//'%AUTO',sic_mode_auto,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%TREC',sic_mode_trec,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%HUMI',sic_mode_humi,0,0,.true.,error)
  call sic_def_inte(trim(parent)//'%MANU',sic_mode_manu,0,0,.true.,error)
  if (error)  return
end subroutine las_codes_calmode

subroutine class_dump(line,r,t,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_dump
  use class_data
  !----------------------------------------------------------------------
  ! @ public (for libclass only)
  ! CLASS Support routine for command DUMP
  ! Types the contents of an obs.
  !----------------------------------------------------------------------
  character(len=*),  intent(in)    :: line   ! Input command line
  type(observation), intent(in)    :: r,t    !
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DUMP'
  character(len=12) :: key,argum
  integer(kind=4) :: nc,nkey
  ! Keywords
  integer(kind=4), parameter :: mkeys=7
  integer(kind=4), parameter :: msections=26
  character(len=12) :: keys(mkeys),sections(msections)
  data keys /'ADDRESSES','DATA','FILE','INDEX','MEMORY','OTF','PLOT'/
  data sections /'ALL','HEADER','GENERAL','POSITION','SPECTRO','RESOLUTION',    &
    'BASELINE','ORIGIN','HISTORY','PLOT','FSWITCH','SWITCH','CALIBRATION',      &
    'CONTINUUM','BEAM','GAUSS','SHELL','NH3','ABS','DRIFT','COMMENT','SKYDIP',  &
    'SECTIONS','USER','ASSOCIATED','HERSCHEL'/
  !
  argum = ' '
  call sic_ke (line,0,1,argum,nc,.false.,error)
  if (error) return
  !
  if (nc.gt.0) then
    call sic_ambigs(rname,argum,key,nkey,keys,mkeys,error)
    if (error) return
    select case (key)
    case('FILE')  ! FILE [IN|OUT]
      call filedump(line,error)
    case('INDEX')
      call idump(error)
    case('DATA')  ! DATA [buffer]
      argum = 'R'
      call sic_ke (line,0,2,argum,nc,.false.,error)
      if (error) return
      if (argum.eq.'R') then
        call ddump(r,error)
      else if (argum.eq.'P') then
        call ddump(p,error)
      else if (argum.eq.'T') then
        call ddump(t,error)
      endif
    case('ADDRESSES')
      call adump(r,t,error)
    case('OTF')
      call odump(r,error)
    case('PLOT')
      call pdump(error)
    case('MEMORY')
      call mdump(error)
    end select
    !
  else
    ! /SECTION: identify desired header section (default: all)
    if (sic_present(1,0)) then
      call sic_ke (line,1,1,argum,nc,.false.,error)
      if (error) return
      if (nc.gt.0) then
        call sic_ambigs(rname,argum,key,nkey,sections,msections,error)
        if (error) return
      else
        key = 'ALL'
      endif
    else
      key = 'ALL'
    endif
    !
    ! 2nd argument: which buffer?
    argum = 'R'
    call sic_ke (line,0,2,argum,nc,.false.,error)
    if (error) return
    if (argum.eq.'R') then
      call rdump(r,key,error)
    else if (argum.eq.'P') then
      call rdump(p,key,error)
    else if (argum.eq.'T') then
      call rdump(t,key,error)
    endif
  endif
  !
end subroutine class_dump
!
subroutine rdump(obs,key,error)
  use gildas_def
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>rdump
  use class_common
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs    !
  character(len=*),  intent(in)    :: key    !
  logical,           intent(inout) :: error  !
  ! Local
  integer(kind=4) :: i,j
  character(len=11) :: cdobs,cdred
  !
  if (key.eq."ALL" .or. key.eq."HEADER" .or. key.eq."SECTIONS") then
     write(6,*) 'HEADER -----------------------'
     write(6,*) 'Index # ',obs%head%xnum
     write(6,*) 'Record # ',ibufobs%rstart, ', word # ',ibufobs%wstart
     call classic_entrydesc_dump(obs%desc)
     write(6,*) 'Present sections ',obs%head%presec
  endif
  !
  if (key.eq."ALL".or.key.eq."GENERAL") then
     if(obs%head%presec(class_sec_gen_id))then
        write(6,*) ' '
        write(6,*) 'GENERAL ---------------------------------------------------'
        write(6,*) 'r%head%gen%num   = ',obs%head%gen%num
        write(6,*) 'r%head%gen%ver   = ',obs%head%gen%ver
        write(6,*) 'r%head%gen%teles = ',obs%head%gen%teles
        call gag_todate(obs%head%gen%dobs,cdobs,error)
        call gag_todate(obs%head%gen%dred,cdred,error)
        write(6,*) 'r%head%gen%dobs  = ',cdobs
        write(6,*) 'r%head%gen%dred  = ',cdred
        write(6,*) 'r%head%gen%ut    = ',obs%head%gen%ut
        write(6,*) 'r%head%gen%st    = ',obs%head%gen%st
        write(6,*) 'r%head%gen%az    = ',obs%head%gen%az
        write(6,*) 'r%head%gen%el    = ',obs%head%gen%el
        write(6,*) 'r%head%gen%tau   = ',obs%head%gen%tau
        write(6,*) 'r%head%gen%tsys  = ',obs%head%gen%tsys
        write(6,*) 'r%head%gen%time  = ',obs%head%gen%time
        write(6,*) 'r%head%gen%parang= ',obs%head%gen%parang
        write(6,*) 'r%head%gen%yunit = ',obs%head%gen%yunit
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."POSITION") then
     if(obs%head%presec(class_sec_pos_id))then
        write(6,*) ' '
        write(6,*) 'POSITION ---------------------------------------------------'
        write(6,*) 'r%head%pos%sourc   = ',obs%head%pos%sourc
        write(6,*) 'r%head%pos%system  = ',obs%head%Pos%system
        write(6,*) 'r%head%pos%equinox = ',obs%head%Pos%equinox
        write(6,*) 'r%head%pos%proj    = ',obs%head%Pos%proj
        write(6,*) 'r%head%pos%lam     = ',obs%head%Pos%lam
        write(6,*) 'r%head%pos%bet     = ',obs%head%Pos%bet
        write(6,*) 'r%head%pos%projang = ',obs%head%Pos%projang
        write(6,*) 'r%head%pos%lamof   = ',obs%head%Pos%lamof
        write(6,*) 'r%head%pos%betof   = ',obs%head%Pos%betof
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."SPECTRO") then
     if(obs%head%presec(class_sec_spe_id))then
        write(6,*) ' '
        write(6,*) 'SPECTROSCOPY (for spectra) --------------------------------'
        write(6,*) 'r%head%spe%line    = "',obs%head%Spe%line,'"'
        write(6,*) 'r%head%spe%restf   = ', obs%head%spe%restf
        write(6,*) 'r%head%spe%image   = ', obs%head%spe%image
        write(6,*) 'r%head%spe%nchan   = ', obs%head%spe%nchan
        write(6,*) 'r%head%spe%rchan   = ',obs%head%Spe%rchan
        write(6,*) 'r%head%spe%doppler = ', obs%head%spe%doppler
        if (obs%head%spe%doppler.ne.-1.d0) then
          write(6,*) 'r%head%spe%fres    = ', obs%head%spe%fres, ' (obs.), ',  &
            obs%head%spe%fres/(1.d0+obs%head%spe%doppler),' (rest)'
        else
          write(6,*) 'r%head%spe%fres    = ', obs%head%spe%fres
        endif
        write(6,*) 'r%head%spe%vres    = ', obs%head%spe%vres
        write(6,*) 'r%head%spe%voff    = ',obs%head%Spe%voff
        write(6,*) 'r%head%spe%bad     = ', obs%head%spe%bad
        write(6,*) 'r%head%spe%vtype   = ', obs%head%Spe%vtype
        write(6,*) 'r%head%spe%vconv   = ',obs%head%Spe%vconv
        write(6,*) 'r%head%spe%vdire   = ',obs%head%Spe%vdire
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."RESOLUTION") then
     if(obs%head%presec(class_sec_res_id))then
        write(6,*) ' '
        write(6,*) 'RESOLUTION -------------------------------------------------'
        write(6,*) 'r%head%res%major  = ',obs%head%res%major
        write(6,*) 'r%head%res%minor  = ',obs%head%res%minor
        write(6,*) 'r%head%res%posang = ',obs%head%res%posang
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."BASELINE") then
     if(obs%head%presec(class_sec_bas_id))then
        write(6,*) ' '
        write(6,*) 'BASELINE (for spectra of drifts) --------------------------'
        write(6,*) 'r%head%bas%deg   = ',obs%head%Bas%deg
        write(6,*) 'r%head%bas%sigfi = ',obs%head%Bas%sigfi
        write(6,*) 'r%head%bas%aire  = ',obs%head%Bas%aire
        write(6,*) 'r%head%bas%nwind = ',obs%head%Bas%nwind
        if (obs%head%bas%nwind.gt.0 .and. obs%head%bas%nwind.lt.10) then
           write(6,*) 'r%head%bas%w1    = ',(obs%head%Bas%w1(j),j=1,obs%head%Bas%nwind)
           write(6,*) 'r%head%bas%w2    = ',(obs%head%Bas%w2(j),j=1,obs%head%Bas%nwind)
        endif
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."HISTORY") then  ! Origin
     if(obs%head%presec(class_sec_his_id))then
        write(6,*) ' '
        write(6,*) 'HISTORY ---------------------------------------------------'
        write(6,*) 'r%head%his%nseq  = ',obs%head%His%nseq
        if (obs%head%his%nseq.gt.0 .and. obs%head%his%nseq.lt.20) then
           write(6,*) 'r%head%his%start = ',(obs%head%His%start(j),j=1,obs%head%His%nseq)
           write(6,*) 'r%head%his%end   = ',(obs%head%His%end(j),j=1,obs%head%His%nseq)
        endif
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."PLOT") then
     if(obs%head%presec(class_sec_plo_id))then
        write(6,*) ' '
        write(6,*) 'PLOT Default plotting limits ------------------------------'
        write(6,*) 'r%head%plo%amin = ',obs%head%Plo%amin
        write(6,*) 'r%head%plo%amax = ',obs%head%Plo%amax
        write(6,*) 'r%head%plo%vmin = ',obs%head%Plo%vmin
        write(6,*) 'r%head%plo%vmax = ',obs%head%Plo%vmax
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."FSWITCH".or.key.eq."SWITCH") then
     if(obs%head%presec(class_sec_swi_id))then
        write(6,*) ' '
        write(6,*)  'FSWITCH (for spectra) ------------------------------------'
        write(6,*)  'r%head%fsw%nphas  = ',obs%head%swi%nphas
        write(6,*)  'r%head%fsw%swmod  = ',obs%head%swi%swmod
        write(6,*)  'r%head%fsw%decal  = ',(obs%head%swi%decal(i),i=1,obs%head%swi%nphas)
        write(6,*)  'r%head%fsw%duree  = ',(obs%head%swi%duree(i),i=1,obs%head%swi%nphas)
        write(6,*)  'r%head%fsw%poids  = ',(obs%head%swi%poids(i),i=1,obs%head%swi%nphas)
        write(6,*)  'r%head%fsw%ldecal = ',(obs%head%swi%ldecal(i),i=1,obs%head%swi%nphas)
        write(6,*)  'r%head%fsw%bdecal = ',(obs%head%swi%bdecal(i),i=1,obs%head%swi%nphas)
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."CALIBRATION") then
     if(obs%head%presec(class_sec_cal_id))then
        write(6,*) ' '
        write(6,*)  'CALIBRATION ----------------------------------------------'
        write(6,*)  'r%head%cal%beeff    = ',obs%head%cal%beeff
        write(6,*)  'r%head%cal%foeff    = ',obs%head%cal%foeff
        write(6,*)  'r%head%cal%gaini    = ',obs%head%cal%gaini
        write(6,*)  'r%head%cal%h2omm    = ',obs%head%cal%h2omm
        write(6,*)  'r%head%cal%pamb     = ',obs%head%cal%pamb
        write(6,*)  'r%head%cal%tamb     = ',obs%head%cal%tamb
        write(6,*)  'r%head%cal%tatms    = ',obs%head%cal%tatms
        write(6,*)  'r%head%cal%tchop    = ',obs%head%cal%tchop
        write(6,*)  'r%head%cal%tcold    = ',obs%head%cal%tcold
        write(6,*)  'r%head%cal%taus     = ',obs%head%cal%taus
        write(6,*)  'r%head%cal%taui     = ',obs%head%cal%taui
        write(6,*)  'r%head%cal%tatmi    = ',obs%head%cal%tatmi
        write(6,*)  'r%head%cal%trec     = ',obs%head%cal%trec
        write(6,*)  'r%head%cal%cmode    = ',obs%head%cal%cmode
        write(6,*)  'r%head%cal%atfac    = ',obs%head%cal%atfac
        write(6,*)  'r%head%cal%alti     = ',obs%head%cal%alti
        write(6,*)  'r%head%cal%count(:) = ',obs%head%cal%count(:)
        write(6,*)  'r%head%cal%lcalof   = ',obs%head%cal%lcalof
        write(6,*)  'r%head%cal%bcalof   = ',obs%head%cal%bcalof
        write(6,*)  'r%head%cal%geolong  = ',obs%head%cal%geolong
        write(6,*)  'r%head%cal%geolat   = ',obs%head%cal%geolat
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."CONTINUUM") then
     if(obs%head%presec(class_sec_dri_id))then
        write(6,*) ' '
        write(6,*) 'CONTINUUM Double gaussian  (for drifts) -------------------'
        write(6,*) 'Observing Frequency ',obs%head%Dri%freq,obs%head%Dri%cimag
        write(6,*) 'Frequency Bandwidth ', obs%head%Dri%width
        write(6,*) 'Reference channel ',obs%head%Dri%rpoin
        write(6,*) 'Time at reference channel ', obs%head%Dri%tref
        write(6,*) 'Angle at reference channel ', obs%head%Dri%aref
        write(6,*) 'Position angle of the drift ', obs%head%Dri%apos
        write(6,*) 'Time Resolution (s) ', obs%head%Dri%tres
        write(6,*) 'Angular resolution (radian) ', obs%head%Dri%ares
        write(6,*) 'Blanking value ', obs%head%Dri%bad
        write(6,*) 'Number of data points ',obs%head%Dri%npoin
        write(6,*) 'Type of offsets ', obs%head%Dri%ctype
        write(6,*) 'Collimations ', obs%head%Dri%colla,obs%head%Dri%colle
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."BEAM") then  ! Beam-switch
     if(obs%head%presec(class_sec_bea_id))then
        write(6,*) ' '
        write(6,*)  'BEAM (for spectra or drifts) -----------------------------'
        write(6,*) 'Azimuth of observing (rad) ', obs%head%Bea%cazim
        write(6,*) 'Elevation of observing (rad) ', obs%head%Bea%celev
        write(6,*) 'Angular offset of reference beam ',obs%head%Bea%space
        write(6,*) 'Position angle of reference beam ', obs%head%Bea%bpos
        write(6,*) 'Coordinate system for RBPOS ', obs%head%Bea%btype
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."GAUSS") then
     if(obs%head%presec(class_sec_gau_id))then
        write(6,*) ' '
        write(6,*)  'GAUSS METHOD FIT RESULTS ---------------------------------'
        write(6,*) 'Number of components',obs%head%Gau%nline   ! Number of components
        write(6,*) 'Sigma on base', obs%head%Gau%sigba ! Sigma on base
        write(6,*) 'Sigma on line', obs%head%Gau%sigra
        write(6,*) 'Fit results', obs%head%Gau%nfit
        write(6,*) 'Fit errors', obs%head%Gau%nerr
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."SHELL") then
     if(obs%head%presec(class_sec_she_id))then
        write(6,*) ' '
        write(6,*)  'SHELL METHOD FIT RESULTS ---------------------------------'
        write(6,*) 'Number of components',obs%head%She%nline   ! Number of components
        write(6,*) 'Sigma on base', obs%head%She%sigba ! Sigma on base
        write(6,*) 'Sigma on line', obs%head%She%sigra
        write(6,*) 'Fit results', obs%head%She%nfit
        write(6,*) 'Fit errors', obs%head%She%nerr
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."NH3") then
     if(obs%head%presec(class_sec_hfs_id))then
        write(6,*) ' '
        write(6,*)  'NH3 METHOD FIT RESULTS -----------------------------------'
        write(6,*) 'Number of components',obs%head%Hfs%nline   ! Number of components
        write(6,*) 'Sigma on base', obs%head%Hfs%sigba ! Sigma on base
        write(6,*) 'Sigma on line', obs%head%Hfs%sigra
        write(6,*) 'Fit results', obs%head%Hfs%nfit
        write(6,*) 'Fit errors', obs%head%Hfs%nerr
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."ABS") then
     if(obs%head%presec(class_sec_abs_id))then
        write(6,*) ' '
        write(6,*)  'ABSORPTION METHOD FIT RESULTS ----------------------------'
        write(6,*) 'Number of components', obs%head%Abs%nline ! Number of components
        write(6,*) 'Sigma on base       ', obs%head%Abs%sigba ! Sigma on base
        write(6,*) 'Sigma on line       ', obs%head%Abs%sigra
        write(6,*) 'Fit results         ', obs%head%Abs%nfit
        write(6,*) 'Fit errors          ', obs%head%Abs%nerr
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."DRIFT") then
     if(obs%head%presec(class_sec_poi_id))then
        write(6,*) ' '
        write(6,*)  'CONTINUUM DRIFT FIT RESULTS ------------------------------'
        write(6,*) 'Number of components ', obs%head%poi%nline
        write (6,*) 'rms on Baseline and line ', obs%head%poi%sigba, obs%head%poi%sigra
        write (6,*) 'fit results ',obs%head%poi%nfit
        write (6,*) 'fit errors ',obs%head%poi%nerr
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."COMMENT") then
     if(obs%head%presec(class_sec_com_id))then
        write(6,*) ' '
        write(6,*) 'COMMENT  --------------------------------------------------'
        do i = 1,obs%head%com%ltext,76
           write(6,'(1X,A)') obs%head%com%ctext(i:min(i+75,obs%head%com%ltext))
        enddo
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."SKYDIP") then
     if(obs%head%presec(class_sec_sky_id))then
        write(6,*) ' '
        write(6,*) 'SKYDIP ----------------------------------------------------'
        write(6,*) 'Number of points on sky ',obs%head%sky%nsky
        write(6,*) 'Number of points on sky ',obs%head%sky%nchop
        write(6,*) 'Number of points on sky ',obs%head%sky%ncold
        write(6,*) 'Elevations ', obs%head%sky%elev(1:obs%head%sky%nsky)
        write(6,*) 'Power on sky ',obs%head%sky%emiss(1:obs%head%sky%nsky)
        write(6,*) 'Power on chopper ',obs%head%sky%chopp(1:obs%head%sky%nchop)
        write(6,*) 'Power on cold load ',obs%head%sky%cold(1:obs%head%sky%ncold)
     endif
  endif
  !
  if (key.eq."ALL".or.key.eq."XCOORDINATE") then
     if(obs%head%presec(class_sec_xcoo_id))then
        write(6,*) ' '
        write(6,*) 'X COORDINATES ---------------------------------------------'
        write(6,*) 'X unit ',obs%head%gen%xunit
        write(6,*) 'DATAX should be in RX'
     endif
  endif
  !
  if (key.eq."ALL" .or. key.eq."DESCRIPTOR") then
     if (obs%head%presec(class_sec_desc_id))then
        write(6,*) ' '
        write(6,*) 'DATA DESCRIPTOR -------------------------------------------'
        write(6,*) 'Number of dumps ',obs%head%des%ndump
        write(6,*) 'Length of one dump ',obs%head%des%ldump
        write(6,*) 'Length of dump header ',obs%head%des%ldpar
        write(6,*) 'Length of dump data ', obs%head%des%ldatl
     elseif (key.eq."DESCRIPTOR") then
        write(6,*) ' '
        write(6,*) 'NO DATA DESCRIPTOR ---------------------------'
        write(6,*) 'Number of dumps ',obs%head%des%ndump
        write(6,*) 'Length of one dump ',obs%head%des%ldump
     endif
  endif
  !
  if (key.eq."ALL" .or. key.eq."USER") then  ! User Section
     if (obs%head%presec(class_sec_user_id))then
        write(6,*) ' '
        write(6,*) 'USER ------------------------------------------------------'
        call user_sec_dump(obs,error)
        if (error)  return
     elseif (key.eq.'USER') then
        write(6,*) ' '
        write(6,*) 'NO USER SECTION -------------------------------------------'
     endif
  endif
  !
  if (key.eq."ALL" .or. key.eq."HERSCHEL") then  ! Herschel-HIFI section
     if (obs%head%presec(class_sec_her_id))then
        write(6,*) ' '
        write(6,*) 'HERSCHEL --------------------------------------------------'
        write(6,11) 'Observation id',obs%head%her%obsid
        write(6,10) 'Instrument, proposal',obs%head%her%instrument,obs%head%her%proposal
        write(6,10) 'Astronomical Obs. Request',obs%head%her%aor
        write(6,11) 'Operational day number',obs%head%her%operday
        write(6,10) 'Date of observation',obs%head%her%dateobs
        write(6,10) 'End of observation',obs%head%her%dateend
        write(6,10) 'Observing mode',obs%head%her%obsmode
        write(6,12) 'Informative source LSR vel.',obs%head%her%vinfo
        write(6,12) 'Informative target redshift',obs%head%her%zinfo
        write(6,13) 'Spacecraft pointing pos. angle', obs%head%her%posangle
        write(6,13) 'Sky reference (a.k.a. OFF)', obs%head%her%reflam, obs%head%her%refbet
        write(6,13) 'ON average H and V coordinate (HIFI)',obs%head%her%hifavelam, obs%head%her%hifavebet
        write(6,12) 'MB and forward effic. used',obs%head%her%etamb, obs%head%her%etal
        write(6,10) 'Temperature scale',obs%head%her%tempscal
        write(6,13) 'Average LO freq Doppler corrected',obs%head%her%lodopave
        write(6,12) 'Sideband gain polynom. coeffs',obs%head%her%gim0, obs%head%her%gim1,obs%head%her%gim2, obs%head%her%gim3
        write(6,12) 'Calibr. mixer junction current',obs%head%her%mixercurh, obs%head%her%mixercurv
        write(6,10) 'Processing date',obs%head%her%datehcss
        write(6,10) 'HCSS and calibration versions',obs%head%her%hcssver, obs%head%her%calver
        write(6,12) 'Pipeline level',obs%head%her%level
     endif
  endif
  !
  if (key.eq."ALL" .or. key.eq."ASSOCIATED") then  ! Associated arrays
     if (obs%head%presec(class_sec_assoc_id)) then
        write(6,*) ' '
        write(6,*) 'ASSOCIATED ARRAYS -----------------------------------------'
        call class_assoc_dump(obs,error)
        if (error)  return
     elseif (key.eq.'ASSOCIATED') then
        write(6,*) ' '
        write(6,*) 'NO ASSOCIATED ARRAY ---------------------------------------'
     endif
  endif
  !
10 format(1X,A,T32,' = ',2A)
11 format(1X,A,T32,' = ',I0)
12 format(1X,A,T32,' = ',4(1PG14.7,1X))
13 format(1X,A,T32,' = ',4(1PG25.18,1X))
  !
end subroutine rdump
!
subroutine adump(r,t,error)
  use gildas_def
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Dump addresses
  !----------------------------------------------------------------------
  type(observation), intent(in)    :: r,t
  logical,           intent(inout) :: error
  !
  write(6,*) 'ADDRESSES --------------------------'
  call aadump('R',r)
  call aadump('T',t)
end subroutine adump
!
subroutine aadump(chain,r)
  use gildas_def
  use gkernel_interfaces
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Dump addresses
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: chain
  type (OBSERVATION), intent(in) :: r
  !
  write(6,*) 'Addresses X & W',chain,locwrd(r%datax(1)), locwrd(r%dataw(1))
  write(6,*) 'Addresses 1 & 2 ',chain,locwrd(r%data1(1)), locwrd(r%data2(1,1))
end subroutine aadump
!
subroutine odump(r,error)
  use gildas_def
  use class_types
  use gbl_constant
  !----------------------------------------------------------------------
  ! @ private
  ! Dump OTF
  !----------------------------------------------------------------------
  type (OBSERVATION), intent(in) :: r
  logical, intent(out) :: error
  !
  integer i
  !
  error = .false.
  if (associated(r%dap)) then
     do i=1,r%head%des%ndump
        print *,i,r%dap(i)%lamof,r%dap(i)%betof
     enddo
  else
     print *,'Not an OTF'
  endif
end subroutine odump
!
subroutine ddump(r,error)
  use gildas_def
  use class_types
  use gbl_constant
  !----------------------------------------------------------------------
  ! @ private
  ! Dump data
  !----------------------------------------------------------------------
  type (OBSERVATION), intent(in) :: r
  logical, intent(out) :: error
  !
  integer j,ndata
  !
  error = .false.
  write(6,*) 'DATA -------------------------------'
  if (r%head%gen%kind.eq.kind_spec) then
     ndata = r%head%spe%nchan
  else
     ndata = r%head%dri%npoin
  endif
  write(6,*) 'ndata = ',ndata,'   data = '
  write(6,1005) (r%spectre(j),j=1,ndata)
1005 format(8(1pg10.2))
end subroutine ddump
!
subroutine idump(error)
  use classic_api
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Dump INDEX
  !----------------------------------------------------------------------
  logical, intent(out) :: error
  ! Local
  integer(kind=entry_length) :: i
  !
  error = .false.
  write(6,*) 'INDEX --------------------------'
  write(6,'(A,I0,A)') 'Input file index (ixnext=',ix%next,'):'
  write(6,'(5(A12))') 'Entry num','Obs. num','Obs. ver','Record','Word'
  do i=1,ix%next-1
     write(6,'(5(I12))') i,ix%num(i),ix%ver(i),ix%bloc(i),ix%word(i)
  enddo
  write(6,*) ' '
  write(6,'(A,I0,A)') 'Output file index (oxnext=',ox%next,'):'
  write(6,'(5(A12))') 'Entry num','Obs. num','Obs. ver','Record','Word'
  do i=1,ox%next-1
     write(6,'(5(I12))') i,ox%num(i),ox%ver(i),ox%bloc(i),ox%word(i)
  enddo
  write(6,*) ' '
  write(6,'(A,I0,A)') 'Current index (cxnext=',cx%next,'):'
  write(6,'(5(A12))') 'Entry num','Obs. num','Obs. ver','Record','Word'
  do i=1,cx%next-1
     write(6,'(5(I12))') cx%ind(i),cx%num(i),cx%ver(i),cx%bloc(i),cx%word(i)
  enddo
end subroutine idump
!
subroutine filedump(line,error)
  use gkernel_interfaces
  use classcore_interfaces, except_this=>filedump
  use class_common
  !----------------------------------------------------------------------
  ! @ private
  ! Dump FILE [IN|OUT]
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='DUMP'
  character(len=12) :: argum,found
  integer(kind=4) :: nc,nf
  integer(kind=4), parameter :: nwhat=2
  character(len=12) :: what(nwhat)
  data what /'IN','OUT'/
  !
  write(6,*) 'FILE ---------------------------'
  !
  if (sic_present(0,2)) then
    call sic_ke (line,0,2,argum,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,argum,found,nf,what,nwhat,error)
    if (error)  return
    if (nf.eq.1) then
      call filedump_one(filein,'i',error)
    else
      call filedump_one(fileout,'o',error)
    endif
  else
    call filedump_one(filein,'i',error)
    call filedump_one(fileout,'o',error)
  endif
  !
end subroutine filedump
!
subroutine filedump_one(file,name,error)
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>filedump_one
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file   !
  character(len=*),     intent(in)    :: name   ! The File name (some prefix)
  logical,              intent(inout) :: error  !
  ! Local
  integer(kind=4) :: lind_unused
  !
  write(6,*) trim(name)//'lun = ',file%lun
  if (file%lun.eq.0) return
  !
  write(6,*) file%spec(1:file%nspec)
  call classic_filedesc_dump(file%desc,name)
  !
  if (file%desc%vind.eq.vind_v1) then
    lind_unused = lind_unused_v1
  else
    lind_unused = lind_unused_v2
  endif
  call classic_file_loss(file,lind_unused,error)
  if (error)  return
  !
end subroutine filedump_one
!
subroutine pdump(error)
  use plot_formula
  !----------------------------------------------------------------------
  ! @ private
  ! Dump PLOT
  !----------------------------------------------------------------------
  logical, intent(out) :: error
  error = .false.
  !
  print *,'GC ',GCX, GCX1, GCX2
  print *,'GV ',GVX, GVX1, GVX2
  print *,'GF ',GFX, GFX1, GFX2, GFXO
  print *,'GI ',GIX, GIX1, GIX2, GIXO
  print *,'GU ',GUX, GUX1, GUX2
  print *,'GY ',GUY, GUY1, GUY2
  print *,'GZ ',GUZ, GUZ1, GUZ2
end subroutine pdump
!
subroutine mdump(error)
  use gbl_message
  use classcore_interfaces, except_this=>mdump
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Display the memory usage of the various Class buffers. For
  ! debugging purpose
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DUMP'
  character(len=message_length) :: mess
  integer(kind=8) :: sizetot
  !
  sizetot = 0
  !
  ! --- Indexes --------------------------------------------------------
  if (associated(ix%num)) then
    write(mess,101)  &
      'IX','allocated for ',size(ix%num,kind=8),' entries (',ix%mobs,  &
      ' used)',24*4*size(ix%num,kind=8)/1024./1024.
    sizetot = sizetot+24*4*size(ix%num,kind=8)
  else
    write(mess,101)  'IX','not allocated'
  endif
  call class_message(seve%r,rname,mess)
  !
  if (associated(cx%num)) then
    write(mess,101)  &
      'CX','allocated for ',size(cx%num,kind=8),' entries (',cx%next-1,  &
      ' used)',24*4*size(cx%num,kind=8)/1024./1024.
    sizetot = sizetot+24*4*size(cx%num,kind=8)
  else
    write(mess,101)  'CX','not allocated'
  endif
  call class_message(seve%r,rname,mess)
  !
  if (associated(ox%num)) then
    write(mess,101)  &
      'OX','allocated for ',size(ox%num,kind=8),' entries (',ox%mobs,  &
      ' used)',9*4*size(ox%num,kind=8)/1024./1024.
    sizetot = sizetot+9*4*size(ox%num,kind=8)
  else
    write(mess,101)  'OX','not allocated'
  endif
  call class_message(seve%r,rname,mess)
  !
  ! --- Total ----------------------------------------------------------
  write(mess,103)  'TOTAL',sizetot/1024./1024.
  call class_message(seve%r,rname,mess)
  !
101 format(A,T14,': ',A,I0,A,I0,A,T64,F9.1,' MB')
103 format(A,T14,': ',            T64,F9.1,' MB')
end subroutine mdump

subroutine to_uvfits(fits,check,error)
  use gildas_def
  use gbl_message
  use image_def
  use gio_dependencies_interfaces, no_interface=>gr8_trie_i4
  use gio_interfaces, except_this=>to_uvfits
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! FITS        Internal routine.
  !     Write current UV data on tape.
  !---------------------------------------------------------------------
  type(gildas), intent(in)  :: fits   !
  logical,      intent(in)  :: check  ! Verbose flag
  logical,      intent(out) :: error  ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='TO_UVFITS'
  integer(kind=address_length) :: k, kd, l
  integer :: ndata, iv
  real :: rmin, rmax, umin, umax, vmin, vmax, wmin, wmax, pmax, ps
  real :: jmin
  ! To sort visibilities versus time (to build fits file for aips++)
  integer(kind=size_length) :: length
  integer ::   ier
  logical ::   error_sort
  integer(kind=address_length) :: addr,ip_work,ip_key
  real ::      maxbas, diam
  integer ::   maxa
  character(len=message_length) :: mess
  character(len=8) :: telescop
  !
  error = .false.
  length = 0
  ! Code:
  !
  pmax = -1.e37
  ps = 1.
  rmax = -1.e37
  umin = +1.e37
  umax = -1.e37
  vmin = +1.e37
  vmax = -1.e37
  jmin = 100000
  maxa   = 2                   ! minimum number of antenna
  !
  ! Loop on visibility points
  kd = gag_pointer(fits%loca%addr,memory)
  ndata = fits%gil%nchan * fits%gil%nstokes
  do iv=1, fits%gil%dim(2)
    l = kd + 6
    k = kd + 7
    call swap_antenna(memory(kd),memory(k),ndata)
    call maxdaps(memory(kd),umin,umax,vmin,vmax,jmin)
    call maxvis(memory(k),ndata,rmax,pmax,fits%gil%bval)
    call maxant(memory(l),maxa)
    kd = kd + fits%gil%dim(1)
  enddo
  wmin= -1
  wmax= +1
  write(mess,*) 'Extremum : ', rmax
  call gio_message(seve%i,rname,mess)
  write(mess,*) 'Maximum weight : ',pmax
  call gio_message(seve%i,rname,mess)
  write(mess,*) 'Extrema : ',umin,umax,vmin,vmax
  call gio_message(seve%i,rname,mess)
  rmin = -rmax
  ps = rmax/pmax
  write(mess,*) 'Weight Scale ',ps
  call gio_message(seve%i,rname,mess)
  !
  ! Write header
  if (fits%gil%nteles.gt.0) then
    telescop = fits%gil%teles(1)%ctele
    diam     = fits%gil%teles(1)%diam
  elseif (fits%gil%version_uv.ge.code_version_uvt_syst) then
    telescop = 'NOEMA'
    diam = 15.0
  else
    telescop = 'IRAM PDB'
    diam = 15.0
  endif
  call wr_fitshead(fits,rmin,rmax,umin,umax,vmin,vmax,wmin,wmax, &
                   jmin,ps,telescop,check,error)
  if (error) return
  maxbas = maxa*257             ! Allow MAXA antennas
  !
  ! Order data according to time (if AIPS style)
  if (a_style.eq.code_fits_aips.and.sort) then
    length = (2+fits%gil%dim(1))*fits%gil%dim(2)
    ier = sic_getvm(length,addr)
    if (ier.ne.1) then
      call gio_message(seve%e,rname,'Memory allocation failure')
      error = .true.
      return
    endif
    ip_key  = gag_pointer(addr,memory)
    ip_work = ip_key+2*fits%gil%dim(2)
    kd = gag_pointer(fits%loca%addr,memory)
    do iv=0,2*(fits%gil%dim(2)-1),2
      call compute_time(memory(kd),memory(ip_work+iv),jmin,maxbas)
      kd = kd + fits%gil%dim(1)
    enddo
    !
    call gr8_trie_i4(memory(ip_work),memory(ip_key),fits%gil%dim(2),error_sort)
    kd = gag_pointer(fits%loca%addr,memory)
    call sort_visi(memory(kd),memory(ip_work),memory(ip_key), &
      & fits%gil%dim(1),fits%gil%dim(2))
    !
    kd = ip_work
  else
    kd = gag_pointer(fits%loca%addr,memory)
  endif
  !
  ! Loop to write the visibilities
  fd%nb = 0
  do iv=1, fits%gil%dim(2)
    k = kd + 7
    call write_visi (memory(kd),memory(k),ndata,jmin,ps,error)
    if (error) goto 99
    kd = kd + fits%gil%dim(1)
  enddo
  call fitreal_end(fd,error)
  if (error) goto 99
  !
  ! Write special extension for aips++
  if (a_style.eq.code_fits_aips) then
    write(mess,*) 'Number of antennas : ',maxa
    call gio_message(seve%i,rname,mess)
    call gio_message(seve%i,rname,'AIPS style')
    call write_antenna_extension(telescop,diam,maxa,check,error)
  endif
  call fitreal_end(fd,error)
  if (length.ne.0) call free_vm(length,addr)
  return
  !
99 error = .true.
  if (length.ne.0) call free_vm(length,addr)
  return
end subroutine to_uvfits
!
subroutine swap_antenna(daps,visi,ndata)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Swap antenna if necessary: AIPS and MIRIAD are expecting a1<a2.
  ! This may not be the case if the UV table has been sorted.
  !---------------------------------------------------------------------
  real(kind=4),    intent(inout) :: daps(7)        !
  integer(kind=4), intent(in)    :: ndata          ! nchan * nstokes
  real(kind=4),    intent(inout) :: visi(3,ndata)  ! One visibility
  ! Local
  real :: tmp
  integer :: i
  !
  if (daps(6).gt.daps(7)) then
    daps(1) = -daps(1)         ! U
    daps(2) = -daps(2)         ! V
    tmp = daps(6)
    daps(6) = daps(7)          ! A1
    daps(7) = tmp              ! A2
    do i = 1,ndata
      visi(2,i) = -visi(2,i)   ! Imaginary part
    enddo
  endif
end subroutine swap_antenna
!
subroutine maxant(antenna, maxa)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Get maximum antenna number
  !---------------------------------------------------------------------
  real :: antenna                   !
  integer :: maxa                   !
  !
  maxa = max(antenna,real(maxa))
end subroutine maxant
!
subroutine maxvis (visi, ndata, rmax, pmax, blank)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Get maximum visibility and weight
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: ndata          ! nchan * nstokes
  real(kind=4),    intent(in)    :: visi(3,ndata)  ! One visibility
  real(kind=4),    intent(inout) :: rmax           !
  real(kind=4),    intent(inout) :: pmax           !
  real(kind=4),    intent(in)    :: blank          !
  ! Local
  real :: a
  integer :: i, j
  !
  do i=1, ndata
    a = 0
    do j=1,2
      if (visi(j,i).ne.blank) a = a + visi(j,i)**2
    enddo
    a = sqrt(a)
    rmax = max(a,rmax)
    if (visi(3,i).ne.blank) pmax = max(pmax,visi(3,i))
  enddo
end subroutine maxvis
!
subroutine maxdaps(daps,umin,umax,vmin,vmax,jmin)
  !---------------------------------------------------------------------
  ! @ no-interface
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: daps(7)
  real(kind=4), intent(inout) :: umin
  real(kind=4), intent(inout) :: umax
  real(kind=4), intent(inout) :: vmin
  real(kind=4), intent(inout) :: vmax
  real(kind=4), intent(inout) :: jmin
  !
  umin = min(umin,daps(1))
  umax = max(umax,daps(1))
  vmin = min(vmin,daps(2))
  vmax = max(vmax,daps(2))
  jmin = min(jmin,daps(4))
end subroutine maxdaps
!
subroutine write_visi(daps,visi,ndata,jmin,ps,error)
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ no-interface
  !  Write one visibility on tape.
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: daps(7)        !
  integer(kind=4), intent(in)    :: ndata          ! nchan * nstokes
  real(kind=4),    intent(in)    :: visi(3,ndata)  ! One visibility
  real(kind=4),    intent(in)    :: jmin           !
  real(kind=4),    intent(in)    :: ps             !
  logical,         intent(inout) :: error          !
  ! Local
  integer(kind=4) :: i
  real(kind=4) :: time, date, base, weight
  !
  ! Write daps
  call fitreal(fd,1,daps(1),uscal,uzero,error)
  if (error) return
  call fitreal(fd,1,daps(2),vscal,vzero,error)
  if (error) return
  ! CALL FITREAL(fd,1,DAPS(3),WSCAL,WZERO,ERROR)
  call fitreal(fd,1,0.0,wscal,wzero,error)
  if (error) return
  base = 256*daps(6) + daps(7)
  call fitreal(fd,1,base,1.0,0.0,error)
  if (error) return
  time = daps(4) - jmin + daps(5)/86400.
  date = 0.25*int(4*time)
  time = time-date
  call fitreal(fd,1,date,0.25,0.0,error)
  if (error) return
  call fitreal(fd,1,time,tscal,tzero,error)
  if (error) return
  !
  ! Write data
  do i=1, ndata
    call fitreal(fd,2,visi(1,i),cscal,czero,error)    ! Data
    if (error) return
    weight = visi(3,i)*ps
    call fitreal(fd,1,weight,cscal,czero,error) ! Weight
    if (error) return
  enddo
end subroutine write_visi
!
subroutine compute_time(daps,t,jmin,maxbas)
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Compute time
  !---------------------------------------------------------------------
  real, intent(in) ::   daps(7)                 ! Data Associated Parameters
  real(8), intent(out) :: t                     ! Current time
  real, intent(in) ::   jmin                    ! Minimum date
  real, intent(in) ::   maxbas                  ! Maximum baseline
  !
  t = daps(4) - jmin + daps(5)/86400. + (daps(6)*256+daps(7))/86400/maxbas
end subroutine compute_time
!
subroutine sort_visi(x,xwork,key,dim1,dim2)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Sort visibility records
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: dim1  !
  integer(kind=index_length), intent(in) :: dim2  !
  real :: x(dim1,dim2)              !
  real :: xwork(dim1,dim2)          !
  integer :: key(dim2)              !
  ! Local
  integer(kind=index_length) :: i,j
  !
  do j=1,dim2
    do i=1,dim1
      xwork(i,j) = x(i,key(j))
    enddo
  enddo
end subroutine sort_visi
!
subroutine wr_fitshead(fits,rmin,rmax,umin,umax,vmin,vmax,wmin,wmax,jmin,  &
  ps,telescop,check,error)
  use phys_const
  use gbl_message
  use image_def
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>wr_fitshead
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! UVFITS
  !     Write the FITS header for a visibility set.
  !---------------------------------------------------------------------
  type(gildas),     intent(in)  :: fits       !
  real(kind=4),     intent(in)  :: rmin,rmax  !
  real(kind=4),     intent(in)  :: umin,umax  !
  real(kind=4),     intent(in)  :: vmin,vmax  !
  real(kind=4),     intent(in)  :: wmin,wmax  !
  real(kind=4),     intent(in)  :: jmin       !
  real(kind=4),     intent(in)  :: ps         ! Weight scaling factor
  character(len=*), intent(in)  :: telescop   !
  logical,          intent(in)  :: check      !
  logical,          intent(out) :: error      !
  ! Local
  real(kind=4), parameter :: epsr4=1e-7  ! Relative precision of REAL*4
  character(len=80) :: line
  character(len=23) :: date
  real(kind=4) :: freq_resolution
  real(kind=8) :: factor
  real(kind=8) :: c=clight
  character(len=8) :: refsys,specsys
  !
  ! Make sure we have the right representation of UV table
  if (fits%gil%column_pointer(code_uvt_topo).ne.0) then
    call gio_message(seve%e,'TO_UVFITS', &
    & 'Table has Doppler tracking column, information lost in UVFITS')
    error = .true.
    return
  endif
  !
  if (fd%snbit.eq.16) then
    factor = 1.01d0 / 32767.d0 / 2.d0
  elseif (fd%snbit.eq.32) then
    factor = 1.01d0 / 2147483647.d0 / 2.d0
  elseif (fd%snbit.eq.-32) then
    factor = 1.0d0
  else
    error = .true.
    return
  endif
  call gfits_put ('SIMPLE  =                    T         /',check,error)
  if (error) return
  write (line,10) 'BITPIX  =           ',fd%snbit
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Defines 6 different axis, 7 for AIPS...
  !
  if (a_style.eq.code_fits_aips) then
    call gfits_put ('NAXIS   =                    7         /',check,error)
  else
    call gfits_put ('NAXIS   =                    6         /',check,error)
  endif
  if (error) return
  ! No standard image, just groups.
  call gfits_put ('NAXIS1  =                    0         /',check,error)
  if (error) return
  ! Complex
  call gfits_put ('NAXIS2  =                    3         /',check,error)
  if (error) return
  ! Stokes
  write (line,10) 'NAXIS3  =           ',fits%gil%nstokes
  call gfits_put (line,check,error)
  if (error) return
  ! Frequency
  write (line,10) 'NAXIS4  =           ',fits%gil%nchan
  call gfits_put (line,check,error)
  if (error) return
  ! RA
  call gfits_put ('NAXIS5  =                    1         /',check,error)
  if (error) return
  ! DEC
  call gfits_put ('NAXIS6  =                    1         /',check,error)
  if (error) return
  ! IF
  if (a_style.eq.code_fits_aips) then
    call gfits_put ('NAXIS7  =                    1         /',check,error)
    if (error) return
  endif
  !
  call gfits_put ("TELESCOP= '"//telescop//"'                   /",check,error)
  if (error) return
  call gfits_put ('EXTEND  =                    T         /',check,error)
  if (error) return
  !
  ! Compute extrema, and determine optimal scaling.
  if (fd%snbit.ne.-32) then
    cscal = (rmax - rmin) * factor
    czero  = (rmin+rmax)*0.5
  else
    cscal = 1.0
    czero = 0.0
  endif
  if (fd%snbit.eq.16) then
    write (line,10) 'BLANK   =           ',32767,'Blanking value'
    call gfits_put (line,check,error)
  elseif (fd%snbit.eq.32) then
    write (line,10) 'BLANK   =           ',2147483647,'Blanking value'
    call gfits_put (line,check,error)
  endif
  if (error) return
  write (line,20) 'BSCALE  = ',cscal
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'BZERO   = ',czero
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'DATAMIN = ',rmin
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'DATAMAX = ',rmax
  call gfits_put (line,check,error)
  if (error) return
  call gfits_put ('BUNIT   = ''JY      ''                   /',check,error)
  if (error) return
  !
  ! Coordinates of pointing centre need not be the same as phase centre.
  write (line,20) 'EQUINOX = ',fits%gil%epoc,'Equinox of coordinates'
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'OBSRA   = ',180.d0*fits%gil%ra/pi,'Pointing centre RA'
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'OBSDEC  = ',180.d0*fits%gil%dec/pi,'Pointing centre DEC'
  call gfits_put (line,check,error)
  if (error) return
  !
  !  Description af axes. No first axis for UVFITS.
  call gfits_put ('CTYPE2  = ''COMPLEX ''                   /',check,error)
  if (error) return
  call gfits_put ('CRVAL2  =      1.0000000000000         /',check,error)
  if (error) return
  call gfits_put ('CDELT2  =      1.0000000000000         /',check,error)
  if (error) return
  call gfits_put ('CRPIX2  =      1.0000000000000         /',check,error)
  if (error) return
  call gfits_put ('CROTA2  =      0.0000000000000         /',check,error)
  if (error) return
  !
  call gfits_put ('CTYPE3  = ''STOKES  ''                   /',check,error)
  if (error) return
  if (a_style.ne.code_fits_aips) then
    call gfits_put ('CRVAL3  =      1.0000000000000         /',check,error)
    if (error) return
    call gfits_put ('CDELT3  =      1.0000000000000         /',check,error)
    if (error) return
    call gfits_put ('CRPIX3  =      1.0000000000000         /',check,error)
    if (error) return
  else
    call gfits_put ('CRVAL3  =     -1.0000000000000         /',check,error)
    if (error) return
    call gfits_put ('CDELT3  =     -1.0000000000000         /',check,error)
    if (error) return
    call gfits_put ('CRPIX3  =      1.0000000000000         /',check,error)
    if (error) return
  endif
  call gfits_put ('CROTA3  =      0.0000000000000         /',check,error)
  if (error) return
  !
  ! Observing frequency (upper side band ?..)
  ! Should be the Observatory Frequency
  call gfits_put ('CTYPE4  = ''FREQ    ''                   /',check,error)
  if (error) return
  write (line,20) 'CRVAL4  = ',fits%gil%freq*1d6,'Frequency in Hz'
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Frequency resolution is here
  freq_resolution = fits%gil%fres*1d6 
  write (line,20) 'CDELT4  = ',freq_resolution,'Frequency Resolution in Hz'
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'CRPIX4  = ',fits%gil%ref(1),'Reference channel '
  call gfits_put (line,check,error)
  if (error) return
  call gfits_put ('CROTA4  =      0.0000000000000         /',check,error)
  if (error) return
  !
  ! Coordinates of phase tracking center. Assume Equatorial in present version.
  call gfits_put ('CTYPE5  = ''RA      ''                   /',check,error)
  if (error) return
  write (line,20) 'CRVAL5  = ',180.d0*fits%gil%a0/pi,'Right Ascension'
  call gfits_put (line,check,error)
  if (error) return
  call gfits_put ('CDELT5  =      1.0000000000000         /',check,error)
  if (error) return
  call gfits_put ('CRPIX5  =      1.0000000000000         /',check,error)
  if (error) return
  ! What happens for rotated UV data ?
  call gfits_put ('CROTA5  =      0.0000000000000         /',check,error)
  if (error) return
  !
  call gfits_put ('CTYPE6  = ''DEC     ''                   /',check,error)
  if (error) return
  write (line,20) 'CRVAL6  = ',180.d0*fits%gil%d0/pi,'Declination'
  call gfits_put (line,check,error)
  if (error) return
  call gfits_put ('CDELT6  =      1.0000000000000         /',check,error)
  if (error) return
  call gfits_put ('CRPIX6  =      1.0000000000000         /',check,error)
  if (error) return
  ! What happens for rotated UV data ?
  call gfits_put ('CROTA6  =      0.0000000000000         /',check,error)
  if (error) return
  if (a_style.eq.code_fits_aips) then
    call gfits_put ('CTYPE7  = ''IF      ''                   /',check,error)
    if (error) return
    call gfits_put ('CRVAL7  =      1.0000000000000         /',check,error)
    if (error) return
    call gfits_put ('CDELT7  =      1.0000000000000         /',check,error)
    if (error) return
    call gfits_put ('CRPIX7  =      1.0000000000000         /',check,error)
    if (error) return
    call gfits_put ('CROTA7  =      0.0000000000000         /',check,error)
    if (error) return
  endif
  !
  ! Miscellaneous
  write (line,30) 'OBJECT  = ',fits%char%name
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Spectral line information
  write (line,30) 'LINE    = ',fits%char%line,'Line name'
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'RESTFREQ= ', fits%gil%freq*1d6, 'Rest frequency'
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Check here for velocity referential.
  call gfits_put ('SSYSOBS = ''TOPOCENT''                   /',check,error) 
  select case (fits%gil%vtyp)
  case (vel_lsr)
    refsys = 'LSRK'
  case (vel_hel)
    refsys = 'BARYCENT'
  case (vel_obs)
    refsys = 'TOPOCENT'
  case (vel_ear)
    refsys = 'GEOCENT'
  case default
    refsys = 'SOURCE'
  end select
  if (refsys.ne.'SOURCE') then
    write(line,13)  'SSYSSRC = ',refsys
    call gfits_put (line,check,error)
    write(line,20)  'ZSOURCE = ',fits%gil%voff*1d3  ! km/s to m/s
    call gfits_put(line,check,error)
  endif
  if (a_style.eq.code_fits_aips) then
    specsys = refsys
  else
    specsys = 'SOURCE'
  endif
  write(line,13)  'SPECSYS = ',specsys
  call gfits_put (line,check,error)
  write(line,20)  'VELOSYS = ',fits%gil%dopp*299792458d0  !  m/s
  call gfits_put(line,check,error)
  !
  ! New ISO Date Format
  call sic_isodate(date)
  write (line,13) 'DATE    = ',trim(date),'Date written'
  call gfits_put(line,check,error)
  if (error) return
  ! Write new ISO DATE FORMAT
  call gfits_put('TIMESYS = ''UTC             ''           /',check,error)
  if (error) return
  call gag_mjd2isodate(dble(gagzero_in_mjd+jmin),date,error)
  if (error) return
  write (line,13) 'DATE-OBS= ',trim(date),'Date observed'
  call gfits_put(line,check,error)
  if (error) return
  call gfits_put ('ORIGIN  = ''GILDAS-NOEMA    ''           /',check,error) 
  !
  ! UVFITS specific information
  ! Indicate extension to FITS is UVFITS
  call gfits_put ('GROUPS  =                    T         /',check,error)
  if (error) return
  !
  ! Number of integers in one DAP record
  write (line,10) 'PCOUNT  =           ',6
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Number of visibilities
  write (line,10) 'GCOUNT  =           ',fits%gil%dim(2)
  call gfits_put (line,check,error)
  if (error) return
  !
  ! First DAP is U. Units are seconds  of time.
  call gfits_put ('PTYPE1  = ''UU      ''                   /',check,error)
  if (error) return
  if (fd%snbit.eq.-32) then
    uscal = 1.0
    uzero = 0.0
  else
    uscal = (umax - umin) * factor
    uzero = (umin+umax)*0.5
  endif
  write (line,20) 'PSCAL1  = ',uscal/c ! Convert metres to seconds
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'PZERO1  = ',uzero/c
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Second DAP is V. Units are seconds  of time.
  call gfits_put ('PTYPE2  = ''VV      ''                   /',check,error)
  if (error) return
  if (fd%snbit.eq.-32) then
    vscal = 1.0
    vzero = 0.0
  else
    vscal = (vmax - vmin) * factor
    vzero = (vmin+vmax)*0.5
  endif
  write (line,20) 'PSCAL2  = ',vscal/c
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'PZERO2  = ',vzero/c
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Third DAP is W. Units are seconds  of time.
  call gfits_put ('PTYPE3  = ''WW      ''                   /',check,error)
  if (error) return
  if (fd%snbit.eq.-32) then
    wscal = 1.0
    wzero = 0.0
  else
    wscal = (wmax - wmin) * factor
    wzero = (wmin+wmax)*0.5
  endif
  write (line,20) 'PSCAL3  = ',wscal/c
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'PZERO3  = ',wzero/c
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Fourth DAP is baseline number (256*ANT1+ANT2+(ARRAY#-1)/100).
  call gfits_put ('PTYPE4  = ''BASELINE''                   /',check,error)
  if (error) return
  write (line,20) 'PSCAL4  = ',1.d0
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'PZERO4  = ',0.d0
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Fifth DAP is observing day (Julian Date)
  call gfits_put ('PTYPE5  = ''DATE    ''                   /',check,error)
  if (error) return
  write (line,20) 'PSCAL5  = ',0.25d0
  call gfits_put (line,check,error)
  if (error) return
  ! This is the offset between Julian day numbers and CLIC's internal code
  write (line,20) 'PZERO5  = ',2460549.5d0+jmin
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Sixth DAP is UT (in fraction of Julian Day)
  call gfits_put ('PTYPE6  = ''DATE    ''                   /',check,error)
  if (error) return
  if (fd%snbit.eq.-32) then
    tscal = 1.0
    uzero = 0.0
  else
    tscal = factor
    tzero = 0.
  endif
  write (line,20) 'PSCAL6  = ',tscal
  call gfits_put (line,check,error)
  if (error) return
  write (line,20) 'PZERO6  = ',tzero
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Finish Header
  write (line,20) 'HISTORY   WTSCAL   ',1e6/ps  ! As units are MHz
  call gfits_put (line,check,error)
  if (error) return
  !
  call gfits_put ('END                         ',check,error)
  if (error) return
  call gfits_flush_header (error)
  !
10 format(a,i10,'         / ',a)
13 format(a,'''',a,'''',t40,'/ ',a)
20 format(a,e20.13,'         / ',a)
30 format(a,'''',a12,'''','               / ',a)
end subroutine wr_fitshead
!
subroutine write_antenna_extension(telescop,diam,nant,check,error)
  use gio_interfaces, except_this=>write_antenna_extension
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: telescop  ! Array name
  real(kind=4),     intent(in)    :: diam      ! Antenna diameters (same for all)
  integer(kind=4),  intent(in)    :: nant      ! Number of antennas
  logical,          intent(in)    :: check     ! Verbose flag
  logical,          intent(inout) :: error     ! Error flag
  ! Local
  real(kind=8) :: dval
  integer(kind=4) :: ival,nbit_table
  integer(kind=4) :: j,iant
  character(len=80) :: line
  integer(kind=4), parameter :: lenbuf=74  ! Length of one row in table
  character(len=lenbuf) :: cbuf
  !
  call gfits_put ('XTENSION= ''BINTABLE''                   / Extension type',check,error)
  if (error) return
  nbit_table = 8
  write (line,10) 'BITPIX  =           ',nbit_table,'Binary data'
  call gfits_put (line,check,error)
  if (error) return
  !
  ! Defines 2 different axis
  !
  call gfits_put ('NAXIS   =                    2         / Table is a matrix',check,error)
  if (error) return
  write(line,10) 'NAXIS1  =           ',lenbuf,'Width in bytes'
  call gfits_put (line,check,error)
  if (error) return
  write(line,10) 'NAXIS2  =           ',nant,'Nr of entries in table'
  call gfits_put (line,check,error)
  if (error) return
  !
  ! General parameters of table
  call gfits_put ('PCOUNT  =                    0         / Random parameter group',check,error)
  if (error) return
  call gfits_put ('GCOUNT  =                    1         / Group count',check,error)
  if (error) return
  call gfits_put ('TFIELDS =                   13         / Number of fields',check,error)
  call gfits_put ('EXTNAME = ''AIPS AN ''                   / AIPS table file',check,error)
  if (error) return
  write(line,14) 'EXTVER  =                    2         /',  &
                 ' Version number of table'
  call gfits_put (line, check,error)
  if (error) return
  !
  ! Definitions of table parameters
  write(line,14) 'TFORM1  = ''8A      ''                   /',  &
                 ' FORTRAN format of field 1'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE1  = ''ANNAME          ''           /',  &
                 ' Type (heading) of field 1'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT1  = ''        ''                   /',  &
                 ' Physical units of field 1'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM2  = ''3D      ''                   /',  &
                 ' FORTRAN format of field 2'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE2  = ''STABXYZ         ''           /',  &
                 ' Type (heading) of field 2'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT2  = ''METERS  ''                   /',  &
                 ' Physical units of field 2'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM3  = ''0D      ''                   /',  &
                 ' FORTRAN format of field 3'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE3  = ''ORBPARM         ''           /',  &
                 ' Type (heading) of field 3'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT3  = ''        ''                   /',  &
                 ' Physical units of field 3'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM4  = ''1J      ''                   /',  &
                 ' FORTRAN format of field 4'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE4  = ''NOSTA           ''           /',  &
                 ' Type (heading) of field 4'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT4  = ''        ''                   /',  &
                 ' Physical units of field 4'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM5  = ''1J      ''                   /',  &
                 ' FORTRAN format of field 5'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE5  = ''MNTSTA          ''           /',  &
                 ' Type (heading) of field 5'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT5  = ''        ''                   /',  &
                 ' Physical units of field 5'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM6  = ''1E      ''                   /',  &
                 ' FORTRAN format of field 6'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE6  = ''STAXOF          ''           /',  &
                 ' Type (heading) of field 6'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT6  = ''METERS  ''                   /',  &
                 ' Physical units of field 6'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM7  = ''1A      ''                   /',  &
                 ' FORTRAN format of field 7'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE7  = ''POLTYA          ''           /',  &
                 ' Type (heading) of field 7'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT7  = ''        ''                   /',  &
                 ' Physical units of field 7'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM8  = ''1E      ''                   /',  &
                 ' FORTRAN format of field 8'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE8  = ''POLAA           ''           /',  &
                 ' Type (heading) of field 8'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT8  = ''DEGREES ''                   /',  &
                 ' Physical units of field 8'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM9  = ''2E      ''                   /',  &
                 ' FORTRAN format of field 9'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE9  = ''POLCALA         ''           /',  &
                 ' Type (heading) of field 9'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT9  = ''        ''                   /',  &
                 ' Physical units of field 9'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM10 = ''1A      ''                   /',  &
                 ' FORTRAN format of field 10'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE10 = ''POLTYB          ''           /',  &
                 ' Type (heading) of field 10'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT10 = ''        ''                   /',  &
                 ' Physical units of field 10'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM11 = ''1E      ''                   /',  &
                 ' FORTRAN format of field 11'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE11 = ''POLAB           ''           /',  &
                 ' Type (heading) of field 11'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT11 = ''DEGREES ''                   /',  &
                 ' Physical units of field 11'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM12 = ''2E      ''                   /',  &
                 ' FORTRAN format of field 12'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE12 = ''POLCALB         ''           /',  &
                 ' Type (heading) of field 12'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT12 = ''        ''                   /',  &
                 ' Physical units of field 12'
  call gfits_put (line, check, error)
  if (error) return
  !
  write(line,14) 'TFORM13 = ''1E      ''                   /',  &
                 ' FORTRAN format of field 13'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TTYPE13 = ''DIAMETER        ''           /',  &
                 ' Type (heading) of field 13'
  call gfits_put (line, check,error)
  if (error) return
  write(line,14) 'TUNIT13 = ''METERS  ''                   /',  &
                 ' Physical units of field 13'
  call gfits_put (line, check, error)
  if (error) return
  !
  ! Other parameters
  dval = 4.524e+06   ! BURE
  write(line,20) 'ARRAYX  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  dval = 0.468e+06   ! BURE
  write(line,20) 'ARRAYY  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  dval = 4.460e+06   ! BURE
  write(line,20) 'ARRAYZ  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  !
  dval = 0
  write(line,20) 'GSTIA0  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  write(line,20) 'DEGPDY  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  write(line,20) 'FREQ    = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  call gfits_put ('RDATE   = ''01/01/99''', check, error)
  if (error) return
  write(line,20) 'POLARX  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  write(line,20) 'POLARY  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  write(line,20) 'UT1UTC  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  write(line,20) 'DATUTC  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  call gfits_put ('TIMSYS  = ''IAT     ''', check, error)
  if (error) return
  call gfits_put ('ARRNAM  = '''//telescop//'''', check, error)
  if (error) return
  ival = 0
  write (line,10) 'NUMORB  =           ',ival
  call gfits_put (line, check, error)
  if (error) return
  ival = 2
  write (line,10) 'NOPCAL  =           ',ival
  call gfits_put (line, check, error)
  if (error) return
  ival = 1
  write (line,10) 'FREQID  =           ',ival
  call gfits_put (line, check, error)
  if (error) return
  write (line,20) 'IATUTC  = ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  write(line,'(a)') 'POLTYPE = ''APPROX  '''
  call gfits_put (line, check, error)
  if (error) return
  ival = 15
  write (line,10) 'P_REFANT=           ',ival
  call gfits_put (line, check, error)
  if (error) return
  write (line,20) 'P_DIFF01= ',dval,' '
  call gfits_put (line, check, error)
  if (error) return
  !
  ! Finish Header
  call gfits_put ('END                         ',check,error)
  if (error) return
  call gfits_flush_header (error)
  if (error) return
  !
  ! Table
  !
  fd%nb = 0
  do j=1,lenbuf
    cbuf(j:j) = char(0)  ! Nullify all values common to all antennas
  enddo
  do iant = 1,nant
    write(cbuf(1:8),'(a1,i3.3,4x)') 'A',iant  ! ANNAME
    cbuf(45:45)= 'X'  ! POLTYA
    cbuf(58:58)= 'X'  ! POLTYB
#if defined(IEEE) || defined(VAX)
    call iei4ei(iant,cbuf(33:36),1)  ! NOSTA
    call ier4ei(diam,cbuf(71:74),1)  ! DIAMETER
#else
    call i4toi4(iant,cbuf(33:36),1)  ! NOSTA
    call r4tor4(diam,cbuf(71:74),1)  ! DIAMETER
#endif
    call gfits_putbuf(cbuf,lenbuf,error)
  enddo
  call gfits_flush_data(error)  ! Flush and pad with zeroes
  fd%nb = 0
  return
  !
10 format(a,i10,'         / ',a)
14 format(a,a)
20 format(a,e20.13,'         / ',a)
end subroutine write_antenna_extension

block data setupdata
  include 'setup.inc'
  data elmin, elmax /5.0, 90.0/
  data rmsmax /5.0/
end
!
subroutine set (line,comm,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  include 'setup.inc'
  include 'size.inc'
  ! Local
  integer :: mvocab
  parameter (mvocab=2)
  integer :: nkey,i
  character(len=12) :: vocab(mvocab),argum,keywor
  data vocab /'ELEVATION', 'RMS'/
  !
  call sic_ke (line,0,1,argum,i,.true.,error)
  if (error) return
  call sic_ambigs('SET',argum,keywor,nkey,vocab,mvocab,error)
  if (error) return
  !
  goto (1,2) nkey
  !
  ! Elevation
  1     elmax = 90.0
  elmin = 5.0
  call sic_r4 (line,0,3,elmax,.false.,error)
  if (error) return
  call sic_r4 (line,0,2,elmin,.false.,error)
  if (error) return
  call flag_el(npt,elmin,elmax)
  goto 50
  !
  ! RMS
  2     rmsmax = 5.0
  call sic_r4 (line,0,2,rmsmax,.false.,error)
  if (error) return
  call flag_rm(npt,rmsmax)
  goto 50
  !
  50    return
end
!<FF>
subroutine show (line,comm,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: mvocab
  parameter (mvocab=4)
  integer :: nkey,i,k
  character(len=80) :: chain
  character(len=12) :: vocab(mvocab),argum,keywor
  data vocab /'ELEVATION', 'RMS', 'IGNORED', 'REJECTED'/
  !
  call sic_ke (line,0,1,argum,i,.true.,error)
  if (error) return
  call sic_ambigs('SHOW',argum,keywor,nkey,vocab,mvocab,error)
  if (error) return
  !
  goto (1,2,3,4) nkey
  !
  1     write(6,*) 'Elevation range ',elmin,elmax
  goto 50
  2     write(6,*) 'Maximum rms of measured errors ',rmsmax
  goto 50
  3     k = 1
  write(6,*) 'Ignored data points'
  do i=1,npt
    if (badus(i)) then
      write (chain(k:),'(I4)') scan(i)
      k = k+5
      if (k.gt.70) then
        write(6,*) chain(1:k)
        k = 1
      endif
    endif
  enddo
  if (k.gt.1) write(6,*) chain(1:k)
  goto 50
  !
  4     k = 1
  write(6,*) 'Rejected data points'
  do i=1,npt
    if (badre(i)) then
      write (chain(k:),'(I4)') scan(i)
      k = k+5
      if (k.gt.70) then
        write(6,*) chain(1:k)
        k = 1
      endif
    endif
  enddo
  if (k.gt.1) write(6,*) chain(1:k)
  goto 50
  !
  50    return
end

program make_back
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	Computes the background of an image. Thresholding is used
  !	to define the background, then the image is smoothed
  !	and blanked pixels are filled the CONJUGATE GRADIENT ALGORITHM :
  !	The smoothed image is the equilibrium state of a thin flexible plate
  !	constrained to pass near each height datum by a spring attached
  !	between it and the plate.
  !	the smoothing parameter p is the ratio :
  !	     p = ( plate stiffness) / ( springs stiffness)
  !	The convergence is obtained with about 10 iterations ...
  !---------------------------------------------------------------------
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  integer(size_length) :: i
  integer :: n,niter
  real :: p,thre(3)
  real(4), allocatable :: ipw(:,:,:), ipt(:,:)
  type(gildas) :: x,y
  integer(kind=size_length) :: sdim(gdf_maxdims)
  integer :: ndim, ier
  !
  call gildas_open
  call gildas_real('P$',p,1)
  call gildas_inte('NITER$',niter,1)
  call gildas_char('IN$',namey)
  call gildas_char('OUT$',namex)
  call gildas_real('THRESHOLD$',thre,3)
  call gildas_close
  !
  ! Input file
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error, data=.false.)
  if (error) then
    write(6,*) 'F-MAKE_BACK,  Cannot read input file'
    goto 100
  endif
  !
  ! Create output image
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  n = lenc(namex)
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-MAKE_BACK,  Cannot output image'
    goto 100
  endif
  !
  ! Re-shape to 3 - dim
  ndim = y%gil%ndim
  sdim = y%gil%dim
  y%gil%ndim = 3
  y%gil%dim(3) = y%loca%size/(y%gil%dim(1)*y%gil%dim(2))
  x%gil%ndim = 3
  x%gil%dim = y%gil%dim
  !
  ! Get work space
  allocate (ipt(x%gil%dim(1), x%gil%dim(2)), ipw(x%gil%dim(1), x%gil%dim(2), 4), stat=ier)
  if (ier.ne.0) goto 100
  allocate (x%r2d(x%gil%dim(1), x%gil%dim(2)), y%r2d(x%gil%dim(1), x%gil%dim(2)), stat=ier)
  if (ier.ne.0) goto 100
  !
  ! Now loop over planes
  do i=1,x%gil%dim(3)
    x%blc(3) = i
    x%trc(3) = i
    y%blc = x%blc
    y%trc = x%trc
    call gdf_read_data(x,x%r2d,error)
    call gdf_read_data(y,y%r2d,error)
    !
    ! Fill first work space
    call fill(y%gil%dim(1),y%gil%dim(2),   & !NX,NY,
    &        y%r2d,   & !IN
    &        ipt,     & !WORK
    &        y%gil%bval,y%gil%eval,thre,   &  !bval,eval,thre
    &        ipw(:,:,1),x%r2d) !out,guess
    call dgsm001(x%gil%dim(1),x%gil%dim(2),   &  !mi,mj
    &        ipw(:,:,2) ,   &   !AP
    &        ipw(:,:,3) ,   & !AP2
    &        ipw(:,:,4) ,   & !AP3
    &        thre(3))         !first_guess
    call dgsm002(ipw(:,:,1),x%gil%dim(1),x%gil%dim(2),   &  !V,MI,MJ
    &        x%r2d,x%gil%bval,x%gil%eval,   &   !A,BVAL,EVAL
    &        ipw(:,:,2), &   !DESC
    &        ipw(:,:,3), &   !grad
    &        ipw(:,:,4),  & !W
    &        p,niter)         !P,ITERMAX
    call gdf_write_data(x,x%r2d,error) 
  enddo
  call gagout('S-MAKE_BACK,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program make_back
!
subroutine fill (nx,ny,in,work,bval,eval,thre,   &
     &    out,guess)
  use gildas_def
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: ny                     !
  real :: in(nx,ny)                 !
  real :: work(nx,ny)               !
  real :: bval                      !
  real :: eval                      !
  real :: thre(3)                   !
  real :: out(nx,ny)                !
  real :: guess(nx,ny)              !
  ! Local
  integer :: i,j,ip,im,jp,jm
  real :: z,w
  !
  do j = 1,ny
    do i = 1,nx
      if (abs(in(i,j)-bval).gt.eval) then
        work(i,j) = in(i,j)
      else
        ip = max(i-1,1)
        im = min(i+1,nx)
        jp = max(j-1,1)
        jm = min(j+1,ny)
        w = 0.0
        z = 0.0
        if (abs(in(ip,j)-bval).gt.eval) then
          z = z+in(ip,j)
          w = w+1.0
        endif
        if (abs(in(im,j)-bval).gt.eval) then
          z = z+in(im,j)
          w = w+1.0
        endif
        if (abs(in(i,jp)-bval).gt.eval) then
          z = z+in(i,jp)
          w = w+1.0
        endif
        if (abs(in(i,jm)-bval).gt.eval) then
          z = z+in(i,jm)
          w = w+1.0
        endif
        if (w.gt.0) then
          work(i,j) = z/w
        else
          work(i,j) = bval
        endif
      endif
    enddo
  enddo
  !
  do j = 1,ny
    do i = 1,nx
      if (abs(in(i,j)-bval).le.eval) then
        if (abs(work(i,j)-bval).le.eval) then
          guess(i,j) = thre(3)
        else
          guess(i,j) = work(i,j)
        endif
        out(i,j) = bval
      elseif (in(i,j).gt.thre(2)) then
        work(i,j) = thre(2)
        guess(i,j) = thre(2)
        out(i,j) = bval
      elseif (in(i,j).lt.thre(1)) then
        work(i,j) = thre(1)
        guess(i,j) = thre(1)
        out(i,j) = bval
      else
        work(i,j) = in(i,j)
        guess(i,j) = in(i,j)
        out(i,j) = in(i,j)
      endif
    enddo
  enddo
end subroutine fill
!
subroutine dgsm001(mi,mj,ap,ap2,ap3,first_guess)
  use gildas_def
  !---------------------------------------------------------------------
  !	 Init
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mi                  !
  integer(kind=index_length) :: mj                  !
  real :: ap(mi,mj)                 !
  real :: ap2(mi,mj)                !
  real :: ap3(mi,mj)                !
  real :: first_guess               !
  ! Local
  ap = 0.0
  ap2 = 0.0
  ap3 = 0.0
end subroutine dgsm001
!
subroutine dgsm002(v,mi,mj,a,bval,eval,desc,grad,w,p,itermax)
  use gildas_def
  !---------------------------------------------------------------------
  ! D. Girard  smoothing technique
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mi                   !
  integer(kind=index_length) :: mj                   !
  real(4) :: v(mi,mj)                !
  real(4) :: a(mi,mj)                !
  real(4) :: bval                    !
  real(4) :: eval                    !
  real(4) :: desc(mi,mj)             !
  real(4) :: grad(mi,mj)             !
  real(4) :: w(mi,mj)                !
  real(4) :: p                       !
  integer :: itermax                !
  ! Global
  real(4) :: dot,norme2
  ! Local
  real(4) :: beta,lambda
  real(4) :: norm2grad,norm2grad_1
  !
  ! Resolution iterative par gradient conjugue
  ! Pas de splines pour l'instant
  ! Compromis fidelite aux donnees (moindre carre)
  ! et terme de flexion de symmetrie correcte.
  ! BUT: Etude problemes de convergence.
  !						D. Girard. 20-dec-1986
  !
  ! Ici P n'a pas la signification de C. de Borr
  !-------------------------------------------
  !
  integer i0,j0,i,j,iter
  !
  i0 = max(1,mi/2)
  j0 = max(1,mj/2)
  if (itermax.le.0) return
  !
  call iprotd (v,mi,mj,p,a,grad,bval,eval) ! Calcul du gradient(=residu
  do j=1,mj
    do i=1,mi
      if (abs(v(i,j)-bval).gt.eval) then
        grad(i,j)=grad(i,j)-v(i,j)
      endif
    enddo
  enddo
  norm2grad = norme2(mi,mj,grad)
  !
  call iprotd (v,mi,mj,p,grad,w,bval,eval)
  lambda = norm2grad/dot(mi,mj,grad,w)
  !
  do j=1,mj
    do i=1,mi
      desc(i,j) = - grad(i,j)
    enddo
  enddo
  !
  do j=1,mj
    do i=1,mi
      a(i,j) = a(i,j) - lambda*grad(i,j)
    enddo
  enddo
  norm2grad_1 = norm2grad
  do j=1,mj
    do i=1,mi
      grad(i,j) = grad(i,j) - lambda*w(i,j)
    enddo
  enddo
  !
  ! ITERATIONS
  do iter = 2,itermax
    norm2grad = norme2(mi,mj,grad)
    beta = norm2grad/norm2grad_1
    do j=1,mj
      do i=1,mi
        desc(i,j) = -grad(i,j) + beta*desc(i,j)
      enddo
    enddo
    call iprotd(v,mi,mj,p,desc,w,bval,eval)
    !
    lambda = norm2grad / dot(mi,mj,desc,w)
    !
    do j=1,mj
      do i=1,mi
        a(i,j) = a(i,j) + lambda*desc(i,j)
      enddo
    enddo
    !
    norm2grad_1 = norm2grad
    !
    do j=1,mj
      do i=1,mi
        grad(i,j) = grad(i,j) + lambda*w(i,j)
      enddo
    enddo
  enddo
end subroutine dgsm002
!
subroutine iprotd(v,mi,mj,p,z,s,bval,eval)
  use gildas_def
  integer(kind=index_length) :: mi                   !
  integer(kind=index_length) :: mj                   !
  real(4) :: v(mi,mj)                !
  real(4) :: p                       !
  real(4) :: z(mi,mj)                !
  real(4) :: s(mi,mj)                !
  real(4) :: bval                    !
  real(4) :: eval                    !
  ! Local
  integer :: i,j
  real(4) :: w
  !
  do j=1,mj
    do i=1,mi
      if (abs(v(i,j)-bval).gt.eval) then
        s(i,j) = z(i,j)
      else
        s(i,j) = 0
      endif
    enddo
  enddo
  do j=2,mj-1
    do i=2,mi-1
      w = p*(2*z(i,j)-z(i-1,j)-z(i+1,j))
      s(i,j) = s(i,j) +2*w
      s(i-1,j) = s(i-1,j) -w
      s(i+1,j) = s(i+1,j) -w
      w = p*(2*z(i,j)-z(i,j+1)-z(i,j-1))
      s(i,j) = s(i,j) +2*w
      s(i,j-1) = s(i,j-1) -w
      s(i,j+1) = s(i,j+1) -w
      w = 2*p*(z(i+1,j+1)+z(i-1,j-1)-z(i+1,j-1)-z(i-1,j+1))/4
      s(i+1,j+1) = s(i+1,j+1) +w/4
      s(i-1,j-1) = s(i-1,j-1) +w/4
      s(i+1,j-1) = s(i+1,j-1) -w/4
      s(i-1,j+1) = s(i-1,j+1) -w/4
    enddo
  enddo
end subroutine iprotd
!
function dot (mi,mj,z,s)
  use gildas_def
  real(4) :: dot                     !
  integer(kind=index_length) :: mi                   !
  integer(kind=index_length) :: mj                   !
  real(4) :: z(mi,mj)                !
  real(4) :: s(mi,mj)                !
  ! Local
  integer :: i,j
  !
  dot = 0.
  do j=1,mj
    do i=1,mi
      dot = dot + s(i,j)*z(i,j)
    enddo
  enddo
end function dot
!
function norme2(mi,mj,z)
  use gildas_def
  real(4) :: norme2                  !
  integer(kind=index_length) :: mi                     !
  integer(kind=index_length) :: mj                     !
  real(4) :: z(mi,mj)                !
  ! Local
  integer :: i,j
  !
  norme2 = 0.
  do j=1,mj
    do i=1,mi
      norme2 = norme2 + z(i,j)*z(i,j)
    enddo
  enddo
end function norme2

program extrema_main
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS Task EXTREMA
  !
  !  Update the extrema of a GILDAS data set
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: file
  integer :: n
  logical :: error
  type(gildas) :: x
  !
  call gildas_open
  call gildas_char('FILE$',file)
  call gildas_close
  n = len_trim(file)
  if (n.eq.0) stop
  !
  call gildas_null(x)
  ! Ask for a "flat" array description
  call gdf_read_gildas(x, file, '.gdf', error, rank=0, data=.true.)
  if (error) goto 99
  !
  if (x%gil%type_gdf.eq.code_gdf_uvt) then
    call gdf_get_baselines(x,error)
  else if (x%gil%type_gdf.eq.code_gdf_tuv) then
    call gdf_get_baselines(x,error)
  else
    call gdf_get_extrema(x,error)
  endif
  if (error) goto 99
  !
  call gdf_update_header(x,error)
  if (.not.error) then
    stop 'S-EXTREMA,  Header successfully updated'
  endif
99 call sysexi(fatale)
end program extrema_main

      SUBROUTINE IGNORE(LINE,ERROR)
      USE GKERNEL_INTERFACES
C-----------------------------------------------------------------------------
C ORBIT:
C  Temporarily ignore some data from the fit
C-----------------------------------------------------------------------------
      CHARACTER LINE*(*)
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
*
      INTEGER MVOCAB
      PARAMETER (MVOCAB=5)
      CHARACTER*12 VOCAB(MVOCAB),ARGUM1,ARGUM2,KEYWORD
      CHARACTER*10 STATUS
      INTEGER I,NCH,NKEY,CODE
*
      DATA VOCAB /'PARALLAX','VELOCITY','CORRELATION',
     +     'VISUAL', 'VISIBILITY'/
*
      STATUS= 'Ignored'
      GOTO 100
*
      ENTRY USE(LINE,ERROR)
      STATUS= 'OK'
      GOTO 100
*
* Determine requested action type from command line
 100  CALL SIC_CH (LINE,0,1,ARGUM1,NCH,.TRUE.,ERROR)
      NCH=MAX(NCH,LEN(ARGUM1))
      CALL SIC_UPPER(ARGUM1(1:NCH))
      CALL SIC_AMBIGS('LIST',ARGUM1(1:NCH),KEYWORD,NKEY,
     +     VOCAB,MVOCAB,ERROR)
*
      IF (KEYWORD.EQ.'PARALLAX') THEN
         DO I=1,NPARA
            STATPARA(I) = STATUS
         ENDDO
      ELSEIF (KEYWORD.EQ.'VELOCITY') THEN
         IF (.NOT.SIC_PRESENT(0,2)) THEN
            DO I=1,NVR
               STATVR(I) = STATUS
            ENDDO
         ELSE
            CALL SIC_CH (LINE,0,2,ARGUM2,NCH,.TRUE.,ERROR)         
            DO I=1,NVREF
               IF(ARGUM2.EQ.VR_REF(I)) THEN
                  CODE = I
                  GOTO 110
               ENDIF
            ENDDO
            WRITE(6,*) 'E-IGNORE,  Unknown velocity origin ',ARGUM2
            GOTO 99  ! ERROR
 110        CONTINUE
            DO I=1,NVR
               IF (VREFCODE(I).EQ.CODE) STATVR(I) = STATUS
            ENDDO
         ENDIF
      ELSEIF (KEYWORD.EQ.'CORRELATION') THEN
         DO I=1,NVCORR
            STATVCORR(I) = STATUS
         ENDDO
      ELSEIF (KEYWORD.EQ.'VISUAL') THEN
         DO I=1,NN
            STATOBS(I) = STATUS
         ENDDO
      ELSEIF (KEYWORD.EQ.'VISIBILITY') THEN
         DO I=1,NVISI
            STATVISI(I) = STATUS
         ENDDO
      ENDIF
*
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END

      SUBROUTINE EVAL_ERROR(SIGMA,B)
* Compute (linearised) error bars on any function of the elements, given
* its gradient relative to the orbital element, and the covariance matrix
      REAL SIGMA  ! Probable error on function
      REAL B(*)   ! Gradient of function relative to orbital elements
*
      INCLUDE 'constant.inc'
      INCLUDE 'elements.inc'
*
      INTEGER I,K
*
      SIGMA=0.
      DO I=1,MA
         DO K=1,MA
            SIGMA=SIGMA+ALPHA(I,K)*B(I)*B(K)
         ENDDO
      ENDDO
* Detailed contributions of individual covariances. Make available through
* a verbose switch??
!      IF (SIGMA.GT.0) THEN
!         DO I=1,MA
!            if (b(i).ne.0) then
!               write(6,'(200(1X,F4.2))') 
!     +              (ALPHA(I,K)*B(I)*B(K)/SIGMA,K=1,MA)
!            endif
!         ENDDO
!      ENDIF
*
      SIGMA=SQRT(SIGMA)
      SIGMA=SIGMA*SIG   ! Rescale by reduced Chi to avoid overoptimistic
                        ! values when measurement erros are underestimated.
      RETURN
      END

subroutine gio_cdim (is,ndims,dims)
  use gio_image
  !---------------------------------------------------------------------
  ! @ private
  ! GDF
  !       Change DIM of an Image Slot
  !       Change the dimensions of a pre-defined image slot
  !       This can be useful to reshape an image slot, and
  !               allow reading by blocks regardless of the actual
  !       underlying data structure. Typical applications include
  !       computing extrema, transposition, FITS interface...
  !
  !             It is used by GDF_READ_DATA and GDF_WRITE_DATA which can
  !         thus specify whatever shape they want for their data.
  !---------------------------------------------------------------------
  integer, intent(in) :: is                         ! Image Slot
  integer(4), intent(in) :: ndims                   ! Number of dimensions
  integer(kind=size_length), intent(in) :: dims(:)  ! Dimensions
  ! Local
  integer :: i
  !
  indim(is) = ndims
  do i=1,gdf_maxdims
    idims(i,is)  = max(1,dims(i))
  enddo
end subroutine gio_cdim
!
subroutine gio_dams (ms,is,blc,trc,array,form,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_dams
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF
  !       Data Associated Memory Slot
  !       Associate pre-defined array ARRAY to (sub)-set BLC,TRC of
  !       image IS, at slot MS.
  !---------------------------------------------------------------------
  integer(kind=4),            intent(out) :: ms        ! Memory slot
  integer(kind=4),            intent(in)  :: is        ! Image slot
  integer(kind=index_length), intent(in)  :: blc(:)    ! Bottom left corner
  integer(kind=index_length), intent(in)  :: trc(:)    ! Top right corner
  real(kind=4),               intent(in)  :: array(*)  ! Data array
  integer(kind=4),            intent(in)  :: form      ! Image format
  logical,                    intent(out) :: error     ! Flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=size_length) :: isize,ioffs,ileng
  integer(kind=index_length) :: iblc(gdf_maxdims),itrc(gdf_maxdims),dimou(gdf_maxdims)
  integer(kind=address_length) :: ipi, ipo, addr_tmp
  integer :: ms_tmp, ndim
  integer(kind=index_length) :: jblc(gdf_maxdims), jtrc(gdf_maxdims), dimin(gdf_maxdims)
  !
  integer(kind=4) :: i,j
  logical :: icont
  integer(kind=address_length) :: addr    ! Input address
  character(len=message_length) :: mess
  character(len=*), parameter :: rname = 'GIO_DAMS'
  !
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    error = .true.
    return
  elseif (islot(is).eq.code_gio_full) then
    call gio_message(seve%e,rname,'Image is not mapped')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Get adress...
  addr = locwrd(array)
  !
  ! Special case: set attribute READE (External)
  islot(is) = code_gio_reade            ! Was DUMPE_GIO before
  !
  call gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
  if (isize.le.0) then
    call gio_message(seve%e,rname,'Zero length memory slot')
    write(mess,*) 'Islot ',is
    call gio_message(seve%d,rname,mess)
    write(mess,*) 'NDim ',ndim
    call gio_message(seve%d,rname,mess)
    write(mess,*) 'Isize ',isize
    call gio_message(seve%d,rname,mess)
    write(mess,*) 'Icont ',icont
    call gio_message(seve%d,rname,mess)
    call gio_dump_header(gheads(is))
  endif
  !
  ! Allocate a free memory frame
  if (icont) then
    do i=1,gdf_maxdims
      dimou(i) = itrc(i)-iblc(i)+1
    enddo
    !
    ioffs = 0
    do i=ndim,1,-1
      ioffs = ioffs*idims(i,is)+iblc(i)-1
    enddo
    ileng = isize
    !
    ! Disk file
    if (ichan(is).ne.0) then
      call gio_lnslot (ms,error)
      if (error) return
      if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
        ileng = 2*isize
        ioffs = 8*ioffs
      elseif (form.eq.fmt_by) then
        ileng = (isize+3)/4
      else
        ileng = isize
        ioffs = 4*ioffs
      endif
      mslot(ms) = is
      maddr(1,ms) = addr
      maddr(2,ms) = addr+4*(isize-1)
      mleng(ms) = ileng
      moffs(ms) = ioffs        ! Offset in Bytes
      !
      ! Virtual memory, probably never used in this context...
    else
      ileng = -ileng
      call gio_lnslot (ms,error)
      if (error) return
      mslot(ms) = is
      maddr(1,ms) = addr
      maddr(2,ms) = addr+4*(isize-1)
      mleng(ms) = ileng
    endif
    if (error) then
      mslot(ms) = code_gio_empty
      return
    else
      do i=1,gdf_maxdims
        mblc(i,ms) = blc(i)
        mtrc(i,ms) = trc(i)
      enddo
      msize(ms) = isize
      mcont(ms) = icont
    endif
    ! Define memory slot format
    mform(ms) = form
    !
    ! Read it now
    call gio_rems(ms,error)
  else
    !!call gio_message(seve%w,rname,'Subset option support is experimental')
    !
    ileng = isize ! Are we sure ?
    !
    ! Define smallest contiguous containing subset
    jblc = iblc
    jtrc = itrc
    do i=ndim,1,-1
      if (iblc(i).ne.itrc(i)) then
        do j=1,i-1
          jblc(j) = 1
          jtrc(j) = idims(j,is)
        enddo
      endif
    enddo
    dimin = jtrc-jblc+1
    dimou = itrc-iblc+1
    !
    ! The memory for the subset is already allocated
    call gio_lnslot (ms,error)  ! Get a memory Slot
    mslot(ms) = is
    maddr(1,ms) = addr
    maddr(2,ms) = addr+4*(isize-1)
    mleng(ms) = ileng
    !
    ! Get the continuous subset
    call gio_gemsco (ms_tmp, is, jblc, jtrc, addr_tmp, form, error)
    if (error)  return
    !
    ! Extract the subset
    ipo = gag_pointer(addr,memory)
    ipi = gag_pointer(addr_tmp,memory)
    !
    ! Good code...
    do i=1,ndim
      if (dimin(i).eq.dimou(i)) iblc(i) = 1
    enddo
    !
    if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
      call gdf_sub8(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    elseif (form.eq.fmt_by) then
      call gdf_sub1(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    else
      call gdf_sub4(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    endif
    !
    ! Free the temporary subset.
    ! Note that ISLOT(IS) must be READO in this case, to free the Memory
    islot(is) = code_gio_reado            !
    call gio_frms (ms_tmp, error)
    islot(is) = code_gio_reade            ! Restore the proper code
    !
  endif
  if (error) return
  !
  ! Patch old UV data files
  if (abs(ivers(is)).eq.code_gdf_uvold) then
    call gio_message(seve%i,rname,'Patching old UV data weights')
    !
    ! If the array has been re-shaped for transposition, re-re-shape it
    if (dimou(1).eq.1 .and. dimou(3).ne.1) then
      dimou(1) = dimou(2)
      dimou(2) = dimou(3)
      dimou(3) = dimou(4)
      dimou(4) = 1
    endif
    call patch_weight (ivers(is),array,dimou(1),dimou(2),dimou(3),dimou(4))
  endif
end subroutine gio_dams
!
subroutine gio_rems (ms,error)
  use gio_interfaces, except_this=>gio_rems
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF   REad Memory Slot
  !---------------------------------------------------------------------
  integer, intent(in)  :: ms         ! Memory slot
  logical, intent(out) :: error      ! Flag
  ! Local
  integer :: is
  character(len=*), parameter :: rname = 'GIO_REMS'
  !
  is = mslot(ms)
  if (is.eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Memory slot is empty')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Contiguous slot
  if (mcont(ms)) then
    !
    ! If virtual memory, ignore it
    if (mleng(ms).lt.0) then
      call gio_message(seve%e,rname,'Virtual Memory slot cannot be read')
      error = .true.
      return
    elseif  (islot(is).ne.code_gio_reade) then
      error = .true.
      call gio_message(seve%e,rname,'Memory slot is not READ External')
    else
      if (mapped(is)) then
        return
      else
        !
        ! Read disk file
        call gio_rmslot (ms,iunit(is),error)
      endif
    endif
    !
  else
    error = .true.
    ! Not contiguous
    call gio_message(seve%e,rname,'Inconsistent state of GDF library')
    call gio_message(seve%e,rname,'Non-contiguous READ slot')
  endif
end subroutine gio_rems
!
subroutine gio_rmslot (ms,lun,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_rmslot
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! Read Memory SLOT
  !       Direct access solution
  !---------------------------------------------------------------------
  integer, intent(in)  :: ms         ! Memory slot
  integer, intent(in)  :: lun        ! Logical Unit Number
  logical, intent(out) :: error      ! Flag
  ! Global
  integer(kind=4) :: gdf_conv
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname = 'GIO_RMSLO'
  integer :: ier,form,is,ileft, koffs
  integer(4) :: buffer(lenbig),sizbuf
  integer(kind=record_length) :: i,ikbfi,ikbla
  integer(kind=size_length) :: ioffs
  integer(kind=address_length) :: ip
  character(len=80) :: mess
  !
  ! Read into specified area
  is = mslot(ms)
  error = .true.
  if (islot(is).ne.code_gio_reade) return
  !
  error = .false.
  form = mform(ms)
  !
  ! See also code for DUMPE case
  !!Print *,'RMSLOT ',is,istbl(is),isbig(is)
  ioffs = moffs(ms)/4+istbl(is)*lenbuf ! Offset in Word in file
  sizbuf = isbig(is)*lenbuf
  koffs = mod(ioffs,sizbuf)  ! Offset in Word from first buffer
  ikbfi = ioffs/sizbuf + 1
  ikbla = (ioffs+mleng(ms)+sizbuf-1)/sizbuf  ! Last buffer address
  !
  open(unit=lun,file=cname(is),status='OLD',form='UNFORMATTED',  &
       access='DIRECT',action='READ',recl=sizbuf*facunf,iostat=ier)
  if (ier.ne.0)  goto 90
  ip = gag_pointer(maddr(1,ms),memory)
  !
  ! Read file
  ! Native format
  if (iform(is).eq.mform(ms)) then
    ileft = mleng(ms)
    do i=ikbfi,ikbla-1
      if (i.eq.ikbfi) then
        ier = gio_riox (lun,i,buffer,sizbuf)
        if (ier.ne.0) goto 90
        call r4tor4 (buffer(1+koffs),memory(ip),sizbuf-koffs)
        ip = ip+sizbuf-koffs
        ileft = ileft-sizbuf+koffs
      else
        ier = gio_riox (lun,i,memory(ip),sizbuf)
        if (ier.ne.0) goto 90
        ip = ip+sizbuf
        ileft = ileft-sizbuf
      endif
    enddo
    ier = gio_riox(lun,ikbla,buffer,sizbuf)
    if (ikbla.eq.ikbfi) then
      call r4tor4(buffer(1+koffs),memory(ip),ileft)
    else
      call r4tor4(buffer,memory(ip),ileft)
    endif
  else
    ! As above, but with format Conversion
    ileft = mleng(ms)
    do i=ikbfi,ikbla-1
      if (i.eq.ikbfi) then
        ier = gio_riox (lun,i,buffer,sizbuf)
        if (ier.ne.0) goto 90
        ier = gdf_conv (buffer(1+koffs),memory(ip),sizbuf-koffs,form,iform(is))
        ip = ip+sizbuf-koffs   ! That is what we have filled
        ileft = ileft-sizbuf+koffs
      else
        ier = gio_riox (lun,i,buffer,sizbuf)
        if (ier.ne.0) goto 90
        ier = gdf_conv (buffer,memory(ip),sizbuf,form,iform(is))
        ip = ip+sizbuf
        ileft = ileft-sizbuf
      endif
      if (ier.ne.1) goto 80
    enddo
    ier = gio_riox(lun,ikbla,buffer,sizbuf)
    if (ikbla.eq.ikbfi) then
      ier = gdf_conv (buffer(koffs+1),memory(ip),ileft,form,iform(is))
    else
      ier = gdf_conv (buffer,memory(ip),ileft,form,iform(is))
    endif
    if (ier.ne.1) goto 80
  endif
  !
  close(unit=lun)
  return
  !
  ! Error messages
80 call gio_message(seve%e,rname,'Input conversion error in data')
  write(mess,*) 'Form ',form,' in file ',iform(is)
  call gio_message(seve%e,rname,mess)
  error = .true.
  close(unit=lun)
  return
  !
90 call gio_message(seve%e,rname,'Read error in data')
  call putios(seve%e,rname,ier)
  error = .true.
  close(unit=lun)
end subroutine gio_rmslot
!
subroutine gio_pums (ms,is,blc,trc,addr,form,error)
  use gio_interfaces, except_this=>gio_pums
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF
  !       Put Memory Slot
  !       Associate pre-defined area ADDR to (sub)-set BLC,TRC of
  !       image IS, at slot MS.
  !---------------------------------------------------------------------
  integer, intent(out) :: ms         ! Memory slot
  integer, intent(in)  :: is         ! Image slot
  integer(kind=index_length), intent(in)  :: blc(:) ! Bottom left corner
  integer(kind=index_length), intent(in)  :: trc(:) ! Top right corner
  integer(kind=address_length), intent(in) :: addr  ! Input address
  integer, intent(in)  :: form       ! Image format
  logical, intent(out) :: error      ! Flag
  ! Local
  integer(kind=index_length) :: iblc(gdf_maxdims),itrc(gdf_maxdims)
  integer(kind=size_length) :: isize,ioffs,ileng,i
  integer(kind=4) :: ndim
  logical :: icont
  character(len=message_length) :: mess
  character(len=*), parameter :: rname = 'GIO_PUMS'
  !
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    error = .true.
    return
  elseif (islot(is).eq.code_gio_full) then
    call gio_message(seve%e,rname,'Image is not mapped')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Special case: set attribute DUMP
  islot(is) = code_gio_dumpe
  !
!!  ! Can now be blocked in BIG buffers, because header is skipped
!!  ! Well, what happens if we inherit a file with smaller chunks ?
!!  isbig(is) = gio_blocking
!!  ! Why should we change the initial status of isbig(is)
  !
  call gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
  if (isize.le.0) then
    call gio_message(seve%e,rname,'Zero length memory slot')
    write(mess,*) 'Islot ',is
    call gio_message(seve%d,rname,mess)
    write(mess,*) 'NDim ',ndim
    call gio_message(seve%d,rname,mess)
    write(mess,*) 'Isize ',isize
    call gio_message(seve%d,rname,mess)
    write(mess,*) 'Icont ',icont
    call gio_message(seve%d,rname,mess)
    !!call gio_dump_header(gheads(is))  ! DEBUG !
  endif
  !
  ! Allocate a free memory frame
  if (icont) then
    ioffs = 0
    do i=ndim,1,-1
      ioffs = ioffs*idims(i,is)+iblc(i)-1
    enddo
    ileng = isize
    !
    ! Disk file
    if (ichan(is).ne.0) then
      call gio_lnslot (ms,error)
      if (error) return
      if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
        ileng = 2*isize
        ioffs = 8*ioffs
      elseif (form.eq.fmt_by) then
        ileng = (isize+3)/4
      else
        ileng = isize
        ioffs = 4*ioffs
      endif
      mslot(ms) = is
      maddr(1,ms) = addr
      maddr(2,ms) = addr+4*(isize-1)
      mleng(ms) = ileng
      !
      ! Virtual memory
    else
      ileng = -ileng
      call gio_lnslot (ms,error)
      if (error) return
      mslot(ms) = is
      maddr(1,ms) = addr
      maddr(2,ms) = addr+4*(isize-1)
      mleng(ms) = ileng
    endif
    if (error) then
      mslot(ms) = code_gio_empty
      return
    else
      do i=1,gdf_maxdims
        mblc(i,ms) = blc(i)
        mtrc(i,ms) = trc(i)
      enddo
      msize(ms) = isize
      mcont(ms) = icont
    endif
    moffs(ms) = ioffs          ! Offset in Bytes
  else
    call gio_message(seve%e,rname,'Subset option not yet supported')
    error = .true.
    return
  endif
  ! Define memory slot format
  mform(ms) = form
end subroutine gio_pums
!
subroutine gio_lnslot (ms,error)
  use gio_interfaces, only : gio_message
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF   Get a free memory slot
  !---------------------------------------------------------------------
  integer, intent(out) :: ms                     ! Memory slot number
  logical, intent(out) :: error                  !
  ! Local
  integer :: i,freems
  character(len=*), parameter :: rname = 'GIO_LNSLOT'
  !
  ! OK, now get a free frame-ID and virtual memory
  freems = 0
  ms = 0
  do i=1,mms
    if (mslot(i).eq.code_gio_empty) then
      if (mleng(i).eq.0) then
        freems = i
        exit
      endif
    endif
  enddo
  !
  ! No free frame large enough, or virtual memory
  if (freems.eq.0) then
    call gio_message(seve%e,rname,'Too many memory frames')
    error = .true.
  else
    ms = freems
    maddr(1,ms) = 0
    maddr(2,ms) = 0
    mleng(ms) = 0
    moffs(ms) = 0
  endif
end subroutine gio_lnslot

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_restore
  use gbl_message
  !
  public :: uv_restore_comm
  private
  !
contains
  !
  subroutine uv_restore_comm(line,error)
    use uvmap_tool
    use uvmap_buffers, only: uvmap_prog
    use clean_types, only: beam_unit_conversion
    use clean_buffers, only: clean_user,clean_prog
    !-------------------------------------------------------------------
    ! Support routine for command
    !     UV_RESTORE
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    if (uvmap_prog%nfields.ne.0) then
       call map_message(seve%w,'UV_RESTORE','UV data is a Mosaic, under test...')
       call uv_restore_mosaic(line,error)
    else
       call beam_unit_conversion(clean_user)
       call clean_user%copyto(clean_prog)
       call uvmap_main('UV_RESTORE',line,error)
    endif
  end subroutine uv_restore_comm
    !
  subroutine uv_restore_mosaic(line,error)
    use image_def
    use gkernel_interfaces
    use uv_residual, only: uv_residual_main
    use uvmosaic_tool, only: uvmosaic_main
    use file_buffers
    use uv_buffers
    use uvmap_buffers
    use clean_buffers
    !---------------------------------------------------------------------
    ! Restore a mosaic image
    !
    ! Required input
    !   the CCT table
    !   the RESIDUAL image (obtained by imaging the UV table obtained by UV_RESIDUAL)
    !   the PRIMARY beams
    ! Output 
    !   the restored CLEAN image
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    logical :: zero,err
    integer :: nx,ny,np,nc,ic,ip,ier
    real :: wr2,ws2,wmin
    real, pointer :: prima(:,:,:)
    real, pointer :: myresid(:,:)
    real, pointer :: myclean(:,:)
    real, pointer :: duv_previous(:,:), duv_next(:,:)
    real, allocatable :: response(:,:)
    type(gildas) :: huv_save
    character(len=*), parameter :: rname='MOSAIC_RESTORE'
    !
    ! Compute the primary beams if not done
    if (primbeam%head%loca%size.eq.0) then
       call map_message(seve%e,rname,'Primary beams undefined')
       error = .true.
       return
    endif
    !
    call gildas_null(huv_save,type='UVT')
    call gdf_copy_header(huv, huv_save, error)
    !
    ! Compute the UV Residual and the pure CLEAN part
    nullify (duv_previous, duv_next)
    call uv_residual_main(rname,line,duv_previous,duv_next,.true.,error)
    if (error) return
    !
    ! Associate DUV and HUV to the UV Residual
    duv => duv_next
    ! Resize UV data  
    huv%gil%nvisi = ubound(duv,2)
    huv%gil%dim(2) = huv%gil%nvisi
    !
    ! Perform the Imaging
    call uvmosaic_main(rname,line,error)
    if (error) return
    !
    ! At this stage : DIRTY is the RESIDUAL...
    call gdf_copy_header(dirty%head,resid%head,error)
    if (error) return
    resid%head%r3d => resid%data
    !
    prima => primbeam%data(:,:,:,1)
    np = primbeam%head%gil%dim(1)
    nc = resid%head%gil%dim(3)
    ny = resid%head%gil%dim(2)
    nx = resid%head%gil%dim(1)
    !
    ! Compute the "weight" function 1/N
    wmin = 0.01    ! Hum ?
    ws2 =  0.0     ! Search weight
    wr2 =  0.04    ! Restore weight 20 % level of primary beam
    allocate(response(nx,ny),stat=ier)
    !
    response = 0
    do ip=1,np
       response(:,:) = response(:,:)+prima(ip,:,:)**2
    enddo
    where (response.gt.wr2) 
       response = 1.0/response
    else where
       response = 0.0
    end where
    !
    ! For test, can reset DCLEAN or RESID
    zero = .false.
    call sic_get_logi('ZERO_CLEAN',zero,err)
    if (zero) clean%data = 0.0
    zero = .false.
    call sic_get_logi('ZERO_RESID',zero,err)
    if (zero) resid%data = 0.0
    !
    ! Loop on channels
    do ic=1,nc
       myresid => resid%head%r3d(:,:,ic)
       myclean => clean%head%r3d(:,:,ic)
       ! Mosaic case
       myclean = myclean + myresid*response
       where (response.eq.0) myclean = clean%head%gil%bval ! Undefined pixel there
    enddo
    !
    call sic_delvariable('CLEAN',.false.,error)
    ! Redefine CLEAN data set 
    call sic_mapgildas('CLEAN',clean%head,error,clean%data)! Clean buffers
    clean%head%loca%size = dirty%head%loca%size
    !
    ! Must clean in some way the intermediate UV_BUFFERS and
    ! re-associate the HUV header - Use a new UV_DISCARD_BUFFER tool
    ! to factorize that.
    !
    zero = .false. 
    call sic_get_logi('ZERO_KEEPUV',zero,err)
    !
    if (.not.zero) then
       !call uv_dump_buffers(rname//' before')
       !print *,'Discarding UV buffers '
       call uv_discard_buffers(duv_previous, duv_next, error)
       !call uv_dump_buffers(rname//' after')
       call gdf_copy_header(huv_save,huv,error)
       !
    else
       call map_message(seve%w,rname,'Keeping UV residuals')
       call uv_clean_buffers(duv_previous, duv_next,error)
       if (error) return
       !
       if (allocated(uvtb%data)) deallocate (uvtb%data)            ! UV data not plotted
       uv_plotted = .false.
       !
       ! Indicate optimization and save status
       optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
       save_data(code_save_uv) = .true.
       !
       ! Not needed here: weights are unchanged
       ! do_weig = .true.  ! Recompute weight 
       !
       ! Resize UV data and redefine SIC variables 
       huv%gil%nvisi = ubound(duv,2)
       huv%gil%dim(2) = huv%gil%nvisi
       !
       call sic_delvariable('UV',.false.,error)
       call sic_mapgildas('UV',huv,error,duv) 
    endif
  end subroutine uv_restore_mosaic
end module uv_restore
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE FIT(LINE,ERROR)
C-----------------------------------------------------------------------------
C ORBIT:
C   Driver routine for the Levenberg-Marquardt non linear least square fit 
C   of the orbital elements. 
C-----------------------------------------------------------------------------
      CHARACTER LINE*(*)
      LOGICAL ERROR
*      
      INCLUDE 'constant.inc'
      INCLUDE 'elements.inc'
*
      INTEGER MITER
      REAL*8 DUMMY(MA,1)
      LOGICAL QUIET,UPDATE,WARNING
*
      MITER=100
      ERROR = .FALSE.
*
      CALL SIC_I4(LINE,0,1,MITER,.FALSE.,ERROR)
      IF (ERROR) RETURN
*
      QUIET      = .FALSE.
      UPDATE     = .TRUE.
*
      CALL DO_FIT(MITER,EL,UPDATE,QUIET,WARNING,ERROR)
      IF (ERROR) RETURN
* Print the resulting orbital elements
      CALL PRINT_ELEMENTS(6,.FALSE.,1,0.5,DUMMY,.FALSE.,ERROR)
      RETURN
      END

      SUBROUTINE DO_FIT(MITER,ELEM,UPDATE,QUIET,WARNING,ERROR)
C-----------------------------------------------------------------------------
C ORBIT:
C   Driver routine for the Levenberg-Marquardt non linear least square fit 
C   of the orbital elements. 
C-----------------------------------------------------------------------------
      LOGICAL QUIET,ERROR
      REAL*8 ELEM(*)
      LOGICAL UPDATE,WARNING
      INTEGER MITER
*      
      INCLUDE 'constant.inc'
      include 'elements.inc'
      include 'control.inc'
      INCLUDE 'pi.inc'
*
      INTEGER NITER
      INTEGER I,J
      REAL BETA(MA)        
      INTEGER MFIT,NDATA,LISTA(MA),ALIST(MA)
      REAL*8 EL_TRY(MA)
      REAL ALPHA_TRY(MA,MA),BETA_TRY(MA)
      REAL LAMBDA          ! Levenberg-Marquardt diagonal enhancement factor
      REAL LOCAL_SIG,OCHISQ
      LOGICAL LAST_ITER, BAD_STEP, COMPUTE_COV, WAS_LAST
      CHARACTER STEP_STATUS*16
* External functions
      LOGICAL SIC_CTRLC
C -----------------------------------------
*
* Correct correlations profile for deviations from a gaussian
      IF (PROFILE_METHOD.EQ.'CORRECTED') THEN
         CALL UPDATE_PROFILE_CORRECTIONS(QUIET,ERROR)
         IF (ERROR) RETURN
      ENDIF
* Build up a list (and an inverse list) of the adjustable elements, and 
* initialise the trial element set
      DO I=1,MA
         ALIST(I) = 0
      ENDDO
      MFIT=0
      DO I=1,MA
         IF (EL_STATUS(I)(1:6).EQ.'Adjust') THEN
            MFIT = MFIT+1
            LISTA(MFIT) = I
            ALIST(I) = MFIT
         ELSE
            ALIST(I) = 0
         ENDIF
         EL_TRY(I) = ELEM(I)
      ENDDO
*
      LAMBDA=0.01
      NITER =0
      LAST_ITER = .FALSE.
      WAS_LAST  = .FALSE.
      BAD_STEP  = .FALSE.
      WARNING   = .FALSE.
      OCHISQ = 1E37
*
      IF (.NOT.QUIET) WRITE(6,'(A)') 
     +     '  IT  CHISQ      SD(VA) SD(VB) SD(TETA) SD(RO)'
*
* Main loop: solve the linearised least square problem till chi**2 
* converges to a stable value
      DO WHILE (.TRUE.)
* Build the normal equation system for the linearised least square problem,
* for current trial parameters. Residuals for this same parameter set are
* also simultaneously evaluated here (and only here), so convergence can 
* only be tested further inside the loop.
         CALL BUILD_NORMAL(MFIT,LISTA,EL_TRY,ALPHA_TRY,BETA_TRY,
     +           CHISQ,NMEAS,SD,CHI2,LOCAL_SIG,NDATA,QUIET,ERROR)
!         do j=1,mfit
!!!            beta_try(j) = -betA_TRY(J)
!            write(6,*) (alpha_try(i,j),i=1,mfit), '        ',
!     +           beta_try(j)
!         enddo
!         write(6,*) (el_try(lista(i)),i=1,mfit)
         IF (ERROR) RETURN
* Evaluate the previous iteration for convergence, and print a brief 
* summary of its residuals
         CALL EVALUATE_STEP(CHISQ,OCHISQ,WAS_LAST,BAD_STEP,
     +        STEP_STATUS,LAMBDA,LAST_ITER)
         IF (.NOT.QUIET) WRITE (6,1310) NITER,CHISQ, 
     +        (SD(J), J=1,NDTYPE)
 1310    FORMAT (1X,I3,1X,F10.3,2(1X,F6.3),(1X,F4.1),20(1X,F5.3))
* 
* Step was successful: adopt the trial parameters, and update the normal
* equation system
         IF (STEP_STATUS.EQ.'Successful') THEN
            OCHISQ=CHISQ
            DO J=1,MFIT
               ELEM(LISTA(J)) = EL_TRY(LISTA(J))
               BETA(J) = BETA_TRY(J)
               DO I=1,MFIT
                  ALPHA(I,J) = ALPHA_TRY(I,J)
               ENDDO
            ENDDO
         ENDIF
         IF (LAST_ITER) GOTO 100
*
         NITER=NITER+1
         IF (NITER.GT.MITER) THEN
            IF (.NOT.QUIET) WRITE(6,*) 
     +           'W-FIT,  Maximum iteration count reached',
     +           ' without convergence'
            GOTO 99
         ENDIF
* Test for interruption by CtrlC, except in quiet mode where this is done
* at a higher level
         IF (.NOT.QUIET.AND.SIC_CTRLC()) THEN
            ERROR = .TRUE.
            RETURN
         ENDIF
* Construct the (diagonally enhanced) Levenberg-Marquardt system from the
* linearised least square system
         BAD_STEP = .FALSE. ! Hopefully
         DO J=1,MFIT
            DO I=1,MFIT
               ALPHA_TRY(I,J) = ALPHA(I,J) 
            ENDDO
            ALPHA_TRY(J,J) = ALPHA_TRY(J,J)*(1+LAMBDA)
            IF (ALPHA_TRY(J,J).GT.MAXR4) THEN
               IF (.NOT.QUIET) WRITE(6,*) 
     +              'W-FIT,  Marquardt enhancement factor',
     +        ' has increased to infinity without convergence'
               ERROR = .TRUE.
               RETURN
            ENDIF
            BETA_TRY(J) = BETA(J)
         ENDDO
*     
* Solve the Levenberg-Marquardt system 
         CALL SOLVE(METHOD,ALPHA_TRY,MFIT,MA,BETA_TRY,LISTA,
     +           NAMEL,QUIET,WARNING,BAD_STEP,ERROR)
* Update the trial orbital elements
         IF (.NOT.BAD_STEP) THEN
            CALL UPDATE_ELEMENTS(ELEM,LISTA,MFIT,
     +           SCLEL,EL_TRY,BETA_TRY)
         ENDIF
      ENDDO  !     Go on with iterations
* Converged: some final processing
 100  CONTINUE
* Build the normal matrix for the final solution, and invert it to obtain
* the true covariance matrix
      COMPUTE_COV = .TRUE.
      DO WHILE(COMPUTE_COV)
         COMPUTE_COV = .FALSE.
         CALL BUILD_NORMAL(MFIT,LISTA,EL_TRY,ALPHA_TRY,BETA_TRY,
     +        CHISQ,NMEAS,SD,CHI2,LOCAL_SIG,NDATA,QUIET,ERROR)
         IF (ERROR) RETURN
         CALL SOLVE(METHOD,ALPHA_TRY,MFIT,MA,BETA_TRY,LISTA,
     +        NAMEL,QUIET,WARNING,BAD_STEP,ERROR)
         IF (ERROR) RETURN
* Some cosmetic massaging of the elements to make them more eye-pleasing,
* though equivalent. Do not do that in non-interactive mode, to avoid 
* meaningless confidence intervals broadened by one period for epochs,
* and similar accidents.
         IF (.NOT.QUIET) THEN
            DO I=1,MORBIT
* Try forcing positive velocity amplitudes (through a PI phase shift) 
* when needed, for each orbit in turn
               CALL POSITIVE_K1_K2(I,EL_TRY,COMPUTE_COV)
* Modify the periastron epoch, within reason, to minimize its correlation 
* with the period. Also modify the epoch of the coordinate zero point to
* minimize the correlation with proper motion.
               CALL OPTIMIZE_EPOCH(I,EL_TRY,SCLEL,
     +              ALPHA_TRY,ALIST,COMPUTE_COV)
            ENDDO
         ENDIF
      ENDDO
*
      CALL PRINT_CHI(QUIET,CHISQ,NDATA-MFIT,LOCAL_SIG,ERROR)
      IF (ERROR) RETURN
* Store final elements
      DO J=1,MFIT
         ELEM(LISTA(J)) = EL_TRY(LISTA(J))
      ENDDO
      ELEM(I_EPOCH) = EL_TRY(I_EPOCH)  ! Special case for this "pseudo-element"
* For true adjustments (not those done during montecarlo simulations):
* update reduced Chi and element standard errors
      IF (UPDATE) THEN
         SIG = LOCAL_SIG
         DO I=1,MFIT
            J=LISTA(I)
            ELERR(J)=ABS(SCLEL(J))*SIG*SQRT(ABS(ALPHA_TRY(I,I)))
         ENDDO 
      ENDIF
* Don't accept a solution that remains poorly conditioned at last step.
      IF (BAD_STEP) THEN
         ERROR = .TRUE.
      ENDIF
*
* Rearrange a covariance matrix into the order of all MA elements. Insert 
* apropriate diagonal terms for the fixed elements if standard errors
* were provided for them.
! This should in principle only be done for true adjustments (not montecarlo
! simulations) but for the moment the initial matrix isn't saved. Not too bad
! a problem anyway, covariance matrix should be fairly stable for a well
! behaved solution
      DO J=1,MA
         DO I=1,MA
            ALPHA(I,J) = 0
         ENDDO
! Not quite correct for the moment, reduced CHI indiscriminately rescales
! all errors, even the totally independent ones that may be provided for the
! fixed parameters... Should be 1 any way, so don't fix that for the moment.
         ALPHA(J,J) = SNGL((ELERR(J)/SCLEL(J)/SIG)**2)
      ENDDO
      DO J=1,MFIT
         DO I=1,MFIT
            ALPHA(LISTA(I),LISTA(J)) = ALPHA_TRY(I,J)
         ENDDO
      ENDDO
      RETURN
* Error exit
 99   ERROR = .TRUE.
      RETURN
      END
c<FF>
      SUBROUTINE POSITIVE_K1_K2(IORB,ELEM,UNCHANGED)
C---------------------------------------------------------------------------
C Element massaging routine:
C Try forcing positive velocity amplitudes (through a PI phase shift) 
C when needed
C---------------------------------------------------------------------------
      INTEGER IORB
      REAL*8  ELEM(*)
      LOGICAL UNCHANGED
*
      INCLUDE 'constant.inc'
* External functions
      REAL*8 DMODULO
* Local
      INTEGER IK1,IK2,IOMEGA_L
*
      IK1 = ELINDX(IORB)+I_K1
      IK2 = ELINDX(IORB)+I_K2
      IF (ELEM(IK1).LT.0.AND.ELEM(IK2).LE.0) THEN 
         IOMEGA_L = (ELINDX(IORB)+I_OMEGA_L)
         ELEM(IK1) = -ELEM(IK1)
         ELEM(IK2) = -ELEM(IK2)
         ELEM(IOMEGA_L) = DMODULO(ELEM(IOMEGA_L)+180.D0,360.D0)
         UNCHANGED = .FALSE.    ! To update the covariance matrix
      ENDIF
      END
c<FF>
      SUBROUTINE OPTIMIZE_EPOCH(IORB,ELEM,SCALE,ALPHA,
     +     ALIST,UNCHANGED)
C---------------------------------------------------------------------------
C Element massaging routine:
C - modify the periastron epoch to minimize its correlation with the period.
C   The best epoch is T0-Cov(P,T0)/Cov(P,P)*P, but the formula is slightly 
C   modified because we solve for 2*pi/P rather than P. The result is then 
C   rounded to the closest periastron epoch, and forced to remain within
C   at most one period of the measurement interval.
C - choose the coordinate peoch that minimizes the correlation with the
C   proper motion.
C---------------------------------------------------------------------------
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
*
      INTEGER IORB,ALIST(*)
      REAL*8  ELEM(*)
      REAL    SCALE(*),ALPHA(MA,MA)
      LOGICAL UNCHANGED
*
* Local
      INTEGER IT0, IPERIOD, J_T0, J_PERIOD, J_X0, J_Y0, J_MUX, J_MUY
      INTEGER NDT
      REAL NP, NP_MIN, NP_MAX, DT
      REAL MODULO
      EXTERNAL MODULO
*
      IT0     = ELINDX(IORB)+I_T0
      IPERIOD = ELINDX(IORB)+I_PERIOD
      J_T0     = ALIST(IT0)
      J_PERIOD = ALIST(IPERIOD)
      IF (J_T0.NE.0.AND.J_PERIOD.NE.0) THEN! Check both are adjustable
         IF (ALPHA(J_PERIOD,J_PERIOD).NE.0) THEN
            NP = -ALPHA(J_PERIOD,J_T0)
     +           /(ALPHA(J_PERIOD,J_PERIOD)*SCALE(IPERIOD))
            NP = NINT(NP)
* Ensure the new perioastron epoch is at most one period earlier or later
* than the respectively first and last available measurements.
            NP_MIN = SNGL((FIRST_JDB-ELEM(IT0))/ELEM(IPERIOD))
            NP_MAX = SNGL((LAST_JDB -ELEM(IT0))/ELEM(IPERIOD))
            NP_MIN = NINT(NP_MIN-MODULO(NP_MIN,1.))
            NP_MAX = NINT(NP_MAX-MODULO(NP_MAX,1.)+1)
            NP = MAX(NP_MIN,NP)
            NP = MIN(NP_MAX,NP)
* Warn that something is being done
            IF (NP.NE.0) THEN
               WRITE(6,'(1X,A,A,2(A,F10.3),A)') 
     +              'I-FIT,  Shifting T0',ORBNAME(IORB),'from ',
     +              ELEM(IT0),' to ',
     +              ELEM(IT0) + NP*ELEM(IPERIOD),
     +              ' to minimize (T0,P) covariance'
               ELEM(IT0) = ELEM(IT0) + NP*ELEM(IPERIOD)
               UNCHANGED = .FALSE. ! Request an update of the covariance matrix
            ENDIF
         ENDIF
      ENDIF
* Same thing for the positions, on first orbit by convention
      IF (IORB.EQ.IORB0) THEN
         NDT = 0
         DT  = 0.0
         J_X0     = ALIST(I_X0)
         J_MUX    = ALIST(I_MuX)
         J_Y0     = ALIST(I_Y0)
         J_MUY    = ALIST(I_MuY)
         IF ((J_X0.NE.0.AND.J_MUX.NE.0).AND.
     +       (J_Y0.NE.0.AND.J_MUY.NE.0)) THEN ! Both are adjustable
            IF (ALPHA(J_MUX,J_MUX).NE.0) THEN
               NDT = NDT+1
               DT = DT-ALPHA(J_MUX,J_X0)
     +              /ALPHA(J_MUX,J_MUX)
            ENDIF
            IF (ALPHA(J_MUY,J_MUY).NE.0) THEN
               NDT = NDT+1
               DT = DT-ALPHA(J_MUY,J_Y0)
     +              /ALPHA(J_MUY,J_MUY)
            ENDIF
*     Apply the correction
            IF (NDT.GT.0) THEN
               DT = DT/NDT
               ELEM(I_X0) = ELEM(I_X0)+DT*ELEM(I_MuX)
               ELEM(I_Y0) = ELEM(I_Y0)+DT*ELEM(I_MuY)
               ELEM(I_EPOCH) = ELEM(I_EPOCH) + DT*365.25
               UNCHANGED = .FALSE. ! Request an update of the covariance matrix
            ENDIF
         ENDIF
      ENDIF
      RETURN
      END
c<FF>
      SUBROUTINE EVALUATE_STEP(CHISQ,OCHISQ,forced,BAD,
     +     STATUS,LAMBDA,LAST)
      REAL CHISQ           ! Input:    Chi^2 for current iteration
      REAL OCHISQ          ! Modified: Best Chi^2 to date
      LOGICAL FORCED       ! Input:    Force current iteration to be final
      LOGICAL BAD          ! Input:    Current iteration poorly condtioned
      CHARACTER*(*) STATUS ! Output:   Improved?
      REAL LAMBDA          ! Modified: Levenberg-Marquardt parameter
      LOGICAL LAST         ! Output:   Convergence flag
*
      INCLUDE 'pi.inc'
*
* Just a final covariance matrix update for a converged solution. Do not 
* iterate any further.
      IF (FORCED) THEN
         LAST = .TRUE.
         STATUS = 'Successful'
* Unsuccessful step, increase steepest descent character of the algorithm,
* and retry from same point.
      ELSE
     + IF (CHISQ.GT.OCHISQ*(1+10*EPSR4)
     +        .OR.CHISQ.NE.CHISQ.OR.BAD) THEN
         STATUS = 'Unsuccessful'
         LAMBDA=LAMBDA*10
* Successful step
      ELSE                      ! 
         STATUS = 'Successful'
         LAST = (CHISQ.GE.OCHISQ*(1-1E-4)) ! Converged, will stop
* Converged, request computation of the actual covariance matrix before 
* exiting
         IF (LAST) THEN
            LAMBDA    = 0
* Not yet converged. Increase the linearised least square character of 
* the algorithm, and iterate
         ELSE 
            LAMBDA=LAMBDA/5
         ENDIF
      ENDIF
      RETURN
      END
c<ff>

      SUBROUTINE PRINT_CHI(QUIET,CHISQ,NDEG,CHI,ERROR)
      LOGICAL QUIET
      REAL CHISQ,CHI
      INTEGER NDEG
      LOGICAL ERROR
* External
      REAL*4 GAMMQ,ERFCC  ! Erf and Gamma functions
*
      REAL GOODNESS
*      
      IF (.NOT.QUIET) THEN
         IF (CHISQ.LE.1E-3.AND.NDEG.EQ.0) THEN 
            GOODNESS=1.
            CHI = 1
         ELSEIF ((NDEG).LE.500) THEN
            GOODNESS=gammq(0.5*(NDEG),0.5*chisq,ERROR)
            IF (ERROR) THEN
               WRITE(6,*) 'E-FIT,  Error evaluating Goodness of Fit',
     +              ' for ',chisq,' and ',ndeg
               RETURN
            ENDIF
* Computation of GAMMQ is expensive for large arguments, and the chi**2 
* statistics has then already converged to a normal law with mean Nu and 
* standard deviation sqrt(2*Nu)
         ELSE
            GOODNESS=.5*erfcc(chisq-(NDEG))/
     &           SQRT(4.0*(NDEG))
         ENDIF
         WRITE(6,1300)
     +        'Chi**2 = ',chisq,
     +        'for expected ', NDEG,
     +        '+-',sqrt(2.0*(NDEG))
         WRITE(6,1305)
     +        'Reduced CHI = ', CHI,
     +        'P(Chi**2) = ',Goodness
      ENDIF
 1300 FORMAT((1X,A,F9.2),(1X,A,I6),(1X,A,F6.2))
 1305 FORMAT((1X,A,F6.2),(1X,A,F8.6))
! Shout if goodness of fit falls below 1E-2 or 1E-3? Also maybe if Q 
! is too close to 1?
      RETURN
      END
*<ff> 

      SUBROUTINE UPDATE_ELEMENTS(ELEM,LISTA,MFIT,SCLEL,EL_TRY,BETA_TRY)
C---------------------------------------------------------------------------
C Update the trial orbital elements after one successful step
C---------------------------------------------------------------------------
      INCLUDE 'constant.inc'
      INCLUDE 'pi.inc'
      REAL*8 ELEM(MA),EL_TRY(MA)
      INTEGER MFIT,LISTA(MA)
      REAL SCLEL(MA),BETA_TRY(MA)
*
      INTEGER I,J
*
      DO I=1,MORBIT
* One actually solves for the frequency, but stores and displays the period.
* Correction and error estimate must both be multiplied by d(2*pi/x)/dx
         IF (ELEM(ELINDX(I)+I_PERIOD).NE.0) THEN
            SCLEL(ELINDX(I)+I_PERIOD)=
     +           SNGL(-ELEM(ELINDX(I)+I_PERIOD)**2/PI2)
         ELSE
            SCLEL(ELINDX(I)+I_PERIOD)=1
         ENDIF
      ENDDO
      DO I=1,MFIT
         J=LISTA(I)
         EL_TRY(J)=ELEM(J)+SCLEL(J)*BETA_TRY(I)
!               write(6,*) i,j,elem(j),sclel(j),beta_try(i),el_try(j)
      ENDDO 
      RETURN
      END
c<FF>
      SUBROUTINE SOLVE(METHOD,ALPHA_TRY,MFIT,MA,
     +     BETA_TRY,LISTA,
     +     NAMEL,QUIET,WARNING,BAD_STEP,ERROR)
C-----------------------------------------------------------------------------
c Wrapper routine that calls the currently selected linear system solver and
c performs some low level sanity checks.
C-----------------------------------------------------------------------------
*
      INTEGER MA,MFIT
      CHARACTER*(*) METHOD,NAMEL(MA)
      INTEGER LISTA(MA)
      REAL ALPHA_TRY(MA,MA),BETA_TRY(MA)
      LOGICAL QUIET,WARNING,BAD_STEP,ERROR
*
      INTEGER I
*

      IF (METHOD.EQ.'GAUSS-JORDAN') THEN 
* Gauss-Jordan elimination            
         CALL GAUSSJ(ALPHA_TRY,MFIT,MA,BETA_TRY,1,1,
     +        QUIET,WARNING,BAD_STEP)
      ELSEIF (METHOD.EQ.'DIAGONALISE') THEN
* Diagonalise the matrix, and then solve the system
         CALL DIAGSOLVE(ALPHA_TRY,MFIT,MA,BETA_TRY,LISTA,
     +        NAMEL,QUIET,WARNING,BAD_STEP)
      ELSE
         WRITE(6,*) 'F-FIT,  Unknown solution method'
         ERROR = .TRUE.
         RETURN
      ENDIF
* Protect against NaNs in corrections
      DO I=1,MFIT
         IF (BETA_TRY(I).NE.BETA_TRY(I)) BAD_STEP = .TRUE.  
      ENDDO
      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_terminal_tool
  use cubetools_parameters
  use cubetools_messaging
  !---------------------------------------------------------------------
  ! Tool to interact with an ASCII terminal or file
  !---------------------------------------------------------------------
  !
  public :: terminal,file
!!$  public :: terminal_width,strg_dash
!!$  public :: cubetools_terminal_terminal_width,cubetools_terminal_file_width
!!$  public :: cubetools_terminal_print
  private
  !
  ! Parameters
  integer(kind=4), parameter :: terminal_max_width=90
  integer(kind=4), parameter :: file_default_width=74  ! for e.g. COLLECT
  !
  ! Dynamic
  integer(kind=4) :: current_width=terminal_max_width
  integer(kind=code_k) :: current_format=help_format_term
  !
  ! ZZZ We should merge the 2 types into a common type "current
  ! output device":
  !
  type terminal_t
   contains
     procedure, public, nopass :: set_width  => terminal_set_width
     procedure, public, nopass :: width      => terminal_get_width
     procedure, public, nopass :: set_format => terminal_set_format
     procedure, public, nopass :: format     => file_get_format
     procedure, public, nopass :: dash_strg  => terminal_dash_strg
     procedure, public, nopass :: print_strg => terminal_print_strg
  end type terminal_t
  type(terminal_t) :: terminal
  !
  type file_t
   contains
     procedure, public, nopass :: set_width  => file_set_width
     procedure, public, nopass :: width      => terminal_get_width
     procedure, public, nopass :: set_format => file_set_format
     procedure, public, nopass :: format     => file_get_format
     procedure, public, nopass :: dash_strg  => terminal_dash_strg
     procedure, public, nopass :: print_strg => terminal_print_strg
  end type file_t
  type(file_t) :: file
  !
contains
  !
  subroutine file_set_width()
    !-------------------------------------------------------------------
    ! Set the current terminal width so that it is adapted for ouput to a
    ! file, for e.g., command COLLECT
    !-------------------------------------------------------------------
    current_width = file_default_width
  end subroutine file_set_width
  !
  subroutine file_set_format(forma)
    !-------------------------------------------------------------------
    ! Set the current output file format so that it is adapted for
    ! output to a file, for e.g., command COLLECT
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in) :: forma
    current_format = forma
  end subroutine file_set_format
  !
  function file_get_format()
    !-------------------------------------------------------------------
    ! Get the current output file format
    !-------------------------------------------------------------------
    integer(kind=code_k) :: file_get_format
    file_get_format = current_format
  end function file_get_format
  !
  !---------------------------------------------------------------------
  !
  subroutine terminal_set_width()
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Set the current terminal width so that it is adapted to the current
    ! terminal, if any
    !-------------------------------------------------------------------
    if (sic_isatty().eq.1) then
      ! Interactive session in a terminal
      current_width = min(sic_ttyncol(),terminal_max_width)
    else
      ! Non-interactive session, e.g. batch mode redirected to file
      current_width = file_default_width
    endif
  end subroutine terminal_set_width
  !
  function terminal_get_width() result(width)
    !-------------------------------------------------------------------
    ! Return the terminal string width adapted to the terminal size.
    ! Leave 2 blank characters to the left and to the right of the
    ! terminal.
    !-------------------------------------------------------------------
    integer(kind=4) :: width
    width = current_width-4
  end function terminal_get_width
  !
  subroutine terminal_set_format()
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    current_format = help_format_term
  end subroutine terminal_set_format
  !
  !---------------------------------------------------------------------
  !
  function terminal_dash_strg() result(strg)
    !-------------------------------------------------------------------
    ! Return a string of dashes of length tt_width
    !-------------------------------------------------------------------
    character(len=:), allocatable :: strg
    strg = repeat('-',current_width)  ! Implicit allocation
  end function terminal_dash_strg
  !
  subroutine terminal_print_strg(mkind,strg)
    !-------------------------------------------------------------------
    ! Print a message to the current output device (usually terminal,
    ! but could be a file - see e.g. COLLECT). The line is split
    ! according to the device width.
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in) :: mkind
    character(len=*),     intent(in) :: strg
    !
    character(len=mess_l) :: mess,word
    integer(kind=4) :: lenword,lenline,lenstrg,ichar
    character(len=*), parameter :: spc = ' '
    character(len=*), parameter :: rname='TERMINAL>PRINT>STRG'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    lenstrg = len_trim(strg)
    lenline = 0
    lenword = 0
    do ichar=1,lenstrg
       if (strg(ichar:ichar).eq.spc) then
          if (lenline+lenword.gt.terminal%width()) then
             ! message mess
             call cubetools_message(mkind,rname,mess)
             ! write word to begining of mess
             write(mess,'(2x,a)') word(1:lenword)
             lenline = lenword+2
          else if (lenline.eq.0) then
             write(mess,'(2x,a)') word(1:lenword)
             lenline = lenword+2
          else
             ! write word to end of mess
             write(mess(lenline+1:),'(1x,a)') word(1:lenword)
             lenline = lenline+1+lenword
          endif
          lenword=0
       elseif (ichar.eq.lenstrg) then
          lenword=lenword+1
          word(lenword:lenword) = strg(ichar:ichar)
          if (lenline+lenword.gt.terminal%width()) then
             call cubetools_message(mkind,rname,mess)
             write(mess,'(2x,a)') word(1:lenword)
             lenline = lenword+2
          else
             write(mess(lenline+1:),'(1x,a)') word(1:lenword)
             lenline = lenline+1+lenword
          endif
          call cubetools_message(mkind,rname,mess)
       else if (strg(ichar:ichar).eq.strg_cr) then
          write(mess(lenline+1:),'(1x,a)') word(1:lenword)
          lenline = lenline+1+lenword
          call cubetools_message(mkind,rname,mess(1:lenline))
          lenline = 0
          lenword = 0
       else
          lenword=lenword+1
          word(lenword:lenword) = strg(ichar:ichar)
          ! add char to word
       endif
    enddo
  end subroutine terminal_print_strg
end module cubetools_terminal_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
! Support file for intrinsic functions in Sic
!-----------------------------------------------------------------------
!
subroutine get_funcode(chain,i_code,nfunarg,error)
  use sic_interfaces, except_this=>get_funcode
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Sends back a code for the function contained in CHAIN
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain       ! The line to be analysed
  integer(kind=4),  intent(out)   :: i_code      ! Code for function
  integer(kind=4),  intent(out)   :: nfunarg(2)  ! Min-max number of arguments
  logical,          intent(inout) :: error       ! Logical error flag
  ! Global
  integer(kind=4) :: gpy_findfunc
  ! Local
  character(len=*), parameter :: rname='MTH'
  !
  ! First should check for user defined functions
  select case (chain)
  !
  ! One operand functions
  case ('ABS')
    i_code = code_abs
    nfunarg = 1
  case ('ACOS')
    i_code = code_acos
    nfunarg = 1
  case ('ASIN')
    i_code = code_asin
    nfunarg = 1
  case ('ATAN')
    i_code = code_atan
    nfunarg = 1
  case ('ATANH')
    i_code = code_atanh
    nfunarg = 1
  case ('BESSEL_I0')
    i_code = code_bessel_i0
    nfunarg = 1
  case ('BESSEL_I1')
    i_code = code_bessel_i1
    nfunarg = 1
  case ('BESSEL_J0')
    i_code = code_bessel_j0
    nfunarg = 1
  case ('BESSEL_J1')
    i_code = code_bessel_j1
    nfunarg = 1
  case ('BESSEL_Y0')
    i_code = code_bessel_y0
    nfunarg = 1
  case ('BESSEL_Y1')
    i_code = code_bessel_y1
    nfunarg = 1
  case ('COS')
    i_code = code_cos
    nfunarg = 1
  case ('COSH')
    i_code = code_cosh
    nfunarg = 1
  case ('ERF')
    i_code = code_erf
    nfunarg = 1
  case ('ERFC')
    i_code = code_erfc
    nfunarg = 1
  case ('ERFINV')
    i_code = code_erfinv
    nfunarg = 1
  case ('ERFCINV')
    i_code = code_erfcinv
    nfunarg = 1
  case ('EXP')
    i_code = code_exp
    nfunarg = 1
  case ('INT')
    i_code = code_int
    nfunarg = 1
  case ('LOG')
    i_code = code_log
    nfunarg = 1
  case ('LOG10')
    i_code = code_log10
    nfunarg = 1
  case ('NINT')
    i_code = code_nint
    nfunarg = 1
  case ('SIN')
    i_code = code_sin
    nfunarg = 1
  case ('SINH')
    i_code = code_sinh
    nfunarg = 1
  case ('SQRT')
    i_code = code_sqrt
    nfunarg = 1
  case ('TAN')
    i_code = code_tan
    nfunarg = 1
  case ('TANH')
    i_code = code_tanh
    nfunarg = 1
  case ('FLOOR')
    i_code = code_floor
    nfunarg = 1
  case ('CEILING')
    i_code = code_ceiling
    nfunarg = 1
  case ('EXIST')
    i_code = code_exist
    nfunarg = 1
  case ('FILE')
    i_code = code_file
    nfunarg = 1
  case ('FUNCTION')
    i_code = code_function
    nfunarg = 1
  case ('SYMBOL')
    i_code = code_symbol
    nfunarg = 1
  !
  ! Function with 2 arguments or more
  case ('MAX')
    i_code = code_max
    nfunarg = 2
  case ('MIN')
    i_code = code_min
    nfunarg = 2
  case ('ATAN2')
    i_code = code_atan2
    nfunarg = 2
  case ('BESSEL_IN')
    i_code = code_bessel_in
    nfunarg = 2
  case ('BESSEL_JN')
    i_code = code_bessel_jn
    nfunarg = 2
  case ('BESSEL_YN')
    i_code = code_bessel_yn
    nfunarg = 2
  case ('DIM')
    i_code = code_dim
    nfunarg = 2
  case ('MOD')
    i_code = code_mod
    nfunarg = 2
  case ('SIGN')
    i_code = code_sign
    nfunarg = 2
    !
  case ('TYPEOF')
    i_code = code_typeof
    nfunarg = 1
  case ('RANK')
    i_code = code_rank
    nfunarg = 1
  case ('SIZE')
    i_code = code_size
    nfunarg(1) = 1  ! At least 1 arg
    nfunarg(2) = 2  ! At most 2 args
  case ('INDEX')
    i_code = code_index
    nfunarg = 2
  case ('LEN')
    i_code = code_len
    nfunarg = 1
  case ('LEN_TRIM')
    i_code = code_len_trim
    nfunarg = 1
  case ('ALL')
    i_code = code_all
    nfunarg = 1
  case ('ANY')
    i_code = code_any
    nfunarg = 1
  case ('ISNAN')
    i_code = code_isnan
    nfunarg = 1
  case ('ISNUM')
    i_code = code_isnum
    nfunarg = 1
  !
  ! Try a program-defined function
  case default
    call sic_get_func(chain,i_code,nfunarg,error)
    if (error) then
#if defined(GAG_USE_PYTHON)
      if (gpy_findfunc(chain,len_trim(chain)).eq.0) then
        i_code = code_pyfunc
        nfunarg = 0
        error = .false.
      else
        call sic_message(seve%e,rname,'Unknown function '//chain)
      endif
#else
      call sic_message(seve%e,rname,'Unknown function '//chain)
#endif
    endif
  end select
end subroutine get_funcode
!
recursive subroutine read_operand_byfunc(funcode,chain,nch,descr,error)
  use gbl_message
  use sic_interfaces, except_this=>read_operand_byfunc
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Specific operand parsing for functions which do not accept
  ! numerical operands as arguments.
  !  Recursive for e.g. evaluating ANY(A.EQ.1). The function ANY invokes
  ! its own build_tree+read_operand_byfunc to compute the array 'A.EQ.1'
  !---------------------------------------------------------------------
  integer(kind=4),        intent(inout) :: funcode  ! Function code, emptied in return
  character(len=*),       intent(in)    :: chain    ! The operand
  integer(kind=4),        intent(in)    :: nch      ! Length of chain
  type(sic_descriptor_t)                :: descr    ! Resulting descriptor of operand
  logical,                intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  !
  select case (funcode)
  case (code_exist)
    call read_operand_exist(chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_file)
    call read_operand_file (chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_typeof,code_rank)
    call read_operand_descr(chain,nch,funcode,descr,error)
    funcode = code_nop
    !
  case (code_function)
    call read_operand_func(chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_symbol)
    call read_operand_symb(chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_len)
    call read_operand_len(chain,nch,.false.,descr,error)
    funcode = code_nop
    !
  case (code_len_trim)
    call read_operand_len(chain,nch,.true.,descr,error)
    funcode = code_nop
    !
  case (code_all)
    call read_operand_allorany(chain,nch,.true.,descr,error)
    funcode = code_nop
    !
  case (code_any)
    call read_operand_allorany(chain,nch,.false.,descr,error)
    funcode = code_nop
    !
  case (code_isnan)
    call read_operand_isnan(chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_isnum)
    call read_operand_isnum(chain,nch,descr,error)
    funcode = code_nop
    !
  case default
    call read_operand(chain,nch,descr,error)
    ! Keep code for other "normal" functions
    !
  end select
  !
  if (error) then
    call sic_message(seve%e,rname,'Error reading operand '//chain(1:nch))
    return
  endif
  !
end subroutine read_operand_byfunc
!
subroutine read_operand_exist(chain,nch,descr,error)
  use gildas_def
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_exist
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a variable exist...
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out) :: descr  ! Operand descriptor
  logical,                intent(out) :: error  ! Logical error flag
  ! Local
  logical :: found
  integer(kind=4) :: ip
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! It must be a variable.
  found = .true.
  call sic_descriptor (chain(1:ip),descr,found)    ! Checked
  if (.not.found) then
    call sic_descriptor ('NO',descr,found) ! Checked
  else
    call sic_descriptor ('YES',descr,found)    ! Checked
  endif
  descr%readonly = .false.
  descr%status = readonly_operand
end subroutine read_operand_exist
!
subroutine read_operand_descr(chain,nch,funcode,descr,error)
  use gbl_message
  use sic_interfaces, except_this=>read_operand_descr
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Get one of the variable descriptor properties
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain    ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch      ! Length of chain
  integer(kind=4),        intent(in)    :: funcode  ! Function code
  type(sic_descriptor_t), intent(out)   :: descr    ! Operand descriptor
  logical,                intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  logical :: found
  integer(kind=4) :: ip,val
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! It must be a variable.
  found = .true.
  call sic_descriptor (chain(1:ip),descr,found)    ! Checked
  if (.not.found) then
    call sic_message(seve%e,rname,'No such variable '//chain(1:ip))
    error = .true.
    return
  endif
  !
  ! Put the desired value in a temporary variable
  if (funcode.eq.code_typeof) then
    val = descr%type
  elseif (funcode.eq.code_rank) then
    val = descr%ndim
  endif
  !
  ! Put the value in a temporary variable
  call sic_incarnate(val,descr,error)
  if (error)  return
  !
end subroutine read_operand_descr
!
subroutine read_operand_len(chain,nch,trimmed,descr,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>read_operand_len
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return the length (trimmed or not) of a Sic variable
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain    ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch      ! Length of chain
  logical,                intent(in)    :: trimmed  ! Trimmed value?
  type(sic_descriptor_t), intent(out)   :: descr    ! Operand descriptor
  logical,                intent(inout) :: error    ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=8) :: rname
  logical :: found
  integer(kind=4) :: ip,length
  character(len=1) :: onechar
  integer(kind=address_length) :: ipnt
  !
  if (trimmed) then
    rname = 'LEN_TRIM'
  else
    rname = 'LEN'
  endif
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! It must be a variable. NB: it seems difficult to allow plain text
  ! strings e.g. SAY 'LEN("ABC")', because of complicated combinations
  ! like in IF LEN_TRIM("PI = "'PI').GT.0 THEN
  found = .true.  ! Verbose
  call sic_descriptor(chain(1:ip),descr,found)
  if (.not.found) then
    call sic_message(seve%e,rname,'No such variable '//chain(1:ip))
    error = .true.
    return
  elseif (descr%ndim.ne.0) then
    call sic_message(seve%e,rname,'Variable '//chain(1:ip)//' must be scalar')
    error = .true.
    return
  elseif (descr%type.le.0) then
    call sic_message(seve%e,rname,  &
      'Variable '//chain(1:ip)//' must be a character string')
    error = .true.
    return
  else
    if (trimmed) then
      ! Avoid copy in a (limited) temporary string
      do while (descr%type.ge.1)
        ipnt = bytpnt(descr%addr,membyt)+descr%type-1
        call bytoch(membyt(ipnt),onechar,1)
        if (onechar.ne.' ')  exit
        descr%type = descr%type-1  ! Try previous character
      enddo
    endif
    length = descr%type
  endif
  !
  ! Put the value in a temporary variable
  call sic_incarnate(length,descr,error)
  if (error)  return
  !
end subroutine read_operand_len
!
subroutine read_operand_symb(chain,nch,descr,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_structures
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_symb
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a SYMBOL exist...
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out)   :: descr  ! Operand descriptor
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: found
  integer(kind=4) :: ip
  character(len=32) :: tran
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! Check if it exists and is not Void
  call sic_getsymbol(chain(1:ip),tran,error)
  if (error.or.(len_trim(tran).eq.0)) then
    call sic_descriptor ('NO',descr,found)
    error = .false.
  else
    call sic_descriptor ('YES',descr,found)
  endif
  descr%readonly = .false.
  descr%status = readonly_operand       ! READ status in module 'sic_dictionaries'
end subroutine read_operand_symb
!
subroutine read_operand_func(chain,nch,descr,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_structures
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_func
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a function exist...
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out)   :: descr  ! Operand descriptor
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: found
  integer(kind=4) :: ip,i
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! Check if it exists
  i = sic_get_expr(chain(1:ip),ip)
  if (i.ne.0) then
    call sic_descriptor ('YES',descr,found)
  else
    call sic_descriptor ('NO',descr,found)
  endif
  descr%readonly = .false.
  descr%status = readonly_operand       ! READ status in module 'sic_dictionaries'
end subroutine read_operand_func
!
subroutine read_operand_file(chain,nch,descr,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_structures
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_file
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a file exist...
  !  The input file name (CHAIN) can be any "implicitely formatted" SIC
  ! expression.
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out)   :: descr  ! Operand descriptor
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=filename_length) :: name,file,nami
  logical :: found
  integer(kind=4) :: ip,larg,iarg
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! Debugged by S.Guilloteau 15-May-2000
  !
  ! It must be a file name, possibly coded, e.g. a variable name 'MYVAR'.
  ! Two calls to SIC_EXPAND required.
  call sic_expand(nami,chain,1,ip,iarg,error)
  call sic_expand(name,nami,1,iarg,larg,error)
  !
  ! Check just in case
  if (name(1:larg).eq.chain(1:ip)) then
    call sic_get_char(name,nami,iarg,error)
    if (iarg.ne.0) then
      name = nami
      larg = iarg
    endif
    error = .false.
  endif
  if (error) return
  !
  ! Use the generic search, which returns the file name even if a path
  ! is specified in the logical name field.
  if (sic_findfile(name,file,' ',' ')) then
    call sic_descriptor ('YES',descr,found)
  else
    call sic_descriptor ('NO',descr,found)
  endif
  descr%readonly = .false.
  descr%status = readonly_operand       ! READ status in module 'sic_dictionaries'
end subroutine read_operand_file
!
subroutine read_operand_allorany(chain,nch,doall,odesc,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>read_operand_allorany
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return true if all or any elements of a logical array are true
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  logical,                intent(in)  :: doall  ! Do ALL or ANY?
  type(sic_descriptor_t), intent(out) :: odesc  ! Output descriptor
  logical,                intent(out) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  logical, external :: all_or_any
  ! Local
  character(len=3) :: rname
  logical :: found
  integer(kind=4) :: nc
  integer(kind=address_length) :: ip
  type(sic_descriptor_t) :: idesc
  !
  if (doall) then
    rname = 'ALL'
  else
    rname = 'ANY'
  endif
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  nc = nch
  do while (nc.ge.1 .and. (chain(nc:nc).eq.')'.or.chain(nc:nc).eq.' '))
    nc = nc-1
  enddo
  !
  ! It can be a variable. Non-contiguous sub-arrays allowed.
  found = .true.  ! Verbose
  call sic_materialize(chain(1:nc),idesc,found)
  if (.not.found) then
    ! Not a variable. Try to evaluate a vectorized logical expression
    call sic_math_desc(chain,nc,fmt_l,desc=idesc,error=error)
    if (error) then
      call sic_message(seve%e,rname,'Invalid logical expression '//chain(1:nc))
      return
    endif
  endif
  if (idesc%type.ne.fmt_l) then
    call sic_message(seve%e,rname,  &
      'Variable '//chain(1:nc)//' must a logical variable or expression')
    error = .true.
    call sic_volatile(idesc)
    return
  endif
  !
  ip = gag_pointer(idesc%addr,memory)
  found = .false.
  if (all_or_any(memory(ip),desc_nelem(idesc),doall)) then
    call sic_descriptor('YES',odesc,found)
  else
    call sic_descriptor('NO',odesc,found)
  endif
  odesc%readonly = .false.
  odesc%status = readonly_operand       ! READ status in module 'sic_dictionaries'
  call sic_volatile(idesc)
  !
end subroutine read_operand_allorany
!
function all_or_any(l,n,doall)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Evaluate ALL(L) or ANY(L)
  !---------------------------------------------------------------------
  logical :: all_or_any  ! Function value on return
  integer(kind=size_length), intent(in) :: n
  logical,                   intent(in) :: l(n)
  logical,                   intent(in) :: doall
  if (doall) then
    all_or_any = all(l)
  else
    all_or_any = any(l)
  endif
end function all_or_any
!
subroutine read_operand_isnan(chain,nch,odesc,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>read_operand_isnan
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return a logical array which is true for each value evaluating as
  ! NaN
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out) :: odesc  ! Output descriptor
  logical,                intent(out) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ISNAN'
  logical :: found
  integer(kind=4) :: nc,ier
  integer(kind=address_length) :: ip,op
  type(sic_descriptor_t) :: idesc
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  nc = nch
  do while (nc.ge.1 .and. (chain(nc:nc).eq.')'.or.chain(nc:nc).eq.' '))
    nc = nc-1
  enddo
  !
  ! It can be a variable. Non-contiguous sub-arrays allowed.
  found = .true.  ! Verbose
  call sic_materialize(chain(1:nc),idesc,found)
  if (.not.found) then
    ! Not a variable. Try to evaluate a vectorized logical expression
    call sic_math_desc(chain,nc,fmt_r8,desc=idesc,error=error)
    if (error) then
      call sic_message(seve%e,rname,'Invalid expression '//chain(1:nc))
      return
    endif
  endif
  if (idesc%type.ne.fmt_r4 .and.  &
      idesc%type.ne.fmt_r8) then
    ! We could tolerate integers. Unclear for complex.
    call sic_message(seve%e,rname,  &
      'Variable '//chain(1:nc)//' must a floating point variable or expression')
    error = .true.
    call sic_volatile(idesc)
    return
  endif
  !
  ! Create a clone of same size but logical
  odesc%type = fmt_l
  odesc%ndim = idesc%ndim
  odesc%dims(:) = idesc%dims(:)
  odesc%size = desc_nelem(odesc)
  ier = sic_getvm(odesc%size,odesc%addr)
  if (ier.ne.1)  goto 10
  odesc%head => null()
  odesc%status = scratch_operand
  odesc%readonly = .false.
  ! Fill it
  ip = gag_pointer(idesc%addr,memory)
  op = gag_pointer(odesc%addr,memory)
  if (idesc%type.eq.fmt_r4) then
    call isnan_r4(memory(ip),memory(op),desc_nelem(idesc))
  else
    call isnan_r8(memory(ip),memory(op),desc_nelem(idesc))
  endif
  !
10 continue
  call sic_volatile(idesc)
  !
end subroutine read_operand_isnan
!
subroutine isnan_r4(in,out,n)
  use ieee_arithmetic
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n
  real(kind=4),              intent(in)  :: in(n)
  logical,                   intent(out) :: out(n)
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = ieee_is_nan(in(i))
  enddo
end subroutine isnan_r4
!
subroutine isnan_r8(in,out,n)
  use ieee_arithmetic
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n
  real(kind=8),              intent(in)  :: in(n)
  logical,                   intent(out) :: out(n)
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = ieee_is_nan(in(i))
  enddo
end subroutine isnan_r8
!
subroutine read_operand_isnum(chain,nch,descr,error)
  use gildas_def
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_isnum
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a string is a number or scalar number variable...
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out) :: descr  ! Operand descriptor
  logical,                intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ISNUM'
  logical :: found
  integer(kind=4) :: nc, ier
  type(sic_descriptor_t) :: idesc
  real(8) :: dble
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  nc = nch
  do while (nc.ge.1 .and. (chain(nc:nc).eq.')'.or.chain(nc:nc).eq.' '))
    nc = nc-1
  enddo
  !
  ! Default result
  descr%readonly = .false.
  descr%status = readonly_operand
  error = .false.
  call sic_descriptor ('NO',descr,found)
  !
  ! It can be a variable. Non-contiguous sub-arrays allowed.
  found = .true.  ! Verbose
  call sic_materialize(chain(1:nc),idesc,found)
  if (.not.found) then
    !
    if (chain(1:1).eq."'".and.chain(nc:nc).eq."'") then
      ! Try to evaluate the expression
      call sic_math_desc(chain,nc,fmt_r8,desc=idesc,error=error)
      call sic_volatile(idesc)
      if (error) then
        call sic_message(seve%e,rname,'Invalid expression '//chain(1:nc))
        return
      endif
    else
      ! Plain reading 
      read(chain(1:nc),*,iostat=ier) dble
      idesc%type = fmt_l
      if (ier.eq.0) idesc%type = fmt_r8 ! A number
    endif
  endif
  !
  ! Check it is scalar
  !!Print *,'Allowed types ',fmt_r4,fmt_r8,fmt_i4,fmt_i8
  if (idesc%type.eq.fmt_r4 .or.  &
      idesc%type.eq.fmt_r8 .or.  &
      idesc%type.eq.fmt_i4 .or.  &
      idesc%type.eq.fmt_i8) then
    if (idesc%ndim.eq.0) then
      call sic_descriptor ('YES',descr,found) ! Checked
    else if (product(idesc%dims(1:idesc%ndim)).eq.1) then
      call sic_descriptor ('YES',descr,found) ! Checked
    endif
  endif
  call sic_volatile(idesc)
  descr%readonly = .false.
  descr%status = readonly_operand
  error = .false.
end subroutine read_operand_isnum
!

!
subroutine translate (in, nx, ny, trans, ix, iy)
  !-----------------------------------------------------------------------
  ! @ private
  !
  !     Translate the beam to new position IX, IY
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx          ! X size
  integer, intent(in) :: ny          ! Y size
  real, intent(in) :: in(nx,ny)      ! Input beam
  real, intent(out) :: trans(nx,ny)  ! Translated beam
  integer, intent(in) :: ix          ! X shift
  integer, intent(in) :: iy          ! Y shift
  !
  ! Local
  integer i,j
  !
  trans = 0.0  ! That seemed to have been forgotten until 23-Sep-2009
  ! but this was only a side effect, anyway
  !
  do j=max(1,iy+1),min(ny,ny+iy)
    do i=max(1,ix+1),min(nx,nx+ix)
      trans(i,j) = in(i-ix,j-iy)
    enddo
  enddo
end subroutine translate

subroutine gtx_err
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtx_err
  use gildas_def
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Traps an error according to ERFLAG.
  !---------------------------------------------------------------------
  error_condition = .true.
  if (erflag) return
  call gtv_message(seve%f,'GTVIRT','Error not trapped')
  call sysexi (fatale)
end subroutine gtx_err

subroutine solve_tp(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  !---------------------------------------------------------------------
  ! Antenna based.
  ! SOLVE arg /TOTAL /FIX /PLOT /COMPRESS
  ! option numbers
  !      1  /PLOT
  !                      (plot data and fit)
  !      6  /COMPRESS
  !                      (used to improve SNR and combine beam switch states)
  !     11  /FIX parameter1 value1 parameter2 value2 ...
  !                      ( to fix parameters)
  !     12  /TOTAL       (is there)
  !         /OUT
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  external :: fitfcn
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  include 'gbl_memory.inc'
  include 'clic_tpfit.inc'
  ! Local
  logical :: plot, weight, compress, check
  logical :: output, tpoint,print
  integer :: i, lwork, jb, nkey, old_pen, iopt, itype
  integer :: p_lun, q_lun
  integer(kind=address_length) :: ipwork, ipfvec, ipr, ipwa, ipwa1
  integer(kind=address_length) :: ipwa2, ipwa3, ipwa4, ipiw, ipcheck, addr, mtype, my
  parameter (mtype=4, my=2)
  integer :: nvpar, lwa, ia, ib, ix, nprint, info
  integer :: ldr, k, lc, kant, narg, ncoord(mtype)
  integer(kind=index_length) :: dim(4)
  real :: t0, l0(mdim), t1, diam, rms, rarg, coll(2)
  real :: plate
  character(len=6) :: cpar(mpar,mtype),arg
  character(len=80) :: chain
  character(len=12) :: ctype(mtype),yvocab(my)
  integer :: xy_par
  real*8 :: vpar(mpar), fsumsq, cj(mpar), denorm, epars(mpar)
  real*8 :: p0(mpar), y0, dy0(mpar), dy1, y, dy(mpar), tol, xx(mdim)
  real*8 :: d1mach, parant(mnant,mpar), eparant(mnant,mpar), freq
  save parant, eparant
  !
  parameter (check = .false.)
  !cc      parameter (check = .true.) !! for derivative calculation testing only
  data cpar /'AZ','EL','PEAK','WIDTH','ZERO','ASTIGM',   &
    'ZFOCUS','PEAK','WIDTH','ZERO',' ',' ',   &
    'XFOCUS','PEAK','WIDTH','ZERO',' ',' ',   &
    'YFOCUS','PEAK','WIDTH','ZERO',' ',' '/
  data ctype /'POINTING','FOCUS','XFOCUS','YFOCUS'/
  data ncoord /2,1,1,1/
  data yvocab/'TOTAL', 'T02'/
  !------------------------------------------------------------------------
  ! Code:
  call xsetf(0)
  lwork = 0
  tol = sqrt(d1mach(4))
  old_pen = -1
  !
  ! reset some defaults for plotting
  call check_index(error)
  if (error) return
  call get_first(.false.,error)
  if (error) return
  !
  ! First argument: type of fit
  call clic_kw(line,0,1,arg,nkey,ctype,mtype,.true.,error,.true.)
  if (error) return
  itype = nkey
  call message(6,1,'SOLVE_TP','Solve type is '//ctype(itype))
  print = sic_present(10,0)
  !
  ! /OUTPUT FLUX|OLD|NEW, /PRINT
  call file_point(line,output,p_lun,flux,q_lun,tpoint,error)
  !
  ! Fixed parameters (option 11)
  do i=1, mpar
    variable(i) = .true.
  enddo
  if (sic_present(11,0)) then
    i = 1
    nkey = 0
    do while (i.le.sic_narg(11))
      call sic_ch(line,11,i,arg,narg,.true.,error)
      if (error) return
      if (ichar(arg(1:1)).gt.ichar('9')) then
        call clic_kw(line,11,i,arg,nkey,   &
          cpar(1,itype),mpar,.true.,error,.true.)
        if (error) return
        variable(nkey) = .false.
        i = i+1
      elseif (nkey.gt.0) then
        call sic_r4(line,11,i,rarg,.true.,error)
        pars(nkey) = rarg
        i = i+1
        chain = cpar(nkey,itype)//' fixed to'
        lc = lenc(chain)
        write (chain(lc+1:),'(1x,1pg13.6)') pars(nkey)
        lc = lc + 14
        call message(6,1,'SOLVE_TP',chain(1:lc))
      endif
    enddo
  endif
  chain = 'Fitting'
  lc = 7
  do i=1, mpar
    if (variable(i)) then
      chain(lc+1:) = ' ' // cpar(i,itype)
      lc = lc + 1 +lenc(cpar(i,itype))
    endif
  enddo
  call message(6,1,'SOLVE_TP',chain(1:lc))
  !
  ! /COMPRESS option
  !c      compress = sic_present(6,0)
  !
  ! Get  a first one
  call get_first(.true.,error)
  if (error) goto 999
  compress = r_nswitch.gt.0
  !      print *, r_scaty
  !      print *, ctype(itype),r_scaty
  if ((itype.eq.3).or.(itype.eq.4)) then
    if (r_scaty.eq.11) then
      itype = 3
    elseif (r_scaty.eq.12) then
      itype = 4
    endif
  endif
  !
  ! Plot and data description
  if (ctype(itype).eq.'POINTING') then
    fbeam = 1.5
    !
    ! Lambda, Beta in X
    ndim = 2
    if (n_x.ne.ndim) then
      n_x = ndim
      change_display = .true.
    endif
    if (i_x(1) .ne. xy_lambd) then
      i_x(1) = xy_lambd
      sm_x1(1) = '*'
      sm_x2(1) = '*'
      do_bin = .false.
      change_display = .true.
    endif
    if (i_x(2) .ne. xy_beta) then
      i_x(2) = xy_beta
      sm_x1(2) = '*'
      sm_x2(2) = '*'
      do_bin = .false.
      change_display = .true.
    endif
  else
    !
    ! Focus in X
    fbeam = 10.
    ndim = 1
    if (n_x.ne.ndim) then
      n_x = ndim
      change_display = .true.
    endif
    if (ctype(itype).eq.'FOCUS') then
      if (i_x(1) .ne. xy_focus) then
        i_x(1) = xy_focus
        sm_x1(1) = '*'
        sm_x2(1) = '*'
        do_bin = .false.
        change_display = .true.
      endif
    ! XFOCUS or YFOCUS: use lambda or beta
    elseif (ctype(itype).eq.'XFOCUS') then
      if (i_x(1) .ne. xy_lambd) then
        i_x(1) = xy_lambd
        sm_x1(1) = '*'
        sm_x2(1) = '*'
        do_bin = .false.
        change_display = .true.
      endif
    elseif (ctype(itype).eq.'YFOCUS') then
      if (i_x(1) .ne. xy_beta) then
        i_x(1) = xy_beta
        sm_x1(1) = '*'
        sm_x2(1) = '*'
        do_bin = .false.
        change_display = .true.
      endif
    endif
  endif
  !!      npar = ndim+3
  npar = ndim+4
  !
  ! Total Power in Y by default can be overridden in /TOTAL T02
  arg='TOTAL'
  call clic_kw(line,12,1,arg,nkey,yvocab,my,.false.,error,.true.)
  if (error) return
  call message(6,1,'SOLVE_TP','Y variable is '//yvocab(nkey))
  if (yvocab(nkey).eq.'TOTAL') then
    xy_par = xy_total
  elseif (yvocab(nkey).eq.'T02') then
    xy_par = xy_t02
  endif
  if (n_y.ne.1) then
    n_y = 1
    change_display = .true.
  endif
  if (i_y(1) .ne. xy_par) then
    i_y(1) = xy_par
    sm_y1(1) = '*'
    sm_y2(1) = '*'
    do_bin = .false.
    change_display = .true.
  endif
  call switch_antenna
  !
  call set_display(error)
  if (error) return
  !
  ! plot all scans in index, UNsorted, plot buffer re-initialized.
  if (compress) then
    call read_data('COMPRESS',.false.,.true., error)
  else
    call read_data('ALL',.false.,.true., error)
  endif
  plotted = .false.
  if (error) return
  change_display = .false.
  plot = sic_present(1,0)
  weight = sic_present(2,0)
  if (plot) then
    clear = .true.
    if (.not. plotted) call sub_plot('A',.false.,.false.,0,error)
    if (error) return
    plotted = .true.
    old_pen = gr_spen (1)
    call gr_segm('FIT',error)
  endif
  !cc      return
  !cc 1999 continue
  !
  ! Get storage:
  !
  do i=1, npar
    epars(i) = 0
  enddo
  np = n_data(1)
  nb = m_boxes
  if (np.eq.0) goto 999
  lwa = npar*(np+5) + np
  lwork = 6*np + 2*lwa + 2*npar*np + 7*npar
  if (sic_getvm(lwork,addr) .ne. 1) goto 999
  ipwork = gag_pointer(addr, memory)
  !
  ipfvec = ipwork
  ipwa = ipfvec + 2*np
  ipr = ipwa + 2*lwa
  ipwa1 = ipr + 2*npar*np
  ipwa2 = ipwa1 + 2*npar
  ipwa3 = ipwa2 + 2*npar
  ipwa4 = ipwa3 + 2*npar
  ipiw = ipwa4 + npar
  ipcheck = ipiw + 4*np
  if (ipcheck-ipwork .ne. lwork) goto 999
  !
  ipx = gag_pointer(data_x,memory)
  ipy = gag_pointer(data_y,memory)
  ipw = gag_pointer(data_w,memory)
  ipfvec = ipwork
  !
  ! Get beam size
  if (r_presec(alma_sec)) then
    diam = r_dishdiameter(1)
  else
    call get_diameter(r_teles, diam)
  endif
  print *, 'diameter ',diam
  ! this is the half power  beam size - or width of focus curve
  freq = r_flo1 + r_isb*r_fif1
  if (ctype(itype) .eq. 'POINTING') then
    beam = 41*(115000./freq)*(15./diam)
    print *, 'Estimated beam size ',beam, ' arc sec.'
  elseif (ctype(itype) .eq. 'FOCUS') then
    beam = 4.2*sqrt(95000./freq)   ! IS THIS TRUE ?
    print *, 'Estimated width of focus curve ',beam, ' mm.'
  elseif (ctype(itype) .eq. 'XFOCUS' .or.   &
    ctype(itype) .eq. 'YFOCUS') then
    beam = 21.5*sqrt(95000./freq)  ! IS THIS TRUE ?
    print *, 'Estimated width of focus curve ',beam, ' mm.'
    plate = 33.5
    if (ctype(itype) .eq. 'YFOCUS') plate=-plate
    beam = beam*abs(plate)
    print *, '(converted into ',beam, ' arc sec.)'
  endif
  !
  ! /PRINT option
  if (q_lun.ne.0) then
    if (r_scaty.eq.1) then
      call check_scan(q_lun,r_scan,'Focus')
    else
      call check_scan(q_lun,r_scan,'Pointing')
    endif
  endif
  !
  ! Indentify box numbers
  antenna: do jb = 1, n_base
    ia = - i_base(jb)
    if (.not.r_mobil(ia)) then
      exit antenna
    endif
    do i=1, ndim
      ibx(i) = 0
    enddo
    do ib=1, n_boxes
      if (jb.eq.k_base(ib)) then
        ix = i_x(k_x(ib))
        if (ix.eq.xy_lambd   &
          .or. ix.eq.xy_focus   &
          .or.   &
          (ix.eq.xy_beta.and.ctype(itype).eq.'YFOCUS'))   &
          then
          ibx(1) = ib
        elseif (ix.eq.xy_beta) then
          ibx(2) = ib
        endif
      endif
    enddo
    !         print *, '(ibx(i),i=1, ndim)'
    !         print *, (ibx(i),i=1, ndim)
    if (ibx(1).eq.0) goto 999
    !
    ! Guess parameters
    call guess_tp(l0, t0, t1, error)
    if (error) return
    do k=1, ndim
      if (variable(k)) pars(k) = l0(k)
    enddo
    k = ndim+1
    if (variable(k)) pars(k) = t1
    k = k+1
    if (variable(k)) pars(k) = beam
    k = k+1
    if (variable(k)) pars(k) = t0
    k = k+1
    if (variable(k)) pars(k) = 1.d0
    nvpar = 0
    !         print *, '(pars(k), k=1, ndim)'
    !         print *, (pars(k), k=1, ndim)
    !
    ! Check derivatives
    if (check) then
      xx(1) = 0.
      xx(2) = 0.
      call gmodel(xx, pars, y, dy)
      do i=1, npar
        p0(i) = pars(i)
        dy0(i) = dy(i)
        y0 = y
      enddo
      do i=1, npar
        pars(i) = p0(i)*1.001d0
        call gmodel(xx, pars, y, dy)
        dy1 = (y-y0)/(pars(i)-p0(i))
        !               print *, 'TEST', i, dy0(i), dy1
        pars(i) = p0(i)
      enddo
    endif
    !
    do i=1, npar
      if (variable(i)) then
        nvpar = nvpar+1
        vpar(nvpar) = pars(i)
      endif
    enddo
    nprint = -1
    !         print *, '(pars(k), k=1, ndim)'
    !         print *, (pars(k), k=1, ndim)
    !         print *, (vpar(k), k=1, nvpar)
    !
    iopt=2                     ! full jacobian
    !cc         iopt = 1               ! no jacobian
    !         print *, 'call dnls1e'
    call dnls1e(fitfcn,   &    ! function
      iopt,   &                ! jacobian code
      np,   &                  ! number of points
      nvpar,   &               ! number of fitted parameters
      vpar,   &                ! fitted parameters
      memory(ipfvec),   &      !
      tol,   &
      nprint,   &
      info,   &                ! error code
      memory(ipiw),   &
      memory(ipwa),   &
      lwa)
    !
    if (info.eq.0) then
      print *,'F-DNLS1E, improper input parameters, info= ',   &
        info
    elseif (info.eq.6 .or. info.eq.7) then
      print *,'F-DNLS1E, TOL too small, info= ',info
    elseif (info.eq.5) then
      print *,'F-DNLS1E, not converging, info= ',info
    elseif (info.eq.4) then
      print *,'W-DNLS1E, FVEC orthog. to Jacob. col., info= ',   &
        info
    endif
    fsumsq  = denorm(np, memory(ipfvec))
    !
    ldr = np
    !         print *, 'call dcov'
    call dcov (fitfcn,   &
      iopt,   &
      np,   &
      nvpar,   &
      vpar,   &
      memory(ipfvec),   &
      memory(ipr),   &
      ldr,   &
      info,   &
      memory(ipwa1),   &
      memory(ipwa2),   &
      memory(ipwa3),   &
      memory(ipwa3))
    if (info.eq.0) then
      print *,'F-DCOV, improper input parameters, info= ',info
    elseif (info.eq.2) then
      print *,'W-DCOV, Jacobian singular, info= ',info
    endif
    !
    ! extract the diagonal of r
    call diagonal(np, nvpar, memory(ipr), cj)
    rms = fsumsq*dsqrt(np*1d0)
    kant = r_kant(ia)
    write(chain,'(a,1x,i0,a,f10.4,a)') 'Ant',kant,' r.m.s.= ',rms,   &
      ' units of '//clab(i_y(1))
    lc = lenc(chain)
    call message(6,1,'SOLVE_TP',chain(1:lc))
    k = 0
    do i=1, npar
      write(chain,'(a4,i0,1x,a5)') 'Ant ',kant, cpar(i,itype)
      lc = 12
      if (variable(i)) then
        k = k+1
        pars(i) = vpar(k)
        epars(i) = sqrt(abs(cj(k)))
        if (cpar(i,itype).eq.'XFOCUS'   &
          .or. cpar(i,itype) .eq. 'YFOCUS'   &
          .or. (cpar(i,itype) .eq. 'WIDTH'   &
          .and. (ctype(itype) .eq. 'XFOCUS'   &
          .or. ctype(itype) .eq. 'YFOCUS')))   &
          then
          write(chain(lc+1:),1000) pars(i)/plate,   &
            '(',epars(i)/abs(plate),')'
          parant(ia,i) = pars(i)/plate
          eparant(ia,i) = epars(i)/abs(plate)
        else
          write(chain(lc+1:),1000) pars(i), '(',epars(i),')'
          parant(ia,i) = pars(i)
          eparant(ia,i) = epars(i)
        endif
1000    format(1x,f8.3,1a,f5.3,1a)
      else
        epars(i) = 0
        eparant(ia,i) = 0
        if (cpar(i,itype).eq.'XFOCUS'   &
          .or. cpar(i,itype) .eq. 'YFOCUS'   &
          .or. (cpar(i,itype) .eq. 'WIDTH'   &
          .and. (ctype(itype) .eq. 'XFOCUS'   &
          .or. ctype(itype) .eq. 'YFOCUS')))   &
          then
          write(chain(lc+1:),1001) pars(i)/plate, '(fixed)'
          parant(ia,i) = pars(i)/plate
        else
          write(chain(lc+1:),1001) pars(i), '(fixed)'
          parant(ia,i) = pars(i)
        endif
1001    format(1x,f8.3,7a)
      endif
      lc = lenc(chain)
      call message(6,1,'SOLVE_TP',chain(1:lc))
    enddo
    ! use message ...
    if (plot) then
      call plot_fittp(error)
    endif
    !
    ! Optionally write result file for POINT / TPOINT
    !
    if (output .and. r_mobil(ia)) then
      coll(1) = r_collaz(ia)
      coll(2) = r_collel(ia)
      ! (tpoint use only valid for one antenna...)
      if (tpoint) then
        write(p_lun,2003)   &
          r_num, r_scan, r_ut*12d0/pi,   &
          pars(1), epars(1), pars(2), epars(2),   &
          pars(3), epars(3),   &
          pars(4), epars(4), r_sourc
2003    format('!',2i5, f6.2, 8f8.2, 1x, a12)
        write(p_lun,2002)   &
          r_az*180d0/pi, r_el*180d0/pi,   &
          r_az*180d0/pi+(pars(1)+coll(1))/cos(r_el)/3600.d0,   &
          r_el*180d0/pi+(pars(2)+coll(2))/3600.d0
2002    format(3(1x,f10.5,','),1x,f10.5)
      else
        do i=1, 2
          write(p_lun,2001)   &
            r_num, r_scan, 2-i,   &
            r_az*180d0/pi, r_el*180d0/pi, r_ut*12d0/pi,   &
            r_kant(ia), r_istat(ia),   &
            pars(i)+coll(i), epars(i),   &
            pars(4), epars(4),   &
            pars(3), r_sourc, pars(i)
        enddo
2001    format(1x,i8,i6,i4,3(2x,f8.3),1x,2i4,   &
          2(f9.2,' ',f8.2,'  '),g10.3,2x,'''',a,''' ',f9.2)
      endif
    endif
    if (print) then
      if (ctype(itype) .eq. 'POINTING') then
        write(q_lun,3002) pars(1),pars(2),kant,r_nrec
3002    format('CORRECTION ',f6.1,1x,f6.1,' /ANTENNA ',i0, &
        ' /RECEIVER ',i0)
      elseif (ctype(itype) .eq. 'FOCUS') then
        write(q_lun,3001) pars(1),kant,r_nrec
3001    format('CORRECTION * * ',f6.2,' /ANTENNA ',i0, &
        ' /RECEIVER ',i0)
      endif
    endif
  enddo antenna
  ! Variables
  do i=1, npar
    call sic_delvariable('F_'//cpar(i,itype),.false.,error)
    call sic_delvariable('E_'//cpar(i,itype),.false.,error)
    dim(1)=mnant
    dim(2)= 1
    dim(3) = 1
    dim(4) = 1
    call sic_def_dble('F_'//cpar(i,itype),parant(1,i),1,dim,   &
      .false., error)
    call sic_def_dble('E_'//cpar(i,itype),eparant(1,i),1,dim,   &
      .false.,error)
  enddo
  !
998 if (output) then
    !         print *, 'close ',p_lun
    close(unit=p_lun)
    call sic_frelun(p_lun)
  endif
  if (print) then
    close(unit=q_lun)
    call sic_frelun(q_lun)
  endif
  if (lwork.gt.0) call free_vm(lwork,addr)
  if (old_pen.ne.-1)  then
    call gr_segm_close(error)
    i = gr_spen(old_pen)
  endif
  return
  !
999 error = .true.
  goto 998
end subroutine solve_tp
!
subroutine fitfcn(iflag,m,nvpar,x,f,fjac,ljc)
  use gildas_def
  !---------------------------------------------------------------------
  ! FCN is called by DNLS1E
  !
  !     IFLAG   Integer    Code for print out                Input
  !     M       Integer    Number of data points             Input
  !     NVPAR   Integer    Number of variable parameters     Input
  !     X       Real*8     Variable Parameters               Input
  !     F       Real*8     Function value at each point      Output
  !     FJAC    Real*8     Partial derivatives of F          Output
  !     LJC     Integer    First dimension of FJAC           Input
  !
  ! replacing     SUBROUTINE LSFUN2(M, NVPAR, X, F, FJAC, LJC)
  !---------------------------------------------------------------------
  integer :: iflag                  !
  integer :: m                      !
  integer :: nvpar                  !
  real*8 :: x(nvpar)                !
  real*8 :: f(m)                    !
  integer :: ljc                    !
  real*8 :: fjac(ljc,nvpar)         !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  include 'clic_tpfit.inc'
  ! Local
  integer :: k, i, l, j, kvpar
  real*8 :: tt, ww, ll(mdim), y, dy(mpar), denorm, sw
  real*8 :: rr
  !------------------------------------------------------------------------
  k = 1
  sw = 0
  !
  ! Put the variable parameters in PARS (already including the fixed ones)
  kvpar = 1
  do j=1, npar
    if (variable(j)) then
      pars(j) = x(kvpar)
      kvpar = kvpar+1
    endif
  enddo
  do i=1, np
    !
    ! Get total power
    call gettotal(m_data, m_boxes,   &
      memory(ipx), memory(ipy), memory(ipw),   &
      i, ll, tt, ww)
    rr = 0
    do l=1, ndim
      rr = rr+ll(l)**2
    enddo
    rr = sqrt(rr)
    !
    ! fit out to 1.5 beam radius only
    !         if (rr.gt.beam*fbeam) then
    !            ww = 0
    !         endif
    !
    if (iflag.le.1) then
      f(k) = -tt
    elseif (iflag.eq.2) then
      do l=1, nvpar
        fjac(k,l) = 0
      enddo
    endif
    !
    ! Compute F and FJAC from model
    call gmodel(ll, pars, y, dy)
    kvpar = 1
    if (iflag.le.1) then
      f(k) = f(k) + y
    elseif (iflag.eq.2) then
      do l = 1, mpar
        if (variable(l)) then
          fjac(k,kvpar) = fjac(k,kvpar) + dy(l)
          kvpar = kvpar+1
        endif
      enddo
    endif
    !
    ! Weight appropriately:
    !
    if (iflag.le.1) then
      f(k) = f(k)*ww
    elseif (iflag.eq.2) then
      do l=1, nvpar
        fjac(k,l) = fjac(k,l)*ww
      enddo
    endif
    k = k + 1
    sw = sw + ww
  enddo
  !
  ! In the end: normalize by the sum of weights.
  k = 1
  do i=1, np
    if (iflag.le.1) then
      f(k) = f(k)/sw
    elseif (iflag.eq.2) then
      do l=1, nvpar
        fjac(k,l) = fjac(k,l)/sw
      enddo
    endif
    k = k + 1
  enddo
  if (iflag.eq.0) then
    print 1000, (x(i), i=1, nvpar), denorm(k-1,f)
1000 format (10(1pg19.12))
  endif
  return
end subroutine fitfcn
!
subroutine gettotal(mp, mb, xd, yd, wd,   &
    i, ll, tt, ww)
  use gildas_def
  !---------------------------------------------------------------------
  !     Obtain U, V, and the visibility from the array UVRIW.
  !
  !     Np     Integer     Number data points        Input
  !     Nb     Integer     Number of boxes            Input
  !     xd     real        X data plot array
  !     yd     real        Y data plot array
  !     ibl    integer     box number of lambda       Input
  !     ibb    integer     box number of beta         Input
  !     i      integer     point nmber                Input
  !
  !     ll     Real*8      Lambda coord.              Output
  !     bb     Real*8      Beta   coord.              Output
  !     tt     Real*8      Total Power                Output
  !     ww     Real*8      Weight                     Output
  !---------------------------------------------------------------------
  include 'clic_tpfit.inc'
  integer :: mp                     !
  integer :: mb                     !
  real :: xd(mp, mb)                !
  real :: yd(mp, mb)                !
  real :: wd(mp, mb)                !
  integer :: i                      !
  real*8 ::  ll(mdim)               !
  real*8 ::  tt                     !
  real*8 ::  ww                     !
  ! Local
  integer :: k
  !-----------------------------------------------------------------------
  do k=1, ndim
    ll(k) = xd(i, ibx(k))
  enddo
  tt = yd(i, ibx(1))
  ww = wd(i, ibx(1))
  return
end subroutine gettotal
!
subroutine diagonal(m,n,r,c)
  integer :: m                      !
  integer :: n                      !
  real*8 :: r(m,n)                  !
  real*8 :: c(n)                    !
  ! Local
  integer :: i
  do i=1, n
    c(i) = r(i,i)
  enddo
end subroutine diagonal
!
subroutine guess_tp(x0, t0, t1, error)
  use gildas_def
  include 'clic_tpfit.inc'
  real :: x0(mdim)                  !
  real :: t0                        !
  real :: t1                        !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: i, k
  real*8 :: s_w, s_wt, s_wt2, s_wf, s_wf2, s_wx(mdim), s_wxt(mdim)
  real*8 :: xx(mdim), tt, ww, ff, rr2, b2, cx(mdim)
  ! Code
  s_w = 0
  s_wt = 0
  s_wf = 0
  s_wt2 = 0
  s_wf2 = 0
  do k= 1, ndim
    s_wx(k) = 0
    s_wxt(k) = 0
  enddo
  !
  ! estimate  total power offset  and flux, and position(s)
  ! beam is assumed known at this point
  ! get center in all dimensions
  do i=1, np
    call gettotal(m_data, m_boxes,   &
      memory(ipx), memory(ipy), memory(ipw),   &
      i, xx, tt, ww)
    do k=1, ndim
      s_wx(k) = s_wx(k) + ww*xx(k)
    enddo
    s_w = s_w + ww
  enddo
  if (s_w .le. 0) then
    error = .true.
    call message (8,3,'GUESS_TP','Sum of weights <= zero')
    return
  endif
  do k=1, ndim
    cx(k) = s_wx(k)/s_w
    !         print *, k, cx(k)
    s_wx(k) = 0
  enddo
  !
  ! circular range of estimation
  b2 = (beam*fbeam)**2
  do i=1, np
    call gettotal(m_data, m_boxes,   &
      memory(ipx), memory(ipy), memory(ipw),   &
      i, xx, tt, ww)
    !
    rr2 = 0
    do k=1, ndim
      xx(k) = xx(k) - cx(k)
      rr2 = rr2 + xx(k)**2
    enddo
    if (rr2.le.b2) then
      ff = exp(-4*log(2.)*rr2/beam**2)
      s_wf = s_wf + ww*ff
      s_wf2 = s_wf2 + ww*ff*ff
      s_wt = s_wt + ww*tt
      s_wt2 = s_wt2 + ww*tt*tt
      s_w = s_w + ww
      do k=1, ndim
        s_wx(k) = s_wx(k) + ww*xx(k)
        s_wxt(k) = s_wxt(k) + ww*xx(k)*tt
      enddo
    endif
  enddo
  if (s_w .le. 0) then
    error = .true.
    call message (8,3,'GUESS_TP','Sum of weights <= zero')
    return
  endif
  t1 = (s_wt2*s_w - s_wt**2) / (s_wf2*s_w - s_wf**2)
  t1 = sqrt(abs(t1))
  t0 = (s_wt - t1*s_wf) / s_w
  !      print *, 't0, t1 ', t0, t1
  do k=1, ndim
    x0(k) = (s_wxt(k) - t0 * s_wx(k)) / (s_wt - t0*s_w) + cx(k)
  !         print *, 'k, x0(k) ', k, x0(k)
  enddo
  return
end subroutine guess_tp
!*
subroutine gmodel(xx, par, y, dy)
  use gildas_def
  !---------------------------------------------------------------------
  ! Function is
  !     t0 + t1 * exp (-4.*log(2.)*((xx-x0)**2+(yy-y0)**2)*ast**2)/beam**2
  ! pars are:
  !
  !     1 x0       x position
  !     2 y0       y position [optional]
  !     3 t1       amplitude (peak-offset)
  !     4 beam     half-power beam
  !     5 t0       amplitude offset
  !     6 ast      beam ratio y/x
  !---------------------------------------------------------------------
  include 'clic_tpfit.inc'
  real*8 :: xx(mdim)                !
  real*8 :: par(6)                  !
  real*8 :: y                       !
  real*8 :: dy(6)                   !
  ! Global
  real*8 :: z_exp
  ! Local
  !      integer ndim
  real*8 :: c, d, e, f, a
  integer :: kx(mdim), kt1, kw, kt0, k, i, kast
  !--------------------------------------------------------------------------
  !
  k = 1
  do i=1, ndim
    kx(i) = k
    k = k+1
  enddo
  kt1 = k                      ! amplitude
  k = k+1
  kw = k                       ! width
  k = k+1
  kt0 = k                      ! zero
  k = k+1
  kast = k                     ! zero
  c = 4.*log(2.)
  d = 0
  a = 1.d0
  do i=1, ndim
    if (i.eq.2) a = par(kast)
    d = d + ((xx(i)-par(kx(i)))*a)**2
  enddo
  e = par(kw)**2
  if (e.eq.0) return
  f = z_exp(-c*d/e)
  y = par(kt1) * f
  a = 1.d0
  do i = 1, ndim
    if (i.eq.2) a = par(kast)
    dy(kx(i)) = 2 * c / e * (xx(i)-par(kx(i))) * a**2 * y
  enddo
  dy(kt1) = f
  dy(kw) = par(kw) * 2*c*d/e**2 * y
  if (ndim.gt.1) then
    dy(kast) = - 2*c/e * par(kast) * (xx(2)-par(kx(2)))**2 * y
  endif
  y = y + par(kt0)
  dy(kt0) = 1.
  return
end subroutine gmodel
!
subroutine get_diameter(telescope,diam)
  character(len=12) :: telescope    !
  real *4 :: diam                   !
  ! Global
  include 'clic_panels.inc'
  !
  if (telescope.eq.'VTX-ALMATI') then
    write(6,*) 'I-GET_DIAMETER, ALMA Vertex 12m Antenna '
    call set_panels(type_vx12m)
  elseif (telescope.eq.'AEC-ALMATI') then
    write(6,*) 'I-GET_DIAMETER, ALMA AEC 12m Antenna '
    call set_panels(type_vx12m)
  else
    write(6,*) 'I-GET_DIAMETER, IRAM/NOEMA 15-m Antenna '
    call set_panels(type_bure)
  endif
  diam = diameter
  return
end subroutine get_diameter
!
function z_exp(x)
  real*8 :: z_exp                   !
  real*8 :: x                       !
  ! Local
  real*8 :: d1mach, xmin, ymin
  logical :: first
  data first/.true./
  save xmin, ymin, first
  if (first) then
    ymin = 2*d1mach(1)
    xmin = log(ymin)
    first = .false.
  endif
  if (x.lt.xmin) then
    z_exp = ymin
    return
  endif
  z_exp = exp(x)
  return
end function z_exp
!
subroutine plot_fittp(error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! Plot total power fit.
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  include 'clic_tpfit.inc'
  ! Local
  integer :: nn, i, j, k
  parameter (nn=100)
  real*4 :: xx(nn), yy(nn), xmin, xmax, dx
  real*8 :: ll(mdim), tt, dy(mpar)
  character(len=4) :: chain
  !---------------------------------------------------------------------------
  ! Code
  !
  ! ndim boxes:
  do i = 1, ndim
    write(chain,'(i4.4)') ibx(i)
    call gr_execl('CHANGE DIRECTORY BOX'//chain)
    error = gr_error()
    if (error) goto 999
    call sic_get_real ('USER_XMIN',xmin,error)
    call sic_get_real ('USER_XMAX',xmax,error)
    if (error) goto 999
    dx = (xmax-xmin)/(nn-1)
    do k = 1, nn
      xx(k) = xmin + (k-1)*dx
      do j=1, ndim
        if (j.eq.i) then
          ll(j) = xx(k)
        else
          ll(j) = 0.
        endif
      enddo
      call gmodel(ll, pars, tt, dy)
      yy(k) = tt
    enddo
    call gr4_connect (nn, xx, yy, 0.0d0, -1.0d0)
    call gr_execl('CHANGE DIRECTORY')
  enddo
  !
999 return
end subroutine plot_fittp
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtholo_pack_set(pack)
  use gpack_def
  use mrtholo_dependencies_interfaces
  use mrtholo_interfaces, except_this => mrtholo_pack_set
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack
  !
  external :: clic_pack_set
  !
  pack%name='mrtholo'
  pack%ext='.holo'
  pack%authors="R.Lucas"
  pack%depend(1:4) = (/ locwrd(sic_pack_set),    locwrd(greg_pack_set),  &
                        locwrd(mrtcal_pack_set), locwrd(clic_pack_set)/)
  pack%init=locwrd(mrtholo_pack_init)
  pack%clean=locwrd(mrtholo_pack_clean)
  !
end subroutine mrtholo_pack_set
!
subroutine mrtholo_pack_init(gpack_id,error)
  use mrtholo_interfaces, except_this => mrtholo_pack_init
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Init messaging
  call mrtholo_message_set_id(gpack_id)
  ! Init error flag
  error = .false.
  ! MRTHOLO package specific initialization
  call mrtholo_init(error)
  if (error) return
  ! Load local language
  call mrtholo_load
  !
end subroutine mrtholo_pack_init
!
subroutine mrtholo_pack_clean(error)
  use mrtholo_interfaces, except_this => mrtholo_pack_clean
  !----------------------------------------------------------------------
  ! @ private-mandatory
  ! Called at end of session. Might clean here for example global buffers
  ! allocated during the session
  !----------------------------------------------------------------------
  logical :: error
  !
  call mrtholo_exit(error)
  if (error) return
  !
end subroutine mrtholo_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sic_let_auto (var,dble,error)
  use sic_interfaces, except_this=>sic_let_auto
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Attributes a value to an already defined variable of numeric type.
  !       No data type checking for this entry. Only Global
  !       variables are affected by this entry, since it is
  !       called by program only.
  !---------------------------------------------------------------------
  character(len=*)                :: var    !
  real*8                          :: dble   !
  logical,          intent(inout) :: error  !
  ! Local
  real*4 :: value
  integer*4 :: inte
  integer*8 :: long
  logical :: logi
  character(len=1) :: string
  integer :: fmt
  !
  fmt = 0
  call sic_let_var(var,value,dble,inte,long,logi,string,fmt,error)
end subroutine sic_let_auto
!
subroutine sic_let_real (var,value,error)
  use sic_interfaces, except_this=>sic_let_real
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  !  Attributes a value to an already defined variable.
  !  No data type checking for this entry. Only Global variables are
  ! affected by this entry, since it is called by program only.
  !---------------------------------------------------------------------
  character(len=*)                :: var    !
  real*4                          :: value  !
  logical,          intent(inout) :: error  !
  ! Local
  real*8 :: dble
  integer*4 :: inte
  integer*8 :: long
  logical :: logi
  character(len=1) :: string
  integer :: fmt
  !
  fmt = fmt_r4
  call sic_let_var(var,value,dble,inte,long,logi,string,fmt,error)
end subroutine sic_let_real
!
subroutine sic_let_dble (var,dble,error)
  use sic_interfaces, except_this=>sic_let_dble
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  !  Attributes a value to an already defined variable.
  !  No data type checking for this entry. Only Global variables are
  ! affected by this entry, since it is called by program only.
  !---------------------------------------------------------------------
  character(len=*)                :: var    !
  real*8                          :: dble   !
  logical,          intent(inout) :: error  !
  ! Local
  real*4 :: value
  integer*4 :: inte
  integer*8 :: long
  logical :: logi
  integer :: fmt
  character(len=1) :: string
  !
  fmt = fmt_r8
  call sic_let_var(var,value,dble,inte,long,logi,string,fmt,error)
end subroutine sic_let_dble
!
subroutine sic_let_inte (var,inte,error)
  use sic_interfaces, except_this=>sic_let_inte
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  !  Attributes a value to an already defined variable.
  !  No data type checking for this entry. Only Global variables are
  ! affected by this entry, since it is called by program only.
  !---------------------------------------------------------------------
  character(len=*)                :: var    !
  integer*4                       :: inte   !
  logical,          intent(inout) :: error  !
  ! Local
  real*4 :: value
  real*8 :: dble
  logical :: logi
  integer*8 :: long
  integer :: fmt
  character(len=1) :: string
  !
  fmt = fmt_i4
  call sic_let_var(var,value,dble,inte,long,logi,string,fmt,error)
end subroutine sic_let_inte
!
subroutine sic_let_long (var,long,error)
  use sic_interfaces, except_this=>sic_let_long
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  !  Attributes a value to an already defined variable.
  !  No data type checking for this entry. Only Global variables are
  ! affected by this entry, since it is called by program only.
  !---------------------------------------------------------------------
  character(len=*)                :: var    !
  integer*8                       :: long   !
  logical,          intent(inout) :: error  !
  ! Local
  real*4 :: value
  real*8 :: dble
  logical :: logi
  integer*4 :: inte
  integer :: fmt
  character(len=1) :: string
  !
  fmt = fmt_i8
  call sic_let_var(var,value,dble,inte,long,logi,string,fmt,error)
end subroutine sic_let_long
!
subroutine sic_let_logi (var,logi,error)
  use sic_interfaces, except_this=>sic_let_logi
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  !  Attributes a value to an already defined variable.
  !  No data type checking for this entry. Only Global variables are
  ! affected by this entry, since it is called by program only.
  !---------------------------------------------------------------------
  character(len=*)                :: var    !
  logical                         :: logi   !
  logical,          intent(inout) :: error  !
  ! Local
  real*4 :: value
  real*8 :: dble
  integer*4 :: inte
  integer*8 :: long
  integer :: fmt
  character(len=1) :: string
  !
  fmt = fmt_l
  call sic_let_var(var,value,dble,inte,long,logi,string,fmt,error)
end subroutine sic_let_logi
!
subroutine sic_let_char (var,string,error)
  use sic_interfaces, except_this=>sic_let_char
  !---------------------------------------------------------------------
  ! @ public
  !  Attributes a value to an already defined variable.
  !  No data type checking for this entry. Only Global variables are
  ! affected by this entry, since it is called by program only.
  !---------------------------------------------------------------------
  character(len=*)                :: var     !
  character(len=*)                :: string  !
  logical,          intent(inout) :: error   !
  ! Local
  real*4 :: value
  real*8 :: dble
  integer*4 :: inte
  integer*8 :: long
  logical :: logi
  integer :: fmt
  !
  fmt = 1
  call sic_let_var(var,value,dble,inte,long,logi,string,fmt,error)
end subroutine sic_let_char
!
subroutine sic_let_var(namein,value,dble,inte,long,logi,string,fmt,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_let_var
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Attributes a value to an already defined variable.
  !       No data type checking for this entry. Only Global
  !       variables are affected by this entry, since it is
  !       called by program only.
  !
  !     Uses the appropriate input variable according to FMT
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: namein  !
  real(kind=4),     intent(in)  :: value   !
  real(kind=8),     intent(in)  :: dble    !
  integer(kind=4),  intent(in)  :: inte    !
  integer(kind=8),  intent(in)  :: long    !
  logical,          intent(in)  :: logi    !
  character(len=*), intent(in)  :: string  !
  integer(kind=4),  intent(in)  :: fmt     !
  logical,          intent(out) :: error   !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LET'
  type(sic_identifier_t) :: var
  integer :: in,ier,atype
  type(sic_descriptor_t) :: desc
  integer(kind=address_length) :: ipnt
  logical :: verbose
  type(sic_dimensions_t) :: spec
  character(len=message_length) :: mess
  real*4 :: lvalue
  integer*4 :: linte
  integer*8 :: llong
  !
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! 'namein' must refer to a valid specifier, not e.g. an expression
  spec%do%range    = .true.   ! e.g. A[3:5] allowed
  spec%do%subset   = .true.   ! e.g. A[2,] allowed
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .true.   ! e.g. A[i][j:k] allowed
  verbose  = .true.
  error    = .false.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error) return
  !
  ! Only Global here
  var%level = 0
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'No such variable '//namein)
    error =.true.
    return
  endif
  !
  ! Do not allow incarnation or transposition here
  call extract_descr(desc,dicvar(in)%desc,spec%done,var%name,.false.,0,error)
  if (error) return
  !
  atype = desc%type
  !
  if (desc%readonly) then
    call sic_message(seve%e,rname,'Readonly variables cannot be modified')
    error = .true.
    return
  elseif (desc%status.eq.scratch_operand) then
    call sic_message(seve%e,rname,'Trying to store in a scratch variable')
    error = .true.
    return
  elseif (atype.eq.0) then
    if (fmt.le.0) then
      call sic_message(seve%e,rname,'Header or Structure cannot be '//  &
      'assigned as a whole')
      error = .true.
      return
    endif
  elseif (atype.gt.0) then
    if (fmt.le.0) then
      write(mess,1001) 'Variable type does not match declaration ',fmt,atype,  &
      namein
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    call ctodes(string,desc%type,desc%addr)
  elseif (desc%ndim.ne.0) then
    call sic_message(seve%e,rname,'Cannot assign arrays')
    error = .true.
  elseif (fmt.eq.0) then
    ! Automatic: convert from the input real*8 value
    ipnt = bytpnt(desc%addr,membyt)
    if (atype.eq.fmt_i4) then
      linte = nint(dble)
      call i4toi4(linte,membyt(ipnt),1)
    elseif (atype.eq.fmt_r4) then
      lvalue = dble
      call r4tor4(lvalue,membyt(ipnt),1)
    elseif (atype.eq.fmt_r8) then
      call r8tor8(dble,membyt(ipnt),1)
    elseif (atype.eq.fmt_i8) then
      llong = nint(dble,kind=8)
      call i8toi8(llong,membyt(ipnt),1)
    else
      write(mess,1001) 'Variable type does not match declaration ',fmt,atype,  &
      namein
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
  elseif (fmt.ne.atype) then
    write(mess,1001) 'Variable type does not match declaration',fmt,atype,namein
    call sic_message(seve%e,rname,mess)
    error = .true.
  else
    ipnt = bytpnt(desc%addr,membyt)
    if (atype.eq.fmt_l) then
      call l4tol4(logi,membyt(ipnt),1)
    elseif (atype.eq.fmt_i4) then
      call i4toi4(inte,membyt(ipnt),1)
    elseif (atype.eq.fmt_r4) then
      call r4tor4(value,membyt(ipnt),1)
    elseif (atype.eq.fmt_r8) then
      call r8tor8(dble,membyt(ipnt),1)
    elseif (atype.eq.fmt_i8) then
      call i8toi8(long,membyt(ipnt),1)
    endif
  endif
  !
1001 format(a,i4,i4,a)
end subroutine sic_let_var
!
subroutine sic_def_real_addr (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Define a REAL Sic variable
  !  Does the real job. Do not call directly (use the generic interface
  !  'sic_def_real' instead), except for memory(ip) targets.
  ! Warning! Dimensions must be integers of kind index_length, i.e.
  ! explicit integer values can not be used.
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  real(kind=4),                intent(in)    :: rel        ! First element of target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,i,vlev
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vaddr = locwrd (rel)
  vtype = fmt_r4
  vlev = 0
  size = 1
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,vlev,error)
end subroutine sic_def_real_addr
!
subroutine sic_def_dble_addr(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Define a DOUBLE Sic variable
  !  Does the real job. Do not call directly (use the generic interface
  !  'sic_def_dble' instead), except for memory(ip) targets.
  ! Warning! Dimensions must be integers of kind index_length, i.e.
  ! explicit integer values can not be used.
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  real(kind=8),                intent(in)    :: dble       ! First element of target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,i,vlev
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vaddr = locwrd(dble)
  vtype = fmt_r8
  vlev = 0
  size = 2
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,vlev,error)
end subroutine sic_def_dble_addr
!
subroutine sic_def_inte_addr(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Define an INTEGER Sic variable
  !  Does the real job. Do not call directly (use the generic interface
  !  'sic_def_inte' instead), except for memory(ip) targets.
  ! Warning! Dimensions must be integers of kind index_length, i.e.
  ! explicit integer values can not be used.
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  integer(kind=4),             intent(in)    :: inte       ! First element of target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,i,vlev
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vaddr = locwrd(inte)
  vtype = fmt_i4
  vlev = 0
  size = 1
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,vlev,error)
end subroutine sic_def_inte_addr
!
subroutine sic_def_long_addr(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Define a LONG Sic variable
  !  Does the real job. Do not call directly (use the generic interface
  !  'sic_def_long' instead), except for memory(ip) targets.
  ! Warning! Dimensions must be integers of kind index_length, i.e.
  ! explicit integer values can not be used.
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  integer(kind=8),             intent(in)    :: long       ! First element of target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,i,vlev
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vaddr = locwrd(long)
  vtype = fmt_i8
  vlev = 0
  size = 2
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,vlev,error)
end subroutine sic_def_long_addr
!
subroutine sic_def_cplx_addr (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Define a COMPLEX Sic variable
  !  Does the real job. Do not call directly (use the generic interface
  !  'sic_def_cplx' instead), except for memory(ip) targets.
  ! Warning! Dimensions must be integers of kind index_length, i.e.
  ! explicit integer values can not be used.
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  complex(kind=4),             intent(in)    :: cplx       ! First element of target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,i,vlev
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vaddr = locwrd (cplx)
  vtype = fmt_c4
  vlev = 0
  size = 2
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,vlev,error)
end subroutine sic_def_cplx_addr
!
subroutine sic_def_logi (symb,logi,readonly,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_def_logi
  !---------------------------------------------------------------------
  ! @ public
  !  Define a LOGICAL scalar Sic variable
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  logical,          intent(in)    :: logi      ! Target scalar
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer :: vtype,ndim,vlev
  integer(kind=index_length) :: jdim(sic_maxdims)
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vaddr = locwrd(logi)
  vtype = fmt_l
  vlev = 0
  size = 1
  ndim = 0
  call sic_def_avar(symb,vaddr,vtype,size,ndim,jdim,readonly,vlev,error)
end subroutine sic_def_logi
!
subroutine sic_def_login_addr(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Define a LOGICAL array Sic variable
  !  Does the real job. Do not call directly (use the generic interface
  !  'sic_def_login' instead), except for memory(ip) targets.
  ! Warning! Dimensions must be integers of kind index_length, i.e.
  ! explicit integer values can not be used.
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  logical,                     intent(in)    :: logi       ! First element of target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,i,vlev
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vaddr = locwrd(logi)
  vtype = fmt_l
  vlev = 0
  size = 1
  do i = 1,ndim
    size = size*dim(i)
  enddo
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,vlev,error)
end subroutine sic_def_login_addr
!
subroutine sic_def_char(symb,chain,readonly,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_def_char
  !---------------------------------------------------------------------
  ! @ public
  !  Define a CHARACTER scalar Sic variable
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  character(len=*), intent(in)    :: chain     ! Target scalar string
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer :: vtype,ndim,vlev
  integer(kind=index_length) :: jdim(sic_maxdims)
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vtype = len(chain)
  if (vtype.le.0) then
    call sic_message(seve%e,'SIC','Character string '//trim(symb)//' has zero-length')
    error = .true.
    return
  endif
  vaddr = locstr(chain)
  vlev = 0
  size = (vtype+3)/4
  ndim = 0
  call sic_def_avar(symb,vaddr,vtype,size,ndim,jdim,readonly,vlev,error)
end subroutine sic_def_char
!
subroutine sic_def_strn(symb,string,ns,readonly,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch - on purpose -)
  ! Define a CHARACTER scalar SIC variable.
  ! The input 'string' variable can be of any kind, so the string
  ! length is passed in a complementary argument. Added for HEADERCHAR
  ! (at least).
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  integer(kind=1),  intent(in)    :: string(*)  ! Target object
  integer(kind=4),  intent(in)    :: ns         ! String length
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,ndim,vlev
  integer(kind=index_length) :: jdim(sic_maxdims)
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vtype = ns
  if (vtype.le.0) then
    call sic_message(seve%e,'SIC','Character string '//trim(symb)//' has zero-length')
    error = .true.
    return
  endif
  vaddr = locwrd(string)
  vlev = 0
  size = (vtype+3)/4
  ndim = 0
  call sic_def_avar(symb,vaddr,vtype,size,ndim,jdim,readonly,vlev,error)
end subroutine sic_def_strn
!
subroutine sic_def_charn_addr(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Define a CHARACTER array Sic variable
  !  Does the real job. Do not call directly (use the generic interface
  !  'sic_def_charn' instead), except for memory(ip) targets.
  ! Warning! Dimensions must be integers of kind index_length, i.e.
  ! explicit integer values can not be used.
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  character(len=*),            intent(in)    :: chain      ! First element of target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,i,vlev
  integer(kind=size_length) :: size
  integer(kind=address_length) :: vaddr
  !
  vtype = len(chain)
  if (vtype.le.0) then
    call sic_message(seve%e,'SIC','Character string '//trim(symb)//' has zero-length')
    error = .true.
    return
  endif
  vaddr = locstr(chain)
  vlev = 0
  size = vtype
  do i = 1,ndim
    size = size*dim(i)
  enddo
  size = (size+3)/4  ! Convert to words
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,vlev,error)
end subroutine sic_def_charn_addr
!
subroutine sic_def_charpnt(symb,vaddr,vsize,ndim,dim,readonly,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>sic_def_charpnt
  !---------------------------------------------------------------------
  ! @ public
  !  Define a CHARACTER array Sic variable
  !---------------------------------------------------------------------
  character(len=*),             intent(in)    :: symb       ! Variable name
  integer(kind=address_length), intent(in)    :: vaddr      ! Target address
  integer(kind=4),              intent(in)    :: vsize      ! Size of each string
  integer(kind=4),              intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),   intent(in)    :: dim(ndim)  ! Dimensions
  logical,                      intent(in)    :: readonly   ! Read only?
  logical,                      intent(inout) :: error      ! Logical error flag
  ! Local
  integer :: vtype,i,vlev
  integer(kind=size_length) :: size
  !
  vtype = vsize
  if (vtype.le.0) then
    call sic_message(seve%e,'SIC','Character string '//trim(symb)//' has zero-length')
    error = .true.
    return
  endif
  vlev = 0
  size = vtype
  do i = 1,ndim
    size = size*dim(i)
  enddo
  size = (size+3)/4  ! Convert to words
  call sic_def_avar(symb,vaddr,vtype,size,ndim,dim,readonly,vlev,error)
end subroutine sic_def_charpnt
!
subroutine sic_def_avar(symb,vaddr,vtype,size,ndim,jdim,readonly,lev,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_def_avar
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! Defines Sic variables by program or user
  !---------------------------------------------------------------------
  character(len=*),             intent(in)  :: symb        ! Variable name
  integer(kind=address_length), intent(in)  :: vaddr       ! Variable address
  integer(kind=4),              intent(in)  :: vtype       ! Variable type
  integer(kind=size_length),    intent(in)  :: size        ! Variable size (4-bytes words)
  integer(kind=4),              intent(in)  :: ndim        ! Number of dimensions
  integer(kind=index_length),   intent(in)  :: jdim(ndim)  ! Dimensions
  logical,                      intent(in)  :: readonly    ! ReadOnly flag
  integer(kind=4),              intent(in)  :: lev         ! Variable level
  logical,                      intent(out) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  type(sic_identifier_t) :: var
  integer(kind=4) :: ls,in,i,ier
  !
  ! Check if SIC is loaded
  if (.not.loaded) then
    call sic_message(seve%e,rname,'SIC is not loaded')
    error = .true.
    return
  endif
  !
  ! NEVER CHECK THAT HERE! Does not work on 16 bit macs!
  !* Check "odd" address for non-character data
#ifndef CYGWIN
  if (mod(vaddr,4_address_length).ne.0.and.vtype.lt.0) then
    call sic_message(seve%e,rname,  &
      'Address of '//trim(symb)//' is not multiple of 4')
    error = .true.
    return
  endif
#endif
  !
  ! Find the symbol and truncate, exclude quotes
  ls = len_trim(symb)
  if (ls.gt.varname_length) then
    call sic_message(seve%e,rname,'Variable name too long '//symb)
    error = .true.
    return
  endif
  var%name = symb
  var%lname = ls
  call sic_upper(var%name)
  var%level = lev
  !
  ! Check if it already exists
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,'Variable '//trim(symb)//  &
    ' already exists')
    error = .true.
    return
  endif
  !
  ! Insert in symbol dictionnary
  ier = sic_hasins(rname,maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.0 .or. ier.eq.2) then
    error = .true.
    return
  endif
  !
  error = .false.
  !
  dicvar(in)%desc%addr = vaddr
  dicvar(in)%desc%type = vtype
  dicvar(in)%desc%readonly = readonly
  dicvar(in)%desc%ndim = ndim
  do i = 1,ndim
    dicvar(in)%desc%dims(i) = jdim(i)
  enddo
  do i = ndim+1,sic_maxdims
    dicvar(in)%desc%dims(i) = 1
  enddo
  dicvar(in)%desc%size = size
  dicvar(in)%desc%status = program_defined
  !
#if defined(GAG_USE_PYTHON)
  call gpy_getvar(var%name,var%level)
#endif
  !
end subroutine sic_def_avar
!
subroutine i4_type(n,arr)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: n    !
  integer*4 :: arr(n)               !
  ! Local
  integer :: i,m,j
  !
  m = n/6
  do i=1,6*m,6
    write(6,100) (arr(j),j=i,i+5)
    if (sic_ctrlc()) return
  enddo
  if (6*m.ne.n) write(6,100) (arr(j),j=6*m+1,n)
100 format(6(1x,i12))
end subroutine i4_type
!
subroutine i8_type(n,arr)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: n    !
  integer*8 :: arr(n)               !
  ! Local
  integer :: i,j,m
  m = n/3
  do i=1,3*m,3
    write(6,100) (arr(j),j=i,i+2)
    if (sic_ctrlc()) return
  enddo
  if (3*m.ne.n) write(6,100) (arr(j),j=3*m+1,n)
100 format (3(1x,i21))
end subroutine i8_type
!
subroutine r4_type(n,arr)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: n    !
  real :: arr(n)                    !
  ! Local
  integer :: i,j,m
  !
  m = n/5
  do i=1,5*m,5
    write(6,100) (arr(j),j=i,i+4)
    if (sic_ctrlc()) return
  enddo
  if (5*m.ne.n) write(6,100) (arr(j),j=5*m+1,n)
100 format (5(1x,1pg14.7))
end subroutine r4_type
!
subroutine r8_type(n,arr)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: n    !
  real*8 :: arr(n)                  !
  ! Local
  integer :: i,j,m
  m = n/3
  do i=1,3*m,3
    write(6,100) (arr(j),j=i,i+2)
    if (sic_ctrlc()) return
  enddo
  if (3*m.ne.n) write(6,100) (arr(j),j=3*m+1,n)
100 format (3(1x,1pg25.18))
end subroutine r8_type
!
subroutine c4_type(n,arr)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: n    !
  real*4 :: arr(*)                  !
  ! Local
  integer :: i,j,m
  m = n/2
  do i=1,4*m,4
    write(6,100) (arr(j),j=i,i+3)
    if (sic_ctrlc()) return
  enddo
  if (2*m.ne.n) write(6,100) (arr(j),j=4*m+1,2*n)
100 format (2(1x,'(',1pg15.7,',',1pg15.7,')'))
end subroutine c4_type
!
subroutine l_type(n,arr)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: n    !
  logical :: arr(n)                 !
  ! Local
  integer :: i,j,m
  m = n/24
  do i=1,24*m,24
    write(6,100) (arr(j),j=i,i+23)
    if (sic_ctrlc()) return
  enddo
  if (24*m.ne.n) write(6,100) (arr(j),j=24*m+1,n)
100 format (24(1x,l1))
end subroutine l_type
!
subroutine ch_type(n,arr,l)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: n       ! Number of elements
  character(len=*),          intent(in) :: arr(n)  !
  integer(kind=4),           intent(in) :: l       ! String length
  ! Local
  character(len=*), parameter :: blank =  &
    '                                                                '
  integer(kind=4) :: nperline,nblank,i,j,m,tt_width
  !
  tt_width = sic_ttyncol()
  nperline = max(1,tt_width/(l+1))  ! l+1: at least 1 blank between each value
  nblank = max(1,(tt_width-l*nperline)/nperline)
  m = n/nperline
  do i=1,nperline*m,nperline
    write(6,100) (arr(j)(1:l)//blank(1:nblank),j=i,i+nperline-1)
    if (sic_ctrlc()) return
  enddo
  if (nperline*m.ne.n)  &
    write(6,100) (arr(j)(1:l)//blank(1:nblank),j=nperline*m+1,n)
100 format (40A)
end subroutine ch_type
!
subroutine hex_type(n,arr)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Print the input byte-array as hexadecimal strings.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: n       ! Number of elements
  integer(kind=1),           intent(in) :: arr(n)  !
  ! Local
  integer(kind=size_length) :: i,m,j
  integer(kind=4), parameter :: nperline=32 ! Number of bytes per line
  !
  m = n/nperline
  do i=1,nperline*m,nperline
    write(6,100) (arr(j),j=i,i+nperline-1)
    if (sic_ctrlc()) return
  enddo
  if (nperline*m.ne.n) write(6,100) (arr(j),j=nperline*m+1,n)
100 format(8(4(Z2.2),1X))  ! Gather by group of 4-bytes
end subroutine hex_type
!
! subroutine i4_type_to_string(n,arr,string)
!   use sic_interfaces
!   integer :: n                      !
!   integer :: arr(n)                 !
!   character(len=*) :: string        !
!   ! Local
!   integer :: i,nc
!   !
!   nc = 1
!   do i = 1, n
!     call sic_dble_to_string(arr(i),string(nc:))
!     nc = nc + len_trim(string(nc:))+ 1
!   enddo
! end subroutine i4_type_to_string
!
! subroutine r4_type_to_string(n,arr,string)
!   use sic_interfaces
!   integer :: n                      !
!   real :: arr(n)                    !
!   character(len=*) :: string        !
!   ! Local
!   integer :: i,nc
!   !
!   nc = 1
!   do i = 1, n
!     call sic_dble_to_string(arr(i),string(nc:))
!     nc = nc + len_trim(string(nc:))+ 1
!   enddo
! end subroutine r4_type_to_string
!
! subroutine r8_type_to_string(n,arr,string)
!   use sic_interfaces
!   integer :: n                      !
!   real*8 :: arr(n)                  !
!   character(len=*) :: string        !
!   ! Local
!   integer :: i,nc
!   !
!   nc = 1
!   do i = 1, n
!     call sic_dble_to_string(arr(i),string(nc:))
!     nc = nc + len_trim(string(nc:))+ 1
!   enddo
! end subroutine r8_type_to_string
!
! subroutine c4_type_to_string(n,arr,string)
!   use sic_interfaces
!   !---------------------------------------------------------------------
!   !
!   !---------------------------------------------------------------------
!   integer :: n                      !
!   real*4 :: arr(*)                  !
!   character(len=*) :: string        !
!   ! Local
!   integer :: i,nc
!   !
!   nc = 1
!   do i = 1, 2*n, 2
!     string(nc:nc) = '('
!     nc = nc+1
!     !
!     call sic_dble_to_string(arr(i),string(nc:))
!     nc = nc+len_trim(string(nc:))
!     !
!     string(nc:nc) = ','
!     nc = nc+1
!     !
!     call sic_dble_to_string(arr(i),string(nc:))
!     nc = nc+len_trim(string(nc:))
!     !
!     string(nc:nc) = ')'
!     nc = nc+2
!   enddo
!   !
! end subroutine c4_type_to_string
!
subroutine l_type_to_string(n,arr,string)
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer :: n                      !
  logical :: arr(n)                 !
  character(len=*) :: string        !
  ! Local
  integer :: i,nc
  !
  nc = 1
  do i = 1, n
    call sic_logi_to_string(arr(i),string(nc:))
    nc = nc + len_trim(string(nc:))+ 1
  enddo
end subroutine l_type_to_string
!
subroutine sic_validname(name,error)
  use sic_interfaces, except_this=>sic_validname
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC  Internal Routine
  !     Check if a variable name is valid
  !---------------------------------------------------------------------
  character(len=*) :: name          !
  logical :: error                  !
  ! Local
  integer :: i,n,ic
  character(len=1) :: c
  !
  error = .false.
  n = len_trim(name)
  do i=1,n
    if (name(i:i).eq.'$') then
      if (i.ne.n) then
        call sic_message(seve%w,'SIC','$ is only valid as last char '//  &
        name(1:n))
        !  error = .true. ! For the time being
      endif
    elseif  (name(i:i).eq.'_') then
      continue
    elseif  (name(i:i).eq.'%') then
      continue
    elseif  (name(i:i).ge.'a' .and. name(i:i).le.'z') then
      ic=ichar(name(i:i))+ichar('A')-ichar('a')
      name(i:i)=char(ic)
    elseif  (name(i:i).ge.'A' .and. name(i:i).le.'Z') then
      continue
    elseif  (name(i:i).ge.'0' .and. name(i:i).le.'9') then
      continue
    else
      c= name(i:i)
      call sic_message(seve%e,'SIC',c//' is not a valid character')
      error = .true.
    endif
  enddo
  if (error) then
    call sic_message(seve%e,'SIC_VALID','Invalid variable '//name(1:n))
  endif
end subroutine sic_validname

subroutine setmod(set,line,r,error)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>setmod
  use class_setup_new
  use class_types
  use class_popup
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS Support routine for command
  !   SET MODE X | Y | Z | ALL [ AUTO | TOTAL | CURRENT | [Min Max] ]
  !   Computes limits and initialise plot parameters
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(inout) :: line   ! Input command line (modified on return)
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SET MODE'
  logical :: doall,dox,doy,doz, docursor,dovalues
  integer(kind=4) :: nkey1,nkey2,nl,nc
  real(kind=plot_length) :: ux1,ux2,uy1,uy2,uz1,uz2
  real(kind=plot_length) :: xc1,xc2,xv1,xv2,xf1,xf2,xi1,xi2
  real(kind=8) :: dux1,dux2,xfo,xio,restf,image,dummy
  character(len=1) :: ch
  character(len=64) :: chgreg
  integer(kind=4), parameter :: mvoc1=4,mvoc2=3
  character(len=12) :: voc1(mvoc1),voc2(mvoc2),arg1,key1
  character(len=24) :: arg2,key2
  ! Data
  data voc1 /'X','Y','Z','ALL'/
  data voc2 /'AUTO','TOTAL','CURRENT'/
  !
  ! 2nd argument: find which dimension
  call sic_ke (line,0,2,arg1,nc,.true.,error)
  nl = index(line,' ')+1
  call sic_ambigs(rname,arg1,key1,nkey1,voc1,mvoc1,error)
  if (error) return
  doall = key1.eq.'ALL'
  dox = key1.eq.'X' .or. doall
  doy = key1.eq.'Y' .or. doall
  doz = key1.eq.'Z' .or. doall
  !
  ! 3rd argument: find mode
  docursor = .false.
  dovalues = .true.
  if (sic_present(0,3)) then
    call sic_ke(line,0,3,arg2,nc,.true.,error)
    if (error)  return
    ! 'sic_ambigs_sub' will return nfound=0 without complaining if
    ! arg2 is not in the list of known keywords
    call sic_ambigs_sub(rname,arg2,key2,nkey2,voc2,mvoc2,error)
    if (error)  return
    !
    select case (nkey2)
    case (1)  ! Auto
      dovalues = .false.
    case (2)  ! Total
      dovalues = .false.
    case (3)  ! Current
      arg2 = 'F'  ! Fixed
      dovalues = .false.
    case (0)  ! Not a known keyword
      arg2 = 'F'  ! Fixed
      dovalues = .true.
    case default
      call class_message(seve%e,rname,'Internal error: argument not understood')
      error = .true.
      return
    end select
  else
    if (gtg_curs()) then
      arg2 = 'F'  ! Fixed
      docursor = .true.
      dovalues = .false.
    else
      call class_message(seve%e,rname,  &
        'Missing values and no cursor available')
      error = .true.
      return
    endif
  endif
  ! In all others cases, numerical values have to be retrieved from
  ! command line
  !
  ! Protections
  if (doall) then
    if (dovalues) then
      call class_message(seve%e,rname,  &
        'Can not set ALL values from numeric arguments on command line')
      error = .true.
      return
    endif
    if (docursor) then
      call class_message(seve%e,rname,'Can not set ALL values with cursor')
      error = .true.
      return
    endif
  endif
  !
  if (dox)  set%modex = arg2
  if (doy)  set%modey = arg2
  if (doz)  set%modez = arg2
  !
  ! Get values with the cursor
  if (docursor) then
    if (dox) then
      call setmod_cursor(set%kind,'X',set%unitx(1),ux1,ux2,error)
      if (error)  return
      !
      xc1 = 0.d0
      xc2 = 0.d0
      xv1 = 0.d0
      xv2 = 0.d0
      xf1 = 0.d0
      xf2 = 0.d0
      xfo = 0.d0
      xi1 = 0.d0
      xi2 = 0.d0
      xio = 0.d0
      !
      if (set%kind.eq.kind_cont) then
        ! Continuum observation
        if (set%unitx(1).eq.'C') then
          xc1 = ux1
          xc2 = ux2
        elseif (set%unitx(1).eq.'T') then
          xf1 = ux1
          xf2 = ux2
          xfo = 0.d0
        else
          xv1 = ux1
          xv2 = ux2
        endif
      elseif (set%kind.eq.kind_spec) then
        ! Spectroscopy observation
        if (set%unitx(1).eq.'I') then
          xi1 = ux1  ! Image units, without the 'image' frequency
          xi2 = ux2
          xio = gixo
        elseif (set%unitx(1).eq.'F') then
          xf1 = ux1  ! Frequency units, without the 'restf' frequency
          xf2 = ux2
          xfo = gfxo
        elseif (set%unitx(1).eq.'C') then
          xc1 = ux1
          xc2 = ux2
        elseif (set%unitx(1).eq.'V') then
          xv1 = ux1
          xv2 = ux2
        endif
      else
        call class_message(seve%e,rname,'Unsupported kind of data')
        error = .true.
        return
      endif
      !
      ! Save in command line
      write (line(nl:),100) 'X',tounit(set%kind,set%unitx(1),ux1),  &
                                tounit(set%kind,set%unitx(1),ux2),  &
                                set%unitx(1)
    endif
    !
    if (doy) then
      call setmod_cursor(set%kind,'Y','',uy1,uy2,error)
      if (error)  return
      ! Save in command line
      write (line(nl:),100) 'Y',tounit(set%kind,'',uy1),  &
                                tounit(set%kind,'',uy2)
    endif
    !
    if (doz) then
      call setmod_cursor(set%kind,'Z','',uz1,uz2,error)
      if (error)  return
      ! Save in command line
      write (line(nl:),100) 'Y',tounit(set%kind,'',uz1),  &
                                tounit(set%kind,'',uz2)
    endif
  endif
  !
  ! Get values from command line
  if (dovalues) then
    if (dox) then
      call sic_r8(line,0,3,dux1,.true.,error)
      if (error) return
      call sic_r8(line,0,4,dux2,.true.,error)
      if (error) return
      ch = set%unitx(1)
      call sic_ke(line,0,5,ch,nc,.false.,error)
      if (error) return
      !
      xc1 = 0.d0
      xc2 = 0.d0
      xv1 = 0.d0
      xv2 = 0.d0
      xf1 = 0.d0
      xf2 = 0.d0
      xfo = 0.d0
      xi1 = 0.d0
      xi2 = 0.d0
      xio = 0.d0
      if (set%kind.eq.kind_cont) then
        ! Continuum case
        if (ch.eq.'C') then
          ! Channel scale
          xc1 = dux1
          xc2 = dux2
          ux1 = xc1  ! For X range test there after
          ux2 = xc2
        elseif (ch.eq.'A') then
          ! Angle scale
          xv1 = dux1/class_setup_get_fangle()
          xv2 = dux2/class_setup_get_fangle()
          ux1 = xv1  ! For X range test there after
          ux2 = xv2
        else
          ! Time scale
          xf1 = dux1
          xf2 = dux2
          xfo = 0.d0
          ux1 = xf1  ! For X range test there after
          ux2 = xf2
        endif
        !
      elseif (set%kind.eq.kind_spec) then
        ! Spectrum case
        if (ch.eq.'C') then
          ! Channel scale
          xc1 = dux1
          xc2 = dux2
          ux1 = xc1  ! For X range test there after
          ux2 = xc2
        elseif (ch.eq.'V') then
          ! Velocity scale
          xv1 = dux1
          xv2 = dux2
          ux1 = xv1  ! For X range test there after
          ux2 = xv2
        elseif (ch.eq.'F') then
          ! Frequency scale
          if (r%head%xnum.eq.0) then
            restf = 1.d5  ! Use an arbitrary value, large enough to avoid
                          ! precision loss in offset frequencies
          else
            restf = r%head%spe%restf
          endif
          xf1 = dux1 - restf
          xf2 = dux2 - restf
          xfo = restf
          ux1 = xf1  ! For X range test there after
          ux2 = xf2
        elseif (ch.eq.'I') then
          ! Image frequency scale
          if (r%head%xnum.eq.0) then
            image = 1.d5  ! Use an arbitrary value, large enough to avoid
                          ! precision loss in offset frequencies
          else
            image = r%head%spe%image
          endif
          xi1 = dux1 - image
          xi2 = dux2 - image
          xio = image
          ux1 = xi1  ! For X range test there after
          ux2 = xi2
        endif
        !
      else
        call class_message(seve%e,rname,'Unsupported kind of data')
        error = .true.
        return
      endif
    endif
    !
    if (doy) then
      uy1 = guy1
      uy2 = guy2
      call sic_r4(line,0,3,uy1,.true.,error)
      if (error) return
      call sic_r4(line,0,4,uy2,.true.,error)
      if (error) return
    endif
    !
    if (doz) then
      uz1 = guz1
      uz2 = guz2
      call sic_r4(line,0,3,uz1,.true.,error)
      if (error) return
      call sic_r4(line,0,4,uz2,.true.,error)
      if (error) return
    endif
    !
  endif
  !
  ! Store values in global parameters
  if (dovalues .or. docursor) then
    if (dox) then
      if (ux1.eq.ux2) then
        call class_message(seve%e,rname,'No range in X')
        error = .true.
        return
      endif
      ! Set graphic limits. This is done only for the relevant X units.
      ! The other limits are computed when plotting the spectrum
      !! Print *,' xc1,xc2,xv1,xv2,xf1,xf2,xfo,xi1,xi2,xio'
      !! Print *, xc1,xc2,xv1,xv2,xf1,xf2,xfo,xi1,xi2,xio
      call selimx(r,xc1,xc2,xv1,xv2,xf1,xf2,xfo,xi1,xi2,xio)
      ! Note that the BASE is performed in the obs%cimin to obs%cimax
      ! range. They are set (indirectly) in selimx, from the gcx1 and gcx2
      ! range. So we need to set all the g*x1 and g*x2 plotting limits, and
      ! then call selimx to compute obs%cimin and obs%cimax. All this is done
      ! by newlimx:
      if (r%head%xnum.eq.0) then
        ! Compute new current limits
        call gelimx(dummy,gux1,gux2,gux,set%unitx(1))
      else
        call newlimx(set,r,error)
        if (error)  return
      endif
      ! Transmit to GreG ?
      write(chgreg,'(A,2(1X,G20.13),A)') 'LIMITS ',gux1,gux2,' = ='
      call gr_exec(chgreg)
      error = gr_error()
      if (error)  return
    endif
    !
    if (doy) then
      if (uy1.eq.uy2) then
        call class_message(seve%e,rname,'No range in Y')
        error = .true.
        return
      endif
      ! Compute new current Y limits
      guy1 = uy1
      guy2 = uy2
      guy = (gy2-gy1)/(guy2-guy1)
      ! Transmit to GreG ?
      write(chgreg,'(A,2(1X,G20.13),A)') 'LIMITS = = ',guy1,guy2
      call gr_exec(chgreg)
      error = gr_error()
      if (error)  return
    endif
    !
    if (doz) then
      if (uz1.eq.uz2) then
        call class_message(seve%e,rname,'No range in Z')
        error = .true.
        return
      endif
      ! Compute new current Z limits
      puz1 = 0.5+nint(uz1)
      puz2 = 0.5+nint(uz2)
      guz1 = puz1
      guz2 = puz2
      guz  = (gy2-gy1)/(guz2-guz1)
    endif
    !
  endif
  !
100 format('MODE ',a,1x,1pg15.8,1x,1pg15.8,1x,a)
  !
contains
  !
  function tounit(kind,unit,x)
    !-------------------------------------------------------------------
    ! Convert a X cursor position to absolute signal frequency (kind
    ! spec)
    !-------------------------------------------------------------------
    real(kind=8) :: tounit
    integer(kind=4),        intent(in) :: kind
    character(len=*),       intent(in) :: unit
    real(kind=plot_length), intent(in) :: x
    !
    if (kind.eq.kind_cont) then
      if (unit.eq.'A') then
        tounit = x*class_setup_get_fangle()
      else
        tounit = x
      endif
    else  ! kind_spec
      if (unit.eq.'F') then
        tounit = x+gfxo
      elseif (unit.eq.'I') then
        tounit = x+gixo
      else
        tounit = x
      endif
    endif
  end function tounit
  !
  subroutine setmod_cursor(kind,axis,unit,v1,v2,error)
    use plot_formula
    !---------------------------------------------------------------------
    ! Get min-max values from cursor
    !---------------------------------------------------------------------
    integer(kind=4),        intent(in)    :: kind   ! Kind of data
    character(len=*),       intent(in)    :: axis   ! Axis name
    character(len=*),       intent(in)    :: unit   ! Unit name
    real(kind=plot_length), intent(out)   :: v1     ! Lower value
    real(kind=plot_length), intent(out)   :: v2     ! Upper value
    logical,                intent(inout) :: error  ! Logical error flag
    ! Local
    real(kind=4) :: x,y
    character(len=1) :: ch
    !
    write(6,*) 'Type any char to set ',axis,' lower and upper limits'
    !
    call gtcurs(x,y,ch,error)
    if (error)  return
    if (axis.eq.'X') then
      v1 = gux1 + (x-gx1)/gux
    elseif (axis.eq.'Y') then
      v1 = guy1 + (y-gy1)/guy
    elseif (axis.eq.'Z') then
      v1 = guz1 + (y-gy1)/guz
    else
      error = .true.
      return
    endif
    write(6,10) axis,'1 = ',tounit(kind,unit,v1)  ! Feedback in terminal in user-friendly unit
    !
    call gtcurs(x,y,ch,error)
    if (error)  return
    if (axis.eq.'X') then
      v2 = gux1 + (x-gx1)/gux
    elseif (axis.eq.'Y') then
      v2 = guy1 + (y-gy1)/guy
    elseif (axis.eq.'Z') then
      v2 = guz1 + (y-gy1)/guz
    else
      error = .true.
      return
    endif
    write(6,10) axis,'2 = ',tounit(kind,unit,v2)  ! Feedback in terminal in user-friendly unit
    !
    10 format(a2,a,f12.3)
    !
  end subroutine setmod_cursor
  !
end subroutine setmod

program map_aver
  use gildas_def
  use gkernel_interfaces
  use image_def
  !---------------------------------------------------------------------
  ! GILDAS
  !	Compress an input LMV-like image
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: mapin,mapout
  integer :: nc(2),n,naver,ier
  logical :: error
  real :: dv
  integer(kind=size_length) :: nd
  type(gildas) :: x,y
  real(kind=8) :: xposi,yposi
  !
  ! Code:
  call gildas_open
  call gildas_char('INPUT_MAP$',mapin)
  call gildas_char('OUTPUT_MAP$',mapout)
  call gildas_inte('NC$',nc,2)
  call gildas_close
  !
  ! Input file
  n = len_trim(mapin)
  call gildas_null(y)
  y%gil%ndim = 3
  call gdf_read_gildas(y,mapin,'.lmv',error)
  if (error) then
    call gagout('F-MAP_COMPRESS,  Cannot read input cube')
    goto 999
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(mapout,x%file,' ','.lmv')
  !
  ! Define number of channels
  ier = gdf_range(nc,y%gil%dim(3))
  if (ier.ne.0) goto 999
  naver = nc(2)-nc(1)+1
  !
  ! Build a pseudo axis aligned on the input one:
  !  - Number of channels set to 1,
  !  - Increment set to the extracted range,
  !  - Value at reference unchanged (same spectroscopic axis, e.g. regarding
  !    associated Rest Freq),
  !  - Center of averaged range (old axis) is aligned on the center of the
  !    output channel #1 (new axis)
  ! This writes as:
  x%gil%dim(3) = 1
! x%gil%val(3) = unchanged
  yposi = (nc(1)+nc(2))*0.5d0
  xposi = 1.d0
  x%gil%inc(3) = y%gil%inc(3)*naver
  x%gil%ref(3) = xposi - (yposi-y%gil%ref(3))/naver
  ! Do not forget the SPECTRO section
  x%gil%vres = y%gil%vres*naver
  x%gil%fres = y%gil%fres*naver
! x%gil%voff = unchanged
! x%gil%freq = unchanged
! x%gil%fima = unchanged
  !
  x%gil%extr_words = 0
  !
  call gdf_create_image(x,error)
  if (error)  goto 999
  !
  y%blc(3) = nc(1)
  y%trc(3) = nc(2)
  call gdf_read_gildas(y,mapin,'.lmv',error,rank=3)
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)),stat=ier)
  !
  dv = 1.0/float(naver)
  nd = x%gil%dim(1)*x%gil%dim(2)
  call compress (y%r3d,nd,x%r2d,naver,dv)
  call gdf_write_data(x,x%r2d,error)
  if (error) goto 999
  call gagout('S-MAP_AVER,  Successful completion')
  call sysexi(1)
999 call sysexi(fatale)
end program map_aver
!
subroutine compress (in,n,out,nc,dv)
  use gildas_def
  integer(kind=size_length) :: n    !
  integer :: nc                     !
  real :: in(n,nc)                  !
  real :: out(n)                    !
  real :: dv                        !
  ! Local
  integer :: ic
  !
  out = in(:,1)
  do ic=2,nc
    out = out+in(:,ic)
  enddo
  out = out*dv
end subroutine compress

subroutine allocate_class(error)
  use class_dependencies_interfaces
  use class_interfaces, except_this=>allocate_class
  !---------------------------------------------------------------------
  ! @ private
  ! Allocate all Class buffers
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  call allocate_classcore(error)
  if (error)  return
  call allocate_RT(error)
  if (error)  return
  !
end subroutine allocate_class
!
subroutine allocate_RT(error)
  use class_dependencies_interfaces
  use class_interfaces, except_this=>allocate_RT
  use class_rt
  !---------------------------------------------------------------------
  ! @ private
  ! Allocate R and T buffers
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  integer(kind=4), parameter :: class_data_len=32  ! Default size for R/T arrays
  !
  r => RandT(1)
  t => RandT(2)
  !
  call class_obs_init(r,error)
  r%is_R = .true.
  call class_obs_init(t,error)
  t%is_R = .false.
  !
  call reallocate_obs(r,class_data_len,error)
  if (error) return
  call reallocate_obs(t,class_data_len,error)
  if (error) return
  !
end subroutine allocate_RT
!
!-----------------------------------------------------------------------
!
subroutine deallocate_class(error)
  use class_dependencies_interfaces
  use class_interfaces, except_this=>deallocate_class
  !---------------------------------------------------------------------
  ! @ private
  ! Deallocate all Class buffers
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  call deallocate_RT(error)
  if (error)  return
  call deallocate_classcore(error)
  if (error)  return
  !
end subroutine deallocate_class
!
subroutine deallocate_RT(error)
  use class_dependencies_interfaces
  use class_interfaces, except_this=>deallocate_RT
  use class_rt
  !---------------------------------------------------------------------
  ! @ private
  ! Deallocate R and T buffers
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  call class_obs_clean(r,error)
  call class_obs_clean(t,error)
  !
end subroutine deallocate_RT
!
subroutine class_exit(error)
  use class_dependencies_interfaces
  use class_interfaces, except_this=>class_exit
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  ! Class buffers
  call deallocate_class(error)
  !
  ! Free MEMORY buffers
  call memorize_free_all
  !
  call class_files_close(error)
  ! if (error)  continue
  call class_luns_free(error)
  ! if (error)  continue
  !
  call class_toc_clean(error)
  ! if (error)  continue
  !
end subroutine class_exit

subroutine allinfo(obs,v1,v2,v,s0,data1)
  use gildas_def
  use classcore_interfaces, except_this=>allinfo
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !---------------------------------------------------------------------
  type(observation), intent(in)  :: obs    !
  real(kind=8),      intent(in)  :: v1     ! Lower bound of velocity interval
  real(kind=8),      intent(in)  :: v2     ! Upper bound of velocity interval
  real(kind=4),      intent(out) :: v      !
  real(kind=4),      intent(out) :: s0     !
  real(kind=4),      intent(out) :: data1  !
  ! Local
  real(kind=8) :: ri1,ri2
  integer(kind=4) :: i1,i2,imin,imax,nmax(1)
  !
  ! Compute the integrated area,Tmax,V of MaX
  call abscissa_velo2chan(obs%head,v1,ri1)
  call abscissa_velo2chan(obs%head,v2,ri2)
  i1 = nint(ri1)
  i2 = nint(ri2)
  imin = max(min(i1,i2),1)
  imax = min(max(i1,i2),obs%head%spe%nchan)
!!$  s0 = 0
!!$  n = 0
!!$  v = 0
!!$  nc=imin
!!$  data1 = obs%spectre(nc)
!!$  do while(obs%spectre(nc).eq.obs%head%spe%bad.and.nc.le.imax)
!!$     nc=nc+1
!!$  enddo
!!$  if (nc.lt.imax) data1 = obs%spectre(nc)
!!$  datav = 0.0
!!$  do i=nc,imax
!!$     if (obs%spectre(i).ne.obs%head%spe%bad) then
!!$        datav = obs%spectre(i)
!!$        n = n+1
!!$        s0 = s0+datav
!!$        if (datav.gt.data1) then
!!$           data1=datav
!!$           call abscissa_chan2velo(obs%head,i,v)
!!$        endif
!!$     endif
!!$  enddo
!!$  ! Transforms K*channels to K*km/s
!!$  if (n.ne.0) then
!!$     s0 = s0*abs(obs%head%spe%vres)
!!$  else
!!$     s0 = obs%head%spe%bad
!!$  endif
  data1 = maxval(obs%spectre(imin:imax),1,obs%spectre(imin:imax).ne.obs%head%spe%bad)
  s0    = sum   (obs%spectre(imin:imax),1,obs%spectre(imin:imax).ne.obs%head%spe%bad)
  nmax  = maxloc(obs%spectre(imin:imax),  obs%spectre(imin:imax).ne.obs%head%spe%bad)
  nmax  = imin+nmax-1
  call abscissa_chan2velo(obs%head,real(nmax(1)),v)
  if (s0.eq.0.) then
     s0 = obs%head%spe%bad
  else
     s0 = s0*abs(obs%head%spe%vres)
  endif
end subroutine allinfo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the ORBIT package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine orbit_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !
  type(gpack_info_t), intent(out) :: pack
  !
  external :: orbit_pack_init
  external :: orbit_pack_clean
  !
  pack%name='orbit'
  pack%ext='.orbit'
  pack%depend(1:1) = (/ locwrd(greg_pack_set) /) ! List here dependencies
  pack%init=locwrd(orbit_pack_init)
  pack%clean=locwrd(orbit_pack_clean)
  pack%authors='T.Forveille'
  !
end subroutine orbit_pack_set
!
subroutine orbit_pack_init(gpack_id,error)
  !----------------------------------------------------------------------
  ! 
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  ! Local
  character(len=1), parameter :: bksl=char(92)
  character(len=64) :: line
  !
  call init_orbit()
  !
  line = 'sic'//bksl//'sic greg2'//bksl//' off'
  call exec_command(line,error)
  !
end subroutine orbit_pack_init
!
subroutine orbit_pack_clean(error)
  !----------------------------------------------------------------------
  ! Called at end of session. Might clean here for example global buffers
  ! allocated during the session
  !----------------------------------------------------------------------
  logical :: error
  !
  ! print *,"Called orbit_pack_clean"
  !
end subroutine orbit_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine eulmat (psi,the,phi,mat)
  !---------------------------------------------------------------------
  ! @ public
  !  from Didier Despois 1980
  !  modified 30 november 1984 by Michel Perault
  !  matrice de changement de coordonnees pour une rotation d'angles d'Euler
  !  PSI, THE et PHI, given in radians.
  !  Multiplication of the euclidian coordinates of a vector in the original base
  !  by this matrix gives the coordinates in the rotated base.
  !  For example, the transformation from galactic II coordinates to equatorial
  !  1950 coordinates is obtained with PSI=33., THETA=-62.6, PHI=-282.25 degrees.
  !  The reverse transformation with PSI=282.25, THETA=62.5, PHI=-33 degrees.
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: psi       ! Euler angles (radians)
  real(kind=8), intent(in)  :: the       ! Euler angles (radians)
  real(kind=8), intent(in)  :: phi       ! Euler angles (radians)
  real(kind=8), intent(out) :: mat(3,3)  ! transformation matrix
  ! Local
  real(kind=8) :: cpsi,spsi,cthe,sthe,cphi,sphi ! sines and cosines
  real(kind=8) :: x
  !
  !  coefficients de la matrice de transformation
  cpsi=dcos(psi)
  spsi=dsin(psi)
  cthe=dcos(the)
  sthe=dsin(the)
  cphi=dcos(phi)
  sphi=dsin(phi)
  x=spsi*cthe
  mat(1,1)=cpsi*cphi-x*sphi
  mat(2,1)=-cpsi*sphi-x*cphi
  mat(3,1)=spsi*sthe
  x=cpsi*cthe
  mat(1,2)=spsi*cphi+x*sphi
  mat(2,2)=-spsi*sphi+x*cphi
  mat(3,2)=-cpsi*sthe
  mat(1,3)=sthe*sphi
  mat(2,3)=sthe*cphi
  mat(3,3)=cthe
  !
end subroutine eulmat
!
subroutine mulmat (mat1,mat2,mat)
  !---------------------------------------------------------------------
  ! @ public
  !  multiplication of two 3 by 3 matrices
  !  Michel Perault - 1 december 1984.
  !  this routine computes MAT = MAT2 x MAT1
  !  it could be a little faster, but also less compact
  !  take care that MAT ought to be different from MAT1 and MAT2
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: mat1(3,3)  !
  real(kind=8), intent(in)  :: mat2(3,3)  !
  real(kind=8), intent(out) :: mat(3,3)   !
  ! Local
  integer(kind=4) :: i,j
  !
  do i=1,3
    do j=1,3
      mat(i,j) = mat2(i,1)*mat1(1,j) + mat2(i,2)*mat1(2,j) + mat2(i,3)*mat1(3,j)
    enddo
  enddo
end subroutine mulmat
!
subroutine matvec (mat1,mat2,mat)
  !---------------------------------------------------------------------
  ! @ public
  !  multiplication of 1 3-D vector by a 3x3 matrix
  !  Michel Perault - 1 december 1984.
  !  this routine computes MAT = MAT2 x MAT1
  !  take care that MAT must be different from MAT1 and MAT2
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: mat1(3)    !
  real(kind=8), intent(in)  :: mat2(3,3)  !
  real(kind=8), intent(out) :: mat(3)     !
  !
  mat(1) = mat2(1,1)*mat1(1) + mat2(1,2)*mat1(2) + mat2(1,3)*mat1(3)
  mat(2) = mat2(2,1)*mat1(1) + mat2(2,2)*mat1(2) + mat2(2,3)*mat1(3)
  mat(3) = mat2(3,1)*mat1(1) + mat2(3,2)*mat1(2) + mat2(3,3)*mat1(3)
end subroutine matvec
!
subroutine transp (mat1,mat2)
  !---------------------------------------------------------------------
  ! @ public
  !  Transposee d'une matrice 3x3
  !  20 Septembre 1985 - Michel Perault - POM Version 2.0
  !  Appel : call TRANSP (MAT1,MAT2)  result in MAT2 = transp (MAT1)
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: mat1(9)  !
  real(kind=8), intent(out) :: mat2(9)  !
  !
  mat2(1)=mat1(1)
  mat2(2)=mat1(4)
  mat2(3)=mat1(7)
  mat2(4)=mat1(2)
  mat2(5)=mat1(5)
  mat2(6)=mat1(8)
  mat2(7)=mat1(3)
  mat2(8)=mat1(6)
  mat2(9)=mat1(9)
  !
end subroutine transp
!
subroutine matinv3(a,b)
  !---------------------------------------------------------------------
  ! @ public
  ! Performs a direct calculation of the inverse of a 3x3 matrix.
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: A(3,3)  ! Matrix
  real(kind=8), intent(out) :: B(3,3)  ! Inverse matrix
  ! Local
  real(kind=8) :: detinv
  !
  ! Calculate the determinant of the matrix
  detinv = A(1,1)*A(2,2)*A(3,3) - A(1,1)*A(2,3)*A(3,2)  &
         - A(1,2)*A(2,1)*A(3,3) + A(1,2)*A(2,3)*A(3,1)  &
         + A(1,3)*A(2,1)*A(3,2) - A(1,3)*A(2,2)*A(3,1)
  !
  ! Inverse determinant of the matrix
  detinv = 1.d0/detinv
  !
  ! Calculate the inverse of the matrix
  B(1,1) = +detinv * (A(2,2)*A(3,3) - A(2,3)*A(3,2))
  B(2,1) = -detinv * (A(2,1)*A(3,3) - A(2,3)*A(3,1))
  B(3,1) = +detinv * (A(2,1)*A(3,2) - A(2,2)*A(3,1))
  B(1,2) = -detinv * (A(1,2)*A(3,3) - A(1,3)*A(3,2))
  B(2,2) = +detinv * (A(1,1)*A(3,3) - A(1,3)*A(3,1))
  B(3,2) = -detinv * (A(1,1)*A(3,2) - A(1,2)*A(3,1))
  B(1,3) = +detinv * (A(1,2)*A(2,3) - A(1,3)*A(2,2))
  B(2,3) = -detinv * (A(1,1)*A(2,3) - A(1,3)*A(2,1))
  B(3,3) = +detinv * (A(1,1)*A(2,2) - A(1,2)*A(2,1))
  !
end subroutine matinv3

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_mrc
  use gbl_message
  !
  public :: mrc_comm
  private
  !
contains
  !
  subroutine mrc_comm(line,error)
    use gkernel_interfaces
    use mapping_interfaces    
    use clean_tool, only: sub_clean,clean_data
    use clean_types, only: beam_unit_conversion
    use uvmap_buffers
    use clean_buffers, only: clean_user,clean_prog
    !----------------------------------------------------------------------
    ! Implementation of Multi Resolution Clean
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: ratio,nx,ny
    character(len=3) :: rname='MRC'
    !
    if (clean_user%mosaic) then
       call map_message(seve%e,rname,'Not valid for mosaic')
       error = .true.
       return
    endif
    !
    ! Data checkup
    clean_user%method = 'MRC'
    call clean_data (error)
    if (error) return
    !
    ! Parameter Definitions
    call beam_unit_conversion(clean_user)
    call clean_user%copyto(clean_prog)
    !
    ! Smoothing ratio : given by user or 2, 4 or 8 according to image size
    if (clean_prog%ratio.ne.0) then
       ratio = clean_prog%ratio
       if (power_of_two(ratio).eq.-1) then
          call map_message(seve%e,rname,'Smoothing ratio has to be a power of 2')
          error = .true.
          return
       endif
    else
       nx = dirty%head%gil%dim(1)
       ny = dirty%head%gil%dim(2)
       if (nx*ny.gt.512*512) then
          ratio = 8
       elseif (nx*ny.gt.128*128) then
          ratio = 4
       else
          ratio = 2
       endif
    endif
    clean_prog%ratio = ratio
    clean_prog%pflux = sic_present(1,0)
    clean_prog%pcycle = sic_present(2,0)
    clean_prog%qcycle = .false.
    !
    call sub_clean(line,error)
    clean_user%do_mask = .true. ! important sinon CLARK ne marche plus
  end subroutine mrc_comm
end module clean_mrc
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine las_setvar(set,line,r,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>las_setvar
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  SET VARIABLE Section_name [READ|WRITE|OFF]
  ! This commands has 2 purposes:
  !  - change the RO/RW status of the R%HEAD%Section,
  !  - create/remove aliases to this section
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(in)    :: line   !
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  !
  ! Local
  integer(kind=4) :: nkey,nc,mode
  character(len=12) :: argum,keywor
  integer, parameter :: mvocab1=24
  character(len=12) :: vocab1(mvocab1)
  ! Data
  data vocab1 /'GENERAL','POSITION','SPECTRO','RESOLUTION','BASE',        &
    'HISTORY','PLOT','FSWITCH','SWITCH','CALIBRATION','SKYDIP','GAUSS',   &
    'SHELL','NH3','HFS','ABSORPTION','DRIFT','BEAM', 'CONTINUUM',         &
    'ASSOCIATED','HERSCHEL','SECTIONS','COMMENT','USER' /
  !
  ! Access mode
  argum = setvar_modes(setvar_read)
  call sic_ke (line,0,3,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs('SET',argum,keywor,mode,setvar_modes,setvar_mmodes,error)
  if (error) return
  !
  ! Section
  call sic_ke (line,0,2,argum,nc,.true.,error)
  if (error) return
  call sic_ambigs('SET',argum,keywor,nkey,vocab1,mvocab1,error)
  if (error) return
  !
  call las_setvar_R(set,r,keywor,mode,error)
  if (error)  return
  !
end subroutine las_setvar
!
subroutine class_variable(set,line,error,user_function)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_variable
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Support routine for command
  !   VARIABLE Section1 [... SectionN]
  ! 1   /MODE  READ|WRITE|OFF
  ! 2   /INDEX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Input command line
  logical,             intent(inout) :: error          ! Logical error flag
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  integer(kind=4) :: nkey,nc,mode,iarg
  character(len=12) :: argum,keywor
  logical :: presec,readsec(-mx_sec:0)  ! Which section are to be added
  ! Data
  integer, parameter :: msections=22
  character(len=12) :: sections(msections)
  data sections /'SECTIONS','GENERAL','POSITION','SPECTRO','RESOLUTION',      &
    'BASE','HISTORY','PLOT','FSWITCH','SWITCH','CALIBRATION','SKYDIP',        &
    'GAUSS','SHELL','HFS','ABSORPTION','DRIFT','BEAM','CONTINUUM','COMMENT',  &
    'USER','HERSCHEL' /
  !
  ! Sections
  presec = .false.
  readsec(:) = .false.  ! None but:
  do iarg=1,sic_narg(0)
    call sic_ke(line,0,iarg,argum,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,argum,keywor,nkey,sections,msections,error)
    if (error) return
    select case (keywor)
    case ('SECTIONS')
      presec = .true.
    case ('GENERAL')
      readsec(class_sec_gen_id) = .true.
    case ('POSITION')
      readsec(class_sec_pos_id) = .true.
    case ('SPECTRO')
      readsec(class_sec_spe_id) = .true.
    case ('RESOLUTION')
      readsec(class_sec_res_id) = .true.
    case ('BASE')
      readsec(class_sec_bas_id) = .true.
    case ('HISTORY')
      readsec(class_sec_his_id) = .true.
    case ('PLOT')
      readsec(class_sec_plo_id) = .true.
    case ('FSWITCH','SWITCH')
      readsec(class_sec_swi_id) = .true.
    case ('CALIBRATION')
      readsec(class_sec_cal_id) = .true.
    case ('SKYDIP')
      readsec(class_sec_sky_id) = .true.
    case ('GAUSS')
      readsec(class_sec_gau_id) = .true.
    case ('SHELL')
      readsec(class_sec_she_id) = .true.
    case ('HFS')
      readsec(class_sec_hfs_id) = .true.
    case ('ABSORPTION')
      readsec(class_sec_abs_id) = .true.
    case ('DRIFT')
      readsec(class_sec_dri_id) = .true.
    case ('BEAM')
      readsec(class_sec_bea_id) = .true.
    case ('CONTINUUM')
      readsec(class_sec_poi_id) = .true.
    case ('COMMENT')
      readsec(class_sec_com_id) = .true.
    case ('USER')
      readsec(class_sec_user_id) = .true.
    case ('HERSCHEL')
      readsec(class_sec_her_id) = .true.
    case default
      call class_message(seve%w,rname,  &
        'Section '//trim(keywor)//' not implemented')
    end select
  enddo
  !
  ! Access mode
  argum = setvar_modes(setvar_read)
  call sic_ke (line,1,1,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,argum,keywor,mode,setvar_modes,setvar_mmodes,error)
  if (error) return
  !
  if (sic_present(2,0)) then  ! /INDEX
    call class_variable_index(set,presec,readsec,mode,error,user_function)
    if (error)  return
  else
    call class_message(seve%e,rname,'Only /INDEX is implemented')
    error = .true.
    return
  endif
  !
end subroutine class_variable
!
subroutine las_setvar_R(set,r,keywor,mode,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>las_setvar_R
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Instantiate the requested section in Sic structure R%HEAD
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set     !
  type(observation),   intent(inout) :: r       !
  character(len=*),    intent(in)    :: keywor  !
  integer(kind=4),     intent(in)    :: mode    ! setvar_off/read/write
  logical,             intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SETVAR'
  logical :: userreq
  integer(kind=index_length) :: dim(4)
  !
  userreq = .false.
  !
  select case (keywor)
  case('GENERAL')
    call las_variables_rgen('R%HEAD',r,mode.ne.setvar_write,error)  ! Must be re-created before the aliases
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_gen_id) = .true.  ! else unchanged
    call las_setvar_R_alias(class_sec_gen_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_gen_id) = mode
    !
  case('POSITION')
    call las_variables_rpos('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_pos_id) = .true.
    call las_setvar_R_alias(class_sec_pos_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_pos_id) = mode
    !
  case('SPECTRO')
    call las_variables_rspe('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_spe_id) = .true.
    call las_setvar_R_alias(class_sec_spe_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_spe_id) = mode
    !
  case('RESOLUTION')
    call las_variables_rres('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_res_id) = .true.
    call las_setvar_R_alias(class_sec_res_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_res_id) = mode
    !
  case('BASE')
    call las_variables_rbas('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_bas_id) = .true.
    call las_setvar_R_alias(class_sec_bas_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_bas_id) = mode
    !
  case('HISTORY')
    call las_variables_rhis('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_his_id) = .true.
    call las_setvar_R_alias(class_sec_his_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_his_id) = mode
    !
  case('PLOT')
    call las_variables_rplo('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_plo_id) = .true.
    call las_setvar_R_alias(class_sec_plo_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_plo_id) = mode
    !
  case('FSWITCH','SWITCH')
    call las_variables_rswi('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_swi_id) = .true.
    call las_setvar_R_alias(class_sec_swi_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_swi_id) = mode
    !
  case('CALIBRATION')
    call las_variables_rcal('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_cal_id)=.true.
    call las_setvar_R_alias(class_sec_cal_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_cal_id) = mode
    !
  case('SKYDIP')
    call las_variables_rsky('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_sky_id)=.true.
    call las_setvar_R_alias(class_sec_sky_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_sky_id) = mode
    !
  case('GAUSS')
    call las_variables_rgau('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_gau_id) = .true.
    call las_setvar_R_alias(class_sec_gau_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_gau_id) = mode
    !
  case('SHELL')
    call las_variables_rshe('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_she_id) = .true.
    call las_setvar_R_alias(class_sec_she_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_she_id) = mode
    !
  case('NH3','HFS')
    call las_variables_rhfs('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_hfs_id) = .true.
    call las_setvar_R_alias(class_sec_hfs_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_hfs_id) = mode
    !
  case('ABS')
    call las_variables_rabs('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_abs_id)=.true.
    call las_setvar_R_alias(class_sec_abs_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_abs_id) = mode
    !
  case('DRIFT')
    call las_variables_rdri('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_dri_id) = .true.
    call las_setvar_R_alias(class_sec_dri_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_dri_id) = mode
    !
  case('BEAM')
    call las_variables_rbea('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_bea_id) = .true.
    call las_setvar_R_alias(class_sec_bea_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_bea_id) = mode
    !
  case('CONTINUUM')
    call las_variables_rpoi('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_poi_id)=.true.
    call las_setvar_R_alias(class_sec_poi_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_poi_id) = mode
    !
  case('HERSCHEL')
    call las_variables_rher('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_her_id)=.true.
    call las_setvar_R_alias(class_sec_her_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_her_id) = mode
    !
  case('ASSOCIATED')
    set%varpresec(class_sec_assoc_id) = mode  ! New mode
    call newdat_assoc(set,r,error)  ! Must come after the new mode
    if (error)  return
    ! if (mode.eq.setvar_write) r%head%presec(class_sec_assoc_id)=.true.
    !     No: activating the section with SET VAR ASSOC WR is useless without
    !     adding an Associated Array. Use command ASSOCIATE instead.
    ! call las_setvar_R_alias(class_sec_her_id,mode.eq.setvar_off,error)
    !     No: no aliases onto the assoc arrays...
    !
  case('SECTIONS')
     call sic_delvariable('R%HEAD%PRESEC',userreq,error)
     error = .false.  ! Attempt to delete non-existent variables is not an error
     if (mode.eq.setvar_off) return
     !
     dim(1) = mx_sec+1
     call sic_def_login('R%HEAD%PRESEC',r%head%presec(-mx_sec),1,dim,mode.ne.setvar_write,error)
     !
  case('COMMENT')
     if (.not.r%head%presec(class_sec_com_id)) then
        call class_message(seve%w,rname,'Comment section does not exist')
        return
     elseif (mode.eq.setvar_write) then
        call class_message(seve%e,rname,  &
          'Keyword WRITE not possible, use command COMMENT')
        error = .true.
        return
     else
        call sic_delvariable('COMMENT',userreq,error)
        error = .false.  ! Attempt to delete non-existent variables is not an error
        if (mode.eq.setvar_off) return
        call sic_def_char('COMMENT',r%head%com%ctext,mode.ne.setvar_write,error)
     endif
     set%varpresec(class_sec_com_id) = mode
     !
  case('USER')
     set%varpresec(class_sec_user_id) = mode  ! Must be set before calling newdat_user
     call user_sec_setvar(set,r,mode.eq.setvar_off,error)
     if (error)  return
     !
  case default
     call class_message(seve%e,rname,'Unknown section '//keywor)
     error = .true.
  end select
  !
end subroutine las_setvar_R
!
subroutine las_setvar_R_alias(code,delete,error)
  use gkernel_interfaces
  use classcore_interfaces, except_this=>las_setvar_R_alias
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  !  Delete and/or (re)create aliases to the section elements.
  !  NB: aliases inherit the RW/RO status of their targets
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: code    ! Section code
  logical,         intent(in)    :: delete  ! Delete or create aliases?
  logical,         intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  !
  userreq = .false.
  !
  select case (code)
  case (class_sec_gen_id)
    call sic_delvariable('NUM',userreq,error)
    call sic_delvariable('VER',userreq,error)
    call sic_delvariable('TELES',userreq,error)
    call sic_delvariable('DOBS',userreq,error)
    call sic_delvariable('DRED',userreq,error)
    call sic_delvariable('CDOBS',userreq,error)
    call sic_delvariable('CDRED',userreq,error)
    call sic_delvariable('KIND',userreq,error)
    call sic_delvariable('QUAL',userreq,error)
    call sic_delvariable('UT',userreq,error)
    call sic_delvariable('ST',userreq,error)
    call sic_delvariable('AZ',userreq,error)
    call sic_delvariable('EL',userreq,error)
    call sic_delvariable('TAU',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('NUM',  'R%HEAD%GEN%NUM',  .true.,error)
    call sic_def_alias('VER',  'R%HEAD%GEN%VER',  .true.,error)
    call sic_def_alias('TELES','R%HEAD%GEN%TELES',.true.,error)
    call sic_def_alias('DOBS', 'R%HEAD%GEN%DOBS', .true.,error)
    call sic_def_alias('DRED', 'R%HEAD%GEN%DRED', .true.,error)
    call sic_def_alias('CDOBS','R%HEAD%GEN%CDOBS',.true.,error)
    call sic_def_alias('CDRED','R%HEAD%GEN%CDRED',.true.,error)
    call sic_def_alias('KIND', 'R%HEAD%GEN%KIND', .true.,error)
    call sic_def_alias('QUAL', 'R%HEAD%GEN%QUAL', .true.,error)
    call sic_def_alias('UT',   'R%HEAD%GEN%UT',   .true.,error)
    call sic_def_alias('ST',   'R%HEAD%GEN%ST',   .true.,error)
    call sic_def_alias('AZ',   'R%HEAD%GEN%AZ',   .true.,error)
    call sic_def_alias('EL',   'R%HEAD%GEN%EL',   .true.,error)
    call sic_def_alias('TAU',  'R%HEAD%GEN%TAU',  .true.,error)
    if (error)  return
    !
  case (class_sec_pos_id)
    call sic_delvariable('SOURC',userreq,error)
    call sic_delvariable('EQUINOX',userreq,error)
    call sic_delvariable('LAM',userreq,error)
    call sic_delvariable('BET',userreq,error)
    call sic_delvariable('LAMOF',userreq,error)
    call sic_delvariable('BETOF',userreq,error)
    call sic_delvariable('PROJ',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('SOURC',  'R%HEAD%POS%SOURC',  .true.,error)
    call sic_def_alias('EQUINOX','R%HEAD%POS%EQUINOX',.true.,error)
    call sic_def_alias('LAM',    'R%HEAD%POS%LAM',    .true.,error)
    call sic_def_alias('BET',    'R%HEAD%POS%BET',    .true.,error)
    call sic_def_alias('LAMOF',  'R%HEAD%POS%LAMOF',  .true.,error)
    call sic_def_alias('BETOF',  'R%HEAD%POS%BETOF',  .true.,error)
    call sic_def_alias('PROJ',   'R%HEAD%POS%PROJ',   .true.,error)
    if (error)  return
    !
  case (class_sec_spe_id)
    call sic_delvariable('LINE',userreq,error)
    call sic_delvariable('NCHAN',userreq,error)
    call sic_delvariable('RESTF',userreq,error)
    call sic_delvariable('RCHAN',userreq,error)
    call sic_delvariable('FRES',userreq,error)
    call sic_delvariable('VRES',userreq,error)
    call sic_delvariable('VOFF',userreq,error)
    call sic_delvariable('BAD',userreq,error)
    call sic_delvariable('IMAGE',userreq,error)
    call sic_delvariable('VTYPE',userreq,error)
    call sic_delvariable('SKYFR',userreq,error)
    call sic_delvariable('VTELES',userreq,error)
    call sic_delvariable('DOPPLER',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LINE',   'R%HEAD%SPE%LINE',   .true.,error)
    call sic_def_alias('NCHAN',  'R%HEAD%SPE%NCHAN',  .true.,error)
    call sic_def_alias('RESTF',  'R%HEAD%SPE%RESTF',  .true.,error)
    call sic_def_alias('RCHAN',  'R%HEAD%SPE%RCHAN',  .true.,error)
    call sic_def_alias('FRES',   'R%HEAD%SPE%FRES',   .true.,error)
    call sic_def_alias('VRES',   'R%HEAD%SPE%VRES',   .true.,error)
    call sic_def_alias('VOFF',   'R%HEAD%SPE%VOFF',   .true.,error)
    call sic_def_alias('BAD',    'R%HEAD%SPE%BAD',    .true.,error)
    call sic_def_alias('IMAGE',  'R%HEAD%SPE%IMAGE',  .true.,error)
    call sic_def_alias('VTYPE',  'R%HEAD%SPE%VTYPE',  .true.,error)
  ! call sic_def_alias('SKYFR',  'R%HEAD%SPE%SKYFR',  .true.,error)
  ! call sic_def_alias('VTELES', 'R%HEAD%SPE%VTELES', .true.,error)
    call sic_def_alias('DOPPLER','R%HEAD%SPE%DOPPLER',.true.,error)
    if (error)  return
    !
  case (class_sec_bas_id)
    call sic_delvariable('DEG',userreq,error)
    call sic_delvariable('SIGFI',userreq,error)
    call sic_delvariable('AIRE',userreq,error)
    call sic_delvariable('NWIND',userreq,error)
    call sic_delvariable('W1',userreq,error)
    call sic_delvariable('W2',userreq,error)
    call sic_delvariable('SINUS',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('DEG',  'R%HEAD%BAS%DEG',  .true.,error)
    call sic_def_alias('SIGFI','R%HEAD%BAS%SIGFI',.true.,error)
    call sic_def_alias('AIRE', 'R%HEAD%BAS%AIRE', .true.,error)
    call sic_def_alias('NWIND','R%HEAD%BAS%NWIND',.true.,error)
    call sic_def_alias('W1',   'R%HEAD%BAS%W1',   .true.,error)
    call sic_def_alias('W2',   'R%HEAD%BAS%W2',   .true.,error)
    call sic_def_alias('SINUS','R%HEAD%BAS%SINUS',.true.,error)
    if (error)  return
    !
  case (class_sec_his_id)
    call sic_delvariable('NSEQ',userreq,error)
    call sic_delvariable('START',userreq,error)
    call sic_delvariable('END',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('NSEQ', 'R%HEAD%HIS%NSEQ', .true.,error)
    call sic_def_alias('START','R%HEAD%HIS%START',.true.,error)
    call sic_def_alias('END',  'R%HEAD%HIS%END',  .true.,error)
    if (error)  return
    !
  case (class_sec_plo_id)
    call sic_delvariable('AMIN',userreq,error)
    call sic_delvariable('AMAX',userreq,error)
    call sic_delvariable('VMIN',userreq,error)
    call sic_delvariable('VMAX',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('AMIN','R%HEAD%PLO%AMIN',.true.,error)
    call sic_def_alias('AMAX','R%HEAD%PLO%AMAX',.true.,error)
    call sic_def_alias('VMIN','R%HEAD%PLO%VMIN',.true.,error)
    call sic_def_alias('VMAX','R%HEAD%PLO%VMAX',.true.,error)
    if (error)  return
    !
  case (class_sec_swi_id)
    call sic_delvariable('NPHAS',userreq,error)
    call sic_delvariable('DECAL',userreq,error)
    call sic_delvariable('DUREE',userreq,error)
    call sic_delvariable('POIDS',userreq,error)
    call sic_delvariable('SWMOD',userreq,error)
    call sic_delvariable('LDECAL',userreq,error)
    call sic_delvariable('BDECAL',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('NPHAS', 'R%HEAD%FSW%NPHAS', .true.,error)
    call sic_def_alias('SWMOD', 'R%HEAD%FSW%SWMOD', .true.,error)
    call sic_def_alias('DECAL', 'R%HEAD%FSW%DECAL', .true.,error)
    call sic_def_alias('DUREE', 'R%HEAD%FSW%DUREE', .true.,error)
    call sic_def_alias('POIDS', 'R%HEAD%FSW%POIDS', .true.,error)
    call sic_def_alias('LDECAL','R%HEAD%FSW%LDECAL',.true.,error)
    call sic_def_alias('BDECAL','R%HEAD%FSW%BDECAL',.true.,error)
    if (error)  return
    !
  case (class_sec_cal_id)
    call sic_delvariable('BEEFF',userreq,error)
    call sic_delvariable('FOEFF',userreq,error)
    call sic_delvariable('GAINI',userreq,error)
    call sic_delvariable('H2OMM',userreq,error)
    call sic_delvariable('PAMB',userreq,error)
    call sic_delvariable('TAMB',userreq,error)
    call sic_delvariable('TATMS',userreq,error)
    call sic_delvariable('TCHOP',userreq,error)
    call sic_delvariable('TCOLD',userreq,error)
    call sic_delvariable('TAUS',userreq,error)
    call sic_delvariable('TAUI',userreq,error)
    call sic_delvariable('TATMI',userreq,error)
    call sic_delvariable('TREC',userreq,error)
    call sic_delvariable('CMODE',userreq,error)
    call sic_delvariable('ATFAC',userreq,error)
    call sic_delvariable('ALTI',userreq,error)
    call sic_delvariable('COUNT',userreq,error)
    call sic_delvariable('LCALOF',userreq,error)
    call sic_delvariable('BCALOF',userreq,error)
    call sic_delvariable('GEOLONG',userreq,error)
    call sic_delvariable('GEOLAT',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('BEEFF',  'R%HEAD%CAL%BEEFF',  .true.,error)
    call sic_def_alias('FOEFF',  'R%HEAD%CAL%FOEFF',  .true.,error)
    call sic_def_alias('GAINI',  'R%HEAD%CAL%GAINI',  .true.,error)
    call sic_def_alias('H2OMM',  'R%HEAD%CAL%H2OMM',  .true.,error)
    call sic_def_alias('PAMB',   'R%HEAD%CAL%PAMB',   .true.,error)
    call sic_def_alias('TAMB',   'R%HEAD%CAL%TAMB',   .true.,error)
    call sic_def_alias('TATMS',  'R%HEAD%CAL%TATMS',  .true.,error)
    call sic_def_alias('TCHOP',  'R%HEAD%CAL%TCHOP',  .true.,error)
    call sic_def_alias('TCOLD',  'R%HEAD%CAL%TCOLD',  .true.,error)
    call sic_def_alias('TAUS',   'R%HEAD%CAL%TAUS',   .true.,error)
    call sic_def_alias('TAUI',   'R%HEAD%CAL%TAUI',   .true.,error)
    call sic_def_alias('TATMI',  'R%HEAD%CAL%TATMI',  .true.,error)
    call sic_def_alias('TREC',   'R%HEAD%CAL%TREC',   .true.,error)
    call sic_def_alias('CMODE',  'R%HEAD%CAL%CMODE',  .true.,error)
    call sic_def_alias('ATFAC',  'R%HEAD%CAL%ATFAC',  .true.,error)
    call sic_def_alias('ALTI',   'R%HEAD%CAL%ALTI',   .true.,error)
    call sic_def_alias('COUNT',  'R%HEAD%CAL%COUNT',  .true.,error)
    call sic_def_alias('LCALOF', 'R%HEAD%CAL%LCALOF', .true.,error)
    call sic_def_alias('BCALOF', 'R%HEAD%CAL%BCALOF', .true.,error)
    call sic_def_alias('GEOLONG','R%HEAD%CAL%GEOLONG',.true.,error)
    call sic_def_alias('GEOLAT', 'R%HEAD%CAL%GEOLAT', .true.,error)
    if (error)  return
    !
  case (class_sec_sky_id)
    call sic_delvariable('SREST',userreq,error)
    call sic_delvariable('SIMAG',userreq,error)
    call sic_delvariable('NSKY',userreq,error)
    call sic_delvariable('NCHOP',userreq,error)
    call sic_delvariable('NCOLD',userreq,error)
    call sic_delvariable('ELEV',userreq,error)
    call sic_delvariable('EMISS',userreq,error)
    call sic_delvariable('CHOPP',userreq,error)
    call sic_delvariable('COLD',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('SREST','R%HEAD%SKY%RESTF',.true.,error)
    call sic_def_alias('SIMAG','R%HEAD%SKY%IMAGE',.true.,error)
    call sic_def_alias('NSKY', 'R%HEAD%SKY%NSKY', .true.,error)
    call sic_def_alias('NCHOP','R%HEAD%SKY%NCHOP',.true.,error)
    call sic_def_alias('NCOLD','R%HEAD%SKY%NCOLD',.true.,error)
    call sic_def_alias('ELEV', 'R%HEAD%SKY%ELEV', .true.,error)
    call sic_def_alias('EMISS','R%HEAD%SKY%EMISS',.true.,error)
    call sic_def_alias('CHOPP','R%HEAD%SKY%CHOPP',.true.,error)
    call sic_def_alias('COLD', 'R%HEAD%SKY%COLD', .true.,error)
    if (error)  return
    !
  case (class_sec_gau_id)
    call sic_delvariable('NLINE',userreq,error)
    call sic_delvariable('SIGBA',userreq,error)
    call sic_delvariable('SIGRA',userreq,error)
    call sic_delvariable('NFIT',userreq,error)
    call sic_delvariable('NERR',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('NLINE','R%HEAD%GAU%NLINE',.true.,error)
    call sic_def_alias('SIGBA','R%HEAD%GAU%RMS_BASE',.true.,error)
    call sic_def_alias('SIGRA','R%HEAD%GAU%RMS_LINE',.true.,error)
    call sic_def_alias('NFIT', 'R%HEAD%GAU%RESULT', .true.,error)
    call sic_def_alias('NERR', 'R%HEAD%GAU%ERROR', .true.,error)
    if (error)  return
    !
  case (class_sec_she_id)
    call sic_delvariable('LSHEL',userreq,error)
    call sic_delvariable('BSHEL',userreq,error)
    call sic_delvariable('RSHEL',userreq,error)
    call sic_delvariable('NSHEL',userreq,error)
    call sic_delvariable('ESHEL',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LSHEL','R%HEAD%SHE%NLINE',.true.,error)
    call sic_def_alias('BSHEL','R%HEAD%SHE%RMS_BASE',.true.,error)
    call sic_def_alias('RSHEL','R%HEAD%SHE%RMS_LINE',.true.,error)
    call sic_def_alias('NSHEL','R%HEAD%SHE%RESULT', .true.,error)
    call sic_def_alias('ESHEL','R%HEAD%SHE%ERROR', .true.,error)
    if (error)  return
    !
  case (class_sec_hfs_id)
    call sic_delvariable('LNH3',userreq,error)
    call sic_delvariable('BNH3',userreq,error)
    call sic_delvariable('RNH3',userreq,error)
    call sic_delvariable('NNH3',userreq,error)
    call sic_delvariable('ENH3',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LNH3','R%HEAD%HFS%NLINE',.true.,error)
    call sic_def_alias('BNH3','R%HEAD%HFS%RMS_BASE',.true.,error)
    call sic_def_alias('RNH3','R%HEAD%HFS%RMS_LINE',.true.,error)
    call sic_def_alias('NNH3','R%HEAD%HFS%RESULT', .true.,error)
    call sic_def_alias('ENH3','R%HEAD%HFS%ERROR', .true.,error)
    if (error)  return
    !
  case (class_sec_abs_id)
    call sic_delvariable('LABS',userreq,error)
    call sic_delvariable('BABS',userreq,error)
    call sic_delvariable('RABS',userreq,error)
    call sic_delvariable('NABS',userreq,error)
    call sic_delvariable('EABS',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LABS','R%HEAD%ABS%NLINE',.true.,error)
    call sic_def_alias('BABS','R%HEAD%ABS%RMS_BASE',.true.,error)
    call sic_def_alias('RABS','R%HEAD%ABS%RMS_LINE',.true.,error)
    call sic_def_alias('NABS','R%HEAD%ABS%RESULT', .true.,error)
    call sic_def_alias('EABS','R%HEAD%ABS%ERROR', .true.,error)
    if (error)  return
    !
  case (class_sec_dri_id)
    call sic_delvariable('FREQ',userreq,error)
    call sic_delvariable('WIDTH',userreq,error)
    call sic_delvariable('NPOIN',userreq,error)
    call sic_delvariable('RPOIN',userreq,error)
    call sic_delvariable('TREF',userreq,error)
    call sic_delvariable('AREF',userreq,error)
    call sic_delvariable('TRES',userreq,error)
    call sic_delvariable('ARES',userreq,error)
    call sic_delvariable('APOS',userreq,error)
    call sic_delvariable('CBAD',userreq,error)
    call sic_delvariable('CTYPE',userreq,error)
    call sic_delvariable('CIMAG',userreq,error)
    call sic_delvariable('COLLA',userreq,error)
    call sic_delvariable('COLLE',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('FREQ', 'R%HEAD%DRI%FREQ', .true.,error)
    call sic_def_alias('WIDTH','R%HEAD%DRI%WIDTH',.true.,error)
    call sic_def_alias('NPOIN','R%HEAD%DRI%NPOIN',.true.,error)
    call sic_def_alias('RPOIN','R%HEAD%DRI%RPOIN',.true.,error)
    call sic_def_alias('TREF', 'R%HEAD%DRI%TREF', .true.,error)
    call sic_def_alias('AREF', 'R%HEAD%DRI%AREF', .true.,error)
    call sic_def_alias('TRES', 'R%HEAD%DRI%TRES', .true.,error)
    call sic_def_alias('ARES', 'R%HEAD%DRI%ARES', .true.,error)
    call sic_def_alias('APOS', 'R%HEAD%DRI%APOS', .true.,error)
    call sic_def_alias('CBAD', 'R%HEAD%DRI%BAD',  .true.,error)
    call sic_def_alias('CTYPE','R%HEAD%DRI%CTYPE',.true.,error)
    call sic_def_alias('CIMAG','R%HEAD%DRI%CIMAG',.true.,error)
    call sic_def_alias('COLLA','R%HEAD%DRI%COLLA',.true.,error)
    call sic_def_alias('COLLE','R%HEAD%DRI%COLLE',.true.,error)
    if (error)  return
    !
  case (class_sec_bea_id)
    call sic_delvariable('CAZIM',userreq,error)
    call sic_delvariable('CELEV',userreq,error)
    call sic_delvariable('SPACE',userreq,error)
    call sic_delvariable('BPOS',userreq,error)
    call sic_delvariable('BTYPE',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('CAZIM','R%HEAD%BEA%CAZIM',.true.,error)
    call sic_def_alias('CELEV','R%HEAD%BEA%CELEV',.true.,error)
    call sic_def_alias('SPACE','R%HEAD%BEA%SPACE',.true.,error)
    call sic_def_alias('BPOS', 'R%HEAD%BEA%BPOS', .true.,error)
    call sic_def_alias('BTYPE','R%HEAD%BEA%BTYPE',.true.,error)
    if (error)  return
    !
  case (class_sec_poi_id)
    call sic_delvariable('LCONT',userreq,error)
    call sic_delvariable('BCONT',userreq,error)
    call sic_delvariable('RCONT',userreq,error)
    call sic_delvariable('NCONT',userreq,error)
    call sic_delvariable('ECONT',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LCONT','R%HEAD%POI%NLINE',.true.,error)
    call sic_def_alias('BCONT','R%HEAD%POI%RMS_BASE',.true.,error)
    call sic_def_alias('RCONT','R%HEAD%POI%RMS_LINE',.true.,error)
    call sic_def_alias('NCONT','R%HEAD%POI%RESULT', .true.,error)
    call sic_def_alias('ECONT','R%HEAD%POI%ERROR', .true.,error)
    if (error)  return
    !
  case default
    ! No aliases for this section, not an error
    return
  end select
  !
end subroutine las_setvar_R_alias
!
subroutine las_setvar_R_aliases(set,error)
  use classcore_interfaces, except_this=>las_setvar_R_aliases
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Recreate the aliases for ALL sections which are currently
  ! activated (SET VARIABLE Section ON|READ|WRITE)
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: isec
  !
  do isec=-mx_sec,0
    if (set%varpresec(isec).ne.setvar_off) then
      call las_setvar_R_alias(isec,.false.,error)
      if (error)  return
    endif
  enddo
  !
end subroutine las_setvar_R_aliases
!
!-----------------------------------------------------------------------
!
subroutine class_variable_index_reset(error)
  use classcore_interfaces, except_this=>class_variable_index_reset
  !---------------------------------------------------------------------
  ! @ private
  !  Reset the IDX% structure in Sic, probably because something has
  ! changed in CX.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  ! Destroy IDX%HEAD%: the support arrays are now outdated. Do not
  ! recompute them implicitly, this is too costly
  call sic_delvariable('IDX%HEAD',.false.,error)
  if (error)  error = .false.  ! No error if it does not exists
  call sic_delvariable('IDX%USER',.false.,error)
  if (error)  error = .false.  ! No error if it does not exists
  !
  ! Remap the CX arrays
  call class_variable_index_cx(error)
  if (error)  return
  !
end subroutine class_variable_index_reset
!
subroutine class_variable_index_cx(error)
  use classcore_dependencies_interfaces
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  !  Create the IDX% Sic structure mapping the CX arrays (always
  ! available)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error status
  ! Local
  integer(kind=index_length) :: dim(4)
  !
  ! Create structure if needed
  if (.not.sic_varexist('idx')) then
     call sic_defstructure('idx%',.true.,error)
     call sic_def_logi('idx%oldfmt',cx%has_old_fmt,.false.,error)
     call sic_def_long('idx%time',cx%time,0,dim,.false.,error)
     if (error) return
  endif
  !
  ! Removed previously defined structure variable
  call sic_delvariable('idx%ind',    .false.,error)
  call sic_delvariable('idx%num',    .false.,error)
  call sic_delvariable('idx%ver',    .false.,error)
  call sic_delvariable('idx%kind',   .false.,error)
  call sic_delvariable('idx%qual',   .false.,error)
  call sic_delvariable('idx%scan',   .false.,error)
  call sic_delvariable('idx%subscan',.false.,error)
  call sic_delvariable('idx%dobs',   .false.,error)
  call sic_delvariable('idx%loff',   .false.,error)
  call sic_delvariable('idx%boff',   .false.,error)
  call sic_delvariable('idx%sourc',  .false.,error)
  call sic_delvariable('idx%line',   .false.,error)
  call sic_delvariable('idx%teles',  .false.,error)
  call sic_delvariable('idx%posa',   .false.,error)
  ! UT is not in index V1 or V2. Comment out IDX%UT as long as index V3
  ! is not the default and widely distributed.
! call sic_delvariable('idx%ut',     .false.,error)
  error = .false.
  !
  nindex = cx%next-1
  if (nindex.gt.0) then
     dim(1) = nindex
     call sic_def_long ('idx%ind',    cx%ind,    1,dim,.false.,error)
     call sic_def_long ('idx%num',    cx%num,    1,dim,.false.,error)
     call sic_def_inte ('idx%ver',    cx%ver,    1,dim,.false.,error)
     call sic_def_inte ('idx%kind',   cx%kind,   1,dim,.false.,error)
     call sic_def_inte ('idx%qual',   cx%qual,   1,dim,.false.,error)
     call sic_def_long ('idx%scan',   cx%scan,   1,dim,.false.,error)
     call sic_def_inte ('idx%subscan',cx%subscan,1,dim,.false.,error)
     call sic_def_inte ('idx%dobs',   cx%dobs,   1,dim,.false.,error)
     call sic_def_real ('idx%loff',   cx%off1,   1,dim,.false.,error)
     call sic_def_real ('idx%boff',   cx%off2,   1,dim,.false.,error)
     call sic_def_charn('idx%sourc',  cx%csour,  1,dim,.false.,error)
     call sic_def_charn('idx%line',   cx%cline,  1,dim,.false.,error)
     call sic_def_charn('idx%teles',  cx%ctele,  1,dim,.false.,error)
     call sic_def_real ('idx%posa',   cx%posa,   1,dim,.false.,error)
   ! call sic_def_dble ('idx%ut',     cx%ut,     1,dim,.false.,error)
     error = .false.
  endif
  !
end subroutine class_variable_index_cx
!
subroutine class_variable_index(set,presec,readsec,mode,error,user_function)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_variable_index
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Create a section in the IDX%HEAD% Sic structure
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set                 !
  logical,             intent(in)    :: presec              ! Enable the 'present sections' array?
  logical,             intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be added
  integer(kind=4),     intent(in)    :: mode                ! setvar_off/read/write
  logical,             intent(inout) :: error               !
  logical,             external      :: user_function       !
  !
  if (mode.eq.setvar_write) then
    call class_message(seve%e,'VARIABLE',  &
      '/MODE WRITE is exclusive with option /INDEX')
    error = .true.
    return
  endif
  !
  ! Delete support variables
  call class_variable_index_delvar(presec,readsec,error)
  if (error)  return
  !
  if (mode.eq.setvar_off) then  ! DELETE mode
    ! Free associated memory
    call class_variable_index_reallocate(presec,readsec,0_8,error)
    return  ! Nothing more
  endif
  !
  call class_variable_index_fill(set,presec,readsec,error,user_function)
  if (error)  return
  !
  ! Create support variables
  call class_variable_index_defvar(presec,readsec,error)
  if (error)  return
  !
end subroutine class_variable_index
!
subroutine class_variable_index_delvar(presec,readsec,error)
  use classcore_dependencies_interfaces
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  !  Delete variables (structures) in IDX%HEAD%
  !---------------------------------------------------------------------
  logical, intent(in)    :: presec              ! Enable the 'present sections' array?
  logical, intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be added
  logical, intent(inout) :: error               !
  !
  if (presec)  call sic_delvariable('IDX%HEAD%PRESEC',.false.,error)
  if (readsec(class_sec_gen_id))   call sic_delvariable('IDX%HEAD%GEN',.false.,error)
  if (readsec(class_sec_pos_id))   call sic_delvariable('IDX%HEAD%POS',.false.,error)
  if (readsec(class_sec_spe_id))   call sic_delvariable('IDX%HEAD%SPE',.false.,error)
  if (readsec(class_sec_res_id))   call sic_delvariable('IDX%HEAD%RES',.false.,error)
  if (readsec(class_sec_bas_id))   call sic_delvariable('IDX%HEAD%BAS',.false.,error)
  if (readsec(class_sec_his_id))   call sic_delvariable('IDX%HEAD%HIS',.false.,error)
  if (readsec(class_sec_plo_id))   call sic_delvariable('IDX%HEAD%PLO',.false.,error)
  if (readsec(class_sec_swi_id))   call sic_delvariable('IDX%HEAD%FSW',.false.,error)
  if (readsec(class_sec_cal_id))   call sic_delvariable('IDX%HEAD%CAL',.false.,error)
  if (readsec(class_sec_sky_id))   call sic_delvariable('IDX%HEAD%SKY',.false.,error)
  if (readsec(class_sec_gau_id))   call sic_delvariable('IDX%HEAD%GAU',.false.,error)
  if (readsec(class_sec_she_id))   call sic_delvariable('IDX%HEAD%SHE',.false.,error)
  if (readsec(class_sec_hfs_id))   call sic_delvariable('IDX%HEAD%HFS',.false.,error)
  if (readsec(class_sec_abs_id))   call sic_delvariable('IDX%HEAD%ABS',.false.,error)
  if (readsec(class_sec_dri_id))   call sic_delvariable('IDX%HEAD%DRI',.false.,error)
  if (readsec(class_sec_bea_id))   call sic_delvariable('IDX%HEAD%BEA',.false.,error)
  if (readsec(class_sec_poi_id))   call sic_delvariable('IDX%HEAD%POI',.false.,error)
  if (readsec(class_sec_com_id))   call sic_delvariable('IDX%HEAD%COM',.false.,error)
  if (readsec(class_sec_her_id))   call sic_delvariable('IDX%HEAD%HER',.false.,error)
  if (readsec(class_sec_user_id))  call sic_delvariable('IDX%USER',    .false.,error)
  !
end subroutine class_variable_index_delvar
!
subroutine class_variable_index_fill(set,presec,readsec,error,user_function)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_variable_index_fill
  use class_index
  use class_parameter
  use class_sicidx
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the section arrays for the IDX%HEAD% Sic structure
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set                 !
  logical,             intent(in)    :: presec              ! Enable the 'present sections' array?
  logical,             intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be added
  logical,             intent(inout) :: error               !
  logical,             external      :: user_function       !
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  type(observation) :: obs
  integer(kind=entry_length) :: ient,kx
  type(time_t) :: time
  !
  if (cx%next.le.1) then
    call class_message(seve%w,rname,'Current index is empty')
    return
  endif
  !
  ! (Re)allocations
  call class_variable_index_reallocate(presec,readsec,cx%next-1,error)
  if (error)  return
  !
  call init_obs(obs)
  !
  call gtime_init(time,cx%next-1,error)
  if (error)  return
  !
  ! (Re)fill
  do ient=1,cx%next-1
    call gtime_current(time)
    !
    ! Exit when asked by user
    call class_controlc(rname,error)
    if (error)  return
    !
    kx = cx%ind(ient)
    call rheader(set,obs,kx,user_function,error,readsec)
    if (error)  return
    !
    if (presec) then
      idxhead%presec(:,ient) = obs%head%presec(:)
    endif
    if (readsec(class_sec_gen_id)) then
      idxhead%gen%num(ient)     = obs%head%gen%num
      idxhead%gen%ver(ient)     = obs%head%gen%ver
      idxhead%gen%teles(ient)   = obs%head%gen%teles
      idxhead%gen%dobs(ient)    = obs%head%gen%dobs
      idxhead%gen%dred(ient)    = obs%head%gen%dred
      idxhead%gen%kind(ient)    = obs%head%gen%kind
      idxhead%gen%qual(ient)    = obs%head%gen%qual
      idxhead%gen%subscan(ient) = obs%head%gen%subscan
      idxhead%gen%scan(ient)    = obs%head%gen%scan
      idxhead%gen%ut(ient)      = obs%head%gen%ut
      idxhead%gen%st(ient)      = obs%head%gen%st
      idxhead%gen%az(ient)      = obs%head%gen%az
      idxhead%gen%el(ient)      = obs%head%gen%el
      idxhead%gen%tau(ient)     = obs%head%gen%tau
      idxhead%gen%tsys(ient)    = obs%head%gen%tsys
      idxhead%gen%time(ient)    = obs%head%gen%time
      idxhead%gen%parang(ient)  = obs%head%gen%parang
      idxhead%gen%xunit(ient)   = obs%head%gen%xunit
    endif
    if (readsec(class_sec_pos_id)) then
      idxhead%pos%sourc(ient)   = obs%head%pos%sourc
      idxhead%pos%system(ient)  = obs%head%pos%system
      idxhead%pos%equinox(ient) = obs%head%pos%equinox
      idxhead%pos%proj(ient)    = obs%head%pos%proj
      idxhead%pos%lam(ient)     = obs%head%pos%lam
      idxhead%pos%bet(ient)     = obs%head%pos%bet
      idxhead%pos%projang(ient) = obs%head%pos%projang
      idxhead%pos%lamof(ient)   = obs%head%pos%lamof
      idxhead%pos%betof(ient)   = obs%head%pos%betof
    endif
    if (readsec(class_sec_spe_id)) then
      idxhead%spe%line(ient)    = obs%head%spe%line
      idxhead%spe%restf(ient)   = obs%head%spe%restf
      idxhead%spe%nchan(ient)   = obs%head%spe%nchan
      idxhead%spe%rchan(ient)   = obs%head%spe%rchan
      idxhead%spe%fres(ient)    = obs%head%spe%fres
      idxhead%spe%vres(ient)    = obs%head%spe%vres
      idxhead%spe%voff(ient)    = obs%head%spe%voff
      idxhead%spe%bad(ient)     = obs%head%spe%bad
      idxhead%spe%image(ient)   = obs%head%spe%image
      idxhead%spe%vtype(ient)   = obs%head%spe%vtype
      idxhead%spe%vconv(ient)   = obs%head%spe%vconv
      idxhead%spe%vdire(ient)   = obs%head%spe%vdire
      idxhead%spe%doppler(ient) = obs%head%spe%doppler
    endif
    if (readsec(class_sec_res_id)) then
      idxhead%res%major(ient)  = obs%head%res%major
      idxhead%res%minor(ient)  = obs%head%res%minor
      idxhead%res%posang(ient) = obs%head%res%posang
    endif
    if (readsec(class_sec_bas_id)) then
      idxhead%bas%deg(ient)     = obs%head%bas%deg
      idxhead%bas%sigfi(ient)   = obs%head%bas%sigfi
      idxhead%bas%aire(ient)    = obs%head%bas%aire
      idxhead%bas%nwind(ient)   = obs%head%bas%nwind
      idxhead%bas%w1(:,ient)    = obs%head%bas%w1(:)
      idxhead%bas%w2(:,ient)    = obs%head%bas%w2(:)
      idxhead%bas%sinus(:,ient) = obs%head%bas%sinus(:)
    endif
    if (readsec(class_sec_his_id)) then
      idxhead%his%nseq(ient)    = obs%head%his%nseq
      idxhead%his%start(:,ient) = obs%head%his%start(:)
      idxhead%his%end(:,ient)   = obs%head%his%end(:)
    endif
    if (readsec(class_sec_plo_id)) then
      idxhead%plo%amin(ient) = obs%head%plo%amin
      idxhead%plo%amax(ient) = obs%head%plo%amax
      idxhead%plo%vmin(ient) = obs%head%plo%vmin
      idxhead%plo%vmax(ient) = obs%head%plo%vmax
    endif
    if (readsec(class_sec_swi_id)) then
      idxhead%swi%nphas(ient)    = obs%head%swi%nphas
      idxhead%swi%decal(:,ient)  = obs%head%swi%decal(:)
      idxhead%swi%duree(:,ient)  = obs%head%swi%duree(:)
      idxhead%swi%poids(:,ient)  = obs%head%swi%poids(:)
      idxhead%swi%swmod(ient)    = obs%head%swi%swmod
      idxhead%swi%ldecal(:,ient) = obs%head%swi%ldecal(:)
      idxhead%swi%bdecal(:,ient) = obs%head%swi%bdecal(:)
    endif
    if (readsec(class_sec_cal_id)) then
      idxhead%cal%beeff(ient)   = obs%head%cal%beeff
      idxhead%cal%foeff(ient)   = obs%head%cal%foeff
      idxhead%cal%gaini(ient)   = obs%head%cal%gaini
      idxhead%cal%h2omm(ient)   = obs%head%cal%h2omm
      idxhead%cal%pamb(ient)    = obs%head%cal%pamb
      idxhead%cal%tamb(ient)    = obs%head%cal%tamb
      idxhead%cal%tatms(ient)   = obs%head%cal%tatms
      idxhead%cal%tchop(ient)   = obs%head%cal%tchop
      idxhead%cal%tcold(ient)   = obs%head%cal%tcold
      idxhead%cal%taus(ient)    = obs%head%cal%taus
      idxhead%cal%taui(ient)    = obs%head%cal%taui
      idxhead%cal%tatmi(ient)   = obs%head%cal%tatmi
      idxhead%cal%trec(ient)    = obs%head%cal%trec
      idxhead%cal%cmode(ient)   = obs%head%cal%cmode
      idxhead%cal%atfac(ient)   = obs%head%cal%atfac
      idxhead%cal%alti(ient)    = obs%head%cal%alti
      idxhead%cal%count(:,ient) = obs%head%cal%count(:)
      idxhead%cal%lcalof(ient)  = obs%head%cal%lcalof
      idxhead%cal%bcalof(ient)  = obs%head%cal%bcalof
      idxhead%cal%geolong(ient) = obs%head%cal%geolong
      idxhead%cal%geolat(ient)  = obs%head%cal%geolat
    endif
    if (readsec(class_sec_sky_id)) then
      idxhead%sky%restf(ient)   = obs%head%sky%restf
      idxhead%sky%image(ient)   = obs%head%sky%image
      idxhead%sky%nsky(ient)    = obs%head%sky%nsky
      idxhead%sky%nchop(ient)   = obs%head%sky%nchop
      idxhead%sky%ncold(ient)   = obs%head%sky%ncold
      idxhead%sky%elev(:,ient)  = obs%head%sky%elev(:)
      idxhead%sky%emiss(:,ient) = obs%head%sky%emiss(:)
      idxhead%sky%chopp(:,ient) = obs%head%sky%chopp(:)
      idxhead%sky%cold(:,ient)  = obs%head%sky%cold(:)
    endif
    if (readsec(class_sec_gau_id)) then
      idxhead%gau%nline(ient)  = obs%head%gau%nline
      idxhead%gau%sigba(ient)  = obs%head%gau%sigba
      idxhead%gau%sigra(ient)  = obs%head%gau%sigra
      idxhead%gau%nfit(:,ient) = obs%head%gau%nfit(:)
      idxhead%gau%nerr(:,ient) = obs%head%gau%nerr(:)
    endif
    if (readsec(class_sec_she_id)) then
      idxhead%she%nline(ient)  = obs%head%she%nline
      idxhead%she%sigba(ient)  = obs%head%she%sigba
      idxhead%she%sigra(ient)  = obs%head%she%sigra
      idxhead%she%nfit(:,ient) = obs%head%she%nfit(:)
      idxhead%she%nerr(:,ient) = obs%head%she%nerr(:)
    endif
    if (readsec(class_sec_hfs_id)) then
      idxhead%hfs%nline(ient)  = obs%head%hfs%nline
      idxhead%hfs%sigba(ient)  = obs%head%hfs%sigba
      idxhead%hfs%sigra(ient)  = obs%head%hfs%sigra
      idxhead%hfs%nfit(:,ient) = obs%head%hfs%nfit(:)
      idxhead%hfs%nerr(:,ient) = obs%head%hfs%nerr(:)
    endif
    if (readsec(class_sec_abs_id)) then
      idxhead%abs%nline(ient)  = obs%head%abs%nline
      idxhead%abs%sigba(ient)  = obs%head%abs%sigba
      idxhead%abs%sigra(ient)  = obs%head%abs%sigra
      idxhead%abs%nfit(:,ient) = obs%head%abs%nfit(:)
      idxhead%abs%nerr(:,ient) = obs%head%abs%nerr(:)
    endif
    if (readsec(class_sec_dri_id)) then
      idxhead%dri%freq(ient)  = obs%head%dri%freq
      idxhead%dri%width(ient) = obs%head%dri%width
      idxhead%dri%npoin(ient) = obs%head%dri%npoin
      idxhead%dri%rpoin(ient) = obs%head%dri%rpoin
      idxhead%dri%tref(ient)  = obs%head%dri%tref
      idxhead%dri%aref(ient)  = obs%head%dri%aref
      idxhead%dri%apos(ient)  = obs%head%dri%apos
      idxhead%dri%tres(ient)  = obs%head%dri%tres
      idxhead%dri%ares(ient)  = obs%head%dri%ares
      idxhead%dri%bad(ient)   = obs%head%dri%bad
      idxhead%dri%ctype(ient) = obs%head%dri%ctype
      idxhead%dri%cimag(ient) = obs%head%dri%cimag
      idxhead%dri%colla(ient) = obs%head%dri%colla
      idxhead%dri%colle(ient) = obs%head%dri%colle
    endif
    if (readsec(class_sec_bea_id)) then
      idxhead%bea%cazim(ient) = obs%head%bea%cazim
      idxhead%bea%celev(ient) = obs%head%bea%celev
      idxhead%bea%space(ient) = obs%head%bea%space
      idxhead%bea%bpos(ient)  = obs%head%bea%bpos
      idxhead%bea%btype(ient) = obs%head%bea%btype
    endif
    if (readsec(class_sec_poi_id)) then
      idxhead%poi%nline(ient)  = obs%head%poi%nline
      idxhead%poi%sigba(ient)  = obs%head%poi%sigba
      idxhead%poi%sigra(ient)  = obs%head%poi%sigra
      idxhead%poi%nfit(:,ient) = obs%head%poi%nfit(:)
      idxhead%poi%nerr(:,ient) = obs%head%poi%nerr(:)
    endif
    if (readsec(class_sec_com_id)) then
      idxhead%com%ltext(ient) = obs%head%com%ltext
      idxhead%com%ctext(ient) = obs%head%com%ctext
    endif
    if (readsec(class_sec_her_id)) then
      idxhead%her%obsid(ient)      = obs%head%her%obsid
      idxhead%her%instrument(ient) = obs%head%her%instrument
      idxhead%her%proposal(ient)   = obs%head%her%proposal
      idxhead%her%aor(ient)        = obs%head%her%aor
      idxhead%her%operday(ient)    = obs%head%her%operday
      idxhead%her%dateobs(ient)    = obs%head%her%dateobs
      idxhead%her%dateend(ient)    = obs%head%her%dateend
      idxhead%her%obsmode(ient)    = obs%head%her%obsmode
      idxhead%her%vinfo(ient)      = obs%head%her%vinfo
      idxhead%her%zinfo(ient)      = obs%head%her%zinfo
      idxhead%her%posangle(ient)   = obs%head%her%posangle
      idxhead%her%reflam(ient)     = obs%head%her%reflam
      idxhead%her%refbet(ient)     = obs%head%her%refbet
      idxhead%her%hifavelam(ient)  = obs%head%her%hifavelam
      idxhead%her%hifavebet(ient)  = obs%head%her%hifavebet
      idxhead%her%etamb(ient)      = obs%head%her%etamb
      idxhead%her%etal(ient)       = obs%head%her%etal
      idxhead%her%etaa(ient)       = obs%head%her%etaa
      idxhead%her%hpbw(ient)       = obs%head%her%hpbw
      idxhead%her%tempscal(ient)   = obs%head%her%tempscal
      idxhead%her%lodopave(ient)   = obs%head%her%lodopave
      idxhead%her%gim0(ient)       = obs%head%her%gim0
      idxhead%her%gim1(ient)       = obs%head%her%gim1
      idxhead%her%gim2(ient)       = obs%head%her%gim2
      idxhead%her%gim3(ient)       = obs%head%her%gim3
      idxhead%her%mixercurh(ient)  = obs%head%her%mixercurh
      idxhead%her%mixercurv(ient)  = obs%head%her%mixercurv
      idxhead%her%datehcss(ient)   = obs%head%her%datehcss
      idxhead%her%hcssver(ient)    = obs%head%her%hcssver
      idxhead%her%calver(ient)     = obs%head%her%calver
      idxhead%her%level(ient)      = obs%head%her%level
    endif
    if (readsec(class_sec_user_id)) then
      call user_sec_varidx_fill(obs,ient,error)
      if (error)  exit
    endif
  enddo
  !
  call free_obs(obs)
  !
end subroutine class_variable_index_fill
!
subroutine class_variable_index_defvar(presec,readsec,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_variable_index_defvar
  use class_index
  use class_parameter
  use class_sicidx
  !---------------------------------------------------------------------
  ! @ private
  !  Create the sections in the IDX%HEAD% Sic structure
  !---------------------------------------------------------------------
  logical, intent(in)    :: presec              ! Enable the 'present sections' array?
  logical, intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be added
  logical, intent(inout) :: error               !
  ! Local
  character(len=10) :: struct
  integer(kind=index_length) :: dims(4)
  !
  if (.not.sic_varexist('IDX')) then
    call sic_defstructure('IDX',.true.,error)
    if (error)  return
  endif
  !
  struct = 'IDX%HEAD'
  if (.not.sic_varexist(struct)) then
    call sic_defstructure(struct,.true.,error)
    if (error)  return
  endif
  !
  ! Present sections
  if (presec) then
    dims(1) = mx_sec+1
    dims(2) = cx%next-1
    call sic_def_login(trim(struct)//'%PRESEC',idxhead%presec,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! General
  if (readsec(class_sec_gen_id)) then
    call sic_defstructure(trim(struct)//'%GEN',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_long (trim(struct)//'%GEN%NUM',    idxhead%gen%num,    1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%VER',    idxhead%gen%ver,    1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%GEN%TELES',  idxhead%gen%teles,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%DOBS',   idxhead%gen%dobs,   1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%DRED',   idxhead%gen%dred,   1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%KIND',   idxhead%gen%kind,   1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%QUAL',   idxhead%gen%qual,   1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%SUBSCAN',idxhead%gen%subscan,1,dims,.true.,error)
    call sic_def_long (trim(struct)//'%GEN%SCAN',   idxhead%gen%scan,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%GEN%UT',     idxhead%gen%ut,     1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%GEN%ST',     idxhead%gen%st,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%AZ',     idxhead%gen%az,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%EL',     idxhead%gen%el,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%TAU',    idxhead%gen%tau,    1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%TSYS',   idxhead%gen%tsys,   1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%TIME',   idxhead%gen%time,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%GEN%PARANG', idxhead%gen%parang, 1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%XUNIT',  idxhead%gen%xunit,  1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Position
  if (readsec(class_sec_pos_id)) then
    call sic_defstructure(trim(struct)//'%POS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_charn(trim(struct)//'%POS%SOURC',  idxhead%pos%sourc,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%POS%SYSTEM', idxhead%pos%system, 1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%POS%EQUINOX',idxhead%pos%equinox,1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%POS%PROJ',   idxhead%pos%proj,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%POS%LAM',    idxhead%pos%lam,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%POS%BET',    idxhead%pos%bet,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%POS%PROJANG',idxhead%pos%projang,1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%POS%LAMOF',  idxhead%pos%lamof,  1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%POS%BETOF',  idxhead%pos%betof,  1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Spectro
  if (readsec(class_sec_spe_id)) then
    call sic_defstructure(trim(struct)//'%SPE',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_charn(trim(struct)//'%SPE%LINE',   idxhead%spe%line,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%RESTF',  idxhead%spe%restf,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%SPE%NCHAN',  idxhead%spe%nchan,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%RCHAN',  idxhead%spe%rchan,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%FRES',   idxhead%spe%fres,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%VRES',   idxhead%spe%vres,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%VOFF',   idxhead%spe%voff,   1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%SPE%BAD',    idxhead%spe%bad,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%IMAGE',  idxhead%spe%image,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%SPE%VTYPE',  idxhead%spe%vtype,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%SPE%VCONV',  idxhead%spe%vconv,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%SPE%VDIRE',  idxhead%spe%vdire,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%DOPPLER',idxhead%spe%doppler,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Beam
  if (readsec(class_sec_res_id)) then
    call sic_defstructure(trim(struct)//'%RES',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_real(trim(struct)//'%RES%MAJOR', idxhead%res%major, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%RES%MINOR', idxhead%res%minor, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%RES%POSANG',idxhead%res%posang,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Base
  if (readsec(class_sec_bas_id)) then
    call sic_defstructure(trim(struct)//'%BAS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%BAS%DEG',  idxhead%bas%deg,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BAS%SIGFI',idxhead%bas%sigfi,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BAS%AIRE', idxhead%bas%aire, 1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%BAS%NWIND',idxhead%bas%nwind,1,dims,.true.,error)
    dims(1) = mwind
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%BAS%W1',   idxhead%bas%w1,   2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BAS%W2',   idxhead%bas%w2,   2,dims,.true.,error)
    dims(1) = 3
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%BAS%SINUS',idxhead%bas%sinus,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! History
  if (readsec(class_sec_his_id)) then
    call sic_defstructure(trim(struct)//'%HIS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%HIS%NSEQ', idxhead%his%nseq, 1,dims,.true.,error)
    dims(1) = mseq
    dims(2) = cx%next-1
    call sic_def_inte(trim(struct)//'%HIS%START',idxhead%his%start,2,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%HIS%END',  idxhead%his%end,  2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Plot
  if (readsec(class_sec_plo_id)) then
    call sic_defstructure(trim(struct)//'%PLO',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_real(trim(struct)//'%PLO%AMIN',idxhead%plo%amin,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%PLO%AMAX',idxhead%plo%amax,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%PLO%VMIN',idxhead%plo%vmin,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%PLO%VMAX',idxhead%plo%vmax,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Switching
  if (readsec(class_sec_swi_id)) then
    call sic_defstructure(trim(struct)//'%FSW',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%FSW%NPHAS',idxhead%swi%nphas,1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%FSW%SWMOD',idxhead%swi%swmod,1,dims,.true.,error)
    dims(1) = mxphas
    dims(2) = cx%next-1
    call sic_def_dble(trim(struct)//'%FSW%DECAL', idxhead%swi%decal, 2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%FSW%DUREE', idxhead%swi%duree, 2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%FSW%POIDS', idxhead%swi%poids, 2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%FSW%LDECAL',idxhead%swi%ldecal,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%FSW%BDECAL',idxhead%swi%bdecal,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Calibration
  if (readsec(class_sec_cal_id)) then
    call sic_defstructure(trim(struct)//'%CAL',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_real(trim(struct)//'%CAL%BEEFF',  idxhead%cal%beeff,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%FOEFF',  idxhead%cal%foeff,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%GAINI',  idxhead%cal%gaini,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%H2OMM',  idxhead%cal%h2omm,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%PAMB',   idxhead%cal%pamb,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TAMB',   idxhead%cal%tamb,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TATMS',  idxhead%cal%tatms,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TCHOP',  idxhead%cal%tchop,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TCOLD',  idxhead%cal%tcold,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TAUS',   idxhead%cal%taus,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TAUI',   idxhead%cal%taui,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TATMI',  idxhead%cal%tatmi,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TREC',   idxhead%cal%trec,   1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%CAL%CMODE',  idxhead%cal%cmode,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%ATFAC',  idxhead%cal%atfac,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%ALTI',   idxhead%cal%alti,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%LCALOF', idxhead%cal%lcalof, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%BCALOF', idxhead%cal%bcalof, 1,dims,.true.,error)
    call sic_def_dble(trim(struct)//'%CAL%GEOLONG',idxhead%cal%geolong,1,dims,.true.,error)
    call sic_def_dble(trim(struct)//'%CAL%GEOLAT', idxhead%cal%geolat, 1,dims,.true.,error)
    dims(1) = 3
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%CAL%COUNT',idxhead%cal%count,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Skydip
  if (readsec(class_sec_sky_id)) then
    call sic_defstructure(trim(struct)//'%SKY',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_dble(trim(struct)//'%SKY%SREST',idxhead%sky%restf,1,dims,.true.,error)
    call sic_def_dble(trim(struct)//'%SKY%SIMAG',idxhead%sky%image,1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%SKY%NSKY', idxhead%sky%nsky, 1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%SKY%NCHOP',idxhead%sky%nchop,1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%SKY%NCOLD',idxhead%sky%ncold,1,dims,.true.,error)
    dims(1) = msky
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%SKY%ELEV', idxhead%sky%elev, 2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SKY%EMISS',idxhead%sky%emiss,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SKY%CHOPP',idxhead%sky%chopp,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SKY%COLD', idxhead%sky%cold, 2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Gauss
  if (readsec(class_sec_gau_id)) then
    call sic_defstructure(trim(struct)//'%GAU',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%GAU%NLINE',   idxhead%gau%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%GAU%RMS_BASE',idxhead%gau%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%GAU%RMS_LINE',idxhead%gau%sigra,1,dims,.true.,error)
    dims(1) = mgausfit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%GAU%RESULT',idxhead%gau%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%GAU%ERROR', idxhead%gau%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Shell
  if (readsec(class_sec_she_id)) then
    call sic_defstructure(trim(struct)//'%SHE',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%SHE%NLINE',   idxhead%she%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SHE%RMS_BASE',idxhead%she%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SHE%RMS_LINE',idxhead%she%sigra,1,dims,.true.,error)
    dims(1) = mshellfit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%SHE%RESULT',idxhead%she%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SHE%ERROR', idxhead%she%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! HFS
  if (readsec(class_sec_hfs_id)) then
    call sic_defstructure(trim(struct)//'%HFS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%HFS%NLINE',   idxhead%hfs%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%HFS%RMS_BASE',idxhead%hfs%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%HFS%RMS_LINE',idxhead%hfs%sigra,1,dims,.true.,error)
    dims(1) = mhfsfit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%HFS%RESULT',idxhead%hfs%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%HFS%ERROR', idxhead%hfs%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Absorption
  if (readsec(class_sec_abs_id)) then
    call sic_defstructure(trim(struct)//'%ABS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%ABS%NLINE',   idxhead%abs%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%ABS%RMS_BASE',idxhead%abs%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%ABS%RMS_LINE',idxhead%abs%sigra,1,dims,.true.,error)
    dims(1) = mabsfit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%ABS%RESULT',idxhead%abs%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%ABS%ERROR', idxhead%abs%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Drift
  if (readsec(class_sec_dri_id)) then
    call sic_defstructure(trim(struct)//'%DRI',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_dble(trim(struct)//'%DRI%FREQ', idxhead%dri%freq, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%WIDTH',idxhead%dri%width,1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%DRI%NPOIN',idxhead%dri%npoin,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%RPOIN',idxhead%dri%rpoin,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%TREF', idxhead%dri%tref, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%AREF', idxhead%dri%aref, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%APOS', idxhead%dri%apos, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%TRES', idxhead%dri%tres, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%ARES', idxhead%dri%ares, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%CBAD', idxhead%dri%bad,  1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%DRI%CTYPE',idxhead%dri%ctype,1,dims,.true.,error)
    call sic_def_dble(trim(struct)//'%DRI%CIMAG',idxhead%dri%cimag,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%COLLA',idxhead%dri%colla,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%COLLE',idxhead%dri%colle,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Beam
  if (readsec(class_sec_bea_id)) then
    call sic_defstructure(trim(struct)//'%BEA',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_real(trim(struct)//'%BEA%CAZIM',idxhead%bea%cazim,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BEA%CELEV',idxhead%bea%celev,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BEA%SPACE',idxhead%bea%space,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BEA%BPOS', idxhead%bea%bpos, 1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%BEA%BTYPE',idxhead%bea%btype,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Continuum
  if (readsec(class_sec_poi_id)) then
    call sic_defstructure(trim(struct)//'%POI',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%POI%LCONT',idxhead%poi%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%POI%BCONT',idxhead%poi%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%POI%RCONT',idxhead%poi%sigra,1,dims,.true.,error)
    dims(1) = mpoifit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%POI%NCONT',idxhead%poi%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%POI%ECONT',idxhead%poi%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Herschel
  if (readsec(class_sec_her_id)) then
    call sic_defstructure(trim(struct)//'%HER',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_long (trim(struct)//'%HER%OBSID',     idxhead%her%obsid,     1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%INSTRUMENT',idxhead%her%instrument,1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%PROPOSAL',  idxhead%her%proposal,  1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%AOR',       idxhead%her%aor,       1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%HER%OPERDAY',   idxhead%her%operday,   1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%DATEOBS',   idxhead%her%dateobs,   1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%DATEEND',   idxhead%her%dateend,   1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%OBSMODE',   idxhead%her%obsmode,   1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%VINFO',     idxhead%her%vinfo,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%ZINFO',     idxhead%her%zinfo,     1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%POSANGLE',  idxhead%her%posangle,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%REFLAM',    idxhead%her%reflam,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%REFBET',    idxhead%her%refbet,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%HIFAVELAM', idxhead%her%hifavelam, 1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%HIFAVEBET', idxhead%her%hifavebet, 1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%ETAMB',     idxhead%her%etamb,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%ETAL',      idxhead%her%etal,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%ETAA',      idxhead%her%etaa,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%HPBW',      idxhead%her%hpbw,      1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%TEMPSCAL',  idxhead%her%tempscal,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%LODOPAVE',  idxhead%her%lodopave,  1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%GIM0',      idxhead%her%gim0,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%GIM1',      idxhead%her%gim1,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%GIM2',      idxhead%her%gim2,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%GIM3',      idxhead%her%gim3,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%MIXERCURH', idxhead%her%mixercurh, 1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%MIXERCURV', idxhead%her%mixercurv, 1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%DATEHCSS',  idxhead%her%datehcss,  1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%HCSSVER',   idxhead%her%hcssver,   1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%CALVER',    idxhead%her%calver,    1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%LEVEL',     idxhead%her%level,     1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Comment
  if (readsec(class_sec_com_id)) then
    call sic_defstructure(trim(struct)//'%COM',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte (trim(struct)//'%COM%LTEXT',idxhead%com%ltext,1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%COM%CTEXT',idxhead%com%ctext,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! User section
  if (readsec(class_sec_user_id)) then
    call user_sec_varidx_defvar(error)
    if (error)  return
  endif
  !
end subroutine class_variable_index_defvar
!
subroutine class_variable_index_reallocate(presec,readsec,nent,error)
  use classcore_dependencies_interfaces
  use class_parameter
  use class_sicidx
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Reallocate (if needed) the IDX support arrays, section by section.
  !  nent <= 0 means deallocate only.
  !---------------------------------------------------------------------
  logical,         intent(in)    :: presec              ! Enable the 'present sections' array?
  logical,         intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be reallocated
  integer(kind=8), intent(in)    :: nent                ! Size of reallocation
  logical,         intent(inout) :: error               ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='REALLOCATE'
  logical :: realloc
  integer(kind=4) :: ier
  !
  ! Present sections
  if (presec) then
    if (allocated(idxhead%presec)) then
      realloc = ubound(idxhead%presec,2).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%presec)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc) then
      allocate(idxhead%presec(-mx_sec:0,nent),stat=ier)
      if (failed_allocate(rname,'IDX%PRESEC arrays',ier,error))  return
    endif
  endif
  !
  ! General
  if (readsec(class_sec_gen_id)) then
    if (allocated(idxhead%gen%num)) then
      realloc = size(idxhead%gen%num).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%gen%num, idxhead%gen%ver,    idxhead%gen%teles)
        deallocate(idxhead%gen%dobs,idxhead%gen%dred,   idxhead%gen%kind )
        deallocate(idxhead%gen%qual,idxhead%gen%subscan,idxhead%gen%scan )
        deallocate(idxhead%gen%ut,  idxhead%gen%st,     idxhead%gen%az   )
        deallocate(idxhead%gen%el,  idxhead%gen%tau,    idxhead%gen%tsys )
        deallocate(idxhead%gen%time,idxhead%gen%parang, idxhead%gen%xunit)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc) then
      allocate(idxhead%gen%num(nent),   idxhead%gen%ver(nent),    stat=ier)
      allocate(idxhead%gen%teles(nent), idxhead%gen%dobs(nent),   stat=ier)
      allocate(idxhead%gen%dred(nent),  idxhead%gen%kind(nent),   stat=ier)
      allocate(idxhead%gen%qual(nent),  idxhead%gen%subscan(nent),stat=ier)
      allocate(idxhead%gen%scan(nent),  idxhead%gen%ut(nent),     stat=ier)
      allocate(idxhead%gen%st(nent),    idxhead%gen%az(nent),     stat=ier)
      allocate(idxhead%gen%el(nent),    idxhead%gen%tau(nent),    stat=ier)
      allocate(idxhead%gen%tsys(nent),  idxhead%gen%time(nent),   stat=ier)
      allocate(idxhead%gen%parang(nent),idxhead%gen%xunit(nent),  stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%GEN arrays',ier,error))  return
    endif
  endif
  !
  ! Position
  if (readsec(class_sec_pos_id)) then
    if (allocated(idxhead%pos%sourc)) then
      realloc = size(idxhead%pos%sourc).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%pos%sourc,  idxhead%pos%system,idxhead%pos%equinox)
        deallocate(idxhead%pos%proj,   idxhead%pos%lam,   idxhead%pos%bet    )
        deallocate(idxhead%pos%projang,idxhead%pos%lamof, idxhead%pos%betof  )
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%pos%sourc(nent),  idxhead%pos%system(nent),stat=ier)
      allocate(idxhead%pos%equinox(nent),idxhead%pos%proj(nent),  stat=ier)
      allocate(idxhead%pos%lam(nent),    idxhead%pos%bet(nent),   stat=ier)
      allocate(idxhead%pos%projang(nent),idxhead%pos%lamof(nent), stat=ier)
      allocate(idxhead%pos%betof(nent),                           stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%POS arrays',ier,error))  return
    endif
  endif
  !
  ! Spectro
  if (readsec(class_sec_spe_id)) then
    if (allocated(idxhead%spe%line)) then
      realloc = size(idxhead%spe%line).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%spe%line, idxhead%spe%restf,idxhead%spe%nchan)
        deallocate(idxhead%spe%rchan,idxhead%spe%fres, idxhead%spe%vres)
        deallocate(idxhead%spe%voff, idxhead%spe%bad,  idxhead%spe%image)
        deallocate(idxhead%spe%vtype,idxhead%spe%vconv,idxhead%spe%vdire)
        deallocate(idxhead%spe%doppler)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%spe%line(nent), idxhead%spe%restf(nent),stat=ier)
      allocate(idxhead%spe%nchan(nent),idxhead%spe%rchan(nent),stat=ier)
      allocate(idxhead%spe%fres(nent), idxhead%spe%vres(nent), stat=ier)
      allocate(idxhead%spe%voff(nent), idxhead%spe%bad(nent),  stat=ier)
      allocate(idxhead%spe%image(nent),idxhead%spe%vtype(nent),stat=ier)
      allocate(idxhead%spe%vconv(nent),idxhead%spe%vdire(nent),stat=ier)
      allocate(idxhead%spe%doppler(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%SPE arrays',ier,error))  return
    endif
  endif
  !
  ! Resolution
  if (readsec(class_sec_res_id)) then
    if (allocated(idxhead%res%major)) then
      realloc = size(idxhead%res%major).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%res%major,idxhead%res%minor,idxhead%res%posang)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%res%major(nent),idxhead%res%minor(nent),stat=ier)
      allocate(idxhead%res%posang(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%RES arrays',ier,error))  return
    endif
  endif
  !
  ! Base
  if (readsec(class_sec_bas_id)) then
    if (allocated(idxhead%bas%deg)) then
      realloc = size(idxhead%bas%deg).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%bas%deg,  idxhead%bas%sigfi,idxhead%bas%aire)
        deallocate(idxhead%bas%nwind,idxhead%bas%w1,   idxhead%bas%w2  )
        deallocate(idxhead%bas%sinus)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%bas%deg(nent),     idxhead%bas%sigfi(nent),   stat=ier)
      allocate(idxhead%bas%aire(nent),    idxhead%bas%nwind(nent),   stat=ier)
      allocate(idxhead%bas%w1(mwind,nent),idxhead%bas%w2(mwind,nent),stat=ier)
      allocate(idxhead%bas%sinus(3,nent), stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%BAS arrays',ier,error))  return
    endif
  endif
  !
  ! History
  if (readsec(class_sec_his_id)) then
    if (allocated(idxhead%his%nseq)) then
      realloc = size(idxhead%his%nseq).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%his%nseq,idxhead%his%start,idxhead%his%end)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%his%nseq(nent),    idxhead%his%start(mseq,nent),stat=ier)
      allocate(idxhead%his%end(mseq,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%HIS arrays',ier,error))  return
    endif
  endif
  !
  ! Plot
  if (readsec(class_sec_plo_id)) then
    if (allocated(idxhead%plo%amin)) then
      realloc = size(idxhead%plo%amin).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%plo%amin,idxhead%plo%amax,idxhead%plo%vmin)
        deallocate(idxhead%plo%vmax)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%plo%amin(nent),idxhead%plo%amax(nent),stat=ier)
      allocate(idxhead%plo%vmin(nent),idxhead%plo%vmax(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%PLO arrays',ier,error))  return
    endif
  endif
  !
  ! Switching
  if (readsec(class_sec_swi_id)) then
    if (allocated(idxhead%swi%nphas)) then
      realloc = size(idxhead%swi%nphas).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%swi%nphas,idxhead%swi%decal,idxhead%swi%duree)
        deallocate(idxhead%swi%poids,idxhead%swi%swmod,idxhead%swi%ldecal)
        deallocate(idxhead%swi%bdecal)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%swi%nphas(nent),       idxhead%swi%decal(mxphas,nent), stat=ier)
      allocate(idxhead%swi%duree(mxphas,nent),idxhead%swi%poids(mxphas,nent), stat=ier)
      allocate(idxhead%swi%swmod(nent),       idxhead%swi%ldecal(mxphas,nent),stat=ier)
      allocate(idxhead%swi%bdecal(mxphas,nent),                               stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%FSW arrays',ier,error))  return
    endif
  endif
  !
  ! Calibration
  if (readsec(class_sec_cal_id)) then
    if (allocated(idxhead%cal%beeff)) then
      realloc = size(idxhead%cal%beeff).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%cal%beeff, idxhead%cal%foeff,  idxhead%cal%gaini )
        deallocate(idxhead%cal%h2omm, idxhead%cal%pamb,   idxhead%cal%tamb  )
        deallocate(idxhead%cal%tatms, idxhead%cal%tchop,  idxhead%cal%tcold )
        deallocate(idxhead%cal%taus,  idxhead%cal%taui,   idxhead%cal%tatmi )
        deallocate(idxhead%cal%trec,  idxhead%cal%cmode,  idxhead%cal%atfac )
        deallocate(idxhead%cal%alti,  idxhead%cal%count,  idxhead%cal%lcalof)
        deallocate(idxhead%cal%bcalof,idxhead%cal%geolong,idxhead%cal%geolat)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%cal%beeff(nent),  idxhead%cal%foeff(nent), stat=ier)
      allocate(idxhead%cal%gaini(nent),  idxhead%cal%h2omm(nent), stat=ier)
      allocate(idxhead%cal%pamb(nent),   idxhead%cal%tamb(nent),  stat=ier)
      allocate(idxhead%cal%tatms(nent),  idxhead%cal%tchop(nent), stat=ier)
      allocate(idxhead%cal%tcold(nent),  idxhead%cal%taus(nent),  stat=ier)
      allocate(idxhead%cal%taui(nent),   idxhead%cal%tatmi(nent), stat=ier)
      allocate(idxhead%cal%trec(nent),   idxhead%cal%cmode(nent), stat=ier)
      allocate(idxhead%cal%atfac(nent),  idxhead%cal%alti(nent),  stat=ier)
      allocate(idxhead%cal%count(3,nent),                         stat=ier)
      allocate(idxhead%cal%lcalof(nent), idxhead%cal%bcalof(nent),stat=ier)
      allocate(idxhead%cal%geolong(nent),idxhead%cal%geolat(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%CAL arrays',ier,error))  return
    endif
  endif
  !
  ! Skydip
  if (readsec(class_sec_sky_id)) then
    if (allocated(idxhead%sky%restf)) then
      realloc = size(idxhead%sky%restf).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%sky%restf,idxhead%sky%image,idxhead%sky%nsky)
        deallocate(idxhead%sky%nchop,idxhead%sky%ncold,idxhead%sky%elev)
        deallocate(idxhead%sky%emiss,idxhead%sky%chopp,idxhead%sky%cold)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%sky%restf(nent),     idxhead%sky%image(nent),     stat=ier)
      allocate(idxhead%sky%nsky(nent),      idxhead%sky%nchop(nent),     stat=ier)
      allocate(idxhead%sky%ncold(nent),     idxhead%sky%elev(msky,nent), stat=ier)
      allocate(idxhead%sky%emiss(msky,nent),idxhead%sky%chopp(msky,nent),stat=ier)
      allocate(idxhead%sky%cold(msky,nent),                              stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%SKY arrays',ier,error))  return
    endif
  endif
  !
  ! Gauss
  if (readsec(class_sec_gau_id)) then
    if (allocated(idxhead%gau%nline)) then
      realloc = size(idxhead%gau%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%gau%nline,idxhead%gau%sigba,idxhead%gau%sigra)
        deallocate(idxhead%gau%nfit, idxhead%gau%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%gau%nline(nent),                                        stat=ier)
      allocate(idxhead%gau%sigba(nent),        idxhead%gau%sigra(nent),        stat=ier)
      allocate(idxhead%gau%nfit(mgausfit,nent),idxhead%gau%nerr(mgausfit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%GAU arrays',ier,error))  return
    endif
  endif
  !
  ! Shell
  if (readsec(class_sec_she_id)) then
    if (allocated(idxhead%she%nline)) then
      realloc = size(idxhead%she%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%she%nline,idxhead%she%sigba,idxhead%she%sigra)
        deallocate(idxhead%she%nfit, idxhead%she%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%she%nline(nent),                                          stat=ier)
      allocate(idxhead%she%sigba(nent),         idxhead%she%sigra(nent),         stat=ier)
      allocate(idxhead%she%nfit(mshellfit,nent),idxhead%she%nerr(mshellfit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%SHE arrays',ier,error))  return
    endif
  endif
  !
  ! HFS
  if (readsec(class_sec_hfs_id)) then
    if (allocated(idxhead%hfs%nline)) then
      realloc = size(idxhead%hfs%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%hfs%nline,idxhead%hfs%sigba,idxhead%hfs%sigra)
        deallocate(idxhead%hfs%nfit, idxhead%hfs%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%hfs%nline(nent),                                      stat=ier)
      allocate(idxhead%hfs%sigba(nent),       idxhead%hfs%sigra(nent),       stat=ier)
      allocate(idxhead%hfs%nfit(mhfsfit,nent),idxhead%hfs%nerr(mhfsfit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%HFS arrays',ier,error))  return
    endif
  endif
  !
  ! Absorption
  if (readsec(class_sec_abs_id)) then
    if (allocated(idxhead%abs%nline)) then
      realloc = size(idxhead%abs%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%abs%nline,idxhead%abs%sigba,idxhead%abs%sigra)
        deallocate(idxhead%abs%nfit, idxhead%abs%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%abs%nline(nent),                                      stat=ier)
      allocate(idxhead%abs%sigba(nent),       idxhead%abs%sigra(nent),       stat=ier)
      allocate(idxhead%abs%nfit(mabsfit,nent),idxhead%abs%nerr(mabsfit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%ABS arrays',ier,error))  return
    endif
  endif
  !
  ! Drift
  if (readsec(class_sec_dri_id)) then
    if (allocated(idxhead%dri%freq)) then
      realloc = size(idxhead%dri%freq).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%dri%freq, idxhead%dri%width,idxhead%dri%npoin)
        deallocate(idxhead%dri%rpoin,idxhead%dri%tref, idxhead%dri%aref )
        deallocate(idxhead%dri%apos, idxhead%dri%tres, idxhead%dri%ares )
        deallocate(idxhead%dri%bad,  idxhead%dri%ctype,idxhead%dri%cimag)
        deallocate(idxhead%dri%colla,idxhead%dri%colle)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%dri%freq(nent), idxhead%dri%width(nent),stat=ier)
      allocate(idxhead%dri%npoin(nent),idxhead%dri%rpoin(nent),stat=ier)
      allocate(idxhead%dri%tref(nent), idxhead%dri%aref(nent), stat=ier)
      allocate(idxhead%dri%apos(nent), idxhead%dri%tres(nent), stat=ier)
      allocate(idxhead%dri%ares(nent), idxhead%dri%bad(nent),  stat=ier)
      allocate(idxhead%dri%ctype(nent),idxhead%dri%cimag(nent),stat=ier)
      allocate(idxhead%dri%colla(nent),idxhead%dri%colle(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%DRI arrays',ier,error))  return
    endif
  endif
  !
  ! Resolution
  if (readsec(class_sec_bea_id)) then
    if (allocated(idxhead%bea%cazim)) then
      realloc = size(idxhead%bea%cazim).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%bea%cazim,idxhead%bea%celev,idxhead%bea%space)
        deallocate(idxhead%bea%bpos, idxhead%bea%btype)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%bea%cazim(nent),idxhead%bea%celev(nent),stat=ier)
      allocate(idxhead%bea%space(nent),idxhead%bea%bpos(nent), stat=ier)
      allocate(idxhead%bea%btype(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%BEA arrays',ier,error))  return
    endif
  endif
  !
  ! Continuum
  if (readsec(class_sec_poi_id)) then
    if (allocated(idxhead%poi%nline)) then
      realloc = size(idxhead%poi%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%poi%nline,idxhead%poi%sigba,idxhead%poi%sigra)
        deallocate(idxhead%poi%nfit, idxhead%poi%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%poi%nline(nent),                                      stat=ier)
      allocate(idxhead%poi%sigba(nent),       idxhead%poi%sigra(nent),       stat=ier)
      allocate(idxhead%poi%nfit(mpoifit,nent),idxhead%poi%nerr(mpoifit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%POI arrays',ier,error))  return
    endif
  endif
  !
  ! Herschel
  if (readsec(class_sec_her_id)) then
    if (allocated(idxhead%her%obsid)) then
      realloc = size(idxhead%her%obsid).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%her%obsid,   idxhead%her%instrument,idxhead%her%proposal)
        deallocate(idxhead%her%aor,     idxhead%her%operday,   idxhead%her%dateobs)
        deallocate(idxhead%her%dateend, idxhead%her%obsmode,   idxhead%her%vinfo)
        deallocate(idxhead%her%zinfo,   idxhead%her%posangle,  idxhead%her%reflam)
        deallocate(idxhead%her%refbet,  idxhead%her%hifavelam, idxhead%her%hifavebet)
        deallocate(idxhead%her%etamb,   idxhead%her%etal,      idxhead%her%etaa)
        deallocate(idxhead%her%hpbw,    idxhead%her%tempscal,  idxhead%her%lodopave)
        deallocate(idxhead%her%gim0,    idxhead%her%gim1,      idxhead%her%gim2)
        deallocate(idxhead%her%gim3,    idxhead%her%mixercurh, idxhead%her%mixercurv)
        deallocate(idxhead%her%datehcss,idxhead%her%hcssver,   idxhead%her%calver)
        deallocate(idxhead%her%level)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%her%obsid(nent),    idxhead%her%instrument(nent),stat=ier)
      allocate(idxhead%her%proposal(nent), idxhead%her%aor(nent),       stat=ier)
      allocate(idxhead%her%operday(nent),  idxhead%her%dateobs(nent),   stat=ier)
      allocate(idxhead%her%dateend(nent),  idxhead%her%obsmode(nent),   stat=ier)
      allocate(idxhead%her%vinfo(nent),    idxhead%her%zinfo(nent),     stat=ier)
      allocate(idxhead%her%posangle(nent), idxhead%her%reflam(nent),    stat=ier)
      allocate(idxhead%her%refbet(nent),   idxhead%her%hifavelam(nent), stat=ier)
      allocate(idxhead%her%hifavebet(nent),idxhead%her%etamb(nent),     stat=ier)
      allocate(idxhead%her%etal(nent),     idxhead%her%etaa(nent),      stat=ier)
      allocate(idxhead%her%hpbw(nent),     idxhead%her%tempscal(nent),  stat=ier)
      allocate(idxhead%her%lodopave(nent), idxhead%her%gim0(nent),      stat=ier)
      allocate(idxhead%her%gim1(nent),     idxhead%her%gim2(nent),      stat=ier)
      allocate(idxhead%her%gim3(nent),     idxhead%her%mixercurh(nent), stat=ier)
      allocate(idxhead%her%mixercurv(nent),idxhead%her%datehcss(nent),  stat=ier)
      allocate(idxhead%her%hcssver(nent),  idxhead%her%calver(nent),    stat=ier)
      allocate(idxhead%her%level(nent),                                 stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%HER arrays',ier,error))  return
    endif
  endif
  !
  ! Comment
  if (readsec(class_sec_com_id)) then
    if (allocated(idxhead%com%ltext)) then
      realloc = size(idxhead%com%ltext).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%com%ltext,idxhead%com%ctext)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%com%ltext(nent),idxhead%com%ctext(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%COM arrays',ier,error))  return
    endif
  endif
  !
  ! User section
  if (readsec(class_sec_user_id)) then
    call user_sec_varidx_realloc(nent,error)
    if (error)  return
  endif
  !
end subroutine class_variable_index_reallocate

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_moments_cube_types
  use cube_types
  use cubetools_parameters
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: moments_cubeprodset_t
  public :: moments_cube_t,moments_cubeset_t
  private
  !
  type moments_cubeprod_t
     type(cube_prod_t), pointer :: sig
     type(cube_prod_t), pointer :: noi
     type(cube_prod_t), pointer :: snr
  contains
     procedure, private :: register => moments_cubeprod_register
  end type moments_cubeprod_t
  !
  type moments_cubeprodset_t
     type(moments_cubeprod_t) :: peak ! [     K] Peak intensity
     type(moments_cubeprod_t) :: area ! [*.km/s] Integrated intensity
     type(moments_cubeprod_t) :: velo ! [  km/s] Velocity at peak intensity
     type(moments_cubeprod_t) :: cent ! [  km/s] Centroid velocity
     type(moments_cubeprod_t) :: fwhm ! [  km/s] Full Width at Half Maximum
     type(moments_cubeprod_t) :: eqwd ! [  km/s] area over peak
  contains
     procedure, public :: register => moments_cubeprodset_register
  end type moments_cubeprodset_t
  !
  type moments_cube_t
     type(cube_t), pointer :: sig
     type(cube_t), pointer :: noi
     type(cube_t), pointer :: snr
   contains
     procedure, private :: header => cubemain_moments_cube_header_all
  end type moments_cube_t
  !
  type moments_cubeset_t
     type(moments_cube_t) :: peak ! [     K] Peak intensity
     type(moments_cube_t) :: area ! [*.km/s] Integrated intensity
     type(moments_cube_t) :: velo ! [  km/s] Velocity at peak intensity
     type(moments_cube_t) :: cent ! [  km/s] Centroid velocity
     type(moments_cube_t) :: fwhm ! [  km/s] Full Width at Half Maximum
     type(moments_cube_t) :: eqwd ! [  km/s] area over peak
   contains
     procedure, public :: header => cubemain_moments_cubeset_header
  end type moments_cubeset_t
  !
contains
  !
  subroutine  moments_cubeprodset_register(cubeprodset,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(moments_cubeprodset_t), intent(in)    :: cubeprodset
    logical,                      intent(inout) :: error
    !
    call cubeprodset%peak%register('PEAKB','Peak brightness',&
         [flag_peak,flag_brightness],error)
    if (error) return
    call cubeprodset%velo%register('PEAKV','Peak velocity',&
         [flag_peak,flag_velocity],error)
    if (error) return
    call cubeprodset%area%register('AREA','Area',&
         [flag_area],error)
    if (error) return
    call cubeprodset%cent%register('CVELO','Centroid velocity',&
         [flag_centroid,flag_velocity],error)
    if (error) return
    call cubeprodset%fwhm%register('FWHM','FWHM',&
         [flag_fwhm,flag_width],error)
    if (error) return
    call cubeprodset%eqwd%register('EQWIDTH','Equivalent width',&
         [flag_equivalent,flag_width],error)
    if (error) return
  end subroutine moments_cubeprodset_register
  !
  subroutine moments_cubeprod_register(moments,name,hlp,flag_momkind,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(moments_cubeprod_t), intent(in)    :: moments
    character(len=*),          intent(in)    :: name
    character(len=*),          intent(in)    :: hlp
    type(flag_t),              intent(in)    :: flag_momkind(:)
    logical,                   intent(inout) :: error
    !
    type(cube_prod_t) :: oucube
    !
    call oucube%register(&
         name//'SIG',&
         hlp//' signal',&
         strg_emp,&
         [flag_moment,flag_momkind(:),flag_signal],&
         moments%sig,&
         error)
    if (error) return
    call oucube%register(&
         name//'NOI',&
         hlp//' noise',&
         strg_emp,&
         [flag_moment,flag_momkind(:),flag_noise],&
         moments%noi,&
         error)
    if (error) return
    call oucube%register(&
         name//'SNR',&
         hlp//' SNR',&
         strg_emp,&
         [flag_moment,flag_momkind(:),flag_snr],&
         moments%snr,&
         error)
    if (error) return
  end subroutine moments_cubeprod_register
  !
  subroutine cubemain_moments_cubeset_header(cubeset,prodset,cube,nw,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_cubeset_t),    intent(inout) :: cubeset
    type(moments_cubeprodset_t), intent(in)    :: prodset
    type(cube_t), pointer,       intent(in)    :: cube
    integer(kind=wind_k),        intent(in)    :: nw
    logical,                     intent(inout) :: error
    !
    character(len=unit_l) :: unit
    character(len=*), parameter :: rname='MOMENTS>CUBESET>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    unit = cube%head%arr%unit 
    call cubeset%peak%header(prodset%peak,unit,nw,cube,error)
    if (error) return
    call cubeset%velo%header(prodset%velo,'km/s',nw,cube,error)
    if (error) return
    call cubeset%area%header(prodset%area,trim(unit)//'.km/s',nw,cube,error)
    if (error) return
    call cubeset%cent%header(prodset%cent,'km/s',nw,cube,error)
    if (error) return
    call cubeset%fwhm%header(prodset%fwhm,'km/s',nw,cube,error)
    if (error) return
    call cubeset%eqwd%header(prodset%eqwd,'km/s',nw,cube,error)
    if (error) return
  end subroutine cubemain_moments_cubeset_header
  !
  subroutine cubemain_moments_cube_header_all(moments,momprod,unit,nw,cube,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_cube_t),    intent(inout) :: moments
    type(moments_cubeprod_t), intent(in)    :: momprod
    character(len=*),         intent(in)    :: unit
    integer(kind=wind_k),     intent(in)    :: nw
    type(cube_t), pointer,    intent(in)    :: cube
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>CUBE>HEADER>ALL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubemain_moments_cube_header_one(moments%sig,momprod%sig,&
         unit,nw,cube,error)
    if (error) return
    call cubemain_moments_cube_header_one(moments%noi,momprod%noi,&
         unit,nw,cube,error)
    if (error) return
    call cubemain_moments_cube_header_one(moments%snr,momprod%snr,&
         '---',nw,cube,error)
    if (error) return
  end subroutine cubemain_moments_cube_header_all
  !
  subroutine cubemain_moments_cube_header_one(ou,cubeprod,unit,nw,in,error)
    use cubeadm_clone
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: ou
    type(cube_prod_t),     intent(in)    :: cubeprod
    character(len=*),      intent(in)    :: unit
    integer(kind=wind_k),  intent(in)    :: nw
    type(cube_t), pointer, intent(in)    :: in
    logical,               intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='MOMENTS>CUBE>HEADER>ONE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(cubeprod,in,ou,error)
    if (error) return
    call cubetools_header_put_array_unit(unit,ou%head,error)
    if (error) return
    call cubetools_header_get_axis_head_c(ou%head,axis,error)
    if (error) return
    axis%n = nw
    axis%ref = 1d0
    axis%val = 0d0
    call cubetools_header_update_axset_c(axis,ou%head,error)
    if (error) return
  end subroutine cubemain_moments_cube_header_one  
end module cubemain_moments_cube_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_moments_spec_types
  use cubetools_parameters
  use cubemain_messaging
  use cubemain_spectrum_real
  use cubemain_spectrum_moment_tool
  !
  public :: moments_spec_t
  private
  !
  type moments_spec_t
     type(spectrum_t) :: sig
     type(spectrum_t) :: noi
     type(spectrum_t) :: snr
   contains
     procedure, public :: reallocate => cubemain_moments_spec_reallocate
     procedure, public :: get        => cubemain_moments_spec_get
     procedure, public :: put        => cubemain_moments_spec_put
  end type moments_spec_t
  !
contains
  !
  subroutine cubemain_moments_spec_reallocate(spec,kind,nw,iterator,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_spec_t),    intent(inout) :: spec
    character(len=*),         intent(in)    :: kind
    integer(kind=wind_k),     intent(in)    :: nw
    type(cubeadm_iterator_t), intent(in)    :: iterator
    logical,                  intent(inout) :: error
    !
    integer(kind=chan_k) :: mw
    character(len=*), parameter :: rname='MOMENTS>SPEC>REALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    mw = int(nw,kind=chan_k)
    call spec%sig%reallocate(kind//'-sig',mw,iterator,error)
    if (error) return
    call spec%noi%reallocate(kind//'-noi',mw,iterator,error)
    if (error) return
    call spec%snr%reallocate(kind//'-snr',mw,iterator,error)
    if (error) return
  end subroutine cubemain_moments_spec_reallocate
  !
  subroutine cubemain_moments_spec_get(spec,iw,val,error)
    use cubemain_spectrum_moment_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_spec_t),    intent(inout) :: spec
    integer(kind=wind_k),     intent(in)    :: iw
    class(spectrum_moment_t), intent(in)    :: val
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>SPEC>GET'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    spec%sig%t(iw) = val%sig
    spec%noi%t(iw) = val%noi
    spec%snr%t(iw) = val%snr
  end subroutine cubemain_moments_spec_get
  !
  subroutine cubemain_moments_spec_put(spec,cube,ie,error)
    use cubemain_moments_cube_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_spec_t), intent(in)    :: spec
    type(moments_cube_t),  intent(inout) :: cube
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>SPEC>PUT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%sig%put(cube%sig,ie,error)
    if (error) return
    call spec%noi%put(cube%noi,ie,error)
    if (error) return
    call spec%snr%put(cube%snr,ie,error)
    if (error) return
  end subroutine cubemain_moments_spec_put
end module cubemain_moments_spec_types
!
module cubemain_moments_specset_types
  use cubetools_parameters
  use cubemain_messaging
  use cubemain_moments_spec_types
  !
  public :: moments_specset_t
  private
  !
  type moments_specset_t
     type(moments_spec_t) :: peak ! [     *] Peak intensity
     type(moments_spec_t) :: velo ! [  km/s] Velocity at peak intensity
     type(moments_spec_t) :: area ! [*.km/s] Integrated intensity
     type(moments_spec_t) :: cent ! [  km/s] Centroid velocity
     type(moments_spec_t) :: fwhm ! [  km/s] Full Width at Half Maximum
     type(moments_spec_t) :: eqwd ! [  km/s] area over peak
   contains
     procedure, public :: reallocate => cubemain_moments_specset_reallocate
     procedure, public :: compute    => cubemain_moments_specset_compute
     procedure, public :: put        => cubemain_moments_specset_put
     procedure, public :: null       => cubemain_moments_specset_null
  end type moments_specset_t
  !
contains
  ! 
  subroutine cubemain_moments_specset_reallocate(specset,nw,iterator,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_specset_t), intent(inout) :: specset
    integer(kind=wind_k),     intent(in)    :: nw
    type(cubeadm_iterator_t), intent(in)    :: iterator
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>SPECSET>REALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call specset%peak%reallocate('peak',nw,iterator,error)
    if (error) return
    call specset%area%reallocate('area',nw,iterator,error)
    if (error) return
    call specset%velo%reallocate('velo',nw,iterator,error)
    if (error) return
    call specset%cent%reallocate('cent',nw,iterator,error)
    if (error) return
    call specset%fwhm%reallocate('fwhm',nw,iterator,error)
    if (error) return
    call specset%eqwd%reallocate('eqwd',nw,iterator,error)
    if (error) return
  end subroutine cubemain_moments_specset_reallocate
  !
  subroutine cubemain_moments_specset_compute(specset,spec,first,last,noise,good,iw,error)
    use cubemain_spectrum_real
    use cubemain_spectrum_blanking
    use cubemain_spectrum_moment_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_specset_t), intent(inout) :: specset
    type(spectrum_t),         intent(in)    :: spec
    integer(kind=chan_k),     intent(in)    :: first
    integer(kind=chan_k),     intent(in)    :: last
    real(kind=sign_k),        intent(in)    :: noise    
    type(spectrum_t),         intent(inout) :: good
    integer(kind=wind_k),     intent(in)    :: iw
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: line
    type(spectrum_tpeak_t) :: peak
    type(spectrum_vpeak_t) :: velo
    type(spectrum_area_t) :: area
    type(spectrum_cent_t) :: cent
    type(spectrum_fwhm_t) :: fwhm
    type(spectrum_eqwd_t) :: eqwd
    character(len=*), parameter :: rname='MOMENTS>SPECSET>COMPUTE'
    !
    call line%point_to(spec,first,last,noise,error)
    if (error) return
    call cubemain_spectrum_unblank(line,good,error)
    if (error) return
    if (good%n.gt.0) then
       ! Compute
       call peak%compute(good,error)
       if (error) return
       call velo%compute(good,peak,error)
       if (error) return             
       call area%compute(good,error)
       if (error) return
       call cent%compute(good,area,error)
       if (error) return
       call fwhm%compute(good,cent,error)
       if (error) return
       call eqwd%compute(peak,area,error)
       if (error) return
       call specset%peak%get(iw,peak,error)
       if (error) return
       call specset%area%get(iw,area,error)
       if (error) return
       call specset%velo%get(iw,velo,error)
       if (error) return
       call specset%cent%get(iw,cent,error)
       if (error) return
       call specset%fwhm%get(iw,fwhm,error)
       if (error) return
       call specset%eqwd%get(iw,eqwd,error)
       if (error) return
    else
       call specset%null(iw,error)
       if (error) return
    endif
  end subroutine cubemain_moments_specset_compute
  !
  subroutine cubemain_moments_specset_null(specset,iw,error)
    use cubemain_spectrum_moment_tool
    use cubetools_nan
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_specset_t), intent(inout) :: specset
    integer(kind=wind_k),     intent(in)    :: iw
    logical,                  intent(inout) :: error
    !
    type(spectrum_moment_t) :: null
    character(len=*), parameter :: rname='MOMENTS>SPECSET>NULL'
    !
    null%sig = gr4nan
    null%noi = gr4nan
    null%snr = gr4nan
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call specset%peak%get(iw,null,error)
    if (error) return
    call specset%area%get(iw,null,error)
    if (error) return
    call specset%velo%get(iw,null,error)
    if (error) return
    call specset%cent%get(iw,null,error)
    if (error) return
    call specset%fwhm%get(iw,null,error)
    if (error) return
    call specset%eqwd%get(iw,null,error)
    if (error) return
  end subroutine cubemain_moments_specset_null
  !
  subroutine cubemain_moments_specset_put(specset,cubeset,ie,error)
    use cubemain_moments_cube_types    
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_specset_t), intent(in)    :: specset
    type(moments_cubeset_t),  intent(inout) :: cubeset
    integer(kind=entr_k),     intent(in)    :: ie
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>SPECSET>PUT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call specset%peak%put(cubeset%peak,ie,error)
    if (error) return                                           
    call specset%area%put(cubeset%area,ie,error)
    if (error) return                                           
    call specset%velo%put(cubeset%velo,ie,error)
    if (error) return                                           
    call specset%cent%put(cubeset%cent,ie,error)
    if (error) return                                           
    call specset%fwhm%put(cubeset%fwhm,ie,error)
    if (error) return                                           
    call specset%eqwd%put(cubeset%eqwd,ie,error)
    if (error) return
  end subroutine cubemain_moments_specset_put
end module cubemain_moments_specset_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_moments
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_cubeid_types
  use cubemain_messaging
  use cubeadm_ancillary_cube_types
  use cubemain_moments_specset_types
  use cubemain_moments_cube_types
  use cubemain_range
  use cubemain_windowing
  !
  public :: moments
  private
  !
  type :: moments_comm_t
     type(option_t), pointer     :: comm
     type(range_opt_t)           :: range
     type(cubeid_arg_t), pointer :: cube
     type(cubeid_arg_t), pointer :: noise
     type(ancillary_cube_comm_t) :: win
     type(moments_cubeprodset_t) :: moments
   contains
     procedure, public  :: register => cubemain_moments_comm_register
     procedure, private :: parse    => cubemain_moments_comm_parse
     procedure, private :: main     => cubemain_moments_comm_main
  end type moments_comm_t
  type(moments_comm_t) :: moments
  !
  type moments_user_t
     type(cubeid_user_t)         :: cubeids
     type(ancillary_cube_user_t) :: win
     type(range_array_t)         :: range
     logical                     :: dorange = .false.
   contains
     procedure, private :: toprog => cubemain_moments_user_toprog
  end type moments_user_t
  !
  type moments_prog_t
     integer(kind=wind_k)        :: nw = 0  ! Number of windows
     integer(kind=chan_k)        :: nc = 0  ! Maximum number of channels inside one window
     type(window_array_t)        :: glowin ! One set of windows for the full index
     type(ancillary_cube_prog_t) :: locwin ! Number and positions of windows depend on the spectrum
     type(cube_t), pointer       :: noise
     type(cube_t), pointer       :: cube
     type(moments_cubeset_t)     :: moments
   contains
     procedure, private :: data        => cubemain_moments_prog_data
     procedure, private :: header      => cubemain_moments_prog_header
     procedure, private :: loop        => cubemain_moments_prog_loop
     procedure, private :: locwin_loop => cubemain_moments_prog_locwin_loop
     procedure, private :: locwin_act  => cubemain_moments_prog_locwin_act
     procedure, private :: glowin_loop => cubemain_moments_prog_glowin_loop
     procedure, private :: glowin_act  => cubemain_moments_prog_glowin_act
  end type moments_prog_t
  !
contains
  !
  subroutine cubemain_moments_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(moments_user_t) :: user
    character(len=*), parameter :: rname='MOMENTS>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call moments%parse(line,user,error)
    if (error) return
    call moments%main(user,error)
    if (error) continue
  end subroutine cubemain_moments_command
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_moments_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_comm_t), intent(inout) :: comm
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    character(len=*), parameter :: rname='MOMENTS>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'MOMENTS','[signalid [noiseid]]',&
         'Compute various moments for each spectrum of a cube',&
         'Compute moment products for each spectrum of SIGNALID using&
         & a global range or per-spectrum windows.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- MOMENTS computes peak, peak velocity, integrated area,&
         & centroid velocity, FWHM, and equivalent width.'//strg_cr//&
         '- For each quantity, signal, noise, and SNR products are&
         & written.'//strg_cr//&
         '- Window selection is controlled with /RANGE and /WINDOWS&
         & keys.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> MOMENTS 12co10:cube 12co10:noise /RANGE -5 15 km/s'//strg_cr//&
         'CUBE> MOMENTS 12co10:cube 12co10:noise /WINDOWS&
         & 12co10:window',&
         cubemain_moments_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         comm%cube,&
         error)
    if (error) return
    call incube%register(&
         'NOISEID',&
         'Noise cube identifier',&
         'If omitted, use the last matching cube (noise flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_noise],&
         code_read,&
         code_access_speset,&
         comm%noise,&
         error)
    if (error) return
    !
    call comm%range%register('RANGE',&
         'Define the velocity range(s) over which to compute moments',&
         range_is_multiple,error)
    if (error) return
    !
    call comm%win%fully_register(&
         'WINDOWS','[windowid]',&
         'Use a window set per spectrum',&
         'If present, per-spectrum window pairs from WINDOWID are used&
         & and /RANGE is ignored. If /WINDOWS is absent, /RANGE is used&
         & and defaults to the full spectral axis when /RANGE is also&
         & absent. If WINDOWID is omitted, use the last matching cube&
         & (window flag) in the default index (DAG by default; see&
         & SET\INDEX).',&
         'WINDOWID','Spectral windows',&
         [flag_window],&
         code_arg_optional,&
         code_read,&
         code_access_speset,&
         error)
    if (error) return
    !
    ! Products
    call comm%moments%register(error)
    if (error)  return
  end subroutine cubemain_moments_comm_register
  !
  subroutine cubemain_moments_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! MOMENTS [signalid [noiseid]]
    ! /RANGE v11 v12 [... [vn1 vn2]] [unit]
    ! /WINDOWS [windowid]
    !----------------------------------------------------------------------
    class(moments_comm_t), intent(inout) :: comm
    character(len=*),      intent(in)    :: line
    type(moments_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%range%parse(line,user%dorange,user%range,error)
    if (error) return
    call comm%win%parse(line,user%win,error)
    if (error) return
  end subroutine cubemain_moments_comm_parse
  !
  subroutine cubemain_moments_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_comm_t), intent(in)    :: comm
    type(moments_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(moments_prog_t) :: prog
    character(len=*), parameter :: rname='MOMENTS>COMM>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_moments_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_moments_user_toprog(user,comm,prog,error)
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_user_t), intent(in)    :: user
    type(moments_comm_t),  intent(in)    :: comm
    type(moments_prog_t),  intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    logical :: conspb
    integer(kind=wind_k) :: iw
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='MOMENTS>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    conspb = .false. ! For consistency checks
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call cubeadm_get_header(comm%noise,user%cubeids,prog%noise,error)
    if (error) return
    call cubetools_consistency_signal_noise(&
         'Cube',prog%cube%head,&
         'Noise',prog%noise%head,conspb,&
         error)
    if (error) return
    call user%win%toprog(comm%win,prog%locwin,error)
    if (error) return
    if (prog%locwin%do) then
       ! User requests to use a windowing file
       call cubetools_consistency_spatial(&
            'Cube',prog%cube%head,&
            'Window',prog%locwin%cube%head,&
            conspb,error)
       if (error) return
       call cubetools_header_get_array_shape(prog%locwin%cube%head,n,error)
       if (error) return
       prog%nw = n%c
       if (mod(prog%nw,2).ne.0) then
          call cubemain_message(seve%e,rname,'Odd number of window edges!')
          error = .true.
          return
       else
          prog%nw = prog%nw/2
       endif
       !
       call cubetools_header_get_array_shape(prog%cube%head,n,error)
       if (error) return
       prog%nc = n%c
    else
       ! Try to use a global window
       ! When the user did not define any range, it defaults to the full
       ! spectrum range => 1 window
       ! *** JP: to be checked...
       call comm%range%user2prog(prog%cube,user%range,prog%glowin,error)
       if (error) return
       prog%nw = prog%glowin%n
       !
       prog%nc = 0
       do iw=1,prog%nw
          if (prog%nc.lt.prog%glowin%val(iw)%nc) prog%nc = prog%glowin%val(iw)%nc
       enddo ! iw
    endif
    if (cubetools_consistency_failed(rname,conspb,error)) return
    ! Another sanity check
    if (prog%nw.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of windows')
       error = .true.
       return
    endif
    ! User feedback
    write (mess,'(a,i0)') 'Maximum number of spectral moments: ',prog%nw
    call cubemain_message(seve%i,rname,mess)
  end subroutine cubemain_moments_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_moments_prog_header(prog,comm,error)
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_prog_t), intent(inout) :: prog
    type(moments_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call prog%moments%header(comm%moments,prog%cube,prog%nw,error)
    if (error) return
  end subroutine cubemain_moments_prog_header
  !
  subroutine cubemain_moments_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='MOMENTS>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))   
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_moments_prog_data
  !
  subroutine cubemain_moments_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>PROG>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (prog%locwin%do) then
       call prog%locwin_loop(iter,error)
       if (error) return
    else
       call prog%glowin_loop(iter,error)
       if (error) return
    endif
  end subroutine cubemain_moments_prog_loop  
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_moments_prog_locwin_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubemain_spectrum_real
    use cubemain_spectrum_blanking
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t), target, intent(inout) :: prog
    type(cubeadm_iterator_t),      intent(inout) :: iter
    logical,                       intent(inout) :: error
    !
    type(spectrum_t) :: spec,good,noise,win
    type(moments_specset_t) :: specset
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='MOMENTS>PROG>LOCWIN>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%reassociate_and_init(prog%cube,iter,error)
    if (error) return
    call good%reallocate('good',prog%nc,iter,error)
    if (error) return
    call noise%reallocate('noise',one,iter,error)
    if (error) return
    call win%reallocate('win',int(2*prog%nw,kind=chan_k),iter,error)
    if (error) return
    call specset%reallocate(prog%nw,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%locwin_act(iter%ie,spec,good,noise,win,specset,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_moments_prog_locwin_loop
  !
  subroutine cubemain_moments_prog_locwin_act(prog,ie,spec,good,noise,win,specset,error)
    use cubemain_spectrum_real
    use cubetopology_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t),   intent(inout) :: prog
    integer(kind=entr_k),    intent(in)    :: ie
    type(spectrum_t),        intent(inout) :: spec
    type(spectrum_t),        intent(inout) :: good
    type(spectrum_t),        intent(inout) :: noise
    type(spectrum_t),        intent(inout) :: win
    type(moments_specset_t), intent(inout) :: specset
    logical,                 intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    integer(kind=chan_k) :: ichan(2)
    real(kind=coor_k) :: vrange(2)
    character(len=*), parameter :: rname='MOMENTS>PROG>LOCWIN>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%get(prog%cube,ie,error)
    if (error) return
    call noise%get(prog%noise,ie,error)
    if (error) return
    call win%get(prog%locwin%cube,ie,error)
    if (error) return
    do iw=1,prog%nw
       if (cubemain_window_blank(win,iw)) then
          call specset%null(iw,error)
          if (error) return
          cycle
       endif
       vrange(:) = win%t(2*iw-1:2*iw)
       call cubetopology_tool_vrange2crange(prog%cube,vrange,ichan,error)
       if (error) return
       call specset%compute(spec,ichan(1),ichan(2),noise%t(1),good,iw,error)
       if (error) return
    enddo ! iw
    call specset%put(prog%moments,ie,error)
    if (error) return
  end subroutine cubemain_moments_prog_locwin_act
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_moments_prog_glowin_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: noise,spec,good
    type(moments_specset_t) :: specset
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='MOMENTS>PROG>GLOWIN>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%reassociate_and_init(prog%cube,iter,error)
    if (error) return
    call good%reallocate('good',prog%nc,iter,error)
    if (error) return
    call noise%reallocate('noise',one,iter,error)
    if (error) return
    call specset%reallocate(prog%nw,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%glowin_act(iter%ie,spec,good,noise,prog%glowin,specset,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_moments_prog_glowin_loop
  !
  subroutine cubemain_moments_prog_glowin_act(prog,ie,spec,good,noise,win,specset,error)
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t),   intent(inout) :: prog
    integer(kind=entr_k),    intent(in)    :: ie
    type(spectrum_t),        intent(inout) :: spec
    type(spectrum_t),        intent(inout) :: good
    type(spectrum_t),        intent(inout) :: noise
    type(window_array_t),    intent(in)    :: win
    type(moments_specset_t), intent(inout) :: specset
    logical,                 intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    integer(kind=chan_k) :: sfirst,slast
    character(len=*), parameter :: rname='MOMENTS>PROG>GLOWIN>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%get(prog%cube,ie,error)
    if (error) return
    call noise%get(prog%noise,ie,error)
    if (error) return
    do iw=1,prog%nw
       if (win%val(iw)%nc.le.0) then
          call specset%null(iw,error)
          if (error) return
          cycle
       endif
       sfirst = win%val(iw)%o(1)
       slast  = win%val(iw)%o(2)
       call specset%compute(spec,sfirst,slast,noise%t(1),good,iw,error)
       if (error) return
    enddo ! iw
    call specset%put(prog%moments,ie,error)
    if (error) return
  end subroutine cubemain_moments_prog_glowin_act
end module cubemain_moments
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the CLIC package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine clic_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Public
  !---------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack  !
  ! Global
  external :: ephem_pack_set
  external :: clic_pack_init
  ! external :: clic_pack_clean
  !
  pack%name='clic'
  pack%ext='.clic'
  pack%depend(1:2) = (/ locwrd(ephem_pack_set), locwrd(greg_pack_set) /)
  pack%init=locwrd(clic_pack_init)
  ! pack%clean=locwrd(clic_pack_clean)
  pack%authors="V.Pietu, A.Castro-Carrizo"
  !
end subroutine clic_pack_set
!
subroutine clic_pack_init(gpack_id,error)
  use gkernel_interfaces
  use sic_def
  !---------------------------------------------------------------------
  ! Private
  !---------------------------------------------------------------------
  integer, intent(in) :: gpack_id   !
  logical, intent(inout) :: error   !
  ! Local
  character(len=80) :: comm
  !
  ! Ensure messages first since next calls produce messages
  call gmessage_log_date(.true.)
  call classic_message_set_id(gpack_id)
  call clic_message_set_id(gpack_id)  ! Set library id
  !
  ! Local language
  call init_clic
  call found_variable
  call mth_init               ! Init MATH package
  !
!!!!!!!!!!!!! Unneeded !!!!!!!!!!!!!!!!
!       CALL MESNAME(LOGFILE)
!       MESFILE = LOGFILE
!       NL = LENC(LOGFILE)
!       LOGFILE(NL-3:) = '.log'
!       MESFILE(NL-3:) = '.mes'
! Get rid of older versions
!       STATUS = SIC_PURGE (LOGFILE,2)
!       STATUS = SIC_PURGE (MESFILE,2)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!       CALL SIC_OPT(NAME,LOGFILE,.TRUE.)
!
! Set priorities:
#if defined(SDM)
      CALL MESSAGE_INIT('',2,2)
#else
      CALL MESSAGE_INIT('',1,0)
#endif
!
  comm = 'CLIC'//backslash//'SHOW'
  call sic_setsymbol('SH*OW',comm,error)
  comm = 'CLIC'//backslash//'FIND'
  call sic_setsymbol('FIN*D',comm,error)
!  comm = 'SIC'//backslash//'HELP CLIC'//backslash//' INFO'
!  call siC_setsymbol('INFO',comm,error)
  comm = 'CLIC'//backslash//'HEADER'
  call sic_setsymbol('HEAD*ER',comm,error)
  comm = 'CLIC'//backslash//'SET DEFAULT'
  call exec_program(comm)
  !
end subroutine clic_pack_init
!
! subroutine clic_pack_clean(error)
!   !----------------------------------------------------------------------
!   ! Private
!   !----------------------------------------------------------------------
!   logical, intent(inout) :: error
!   !
! end subroutine clic_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_read_header(filename,imbf,error)
  use gildas_def
  use gbl_message
  use imbfits_interfaces, except_this => imbfits_read_header
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Open the file, read the leading HDUs, and build the list
  ! (equivalence classes) of subscans.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: filename
  type(imbfits_t),  intent(inout) :: imbf
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='READ>HEADER'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  call imbfits_reopen_file(filename,imbf%file,imbf%hdus,error)
  if (error) return
  !
  call imbfits_read_leadhdus(imbf,error)
  if (error) return
  !
  call imbfits_check_leadhdus(imbf,error)
  if (error) return
  !
  call imbfits_read_subscan_eclass(imbf,error)
  if (error)  return
  !
end subroutine imbfits_read_header
!
subroutine imbfits_reopen_file(filename,file,hdus,error)
  use gildas_def
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_reopen_file
  !---------------------------------------------------------------------
  ! @ private
  ! Open, if needed, the given file. Close of needed any previous file
  ! (if different).
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: filename
  type(imbfits_file_t), intent(inout) :: file
  type(imbfits_hdus_t), intent(inout) :: hdus
  logical,              intent(inout) :: error
  !
  if (file%name.eq.'') then
    ! No previous file in memory
    call imbfits_open_file(filename,file,hdus,error)
    !
  elseif (filename.eq.file%name) then
    ! Same file, is it closed or opened?
    if (file%unit.eq.0) then
      ! File is closed, open it
      call imbfits_open_file(filename,file,hdus,error)
    else
      ! Same file, already opened: nothing to do
      continue
    endif
  else
    ! Not the same file name
    if (file%unit.ne.0) then
      ! The old file is still opened: close it
      call imbfits_close_file(file,error)
      if (error)  return
    endif
    call imbfits_open_file(filename,file,hdus,error)
  endif
  !
end subroutine imbfits_reopen_file
!
subroutine imbfits_open_file(filename,file,hdus,error)
  use gbl_message
  use gildas_def
  use cfitsio_api
  use gkernel_interfaces
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_open_file
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: filename
  type(imbfits_file_t), intent(out)   :: file
  type(imbfits_hdus_t), intent(out)   :: hdus
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>OPEN>FILE'
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  ! CFITSIO is able to deal with several files at the same time as long
  ! as we identify them with different logical units.
  status = sic_getlun(file%unit)
  if (status.ne.1) then
    call imbfits_message(seve%e,rname,'Could not get new logical unit')
    error = .true.
    return
  endif
  !
  status = 0
  file%name = filename
  call ftopen(file%unit,file%name,file%rwstatus,file%block,status)
  if (status.gt.0) then
     call imbfits_message(seve%e,rname,'Do not succeed to open '''//trim(file%name)//'''')
     call cfitsio_errormsg(status)
     error = .true.
     ! Must clean before exit
     file%name = ''
     call sic_frelun(file%unit)
     file%unit = 0
     return
  endif
  !
  call imbfits_hdus(file,hdus,error)
  if (error)  return
  !
end subroutine imbfits_open_file
!
subroutine imbfits_read_leadhdus(imbf,error)
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_read_leadhdus
  !---------------------------------------------------------------------
  ! @ public
  ! Read the 4 first leading HDUs
  !---------------------------------------------------------------------
  type(imbfits_t), intent(inout) :: imbf
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='READ>LEADHDUS'
  !
  call imbfits_read_header_primary(imbf%file,imbf%primary,error)
  if (error)  return
  imbf%file%isholography = imbf%primary%instrume%val.eq.'holo'
  !
  call imbfits_read_header_scan(imbf,imbf%scan,error)
  if (error)  return
  !
  call imbfits_read_header_frontend(imbf%file,imbf%front,error)
  if (error)  return
  imbf%file%isarray = any(imbf%front%table%nofeeds%val.gt.1)
  !
  ! Backend-HDU: must come after Frontend-HDU
  call imbfits_read_header_backend(imbf,error)
  if (error)  return
  !
  ! Derotator: only for array receivers
  if (imbf%file%isarray) then
    call imbfits_read_header_derot(imbf,imbf%derot,error)
  else
    call imbfits_free_header_derot(imbf%derot,error)
  endif
  if (error)  return
  !
end subroutine imbfits_read_leadhdus
!
subroutine imbfits_check_leadhdus(imbf,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_check_leadhdus
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 4 first HDUs
  !---------------------------------------------------------------------
  type(imbfits_t),  intent(inout) :: imbf      !
  logical,          intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='CHECK>LEADHDUS'
  !
  call imbfits_check_header_primary(imbf%file,imbf%primary,error)
  if (error)  return
  call imbfits_check_header_scan(imbf%primary,imbf%scan,error)
  if (error)  return
  ! call imbfits_check_header_frontend(imbf%file,imbf%front,error)
  ! if (error)  return
  call imbfits_check_header_backend(imbf%back,error)
  if (error)  return
  !
end subroutine imbfits_check_leadhdus
!
subroutine imbfits_read_subscan_eclass(imbf,error)
  use gkernel_interfaces
  use imbfits_interfaces, except_this=>imbfits_read_subscan_eclass
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ private
  ! Run through all the subscans headers and build equivalences classes
  ! for all of them
  !---------------------------------------------------------------------
  type(imbfits_t), intent(inout) :: imbf
  logical,         intent(inout) :: error
  ! Local
  integer(kind=4) :: isub,nsub
  type(imbfits_subscan_t) :: subs
  !
  nsub = imbf%primary%n_obsp%val
  !
  call reallocate_eclass_char(imbf%seclass,nsub,error)
  if (error)  return
  !
  do isub=1,nsub
    ! Read IMBF-antenna ONLY for efficiency purpose
    ! Note: no need for mjd_shift => set to 0
    call imbfits_read_header_antslow(imbf,isub,0.d0,subs%antslow,error)
    if (error)  goto 100
    !
    imbf%seclass%val(isub) = subs%antslow%head%substype%val
    imbf%seclass%cnt(isub) = 1
  enddo
  !
  ! Compute equivalence classes to gather the subscans by family:
  call eclass_char(eclass_char_eq,imbf%seclass)
  !
100 continue
  call imbfits_free_header_antslow(subs%antslow,error)
  if (error)  return
  !
end subroutine imbfits_read_subscan_eclass
!
subroutine imbfits_close_file(file,error)
  use gbl_message
  use gildas_def
  use cfitsio_api
  use gkernel_interfaces
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_close_file
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(inout) :: file
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='IMBFITS>CLOSE>FILE'
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  status = 0
  call ftclos(file%unit,status)
  if (status.gt.0) then
     call imbfits_message(seve%e,rname,'Do not succeed to close '//trim(file%name))
     call cfitsio_errormsg(status)
     error = .true.
     return
  endif
  !
  call sic_frelun(file%unit)
  file%unit = 0
  !
end subroutine imbfits_close_file
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_free_leadhdus(imbf,error)
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_free_leadhdus
  !---------------------------------------------------------------------
  ! @ public
  ! Free the leading HDUs. Can be called in an error recovery context
  ! i.e. with error .true. as input.
  !---------------------------------------------------------------------
  type(imbfits_t), intent(inout) :: imbf      !
  logical,         intent(inout) :: error     !
  !
  call imbfits_free_header_primary(imbf%primary,error)
  if (error)  continue
  call imbfits_free_header_scan(imbf%scan,error)
  if (error)  continue
  call imbfits_free_header_frontend(imbf%front,error)
  if (error)  continue
  call imbfits_free_header_backend(imbf%back,error)
  if (error)  continue
  call imbfits_free_header_derot(imbf%derot,error)
  if (error)  continue
  !
end subroutine imbfits_free_leadhdus
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program mask_main
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  ! GILDAS
  !  Mask all planes of a data cube according to a given polygon file.
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: name_in,name_out,polyfile
  real(kind=4) :: blank
  integer(kind=4) :: i,j,ier
  logical :: in,error,mblank
  logical, allocatable :: mask(:,:)
  type(gildas) :: x,y
  type(polygon_t) :: poly
  !
  error = .false.
  !
  ! Get parameters
  call gildas_open
  call gildas_char('POLYGON$',polyfile)
  call gildas_char('Y_NAME$',name_in)
  call gildas_char('X_NAME$',name_out)
  call gildas_logi('MASK_IN$',in,1)
  call gildas_logi('MODIFY$',mblank,1)
  if (mblank) call gildas_real('BLANKING$',blank,1)
  call gildas_close
  !
  call greg_poly_load('MASK',.true.,polyfile,poly,error)
  if (error)  goto 100
  !
  ! Read Input Map
  call gildas_null(y)
  y%gil%form = fmt_r4
  call gdf_read_gildas(y,name_in,'.lmv',error) 
  if (error) then
    call gagout('F-MASK,  Cannot read input file '//y%file)
    goto 100
  endif
  if (.not.mblank)  blank = y%gil%bval
  !
  ! Create Output Map
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  x%gil%blan_words = 2
  if (mblank) then
    x%gil%bval = blank
    x%gil%eval = 0.0
  else
    x%gil%eval = max(x%gil%eval,0.0)
  endif
  call sic_parsef(name_out,x%file,' ','.gdf')
  call gdf_create_image(x,error)
  if (error) then
    call gagout('F-MASK,  Cannot create output image')
    goto 100
  endif
  !
  allocate(mask(x%gil%dim(1),x%gil%dim(2)),  &
          y%r2d(x%gil%dim(1),x%gil%dim(2)),stat=ier)
  if (ier.ne.0) goto 100
  !
  ! Scale the polygon to pixel
  call gr8_scalpol(poly,x%gil%convert)
  !
  ! Define the mask once
  call gr4_getmask(mask,x%gil%dim(1),x%gil%dim(2),poly,in)
  !
  ! Mask all channels of the Output Map
  do j = 1,x%gil%dim(4)
    x%blc(4) = j
    x%trc(4) = j
    do i=1,x%gil%dim(3)
      x%blc(3) = i
      x%trc(3) = i
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,y%r2d,error)
      if (error) goto 100
      ! Mask
      where (mask) y%r2d = blank
      call gdf_write_data(x,y%r2d,error)
    enddo
  enddo
  call gagout('S-MASK,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program mask_main
!
subroutine gr8_scalpol(poly,zconv)
  use gkernel_types
  !---------------------------------------------------------------------
  ! GILDAS
  !     Scale a polygon data structure to pixel units
  !---------------------------------------------------------------------
  type(polygon_t), intent(inout) :: poly      !
  real(kind=8),    intent(in)    :: zconv(6)  ! Conversion formula
  ! Local
  real(kind=8) :: xref,xval,xinc,yref,yval,yinc,tmp
  integer(kind=4) :: i
  !
  xref = zconv(1)
  xval = zconv(2)
  xinc = zconv(3)
  yref = zconv(4)
  yval = zconv(5)
  yinc = zconv(6)
  !
  do i=1,poly%ngon
    poly%xgon(i)  = (poly%xgon(i) - xval)/xinc + xref
    poly%ygon(i)  = (poly%ygon(i) - yval)/yinc + yref
    poly%dxgon(i) =  poly%dxgon(i)/xinc
    poly%dygon(i) =  poly%dygon(i)/yinc
  enddo
  !
  poly%xout  = (poly%xout - xval)/xinc + xref
  poly%xgon1 = (poly%xgon1 - xval)/xinc + xref
  poly%xgon2 = (poly%xgon2 - xval)/xinc + xref
  if (xinc.lt.0) then
    tmp = poly%xgon1
    poly%xgon1 = poly%xgon2
    poly%xgon2 = tmp
  endif
  poly%ygon1 = (poly%ygon1 - yval)/yinc + yref
  poly%ygon2 = (poly%ygon2 - yval)/yinc + yref
  if (yinc.lt.0) then
    tmp = poly%ygon1
    poly%ygon1 = poly%ygon2
    poly%ygon2 = tmp
  endif
  poly%xout = poly%xgon1 - 0.05*(poly%xgon2-poly%xgon1)
end subroutine gr8_scalpol
!
subroutine gr4_getmask(z,nx,ny,poly,inside)
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  !  Mask part of a regular grid map using a POLYGON, in
  !  PIXEL coordinates (for speed, use GR8_SETPOL before to scale it)
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nx        ! Size of Map
  integer(kind=index_length), intent(in)  :: ny        ! Size of Map
  logical,         intent(out) :: z(nx,ny)  ! Mask to be computed
  type(polygon_t), intent(in)  :: poly      !
  logical,         intent(in)  :: inside    ! Mask Inside or Outside
  ! Local
  logical :: blank,good
  real(kind=8) :: x,y
  integer(kind=index_length) :: i,j,imin,imax,jmin,jmax
  !
  ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
  imin = max (1, int(poly%xgon1) )
  imax = min (nx,int(poly%xgon2)+1 )
  jmin = max (1, int(poly%ygon1) )
  jmax = min (ny,int(poly%ygon2)+1 )
  !
  ! Mask the outside or the inside ?
  blank = .not.inside
  good = .not.blank
  !
  ! Test location only when not known
  do j=1,ny
    if (j.lt.jmin .or. j.gt.jmax) then
      do i=1,nx
        z(i,j) = blank
      enddo
    else
      do i=1,nx
        if (i.lt.imin) then
          z(i,j) = blank
        elseif (i.gt.imax) then
          z(i,j) = blank
        else
          x = dble(i)
          y = dble(j)
          if (greg_poly_inside(x,y,poly)) then
            z(i,j) = good
          else
            z(i,j) = blank
          endif
        endif
      enddo
    endif
  enddo
end subroutine gr4_getmask

* DECK dopgtr.f
      SUBROUTINE DOPGTR( UPLO, N, AP, TAU, Q, LDQ, WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDQ, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AP( * ), Q( LDQ, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DOPGTR generates a real orthogonal matrix Q which is defined as the
*  product of n-1 elementary reflectors H(i) of order n, as returned by
*  DSPTRD using packed storage:
*
*  if UPLO = 'U', Q = H(n-1) . . . H(2) H(1),
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(n-1).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangular packed storage used in previous
*                 call to DSPTRD;
*          = 'L': Lower triangular packed storage used in previous
*                 call to DSPTRD.
*
*  N       (input) INTEGER
*          The order of the matrix Q. N >= 0.
*
*  AP      (input) DOUBLE PRECISION array, dimension (N*(N+1)/2)
*          The vectors which define the elementary reflectors, as
*          returned by DSPTRD.
*
*  TAU     (input) DOUBLE PRECISION array, dimension (N-1)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DSPTRD.
*
*  Q       (output) DOUBLE PRECISION array, dimension (LDQ,N)
*          The N-by-N orthogonal matrix Q.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= max(1,N).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N-1)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, IINFO, IJ, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORG2L, DORG2R, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DOPGTR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to DSPTRD with UPLO = 'U'
*
*        Unpack the vectors which define the elementary reflectors and
*        set the last row and column of Q equal to those of the unit
*        matrix
*
         IJ = 2
         DO 20 J = 1, N - 1
            DO 10 I = 1, J - 1
               Q( I, J ) = AP( IJ )
               IJ = IJ + 1
   10       CONTINUE
            IJ = IJ + 2
            Q( N, J ) = ZERO
   20    CONTINUE
         DO 30 I = 1, N - 1
            Q( I, N ) = ZERO
   30    CONTINUE
         Q( N, N ) = ONE
*
*        Generate Q(1:n-1,1:n-1)
*
         CALL DORG2L( N-1, N-1, N-1, Q, LDQ, TAU, WORK, IINFO )
*
      ELSE
*
*        Q was determined by a call to DSPTRD with UPLO = 'L'.
*
*        Unpack the vectors which define the elementary reflectors and
*        set the first row and column of Q equal to those of the unit
*        matrix
*
         Q( 1, 1 ) = ONE
         DO 40 I = 2, N
            Q( I, 1 ) = ZERO
   40    CONTINUE
         IJ = 3
         DO 60 J = 2, N
            Q( 1, J ) = ZERO
            DO 50 I = J + 1, N
               Q( I, J ) = AP( IJ )
               IJ = IJ + 1
   50       CONTINUE
            IJ = IJ + 2
   60    CONTINUE
         IF( N.GT.1 ) THEN
*
*           Generate Q(2:n,2:n)
*
            CALL DORG2R( N-1, N-1, N-1, Q( 2, 2 ), LDQ, TAU, WORK,
     $                   IINFO )
         END IF
      END IF
      RETURN
*
*     End of DOPGTR
*
      END
* DECK dopmtr.f
      SUBROUTINE DOPMTR( SIDE, UPLO, TRANS, M, N, AP, TAU, C, LDC, WORK,
     $                   INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS, UPLO
      INTEGER            INFO, LDC, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   AP( * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DOPMTR overwrites the general real M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  where Q is a real orthogonal matrix of order nq, with nq = m if
*  SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*  nq-1 elementary reflectors, as returned by DSPTRD using packed
*  storage:
*
*  if UPLO = 'U', Q = H(nq-1) . . . H(2) H(1);
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(nq-1).
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**T from the Left;
*          = 'R': apply Q or Q**T from the Right.
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangular packed storage used in previous
*                 call to DSPTRD;
*          = 'L': Lower triangular packed storage used in previous
*                 call to DSPTRD.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'T':  Transpose, apply Q**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  AP      (input) DOUBLE PRECISION array, dimension
*                               (M*(M+1)/2) if SIDE = 'L'
*                               (N*(N+1)/2) if SIDE = 'R'
*          The vectors which define the elementary reflectors, as
*          returned by DSPTRD.  AP is modified by the routine but
*          restored on exit.
*
*  TAU     (input) DOUBLE PRECISION array, dimension (M-1) if SIDE = 'L'
*                                     or (N-1) if SIDE = 'R'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DSPTRD.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension
*                                   (N) if SIDE = 'L'
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            FORWRD, LEFT, NOTRAN, UPPER
      INTEGER            I, I1, I2, I3, IC, II, JC, MI, NI, NQ
      DOUBLE PRECISION   AII
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
      UPPER = LSAME( UPLO, 'U' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DOPMTR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to DSPTRD with UPLO = 'U'
*
         FORWRD = ( LEFT .AND. NOTRAN ) .OR.
     $            ( .NOT.LEFT .AND. .NOT.NOTRAN )
*
         IF( FORWRD ) THEN
            I1 = 1
            I2 = NQ - 1
            I3 = 1
            II = 2
         ELSE
            I1 = NQ - 1
            I2 = 1
            I3 = -1
            II = NQ*( NQ+1 ) / 2 - 1
         END IF
*
         IF( LEFT ) THEN
            NI = N
         ELSE
            MI = M
         END IF
*
         DO 10 I = I1, I2, I3
            IF( LEFT ) THEN
*
*              H(i) is applied to C(1:i,1:n)
*
               MI = I
            ELSE
*
*              H(i) is applied to C(1:m,1:i)
*
               NI = I
            END IF
*
*           Apply H(i)
*
            AII = AP( II )
            AP( II ) = ONE
            CALL DLARF( SIDE, MI, NI, AP( II-I+1 ), 1, TAU( I ), C, LDC,
     $                  WORK )
            AP( II ) = AII
*
            IF( FORWRD ) THEN
               II = II + I + 2
            ELSE
               II = II - I - 1
            END IF
   10    CONTINUE
      ELSE
*
*        Q was determined by a call to DSPTRD with UPLO = 'L'.
*
         FORWRD = ( LEFT .AND. .NOT.NOTRAN ) .OR.
     $            ( .NOT.LEFT .AND. NOTRAN )
*
         IF( FORWRD ) THEN
            I1 = 1
            I2 = NQ - 1
            I3 = 1
            II = 2
         ELSE
            I1 = NQ - 1
            I2 = 1
            I3 = -1
            II = NQ*( NQ+1 ) / 2 - 1
         END IF
*
         IF( LEFT ) THEN
            NI = N
            JC = 1
         ELSE
            MI = M
            IC = 1
         END IF
*
         DO 20 I = I1, I2, I3
            AII = AP( II )
            AP( II ) = ONE
            IF( LEFT ) THEN
*
*              H(i) is applied to C(i+1:m,1:n)
*
               MI = M - I
               IC = I + 1
            ELSE
*
*              H(i) is applied to C(1:m,i+1:n)
*
               NI = N - I
               JC = I + 1
            END IF
*
*           Apply H(i)
*
            CALL DLARF( SIDE, MI, NI, AP( II ), 1, TAU( I ),
     $                  C( IC, JC ), LDC, WORK )
            AP( II ) = AII
*
            IF( FORWRD ) THEN
               II = II + NQ - I + 1
            ELSE
               II = II - NQ + I - 2
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of DOPMTR
*
      END
* DECK dorg2l.f
      SUBROUTINE DORG2L( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORG2L generates an m by n real matrix Q with orthonormal columns,
*  which is defined as the last n columns of a product of k elementary
*  reflectors of order m
*
*        Q  =  H(k) . . . H(2) H(1)
*
*  as returned by DGEQLF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. M >= N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. N >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the (n-k+i)-th column must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by DGEQLF in the last k columns of its array
*          argument A.
*          On exit, the m by n matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQLF.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, II, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORG2L', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
*     Initialise columns 1:n-k to columns of the unit matrix
*
      DO 20 J = 1, N - K
         DO 10 L = 1, M
            A( L, J ) = ZERO
   10    CONTINUE
         A( M-N+J, J ) = ONE
   20 CONTINUE
*
      DO 40 I = 1, K
         II = N - K + I
*
*        Apply H(i) to A(1:m-k+i,1:n-k+i) from the left
*
         A( M-N+II, II ) = ONE
         CALL DLARF( 'Left', M-N+II, II-1, A( 1, II ), 1, TAU( I ), A,
     $               LDA, WORK )
         CALL DSCAL( M-N+II-1, -TAU( I ), A( 1, II ), 1 )
         A( M-N+II, II ) = ONE - TAU( I )
*
*        Set A(m-k+i+1:m,n-k+i) to zero
*
         DO 30 L = M - N + II + 1, M
            A( L, II ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of DORG2L
*
      END
* DECK dorg2r.f
      SUBROUTINE DORG2R( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORG2R generates an m by n real matrix Q with orthonormal columns,
*  which is defined as the first n columns of a product of k elementary
*  reflectors of order m
*
*        Q  =  H(1) H(2) . . . H(k)
*
*  as returned by DGEQRF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. M >= N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. N >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the i-th column must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by DGEQRF in the first k columns of its array
*          argument A.
*          On exit, the m-by-n matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQRF.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORG2R', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
*     Initialise columns k+1:n to columns of the unit matrix
*
      DO 20 J = K + 1, N
         DO 10 L = 1, M
            A( L, J ) = ZERO
   10    CONTINUE
         A( J, J ) = ONE
   20 CONTINUE
*
      DO 40 I = K, 1, -1
*
*        Apply H(i) to A(i:m,i:n) from the left
*
         IF( I.LT.N ) THEN
            A( I, I ) = ONE
            CALL DLARF( 'Left', M-I+1, N-I, A( I, I ), 1, TAU( I ),
     $                  A( I, I+1 ), LDA, WORK )
         END IF
         IF( I.LT.M )
     $      CALL DSCAL( M-I, -TAU( I ), A( I+1, I ), 1 )
         A( I, I ) = ONE - TAU( I )
*
*        Set A(1:i-1,i) to zero
*
         DO 30 L = 1, I - 1
            A( L, I ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of DORG2R
*
      END
* DECK dorgbr.f
      SUBROUTINE DORGBR( VECT, M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          VECT
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORGBR generates one of the real orthogonal matrices Q or P**T
*  determined by DGEBRD when reducing a real matrix A to bidiagonal
*  form: A = Q * B * P**T.  Q and P**T are defined as products of
*  elementary reflectors H(i) or G(i) respectively.
*
*  If VECT = 'Q', A is assumed to have been an M-by-K matrix, and Q
*  is of order M:
*  if m >= k, Q = H(1) H(2) . . . H(k) and DORGBR returns the first n
*  columns of Q, where m >= n >= k;
*  if m < k, Q = H(1) H(2) . . . H(m-1) and DORGBR returns Q as an
*  M-by-M matrix.
*
*  If VECT = 'P', A is assumed to have been a K-by-N matrix, and P**T
*  is of order N:
*  if k < n, P**T = G(k) . . . G(2) G(1) and DORGBR returns the first m
*  rows of P**T, where n >= m >= k;
*  if k >= n, P**T = G(n-1) . . . G(2) G(1) and DORGBR returns P**T as
*  an N-by-N matrix.
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          Specifies whether the matrix Q or the matrix P**T is
*          required, as defined in the transformation applied by DGEBRD:
*          = 'Q':  generate Q;
*          = 'P':  generate P**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q or P**T to be returned.
*          M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q or P**T to be returned.
*          N >= 0.
*          If VECT = 'Q', M >= N >= min(M,K);
*          if VECT = 'P', N >= M >= min(N,K).
*
*  K       (input) INTEGER
*          If VECT = 'Q', the number of columns in the original M-by-K
*          matrix reduced by DGEBRD.
*          If VECT = 'P', the number of rows in the original K-by-N
*          matrix reduced by DGEBRD.
*          K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the vectors which define the elementary reflectors,
*          as returned by DGEBRD.
*          On exit, the M-by-N matrix Q or P**T.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension
*                                (min(M,K)) if VECT = 'Q'
*                                (min(N,K)) if VECT = 'P'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i) or G(i), which determines Q or P**T, as
*          returned by DGEBRD in its array argument TAUQ or TAUP.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,min(M,N)).
*          For optimum performance LWORK >= min(M,N)*NB, where NB
*          is the optimal blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            WANTQ
      INTEGER            I, IINFO, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORGLQ, DORGQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      WANTQ = LSAME( VECT, 'Q' )
      IF( .NOT.WANTQ .AND. .NOT.LSAME( VECT, 'P' ) ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 .OR. ( WANTQ .AND. ( N.GT.M .OR. N.LT.MIN( M,
     $         K ) ) ) .OR. ( .NOT.WANTQ .AND. ( M.GT.N .OR. M.LT.
     $         MIN( N, K ) ) ) ) THEN
         INFO = -3
      ELSE IF( K.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -6
      ELSE IF( LWORK.LT.MAX( 1, MIN( M, N ) ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGBR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( WANTQ ) THEN
*
*        Form Q, determined by a call to DGEBRD to reduce an m-by-k
*        matrix
*
         IF( M.GE.K ) THEN
*
*           If m >= k, assume m >= n >= k
*
            CALL DORGQR( M, N, K, A, LDA, TAU, WORK, LWORK, IINFO )
*
         ELSE
*
*           If m < k, assume m = n
*
*           Shift the vectors which define the elementary reflectors one
*           column to the right, and set the first row and column of Q
*           to those of the unit matrix
*
            DO 20 J = M, 2, -1
               A( 1, J ) = ZERO
               DO 10 I = J + 1, M
                  A( I, J ) = A( I, J-1 )
   10          CONTINUE
   20       CONTINUE
            A( 1, 1 ) = ONE
            DO 30 I = 2, M
               A( I, 1 ) = ZERO
   30       CONTINUE
            IF( M.GT.1 ) THEN
*
*              Form Q(2:m,2:m)
*
               CALL DORGQR( M-1, M-1, M-1, A( 2, 2 ), LDA, TAU, WORK,
     $                      LWORK, IINFO )
            END IF
         END IF
      ELSE
*
*        Form P', determined by a call to DGEBRD to reduce a k-by-n
*        matrix
*
         IF( K.LT.N ) THEN
*
*           If k < n, assume k <= m <= n
*
            CALL DORGLQ( M, N, K, A, LDA, TAU, WORK, LWORK, IINFO )
*
         ELSE
*
*           If k >= n, assume m = n
*
*           Shift the vectors which define the elementary reflectors one
*           row downward, and set the first row and column of P' to
*           those of the unit matrix
*
            A( 1, 1 ) = ONE
            DO 40 I = 2, N
               A( I, 1 ) = ZERO
   40       CONTINUE
            DO 60 J = 2, N
               DO 50 I = J - 1, 2, -1
                  A( I, J ) = A( I-1, J )
   50          CONTINUE
               A( 1, J ) = ZERO
   60       CONTINUE
            IF( N.GT.1 ) THEN
*
*              Form P'(2:n,2:n)
*
               CALL DORGLQ( N-1, N-1, N-1, A( 2, 2 ), LDA, TAU, WORK,
     $                      LWORK, IINFO )
            END IF
         END IF
      END IF
      RETURN
*
*     End of DORGBR
*
      END
* DECK dorghr.f
      SUBROUTINE DORGHR( N, ILO, IHI, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORGHR generates a real orthogonal matrix Q which is defined as the
*  product of IHI-ILO elementary reflectors of order N, as returned by
*  DGEHRD:
*
*  Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix Q. N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          ILO and IHI must have the same values as in the previous call
*          of DGEHRD. Q is equal to the unit matrix except in the
*          submatrix Q(ilo+1:ihi,ilo+1:ihi).
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the vectors which define the elementary reflectors,
*          as returned by DGEHRD.
*          On exit, the N-by-N orthogonal matrix Q.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (N-1)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEHRD.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= IHI-ILO.
*          For optimum performance LWORK >= (IHI-ILO)*NB, where NB is
*          the optimal blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IINFO, J, NH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORGQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -2
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, IHI-ILO ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGHR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Shift the vectors which define the elementary reflectors one
*     column to the right, and set the first ilo and the last n-ihi
*     rows and columns to those of the unit matrix
*
      DO 40 J = IHI, ILO + 1, -1
         DO 10 I = 1, J - 1
            A( I, J ) = ZERO
   10    CONTINUE
         DO 20 I = J + 1, IHI
            A( I, J ) = A( I, J-1 )
   20    CONTINUE
         DO 30 I = IHI + 1, N
            A( I, J ) = ZERO
   30    CONTINUE
   40 CONTINUE
      DO 60 J = 1, ILO
         DO 50 I = 1, N
            A( I, J ) = ZERO
   50    CONTINUE
         A( J, J ) = ONE
   60 CONTINUE
      DO 80 J = IHI + 1, N
         DO 70 I = 1, N
            A( I, J ) = ZERO
   70    CONTINUE
         A( J, J ) = ONE
   80 CONTINUE
*
      NH = IHI - ILO
      IF( NH.GT.0 ) THEN
*
*        Generate Q(ilo+1:ihi,ilo+1:ihi)
*
         CALL DORGQR( NH, NH, NH, A( ILO+1, ILO+1 ), LDA, TAU( ILO ),
     $                WORK, LWORK, IINFO )
      END IF
      RETURN
*
*     End of DORGHR
*
      END
* DECK dorgl2.f
      SUBROUTINE DORGL2( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORGL2 generates an m by n real matrix Q with orthonormal rows,
*  which is defined as the first m rows of a product of k elementary
*  reflectors of order n
*
*        Q  =  H(k) . . . H(2) H(1)
*
*  as returned by DGELQF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. N >= M.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. M >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the i-th row must contain the vector which defines
*          the elementary reflector H(i), for i = 1,2,...,k, as returned
*          by DGELQF in the first k rows of its array argument A.
*          On exit, the m-by-n matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGELQF.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (M)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGL2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.LE.0 )
     $   RETURN
*
      IF( K.LT.M ) THEN
*
*        Initialise rows k+1:m to rows of the unit matrix
*
         DO 20 J = 1, N
            DO 10 L = K + 1, M
               A( L, J ) = ZERO
   10       CONTINUE
            IF( J.GT.K .AND. J.LE.M )
     $         A( J, J ) = ONE
   20    CONTINUE
      END IF
*
      DO 40 I = K, 1, -1
*
*        Apply H(i) to A(i:m,i:n) from the right
*
         IF( I.LT.N ) THEN
            IF( I.LT.M ) THEN
               A( I, I ) = ONE
               CALL DLARF( 'Right', M-I, N-I+1, A( I, I ), LDA,
     $                     TAU( I ), A( I+1, I ), LDA, WORK )
            END IF
            CALL DSCAL( N-I, -TAU( I ), A( I, I+1 ), LDA )
         END IF
         A( I, I ) = ONE - TAU( I )
*
*        Set A(1:i-1,i) to zero
*
         DO 30 L = 1, I - 1
            A( I, L ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of DORGL2
*
      END
* DECK dorglq.f
      SUBROUTINE DORGLQ( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORGLQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*
*        Q  =  H(k) . . . H(2) H(1)
*
*  as returned by DGELQF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. N >= M.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. M >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the i-th row must contain the vector which defines
*          the elementary reflector H(i), for i = 1,2,...,k, as returned
*          by DGELQF in the first k rows of its array argument A.
*          On exit, the M-by-N matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGELQF.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,M).
*          For optimum performance LWORK >= M*NB, where NB is
*          the optimal blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IB, IINFO, IWS, J, KI, KK, L, LDWORK, NB,
     $                   NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARFB, DLARFT, DORGL2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, M ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGLQ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.LE.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.
*
      NB = ILAENV( 1, 'DORGLQ', ' ', M, N, K, -1 )
      NBMIN = 2
      NX = 0
      IWS = M
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'DORGLQ', ' ', M, N, K, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = M
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'DORGLQ', ' ', M, N, K, -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code after the last block.
*        The first kk rows are handled by the block method.
*
         KI = ( ( K-NX-1 ) / NB )*NB
         KK = MIN( K, KI+NB )
*
*        Set A(kk+1:m,1:kk) to zero.
*
         DO 20 J = 1, KK
            DO 10 I = KK + 1, M
               A( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE
         KK = 0
      END IF
*
*     Use unblocked code for the last or only block.
*
      IF( KK.LT.M )
     $   CALL DORGL2( M-KK, N-KK, K-KK, A( KK+1, KK+1 ), LDA,
     $                TAU( KK+1 ), WORK, IINFO )
*
      IF( KK.GT.0 ) THEN
*
*        Use blocked code
*
         DO 50 I = KI + 1, 1, -NB
            IB = MIN( NB, K-I+1 )
            IF( I+IB.LE.M ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i) H(i+1) . . . H(i+ib-1)
*
               CALL DLARFT( 'Forward', 'Rowwise', N-I+1, IB, A( I, I ),
     $                      LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H' to A(i+ib:m,i:n) from the right
*
               CALL DLARFB( 'Right', 'Transpose', 'Forward', 'Rowwise',
     $                      M-I-IB+1, N-I+1, IB, A( I, I ), LDA, WORK,
     $                      LDWORK, A( I+IB, I ), LDA, WORK( IB+1 ),
     $                      LDWORK )
            END IF
*
*           Apply H' to columns i:n of current block
*
            CALL DORGL2( IB, N-I+1, IB, A( I, I ), LDA, TAU( I ), WORK,
     $                   IINFO )
*
*           Set columns 1:i-1 of current block to zero
*
            DO 40 J = 1, I - 1
               DO 30 L = I, I + IB - 1
                  A( L, J ) = ZERO
   30          CONTINUE
   40       CONTINUE
   50    CONTINUE
      END IF
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of DORGLQ
*
      END
* DECK dorgql.f
      SUBROUTINE DORGQL( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORGQL generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*
*        Q  =  H(k) . . . H(2) H(1)
*
*  as returned by DGEQLF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. M >= N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. N >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the (n-k+i)-th column must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by DGEQLF in the last k columns of its array
*          argument A.
*          On exit, the M-by-N matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQLF.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,N).
*          For optimum performance LWORK >= N*NB, where NB is the
*          optimal blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IB, IINFO, IWS, J, KK, L, LDWORK, NB, NBMIN,
     $                   NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARFB, DLARFT, DORG2L, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGQL', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.
*
      NB = ILAENV( 1, 'DORGQL', ' ', M, N, K, -1 )
      NBMIN = 2
      NX = 0
      IWS = N
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'DORGQL', ' ', M, N, K, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = N
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'DORGQL', ' ', M, N, K, -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code after the first block.
*        The last kk columns are handled by the block method.
*
         KK = MIN( K, ( ( K-NX+NB-1 ) / NB )*NB )
*
*        Set A(m-kk+1:m,1:n-kk) to zero.
*
         DO 20 J = 1, N - KK
            DO 10 I = M - KK + 1, M
               A( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE
         KK = 0
      END IF
*
*     Use unblocked code for the first or only block.
*
      CALL DORG2L( M-KK, N-KK, K-KK, A, LDA, TAU, WORK, IINFO )
*
      IF( KK.GT.0 ) THEN
*
*        Use blocked code
*
         DO 50 I = K - KK + 1, K, NB
            IB = MIN( NB, K-I+1 )
            IF( N-K+I.GT.1 ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i+ib-1) . . . H(i+1) H(i)
*
               CALL DLARFT( 'Backward', 'Columnwise', M-K+I+IB-1, IB,
     $                      A( 1, N-K+I ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H to A(1:m-k+i+ib-1,1:n-k+i-1) from the left
*
               CALL DLARFB( 'Left', 'No transpose', 'Backward',
     $                      'Columnwise', M-K+I+IB-1, N-K+I-1, IB,
     $                      A( 1, N-K+I ), LDA, WORK, LDWORK, A, LDA,
     $                      WORK( IB+1 ), LDWORK )
            END IF
*
*           Apply H to rows 1:m-k+i+ib-1 of current block
*
            CALL DORG2L( M-K+I+IB-1, IB, IB, A( 1, N-K+I ), LDA,
     $                   TAU( I ), WORK, IINFO )
*
*           Set rows m-k+i+ib:m of current block to zero
*
            DO 40 J = N - K + I, N - K + I + IB - 1
               DO 30 L = M - K + I + IB, M
                  A( L, J ) = ZERO
   30          CONTINUE
   40       CONTINUE
   50    CONTINUE
      END IF
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of DORGQL
*
      END
* DECK dorgqr.f
      SUBROUTINE DORGQR( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORGQR generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*
*        Q  =  H(1) H(2) . . . H(k)
*
*  as returned by DGEQRF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. M >= N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. N >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the i-th column must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by DGEQRF in the first k columns of its array
*          argument A.
*          On exit, the M-by-N matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQRF.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,N).
*          For optimum performance LWORK >= N*NB, where NB is the
*          optimal blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IB, IINFO, IWS, J, KI, KK, L, LDWORK, NB,
     $                   NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARFB, DLARFT, DORG2R, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGQR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.
*
      NB = ILAENV( 1, 'DORGQR', ' ', M, N, K, -1 )
      NBMIN = 2
      NX = 0
      IWS = N
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'DORGQR', ' ', M, N, K, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = N
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'DORGQR', ' ', M, N, K, -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code after the last block.
*        The first kk columns are handled by the block method.
*
         KI = ( ( K-NX-1 ) / NB )*NB
         KK = MIN( K, KI+NB )
*
*        Set A(1:kk,kk+1:n) to zero.
*
         DO 20 J = KK + 1, N
            DO 10 I = 1, KK
               A( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE
         KK = 0
      END IF
*
*     Use unblocked code for the last or only block.
*
      IF( KK.LT.N )
     $   CALL DORG2R( M-KK, N-KK, K-KK, A( KK+1, KK+1 ), LDA,
     $                TAU( KK+1 ), WORK, IINFO )
*
      IF( KK.GT.0 ) THEN
*
*        Use blocked code
*
         DO 50 I = KI + 1, 1, -NB
            IB = MIN( NB, K-I+1 )
            IF( I+IB.LE.N ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i) H(i+1) . . . H(i+ib-1)
*
               CALL DLARFT( 'Forward', 'Columnwise', M-I+1, IB,
     $                      A( I, I ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H to A(i:m,i+ib:n) from the left
*
               CALL DLARFB( 'Left', 'No transpose', 'Forward',
     $                      'Columnwise', M-I+1, N-I-IB+1, IB,
     $                      A( I, I ), LDA, WORK, LDWORK, A( I, I+IB ),
     $                      LDA, WORK( IB+1 ), LDWORK )
            END IF
*
*           Apply H to rows i:m of current block
*
            CALL DORG2R( M-I+1, IB, IB, A( I, I ), LDA, TAU( I ), WORK,
     $                   IINFO )
*
*           Set rows 1:i-1 of current block to zero
*
            DO 40 J = I, I + IB - 1
               DO 30 L = 1, I - 1
                  A( L, J ) = ZERO
   30          CONTINUE
   40       CONTINUE
   50    CONTINUE
      END IF
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of DORGQR
*
      END
* DECK dorgr2.f
      SUBROUTINE DORGR2( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORGR2 generates an m by n real matrix Q with orthonormal rows,
*  which is defined as the last m rows of a product of k elementary
*  reflectors of order n
*
*        Q  =  H(1) H(2) . . . H(k)
*
*  as returned by DGERQF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. N >= M.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. M >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the (m-k+i)-th row must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by DGERQF in the last k rows of its array argument
*          A.
*          On exit, the m by n matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGERQF.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (M)
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, II, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGR2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.LE.0 )
     $   RETURN
*
      IF( K.LT.M ) THEN
*
*        Initialise rows 1:m-k to rows of the unit matrix
*
         DO 20 J = 1, N
            DO 10 L = 1, M - K
               A( L, J ) = ZERO
   10       CONTINUE
            IF( J.GT.N-M .AND. J.LE.N-K )
     $         A( M-N+J, J ) = ONE
   20    CONTINUE
      END IF
*
      DO 40 I = 1, K
         II = M - K + I
*
*        Apply H(i) to A(1:m-k+i,1:n-k+i) from the right
*
         A( II, N-M+II ) = ONE
         CALL DLARF( 'Right', II-1, N-M+II, A( II, 1 ), LDA, TAU( I ),
     $               A, LDA, WORK )
         CALL DSCAL( N-M+II-1, -TAU( I ), A( II, 1 ), LDA )
         A( II, N-M+II ) = ONE - TAU( I )
*
*        Set A(m-k+i,n-k+i+1:n) to zero
*
         DO 30 L = N - M + II + 1, N
            A( II, L ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of DORGR2
*
      END
* DECK dorgrq.f
      SUBROUTINE DORGRQ( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORGRQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*
*        Q  =  H(1) H(2) . . . H(k)
*
*  as returned by DGERQF.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix Q. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix Q. N >= M.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines the
*          matrix Q. M >= K >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the (m-k+i)-th row must contain the vector which
*          defines the elementary reflector H(i), for i = 1,2,...,k, as
*          returned by DGERQF in the last k rows of its array argument
*          A.
*          On exit, the M-by-N matrix Q.
*
*  LDA     (input) INTEGER
*          The first dimension of the array A. LDA >= max(1,M).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGERQF.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,M).
*          For optimum performance LWORK >= M*NB, where NB is the
*          optimal blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument has an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IB, II, IINFO, IWS, J, KK, L, LDWORK, NB,
     $                   NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARFB, DLARFT, DORGR2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.M ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, M ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGRQ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.LE.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.
*
      NB = ILAENV( 1, 'DORGRQ', ' ', M, N, K, -1 )
      NBMIN = 2
      NX = 0
      IWS = M
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'DORGRQ', ' ', M, N, K, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = M
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'DORGRQ', ' ', M, N, K, -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code after the first block.
*        The last kk rows are handled by the block method.
*
         KK = MIN( K, ( ( K-NX+NB-1 ) / NB )*NB )
*
*        Set A(1:m-kk,n-kk+1:n) to zero.
*
         DO 20 J = N - KK + 1, N
            DO 10 I = 1, M - KK
               A( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE
         KK = 0
      END IF
*
*     Use unblocked code for the first or only block.
*
      CALL DORGR2( M-KK, N-KK, K-KK, A, LDA, TAU, WORK, IINFO )
*
      IF( KK.GT.0 ) THEN
*
*        Use blocked code
*
         DO 50 I = K - KK + 1, K, NB
            IB = MIN( NB, K-I+1 )
            II = M - K + I
            IF( II.GT.1 ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i+ib-1) . . . H(i+1) H(i)
*
               CALL DLARFT( 'Backward', 'Rowwise', N-K+I+IB-1, IB,
     $                      A( II, 1 ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H' to A(1:m-k+i-1,1:n-k+i+ib-1) from the right
*
               CALL DLARFB( 'Right', 'Transpose', 'Backward', 'Rowwise',
     $                      II-1, N-K+I+IB-1, IB, A( II, 1 ), LDA, WORK,
     $                      LDWORK, A, LDA, WORK( IB+1 ), LDWORK )
            END IF
*
*           Apply H' to columns 1:n-k+i+ib-1 of current block
*
            CALL DORGR2( IB, N-K+I+IB-1, IB, A( II, 1 ), LDA, TAU( I ),
     $                   WORK, IINFO )
*
*           Set columns n-k+i+ib:n of current block to zero
*
            DO 40 L = N - K + I + IB, N
               DO 30 J = II, II + IB - 1
                  A( J, L ) = ZERO
   30          CONTINUE
   40       CONTINUE
   50    CONTINUE
      END IF
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of DORGRQ
*
      END
* DECK dorgtr.f
      SUBROUTINE DORGTR( UPLO, N, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORGTR generates a real orthogonal matrix Q which is defined as the
*  product of n-1 elementary reflectors of order N, as returned by
*  DSYTRD:
*
*  if UPLO = 'U', Q = H(n-1) . . . H(2) H(1),
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(n-1).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangle of A contains elementary reflectors
*                 from DSYTRD;
*          = 'L': Lower triangle of A contains elementary reflectors
*                 from DSYTRD.
*
*  N       (input) INTEGER
*          The order of the matrix Q. N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the vectors which define the elementary reflectors,
*          as returned by DSYTRD.
*          On exit, the N-by-N orthogonal matrix Q.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,N).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (N-1)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DSYTRD.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= max(1,N-1).
*          For optimum performance LWORK >= (N-1)*NB, where NB is
*          the optimal blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, IINFO, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORGQL, DORGQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, N-1 ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGTR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to DSYTRD with UPLO = 'U'
*
*        Shift the vectors which define the elementary reflectors one
*        column to the left, and set the last row and column of Q to
*        those of the unit matrix
*
         DO 20 J = 1, N - 1
            DO 10 I = 1, J - 1
               A( I, J ) = A( I, J+1 )
   10       CONTINUE
            A( N, J ) = ZERO
   20    CONTINUE
         DO 30 I = 1, N - 1
            A( I, N ) = ZERO
   30    CONTINUE
         A( N, N ) = ONE
*
*        Generate Q(1:n-1,1:n-1)
*
         CALL DORGQL( N-1, N-1, N-1, A, LDA, TAU, WORK, LWORK, IINFO )
*
      ELSE
*
*        Q was determined by a call to DSYTRD with UPLO = 'L'.
*
*        Shift the vectors which define the elementary reflectors one
*        column to the right, and set the first row and column of Q to
*        those of the unit matrix
*
         DO 50 J = N, 2, -1
            A( 1, J ) = ZERO
            DO 40 I = J + 1, N
               A( I, J ) = A( I, J-1 )
   40       CONTINUE
   50    CONTINUE
         A( 1, 1 ) = ONE
         DO 60 I = 2, N
            A( I, 1 ) = ZERO
   60    CONTINUE
         IF( N.GT.1 ) THEN
*
*           Generate Q(2:n,2:n)
*
            CALL DORGQR( N-1, N-1, N-1, A( 2, 2 ), LDA, TAU, WORK,
     $                   LWORK, IINFO )
         END IF
      END IF
      RETURN
*
*     End of DORGTR
*
      END
* DECK dorm2l.f
      SUBROUTINE DORM2L( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORM2L overwrites the general real m by n matrix C with
*
*        Q * C  if SIDE = 'L' and TRANS = 'N', or
*
*        Q'* C  if SIDE = 'L' and TRANS = 'T', or
*
*        C * Q  if SIDE = 'R' and TRANS = 'N', or
*
*        C * Q' if SIDE = 'R' and TRANS = 'T',
*
*  where Q is a real orthogonal matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(k) . . . H(2) H(1)
*
*  as returned by DGEQLF. Q is of order m if SIDE = 'L' and of order n
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q' from the Left
*          = 'R': apply Q or Q' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply Q  (No transpose)
*          = 'T': apply Q' (Transpose)
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA,K)
*          The i-th column must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          DGEQLF in the last k columns of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          If SIDE = 'L', LDA >= max(1,M);
*          if SIDE = 'R', LDA >= max(1,N).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQLF.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the m by n matrix C.
*          On exit, C is overwritten by Q*C or Q'*C or C*Q' or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension
*                                   (N) if SIDE = 'L',
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, MI, NI, NQ
      DOUBLE PRECISION   AII
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORM2L', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 )
     $   RETURN
*
      IF( ( LEFT .AND. NOTRAN ) .OR. ( .NOT.LEFT .AND. .NOT.NOTRAN ) )
     $     THEN
         I1 = 1
         I2 = K
         I3 = 1
      ELSE
         I1 = K
         I2 = 1
         I3 = -1
      END IF
*
      IF( LEFT ) THEN
         NI = N
      ELSE
         MI = M
      END IF
*
      DO 10 I = I1, I2, I3
         IF( LEFT ) THEN
*
*           H(i) is applied to C(1:m-k+i,1:n)
*
            MI = M - K + I
         ELSE
*
*           H(i) is applied to C(1:m,1:n-k+i)
*
            NI = N - K + I
         END IF
*
*        Apply H(i)
*
         AII = A( NQ-K+I, I )
         A( NQ-K+I, I ) = ONE
         CALL DLARF( SIDE, MI, NI, A( 1, I ), 1, TAU( I ), C, LDC,
     $               WORK )
         A( NQ-K+I, I ) = AII
   10 CONTINUE
      RETURN
*
*     End of DORM2L
*
      END
* DECK dorm2r.f
      SUBROUTINE DORM2R( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORM2R overwrites the general real m by n matrix C with
*
*        Q * C  if SIDE = 'L' and TRANS = 'N', or
*
*        Q'* C  if SIDE = 'L' and TRANS = 'T', or
*
*        C * Q  if SIDE = 'R' and TRANS = 'N', or
*
*        C * Q' if SIDE = 'R' and TRANS = 'T',
*
*  where Q is a real orthogonal matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(1) H(2) . . . H(k)
*
*  as returned by DGEQRF. Q is of order m if SIDE = 'L' and of order n
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q' from the Left
*          = 'R': apply Q or Q' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply Q  (No transpose)
*          = 'T': apply Q' (Transpose)
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA,K)
*          The i-th column must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          DGEQRF in the first k columns of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          If SIDE = 'L', LDA >= max(1,M);
*          if SIDE = 'R', LDA >= max(1,N).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQRF.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the m by n matrix C.
*          On exit, C is overwritten by Q*C or Q'*C or C*Q' or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension
*                                   (N) if SIDE = 'L',
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, IC, JC, MI, NI, NQ
      DOUBLE PRECISION   AII
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORM2R', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 )
     $   RETURN
*
      IF( ( LEFT .AND. .NOT.NOTRAN ) .OR. ( .NOT.LEFT .AND. NOTRAN ) )
     $     THEN
         I1 = 1
         I2 = K
         I3 = 1
      ELSE
         I1 = K
         I2 = 1
         I3 = -1
      END IF
*
      IF( LEFT ) THEN
         NI = N
         JC = 1
      ELSE
         MI = M
         IC = 1
      END IF
*
      DO 10 I = I1, I2, I3
         IF( LEFT ) THEN
*
*           H(i) is applied to C(i:m,1:n)
*
            MI = M - I + 1
            IC = I
         ELSE
*
*           H(i) is applied to C(1:m,i:n)
*
            NI = N - I + 1
            JC = I
         END IF
*
*        Apply H(i)
*
         AII = A( I, I )
         A( I, I ) = ONE
         CALL DLARF( SIDE, MI, NI, A( I, I ), 1, TAU( I ), C( IC, JC ),
     $               LDC, WORK )
         A( I, I ) = AII
   10 CONTINUE
      RETURN
*
*     End of DORM2R
*
      END
* DECK dormbr.f
      SUBROUTINE DORMBR( VECT, SIDE, TRANS, M, N, K, A, LDA, TAU, C,
     $                   LDC, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS, VECT
      INTEGER            INFO, K, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  If VECT = 'Q', DORMBR overwrites the general real M-by-N matrix C
*  with
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  If VECT = 'P', DORMBR overwrites the general real M-by-N matrix C
*  with
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      P * C          C * P
*  TRANS = 'T':      P**T * C       C * P**T
*
*  Here Q and P**T are the orthogonal matrices determined by DGEBRD when
*  reducing a real matrix A to bidiagonal form: A = Q * B * P**T. Q and
*  P**T are defined as products of elementary reflectors H(i) and G(i)
*  respectively.
*
*  Let nq = m if SIDE = 'L' and nq = n if SIDE = 'R'. Thus nq is the
*  order of the orthogonal matrix Q or P**T that is applied.
*
*  If VECT = 'Q', A is assumed to have been an NQ-by-K matrix:
*  if nq >= k, Q = H(1) H(2) . . . H(k);
*  if nq < k, Q = H(1) H(2) . . . H(nq-1).
*
*  If VECT = 'P', A is assumed to have been a K-by-NQ matrix:
*  if k < nq, P = G(1) G(2) . . . G(k);
*  if k >= nq, P = G(1) G(2) . . . G(nq-1).
*
*  Arguments
*  =========
*
*  VECT    (input) CHARACTER*1
*          = 'Q': apply Q or Q**T;
*          = 'P': apply P or P**T.
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q, Q**T, P or P**T from the Left;
*          = 'R': apply Q, Q**T, P or P**T from the Right.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q  or P;
*          = 'T':  Transpose, apply Q**T or P**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          If VECT = 'Q', the number of columns in the original
*          matrix reduced by DGEBRD.
*          If VECT = 'P', the number of rows in the original
*          matrix reduced by DGEBRD.
*          K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension
*                                (LDA,min(nq,K)) if VECT = 'Q'
*                                (LDA,nq)        if VECT = 'P'
*          The vectors which define the elementary reflectors H(i) and
*          G(i), whose products determine the matrices Q and P, as
*          returned by DGEBRD.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          If VECT = 'Q', LDA >= max(1,nq);
*          if VECT = 'P', LDA >= max(1,min(nq,K)).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (min(nq,K))
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i) or G(i) which determines Q or P, as returned
*          by DGEBRD in the array argument TAUQ or TAUP.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q
*          or P*C or P**T*C or C*P or C*P**T.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            APPLYQ, LEFT, NOTRAN
      CHARACTER          TRANST
      INTEGER            I1, I2, IINFO, MI, NI, NQ, NW
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORMLQ, DORMQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      APPLYQ = LSAME( VECT, 'Q' )
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q or P and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.APPLYQ .AND. .NOT.LSAME( VECT, 'P' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( K.LT.0 ) THEN
         INFO = -6
      ELSE IF( ( APPLYQ .AND. LDA.LT.MAX( 1, NQ ) ) .OR.
     $         ( .NOT.APPLYQ .AND. LDA.LT.MAX( 1, MIN( NQ, K ) ) ) )
     $          THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      ELSE IF( LWORK.LT.MAX( 1, NW ) ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMBR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      WORK( 1 ) = 1
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
      IF( APPLYQ ) THEN
*
*        Apply Q
*
         IF( NQ.GE.K ) THEN
*
*           Q was determined by a call to DGEBRD with nq >= k
*
            CALL DORMQR( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, IINFO )
         ELSE IF( NQ.GT.1 ) THEN
*
*           Q was determined by a call to DGEBRD with nq < k
*
            IF( LEFT ) THEN
               MI = M - 1
               NI = N
               I1 = 2
               I2 = 1
            ELSE
               MI = M
               NI = N - 1
               I1 = 1
               I2 = 2
            END IF
            CALL DORMQR( SIDE, TRANS, MI, NI, NQ-1, A( 2, 1 ), LDA, TAU,
     $                   C( I1, I2 ), LDC, WORK, LWORK, IINFO )
         END IF
      ELSE
*
*        Apply P
*
         IF( NOTRAN ) THEN
            TRANST = 'T'
         ELSE
            TRANST = 'N'
         END IF
         IF( NQ.GT.K ) THEN
*
*           P was determined by a call to DGEBRD with nq > k
*
            CALL DORMLQ( SIDE, TRANST, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, IINFO )
         ELSE IF( NQ.GT.1 ) THEN
*
*           P was determined by a call to DGEBRD with nq <= k
*
            IF( LEFT ) THEN
               MI = M - 1
               NI = N
               I1 = 2
               I2 = 1
            ELSE
               MI = M
               NI = N - 1
               I1 = 1
               I2 = 2
            END IF
            CALL DORMLQ( SIDE, TRANST, MI, NI, NQ-1, A( 1, 2 ), LDA,
     $                   TAU, C( I1, I2 ), LDC, WORK, LWORK, IINFO )
         END IF
      END IF
      RETURN
*
*     End of DORMBR
*
      END
* DECK dormhr.f
      SUBROUTINE DORMHR( SIDE, TRANS, M, N, ILO, IHI, A, LDA, TAU, C,
     $                   LDC, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            IHI, ILO, INFO, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORMHR overwrites the general real M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  where Q is a real orthogonal matrix of order nq, with nq = m if
*  SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*  IHI-ILO elementary reflectors, as returned by DGEHRD:
*
*  Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**T from the Left;
*          = 'R': apply Q or Q**T from the Right.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'T':  Transpose, apply Q**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          ILO and IHI must have the same values as in the previous call
*          of DGEHRD. Q is equal to the unit matrix except in the
*          submatrix Q(ilo+1:ihi,ilo+1:ihi).
*          If SIDE = 'L', then 1 <= ILO <= IHI <= M, if M > 0, and
*          ILO = 1 and IHI = 0, if M = 0;
*          if SIDE = 'R', then 1 <= ILO <= IHI <= N, if N > 0, and
*          ILO = 1 and IHI = 0, if N = 0.
*
*  A       (input) DOUBLE PRECISION array, dimension
*                               (LDA,M) if SIDE = 'L'
*                               (LDA,N) if SIDE = 'R'
*          The vectors which define the elementary reflectors, as
*          returned by DGEHRD.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          LDA >= max(1,M) if SIDE = 'L'; LDA >= max(1,N) if SIDE = 'R'.
*
*  TAU     (input) DOUBLE PRECISION array, dimension
*                               (M-1) if SIDE = 'L'
*                               (N-1) if SIDE = 'R'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEHRD.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LEFT
      INTEGER            I1, I2, IINFO, MI, NH, NI, NQ, NW
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORMQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.LSAME( TRANS, 'T' ) )
     $          THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, NQ ) ) THEN
         INFO = -5
      ELSE IF( IHI.LT.MIN( ILO, NQ ) .OR. IHI.GT.NQ ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      ELSE IF( LWORK.LT.MAX( 1, NW ) ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMHR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      NH = IHI - ILO
      IF( M.EQ.0 .OR. N.EQ.0 .OR. NH.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( LEFT ) THEN
         MI = NH
         NI = N
         I1 = ILO + 1
         I2 = 1
      ELSE
         MI = M
         NI = NH
         I1 = 1
         I2 = ILO + 1
      END IF
*
      CALL DORMQR( SIDE, TRANS, MI, NI, NH, A( ILO+1, ILO ), LDA,
     $             TAU( ILO ), C( I1, I2 ), LDC, WORK, LWORK, IINFO )
      RETURN
*
*     End of DORMHR
*
      END
* DECK dorml2.f
      SUBROUTINE DORML2( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORML2 overwrites the general real m by n matrix C with
*
*        Q * C  if SIDE = 'L' and TRANS = 'N', or
*
*        Q'* C  if SIDE = 'L' and TRANS = 'T', or
*
*        C * Q  if SIDE = 'R' and TRANS = 'N', or
*
*        C * Q' if SIDE = 'R' and TRANS = 'T',
*
*  where Q is a real orthogonal matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(k) . . . H(2) H(1)
*
*  as returned by DGELQF. Q is of order m if SIDE = 'L' and of order n
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q' from the Left
*          = 'R': apply Q or Q' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply Q  (No transpose)
*          = 'T': apply Q' (Transpose)
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension
*                               (LDA,M) if SIDE = 'L',
*                               (LDA,N) if SIDE = 'R'
*          The i-th row must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          DGELQF in the first k rows of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,K).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGELQF.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the m by n matrix C.
*          On exit, C is overwritten by Q*C or Q'*C or C*Q' or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension
*                                   (N) if SIDE = 'L',
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, IC, JC, MI, NI, NQ
      DOUBLE PRECISION   AII
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, K ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORML2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 )
     $   RETURN
*
      IF( ( LEFT .AND. NOTRAN ) .OR. ( .NOT.LEFT .AND. .NOT.NOTRAN ) )
     $     THEN
         I1 = 1
         I2 = K
         I3 = 1
      ELSE
         I1 = K
         I2 = 1
         I3 = -1
      END IF
*
      IF( LEFT ) THEN
         NI = N
         JC = 1
      ELSE
         MI = M
         IC = 1
      END IF
*
      DO 10 I = I1, I2, I3
         IF( LEFT ) THEN
*
*           H(i) is applied to C(i:m,1:n)
*
            MI = M - I + 1
            IC = I
         ELSE
*
*           H(i) is applied to C(1:m,i:n)
*
            NI = N - I + 1
            JC = I
         END IF
*
*        Apply H(i)
*
         AII = A( I, I )
         A( I, I ) = ONE
         CALL DLARF( SIDE, MI, NI, A( I, I ), LDA, TAU( I ),
     $               C( IC, JC ), LDC, WORK )
         A( I, I ) = AII
   10 CONTINUE
      RETURN
*
*     End of DORML2
*
      END
* DECK dormlq.f
      SUBROUTINE DORMLQ( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORMLQ overwrites the general real M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  where Q is a real orthogonal matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(k) . . . H(2) H(1)
*
*  as returned by DGELQF. Q is of order M if SIDE = 'L' and of order N
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**T from the Left;
*          = 'R': apply Q or Q**T from the Right.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'T':  Transpose, apply Q**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension
*                               (LDA,M) if SIDE = 'L',
*                               (LDA,N) if SIDE = 'R'
*          The i-th row must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          DGELQF in the first k rows of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,K).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGELQF.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NBMAX, LDT
      PARAMETER          ( NBMAX = 64, LDT = NBMAX+1 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      CHARACTER          TRANST
      INTEGER            I, I1, I2, I3, IB, IC, IINFO, IWS, JC, LDWORK,
     $                   MI, NB, NBMIN, NI, NQ, NW
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   T( LDT, NBMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARFB, DLARFT, DORML2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, K ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LWORK.LT.MAX( 1, NW ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMLQ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.  NB may be at most NBMAX, where NBMAX
*     is used to define the local array T.
*
      NB = MIN( NBMAX, ILAENV( 1, 'DORMLQ', SIDE // TRANS, M, N, K,
     $     -1 ) )
      NBMIN = 2
      LDWORK = NW
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
         IWS = NW*NB
         IF( LWORK.LT.IWS ) THEN
            NB = LWORK / LDWORK
            NBMIN = MAX( 2, ILAENV( 2, 'DORMLQ', SIDE // TRANS, M, N, K,
     $              -1 ) )
         END IF
      ELSE
         IWS = NW
      END IF
*
      IF( NB.LT.NBMIN .OR. NB.GE.K ) THEN
*
*        Use unblocked code
*
         CALL DORML2( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC, WORK,
     $                IINFO )
      ELSE
*
*        Use blocked code
*
         IF( ( LEFT .AND. NOTRAN ) .OR.
     $       ( .NOT.LEFT .AND. .NOT.NOTRAN ) ) THEN
            I1 = 1
            I2 = K
            I3 = NB
         ELSE
            I1 = ( ( K-1 ) / NB )*NB + 1
            I2 = 1
            I3 = -NB
         END IF
*
         IF( LEFT ) THEN
            NI = N
            JC = 1
         ELSE
            MI = M
            IC = 1
         END IF
*
         IF( NOTRAN ) THEN
            TRANST = 'T'
         ELSE
            TRANST = 'N'
         END IF
*
         DO 10 I = I1, I2, I3
            IB = MIN( NB, K-I+1 )
*
*           Form the triangular factor of the block reflector
*           H = H(i) H(i+1) . . . H(i+ib-1)
*
            CALL DLARFT( 'Forward', 'Rowwise', NQ-I+1, IB, A( I, I ),
     $                   LDA, TAU( I ), T, LDT )
            IF( LEFT ) THEN
*
*              H or H' is applied to C(i:m,1:n)
*
               MI = M - I + 1
               IC = I
            ELSE
*
*              H or H' is applied to C(1:m,i:n)
*
               NI = N - I + 1
               JC = I
            END IF
*
*           Apply H or H'
*
            CALL DLARFB( SIDE, TRANST, 'Forward', 'Rowwise', MI, NI, IB,
     $                   A( I, I ), LDA, T, LDT, C( IC, JC ), LDC, WORK,
     $                   LDWORK )
   10    CONTINUE
      END IF
      WORK( 1 ) = IWS
      RETURN
*
*     End of DORMLQ
*
      END
* DECK dormql.f
      SUBROUTINE DORMQL( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORMQL overwrites the general real M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  where Q is a real orthogonal matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(k) . . . H(2) H(1)
*
*  as returned by DGEQLF. Q is of order M if SIDE = 'L' and of order N
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**T from the Left;
*          = 'R': apply Q or Q**T from the Right.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'T':  Transpose, apply Q**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA,K)
*          The i-th column must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          DGEQLF in the last k columns of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          If SIDE = 'L', LDA >= max(1,M);
*          if SIDE = 'R', LDA >= max(1,N).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQLF.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NBMAX, LDT
      PARAMETER          ( NBMAX = 64, LDT = NBMAX+1 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, IB, IINFO, IWS, LDWORK, MI, NB,
     $                   NBMIN, NI, NQ, NW
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   T( LDT, NBMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARFB, DLARFT, DORM2L, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LWORK.LT.MAX( 1, NW ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMQL', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.  NB may be at most NBMAX, where NBMAX
*     is used to define the local array T.
*
      NB = MIN( NBMAX, ILAENV( 1, 'DORMQL', SIDE // TRANS, M, N, K,
     $     -1 ) )
      NBMIN = 2
      LDWORK = NW
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
         IWS = NW*NB
         IF( LWORK.LT.IWS ) THEN
            NB = LWORK / LDWORK
            NBMIN = MAX( 2, ILAENV( 2, 'DORMQL', SIDE // TRANS, M, N, K,
     $              -1 ) )
         END IF
      ELSE
         IWS = NW
      END IF
*
      IF( NB.LT.NBMIN .OR. NB.GE.K ) THEN
*
*        Use unblocked code
*
         CALL DORM2L( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC, WORK,
     $                IINFO )
      ELSE
*
*        Use blocked code
*
         IF( ( LEFT .AND. NOTRAN ) .OR.
     $       ( .NOT.LEFT .AND. .NOT.NOTRAN ) ) THEN
            I1 = 1
            I2 = K
            I3 = NB
         ELSE
            I1 = ( ( K-1 ) / NB )*NB + 1
            I2 = 1
            I3 = -NB
         END IF
*
         IF( LEFT ) THEN
            NI = N
         ELSE
            MI = M
         END IF
*
         DO 10 I = I1, I2, I3
            IB = MIN( NB, K-I+1 )
*
*           Form the triangular factor of the block reflector
*           H = H(i+ib-1) . . . H(i+1) H(i)
*
            CALL DLARFT( 'Backward', 'Columnwise', NQ-K+I+IB-1, IB,
     $                   A( 1, I ), LDA, TAU( I ), T, LDT )
            IF( LEFT ) THEN
*
*              H or H' is applied to C(1:m-k+i+ib-1,1:n)
*
               MI = M - K + I + IB - 1
            ELSE
*
*              H or H' is applied to C(1:m,1:n-k+i+ib-1)
*
               NI = N - K + I + IB - 1
            END IF
*
*           Apply H or H'
*
            CALL DLARFB( SIDE, TRANS, 'Backward', 'Columnwise', MI, NI,
     $                   IB, A( 1, I ), LDA, T, LDT, C, LDC, WORK,
     $                   LDWORK )
   10    CONTINUE
      END IF
      WORK( 1 ) = IWS
      RETURN
*
*     End of DORMQL
*
      END
* DECK dormqr.f
      SUBROUTINE DORMQR( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORMQR overwrites the general real M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  where Q is a real orthogonal matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(1) H(2) . . . H(k)
*
*  as returned by DGEQRF. Q is of order M if SIDE = 'L' and of order N
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**T from the Left;
*          = 'R': apply Q or Q**T from the Right.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'T':  Transpose, apply Q**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA,K)
*          The i-th column must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          DGEQRF in the first k columns of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          If SIDE = 'L', LDA >= max(1,M);
*          if SIDE = 'R', LDA >= max(1,N).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGEQRF.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NBMAX, LDT
      PARAMETER          ( NBMAX = 64, LDT = NBMAX+1 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, IB, IC, IINFO, IWS, JC, LDWORK,
     $                   MI, NB, NBMIN, NI, NQ, NW
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   T( LDT, NBMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARFB, DLARFT, DORM2R, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LWORK.LT.MAX( 1, NW ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMQR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.  NB may be at most NBMAX, where NBMAX
*     is used to define the local array T.
*
      NB = MIN( NBMAX, ILAENV( 1, 'DORMQR', SIDE // TRANS, M, N, K,
     $     -1 ) )
      NBMIN = 2
      LDWORK = NW
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
         IWS = NW*NB
         IF( LWORK.LT.IWS ) THEN
            NB = LWORK / LDWORK
            NBMIN = MAX( 2, ILAENV( 2, 'DORMQR', SIDE // TRANS, M, N, K,
     $              -1 ) )
         END IF
      ELSE
         IWS = NW
      END IF
*
      IF( NB.LT.NBMIN .OR. NB.GE.K ) THEN
*
*        Use unblocked code
*
         CALL DORM2R( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC, WORK,
     $                IINFO )
      ELSE
*
*        Use blocked code
*
         IF( ( LEFT .AND. .NOT.NOTRAN ) .OR.
     $       ( .NOT.LEFT .AND. NOTRAN ) ) THEN
            I1 = 1
            I2 = K
            I3 = NB
         ELSE
            I1 = ( ( K-1 ) / NB )*NB + 1
            I2 = 1
            I3 = -NB
         END IF
*
         IF( LEFT ) THEN
            NI = N
            JC = 1
         ELSE
            MI = M
            IC = 1
         END IF
*
         DO 10 I = I1, I2, I3
            IB = MIN( NB, K-I+1 )
*
*           Form the triangular factor of the block reflector
*           H = H(i) H(i+1) . . . H(i+ib-1)
*
            CALL DLARFT( 'Forward', 'Columnwise', NQ-I+1, IB, A( I, I ),
     $                   LDA, TAU( I ), T, LDT )
            IF( LEFT ) THEN
*
*              H or H' is applied to C(i:m,1:n)
*
               MI = M - I + 1
               IC = I
            ELSE
*
*              H or H' is applied to C(1:m,i:n)
*
               NI = N - I + 1
               JC = I
            END IF
*
*           Apply H or H'
*
            CALL DLARFB( SIDE, TRANS, 'Forward', 'Columnwise', MI, NI,
     $                   IB, A( I, I ), LDA, T, LDT, C( IC, JC ), LDC,
     $                   WORK, LDWORK )
   10    CONTINUE
      END IF
      WORK( 1 ) = IWS
      RETURN
*
*     End of DORMQR
*
      END
* DECK dormr2.f
      SUBROUTINE DORMR2( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DORMR2 overwrites the general real m by n matrix C with
*
*        Q * C  if SIDE = 'L' and TRANS = 'N', or
*
*        Q'* C  if SIDE = 'L' and TRANS = 'T', or
*
*        C * Q  if SIDE = 'R' and TRANS = 'N', or
*
*        C * Q' if SIDE = 'R' and TRANS = 'T',
*
*  where Q is a real orthogonal matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(1) H(2) . . . H(k)
*
*  as returned by DGERQF. Q is of order m if SIDE = 'L' and of order n
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q' from the Left
*          = 'R': apply Q or Q' from the Right
*
*  TRANS   (input) CHARACTER*1
*          = 'N': apply Q  (No transpose)
*          = 'T': apply Q' (Transpose)
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension
*                               (LDA,M) if SIDE = 'L',
*                               (LDA,N) if SIDE = 'R'
*          The i-th row must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          DGERQF in the last k rows of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,K).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGERQF.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the m by n matrix C.
*          On exit, C is overwritten by Q*C or Q'*C or C*Q' or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension
*                                   (N) if SIDE = 'L',
*                                   (M) if SIDE = 'R'
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, MI, NI, NQ
      DOUBLE PRECISION   AII
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, K ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMR2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 )
     $   RETURN
*
      IF( ( LEFT .AND. .NOT.NOTRAN ) .OR. ( .NOT.LEFT .AND. NOTRAN ) )
     $     THEN
         I1 = 1
         I2 = K
         I3 = 1
      ELSE
         I1 = K
         I2 = 1
         I3 = -1
      END IF
*
      IF( LEFT ) THEN
         NI = N
      ELSE
         MI = M
      END IF
*
      DO 10 I = I1, I2, I3
         IF( LEFT ) THEN
*
*           H(i) is applied to C(1:m-k+i,1:n)
*
            MI = M - K + I
         ELSE
*
*           H(i) is applied to C(1:m,1:n-k+i)
*
            NI = N - K + I
         END IF
*
*        Apply H(i)
*
         AII = A( I, NQ-K+I )
         A( I, NQ-K+I ) = ONE
         CALL DLARF( SIDE, MI, NI, A( I, 1 ), LDA, TAU( I ), C, LDC,
     $               WORK )
         A( I, NQ-K+I ) = AII
   10 CONTINUE
      RETURN
*
*     End of DORMR2
*
      END
* DECK dormrq.f
      SUBROUTINE DORMRQ( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORMRQ overwrites the general real M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  where Q is a real orthogonal matrix defined as the product of k
*  elementary reflectors
*
*        Q = H(1) H(2) . . . H(k)
*
*  as returned by DGERQF. Q is of order M if SIDE = 'L' and of order N
*  if SIDE = 'R'.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**T from the Left;
*          = 'R': apply Q or Q**T from the Right.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'T':  Transpose, apply Q**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  K       (input) INTEGER
*          The number of elementary reflectors whose product defines
*          the matrix Q.
*          If SIDE = 'L', M >= K >= 0;
*          if SIDE = 'R', N >= K >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension
*                               (LDA,M) if SIDE = 'L',
*                               (LDA,N) if SIDE = 'R'
*          The i-th row must contain the vector which defines the
*          elementary reflector H(i), for i = 1,2,...,k, as returned by
*          DGERQF in the last k rows of its array argument A.
*          A is modified by the routine but restored on exit.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,K).
*
*  TAU     (input) DOUBLE PRECISION array, dimension (K)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DGERQF.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NBMAX, LDT
      PARAMETER          ( NBMAX = 64, LDT = NBMAX+1 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      CHARACTER          TRANST
      INTEGER            I, I1, I2, I3, IB, IINFO, IWS, LDWORK, MI, NB,
     $                   NBMIN, NI, NQ, NW
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   T( LDT, NBMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARFB, DLARFT, DORMR2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, K ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LWORK.LT.MAX( 1, NW ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMRQ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Determine the block size.  NB may be at most NBMAX, where NBMAX
*     is used to define the local array T.
*
      NB = MIN( NBMAX, ILAENV( 1, 'DORMRQ', SIDE // TRANS, M, N, K,
     $     -1 ) )
      NBMIN = 2
      LDWORK = NW
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
         IWS = NW*NB
         IF( LWORK.LT.IWS ) THEN
            NB = LWORK / LDWORK
            NBMIN = MAX( 2, ILAENV( 2, 'DORMRQ', SIDE // TRANS, M, N, K,
     $              -1 ) )
         END IF
      ELSE
         IWS = NW
      END IF
*
      IF( NB.LT.NBMIN .OR. NB.GE.K ) THEN
*
*        Use unblocked code
*
         CALL DORMR2( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC, WORK,
     $                IINFO )
      ELSE
*
*        Use blocked code
*
         IF( ( LEFT .AND. .NOT.NOTRAN ) .OR.
     $       ( .NOT.LEFT .AND. NOTRAN ) ) THEN
            I1 = 1
            I2 = K
            I3 = NB
         ELSE
            I1 = ( ( K-1 ) / NB )*NB + 1
            I2 = 1
            I3 = -NB
         END IF
*
         IF( LEFT ) THEN
            NI = N
         ELSE
            MI = M
         END IF
*
         IF( NOTRAN ) THEN
            TRANST = 'T'
         ELSE
            TRANST = 'N'
         END IF
*
         DO 10 I = I1, I2, I3
            IB = MIN( NB, K-I+1 )
*
*           Form the triangular factor of the block reflector
*           H = H(i+ib-1) . . . H(i+1) H(i)
*
            CALL DLARFT( 'Backward', 'Rowwise', NQ-K+I+IB-1, IB,
     $                   A( I, 1 ), LDA, TAU( I ), T, LDT )
            IF( LEFT ) THEN
*
*              H or H' is applied to C(1:m-k+i+ib-1,1:n)
*
               MI = M - K + I + IB - 1
            ELSE
*
*              H or H' is applied to C(1:m,1:n-k+i+ib-1)
*
               NI = N - K + I + IB - 1
            END IF
*
*           Apply H or H'
*
            CALL DLARFB( SIDE, TRANST, 'Backward', 'Rowwise', MI, NI,
     $                   IB, A( I, 1 ), LDA, T, LDT, C, LDC, WORK,
     $                   LDWORK )
   10    CONTINUE
      END IF
      WORK( 1 ) = IWS
      RETURN
*
*     End of DORMRQ
*
      END
* DECK dormtr.f
      SUBROUTINE DORMTR( SIDE, UPLO, TRANS, M, N, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS, UPLO
      INTEGER            INFO, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( LWORK )
*     ..
*
*  Purpose
*  =======
*
*  DORMTR overwrites the general real M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'T':      Q**T * C       C * Q**T
*
*  where Q is a real orthogonal matrix of order nq, with nq = m if
*  SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*  nq-1 elementary reflectors, as returned by DSYTRD:
*
*  if UPLO = 'U', Q = H(nq-1) . . . H(2) H(1);
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(nq-1).
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**T from the Left;
*          = 'R': apply Q or Q**T from the Right.
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangle of A contains elementary reflectors
*                 from DSYTRD;
*          = 'L': Lower triangle of A contains elementary reflectors
*                 from DSYTRD.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'T':  Transpose, apply Q**T.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension
*                               (LDA,M) if SIDE = 'L'
*                               (LDA,N) if SIDE = 'R'
*          The vectors which define the elementary reflectors, as
*          returned by DSYTRD.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          LDA >= max(1,M) if SIDE = 'L'; LDA >= max(1,N) if SIDE = 'R'.
*
*  TAU     (input) DOUBLE PRECISION array, dimension
*                               (M-1) if SIDE = 'L'
*                               (N-1) if SIDE = 'R'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by DSYTRD.
*
*  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LEFT, UPPER
      INTEGER            I1, I2, IINFO, MI, NI, NQ, NW
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORMQL, DORMQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      UPPER = LSAME( UPLO, 'U' )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.LSAME( TRANS, 'T' ) )
     $          THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LWORK.LT.MAX( 1, NW ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORMTR', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. NQ.EQ.1 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( LEFT ) THEN
         MI = M - 1
         NI = N
      ELSE
         MI = M
         NI = N - 1
      END IF
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to DSYTRD with UPLO = 'U'
*
         CALL DORMQL( SIDE, TRANS, MI, NI, NQ-1, A( 1, 2 ), LDA, TAU, C,
     $                LDC, WORK, LWORK, IINFO )
      ELSE
*
*        Q was determined by a call to DSYTRD with UPLO = 'L'
*
         IF( LEFT ) THEN
            I1 = 2
            I2 = 1
         ELSE
            I1 = 1
            I2 = 2
         END IF
         CALL DORMQR( SIDE, TRANS, MI, NI, NQ-1, A( 2, 1 ), LDA, TAU,
     $                C( I1, I2 ), LDC, WORK, LWORK, IINFO )
      END IF
      RETURN
*
*     End of DORMTR
*
      END

subroutine class_header(set,r,error)
  use gbl_message
  use classcore_interfaces, except_this=>class_header
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Gives full header information
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(in)    :: r
  logical,             intent(inout) :: error
  !
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,'HEADER','No R spectrum in memory')
    error = .true.
    return
  endif
  !
  call out0('Terminal',0.,0.,error)
  call titout(set,r%head,'F',' ')
  call out1(error)
  !
end subroutine class_header

program uv_track_phase
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !       Task to create a UV table from Station Coordinates and Observation
  ! parameters.
  !---------------------------------------------------------------------
  ! Global
  real :: a_lever
  include 'gbl_pi.inc'
  ! Local
  type(gildas) :: xima,yima,zima
  integer :: mstat, nstat, muv, ier, nc
  parameter (mstat=100, muv=10000)
  real :: x(mstat), xx, yy, zz, sd, cd, sp, cp, h, sh, ch
  real :: y(mstat), z(mstat), extr, zch(muv), zsh(muv), hlim(2)
  real :: hmin, hmax, array, uk, vk, horizon, phase, ph
  real :: uvmin, uvmin2, uv_spacing, diameter, dd, bx(mstat), by(mstat)
  real*8 :: decs,freq,latitud,amat(9),bvec(3),az,el,avec(3),bandwidth
  integer :: i, j, k, kh, lun, count, nvis, nshadow, nfill, ip, ff
  character(len=256) :: chain, file, fstation, phase_screen, cal_file
!  integer(kind=address_length) :: ipa, ipb, ipc, ipx, ipy, ipz
!  integer(kind=address_length) :: addr
  logical :: error,new,complete(mstat),ok,cal(muv)
  real :: integ_time, frac, test, date, bandw
  real :: trec, tsys, tau, jpk, weight, total
  real :: step_time, windangle, windvelo, cal_dist_x, cal_dist_y
  real :: cal_integ, cal_dist, cal_angle, source_integ
  real :: t, time(muv), hour(muv), alt, deadtime, ontime
  real :: sd_cal, cd_cal, sd_sou, cd_sou, dx, dy
  real :: offset, offsetx, offsety, t0, later
  real :: phrad(mstat), phn(mstat), phn0(mstat), phcal(mstat)
  real :: phase_scale, wvr_precis, wvr_noise
  real :: amp, amperror(mstat),amplitude(2), ampli(mstat)
  real :: drift(mstat), tmp, ptg, amp_time
  real :: azerr(mstat), elerr(mstat)
  real*8 :: ra_err(2), dec_err(2)
  integer :: nnx, nny, nh, nh_sou, nh_cal, nshadow_c, nfill_c
  integer :: nshadow_s,nfill_s,next_c,next_s
  parameter (step_time=180.0)
  logical :: first, do_screen, do_calib, do_radiom, do_correct
  logical :: do_anrefr
  !
  !------------------------------------------------------------------------
  !
  trec = 50.0
  tau = 0.1
  first = .true.
  total = 0.0
  !
  ! uv_track
  call gildas_open
  call gildas_dble('DECLINATION$',decs,1)
  call gildas_dble('FREQUENCY$',freq,1)
  call gildas_logi('NEW$',new,1)
  call gildas_char('UV_TABLE$',file)
  call gildas_char('STATION_FILE$',fstation)
  call gildas_real('UV_SPACING$',uv_spacing,1)
  call gildas_real('DIAMETER$',diameter,1)
  call gildas_real('HORIZON$',horizon,1)
  call gildas_dble('LATITUDE$',latitud,1)  ! deg
  call gildas_real('HOUR$',hlim,2)
  call gildas_real('INTEGRATION$',integ_time,1)
  call gildas_real('BANDWIDTH$',bandw,1)
  call gildas_real('TREC$',trec,1)
  call gildas_real('TAU$',tau,1)
  call gildas_real('PHASE$',phase,1)
  ! screen phase
  call gildas_logi('DO_SCREEN$',do_screen,1)
  call gildas_char('PHASE_SCREEN$',phase_screen)
  call gildas_real('PHASE_NOISE$',phase_scale,1)
  call gildas_real('WINDANGLE$',windangle,1)   ! deg
  call gildas_real('WINDVELO$',windvelo,1) ! m/s
  ! calibrator
  call gildas_logi('DO_CALIB$',do_calib,1)
  call gildas_char('CAL_UV_TABLE$',cal_file)
  call gildas_real('DEADTIME$',deadtime,1) ! sec
  call gildas_real('CAL_INTEG$',cal_integ,1)   ! sec
  call gildas_real('SOURCE_INTEG$',source_integ,1) ! sec
  call gildas_real('CAL_DIST$',cal_dist,1) ! deg
  call gildas_real('CAL_ANGLE$',cal_angle,1)   ! deg
  call gildas_real('ALTITUDE$',alt,1)  ! m
  ! wvr correction
  call gildas_logi('DO_RADIOM$',do_radiom,1)
  call gildas_real('WVR_PRECIS$',wvr_precis,1)
  call gildas_real('WVR_NOISE$',wvr_noise,1)
  call gildas_logi('DO_CORRECT$',do_correct,1)
  ! amplitude errors
  call gildas_real('AMPLITUDE$',amplitude,2)
  call gildas_real('AMP_TIME$',amp_time,1) ! sec
  ! anomalous refraction
  call gildas_logi('DO_ANREFR$',do_anrefr,1)
  call gildas_close
  !
  if (do_correct) do_calib = .true.
  !
  ! Current limitation
  if ((.not.new).and.(do_calib)) then
    call gagout('E-UV_TRACK,  Options not compatible')
    stop
  endif
  !
  ! Convert to rad
  decs = decs*pi/180.0
  phase = phase*pi/180.0
  windangle = windangle*pi/180.0
  cal_angle = cal_angle*pi/180.0
  wvr_noise = wvr_noise*pi/180.0
  !
  ! CAL_INTEG and SOURCE_INTEG are in dump, convert in time (sec)
  cal_integ = cal_integ*integ_time
  source_integ = source_integ*integ_time
  !
  ! Translate angular distance into linear distance at altitude alt
  cal_dist = cal_dist*pi/180.0
  cal_dist = alt*tan(cal_dist)
  !
  ! Output uvt file: source
  chain = file
  call sic_parsef(chain,file,' ','.uvt')
  call gagout('W-UV_TRACK,  Source table name '   &
     &    //file(1:lenc(file)))
  !
  ! Ouput uvt file: calibrator
  if (do_calib) then
    chain = cal_file
    call sic_parsef(chain,cal_file,' ','.uvt')
    call gagout('W-UV_TRACK,  Calibrator table name '   &
     &      //cal_file(1:lenc(cal_file)))
  endif
  !
  ! Use all stations in station file
  chain = fstation
  ier = sic_getlog(chain)
  call sic_parsef (chain,fstation,' ','.dat')
  !
  ! Antenna Diameter and Min UV spacing
  if (diameter.eq.0) then
    call gagout ('W-UV_TRACKS,  Antenna size unknown. '//   &
     &      'No shadowing warnings will be given.')
    jpk = 1.0
  else
    !
    ! Jy/K for 70 % Aperture efficiency
    jpk = 2.0*1.38e3*4.0/(pi*diameter**2)/0.70
    write(chain,'(A,F7.2,A)') 'I-UV_TRACKS, Using ',jpk,   &
     &      ' Jansky/K'
    call gagout(chain)
  endif
  !
  ! Hour angle coverage
  horizon = max(3.0,min(horizon,90.0))
  !
  ! Observatory coordinates
  call amset(latitud,amat)     ! Hour-Dec to Az-El matrix
  !
  ! Source is visible?
  hmin = a_lever(sngl(decs),sngl(latitud),horizon)
  if (hmin.ge.0) then
    write(6,*) 'Dec. ',decs
    write(6,*) 'Latitude ',latitud
    write(6,*) 'E-UV_TRACK,  Source is not visible'
    call sysexi(fatale)
  endif
  !
  ! Declination
  sd_sou = sin(decs)
  cd_sou = cos(decs)
  sd_cal = sin(decs)
  cd_cal = cos(decs)
  !
  ! Hour angle range
  hmax = -hmin
  if (hlim(1).ne.0.0) then
    if (hlim(1).lt.hmin) then
      write(6,*) 'W-UV_TRACK,  Source rises only at ',hmin
    else
      hmin = hlim(1)
    endif
  endif
  if (hlim(2).ne.0.0) then
    if (hlim(2).gt.hmax) then
      write(6,*) 'W-UV_TRACK,  Source already sets at ',hmax
    else
      hmax = hlim(2)
    endif
  endif
  !
  ! Open Station Main List; Get best coverage from First Line
  ier = sic_getlun (lun)
  ier = sic_open(lun,fstation(1:lenc(fstation)),'OLD',.true.)
  if (ier.ne.0) goto 998
  read (lun,'(A)',iostat=ier,end=998,err=998) chain
  !
  ! Handle various formats.
  array = 0.0
  ok = chain(1:1).eq.'!'
  if (ok) then
    do while(ok)
      read(lun,'(A)',iostat=ier) chain
      ok = chain(1:1).eq.'!'
    enddo
  else
    read(lun,'(A)',iostat=ier) chain
  endif
  array = array**2
  !
  ! Read coordinates from station file
  ! For each antenna, read: X,Y,Z,Diameter,BX,BY with BX,BY the baselines
  ! projected onto the local horizontal plane
  nstat = 0
  xx = 0.
  yy = 0.
  zz = 0.
  ok = .true.
  do while (ok)
    nstat = nstat+1
    i = 1
    do while(chain(i:i).eq.' ')
      i = i+1
    enddo
    ip = index(chain(i:),' ')+i
    read(chain(ip:),*,iostat=ier) x(nstat),y(nstat),z(nstat),dd,   &
     &      bx(nstat),by(nstat)
    xx = xx+x(nstat)
    yy = yy+y(nstat)
    zz = zz+z(nstat)
    read(lun,'(A)',iostat=ier) chain
    ok = ier.eq.0
  enddo
  close(unit=lun)
  call sic_frelun(lun)
  !
  ! Check diameter (done only for the last antenna)
  if (dd.ne.diameter) then
    call gagout ('W-UV_TRACKS,  Antenna size in configuration '//   &
     &      'file different from task input.')
  endif
  !
  ! Array size
  xx = xx/nstat
  yy = yy/nstat
  zz = zz/nstat
  array = 0.0
  do i=1,nstat
    array = max(array,(x(i)-xx)**2+   &
     &      (y(i)-yy)**2+(z(i)-zz)**2)
  enddo
  array = 2.0*sqrt(array)
  write(6,*) 'I-UV_TRACKS, Array size is ',array
  !
  ! Integration time (in secondes)
  if (integ_time.eq.0) then
    integ_time = 24.*3600.*uv_spacing/(4.*pi*array)
  endif
  integ_time = nint(integ_time)
  if (integ_time.gt.step_time) integ_time = step_time
  write(6,*) 'I-UV_TRACKS, Integration time ',integ_time,' sec.'
  !
  ! Precompute the coordinates
  frac = integ_time/3600.      ! in hours
  deadtime = deadtime/3600.
  nh = 0
  nh_sou = 0
  nh_cal = 0
  h = pi*hmin/12.0
  t = 0.
  ontime = 0.0
  if (do_calib) then
    !
    ! Sequence: source_integ seconds on source
    !           dead time
    !           cal_integ seconds on calibrator
    !           dead_time
    ! But start with a Calibrator
    ! H = PI*(HMIN-2*DEADTIME-CAL_INTEG)/12.0
    ontime = source_integ
    !
    do while (h.lt.(pi*hmax/12.0))
      do while (ontime.lt.source_integ)
        ch = cos(h)
        sh = sin(h)
        nh = nh + 1
        nh_sou = nh_sou+1
        zch(nh) = ch
        zsh(nh) = sh
        cal(nh) = .false.
        h = h+pi*frac/12.0
        hour(nh) = h
        t = t+integ_time
        time(nh) = t
        ontime = ontime+integ_time
      enddo
      ontime = 0.0
      h = h+pi*deadtime/12.0
      t = t+deadtime*3600.
      do while (ontime.lt.cal_integ)
        ch = cos(h)
        sh = sin(h)
        nh = nh + 1
        nh_cal = nh_cal+1
        zch(nh) = ch
        zsh(nh) = sh
        cal(nh) = .true.
        h = h+pi*frac/12.0
        hour(nh) = h
        t = t+integ_time
        time(nh) = t
        ontime = ontime+integ_time
      enddo
      ontime = 0.0
      h = h+pi*deadtime/12.0
      t = t+deadtime*3600.
    enddo
  else
    !
    ! Only source observations
    do while (h.lt.(pi*hmax/12.0))
      ch = cos(h)
      sh = sin(h)
      nh = nh + 1
      zch(nh) = ch
      zsh(nh) = sh
      cal(nh) = .false.
      h = h+pi*frac/12.0
    enddo
    nh_sou = nh
  endif
  write(6,*) 'Number of time dump ',nh
  write(6,*) 'Number of time dump on source ',nh_sou
  write(6,*) 'Number of time dump on calib. ',nh_cal
  tmp = t/integ_time
  write(6,*) 'Total equivalent dumps ',tmp
  !
  ! Bandwidth (in MHz)
  bandwidth = bandw            ! single -> double precision
  if (bandwidth.eq.0) then
    bandwidth = 8000.
  endif
  !
  ! Create or open SOURCE uvt table -- use X
  date = -10000.
  nvis = nh_sou*nstat*(nstat-1)/2
  write(6,*) 'Source: Number of visibilities ',nvis
  if (new) then
    xima%gil%inc(2) = integ_time
    call init_table (xima,file,nvis,decs,freq,bandwidth,error)
  else
    call extend_table (xima,file,nvis,decs,freq,bandwidth,error)
    date = -9999.
  endif
  if (error) then
    write(6,*) 'F-UV_TRACK,  Cannot open output Table'
    call sysexi(fatale)
  endif
  if (new) then
    allocate (xima%r2d(xima%gil%dim(1), xima%gil%dim(2)), stat=ier)
  else
    allocate (xima%r2d(xima%gil%dim(1), xima%trc(2)-xima%blc(2)+1), stat=ier)
  endif
  if (ier.ne.0) then
    write(6,*) 'W-UV_TRACK,  Cannot allocate output Table'
    call sysexi(fatale)
  endif
!!  ipx = gag_pointer(addr,memory)
  !
  ! Create CALIBRATOR uvt table -- use Y
  if (do_calib) then
    nvis = nh_cal*nstat*(nstat-1)/2
    write(6,*) 'Calibrator: Number of visibilities ',nvis
    call init_table (yima,cal_file,nvis,decs,freq,bandwidth,error)
    if (error) then
      write(6,*) 'F-UV_TRACK,  Cannot open output Table'
      call sysexi(fatale)
    endif
    allocate (yima%r2d(yima%gil%dim(1), yima%gil%dim(2)), stat=ier)
!    ipy = gag_pointer(addr,memory)
  endif
  !
  ! Open phase screen file -- use Z -- data in IPB
  if (do_screen) then
    call open_screen(phase_screen,nnx,nny,dx,dy,zima,phase_scale,error)
    if (error) then
      write(6,*) 'F-UV_TRACK,  Problem with Screen Phase image'
      call sysexi(fatale)
    endif
!    ipb = gag_pointer(addr,memory)
!    ipc = ipb + nnx*nny        ! Gradient address
    !
    ! Rotate and check the array layout, to be used for phase extraction
    call prepare_array(bx,by,nstat,windangle,windvelo,t,   &
     &      cal_dist,nnx,nny,dx,dy,error)
    if (error) goto 999        ! CALL SYSEXI(FATALE)
    !
    ! Distance to calibrator, on axis // and perp. to wind directions
    cal_dist_x = cal_dist*cos(cal_angle)
    cal_dist_y = cal_dist*sin(cal_angle)
  endif
  !
  ! Prepare phase gradient -- data in IPC
  if ((do_screen).and.(do_anrefr)) then
    !
    ! Translate phase gradient into pointing error
    call phase_to_ptg(zima%r3d(1,1,2),nnx,nny,freq,phase_scale)
  endif
  !
  ! Amplitude errors: compute drift rate for each antenna from given rms
  call compute_amp(drift,nstat,amplitude(2))   ! Drift
  call compute_amp(ampli,nstat,amplitude(1))   ! Offset
  !
  ! Time loop
  uvmin2 = diameter**2
  nshadow = 0
  nshadow_s = 0
  nshadow_c = 0
  nfill = 0
  nfill_s = 0
  nfill_c = 0
  next_c = 0
  next_s = 0
  h = pi*hmin/12.0
  later = time(nh) + 10.0      ! Time after end of data
  t0 = later
  ptg = time(1)
  !
  do k = 1,nh
    !
    ! Time (sec)
    t = time(k)
    !
    ! Calibrate the amplitude?
    if ((t-ptg).gt.amp_time) then
      ptg = t
      call compute_amp(ampli,nstat,amplitude(1))
    endif
    !
    ! Source or calibrator?
    if (cal(k)) then
      sd = sd_cal
      cd = cd_cal
      offsetx = cal_dist_x
      offsety = cal_dist_y
!      ipa = ipy
      t0 = later
    else
      sd = sd_sou
      cd = cd_sou
      offsetx = 0.0
      offsety = 0.0
!      ipa = ipx
    endif
    !
    ! Reset shadowing
    do i=1,nstat
      complete(i) = .true.
    enddo
    !
    ! Check for shadowing
    do i=1,nstat-1
      if (complete(i)) then
        do j=i+1,nstat
          if (complete(j)) then
            xx = x(i)-x(j)
            yy = y(i)-y(j)
            zz = z(i)-z(j)
            uk = zsh(k)*xx + zch(k)*yy
            vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
            if ((uk**2+vk**2).le.uvmin2) then
              test = (xx*zch(k) - yy*zsh(k))*cd + zz*sd
              if (test.gt.0.0) then
                complete(j) = .false.
                ff = j
              else
                complete(i) = .false.
                ff = i
              endif
              !!                        PRINT *,'U2+V2',UK**2+VK**2,UK,VK,UVMIN2,I,J,FF
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Compute source elevation
    avec(1) = zch(k)*cd
    avec(2) = zsh(k)*cd
    avec(3) = sd
    call matmul(amat,avec,bvec,1)
    call dangle(az,el,bvec)
    !
    ! Difference azimuth -- wind direction
    ! Angle convention:
    ! Azimuth: 0 South, -90 East, +90 West
    ! Windangle: 0 East, +90 North, -0 South (trig.)
    ! To get same convention than windangle: az = -az-90
    !
    az = -az-pi/2.
    az = az-windangle
    !
    ! Compute Tsys
    call atmos(trec,tsys,tau,el)
    if (first) then
      write(chain,'(A,F8.1)') 'I-UV_TRACK, Typical Tsys ',tsys
      call gagout(chain)
      first = .false.
    endif
    !
    ! Compute Weight
    weight= 2*bandwidth*integ_time/(jpk*tsys)**2
    total = total+weight
    !
    ! Generate phase noise from input phase screen
    if (do_screen) then
      !
      call phase_noise(phn,nstat,zima%r3d,nnx,nny,dx,dy,   &
     &        bx,by,windvelo,t,offsetx,offsety,phase_scale,   &
     &        do_anrefr,zima%r3d(1,1,2),az,el,azerr,elerr)
      !
      ! Radiometer correction
      if (do_radiom) then
        if (cal(k)) then
          do i=1,nstat
            phcal(i) = phn(i)
          enddo
        else
          call phase_rad(phrad,phn,nstat,wvr_precis,t,   &
     &            phn0,t0,wvr_noise)
        endif
      endif
    else
      !
      ! Pure random noise
      call phase_random(phase,phn,nstat)
    endif
    !
    ! Generate amplitude noise
    call ampli_noise(amperror,nstat,ampli,drift,t,ptg)
    !
    ! Fill the table now
    do i=1,nstat-1
      do j=i+1,nstat
        !
        ! Phase
        if ((.not.cal(k)).and.do_radiom) then
          ph = phrad(i)-phrad(j)
          if (do_correct) then
            ph = ph - (phcal(i)-phcal(j))
          endif
        else
          ph = phn(i)-phn(j)
        endif
        !
        ! Amplitude
        amp = sqrt(amperror(i)*amperror(j))
        !
        ! Pointing error (anomalous refraction)
        ! RADEC convert az,el offsets into ra,dec offsets
        if (do_anrefr) then
          call radec(azerr(i),elerr(i),hour(k),latitud,decs,   &
     &            ra_err(1),dec_err(1))
          call radec(azerr(j),elerr(j),hour(k),latitud,decs,   &
     &            ra_err(2),dec_err(2))
        else
          ra_err(1) = 0.
          dec_err(1) = 0.
          ra_err(2) = 0.
          dec_err(2) = 0.
        endif
        ! RA_ERR(1) = azerr(i)
        ! DEC_ERR(1) = elerr(i)
        ! RA_ERR(2) = azerr(j)
        ! DEC_ERR(2) = elerr(j)
        !
        ! Baseline
        xx = x(i)-x(j)
        yy = y(i)-y(j)
        zz = z(i)-z(j)
        uk = zsh(k)*xx + zch(k)*yy
        vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
        if (complete(i).and.complete(j)) then
          total = total+weight
          nfill = nfill+1
          if (cal(k)) then
            nfill_c = nfill_c+1
            next_c = next_c+1
            call fill_table (uk,vk,date,t,   &
     &            weight,i,j,yima%r2d(1,next_c),el,   &
     &            integ_time,ph,amp,ra_err,dec_err)
          else
            nfill_s = nfill_s+1
            next_s = next_s+1
            call fill_table (uk,vk,date,t,   &
     &            weight,i,j,xima%r2d(1,next_c),el,   &
     &            integ_time,ph,amp,ra_err,dec_err)
          endif
        else
          nshadow = nshadow+1
          if (cal(k)) then
            nshadow_c = nshadow_c+1
            next_c = next_c+1
            call fill_table (uk,vk,date,t,   &
     &            0.0,i,j,yima%r2d(1,next_c),el,   &
     &            integ_time,ph,amp,ra_err,dec_err)
          else
            nshadow_s = nshadow_s+1
            next_s = next_s+1
            call fill_table (uk,vk,date,t,   &
     &            0.0,i,j,xima%r2d(1,next_c),el,   &
     &            integ_time,ph,amp,ra_err,dec_err)
          endif
        endif
      enddo
    enddo
    !
    ! End time loop
  enddo
  write(6,*) 'Wrote ',nfill,' visibilities (',nshadow,' shadowed)'
  write(6,*) 'Source: ',nfill_s, 'vis. (',nshadow_s,' shadowed)'
  write(6,*) 'Calib.: ',nfill_c, 'vis. (',nshadow_c,' shadowed)'
  !
  ! Free, close, etc
  call gdf_write_data (xima, xima%r2d, error)
  call cut_table(xima,file,0,error)
  if (do_calib) then
    call gdf_write_data (yima, yima%r2d, error)
    call cut_table(yima,cal_file,0,error)
  endif
  if (do_screen) then
    call gdf_close_image(zima,error)
  endif
  !
  ! Write estimate noise
  total = 1e-3/sqrt(total)
  write(chain,*) 'I-UV_TRACK,  Expected noise ',total,' Jy/beam'
  call gagout(chain(2:))
  call sysexi(1)
  !
  998   call gagout('E-UV_TRACK,  Trouble with ASTRO_STATIONS')
  call gagout(fstation)
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
  999   call gagout('F-UV_TRACK,  Fatal Error')
  call sysexi(fatale)
end program uv_track_phase
!<FF>



!!subroutine newuvt_init (xima,name,nvis,error)
subroutine init_table (xima,name,nvis,dec,freq,bandwidth,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Creates the output table header in X (the significant header parameters
  ! have already been defned in clic_table)
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(out) :: error         ! Error flag
  real(8), intent(in) :: dec                         !
  real(8), intent(in) :: freq                        !
  real(8), intent(in) :: bandwidth                   !
  ! Local
  integer :: i, last
  !
  ! Do not nullify X header here: it has already been partly computed before.
  !
  error = .false.
  !
  xima%file = name
  xima%gil%blan_words = def_blan_words
  xima%gil%extr_words = def_extr_words
  xima%gil%desc_words = def_desc_words
  xima%gil%posi_words = def_posi_words
  xima%gil%proj_words = def_proj_words
  xima%gil%spec_words = def_spec_words
  xima%gil%reso_words = def_reso_words
  xima%gil%uvda_words = 2 ! Not Zero is enough
  !
  xima%gil%eval = 0.
  xima%gil%dim(2) = nvis              ! +1 ! = add the dummy uv = 7.5 m point
  xima%gil%ref(2) = 0.
  xima%gil%inc(2) = 1.                  ! needed to avoid crash in GRAPHIC
  xima%gil%val(2) = 0.
  xima%gil%ndim = 2
  xima%char%unit = 'Jy'
  xima%char%syst = 'EQUATORIAL'
  xima%gil%ptyp = p_azimuthal
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%gil%faxi = 1
  !
  xima%gil%dec = dec
  xima%gil%epoc = 2000.0
  xima%gil%a0 = xima%gil%ra
  xima%gil%d0 = xima%gil%dec
  xima%char%line = ' '
  xima%gil%fres = bandwidth
  if (freq.ne.0d0) then
    xima%gil%fima = (freq+12.0)*1d3
    xima%gil%freq = freq*1d3
  else
    xima%gil%fima = 102d3
    xima%gil%freq = 90d3
  endif
  xima%gil%val(1) = xima%gil%freq
  !
  ! Here define the order in which you want the extra "columns"
  xima%gil%column_pointer = 0
  xima%gil%column_size = 0
  xima%gil%column_pointer(code_uvt_u) = 1
  xima%gil%column_pointer(code_uvt_v) = 2
  xima%gil%column_pointer(code_uvt_w) = 3
  xima%gil%column_pointer(code_uvt_date) = 4
  xima%gil%column_pointer(code_uvt_time) = 5
  xima%gil%column_pointer(code_uvt_anti) = 6
  xima%gil%column_pointer(code_uvt_antj) = 7
  xima%gil%natom = 3
  xima%gil%nstokes = 1
  ! Extra columns
  xima%gil%fcol = 8
  last = xima%gil%fcol+xima%gil%natom * xima%gil%nchan
  xima%gil%column_pointer(code_uvt_el) = last
  last = last+1
  xima%gil%column_pointer(code_uvt_int) = last
  last = last+1
  xima%gil%column_pointer(code_uvt_xoff) = last  ! xoffi
  last = last+1
  xima%gil%column_pointer(code_uvt_yoff) = last  ! yoffi
  last = last+1
  xima%gil%column_pointer(code_uvt_loff) = last  ! xoffj
  last = last+1
  xima%gil%column_pointer(code_uvt_moff) = last  ! yoffj
  do i=1,code_uvt_last
    if (xima%gil%column_pointer(i).ne.0) xima%gil%column_size(i) = 1
  enddo
  !
  xima%gil%nvisi = nvis
  xima%gil%type_gdf = code_gdf_uvt
  call gdf_setuv (xima,error)
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2)
  print *, 'Into newuvt_init ',xima%gil%nvisi, xima%gil%nchan, xima%gil%dim(1:2)
  print *, 'Into newuvt_init UVDA_WORDS', xima%gil%uvda_words
  call gdf_create_image (xima,error)
  print *, 'Done newuvt_init '
end subroutine init_table
!<FF>
!!subroutine newuvt_extend (xima,name,nvis,nn,ndobs,ndscan,error,lc)
subroutine extend_table (xima,name,nvis,dec,freq,bandwidth,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Open a Table to extend it.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(out) :: error         ! Error flag
  real(8), intent(in) :: dec                         !
  real(8), intent(in) :: freq                        !
  real(8), intent(in) :: bandwidth                   !
!  integer, intent(in) :: nn             !
!  integer, intent(in) :: ndobs(nn)      !
!  integer, intent(in) :: ndscan(nn)     !
!  logical, intent(in) :: lc             ! Check table before
  ! Local
  integer(kind=size_length) :: mvis
  integer :: ier
  character(len=60) :: chain
  !-----------------------------------------------------------------------
  !
  call gdf_read_gildas(xima, name, '.uvt', error, data=.false.)
  if (.not.error) then
    if (abs(xima%gil%dec-dec).gt.1d-6) then
      write(6,*) 'W-ASTRO_UV,  Different declinations'
      error = .true.
    endif
    if (freq.ne.0.0 .and. (abs(freq-xima%gil%freq*1d-3).gt.1d-6)) then
      write(6,*) 'W-ASTRO_UV,  Different frequencies'
      error = .true.
    endif
    if (abs(bandwidth-xima%gil%fres).gt.1d-6) then
      write(6,*) 'W-ASTRO_UV, Different bandwidth'
      error = .true.
    endif
  endif
  if (error) return
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) xima%gil%dim(2),nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call gagout('I-EXTEND_TABLE,  '//chain)
  !
  mvis = xima%gil%dim(2)+nvis
  !
  print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  call gdf_extend_image (xima,mvis,error)
  print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  if (error) then
    call gagout('I-EXTEND_TABLE,  Table extension failed')
    return
  endif
  !
  ! Map only new region
  xima%blc(1) = 1
  xima%blc(2) = xima%gil%dim(2)+1-nvis
  xima%trc(1) = xima%gil%dim(1)
  xima%trc(2) = xima%gil%dim(2)
  print *, 'Done newuvt_extend '
end subroutine extend_table
!
subroutine cut_table (xima,name,ncut,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Update the number of visibilities
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: xima !
  character(len=*) :: name          !
  integer, intent(in) :: ncut         ! Number of missing visibilities
  logical :: error                    !
  !
  ! Local
  character(len=80) :: chain
  !----------------------------------------------------------------------
  !
  xima%gil%nvisi = xima%gil%dim(2) - ncut
  write(chain,1001) xima%gil%dim(2), xima%gil%nvisi
  xima%gil%dim(2) = xima%gil%nvisi
  call gagout('I-CUT_TABLE,  '//chain)
  call gdf_update_header(xima,error)
  print *, 'Done newuvt_cut ',xima%gil%nchan
  !
1001 format('Old size ',i8,' New ',i8)
end subroutine cut_table


subroutine fill_table (u,v,d,t,w,ideb,ifin,visi,e,dt,ph,amp,   &
     &    err_x,err_y)
  !---------------------------------------------------------------------
  ! 7 Parametres :
  ! U, V, W=0, Date, Temps, Ant1, Ant2
  ! 3 values
  ! Reel, Imag, Poids
  ! 1.0,   0.0, 1.0
  !---------------------------------------------------------------------
  real :: u                         !
  real :: v                         !
  real :: d                         !
  real :: t                         !
  real :: w                         !
  integer :: ideb                   !
  integer :: ifin                   !
  real :: visi(*)                   !
  real*8 :: e                       !
  real :: dt                        !
  real :: ph                        !
  real :: amp                       !
  real*8 :: err_x(2)                !
  real*8 :: err_y(2)                !
  !
  visi(1) = u
  visi(2) = v
  visi(3) = 0.0
  visi(4) = d
  visi(5) = t
  visi(6) = ideb
  visi(7) = ifin
  visi(8) = amp*cos(ph)
  visi(9) = amp*sin(ph)
  visi(10) = w
  visi(11) = e
  visi(12) = dt
  visi(13) = err_x(1)
  visi(14) = err_y(1)
  visi(15) = err_x(2)
  visi(16) = err_y(2)
end
!<FF>
function a_lever(d,d0,el)
  !---------------------------------------------------------------------
  ! Lever d'une etoile de declinaison D a latitude D0
  ! Ce code est different de "lever" de GreG, donc je l'appelle A_LEVER
  ! (sinon big problemes,...GD, 8-10-1992)
  ! D Declination in radians
  ! D0  Latitude in degrees
  !   EL  elevation limit in degrees
  ! LEVER Hour angle in Hours
  !
  ! PI/2-D0+EL < D  Circumpolaire
  ! D0-PI/2+EL < D < PI/2-D0+EL H = ACOS (TAN(D)/TAN(D0-PI/2))
  ! D < D0-PI/2+EL  Toujours cocheue...
  !
  ! Formule applicable a la partie visible du ciel en projection
  ! sur un plan
  !---------------------------------------------------------------------
  real :: a_lever                   !
  real :: d                         !
  real :: d0                        !
  real :: el                        !
  ! Local
  real :: dd,d1,d2,ee
  real*8 :: pi
  parameter (pi=3.14159265358979323846d0)
  !
  if (d0.lt.0.) then
    d2 = -d
    d1 = -d0*pi/180.0
  else
    d2 = d
    d1 = d0*pi/180.0
  endif
  dd = d1-pi*0.5d0
  ee = el*pi/180.
  a_lever = (-sin(ee)+sin(d2)*cos(dd))/(cos(d2)*sin(dd))
  if (a_lever.le.-1.0) then
    a_lever = -12.0            ! Circumpolar
  elseif (a_lever.ge.1.0) then
    a_lever = 0.0              ! Not visible
  else
    a_lever = -12.0/pi* acos(a_lever)
  endif
end
!<FF>
subroutine amset(obslat,amat)
  !---------------------------------------------------------------------
  !   subroutine to provide transformation matrix from hour angle - dec
  !       into azimuth - elevation.
  !---------------------------------------------------------------------
  real*8 ::  obslat                 ! in degrees
  real*8 ::  amat(9)                !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::  x1,y1,z1
  !
  x1=pi/180d0*obslat
  y1=dsin(x1)
  z1=dcos(x1)
  amat(1)=-y1
  amat(2)=0.d0
  amat(3)=z1
  amat(4)=0.d0
  amat(5)=-1.d0
  amat(6)=0.d0
  amat(7)=z1
  amat(8)=0.d0
  amat(9)=y1
end
!<FF>
subroutine dangle(along,alat,a)
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine recovers the longitude and latitude angles, along
  ! (0 - 360) and alat ( +.- 180) in deg_to_radrees, which correspond to the
  ! vector a.
  !---------------------------------------------------------------------
  real*8 ::   along                 !
  real*8 ::   alat                  !
  real*8 ::   a(3)                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::   aa
  !
  aa     = a(1)*a(1)+a(2)*a(2)
  aa     = dsqrt(aa)
  alat   = pi/2d0
  if (aa.ge.0.000001d0) then
    aa = a(3)/aa
    alat = datan(aa)           ! latitude in Radian
  endif
  !
  if (a(2).ne.0.d0 .or. a(1).ne.0.d0) then
    along=datan2(a(2),a(1))    ! longitude in Radian
  else
    along = 0.d0
  endif
end
!<FF>
subroutine dcosin(along,alat,a)    ! direction cosinus
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine computes the vector a for the angles, along and alat,
  ! which should be specified in deg_to_radrees.
  !---------------------------------------------------------------------
  real*8 ::   along                 !
  real*8 ::   alat                  !
  real*8 ::   a(3)                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::   x,y,z
  !
  x    = along                 ! x in radians
  y    = alat                  ! y in radians
  z    = dcos(y)
  a(1) = dcos(x)*z
  a(2) = dsin(x)*z
  a(3) = dsin(y)
end
!<FF>
subroutine matmul(mat,a,b,n)
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.  G.Haslam
  ! version 2.0  iram
  !
  ! this routine provides the transformation of vector a to vector b
  ! using the n dimensional direction cosine array, mat.
  !---------------------------------------------------------------------
  real*8 ::    mat(3,3)             !
  real*8 ::    a(3)                 !
  real*8 ::    b(3)                 !
  integer ::   n                    !
  ! Local
  integer ::   i,j
  !
  if (n.gt.0) then
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(i,j)*a(j)
      enddo
    enddo
  else
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(j,i)*a(j)
      enddo
    enddo
  endif
end
!<FF>
subroutine atmos(trec,tsys,tau0,el)
  real :: trec                      !
  real :: tsys                      !
  real :: tau0                      !
  real*8 :: el                      !
  ! Local
  real :: tau,tatm,feff,tcab
  feff = 0.93
  tatm = 240.0
  tcab = 300.0
  !
  tau = tau0/sin(el)
  tsys = feff*(1.-exp(-tau))*tatm + (1.0-feff)*tcab + trec
  tsys = exp(tau)/feff*tsys
end
!<FF>
!<FF>
subroutine open_screen(phase_screen,nnx,nny,dx,dy,s,scale,error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  type(gildas), intent(inout) :: s
  character(len=*) :: phase_screen      !
  integer :: nnx                        !
  integer :: nny                        !
  real :: dx                            !
  real :: dy                            !
  real :: scale                         !
  logical :: error                      !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  integer :: n
  character(len=256) :: name
  !
  n = lenc(phase_screen)
  if (n.le.0) return
  name = phase_screen(1:n)
  call gildas_null (s)
  call gdf_read_gildas (s, name, '.gdf', error)
  if (error) then
    call gagout ('F-UV_TRACK, Cannot read phase screen')
    return
  endif
  !
  if (s%gil%dim(3).ne.3) then
    call gagout('F-UV_TRACK, Phase sreen does not have gradients')
    error = .true.
    return
  endif
  !
  ! Dimensions
  nnx = s%gil%dim(1)
  nny = s%gil%dim(2)
  dx = s%gil%inc(1)
  dy = s%gil%inc(2)
  !
  ! Scaling factor for phases
  if (s%gil%inc(3).eq.0) s%gil%inc(3) = 1.0
  scale = scale / s%gil%inc(3)
  print *,'Scale ',scale,s%gil%inc(3)
  scale = scale*pi/180.0
  if (scale.eq.0.) then
    scale = pi/180.0
  endif
  !
end
!<FF>
subroutine prepare_array(bx,by,nstat,windangle,windvelo,   &
     &    time,cal_dist,nnx,nny,dx,dy,error)
  integer :: nstat                  !
  real :: bx(nstat)                 !
  real :: by(nstat)                 !
  real :: windangle                 !
  real :: windvelo                  !
  real :: time                      !
  real :: cal_dist                  !
  integer :: nnx                    !
  integer :: nny                    !
  real :: dx                        !
  real :: dy                        !
  logical :: error                  !
  ! Local
  real :: tmp,cs,sn,xx,yy,xmin,xmax,ymin,ymax
  integer :: i
  !
  error = .false.
  !
  ! Rotate the array layout by windangle
  !
  cs = cos(windangle)
  sn = sin(windangle)
  do i = 1,nstat
    tmp = bx(i)
    bx(i) =  tmp*cs + by(i)*sn
    by(i) = -tmp*sn + by(i)*cs
  enddo
  !
  ! Array dimension
  xmin = 1e20
  ymin = 1e20
  xmax = 0.0
  ymax = 0.0
  do i = 1,nstat
    xmin = min(xmin,bx(i))
    ymin = min(ymin,by(i))
    xmax = max(xmax,bx(i))
    ymax = max(ymax,by(i))
  enddo
  write(*,*) 'Min/max antenna positions ',xmin,ymin,xmax,ymax
  write(*,*) 'Wind in X ',windvelo,time,windvelo*time
  write(*,*) 'Calib distance ',cal_dist
  !
  ! Check the dimension of the phase screen
  ! Max. distance to be added in X = windvelo * max elapsed time
  ! Max. distance to be added in Y = 2*distance to calibrator (to allow
  !      any cal_angle)
  xx = xmax-xmin + windvelo*time +2*cal_dist + 2*dx
  yy = ymax-ymin + 2*cal_dist + 2*dy
  if ((dx*nnx).le.xx) then
    call gagout('W-UV_TRACKS,  Phase screen too short, Wrapping')
  endif
  if ((dy*nny).le.yy) then
    call gagout('E-UV_TRACKS,  Phase screen too narrow')
    write(*,*) 'Phase screen X',dx,nnx,' Y ',dy,nny
    write(*,*) 'Wind ',windvelo
    write(*,*) 'Time ',time
    write(*,*) 'Cal. distance ',cal_dist
    error = .true.
    return
  endif
  !
  ! Move array: start at 1m in X, center the array in Y
  do i = 1,nstat
    bx(i) = bx(i)-xmin+1
    by(i) = by(i)-(ymax+ymin)/2.+nny*dy/2.
  enddo
  !
end
! <FF>
subroutine phase_noise(phn,nstat,screen,nnx,nny,dx,dy,   &
     &    bx,by,windvelo,time,offsetx,offsety,scale,do_anrefr,   &
     &    ptg,az,el,azerr,elerr)
  integer :: nstat                  !
  real :: phn(nstat)                !
  integer :: nnx                    !
  integer :: nny                    !
  real :: screen(nnx,nny)           !
  real :: dx                        !
  real :: dy                        !
  real :: bx(nstat)                 !
  real :: by(nstat)                 !
  real :: windvelo                  !
  real :: time                      !
  real :: offsetx                   !
  real :: offsety                   !
  real :: scale                     !
  logical :: do_anrefr              !
  real :: ptg(nnx,nny,2)            !
  real*8 :: az                      !
  real*8 :: el                      !
  real :: azerr(nstat)              !
  real :: elerr(nstat)              !
  ! Local
  integer :: n
  !
  integer :: i,px,py
  real :: offx, offy, tmpx, tmpy, cs, sn
  !
  ! Rotation angle for anomalous refraction
  cs = cos(az)
  sn = sin(az)
  !
  ! Translate array layout
  offx = windvelo*time + offsetx
  offy = offsety
  !
  ! Extract phase noise
  do i = 1,nstat
    px = nint((bx(i)+offx)/dx)+1
    px = mod(px+1,nnx) - 1     ! Automatic wrap around
    py = nint((by(i)+offy)/dy)+1
    if ((px.lt.1).or.(py.gt.nny).or.(py.lt.1)) then
      call gagout('W-UV_TRACKS,  Phase screen too small')
      phn(i) = 0.0
      azerr(i) = 0.0
      elerr(i) = 0.0
    else
      phn(i) = screen(px,py)*scale
      !
      !         if (i.eq.1) then
      !            write(*,*) 'ant. 1, time ',time,' position ',bx(1),by(1),
      !     $                 'offsets ',offx,offy, offsetx, 'in pixel ',px,py,
      !     $                 'phase',phn(1),'screen ',dx,dy,scale
      !         endif
      !
      ! Anomalous refraction
      if (do_anrefr) then
        tmpx = ptg(px,py,1)
        tmpy = ptg(px,py,2)
        azerr(i) =  tmpx*cs+tmpy*sn
        elerr(i) = -tmpx*sn+tmpy*cs
      endif
    endif
  enddo
  !
end
!<FF>
subroutine phase_random(phase,phn,n)
  real :: phase                     !
  integer :: n                      !
  real :: phn(n)                    !
  ! Local
  integer :: i
  real :: rangau
  !
  do i = 1,n
    phn(i) = rangau (phase)
  enddo
end
!<FF>
subroutine phase_rad(phrad,phn,n,precis,t,phn0,t0,noise)
  integer :: n                      !
  real :: phrad(n)                  !
  real :: phn(n)                    !
  real :: precis                    !
  real :: t                         !
  real :: phn0(n)                   !
  real :: t0                        !
  real :: noise                     !
  ! Local
  real :: rangau
  integer :: i
  logical :: debut
  !
  ! Computes phase deduced from radiometer data
  !   PHN = current atmospheric phase
  !   PHN0 = phase at beginning of correction
  !   PHRAD = after radiometric correction
  !
  debut = .false.
  if (t0.gt.t) then
    t0 = t
    debut = .true.
  endif
  !
  do i = 1,n
    if (debut) then
      phn0(i) = phn(i)
      phrad(i) = phn0(i)
    else
      phrad(i) = phn0(i) + (phn(i)-phn0(i))*precis
    endif
  enddo
  !
  ! Add WVR noise
  if (noise.gt.0) then
    do i = 1,n
      phrad(i) = phrad(i) + rangau (noise)
    enddo
  endif
end
!<FF>
subroutine compute_amp(drift,n,amplitude)
  integer :: n                      !
  real :: drift(n)                  !
  real :: amplitude                 !
  ! Local
  integer :: i
  real :: rangau
  !
  if (amplitude.eq.0) then
    do i = 1,n
      drift(i) = 0.0
    enddo
  else
    do i = 1,n
      drift(i) = rangau(amplitude)
    enddo
  endif
end
!<FF>
subroutine ampli_noise(amperror,n,ampli,drift,t,t0)
  integer :: n                      !
  real :: amperror(n)               !
  real :: ampli(n)                  !
  real :: drift(n)                  !
  real :: t                         !
  real :: t0                        !
  ! Local
  integer :: i
  real :: rangau, tt
  !
  tt = (t-t0)/3600.            ! in hours
  do i = 1,n
    amperror(i) = ampli(i)+drift(i)*tt !  in %
    amperror(i) = 1.-amperror(i)/100.
    if (amperror(i).lt.0.) then
      amperror(i) = 0.0
    endif
  enddo
  ! Print *,'Amp errr ',amperror(1),amperror(n)
  ! Print *,'Ampliude & Drift ',ampli(1),drift(1)
end
!<FF>
subroutine phase_to_ptg(gr,nnx,nny,freq,scale)
  integer :: nnx                    !
  integer :: nny                    !
  real :: gr(nnx,nny,2)             !
  real*8 :: freq                    !
  real :: scale                     !
  ! Local
  integer :: i,j
  real :: factor, lambda
  real*8 :: pi
  parameter (pi=3.141592653589793238d0)
  !
  lambda = 299792.458e3/(freq*1e9) ! in meter
  factor = lambda/(2*pi)       ! rad to meters
  factor = factor*scale        ! phase rms scaling factor (convert deg to rad)
  !
  ! phase gradient in deg/m
  ! * factor --> m/m
  ! atan --> pointing error in rad
  !
  do i=1,nnx
    do j=1,nny
      gr(i,j,1) = atan(gr(i,j,1)*factor)
      gr(i,j,2) = atan(gr(i,j,2)*factor)
    enddo
  enddo
  !
end
!<FF>
subroutine radec(along,elat,hour,tellat,dedate,dra,ddec)
  !---------------------------------------------------------------------
  ! Copy from task/nic/radec.f
  ! Modifications 31.07.01
  ! Original version: takes LST and RA as input, and computes HA
  !           SUBROUTINE RADEC(ALONG,ELAT,ALST,TELLAT,RADATE,DEDATE,DRA,DDEC)
  ! Present version: takes directly HA as input
  !           SUBROUTINE RADEC(ALONG,ELAT,HOUR,TELLAT,DEDATE,DRA,DDEC)
  !           All angles given and computed in radians
  !           except TELLAT, given in deg
  !
  !   THIS ROUTINE TAKES AS INPUT THE AZ AND EL OFFSET RELATIVE
  !   TO THE FIELD CENTRE, THE L.S.T., THE OBSERVATORY LATITUDE
  !   AND THE CURRENT EPOCH EQUATORIAL COORDINATES OF THE FIELD
  !   CENTRE AND RETURNS THE RA AND DEC OFFSETS RELATIVE TO THE
  !   FIELD CENTRE.
  !   ALONG , ELAT = OFFSETS RELATIVE TO FIELD CENTRE IN AZ-EL
  !   ALST = L.S.T. OF DATA POINT
  !   TELLAT = OBSERVATORY LATITUDE
  !   RADATE , DEDATE = CURRENT EPOCH RA AND DEC OF FIELD CENTRE
  !   DRA , DDEC = RA AND DEC OFFSETS RELATIVE TO FIELD CENTRE
  !
  ! Input:
  !   ALONG,ALAT : Offset to the field centre (arcsec)
  !   ALST       : Local sideral time (sec)
  !   TELLAT     : Telescope latitude (degrees)
  !   RADATE,DEDATE : RA and DEC of the day (degrees)
  ! Output:
  !   DRA,DDEC   : RA and DEC offsets relative to the field centre (degrees)
  !---------------------------------------------------------------------
  real ::     along                 !
  real ::     elat                  !
  real ::     hour                  !
  real*8 ::   tellat                !
  real ::     dedate                !
  real*8 ::   dra                   !
  real*8 ::   ddec                  !
  ! Local
  real ::     raoff,decoff
  real*8 ::   ha
  real*8 ::   deccur
  real*8 ::   dlo,dla
  real*8 ::   sinr,cosr,sine,cose,sinpa,cospa,sinlo,coslo,sinla,cosla
  real*8 ::   sindd,cosdd,cosdra,sindra
  real*8 ::   pa
  !
  real*8 ::   sindec,cosdec,sinol,cosol,obslat
  real*8 ::   pi
  parameter (pi=3.141592653589793238d0)
  !
  ! NIC code
  !      ALST1 = ALST / 240. * DEG_TO_RAD
  !      RACUR = RADATE * DEG_TO_RAD
  !      DLO = ALONG / 3600. * DEG_TO_RAD
  !      DLA = ELAT /3600. * DEG_TO_RAD
  !      HA = RACUR - ALST1               ! hour angle
  !
  ! UV_OBSERVE code
  obslat = tellat*pi/180.
  deccur = dedate
  dlo = along                  ! real to double
  dla = elat                   ! real to double
  ha = hour                    ! real to double
  !
  sindec = dsin(deccur)
  cosdec = dsqrt(1.d0 - sindec * sindec)
  sinol = dsin(tellat)
  cosol = dsqrt(1.d0 - sinol * sinol)
  !
  sinr = dsin(ha)
  cosr = dcos(ha)
  sine = sindec * sinol + cosdec * cosol * cosr
  ! E = DASIN(SINE)
  cose = dsqrt(1.d0 - sine * sine)
  sinpa = cosol * sinr / cose
  cospa = (sinol - sindec *sine) / (cosdec * cose)
  pa = datan2(sinpa,cospa)
  sinlo = dsin(dlo)
  coslo = dcos(dlo)
  sinla = dsin(dla)
  cosla = dcos(dla)
  sindd = cospa * sinla - sinpa * cosla *sinlo
  ddec = dasin(sindd)
  cosdd = dcos(ddec)
  cosdra = cosla * coslo / cosdd
  if(abs(sinpa).lt.1.d-6) then
    dra = -dlo
  else
    sindra = -(sinla - cospa * sindd) / (sinpa * cosdd)
    dra = datan2(sindra,cosdra)
  endif
  raoff = dra
  decoff = ddec
  return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_chunkset_2d_swi_fill(swmode,swdesc,chunkset2d,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_swi_fill
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: swmode
  type(switch_desc_t), intent(in)    :: swdesc
  type(chunkset_2d_t), intent(inout) :: chunkset2d
  logical,             intent(inout) :: error
  ! Local
  type(chunkset_t), pointer :: chunkset
  integer(kind=size_length) :: ipix,iset,ichunk
  character(len=*), parameter :: rname='CHUNKSET>2D>SWI>FILL'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do ipix=1,chunkset2d%npix
     do iset=1,chunkset2d%nset
        chunkset => chunkset2d%chunkset(iset,ipix)
        do ichunk=1,chunkset%n
           call mrtcal_chunk_swi_fill(swmode,swdesc,chunkset%chunks(ichunk),error)
           if (error) return
        enddo ! ichunk
     enddo ! iset
  enddo ! ipix
  !
end subroutine mrtcal_chunkset_2d_swi_fill
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_chunkset_2d_copy_data(in,out,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_copy_data
  !---------------------------------------------------------------------
  ! @ private
  ! Data are copied
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: in
  type(chunkset_2d_t), intent(inout) :: out
  logical,             intent(inout) :: error
  ! Local
  type(chunkset_t), pointer :: inset,outset
  integer(kind=size_length) :: ipix,iset,ichunk
  character(len=*), parameter :: rname='CHUNKSET>2D>COPY>DATA'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do ipix=1,out%npix
     do iset=1,out%nset
        inset => in%chunkset(iset,ipix)
        outset => out%chunkset(iset,ipix)
        do ichunk=1,outset%n
           call outset%chunks(ichunk)%copy_data(inset%chunks(ichunk),error)
           if (error) return
        enddo ! ichunk
     enddo ! iset
  enddo ! ipix
  !
end subroutine mrtcal_chunkset_2d_copy_data
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_chunkset_2d_interpolate_init(prev,next,slope,offset,interp,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_interpolate_init
  !---------------------------------------------------------------------
  ! @ private
  ! Initialize linear interpolation
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: prev
  type(chunkset_2d_t), intent(in)    :: next
  type(chunkset_2d_t), intent(inout) :: slope
  type(chunkset_2d_t), intent(inout) :: offset
  type(chunkset_2d_t), intent(inout) :: interp
  logical,             intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ipix,iset,ichunk
  character(len=*), parameter :: rname='CHUNKSET>2D>INTERPOLATE>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call prev%consistency(rname,next,error)
  if (error) return
  call mrtcal_chunkset_2d_interpolate_init_as_ref(prev,slope,offset,interp,error)
  if (error) return
  !
  do ipix=1,prev%npix
     do iset=1,prev%nset
        do ichunk=1,prev%chunkset(iset,ipix)%n
           call mrtcal_chunk_interpolate_init(&
                prev%chunkset(iset,ipix)%chunks(ichunk),&
                next%chunkset(iset,ipix)%chunks(ichunk),&
                slope%chunkset(iset,ipix)%chunks(ichunk),&
                offset%chunkset(iset,ipix)%chunks(ichunk),&
                error)
           if (error) return
        enddo ! ichunk
     enddo ! iset
  enddo ! ipix
  !
end subroutine mrtcal_chunkset_2d_interpolate_init
!
subroutine mrtcal_chunkset_2d_interpolate_init_as_ref(ref,slope,offset,interp,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_interpolate_init_as_ref
  !---------------------------------------------------------------------
  ! @ private
  ! Reallocate as ref and copy header from ref
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: ref
  type(chunkset_2d_t), intent(inout) :: slope
  type(chunkset_2d_t), intent(inout) :: offset
  type(chunkset_2d_t), intent(inout) :: interp
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>2D>INTERPOLATE>INIT>AS>REF'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call slope%clone(ref,.true.,error)
  if (error) return
  call offset%clone(ref,.true.,error)
  if (error) return
  call interp%clone(ref,.true.,error)
  if (error) return
  !
end subroutine mrtcal_chunkset_2d_interpolate_init_as_ref
!
subroutine mrtcal_chunkset_2d_interpolate_do(mjd,slope,offset,interp,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_interpolate_do
  !---------------------------------------------------------------------
  ! @ private
  ! Compute linear interpolation
  !---------------------------------------------------------------------
  real(kind=8),        intent(in)    :: mjd
  type(chunkset_2d_t), intent(inout) :: slope
  type(chunkset_2d_t), intent(inout) :: offset
  type(chunkset_2d_t), intent(inout) :: interp
  logical,             intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ipix,iset,ichunk
  character(len=*), parameter :: rname='CHUNKSET>2D>INTERPOLATE>DO'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call slope%consistency(rname,offset,error)
  if (error) return
  call slope%consistency(rname,interp,error)
  if (error) return
  !
  do ipix=1,slope%npix
     do iset=1,slope%nset
        do ichunk=1,slope%chunkset(iset,ipix)%n
           call mrtcal_chunk_interpolate_do(mjd,&
                slope%chunkset(iset,ipix)%chunks(ichunk),&
                offset%chunkset(iset,ipix)%chunks(ichunk),&
                interp%chunkset(iset,ipix)%chunks(ichunk),&
                error)
           if (error) return
        enddo ! ichunk
     enddo ! iset
  enddo ! ipix
  !
end subroutine mrtcal_chunkset_2d_interpolate_do
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_chunkset_2d_blank(ref,blank,error)
  use class_types
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_2d_blank
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Create a blank 'chunkset_2d' (all 'bad' data), duplicate of the
  ! reference, with relevant sections blanked or kept.
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: ref
  type(chunkset_2d_t), intent(inout) :: blank
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ipix,iset,ichunk
  character(len=*), parameter :: rname='CHUNKSET2D>BLANK'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Clone and duplicate headers, in particular the spectroscopic axis
  ! description
  call blank%clone(ref,.true.,error)
  if (error)  return
  !
  ! Reset irrelevant header values
  do ipix=1,blank%npix
    do iset=1,blank%nset
      do ichunk=1,blank%chunkset(iset,ipix)%n
! *** JP Still to be done
!        blank%chunkset(iset,ipix)%chunks(ichunk)%pos%sourc = ''
      enddo
    enddo
  enddo
  !
  ! Blank data and continuum, 0 weight.
  call blank%init_data(class_bad,0.,class_bad,error)
  if (error) return
  !
end subroutine mrtcal_chunkset_2d_blank
!
subroutine mrtcal_chunkset_2d_accumulate_init(ref,acc,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_2d_accumulate_init
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! (Re)allocate and initialize a 'chunkset_2d' structure for future
  ! use in mrtcal_chunkset_2d_accumulate_2d.
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: ref
  type(chunkset_2d_t), intent(inout) :: acc
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ipix,iset,ichunk
  character(len=*), parameter :: rname='CHUNKSET2D>ACCUMULATE>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call acc%clone(ref,.true.,error)
  if (error)  return
  !
  ! Reset integration time in 'accumulate' instance
  do ipix=1,acc%npix
    do iset=1,acc%nset
      do ichunk=1,acc%chunkset(iset,ipix)%n
        acc%chunkset(iset,ipix)%chunks(ichunk)%gen%time = 0.
        acc%chunkset(iset,ipix)%chunks(ichunk)%swi%duree(:) = 0.
      enddo
    enddo
  enddo
  !
  ! Reset values and weights in 'accumulate' instance
  call acc%init_data(0.,0.,0.,error)
  if (error) return
  !
end subroutine mrtcal_chunkset_2d_accumulate_init
!
subroutine mrtcal_chunkset_3d_accumulate_init(ref,acc,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_3d_accumulate_init
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! (Re)allocate and initialize a 'chunkset_3d' structure for future
  ! use in mrtcal_chunkset_accumulate_do.
  !---------------------------------------------------------------------
  type(chunkset_3d_t), intent(in)    :: ref
  type(chunkset_3d_t), intent(inout) :: acc
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: itime,ipix,iset,ichunk
  character(len=*), parameter :: rname='CHUNKSET3D>ACCUMULATE>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call acc%clone(ref,.true.,error)
  if (error)  return
  !
  ! Reset integration time in 'accumulate' instance
  do itime=1,acc%ntime
    do ipix=1,acc%npix
      do iset=1,acc%nset
        do ichunk=1,acc%chunkset(iset,ipix,itime)%n
          acc%chunkset(iset,ipix,itime)%chunks(ichunk)%gen%time = 0.
          acc%chunkset(iset,ipix,itime)%chunks(ichunk)%swi%duree(:) = 0.
        enddo
      enddo
    enddo
  enddo
  !
  ! Reset values and weights in 'accumulate' instance
  call acc%init_data(0.,0.,0.,error)
  if (error) return
  !
end subroutine mrtcal_chunkset_3d_accumulate_init
!
subroutine mrtcal_chunkset_2d_accumulate_setweight(diff,tscale,dowei,error)
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_2d_accumulate_setweight
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! ZZZ
  ! Quick and dirty subroutine to enforce chunks dataw to something
  ! non-zero (needed by simple_waverage). Currently set to 1.0 i.e.
  ! equal weights. Should probably come early and cleverly e.g.
  ! weight equal, tsys, time, maybe in mrtcal_on_minus_off.
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(inout) :: diff
  type(chunkset_2d_t), intent(in)    :: tscale
  logical,             intent(in)    :: dowei   ! Compute real weights or dummy?
  logical,             intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ipix,iset
  !
  do ipix=1,diff%npix
    do iset=1,diff%nset
      call mrtcal_chunkset_accumulate_setweight(  &
        diff%chunkset(iset,ipix),    &
        tscale%chunkset(iset,ipix),  &
        dowei,error)
      if (error)  return
    enddo ! iset
  enddo ! ipix
  !
end subroutine mrtcal_chunkset_2d_accumulate_setweight
!
subroutine mrtcal_chunkset_3d_accumulate_setweight(diff,tscale,dowei,error)
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_3d_accumulate_setweight
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! ZZZ
  ! Quick and dirty subroutine to enforce chunks dataw to something
  ! non-zero (needed by simple_waverage). Currently set to 1.0 i.e.
  ! equal weights. Should probably come early and cleverly e.g.
  ! weight equal, tsys, time, maybe in mrtcal_on_minus_off.
  !---------------------------------------------------------------------
  type(chunkset_3d_t), intent(inout) :: diff
  type(chunkset_2d_t), intent(in)    :: tscale
  logical,             intent(in)    :: dowei   ! Compute real weights or dummy?
  logical,             intent(inout) :: error
  ! Local
  integer(kind=size_length) :: itime,ipix,iset
  !
  do itime=1,diff%ntime
    do ipix=1,diff%npix
      do iset=1,diff%nset
        call mrtcal_chunkset_accumulate_setweight(  &
          diff%chunkset(iset,ipix,itime),    &
          tscale%chunkset(iset,ipix),        &
          dowei,error)
        if (error)  return
      enddo ! iset
    enddo ! ipix
  enddo ! itime
  !
end subroutine mrtcal_chunkset_3d_accumulate_setweight
!
subroutine mrtcal_chunkset_2d_accumulate_do(in2d,ou2d,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_2d_accumulate_do
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Accumulate the input chunkset_2d into the running 'ou2d'
  ! chunkset_2d.
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: in2d
  type(chunkset_2d_t), intent(inout) :: ou2d
  logical,             intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ipix,iset
  character(len=*), parameter :: rname='CHUNKSET2D>ACCUMULATE>DO'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! ZZZ Something to be done on acc%corr?
  !
  ! ZZZ Something to be done on acc%isub? Makes probably no sense
  !
  do ipix=1,in2d%npix
    do iset=1,in2d%nset
      call mrtcal_chunkset_accumulate_do(  &
        in2d%chunkset(iset,ipix),    &
        ou2d%chunkset(iset,ipix),    &
        error)
    enddo ! iset
  enddo ! ipix
  !
end subroutine mrtcal_chunkset_2d_accumulate_do
!
subroutine mrtcal_chunkset_3d_accumulate_do(in3d,ou3d,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_3d_accumulate_do
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Accumulate the input chunkset_3d into the running 'ou3d'
  ! chunkset_3d.
  !---------------------------------------------------------------------
  type(chunkset_3d_t), intent(in)    :: in3d
  type(chunkset_3d_t), intent(inout) :: ou3d
  logical,             intent(inout) :: error
  ! Local
  integer(kind=size_length) :: itime,ipix,iset
  character(len=*), parameter :: rname='CHUNKSET3D>ACCUMULATE>DO'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! ZZZ Something to be done on acc%corr?
  !
  ! ZZZ Something to be done on acc%isub? Makes probably no sense
  !
  do itime=1,in3d%ntime  ! Not a time dimension here
    do ipix=1,in3d%npix
      do iset=1,in3d%nset
        call mrtcal_chunkset_accumulate_do(  &
          in3d%chunkset(iset,ipix,itime),    &
          ou3d%chunkset(iset,ipix,itime),    &
          error)
      enddo ! iset
    enddo ! ipix
  enddo ! itime
  !
end subroutine mrtcal_chunkset_3d_accumulate_do
!
subroutine mrtcal_chunkset_3d_append_init(ref,acc,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_3d_append_init
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! (Re)allocate and initialize a 'chunkset_3d' structure for future
  ! use in mrtcal_chunkset_append_do
  !---------------------------------------------------------------------
  type(chunkset_3d_t), intent(in)    :: ref
  type(chunkset_3d_t), intent(inout) :: acc
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: itime,ipix,iset
  character(len=*), parameter :: rname='CHUNKSET3D>APPEND>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call acc%clone(ref,.true.,error)
  if (error)  return
  !
  ! In append mode, the 'acc' object must start with 0 chunk in
  ! each chunkset. Just nullify their number in use (chunkset%n).
  ! Avoid deallocation as we will reallocate soon.
  do itime=1,acc%ntime
    do ipix=1,acc%npix
      do iset=1,acc%nset
        acc%chunkset(iset,ipix,itime)%n = 0
      enddo
    enddo
  enddo
  !
end subroutine mrtcal_chunkset_3d_append_init
!
subroutine mrtcal_chunkset_3d_append_do(in3d,ou3d,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_3d_append_do
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Append the input chunkset_3d into the running 'ou3d'
  ! chunkset_3d.
  !---------------------------------------------------------------------
  type(chunkset_3d_t), intent(in)    :: in3d
  type(chunkset_3d_t), intent(inout) :: ou3d
  logical,             intent(inout) :: error
  ! Local
  integer(kind=size_length) :: itime,ipix,iset
  character(len=*), parameter :: rname='CHUNKSET3D>APPEND>DO'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! ZZZ Something to be done on acc%corr?
  !
  ! ZZZ Something to be done on acc%isub? Makes probably no sense
  !
  do itime=1,in3d%ntime  ! Not a time dimension here
    do ipix=1,in3d%npix
      do iset=1,in3d%nset
        call mrtcal_chunkset_append_do(  &
          in3d%chunkset(iset,ipix,itime),    &
          ou3d%chunkset(iset,ipix,itime),    &
          error)
      enddo ! iset
    enddo ! ipix
  enddo ! itime
  !
end subroutine mrtcal_chunkset_3d_append_do
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_chunkset_2d_noise_init(chunkset_2d,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_noise_init
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(inout) :: chunkset_2d
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ipix,iset,ichunk
  type(chunkset_t), pointer :: chunkset
  character(len=*), parameter :: rname='CHUNKSET2D>NOISE>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do ipix=1,chunkset_2d%npix
     do iset=1,chunkset_2d%nset
        chunkset => chunkset_2d%chunkset(iset,ipix)
        do ichunk=1,chunkset%n
           call mrtcal_chunk_noise_init(chunkset%chunks(ichunk),error)
           if (error)  return
        enddo ! ichunk
     enddo ! iset
  enddo ! ipix
  !
end subroutine mrtcal_chunkset_2d_noise_init
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!*********************************************************************
! INTEGER*8 Generic External three argument function on vectors
!
subroutine do_long_loop3 (func,n,result,m1,oper1,m2,oper2,m3,oper3,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           external      :: func      !
  integer(kind=size_length)                :: n         !
  integer(kind=8)                          :: result(n) !
  integer(kind=size_length)                :: m1        !
  integer(kind=8)                          :: oper1(m1) !
  integer(kind=size_length)                :: m2        !
  integer(kind=8)                          :: oper2(m2) !
  integer(kind=size_length)                :: m3        !
  integer(kind=8)                          :: oper3(m3) !
  logical,                   intent(inout) :: error     !
  ! Local
  integer(kind=8) :: r,a,b,c
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1 .and. m2.eq.1 .and. m3.eq.1) then
    r = func(oper1(1),oper2(1),oper3(1))
    do i=1,n
      result(i) = r
    enddo
  elseif (m1.eq.n .and. m2.eq.1 .and. m3.eq.1) then
    b = oper2(1)
    c = oper3(1)
    do i=1,n
      result(i) = func(oper1(i),b,c)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n .and. m3.eq.1) then
    a = oper1(1)
    c = oper3(1)
    do i=1,n
      result(i) = func(a,oper2(i),c)
    enddo
  elseif (m1.eq.n .and. m2.eq.n .and. m3.eq.1) then
    c = oper3(1)
    do i=1,n
      result(i) = func(oper1(i),oper2(i),c)
    enddo
  elseif (m1.eq.1 .and. m2.eq.1 .and. m3.eq.n) then
    a = oper1(1)
    b = oper2(1)
    do i=1,n
      result(i) = func(a,b,oper3(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.1 .and. m3.eq.n) then
    b = oper2(1)
    do i=1,n
      result(i) = func(oper1(i),b,oper3(i))
    enddo
  elseif (m1.eq.1 .and. m2.eq.n .and. m3.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = func(a,oper2(i),oper3(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n .and. m3.eq.n) then
    do i=1,n
      result(i) = func(oper1(i),oper2(i),oper3(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2,m3
    call sic_message(seve%e,'I_FUNC',mess)
    error = .true.
  endif
end subroutine do_long_loop3
!
!*********************************************************************
! INTEGER*8 Generic External two argument function on vectors
!
subroutine do_long_loop2 (func,n,result,m1,oper1,m2,oper2,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           external      :: func      !
  integer(kind=size_length)                :: n         !
  integer(kind=8)                          :: result(n) !
  integer(kind=size_length)                :: m1        !
  integer(kind=8)                          :: oper1(m1) !
  integer(kind=size_length)                :: m2        !
  integer(kind=8)                          :: oper2(m2) !
  logical,                   intent(inout) :: error     !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1 .and. m2.eq.1) then
    a = func(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = func(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = func(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = func(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_FUNC',mess)
    error = .true.
  endif
end subroutine do_long_loop2
!
!----------------------------------------------------------------------
! INTEGER*8 Two operands arithmetic operations on vectors
!
function lsic_i_bplus (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bplus   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_bplus = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)+oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)+a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a+oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)+oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_BPLUS',mess)
    lsic_i_bplus = 1
  endif
end function lsic_i_bplus
!
function lsic_i_bminus (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bminus  !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_bminus = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)-oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)-a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a-oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)-oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_BMINUS',mess)
    lsic_i_bminus = 1
  endif
end function lsic_i_bminus
!
function lsic_i_mul (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_mul     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_mul = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)*oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)*a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a*oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)*oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_MUL',mess)
    lsic_i_mul = 1
  endif
end function lsic_i_mul
!
function lsic_i_div (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Integer division: what should be the rule with negative operands?
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_div     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  integer(kind=8), parameter :: i_pinf=9223372036854775807_8  ! 2**63-1
  integer(kind=8), parameter :: i_minf=-i_pinf-1              ! -2**63
  integer(kind=8), parameter :: i_nan=0
  !
  lsic_i_div = 0
  if (m1.eq.1 .and. m2.eq.1) then
    if (oper2(1).ne.0) then
      a = int(oper1(1)/oper2(1),8)  ! Wrong (precision loss)?
    elseif (oper1(1).gt.0) then
      a = i_pinf
    elseif  (oper1(1).lt.0) then
      a = i_minf
    else
      a = i_nan
    endif
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      if (a.ne.0) then
        result(i) = int(oper1(i)/a,8)  ! Wrong (precision loss)?
      elseif  (oper1(i).gt.0) then
        result(i) = i_pinf
      elseif  (oper1(i).lt.0) then
        result(i) = i_minf
      else
        result(i) = i_nan
      endif
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      if (oper2(i).ne.0) then
        result(i) = int(a/oper2(i),8)  ! Wrong (precision loss)?
      elseif  (a.gt.0) then
        result(i) = i_pinf
      elseif  (a.lt.0) then
        result(i) = i_minf
      else
        result(i) = i_nan
      endif
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      if (oper2(i).ne.0) then
        result(i) = int(oper1(i)/oper2(i),8)  ! Wrong (precision loss)?
      elseif  (oper1(i).gt.0) then
        result(i) = i_pinf
      elseif  (oper1(i).lt.0) then
        result(i) = i_minf
      else
        result(i) = i_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_DIV',mess)
    lsic_i_div = 1
  endif
end function lsic_i_div
!
function lsic_i_power (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_power   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_power = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)**oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)**a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a**oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)**oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_POWER',mess)
    lsic_i_power = 1
  endif
end function lsic_i_power
!
!----------------------------------------------------------------------
! INTEGER*8 Two argument functions on vectors
!
function lsic_i_min (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_min     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_min = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = min(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = min(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = min(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = min(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_MIN',mess)
    lsic_i_min = 1
  endif
end function lsic_i_min
!
function lsic_i_max (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_max     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_max = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = max(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = max(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = max(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = max(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_MAX',mess)
    lsic_i_max = 1
  endif
end function lsic_i_max
!
function lsic_i_atan2 (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_atan2   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ATAN2','Not implemented')
  lsic_i_atan2 = 1
  !
end function lsic_i_atan2
!
function lsic_i_dim (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_dim     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_dim = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = dim(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = dim(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = dim(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = dim(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_DIM',mess)
    lsic_i_dim = 1
  endif
end function lsic_i_dim
!
function lsic_i_sign (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_sign    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_sign = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = sign(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = sign(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = sign(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = sign(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_SIGN',mess)
    lsic_i_sign = 1
  endif
end function lsic_i_sign
!
function lsic_i_mod (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_mod     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_mod = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = mod(oper1(1),oper2(1))
    if (a.lt.0.0) a = a+oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = mod(oper1(i),a)
      if (result(i).lt.0.0) result(i) = result(i)+a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = mod(a,oper2(i))
      if (result(i).lt.0.0) result(i) = result(i)+oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = mod(oper1(i),oper2(i))
      if (result(i).lt.0.0) result(i) = result(i)+oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_MOD',mess)
    lsic_i_mod = 1
  endif
end function lsic_i_mod
!
!----------------------------------------------------------------------
! INTEGER*8 Generic External single argument function on vector
!
subroutine do_long_loop1(func,n,result,m1,oper1,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           external      :: func       !
  integer(kind=size_length)                :: n          !
  integer(kind=8)                          :: result(n)  !
  integer(kind=size_length)                :: m1         !
  integer(kind=8)                          :: oper1(m1)  !
  logical,                   intent(inout) :: error      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1) then
    a = func(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = func(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_FUNC',mess)
    error = .true.
  endif
end subroutine do_long_loop1
!
!----------------------------------------------------------------------
! INTEGER*8 Single argument functions on vectors
!
function lsic_i_abs (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_abs     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_abs = 0
  if (m1.eq.1) then
    a = abs(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = abs(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_ABS',mess)
    lsic_i_abs = 1
  endif
end function lsic_i_abs
!
function lsic_i_acos (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_acos    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ACOS','Not implemented')
  lsic_i_acos = 1
  !
end function lsic_i_acos
!
function lsic_i_asin (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_asin    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ASIN','Not implemented')
  lsic_i_asin = 1
  !
end function lsic_i_asin
!
function lsic_i_atan (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_atan    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ATAN','Not implemented')
  lsic_i_atan = 1
  !
end function lsic_i_atan
!
function lsic_i_atanh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_atanh   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ATANH','Not implemented')
  lsic_i_atanh = 1
  !
end function lsic_i_atanh
!
function lsic_i_cos (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_cos     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_COS','Not implemented')
  lsic_i_cos = 1
  !
end function lsic_i_cos
!
function lsic_i_cosh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_cosh    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_COSH','Not implemented')
  lsic_i_cosh = 1
  !
end function lsic_i_cosh
!
function lsic_i_exp (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_exp     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_EXP','Not implemented')
  lsic_i_exp = 1
  !
end function lsic_i_exp
!
function lsic_i_int (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_int     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_int = 0
  if (m1.eq.1) then
    a = oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_INT',mess)
    lsic_i_int = 1
  endif
end function lsic_i_int
!
function lsic_i_log (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_log     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_LOG','Not implemented')
  lsic_i_log = 1
  !
end function lsic_i_log
!
function lsic_i_log10 (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_log10   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_LOG10','Not implemented')
  lsic_i_log10 = 1
  !
end function lsic_i_log10
!
function lsic_i_nint (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_nint    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_nint = 0
  if (m1.eq.1) then
    a = oper1(1)  ! NINT on int value => simple copy
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_NINT',mess)
    lsic_i_nint = 1
  endif
end function lsic_i_nint
!
function lsic_i_sin (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_sin     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_SIN','Not implemented')
  lsic_i_sin = 1
  !
end function lsic_i_sin
!
function lsic_i_sinh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_sinh    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_SINH','Not implemented')
  lsic_i_sinh = 1
  !
end function lsic_i_sinh
!
function lsic_i_sqrt (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_sqrt    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_SQRT','Not implemented')
  lsic_i_sqrt = 1
  !
end function lsic_i_sqrt
!
function lsic_i_tan (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_tan     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_TAN','Not implemented')
  lsic_i_tan = 1
  !
end function lsic_i_tan
!
function lsic_i_tanh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_tanh    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_TANH','Not implemented')
  lsic_i_tanh = 1
  !
end function lsic_i_tanh
!
function lsic_i_floor (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_floor   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_floor = 0
  if (m1.eq.1) then
    a = oper1(1)  ! FLOOR on int value => simple copy
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_FLOOR',mess)
    lsic_i_floor = 1
  endif
end function lsic_i_floor
!
function lsic_i_ceiling (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_ceiling  !
  integer(kind=size_length) :: n     !
  integer(kind=8) :: result(n)       !
  integer(kind=size_length) :: m1    !
  integer(kind=8) :: oper1(m1)       !
  integer(kind=size_length) :: k     !
  integer :: dummy                   !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_ceiling = 0
  if (m1.eq.1) then
    a = oper1(1)  ! CEILING on int value => simple copy
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_CEILING',mess)
    lsic_i_ceiling = 1
  endif
end function lsic_i_ceiling
!
function lsic_i_uminus (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_uminus  !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_uminus = 0
  if (m1.eq.1) then
    a = -oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = -oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_UMINUS',mess)
    lsic_i_uminus = 1
  endif
end function lsic_i_uminus
!
function lsic_i_uplus (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_uplus   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_uplus = 0
  if (m1.eq.1) then
    a = oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_PLUS',mess)
    lsic_i_uplus = 1
  endif
end function lsic_i_uplus
!
function lsic_i_pyfunc (noper,nelem,nwords,n,result)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! INTEGER*8 Generic PYTHON function with variable number of arguments
  !        Called by DO_VECTOR
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_pyfunc  ! Function value on return
  integer(kind=4),              intent(in)  :: noper          ! Number of operands
  integer(kind=size_length),    intent(in)  :: nelem(noper)   ! # of elements for each operand
  integer(kind=address_length), intent(in)  :: nwords(noper)  ! Memory location for each operand
  integer(kind=size_length),    intent(in)  :: n              ! Size of result
  integer(kind=8),              intent(out) :: result(n)      ! Result
  !
  ! Check dimensions and construct strides
#if defined(GAG_USE_PYTHON)
  ! C does not have an equivalent for integer*8 on all platforms...
  result(:) = 0
  call sic_message(seve%e,'I_PYFUNC','Not implemented')
  lsic_i_pyfunc = 1
#else
  call sic_message(seve%e,'I_PYFUNC','Python not available')
  lsic_i_pyfunc = 1
#endif
end function lsic_i_pyfunc
!
function lsic_i_erf(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_erf    !
  integer(kind=size_length) :: n   !
  integer(kind=8) :: result(n)     !
  integer(kind=size_length) :: m1  !
  integer(kind=8) :: oper1(m1)     !
  integer(kind=size_length) :: k   !
  integer :: dummy                 !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ERF','Not implemented')
  lsic_i_erf = 1
  !
end function lsic_i_erf
!
function lsic_i_erfc(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_erfc   !
  integer(kind=size_length) :: n   !
  integer(kind=8) :: result(n)     !
  integer(kind=size_length) :: m1  !
  integer(kind=8) :: oper1(m1)     !
  integer(kind=size_length) :: k   !
  integer :: dummy                 !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ERFC','Not implemented')
  lsic_i_erfc = 1
  !
end function lsic_i_erfc
!
function lsic_i_erfinv(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_erfinv  !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ERFINV','Not implemented')
  lsic_i_erfinv = 1
  !
end function lsic_i_erfinv
!
function lsic_i_erfcinv(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_erfcinv  !
  integer(kind=size_length) :: n     !
  integer(kind=8) :: result(n)       !
  integer(kind=size_length) :: m1    !
  integer(kind=8) :: oper1(m1)       !
  integer(kind=size_length) :: k     !
  integer :: dummy                   !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ERFCINV','Not implemented')
  lsic_i_erfcinv = 1
  !
end function lsic_i_erfcinv
!
function lsic_i_bessel_i0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_i0  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_I0','Not implemented')
  lsic_i_bessel_i0 = 1
  !
end function lsic_i_bessel_i0
!
function lsic_i_bessel_i1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_i1  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_I1','Not implemented')
  lsic_i_bessel_i1 = 1
  !
end function lsic_i_bessel_i1
!
function lsic_i_bessel_in(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_in  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_IN','Not implemented')
  lsic_i_bessel_in = 1
  !
end function lsic_i_bessel_in
!
function lsic_i_bessel_j0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_j0  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_J0','Not implemented')
  lsic_i_bessel_j0 = 1
  !
end function lsic_i_bessel_j0
!
function lsic_i_bessel_j1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_j1  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_J1','Not implemented')
  lsic_i_bessel_j1 = 1
  !
end function lsic_i_bessel_j1
!
function lsic_i_bessel_jn(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_jn  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_JN','Not implemented')
  lsic_i_bessel_jn = 1
  !
end function lsic_i_bessel_jn
!
function lsic_i_bessel_y0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_y0  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_Y0','Not implemented')
  lsic_i_bessel_y0 = 1
  !
end function lsic_i_bessel_y0
!
function lsic_i_bessel_y1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_y1  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_Y1','Not implemented')
  lsic_i_bessel_y1 = 1
  !
end function lsic_i_bessel_y1
!
function lsic_i_bessel_yn(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_yn  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_YN','Not implemented')
  lsic_i_bessel_yn = 1
  !
end function lsic_i_bessel_yn

!-----------------------------------------------------------------------
! ZZZ Attacher du texte aux png
! ZZZ Quid si l'utilisateur a modifie ses pens?
! ZZZ DEVICE PNG BLACK devrait changer cette variable x_back (dans le
!     tdf) (cf combinaison grey+black)
! ZZZ En mode grey, la couleur des segments est mal convertie.
! ZZZ Utilisation en device principal? CLEAR?
! ZZZ Tout documenter
! ZZZ Renommer gi4_bltlis.
! ZZZ Supprimer les globaux en C puis Fortran
!-----------------------------------------------------------------------
!
module gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! Variables and parameters for PNG devices support
  !---------------------------------------------------------------------
  !
  integer(kind=4), parameter :: pngmap_size = 65536  ! i.e. the most we
    ! can encode in integers of KIND=BITMAP_DEPTH == 2
  integer(kind=4), parameter :: pngmap_offset = -32768  ! i.e. encode the
    ! 65536 colors from -32768 to 32767
  !
  ! Some integer*1 typical values
  integer(kind=1) :: i0,i255
  integer(kind=1) :: dummy  ! Used when some of the channels are not used
  !
end module gtv_png
!
subroutine png_open(output,error,dir)
  use gtv_interfaces, except_this=>png_open
  use gtv_png
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Open the PNG output file.
  !---------------------------------------------------------------------
  type(gt_display),   intent(inout)        :: output  ! Output instance
  logical,            intent(inout)        :: error   ! Logical error flag
  type(gt_directory), intent(in), optional :: dir     ! The directory to display, or
#if defined(PNG)
  ! Local
  character(len=*), parameter :: rname='PNG_OPEN'
  integer :: ier,npixx,npixy
  integer(kind=1) :: ibackground,itransparency
  character(len=message_length) :: mess
  !
  if (output%file.eq.' ' .and. output%tofile) then
    call gtv_message(seve%e,rname,'File name is missing')
    error = .true.
    return
  endif
  !
  ! Initialize some shared values
  i0   = si4_to_ui1(0)
  i255 = si4_to_ui1(255)
  !
  ! Black or white device?
  if (output%background.eq.0) then
    ibackground = i0
  else
    ibackground = i255
  endif
  !
  ! Transparent background or not?
  if (output%png%transparency) then
    itransparency = i0
  else
    itransparency = i255
  endif
  !
  ! Set number of channels (planes). Use it also as a unique identifier since
  ! there is no ambiguity between the number of channels and the different
  ! available devices.
  if (output%color) then
    output%png%nchan = 3
  else
    output%png%nchan = 1  ! (grey)
  endif
  if (output%png%transparency)  output%png%nchan = output%png%nchan+1
  !
  if (output%png%cropped .and. present(dir)) then
    ! Crop the area viewed by the PNG instance
    call gt_hardcopy_crop(output,dir,error)
    if (error)  return
  endif
  !
  ! Use the actual number of pixels of the output instance.
  npixx = output%px2
  npixy = output%py2
  !
  ! Buffer allocation
  select case (output%png%nchan)
  case(1)
    allocate(output%png%R(npixx,npixy),stat=ier)
  case(2)
    allocate(output%png%R(npixx,npixy),  &
             output%png%A(npixx,npixy),stat=ier)
  case(3)
    allocate(output%png%R(npixx,npixy),  &
             output%png%G(npixx,npixy),  &
             output%png%B(npixx,npixy),stat=ier)
  case(4)
    allocate(output%png%R(npixx,npixy),  &
             output%png%G(npixx,npixy),  &
             output%png%B(npixx,npixy),  &
             output%png%A(npixx,npixy),stat=ier)
  case default
    call gtv_message(seve%e,rname,"Internal error, unsupported number of channels")
    error = .true.
    return
  end select
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,"Internal error, R/G/B/A allocation failed")
    error = .true.
    return
  endif
  !
  ier = gpng_zopen(output%file,len_trim(output%file),npixx,npixy,output%png%nchan)
  if (ier.ne.0) then
    write(mess,'(A,A,A,3(I0,A))') 'Error creating file ',trim(output%file),  &
      ': ',npixx,' x ',npixy,' pixels x ',output%png%nchan,' channels'
    call gtv_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Initialize the arrays
  output%png%R = ibackground
  if (output%png%nchan.ge.3) then
    output%png%G = ibackground
    output%png%B = ibackground
  endif
  if (output%png%transparency)  output%png%A = itransparency
  !
  ! Initialize the colormap
  ! ZZZ Do something: we may not want to use LUT 0 e.g. in grey mode
  ! call load_lut(output%map,.true.,output%color,0,error)
  ! if (error)  return
  !
#else
  call gtv_message(seve%e,'HARDCOPY','No PNG support on this system')
  error = .true.
  return
#endif
  !
end subroutine png_open
!
subroutine png_close(output,desc)
  use gtv_interfaces, except_this=>png_close
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Close the current PNG device, i.e. copy the rows to the file
  ! opened by the C routines, and close it.
  !---------------------------------------------------------------------
  type(gt_display),       intent(inout) :: output
  real(kind=4), optional, intent(in)    :: desc(4)
#if defined(PNG)
  ! Local
  integer(kind=4) :: row
  !
  do row=output%py2,1,-1
    select case (output%png%nchan)
    case (1)
      call gpng_copy_data(row,  &
                          output%png%R(1,row),  &
                          dummy,                &
                          dummy,                &
                          dummy)
    case (2)
      call gpng_copy_data(row,  &
                          output%png%R(1,row),  &
                          dummy,                &
                          dummy,                &
                          output%png%A(1,row))
    case (3)
      call gpng_copy_data(row,  &
                          output%png%R(1,row),  &
                          output%png%G(1,row),  &
                          output%png%B(1,row),  &
                          dummy)
    case (4)
      call gpng_copy_data(row,  &
                          output%png%R(1,row),  &
                          output%png%G(1,row),  &
                          output%png%B(1,row),  &
                          output%png%A(1,row))
    end select
  enddo
  !
  call gpng_finish()
  !
  if (.not.output%tofile)  call png_base64(output,desc)
  !
  call gpng_cleanup()
  !
  if (allocated(output%png%R)) deallocate(output%png%R)
  if (allocated(output%png%G)) deallocate(output%png%G)
  if (allocated(output%png%B)) deallocate(output%png%B)
  if (allocated(output%png%A)) deallocate(output%png%A)
  !
#endif
end subroutine png_close
!
subroutine png_base64(output,desc)
  use gildas_def
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>png_base64
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Dump the PNG currently in memory with base 64 encoding. This makes
  ! sense only for memory only PNG, which have no associated file on
  ! disk.
  !  Because the output is not the (binary) PNG but an encoded form,
  ! a header and footer are added.
  !---------------------------------------------------------------------
  type(gt_display),       intent(in) :: output
  real(kind=4), optional, intent(in) :: desc(4)
#if defined(PNG)
  ! Local
  integer(kind=4) :: memory(2),size
  integer(kind=address_length) :: addr,ip
  !
  ! Get the memory buffer address
  call gpng_getbuf(size,addr)  ! ZZZ sanity check
  !
  ! --- Header ---
  !
  if (present(desc)) then
    ! Reference position and image size (in device units), suited for
    ! embedding in SVG
    !
    write(output%iunit,'(5(A,F0.1))')  &
      '<image preserveAspectRatio="none" x="',desc(1),'" y="',desc(2),  &
      '" width="',desc(3),'" height="',desc(4),'" xlink:href="data:image/png;base64,'
    !
  else
    ! More basic header. Relative position does not make sense
    write(output%iunit,'(A,I0,A,I0,A)')  &
      '<image width="',output%px2,'" height="',output%py2,'" xlink:href="data:image/png;base64,'
  endif
  !
  ! --- Data ---
  ! Pass the C buffer and convert it to base-64
  ip = gag_pointer(addr,memory)
  call base64_encode(memory(ip),size,output%iunit)
  !
  ! --- Footer ---
  write(output%iunit,'(A)') '"/>'
  !
#endif
end subroutine png_base64
!
subroutine png_hard(out)
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  !
  !
  ! Dash
  if (out%idashe.ne.1) then
    out%dev%hardw_line_dash = .false.
  else
    out%dev%hardw_line_dash = .true.
  endif
  !
  ! Weight. Always use hardware thickness generator. Take care
  ! that simulating thickness with gtx_chopper draws several lines
  ! on each side of the original line, which can lead to negative
  ! positions in cropped PNG => error!
  out%dev%hardw_line_weig = .true.
  !
end subroutine png_hard
!
subroutine png_pen_negative(out)
  use gtv_interfaces, except_this=>png_pen_negative
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current pen as negative, i.e. invert pixels below
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  ! The PNG instance
#if defined(PNG)
  !
  out%png%negative = .true.
  ! Put some grey just safety. Normally unused.
  out%png%rpen = si4_to_ui1(128)
  out%png%gpen = si4_to_ui1(128)
  out%png%bpen = si4_to_ui1(128)
  !
#endif
end subroutine png_pen_negative
!
subroutine png_pen_rgb(out,r,g,b)
  use gtv_interfaces, except_this=>png_pen_rgb
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current pen from the input R G B values (0-255)
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! The PNG instance
  integer(kind=4),  intent(in)    :: r,g,b  !
#if defined(PNG)
  !
  out%png%negative = .false.
  out%png%rpen = si4_to_ui1(r)
  out%png%gpen = si4_to_ui1(g)
  out%png%bpen = si4_to_ui1(b)
  !
#endif
end subroutine png_pen_rgb
!
subroutine png_weigh(out,width)
  use gtv_interfaces, except_this=>png_weigh
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current pen width. Note that we may get a 0 width, which
  ! means "hairline" (smallest possible on the device)
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! The PNG instance
  integer(kind=4),  intent(in)    :: width  ! New pen width (pixels)
  !
  out%png%width = max(width,1)
end subroutine png_weigh
!
subroutine png_moveto(out,x,y)
  use gtv_interfaces, except_this=>png_moveto
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Move the pen to the input location
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  ! Input gt_display
  real(kind=4),     intent(in)    :: x,y  ! New pen coordinates, in world coordinates
  !
  call world_to_pixel(out,x,y,out%png%xpos,out%png%ypos)
  !
end subroutine png_moveto
!
subroutine png_lineto(out,x,y)
  use gtv_interfaces, except_this=>png_lineto
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw a line from current pen position to input location, simulating
  ! its thickness if needed.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  ! Input gt_display
  real(kind=4),     intent(in)    :: x,y  ! Draw line down to this location, in world coordinates
  ! Local
  real(kind=4) :: xend,yend
  !
  call world_to_pixel(out,x,y,xend,yend)
  !
  call png_wline(out,out%png%xpos,out%png%ypos,xend,yend)
  !
  out%png%xpos = xend
  out%png%ypos = yend
  !
end subroutine png_lineto
!
subroutine png_wline(out,xr1,yr1,xr2,yr2)
  use gtv_interfaces, except_this=>png_wline
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Draw a line from (x1,y1) to (x2,y2), simulating its width by
  ! drawing several 1-pixel lines
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out      ! Input gt_display
  real(kind=4),     intent(in) :: xr1,yr1  !
  real(kind=4),     intent(in) :: xr2,yr2  !
  ! Local
  real(kind=4) :: dx,dy
  integer(kind=4) :: iw,x1,x2,y1,y2,start
  !
  if ((xr2-xr1).gt.(yr2-yr1)) then
    ! Line is rather horizontal
    dx = 0.
    dy = 1.
  else
    ! Line is rather vertical
    dx = 1.
    dy = 0.
  endif
  !
  if (out%png%width.eq.1) then
    start = 0
  else
    start = -out%png%width/2
  endif
  do iw=start,start+out%png%width-1
    !
    x1 = nint(xr1+iw*dx)
    y1 = nint(yr1+iw*dy)
    x2 = nint(xr2+iw*dx)
    y2 = nint(yr2+iw*dy)
    !
    ! ---------------------
    !  BOUNDARY conditions
    !
    ! The way the scale is defined (see details in subroutine get_scale_awd) for
    ! cropped PNG, there must be one (poly)line summit which starts exactly at the
    ! left of the device, i.e. left of first pixel, i.e. coordinate 0.5. Same for
    ! right limit. Because of nint() rounding, this means that these coordinates
    ! may overflow beyond the device range. No better way than bringing them back
    ! into the range. Again, this is for the boundary conditions where we want:
    !  Left  boundary =   0.5 -> pixel 1
    !  Right boundary = N+0.5 -> pixel N
    ! nint() does not satisfy this rule... Apart from this boundary problem, nint()
    ! is correct. If a line summit is exactly at position i+0.5, we can ambiguously
    ! make it start in pixel i or i+1. We let nint() decide arbitrarily.
    if (x1.lt.out%px1)  x1 = out%px1
    if (x1.gt.out%px2)  x1 = out%px2
    if (x2.lt.out%px1)  x2 = out%px1
    if (x2.gt.out%px2)  x2 = out%px2
    if (y1.lt.out%py1)  y1 = out%py1
    if (y1.gt.out%py2)  y1 = out%py2
    if (y2.lt.out%py1)  y2 = out%py1
    if (y2.gt.out%py2)  y2 = out%py2
    ! ---------------------
    !
    call png_line(out,x1,y1,x2,y2)
    !
  enddo
  !
end subroutine png_wline
!
subroutine png_line(out,x1,y1,x2,y2)
  use gtv_interfaces, except_this=>png_line
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Draw a 1 pixel-wide line from (x1,y1) to (x2,y2), using Bresenham
  ! algorithm. See e.g.
  !  http://tech-algorithm.com/articles/drawing-line-using-bresenham-algorithm/
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out    ! Input gt_display
  integer(kind=4),  intent(in) :: x1,y1  !
  integer(kind=4),  intent(in) :: x2,y2  !
  ! Local
  integer(kind=4) :: x,y,dx1,dy1,dx2,dy2
  integer(kind=4) :: w,h,longest,shortest,numerator,i
  !
  dx1 = 0
  dy1 = 0
  dx2 = 0
  dy2 = 0
  !
  w = x2-x1
  h = y2-y1
  !
  if (w.lt.0) then
    dx1 = -1
  elseif (w.gt.0) then
    dx1 = +1
  endif
  if (h.lt.0) then
    dy1 = -1
  elseif (h.gt.0) then
    dy1 = +1
  endif
  if (w.lt.0) then
    dx2 = -1
  elseif (w.gt.0) then
    dx2 = +1
  endif
  !
  longest = abs(w)
  shortest = abs(h)
  if (longest.le.shortest) then
    longest = abs(h)
    shortest = abs(w)
    if (h.lt.0) then
      dy2 = -1
    elseif (h.gt.0) then
      dy2 = +1
    endif
    dx2 = 0
  endif
  !
  numerator = longest/2
  x = x1
  y = y1
  do i=0,longest
    call png_point(out,x,y)
    numerator = numerator+shortest
    if (numerator.ge.longest) then
      numerator = numerator-longest
      x = x+dx1
      y = y+dy1
    else
      x = x+dx2
      y = y+dy2
    endif
  enddo
  !
end subroutine png_line
!
subroutine png_fill(out,n,xr,yr)
  use gtv_interfaces, except_this=>png_fill
  use gtv_types
  use gtv_png
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! Fill the input polygon
  !---------------------------------------------------------------------
  ! ZZZ Nettoyer cette routine (noms, etc)
  type(gt_display), intent(inout) :: out    ! Input gt_display
  integer,          intent(in)    :: n      ! Number of summits
  real*4,           intent(in)    :: xr(n)  ! X coordinates, in world units
  real*4,           intent(in)    :: yr(n)  ! Y coordinates, in world units
  ! Local
  integer(kind=4) :: i,iy,lnx,nr(2),j, miny, maxy
  integer(kind=4) :: x(n),y(n),ixl(n),ixu(n)  ! Automatic arrays
  !
  ! Calculation of pixel coordinates
  miny = min(out%py1,out%py2)  ! ZZZ Check this
  maxy = max(out%py1,out%py2)
  do i = 1, n
    call world_to_pixel(out,xr(i),yr(i),x(i),y(i))
    miny = min(miny, y(i))
    maxy = max(maxy, y(i))
  enddo
  !
  nr(1) = n
  do iy = miny,maxy
    ! Calculate all x inside the polygons for row #iy
    call gi4_bltlis(1,1,1,nr,x,y,iy,lnx,ixl,ixu)
    do j = 1, lnx
      call png_line(out,ixl(j),iy,ixu(j),iy)
    enddo
  enddo
  !
end subroutine png_fill
!
subroutine png_points(out,n,xr,yr)
  use gtv_interfaces, except_this=>png_points
  use gtv_types
  use gtv_png
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !   Draw dot-points at input coordinates (world units)
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! Input gt_display
  integer(kind=4),  intent(in)    :: n      ! Number of summits
  real(kind=4),     intent(in)    :: xr(n)  ! X coordinates, in world units
  real(kind=4),     intent(in)    :: yr(n)  ! Y coordinates, in world units
  ! Local
  integer(kind=4) :: i
  integer(kind=4) :: xp,yp
  !
  do i=1,n
    call world_to_pixel(out,xr(i),yr(i),xp,yp)
    call png_point(out,xp,yp)
  enddo
  !
end subroutine png_points
!
subroutine gti_pngimage(out,image)
  use gtv_interfaces, except_this=>gti_pngimage
  use gildas_def
  use gtv_bitmap
  use gtv_buffers
  use gtv_plot
  use gtv_types
  use gtv_tree
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Load the image to be drawn in the PNG device
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! Input gt_display
  type(gt_image),   intent(in)    :: image  ! Image instance
  ! Local
  character(len=*), parameter :: rname='PNGIMAGE'
  real(kind=4) :: clip(4),trans(4)
  integer(kind=4) :: window(4),ier
  type(gt_lut), pointer :: lut
  type(gt_bitmap) :: bitmap
  logical :: visible
  character(len=message_length) :: mess
  !
  ! Check the clipping box
  call clip_image(out,  &
    image%r%taille(1),  &
    image%r%taille(2),  &
    image%conv,         &
    image%position,     &
    image%limits,       &
    .true.,             &  ! Always resample to device pixels
    1.0,                &  ! Resampling factor (1 = no extra factor)
    visible,clip,window,trans)
  if (.not.visible)  return
  !
  ! Some debuging feedback
  write(mess,'(5(A,I0))')  'Image size is ',window(1),'x',window(2),  &
    ', corner at position (',window(3),',',window(4),') in the PNG'
  call gtv_message(seve%d,rname,mess)
  write(mess,'(A,F0.7,A,F0.7,A)')  'Ximag(Xpng) = ',trans(2),' + ',trans(1),'*Xpng'
  call gtv_message(seve%d,rname,mess)
  write(mess,'(A,F0.7,A,F0.7,A)')  'Yimag(Xpng) = ',trans(4),' + ',trans(3),'*Ypng'
  call gtv_message(seve%d,rname,mess)
  !
  if (.not.image%isrgb) then
    ! Image is indexed: which LUT use?
    if (associated(image%lut)) then
      lut => image%lut  ! Custom LUT
      call gti_lut(out,lut)  ! Load this LUT, in case it is not yet
    else
      lut => gbl_colormap  ! Global LUT
    endif
  endif
  !
  ! Allocate the new resampled image
  bitmap%size(1) = window(1)
  bitmap%size(2) = window(2)
  bitmap%position(1) = window(3)
  bitmap%position(2) = window(4)
  bitmap%trans = trans
  if (image%isrgb) then
    allocate(bitmap%irvalues(window(1),window(2)),  &
             bitmap%igvalues(window(1),window(2)),  &
             bitmap%ibvalues(window(1),window(2)),stat=ier)
  else
    allocate(bitmap%irvalues(window(1),window(2)),stat=ier)
    bitmap%igvalues => null()
    bitmap%ibvalues => null()
  endif
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Memory allocation failure')
    return
  endif
  !
  ! Get it from memory...
  call gti_pngmap(image,out,bitmap,lut)
  !
  if (associated(bitmap%irvalues))  deallocate(bitmap%irvalues)
  if (associated(bitmap%igvalues))  deallocate(bitmap%igvalues)
  if (associated(bitmap%ibvalues))  deallocate(bitmap%ibvalues)
  !
end subroutine gti_pngimage
!
subroutine gti_pngmap(image,output,bitmap,lut)
  use gtv_interfaces, except_this=>gti_pngmap
  use gildas_def
  use gtv_png
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device.
  !---------------------------------------------------------------------
  type(gt_image),   intent(in)    :: image   ! The image to be displayed
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(inout) :: bitmap  !
  type(gt_lut),     intent(in)    :: lut     ! Colormap to use
  ! Local
  integer :: ncol,offset
  !
  ! Use colour MAP_SIZE for blanking, so there are MAP_SIZE-1 colour
  ! available, from 1 to MAP_SIZE-1...
  ncol = output%dev%map_size-1
  offset = output%dev%map_offset
  !
  call compute_bitmap(image,bitmap,ncol,offset)
  !
  if (output%color) then
    if (image%isrgb) then
      call png_image_rgb_color(output,bitmap)
    else
      call png_image_ind_color(output,bitmap,lut)
    endif
  else
    if (image%isrgb) then
      call png_image_rgb_grey(output,bitmap)
    else
      call png_image_ind_grey(output,bitmap,lut)
    endif
  endif
  !
end subroutine gti_pngmap
!
subroutine png_image_rgb_color(output,bitmap)
  use gtv_interfaces, except_this=>png_image_rgb_color
  use gtv_plot
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device, in color scale. The input RGB
  ! intensities are rescaled from 0 to 255.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(in)    :: bitmap  !
#if defined(PNG)
  ! Local
  integer :: i,j,x0,y0,x,y
  integer(kind=4) :: i4
  !
  x0 = bitmap%position(1)
  y0 = bitmap%position(2)
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      x = x0+i-1
      y = y0+j-1
      !
      i4 = nint(real(bitmap%irvalues(i,j)-pngmap_offset+1,kind=4)/pngmap_size*255.)
      output%png%r(x,y) = si4_to_ui1(i4)
      !
      i4 = nint(real(bitmap%igvalues(i,j)-pngmap_offset+1,kind=4)/pngmap_size*255.)
      output%png%g(x,y) = si4_to_ui1(i4)
      !
      i4 = nint(real(bitmap%ibvalues(i,j)-pngmap_offset+1,kind=4)/pngmap_size*255.)
      output%png%b(x,y) = si4_to_ui1(i4)
      !
      if (output%png%transparency)  output%png%a(x,y) = i255  ! i.e. not transparent
    enddo
  enddo
  !
#endif
end subroutine png_image_rgb_color
!
subroutine png_image_rgb_grey(output,bitmap)
  use gtv_interfaces, except_this=>png_image_rgb_grey
  use gtv_plot
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device, in color scale. The input RGB
  ! intensities are rescaled from 0 to 255.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(in)    :: bitmap  !
#if defined(PNG)
  ! Local
  integer :: i,j,x0,y0,x,y
  integer(kind=4) :: i4
  real(kind=4) :: lumi
  !
  x0 = bitmap%position(1)
  y0 = bitmap%position(2)
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      x = x0+i-1
      y = y0+j-1
      !
      lumi = rgb_to_grey((bitmap%irvalues(i,j)-pngmap_offset+1)*255./pngmap_size,  &
                         (bitmap%igvalues(i,j)-pngmap_offset+1)*255./pngmap_size,  &
                         (bitmap%ibvalues(i,j)-pngmap_offset+1)*255./pngmap_size)
      i4 = nint(lumi)
      output%png%r(x,y) = si4_to_ui1(i4)
      !
      if (output%png%transparency)  output%png%a(x,y) = i255  ! i.e. not transparent
    enddo
  enddo
  !
#endif
end subroutine png_image_rgb_grey
!
subroutine png_image_ind_color(output,bitmap,lut)
  use gtv_interfaces, except_this=>png_image_ind_color
  use gtv_plot
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device, in color scale. The single-scale
  ! intensities are split in 3 RGB intensities from 0 to 255.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(in)    :: bitmap  !
  type(gt_lut),     intent(in)    :: lut     ! Colormap to use
#if defined(PNG)
  ! Local
  integer(kind=1) :: br(lut%size)
  integer(kind=1) :: bg(lut%size)
  integer(kind=1) :: bb(lut%size)
  integer :: intensity,i,j,x0,y0,x,y
  integer*4 :: i4
  !
  ! Prepare Byte values for R, G and B
  do intensity=1,lut%size
    i4 = nint(lut%r(intensity)*255.)
    br(intensity) = si4_to_ui1(i4)
    i4 = nint(lut%g(intensity)*255.)
    bg(intensity) = si4_to_ui1(i4)
    i4 = nint(lut%b(intensity)*255.)
    bb(intensity) = si4_to_ui1(i4)
  enddo
  !
  x0 = bitmap%position(1)
  y0 = bitmap%position(2)
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      intensity = bitmap%irvalues(i,j)  &
                  - pngmap_offset + 1 ! +1 because the values were
                                      ! shifted by 1 for C indices
      x = x0+i-1
      y = y0+j-1
      !
      if (intensity.eq.lut%size .and. output%png%noblank) then
        ! Last level was used in compute_bitmap for blanking. If
        ! NOBLANK mode, do nothing! We will see the preset background or,
        ! even better, other plots already drawn!
        continue
        !
      else
        output%png%r(x,y) = br(intensity)
        output%png%g(x,y) = bg(intensity)
        output%png%b(x,y) = bb(intensity)
        if (output%png%transparency)  output%png%a(x,y) = i255  ! i.e. not transparent
      endif
    enddo
  enddo
  !
#endif
end subroutine png_image_ind_color
!
subroutine png_image_ind_grey(output,bitmap,lut)
  use gtv_interfaces, except_this=>png_image_ind_grey
  use gtv_plot
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device, in grey scale
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(in)    :: bitmap  !
  type(gt_lut),     intent(in)    :: lut     ! Colormap to use
#if defined(PNG)
  ! Local
  integer(kind=1) :: bg(lut%size)
  integer :: intensity,i,j,x0,y0,x,y
  integer*4 :: i4
  !
  ! Prepare Byte values for Grey colorscale
  do intensity=1,lut%size
    i4 = nint(rgb_to_grey(lut%r(intensity),lut%g(intensity),lut%b(intensity))*255.)
    bg(intensity) = si4_to_ui1(i4)
  enddo
  !
  x0 = bitmap%position(1)
  y0 = bitmap%position(2)
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      intensity = bitmap%irvalues(i,j)  &
                  - pngmap_offset + 1 ! +1 because the values were
                                      ! shifted by 1 for C indices
      x = x0+i-1
      y = y0+j-1
      !
      if (intensity.eq.lut%size .and. output%png%noblank) then
        ! Last level was used in compute_bitmap for blanking. If
        ! NOBLANK mode, do nothing! We will see the preset background or,
        ! even better, other plots already drawn!
        continue
        !
      else
        output%png%r(x,y) = bg(intensity)
        if (output%png%transparency)  output%png%a(x,y) = i255  ! i.e. not transparent
      endif
    enddo
  enddo
  !
#endif
end subroutine png_image_ind_grey
!
subroutine png_image_inquire(map_size,map_offset,map_color,map_static)
  use gtv_interfaces, except_this=>png_image_inquire
  use gtv_png
  !---------------------------------------------------------------------
  ! @ private
  ! ZZZ Not sure all these really have to be returned...
  !---------------------------------------------------------------------
  integer, intent(out) :: map_size    ! Desired scale dynamics
  integer, intent(out) :: map_offset  !
  logical, intent(out) :: map_color   ! Is a color or grey map?
  logical, intent(out) :: map_static  !
  !
  map_size = pngmap_size
  map_offset = pngmap_offset
  map_color = .true.   ! What about a Grey PNG?
  map_static = .true.  ! PNG filler is able to render one LUT per image
                       ! of the plot (if LUT STATIC mode)
  !
end subroutine png_image_inquire
!
subroutine png_point(out,x,y)
  use gtv_interfaces, except_this=>png_point
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Draw the pixel at input coordinates (pixel units)
  !---------------------------------------------------------------------
  type(gt_display)             :: out  ! Output instance
  integer(kind=4),  intent(in) :: x,y  ! Pixel coordinates, in pixel units
  !
  if (out%png%negative) then
    ! Only revert the color at pixel position
    out%png%R(x,y) = ieor(out%png%R(x,y),i255)  ! Exclusive OR: revert all the bits
    if (out%png%nchan.ge.3) then
      out%png%G(x,y) = ieor(out%png%G(x,y),i255)
      out%png%B(x,y) = ieor(out%png%B(x,y),i255)
    endif
    if (out%png%transparency)  out%png%A(x,y) = i255  ! i.e. not transparent
  else
    out%png%R(x,y) = out%png%rpen
    if (out%png%nchan.ge.3) then
      out%png%G(x,y) = out%png%gpen
      out%png%B(x,y) = out%png%bpen
    endif
    if (out%png%transparency)  out%png%A(x,y) = i255  ! i.e. not transparent
  endif
  !
end subroutine png_point
!
subroutine base64_encode(c,nc,olun)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch
  !  Encode a (binary) buffer as a base-64 string
  !
  !  Example:
  !
  ! Text content   |      M        |      a        |        n      |
  ! ASCII          |   77 (0x4d)   |   97 (0x61)   |    110 (0x6e) |
  ! Bit pattern    |0 1 0 0 1 1 0 1|0 1 1 0 0 0 0 1|0 1 1 0 1 1 1 0|
  ! Index          |     19    |    22     |     5     |     46    |
  ! Base64-encoded |     T     |    W      |     F     |     u     |
  !
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nc     ! Number of Bytes
  integer(kind=1), intent(in) :: c(nc)  ! Input buffer
  integer(kind=4), intent(in) :: olun   ! Output logical unit
  ! Local
  integer(kind=4) :: ib,ic
  integer(kind=1) :: j(4)
  integer(kind=1), parameter :: zero=0
  character(len=76) :: buf
  ! Equivalence
  integer(kind=4) :: b32  ! We need only 24 bits but we can not have an integer(kind=3)
  integer(kind=1) :: b8(4)
  equivalence (b32,b8)
  ! Table
  character(len=1), parameter :: b64table(0:63) = (/    &
  "A","B","C","D","E","F","G","H","I","J","K","L","M",  &
  "N","O","P","Q","R","S","T","U","V","W","X","Y","Z",  &
  "a","b","c","d","e","f","g","h","i","j","k","l","m",  &
  "n","o","p","q","r","s","t","u","v","w","x","y","z",  &
  "0","1","2","3","4","5","6","7","8","9","+","/"       /)
  !
  ib = 0
  ic = 1
  b8(4) = zero  ! Never used, put zeroes for safety
  do
    b8(1) = c(ic+2)
    b8(2) = c(ic+1)
    b8(3) = c(ic)
    !
    j(4) = ibits(b32, 0,6)
    j(3) = ibits(b32, 6,6)
    j(2) = ibits(b32,12,6)
    j(1) = ibits(b32,18,6)
    !
    buf(ib+1:ib+1) = b64table(j(1))
    buf(ib+2:ib+2) = b64table(j(2))
    buf(ib+3:ib+3) = b64table(j(3))
    buf(ib+4:ib+4) = b64table(j(4))
    !
    ib = ib+4
    if (ib.ge.len(buf)) then
      write(olun,'(A)') buf
      ib = 0
    endif
    !
    ic = ic+3
    if (ic.gt.nc-2)  exit
  enddo
  !
  ! Last 1 or 2 bytes, need specific padding
  if (ic.eq.nc-1) then
    b8(1) = zero
    b8(2) = c(ic+1)
    b8(3) = c(ic)
    j(3) = ibits(b32, 6,6)
    j(2) = ibits(b32,12,6)
    j(1) = ibits(b32,18,6)
    buf(ib+1:ib+1) = b64table(j(1))
    buf(ib+2:ib+2) = b64table(j(2))
    buf(ib+3:ib+3) = b64table(j(3))
    buf(ib+4:ib+4) = '='
    ib = ib+4
  elseif (ic.eq.nc) then
    b8(1) = zero
    b8(2) = zero
    b8(3) = c(ic)
    j(2) = ibits(b32,12,6)
    j(1) = ibits(b32,18,6)
    buf(ib+1:ib+1) = b64table(j(1))
    buf(ib+2:ib+2) = b64table(j(2))
    buf(ib+3:ib+3) = '='
    buf(ib+4:ib+4) = '='
    ib = ib+4
  endif
  !
  if (ib.gt.0)  write(olun,'(A)') buf(1:ib)
  !
end subroutine base64_encode

subroutine modify(set,line,r,error)
  use gildas_def
  use gbl_message
  use gbl_constant
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ no-interface (name is too generic, conflicts with local variables)
  ! CLASS Support routine for commande MODIFY
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Status flag
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  integer(kind=4), parameter :: nterm=22
  character(len=17) :: term(nterm),chain,key
  integer(kind=4) :: iterm,i,nc,iarg
  real(kind=8) :: r8
  real(kind=4) :: newblank
  character(len=80) :: ch
  character(len=24) :: arg,proja0,projd0,projang
  character(len=13) :: projarg,projunit
  data term /'BANDS',    'BEAM_EFF',         'BLANKING',   'DOPPLER',      &
             'FREQUENCY','ELEVATION_GAIN',   'IMAGE',      'LINENAME',     &
             'OFFSETS',  'PARALLACTIC_ANGLE','POSITION',   'PROJECTION',   &
             'RECENTER', 'SCALE',            'SOURCE',     'SWITCH_MODE',  &
             'SYSTEM',   'TELESCOPE',        'VCONVENTION','VDIRECTION',   &
             'VELOCITY', 'WIDTH'/
  !
  ! Parse for modify kind
  call sic_ke(line,0,1,chain,nc,.true.,error)
  if (error) return
  call sic_ambigs(rname,chain,key,iterm,term,nterm,error)
  if (error) return
  !
  if (sic_present(1,0) .and. key.ne.'BEAM_EFF') then
    call class_message(seve%e,rname,'Option /RUZE is not compatible with '//key)
    error = .true.
    return
  endif
  !
  ! Sanity checks
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No spectrum in memory')
    error = .true.
    return
  endif
  !
  select case (key)
  case ('FREQUENCY')
     ! Modify velocity scale according to new rest frequency [MHz]
     call sic_r8(line,0,2,r8,.true.,error)
     if (error) return
     call modify_frequency(r,r8,error)
     if (error) return
     call newdat(set,r,error)
     if (error) return
     !
  case ('VELOCITY')
     ! Modify image and rest frequency according to new reference velocity [km/s]
     call sic_r8(line,0,2,r8,.true.,error)
     if (error) return
     call modify_velocity(r,r8,error)
     if (error)  return
     call newdat(set,r,error)
     if (error) return
     !
  case ('DOPPLER')
     ! Modify the Doppler factor (in the CLASS convention: Dopp = -V/c)
     arg = ''
     call sic_ke(line,0,2,arg,nc,.false.,error)
     if (error) return
     call modify_doppler(set,arg,r%head,error)
     if (error)  return
     !
  case ('RECENTER')
     ! SG: Confidentiel pour corriger erreurs frequences
     call sic_r8(line,0,2,r8,.true.,error)
     if (error) return
     if (r%head%gen%kind.eq.kind_spec) then
        r%head%spe%rchan = r8
     elseif (r%head%gen%kind.eq.kind_cont) then
        r%head%dri%rpoin = r8
     endif
     write(ch,'(A,1PG13.6)') 'Reference channel set to ',r8
     call class_message(seve%w,rname,ch)
     call newdat(set,r,error)
     if (error) return
     !
  case ('BANDS')
     ! Exchange signal and image bands
     if (r%head%spe%image.eq.image_null) then
       call class_message(seve%e,rname,'Spectrum has no image band defined')
       error = .true.
       return
     endif
     r%head%spe%fres = -r%head%spe%fres
     r8 = r%head%spe%image
     r%head%spe%image= r%head%spe%restf
     r%head%spe%restf= r8
     r%head%spe%vres = -clight_kms*r%head%spe%fres/r%head%spe%restf
     call newdat(set,r,error)
     if (error) return
     !
  case ('LINENAME')
     ! Modify line name
     call sic_ch (line,0,2,arg,nc,.true.,error)
     if (error) then
       if (nc.eq.12) then
         call class_message(seve%w,rname,'Line name truncated to 12 char.')
         error = .false.
       else
         return
       endif
     endif
     r%head%spe%line = arg(1:12)
     !
  case ('WIDTH')
     ! Modify channel width [MHz]
     call sic_r8 (line,0,2,r8,.true.,error)
     if (error) return
     if (r%head%gen%kind.eq.kind_spec) then
        r%head%spe%fres = r8
        ! The velocity resolution should actually be computed from the sky frequency
        ! (not available in present header; will have to be added).
        r%head%spe%vres = -clight_kms*r%head%spe%fres/r%head%spe%restf
     elseif (r%head%gen%kind.eq.kind_cont) then
        r%head%dri%tres = r8*r%head%dri%tres/r%head%dri%ares
        r%head%dri%ares = r8
     endif
     call newdat(set,r,error)
     if (error) return
     !
  case ('IMAGE')
     ! Modify the velocity scale corresponding to a new rest frequency [MHz]
     call sic_r8 (line,0,2,r8,.true.,error)
     if (error) return
     r%head%spe%image = r8
     write (ch,'(A,1X,F19.6)') 'Image frequency set to ',r%head%spe%image
     call class_message(seve%i,rname,ch)
     call newdat(set,r,error)
     if (error) return
     !
  case ('TELESCOPE')
     ! Modify telescope name
     call sic_ch (line,0,2,arg,nc,.true.,error)
     if (error) then
       if (nc.eq.12) then
         call class_message(seve%w,rname,'Telescope name truncated to 12 char.')
         error = .false.
       else
         return
       endif
     endif
     r%head%gen%teles = arg(1:12)
     !
  case ('BEAM_EFF')
     ! Modified the beam efficiency.
     call modify_beeff(set,line,r,error)
     if (error)  return
     !
  case ('SOURCE')
     ! Modify source name
     call sic_ch (line,0,2,arg,nc,.true.,error)
     if (error) then
       if (nc.eq.12) then
         call class_message(seve%w,rname,'Source name truncated to 12 char.')
         error = .false.
       else
         return
       endif
     endif
     r%head%pos%sourc = arg(1:12)
     !
  case ('SYSTEM')
     ! Change the System in which the center of projection has  been defined
     call sic_ke(line,0,2,arg,nc,.true.,error)
     if (error) return
     if (arg(1:2).eq.'GA') then
        r%head%pos%system = sign(type_ga,r%head%pos%system)
     elseif (arg(1:2).eq.'EQ') then
        r%head%pos%system = sign(type_eq,r%head%pos%system)
     elseif (arg(1:2).eq.'HO') then
        r%head%pos%system = sign(type_ho,r%head%pos%system)
     elseif (arg(1:2).eq.'IC') then
        r%head%pos%system = sign(type_ic,r%head%pos%system)
     elseif (arg(1:2).eq.'UN') then
        r%head%pos%system = sign(type_un,r%head%pos%system)
     else
        call class_message(seve%e,rname,'Unknown SYSTEM')
        error = .true.
        return
     endif
     !
  case ('OFFSETS') ! MODIFY OFFSET O1 O2 [Unit]
     arg = ' '  ! Default current angle unit
     call sic_ke(line,0,4,arg,nc,.false.,error)
     if (error) return
     call sic_ch(line,0,2,ch,nc,.true.,error)
     if (error) return
     call coffse(set,rname,ch,arg,r%head%pos%lamof,error)
     if (error) return
     call sic_ch(line,0,3,ch,nc,.true.,error)
     if (error) return
     call coffse(set,rname,ch,arg,r%head%pos%betof,error)
     if (error) return
     r%head%pos%rx_off = class_setup_get_fangle()*r%head%pos%lamof
     r%head%pos%ry_off = class_setup_get_fangle()*r%head%pos%betof
     write(ch,'(A,1X,2(1PG10.3,1X),A)') 'Offsets set to ',  &
       r%head%pos%rx_off,r%head%pos%ry_off,obs_system(r%head%pos%system)
     call class_message(seve%i,rname,ch)
     !
  case ('PROJECTION')
     ! Modify the kind of projection (RADIO, AZIMUTHAL, etc) and
     ! optionally the projection center and angle
     call sic_ke(line,0,2,projarg,nc,.true.,error)
     if (error) return
     proja0 = '='  ! Means unchanged by default
     call sic_ch(line,0,3,proja0,nc,.false.,error)
     if (error)  return
     projd0 = '='  ! Means unchanged by default. Must be present if A0 is present
     call sic_ch(line,0,4,projd0,nc,sic_present(0,3),error)
     if (error)  return
     projang = '='  ! Means unchanged by default
     call sic_ch(line,0,5,projang,nc,.false.,error)
     if (error) return
     projunit = 'D'  ! Default degree
     call sic_ke(line,0,6,projunit,nc,.false.,error)
     if (error) return
     !
     call modify_projection(set,r%head,projarg,proja0,projd0,projang,projunit,error)
     if (error)  return
     !
  case ('POSITION')
     ! Modify center of projection
     call sic_ch(line,0,2,proja0,nc,.true.,error)
     if (error)  return
     call sic_ch(line,0,3,projd0,nc,.true.,error)
     if (error)  return
     !
     call modify_projection(set,r%head,'=',proja0,projd0,'=','',error)
     if (error)  return
     !
  case ('SWITCH_MODE')
     ! Modify the description of the switching mode (typically
     ! for foreign data)
     call sic_i4 (line,0,3,nc,.true.,error)
     if (error) return
     if (nc.gt.mxphas) then
        write(chain,'(I2)') mxphas
        ch = 'Too many phases. Only '//chain(1:2)   &
             &        //' supported.'
        call class_message(seve%e,rname,ch)
        error = .true.
        return
     elseif (nc.lt.1) then
        ch = 'Invalid number of phases. Must be positive.'
        call class_message(seve%e,rname,ch)
        error = .true.
        return
     endif
     r%head%swi%nphas = nc
     call sic_ke (line,0,2,chain,nc,.true.,error)
     if (error) return
     if (chain(1:1).eq.'F') then
        do i =1,r%head%swi%nphas
           call sic_r8 (line,0,3*i+1,r%head%swi%decal(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,3*i+2,r%head%swi%duree(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,3*i+3,r%head%swi%poids(i),.true.,error)
           if (error) return
        enddo
        r%head%swi%swmod = mod_freq
        r%head%presec(class_sec_swi_id) = .true.
     elseif (chain(1:1).eq.'P') then
        do i =1,r%head%swi%nphas
           call sic_r4 (line,0,4*i,r%head%swi%ldecal(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,4*i+1,r%head%swi%bdecal(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,4*i+2,r%head%swi%duree(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,4*i+3,r%head%swi%poids(i),.true.,error)
           if (error) return
        enddo
        r%head%swi%swmod = mod_pos
        r%head%presec(class_sec_swi_id) = .true.
     else
        ch = chain//' Switching not yet supported in this command'
        call class_message(seve%e,rname,ch)
        error = .true.
        return
     endif
     !
  case ('BLANKING')
     ! Modify blanking value in both header and data
     call sic_r4 (line,0,2,newblank,.true.,error)
     if (error) return
     call modify_blanking(r,newblank)
     !
  case ('SCALE')  ! MODIFY SCALE ToUnit
     ! Modify Y scale unit (i.e. RY values)
     call sic_ch(line,0,2,chain,nc,.true.,error)
     if (error)  return
     call sic_upper(chain)
     call sic_ambigs(rname,chain,arg,iarg,yunit_keys(1:myunit),myunit,error)
     if (error) return
     call modify_scale(r,iarg,.true.,error)
     if (error)  return
     !
  case ('VCONVENTION')
     call modify_vconvention(set,r%head,error)
     if (error)  return
     call newdat(set,r,error)
     if (error) return
     !
  case ('VDIRECTION')
     call modify_vdirection(set,r%head,error)
     if (error)  return
     call newdat(set,r,error)
     if (error) return
     !
  case ('ELEVATION_GAIN')
     call modify_elevationgain(r,error)
     if (error)  return
     !
  case ('PARALLACTIC_ANGLE')
     call modify_parang(r,error)
     if (error)  return
     !
  case default
     call class_message(seve%e,rname,'Keyword '//trim(key)//' not implemented')
     error = .true.
     return
  end select
  !
end subroutine modify
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine modify_frequency(obs,new_restf,error)
  use phys_const
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Modify velocity scale according to new rest frequency [MHz]
  ! The axes are assumed to be linear in Frequency.
  ! It will also work properly for the RADIO definition of the velocity,
  ! but not for the others
  ! See IRAM Memo "Description of the frequency/velocity axes in CLASS"
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs        !
  real(kind=8),      intent(in)    :: new_restf  !
  logical,           intent(inout) :: error      !
  !
  if (obs%head%spe%restf.eq.new_restf)  return
  !
  ! Update Resolution section
  call modify_resolution(obs,obs%head%spe%restf,new_restf,error)
  if (error)  return
  !
  ! Update Spectroscopic section
  if (obs%head%spe%doppler.ne.-1.d0) then
    obs%head%spe%rchan = obs%head%spe%rchan + &
      (new_restf-obs%head%spe%restf)/obs%head%spe%fres * (1d0+obs%head%spe%doppler)
  else
    obs%head%spe%rchan = obs%head%spe%rchan + &
      (new_restf-obs%head%spe%restf)/obs%head%spe%fres
  endif
  if (obs%head%spe%image.ne.image_null) then
    obs%head%spe%image = (obs%head%spe%image+obs%head%spe%restf) - new_restf
  endif
  obs%head%spe%vres = -clight_kms*obs%head%spe%fres/new_restf
  obs%head%spe%restf = new_restf
  !
end subroutine modify_frequency
!
subroutine modify_velocity(obs,velo_new,error)
  use gbl_message
  use class_types
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   MODIFY VELOCITY
  ! See IRAM Memo "Description of the frequency/velocity axes in CLASS"
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs       !
  real(kind=8),      intent(in)    :: velo_new  !
  logical,           intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  real(kind=8) :: dop_old,dop_new
  !
  if (obs%head%spe%voff.eq.velo_new)  return
  !
  if (obs%head%spe%doppler.eq.-1.d0) then
    call class_message(seve%e,rname,  &
      'Can not compute new Doppler: initial Doppler factor absent')
    call class_message(seve%e,rname,  &
      'You can compute it with MODIFY DOPPLER, see HELP for details')
    error = .true.
    return
  endif
  !
  dop_old = obs%head%spe%doppler
  dop_new = dop_old + (obs%head%spe%voff-velo_new)/clight_kms
  !
  if (obs%head%spe%image.ne.image_null) then
    obs%head%spe%image = obs%head%spe%image*(1.d0+dop_old)/(1.d0+dop_new) -  &
                         obs%head%spe%restf*(dop_new-dop_old)/(1.d0+dop_new)
  endif
  obs%head%spe%rchan   = obs%head%spe%rchan +  &
                         obs%head%spe%restf/obs%head%spe%fres*(dop_new-dop_old)
  obs%head%spe%voff    = velo_new
  obs%head%spe%doppler = dop_new
  !
end subroutine modify_velocity
!
subroutine modify_resolution(obs,old_freq,new_freq,error)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Recompute the resolution according to the new frequency at
  ! reference channel (= rest frequency)
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  real(kind=8),      intent(in)    :: old_freq
  real(kind=8),      intent(in)    :: new_freq
  logical,           intent(inout) :: error
  ! Local
  real(kind=8) :: factor
  !
  if (.not.obs%head%presec(class_sec_res_id))  return
  if (old_freq.eq.new_freq)  return
  !
  factor = old_freq/new_freq
  obs%head%res%major = obs%head%res%major*factor
  obs%head%res%minor = obs%head%res%minor*factor
  !
end subroutine modify_resolution
!
subroutine modify_projection_charval(set,head,newproj_c,newa0_c,newd0_c,  &
  newang_c,newaunit_c,error)
  use gbl_constant
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>modify_projection_charval
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic modify_projection
  !   Modify the kind of projection (RADIO, AZIMUTHAL, etc), the
  ! projection center, and the projection angle
  ! ---
  !  Entry point with char*(*) proj, A0, and D0. If head%pos%system is
  ! Equatorial or ICRS, A0 is assumed an hour angle. Arguments with
  ! value '=' mean unchanged.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set         !
  type(header),        intent(inout) :: head        ! Header to be modified
  character(len=*),    intent(in)    :: newproj_c   ! New projection name
  character(len=*),    intent(in)    :: newa0_c     ! New proj. center A0 (sexagesimal)
  character(len=*),    intent(in)    :: newd0_c     ! New proj. center D0 (sexagesimal)
  character(len=*),    intent(in)    :: newang_c    ! New projection angle
  character(len=*),    intent(in)    :: newaunit_c  ! Projection angle unit
  logical,             intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  character(len=13) :: projkey,projnam_array(0:mproj)
  integer(kind=4) :: newproj
  real(kind=8) :: newa0,newd0,newang
  !
  if (newproj_c.eq.'=') then
    newproj = head%pos%proj
  else
    call projnam_list(projnam_array)  ! Fill with the projection names
    call sic_ambigs(rname,newproj_c,projkey,newproj,projnam_array,mproj+1,error)
    if (error) return
    newproj = newproj-1  ! Because projnam_array numbering starts at 0
  endif
  !
  if (newa0_c.eq.'=') then
    ! Unchanged projection center
    newa0 = head%pos%lam
  else
    ! Decode sexagesimal string
    call sic_sexa(newa0_c,len_trim(newa0_c),newa0,error)
    if (error)  return
    if (head%pos%system.eq.type_eq .or. &
        head%pos%system.eq.type_ic) then
      newa0 = newa0*rad_per_hang
    else
      newa0 = newa0*rad_per_deg
    endif
  endif
  !
  if (newd0_c.eq.'=') then
    ! Unchanged projection center
    newd0 = head%pos%bet
  else
    ! Decode sexagesimal string
    call sic_sexa(newd0_c,len_trim(newd0_c),newd0,error)
    if (error)  return
    newd0 = newd0*rad_per_deg
  endif
  !
  if (newang_c.eq.'=') then
    newang = head%pos%projang
  else
    call sic_math_dble(newang_c,len_trim(newang_c),newang,error)
    if (error)  return
    if (newaunit_c(1:1).eq.'R') then
      continue  ! Unchanged
    elseif (newaunit_c(1:1).eq.'D') then
      newang = newang*rad_per_deg
    else
      call class_message(seve%e,rname,'Angle unit not understood: '//newaunit_c)
      error = .true.
      return
    endif
  endif
  !
  call modify_projection_numval(set,head,newproj,newa0,newd0,newang,error)
  if (error)  return
  !
end subroutine modify_projection_charval
!
subroutine modify_projection_numval(set,head,newproj,newa0,newd0,newang,error)
  use gbl_constant
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic modify_projection
  !   Modify the kind of projection (RADIO, AZIMUTHAL, etc), the
  ! projection center, and the projection angle
  ! ---
  !  Entry point with integer code for proj, and real*8 a0, d0, pang
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set      !
  type(header),        intent(inout) :: head     !
  integer(kind=4),     intent(in)    :: newproj  ! [code] New proj. code
  real(kind=8),        intent(in)    :: newa0    ! [rad ] New proj. center A0
  real(kind=8),        intent(in)    :: newd0    ! [rad ] New proj. center D0
  real(kind=8),        intent(in)    :: newang   ! [rad ] New proj. angle
  logical,             intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='PROJECTION'
  real(kind=8) :: rxoff,ryoff,axoff,ayoff
  type(projection_t) :: proj
  !
  if (newproj.lt.0 .or. newproj.gt.mproj) then
    call class_message(seve%e,rname,'Invalid projection code')
    error = .true.
    return
  endif
  !
  ! Setup Input projection
  call gwcs_projec(head%pos%lam,head%pos%bet,head%pos%projang,head%pos%proj,  &
    proj,error)
  if (error)  return
  !
  ! Convert to absolute coordinates
  rxoff = head%pos%lamof
  ryoff = head%pos%betof
  call rel_to_abs(proj,rxoff,ryoff,axoff,ayoff,1)
  !
  ! Setup Output projection
  call gwcs_projec(newa0,newd0,newang,newproj,proj,error)
  if (error)  return
  !
  ! Convert to new projection
  call abs_to_rel(proj,axoff,ayoff,rxoff,ryoff,1)
  !
  ! Update header
  head%pos%proj = newproj
  head%pos%lam = newa0
  head%pos%bet = newd0
  head%pos%projang = newang
  head%pos%lamof = rxoff
  head%pos%betof = ryoff
  head%pos%rx_off = class_setup_get_fangle()*rxoff
  head%pos%ry_off = class_setup_get_fangle()*ryoff
  !
end subroutine modify_projection_numval
!
subroutine modify_beeff(set,line,r,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>modify_beeff
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   MODIFY BEAM_EFF Beeff
  !   MODIFY BEAM_EFF /RUZE [B0 Sigma]
  ! The spectrum is rescaled according to the new value only if the beam
  ! efficiency previously was non zero valued
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  integer(kind=4), parameter :: optruze=1
  real(kind=4) :: r4,r5,beeff_old
  character(len=message_length) :: mess
  !
  beeff_old = r%head%cal%beeff
  if (beeff_old.eq.0.) then
    call class_message(seve%w,rname,  &
      'Former beam efficiency is 0.0, no correction applied to intensities')
  endif
  !
  if (sic_present(optruze,0)) then  ! /RUZE option
    ! Get values
    if (sic_present(optruze,2)) then
      ! User provides the 2 values
      call sic_r4(line,optruze,1,r4,.true.,error)
      if (error)  return
      call sic_r4(line,optruze,2,r5,.true.,error)
      if (error)  return
    elseif (sic_present(optruze,1)) then
      ! 1 value provided
      call class_message(seve%e,rname,'/RUZE option takes 2 values or none')
      error = .true.
      return
    else
      ! 0 values. Use defaults if known, else error
      call get_ruze_parameters(r,r4,r5,error)
      if (error)  return
    endif
    !
    ! Sanity
    if (r4.le.0. .or. r4.gt.1.) then
        write (mess,'(A,1X,1PG10.3)') 'Invalid B0 in Ruze''s equation: ',r4
        call class_message(seve%e,rname,mess)
        error = .true.
    endif
    if (r5.le.1. .or. r5.gt.1e3) then  ! Sigma in microns
        write (mess,'(A,1X,1PG10.3)')  &
          'Invalid sigma in Ruze''s equation (microns): ',r5
        call class_message(seve%e,rname,mess)
        error = .true.
    endif
    if (error) return
    !
    ! Apply value
    if (r%head%cal%beeff.ne.0.) then
      call modify_beeff_ruze(r,r4,r5)
    else
      r%head%cal%beeff = r4
    endif
    !
  else
    ! No /RUZE option
    call sic_r4 (line,0,2,r4,.true.,error)
    if (error) return
    if (r4.le.0. .or. r4.gt.1.0) then
        write (mess,'(A,1X,1PG10.3)') 'Invalid beam efficiency ',r4
        call class_message(seve%e,rname,mess)
        error = .true.
        return
    endif
    if (r%head%cal%beeff.ne.0.) then
        ! Known beam_eff: rescale
        r5 = r%head%cal%beeff/r4
        call rescale_data (r,r5)
        call rescale_header(r%head,r5)
    else
        ! No known beam_eff: just set the value
    endif
    r%head%cal%beeff = r4
    !
  endif
  !
  write(mess,'(2(A,1X,F6.4))')  &
    'Former beam efficiency:',beeff_old,', new:',r%head%cal%beeff
  call class_message(seve%i,rname,mess)
  !
  call newlimy(set,r,error)
  if (error) return
  !
contains
  !
  subroutine get_ruze_parameters(obs,b0,sigma,error)
    !-------------------------------------------------------------------
    ! Get the known Ruze paramters for the given telescope, observing
    ! date and observing frequency.
    !-------------------------------------------------------------------
    type(observation), intent(in)    :: obs
    real(kind=4),      intent(out)   :: b0
    real(kind=4),      intent(out)   :: sigma
    logical,           intent(inout) :: error
    ! Local
    character(len=24) :: teles
    integer(kind=4) :: ilimit,iband
    character(len=message_length) :: mess
    ! 30m bands
    character(len=2), parameter :: band(4) = (/ 'E0', 'E1', 'E2', 'E3' /)
    real(kind=4), parameter :: flimits(5) = (/ 70.,120.,190.,275.,380. /) ! [GHz] Band limits
    ! Defaults for 30m: after EMIR installation
    integer(kind=4), parameter :: dobs1=-5627  ! 01-APR-2009
    real(kind=4), parameter :: b01=0.863    ! [---] B0 since dobs1
    real(kind=4), parameter :: sigma1=65.6  ! [um] Sigma since dobs1
    ! Defaults for 30m: after surface painting
    integer(kind=4), parameter :: dobs2=5 ! 01-SEP-2024
    real(kind=4), parameter :: b02(4) = (/ 0.82,0.72,0.82,0.72 /)  ! [---] Per band
    real(kind=4), parameter :: sigma2(4) = (/ 74.,73.,74.,73. /) ! [um] Per band
    !
    ! Sanity checks
    call my_get_teles(rname,obs%head%gen%teles,.true.,teles,error)
    if (error) then
      call class_message(seve%e,rname,'/RUZE option knows no measured values for unknown telescope')
      error = .true.
      return
    endif
    if (teles.ne.'30M') then
      call class_message(seve%e,rname,'/RUZE option knows no measured values for telescope '//teles)
      error = .true.
      return
    endif
    !
    ! Fetch the observing band
    if (obs%head%spe%restf.lt.flimits(1)*1.e3 .or. &
        obs%head%spe%restf.gt.flimits(5)*1.e3) then
      write(mess,'(a,1pg14.7,a)')  'Rest frequency ',obs%head%spe%restf/1.e3,  &
        ' GHz out of 30M bands: no /RUZE values available'
      call class_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    do ilimit=1,4
      if (obs%head%spe%restf.gt.flimits(ilimit)*1.e3)  iband = ilimit
    enddo
    !
    if (obs%head%gen%dobs.ge.dobs2) then
      b0 = b02(iband)
      sigma = sigma2(iband)
    elseif (obs%head%gen%dobs.ge.dobs1) then
      b0 = b01
      sigma = sigma1
    else
      call class_message(seve%e,rname,'/RUZE knows no measured values for 30M before 01-APR-2009')
      error = .true.
      return
    endif
    !
    ! Feedback
    write(mess,'(a,f5.3,a,f0.1,3a)') 'Using 30M measured values B0=',b0,  &
      ' and Sigma=',sigma,' in band ',band(iband),' for Ruze''s equation'
    call class_message(seve%i,rname,mess)
  end subroutine get_ruze_parameters
  !
  subroutine modify_beeff_ruze(obs,b0,sigma)
    use phys_const
    !---------------------------------------------------------------------
    !  Modify the observation intensities, channel per channel, according
    ! to the Ruze's equation:
    !   Beeff(lambda) = B0*exp(-(4*pi*sigma/lambda)**2)
    !                 = B0*exp(-(4*pi*sigma*freq/c)**2)
    !---------------------------------------------------------------------
    type(observation), intent(inout) :: obs    !
    real(kind=4),      intent(in)    :: b0     ! [] Scaling factor in Ruze's equation
    real(kind=4),      intent(in)    :: sigma  ! [microns] Width factor in Ruze's equation
    ! Local
    integer(kind=4) :: ichan
    real(kind=4) :: fact1,fact2,bf,bc,bl
    real(kind=8) :: freq
    character(len=message_length) :: mess
    !
    fact2 = -(4.*pis*sigma/clight)**2  ! Sigma converted to meters (* 1.e-6),
                                      ! freq (hereafter) converted to Hz (* 1.e6)
    !
    ! Rescale DATA
    if (obs%head%cal%beeff.ne.0.) then
      fact1 = obs%head%cal%beeff/b0
      !
      do ichan=1,obs%head%spe%nchan
        if (obs%spectre(ichan).eq.obs%cbad)  cycle
        !
        ! Observatory frequency at channel #ichan
        call abscissa_chan2obsfre(obs%head,real(ichan,kind=8),freq)
        !
        obs%spectre(ichan) = obs%spectre(ichan)*fact1/exp(fact2*freq*freq)
      enddo
      !
    endif
    !
    ! User feedback
    ! At left of spectrum
    call abscissa_obsfre_left(obs%head,freq)
    bf = b0*exp(fact2*freq*freq)
    ! At center channel
    call abscissa_obsfre_middle(obs%head,freq)
    bc = b0*exp(fact2*freq*freq)
    ! At right of spectrum
    call abscissa_obsfre_right(obs%head,freq)
    bl = b0*exp(fact2*freq*freq)
    !
    write (mess,'(A,3(2X,F6.4),A,F4.1,A)')  &
      'Beam efficiencies at first, center, and last channels:',bf,bc,bl,  &
      ' (',abs(bl-bf)/bf*100.,'% variation)'
    call class_message(seve%i,rname,mess)
    !
    ! Rescale HEADER. Use new efficiency at central channel
    call rescale_header(obs%head,obs%head%cal%beeff/bc)
    obs%head%cal%beeff = bc
  end subroutine modify_beeff_ruze
end subroutine modify_beeff
!
subroutine modify_blanking_obs(obs,newbad)
  use classcore_interfaces, except_this=>modify_blanking_obs
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic modify_blanking
  !  Modify blank values (bad and NaN) from the spectrum, and update
  ! the header accordingly
  ! ---
  ! This version for a type(observation) as argument
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  real(kind=4),      intent(in)    :: newbad
  ! Local
  real(kind=4) :: oldbad
  integer(kind=4) :: nchan
  !
  oldbad = obs_bad(obs%head)
  nchan = obs_nchan(obs%head)
  call modify_blanking_nv4(obs%data1,nchan,oldbad,newbad)
  !
  call modify_blanking_head(obs,newbad)
  !
end subroutine modify_blanking_obs
!
subroutine modify_blanking_head(obs,newbad)
  use gbl_constant
  use classcore_interfaces, except_this=>modify_blanking_head
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Modify the blank value in a header
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  real(kind=4),      intent(in)    :: newbad
  !
  if (obs%head%gen%kind.eq.kind_spec) then
    obs%head%spe%bad = newbad
  else
    obs%head%dri%bad = newbad
  endif
  obs%cbad = newbad
  !
end subroutine modify_blanking_head
!
subroutine modify_blanking_nv4(val,nv4,oldbad,newbad)
  use classcore_interfaces, except_this=>modify_blanking_nv4
  !---------------------------------------------------------------------
  ! @ private-generic modify_blanking
  ! Modify blank values (bad and NaN) from the spectrum
  ! ---
  ! This version for I*4 number of values
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: nv4
  real(kind=4),    intent(inout) :: val(nv4)
  real(kind=4),    intent(in)    :: oldbad
  real(kind=4),    intent(in)    :: newbad
  ! Local
  integer(kind=8) :: nv8
  !
  nv8 = nv4
  call modify_blanking_nv8(val,nv8,oldbad,newbad)
  !
end subroutine modify_blanking_nv4
!
subroutine modify_blanking_nv8(val,nv8,oldbad,newbad)
  !---------------------------------------------------------------------
  ! @ private-generic modify_blanking
  ! Modify blank values (bad and NaN) from the spectrum
  ! ---
  ! This version for I*8 number of values
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: nv8
  real(kind=4),    intent(inout) :: val(nv8)
  real(kind=4),    intent(in)    :: oldbad
  real(kind=4),    intent(in)    :: newbad
  ! Local
  integer(kind=8) :: i
  !
  do i=1,nv8
    if (val(i).ne.val(i)) then
      ! Normal compilers: NaN are not even equal to themselves
      val(i) = newbad
    elseif (val(i).eq.oldbad) then
      ! Patch old bad +
      ! also gfortran -O3 case... NaN are equal to everything
      val(i) = newbad
    endif
  enddo
end subroutine modify_blanking_nv8
!
subroutine modify_scale(obs,tocode,verbose,error)
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>modify_scale
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Modify the Y scale unit
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs      !
  integer(kind=4),   intent(in)    :: tocode   ! Class internal code for new Y unit
  logical,           intent(in)    :: verbose  ! Verbose warnings and infos?
  logical,           intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SCALE'
  real(kind=4) :: factor
  character(len=message_length) :: mess
  !
  ! Fast exit
  if (obs%head%gen%yunit.eq.tocode .and. verbose) then
    ! Nothing to be done
    call class_message(seve%w,rname,'Y scale unit is already '//  &
      trim(obs_yunit(tocode))//', nothing done')
    return
  endif
  !
  ! Sanity checks
  if (obs%head%gen%yunit.eq.yunit_unknown) then
    call class_message(seve%e,rname,'Can not modify Y unit from Unknown')
    error = .true.
    return
  endif
  if (tocode.eq.yunit_unknown) then
    call class_message(seve%e,rname,'Can not modify Y unit to Unknown')
    error = .true.
    return
  endif
  !
  if (obs%head%gen%yunit.eq.yunit_Jyperbeam  .or. tocode.eq.yunit_Jyperbeam .or.  &
      obs%head%gen%yunit.eq.yunit_mJyperbeam .or. tocode.eq.yunit_mJyperbeam) then
    ! To/from Jansky
    call modify_scale_jy(factor,error)
  else
    ! Tmb to/from Ta*
    call modify_scale_t(factor,error)
  endif
  if (error)  return
  !
  if (verbose) then
    write(mess,'(5A,F0.3)')  'Scaling factor from ',obs_yunit(obs%head%gen%yunit),  &
      ' to ',obs_yunit(tocode),': ',factor
    call class_message(seve%i,rname,mess)
  endif
  !
  call rescale_header(obs%head,factor)
  call rescale_data(obs,factor)
  obs%head%gen%yunit = tocode
  !
contains
  subroutine modify_scale_jy(factor,error)
    !-------------------------------------------------------------------
    ! Specific conversion to/from Jansky
    !-------------------------------------------------------------------
    real(kind=4), intent(out)   :: factor
    logical,      intent(inout) :: error
    ! Local
    real(kind=8) :: lambda,jyperbeam_per_ktmb
    real(kind=4) :: major,minor
    !
    ! Sanity checks
    if (.not.obs%head%presec(class_sec_res_id)) then
      call class_message(seve%e,rname,'Observation has no Resolution section')
      error = .true.
      return
    endif
    major = obs%head%res%major
    minor = obs%head%res%minor
    if (major.eq.0. .and. minor.eq.0.)  then
      ! Section is defined but resolution is null...
      call class_message(seve%e,rname,'Resolution has null size')
      error = .true.
      return
    endif
    if (major.eq.0. .and. verbose) then
      call class_message(seve%w,rname,'Null major axis resolution defaults to minor axis')
      major = minor
    endif
    if (minor.eq.0. .and. verbose) then
      call class_message(seve%w,rname,'Null minor axis resolution defaults to major axis')
      major = minor
    endif
    !
    lambda = clight_mhz/obs%head%spe%restf  ! [m]
    jyperbeam_per_ktmb = 2.d0*kbolt*1.e26*pi*major*minor/(4.d0*log(2.d0)*lambda**2)
    !
    ! Convert from current scale to K (Tmb)
    select case (obs%head%gen%yunit)
    case (yunit_K_Tmb)
      factor = 1.
    case (yunit_Jyperbeam)
      factor = 1./jyperbeam_per_ktmb
    case (yunit_mJyperbeam)
      factor = 1.e-3/jyperbeam_per_ktmb
    case default
      call modify_scale_notimplemented(error)
      return
    end select
    !
    ! Convert from K (Tmb) to new scale
    select case (tocode)
    case (yunit_K_Tmb)
      continue  ! factor = factor*1.
    case (yunit_Jyperbeam)
      factor = factor*jyperbeam_per_ktmb
    case (yunit_mJyperbeam)
      factor = factor*1.e3*jyperbeam_per_ktmb
    case default
      call modify_scale_notimplemented(error)
      return
    end select
    !
  end subroutine modify_scale_jy
  !
  subroutine modify_scale_t(factor,error)
    !-------------------------------------------------------------------
    ! Specific conversion between temperatures
    !-------------------------------------------------------------------
    real(kind=4), intent(out)   :: factor
    logical,      intent(inout) :: error
    ! Local
    !
    ! Sanity checks
    if (.not.obs%head%presec(class_sec_cal_id)) then
      call class_message(seve%e,rname,'Observation has no Calibration section')
      error = .true.
      return
    endif
    if (obs%head%cal%beeff.le.0.) then
      call class_message(seve%e,rname,'Current beam efficiency is null')
      error = .true.
      return
    endif
    if (obs%head%cal%foeff.le.0.) then
      call class_message(seve%e,rname,'Current forward efficiency is null')
      error = .true.
      return
    endif
    if (obs%head%gen%yunit.ne.yunit_K_Tmb .or.  &
        tocode.ne.yunit_K_Tas) then
      ! Only Tmb to Ta* implemented here
      call modify_scale_notimplemented(error)
      return
    endif
    !
    factor = obs%head%cal%beeff/obs%head%cal%foeff
    !
  end subroutine modify_scale_t
  !
  subroutine modify_scale_notimplemented(error)
    logical, intent(inout) :: error
    call class_message(seve%e,rname,'Modifying Y unit scale from '//  &
      trim(obs_yunit(obs%head%gen%yunit))//' to '//trim(obs_yunit(tocode))//  &
      ' is not implemented')
    error = .true.
  end subroutine modify_scale_notimplemented
  !
end subroutine modify_scale
!
subroutine modify_doppler(set,code,head,error)
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>modify_doppler
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  MODIFY DOPPLER [SIGN|*|Value]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: code   !
  type(header),        intent(inout) :: head   ! head%pos%doppler modified in return
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  character(len=message_length) :: mess
  real(kind=8) :: dop0,dop1
  logical, save :: doppler_pb
  logical, save :: first = .true.
  !
  dop0 = head%spe%doppler
  select case (code)
  case ('')
    if (first) then
      call sic_def_logi('DOPPLER_PB',doppler_pb,.true.,error)
      first = .false.
    endif
    !*  Test the likelyhood of a sign error for the Doppler factor (-V/c),
    !   by comparing the stored Doppler factor to the computed
    !   Doppler correction in the source direction.
    ! * Compare Doppler factor down to 0.6m/s change in V
    !   (LO precision is 10Hz @ 5GHz)
    ! * SIC variable DOPPLER_PB is created and set to correct state
    ! * Doppler factor is NOT changed
    call compute_doppler(set,head,.true.,error)
    if (error) return
    dop1 = head%spe%doppler
    head%spe%doppler = dop0 ! reset the Doppler correction
    if (abs(dop1-dop0)*clight.gt.6.d-1.and.dop0*dop1.lt.0.d0) then
      write(mess,'(a,g14.8,a,g14.8)') &
          'Sign problem for Doppler factor: Old ',dop0,' New ',dop1
      doppler_pb = .true.
    else
      doppler_pb = .false.
      write(mess,'(a,1pg14.8)') 'Doppler factor agree ',dop0
    endif
    !
  case ('SIGN')
    ! Reverse the sign of the Doppler factor (patch)
    head%spe%doppler = -dop0
    write(mess,*) 'Swap doppler factor sign. New value is: ',head%spe%doppler
    !
  case ('*')
    ! Compute Doppler factor
    call compute_doppler(set,head,.true.,error)
    write(mess,*) 'Doppler factor set to: ',head%spe%doppler
    !
  case default
    ! Change Doppler value from user value
    call sic_math_dble(code,len_trim(code),dop1,error)
    if (error) return
    head%spe%doppler = dop1
    write(mess,*) 'Doppler factor set to: ',head%spe%doppler
  end select
  !
  call class_message(seve%i,rname,mess)
  !
end subroutine modify_doppler
!
subroutine modify_vconvention(set,head,error)
  use gbl_message
  use classcore_interfaces, except_this=>modify_vconvention
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Support routine for command:
  !  MODIFY VCONVENTION
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(header),        intent(inout) :: head   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  real(kind=8) :: dop_rad,dop_opt
  !
  dop_rad = 1.d0+head%spe%doppler
  dop_opt = 1.d0/(1.d0-head%spe%doppler)
  !
  head%spe%rchan = head%spe%rchan +  &
                   (dop_opt-dop_rad) * head%spe%restf/head%spe%fres
  !
  ! head%spe%vconv = ZZZ should be changed when the definition of vconv
  !                      is clarified
  !
end subroutine modify_vconvention
!
subroutine modify_vdirection(set,head,error)
  use gbl_message
  use classcore_interfaces, except_this=>modify_vdirection
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Support routine for command:
  !  MODIFY VDIRECTION
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(header),        intent(inout) :: head   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  real(kind=8) :: dop_old,dop_new
  !
  if (head%spe%vdire.eq.vdire_act)  return
  !
  dop_old = head%spe%doppler
  ! write (*,*) ">>> Doppler old : ",dop_old
  !
  ! Recompute Doppler at reference position
  ! call compute_doppler(set,head,.true.,error)
  ! if (error)  return
  ! d1 = head%spe%doppler
  ! write (*,*)  ">>> At reference: ",d1,(dop_old-d1)/dop_old*head%spe%restf
  !
  ! Recompute Doppler at the offset position
  call compute_doppler(set,head,.false.,error)
  if (error)  return
  dop_new = head%spe%doppler
  ! write (*,*)  ">>> At offset   : ",dop_new,(d1-dop_new)/d1*head%spe%restf
  !
  if (head%spe%image.ne.image_null) then
    head%spe%image = head%spe%image*(1.d0+dop_old)/(1.d0+dop_new) -  &
                     head%spe%restf*(dop_new-dop_old)/(1.d0+dop_new)
  endif
  head%spe%rchan   = head%spe%rchan +  &
                     head%spe%restf/head%spe%fres*(dop_new-dop_old)
  !
  head%spe%vdire = vdire_act
  !
end subroutine modify_vdirection
!
subroutine modify_elevationgain(obs,error)
  use phys_const
  use gbl_message
  use classcore_interfaces, except_this=>modify_elevationgain
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Apply elevation gain correction for 30M data (see Juan Penalver memo
  ! 16-Apr-2012).
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='ELEVATION_GAIN'
  character(len=24) :: teles
  real(kind=4) :: gain,el,fghz
  character(len=message_length) :: mess
  !
  call my_get_teles(rname,obs%head%gen%teles,.true.,teles,error)
  if (error) then
    call class_message(seve%e,rname,'Can not correct for unknown telescope')
    error = .true.
    return
  endif
  if (teles.ne.'30M') then
    call class_message(seve%e,rname,'Correction is not available for telescope '//teles)
    error = .true.
    return
  endif
  !
  fghz = obs%head%spe%restf/1e3
  el = obs%head%gen%el*deg_per_rad
  gain = elevationgain(fghz,el)
  !
  write(mess,'(A,F5.3,A,F0.3,A,F0.1,A)')  'Applying gain ',gain,  &
    ' at freq ',fghz,' GHz elevation ',el,' deg.'
  call class_message(seve%i,rname,mess)
  !
  call rescale_header(obs%head,1/gain)
  call rescale_data(obs,1/gain)
  !
contains
  function elevationgain(freq,elobs)
    real(kind=4) :: elevationgain
    real(kind=4), intent(in) :: freq   ! [GHz]
    real(kind=4), intent(in) :: elobs  ! [deg]
    ! Local
    real(kind=4) :: lambdamu,elmax
    !
    lambdamu = clight_kms/freq  ! km/s / GHz => microns
    elmax = 1.567e-6*freq**3 - 1.233e-3*freq**2 + 3.194e-1*freq+2.203e+1
    elevationgain = aeff(lambdamu,elobs)/aeff(lambdamu,elmax)
    !
  end function elevationgain
  !
  function aeff(lambdamu,el)
    real(kind=4) :: aeff
    real(kind=4), intent(in) :: lambdamu  ! [microns]
    real(kind=4), intent(in) :: el        ! [deg]
    ! Local
    real(kind=4) :: aeff0,rms
    !
    aeff0 = 8.8466e-6*el**2 - 1.2523e-3*el + 6.9608e-1
    rms   = 2.5523e-2*el**2 - 2.5534*el + 1.1937e+2
    aeff  = aeff0 * exp(-1*((4*pi*rms)/(lambdamu))**2)
    !
  end function aeff
  !
end subroutine modify_elevationgain
!
subroutine modify_parang(obs,error)
  use phys_const
  use gbl_message
  use gkernel_interfaces
  use classcore_interfaces, except_this=>modify_parang
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Recompute the parallactic angle from latitude + azimuth + elevation
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='PARALLACTIC_ANGLE'
  character(len=24) :: teles
  real(kind=8) :: lonlat(2),alti,slimit
  real(kind=4) :: diam
  real(kind=8) :: lat,az,el
  character(len=message_length) :: mess
  !
  call my_get_teles(rname,obs%head%gen%teles,.false.,teles,error)
  if (error)  return
  if (teles.ne.'30M') then
    call class_message(seve%w,rname,  &
      'Assuming azimuth convention South at 180 degrees for telescope '//teles)
    error = .true.
    return
  endif
  !
  call gwcs_observatory(teles,lonlat,alti,slimit,diam,error)
  if (error)  return
  lat = lonlat(2)*rad_per_deg
  az = obs%head%gen%az  ! Is this the azimuth of the spectrum or the projection center?
  el = obs%head%gen%el  ! Same
  call gwcs_azel2pa(lat,az,el,obs%head%gen%parang)
  !
  !---------------------------------------------------------------------
  ! This version of the code uses the traditional parallactic angle
  ! formula, but needs to precess the exact position of the spectrum.
  !
  !  ! Need the equinox at observation date
  !  call gag_gagut2mjd(obs%head%gen%dobs,obs%head%gen%ut,mjd,error)
  !  if (error)  return
  !  call gag_mjd2gregorian(mjd,iy,im,id,error)
  !  if (error)  return
  !  newequinox = iy  ! ZZZ To be improved for fractional part
  !  !
  !  ! Precess the RA/DEC coordinates at observation date
  !  if (obs%head%pos%system.ne.type_eq) then
  !    call class_message(seve%e,rname,  &
  !      'Computing parallactic angle from non-equatorial system is not implemented')
  !    ! Actually we could go from any system to EQ.XXXX
  !    error = .true.
  !    return
  !  endif
  !  call equ_to_equ(  &
  !    obs%head%pos%lam,obs%head%pos%bet,obs%head%pos%lamof,obs%head%pos%betof,obs%head%pos%equinox,  &
  !    newra,           newdec,          lamof,             betof,             newequinox,  &
  !    error)
  !  if (error)  return
  !  ! ZZZ This is new (RA,DEC) at projection center, not spectrum position!
  !  !
  !  ! Compute parallactic angle
  !  ha = obs%head%gen%st-newra
  !  obs%head%gen%parang = atan2(sin(ha),tan(lat)*cos(newdec)-sin(newdec)*cos(ha))
  !---------------------------------------------------------------------
  !
  write(mess,'(A,F0.3,A)')  &
    'Parallactic angle set to ',obs%head%gen%parang*deg_per_rad,' degrees'
  call class_message(seve%i,rname,mess)
  !
end subroutine modify_parang

module cubetools_uservar ! should be renamed to uservar
  use gkernel_interfaces
  use gbl_format
  use cubesyntax_messaging
  use cubetools_parameters
  use cubetools_userspace
  !
  ! Formats
  character(len=*), parameter :: fmt1d = '(a,"[",i0,"]")'
  character(len=*), parameter :: fmt2d = '(a,"[",i0,",",i0,"]")'
  character(len=*), parameter :: fmt3d = '(a,"[",i0,",",i0,",",i0,"]")'
  !
  !
  type, extends(userspace_t) :: uservar_t
   contains
     procedure :: create    => cubetools_sicdef_var_create  
     !
     procedure :: get_dims  => cubetools_sicdef_getdims
     !
     generic   :: set       => def_r4_0d,def_r4_1d,def_r4_2d,def_r4_3d,&
                               def_r8_0d,def_r8_1d,def_r8_2d,def_r8_3d,&
                               def_c4_0d,def_c4_1d,def_c4_2d,def_c4_3d,&
                               def_i4_0d,def_i4_1d,def_i4_2d,def_i4_3d,&
                               def_i8_0d,def_i8_1d,def_i8_2d,def_i8_3d,&
                               def_st_0d,def_st_1d,&
                               def_lg_0d
     !
     generic   :: get       => get_r4_0d,get_r4_1d,get_r4_2d,get_r4_3d,&
                               get_r8_0d,get_r8_1d,get_r8_2d,get_r8_3d,&
                               get_c4_0d,get_c4_1d,get_c4_2d,get_c4_3d,&
                               get_i4_0d,get_i4_1d,get_i4_2d,get_i4_3d,&
                               get_i8_0d,get_i8_1d,get_i8_2d,get_i8_3d,&
                               get_st_0d,&
                               get_lg_0d
     !
     procedure :: def_r4_0d => cubetools_sicdef_r4_0d
     procedure :: def_r4_1d => cubetools_sicdef_r4_1d
     procedure :: def_r4_2d => cubetools_sicdef_r4_2d
     procedure :: def_r4_3d => cubetools_sicdef_r4_3d
     !
     procedure :: def_r8_0d => cubetools_sicdef_r8_0d
     procedure :: def_r8_1d => cubetools_sicdef_r8_1d
     procedure :: def_r8_2d => cubetools_sicdef_r8_2d
     procedure :: def_r8_3d => cubetools_sicdef_r8_3d
     !
     procedure :: def_c4_0d => cubetools_sicdef_c4_0d
     procedure :: def_c4_1d => cubetools_sicdef_c4_1d
     procedure :: def_c4_2d => cubetools_sicdef_c4_2d
     procedure :: def_c4_3d => cubetools_sicdef_c4_3d
     !
     procedure :: def_i4_0d => cubetools_sicdef_i4_0d
     procedure :: def_i4_1d => cubetools_sicdef_i4_1d
     procedure :: def_i4_2d => cubetools_sicdef_i4_2d
     procedure :: def_i4_3d => cubetools_sicdef_i4_3d
     !
     procedure :: def_i8_0d => cubetools_sicdef_i8_0d
     procedure :: def_i8_1d => cubetools_sicdef_i8_1d
     procedure :: def_i8_2d => cubetools_sicdef_i8_2d
     procedure :: def_i8_3d => cubetools_sicdef_i8_3d
     !
     procedure :: def_st_0d => cubetools_sicdef_st_0d
     procedure :: def_st_1d => cubetools_sicdef_st_1d
     !
     procedure :: def_lg_0d => cubetools_sicdef_lg_0d
     !
     !----------------------------------------------------------------------
     !
     procedure :: get_r4_0d => cubetools_sicget_r4_0d
     procedure :: get_r4_1d => cubetools_sicget_r4_1d
     procedure :: get_r4_2d => cubetools_sicget_r4_2d
     procedure :: get_r4_3d => cubetools_sicget_r4_3d
     !
     procedure :: get_r8_0d => cubetools_sicget_r8_0d
     procedure :: get_r8_1d => cubetools_sicget_r8_1d
     procedure :: get_r8_2d => cubetools_sicget_r8_2d
     procedure :: get_r8_3d => cubetools_sicget_r8_3d
     !
     procedure :: get_c4_0d => cubetools_sicget_c4_0d
     procedure :: get_c4_1d => cubetools_sicget_c4_1d
     procedure :: get_c4_2d => cubetools_sicget_c4_2d
     procedure :: get_c4_3d => cubetools_sicget_c4_3d
     !
     procedure :: get_i4_0d => cubetools_sicget_i4_0d
     procedure :: get_i4_1d => cubetools_sicget_i4_1d
     procedure :: get_i4_2d => cubetools_sicget_i4_2d
     procedure :: get_i4_3d => cubetools_sicget_i4_3d
     !
     procedure :: get_i8_0d => cubetools_sicget_i8_0d
     procedure :: get_i8_1d => cubetools_sicget_i8_1d
     procedure :: get_i8_2d => cubetools_sicget_i8_2d
     procedure :: get_i8_3d => cubetools_sicget_i8_3d
     !
     procedure :: get_st_0d => cubetools_sicget_st_0d
     !
     procedure :: get_lg_0d => cubetools_sicget_lg_0d
  end type uservar_t
  !
  public :: uservar_t, cubetools_userspace_get
  public :: cubetools_uservar_ptr
  private
  !
contains
  !
  function cubetools_uservar_ptr(userspace,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(uservar_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    type(uservar_t),    pointer :: cubetools_uservar_ptr  ! Function value on return
    class(userspace_t), target        :: userspace
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='USERVAR>PTR'
    !
    select type(userspace)
    type is (uservar_t)
      cubetools_uservar_ptr => userspace
    class default
      cubetools_uservar_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: user space is not a uservar_t type')
      error = .true.
      return
    end select
  end function cubetools_uservar_ptr
  !
  subroutine cubetools_sicdef_var_create(uservar,name,scope,overwrite,error)
    !------------------------------------------------------------------------
    ! Create a uservar instance from name and scope 
    !------------------------------------------------------------------------
    class(uservar_t),     intent(out)   :: uservar
    character(len=*),     intent(in)    :: name
    logical,              intent(in)    :: scope
    integer(kind=code_k), intent(in)    :: overwrite
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>VAR'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    uservar%name = name
    uservar%scope = scope
    uservar%overwrite = overwrite
    call uservar%delete(error)
    if (error) return
  end subroutine cubetools_sicdef_var_create
  !
  subroutine cubetools_sicdef_r4_0d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a r4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    real(kind=4),     intent(in)    :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>R4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    call sic_defvariable(fmt_r4,trim(uservar%name),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,error)
    if (error) return
  end subroutine cubetools_sicdef_r4_0d
  !
  subroutine cubetools_sicdef_r4_1d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a r4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    real(kind=4),     intent(in)    :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dim
    character(len=*), parameter :: rname='SICDEF>R4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dim = size(data)
    write(fullname,fmt1d) trim(uservar%name),dim
    !
    call sic_defvariable(fmt_r4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,dim,error)
    if (error) return
  end subroutine cubetools_sicdef_r4_1d
  !
  subroutine cubetools_sicdef_r4_2d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a r4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    real(kind=4),     intent(in)    :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(2)
    character(len=*), parameter :: rname='SICDEF>R4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt2d) trim(uservar%name),dims(1),dims(2)
    !
    call sic_defvariable(fmt_r4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fillr4_1d(rname,uservar%name,data,dims(1)*dims(2),error)
    if (error) return
  end subroutine cubetools_sicdef_r4_2d
  !
  subroutine cubetools_sicdef_r4_3d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a r4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    real(kind=4),     intent(in)    :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(3)
    character(len=*), parameter :: rname='SICDEF>R4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt3d) trim(uservar%name),dims(1),dims(2),dims(3)
    !
    call sic_defvariable(fmt_r4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fillr4_1d(rname,uservar%name,data,dims(1)*dims(2)*dims(3),error)
    if (error) return
  end subroutine cubetools_sicdef_r4_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_r8_0d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a r8 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    real(kind=8),     intent(in)    :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>R8>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    call sic_defvariable(fmt_r8,trim(uservar%name),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,error)
    if (error) return
  end subroutine cubetools_sicdef_r8_0d
  !
  subroutine cubetools_sicdef_r8_1d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a r8 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    real(kind=8),     intent(in)    :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dim
    character(len=*), parameter :: rname='SICDEF>R8>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dim = size(data)
    write(fullname,fmt1d) trim(uservar%name),dim
    !
    call sic_defvariable(fmt_r8,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,dim,error)
    if (error) return
  end subroutine cubetools_sicdef_r8_1d
  !
  subroutine cubetools_sicdef_r8_2d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a r8 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    real(kind=8),     intent(in)    :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(2)
    character(len=*), parameter :: rname='SICDEF>R8>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt2d) trim(uservar%name),dims(1),dims(2)
    !
    call sic_defvariable(fmt_r8,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fillr8_1d(rname,uservar%name,data,dims(1)*dims(2),error)
    if (error) return
  end subroutine cubetools_sicdef_r8_2d
  !
  subroutine cubetools_sicdef_r8_3d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a r8 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    real(kind=8),     intent(in)    :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(3)
    character(len=*), parameter :: rname='SICDEF>R8>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt3d) trim(uservar%name),dims(1),dims(2),dims(3)
    !
    call sic_defvariable(fmt_r8,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fillr8_1d(rname,uservar%name,data,dims(1)*dims(2)*dims(3),error)
    if (error) return
  end subroutine cubetools_sicdef_r8_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_c4_0d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a c4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    complex(kind=4),  intent(in)    :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>C4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    call sic_defvariable(fmt_c4,trim(uservar%name),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,error)
    if (error) return
  end subroutine cubetools_sicdef_c4_0d
  !
  subroutine cubetools_sicdef_c4_1d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a c4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    complex(kind=4),  intent(in)    :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dim
    character(len=*), parameter :: rname='SICDEF>C4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dim = size(data)
    write(fullname,fmt1d) trim(uservar%name),dim
    !
    call sic_defvariable(fmt_c4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,dim,error)
    if (error) return
  end subroutine cubetools_sicdef_c4_1d
  !
  subroutine cubetools_sicdef_c4_2d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a c4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    complex(kind=4),  intent(in)    :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(2)
    character(len=*), parameter :: rname='SICDEF>C4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt2d) trim(uservar%name),dims(1),dims(2)
    !
    call sic_defvariable(fmt_c4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fillc4_1d(rname,uservar%name,data,dims(1)*dims(2),error)
    if (error) return
  end subroutine cubetools_sicdef_c4_2d
  !
  subroutine cubetools_sicdef_c4_3d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a c4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    complex(kind=4),  intent(in)    :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(3)
    character(len=*), parameter :: rname='SICDEF>C4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt3d) trim(uservar%name),dims(1),dims(2),dims(3)
    !
    call sic_defvariable(fmt_c4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fillc4_1d(rname,uservar%name,data,dims(1)*dims(2)*dims(3),error)
    if (error) return
  end subroutine cubetools_sicdef_c4_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_i4_0d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a i4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    integer(kind=4),  intent(in)    :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>I4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    call sic_defvariable(fmt_i4,trim(uservar%name),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,error)
    if (error) return
  end subroutine cubetools_sicdef_i4_0d
  !
  subroutine cubetools_sicdef_i4_1d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a i4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    integer(kind=4),  intent(in)    :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dim
    character(len=*), parameter :: rname='SICDEF>I4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dim = size(data)
    write(fullname,fmt1d) trim(uservar%name),dim
    !
    call sic_defvariable(fmt_i4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,dim,error)
    if (error) return
  end subroutine cubetools_sicdef_i4_1d
  !
  subroutine cubetools_sicdef_i4_2d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a i4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    integer(kind=4),  intent(in)    :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(2)
    character(len=*), parameter :: rname='SICDEF>I4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt2d) trim(uservar%name),dims(1),dims(2)
    !
    call sic_defvariable(fmt_i4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_filli4_1d(rname,uservar%name,data,dims(1)*dims(2),error)
    if (error) return
  end subroutine cubetools_sicdef_i4_2d
  !
  subroutine cubetools_sicdef_i4_3d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a i4 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    integer(kind=4),  intent(in)    :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(3)
    character(len=*), parameter :: rname='SICDEF>I4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt3d) trim(uservar%name),dims(1),dims(2),dims(3)
    !
    call sic_defvariable(fmt_i4,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_filli4_1d(rname,uservar%name,data,dims(1)*dims(2)*dims(3),error)
    if (error) return
  end subroutine cubetools_sicdef_i4_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_i8_0d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a i8 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    integer(kind=8),  intent(in)    :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>I8>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    call sic_defvariable(fmt_i8,trim(uservar%name),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,error)
    if (error) return
  end subroutine cubetools_sicdef_i8_0d
  !
  subroutine cubetools_sicdef_i8_1d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a i8 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    integer(kind=8),  intent(in)    :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dim
    character(len=*), parameter :: rname='SICDEF>I8>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dim = size(data)
    write(fullname,fmt1d) trim(uservar%name),dim
    !
    call sic_defvariable(fmt_i8,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,dim,error)
    if (error) return
  end subroutine cubetools_sicdef_i8_1d
  !
  subroutine cubetools_sicdef_i8_2d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a i8 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    integer(kind=8),  intent(in)    :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(2)
    character(len=*), parameter :: rname='SICDEF>I8>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt2d) trim(uservar%name),dims(1),dims(2)
    !
    call sic_defvariable(fmt_i8,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_filli8_1d(rname,uservar%name,data,dims(1)*dims(2),error)
    if (error) return
  end subroutine cubetools_sicdef_i8_2d
  !
  subroutine cubetools_sicdef_i8_3d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a i8 sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    integer(kind=8),  intent(in)    :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=varn_l) :: fullname
    integer(kind=size_length) :: dims(3)
    character(len=*), parameter :: rname='SICDEF>I8>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    !
    dims = shape(data)
    write(fullname,fmt3d) trim(uservar%name),dims(1),dims(2),dims(3)
    !
    call sic_defvariable(fmt_i8,trim(fullname),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_filli8_1d(rname,uservar%name,data,dims(1)*dims(2)*dims(3),error)
    if (error) return
  end subroutine cubetools_sicdef_i8_3d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_st_0d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a string sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    character(len=*), intent(in)    :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>ST>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    call sic_defvariable(len(data),trim(uservar%name),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,error)
    if (error) return
  end subroutine cubetools_sicdef_st_0d
  !
  subroutine cubetools_sicdef_st_1d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a string sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    character(len=*), intent(in)    :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=16) :: dims
    integer(kind=size_length) nelem
    character(len=*), parameter :: rname='SICDEF>ST>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    nelem = size(data)
    write (dims,'(a,i0,a)') '[',nelem,']'
    call sic_defvariable(len(data),trim(uservar%name)//trim(dims),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fillch_1d(rname,trim(uservar%name),data,nelem,error)
    if (error) return
  end subroutine cubetools_sicdef_st_1d
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_lg_0d(uservar,data,error)
    !------------------------------------------------------------------------
    ! Define a logical sic variable and fills it with data
    !------------------------------------------------------------------------
    class(uservar_t), intent(inout) :: uservar
    logical,          intent(in)    :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICDEF>LG>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call uservar%delete(error)
    if (error) return
    call sic_defvariable(fmt_l,trim(uservar%name),uservar%scope,error)
    if (error) return
    call uservar%fetch_desc(error)
    if (error) return
    call sic_variable_fill(rname,trim(uservar%name),data,error)
    if (error) return
  end subroutine cubetools_sicdef_lg_0d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_getdims(uservar,ndim,dims,error)
    !----------------------------------------------------------------------
    ! Return dimensions of the SIC variable
    !----------------------------------------------------------------------
    class(uservar_t),                  intent(in)    :: uservar
    integer(kind=4),                   intent(out)   :: ndim
    integer(kind=entr_k), allocatable, intent(out)   :: dims(:)
    logical,                           intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='SICDEF>GETDIMS'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ndim = uservar%desc%ndim
    if (ndim.gt.0) then
       allocate(dims(ndim),stat=ier)
       if (failed_allocate(rname,'dims',ier,error)) return
       dims(:) = uservar%desc%dims(1:ndim)
    endif
  end subroutine cubetools_sicdef_getdims
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_r4_0d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets R4 0d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    real(kind=4),     intent(inout) :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>R4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.0) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not scalar')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,int(1,kind=size_length),data,error)
    if (error)  return
  end subroutine cubetools_sicget_r4_0d
  !
  subroutine cubetools_sicget_r4_1d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets R4 1d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    real(kind=4),     intent(inout) :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>R4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.1) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 1D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_r4_1d
  !
  subroutine cubetools_sicget_r4_2d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets R4 2d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    real(kind=4),     intent(inout) :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>R4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.2) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 2D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_r4_2d
  !
  subroutine cubetools_sicget_r4_3d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets R4 3d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    real(kind=4),     intent(inout) :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>R4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.3) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 3D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_r4_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_r8_0d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets R8 0d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    real(kind=8),     intent(inout) :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>R8>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.0) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not scalar')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,int(1,kind=size_length),data,error)
    if (error)  return
  end subroutine cubetools_sicget_r8_0d
  !
  subroutine cubetools_sicget_r8_1d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets R8 1d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    real(kind=8),     intent(inout) :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>R8>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.1) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 1D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_r8_1d
  !
  subroutine cubetools_sicget_r8_2d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets R8 2d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    real(kind=8),     intent(inout) :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>R8>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.2) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 2D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_r8_2d
  !
  subroutine cubetools_sicget_r8_3d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets R8 3d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    real(kind=8),     intent(inout) :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>R8>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.3) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 3D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_r8_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_c4_0d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets C4 0d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    complex(kind=4),  intent(inout) :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>C4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.0) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not scalar')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,int(1,kind=size_length),data,error)
    if (error)  return
  end subroutine cubetools_sicget_c4_0d
  !
  subroutine cubetools_sicget_c4_1d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets C4 1d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    complex(kind=4),  intent(inout) :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>C4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.1) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 1D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_c4_1d
  !
  subroutine cubetools_sicget_c4_2d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets C4 2d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    complex(kind=4),  intent(inout) :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>C4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.2) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 2D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_c4_2d
  !
  subroutine cubetools_sicget_c4_3d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets C4 3d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    complex(kind=4),  intent(inout) :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>C4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.3) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 3D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_c4_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_i4_0d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets I4 0d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    integer(kind=4),  intent(inout) :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>I4>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.0) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not scalar')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,int(1,kind=size_length),data,error)
    if (error)  return
  end subroutine cubetools_sicget_i4_0d
  !
  subroutine cubetools_sicget_i4_1d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets I4 1d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    integer(kind=4),  intent(inout) :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>I4>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.1) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 1D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_i4_1d
  !
  subroutine cubetools_sicget_i4_2d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets I4 2d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    integer(kind=4),  intent(inout) :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>I4>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.2) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 2D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_i4_2d
  !
  subroutine cubetools_sicget_i4_3d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets I4 3d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    integer(kind=4),  intent(inout) :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>I4>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.3) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 3D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_i4_3d
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_sicget_i8_0d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets I8 0d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    integer(kind=8),  intent(inout) :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>I8>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.0) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not scalar')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,int(1,kind=size_length),data,error)
    if (error)  return
  end subroutine cubetools_sicget_i8_0d
  !
  subroutine cubetools_sicget_i8_1d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets I8 1d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    integer(kind=8),  intent(inout) :: data(:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>I8>1D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.1) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 1D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_i8_1d
  !
  subroutine cubetools_sicget_i8_2d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets I8 2d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    integer(kind=8),  intent(inout) :: data(:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>I8>2D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.2) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 2D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_i8_2d
  !
  subroutine cubetools_sicget_i8_3d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets I8 3d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    integer(kind=8),  intent(inout) :: data(:,:,:)
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>I8>3D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.3) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not 3D')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,data,error)
    if (error)  return
  end subroutine cubetools_sicget_i8_3d
  !
  subroutine cubetools_sicget_st_0d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets STring 0d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    character(len=*), intent(inout) :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>ST>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.0) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not scalar')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,int(1,kind=size_length),data,error)
    if (error)  return
  end subroutine cubetools_sicget_st_0d
  !
  subroutine cubetools_sicget_lg_0d(uservar,data,error)
    !----------------------------------------------------------------------
    ! Gets Logical 0d data from a SIC variable
    !----------------------------------------------------------------------
    class(uservar_t), intent(in)    :: uservar
    logical,          intent(inout) :: data
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICGET>LG>0D'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (uservar%desc%ndim.ne.0) then
       call cubesyntax_message(seve%e,rname,'SIC variable is not scalar')
       error = .true.
       return
    endif
    call sic_descriptor_getval(uservar%desc,int(1,kind=size_length),data,error)
    if (error)  return
  end subroutine cubetools_sicget_lg_0d
end module cubetools_uservar

subroutine pdbi_line(line,error)
  use gildas_def
  use gkernel_interfaces
  use astro_interfaces, except_this=>pdbi_line
  !---------------------------------------------------------------------
  !@ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Input command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=commandline_length) :: comm,mess
  !
  call pdbi_line_sub(line,error)
  if (error) then
    write (mess,'(a)') 'Error executing command line'
    call gr_execl('CLEAR DIRECTORY')
    call gr_exec1('SET ORIEN 0')
    call gr_execl('CLEAR DIRECTORY')
    call gr_exec1('SET BOX 3 29 3 17')
    call gr_exec1('PENCIL /COLO 1')
    write (comm,'(a,a,a)') 'DRAW TEXT 0 0 "',trim(mess),'" /BOX 5'
    call gr_exec1(comm)
    call gr_exec1('PENCIL /COL 0')
  endif
  !
end subroutine pdbi_line
!
subroutine pdbi_line_sub(line,error)
  use gildas_def
  use gkernel_interfaces
  use astro_interfaces, except_this=>pdbi_line_sub
  use gbl_message
  use ast_line
  use ast_astro
  use phys_const
  !---------------------------------------------------------------------
  !@ private
  ! PDBI  Internal routine, support for command
  ! LINE name Freq SB [Lock [Center [Harm]]]
  !         /RECEIVER rec                                (1)
  !         /BEST best                                   (2)
  !         /FIXED_FREQ in order to allow tuning out of the LO 500MHz grid
  !                         (which is the default for obs_year.ge.2015)
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Input command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PDBI_LINE'
  character(len=message_length) :: mess
  character(len=256) :: chain
  character(len=12) :: name,par
  character(len=4) :: band, lock
  integer(kind=4), parameter :: nb_rec=4
  integer(kind=4) :: i,lname,lpar,ipar,ir,iargfcent
  integer(kind=4) :: mult, harm, lck, inputharm
  integer(kind=4) :: irec, userrec
  integer(kind=4) :: tabmult(nb_rec)
  integer(kind=4), parameter :: optfixed=9 !option fixed_frequency
  integer(kind=4), parameter :: optongrid=10 !option ongrid
  real(kind=8) :: fcent,fsky,best,f1,eps,vsys,fsynth,tmpnum,vlsr,lsrshift,ftune,flsr,loobs,lotune,newfcent,oldfcent
  real(kind=8) :: freqmin(nb_rec),freqmax(nb_rec),lolmin(nb_rec),lolmax(nb_rec),loumin(nb_rec),loumax(nb_rec)
  logical :: freqok,sideband_entered,fixed,nosource,ongrid
  data freqmin/74.7,128.2,200.2,275.2/  !RF extreme freq (lsb @7.8ghz if) JMW June 2016
  data freqmax/117.8,179.8,275.8,372.8/ !RF extreme freq (usb @7.8ghz if) JMW June 2016
  data lolmin/82.5,136,208,283/,lolmax/110,172,268,365/  !lo freqs for lsb tunings JMW june 2016
  data loumin/89,139,208,283/,loumax/110,172,268,365/  !lo freqs for usb tunings JMW june 2016
  data tabmult/1,2,3,3/                    !multiplier (pdb 2010)
  !
  ! Reset
  error = .false.
  narrow_def = .false.
  do i = 1,nunit
    unit_def(i) = .false.
  enddo
  !
  ! [PDBI\]LINE linename freq lsb|usb [low|high] [if] [harm]
  !
  ! Line name
  lname = 12
  call sic_ch(line,0,1,name,lname,.true.,error)
  if (error) return
  !
  ! Frequency
  if (fshift.eq.0.0d0) fshift = 1.0d0
  call sic_r8(line,0,2,freq,.true.,error)
  if (error)  return
  if (sic_varexist("ASTRO%SOURCE")) then
    call sic_get_dble('ASTRO%SOURCE%V_SOU_OBS',vsys,error)
    call sic_get_dble('ASTRO%SOURCE%V_SOU_LSR',vlsr,error)
    lsrshift = 1.0d0-vlsr/clight_kms
    nosource = .false.
  else
    vlsr = 0d0
    lsrshift = 1d0
    nosource = .true.
  endif
  fsky = freq*1d3*fshift          ! In MHz
  flsr = freq*1d3*lsrshift       ! In MHz
  !check true frequencies taken from OBS on Fsky
  irec = 0
  do ir=1,nb_rec
    if (fsky.ge.freqmin(ir)*1e3.and.fsky.le.freqmax(ir)*1e3) then
      irec=ir
    endif
  enddo
  if (irec.eq.0) then
    call astro_message(seve%e,rname,'Frequency cannot be observed with NOEMA')
    error = .true.
    return
  endif
  mult=tabmult(irec)
  !
  ! The next parameters are optional and can be entered in any
  ! order
  !
  ! Sideband defaults - USB limits FROM OBS [oct 2015]
  !
  !
  band = 'LSB '
  sky = -1
  if ((fsky.gt.103.55*1e3.and.fsky.lt.120*1e3).or.  &
       (fsky.gt.164*1e3.and.fsky.lt.200*1e3).or.    &
       (fsky.gt.267*1e3.and.fsky.lt.290*1e3)) then
     band = 'USB '
     sky = +1
     call astro_message(seve%i,rname,&
          'Default receiver tuning is USB at that frequency')
  endif
  !
  ! Frequency ofset in the LO system
  ! (changed in Sept. 2013)
  !
  if (obs_year.ge.2013) then
    eps = 100.00d0
  else
    eps = 100.25d0
  endif
  !
  ! Other defaults
  !
  ! Defaults
  harm = 0
  lock = 'LOW'
  lck = -1
  fcent = 6500                 ! Do NOT center at 6000
  oldfcent = 0
  iargfcent = 0
  !
  ! Decode the rest of the command line
  sideband_entered = .false.
  do ipar=3,sic_narg(0)
     call sic_ke(line,0,ipar,par,lpar,.true.,error)
     if (error)  return
     !
     if (par(1:1).eq.'H') then
        !
        ! HIGH
        call astro_message(seve%w,rname,  &
             'LOCK LOW|HIGH is not an input parameter anymore')
        !
     elseif (par(1:1).eq.'L') then
        !
        ! LOW
        if (lpar.ge.2.and.par(1:2).eq.'LO') then
           call astro_message(seve%w,rname, &
                'LOCK LOW|HIGH is not an input parameter anymore')
           cycle
        endif
        !
        ! LSB
        if (sideband_entered) then
           call astro_message(seve%e,rname,'Ambiguous entries: LSB or USB?')
           error = .true.
           return
        endif
        if (band(1:1).eq.'U') then
           call astro_message(seve%w,rname,'Default tuning (USB) forced to LSB')
        endif
        band = 'LSB '
        sky = -1
        sideband_entered = .true.
        !
     elseif (par(1:1).eq.'U') then
        !
        ! USB
        if (sideband_entered) then
           call astro_message(seve%e,rname,'Ambiguous entries: LSB or USB?')
           error = .true.
           return
        endif
        if (band(1:1).eq.'L') then
           call astro_message(seve%w,rname,'Default tuning (LSB) forced to USB')
        endif
        band = 'USB '
        sky = 1
        sideband_entered = .true.
        !
     else
        ! A number...
        call sic_math_dble (par,lpar,tmpnum,error)
        if (error) goto 930
        if (tmpnum.gt.4210 .and. tmpnum.lt.7790) then
           ! Fcent in MHz
           fcent = tmpnum
           iargfcent = ipar
        elseif (tmpnum.ge.32 .and. tmpnum.le.70) then
           ! Harmonic number - old system  (<2010)
           if (obs_year.lt.2010) then
              harm = tmpnum
           else
              call astro_message(seve%e,rname,'Invalid harmonic number 1')
              error = .true.
              return
           endif
        elseif (tmpnum.ge.5 .and. tmpnum.le.9) then
           ! Harmonic number - old system  (<2010)
           if (obs_year.ge.2010) then
              harm = tmpnum
           else
              call astro_message(seve%e,rname,'Invalid harmonic number 2')
              error = .true.
              return
           endif
        else
           error = .true.
           goto 930
        endif
     endif
  enddo
  !
  ! LINE /BEST bestvalue  [this option #5 of LINE command]
  !
  best = 0
  call sic_r8(line,5,1,best,.false.,error)
  if (error) return
  if (best.eq.0) best=1850
  !
  ! /RECEIVER option #8
  !
  userrec = irec
  call sic_i4(line,8,1,userrec,.false.,error)
  if (error) return
  if ((userrec.lt.1).or.(userrec.gt.4)) then
    call astro_message(seve%e,rname,'Only 4 receivers available')
    error = .true.
    return
  endif
  if (irec.ne.userrec) then
    call astro_message(seve%e,rname,'Frequency/Receiver mismatch')
    error = .true.
    return
  endif
  !
  ! /FIXED_FREQ option #optfixed - if fixed freq is given, we don't check the tuning grid
  !
  fixed = sic_present(optfixed,0)
  if (fixed.and.obs_year.lt.2015) then
    call astro_message(seve%w,rname,'Option /FIXED_FREQ ignored. Valid only with PdBI 2015')
  endif
  !
  ! /ONGRID option #optongrid
  ! With this option the system will choose the IF centrer freq so that the tuning LO is on the tuning grid
  !
  ongrid = sic_present(optongrid,0)
  if (ongrid.and.obs_year.lt.2015) then
    call astro_message(seve%w,rname,'Option /ONGRID ignored. Valid only with PdBI 2015')
  endif
  if (ongrid.and.fixed.and.obs_year.ge.2015) then
    call astro_message(seve%e,rname,'Options /FIXED_FREQ and /ONGRID are exclusive from each other')
    error = .true.
    return
  endif
  !
  ! Define harmonic number - LO system until Sept. 2010
  !
98 continue
  harm=0
  if (obs_year.lt.2010) then
     if (harm.eq.0) then
        f1 =  (fsky - sky*fcent + lck*eps*mult) / (best*mult)
        harm = int(f1)
     endif
     !
     ! Check resulting FLO1REF
     !
     flo1ref = (fsky - sky*fcent + lck*mult*eps) / (harm*mult)
     if (flo1ref.lt.1850 .or. flo1ref.gt.1900) then
        write(chain,'(A,1PG10.3)') 'Invalid LO1REF frequency',flo1ref
        call astro_message(seve%e,rname,chain)
        goto 99
     endif
     !
     ! Compute FLO1 and FLO1REF
     !
     flo1ref = (fsky - sky*fcent + lck*mult*eps) / (mult*harm)
     flo1 = mult*(harm*flo1ref - lck*eps)
     fsynth = flo1ref+0.5d0
     !
     !! Check that other formulas give same results
     !!      PRINT *,flo1,flo1ref
     !!      FLO1 = FSKY - SKY*FCENT
     !!      FLO1REF = FLO1/MULT/HARM + LCK*EPS/HARM
     !!      PRINT *,flo1,flo1ref
     !
  else
     !
     ! New LO 3G (Sept. 2010)
     !
     inputharm = harm
     freqok = .false.
     harm = 5
     if (fixed) then
       ftune = fsky
     else
       ftune = flsr
     endif
     do while ((.not.freqok).and.(harm.le.8))
        flo1ref =  (ftune - sky*fcent + lck*eps*mult) / (harm*mult)
        if ((flo1ref.gt.13200d0).and.(flo1ref.lt.16400d0)) then
           freqok = .true.
        else
           harm = harm+1
        endif
     enddo
     if (.not.freqok) then
        call astro_message(seve%e,rname,'Impossible to find harmonic number')
        error = .true.
        return
     endif
     !
     ! Give priority to harmonic number in LINE command
     !
     if ((inputharm.ne.0).and.(inputharm.ne.harm)) then
        harm = inputharm
        flo1ref = (ftune - sky*fcent + lck*eps*mult) / (harm*mult)
        if ((flo1ref.gt.13400d0).and.(flo1ref.lt.16100d0)) then
           call astro_message (seve%w,rname, &
                'A lower harmonic number may be preferable')
        else
           call astro_message (seve%e,rname,'Invalid harmonic number')
           error = .true.
           return
        endif
     endif
     !
     ! Compute FLO1 and FLO1REF
     !
     flo1ref = (ftune - sky*fcent + lck*mult*eps) / (mult*harm)
     flo1 = mult*(harm*flo1ref - lck*eps)
     fsynth = flo1ref/8d0+0.5d0
  endif
  !CHECK that FLO1 is in the right range given the USB/LSB band
  if (band.eq.'LSB'.and.(flo1.lt.lolmin(irec)*1e3.or.flo1.gt.lolmax(irec)*1e3)) then
    call astro_message(seve%e,rname,'LO frequency out of range. Tuning impossible in LSB')
    error = .true.
    return
  endif
  if (band.eq.'USB'.and.(flo1.lt.loumin(irec)*1e3.or.flo1.gt.loumax(irec)*1e3)) then
    call astro_message(seve%e,rname,'LO frequency out of range. Tuning impossible in USB')
    error = .true.
    return
  endif
  !
  ! Check that flo is on the grid provided by  FE group
  !
  if (obs_year.ge.2015) then
    if (.not.fixed) then
      call line_check_grid(line,iargfcent,flo1,fcent,sky,ftune,ongrid,newfcent,error)
      if (error) then
        if (.not.ongrid) return
        oldfcent = fcent
        fcent = newfcent
        error = .false.
        goto 98
      endif
      loobs = fsky-sky*fcent
      lotune=flo1
      flo1=loobs
    endif
  endif
  !
  ! Output message
  !
  write(mess,'(A,I2,A,A,A)') 'Setup valid for receiver ', irec,' (',trim(band),')'
  call astro_message(seve%i,rname,mess)
  if (irec.eq.4) then
    call astro_message(seve%w,rname,'----------------------------------------------------------------')
    call astro_message(seve%w,rname,'Note that Band 4 is presently NOT offered for NOEMA Observations')
    call astro_message(seve%w,rname,'----------------------------------------------------------------')
  endif
  if (nosource) then
    call astro_message(seve%i,rname,'No Source in memory, velocity 0 km/s used')
  else
    write(mess,'(a,f0.2,a)') '  Source velocity = ', vsys,' km/s'
    call astro_message(seve%r,rname,mess)
  endif
  write(mess,'(a,f10.5,a)') '  FSKY  = ',fsky/1d3,' GHz'
  call astro_message(seve%r,rname,mess)
  write(mess,'(a,i0,a)')      '  IF1 center frequency           FCENT  = ',nint(fcent),' MHz'
  call astro_message(seve%r,rname,mess)
  write(mess,'(a,f10.5,a)')   '  LO frequency for observations   FLO1  = ',flo1/1d3,' GHz'
  call astro_message(seve%r,rname,mess)
  if (obs_year.ge.2015.and.(.not.fixed)) then
    write(mess,'(a,f10.5,a)') '  LO frequency for tuning    FLO1_TUNE  = ',lotune/1d3,' GHz'
    call astro_message(seve%r,rname,mess)
  endif
  write(mess,*) ' FLO1REF  = ',flo1ref,' MHz'
  call astro_message(seve%r,rname,mess)
  write(mess,'(a,i2)') '  HARM     =    ',harm
  call astro_message(seve%r,rname,mess)
  write(mess,*) ' FSYN     = ',fsynth,' MHz'
  call astro_message(seve%r,rname,mess)
  !
  ! Define plot label
  !
  write(linecomm,1000) trim(name), freq, band,   &
  fcent, harm
  write(label,1010) trim(name), freq,  band, fcent,  &
  harm, '  /RECEIVER',irec,'   [V= ',vsys,' km/s]'
  recband = irec
  !
  ! Now do the plot
  !
  plot_mode = 1
  call pdbi_plot_def(error)
  if (error) return
  call pdbi_plot_line(error)
  if (obs_year.ge.2015.and.(.not.fixed)) then
    call pdbi_plot_grid(oldfcent,fcent,error)
  endif
  !
  ! Info re. Quarters definition
  !
  call astro_message(seve%i,rname,'Bandwidth quarters definition:')
  call astro_message(seve%r,rname,' Q1 from 4.2 GHz to 5.2 GHz')
  call astro_message(seve%r,rname,' Q2 from 5.0 GHz to 6.0 GHz')
  call astro_message(seve%r,rname,' Q3 from 6.0 GHz to 7.0 GHz')
  call astro_message(seve%r,rname,' Q4 from 6.8 GHz to 7.8 GHz')
  call astro_message(seve%i,rname,'Polarizations possibilities:')
  call astro_message(seve%r,rname,  &
    ' Correlator input 1: Q1 HOR, Q2 HOR, Q3 VER, Q4 VER')
  call astro_message(seve%r,rname,  &
    ' Correlator input 2: Q1 VER, Q2 VER, Q3 HOR, Q4 HOR')
  !
  ! End
  !
  return
  !
  ! Errors
  !
  930  call astro_message(seve%e,rname,'Error decoding '//par(1:lpar))
  99   error = .true.
  return
  !
  ! Format
  !
  1000 format('LINE ',a,1x,f10.5,1x,a,1x,f7.0,1x,i3)
  1010 format('LINE ',a,1x,f10.5,1x,a,1x,f7.0,1x,i3,a,i2,a,f6.1,a)
  !
end subroutine pdbi_line_sub
!
subroutine line_check_grid(line,iarg,flo1,fcent,sky,ftune,ongrid,fcentgrid,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>line_check_grid
  !---------------------------------------------------------------------
  ! @private
  ! Check that the proposed tuning corresponds to an LO frequency
  ! on the grid provided by the FrontEnd
  ! If not, a new IF frequency is suggested
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! command line
  integer(kind=4), intent(in) :: iarg   ! position of fcent in the command line
  real(kind=8), intent(in) :: flo1      !lo1 frequency to check
  real(kind=8), intent(in) :: fcent     !IF center frequency
  integer(kind=4), intent(in) :: sky    !+1 USB, -1 LSB
  real(kind=8), intent(in) :: ftune     !corresponding sky frequency
  logical, intent(in) :: ongrid         ! option /ONGRID present or not
  real(kind=8), intent(out) :: fcentgrid ! proposed IF freq to move the tuning to the grid
  logical, intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='PDBI_LINE'
  real(kind=8) :: fgrid,gridbin,gridtol
  character(len=message_length) :: mess
  integer(kind=4) :: lastarg
  character(len=commandline_length) :: rline
  integer(kind=4), parameter :: optongrid=10 !option ongrid
  data gridbin/500/      ! bins in the LO tuning grid (500MHz - Nov 2015)
  data gridtol/1/        !tolerance on the LO grid : 1MHz
  !
  fgrid = nint(flo1/gridbin)*gridbin
  if (abs(fgrid-flo1).lt.gridtol) return
  fcentgrid = (ftune-fgrid)/sky
  !avoid well known if parasites and 6000MHz (limit of the 2 widex)
  if (abs(fcentgrid-4500).lt.50.or.abs(fcentgrid-6000).lt.50.or.abs(fcentgrid-6300).lt.50) then
    fcentgrid = fcentgrid+500
  endif
  !
  if (.not.ongrid) then
    write(mess,'(a,f0.3,a)') '  Tuning frequency out of the grid:       ',flo1,' MHz'
    call astro_message(seve%e,rname,mess)
    write(mess,'(a,f0.3,a)') '  Closest grid point (with optimized Trec)',fgrid,' MHz'
    call astro_message(seve%i,rname,mess)
    write(mess,'(a,i0,a)')   '  Recommended IF frequency                ',nint(fcentgrid),' MHz'
    call astro_message(seve%i,rname,mess)
    write(mess,'(a,f0.3,a)') '  Corresponding shift wrt original setup  ',fcentgrid-fcent,' MHz'
    call astro_message(seve%i,rname,mess)
  endif
  if (.not.ongrid) then
    ! Build the recommended command line
    if (iarg.le.0) then
      ! Fcent was not present, put it right after the last argument of command
      lastarg = sic_narg(0)
      write(rline,'(A,1X,I0,A)')  line(1:sic_end(0,lastarg)),  &
                                  nint(fcentgrid),  &
                                  trim(line(sic_end(0,lastarg)+1:))
    else
      ! Replace Fcent in place
      write(rline,'(A,I0,A)')  line(1:sic_start(0,iarg)-1),  &
                              nint(fcentgrid),  &
                              trim(line(sic_end(0,iarg)+1:))
    endif
    call astro_message(seve%i,rname,"  You may try the following command line:")
    call astro_message(seve%r,rname,rline)
    call astro_message(seve%i,rname,'With the option /ONGRID, the LINE command will shift the tuning automatically')
    call astro_message(seve%i,rname,'With the option /FIXED_FREQ, the tuning will be forced out of the grid')
  else
    !prepare the effective command line
    if (iarg.le.0) then
      ! Fcent was not present, put it right after the last argument of command
      lastarg = sic_narg(0)
      write(rline,'(A,1X,I0,A,A)')  line(1:sic_end(0,lastarg)),  &
                                  nint(fcentgrid),  &
                                  line(sic_end(0,lastarg)+1:sic_start(optongrid,0)-1), &
                                  trim(line(sic_end(optongrid,0)+1:))
    else
      ! Replace Fcent in place
      write(rline,'(A,I0,A,A)')  line(1:sic_start(0,iarg)-1),  &
                              nint(fcentgrid),  &
                              line(sic_end(0,iarg)+1:sic_start(optongrid,0)-1), &
                              trim(line(sic_end(optongrid,0)+1:))
    endif
!    print *,trim(rline)
    write(mess,'(a)') '  IF Frequency automatically shifted to match tuning grid'
    call astro_message(seve%i,rname,mess)
    write(mess,'(a,i0,a)') '  New IF center Frequency = ',nint(fcentgrid),' MHz'
    call astro_message(seve%i,rname,mess)
    write(mess,'(a,f0.3,a)') '  Corresponding shift wrt original setup  ',fcentgrid-fcent,' MHz'
    call astro_message(seve%i,rname,mess)
    call astro_message(seve%i,rname,"  Illustrated by the black, dashed arrow")
    call astro_message(seve%i,rname,"  Equivalent command line:")
    call astro_message(seve%r,rname,rline)
  endif
  error = .true.
  !
end subroutine line_check_grid
!
subroutine pdbi_plot_grid(oldfcent,fcent,error)
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot IF frequencies matching the tuning grid (obs_year>=2015) 
  ! and the original Fcent to visualize to change in /ONGRID MODE
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: oldfcent  ! original IF center frequency in the LINE command
  real(kind=8), intent(in) :: fcent     ! actually used IF center frequency in the LINE command (/ONGRID option)
  logical, intent(inout) :: error       !
  integer(kind=4) :: i,nposs
  real(kind=8)  :: fposs
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=132) :: chain,flist
  call gr_exec1('SET BOX_LOCATION 3 29 9 17')
  ! show when fcent was changed (/ONGRID OPTION)
  if (fcent.ne.oldfcent.and.oldfcent.gt.4000.and.oldfcent.lt.8000) then
    call astro_message(seve%i,rname,"Plotting the original IF center frequency (dashed black line)")
    call gr_exec1('PEN /COL 0 /DASH 2')
    write(chain,1010) oldfcent,-0.2
    call gr_exec1(chain)
    write(chain,1020) oldfcent,1.5
    call gr_exec1(chain)
    write(chain,1010) oldfcent,-0.2
    call gr_exec1(chain)
    write(chain,1030) fcent,-.2
    call gr_exec1(chain)
    call gr_exec1('PEN /COL 0 /DASH 1')
  endif
  !
  ! show other possible FCent
  flist = ''
  nposs = 0
  do i = 1,17
    fposs = fcent+(i-9)*500
    call gr_exec1('PEN /COL 6 /DASH 2')
    if (fposs.gt.4250.and.fposs.lt.7750) then
      if (abs(fposs-6300).gt.50.and.abs(fposs-4500).gt.50.and.abs(fposs-6000).gt.50) then
        nposs = nposs+1
        write(chain,1010) fposs,0.0
        call gr_exec1(chain)
        write(chain,1020) fposs,1.0
        call gr_exec1(chain)
        write(flist,'(a,1x,i0)') trim(flist),nint(fposs)
      endif
    endif
    call gr_exec1('PEN /COL 0 /DASH 1')
  enddo
  if (nposs.ge.1) then
    write(flist,'(a,a)') trim(flist),' MHz'
    call astro_message(seve%i,rname,"IF frequencies respecting the tuning grid (dashed pink lines):")
    call astro_message(seve%i,rname,flist)
  endif
  !
  1010 format('DRAW RELOCATE ',f15.3,1x,f15.3,' /USER')
  1020 format('DRAW LINE ',f15.3,1x,f15.3' /USER')
  1030 format('DRAW ARROW ',f15.3,1x,f15.3' /USER')
  1040 format(f10.2,1x,'MHz')
  !
end subroutine pdbi_plot_grid

subroutine class_accumulate(set,line,r,t,error)
  use classcore_interfaces, except_this=>class_accumulate
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command ACCUMULATE
  !   Adds the R and T spectra together
  !   Reset the plotting constants
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  type(observation),   intent(inout) :: r,t    ! The observations to be added
  logical,             intent(inout) :: error  ! Logical error flag
  !
  call accumulate_generic(set,line,r,t,error)
  !
end subroutine class_accumulate
!
subroutine accumulate_generic(set,line,r,t,error)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>accumulate_generic
  use class_averaging
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  !    AVERAGE all scans of current index together with
  !    various weights and options. Update the origin information and
  !    reset the plotting constants
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  type(observation),   intent(inout) :: r,t    ! The observations to be added
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ACCUMULATE'
  integer(kind=4), parameter :: optresample=1
  integer(kind=4), parameter :: optnocheck=2
  integer(kind=4), parameter :: optweight=3
  type(observation) :: sumio
  type(consistency_t) :: cons
  type(average_t) :: aver
  integer(kind=4) :: nc
  !
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No R spectrum in memory')
    error = .true.
    return
  endif
  if (t%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No T spectrum in memory')
    error = .true.
    return
  endif
  !
  call init_obs(sumio)
  !
  ! Prepare the addition
  if (sic_present(optresample,0)) then
    if (sic_present(optresample,1)) then
      ! /RESAMPLE Nchan Xref Xval Xinc Unit
      aver%do%resampling = resample_user
      ! aver%do%alignment = unused
      call resample_parse_command(line,optresample,rname,r%head,aver%do%axis,error)
      if (error)  return
    else
      ! /RESAMPLE
      aver%do%resampling = resample_auto
    endif
  else
    ! No /RESAMPLE option
    aver%do%resampling = resample_no
  endif
  !
  aver%do%rname       = rname
  aver%do%kind        = r%head%gen%kind
  aver%do%alignment   = align_auto
  aver%do%weight      = set%weigh
  if (sic_present(optweight,0)) then
    call sic_ke(line,optweight,1,aver%do%weight,nc,.true.,error)
    if (error)  return
  endif
  aver%do%composition = composite_user
  aver%do%range       = .false.  ! No option /RANGE
  aver%do%modfreq     = .false.
  aver%do%restf       = 0.d0  ! Not used
  aver%do%modvelo     = .false.
  aver%do%voff        = 0.d0  ! Not used
  !
  ! Select what will be checked according to user input
  call consistency_defaults(set,cons)
  call consistency_check_selection(set,line,optnocheck,cons,error)
  if (error) return
  ! Consistency of the spectroscopic axes is enabled by default (but the user
  ! can deactivate it, to his own risk). Note that this check is useful if
  ! /RESAMPLE is present (resampling automatically disabled if useless) or
  ! not (request for enabling resampling in case of inconsistency).
  ! No need for inconsistency messages if /RESAMPLE is enabled: user
  ! already knows the axes can be inconsistent!
  cons%spe%mess = aver%do%resampling.eq.resample_no
  ! Set checking tolerances
  call consistency_tole(r%head,cons)
  ! Give user feedback on what will be done
  call consistency_print(set,r%head,cons)
  !
  ! -------------- Duplicate of SUMLIN_HEADER, for R & T --------------
  ! 1) Parse the input parameters
  call sumlin_init(set,cons,aver,error)
  if (error)  goto 10
  !
  ! 2) Prepare the sum header
  call sumlin_header_init(aver,r%head,sumio,error)
  if (error)  goto 10
  !
  ! 3) Prepare internal variables for the addition
  call sumlin_init_variables(aver,r%head,sumio%head,error)
  if (error)  goto 10
  !
  ! 4) Loop on the observations to store their axis parameters. Include
  !    also some checks.
  call sumlin_header_register(r,sumio,aver,error)
  if (error)  goto 10
  ! Check consistency of T against R
  call observation_consistency_check(set,r%head,t%head,cons)
  if (aver%done%kind_is_spec) then
    if ((cons%gen%check.and.cons%gen%prob) .or.  &
        (cons%sou%check.and.cons%sou%prob) .or.  &
        (cons%pos%check.and.cons%pos%prob) .or.  &
        (cons%off%check.and.cons%off%prob) .or.  &
        (cons%lin%check.and.cons%lin%prob) .or.  &
        (cons%cal%check.and.cons%cal%prob)) then
      error = .true.
    endif
    if (cons%spe%check.and.cons%spe%prob) then
      if (aver%do%resampling.eq.resample_no) then
        call class_message(seve%e,aver%do%rname,'Inconsistent spectroscopic '//  &
          'axes, use option /RESAMPLE to enforce resampling')
        error = .true.
      elseif (aver%do%resampling.eq.resample_auto) then
        aver%done%resample = .true.
      endif
    endif
  else
    if ((cons%gen%check.and.cons%gen%prob) .or.  &
        (cons%sou%check.and.cons%sou%prob) .or.  &
        (cons%pos%check.and.cons%pos%prob) .or.  &
        (cons%off%check.and.cons%off%prob)) then
      error = .true.
    endif
    if (cons%dri%check.and.cons%dri%prob) then
      if (aver%do%resampling.eq.resample_no) then
        call class_message(seve%e,aver%do%rname,'Inconsistent drift '//  &
          'axes, use option /RESAMPLE to enforce resampling')
        error = .true.
      elseif (aver%do%resampling.eq.resample_auto) then
        aver%done%resample = .true.
      endif
    endif
  endif
  if (error) then
    call class_message(seve%e,aver%do%rname,'R and T are inconsistent')
    goto 10
  endif
  call sumlin_header_register(t,sumio,aver,error)
  if (error)  goto 10
  !
  ! 5) Set the sum header and X axis description
  call sumlin_header_xaxis(set,aver,sumio,2_8,error)  ! Possibly modify nchan
  if (error)  goto 10
  ! --------------- End of duplicate of SUMLIN_HEADER ---------------
  !
  ! 6) Prepare the sum data
  call sumlin_data_prepro(aver,sumio,r%assoc,error)
  if (error)  goto 10
  !
  ! if (aver%do%modfreq) ...
  ! if (aver%do%modvelo) ...
  !
  ! 7) Loop on the observations to average them
  call sumlin_wadd_new(set,r,aver,sumio,error)
  if (error)  goto 10
  call sumlin_wadd_new(set,t,aver,sumio,error)
  if (error)  goto 10
  !
  ! Special for EQUAL weight: return sum instead of average
  if (set%weigh.eq.'E')  then
    call class_message(seve%w,rname,'Gives sum of spectra for EQUAL weight')
    sumio%data1 = sumio%data1*sumio%dataw
  endif
  !
  call sumlin_data_postpro_waverage(aver,sumio,error)
  if (error)  continue
  sumio%spectre => sumio%data1
  !
  call abscissa(set,sumio,error)
  if (error)  goto 10
  !
  ! Convert temporary R*4 Associated Arrays into correct format
  call copy_assoc_r4toaa(aver%comm%rname,r%assoc,sumio%assoc,error)
  if (error)  continue
  !
  ! Push the stack and copy SUM to R
  call copy_obs(r,t,error)
  if (error)  goto 10
  call copy_obs(sumio,r,error)
  if (error)  goto 10
  !
  call newdat(set,r,error)
  call newdat_assoc(set,r,error)
  call newdat_user(set,r,error)
  !
10 continue
  !
  ! Free memory
  call free_obs(sumio)
  !
end subroutine accumulate_generic

!
!     Id: pako-load.f90,v 1.2.3 2014-12-01 Hans Ungerechts
!     Id: pako-load.f90,v 1.2.3 2014-02-17 Hans Ungerechts
!     Id: pako-load.f90,v 1.2.3 2014-02-03 Hans Ungerechts
!
!         previous (inconsistent v number)
!         pako-load.f90,v 1.2.4 2013-04-19 Hans Ungerechts
!
Subroutine pako_load
  !
  Use gbl_message
  Use gkernel_interfaces
  Use modulePakoGlobalParameters    !  to get pakoVersion string
  Use modulePakoMessages            !
  !
  !---------------------------------------------------------------------
  ! Define and load languages of the package.
  !---------------------------------------------------------------------
  ! Global
  External :: pako_run
  Logical, External :: pako_error
  !
  ! Local
  ! Define commands of a new language
  !
!!$  from template:
!!$  integer, parameter :: mcom=4
!!$  character(len=12) :: vocab(mcom)
!!$  data vocab /                      &
!!$    ' DUMMY', '/OPT1', '/OPT2',     &  ! A command with 2 options
!!$    ' VOID' /                          ! A standalone command
  !
  Include 'inc/commands/pakoVocab.inc'
  !
  Character*80 messageText, shellCommand
  Integer system
  Integer ier2, ipid, iou
  Character*8   Date
  Character*10  Time
  Character*5   Zone
  Integer       Values(8)
  !
  Logical ERROR
  !
  Character*12 programName
  programName = "pako"                      !! TBD program/language name for messages and scripts
  !
  Call pako_message(seve%t,programName,                                          &
       &    " pako_load.f90 ---> SR: pako_load: ")                               ! trace execution
!!$  Call pako_message(seve%t,programName,                                          &
!!$       &    " SR pako_load, pakoVersion: "//pakoVersion )                        ! trace execution
  !
  !D   Write (6,*) " --> pako_load "
  !
  ! Load the new language:
  Call sic_begin(                                                                &
    'PAKO',                                                                      &  ! Language name
    'GAG_HELP_PAKO',                                                             &  !
    mcom,                                                                        &  ! Number of commands + options in language
    vocab,                                                                       &  ! Array of commands
    pakoVersion,                                                                 &  ! Some version string
    pako_run,                                                                    &  ! The routine which handles incoming commands
    pako_error)                                                                  !  ! The error status routine of the library
  !
!!$  from template:
!!$  call sic_begin(           &
!!$    'PAKO',             &  ! Language name
!!$    'GAG_HELP_PAKO',   &  !
!!$    mcom,                   &  ! Number of commands + options in language
!!$    vocab,                  &  ! Array of commands
!!$    '1.0    27-Oct-2008 ',  &  ! Some version string
!!$    pako_run,          &  ! The routine which handles incoming commands
!!$    pako_error)           ! The error status routine of the library
  !
  !  
  !! Check if pakoLock file exists; if yes: STOP
  if (gag_inquire(".pakoLock",9).eq.0) then
     messageText = "THIS WORKING DIRECTORY APPEARS"                              &
          &             //" TO BE LOCKED BY ANOTHER PAKO:"                       !
     Call pakoMessage(8,4,"pako",messageText)
     shellCommand = "cat .pakoLock"
     ier2 = system(shellCommand)
     messageText = "EXIT THE OTHER PAKO"                                         &
          &               //" OR USE ANOTHER WORKING DIRECTORY"                  !
     Call pakoMessage(8,4,"pako",messageText)
     messageText = 'if you are sure there is no other pako'                      &
          &              //' try: "rm .pakoLock" and again "pako"'               !
     Call pakoMessage(8,4,"pako",messageText)
     Error = .True.
     STOP
  End If
  !
  ! Create lock file
  ipid = gag_getpid()
  Call Date_And_Time(date,time,zone,values)
  iou = 31                                                                       !  !!  TBD: cleanup, use global value
!!$      iou = ioUnit%Lock
  Open (unit=iou,file=".pakoLock")
  Write (iou,'(A,A,I4.4,A,I2.2,A,I2.2,A,I2.2,A,I2.2,A,I2.2,A5,A,I0)')            &
       &            "         PAKO LOCK. ",                                      &
       &                      " DateTime:",                                      &
       &                Values(1), "-", Values(2), "-",Values(3),                &
       &                      "T",                                               &
       &                Values(5), ":", Values(6), ":",Values(7),Zone,           &
       &                      " PID: ",                                          &
       &                      ipid                                               !
  Close (unit=iou)
  shellCommand = "chmod 400 .pakoLock"
  ier2 = system(shellCommand)
  !
End Subroutine pako_load
!<FF>
Subroutine pako_run(line,comm,error)
  !---------------------------------------------------------------------
  ! Support routine for the language PAKO.
  ! This routine is able to call the routines associated to each
  ! command of the language PAKO
  !---------------------------------------------------------------------
  !
  Use modulePakoGlobalVariables
  Use modulePakoDisplayText
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  Use modulePakoCatalog
  Use modulePakoSource
  Use modulePakoCalibrate
  Use modulePakoDIYlist
  Use modulePakoFocus
  Use modulePakoOnOff
  Use modulePakoLissajous
  Use modulePakoOtfMap
  Use modulePakoPointing
  Use modulePakoTip
  Use modulePakoTrack
  Use modulePakoVlbi
  Use modulePakoDisplay
  Use modulePakoStart
  Use modulePakoStop
  Use modulePakoSave
  !
!!   from run*.f < 2011:
!!$ !!$OLD      Use modulePakoMessages
!!$ !!$OLD      Use modulePakoGlobalParameters
!!$ !!$OLD      Use modulePakoGlobalVariables
!!$ !!$OLD      Use modulePakoDisplayText
!!$ !!$OLD      Use modulePakoReceiver
!!$ !!$OLD      Use modulePakoBackend
!!$ !!$OLD      Use modulePakoSwBeam
!!$ !!$OLD      Use modulePakoSwFrequency
!!$ !!$OLD      Use modulePakoSwWobbler
!!$ !!$OLD      Use modulePakoSwTotalPower
!!$ !!$OLD      Use modulePakoCatalog
!!$ !!$OLD      Use modulePakoSource
!!$ !!$OLD      Use modulePakoCalibrate
!!$ !!$OLD      Use modulePakoDIYlist
!!$ !!$OLD      Use modulePakoFocus
!!$ !!$OLD      Use modulePakoOnOff
!!$ !!$OLD      Use modulePakoOtfMap
!!$ !!$OLD      Use modulePakoPointing
!!$ !!$OLD      Use modulePakoTip
!!$ !!$OLD      Use modulePakoTrack
!!$ !!$OLD      Use modulePakoVlbi
!!$ !!$OLD      Use modulePakoDisplay
!!$ !!$OLD      Use modulePakoStart
!!$ !!$OLD      Use modulePakoStop
!!$ !!$OLD      Use modulePakoSave
  !
  Use gbl_message
  !
  Character(len=*),  Intent(in)    :: line   ! Command line to send to support routines
  Character(len=12), Intent(in)    :: comm   ! Command resolved by the SIC interpreter
  Logical,           Intent(inout) :: error  ! Logical error flag
  !
  Integer iUnit, ioerr
  !
  Character*128 messageText
  !
  Character*12  programName
  programName = "pako"                      !! TBD program/language name for messages and scripts
  !
!!$  Call pako_message(seve%c,'PAKO',line)
  !
  Call pako_message(seve%t,programName,                                          &
       &    " pako-load.f90, ---> SR: pako_run: ")                               ! trace execution
  Call pako_message(seve%t,programName,                                          &
       &    " SR pako-run, line: "//line )                                       ! trace execution
  !
  Include 'inc/display/displayCommandLine.inc'
  !
  ! Call appropriate subroutine according to COMM
  !
  Select Case(comm)
     !
!!$  from template:
!!$  Case('DUMMY')
!!$    Call pako_dummy(line,error)
!!$  Case('VOID')
!!$    Call pako_void(line,error)
     !
  Case ('BACKEND')        
     Call backend             (programName,LINE,COMM,ERROR)
  Case ('CALIBRATE')  
     Call CALIBRATE           (programName,LINE,COMM, ERROR)
  Case('CATALOG')  
     Call CATALOG             (LINE,ERROR)   !! TBD 1.2 review parameters
  Case ('DISPLAY')  
     Call pakoDisplay         (programName,LINE,COMM, ERROR)
  Case ('DIYLIST')  
     Call DIYlist             (programName,LINE,COMM, ERROR)
  Case('FOCUS')  
     Call FOCUS               (programName,LINE,COMM, ERROR)
  Case('OFFSETS') 
     Call OFFSETS             (programName,LINE,COMM,ERROR)
  Case('ONOFF')  
     Call ONOFF               (programName,LINE,COMM,ERROR)
!!$!! TBD future     Case('OTFCIRCLE')  
!!$!! TBD future        Call  OTFCIRCLE(LINE,COMM, ERROR)
!!$!! TBD future     Case('OTFLINEAR')  
!!$!! TBD future         Call OTFLINEAR(LINE,COMM, ERROR)
  Case('LISSAJOUS')     
     Call LISSAJOUS           (programName,LINE,COMM, ERROR)
  Case('OTFMAP')     
     Call OTFMAP              (programName,LINE,COMM, ERROR)
  Case('POINTING') 
     Call POINTING            (programName,LINE,COMM, ERROR)
  Case('RECEIVER')  
     Call receiver            (programName,LINE,COMM,ERROR)
  Case('SAVE') 
     Call pakoSave            (programName,LINE,COMM, ERROR)
!! TBD future  Case('SEGMENT') 
!! TBD future     Call segment(programName,LINE,COMM, ERROR)
  Case('SET') 
     Call pakoSet             (programName,LINE,COMM,ERROR)
  Case('SHOW')
!!$     Call pako_message(seve%t,'PAKO_RUN',' CASE '//comm)
     Call pakoShow            (programName,LINE,COMM,ERROR)
  Case('SOURCE')  
     Call source              (programName,LINE,COMM,ERROR)
  Case('START') 
     Call pakoStart           (programName,LINE,COMM, ERROR)
  Case('STOP') 
     Call pakoStop            (programName,LINE,COMM, ERROR)
  Case('SUBSCAN') 
     Call Subscan             (programName,LINE,COMM, ERROR)
  Case('SWBEAM') 
     Call swBeam              (programName,LINE,COMM,ERROR)
  Case('SWFREQUENCY') 
     Call swFrequency         (programName,LINE,COMM,ERROR)
  Case('SWTOTAL') 
     Call swTotalPower        (programName,LINE,COMM,ERROR)
  Case('SWWOBBLER') 
     Call swWobbler           (programName,LINE,COMM,ERROR)
  Case('TIP') 
     Call TIP                 (programName,LINE,COMM, ERROR)
  Case('TRACK') 
     Call TRACK               (programName,LINE,COMM, ERROR)
  Case('VLBI') 
     Call VLBI                (programName,LINE,COMM, ERROR)
     !
  Case default
    Call pako_message(seve%e,'PAKO_RUN','Unimplemented command '//comm)
    error = .True.
  End Select
  !
End Subroutine pako_run
!<FF>
Function pako_error()
  !---------------------------------------------------------------------
  ! Support routine for the error status of the library. Does nothing
  ! here.
  !---------------------------------------------------------------------
  Logical :: pako_error
  !
  pako_error = .False.
  !
End Function pako_error

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the GTEMPLATE package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gtemplate_package
  use gtemplate_messaging
  use gtemplate_language
  !
  public :: gtemplate_pack_init,gtemplate_pack_clean
  private
  !
contains
  !
  subroutine gtemplate_pack_init(gpack_id,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    integer(kind=4), intent(in)    :: gpack_id
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    !
    call gtemplate_message_set_id(gpack_id)
    !
    ! Specific variables
    ier = sic_setlog('gag_help_gtemplate','gag_doc:hlp/gtemplate-help-template.hlp')
    if (ier.eq.0) then
      error=.true.
      return
    endif
    !
    ! Load local language
    call gtemplate_load
    !
    ! Specific initializations
  end subroutine gtemplate_pack_init
  !
  subroutine gtemplate_pack_clean(error)
    !----------------------------------------------------------------------
    ! Called at end of session. Might clean here for example global buffers
    ! allocated during the session
    !----------------------------------------------------------------------
    logical :: error
    !
    print *,"Called gtemplate_pack_clean"
  end subroutine gtemplate_pack_clean
end module gtemplate_package
!
subroutine gtemplate_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  use gtemplate_package
  !
  type(gpack_info_t), intent(out) :: pack
  !
  pack%name='template'
  pack%ext='.gtemplate'
  pack%depend(1:1) = (/ locwrd(sic_pack_set) /) ! List here dependencies
  pack%init=locwrd(gtemplate_pack_init)
  pack%clean=locwrd(gtemplate_pack_clean)
end subroutine gtemplate_pack_set
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine relocate(x,y)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !   Position pen at user coordinate (X,Y)
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: x  ! User X coordinate
  real(kind=8), intent(in) :: y  ! User Y coordinate
  !
  if (axis_xlog) then
    if (x.gt.0) then
      xp = gx1 + gux * (log(x)-lux)
    elseif (gux.gt.0) then
      xp = gx1
    else
      xp = gx2
    endif
  else
    xp = gx1 + gux * (x-gux1)
  endif
  if (axis_ylog) then
    if (y.gt.0) then
      yp = gy1 + guy * (log(y)-luy)
    elseif (guy.gt.0) then
      yp = gy1
    else
      yp = gy2
    endif
  else
    yp = gy1 + guy * (y-guy1)
  endif
end subroutine relocate
!
subroutine grelocate(ax,ay)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !   Position pen at Plot coordinate (X,Y)
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: ax  ! Plot X coordinate
  real(kind=4), intent(in) :: ay  ! Plot Y coordinate
  xp = ax
  yp = ay
end subroutine grelocate
!
subroutine draw(ux,uy)
  use greg_interfaces
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface (name is too generic)
  !   Draw a vector from current pen position to given point. The
  ! current line type is used.
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: ux  ! User X coordinate (DRAW)
  real(kind=8), intent(in) :: uy  ! User Y coordinate
  real(kind=4), intent(in) :: ax  ! Plot X coordinate (GDRAW)
  real(kind=4), intent(in) :: ay  ! Plot Y coordinate
  ! Local
  real(kind=4) :: xq,yq
  integer(kind=4) :: c0,c1,c
  real(kind=4) :: x,y, x0,y0, x1,y1
  !
  ! User coordinates
  if (axis_xlog) then
    if (ux.gt.0) then
      xq = gx1 + gux * (log(ux)-lux)
    elseif (gux.gt.0) then
      xq = gx1
    else
      xq = gx2
    endif
  else
    xq = gx1 + gux * (ux-gux1)
  endif
  if (axis_ylog) then
    if (uy.gt.0) then
      yq = gy1 + guy * (log(uy)-luy)
    elseif (guy.gt.0) then
      yq = gy1
    else
      yq = gy2
    endif
  else
    yq = gy1 + guy * (uy-guy1)
  endif
  goto 1
  !
entry gdraw(ax,ay)
  !---------------------------------------------------------------------
  ! @ public
  ! Page coordinates
  !---------------------------------------------------------------------
  xq = ax
  yq = ay
  !
  ! End-points of line are (X0,Y0), (X1,Y1)
  !
1 x0 = xp
  y0 = yp
  x1 = xq
  y1 = yq
  xp = xq
  yp = yq
  !
  ! Clip the line
  if (noclip) goto 100
  !
  ! Change the end-points of the line (X0,Y0) - (X1,Y1)
  ! to clip the line at the window boundary.
  ! The algorithm is that of Cohen and Sutherland (ref: Newman & Sproull)
  !
  call grclip(x0,y0,c0)
  call grclip(x1,y1,c1)
  !
  do while (c0.ne.0 .or. c1.ne.0)
    if (iand(c0,c1).ne.0) then ! line is invisible
      return
    endif
    c = c0
    if (c.eq.0) c = c1
    if (iand(c,1).ne.0) then   ! crosses GX1
      y = y0 + (y1-y0)*(gx1-x0)/(x1-x0)
      x = gx1
    elseif (iand(c,2).ne.0) then   ! crosses GX2
      y = y0 + (y1-y0)*(gx2-x0)/(x1-x0)
      x = gx2
    elseif (iand(c,4).ne.0) then   ! crosses GY1
      x = x0 + (x1-x0)*(gy1-y0)/(y1-y0)
      y = gy1
    elseif (iand(c,8).ne.0) then   ! crosses GY2
      x = x0 + (x1-x0)*(gy2-y0)/(y1-y0)
      y = gy2
    endif
    if (c.eq.c0) then
      x0 = x
      y0 = y
      call grclip(x,y,c0)
    else
      x1 = x
      y1 = y
      call grclip(x,y,c1)
    endif
  enddo
  !
100 continue
  call grline(x0,y0,x1,y1)
end subroutine draw
!
subroutine grline(cxa,cya,cxb,cyb)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>grline
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !   Plot a line from CXA,CYA to CXB,CYB with current pen attributes.
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: cxa  ! Plot X coordinate of start point
  real(kind=4), intent(in) :: cya  ! Plot Y coordinate of start point
  real(kind=4), intent(in) :: cxb  ! Plot X coordinate of end point
  real(kind=4), intent(in) :: cyb  ! Plot Y coordinate of end point
  !
  if (cxa.ne.gxp .or. cya.ne.gyp) then
    !!print *,'GTRELOC at ',cxa,cya
    call gtreloc(cxa,cya)
  endif
  !!print *,'GRLINE relo at ',gxp,gyp
  call gtdraw(cxb,cyb)
  !!print *,'GRLINE draw at ',cxb,cyb
  gxp = cxb  ! Set the pen location after the 'gtdraw'
  gyp = cyb  !
end subroutine grline
!
subroutine grpoly(nq,xq,yq)
  use gildas_def
  use greg_interfaces, except_this=>grpoly
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Plots a poly-line in paper coordinate, with clipping in the BOX
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nq     ! Number of points
  real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
  real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
  ! Local
  integer(kind=size_length) :: k
  integer(kind=4) :: c0,c1,c,cold
  real(kind=4) :: x,y, x0,y0, x1,y1
  logical :: up
  !
  ! NQ is less than 2.
  if (nq.lt.2) then
    if (nq.lt.1) return
    xp = xq(1)
    yp = yq(1)
    return
  endif
  !
  ! Update XP and YP
  xp = xq(nq)
  yp = yq(nq)
  !
  ! End-points of line are (X0,Y0), (X1,Y1)
  x0 = xq(1)
  y0 = yq(1)
  call grclip(x0,y0,c0)
  up = .true.
  !
  ! Loop on points
  ! Change the end-points of the line (X0,Y0) - (X1,Y1)
  ! to clip the line at the window boundary.
  ! The algorithm is that of Cohen and Sutherland (ref: Newman & Sproull)
  !
  do k=2,nq
    x1 = xq(k)
    y1 = yq(k)
    call grclip(x1,y1,c1)
    cold = c1
    !
    do while (ior(c0,c1).ne.0)
      if (iand(c0,c1).ne.0) goto 100   ! line is invisible
      if (c0.eq.0) then
        c = c1
      else
        c = c0
      endif
      if (iand(c,1).ne.0) then ! crosses GX1
        if (abs(x0).gt.huge(x0)) then  ! x0 is +-Inf
          y = y1
        else
          y = y0 + (y1-y0)*(gx1-x0)/(x1-x0)
        endif
        x = gx1
      elseif (iand(c,2).ne.0) then ! crosses GX2
        if (abs(x0).gt.huge(x0)) then  ! x0 is +-Inf
          y = y1
        else
          y = y0 + (y1-y0)*(gx2-x0)/(x1-x0)
        endif
        x = gx2
      elseif (iand(c,4).ne.0) then ! crosses GY1
        if (abs(y0).gt.huge(y0)) then  ! y0 is +-Inf
          x = x1
        else
          x = x0 + (x1-x0)*(gy1-y0)/(y1-y0)
        endif
        y = gy1
      elseif (iand(c,8).ne.0) then ! crosses GY2
        if (abs(y0).gt.huge(y0)) then  ! y0 is +-Inf
          x = x1
        else
          x = x0 + (x1-x0)*(gy2-y0)/(y1-y0)
        endif
        y = gy2
      endif
      if (c.eq.c0) then
        x0 = x
        y0 = y
        call grclip(x,y,c0)
      else
        x1 = x
        y1 = y
        call grclip(x,y,c1)
      endif
    enddo
    !
    ! Plot the line : Pen up to X0,Y0 then pen down to X1,Y1
    ! Nor yet optimised
    if (up) then
      call grline(x0,y0,x1,y1)
    else
      call grline(x0,y0,x1,y1)
    endif
    !
    ! End of loop
100 c0 = cold
    x0 = xq(k)
    y0 = yq(k)
    up = cold.ne.0
  enddo
end subroutine grpoly
!
subroutine grdots(nq,xq,yq)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface (rank mismatch)
  ! GREG Internal routine
  !  Plots a list of dot points in paper coordinate, with clipping in
  ! the BOX. REAL*4 coordinates.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nq     ! Number of points
  real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
  real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
  ! Local
  integer(kind=size_length) :: ip,fp
  integer(kind=4) :: c0,np
  logical :: error
  !
  ! Update XP and YP (pen position)
  xp = xq(nq)
  yp = yq(nq)
  !
  c0 = -1
  np = 0
  fp = 1
  do ip=1,nq
    call grclip(xq(ip),yq(ip),c0)
    if (c0.eq.0) then
      if (np.eq.0)  fp = ip  ! First point
      np = np+1
    elseif (c0.ne.0) then
      ! Point is clipped out
      if (np.ne.0) then
        error = .false.
        call gtv_points(np,xq(fp),yq(fp),error)
        if (error)  return
        np = 0
      endif
    endif
  enddo
  !
  if (c0.eq.0) then
    ! Last (serie of) point(s)
    if (np.ne.0) then
      error = .false.
      call gtv_points(np,xq(fp),yq(fp),error)
      if (error)  return
    endif
  endif
  !
end subroutine grdots
!
subroutine grclip (x,y,c)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !   Support routine for the clipping algorithm ; called from DRAW
  ! and GRPOLY only.  C is a 4 bit code indicating the relationship
  ! between point (X,Y) and the window boundaries ; 0 implies the
  ! point is within the window.
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: x  ! Plot X coordinate
  real(kind=4),    intent(in)  :: y  ! Plot Y coordinate
  integer(kind=4), intent(out) :: c  ! Code for clipping
  !
  c = 0
  if (x.lt.gx1) then
    c = 1
  elseif (x.gt.gx2) then
    c = 2
  endif
  if (y.lt.gy1) then
    c = c+4
  elseif (y.gt.gy2) then
    c = c+8
  endif
end subroutine grclip
!
subroutine cross(xp,yp,xq,yq,x1,x2,y1,y2,xc,yc,xd,yd,ok)
  !---------------------------------------------------------------------
  ! @ private
  ! Clipping subroutine. Not used, kept for reference.
  !
  ! Return segment XC,YC,XD,YD where the segment XP,YP,XQ,YQ crosses the
  ! box X1,Y1,X2,Y2. Set OK to FALSE if never in the box.
  ! It is assumed that X1 < X2 and Y1 < Y2.
  !---------------------------------------------------------------------
  real(kind=4), intent(in)  :: xp,yp  ! Line to be clipped (start point)
  real(kind=4), intent(in)  :: xq,yq  ! Line to be clipped (end point)
  real(kind=4), intent(in)  :: x1,y1  ! Box BLC
  real(kind=4), intent(in)  :: x2,y2  ! Box TRC
  real(kind=4), intent(out) :: xc,yc  ! Clipped line (start point)
  real(kind=4), intent(out) :: xd,yd  ! Clipped line (end point)
  logical,      intent(out) :: ok     ! Is the clipped line visible?
  ! Local
  real(kind=4) :: x,y
  !
  xc = xp
  yc = yp
  xd = xq
  yd = yq
  !
  ! Cross left boundary?
  if ((xc-x1)*(xd-x1).lt.0) then
    y = yc + (yd-yc)*(x1-xc)/(xd-xc)
    if (xc-x1.gt.0) then
      xd = x1
      yd = y
    else
      xc = x1
      yc = y
    endif
  endif
  !
  ! Cross right boundary?
  if ((xc-x2)*(xd-x2).lt.0) then
    y = yc + (yd-yc)*(x2-xc)/(xd-xc)
    if (x2-xc.gt.0) then
      xd = x2
      yd = y
    else
      xc = x2
      yc = y
    endif
  endif
  !
  ! Cross bottom boundary?
  if ((yc-y1)*(yd-y1).lt.0) then
    x = xc + (xd-xc)*(y1-yc)/(yd-yc)
    if (yc-y1.gt.0) then
      yd = y1
      xd = x
    else
      yc = y1
      xc = x
    endif
  endif
  !
  ! Cross top boundary?
  if ((yc-y2)*(yd-y2).lt.0) then
    x = xc + (xd-xc)*(y2-yc)/(yd-yc)
    if (y2-yc.gt.0) then
      yd = y2
      xd = x
    else
      yc = y2
      xc = x
    endif
  endif
  !
  ok = xc.ge.x1 .and. xc.le.x2 .and.  &
       yc.ge.y1 .and. yc.le.y2 .and.  &
       xd.ge.x1 .and. xd.le.x2 .and.  &
       yd.ge.y1 .and. yd.le.y2
  !
end subroutine cross

subroutine clic_copy(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_file
  use clic_index
  use clic_virtual
  !---------------------------------------------------------------------
  ! Command COPY = MODIFY NOTHING
  !     well not so simple
  ! COPY DATA|HEADERS [ANT | NOANT] [BASE | NOBASE]
  ! 1:
  !     DATA     data and headers are copied
  !     HEADERS  headers only
  ! 2 and/or 3:
  !     ANT      Antenna calibration section created
  !     BASE     Baseline calibration section created
  !     NOANT    Antenna calibration sections  NOT created
  !     NOBASE   Baseline calibration sections NOT created
  ! otherwise sections are copied if and only if present.
  ! default is "ANT"
  ! Bure copy Job does "NOANT NOBASE"
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: end, check, extract
  integer(kind=address_length) :: data_in, ip_data, kh, data_out
  integer(kind=data_length) :: ndata,ndata_out, h_offset
  integer :: narg, ii, esb
  character(len=80) :: chain
  character(len=7) :: done
  character(len=12) :: argum, argum2
  logical :: do_write_saved, acopy, bcopy, askip, bskip,do_list,norf
  integer :: mvoc1, mvoc2,mvoc3
  parameter (mvoc1=5, mvoc2=6,mvoc3=2)
  character(len=12) :: voc1(mvoc1), voc2(mvoc2),voc3(mvoc3)
  data voc1/'HEADERS','NOHEADERS','DATA','NODATA','LIST'/
  data voc2/'ANTENNA','NOANTENNA','BASELINE','NOBASELINE','NOCHECK',&
            'NORF'/
  data voc3/'USB','LSB'/
  !------------------------------------------------------------------------
  ! Code:
  do_write_saved = do_write_data
  extract = .false.
  do_list = .false.
  if (sic_present(1,0)) then
    call clic_kw(line,1,1,argum,narg,voc3,mvoc3,.true.,error,.true.)
    if (error) return
    extract = .true.
    esb = narg
  endif 
  argum = 'HEADERS'
  call clic_kw(line,0,1,argum,narg,voc1,mvoc1,.true.,error,.true.)
  if (error) return
  if (argum.eq.'HEADERS' .or. argum.eq.'NODATA') then
    do_write_data = .false.
    if (extract) then
      call message(6,3,'CLIC_COPY','Option /EXTRACT not compatible with'// &
&       'COPY HEADERS')
      error = .true.
      return
    endif
  elseif (argum.eq.'NOHEADERS' .or. argum.eq.'DATA') then
    do_write_data = .true.
  elseif (argum.eq.'LIST') then
    do_list = .true.
    r_presec(bpcal_sec) = .false.
    r_presec(ical_sec) =  .false.
    r_presec(abpcal_sec) =  .false.
    r_presec(aical_sec) =  .false.
  endif
  ! FULL BASELINE or ANTENNA
  acopy = .true.
  bcopy = .false.
  askip = .false.
  bskip = .false.
  check = .true.
  norf  = .false.
  do ii=2, sic_narg(0)
    argum2 = 'ANTENNA'
    call clic_kw(line,0,ii,argum2,narg,voc2,mvoc2,.false.,error,.true.)
    if (error) return
    if (argum2.eq.'ANTENNA') then
      acopy = .true.
      askip = .false.
    elseif (argum2.eq.'NOANTENNA') then
      askip = .true.
      acopy = .false.
    elseif (argum2.eq.'BASELINE') then
      bcopy = .true.
      bskip = .false.
    elseif (argum2.eq.'NOBASELINE') then
      bskip = .true.
      bcopy = .false.
    elseif (argum2.eq.'NOCHECK') then
      check = .false.
    elseif (argum2.eq.'NORF') then
      norf = .true.
    endif
  enddo
  !
  call check_input_file(error)
  if (error) goto 99
  call check_index(error)
  if (error) goto 99
  call check_output_file(error)
  if (error) goto 99
  call check_different_file(error)
  if (error) goto 99
  call show_general('COPY',.false.,line,error)
  if (error) goto 99
  !
  ! Loop on current index
call get_first(.true.,error)
  if (error) goto 99
  end = .false.
  got_data = .false.
  do while (.not.end)
    ! Get storage and data
    if (.not.do_list) then 
      call get_data (ndata,data_in,error)
      if (error) goto 99
      ip_data = gag_pointer(data_in,memory)
      ! Write
      kh = ip_data + h_offset(r_ndump + 1)
      call decode_header (memory(kh))
      ! this is the only reason to acess tha data itself.
      ! Only needed for data older than 11 feb 1997.
      ! Sould be tested.
      ! For time consistency
      r_ut = dh_utc*2*pi/86400.
      r_dobs = dh_obs
      !
      ! Reserve space for ANTENNA based sections only by default.
      r_bpcdeg = 40
      r_abpcdeg = 40
      r_icdeg = 3
      r_aicdeg = 3
      if (r_proc.ne.p_pass .and. r_proc.ne.p_skydip   &
        .and. r_proc.ne.p_sky .and. r_proc.ne.p_cal   &
        .and. r_proc.ne.p_onoff .and. r_proc.ne.p_pseudo) then 
        r_presec(bpcal_sec)=((r_presec(bpcal_sec).and..not.bskip)  &
          .or. bcopy)  .and. .not. norf
        r_presec(ical_sec)=(r_presec(ical_sec).and..not.bskip)   &
          .or. bcopy
        r_presec(abpcal_sec)=((r_presec(abpcal_sec).and..not.askip) &
           .or. acopy) .and. .not. norf
        r_presec(aical_sec)=(r_presec(aical_sec).and..not.askip)   &
          .or. acopy
      else
        r_presec(bpcal_sec) = .false.
        r_presec(ical_sec) =  .false.
        r_presec(abpcal_sec) =  .false.
        r_presec(aical_sec) =  .false.
      endif
      if (extract) then
        write(chain,'(a,i0,a,i0,a)') 'Extracting band '//voc3(esb)
        call message(6,1,'COPY',chain(1:lenc(chain)))
        !
        ! Extract desired sideband
        call extract_data(data_in,ndata,data_out,ndata_out,esb,error)
        if (error) return
        !
        ! Point to new data
        ip_data = gag_pointer(data_out,memory)
        data_in = data_out    ! Required if subsequent update
        ndata = ndata_out
        !
        ! Update data address in buffer for further use
        v_data_length(r_xnum) = ndata
        v_data(r_xnum) = data_out      
      endif
      if (e%version.ne.version_current.and.do_write_data) then
        !
        ! New file: update data header to latest version
        write(chain,'(a,i0,a,i0,a)') 'Updating observation version from ', &
            e%version,' to current version (',version_current,')'
        call message(6,1,'COPY',chain(1:lenc(chain)))
        call update_observation(data_in,ndata,data_out,ndata_out,error)
        if (error) return
        !
        ! Point to new data
        ip_data = gag_pointer(data_out,memory)
        ndata = ndata_out
        !
        ! Update data address in buffer for further use
        v_data_length(r_xnum) = ndata
        v_data(r_xnum) = data_out
      endif
    endif
    call ipb_write(write_mode,check,error)
    if (.not.error) then
      if (.not.do_list) call wdata (ndata,memory(ip_data),.true.,error)
      if (error) goto 99
      call ipb_close(error)
      if (error) goto 99
      write(chain,'(a,i6,a,i6,a)') 'Observation ',r_num,   &
        ' '//done(write_mode)//' (',r_ndump,' records)'
      call message(4,1,'CLIC_COPY',chain(1:50))
    endif
if (sic_ctrlc()) then
      error = .true.
      goto 99
    endif
    call get_next(end,error)
    if (error) goto 99
  enddo
99 do_write_data = do_write_saved
  return
end subroutine clic_copy
!
subroutine extract_data(data_in,ndata_in,data_out,ndata_out,esb,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_index
  !
  ! Routine to extract one sideband from the data
  !
  integer(kind=address_length) :: data_in   ! Data in address
  integer(kind=data_length)    :: ndata_in  ! Data length  
  integer(kind=address_length) :: data_out  ! Data out address 
  integer(kind=data_length)    :: ndata_out ! Data length  
  integer(kind=4)              :: esb       ! Sideband to extract 
  logical                      :: error     ! Error flag
  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  !
  ! Local
  integer(kind=data_length) :: h_offset, c_offset, l_offset
  integer :: ir, ibas
  integer :: kin, ipk, kou, opk
  integer :: ldatc, ldatl, ldump
  !
  ! Do nothing on autocorrelation
  if (r_lmode.ne.1) then
    data_out  = data_in 
    ndata_out = ndata_in
    return
  endif
  !   
  ! Return an error if only one SB present
  if (r_lnsb.lt.2) then
    call message(8,3,'EXTRACT','Data have only one sideband')
    error = .true.
    return
  endif
  ! 
  ! Out sizes
  ldatc   = r_ldatc/2        ! Continuum data length
  ldatl   = r_ldatl/2        ! Line data length
  ldump   = ldatc+r_ldpar  ! Continuumm record dump length
  if (r_ndatl.ge.1) then
    ndata_out = (r_ndump+r_ndatl)*ldump+r_ndatl*ldatl 
  else
    ndata_out = (r_ndump+1)*ldump+ldatl
  endif
  !
  ! Get some memory 
  call get_memory(ndata_out,data_out,error)
  if (error) then
    call message(6,3,'EXTRACT','Problems with getting memory')
    return
  endif
  !
  ! First temporal dumps
  kin = gag_pointer(data_in,memory)
  kou = gag_pointer(data_out,memory)
  opk = kou
  do ir = 1, r_ndump
    ipk = kin + h_offset(ir)
    call decode_header(memory(ipk))
    ! Place here modifications to data header
    call encode_header(memory(opk))
    opk = opk + r_ldpar
    !
    ! Extract continuum data
    ipk = kin + c_offset(ir)
    do ibas = 1, r_nbas
      if (esb.eq.2) ipk = ipk + 2*r_nband
      call w4tow4(memory(ipk),memory(opk),2*r_nband)
      ipk = ipk + 2*r_nband
      opk = opk + 2*r_nband
      if (esb.eq.1) ipk = ipk + 2*r_nband
    enddo    
  enddo
  !
  ! Then time averaged dumps
  do ir = r_ndump+1, r_ndump+max(1, r_ndatl)
    ipk = kin + h_offset(ir)
    call decode_header(memory(ipk))
    ! Place here modifications to data header
    call encode_header(memory(opk))
    opk = opk + r_ldpar
    !
    ! Extract continuum data
    ipk = kin + c_offset(ir)
    do ibas = 1, r_nbas
      if (esb.eq.2) ipk = ipk + 2*r_nband
      call w4tow4(memory(ipk),memory(opk),2*r_nband)
      ipk = ipk + 2*r_nband
      opk = opk + 2*r_nband
      if (esb.eq.1) ipk = ipk + 2*r_nband
    enddo 
    !
    ! Extract line data   
    ipk = kin + l_offset(ir)
    do ibas = 1, r_nbas
      if (esb.eq.2) ipk = ipk + 2*r_lntch
      call w4tow4(memory(ipk),memory(opk),2*r_lntch)
      ipk = ipk + 2*r_lntch
      opk = opk + 2*r_lntch
      if (esb.eq.1) ipk = ipk + 2*r_lntch
    enddo
  enddo
  !
  ! Update data descriptor
  r_ldatc = ldatc
  r_ldatl = ldatl
  r_ldump = ldump
  !
  ! Update continuum and line sections
  r_nsb = 1
  r_sband(1,1:r_nsb)  = esb
  r_lnsb = 1
  r_lsband(1,1:r_lnsb) = esb
  return
end subroutine extract_data

subroutine pico_backend(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>pico_backend
  use astro_types
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Set and show the backend coverage for EMIR
  !
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='BACKEND'
  logical       :: dopchanged
  integer(kind=4) :: iback,lpar,iftsm,imode
  integer(kind=4), parameter :: m_backnames = 3
  integer(kind=4), parameter :: m_ftsmodes = 2
  character(len=20)     :: backnames(m_backnames), backname,par
  character(len=20)     :: backmode,ftsmodes(m_ftsmodes),ftsmode
  data backnames/'FTS','WILMA','VESPA'/
  data ftsmodes/'WIDE','NARROW'/
  !
  if (obsname.ne.'PICOVELETA'.and.obsname.ne.'VELETA') then
      call astro_message(seve%e,rname,'Inconsistency between Receiver Name and Observatory')
      error = .true.
      return
  endif
  !
  if (emir%rec%n_tunings.eq.0) then
    call astro_message(seve%e,rname,'Please define a tuning (EMIR command) before setting up backends')
    error = .true.
    return
  endif
  !
  !check that doppler did not changed since last tuning
  call rec_check_doppler(emir%rec%source,emir%rec%desc%redshift,dopchanged,error)
  if (dopchanged) then
    call astro_message(seve%e,rname,'Source properties changed since last tuning')
    call astro_message(seve%i,rname,'You should set again the tuning (EMIR command) before working with backends')
    call rec_display_error('Source changed since last tuning',error)
    error = .true.
    return
  endif
  !
  !backend selection
  call sic_ke(line,0,1,par,lpar,.true.,error)
  if (error) return
  call sic_ambigs(rname,par,backname,iback,backnames,m_backnames,error)
  if (error) return
  !
  if (emir%rec%desc%name.eq.'EMIR') then
    if (.not.emir%switch%defined) then
      call astro_message(seve%e,rname,'Please configure first the switchbox (BASEBAND command)')
      error = .true.
      return
    endif
    call define_emir_backends(rname,emir,error)
    if (error) return
    if (backname.eq.'FTS') then
      call sic_ke(line,0,2,backmode,lpar,.true.,error)
      if (error) return
      call sic_ambigs(rname,backmode,ftsmode,iftsm,ftsmodes,m_ftsmodes,error)
      if (error) return
      emir%be(iback)%imode = iftsm
    else if (backname.eq.'WILMA') then
      emir%be(iback)%imode = 1
    else if (backname.eq.'VESPA') then
      emir%be(iback)%imode = 1
    else
      call astro_message(seve%e,rname,'NOT YET IMPLEMENTED')
      error = .true.
      return
    endif
    imode=emir%be(iback)%imode
    call emir_setup_backend(emir,iback,imode,error)
    if (error) return
    call emir_plot_backend(emir,iback,imode,cplot,molecules,freq_axis,error)
    if (error) return
  else
    call astro_message(seve%e,rname,'NOT YET IMPLEMENTED')
    error = .true.
    return
  endif
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine pico_backend
!
subroutine define_emir_backends(rname,em,error)
  use gbl_message
  use astro_interfaces, except_this=>define_emir_backends
  use ast_line
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! defines IF1 frequency coverage of backends
  !-----------------------------------------------------------------------
  character(len=*), intent(in)  :: rname
  type(emir_t), intent(inout)  :: em
  logical, intent(inout)            :: error
  ! Local
  integer(kind=4)       :: i,j,k
  real(kind=8)          :: fold_offset
  !
  ! Handle the change of frequency implemented in 2021
  if (obs_year.eq.2016) then
    fold_offset=0d0
  else if  (obs_year.eq.2021) then
    fold_offset=320d0
  else
    call astro_message(seve%e,rname,'PICO generation not understood')
    error = .true.
    return
  endif
  !
  ! Backend definition 1: FTS
  em%be(1)%name = 'FTS'
  em%be(1)%n_backmodes = 2
  !Mode 1 = 200
  em%be(1)%mode(1)%backname = 'FTS'
  em%be(1)%mode(1)%modename = 'WIDE'
  em%be(1)%mode(1)%n_backunits = 8 ! [backend unit process 1 baseband]
  em%be(1)%mode(1)%m_chunks = 24
  em%be(1)%mode(1)%iflim(1,1) = 7680d0+fold_offset    !outer
  em%be(1)%mode(1)%iflim(2,1) = 11730d0+fold_offset
  em%be(1)%mode(1)%iflim(1,2) = 3950d0    !inner
  em%be(1)%mode(1)%iflim(2,2) = 8000d0
  !Mode 2 = 50
  em%be(1)%mode(2)%backname = 'FTS'
  em%be(1)%mode(2)%modename = 'NARROW'
  em%be(1)%mode(2)%n_backunits = 8 ! [backend unit process 1 baseband]
  em%be(1)%mode(2)%m_chunks = 24
  em%be(1)%mode(2)%iflim(1,1) = 8570d0+fold_offset    !outer
  em%be(1)%mode(2)%iflim(2,1) = 10390d0+fold_offset
  em%be(1)%mode(2)%iflim(1,2) = 5290d0    !inner
  em%be(1)%mode(2)%iflim(2,2) = 7110d0
  !
  em%be(2)%name = 'WILMA'
  em%be(2)%n_backmodes = 1
  !Mode 1
  em%be(2)%mode(1)%backname = 'WILMA'
  em%be(2)%mode(1)%modename = '2MHz'
  em%be(2)%mode(1)%n_backunits = 4 ! [backend unit process 1 baseband, 4 at most]
  em%be(2)%mode(1)%m_chunks = 16
  em%be(2)%mode(1)%iflim(1,1) = 7835d0+fold_offset    !outer
  em%be(2)%mode(1)%iflim(2,1) = 11555d0+fold_offset
  em%be(2)%mode(1)%iflim(1,2) = 4125d0    !inner
  em%be(2)%mode(1)%iflim(2,2) = 7845d0
  !
  em%be(3)%name = 'VESPA'
  em%be(3)%n_backmodes = 1
  em%be(3)%mode(1)%backname = 'VESPA'
  em%be(3)%mode(1)%modename = ''
  em%be(3)%mode(1)%n_backunits = 4 ! []
  em%be(3)%mode(1)%m_chunks = em%be(2)%mode(1)%n_backunits
  em%be(3)%mode(1)%iflim(1,1) = 9430d0-250d0+fold_offset   !outer
  em%be(3)%mode(1)%iflim(2,1) = 9430d0+250d0+fold_offset
  em%be(3)%mode(1)%iflim(1,2) = 6250d0-250d0    !inner
  em%be(3)%mode(1)%iflim(2,2) = 6250d0+250d0
  !
  do k=1,em%rec%desc%n_backends
    do i=1,em%be(k)%n_backmodes
      do j =1,em%be(k)%mode(i)%n_backunits
        em%be(k)%mode(i)%unit(j)%n_chunks = em%be(k)%mode(i)%m_chunks/em%be(k)%mode(i)%n_backunits
      enddo
    enddo
  enddo
  !
end subroutine define_emir_backends
!
subroutine emir_setup_backend(emir,iback,imode,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>emir_setup_backend
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! Set backend coverage from if cables content
  !
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout) :: emir
  integer(kind=4), intent(in) :: iback
  integer(kind=4), intent(in) :: imode
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='BACKEND'
  integer(kind=4)       :: icable
  integer(kind=4), parameter       :: m_cable_wilma = 4
  !
  if (emir%rec%n_tunings.eq.0) then
    call astro_message(seve%e,rname,'Please define a tuning (EMIR command) before setting up backends')
    error = .true.
    return
  endif
  !
  if (.not.emir%switch%defined) then
    call astro_message(seve%e,rname,'Please configure first the switchbox (BASEBAND command)')
    error = .true.
    return
  endif
  !
  icable = 1
  do while (icable.le.emir%be(iback)%mode(imode)%n_backunits) ! correlator units
    emir%be(iback)%mode(imode)%unit(icable)%sb_code = emir%switch%ifc(icable)%sb_code
    emir%be(iback)%mode(imode)%unit(icable)%pol_code = emir%switch%ifc(icable)%pol_code
    emir%be(iback)%mode(imode)%unit(icable)%bb_code = emir%switch%ifc(icable)%bb_code
    emir%be(iback)%mode(imode)%unit(icable)%iband = emir%switch%ifc(icable)%iband
    emir%be(iback)%mode(imode)%unit(icable)%ifmin = &
        emir%be(iback)%mode(imode)%iflim(1,emir%be(iback)%mode(imode)%unit(icable)%bb_code)
    emir%be(iback)%mode(imode)%unit(icable)%ifmax = &
        emir%be(iback)%mode(imode)%iflim(2,emir%be(iback)%mode(imode)%unit(icable)%bb_code)
    emir%be(iback)%mode(imode)%unit(icable)%width = &
        emir%be(iback)%mode(imode)%unit(icable)%ifmax-emir%be(iback)%mode(imode)%unit(icable)%ifmin
    emir%be(iback)%mode(imode)%unit(icable)%ifcenter = &
        (emir%be(iback)%mode(imode)%unit(icable)%ifmax+emir%be(iback)%mode(imode)%unit(icable)%ifmin)/2d0
    emir%be(iback)%mode(imode)%unit(icable)%label = emir%switch%ifc(icable)%label
    icable = icable+1
  enddo
  !
end subroutine emir_setup_backend
!
subroutine emir_plot_backend(emir,iback,imode,cplot,cata,drawaxis,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>emir_plot_backend
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! Displays the backend coverage when switchbox setup was given by user
  !
  !-----------------------------------------------------------------------
  type(emir_t), intent(in) :: emir
  integer(kind=4), intent(in) :: iback
  integer(kind=4), intent(in) :: imode
  type(current_boxes_t), intent(inout) :: cplot
  type(plot_molecules_t), intent(in) :: cata
  type(frequency_axis_t), intent(in) :: drawaxis
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='BACKEND'
  integer(kind=4)       :: it,is,ib,sb_code(m_sideband),ibox,iu,ich,ku,irec,ib1,ib2,iinc
  character(len=16)     :: isbcol(m_sideband)
  real(kind=8)          :: px,py,yoff,xt,yt,wch,bandoff
  character(len=200)    :: comm,bbname,boxlabel
  character(len=200)    :: defchar,smallchar,molchar
  type(draw_rect_t)     :: backrect
  type(frequency_box_phys_t) :: recbox
  type(draw_line_t)     :: chline
  integer(kind=4), parameter :: iframedash = 3
  integer(kind=4), parameter :: idefdash = 1
  !
  if (.not.emir%switch%defined) then
    call astro_message(seve%e,rname,'Please configure first the switchbox (BASEBAND command)')
    error = .true.
    return
  endif
  !Determine number of box to plot
  if (emir%rec%n_tunings.eq.0) then
    call astro_message(seve%e,rname,'Please define a tuning (EMIR command) before setting up backends')
    error = .true.
    return
  else if (emir%rec%n_tunings.eq.1) then
    cplot%nbox = emir%rec%desc%n_sbands*emir%rec%desc%n_bbands
  else if  (emir%rec%n_tunings.eq.2) then
    if (emir%setup%sb_mode.eq.'SSB') then
      cplot%nbox = emir%rec%n_tunings*emir%rec%desc%n_bbands
    else if (emir%setup%sb_mode.eq.'2SB'.or.emir%switch%mode.eq.'LIST') then
       cplot%nbox = emir%rec%n_tunings*emir%rec%desc%n_sbands*emir%rec%desc%n_bbands
    else
      call astro_message(seve%e,rname,'Problem with EMIR setup (SSB or 2SB)')
      error = .true.
      return
    endif
  else
    call astro_message(seve%e,rname,'EMIR supports only 1 or 2 tuning bands')
    error = .true.
    return
  endif
  ! Reset boxes
  do ib=1,cplot%nbox
    call rec_reset_box(cplot%box(ib),error)
    if (error) return
  enddo
  !
  ! Clear the current window, and ONLY the current window
  call gr_execl('CHANGE DIRECTORY') ! No arg = go to the top directory
  call gr_execl('CLEAR DIRECTORY') ! No arg = clear the whole window
  ! get page info
  px = 0
  py = 0
  call sic_get_dble('page_x',px,error)
  if (error) return
  call sic_get_dble('page_y',py,error)
  if (error) return
  !
  if (cplot%nbox.ge.5) then
  cplot%desc%defchar = 0.3
  cplot%desc%smallchar = 0.2
  cplot%desc%molchar = 0.2
  else
  cplot%desc%defchar = 0.35
  cplot%desc%smallchar = 0.3
  cplot%desc%molchar = 0.2
  endif
  write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%defchar
  write (smallchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%smallchar
  write (molchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%molchar
  call gr_exec1(defchar)
  call gr_exec1('TICKSPACE 0 0 0 0')
  call gr_pen(colour=adefcol,idash=1,error=error)
  if (error) return
  ! set plot parameters
  if (cplot%nbox.gt.4) then
    yoff = 1.d0
  else
    yoff = 1.5d0
  endif
  ibox = 0
  bandoff = -1
  irec = 0
  do it=1,emir%rec%n_tunings !tunings
    bandoff = bandoff+1
    if (emir%rec%desc%n_sbands.eq.2) then
      sb_code(1) = lsb_code !lsb first to show increasing frequencies
      sb_code(2) = usb_code
      isbcol(1) = sb_col(lsb_code)
      isbcol(2) = sb_col(usb_code)
    else if (emir%rec%desc%n_sbands.eq.1) then
      sb_code(1) = emir%rec%tune(it)%sb_code
      isbcol(1) = sb_col(emir%rec%tune(it)%sb_code)
    else
      call astro_message(seve%e,rname,'Problem with number of sidebands')
      error = .true.
      return
    endif
    do is=1,emir%rec%desc%n_sbands !sidebands
      if (emir%switch%mode.ne.'LIST'.and.               &
          emir%setup%sb_mode.ne.'2SB'.and.              &
          sb_code(is).ne.emir%setup%sb_code(it)) cycle
      !sort basebands by frequency
      if (sb_code(is).eq.lsb_code) then
        ib1 = 1
        ib2 = emir%rec%desc%n_bbands
        iinc = 1
      else if (sb_code(is).eq.usb_code) then
        ib1 = emir%rec%desc%n_bbands
        ib2 = 1
        iinc = -1
      else
        call astro_message(seve%e,rname,'Problem with sideband determination')
        error = .true.
        return
      endif
      do ib=ib1,ib2,iinc
        ibox = ibox+1
        boxlabel = ''
        cplot%box(ibox)%iband = emir%rec%tune(it)%iband
        cplot%box(ibox)%sb_code = sb_code(is)
        write (bbname,'(a,1x,a,a)') emir%setup%polar(it),sideband(cplot%box(ibox)%sb_code)(1:1),          &
                                  emir%rec%desc%bbname(ib)(1:1)
        cplot%box(ibox)%phys%sx = px-4.5d0 ! depends on plot orientation
        cplot%box(ibox)%phys%sy = min((py-3.d0)/cplot%nbox-yoff,4.) ! depends on baseband number
        cplot%box(ibox)%phys%xmin = 3.d0
        cplot%box(ibox)%phys%xmax = cplot%box(ibox)%phys%xmin+cplot%box(ibox)%phys%sx
        cplot%box(ibox)%phys%ymax = py-2.5d0-(cplot%box(ibox)%phys%sy+yoff)*(ibox-1)-bandoff
        cplot%box(ibox)%phys%ymin = cplot%box(ibox)%phys%ymax-cplot%box(ibox)%phys%sy
        if (it.ne.irec) then
          recbox%ymax = cplot%box(ibox)%phys%ymax+1.6*cplot%desc%defchar
          irec = it
          recbox%xmin = cplot%box(ibox)%phys%xmin-1
          recbox%xmax = cplot%box(ibox)%phys%xmax+0.5
        endif
        write (comm,'(a,i0)') 'CREATE DIRECTORY BOX',ibox
        call gr_execl(comm)
        write (comm,'(a,i0)') 'CHANGE DIRECTORY BOX',ibox
        call gr_execl(comm)
!         call rec_def_fbox(cplot%box(ibox)%sb_code,rec%desc%bblim(1,ib),         &
!                           rec%desc%bblim(2,ib),'IF1',cplot%box(ibox),           &
!                           rec%source%dopshift,rec%tune(it),error)
        call rec_def_fbox(emir%rec%desc%bblim(1,ib),emir%rec%desc%bblim(2,ib), &
                          'IF1',cplot%box(ibox),emir%rec%desc,emir%rec%source,emir%rec%tune(it)%flo1,error)
        if (error) return
        ! Locate the box
        call rec_locate_fbox(cplot%box(ibox)%phys,error)
        if (error) return
        ! identify different bands
        if ((is.eq.emir%rec%desc%n_sbands.and.ib.eq.ib2).or.(ib.eq.ib2.and.emir%setup%sb_mode.eq.'SSB')) then
          recbox%ymin = cplot%box(ibox)%phys%ymin-1.6*cplot%desc%defchar
          write (comm,'(a,i0)') 'CHANGE DIRECTORY'
          call gr_execl(comm)
          call rec_draw_physrect(recbox,adefcol,iframedash,error)
          if (error) return
          write (comm,'(a,1x,f0.3)') 'SET CHARACTER',2*cplot%desc%defchar
          call gr_exec1(comm)
          if (emir%rec%source%z.ne.0) then
            call gr_pen(colour=azcol,idash=idefdash,error=error)
            if (error) return
          endif
          write (comm,'(a,a,a)') 'DRAW TEXT -1.8 0 "',                    &
                      trim(emir%rec%desc%bandname(emir%rec%tune(it)%iband)),'" 5 90 /CHARACTER 4'
          call gr_exec1(comm)
          call gr_exec1(defchar)
!          Comment here until we create a short title that fits well in the plot
          if (emir%rec%tune(it)%outlo) then
            call gr_pen(colour=aconflictcol,idash=1,error=error)
            if (error) return
            write (comm,'(a)') 'DRAW TEXT -1.2 0 "LO out of recommended range" 5 90 /CHARACTER 4'
            call gr_exec1(comm)
            call gr_pen(colour=adefcol,idash=1,error=error)
            if (error) return
          endif
!           call rec_make_title(rec%tune(it),mess,error)
!           if (error) return
!           write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT -2.3 0 "',trim(mess),'" 5 90 /CHARACTER 4'
!           call gr_exec1(comm)
          call gr_pen(colour=adefcol,idash=1,error=error)
          if (error) return
          write (comm,'(a,i0)') 'CHANGE DIRECTORY BOX',ibox
          call gr_execl(comm)
          call gr_exec1(defchar)
          call gr_pen(colour=adefcol,idash=1,error=error)
          if (error) return
        endif
        ! draw header
        if (ibox.eq.1) then
          call gr_exec1(defchar)
          call gr_pen(colour=apolcol,idash=1,error=error)
          if (error) return
          if (emir%switch%mode.eq.'LIST') then
            call gr_pen(colour=adefcol,idash=1,error=error)
            if (error) return
            write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +5 2.5 "USER DEFINED" 5 0 /CHARACTER 7'
            call gr_exec1(comm)
          else
            write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +3 2.5 "',trim(emir%setup%polmode),'" 5 0 /CHARACTER 7'
            call gr_exec1(comm)
            call gr_pen(colour=adefcol,idash=1,error=error)
            if (error) return
            write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +6 2.5 " POLAR" 5 0 /CHARACTER 7'
            call gr_exec1(comm)
          endif
          call rec_draw_source(rname,emir%rec%source,error)
          if (error) return
          call gr_exec1(defchar)
        endif
        call gr_pen(colour=adefcol,idash=1,error=error)
        if (error) return
        !fill in default colorize
        backrect%xmin = cplot%box(ibox)%if1%xmin
        backrect%xmax = cplot%box(ibox)%if1%xmax
        backrect%ymin = cplot%box(ibox)%if1%ymin
        backrect%ymax = cplot%box(ibox)%if1%ymax
        backrect%col = anotselcol
        call rec_draw_frect(backrect,cplot%box(ibox)%if1,error)
        if (error) return
        do iu=1,emir%be(iback)%mode(imode)%n_backunits ! loop on backend units
          if (emir%be(iback)%mode(imode)%unit(iu)%iband.ne.emir%rec%tune(it)%iband.or.               &
              emir%be(iback)%mode(imode)%unit(iu)%sb_code.ne.sb_code(is).or.                     &
              emir%be(iback)%mode(imode)%unit(iu)%bb_code.ne.ib.or.            &
              emir%be(iback)%mode(imode)%unit(iu)%ifcenter.eq.0) cycle
          backrect%xmin = emir%be(iback)%mode(imode)%unit(iu)%ifmin
          backrect%xmax = emir%be(iback)%mode(imode)%unit(iu)%ifmax
          backrect%ymin = cplot%box(ibox)%if1%ymin
          backrect%ymax = cplot%box(ibox)%if1%ymax
          backrect%col = ahighrescol
          call rec_draw_frect(backrect,cplot%box(ibox)%if1,error)
          if (error) return
          wch = emir%be(iback)%mode(imode)%unit(iu)%width/emir%be(iback)%mode(imode)%unit(iu)%n_chunks
          do ich=1,emir%be(iback)%mode(imode)%unit(iu)%n_chunks-1
            chline%xmin = emir%be(iback)%mode(imode)%unit(iu)%ifmin+wch*ich
            chline%xmax = emir%be(iback)%mode(imode)%unit(iu)%ifmin+wch*ich
            chline%ymin = cplot%box(ibox)%if1%ymin
            chline%ymax = cplot%box(ibox)%if1%ymax
            chline%col = achunkcol
            chline%dash = 2
            call rec_draw_line(chline,cplot%box(ibox)%if1,error)
            if (error) return
          enddo ! chunks
          write (boxlabel,'(a,1x,a,i0,1x,a)') trim(boxlabel),trim(emir%be(iback)%mode(imode)%backname)  &
                    ,iu,trim(emir%be(iback)%mode(imode)%unit(iu)%label)
          ! check for overlap
          do ku = 1,emir%be(iback)%mode(imode)%n_backunits !overlap
            if (ku.ne.iu) then
              if (emir%be(iback)%mode(imode)%unit(ku)%iband.eq.emir%rec%tune(it)%iband.and.               &
                emir%be(iback)%mode(imode)%unit(ku)%sb_code.eq.sb_code(is).and.                     &
                emir%be(iback)%mode(imode)%unit(ku)%bb_code.ne.ib) then
                backrect%col = aoverlapcol
                backrect%xmin = emir%be(iback)%mode(imode)%unit(ku)%ifmin
                backrect%xmax = emir%be(iback)%mode(imode)%unit(ku)%ifmax
                backrect%ymin = cplot%box(ibox)%if1%ymin
                backrect%ymax = cplot%box(ibox)%if1%ymax/2
                call rec_draw_frect(backrect,cplot%box(ibox)%if1,error)
                if (error) return
              endif
            endif
          enddo !overlap
          call gr_pen(colour=adefcol,idash=1,error=error)
          if (error) return
          !plot  molecules
          call gr_exec1(molchar)
          call rec_draw_molecules(cata,cplot%box(ibox)%rest,error)
          if (error) return
          call gr_exec1(defchar)
        enddo !correl units
        !
        ! show tuning line
        if (cplot%box(ibox)%rest%xmin.le.emir%rec%tune(it)%frest.and.cplot%box(ibox)%rest%xmax.ge.emir%rec%tune(it)%frest) then
          call rec_draw_linetune(emir%rec%tune(it),cplot%box(ibox)%rest,error)
          if (error) return
        endif
        !
        ! Draw unit name
        xt = 0.d0
        yt = 1d0
        call gr_exec1(smallchar)
        write (comm,'(a,1x,f0.3,1x,f0.3,1x,a,a,a)')             &
              'DRAW TEXT',xt,yt,'"',trim(boxlabel),'" 6 0 /CHARACTER 1'
        call gr_exec1(defchar)
        call gr_exec1(comm)
        ! Draw the box
        !
        call rec_draw_fbox(cplot,ibox,drawaxis,error)
        if (error) return
        call gr_execl('CHANGE DIRECTORY')
      enddo !basebands
    enddo !sidebands
  enddo !tunings
  cplot%desc%plotmode = pm_basebands
  !
end subroutine emir_plot_backend

!
! -------------------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoSwFrequency">
!   <VERSION>
!                Id: modulePakoSwFrequency.f90,v 1.2.3 2014-02-10 Hans Ungerechts
!                Id: modulePakoSwFrequency.f90,v 1.2.2 2013-02-15 Hans Ungerechts
!                    reviewed w/r/t paKo               2012-11-30
!                Id: modulePakoSwFrequency.f90,v 1.2.0 2012-06-14 Hans Ungerechts
!                based on
!                Id: modulePakoSwFrequency.f90,v 1.1.6 2011-06-30 Hans Ungerechts
!   </VERSION>
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Switchinging Modes
!   </FAMILY>
!   <SIBLINGS>
!                SwBeam
!                SwFrequency
!                SwTotalPower
!                SwWobbler
!   </SIBLINGS>        
!
!   Pako module for command: SWFREQUENCY
!
!   <NOTES>
!     - to be realized with 2nd reference synthesizer (SYN2)
!     - value of SYN2 is added to LO frequency by PLL
!     - SYN2 is normally set fixed to:        100 MHz
!     - SYN2                    range:  90 to 120 MHz 
!            except for A100 and C150:  80 to 130 MHz
!     - therefore +/- 9 MHz is in range for all SYN2s
!     - LO frequency, and therefore SYN2 is multiplied
!          by 1 for 3mm     --> +/-  9 MHz  (limits in old CS)
!             2 for 2mm     --> +/- 18 MHz
!             3 for 1.3mm   --> +/- 27 MHz
!     - in NCS v++ we could have some what larger FSW  by
!       adjusting first synthesizer (which is also used to 
!                 realize the Doppler correction)
!   </NOTES>
!
! </DOCUMENTATION> <!-- name="modulePakoSwFrequency" -->
!
! -------------------------------------------------------------------------------
!
Module modulePakoSwFrequency
  !
  Use modulePakoMessages
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoReceiver
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  Public :: swFrequency
  Public :: displaySwFrequency
  Public :: saveSwFrequency
  Public :: writeXMLswFrequency
  !     
  ! *** Variables for swFrequency ***
  Include 'inc/variables/variablesSwFrequency.inc'
  !     
Contains
!!!
!!!
  Subroutine swFrequency(programName,line,command,error)
    !
    ! *** Arguments: ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Real(Kind=kindSingle)   ::  rr
    !
    Include 'inc/ranges/rangesSwFrequency.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module SwFrequency, v 1.2.0 2012-06-14 ---> SR: SwFrequency ")     ! trace execution
    !
    ! *** initialize:   ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/swFrequencySetDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values   ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    Call checkNofParameters(command,                                             &
         &     0, 2,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    ! *** read Parameters, Options (to detect errors)         ***
    ! *** and check for validity and ranges                   ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/options/optionSwfReceiver.inc'
       Include 'inc/parameters/parametersFoffsets.inc'      
       Include 'inc/options/readOptionsSwFrequency.inc'
    End If
    !
    ! *** set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          Include 'inc/variables/swFrequencySetDefaults.inc'
       Endif
    Endif
    !
    ! *** read Parameters, Options (again, after defaults!)   ***
    ! *** and check for validity and ranges                   ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/options/optionSwfReceiver.inc'
       Include 'inc/parameters/parametersFoffsets.inc'
       Include 'inc/options/readOptionsSwFrequency.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** derived parameters                              ***
    !
    If (.Not.ERROR) Then
       !
       rr                     =     vars(iIn)%tPhase                             &
            &                     * vars(iIn)%nPhases                            &
            &                     * vars(iIn)%nCycles                            !
       !
       Write (messageText,*)                                                     &
            &                 " number of phases = nPhases =  ",                 &
            &                 vars(iIn)%nPhases                                  !
       Call PakoMessage(priorityI,severityI,command,messageText)
       Write (messageText,*)                                                     &
            &                 " time per record = tRecord = " //                 &
            &                 " tPhase*nPhases*nCycles = " ,                     &
            &                 rr                                                 !
       If      (rr.Gt.vars(iLimit2)%tRecord) Then
          Call PakoMessage(priorityE,severityE,command,messageText)
       Else If (rr.Gt.vars(iStd2)%tRecord) Then
          Call PakoMessage(priorityW,severityW,command,messageText)
       Else 
          Call PakoMessage(priorityI,severityI,command,messageText)
       End If
       !
       Call checkR4("SWF tRecord ",rr,                                           &
            &           vars%tRecord,                                            &
            &           errorR)                                                  !
       !
       If (errorR) Then
          Write (messageText,*)                                                  &
               &         " tRecord = tPhase*nPhases*nCycles "//                  &
               &         " is outside limits "                                   !
          Call PakoMessage(priorityE,severityE,command,messageText)
       End If
       !
       ERROR = ERROR .or. errorR
       !
    End If
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.ERROR) Then
       !
       errorInconsistent = .False.
       !
       Include 'inc/options/checkConsistentSwfReceiver.inc'
       !
       If (GV%backendFTS .And. vars(iIn)%tPhase.Le.0.1-0.001) Then
          errorInconsistent = .True.
          Write (messageText, '(a,F8.2,a,a,a,a)')                                &
                  &   " /tPhase ",            vars(iIn)%tPhase,                  &
                  &   " in ",                 swModePako%Freq,                   &
                  &   " too small for ",      bac%FTS                            !
          Call PakoMessage(priorityE,severityE,command,messageText)
       End If
       !
       If (.Not. errorInconsistent) Then
          vars(iTemp) = vars(iIn)
       End If
       !
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from Temp into persistent variables   ***
    If (.Not.ERROR) Then
       vars(iValue) = vars(iTemp)
    End If
    !
    ! *** display values  ***
    !     (Note: this is done independantly of the Error status)
    Call displaySwFrequency
    !
    ! *** set "selected" switching mode ***
    If (.Not.error) Then
       GV%switchingMode     = swMode%Freq
       GV%tPhase            = vars(iValue)%tPhase
       GV%tRecord           = vars(iValue)%tRecord
       GV%notReadySWafterOM = .True.
       GV%notReadyFocus     = .True.
       GV%notReadyOnOff     = .True.
       GV%notReadyOtfMap    = .True.
       GV%notReadyPointing  = .True.
       GV%notReadyTrack     = .True.
       !
       Include 'inc/messages/messageSwModeSelected.inc'
       !
       swFrequencyCommand = line(1:lenc(line))
    End If
    !
    Return
  End Subroutine swFrequency
!!!
!!!
  Subroutine displaySwFrequency
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    ! 
    Include 'inc/display/commandDisplaySwFrequency.inc'
    !
  End Subroutine displaySwFrequency
!!!
!!!
  Subroutine saveSwFrequency(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical  ::  isConnected
    !
    contC = contNN
    !
    B = '\'   !  '
    S = ' '
    CMD =  programName//B//"SWFREQUENCY"
    lCMD = lenc(CMD)
    !
    ERROR = .False.
    !
    Write (iUnit,*) "! "
    Write (iUnit,*) "! ", CMD(1:lCMD)
    !
    contC = contNN
    !
    Include 'inc/parameters/saveFoffsets.inc'
    !
    contC = contNN
    !
    Include 'inc/options/saveNcycles.inc'
    Include 'inc/options/saveTphase.inc'
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveSwFrequency
!!!
!!!
  Subroutine writeXMLswFrequency(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Character (len=lenCh)  :: valueC
    Character (len=lenVar) :: valueComment
    Real                   :: value
    Logical                :: errorXML
    Logical                :: isConnected
    !
    ERROR = .False.
    !
    Include 'inc/startXML/swFrequency.inc'
    !
    Return
  End Subroutine writeXMLswFrequency
!!!
!!!
End Module modulePakoSwFrequency

subroutine class_title(set,line,r,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_title
  use class_data
  use class_types
  !----------------------------------------------------------------------
  ! @ public (for libclass only)
  ! CLASS support routine for command line
  !       TITLE
  ! 1           [/INDEX]
  ! 2           [/OBS]
  ! 3           [/BRIEF]
  ! 4           [/LONG]
  ! 5           [/FULL]
  !  Draw a header above the box
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  type(observation),   intent(in)    :: r      !
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='TITLE'
  real(4) :: x,y,expa,cdef,lx2,ly2
  character(len=1) :: key1,key2
  !
  ! Command line parsing for title format
  key1 = set%heade
  if (sic_present(3,0)) key1 = 'B'
  if (sic_present(4,0)) key1 = 'L'
  if (sic_present(5,0)) key1 = 'F'
  !
  ! Command line parsing for action level
  key2 = set%action
  if (sic_present(1,0).and.sic_present(2,0)) then
     call class_message(seve%e,rname,'/INDEX and /OBS are exclusive from each other')
     error = .true.
     return
  else if (sic_present(1,0)) then
     key2 = 'I'
  else if (sic_present(2,0)) then
     key2 = 'O'
  endif
  !
  if (key2.eq.'I') then
     if (.not.associated(p%data2)) then
        call class_message(seve%e,rname,'No index loaded')
        error = .true.
        return
     endif
  endif
  !
  call sic_get_real('PAGE_X',lx2,error)
  call sic_get_real('PAGE_Y',ly2,error)
  call sic_get_real('CHARACTER_SIZE',cdef,error)
  expa = 1.0
  x = lx2/2.0
  y = ly2-cdef*0.575*expa
  call out0('Graphic',x,y,error)
  if (key2.eq.'I') then
     call titout(set,p%head,key1,key2)
  else if (key2.eq.'O') then
     call titout(set,r%head,key1,key2)
  else
     call class_message(seve%e,rname,'Unknown action level: '//key2)
     error = .true.
     return
  endif
  !
end subroutine class_title

subroutine gdf_allocate (hx,error)
  use gio_interfaces, only : gio_message, gdf_range
  use image_def
  use gbl_message
  !-----------------------------------------------------------------
  ! @ public
  !   Allocate the appropriate work space
  !   for a Gildas data type.
  ! CAUTION
  !   blc, trc not yet tested ...
  !
  !-----------------------------------------------------------------
  type (gildas), intent(inout) :: hx    ! Gildas data type
  logical, intent(out) :: error         ! Error flag
  !
  character(len=*), parameter :: rname = 'GDF_ALLOCATE'
  character(len=80) :: mess
  integer :: is, rank, type, form, ier, i
  integer(kind=size_length) :: asize
  integer(kind=index_length) :: my_dims(gdf_maxdims), nc(2)
  !
  ier = 0
  if (any(hx%blc.ne.0) .or. any(hx%trc.ne.0)) then
    call gio_message(seve%w,rname,'Subset mode not tested yet')
    my_dims = 1
    do i=1,hx%gil%ndim
      nc(1) = hx%blc(i)
      nc(2) = hx%trc(i)
      ier = gdf_range(nc,hx%gil%dim(i))
      my_dims(i) = nc(2)-nc(1)+1
    enddo
  else
    my_dims = hx%gil%dim
  endif
  !
  if (hx%gil%form.eq.0) then
    form = fmt_r4
  else
    form = hx%gil%form
  endif
  !
  rank = hx%gil%ndim
  type = hx%gil%type_gdf
  !
  ! UVT Table case needs special treatment
  if (type.eq.abs(code_gdf_uvt)) then
    if (type.ne.hx%gil%type_gdf) then
      if (hx%gil%type_gdf .eq. code_gdf_uvt) then
        mess = "UV data set is in UVT order, not TUV"
      else if (hx%gil%type_gdf .eq. code_gdf_tuv) then
        mess = "UV data set is in TUV order, not UVT"
      else
        mess = "File is not a UVT or TUV data set"
      endif
      goto 200
    endif
    if (rank.ne.0 .and. rank.ne.2) then
      write(mess,'(A,I1,A)') "UV data sets must have 2 dimensions, found ", rank
      goto 200
    endif
    if (form.ne.fmt_r4) then
      mess = "UV data sets are only Real*4"
      goto 200
    endif
    !
    allocate (hx%r2d(my_dims(1), my_dims(2)), stat=ier)
    !
    ! Currently, all other types are treated as Images...
  else
    select case (rank)
    !
    case(0)
      ! Return a "flat" array, whatever the image rank
      asize = 1
      do is=1,hx%gil%ndim
        asize = asize*my_dims(is)
      enddo
      if (form.eq.fmt_r4) then
        allocate (hx%r1d(asize), stat=ier)
      else if (form.eq.fmt_r8) then
        allocate (hx%d1d(asize), stat=ier)
      else if (form.eq.fmt_i4) then
        allocate (hx%i1d(asize), stat=ier)
      endif
    case(1)
      ! Return a true 1-D only array
      if (form.eq.fmt_r4) then
        allocate (hx%r1d(my_dims(1)), stat=ier)
      else if (form.eq.fmt_r8) then
        allocate (hx%d1d(my_dims(1)), stat=ier)
      else if (form.eq.fmt_i4) then
        allocate (hx%i1d(my_dims(1)), stat=ier)
      endif
      !
    case(2)
      ! Return a true 2-D only array
      if (form.eq.fmt_r4) then
        allocate (hx%r2d(my_dims(1), my_dims(2)), stat=ier)
      else if (form.eq.fmt_r8) then
        allocate (hx%d2d(my_dims(1), my_dims(2)), stat=ier)
      else if (form.eq.fmt_i4) then
        allocate (hx%i2d(my_dims(1), my_dims(2)), stat=ier)
      endif
      !
     case(3)
      ! Return a true 3-D only array
      if (form.eq.fmt_r4) then
        allocate (hx%r3d(my_dims(1), my_dims(2), my_dims(3)), stat=ier)
      else if (form.eq.fmt_r8) then
        allocate (hx%d3d(my_dims(1), my_dims(2), my_dims(3)), stat=ier)
      else if (form.eq.fmt_i4) then
        allocate (hx%i3d(my_dims(1), my_dims(2), my_dims(3)), stat=ier)
      endif
      !
    case(4)
      ! Return a true 4-D only array
      if (form.eq.fmt_r4) then
        allocate (hx%r4d(my_dims(1), my_dims(2), my_dims(3), my_dims(4)), stat=ier)
      else if (form.eq.fmt_r8) then
        allocate (hx%d4d(my_dims(1), my_dims(2), my_dims(3), my_dims(4)), stat=ier)
      else if (form.eq.fmt_i4) then
        allocate (hx%i4d(my_dims(1), my_dims(2),  my_dims(3), hx%gil%dim(4)), stat=ier)
      endif
    case default
      write(mess,'(A,I1,A)') "Rank ",rank," no yet supported"
      goto 200
    end select
  endif
  error = ier.ne.0
  if (.not.error) return
  !
  mess = "Memory allocation failure"
  !
200  call gio_message(seve%e,rname,mess)
  error = .true.
end subroutine gdf_allocate
!
subroutine gdf_read_gildas(hx,name,ext,error, rank, data)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_read_gildas
  use image_def
  use gbl_message
  !-----------------------------------------------------------------
  ! @ public
  ! Read a Gildas Data File of name "name" and extention "ext"
  ! and return it into the "hx" Gildas data type.
  !
  ! Desired Form & Rank can be specified: an error will happen
  ! in case of mismatch.
  !-----------------------------------------------------------------
  type(gildas),     intent(inout)        :: hx      ! Gildas data type
  character(len=*), intent(in)           :: name    ! Filename
  character(len=*), intent(in)           :: ext     ! Extension
  logical,          intent(inout)        :: error   ! Error flag
  integer,          intent(in), optional :: rank    !
  logical,          intent(in), optional :: data    !
  ! Local
  character(len=*), parameter :: rname='GDF_READ_GILDAS'
  integer :: form, type, ier, therank
  character(len=80) :: mess
  logical :: addrank, aheader
  !
  call sic_parse_file(name,' ',ext,hx%file)
  !
  ! Default form, rank & type
  form = hx%gil%form
  type = hx%gil%type_gdf
  !
  addrank = present(rank)
  if (present(data)) then
    aheader = .not.data
  else
    aheader = .false.
  endif
  !
  call gdf_read_header(hx,error)
  if (error) then
    mess = "Cannot read input file "//trim(hx%file)
    goto 200
  endif
  if (form.ne.0) then
    if (hx%gil%form.ne.form) then
      if (form.eq.fmt_r4) then
        mess = "Only real images supported"
      else if (form.eq.fmt_r8) then
        mess = "Only double images supported"
      else if (form.eq.fmt_i4) then
        mess = "Only integer images supported"
      endif
      goto 200
    endif
  else
    form = hx%gil%form
  endif
  !
  ! Addrank indicates some Rank checking, trimming or extension
  if (addrank) then
    therank = rank
    if (therank.lt.0) then
      ! Matching
      if (hx%gil%ndim.ne.-therank) then
        write(mess,'(A,I0,A,I0)')  &
          'Rank mismatch: Image ',hx%gil%ndim,', Requested ',-therank
        goto 200
      endif
      therank = -rank  ! >0
    else if (therank.gt.0) then
      ! Trimming or extension
      call sub_trim_header(rname,hx,therank,error)
      if (error) return
    else
      ! Rank 0 means flat memory model
    endif
  else
    ! Use image rank from file
    therank = hx%gil%ndim
  endif
  !
  ! Return if header only
  if (aheader) return
  !
  ! UVT Table case needs special treatment
  if (type.eq.abs(code_gdf_uvt)) then
    if (type.ne.hx%gil%type_gdf) then
      if (hx%gil%type_gdf .eq. code_gdf_uvt) then
        write(mess,'(A,I1,A)') "UV data set is in UVT order, not TUV"
      else if (hx%gil%type_gdf .eq. code_gdf_tuv) then
        write(mess,'(A,I1,A)') "UV data set is in TUV order, not UVT"
      else
        write(mess,'(A,I1,A)') "File is not a UVT or TUV data set"
      endif
      goto 200
    endif
    if (therank.ne.0 .and. therank.ne.2) then
      write(mess,'(A,I1,A,I2)') "UV data sets must have 2 dimensions, found ",rank
      goto 200
    endif
    if (form.ne.fmt_r4) then
      write(mess,'(A,I1,A)') "UV data sets are only Real*4"
      goto 200
    endif
    !
    allocate (hx%r2d(hx%gil%dim(1), hx%gil%dim(2)), stat=ier)
    if (ier.ne.0) goto 100
    !
    ! This will read properly the extra columns even if
    ! Real*8 and data conversions are implied...
    call gdf_read_uvall (hx,hx%r2d,error)
    !
    ! Currently, all other types are treated as Images...
  else
    select case (therank)
    !
    case(0)
      ! Return a "flat" array, whatever the image rank
      if (form.eq.fmt_r4) then
        allocate (hx%r1d(hx%loca%size), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%r1d,error)
        hx%loca%addr = locwrd(hx%r1d)
      else if (form.eq.fmt_r8) then
        allocate (hx%d1d(hx%loca%size), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%d1d,error)
        hx%loca%addr = locwrd(hx%d1d)
      else if (form.eq.fmt_i4) then
        allocate (hx%i1d(hx%loca%size), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%i1d,error)
        hx%loca%addr = locwrd(hx%i1d)
      endif
    case(1)
      ! Return a true 1-D only array
      if (form.eq.fmt_r4) then
        allocate (hx%r1d(hx%gil%dim(1)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%r1d,error)
      else if (form.eq.fmt_r8) then
        allocate (hx%d1d(hx%gil%dim(1)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%d1d,error)
      else if (form.eq.fmt_i4) then
        allocate (hx%i1d(hx%gil%dim(1)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%i1d,error)
      endif
      !
    case(2)
      ! Return a true 2-D only array
      if (form.eq.fmt_r4) then
        allocate (hx%r2d(hx%gil%dim(1), hx%gil%dim(2)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%r2d,error)
      else if (form.eq.fmt_r8) then
        allocate (hx%d2d(hx%gil%dim(1), hx%gil%dim(2)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%d2d,error)
      else if (form.eq.fmt_i4) then
        allocate (hx%i2d(hx%gil%dim(1), hx%gil%dim(2)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%i2d,error)
      endif
      !
     case(3)
      ! Return a true 3-D only array
      if (form.eq.fmt_r4) then
        allocate (hx%r3d(hx%gil%dim(1), hx%gil%dim(2), hx%gil%dim(3)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%r3d,error)
      else if (form.eq.fmt_r8) then
        allocate (hx%d3d(hx%gil%dim(1), hx%gil%dim(2), hx%gil%dim(3)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%d3d,error)
      else if (form.eq.fmt_i4) then
        allocate (hx%i3d(hx%gil%dim(1), hx%gil%dim(2), hx%gil%dim(3)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%i3d,error)
      endif
      !
    case(4)
      ! Return a true 4-D only array
      if (form.eq.fmt_r4) then
        allocate (hx%r4d(hx%gil%dim(1), hx%gil%dim(2), hx%gil%dim(3), hx%gil%dim(4)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%r4d,error)
      else if (form.eq.fmt_r8) then
        allocate (hx%d4d(hx%gil%dim(1), hx%gil%dim(2), hx%gil%dim(3), hx%gil%dim(4)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%d4d,error)
      else if (form.eq.fmt_i4) then
        allocate (hx%i4d(hx%gil%dim(1), hx%gil%dim(2),  hx%gil%dim(3), hx%gil%dim(4)), stat=ier)
        if (ier.ne.0) goto 100
        call gdf_read_data(hx,hx%i4d,error)
      endif
    case default
      write(mess,'(A,I0,A)') "Rank ",rank," not yet supported"
      goto 200
    end select
  endif
  error = .false.
  return

100  mess = "Memory allocation failure"
200  call gio_message(seve%e,rname,mess)
  error = .true.
end subroutine gdf_read_gildas
!
subroutine gdf_read_data(imag,array,error)
  use gio_interfaces
  use image_def
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type & rank mismatch)
  !       Read data from an image structure and
  !       place it in the specified array
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag       ! Image descriptor
  real(kind=4), intent(inout) :: array(*)   ! Data
  logical,      intent(out)   :: error      ! Flag
  ! Local
  integer(kind=4) :: is,ms,form
  integer(kind=size_length) :: mydims(gdf_maxdims)
  character(len=message_length) :: chain
  character(len=*), parameter :: rname='GDF_READ_DATA'
  !
  imag%status = code_read_data
  is = imag%loca%islo
  if (gdf_stis(is).eq.-1) then
    call gio_message(seve%e,rname,'No such image')
    error = .true.
    return
  endif
  !
  ! Reshape slot to current image shape
  mydims = imag%gil%dim
  call gio_cdim(is,imag%gil%ndim,mydims)
  if (imag%gil%form.eq.0) then
    form = fmt_r4
    write(chain,'(A,I6)') 'Using default file format ',form
    call gio_message(seve%w,rname,chain)
  else
    form = imag%gil%form
  endif
  !!Print *,'DAMS ', imag%blc,imag%trc
  call gio_dams(ms,is,imag%blc,imag%trc,array,form,error)
  !!Print *,'DAMS ', imag%gil%ndim,imag%gil%dim
  if (error) return
  !
  ! Free it
  call gio_frms(ms,error)
  imag%loca%mslo = ms
  imag%status = 0
end subroutine gdf_read_data
!
subroutine gdf_write_data(imag,array,error)
  use gildas_def
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type & rank mismatch)
  !       Write data to an image file specified
  !       by its image structure. The image must have been
  !       opened for write before
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag       ! Image descriptor
  real, intent(in) :: array(*)              ! Data
  logical, intent(out) :: error             ! Flag
  ! Local
  integer :: ms, is
  integer(kind=size_length) :: mydims(gdf_maxdims)
  character(len=*), parameter :: rname='GDF_WRITE_DATA'
  !
  imag%status = code_write_data
  is = imag%loca%islo
  if (gdf_stis(is).eq.-1) then
    call gio_message(seve%e,rname,'No such image')
    error = .true.
    return
  endif
  ! Reshape slot to current image shape
  mydims = imag%gil%dim
  call gio_cdim(is,imag%gil%ndim,mydims)
  !
  ! Associate pre-defined memory area to image
  imag%loca%addr = locwrd(array)
  call gio_pums (ms,is,imag%blc,imag%trc,imag%loca%addr,imag%gil%form,error)
  if (error) return
  !
  ! Dump to disk
  call gio_frms(ms,error)
  imag%loca%mslo = ms
  imag%status = 0
end subroutine gdf_write_data
!
function gdf_range_48(nc,nchan)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-generic   gdf_range
  ! GDF API
  !       Return a range of (pixel / channel / items)
  !---------------------------------------------------------------------
  integer(4) :: gdf_range_48  ! Intent(out)  0 if no error
  integer(8), intent(in) :: nchan     ! The actual number of channels
  integer(4), intent(inout) :: nc(2)  ! The interpreted range of selected channels
  !
  integer(4) :: res
  integer(8) :: mc(2)     ! The actual number of channels
  integer mchan
  !
  ! Use the <0 convention to start from the end
  !
  mc = nc
  mchan = nchan
  if (mc(1).lt.0) then
    mc(1) = mchan+mc(1)
  else if (mc(1).eq.0) then
    mc(1) = 1
  else if (mc(1).gt.mchan) then
    mc(1) = mchan
  endif
  if (mc(2).le.0) then
    mc(2) = mchan+mc(2)
  elseif (mc(2).gt.mchan) then
    mc(2) = mchan
  endif
  !
  if (mc(2).gt.2147483647) then
    call gio_message(seve%e,'GDF_RANGE','Range too large for an Integer(4)')
    res = -1
  else if (mc(2).lt.mc(1)) then
    call gio_message(seve%e,'GDF_RANGE','Invalid range: Last smaller than First')
    print *,'MC ',mc
    res = -2
  else
    res = 0
    nc = mc
  endif
  gdf_range_48 = res
end function gdf_range_48
!
function gdf_range_88(nc,nchan)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-generic  gdf_range
  ! GDF API
  !       Return a range of (pixel / channel / items)
  !---------------------------------------------------------------------
  integer(4) :: gdf_range_88          ! Intent(out)
  integer(8), intent(in) :: nchan     ! The actual number of channels
  integer(8), intent(inout) :: nc(2)  ! The interpreted range of selected channels
  !
  integer :: res
  integer(8) :: mc(2)     ! The actual number of channels
  !
  ! Use the <0 convention to start from the end
  !
  mc = nc
  if (mc(1).lt.0) then
    mc(1) = nchan+mc(1)
  else if (mc(1).eq.0) then
    mc(1) = 1
  else if (mc(1).gt.nchan) then
    mc(1) = nchan
  endif
  if (mc(2).le.0) then
    mc(2) = nchan+mc(2)
  elseif (mc(2).gt.nchan) then
    mc(2) = nchan
  endif
  !
  if (mc(2).lt.mc(1)) then
    call gio_message(seve%e,'GDF_RANGE','Invalid range: Last smaller than First')
    print *,'MC ',mc
    res = -2
  else
    res = 0
    nc = mc
  endif
  gdf_range_88 = res
end function gdf_range_88
!
function gdf_range_44(nc,nchan) ! result (res)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-generic  gdf_range
  ! GDF API
  !       Return a range of (pixel / channel / items)
  !---------------------------------------------------------------------
  integer(4) :: gdf_range_44          ! Intent(out)  0 if no error
  integer(4), intent(in) :: nchan     ! The actual number of channels
  integer(4), intent(inout) :: nc(2)  ! The interpreted range of selected channels
  !
  integer(4) :: mc(2)     ! The actual number of channels
  integer(4) :: res
  !
  ! Use the <0 convention to start from the end
  !
  mc = nc 
  if (mc(1).lt.0) then
    mc(1) = nchan+mc(1)
  else if (mc(1).eq.0) then
    mc(1) = 1
  else if (mc(1).gt.nchan) then
    mc(1) = nchan
  endif
  if (mc(2).le.0) then
    mc(2) = nchan+mc(2)
  else if (mc(2).gt.nchan) then
    mc(2) = nchan
  endif
  !
  if (mc(2).lt.mc(1)) then
    call gio_message(seve%e,'GDF_RANGE','Invalid range: Last smaller than First')
    print *,'MC ',mc
    res = -2
  else
    res = 0
    nc = mc
  endif
  gdf_range_44 = res
end function gdf_range_44
!
function gdf_range_84(nc,nchan)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-generic  gdf_range
  ! GDF API
  !       Return a range of (pixel / channel / items)
  !---------------------------------------------------------------------
  integer(4) :: gdf_range_84          ! Intent(out)  0 if no error
  integer(4), intent(in) :: nchan     ! The actual number of channels
  integer(8), intent(inout) :: nc(2)  ! The interpreted range of selected channels
  !
  integer(8) :: mc(2)     ! The actual number of channels
  integer(4) :: res
  integer(8) :: mchan
  !
  ! Use the <0 convention to start from the end
  !
  if (any(nc.gt.2147483647_8) .or. any(nc.lt.-2147483648_8)) then
    call gio_message(seve%e,'GDF_RANGE','Range too large for an Integer(4)')
    gdf_range_84 = -1
    res = -1
    return
  endif
  mc = nc
  mchan = nchan
  if (mc(1).lt.0) then
    mc(1) = mchan+mc(1)
  else if (mc(1).eq.0) then
    mc(1) = 1
  else if (mc(1).gt.mchan) then
    mc(1) = mchan
  endif
  if (mc(2).le.0) then
    mc(2) = mchan+mc(2)
  elseif (mc(2).gt.mchan) then
    mc(2) = mchan
  endif
  !
  if (mc(2).lt.mc(1)) then
    call gio_message(seve%e,'GDF_RANGE','Invalid range: Last smaller than First')
    print *,'MC ',mc
    res = -2
  else
    res = 0
    nc = mc
  endif
  gdf_range_84 = res
end function gdf_range_84

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetopology_speline_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_unit_arg
  use cubetopology_messaging
  !
  public :: speline_opt_t,speline_user_t,speline_prog_t
  private
  !
  type speline_opt_t
     type(option_t),   pointer :: opt
     type(unit_arg_t), pointer :: unit_arg
   contains
     procedure :: register => cubetopology_speline_register
     procedure :: parse    => cubetopology_speline_parse
  end type speline_opt_t
  !
  type speline_user_t
     logical               :: do = .false.
     character(len=argu_l) :: name = strg_star
     character(len=argu_l) :: freq = strg_star
     character(len=argu_l) :: unit = strg_star
   contains
     procedure :: init   => cubetopology_speline_user_init
     procedure :: toprog => cubetopology_speline_user_toprog
     procedure :: list   => cubetopology_speline_user_list
  end type speline_user_t
  !
  type speline_prog_t
     character(len=line_l) :: name = strg_unk
     real(kind=coor_k)     :: freq = 0d0
  end type speline_prog_t
  !
contains
  !
  subroutine cubetopology_speline_register(line,abstract,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(speline_opt_t), intent(out)   :: line
    character(len=*),     intent(in)    :: abstract
    logical,              intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(unit_arg_t) :: unitarg
    !
    character(len=*), parameter :: rname='SPELINE>REGISTER'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'FREQUENCY','line frequency [unit]',&
         abstract,&
         strg_emp,&
         line%opt,&
         error)
    if (error) return
    call stdarg%register(&
         'line',&
         'New line name',&
         '"*" uses the current cube header line name.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'frequency',&
         'New rest frequency',&
         '"*" uses the current cube header rest frequency.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call unitarg%register(&
         'unit',&
         'Associated frequency unit',&
         '"*" or "=" uses the current user frequency unit.',&
         code_arg_optional,&
         code_unit_freq,&
         line%unit_arg,&
         error)
    if (error) return
  end subroutine cubetopology_speline_register
  !
  subroutine cubetopology_speline_parse(line,cline,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(speline_opt_t), intent(in)    :: line
    character(len=*),     intent(in)    :: cline
    type(speline_user_t), intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPELINE>PARSE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    user%name = strg_star
    user%freq = strg_star
    user%unit = strg_star
    !
    call line%opt%present(cline,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(cline,line%opt,1,user%name,mandatory,error)
       if (error) return
       call cubetools_getarg(cline,line%opt,2,user%freq,mandatory,error)
       if (error) return
       call cubetools_getarg(cline,line%opt,3,user%unit,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubetopology_speline_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetopology_speline_user_init(line,error)
    !----------------------------------------------------------------------
    ! Initialize by setting the intent of line to out
    !----------------------------------------------------------------------
    class(speline_user_t), intent(out)   :: line 
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPELINE>USER>INIT'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
  end subroutine cubetopology_speline_user_init
  !
  subroutine cubetopology_speline_user_toprog(user,cube,prog,error)
    use cubetools_unit
    use cubetools_user2prog
    use cubetools_header_methods
    use cube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(speline_user_t), intent(in)    :: user
    type(cube_t),          intent(in)    :: cube
    type(speline_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    real(kind=coor_k) :: default
    type(unit_user_t) :: unit
    character(len=line_l) :: defline
    character(len=*), parameter :: rname='SPELINE>USER>TOPROG'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    if (user%do) then
       call unit%get_from_name_for_code(user%unit,code_unit_freq,error)
       if (error) return
       call cubetools_header_get_line(cube%head,defline,error)
       if (error) return
       call cubetools_user2prog_resolve_star(user%name,defline,prog%name,error)
       if (error) return
       call cubetools_header_get_rest_frequency(cube%head,default,error)
       if (error) return
       prog%freq = default
       call cubetools_user2prog_resolve_star(user%freq,unit,default,prog%freq,error)
       if (error) return
    else
       call cubetools_header_get_rest_frequency(cube%head,prog%freq,error)
       if (error) return
       call cubetools_header_get_line(cube%head,prog%name,error)
       if (error) return
    endif
  end subroutine cubetopology_speline_user_toprog
  !
  subroutine cubetopology_speline_user_list(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(speline_user_t), intent(in)    :: line 
    logical,               intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPELINE>USER>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    write(mess,'(2a)')     'Line      : ',trim(line%name)
    call cubetopology_message(seve%r,rname,mess)
    write(mess,'(2a,x,a)') 'Frequency : ',trim(line%freq),line%unit
    call cubetopology_message(seve%r,rname,mess)
  end subroutine cubetopology_speline_user_list
end module cubetopology_speline_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubelist_variable_types
  use cubetools_parameters
  use cubelist_types
  use cubedag_messaging
  !---------------------------------------------------------------------
  ! Support module for generic user variable creation (in a structure)
  ! based on a list
  ! ---
  ! FixME: this module should go in cubelist (hence the name of this
  ! module), but we have a dependency on the cubetools_user* modules
  ! from the cubesyntax library, which depend themselves on the basic
  ! list_t. Possible solution:
  !  - have the basic list_t in a library
  !  - have the cubetools_user* modules in cubesyntax library (or other)
  !  - have the advandced list_object_advanced_t in another library.
  !---------------------------------------------------------------------
  !
  public :: list_variable_t
  public :: list_variable_list_t
  private
  !
  ! Support for 1 value
  type, abstract, extends(list_object_t) :: list_variable_t
    character(len=varn_l), public :: parent  ! Parent structure name (e.g. 'ID' used in IDX%ID%)
    character(len=varn_l), public :: name    ! Variable name (e.g. 'FAMILY' used in IDX%ID%FAMILY)
    integer(kind=code_k),  public :: kind
    ! Support arrays (only one used per instance)
    integer(kind=4),  public, allocatable :: i4(:)
    integer(kind=8),  public, allocatable :: i8(:)
    real(kind=4),     public, allocatable :: r4(:)
    real(kind=8),     public, allocatable :: r8(:)
    character(len=:), public, allocatable :: cc(:)
  contains
    procedure(variable_init_interface), deferred :: init        ! [private]
    procedure(fill_array_interface),    deferred :: fill_array  ! [private]
  end type list_variable_t
  !
  ! The collection of variables
  type, extends(list_t) :: list_variable_list_t
    ! No more attributes
  contains
    procedure, public :: create => cubelist_variable_create
  end type list_variable_list_t
  !
contains
  !
  function cubelist_variable_ptr(obj,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(list_variable_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(list_variable_t), pointer :: cubelist_variable_ptr
    class(list_object_t),  pointer       :: obj
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='VARIABLE>PTR'
    !
    select type(obj)
    class is (list_variable_t)
      cubelist_variable_ptr => obj
    class default
      cubelist_variable_ptr => null()
      call cubedag_message(seve%e,rname,  &
        'Internal error: object is not a list_variable_t class')
      error = .true.
      return
    end select
  end function cubelist_variable_ptr
  !
  subroutine variable_init_interface(var,error)
    !-------------------------------------------------------------------
    ! Initialize the variable properties
    !-------------------------------------------------------------------
    class(list_variable_t), intent(inout) :: var
    logical,                intent(inout) :: error
  end subroutine variable_init_interface
  !
  subroutine fill_array_interface(var,obj,ient)
    !-------------------------------------------------------------------
    ! Interface for a function returning a I*4 value
    !-------------------------------------------------------------------
    class(list_variable_t),        intent(inout) :: var
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=list_k),          intent(in)    :: ient
  end subroutine fill_array_interface
  !
  subroutine cubelist_variable_create(var,list,name,error)
    use gbl_format
    use gkernel_interfaces
    use cubetools_userspace
    use cubetools_userstruct
    !-------------------------------------------------------------------
    ! Create the user variable structure (top structure + substructures
    ! + members) based on the declared list of variables and the list of
    ! objects.
    !-------------------------------------------------------------------
    class(list_variable_list_t), intent(in)    :: var
    class(list_t),               intent(in)    :: list
    character(len=*),            intent(in)    :: name  ! Top structure name
    logical,                     intent(inout) :: error
    !
    integer(kind=list_k) :: ivar,ient
    class(list_variable_t), pointer :: onevar
    integer(kind=4) :: ier
    class(list_object_advanced_t), pointer :: obj
    type(userstruct_t) :: topstruct,substruct
    character(len=*), parameter :: rname='VARIABLE>MAIN'
    !
    do ivar=1,var%n
      onevar => cubelist_variable_ptr(var%list(ivar)%p,error)
      if (error)  return
      ! Initialize the variable properties
      call onevar%init(error)
      if (error)  return
      ! Allocate the temporary array gathering the relevant values
      select case (onevar%kind)
      case (fmt_i4)
        allocate(onevar%i4(list%n),stat=ier)
      case (fmt_i8)
        allocate(onevar%i8(list%n),stat=ier)
      case (fmt_r4)
        allocate(onevar%r4(list%n),stat=ier)
      case (fmt_r8)
        allocate(onevar%r8(list%n),stat=ier)
      case default  ! >0 == string length
        allocate(character(onevar%kind)::onevar%cc(list%n),stat=ier)
      end select
      if (failed_allocate(rname,'IDX '//trim(onevar%name)//' array',ier,error)) return
    enddo
    !
    ! Fill with values
    do ient=1,list%n
      obj => cubelist_object_advanced_ptr(list%list(ient)%p,error)
      if (error)  return
      !
      do ivar=1,var%n
        onevar => cubelist_variable_ptr(var%list(ivar)%p,error)
        if (error)  return
        call onevar%fill_array(obj,ient)
      enddo
    enddo
    !
    ! The user structure is user-defined: no need for a permanent allocation
    ! of the arrays nor topstruct userstruct_t
    topstruct%name      = name
    topstruct%scope     = .true.          ! Global variable
    topstruct%overwrite = overwrite_user  ! Avoid overwriting e.g. PI
    !
    ! Main structure
    call topstruct%def(error)
    if (error)  return
    call topstruct%set_member('n',list%n,error)
    if (error) return
    if (list%n.le.0)  return  ! No zero-sized arrays in SIC: leave
    !
    ! Create all variables in their substructures
    do ivar=1,var%n
      onevar => cubelist_variable_ptr(var%list(ivar)%p,error)
      if (error)  return
      if (.not.topstruct%has_member(onevar%parent)) then
        ! Create only once if not already existing. topstruct%def()
        ! ensures that the top structure was fully reset.
        call topstruct%def_substruct(onevar%parent,substruct,error)
        if (error) return
      endif
      select case (onevar%kind)
      case (fmt_i4)
        call substruct%set_member(onevar%name,onevar%i4,error)
        if (error) return
      case (fmt_i8)
        call substruct%set_member(onevar%name,onevar%i8,error)
        if (error) return
      case (fmt_r4)
        call substruct%set_member(onevar%name,onevar%r4,error)
        if (error) return
      case (fmt_r8)
        call substruct%set_member(onevar%name,onevar%r8,error)
        if (error) return
      case default
        call substruct%set_member(onevar%name,onevar%cc,error)
        if (error) return
      end select
    enddo
    !
  end subroutine cubelist_variable_create
end module cubelist_variable_types
!
module cubedag_variables
  use gbl_format
  use cubetools_parameters
  use cubelist_types
  use cubelist_variable_types
  !---------------------------------------------------------------------
  ! Support module for all the possible user variables created from the
  ! DAG
  !---------------------------------------------------------------------
  !
  public :: var_identifier_t
  public :: var_family_t
  public :: var_cflags_t
  private
  !
  ! ID number
  type, extends(list_variable_t) :: var_identifier_t
  contains
    procedure         :: init       => variable_init_id        ! [private]
    procedure         :: fill_array => variable_fill_array_id  ! [private]
    procedure, public :: final      => variable_final_id
  end type var_identifier_t
  !
  ! Family
  type, extends(list_variable_t) :: var_family_t
  contains
    procedure         :: init       => variable_init_family        ! [private]
    procedure         :: fill_array => variable_fill_array_family  ! [private]
    procedure, public :: final      => variable_final_family
  end type var_family_t
  !
  ! Character-flags
  type, extends(list_variable_t) :: var_cflags_t
  contains
    procedure         :: init       => variable_init_cflags        ! [private]
    procedure         :: fill_array => variable_fill_array_cflags  ! [private]
    procedure, public :: final      => variable_final_cflags
  end type var_cflags_t
  !
contains
  !
  !---------------------------------------------------------------------
  subroutine variable_init_id(var,error)
    class(var_identifier_t), intent(inout) :: var
    logical,                 intent(inout) :: error
    var%parent = 'id'
    var%name   = 'id'
    var%kind   = fmt_i8
  end subroutine variable_init_id
  subroutine variable_fill_array_id(var,obj,ient)
    use cubedag_node_class
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(var_identifier_t),       intent(inout) :: var
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=list_k),          intent(in)    :: ient
    logical :: found,error
    var%i8(ient) = 0_8  ! Should not be necessary
    error = .false.
    call obj%get_value('IDENTIFIER',found,var%i8(ient),error)
  end subroutine variable_fill_array_id
  subroutine variable_final_id(obj,error)
    class(var_identifier_t), intent(inout) :: obj
    logical,                 intent(inout) :: error
    if (allocated(obj%i8))  deallocate(obj%i8)
  end subroutine variable_final_id
  !---------------------------------------------------------------------
  subroutine variable_init_family(var,error)
    class(var_family_t), intent(inout) :: var
    logical,             intent(inout) :: error
    var%parent = 'id'
    var%name   = 'family'
    var%kind   = base_l
  end subroutine variable_init_family
  subroutine variable_fill_array_family(var,obj,ient)
    use cubedag_node_class
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(var_family_t),           intent(inout) :: var
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=list_k),          intent(in)    :: ient
    logical :: found,error
    error = .false.
    var%cc(ient) = strg_unk
    call obj%get_value('FAMILY',found,var%cc(ient),error)
  end subroutine variable_fill_array_family
  subroutine variable_final_family(obj,error)
    class(var_family_t), intent(inout) :: obj
    logical,             intent(inout) :: error
    if (allocated(obj%cc))  deallocate(obj%cc)
  end subroutine variable_final_family
  !---------------------------------------------------------------------
  subroutine variable_init_cflags(var,error)
    class(var_cflags_t), intent(inout) :: var
    logical,             intent(inout) :: error
    var%parent = 'id'
    var%name   = 'flagstring'
    var%kind   = argu_l  ! Same as LOAD /ID => len=argu_l
  end subroutine variable_init_cflags
  subroutine variable_fill_array_cflags(var,obj,ient)
    use cubedag_node_class
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(var_cflags_t),           intent(inout) :: var
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=list_k),          intent(in)    :: ient
    logical :: found,error
    error = .false.
    var%cc(ient) = strg_unk
    call obj%get_value('FLAGS',found,var%cc(ient),error)
  end subroutine variable_fill_array_cflags
  subroutine variable_final_cflags(obj,error)
    class(var_cflags_t), intent(inout) :: obj
    logical,             intent(inout) :: error
    if (allocated(obj%cc))  deallocate(obj%cc)
  end subroutine variable_final_cflags
  !---------------------------------------------------------------------
end module cubedag_variables
!
module cubedag_variable_types
  use cubetools_parameters
  use cubelist_variable_types
  use cubedag_messaging
  use cubedag_node_class
  use cubedag_link_type
  use cubedag_dag_buffer
  use cubedag_variables
  !---------------------------------------------------------------------
  ! Support module which creates user variables based on the DAG without
  ! knowing the node properties
  !---------------------------------------------------------------------
  !
  ! For convenience, re-export all individual variables known by the DAG
  public :: var_identifier_t
  public :: var_family_t
  public :: var_cflags_t
  public :: dag_variable_list_t
  private
  !
  ! The collection of variables
  type, extends(list_variable_list_t) :: dag_variable_list_t
    ! No more attributes
  contains
    procedure, public :: ix => cubedag_variable_ix
    procedure, public :: cx => cubedag_variable_cx
  end type dag_variable_list_t
  !
contains
  !
  subroutine cubedag_variable_ix(var,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Define the structure for the DAG index
    ! ZZZ Should be called by cubedag_dag_attach for each new node
    !-------------------------------------------------------------------
    class(dag_variable_list_t), intent(in)    :: var
    logical,                    intent(inout) :: error
    !
    ! call cubedag_variable_act(var,ix,'DAG',error)
    call var%create(ix,'DAG',error)
    if (error)  return
  end subroutine cubedag_variable_ix
  !
  subroutine cubedag_variable_cx(var,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Define the structure for the CURRENT index
    !-------------------------------------------------------------------
    class(dag_variable_list_t), intent(in)    :: var
    logical,                    intent(inout) :: error
    !
    ! call cubedag_variable_act(var,cx,'IDX',error)
    call var%create(cx,'IDX',error)
    if (error)  return
  end subroutine cubedag_variable_cx
end module cubedag_variable_types

program uv_ref_gauss
  use gildas_def
  use gkernel_interfaces
  use mapping_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! TASK  Self-Calibration
  !	Applies "Self-Calibration" results to a CLIC UV table.
  ! Input :
  !	TABLE$	The UV table to be self-calibrated
  !	SELF$	The "gain" table, i.e. a UV table used as phase reference
  !	DTIME$	The smoothing time constant
  !	TYPE$	Type of self-cal, Ampli, Phase or Both
  !	GAUSS$  Position, Amplitude and Size of source
  !	SUBT$	Subtract point source model from data
  ! S.Guilloteau 19-Jun-1991
  !---------------------------------------------------------------------
  ! Local
  type(gildas) :: x,y
  character(len=filename_length) :: uv_table,self_name,name
  character(len=8) :: type
  real(8) :: time,stime,dtime
  integer :: wcol,itype
  !
  complex(4) :: model,  result, self
  real(8), allocatable :: ipw(:)
  integer, allocatable :: ipi(:)
  integer :: sblock=1000
  integer :: i,nvs,nvi,nsc,nc,n,j,k,ier,wrange(2)
  real :: factor,rbase(2),gauss(7),reel,imgi
  real :: kilow,weight,uv(2)
  logical :: error
  real(8) :: freq
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 1.d0/299792458.d-6
  !
  call gildas_open
  call gildas_char('UV_TABLE$',uv_table)
  call gildas_char('SELF$',self_name)
  call gildas_dble('DTIME$',dtime,1)
  call gildas_inte('WCOL$',wcol,1)
  call gildas_char('TYPE$',type)
  call gildas_real('GAUSS$',gauss,6)
  call gildas_real('SUB$',factor,1)
  call gildas_close
  !
  self = cmplx(1.0,0.0)
  weight = 1.0
  if (type.eq.'BOTH') then
    itype = 0
  elseif (type.eq.'AMPLI') then
    itype = -1
  elseif (type.eq.'PHASE') then
    itype = 1
  elseif (type.eq.'NONE') then
    itype = 2
  endif
  dtime = 0.5d0*dtime
  ! North towards East convention
  gauss(7) = sin(gauss(6))
  gauss(6) = cos(gauss(6))
  !
  ! Open continuum table
  n = lenc(self_name)
  if (n.le.0) goto 999
  name = self_name(1:n)
  call gildas_null (y, type = 'UVT')
  call gdf_read_gildas(y, name, '.uvt', error)
  if (error) then
    call gagout('F-SELF_CAL,  Cannot read input UV table')
    goto 999
  endif
  nsc = y%gil%nchan 
  freq = y%gil%val(1)+y%gil%fres*(y%gil%val(1)/y%gil%freq)*((nsc+1)*0.5-y%gil%ref(1))
  kilow = freq*f_to_k
  wcol = max(1,wcol)
  wcol = min(wcol,nsc)
  wrange(1:2) = wcol
  !
  ! Load time variable and sort by time order
  nvi = y%gil%dim(2)
  nvs = y%gil%dim(1)
  allocate (ipw(nvi), ipi(nvi), stat=ier)
  !
  ! Open line table
  n = lenc(uv_table)
  if (n.le.0) goto 999
  name = uv_table(1:n)
  call sic_parsef(name,x%file,' ','.uvt')
  call gildas_null(x, type = 'UVT')
  call gdf_read_gildas(x, name, '.uvt', error, data=.false.)
  if (error) then
    call gagout ('F-SELF_CAL,  Cannot read input/output UV table')
    goto 999
  endif
  nc = x%gil%nchan 
  !
  ! Sort self-cal table
  call dotime (nvs,nvi,y%r2d, ipw, ipi, stime)
  allocate (x%r2d(x%gil%dim(1), sblock), stat=ier)
  !
  ! Loop over line table
  do i=1,x%gil%dim(2),sblock
    x%blc(2) = i
    x%trc(2) = min(x%gil%dim(2),i-1+sblock)
    call gdf_read_data(x,x%r2d,error)
    k = 0
    do j=x%blc(2),x%trc(2)
      k = k+1
      !
      ! Get time and baseline
      call getiba (x%r2d(:,k),stime,time,rbase,uv)
      !
      ! Compute the observed reference visibility for that baseline
      call geself (nvs,nvi,wrange,y%r2d,   &
     &        time,dtime,ipw,ipi,   &
     &        rbase,result,uv)
      !
      ! No data: flag
      if (result.eq.cmplx(0.0,0.0)) then
        call doflag (nc,x%r2d(:,k)) 
      else
        !
        ! Compute the model visibility
        call domodel (x%r2d(:,k),gauss,model,kilow)
        ! Compute self-cal correction
        if (itype.ne.2) then
          call doself  (model,result,itype,self,weight)
        endif
        ! Compute fraction of source to remove
        reel = factor*real(model)
        imgi = factor*imag(model)
        ! Apply self-cal and remove source
        call doscal (nc,x%r2d(:,k),real(self),imag(self),reel,imgi,   &
     &          weight)
      endif
    enddo
    call gdf_write_data(x,x%r2d,error)
  enddo
  ! end loop
  call gdf_close_image(x,error)
  call gdf_close_image(y,error)
  call gagout('S-UV_REF_GAUSS,  Successful completion')
  call sysexi(1)
  999   call sysexi(fatale)
end program uv_ref_gauss
!
subroutine domodel (uv,gauss,model,kilow)
  !---------------------------------------------------------------------
  !	GAUSS
  !	1	Amplitude
  !	2	X center
  !	3	Y center
  !	4	Major axis
  !	5	Minor axis
  !	6	Cos (Angle)
  !	7	Sin (Angle)
  !---------------------------------------------------------------------
  real, intent(in) :: uv(2)                     !
  real, intent(in) :: gauss(7)                  !
  complex, intent(out) :: model                 !
  real, intent(in) :: kilow                     !
  ! Local
  real(8) :: gfact
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: twopi=2.d0*pi
  !
  real :: phi,major,minor,fact
  !
  ! 1/e width of Fourier Transform is 2*sqrt(log(2.0))/pi/FWHM of image
  ! Rotation commute with Fourier Transform
  !
  fact = gauss(1)
  if (gauss(4).ne.0.0) then
    gfact=pi**2/4d0/dlog(2.0d0)
    major = kilow*(uv(1)*gauss(6)+uv(2)*gauss(7))*gauss(4)
    minor = kilow*(uv(1)*gauss(7)-uv(2)*gauss(6))*gauss(5)
    fact = fact*exp (-gfact * (major**2+minor**2))
  endif
  phi = twopi*kilow*(gauss(2)*uv(1)+gauss(3)*uv(2))
  model = cmplx(fact*cos(phi),fact*sin(phi))
end subroutine domodel

*DECK TEVLC
      SUBROUTINE TEVLC (N, D, E2, IERR)
C***BEGIN PROLOGUE  TEVLC
C***SUBSIDIARY
C***PURPOSE  Subsidiary to CBLKTR
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TEVLC-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine finds the eigenvalues of a symmetric tridiagonal
C     matrix by the rational QL method.
C
C     On Input-
C
C        N is the order of the matrix,
C
C        D contains the diagonal elements of the input matrix,
C
C        E2 contains the subdiagonal elements of the input matrix
C           in its last N-1 positions.  E2(1) is arbitrary.
C
C      On Output-
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct and
C          ordered for indices 1,2,...IERR-1, but may not be
C          the smallest eigenvalues,
C
C        E2 has been destroyed,
C
C        IERR is set to
C          ZERO       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C***SEE ALSO  CBLKTR
C***REFERENCES  C. H. Reinsch, Eigenvalues of a real, symmetric, tri-
C                 diagonal matrix, Algorithm 464, Communications of the
C                 ACM 16, 11 (November 1973), pp. 689.
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    CCBLK
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   920528  DESCRIPTION revised and REFERENCES section added.  (WRB)
C***END PROLOGUE  TEVLC
C
      INTEGER         I          ,J          ,L          ,M          ,
     1                N          ,II         ,L1         ,MML        ,
     2                IERR
      REAL            D(*)       ,E2(*)
      REAL            B          ,C          ,F          ,G          ,
     1                H          ,P          ,R          ,S          ,
     2                MACHEP
C
      COMMON /CCBLK/  NPP        ,K          ,MACHEP     ,CNV        ,
     1                NM         ,NCMPLX     ,IK
C***FIRST EXECUTABLE STATEMENT  TEVLC
      IERR = 0
      IF (N .EQ. 1) GO TO 115
C
      DO 101 I=2,N
         E2(I-1) = E2(I)*E2(I)
  101 CONTINUE
C
      F = 0.0
      B = 0.0
      E2(N) = 0.0
C
      DO 112 L=1,N
         J = 0
         H = MACHEP*(ABS(D(L))+SQRT(E2(L)))
         IF (B .GT. H) GO TO 102
         B = H
         C = B*B
C
C     ********** LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT **********
C
  102    DO 103 M=L,N
            IF (E2(M) .LE. C) GO TO 104
C
C     ********** E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
C
  103    CONTINUE
C
  104    IF (M .EQ. L) GO TO 108
  105    IF (J .EQ. 30) GO TO 114
         J = J+1
C
C     ********** FORM SHIFT **********
C
         L1 = L+1
         S = SQRT(E2(L))
         G = D(L)
         P = (D(L1)-G)/(2.0*S)
         R = SQRT(P*P+1.0)
         D(L) = S/(P+SIGN(R,P))
         H = G-D(L)
C
         DO 106 I=L1,N
            D(I) = D(I)-H
  106    CONTINUE
C
         F = F+H
C
C     ********** RATIONAL QL TRANSFORMATION **********
C
         G = D(M)
         IF (G .EQ. 0.0) G = B
         H = G
         S = 0.0
         MML = M-L
C
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
C
         DO 107 II=1,MML
            I = M-II
            P = G*H
            R = P+E2(I)
            E2(I+1) = S*R
            S = E2(I)/R
            D(I+1) = H+S*(H+D(I))
            G = D(I)-E2(I)/G
            IF (G .EQ. 0.0) G = B
            H = G*P/R
  107    CONTINUE
C
         E2(L) = S*G
         D(L) = H
C
C     ********** GUARD AGAINST UNDERFLOWED H **********
C
         IF (H .EQ. 0.0) GO TO 108
         IF (ABS(E2(L)) .LE. ABS(C/H)) GO TO 108
         E2(L) = H*E2(L)
         IF (E2(L) .NE. 0.0) GO TO 105
  108    P = D(L)+F
C
C     ********** ORDER EIGENVALUES **********
C
         IF (L .EQ. 1) GO TO 110
C
C     ********** FOR I=L STEP -1 UNTIL 2 DO -- **********
C
         DO 109 II=2,L
            I = L+2-II
            IF (P .GE. D(I-1)) GO TO 111
            D(I) = D(I-1)
  109    CONTINUE
C
  110    I = 1
  111    D(I) = P
  112 CONTINUE
C
      IF (ABS(D(N)) .GE. ABS(D(1))) GO TO 115
      NHALF = N/2
      DO 113 I=1,NHALF
         NTOP = N-I
         DHOLD = D(I)
         D(I) = D(NTOP+1)
         D(NTOP+1) = DHOLD
  113 CONTINUE
      GO TO 115
C
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
C
  114 IERR = L
  115 RETURN
C
C     ********** LAST CARD OF TQLRAT **********
C
      END
*DECK TEVLS
      SUBROUTINE TEVLS (N, D, E2, IERR)
C***BEGIN PROLOGUE  TEVLS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BLKTRI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TEVLS-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine finds the eigenvalues of a symmetric tridiagonal
C     matrix by the rational QL method.
C
C     On Input-
C
C        N is the order of the matrix,
C
C        D contains the diagonal elements of the input matrix,
C
C        E2 contains the subdiagonal elements of the input matrix
C           in its last N-1 positions.  E2(1) is arbitrary.
C
C      On Output-
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct and
C          ordered for indices 1,2,...IERR-1, but may not be
C          the smallest eigenvalues,
C
C        E2 has been destroyed,
C
C        IERR is set to
C          ZERO       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C***SEE ALSO  BLKTRI
C***REFERENCES  C. H. Reinsch, Eigenvalues of a real, symmetric, tri-
C                 diagonal matrix, Algorithm 464, Communications of the
C                 ACM 16, 11 (November 1973), pp. 689.
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    CBLKT
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   920528  DESCRIPTION revised and REFERENCES section added.  (WRB)
C***END PROLOGUE  TEVLS
C
      INTEGER         I          ,J          ,L          ,M          ,
     1                N          ,II         ,L1         ,MML        ,
     2                IERR
      REAL            D(*)       ,E2(*)
      REAL            B          ,C          ,F          ,G          ,
     1                H          ,P          ,R          ,S          ,
     2                MACHEP
C
      COMMON /CBLKT/  NPP        ,K          ,MACHEP     ,CNV        ,
     1                NM         ,NCMPLX     ,IK
C***FIRST EXECUTABLE STATEMENT  TEVLS
      IERR = 0
      IF (N .EQ. 1) GO TO 115
C
      DO 101 I=2,N
         E2(I-1) = E2(I)*E2(I)
  101 CONTINUE
C
      F = 0.0
      B = 0.0
      E2(N) = 0.0
C
      DO 112 L=1,N
         J = 0
         H = MACHEP*(ABS(D(L))+SQRT(E2(L)))
         IF (B .GT. H) GO TO 102
         B = H
         C = B*B
C
C     ********** LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT **********
C
  102    DO 103 M=L,N
            IF (E2(M) .LE. C) GO TO 104
C
C     ********** E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
C
  103    CONTINUE
C
  104    IF (M .EQ. L) GO TO 108
  105    IF (J .EQ. 30) GO TO 114
         J = J+1
C
C     ********** FORM SHIFT **********
C
         L1 = L+1
         S = SQRT(E2(L))
         G = D(L)
         P = (D(L1)-G)/(2.0*S)
         R = SQRT(P*P+1.0)
         D(L) = S/(P+SIGN(R,P))
         H = G-D(L)
C
         DO 106 I=L1,N
            D(I) = D(I)-H
  106    CONTINUE
C
         F = F+H
C
C     ********** RATIONAL QL TRANSFORMATION **********
C
         G = D(M)
         IF (G .EQ. 0.0) G = B
         H = G
         S = 0.0
         MML = M-L
C
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
C
         DO 107 II=1,MML
            I = M-II
            P = G*H
            R = P+E2(I)
            E2(I+1) = S*R
            S = E2(I)/R
            D(I+1) = H+S*(H+D(I))
            G = D(I)-E2(I)/G
            IF (G .EQ. 0.0) G = B
            H = G*P/R
  107    CONTINUE
C
         E2(L) = S*G
         D(L) = H
C
C     ********** GUARD AGAINST UNDERFLOWED H **********
C
         IF (H .EQ. 0.0) GO TO 108
         IF (ABS(E2(L)) .LE. ABS(C/H)) GO TO 108
         E2(L) = H*E2(L)
         IF (E2(L) .NE. 0.0) GO TO 105
  108    P = D(L)+F
C
C     ********** ORDER EIGENVALUES **********
C
         IF (L .EQ. 1) GO TO 110
C
C     ********** FOR I=L STEP -1 UNTIL 2 DO -- **********
C
         DO 109 II=2,L
            I = L+2-II
            IF (P .GE. D(I-1)) GO TO 111
            D(I) = D(I-1)
  109    CONTINUE
C
  110    I = 1
  111    D(I) = P
  112 CONTINUE
C
      IF (ABS(D(N)) .GE. ABS(D(1))) GO TO 115
      NHALF = N/2
      DO 113 I=1,NHALF
         NTOP = N-I
         DHOLD = D(I)
         D(I) = D(NTOP+1)
         D(NTOP+1) = DHOLD
  113 CONTINUE
      GO TO 115
C
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
C
  114 IERR = L
  115 RETURN
C
C     ********** LAST CARD OF TQLRAT **********
C
      END
*DECK TINVIT
      SUBROUTINE TINVIT (NM, N, D, E, E2, M, W, IND, Z, IERR, RV1, RV2,
     +   RV3, RV4, RV6)
C***BEGIN PROLOGUE  TINVIT
C***PURPOSE  Compute the eigenvectors of symmetric tridiagonal matrix
C            corresponding to specified eigenvalues, using inverse
C            iteration.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C3
C***TYPE      SINGLE PRECISION (TINVIT-S)
C***KEYWORDS  EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the inverse iteration tech-
C     nique in the ALGOL procedure TRISTURM by Peters and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 418-439(1971).
C
C     This subroutine finds those eigenvectors of a TRIDIAGONAL
C     SYMMETRIC matrix corresponding to specified eigenvalues,
C     using inverse iteration.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E,
C          with zeros corresponding to negligible elements of E.
C          E(I) is considered negligible if it is not larger than
C          the product of the relative machine precision and the sum
C          of the magnitudes of D(I) and D(I-1).  E2(1) must contain
C          0.0e0 if the eigenvalues are in ascending order, or 2.0e0
C          if the eigenvalues are in descending order.  If  BISECT,
C          TRIDIB, or  IMTQLV  has been used to find the eigenvalues,
C          their output E2 array is exactly what is expected here.
C          E2 is a one-dimensional REAL array, dimensioned E2(N).
C
C        M is the number of specified eigenvalues for which eigenvectors
C          are to be determined.  M is an INTEGER variable.
C
C        W contains the M eigenvalues in ascending or descending order.
C          W is a one-dimensional REAL array, dimensioned W(M).
C
C        IND contains in its first M positions the submatrix indices
C          associated with the corresponding eigenvalues in W --
C          1 for eigenvalues belonging to the first submatrix from
C          the top, 2 for those belonging to the second submatrix, etc.
C          If  BISECT  or  TRIDIB  has been used to determine the
C          eigenvalues, their output IND array is suitable for input
C          to TINVIT.  IND is a one-dimensional INTEGER array,
C          dimensioned IND(M).
C
C     On Output
C
C       ** All input arrays are unaltered.**
C
C        Z contains the associated set of orthonormal eigenvectors.
C          Any vector which fails to converge is set to zero.
C          Z is a two-dimensional REAL array, dimensioned Z(NM,M).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          -J         if the eigenvector corresponding to the J-th
C                     eigenvalue fails to converge in 5 iterations.
C
C        RV1, RV2 and RV3 are one-dimensional REAL arrays used for
C          temporary storage.  They are used to store the main diagonal
C          and the two adjacent diagonals of the triangular matrix
C          produced in the inverse iteration process.  RV1, RV2 and
C          RV3 are dimensioned RV1(N), RV2(N) and RV3(N).
C
C        RV4 and RV6 are one-dimensional REAL arrays used for temporary
C          storage.  RV4 holds the multipliers of the Gaussian
C          elimination process.  RV6 holds the approximate eigenvectors
C          in this process.  RV4 and RV6 are dimensioned RV4(N) and
C          RV6(N).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TINVIT
C
      INTEGER I,J,M,N,P,Q,R,S,II,IP,JJ,NM,ITS,TAG,IERR,GROUP
      INTEGER IND(*)
      REAL D(*),E(*),E2(*),W(*),Z(NM,*)
      REAL RV1(*),RV2(*),RV3(*),RV4(*),RV6(*)
      REAL U,V,UK,XU,X0,X1,EPS2,EPS3,EPS4,NORM,ORDER
C
C***FIRST EXECUTABLE STATEMENT  TINVIT
      IERR = 0
      IF (M .EQ. 0) GO TO 1001
      TAG = 0
      ORDER = 1.0E0 - E2(1)
      Q = 0
C     .......... ESTABLISH AND PROCESS NEXT SUBMATRIX ..........
  100 P = Q + 1
C
      DO 120 Q = P, N
         IF (Q .EQ. N) GO TO 140
         IF (E2(Q+1) .EQ. 0.0E0) GO TO 140
  120 CONTINUE
C     .......... FIND VECTORS BY INVERSE ITERATION ..........
  140 TAG = TAG + 1
      S = 0
C
      DO 920 R = 1, M
         IF (IND(R) .NE. TAG) GO TO 920
         ITS = 1
         X1 = W(R)
         IF (S .NE. 0) GO TO 510
C     .......... CHECK FOR ISOLATED ROOT ..........
         XU = 1.0E0
         IF (P .NE. Q) GO TO 490
         RV6(P) = 1.0E0
         GO TO 870
  490    NORM = ABS(D(P))
         IP = P + 1
C
         DO 500 I = IP, Q
  500    NORM = MAX(NORM, ABS(D(I)) + ABS(E(I)))
C     .......... EPS2 IS THE CRITERION FOR GROUPING,
C                EPS3 REPLACES ZERO PIVOTS AND EQUAL
C                ROOTS ARE MODIFIED BY EPS3,
C                EPS4 IS TAKEN VERY SMALL TO AVOID OVERFLOW ..........
         EPS2 = 1.0E-3 * NORM
         EPS3 = NORM
  502    EPS3 = 0.5E0*EPS3
         IF (NORM + EPS3 .GT. NORM) GO TO 502
         UK = SQRT(REAL(Q-P+5))
         EPS3 = UK * EPS3
         EPS4 = UK * EPS3
         UK = EPS4 / UK
         S = P
  505    GROUP = 0
         GO TO 520
C     .......... LOOK FOR CLOSE OR COINCIDENT ROOTS ..........
  510    IF (ABS(X1-X0) .GE. EPS2) GO TO 505
         GROUP = GROUP + 1
         IF (ORDER * (X1 - X0) .LE. 0.0E0) X1 = X0 + ORDER * EPS3
C     .......... ELIMINATION WITH INTERCHANGES AND
C                INITIALIZATION OF VECTOR ..........
  520    V = 0.0E0
C
         DO 580 I = P, Q
            RV6(I) = UK
            IF (I .EQ. P) GO TO 560
            IF (ABS(E(I)) .LT. ABS(U)) GO TO 540
C     .......... WARNING -- A DIVIDE CHECK MAY OCCUR HERE IF
C                E2 ARRAY HAS NOT BEEN SPECIFIED CORRECTLY ..........
            XU = U / E(I)
            RV4(I) = XU
            RV1(I-1) = E(I)
            RV2(I-1) = D(I) - X1
            RV3(I-1) = 0.0E0
            IF (I .NE. Q) RV3(I-1) = E(I+1)
            U = V - XU * RV2(I-1)
            V = -XU * RV3(I-1)
            GO TO 580
  540       XU = E(I) / U
            RV4(I) = XU
            RV1(I-1) = U
            RV2(I-1) = V
            RV3(I-1) = 0.0E0
  560       U = D(I) - X1 - XU * V
            IF (I .NE. Q) V = E(I+1)
  580    CONTINUE
C
         IF (U .EQ. 0.0E0) U = EPS3
         RV1(Q) = U
         RV2(Q) = 0.0E0
         RV3(Q) = 0.0E0
C     .......... BACK SUBSTITUTION
C                FOR I=Q STEP -1 UNTIL P DO -- ..........
  600    DO 620 II = P, Q
            I = P + Q - II
            RV6(I) = (RV6(I) - U * RV2(I) - V * RV3(I)) / RV1(I)
            V = U
            U = RV6(I)
  620    CONTINUE
C     .......... ORTHOGONALIZE WITH RESPECT TO PREVIOUS
C                MEMBERS OF GROUP ..........
         IF (GROUP .EQ. 0) GO TO 700
         J = R
C
         DO 680 JJ = 1, GROUP
  630       J = J - 1
            IF (IND(J) .NE. TAG) GO TO 630
            XU = 0.0E0
C
            DO 640 I = P, Q
  640       XU = XU + RV6(I) * Z(I,J)
C
            DO 660 I = P, Q
  660       RV6(I) = RV6(I) - XU * Z(I,J)
C
  680    CONTINUE
C
  700    NORM = 0.0E0
C
         DO 720 I = P, Q
  720    NORM = NORM + ABS(RV6(I))
C
         IF (NORM .GE. 1.0E0) GO TO 840
C     .......... FORWARD SUBSTITUTION ..........
         IF (ITS .EQ. 5) GO TO 830
         IF (NORM .NE. 0.0E0) GO TO 740
         RV6(S) = EPS4
         S = S + 1
         IF (S .GT. Q) S = P
         GO TO 780
  740    XU = EPS4 / NORM
C
         DO 760 I = P, Q
  760    RV6(I) = RV6(I) * XU
C     .......... ELIMINATION OPERATIONS ON NEXT VECTOR
C                ITERATE ..........
  780    DO 820 I = IP, Q
            U = RV6(I)
C     .......... IF RV1(I-1) .EQ. E(I), A ROW INTERCHANGE
C                WAS PERFORMED EARLIER IN THE
C                TRIANGULARIZATION PROCESS ..........
            IF (RV1(I-1) .NE. E(I)) GO TO 800
            U = RV6(I-1)
            RV6(I-1) = RV6(I)
  800       RV6(I) = U - RV4(I) * RV6(I-1)
  820    CONTINUE
C
         ITS = ITS + 1
         GO TO 600
C     .......... SET ERROR -- NON-CONVERGED EIGENVECTOR ..........
  830    IERR = -R
         XU = 0.0E0
         GO TO 870
C     .......... NORMALIZE SO THAT SUM OF SQUARES IS
C                1 AND EXPAND TO FULL ORDER ..........
  840    U = 0.0E0
C
         DO 860 I = P, Q
  860    U = U + RV6(I)**2
C
         XU = 1.0E0 / SQRT(U)
C
  870    DO 880 I = 1, N
  880    Z(I,R) = 0.0E0
C
         DO 900 I = P, Q
  900    Z(I,R) = RV6(I) * XU
C
         X0 = X1
  920 CONTINUE
C
      IF (Q .LT. N) GO TO 100
 1001 RETURN
      END
*DECK TQL1
      SUBROUTINE TQL1 (N, D, E, IERR)
C***BEGIN PROLOGUE  TQL1
C***PURPOSE  Compute the eigenvalues of symmetric tridiagonal matrix by
C            the QL method.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TQL1-S)
C***KEYWORDS  EIGENVALUES OF A SYMMETRIC TRIDIAGONAL MATRIX, EISPACK,
C             QL METHOD
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TQL1,
C     NUM. MATH. 11, 293-306(1968) by Bowdler, Martin, Reinsch, and
C     Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 227-240(1971).
C
C     This subroutine finds the eigenvalues of a SYMMETRIC
C     TRIDIAGONAL matrix by the QL method.
C
C     On Input
C
C        N is the order of the matrix.  N is an INTEGER variable.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C      On Output
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct and
C          ordered for indices 1, 2, ..., IERR-1, but may not be
C          the smallest eigenvalues.
C
C        E has been destroyed.
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C     Calls PYTHAG(A,B) for sqrt(A**2 + B**2).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  PYTHAG
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TQL1
C
      INTEGER I,J,L,M,N,II,L1,L2,MML,IERR
      REAL D(*),E(*)
      REAL B,C,C2,C3,DL1,EL1,F,G,H,P,R,S,S2
      REAL PYTHAG
C
C***FIRST EXECUTABLE STATEMENT  TQL1
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E(I-1) = E(I)
C
      F = 0.0E0
      B = 0.0E0
      E(N) = 0.0E0
C
      DO 290 L = 1, N
         J = 0
         H = ABS(D(L)) + ABS(E(L))
         IF (B .LT. H) B = H
C     .......... LOOK FOR SMALL SUB-DIAGONAL ELEMENT ..........
         DO 110 M = L, N
            IF (B + ABS(E(M)) .EQ. B) GO TO 120
C     .......... E(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
  110    CONTINUE
C
  120    IF (M .EQ. L) GO TO 210
  130    IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     .......... FORM SHIFT ..........
         L1 = L + 1
         L2 = L1 + 1
         G = D(L)
         P = (D(L1) - G) / (2.0E0 * E(L))
         R = PYTHAG(P,1.0E0)
         D(L) = E(L) / (P + SIGN(R,P))
         D(L1) = E(L) * (P + SIGN(R,P))
         DL1 = D(L1)
         H = G - D(L)
         IF (L2 .GT. N) GO TO 145
C
         DO 140 I = L2, N
  140    D(I) = D(I) - H
C
  145    F = F + H
C     .......... QL TRANSFORMATION ..........
         P = D(M)
         C = 1.0E0
         C2 = C
         EL1 = E(L1)
         S = 0.0E0
         MML = M - L
C     .......... FOR I=M-1 STEP -1 UNTIL L DO -- ..........
         DO 200 II = 1, MML
            C3 = C2
            C2 = C
            S2 = S
            I = M - II
            G = C * E(I)
            H = C * P
            IF (ABS(P) .LT. ABS(E(I))) GO TO 150
            C = E(I) / P
            R = SQRT(C*C+1.0E0)
            E(I+1) = S * P * R
            S = C / R
            C = 1.0E0 / R
            GO TO 160
  150       C = P / E(I)
            R = SQRT(C*C+1.0E0)
            E(I+1) = S * E(I) * R
            S = 1.0E0 / R
            C = C * S
  160       P = C * D(I) - S * G
            D(I+1) = H + S * (C * G + S * D(I))
  200    CONTINUE
C
         P = -S * S2 * C3 * EL1 * E(L) / DL1
         E(L) = S * P
         D(L) = C * P
         IF (B + ABS(E(L)) .GT. B) GO TO 130
  210    P = D(L) + F
C     .......... ORDER EIGENVALUES ..........
         IF (L .EQ. 1) GO TO 250
C     .......... FOR I=L STEP -1 UNTIL 2 DO -- ..........
         DO 230 II = 2, L
            I = L + 2 - II
            IF (P .GE. D(I-1)) GO TO 270
            D(I) = D(I-1)
  230    CONTINUE
C
  250    I = 1
  270    D(I) = P
  290 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ..........
 1000 IERR = L
 1001 RETURN
      END
*DECK TQL2
      SUBROUTINE TQL2 (NM, N, D, E, Z, IERR)
C***BEGIN PROLOGUE  TQL2
C***PURPOSE  Compute the eigenvalues and eigenvectors of symmetric
C            tridiagonal matrix.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TQL2-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TQL2,
C     NUM. MATH. 11, 293-306(1968) by Bowdler, Martin, Reinsch, and
C     Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 227-240(1971).
C
C     This subroutine finds the eigenvalues and eigenvectors
C     of a SYMMETRIC TRIDIAGONAL matrix by the QL method.
C     The eigenvectors of a FULL SYMMETRIC matrix can also
C     be found if  TRED2  has been used to reduce this
C     full matrix to tridiagonal form.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        Z contains the transformation matrix produced in the
C          reduction by  TRED2, if performed.  If the eigenvectors
C          of the tridiagonal matrix are desired, Z must contain
C          the identity matrix.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,N).
C
C      On Output
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct but
C          unordered for indices 1, 2, ..., IERR-1.
C
C        E has been destroyed.
C
C        Z contains orthonormal eigenvectors of the symmetric
C          tridiagonal (or full) matrix.  If an error exit is made,
C          Z contains the eigenvectors associated with the stored
C          eigenvalues.
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C     Calls PYTHAG(A,B) for sqrt(A**2 + B**2).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  PYTHAG
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TQL2
C
      INTEGER I,J,K,L,M,N,II,L1,L2,NM,MML,IERR
      REAL D(*),E(*),Z(NM,*)
      REAL B,C,C2,C3,DL1,EL1,F,G,H,P,R,S,S2
      REAL PYTHAG
C
C***FIRST EXECUTABLE STATEMENT  TQL2
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E(I-1) = E(I)
C
      F = 0.0E0
      B = 0.0E0
      E(N) = 0.0E0
C
      DO 240 L = 1, N
         J = 0
         H = ABS(D(L)) + ABS(E(L))
         IF (B .LT. H) B = H
C     .......... LOOK FOR SMALL SUB-DIAGONAL ELEMENT ..........
         DO 110 M = L, N
            IF (B + ABS(E(M)) .EQ. B) GO TO 120
C     .......... E(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
  110    CONTINUE
C
  120    IF (M .EQ. L) GO TO 220
  130    IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     .......... FORM SHIFT ..........
         L1 = L + 1
         L2 = L1 + 1
         G = D(L)
         P = (D(L1) - G) / (2.0E0 * E(L))
         R = PYTHAG(P,1.0E0)
         D(L) = E(L) / (P + SIGN(R,P))
         D(L1) = E(L) * (P + SIGN(R,P))
         DL1 = D(L1)
         H = G - D(L)
         IF (L2 .GT. N) GO TO 145
C
         DO 140 I = L2, N
  140    D(I) = D(I) - H
C
  145    F = F + H
C     .......... QL TRANSFORMATION ..........
         P = D(M)
         C = 1.0E0
         C2 = C
         EL1 = E(L1)
         S = 0.0E0
         MML = M - L
C     .......... FOR I=M-1 STEP -1 UNTIL L DO -- ..........
         DO 200 II = 1, MML
            C3 = C2
            C2 = C
            S2 = S
            I = M - II
            G = C * E(I)
            H = C * P
            IF (ABS(P) .LT. ABS(E(I))) GO TO 150
            C = E(I) / P
            R = SQRT(C*C+1.0E0)
            E(I+1) = S * P * R
            S = C / R
            C = 1.0E0 / R
            GO TO 160
  150       C = P / E(I)
            R = SQRT(C*C+1.0E0)
            E(I+1) = S * E(I) * R
            S = 1.0E0 / R
            C = C * S
  160       P = C * D(I) - S * G
            D(I+1) = H + S * (C * G + S * D(I))
C     .......... FORM VECTOR ..........
            DO 180 K = 1, N
               H = Z(K,I+1)
               Z(K,I+1) = S * Z(K,I) + C * H
               Z(K,I) = C * Z(K,I) - S * H
  180       CONTINUE
C
  200    CONTINUE
C
         P = -S * S2 * C3 * EL1 * E(L) / DL1
         E(L) = S * P
         D(L) = C * P
         IF (B + ABS(E(L)) .GT. B) GO TO 130
  220    D(L) = D(L) + F
  240 CONTINUE
C     .......... ORDER EIGENVALUES AND EIGENVECTORS ..........
      DO 300 II = 2, N
         I = II - 1
         K = I
         P = D(I)
C
         DO 260 J = II, N
            IF (D(J) .GE. P) GO TO 260
            K = J
            P = D(J)
  260    CONTINUE
C
         IF (K .EQ. I) GO TO 300
         D(K) = D(I)
         D(I) = P
C
         DO 280 J = 1, N
            P = Z(J,I)
            Z(J,I) = Z(J,K)
            Z(J,K) = P
  280    CONTINUE
C
  300 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ..........
 1000 IERR = L
 1001 RETURN
      END
*DECK TQLRAT
      SUBROUTINE TQLRAT (N, D, E2, IERR)
C***BEGIN PROLOGUE  TQLRAT
C***PURPOSE  Compute the eigenvalues of symmetric tridiagonal matrix
C            using a rational variant of the QL method.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TQLRAT-S)
C***KEYWORDS  EIGENVALUES OF A SYMMETRIC TRIDIAGONAL MATRIX, EISPACK,
C             QL METHOD
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TQLRAT.
C
C     This subroutine finds the eigenvalues of a SYMMETRIC
C     TRIDIAGONAL matrix by the rational QL method.
C
C     On Input
C
C        N is the order of the matrix.  N is an INTEGER variable.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E2 contains the squares of the subdiagonal elements of the
C          symmetric tridiagonal matrix in its last N-1 positions.
C          E2(1) is arbitrary.  E2 is a one-dimensional REAL array,
C          dimensioned E2(N).
C
C      On Output
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct and
C          ordered for indices 1, 2, ..., IERR-1, but may not be
C          the smallest eigenvalues.
C
C        E2 has been destroyed.
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C     Calls PYTHAG(A,B) for sqrt(A**2 + B**2).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C               C. H. Reinsch, Eigenvalues of a real, symmetric, tri-
C                 diagonal matrix, Algorithm 464, Communications of the
C                 ACM 16, 11 (November 1973), pp. 689.
C***ROUTINES CALLED  PYTHAG, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TQLRAT
C
      INTEGER I,J,L,M,N,II,L1,MML,IERR
      REAL D(*),E2(*)
      REAL B,C,F,G,H,P,R,S,MACHEP
      REAL PYTHAG
      LOGICAL FIRST
C
      SAVE FIRST, MACHEP
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  TQLRAT
      IF (FIRST) THEN
         MACHEP = R1MACH(4)
      ENDIF
      FIRST = .FALSE.
C
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E2(I-1) = E2(I)
C
      F = 0.0E0
      B = 0.0E0
      E2(N) = 0.0E0
C
      DO 290 L = 1, N
         J = 0
         H = MACHEP * (ABS(D(L)) + SQRT(E2(L)))
         IF (B .GT. H) GO TO 105
         B = H
         C = B * B
C     .......... LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT ..........
  105    DO 110 M = L, N
            IF (E2(M) .LE. C) GO TO 120
C     .......... E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
  110    CONTINUE
C
  120    IF (M .EQ. L) GO TO 210
  130    IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     .......... FORM SHIFT ..........
         L1 = L + 1
         S = SQRT(E2(L))
         G = D(L)
         P = (D(L1) - G) / (2.0E0 * S)
         R = PYTHAG(P,1.0E0)
         D(L) = S / (P + SIGN(R,P))
         H = G - D(L)
C
         DO 140 I = L1, N
  140    D(I) = D(I) - H
C
         F = F + H
C     .......... RATIONAL QL TRANSFORMATION ..........
         G = D(M)
         IF (G .EQ. 0.0E0) G = B
         H = G
         S = 0.0E0
         MML = M - L
C     .......... FOR I=M-1 STEP -1 UNTIL L DO -- ..........
         DO 200 II = 1, MML
            I = M - II
            P = G * H
            R = P + E2(I)
            E2(I+1) = S * R
            S = E2(I) / R
            D(I+1) = H + S * (H + D(I))
            G = D(I) - E2(I) / G
            IF (G .EQ. 0.0E0) G = B
            H = G * P / R
  200    CONTINUE
C
         E2(L) = S * G
         D(L) = H
C     .......... GUARD AGAINST UNDERFLOW IN CONVERGENCE TEST ..........
         IF (H .EQ. 0.0E0) GO TO 210
         IF (ABS(E2(L)) .LE. ABS(C/H)) GO TO 210
         E2(L) = H * E2(L)
         IF (E2(L) .NE. 0.0E0) GO TO 130
  210    P = D(L) + F
C     .......... ORDER EIGENVALUES ..........
         IF (L .EQ. 1) GO TO 250
C     .......... FOR I=L STEP -1 UNTIL 2 DO -- ..........
         DO 230 II = 2, L
            I = L + 2 - II
            IF (P .GE. D(I-1)) GO TO 270
            D(I) = D(I-1)
  230    CONTINUE
C
  250    I = 1
  270    D(I) = P
  290 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ..........
 1000 IERR = L
 1001 RETURN
      END
*DECK TRBAK1
      SUBROUTINE TRBAK1 (NM, N, A, E, M, Z)
C***BEGIN PROLOGUE  TRBAK1
C***PURPOSE  Form the eigenvectors of real symmetric matrix from
C            the eigenvectors of a symmetric tridiagonal matrix formed
C            by TRED1.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      SINGLE PRECISION (TRBAK1-S)
C***KEYWORDS  EIGENVECTORS OF A REAL SYMMETRIC MATRIX, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRBAK1,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine forms the eigenvectors of a REAL SYMMETRIC
C     matrix by back transforming those of the corresponding
C     symmetric tridiagonal matrix determined by  TRED1.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        A contains information about the orthogonal transformations
C          used in the reduction by  TRED1  in its strict lower
C          triangle.  A is a two-dimensional REAL array, dimensioned
C          A(NM,N).
C
C        E contains the subdiagonal elements of the tridiagonal matrix
C          in its last N-1 positions.  E(1) is arbitrary.  These
C          elements provide the remaining information about the
C          orthogonal transformations.  E is a one-dimensional REAL
C          array, dimensioned E(N).
C
C        M is the number of columns of Z to be back transformed.
C          M is an INTEGER variable.
C
C        Z contains the eigenvectors to be back transformed in its
C          first M columns.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,M).
C
C     On Output
C
C        Z contains the transformed eigenvectors in its first M columns.
C
C     Note that TRBAK1 preserves vector Euclidean norms.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRBAK1
C
      INTEGER I,J,K,L,M,N,NM
      REAL A(NM,*),E(*),Z(NM,*)
      REAL S
C
C***FIRST EXECUTABLE STATEMENT  TRBAK1
      IF (M .EQ. 0) GO TO 200
      IF (N .EQ. 1) GO TO 200
C
      DO 140 I = 2, N
         L = I - 1
         IF (E(I) .EQ. 0.0E0) GO TO 140
C
         DO 130 J = 1, M
            S = 0.0E0
C
            DO 110 K = 1, L
  110       S = S + A(I,K) * Z(K,J)
C     .......... DIVISOR BELOW IS NEGATIVE OF H FORMED IN TRED1.
C                DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            S = (S / A(I,L)) / E(I)
C
            DO 120 K = 1, L
  120       Z(K,J) = Z(K,J) + S * A(I,K)
C
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END
*DECK TRBAK3
      SUBROUTINE TRBAK3 (NM, N, NV, A, M, Z)
C***BEGIN PROLOGUE  TRBAK3
C***PURPOSE  Form the eigenvectors of a real symmetric matrix from the
C            eigenvectors of a symmetric tridiagonal matrix formed
C            by TRED3.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      SINGLE PRECISION (TRBAK3-S)
C***KEYWORDS  EIGENVECTORS OF A REAL SYMMETRIC MATRIX, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRBAK3,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine forms the eigenvectors of a REAL SYMMETRIC
C     matrix by back transforming those of the corresponding
C     symmetric tridiagonal matrix determined by  TRED3.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        NV is an INTEGER variable set equal to the dimension of the
C          array A as specified in the calling program.  NV must not
C          be less than  N*(N+1)/2.
C
C        A contains information about the orthogonal transformations
C          used in the reduction by  TRED3  in its first N*(N+1)/2
C          positions.  A is a one-dimensional REAL array, dimensioned
C          A(NV).
C
C        M is the number of columns of Z to be back transformed.
C          M is an INTEGER variable.
C
C        Z contains the eigenvectors to be back transformed in its
C          first M columns.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,M).
C
C     On Output
C
C        Z contains the transformed eigenvectors in its first M columns.
C
C     Note that TRBAK3 preserves vector Euclidean norms.
C
C     Questions and comments should be directed to b. s. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRBAK3
C
      INTEGER I,J,K,L,M,N,IK,IZ,NM,NV
      REAL A(*),Z(NM,*)
      REAL H,S
C
C***FIRST EXECUTABLE STATEMENT  TRBAK3
      IF (M .EQ. 0) GO TO 200
      IF (N .EQ. 1) GO TO 200
C
      DO 140 I = 2, N
         L = I - 1
         IZ = (I * L) / 2
         IK = IZ + I
         H = A(IK)
         IF (H .EQ. 0.0E0) GO TO 140
C
         DO 130 J = 1, M
            S = 0.0E0
            IK = IZ
C
            DO 110 K = 1, L
               IK = IK + 1
               S = S + A(IK) * Z(K,J)
  110       CONTINUE
C     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            S = (S / H) / H
            IK = IZ
C
            DO 120 K = 1, L
               IK = IK + 1
               Z(K,J) = Z(K,J) - S * A(IK)
  120       CONTINUE
C
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END
*DECK TRED1
      SUBROUTINE TRED1 (NM, N, A, D, E, E2)
C***BEGIN PROLOGUE  TRED1
C***PURPOSE  Reduce a real symmetric matrix to symmetric tridiagonal
C            matrix using orthogonal similarity transformations.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1B1
C***TYPE      SINGLE PRECISION (TRED1-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRED1,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine reduces a REAL SYMMETRIC matrix
C     to a symmetric tridiagonal matrix using
C     orthogonal similarity transformations.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, A, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        A contains the real symmetric input matrix.  Only the lower
C          triangle of the matrix need be supplied.  A is a two-
C          dimensional REAL array, dimensioned A(NM,N).
C
C     On Output
C
C        A contains information about the orthogonal transformations
C          used in the reduction in its strict lower triangle.  The
C          full upper triangle of A is unaltered.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is set
C          to zero.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2 may coincide with E if the squares are not needed.
C          E2 is a one-dimensional REAL array, dimensioned E2(N).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRED1
C
      INTEGER I,J,K,L,N,II,NM,JP1
      REAL A(NM,*),D(*),E(*),E2(*)
      REAL F,G,H,SCALE
C
C***FIRST EXECUTABLE STATEMENT  TRED1
      DO 100 I = 1, N
  100 D(I) = A(I,I)
C     .......... FOR I=N STEP -1 UNTIL 1 DO -- ..........
      DO 300 II = 1, N
         I = N + 1 - II
         L = I - 1
         H = 0.0E0
         SCALE = 0.0E0
         IF (L .LT. 1) GO TO 130
C     .......... SCALE ROW (ALGOL TOL THEN NOT NEEDED) ..........
         DO 120 K = 1, L
  120    SCALE = SCALE + ABS(A(I,K))
C
         IF (SCALE .NE. 0.0E0) GO TO 140
  130    E(I) = 0.0E0
         E2(I) = 0.0E0
         GO TO 290
C
  140    DO 150 K = 1, L
            A(I,K) = A(I,K) / SCALE
            H = H + A(I,K) * A(I,K)
  150    CONTINUE
C
         E2(I) = SCALE * SCALE * H
         F = A(I,L)
         G = -SIGN(SQRT(H),F)
         E(I) = SCALE * G
         H = H - F * G
         A(I,L) = F - G
         IF (L .EQ. 1) GO TO 270
         F = 0.0E0
C
         DO 240 J = 1, L
            G = 0.0E0
C     .......... FORM ELEMENT OF A*U ..........
            DO 180 K = 1, J
  180       G = G + A(J,K) * A(I,K)
C
            JP1 = J + 1
            IF (L .LT. JP1) GO TO 220
C
            DO 200 K = JP1, L
  200       G = G + A(K,J) * A(I,K)
C     .......... FORM ELEMENT OF P ..........
  220       E(J) = G / H
            F = F + E(J) * A(I,J)
  240    CONTINUE
C
         H = F / (H + H)
C     .......... FORM REDUCED A ..........
         DO 260 J = 1, L
            F = A(I,J)
            G = E(J) - H * F
            E(J) = G
C
            DO 260 K = 1, J
               A(J,K) = A(J,K) - F * E(K) - G * A(I,K)
  260    CONTINUE
C
  270    DO 280 K = 1, L
  280    A(I,K) = SCALE * A(I,K)
C
  290    H = D(I)
         D(I) = A(I,I)
         A(I,I) = H
  300 CONTINUE
C
      RETURN
      END
*DECK TRED2
      SUBROUTINE TRED2 (NM, N, A, D, E, Z)
C***BEGIN PROLOGUE  TRED2
C***PURPOSE  Reduce a real symmetric matrix to a symmetric tridiagonal
C            matrix using and accumulating orthogonal transformations.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1B1
C***TYPE      SINGLE PRECISION (TRED2-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRED2,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine reduces a REAL SYMMETRIC matrix to a
C     symmetric tridiagonal matrix using and accumulating
C     orthogonal similarity transformations.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        A contains the real symmetric input matrix.  Only the lower
C          triangle of the matrix need be supplied.  A is a two-
C          dimensional REAL array, dimensioned A(NM,N).
C
C     On Output
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is set
C          to zero.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        Z contains the orthogonal transformation matrix produced in
C          the reduction.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,N).
C
C        A and Z may coincide.  If distinct, A is unaltered.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRED2
C
      INTEGER I,J,K,L,N,II,NM,JP1
      REAL A(NM,*),D(*),E(*),Z(NM,*)
      REAL F,G,H,HH,SCALE
C
C***FIRST EXECUTABLE STATEMENT  TRED2
      DO 100 I = 1, N
C
         DO 100 J = 1, I
            Z(I,J) = A(I,J)
  100 CONTINUE
C
      IF (N .EQ. 1) GO TO 320
C     .......... FOR I=N STEP -1 UNTIL 2 DO -- ..........
      DO 300 II = 2, N
         I = N + 2 - II
         L = I - 1
         H = 0.0E0
         SCALE = 0.0E0
         IF (L .LT. 2) GO TO 130
C     .......... SCALE ROW (ALGOL TOL THEN NOT NEEDED) ..........
         DO 120 K = 1, L
  120    SCALE = SCALE + ABS(Z(I,K))
C
         IF (SCALE .NE. 0.0E0) GO TO 140
  130    E(I) = Z(I,L)
         GO TO 290
C
  140    DO 150 K = 1, L
            Z(I,K) = Z(I,K) / SCALE
            H = H + Z(I,K) * Z(I,K)
  150    CONTINUE
C
         F = Z(I,L)
         G = -SIGN(SQRT(H),F)
         E(I) = SCALE * G
         H = H - F * G
         Z(I,L) = F - G
         F = 0.0E0
C
         DO 240 J = 1, L
            Z(J,I) = Z(I,J) / H
            G = 0.0E0
C     .......... FORM ELEMENT OF A*U ..........
            DO 180 K = 1, J
  180       G = G + Z(J,K) * Z(I,K)
C
            JP1 = J + 1
            IF (L .LT. JP1) GO TO 220
C
            DO 200 K = JP1, L
  200       G = G + Z(K,J) * Z(I,K)
C     .......... FORM ELEMENT OF P ..........
  220       E(J) = G / H
            F = F + E(J) * Z(I,J)
  240    CONTINUE
C
         HH = F / (H + H)
C     .......... FORM REDUCED A ..........
         DO 260 J = 1, L
            F = Z(I,J)
            G = E(J) - HH * F
            E(J) = G
C
            DO 260 K = 1, J
               Z(J,K) = Z(J,K) - F * E(K) - G * Z(I,K)
  260    CONTINUE
C
  290    D(I) = H
  300 CONTINUE
C
  320 D(1) = 0.0E0
      E(1) = 0.0E0
C     .......... ACCUMULATION OF TRANSFORMATION MATRICES ..........
      DO 500 I = 1, N
         L = I - 1
         IF (D(I) .EQ. 0.0E0) GO TO 380
C
         DO 360 J = 1, L
            G = 0.0E0
C
            DO 340 K = 1, L
  340       G = G + Z(I,K) * Z(K,J)
C
            DO 360 K = 1, L
               Z(K,J) = Z(K,J) - G * Z(K,I)
  360    CONTINUE
C
  380    D(I) = Z(I,I)
         Z(I,I) = 1.0E0
         IF (L .LT. 1) GO TO 500
C
         DO 400 J = 1, L
            Z(I,J) = 0.0E0
            Z(J,I) = 0.0E0
  400    CONTINUE
C
  500 CONTINUE
C
      RETURN
      END
*DECK TRED3
      SUBROUTINE TRED3 (N, NV, A, D, E, E2)
C***BEGIN PROLOGUE  TRED3
C***PURPOSE  Reduce a real symmetric matrix stored in packed form to
C            symmetric tridiagonal matrix using orthogonal
C            transformations.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1B1
C***TYPE      SINGLE PRECISION (TRED3-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRED3,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine reduces a REAL SYMMETRIC matrix, stored as
C     a one-dimensional array, to a symmetric tridiagonal matrix
C     using orthogonal similarity transformations.
C
C     On Input
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C
C        NV is an INTEGER variable set equal to the dimension of the
C          array A as specified in the calling program.  NV must not
C          be less than  N*(N+1)/2.
C
C        A contains the lower triangle, stored row-wise, of the real
C          symmetric packed matrix.  A is a one-dimensional REAL
C          array, dimensioned A(NV).
C
C     On Output
C
C        A contains information about the orthogonal transformations
C          used in the reduction in its first N*(N+1)/2 positions.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is set
C          to zero.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2 may coincide with E if the squares are not needed.
C          E2 is a one-dimensional REAL array, dimensioned E2(N).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRED3
C
      INTEGER I,J,K,L,N,II,IZ,JK,NV
      REAL A(*),D(*),E(*),E2(*)
      REAL F,G,H,HH,SCALE
C
C     .......... FOR I=N STEP -1 UNTIL 1 DO -- ..........
C***FIRST EXECUTABLE STATEMENT  TRED3
      DO  300 II = 1, N
         I = N + 1 - II
         L = I - 1
         IZ = (I * L) / 2
         H = 0.0E0
         SCALE = 0.0E0
         IF (L .LT. 1) GO TO 130
C     .......... SCALE ROW (ALGOL TOL THEN NOT NEEDED) ..........
         DO 120 K = 1, L
            IZ = IZ + 1
            D(K) = A(IZ)
            SCALE = SCALE + ABS(D(K))
  120    CONTINUE
C
         IF (SCALE .NE. 0.0E0) GO TO 140
  130    E(I) = 0.0E0
         E2(I) = 0.0E0
         GO TO 290
C
  140    DO 150 K = 1, L
            D(K) = D(K) / SCALE
            H = H + D(K) * D(K)
  150    CONTINUE
C
         E2(I) = SCALE * SCALE * H
         F = D(L)
         G = -SIGN(SQRT(H),F)
         E(I) = SCALE * G
         H = H - F * G
         D(L) = F - G
         A(IZ) = SCALE * D(L)
         IF (L .EQ. 1) GO TO 290
         F = 0.0E0
C
         DO 240 J = 1, L
            G = 0.0E0
            JK = (J * (J-1)) / 2
C     .......... FORM ELEMENT OF A*U ..........
            DO 180 K = 1, L
               JK = JK + 1
               IF (K .GT. J) JK = JK + K - 2
               G = G + A(JK) * D(K)
  180       CONTINUE
C     .......... FORM ELEMENT OF P ..........
            E(J) = G / H
            F = F + E(J) * D(J)
  240    CONTINUE
C
         HH = F / (H + H)
         JK = 0
C     .......... FORM REDUCED A ..........
         DO 260 J = 1, L
            F = D(J)
            G = E(J) - HH * F
            E(J) = G
C
            DO 260 K = 1, J
               JK = JK + 1
               A(JK) = A(JK) - F * E(K) - G * D(K)
  260    CONTINUE
C
  290    D(I) = A(IZ+1)
         A(IZ+1) = SCALE * SQRT(H)
  300 CONTINUE
C
      RETURN
      END
*DECK TRI3
      SUBROUTINE TRI3 (M, A, B, C, K, Y1, Y2, Y3, TCOS, D, W1, W2, W3)
C***BEGIN PROLOGUE  TRI3
C***SUBSIDIARY
C***PURPOSE  Subsidiary to GENBUN
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRI3-S, CMPTR3-C)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     Subroutine to solve three linear systems whose common coefficient
C     matrix is a rational function in the matrix given by
C
C                  TRIDIAGONAL (...,A(I),B(I),C(I),...)
C
C***SEE ALSO  GENBUN
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890206  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRI3
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,K(4)       ,
     1                TCOS(*)    ,Y1(*)      ,Y2(*)      ,Y3(*)      ,
     2                D(*)       ,W1(*)      ,W2(*)      ,W3(*)
      INTEGER K1P1, K2P1, K3P1, K4P1
C
C***FIRST EXECUTABLE STATEMENT  TRI3
      MM1 = M-1
      K1 = K(1)
      K2 = K(2)
      K3 = K(3)
      K4 = K(4)
      K1P1 = K1+1
      K2P1 = K2+1
      K3P1 = K3+1
      K4P1 = K4+1
      K2K3K4 = K2+K3+K4
      IF (K2K3K4 .EQ. 0) GO TO 101
      L1 = (K1+1)/(K2+1)
      L2 = (K1+1)/(K3+1)
      L3 = (K1+1)/(K4+1)
      LINT1 = 1
      LINT2 = 1
      LINT3 = 1
      KINT1 = K1
      KINT2 = KINT1+K2
      KINT3 = KINT2+K3
  101 CONTINUE
      DO 115 N=1,K1
         X = TCOS(N)
         IF (K2K3K4 .EQ. 0) GO TO 107
         IF (N .NE. L1) GO TO 103
         DO 102 I=1,M
            W1(I) = Y1(I)
  102    CONTINUE
  103    IF (N .NE. L2) GO TO 105
         DO 104 I=1,M
            W2(I) = Y2(I)
  104    CONTINUE
  105    IF (N .NE. L3) GO TO 107
         DO 106 I=1,M
            W3(I) = Y3(I)
  106    CONTINUE
  107    CONTINUE
         Z = 1./(B(1)-X)
         D(1) = C(1)*Z
         Y1(1) = Y1(1)*Z
         Y2(1) = Y2(1)*Z
         Y3(1) = Y3(1)*Z
         DO 108 I=2,M
            Z = 1./(B(I)-X-A(I)*D(I-1))
            D(I) = C(I)*Z
            Y1(I) = (Y1(I)-A(I)*Y1(I-1))*Z
            Y2(I) = (Y2(I)-A(I)*Y2(I-1))*Z
            Y3(I) = (Y3(I)-A(I)*Y3(I-1))*Z
  108    CONTINUE
         DO 109 IP=1,MM1
            I = M-IP
            Y1(I) = Y1(I)-D(I)*Y1(I+1)
            Y2(I) = Y2(I)-D(I)*Y2(I+1)
            Y3(I) = Y3(I)-D(I)*Y3(I+1)
  109    CONTINUE
         IF (K2K3K4 .EQ. 0) GO TO 115
         IF (N .NE. L1) GO TO 111
         I = LINT1+KINT1
         XX = X-TCOS(I)
         DO 110 I=1,M
            Y1(I) = XX*Y1(I)+W1(I)
  110    CONTINUE
         LINT1 = LINT1+1
         L1 = (LINT1*K1P1)/K2P1
  111    IF (N .NE. L2) GO TO 113
         I = LINT2+KINT2
         XX = X-TCOS(I)
         DO 112 I=1,M
            Y2(I) = XX*Y2(I)+W2(I)
  112    CONTINUE
         LINT2 = LINT2+1
         L2 = (LINT2*K1P1)/K3P1
  113    IF (N .NE. L3) GO TO 115
         I = LINT3+KINT3
         XX = X-TCOS(I)
         DO 114 I=1,M
            Y3(I) = XX*Y3(I)+W3(I)
  114    CONTINUE
         LINT3 = LINT3+1
         L3 = (LINT3*K1P1)/K4P1
  115 CONTINUE
      RETURN
      END
*DECK TRIDIB
      SUBROUTINE TRIDIB (N, EPS1, D, E, E2, LB, UB, M11, M, W, IND,
     +   IERR, RV4, RV5)
C***BEGIN PROLOGUE  TRIDIB
C***PURPOSE  Compute the eigenvalues of a symmetric tridiagonal matrix
C            in a given interval using Sturm sequencing.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TRIDIB-S)
C***KEYWORDS  EIGENVALUES OF A REAL SYMMETRIC MATRIX, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure BISECT,
C     NUM. MATH. 9, 386-393(1967) by Barth, Martin, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 249-256(1971).
C
C     This subroutine finds those eigenvalues of a TRIDIAGONAL
C     SYMMETRIC matrix between specified boundary indices,
C     using bisection.
C
C     On Input
C
C        N is the order of the matrix.  N is an INTEGER variable.
C
C        EPS1 is an absolute error tolerance for the computed eigen-
C          values.  If the input EPS1 is non-positive, it is reset for
C          each submatrix to a default value, namely, minus the product
C          of the relative machine precision and the 1-norm of the
C          submatrix.  EPS1 is a REAL variable.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2(1) is arbitrary.  E2 is a one-dimensional REAL array,
C          dimensioned E2(N).
C
C        M11 specifies the lower boundary index for the set of desired
C          eigenvalues.  M11 is an INTEGER variable.
C
C        M specifies the number of eigenvalues desired.  The upper
C          boundary index M22 is then obtained as M22=M11+M-1.
C          M is an INTEGER variable.
C
C     On Output
C
C        EPS1 is unaltered unless it has been reset to its
C          (last) default value.
C
C        D and E are unaltered.
C
C        Elements of E2, corresponding to elements of E regarded
C          as negligible, have been replaced by zero causing the
C          matrix to split into a direct sum of submatrices.
C          E2(1) is also set to zero.
C
C        LB and UB define an interval containing exactly the desired
C          eigenvalues.  LB and UB are REAL variables.
C
C        W contains, in its first M positions, the eigenvalues
C          between indices M11 and M22 in ascending order.
C          W is a one-dimensional REAL array, dimensioned W(M).
C
C        IND contains in its first M positions the submatrix indices
C          associated with the corresponding eigenvalues in W --
C          1 for eigenvalues belonging to the first submatrix from
C          the top, 2 for those belonging to the second submatrix, etc.
C          IND is an one-dimensional INTEGER array, dimensioned IND(M).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          3*N+1      if multiple eigenvalues at index M11 make
C                     unique selection of LB impossible,
C          3*N+2      if multiple eigenvalues at index M22 make
C                     unique selection of UB impossible.
C
C        RV4 and RV5 are one-dimensional REAL arrays used for temporary
C          storage of the lower and upper bounds for the eigenvalues in
C          the bisection process.  RV4 and RV5 are dimensioned RV4(N)
C          and RV5(N).
C
C     Note that subroutine TQL1, IMTQL1, or TQLRAT is generally faster
C     than TRIDIB, if more than N/4 eigenvalues are to be found.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRIDIB
C
      INTEGER I,J,K,L,M,N,P,Q,R,S,II,M1,M2,M11,M22,TAG,IERR,ISTURM
      REAL D(*),E(*),E2(*),W(*),RV4(*),RV5(*)
      REAL U,V,LB,T1,T2,UB,XU,X0,X1,EPS1,MACHEP,S1,S2
      INTEGER IND(*)
      LOGICAL FIRST
C
      SAVE FIRST, MACHEP
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  TRIDIB
      IF (FIRST) THEN
         MACHEP = R1MACH(4)
      ENDIF
      FIRST = .FALSE.
C
      IERR = 0
      TAG = 0
      XU = D(1)
      X0 = D(1)
      U = 0.0E0
C     .......... LOOK FOR SMALL SUB-DIAGONAL ENTRIES AND DETERMINE AN
C                INTERVAL CONTAINING ALL THE EIGENVALUES ..........
      DO 40 I = 1, N
         X1 = U
         U = 0.0E0
         IF (I .NE. N) U = ABS(E(I+1))
         XU = MIN(D(I)-(X1+U),XU)
         X0 = MAX(D(I)+(X1+U),X0)
         IF (I .EQ. 1) GO TO 20
         S1 = ABS(D(I)) + ABS(D(I-1))
         S2 = S1 + ABS(E(I))
         IF (S2 .GT. S1) GO TO 40
   20    E2(I) = 0.0E0
   40 CONTINUE
C
      X1 = MAX(ABS(XU),ABS(X0)) * MACHEP * N
      XU = XU - X1
      T1 = XU
      X0 = X0 + X1
      T2 = X0
C     .......... DETERMINE AN INTERVAL CONTAINING EXACTLY
C                THE DESIRED EIGENVALUES ..........
      P = 1
      Q = N
      M1 = M11 - 1
      IF (M1 .EQ. 0) GO TO 75
      ISTURM = 1
   50 V = X1
      X1 = XU + (X0 - XU) * 0.5E0
      IF (X1 .EQ. V) GO TO 980
      GO TO 320
   60 IF (S - M1) 65, 73, 70
   65 XU = X1
      GO TO 50
   70 X0 = X1
      GO TO 50
   73 XU = X1
      T1 = X1
   75 M22 = M1 + M
      IF (M22 .EQ. N) GO TO 90
      X0 = T2
      ISTURM = 2
      GO TO 50
   80 IF (S - M22) 65, 85, 70
   85 T2 = X1
   90 Q = 0
      R = 0
C     .......... ESTABLISH AND PROCESS NEXT SUBMATRIX, REFINING
C                INTERVAL BY THE GERSCHGORIN BOUNDS ..........
  100 IF (R .EQ. M) GO TO 1001
      TAG = TAG + 1
      P = Q + 1
      XU = D(P)
      X0 = D(P)
      U = 0.0E0
C
      DO 120 Q = P, N
         X1 = U
         U = 0.0E0
         V = 0.0E0
         IF (Q .EQ. N) GO TO 110
         U = ABS(E(Q+1))
         V = E2(Q+1)
  110    XU = MIN(D(Q)-(X1+U),XU)
         X0 = MAX(D(Q)+(X1+U),X0)
         IF (V .EQ. 0.0E0) GO TO 140
  120 CONTINUE
C
  140 X1 = MAX(ABS(XU),ABS(X0)) * MACHEP
      IF (EPS1 .LE. 0.0E0) EPS1 = -X1
      IF (P .NE. Q) GO TO 180
C     .......... CHECK FOR ISOLATED ROOT WITHIN INTERVAL ..........
      IF (T1 .GT. D(P) .OR. D(P) .GE. T2) GO TO 940
      M1 = P
      M2 = P
      RV5(P) = D(P)
      GO TO 900
  180 X1 = X1 * (Q-P+1)
      LB = MAX(T1,XU-X1)
      UB = MIN(T2,X0+X1)
      X1 = LB
      ISTURM = 3
      GO TO 320
  200 M1 = S + 1
      X1 = UB
      ISTURM = 4
      GO TO 320
  220 M2 = S
      IF (M1 .GT. M2) GO TO 940
C     .......... FIND ROOTS BY BISECTION ..........
      X0 = UB
      ISTURM = 5
C
      DO 240 I = M1, M2
         RV5(I) = UB
         RV4(I) = LB
  240 CONTINUE
C     .......... LOOP FOR K-TH EIGENVALUE
C                FOR K=M2 STEP -1 UNTIL M1 DO --
C                (-DO- NOT USED TO LEGALIZE -COMPUTED GO TO-) ..........
      K = M2
  250    XU = LB
C     .......... FOR I=K STEP -1 UNTIL M1 DO -- ..........
         DO 260 II = M1, K
            I = M1 + K - II
            IF (XU .GE. RV4(I)) GO TO 260
            XU = RV4(I)
            GO TO 280
  260    CONTINUE
C
  280    IF (X0 .GT. RV5(K)) X0 = RV5(K)
C     .......... NEXT BISECTION STEP ..........
  300    X1 = (XU + X0) * 0.5E0
         S1 = ABS(XU) + ABS(X0) + ABS(EPS1)
         S2 = S1 + ABS(X0-XU)/2.0E0
         IF (S2 .EQ. S1) GO TO 420
C     .......... IN-LINE PROCEDURE FOR STURM SEQUENCE ..........
  320    S = P - 1
         U = 1.0E0
C
         DO 340 I = P, Q
            IF (U .NE. 0.0E0) GO TO 325
            V = ABS(E(I)) / MACHEP
            IF (E2(I) .EQ. 0.0E0) V = 0.0E0
            GO TO 330
  325       V = E2(I) / U
  330       U = D(I) - X1 - V
            IF (U .LT. 0.0E0) S = S + 1
  340    CONTINUE
C
         GO TO (60,80,200,220,360), ISTURM
C     .......... REFINE INTERVALS ..........
  360    IF (S .GE. K) GO TO 400
         XU = X1
         IF (S .GE. M1) GO TO 380
         RV4(M1) = X1
         GO TO 300
  380    RV4(S+1) = X1
         IF (RV5(S) .GT. X1) RV5(S) = X1
         GO TO 300
  400    X0 = X1
         GO TO 300
C     .......... K-TH EIGENVALUE FOUND ..........
  420    RV5(K) = X1
      K = K - 1
      IF (K .GE. M1) GO TO 250
C     .......... ORDER EIGENVALUES TAGGED WITH THEIR
C                SUBMATRIX ASSOCIATIONS ..........
  900 S = R
      R = R + M2 - M1 + 1
      J = 1
      K = M1
C
      DO 920 L = 1, R
         IF (J .GT. S) GO TO 910
         IF (K .GT. M2) GO TO 940
         IF (RV5(K) .GE. W(L)) GO TO 915
C
         DO 905 II = J, S
            I = L + S - II
            W(I+1) = W(I)
            IND(I+1) = IND(I)
  905    CONTINUE
C
  910    W(L) = RV5(K)
         IND(L) = TAG
         K = K + 1
         GO TO 920
  915    J = J + 1
  920 CONTINUE
C
  940 IF (Q .LT. N) GO TO 100
      GO TO 1001
C     .......... SET ERROR -- INTERVAL CANNOT BE FOUND CONTAINING
C                EXACTLY THE DESIRED EIGENVALUES ..........
  980 IERR = 3 * N + ISTURM
 1001 LB = T1
      UB = T2
      RETURN
      END
*DECK TRIDQ
      SUBROUTINE TRIDQ (MR, A, B, C, Y, D)
C***BEGIN PROLOGUE  TRIDQ
C***SUBSIDIARY
C***PURPOSE  Subsidiary to POIS3D
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRIDQ-S)
C***AUTHOR  (UNKNOWN)
C***SEE ALSO  POIS3D
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900308  Renamed routine from TRID to TRIDQ.  (WRB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRIDQ
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,Y(*)       ,
     1                D(*)
C***FIRST EXECUTABLE STATEMENT  TRIDQ
      M = MR
      MM1 = M-1
      Z = 1./B(1)
      D(1) = C(1)*Z
      Y(1) = Y(1)*Z
      DO 101 I=2,MM1
         Z = 1./(B(I)-A(I)*D(I-1))
         D(I) = C(I)*Z
         Y(I) = (Y(I)-A(I)*Y(I-1))*Z
  101 CONTINUE
      Z = B(M)-A(M)*D(MM1)
      IF (Z .NE. 0.) GO TO 102
      Y(M) = 0.
      GO TO 103
  102 Y(M) = (Y(M)-A(M)*Y(MM1))/Z
  103 CONTINUE
      DO 104 IP=1,MM1
         I = M-IP
         Y(I) = Y(I)-D(I)*Y(I+1)
  104 CONTINUE
      RETURN
      END
*DECK TRIS4
      SUBROUTINE TRIS4 (N, A, B, C, D, U, Z)
C***BEGIN PROLOGUE  TRIS4
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPX4
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRIS4-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine solves for a non-zero eigenvector corresponding
C     to the zero eigenvalue of the transpose of the rank
C     deficient ONE matrix with subdiagonal A, diagonal B, and
C     superdiagonal C , with A(1) in the (1,N) position, with
C     C(N) in the (N,1) position, AND all other elements zero.
C
C***SEE ALSO  SEPX4
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRIS4
C
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,D(*)       ,
     1                U(*)       ,Z(*)
C***FIRST EXECUTABLE STATEMENT  TRIS4
      BN = B(N)
      D(1) = A(2)/B(1)
      V = A(1)
      U(1) = C(N)/B(1)
      NM2 = N-2
      DO  10 J=2,NM2
         DEN = B(J)-C(J-1)*D(J-1)
         D(J) = A(J+1)/DEN
         U(J) = -C(J-1)*U(J-1)/DEN
         BN = BN-V*U(J-1)
         V = -V*D(J-1)
   10 CONTINUE
      DEN = B(N-1)-C(N-2)*D(N-2)
      D(N-1) = (A(N)-C(N-2)*U(N-2))/DEN
      AN = C(N-1)-V*D(N-2)
      BN = BN-V*U(N-2)
      DEN = BN-AN*D(N-1)
C
C     SET LAST COMPONENT EQUAL TO ONE
C
      Z(N) = 1.0
      Z(N-1) = -D(N-1)
      NM1 = N-1
      DO  20 J=2,NM1
         K = N-J
         Z(K) = -D(K)*Z(K+1)-U(K)*Z(N)
   20 CONTINUE
      RETURN
      END
*DECK TRISP
      SUBROUTINE TRISP (N, A, B, C, D, U, Z)
C***BEGIN PROLOGUE  TRISP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPELI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRISP-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine solves for a non-zero eigenvector corresponding
C     to the zero eigenvalue of the transpose of the rank
C     deficient ONE matrix with subdiagonal A, diagonal B, and
C     superdiagonal C , with A(1) in the (1,N) position, with
C     C(N) in the (N,1) position, and all other elements zero.
C
C***SEE ALSO  SEPELI
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRISP
C
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,D(*)       ,
     1                U(*)       ,Z(*)
C***FIRST EXECUTABLE STATEMENT  TRISP
      BN = B(N)
      D(1) = A(2)/B(1)
      V = A(1)
      U(1) = C(N)/B(1)
      NM2 = N-2
      DO  10 J=2,NM2
         DEN = B(J)-C(J-1)*D(J-1)
         D(J) = A(J+1)/DEN
         U(J) = -C(J-1)*U(J-1)/DEN
         BN = BN-V*U(J-1)
         V = -V*D(J-1)
   10 CONTINUE
      DEN = B(N-1)-C(N-2)*D(N-2)
      D(N-1) = (A(N)-C(N-2)*U(N-2))/DEN
      AN = C(N-1)-V*D(N-2)
      BN = BN-V*U(N-2)
      DEN = BN-AN*D(N-1)
C
C     SET LAST COMPONENT EQUAL TO ONE
C
      Z(N) = 1.0
      Z(N-1) = -D(N-1)
      NM1 = N-1
      DO  20 J=2,NM1
         K = N-J
         Z(K) = -D(K)*Z(K+1)-U(K)*Z(N)
   20 CONTINUE
      RETURN
      END
*DECK TRIX
      SUBROUTINE TRIX (IDEGBR, IDEGCR, M, A, B, C, Y, TCOS, D, W)
C***BEGIN PROLOGUE  TRIX
C***SUBSIDIARY
C***PURPOSE  Subsidiary to GENBUN
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRIX-S, CMPTRX-C)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     Subroutine to solve a system of linear equations where the
C     coefficient matrix is a rational function in the matrix given by
C     TRIDIAGONAL  ( . . . , A(I), B(I), C(I), . . . ).
C
C***SEE ALSO  GENBUN
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRIX
C
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,Y(*)       ,
     1                TCOS(*)    ,D(*)       ,W(*)
      INTEGER KB, KC
C***FIRST EXECUTABLE STATEMENT  TRIX
      MM1 = M-1
      KB = IDEGBR+1
      KC = IDEGCR+1
      L = (IDEGBR+1)/(IDEGCR+1)
      LINT = 1
      DO 108 K=1,IDEGBR
         X = TCOS(K)
         IF (K .NE. L) GO TO 102
         I = IDEGBR+LINT
         XX = X-TCOS(I)
         DO 101 I=1,M
            W(I) = Y(I)
            Y(I) = XX*Y(I)
  101    CONTINUE
  102    CONTINUE
         Z = 1./(B(1)-X)
         D(1) = C(1)*Z
         Y(1) = Y(1)*Z
         DO 103 I=2,MM1
            Z = 1./(B(I)-X-A(I)*D(I-1))
            D(I) = C(I)*Z
            Y(I) = (Y(I)-A(I)*Y(I-1))*Z
  103    CONTINUE
         Z = B(M)-X-A(M)*D(MM1)
         IF (Z .NE. 0.) GO TO 104
         Y(M) = 0.
         GO TO 105
  104    Y(M) = (Y(M)-A(M)*Y(MM1))/Z
  105    CONTINUE
         DO 106 IP=1,MM1
            I = M-IP
            Y(I) = Y(I)-D(I)*Y(I+1)
  106    CONTINUE
         IF (K .NE. L) GO TO 108
         DO 107 I=1,M
            Y(I) = Y(I)+W(I)
  107    CONTINUE
         LINT = LINT+1
         L = (LINT*KB)/KC
  108 CONTINUE
      RETURN
      END
*DECK TSTURM
      SUBROUTINE TSTURM (NM, N, EPS1, D, E, E2, LB, UB, MM, M, W, Z,
     +   IERR, RV1, RV2, RV3, RV4, RV5, RV6)
C***BEGIN PROLOGUE  TSTURM
C***PURPOSE  Find those eigenvalues of a symmetric tridiagonal matrix
C            in a given interval and their associated eigenvectors by
C            Sturm sequencing.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TSTURM-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine finds those eigenvalues of a TRIDIAGONAL
C     SYMMETRIC matrix which lie in a specified interval and their
C     associated eigenvectors, using bisection and inverse iteration.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        EPS1 is an absolute error tolerance for the computed eigen-
C          values.  It should be chosen so that the accuracy of these
C          eigenvalues is commensurate with relative perturbations of
C          the order of the relative machine precision in the matrix
C          elements.  If the input EPS1 is non-positive, it is reset
C          for each submatrix to a default value, namely, minus the
C          product of the relative machine precision and the 1-norm of
C          the submatrix.  EPS1 is a REAL variable.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2(1) is arbitrary.  E2 is a one-dimensional REAL array,
C          dimensioned E2(N).
C
C        LB and UB define the interval to be searched for eigenvalues.
C          If LB is not less than UB, no eigenvalues will be found.
C          LB and UB are REAL variables.
C
C        MM should be set to an upper bound for the number of
C          eigenvalues in the interval.  MM is an INTEGER variable.
C          WARNING -  If more than MM eigenvalues are determined to lie
C          in the interval, an error return is made with no values or
C          vectors found.
C
C     On Output
C
C        EPS1 is unaltered unless it has been reset to its
C          (last) default value.
C
C        D and E are unaltered.
C
C        Elements of E2, corresponding to elements of E regarded as
C          negligible, have been replaced by zero causing the matrix to
C          split into a direct sum of submatrices.  E2(1) is also set
C          to zero.
C
C        M is the number of eigenvalues determined to lie in (LB,UB).
C          M is an INTEGER variable.
C
C        W contains the M eigenvalues in ascending order if the matrix
C          does not split.  If the matrix splits, the eigenvalues are
C          in ascending order for each submatrix.  If a vector error
C          exit is made, W contains those values already found.  W is a
C          one-dimensional REAL array, dimensioned W(MM).
C
C        Z contains the associated set of orthonormal eigenvectors.
C          If an error exit is made, Z contains those vectors already
C          found.  Z is a one-dimensional REAL array, dimensioned
C          Z(NM,MM).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          3*N+1      if M exceeds MM no eigenvalues or eigenvectors
C                     are computed,
C          4*N+J      if the eigenvector corresponding to the J-th
C                     eigenvalue fails to converge in 5 iterations, then
C                     the eigenvalues and eigenvectors in W and Z should
C                     be correct for indices 1, 2, ..., J-1.
C
C        RV1, RV2, RV3, RV4, RV5, and RV6 are temporary storage arrays,
C          dimensioned RV1(N), RV2(N), RV3(N), RV4(N), RV5(N), and
C          RV6(N).
C
C     The ALGOL procedure STURMCNT contained in TRISTURM
C     appears in TSTURM in-line.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TSTURM
C
      INTEGER I,J,K,M,N,P,Q,R,S,II,IP,JJ,MM,M1,M2,NM,ITS
      INTEGER IERR,GROUP,ISTURM
      REAL D(*),E(*),E2(*),W(*),Z(NM,*)
      REAL RV1(*),RV2(*),RV3(*),RV4(*),RV5(*),RV6(*)
      REAL U,V,LB,T1,T2,UB,UK,XU,X0,X1,EPS1,EPS2,EPS3,EPS4
      REAL NORM,MACHEP,S1,S2
      LOGICAL FIRST
C
      SAVE FIRST, MACHEP
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  TSTURM
      IF (FIRST) THEN
         MACHEP = R1MACH(4)
      ENDIF
      FIRST = .FALSE.
C
      IERR = 0
      T1 = LB
      T2 = UB
C     .......... LOOK FOR SMALL SUB-DIAGONAL ENTRIES ..........
      DO 40 I = 1, N
         IF (I .EQ. 1) GO TO 20
         S1 = ABS(D(I)) + ABS(D(I-1))
         S2 = S1 + ABS(E(I))
         IF (S2 .GT. S1) GO TO 40
   20    E2(I) = 0.0E0
   40 CONTINUE
C     .......... DETERMINE THE NUMBER OF EIGENVALUES
C                IN THE INTERVAL ..........
      P = 1
      Q = N
      X1 = UB
      ISTURM = 1
      GO TO 320
   60 M = S
      X1 = LB
      ISTURM = 2
      GO TO 320
   80 M = M - S
      IF (M .GT. MM) GO TO 980
      Q = 0
      R = 0
C     .......... ESTABLISH AND PROCESS NEXT SUBMATRIX, REFINING
C                INTERVAL BY THE GERSCHGORIN BOUNDS ..........
  100 IF (R .EQ. M) GO TO 1001
      P = Q + 1
      XU = D(P)
      X0 = D(P)
      U = 0.0E0
C
      DO 120 Q = P, N
         X1 = U
         U = 0.0E0
         V = 0.0E0
         IF (Q .EQ. N) GO TO 110
         U = ABS(E(Q+1))
         V = E2(Q+1)
  110    XU = MIN(D(Q)-(X1+U),XU)
         X0 = MAX(D(Q)+(X1+U),X0)
         IF (V .EQ. 0.0E0) GO TO 140
  120 CONTINUE
C
  140 X1 = MAX(ABS(XU),ABS(X0)) * MACHEP
      IF (EPS1 .LE. 0.0E0) EPS1 = -X1
      IF (P .NE. Q) GO TO 180
C     .......... CHECK FOR ISOLATED ROOT WITHIN INTERVAL ..........
      IF (T1 .GT. D(P) .OR. D(P) .GE. T2) GO TO 940
      R = R + 1
C
      DO 160 I = 1, N
  160 Z(I,R) = 0.0E0
C
      W(R) = D(P)
      Z(P,R) = 1.0E0
      GO TO 940
  180 X1 = X1 * (Q-P+1)
      LB = MAX(T1,XU-X1)
      UB = MIN(T2,X0+X1)
      X1 = LB
      ISTURM = 3
      GO TO 320
  200 M1 = S + 1
      X1 = UB
      ISTURM = 4
      GO TO 320
  220 M2 = S
      IF (M1 .GT. M2) GO TO 940
C     .......... FIND ROOTS BY BISECTION ..........
      X0 = UB
      ISTURM = 5
C
      DO 240 I = M1, M2
         RV5(I) = UB
         RV4(I) = LB
  240 CONTINUE
C     .......... LOOP FOR K-TH EIGENVALUE
C                FOR K=M2 STEP -1 UNTIL M1 DO --
C                (-DO- NOT USED TO LEGALIZE -COMPUTED GO TO-) ..........
      K = M2
  250    XU = LB
C     .......... FOR I=K STEP -1 UNTIL M1 DO -- ..........
         DO 260 II = M1, K
            I = M1 + K - II
            IF (XU .GE. RV4(I)) GO TO 260
            XU = RV4(I)
            GO TO 280
  260    CONTINUE
C
  280    IF (X0 .GT. RV5(K)) X0 = RV5(K)
C     .......... NEXT BISECTION STEP ..........
  300    X1 = (XU + X0) * 0.5E0
         S1 = 2.0E0*(ABS(XU) + ABS(X0) + ABS(EPS1))
         S2 = S1 + ABS(X0 - XU)
         IF (S2 .EQ. S1) GO TO 420
C     .......... IN-LINE PROCEDURE FOR STURM SEQUENCE ..........
  320    S = P - 1
         U = 1.0E0
C
         DO 340 I = P, Q
            IF (U .NE. 0.0E0) GO TO 325
            V = ABS(E(I)) / MACHEP
            IF (E2(I) .EQ. 0.0E0) V = 0.0E0
            GO TO 330
  325       V = E2(I) / U
  330       U = D(I) - X1 - V
            IF (U .LT. 0.0E0) S = S + 1
  340    CONTINUE
C
         GO TO (60,80,200,220,360), ISTURM
C     .......... REFINE INTERVALS ..........
  360    IF (S .GE. K) GO TO 400
         XU = X1
         IF (S .GE. M1) GO TO 380
         RV4(M1) = X1
         GO TO 300
  380    RV4(S+1) = X1
         IF (RV5(S) .GT. X1) RV5(S) = X1
         GO TO 300
  400    X0 = X1
         GO TO 300
C     .......... K-TH EIGENVALUE FOUND ..........
  420    RV5(K) = X1
      K = K - 1
      IF (K .GE. M1) GO TO 250
C     .......... FIND VECTORS BY INVERSE ITERATION ..........
      NORM = ABS(D(P))
      IP = P + 1
C
      DO 500 I = IP, Q
  500 NORM = MAX(NORM, ABS(D(I)) + ABS(E(I)))
C     .......... EPS2 IS THE CRITERION FOR GROUPING,
C                EPS3 REPLACES ZERO PIVOTS AND EQUAL
C                ROOTS ARE MODIFIED BY EPS3,
C                EPS4 IS TAKEN VERY SMALL TO AVOID OVERFLOW ..........
      EPS2 = 1.0E-3 * NORM
      UK = SQRT(REAL(Q-P+5))
      EPS3 = UK * MACHEP * NORM
      EPS4 = UK * EPS3
      UK = EPS4 / SQRT(UK)
      GROUP = 0
      S = P
C
      DO 920 K = M1, M2
         R = R + 1
         ITS = 1
         W(R) = RV5(K)
         X1 = RV5(K)
C     .......... LOOK FOR CLOSE OR COINCIDENT ROOTS ..........
         IF (K .EQ. M1) GO TO 520
         IF (X1 - X0 .GE. EPS2) GROUP = -1
         GROUP = GROUP + 1
         IF (X1 .LE. X0) X1 = X0 + EPS3
C     .......... ELIMINATION WITH INTERCHANGES AND
C                INITIALIZATION OF VECTOR ..........
  520    V = 0.0E0
C
         DO 580 I = P, Q
            RV6(I) = UK
            IF (I .EQ. P) GO TO 560
            IF (ABS(E(I)) .LT. ABS(U)) GO TO 540
            XU = U / E(I)
            RV4(I) = XU
            RV1(I-1) = E(I)
            RV2(I-1) = D(I) - X1
            RV3(I-1) = 0.0E0
            IF (I .NE. Q) RV3(I-1) = E(I+1)
            U = V - XU * RV2(I-1)
            V = -XU * RV3(I-1)
            GO TO 580
  540       XU = E(I) / U
            RV4(I) = XU
            RV1(I-1) = U
            RV2(I-1) = V
            RV3(I-1) = 0.0E0
  560       U = D(I) - X1 - XU * V
            IF (I .NE. Q) V = E(I+1)
  580    CONTINUE
C
         IF (U .EQ. 0.0E0) U = EPS3
         RV1(Q) = U
         RV2(Q) = 0.0E0
         RV3(Q) = 0.0E0
C     .......... BACK SUBSTITUTION
C                FOR I=Q STEP -1 UNTIL P DO -- ..........
  600    DO 620 II = P, Q
            I = P + Q - II
            RV6(I) = (RV6(I) - U * RV2(I) - V * RV3(I)) / RV1(I)
            V = U
            U = RV6(I)
  620    CONTINUE
C     .......... ORTHOGONALIZE WITH RESPECT TO PREVIOUS
C                MEMBERS OF GROUP ..........
         IF (GROUP .EQ. 0) GO TO 700
C
         DO 680 JJ = 1, GROUP
            J = R - GROUP - 1 + JJ
            XU = 0.0E0
C
            DO 640 I = P, Q
  640       XU = XU + RV6(I) * Z(I,J)
C
            DO 660 I = P, Q
  660       RV6(I) = RV6(I) - XU * Z(I,J)
C
  680    CONTINUE
C
  700    NORM = 0.0E0
C
         DO 720 I = P, Q
  720    NORM = NORM + ABS(RV6(I))
C
         IF (NORM .GE. 1.0E0) GO TO 840
C     .......... FORWARD SUBSTITUTION ..........
         IF (ITS .EQ. 5) GO TO 960
         IF (NORM .NE. 0.0E0) GO TO 740
         RV6(S) = EPS4
         S = S + 1
         IF (S .GT. Q) S = P
         GO TO 780
  740    XU = EPS4 / NORM
C
         DO 760 I = P, Q
  760    RV6(I) = RV6(I) * XU
C     .......... ELIMINATION OPERATIONS ON NEXT VECTOR
C                ITERATE ..........
  780    DO 820 I = IP, Q
            U = RV6(I)
C     .......... IF RV1(I-1) .EQ. E(I), A ROW INTERCHANGE
C                WAS PERFORMED EARLIER IN THE
C                TRIANGULARIZATION PROCESS ..........
            IF (RV1(I-1) .NE. E(I)) GO TO 800
            U = RV6(I-1)
            RV6(I-1) = RV6(I)
  800       RV6(I) = U - RV4(I) * RV6(I-1)
  820    CONTINUE
C
         ITS = ITS + 1
         GO TO 600
C     .......... NORMALIZE SO THAT SUM OF SQUARES IS
C                1 AND EXPAND TO FULL ORDER ..........
  840    U = 0.0E0
C
         DO 860 I = P, Q
  860    U = U + RV6(I)**2
C
         XU = 1.0E0 / SQRT(U)
C
         DO 880 I = 1, N
  880    Z(I,R) = 0.0E0
C
         DO 900 I = P, Q
  900    Z(I,R) = RV6(I) * XU
C
         X0 = X1
  920 CONTINUE
C
  940 IF (Q .LT. N) GO TO 100
      GO TO 1001
C     .......... SET ERROR -- NON-CONVERGED EIGENVECTOR ..........
  960 IERR = 4 * N + R
      GO TO 1001
C     .......... SET ERROR -- UNDERESTIMATE OF NUMBER OF
C                EIGENVALUES IN INTERVAL ..........
  980 IERR = 3 * N + 1
 1001 LB = T1
      UB = T2
      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_extrema_types
  use cubetools_parameters
  use cubetools_nan
  use cubetools_header_types
  use cubetools_arrelt_types
  !---------------------------------------------------------------------
  ! Support module for a dedicated type used in the context of extrema
  ! computation. As the extrema are updated at entry%put() time, there
  ! can be a race condition between tasks.
  !---------------------------------------------------------------------
  !
  type :: cubetools_extrema_t
    type(arrelt_t)       :: min   ! Minimum value
    type(arrelt_t)       :: max   ! Maximum value
    integer(kind=data_k) :: nnan  ! Number of NaN elements
  contains
    procedure, public :: init  => cubetools_extrema_init
    procedure, public :: merge => cubetools_extrema_merge
  end type cubetools_extrema_t
  !
  public :: cubetools_extrema_t
  private
  !
contains
  !
  subroutine cubetools_extrema_init(ext,head,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(cubetools_extrema_t), intent(out)   :: ext
    type(cube_header_t),        intent(in)    :: head
    logical,                    intent(inout) :: error
    !
    call cubetools_arrelt_init('Min',ext%min,error)
    if (error)  return
    call cubetools_arrelt_init('Max',ext%max,error)
    if (error)  return
    ! Ensure min%ix min%iy min%ic pointers are properly set
    call ext%min%associate(head%set%il,head%set%im,head%set%ic,error)
    if (error)  return
    call ext%max%associate(head%set%il,head%set%im,head%set%ic,error)
    if (error)  return
    !
    ext%nnan    = 0
  end subroutine cubetools_extrema_init
  !
  subroutine cubetools_extrema_merge(out,ouhead,in,error)
    !-------------------------------------------------------------------
    ! Merge a list of cubetools_extrema_t into a single one
    !-------------------------------------------------------------------
    class(cubetools_extrema_t), intent(out)   :: out
    type(cube_header_t),        intent(in)    :: ouhead
    type(cubetools_extrema_t),  intent(in)    :: in(:)
    logical,                    intent(inout) :: error
    !
    integer(kind=4) :: iext
    !
    call out%init(ouhead,error)
    !
    do iext=1,size(in)
      if (ieee_is_nan(out%min%val) .or. in(iext)%min%val.lt.out%min%val) then
        out%min = in(iext)%min
      endif
      if (ieee_is_nan(out%max%val) .or. in(iext)%max%val.gt.out%max%val) then
        out%max = in(iext)%max
      endif
      out%nnan = out%nnan + in(iext)%nnan
    enddo
  end subroutine cubetools_extrema_merge
  !
end module cubetools_extrema_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK SLLTI2
      SUBROUTINE SLLTI2 (N, B, X, NEL, IEL, JEL, EL, DINV)
C***BEGIN PROLOGUE  SLLTI2
C***PURPOSE  SLAP Backsolve routine for LDL' Factorization.
C            Routine to solve a system of the form  L*D*L' X = B,
C            where L is a unit lower triangular matrix and D is a
C            diagonal matrix and ' means transpose.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2E
C***TYPE      SINGLE PRECISION (SLLTI2-S, DLLTI2-D)
C***KEYWORDS  INCOMPLETE FACTORIZATION, ITERATIVE PRECONDITION, SLAP,
C             SPARSE, SYMMETRIC LINEAR SYSTEM SOLVE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER N, NEL, IEL(NEL), JEL(NEL)
C     REAL    B(N), X(N), EL(NEL), DINV(N)
C
C     CALL SLLTI2( N, B, X, NEL, IEL, JEL, EL, DINV )
C
C *Arguments:
C N      :IN       Integer
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right hand side vector.
C X      :OUT      Real X(N).
C         Solution to L*D*L' x = b.
C NEL    :IN       Integer.
C         Number of non-zeros in the EL array.
C IEL    :IN       Integer IEL(NEL).
C JEL    :IN       Integer JEL(NEL).
C EL     :IN       Real     EL(NEL).
C         IEL, JEL, EL contain the unit lower triangular factor   of
C         the incomplete decomposition   of the A  matrix  stored in
C         SLAP Row format.   The diagonal of ones *IS* stored.  This
C         structure can be set  up  by  the SS2LT routine.  See  the
C         "Description", below for more details about the  SLAP  Row
C         format.
C DINV   :IN       Real DINV(N).
C         Inverse of the diagonal matrix D.
C
C *Description:
C       This routine is supplied with  the SLAP package as a routine
C       to perform the MSOLVE operation in the SCG iteration routine
C       for  the driver  routine SSICCG.   It must be called via the
C       SLAP  MSOLVE calling sequence  convention  interface routine
C       SSLLI.
C         **** THIS ROUTINE ITSELF DOES NOT CONFORM TO THE ****
C               **** SLAP MSOLVE CALLING CONVENTION ****
C
C       IEL, JEL, EL should contain the unit lower triangular factor
C       of  the incomplete decomposition of  the A matrix  stored in
C       SLAP Row format.   This IC factorization  can be computed by
C       the  SSICS routine.  The  diagonal  (which is all one's) is
C       stored.
C
C       ==================== S L A P Row format ====================
C
C       This routine requires  that the matrix A  be  stored  in the
C       SLAP  Row format.   In this format  the non-zeros are stored
C       counting across  rows (except for the diagonal  entry, which
C       must appear first in each "row") and  are stored in the real
C       array A.  In other words, for each row in the matrix put the
C       diagonal entry in  A.   Then   put  in the   other  non-zero
C       elements   going  across the  row (except   the diagonal) in
C       order.   The  JA array  holds   the column   index for  each
C       non-zero.   The IA  array holds the  offsets into  the JA, A
C       arrays  for   the   beginning  of   each  row.   That    is,
C       JA(IA(IROW)),  A(IA(IROW)) points  to  the beginning  of the
C       IROW-th row in JA and A.   JA(IA(IROW+1)-1), A(IA(IROW+1)-1)
C       points to the  end of the  IROW-th row.  Note that we always
C       have IA(N+1) =  NELT+1, where  N  is  the number of rows  in
C       the matrix  and NELT  is the  number   of  non-zeros in  the
C       matrix.
C
C       Here is an example of the SLAP Row storage format for a  5x5
C       Matrix (in the A and JA arrays '|' denotes the end of a row):
C
C           5x5 Matrix         SLAP Row format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 12 15 | 22 21 | 33 35 | 44 | 55 51 53
C       |21 22  0  0  0|  JA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  IA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       With  the SLAP  Row format  the "inner loop" of this routine
C       should vectorize   on machines with   hardware  support  for
C       vector gather/scatter operations.  Your compiler may require
C       a  compiler directive  to  convince   it that there  are  no
C       implicit vector  dependencies.  Compiler directives  for the
C       Alliant FX/Fortran and CRI CFT/CFT77 compilers  are supplied
C       with the standard SLAP distribution.
C
C***SEE ALSO  SSICCG, SSICS
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   920511  Added complete declaration section.  (WRB)
C   921113  Corrected C***CATEGORY line.  (FNF)
C   930701  Updated CATEGORY section.  (FNF, WRB)
C***END PROLOGUE  SLLTI2
C     .. Scalar Arguments ..
      INTEGER N, NEL
C     .. Array Arguments ..
      REAL B(N), DINV(N), EL(NEL), X(N)
      INTEGER IEL(NEL), JEL(NEL)
C     .. Local Scalars ..
      INTEGER I, IBGN, IEND, IROW
C***FIRST EXECUTABLE STATEMENT  SLLTI2
C
C         Solve  L*y = b,  storing result in x.
C
      DO 10 I=1,N
         X(I) = B(I)
 10   CONTINUE
      DO 30 IROW = 1, N
         IBGN = IEL(IROW) + 1
         IEND = IEL(IROW+1) - 1
         IF( IBGN.LE.IEND ) THEN
CLLL. OPTION ASSERT (NOHAZARD)
CDIR$ IVDEP
CVD$ NOCONCUR
CVD$ NODEPCHK
            DO 20 I = IBGN, IEND
               X(IROW) = X(IROW) - EL(I)*X(JEL(I))
 20         CONTINUE
         ENDIF
 30   CONTINUE
C
C         Solve  D*Z = Y,  storing result in X.
C
      DO 40 I=1,N
         X(I) = X(I)*DINV(I)
 40   CONTINUE
C
C         Solve  L-trans*X = Z.
C
      DO 60 IROW = N, 2, -1
         IBGN = IEL(IROW) + 1
         IEND = IEL(IROW+1) - 1
         IF( IBGN.LE.IEND ) THEN
CLLL. OPTION ASSERT (NOHAZARD)
CDIR$ IVDEP
CVD$ NOCONCUR
CVD$ NODEPCHK
            DO 50 I = IBGN, IEND
               X(JEL(I)) = X(JEL(I)) - EL(I)*X(IROW)
 50         CONTINUE
         ENDIF
 60   CONTINUE
C
      RETURN
C------------- LAST LINE OF SLLTI2 FOLLOWS ----------------------------
      END
*DECK SLPDOC
      SUBROUTINE SLPDOC
C***BEGIN PROLOGUE  SLPDOC
C***PURPOSE  Sparse Linear Algebra Package Version 2.0.2 Documentation.
C            Routines to solve large sparse symmetric and nonsymmetric
C            positive definite linear systems, Ax = b, using precondi-
C            tioned iterative methods.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4, Z
C***TYPE      SINGLE PRECISION (SLPDOC-S, DLPDOC-D)
C***KEYWORDS  BICONJUGATE GRADIENT SQUARED, DOCUMENTATION,
C             GENERALIZED MINIMUM RESIDUAL, ITERATIVE IMPROVEMENT,
C             NORMAL EQUATIONS, ORTHOMIN,
C             PRECONDITIONED CONJUGATE GRADIENT, SLAP,
C             SPARSE ITERATIVE METHODS
C***AUTHOR  Seager, Mark. K., (LLNL)
C             User Systems Division
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550
C             (FTS) 543-3141, (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C                                 The
C                    Sparse Linear Algebra Package
C
C                @@@@@@@  @            @@@    @@@@@@@@
C               @       @ @           @   @   @       @
C               @         @          @     @  @       @
C                @@@@@@@  @         @       @ @@@@@@@@
C                       @ @         @@@@@@@@@ @
C               @       @ @         @       @ @
C                @@@@@@@  @@@@@@@@@ @       @ @
C
C      @       @                            @@@@@@@        @@@@@
C      @       @                           @       @      @    @@
C      @       @  @@@@@@@  @ @@                    @     @    @  @
C      @       @ @       @ @@  @             @@@@@@      @   @   @
C       @     @  @@@@@@@@@ @                @            @  @    @
C        @   @   @         @               @         @@@  @@    @
C         @@@     @@@@@@@  @               @@@@@@@@@ @@@   @@@@@
C
C
C    =================================================================
C    ========================== Introduction =========================
C    =================================================================
C      This package was  originally derived from a set of  iterative
C      routines written by Anne Greenbaum, as announced in "Routines
C      for Solving Large Sparse Linear Systems",  Tentacle, Lawrence
C      Livermore  National  Laboratory,  Livermore  Computing Center
C      (January 1986), pp 15-21.
C
C    This document  contains the specifications for  the  SLAP Version
C    2.0 package, a Fortran 77  package  for  the  solution  of  large
C    sparse   linear systems, Ax  =  b,  via  preconditioned iterative
C    methods.   Included in  this  package are "core"  routines  to do
C    Iterative   Refinement  (Jacobi's  method),  Conjugate  Gradient,
C    Conjugate Gradient on the normal equations, AA'y = b,  (where x =
C    A'y and  A' denotes the  transpose of   A), BiConjugate Gradient,
C    BiConjugate  Gradient  Squared, Orthomin and  Generalized Minimum
C    Residual Iteration.    These "core" routines   do  not  require a
C    "fixed"   data  structure   for storing  the   matrix  A  and the
C    preconditioning   matrix  M.   The  user  is free  to  choose any
C    structure that facilitates  efficient solution  of the problem at
C    hand.  The drawback  to this approach  is that the user must also
C    supply at least two routines  (MATVEC and MSOLVE,  say).   MATVEC
C    must calculate, y = Ax, given x and the user's data structure for
C    A.  MSOLVE must solve,  r = Mz, for z (*NOT*  r) given r  and the
C    user's data  structure for  M (or its  inverse).  The user should
C    choose M so that  inv(M)*A  is approximately the identity and the
C    solution step r = Mz is "easy" to  solve.  For some of the "core"
C    routines (Orthomin,  BiConjugate Gradient and  Conjugate Gradient
C    on the  normal equations)   the user must  also  supply  a matrix
C    transpose times   vector  routine  (MTTVEC,  say)  and (possibly,
C    depending    on the "core"  method)   a  routine  that solves the
C    transpose  of   the   preconditioning    step     (MTSOLV,  say).
C    Specifically, MTTVEC is a routine which calculates y = A'x, given
C    x and the user's data structure for A (A' is the transpose of A).
C    MTSOLV is a routine which solves the system r = M'z for z given r
C    and the user's data structure for M.
C
C    This process of writing the matrix vector operations  can be time
C    consuming and error  prone.  To alleviate  these problems we have
C    written drivers   for  the  "core" methods  that  assume the user
C    supplies one of two specific data structures (SLAP Triad and SLAP
C    Column format), see  below.  Utilizing these  data structures  we
C    have augmented   each  "core" method  with   two preconditioners:
C    Diagonal  Scaling and Incomplete Factorization.  Diagonal scaling
C    is easy to implement, vectorizes very  well and for problems that
C    are  not too  ill-conditioned  reduces the  number  of iterations
C    enough   to warrant its use.  On   the other  hand, an Incomplete
C    factorization  (Incomplete  Cholesky for  symmetric systems   and
C    Incomplete LU for nonsymmetric  systems) may  take much longer to
C    calculate, but it reduces the iteration count (for most problems)
C    significantly.  Our implementations  of IC and ILU  vectorize for
C    machines with hardware gather scatter, but the vector lengths can
C    be quite short if  the  number  of non-zeros  in a column is  not
C    large.
C
C    =================================================================
C    ==================== Supplied Data Structures ===================
C    =================================================================
C    The following describes the data   structures supplied  with  the
C    package: SLAP Triad and Column formats.
C
C    ====================== S L A P Triad format =====================
C
C    In the SLAP Triad format only the non-zeros are stored.  They may
C    appear in *ANY* order.  The user supplies three  arrays of length
C    NELT, where NELT  is the   number of  non-zeros  in the   matrix:
C    (IA(NELT),  JA(NELT), A(NELT)).  If  the matrix is symmetric then
C    one need only store the lower triangle (including  the  diagonal)
C    and NELT would be the corresponding  number  of non-zeros stored.
C    For each non-zero the user puts the row and column  index of that
C    matrix  element   in the  IA  and JA  arrays.  The  value  of the
C    non-zero matrix element is placed  in  the corresponding location
C    of  the A array.   This  is an extremely  easy  data structure to
C    generate.  On the other hand, it is not very  efficient on vector
C    computers for the iterative  solution of  linear systems.  Hence,
C    SLAP changes this input data structure to  the SLAP Column format
C    for the iteration (but does not change it back).
C
C    Here  is an example   of  the  SLAP  Triad storage  format  for a
C    nonsymmetric 5x5 Matrix.  NELT=11.   Recall that the  entries may
C    appear in any order.
C
C     5x5 Matrix       SLAP Triad format for 5x5 matrix on left.
C                           1  2  3  4  5  6  7  8  9 10 11
C    |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C    |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C    | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C    | 0  0  0 44  0|
C    |51  0 53  0 55|
C
C    ====================== S L A P Column format ====================
C
C    In the SLAP Column format  the non-zeros are stored counting down
C    columns (except for the  diagonal entry,  which must appear first
C    in each "column") and are stored  in the real array A.   In other
C    words, for each column in the matrix first put the diagonal entry
C    in A.   Then put in  the other non-zero  elements going  down the
C    column (except the  diagonal) in order.   The IA  array holds the
C    row index for each non-zero.  The JA array holds the offsets into
C    the  IA,  A arrays for the  beginning  of each column.   That is,
C    IA(JA(ICOL)), A(JA(ICOL)) are the  first elements of the  ICOL-th
C    column in IA   and A.  IA(JA(ICOL+1)-1),  A(JA(ICOL+1)-1) are the
C    last elements  of  the ICOL-th column.   Note that we always have
C    JA(N+1) = NELT+1, where N is the number of  columns in the matrix
C    and NELT is the number of non-zeros in the matrix.  If the matrix
C    is  symmetric one need  only store the  lower triangle (including
C    the diagonal) and  NELT  would be the   corresponding   number of
C    non-zeros stored.
C
C    Here is  an  example of the  SLAP   Column storage format  for  a
C    nonsymmetric 5x5 Matrix (in the  A and  IA arrays '|' denotes the
C    end of a column):
C
C       5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                           1  2  3    4  5    6  7    8    9 10 11
C    |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C    |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C    | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C    | 0  0  0 44  0|
C    |51  0 53  0 55|
C
C    =================================================================
C    ====================== Which Method To Use ======================
C    =================================================================
C
C                          BACKGROUND
C    In solving a large sparse linear system Ax = b using an iterative
C    method, it   is  not necessary to actually   store  the matrix A.
C    Rather, what is needed is a procedure  for multiplying the matrix
C    A times a given vector y to obtain the matrix-vector product, Ay.
C    SLAP has been written to take advantage of this fact.  The higher
C    level routines in the package require storage only of the non-zero
C    elements of   A (and  their  positions), and  even this   can  be
C    avoided, if the  user  writes his own subroutine for  multiplying
C    the matrix times a vector  and   calls the lower-level  iterative
C    routines in the package.
C
C    If  the matrix A is ill-conditioned,  then most iterative methods
C    will be slow to converge (if they converge  at all!).  To improve
C    the  convergence  rate,  one  may use  a "matrix  splitting," or,
C    "preconditioning matrix," say, M.  It is then necessary to solve,
C    at each iteration, a linear system  with coefficient matrix M.  A
C    good preconditioner  M should have  two  properties: (1) M should
C    "approximate" A, in the sense that the  matrix inv(M)*A  (or some
C    variant  thereof) is better conditioned  than the original matrix
C    A; and  (2) linear  systems with coefficient  matrix M should  be
C    much easier  to solve  than  the original system with coefficient
C    matrix   A.   Preconditioning routines  in the   SLAP package are
C    separate from the  iterative   routines,  so   that any of    the
C    preconditioners provided in the package,   or one that the   user
C    codes himself, can be used with any of the iterative routines.
C
C                        CHOICE OF PRECONDITIONER
C    If you  willing   to live with   either the SLAP Triad or  Column
C    matrix data structure  you  can then  choose one  of two types of
C    preconditioners   to   use:   diagonal  scaling    or  incomplete
C    factorization.  To  choose   between these two   methods requires
C    knowing  something  about the computer you're going  to run these
C    codes on  and how well incomplete factorization  approximates the
C    inverse of your matrix.
C
C    Let us  suppose you have   a scalar  machine.   Then,  unless the
C    incomplete factorization is very,  very poor this  is *GENERALLY*
C    the method to choose.  It  will reduce the  number of  iterations
C    significantly and is not all  that expensive  to compute.  So  if
C    you have just one  linear system to solve  and  "just want to get
C    the job  done" then try  incomplete factorization first.   If you
C    are thinking of integrating some SLAP  iterative method into your
C    favorite   "production  code" then  try incomplete  factorization
C    first,  but  also check  to see that  diagonal  scaling is indeed
C    slower for a large sample of test problems.
C
C    Let us now suppose  you have  a  vector  computer  with  hardware
C    gather/scatter support (Cray X-MP, Y-MP, SCS-40 or Cyber 205, ETA
C    10,  ETA Piper,  Convex C-1,  etc.).   Then  it is much harder to
C    choose  between the  two  methods.   The  versions  of incomplete
C    factorization in SLAP do in fact vectorize, but have short vector
C    lengths and the factorization step is relatively  more expensive.
C    Hence,  for  most problems (i.e.,  unless  your  problem  is  ill
C    conditioned,  sic!)  diagonal  scaling is  faster,  with its very
C    fast    set up  time    and  vectorized  (with   long    vectors)
C    preconditioning step (even though  it  may take more iterations).
C    If you have several systems (or  right hand sides) to  solve that
C    can  utilize  the  same  preconditioner  then the   cost   of the
C    incomplete factorization can   be  amortized over these  several
C    solutions.  This situation gives more advantage to the incomplete
C    factorization methods.  If  you have  a  vector  machine  without
C    hardware  gather/scatter (Cray  1,  Cray  2  &  Cray 3) then  the
C    advantages for incomplete factorization are even less.
C
C    If you're trying to shoehorn SLAP into your  favorite "production
C    code" and can not easily generate either the SLAP Triad or Column
C    format  then  you are  left  to   your  own  devices in terms  of
C    preconditioning.  Also,  you may  find that the   preconditioners
C    supplied with SLAP are not sufficient  for your problem.  In this
C    situation we would  recommend  that you   talk  with a  numerical
C    analyst  versed in   iterative   methods   about   writing  other
C    preconditioning  subroutines (e.g.,  polynomial  preconditioning,
C    shifted incomplete factorization,  SOR  or SSOR  iteration).  You
C    can always "roll your own"  by using the "core" iterative methods
C    and supplying your own MSOLVE and MATVEC (and possibly MTSOLV and
C    MTTVEC) routines.
C
C                          SYMMETRIC SYSTEMS
C    If your matrix is symmetric then you would want to use one of the
C    symmetric system  solvers.    If  your  system  is  also positive
C    definite,   (Ax,x) (Ax dot  product  with x) is  positive for all
C    non-zero  vectors x,  then use   Conjugate Gradient (SCG,  SSDCG,
C    SSICSG).  If you're  not sure it's SPD   (symmetric and  Positive
C    Definite)  then try SCG anyway and  if it works, fine.  If you're
C    sure your matrix is not  positive definite  then you  may want to
C    try the iterative refinement   methods  (SIR)  or the  GMRES code
C    (SGMRES) if SIR converges too slowly.
C
C                         NONSYMMETRIC SYSTEMS
C    This   is currently  an  area  of  active research  in  numerical
C    analysis  and   there   are   new  strategies  being   developed.
C    Consequently take the following advice with a grain of salt.   If
C    you matrix is positive definite, (Ax,x)  (Ax  dot product  with x
C    is positive for all non-zero  vectors x), then you can use any of
C    the    methods   for   nonsymmetric   systems (Orthomin,   GMRES,
C    BiConjugate Gradient, BiConjugate Gradient  Squared and Conjugate
C    Gradient applied to the normal equations).  If your system is not
C    too ill conditioned then try  BiConjugate Gradient Squared (BCGS)
C    or GMRES (SGMRES).  Both  of  these methods converge very quickly
C    and do  not require A'  or M' ('  denotes transpose) information.
C    SGMRES  does require  some  additional storage,  though.  If  the
C    system is very  ill conditioned  or   nearly positive  indefinite
C    ((Ax,x) is positive,  but may be  very small),  then GMRES should
C    be the first choice,  but try the  other  methods  if you have to
C    fine tune  the solution process for a  "production code".  If you
C    have a great preconditioner for the normal  equations (i.e., M is
C    an approximation to the inverse of AA' rather than  just  A) then
C    this is not a bad route to travel.  Old wisdom would say that the
C    normal equations are a disaster  (since it squares the  condition
C    number of the system and SCG convergence is linked to this number
C    of    infamy), but   some     preconditioners    (like incomplete
C    factorization) can reduce the condition number back below that of
C    the original system.
C
C    =================================================================
C    ======================= Naming Conventions ======================
C    =================================================================
C    SLAP  iterative  methods,    matrix vector    and  preconditioner
C    calculation  routines   follow a naming   convention  which, when
C    understood, allows one to determine the iterative method and data
C    structure(s) used.  The  subroutine  naming convention  takes the
C    following form:
C                          P[S][M]DESC
C    where
C        P  stands for the precision (or data type) of the routine and
C           is required in all names,
C        S  denotes whether or not the routine requires the SLAP Triad
C           or Column format (it does if the second letter of the name
C           is S and does not otherwise),
C        M  stands for the type of preconditioner used (only appears
C           in drivers for "core" routines), and
C     DESC  is some number of letters describing the method or purpose
C           of the routine.  The following is a list of the "DESC"
C           fields for iterative methods and their meaning:
C             BCG,BC:       BiConjugate Gradient
C             CG:           Conjugate Gradient
C             CGN,CN:       Conjugate Gradient on the Normal equations
C             CGS,CS:       biConjugate Gradient Squared
C             GMRES,GMR,GM: Generalized Minimum RESidual
C             IR,R:         Iterative Refinement
C             JAC:          JACobi's method
C             GS:           Gauss-Seidel
C             OMN,OM:       OrthoMiN
C
C    In the single precision version of SLAP, all routine names start
C    with an S. The brackets around the S and M designate that these
C    fields are optional.
C
C    Here are some examples of the routines:
C    1) SBCG: Single precision BiConjugate Gradient "core" routine.
C       One can deduce that this is a "core" routine, because the S and
C       M fields are missing and BiConjugate Gradient is an iterative
C       method.
C    2) SSDBCG: Single precision, SLAP data structure BCG with Diagonal
C       scaling.
C    3) SSLUBC: Single precision, SLAP data structure BCG with incom-
C       plete LU factorization as the preconditioning.
C    4) SCG: Single precision Conjugate Gradient "core" routine.
C    5) SSDCG: Single precision, SLAP data structure Conjugate Gradient
C       with Diagonal scaling.
C    6) SSICCG: Single precision, SLAP data structure Conjugate Gra-
C       dient with Incomplete Cholesky factorization preconditioning.
C
C
C    =================================================================
C    ===================== USER CALLABLE ROUTINES ====================
C    =================================================================
C    The following is a list of  the "user callable" SLAP routines and
C    their one line descriptions.  The headers denote  the  file names
C    where the routines can be found, as distributed for UNIX systems.
C
C    Note:  Each core routine, SXXX, has a corresponding stop routine,
C         ISSXXX.  If the stop routine does not have the specific stop
C         test the user requires (e.g., weighted infinity norm),  then
C         the user should modify the source for ISSXXX accordingly.
C
C    ============================= sir.f =============================
C    SIR: Preconditioned Iterative Refinement Sparse Ax = b Solver.
C    SSJAC: Jacobi's Method Iterative Sparse Ax = b Solver.
C    SSGS: Gauss-Seidel Method Iterative Sparse Ax = b Solver.
C    SSILUR: Incomplete LU Iterative Refinement Sparse Ax = b Solver.
C
C    ============================= scg.f =============================
C    SCG: Preconditioned Conjugate Gradient Sparse Ax=b Solver.
C    SSDCG: Diagonally Scaled Conjugate Gradient Sparse Ax=b Solver.
C    SSICCG: Incomplete Cholesky Conjugate Gradient Sparse Ax=b Solver.
C
C    ============================= scgn.f ============================
C    SCGN: Preconditioned CG Sparse Ax=b Solver for Normal Equations.
C    SSDCGN: Diagonally Scaled CG Sparse Ax=b Solver for Normal Eqn's.
C    SSLUCN: Incomplete LU CG Sparse Ax=b Solver for Normal Equations.
C
C    ============================= sbcg.f ============================
C    SBCG: Preconditioned BiConjugate Gradient Sparse Ax = b Solver.
C    SSDBCG: Diagonally Scaled BiConjugate Gradient Sparse Ax=b Solver.
C    SSLUBC: Incomplete LU BiConjugate Gradient Sparse Ax=b Solver.
C
C    ============================= scgs.f ============================
C    SCGS: Preconditioned BiConjugate Gradient Squared Ax=b Solver.
C    SSDCGS: Diagonally Scaled CGS Sparse Ax=b Solver.
C    SSLUCS: Incomplete LU BiConjugate Gradient Squared Ax=b Solver.
C
C    ============================= somn.f ============================
C    SOMN: Preconditioned Orthomin Sparse Iterative Ax=b Solver.
C    SSDOMN: Diagonally Scaled Orthomin Sparse Iterative Ax=b Solver.
C    SSLUOM: Incomplete LU Orthomin Sparse Iterative Ax=b Solver.
C
C    ============================ sgmres.f ===========================
C    SGMRES: Preconditioned GMRES Iterative Sparse Ax=b Solver.
C    SSDGMR: Diagonally Scaled GMRES Iterative Sparse Ax=b Solver.
C    SSLUGM: Incomplete LU GMRES Iterative Sparse Ax=b Solver.
C
C    ============================ smset.f ============================
C       The following routines are used to set up preconditioners.
C
C    SSDS: Diagonal Scaling Preconditioner SLAP Set Up.
C    SSDSCL: Diagonally Scales/Unscales a SLAP Column Matrix.
C    SSD2S: Diagonal Scaling Preconditioner SLAP Normal Eqns Set Up.
C    SS2LT: Lower Triangle Preconditioner SLAP Set Up.
C    SSICS: Incomplete Cholesky Decomp. Preconditioner SLAP Set Up.
C    SSILUS: Incomplete LU Decomposition Preconditioner SLAP Set Up.
C
C    ============================ smvops.f ===========================
C       Most of the incomplete  factorization  (LL' and LDU) solvers
C       in this  file require an  intermediate routine  to translate
C       from the SLAP MSOLVE(N, R, Z, NELT, IA,  JA, A, ISYM, RWORK,
C       IWORK) calling  convention to the calling  sequence required
C       by  the solve routine.   This generally  is  accomplished by
C       fishing out pointers to the preconditioner (stored in RWORK)
C       from the  IWORK  array and then making a call to the routine
C       that actually does the backsolve.
C
C    SSMV: SLAP Column Format Sparse Matrix Vector Product.
C    SSMTV: SLAP Column Format Sparse Matrix (transpose) Vector Prod.
C    SSDI: Diagonal Matrix Vector Multiply.
C    SSLI: SLAP MSOLVE for Lower Triangle Matrix (set up for SSLI2).
C    SSLI2: Lower Triangle Matrix Backsolve.
C    SSLLTI: SLAP MSOLVE for LDL' (IC) Fact. (set up for SLLTI2).
C    SLLTI2: Backsolve routine for LDL' Factorization.
C    SSLUI: SLAP MSOLVE for LDU Factorization (set up for SSLUI2).
C    SSLUI2: SLAP Backsolve for LDU Factorization.
C    SSLUTI: SLAP MTSOLV for LDU Factorization (set up for SSLUI4).
C    SSLUI4: SLAP Backsolve for LDU Factorization.
C    SSMMTI: SLAP MSOLVE for LDU Fact of Normal Eq (set up for SSMMI2).
C    SSMMI2: SLAP Backsolve for LDU Factorization of Normal Equations.
C
C    =========================== slaputil.f ==========================
C       The following utility routines are useful additions to SLAP.
C
C    SBHIN: Read Sparse Linear System in the Boeing/Harwell Format.
C    SCHKW: SLAP WORK/IWORK Array Bounds Checker.
C    SCPPLT: Printer Plot of SLAP Column Format Matrix.
C    SS2Y: SLAP Triad to SLAP Column Format Converter.
C    QS2I1R: Quick Sort Integer array, moving integer and real arrays.
C            (Used by SS2Y.)
C    STIN: Read in SLAP Triad Format Linear System.
C    STOUT: Write out SLAP Triad Format Linear System.
C
C
C***REFERENCES  1. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   880715  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C           -----( This produced Version 2.0.1. )-----
C   891003  Rearranged list of user callable routines to agree with
C           order in source deck.  (FNF)
C   891004  Updated reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C           -----( This produced Version 2.0.2. )-----
C   910506  Minor improvements to prologue.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of reference.  (FNF)
C   921019  Improved one-line descriptions, reordering some.  (FNF)
C***END PROLOGUE  SLPDOC
C***FIRST EXECUTABLE STATEMENT  SLPDOC
C
C     This is a *DUMMY* subroutine and should never be called.
C
      RETURN
C------------- LAST LINE OF SLPDOC FOLLOWS -----------------------------
      END
*DECK SLVS
      SUBROUTINE SLVS (WM, IWM, X, TEM)
C***BEGIN PROLOGUE  SLVS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DEBDF
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SLVS-S, DSLVS-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   SLVS solves the linear system in the iteration scheme for the
C   integrator package DEBDF.
C
C***SEE ALSO  DEBDF
C***ROUTINES CALLED  SGBSL, SGESL
C***COMMON BLOCKS    DEBDF1
C***REVISION HISTORY  (YYMMDD)
C   800901  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C   920422  Changed DIMENSION statement.  (WRB)
C***END PROLOGUE  SLVS
C
CLLL. OPTIMIZE
      INTEGER IWM, I, IER, IOWND, IOWNS, JSTART, KFLAG, L, MAXORD,
     1   MEBAND, METH, MITER, ML, MU, N, NFE, NJE, NQ, NQU, NST
      REAL WM, X, TEM,
     1   ROWND, ROWNS, EL0, H, HMIN, HMXI, HU, TN, UROUND,
     2   DI, HL0, PHL0, R
      DIMENSION WM(*), IWM(*), X(*), TEM(*)
      COMMON /DEBDF1/ ROWND, ROWNS(210),
     1   EL0, H, HMIN, HMXI, HU, TN, UROUND, IOWND(14), IOWNS(6),
     2   IER, JSTART, KFLAG, L, METH, MITER, MAXORD, N, NQ, NST, NFE,
     3   NJE, NQU
C-----------------------------------------------------------------------
C THIS ROUTINE MANAGES THE SOLUTION OF THE LINEAR SYSTEM ARISING FROM
C A CHORD ITERATION.  IT IS CALLED BY STOD  IF MITER .NE. 0.
C IF MITER IS 1 OR 2, IT CALLS SGESL TO ACCOMPLISH THIS.
C IF MITER = 3 IT UPDATES THE COEFFICIENT H*EL0 IN THE DIAGONAL
C MATRIX, AND THEN COMPUTES THE SOLUTION.
C IF MITER IS 4 OR 5, IT CALLS SGBSL.
C COMMUNICATION WITH SLVS USES THE FOLLOWING VARIABLES..
C WM  = REAL WORK SPACE CONTAINING THE INVERSE DIAGONAL MATRIX IF MITER
C       IS 3 AND THE LU DECOMPOSITION OF THE MATRIX OTHERWISE.
C       STORAGE OF MATRIX ELEMENTS STARTS AT WM(3).
C       WM ALSO CONTAINS THE FOLLOWING MATRIX-RELATED DATA..
C       WM(1) = SQRT(UROUND) (NOT USED HERE),
C       WM(2) = HL0, THE PREVIOUS VALUE OF H*EL0, USED IF MITER = 3.
C IWM = INTEGER WORK SPACE CONTAINING PIVOT INFORMATION, STARTING AT
C       IWM(21), IF MITER IS 1, 2, 4, OR 5.  IWM ALSO CONTAINS THE
C       BAND PARAMETERS ML = IWM(1) AND MU = IWM(2) IF MITER IS 4 OR 5.
C X   = THE RIGHT-HAND SIDE VECTOR ON INPUT, AND THE SOLUTION VECTOR
C       ON OUTPUT, OF LENGTH N.
C TEM = VECTOR OF WORK SPACE OF LENGTH N, NOT USED IN THIS VERSION.
C IER = OUTPUT FLAG (IN COMMON).  IER = 0 IF NO TROUBLE OCCURRED.
C       IER = -1 IF A SINGULAR MATRIX AROSE WITH MITER = 3.
C THIS ROUTINE ALSO USES THE COMMON VARIABLES EL0, H, MITER, AND N.
C-----------------------------------------------------------------------
C***FIRST EXECUTABLE STATEMENT  SLVS
      IER = 0
      GO TO (100, 100, 300, 400, 400), MITER
 100  CALL SGESL (WM(3), N, N, IWM(21), X, 0)
      RETURN
C
 300  PHL0 = WM(2)
      HL0 = H*EL0
      WM(2) = HL0
      IF (HL0 .EQ. PHL0) GO TO 330
      R = HL0/PHL0
      DO 320 I = 1,N
        DI = 1.0E0 - R*(1.0E0 - 1.0E0/WM(I+2))
        IF (ABS(DI) .EQ. 0.0E0) GO TO 390
 320    WM(I+2) = 1.0E0/DI
 330  DO 340 I = 1,N
 340    X(I) = WM(I+2)*X(I)
      RETURN
 390  IER = -1
      RETURN
C
 400  ML = IWM(1)
      MU = IWM(2)
      MEBAND = 2*ML + MU + 1
      CALL SGBSL (WM(3), MEBAND, N, ML, MU, IWM(21), X, 0)
      RETURN
C----------------------- END OF SUBROUTINE SLVS -----------------------
      END
*DECK SMOUT
      SUBROUTINE SMOUT (M, N, LDA, A, IFMT, IDIGIT)
C***BEGIN PROLOGUE  SMOUT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to FC and SBOCLS
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SMOUT-S, DMOUT-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     SINGLE PRECISION MATRIX OUTPUT ROUTINE.
C
C  INPUT..
C
C  M,N,LDA,A(*,*) PRINT THE SINGLE PRECISION ARRAY A(I,J),I  = 1,...,M,
C                 J=1,...,N, ON OUTPUT UNIT LOUT=6. LDA IS THE DECLARED
C                 FIRST DIMENSION OF A(*,*) AS SPECIFIED IN THE CALLING
C                 PROGRAM. THE HEADING IN THE FORTRAN FORMAT STATEMENT
C                 IFMT(*), DESCRIBED BELOW, IS PRINTED AS A FIRST STEP.
C                 THE COMPONENTS A(I,J) ARE INDEXED, ON OUTPUT, IN A
C                 PLEASANT FORMAT.
C  IFMT(*)        A FORTRAN FORMAT STATEMENT. THIS IS PRINTED ON
C                 OUTPUT UNIT LOUT=6 WITH THE VARIABLE FORMAT FORTRAN
C                 STATEMENT
C                       WRITE(LOUT,IFMT).
C  IDIGIT         PRINT AT LEAST ABS(IDIGIT) DECIMAL DIGITS PER NUMBER.
C                 THE SUBPROGRAM WILL CHOOSE THAT INTEGER 4,6,10, OR 14
C                 WHICH WILL PRINT AT LEAST ABS(IDIGIT) NUMBER OF
C                 PLACES.  IF IDIGIT.LT.0, 72 PRINTING COLUMNS ARE
C                 UTILIZED TO WRITE EACH LINE OF OUTPUT OF THE ARRAY
C                 A(*,*). (THIS CAN BE USED ON MOST TIME-SHARING
C                 TERMINALS).  IF IDIGIT.GE.0, 133 PRINTING COLUMNS ARE
C                 UTILIZED. (THIS CAN BE USED ON MOST LINE PRINTERS).
C
C  EXAMPLE..
C
C  PRINT AN ARRAY CALLED (SIMPLEX TABLEAU   ) OF SIZE 10 BY 20 SHOWING
C  6 DECIMAL DIGITS PER NUMBER. THE USER IS RUNNING ON A TIME-SHARING
C  SYSTEM WITH A 72 COLUMN OUTPUT DEVICE.
C
C     DIMENSION TABLEU(20,20)
C     M = 10
C     N = 20
C     LDTABL = 20
C     IDIGIT = -6
C     CALL SMOUT(M,N,LDTABL,TABLEU,21H(16H1SIMPLEX TABLEAU),IDIGIT)
C
C***SEE ALSO  FC, SBOCLS
C***ROUTINES CALLED  I1MACH
C***REVISION HISTORY  (YYMMDD)
C   780801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891107  Added comma after 1P edit descriptor in FORMAT
C           statements.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  SMOUT
      DIMENSION A(LDA,*)
      CHARACTER IFMT*(*),ICOL*3
      SAVE ICOL
      DATA ICOL /'COL'/
C***FIRST EXECUTABLE STATEMENT  SMOUT
      LOUT=I1MACH(2)
      WRITE(LOUT,IFMT)
      IF(M.LE.0.OR.N.LE.0.OR.LDA.LE.0) RETURN
      NDIGIT = IDIGIT
      IF(IDIGIT.EQ.0) NDIGIT = 4
      IF(IDIGIT.GE.0) GO TO 80
C
      NDIGIT = -IDIGIT
      IF(NDIGIT.GT.4) GO TO 20
C
      DO 10 K1=1,N,5
      K2 = MIN(N,K1+4)
      WRITE(LOUT,1000) (ICOL,I,I = K1, K2)
      DO 10 I = 1, M
      WRITE(LOUT,1004) I,(A(I,J),J = K1, K2)
   10 CONTINUE
      RETURN
C
   20 CONTINUE
      IF(NDIGIT.GT.6) GO TO 40
C
      DO 30 K1=1,N,4
      K2 = MIN(N,K1+3)
      WRITE(LOUT,1001) (ICOL,I,I = K1, K2)
      DO 30 I = 1, M
      WRITE(LOUT,1005) I,(A(I,J),J = K1, K2)
   30 CONTINUE
      RETURN
C
   40 CONTINUE
      IF(NDIGIT.GT.10) GO TO 60
C
      DO 50 K1=1,N,3
      K2=MIN(N,K1+2)
      WRITE(LOUT,1002) (ICOL,I,I = K1, K2)
      DO 50 I = 1, M
      WRITE(LOUT,1006) I,(A(I,J),J = K1, K2)
   50 CONTINUE
      RETURN
C
   60 CONTINUE
      DO 70 K1=1,N,2
      K2 = MIN(N,K1+1)
      WRITE(LOUT,1003) (ICOL,I,I = K1, K2)
      DO 70 I = 1, M
      WRITE(LOUT,1007) I,(A(I,J),J = K1, K2)
   70 CONTINUE
      RETURN
C
   80 CONTINUE
      IF(NDIGIT.GT.4) GO TO 100
C
      DO 90 K1=1,N,10
      K2 = MIN(N,K1+9)
      WRITE(LOUT,1000) (ICOL,I,I = K1, K2)
      DO 90 I = 1, M
      WRITE(LOUT,1004) I,(A(I,J),J = K1, K2)
   90 CONTINUE
      RETURN
C
  100 CONTINUE
      IF(NDIGIT.GT.6) GO TO 120
C
      DO 110 K1=1,N,8
      K2 = MIN(N,K1+7)
      WRITE(LOUT,1001) (ICOL,I,I = K1, K2)
      DO 110 I = 1, M
      WRITE(LOUT,1005) I,(A(I,J),J = K1, K2)
  110 CONTINUE
      RETURN
C
  120 CONTINUE
      IF(NDIGIT.GT.10) GO TO 140
C
      DO 130 K1=1,N,6
      K2 = MIN(N,K1+5)
      WRITE(LOUT,1002) (ICOL,I,I = K1, K2)
      DO 130 I = 1, M
      WRITE(LOUT,1006) I,(A(I,J),J = K1, K2)
  130 CONTINUE
      RETURN
C
  140 CONTINUE
      DO 150 K1=1,N,5
      K2 = MIN(N,K1+4)
      WRITE(LOUT,1003) (ICOL,I,I = K1, K2)
      DO 150 I = 1, M
      WRITE(LOUT,1007) I,(A(I,J),J = K1, K2)
  150 CONTINUE
      RETURN
 1000 FORMAT(10X,10(4X,A,I4,1X))
 1001 FORMAT(10X,8(5X,A,I4,2X))
 1002 FORMAT(10X,6(7X,A,I4,4X))
 1003 FORMAT(10X,5(9X,A,I4,6X))
 1004 FORMAT(1X,'ROW',I4,2X,1P,10E12.3)
 1005 FORMAT(1X,'ROW',I4,2X,1P,8E14.5)
 1006 FORMAT(1X,'ROW',I4,2X,1P,6E18.9)
 1007 FORMAT(1X,'ROW',I4,2X,1P,5E22.13)
      END
*DECK SNBCO
      SUBROUTINE SNBCO (ABE, LDA, N, ML, MU, IPVT, RCOND, Z)
C***BEGIN PROLOGUE  SNBCO
C***PURPOSE  Factor a band matrix using Gaussian elimination and
C            estimate the condition number.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      SINGLE PRECISION (SNBCO-S, DNBCO-D, CNBCO-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, MATRIX FACTORIZATION,
C             NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C     SNBCO factors a real band matrix by Gaussian
C     elimination and estimates the condition of the matrix.
C
C     If RCOND is not needed, SNBFA is slightly faster.
C     To solve  A*X = B , follow SNBCO by SNBSL.
C     To compute  INVERSE(A)*C , follow SNBCO by SNBSL.
C     To compute  DETERMINANT(A) , follow SNBCO by SNBDI.
C
C     On Entry
C
C        ABE     REAL(LDA, NC)
C                contains the matrix in band storage.  The rows
C                of the original matrix are stored in the rows
C                of ABE and the diagonals of the original matrix
C                are stored in columns 1 through ML+MU+1 of ABE.
C                NC must be .GE. 2*ML+MU+1 .
C                See the comments below for details.
C
C        LDA     INTEGER
C                the leading dimension of the array ABE.
C                LDA must be .GE. N .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C                0 .LE. ML .LT. N .
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C                0 .LE. MU .LT. N .
C                More efficient if ML .LE. MU .
C
C     On Return
C
C        ABE     an upper triangular matrix in band storage
C                and the multipliers which were used to obtain it.
C                The factorization can be written  A = L*U , where
C                L is a product of permutation and unit lower
C                triangular matrices and  U  is upper triangular.
C
C        IPVT    INTEGER(N)
C                an integer vector of pivot indices.
C
C        RCOND   REAL
C                an estimate of the reciprocal condition of  A .
C                For the system  A*X = B , relative perturbations
C                in  A  and  B  of size  EPSILON  may cause
C                relative perturbations in  X  of size  EPSILON/RCOND .
C                If  RCOND  is so small that the logical expression
C                         1.0 + RCOND .EQ. 1.0
C                is true, then  A  may be singular to working
C                precision.  In particular,  RCOND  is zero  if
C                exact singularity is detected or the estimate
C                underflows.
C
C        Z       REAL(N)
C                a work vector whose contents are usually unimportant.
C                If  A  is close to a singular matrix, then  Z  is
C                an approximate null vector in the sense that
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C     Band Storage
C
C           If  A  is a band matrix, the following program segment
C           will set up the input.
C
C                   ML = (band width below the diagonal)
C                   MU = (band width above the diagonal)
C                   DO 20 I = 1, N
C                      J1 = MAX(1, I-ML)
C                      J2 = MIN(N, I+MU)
C                      DO 10 J = J1, J2
C                         K = J - I + ML + 1
C                         ABE(I,K) = A(I,J)
C                10    CONTINUE
C                20 CONTINUE
C
C           This uses columns  1  through  ML+MU+1  of ABE .
C           Furthermore,  ML  additional columns are needed in
C           ABE  starting with column  ML+MU+2  for elements
C           generated during the triangularization.  The total
C           number of columns needed in  ABE  is  2*ML+MU+1 .
C
C     Example:  If the original matrix is
C
C           11 12 13  0  0  0
C           21 22 23 24  0  0
C            0 32 33 34 35  0
C            0  0 43 44 45 46
C            0  0  0 54 55 56
C            0  0  0  0 65 66
C
C      then  N = 6, ML = 1, MU = 2, LDA .GE. 5  and ABE should contain
C
C            * 11 12 13  +     , * = not used
C           21 22 23 24  +     , + = used for pivoting
C           32 33 34 35  +
C           43 44 45 46  +
C           54 55 56  *  +
C           65 66  *  *  +
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SASUM, SAXPY, SDOT, SNBFA, SSCAL
C***REVISION HISTORY  (YYMMDD)
C   800723  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNBCO
      INTEGER LDA,N,ML,MU,IPVT(*)
      REAL ABE(LDA,*),Z(*)
      REAL RCOND
C
      REAL SDOT,EK,T,WK,WKM
      REAL ANORM,S,SASUM,SM,YNORM
      INTEGER I,INFO,J,JU,K,KB,KP1,L,LDB,LM,LZ,M,ML1,MM,NL,NU
C***FIRST EXECUTABLE STATEMENT  SNBCO
      ML1=ML+1
      LDB = LDA - 1
      ANORM = 0.0E0
      DO 10 J = 1, N
        NU = MIN(MU,J-1)
        NL = MIN(ML,N-J)
        L = 1 + NU + NL
        ANORM = MAX(ANORM,SASUM(L,ABE(J+NL,ML1-NL),LDB))
   10 CONTINUE
C
C     FACTOR
C
      CALL SNBFA(ABE,LDA,N,ML,MU,IPVT,INFO)
C
C     RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  A*Z = Y  AND TRANS(A)*Y = E .
C     TRANS(A)  IS THE TRANSPOSE OF A .  THE COMPONENTS OF  E  ARE
C     CHOSEN TO CAUSE MAXIMUM LOCAL GROWTH IN THE ELEMENTS OF  W WHERE
C     TRANS(U)*W = E .  THE VECTORS ARE FREQUENTLY RESCALED TO AVOID
C     OVERFLOW.
C
C     SOLVE TRANS(U)*W = E
C
      EK = 1.0E0
      DO 20 J = 1, N
        Z(J) = 0.0E0
   20 CONTINUE
      M = ML + MU + 1
      JU = 0
      DO 100 K = 1, N
        IF (Z(K) .NE. 0.0E0) EK = SIGN(EK,-Z(K))
        IF (ABS(EK-Z(K)) .LE. ABS(ABE(K,ML1))) GO TO 30
          S = ABS(ABE(K,ML1))/ABS(EK-Z(K))
          CALL SSCAL(N,S,Z,1)
          EK = S*EK
   30   CONTINUE
        WK = EK - Z(K)
        WKM = -EK - Z(K)
        S = ABS(WK)
        SM = ABS(WKM)
        IF (ABE(K,ML1) .EQ. 0.0E0) GO TO 40
          WK = WK/ABE(K,ML1)
          WKM = WKM/ABE(K,ML1)
        GO TO 50
   40   CONTINUE
          WK = 1.0E0
          WKM = 1.0E0
   50   CONTINUE
        KP1 = K + 1
        JU = MIN(MAX(JU,MU+IPVT(K)),N)
        MM = ML1
        IF (KP1 .GT. JU) GO TO 90
          DO 60 I = KP1, JU
            MM = MM + 1
            SM = SM + ABS(Z(I)+WKM*ABE(K,MM))
            Z(I) = Z(I) + WK*ABE(K,MM)
            S = S + ABS(Z(I))
   60     CONTINUE
          IF (S .GE. SM) GO TO 80
            T = WKM -WK
            WK = WKM
            MM = ML1
            DO 70 I = KP1, JU
              MM = MM + 1
              Z(I) = Z(I) + T*ABE(K,MM)
   70       CONTINUE
   80     CONTINUE
   90   CONTINUE
      Z(K) = WK
  100 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
C
C     SOLVE TRANS(L)*Y = W
C
      DO 120 KB = 1, N
        K = N + 1 - KB
        NL = MIN(ML,N-K)
        IF (K .LT. N) Z(K) = Z(K) + SDOT(NL,ABE(K+NL,ML1-NL),-LDB,Z(K+1)
     1  ,1)
        IF (ABS(Z(K)) .LE. 1.0E0) GO TO 110
          S = 1.0E0/ABS(Z(K))
          CALL SSCAL(N,S,Z,1)
  110   CONTINUE
        L = IPVT(K)
        T = Z(L)
        Z(L) = Z(K)
        Z(K) = T
  120 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
C
      YNORM = 1.0E0
C
C     SOLVE L*V = Y
C
      DO 140 K = 1, N
        L = IPVT(K)
        T = Z(L)
        Z(L) = Z(K)
        Z(K) = T
        NL = MIN(ML,N-K)
        IF (K .LT. N) CALL SAXPY(NL,T,ABE(K+NL,ML1-NL),-LDB,Z(K+1),1)
        IF (ABS(Z(K)) .LE. 1.0E0) GO TO 130
          S = 1.0E0/ABS(Z(K))
          CALL SSCAL(N,S,Z,1)
          YNORM = S*YNORM
  130   CONTINUE
  140 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
C     SOLVE  U*Z = V
C
      DO 160 KB = 1, N
        K = N + 1 - KB
        IF (ABS(Z(K)) .LE. ABS(ABE(K,ML1))) GO TO 150
          S = ABS(ABE(K,ML1))/ABS(Z(K))
          CALL SSCAL(N,S,Z,1)
          YNORM = S*YNORM
  150   CONTINUE
        IF (ABE(K,ML1) .NE. 0.0E0) Z(K) = Z(K)/ABE(K,ML1)
        IF (ABE(K,ML1) .EQ. 0.0E0) Z(K) = 1.0E0
        LM = MIN(K,M) - 1
        LZ = K - LM
        T = -Z(K)
        CALL SAXPY(LM,T,ABE(K-1,ML+2),-LDB,Z(LZ),1)
  160 CONTINUE
C     MAKE ZNORM = 1.0E0
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
      IF (ANORM .NE. 0.0E0) RCOND = YNORM/ANORM
      IF (ANORM .EQ. 0.0E0) RCOND = 0.0E0
      RETURN
      END
*DECK SNBDI
      SUBROUTINE SNBDI (ABE, LDA, N, ML, MU, IPVT, DET)
C***BEGIN PROLOGUE  SNBDI
C***PURPOSE  Compute the determinant of a band matrix using the factors
C            computed by SNBCO or SNBFA.
C***LIBRARY   SLATEC
C***CATEGORY  D3A2
C***TYPE      SINGLE PRECISION (SNBDI-S, DNBDI-D, CNBDI-C)
C***KEYWORDS  BANDED, DETERMINANT, LINEAR EQUATIONS, NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C     SNBDI computes the determinant of a band matrix
C     using the factors computed by SNBCO or SNBFA.
C     If the inverse is needed, use SNBSL  N  times.
C
C     On Entry
C
C        ABE     REAL(LDA, NC)
C                the output from SNBCO or SNBFA.
C                NC must be .GE. 2*ML+MU+1 .
C
C        LDA     INTEGER
C                the leading dimension of the array  ABE .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C
C        IPVT    INTEGER(N)
C                the pivot vector from SNBCO or SNBFA.
C
C     On Return
C
C        DET     REAL(2)
C                determinant of original matrix.
C                Determinant = DET(1) * 10.0**DET(2)
C                with  1.0 .LE. ABS(DET(1)) .LT. 10.0
C                or  DET(1) = 0.0 .
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   800725  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNBDI
      INTEGER LDA,N,ML,MU,IPVT(*)
      REAL ABE(LDA,*),DET(2)
C
      REAL TEN
      INTEGER I
C***FIRST EXECUTABLE STATEMENT  SNBDI
      DET(1) = 1.0E0
      DET(2) = 0.0E0
      TEN = 10.0E0
      DO 50 I = 1, N
         IF (IPVT(I) .NE. I) DET(1) = -DET(1)
         DET(1) = ABE(I,ML+1)*DET(1)
         IF (DET(1) .EQ. 0.0E0) GO TO 60
   10    IF (ABS(DET(1)) .GE. 1.0E0) GO TO 20
            DET(1) = TEN*DET(1)
            DET(2) = DET(2) - 1.0E0
         GO TO 10
   20    CONTINUE
   30    IF (ABS(DET(1)) .LT. TEN) GO TO 40
            DET(1) = DET(1)/TEN
            DET(2) = DET(2) + 1.0E0
         GO TO 30
   40    CONTINUE
   50 CONTINUE
   60 CONTINUE
      RETURN
      END
*DECK SNBFA
      SUBROUTINE SNBFA (ABE, LDA, N, ML, MU, IPVT, INFO)
C***BEGIN PROLOGUE  SNBFA
C***PURPOSE  Factor a real band matrix by elimination.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      SINGLE PRECISION (SNBFA-S, DNBFA-D, CNBFA-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, MATRIX FACTORIZATION,
C             NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C     SNBFA factors a real band matrix by elimination.
C
C     SNBFA is usually called by SNBCO, but it can be called
C     directly with a saving in time if RCOND is not needed.
C
C     On Entry
C
C        ABE     REAL(LDA, NC)
C                contains the matrix in band storage.  The rows
C                of the original matrix are stored in the rows
C                of ABE and the diagonals of the original matrix
C                are stored in columns 1 through ML+MU+1 of ABE.
C                NC must be .GE. 2*ML+MU+1 .
C                See the comments below for details.
C
C        LDA     INTEGER
C                the leading dimension of the array ABE.
C                LDA must be .GE. N .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C                0 .LE. ML .LT. N .
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C                0 .LE. MU .LT. N .
C                More efficient if ML .LE. MU .
C
C     On Return
C
C        ABE     an upper triangular matrix in band storage
C                and the multipliers which were used to obtain it.
C                The factorization can be written  A = L*U , where
C                L is a product of permutation and unit lower
C                triangular matrices and  U  is upper triangular.
C
C        IPVT    INTEGER(N)
C                an integer vector of pivot indices.
C
C        INFO    INTEGER
C                =0  normal value
C                =K  if  U(K,K) .EQ. 0.0 .  This is not an error
C                condition for this subroutine, but it does
C                indicate that SNBSL will divide by zero if
C                called.  Use RCOND in SNBCO for a reliable
C                indication of singularity.
C
C     Band Storage
C
C           If  A  is a band matrix, the following program segment
C           will set up the input.
C
C                   ML = (band width below the diagonal)
C                   MU = (band width above the diagonal)
C                   DO 20 I = 1, N
C                      J1 = MAX(1, I-ML)
C                      J2 = MIN(N, I+MU)
C                      DO 10 J = J1, J2
C                         K = J - I + ML + 1
C                         ABE(I,K) = A(I,J)
C                10    CONTINUE
C                20 CONTINUE
C
C           This uses columns  1  through  ML+MU+1  of ABE .
C           Furthermore,  ML  additional columns are needed in
C           ABE  starting with column  ML+MU+2  for elements
C           generated during the triangularization.  The total
C           number of columns needed in  ABE  is  2*ML+MU+1 .
C
C     Example:  If the original matrix is
C
C           11 12 13  0  0  0
C           21 22 23 24  0  0
C            0 32 33 34 35  0
C            0  0 43 44 45 46
C            0  0  0 54 55 56
C            0  0  0  0 65 66
C
C      then  N = 6, ML = 1, MU = 2, LDA .GE. 5  and ABE should contain
C
C            * 11 12 13  +     , * = not used
C           21 22 23 24  +     , + = used for pivoting
C           32 33 34 35  +
C           43 44 45 46  +
C           54 55 56  *  +
C           65 66  *  *  +
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  ISAMAX, SAXPY, SSCAL, SSWAP
C***REVISION HISTORY  (YYMMDD)
C   800606  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNBFA
      INTEGER LDA,N,ML,MU,IPVT(*),INFO
      REAL ABE(LDA,*)
C
      INTEGER ML1,MB,M,N1,LDB,I,J,K,L,LM,LM1,LM2,MP,ISAMAX
      REAL T
C***FIRST EXECUTABLE STATEMENT  SNBFA
      ML1=ML+1
      MB=ML+MU
      M=ML+MU+1
      N1=N-1
      LDB=LDA-1
      INFO=0
C
C     SET FILL-IN COLUMNS TO ZERO
C
      IF(N.LE.1)GO TO 50
      IF(ML.LE.0)GO TO 7
      DO 6 J=1,ML
        DO 5 I=1,N
          ABE(I,M+J)=0.0E0
    5   CONTINUE
    6 CONTINUE
    7 CONTINUE
C
C     GAUSSIAN ELIMINATION WITH PARTIAL ELIMINATION
C
      DO 40 K=1,N1
        LM=MIN(N-K,ML)
        LM1=LM+1
        LM2=ML1-LM
C
C     SEARCH FOR PIVOT INDEX
C
        L=-ISAMAX(LM1,ABE(LM+K,LM2),LDB)+LM1+K
        IPVT(K)=L
        MP=MIN(MB,N-K)
C
C     SWAP ROWS IF NECESSARY
C
        IF(L.NE.K)CALL SSWAP(MP+1,ABE(K,ML1),LDA,ABE(L,ML1+K-L),LDA)
C
C     SKIP COLUMN REDUCTION IF PIVOT IS ZERO
C
        IF(ABE(K,ML1).EQ.0.0E0) GO TO 20
C
C     COMPUTE MULTIPLIERS
C
        T=-1.0/ABE(K,ML1)
        CALL SSCAL(LM,T,ABE(LM+K,LM2),LDB)
C
C     ROW ELIMINATION WITH COLUMN INDEXING
C
        DO 10 J=1,MP
          CALL SAXPY (LM,ABE(K,ML1+J),ABE(LM+K,LM2),LDB,ABE(LM+K,LM2+J),
     1                LDB)
   10   CONTINUE
        GO TO 30
   20   CONTINUE
        INFO=K
   30   CONTINUE
   40 CONTINUE
   50 CONTINUE
      IPVT(N)=N
      IF(ABE(N,ML1).EQ.0.0E0) INFO=N
      RETURN
      END
*DECK SNBFS
      SUBROUTINE SNBFS (ABE, LDA, N, ML, MU, V, ITASK, IND, WORK, IWORK)
C***BEGIN PROLOGUE  SNBFS
C***PURPOSE  Solve a general nonsymmetric banded system of linear
C            equations.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      SINGLE PRECISION (SNBFS-S, DNBFS-D, CNBFS-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C    Subroutine SNBFS solves a general nonsymmetric banded NxN
C    system of single precision real linear equations using
C    SLATEC subroutines SNBCO and SNBSL.  These are adaptations
C    of the LINPACK subroutines SBGCO and SGBSL, which require
C    a different format for storing the matrix elements.  If
C    A  is an NxN real matrix and if  X  and  B  are real
C    N-vectors, then SNBFS solves the equation
C
C                          A*X=B.
C
C    A band matrix is a matrix whose nonzero elements are all
C    fairly near the main diagonal, specifically  A(I,J) = 0
C    if  I-J is greater than  ML  or  J-I  is greater than
C    MU .  The integers ML and MU are called the lower and upper
C    band widths and  M = ML+MU+1  is the total band width.
C    SNBFS uses less time and storage than the corresponding
C    program for general matrices (SGEFS) if 2*ML+MU .LT. N  .
C
C    The matrix A is first factored into upper and lower tri-
C    angular matrices U and L using partial pivoting.  These
C    factors and the pivoting information are used to find the
C    solution vector X.  An approximate condition number is
C    calculated to provide a rough estimate of the number of
C    digits of accuracy in the computed solution.
C
C    If the equation A*X=B is to be solved for more than one vector
C    B, the factoring of A does not need to be performed again and
C    the option to only solve (ITASK .GT. 1) will be faster for
C    the succeeding solutions.  In this case, the contents of A,
C    LDA, N and IWORK must not have been altered by the user follow-
C    ing factorization (ITASK=1).  IND will not be changed by SNBFS
C    in this case.
C
C
C    Band Storage
C
C          If  A  is a band matrix, the following program segment
C          will set up the input.
C
C                  ML = (band width below the diagonal)
C                  MU = (band width above the diagonal)
C                  DO 20 I = 1, N
C                     J1 = MAX(1, I-ML)
C                     J2 = MIN(N, I+MU)
C                     DO 10 J = J1, J2
C                        K = J - I + ML + 1
C                        ABE(I,K) = A(I,J)
C               10    CONTINUE
C               20 CONTINUE
C
C          This uses columns  1  through  ML+MU+1  of ABE .
C          Furthermore,  ML  additional columns are needed in
C          ABE  starting with column  ML+MU+2  for elements
C          generated during the triangularization.  The total
C          number of columns needed in  ABE  is  2*ML+MU+1 .
C
C    Example:  If the original matrix is
C
C          11 12 13  0  0  0
C          21 22 23 24  0  0
C           0 32 33 34 35  0
C           0  0 43 44 45 46
C           0  0  0 54 55 56
C           0  0  0  0 65 66
C
C     then  N = 6, ML = 1, MU = 2, LDA .GE. 5  and ABE should contain
C
C           * 11 12 13  +     , * = not used
C          21 22 23 24  +     , + = used for pivoting
C          32 33 34 35  +
C          43 44 45 46  +
C          54 55 56  *  +
C          65 66  *  *  +
C
C
C  Argument Description ***
C
C    ABE    REAL(LDA,NC)
C             on entry, contains the matrix in band storage as
C               described above.  NC  must not be less than
C               2*ML+MU+1 .  The user is cautioned to specify  NC
C               with care since it is not an argument and cannot
C               be checked by SNBFS.  The rows of the original
C               matrix are stored in the rows of  ABE  and the
C               diagonals of the original matrix are stored in
C               columns  1  through  ML+MU+1  of  ABE .
C             on return, contains an upper triangular matrix U and
C               the multipliers necessary to construct a matrix L
C               so that A=L*U.
C    LDA    INTEGER
C             the leading dimension of array ABE.  LDA must be great-
C             er than or equal to N.  (terminal error message IND=-1)
C    N      INTEGER
C             the order of the matrix A.  N must be greater
C             than or equal to 1 .  (terminal error message IND=-2)
C    ML     INTEGER
C             the number of diagonals below the main diagonal.
C             ML  must not be less than zero nor greater than or
C             equal to  N .  (terminal error message IND=-5)
C    MU     INTEGER
C             the number of diagonals above the main diagonal.
C             MU  must not be less than zero nor greater than or
C             equal to  N .  (terminal error message IND=-6)
C    V      REAL(N)
C             on entry, the singly subscripted array(vector) of di-
C               mension N which contains the right hand side B of a
C               system of simultaneous linear equations A*X=B.
C             on return, V contains the solution vector, X .
C    ITASK  INTEGER
C             If ITASK=1, the matrix A is factored and then the
C               linear equation is solved.
C             If ITASK .GT. 1, the equation is solved using the existing
C               factored matrix A and IWORK.
C             If ITASK .LT. 1, then terminal error message IND=-3 is
C               printed.
C    IND    INTEGER
C             GT. 0  IND is a rough estimate of the number of digits
C                     of accuracy in the solution, X.
C             LT. 0  See error message corresponding to IND below.
C    WORK   REAL(N)
C             a singly subscripted array of dimension at least N.
C    IWORK  INTEGER(N)
C             a singly subscripted array of dimension at least N.
C
C  Error Messages Printed ***
C
C    IND=-1  terminal   N is greater than LDA.
C    IND=-2  terminal   N is less than 1.
C    IND=-3  terminal   ITASK is less than 1.
C    IND=-4  terminal   the matrix A is computationally singular.
C                         A solution has not been computed.
C    IND=-5  terminal   ML is less than zero or is greater than
C                         or equal to N .
C    IND=-6  terminal   MU is less than zero or is greater than
C                         or equal to N .
C    IND=-10 warning    the solution has no apparent significance.
C                         The solution may be inaccurate or the matrix
C                         A may be poorly scaled.
C
C               Note-  The above terminal(*fatal*) error messages are
C                      designed to be handled by XERMSG in which
C                      LEVEL=1 (recoverable) and IFLAG=2 .  LEVEL=0
C                      for warning error messages from XERMSG.  Unless
C                      the user provides otherwise, an error message
C                      will be printed followed by an abort.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  R1MACH, SNBCO, SNBSL, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800808  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNBFS
C
      INTEGER LDA,N,ITASK,IND,IWORK(*),ML,MU
      REAL ABE(LDA,*),V(*),WORK(*),R1MACH
      REAL RCOND
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  SNBFS
      IF (LDA.LT.N) THEN
         IND = -1
         WRITE (XERN1, '(I8)') LDA
         WRITE (XERN2, '(I8)') N
         CALL XERMSG ('SLATEC', 'SNBFS', 'LDA = ' // XERN1 //
     *      ' IS LESS THAN N = ' // XERN2, -1, 1)
         RETURN
      ENDIF
C
      IF (N.LE.0) THEN
         IND = -2
         WRITE (XERN1, '(I8)') N
         CALL XERMSG ('SLATEC', 'SNBFS', 'N = ' // XERN1 //
     *      ' IS LESS THAN 1', -2, 1)
         RETURN
      ENDIF
C
      IF (ITASK.LT.1) THEN
         IND = -3
         WRITE (XERN1, '(I8)') ITASK
         CALL XERMSG ('SLATEC', 'SNBFS', 'ITASK = ' // XERN1 //
     *      ' IS LESS THAN 1', -3, 1)
         RETURN
      ENDIF
C
      IF (ML.LT.0 .OR. ML.GE.N) THEN
         IND = -5
         WRITE (XERN1, '(I8)') ML
         CALL XERMSG ('SLATEC', 'SNBFS',
     *      'ML = ' // XERN1 // ' IS OUT OF RANGE', -5, 1)
         RETURN
      ENDIF
C
      IF (MU.LT.0 .OR. MU.GE.N) THEN
         IND = -6
         WRITE (XERN1, '(I8)') MU
         CALL XERMSG ('SLATEC', 'SNBFS',
     *      'MU = ' // XERN1 // ' IS OUT OF RANGE', -6, 1)
         RETURN
      ENDIF
C
      IF (ITASK.EQ.1) THEN
C
C        FACTOR MATRIX A INTO LU
C
         CALL SNBCO(ABE,LDA,N,ML,MU,IWORK,RCOND,WORK)
C
C        CHECK FOR COMPUTATIONALLY SINGULAR MATRIX
C
         IF (RCOND.EQ.0.0) THEN
            IND = -4
            CALL XERMSG ('SLATEC', 'SNBFS',
     *         'SINGULAR MATRIX A - NO SOLUTION', -4, 1)
            RETURN
         ENDIF
C
C        COMPUTE IND (ESTIMATE OF NO. OF SIGNIFICANT DIGITS)
C        AND CHECK FOR IND GREATER THAN ZERO
C
         IND = -LOG10(R1MACH(4)/RCOND)
         IF (IND.LE.0) THEN
            IND = -10
            CALL XERMSG ('SLATEC', 'SNBFS',
     *         'SOLUTION MAY HAVE NO SIGNIFICANCE', -10, 0)
         ENDIF
      ENDIF
C
C     SOLVE AFTER FACTORING
C
      CALL SNBSL(ABE,LDA,N,ML,MU,IWORK,V,0)
      RETURN
      END
*DECK SNBIR
      SUBROUTINE SNBIR (ABE, LDA, N, ML, MU, V, ITASK, IND, WORK, IWORK)
C***BEGIN PROLOGUE  SNBIR
C***PURPOSE  Solve a general nonsymmetric banded system of linear
C            equations.  Iterative refinement is used to obtain an error
C            estimate.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      SINGLE PRECISION (SNBIR-S, CNBIR-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C    Subroutine SNBIR solves a general nonsymmetric banded NxN
C    system of single precision real linear equations using
C    SLATEC subroutines SNBFA and SNBSL.  These are adaptations
C    of the LINPACK subroutines SGBFA and SGBSL, which require
C    a different format for storing the matrix elements.
C    One pass of iterative refinement is used only to obtain an
C    estimate of the accuracy.  If  A  is an NxN real banded
C    matrix and if  X  and  B  are real N-vectors, then SNBIR
C    solves the equation
C
C                          A*X=B.
C
C    A band matrix is a matrix whose nonzero elements are all
C    fairly near the main diagonal, specifically  A(I,J) = 0
C    if  I-J is greater than  ML  or  J-I  is greater than
C    MU .  The integers ML and MU are called the lower and upper
C    band widths and  M = ML+MU+1  is the total band width.
C    SNBIR uses less time and storage than the corresponding
C    program for general matrices (SGEIR) if 2*ML+MU .LT. N .
C
C    The matrix A is first factored into upper and lower tri-
C    angular matrices U and L using partial pivoting.  These
C    factors and the pivoting information are used to find the
C    solution vector X .  Then the residual vector is found and used
C    to calculate an estimate of the relative error, IND .  IND esti-
C    mates the accuracy of the solution only when the input matrix
C    and the right hand side are represented exactly in the computer
C    and does not take into account any errors in the input data.
C
C    If the equation A*X=B is to be solved for more than one vector
C    B, the factoring of A does not need to be performed again and
C    the option to only solve (ITASK .GT. 1) will be faster for
C    the succeeding solutions.  In this case, the contents of A, LDA,
C    N, work and IWORK must not have been altered by the user follow-
C    ing factorization (ITASK=1).  IND will not be changed by SNBIR
C    in this case.
C
C
C    Band Storage
C
C          If  A  is a band matrix, the following program segment
C          will set up the input.
C
C                  ML = (band width below the diagonal)
C                  MU = (band width above the diagonal)
C                  DO 20 I = 1, N
C                     J1 = MAX(1, I-ML)
C                     J2 = MIN(N, I+MU)
C                     DO 10 J = J1, J2
C                        K = J - I + ML + 1
C                        ABE(I,K) = A(I,J)
C               10    CONTINUE
C               20 CONTINUE
C
C          This uses columns  1  Through  ML+MU+1  of ABE .
C
C    Example:  If the original matrix is
C
C          11 12 13  0  0  0
C          21 22 23 24  0  0
C           0 32 33 34 35  0
C           0  0 43 44 45 46
C           0  0  0 54 55 56
C           0  0  0  0 65 66
C
C     then  N = 6, ML = 1, MU = 2, LDA .GE. 5  and ABE should contain
C
C           * 11 12 13        , * = not used
C          21 22 23 24
C          32 33 34 35
C          43 44 45 46
C          54 55 56  *
C          65 66  *  *
C
C
C  Argument Description ***
C
C    ABE    REAL(LDA,MM)
C             on entry, contains the matrix in band storage as
C               described above.  MM  must not be less than  M =
C               ML+MU+1 .  The user is cautioned to dimension  ABE
C               with care since MM is not an argument and cannot
C               be checked by SNBIR.  The rows of the original
C               matrix are stored in the rows of  ABE  and the
C               diagonals of the original matrix are stored in
C               columns  1  through  ML+MU+1  of  ABE .  ABE  is
C               not altered by the program.
C    LDA    INTEGER
C             the leading dimension of array ABE.  LDA must be great-
C             er than or equal to N.  (terminal error message IND=-1)
C    N      INTEGER
C             the order of the matrix A.  N must be greater
C             than or equal to 1 .  (terminal error message IND=-2)
C    ML     INTEGER
C             the number of diagonals below the main diagonal.
C             ML  must not be less than zero nor greater than or
C             equal to  N .  (terminal error message IND=-5)
C    MU     INTEGER
C             the number of diagonals above the main diagonal.
C             MU  must not be less than zero nor greater than or
C             equal to  N .  (terminal error message IND=-6)
C    V      REAL(N)
C             on entry, the singly subscripted array(vector) of di-
C               mension N which contains the right hand side B of a
C               system of simultaneous linear equations A*X=B.
C             on return, V contains the solution vector, X .
C    ITASK  INTEGER
C             If ITASK=1, the matrix A is factored and then the
C               linear equation is solved.
C             If ITASK .GT. 1, the equation is solved using the existing
C               factored matrix A and IWORK.
C             If ITASK .LT. 1, then terminal error message IND=-3 is
C               printed.
C    IND    INTEGER
C             GT. 0  IND is a rough estimate of the number of digits
C                     of accuracy in the solution, X .  IND=75 means
C                     that the solution vector  X  is zero.
C             LT. 0  See error message corresponding to IND below.
C    WORK   REAL(N*(NC+1))
C             a singly subscripted array of dimension at least
C             N*(NC+1)  where  NC = 2*ML+MU+1 .
C    IWORK  INTEGER(N)
C             a singly subscripted array of dimension at least N.
C
C  Error Messages Printed ***
C
C    IND=-1  terminal   N is greater than LDA.
C    IND=-2  terminal   N is less than 1.
C    IND=-3  terminal   ITASK is less than 1.
C    IND=-4  terminal   the matrix A is computationally singular.
C                         A solution has not been computed.
C    IND=-5  terminal   ML is less than zero or is greater than
C                         or equal to N .
C    IND=-6  terminal   MU is less than zero or is greater than
C                         or equal to N .
C    IND=-10 warning    the solution has no apparent significance.
C                         The solution may be inaccurate or the matrix
C                         A may be poorly scaled.
C
C               Note-  The above terminal(*fatal*) error messages are
C                      designed to be handled by XERMSG in which
C                      LEVEL=1 (recoverable) and IFLAG=2 .  LEVEL=0
C                      for warning error messages from XERMSG.  Unless
C                      the user provides otherwise, an error message
C                      will be printed followed by an abort.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  R1MACH, SASUM, SCOPY, SDSDOT, SNBFA, SNBSL, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800815  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNBIR
C
      INTEGER LDA,N,ITASK,IND,IWORK(*),INFO,J,K,KK,L,M,ML,MU,NC
      REAL ABE(LDA,*),V(*),WORK(N,*),XNORM,DNORM,SDSDOT,SASUM,R1MACH
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  SNBIR
      IF (LDA.LT.N) THEN
         IND = -1
         WRITE (XERN1, '(I8)') LDA
         WRITE (XERN2, '(I8)') N
         CALL XERMSG ('SLATEC', 'SNBIR', 'LDA = ' // XERN1 //
     *      ' IS LESS THAN N = ' // XERN2, -1, 1)
         RETURN
      ENDIF
C
      IF (N.LE.0) THEN
         IND = -2
         WRITE (XERN1, '(I8)') N
         CALL XERMSG ('SLATEC', 'SNBIR', 'N = ' // XERN1 //
     *      ' IS LESS THAN 1', -2, 1)
         RETURN
      ENDIF
C
      IF (ITASK.LT.1) THEN
         IND = -3
         WRITE (XERN1, '(I8)') ITASK
         CALL XERMSG ('SLATEC', 'SNBIR', 'ITASK = ' // XERN1 //
     *      ' IS LESS THAN 1', -3, 1)
         RETURN
      ENDIF
C
      IF (ML.LT.0 .OR. ML.GE.N) THEN
         IND = -5
         WRITE (XERN1, '(I8)') ML
         CALL XERMSG ('SLATEC', 'SNBIR',
     *      'ML = ' // XERN1 // ' IS OUT OF RANGE', -5, 1)
         RETURN
      ENDIF
C
      IF (MU.LT.0 .OR. MU.GE.N) THEN
         IND = -6
         WRITE (XERN1, '(I8)') MU
         CALL XERMSG ('SLATEC', 'SNBIR',
     *      'MU = ' // XERN1 // ' IS OUT OF RANGE', -6, 1)
         RETURN
      ENDIF
C
      NC = 2*ML+MU+1
      IF (ITASK.EQ.1) THEN
C
C        MOVE MATRIX ABE TO WORK
C
         M=ML+MU+1
         DO 10 J=1,M
            CALL SCOPY(N,ABE(1,J),1,WORK(1,J),1)
   10    CONTINUE
C
C        FACTOR MATRIX A INTO LU
C
         CALL SNBFA(WORK,N,N,ML,MU,IWORK,INFO)
C
C        CHECK FOR COMPUTATIONALLY SINGULAR MATRIX
C
         IF (INFO.NE.0) THEN
            IND = -4
            CALL XERMSG ('SLATEC', 'SNBIR',
     *         'SINGULAR MATRIX A - NO SOLUTION', -4, 1)
            RETURN
         ENDIF
      ENDIF
C
C     SOLVE WHEN FACTORING COMPLETE
C     MOVE VECTOR B TO WORK
C
      CALL SCOPY(N,V(1),1,WORK(1,NC+1),1)
      CALL SNBSL(WORK,N,N,ML,MU,IWORK,V,0)
C
C     FORM NORM OF X0
C
      XNORM = SASUM(N,V(1),1)
      IF (XNORM.EQ.0.0) THEN
         IND = 75
         RETURN
      ENDIF
C
C     COMPUTE  RESIDUAL
C
      DO 40 J=1,N
         K  = MAX(1,ML+2-J)
         KK = MAX(1,J-ML)
         L  = MIN(J-1,ML)+MIN(N-J,MU)+1
         WORK(J,NC+1) = SDSDOT(L,-WORK(J,NC+1),ABE(J,K),LDA,V(KK),1)
   40 CONTINUE
C
C     SOLVE A*DELTA=R
C
      CALL SNBSL(WORK,N,N,ML,MU,IWORK,WORK(1,NC+1),0)
C
C     FORM NORM OF DELTA
C
      DNORM = SASUM(N,WORK(1,NC+1),1)
C
C     COMPUTE IND (ESTIMATE OF NO. OF SIGNIFICANT DIGITS)
C     AND CHECK FOR IND GREATER THAN ZERO
C
      IND = -LOG10(MAX(R1MACH(4),DNORM/XNORM))
      IF (IND.LE.0) THEN
         IND = -10
         CALL XERMSG ('SLATEC', 'SNBIR',
     *      'SOLUTION MAY HAVE NO SIGNIFICANCE', -10, 0)
      ENDIF
      RETURN
      END
*DECK SNBSL
      SUBROUTINE SNBSL (ABE, LDA, N, ML, MU, IPVT, B, JOB)
C***BEGIN PROLOGUE  SNBSL
C***PURPOSE  Solve a real band system using the factors computed by
C            SNBCO or SNBFA.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      SINGLE PRECISION (SNBSL-S, DNBSL-D, CNBSL-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, NONSYMMETRIC, SOLVE
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C     SNBSL solves the real band system
C     A * X = B  or  TRANS(A) * X = B
C     using the factors computed by SNBCO or SNBFA.
C
C     On Entry
C
C        ABE     REAL(LDA, NC)
C                the output from SNBCO or SNBFA.
C                NC must be .GE. 2*ML+MU+1 .
C
C        LDA     INTEGER
C                the leading dimension of the array  ABE .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C
C        IPVT    INTEGER(N)
C                the pivot vector from SNBCO or SNBFA.
C
C        B       REAL(N)
C                the right hand side vector.
C
C        JOB     INTEGER
C                = 0         to solve  A*X = B .
C                = nonzero   to solve  TRANS(A)*X = B , where
C                            TRANS(A)  is the transpose.
C
C     On Return
C
C        B       the solution vector  X .
C
C     Error Condition
C
C        A division by zero will occur if the input factor contains a
C        zero on the diagonal.  Technically, this indicates singularity,
C        but it is often caused by improper arguments or improper
C        setting of LDA.  It will not occur if the subroutines are
C        called correctly and if SNBCO has set RCOND .GT. 0.0
C        or SNBFA has set INFO .EQ. 0 .
C
C     To compute  INVERSE(A) * C  where  C  is a matrix
C     with  P  columns
C           CALL SNBCO(ABE,LDA,N,ML,MU,IPVT,RCOND,Z)
C           IF (RCOND is too small) GO TO ...
C           DO 10 J = 1, P
C             CALL SNBSL(ABE,LDA,N,ML,MU,IPVT,C(1,J),0)
C        10 CONTINUE
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   800717  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNBSL
      INTEGER LDA,N,ML,MU,IPVT(*),JOB
      REAL ABE(LDA,*),B(*)
C
      REAL SDOT,T
      INTEGER K,KB,L,LB,LDB,LM,M,MLM,NM1
C***FIRST EXECUTABLE STATEMENT  SNBSL
      M=MU+ML+1
      NM1=N-1
      LDB=1-LDA
      IF(JOB.NE.0)GO TO 50
C
C       JOB = 0 , SOLVE  A * X = B
C       FIRST SOLVE L*Y = B
C
        IF(ML.EQ.0)GO TO 30
        IF(NM1.LT.1)GO TO 30
          DO 20 K=1,NM1
            LM=MIN(ML,N-K)
            L=IPVT(K)
            T=B(L)
            IF(L.EQ.K)GO TO 10
              B(L)=B(K)
              B(K)=T
   10       CONTINUE
            MLM=ML-(LM-1)
            CALL SAXPY(LM,T,ABE(K+LM,MLM),LDB,B(K+1),1)
   20     CONTINUE
   30   CONTINUE
C
C       NOW SOLVE  U*X = Y
C
        DO 40 KB=1,N
          K=N+1-KB
          B(K)=B(K)/ABE(K,ML+1)
          LM=MIN(K,M)-1
          LB=K-LM
          T=-B(K)
          CALL SAXPY(LM,T,ABE(K-1,ML+2),LDB,B(LB),1)
   40   CONTINUE
      GO TO 100
   50 CONTINUE
C
C       JOB = NONZERO, SOLVE TRANS(A) * X = B
C       FIRST SOLVE  TRANS(U)*Y = B
C
        DO 60 K = 1, N
          LM = MIN(K,M) - 1
          LB = K - LM
          T = SDOT(LM,ABE(K-1,ML+2),LDB,B(LB),1)
          B(K) = (B(K) - T)/ABE(K,ML+1)
   60   CONTINUE
C
C       NOW SOLVE TRANS(L)*X = Y
C
        IF (ML .EQ. 0) GO TO 90
        IF (NM1 .LT. 1) GO TO 90
          DO 80 KB = 1, NM1
            K = N - KB
            LM = MIN(ML,N-K)
            MLM = ML - (LM - 1)
            B(K) = B(K) + SDOT(LM,ABE(K+LM,MLM),LDB,B(K+1),1)
            L = IPVT(K)
            IF (L .EQ. K) GO TO 70
              T = B(L)
              B(L) = B(K)
              B(K) = T
   70       CONTINUE
   80     CONTINUE
   90   CONTINUE
  100 CONTINUE
      RETURN
      END
*DECK SNLS1
      SUBROUTINE SNLS1 (FCN, IOPT, M, N, X, FVEC, FJAC, LDFJAC, FTOL,
     +   XTOL, GTOL, MAXFEV, EPSFCN, DIAG, MODE, FACTOR, NPRINT, INFO,
     +   NFEV, NJEV, IPVT, QTF, WA1, WA2, WA3, WA4)
C***BEGIN PROLOGUE  SNLS1
C***PURPOSE  Minimize the sum of the squares of M nonlinear functions
C            in N variables by a modification of the Levenberg-Marquardt
C            algorithm.
C***LIBRARY   SLATEC
C***CATEGORY  K1B1A1, K1B1A2
C***TYPE      SINGLE PRECISION (SNLS1-S, DNLS1-D)
C***KEYWORDS  LEVENBERG-MARQUARDT, NONLINEAR DATA FITTING,
C             NONLINEAR LEAST SQUARES
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of SNLS1 is to minimize the sum of the squares of M
C       nonlinear functions in N variables by a modification of the
C       Levenberg-Marquardt algorithm.  The user must provide a subrou-
C       tine which calculates the functions.  The user has the option
C       of how the Jacobian will be supplied.  The user can supply the
C       full Jacobian, or the rows of the Jacobian (to avoid storing
C       the full Jacobian), or let the code approximate the Jacobian by
C       forward-differencing.   This code is the combination of the
C       MINPACK codes (Argonne) LMDER, LMDIF, and LMSTR.
C
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE SNLS1(FCN,IOPT,M,N,X,FVEC,FJAC,LDFJAC,FTOL,XTOL,
C      *                 GTOL,MAXFEV,EPSFCN,DIAG,MODE,FACTOR,NPRINT,INFO
C      *                 ,NFEV,NJEV,IPVT,QTF,WA1,WA2,WA3,WA4)
C       INTEGER IOPT,M,N,LDFJAC,MAXFEV,MODE,NPRINT,INFO,NFEV,NJEV
C       INTEGER IPVT(N)
C       REAL FTOL,XTOL,GTOL,EPSFCN,FACTOR
C       REAL X(N),FVEC(M),FJAC(LDFJAC,N),DIAG(N),QTF(N),
C      *     WA1(N),WA2(N),WA3(N),WA4(M)
C
C
C 3. Parameters.
C
C       Parameters designated as input parameters must be specified on
C       entry to SNLS1 and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from SNLS1.
C
C       FCN is the name of the user-supplied subroutine which calculates
C         the functions.  If the user wants to supply the Jacobian
C         (IOPT=2 or 3), then FCN must be written to calculate the
C         Jacobian, as well as the functions.  See the explanation
C         of the IOPT argument below.
C         If the user wants the iterates printed (NPRINT positive), then
C         FCN must do the printing.  See the explanation of NPRINT
C         below.  FCN must be declared in an EXTERNAL statement in the
C         calling program and should be written as follows.
C
C
C         SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C         INTEGER IFLAG,LDFJAC,M,N
C         REAL X(N),FVEC(M)
C         ----------
C         FJAC and LDFJAC may be ignored     , if IOPT=1.
C         REAL FJAC(LDFJAC,N)                , if IOPT=2.
C         REAL FJAC(N)                       , if IOPT=3.
C         ----------
C           If IFLAG=0, the values in X and FVEC are available
C           for printing.  See the explanation of NPRINT below.
C           IFLAG will never be zero unless NPRINT is positive.
C           The values of X and FVEC must not be changed.
C         RETURN
C         ----------
C           If IFLAG=1, calculate the functions at X and return
C           this vector in FVEC.
C         RETURN
C         ----------
C           If IFLAG=2, calculate the full Jacobian at X and return
C           this matrix in FJAC.  Note that IFLAG will never be 2 unless
C           IOPT=2.  FVEC contains the function values at X and must
C           not be altered.  FJAC(I,J) must be set to the derivative
C           of FVEC(I) with respect to X(J).
C         RETURN
C         ----------
C           If IFLAG=3, calculate the LDFJAC-th row of the Jacobian
C           and return this vector in FJAC.  Note that IFLAG will
C           never be 3 unless IOPT=3.  FVEC contains the function
C           values at X and must not be altered.  FJAC(J) must be
C           set to the derivative of FVEC(LDFJAC) with respect to X(J).
C         RETURN
C         ----------
C         END
C
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of SNLS1.  In this case, set
C         IFLAG to a negative integer.
C
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=2 or 3, then the user must supply the
C         Jacobian, as well as the function values, through the
C         subroutine FCN.  If IOPT=2, the user supplies the full
C         Jacobian with one call to FCN.  If IOPT=3, the user supplies
C         one row of the Jacobian with each call.  (In this manner,
C         storage can be saved because the full Jacobian is not stored.)
C         If IOPT=1, the code will approximate the Jacobian by forward
C         differencing.
C
C       M is a positive integer input variable set to the number of
C         functions.
C
C       N is a positive integer input variable set to the number of
C         variables.  N must not exceed M.
C
C       X is an array of length N.  On input, X must contain an initial
C         estimate of the solution vector.  On output, X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length M which contains the functions
C         evaluated at the output X.
C
C       FJAC is an output array.  For IOPT=1 and 2, FJAC is an M by N
C         array.  For IOPT=3, FJAC is an N by N array.  The upper N by N
C         submatrix of FJAC contains an upper triangular matrix R with
C         diagonal elements of nonincreasing magnitude such that
C
C                T     T           T
C               P *(JAC *JAC)*P = R *R,
C
C         where P is a permutation matrix and JAC is the final calcu-
C         lated Jacobian.  Column J of P is column IPVT(J) (see below)
C         of the identity matrix.  The lower part of FJAC contains
C         information generated during the computation of R.
C
C       LDFJAC is a positive integer input variable which specifies
C         the leading dimension of the array FJAC.  For IOPT=1 and 2,
C         LDFJAC must not be less than M.  For IOPT=3, LDFJAC must not
C         be less than N.
C
C       FTOL is a non-negative input variable.  Termination occurs when
C         both the actual and predicted relative reductions in the sum
C         of squares are at most FTOL.  Therefore, FTOL measures the
C         relative error desired in the sum of squares.  Section 4 con-
C         tains more details about FTOL.
C
C       XTOL is a non-negative input variable.  Termination occurs when
C         the relative error between two consecutive iterates is at most
C         XTOL.  Therefore, XTOL measures the relative error desired in
C         the approximate solution.  Section 4 contains more details
C         about XTOL.
C
C       GTOL is a non-negative input variable.  Termination occurs when
C         the cosine of the angle between FVEC and any column of the
C         Jacobian is at most GTOL in absolute value.  Therefore, GTOL
C         measures the orthogonality desired between the function vector
C         and the columns of the Jacobian.  Section 4 contains more
C         details about GTOL.
C
C       MAXFEV is a positive integer input variable.  Termination occurs
C         when the number of calls to FCN to evaluate the functions
C         has reached MAXFEV.
C
C       EPSFCN is an input variable used in determining a suitable step
C         for the forward-difference approximation.  This approximation
C         assumes that the relative errors in the functions are of the
C         order of EPSFCN.  If EPSFCN is less than the machine preci-
C         sion, it is assumed that the relative errors in the functions
C         are of the order of the machine precision.  If IOPT=2 or 3,
C         then EPSFCN can be ignored (treat it as a dummy argument).
C
C       DIAG is an array of length N.  If MODE = 1 (see below), DIAG is
C         internally set.  If MODE = 2, DIAG must contain positive
C         entries that serve as implicit (multiplicative) scale factors
C         for the variables.
C
C       MODE is an integer input variable.  If MODE = 1, the variables
C         will be scaled internally.  If MODE = 2, the scaling is speci-
C         fied by the input DIAG.  Other values of MODE are equivalent
C         to MODE = 1.
C
C       FACTOR is a positive input variable used in determining the ini-
C         tial step bound.  This bound is set to the product of FACTOR
C         and the Euclidean norm of DIAG*X if nonzero, or else to FACTOR
C         itself.  In most cases FACTOR should lie in the interval
C         (.1,100.).  100. is a generally recommended value.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iterations thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN (see example) and
C         FVEC should not be altered.  If NPRINT is not positive, no
C         special calls to FCN with IFLAG = 0 are made.
C
C       INFO is an integer output variable.  If the user has terminated
C         execution, INFO is set to the (negative) value of IFLAG.  See
C         description of FCN and JAC. Otherwise, INFO is set as follows.
C
C         INFO = 0  improper input parameters.
C
C         INFO = 1  both actual and predicted relative reductions in the
C                   sum of squares are at most FTOL.
C
C         INFO = 2  relative error between two consecutive iterates is
C                   at most XTOL.
C
C         INFO = 3  conditions for INFO = 1 and INFO = 2 both hold.
C
C         INFO = 4  the cosine of the angle between FVEC and any column
C                   of the Jacobian is at most GTOL in absolute value.
C
C         INFO = 5  number of calls to FCN for function evaluation
C                   has reached MAXFEV.
C
C         INFO = 6  FTOL is too small.  No further reduction in the sum
C                   of squares is possible.
C
C         INFO = 7  XTOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         INFO = 8  GTOL is too small.  FVEC is orthogonal to the
C                   columns of the Jacobian to machine precision.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       NFEV is an integer output variable set to the number of calls to
C         FCN for function evaluation.
C
C       NJEV is an integer output variable set to the number of
C         evaluations of the full Jacobian.  If IOPT=2, only one call to
C         FCN is required for each evaluation of the full Jacobian.
C         If IOPT=3, the M calls to FCN are required.
C         If IOPT=1, then NJEV is set to zero.
C
C       IPVT is an integer output array of length N.  IPVT defines a
C         permutation matrix P such that JAC*P = Q*R, where JAC is the
C         final calculated Jacobian, Q is orthogonal (not stored), and R
C         is upper triangular with diagonal elements of nonincreasing
C         magnitude.  Column J of P is column IPVT(J) of the identity
C         matrix.
C
C       QTF is an output array of length N which contains the first N
C         elements of the vector (Q transpose)*FVEC.
C
C       WA1, WA2, and WA3 are work arrays of length N.
C
C       WA4 is a work array of length M.
C
C
C 4. Successful Completion.
C
C       The accuracy of SNLS1 is controlled by the convergence parame-
C       ters FTOL, XTOL, and GTOL.  These parameters are used in tests
C       which make three types of comparisons between the approximation
C       X and a solution XSOL.  SNLS1 terminates when any of the tests
C       is satisfied.  If any of the convergence parameters is less than
C       the machine precision (as defined by the function R1MACH(4)),
C       then SNLS1 only attempts to satisfy the test defined by the
C       machine precision.  Further progress is not usually possible.
C
C       The tests assume that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian are coded consistently.  If these conditions
C       are not satisfied, then SNLS1 may incorrectly indicate conver-
C       gence.  If the Jacobian is coded correctly or IOPT=1,
C       then the validity of the answer can be checked, for example, by
C       rerunning SNLS1 with tighter tolerances.
C
C       First Convergence Test.  If ENORM(Z) denotes the Euclidean norm
C         of a vector Z, then this test attempts to guarantee that
C
C               ENORM(FVEC) .LE. (1+FTOL)*ENORM(FVECS),
C
C         where FVECS denotes the functions evaluated at XSOL.  If this
C         condition is satisfied with FTOL = 10**(-K), then the final
C         residual norm ENORM(FVEC) has K significant decimal digits and
C         INFO is set to 1 (or to 3 if the second test is also satis-
C         fied).  Unless high precision solutions are required, the
C         recommended value for FTOL is the square root of the machine
C         precision.
C
C       Second Convergence Test.  If D is the diagonal matrix whose
C         entries are defined by the array DIAG, then this test attempts
C         to guarantee that
C
C               ENORM(D*(X-XSOL)) .LE. XTOL*ENORM(D*XSOL).
C
C         If this condition is satisfied with XTOL = 10**(-K), then the
C         larger components of D*X have K significant decimal digits and
C         INFO is set to 2 (or to 3 if the first test is also satis-
C         fied).  There is a danger that the smaller components of D*X
C         may have large relative errors, but if MODE = 1, then the
C         accuracy of the components of X is usually related to their
C         sensitivity.  Unless high precision solutions are required,
C         the recommended value for XTOL is the square root of the
C         machine precision.
C
C       Third Convergence Test.  This test is satisfied when the cosine
C         of the angle between FVEC and any column of the Jacobian at X
C         is at most GTOL in absolute value.  There is no clear rela-
C         tionship between this test and the accuracy of SNLS1, and
C         furthermore, the test is equally well satisfied at other crit-
C         ical points, namely maximizers and saddle points.  Therefore,
C         termination caused by this test (INFO = 4) should be examined
C         carefully.  The recommended value for GTOL is zero.
C
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of SNLS1 can be due to improper input
C       parameters, arithmetic interrupts, or an excessive number of
C       function evaluations.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT. 1
C         or IOPT .GT. 3, or N .LE. 0, or M .LT. N, or for IOPT=1 or 2
C         LDFJAC .LT. M, or for IOPT=3 LDFJAC .LT. N, or FTOL .LT. 0.E0,
C         or XTOL .LT. 0.E0, or GTOL .LT. 0.E0, or MAXFEV .LE. 0, or
C         FACTOR .LE. 0.E0.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by SNLS1.  In this
C         case, it may be possible to remedy the situation by rerunning
C         SNLS1 with a smaller value of FACTOR.
C
C       Excessive Number of Function Evaluations.  A reasonable value
C         for MAXFEV is 100*(N+1) for IOPT=2 or 3 and 200*(N+1) for
C         IOPT=1.  If the number of calls to FCN reaches MAXFEV, then
C         this indicates that the routine is converging very slowly
C         as measured by the progress of FVEC, and INFO is set to 5.
C         In this case, it may be helpful to restart SNLS1 with MODE
C         set to 1.
C
C
C 6. Characteristics of the Algorithm.
C
C       SNLS1 is a modification of the Levenberg-Marquardt algorithm.
C       Two of its main characteristics involve the proper use of
C       implicitly scaled variables (if MODE = 1) and an optimal choice
C       for the correction.  The use of implicitly scaled variables
C       achieves scale invariance of SNLS1 and limits the size of the
C       correction in any direction where the functions are changing
C       rapidly.  The optimal choice of the correction guarantees (under
C       reasonable conditions) global convergence from starting points
C       far from the solution and a fast rate of convergence for
C       problems with small residuals.
C
C       Timing.  The time required by SNLS1 to solve a given problem
C         depends on M and N, the behavior of the functions, the accu-
C         racy requested, and the starting point.  The number of arith-
C         metic operations needed by SNLS1 is about N**3 to process each
C         evaluation of the functions (call to FCN) and to process each
C         evaluation of the Jacobian it takes M*N**2 for IOPT=2 (one
C         call to FCN), M*N**2 for IOPT=1 (N calls to FCN) and
C         1.5*M*N**2 for IOPT=3 (M calls to FCN).  Unless FCN
C         can be evaluated quickly, the timing of SNLS1 will be
C         strongly influenced by the time spent in FCN.
C
C       Storage.  SNLS1 requires (M*N + 2*M + 6*N) for IOPT=1 or 2 and
C         (N**2 + 2*M + 6*N) for IOPT=3 single precision storage
C         locations and N integer storage locations, in addition to
C         the storage required by the program.  There are no internally
C         declared storage arrays.
C
C *Long Description:
C
C 7. Example.
C
C       The problem is to determine the values of X(1), X(2), and X(3)
C       which provide the best fit (in the least squares sense) of
C
C             X(1) + U(I)/(V(I)*X(2) + W(I)*X(3)),  I = 1, 15
C
C       to the data
C
C             Y = (0.14,0.18,0.22,0.25,0.29,0.32,0.35,0.39,
C                  0.37,0.58,0.73,0.96,1.34,2.10,4.39),
C
C       where U(I) = I, V(I) = 16 - I, and W(I) = MIN(U(I),V(I)).  The
C       I-th component of FVEC is thus defined by
C
C             Y(I) - (X(1) + U(I)/(V(I)*X(2) + W(I)*X(3))).
C
C       **********
C
C       PROGRAM TEST
C C
C C     Driver for SNLS1 example.
C C
C       INTEGER J,IOPT,M,N,LDFJAC,MAXFEV,MODE,NPRINT,INFO,NFEV,NJEV,
C      *        NWRITE
C       INTEGER IPVT(3)
C       REAL FTOL,XTOL,GTOL,FACTOR,FNORM,EPSFCN
C       REAL X(3),FVEC(15),FJAC(15,3),DIAG(3),QTF(3),
C      *     WA1(3),WA2(3),WA3(3),WA4(15)
C       REAL ENORM,R1MACH
C       EXTERNAL FCN
C       DATA NWRITE /6/
C C
C       IOPT = 1
C       M = 15
C       N = 3
C C
C C     The following starting values provide a rough fit.
C C
C       X(1) = 1.E0
C       X(2) = 1.E0
C       X(3) = 1.E0
C C
C       LDFJAC = 15
C C
C C     Set FTOL and XTOL to the square root of the machine precision
C C     and GTOL to zero.  Unless high precision solutions are
C C     required, these are the recommended settings.
C C
C       FTOL = SQRT(R1MACH(4))
C       XTOL = SQRT(R1MACH(4))
C       GTOL = 0.E0
C C
C       MAXFEV = 400
C       EPSFCN = 0.0
C       MODE = 1
C       FACTOR = 1.E2
C       NPRINT = 0
C C
C       CALL SNLS1(FCN,IOPT,M,N,X,FVEC,FJAC,LDFJAC,FTOL,XTOL,
C      *           GTOL,MAXFEV,EPSFCN,DIAG,MODE,FACTOR,NPRINT,
C      *           INFO,NFEV,NJEV,IPVT,QTF,WA1,WA2,WA3,WA4)
C       FNORM = ENORM(M,FVEC)
C       WRITE (NWRITE,1000) FNORM,NFEV,NJEV,INFO,(X(J),J=1,N)
C       STOP
C  1000 FORMAT (5X,' FINAL L2 NORM OF THE RESIDUALS',E15.7 //
C      *        5X,' NUMBER OF FUNCTION EVALUATIONS',I10 //
C      *        5X,' NUMBER OF JACOBIAN EVALUATIONS',I10 //
C      *        5X,' EXIT PARAMETER',16X,I10 //
C      *        5X,' FINAL APPROXIMATE SOLUTION' // 5X,3E15.7)
C       END
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,DUM,IDUM)
C C     This is the form of the FCN routine if IOPT=1,
C C     that is, if the user does not calculate the Jacobian.
C       INTEGER M,N,IFLAG
C       REAL X(N),FVEC(M)
C       INTEGER I
C       REAL TMP1,TMP2,TMP3,TMP4
C       REAL Y(15)
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C       END
C
C
C       Results obtained with different compilers or machines
C       may be slightly different.
C
C       FINAL L2 NORM OF THE RESIDUALS  0.9063596E-01
C
C       NUMBER OF FUNCTION EVALUATIONS        25
C
C       NUMBER OF JACOBIAN EVALUATIONS         0
C
C       EXIT PARAMETER                         1
C
C       FINAL APPROXIMATE SOLUTION
C
C        0.8241058E-01  0.1133037E+01  0.2343695E+01
C
C
C       For IOPT=2, FCN would be modified as follows to also
C       calculate the full Jacobian when IFLAG=2.
C
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C C
C C     This is the form of the FCN routine if IOPT=2,
C C     that is, if the user calculates the full Jacobian.
C C
C       INTEGER LDFJAC,M,N,IFLAG
C       REAL X(N),FVEC(M)
C       REAL FJAC(LDFJAC,N)
C       INTEGER I
C       REAL TMP1,TMP2,TMP3,TMP4
C       REAL Y(15)
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       IF(IFLAG.NE.1) GO TO 20
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C C
C C     Below, calculate the full Jacobian.
C C
C    20    CONTINUE
C C
C       DO 30 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          TMP4 = (X(2)*TMP2 + X(3)*TMP3)**2
C          FJAC(I,1) = -1.E0
C          FJAC(I,2) = TMP1*TMP2/TMP4
C          FJAC(I,3) = TMP1*TMP3/TMP4
C    30    CONTINUE
C       RETURN
C       END
C
C
C       For IOPT = 3, FJAC would be dimensioned as FJAC(3,3),
C         LDFJAC would be set to 3, and FCN would be written as
C         follows to calculate a row of the Jacobian when IFLAG=3.
C
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C C     This is the form of the FCN routine if IOPT=3,
C C     that is, if the user calculates the Jacobian row by row.
C       INTEGER M,N,IFLAG
C       REAL X(N),FVEC(M)
C       REAL FJAC(N)
C       INTEGER I
C       REAL TMP1,TMP2,TMP3,TMP4
C       REAL Y(15)
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       IF( IFLAG.NE.1) GO TO 20
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C C
C C     Below, calculate the LDFJAC-th row of the Jacobian.
C C
C    20 CONTINUE
C
C       I = LDFJAC
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          TMP4 = (X(2)*TMP2 + X(3)*TMP3)**2
C          FJAC(1) = -1.E0
C          FJAC(2) = TMP1*TMP2/TMP4
C          FJAC(3) = TMP1*TMP3/TMP4
C       RETURN
C       END
C
C***REFERENCES  Jorge J. More, The Levenberg-Marquardt algorithm:
C                 implementation and theory.  In Numerical Analysis
C                 Proceedings (Dundee, June 28 - July 1, 1977, G. A.
C                 Watson, Editor), Lecture Notes in Mathematics 630,
C                 Springer-Verlag, 1978.
C***ROUTINES CALLED  CHKDER, ENORM, FDJAC3, LMPAR, QRFAC, R1MACH,
C                    RWUPDT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNLS1
      INTEGER IOPT,M,N,LDFJAC,MAXFEV,MODE,NPRINT,INFO,NFEV,NJEV
      INTEGER IJUNK,NROW,IPVT(*)
      REAL FTOL,XTOL,GTOL,FACTOR,EPSFCN
      REAL X(*),FVEC(*),FJAC(LDFJAC,*),DIAG(*),QTF(*),WA1(*),WA2(*),
     1     WA3(*),WA4(*)
      LOGICAL SING
      EXTERNAL FCN
      INTEGER I,IFLAG,ITER,J,L,MODECH
      REAL ACTRED,DELTA,DIRDER,EPSMCH,FNORM,FNORM1,GNORM,ONE,PAR,
     1     PNORM,PRERED,P1,P5,P25,P75,P0001,RATIO,SUM,TEMP,TEMP1,
     2     TEMP2,XNORM,ZERO
      REAL R1MACH,ENORM,ERR,CHKLIM
      CHARACTER*8 XERN1
      CHARACTER*16 XERN3
C
      SAVE CHKLIM, ONE, P1, P5, P25, P75, P0001, ZERO
      DATA CHKLIM/.1E0/
      DATA ONE,P1,P5,P25,P75,P0001,ZERO
     1     /1.0E0,1.0E-1,5.0E-1,2.5E-1,7.5E-1,1.0E-4,0.0E0/
C
C***FIRST EXECUTABLE STATEMENT  SNLS1
      EPSMCH = R1MACH(4)
C
      INFO = 0
      IFLAG = 0
      NFEV = 0
      NJEV = 0
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF (IOPT .LT. 1 .OR. IOPT .GT. 3 .OR. N .LE. 0 .OR.
     1    M .LT. N .OR. LDFJAC .LT. N .OR. FTOL .LT. ZERO
     2    .OR. XTOL .LT. ZERO .OR. GTOL .LT. ZERO
     3    .OR. MAXFEV .LE. 0 .OR. FACTOR .LE. ZERO) GO TO 300
      IF (IOPT .LT. 3 .AND. LDFJAC .LT. M) GO TO 300
      IF (MODE .NE. 2) GO TO 20
      DO 10 J = 1, N
         IF (DIAG(J) .LE. ZERO) GO TO 300
   10    CONTINUE
   20 CONTINUE
C
C     EVALUATE THE FUNCTION AT THE STARTING POINT
C     AND CALCULATE ITS NORM.
C
      IFLAG = 1
      IJUNK = 1
      CALL FCN(IFLAG,M,N,X,FVEC,FJAC,IJUNK)
      NFEV = 1
      IF (IFLAG .LT. 0) GO TO 300
      FNORM = ENORM(M,FVEC)
C
C     INITIALIZE LEVENBERG-MARQUARDT PARAMETER AND ITERATION COUNTER.
C
      PAR = ZERO
      ITER = 1
C
C     BEGINNING OF THE OUTER LOOP.
C
   30 CONTINUE
C
C        IF REQUESTED, CALL FCN TO ENABLE PRINTING OF ITERATES.
C
         IF (NPRINT .LE. 0) GO TO 40
         IFLAG = 0
         IF (MOD(ITER-1,NPRINT) .EQ. 0)
     1      CALL FCN(IFLAG,M,N,X,FVEC,FJAC,IJUNK)
         IF (IFLAG .LT. 0) GO TO 300
   40    CONTINUE
C
C        CALCULATE THE JACOBIAN MATRIX.
C
      IF (IOPT .EQ. 3) GO TO 475
C
C     STORE THE FULL JACOBIAN USING M*N STORAGE
C
      IF (IOPT .EQ. 1) GO TO 410
C
C     THE USER SUPPLIES THE JACOBIAN
C
         IFLAG = 2
         CALL FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
         NJEV = NJEV + 1
C
C             ON THE FIRST ITERATION, CHECK THE USER SUPPLIED JACOBIAN
C
         IF (ITER .LE. 1) THEN
            IF (IFLAG .LT. 0) GO TO 300
C
C           GET THE INCREMENTED X-VALUES INTO WA1(*).
C
            MODECH = 1
            CALL CHKDER(M,N,X,FVEC,FJAC,LDFJAC,WA1,WA4,MODECH,ERR)
C
C           EVALUATE FUNCTION AT INCREMENTED VALUE AND PUT IN WA4(*).
C
            IFLAG = 1
            CALL FCN(IFLAG,M,N,WA1,WA4,FJAC,LDFJAC)
            NFEV = NFEV + 1
            IF(IFLAG .LT. 0) GO TO 300
            DO 350 I = 1, M
               MODECH = 2
               CALL CHKDER(1,N,X,FVEC(I),FJAC(I,1),LDFJAC,WA1,
     1              WA4(I),MODECH,ERR)
               IF (ERR .LT. CHKLIM) THEN
                  WRITE (XERN1, '(I8)') I
                  WRITE (XERN3, '(1PE15.6)') ERR
                  CALL XERMSG ('SLATEC', 'SNLS1', 'DERIVATIVE OF ' //
     *               'FUNCTION ' // XERN1 // ' MAY BE WRONG, ERR = ' //
     *               XERN3 // ' TOO CLOSE TO 0.', 7, 0)
               ENDIF
  350       CONTINUE
         ENDIF
C
         GO TO 420
C
C     THE CODE APPROXIMATES THE JACOBIAN
C
410      IFLAG = 1
         CALL FDJAC3(FCN,M,N,X,FVEC,FJAC,LDFJAC,IFLAG,EPSFCN,WA4)
         NFEV = NFEV + N
  420    IF (IFLAG .LT. 0) GO TO 300
C
C        COMPUTE THE QR FACTORIZATION OF THE JACOBIAN.
C
         CALL QRFAC(M,N,FJAC,LDFJAC,.TRUE.,IPVT,N,WA1,WA2,WA3)
C
C        FORM (Q TRANSPOSE)*FVEC AND STORE THE FIRST N COMPONENTS IN
C        QTF.
C
         DO 430 I = 1, M
            WA4(I) = FVEC(I)
  430         CONTINUE
         DO 470 J = 1, N
            IF (FJAC(J,J) .EQ. ZERO) GO TO 460
            SUM = ZERO
            DO 440 I = J, M
               SUM = SUM + FJAC(I,J)*WA4(I)
  440          CONTINUE
            TEMP = -SUM/FJAC(J,J)
            DO 450 I = J, M
               WA4(I) = WA4(I) + FJAC(I,J)*TEMP
  450          CONTINUE
  460       CONTINUE
            FJAC(J,J) = WA1(J)
            QTF(J) = WA4(J)
  470       CONTINUE
         GO TO 560
C
C        ACCUMULATE THE JACOBIAN BY ROWS IN ORDER TO SAVE STORAGE.
C        COMPUTE THE QR FACTORIZATION OF THE JACOBIAN MATRIX
C        CALCULATED ONE ROW AT A TIME, WHILE SIMULTANEOUSLY
C        FORMING (Q TRANSPOSE)*FVEC AND STORING THE FIRST
C        N COMPONENTS IN QTF.
C
  475    DO 490 J = 1, N
            QTF(J) = ZERO
            DO 480 I = 1, N
               FJAC(I,J) = ZERO
  480          CONTINUE
  490        CONTINUE
         DO 500 I = 1, M
            NROW = I
            IFLAG = 3
            CALL FCN(IFLAG,M,N,X,FVEC,WA3,NROW)
            IF (IFLAG .LT. 0) GO TO 300
C
C            ON THE FIRST ITERATION, CHECK THE USER SUPPLIED JACOBIAN.
C
            IF(ITER .GT. 1) GO TO 498
C
C            GET THE INCREMENTED X-VALUES INTO WA1(*).
C
            MODECH = 1
            CALL CHKDER(M,N,X,FVEC,FJAC,LDFJAC,WA1,WA4,MODECH,ERR)
C
C            EVALUATE AT INCREMENTED VALUES, IF NOT ALREADY EVALUATED.
C
            IF(I .NE. 1) GO TO 495
C
C            EVALUATE FUNCTION AT INCREMENTED VALUE AND PUT INTO WA4(*).
C
            IFLAG = 1
            CALL FCN(IFLAG,M,N,WA1,WA4,FJAC,NROW)
            NFEV = NFEV + 1
            IF(IFLAG .LT. 0) GO TO 300
495         CONTINUE
            MODECH = 2
            CALL CHKDER(1,N,X,FVEC(I),WA3,1,WA1,WA4(I),MODECH,ERR)
            IF (ERR .LT. CHKLIM) THEN
               WRITE (XERN1, '(I8)') I
               WRITE (XERN3, '(1PE15.6)') ERR
               CALL XERMSG ('SLATEC', 'SNLS1', 'DERIVATIVE OF FUNCTION '
     *            // XERN1 // ' MAY BE WRONG, ERR = ' // XERN3 //
     *            ' TOO CLOSE TO 0.', 7, 0)
            ENDIF
498         CONTINUE
C
            TEMP = FVEC(I)
            CALL RWUPDT(N,FJAC,LDFJAC,WA3,QTF,TEMP,WA1,WA2)
  500       CONTINUE
         NJEV = NJEV + 1
C
C        IF THE JACOBIAN IS RANK DEFICIENT, CALL QRFAC TO
C        REORDER ITS COLUMNS AND UPDATE THE COMPONENTS OF QTF.
C
         SING = .FALSE.
         DO 510 J = 1, N
            IF (FJAC(J,J) .EQ. ZERO) SING = .TRUE.
            IPVT(J) = J
            WA2(J) = ENORM(J,FJAC(1,J))
  510       CONTINUE
         IF (.NOT.SING) GO TO 560
         CALL QRFAC(N,N,FJAC,LDFJAC,.TRUE.,IPVT,N,WA1,WA2,WA3)
         DO 550 J = 1, N
            IF (FJAC(J,J) .EQ. ZERO) GO TO 540
            SUM = ZERO
            DO 520 I = J, N
               SUM = SUM + FJAC(I,J)*QTF(I)
  520         CONTINUE
            TEMP = -SUM/FJAC(J,J)
            DO 530 I = J, N
               QTF(I) = QTF(I) + FJAC(I,J)*TEMP
  530          CONTINUE
  540       CONTINUE
            FJAC(J,J) = WA1(J)
  550       CONTINUE
  560    CONTINUE
C
C        ON THE FIRST ITERATION AND IF MODE IS 1, SCALE ACCORDING
C        TO THE NORMS OF THE COLUMNS OF THE INITIAL JACOBIAN.
C
         IF (ITER .NE. 1) GO TO 80
         IF (MODE .EQ. 2) GO TO 60
         DO 50 J = 1, N
            DIAG(J) = WA2(J)
            IF (WA2(J) .EQ. ZERO) DIAG(J) = ONE
   50       CONTINUE
   60    CONTINUE
C
C        ON THE FIRST ITERATION, CALCULATE THE NORM OF THE SCALED X
C        AND INITIALIZE THE STEP BOUND DELTA.
C
         DO 70 J = 1, N
            WA3(J) = DIAG(J)*X(J)
   70       CONTINUE
         XNORM = ENORM(N,WA3)
         DELTA = FACTOR*XNORM
         IF (DELTA .EQ. ZERO) DELTA = FACTOR
   80    CONTINUE
C
C        COMPUTE THE NORM OF THE SCALED GRADIENT.
C
         GNORM = ZERO
         IF (FNORM .EQ. ZERO) GO TO 170
         DO 160 J = 1, N
            L = IPVT(J)
            IF (WA2(L) .EQ. ZERO) GO TO 150
            SUM = ZERO
            DO 140 I = 1, J
               SUM = SUM + FJAC(I,J)*(QTF(I)/FNORM)
  140          CONTINUE
            GNORM = MAX(GNORM,ABS(SUM/WA2(L)))
  150       CONTINUE
  160       CONTINUE
  170    CONTINUE
C
C        TEST FOR CONVERGENCE OF THE GRADIENT NORM.
C
         IF (GNORM .LE. GTOL) INFO = 4
         IF (INFO .NE. 0) GO TO 300
C
C        RESCALE IF NECESSARY.
C
         IF (MODE .EQ. 2) GO TO 190
         DO 180 J = 1, N
            DIAG(J) = MAX(DIAG(J),WA2(J))
  180       CONTINUE
  190    CONTINUE
C
C        BEGINNING OF THE INNER LOOP.
C
  200    CONTINUE
C
C           DETERMINE THE LEVENBERG-MARQUARDT PARAMETER.
C
            CALL LMPAR(N,FJAC,LDFJAC,IPVT,DIAG,QTF,DELTA,PAR,WA1,WA2,
     1                 WA3,WA4)
C
C           STORE THE DIRECTION P AND X + P. CALCULATE THE NORM OF P.
C
            DO 210 J = 1, N
               WA1(J) = -WA1(J)
               WA2(J) = X(J) + WA1(J)
               WA3(J) = DIAG(J)*WA1(J)
  210          CONTINUE
            PNORM = ENORM(N,WA3)
C
C           ON THE FIRST ITERATION, ADJUST THE INITIAL STEP BOUND.
C
            IF (ITER .EQ. 1) DELTA = MIN(DELTA,PNORM)
C
C           EVALUATE THE FUNCTION AT X + P AND CALCULATE ITS NORM.
C
            IFLAG = 1
            CALL FCN(IFLAG,M,N,WA2,WA4,FJAC,IJUNK)
            NFEV = NFEV + 1
            IF (IFLAG .LT. 0) GO TO 300
            FNORM1 = ENORM(M,WA4)
C
C           COMPUTE THE SCALED ACTUAL REDUCTION.
C
            ACTRED = -ONE
            IF (P1*FNORM1 .LT. FNORM) ACTRED = ONE - (FNORM1/FNORM)**2
C
C           COMPUTE THE SCALED PREDICTED REDUCTION AND
C           THE SCALED DIRECTIONAL DERIVATIVE.
C
            DO 230 J = 1, N
               WA3(J) = ZERO
               L = IPVT(J)
               TEMP = WA1(L)
               DO 220 I = 1, J
                  WA3(I) = WA3(I) + FJAC(I,J)*TEMP
  220             CONTINUE
  230          CONTINUE
            TEMP1 = ENORM(N,WA3)/FNORM
            TEMP2 = (SQRT(PAR)*PNORM)/FNORM
            PRERED = TEMP1**2 + TEMP2**2/P5
            DIRDER = -(TEMP1**2 + TEMP2**2)
C
C           COMPUTE THE RATIO OF THE ACTUAL TO THE PREDICTED
C           REDUCTION.
C
            RATIO = ZERO
            IF (PRERED .NE. ZERO) RATIO = ACTRED/PRERED
C
C           UPDATE THE STEP BOUND.
C
            IF (RATIO .GT. P25) GO TO 240
               IF (ACTRED .GE. ZERO) TEMP = P5
               IF (ACTRED .LT. ZERO)
     1            TEMP = P5*DIRDER/(DIRDER + P5*ACTRED)
               IF (P1*FNORM1 .GE. FNORM .OR. TEMP .LT. P1) TEMP = P1
               DELTA = TEMP*MIN(DELTA,PNORM/P1)
               PAR = PAR/TEMP
               GO TO 260
  240       CONTINUE
               IF (PAR .NE. ZERO .AND. RATIO .LT. P75) GO TO 250
               DELTA = PNORM/P5
               PAR = P5*PAR
  250          CONTINUE
  260       CONTINUE
C
C           TEST FOR SUCCESSFUL ITERATION.
C
            IF (RATIO .LT. P0001) GO TO 290
C
C           SUCCESSFUL ITERATION. UPDATE X, FVEC, AND THEIR NORMS.
C
            DO 270 J = 1, N
               X(J) = WA2(J)
               WA2(J) = DIAG(J)*X(J)
  270          CONTINUE
            DO 280 I = 1, M
               FVEC(I) = WA4(I)
  280          CONTINUE
            XNORM = ENORM(N,WA2)
            FNORM = FNORM1
            ITER = ITER + 1
  290       CONTINUE
C
C           TESTS FOR CONVERGENCE.
C
            IF (ABS(ACTRED) .LE. FTOL .AND. PRERED .LE. FTOL
     1          .AND. P5*RATIO .LE. ONE) INFO = 1
            IF (DELTA .LE. XTOL*XNORM) INFO = 2
            IF (ABS(ACTRED) .LE. FTOL .AND. PRERED .LE. FTOL
     1          .AND. P5*RATIO .LE. ONE .AND. INFO .EQ. 2) INFO = 3
            IF (INFO .NE. 0) GO TO 300
C
C           TESTS FOR TERMINATION AND STRINGENT TOLERANCES.
C
            IF (NFEV .GE. MAXFEV) INFO = 5
            IF (ABS(ACTRED) .LE. EPSMCH .AND. PRERED .LE. EPSMCH
     1          .AND. P5*RATIO .LE. ONE) INFO = 6
            IF (DELTA .LE. EPSMCH*XNORM) INFO = 7
            IF (GNORM .LE. EPSMCH) INFO = 8
            IF (INFO .NE. 0) GO TO 300
C
C           END OF THE INNER LOOP. REPEAT IF ITERATION UNSUCCESSFUL.
C
            IF (RATIO .LT. P0001) GO TO 200
C
C        END OF THE OUTER LOOP.
C
         GO TO 30
  300 CONTINUE
C
C     TERMINATION, EITHER NORMAL OR USER IMPOSED.
C
      IF (IFLAG .LT. 0) INFO = IFLAG
      IFLAG = 0
      IF (NPRINT .GT. 0) CALL FCN(IFLAG,M,N,X,FVEC,FJAC,IJUNK)
      IF (INFO .LT. 0) CALL XERMSG ('SLATEC', 'SNLS1',
     +   'EXECUTION TERMINATED BECAUSE USER SET IFLAG NEGATIVE.', 1, 1)
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'SNLS1',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      IF (INFO .EQ. 4) CALL XERMSG ('SLATEC', 'SNLS1',
     +   'THIRD CONVERGENCE CONDITION, CHECK RESULTS BEFORE ACCEPTING.',
     +   1, 1)
      IF (INFO .EQ. 5) CALL XERMSG ('SLATEC', 'SNLS1',
     +   'TOO MANY FUNCTION EVALUATIONS.', 9, 1)
      IF (INFO .GE. 6) CALL XERMSG ('SLATEC', 'SNLS1',
     +   'TOLERANCES TOO SMALL, NO FURTHER IMPROVEMENT POSSIBLE.', 3, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE SNLS1.
C
      END
*DECK SNLS1E
      SUBROUTINE SNLS1E (FCN, IOPT, M, N, X, FVEC, TOL, NPRINT, INFO,
     +   IW, WA, LWA)
C***BEGIN PROLOGUE  SNLS1E
C***PURPOSE  An easy-to-use code which minimizes the sum of the squares
C            of M nonlinear functions in N variables by a modification
C            of the Levenberg-Marquardt algorithm.
C***LIBRARY   SLATEC
C***CATEGORY  K1B1A1, K1B1A2
C***TYPE      SINGLE PRECISION (SNLS1E-S, DNLS1E-D)
C***KEYWORDS  EASY-TO-USE, LEVENBERG-MARQUARDT, NONLINEAR DATA FITTING,
C             NONLINEAR LEAST SQUARES
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of SNLS1E is to minimize the sum of the squares of M
C       nonlinear functions in N variables by a modification of the
C       Levenberg-Marquardt algorithm.  This is done by using the more
C       general least-squares solver SNLS1.  The user must provide a
C       subroutine which calculates the functions.  The user has the
C       option of how the Jacobian will be supplied.  The user can
C       supply the full Jacobian, or the rows of the Jacobian (to avoid
C       storing the full Jacobian), or let the code approximate the
C       Jacobian by forward-differencing.  This code is the combination
C       of the MINPACK codes (Argonne) LMDER1, LMDIF1, and LMSTR1.
C
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE SNLS1E(FCN,IOPT,M,N,X,FVEC,TOL,NPRINT,
C      *                  INFO,IW,WA,LWA)
C       INTEGER IOPT,M,N,NPRINT,INFO,LWA
C       INTEGER IW(N)
C       REAL TOL
C       REAL X(N),FVEC(M),WA(LWA)
C       EXTERNAL FCN
C
C
C 3. Parameters.
C
C       Parameters designated as input parameters must be specified on
C       entry to SNLS1E and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from SNLS1E.
C
C       FCN is the name of the user-supplied subroutine which calculates
C         the functions.  If the user wants to supply the Jacobian
C         (IOPT=2 or 3), then FCN must be written to calculate the
C         Jacobian, as well as the functions.  See the explanation
C         of the IOPT argument below.
C         If the user wants the iterates printed (NPRINT positive), then
C         FCN must do the printing.  See the explanation of NPRINT
C         below.  FCN must be declared in an EXTERNAL statement in the
C         calling program and should be written as follows.
C
C
C         SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C         INTEGER IFLAG,LDFJAC,M,N
C         REAL X(N),FVEC(M)
C         ----------
C         FJAC and LDFJAC may be ignored     , if IOPT=1.
C         REAL FJAC(LDFJAC,N)                , if IOPT=2.
C         REAL FJAC(N)                       , if IOPT=3.
C         ----------
C           If IFLAG=0, the values in X and FVEC are available
C           for printing.  See the explanation of NPRINT below.
C           IFLAG will never be zero unless NPRINT is positive.
C           The values of X and FVEC must not be changed.
C         RETURN
C         ----------
C           If IFLAG=1, calculate the functions at X and return
C           this vector in FVEC.
C         RETURN
C         ----------
C           If IFLAG=2, calculate the full Jacobian at X and return
C           this matrix in FJAC.  Note that IFLAG will never be 2 unless
C           IOPT=2.  FVEC contains the function values at X and must
C           not be altered.  FJAC(I,J) must be set to the derivative
C           of FVEC(I) with respect to X(J).
C         RETURN
C         ----------
C           If IFLAG=3, calculate the LDFJAC-th row of the Jacobian
C           and return this vector in FJAC.  Note that IFLAG will
C           never be 3 unless IOPT=3.  FVEC contains the function
C           values at X and must not be altered.  FJAC(J) must be
C           set to the derivative of FVEC(LDFJAC) with respect to X(J).
C         RETURN
C         ----------
C         END
C
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of SNLS1E.  In this case,
C         set IFLAG to a negative integer.
C
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=2 or 3, then the user must supply the
C         Jacobian, as well as the function values, through the
C         subroutine FCN.  If IOPT=2, the user supplies the full
C         Jacobian with one call to FCN.  If IOPT=3, the user supplies
C         one row of the Jacobian with each call.  (In this manner,
C         storage can be saved because the full Jacobian is not stored.)
C         If IOPT=1, the code will approximate the Jacobian by forward
C         differencing.
C
C       M is a positive integer input variable set to the number of
C         functions.
C
C       N is a positive integer input variable set to the number of
C         variables.  N must not exceed M.
C
C       X is an array of length N.  On input, X must contain an initial
C         estimate of the solution vector.  On output, X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length M which contains the functions
C         evaluated at the output X.
C
C       TOL is a non-negative input variable.  Termination occurs when
C         the algorithm estimates either that the relative error in the
C         sum of squares is at most TOL or that the relative error
C         between X and the solution is at most TOL.  Section 4 contains
C         more details about TOL.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iterations thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN (see example) and
C         FVEC should not be altered.  If NPRINT is not positive, no
C         special calls of FCN with IFLAG = 0 are made.
C
C       INFO is an integer output variable.  If the user has terminated
C         execution, INFO is set to the (negative) value of IFLAG.  See
C         description of FCN and JAC. Otherwise, INFO is set as follows.
C
C         INFO = 0  improper input parameters.
C
C         INFO = 1  algorithm estimates that the relative error in the
C                   sum of squares is at most TOL.
C
C         INFO = 2  algorithm estimates that the relative error between
C                   X and the solution is at most TOL.
C
C         INFO = 3  conditions for INFO = 1 and INFO = 2 both hold.
C
C         INFO = 4  FVEC is orthogonal to the columns of the Jacobian to
C                   machine precision.
C
C         INFO = 5  number of calls to FCN has reached 100*(N+1)
C                   for IOPT=2 or 3 or 200*(N+1) for IOPT=1.
C
C         INFO = 6  TOL is too small.  No further reduction in the sum
C                   of squares is possible.
C
C         INFO = 7  TOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       IW is an INTEGER work array of length N.
C
C       WA is a work array of length LWA.
C
C       LWA is a positive integer input variable not less than
C         N*(M+5)+M for IOPT=1 and 2 or N*(N+5)+M for IOPT=3.
C
C
C 4. Successful Completion.
C
C       The accuracy of SNLS1E is controlled by the convergence parame-
C       ter TOL.  This parameter is used in tests which make three types
C       of comparisons between the approximation X and a solution XSOL.
C       SNLS1E terminates when any of the tests is satisfied.  If TOL is
C       less than the machine precision (as defined by the function
C       R1MACH(4)), then SNLS1E only attempts to satisfy the test
C       defined by the machine precision.  Further progress is not usu-
C       ally possible.  Unless high precision solutions are required,
C       the recommended value for TOL is the square root of the machine
C       precision.
C
C       The tests assume that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian are coded consistently.  If these conditions
C       are not satisfied, then SNLS1E may incorrectly indicate conver-
C       gence.  If the Jacobian is coded correctly or IOPT=1,
C       then the validity of the answer can be checked, for example, by
C       rerunning SNLS1E with tighter tolerances.
C
C       First Convergence Test.  If ENORM(Z) denotes the Euclidean norm
C         of a vector Z, then this test attempts to guarantee that
C
C               ENORM(FVEC) .LE. (1+TOL)*ENORM(FVECS),
C
C         where FVECS denotes the functions evaluated at XSOL.  If this
C         condition is satisfied with TOL = 10**(-K), then the final
C         residual norm ENORM(FVEC) has K significant decimal digits and
C         INFO is set to 1 (or to 3 if the second test is also satis-
C         fied).
C
C       Second Convergence Test.  If D is a diagonal matrix (implicitly
C         generated by SNLS1E) whose entries contain scale factors for
C         the variables, then this test attempts to guarantee that
C
C               ENORM(D*(X-XSOL)) .LE.  TOL*ENORM(D*XSOL).
C
C         If this condition is satisfied with TOL = 10**(-K), then the
C         larger components of D*X have K significant decimal digits and
C         INFO is set to 2 (or to 3 if the first test is also satis-
C         fied).  There is a danger that the smaller components of D*X
C         may have large relative errors, but the choice of D is such
C         that the accuracy of the components of X is usually related to
C         their sensitivity.
C
C       Third Convergence Test.  This test is satisfied when FVEC is
C         orthogonal to the columns of the Jacobian to machine preci-
C         sion.  There is no clear relationship between this test and
C         the accuracy of SNLS1E, and furthermore, the test is equally
C         well satisfied at other critical points, namely maximizers and
C         saddle points.  Therefore, termination caused by this test
C         (INFO = 4) should be examined carefully.
C
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of SNLS1E can be due to improper input
C       parameters, arithmetic interrupts, or an excessive number of
C       function evaluations.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT. 1
C         or IOPT .GT. 3, or N .LE. 0, or M .LT. N, or TOL .LT. 0.E0,
C         or for IOPT=1 or 2 LWA .LT. N*(M+5)+M, or for IOPT=3
C         LWA .LT. N*(N+5)+M.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by SNLS1E.  In this
C         case, it may be possible to remedy the situation by not evalu-
C         ating the functions here, but instead setting the components
C         of FVEC to numbers that exceed those in the initial FVEC.
C
C       Excessive Number of Function Evaluations.  If the number of
C         calls to FCN reaches 100*(N+1) for IOPT=2 or 3 or 200*(N+1)
C         for IOPT=1, then this indicates that the routine is converging
C         very slowly as measured by the progress of FVEC, and INFO is
C         set to 5.  In this case, it may be helpful to restart SNLS1E,
C         thereby forcing it to disregard old (and possibly harmful)
C         information.
C
C
C 6. Characteristics of the Algorithm.
C
C       SNLS1E is a modification of the Levenberg-Marquardt algorithm.
C       Two of its main characteristics involve the proper use of
C       implicitly scaled variables and an optimal choice for the cor-
C       rection.  The use of implicitly scaled variables achieves scale
C       invariance of SNLS1E and limits the size of the correction in
C       any direction where the functions are changing rapidly.  The
C       optimal choice of the correction guarantees (under reasonable
C       conditions) global convergence from starting points far from the
C       solution and a fast rate of convergence for problems with small
C       residuals.
C
C       Timing.  The time required by SNLS1E to solve a given problem
C         depends on M and N, the behavior of the functions, the accu-
C         racy requested, and the starting point.  The number of arith-
C         metic operations needed by SNLS1E is about N**3 to process
C         each evaluation of the functions (call to FCN) and to process
C         each evaluation of the Jacobian SNLS1E takes M*N**2 for IOPT=2
C         (one call to JAC), M*N**2 for IOPT=1 (N calls to FCN) and
C         1.5*M*N**2 for IOPT=3 (M calls to FCN).  Unless FCN
C         can be evaluated quickly, the timing of SNLS1E will be
C         strongly influenced by the time spent in FCN.
C
C       Storage.  SNLS1E requires (M*N + 2*M + 6*N) for IOPT=1 or 2 and
C         (N**2 + 2*M + 6*N) for IOPT=3 single precision storage
C         locations and N integer storage locations, in addition to
C         the storage required by the program.  There are no internally
C         declared storage arrays.
C
C *Long Description:
C
C 7. Example.
C
C       The problem is to determine the values of X(1), X(2), and X(3)
C       which provide the best fit (in the least squares sense) of
C
C             X(1) + U(I)/(V(I)*X(2) + W(I)*X(3)),  I = 1, 15
C
C       to the data
C
C             Y = (0.14,0.18,0.22,0.25,0.29,0.32,0.35,0.39,
C                  0.37,0.58,0.73,0.96,1.34,2.10,4.39),
C
C       where U(I) = I, V(I) = 16 - I, and W(I) = MIN(U(I),V(I)).  The
C       I-th component of FVEC is thus defined by
C
C             Y(I) - (X(1) + U(I)/(V(I)*X(2) + W(I)*X(3))).
C
C       **********
C
C       PROGRAM TEST
C C
C C     Driver for SNLS1E example.
C C
C       INTEGER I,IOPT,M,N,NPRINT,JNFO,LWA,NWRITE
C       INTEGER IW(3)
C       REAL TOL,FNORM
C       REAL X(3),FVEC(15),WA(75)
C       REAL ENORM,R1MACH
C       EXTERNAL FCN
C       DATA NWRITE /6/
C C
C       IOPT = 1
C       M = 15
C       N = 3
C C
C C     The following starting values provide a rough fit.
C C
C       X(1) = 1.E0
C       X(2) = 1.E0
C       X(3) = 1.E0
C C
C       LWA = 75
C       NPRINT = 0
C C
C C     Set TOL to the square root of the machine precision.
C C     Unless high precision solutions are required,
C C     this is the recommended setting.
C C
C       TOL = SQRT(R1MACH(4))
C C
C       CALL SNLS1E(FCN,IOPT,M,N,X,FVEC,TOL,NPRINT,
C      *            INFO,IW,WA,LWA)
C       FNORM = ENORM(M,FVEC)
C       WRITE (NWRITE,1000) FNORM,INFO,(X(J),J=1,N)
C       STOP
C  1000 FORMAT (5X,' FINAL L2 NORM OF THE RESIDUALS',E15.7 //
C      *        5X,' EXIT PARAMETER',16X,I10 //
C      *        5X,' FINAL APPROXIMATE SOLUTION' // 5X,3E15.7)
C       END
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,DUM,IDUM)
C C     This is the form of the FCN routine if IOPT=1,
C C     that is, if the user does not calculate the Jacobian.
C       INTEGER M,N,IFLAG
C       REAL X(N),FVEC(M)
C       INTEGER I
C       REAL TMP1,TMP2,TMP3,TMP4
C       REAL Y(15)
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C       END
C
C
C       Results obtained with different compilers or machines
C       may be slightly different.
C
C       FINAL L2 NORM OF THE RESIDUALS  0.9063596E-01
C
C       EXIT PARAMETER                         1
C
C       FINAL APPROXIMATE SOLUTION
C
C        0.8241058E-01  0.1133037E+01  0.2343695E+01
C
C
C       For IOPT=2, FCN would be modified as follows to also
C       calculate the full Jacobian when IFLAG=2.
C
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C C
C C     This is the form of the FCN routine if IOPT=2,
C C     that is, if the user calculates the full Jacobian.
C C
C       INTEGER LDFJAC,M,N,IFLAG
C       REAL X(N),FVEC(M)
C       REAL FJAC(LDFJAC,N)
C       INTEGER I
C       REAL TMP1,TMP2,TMP3,TMP4
C       REAL Y(15)
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       IF(IFLAG.NE.1) GO TO 20
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C C
C C     Below, calculate the full Jacobian.
C C
C    20    CONTINUE
C C
C       DO 30 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          TMP4 = (X(2)*TMP2 + X(3)*TMP3)**2
C          FJAC(I,1) = -1.E0
C          FJAC(I,2) = TMP1*TMP2/TMP4
C          FJAC(I,3) = TMP1*TMP3/TMP4
C    30    CONTINUE
C       RETURN
C       END
C
C
C       For IOPT = 3, FJAC would be dimensioned as FJAC(3,3),
C         LDFJAC would be set to 3, and FCN would be written as
C         follows to calculate a row of the Jacobian when IFLAG=3.
C
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C C     This is the form of the FCN routine if IOPT=3,
C C     that is, if the user calculates the Jacobian row by row.
C       INTEGER M,N,IFLAG
C       REAL X(N),FVEC(M)
C       REAL FJAC(N)
C       INTEGER I
C       REAL TMP1,TMP2,TMP3,TMP4
C       REAL Y(15)
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       IF( IFLAG.NE.1) GO TO 20
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C C
C C     Below, calculate the LDFJAC-th row of the Jacobian.
C C
C    20 CONTINUE
C
C       I = LDFJAC
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          TMP4 = (X(2)*TMP2 + X(3)*TMP3)**2
C          FJAC(1) = -1.E0
C          FJAC(2) = TMP1*TMP2/TMP4
C          FJAC(3) = TMP1*TMP3/TMP4
C       RETURN
C       END
C
C***REFERENCES  Jorge J. More, The Levenberg-Marquardt algorithm:
C                 implementation and theory.  In Numerical Analysis
C                 Proceedings (Dundee, June 28 - July 1, 1977, G. A.
C                 Watson, Editor), Lecture Notes in Mathematics 630,
C                 Springer-Verlag, 1978.
C***ROUTINES CALLED  SNLS1, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890206  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNLS1E
      INTEGER M,N,NPRINT,INFO,LWA,IOPT
      INTEGER INDEX,IW(*)
      REAL TOL
      REAL X(*),FVEC(*),WA(*)
      EXTERNAL FCN
      INTEGER MAXFEV,MODE,NFEV,NJEV
      REAL FACTOR,FTOL,GTOL,XTOL,ZERO,EPSFCN
      SAVE FACTOR, ZERO
      DATA FACTOR,ZERO /1.0E2,0.0E0/
C***FIRST EXECUTABLE STATEMENT  SNLS1E
      INFO = 0
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF (IOPT .LT. 1 .OR. IOPT .GT. 3 .OR.
     1    N .LE. 0 .OR. M .LT. N .OR. TOL .LT. ZERO
     2    .OR. LWA .LT. N*(N+5) + M) GO TO 10
      IF (IOPT .LT. 3 .AND. LWA .LT. N*(M+5) + M) GO TO 10
C
C     CALL SNLS1.
C
      MAXFEV = 100*(N + 1)
      IF (IOPT .EQ. 1) MAXFEV = 2*MAXFEV
      FTOL = TOL
      XTOL = TOL
      GTOL = ZERO
      EPSFCN = ZERO
      MODE = 1
      INDEX = 5*N+M
      CALL SNLS1(FCN,IOPT,M,N,X,FVEC,WA(INDEX+1),M,FTOL,XTOL,GTOL,
     1           MAXFEV,EPSFCN,WA(1),MODE,FACTOR,NPRINT,INFO,NFEV,NJEV,
     2           IW,WA(N+1),WA(2*N+1),WA(3*N+1),WA(4*N+1),WA(5*N+1))
      IF (INFO .EQ. 8) INFO = 4
   10 CONTINUE
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'SNLS1E',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE SNLS1E.
C
      END
*DECK SNSQ
      SUBROUTINE SNSQ (FCN, JAC, IOPT, N, X, FVEC, FJAC, LDFJAC, XTOL,
     +   MAXFEV, ML, MU, EPSFCN, DIAG, MODE, FACTOR, NPRINT, INFO, NFEV,
     +   NJEV, R, LR, QTF, WA1, WA2, WA3, WA4)
C***BEGIN PROLOGUE  SNSQ
C***PURPOSE  Find a zero of a system of a N nonlinear functions in N
C            variables by a modification of the Powell hybrid method.
C***LIBRARY   SLATEC
C***CATEGORY  F2A
C***TYPE      SINGLE PRECISION (SNSQ-S, DNSQ-D)
C***KEYWORDS  NONLINEAR SQUARE SYSTEM, POWELL HYBRID METHOD, ZEROS
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of SNSQ is to find a zero of a system of N non-
C       linear functions in N variables by a modification of the Powell
C       hybrid method.  The user must provide a subroutine which calcu-
C       lates the functions.  The user has the option of either to
C       provide a subroutine which calculates the Jacobian or to let the
C       code calculate it by a forward-difference approximation.
C       This code is the combination of the MINPACK codes (Argonne)
C       HYBRD and HYBRDJ.
C
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE SNSQ(FCN,JAC,IOPT,N,X,FVEC,FJAC,LDFJAC,XTOL,MAXFEV,
C      *                 ML,MU,EPSFCN,DIAG,MODE,FACTOR,NPRINT,INFO,NFEV,
C      *                 NJEV,R,LR,QTF,WA1,WA2,WA3,WA4)
C       INTEGER IOPT,N,MAXFEV,ML,MU,MODE,NPRINT,INFO,NFEV,LDFJAC,NJEV,LR
C       REAL XTOL,EPSFCN,FACTOR
C       REAL X(N),FVEC(N),DIAG(N),FJAC(LDFJAC,N),R(LR),QTF(N),
C      *     WA1(N),WA2(N),WA3(N),WA4(N)
C       EXTERNAL FCN,JAC
C
C
C 3. Parameters.
C
C       Parameters designated as input parameters must be specified on
C       entry to SNSQ and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from SNSQ.
C
C       FCN is the name of the user-supplied subroutine which calculates
C         the functions.  FCN must be declared in an EXTERNAL statement
C         in the user calling program, and should be written as follows.
C
C         SUBROUTINE FCN(N,X,FVEC,IFLAG)
C         INTEGER N,IFLAG
C         REAL X(N),FVEC(N)
C         ----------
C         Calculate the functions at X and
C         return this vector in FVEC.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of SNSQ.  In this case, set
C         IFLAG to a negative integer.
C
C       JAC is the name of the user-supplied subroutine which calculates
C         the Jacobian.  If IOPT=1, then JAC must be declared in an
C         EXTERNAL statement in the user calling program, and should be
C         written as follows.
C
C         SUBROUTINE JAC(N,X,FVEC,FJAC,LDFJAC,IFLAG)
C         INTEGER N,LDFJAC,IFLAG
C         REAL X(N),FVEC(N),FJAC(LDFJAC,N)
C         ----------
C         Calculate the Jacobian at X and return this
C         matrix in FJAC.  FVEC contains the function
C         values at X and should not be altered.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by JAC unless the
C         user wants to terminate execution of SNSQ.  In this case, set
C         IFLAG to a negative integer.
C
C         If IOPT=2, JAC can be ignored (treat it as a dummy argument).
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=1, then the user must supply the
C         Jacobian through the subroutine JAC.  If IOPT=2, then the
C         code will approximate the Jacobian by forward-differencing.
C
C       N is a positive integer input variable set to the number of
C         functions and variables.
C
C       X is an array of length N.  On input, X must contain an initial
C         estimate of the solution vector.  On output, X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length N which contains the functions
C         evaluated at the output X.
C
C       FJAC is an output N by N array which contains the orthogonal
C         matrix Q produced by the QR factorization of the final approx-
C         imate Jacobian.
C
C       LDFJAC is a positive integer input variable not less than N
C         which specifies the leading dimension of the array FJAC.
C
C       XTOL is a non-negative input variable.  Termination occurs when
C         the relative error between two consecutive iterates is at most
C         XTOL.  Therefore, XTOL measures the relative error desired in
C         the approximate solution.  Section 4 contains more details
C         about XTOL.
C
C       MAXFEV is a positive integer input variable.  Termination occurs
C         when the number of calls to FCN is at least MAXFEV by the end
C         of an iteration.
C
C       ML is a non-negative integer input variable which specifies the
C         number of subdiagonals within the band of the Jacobian matrix.
C         If the Jacobian is not banded or IOPT=1, set ML to at
C         least N - 1.
C
C       MU is a non-negative integer input variable which specifies the
C         number of superdiagonals within the band of the Jacobian
C         matrix.  If the Jacobian is not banded or IOPT=1, set MU to at
C         least N - 1.
C
C       EPSFCN is an input variable used in determining a suitable step
C         for the forward-difference approximation.  This approximation
C         assumes that the relative errors in the functions are of the
C         order of EPSFCN.  If EPSFCN is less than the machine preci-
C         sion, it is assumed that the relative errors in the functions
C         are of the order of the machine precision.  If IOPT=1, then
C         EPSFCN can be ignored (treat it as a dummy argument).
C
C       DIAG is an array of length N.  If MODE = 1 (see below), DIAG is
C         internally set.  If MODE = 2, DIAG must contain positive
C         entries that serve as implicit (multiplicative) scale factors
C         for the variables.
C
C       MODE is an integer input variable.  If MODE = 1, the variables
C         will be scaled internally.  If MODE = 2, the scaling is speci-
C         fied by the input DIAG.  Other values of MODE are equivalent
C         to MODE = 1.
C
C       FACTOR is a positive input variable used in determining the ini-
C         tial step bound.  This bound is set to the product of FACTOR
C         and the Euclidean norm of DIAG*X if nonzero, or else to FACTOR
C         itself.  In most cases FACTOR should lie in the interval
C         (.1,100.).  100. is a generally recommended value.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iteration thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN(see example).  If NPRINT
C         is not positive, no special calls of FCN with IFLAG = 0 are
C         made.
C
C       INFO is an integer output variable.  If the user has terminated
C         execution, INFO is set to the (negative) value of IFLAG.  See
C         description of FCN and JAC. Otherwise, INFO is set as follows.
C
C         INFO = 0  improper input parameters.
C
C         INFO = 1  relative error between two consecutive iterates is
C                   at most XTOL.
C
C         INFO = 2  number of calls to FCN has reached or exceeded
C                   MAXFEV.
C
C         INFO = 3  XTOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         INFO = 4  iteration is not making good progress, as measured
C                   by the improvement from the last five Jacobian eval-
C                   uations.
C
C         INFO = 5  iteration is not making good progress, as measured
C                   by the improvement from the last ten iterations.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       NFEV is an integer output variable set to the number of calls to
C         FCN.
C
C       NJEV is an integer output variable set to the number of calls to
C         JAC. (If IOPT=2, then NJEV is set to zero.)
C
C       R is an output array of length LR which contains the upper
C         triangular matrix produced by the QR factorization of the
C         final approximate Jacobian, stored rowwise.
C
C       LR is a positive integer input variable not less than
C         (N*(N+1))/2.
C
C       QTF is an output array of length N which contains the vector
C         (Q TRANSPOSE)*FVEC.
C
C       WA1, WA2, WA3, and WA4 are work arrays of length N.
C
C
C 4. Successful Completion.
C
C       The accuracy of SNSQ is controlled by the convergence parameter
C       XTOL.  This parameter is used in a test which makes a comparison
C       between the approximation X and a solution XSOL.  SNSQ termi-
C       nates when the test is satisfied.  If the convergence parameter
C       is less than the machine precision (as defined by the function
C       R1MACH(4)), then SNSQ only attempts to satisfy the test
C       defined by the machine precision.  Further progress is not
C       usually possible.
C
C       The test assumes that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian are coded consistently.  If these conditions
C       are not satisfied, then SNSQ may incorrectly indicate conver-
C       gence.  The coding of the Jacobian can be checked by the
C       subroutine CHKDER. If the Jacobian is coded correctly or IOPT=2,
C       then the validity of the answer can be checked, for example, by
C       rerunning SNSQ with a tighter tolerance.
C
C       Convergence Test.  If ENORM(Z) denotes the Euclidean norm of a
C         vector Z and D is the diagonal matrix whose entries are
C         defined by the array DIAG, then this test attempts to guaran-
C         tee that
C
C               ENORM(D*(X-XSOL)) .LE. XTOL*ENORM(D*XSOL).
C
C         If this condition is satisfied with XTOL = 10**(-K), then the
C         larger components of D*X have K significant decimal digits and
C         INFO is set to 1.  There is a danger that the smaller compo-
C         nents of D*X may have large relative errors, but the fast rate
C         of convergence of SNSQ usually avoids this possibility.
C         Unless high precision solutions are required, the recommended
C         value for XTOL is the square root of the machine precision.
C
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of SNSQ can be due to improper input
C       parameters, arithmetic interrupts, an excessive number of func-
C       tion evaluations, or lack of good progress.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT. 1,
C         or IOPT .GT. 2, or N .LE. 0, or LDFJAC .LT. N, or
C         XTOL .LT. 0.E0, or MAXFEV .LE. 0, or ML .LT. 0, or MU .LT. 0,
C         or FACTOR .LE. 0.E0, or LR .LT. (N*(N+1))/2.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by SNSQ.  In this
C         case, it may be possible to remedy the situation by rerunning
C         SNSQ with a smaller value of FACTOR.
C
C       Excessive Number of Function Evaluations.  A reasonable value
C         for MAXFEV is 100*(N+1) for IOPT=1 and 200*(N+1) for IOPT=2.
C         If the number of calls to FCN reaches MAXFEV, then this
C         indicates that the routine is converging very slowly as
C         measured by the progress of FVEC, and INFO is set to 2.  This
C         situation should be unusual because, as indicated below, lack
C         of good progress is usually diagnosed earlier by SNSQ,
C         causing termination with INFO = 4 or INFO = 5.
C
C       Lack of Good Progress.  SNSQ searches for a zero of the system
C         by minimizing the sum of the squares of the functions.  In so
C         doing, it can become trapped in a region where the minimum
C         does not correspond to a zero of the system and, in this situ-
C         ation, the iteration eventually fails to make good progress.
C         In particular, this will happen if the system does not have a
C         zero.  If the system has a zero, rerunning SNSQ from a dif-
C         ferent starting point may be helpful.
C
C
C 6. Characteristics of the Algorithm.
C
C       SNSQ is a modification of the Powell hybrid method.  Two of its
C       main characteristics involve the choice of the correction as a
C       convex combination of the Newton and scaled gradient directions,
C       and the updating of the Jacobian by the rank-1 method of Broy-
C       den.  The choice of the correction guarantees (under reasonable
C       conditions) global convergence for starting points far from the
C       solution and a fast rate of convergence.  The Jacobian is
C       calculated at the starting point by either the user-supplied
C       subroutine or a forward-difference approximation, but it is not
C       recalculated until the rank-1 method fails to produce satis-
C       factory progress.
C
C       Timing.  The time required by SNSQ to solve a given problem
C         depends on N, the behavior of the functions, the accuracy
C         requested, and the starting point.  The number of arithmetic
C         operations needed by SNSQ is about 11.5*(N**2) to process
C         each evaluation of the functions (call to FCN) and 1.3*(N**3)
C         to process each evaluation of the Jacobian (call to JAC,
C         if IOPT = 1).  Unless FCN and JAC can be evaluated quickly,
C         the timing of SNSQ will be strongly influenced by the time
C         spent in FCN and JAC.
C
C       Storage.  SNSQ requires (3*N**2 + 17*N)/2 single precision
C         storage locations, in addition to the storage required by the
C         program.  There are no internally declared storage arrays.
C
C
C 7. Example.
C
C       The problem is to determine the values of X(1), X(2), ..., X(9),
C       which solve the system of tridiagonal equations
C
C       (3-2*X(1))*X(1)           -2*X(2)                   = -1
C               -X(I-1) + (3-2*X(I))*X(I)         -2*X(I+1) = -1, I=2-8
C                                   -X(8) + (3-2*X(9))*X(9) = -1
C C     **********
C
C       PROGRAM TEST
C C
C C     Driver for SNSQ example.
C C
C       INTEGER J,IOPT,N,MAXFEV,ML,MU,MODE,NPRINT,INFO,NFEV,LDFJAC,LR,
C      *        NWRITE
C       REAL XTOL,EPSFCN,FACTOR,FNORM
C       REAL X(9),FVEC(9),DIAG(9),FJAC(9,9),R(45),QTF(9),
C      *     WA1(9),WA2(9),WA3(9),WA4(9)
C       REAL ENORM,R1MACH
C       EXTERNAL FCN
C       DATA NWRITE /6/
C C
C       IOPT = 2
C       N = 9
C C
C C     The following starting values provide a rough solution.
C C
C       DO 10 J = 1, 9
C          X(J) = -1.E0
C    10    CONTINUE
C C
C       LDFJAC = 9
C       LR = 45
C C
C C     Set XTOL to the square root of the machine precision.
C C     Unless high precision solutions are required,
C C     this is the recommended setting.
C C
C       XTOL = SQRT(R1MACH(4))
C C
C       MAXFEV = 2000
C       ML = 1
C       MU = 1
C       EPSFCN = 0.E0
C       MODE = 2
C       DO 20 J = 1, 9
C          DIAG(J) = 1.E0
C    20    CONTINUE
C       FACTOR = 1.E2
C       NPRINT = 0
C C
C       CALL SNSQ(FCN,JAC,IOPT,N,X,FVEC,FJAC,LDFJAC,XTOL,MAXFEV,ML,MU,
C      *           EPSFCN,DIAG,MODE,FACTOR,NPRINT,INFO,NFEV,NJEV,
C      *           R,LR,QTF,WA1,WA2,WA3,WA4)
C       FNORM = ENORM(N,FVEC)
C       WRITE (NWRITE,1000) FNORM,NFEV,INFO,(X(J),J=1,N)
C       STOP
C  1000 FORMAT (5X,' FINAL L2 NORM OF THE RESIDUALS',E15.7 //
C      *        5X,' NUMBER OF FUNCTION EVALUATIONS',I10 //
C      *        5X,' EXIT PARAMETER',16X,I10 //
C      *        5X,' FINAL APPROXIMATE SOLUTION' // (5X,3E15.7))
C       END
C       SUBROUTINE FCN(N,X,FVEC,IFLAG)
C       INTEGER N,IFLAG
C       REAL X(N),FVEC(N)
C       INTEGER K
C       REAL ONE,TEMP,TEMP1,TEMP2,THREE,TWO,ZERO
C       DATA ZERO,ONE,TWO,THREE /0.E0,1.E0,2.E0,3.E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       DO 10 K = 1, N
C          TEMP = (THREE - TWO*X(K))*X(K)
C          TEMP1 = ZERO
C          IF (K .NE. 1) TEMP1 = X(K-1)
C          TEMP2 = ZERO
C          IF (K .NE. N) TEMP2 = X(K+1)
C          FVEC(K) = TEMP - TEMP1 - TWO*TEMP2 + ONE
C    10    CONTINUE
C       RETURN
C       END
C
C       Results obtained with different compilers or machines
C       may be slightly different.
C
C       FINAL L2 NORM OF THE RESIDUALS  0.1192636E-07
C
C       NUMBER OF FUNCTION EVALUATIONS        14
C
C       EXIT PARAMETER                         1
C
C       FINAL APPROXIMATE SOLUTION
C
C       -0.5706545E+00 -0.6816283E+00 -0.7017325E+00
C       -0.7042129E+00 -0.7013690E+00 -0.6918656E+00
C       -0.6657920E+00 -0.5960342E+00 -0.4164121E+00
C
C***REFERENCES  M. J. D. Powell, A hybrid method for nonlinear equa-
C                 tions. In Numerical Methods for Nonlinear Algebraic
C                 Equations, P. Rabinowitz, Editor.  Gordon and Breach,
C                 1988.
C***ROUTINES CALLED  DOGLEG, ENORM, FDJAC1, QFORM, QRFAC, R1MACH,
C                    R1MPYQ, R1UPDT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNSQ
      INTEGER IOPT,N,MAXFEV,ML,MU,MODE,NPRINT,INFO,NFEV,LDFJAC,LR,NJEV
      REAL XTOL,EPSFCN,FACTOR
      REAL X(*),FVEC(*),DIAG(*),FJAC(LDFJAC,*),R(LR),QTF(*),WA1(*),
     1     WA2(*),WA3(*),WA4(*)
      EXTERNAL FCN
      INTEGER I,IFLAG,ITER,J,JM1,L,NCFAIL,NCSUC,NSLOW1,NSLOW2
      INTEGER IWA(1)
      LOGICAL JEVAL,SING
      REAL ACTRED,DELTA,EPSMCH,FNORM,FNORM1,ONE,PNORM,PRERED,P1,P5,
     1     P001,P0001,RATIO,SUM,TEMP,XNORM,ZERO
      REAL R1MACH,ENORM
      SAVE ONE, P1, P5, P001, P0001, ZERO
      DATA ONE,P1,P5,P001,P0001,ZERO
     1     /1.0E0,1.0E-1,5.0E-1,1.0E-3,1.0E-4,0.0E0/
C
C***FIRST EXECUTABLE STATEMENT  SNSQ
      EPSMCH = R1MACH(4)
C
      INFO = 0
      IFLAG = 0
      NFEV = 0
      NJEV = 0
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF (IOPT .LT. 1 .OR. IOPT .GT. 2 .OR.
     1    N .LE. 0 .OR. XTOL .LT. ZERO .OR. MAXFEV .LE. 0
     2    .OR. ML .LT. 0 .OR. MU .LT. 0 .OR. FACTOR .LE. ZERO
     3    .OR. LDFJAC .LT. N .OR. LR .LT. (N*(N + 1))/2) GO TO 300
      IF (MODE .NE. 2) GO TO 20
      DO 10 J = 1, N
         IF (DIAG(J) .LE. ZERO) GO TO 300
   10    CONTINUE
   20 CONTINUE
C
C     EVALUATE THE FUNCTION AT THE STARTING POINT
C     AND CALCULATE ITS NORM.
C
      IFLAG = 1
      CALL FCN(N,X,FVEC,IFLAG)
      NFEV = 1
      IF (IFLAG .LT. 0) GO TO 300
      FNORM = ENORM(N,FVEC)
C
C     INITIALIZE ITERATION COUNTER AND MONITORS.
C
      ITER = 1
      NCSUC = 0
      NCFAIL = 0
      NSLOW1 = 0
      NSLOW2 = 0
C
C     BEGINNING OF THE OUTER LOOP.
C
   30 CONTINUE
         JEVAL = .TRUE.
C
C        CALCULATE THE JACOBIAN MATRIX.
C
         IF (IOPT .EQ. 2) GO TO 31
C
C        USER SUPPLIES JACOBIAN
C
            CALL JAC(N,X,FVEC,FJAC,LDFJAC,IFLAG)
            NJEV = NJEV+1
            GO TO 32
C
C        CODE APPROXIMATES THE JACOBIAN
C
   31       IFLAG = 2
            CALL FDJAC1(FCN,N,X,FVEC,FJAC,LDFJAC,IFLAG,ML,MU,EPSFCN,WA1,
     1               WA2)
            NFEV = NFEV + MIN(ML+MU+1,N)
C
   32    IF (IFLAG .LT. 0) GO TO 300
C
C        COMPUTE THE QR FACTORIZATION OF THE JACOBIAN.
C
         CALL QRFAC(N,N,FJAC,LDFJAC,.FALSE.,IWA,1,WA1,WA2,WA3)
C
C        ON THE FIRST ITERATION AND IF MODE IS 1, SCALE ACCORDING
C        TO THE NORMS OF THE COLUMNS OF THE INITIAL JACOBIAN.
C
         IF (ITER .NE. 1) GO TO 70
         IF (MODE .EQ. 2) GO TO 50
         DO 40 J = 1, N
            DIAG(J) = WA2(J)
            IF (WA2(J) .EQ. ZERO) DIAG(J) = ONE
   40       CONTINUE
   50    CONTINUE
C
C        ON THE FIRST ITERATION, CALCULATE THE NORM OF THE SCALED X
C        AND INITIALIZE THE STEP BOUND DELTA.
C
         DO 60 J = 1, N
            WA3(J) = DIAG(J)*X(J)
   60       CONTINUE
         XNORM = ENORM(N,WA3)
         DELTA = FACTOR*XNORM
         IF (DELTA .EQ. ZERO) DELTA = FACTOR
   70    CONTINUE
C
C        FORM (Q TRANSPOSE)*FVEC AND STORE IN QTF.
C
         DO 80 I = 1, N
            QTF(I) = FVEC(I)
   80       CONTINUE
         DO 120 J = 1, N
            IF (FJAC(J,J) .EQ. ZERO) GO TO 110
            SUM = ZERO
            DO 90 I = J, N
               SUM = SUM + FJAC(I,J)*QTF(I)
   90          CONTINUE
            TEMP = -SUM/FJAC(J,J)
            DO 100 I = J, N
               QTF(I) = QTF(I) + FJAC(I,J)*TEMP
  100          CONTINUE
  110       CONTINUE
  120       CONTINUE
C
C        COPY THE TRIANGULAR FACTOR OF THE QR FACTORIZATION INTO R.
C
         SING = .FALSE.
         DO 150 J = 1, N
            L = J
            JM1 = J - 1
            IF (JM1 .LT. 1) GO TO 140
            DO 130 I = 1, JM1
               R(L) = FJAC(I,J)
               L = L + N - I
  130          CONTINUE
  140       CONTINUE
            R(L) = WA1(J)
            IF (WA1(J) .EQ. ZERO) SING = .TRUE.
  150       CONTINUE
C
C        ACCUMULATE THE ORTHOGONAL FACTOR IN FJAC.
C
         CALL QFORM(N,N,FJAC,LDFJAC,WA1)
C
C        RESCALE IF NECESSARY.
C
         IF (MODE .EQ. 2) GO TO 170
         DO 160 J = 1, N
            DIAG(J) = MAX(DIAG(J),WA2(J))
  160       CONTINUE
  170    CONTINUE
C
C        BEGINNING OF THE INNER LOOP.
C
  180    CONTINUE
C
C           IF REQUESTED, CALL FCN TO ENABLE PRINTING OF ITERATES.
C
            IF (NPRINT .LE. 0) GO TO 190
            IFLAG = 0
            IF (MOD(ITER-1,NPRINT) .EQ. 0) CALL FCN(N,X,FVEC,IFLAG)
            IF (IFLAG .LT. 0) GO TO 300
  190       CONTINUE
C
C           DETERMINE THE DIRECTION P.
C
            CALL DOGLEG(N,R,LR,DIAG,QTF,DELTA,WA1,WA2,WA3)
C
C           STORE THE DIRECTION P AND X + P. CALCULATE THE NORM OF P.
C
            DO 200 J = 1, N
               WA1(J) = -WA1(J)
               WA2(J) = X(J) + WA1(J)
               WA3(J) = DIAG(J)*WA1(J)
  200          CONTINUE
            PNORM = ENORM(N,WA3)
C
C           ON THE FIRST ITERATION, ADJUST THE INITIAL STEP BOUND.
C
            IF (ITER .EQ. 1) DELTA = MIN(DELTA,PNORM)
C
C           EVALUATE THE FUNCTION AT X + P AND CALCULATE ITS NORM.
C
            IFLAG = 1
            CALL FCN(N,WA2,WA4,IFLAG)
            NFEV = NFEV + 1
            IF (IFLAG .LT. 0) GO TO 300
            FNORM1 = ENORM(N,WA4)
C
C           COMPUTE THE SCALED ACTUAL REDUCTION.
C
            ACTRED = -ONE
            IF (FNORM1 .LT. FNORM) ACTRED = ONE - (FNORM1/FNORM)**2
C
C           COMPUTE THE SCALED PREDICTED REDUCTION.
C
            L = 1
            DO 220 I = 1, N
               SUM = ZERO
               DO 210 J = I, N
                  SUM = SUM + R(L)*WA1(J)
                  L = L + 1
  210             CONTINUE
               WA3(I) = QTF(I) + SUM
  220          CONTINUE
            TEMP = ENORM(N,WA3)
            PRERED = ZERO
            IF (TEMP .LT. FNORM) PRERED = ONE - (TEMP/FNORM)**2
C
C           COMPUTE THE RATIO OF THE ACTUAL TO THE PREDICTED
C           REDUCTION.
C
            RATIO = ZERO
            IF (PRERED .GT. ZERO) RATIO = ACTRED/PRERED
C
C           UPDATE THE STEP BOUND.
C
            IF (RATIO .GE. P1) GO TO 230
               NCSUC = 0
               NCFAIL = NCFAIL + 1
               DELTA = P5*DELTA
               GO TO 240
  230       CONTINUE
               NCFAIL = 0
               NCSUC = NCSUC + 1
               IF (RATIO .GE. P5 .OR. NCSUC .GT. 1)
     1            DELTA = MAX(DELTA,PNORM/P5)
               IF (ABS(RATIO-ONE) .LE. P1) DELTA = PNORM/P5
  240       CONTINUE
C
C           TEST FOR SUCCESSFUL ITERATION.
C
            IF (RATIO .LT. P0001) GO TO 260
C
C           SUCCESSFUL ITERATION. UPDATE X, FVEC, AND THEIR NORMS.
C
            DO 250 J = 1, N
               X(J) = WA2(J)
               WA2(J) = DIAG(J)*X(J)
               FVEC(J) = WA4(J)
  250          CONTINUE
            XNORM = ENORM(N,WA2)
            FNORM = FNORM1
            ITER = ITER + 1
  260       CONTINUE
C
C           DETERMINE THE PROGRESS OF THE ITERATION.
C
            NSLOW1 = NSLOW1 + 1
            IF (ACTRED .GE. P001) NSLOW1 = 0
            IF (JEVAL) NSLOW2 = NSLOW2 + 1
            IF (ACTRED .GE. P1) NSLOW2 = 0
C
C           TEST FOR CONVERGENCE.
C
            IF (DELTA .LE. XTOL*XNORM .OR. FNORM .EQ. ZERO) INFO = 1
            IF (INFO .NE. 0) GO TO 300
C
C           TESTS FOR TERMINATION AND STRINGENT TOLERANCES.
C
            IF (NFEV .GE. MAXFEV) INFO = 2
            IF (P1*MAX(P1*DELTA,PNORM) .LE. EPSMCH*XNORM) INFO = 3
            IF (NSLOW2 .EQ. 5) INFO = 4
            IF (NSLOW1 .EQ. 10) INFO = 5
            IF (INFO .NE. 0) GO TO 300
C
C           CRITERION FOR RECALCULATING JACOBIAN
C
            IF (NCFAIL .EQ. 2) GO TO 290
C
C           CALCULATE THE RANK ONE MODIFICATION TO THE JACOBIAN
C           AND UPDATE QTF IF NECESSARY.
C
            DO 280 J = 1, N
               SUM = ZERO
               DO 270 I = 1, N
                  SUM = SUM + FJAC(I,J)*WA4(I)
  270             CONTINUE
               WA2(J) = (SUM - WA3(J))/PNORM
               WA1(J) = DIAG(J)*((DIAG(J)*WA1(J))/PNORM)
               IF (RATIO .GE. P0001) QTF(J) = SUM
  280          CONTINUE
C
C           COMPUTE THE QR FACTORIZATION OF THE UPDATED JACOBIAN.
C
            CALL R1UPDT(N,N,R,LR,WA1,WA2,WA3,SING)
            CALL R1MPYQ(N,N,FJAC,LDFJAC,WA2,WA3)
            CALL R1MPYQ(1,N,QTF,1,WA2,WA3)
C
C           END OF THE INNER LOOP.
C
            JEVAL = .FALSE.
            GO TO 180
  290    CONTINUE
C
C        END OF THE OUTER LOOP.
C
         GO TO 30
  300 CONTINUE
C
C     TERMINATION, EITHER NORMAL OR USER IMPOSED.
C
      IF (IFLAG .LT. 0) INFO = IFLAG
      IFLAG = 0
      IF (NPRINT .GT. 0) CALL FCN(N,X,FVEC,IFLAG)
      IF (INFO .LT. 0) CALL XERMSG ('SLATEC', 'SNSQ',
     +   'EXECUTION TERMINATED BECAUSE USER SET IFLAG NEGATIVE.', 1, 1)
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'SNSQ',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      IF (INFO .EQ. 2) CALL XERMSG ('SLATEC', 'SNSQ',
     +   'TOO MANY FUNCTION EVALUATIONS.', 9, 1)
      IF (INFO .EQ. 3) CALL XERMSG ('SLATEC', 'SNSQ',
     +   'XTOL TOO SMALL. NO FURTHER IMPROVEMENT POSSIBLE.', 3, 1)
      IF (INFO .GT. 4) CALL XERMSG ('SLATEC', 'SNSQ',
     +   'ITERATION NOT MAKING GOOD PROGRESS.', 1, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE SNSQ.
C
      END
*DECK SNSQE
      SUBROUTINE SNSQE (FCN, JAC, IOPT, N, X, FVEC, TOL, NPRINT, INFO,
     +   WA, LWA)
C***BEGIN PROLOGUE  SNSQE
C***PURPOSE  An easy-to-use code to find a zero of a system of N
C            nonlinear functions in N variables by a modification of
C            the Powell hybrid method.
C***LIBRARY   SLATEC
C***CATEGORY  F2A
C***TYPE      SINGLE PRECISION (SNSQE-S, DNSQE-D)
C***KEYWORDS  EASY-TO-USE, NONLINEAR SQUARE SYSTEM,
C             POWELL HYBRID METHOD, ZEROS
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C
C       The purpose of SNSQE is to find a zero of a system of N non-
C       linear functions in N variables by a modification of the Powell
C       hybrid method.  This is done by using the more general nonlinear
C       equation solver SNSQ.  The user must provide a subroutine which
C       calculates the functions.  The user has the option of either to
C       provide a subroutine which calculates the Jacobian or to let the
C       code calculate it by a forward-difference approximation.  This
C       code is the combination of the MINPACK codes (Argonne) HYBRD1
C       and HYBRJ1.
C
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE SNSQE(FCN,JAC,IOPT,N,X,FVEC,TOL,NPRINT,INFO,
C      *                  WA,LWA)
C       INTEGER IOPT,N,NPRINT,INFO,LWA
C       REAL TOL
C       REAL X(N),FVEC(N),WA(LWA)
C       EXTERNAL FCN,JAC
C
C
C 3. Parameters.
C
C       Parameters designated as input parameters must be specified on
C       entry to SNSQE and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from SNSQE.
C
C       FCN is the name of the user-supplied subroutine which calculates
C         the functions.  FCN must be declared in an EXTERNAL statement
C         in the user calling program, and should be written as follows.
C
C         SUBROUTINE FCN(N,X,FVEC,IFLAG)
C         INTEGER N,IFLAG
C         REAL X(N),FVEC(N)
C         ----------
C         Calculate the functions at X and
C         return this vector in FVEC.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of SNSQE.  In this case, set
C         IFLAG to a negative integer.
C
C       JAC is the name of the user-supplied subroutine which calculates
C         the Jacobian.  If IOPT=1, then JAC must be declared in an
C         EXTERNAL statement in the user calling program, and should be
C         written as follows.
C
C         SUBROUTINE JAC(N,X,FVEC,FJAC,LDFJAC,IFLAG)
C         INTEGER N,LDFJAC,IFLAG
C         REAL X(N),FVEC(N),FJAC(LDFJAC,N)
C         ----------
C         Calculate the Jacobian at X and return this
C         matrix in FJAC.  FVEC contains the function
C         values at X and should not be altered.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by JAC unless the
C         user wants to terminate execution of SNSQE.  In this case, set
C         IFLAG to a negative integer.
C
C         If IOPT=2, JAC can be ignored (treat it as a dummy argument).
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=1, then the user must supply the
C         Jacobian through the subroutine JAC.  If IOPT=2, then the
C         code will approximate the Jacobian by forward-differencing.
C
C       N is a positive integer input variable set to the number of
C         functions and variables.
C
C       X is an array of length N.  On input, X must contain an initial
C         estimate of the solution vector.  On output, X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length N which contains the functions
C         evaluated at the output X.
C
C       TOL is a non-negative input variable.  Termination occurs when
C         the algorithm estimates that the relative error between X and
C         the solution is at most TOL.  Section 4 contains more details
C         about TOL.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iteration thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN (see example). If NPRINT
C         is not positive, no special calls of FCN with IFLAG = 0 are
C         made.
C
C       INFO is an integer output variable.  If the user has terminated
C         execution, INFO is set to the (negative) value of IFLAG.  See
C         description of FCN and JAC. Otherwise, INFO is set as follows.
C
C         INFO = 0  improper input parameters.
C
C         INFO = 1  algorithm estimates that the relative error between
C                   X and the solution is at most TOL.
C
C         INFO = 2  number of calls to FCN has reached or exceeded
C                   100*(N+1) for IOPT=1 or 200*(N+1) for IOPT=2.
C
C         INFO = 3  TOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         INFO = 4  iteration is not making good progress.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       WA is a work array of length LWA.
C
C       LWA is a positive integer input variable not less than
C         (3*N**2+13*N))/2.
C
C
C 4. Successful Completion.
C
C       The accuracy of SNSQE is controlled by the convergence parame-
C       ter TOL.  This parameter is used in a test which makes a compar-
C       ison between the approximation X and a solution XSOL.  SNSQE
C       terminates when the test is satisfied.  If TOL is less than the
C       machine precision (as defined by the function R1MACH(4)), then
C       SNSQE attempts only to satisfy the test defined by the machine
C       precision.  Further progress is not usually possible.  Unless
C       high precision solutions are required, the recommended value
C       for TOL is the square root of the machine precision.
C
C       The test assumes that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian  coded consistently.  If these conditions
C       are not satisfied, SNSQE may incorrectly indicate convergence.
C       The coding of the Jacobian can be checked by the subroutine
C       CHKDER.  If the Jacobian is coded correctly or IOPT=2, then
C       the validity of the answer can be checked, for example, by
C       rerunning SNSQE with a tighter tolerance.
C
C       Convergence Test.  If ENORM(Z) denotes the Euclidean norm of a
C         vector Z, then this test attempts to guarantee that
C
C               ENORM(X-XSOL) .LE.  TOL*ENORM(XSOL).
C
C         If this condition is satisfied with TOL = 10**(-K), then the
C         larger components of X have K significant decimal digits and
C         INFO is set to 1.  There is a danger that the smaller compo-
C         nents of X may have large relative errors, but the fast rate
C         of convergence of SNSQE usually avoids this possibility.
C
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of SNSQE can be due to improper input
C       parameters, arithmetic interrupts, an excessive number of func-
C       tion evaluations, errors in the functions, or lack of good prog-
C       ress.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT. 1, or
C         IOPT .GT. 2, or N .LE. 0, or TOL .LT. 0.E0, or
C         LWA .LT. (3*N**2+13*N)/2.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by SNSQE.  In this
C         case, it may be possible to remedy the situation by not evalu-
C         ating the functions here, but instead setting the components
C         of FVEC to numbers that exceed those in the initial FVEC.
C
C       Excessive Number of Function Evaluations.  If the number of
C         calls to FCN reaches 100*(N+1) for IOPT=1 or 200*(N+1) for
C         IOPT=2, then this indicates that the routine is converging
C         very slowly as measured by the progress of FVEC, and INFO is
C         set to 2.  This situation should be unusual because, as
C         indicated below, lack of good progress is usually diagnosed
C         earlier by SNSQE, causing termination with INFO = 4.
C
C       Errors in the Functions.  When IOPT=2, the choice of step length
C         in the forward-difference approximation to the Jacobian
C         assumes that the relative errors in the functions are of the
C         order of the machine precision.  If this is not the case,
C         SNSQE may fail (usually with INFO = 4).  The user should
C         then either use SNSQ and set the step length or use IOPT=1
C         and supply the Jacobian.
C
C       Lack of Good Progress.  SNSQE searches for a zero of the system
C         by minimizing the sum of the squares of the functions.  In so
C         doing, it can become trapped in a region where the minimum
C         does not correspond to a zero of the system and, in this situ-
C         ation, the iteration eventually fails to make good progress.
C         In particular, this will happen if the system does not have a
C         zero.  If the system has a zero, rerunning SNSQE from a dif-
C         ferent starting point may be helpful.
C
C
C 6. Characteristics of the Algorithm.
C
C       SNSQE is a modification of the Powell hybrid method.  Two of
C       its main characteristics involve the choice of the correction as
C       a convex combination of the Newton and scaled gradient direc-
C       tions, and the updating of the Jacobian by the rank-1 method of
C       Broyden.  The choice of the correction guarantees (under reason-
C       able conditions) global convergence for starting points far from
C       the solution and a fast rate of convergence.  The Jacobian is
C       calculated at the starting point by either the user-supplied
C       subroutine or a forward-difference approximation, but it is not
C       recalculated until the rank-1 method fails to produce satis-
C       factory progress.
C
C       Timing.  The time required by SNSQE to solve a given problem
C         depends on N, the behavior of the functions, the accuracy
C         requested, and the starting point.  The number of arithmetic
C         operations needed by SNSQE is about 11.5*(N**2) to process
C         each evaluation of the functions (call to FCN) and 1.3*(N**3)
C         to process each evaluation of the Jacobian (call to JAC,
C         if IOPT = 1).  Unless FCN and JAC can be evaluated quickly,
C         the timing of SNSQE will be strongly influenced by the time
C         spent in FCN and JAC.
C
C       Storage.  SNSQE requires (3*N**2 + 17*N)/2 single precision
C         storage locations, in addition to the storage required by the
C         program.  There are no internally declared storage arrays.
C
C
C 7. Example.
C
C       The problem is to determine the values of X(1), X(2), ..., X(9),
C       which solve the system of tridiagonal equations
C
C       (3-2*X(1))*X(1)           -2*X(2)                   = -1
C               -X(I-1) + (3-2*X(I))*X(I)         -2*X(I+1) = -1, I=2-8
C                                   -X(8) + (3-2*X(9))*X(9) = -1
C
C       **********
C
C       PROGRAM TEST
C C
C C     Driver for SNSQE example.
C C
C       INTEGER J,N,IOPT,NPRINT,INFO,LWA,NWRITE
C       REAL TOL,FNORM
C       REAL X(9),FVEC(9),WA(180)
C       REAL ENORM,R1MACH
C       EXTERNAL FCN
C       DATA NWRITE /6/
C C
C       IOPT = 2
C       N = 9
C C
C C     The following starting values provide a rough solution.
C C
C       DO 10 J = 1, 9
C          X(J) = -1.E0
C    10    CONTINUE
C
C       LWA = 180
C       NPRINT = 0
C C
C C     Set TOL to the square root of the machine precision.
C C     Unless high precision solutions are required,
C C     this is the recommended setting.
C C
C       TOL = SQRT(R1MACH(4))
C C
C       CALL SNSQE(FCN,JAC,IOPT,N,X,FVEC,TOL,NPRINT,INFO,WA,LWA)
C       FNORM = ENORM(N,FVEC)
C       WRITE (NWRITE,1000) FNORM,INFO,(X(J),J=1,N)
C       STOP
C  1000 FORMAT (5X,' FINAL L2 NORM OF THE RESIDUALS',E15.7 //
C      *        5X,' EXIT PARAMETER',16X,I10 //
C      *        5X,' FINAL APPROXIMATE SOLUTION' // (5X,3E15.7))
C       END
C       SUBROUTINE FCN(N,X,FVEC,IFLAG)
C       INTEGER N,IFLAG
C       REAL X(N),FVEC(N)
C       INTEGER K
C       REAL ONE,TEMP,TEMP1,TEMP2,THREE,TWO,ZERO
C       DATA ZERO,ONE,TWO,THREE /0.E0,1.E0,2.E0,3.E0/
C C
C       DO 10 K = 1, N
C          TEMP = (THREE - TWO*X(K))*X(K)
C          TEMP1 = ZERO
C          IF (K .NE. 1) TEMP1 = X(K-1)
C          TEMP2 = ZERO
C          IF (K .NE. N) TEMP2 = X(K+1)
C          FVEC(K) = TEMP - TEMP1 - TWO*TEMP2 + ONE
C    10    CONTINUE
C       RETURN
C       END
C
C       Results obtained with different compilers or machines
C       may be slightly different.
C
C       FINAL L2 NORM OF THE RESIDUALS  0.1192636E-07
C
C       EXIT PARAMETER                         1
C
C       FINAL APPROXIMATE SOLUTION
C
C       -0.5706545E+00 -0.6816283E+00 -0.7017325E+00
C       -0.7042129E+00 -0.7013690E+00 -0.6918656E+00
C       -0.6657920E+00 -0.5960342E+00 -0.4164121E+00
C
C***REFERENCES  M. J. D. Powell, A hybrid method for nonlinear equa-
C                 tions. In Numerical Methods for Nonlinear Algebraic
C                 Equations, P. Rabinowitz, Editor.  Gordon and Breach,
C                 1988.
C***ROUTINES CALLED  SNSQ, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SNSQE
      INTEGER IOPT,N,NPRINT,INFO,LWA
      REAL TOL
      REAL X(*),FVEC(*),WA(LWA)
      EXTERNAL FCN, JAC
      INTEGER INDEX,J,LR,MAXFEV,ML,MODE,MU,NFEV,NJEV
      REAL EPSFCN,FACTOR,ONE,XTOL,ZERO
      SAVE FACTOR, ONE, ZERO
      DATA FACTOR,ONE,ZERO /1.0E2,1.0E0,0.0E0/
C***FIRST EXECUTABLE STATEMENT  SNSQE
      INFO = 0
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF (IOPT .LT. 1 .OR. IOPT .GT. 2 .OR. N .LE. 0
     1    .OR. TOL .LT. ZERO .OR. LWA .LT. (3*N**2 +13*N)/2)
     2   GO TO 20
C
C     CALL SNSQ.
C
      MAXFEV = 100*(N + 1)
      IF (IOPT .EQ. 2) MAXFEV = 2*MAXFEV
      XTOL = TOL
      ML = N - 1
      MU = N - 1
      EPSFCN = ZERO
      MODE = 2
      DO 10 J = 1, N
         WA(J) = ONE
   10    CONTINUE
      LR = (N*(N + 1))/2
      INDEX=6*N+LR
      CALL SNSQ(FCN,JAC,IOPT,N,X,FVEC,WA(INDEX+1),N,XTOL,MAXFEV,ML,MU,
     1           EPSFCN,WA(1),MODE,FACTOR,NPRINT,INFO,NFEV,NJEV,
     2           WA(6*N+1),LR,WA(N+1),WA(2*N+1),WA(3*N+1),WA(4*N+1),
     3           WA(5*N+1))
      IF (INFO .EQ. 5) INFO = 4
   20 CONTINUE
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'SNSQE',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE SNSQE.
C
      END

module cubedag_remove
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubedag_parameters
  use cubedag_allflags
  use cubeadm_cubeid_types
  use cubedag_messaging
  !
  public :: remove
  private
  !
  type :: remove_comm_t
    type(option_t),      pointer :: comm
    type(cubeid_arg_t),  pointer :: node
    type(option_t),      pointer :: index
    type(keywordlist_comm_t), pointer :: index_arg
  contains
    procedure, public  :: register => cubedag_remove_register
    procedure, private :: parse    => cubedag_remove_parse
    procedure, private :: main     => cubedag_remove_main
  end type remove_comm_t
  type(remove_comm_t) :: remove
  !
  type remove_user_t
    type(cubeid_user_t)   :: cubeids
    logical               :: doindex
    character(len=argu_l) :: index
  contains
    procedure, private :: toprog => cubedag_remove_user_toprog
  end type remove_user_t
  !
  type remove_prog_t
    integer(kind=iden_l) :: id
    integer(kind=code_k) :: index
  contains
    procedure, private :: do => cubedag_remove_do
  end type remove_prog_t
  !
contains
  !
  subroutine cubedag_remove_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command REMOVE
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(remove_user_t) :: user
    character(len=*), parameter :: rname='REMOVE>COMMAND'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call remove%parse(line,user,error)
    if (error) return
    call remove%main(user,error)
    if (error) return
  end subroutine cubedag_remove_command
  !
  subroutine cubedag_remove_register(remove,error)
    !-------------------------------------------------------------------
    ! Register ADM\REMOVE command and its options
    !-------------------------------------------------------------------
    class(remove_comm_t), intent(in)    :: remove
    logical,              intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='REMOVE>REGISTER'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    ! Command
    call cubetools_register_command(&
         'REMOVE','[CubeID]',&
         'Remove a cube from the DAG',&
         strg_emp,&
         cubedag_remove_command,&
         remove%comm,error)
    if (error) return
    call cubearg%register( &
         'CUBE', &
         '[CubeID]',  &
         strg_emp,&
         code_arg_optional,  &
         [flag_any], &
         code_read_none,&  ! Header not needed
         code_access_any,&
         remove%node,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'INDEX','[IndexName]',&
         'Remove all cubes from default or named index',&
         strg_emp,&
         remove%index,error)
    if (error) return
    call keyarg%register( &
         'IndexName',  &
         'Name of the index to be removed', &
         'If absent, default index is used.',&
         code_arg_optional, &
         indexname, &
         .not.flexible, &
         remove%index_arg,&
         error)
    if (error) return
  end subroutine cubedag_remove_register
  !
  subroutine cubedag_remove_parse(remove,line,user,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    ! Parsing facility for command
    !   REMOVE CubeID
    !-------------------------------------------------------------------
    class(remove_comm_t), intent(in)    :: remove
    character(len=*),     intent(in)    :: line
    type(remove_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='REMOVE>PARSE'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,remove%comm,user%cubeids,error)
    if (error) return
    !
    call remove%index%present(line,user%doindex,error)
    if (error) return
    if (user%doindex .and. remove%comm%getnarg().ge.1) then
      call cubedag_message(seve%e,rname,  &
          'Option /INDEX is incompatible with a named cube passed to command')
      error = .true.
      return
    endif
    if (remove%index%getnarg().ge.1) then
      call cubetools_getarg(line,remove%index,1,user%index,mandatory,error)
      if (error) return
    else
      user%index = ''
    endif
  end subroutine cubedag_remove_parse
  !
  subroutine cubedag_remove_main(remove,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(remove_comm_t), intent(in)    :: remove
    type(remove_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(remove_prog_t) :: prog
    character(len=*), parameter :: rname='REMOVE>MAIN'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call user%toprog(remove,prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubedag_remove_main
  !
  !---------------------------------------------------------------------
  !
  subroutine cubedag_remove_user_toprog(user,comm,prog,error)
    use cubetools_setup_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(remove_user_t), intent(in)    :: user
    type(remove_comm_t),  intent(in)    :: comm
    type(remove_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    type(cube_setup_api_t) :: setup
    character(len=argu_l) :: key
    character(len=*), parameter :: rname='REMOVE>USER>TOPROG'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call cubedag_cubeid_user2prog_one(remove%node,user%cubeids%cube(1),prog%id,error)
    if (error) return
    !
    if (user%doindex) then
      if (user%index.eq.'') then
        call setup%index%default%get(prog%index)
      else
        call cubetools_keywordlist_user2prog(comm%index_arg,user%index,prog%index,key,error)
        if (error) return
      endif
    else
      prog%index = code_null
    endif
  end subroutine cubedag_remove_user_toprog
  !
  subroutine cubedag_remove_do(prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(remove_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    if (prog%index.ne.code_null) then
      call cubedag_remove_index(prog,error)
      if (error)  return
    else
      call cubedag_remove_node(prog%id,error)
      if (error)  return
    endif
  end subroutine cubedag_remove_do
  !
  subroutine cubedag_remove_index(prog,error)
    use cubedag_find_types
    use cubedag_link_type
    use cubedag_node_class
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(remove_prog_t), intent(in)    :: prog
    logical,             intent(inout) :: error
    !
    type(dag_find_t) :: find
    type(cubedag_link_t) :: optx
    integer(kind=entr_k) :: inode
    class(cubedag_node_object_t), pointer :: dno
    character(len=*), parameter :: rname='REMOVE>INDEX'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    select case (prog%index)
    case (code_index_dag)
      call find%ix2optx(optx,error)
      if (error)  return
    case (code_index_current)
      call find%cx2optx(optx,error)
      if (error)  return
    case default
      call cubedag_message(seve%e,rname,'Index is not supported')
      error = .true.
      return
    end select
    !
    do inode=optx%n,1,-1
      dno => cubedag_node_ptr(optx%list(inode)%p,error)
      if (error) return
      call cubedag_remove_node(dno%get_id(),error)
      if (error)  return
    enddo
  end subroutine cubedag_remove_index
  !
  subroutine cubedag_remove_node(id,error)
    use cubedag_history_buffer
    use cubedag_dag_buffer
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: id
    logical,         intent(inout) :: error
    !
    character(len=*), parameter :: rname='REMOVE>NODE'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    ! Unreference from history
    call cubedag_history_removenode(id,error)
    if (error) return
    ! Remove it from DAG
    call cubedag_dag_removenode(id,error)
    if (error) return
  end subroutine cubedag_remove_node
end module cubedag_remove

SUBROUTINE WRITE_SDM(LINE,ERROR)
  use gildas_def
  use gkernel_interfaces
  !------------------------------------------------------------------------
  ! Support WRITE file /DATA /NOCAL
  ! Write a SDM data set in ALMA SDM FITS format
  ! write the current index
  !( Actual options TBD)
  !     file   character     file name
  !     /DATA     option        write all data table extensions
  !     /NOCAL    option        write data uncalibrated (not multiplied by Tsys)
  !     /HOLODATA option        write data table in holography format
  !                iant  ref      scanned antennaand reference antenna
  !     /ANTENNAS  a1 a2 a3     use only a subarray ...
  !     /TELESCOPE name         telescope value
  !     /SIMULATE  list        simulate data for ATF
  !------------------------------------------------------------------------
  ! Dummy variables:
  character*(*) line
  logical error
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_number.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Local variables:
  integer(kind=address_length) data_in, ip_data
  character*132 argum, argum2
  character c2*2
  character telarg*12
  integer msimvocab
  parameter (msimvocab=3)
  character simvocab(msimvocab)*12, arg*12, simkw*12
  logical :: end, data, nocal, holodata,   &
    telesc, dosubant, switch, simpolar, old, simAddressing
  integer nch, unit, ndata, status, ib, kfich, maxhdu, num,   &
    larg, larg2, holoant, holoref, holobase, nsubant, subant(mnant),   &
    i, narg, nk
  integer lfich, iswitch
  parameter (maxhdu=950)
  save unit
  data unit/-999/
  data simvocab/'SWITCH','POLARIZATION','ADDRESSING'/
  !c      data next_uid/0/, file_name/'EMPTY '/
  data file_name/'EMPTY '/
  !------------------------------------------------------------------------
  ! Code:
  DOSUBANT = .FALSE.
  switch = .FALSE.
  simpolar = .FALSE.
  simAddressing = .false.
  STATUS = 0
  !c unused       DATA = SIC_PRESENT(1,0)
  !c unused       NOCAL = SIC_PRESENT(2,0)
  HOLODATA = SIC_PRESENT(3,0)  ! used.
  TELESC = SIC_PRESENT(5,0)    ! used.
  ! get ATF simulation parameters
  if (SIC_PRESENT(6,0)) then
    i = 1
    do while (i.le.sic_narg(6))
      call sic_ke(line,6,i,arg,narg,.true.,error)
      if (error) return
      call sic_ambigs('WRITE /SIMULATE',arg,simkw,nk,   &
        simvocab,msimvocab,error)
      if (error) return
      i = i+1
      if (simkw.eq.'SWITCH') then
        switch = .true.
        CALL SIC_I4(LINE,6,i,iswitch,.TRUE.,ERROR)
        if (error) return
        i = i+1
      elseif (simkw.eq.'POLARIZATION') then
        simpolar = .true.
      elseif (simkw.eq.'ADDRESSING') then
        simAddressing = .true.
      endif
    enddo
  endif
  !
  ! /ANTENNA
  IF (SIC_PRESENT(4,0)) THEN
    NSUBANT = SIC_NARG(4)
    DO I =1, NSUBANT
      CALL SIC_I4(LINE,4,I,SUBANT(I),.FALSE.,ERROR)
      IF (SUBANT(I).LE.0 .OR. SUBANT(I).GT.MNANT) THEN
        CALL MESSAGE(8,3,'WRITE_SDM',   &
          'Wrong /ANTENNA argument')
      ENDIF
    ENDDO
    DOSUBANT = .TRUE.
  ENDIF
  ! /TELESCOPE
  IF (TELESC) THEN
    CALL SIC_CH(LINE,5,1,TELARG,NARG,.TRUE.,ERROR)
  ENDIF
  !
  ! Verify if any input file
  CALL CHECK_INPUT_FILE(ERROR)
  IF (ERROR) RETURN
  !
  CALL CHECK_INDEX(ERROR)
  IF (ERROR) RETURN
  ! Get file name
  lfich = lenc(file_name)
  if (sic_present(0,1)) then
    ARGUM = 'clicFile'
    CALL SIC_CH(LINE,0,1,ARGUM,NCH,.false.,ERROR)
    IF (ERROR) RETURN
    CALL SIC_PARSEF(ARGUM,file_name,' ','')
    lfich = lenc(file_name)
    old = .false.
    call message(2,1,'WRITE_SDM',   &
      'Creating '//file_name(1:lfich))
  else
    if (file_name(1:lfich).eq.'EMPTY') then
      error = .true.
      CALL MESSAGE(8,3,'WRITE_SDM',   &
        'No open ASDM to extend')
      return
    endif
    old = .true.
    call message(2,1,'WRITE_SDM',   &
      'Extending '//file_name(1:lfich))
  endif
  KFICH = 0
  !
  ! Now loop on current index.
  ! we need a first loop to get the start and end times for the execblock table
  eb_starttime = 9223372036854775807_8
  eb_endtime = 0
  call get_first(.true.,error)
  if (error) goto 99
  call get_data (ndata,data_in,error)
  if (error) goto 99
  ip_data = gag_pointer(data_in,memory)
  call get_eb_times (ndata, memory(ip_data), error)
  if (error) goto 99
  end = .false.
  do while (.not.end)
    
    call get_next(end,error)
    call get_data (ndata,data_in,error)
    if (error) goto 99
    ip_data = gag_pointer(data_in,memory)
    call get_eb_times (ndata, memory(ip_data), error)
  enddo
  
  !
  ! Loop on current index
  call get_first(.true.,error)
  if (error) goto 99
  if (.not.dosubant) then
    nsubant = r_nant
    do i=1, nsubant
      subant(i) = i
    enddo
  endif
  lfich = lenc(file_name)
  file_name = file_name(1:lfich)//char(0)//' '
  call sdm_init(file_name(1:lfich)//char(0),error)
  if (.not.old) then
    call system('mkdir '//file_name(1:lfich))
    call system('mkdir '//file_name(1:lfich)//'/ASDMBinary')
    ! define uids for containers:
    call sdm_getUid(Project_Uid)
    call sdm_getUid(ObsUnitSet_Uid)
    call sdm_getUid(SchedBlock_Uid)
    call sdm_getUid(ExecBlock_Uid)
    r_execblocknum = 1
  endif
  ! reset all identifiers
  call init_sdm
  if (error) goto 99
  end = .false.
  !     This makes sure the time_start is set to the date of the first
  !     scan (this is used for sources and the like)
  time_start = -1
  do while (.not.end)
    !
    ! Get storage and data
    call get_data (ndata,data_in,error)
    if (error) goto 99
    ip_data = gag_pointer(data_in,memory)
    ! 
    !
    if (telesc) r_teles = telarg
    ! Specific Holography setup:
    if (holodata) then
      !c            ntch = r_nband
      r_nband = 1
      r_lband = 1
      r_lnsb = 1
      r_nsb = 2
      call write_sdm_holotables (ndata, memory(ip_data), error)
    else
      call write_sdm_tables (ndata, memory(ip_data),   &
        switch, iswitch, simAddressing, error)
    endif
    if (error) goto 99
    if (sic_ctrlc()) then
      error = .true.
      goto 99
    endif
    call get_next(end,error)
  enddo
  call write_sdm_scan(error)
  if (error) return
  call sdm_write()
  call sdm_close()
  call message(2,1,'Write_sdm','Data set '//file_name(1:lfich)//   &
    ' written.')
  return
  !
  !
99 call message(8,4,'Write_sdm','SDM Writing Failed')
  return
end subroutine WRITE_SDM
!
subroutine get_eb_times(ldata, data, error)
  integer :: ldata, data(ldata)
  logical :: error
  INCLUDE 'clic_parameter.inc'
  INCLUDE 'clic_par.inc'
  include 'sdm_identifiers.inc'
  integer :: ir, k, h_offset

  ir = r_ndump+1
  k = 1+ h_offset(ir)
  call decode_header (data(k))
  call get_time_interval
  eb_starttime = min(time_interval(1),eb_starttime)
  eb_endtime = max(time_interval(1)+time_interval(2), eb_endtime)
end subroutine get_eb_times

program uv_cc_model
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! GILDAS
  ! Compute a UV data set from a Clean Component Table
  ! Input : a UV table, created for example by ASTRO
  ! Input : a Clean Component Table
  ! Output: the UV table, where the visibilities have been computed.
  !----------------------------------------------------------------------
  ! Global variables:
  character(len=256) uvdata,cleant,uvmodel
  real(8) frequency
  logical subtract,error
  !
  ! Code:
  call gildas_open
  call gildas_char('UVSAMPLE$',uvdata)
  call gildas_char('CLEAN$',cleant)
  call gildas_char('UVMODEL$',uvmodel)
  call gildas_dble('FREQUENCY$',frequency,1)
  call gildas_logi('SUBTRACT$',subtract,1)
  call gildas_close
  !
  call cct_model(uvdata,cleant,uvmodel,frequency,subtract,error)
end program uv_cc_model
!<FF>
subroutine cct_model (uvdata,cleant,uvmodel,frequency,subtract,error)
  !----------------------------------------------------------------------
  ! GILDAS
  ! Compute a UV data set from an image model
  ! Input : a UV table, created for example by ASTRO
  ! Input : a Clean Component Table
  ! Output: the UV table, where the visibilities have been computed.
  !
  !----------------------------------------------------------------------
  use gkernel_interfaces
  use image_def
  character(len=*), intent(in) :: uvdata, cleant, uvmodel
  real(8), intent(in) :: frequency
  logical, intent(in) :: subtract
  logical, intent(out) :: error
  !
  type (gildas) :: huvd, hcct, huvm
  real, allocatable :: dcct(:,:,:),duvm(:,:)
  real(8), allocatable :: freqs(:)
  integer :: ier, ic
  !
  error = .false.
  !
  ! Read UVDATA
  call gildas_null(huvd, type = 'UVT')
  call sic_parse_file(uvdata,' ','.uvt',huvd%file)
  call gdf_read_header (huvd,error)
  if (error) return
  !
  ! Define UVMODEL
  call gildas_null(huvm, type = 'UVT')
  call gdf_copy_header (huvd,huvm,error)
  call sic_parse_file(uvmodel,' ','.uvt',huvm%file)
  if (frequency.ne.0) then
    huvm%gil%freq = frequency
    huvm%gil%val(1) = frequency
  endif
  if (huvm%gil%freq.eq.0) then
    call gagout('E-UV_CCMODEL,  Missing UV table frequency')
    error = .true.
    return
  endif
  !
  ! Read data from UVDATA
  allocate (duvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
  call gdf_read_data (huvd,duvm,error)
  !
  ! Read the Clean Component Table
  call gildas_null(hcct)
  call sic_parse_file(cleant,' ','.cct',hcct%file)
  call gdf_read_header (hcct,error)
  if (error) return
  allocate (dcct(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3)),stat=ier)
  call gdf_read_data (hcct,dcct,error)
  if (error) return
  !
  allocate (freqs(huvm%gil%nchan),stat=ier)
  do ic = 1,huvm%gil%nchan
    freqs(ic) = gdf_uv_frequency(huvm,dble(ic))
  enddo
  !
  ! Compute the model
  if (hcct%char%code(3).eq.'COMPONENT') then
    call gagout('I-UV_CCMODEL,  Clean Components from MAPPING')
    call do_model_a (freqs   & ! Frequency
     &      ,huvm%gil%dim(1) & ! Visibility size
     &      ,huvm%gil%dim(2) & ! Number of visibilities
     &      ,duvm            & ! Visibilities
     &      ,hcct%gil%dim(1) & !
     &      ,hcct%gil%dim(2) & ! Number of channels
     &      ,hcct%gil%dim(3) & ! Number of Clean Components
     &      ,dcct            & !
     &      ,subtract)         ! Subtract ?
  else
    call gagout('I-UV_CCMODEL,  Clean Components from CLEAN')
    call do_model_b (freqs   &   ! Frequency
     &      ,huvm%gil%dim(1) & ! Visibility size
     &      ,huvm%gil%dim(2) & ! Number of visibilities
     &      ,duvm            & ! Visibilities
     &      ,hcct%gil%dim(1) & !
     &      ,hcct%gil%dim(2) & ! Number of Clean Components
     &      ,hcct%gil%dim(3) & ! Number of channels
     &      ,dcct            & !
     &      ,subtract)         ! Subtract ?
  endif
  !
  ! Write the result
  call gdf_write_image(huvm,duvm,error)
  deallocate (dcct)
  deallocate (duvm)
end subroutine cct_model
!<FF>
subroutine do_model_a (freq,nf,nv,visi,lc,nc,mc,clean,sub)
  use gildas_def
  !-----------------------------------------------------------------
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table
  ! This version is for CCT tables from MAPPING
  !-----------------------------------------------------------------
  integer(kind=index_length), intent(in)    :: nf               ! Number of frequency channels
  integer(kind=index_length), intent(in)    :: nv               ! Number of visibilities
  real,                       intent(inout) :: visi(nf,nv)      ! Visibilities
  integer(kind=index_length), intent(in)    :: lc               ! Dimension of a Clean Component
  integer(kind=index_length), intent(in)    :: mc               ! Number of Clean Components
  integer(kind=index_length), intent(in)    :: nc               ! Number of Channels
  real(8),                    intent(in)    :: freq(nc)         ! Frequency
  real,                       intent(in)    :: clean(lc,nc,mc)  ! X,Y,V per channel and component
  logical,                    intent(in)    :: sub              ! Subtract or Add
  !
  real(8), allocatable :: pidsur(:)            ! 2*pi*D/Lambda
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k=2.d0*pi/299792458.d-6
  real(8) :: x, y, phase, rvis, ivis
  integer ii, ir, ier
  integer ic,iv,jc
  !
  allocate(pidsur(nc),stat=ier)
  if (ier.ne.0) return
  !
  pidsur(:) = f_to_k * freq
  !
  if (sub) then
    !
    ! Remove clean component from UV data set
    do iv=1,nv
      ir = 7+1
      ii = 7+2
      do jc = 1,nc
        do ic = 1,mc
          if (clean(3,jc,ic).ne.0) then
            x = pidsur(jc)*clean(1,jc,ic)
            y = pidsur(jc)*clean(2,jc,ic)
            phase = visi(1,iv)*x+visi(2,iv)*y
            rvis = clean(3,jc,ic)*cos(phase)
            ivis = clean(3,jc,ic)*sin(phase)
            visi(ir,iv) = visi(ir,iv) - rvis   ! Subtract
            visi(ii,iv) = visi(ii,iv) - ivis
          endif
        enddo
        ir = ir+3
        ii = ii+3
      enddo
    enddo
  else
    do iv=1,nv
      ir = 7+1
      ii = 7+2
      do jc = 1,nc
        visi(ir,iv) = 0.0
        visi(ii,iv) = 0.0
        do ic = 1,mc
          if (clean(3,jc,ic).ne.0) then
            x = pidsur(jc)*clean(1,jc,ic)
            y = pidsur(jc)*clean(2,jc,ic)
            phase = visi(1,iv)*x+visi(2,iv)*y
            rvis = clean(3,jc,ic)*cos(phase)
            ivis = clean(3,jc,ic)*sin(phase)
            visi(ir,iv) = visi(ir,iv) + rvis   ! Add
            visi(ii,iv) = visi(ii,iv) + ivis
          endif
        enddo
        ir = ir+3
        ii = ii+3
      enddo
    enddo
  endif
end subroutine do_model_a
!
subroutine do_model_b (freq,nf,nv,visi,lc,mc,nc,clean,sub)
  use gildas_def
  !-----------------------------------------------------------------
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table
  ! This version is for CCT tables from TASK CLEAN
  !-----------------------------------------------------------------
  integer(kind=index_length), intent(in)    :: nf               ! Number of frequency channels
  integer(kind=index_length), intent(in)    :: nv               ! Number of visibilities
  real,                       intent(inout) :: visi(nf,nv)      ! Visibilities
  integer(kind=index_length), intent(in)    :: lc               !
  integer(kind=index_length), intent(in)    :: mc               ! Number of Clean Components
  integer(kind=index_length), intent(in)    :: nc               ! Number of Channels
  real(8),                    intent(in)    :: freq(nc)         ! Frequency
  real,                       intent(in)    :: clean(lc,mc,nc)  ! X,Y,V for per component and channel
  logical,                    intent(in)    :: sub              ! Subtract or Add component
  !
  real(8), allocatable :: pidsur(:)  ! 2*pi*D/Lambda
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k=2.d0*pi/299792458.d-6
  real(8) :: x, y, phase, rvis, ivis
  integer ii, ir, ier
  integer ic,iv,jc
  !
  allocate(pidsur(nc),stat=ier)
  if (ier.ne.0) return
  !
  pidsur(:) = f_to_k * freq
  !
  if (sub) then
    !
    ! Remove clean component from UV data set
    do iv=1,nv
      ir = 7+1
      ii = 7+2
      do jc = 1,nc
        do ic = 1,mc
          if (clean(3,ic,jc).ne.0) then
            x = pidsur(jc)*clean(1,ic,jc)
            y = pidsur(jc)*clean(2,ic,jc)
            phase = visi(1,iv)*x+visi(2,iv)*y
            rvis = clean(3,ic,jc)*cos(phase)
            ivis = clean(3,ic,jc)*sin(phase)
            visi(ir,iv) = visi(ir,iv) - rvis   ! Subtract
            visi(ii,iv) = visi(ii,iv) - ivis
          endif
        enddo
        ir = ir+3
        ii = ii+3
      enddo
    enddo
  else
    do iv=1,nv
      ir = 7+1
      ii = 7+2
      do jc = 1,nc
        visi(ir,iv) = 0.0
        visi(ii,iv) = 0.0
        do ic = 1,mc
          if (clean(3,ic,jc).ne.0) then
            x = pidsur(jc)*clean(1,ic,jc)
            y = pidsur(jc)*clean(2,ic,jc)
            phase = visi(1,iv)*x+visi(2,iv)*y
            rvis = clean(3,ic,jc)*cos(phase)
            ivis = clean(3,ic,jc)*sin(phase)
            visi(ir,iv) = visi(ir,iv) + rvis   ! Subtract
            visi(ii,iv) = visi(ii,iv) + ivis
          endif
        enddo
        ir = ir+3
        ii = ii+3
      enddo
    enddo
  endif
end subroutine do_model_b

subroutine greg_plot (line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_plot
  !---------------------------------------------------------------------
  ! @ private
  ! GREG
  ! Support for command PLOT
  !  [GREG2\]PLOT [Var_name]
  !     [/BLANKING Bval Eval Colour]
  !     [/SCALING Type Low_cut High_cut]
  !     [/POSITION Posx1 Posx2 Posy1 Posy2]
  !     [/BOUNDARIES Userx1 Userx2 Usery1 Usery2]
  !     [/VISIBLE]
  !
  ! Usage:
  !   Var_name is a 2-D SIC variable name. Subsets like A[4] where A
  ! is a 3-D sic variable are not yet allowed. This command is normally
  ! used in the following sequence:
  !
  !     SET BOX LOCATION Gx1 Gx2 Gy1 Gy2  ! Define box position
  !     RGDATA /VARIABLE Var_name         ! Get characteristics from image.
  !     LIMITS /RGDATA                    ! Get limits
  !     PLOT Var_name                     ! Plot the array in the box
  !     BOX
  !     RGMAP                             ! Draw contour levels (...)
  !
  ! Without argument, the RG variable is plotted
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call im_plot(line,error)
  if (error)  return
  !
end subroutine greg_plot
!
subroutine im_plot (line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces, no_interface1=>gtv_image,  &
                                    no_interface2=>gtv_rgbimage,  &
                                    no_interface3=>gr4_minmax
  use greg_interfaces, except_this=>im_plot
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG
  ! Support for command PLOT
  !  [GREG2\]PLOT [Var_name]
  !     [/BLANKING Bval Eval Colour]
  !     [/SCALING Type Low_cut High_cut]
  !     [/POSITION Posx1 Posx2 Posy1 Posy2]
  !     [/BOUNDARIES Userx1 Userx2 Usery1 Usery2]
  !     [/VISIBLE]
  !
  ! Usage:
  !   Var_name is a 2-D SIC variable name. Subsets like A[4] where A
  ! is a 3-D sic variable are not yet allowed. This command is normally
  ! used in the following sequence:
  !
  !     SET BOX LOCATION Gx1 Gx2 Gy1 Gy2  ! Define box position
  !     RGDATA /VARIABLE Var_name         ! Get characteristics from image.
  !     LIMITS /RGDATA                    ! Get limits
  !     PLOT Var_name                     ! Plot the array in the box
  !     BOX
  !     RGMAP                             ! Draw contour levels (...)
  !
  ! Without argument, the RG variable is plotted
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='PLOT'
  integer(kind=index_length) :: mx,my
  real(kind=4) :: locx1,locx2,locy1,locy2
  real(kind=4) :: wux1,wux2,wuy1,wuy2
  real(kind=4) ::  cuts(2), extrem(2)
  real(kind=4) :: rcuts(2),rextrem(2)
  real(kind=4) :: gcuts(2),gextrem(2)
  real(kind=4) :: bcuts(2),bextrem(2)
  real(kind=4) :: loca(4),limts(4),convrt(6)
  real(kind=4) :: blank(3),scaling_lup_b
  integer(kind=4) :: k,nc
  integer(kind=size_length) :: kmin,kmax,size
  logical :: found,is_image,has_extrema,is_visible,is_rgb
  character(len=32) :: var_name,ima_name
  type(sic_descriptor_t) :: desc,inca
  integer(kind=address_length) :: ipnta,ipntr,ipntg,ipntb,ipnt
  save inca  ! Is this SAVE attribute needed?
  integer(kind=4) :: iper
  integer(kind=4) :: scaling
  integer(kind=4), parameter :: nscale=4
  character(len=12) :: scale(nscale),chain,keyw
  ! Data
  data scale/'LINEAR','LOGARITHMIC','EQUALIZATION','LUPTON'/
  !
  ! Locate the variable
  var_name = 'RG'  ! Use "RG" variable as a default
  call sic_ke (line,0,1,var_name,nc,.false.,error)
  if (error) return
  !
  call plot_getvar(var_name,inca,error)
  if (error)  return
  is_rgb = inca%ndim.eq.3 .and. inca%dims(3).gt.1  ! 3 RGB planes
  if (is_rgb) then
    ipntr = gag_pointer(inca%addr,memory)
    ipntg = ipntr+inca%dims(1)*inca%dims(2)
    ipntb = ipntg+inca%dims(1)*inca%dims(2)
  else
    ipnt = gag_pointer(inca%addr,memory)
  endif
  mx = inca%dims(1)
  my = inca%dims(2)
  !
  k = index(var_name,'[')
  if (k.ne.0) then
    ! call gagout('W-PLOT,  Plotting a Sub-array')
    var_name(k:) = ' '
  endif
  !
  ! Check if it is an IMAGE, and load the associated extrema,
  ! blanking and pixel to user coordinates conversion if so.
  iper = lenc(var_name)+1
  ima_name = var_name
  ima_name(iper:) = '%CONVERT'
  is_image = .false.
  call sic_descriptor(ima_name,desc,is_image)
  !
  if (sic_present(4,0)) then
    !
    ! 4 /BOUNDARIES option indicates the User Limits
    call sic_r4 (line,4,1,wux1,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,4,2,wux2,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,4,3,wuy1,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,4,4,wuy2,.true.,error)
    if (error)  goto 100
  else
    wux1 = gux1
    wux2 = gux2
    wuy1 = guy1
    wuy2 = guy2
  endif
  !
  ! This is an image with everything...
  has_extrema = .false.
  if (is_image) then
    ! Conversion
    ipnta = gag_pointer(desc%addr,memory)
    call r8tor4(memory(ipnta),convrt,6)
    ! Blanking
    ima_name(iper:) = '%BLANK'
    call sic_descriptor(ima_name,desc,found)
    ipnta = gag_pointer(desc%addr,memory)
    call r4tor4(memory(ipnta),blank,2)
    ! Extrema
    ima_name(iper:) = '%EXTREMA'
    has_extrema = sic_varexist(ima_name)
    if (has_extrema) then
      ima_name(iper:) = '%MIN'
      call sic_get_real(ima_name,extrem(1),error)
      ima_name(iper:) = '%MAX'
      call sic_get_real(ima_name,extrem(2),error)
    endif
  elseif (var_name.eq.'RG') then
    ! RG variable also has some conversion formula
    convrt(1) = rg%xref
    convrt(2) = rg%xval
    convrt(3) = rg%xinc
    convrt(4) = rg%yref
    convrt(5) = rg%yval
    convrt(6) = rg%yinc
  else
    !
    ! Compute the user coordinate conversion assuming
    !     1) The image fits in the box
    !     2) It has the corresponding user limits
    !
    convrt(1) = 0.5
    convrt(2) = wux1
    convrt(3) = (wux2-wux1)/mx
    convrt(4) = 0.5
    convrt(5) = wuy1
    convrt(6) = (wuy2-wuy1)/my
  endif
  !
  ! If limits are overridden, change them
  if (sic_present(4,0)) then
    convrt(1) = 0.5
    convrt(2) = wux1
    convrt(3) = (wux2-wux1)/mx
    convrt(4) = 0.5
    convrt(5) = wuy1
    convrt(6) = (wuy2-wuy1)/my
  endif
  !
  limts(1) = gux1
  limts(2) = gux2
  limts(3) = guy1
  limts(4) = guy2             ! It was the WUXi before ...
  !
  ! Option 1 /BLANKING
  if (sic_present(1,0)) then
    call sic_r4 (line,1,1,blank(1),.true.,error)
    if (error)  goto 100
    call sic_r4 (line,1,2,blank(2),.true.,error)
    if (error)  goto 100
    blank(3) = -1.0            ! Use Background Colour
    call sic_r4 (line,1,3,blank(3),.false.,error)
    if (error)  goto 100
  elseif (.not.is_image) then
    ! Use GreG blanking as a default
    blank(1) = cblank
    blank(2) = eblank
  endif
  !
  ! Compute the extrema
  if (is_rgb) then
    ! Ignore RG%MIN/MAX, compute extrema for each plane
    size = mx*my
    call gr4_minmax(size,memory(ipntr),blank(1),blank(2),rextrem(1),rextrem(2),  &
      kmin,kmax)
    call gr4_minmax(size,memory(ipntg),blank(1),blank(2),gextrem(1),gextrem(2),  &
      kmin,kmax)
    call gr4_minmax(size,memory(ipntb),blank(1),blank(2),bextrem(1),bextrem(2),  &
      kmin,kmax)
  else
    ! Get extrema from RG%MIN/MAX, else compute them
    if (.not.has_extrema) then
      if (var_name.eq.'RG') then
        call rgextr(0,extrem(1),extrem(2),rg%data,blank(1),blank(2),.false.)
      else
        call gr4_minmax (inca%size,memory(ipnt),blank(1),blank(2),  &
          extrem(1),extrem(2),kmin,kmax)
      endif
    endif
  endif
  !
  ! 2 /SCALING
  chain = 'LINEAR'  ! Default
  call sic_ke (line,2,1,chain,nc,.false.,error)
  if (error)  goto 100
  call sic_ambigs(rname,chain,keyw,scaling,scale,nscale,error)
  if (error)  goto 100
  !
  if (is_rgb) then
    ! RGB image (3 planes)
    rcuts = rextrem
    gcuts = gextrem
    bcuts = bextrem
    if (scaling.eq.4) then
      ! Lupton mode, retrieve beta factor
      scaling_lup_b = 3.0  ! Default
      call sic_r4(line,2,2,scaling_lup_b,.false.,error)
      if (error)  goto 100
    else
      ! Other modes, can override the default cuts
      call sic_r4(line,2,2,rcuts(1),.false.,error)
      if (error)  goto 100
      call sic_r4(line,2,3,rcuts(2),.false.,error)
      if (error)  goto 100
      !
      call sic_r4(line,2,4,gcuts(1),.false.,error)
      if (error)  goto 100
      call sic_r4(line,2,5,gcuts(2),.false.,error)
      if (error)  goto 100
      !
      call sic_r4(line,2,6,bcuts(1),.false.,error)
      if (error)  goto 100
      call sic_r4(line,2,7,bcuts(2),.false.,error)
      if (error)  goto 100
    endif
  else
    ! RG image (single plane)
    if (scaling.eq.4) then
      call greg_message(seve%e,rname,'LUPTON scaling valid only for RGB images')
      error = .true.
      return
    endif
    cuts = extrem
    call sic_r4 (line,2,2,cuts(1),.false.,error)
    if (error)  goto 100
    call sic_r4 (line,2,3,cuts(2),.false.,error)
    if (error)  goto 100
  endif
  !
  ! Setup the characteristics
  !
  ! Now setup the characteristics of the plotting area
  ! 3 /POSITION
  if (sic_present(3,0)) then
    call sic_r4 (line,3,1,locx1,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,3,2,locx2,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,3,3,locy1,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,3,4,locy2,.true.,error)
    if (error)  goto 100
  else
    ! Use GreG Box location
    locx1 = gx1
    locx2 = gx2
    locy1 = gy1
    locy2 = gy2
  endif
  loca(1) = locx1
  loca(2) = locx2
  loca(3) = locy1
  loca(4) = locy2
  !
  ! /VISIBLE
  is_visible = .not.sic_present(5,0)
  !
  ! Create the image segment
  call gr_segm(var_name,error)
  if (error) then
    call greg_message(seve%e,rname,'Could not create image segment')
    goto 100
  endif
  !
  ! Create the image descriptor in GTVIRT
  if (is_rgb) then
    ! RGB image
    call gtv_rgbimage(                    &
      mx,my,                              &  ! Size of planes
      memory(ipntr),blank,rcuts,rextrem,  &  ! R plane description
      memory(ipntg),blank,gcuts,gextrem,  &  ! G plane description
      memory(ipntb),blank,bcuts,bextrem,  &  ! B plane description
      scaling,scaling_lup_b,              &  ! RGB planes scaling mode
      loca,                               &  ! Position in Paper coordinates
      limts,                              &  ! User limits
      convrt,                             &  ! Image pixel to User conversion formula
      is_visible,                         &  ! Always Visible ?
      error)
  else
    ! RG image
    call gtv_image(        &
      mx,my,memory(ipnt),  &  ! Data
      loca,                &  ! Position in Paper coordinates
      limts,               &  ! User limits
      convrt,              &  ! Image pixel to User conversion formula
      scaling,             &  ! Scaling mode (1=Lin, 2=Log, 3=Equ)
      cuts,                &  ! Low and High cuts
      extrem,              &  ! Low and High extrema
      blank,               &  ! Blanking value
      is_visible,          &  ! Always Visible ?
      .true.,              &  ! Update the SIC structure CURIMA%
      error)
  endif
  ! if (error) do nothing: we have to close this (empty) segment
  !
  ! Close the image segment
  call gtsegm_close(error)
  if (error)  goto 100
  !
100 continue
  call sic_volatile(inca)  ! Free the image incarnation
  !
end subroutine im_plot
!
subroutine plot_getvar(name,inca,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>plot_getvar
  !---------------------------------------------------------------------
  ! @ private
  ! Check if the variable is something you can plot
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: name   ! Variable name
  type(sic_descriptor_t), intent(out)   :: inca   ! REAL*4 incarnation
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PLOT'
  type(sic_descriptor_t) :: desc
  logical :: found
  integer(kind=size_length) :: size
  integer(kind=4) :: i
  !
  call sic_descriptor(name,desc,found)
  if (.not.found) then
    call greg_message(seve%e,rname,'Variable '//trim(name)//' does not exist')
    error = .true.
    return
  endif
  !
  if (desc%ndim.eq.1) then
    call greg_message(seve%e,rname,'Variable '//trim(name)//' is 1-D only')
    error = .true.
    return
    !
! elseif (desc%ndim.eq.2) then
!   2-D RG plot: ok
  elseif (desc%ndim.eq.3) then
    ! 3th dimension == 1: ok (2D single plane RG plot)
    ! 3th dimension == 3: ok (2D 3 planes RGB plot)
    if (desc%dims(3).ne.1 .and. desc%dims(3).ne.3) then
      call greg_message(seve%e,rname,  &
        '3rd dimension must be 1 (single plane) or 3 (3 RGB planes)')
      error = .true.
      return
    endif
  elseif (desc%ndim.ge.4) then
    ! Check if the 4th and more dimensions are degenerated
    size = 1
    do i=desc%ndim,4,-1
      size = size*desc%dims(i)
    enddo
    if (size.gt.1) then
      call greg_message(seve%e,rname,'Variable '//trim(name)//' is 4-D or more')
      error = .true.
      return
    endif
  endif
  !
  !
  ! Incarnate it in REAL*4
  call sic_incarnate(fmt_r4,desc,inca,error)
  if (error) return
  !
end subroutine plot_getvar

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_standard_arg
  use cubetools_parameters
  use cubetools_primitive_arg
  use cubetools_structure_main
  !
  public :: standard_arg_t
  private
  !
  type, extends(primitive_arg_t) :: standard_arg_t
     ! No element to add
  contains
     procedure :: register => cubetools_register_standard_arg
  end type standard_arg_t
  !
contains
  !
  subroutine cubetools_register_standard_arg(template,name,abstract,help,mandat,error)
    !----------------------------------------------------------------------
    ! Register an argument of exact type standard_arg_t in the global 'pack'
    !----------------------------------------------------------------------
    class(standard_arg_t), intent(in)    :: template
    character(len=*),      intent(in)    :: name
    character(len=*),      intent(in)    :: abstract
    character(len=*),      intent(in)    :: help
    integer(kind=code_k),  intent(in)    :: mandat
    logical,               intent(inout) :: error
    !
    class(primitive_arg_t), pointer :: parg
    !
    call cubetools_register_primitive_arg(template,name,abstract,help,mandat,parg,error)
    if (error) return
  end subroutine cubetools_register_standard_arg

end module cubetools_standard_arg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_topology
  use cubetools_parameters
  use cubetools_structure
  use cubetools_switch_types
  use cube_types
  use cubeadm_cubeid_types
  use cubetopology_cuberegion_types
  use cubetopology_speline_types
  use cubetopology_spevsys_types
  use cubetopology_spasamp_types
  use cubeset_spatial
  use cubeset_spectral
  use cubego_messaging
  use cubego_extrema_types
  !
  public :: topology
  private
  !
  type :: topology_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(option_t),     pointer :: list
     type(switch_comm_t)         :: truncate
   contains
     procedure, public  :: register => cubego_topology_register
     procedure, private :: parse    => cubego_topology_parse
     procedure, private :: main     => cubego_topology_main
  end type topology_comm_t
  type(topology_comm_t) :: topology
  !
  type topology_user_t
     logical             :: dolist
     type(cubeid_user_t) :: incube
     type(switch_user_t) :: truncate
   contains
     procedure, private :: toprog => cubego_topology_user_toprog
  end type topology_user_t
  !
  type topology_prog_t
     logical                 :: dolist
     type(cube_t), pointer   :: cube
     type(speline_prog_t)    :: freq
     type(spevsys_prog_t)    :: vsys
     type(cuberegion_prog_t) :: region
     type(extrema_prog_t)    :: extrema
     type(switch_prog_t)     :: truncate
   contains
     procedure, private :: compute    => cubego_topology_prog_compute
     procedure, private :: def_struct => cubego_topology_prog_def_struct
     procedure, private :: list       => cubego_topology_prog_list
  end type topology_prog_t
  type(topology_prog_t) :: progtopo
  !
contains
  !
  subroutine cubego_topology_command(line,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(topology_user_t) :: user
    character(len=*), parameter :: rname='TOPOLOGY>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call topology%parse(line,user,error)
    if (error) return
    call topology%main(user,error)
    if (error) return
  end subroutine cubego_topology_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_topology_register(topology,error)
    use cubedag_allflags
    !--------------------------------------------------------------------
    ! 
    !--------------------------------------------------------------------
    class(topology_comm_t), intent(inout) :: topology
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    character(len=*), parameter :: rname='TOPOLOGY>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'TOPOLOGY','[cubeid]',&
         'Compute the topology of the region of interest',&
         'Compute topology diagnostics for the currently selected cube region and&
         & export them into the TOPOLOGY structure.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Cube selection is resolved together with shared SET\SPATIAL&
         & and SET\SPECTRAL defaults.'//strg_cr//&
         '- /TRUNCATE selects the topology range conversion mode for&
         & exported ranges.'//strg_cr//&
         '- /LIST prints a human-readable report.'//strg_bl//&
         'Additional Output:'//strg_cr//&
         '- topology%x: spatial X-range information.'//strg_cr//&
         '- topology%y: spatial Y-range information.'//strg_cr//&
         '- topology%z: spectral range information.'//strg_cr//&
         '- topology%extrema: min/max values and positions for the&
         & analyzed region.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- Exported ranges can preserve user-requested bounds while&
         & extrema use intersected index spans.'//strg_cr//&
         '- Results are rewritten at each command call.'//strg_bl//&
         'Examples:'//strg_cr//&
         '  CUBE> GO\TOPOLOGY /LIST'//strg_cr//&
         '  CUBE> GO\TOPOLOGY c12 /TRUNCATE OFF /LIST'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         '  CUBE> SET\SPATIAL /SIZE 60 40 /CENTER * * relative'//strg_cr//&
         '  CUBE> SET\SPECTRAL /RANGE -5 5 km/s'//strg_cr//&
         '  CUBE> GO\TOPOLOGY c12 /TRUNCATE ON /LIST'//strg_bl//&
         'Associated commands: SET\SPATIAL, SET\SPECTRAL.',&
         cubego_topology_command,&
         topology%comm,&
         error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Identity of the cube used for topology computation',&
         'If omitted, use the last matching cube (any family/flags) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         topology%cube,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'LIST','',&
         'List the topology computed for the current cube',&
         strg_emp,&
         topology%list,&
         error)
    if (error) return
    !
    call topology%truncate%register(&
         'TRUNCATE',&
         'topology range conversion mode near cube bounds',&
         'ON',&
         'Controls how SET\SPATIAL and SET\SPECTRAL ranges are&
         & converted:'//strg_cr//&
         '- ON clips default ranges to in-cube indices [1,N].'//strg_cr//&
         '- OFF keeps default ranges at full half-bin limits&
         & [0.5,N+0.5].'//strg_cr//&
         '- Extrema are always computed on the intersected in-cube&
         & region.'//strg_cr//&
         '- If requested ranges do not overlap the cube, TOPOLOGY&
         & returns an outside-cube error.',&
         error)
    if (error) return
  end subroutine cubego_topology_register
  !
  subroutine cubego_topology_parse(topology,line,user,error)
    !-------------------------------------------------------------------
    ! TOPOLOGY cubeid [/LIST] [/TRUNCATE ON|OFF]
    !-------------------------------------------------------------------
    class(topology_comm_t), intent(in)    :: topology
    character(len=*),       intent(in)    :: line
    type(topology_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOPOLOGY>PARSE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,topology%comm,user%incube,error)
    if (error) return
    call topology%list%present(line,user%dolist,error)
    if (error) return
    call topology%truncate%parse(line,user%truncate,error)
    if (error) return
  end subroutine cubego_topology_parse
  !
  subroutine cubego_topology_main(topology,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(topology_comm_t), intent(in)    :: topology
    type(topology_user_t),  intent(in)    :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOPOLOGY>MAIN'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call user%toprog(topology,progtopo,error)
    if (error) return
    call progtopo%compute(error)
    if (error) return
    if (progtopo%dolist) then
       call progtopo%list(error)
       if (error) return
    endif
    ! Need to redefine it each time because it's a copy!
    call progtopo%def_struct('topology',error)
    if (error) return
  end subroutine cubego_topology_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_topology_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(topology_user_t), intent(in)    :: user
    type(topology_comm_t),  intent(in)    :: comm
    type(topology_prog_t),  intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOPOLOGY>USER>TOPROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(topology%cube,user%incube,prog%cube,error)
    if (error) return
    prog%dolist = user%dolist
    !
    call prog%truncate%init(comm%truncate,error)
    if (error)  return
    call user%truncate%toprog(comm%truncate,prog%truncate,error)
    if (error)  return
    !
    call cubego_topology_user_toprog_region(prog,prog%region,error)
    if (error)  return
  end subroutine cubego_topology_user_toprog
  !
  subroutine cubego_topology_user_toprog_region(prog,region,error)
    use cubetopology_sperange_types
    use cubetopology_sparange_types
    !-------------------------------------------------------------------
    ! Duplication of part of cubetopology_cuberegion_user_toprog because:
    ! 1. This code fills the cuberegion_prog_t but the user* types
    !    are not cuberegion_user_t.
    ! 2. The user may want to have a larger topology than the cube can
    !    provide. It's his responsability to intersect when
    !    needed. Nevertheless the command will also compute the minimum and
    !    maximum value of the subcube that intersect the user request and
    !    the actual cube.
    !-------------------------------------------------------------------
    class(topology_prog_t),  intent(inout) :: prog
    type(cuberegion_prog_t), intent(out)   :: region
    logical,                 intent(inout) :: error
    !
    integer(kind=code_k) :: code_sperange,code_sparange
    character(len=*), parameter :: rname='TOPOLOGY>USER>TOPROG>REGION'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    if (prog%truncate%enabled) then
      code_sperange = code_sperange_truncated
      code_sparange = code_sparange_truncated
    else
      code_sperange = code_sperange_full
      code_sparange = code_sparange_full
    endif
    !
    ! From user to prog ranges
    call userspe%toprog(prog%cube,code_sperange,prog%freq,prog%vsys,region%zrange,error)
    if (error) return
    call userspa%toprog(prog%cube,code_sparange,region%xrange,region%yrange,error)
    if (error) return
    !
    ! Ensure that the range will be inside the axis range
    call region%xrange%intersect_axis(error)
    if (error) return
    call region%yrange%intersect_axis(error)
    if (error) return
    call region%zrange%intersect_axis(error)
    if (error) return
    ! Then compute the associated firstlaststride to ensure that we will compute the
    ! minimum and maximum value inside the part of the cube that intersects the user
    ! defined region
    call region%xrange%to_pixe_k(region%ix%first,region%ix%last,region%ix%stride,error)
    if (error) return
    call region%yrange%to_pixe_k(region%iy%first,region%iy%last,region%iy%stride,error)
    if (error) return
    call region%zrange%to_chan_k(region%iz%first,region%iz%last,region%iz%stride,error)
    if (error) return
    !
    ! From user to prog ranges again to avoid the previous intersection
    call userspe%toprog(prog%cube,code_sperange,prog%freq,prog%vsys,region%zrange,error)
    if (error) return
    call userspa%toprog(prog%cube,code_sparange,region%xrange,region%yrange,error)
    if (error) return
  end subroutine cubego_topology_user_toprog_region
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_topology_prog_compute(prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(topology_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOPOLOGY>COMPUTE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call prog%extrema%get(prog%cube,prog%region,error)
    if (error) return
  end subroutine cubego_topology_prog_compute
  !
  subroutine cubego_topology_prog_def_struct(prog,name,error)
    use cubetools_userspace
    use cubetools_userstruct
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(topology_prog_t), intent(in)    :: prog
    character(len=*),       intent(in)    :: name
    logical,                intent(inout) :: error
    !
    type(userstruct_t) :: struct
    character(len=*), parameter :: rname='TOPOLOGY>PROG>DEF>STRUCT'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call struct%create(name,global,overwrite_user,error)
    if (error) return
    call prog%region%xrange%def_substruct('x',struct,error)
    if (error) return
    call prog%region%yrange%def_substruct('y',struct,error)
    if (error) return
    call prog%region%zrange%def_substruct('z',struct,error)
    if (error) return
    call prog%extrema%def_substruct('extrema',struct,error)
    if (error) return
  end subroutine cubego_topology_prog_def_struct
  !
  subroutine cubego_topology_prog_list(prog,error)
    !-------------------------------------------------------------------
    ! List topology variables in a user friendly manner 
    !-------------------------------------------------------------------
    class(topology_prog_t), intent(in)    :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOPOLOGY>PROG>LIST'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call prog%region%list(error)
    if (error) return
    call prog%region%list_size_center(error)
    if (error) return
    call cubego_message(seve%r,rname,blankstr)
    call prog%extrema%list(error)
    if (error) return
  end subroutine cubego_topology_prog_list
end module cubego_topology
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gsys_interfaces_none
  interface
    subroutine cdclose(ierror,lun)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
    end subroutine cdclose
  end interface
  !
  interface
    subroutine cddir(ierror,lun,s_dir,lines)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      character(len=*) :: s_dir                 !
      integer(kind=4) :: lines                  !
    end subroutine cddir
  end interface
  !
  interface
    subroutine cdfclose(ierror,fid)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: fid                    !
    end subroutine cdfclose
  end interface
  !
  interface
    subroutine cdfopen(ierror,lun,s_file,fid,recl,bytes)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      character(len=*) :: s_file                !
      integer(kind=4) :: fid                    !
      integer(kind=4) :: recl                   !
      integer(kind=4) :: bytes                  !
    end subroutine cdfopen
  end interface
  !
  interface
    subroutine cdfread(ierror,fid,startbyte,numbytes,array)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: fid                    !
      integer(kind=4) :: startbyte              !
      integer(kind=4) :: numbytes               !
      integer(kind=1) :: array(0:*)             !
    end subroutine cdfread
  end interface
  !
  interface
    subroutine cdgetblock(ierror,lun,block,array)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      integer(kind=4) :: block                  !
      integer(kind=1) :: array(0:511)           !
    end subroutine cdgetblock
  end interface
  !
  interface
    subroutine cdgetdir(ierror,lun,block,att,lines)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      integer(kind=4) :: block                  !
      integer(kind=4) :: att                    !
      integer(kind=4) :: lines                  !
    end subroutine cdgetdir
  end interface
  !
  interface
    subroutine cdgetdirline(ierror,lun,lineno,linebytes,linelen)
      integer(kind=4) :: ierror                  !
      integer(kind=4) :: lun                     !
      integer(kind=4) :: lineno                  !
      integer(kind=1) :: linebytes(0:*)          !
      integer(kind=4) :: linelen                 !
    end subroutine cdgetdirline
  end interface
  !
  interface
    subroutine cdgetlbs(ierror,lun,lbs,rootbeg,rootatt)
      integer(kind=4) :: ierror                 !Error flag
      integer(kind=4) :: lun                    !Logical unit number
      integer(kind=4) :: lbs                    !Logical block size
      integer(kind=4) :: rootbeg                !Starting block of root
      integer(kind=4) :: rootatt                !Attribute blocks in root
    end subroutine cdgetlbs
  end interface
  !
  interface
    subroutine cdgetlun(ierror,lun,lindex)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      integer(kind=4) :: lindex                 !
    end subroutine cdgetlun
  end interface
  !
  interface
    subroutine cdopen(ierror,lun,s_name)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      character(len=*) :: s_name                !
    end subroutine cdopen
  end interface
  !
  interface
    subroutine smvb(from,length,to)
      integer(kind=1) :: from(*)                !
      integer(kind=4) :: length                 !
      integer(kind=1) :: to(*)                  !
    end subroutine smvb
  end interface
  !
#if defined(CYGWIN) || defined(MINGW)
  interface
    subroutine gbl_message_mp_seve
    end subroutine gbl_message_mp_seve
  end interface
  !
#endif
end module gsys_interfaces_none

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_import
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubedag_parameters
  use cubedag_link_type
  use cubedag_node_class
  use cubedag_dag_buffer
  use cubeadm_messaging
  use cubedag_directory_type
  !
  type(cubedag_link_t) :: im  ! List of imported cubes
  type(cubedag_link_t) :: tw  ! List of current twins
  !
  public :: import
  private
  !
  type :: import_comm_t
     type(option_t),      pointer :: comm
     type(option_t),      pointer :: hdu
     type(option_t),      pointer :: mapping
     type(option_t),      pointer :: class
     type(option_t),      pointer :: optparse
     type(option_t),      pointer :: sort
     type(keywordlist_comm_t), pointer :: sort_arg
     type(option_t),      pointer :: verbose
  contains
     procedure, public  :: register => cubeadm_import_register
     procedure, private :: parse    => cubeadm_import_parse
     procedure, private :: main     => cubeadm_import_main
  end type import_comm_t
  type(import_comm_t) :: import
  !
  integer(kind=4), parameter :: fits_primary_hdu=1
  !
  integer(kind=code_k), parameter :: sort_none=1
  integer(kind=code_k), parameter :: sort_chro=2
  integer(kind=code_k), parameter :: sort_alph=3
  integer(kind=4), parameter :: nsort=3
  character(len=*), parameter :: sort_names(nsort) = &
    (/ 'NONE         ','CHRONOLOGICAL','ALPHABETICAL ' /)
  !
  type import_user_t
     character(len=file_l), allocatable :: argum(:)
     character(len=8)  :: hdu       = strg_star
     logical           :: domapping = .false.
     logical           :: doclass   = .false.
     logical           :: doparse   = .false.
     character(len=1)  :: parse_sep = '-'
     character(len=24) :: sort      = strg_star
     logical           :: doverbose = .false.
  contains
     procedure, private :: toprog => cubeadm_import_user_toprog
  end type import_user_t
  !
  type import_prog_t
    character(len=commandline_length)  :: line      ! Full command line to be inserted in history
    character(len=file_l), allocatable :: argum(:)  ! Arguments to be imported
    integer(kind=4)      :: seve       ! Severity of /VERBOSE messages
    logical              :: allhdus    ! Import all HDUs?
    integer(kind=4)      :: onehdu     ! If not all HDUs, which one?
    logical              :: domapping
    logical              :: doclass
    logical              :: doparse    ! /PARSE enabled?
    character(len=1)     :: parse_sep  ! /PARSE separator if option is enabled
    integer(kind=code_k) :: sort
  contains
    procedure, private :: act       => cubeadm_import_act
    procedure, private :: argument  => cubeadm_import_argument
    procedure, private :: pattern   => cubeadm_import_pattern
    procedure, private :: directory => cubeadm_import_directory
    procedure, private :: file      => cubeadm_import_onefile
    procedure, private :: cube      => cubeadm_import_onecube
  end type import_prog_t
  !
contains
  !
  subroutine cubeadm_import_register(import,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(import_comm_t), intent(inout) :: import
    logical,              intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='IMPORT>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'IMPORT','[Directory|FilePattern]',&
         'Import files into the DAG',&
         'Import GDF/FITS files into the DAG from either explicit file or directory targets. &
         & Without argument, it imports the GDF/FITS files from the default raw directory &
         & defined by the DIRECTORY /RAW command (default is ./raw).'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Each argument is resolved as a file or directory pattern.'//strg_cr//&
         '- Name or extension metadata can be used during import, but header&
         & metadata takes precedence when present.'//strg_cr//&
         '- Unsupported files and already-imported entries are skipped.'//strg_bl//&
         'Additional outputs:'//strg_cr//&
         '- The /VERBOSE key reports the number of imported or skipped files.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- /MAPPING and /CLASS are mutually exclusive.'//strg_cr//&
         '- A single call can import multiple file or directory targets.'//strg_bl//&
         'Examples:'//strg_cr//&
         '  CUBE> IMPORT'//strg_cr//&
         '  CUBE> IMPORT mydir'//strg_cr//&
         '  CUBE> IMPORT mydir/*.fits'//strg_cr//&
         '  CUBE> IMPORT mydir/*.fits /HDU *'//strg_cr//&
         '  CUBE> IMPORT file1.fits file2.fits'//strg_cr//&
         'Using file patterns is also possible when invoking CUBE from the shell, e.g.'//strg_cr//&
         '  shell-prompt> cube import *',&
         cubeadm_import_command,&
         import%comm,error)
    if (error) return
    call stdarg%register( &
         'Target',  &
         'Import targets: a list of directory or file patterns', &
         strg_emp,&
         code_arg_unlimited, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'HDU','Number',&
         'Specify the FITS HDU to be imported',&
         'Use * to import all possible images or cubes. Default is 1 (Primary HDU only).',&
         import%hdu,error)
    if (error) return
    call stdarg%register( &
         'HDU Number',  &
         'FITS HDU number', &
         'Default is 1 (Primary).',&
         code_arg_optional, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'MAPPING','',&
         'Import MAPPING files and set cube flags based on the file extension',&
         'This option is ignored if the file header provides its own flags.',&
         import%mapping,error)
    if (error) return
    !
    call cubetools_register_option(&
         'CLASS','',&
         'Import CLASS files and set cube flags based on the file extension',&
         'This option is ignored if the file header provides its own flags.',&
         import%class,error)
    if (error) return
    !
    call cubetools_register_option(&
         'PARSE','Separator',&
         'Split the file basename into family and flags',&
         'The computed flags are ignored if the file header provides its own '//&
         'flags. Without this option, the whole basename is used as family name.',&
         import%optparse,error)
    if (error) return
    call stdarg%register( &
         'Separator',  &
         'Single character separator in file basename', &
         'Default is "-".',&
         code_arg_optional, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'SORT','Mode',&
         'Specify the sorting order of imported files',&
         'Without this option, sorting is done in chronological order.',&
         import%sort,error)
    if (error) return
    call keyarg%register( &
         'Mode',  &
         'Sorting mode', &
         strg_emp,&
         code_arg_mandatory, &
         sort_names, &
         .not.flexible, &
         import%sort_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'VERBOSE','',&
         'Indicate which files are imported or skipped',&
         strg_emp,&
         import%verbose,error)
    if (error) return
  end subroutine cubeadm_import_register
  !
  subroutine cubeadm_import_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(import_user_t) :: user
    character(len=*), parameter :: rname='IMPORT>COMMAND'
    !
    call cubeadm_message(admseve%trace,rname,'welcome')
    !
    call import%parse(line,user,error)
    if (error) return
    call import%main(user,line,error)
    if (error) return
  end subroutine cubeadm_import_command
  !
  subroutine cubeadm_import_parse(comm,line,user,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Support routine for command:
    !   IMPORT
    !   IMPORT Directory
    !   IMPORT Pattern
    !---------------------------------------------------------------------
    class(import_comm_t), intent(in)    :: comm
    character(len=*),     intent(in)    :: line
    type(import_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: narg,iarg,ier
    logical :: dosort
    character(len=*), parameter :: rname='IMPORT>COMMAND'
    !
    ! Command arguments
    narg = import%comm%getnarg()  ! Can be 0 = no argument
    allocate(user%argum(narg),stat=ier)
    if (failed_allocate(rname,'arguments',ier,error)) return
    do iarg=1,narg
      call cubetools_getarg(line,import%comm,iarg,user%argum(iarg),mandatory,error)
      if (error) return
    enddo
    !
    ! /HDU
    call cubetools_getarg(line,import%hdu,1,user%hdu,.not.mandatory,error)
    if (error)  return
    !
    ! /MAPPING or /CLASS
    call import%mapping%present(line,user%domapping,error)
    if (error) return
    call import%class%present(line,user%doclass,error)
    if (error) return
    if (user%domapping.and.user%doclass) then
       call cubeadm_message(seve%e,rname,'Options /MAPPING and /CLASS conflict with each other')
       error = .true.
       return
    endif
    !
    ! /VERBOSE
    call import%verbose%present(line,user%doverbose,error)
    if (error) return
    !
    ! /PARSE
    call import%optparse%present(line,user%doparse,error)
    if (error) return
    if (user%doparse) then
      call cubetools_getarg(line,import%optparse,1,user%parse_sep,.not.mandatory,error)
      if (error)  return
    endif
    !
    ! /SORT
    call import%sort%present(line,dosort,error)
    if (error) return
    if (dosort) then
      call cubetools_getarg(line,import%sort,1,user%sort,mandatory,error)
      if (error) return
    else
      user%sort = strg_star
    endif
  end subroutine cubeadm_import_parse
  !
  subroutine cubeadm_import_main(import,user,line,error)
    !----------------------------------------------------------------------
    ! Import all arguments passed to the command, create CX, and terminate
    ! command.
    !----------------------------------------------------------------------
    class(import_comm_t), intent(in)    :: import
    type(import_user_t),  intent(in)    :: user
    character(len=*),     intent(in)    :: line
    logical,              intent(inout) :: error
    !
    type(import_prog_t) :: prog
    character(len=*), parameter :: rname='IMPORT>MAIN'
    !
    call user%toprog(line,prog,error)
    if (error)  return
    call prog%act(error)
    if (error)  return
  end subroutine cubeadm_import_main
  !
  subroutine cubeadm_import_act(prog,error)
    use cubedag_find_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    logical,              intent(inout) :: error
    !
    logical :: do_cx
    integer(kind=4) :: iarg
    type(dag_find_t) :: criter
    character(len=*), parameter :: rname='IMPORT>MAIN'
    !
    do_cx = .false.
    !
    do iarg=1,size(prog%argum)
      call prog%argument(prog%argum(iarg),do_cx,error)
      if (error)  return
    enddo
    !
    if (do_cx) then
      ! Implicitly FIND everything in current index
      call criter%ix2cx(error)
      if (error) return
    endif
    !
    ! Insert in history
    call cubeadm_imported_flush_nodes(prog%line,error)
    if (error)  return
  end subroutine cubeadm_import_act
  !
  subroutine cubeadm_import_user_toprog(user,line,prog,error)
    use gkernel_interfaces
    use cubetools_string
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(import_user_t), intent(in)    :: user
    character(len=*),     intent(in)    :: line
    type(import_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: iarg,narg,ier
    character(len=argu_l) :: key
    character(len=*), parameter :: rname='IMPORT>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    prog%line = line
    !
    ! Command arguments
    if (size(user%argum).le.0) then
      ! No argument provided: import from dir%raw
      call cubetools_string_split(dir%raw,';',prog%argum,error)
      if (error)  return
    else
      ! Fetch user arguments
      narg = size(user%argum)
      allocate(prog%argum(narg),stat=ier)
      if (failed_allocate(rname,'arguments',ier,error)) return
      do iarg=1,narg
        prog%argum(iarg) = user%argum(iarg)
      enddo
    endif
    !
    if (user%doverbose) then
      prog%seve = seve%i
    else
      prog%seve = seve%d
    endif
    !
    prog%allhdus = user%hdu.eq.strg_star
    if (prog%allhdus) then
      prog%onehdu = 0  ! Unused
    else
      read(user%hdu,*) prog%onehdu
    endif
    !
    prog%domapping = user%domapping
    prog%doclass   = user%doclass
    prog%doparse   = user%doparse
    prog%parse_sep = user%parse_sep
    !
    if (user%sort.eq.strg_star) then
      prog%sort = sort_chro
    else
      call cubetools_keywordlist_user2prog(import%sort_arg,user%sort,prog%sort,key,error)
      if (error) return
    endif
  end subroutine cubeadm_import_user_toprog
  !
  subroutine cubeadm_import_argument(prog,argum,do_cx,error)
    use gkernel_interfaces
    use cubetools_setup_types
    !----------------------------------------------------------------------
    ! Process 1 argument passed to the command
    !----------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: argum
    logical,              intent(inout) :: do_cx
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: nc
    logical :: skipped
    type(cube_setup_api_t) :: setup
    integer(kind=code_k) :: default_index
    character(len=*), parameter :: rname='IMPORT>ARGUMENT'
    !
    call cubeadm_message(admseve%trace,rname,'welcome')
    !
    nc = len_trim(argum)
    call setup%index%default%get(default_index)
    if (gag_isdir(argum(1:nc)).eq.0) then
       ! A directory
       do_cx = default_index.eq.code_index_current
       call prog%directory(argum,nc,error)
    elseif (gag_inquire(argum,nc).eq.0) then
       ! A file. Note it can contain unfriendly characters (space, parentheses, etc).
       do_cx = default_index.eq.code_index_current
       call prog%file(argum,skipped,error)
    elseif (gag_exists(argum(1:nc))) then
       ! Try a pattern. Unfriendly characters badly supported.
       do_cx = default_index.eq.code_index_current
       call prog%pattern(argum,error)
    else
       ! Resolves as nothing in the shell!
       call cubeadm_message(seve%w,rname,'No such file or directory '''//argum(1:nc)//'''')
    endif
    if (error) return
  end subroutine cubeadm_import_argument
  !
  function gag_exists(pattern)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Return .true. if the pattern resolves as some file(s) or
    ! directory(ies) resolved by the shell.
    !-------------------------------------------------------------------
    logical :: gag_exists
    character(len=*), intent(in) :: pattern
    !
    integer(kind=4) :: nfile
    character(len=file_l), allocatable :: filelist(:)
    logical :: error
    !
    gag_exists = .false.
    !
    ! No better way to invoke a subroutine which translates the
    ! shell-dependant syntax (e.g. *, ?, ... for bash). The pattern
    ! is passed "as is":
    !  - exact directory name            => return the same exact name (not its contents)
    !  - exact file name                 => return the same exact name
    !  - wilcarded directory name        => return the expanded directory name (not its contents)
    !  - wilcarded file      name        => return the expanded file name
    !  - exact but non-existent name     => return empty list
    !  - wilcarded but non-existent name => return empty list
    ! (wilcarded combinations on existing material are possible).
    !
    error = .false.
    call gag_directory('.',pattern,filelist,nfile,error)
    if (error) return
    gag_exists = nfile.gt.0
  end function gag_exists
  !
  subroutine cubeadm_import_directory(prog,dirname,nc,error)
    !---------------------------------------------------------------------
    ! Import *.* files from a directory into the DAG
    !---------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: dirname
    integer(kind=4),      intent(in)    :: nc
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='IMPORT>DIRECTORY'
    !
    if (dirname(nc:nc).eq.'/') then
      call prog%pattern(dirname(1:nc)//'*.*',error)
    else
      call prog%pattern(dirname(1:nc)//'/*.*',error)
    endif
    if (error) return
  end subroutine cubeadm_import_directory
  !
  recursive subroutine cubeadm_import_pattern(prog,pattern,error)
    use gkernel_types
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Import files given a pattern into the DAG
    !---------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: pattern
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: nfile,ifile,nimported,nskipped,nc,myseve
    logical :: skipped
    character(len=file_l), allocatable :: filelist(:)
    character(len=mess_l) :: mess
    type(time_t) :: time
    character(len=*), parameter :: rname='IMPORT>PATTERN'
    !
    ! Get the file names and sorting array
    call gag_directory('.',trim(pattern),filelist,nfile,error)
    if (error) return
    call cubeadm_import_sort(filelist,nfile,prog%sort,error)
    if (error)  return
    !
    call gtime_init(time,nfile,error)
    if (error) return
    !
    ! Import the GDF and FITS files in the DAG
    nimported = 0
    nskipped = 0
    do ifile=1,nfile
      call gtime_current(time)
      nc = len_trim(filelist(ifile))
      if (gag_isdir(filelist(ifile)(1:nc)).eq.0) then
        ! This is a directory. NB: this is not precisely a recursion
        ! as cubeadm_import_directory imports "somedir/*.*"
        call cubeadm_message(prog%seve,rname,'Importing directory '//filelist(ifile)(1:nc))
        call prog%directory(filelist(ifile),nc,error)
        if (error) error = .false.  ! Skip errors indexing file
      else
        ! This is not a directory (regular file...)
        call prog%file(filelist(ifile),skipped,error)
        if (error) error = .false.  ! Skip errors indexing file
        if (skipped) then ! Duplicate or not supported kind
          nskipped = nskipped+1
        else
          nimported = nimported+1
        endif
      endif
    enddo
    deallocate(filelist)
    !
    write(mess,'(I0,A,A)')  nimported,' new file(s) imported from ',trim(pattern)
    if (nimported.le.0) then
      myseve = seve%w
    else
      myseve = seve%i
    endif
    if (nskipped.gt.0)  &
      write(mess,'(A,A,I0,A)')  trim(mess),', skipped ',nskipped,' file(s)'
    call cubeadm_message(myseve,rname,mess)
  end subroutine cubeadm_import_pattern
  !
  subroutine cubeadm_import_sort(filelist,nfile,sortmode,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Sort the file-list in-place according to sorting mode
    !-------------------------------------------------------------------
    integer(kind=4),      intent(in)    :: nfile
    character(len=*),     intent(inout) :: filelist(nfile)
    integer(kind=code_k), intent(in)    :: sortmode
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: ifile,ier,nc
    integer(kind=4), allocatable :: sort(:)
    character(len=file_l), allocatable :: tmp(:)
    integer(kind=8), allocatable :: mtime(:)
    character(len=*), parameter :: rname='IMPORT>GETSORT'
    !
    nc = len(filelist(1))
    !
    select case (sortmode)
    case (sort_none)
      return
      !
    case (sort_chro)
      ! Get the file dates
      allocate(mtime(nfile))
      do ifile=1,nfile
        ier = gag_mtime(filelist(ifile),mtime(ifile))
        if (ier.ne.0) then
          call cubeadm_message(seve%w,rname,'Error evaluating date of file '//filelist(ifile))
          mtime(ifile) = 0
        endif
      enddo
      ! Compute sorting array
      allocate(sort(nfile))
      call gi8_trie(mtime,sort,nfile,error)
      if (error)  return
      deallocate(mtime)
      ! Sort the character array
      allocate(tmp(nfile))
      call gch_sort(filelist,tmp,sort,nc,nfile)
      deallocate(sort,tmp)
      !
    case (sort_alph)
      allocate(sort(nfile))
      call gch_trie(filelist,sort,nfile,nc,error)
      if (error)  return
      deallocate(sort)
    end select
  end subroutine cubeadm_import_sort
  !
  subroutine cubeadm_import_onefile(prog,filename,skipped,error)
    use gkernel_interfaces
    use cubefitsio_header
    !-------------------------------------------------------------------
    ! Try to import the named file
    !-------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: filename
    logical,              intent(out)   :: skipped
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: nc,filekind,ihdu,fhdu,lhdu
    logical :: done
    character(len=*), parameter :: rname='IMPORT>ONEFILE'
    !
    nc = len_trim(filename)
    !
    call gag_file_guess(rname,filename,filekind,error)
    if (error) error = .false.  ! Skip errors indexing file
    !
    if (filekind.ne.1 .and. filekind.ne.2) then
      call cubeadm_message(prog%seve,rname,  &
        'Skipping non-GDF/non-FITS file '//filename(1:nc))
      skipped = .true.
      return
    endif
    !
    ! Which HDU range?
    if (prog%allhdus) then
      select case (filekind)
      case (1)  ! GDF
        fhdu = 1
        lhdu = 1
      case (2)  ! FITS
        fhdu = 1
        call cubefitsio_file_nhdu(filename,lhdu,error)
        if (error) then
          error = .false.
          skipped = .true.
          return
        endif
      end select
    else
      fhdu = prog%onehdu
      lhdu = prog%onehdu
    endif
    !
    ! Loop on HDUs
    done = .false.
    do ihdu=fhdu,lhdu
      call prog%cube(filename(1:nc),ihdu,skipped,error)
      if (error) then
        error = .false.
        cycle
      endif
      if (.not.skipped)  done = .true.
    enddo
    if (done) then  ! At least 1 HDU imported
      skipped = .false.
      call cubeadm_imported_flush_twins(error)
      if (error)  return
    endif
  end subroutine cubeadm_import_onefile
  !
  subroutine cubeadm_import_onecube(prog,filename,ihdu,skipped,error)
    use cube_types
    use cubetools_flag_types
    use cubedag_allflags
    use cubedag_tuple
    use cubeio_file
    use cubetuple_format_class
    use cubeformats_uv
    use cubeformats_engine_types
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: filename
    integer(kind=4),      intent(in)    :: ihdu
    logical,              intent(out)   :: skipped
    logical,              intent(inout) :: error
    !
    character(len=base_l) :: family,cubeid
    character(len=file_l) :: fullname
    type(flag_t), allocatable :: flags(:)
    integer(kind=code_k) :: code_ftype
    type(cubeio_file_t), pointer :: file
    type(cube_t), pointer :: cube
    class(format_t), pointer :: fo
    class(cubedag_node_object_t), pointer :: dno
    character(len=*), parameter :: rname='IMPORT>ONECUBE'
    !
    write(fullname,'(2a,i0,a)')  trim(filename),'[',ihdu,']'
    skipped = .true.
    !
    if (cubedag_dag_contains(filename,ihdu)) then
      call cubeadm_message(prog%seve,rname,'Skipping cube already in DAG '//fullname)
      return
    endif
    !
    ! A word on flags associated to the imported cube. They can have
    ! several origins:
    ! 1a - Reading the file header (CUBE writes FITS with dedicated
    !      keywords for flags). It has precedence if available.
    ! 1b - Still in case of FITS, if the dedicated keywords are not
    !      found, the flags based on the HDU kind and name are used.
    ! 2a - Parsing the file base name (IMPORT /PARSE) for symetry with
    !      EXPORT,
    ! 2b - Parsing the file extention (IMPORT /MAPPING|/CLASS);
    !      2a can be combined with 2b,
    ! 4 -  Some default flag as fallback.
    !
    call cubeadm_import_default_familyflags(prog,filename,family,flags,cubeid,error)
    if (error)  return
    !
    file => file_allocate_new(error)
    if (error) return
    call file%read_header(filename,ihdu,cubeid,error)
    if (error) then
      call file%free(error)
      deallocate(file)
      return
    endif
    !
    cube => null()
    if (file%is_cube()) then
      code_ftype = code_ftype_cube
      cube => cubeformats_cube_allocate(cubset,error)
      if (error) return
      fo => cube
    elseif (file%is_uvt()) then
      code_ftype = code_ftype_uv
      fo => cubeformats_uv_allocate(cubset,error)
      if (error) return
    else
      ! Clean before skipping
      call cubeadm_message(prog%seve,rname,'Skipping non-cube/non-UVT file '//fullname)
      call file%close(error)
      call file%free(error)
      deallocate(file)
      return
    endif
    call fo%attach_file(file,error)
    if (error) return
    call fo%default_iorder(error)
    if (error)  return
    !
    ! Fix the header, if relevant
    if (associated(cube)) then
      call cube%default_order(error)
      if (error)  return
    endif
    !
    ! Attach a new cube to the DAG and set its attributes
    dno => fo
    call cubedag_dag_newbranch(dno,code_ftype,error)
    if (error) return
    call dno%set_value('ORIGIN',code_origin_imported,error)
    if (error) return
    call cubeadm_import_actual_family(prog,family,fo,error)
    if (error) return
    call cubeadm_import_actual_flags(prog,flags,fo,error)
    if (error) return
    !
    call cubeadm_imported_add_node(dno)  ! Fill list of all cubes imported
    call cubeadm_imported_add_twin(dno)  ! Fill list of current twins imported
    !
    ! Cleaning
    !
    ! GIO slots: we could wait to go through the cubeadm_finish_all at the end
    ! of the command execution, but IMPORT can open hundreds of cubes, and
    ! GIO slots are more limited than this. We have to avoid accumulating
    ! them.
    ! This also includes insertion in DAG
    call fo%finish(error)
    if (error) return
    !
    ! Feedback (after insertion in DAG)
    call fo%node%tuple%location(fo%iorder(),code_buffer_disk,fullname)
    call cubeadm_message(prog%seve,rname,'Importing file '//fullname)
    skipped = .false.
  end subroutine cubeadm_import_onecube
  !
  subroutine cubeadm_import_default_familyflags(prog,filename,  &
    family,flags,cubeid,error)
    use gkernel_interfaces
    use cubetools_flag_types
    use cubedag_allflags
    use cubetools_cubeid_types
    !-------------------------------------------------------------------
    ! Create the default family, flags, and cubeid based on file name
    ! and parsing option.
    ! Note that this might not be the final family and flags attached to
    ! the cube, since the file header might provide its own ones.
    !-------------------------------------------------------------------
    type(import_prog_t), intent(in)    :: prog
    character(len=*),    intent(in)    :: filename
    character(len=*),    intent(out)   :: family
    type(flag_t),        allocatable   :: flags(:)
    character(len=*),    intent(out)   :: cubeid
    logical,             intent(inout) :: error
    !
    character(len=base_l) :: filebase
    character(len=exte_l) :: fileext
    type(flag_t), allocatable :: baseflags(:),extflags(:)
    type(flag_t) :: noflag(0)
    integer(kind=4) :: pos
    !
    call sic_parse_name(filename,filebase,fileext)
    !
    ! Flags from the basename
    if (prog%doparse) then
      pos = index(filebase,prog%parse_sep)
      if (pos.gt.0) then
        call cubetools_string_toflaglist(filebase(pos+1:),.true.,baseflags, &
             error,sep=prog%parse_sep)
        if (error)  return
        filebase(pos:) = ''  ! Drop the parsed flags
      else
        ! filebase unchanged
        ! baseflags remains unallocated
      endif
    endif
    family = filebase
    !
    ! Flags from the extension
    if (prog%domapping) then
       call cubetools_mapping_ext2flag(fileext,extflags,error)
       if (error) return
    else if (prog%doclass) then
       call cubetools_class_ext2flag(fileext,extflags,error)
       if (error) return
    else
       ! No special flags
    endif
    !
    ! Merge baseflags+extflags
    if (.not.allocated(baseflags))  call cubeadm_import_reallocate_flags(baseflags,noflag,error)
    if (.not.allocated(extflags))   call cubeadm_import_reallocate_flags(extflags,noflag,error)
    if (size(baseflags)+size(extflags).gt.0) then
      call cubeadm_import_reallocate_flags(flags,[baseflags,extflags],error)
      if (error)  return
    else
      ! Allocate empty list of flags. It will be improved after the file
      ! header is actually read.
      call cubeadm_import_reallocate_flags(flags,noflag,error)
      if (error)  return
    endif
    !
    ! Create a cubeid (for feedback) from these default family and flags
    if (size(flags).gt.0) then
      call cubetools_cubeid_familyflags2string(family,flags,cubeid,error)
      if (error) return
    else
      ! Put a 'cube' flag as poor-man solution. Avoid 'unknown' which can be
      ! misleading.
      call cubetools_cubeid_familyflags2string(family,[flag_cube],cubeid,error)
      if (error) return
    endif
  end subroutine cubeadm_import_default_familyflags
  !
  subroutine cubeadm_import_actual_family(prog,deffamily,fo,error)
    use cubetuple_format_class
    !-------------------------------------------------------------------
    ! Set the node family name, if not yet done at read header time
    !-------------------------------------------------------------------
    type(import_prog_t), intent(in)    :: prog
    character(len=*),    intent(in)    :: deffamily  ! Default family to be applied
    class(format_t),     intent(inout) :: fo
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='IMPORT>ACTUAL>FAMILY'
    !
    if (fo%node%family.ne.'') then
      ! The family name was read from the header: it has precedence
      if (prog%doparse)  &
        call cubeadm_message(seve%w,rname,'Family read from header; /PARSE ignored')
    else
      ! No family yet: apply the precomputed default
      call fo%set_value('FAMILY',deffamily,error)
      if (error) return
    endif
  end subroutine cubeadm_import_actual_family
  !
  subroutine cubeadm_import_actual_flags(prog,defflags,fo,error)
    use cubetools_flag_types
    use cubedag_allflags
    use cubetuple_format_class
    !-------------------------------------------------------------------
    ! Set the node flags, if not yet done at read header time
    !-------------------------------------------------------------------
    type(import_prog_t), intent(in)    :: prog
    type(flag_t),        intent(in)    :: defflags(:)  ! Default flags to be applied
    class(format_t),     intent(inout) :: fo
    logical,             intent(inout) :: error
    !
    type(flag_t), allocatable :: flags(:)
    character(len=*), parameter :: rname='IMPORT>ACTUAL>FLAGS'
    !
    if (fo%node%flag%n.gt.0) then
      ! Some flags were read from the header: they have precedence
      if (prog%doparse) &
        call cubeadm_message(seve%w,rname,'Flags read from header; /PARSE ignored')
      if (prog%domapping) &
        call cubeadm_message(seve%w,rname,'Flags read from header; /MAPPING ignored')
      if (prog%doclass) &
        call cubeadm_message(seve%w,rname,'Flags read from header; /CLASS ignored')
    else
      ! No flags yet
      if (size(defflags).gt.0) then
        ! Default flags available
        call cubeadm_import_reallocate_flags(flags,defflags,error)
        if (error)  return
      else
        ! No pre-computed default. Use fallback flags
        if (fo%tuple%current%file%is_cube()) then
          call cubeadm_import_reallocate_flags(flags,[flag_cube],error)
          if (error)  return
        elseif (fo%tuple%current%file%is_uvt()) then
          call cubeadm_import_reallocate_flags(flags,[flag_uv,flag_table],error)
          if (error)  return
        endif
      endif
      ! Apply them
      call fo%set_flags(flags,error)
      if (error) return
    endif
  end subroutine cubeadm_import_actual_flags
  !
  subroutine cubeadm_import_reallocate_flags(list,flags,error)
    use gkernel_interfaces
    use cubetools_flag_types
    !-------------------------------------------------------------------
    ! Ad-hoc subroutine which reallocates and stores a list of flags
    !-------------------------------------------------------------------
    type(flag_t), allocatable   :: list(:)
    type(flag_t), intent(in)    :: flags(:)
    logical,      intent(inout) :: error
    !
    integer(kind=4) :: nflags,ier
    character(len=*), parameter :: rname='IMPORT>REALLOCATE>FLAGS'
    !
    if (allocated(list))  deallocate(list)
    nflags = size(flags)
    allocate(list(nflags),stat=ier)  ! Size can be 0 on purpose
    if (failed_allocate(rname,'flags',ier,error)) return
    if (nflags.gt.0)  list(:) = flags(:)
  end subroutine cubeadm_import_reallocate_flags
  !
  subroutine cubeadm_imported_add_node(dno)
    class(cubedag_node_object_t), pointer :: dno
    logical :: error
    error = .false.
    call cubeadm_imported_add(im,dno,error)
    if (error)  return
  end subroutine cubeadm_imported_add_node
  !
  subroutine cubeadm_imported_add_twin(dno)
    class(cubedag_node_object_t), pointer :: dno
    logical :: error
    error = .false.
    call cubeadm_imported_add(tw,dno,error)
    if (error)  return
  end subroutine cubeadm_imported_add_twin
  !
  subroutine cubeadm_imported_add(list,dno,error)
    type(cubedag_link_t),         intent(inout) :: list
    class(cubedag_node_object_t), pointer       :: dno
    logical,                      intent(inout) :: error
    call list%associate(dno,error)
    if (error)  return
  end subroutine cubeadm_imported_add
  !
  subroutine cubeadm_imported_flush_nodes(line,error)
    use cubedag_history_buffer
    use cubedag_links_tool
    !-------------------------------------------------------------------
    ! Insert all imported nodes in history and reset the list
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(cubedag_link_t) :: void
    integer(kind=entr_k) :: hid
    !
    call cubedag_history_add_tohx('IMPORT',line,void,im,hid,error)
    if (error)  return
    call nodeln%set_history(im,hid,error)
    if (error)  return
    call im%final(error)
    if (error)  return
  end subroutine cubeadm_imported_flush_nodes
  !
  subroutine cubeadm_imported_flush_twins(error)
    use cubedag_links_tool
    !-------------------------------------------------------------------
    ! Link all current twins and reset the list
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call nodeln%set_twins_to_children(tw,error)
    if (error)  return
    call tw%final(error)
    if (error)  return
  end subroutine cubeadm_imported_flush_twins
  !
end module cubeadm_import
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_clean
  use gbl_message
  !
  public :: clean_comm
  private
  !
contains
  !
  subroutine clean_comm(line,error)
    use gkernel_interfaces
    use clean_buffers, only: ares_listsize,niter_listsize
    use clean_clark
    use clean_hogbom
    use clean_mrc
    use clean_multi
    use clean_sdi
    !----------------------------------------------------------------------
    ! Call appropriate subroutine according to METHOD%METHOD
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    character(len=12) :: cmethod
    integer :: nm
    !
    call sic_get_char('METHOD',cmethod,nm,error)
    if (nm.eq.0) then
       error = .true.
    else
       call sic_upper(cmethod)
    endif
    if (error) return
    !
    select case (cmethod)
    case ('CLARK')
       call clark_comm(line,error)
    case ('HOGBOM')
       call hogbom_comm(line,error)
    case ('MRC')
       call mrc_comm(line,error)
    case ('MULTI')
       call multi_comm(line,error)
    case ('SDI')
       call sdi_comm(line,error)
    case default
       call map_message(seve%e,'CLEAN','Unsupported method '//cmethod)
       error = .true.
       return
    end select
    ! 
    ! Reset the per-plane stopping criterium
    ares_listsize = 0
    niter_listsize = 0
  end subroutine clean_comm
end module clean_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_language
  use cubetools_parameters
  use cubetools_structure
  use cubecompute_messaging
  !
  use cubecompute_average
  use cubecompute_difference
  use cubecompute_product
  use cubecompute_ratio
  use cubecompute_sum
  !
!  use cubecompute_correlation
  use cubecompute_convolution
  !
  use cubecompute_amplitude
  use cubecompute_complex
  use cubecompute_conjugate
  use cubecompute_fft
  use cubecompute_phase
  !
  use cubecompute_cumulant
  use cubecompute_derivative
  use cubecompute_weight
  !
  public :: cubecompute_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubecompute_register_language(error)
    !----------------------------------------------------------------------
    ! Register the COMPUTE\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'COMPUTE',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Basic mathematical operations on a cube',&
         'COMPUTE provides mathematical transforms commonly used before&
         & physical interpretation of radio-astronomy cubes.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Pairwise operators combine aligned cubes (for example sum,&
         & ratio, or weighted products).'//strg_cr//&
         '- FFT-related operators move between image and Fourier domains&
         & to inspect amplitude and phase structure.'//strg_cr//&
         '- Convolution, derivative, and cumulant operators highlight&
         & spectral-shape changes.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> COMPUTE\SUM [cubeid1] [cubeid2]'//strg_cr//&
         'CUBE> COMPUTE\FFT [cubeid]'//strg_cr//&
         'CUBE> COMPUTE\AMPLITUDE [cubeid]'//strg_bl//&
         'Note:'//strg_cr//&
         'Inspect intermediate products between steps before deriving&
         & final science diagnostics.',&
         'gag_doc:hlp/cube-help-ima.hlp',&
         cubecompute_execute_command,&
         langid,&
         error)
    if (error) return
    !
    call cubecompute_sum_register(error)
    if (error) return
    call cubecompute_difference_register(error)
    if (error) return
    call cubecompute_product_register(error)
    if (error) return
    call cubecompute_ratio_register(error)
    if (error) return
    call cubecompute_average_register(error)
    if (error) return
    !
    call convolution%register(error)
    if (error) return
    !
    call fft%register(error)
    if (error) return
    call cubecompute_amplitude_register(error)
    if (error) return
    call cubecompute_phase_register(error)
    if (error) return
    call cubecompute_complex_register(error)
    if (error) return
    call cubecompute_conjugate_register(error)
    if (error) return
    !
    call cumulant%register(error)
    if (error) return
    call cubecompute_derivative_register(error)
    if (error) return
    call cubecompute_weight_register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubecompute_register_language
  !
  subroutine cubecompute_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the COMPUTE\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'COMPUTE?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to finalize_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubecompute_execute_command
end module cubecompute_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
!----------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoSource">
!   <VERSION>
!     Id: modulePakoSource.f90,v 1.2.4 2015-07-16 Hans Ungerechts
!     Id: modulePakoSource.f90,v 1.2.4 2015-06-18 Hans Ungerechts
!     Id: modulePakoSource.f90,v 1.2.3 2014-09-01 Hans Ungerechts
!     Id: modulePakoSource.f90,v 1.2.3 2014-02-13 Hans Ungerechts
!                                1.2.1 2012-08-23 Hans Ungerechts
!     based on:
!     Id: modulePakoSource.f90,v 1.1.3 2010-11-16 Hans Ungerechts
!     originally based on SOURCE in PdB OBS
!   </VERSION>
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Source
!   </FAMILY>
!   <SIBLINGS>
!                Source
!   </SIBLINGS>        
!
!   Pako module for command: SOURCE
!
! </DOCUMENTATION> <!-- name="modulePakoSource" -->
!
!----------------------------------------------------------------------
!
!
Module modulePakoSource
  !
  Use modulePakoMessages
  Use modulePakoTypes
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoDisplayText
  Use modulePakoUtilities
  Use modulePakoGlobalVariables
!!  Use modulePakoSubscanList
  Use modulePakoReceiver
  !
  Use gbl_message
  Use gkernel_interfaces
  !
  Implicit None
  Save
  Private
  Public :: source,  displaySource, saveSource, storeSource, getSource
  Public :: writeXMLsource, writeXMLoffsets, writeXMLtopology
  Public :: writeXMLfocusCorrections, writeXMLpointingCorrections
  Public :: offsets, displayOffsets, saveOffsets, queryOffsets
  !     
  ! *** Variables for Commands ***
  Include 'inc/variables/variablesSource.inc'
!!!   
!!!   
Contains
!!!
!!!
  Subroutine source(programName,line,command, ERROR)
    !
    !	searches the source catalog for source 'name'
    !	parses the line found for coords and velocities
    !	converts coordinates to internal format
    !
    ! *** Arguments: ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=lenCO)   :: cInputUpper2
    Character(len=lenVar)  :: cFileCount, cFileGrep
    Character(len=lenLine) :: shellCommand
    Logical                :: errorSourceNotInCatalog
    Logical                :: longitudeInCommandLine, latitudeInCommandLine
    Integer                :: iEr, System
    !
    Integer                :: iUnitR
    !
    Character(len=lenCh)   :: howTo
    !
    Logical                :: longitudeFromVariable, latitudeFromVariable
    Character(len=lenCh)   :: longitudeValue,        latitudeValue
    !
    Logical                :: isConnectedBolo
    Logical                :: isConnectedHERA1, isConnectedHERA2
    Logical                :: isConnectedHERA  
    !
    iUnitR  =  ioUnit%Read
    !
    Call initializeSystemNameChoices   !!! TBD: delete / obsolete
    !
    !     TBD: the following shall be replaced by a SR reading from XML:
    Include 'inc/ranges/rangesSource.inc'
    !
    errorSourceNotInCatalog = .False.
    !
    !
    Call pako_message(seve%t,programName,                                        &
         &    " module source, 1.2.4 2015-06-18 ---> SR: Source ")               ! trace execution
    !
    !D      Write (6,*) " modulePako Source ---> SR: Source "
    !D      Write (6,*) "                      "
    !D      Write (6,*) "        programName:    ->", programName,"<-"
    !D!
    !D      Write (6,*) "        command:      ", command
    !D      Write (6,*) "        modeSelected: ", modeSelected
    !D      Write (6,*) "        error:        ", error
    !D      Write (6,*) "        isInitialized:   ", isInitialized
    !D      Write (6,*) "                      "
    !
    ! *** initialize:   ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       varsOffsets(iIn,:)    = varsOffsets(iDefault,:)
       varsOffsets(iTemp,:)  = varsOffsets(iDefault,:)
       varsOffsets(iValue,:) = varsOffsets(iDefault,:)
       isInitialized = .True.
       GV%sourceSet  = .True.
       messageText = " default source "//vars(iValue)%sourceName//" selected"
       l = Len_trim (messageText)
       Call  pakoMessage(priorityW,severityW,command,messageText(1:l))
    Endif
    !
    option = 'DEFAULTS'
    Call indexCommmandOption                                                     &
         &        (command,option,commandFull,optionFull,                        &
         &        commandIndex,optionIndex,iCommand,iOption,                     &
         &        errorNotFound,errorNotUnique)                                  !
    setDefaults = SIC_PRESENT(iOption,0)
    !
    ! *** set In-values = previous Values   ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    ! *** read Parameters, Options (to detect errors)         ***
    ! *** and check for validity and ranges                   ***
    Call checkNofParameters(command,                                             &
         &     0, 12,                                                            &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       If (.Not. setDefaults) Then
          Include 'inc/options/optionCatalog.inc'
          Include 'inc/parameters/parametersSource.inc'      
          !D           l = len_trim(vars(iIn)%sourceCatalog)
          !D           Write (6,*) " vars(iIn)%sourceCatalog(1:l) -->",                       &
          !D                &        vars(iIn)%sourceCatalog(1:l), "<--"                      !
       End If
       !
       Include 'inc/options/readOptionsSource.inc'
    End If
    !
    ! *** set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          Include 'inc/variables/setDefaults.inc'
          GV%sourceSet  = .True.
          messageText = " default source "//vars(iValue)%sourceName//" selected"
          l = Len_trim (messageText)
          Call  pakoMessage(priorityW,severityW,command,messageText(1:l))
          !TBD reset offsets with SOURCE command? NO!
       Endif
    Endif
    !
    ! *** read Parameters, Options (again, after defaults!)   ***
    ! *** and check for validity and ranges                   ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       If (.Not. setDefaults) Then
          Include 'inc/options/optionCatalog.inc'
          Include 'inc/parameters/parametersSource.inc'      
       End If
       !
       Include 'inc/options/readOptionsSource.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.ERROR) Then
       !
       Include 'inc/parameters/checkConsistentSource.inc'
       !
       If (.Not. errorInconsistent) Then
          vars(iTemp) = vars(iIn)
       End If
       !
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from Temp into persistent variables   ***
    If (.Not.ERROR) Then
       vars(iValue)          = vars(iTemp)
       GV%sourceProjectID    = vars(iValue)%projectID
       GV%sourceSet          = .True.
    End If
    !D     l = len_trim(vars(iValue)%sourceCatalog)
    !D     Write (6,*) " vars(iValue)%sourceCatalog(1:l) -->",                          &
    !D          &        vars(iValue)%sourceCatalog(1:l), "<--"                         !
    !
    ! *** display values  ***
    !     (Note: this is done independantly of the Error status)
    Call displaySource
    !D    Write (6,*) "      GV%sourceProjectID: ",  GV%sourceProjectID
    !
    ! ***  ***
    If (.Not.error) Then
       If (vars(iValue)%isPlanet) Then
          messageText = "Planet selected:"//' '//vars(iValue)%sourceName
       Else If (vars(iValue)%isSatellite) Then
          messageText = "Satellite selected:"//' '//vars(iValue)%sourceName
       Else If (vars(iValue)%isBody) Then
          messageText = "Solar System Body selected:"//                          &
               &        ' '//vars(iValue)%sourceName                             !
       Else
          !
          If (vars(iValue)%systemName.Eq.sys%equatorial.Or.                      &
               &    vars(iValue)%systemName.Eq.sys%ecliptic) Then                !
             !
             Write (valueText,'(f6.1)') vars(iValue)%epoch
             larg = Len_trim(valueText)
             Write (messageText,*) "selected: ", vars(iValue)%sourceName,        &
                  &            " ",vars(iValue)%systemName(1:2),                 &
                  &            " ",vars(iValue)%equinoxSystemName(1:1)//         &
                  &                valueText(1:larg),                            &
                  &            " ",vars(iValue)%longitude%text,                  &
                  &            " ",vars(iValue)%latitude%text,                   &
                  &            " "                                               !
          Else
             Write (messageText,*) "selected: ", vars(iValue)%sourceName,        &
                  &            " ",vars(iValue)%systemName(1:2),                 &
                  &            " ",vars(iValue)%longitude%text,                  &
                  &            " ",vars(iValue)%latitude%text,                   &
                  &            " "                                               !
          End If
          !
       End If
       !
       l = Len_trim (messageText)
       If (        GV%matchSource .Eq. setMatchSource%Start                      &
            & .Or. GV%matchSource .Eq. setMatchSource%Match ) Then               !
          Call  pakoMessage(        7,severityI,command,messageText(1:l))
       Else
          Call  pakoMessage(priorityI,severityI,command,messageText(1:l))
       End If
       !
       Do ii = nDimOffsetChoices, 1, -1
          If (varsOffsets(iValue,ii)%isSet) Then
             !
             messageText = "   please review OFFSETS (not cleared by SOURCE!)"
             l = Len_trim (messageText)
             Call  pakoMessage(priorityW,severityW,command,messageText(1:l))
             messageText = "   consider: OFFSETS or OFFSET /CLEAR "
             l = Len_trim (messageText)
             Call  pakoMessage(priorityI,severityI,command,messageText(1:l))
             !
          End If
       End Do
       sourceCommand = line(1:lenc(line))
    End If
    !
    If (catalogOpen) Close(UNIT=10)
    !
    Return
  End Subroutine source
!!!
!!!
  Subroutine displaySource
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Include 'inc/display/commandDisplaySource.inc'
    !
  End Subroutine displaySource
!!!
!!!
  Subroutine  storeSource(OM,iOm)
    !
    Character(len=lenCh), Intent(IN)   ::  OM 
    Integer,              Intent(IN)   ::  iOm
    !
    !D    Write (6,*) "      --> storeSource: "
    !D    Write (6,*) "          OM, iOm:   ", OM, iOm
    !
    OMsource(iOm) = vars(iValue) 
    ! 
    !D    Write (6,*) "          OMsource(iOm) = ",  OMsource(iOm)
    !
  End Subroutine storeSource
!!!
!!!
  Subroutine  getSource(OM,iOm)
    !
    Character(len=lenCh), Intent(IN)   ::  OM 
    Integer,              Intent(IN)   ::  iOm
    !
    ! *** standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    vars(iValue) = OMsource(iOm)  
    ! 
    Write (messageText,*) " got last source ",OMsource(iOm)%sourceName
    l = Len_trim (OM)
    Call  pakoMessage(priorityW,severityW,OM(1:l)//" /lastSource",messageText)
    !
    Call displaySource
    !
  End Subroutine getSource
!!!
!!!
  Subroutine offsets(programName,line,command, ERROR)
    !
    ! *** Arguments: ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer                ::  nPDB, nEH, nTH
    Logical                ::  inconsistentReceiverOffsets
    !
    Call initializeSystemNameChoices   !!  TBD: delete /obsolete
    !
    !     TBD: the following shall be replaced by a SR reading from XML:
    Include 'inc/ranges/rangesSource.inc'
    !
    Call pako_message(seve%t,programName,                                        &
         &    " module source,  --> SR: Offsets ")                               ! trace execution
    !
    !D    Write (6,*) " modulePako Source ---> SR: Offsets "
    !D    Write (6,*) "                      "
    !D    Write (6,*) "      iiSystemOffset:    ", iiSystemOffset
    !D    Write (6,*) "      ccSystemOffset:    ", ccSystemOffset
    !
    ! *** initialize:   ***
    If (.Not.isInitialized) Then
       varsOffsets(iIn,:)    = varsOffsets(iDefault,:)
       varsOffsets(iTemp,:)  = varsOffsets(iDefault,:)
       varsOffsets(iValue,:) = varsOffsets(iDefault,:)
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values   ***
    If (.Not.ERROR) Then
       varsOffsets(iIn,:) = varsOffsets(iValue,:)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    ! *** read Parameters, Options (to detect errors)         ***
    ! *** and check for validity and ranges                   ***
    Call checkNofParameters(command,                                             &
         &     0, 2,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    If (.Not. ERROR) Then
       !TBD check case depending on /SYSTEM
       Include 'inc/options/optionSystemOffsets.inc'
       Include 'inc/options/optionClearOffsets.inc'
       Include 'inc/parameters/parametersOffsets.inc'      
       !! Include 'inc/options/readOptionsOffsets.inc'
    End If
    !
    ! *** set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          varsOffsets(iIn,:)    = varsOffsets(iDefault,:)
          varsOffsets(iTemp,:)  = varsOffsets(iDefault,:)
          varsOffsets(iValue,:) = varsOffsets(iDefault,:)
       Endif
    Endif
    !
    ! *** read Parameters, Options (again, after defaults!)   ***
    ! *** and check for validity and ranges                   ***
    If (.Not. ERROR) Then
       !TBD check case depending on /SYSTEM
       Include 'inc/options/optionSystemOffsets.inc'
       Include 'inc/options/optionClearOffsets.inc'
       Include 'inc/parameters/parametersOffsets.inc'      
       !! Include 'inc/options/readOptionsOffsets.inc'
    End If
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    !D    Write (6,*) "        GV%observingMode ", GV%observingMode
    If (.Not.ERROR) Then
       !
       Include 'inc/options/checkConsistentOffsets.inc'
       !
       l = Len_trim(command)
       !
       doWarnOffsets = .False.
       doWarnOM      = .False.
       If (GV%observingMode .Eq. OM%onOff) Then
          Do ii = 1, nDimOffsetChoices, 1
             If (varsOffsets(iIn,ii)%isSet) Then
                !
                If (varsOffsets(iIn,ii)%systemName .Eq. GV%omSystemName) Then
                   doWarnOffsets = .True.
                   !D                   Write (6,*) "      GV%omSystemName:   ", GV%omSystemName
                   Write (messageText,*)                                         &
                        &    " NOTE: the offsets set with OFFSETS /system "      &
                        &    //varsOffsets(iIn,ii)%SystemName//                  &
                        &    " will be ignored!"                                 !
                   Call PakoMessage(priorityW,severityW,                         &
                        &    command(1:l)//" /SYSTEM",                           &
                        &    messageText)                                        !
                   Write (messageText,*)                                         &
                        &    " -- i.e., they are not added to those of the "     &
                        &    //"observing mode "                                 &
                        &    //GV%observingMode                                  !
                   Call PakoMessage(priorityW,severityW,                         &
                        &    command(1:l)//" /SYSTEM",                           &
                        &    messageText)                                        !
                End If
                !
             End If
          End Do
          !
          ! **  observing mode must be specified after OFFSETS:
          !
          If (GV%observingMode .Eq. OM%OnOff) Then
             doWarnOM                      = .True.
             GV%notReadyOffsetsAfterOnOff  = .True.
             GV%notReadyOnOff              = .True.
             messageText = "Please re-execute ONOFF"//                           &
                  &        " after OFFSETS"                                      !
             Call PakoMessage(priorityW,severityW,command,messageText)
             messageText = "Recommended Usage: ONOFF"
             Call PakoMessage(priorityI,severityI,command,messageText)
          End If
       End If
       !
       If (.Not. errorInconsistent) Then
          varsOffsets(iTemp,:) = varsOffsets(iIn,:)
       End If
       !
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from Temp into persistent variables   ***
    If (.Not.ERROR) Then
       varsOffsets(iValue,:) = varsOffsets(iTemp,:)
    !!   GV%sourceOffsets      = varsOffsets(iTemp,:)
    End If
    !
    !! ! OBSOLETE:
    !! ! *** check consistency with receiver offsets
    !
    !! Call checkBolometerArray (inconsistentReceiverOffsets,  errorCode)
    !D     Write (6,*) "  inconsistentReceiverOffsets: ", inconsistentReceiverOffsets
    !D     Write (6,*) "  errorCode: ", errorCode(1:len_trim(errorCode))
    !
    If (inconsistentReceiverOffsets) Then
       GV%notReadyReceiverOffsets = .True.
       messageText = "OFFSETS /SYSTEM Nasmyth and "//                            &
            &    "RX Array offsets are inconsistent"                             !
       Call PakoMessage(priorityW,severityW,command,messageText)
       Call PakoMessage(priorityI,severityI,command,errorCode)
    Else
       GV%notReadyReceiverOffsets = .False.
    End If
    !
    ! *** display values  ***
    !     (Note: this is done independently of the Error status)
    Call displayOffsets
    !
    Do ii = 1, nDimOffsetChoices, 1
       If (varsOffsets(iValue,ii)%isSet) Then
          !
          If ( ii.Eq.iNas) Then
             !
             Write (messageText,*)                                               &
                  &              varsOffsets(iValue,ii)%point%x/GV%anglefactorR, &
                  &              varsOffsets(iValue,ii)%point%y/GV%anglefactorR, &
                  & " /SYSTEM ", varsOffsets(iValue,ii)%systemName               !
             Write (messageText,*)                                               &
                  & " /SYSTEM ", varsOffsets(iValue,ii)%systemName,              &
                  & " are explicitly set: they OVERRULE any automatic values"    ! 
             Call  pakoMessage(666,severityW,command,messageText)
             !
          Else
             Write (messageText,*)                                               &
                  &              varsOffsets(iValue,ii)%point%x/GV%anglefactorR, &
                  &              varsOffsets(iValue,ii)%point%y/GV%anglefactorR, &
                  & " /SYSTEM ", varsOffsets(iValue,ii)%systemName               !
          End If
          Call  pakoMessage(priorityI,severityI,command,messageText)
          !
       End If
    End Do
    !
    !D    Do ii = 1, nDimOffsetChoices, 1
    !D       If (GV%sourceOffsets(ii)%isSet) Then
    !D          !
    !D          If (GV%sourceOffsets(ii)%systemName .Eq.                                     &
    !D               &  offsetSystemChoices(iNASMYTH)) Then
    !D             Write (messageText,*)                                                     &
    !D                  &                GV%sourceOffsets(ii)%point%x/GV%anglefactorR,       &
    !D                  &                GV%sourceOffsets(ii)%point%y/GV%anglefactorR,       &
    !D                  & " /SYSTEM ",    GV%sourceOffsets(ii)%systemName
    !D             !TBD                    & "/CHANNEL ",   GV%sourceOffsets(ii)%channel,    &
    !D             !TBD                    & "/ELEVATION ", GV%sourceOffsets(ii)%elevation
    !D          Else
    !D             Write (messageText,*)                                                     &
    !D                  &             GV%sourceOffsets(ii)%point%x/GV%anglefactorR,          &
    !D                  &             GV%sourceOffsets(ii)%point%y/GV%anglefactorR,          &
    !D                  & " /SYSTEM ", GV%sourceOffsets(ii)%systemName
    !D          End If
    !D          Call  pakoMessage(priorityI,severityI,command,messageText)
    !D          !
    !D       End If
    !D    End Do
    !
    Return
  End Subroutine offsets
!!!
!!!
  Subroutine queryOffsets(iQuery,nameQuery,isSet,pointResult)
    !
    Integer              ,  Intent(IN)    :: iQuery
    Character(len=lenCh) ,  Intent(IN)    :: nameQuery
    Logical              ,  Intent(OUT)   :: isSet
    Type(xyPointType)    ,  Intent(OUT)   :: pointResult
    !
    ! TBD: elaborate!
    !
    !D        Write (6,*) "   --> queryOffsets: "
    !D        Write (6,*) "            iQuery = ", iQuery
    !
    isSet = .False.
    pointResult = xyPointType(GPnoneR,GPnoneR)
    If (iQuery.Ge.1 .And. iQuery.Le.nDimOffsetChoices) Then
       If (varsOffsets(iValue,iQuery)%isSet) Then
          isSet = .True.
          pointResult =  varsOffsets(iValue,iQuery)%point
       End If
    End If
    !
    !D        Write (6,*) "           isSet =       ", isSet
    !D        Write (6,*) "           pointResult = ", pointResult
    !
    Return
  End Subroutine queryOffsets
!!!
!!!
  Subroutine displayOffsets
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Integer  :: nCount
    !
    Include 'inc/display/commandDisplayOffsets.inc'
    !
  End Subroutine displayOffsets
!!!
!!!
  Subroutine saveSource(programName,LINE,commandToSave,                          &
       &        iUnit, error)                                                    !
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer :: l1, l2
    !
    B = '\'  ! '
    S = ' '
    CMD =  programName//B//"SOURCE"
    lCMD = lenc(CMD)
    !
    ERROR = .False.
    !
    contC = contNN
    !
    Write (iUnit,*) "! "
    Write (iUnit,*) "! ", CMD(1:lCMD)
    !
    ! TBD debug for all possible cases ///
    !
    If (vars(iValue)%isBody) Then
       contC = contNC
       Include 'inc/parameters/saveBodyName.inc'
       contC = contCC
       Include 'inc/parameters/savePerihelionEpoch.inc'
       Include 'inc/parameters/saveAscendingNode.inc'
       Include 'inc/parameters/saveArgumentOfPerihelion.inc'
       Include 'inc/parameters/saveInclination.inc'
       Include 'inc/parameters/savePerihelionDistance.inc'
       contC = contCN
       Include 'inc/parameters/saveEccentricity.inc'
    Else If (vars(iValue)%isPlanet .Or. vars(iValue)%isSatellite) Then
       contC = contNC
       Include 'inc/parameters/saveSourceName.inc'
       contC = contCN
!!$       Include 'inc/options/saveVelocity.inc'
!!$       Include 'inc/options/saveFlux.inc'
    Else
       contC = contNC
       Include 'inc/parameters/saveSourceName.inc'
       contC = contCC
       Include 'inc/parameters/saveSystem.inc'
       Include 'inc/parameters/saveLongitudeLatitude.inc'
       If (vars(iValue)%projectID .Eq. GPnone) Then
          contC = contCN
          Include 'inc/parameters/saveVelocity.inc'
!!$       Include 'inc/parameters/saveFlux.inc'
       Else
          Include 'inc/parameters/saveVelocity.inc'
          Include 'inc/parameters/saveFlux.inc'
          contC = contCN
          Include 'inc/parameters/saveSourceProjectID.inc'
       End If
    End If
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveSource
!!!
!!!
  Subroutine saveOffsets(programName,LINE,commandToSave,                         &
       &        iUnit, error)                                                    !
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer  :: ii
    !
    B = '\'  ! '
    S = ' '
    CMD =  programName//B//"OFFSETS"
    lCMD = lenc(CMD)
    !
    ERROR = .False.
    !
    Write (iUnit,*) "! "
    Write (iUnit,*) "! ", CMD(1:lCMD)
    !
    contC = contNN
    Include 'inc/commands/saveOffsets.inc'
    contC = contCN
    Include 'inc/options/saveClear.inc'
    !
    Do ii = 1, nDimOffsetChoices, 1
       If (varsOffsets(iValue,ii)%isSet) Then
          !
          !TBD: special case Nasmyth:
!!$            If (varsOffsets(iValue,ii)%systemName .EQ.                  &
!!$                 &  offsetSystemChoices(iNASMYTH)) Then
!!$            Else      
          !
          contC = contNN
          !
          Include 'inc/commands/saveOffsets.inc'
          !
          contC = contCC
          !
          Include 'inc/parameters/saveXoffsetYoffset.inc'
          !
          contC = contCN
          !
          Include 'inc/options/saveOffsetsSystem.inc'
          !
!!$            End If
       End If
    End Do
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveOffsets
!!!
!!!
  Subroutine SUFFIX(PAR,LPAR,R1,R2)
    !------------------------------------------------------------------------
    !------------------------------------------------------------------------
    ! Dummy variables:
    Character*(*) PAR
    Real R1,R2
    Integer LPAR
    ! Local variables:
    Integer I
    Character*80 CHAIN
    !------------------------------------------------------------------------
    ! Code:
    !
    R1 = 0
    R2 = 0
    I = Index(PAR(1:LPAR),',')
    If (I.Eq.0) Return
    CHAIN = PAR(I+1:LPAR)
    PAR = PAR(1:I-1)
    LPAR = I-1
    I = Index(CHAIN,',')
    If (I.Eq.0) Then
       Read (CHAIN,*,ERR=99) R1
    Else
       Read (CHAIN,*,ERR=99) R1,R2
    Endif
99  Return
  End Subroutine SUFFIX
!!!
!!!
!!$      SUBROUTINE CHECK_POSITION
!!$!------------------------------------------------------------------------
!!$! Check elevation and distance from sun
!!$!------------------------------------------------------------------------
!!$! Global variables:
!!$      INCLUDE 'const.f'
!!$      INCLUDE 'obs_parameter.inc'
!!$      INCLUDE 'obs_obs.inc'
!!$      INCLUDE 'obs_structure.inc'
!!$      INCLUDE 'obs_common.inc'
!!$      REAL*4 D_SUN, S_RISE, S_SET, D_AZIM
!!$      LOGICAL D_SHADOW, ERROR
!!$      COMMON/SUN/D_SUN, D_AZIM, D_SHADOW
!!$! Local variables:
!!$      REAL*8 D_ELEV, TEST, TRISE, TSET
!!$      REAL*4 SUNLIM
!!$      CHARACTER*80 MSG
!!$!------------------------------------------------------------------------
!!$! Code:
!!$      TEST = D_ELEV(0.)
!!$      TRISE = S_RISE(0.)
!!$      TSET = S_SET(0.)
!!$      IF (TEST.LT.0) THEN
!!$         IF (TRISE.LT.25) THEN
!!$            WRITE(MSG,'(a,f6.2,a)') NEXT.SOU.NAME
!!$     $      //' is set and will rise at ',TRISE,' h LST'
!!$            CALL  pakoMessage(8,3,'SOURCE',MSG)
!!$         ELSE
!!$            CALL  pakoMessage(8,3,'SOURCE',NEXT.SOU.NAME
!!$     $      //' cannot be observed (low declnation).')
!!$         ENDIF
!!$      ELSEIF (TEST.LT.20.) THEN
!!$         WRITE(MSG,300) NEXT.SOU.NAME//' is at low elevation: ',
!!$     $   TEST,' degrees.'
!!$         CALL  pakoMessage(4,2,'SOURCE',MSG)
!!$      ELSE
!!$         WRITE(MSG,300) 'Elevation of '
!!$     $   //NEXT.SOU.NAME//' is ',TEST,' degrees.'
!!$         CALL  pakoMessage(2,1,'SOURCE',MSG)
!!$      ENDIF
!!$      IF (TEST.GT.0) THEN
!!$         IF (D_SHADOW) THEN
!!$            CALL  pakoMessage(4,2,'SOURCE','Antenna shadowing will occur')
!!$         ENDIF
!!$      ENDIF
!!$      IF (TSET.GE.0 .AND. TSET.LE.24.) THEN
!!$         WRITE(MSG,'(a,f6.2,a)') 'Setting time : ',TSET,'h LST'
!!$         CALL MESSAGE (2,1,'SOURCE',MSG)
!!$      ENDIF
!!$      WRITE(MSG,300) NEXT.SOU.NAME//' is at ',D_SUN,' degrees from Sun.'
!!$      CALL SIC_GET_REAL('SUN_LIMIT',SUNLIM,ERROR)
!!$      IF (D_SUN.LT.30) THEN
!!$         CALL  pakoMessage(8,3,'SOURCE',MSG)
!!$      ELSEIF (.NOT.ERROR .AND. D_SUN.LT.SUNLIM) THEN
!!$         CALL  pakoMessage(6,2,'SOURCE',MSG)
!!$      ELSEIF (D_SUN.LT.50) THEN
!!$         CALL  pakoMessage(4,1,'SOURCE',MSG)
!!$      ENDIF
!!$      RETURN
!!$300   FORMAT(A,F6.2,A)
!!$      END SUBROUTINE CHECK_POSITION
!!!
!!!
  Subroutine DECDEG(CHAIN,LCHAIN,Value,NDIV,ERROR)
    !----------------------------------------------------------------------
    ! ASTRO	Internal routine
    !	Decode a sexagesimal character string into angle value in
    !	DEGREES. Formats can be
    !	61.5000000	or	161
    !	61:30.0000	or	161:40
    !	61:45:50.9	or	161:40:50
    ! Arguments :
    !	CHAIN	C*(*)	Character string		Input
    !	LCHAIN	I	length of			Input
    !	VALUE	R*8	Value of angle(radians)		Output
    !	NDIV	I	360/24				Input
    !	ERROR	L	Error flag
    ! No subroutines
    ! No common
    !----------------------------------------------------------------------
    Character*(*) CHAIN
    Real*8 Value,CONV,DEGREE,MINUTE,SECOND
    Integer NDIV,NDOT,NLEN,NMIN,NSEC, LENC, LCHAIN
    Logical MINUS, ERROR
    !
    NLEN = LENC(CHAIN(1:LCHAIN))
    !
    ! Zeroth find minus sign if any
    NDOT = Index(CHAIN(1:NLEN),'-')
    MINUS = NDOT.Ne.0
    !
    ! First find if any dot in Chain
    NDOT = Index(CHAIN(1:NLEN),'.')
    If (NDOT.Eq.0) Then
       NDOT=NLEN+1
    Endif
    !
    ! Set CONV factor
    CONV = 360.D0/NDIV
    !
    ! Find if any minute Field
    NMIN = Index(CHAIN(1:NLEN),':')
    If (NMIN.Eq.0) Then
       ! No Minutes Field
       Read(CHAIN(1:NLEN),100,ERR=99) DEGREE
       Value = CONV*DEGREE
       Return
    Endif
    !
    ! Find if any Second field
    NSEC = Index(CHAIN(NMIN+1:NLEN),':')
    If (NSEC.Eq.0) Then
       ! No Seconds Field
       If (NDOT.Ne.NMIN+3) Then
          ! Minutes Field not two characters
          Goto 99
       Endif
       Read(CHAIN(NMIN+1:NLEN),100,ERR=99) MINUTE
       If (MINUTE.Ge.60.D0) Then
          Write(6,101) 'E-ANGLE, more than 60 minutes...'
          ERROR = .True.
          Return
       Endif
       Read(CHAIN(1:NMIN-1),100,ERR=99) DEGREE
       If (.Not.MINUS) Then
          Value = CONV*(DEGREE+MINUTE/60.D0)
       Else
          Value = CONV*(DEGREE-MINUTE/60.D0)
       Endif
    Elseif (NSEC.Ne.3) Then
       ! Minutes Field not two characters
       Goto 99
    Else
       ! Seconds Field is present
       If (NDOT.Ne.NMIN+6) Then
          ! Seconds Field not two characters
          Goto 99
       Endif
       Read(CHAIN(NMIN+4:NLEN),100,ERR=99) SECOND
       If (SECOND.Ge.60.D0) Then
          Write(6,101) 'E-ANGLE,  more than 60 seconds...'
          ERROR = .True.
          Return
       Endif
       Read(CHAIN(NMIN+1:NMIN+2),100,ERR=99) MINUTE
       If (MINUTE.Ge.60.D0) Then
          Write(6,101) 'E-ANGLE,  more than 60 minutes...'
          ERROR = .True.
          Return
       Endif
       Read(CHAIN(1:NMIN-1),100,ERR=99) DEGREE
       If (.Not.MINUS) Then
          Value = CONV*(DEGREE+MINUTE/60.D0+SECOND/3600.D0)
       Else
          Value = CONV*(DEGREE-MINUTE/60.D0-SECOND/3600.D0)
       Endif
    Endif
    Return
    !
99  Write(6,101) 'E-ANGLE,  Invalid angle format'
    ERROR = .True.
    Return
100 Format(F20.0)
101 Format(1X,A)
  End Subroutine DECDEG
!!!
!!!
  Subroutine CVDEG (ARG,NARG,ANG,DVAL,ERROR)
    !------------------------------------------------------------------------
    ! POM	internal routine
    !	converts a chain into RADIANS according to angle unit
    !	arg	c*1	chain to be decoded	Input
    !	narg	I	length of arg		Input
    !	ang	C*1	angle unit : H = hours, M = arc minutes,
    !			D = arc degrees, S = arc seconds	Input
    !	dval	R*8	result			Output
    !	error	L*1	error code		Output
    !
    ! Dummy -----------------------------------------------------------------
    Character*(*) ARG, ANG
    Integer NARG, NDIV1
    Logical ERROR
    Real*8 DVAL, PI
    Parameter (PI=3.141592653589793D0)
    ! Code ------------------------------------------------------------------
    If (ANG.Eq.'S') Then
       Read(ARG(1:NARG),'(f20.0)',ERR=900) DVAL
       DVAL = DVAL / 3600.
    Else
       If (ANG.Eq.'M') Then
          NDIV1 = 21600
       Elseif (ANG.Eq.'H') Then
          NDIV1 = 24
       Else
          NDIV1 = 360
       Endif
       Call DECDEG(ARG,NARG,DVAL,NDIV1,ERROR)
       If(ERROR) Return
       DVAL = DVAL * PI /180D0
    Endif
    Return
900 Write(6,100) 'E-CVDEG,  error decoding ',ARG(1:NARG)
    ERROR = .True.
    Return
100 Format(1X,A,A)
  End Subroutine CVDEG
!!!
!!!
  Subroutine FIND_VTYPE (PAR,VTYPE)
    Character*(*) PAR
    Integer VTYPE
    ! Velocity type
    ! (note that for CLASS: 3 means observatory, 4 earth-moon baryc.)
    Integer V_LSR, V_HELIO, V_EARTH, V_NULL, V_UNKNOWN
    Parameter (V_LSR = 1)
    Parameter (V_HELIO = 2)
    Parameter (V_EARTH = 3)
    Parameter (V_NULL = 4)
    Parameter (V_UNKNOWN = 0)
    !
!!$      Write (6,*) "   ---> SR: FIND_VTYPE "
!!$      Write (6,*) "            par :", par
    !
    If (PAR(1:1).Eq.'l') Then
       VTYPE = V_LSR                   !LSR
    Elseif (PAR(1:1).Eq.'h') Then
       VTYPE = V_HELIO                 !Helio
    Elseif (PAR(1:1).Eq.'e') Then
       VTYPE = V_EARTH                 !Earth
    Elseif (PAR(1:1).Eq.'n') Then
       VTYPE = V_NULL                  !Null
    Else
       VTYPE = V_UNKNOWN
    Endif
    !
    !D      Write (6,*) "            vtype :", vtype
    !
  End Subroutine FIND_VTYPE
!!!
!!!
  Subroutine checkSOURCE(NAME,LNAME,PAR,LPAR,FOUND)
    Character*(*) NAME,PAR
    Integer LNAME,LPAR
    Logical FOUND
    !
    Integer J,K,J1,J2,NAME_OUT,JK
    Character*80 NOM
    Data NAME_OUT/0/
    !
    ! Syntax  is   NAME1[|NAME2[|NAME3]]
    !
!!$      Write (6,*) "   ---> SR: checkSource "
!!$      Write (6,*) "            par :", par
    !
    If (.Not.FOUND) Then
       JK = 1
       Do While (.Not.FOUND .And. JK.Lt.LPAR)
          J = Index(PAR(JK:LPAR),NAME(1:LNAME))
          FOUND = J.Ne.0
          If (.Not.FOUND) Return
          K = JK-1+J-1
          If (K.Gt.0 .And. PAR(K:K).Ne.'|') FOUND = .False.
          K = JK-1+J+LNAME
          If (K.Le.LPAR .And. PAR(K:K).Ne.'|') FOUND = .False.
          JK = K
       Enddo
       If (.Not.FOUND) Return
       ! Use only one name if NAME_OUT is set
       If (NAME_OUT.Eq.0) Then
          PAR = NAME(1:LNAME)
          LPAR = LNAME
          ! Use all names
       Elseif (NAME_OUT.Eq.-1) Then
          Return
       Endif
    Elseif (NAME_OUT.Eq.-1) Then
       Return
    Else
       ! Extract name of order NAME_OUT
       J = 0
       J1 = 1
       Do While (.True.)
          J2 = Index(PAR(J1:LPAR),'|')
          If (J2.Eq.0) Then
             NOM = PAR(J1:LPAR)
             LPAR = LPAR-J1+1
             PAR = NOM
             Return
          Endif
          J2 = J2+J1-2
          If (J.Eq.NAME_OUT) Then
             NOM = PAR(J1:J2)
             LPAR = J2-J1+1
             PAR = NOM
             Return
          Endif
          J1 = J2+2
          J = J+1
       Enddo
    Endif
  End Subroutine checkSource
!!!
!!!
  Subroutine writeXMLsource(programName,LINE,commandToSave,                      &
       &        iUnit, ERROR)                                                    !
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical :: errorXML
    !
    Character (len=lenVar) :: valueC
    Character (len=lenVar) :: valueComment
    !
    !D      write (6,*)  "      modulePakoSource --> SR: writeXMLsource "
    !
    ! TBD: solve problem with "special characters" in source name: <>& 
    !      --> write source information as XML table like receivers & backends
    !
    Include 'inc/startXML/source.inc'
    !
    Return
  End Subroutine writeXMLsource
!!!
!!!
  Subroutine writeXMLradialVelocity(programName,LINE,commandToSave,              &
       &        iUnit, ERROR)                                                    !
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical :: errorXML
    !
    Character (len=24) :: valueC
    Character (len=48) :: valueComment
    !
    ERROR = .False.
    !
    !D    Write (6,*)  "      modulePakoSource --> SR: writeXMLradialVelocity "
    !
    Include 'inc/startXML/radialVelocity.inc'
    !
    Return
  End Subroutine writeXMLradialVelocity
!!!
!!!
  Subroutine writeXMLoffsets(programName,LINE,commandToSave,                     &
       &        iUnit, ERROR)                                                    !
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical :: errorXML
    !
    Integer :: ii
    Integer :: nCount
    !
    Character (len=24) :: valueC
    Character (len=48) :: valueComment
    !
    ERROR = .False.
    !
    !D      Write (6,*)  "      modulePakoSource --> SR: writeXMLoffsets "
    !
    Include 'inc/startXML/startXMLoffsets.inc'
    !
    Return
  End Subroutine writeXMLoffsets
!!!
!!!
  Subroutine writeXMLtopology(programName,LINE,commandToSave,                    &
       &     iUnit, ERROR)                                                       !
    !
    ! *** inc/variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical :: errorXML
    !
    Character (len=24) :: valueC
    !
    ERROR = .False.
    !
    !D        Write (6,*)  "      modulePakoSource --> SR: writeXMLtopology "
    !D        !
    !D        Write (6,*)  "       GV%topology = ",  GV%topology
    !
    If (.Not. GV%topology.Eq."none") Then
       !
       Call pakoXMLwriteStartElement("RESOURCE","topology",                      &
            &                         error=errorXML)                            !
       !
       valueC = GV%topology
       Call pakoXMLcase(valueC,error=errorXML)
       Call pakoXMLwriteElement("PARAM","azimuthWrap",valueC,                    &
            &                         dataType="char",                           &
            &                         error=errorXML)                            !
       !
       Call pakoXMLwriteEndElement  ("RESOURCE","topology",                      &
            &                         error=errorXML)                            !
       !
    End If
    !
    Return
  End Subroutine writeXMLtopology
!!!
!!!
  Subroutine writeXMLpointingCorrections(programName,LINE,commandToSave,         &
       &     iUnit, ERROR)                                                       !
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical :: errorXML
    !
    Character (len=24) :: valueC
    Character (len=48) :: valueComment
    !
    ERROR = .False.
    !
    !D  Write (6,*)  " modulePakoSource --> SR: writeXMLpointingCorrections "
    !
    Call pakoXMLwriteStartElement("RESOURCE","pointingCorrections",              &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(0.0*arcsec)
    Write (valueComment,*) Real(0.0), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionP1",valueC,              &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(GVpCorr%azimuthCorrection*arcsec)
    Write (valueComment,*) Real(GVpCorr%azimuthCorrection), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionP2",valueC,              &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(0.0*arcsec)
    Write (valueComment,*) Real(0.0), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionP3",valueC,              &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(0.0*arcsec)
    Write (valueComment,*) Real(0.0), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionP4",valueC,              &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(0.0*arcsec)
    Write (valueComment,*) Real(0.0), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionP5",valueC,              &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(GVpCorr%elevationCorrection*arcsec)
    Write (valueComment,*) Real(GVpCorr%elevationCorrection), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionP7",valueC,              &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(0.0*arcsec)
    Write (valueComment,*) Real(0.0), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionP8",valueC,              &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(0.0*arcsec)
    Write (valueComment,*) Real(0.0), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionP9",valueC,              &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(0.0*arcsec)
    Write (valueComment,*) Real(0.0), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionRxHorizontal",valueC,    &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(0.0*arcsec)
    Write (valueComment,*) Real(0.0), au%arcsec
    Call pakoXMLwriteElement("PARAM","pointingCorrectionRxVertical",valueC,      &
         &                         "rad", "double",                              &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","pointingCorrections",              &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLpointingCorrections
!!!
!!!
  Subroutine writeXMLfocusCorrections(programName,LINE,commandToSave,            &
       &        iUnit, ERROR)                                                    !
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical :: errorXML
    !
    Character (len=24) :: valueC
    Character (len=48) :: valueComment
    !
    !D        Write (6,*)  "      modulePakoSource --> SR: writeXMLfocusCorrections "
    !
    ERROR = .False.
    !
    Call pakoXMLwriteStartElement("RESOURCE","focusCorrections",                 &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(GVfCorrX%focusCorrection)
    Write (valueComment,*) Real(GVfCorrX%focusCorrection), "mm"
!!$    Write (valueC,*)       Real(0.0)
!!$    Write (valueComment,*) Real(0.0), "mm"
    Call pakoXMLwriteElement("PARAM","focusCorrectionX",valueC,                  &
         &                         "mm", "double",                               &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(GVfCorrY%focusCorrection)
    Write (valueComment,*) Real(GVfCorrY%focusCorrection), "mm"
!!$    Write (valueC,*)       Real(0.0)
!!$    Write (valueComment,*) Real(0.0), "mm"
    Call pakoXMLwriteElement("PARAM","focusCorrectionY",valueC,                  &
         &                         "mm", "double",                               &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Write (valueC,*)       Real(GVfCorr%focusCorrection)
    Write (valueComment,*) Real(GVfCorr%focusCorrection), "mm"
    Call pakoXMLwriteElement("PARAM","focusCorrectionZ",valueC,                  &
         &                         "mm", "double",                               &
         &                         comment=valueComment,                         &
         &                         error=errorXML)                               !
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","focusCorrections",                 &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLfocusCorrections
!!!
!!!
End Module modulePakoSource
!!!
!!!

subroutine solve_point(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !	Support routine for command
  !	SOLVE POINT [BEAM] [/PLOT] [/OUTPUT File [OLD|NEW|PROC]]
  !              [/COMPRESS TIME_MAX]
  !	[/Store /Reset /Offset /Search] Not relevant here
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  include 'clic_parameter.inc'
  include 'clic_point.inc'
  ! Local
  logical :: plot, output, end, flu, tpoint
  real :: beam, lo1, bsize, time_max
  integer :: p_lun, q_lun
  integer :: icount, naddr, nant
  integer(kind=address_length) :: data_in, ip_data, iaddr
  integer(kind=data_length)    :: ldata_in
  !------------------------------------------------------------------------
  ! Code:
  iproc = 0
  naddr = 0
  iaddr = 0
  q_lun = 0
  output = .false.
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  plot = sic_present(1,0)
  !
  ! /COMPRESS TIME_MAX option
  time_max = 4.0
  call sic_r4(line,6,1,time_max,.false.,error)
  if (error) goto 999
  !
  ! /OUTPUT FLUX|OLD|NEW, /PRINT
  call file_point(line,output,p_lun,flu,q_lun,tpoint,error)
  !
  ! Get beam size
  beam = -1.0                  ! fix to frequency dep. value
  call sic_r4(line,0,2,beam,.false.,error)
  if (error) goto 999
  !
  if (plot) call gr_exec1('TICKSPACE 0 0 0 0')
  !
  ! Get  a first one
  call get_first(.true.,error)
  if (error) goto 999
  end = .false.
  call check_point(error)
  do while (error .and. .not.end)
    call get_next(end,error)
    if (error) goto 999
    if (.not.end) call check_point(error)
  enddo
  if (error) goto 999
  icount = 0
  call get_data (ldata_in,data_in,error)
  if (error) goto 999
  ip_data = gag_pointer(data_in,memory)
  !
  call load_point (memory(ip_data),   &
    icount,iaddr,naddr,error,lo1,nant,time_max)
  if (error) goto 999
  call load_beam  (beam,bsize,lo1,nant)
  !
  ! Get next ones alike
  call get_next(end,error)
  if (error) goto 999
  do while (.not.end)
    call check_point(error)
    if (error) then
      if (icount.ne.0) then
        call sub_point (plot,output,p_lun,iaddr,naddr,q_lun,   &
          error,bsize,flu,end)
        icount = 0
        if (error) goto 998
        call free_vm  (naddr,iaddr)
        naddr = 0
        iaddr = 0
      endif
    elseif (icount.eq.0) then
      call get_data (ldata_in,data_in,error)
      if (error) goto 999
      ip_data = gag_pointer(data_in,memory)
      call load_point (memory(ip_data),   &
        icount,iaddr,naddr,error,lo1,nant,time_max)
      if (error) goto 998
      call load_beam  (beam,bsize,lo1,nant)
    else
      call get_data (ldata_in,data_in,error)
      if (error) goto 999
      ip_data = gag_pointer(data_in,memory)
      call load_point (memory(ip_data),   &
        icount,iaddr,naddr,error,lo1,nant,time_max)
      if (icount.eq.0) then
        call sub_point (plot,output,p_lun,iaddr,naddr,q_lun,   &
          error,bsize,flu,end)
        if (error) goto 998
        call free_vm(naddr,iaddr)
        naddr = 0
        iaddr = 0
        call load_point (memory(ip_data),   &
          icount,iaddr,naddr,error,lo1,nant,time_max)
        if (error) goto 998
      endif
      call load_beam  (beam,bsize,lo1,nant)
    endif
    call get_next(end,error)
    if (error) goto 999
    if (sic_ctrlc()) goto 999
  enddo
  !
  if (icount.ne.0) then
    call sub_point (plot,output,p_lun,iaddr,naddr,q_lun,   &
      error,bsize,flu,end)
    call free_vm(naddr,iaddr)
    naddr = 0
    iaddr = 0
  endif
  !
  goto 998
  !
999 error = .true.
998 if (output) then
    close(unit=p_lun)
    call sic_frelun(p_lun)
  endif
  if (naddr.ne.0 .and. iaddr.ne.0) then
    call free_vm(naddr,iaddr)
    iaddr = 0
    naddr = 0
  endif
  if (q_lun.ne.0) then
    close (unit=q_lun)
    call sic_frelun(q_lun)
  endif
end subroutine solve_point
!
subroutine check_point(error)
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !	Check if data is a pointing scan
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_point.inc'
  ! Code:
  if (r_proc.ne.16) then
    call message(6,3,'POINT','Scan is not a pointing measurement')
    error = .true.
    return
  endif
  iauto = 0
end subroutine check_point
!
subroutine load_point (data,   &
    icount,jaddr,naddr,error,lo1,nant,time_max)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !	Support routine for SOLVE POINTING
  !	Measure antenna pointing position from a specialised
  !	routine in the real-time acquisition system
  ! Arguments:
  !     DATA      *      Data array
  !	ICOUNT	I	Subscan number 0 : not loaded
  !	JADDR	I	Array address
  !	NADDR	I	Array length
  !	LO1	R*4 	LO1 frequency
  !	NANT	I	Number of antennas
  !       TIME_MAX R*4    Max. integration time (compression)
  !---------------------------------------------------------------------
  real :: data(*)                        !
  integer :: icount                      !
  integer(kind=address_length) :: jaddr  !
  integer :: naddr                       !
  logical :: error                       !
  real :: lo1                            !
  integer :: nant                        !
  real :: time_max                       !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_point.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: iaddr, visi, posi, weig
  integer :: i, k1, kp1, kv1, kw1, mdump, msub
  real :: weight_factor, seuil
  save mdump
  real*8 :: fnu, ff, size(3)
  character(len=132) :: chain
  !
  ! Process up to msub subscan
  msub = 10  
  !
  ! Compute threshold and weight
  error = .false.
  seuil = 40.0                 ! Big displacement is bad
  weight_factor = 0.1          ! and really bad
  if (icount.ne.0 .and.   &
    (r_scan.ne.iscan  .or. r_scaty.ne.icode)) then
    icount = 0
    return
  endif
  !
  ! Compress (to time_max)
  if (icount.eq.0) mdump = r_ndump
  !      CALL COMPRESS(TIME_MAX, 7.5, DATA, NOUT,ERROR)
  !      IF (ERROR) GOTO 999
  !      R_NDUMP = MIN(NOUT,MDUMP)
  !      CALL LOOSE_DATA
  !
  if (icount.eq.0) then
    iscan = r_scan
    icode = r_scaty
    lo1   = r_flo1
    nfix = 0
    nmob = 0
    nant = r_nant
    do i=1,r_nant
      if (r_mobil(i)) then
        nmob = nmob+1
        imob(nmob) = i
      else
        nfix = nfix+1
        ifix(nfix) = i
      endif
      if (r_scaty.eq.2) then
        coll(i) = r_collaz(i)
      elseif (r_scaty.eq.3) then
        coll(i) = r_collel(i)
      elseif (r_scaty.eq.1) then
        coll(i) = r_corfoc(i)
      endif
      kant(i) = r_kant(i)
      istat(i) = r_istat(i)
    enddo
    source = r_sourc
    az = r_az
    el = r_el
    ut = r_ut
    mp = msub*mdump
    a_flux = r_flux
    fnu = r_restf * 1d-3
    call planet_flux (source,r_dobs,r_ut,   &
      fnu,ff,a_flux,size,error)
    !
    ! Get storage for up to 8 subscans like that one...
    !	IADDR (MP,3,NMOB)
    !
    naddr = mp*3*nmob + mdump*r_nant*3
    if (sic_getvm(naddr,jaddr).ne.1) goto 999
    np = 0
  endif
  !
  ! Check overflow
  if (icount.ge.msub) then
    write (chain,'(A,I0,A)') 'Can process only up to ',msub,' subscans'
    call message (6,3,'LOAD_POINT',chain(1:lenc(chain)))
    error = .true.
    return
  endif
  !
  ! Read visibilities and positions
  iaddr = gag_pointer(jaddr,memory)
  visi = iaddr + 3*mp*nmob
  posi = visi + mdump*r_nant
  weig = posi + mdump*r_nant
  call fill_visi_posi (mdump, r_nbas, r_nant,   &
    memory(visi),memory(posi),memory(weig),time_max,data,error)
  if (error) goto 999
  !
  ! Put in final array
  do i=1,nmob
    k1 = (imob(i)-1)*mdump
    kp1 = mdump*(3*msub*(i-1)+icount)
    kv1 = mdump*(3*msub*(i-1)+msub+icount)
    kw1 = mdump*(3*msub*(i-1)+2*msub+icount)
    call r4tor4 (memory(posi+k1),memory(iaddr+kp1),mdump)
    call r4tor4 (memory(visi+k1),memory(iaddr+kv1),mdump)
    call r4tor4 (memory(weig+k1),memory(iaddr+kw1),mdump)
  enddo
  icount = icount+1
  np = np+mdump
  return
  !
999 error = .true.
end subroutine load_point
!
subroutine sub_point (plot,out,iout,jaddr,naddr,qlun,   &
    error,beam,flu,end)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !	Support routine for SOLVE POINTING/PLOT
  !	Measure antenna pointing position from a specialised
  !	routine in the real-time acquisition system
  ! Arguments:
  !	PLOT	L	Plot data and fit
  !	OUT	L	Write fit on output file
  !	IOUT	I	Output logical unit
  !	JADDR	I	Work space address
  !	NADDR	I	Work space length
  !	ERROR	L	Logical error flag
  !	BEAM	R*4	Beam size (radian)
  !     flu      L       Special format for flux determination.
  !     end      L       Means this is the last scan in the index
  !---------------------------------------------------------------------
  logical :: plot                        !
  logical :: out                         !
  integer :: iout                        !
  integer(kind=address_length) :: jaddr  !
  integer :: naddr                       !
  integer :: qlun                        !
  logical :: error                       !
  real :: beam                           !
  logical :: flu                         !
  logical :: end                         !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_point.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: iaddr, posi, gain, weig
  integer :: i, n, j
  real :: dfo(mnant),efo(mnant),ofo(mnant),maxefo
  real :: focus,weigh,tan_el
  real :: par(3), err(3), daz(mnant), del(mnant), refraction(3)
  real :: qaz(mnant), qel(mnant), eaz(mnant), eel(mnant), ref_corr
  real :: effaz(mnant), effel(mnant), widaz(mnant), widel(mnant)
  integer :: lant(mnant), jant, nant, tant
  integer(kind=index_length) :: dim(2)
  character(len=12) :: answer
  character(len=132) :: chain
  character(len=6) :: sca(3)
  character(len=24) :: limit
  logical :: clear
  integer :: dummy
  real*8 :: tt, eff
  ! Data
  data sca /'Focus','Azim.','Elev.'/
  !
  ! Compulsory SAVE statement
  save daz,del,lant,nant,qaz,qel,effaz,effel, widaz, widel
  !
  if (iauto.eq.0) then
    limit = 'LIMITS * * 0 *'
  else
    limit = 'LIMITS'
  endif
  !
  ! Find pointing parameters position
  clear = icode.le.2
  if (clear) nant = 0
  !
  iaddr = gag_pointer(jaddr,memory)
  do i=1,nmob
    posi = iaddr + 3*(i-1)*mp
    gain = posi + mp
    weig = gain + mp
    write (chain,1004) iscan, r_nrec, source, a_flux, az*180.d0/pi,   &
      el*180.d0/pi,' " 9 /BOX 7'
    if (plot) then
      call plot_point (nmob,i,kant(imob(i)),icode,clear,   &
        'DRAW TEXT 0 0.2 "'//chain(1:lenc(chain)),   &
        np,memory(gain),memory(posi),memory(weig),   &
        limit)
      clear = .false.
    endif
    call fit_point (np,   &
      memory(gain),memory(posi),memory(weig),   &
      par,err,beam,error)
    if (.not.error) then
      if (plot) then
        call pro_point(error)
      endif
      jant = kant(imob(i))     ! Physically connected antenna
      tant = 0
      do j=1,nant
        if (jant.eq.lant(j)) tant = j
      enddo
      if (tant.eq.0) then
        nant = nant+1
        lant(nant) = jant
        tant = nant
      endif
      !
      ! Write Results
      write (chain,1001) sca(icode), iscan, source, az*180.d0/pi,   &
        el*180.d0/pi
      call message(6,1,'SUB_POINT',chain(1:lenc(chain)))
      write (chain,1002) kant(imob(i)), (par(j),j=1,3)
      call message(6,1,'SUB_POINT',chain(1:lenc(chain)))
      write (chain,1003) kant(imob(i)), (err(j),j=1,3)
      call message(6,1,'SUB_POINT',chain(1:lenc(chain)))
      if (out) then
        if (.not.flu) then
          call refrac(refraction)
          ref_corr = 0.0
          if (el.ne.0) then
            tan_el = tan(el)
            ref_corr = refraction(1)/tan_el &
               + refraction(2)/tan_el**3 &
               + refraction(3)/tan_el**5 
            ref_corr = ref_corr * 180.0/pi * 3600.0
          endif
          write(iout,2001) inum, iscan, 3-icode,   &
            az*180d0/pi, el*180d0/pi, ut*12d0/pi,   &
            kant(imob(i)), istat(imob(i)),   & ! Antenna Station
            par(2)+coll(imob(i)), err(2),   &  ! position
            par(2), par(3), err(3),   &
            par(1)/par(3)/1.064467, r_topwind, &
            r_topwindir*180.0/pi, r_humid, r_tamb, r_pamb, &
            refraction(1), refraction(2), refraction(3), &
            ref_corr, source
        else
          !
          ! For flux: compute error on intensity...
          !C NGRX: Give the Gain for the first polar...
          !C TODO Average??
          call datec (r_dobs,chain,error)
          write(iout,2011) r_num, iscan, 3-icode,   &
            az*180d0/pi, el*180d0/pi, ut*12d0/pi,   &
            par(2), err(2),   &    ! Position & error
            kant(imob(i)),   & ! Station
            par(3), err(3),   &    ! Width & error
            par(1)/par(3)/1.064467, err(1)/par(3)/1.064467,   &
            r_gim(1,imob(i)),   &
            r_restf*1e-3,   &
            (r_restf-2*r_isb*r_fif1)*1e-3,   &
            source,chain(1:11)
        endif
        !
2011    format(1x,i8,i6,i3,3(1x,f8.3),1x,   &
          f9.2,1x,f8.2,1x,i2,1x,f9.2,1x,f8.2,1x,   &
          1pg10.3,1x,1pg10.3,1x,0pf6.2,2(1x,f8.3),1x,'''',a,'''',   &
          1x,'''',a,'''')
      !
      endif
      !
      ! compute efficiency?
      tt = par(1)/par(3)/1.064467
      eff = a_flux/tt
      !
      if (icode.eq.1) then
        !
        ! Write Results
        dfo(tant) = par(2)
        efo(tant) = err(2)
        ofo(tant) = r_corfoc(imob(i))
        if (plot) then
          write (chain,1025) 'DRAW TEXT 0.2 -0.2 "',   &
            dfo(tant),'" 3 /BOX 7'
          call gr_exec1(chain(1:lenc(chain)))
        endif
      !
      ! Bias the result towards the reference pointing constant by 1 sigma.
      ! However do nothing if the sigma is larger that 5 arc seconds (really bad).
      ! Note that R_COLL* are based on logical antennas
      elseif (icode.eq.2) then
        daz(jant) = par(2)
        eaz(jant) = err(2)
        effaz(jant) = eff
        widaz(jant) = par(3)
        if (eaz(jant).lt.5.) then
          qaz(jant) = daz(jant) + r_collaz(imob(i))
        else
          qaz(jant) = r_collaz(imob(i))
        endif
        if (plot) then
          write (chain,1015) 'DRAW TEXT 0.2 -0.2 "',   &
            daz(jant),'" 3 /BOX 7'
          call gr_exec1(chain(1:lenc(chain)))
          write (chain,1015) 'DRAW TEXT -0.2 -0.2 "',   &
            eff,' Jy/K" 1 /BOX 9'
          call gr_exec1(chain(1:lenc(chain)))
        endif
      else
        del(jant) = par(2)
        eel(jant) = err(2)
        effel(jant) = eff
        widel(jant) = par(3)
        if (eel(jant).lt.5.) then
          qel(jant) = del(jant) + r_collel(imob(i))
        else
          qel(jant) = r_collel(imob(i))
        endif
        if (plot) then
          write (chain,1015) 'DRAW TEXT 0.2 -0.2 "',   &
            del(jant),'" 3 /BOX 7'
          call gr_exec1(chain(1:lenc(chain)))
          write (chain,1015) 'DRAW TEXT -0.2 -0.2 "',   &
            eff,' Jy/K" 1 /BOX 9'
          call gr_exec1(chain(1:lenc(chain)))
        endif
      endif
    endif
  enddo
  if (icode.eq.3) then
    call sic_delvariable('DEL',.false.,error)
    call sic_delvariable('EFFEL',.false.,error)
    call sic_delvariable('WIDEL',.false.,error)
    dim = mnant
    call sic_def_real ('DEL',del,1,dim,.false.,error)
    call sic_def_real ('EFFEL',effel,1,dim,.false.,error)
    call sic_def_real ('WIDEL',widel,1,dim,.false.,error)
  elseif (icode.eq.2) then
    call sic_delvariable('DAZ',.false.,error)
    call sic_delvariable('EFFAZ',.false.,error)
    call sic_delvariable('WIDAZ',.false.,error)
    dim = mnant
    call sic_def_real ('DAZ',daz,1,dim,.false.,error)
    call sic_def_real ('EFFAZ',effaz,1,dim,.false.,error)
    call sic_def_real ('WIDAZ',widaz,1,dim,.false.,error)
  endif
  if (icode.eq.3) then
    do j =1,nant
      write(chain,1017) lant(j), daz(lant(j)), eaz(lant(j)),   &
        qaz(lant(j)), del(lant(j)), eel(lant(j)), qel(lant(j))
      call message(6,1,'SUB_POINT',chain(1:lenc(chain)))
    enddo
  endif
  !
  if (plot .and. icode.ne.2) then
    if (.not.end .and. sic_inter_state(dummy)) then
      answer = ' '
      write(6,*)   &
        '[Hardcopy - clear Alpha - Clear Plot - Quit]'
      call sic_wprn('I-PLOT,  Type H,A,Q,P or Return'   &
        ,answer,n)
      call sic_blanc(answer,n)
      if (index(answer,'H').ne.0)  call   &
        gr_exec('HARDCOPY /PRINT')
      if (index(answer,'A').ne.0)  call   &
        gtclear
      if (index(answer,'Q').ne.0)   &
        error = .true.
      if (index(answer,'P').ne.0)  call   &
        gtclal
    endif
  endif
  !
  ! /PRINT option
  if (qlun.ne.0 .and. icode.eq.3) then
    call check_scan(qlun,r_scan,'Pointing')
    do j =1,nant
      write(qlun,1007) qaz(lant(j)),qel(lant(j)),lant(j),r_nrec
    enddo
  endif
  !
  ! Print the focus value
  if (qlun.ne.0 .and. icode.eq.1) then
    call check_scan(qlun,r_scan,'Focus')
    !
    ! First pass to compute the mean focus change
    focus = 0.0
    weigh = 0.0
    maxefo = 0.0
    do i=1,nant
      maxefo = max(maxefo,efo(i))
    enddo
    if (maxefo.eq.0.0) then
      do i=1,nant
        focus = focus + dfo(i)
        weigh = weigh + 1.0
      enddo
    else
      do i=1,nant
        if (efo(i).eq.0.0) efo(i) = maxefo
        focus = focus + dfo(i)/efo(i)**2
        weigh = weigh + 1.0/efo(i)**2
      enddo
    endif
    focus = focus/weigh
    !
    ! Use either the mean change, or the real change if significant
    write(chain,1025) 'Mean Focus: ',focus
    call message(6,1,'SUB_FOCUS',chain(1:lenc(chain)))
    do i=1,nant
      if (abs(focus-dfo(i)).gt.efo(i)) then
        write(chain,1035) 'Ant ',i,' correction ',dfo(i),' mm '
        ofo(i) = dfo(i)+ofo(i)
      else
        write(chain,1035) 'Ant ',i,' correction ',focus,   &
          ' mm (aver.)'
        ofo(i) = focus+ofo(i)
      endif
      write(qlun,'(A,F6.2,A,I2,A,I0)') 'CORRECTION * * ',ofo(i),   &
        ' /ANTENNA ',lant(i),' /RECEIVER ',r_nrec
      call message(6,1,'SUB_POINT',chain(1:lenc(chain)))
    enddo
    close (unit=qlun)
  endif
  return
  !
1001 format (a,' Scan ',i5,' Source ',a,' Az ',f8.2,' El ',f8.2)
1002 format ('A',i0,' Area ',1pg10.3,' Pos. ',1pg10.3,   &
    ' Wid. ',1pg10.3)
1003 format ('A',i0,' Err. ',1pg10.3,' Err. ',1pg10.3,   &
    ' Err. ',1pg10.3)
1004 format ('Scan: ',i4,' R',i1,1x,'Source: 'a,' S=',f8.2,& 
    ' Az=',f8.2,' El=',f8.2, a)
1015 format (a,f5.1,a)
1025 format (a,f6.2,a)
1035 format (a,i0,a,f6.2,a)
1007 format ('CORRECTIONS ',f6.1,1x,f6.1,' /ANTENNA ',i0,' /RECEIVER ',i0)
1017 format('A',i0,' AZ:',f6.1,'(',f4.1,') Corr.',f6.1,   &
    ';   EL:',f6.1,'(',f4.1,') Corr.',f6.1)
2001 format(1x,i8,i6,i4,3(2x,f9.4),1x,2i4,   &
    2(f9.3,' ',f8.3,'  '),1pg9.3,1pg10.3,5(1x,1pg10.4), &
    4(1x,1pg10.3),2x,'''',a,''' ')
end subroutine sub_point
!
subroutine plot_point(nmob,imob,iant,icode,clea,chain,   &
    np,gain,posi,weig,limit)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! CLIC
  !	Support routine for SOLVE POINTING/PLOT
  ! 	Plot gain data
  ! Arguments
  !	NMOB	I 	Number of mobile antennas
  !	IMOB	I 	Antenna
  !	ICODE	I	1,2,3 = Focus, Az, El
  !	CLEA	L	Reset plot
  !	CHAIN	C	Header
  !	NP	I 	Number of data points
  !	GAIN	R*4(NP)	Gain values
  !	POSI	R*4(NP) Position values
  !	WEIG 	R*4(NP) Weights
  !	CHAIN	C*(*)	X Axis Label
  !       LIMIT   C*(*)   Limits command
  !---------------------------------------------------------------------
  integer :: nmob                   !
  integer :: imob                   !
  integer :: iant                   !
  integer :: icode                  !
  logical :: clea                   !
  character(len=*) :: chain         !
  integer :: np                     !
  real :: gain(np)                  !
  real :: posi(np)                  !
  real :: weig(np)                  !
  character(len=*) :: limit         !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  ! Local
  character(len=10) :: label(3)
  character(len=132) :: ch, ch2,ch3
  real :: b1, b2, b3, b4, bx1, bx2, bx3, bx4
  parameter (b1=0.15,b2=0.9,b3=0.15,b4=0.90)
  integer :: i, lch
  ! Data
  data label/'Focus (mm)','Az pos.(`)','El pos(`)'/
  !------------------------------------------------------------------------
  ! Code:
  if (clea) then
    call gtclear
    write(ch,1000) b1, b2, b3, b4
    call gr_exec1('SET VIEW '//ch(1:lenc(ch)))
    call gr_exec1(chain)
    lch = 9
    ch2(1:9) = 'BB used: '
    do i = 1, l_baseband(1)
       ch2(lch:) = r_bbname(i_baseband(i,1))(1:4)//' '
       lch = lch+4
    enddo
    write(ch3,'(A,F4.2,A)') 'DRAW TEXT 0 ',0.8,' "'
    call gr_exec1 (ch3(1:18)//ch2(1:lch)//'" 9 /BOX 7')
  endif
  if (icode.eq.1) then
    bx1 = b1
    bx2 = b2
  else
    bx1 = b1+(b2-b1)/2*(icode-2)
    bx2 = b1+(b2-b1)/2*(icode-1)
  endif
  bx4 = b4-(b4-b3)/nmob*(imob-1)
  bx3 = b4-(b4-b3)/nmob*imob
  write(ch,1000) bx1, bx2, bx3, bx4
1000 format(4(1x,f4.2))
  call gr_exec1 ('SET VIEW '//ch(1:lenc(ch)))
  call gr4_give ('X',np,posi)
  call gr4_give ('Y',np,gain)
  call gr8_blanking(blank8,d_blank8)
  do i=1, np
    if (weig(i).gt.0) then
      weig(i) = 1e-3/sqrt(weig(i))
    endif
  enddo
  call gr4_give ('Z',np,weig)
  call gr_exec1(limit)
  if (icode.le.2) then
    call gr_exec1('AXIS YL')
    write(ch,'(i0)') iant
    call gr_exec1('LABEL "A'//ch(1:lenc(ch))//'" /Y')
    call gr_exec1('AXIS YR /LABEL NONE')
  else
    call gr_exec1('AXIS YL /LABEL NONE')
    call gr_exec1('AXIS YR /LABEL O')
  endif
  if (imob.eq.nmob) then
    call gr_exec1('LABEL "'//label(icode)//'" /X')
    call gr_exec1('AXIS XL /LABEL P')
  else
    call gr_exec1('AXIS XL /LABEL N')
  endif
  call gr_exec1('AXIS XU')
  call gr_exec1('POINTS')
  if (limit.ne.'LIMITS') call gr_exec1('ERROR Y')
  do i=1, np
    if (weig(i).gt.0) then
      weig(i) = 1e-6/weig(i)**2
    endif
  enddo
end subroutine plot_point
!
subroutine  pro_point(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! CLIC
  !	Support routine for SOLVE POINTING/PLOT
  !	Plots fit result
  ! Arguments
  !	ERROR 	L 	Logical error flag
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  real :: progauss
  include 'gbl_pi.inc'
  ! Local
  integer :: mx, i
  parameter (mx=100)
  real :: x(mx), y(mx), xmin, xmax
  !
  call gr_segm('FIT',error)
  call sic_get_real('USER_XMIN', xmin,error)
  call sic_get_real('USER_XMAX', xmax,error)
  if (error) return
  do i=1, mx
    x(i) = (xmax-xmin)/(mx-1.)*(i-1) + xmin
    y(i) = progauss (x(i),1)   !!*pi/180./3600.,1)
  enddo
  call gr4_connect (mx, x, y, 0.,-1.)
  call gr_segm_close(error)
end subroutine pro_point
!
subroutine load_beam (beam, bsize, lo1, nant)
  use gildas_def
  use classic_api  
  real :: beam                      !
  real :: bsize                     !
  real :: lo1                       !
  integer :: nant                   !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  ! Local
  integer :: i,j
  real*4 :: freq, fif1
  !
  if (beam.lt.0.0) then
    if (l_baseband(1).ne.0) then
      do i=1, l_baseband(1)
        j = i_baseband(i,1)
        fif1 = fif1+r_flo2(j)+r_band2(j)*(r_flo2bis(j) + &
                    r_band2bis(j)*r_lfcen(j))
      enddo
      fif1 = fif1/l_baseband(1)
    else
      fif1 = r_fif1
    endif
    if (n_band.eq.0 .or. i_band(1).eq.3) then
      freq = lo1               ! Sideband average
    elseif (i_band(1).eq.1) then
      freq = lo1+fif1      ! Upper sideband
    else
      freq = lo1-fif1      ! Lower sideband
    endif
    bsize = 41.0*115.0e3/freq  ! In arcseconds
    if (nant.lt.3) bsize = bsize*sqrt(2.0)
  elseif (beam.eq.0.0) then
    bsize = 0.0
  else
    bsize = beam
    if (nant.lt.3) bsize = bsize*sqrt(2.0)
  endif
end subroutine load_beam
!
subroutine check_scan(lun,iscan,measure)
  integer :: lun                    !
  integer :: iscan                  !
  character(len=*) :: measure       !
  ! Local
  character(len=8) :: pacifyf77
  !-----------------------------------------------------------------------
  pacifyf77=measure
  write(lun,100) 'IF SCAN-',iscan,'.GT.10 THEN'
  write(lun,100)   &
    '  SAY "_ '//pacifyf77//' is more than 10 scans old."'
  write(lun,100) '  DEFINE LOGICAL GO'
  write(lun,100) '  LET GO /PROMPT "Use anyway ?"'
  write(lun,100) '  IF .NOT.GO THEN'
  write(lun,100) '    RETURN'
  write(lun,100) '  ENDIF'
  write(lun,100) 'ENDIF'
100 format(a,i4.4,a)
  return
end subroutine check_scan
!
subroutine fit_point (npt,gain,posi,weig,pars,errs,beam,error)
  !---------------------------------------------------------------------
  ! CLIC
  !	Support routine for SOLVE POINTING
  ! 	Determine pointing parameters from a drift
  ! Arguments:
  !	NPT	I	Number of points in drift
  !	GAIN	R*4(Np)	Antenna gains
  !	POSI	R*4(Np)	Antenna positions
  !	WEIG	R*4(Np)	Minimization weights
  !	PARS	R*4(3)	Fitted parameters
  !	ERRS	R*4(3)	Fitted errors
  !	BEAM	R*4	Beam size (Radians)
  !---------------------------------------------------------------------
  integer :: npt                    !
  real :: gain(npt)                 !
  real :: posi(npt)                 !
  real :: weig(npt)                 !
  real :: pars(3)                   !
  real :: errs(3)                   !
  real :: beam                      !
  logical :: error                  !
  ! Global
  external :: mingauss
  include 'clic_parameter.inc'
  include 'clic_point.inc'
  include 'clic_gauss.inc'
  include 'clic_gaussdata.inc'
  include 'clic_fit.inc'
  include 'gbl_pi.inc'
  ! Local
  character(len=12) :: chain
  integer :: i,ier
  real :: sw,zzer,wzer,zinf,winf,zsup,wsup,offset,ao,aw,ak,ap
  !------------------------------------------------------------------------
  ! Code:
  nline = 1
  !
  ! Find starting parameters
  ndata = 0
  sw = 0
  if (iproc.le.1) then
    bavard = .true.
    do i = 1, npt
      if (weig(i).gt.0) then
        ndata = ndata + 1
        rdatax(ndata) = posi(i)
        rdatay(ndata) = gain(i)
        wfit(ndata) = sqrt(weig(i))
        sw = sw + wfit(ndata)
      endif
    enddo
    if (ndata.le.0) then
      call message(8,4,'FIT_POINT','No valid data point')
      error = .true.
      return
    endif
    do i=1, ndata
      wfit(i) = wfit(i)/sw*ndata
    enddo
    call inigauss
    if (beam.ne.0) then
      par(3) = beam
      kd1 = 1                  ! Fix the beam width
    else
      kd1 = 0                  !
    endif
    spar(1) = par(1)           ! Area
    spar(2) = par(2)           ! Position
    spar(3) = par(3)           ! Beam
    spar(1) = spar(1)/spar(3)/1.064467 ! Peak value
    call fitgauss (mingauss,.false.,ier)
    if (iproc.eq.0) then
      chain = 'SOLVE_POINT'
    else
      chain = 'SOLVE_FOCUS'
    endif
  else
    bavard = .false.
    zzer = 0
    wzer = 0
    zinf = 0
    winf = 0
    zsup = 0
    wsup = 0
    offset = 0
    do i=1,npt
      if (weig(i).gt.0) then
        ndata = ndata + 1
        rdatax(i) = posi(i)
        rdatay(i) = gain(i)
        offset = max(offset,abs(rdatax(i)))
        wfit(i) = weig(i)
        sw = sw + wfit(i)
        if (posi(i).lt.0) then
          zinf = zinf+wfit(i)*rdatay(i)
          winf = winf+wfit(i)
        elseif (posi(i).eq.0) then
          zzer = zzer+wfit(i)*rdatay(i)
          wzer = wzer+wfit(i)
        else
          zsup = zsup+wfit(i)*rdatay(i)
          wsup = wsup+wfit(i)
        endif
      endif
    enddo
    if (ndata.le.0) then
      call message(8,4,'FIT_POINT','No valid data point')
      error = .true.
      return
    endif
    do i=1, npt
      wfit(i) = wfit(i)/sw*ndata
    enddo
    zzer = zzer/wzer
    zsup = zsup/wsup
    zinf = zinf/winf
    ak = log(zsup/zinf)
    if (beam.ne.0) then
      par(3) = beam
      kd1 = 1                  ! Fix the beam width
      aw = par(3)/offset
      ap = log(zzer**2/(zinf*zsup))
      write(*,*) ' Width ',   &
        sqrt(2.0/ap)*offset*2.0*sqrt(log(2.0)),par(3)
      !??
      if (iproc.eq.1) then
        ao = 0.25*aw**2*ak
      else
        ao = 0.5*ak/ap
      endif
    else
      kd1 = 0                  !
      ap = log(zzer**2/(zinf*zsup))
      ao = 0.5*ak/ap
      aw = sqrt(2.0/ap)
      par(3) = aw*2.0*sqrt(log(2.0))*offset
    endif
    par(2) = ao*offset
    par(1) = par(3)*max(zsup,zinf,zzer)
    err(1) = 1e-3/sqrt(sw)*par(3)  ! Error on area
    err(2) = 1e-3*sqrt(sw)/par(1)  ! Error on position
    do i=1,4
      spar(1) = par(1)         ! Area
      spar(2) = par(2)         ! Position
      spar(3) = par(3)         ! Beam
      spar(1) = spar(1)/spar(3)/1.064467   ! Peak value
      call fitgauss (mingauss,.true.,ier)
    enddo
    chain = 'SOLVE_FIVE'
  endif
  if (ier.lt.0) then
    call message(6,3,chain,'Error on input parameters')
    error = .true.
  elseif (ier.eq.3) then
    call message(6,3,chain,'Solution not converged')
    error = .false.
  elseif (ier.ne.0) then
    call message(6,3,chain,'Bad Solution')
    error = .true.
  else
    error = .false.
  endif
  do i=1,3
    pars(i) = par(i)
    errs(i) = err(i)
  enddo
end subroutine fit_point
!
subroutine fill_visi_posi (qdump,qbas,qant,visi,posi,weig,   &
    time_max,data,error)
  use gildas_def
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! Read the data section and extract the visibilities for all baselines
  ! and the positions of all antennas
  ! Arguments:
  !	R 	Struc.	Header
  !	VISI	R*4(*)	Visibilities to be returned
  !	POSI	R*4(*)	"Position" of antenna. The "position"
  !			is actually a parameter defined by R.SCATY
  !	WEIG	R*4(*)	Weights to be returned
  !---------------------------------------------------------------------
  integer :: qdump                  !
  integer :: qbas                   !
  integer :: qant                   !
  real :: visi(qdump,qant)          !
  real :: posi(qdump,qant)          !
  real :: weig(qdump,qant)          !
  real :: time_max                  !
  real :: data(*)                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local variables:
  logical :: change
  integer :: iband, ibas, ir, iant, ix, iy, jw1, jw2, ivt, ipol, kb, kif
  integer :: iv, im, kr
  real :: vta(4,3,mnant), wta(4,3,mnant), vtb(4,3,mnbas)
  real :: wtb(4,3,mnbas), wbas(mnbas), want(mnant), dtmax
  integer(kind=address_length) :: k, kc, kl
  integer(kind=data_length) :: h_offset, c_offset, l_offset
  complex :: zbas(mnbas), zant(mnant)
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Select band UPPER LOWER or AVERAGE
  ipol = 1 ! Not used, but for consistent call to brecord
  kb   = 1 ! Not used, but for consistent call to brecord
  kif  = 1 ! idem 
  if (n_band.ne.1) then
    call message(6,2,'FILL_VISI_POSI',   &
      'Using only first selected Band')
  endif
  iband = i_band(1)
  if (iband.eq.4) then
    call message(6,2,'FILL_VISI_POSI',   &
      'Sideband Ratio invalid in this context')
    error = .true.
    return
  endif
  !
  ! Select subbands and channels to be averaged
  jw1 = iw1(1)
  jw2 = iw2(1)
  call check_subb(1,.true.,error)
  if (error) goto 999
  iy = 1                       ! Amplitude
  if (r_scaty.eq.1) then
    ix = 78                    ! Focus
  elseif (r_scaty.eq.2) then
    ix = 76                    ! Lambda
  elseif (r_scaty.eq.3) then
    ix = 77                    ! Beta
  elseif (r_scaty.eq.6) then
    ix = 76                    ! Lambda first, Then Beta
  endif
  !
  if (do_pass) then
    call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, passc, passl, error)
    if (error) goto 999
  endif
  !
  do ibas = 1, r_nbas
    !     im = 1 (time weight) 2 (tsys weight) 3 (phase rms weighting)
    !     iv = 1 (X value) 2 (Y value) 3 (real part) 4 (imag part)
    do iv=1,4
      do im=1,3
        vtb(iv,im,ibas) = 0
        wtb(iv,im,ibas) = 0
      enddo
    enddo
  enddo
  do iant = 1, r_nant
    do iv=1,4
      do im=1,3
        vta(iv,im,iant) = 0
        wta(iv,im,iant) = 0
      enddo
    enddo
  enddo
  ivt = 0
  !
  ! Loop on records
  call spectral_dump(kr,0,0)
  do ir = 1, r_ndump
    k = h_offset(ir)+1
    call decode_header (data(k))
    if (ir.eq.1) then
      call set_scaling(error)
      if (error) return
    endif
    kc = 1 + c_offset(ir)
    dtmax = 0
    do iant = 1, r_nant
      call spectral_dump(kr,iant,0)
      kl = 1 + l_offset(kr)
      call arecord (   &
        r_nsb, r_nband, r_nbas, r_lntch,   &
        data(kc), data(kl), passc, passl,   &
        iant, iband, ipol, kb, kif, l_subb(1), i_subb(1,1),jw1,jw2,ix,iy,   &
        vta(1,1,iant),wta(1,1,iant),.false.,error)
      dtmax = max(dtmax,wta(1,1,iant))
      if (error) goto 999
    enddo
    do ibas = 1, r_nbas
      call spectral_dump(kr,0,ibas)
      kl = 1 + l_offset(kr)
      call brecord (   &
        r_nsb, r_nband, r_nbas, r_lntch,   &
        data(kc), data(kl), passc, passl,   &
        ibas, iband, ipol, kb, kif, l_subb(1), i_subb(1,1),jw1,jw2,ix,iy,   &
        vtb(1,1,ibas),wtb(1,1,ibas),error)
      if (error) goto 999
    enddo
    if (dtmax.ge.time_max   &
      .or. (dtmax.gt.0 .and. ir.eq.r_ndump)) then
      ivt = ivt+1
      do ibas = 1, r_nbas
        if (wtb(3,2,ibas).gt.0) then
          zbas(ibas) = cmplx(vtb(3,2,ibas),vtb(4,2,ibas))   &
            /wtb(3,2,ibas)
        endif
        wbas(ibas) = wtb(1,2,ibas)
      enddo
      call antgain(zbas,wbas,zant,want)
      do iant = 1, r_nant
        weig(ivt,iant) =  want(iant)
        visi(ivt,iant) = abs(zant(iant))
        if (wta(1,2,iant).gt.0) then
          posi(ivt,iant) = vta(1,2,iant)/wta(1,2,iant)
        endif
        if (wta(1,2,iant).eq.0 .or. wta(2,2,iant).eq.0   &
          .or. want(iant).eq.0 ) then
          visi(ivt,iant) = blank4
          posi(ivt,iant) = 0
          weig(ivt,iant) = 0
        endif
        do iv=1,4
          do im=1,3
            vta(iv,im,iant) = 0
            wta(iv,im,iant) = 0
          enddo
        enddo
      enddo
      do ibas = 1, r_nbas
        do iv=1,4
          do im=1,3
            vtb(iv,im,ibas) = 0
            wtb(iv,im,ibas) = 0
          enddo
        enddo
      enddo
    endif
    !
    ! Change scanning direction if on (0,0) for Five-Points
    if (r_scaty.eq.6) then
      change = .true.
      do iant=1,r_nant
        if (posi(ir,iant).ne.0.0) change = .false.
      enddo
      if (change) ix = 77
    endif
  enddo
  if (qdump.gt.ivt) then
    do iant = 1, r_nant
      do ir=ivt+1, qdump
        posi(ir,iant) = 0
        visi(ir,iant) = 0
        weig(ir,iant) = 0
      enddo
    enddo
  endif
  !
  return
  !
999 error = .true.
  return
end subroutine fill_visi_posi
!
      subroutine refrac(refraction)
      use classic_api  
!----------------------------------------------------------------------
!       cette subroutine calcule les coefficients de la refraction
!       atmospherique (copiee de obs.)
!
!       les parametres d'entree sont :
!
!               tambia  = temperature ambiante en k ( 223 < tambia <  323   )
!               humidi  = humidite relative (%)     (   0 < humidi <  100   )
!               pambia  = pression in mbar          ( 690 < pambia <  790   )
!
!       les parametres de sortie sont :
!               refrc1,refrc2,refrc3
!               la formule utilisee est
!               refr = refrc1/tan(el.)+refrc2/tan(el.)**3+refrc3/tan(el.)**5
!
!       pour la refraction radio on utilise la formule suivante
!       waters, j.w. 1976, in methods of experimental physics
!       vol 12, part b, pag. 186.
!
!       n = (77.6 pambia/tambia+ 3.73e05 e/tambia**2)*10e-06 radians
!
!       ou e est la pression partielle de la vapeur d'eau donnee par
!       e=es*humidi/100./(1-(1-humidi/100.)*es/pambia) mbar
!       ou es est la pression de saturation de la vapeur d'eau donnee par
!       es=6.105*exp(25.22*(tambia-273)/tambia-5.31*ln(tambia/273)) mbar
!
!       par example, pambia=1013, tambia=273, humidi=90
!       es=6.105 mbar
!       e=5.491 mbar
!       n=59.39" + 5.67" (contribution de la vapeur d'eau)
!---------------------------------------------------------------------- 
      real refraction(3)
!
      include 'clic_parameter.inc'
      include 'clic_par.inc'
!
      real tmin, tmax, pmin, pmax, hmin, hmax
      real hum, alpha, alpha0, beta, beta0, es, e
      real alphad, alphaw, betad, betaw, c1d, c1w
      real c2d, c2w, c3d, c3w
      data tmin/223./,tmax/323./
      data pmin/690./,pmax/790./
      data hmin/0./hmax/100./
      data alpha0/0.00029255/,beta0/.001254/
      character text*80
!
      if((r_tamb.lt.tmin.or.r_tamb.gt.tmax).or.   &
        (r_pamb.lt.pmin.or.r_pamb.gt.pmax).or.    &
        (r_humid.lt.hmin.or.r_humid.gt.hmax))then
         if (r_tamb.lt.tmin.or.r_tamb.gt.tmax) &
             call message (6,3,'meteo',  &
             'ambient temperature out of limits')
         if (r_pamb.lt.pmin.or.r_pamb.gt.pmax) &
             call message (6,3,'meteo', &
             'ambient pressure out of limits')
         if (r_humid.lt.hmin.or.r_humid.gt.hmax) &
             call message (6,3,'meteo', &
             'ambient humidity out of limits')
         return
      endif
      hum=r_humid/100.
! calcul des coefficients de la refraction radio
!
! calcul de la pression de saturation de la vapeur d'eau
      es=6.105*exp(25.22*(r_tamb-273) &
        /r_tamb-5.31*log(r_tamb/273))
!
! calcul de la pression partielle de la vapeur d'eau
      e=es *hum /(1- (1-hum) *es /r_pamb)
!
! calcul des coefficients alpha et beta pour une atmosphere
! seche et une atmosphere contenant de la vapeur d'eau
      alphad=77.6 *r_pamb /r_tamb *1d-06
      alphaw=3.73e-01 *e /r_tamb**2
      betad=beta0 *273 /r_tamb  !identique que pour l'optique
!
!       hauteur caracteristique de la distribution de la vapeur d'eau
!       = 2.5 km et betaw=beta0/hd*2.5, ou hd, l'hauteur
!       caracteristique de l'atmosphere seche (ou de la distribution
!       de densite de n2 et o2) est de 7.99 km
!
      betaw=beta0 /3.2 *273 /r_tamb
!
! maintenant on calcule c1, c2 et c3 pour n2+o2 et pour h2o
      c1d=alphad *(1-betad)
      c1w=alphaw *(1-betaw)
      c2d=-alphad *(betad-alphad/2.)
      c2w=-alphaw *(betaw-alphaw/2.)
      c3d=3 *alphad *(betad -alphad/2.)**2
      c3w=3 *alphaw *(betaw -alphaw/2.)**2
!
! 1 pour radio
      refraction(1) = c1d +c1w
      refraction(2) = c2d +c2w
      refraction(3) = c3d +c3w
!
    end subroutine refrac

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the EPHEM package
! This is a trick to solve the fact that we may want to load only part of
! a package as in the case of ASTRO. The EPHEM name is probably not
! adequate...
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine ephem_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack  !
  !
  external :: atm_pack_set
  external :: ephem_pack_init
  external :: ephem_pack_clean
  !
  pack%name='ephem'
  pack%depend(1:2) = (/ locwrd(atm_pack_set), locwrd(greg_pack_set) /)
  pack%init=locwrd(ephem_pack_init)
  pack%clean=locwrd(ephem_pack_clean)
  pack%authors="J.Boissier, J.Pety"
  !
end subroutine ephem_pack_set
!
subroutine ephem_pack_init(gpack_id,error)
  !----------------------------------------------------------------------
  ! @ private
  !
  !----------------------------------------------------------------------
  integer(kind=4) :: gpack_id       !
  logical :: error                  !
  !
  call atm_message_set_id(gpack_id)
#if defined(ATM2009)
  call atm_c_message_set_id(gpack_id)
#endif
#if defined(ATM2016)
  call atm_c_message_set_id(gpack_id)
#endif
  call astro_message_set_id(gpack_id)
  !
  ! Specific initializations
  call ephini(error)
  if (error) return
  !
end subroutine ephem_pack_init
!
subroutine ephem_pack_clean(error)
  !----------------------------------------------------------------------
  ! @ private
  !
  !----------------------------------------------------------------------
  logical, intent(inout) :: error   !
  !
  call ephclose(error)
  !
end subroutine ephem_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the ASTRO package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine astro_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ public
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack  !
  !
  external :: astro_pack_init
  external :: astro_pack_clean
  !
  pack%name='astro'
  pack%ext='.astro'
  pack%depend(1:1) = (/ locwrd(greg_pack_set) /)
  pack%init=locwrd(astro_pack_init)
  pack%clean=locwrd(astro_pack_clean)
  pack%authors="J.Boissier, F.Gueth, J.Pety"
  !
end subroutine astro_pack_set
!
subroutine astro_pack_init(gpack_id,error)
  !----------------------------------------------------------------------
  ! @ private
  !
  !----------------------------------------------------------------------
  integer(kind=4) :: gpack_id       !
  logical :: error                  !
  !
  call atm_message_set_id(gpack_id)
#if defined(ATM2009)
  call atm_c_message_set_id(gpack_id)
#endif
#if defined(ATM2016)
  call atm_c_message_set_id(gpack_id)
#endif
  call astro_message_set_id(gpack_id)
  !
  call load_astro('INTERACTIVE')
  call exec_program('SIC'//char(92)//'SIC PRIORITY 1 ASTRO')
  !
  ! Specific initializations
  call atm_init(error)
  if (error) return
  call astro_init(error)
  if (error) return
  !
end subroutine astro_pack_init
!
subroutine astro_pack_clean(error)
  !----------------------------------------------------------------------
  ! @ private
  !
  !----------------------------------------------------------------------
  logical, intent(inout) :: error   !
  !
  call ephclose(error)
  !
end subroutine astro_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module examine_parameters
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Support module for command SIC\EXAMINE
  !---------------------------------------------------------------------
  logical :: global   ! /GLOBAL
  logical :: header   ! /HEADER
  logical :: address  ! /ADDRESS
  logical :: dopage   ! /PAGE
  logical :: dosave   ! /SAVE
  character(len=filename_length) :: savname  ! Output file for /SAVE
  integer(kind=4) :: savlun=0
  !
  ! Display mode
  integer, parameter :: summary = 1
  integer, parameter :: short   = 2
  integer, parameter :: full    = 3
  integer, parameter :: save    = 4
  !
end module examine_parameters
!
subroutine examine_variable(line,error)
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>examine_variable
  use gbl_message
  use gbl_format
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! SIC  Support routine for command
  ! SIC\EXAMINE [Variable]
  ! 1           [/GLOBAL]
  ! 2           [/FUNCTION]
  ! 3           [/HEADER]
  ! 4           [/ADDRESS]
  ! 5           [/ALIAS]
  ! 6           [/PAGE]
  ! 7           [/SAVE]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: nn,iarg,ier
  character(len=64) :: name
  character(len=filename_length) :: tmpname
  integer(kind=4), parameter :: optglob=1
  integer(kind=4), parameter :: optfunc=2
  integer(kind=4), parameter :: opthead=3
  integer(kind=4), parameter :: optaddr=4
  integer(kind=4), parameter :: optalia=5
  integer(kind=4), parameter :: optpage=6
  integer(kind=4), parameter :: optsave=7
  !
  ! /FUNCTION obsolete since 14-apr-2016
  if (sic_present(optfunc,0)) then
    call sic_message(seve%e,'EXAMINE','/FUNCTION is obsolete, use HELP FUNCTION [Name] instead')
    error = .true.
    return
  endif
  !
  ! /GLOBAL
  global = sic_present(optglob,0)
  !
  ! /ALIAS
  if (sic_present(optalia,0)) then
    call sic_list_alias
    return
  endif
  !
  if (pfvar(27).eq.0) then
    call sic_message(seve%w,'EXAMINE','No known variables')
    return
  endif
  !
  ! /HEADER
  header = sic_present(opthead,0)
  !
  ! /ADDRESS
  address = sic_present(optaddr,0)
  !
  ! /PAGE
  dopage = sic_present(optpage,0)
  !
  ! /SAVE
  dosave = sic_present(optsave,0)
  if (dosave) then
    call sic_ch(line,optsave,1,tmpname,nn,.true.,error)
    if (error)  return
    ! Open new one
    ier = sic_getlun(savlun)
    if (mod(ier,2).eq.0) then
      error=.true.
      return
    endif
    call sic_parse_file(tmpname,' ','.sic',savname)
    ier = sic_open(savlun,savname,'NEW',.false.)
    if (ier.ne.0) then
      call putios('E-SIC, ',ier)
      call sic_output_close(error)
      error = .true.
    endif
  endif
  !
  ! Arguments
  if (sic_present(0,1)) then
    do iarg=1,sic_narg(0)
      call sic_ke(line,0,iarg,name,nn,.true.,error)
      if (error)  return
      call sic_examine(name,error)
      if (error)  return
    enddo
  else
    ! No arguments, list all
    call sic_examine('*',error)
    if (error)  return
  endif
  !
  ! /SAVE
  if (savlun.ne.0) then
    ! Close the unit
    ier = sic_close(savlun)
    if (ier.ne.0) then
      call putios('E-SAY, ',ier)
      error = .true.
      ! continue
    endif
    !
    ! Free the unit
    call sic_frelun(savlun)
    savlun = 0
  endif
  !
end subroutine examine_variable
!
subroutine sic_examine(name,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_examine
  use sic_structures
  use sic_dictionaries
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Support subroutine for command SIC\EXAMINE
  ! Given an input name or pattern, list one or all associated
  ! variables. Verbosity relies on the kind of input.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   ! Name or pattern to find
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: list(maxvar),vtype,ivar,in,level,nn,ik,tt_lines
  integer(kind=4) :: nlisted,first,last,step
  logical :: notastruct,wilcarded,verbose_struct
  !
  nn = len_trim(name)
  verbose_struct = nn.ge.2 .and. name(nn-1:nn).eq.'%*'
  if (verbose_struct)  nn = nn-1   ! Strip the *
  notastruct = name(nn:nn).ne.'%'
  wilcarded = index(name(1:nn),'*').ne.0
  tt_lines = sic_ttynlin()-1
  !
  if (notastruct .and. .not.wilcarded) then
    ! Input name is a standard variable
    if (dosave) then
      call sic_examine_save(name,error)
    elseif (address) then
      call sic_examine_summary(name,error)
    else
      call sic_examine_full(name,error)
      if (error) call sic_exambigs(name,error)
    endif
    !
  elseif (.not.wilcarded) then
    ! Input name is a structure
    !
    call sic_examine_short(name(1:nn-1),error)
    if (error)  return
    !
    call sic_examine_type(name(1:nn-1),vtype,error)
    if (error)  return
    if (vtype.eq.8) then
      ! Special case for Header and Images:
      ! 1) Turn on full verbose mode
      verbose_struct = .true.
      ! 2a) Use the unsorted list (i.e. keep the list as it was defined;
      !     note that this is a side effect of the way hashing is done
      !     today, this may not work anymore when hashing is modified).
      call gag_haslis(maxvar,pfvar,pnvar,list,in)
      ! 2b) Revert the list, so that we see the first defined first
      first = in
      last = 1
      step = -1
    else
      ! Other structures: sort alphabetically
      call sic_hassort(maxvar,pfvar,pnvar,dicvar,list,in)
      first = 1
      last = in
      step = +1
    endif
    !
    ! Loop over all variables
    nlisted = 0
    do ivar=first,last,step
      ik = list(ivar)
      !
      ! Check name
      if (name(1:nn).ne.dicvar(ik)%id%name(1:nn))  cycle  ! Next variable
      !
      nlisted = nlisted+1
      if (dopage) then
        if (mod(nlisted,tt_lines).eq.0) then
          if (hlp_more().ne.0)  return
        endif
      endif
      !
      if (dosave) then
        call sic_examine_save(dicvar(ik)%id%name,error)
      elseif (address) then
        call sic_examine_summary(dicvar(ik)%id%name,error)
      else
        if (verbose_struct) then
          ! Short output for %U and %V which are too long in UVDATA
          if (dicvar(ik)%id%name(nn:nn+2).eq.'%U ' .or.  &
              dicvar(ik)%id%name(nn:nn+2).eq.'%V ') then
            call sic_examine_short(dicvar(ik)%id%name,error)
          else
            ! i.e. fully examine this member of the structure
            call sic_examine_full(dicvar(ik)%id%name,error)
          endif
        else
          ! Valued output, in one line
          call sic_examine_short(dicvar(ik)%id%name,error)
        endif
      endif
    enddo
    !
  else
    ! Wilcarded search
    if (global) then
      level = 0
    else
      level = var_level
    endif
    !
    ! Check if one is listing all variables
    call sic_hassort(maxvar,pfvar,pnvar,dicvar,list,in)
    nlisted = 0
    do ivar=1,in
      ik = list(ivar)
      !
      ! Check name
      if (.not.match_string(dicvar(ik)%id%name(1:dicvar(ik)%id%lname),name(1:nn)))  &
                                                 cycle  ! Next variable
      !
      ! Check level
      if (dicvar(ik)%id%level.ne.level)          cycle  ! Next variable
      !
      ! List only variable having a header (/HEADER)
      if (header .and. dicvar(ik)%desc%status.le.0)  cycle  ! Next variable
      !
      ! Drop structure members, but not structure itself.
      ! Be carefull: I want the output when typing EXA SIC%IN*
      if (index(dicvar(ik)%id%name,'%').ne.0 .and.  &  ! Found a structure member
          index(name,'%').eq.0)                     &  ! but the pattern has no '%'
        cycle  ! Next variable
      !
      ! Ok, examine it
      nlisted = nlisted+1
      if (dopage) then
        if (mod(nlisted,tt_lines).eq.0) then
          if (hlp_more().ne.0)  return
        endif
      endif
      !
      call sic_examine_brief(ik,error)
      if (error)  return
      !
    enddo
  endif
  !
end subroutine sic_examine
!
subroutine sic_examine_brief(ik,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_examine_brief
  use sic_dictionaries
  use gbl_format
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command SIC\EXAMINE
  ! Print out in short format e.g.
  ! PI              DOUBLE                                       GBL,RD
  !---------------------------------------------------------------------
  integer, intent(in)    :: ik     ! Variable index in dicvar
  logical, intent(inout) :: error  ! Error flag
  ! Local
  integer :: ls,ms,ird
  character(len=2) :: status
  character(len=132) :: msg
  character(len=2) :: rd(2)
  ! Data
  data rd /'RD','WR'/
  !
  ls = dicvar(ik)%id%lname
  ms = 15
  do while (ms.lt.ls)
    ms = ms+8
  enddo
  ls=ms  ! Short variable names will be nicely listed
  if (dicvar(ik)%desc%readonly) then
    ird = 1
  else
    ird = 2
  endif
  !
  call sic_examine_strtype_byid(ik,msg)
  !
  if (address) then
    if (dicvar(ik)%id%level.eq.0) then
      status = 'G'
    else
      write(status,'(I0)') dicvar(ik)%id%level
    endif
    write(6,110) dicvar(ik)%id%name(1:ls),status,trim(msg),  &
      dicvar(ik)%desc%type,     &
      dicvar(ik)%desc%addr,     &
      dicvar(ik)%desc%ndim,     &
      dicvar(ik)%desc%dims(:),  &
      dicvar(ik)%desc%size,     &
      dicvar(ik)%desc%status
  else
    if (dicvar(ik)%id%level.eq.0) then
      write (6,100) dicvar(ik)%id%name(1:ls),trim(msg),'GBL,',rd(ird)
    else
      write(status,'(I0)') dicvar(ik)%id%level
      write (6,109) dicvar(ik)%id%name(1:ls),trim(msg),'LCL('//status//'),',rd(ird)
    endif
  endif
  !
100 format(a,1x,a,t72,a,a,a)
109 format(a,1x,a,t69,a,a,a)
110 format(a,1x,a,a,i5,2x,i0,i2,7(2x,i0),2x,i0,i3)  ! This format for sic_maxdims==7
  !
end subroutine sic_examine_brief
!
subroutine sic_examine_strtype_byname(varname,global,verbose,chain,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_examine_strtype_byname
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !   Return a type description suited e.g. for EXAMINE. See
  ! sic_examine_strtype_byid for examples
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: varname  ! Variable name
  logical,          intent(in)    :: global   ! Search for global or local?
  logical,          intent(in)    :: verbose  ! Verbose in case of error?
  character(len=*), intent(out)   :: chain    !
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='EXAMINE'
  integer(kind=4) :: ier,in
  type(sic_identifier_t) :: var
  !
  chain = ""
  !
  ! Should we parse name from dimensions? See sic_parse_dim
  var%name = varname
  var%lname = len_trim(varname)
  if (global) then
    var%level = 0
  else
    var%level = var_level
  endif
  !
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    if (verbose)  &
      call sic_message(seve%e,rname,'No such variable '//varname)
    error = .true.
    return
  endif
  !
  call sic_examine_strtype_byid(in,chain)
  !
end subroutine sic_examine_strtype_byname
!
subroutine sic_examine_strtype_byid(ik,msg)
  use gbl_format
  use sic_interfaces, except_this=>sic_examine_strtype_byid
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Return a type description suited e.g. for EXAMINE. Examples:
  !    LOGICAL
  !    CHARACTER*64
  !    INTEGER[3,4]
  !    (STRUCTURE)
  !    (IMAGE)REAL[512,512]
  !    etc
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: ik   ! Position in global dictionary
  character(len=*), intent(out) :: msg  ! Returned string
  ! Local
  character(len=12) :: stype,what(10)
  integer(kind=4) :: j,utype,n
  ! Data
  data what /'REAL','DOUBLE','INTEGER','LONG','LOGICAL','CHARACTER',  &
             'COMPLEX','(HEADER)','(STRUCTURE)','(TABLE)'/
  !
  msg = ' '
  n = 1
  utype = 0
  if (dicvar(ik)%desc%status.gt.0) then
    stype = '(IMAGE)'
  else
    stype = ' '
  endif
  !
  if (dicvar(ik)%desc%type.eq.0) then
    if (dicvar(ik)%desc%status.gt.0) then
      utype = 8
      write(msg,104) what(utype)
    else
      utype = 9
      write(msg,104) what(utype)
    endif
  elseif (dicvar(ik)%desc%type.gt.0) then
    utype = 6
    write(msg,102) trim(stype),trim(what(utype)),dicvar(ik)%desc%type
  else
    if (dicvar(ik)%desc%type.eq.fmt_r4) then
      utype = 1
    elseif (dicvar(ik)%desc%type.eq.fmt_r8) then
      utype = 2
    elseif (dicvar(ik)%desc%type.eq.fmt_i4) then
      utype = 3
    elseif (dicvar(ik)%desc%type.eq.fmt_i8) then
      utype = 4
    elseif (dicvar(ik)%desc%type.eq.fmt_l) then
      utype = 5
    elseif (dicvar(ik)%desc%type.eq.fmt_c4) then
      utype = 7
    endif
    write(msg,103) trim(stype),what(utype)
  endif
  !
  n = len_trim(msg)
  if (dicvar(ik)%desc%ndim.gt.0) then
    write(msg(n+1:),101) (dicvar(ik)%desc%dims(j),j=1,dicvar(ik)%desc%ndim)
    n = len_trim(msg)
    msg(n:n)=']'
  endif
  !
101 format('[',i0,',',i0,',',i0,',',i0,',',i0,',',i0,',',i0,']')
102 format(a,a,'*',i0)
103 format(a,a)
104 format(a)
end subroutine sic_examine_strtype_byid
!
subroutine sic_examine_summary(name,error)
  use sic_interfaces, except_this=>sic_examine_summary
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Examine the input variable. Output does not display the value and
  ! must fit in one line.
  ! PI                    ! Double  GLOBAL RO
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   ! Variable to examine
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call sic_examine_print(name,summary,.false.,6,error)
  !
end subroutine sic_examine_summary
!
subroutine sic_examine_short(name,error)
  use sic_interfaces, except_this=>sic_examine_short
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Examine the input variable. Output (tries to) display the value but
  ! must fit in one line, e.g.
  ! SIC%EDITOR      = emacs            ...  ! Character*  256 GLOBAL RO
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   ! Variable to examine
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call sic_examine_print(name,short,.false.,6,error)
  !
end subroutine sic_examine_short
!
subroutine sic_examine_full(name,error)
  use sic_interfaces, except_this=>sic_examine_full
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Examine the input variable. Output can fit in several lines,
  ! e.g. arrays or long strings. Example:
  ! PI              =     3.141592653589793      ! Double  GLOBAL RO
  !---------------------------------------------------------------------
  character(len=*)                :: name   ! Variable to examine
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call sic_examine_print(name,full,.true.,6,error)
  !
end subroutine sic_examine_full
!
subroutine sic_examine_save(name,error)
  use sic_interfaces, except_this=>sic_examine_save
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Examine the input variable. Output is suited for re-execution by Sic
  ! itself. Example:
  ! PI              =     3.141592653589793
  !---------------------------------------------------------------------
  character(len=*)                :: name   ! Variable to examine
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call sic_examine_print(name,full,.false.,savlun,error)
  !
end subroutine sic_examine_save
!
subroutine sic_examine_print(name,mode,incarnable,olun,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_interfaces, except_this=>sic_examine_print
  use sic_types
  use gbl_message
  use gbl_format
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! List the variable of specified name. Output displays the value or
  ! not, on 1 or several lines, depending on the tuned mode.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name        ! Variable to examine
  integer,          intent(in)    :: mode        ! Verbosity mode
  logical,          intent(in)    :: incarnable  ! Incarnations are allowed?
  integer(kind=4),  intent(in)    :: olun        ! Output LUN
  logical,          intent(inout) :: error       ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='EXAMINE'
  logical :: verbose,isscalar,logi
  integer(kind=4) :: lt,ier,in,type,i,ic,ls,inte,nc
  type(sic_dimensions_t) :: spec
  character(len=11) :: text
  integer(kind=address_length) :: ipnt,addr
  type(sic_descriptor_t) :: desc
  character(len=11) :: what
  character(len=12) :: struct_type
  type(sic_identifier_t) :: var
  integer, parameter :: ll=25
  character(len=ll) :: oneline
  character(len=1024) :: bigline
  character(len=:), allocatable :: str
  real*8 :: double
  real*4 :: value,complex(2)
  integer*8 :: long
  !
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .true.   ! e.g. A[3:5] allowed
  spec%do%subset   = .true.   ! e.g. A[2,] allowed
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .true.   ! e.g. A[i][j:k] allowed
  verbose  = .true.
  call sic_parse_dim(name,var,spec,verbose,error)
  if (error) return
  !
  ! Find the variable
  if (var_level.eq.0 .or. global) then
    var%level = 0
    text = 'GLOBAL'
    lt = 8
  else
    var%level = var_level
    write(text,'(A,I2)') 'LOCAL ',var_level
    lt = 10
  endif
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1 .and. var_level.ne.0) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
    text = 'GLOBAL'
    lt = 8
  endif
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'No such variable '//name)
    error =.true.
    return
  endif
  !
  ! Get its incarnation
  call extract_descr(desc,dicvar(in)%desc,spec%done,var%name,incarnable,0,error)
  if (error) then
    if (.not.incarnable)  &
      call sic_message(seve%e,rname,'Incarnation not allowed in this context')
    return
  endif
  !
  ! Kind?
  ! If DESC%OLD = DICVAR(IN)%DESC%OLD, the variable is considered in its entirety:
  what=' Array'
  if (sic_notsamedesc(desc,dicvar(in)%desc))  what=' Sub-Array'
  !
  ! Read-only?
  type = desc%type
  if (desc%readonly)  text(lt:) = 'RO'
  !
  ! Short variable names will be nicely aligned
  ls = len_trim(name)
  if (.not.dosave)  ls = max(15,ls)  ! For alignment cosmetics to screen
  !
  ! Alias?
  if (desc%status.eq.alias_defined) then
    do i=1,nalias
      if (alias(i).eq.in) then
        write (olun,'(A)') name(1:ls)//' is an alias of '//trim(dicali(i)%name)
        exit
      endif
    enddo
  endif
  !
  isscalar = dicvar(in)%desc%ndim.eq.0
  !
  if (type.eq.0) then
    if (desc%status.gt.0) then
      struct_type='! Header'
    else
      ! Retrieve the information associated with the structure name:
      struct_type='! Structure'
    endif
    if (.not.dosave)  &
      write (olun,100) name(1:ls),struct_type,text
  !
  ! CHARACTER
  elseif (type.gt.0) then
    if (dosave) then
      nc = desc%type
      addr = desc%addr
      ic = 1
      do i=1,desc_nelem(desc)
        call destoc(nc,addr,oneline)
        bigline(ic:) = ' "'//trim(oneline)//'"'
        ic = len_trim(bigline)+1
        addr = addr+desc%type
      enddo
      write (olun,102) name(1:ls),' =',bigline(1:ic-1)
    elseif (isscalar) then
      if (mode.eq.short) then  ! Fit in one line
        type = min(type,ll)
        call destoc(type,desc%addr,oneline)
        if (type.gt.ll) oneline(ll-2:ll) = '...'
        write (olun,110) name(1:ls),' = ',oneline,'  ! Character*',desc%type,' ',text
      elseif (mode.eq.full) then
        if (type.gt.ll) then
          write (olun,101) name(1:ls),'       ! Character*',desc%type,' ',text
          allocate(character(desc%type)::str)
          call destoc(desc%type,desc%addr,str)
          write (olun,'(A)') trim(str(1:desc%type))
          deallocate(str)
        else
          call destoc(type,desc%addr,oneline)
          write (olun,102) name(1:ls),' = ',oneline,'  ! Character*',  &
          desc%type,' ',text
        endif
      else
        write (olun,101) name(1:ls),'       ! Character*',desc%type,' ',text
      endif
    else
      write (olun,103) name(1:ls),' is a character*',desc%type,what,  &
      'of dimensions',(desc%dims(i),i=1,desc%ndim)
      if (mode.eq.full) then
        call say_array_ch(desc%addr,desc%type,desc_nelem(desc),'(A)',olun,bigline,.true.,error)
        goto 999
      endif
    endif
  !
  ! LOGICAL
  elseif (type.eq.fmt_l) then
    if (dosave) then
      ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
      ic = 1
      do i=1,desc_nelem(desc)
        call l4tol4(membyt(ipnt),logi,1)
        if (logi) then
          bigline(ic:) = ' yes'
          ic = ic+4
        else
          bigline(ic:) = ' no'
          ic = ic+3
        endif
        ipnt = ipnt+4
      enddo
      write (olun,102) name(1:ls),' =',bigline(1:ic-1)
    elseif (isscalar) then
      if (mode.ge.short) then
        ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
        call l4tol4(membyt(ipnt),logi,1)
        write (olun,104) name(1:ls),' = ',logi,  &
        '                          ! Logical ',text
      else
        write (olun,100) name(1:ls),'       ! Logical ',text
      endif
    else
      write (olun,105) name(1:ls),' is a logical',what,'of dimensions',  &
      (desc%dims(i),i=1,desc%ndim)
      if (mode.eq.full) then
        ipnt = bytpnt(desc%addr,membyt)
        call l_type(desc%size,membyt(ipnt))
      endif
    endif
  !
  ! INTEGER
  elseif (type.eq.fmt_i4) then
    if (dosave) then
      ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
      ic = 1
      do i=1,desc_nelem(desc)
        call i4toi4(membyt(ipnt),inte,1)
        write(bigline(ic:),'(1X,I0)')  inte
        ic = len_trim(bigline)+1
        ipnt = ipnt+4
      enddo
      write (olun,102) name(1:ls),' =',bigline(1:ic-1)
    elseif (isscalar) then
      if (mode.ge.short) then
        ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
        call i4toi4(membyt(ipnt),inte,1)
        write (olun,106) name(1:ls),' = ',inte,'               ! Integer ',text
      else
        write (olun,100) name(1:ls),'       ! Integer ',text
      endif
    else
      write (olun,105) name(1:ls),' is an integer',what,'of dimensions',  &
      (desc%dims(i),i=1,desc%ndim)
      if (mode.eq.full) then
        ipnt = bytpnt(desc%addr,membyt)
        call i4_type(desc%size,membyt(ipnt))
      endif
    endif
  !
  ! LONG
  elseif (type.eq.fmt_i8) then
    if (dosave) then
      ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
      ic = 1
      do i=1,desc_nelem(desc)
        call i8toi8(membyt(ipnt),long,1)
        write(bigline(ic:),'(1X,I0)')  long
        ic = len_trim(bigline)+1
        ipnt = ipnt+8
      enddo
      write (olun,102) name(1:ls),' =',bigline(1:ic-1)
    elseif (isscalar) then
      if (mode.ge.short) then
        ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
        call i8toi8(membyt(ipnt),long,1)
        write (olun,111) name(1:ls),' = ',long,'       ! Long    ',text
      else
        write (olun,100) name(1:ls),'       ! Long    ',text
      endif
    else
      write (olun,105) name(1:ls),' is a long integer',what,'of dimensions',  &
      (desc%dims(i),i=1,desc%ndim)
      if (mode.eq.full) then
        ipnt = bytpnt(desc%addr,membyt)
        call i8_type(desc%size/2,membyt(ipnt))
      endif
    endif
  !
  ! REAL*4
  elseif (type.eq.fmt_r4) then
    if (dosave) then
      ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
      ic = 1
      do i=1,desc_nelem(desc)
        call r4tor4(membyt(ipnt),value,1)
        write(bigline(ic:),'(1X,1PG0.7)')  value
        ic = len_trim(bigline)+1
        ipnt = ipnt+4
      enddo
      write (olun,102) name(1:ls),' =',bigline(1:ic-1)
    elseif (isscalar) then
      if (mode.ge.short) then
        ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
        call r4tor4(membyt(ipnt),value,1)
        write (olun,107) name(1:ls),' = ',value,'            ! Real    ',text
      else
        write (olun,100) name(1:ls),'       ! Real    ',text
      endif
    else
      write (olun,105) name(1:ls),' is a real',what,'of dimensions',  &
      (desc%dims(i),i=1,desc%ndim)
      if (mode.eq.full) then
        ipnt = bytpnt(desc%addr,membyt)
        call r4_type(desc%size,membyt(ipnt))
      endif
    endif
  !
  ! REAL*8
  elseif (type.eq.fmt_r8) then
    if (dosave) then
      ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
      ic = 1
      do i=1,desc_nelem(desc)
        call r8tor8(membyt(ipnt),double,1)
        write(bigline(ic:),'(1X,1PG0.16)')  double
        ic = len_trim(bigline)+1
        ipnt = ipnt+8
      enddo
      write (olun,102) name(1:ls),' =',bigline(1:ic-1)
    elseif (isscalar) then
      if (mode.ge.short) then
        ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
        call r8tor8(membyt(ipnt),double,1)
        write (olun,108) name(1:ls),' = ',double,'  ! Double  ',text
      else
        write (olun,100) name(1:ls),'       ! Double  ',text
      endif
    else
      write (olun,105) name(1:ls),' is a double precision',what,'of dimensions', &
      (desc%dims(i),i=1,desc%ndim)
      if (mode.eq.full) then
        ipnt = bytpnt(desc%addr,membyt)
        call r8_type(desc%size/2,membyt(ipnt))
      endif
    endif
  !
  ! COMPLEX*4
  elseif (type.eq.fmt_c4) then
    if (dosave) then
      write (olun,102) '! ',name(1:ls),' = ?  ! Complex values not available'
    elseif (isscalar) then
      if (mode.ge.short) then
        ipnt = bytpnt(dicvar(in)%desc%addr,membyt)
        call c4toc4(membyt(ipnt),complex,1)
        write (olun,109) name(1:ls),' = ',complex(1),complex(2),  &
        '  ! Complex ',text
      else
        write (olun,100) name(1:ls),'       ! Complex  ',text
      endif
    else
      write (olun,105) name(1:ls),' is a complex',what,'of dimensions',  &
      (desc%dims(i),i=1,desc%ndim)
      if (mode.eq.full) then
        ipnt = bytpnt(desc%addr,membyt)
        call c4_type(desc%size/2,membyt(ipnt))
      endif
    endif
  !
  ! Unknown
  else
    call sic_message(seve%e,rname,'Invalid data format, internal logic error')
  endif
  !
  if (address) then
    ! Print out the descriptor + level
    write(olun,'(A,T28,3(I0,2X))')      'Data type, address, size:',desc%type,desc%addr,desc%size
    write(olun,'(A,T28,L)')             'Header associated:',associated(desc%head)
    write(olun,'(A,T28,8(I0,2X))')      'Ndim, dims:',desc%ndim,desc%dims(:)  ! This format for sic_maxdims==7
    write(olun,'(A,T28,I0,2X,L,2X,I0)') 'Status, read-only, level:',desc%status,desc%readonly,var%level
  endif
  !
  ! Remove scracth memory returned by extract_descr...
999 call sic_volatile(desc)
  return
  !
100 format (20(a))
101 format (a,a,i0,a,a)
102 format (a,a,a,a,i2,a,a)
103 format (a,a,i0,a,a,7(2x,i0))  ! This format for sic_maxdims==7
104 format (a,a,l1,a,a)
105 format (a,a,a,a,7(2x,i0))  ! This format for sic_maxdims==7
106 format (a,a,i12,a,a)   ! 1 standard integer
111 format (a,a,i20,a,a)   ! 1 long integer
107 format (a,a,1pg15.7,a,a)
108 format (a,a,1pg25.16,a,a)
109 format (a,a,'(',1pg15.7,',',1pg15.7,')',a,a)
110 format (a,a,a,a,i0,a,a)
end subroutine sic_examine_print
!
subroutine sic_examine_type(name,utype,error)
  use sic_interfaces, except_this=>sic_examine_type
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! List the variable of specified name, Local and Globals
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name    !
  integer,          intent(out)   :: utype   !
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='EXAMINE'
  integer(kind=4) :: in,ier,type
  logical :: verbose
  type(sic_identifier_t) :: var
  type(sic_descriptor_t) :: desc
  type(sic_dimensions_t) :: spec
  !
  utype = 0
  !
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .true.   ! e.g. A[3:5] allowed
  spec%do%subset   = .true.   ! e.g. A[2,] allowed
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .true.   ! e.g. A[i][j:k] allowed
  verbose  = .true.
  call sic_parse_dim(name,var,spec,verbose,error)
  if (error) return
  !
  if (var_level.eq.0 .or. global) then
    var%level = 0
  else
    var%level = var_level
  endif
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1 .and. var_level.ne.0) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  endif
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'Undefined variable '//name)
    error =.true.
    return
  endif
  !
  ! Do not allow incarnation or transposition here
  call extract_descr(desc,dicvar(in)%desc,spec%done,var%name,.false.,0,error)
  if (error) return
  type = desc%type
  !
  if (type.eq.0) then
    if (desc%status.gt.0) then
      ! Header
      utype = 8
    else
      ! Retrieve the information associated with the structure name:
      ! Structure
      utype = 9
    endif
    ! What about utype=10 (table)?
    !
  ! Character variable
  elseif (type.gt.0) then
    utype = 6
    !
  elseif (type.eq.fmt_l) then
    utype = 5
    !
  elseif (type.eq.fmt_i8) then
    utype = 4
    !
  elseif (type.eq.fmt_i4) then
    utype = 3
    !
  elseif (type.eq.fmt_r4) then
    utype = 1
    !
  elseif (type.eq.fmt_r8) then
    utype = 2
    !
  elseif (type.eq.fmt_c4) then
    utype = 7
    !
  else
    call sic_message(seve%e,rname,'Invalid data format, internal logic error')
  endif
  !
end subroutine sic_examine_type
!
subroutine sic_exambigs(name,error)
  use sic_interfaces, except_this=>sic_exambigs
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! List all matches of specified name, Local and Globals
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer :: in,il,ier
  !
  ! List ambiguities...
  ier = sic_hasambigs(maxvar,pfvar,pnvar,dicvar,name,in,il)
  if (ier.eq.0)  error = .true.
  !
end subroutine sic_exambigs
!
subroutine sic_list_alias
  use sic_interfaces, except_this=>sic_list_alias
  use sic_structures
  use sic_dictionaries
  use examine_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! List all the known aliases
  !---------------------------------------------------------------------
  ! Local
  integer :: i,ls,level
  !
  if (nalias.eq.0) return
  !
  if (global) then
    level = 0
  else
    level = var_level
  endif
  !
  do i=1,nalias
    if ( dicvar(alias(i))%id%level.ne.level )  cycle
    !
    ls = index(dicvar(alias(i))%id%name,' ')
    ls = max(ls,15)
    write(6,'(A,A,A)') dicvar(alias(i))%id%name(1:ls),'  =>  ',trim(dicali(i)%name)
  enddo
  !
end subroutine sic_list_alias
!
subroutine sic_debug_variables
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_debug_variables
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !   SIC DEBUG VARIABLES
  !---------------------------------------------------------------------
  ! Local
  integer(kind=4) :: list(maxvar),ivar,in,ik
  !
  call sic_hassort(maxvar,pfvar,pnvar,dicvar,list,in)
  write(*,'(A)')  '         #  Lev Stat Name'
  do ivar=1,in
    ik = list(ivar)
    call onevar(ik)
  enddo
  ! write(*,'(A,I0,A)') 'Total: ',in,' variables'
  !
  write(*,'(A)')  ' '
  write(*,'(A)')  'Local user-defined variables:'
  do ivar=1,var_n
    ik = var_pointer(ivar)
    call onevar(ik)
  enddo
  !
  write(*,'(A)')  ' '
  write(*,'(A)')  'Global user-defined variables:'
  do ivar=maxvar,var_g,-1
    ik = var_pointer(ivar)
    call onevar(ik)
  enddo
  !
contains
  subroutine onevar(ik)
    integer(kind=4) :: ik
    write(*,'(I4,A,3I4,1X,A)')  &
      ivar,': ',ik,dicvar(ik)%id%level,dicvar(ik)%desc%status,trim(dicvar(ik)%id%name)
  end subroutine onevar
  !
end subroutine sic_debug_variables

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_stack_spatial
  use cubetools_parameters
  use cubetools_shape_types
  use cube_types
  use cubeadm_cubeprod_types
  use cubemain_spectrum_real
  use cubemain_windowing
  use cubemain_messaging
  !
  public :: cubemain_stack_spatial_do
  private
  !
  integer(kind=entr_k), parameter :: one = 1
  !
  type stack_spatial_prog_t
     type(window_array_t), pointer :: wind               ! Window to be spatially stacked
     type(cube_t), pointer         :: incube             ! Input cube
     type(cube_prod_t)             :: ouprod             ! Output spectrum description
     type(cube_t), pointer         :: oucube             ! Output spectrum
     type(cube_t), pointer         :: mask               ! Mask
     real(kind=sign_k)             :: factor             ! brightness conversion factor
     type(shape_t)                 :: nin                ! Shape of input cube
     logical                       :: contaminate        ! NaNs contaminate image
     logical                       :: mask2d = .false.   ! Is the mask 2d?
     logical                       :: domean = .false.   ! Output is a mean spectrum
     logical                       :: domask             ! Use a mask
  end type stack_spatial_prog_t
  !
contains
  !   
  subroutine cubemain_stack_spatial_init(domean,wind,incube,domask,&
       mask2d,mask,ouprod,oucube,job,error)
    use cubetools_header_methods
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! Initializes stack_spatial_prog_t
    !----------------------------------------------------------------------
    logical,                     intent(in)    :: domean
    type(window_array_t),target, intent(in)    :: wind
    type(cube_t),pointer,        intent(in)    :: incube
    logical,                     intent(in)    :: domask
    logical,                     intent(in)    :: mask2d
    type(cube_t),pointer,        intent(in)    :: mask
    type(cube_prod_t),           intent(in)    :: ouprod
    type(cube_t),pointer,        intent(in)    :: oucube
    type(stack_spatial_prog_t),  intent(out)   :: job
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='STACK>SPATIAL>INIT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    job%domean  =  domean
    job%wind    => wind
    job%incube  => incube
    job%domask  =  domask
    job%mask2d  =  mask2d
    job%mask    => mask
    job%oucube  => oucube
    !
    ! Do not replace the flag in-place, do it in a copy
    call ouprod%copy(job%ouprod,error)
    if (error)  return
    call job%ouprod%flag_to_flag(flag_image_or_spectrum,flag_image,error)
    if (error)  return
    !
    call cubetools_header_get_array_shape(job%incube%head,job%nin,error)
    if (error) return
    !
    job%contaminate = .true.
  end subroutine cubemain_stack_spatial_init
  !
  subroutine cubemain_stack_spatial_do(domean,wind,incube,domask,&
       mask2d,mask,ouprod,oucube,error)
    !----------------------------------------------------------------------
    ! Does the job
    !----------------------------------------------------------------------
    logical,                     intent(in)    :: domean
    type(window_array_t),        intent(in)    :: wind
    type(cube_t),pointer,        intent(inout) :: incube
    logical,                     intent(in)    :: domask
    logical,                     intent(in)    :: mask2d
    type(cube_t),pointer,        intent(inout) :: mask
    type(cube_prod_t), target,   intent(in)    :: ouprod
    type(cube_t),pointer,        intent(inout) :: oucube
    logical,                     intent(inout) :: error
    !
    type(stack_spatial_prog_t) :: job
    character(len=*), parameter :: rname='STACK>SPATIAL>DO'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubemain_stack_spatial_init(domean,wind,incube,domask,&
         mask2d,mask,ouprod,oucube,job,error)
    if (error) return
    !
    call cubemain_stack_spatial_header(job,error)
    if (error) return
    call cubemain_stack_spatial_data(job,error)
    if (error) return
  end subroutine cubemain_stack_spatial_do
  !
  subroutine cubemain_stack_spatial_header(job,error)
    use cubeadm_clone
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(stack_spatial_prog_t), intent(inout) :: job
    logical,                    intent(inout) :: error
    !
    character(len=unit_l) :: unitin,unitou
    character(len=*), parameter :: rname='STACK>SPATIAL>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(job%ouprod,job%incube,job%oucube,error)
    if (error) return    
    !
    call cubetools_header_put_nchan(one,job%oucube%head,error)
    if (error) return
    call cubetools_header_multiply_spectral_spacing(job%nin%c,job%oucube%head,error)
    if (error) return
    call cubetools_header_rederive_spectral_axes(job%oucube%head,error)
    if (error) return
    if (job%domean) then
       job%factor = 1.0
    else
       call cubetools_header_get_array_unit(job%incube%head,unitin,error)
       if (error) return
       unitou = trim(unitin)//'.km/s'
       call cubetools_header_put_array_unit(unitou,job%oucube%head,error)
       if (error) return
       job%factor = job%incube%head%spe%inc%v
    endif
  end subroutine cubemain_stack_spatial_header
  !
  subroutine cubemain_stack_spatial_data(job,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(stack_spatial_prog_t), intent(inout) :: job
    logical,                    intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='STACK>SPATIAL>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(job,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(job,error) FIRSTPRIVATE(iter)
       if (.not.error) then
          if (job%domask) then
             call cubemain_stack_spatial_mask(job,iter,error)
          else
             call cubemain_stack_spatial_nomask(job,iter,error)
          endif
       endif
       !$OMP END TASK
    enddo ! ie
    !$OMP END SINGLE
    !$OMP END PARALLEL
    !
  end subroutine cubemain_stack_spatial_data
  !
  subroutine cubemain_stack_spatial_nomask(job,iter,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(stack_spatial_prog_t), intent(inout) :: job
    type(cubeadm_iterator_t),   intent(inout) :: iter
    logical,                    intent(inout) :: error
    !
    type(spectrum_t) :: inspec,ouspec
    character(len=*), parameter :: rname='STACK>SPATIAL>NOMASK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call inspec%reassociate_and_init(job%incube,iter,error)
    if (error) return
    call ouspec%reallocate('stacked',one,iter,error)
    if (error) return
    call cubemain_window2mask(job%wind,inspec,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call inspec%get(job%incube,iter%ie,error)
       if (error) return
       call cubemain_stack_spatial_spectrum_nomask(job,inspec,ouspec,error)
       if (error) return
       call ouspec%put(job%oucube,iter%ie,error)
       if (error) return
    enddo
  end subroutine cubemain_stack_spatial_nomask
  !
  subroutine cubemain_stack_spatial_mask(job,iter,error)
    use cubetools_nan
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(stack_spatial_prog_t), intent(inout) :: job
    type(cubeadm_iterator_t),   intent(inout) :: iter
    logical,                    intent(inout) :: error
    !
    type(spectrum_t) :: inspec,ouspec,mask
    character(len=*), parameter :: rname='STACK>SPATIAL>MASK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call inspec%reassociate_and_init(job%incube,iter,error)
    if (error) return
    call mask%reassociate_and_init(job%mask,iter,error)
    if (error) return
    call ouspec%reallocate('stacked',one,iter,error)
    if (error) return
    call cubemain_window2mask(job%wind,inspec,error)
    if (error) return
    !
    if (job%mask2d) then
       do while (iter%iterate_entry(error))
          call mask%get(job%mask,iter%ie,error)
          if (error) return
          if (ieee_is_nan(mask%t(one))) then
             ouspec%t(one) = gr4nan
          else
             call inspec%get(job%incube,iter%ie,error)
             if (error) return       
             call cubemain_stack_spatial_spectrum_nomask(job,inspec,ouspec,error)
             if (error) return
          endif
          call ouspec%put(job%oucube,iter%ie,error)
          if (error) return
       enddo
    else
       do while (iter%iterate_entry(error))
          call mask%get(job%mask,iter%ie,error)
          if (error) return
          call inspec%get(job%incube,iter%ie,error)
          if (error) return       
          call cubemain_stack_spatial_spectrum_mask(job,inspec,mask,ouspec,error)
          if (error) return
          call ouspec%put(job%oucube,iter%ie,error)
          if (error) return
       enddo
    endif
  end subroutine cubemain_stack_spatial_mask
  !
  subroutine cubemain_stack_spatial_spectrum_nomask(job,inspec,ouspec,error)
    use cubetools_nan
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(stack_spatial_prog_t), intent(in)    :: job
    type(spectrum_t),           intent(in)    :: inspec
    type(spectrum_t),           intent(inout) :: ouspec
    logical,                    intent(inout) :: error
    !
    real(kind=sign_k) :: val,wei
    integer(kind=chan_k) :: ic
    character(len=*), parameter :: rname='STACK>SPATIAL>SPECTRUM>NOMASK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    val = 0
    wei = 0
    if (job%contaminate) then
       do ic=1,job%nin%c
          val = val + inspec%t(ic)*inspec%w(ic)
          wei = wei + inspec%w(ic)
       enddo
    else
       do ic=1,job%nin%c
          if (.not.ieee_is_nan(inspec%t(ic)).and.inspec%w(ic).gt.0) then
             val = val + inspec%t(ic)*inspec%w(ic)
             wei = wei + inspec%w(ic)
          endif
       enddo
    endif
    if (wei.gt.0) then
       ! *** JP: Ugly patch
       if (job%domean) then
          ouspec%t(one) = val/wei*job%factor
       else
          ouspec%t(one) = val*job%factor
       endif
       ! *** JP: Ugly patch
    else
       ouspec%t(one) = gr4nan
    endif
  end subroutine cubemain_stack_spatial_spectrum_nomask
  !
  subroutine cubemain_stack_spatial_spectrum_mask(job,inspec,mask,ouspec,error)
    use cubetools_nan
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(stack_spatial_prog_t), intent(in)    :: job
    type(spectrum_t),           intent(in)    :: inspec
    type(spectrum_t),           intent(in)    :: mask
    type(spectrum_t),           intent(inout) :: ouspec
    logical,                    intent(inout) :: error
    !
    real(kind=sign_k) :: val,wei
    integer(kind=chan_k) :: ic
    character(len=*), parameter :: rname='STACK>SPATIAL>SPECTRUM>MASK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    val = 0
    wei = 0
    if (job%contaminate) then
       do ic=1,job%nin%c
          if (.not.ieee_is_nan(mask%t(ic))) then
             val = val + inspec%t(ic)*inspec%w(ic)
             wei = wei + inspec%w(ic)
          endif
       enddo
    else
       do ic=1,job%nin%c
          if (.not.ieee_is_nan(inspec%t(ic)).and..not.ieee_is_nan(mask%t(ic))) then
             val = val + inspec%t(ic)*inspec%w(ic)
             wei = wei + inspec%w(ic)
          endif
       enddo
    endif
    if (wei.gt.0) then
       ! *** JP: Ugly patch
       if (job%domean) then
          ouspec%t(one) = val/wei*job%factor
       else
          ouspec%t(one) = val*job%factor
       endif
       ! *** JP: Ugly patch
    else
       ouspec%t(one) = gr4nan
    endif
  end subroutine cubemain_stack_spatial_spectrum_mask
end module cubemain_stack_spatial
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clic_plot(line,error)
  use gildas_def
  use gkernel_interfaces
  use gkernel_types
  use classic_api
  !---------------------------------------------------------------------
  !	PLOT [SAME] [obs_number] [NEXT] [FIRST] [CLOURE]
  !		/NOFRAME [pen]		option 1
  !		/RECORD			option 2
  !		/IDENTIFY		option 3
  !		/RESET			option 4
  !		/NODRAW			option 5
  !		/APPEND                 option 6
  !               /PHYSICAL               option 7
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'clic_xy_code.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: ident, do_record, init_data, reset
  logical :: do_frame, nodraw, colour, closure, reset_display, power
  logical :: save_bin, physical, sort
  character(len=12) :: argum
  integer :: ic, iv, i, nnn
  integer :: pen_plot
  integer :: n_loop_save, rec_1_save(m_loop), rec_2_save(m_loop)
  integer :: rec_3_save(m_loop), nd, nysave, nch
  integer(kind=address_length) :: ipx,ipy,ipw
  type(sic_listi4_t) :: list
  integer :: mvocab, nkey, mvoc1
  parameter (mvocab=6, mvoc1=2)
  character(len=12) :: vocab(mvocab), key, voc1(mvoc1)
  data voc1/'COLOR','NOCOLOR'/
  data vocab/'ALL','CLOSURE','FIRST','NEXT','POWER','SAME'/
  data reset_display/.false./
  save reset_display
  !------------------------------------------------------------------------
  ! Code:
  ! Options:
  ! /NOFRAME pen
  do_frame = .not.sic_present(1,0)
  pen_plot = 0
  call sic_i4(line,1,1,pen_plot,.false.,error)
  if (.not.do_frame.and.many_pages) then
   call message(4,4,'CLIC_PLOT','Cannot use /NOFRAME option on a many pages plot')
   error = .true.
   return
  endif
  ! /IDENT colour
  ident = sic_present(3,0)
  argum = 'COLOR'
  call clic_kw(line,3,1,argum,nkey,voc1,mvoc1,.false.,error,.true.)
  if (error) return
  colour = argum.eq.'COLOR'
  ! /NODRAW
  nodraw = sic_present(5,0)
  ! /APPEND
  init_data = .not.sic_present(6,0)
  ! /RESET
  reset = sic_present(4,0)
  if (reset) then
    call reset_time
  endif
  ! /RECORD
  do_record = sic_present(2,1)
  if (do_record) then
    n_loop_save = n_loop
    do i=1, n_loop
      rec_1_save(i) = rec_1(i)
      rec_2_save(i) = rec_2(i)
      rec_3_save(i) = rec_3(i)
    enddo
    ic = sic_start(2,1)
    iv = sic_end(2,sic_narg(2))
    call sic_parse_listi4('CLIC_PLOT',line(ic:iv),list,m_loop,error)
    if (error) return
    n_loop = list%nlist
    rec_1(:) = list%i1(:)
    rec_2(:) = list%i2(:)
    rec_3(:) = list%i3(:)
  endif
  !  /PHYSICAL
  physical = sic_present(7,0).or.do_physical
  if (physical) then
    if (.not.phys_base) then
      phys_base = .true.
      call set_display(error)
    endif
  else
    if (phys_base) then
      phys_base = .false.
      call set_display(error)
    endif
  endif
  ! /NOSORT
  sort = .not.sic_present(9,0)
  !
  ! Command Argument
  argum = 'ALL'
  call sic_ke(line,0,1,argum,nch,.false.,error)
  if (error) return
  nnn = ichar(argum(1:1))
  if (nnn.ge.ichar('0') .and. nnn.le.ichar('9')) then
    key = argum
  else
    call sic_ambigs('PLOT',argum,key,nkey,vocab,mvocab,error)
    if (error) return
  endif
  if (key.eq.'SAME' .and. change_display) then
    call message(4,2,'CLIC_PLOT','Data needs to be read')
    argum(1:3) = 'ALL'
  endif
  if (reset_display .and. key.ne.'SAME') then
    call set_display(error)
    reset_display = .false.
  endif
  ! /BOXES
  if (sic_present(8,0)) then
    call sic_ke(line,8,1,argum,nch,.true.,error)
    if (argum.eq.'*') then
       user_box_nx = -1
    else
       call sic_i4(line,8,1,user_box_nx,.false.,error)
    endif
    call sic_ke(line,8,2,argum,nch,.true.,error)
    if (argum.eq.'*') then
       user_box_ny = -1
    else
      call sic_i4(line,8,2,user_box_ny,.false.,error)
    endif
    user_box = (user_box_nx.gt.0.or.user_box_ny.gt.0)
  else
    user_box = .false.
  endif
  !
  ! Deal with Title
  call gr_exec('SET VIEWPORT /DEF')
  ! Closure plot:
  ! set some defaults for plotting
  closure = .false.
  power = .false.
  if (key.eq.'CLOSURE') then
    call get_first(.false.,error)
    if (error) return
    change_display = .true.
    ! Y variables: amplitude and/or phase
    nysave = n_y
    n_y = 1
    if ((i_y(1).ne. xy_ampli).and.(i_y(1).ne. xy_phase)) then
      call message (8,3,'CLIC_PLOT',   &
        'Use SET Y AMPLITUDE or SET Y PHASE for closure plots')
      error = .true.
    endif
    ! all available baselines:
    n_base = r_nbas
    do i=1, n_base
      i_base(i) = i
    enddo
    call set_display(error)
    if (error) return
    closure = .true.
    key = 'ALL'
  elseif (key.eq.'POWER') then
    power = .true.
    key = 'ALL'
  endif
  !
  if (key.ne.'SAME') then
    if (plot_mode.eq.'TIME') then
      if (power) then
        save_bin = do_bin
        do_bin = .false.
      endif
      call read_data(key,sort,init_data,error)
      if (power) do_bin = save_bin
    elseif (plot_mode.eq.'SPEC') then
      call read_spec(key,init_data,error)
    endif
    if (error) return
  endif
  if (do_record) then
    n_loop = n_loop_save
    do i=1, n_loop
      rec_1(i) = rec_1_save(i)
      rec_2(i) = rec_2_save(i)
      rec_3(i) = rec_3_save(i)
    enddo
  endif
  change_display = .false.
  clear = (clear .or. key.eq.'ALL' .or. key.eq.'SAME')   &
    .and. do_frame
  if (nodraw) return
  if (closure) then
    ipx = gag_pointer(data_x,memory)
    ipy = gag_pointer(data_y,memory)
    ipw = gag_pointer(data_w,memory)
    nd = m_data
    if (i_y(1).eq.xy_phase.and.r_nant.ge.3) then
      call sub_clos_pha(r_nant,nd,n_base,   &
        memory(ipx),memory(ipy),memory(ipw),error)
    elseif (r_nant.ge.4) then
      call sub_clos_amp(r_nant,nd,n_base,   &
        memory(ipx),memory(ipy),memory(ipw),error)
    endif
    if (error) return
    call sub_resetvar(m_data,m_boxes,   &
      memory(ipx),memory(ipy),memory(ipw),error)
    if (error) return
    call position_boxes(error)
    if (error) return
  elseif (power) then
    call plot_power(error)
    if (error) return
  endif
  call sub_plot(key, ident, colour, pen_plot, error)
  if (closure) then
    n_y = nysave
    reset_display = .true.
  endif
  user_box = .false.
  return
end subroutine clic_plot
!
subroutine sub_plot(argum, ident, colour, pen_plot, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! this intermediate entry point needed for solve ... /plot
  !---------------------------------------------------------------------
  character(len=*) :: argum         !
  logical :: ident                  !
  logical :: colour                 !
  integer :: pen_plot               !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'clic_xy_code.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ipx,ipy,ipw,ipi,ips,ipj
  !-----------------------------------------------------------------------
  ipx = gag_pointer(data_x,memory)
  ipy = gag_pointer(data_y,memory)
  ipw = gag_pointer(data_w,memory)
  ipi = gag_pointer(data_i,memory)
  ips = gag_pointer(data_s,memory)
  ipj = ips + m_data*m_boxes
  call sub_sub_plot(m_data, m_boxes, memory(ipx), memory(ipy),   &
    memory(ipw), memory(ipi), memory(ips),   &
    memory(ipj), argum, ident, colour, pen_plot,   &
    error)
  return
end subroutine sub_plot
!
subroutine sub_clos_pha(nant,nd,nb,x,y,w,error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! same comment as for amplitudes.
  !---------------------------------------------------------------------
  integer :: nant                   !
  integer :: nd                     !
  integer :: nb                     !
  real :: x(nd,nb)                  !
  real :: y(nd,nb)                  !
  real :: w(nd,nb)                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_number.inc'
  ! Local
  integer :: i, k, id, nclos, kbox, kb, islash, ii, nt
  integer :: jcl(3,mnbas), j1, j2, j3, ib, kk
  real :: xc(mnbas),yc(mnbas),wc(mnbas),p, ww(3), yy(3), www, xx
  character(len=3) :: cc,ccl(mnbas)
  character(len=80) :: ch
  logical :: new(mnbas)
  !-----------------------------------------------------------------------
  kbox = n_boxes/n_base
  if (degrees) then
    p = 180.
  else
    p = pi
  endif
  !
  ! Build the relations table starting from the list of triangles:
  nt = nant*(nant-1)*(nant-2)/6
  nclos = 0
  do i=1, mnbas
    new(i) = .true.
  enddo
  do k=1, nt
    j1 = bastri(1,k)
    j2 = bastri(2,k)
    j3 = bastri(3,k)
    write(cc,'(4i1)') anttri(1,k),anttri(2,k),anttri(3,k)
    if (new(j1).or.new(j2).or.new(j3)) then
      nclos = nclos+1
      new(j1) = .false.
      new(j2) = .false.
      new(j3) = .false.
      jcl(1,nclos) = j1
      jcl(2,nclos) = j2
      jcl(3,nclos) = j3
      ccl(nclos) = cc
    endif
  enddo
  !
  do ib=1, kbox
    do k=1, nclos
      kb = (k-1)*kbox+ib
      header_1(kb) = 'Clos '//ccl(k)
      header_2(kb) = header_2(ib)
      header_3(kb) = header_3(ib)
      x_label(kb)  = x_label(ib)
      y_label(kb)  = y_label(ib)
      write (ch,1005) kb, kb
      islash = index(c_limits(ib),'/')-1
      c_limits(kb) = c_limits(ib)(1:islash)//ch(1:lenc(ch))
    enddo
  enddo
  !
  do id=1, n_data(k)
    do ib=1, kbox
      do i=1, nclos
        kb = (i-1)*kbox+ib
        do kk=1,3
          ii = (jcl(kk,i)-1)*kbox+ib
          yy(kk) = y(id,ii)
          ww(kk) = w(id,ii)
          xx = x(id,ii)
        enddo
        www = ww(1)*ww(2)*ww(3)
        if (www.gt.0) then
          yc(i) = mod(yy(1)-yy(2)+yy(3)+11*p,2*p)-p
          wc(i) = 1./(1/ww(1)+1/ww(2)+1/ww(3))
          xc(i) = xx
        else
          yc(i) = blank4
          wc(i) = 0
          xc(i) = blank4
        endif
      enddo
      do i=1, nclos
        ii = (i-1)*kbox+ib
        y(id,ii) =  yc(i)
        w(id,ii) =  wc(i)
        x(id,ii) =  xc(i)
      enddo
    enddo
  enddo
  n_boxes = nclos*kbox
  !
  ! reset the variables
  call sub_resetvar(nd,n_boxes,x,y,w,error)
  return
1005 format(' /VARIABLE X_DATA[',i4.4,'] Y_DATA[',i4.4,']')
end subroutine sub_clos_pha
!
subroutine sub_clos_amp(nant,nd,nb,x,y,w,error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! take only 2 closures for each quadrangle (13.24/12.34 and 14.23/12.34)
  ! this would produce n*(n-1)*(n-2)*(n-3)|(4*3) closure
  ! relations of which only n*(n-3)|2 are independent. For 5 antennas these
  ! numbers are 10 and 5. For more than 5 antennas one has to sort out
  ! dependent relations because there will be more clos. relations produced
  ! than available baselines.
  ! Hint : start with 2 independent relations in a given quadrangle, and add
  ! relations with additional baselines; using only once each new baseline
  ! should give independent relations:
  !  (n-1)(n-4)|2 relations between n-1 antennas
  ! there are n-1 new baselines with a nth antenna
  ! add (n-2) relations (the first has 2 new baselines)
  ! one gets (n-1)(n-4)|2 + n-2 = (n^2-5n+4 +2n-4)|2 = n*(n-3)|2 relations.
  !---------------------------------------------------------------------
  integer :: nant                   !
  integer :: nd                     !
  integer :: nb                     !
  real :: x(nd,nb)                  !
  real :: y(nd,nb)                  !
  real :: w(nd,nb)                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_number.inc'
  ! Local
  integer ::  i, id, nclos, k, kb, kbox, l, islash, ii, nq
  integer ::  jcl(4,mnbas), j1, j2, j3, j4, ib, kk
  real :: xc(mnbas),yc(mnbas), wc(mnbas), yy(4), ww(4)
  real :: www, yyy, xx
  character(len=4) :: cc,ccl(mnbas)
  character(len=80) :: ch
  logical :: new(mnbas)
  !-----------------------------------------------------------------------
  kbox = n_boxes/n_base
  !
  ! Build the relations table starting from the list of quadrangles:
  nq = nant*(nant-1)*(nant-2)*(nant-3)/24
  nclos = 0
  do i=1, mnbas
    new(i) = .true.
  enddo
  !
  do k=1, nq
    j1 = basquad(1,k)
    j2 = basquad(6,k)
    do l=1, 2
      if (l.eq.1) then         ! (A_12*A_34)/(A_13*A_24)
        j3 = basquad(2,k)
        j4 = basquad(5,k)
        write(cc,'(4i1)') antquad(1,k),antquad(2,k),   &
          antquad(3,k),antquad(4,k)
      else                     ! (A_12*A_34)/(A_14*A_23)
        j3 = basquad(3,k)
        j4 = basquad(4,k)
        write(cc,'(4i1)') antquad(1,k),antquad(2,k),   &
          antquad(4,k),antquad(3,k)
      endif
      if (new(j1).or.new(j2).or.new(j3).or.new(j4)) then
        nclos = nclos+1
        new(j1) = .false.
        new(j2) = .false.
        new(j3) = .false.
        new(j4) = .false.
        jcl(1,nclos) = j1
        jcl(2,nclos) = j2
        jcl(3,nclos) = j3
        jcl(4,nclos) = j4
        ccl(nclos) = cc
      endif
    enddo
  enddo
  !
  do ib=1, kbox
    do k=1, nclos
      kb = (k-1)*kbox+ib
      header_1(kb) = 'Clos '//ccl(k)
      header_2(kb) = header_2(ib)
      header_3(kb) = header_3(ib)
      x_label(kb)  = x_label(ib)
      y_label(kb)  = y_label(ib)
      write (ch,1005) kb, kb
      islash = index(c_limits(ib),'/')-1
      c_limits(kb) = c_limits(ib)(1:islash)//ch(1:lenc(ch))
    enddo
  enddo
  !
  do id=1, n_data(k)
    do ib=1, kbox
      do i=1, nclos
        kb = (i-1)*kbox+ib
        do kk=1,4
          ii = (jcl(kk,i)-1)*kbox+ib
          yy(kk) = y(id,ii)
          ww(kk) = w(id,ii)
          xx = x(id,ii)
        enddo
        www = ww(1)*ww(2)*ww(3)*ww(4)
        yyy = yy(1)*yy(2)*yy(3)*yy(4)
        if (www.gt.0) then
          if (yyy.ne.0) then
            do kk=1,4
              ww(kk) = 1./ww(kk)/yy(kk)**2
            enddo
            yc(i) = (yy(1)*yy(2))/(yy(3)*yy(4))
            wc(i) = 1./(ww(1)+ww(2)+ww(3)+ww(4))/yc(i)**2
            xc(i) = xx
          endif
        else
          yc(i) = blank4
          wc(i) = 0
          xc(i) = blank4
        endif
      enddo
      do i=1, nclos
        ii = (i-1)*kbox+ib
        y(id,ii) =  yc(i)
        w(id,ii) =  wc(i)
        x(id,ii) =  xc(i)
      enddo
    enddo
  enddo
  n_boxes = nclos*kbox
  !
  ! reset the variables
  call sub_resetvar(nd,n_boxes,x,y,w,error)
  return
1005 format('/VARIABLE X_DATA[',i4.4,'] Y_DATA[',i4.4,']')
end subroutine sub_clos_amp
!
subroutine sub_sub_plot(md,mb,x_data,y_data,w_data,   &
    i_data,b_data,j_data,argum,ident, colour, pen_plot, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_index
  use clic_title
  !---------------------------------------------------------------------
  ! This version for GREG1 Version 7.2 and later : call list of
  ! GR4_HISTO was incorrect previously.
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  integer :: i_data(md,mb)             !
  real :: b_data(md,mb)             !
  integer :: j_data(mb)                !
  character(len=*) :: argum         !
  logical :: ident                  !
  logical :: colour                 !
  integer :: pen_plot               !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  ! Local
  type(title_v2_t) :: title_save
  integer :: i, l, l1, j, lc, isides, istyle, sides0, style0, k, n
  integer :: nch, ix, iy, nplot, mplot, iscan
  integer :: i_data_dumm(md)
  real :: tick(4)
  character(len=132) :: chain,ch1,ch2,ch3
  character(len=4) :: cloc
  character(len=3) :: italic
  character(len=12) :: answer
  integer :: nch1, nch2, nch3, old_pen, status
  real*4 :: cdef, cdef0, cdef1
  real*4 :: xmax, ymax, size0, sl, sl1, sl2, sl3, bx1, bx2, by1, by2
  real*4 :: xmax1, ymax1, xx1(mbox), xx2(mbox), yy1(mbox), yy2(mbox)
  real*4 :: dummy(1)
  logical :: angle_data, good(mbox)
  logical :: fatm, fwvr, fmon
  !------------------------------------------------------------------------
  save xmax1, ymax1
  data xmax1/0.0/, ymax1/0.0/
  ! 
  ! Save the current short tile
  title_save = title
  !
  ! Code:
  italic = char(92)//char(92)//'i'
  do i=1, n_x
    xx1(i) = 1e30
    xx2(i) = -1e30
  enddo
  do i=1, n_y
    yy1(i) = 1e30
    yy2(i) = -1e30
  enddo
  mplot = 0
  do i=1, n_boxes
    nplot = 0
    do j = 1, n_data(i)
      if (abs(y_data(j,i)-blank4).gt.d_blank4) then
        nplot = nplot + 1
      endif
    enddo
    if (nplot.le.0) then
      write(chain,'(A,I0)') 'No data in box ',i
      call message(8,2,'SUB_PLOT',chain(1:lenc(chain)))
    endif
    good(i) = nplot.gt.0
    mplot = mplot + nplot
  enddo
  if (mplot.le.0) then
    call message(8,2,'SUB_PLOT','No data to plot')
    call gtclear  
    error = .true.
    return
  endif
  call gr8_blanking(blank8,d_blank8)
  if (clear) then
    call gtclear
    error = gr_error()
    if (error) goto 999
    call sic_get_real('CHARACTER_SIZE',cdef0,error)
    call sic_get_real('PAGE_X',xmax,error)
    call sic_get_real('PAGE_Y',ymax,error)
    if (xmax1.ne.0 .and. (xmax.ne.xmax1 .or. ymax.ne.ymax1)) then
      call set_display(error)
      if (error) return
    endif
    xmax1 = xmax
    ymax1 = ymax
    !
    ! Central header should fit in (0.70*xmax,0.08*xmax)
    cdef = 0.08*xmax/3.0       ! space for 3 lines
    !
    ! First line
    call user_info(ch1)
    nch1 = lenc(ch1)
    ch1 = ch1(1:nch1)//'   '   &
      //r_config(1:lenc(r_config))//' '   &
      //r_teles
    nch1 = lenc(ch1)
    call gtg_charlen(nch1,ch1(1:nch1),cdef,sl1,0)
    !
    ! Second and third line -- Old receivers
    if (.not.new_receivers) then
      if ((argum.eq.'ALL' .or. argum.eq.'SAME')   &
        .and. cxnext.gt.2) then
        call rix(cx_ind(1),error)
      else
        call rix(r_xnum,error)
      endif
      call out0('Chain',xmax/2,ymax-cdef,error)
      call titout('Normal',error)
      call out2(ch2,error)
      nch2 = lenc(ch2)
      call gtg_charlen(nch2,ch2(1:nch2),cdef,sl2,0)
      if ((argum.eq.'ALL' .or. argum.eq.'SAME')   &
        .and. cxnext.gt.2) then
        call rix(cx_ind(cxnext-1),error)
        call out0('Chain',xmax/2,ymax-cdef,error)
        call titout('Normal',error)
        call out2(ch3,error)
        nch3 = lenc(ch3)
        call gtg_charlen(nch3,ch3(1:nch3),cdef,sl3,0)
      else
        sl3 = 0
      endif
    !
    ! Second and third lines -- New receivers
    else
      call rix(cx_ind(1),error)
      call out0('Chain',xmax/2,ymax-cdef,error)
      call titout('Plot',error)
      call out2(ch2,error)
      nch2 = lenc(ch2)
      call gtg_charlen(nch2,ch2(1:nch2),cdef,sl2,0)
      !
      call rix(cx_ind(cxnext-1),error)
      call out0('Chain',xmax/2,ymax-cdef,error)
      call titout('Blot',error)
      call out2(ch3,error)
      nch3 = lenc(ch3)
      call gtg_charlen(nch3,ch3(1:nch3),cdef,sl3,0)
    endif
    !
    ! Now print the two or three lines
    sl = max(sl1, sl2, sl3)
    if (sl.gt.0.70*xmax) then
      cdef = cdef*0.70*xmax/sl
    endif
    write (chain,'(A,F7.3)') 'SET CHAR ',cdef
    call gr_exec1 (chain(1:lenc(chain)))
    call grelocate(xmax*0.5-0.1*cdef,ymax)
    call gr_labe_cent(2)
    call gr_labe(italic//ch1(1:nch1))
    call grelocate(xmax/2.,ymax-cdef)
    call gr_labe_cent(2)
    call gr_labe(ch2(1:nch2))
    if (sl3.gt.0) then
      call grelocate(xmax/2.,ymax-cdef*2)
      call gr_labe_cent(2)
      call gr_labe(ch3(1:nch3))
    endif
    !
    ! Corner labels (Left)
    cdef = 0.08*xmax/4         ! space for 4 lines
    call gtg_charlen(13,'XXXXXXXXXXXXXXXXXX',cdef,sl,0)
    if (sl.gt.0.12*xmax) then
      cdef = cdef*0.12*xmax/sl
    endif
    write (chain,'(A,F7.3)') 'SET CHAR ',cdef
    call gr_exec1 (chain(1:lenc(chain)))
    call grelocate(0.1,ymax)
    call gr_labe_cent(3)
    call gr_labe(italic//'RF:')
    call grelocate(0.1,ymax-cdef)
    call gr_labe_cent(3)
    call gr_labe(italic//'Am:')
    call grelocate(0.1,ymax-2*cdef)
    call gr_labe_cent(3)
    call gr_labe(italic//'Ph:')
    !
    !RF
    if (do_pass) then
      if (do_pass_freq) then
        chain = 'Fr.'
      else
        chain = 'Ch.'
      endif
      if (do_pass_antenna) then
        chain(4:6) = '(A)'
      else
        chain(4:6) = '(B)'
      endif
      if (do_pass_spectrum) then
        iscan = 0
        call get_pass_scan(chain,iscan,error)
      endif
    else
      chain = 'Uncal.'
    endif
    call grelocate(3*cdef,ymax)
    call gr_labe_cent(3)
    call gr_labe(chain(1:10))
    !Amp.
    if (do_amplitude) then
      if (do_amplitude_antenna) then
        chain = 'Rel.(A)'
      else
        chain = 'Rel.(B)'
      endif
    elseif (do_scale) then
      chain = 'Scaled'
    else
      chain = 'Abs.   '
    endif
    call grelocate(3*cdef,ymax-cdef)
    call gr_labe_cent(3)
    call gr_labe(chain(1:7))
    if (do_phase) then
      if (do_phase_antenna) then
        chain = 'Rel.(A)'
      else
        chain = 'Rel.(B)'
      endif
    else
      chain = 'Abs.'
    endif
    fatm = .false.
    do i=1, r_nant
      fatm = fatm.or.do_phase_atm(i)
    enddo
    if (fatm) then
      lc = lenc(chain)
      chain = chain(1:lc)//' Atm.'
    endif
    fwvr = .false.
    do i=1, r_nant
      fwvr = fwvr.or.do_phase_wvr(i)
    enddo
    if (fwvr) then
      lc = lenc(chain)
      chain = chain(1:lc)//' Wvr.'
    endif
    fmon = .false.
    do i=1, r_nant
      fmon = fmon.or.do_phase_mon(i)
    enddo
    if (fmon) then
      lc = lenc(chain)
      chain = chain(1:lc)//' Tot.'
    endif
    if (do_phase_ext) then
      lc = lenc(chain)
      chain = chain(1:lc)//' Ext.'
    endif
    lc = lenc(chain)
    call grelocate(3*cdef,ymax-2*cdef)
    call gr_labe_cent(3)
    call gr_labe(chain(1:lc))
    !
    ! Corner labels (Right)
    ! -- Averaging
    if (i_average.eq.0) then
      chain = 'No Avg.'
    elseif (i_average.eq.1) then
      chain = 'Scan Avg.'
    elseif (i_average.eq.2) then
      write(chain,'(A,F5.0,A)') 'T.Av:',t_average,' s.'
    endif
    call grelocate(xmax,ymax)
    call gr_labe_cent(1)
    nch = lenc(chain)
    call gr_labe(chain(1:nch))
    ! Obsolete ?
    !         IF (J_AVERAGE.EQ.0) THEN
    !            CHAIN = 'Scal.Avg.'
    !         ELSE
    !            CHAIN = 'Vect.Avg.'
    !         ENDIF
    !         CALL GRELOCATE(XMAX,YMAX-CDEF)
    !         CALL GR_LABE_CENT(1)
    !         CALL GR_LABE(CHAIN(1:9))
    !
    ! -- Phys. antenna
    if (phys_base) then
      old_pen = gr_spen(1)
      chain = 'PHYSICAL ant.'
      call grelocate(xmax,ymax-cdef)
      call gr_labe_cent(1)
      call gr_labe(chain(1:13))
      old_pen = gr_spen(old_pen)
      ymax = ymax-cdef
    endif
    !
    ! -- Subbands selection
    if (new_receivers) then
      chain = ' '
      if (do_polar.ne.0.or.each_polar) then
        if (do_polar.eq.1) then
          chain = 'HORIZONTAL pol.'
        elseif (do_polar.eq.2) then
          chain = 'VERTICAL pol.'
        elseif (do_polar.eq.3) then
          chain = 'BOTH polarizations'
        endif
        if (each_polar) then
          chain = 'EACH polar'
        endif
        old_pen = gr_spen(1)
        call grelocate(xmax,ymax-cdef)
        call gr_labe_cent(1)
        call gr_labe(chain(1:lenc(chain)))
        old_pen = gr_spen(old_pen)
      endif
      if (narrow_input.ne.0) then
        if (narrow_input.eq.1) then
          chain = 'Narrow Input 1'
        elseif (narrow_input.eq.2) then
          chain = 'Narrow Input 2'
        elseif (narrow_input.eq.3) then
          chain = 'Narrow Input 1+2'
        endif
        old_pen = gr_spen(1)
        call grelocate(xmax,ymax-cdef)
        call gr_labe_cent(1)
        call gr_labe(chain(1:lenc(chain)))
        old_pen = gr_spen(old_pen)
      endif
      if (widex_unit.ne.0) then
        write (chain,'(a,i1)')'WIDEX Unit ',widex_unit
        old_pen = gr_spen(1)
        call grelocate(xmax,ymax-cdef)
        call gr_labe_cent(1)
        call gr_labe(chain(1:lenc(chain)))
        old_pen = gr_spen(old_pen)
      endif
    endif
  endif
  !
  ! Recover the data if PLOT SAME
  if (argum.eq.'SAME') then
    call getvar(md,mb,x_data,y_data,w_data)
  endif
  !
  ! Global limits (using e.g. "/LIMITS 0 =")
  do i=1, n_boxes
    if (good(i) .and. n_data(i).gt.0) then
      l = lenc(c_limits(i))
      call gr_exec1 (c_limits(i)(1:l))
      error = gr_error()
      if (error) goto 999
      call save_limits(i,error)
      ix = k_x(i)
      if (sm_x1(ix).eq.'=') then
        xx1(ix) = min(xx1(ix),gb1_x(i))
      endif
      if (sm_x2(ix).eq.'=') then
        xx2(ix) = max(xx2(ix),gb2_x(i))
      endif
      iy = k_y(i)
      if (sm_y1(iy).eq.'=') then
        yy1(iy) = min(yy1(iy),gb1_y(i))
      endif
      if (sm_y2(iy).eq.'=') then
        yy2(iy) = max(yy2(iy),gb2_y(i))
      endif
    endif
  enddo
  do i=1, n_boxes
    ix = k_x(i)
    if (sm_x1(ix).eq.'=') then
      gb1_x(i) = xx1(ix)
    elseif (sm_x1(ix).eq.'F') then
      gb1_x(i) = gu1_x(ix)
    endif
    if (sm_x2(ix).eq.'=') then
      gb2_x(i) = xx2(ix)
    elseif (sm_x2(ix).eq.'F') then
      gb2_x(i) = gu2_x(ix)
    endif
    iy = k_y(i)
    if (sm_y1(iy).eq.'=') then
      gb1_y(i) = yy1(iy)
    elseif (sm_y1(iy).eq.'F') then
      gb1_y(i) = gu1_y(iy)
    endif
    if (sm_y2(iy).eq.'=') then
      gb2_y(i) = yy2(iy)
    elseif (sm_y2(iy).eq.'F') then
      gb2_y(i) = gu2_y(iy)
    endif
  enddo
  !
  ! Recompute The positions of boxes if needed
  if (user_box) then
    call position_boxes_user(user_box_nx,user_box_ny,error)
  else
    call position_boxes(error)
  endif
  !
  k = 0
  many_pages = .false.
  do i=1, n_boxes
    k = k + 1
    if (user_box.and.k.gt.user_nboxes) then
      answer=' '
      do while (answer(1:1).ne."C")
        call sic_wprn('I-PLOT, Type C to continue',answer,n)
        if (answer(1:1).eq."Q") return
      enddo
      call gr_execl('CHANGE DIRECTORY')
      do j=1, user_nboxes
         write(chain,'(I4.4)') j
         call gr_execl('DESTROY DIRECTORY BOX'//chain)
      enddo
      many_pages = .true.
      change_display = .true.
      k = 1
    endif
    call gr_execl('CHANGE DIRECTORY')
    error = gr_error()
    if (error) goto 999
    !
    write(chain,'(I4.4)') k
    if (clear) then
      call gr_execl('CREATE DIRECTORY BOX'//chain)
      error = gr_error()
      if (error) goto 999
    endif
    call gr_execl('CHANGE DIRECTORY BOX'//chain)
    error = gr_error()
    if (error) goto 999
    if (n_data(i).le.0.or..not.good(i)) then
      goto 800
    endif
    !
    if (clear) then
      l = lenc(c_setbox(k))
      call gr_exec  (c_setbox(k)(1:l))
      error = gr_error()
      if (error) goto 999
      write(chain,'(A,4(1X,G19.12))') 'LIMITS ',gb1_x(i),   &
        gb2_x(i),gb1_y(i),gb2_y(i)
      l = lenc(chain)
      call gr_exec(chain(1:l))
      error = gr_error()
      if (error) goto 999
      call sic_get_real('BOX_XMIN',bx1,error)
      call sic_get_real('BOX_XMAX',bx2,error)
      call sic_get_real('BOX_YMIN',by1,error)
      call sic_get_real('BOX_YMAX',by2,error)
      cdef = 0.20*(by2-by1)
      cdef1 = min(0.1*(by2-by1),0.1*(bx2-bx1))
      nch1 = lenc(header_1(i))
      nch2 = lenc(header_2(i))
      nch3 = lenc(header_3(i))
      call gtg_charlen(nch1,header_1(i)(1:nch1),cdef,sl1,0)
      call gtg_charlen(nch2,header_2(i)(1:nch2),cdef,sl2,0)
      call gtg_charlen(nch3,header_3(i)(1:nch3),cdef,sl3,0)
      sl = max(2*sl1+sl2,2*sl3+sl2)
      if (sl.gt.0.95*(bx2-bx1)) then
        cdef = cdef*0.95*(bx2-bx1)/sl
      endif
      write (chain,'(A,F7.3)') 'SET CHAR ',cdef1
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      ix = i_x(k_x(i))
      iy = i_y(k_y(i))
      do j=1, 4
        tick (j) = 0.0
      enddo
      ! Convert to degrees if angle data
      if (angle_data(ix)) then
        if (degrees.and.abs(gb1_x(i)-gb2_x(i)).gt.180.) then
          tick(2) = 90.
          do while (abs(gb1_x(i)-gb2_x(i))/tick(2).gt.5)
            tick(2) = tick(2)*2.0
          enddo
          tick(1) = tick(2)/3.0
        endif
      endif
      if (angle_data(iy)) then
        if (degrees.and.abs(gb1_y(i)-gb2_y(i)).gt.180.) then
          tick(4) = 90.
          do while (abs(gb1_y(i)-gb2_y(i))/tick(4).gt.5)
            tick(4) = tick(4)*2.0
          enddo
          tick(3) = tick(4)/3.0
        endif
      endif
      write (chain,'(A,4(1X,F10.1))') 'TICKSPACE ',tick
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      call gr_exec1 ('BOX')
      error = gr_error()
      if (error) goto 999
      ! Box Header
      write (chain,'(A,F7.3)') 'SET CHAR ',cdef
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      l = lenc(header_1(i))
      write(chain,'(A,F4.2,A)') 'DRAW TEXT 0 ',0.2*cdef,' "'
      call gr_exec1 (chain(1:18)//header_1(i)(1:l)//'" 9 /BOX 7')
      error = gr_error()
      if (error) goto 999
      l = lenc(header_2(i))
      call gr_exec1 (chain(1:18)//header_2(i)(1:l)//'" 8 /BOX 8')
      error = gr_error()
      if (error) goto 999
      l = lenc(header_3(i))
      call gr_exec1 (chain(1:18)//header_3(i)(1:l)//'" 7 /BOX 9')
      error = gr_error()
      if (error) goto 999
      write (chain,'(A,F7.3)') 'SET CHAR ',cdef1
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      l = lenc(x_label(i))
      l1 = lenc(y_label(i))
      call gr_exec1 ('LABEL "'//y_label(i)(1:l1)//'  vs.  '   &
        //x_label(i)(1:l)//'" /X')
      error = gr_error()
      if (error) goto 999
    endif
    !
    ! change the pen here for overlay plots
    if (.not.clear) then
      old_pen = gr_spen(pen_plot)
    endif
    !         IF (ARGUM.EQ.'SAME') THEN
    !            CALL GETVAR(MD,MB,X_DATA,Y_DATA,W_DATA)
    !         ENDIF
    if (plot_type.eq.'LINE') then
      call gr_segm('PLOT',error)
      call gr4_connect (n_data(i),   &
        x_data(1,i),y_data(1,i),   &
        blank4,d_blank4)
      call gr_segm_close(error)
    elseif (plot_type.eq.'POIN') then
      if (.not.ident) then
        call gr_segm('PLOT',error)
        call gr4_marker (n_data(i), x_data(1,i),y_data(1,i),   &
          blank4,d_blank4)
        call gr_segm_close(error)
      else
        i_data_dumm(:) = i_data(:,i)
        call gr4_ident (n_data(i), x_data(1,i),y_data(1,i),   &
          i_data_dumm(1),j_data(1),colour,.false.,b_data(1,i),   &
          error)
      endif
    elseif (plot_type.eq.'HIST') then
      call gr_segm('PLOT',error)
      call gr4_histo (n_data(i), x_data(1,i),y_data(1,i),   &
        blank4,d_blank4)
      call gr_segm_close(error)
    elseif (plot_type.eq.'BARS') then
      do j = 1, n_data(i)
        if (w_data(j,i).gt.0.0) then
          b_data(j,i) = 1.0e-3/sqrt(w_data(j,i))
        else
          b_data(j,i) = 0.0
        endif
      enddo
      cloc = 'Y'
      if (.not.ident) then
        call gr_segm('PLOT',error)
        call gr4_bars (cloc,n_data(i),   &
          x_data(1,i),y_data(1,i),b_data(1,i),dummy,   &
          blank4,d_blank4)
        call gr4_marker (n_data(i),x_data(1,i),y_data(1,i),   &
          blank4,d_blank4)
        call gr_segm_close(error)
      else
        i_data_dumm(1:md) = i_data(1:md,i)
        call gr4_ident (n_data(i),x_data(1,i),y_data(1,i),   &
          i_data_dumm(1),j_data(1),colour,.true.,b_data(1,i),   &
          error)
      endif
    endif
    !
    ! reset the pen here for overlay plots
    if (.not.clear) then
      old_pen = gr_spen(old_pen)
    endif
    !
800 continue
  enddo
  !
  if (ident) then
    print *,'Ident ',cdef1
    write (chain,'(A,F7.3)') 'SET CHAR ',cdef1
    call gr_exec1 (chain(1:lenc(chain)))
    error = gr_error()
    if (error) goto 999
    call gr_get_marker(sides0,style0,size0)
    old_pen = gr_spen(0)
    do i=1, n_ident
      isides = (i-1)/4 + 3
      istyle = i - (isides-3)*4 -1
      call gr_set_marker(isides,istyle,size0*3)
      if (colour) then
        status = gr_spen(mod(i-1,7))
      endif
      write (chain,'(A,1PG13.6,1X,1PG13.6,a)') 'DRAW MARKER ',   &
        0.5*cdef1,-i*cdef1,' /BOX 7'
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      write (chain,'(A,1PG13.6,1X,1PG13.6,a)') 'DRAW RELOCATE ',   &
        1.5*cdef1,-i*cdef1,' /BOX 7'
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      lc = lenc(ch_ident(i))
      call gr_labe_cent(6)
      call gr_labe(ch_ident(i)(1:lc))
    enddo
    call gr_set_marker(sides0,style0,size0)
    if (colour) then
      status = gr_spen(old_pen)
    endif
  endif
  call gr_execl('CHANGE DIRECTORY')
  call gr_exec1('LIMITS 0 1 0 1')
  error = gr_error()
  if (error) goto 999
  if (clear) then
    write (chain,'(A,F7.3)') 'SET CHAR ',cdef0
    call gr_exec1 (chain(1:lenc(chain)))
    error = gr_error()
    if (error) goto 999
  endif
999 continue
  !
  ! For consistency of further commands restore saved title
  title = title_save
  clear = .false.
end subroutine sub_sub_plot
!
subroutine save_limits(ibox,error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! Save current GREG plot limits into display common, for box # IBOX
  !---------------------------------------------------------------------
  integer :: ibox                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  ! Local
  real :: x1, x2, y1, y2
  !------------------------------------------------------------------------
  ! Code:
  call sic_get_real('USER_XMIN',x1,error)
  call sic_get_real('USER_XMAX',x2,error)
  if (x2.gt.x1) then
    gb1_x(ibox) = x1
    gb2_x(ibox) = x2
  endif
  call sic_get_real('USER_YMIN',y1,error)
  call sic_get_real('USER_YMAX',y2,error)
  if (y2.gt.y1) then
    gb1_y(ibox) = y1
    gb2_y(ibox) = y2
  endif
  return
end subroutine save_limits
!
subroutine gr4_ident (np,x,y,id,ind,colour,bars,b,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Plot data with identifying markers
  !---------------------------------------------------------------------
  integer :: np                     ! number of points
  real :: x(np)                     ! coordinates
  real :: y(np)                     ! coordinates
  integer :: id(np)                 ! identifying numbers
  integer :: ind(np)                ! identifying numbers
  logical :: colour                 !
  logical :: bars                   !
  real :: b(np)                     ! Error bars
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'      ! needed for blank4, ...
  ! Local
  real :: size,dummy(1)
  integer :: i, j, sides, style, idlast, idsave, old_pen
  integer :: status, k, nc
  character(len=48) :: chain
  character(len=4) :: cloc
  !------------------------------------------------------------------------
  ! Code:
  ! first sort data according to ID (indexes in IND)
  call gi4_trie(id,ind,np,error)
  if (error) then
    call message(8,4,'GR4_IDENT','Error in sorting points')
    return
  endif
  !
  if (colour) then
    cloc = 'Y'
    !
    ! Compute maximum number of colours
    nc = 0
    do i=1,np
      nc = max(nc,id(i))
    enddo
    old_pen = gr_spen(0)
    !
    do k=1,nc
      status = gr_spen(mod(k-1,7))
      call gr_segm('IDENT',error)
      do i=1,np
        if (id(i).eq.k) then
          j = ind(i)
          call gr4_marker (1, x(j),y(j),   &
            blank4,d_blank4)
          if (bars) then
            call gr4_bars (cloc,1,   &
              x(j),y(j),b(j),dummy,   &
              blank4,d_blank4)
          endif
        endif
      enddo
      call gr_segm_close(error)
    enddo
    status = gr_spen(old_pen)
  else
    call gr_get_marker(sides,style,size)
    idlast = style + 1 + (sides-3)*4
    idsave = idlast
    call gr_set_marker(sides,style,size*3.0)
    do i=1, np
      if (id(i).ne.idlast) then
        idlast = id(i)
        sides = (idlast-1)/4 + 3
        style = idlast - (sides-3)*4 -1
        call gr_set_marker(sides,style,size*3.0)
        if (colour) then
          status = gr_spen(mod(idlast-1,7))
        endif
      endif
      j = ind(i)
      write(chain,100) x(j),y(j)
      call gr_exec1(chain)
      error = gr_error()
      if (error) return
    enddo
    sides = (idsave-1)/4 + 3
    style = idsave - (sides-3)*4 -1
    call gr_set_marker(sides,style,size)
  endif
  return
  !
100 format('DRAW MARKER ',1pg13.6,1x,1pg13.6,' /USER')
end subroutine gr4_ident
!
subroutine user_info(name)
  use gkernel_interfaces
  character(len=*) :: name          !
  ! Local
  character(len=20) :: date,user
  !------------------------------------------------------------------------
  ! Code:
  call sic_date(date)
  call sic_user(user)
  name = 'CLIC - '//date!//' - '//user
end subroutine user_info
!
subroutine getvar(md,mb,x_data,y_data,w_data)
  use gildas_def
  use gkernel_types
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Load the plot buffers with the contents of related variables
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ipnt, nd, nb
  type(sic_descriptor_t) :: descr
  logical :: found
  ! Code ----------------------------------------------------------------
  ! X_DATA
  call sic_descriptor ('X_DATA',descr,found)
  if (.not.found) return
  ipnt = gag_pointer(descr%addr,memory)
  nd = descr%dims(1)
  nb = descr%dims(2)
  call copyvar(memory(ipnt),md,nd,nb,x_data)
  ! Y_DATA
  call sic_descriptor ('Y_DATA',descr,found)
  if (.not.found) return
  ipnt = gag_pointer(descr%addr,memory)
  nd = descr%dims(1)
  nb = descr%dims(2)
  call copyvar(memory(ipnt),md,nd,nb,y_data)
  ! W_DATA
  call sic_descriptor ('W_DATA',descr,found)
  if (.not.found) return
  ipnt = gag_pointer(descr%addr,memory)
  nd = descr%dims(1)
  nb = descr%dims(2)
  call copyvar(memory(ipnt),md,nd,nb,w_data)
  return
end subroutine getvar
!
subroutine reset_time
  use gildas_def
  use classic_api
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'clic_xy_code.inc'
  include 'clic_par.inc'
  ! Local
  integer :: iy,isb,iba,i,k,km(2),kp(2), ir,ipol
  !
  km(1) = -mnant
  kp(1) = -1
  km(2) = 1
  kp(2) = mnbas
  !
  do ir=1, 2
    do iy=1, 2
      do isb=1, 3
        do k=1,2
          do ipol=1,3
            do iba = km(k), kp(k)
              f_spline(iy,isb,ipol,iba,ir) = 0
              n_knots(iy,isb,ipol,iba,ir) = 0
              do i=1, m_spl+4
                c_spline(i,iy,isb,ipol,iba,ir) = 0
              enddo
              do i=1, m_spl+8
                k_spline(i,iy,isb,ipol,iba,ir) = 0
              enddo
              do i=1, m_pol
                c_pol(i,iy,isb,ipol,iba,ir) = 0
              enddo
              n_pol(iy,isb,ipol,iba,ir) = 0
              f_pol(iy,isb,ipol,iba,ir) = 0
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo
  dobs_0 = 0
  change_display = .true.
  call message(6,1,'CLIC_PLOT','Time origin reset')
  call message(6,2,'CLIC_PLOT','Calibration curves reset')
end subroutine reset_time

!
!  ALMA - Atacama Large Millimeter Array
!  (c) European Southern Observatory, 2002
!  (c) Associated Universities Inc., 2002
!  Copyright by ESO (in the framework of the ALMA collaboration),
!  Copyright by AUI (in the framework of the ALMA collaboration),
!  All rights reserved.
!
!  This library is free software; you can redistribute it and/or
!  modify it under the terms of the GNU Lesser General Public
!  License as published by the Free software Foundation; either
!  version 2.1 of the License, or (at your option) any later version.
!
!  This library is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY, without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with this library; if not, write to the Free Software
!  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
!  MA 02111-1307  USA
!
!                                                                /
!   WARNING!  DO NOT MODIFY THIS FILE!
!    ---------------------------------------------------------
!   | This is generated code!  Do not modify this file.       |
!   | Any changes will be lost when the file is re-generated. |
!    ---------------------------------------------------------
!                                                                /
!
!  File sdm_enumerations.f90
!
module sdm_Enumerations
  integer, parameter ::  AssociatedCalNature_ASSOCIATED_EXECBLOCK=0
  integer, parameter ::  PolarizationType_R=0 , PolarizationType_L=1 , PolarizationType_X=2 , PolarizationType_Y=3
  integer, parameter ::  SyscalMethod_TEMPERATURE_SCALE=0 , SyscalMethod_SKYDIP=1
  integer, parameter ::  CalCurveType_AMPLITUDE=0 , CalCurveType_PHASE=1 , CalCurveType_UNDEFINED=2
  integer, parameter :: CalDataOrigin_TOTAL_POWER=0 , CalDataOrigin_WVR=1 , CalDataOrigin_CHANNEL_AVERAGE_AUTO=2 ,&
      & CalDataOrigin_CHANNEL_AVERAGE_CROSS=3 , CalDataOrigin_FULL_RESOLUTION_AUTO=4 ,&
      & CalDataOrigin_FULL_RESOLUTION_CROSS=5 , CalDataOrigin_OPTICAL_POINTING=6 , CalDataOrigin_HOLOGRAPHY=7 ,&
      & CalDataOrigin_NONE=8
  integer, parameter :: CalType_CAL_AMPLI=0 , CalType_CAL_ATMOSPHERE=1 , CalType_CAL_BANDPASS=2 , CalType_CAL_CURVE=3 ,&
      & CalType_CAL_DELAY=4 , CalType_CAL_FLUX=5 , CalType_CAL_FOCUS=6 , CalType_CAL_FOCUS_MODEL=7 , CalType_CAL_GAIN=8&
      & , CalType_CAL_HOLOGRAPHY=9 , CalType_CAL_PHASE=10 , CalType_CAL_POINTING=11 , CalType_CAL_POINTING_MODEL=12 ,&
      & CalType_CAL_POSITION=13 , CalType_CAL_PRIMARY_BEAM=14 , CalType_CAL_SEEING=15 , CalType_CAL_WVR=16
  integer, parameter :: ScanIntent_CALIBRATE_AMPLI=0 , ScanIntent_CALIBRATE_ATMOSPHERE=1 ,&
      & ScanIntent_CALIBRATE_BANDPASS=2 , ScanIntent_CALIBRATE_DELAY=3 , ScanIntent_CALIBRATE_FLUX=4 ,&
      & ScanIntent_CALIBRATE_FOCUS=5 , ScanIntent_CALIBRATE_FOCUS_X=6 , ScanIntent_CALIBRATE_FOCUS_Y=7 ,&
      & ScanIntent_CALIBRATE_PHASE=8 , ScanIntent_CALIBRATE_POINTING=9 , ScanIntent_CALIBRATE_POLARIZATION=10 ,&
      & ScanIntent_CALIBRATE_SIDEBAND_RATIO=11 , ScanIntent_CALIBRATE_WVR=12 , ScanIntent_DO_SKYDIP=13 ,&
      & ScanIntent_MAP_ANTENNA_SURFACE=14 , ScanIntent_MAP_PRIMARY_BEAM=15 , ScanIntent_OBSERVE_TARGET=16 ,&
      & ScanIntent_TEST=17 , ScanIntent_UNSPECIFIED=18
  integer, parameter :: StokesParameter_I=0 , StokesParameter_Q=1 , StokesParameter_U=2 , StokesParameter_V=3 ,&
      & StokesParameter_RR=4 , StokesParameter_RL=5 , StokesParameter_LR=6 , StokesParameter_LL=7 ,&
      & StokesParameter_XX=8 , StokesParameter_XY=9 , StokesParameter_YX=10 , StokesParameter_YY=11 ,&
      & StokesParameter_RX=12 , StokesParameter_RY=13 , StokesParameter_LX=14 , StokesParameter_LY=15 ,&
      & StokesParameter_XR=16 , StokesParameter_XL=17 , StokesParameter_YR=18 , StokesParameter_YL=19 ,&
      & StokesParameter_PP=20 , StokesParameter_PQ=21 , StokesParameter_QP=22 , StokesParameter_QQ=23 ,&
      & StokesParameter_RCIRCULAR=24 , StokesParameter_LCIRCULAR=25 , StokesParameter_LINEAR=26 ,&
      & StokesParameter_PTOTAL=27 , StokesParameter_PLINEAR=28 , StokesParameter_PFTOTAL=29 ,&
      & StokesParameter_PFLINEAR=30 , StokesParameter_PANGLE=31
  integer, parameter :: FluxCalibrationMethod_ABSOLUTE=0 , FluxCalibrationMethod_RELATIVE=1 ,&
      & FluxCalibrationMethod_EFFICIENCY=2
  integer, parameter :: CalibrationMode_HOLOGRAPHY=0 , CalibrationMode_INTERFEROMETRY=1 , CalibrationMode_OPTICAL=2 ,&
      & CalibrationMode_RADIOMETRY=3 , CalibrationMode_WVR=4
  integer, parameter ::  FocusMethod_THREE_POINT=0 , FocusMethod_FIVE_POINT=1
  integer, parameter :: PointingMethod_THREE_POINT=0 , PointingMethod_FOUR_POINT=1 , PointingMethod_FIVE_POINT=2 ,&
      & PointingMethod_CROSS=3 , PointingMethod_CIRCLE=4
  integer, parameter :: WindowFunction_UNIFORM=0 , WindowFunction_HANNING=1 , WindowFunction_HAMMING=2 ,&
      & WindowFunction_BARTLETT=3 , WindowFunction_BLACKMANN=4 , WindowFunction_BLACKMANN_HARRIS=5 ,&
      & WindowFunction_WELCH=6
  integer, parameter :: AssociatedFieldNature_ON=0 , AssociatedFieldNature_OFF=1 ,&
      & AssociatedFieldNature_PHASE_REFERENCE=2
  integer, parameter ::  ProcessorType_CORRELATOR=0 , ProcessorType_RADIOMETER=1 , ProcessorType_SPECTROMETER=2
  integer, parameter ::  SourceModel_GAUSSIAN=0 , SourceModel_POINT=1 , SourceModel_DISK=2
  integer, parameter ::  NetSideband_NOSB=0 , NetSideband_LSB=1 , NetSideband_USB=2 , NetSideband_DSB=3
  integer, parameter :: ReceiverSideband_NOSB=0 , ReceiverSideband_DSB=1 , ReceiverSideband_SSB=2 ,&
      & ReceiverSideband_TSB=3
  integer, parameter :: SidebandProcessingMode_NONE=0 , SidebandProcessingMode_PHASE_SWITCH_SEPARATION=1 ,&
      & SidebandProcessingMode_FREQUENCY_OFFSET_SEPARATION=2 , SidebandProcessingMode_PHASE_SWITCH_REJECTION=3 ,&
      & SidebandProcessingMode_FREQUENCY_OFFSET_REJECTION=4
  integer, parameter :: SwitchingMode_NO_SWITCHING=0 , SwitchingMode_LOAD_SWITCHING=1 ,&
      & SwitchingMode_POSITION_SWITCHING=2 , SwitchingMode_PHASE_SWITCHING=3 , SwitchingMode_FREQUENCY_SWITCHING=4 ,&
      & SwitchingMode_NUTATOR_SWITCHING=5 , SwitchingMode_CHOPPER_WHEEL=6
  integer, parameter ::  StationType_ANTENNA_PAD=0 , StationType_MAINTENANCE_PAD=1 , StationType_WEATHER_STATION=2
  integer, parameter :: SubscanIntent_ON_SOURCE=0 , SubscanIntent_OFF_SOURCE=1 , SubscanIntent_MIXED=2 ,&
      & SubscanIntent_REFERENCE=3 , SubscanIntent_SCANNING=4 , SubscanIntent_HOT=5 , SubscanIntent_AMBIENT=6 ,&
      & SubscanIntent_TEST=7 , SubscanIntent_UNSPECIFIED=8
  integer, parameter :: BasebandName_NOBB=0 , BasebandName_BB_1=1 , BasebandName_BB_2=2 , BasebandName_BB_3=3 ,&
      & BasebandName_BB_4=4 , BasebandName_BB_5=5 , BasebandName_BB_6=6 , BasebandName_BB_7=7 , BasebandName_BB_8=8 ,&
      & BasebandName_BB_ALL=9
  integer, parameter :: AxisName_TIM=0 , AxisName_BAL=1 , AxisName_ANT=2 , AxisName_BAB=3 , AxisName_SPW=4 ,&
      & AxisName_SIB=5 , AxisName_SUB=6 , AxisName_BIN=7 , AxisName_APC=8 , AxisName_SPP=9 , AxisName_POL=10 ,&
      & AxisName_STO=11 , AxisName_HOL=12
  integer, parameter :: DataContent_CROSS_DATA=0 , DataContent_AUTO_DATA=1 , DataContent_ZERO_LAGS=2 ,&
      & DataContent_ACTUAL_TIMES=3 , DataContent_ACTUAL_DURATIONS=4 , DataContent_WEIGHTS=5 , DataContent_FLAGS=6
  integer, parameter ::  AtmPhaseCorrection_AP_UNCORRECTED=0 , AtmPhaseCorrection_AP_CORRECTED=1
  integer, parameter :: PrimitiveDataType_INT16_TYPE=0 , PrimitiveDataType_INT32_TYPE=1 ,&
      & PrimitiveDataType_INT64_TYPE=2 , PrimitiveDataType_FLOAT32_TYPE=3 , PrimitiveDataType_FLOAT64_TYPE=4
  integer, parameter :: CorrelationMode_CROSS_ONLY=0 , CorrelationMode_AUTO_ONLY=1 , CorrelationMode_CROSS_AND_AUTO=2
  integer, parameter ::  WVRMethod_ATM_MODEL=0 , WVRMethod_EMPIRICAL=1
  integer, parameter ::  AccumMode_FAST=0 , AccumMode_NORMAL=1 , AccumMode_UNDEFINED=2
  integer, parameter ::  AntennaType_GROUND_BASED=0 , AntennaType_SPACE_BASED=1 , AntennaType_TRACKING_STN=2
  integer, parameter :: AntennaMake_AEM_12=0 , AntennaMake_MITSUBISHI_7=1 , AntennaMake_MITSUBISHI_12_A=2 ,&
      & AntennaMake_MITSUBISHI_12_B=3 , AntennaMake_VERTEX_12_ATF=4 , AntennaMake_AEM_12_ATF=5 ,&
      & AntennaMake_VERTEX_12=6 , AntennaMake_IRAM_15=7 , AntennaMake_UNDEFINED=8
  integer, parameter ::  PositionMethod_DELAY_FITTING=0 , PositionMethod_PHASE_FITTING=1
  integer, parameter ::  PointingModelMode_RADIO=0 , PointingModelMode_OPTICAL=1
  integer, parameter :: InvalidatingCondition_ANTENNA_DISCONNECT=0 , InvalidatingCondition_ANTENNA_MOVE=1 ,&
      & InvalidatingCondition_ANTENNA_POWER_DOWN=2 , InvalidatingCondition_RECEIVER_EXCHANGE=3 ,&
      & InvalidatingCondition_RECEIVER_POWER_DOWN=4
  integer, parameter :: SchedulerMode_DYNAMIC=0 , SchedulerMode_INTERACTIVE=1 , SchedulerMode_MANUAL=2 ,&
      & SchedulerMode_QUEUED=3
  integer, parameter ::  FieldCode_NONE=0
  integer, parameter :: HolographyChannelType_Q2=0 , HolographyChannelType_QR=1 , HolographyChannelType_QS=2 ,&
      & HolographyChannelType_R2=3 , HolographyChannelType_RS=4 , HolographyChannelType_S2=5
  integer, parameter :: ProcessorSubType_ALMA_CORRELATOR_MODE=0 , ProcessorSubType_SQUARE_LAW_DETECTOR=1 ,&
      & ProcessorSubType_HOLOGRAPHY=2 , ProcessorSubType_ALMA_RADIOMETER=3
  integer, parameter :: ReceiverBand_ALMA_RB_01=0 , ReceiverBand_ALMA_RB_02=1 , ReceiverBand_ALMA_RB_03=2 ,&
      & ReceiverBand_ALMA_RB_04=3 , ReceiverBand_ALMA_RB_05=4 , ReceiverBand_ALMA_RB_06=5 , ReceiverBand_ALMA_RB_07=6 ,&
      & ReceiverBand_ALMA_RB_08=7 , ReceiverBand_ALMA_RB_09=8 , ReceiverBand_ALMA_RB_10=9 , ReceiverBand_ALMA_RB_ALL=10&
      & , ReceiverBand_ALMA_HOLOGRAPHY_RECEIVER=11 , ReceiverBand_BURE_01=12 , ReceiverBand_BURE_02=13 ,&
      & ReceiverBand_BURE_03=14 , ReceiverBand_BURE_04=15 , ReceiverBand_UNSPECIFIED=16
  integer, parameter ::  SBType_OBSERVATORY=0 , SBType_OBSERVER=1 , SBType_EXPERT=2
  integer, parameter :: SpectralResolutionType_CHANNEL_AVERAGE=0 , SpectralResolutionType_BASEBAND_WIDE=1 ,&
      & SpectralResolutionType_FULL_RESOLUTION=2
  integer, parameter :: DetectorBandType_BASEBAND=0 , DetectorBandType_DOWN_CONVERTER=1 ,&
      & DetectorBandType_HOLOGRAPHY_RECEIVER=2 , DetectorBandType_SUBBAND=3
  integer, parameter :: FilterMode_FILTER_NA=0 , FilterMode_FILTER_TDM=1 , FilterMode_FILTER_TFB=2 ,&
      & FilterMode_UNDEFINED=3
  integer, parameter ::  CorrelationBit_BITS_2x2=0 , CorrelationBit_BITS_3x3=1 , CorrelationBit_BITS_4x4=2
  integer, parameter :: ACAPolarization_ACA_STANDARD=0 , ACAPolarization_ACA_XX_YY_SUM=1 , ACAPolarization_ACA_XX_50=2&
      & , ACAPolarization_ACA_YY_50=3
  integer, parameter :: CorrelatorCalibration_NONE=0 , CorrelatorCalibration_CORRELATOR_CALIBRATION=1 ,&
      & CorrelatorCalibration_REAL_OBSERVATION=2
  integer, parameter :: CorrelatorName_ALMA_ACA=0 , CorrelatorName_ALMA_BASELINE=1 , CorrelatorName_ALMA_BASELINE_ATF=2&
      & , CorrelatorName_ALMA_BASELINE_PROTO_OSF=3 , CorrelatorName_HERSCHEL=4 , CorrelatorName_IRAM_PDB=5 ,&
      & CorrelatorName_IRAM_30M_VESPA=6 , CorrelatorName_IRAM_WILMA=7 , CorrelatorName_NRAO_VLA=8 ,&
      & CorrelatorName_NRAO_WIDAR=9
  integer, parameter ::  TimeSampling_SUBINTEGRATION=0 , TimeSampling_INTEGRATION=1
  integer, parameter :: CalibrationDevice_AMBIENT_LOAD=0 , CalibrationDevice_COLD_LOAD=1 , CalibrationDevice_HOT_LOAD=2&
      & , CalibrationDevice_NOISE_TUBE_LOAD=3 , CalibrationDevice_QUARTER_WAVE_PLATE=4 ,&
      & CalibrationDevice_SOLAR_FILTER=5 , CalibrationDevice_NONE=6
  integer, parameter :: AntennaMotionPattern_NONE=0 , AntennaMotionPattern_CROSS_SCAN=1 , AntennaMotionPattern_SPIRAL=2&
      & , AntennaMotionPattern_CIRCLE=3 , AntennaMotionPattern_THREE_POINTS=4 , AntennaMotionPattern_FOUR_POINTS=5 ,&
      & AntennaMotionPattern_FIVE_POINTS=6 , AntennaMotionPattern_TEST=7 , AntennaMotionPattern_UNSPECIFIED=8
  integer, parameter :: CalibrationFunction_FIRST=0 , CalibrationFunction_LAST=1 , CalibrationFunction_UNSPECIFIED=2
  integer, parameter :: CalibrationSet_NONE=0 , CalibrationSet_AMPLI_CURVE=1 , CalibrationSet_ANTENNA_POSITIONS=2 ,&
      & CalibrationSet_PHASE_CURVE=3 , CalibrationSet_POINTING_MODEL=4 , CalibrationSet_ACCUMULATE=5 ,&
      & CalibrationSet_TEST=6 , CalibrationSet_UNSPECIFIED=7
  integer, parameter :: PositionReferenceCode_ITRF=0 , PositionReferenceCode_WGS84=1 , PositionReferenceCode_SITE=2 ,&
      & PositionReferenceCode_STATION=3 , PositionReferenceCode_YOKE=4 , PositionReferenceCode_REFLECTOR=5
  integer, parameter :: DirectionReferenceCode_J2000=0 , DirectionReferenceCode_JMEAN=1 ,&
      & DirectionReferenceCode_JTRUE=2 , DirectionReferenceCode_APP=3 , DirectionReferenceCode_B1950=4 ,&
      & DirectionReferenceCode_B1950_VLA=5 , DirectionReferenceCode_BMEAN=6 , DirectionReferenceCode_BTRUE=7 ,&
      & DirectionReferenceCode_GALACTIC=8 , DirectionReferenceCode_HADEC=9 , DirectionReferenceCode_AZELSW=10 ,&
      & DirectionReferenceCode_AZELSWGEO=11 , DirectionReferenceCode_AZELNE=12 , DirectionReferenceCode_AZELNEGEO=13 ,&
      & DirectionReferenceCode_JNAT=14 , DirectionReferenceCode_ECLIPTIC=15 , DirectionReferenceCode_MECLIPTIC=16 ,&
      & DirectionReferenceCode_TECLIPTIC=17 , DirectionReferenceCode_SUPERGAL=18 , DirectionReferenceCode_ITRF=19 ,&
      & DirectionReferenceCode_TOPO=20 , DirectionReferenceCode_ICRS=21 , DirectionReferenceCode_MERCURY=22 ,&
      & DirectionReferenceCode_VENUS=23 , DirectionReferenceCode_MARS=24 , DirectionReferenceCode_JUPITER=25 ,&
      & DirectionReferenceCode_SATURN=26 , DirectionReferenceCode_URANUS=27 , DirectionReferenceCode_NEPTUNE=28 ,&
      & DirectionReferenceCode_PLUTO=29 , DirectionReferenceCode_SUN=30 , DirectionReferenceCode_MOON=31
  integer, parameter :: BaselineReferenceCode_J2000=0 , BaselineReferenceCode_B1950=1 ,&
      & BaselineReferenceCode_GALACTIC=2 , BaselineReferenceCode_SUPERGAL=3 , BaselineReferenceCode_ECLIPTIC=4 ,&
      & BaselineReferenceCode_JMEAN=5 , BaselineReferenceCode_JTRUE=6 , BaselineReferenceCode_APP=7 ,&
      & BaselineReferenceCode_BMEAN=8 , BaselineReferenceCode_BTRUE=9 , BaselineReferenceCode_JNAT=10 ,&
      & BaselineReferenceCode_MECLIPTIC=11 , BaselineReferenceCode_TECLIPTIC=12 , BaselineReferenceCode_TOPO=13 ,&
      & BaselineReferenceCode_MERCURY=14 , BaselineReferenceCode_VENUS=15 , BaselineReferenceCode_MARS=16 ,&
      & BaselineReferenceCode_JUPITER=17 , BaselineReferenceCode_SATURN=18 , BaselineReferenceCode_NEPTUN=19 ,&
      & BaselineReferenceCode_SUN=20 , BaselineReferenceCode_MOON=21 , BaselineReferenceCode_HADEC=22 ,&
      & BaselineReferenceCode_AZEL=23 , BaselineReferenceCode_AZELGEO=24 , BaselineReferenceCode_AZELSW=25 ,&
      & BaselineReferenceCode_AZELNE=26 , BaselineReferenceCode_ITRF=27
  integer, parameter :: FrequencyReferenceCode_LABREST=0 , FrequencyReferenceCode_LSRD=1 ,&
      & FrequencyReferenceCode_LSRK=2 , FrequencyReferenceCode_BARY=3 , FrequencyReferenceCode_REST=4 ,&
      & FrequencyReferenceCode_GEO=5 , FrequencyReferenceCode_GALACTO=6 , FrequencyReferenceCode_TOPO=7
  integer, parameter :: RadialVelocityReferenceCode_LSRD=0 , RadialVelocityReferenceCode_LSRK=1 ,&
      & RadialVelocityReferenceCode_GALACTO=2 , RadialVelocityReferenceCode_BARY=3 , RadialVelocityReferenceCode_GEO=4&
      & , RadialVelocityReferenceCode_TOPO=5
  integer, parameter :: DopplerReferenceCode_RADIO=0 , DopplerReferenceCode_Z=1 , DopplerReferenceCode_RATIO=2 ,&
      & DopplerReferenceCode_BETA=3 , DopplerReferenceCode_GAMMA=4 , DopplerReferenceCode_OPTICAL=5 ,&
      & DopplerReferenceCode_RELATIVISTIC=6
  integer, parameter ::  CorrelatorType_FX=0 , CorrelatorType_XF=1 , CorrelatorType_FXF=2
contains
!
  function AssociatedCalNature_toString(i)
    integer :: i
    character*80 :: AssociatedCalNature_toString
    select case(i)
    case(AssociatedCalNature_ASSOCIATED_EXECBLOCK)
       AssociatedCalNature_toString = 'ASSOCIATED_EXECBLOCK'
    end select
  end function AssociatedCalNature_toString
!
  function AssociatedCalNature_fromString(str)
    integer :: AssociatedCalNature_fromString
    character*80 :: str
    select case(str)
    case('ASSOCIATED_EXECBLOCK')
       AssociatedCalNature_fromString = AssociatedCalNature_ASSOCIATED_EXECBLOCK
    end select
  end function AssociatedCalNature_fromString
!
  function PolarizationType_toString(i)
    integer :: i
    character*80 :: PolarizationType_toString
    select case(i)
    case(PolarizationType_R)
       PolarizationType_toString = 'R'
    case(PolarizationType_L)
       PolarizationType_toString = 'L'
    case(PolarizationType_X)
       PolarizationType_toString = 'X'
    case(PolarizationType_Y)
       PolarizationType_toString = 'Y'
    end select
  end function PolarizationType_toString
!
  function PolarizationType_fromString(str)
    integer :: PolarizationType_fromString
    character*80 :: str
    select case(str)
    case('R')
       PolarizationType_fromString = PolarizationType_R
    case('L')
       PolarizationType_fromString = PolarizationType_L
    case('X')
       PolarizationType_fromString = PolarizationType_X
    case('Y')
       PolarizationType_fromString = PolarizationType_Y
    end select
  end function PolarizationType_fromString
!
  function SyscalMethod_toString(i)
    integer :: i
    character*80 :: SyscalMethod_toString
    select case(i)
    case(SyscalMethod_TEMPERATURE_SCALE)
       SyscalMethod_toString = 'TEMPERATURE_SCALE'
    case(SyscalMethod_SKYDIP)
       SyscalMethod_toString = 'SKYDIP'
    end select
  end function SyscalMethod_toString
!
  function SyscalMethod_fromString(str)
    integer :: SyscalMethod_fromString
    character*80 :: str
    select case(str)
    case('TEMPERATURE_SCALE')
       SyscalMethod_fromString = SyscalMethod_TEMPERATURE_SCALE
    case('SKYDIP')
       SyscalMethod_fromString = SyscalMethod_SKYDIP
    end select
  end function SyscalMethod_fromString
!
  function CalCurveType_toString(i)
    integer :: i
    character*80 :: CalCurveType_toString
    select case(i)
    case(CalCurveType_AMPLITUDE)
       CalCurveType_toString = 'AMPLITUDE'
    case(CalCurveType_PHASE)
       CalCurveType_toString = 'PHASE'
    case(CalCurveType_UNDEFINED)
       CalCurveType_toString = 'UNDEFINED'
    end select
  end function CalCurveType_toString
!
  function CalCurveType_fromString(str)
    integer :: CalCurveType_fromString
    character*80 :: str
    select case(str)
    case('AMPLITUDE')
       CalCurveType_fromString = CalCurveType_AMPLITUDE
    case('PHASE')
       CalCurveType_fromString = CalCurveType_PHASE
    case('UNDEFINED')
       CalCurveType_fromString = CalCurveType_UNDEFINED
    end select
  end function CalCurveType_fromString
!
  function CalDataOrigin_toString(i)
    integer :: i
    character*80 :: CalDataOrigin_toString
    select case(i)
    case(CalDataOrigin_TOTAL_POWER)
       CalDataOrigin_toString = 'TOTAL_POWER'
    case(CalDataOrigin_WVR)
       CalDataOrigin_toString = 'WVR'
    case(CalDataOrigin_CHANNEL_AVERAGE_AUTO)
       CalDataOrigin_toString = 'CHANNEL_AVERAGE_AUTO'
    case(CalDataOrigin_CHANNEL_AVERAGE_CROSS)
       CalDataOrigin_toString = 'CHANNEL_AVERAGE_CROSS'
    case(CalDataOrigin_FULL_RESOLUTION_AUTO)
       CalDataOrigin_toString = 'FULL_RESOLUTION_AUTO'
    case(CalDataOrigin_FULL_RESOLUTION_CROSS)
       CalDataOrigin_toString = 'FULL_RESOLUTION_CROSS'
    case(CalDataOrigin_OPTICAL_POINTING)
       CalDataOrigin_toString = 'OPTICAL_POINTING'
    case(CalDataOrigin_HOLOGRAPHY)
       CalDataOrigin_toString = 'HOLOGRAPHY'
    case(CalDataOrigin_NONE)
       CalDataOrigin_toString = 'NONE'
    end select
  end function CalDataOrigin_toString
!
  function CalDataOrigin_fromString(str)
    integer :: CalDataOrigin_fromString
    character*80 :: str
    select case(str)
    case('TOTAL_POWER')
       CalDataOrigin_fromString = CalDataOrigin_TOTAL_POWER
    case('WVR')
       CalDataOrigin_fromString = CalDataOrigin_WVR
    case('CHANNEL_AVERAGE_AUTO')
       CalDataOrigin_fromString = CalDataOrigin_CHANNEL_AVERAGE_AUTO
    case('CHANNEL_AVERAGE_CROSS')
       CalDataOrigin_fromString = CalDataOrigin_CHANNEL_AVERAGE_CROSS
    case('FULL_RESOLUTION_AUTO')
       CalDataOrigin_fromString = CalDataOrigin_FULL_RESOLUTION_AUTO
    case('FULL_RESOLUTION_CROSS')
       CalDataOrigin_fromString = CalDataOrigin_FULL_RESOLUTION_CROSS
    case('OPTICAL_POINTING')
       CalDataOrigin_fromString = CalDataOrigin_OPTICAL_POINTING
    case('HOLOGRAPHY')
       CalDataOrigin_fromString = CalDataOrigin_HOLOGRAPHY
    case('NONE')
       CalDataOrigin_fromString = CalDataOrigin_NONE
    end select
  end function CalDataOrigin_fromString
!
  function CalType_toString(i)
    integer :: i
    character*80 :: CalType_toString
    select case(i)
    case(CalType_CAL_AMPLI)
       CalType_toString = 'CAL_AMPLI'
    case(CalType_CAL_ATMOSPHERE)
       CalType_toString = 'CAL_ATMOSPHERE'
    case(CalType_CAL_BANDPASS)
       CalType_toString = 'CAL_BANDPASS'
    case(CalType_CAL_CURVE)
       CalType_toString = 'CAL_CURVE'
    case(CalType_CAL_DELAY)
       CalType_toString = 'CAL_DELAY'
    case(CalType_CAL_FLUX)
       CalType_toString = 'CAL_FLUX'
    case(CalType_CAL_FOCUS)
       CalType_toString = 'CAL_FOCUS'
    case(CalType_CAL_FOCUS_MODEL)
       CalType_toString = 'CAL_FOCUS_MODEL'
    case(CalType_CAL_GAIN)
       CalType_toString = 'CAL_GAIN'
    case(CalType_CAL_HOLOGRAPHY)
       CalType_toString = 'CAL_HOLOGRAPHY'
    case(CalType_CAL_PHASE)
       CalType_toString = 'CAL_PHASE'
    case(CalType_CAL_POINTING)
       CalType_toString = 'CAL_POINTING'
    case(CalType_CAL_POINTING_MODEL)
       CalType_toString = 'CAL_POINTING_MODEL'
    case(CalType_CAL_POSITION)
       CalType_toString = 'CAL_POSITION'
    case(CalType_CAL_PRIMARY_BEAM)
       CalType_toString = 'CAL_PRIMARY_BEAM'
    case(CalType_CAL_SEEING)
       CalType_toString = 'CAL_SEEING'
    case(CalType_CAL_WVR)
       CalType_toString = 'CAL_WVR'
    end select
  end function CalType_toString
!
  function CalType_fromString(str)
    integer :: CalType_fromString
    character*80 :: str
    select case(str)
    case('CAL_AMPLI')
       CalType_fromString = CalType_CAL_AMPLI
    case('CAL_ATMOSPHERE')
       CalType_fromString = CalType_CAL_ATMOSPHERE
    case('CAL_BANDPASS')
       CalType_fromString = CalType_CAL_BANDPASS
    case('CAL_CURVE')
       CalType_fromString = CalType_CAL_CURVE
    case('CAL_DELAY')
       CalType_fromString = CalType_CAL_DELAY
    case('CAL_FLUX')
       CalType_fromString = CalType_CAL_FLUX
    case('CAL_FOCUS')
       CalType_fromString = CalType_CAL_FOCUS
    case('CAL_FOCUS_MODEL')
       CalType_fromString = CalType_CAL_FOCUS_MODEL
    case('CAL_GAIN')
       CalType_fromString = CalType_CAL_GAIN
    case('CAL_HOLOGRAPHY')
       CalType_fromString = CalType_CAL_HOLOGRAPHY
    case('CAL_PHASE')
       CalType_fromString = CalType_CAL_PHASE
    case('CAL_POINTING')
       CalType_fromString = CalType_CAL_POINTING
    case('CAL_POINTING_MODEL')
       CalType_fromString = CalType_CAL_POINTING_MODEL
    case('CAL_POSITION')
       CalType_fromString = CalType_CAL_POSITION
    case('CAL_PRIMARY_BEAM')
       CalType_fromString = CalType_CAL_PRIMARY_BEAM
    case('CAL_SEEING')
       CalType_fromString = CalType_CAL_SEEING
    case('CAL_WVR')
       CalType_fromString = CalType_CAL_WVR
    end select
  end function CalType_fromString
!
  function ScanIntent_toString(i)
    integer :: i
    character*80 :: ScanIntent_toString
    select case(i)
    case(ScanIntent_CALIBRATE_AMPLI)
       ScanIntent_toString = 'CALIBRATE_AMPLI'
    case(ScanIntent_CALIBRATE_ATMOSPHERE)
       ScanIntent_toString = 'CALIBRATE_ATMOSPHERE'
    case(ScanIntent_CALIBRATE_BANDPASS)
       ScanIntent_toString = 'CALIBRATE_BANDPASS'
    case(ScanIntent_CALIBRATE_DELAY)
       ScanIntent_toString = 'CALIBRATE_DELAY'
    case(ScanIntent_CALIBRATE_FLUX)
       ScanIntent_toString = 'CALIBRATE_FLUX'
    case(ScanIntent_CALIBRATE_FOCUS)
       ScanIntent_toString = 'CALIBRATE_FOCUS'
    case(ScanIntent_CALIBRATE_FOCUS_X)
       ScanIntent_toString = 'CALIBRATE_FOCUS_X'
    case(ScanIntent_CALIBRATE_FOCUS_Y)
       ScanIntent_toString = 'CALIBRATE_FOCUS_Y'
    case(ScanIntent_CALIBRATE_PHASE)
       ScanIntent_toString = 'CALIBRATE_PHASE'
    case(ScanIntent_CALIBRATE_POINTING)
       ScanIntent_toString = 'CALIBRATE_POINTING'
    case(ScanIntent_CALIBRATE_POLARIZATION)
       ScanIntent_toString = 'CALIBRATE_POLARIZATION'
    case(ScanIntent_CALIBRATE_SIDEBAND_RATIO)
       ScanIntent_toString = 'CALIBRATE_SIDEBAND_RATIO'
    case(ScanIntent_CALIBRATE_WVR)
       ScanIntent_toString = 'CALIBRATE_WVR'
    case(ScanIntent_DO_SKYDIP)
       ScanIntent_toString = 'DO_SKYDIP'
    case(ScanIntent_MAP_ANTENNA_SURFACE)
       ScanIntent_toString = 'MAP_ANTENNA_SURFACE'
    case(ScanIntent_MAP_PRIMARY_BEAM)
       ScanIntent_toString = 'MAP_PRIMARY_BEAM'
    case(ScanIntent_OBSERVE_TARGET)
       ScanIntent_toString = 'OBSERVE_TARGET'
    case(ScanIntent_TEST)
       ScanIntent_toString = 'TEST'
    case(ScanIntent_UNSPECIFIED)
       ScanIntent_toString = 'UNSPECIFIED'
    end select
  end function ScanIntent_toString
!
  function ScanIntent_fromString(str)
    integer :: ScanIntent_fromString
    character*80 :: str
    select case(str)
    case('CALIBRATE_AMPLI')
       ScanIntent_fromString = ScanIntent_CALIBRATE_AMPLI
    case('CALIBRATE_ATMOSPHERE')
       ScanIntent_fromString = ScanIntent_CALIBRATE_ATMOSPHERE
    case('CALIBRATE_BANDPASS')
       ScanIntent_fromString = ScanIntent_CALIBRATE_BANDPASS
    case('CALIBRATE_DELAY')
       ScanIntent_fromString = ScanIntent_CALIBRATE_DELAY
    case('CALIBRATE_FLUX')
       ScanIntent_fromString = ScanIntent_CALIBRATE_FLUX
    case('CALIBRATE_FOCUS')
       ScanIntent_fromString = ScanIntent_CALIBRATE_FOCUS
    case('CALIBRATE_FOCUS_X')
       ScanIntent_fromString = ScanIntent_CALIBRATE_FOCUS_X
    case('CALIBRATE_FOCUS_Y')
       ScanIntent_fromString = ScanIntent_CALIBRATE_FOCUS_Y
    case('CALIBRATE_PHASE')
       ScanIntent_fromString = ScanIntent_CALIBRATE_PHASE
    case('CALIBRATE_POINTING')
       ScanIntent_fromString = ScanIntent_CALIBRATE_POINTING
    case('CALIBRATE_POLARIZATION')
       ScanIntent_fromString = ScanIntent_CALIBRATE_POLARIZATION
    case('CALIBRATE_SIDEBAND_RATIO')
       ScanIntent_fromString = ScanIntent_CALIBRATE_SIDEBAND_RATIO
    case('CALIBRATE_WVR')
       ScanIntent_fromString = ScanIntent_CALIBRATE_WVR
    case('DO_SKYDIP')
       ScanIntent_fromString = ScanIntent_DO_SKYDIP
    case('MAP_ANTENNA_SURFACE')
       ScanIntent_fromString = ScanIntent_MAP_ANTENNA_SURFACE
    case('MAP_PRIMARY_BEAM')
       ScanIntent_fromString = ScanIntent_MAP_PRIMARY_BEAM
    case('OBSERVE_TARGET')
       ScanIntent_fromString = ScanIntent_OBSERVE_TARGET
    case('TEST')
       ScanIntent_fromString = ScanIntent_TEST
    case('UNSPECIFIED')
       ScanIntent_fromString = ScanIntent_UNSPECIFIED
    end select
  end function ScanIntent_fromString
!
  function StokesParameter_toString(i)
    integer :: i
    character*80 :: StokesParameter_toString
    select case(i)
    case(StokesParameter_I)
       StokesParameter_toString = 'I'
    case(StokesParameter_Q)
       StokesParameter_toString = 'Q'
    case(StokesParameter_U)
       StokesParameter_toString = 'U'
    case(StokesParameter_V)
       StokesParameter_toString = 'V'
    case(StokesParameter_RR)
       StokesParameter_toString = 'RR'
    case(StokesParameter_RL)
       StokesParameter_toString = 'RL'
    case(StokesParameter_LR)
       StokesParameter_toString = 'LR'
    case(StokesParameter_LL)
       StokesParameter_toString = 'LL'
    case(StokesParameter_XX)
       StokesParameter_toString = 'XX'
    case(StokesParameter_XY)
       StokesParameter_toString = 'XY'
    case(StokesParameter_YX)
       StokesParameter_toString = 'YX'
    case(StokesParameter_YY)
       StokesParameter_toString = 'YY'
    case(StokesParameter_RX)
       StokesParameter_toString = 'RX'
    case(StokesParameter_RY)
       StokesParameter_toString = 'RY'
    case(StokesParameter_LX)
       StokesParameter_toString = 'LX'
    case(StokesParameter_LY)
       StokesParameter_toString = 'LY'
    case(StokesParameter_XR)
       StokesParameter_toString = 'XR'
    case(StokesParameter_XL)
       StokesParameter_toString = 'XL'
    case(StokesParameter_YR)
       StokesParameter_toString = 'YR'
    case(StokesParameter_YL)
       StokesParameter_toString = 'YL'
    case(StokesParameter_PP)
       StokesParameter_toString = 'PP'
    case(StokesParameter_PQ)
       StokesParameter_toString = 'PQ'
    case(StokesParameter_QP)
       StokesParameter_toString = 'QP'
    case(StokesParameter_QQ)
       StokesParameter_toString = 'QQ'
    case(StokesParameter_RCIRCULAR)
       StokesParameter_toString = 'RCIRCULAR'
    case(StokesParameter_LCIRCULAR)
       StokesParameter_toString = 'LCIRCULAR'
    case(StokesParameter_LINEAR)
       StokesParameter_toString = 'LINEAR'
    case(StokesParameter_PTOTAL)
       StokesParameter_toString = 'PTOTAL'
    case(StokesParameter_PLINEAR)
       StokesParameter_toString = 'PLINEAR'
    case(StokesParameter_PFTOTAL)
       StokesParameter_toString = 'PFTOTAL'
    case(StokesParameter_PFLINEAR)
       StokesParameter_toString = 'PFLINEAR'
    case(StokesParameter_PANGLE)
       StokesParameter_toString = 'PANGLE'
    end select
  end function StokesParameter_toString
!
  function StokesParameter_fromString(str)
    integer :: StokesParameter_fromString
    character*80 :: str
    select case(str)
    case('I')
       StokesParameter_fromString = StokesParameter_I
    case('Q')
       StokesParameter_fromString = StokesParameter_Q
    case('U')
       StokesParameter_fromString = StokesParameter_U
    case('V')
       StokesParameter_fromString = StokesParameter_V
    case('RR')
       StokesParameter_fromString = StokesParameter_RR
    case('RL')
       StokesParameter_fromString = StokesParameter_RL
    case('LR')
       StokesParameter_fromString = StokesParameter_LR
    case('LL')
       StokesParameter_fromString = StokesParameter_LL
    case('XX')
       StokesParameter_fromString = StokesParameter_XX
    case('XY')
       StokesParameter_fromString = StokesParameter_XY
    case('YX')
       StokesParameter_fromString = StokesParameter_YX
    case('YY')
       StokesParameter_fromString = StokesParameter_YY
    case('RX')
       StokesParameter_fromString = StokesParameter_RX
    case('RY')
       StokesParameter_fromString = StokesParameter_RY
    case('LX')
       StokesParameter_fromString = StokesParameter_LX
    case('LY')
       StokesParameter_fromString = StokesParameter_LY
    case('XR')
       StokesParameter_fromString = StokesParameter_XR
    case('XL')
       StokesParameter_fromString = StokesParameter_XL
    case('YR')
       StokesParameter_fromString = StokesParameter_YR
    case('YL')
       StokesParameter_fromString = StokesParameter_YL
    case('PP')
       StokesParameter_fromString = StokesParameter_PP
    case('PQ')
       StokesParameter_fromString = StokesParameter_PQ
    case('QP')
       StokesParameter_fromString = StokesParameter_QP
    case('QQ')
       StokesParameter_fromString = StokesParameter_QQ
    case('RCIRCULAR')
       StokesParameter_fromString = StokesParameter_RCIRCULAR
    case('LCIRCULAR')
       StokesParameter_fromString = StokesParameter_LCIRCULAR
    case('LINEAR')
       StokesParameter_fromString = StokesParameter_LINEAR
    case('PTOTAL')
       StokesParameter_fromString = StokesParameter_PTOTAL
    case('PLINEAR')
       StokesParameter_fromString = StokesParameter_PLINEAR
    case('PFTOTAL')
       StokesParameter_fromString = StokesParameter_PFTOTAL
    case('PFLINEAR')
       StokesParameter_fromString = StokesParameter_PFLINEAR
    case('PANGLE')
       StokesParameter_fromString = StokesParameter_PANGLE
    end select
  end function StokesParameter_fromString
!
  function FluxCalibrationMethod_toString(i)
    integer :: i
    character*80 :: FluxCalibrationMethod_toString
    select case(i)
    case(FluxCalibrationMethod_ABSOLUTE)
       FluxCalibrationMethod_toString = 'ABSOLUTE'
    case(FluxCalibrationMethod_RELATIVE)
       FluxCalibrationMethod_toString = 'RELATIVE'
    case(FluxCalibrationMethod_EFFICIENCY)
       FluxCalibrationMethod_toString = 'EFFICIENCY'
    end select
  end function FluxCalibrationMethod_toString
!
  function FluxCalibrationMethod_fromString(str)
    integer :: FluxCalibrationMethod_fromString
    character*80 :: str
    select case(str)
    case('ABSOLUTE')
       FluxCalibrationMethod_fromString = FluxCalibrationMethod_ABSOLUTE
    case('RELATIVE')
       FluxCalibrationMethod_fromString = FluxCalibrationMethod_RELATIVE
    case('EFFICIENCY')
       FluxCalibrationMethod_fromString = FluxCalibrationMethod_EFFICIENCY
    end select
  end function FluxCalibrationMethod_fromString
!
  function CalibrationMode_toString(i)
    integer :: i
    character*80 :: CalibrationMode_toString
    select case(i)
    case(CalibrationMode_HOLOGRAPHY)
       CalibrationMode_toString = 'HOLOGRAPHY'
    case(CalibrationMode_INTERFEROMETRY)
       CalibrationMode_toString = 'INTERFEROMETRY'
    case(CalibrationMode_OPTICAL)
       CalibrationMode_toString = 'OPTICAL'
    case(CalibrationMode_RADIOMETRY)
       CalibrationMode_toString = 'RADIOMETRY'
    case(CalibrationMode_WVR)
       CalibrationMode_toString = 'WVR'
    end select
  end function CalibrationMode_toString
!
  function CalibrationMode_fromString(str)
    integer :: CalibrationMode_fromString
    character*80 :: str
    select case(str)
    case('HOLOGRAPHY')
       CalibrationMode_fromString = CalibrationMode_HOLOGRAPHY
    case('INTERFEROMETRY')
       CalibrationMode_fromString = CalibrationMode_INTERFEROMETRY
    case('OPTICAL')
       CalibrationMode_fromString = CalibrationMode_OPTICAL
    case('RADIOMETRY')
       CalibrationMode_fromString = CalibrationMode_RADIOMETRY
    case('WVR')
       CalibrationMode_fromString = CalibrationMode_WVR
    end select
  end function CalibrationMode_fromString
!
  function FocusMethod_toString(i)
    integer :: i
    character*80 :: FocusMethod_toString
    select case(i)
    case(FocusMethod_THREE_POINT)
       FocusMethod_toString = 'THREE_POINT'
    case(FocusMethod_FIVE_POINT)
       FocusMethod_toString = 'FIVE_POINT'
    end select
  end function FocusMethod_toString
!
  function FocusMethod_fromString(str)
    integer :: FocusMethod_fromString
    character*80 :: str
    select case(str)
    case('THREE_POINT')
       FocusMethod_fromString = FocusMethod_THREE_POINT
    case('FIVE_POINT')
       FocusMethod_fromString = FocusMethod_FIVE_POINT
    end select
  end function FocusMethod_fromString
!
  function PointingMethod_toString(i)
    integer :: i
    character*80 :: PointingMethod_toString
    select case(i)
    case(PointingMethod_THREE_POINT)
       PointingMethod_toString = 'THREE_POINT'
    case(PointingMethod_FOUR_POINT)
       PointingMethod_toString = 'FOUR_POINT'
    case(PointingMethod_FIVE_POINT)
       PointingMethod_toString = 'FIVE_POINT'
    case(PointingMethod_CROSS)
       PointingMethod_toString = 'CROSS'
    case(PointingMethod_CIRCLE)
       PointingMethod_toString = 'CIRCLE'
    end select
  end function PointingMethod_toString
!
  function PointingMethod_fromString(str)
    integer :: PointingMethod_fromString
    character*80 :: str
    select case(str)
    case('THREE_POINT')
       PointingMethod_fromString = PointingMethod_THREE_POINT
    case('FOUR_POINT')
       PointingMethod_fromString = PointingMethod_FOUR_POINT
    case('FIVE_POINT')
       PointingMethod_fromString = PointingMethod_FIVE_POINT
    case('CROSS')
       PointingMethod_fromString = PointingMethod_CROSS
    case('CIRCLE')
       PointingMethod_fromString = PointingMethod_CIRCLE
    end select
  end function PointingMethod_fromString
!
  function WindowFunction_toString(i)
    integer :: i
    character*80 :: WindowFunction_toString
    select case(i)
    case(WindowFunction_UNIFORM)
       WindowFunction_toString = 'UNIFORM'
    case(WindowFunction_HANNING)
       WindowFunction_toString = 'HANNING'
    case(WindowFunction_HAMMING)
       WindowFunction_toString = 'HAMMING'
    case(WindowFunction_BARTLETT)
       WindowFunction_toString = 'BARTLETT'
    case(WindowFunction_BLACKMANN)
       WindowFunction_toString = 'BLACKMANN'
    case(WindowFunction_BLACKMANN_HARRIS)
       WindowFunction_toString = 'BLACKMANN_HARRIS'
    case(WindowFunction_WELCH)
       WindowFunction_toString = 'WELCH'
    end select
  end function WindowFunction_toString
!
  function WindowFunction_fromString(str)
    integer :: WindowFunction_fromString
    character*80 :: str
    select case(str)
    case('UNIFORM')
       WindowFunction_fromString = WindowFunction_UNIFORM
    case('HANNING')
       WindowFunction_fromString = WindowFunction_HANNING
    case('HAMMING')
       WindowFunction_fromString = WindowFunction_HAMMING
    case('BARTLETT')
       WindowFunction_fromString = WindowFunction_BARTLETT
    case('BLACKMANN')
       WindowFunction_fromString = WindowFunction_BLACKMANN
    case('BLACKMANN_HARRIS')
       WindowFunction_fromString = WindowFunction_BLACKMANN_HARRIS
    case('WELCH')
       WindowFunction_fromString = WindowFunction_WELCH
    end select
  end function WindowFunction_fromString
!
  function AssociatedFieldNature_toString(i)
    integer :: i
    character*80 :: AssociatedFieldNature_toString
    select case(i)
    case(AssociatedFieldNature_ON)
       AssociatedFieldNature_toString = 'ON'
    case(AssociatedFieldNature_OFF)
       AssociatedFieldNature_toString = 'OFF'
    case(AssociatedFieldNature_PHASE_REFERENCE)
       AssociatedFieldNature_toString = 'PHASE_REFERENCE'
    end select
  end function AssociatedFieldNature_toString
!
  function AssociatedFieldNature_fromString(str)
    integer :: AssociatedFieldNature_fromString
    character*80 :: str
    select case(str)
    case('ON')
       AssociatedFieldNature_fromString = AssociatedFieldNature_ON
    case('OFF')
       AssociatedFieldNature_fromString = AssociatedFieldNature_OFF
    case('PHASE_REFERENCE')
       AssociatedFieldNature_fromString = AssociatedFieldNature_PHASE_REFERENCE
    end select
  end function AssociatedFieldNature_fromString
!
  function ProcessorType_toString(i)
    integer :: i
    character*80 :: ProcessorType_toString
    select case(i)
    case(ProcessorType_CORRELATOR)
       ProcessorType_toString = 'CORRELATOR'
    case(ProcessorType_RADIOMETER)
       ProcessorType_toString = 'RADIOMETER'
    case(ProcessorType_SPECTROMETER)
       ProcessorType_toString = 'SPECTROMETER'
    end select
  end function ProcessorType_toString
!
  function ProcessorType_fromString(str)
    integer :: ProcessorType_fromString
    character*80 :: str
    select case(str)
    case('CORRELATOR')
       ProcessorType_fromString = ProcessorType_CORRELATOR
    case('RADIOMETER')
       ProcessorType_fromString = ProcessorType_RADIOMETER
    case('SPECTROMETER')
       ProcessorType_fromString = ProcessorType_SPECTROMETER
    end select
  end function ProcessorType_fromString
!
  function SourceModel_toString(i)
    integer :: i
    character*80 :: SourceModel_toString
    select case(i)
    case(SourceModel_GAUSSIAN)
       SourceModel_toString = 'GAUSSIAN'
    case(SourceModel_POINT)
       SourceModel_toString = 'POINT'
    case(SourceModel_DISK)
       SourceModel_toString = 'DISK'
    end select
  end function SourceModel_toString
!
  function SourceModel_fromString(str)
    integer :: SourceModel_fromString
    character*80 :: str
    select case(str)
    case('GAUSSIAN')
       SourceModel_fromString = SourceModel_GAUSSIAN
    case('POINT')
       SourceModel_fromString = SourceModel_POINT
    case('DISK')
       SourceModel_fromString = SourceModel_DISK
    end select
  end function SourceModel_fromString
!
  function NetSideband_toString(i)
    integer :: i
    character*80 :: NetSideband_toString
    select case(i)
    case(NetSideband_NOSB)
       NetSideband_toString = 'NOSB'
    case(NetSideband_LSB)
       NetSideband_toString = 'LSB'
    case(NetSideband_USB)
       NetSideband_toString = 'USB'
    case(NetSideband_DSB)
       NetSideband_toString = 'DSB'
    end select
  end function NetSideband_toString
!
  function NetSideband_fromString(str)
    integer :: NetSideband_fromString
    character*80 :: str
    select case(str)
    case('NOSB')
       NetSideband_fromString = NetSideband_NOSB
    case('LSB')
       NetSideband_fromString = NetSideband_LSB
    case('USB')
       NetSideband_fromString = NetSideband_USB
    case('DSB')
       NetSideband_fromString = NetSideband_DSB
    end select
  end function NetSideband_fromString
!
  function ReceiverSideband_toString(i)
    integer :: i
    character*80 :: ReceiverSideband_toString
    select case(i)
    case(ReceiverSideband_NOSB)
       ReceiverSideband_toString = 'NOSB'
    case(ReceiverSideband_DSB)
       ReceiverSideband_toString = 'DSB'
    case(ReceiverSideband_SSB)
       ReceiverSideband_toString = 'SSB'
    case(ReceiverSideband_TSB)
       ReceiverSideband_toString = 'TSB'
    end select
  end function ReceiverSideband_toString
!
  function ReceiverSideband_fromString(str)
    integer :: ReceiverSideband_fromString
    character*80 :: str
    select case(str)
    case('NOSB')
       ReceiverSideband_fromString = ReceiverSideband_NOSB
    case('DSB')
       ReceiverSideband_fromString = ReceiverSideband_DSB
    case('SSB')
       ReceiverSideband_fromString = ReceiverSideband_SSB
    case('TSB')
       ReceiverSideband_fromString = ReceiverSideband_TSB
    end select
  end function ReceiverSideband_fromString
!
  function SidebandProcessingMode_toString(i)
    integer :: i
    character*80 :: SidebandProcessingMode_toString
    select case(i)
    case(SidebandProcessingMode_NONE)
       SidebandProcessingMode_toString = 'NONE'
    case(SidebandProcessingMode_PHASE_SWITCH_SEPARATION)
       SidebandProcessingMode_toString = 'PHASE_SWITCH_SEPARATION'
    case(SidebandProcessingMode_FREQUENCY_OFFSET_SEPARATION)
       SidebandProcessingMode_toString = 'FREQUENCY_OFFSET_SEPARATION'
    case(SidebandProcessingMode_PHASE_SWITCH_REJECTION)
       SidebandProcessingMode_toString = 'PHASE_SWITCH_REJECTION'
    case(SidebandProcessingMode_FREQUENCY_OFFSET_REJECTION)
       SidebandProcessingMode_toString = 'FREQUENCY_OFFSET_REJECTION'
    end select
  end function SidebandProcessingMode_toString
!
  function SidebandProcessingMode_fromString(str)
    integer :: SidebandProcessingMode_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       SidebandProcessingMode_fromString = SidebandProcessingMode_NONE
    case('PHASE_SWITCH_SEPARATION')
       SidebandProcessingMode_fromString = SidebandProcessingMode_PHASE_SWITCH_SEPARATION
    case('FREQUENCY_OFFSET_SEPARATION')
       SidebandProcessingMode_fromString = SidebandProcessingMode_FREQUENCY_OFFSET_SEPARATION
    case('PHASE_SWITCH_REJECTION')
       SidebandProcessingMode_fromString = SidebandProcessingMode_PHASE_SWITCH_REJECTION
    case('FREQUENCY_OFFSET_REJECTION')
       SidebandProcessingMode_fromString = SidebandProcessingMode_FREQUENCY_OFFSET_REJECTION
    end select
  end function SidebandProcessingMode_fromString
!
  function SwitchingMode_toString(i)
    integer :: i
    character*80 :: SwitchingMode_toString
    select case(i)
    case(SwitchingMode_NO_SWITCHING)
       SwitchingMode_toString = 'NO_SWITCHING'
    case(SwitchingMode_LOAD_SWITCHING)
       SwitchingMode_toString = 'LOAD_SWITCHING'
    case(SwitchingMode_POSITION_SWITCHING)
       SwitchingMode_toString = 'POSITION_SWITCHING'
    case(SwitchingMode_PHASE_SWITCHING)
       SwitchingMode_toString = 'PHASE_SWITCHING'
    case(SwitchingMode_FREQUENCY_SWITCHING)
       SwitchingMode_toString = 'FREQUENCY_SWITCHING'
    case(SwitchingMode_NUTATOR_SWITCHING)
       SwitchingMode_toString = 'NUTATOR_SWITCHING'
    case(SwitchingMode_CHOPPER_WHEEL)
       SwitchingMode_toString = 'CHOPPER_WHEEL'
    end select
  end function SwitchingMode_toString
!
  function SwitchingMode_fromString(str)
    integer :: SwitchingMode_fromString
    character*80 :: str
    select case(str)
    case('NO_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_NO_SWITCHING
    case('LOAD_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_LOAD_SWITCHING
    case('POSITION_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_POSITION_SWITCHING
    case('PHASE_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_PHASE_SWITCHING
    case('FREQUENCY_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_FREQUENCY_SWITCHING
    case('NUTATOR_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_NUTATOR_SWITCHING
    case('CHOPPER_WHEEL')
       SwitchingMode_fromString = SwitchingMode_CHOPPER_WHEEL
    end select
  end function SwitchingMode_fromString
!
  function StationType_toString(i)
    integer :: i
    character*80 :: StationType_toString
    select case(i)
    case(StationType_ANTENNA_PAD)
       StationType_toString = 'ANTENNA_PAD'
    case(StationType_MAINTENANCE_PAD)
       StationType_toString = 'MAINTENANCE_PAD'
    case(StationType_WEATHER_STATION)
       StationType_toString = 'WEATHER_STATION'
    end select
  end function StationType_toString
!
  function StationType_fromString(str)
    integer :: StationType_fromString
    character*80 :: str
    select case(str)
    case('ANTENNA_PAD')
       StationType_fromString = StationType_ANTENNA_PAD
    case('MAINTENANCE_PAD')
       StationType_fromString = StationType_MAINTENANCE_PAD
    case('WEATHER_STATION')
       StationType_fromString = StationType_WEATHER_STATION
    end select
  end function StationType_fromString
!
  function SubscanIntent_toString(i)
    integer :: i
    character*80 :: SubscanIntent_toString
    select case(i)
    case(SubscanIntent_ON_SOURCE)
       SubscanIntent_toString = 'ON_SOURCE'
    case(SubscanIntent_OFF_SOURCE)
       SubscanIntent_toString = 'OFF_SOURCE'
    case(SubscanIntent_MIXED)
       SubscanIntent_toString = 'MIXED'
    case(SubscanIntent_REFERENCE)
       SubscanIntent_toString = 'REFERENCE'
    case(SubscanIntent_SCANNING)
       SubscanIntent_toString = 'SCANNING'
    case(SubscanIntent_HOT)
       SubscanIntent_toString = 'HOT'
    case(SubscanIntent_AMBIENT)
       SubscanIntent_toString = 'AMBIENT'
    case(SubscanIntent_TEST)
       SubscanIntent_toString = 'TEST'
    case(SubscanIntent_UNSPECIFIED)
       SubscanIntent_toString = 'UNSPECIFIED'
    end select
  end function SubscanIntent_toString
!
  function SubscanIntent_fromString(str)
    integer :: SubscanIntent_fromString
    character*80 :: str
    select case(str)
    case('ON_SOURCE')
       SubscanIntent_fromString = SubscanIntent_ON_SOURCE
    case('OFF_SOURCE')
       SubscanIntent_fromString = SubscanIntent_OFF_SOURCE
    case('MIXED')
       SubscanIntent_fromString = SubscanIntent_MIXED
    case('REFERENCE')
       SubscanIntent_fromString = SubscanIntent_REFERENCE
    case('SCANNING')
       SubscanIntent_fromString = SubscanIntent_SCANNING
    case('HOT')
       SubscanIntent_fromString = SubscanIntent_HOT
    case('AMBIENT')
       SubscanIntent_fromString = SubscanIntent_AMBIENT
    case('TEST')
       SubscanIntent_fromString = SubscanIntent_TEST
    case('UNSPECIFIED')
       SubscanIntent_fromString = SubscanIntent_UNSPECIFIED
    end select
  end function SubscanIntent_fromString
!
  function BasebandName_toString(i)
    integer :: i
    character*80 :: BasebandName_toString
    select case(i)
    case(BasebandName_NOBB)
       BasebandName_toString = 'NOBB'
    case(BasebandName_BB_1)
       BasebandName_toString = 'BB_1'
    case(BasebandName_BB_2)
       BasebandName_toString = 'BB_2'
    case(BasebandName_BB_3)
       BasebandName_toString = 'BB_3'
    case(BasebandName_BB_4)
       BasebandName_toString = 'BB_4'
    case(BasebandName_BB_5)
       BasebandName_toString = 'BB_5'
    case(BasebandName_BB_6)
       BasebandName_toString = 'BB_6'
    case(BasebandName_BB_7)
       BasebandName_toString = 'BB_7'
    case(BasebandName_BB_8)
       BasebandName_toString = 'BB_8'
    case(BasebandName_BB_ALL)
       BasebandName_toString = 'BB_ALL'
    end select
  end function BasebandName_toString
!
  function BasebandName_fromString(str)
    integer :: BasebandName_fromString
    character*80 :: str
    select case(str)
    case('NOBB')
       BasebandName_fromString = BasebandName_NOBB
    case('BB_1')
       BasebandName_fromString = BasebandName_BB_1
    case('BB_2')
       BasebandName_fromString = BasebandName_BB_2
    case('BB_3')
       BasebandName_fromString = BasebandName_BB_3
    case('BB_4')
       BasebandName_fromString = BasebandName_BB_4
    case('BB_5')
       BasebandName_fromString = BasebandName_BB_5
    case('BB_6')
       BasebandName_fromString = BasebandName_BB_6
    case('BB_7')
       BasebandName_fromString = BasebandName_BB_7
    case('BB_8')
       BasebandName_fromString = BasebandName_BB_8
    case('BB_ALL')
       BasebandName_fromString = BasebandName_BB_ALL
    end select
  end function BasebandName_fromString
!
  function AxisName_toString(i)
    integer :: i
    character*80 :: AxisName_toString
    select case(i)
    case(AxisName_TIM)
       AxisName_toString = 'TIM'
    case(AxisName_BAL)
       AxisName_toString = 'BAL'
    case(AxisName_ANT)
       AxisName_toString = 'ANT'
    case(AxisName_BAB)
       AxisName_toString = 'BAB'
    case(AxisName_SPW)
       AxisName_toString = 'SPW'
    case(AxisName_SIB)
       AxisName_toString = 'SIB'
    case(AxisName_SUB)
       AxisName_toString = 'SUB'
    case(AxisName_BIN)
       AxisName_toString = 'BIN'
    case(AxisName_APC)
       AxisName_toString = 'APC'
    case(AxisName_SPP)
       AxisName_toString = 'SPP'
    case(AxisName_POL)
       AxisName_toString = 'POL'
    case(AxisName_STO)
       AxisName_toString = 'STO'
    case(AxisName_HOL)
       AxisName_toString = 'HOL'
    end select
  end function AxisName_toString
!
  function AxisName_fromString(str)
    integer :: AxisName_fromString
    character*80 :: str
    select case(str)
    case('TIM')
       AxisName_fromString = AxisName_TIM
    case('BAL')
       AxisName_fromString = AxisName_BAL
    case('ANT')
       AxisName_fromString = AxisName_ANT
    case('BAB')
       AxisName_fromString = AxisName_BAB
    case('SPW')
       AxisName_fromString = AxisName_SPW
    case('SIB')
       AxisName_fromString = AxisName_SIB
    case('SUB')
       AxisName_fromString = AxisName_SUB
    case('BIN')
       AxisName_fromString = AxisName_BIN
    case('APC')
       AxisName_fromString = AxisName_APC
    case('SPP')
       AxisName_fromString = AxisName_SPP
    case('POL')
       AxisName_fromString = AxisName_POL
    case('STO')
       AxisName_fromString = AxisName_STO
    case('HOL')
       AxisName_fromString = AxisName_HOL
    end select
  end function AxisName_fromString
!
  function DataContent_toString(i)
    integer :: i
    character*80 :: DataContent_toString
    select case(i)
    case(DataContent_CROSS_DATA)
       DataContent_toString = 'CROSS_DATA'
    case(DataContent_AUTO_DATA)
       DataContent_toString = 'AUTO_DATA'
    case(DataContent_ZERO_LAGS)
       DataContent_toString = 'ZERO_LAGS'
    case(DataContent_ACTUAL_TIMES)
       DataContent_toString = 'ACTUAL_TIMES'
    case(DataContent_ACTUAL_DURATIONS)
       DataContent_toString = 'ACTUAL_DURATIONS'
    case(DataContent_WEIGHTS)
       DataContent_toString = 'WEIGHTS'
    case(DataContent_FLAGS)
       DataContent_toString = 'FLAGS'
    end select
  end function DataContent_toString
!
  function DataContent_fromString(str)
    integer :: DataContent_fromString
    character*80 :: str
    select case(str)
    case('CROSS_DATA')
       DataContent_fromString = DataContent_CROSS_DATA
    case('AUTO_DATA')
       DataContent_fromString = DataContent_AUTO_DATA
    case('ZERO_LAGS')
       DataContent_fromString = DataContent_ZERO_LAGS
    case('ACTUAL_TIMES')
       DataContent_fromString = DataContent_ACTUAL_TIMES
    case('ACTUAL_DURATIONS')
       DataContent_fromString = DataContent_ACTUAL_DURATIONS
    case('WEIGHTS')
       DataContent_fromString = DataContent_WEIGHTS
    case('FLAGS')
       DataContent_fromString = DataContent_FLAGS
    end select
  end function DataContent_fromString
!
  function AtmPhaseCorrection_toString(i)
    integer :: i
    character*80 :: AtmPhaseCorrection_toString
    select case(i)
    case(AtmPhaseCorrection_AP_UNCORRECTED)
       AtmPhaseCorrection_toString = 'AP_UNCORRECTED'
    case(AtmPhaseCorrection_AP_CORRECTED)
       AtmPhaseCorrection_toString = 'AP_CORRECTED'
    end select
  end function AtmPhaseCorrection_toString
!
  function AtmPhaseCorrection_fromString(str)
    integer :: AtmPhaseCorrection_fromString
    character*80 :: str
    select case(str)
    case('AP_UNCORRECTED')
       AtmPhaseCorrection_fromString = AtmPhaseCorrection_AP_UNCORRECTED
    case('AP_CORRECTED')
       AtmPhaseCorrection_fromString = AtmPhaseCorrection_AP_CORRECTED
    end select
  end function AtmPhaseCorrection_fromString
!
  function PrimitiveDataType_toString(i)
    integer :: i
    character*80 :: PrimitiveDataType_toString
    select case(i)
    case(PrimitiveDataType_INT16_TYPE)
       PrimitiveDataType_toString = 'INT16_TYPE'
    case(PrimitiveDataType_INT32_TYPE)
       PrimitiveDataType_toString = 'INT32_TYPE'
    case(PrimitiveDataType_INT64_TYPE)
       PrimitiveDataType_toString = 'INT64_TYPE'
    case(PrimitiveDataType_FLOAT32_TYPE)
       PrimitiveDataType_toString = 'FLOAT32_TYPE'
    case(PrimitiveDataType_FLOAT64_TYPE)
       PrimitiveDataType_toString = 'FLOAT64_TYPE'
    end select
  end function PrimitiveDataType_toString
!
  function PrimitiveDataType_fromString(str)
    integer :: PrimitiveDataType_fromString
    character*80 :: str
    select case(str)
    case('INT16_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_INT16_TYPE
    case('INT32_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_INT32_TYPE
    case('INT64_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_INT64_TYPE
    case('FLOAT32_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_FLOAT32_TYPE
    case('FLOAT64_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_FLOAT64_TYPE
    end select
  end function PrimitiveDataType_fromString
!
  function CorrelationMode_toString(i)
    integer :: i
    character*80 :: CorrelationMode_toString
    select case(i)
    case(CorrelationMode_CROSS_ONLY)
       CorrelationMode_toString = 'CROSS_ONLY'
    case(CorrelationMode_AUTO_ONLY)
       CorrelationMode_toString = 'AUTO_ONLY'
    case(CorrelationMode_CROSS_AND_AUTO)
       CorrelationMode_toString = 'CROSS_AND_AUTO'
    end select
  end function CorrelationMode_toString
!
  function CorrelationMode_fromString(str)
    integer :: CorrelationMode_fromString
    character*80 :: str
    select case(str)
    case('CROSS_ONLY')
       CorrelationMode_fromString = CorrelationMode_CROSS_ONLY
    case('AUTO_ONLY')
       CorrelationMode_fromString = CorrelationMode_AUTO_ONLY
    case('CROSS_AND_AUTO')
       CorrelationMode_fromString = CorrelationMode_CROSS_AND_AUTO
    end select
  end function CorrelationMode_fromString
!
  function WVRMethod_toString(i)
    integer :: i
    character*80 :: WVRMethod_toString
    select case(i)
    case(WVRMethod_ATM_MODEL)
       WVRMethod_toString = 'ATM_MODEL'
    case(WVRMethod_EMPIRICAL)
       WVRMethod_toString = 'EMPIRICAL'
    end select
  end function WVRMethod_toString
!
  function WVRMethod_fromString(str)
    integer :: WVRMethod_fromString
    character*80 :: str
    select case(str)
    case('ATM_MODEL')
       WVRMethod_fromString = WVRMethod_ATM_MODEL
    case('EMPIRICAL')
       WVRMethod_fromString = WVRMethod_EMPIRICAL
    end select
  end function WVRMethod_fromString
!
  function AccumMode_toString(i)
    integer :: i
    character*80 :: AccumMode_toString
    select case(i)
    case(AccumMode_FAST)
       AccumMode_toString = 'FAST'
    case(AccumMode_NORMAL)
       AccumMode_toString = 'NORMAL'
    case(AccumMode_UNDEFINED)
       AccumMode_toString = 'UNDEFINED'
    end select
  end function AccumMode_toString
!
  function AccumMode_fromString(str)
    integer :: AccumMode_fromString
    character*80 :: str
    select case(str)
    case('FAST')
       AccumMode_fromString = AccumMode_FAST
    case('NORMAL')
       AccumMode_fromString = AccumMode_NORMAL
    case('UNDEFINED')
       AccumMode_fromString = AccumMode_UNDEFINED
    end select
  end function AccumMode_fromString
!
  function AntennaType_toString(i)
    integer :: i
    character*80 :: AntennaType_toString
    select case(i)
    case(AntennaType_GROUND_BASED)
       AntennaType_toString = 'GROUND_BASED'
    case(AntennaType_SPACE_BASED)
       AntennaType_toString = 'SPACE_BASED'
    case(AntennaType_TRACKING_STN)
       AntennaType_toString = 'TRACKING_STN'
    end select
  end function AntennaType_toString
!
  function AntennaType_fromString(str)
    integer :: AntennaType_fromString
    character*80 :: str
    select case(str)
    case('GROUND_BASED')
       AntennaType_fromString = AntennaType_GROUND_BASED
    case('SPACE_BASED')
       AntennaType_fromString = AntennaType_SPACE_BASED
    case('TRACKING_STN')
       AntennaType_fromString = AntennaType_TRACKING_STN
    end select
  end function AntennaType_fromString
!
  function AntennaMake_toString(i)
    integer :: i
    character*80 :: AntennaMake_toString
    select case(i)
    case(AntennaMake_AEM_12)
       AntennaMake_toString = 'AEM_12'
    case(AntennaMake_MITSUBISHI_7)
       AntennaMake_toString = 'MITSUBISHI_7'
    case(AntennaMake_MITSUBISHI_12_A)
       AntennaMake_toString = 'MITSUBISHI_12_A'
    case(AntennaMake_MITSUBISHI_12_B)
       AntennaMake_toString = 'MITSUBISHI_12_B'
    case(AntennaMake_VERTEX_12_ATF)
       AntennaMake_toString = 'VERTEX_12_ATF'
    case(AntennaMake_AEM_12_ATF)
       AntennaMake_toString = 'AEM_12_ATF'
    case(AntennaMake_VERTEX_12)
       AntennaMake_toString = 'VERTEX_12'
    case(AntennaMake_IRAM_15)
       AntennaMake_toString = 'IRAM_15'
    case(AntennaMake_UNDEFINED)
       AntennaMake_toString = 'UNDEFINED'
    end select
  end function AntennaMake_toString
!
  function AntennaMake_fromString(str)
    integer :: AntennaMake_fromString
    character*80 :: str
    select case(str)
    case('AEM_12')
       AntennaMake_fromString = AntennaMake_AEM_12
    case('MITSUBISHI_7')
       AntennaMake_fromString = AntennaMake_MITSUBISHI_7
    case('MITSUBISHI_12_A')
       AntennaMake_fromString = AntennaMake_MITSUBISHI_12_A
    case('MITSUBISHI_12_B')
       AntennaMake_fromString = AntennaMake_MITSUBISHI_12_B
    case('VERTEX_12_ATF')
       AntennaMake_fromString = AntennaMake_VERTEX_12_ATF
    case('AEM_12_ATF')
       AntennaMake_fromString = AntennaMake_AEM_12_ATF
    case('VERTEX_12')
       AntennaMake_fromString = AntennaMake_VERTEX_12
    case('IRAM_15')
       AntennaMake_fromString = AntennaMake_IRAM_15
    case('UNDEFINED')
       AntennaMake_fromString = AntennaMake_UNDEFINED
    end select
  end function AntennaMake_fromString
!
  function PositionMethod_toString(i)
    integer :: i
    character*80 :: PositionMethod_toString
    select case(i)
    case(PositionMethod_DELAY_FITTING)
       PositionMethod_toString = 'DELAY_FITTING'
    case(PositionMethod_PHASE_FITTING)
       PositionMethod_toString = 'PHASE_FITTING'
    end select
  end function PositionMethod_toString
!
  function PositionMethod_fromString(str)
    integer :: PositionMethod_fromString
    character*80 :: str
    select case(str)
    case('DELAY_FITTING')
       PositionMethod_fromString = PositionMethod_DELAY_FITTING
    case('PHASE_FITTING')
       PositionMethod_fromString = PositionMethod_PHASE_FITTING
    end select
  end function PositionMethod_fromString
!
  function PointingModelMode_toString(i)
    integer :: i
    character*80 :: PointingModelMode_toString
    select case(i)
    case(PointingModelMode_RADIO)
       PointingModelMode_toString = 'RADIO'
    case(PointingModelMode_OPTICAL)
       PointingModelMode_toString = 'OPTICAL'
    end select
  end function PointingModelMode_toString
!
  function PointingModelMode_fromString(str)
    integer :: PointingModelMode_fromString
    character*80 :: str
    select case(str)
    case('RADIO')
       PointingModelMode_fromString = PointingModelMode_RADIO
    case('OPTICAL')
       PointingModelMode_fromString = PointingModelMode_OPTICAL
    end select
  end function PointingModelMode_fromString
!
  function InvalidatingCondition_toString(i)
    integer :: i
    character*80 :: InvalidatingCondition_toString
    select case(i)
    case(InvalidatingCondition_ANTENNA_DISCONNECT)
       InvalidatingCondition_toString = 'ANTENNA_DISCONNECT'
    case(InvalidatingCondition_ANTENNA_MOVE)
       InvalidatingCondition_toString = 'ANTENNA_MOVE'
    case(InvalidatingCondition_ANTENNA_POWER_DOWN)
       InvalidatingCondition_toString = 'ANTENNA_POWER_DOWN'
    case(InvalidatingCondition_RECEIVER_EXCHANGE)
       InvalidatingCondition_toString = 'RECEIVER_EXCHANGE'
    case(InvalidatingCondition_RECEIVER_POWER_DOWN)
       InvalidatingCondition_toString = 'RECEIVER_POWER_DOWN'
    end select
  end function InvalidatingCondition_toString
!
  function InvalidatingCondition_fromString(str)
    integer :: InvalidatingCondition_fromString
    character*80 :: str
    select case(str)
    case('ANTENNA_DISCONNECT')
       InvalidatingCondition_fromString = InvalidatingCondition_ANTENNA_DISCONNECT
    case('ANTENNA_MOVE')
       InvalidatingCondition_fromString = InvalidatingCondition_ANTENNA_MOVE
    case('ANTENNA_POWER_DOWN')
       InvalidatingCondition_fromString = InvalidatingCondition_ANTENNA_POWER_DOWN
    case('RECEIVER_EXCHANGE')
       InvalidatingCondition_fromString = InvalidatingCondition_RECEIVER_EXCHANGE
    case('RECEIVER_POWER_DOWN')
       InvalidatingCondition_fromString = InvalidatingCondition_RECEIVER_POWER_DOWN
    end select
  end function InvalidatingCondition_fromString
!
  function SchedulerMode_toString(i)
    integer :: i
    character*80 :: SchedulerMode_toString
    select case(i)
    case(SchedulerMode_DYNAMIC)
       SchedulerMode_toString = 'DYNAMIC'
    case(SchedulerMode_INTERACTIVE)
       SchedulerMode_toString = 'INTERACTIVE'
    case(SchedulerMode_MANUAL)
       SchedulerMode_toString = 'MANUAL'
    case(SchedulerMode_QUEUED)
       SchedulerMode_toString = 'QUEUED'
    end select
  end function SchedulerMode_toString
!
  function SchedulerMode_fromString(str)
    integer :: SchedulerMode_fromString
    character*80 :: str
    select case(str)
    case('DYNAMIC')
       SchedulerMode_fromString = SchedulerMode_DYNAMIC
    case('INTERACTIVE')
       SchedulerMode_fromString = SchedulerMode_INTERACTIVE
    case('MANUAL')
       SchedulerMode_fromString = SchedulerMode_MANUAL
    case('QUEUED')
       SchedulerMode_fromString = SchedulerMode_QUEUED
    end select
  end function SchedulerMode_fromString
!
  function FieldCode_toString(i)
    integer :: i
    character*80 :: FieldCode_toString
    select case(i)
    case(FieldCode_NONE)
       FieldCode_toString = 'NONE'
    end select
  end function FieldCode_toString
!
  function FieldCode_fromString(str)
    integer :: FieldCode_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       FieldCode_fromString = FieldCode_NONE
    end select
  end function FieldCode_fromString
!
  function HolographyChannelType_toString(i)
    integer :: i
    character*80 :: HolographyChannelType_toString
    select case(i)
    case(HolographyChannelType_Q2)
       HolographyChannelType_toString = 'Q2'
    case(HolographyChannelType_QR)
       HolographyChannelType_toString = 'QR'
    case(HolographyChannelType_QS)
       HolographyChannelType_toString = 'QS'
    case(HolographyChannelType_R2)
       HolographyChannelType_toString = 'R2'
    case(HolographyChannelType_RS)
       HolographyChannelType_toString = 'RS'
    case(HolographyChannelType_S2)
       HolographyChannelType_toString = 'S2'
    end select
  end function HolographyChannelType_toString
!
  function HolographyChannelType_fromString(str)
    integer :: HolographyChannelType_fromString
    character*80 :: str
    select case(str)
    case('Q2')
       HolographyChannelType_fromString = HolographyChannelType_Q2
    case('QR')
       HolographyChannelType_fromString = HolographyChannelType_QR
    case('QS')
       HolographyChannelType_fromString = HolographyChannelType_QS
    case('R2')
       HolographyChannelType_fromString = HolographyChannelType_R2
    case('RS')
       HolographyChannelType_fromString = HolographyChannelType_RS
    case('S2')
       HolographyChannelType_fromString = HolographyChannelType_S2
    end select
  end function HolographyChannelType_fromString
!
  function ProcessorSubType_toString(i)
    integer :: i
    character*80 :: ProcessorSubType_toString
    select case(i)
    case(ProcessorSubType_ALMA_CORRELATOR_MODE)
       ProcessorSubType_toString = 'ALMA_CORRELATOR_MODE'
    case(ProcessorSubType_SQUARE_LAW_DETECTOR)
       ProcessorSubType_toString = 'SQUARE_LAW_DETECTOR'
    case(ProcessorSubType_HOLOGRAPHY)
       ProcessorSubType_toString = 'HOLOGRAPHY'
    case(ProcessorSubType_ALMA_RADIOMETER)
       ProcessorSubType_toString = 'ALMA_RADIOMETER'
    end select
  end function ProcessorSubType_toString
!
  function ProcessorSubType_fromString(str)
    integer :: ProcessorSubType_fromString
    character*80 :: str
    select case(str)
    case('ALMA_CORRELATOR_MODE')
       ProcessorSubType_fromString = ProcessorSubType_ALMA_CORRELATOR_MODE
    case('SQUARE_LAW_DETECTOR')
       ProcessorSubType_fromString = ProcessorSubType_SQUARE_LAW_DETECTOR
    case('HOLOGRAPHY')
       ProcessorSubType_fromString = ProcessorSubType_HOLOGRAPHY
    case('ALMA_RADIOMETER')
       ProcessorSubType_fromString = ProcessorSubType_ALMA_RADIOMETER
    end select
  end function ProcessorSubType_fromString
!
  function ReceiverBand_toString(i)
    integer :: i
    character*80 :: ReceiverBand_toString
    select case(i)
    case(ReceiverBand_ALMA_RB_01)
       ReceiverBand_toString = 'ALMA_RB_01'
    case(ReceiverBand_ALMA_RB_02)
       ReceiverBand_toString = 'ALMA_RB_02'
    case(ReceiverBand_ALMA_RB_03)
       ReceiverBand_toString = 'ALMA_RB_03'
    case(ReceiverBand_ALMA_RB_04)
       ReceiverBand_toString = 'ALMA_RB_04'
    case(ReceiverBand_ALMA_RB_05)
       ReceiverBand_toString = 'ALMA_RB_05'
    case(ReceiverBand_ALMA_RB_06)
       ReceiverBand_toString = 'ALMA_RB_06'
    case(ReceiverBand_ALMA_RB_07)
       ReceiverBand_toString = 'ALMA_RB_07'
    case(ReceiverBand_ALMA_RB_08)
       ReceiverBand_toString = 'ALMA_RB_08'
    case(ReceiverBand_ALMA_RB_09)
       ReceiverBand_toString = 'ALMA_RB_09'
    case(ReceiverBand_ALMA_RB_10)
       ReceiverBand_toString = 'ALMA_RB_10'
    case(ReceiverBand_ALMA_RB_ALL)
       ReceiverBand_toString = 'ALMA_RB_ALL'
    case(ReceiverBand_ALMA_HOLOGRAPHY_RECEIVER)
       ReceiverBand_toString = 'ALMA_HOLOGRAPHY_RECEIVER'
    case(ReceiverBand_BURE_01)
       ReceiverBand_toString = 'BURE_01'
    case(ReceiverBand_BURE_02)
       ReceiverBand_toString = 'BURE_02'
    case(ReceiverBand_BURE_03)
       ReceiverBand_toString = 'BURE_03'
    case(ReceiverBand_BURE_04)
       ReceiverBand_toString = 'BURE_04'
    case(ReceiverBand_UNSPECIFIED)
       ReceiverBand_toString = 'UNSPECIFIED'
    end select
  end function ReceiverBand_toString
!
  function ReceiverBand_fromString(str)
    integer :: ReceiverBand_fromString
    character*80 :: str
    select case(str)
    case('ALMA_RB_01')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_01
    case('ALMA_RB_02')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_02
    case('ALMA_RB_03')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_03
    case('ALMA_RB_04')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_04
    case('ALMA_RB_05')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_05
    case('ALMA_RB_06')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_06
    case('ALMA_RB_07')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_07
    case('ALMA_RB_08')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_08
    case('ALMA_RB_09')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_09
    case('ALMA_RB_10')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_10
    case('ALMA_RB_ALL')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_ALL
    case('ALMA_HOLOGRAPHY_RECEIVER')
       ReceiverBand_fromString = ReceiverBand_ALMA_HOLOGRAPHY_RECEIVER
    case('BURE_01')
       ReceiverBand_fromString = ReceiverBand_BURE_01
    case('BURE_02')
       ReceiverBand_fromString = ReceiverBand_BURE_02
    case('BURE_03')
       ReceiverBand_fromString = ReceiverBand_BURE_03
    case('BURE_04')
       ReceiverBand_fromString = ReceiverBand_BURE_04
    case('UNSPECIFIED')
       ReceiverBand_fromString = ReceiverBand_UNSPECIFIED
    end select
  end function ReceiverBand_fromString
!
  function SBType_toString(i)
    integer :: i
    character*80 :: SBType_toString
    select case(i)
    case(SBType_OBSERVATORY)
       SBType_toString = 'OBSERVATORY'
    case(SBType_OBSERVER)
       SBType_toString = 'OBSERVER'
    case(SBType_EXPERT)
       SBType_toString = 'EXPERT'
    end select
  end function SBType_toString
!
  function SBType_fromString(str)
    integer :: SBType_fromString
    character*80 :: str
    select case(str)
    case('OBSERVATORY')
       SBType_fromString = SBType_OBSERVATORY
    case('OBSERVER')
       SBType_fromString = SBType_OBSERVER
    case('EXPERT')
       SBType_fromString = SBType_EXPERT
    end select
  end function SBType_fromString
!
  function SpectralResolutionType_toString(i)
    integer :: i
    character*80 :: SpectralResolutionType_toString
    select case(i)
    case(SpectralResolutionType_CHANNEL_AVERAGE)
       SpectralResolutionType_toString = 'CHANNEL_AVERAGE'
    case(SpectralResolutionType_BASEBAND_WIDE)
       SpectralResolutionType_toString = 'BASEBAND_WIDE'
    case(SpectralResolutionType_FULL_RESOLUTION)
       SpectralResolutionType_toString = 'FULL_RESOLUTION'
    end select
  end function SpectralResolutionType_toString
!
  function SpectralResolutionType_fromString(str)
    integer :: SpectralResolutionType_fromString
    character*80 :: str
    select case(str)
    case('CHANNEL_AVERAGE')
       SpectralResolutionType_fromString = SpectralResolutionType_CHANNEL_AVERAGE
    case('BASEBAND_WIDE')
       SpectralResolutionType_fromString = SpectralResolutionType_BASEBAND_WIDE
    case('FULL_RESOLUTION')
       SpectralResolutionType_fromString = SpectralResolutionType_FULL_RESOLUTION
    end select
  end function SpectralResolutionType_fromString
!
  function DetectorBandType_toString(i)
    integer :: i
    character*80 :: DetectorBandType_toString
    select case(i)
    case(DetectorBandType_BASEBAND)
       DetectorBandType_toString = 'BASEBAND'
    case(DetectorBandType_DOWN_CONVERTER)
       DetectorBandType_toString = 'DOWN_CONVERTER'
    case(DetectorBandType_HOLOGRAPHY_RECEIVER)
       DetectorBandType_toString = 'HOLOGRAPHY_RECEIVER'
    case(DetectorBandType_SUBBAND)
       DetectorBandType_toString = 'SUBBAND'
    end select
  end function DetectorBandType_toString
!
  function DetectorBandType_fromString(str)
    integer :: DetectorBandType_fromString
    character*80 :: str
    select case(str)
    case('BASEBAND')
       DetectorBandType_fromString = DetectorBandType_BASEBAND
    case('DOWN_CONVERTER')
       DetectorBandType_fromString = DetectorBandType_DOWN_CONVERTER
    case('HOLOGRAPHY_RECEIVER')
       DetectorBandType_fromString = DetectorBandType_HOLOGRAPHY_RECEIVER
    case('SUBBAND')
       DetectorBandType_fromString = DetectorBandType_SUBBAND
    end select
  end function DetectorBandType_fromString
!
  function FilterMode_toString(i)
    integer :: i
    character*80 :: FilterMode_toString
    select case(i)
    case(FilterMode_FILTER_NA)
       FilterMode_toString = 'FILTER_NA'
    case(FilterMode_FILTER_TDM)
       FilterMode_toString = 'FILTER_TDM'
    case(FilterMode_FILTER_TFB)
       FilterMode_toString = 'FILTER_TFB'
    case(FilterMode_UNDEFINED)
       FilterMode_toString = 'UNDEFINED'
    end select
  end function FilterMode_toString
!
  function FilterMode_fromString(str)
    integer :: FilterMode_fromString
    character*80 :: str
    select case(str)
    case('FILTER_NA')
       FilterMode_fromString = FilterMode_FILTER_NA
    case('FILTER_TDM')
       FilterMode_fromString = FilterMode_FILTER_TDM
    case('FILTER_TFB')
       FilterMode_fromString = FilterMode_FILTER_TFB
    case('UNDEFINED')
       FilterMode_fromString = FilterMode_UNDEFINED
    end select
  end function FilterMode_fromString
!
  function CorrelationBit_toString(i)
    integer :: i
    character*80 :: CorrelationBit_toString
    select case(i)
    case(CorrelationBit_BITS_2x2)
       CorrelationBit_toString = 'BITS_2x2'
    case(CorrelationBit_BITS_3x3)
       CorrelationBit_toString = 'BITS_3x3'
    case(CorrelationBit_BITS_4x4)
       CorrelationBit_toString = 'BITS_4x4'
    end select
  end function CorrelationBit_toString
!
  function CorrelationBit_fromString(str)
    integer :: CorrelationBit_fromString
    character*80 :: str
    select case(str)
    case('BITS_2x2')
       CorrelationBit_fromString = CorrelationBit_BITS_2x2
    case('BITS_3x3')
       CorrelationBit_fromString = CorrelationBit_BITS_3x3
    case('BITS_4x4')
       CorrelationBit_fromString = CorrelationBit_BITS_4x4
    end select
  end function CorrelationBit_fromString
!
  function ACAPolarization_toString(i)
    integer :: i
    character*80 :: ACAPolarization_toString
    select case(i)
    case(ACAPolarization_ACA_STANDARD)
       ACAPolarization_toString = 'ACA_STANDARD'
    case(ACAPolarization_ACA_XX_YY_SUM)
       ACAPolarization_toString = 'ACA_XX_YY_SUM'
    case(ACAPolarization_ACA_XX_50)
       ACAPolarization_toString = 'ACA_XX_50'
    case(ACAPolarization_ACA_YY_50)
       ACAPolarization_toString = 'ACA_YY_50'
    end select
  end function ACAPolarization_toString
!
  function ACAPolarization_fromString(str)
    integer :: ACAPolarization_fromString
    character*80 :: str
    select case(str)
    case('ACA_STANDARD')
       ACAPolarization_fromString = ACAPolarization_ACA_STANDARD
    case('ACA_XX_YY_SUM')
       ACAPolarization_fromString = ACAPolarization_ACA_XX_YY_SUM
    case('ACA_XX_50')
       ACAPolarization_fromString = ACAPolarization_ACA_XX_50
    case('ACA_YY_50')
       ACAPolarization_fromString = ACAPolarization_ACA_YY_50
    end select
  end function ACAPolarization_fromString
!
  function CorrelatorCalibration_toString(i)
    integer :: i
    character*80 :: CorrelatorCalibration_toString
    select case(i)
    case(CorrelatorCalibration_NONE)
       CorrelatorCalibration_toString = 'NONE'
    case(CorrelatorCalibration_CORRELATOR_CALIBRATION)
       CorrelatorCalibration_toString = 'CORRELATOR_CALIBRATION'
    case(CorrelatorCalibration_REAL_OBSERVATION)
       CorrelatorCalibration_toString = 'REAL_OBSERVATION'
    end select
  end function CorrelatorCalibration_toString
!
  function CorrelatorCalibration_fromString(str)
    integer :: CorrelatorCalibration_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       CorrelatorCalibration_fromString = CorrelatorCalibration_NONE
    case('CORRELATOR_CALIBRATION')
       CorrelatorCalibration_fromString = CorrelatorCalibration_CORRELATOR_CALIBRATION
    case('REAL_OBSERVATION')
       CorrelatorCalibration_fromString = CorrelatorCalibration_REAL_OBSERVATION
    end select
  end function CorrelatorCalibration_fromString
!
  function CorrelatorName_toString(i)
    integer :: i
    character*80 :: CorrelatorName_toString
    select case(i)
    case(CorrelatorName_ALMA_ACA)
       CorrelatorName_toString = 'ALMA_ACA'
    case(CorrelatorName_ALMA_BASELINE)
       CorrelatorName_toString = 'ALMA_BASELINE'
    case(CorrelatorName_ALMA_BASELINE_ATF)
       CorrelatorName_toString = 'ALMA_BASELINE_ATF'
    case(CorrelatorName_ALMA_BASELINE_PROTO_OSF)
       CorrelatorName_toString = 'ALMA_BASELINE_PROTO_OSF'
    case(CorrelatorName_HERSCHEL)
       CorrelatorName_toString = 'HERSCHEL'
    case(CorrelatorName_IRAM_PDB)
       CorrelatorName_toString = 'IRAM_PDB'
    case(CorrelatorName_IRAM_30M_VESPA)
       CorrelatorName_toString = 'IRAM_30M_VESPA'
    case(CorrelatorName_IRAM_WILMA)
       CorrelatorName_toString = 'IRAM_WILMA'
    case(CorrelatorName_NRAO_VLA)
       CorrelatorName_toString = 'NRAO_VLA'
    case(CorrelatorName_NRAO_WIDAR)
       CorrelatorName_toString = 'NRAO_WIDAR'
    end select
  end function CorrelatorName_toString
!
  function CorrelatorName_fromString(str)
    integer :: CorrelatorName_fromString
    character*80 :: str
    select case(str)
    case('ALMA_ACA')
       CorrelatorName_fromString = CorrelatorName_ALMA_ACA
    case('ALMA_BASELINE')
       CorrelatorName_fromString = CorrelatorName_ALMA_BASELINE
    case('ALMA_BASELINE_ATF')
       CorrelatorName_fromString = CorrelatorName_ALMA_BASELINE_ATF
    case('ALMA_BASELINE_PROTO_OSF')
       CorrelatorName_fromString = CorrelatorName_ALMA_BASELINE_PROTO_OSF
    case('HERSCHEL')
       CorrelatorName_fromString = CorrelatorName_HERSCHEL
    case('IRAM_PDB')
       CorrelatorName_fromString = CorrelatorName_IRAM_PDB
    case('IRAM_30M_VESPA')
       CorrelatorName_fromString = CorrelatorName_IRAM_30M_VESPA
    case('IRAM_WILMA')
       CorrelatorName_fromString = CorrelatorName_IRAM_WILMA
    case('NRAO_VLA')
       CorrelatorName_fromString = CorrelatorName_NRAO_VLA
    case('NRAO_WIDAR')
       CorrelatorName_fromString = CorrelatorName_NRAO_WIDAR
    end select
  end function CorrelatorName_fromString
!
  function TimeSampling_toString(i)
    integer :: i
    character*80 :: TimeSampling_toString
    select case(i)
    case(TimeSampling_SUBINTEGRATION)
       TimeSampling_toString = 'SUBINTEGRATION'
    case(TimeSampling_INTEGRATION)
       TimeSampling_toString = 'INTEGRATION'
    end select
  end function TimeSampling_toString
!
  function TimeSampling_fromString(str)
    integer :: TimeSampling_fromString
    character*80 :: str
    select case(str)
    case('SUBINTEGRATION')
       TimeSampling_fromString = TimeSampling_SUBINTEGRATION
    case('INTEGRATION')
       TimeSampling_fromString = TimeSampling_INTEGRATION
    end select
  end function TimeSampling_fromString
!
  function CalibrationDevice_toString(i)
    integer :: i
    character*80 :: CalibrationDevice_toString
    select case(i)
    case(CalibrationDevice_AMBIENT_LOAD)
       CalibrationDevice_toString = 'AMBIENT_LOAD'
    case(CalibrationDevice_COLD_LOAD)
       CalibrationDevice_toString = 'COLD_LOAD'
    case(CalibrationDevice_HOT_LOAD)
       CalibrationDevice_toString = 'HOT_LOAD'
    case(CalibrationDevice_NOISE_TUBE_LOAD)
       CalibrationDevice_toString = 'NOISE_TUBE_LOAD'
    case(CalibrationDevice_QUARTER_WAVE_PLATE)
       CalibrationDevice_toString = 'QUARTER_WAVE_PLATE'
    case(CalibrationDevice_SOLAR_FILTER)
       CalibrationDevice_toString = 'SOLAR_FILTER'
    case(CalibrationDevice_NONE)
       CalibrationDevice_toString = 'NONE'
    end select
  end function CalibrationDevice_toString
!
  function CalibrationDevice_fromString(str)
    integer :: CalibrationDevice_fromString
    character*80 :: str
    select case(str)
    case('AMBIENT_LOAD')
       CalibrationDevice_fromString = CalibrationDevice_AMBIENT_LOAD
    case('COLD_LOAD')
       CalibrationDevice_fromString = CalibrationDevice_COLD_LOAD
    case('HOT_LOAD')
       CalibrationDevice_fromString = CalibrationDevice_HOT_LOAD
    case('NOISE_TUBE_LOAD')
       CalibrationDevice_fromString = CalibrationDevice_NOISE_TUBE_LOAD
    case('QUARTER_WAVE_PLATE')
       CalibrationDevice_fromString = CalibrationDevice_QUARTER_WAVE_PLATE
    case('SOLAR_FILTER')
       CalibrationDevice_fromString = CalibrationDevice_SOLAR_FILTER
    case('NONE')
       CalibrationDevice_fromString = CalibrationDevice_NONE
    end select
  end function CalibrationDevice_fromString
!
  function AntennaMotionPattern_toString(i)
    integer :: i
    character*80 :: AntennaMotionPattern_toString
    select case(i)
    case(AntennaMotionPattern_NONE)
       AntennaMotionPattern_toString = 'NONE'
    case(AntennaMotionPattern_CROSS_SCAN)
       AntennaMotionPattern_toString = 'CROSS_SCAN'
    case(AntennaMotionPattern_SPIRAL)
       AntennaMotionPattern_toString = 'SPIRAL'
    case(AntennaMotionPattern_CIRCLE)
       AntennaMotionPattern_toString = 'CIRCLE'
    case(AntennaMotionPattern_THREE_POINTS)
       AntennaMotionPattern_toString = 'THREE_POINTS'
    case(AntennaMotionPattern_FOUR_POINTS)
       AntennaMotionPattern_toString = 'FOUR_POINTS'
    case(AntennaMotionPattern_FIVE_POINTS)
       AntennaMotionPattern_toString = 'FIVE_POINTS'
    case(AntennaMotionPattern_TEST)
       AntennaMotionPattern_toString = 'TEST'
    case(AntennaMotionPattern_UNSPECIFIED)
       AntennaMotionPattern_toString = 'UNSPECIFIED'
    end select
  end function AntennaMotionPattern_toString
!
  function AntennaMotionPattern_fromString(str)
    integer :: AntennaMotionPattern_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       AntennaMotionPattern_fromString = AntennaMotionPattern_NONE
    case('CROSS_SCAN')
       AntennaMotionPattern_fromString = AntennaMotionPattern_CROSS_SCAN
    case('SPIRAL')
       AntennaMotionPattern_fromString = AntennaMotionPattern_SPIRAL
    case('CIRCLE')
       AntennaMotionPattern_fromString = AntennaMotionPattern_CIRCLE
    case('THREE_POINTS')
       AntennaMotionPattern_fromString = AntennaMotionPattern_THREE_POINTS
    case('FOUR_POINTS')
       AntennaMotionPattern_fromString = AntennaMotionPattern_FOUR_POINTS
    case('FIVE_POINTS')
       AntennaMotionPattern_fromString = AntennaMotionPattern_FIVE_POINTS
    case('TEST')
       AntennaMotionPattern_fromString = AntennaMotionPattern_TEST
    case('UNSPECIFIED')
       AntennaMotionPattern_fromString = AntennaMotionPattern_UNSPECIFIED
    end select
  end function AntennaMotionPattern_fromString
!
  function CalibrationFunction_toString(i)
    integer :: i
    character*80 :: CalibrationFunction_toString
    select case(i)
    case(CalibrationFunction_FIRST)
       CalibrationFunction_toString = 'FIRST'
    case(CalibrationFunction_LAST)
       CalibrationFunction_toString = 'LAST'
    case(CalibrationFunction_UNSPECIFIED)
       CalibrationFunction_toString = 'UNSPECIFIED'
    end select
  end function CalibrationFunction_toString
!
  function CalibrationFunction_fromString(str)
    integer :: CalibrationFunction_fromString
    character*80 :: str
    select case(str)
    case('FIRST')
       CalibrationFunction_fromString = CalibrationFunction_FIRST
    case('LAST')
       CalibrationFunction_fromString = CalibrationFunction_LAST
    case('UNSPECIFIED')
       CalibrationFunction_fromString = CalibrationFunction_UNSPECIFIED
    end select
  end function CalibrationFunction_fromString
!
  function CalibrationSet_toString(i)
    integer :: i
    character*80 :: CalibrationSet_toString
    select case(i)
    case(CalibrationSet_NONE)
       CalibrationSet_toString = 'NONE'
    case(CalibrationSet_AMPLI_CURVE)
       CalibrationSet_toString = 'AMPLI_CURVE'
    case(CalibrationSet_ANTENNA_POSITIONS)
       CalibrationSet_toString = 'ANTENNA_POSITIONS'
    case(CalibrationSet_PHASE_CURVE)
       CalibrationSet_toString = 'PHASE_CURVE'
    case(CalibrationSet_POINTING_MODEL)
       CalibrationSet_toString = 'POINTING_MODEL'
    case(CalibrationSet_ACCUMULATE)
       CalibrationSet_toString = 'ACCUMULATE'
    case(CalibrationSet_TEST)
       CalibrationSet_toString = 'TEST'
    case(CalibrationSet_UNSPECIFIED)
       CalibrationSet_toString = 'UNSPECIFIED'
    end select
  end function CalibrationSet_toString
!
  function CalibrationSet_fromString(str)
    integer :: CalibrationSet_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       CalibrationSet_fromString = CalibrationSet_NONE
    case('AMPLI_CURVE')
       CalibrationSet_fromString = CalibrationSet_AMPLI_CURVE
    case('ANTENNA_POSITIONS')
       CalibrationSet_fromString = CalibrationSet_ANTENNA_POSITIONS
    case('PHASE_CURVE')
       CalibrationSet_fromString = CalibrationSet_PHASE_CURVE
    case('POINTING_MODEL')
       CalibrationSet_fromString = CalibrationSet_POINTING_MODEL
    case('ACCUMULATE')
       CalibrationSet_fromString = CalibrationSet_ACCUMULATE
    case('TEST')
       CalibrationSet_fromString = CalibrationSet_TEST
    case('UNSPECIFIED')
       CalibrationSet_fromString = CalibrationSet_UNSPECIFIED
    end select
  end function CalibrationSet_fromString
!
  function PositionReferenceCode_toString(i)
    integer :: i
    character*80 :: PositionReferenceCode_toString
    select case(i)
    case(PositionReferenceCode_ITRF)
       PositionReferenceCode_toString = 'ITRF'
    case(PositionReferenceCode_WGS84)
       PositionReferenceCode_toString = 'WGS84'
    case(PositionReferenceCode_SITE)
       PositionReferenceCode_toString = 'SITE'
    case(PositionReferenceCode_STATION)
       PositionReferenceCode_toString = 'STATION'
    case(PositionReferenceCode_YOKE)
       PositionReferenceCode_toString = 'YOKE'
    case(PositionReferenceCode_REFLECTOR)
       PositionReferenceCode_toString = 'REFLECTOR'
    end select
  end function PositionReferenceCode_toString
!
  function PositionReferenceCode_fromString(str)
    integer :: PositionReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('ITRF')
       PositionReferenceCode_fromString = PositionReferenceCode_ITRF
    case('WGS84')
       PositionReferenceCode_fromString = PositionReferenceCode_WGS84
    case('SITE')
       PositionReferenceCode_fromString = PositionReferenceCode_SITE
    case('STATION')
       PositionReferenceCode_fromString = PositionReferenceCode_STATION
    case('YOKE')
       PositionReferenceCode_fromString = PositionReferenceCode_YOKE
    case('REFLECTOR')
       PositionReferenceCode_fromString = PositionReferenceCode_REFLECTOR
    end select
  end function PositionReferenceCode_fromString
!
  function DirectionReferenceCode_toString(i)
    integer :: i
    character*80 :: DirectionReferenceCode_toString
    select case(i)
    case(DirectionReferenceCode_J2000)
       DirectionReferenceCode_toString = 'J2000'
    case(DirectionReferenceCode_JMEAN)
       DirectionReferenceCode_toString = 'JMEAN'
    case(DirectionReferenceCode_JTRUE)
       DirectionReferenceCode_toString = 'JTRUE'
    case(DirectionReferenceCode_APP)
       DirectionReferenceCode_toString = 'APP'
    case(DirectionReferenceCode_B1950)
       DirectionReferenceCode_toString = 'B1950'
    case(DirectionReferenceCode_B1950_VLA)
       DirectionReferenceCode_toString = 'B1950_VLA'
    case(DirectionReferenceCode_BMEAN)
       DirectionReferenceCode_toString = 'BMEAN'
    case(DirectionReferenceCode_BTRUE)
       DirectionReferenceCode_toString = 'BTRUE'
    case(DirectionReferenceCode_GALACTIC)
       DirectionReferenceCode_toString = 'GALACTIC'
    case(DirectionReferenceCode_HADEC)
       DirectionReferenceCode_toString = 'HADEC'
    case(DirectionReferenceCode_AZELSW)
       DirectionReferenceCode_toString = 'AZELSW'
    case(DirectionReferenceCode_AZELSWGEO)
       DirectionReferenceCode_toString = 'AZELSWGEO'
    case(DirectionReferenceCode_AZELNE)
       DirectionReferenceCode_toString = 'AZELNE'
    case(DirectionReferenceCode_AZELNEGEO)
       DirectionReferenceCode_toString = 'AZELNEGEO'
    case(DirectionReferenceCode_JNAT)
       DirectionReferenceCode_toString = 'JNAT'
    case(DirectionReferenceCode_ECLIPTIC)
       DirectionReferenceCode_toString = 'ECLIPTIC'
    case(DirectionReferenceCode_MECLIPTIC)
       DirectionReferenceCode_toString = 'MECLIPTIC'
    case(DirectionReferenceCode_TECLIPTIC)
       DirectionReferenceCode_toString = 'TECLIPTIC'
    case(DirectionReferenceCode_SUPERGAL)
       DirectionReferenceCode_toString = 'SUPERGAL'
    case(DirectionReferenceCode_ITRF)
       DirectionReferenceCode_toString = 'ITRF'
    case(DirectionReferenceCode_TOPO)
       DirectionReferenceCode_toString = 'TOPO'
    case(DirectionReferenceCode_ICRS)
       DirectionReferenceCode_toString = 'ICRS'
    case(DirectionReferenceCode_MERCURY)
       DirectionReferenceCode_toString = 'MERCURY'
    case(DirectionReferenceCode_VENUS)
       DirectionReferenceCode_toString = 'VENUS'
    case(DirectionReferenceCode_MARS)
       DirectionReferenceCode_toString = 'MARS'
    case(DirectionReferenceCode_JUPITER)
       DirectionReferenceCode_toString = 'JUPITER'
    case(DirectionReferenceCode_SATURN)
       DirectionReferenceCode_toString = 'SATURN'
    case(DirectionReferenceCode_URANUS)
       DirectionReferenceCode_toString = 'URANUS'
    case(DirectionReferenceCode_NEPTUNE)
       DirectionReferenceCode_toString = 'NEPTUNE'
    case(DirectionReferenceCode_PLUTO)
       DirectionReferenceCode_toString = 'PLUTO'
    case(DirectionReferenceCode_SUN)
       DirectionReferenceCode_toString = 'SUN'
    case(DirectionReferenceCode_MOON)
       DirectionReferenceCode_toString = 'MOON'
    end select
  end function DirectionReferenceCode_toString
!
  function DirectionReferenceCode_fromString(str)
    integer :: DirectionReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('J2000')
       DirectionReferenceCode_fromString = DirectionReferenceCode_J2000
    case('JMEAN')
       DirectionReferenceCode_fromString = DirectionReferenceCode_JMEAN
    case('JTRUE')
       DirectionReferenceCode_fromString = DirectionReferenceCode_JTRUE
    case('APP')
       DirectionReferenceCode_fromString = DirectionReferenceCode_APP
    case('B1950')
       DirectionReferenceCode_fromString = DirectionReferenceCode_B1950
    case('B1950_VLA')
       DirectionReferenceCode_fromString = DirectionReferenceCode_B1950_VLA
    case('BMEAN')
       DirectionReferenceCode_fromString = DirectionReferenceCode_BMEAN
    case('BTRUE')
       DirectionReferenceCode_fromString = DirectionReferenceCode_BTRUE
    case('GALACTIC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_GALACTIC
    case('HADEC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_HADEC
    case('AZELSW')
       DirectionReferenceCode_fromString = DirectionReferenceCode_AZELSW
    case('AZELSWGEO')
       DirectionReferenceCode_fromString = DirectionReferenceCode_AZELSWGEO
    case('AZELNE')
       DirectionReferenceCode_fromString = DirectionReferenceCode_AZELNE
    case('AZELNEGEO')
       DirectionReferenceCode_fromString = DirectionReferenceCode_AZELNEGEO
    case('JNAT')
       DirectionReferenceCode_fromString = DirectionReferenceCode_JNAT
    case('ECLIPTIC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_ECLIPTIC
    case('MECLIPTIC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_MECLIPTIC
    case('TECLIPTIC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_TECLIPTIC
    case('SUPERGAL')
       DirectionReferenceCode_fromString = DirectionReferenceCode_SUPERGAL
    case('ITRF')
       DirectionReferenceCode_fromString = DirectionReferenceCode_ITRF
    case('TOPO')
       DirectionReferenceCode_fromString = DirectionReferenceCode_TOPO
    case('ICRS')
       DirectionReferenceCode_fromString = DirectionReferenceCode_ICRS
    case('MERCURY')
       DirectionReferenceCode_fromString = DirectionReferenceCode_MERCURY
    case('VENUS')
       DirectionReferenceCode_fromString = DirectionReferenceCode_VENUS
    case('MARS')
       DirectionReferenceCode_fromString = DirectionReferenceCode_MARS
    case('JUPITER')
       DirectionReferenceCode_fromString = DirectionReferenceCode_JUPITER
    case('SATURN')
       DirectionReferenceCode_fromString = DirectionReferenceCode_SATURN
    case('URANUS')
       DirectionReferenceCode_fromString = DirectionReferenceCode_URANUS
    case('NEPTUNE')
       DirectionReferenceCode_fromString = DirectionReferenceCode_NEPTUNE
    case('PLUTO')
       DirectionReferenceCode_fromString = DirectionReferenceCode_PLUTO
    case('SUN')
       DirectionReferenceCode_fromString = DirectionReferenceCode_SUN
    case('MOON')
       DirectionReferenceCode_fromString = DirectionReferenceCode_MOON
    end select
  end function DirectionReferenceCode_fromString
!
  function BaselineReferenceCode_toString(i)
    integer :: i
    character*80 :: BaselineReferenceCode_toString
    select case(i)
    case(BaselineReferenceCode_J2000)
       BaselineReferenceCode_toString = 'J2000'
    case(BaselineReferenceCode_B1950)
       BaselineReferenceCode_toString = 'B1950'
    case(BaselineReferenceCode_GALACTIC)
       BaselineReferenceCode_toString = 'GALACTIC'
    case(BaselineReferenceCode_SUPERGAL)
       BaselineReferenceCode_toString = 'SUPERGAL'
    case(BaselineReferenceCode_ECLIPTIC)
       BaselineReferenceCode_toString = 'ECLIPTIC'
    case(BaselineReferenceCode_JMEAN)
       BaselineReferenceCode_toString = 'JMEAN'
    case(BaselineReferenceCode_JTRUE)
       BaselineReferenceCode_toString = 'JTRUE'
    case(BaselineReferenceCode_APP)
       BaselineReferenceCode_toString = 'APP'
    case(BaselineReferenceCode_BMEAN)
       BaselineReferenceCode_toString = 'BMEAN'
    case(BaselineReferenceCode_BTRUE)
       BaselineReferenceCode_toString = 'BTRUE'
    case(BaselineReferenceCode_JNAT)
       BaselineReferenceCode_toString = 'JNAT'
    case(BaselineReferenceCode_MECLIPTIC)
       BaselineReferenceCode_toString = 'MECLIPTIC'
    case(BaselineReferenceCode_TECLIPTIC)
       BaselineReferenceCode_toString = 'TECLIPTIC'
    case(BaselineReferenceCode_TOPO)
       BaselineReferenceCode_toString = 'TOPO'
    case(BaselineReferenceCode_MERCURY)
       BaselineReferenceCode_toString = 'MERCURY'
    case(BaselineReferenceCode_VENUS)
       BaselineReferenceCode_toString = 'VENUS'
    case(BaselineReferenceCode_MARS)
       BaselineReferenceCode_toString = 'MARS'
    case(BaselineReferenceCode_JUPITER)
       BaselineReferenceCode_toString = 'JUPITER'
    case(BaselineReferenceCode_SATURN)
       BaselineReferenceCode_toString = 'SATURN'
    case(BaselineReferenceCode_NEPTUN)
       BaselineReferenceCode_toString = 'NEPTUN'
    case(BaselineReferenceCode_SUN)
       BaselineReferenceCode_toString = 'SUN'
    case(BaselineReferenceCode_MOON)
       BaselineReferenceCode_toString = 'MOON'
    case(BaselineReferenceCode_HADEC)
       BaselineReferenceCode_toString = 'HADEC'
    case(BaselineReferenceCode_AZEL)
       BaselineReferenceCode_toString = 'AZEL'
    case(BaselineReferenceCode_AZELGEO)
       BaselineReferenceCode_toString = 'AZELGEO'
    case(BaselineReferenceCode_AZELSW)
       BaselineReferenceCode_toString = 'AZELSW'
    case(BaselineReferenceCode_AZELNE)
       BaselineReferenceCode_toString = 'AZELNE'
    case(BaselineReferenceCode_ITRF)
       BaselineReferenceCode_toString = 'ITRF'
    end select
  end function BaselineReferenceCode_toString
!
  function BaselineReferenceCode_fromString(str)
    integer :: BaselineReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('J2000')
       BaselineReferenceCode_fromString = BaselineReferenceCode_J2000
    case('B1950')
       BaselineReferenceCode_fromString = BaselineReferenceCode_B1950
    case('GALACTIC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_GALACTIC
    case('SUPERGAL')
       BaselineReferenceCode_fromString = BaselineReferenceCode_SUPERGAL
    case('ECLIPTIC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_ECLIPTIC
    case('JMEAN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_JMEAN
    case('JTRUE')
       BaselineReferenceCode_fromString = BaselineReferenceCode_JTRUE
    case('APP')
       BaselineReferenceCode_fromString = BaselineReferenceCode_APP
    case('BMEAN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_BMEAN
    case('BTRUE')
       BaselineReferenceCode_fromString = BaselineReferenceCode_BTRUE
    case('JNAT')
       BaselineReferenceCode_fromString = BaselineReferenceCode_JNAT
    case('MECLIPTIC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_MECLIPTIC
    case('TECLIPTIC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_TECLIPTIC
    case('TOPO')
       BaselineReferenceCode_fromString = BaselineReferenceCode_TOPO
    case('MERCURY')
       BaselineReferenceCode_fromString = BaselineReferenceCode_MERCURY
    case('VENUS')
       BaselineReferenceCode_fromString = BaselineReferenceCode_VENUS
    case('MARS')
       BaselineReferenceCode_fromString = BaselineReferenceCode_MARS
    case('JUPITER')
       BaselineReferenceCode_fromString = BaselineReferenceCode_JUPITER
    case('SATURN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_SATURN
    case('NEPTUN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_NEPTUN
    case('SUN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_SUN
    case('MOON')
       BaselineReferenceCode_fromString = BaselineReferenceCode_MOON
    case('HADEC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_HADEC
    case('AZEL')
       BaselineReferenceCode_fromString = BaselineReferenceCode_AZEL
    case('AZELGEO')
       BaselineReferenceCode_fromString = BaselineReferenceCode_AZELGEO
    case('AZELSW')
       BaselineReferenceCode_fromString = BaselineReferenceCode_AZELSW
    case('AZELNE')
       BaselineReferenceCode_fromString = BaselineReferenceCode_AZELNE
    case('ITRF')
       BaselineReferenceCode_fromString = BaselineReferenceCode_ITRF
    end select
  end function BaselineReferenceCode_fromString
!
  function FrequencyReferenceCode_toString(i)
    integer :: i
    character*80 :: FrequencyReferenceCode_toString
    select case(i)
    case(FrequencyReferenceCode_LABREST)
       FrequencyReferenceCode_toString = 'LABREST'
    case(FrequencyReferenceCode_LSRD)
       FrequencyReferenceCode_toString = 'LSRD'
    case(FrequencyReferenceCode_LSRK)
       FrequencyReferenceCode_toString = 'LSRK'
    case(FrequencyReferenceCode_BARY)
       FrequencyReferenceCode_toString = 'BARY'
    case(FrequencyReferenceCode_REST)
       FrequencyReferenceCode_toString = 'REST'
    case(FrequencyReferenceCode_GEO)
       FrequencyReferenceCode_toString = 'GEO'
    case(FrequencyReferenceCode_GALACTO)
       FrequencyReferenceCode_toString = 'GALACTO'
    case(FrequencyReferenceCode_TOPO)
       FrequencyReferenceCode_toString = 'TOPO'
    end select
  end function FrequencyReferenceCode_toString
!
  function FrequencyReferenceCode_fromString(str)
    integer :: FrequencyReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('LABREST')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_LABREST
    case('LSRD')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_LSRD
    case('LSRK')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_LSRK
    case('BARY')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_BARY
    case('REST')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_REST
    case('GEO')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_GEO
    case('GALACTO')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_GALACTO
    case('TOPO')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_TOPO
    end select
  end function FrequencyReferenceCode_fromString
!
  function RadialVelocityReferenceCode_toString(i)
    integer :: i
    character*80 :: RadialVelocityReferenceCode_toString
    select case(i)
    case(RadialVelocityReferenceCode_LSRD)
       RadialVelocityReferenceCode_toString = 'LSRD'
    case(RadialVelocityReferenceCode_LSRK)
       RadialVelocityReferenceCode_toString = 'LSRK'
    case(RadialVelocityReferenceCode_GALACTO)
       RadialVelocityReferenceCode_toString = 'GALACTO'
    case(RadialVelocityReferenceCode_BARY)
       RadialVelocityReferenceCode_toString = 'BARY'
    case(RadialVelocityReferenceCode_GEO)
       RadialVelocityReferenceCode_toString = 'GEO'
    case(RadialVelocityReferenceCode_TOPO)
       RadialVelocityReferenceCode_toString = 'TOPO'
    end select
  end function RadialVelocityReferenceCode_toString
!
  function RadialVelocityReferenceCode_fromString(str)
    integer :: RadialVelocityReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('LSRD')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_LSRD
    case('LSRK')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_LSRK
    case('GALACTO')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_GALACTO
    case('BARY')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_BARY
    case('GEO')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_GEO
    case('TOPO')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_TOPO
    end select
  end function RadialVelocityReferenceCode_fromString
!
  function DopplerReferenceCode_toString(i)
    integer :: i
    character*80 :: DopplerReferenceCode_toString
    select case(i)
    case(DopplerReferenceCode_RADIO)
       DopplerReferenceCode_toString = 'RADIO'
    case(DopplerReferenceCode_Z)
       DopplerReferenceCode_toString = 'Z'
    case(DopplerReferenceCode_RATIO)
       DopplerReferenceCode_toString = 'RATIO'
    case(DopplerReferenceCode_BETA)
       DopplerReferenceCode_toString = 'BETA'
    case(DopplerReferenceCode_GAMMA)
       DopplerReferenceCode_toString = 'GAMMA'
    case(DopplerReferenceCode_OPTICAL)
       DopplerReferenceCode_toString = 'OPTICAL'
    case(DopplerReferenceCode_RELATIVISTIC)
       DopplerReferenceCode_toString = 'RELATIVISTIC'
    end select
  end function DopplerReferenceCode_toString
!
  function DopplerReferenceCode_fromString(str)
    integer :: DopplerReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('RADIO')
       DopplerReferenceCode_fromString = DopplerReferenceCode_RADIO
    case('Z')
       DopplerReferenceCode_fromString = DopplerReferenceCode_Z
    case('RATIO')
       DopplerReferenceCode_fromString = DopplerReferenceCode_RATIO
    case('BETA')
       DopplerReferenceCode_fromString = DopplerReferenceCode_BETA
    case('GAMMA')
       DopplerReferenceCode_fromString = DopplerReferenceCode_GAMMA
    case('OPTICAL')
       DopplerReferenceCode_fromString = DopplerReferenceCode_OPTICAL
    case('RELATIVISTIC')
       DopplerReferenceCode_fromString = DopplerReferenceCode_RELATIVISTIC
    end select
  end function DopplerReferenceCode_fromString
!
  function CorrelatorType_toString(i)
    integer :: i
    character*80 :: CorrelatorType_toString
    select case(i)
    case(CorrelatorType_FX)
       CorrelatorType_toString = 'FX'
    case(CorrelatorType_XF)
       CorrelatorType_toString = 'XF'
    case(CorrelatorType_FXF)
       CorrelatorType_toString = 'FXF'
    end select
  end function CorrelatorType_toString
!
  function CorrelatorType_fromString(str)
    integer :: CorrelatorType_fromString
    character*80 :: str
    select case(str)
    case('FX')
       CorrelatorType_fromString = CorrelatorType_FX
    case('XF')
       CorrelatorType_fromString = CorrelatorType_XF
    case('FXF')
       CorrelatorType_fromString = CorrelatorType_FXF
    end select
  end function CorrelatorType_fromString
end module sdm_Enumerations

program p_uv_fidelity
  use gildas_def
  use image_def
  use gkernel_interfaces
!
! Compute the radial average fidelity distribution in the UV plane
!
  character(len=filename_length) name1,name2,name3
  logical error
!
  call gildas_open
  call gildas_char('MODEL$',name1)
  call gildas_char('IMAGE$',name2)
  call gildas_char('RESULT$',name3)
  call gildas_close
!
  error = .false.
  call s_uv_fidelity(name1,name2,name3,error)
  if (error) call sysexi (fatale)
end program p_uv_fidelity

subroutine s_uv_fidelity(name1,name2,name3,error)
  use image_def
  use gkernel_interfaces, no_interface=>fourt
  character*(*) name1,name2,name3
  logical error
  !
  type (gildas) :: model,image,result
  real, allocatable :: dmod(:,:),dima(:,:),dres(:,:,:)
  complex, allocatable :: cmod(:,:),cima(:,:), wfft(:), work(:,:)
  integer nx,ny,nn,dim(2),ier,mx,my,i,j, ifact
  real*8 lambda
  character*60 chain
  logical equal
  !
  ! Initialize headers
  call gildas_null(model)
  call gildas_null(image)
  call gildas_null(result)
  !
  ! Read Headers Model & Image 
  call sic_parsef (name1,model%file,' ','.gdf')
  call gdf_read_header (model,error)
  if (error) return
  call sic_parsef (name2,image%file,' ','.lmv-clean')
  call gdf_read_header (image,error)
  if (error) return
  call gdf_compare_shape (model,image,equal)
  if (.not.equal) then
     call gagout('E-UV_FIDELITY,  Model and Simulation do not match')
     error = .true.
     return
  endif
  nx = model%gil%dim(1)
  ny = model%gil%dim(2)
  if (model%gil%ndim .ne. 2) then
     call gagout('E-UV_FIDELITY,  Data cubes not supported')
     error = .true.
     return
  endif
  !
  ifact = 8
  do while (nx*ny*ifact**2.gt.1024*1024)
     ifact = ifact/2
  enddo
  if (ifact.lt.2) then
     ifact = 2
     do while (nx*ny*ifact**2.gt.2048*2048)
        ifact = ifact/2
     enddo
  endif
  ifact = max(ifact,1)
  Print *,'Oversampling factor ',ifact
  !
  ! Read Data Model & Image
  allocate (dmod(nx,ny),stat=ier)
  call gdf_read_data (model,dmod,error)
  if (error) return
  allocate (dima(nx,ny),stat=ier)
  call gdf_read_data (image,dima,error)
  if (error) return
  mx = nx
  my = ny
  nx=ifact*nx
  ny=ifact*ny
  !
  ! Allocate Fourier space
  allocate(cmod(nx,ny),cima(nx,ny),wfft(max(nx,ny)),stat=ier)
  nn = 2
  dim = (/nx,ny/)
  call plunge_real(dmod,mx,my,cmod,nx,ny)
  call fourt (cmod,dim,2,1,1,wfft)
  call plunge_real(dima,mx,my,cima,nx,ny)
  call fourt (cima,dim,2,1,1,wfft)
  !
  ! Define output image
  call gdf_copy_header (image,result,error)
  mx = nx/2
  my = ny/2
  result%gil%ndim = 3
  result%gil%dim(1) = mx
  result%gil%dim(2) = my
  result%gil%dim(3) = 3
  call sic_parsef (name3,result%file,' ','.power')
  allocate(work(nx,ny),stat=ier)
  allocate(dres(mx,my,3),stat=ier)
  work = abs(cima-cmod)
  do j=1,my/2
     do i=1,mx/2
        dres(i+mx/2,j+my/2,1) = work(i,j)
     enddo
     do i=1,mx/2
        dres(i,j+my/2,1) = work(nx-mx/2+i,j)
     enddo
     do i=1,mx/2
        dres(i+mx/2,j,1) = work(i,ny-my/2+j)
     enddo
     do i=1,mx/2
        dres(i,j,1) = work(nx-mx/2+i,ny-my/2+j)
     enddo
  enddo
  work = abs(cmod)
  do j=1,my/2
     do i=1,mx/2
        dres(i+mx/2,j+my/2,2) = work(i,j)
     enddo
     do i=1,mx/2
        dres(i,j+my/2,2) = work(nx-mx/2+i,j)
     enddo
     do i=1,mx/2
        dres(i+mx/2,j,2) = work(i,ny-my/2+j)
     enddo
     do i=1,mx/2
        dres(i,j,2) = work(nx-mx/2+i,ny-my/2+j)
     enddo
  enddo
!
! Get the user units in "m"...
! Oops, quite a difficult problem, isn't it ?
  lambda = 299792458.d-6/result%gil%freq
  Print *,'Lambda ',lambda
  result%gil%inc(1) = lambda / (model%gil%inc(1) * model%gil%dim(1)) / ifact
  result%gil%inc(2) = lambda / (model%gil%inc(2) * model%gil%dim(2)) / ifact
  result%gil%ref(1) = mx/2+1
  result%gil%ref(2) = my/2+1
!
! Compute the fidelity image
  dres(:,:,3) = dres(:,:,2) / dres(:,:,1)
  call gdf_write_image(result,dres,error)
  deallocate (cmod,cima,wfft)
  deallocate (dres,dmod,dima)
end subroutine s_uv_fidelity
!
subroutine plunge_real (r,nx,ny,c,mx,my)
  !-----------------------------------------------------------------
  !     Plunge a Real array into a larger Complex array
  !-----------------------------------------------------------------
  integer nx,ny                      ! size of input array
  real r(nx,ny)                      ! input real array
  integer mx,my                      ! size of output array
  complex c(mx,my)                   ! output complex array
  !
  integer kx,ky,lx,ly
  integer i,j
  !
  kx = nx/2+1
  lx = mx/2+1
  ky = ny/2+1
  ly = my/2+1
  !
  c = 0.0
  do j=1,ny
     do i=1,nx
        c(i-kx+lx,j-ky+ly) = cmplx(r(i,j),0.0)
     enddo
  enddo
end subroutine plunge_real

module mrtcal_interfaces_public
  interface
    subroutine mrtcal_bookkeeping_all(subs,time,error)
      use imbfits_types
      use mrtcal_bookkeeping_types
      !---------------------------------------------------------------------
      ! @ public (for mrtholo)
      !  Fill the time%cur% structure suited for reading ALL the block
      ! of data at once.
      !  This is suited for applications which do not want to iterate the
      ! DATA block, i.e. reading it all at once. Use with caution, memory
      ! consumption may be large.
      !  This must come after a 'get_time_range_*' call (which fills the
      ! time%tot).
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(in)    :: subs
      type(book_t),            intent(inout) :: time
      logical,                 intent(inout) :: error
    end subroutine mrtcal_bookkeeping_all
  end interface
  !
  interface
    subroutine mrtcal_copy_command(line,error)
      use gildas_def
      use mrtcal_messaging
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ public
      !  Support routine for command
      !   MCOPY [IN|CURRENT] /FILE FileName
      !  Copy the named index from memory to disk
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_copy_command
  end interface
  !
  interface
    subroutine mrtcal_pack_set(pack)
      use gpack_def
      !----------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !----------------------------------------------------------------------
      type(gpack_info_t), intent(out) :: pack
    end subroutine mrtcal_pack_set
  end interface
  !
  interface
    subroutine mrtcal_read_subscan_data(imbf,subs,tochunk,databuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read part of the DATA column from the current subscan (i.e. the
      ! current one CFITSIO is positioned in), and implicitely convert it
      ! in chunksets.
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: imbf
      type(imbfits_subscan_t), intent(in)    :: subs
      logical,                 intent(in)    :: tochunk
      type(data_buffer_t),     intent(inout) :: databuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_read_subscan_data
  end interface
  !
  interface
    subroutine mrtcal_get_time_range_for_backend(subs,time,error)
      use gildas_def
      use imbfits_types
      use mrtcal_bookkeeping_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(in)    :: subs
      type(range_t),           intent(out)   :: time
      logical,                 intent(inout) :: error
    end subroutine mrtcal_get_time_range_for_backend
  end interface
  !
  interface
    subroutine mrtcal_interp_coord_from_antslow(antslow,onsky,mjd,longoff,latoff,  &
      azimuth,elevation,lst,error)
      use gildas_def
      use phys_const
      use gbl_constant
      use imbfits_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ public
      !  Interpolate
      !   - longoff, latoff
      !   - azimuth, elevation
      !   - lst
      !  from the antslow table for the given MJD time.
      !---------------------------------------------------------------------
      type(imbfits_antslow_t), intent(in)    :: antslow    !
      logical,                 intent(in)    :: onsky      !
      real(kind=8),            intent(in)    :: mjd        !
      real(kind=4),            intent(out)   :: longoff    ! [rad] ZZZ should check table unit
      real(kind=4),            intent(out)   :: latoff     ! [rad] ZZZ same
      real(kind=4),            intent(out)   :: azimuth    ! [rad] ZZZ same
      real(kind=4),            intent(out)   :: elevation  ! [rad] ZZZ same
      real(kind=8),            intent(out)   :: lst        ! [rad] ZZZ same
      logical,                 intent(inout) :: error      ! Logical error flag
    end subroutine mrtcal_interp_coord_from_antslow
  end interface
  !
end module mrtcal_interfaces_public

subroutine gag_diff_char(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_char
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  character(len=*), intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,A,T52,A)
end subroutine gag_diff_char
!
subroutine gag_diff_inte(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_inte
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  integer(kind=4),  intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,I0,T52,I0)
end subroutine gag_diff_inte
!
subroutine gag_diff_long(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_long
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  integer(kind=8),  intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,I0,T52,I0)
end subroutine gag_diff_long
!
subroutine gag_diff_real(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_real
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ (with some
  ! machine tolerance).
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  real(kind=4),     intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (nearly_equal(a,b,1.e-6))  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,1PG12.5,T52,1PG12.5)
  !
end subroutine gag_diff_real
!
subroutine gag_diff_dble(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_dble
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ (with some
  ! machine tolerance).
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  real(kind=8),     intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (nearly_equal(a,b,1.d-14))  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,1PG19.12,T52,1PG19.12)
  !
end subroutine gag_diff_dble
!
subroutine gag_diff_datar4(caller,a,b,ndata,same)
  use gildas_def
  use gmath_interfaces
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Returns a message if the two flat arrays a and b differ (with some
  ! machine tolerance).
  !---------------------------------------------------------------------
  character(len=*),          intent(in)  :: caller
  integer(kind=size_length), intent(in)  :: ndata
  real(kind=4),              intent(in)  :: a(ndata),b(ndata)
  logical,                   intent(out) :: same
  ! Local
  character(len=message_length) :: mess
  real(kind=4), parameter :: eps=1.e-6
  !
  same = nearly_equal(a,b,ndata,eps)
  !
  if (.not.same) then
    write (mess,'(A,1PG7.1,A)')  'Data differ by ',eps,' relative difference at least'
    call gmath_message(seve%r,caller,mess)
  endif
  !
end subroutine gag_diff_datar4
!
function nearly_equal_r4_0d(a,b,eps)
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r4_0d
  real(kind=4), intent(in) :: a,b
  real(kind=4), intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=4) :: diff
  !
  if (a.ne.a .and. b.ne.b) then  ! Both are NaN => equal
    nearly_equal_r4_0d = .true.
    return
  endif
  !
  if (a.eq.b) then  ! Strictly equal
    nearly_equal_r4_0d = .true.
    return
  endif
  !
  diff = abs(a-b)
  if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
    ! a or b is zero or both are extremely close to it. Note the use
    ! of tiny() which returns the smallest floating point number
    ! representable without being a denormal number.
    ! Relative error is less meaningful here
    nearly_equal_r4_0d = diff.lt.eps*tiny(a)
    return
  endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r4_0d = diff/(abs(a)+abs(b)).lt.eps
  !
end function nearly_equal_r4_0d
!
function nearly_equal_r8_0d(a,b,eps)
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r8_0d
  real(kind=8), intent(in) :: a,b
  real(kind=8), intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=8) :: diff
  !
  if (a.ne.a .and. b.ne.b) then  ! Both are NaN => equal
    nearly_equal_r8_0d = .true.
    return
  endif
  !
  if (a.eq.b) then  ! Strictly equal
    nearly_equal_r8_0d = .true.
    return
  endif
  !
  diff = abs(a-b)
  if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
    ! a or b is zero or both are extremely close to it. Note the use
    ! of tiny() which returns the smallest floating point number
    ! representable without being a denormal number.
    ! Relative error is less meaningful here
    nearly_equal_r8_0d = diff.lt.eps*tiny(a)
    return
  endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r8_0d = diff/(abs(a)+abs(b)).lt.eps
  !
end function nearly_equal_r8_0d
!
function nearly_equal_r4_1d(a,b,ndata,eps)
  use gildas_def
  use gmath_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r4_1d
  integer(kind=size_length), intent(in) :: ndata
  real(kind=4),              intent(in) :: a(ndata),b(ndata)
  real(kind=4),              intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=4), allocatable :: diff(:)
  logical :: error
  integer(kind=4) :: ier
  integer(kind=size_length) :: idata
  !
  nearly_equal_r4_1d = .true.
  !
  do idata=1,ndata
    if (a(idata).ne.a(idata) .and. b(idata).ne.b(idata))  cycle  ! Both are NaN => equal
    if (a(idata).eq.b(idata))  cycle  ! Strictly equal
    nearly_equal_r4_1d = .false.  ! Not strictly equal, need comparison with tolerance
    exit
  enddo
  if (nearly_equal_r4_1d)  return
  !
  error = .false.
  allocate(diff(ndata),stat=ier)
  if (failed_allocate('DIFF','diff',ier,error)) return
  diff(:) = abs(a-b)
  !
  ! Can I write a vectorized form of this test?
!     if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
!       ! a or b is zero or both are extremely close to it. Note the use
!       ! of tiny() which returns the smallest floating point number
!       ! representable without being a denormal number.
!       ! Relative error is less meaningful here
!       nearly_equal_r4_1d = diff.lt.eps*tiny(a)
!       return
!     endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r4_1d = all(diff/(abs(a)+abs(b)).lt.eps)
  !
  deallocate(diff)
  !
end function nearly_equal_r4_1d

function codes (func)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>codes
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: codes  ! Function value on return
  integer(kind=address_length) :: func(300)  !
  ! Global
  external :: lsic_l_or
  external :: lsic_l_and
  external :: lsic_l_not
  external :: lsic_l_exist
  external :: lsic_d_eq,lsic_s_eq,lsic_i_eq
  !
  ! 2 3 4 are logical operators
  func(code_or)  = locwrd(lsic_l_or)
  func(code_and) = locwrd(lsic_l_and)
  func(code_not) = locwrd(lsic_l_not)
  !
  ! Exist Variable and File function
  func(code_exist) = locwrd(lsic_l_exist)
  func(code_file)  = locwrd(lsic_l_exist)
  func(code_function)  = locwrd(lsic_l_exist)
  !
  ! Single precision operations
  ! Relational operators
  func(code_eq) = locwrd(lsic_s_eq)
  func(code_ne) = locwrd(lsic_s_ne)
  func(code_le) = locwrd(lsic_s_le)
  func(code_lt) = locwrd(lsic_s_lt)
  func(code_ge) = locwrd(lsic_s_ge)
  func(code_gt) = locwrd(lsic_s_gt)
  !
  ! Arithmetic operators
  func(code_bplus)  = locwrd(lsic_s_bplus)
  func(code_bminus) = locwrd(lsic_s_bminus)
  func(code_mul)    = locwrd(lsic_s_mul)
  func(code_div)    = locwrd(lsic_s_div)
  func(code_uplus)  = locwrd(lsic_s_uplus)
  func(code_uminus) = locwrd(lsic_s_uminus)
  func(code_power)  = locwrd(lsic_s_power)
  !
  ! Intrinsic functions
  func(code_abs)       = locwrd(lsic_s_abs)
  func(code_acos)      = locwrd(lsic_s_acos)
  func(code_asin)      = locwrd(lsic_s_asin)
  func(code_atan)      = locwrd(lsic_s_atan)
  func(code_atanh)     = locwrd(lsic_s_atanh)
  func(code_bessel_i0) = locwrd(lsic_s_bessel_i0)
  func(code_bessel_i1) = locwrd(lsic_s_bessel_i1)
  func(code_bessel_in) = locwrd(lsic_s_bessel_in)
  func(code_bessel_j0) = locwrd(lsic_s_bessel_j0)
  func(code_bessel_j1) = locwrd(lsic_s_bessel_j1)
  func(code_bessel_jn) = locwrd(lsic_s_bessel_jn)
  func(code_bessel_y0) = locwrd(lsic_s_bessel_y0)
  func(code_bessel_y1) = locwrd(lsic_s_bessel_y1)
  func(code_bessel_yn) = locwrd(lsic_s_bessel_yn)
  func(code_cos)       = locwrd(lsic_s_cos)
  func(code_cosh)      = locwrd(lsic_s_cosh)
  func(code_erf)       = locwrd(lsic_s_erf)
  func(code_erfc)      = locwrd(lsic_s_erfc)
  func(code_erfinv)    = locwrd(lsic_s_erfinv)
  func(code_erfcinv)   = locwrd(lsic_s_erfcinv)
  func(code_exp)       = locwrd(lsic_s_exp)
  func(code_int)       = locwrd(lsic_s_int)
  func(code_log)       = locwrd(lsic_s_log)
  func(code_log10)     = locwrd(lsic_s_log10)
  func(code_nint)      = locwrd(lsic_s_nint)
  func(code_sin)       = locwrd(lsic_s_sin)
  func(code_sinh)      = locwrd(lsic_s_sinh)
  func(code_sqrt)      = locwrd(lsic_s_sqrt)
  func(code_tan)       = locwrd(lsic_s_tan)
  func(code_tanh)      = locwrd(lsic_s_tanh)
  func(code_floor)     = locwrd(lsic_s_floor)
  func(code_ceiling)   = locwrd(lsic_s_ceiling)
  !
  func(code_min)      = locwrd(lsic_s_min)
  func(code_max)      = locwrd(lsic_s_max)
  func(code_atan2)    = locwrd(lsic_s_atan2)
  func(code_dim)      = locwrd(lsic_s_dim)
  func(code_sign)     = locwrd(lsic_s_sign)
  func(code_mod)      = locwrd(lsic_s_mod)
  func(code_typeof)   = locwrd(lsic_s_uplus)  ! Special case + identity operation
  func(code_rank)     = locwrd(lsic_s_uplus)  ! Same
  func(code_size)     = locwrd(lsic_s_uplus)  ! Same
  func(code_index)    = locwrd(lsic_s_uplus)  ! Same
  func(code_len)      = locwrd(lsic_s_uplus)  ! Same
  func(code_len_trim) = locwrd(lsic_s_uplus)  ! Same
  func(code_all)      = locwrd(lsic_s_uplus)  ! Same
  func(code_any)      = locwrd(lsic_s_uplus)  ! Same
  func(code_isnan)    = locwrd(lsic_s_uplus)  ! Same
  func(code_isnum)    = locwrd(lsic_s_uplus)  ! Same
  !
  func(code_pyfunc) = locwrd(lsic_s_pyfunc)
  !
  ! Double precision operations
  ! Relational operators
  func(100+code_eq) = locwrd(lsic_d_eq)
  func(100+code_ne) = locwrd(lsic_d_ne)
  func(100+code_le) = locwrd(lsic_d_le)
  func(100+code_lt) = locwrd(lsic_d_lt)
  func(100+code_ge) = locwrd(lsic_d_ge)
  func(100+code_gt) = locwrd(lsic_d_gt)
  !
  ! Arithmetic operators
  func(100+code_bplus)  = locwrd(lsic_d_bplus)
  func(100+code_bminus) = locwrd(lsic_d_bminus)
  func(100+code_mul)    = locwrd(lsic_d_mul)
  func(100+code_div)    = locwrd(lsic_d_div)
  func(100+code_uplus)  = locwrd(lsic_d_uplus)
  func(100+code_uminus) = locwrd(lsic_d_uminus)
  func(100+code_power)  = locwrd(lsic_d_power)
  !
  ! Intrinsic functions
  func(100+code_abs)       = locwrd(lsic_d_abs)
  func(100+code_acos)      = locwrd(lsic_d_acos)
  func(100+code_asin)      = locwrd(lsic_d_asin)
  func(100+code_atan)      = locwrd(lsic_d_atan)
  func(100+code_atanh)     = locwrd(lsic_d_atanh)
  func(100+code_bessel_i0) = locwrd(lsic_d_bessel_i0)
  func(100+code_bessel_i1) = locwrd(lsic_d_bessel_i1)
  func(100+code_bessel_in) = locwrd(lsic_d_bessel_in)
  func(100+code_bessel_j0) = locwrd(lsic_d_bessel_j0)
  func(100+code_bessel_j1) = locwrd(lsic_d_bessel_j1)
  func(100+code_bessel_jn) = locwrd(lsic_d_bessel_jn)
  func(100+code_bessel_y0) = locwrd(lsic_d_bessel_y0)
  func(100+code_bessel_y1) = locwrd(lsic_d_bessel_y1)
  func(100+code_bessel_yn) = locwrd(lsic_d_bessel_yn)
  func(100+code_cos)       = locwrd(lsic_d_cos)
  func(100+code_cosh)      = locwrd(lsic_d_cosh)
  func(100+code_erf)       = locwrd(lsic_d_erf)
  func(100+code_erfc)      = locwrd(lsic_d_erfc)
  func(100+code_erfinv)    = locwrd(lsic_d_erfinv)
  func(100+code_erfcinv)   = locwrd(lsic_d_erfcinv)
  func(100+code_exp)       = locwrd(lsic_d_exp)
  func(100+code_int)       = locwrd(lsic_d_int)
  func(100+code_log)       = locwrd(lsic_d_log)
  func(100+code_log10)     = locwrd(lsic_d_log10)
  func(100+code_nint)      = locwrd(lsic_d_nint)
  func(100+code_sin)       = locwrd(lsic_d_sin)
  func(100+code_sinh)      = locwrd(lsic_d_sinh)
  func(100+code_sqrt)      = locwrd(lsic_d_sqrt)
  func(100+code_tan)       = locwrd(lsic_d_tan)
  func(100+code_tanh)      = locwrd(lsic_d_tanh)
  func(100+code_floor)     = locwrd(lsic_d_floor)
  func(100+code_ceiling)   = locwrd(lsic_d_ceiling)
  !
  func(100+code_min)      = locwrd(lsic_d_min)
  func(100+code_max)      = locwrd(lsic_d_max)
  func(100+code_atan2)    = locwrd(lsic_d_atan2)
  func(100+code_dim)      = locwrd(lsic_d_dim)
  func(100+code_sign)     = locwrd(lsic_d_sign)
  func(100+code_mod)      = locwrd(lsic_d_mod)
  func(100+code_typeof)   = locwrd(lsic_d_uplus)  ! Special case + identity operation
  func(100+code_rank)     = locwrd(lsic_d_uplus)  !
  func(100+code_size)     = locwrd(lsic_d_uplus)  !
  func(100+code_index)    = locwrd(lsic_d_uplus)  !
  func(100+code_len)      = locwrd(lsic_d_uplus)  !
  func(100+code_len_trim) = locwrd(lsic_d_uplus)  !
  func(100+code_all)      = locwrd(lsic_d_uplus)  !
  func(100+code_any)      = locwrd(lsic_d_uplus)  !
  func(100+code_isnan)    = locwrd(lsic_d_uplus)  !
  func(100+code_isnum)    = locwrd(lsic_d_uplus)  !
  !
  func(100+code_pyfunc) = locwrd(lsic_d_pyfunc)
  !
  ! (Long) integer precision operations
  ! Relational operators
  func(200+code_eq) = locwrd(lsic_i_eq)
  func(200+code_ne) = locwrd(lsic_i_ne)
  func(200+code_le) = locwrd(lsic_i_le)
  func(200+code_lt) = locwrd(lsic_i_lt)
  func(200+code_ge) = locwrd(lsic_i_ge)
  func(200+code_gt) = locwrd(lsic_i_gt)
  !
  ! Arithmetic operators
  func(200+code_bplus)  = locwrd(lsic_i_bplus)
  func(200+code_bminus) = locwrd(lsic_i_bminus)
  func(200+code_mul)    = locwrd(lsic_i_mul)
  func(200+code_div)    = locwrd(lsic_i_div)
  func(200+code_uplus)  = locwrd(lsic_i_uplus)
  func(200+code_uminus) = locwrd(lsic_i_uminus)
  func(200+code_power)  = locwrd(lsic_i_power)
  !
  ! Intrinsic functions
  func(200+code_abs)       = locwrd(lsic_i_abs)
  func(200+code_acos)      = locwrd(lsic_i_acos)
  func(200+code_asin)      = locwrd(lsic_i_asin)
  func(200+code_atan)      = locwrd(lsic_i_atan)
  func(200+code_atanh)     = locwrd(lsic_i_atanh)
  func(200+code_bessel_i0) = locwrd(lsic_i_bessel_i0)
  func(200+code_bessel_i1) = locwrd(lsic_i_bessel_i1)
  func(200+code_bessel_in) = locwrd(lsic_i_bessel_in)
  func(200+code_bessel_j0) = locwrd(lsic_i_bessel_j0)
  func(200+code_bessel_j1) = locwrd(lsic_i_bessel_j1)
  func(200+code_bessel_jn) = locwrd(lsic_i_bessel_jn)
  func(200+code_bessel_y0) = locwrd(lsic_i_bessel_y0)
  func(200+code_bessel_y1) = locwrd(lsic_i_bessel_y1)
  func(200+code_bessel_yn) = locwrd(lsic_i_bessel_yn)
  func(200+code_cos)       = locwrd(lsic_i_cos)
  func(200+code_cosh)      = locwrd(lsic_i_cosh)
  func(200+code_erf)       = locwrd(lsic_i_erf)
  func(200+code_erfc)      = locwrd(lsic_i_erfc)
  func(200+code_erfinv)    = locwrd(lsic_i_erfinv)
  func(200+code_erfcinv)   = locwrd(lsic_i_erfcinv)
  func(200+code_exp)       = locwrd(lsic_i_exp)
  func(200+code_int)       = locwrd(lsic_i_int)
  func(200+code_log)       = locwrd(lsic_i_log)
  func(200+code_log10)     = locwrd(lsic_i_log10)
  func(200+code_nint)      = locwrd(lsic_i_nint)
  func(200+code_sin)       = locwrd(lsic_i_sin)
  func(200+code_sinh)      = locwrd(lsic_i_sinh)
  func(200+code_sqrt)      = locwrd(lsic_i_sqrt)
  func(200+code_tan)       = locwrd(lsic_i_tan)
  func(200+code_tanh)      = locwrd(lsic_i_tanh)
  func(200+code_floor)     = locwrd(lsic_i_floor)
  func(200+code_ceiling)   = locwrd(lsic_i_ceiling)
  !
  func(200+code_min)      = locwrd(lsic_i_min)
  func(200+code_max)      = locwrd(lsic_i_max)
  func(200+code_atan2)    = locwrd(lsic_i_atan2)
  func(200+code_dim)      = locwrd(lsic_i_dim)
  func(200+code_sign)     = locwrd(lsic_i_sign)
  func(200+code_mod)      = locwrd(lsic_i_mod)
  func(200+code_typeof)   = locwrd(lsic_i_uplus)  ! Special case + identity operation
  func(200+code_rank)     = locwrd(lsic_i_uplus)  ! Same
  func(200+code_size)     = locwrd(lsic_i_uplus)  ! Same
  func(200+code_index)    = locwrd(lsic_i_uplus)  ! Same
  func(200+code_len)      = locwrd(lsic_i_uplus)  ! Same
  func(200+code_len_trim) = locwrd(lsic_i_uplus)  ! Same
  func(200+code_all)      = locwrd(lsic_i_uplus)  ! Same
  func(200+code_any)      = locwrd(lsic_i_uplus)  ! Same
  func(200+code_isnan)    = locwrd(lsic_i_uplus)  ! Same
  func(200+code_isnum)    = locwrd(lsic_i_uplus)  ! Same
  !
  func(200+code_pyfunc) = locwrd(lsic_i_pyfunc)
  codes = code_scalar+1
end function codes
!
subroutine sic_def_func(name_in,s_func,d_func,nfunarg,error,hlpfile)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_def_func
  use sic_dictionaries
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  !  Defines user functions
  !---------------------------------------------------------------------
  character(len=*), intent(in)           :: name_in  ! Function name
  real(kind=4),     external             :: s_func   ! Real*4 function
  real(kind=8),     external             :: d_func   ! Real*8 function
  integer(kind=4),  intent(in)           :: nfunarg  ! Number of arguments for function
  logical,          intent(out)          :: error    ! Logical error flag
  character(len=*), intent(in), optional :: hlpfile  ! Help file for "HELP FUNCTION Name"
  ! Local
  character(len=*), parameter :: rname='FUNCTION'
  integer(kind=4) :: in,ier
  character(len=message_length) :: mess
  character(len=16) :: name
  !
  name = name_in
  if (.not.loaded) then
    call sic_message(seve%e,rname,'SIC is not loaded')
    error = .true.
    return
  endif
  if (nfunarg.gt.4) then
    call sic_message(seve%e,rname,'Too many arguments to function '//name)
    error =.true.
    return
  elseif (nfunarg.lt.1) then
    write(mess,1002) nfunarg,' arguments to function ',name
    call sic_message(seve%e,rname,mess)
    error =.true.
    return
  endif
  !
  ! Check if name is already defined
  ier = gag_hasfin(maxfun,pffun,pnfun,namfun,name,in)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,'Function '//name(1:15)//' already exists')
    error = .true.
    return
  endif
  !
  ier = gag_hasins(maxfun,pffun,pnfun,namfun,name,in)
  if (ier.eq.0) then
    call sic_message(seve%e,rname,'Invalid function name '//name)
    error = .true.
    return
  elseif (ier.eq.2) then
    call sic_message(seve%e,rname,'Too many functions')
    error = .true.
    return
  endif
  !
  descfun(in)%narg = nfunarg
  descfun(in)%code = code_user
  if (present(hlpfile)) then
    descfun(in)%help = hlpfile
  else
    descfun(in)%help = ""
  endif
  addr_function (code_user) = locwrd (s_func)
  addr_function (100+code_user) = locwrd (d_func)
  code_user = code_user+1
  error = .false.
  !
1002 format(i2,a,a)
end subroutine sic_def_func
!
subroutine sic_get_func(name_in,code,nfunarg,error)
  use sic_dependencies_interfaces
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Returns number of arguments and code
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name_in     !
  integer(kind=4),  intent(out)   :: code        !
  integer(kind=4),  intent(out)   :: nfunarg(2)  ! Min-max number of arguments
  logical,          intent(inout) :: error       !
  ! Local
  integer(kind=4) :: ier,in
  character(len=16) :: name
  !
  name = name_in
  ier = gag_hasfin(maxfun,pffun,pnfun,namfun,name,in)
  if (ier.ne.1) then
    error = .true.
    return
  endif
  !
  nfunarg = descfun(in)%narg
  code = descfun(in)%code
  !
end subroutine sic_get_func
!
subroutine sic_inifunction
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_inifunction
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  call gag_hasini(maxfun,pffun,pnfun)
  code_user = codes(addr_function)
end subroutine sic_inifunction
!
subroutine sic_list_func
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_list_func
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='FUNCTION'
  integer(kind=4) :: in,list(maxfun),i
  character(len=message_length) :: mess
  !
  call gag_hassort(maxfun,pffun,pnfun,namfun,list,in)
  call sic_message(seve%i,rname,'Program functions are:')
  do i = 1,in
    write(mess,1001) namfun(list(i)),descfun(list(i))%narg
    call sic_message(seve%r,rname,mess)
  enddo
  !
1001 format(a,4x,i1,' arguments')
end subroutine sic_list_func

program shift_main
  use gildas_def
  use gbl_format
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  !	Main program for shifting a 2D image by phase factor in Fourier plane.
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: pname = 'SHIFT'
  real(8), parameter :: pi=3.141592653589793d0
  !
  character(len=filename_length) :: namex,namey
  logical :: error
  real :: xx,yy,xshift,yshift
  complex :: shift
  integer :: i, j, nxy, ndim, dims(2), ier
  complex, allocatable :: cdata(:,:)
  real, allocatable :: work(:), rdata(:,:)
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('X_SHIFT$',xshift,1)
  call gildas_real('Y_SHIFT$',yshift,1)
  call gildas_close
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error,data=.false.)
  if (error) then
    write(6,*) 'F-'//pname//',  Cannot read input file '//trim(y%file) 
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(namex,x%file,' ','.gdf')
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-'//pname//',  Cannot create output image'
    goto 100
  endif
  !
  ! Check if work space is needed.
  nxy = 2*max(x%gil%dim(1),x%gil%dim(2))
  allocate (work(nxy), cdata(x%gil%dim(1), x%gil%dim(2)), &
       & rdata(x%gil%dim(1), x%gil%dim(2)), stat=ier)
  nxy = x%gil%dim(1)*x%gil%dim(2)
  if (ier.ne.0) goto 100
  !
  ! Compute shift factor
  xx = 2.d0*pi*xshift/x%gil%inc(1)
  yy = 2.d0*pi*yshift/x%gil%inc(2)
  shift = cmplx(cos(xx),sin(xx))*cmplx(cos(yy),sin(yy))
  !
  ! Prepare FFTW
  dims = x%gil%dim(1:2)
  ndim = 2
  call fourt_plan (cdata,dims,ndim,1,0)
  call fourt_plan (cdata,dims,ndim,-1,1)
  !
  do j=1,x%gil%dim(4)
    x%blc(4) = j
    x%trc(4) = j
    do i=1,x%gil%dim(3)
      x%blc(3) = i
      x%trc(3) = i
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,rdata,error)
      !
      cdata(:,:) = cmplx(rdata,0.0)
      call fourt(cdata,dims,ndim,1,0,work)
      cdata(:,:) = cdata*shift         ! Apply phase shift
      call fourt(cdata,dims,ndim,-1,+1,work) 
      rdata(:,:) = real(cdata)/nxy     ! Normalize fft
      !
      call gdf_write_data(x,rdata,error)
    enddo
  enddo
  call gagout ('S-'//pname//',  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program shift_main

subroutine difsys4 (f,eps,h,x,y)
  use greg_interfaces, except_this=>difsys4
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !       adapted from Prof. Dr. R. BULIRSCH, 1972-73
  !	P. VALIRON				21-AUG-80
  !	adapted for single precision		27-SEP-84
  !	Integration of first order differential equations.
  !	The equation is supposed to be of the form:
  !             DY/DX = F(X,Y)
  ! Arguments :
  !	F	Ext	User supplied subroutine. Computes
  !			the right end of (1) for a given X and Y
  !			F must contain the instructions:
  !				SUBROUTINE F(X,Y,DYDX)
  !				REAL*4 X,Y,DYDX
  !	EPS	R*4	Accuracy, kept internally > 1.E-11
  !	H	R*4	User estimate of the best step of
  !			integration, updated.
  !	X	R*4	initial abcissa.
  !	Y	R*4	Initial value of Y.
  !	After the calculation, X is replaced by X+H2 and Y by its
  !	value for the abscissa X+H2. H2 is less or equal to H, its value
  !	is chosen internally to satisfy the required accuracy EPS.
  !	The subroutine returns H equal to the best value for the next
  !	step. If the system seems to be ill conditioned, or if the initial
  !	value for H is much too high, H is returned equal to 0.
  !	( See BULIRSCH,R. and STOER,J.; NUM.MATH. /8/,1-13 (1966) )
  ! Subroutines :
  !	F	External
  !---------------------------------------------------------------------
  external :: f                     !
  real*4 :: eps                     !
  real*4 :: h                       !
  real*4 :: x                       !
  real*4 :: y                       !
  ! Local
  real*4 :: ya,yl,ym,dy,dz,dt(7),d(7),s
  real*4 :: xn,g,b,b1,u,v,c,ta,w,ep(4)
  logical ::   konv,bo,kl,gr
  integer :: jti,m,jr,js,j,l,k
  real :: fy,eta,fs,fv,fa
  data ep/0.4e-1,0.16e-2,0.64e-4,0.256e-5/
  !
  jti=0
  fy=1.
  eta=abs(eps)
  if (eta.lt.1.e-11) eta=1.e-11
  ya=y
  call f (x,y,dz)
10 xn=x+h
  bo=.false.
  s=0.
  m=1
  jr=2
  js=3
  do j=1,10
    if(.not.bo) goto 200
    d(2)=1.777777777777778
    d(4)=7.111111111111111
    d(6)=28.44444444444444
    goto 201
200 d(2)=2.25
    d(4)=9.
    d(6)=36.
201 if(j.le.7) goto 202
    l=7
    d(7)=64.
    goto 203
202 l=j
    d(l)=m*m
203 konv=l.gt.3
    m=m+m
    g=h/float(m)
    b=g+g
    m=m-1
    yl=ya
    ym=ya+g*dz
    do k=1,m
      call f (x+float(k)*g,ym,dy)
      u=yl+b*dy
      yl=ym
      ym=u
      u=abs(u)
      if(u.gt.s) s=u
    enddo                      ! K
    call f (xn,ym,dy)
    kl=l.lt.2
    gr=l.gt.5
    fs=0.
    v=dt(1)
    c=(ym+yl+g*dy)*0.5
    dt(1)=c
    ta=c
    if(kl) goto 233
    do k=2,l
      b1=d(k)*v
      b=b1-c
      w=c-v
      u=v
      if(b.eq.0.) goto 230
      b=w/b
      u=c*b
      c=b1*b
230   v=dt(k)
      dt(k)=u
      ta=u+ta
    enddo                      ! K
    if(.not.konv) goto 232
    if(abs(y-ta).gt.s*eta) konv=.false.
232 if(gr.or.s.eq.0.) goto 233
    fv=abs(w)/s
    if(fs.lt.fv) fs=fv
233 y=ta
    if(fs.eq.0.) goto 250
    fa=fy
    k=l-1
    fy=(ep(k)/fs)**(1./float(l+k))
    if(l.eq.2) goto 240
    if(fy.lt.0.7*fa) goto 250
240 if(fy.gt.0.7) goto 250
    h=h*fy
    jti=jti+1
    if(jti.gt.5) goto 30
    goto 10
250 if(konv) goto 20
    d(3)=4.
    d(5)=16.
    bo=.not.bo
    m=jr
    jr=js
    js=m+m
  enddo                        ! J
  h=h*0.5
  goto 10
20 x=xn
  h=h*fy
  return
30 h=0.
  y=ya
  return
end subroutine difsys4

subroutine gtl_create(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_create
  use gtv_tree
  use gtv_buffers
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Support routine for command
  ! CREATE WINDOW|DIRECTORY|PENLUT|LUT [/SIZE SizeX SizeY] [/PIXEL Px Py]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CREATE'
  integer, parameter :: nvocab=4
  character(len=12) :: vocab(nvocab),to_check,comm
  integer :: ncom
  !
  data vocab /'DIRECTORY','PENLUT','LUT','WINDOW'/
  !
  call sic_ke (line,0,1,to_check,ncom,.true.,error)
  if (error) return
  !
  ! Check if type of variable is known
  call sic_ambigs(rname,to_check,comm,ncom,vocab,nvocab,error)
  if (error) return
  !
  select case (comm)
  case('DIRECTORY')
    call gtl_mkdir(line,error)
    !
  case('PENLUT')
    call gtv_penlut(error)
    !
  case('LUT')
    call gtv_lut(error)
    !
  case('WINDOW')
    call gtl_create_window(line,error)
    !
  case default
    call gtv_message(seve%e,rname,'CREATE '//trim(comm)//' not yet implemented')
    error = .true.
    return
  end select
  !
end subroutine gtl_create
!
subroutine gtl_create_window(line,error)
  use gildas_def
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_create_window
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  CREATE WINDOW  [WHITE|BLACK] [NAME Name] /PIXEL Px Py
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CREATE WINDOW'
  real :: ax,ay,bx,by
  integer :: backg,ncom,iarg,nc,sever
  integer, parameter :: nvocab=3
  character(len=12) :: comm,vocab(nvocab),argum,argx,argy
  real(kind=4), parameter :: margin=.05  ! Margin size, as a fraction.
  real(kind=4) :: xmargin,ymargin
  type(x_output) :: xdisplay
  ! Data
  data vocab /'BLACK','WHITE','NAME'/
  !
  ! 0) Basic checks
  if (cw_device%protocol.ne.p_x) then
    call gtv_message(seve%w,rname,'Ignored when not using X-Window')
    return
  endif
  if (associated(cw_directory,root)) then
    call gtv_message(seve%e,rname,'Cannot create window under root <')
    error = .true.
    return
  endif
  if (sic_present(1,0)) then
    call gtv_message(seve%e,rname,'Option /SIZE is invalid in this context')
    error = .true.
    return
  endif
  !
  ! 1) Get the window characteristics
  !
  call x_display_reset(xdisplay)  ! Default values
  !
  ! CREATE WINDOW arguments
  iarg = 2
  backg = -1
  do while (iarg.le.sic_narg(0))
    call sic_ke (line,0,iarg,argum,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,argum,comm,ncom,vocab,nvocab,error)
    if (error) return
    if (comm.eq.'BLACK') then
      backg = 0
    elseif (comm.eq.'WHITE') then
      backg = 1
    elseif (comm.eq.'NAME') then
      iarg = iarg+1
      call sic_ch (line,0,iarg,xdisplay%name,nc,.true.,error)
      if (error) return
    endif
    iarg = iarg+1
  enddo
  !
  ! /GEOMETRY arguments
  if (sic_present(3,0)) then
    call sic_ch(line,3,1,argx,nc,.true.,error)
    if (error) return
    call sic_ch(line,3,2,argy,nc,.true.,error)
    if (error) return
    call decode_coordinates(xdisplay%geometry,argx,argy,error)
    if (error)  return
  endif
  !
  ! /POSITION arguments
  if (sic_present(4,0)) then
    call sic_ch(line,4,1,argx,nc,.true.,error)
    if (error) return
    call sic_ch(line,4,2,argy,nc,.true.,error)
    if (error) return
    call decode_coordinates(xdisplay%position,argx,argy,error)
    if (error)  return
  endif
  !
  ! /PIXEL arguments (obsolete since 05-oct-2010)
  if (sic_present(2,0)) then
    if (strict2011) then
      sever = seve%e
    else
      sever = seve%w
    endif
    call gtv_message(sever,rname,  &
      'CREATE WINDOW /PIXEL is obsolete. Use /GEOMETRY instead.')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call sic_r4(line,2,1,xdisplay%geometry%x,.true.,error)
    if (error) return
    xdisplay%geometry%unitx = 'p'  ! pixels
    !
    call sic_r4(line,2,2,xdisplay%geometry%y,.true.,error)
    if (error) return
    xdisplay%geometry%unity = 'p'  ! pixels
  endif
  !
  ! 2) Prepare the directory
  xmargin = (cw_directory%gen%minmax(2)-cw_directory%gen%minmax(1))*margin
  ax = max(cw_directory%gen%minmax(1)-xmargin,0.)
  bx = min(cw_directory%gen%minmax(2)+xmargin,cw_directory%phys_size(1))
  !
  ymargin = (cw_directory%gen%minmax(4)-cw_directory%gen%minmax(3))*margin
  ay = max(cw_directory%gen%minmax(3)-ymargin,0.)
  by = min(cw_directory%gen%minmax(4)+ymargin,cw_directory%phys_size(2))
  !
  ! 3) Now create it. A new window will be attached to the output instances
  !    list:
  call get_free_slot_output(cw_output,error)
  if (error)  return
  cw_output%dev => cw_device      ! Point on the shared X-protocol instance
  cw_output%color = .true.
  if (backg.eq.-1) then
    ! Use the device default color
    cw_output%background = cw_output%dev%background
  else
    ! Override the device default color
    cw_output%background = backg
  endif
  cw_output%x = xdisplay
  !
  call create_window(cw_output,.false.,cw_directory,.true.,.true.,error)
  if (error)  return
  !
  ! 4) Set up the scaling for the new window, and redraw:
  call gtwindow(cw_output,ax,bx,ay,by)
  !
end subroutine gtl_create_window
!
subroutine create_window(output,first,dir,default,frommain,error)
  use gildas_def
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>create_window
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Create a new window and register it in the GTV tree. If 'output'
  ! already knows a non-null graph_env, we assume the window as already
  ! been created and we only need to register it.
  ! ---
  !  Thread status: safe to call from main or graphic thread.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output    ! Output instance
  logical,          intent(in)    :: first     ! Very first window of the device?
  type(gt_directory)              :: dir       ! Directory to which the window is attached
  logical,          intent(in)    :: default   ! Make it the default window of the directory?
  logical,          intent(in)    :: frommain  ! Call from main or graphic thread?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CREATE WINDOW'
  integer(kind=address_length) :: graph_env
  character(len=32) :: argx,argy
  character(len=gtvpath_length) :: name,dirname
  integer :: ldir,geomx,geomy,posx,posy
  integer*4 :: win_num_c,win_num_user
  character(len=message_length) :: mess
  logical :: created
  !
  if (output%dev%protocol.eq.p_null) then
    ! No device, nothing to do
    return
    !
  elseif (output%dev%protocol.ne.p_x) then
    call gtv_message(seve%e,rname,'Not available for device other than X')
    error = .true.
    return
  endif
  !
  if (frommain) then
    call gtv_open_segments_for_writing_from_main()
  else
    call gtv_open_segments_for_writing_from_graph()
  endif
  !
  created = .false.
  !
  call cree_chemin_dir(dir,dirname,ldir)
  !
  ! Check if the maximum number of windows is reached
  if (dir%x%nbwin.ge.mwindows) then
    write(mess,'(A,I2,2A)') 'Can not attach more than ',mwindows,  &
      ' windows to directory ',dirname
    call gtv_message(seve%e,rname,mess)
    error = .true.
    goto 100
  endif
  !
  ! Compute the new window number (as seen by user)
  win_num_user = create_window_number(dir,error)
  if (error)  goto 100
  !
  if (output%x%graph_env.eq.0) then
    ! Create a new window.
    ! The name of the x window is the directory name and the window number,
    ! unless otherwise specified in the calling arguments
    if (output%x%name.eq.' ') then
      if (win_num_user.eq.1) then
        ! Hide the window number for window #1, most of users are not aware
        ! that a directory can have several windows.
        name = dirname
      else
        write(name,'(A,1X,I0)') trim(dirname),win_num_user
      endif
      output%x%name = name
    else
      name = output%x%name
    endif
    !
    ! WINDOW GEOMETRY
    if (output%x%geometry%x.le.0. .or. output%x%geometry%y.le.0.) then
      ! Try to use user's logical WINDOW_GEOMETRY
      call sic_getlog_coordinates('WINDOW_GEOMETRY',argx,argy,error)
      if (error)  goto 100
      call decode_coordinates(output%x%geometry,argx,argy,error)
      if (error)  goto 100
    endif
    if (output%x%geometry%x.le.0. .or. output%x%geometry%y.le.0.) then
      ! Use internal device default
      output%x%geometry%x = max(output%dev%px1,output%dev%px2)
      output%x%geometry%unitx = 'p'
      output%x%geometry%y = max(output%dev%py1,output%dev%py2)
      output%x%geometry%unity = 'p'
    endif
    ! Coordinates conversion
    call compute_coordinates_geometry(rname,output%x%geometry,geomx,geomy,error)
    if (error)  goto 100
    !
    if (dir%x%nbwin.eq.0) then
      ! This will be a new window in a directory with no windows.
      ! Create a new table for the addresses of the graphical environments,
      ! put the address of the table in the directory descriptor
      dir%x%genv_array = c_new_genv_array(mwindows)
    endif
    !
    ! Now create the window
    call createwindow(output%background,graph_env,name,geomx,geomy,  &
      dir,len_trim(name))
    output%x%graph_env = graph_env
    ! Store the actual size of the window
    call get_win_pixel_info(output%x%graph_env,output%px1,output%py1,  &
      output%px2,output%py2)
    !
    ! WINDOW POSITION
    if (first) then
      !  Try to read the logical WINDOW_POSITION, only for the first
      ! window of the device (else each new window will overlap the other
      ! ones)
      if (output%x%position%x.le.0. .or. output%x%position%y.le.0.) then
        ! Try to use user's logical WINDOW_POSITION
        call sic_getlog_coordinates('WINDOW_POSITION',argx,argy,error)
        if (error)  goto 100
        call decode_coordinates(output%x%position,argx,argy,error)
        if (error)  goto 100
      endif
    endif
    if (output%x%position%x.lt.0. .or. output%x%position%y.lt.0.) then
      ! No internal default! Let the window manager decide.
      continue
    else
      ! Coordinates conversion
      call compute_coordinates_position(output,posx,posy,error)
      if (error) then
        ! Ignore. Window position will be erroneous (only). And we have
        ! to finish its registration!
        error = .false.
      endif
      ! Move
      call x_move_window(output%x%graph_env,posx,posy)
    endif
    !
    created = .true.
  else
    ! The window already exists (e.g. the lens). Just store the actual
    ! size of the window
    call get_win_pixel_info(output%x%graph_env,output%px1,output%py1,  &
      output%px2,output%py2)
  endif
  !
  output%dev%hardw_cursor = .true.
  !
  ! If this is the (new) default window, put the address of the graphical
  ! environment in the directory descriptor
  if (default)  dir%x%genv = output%x%graph_env
  !
  ! Put the address of the graphical environment in the table of addresses for
  ! all the windows in the directory (the table is ordered by window number)
  win_num_c = dir%x%nbwin  ! C numbering starts from 0
  call c_set_win_genv(dir%x%genv_array,win_num_c,output%x%graph_env)
  !
  ! Set the window number, and the current window and the total number of
  ! windows in the directory descriptor
  output%x%number = win_num_user
  if (default)  dir%x%curwin = win_num_c
  dir%x%nbwin = dir%x%nbwin+1
  !
100 continue
  if (frommain) then
    call gtv_close_segments_for_writing_from_main()
  else
    call gtv_close_segments_for_writing_from_graph()
  endif
  !
  if (created)  call createwindow_wait()
  !
end subroutine create_window
!
function create_window_number(dir,error)
  use gtv_interfaces, except_this=>create_window_number
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: create_window_number     ! Function value on return
  type(gt_directory), intent(in)    :: dir    ! Parent directory
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_display), pointer :: output
  integer :: iwin,win_num(mwindows)
  !
  create_window_number = 0
  win_num = 0
  !
  do iwin=0,dir%x%nbwin-1
    call get_slot_output_by_num(dir,iwin,output,error)
    if (error)  return
    !
    win_num(output%x%number) = 1
  enddo
  !
  do iwin=1,mwindows
    if (win_num(iwin).eq.0) then
      create_window_number = iwin
      return
    endif
  enddo
  !
  error = .true.
  return
  !
end function create_window_number
!
subroutine decode_coordinates(xcoord,argx,argy,error)
  use gtv_interfaces, except_this=>decode_coordinates
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(x_coordinates), intent(inout) :: xcoord  !
  character(len=*),    intent(in)    :: argx    ! X value
  character(len=*),    intent(in)    :: argy    ! Y value
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WINDOW'
  character(len=32) :: argum
  integer :: nc,ier
  !
  if (argx.ne.' ') then
    ! Read the X unit
    nc = len_trim(argx)
    if (argx(nc:nc).eq.'p' .or. argx(nc:nc).eq.'P' .or.  &
        argx(nc:nc).eq.'r' .or. argx(nc:nc).eq.'R' .or.  &
        argx(nc:nc).eq.'%') then
      xcoord%unitx = argx(nc:nc)
      argum = argx(1:nc-1)
    else
      xcoord%unitx = 'p'  ! Default is pixels
      argum = argx
    endif
    !
    ! Read the X value
    read (argum,*,iostat=ier) xcoord%x
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Error decoding argument '''//trim(argx)//'''')
      error = .true.
      return
    endif
  endif
  !
  if (argy.ne.' ') then
    ! Read the Y unit
    nc = len_trim(argy)
    if (argy(nc:nc).eq.'p' .or. argy(nc:nc).eq.'P' .or.  &
        argy(nc:nc).eq.'r' .or. argy(nc:nc).eq.'R' .or.  &
        argy(nc:nc).eq.'%') then
      xcoord%unity = argy(nc:nc)
      argum = argy(1:nc-1)
    else
      xcoord%unity = 'p'  ! Default is pixels
      argum = argy
    endif
    !
    ! Read the Y value
    read (argum,*,iostat=ier) xcoord%y
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Error decoding argument '''//trim(argy)//'''')
      error = .true.
      return
    endif
  endif
  !
end subroutine decode_coordinates
!
subroutine sic_getlog_coordinates(logic_in,argx,argy,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>sic_getlog_coordinates
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: logic_in  ! SIC logical
  character(len=*), intent(out)   :: argx      !
  character(len=*), intent(out)   :: argy      !
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SIC_GETLOG_COORD'
  character(len=32) :: logic
  integer(kind=4) :: ier
  !
  ! Default
  argx = ' '
  argy = ' '
  !
  ier = sic_getlog(logic_in,logic)
  if (ier.ne.0)  return  ! SIC LOGICAL is unset
  !
  read(logic,*,iostat=ier) argx,argy
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Could not decode user-defined '//  &
      trim(logic_in)//' logical variable: '''//trim(logic)//'''')
    error = .true.
    return
  endif
  !
end subroutine sic_getlog_coordinates
!
subroutine compute_coordinates_geometry(rname,xcoord,npixx,npixy,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>compute_coordinates_geometry
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: rname   ! Caller name
  type(x_coordinates), intent(in)    :: xcoord  !
  integer(kind=4),     intent(out)   :: npixx   !
  integer(kind=4),     intent(out)   :: npixy   !
  logical,             intent(inout) :: error   ! Logical error flag
  ! Local
  real(kind=4) :: x,y
  character(len=1) :: unitx,unity
  integer :: screenx,screeny
  !
  x     = xcoord%x
  unitx = xcoord%unitx
  y     = xcoord%y
  unity = xcoord%unity
  if (unitx.eq.'r' .and. unity.eq.'r') then
    call gtv_message(seve%e,rname,  &
      'Units can not be both ''ratio'' with /GEOMETRY')
    error = .true.
    return
  endif
  !
  call sic_lower(unitx)
  call sic_lower(unity)
  !
  if (unitx.eq.'%' .or. unity.eq.'%') then
    call x_screen_size(screenx,screeny)
    if (screenx.le.0 .or. screeny.le.0) then
      ! Most likely no screen (batch job) or GTK missing
      call gtv_message(seve%e,rname,  &
        'Could not retrieve screen size: % unit can not be used for device geometry')
      error = .true.
      return
    endif
  endif
  !
  ! X values:
  select case (unitx)
  case ('p')
    npixx = nint(x)
  case ('%')
    npixx = nint(screenx*x/100.)
  case ('r')
    continue  ! Will be set after npixy
  case (' ')
    call gtv_message(seve%e,rname,'Internal error: X unit value is unset')
    error = .true.
    return
  case default
    call gtv_message(seve%e,rname,'Unknown X unit '''//unitx//'''')
    error = .true.
    return
  end select
  !
  ! Y values:
  select case (unity)
  case ('p')
    npixy = nint(y)
  case ('%')
    npixy = nint(screeny*y/100.)
  case ('r')
    npixy = npixx * y
  case (' ')
    call gtv_message(seve%e,rname,'Internal error: Y unit value is unset')
    error = .true.
    return
  case default
    call gtv_message(seve%e,rname,'Unknown Y unit '''//unity//'''')
    error = .true.
    return
  end select
  !
  if (unitx.eq.'r')  npixx = npixy * x
  !
end subroutine compute_coordinates_geometry
!
subroutine compute_coordinates_position(output,npixx,npixy,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>compute_coordinates_position
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  !
  integer(kind=4),  intent(out)   :: npixx   !
  integer(kind=4),  intent(out)   :: npixy   !
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CREATE WINDOW'
  real(kind=4) :: x,y
  character(len=1) :: unitx,unity
  integer :: screenx,screeny,windowx,windowy
  !
  x     = output%x%position%x
  unitx = output%x%position%unitx
  y     = output%x%position%y
  unity = output%x%position%unity
  windowx = output%px2
  windowy = output%py1
  if (unitx.eq.'r' .or. unity.eq.'r') then
    call gtv_message(seve%e,rname,  &
      'Units can not be ''ratio'' with /POSITION')
    error = .true.
    return
  endif
  !
  call sic_lower(unitx)
  call sic_lower(unity)
  !
  if (unitx.eq.'%' .or. unity.eq.'%' .or. unity.eq.'p') then
    call x_screen_size(screenx,screeny)
    if (screenx.le.0 .or. screeny.le.0) then
      ! Most likely no screen (batch job) or GTK missing
      call gtv_message(seve%e,rname,  &
        'Could not retrieve screen size: % or p unit can not be used for device position')
      error = .true.
      return
    endif
  endif
  !
  ! X values:
  select case (unitx)
  case ('p')
    npixx = nint(x)
  case ('%')
    npixx = nint(screenx*x/100. - windowx*x/100.)
  case ('r')
    continue  ! Will be set after npixy
  case (' ')
    call gtv_message(seve%e,rname,'Internal error: X unit value is unset')
    error = .true.
    return
  case default
    call gtv_message(seve%e,rname,'Unknown X unit '''//unitx//'''')
    error = .true.
    return
  end select
  !
  ! Y values:
  select case (unity)
  case ('p')
    y = screeny-y
    npixy = nint(y - windowy)
  case ('%')
    y = 100.-y
    npixy = nint(screeny*y/100. - windowy*y/100.)
  case ('r')
    npixy = npixx * y
  case (' ')
    call gtv_message(seve%e,rname,'Internal error: Y unit value is unset')
    error = .true.
    return
  case default
    call gtv_message(seve%e,rname,'Unknown Y unit '''//unity//'''')
    error = .true.
    return
  end select
  !
  if (unitx.eq.'r')  npixx = npixy * x
  !
end subroutine compute_coordinates_position

subroutine mx_local_clean(hu,hb,hr,hc,hcct,grid,mapx,mapy,work,sblock, cpu0)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use cct_types
  use mx_parameters
  use clean_beam_tool, only: find_sidelobe
  use minmax_tool, only: maxmap
  !---------------------------------------------------------------------
  ! GILDAS: CLEAN Internal routine
  ! Implementation of MX CLEAN deconvolution algorithm.
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hu    ! UV Data  Header
  type(gildas), intent(in) :: hb    ! Beam     Header
  type(gildas), intent(in) :: hr    ! Residual Header
  type(gildas), intent(in) :: hcct  ! Clean Component Table Header
  type(gildas), intent(in) :: hc    ! Clean    Header
  real :: grid(hb%gil%dim(1),hb%gil%dim(2))     ! Gridding correction
  real :: mapx(hb%gil%dim(1))                   ! X coordinates
  real :: mapy(hb%gil%dim(2))                   ! Y coordinates
  real :: work(*)                   ! FFT Work array
  integer :: sblock                 ! Blocking factor
  real :: cpu0                      ! Starting CPU
  ! Local
  integer :: i, j, box(4), ix_min,iy_min, nx,ny,nz, nclean, k, ier
  complex, allocatable :: p_work(:,:)
  real, allocatable :: p_ux(:), p_vy(:)
  integer, allocatable :: p_iter(:)
  type (cct_par), allocatable :: p_comp(:)
  real :: xinc, yinc
  !
  nx = hr%gil%dim(1)
  ny = hr%gil%dim(2)
  !
  ! Get some memory
  nclean = (c_trc(1)-c_blc(1)+1) * (c_trc(2)-c_blc(2)+1)
  allocate (p_work(nx,ny), p_comp(nclean), p_ux(nx), p_vy(ny), stat=ier)
  !
  call mx_loadxy (hu,hr,p_ux,nx,p_vy,ny,mcol)
  !
  box(1) = 1
  box(2) = 1
  box(3) = nx
  box(4) = ny
  !
  ! Prepare beam parameters
  call maxmap (hb%r2d,nx,ny,box,   &
     &    beam_max,ix_beam,iy_beam,beam_min,ix_min,iy_min)
  write(6,1000) 'I-MX_CLEAN,  Beam maximum ',beam_max,   &
     &    ' at ',ix_beam,iy_beam
  write(6,1000) 'I-MX_CLEAN,  Beam minimum ',beam_min,   &
     &    ' at ',ix_min,iy_min
  call find_sidelobe (hb%r2d,nx,ny,   &
     &    ix_beam,iy_beam,ix_patch,iy_patch,beam_gain)
  write(6,1000) 'I-MX_CLEAN,  Maximum sidelobe is ',beam_gain
  !
  box(1) = c_blc(1)
  box(2) = c_blc(2)
  box(3) = c_trc(1)
  box(4) = c_trc(2)
  xinc = hc%gil%inc(1)
  yinc = hc%gil%inc(2)
  !
  ! Find components
  nz = hc%gil%dim(4)*hc%gil%dim(3)
  allocate (p_iter(nz), stat=ier)
  call mx_major (hu,   &
     &    hb%r2d, hr%r3d, nx,ny, nz,   &
     &    p_work, p_comp, nclean,   &
     &    box, max_iter, hcct%r3d, p_iter,   &
     &    grid,  mapx, mapy, p_ux, p_vy,  &
     &    work, map_tf, sblock, cpu0)
  !
  ! Add clean components to clean map
  k = 0
  do j=1,hc%gil%dim(4)
    do i=1,hc%gil%dim(3)
      k = k+1
      write(6,1001) 'I-CLARK,  Restoring plane ',i,j
      call mx_make_clean (   &
     &        hc%r3d(:,:,k),nx,ny,   &
     &        p_work,   &
     &        major_axis,minor_axis,pos_angle,   &
     &        xinc,yinc,hcct%r3d(:,:,k), p_iter(k), &
     &        work, hr%r3d(:,:,k) )
    enddo
  enddo
  !
  1001  format(a,i5,i5)
  1000  format(a,1pg11.4,a,i6,i6)
end subroutine mx_local_clean
!
subroutine mx_make_clean (clean,nx,ny,ft,bmaj,bmin,pa,   &
     &    xinc,yinc,compon,nc,work,resi)
  use gkernel_interfaces
  use mapping_gaussian_tool
  !---------------------------------------------------------------------
  ! GILDAS: CLEAN   Internal routine
  ! Convolve source list into residual map using the Fourier method.
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real :: clean(nx,ny)              !
  complex :: ft(nx,ny)              !
  real :: bmaj                      !
  real :: bmin                      !
  real :: pa                        !
  real :: xinc                      !
  real :: yinc                      !
  integer :: nc                     !
  real :: compon(3,nc)              !
  real :: work(*)                   !
  real :: resi(nx,ny)               !
  ! Local
  real(8), parameter :: pi=3.141592653589793d0
  real :: fact
  integer :: i, j, ic, ndim, dim(2)
  !
  clean = resi
  if (nc.eq.0) return
  !
  ft = 0.0
  !
  ! Convolve source list into residual map ---
  do ic=1,nc
    i = nint(compon(2,ic))
    j = nint(compon(3,ic))
    ft(i,j) = ft(i,j) + compon(1,ic)
  enddo
  !
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  call fourt(ft,dim,ndim,-1,0,work)
  !
  ! Beam Area = PI * BMAJ * BMIN / (4 * LOG(2) ) for flux density
  ! normalisation
  fact = bmaj*bmin*pi/(4.0*log(2.0))/abs(xinc*yinc)/(nx*ny)
  call mulgau(ft,nx,ny,bmaj,bmin,pa,fact,xinc,yinc)
  call fourt (ft,dim,ndim,1,1,work)
  ! Add Residual and Clean image
  clean = clean + real(ft)
end subroutine mx_make_clean
!
subroutine mx_loadxy (x,y,mapux,nx,mapvy,ny,mcol)
  use gkernel_interfaces, only : gdf_uv_frequency
  use gildas_def
  use image_def
  type(gildas) :: x,y               !
  integer :: nx                     !
  real :: mapux(nx)                 !
  integer :: ny                     !
  real :: mapvy(ny)                 !
  integer :: mcol(2)                !
  !
  ! Local
  integer :: i
  real(8) :: pidsur                  ! 2*pi*D/Lambda
  real(8) :: freq, dcol
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  dcol = (mcol(1)+mcol(2))*0.5d0
  freq = gdf_uv_frequency(x,dcol)
  pidsur = f_to_k * freq
  !
  do i=1,nx
    mapux(i) = pidsur*((i-y%gil%ref(1))*y%gil%inc(1)+y%gil%val(1))
  enddo
  do i=1,ny
    mapvy(i) = pidsur*((i-y%gil%ref(2))*y%gil%inc(2)+y%gil%val(2))
  enddo
end subroutine mx_loadxy

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mapping_load
  use gbl_message
  !
  public :: load_comm
  private
  !
contains
  !
  subroutine load_comm(line,error)
    use gkernel_interfaces
    use file_buffers
    use plot_buffers
    use mapping_show_or_view, only: buffer_copy
    !----------------------------------------------------------------------
    ! LOAD Name
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: ntype,nc
    character(len=12) :: argu, d_type
    !
    ! Parse input line
    call sic_ke(line,0,1,argu,nc,.true.,error)
    if (error) return
    if (argu.eq.'?') argu = ' '
    call sic_ambigs('LOAD',argu,d_type,ntype,vtype,mtype,error)
    if (error) return
    ! Load into SIC variable W
    call buffer_copy(d_type,'W',w_plot,error)
    if (error) return
  end subroutine load_comm
end module mapping_load
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gio_reis (is,gtype,name,form,size,error)
  use gildas_def
  use gio_interfaces, only : gio_rewris
  !---------------------------------------------------------------------
  ! @ public
  ! GDF   REad Image Slot
  !   Only used by SIC
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: is     ! Image SLot
  character(len=*),          intent(out)   :: gtype  ! Image type
  character(len=*),          intent(in)    :: name   ! File name
  integer(kind=4),           intent(out)   :: form   ! Data type
  integer(kind=size_length), intent(out)   :: size   ! Data size
  logical,                   intent(inout) :: error  ! Error flag
  !
  call gio_rewris(.true.,is,gtype,name,form,size,error)
end subroutine gio_reis
!
subroutine gio_wris (is,gtype,name,form,size,error)
  use gildas_def
  use gio_interfaces, only : gio_rewris
  !----------------------------------------------------------------------
  ! @ public
  ! GDF   WRite Image Slot
  !   Only used by SIC
  !----------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: is     ! Image SLot
  character(len=*),          intent(out)   :: gtype  ! Image type
  character(len=*),          intent(in)    :: name   ! File name
  integer(kind=4),           intent(out)   :: form   ! Data type
  integer(kind=size_length), intent(out)   :: size   ! Data size
  logical,                   intent(inout) :: error  ! Error flag
  !
  call gio_rewris(.false.,is,gtype,name,form,size,error)
end subroutine gio_wris
!
subroutine gio_rewris(rdonly,is,gtype,name,form,size,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_rewris
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF   REad or WRite Image Slot. Common part for gio_reis and
  !       gio_wris, do not use directly.
  !---------------------------------------------------------------------
  logical,                   intent(in)  :: rdonly  ! Read or Write mode?
  integer(kind=4),           intent(in)  :: is      ! Image Slot
  character(len=*),          intent(out) :: gtype   ! Image type
  character(len=*),          intent(in)  :: name    ! File name
  integer(kind=4),           intent(out) :: form    ! Data type
  integer(kind=size_length), intent(out) :: size    ! Data size
  logical,                   intent(out) :: error   ! Error flag
  ! Local
  integer(kind=size_length) :: jsize
  integer(kind=record_length) :: leng
  integer :: ier
  character(len=3) :: rname
  character(len=30) :: cfits
  character(len=10) :: action
  character(len=filename_length) :: file,curdir
  integer :: curlen
  integer(4) :: fitbuf(8)
  equivalence (fitbuf,cfits)
  logical :: is_fits, probably_fits
  save curlen,curdir  ! Needed to delete temporary file in case of FITS file.
  !
  if (rdonly) then
    rname = 'RIS'
    action = 'READ'
  else
    rname = 'WIS'
    action = 'READWRITE'
  endif
  is_fits = .false.
  file = name
  !
10 continue
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    error = .true.
    return
  elseif (islot(is).ne.code_gio_full) then
    call gio_message(seve%e,rname,'Image slot is already mapped')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Check header
  ier = sic_getlun(iunit(is))
  if (ier.ne.1) then
    error = .true.
    return
  endif
  open(unit=iunit(is),file=file,status='OLD',form='UNFORMATTED',  &
       access='DIRECT',action=action,recl=lenbuf*facunf,iostat=ier)
  if (ier.ne.0) then
    call putios(seve%e,rname//'(Open)',ier)
    call gio_message(seve%e,rname,'Error opening '//file)
    goto 99
  endif
  read (unit=iunit(is),rec=1,iostat=ier) gdfbuf
  ichan(is) = iunit(is)
  if (ier.ne.0) then
    call putios(seve%e,rname//'(Read)',ier)
    call gio_message(seve%e,rname,'Error reading '//file)
    goto 99
  endif
  !
  ier = gio_rih (is,gtype,form,leng)
  !! print *,'After gdf_rih : DIMENSIONS ',gheads(is)%gil%dim ,' Header ', gheads(is)%header
  !
  if (ier.ne.1) then
    if (rdonly .and. .not.is_fits) then
      call bytoby (gdfbuf,fitbuf,30)
      if (cfits.eq.'SIMPLE  =                    T') then
        probably_fits = .true.
      elseif(cfits(1:10).eq.'SIMPLE  = ') then
        call gio_message(seve%e,rname,'Non standard FITS file found')
        call gio_message(seve%e,rname,'Will nonetheless try to proceed')
        probably_fits = .true.
      else
        probably_fits = .false.
      endif
      if (probably_fits) then
        ! where are we?
        curlen = 0
        call sic_setdir(curdir,curlen,error)
        ! Close file as it needs to be reopened for conversion inside fits2gdf.
        close(unit=iunit(is))
        call sic_frelun(iunit(is))
     		iunit(is) = 0
        ! Tries SIMPLE fits to gdf translation.
        call fits2gdf(file,error)
        if (.not.error) then
          is_fits = .true.
          goto 10
        endif
      endif
    endif
    call gio_message(seve%e,rname,'File '//trim(file)//' is neither a '//  &
    'GILDAS data frame nor a SIMPLE FITS file')
    goto 99
  endif
  call gio_idim (is,jsize)
  size = jsize ! Test maximum size here
  !
  if (rdonly) then
    islot(is) = code_gio_reado
  else
    islot(is) = code_gio_write
    ! Forbid using 'GILDAS_UVDAT' as output
    if (abs(ivers(is)).eq.code_gdf_uvold) then
      call gio_message(seve%e,'GDF_RWIS','UVDAT format obsolete for '//  &
      'output, use UVT_CONVERT first')
      close(unit=iunit(is))
      call gdf_deis(is,error)
      error = .true.
      return
    endif
  endif
  cname(is) = file             ! #1
  close (unit=iunit(is))       ! #1
  return
  !
99 call gdf_deis (is,error)
  error = .true.
  return
  !
end subroutine gio_rewris
!
subroutine gag_file_guess_fromname(caller,filename,filekind,error)
  use gbl_format
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gag_file_guess_fromname
  !---------------------------------------------------------------------
  ! @ public-generic gag_file_guess
  ! Guess if the input file is a GDF file (code 1), a FITS file (code
  ! 2), or something else (code 0)
  ! ---
  ! This version with the file name as argument, to be Fortran-opened-
  ! and-closed during the guess
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: filename
  integer(kind=4),  intent(out)   :: filekind
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: ier,lun,reclen
  !
  filekind = 0  ! Code 0 in case of early exit
  !
  ier = sic_getlun(lun)
  if (mod(ier,2).eq.0)  return  ! Do not to be cleverer!
  !
  reclen = 3  ! Use 3-words record length as this is only what we need
              ! in gag_file_guess_fromlun
  open(unit=lun,            &
       file=filename,       &
       access='DIRECT',     &
       form='UNFORMATTED',  &
       recl=facunf*reclen,  &
       status='OLD',        &
       action='READ',       &
       iostat=ier)
  !
  if (ier.eq.0) then
    call gag_file_guess_fromlun(caller,lun,filekind,error)
    if (error)  continue
    close(unit=lun)
  else
    call gio_message(seve%e,caller,'Error opening file '//filename)
    call putios('E-'//caller//',  ',ier)
    error = .true.
    continue
  endif
  !
  call sic_frelun(lun)
  !
end subroutine gag_file_guess_fromname
!
subroutine gag_file_guess_fromlun(caller,lun,filekind,error)
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gag_file_guess_fromlun
  !---------------------------------------------------------------------
  ! @ public-generic gag_file_guess
  ! Guess if the input file is a GDF file (code 1), a FITS file (code
  ! 2), or something else (code 0)
  ! ---
  ! This version with the file name already opened in input logical unit
  ! (must be opened as OLD, DIRECT, UNFORMATTED).
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  integer(kind=4),  intent(in)    :: lun
  integer(kind=4),  intent(out)   :: filekind
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: ier,buf(3)  ! 3 words are enough for 10 characters
  character(len=10) :: start
  character(len=filename_length) :: filename
  !
  filekind = 0
  !
  read(lun,rec=1,iostat=ier) buf
  if (ier.ne.0) then
    inquire(unit=lun,name=filename)
    call gio_message(seve%e,caller,'Error reading file '//filename)
    call putios('E-'//caller//',  ',ier)
    error = .true.
    return
  endif
  !
  call bytoch(buf,start,10)
  if (start(1:6).eq.'GILDAS') then  ! GDF
    filekind = 1
    return
  elseif (start(1:10).eq.'SIMPLE  = ') then  ! FITS
    filekind = 2
    return
  endif
  !
  ! There is no point checking more: the corresponding reader will (or
  ! should) perform all the necessary tests to check the file format
  ! consistency.
  !
end subroutine gag_file_guess_fromlun

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_memory
  use cubetools_parameters
  use cubetools_structure
  use cubedag_messaging
  use cubedag_dag_buffer
  !
  public :: memory
  private
  !
  type :: memory_comm_t
    type(option_t), pointer :: comm
  contains
    procedure, public  :: register => cubedag_memory_register
    procedure, private :: parse    => cubedag_memory_parse
    procedure, private :: main     => cubedag_memory_main
  end type memory_comm_t
  type(memory_comm_t) :: memory
  !
  type memory_user_t
  contains
    procedure, private :: toprog => cubedag_memory_user_toprog
  end type memory_user_t
  !
  type memory_prog_t
  contains
    procedure, public :: act => cubedag_memory_act
  end type memory_prog_t
  !
contains
  !
  subroutine cubedag_memory_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command MEMORY
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(memory_user_t) :: user
    character(len=*), parameter :: rname='MEMORY>COMMAND'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call memory%parse(line,user,error)
    if (error) return
    call memory%main(user,error)
    if (error) return
  end subroutine cubedag_memory_command
  !
  subroutine cubedag_memory_register(memory,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(memory_comm_t), intent(inout) :: memory
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEMORY>REGISTER'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'MEMORY','',&
         'Display the current memory and disk footprint',&
         strg_emp,&
         cubedag_memory_command,&
         memory%comm,error)
    if (error) return
  end subroutine cubedag_memory_register
  !
  subroutine cubedag_memory_parse(memory,line,user,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    ! Parsing facility for command MEMORY
    !-------------------------------------------------------------------
    class(memory_comm_t), intent(inout) :: memory
    character(len=*),     intent(in)    :: line
    type(memory_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEMORY>PARSE'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
  end subroutine cubedag_memory_parse
  !
  subroutine cubedag_memory_main(memory,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(memory_comm_t), intent(in)    :: memory
    type(memory_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(memory_prog_t) :: prog
    character(len=*), parameter :: rname='MEMORY>MAIN'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubedag_memory_main
  !
  subroutine cubedag_memory_user_toprog(user,prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(memory_user_t), intent(in)    :: user
    type(memory_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEMORY>USER2PROG'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
  end subroutine cubedag_memory_user_toprog
  !
  subroutine cubedag_memory_act(prog,error)
    use cubetools_format
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(memory_prog_t), intent(in)    :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEMORY>COMMAND'
    !
    call cubedag_message(seve%r,rname,  &
      'DAG size in memory is '//cubetools_format_memsize(cubedag_dag_memsize()))
    call cubedag_message(seve%r,rname,  &
      'DAG size on disk   is '//cubetools_format_memsize(cubedag_dag_disksize()))
  end subroutine cubedag_memory_act
end module cubedag_memory
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehistogram_histo3d
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_switch_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubehistogram_messaging
  use cubehistogram_histoaxis_types
  !
  public :: histo3d
  private
  !
  type histo3d_t
     type(cube_t), pointer :: cube
     type(histoaxis_prog_t) :: x
     type(histoaxis_prog_t) :: y
     type(histoaxis_prog_t) :: z
     type(switch_prog_t) :: blank     ! Blank empty bins?
     type(switch_prog_t) :: normalize ! Normalize histogram?
     integer(kind=data_k):: nin = 0   ! Number of voxels inside the histogram
  end type histo3d_t
  !
  type :: histo3d_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: xcube
     type(cubeid_arg_t), pointer :: ycube
     type(cubeid_arg_t), pointer :: zcube
     type(histoaxis_opt_t)       :: x
     type(histoaxis_opt_t)       :: y
     type(histoaxis_opt_t)       :: z
     type(switch_comm_t)         :: blank
     type(switch_comm_t)         :: normalize
     type(cube_prod_t),  pointer :: oucube
     type(cube_prod_t),  pointer :: pointer
   contains
     procedure, public  :: register => cubehistogram_histo3d_register
     procedure, private :: parse    => cubehistogram_histo3d_parse
     procedure, private :: main     => cubehistogram_histo3d_main
  end type histo3d_comm_t
  type(histo3d_comm_t) :: histo3d
  !
  type histo3d_user_t
     type(cubeid_user_t) :: cubeids
     type(histoaxis_user_t) :: x
     type(histoaxis_user_t) :: y
     type(histoaxis_user_t) :: z
     type(switch_user_t) :: blank
     type(switch_user_t) :: normalize
   contains
     procedure, private :: toprog => cubehistogram_histo3d_user_toprog
  end type histo3d_user_t
  !
  type histo3d_prog_t
     type(cube_t), pointer :: xcube   ! Input  cube used as histo3d x-axis
     type(cube_t), pointer :: ycube   ! Input  cube used as histo3d y-axis
     type(cube_t), pointer :: zcube   ! Input  cube used as histo3d y-axis
     type(cube_t), pointer :: pointer ! Output cube storing the position of the pixel in the 3D histogram
     type(histo3d_t) :: histo3d       ! Output 3D histogram
   contains
     procedure, private :: header   => cubehistogram_histo3d_prog_header
     procedure, private :: data     => cubehistogram_histo3d_prog_data
     procedure, private :: loop     => cubehistogram_histo3d_prog_loop
     procedure, private :: act      => cubehistogram_histo3d_prog_act
     procedure, private :: postloop => cubehistogram_histo3d_prog_postloop
  end type histo3d_prog_t
  !
contains
  !
  subroutine cubehistogram_histo3d_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(histo3d_user_t) :: user
    character(len=*), parameter :: rname='HISTO3D>COMMAND'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call histo3d%parse(line,user,error)
    if (error) return
    call histo3d%main(user,error)
    if (error) return
  end subroutine cubehistogram_histo3d_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_histo3d_register(histo3d,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_comm_t), intent(inout) :: histo3d
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='HISTO3D>REGISTER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'HISTO3D','xcube ycube zcube',&
         'Build a 3D histogram cube from three cubes',&
         'Build a histogram cube from three aligned input cubes. Each&
         & (X,Y) histogram bin stores the distribution of Z values&
         & that fall into that bin, so follow-up commands such as&
         & HISTOGRAM\MEAN can derive summary images from the&
         & histogram cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         'Use XCUBE, YCUBE, and ZCUBE as the X, Y, and Z value axes of&
         & the output histogram cube. The three input cubes must have&
         & the same shape. /XAXIS, /YAXIS, and /ZAXIS define the&
         & binning on each axis through the shared axis helper.'//strg_cr//&
         'The command currently requires three single-channel cubes.&
         & Multi-channel inputs are rejected before runtime.'//strg_cr//&
         'The HISTO3D product stores counts in each histogram cell.&
         & Use /BLANK and /NORMALIZE to control empty-cell handling&
         & and output scaling.'//strg_bl//&
         'Notes:'//strg_cr//&
         'The Pointer product records the histogram location of each&
         & in-range input pixel.'//strg_cr//&
         'That pointer payload is internal command state; current&
         & remap commands do not expose a public 3D pointer&
         & workflow.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'Build the 3D histogram first, then summarize the Z&
         & distribution in each (X,Y) histogram bin.'//strg_cr//&
         'CUBE> HISTOGRAM\HISTO3D xcube ycube zcube'//strg_cr//&
         'CUBE> HISTOGRAM\MEAN histo3d.',&
         cubehistogram_histo3d_command,&
         histo3d%comm,&
         error)
    if (error) return
    call cubearg%register(&
         'XCUBEID',&
         'Identifier for input cube #1 used as X axis',&
         strg_emp,&
         code_arg_mandatory,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         histo3d%xcube,&
         error)
    if (error) return
    call cubearg%register(&
         'YCUBEID',&
         'Identifier for input cube #2 used as Y axis',&
         strg_emp,&
         code_arg_mandatory,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         histo3d%ycube,&
         error)
    if (error) return
    call cubearg%register(&
         'ZCUBEID',&
         'Identifier for input cube #3 used as Z axis',&
         strg_emp,&
         code_arg_mandatory,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         histo3d%zcube,&
         error)
    if (error) return
    !
    call histo3d%x%register('X',error)
    if (error) return
    call histo3d%y%register('Y',error)
    if (error) return
    call histo3d%z%register('Z',error)
    if (error) return
    call histo3d%blank%register(&
         'BLANK',&
         'setting empty bins to NaN',&
         'ON',&
         'When ON, histogram cells with zero counts are written as&
         & NaN instead of 0 after the full histogram is built.',&
         error)
    if (error) return
    call histo3d%normalize%register(&
         'NORMALIZE',&
         'histogram normalization from counts to %',&
         'OFF',&
         'When ON, the final 3D histogram cube is scaled so the&
         & included counts sum to 100%.',&
         error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'HISTO3D',&
         'Joint histogram',&
         strg_emp,&
         [flag_histo3d],&
         histo3d%oucube,&
         error,&
         access=code_access_fullset)
    if (error) return
    call oucube%register(&
         'Pointer',&
         'Positions back pointer',&
         strg_emp,&
         [flag_histo3d,flag_pointer],&
         histo3d%pointer,&
         error)
    if (error) return
  end subroutine cubehistogram_histo3d_register
  !
  subroutine cubehistogram_histo3d_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_comm_t), intent(inout) :: comm
    character(len=*),      intent(in)    :: line
    type(histo3d_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='HISTO3D>PARSE'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%x%parse(line,user%x,error)
    if (error) return
    call comm%y%parse(line,user%y,error)
    if (error) return
    call comm%z%parse(line,user%z,error)
    if (error) return
    call comm%blank%parse(line,user%blank,error)
    if (error) return
    call comm%normalize%parse(line,user%normalize,error)
    if (error) return
  end subroutine cubehistogram_histo3d_parse
  !
  subroutine cubehistogram_histo3d_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_comm_t), intent(in)    :: comm
    type(histo3d_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(histo3d_prog_t) :: prog
    character(len=*), parameter :: rname='HISTO3D>MAIN'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubehistogram_histo3d_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_histo3d_user_toprog(user,comm,prog,error)
    use cubetools_consistency_methods
    use cubetools_header_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_user_t), intent(in)    :: user
    type(histo3d_comm_t),  intent(in)    :: comm
    type(histo3d_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    logical :: prob
    integer(kind=chan_k) :: nchan
    character(len=*), parameter :: rname='HISTO3D>USER2PROG'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(histo3d%xcube,user%cubeids,prog%xcube,error)
    if (error) return
    call cubeadm_get_header(histo3d%ycube,user%cubeids,prog%ycube,error)
    if (error) return
    call cubeadm_get_header(histo3d%zcube,user%cubeids,prog%zcube,error)
    if (error) return
    !
    prob = .false.
    call cubetools_consistency_shape(&
         'Input cube #1',prog%xcube%head,&
         'Input cube #2',prog%ycube%head,prob,error)
    if (error) return
    if (cubetools_consistency_failed(rname,prob,error)) return
    call cubetools_consistency_shape(&
         'Input cube #1',prog%xcube%head,&
         'Input cube #3',prog%zcube%head,prob,error)
    if (error) return
    if (cubetools_consistency_failed(rname,prob,error)) return
    call cubetools_header_get_nchan(prog%xcube%head,nchan,error)
    if (error) return
    if (nchan.gt.1) then
       call cubehistogram_message(&
            seve%e,rname,&
            'HISTO3D currently requires single-channel input cubes; '&
            //'multi-channel inputs are not supported')
       error = .true.
       return
    endif
    !
    call user%x%toprog(comm%x,prog%xcube,prog%histo3d%x,error)
    if (error) return
    call user%y%toprog(comm%y,prog%ycube,prog%histo3d%y,error)
    if (error) return
    call user%z%toprog(comm%z,prog%zcube,prog%histo3d%z,error)
    if (error) return
    call prog%histo3d%x%list(error)
    if (error) return
    call prog%histo3d%y%list(error)
    if (error) return
    call prog%histo3d%z%list(error)
    if (error) return
    !
    call prog%histo3d%normalize%init(comm%normalize,error)
    if (error) return
    call user%normalize%toprog(comm%normalize,prog%histo3d%normalize,error)
    if (error) return
    call prog%histo3d%blank%init(comm%blank,error)
    if (error) return
    call user%blank%toprog(comm%blank,prog%histo3d%blank,error)
    if (error) return
  end subroutine cubehistogram_histo3d_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_histo3d_prog_header(prog,comm,error)
    use cubetools_unit
    use cubetools_axis_types
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_prog_t), intent(inout) :: prog
    type(histo3d_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=unit_l) :: unit
    character(len=*), parameter :: rname='HISTO3D>PROG>HEADER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%pointer,prog%xcube,prog%pointer,error)
    if (error) return
    call cubeadm_clone_header(comm%oucube,prog%xcube,prog%histo3d%cube,error)
    if (error) return
    ! Unit
    if (prog%histo3d%normalize%enabled) then
       call cubetools_header_put_array_unit('%',prog%histo3d%cube%head,error)
       if (error) return
    else
       call cubetools_header_put_array_unit('Counts',prog%histo3d%cube%head,error)
       if (error) return
    endif
    ! X axis
    call cubetools_header_get_array_unit(prog%xcube%head,unit,error)
    if (error) return
    call cubetools_header_get_axis_head_l(prog%xcube%head,axis,error)
    if (error) return
    axis%name = 'X'
    if (prog%histo3d%x%dolog) then
       ! *** JP huge risk of overflow here...
       ! Try to decrease potential overflow by only adding 'log ' at start.
       axis%unit = 'log '//trim(unit)
    else
       axis%unit = unit
    endif
    axis%kind = code_unit_unk
    axis%genuine = .true.
    axis%regular = .true.
    axis%n   = prog%histo3d%x%n
    axis%ref = 1.0
    axis%val = prog%histo3d%x%min
    axis%inc = prog%histo3d%x%inc
    call cubetools_header_update_axset_l(axis,prog%histo3d%cube%head,error)
    if (error) return
    ! Y axis
    call cubetools_header_get_array_unit(prog%ycube%head,unit,error)
    if (error) return
    call cubetools_header_get_axis_head_m(prog%ycube%head,axis,error)
    if (error) return
    axis%name = 'Y'
    if (prog%histo3d%y%dolog) then
       ! *** JP huge risk of overflow here...
       ! Try to decrease potential overflow by only adding 'log ' at start.
       axis%unit = 'log '//trim(unit)
    else
       axis%unit = unit
    endif
    axis%kind = code_unit_unk
    axis%genuine = .true.
    axis%regular = .true.
    axis%n   = prog%histo3d%y%n
    axis%ref = 1.0
    axis%val = prog%histo3d%y%min
    axis%inc = prog%histo3d%y%inc
    call cubetools_header_update_axset_m(axis,prog%histo3d%cube%head,error)
    if (error) return
    ! Z axis
    call cubetools_header_get_array_unit(prog%zcube%head,unit,error)
    if (error) return
    call cubetools_header_get_axis_head_c(prog%zcube%head,axis,error)
    if (error) return
    axis%name = 'Z'
    if (prog%histo3d%z%dolog) then
       ! *** JP huge risk of overflow here...
       ! Try to decrease potential overflow by only adding 'log ' at start.
       axis%unit = 'log '//trim(unit)
    else
       axis%unit = unit
    endif
    axis%kind = code_unit_unk
    axis%genuine = .true.
    axis%regular = .true.
    axis%n   = prog%histo3d%z%n
    axis%ref = 1.0
    axis%val = prog%histo3d%z%min
    axis%inc = prog%histo3d%z%inc
    call cubetools_header_update_axset_c(axis,prog%histo3d%cube%head,error)
    if (error) return
  end subroutine cubehistogram_histo3d_prog_header
  !
  subroutine cubehistogram_histo3d_prog_data(prog,error)
    use cubeadm_opened
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! Removed parallelization because the histo3d can not be written by
    ! several threads at the same time
    !----------------------------------------------------------------------
    class(histo3d_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(fullcube_t) :: histo3d
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='HISTO3D>PROG>DATA'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    call histo3d%allocate('histo3d',prog%histo3d%cube,error)
    if (error) return
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       if (.not.error) &
         call prog%loop(iter,histo3d,error)
    enddo ! iter
    !
    call prog%postloop(histo3d,error)
    if (error) return
  end subroutine cubehistogram_histo3d_prog_data
  !
  subroutine cubehistogram_histo3d_prog_loop(prog,iter,histo3d,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    type(fullcube_t),         intent(inout) :: histo3d
    logical,                  intent(inout) :: error
    !
    type(image_t) :: xima,yima,zima,pima
    character(len=*), parameter :: rname='HISTO3D>PROG>LOOP'
    !
    ! The allocation of xima, yima, and zima allows me to take the logarithm of the inputs
    call xima%allocate('xima',prog%xcube,iter,error)
    if (error) return
    call yima%allocate('yima',prog%ycube,iter,error)
    if (error) return
    ! *** JP => segfault when zima%allocate is replaced by yima%allocate
    call zima%allocate('zima',prog%zcube,iter,error)
    if (error) return
    call pima%allocate('pointer image',prog%pointer,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,xima,yima,zima,pima,histo3d,error)
      if (error) return
    enddo ! ie
  end subroutine cubehistogram_histo3d_prog_loop
  !
  subroutine cubehistogram_histo3d_prog_act(prog,ie,xima,yima,zima,pima,histo3d,error)
    use cubetools_nan
    use cubeadm_image_types
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_prog_t), intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t), target, intent(inout) :: xima
    type(image_t), target, intent(inout) :: yima
    type(image_t), target, intent(inout) :: zima
    type(image_t),         intent(inout) :: pima
    type(fullcube_t),      intent(inout) :: histo3d
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    integer(kind=pixe_k) :: jx,jy,jz
    integer(kind=data_k) :: nou,nblank
    real(kind=sign_k), pointer :: xval,yval,zval
    character(len=*), parameter :: rname='HISTO3D>ACT'
    !
    ! Get data
    call xima%get(ie,error)
    if (error) return
    call yima%get(ie,error)
    if (error) return
    call zima%get(ie,error)
    if (error) return
    ! Transform it
    if (prog%histo3d%x%dolog) then
       do iy=1,xima%ny
          do ix=1,xima%nx
             xval => xima%val(ix,iy)
             xval = log10(xval)
          enddo ! iy
       enddo ! ix
    endif
    if (prog%histo3d%y%dolog) then
       do iy=1,xima%ny
          do ix=1,xima%nx
             yval => yima%val(ix,iy)
             yval = log10(yval)
          enddo ! iy
       enddo ! ix
    endif
    if (prog%histo3d%z%dolog) then
       do iy=1,xima%ny
          do ix=1,xima%nx
             zval => zima%val(ix,iy)
             zval = log10(zval)
          enddo ! iy
       enddo ! ix
    endif
    ! Compute histogram
    nou = 0
    nblank = 0
    prog%histo3d%nin = 0
    histo3d%val = 0.0
    pima%val = 0
    do iy=1,xima%ny
       do ix=1,xima%nx
          xval => xima%val(ix,iy)
          yval => yima%val(ix,iy)
          zval => zima%val(ix,iy)
          if ((ieee_is_finite(xval)).and.(ieee_is_finite(yval)).and.(ieee_is_finite(zval))) then
             jx = nint((xval-prog%histo3d%x%min)/prog%histo3d%x%inc)
             jy = nint((yval-prog%histo3d%y%min)/prog%histo3d%y%inc)
             jz = nint((zval-prog%histo3d%z%min)/prog%histo3d%z%inc)
             if ((1.le.jx).and.(jx.le.prog%histo3d%x%n).and.&
                  (1.le.jy).and.(jy.le.prog%histo3d%y%n).and.&
                  (1.le.jz).and.(jz.le.prog%histo3d%z%n)) then
                ! *** JP problem when many points?
                pima%val(ix,iy) = jx+(jy-1)*pima%nx+(jz-1)*pima%nx*pima%ny
                histo3d%val(jx,jy,jz) = histo3d%val(jx,jy,jz)+1.0
                prog%histo3d%nin = prog%histo3d%nin+1
             else
                nou = nou+1
             endif
          else
             nblank = nblank+1
          endif
       enddo ! iy
    enddo ! ix
    ! Put result
    call pima%put(ie,error)
    if (error) return
  end subroutine cubehistogram_histo3d_prog_act
  !
  subroutine cubehistogram_histo3d_prog_postloop(prog,histo3d,error)
    use cubetools_nan
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(histo3d_prog_t), intent(inout) :: prog
    type(fullcube_t),      intent(inout) :: histo3d
    logical,               intent(inout) :: error
    !
    integer(kind=data_k) :: ix,iy,iz
    character(len=*), parameter :: rname='HISTO3D>PROG>POSTLOOP'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    ! Blank empty bins when asked
    if (prog%histo3d%blank%enabled) then
       do iz=1,prog%histo3d%z%n
          do iy=1,prog%histo3d%y%n
             do ix=1,prog%histo3d%x%n
                if (histo3d%val(ix,iy,iz).le.0.0) then
                   histo3d%val(ix,iy,iz) = gr4nan
                endif
             enddo ! ix
          enddo ! iy
       enddo ! iz
    endif
    ! Normalize when asked
    if ((prog%histo3d%normalize%enabled).and.(prog%histo3d%nin.gt.0)) then
       do iz=1,prog%histo3d%z%n
          do iy=1,prog%histo3d%y%n
             do ix=1,prog%histo3d%x%n
                histo3d%val(ix,iy,iz) = 100d0*histo3d%val(ix,iy,iz)/real(prog%histo3d%nin,kind=coor_k)
             enddo ! ix
          enddo ! iy
       enddo ! iz
    endif
    ! Put result
    call histo3d%put(error)
    if (error) return
  end subroutine cubehistogram_histo3d_prog_postloop
end module cubehistogram_histo3d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
!  Support file for reading the content of a Sic variable into a target
! Fortran variable, with automatic type casting.
!  (For the reverse operation, i.e. writing a Fortran variable into a
! Sic variable, see file fill.f90)
!-----------------------------------------------------------------------
!
! === SCALARS ==========================================================
!
subroutine sic_get_real (var,rel,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>sic_get_real
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! Retrieve a global variable value
  !---------------------------------------------------------------------
  character(len=*) :: var           !
  real*4 :: rel                     !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: found
  integer :: type
  type(sic_descriptor_t) :: descr
  integer(kind=address_length) :: ipnt
  !
  error = .true.
  found = .true.
  call sic_descriptor (var,descr,found)    ! Checked, must be scalar
  if (.not.found) return
  type = descr%type
  ipnt = bytpnt(descr%addr,membyt)
  if (type.ge.0) then          ! Character variable (>0) or header str
    error = .true.
  elseif (descr%ndim.ne.0) then  ! Not a scalar variable
    error = .true.
  elseif (type.eq.fmt_r4) then
    call r4tor4(membyt(ipnt),rel,1)
    error = .false.
  elseif (type.eq.fmt_r8) then
    call r8tor4(membyt(ipnt),rel,1)
    error = .false.
  elseif (type.eq.fmt_i4) then
    call i4tor4(membyt(ipnt),rel,1)
    error = .false.
  elseif (type.eq.fmt_i8) then
    call i8tor4(membyt(ipnt),rel,1)
    error = .false.
  else
    error =.true.
  endif
end subroutine sic_get_real
!
subroutine sic_get_dble (var,doble,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>sic_get_dble
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! Retrieve a global variable value
  !---------------------------------------------------------------------
  character(len=*) :: var           !
  real*8 :: doble                   !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: found
  integer :: type
  type(sic_descriptor_t) :: descr
  integer(kind=address_length) :: ipnt
  !
  error = .true.
  found = .true.
  call sic_descriptor (var,descr,found)    ! Checked, must be scalar
  if (.not.found) return
  type = descr%type
  ipnt = bytpnt(descr%addr,membyt)
  if (type.ge.0) then
    error = .true.
  elseif (descr%ndim.ne.0) then
    error = .true.
  elseif (type.eq.fmt_r4) then
    call r4tor8(membyt(ipnt),doble,1)
    error = .false.
  elseif (type.eq.fmt_r8) then
    call r8tor8(membyt(ipnt),doble,1)
    error = .false.
  elseif (type.eq.fmt_i4) then
    call i4tor8(membyt(ipnt),doble,1)
    error = .false.
  elseif (type.eq.fmt_i8) then
    call i8tor8(membyt(ipnt),doble,1)
    error = .false.
  else
    error = .true.
  endif
end subroutine sic_get_dble
!
! Integers
subroutine sic_get_inte (var,inte,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>sic_get_inte
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Retrieve a global variable value
  !---------------------------------------------------------------------
  character(len=*) :: var           !
  integer*4 :: inte                 !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: found
  integer :: type
  type(sic_descriptor_t) :: descr
  integer(kind=address_length) :: ipnt
  !
  error = .true.
  found = .true.
  call sic_descriptor (var,descr,found)    ! Checked, must be scalar
  if (.not.found) return
  type = descr%type
  ipnt = bytpnt(descr%addr,membyt)
  if (type.ge.0) then
    error = .true.
  elseif (descr%ndim.ne.0) then
    error = .true.
  elseif (type.eq.fmt_r4) then
    error = .false.
    call r4toi4_fini(membyt(ipnt),inte,1,error)
  elseif (type.eq.fmt_r8) then
    error = .false.
    call r8toi4_fini(membyt(ipnt),inte,1,error)
  elseif (type.eq.fmt_i4) then
    error = .false.
    call i4toi4(membyt(ipnt),inte,1)
  elseif (type.eq.fmt_i8) then
    error = .false.
    call i8toi4_fini(membyt(ipnt),inte,1,error)
  else
    error = .true.
  endif
end subroutine sic_get_inte
!
subroutine sic_get_long (var,long,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>sic_get_long
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! Retrieve a global variable value
  !---------------------------------------------------------------------
  character(len=*) :: var           !
  integer*8 :: long                 !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: found
  integer :: type
  type(sic_descriptor_t) :: descr
  integer(kind=address_length) :: ipnt
  !
  error = .true.
  found = .true.
  call sic_descriptor (var,descr,found)    ! Checked, must be scalar
  if (.not.found) return
  type = descr%type
  ipnt = bytpnt(descr%addr,membyt)
  if (type.ge.0) then
    error = .true.
  elseif (descr%ndim.ne.0) then
    error = .true.
  elseif (type.eq.fmt_r4) then
    error = .false.
    call r4toi8_fini(membyt(ipnt),long,1,error)
  elseif (type.eq.fmt_r8) then
    error = .false.
    call r8toi8_fini(membyt(ipnt),long,1,error)
  elseif (type.eq.fmt_i4) then
    error = .false.
    call i4toi8(membyt(ipnt),long,1)
  elseif (type.eq.fmt_i8) then
    error = .false.
    call i8toi8(membyt(ipnt),long,1)
  else
    error = .true.
  endif
end subroutine sic_get_long
!
! Logicals
subroutine sic_get_logi (var,logi,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>sic_get_logi
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! Retrieve a global variable value
  !---------------------------------------------------------------------
  character(len=*) :: var           !
  logical :: logi                   !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: found
  type(sic_descriptor_t) :: descr
  integer(kind=address_length) :: ipnt
  !
  error = .true.
  found = .true.
  call sic_descriptor (var,descr,found)    ! Checked, must be scalar
  if (.not.found) return
  if (descr%ndim.ne.0) then
    error = .true.
  elseif (descr%type.eq.fmt_i4 .or. descr%type.eq.fmt_l) then
    ipnt = bytpnt(descr%addr,membyt)
    call l4tol4(membyt(ipnt),logi,1)
    error = .false.
  else
    error = .true.
  endif
end subroutine sic_get_logi
!
! Characters
subroutine sic_get_char (var,chain,lc,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>sic_get_char
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Retrieve a global variable value
  !---------------------------------------------------------------------
  character(len=*) :: var           !
  character(len=*) :: chain         !
  integer :: lc                     !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: found
  type(sic_descriptor_t) :: descr
  !
  error = .true.
  found = .true.
  call sic_descriptor (var,descr,found)    ! Checked, must be scalar
  if (.not.found) return
  !
  if (desc_nelem(descr).ne.1) then
    error = .true.
  elseif (descr%type.gt.0) then
    call destoc(descr%type,descr%addr,chain)
    lc = len_trim(chain)           ! not MIN(TYPE,LEN(CHAIN))
    error = .false.
  else
    error = .true.
  endif
end subroutine sic_get_char
!
subroutine sic_get_auto (var,value,type,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch - on purpose -)
  !  Returns the SIC variable value in the 8-bit untyped variable, plus
  ! its type in another variable. Variables are automatically converted
  ! to types: REAL*8, INTEGER*8 or LOGICAL.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: var       !
  integer(kind=1),  intent(out)   :: value(8)  !
  integer(kind=4),  intent(out)   :: type      !
  logical,          intent(inout) :: error     !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: found
  type(sic_descriptor_t) :: descr
  integer(kind=address_length) :: ipnt
  !
  found = .false.
  call sic_descriptor (var,descr,found)
  if (.not.found) then
    error = .true.
    return
  endif
  !
  ipnt = bytpnt(descr%addr,membyt)
  if (descr%ndim.ne.0) then
    error = .true.
    !
  elseif (descr%type.eq.fmt_r4) then
    type = fmt_r4
    call r4tor4(membyt(ipnt),value,1)
  elseif (descr%type.eq.fmt_r8) then
    type = fmt_r8
    call r8tor8(membyt(ipnt),value,1)
    !
  elseif (descr%type.eq.fmt_i4) then
    type = fmt_i8
    call i4toi8(membyt(ipnt),value,1)
  elseif (descr%type.eq.fmt_i8) then
    type = fmt_i8
    call i8toi8(membyt(ipnt),value,1)
    !
  elseif (descr%type.eq.fmt_l) then
    type = fmt_l
    call l4tol4(membyt(ipnt),value,1)
    !
  else
    error = .true.
  endif
end subroutine sic_get_auto
!
! === ARRAYS ===========================================================
!
subroutine sic_variable_getr4_0d(caller,varname,r4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_getr4_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_get
  !  Get a SIC variable into the r4 value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  real(kind=4),     intent(out)   :: r4       ! Scalar value to be filled
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  real(kind=4) :: val(1)
  integer(kind=size_length), parameter :: one=1
  !
  call sic_variable_getr4_1d(caller,varname,val,one,error)
  if (error)  return
  r4 = val(1)
  !
end subroutine sic_variable_getr4_0d
!
subroutine sic_variable_getr4_1d(caller,varname,r4,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_getr4_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_get
  !  Get a SIC variable into the r4 value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  real(kind=4),              intent(out)   :: r4(*)    ! Flat array of values to be filled
  integer(kind=size_length), intent(in)    :: nelem    ! Number of r4 values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.false.,desc,error)
  if (error)  return
  !
  call sic_descriptor_getr4(desc,r4,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_getr4_1d
!
subroutine sic_variable_getr8_0d(caller,varname,r8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_getr8_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_get
  !  Get a SIC variable into the r8 value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  real(kind=8),     intent(out)   :: r8       ! Scalar value to be filled
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  real(kind=8) :: val(1)
  integer(kind=size_length), parameter :: one=1
  !
  call sic_variable_getr8_1d(caller,varname,val,one,error)
  if (error)  return
  r8 = val(1)
  !
end subroutine sic_variable_getr8_0d
!
subroutine sic_variable_getr8_1d(caller,varname,r8,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_getr8_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_get
  !  Get a SIC variable into the r8 value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  real(kind=8),              intent(out)   :: r8(*)    ! Flat array of values to be filled
  integer(kind=size_length), intent(in)    :: nelem    ! Number of r8 values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.false.,desc,error)
  if (error)  return
  !
  call sic_descriptor_getr8(desc,r8,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_getr8_1d
!
!-----------------------------------------------------------------------
!
subroutine sic_descriptor_get_getnelem(desc,neleml,nelem0,ipnt0,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_get_getnelem
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute and return the number of elements and the 'ipnt' of the Sic
  ! variable described by its descriptor, and check if it is consistent
  ! with 'neleml'.
  !  Technical subroutine mostly to be used by the sic_descriptor_get*
  ! subroutines below.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),       intent(in)    :: desc    !
  integer(kind=size_length),    intent(in)    :: neleml  !
  integer(kind=size_length),    intent(out)   :: nelem0  !
  integer(kind=address_length), intent(out)   :: ipnt0   !
  logical,                      intent(inout) :: error   !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  character(len=message_length) :: mess
  !
  ! Convert Nwords to Nelem
  select case (desc%type)
  case (fmt_r8,fmt_i8,fmt_c4)
    nelem0 = desc%size/2
  case (fmt_r4,fmt_i4,fmt_l)
    nelem0 = desc%size
  case (fmt_un)
    call sic_message(seve%e,rname,'Data type is unknown (fmt_un)')
    error = .true.
    return
  case default
    call sic_message(seve%e,rname,'Data type not supported (4)')
    error = .true.
    return
  end select
  !
  if (nelem0.ne.neleml .and. nelem0.ne.1) then
    write(mess,'(A,I0,1X,I0)')  &
      'Mathematics on arrays of inconsistent dimensions ',nelem0,neleml
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ipnt0 = gag_pointer(desc%addr,memory)
  !
end subroutine sic_descriptor_get_getnelem
!
subroutine sic_descriptor_getr4(desc,r4,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getr4
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the r4(*) variable with the descriptor target values. A
  ! consistency check of the number of values is performed, and value is
  ! casted if needed to thee SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  real(kind=4),              intent(out)   :: r4(*)   ! Flat array to be filled
  integer(kind=size_length), intent(in)    :: neleml  ! Number of r4 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_get_getnelem(desc,neleml,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r4)
    if (neleml.eq.nelem0) then
      call w4tow4_sl (memory(ipnt0),r4,neleml)
    elseif (nelem0.eq.1) then
      call r4_fill(neleml,r4,memory(ipnt0))
    endif
    !
  case (fmt_r8)
    if (neleml.eq.nelem0) then
      call r8tor4_sl (memory(ipnt0),r4,neleml)
    elseif (nelem0.eq.1) then
      call r8tor4_sl (memory(ipnt0),r4,nelem0)
      call r4_fill(neleml,r4,r4(1))
    endif
    !
  case (fmt_i4)
    if (neleml.eq.nelem0) then
      call i4tor4_sl (memory(ipnt0),r4,neleml)
      if (error)  return
    elseif (nelem0.eq.1) then
      call i4tor4_sl (memory(ipnt0),r4,nelem0)
      if (error)  return
      call r4_fill (neleml,r4,r4(1))
    endif
    !
  case (fmt_i8)
    if (neleml.eq.nelem0) then
      call i8tor4_sl (memory(ipnt0),r4,neleml)
      if (error)  return
    elseif (nelem0.eq.1) then
      call i8tor4_sl (memory(ipnt0),r4,nelem0)
      if (error)  return
      call r4_fill (neleml,r4,r4(1))
    endif
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (3)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getr4
!
subroutine sic_descriptor_getr8(desc,r8,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getr8
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the r8(*) variable with the descriptor target values. A
  ! consistency check of the number of values is performed, and value is
  ! casted if needed to thee SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  real(kind=8),              intent(out)   :: r8(*)   ! Flat array to be filled
  integer(kind=size_length), intent(in)    :: neleml  ! Number of r4 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_get_getnelem(desc,neleml,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r4)
    if (neleml.eq.nelem0) then
      call r4tor8_sl (memory(ipnt0),r8,neleml)
    elseif (nelem0.eq.1) then
      call r4tor8_sl (memory(ipnt0),r8,nelem0)
      call r8_fill(neleml,r8,r8(1))
    endif
    !
  case (fmt_r8)
    if (neleml.eq.nelem0) then
      call w8tow8_sl (memory(ipnt0),r8,neleml)
    elseif (nelem0.eq.1) then
      call r8_fill(neleml,r8,memory(ipnt0))
    endif
    !
  case (fmt_i4)
    if (neleml.eq.nelem0) then
      call i4tor8_sl (memory(ipnt0),r8,neleml)
      if (error)  return
    elseif (nelem0.eq.1) then
      call i4tor8_sl (memory(ipnt0),r8,nelem0)
      if (error)  return
      call r8_fill (neleml,r8,r8(1))
    endif
    !
  case (fmt_i8)
    if (neleml.eq.nelem0) then
      call i8tor8_sl (memory(ipnt0),r8,neleml)
      if (error)  return
    elseif (nelem0.eq.1) then
      call i8tor8_sl (memory(ipnt0),r8,nelem0)
      if (error)  return
      call r8_fill (neleml,r8,r8(1))
    endif
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (4)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getr8

subroutine class_swap(line,error,user_function)
  use class_interfaces, except_this=>class_swap
  !----------------------------------------------------------------------
  ! @ private
  !  Exchange R and T memories
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  logical,          external      :: user_function
  !
  call swaprt('SWAP',error,user_function)
  !
end subroutine class_swap
!
subroutine swaprt(rname,error,user_function)
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces, except_this=>swaprt
  use class_rt
  use class_setup
  !----------------------------------------------------------------------
  ! @ private
  !  Exchange R and T memories
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  logical,          intent(inout) :: error
  logical,          external      :: user_function
  ! Local
  type(observation), pointer :: tmp
  logical :: ll,myerror
  !
  ! Use a local 'myerror' because the subroutine can be called in error
  ! recovery mode.
  !
  if (t%head%xnum.eq.0) then
    if (rname.eq.'SWAP') then
      call class_message(seve%e,rname,'No spectrum in T buffer')
      error = .true.
    endif
    return  ! Nothing to swap...
  endif
  !
  tmp => r
  r => t
  t => tmp
  r%is_R = .true.
  t%is_R = .false.
  !
  ll = user_function('SWAP')
  !
  ! Need a complete redefinition of all Sic variables pointing to R
  myerror = .false.
  call sic_delvariable ('R',.false.,myerror)
  myerror = .false.  ! No error if not found
  call las_variables_r(set,r,myerror)
  if (myerror) then
    error = .true.
    return
  endif
  call las_setvar_R_aliases(set,myerror)
  if (myerror) then
    error = .true.
    return  ! Also redefine SET VARIABLE aliases
  endif
  !
  call newdat(set,r,myerror)
  call newdat_assoc(set,r,myerror)
  call newdat_user(set,r,myerror)
  if (myerror)  error = .true.
  !
end subroutine swaprt

subroutine set_scaling (error)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Compute the scaling factors for a given scan.
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_number.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  ! Local
  complex :: zscale(mrlband,2,mnbat)  ! subband, U/L, base
  real :: ascale(mrlband,mnant)
  common /clicscale/ zscale, ascale
  save /clicscale/
  integer :: isb, iba, ic, ip, jp, is
  integer :: ia, ja, it, ib, i
  real :: af, phase, amp, faz
  integer :: flux_scan,flux_type,known_flux
  real*8 :: a_flux(2),le_flux,le_flux_zero,fnu,size(3), fbeam,lim_flux
  logical :: down_baseline
  !
  data flux_scan /0/
  !
  ! Fraction of zero flux down which source is considered "too" resolved
  data lim_flux /0.001/    
  save flux_scan,a_flux,size
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  ! for auto correlations, only  raw, kelvin, jansky
  do ia=1, r_nant
    do is=1, r_lband
      ic = r_bb(is)
      ip = r_lpolentry(ia,is)
      amp = 1.0
      !
      ! Take out atmospheric calibration
      if (do_raw) then
        af = dh_atfac(ic,1,ia)
        if (af.gt.0) amp = amp * af
      ! convert to Janskys
      elseif (do_flux) then
        amp = amp * r_jykel(ip,ia)
      endif
      ascale(is,ia) = 1/amp
    enddo
  enddo
  do iba = 1, r_nbas
    do isb = 1, 2
      do is=1, r_lband
        ia = r_iant(iba)
        ja = r_jant(iba)
        ip = r_lpolentry(ia,is)
        jp = r_lpolentry(ja,is)
        ic = r_bb(is)
        phase = 0
        amp = 1.0
        ! amplitude calibration
        if (do_amplitude) then
          if (do_amplitude_antenna) then
            amp =exp(r_aicamp(jp,isb,ja,0)   &
              +r_aicamp(ip,isb,ia,0))
          else
            if (r_lpolmode(is).eq.1) then
               amp = r_icamp(ip,isb,iba,0)
            else
               call message(6,3,'SET_SCALING','Cannot compute' &
     &            //'baseline scaling factor with mixed polarization')
            endif
            if (amp.lt.1e-20) then
              if (dh_infac(isb,iba).eq.0) then
                amp = 0
              else
                amp = 1./abs(dh_infac(isb,iba))
              endif
            endif
          endif
        endif
        !     phase calibration
        !     use phase slot 0
        if (do_phase .and. .not.do_phase_ext) then
          if (do_phase_antenna) then
            phase = phase+r_aicpha(jp,isb,ja,0)   &
              -r_aicpha(ip,isb,ia,0)
          else
            if (r_lpolmode(is).eq.1) then
              phase = phase+r_icpha(ip,isb,iba,0)
            else
               call message(6,3,'SET_SCALING','Cannot compute' &
     &            //'baseline scaling factor with mixed polarization')
            endif
            if (phase.eq.0) then
              phase = -faz(dh_infac(isb,iba))
            endif
          endif
        ! use slot 1 if external, optionally add slot 2 if relative.
        elseif (do_phase_ext) then
          if (do_phase_antenna) then
            phase = phase+r_aicpha(jp,isb,ja,1)   &
              -r_aicpha(ip,isb,ia,1)
          else
            phase = phase+r_icpha(ip,isb,iba,1)
          endif
          if (do_phase) then
            if (do_phase_antenna) then
              phase = phase+r_aicpha(jp,isb,ja,2)   &
                -r_aicpha(ip,isb,ia,2)
            else
              phase = phase+r_icpha(ip,isb,iba,2)
            endif
          endif
        endif
        !
        ! Take out atmospheric calibration
        if (do_raw) then
          af = sqrt(dh_atfac(ic,isb,ia)*   &
            dh_atfac(ic,isb,ja))
          if (af.gt.0) amp = amp * af
        endif
        ! convert to Kelvin
        if (do_amplitude .and. .not.do_flux) then
          amp = amp * sqrt(r_jykel(ip,ia)*r_jykel(jp,ja))
        endif
        ! convert to Janskys
        if (.not.do_amplitude .and. do_flux) then
          amp = amp / sqrt(r_jykel(ip,ia)*r_jykel(jp,ja))
        endif
        !
        ! Scale by calibrator flux  (Will crash here if r_flux is NaN)
        ! Or by calibrator size                           
        if (do_scale.or.do_size) then
          le_flux = max(min (r_flux, 1e12),-1e12)
          flux_type = known_flux(r_sourc,le_flux)
          if (flux_type.ne.0) then
            !
            ! Compute zero spacing flux if needed
            if (flux_scan.ne.r_scan) then
              call message(6,1,'SCALING',&
                r_sourc//' has known structure')
              if (flux_type.eq.-1) then
                fnu = (r_flo1 + r_fif1) * 1d-3
                call planet_flux (r_sourc,r_dobs,r_ut,   &
                  fnu,a_flux(1),fbeam,size,error)
                fnu = (r_flo1 - r_fif1) * 1d-3
                call planet_flux (r_sourc,r_dobs,r_ut,   &
                  fnu,a_flux(2),fbeam,size,error)
              else
                a_flux(1) = le_flux
                a_flux(2) = le_flux
                fnu = (r_flo1 + r_fif1) * 1d-3
                call get_flux (fnu,flux_type,a_flux(1),size)
                fnu = (r_flo1 - r_fif1) * 1d-3
                call get_flux (fnu,flux_type,a_flux(2),size)
              endif
              flux_scan = r_scan
            endif
            !
            ! Compute frequency from R_FLO1 and R_FIF1 and ISB
            ! (1=Upper, 2=Lower, 3=Average)
            if (isb.eq.1) then
              fnu = r_flo1 + r_fif1
              le_flux = a_flux(1)
            elseif (isb.eq.2) then
              fnu = r_flo1 - r_fif1
              le_flux = a_flux(2)
            endif
            fnu = fnu*1.0d-3 ! Use it in GHz for fluxes
            le_flux_zero = le_flux
            call apparent_flux (fnu,le_flux,size,flux_type,   &
              dh_uvm(1,iba))
            if (do_size) then
              if (le_flux_zero.eq.0) then
                call message(8,2,'SCALING', &
                 'Zero flux for source '//r_sourc)
                 error = .true.
                 return
              else
                le_flux = le_flux/le_flux_zero
              endif
              if (abs(le_flux).lt.lim_flux) then
                print *,"le_flux",le_flux,"lim_flux",lim_flux
                call message(8,2,'SCALING', &
                r_sourc//' is too resolved on baseline '//cbas(iba))
                error = .true.
                return
              endif
            endif     
            amp = amp *  abs(le_flux)
            ! Special case for Jupiter
            if (flux_type.eq.-3) then
              if (le_flux.lt.0) phase = phase + pi
            endif
          !     IF (FLUX_TYPE.EQ.-3) THEN
          !     Z = Z / LE_FLUX  ! Special case for Jupiter
          !     if (le_flux.lt.0) phase = phase + pi
          !     ELSE
          !     Z = Z / ABS(LE_FLUX)
          !     ENDIF
          elseif (le_flux.ne.0) then
            amp = amp * abs(le_flux)
          endif
        endif
        !
        if (amp.ne.0) then
          zscale(is,isb,iba) = cmplx(cos(phase),   &
            -sin(phase))   &
            / amp
        elseif (.not. down_baseline(iba)) then
          call message(8,2,'SCALING',   &
            'Zero amplitude calibration factor base. '   &
            //cbas(iba)//' '//cband(isb))
          error = .true.
          zscale(is,isb,iba) = cmplx(cos(phase),   &
            -sin(phase))
        endif
      enddo
    enddo
  enddo
  !
  ! Triangles needed (?)
  if (r_ntri.gt.0) then
    do isb = 1, 2
      do it = 1, r_ntri
        do is = 1, r_lband
          iba = mnbas+it
          zscale(is,isb,iba) = 1.0
          do i=1, 3
            ib = bastri(i,it)
            if (i.eq.2) then
              zscale(is,isb,iba) =   &
                zscale(is,isb,iba)   &
                *conjg(zscale(is,isb,ib))
            else
              zscale(is,isb,iba) =   &
                zscale(is,isb,iba)   &
                *zscale(is,isb,ib)
            endif
          enddo
        enddo
      enddo
    enddo
  endif
  return
end subroutine set_scaling
!
subroutine scaling (is,isb,iba,z,a,error)
  use classic_api  
  integer :: is                     ! subband
  integer :: isb                    ! side band
  integer :: iba                    ! baseline
  complex :: z                      ! complex amplitude
  real :: a                         ! amplitude factor
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_dheader.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  complex :: zscale(mrlband,2,mnbat)
  real :: ascale(mrlband,mnant)
  common /clicscale/ zscale, ascale
  save /clicscale/
  integer :: ia, ja, ic
  complex :: zs                ! complex amplitude
  real :: phase,phase_tmp
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  a = abs(z)
  if (a.eq.0) then
    a = 1
    return
  endif
  zs = zscale(is,isb,iba)
  !
  ! ATMOSPHERIC CORRECTION
  !   needed here, since it changes at every record
  !   do_phase_mon: use total power monitor correction
  !   do_phase_wvr: use wvr correction (note dpath is in micrometers)
  !
  ia = r_iant(iba)
  ja = r_jant(iba)
  !
  ! total power correction
  !      IF (DO_PHASE_ATM .AND.
  !     $((R_NREC_MON.GT.0).OR.DO_PHASE_NOFILE)) THEN
  if (do_phase_mon(ia) .and. do_phase_mon(ja)) then
    phase =   &
      - phase_corr(isb,ja)*(dh_test1(2,ja)-r_csky_mon(ja))   &
      + phase_corr(isb,ia)*(dh_test1(2,ia)-r_csky_mon(ia))
    zs = zs * cmplx(cos(phase),-sin(phase))
  endif
  !
  ! wvr correction
  if (do_phase_wvr(ia) .and. do_phase_wvr(ja) ) then
    phase_tmp = 0.0
    do ic=1,mwvrch
      phase_tmp = phase_tmp + (dh_wvr(ic,ja)-r_wvrref(ic,ja))   &
        *r_wvrtcal(ic,ja)*r_wvrdpath(ic,ja)/1000.
    enddo
    if (do_phase_wvr_e(ja)) then
      phase_tmp=phase_tmp*r_wvrfpath(1,ja)
    endif
    phase = - phase_corr(isb,ja)*phase_tmp
    phase_tmp = 0.0
    do ic=1,mwvrch
      phase_tmp = phase_tmp + (dh_wvr(ic,ia)-r_wvrref(ic,ia))   &
        *r_wvrtcal(ic,ia)*r_wvrdpath(ic,ia)/1000.
    enddo
    if (do_phase_wvr_e(ia)) then
      phase_tmp=phase_tmp*r_wvrfpath(1,ia)
    endif
    phase = phase + phase_corr(isb,ia)*phase_tmp
    zs = zs * cmplx(cos(phase),-sin(phase))
  endif
  !
  ! tot.power and wvr correction
  if (do_phase_mon(ia) .and. do_phase_wvr(ja)) then
    phase_tmp = 0.0
    do ic=1,mwvrch
      phase_tmp = phase_tmp + (dh_wvr(ic,ja)-r_wvrref(ic,ja))   &
        *r_wvrtcal(ic,ja)*r_wvrdpath(ic,ja)/1000.
    enddo
    if (do_phase_wvr_e(ja)) then
      phase_tmp=phase_tmp*r_wvrfpath(1,ja)
    endif
    phase = - phase_corr(isb,ja)*phase_tmp   &
      + phase_corr(isb,ia)*(dh_test1(2,ia)-r_csky_mon(ia))
    zs = zs * cmplx(cos(phase),-sin(phase))
  endif
  !
  ! wvr and tot.power correction
  if (do_phase_mon(ja) .and. do_phase_wvr(ia)) then
    phase_tmp = 0.0
    do ic=1,mwvrch
      phase_tmp = phase_tmp + (dh_wvr(ic,ia)-r_wvrref(ic,ia))   &
        *r_wvrtcal(ic,ia)*r_wvrdpath(ic,ia)/1000.
    enddo
    if (do_phase_wvr_e(ia)) then
      phase_tmp=phase_tmp*r_wvrfpath(1,ia)
    endif
    phase = phase_corr(isb,ia)*phase_tmp   &
      - phase_corr(isb,ja)*(dh_test1(2,ja)-r_csky_mon(ja))
    zs = zs * cmplx(cos(phase),-sin(phase))
  endif
  !
  z = z * zs
  if (z.ne.0) then
    a = abs(z)/a
  else
    a = 1
  endif
  return
end subroutine scaling
!
subroutine ascaling (ia,is,az,a,error)
  use classic_api  
  !---------------------------------------------------------------------
  ! This is used to rescale autocorrelation
  ! (actually only AMPLITUDE RAW = unapply atmospheric calibration)
  !
  ! created 2000-10-20 RL
  !---------------------------------------------------------------------
  integer :: ia                     ! antenna
  integer :: is                     ! subband
  real :: az                        ! amplitude factor
  real :: a                         ! amplitude factor
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_dheader.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  complex :: zscale(mrlband,2,mnbat)
  real :: ascale(mrlband,mnant)
  common /clicscale/ zscale, ascale
  save /clicscale/
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  a = ascale(is,ia)
  if (a.eq.0 .or. az.eq.0) then
    a = 1
    return
  endif
  az = az * ascale(is,ia)
  return
end subroutine ascaling

function pwat(t,u)
  !----------------------------------------------------------------------
  !	calculo de la presion parcial del vapor de agua
  !	t es la temperatura en grados kelvin
  !	p es la presion atmosferica total en milibares
  !	u es la humedad relativa
  !	pwat es la presion parcial del vapor de agua
  !
  !
  !	calculo de la presion de saturacion
  !
  ! J Cernicharo
  !----------------------------------------------------------------------
  real pwat,t,u
  real p,es,e
  !
  p=1013.
  es=6.105*exp(25.22/t*(t-273.)-5.31*alog(t/273.))
  e=1.-(1.-u/100.)*es/p
  pwat=es*u/100.*e
  pwat=pwat*216.5/t
  return
end function pwat

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage MRTCAL messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtcal_messaging
  use gpack_def
  use gbl_message
  !
  public :: seve,mseve,message_length
  public :: mrtcal_message_set_id
  public :: mrtcal_message
  public :: failed_calibrate
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: mrtcal_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: mrtcal_debug_calib_message_t
    integer(kind=4) :: alloc   ! Support for MSET DEBUG CALIB ALLOCATION
    integer(kind=4) :: book    ! Support for MSET DEBUG CALIB BOOKKEEPING
    integer(kind=4) :: others  ! Support for MSET DEBUG CALIB OTHERS
  end type mrtcal_debug_calib_message_t
  !
  type :: mrtcal_debug_output_message_t
    integer(kind=4) :: acc   ! Support for MSET DEBUG OUTPUT ACCUMULATION
  end type mrtcal_debug_output_message_t
  !
  type :: mrtcal_debug_message_t
    type(mrtcal_debug_calib_message_t)  :: calib  ! Support for MSET DEBUG CALIB
    type(mrtcal_debug_output_message_t) :: output ! Support for MSET DEBUG OUTPUT
    integer(kind=4)                     :: sync   ! Support for MSET DEBUG SYNC
  end type mrtcal_debug_message_t
  !
  type(mrtcal_debug_message_t) :: mseve
  !
  interface failed_calibrate
    module procedure failed_calibrate_name
    module procedure failed_calibrate_num
  end interface failed_calibrate
  !
contains
  !
  subroutine mrtcal_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    ! Local
    character(len=message_length) :: mess
    !
    mrtcal_message_id = id
    !
    write (mess,'(A,I3)') 'Now use id #',mrtcal_message_id
    call mrtcal_message(seve%d,'mrtcal_message_set_id',mess)
  end subroutine mrtcal_message_set_id
  !
  subroutine mrtcal_message(mkind,procname,message)
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call gmessage_write(mrtcal_message_id,mkind,procname,message)
  end subroutine mrtcal_message
  !
  function failed_calibrate_name(rname,sname,error)
    !---------------------------------------------------------------------
    ! Display the subscan name if input error is .true.
    ! Nothing done if error is .false.
    !---------------------------------------------------------------------
    logical :: failed_calibrate_name  ! Function value on return
    character(len=*), intent(in) :: rname  ! Calling routine name
    character(len=*), intent(in) :: sname  ! Subscan name
    logical,          intent(in) :: error  ! Error status
    !
    failed_calibrate_name = error
    if (.not.error)  return
    !
    call mrtcal_message(seve%e,rname,'Failed for subscan '''//trim(sname)//'''')
  end function failed_calibrate_name
  !
  function failed_calibrate_num(rname,snum,error)
    !---------------------------------------------------------------------
    ! Display the subscan number if input error is .true.
    ! Nothing done if error is .false.
    !---------------------------------------------------------------------
    logical :: failed_calibrate_num  ! Function value on return
    character(len=*), intent(in) :: rname  ! Calling routine name
    integer(kind=4),  intent(in) :: snum   ! Subscan number
    logical,          intent(in) :: error  ! Error status
    ! Local
    character(len=message_length) :: mess
    !
    failed_calibrate_num = error
    if (.not.error)  return
    !
    write(mess,'(A,I0)')  'Failed for subscan #',snum
    call mrtcal_message(seve%e,rname,mess)
  end function failed_calibrate_num
end module mrtcal_messaging

module class_index
  use classic_params
  use class_types 
  !
  type (indx_t) :: smin    ! Valeurs minimales pour FIND
  type (indx_t) :: smax    ! Valeurs maximales pour FIND
  !
  type (optimize), target, save :: ix  ! Index du fichier d'entree
  type (optimize), target, save :: ox  ! Index du fichier de sortie
  type (optimize), target, save :: cx  ! Index de la selection courante
  !
  type (flag_t), save :: flg     ! Flag for selecting data
  !
  ! Index numbers of observation in memory. If 0 : no obs in memory,
  ! if -1 : an obs in memory that  was not read in a file.
  ! knext : pointer to the next index entry to consider
  integer(kind=entry_length) :: knext          ! Pointer to next observation
  integer(kind=entry_length) :: nindex         ! Index size
  integer(kind=entry_length) :: last_xnum = 0  ! Last observation obtained by GET
end module class_index
!
module class_data
  use class_types
  !
  type(observation), target  :: P  ! Plotted observation (from LOAD)
  !
  real(kind=xdata_kind), allocatable, target :: pdatas(:), pdatai(:), pdatav(:), pdatax(:)
  real, allocatable, target :: pdataw(:)
  real, allocatable, target :: pdata2(:,:)
end module class_data

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_rotate_shift_and_sort_tool
  use gbl_message
  !
  public :: uv_sort_main,loaduv,sortuv
  public :: uvsort_uv,chksuv
  private
  !
contains
  !
  subroutine uv_sort_main(error,sorted,shift,new,uvmax,uvmin)
    use phys_const, only: pi
    use image_def
    use gkernel_interfaces
    use mapping_interfaces, only: uvgmax
    use uv_buffers
    use uv_shift, only: uv_shift_header
    use clean_types
    !----------------------------------------------------------------------
    ! Sort the input UV table
    !----------------------------------------------------------------------
    logical,      intent(inout) :: sorted ! Is table sorted ?
    logical,      intent(inout) :: shift  ! Do we shift phase center ?
    logical,      intent(out)   :: error
    real(kind=8), intent(inout) :: new(3) ! New phase center and PA
    real,         intent(out)   :: uvmin  ! Min baseline
    real,         intent(out)   :: uvmax  ! Max baseline
    !
    integer :: nu,nv
    real :: pos(2),cs(2)
    real, pointer :: duv_previous(:,:)
    real, pointer :: duv_next(:,:)
    real(kind=8) :: freq,off(3)
    real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
    !
    ! The UV table is available in HUV
    if (huv%loca%size.eq.0) then
       call map_message(seve%e,'UV_MAP','No UV data loaded')
       error = .true.
       return
    endif
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    !
    ! Correct for new phase center if required
    if (shift) then
       if (huv%gil%ptyp.eq.p_none) then
          call map_message(seve%w,'SHIFT','No previous phase center info')
          huv%gil%a0 = huv%gil%ra
          huv%gil%d0 = huv%gil%dec
          huv%gil%pang = 0.d0
          huv%gil%ptyp = p_azimuthal
       elseif (huv%gil%ptyp.ne.p_azimuthal) then
          call map_message(seve%w,'SHIFT','Previous projection type not SIN')
          huv%gil%ptyp = p_azimuthal
       endif
       call uv_shift_header(new,huv%gil%a0,huv%gil%d0,huv%gil%pang,off,shift)
       huv%gil%posi_words = def_posi_words
       huv%gil%proj_words = def_proj_words
    endif
    if (shift) then
       sorted = .false.
    else
       call check_order (duv,nu,nv,sorted)
    endif
    !
    ! Get center frequency
    freq = gdf_uv_frequency(huv,huv%gil%ref(1))
    !
    if (sorted) then
       ! If already sorted, use it
       call map_message(seve%i,'UVSORT','UV table is already sorted')
       !
       ! Compute UVMAX
       call uvgmax(huv,duv,uvmax,uvmin)
    else
       ! Else, create another copy
       call map_message(seve%i,'UVSORT','Sorting UV table...')
       !
       ! Compute observing frequency, and new phase center in wavelengths
       if (shift) then
          huv%gil%a0 = new(1)
          huv%gil%d0 = new(2)
          huv%gil%pang = new(3)
          cs(1)  =  cos(off(3))
          cs(2)  = -sin(off(3))
          ! Note that the new phase center is counter-rotated because rotations
          ! are applied before phase shift.
          pos(1) = - freq * f_to_k * ( off(1)*cs(1) - off(2)*cs(2) )
          pos(2) = - freq * f_to_k * ( off(2)*cs(1) + off(1)*cs(2) )
       else
          pos(1) = 0.0
          pos(2) = 0.0
          cs(1) = 1.0
          cs(2) = 0.0
       endif
       !
       !$ call uv_dump_buffers('UV_SORT')
       !
       ! OK, rotate, shift, sort and copy...
       nullify (duv_previous, duv_next)
       call uv_find_buffers('UV_SORT',nu,nv, duv_previous, duv_next, error)
       if (error) return
       call uvsort_uv(nu,nv,huv%gil%ntrail,duv_previous,duv_next,&
            pos,cs,uvmax,uvmin,error)
       huv%gil%basemax = uvmax
       huv%gil%basemin = uvmin
       call uv_clean_buffers(duv_previous, duv_next,error)
       if (error) return
    endif
    !
    ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
    uvmax = uvmax*freq*f_to_k
    uvmin = uvmin*freq*f_to_k
    error = .false.
  end subroutine uv_sort_main
  !
  subroutine check_order(visi,np,nv,sorted)
    !----------------------------------------------------------
    ! Check if visibilites are sorted.
    ! Chksuv does a similar job, but using V values and an index.
    !----------------------------------------------------------
    integer, intent(in)  :: np       ! Size of a visibility
    integer, intent(in)  :: nv       ! Number of visibilities
    real,    intent(in)  :: visi(np,nv) ! Visibilities
    logical, intent(out) :: sorted
    !
    integer :: iv
    real :: vmax
    !
    vmax = visi(2,1)
    do iv=1,nv
       if (visi(2,iv).lt.vmax) then
          sorted = .false.
          return
       endif
       vmax = visi(2,iv)
    enddo
    sorted = .true.
  end subroutine check_order
  !
  subroutine uvsort_uv(np,nv,ntrail,vin,vout,xy,cs,uvmax,uvmin,error)
!    use gildas_def
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Rotate, Shift and Sort a UV table for map making
    ! Differential precession should have been applied before.
    !---------------------------------------------------------------------
    integer, intent(in)  :: np          ! Size of a visibility
    integer, intent(in)  :: nv          ! Number of visibilities
    integer, intent(in)  :: ntrail      ! Number of trailing daps
    real,    intent(in)  :: vin(np,nv)  ! Input visibilities
    real,    intent(out) :: vout(np,nv) ! Output visibilities
    real,    intent(in)  :: xy(2)       ! Phase shift
    real,    intent(in)  :: cs(2)       ! Frame Rotation
    real,    intent(out) :: uvmax       ! Max UV value
    real,    intent(out) :: uvmin       ! Min UV value
    logical, intent(out) :: error
    !
    logical :: sorted
    integer :: ier
    logical, allocatable :: ips(:)       ! Sign of visibility
    integer, allocatable :: ipi(:)       ! Index
    real, allocatable :: ipu(:), ipv(:)  ! U,V coordinates
    !
    ! Load U,V coordinates, applying possible rotation (CS), and
    ! making all V negative
    allocate(ips(nv),ipu(nv),ipv(nv),ipi(nv),stat=ier)
    error = ier.ne.0
    if (error) return
    call loaduv(vin,np,nv,cs,ipu,ipv,ips,uvmax,uvmin)
    !
    ! Sort if needed
    call chksuv(nv,ipv,ipi,sorted)
    if (.not.sorted) then
       call gr4_trie(ipv,ipi,nv,error)
       if (error) return
    endif
    !
    ! Apply phase shift and copy to output visibilities
    call sortuv(vin,vout,np,nv,ntrail,xy,ipu,ipv,ips,ipi)
    !
    deallocate(ips,ipu,ipv,ipi,stat=ier)
    call gagout('I-UVSORT,  Successful completion')
  end subroutine uvsort_uv
  !
  subroutine loaduv(visi,np,nv,cs,u,v,s,uvmax,uvmin)
    !---------------------------------------------------------------------
    ! Load new U,V coordinates and sign indicator into work arrays for
    ! sorting.
    !---------------------------------------------------------------------
    integer, intent(in)    :: np          ! Size of a visibility
    integer, intent(in)    :: nv          ! Number of visibilities
    real,    intent(in)    :: visi(np,nv) ! Input visibilities
    real,    intent(in)    :: cs(2)       ! Rotation parameter
    real,    intent(out)   :: u(nv)       ! Output U and V coordinates
    real,    intent(out)   :: v(nv)       ! Output U and V coordinates
    logical, intent(out)   :: s(nv)       ! V Sign indicator
    real,    intent(inout) :: uvmax       ! Maximum length
    real,    intent(inout) :: uvmin       ! Minimum baseline
    !
    integer :: iv
    real :: uv
    !
    uv = 0
    do iv=1,nv
       uv = visi(1,iv)**2 + visi(2,iv)**2
       if (uv.ne.0) exit
    enddo
    uvmax = uv
    uvmin = uv
    !
    if (cs(2).eq.0.0) then
       do iv=1,nv
          v(iv) = visi(2,iv)
          if (v(iv).gt.0) then
             u(iv) = -visi(1,iv)
             v(iv) = -v(iv)
             s(iv) = .false.
          else
             u(iv) = visi(1,iv)
             s(iv) = .true.
          endif
          uv = u(iv)*u(iv)+v(iv)*v(iv)
          if (uv.gt.uvmax) then
             uvmax = uv
          else if (uv.lt.uvmin .and. uv.ne.0) then
             uvmin = uv
          endif
       enddo
    else
       do iv=1,nv
          u(iv) = cs(1)*visi(1,iv) - cs(2)*visi(2,iv)
          v(iv) = cs(2)*visi(1,iv) + cs(1)*visi(2,iv)
          if (v(iv).gt.0) then
             u(iv) = -u(iv)
             v(iv) = -v(iv)
             s(iv) = .false.
          else
             s(iv) = .true.
          endif
          uv = u(iv)*u(iv)+v(iv)*v(iv)
          if (uv.gt.uvmax) then
             uvmax = uv
          else if (uv.lt.uvmin .and. uv.ne.0) then
             uvmin = uv
          endif
       enddo
    endif
    uvmax = sqrt(uvmax)
    uvmin = sqrt(uvmin)
  end subroutine loaduv
  !
  subroutine chksuv(nv,v,it,sorted)
    !---------------------------------------------------------------------
    ! Check if visibilities are sorted
    !---------------------------------------------------------------------
    integer, intent(in)  :: nv     ! Number of visibilities
    real,    intent(in)  :: v(nv)  ! Visibilities
    integer, intent(out) :: it(nv) ! Sorting pointer
    logical, intent(out) :: sorted ! short cut
    !
    integer :: iv
    real :: vmax
    !
    do iv=1,nv
       it(iv) = iv
    enddo
    !
    vmax = v(1)
    do iv = 1,nv
       if (v(iv).gt.0 .or. v(iv).lt.vmax) then
          sorted = .false.
          return
       endif
       vmax = v(iv)
    enddo
    sorted = .true.
  end subroutine chksuv
  !
  subroutine sortuv(vin,vout,np,nv,ntrail,xy,u,v,s,it)
    !---------------------------------------------------------------------
    ! Sort an input UV table into an output one.
    ! The output UV table is a rotated, phase shifted copy of
    ! the input one, with all V negative and increasing
    !---------------------------------------------------------------------
    integer, intent(in)  :: np          ! Size of a visibility
    integer, intent(in)  :: nv          ! Number of visibilities
    integer, intent(in)  :: ntrail      ! Number of trailing daps
    real,    intent(in)  :: vin(np,nv)  ! Input visibilities
    real,    intent(out) :: vout(np,nv) ! Output visibilities
    real,    intent(in)  :: xy(2)       ! Phase shifting factors
    real,    intent(in)  :: u(nv)       ! New U coordinates
    real,    intent(in)  :: v(nv)       ! New V coordinates
    logical, intent(in)  :: s(nv)       ! Sign of new visibility
    integer, intent(in)  :: it(nv)      ! Pointer to old visibility
    !
    integer :: ip,iv,kv,no
    real :: phi, cphi, sphi
    !
    ! There may be trailing columns in UV table
    no = np-ntrail
    !
    ! Simple case: no phase shift
    !$OMP PARALLEL &
    !$OMP & SHARED(u,v,vin,vout,no,np,xy) &
    !$OMP & PRIVATE(kv,iv,ip, phi,cphi,sphi)
    if (xy(1).eq.0 .and. xy(2).eq.0) then
       !$OMP DO
       do iv=1,nv
          kv = it(iv)
          vout(1,iv) = u(kv)
          vout(2,iv) = v(iv)       ! This one is sorted already
          vout(3,iv) = vin(3,kv)
          vout(4,iv) = vin(4,kv)
          vout(5,iv) = vin(5,kv)
          if (s(kv)) then
             vout(6,iv) = vin(6,kv)
             vout(7,iv) = vin(7,kv)
             do ip=8,np
                vout(ip,iv) = vin(ip,kv)
             enddo
          else
             vout(6,iv) = vin(7,kv)
             vout(7,iv) = vin(6,kv)
             do ip=8,no,3
                vout(ip,iv)   =  vin(ip,kv)
                vout(ip+1,iv) = -vin(ip+1,kv)
                vout(ip+2,iv) =  vin(ip+2,kv)
             enddo
          endif
          do ip=no+1,np
             vout(ip,iv)   =  vin(ip,kv)
          enddo
       enddo
    !$OMP END DO
    else
       !
       ! Complex case: phase center has been shifted
       !$OMP DO
       do iv=1,nv
          kv = it(iv)
          vout(1,iv) = u(kv)
          vout(2,iv) = v(iv)       ! This one is sorted already
          vout(3,iv) = vin(3,kv)
          vout(4,iv) = vin(4,kv)
          vout(5,iv) = vin(5,kv)
          phi = xy(1)*u(kv)+xy(2)*v(iv)
          cphi = cos(phi)
          sphi = sin(phi)
          if (s(kv)) then
             vout(6,iv) = vin(6,kv)
             vout(7,iv) = vin(7,kv)
             do ip=8,no,3
                vout(ip,iv) = vin(ip,kv)*cphi - vin(ip+1,kv)*sphi
                vout(ip+1,iv) = vin(ip,kv)*sphi + vin(ip+1,kv)*cphi
                vout(ip+2,iv) = vin(ip+2,kv)
             enddo
          else
             vout(6,iv) = vin(7,kv)
             vout(7,iv) = vin(6,kv)
             do ip=8,no,3
                vout(ip,iv) = vin(ip,kv)*cphi + vin(ip+1,kv)*sphi
                vout(ip+1,iv) = vin(ip,kv)*sphi - vin(ip+1,kv)*cphi
                vout(ip+2,iv) = vin(ip+2,kv)
             enddo
          endif
          do ip=no+1,np
             vout(ip,iv)   =  vin(ip,kv)
          enddo
       enddo
       !$OMP END DO
    endif
    !$OMP END PARALLEL
  end subroutine sortuv
end module uv_rotate_shift_and_sort_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeio_subcube
  !---------------------------------------------------------------------
  ! Support module for a contiguous block of 2D planes
  !---------------------------------------------------------------------
  use cubetools_parameters
  use cubetools_setup_types
  use cubedag_node_class
  use cubeio_messaging
  use cubeio_cube_define
  use cubeio_cube
  use cubeio_flush
  use cubeio_read
  use cubeio_write

  type cubeio_subcube_t
    integer(kind=data_k), public  :: f3 = 0  ! Index of first plane in the corresponding full cube
    integer(kind=data_k), public  :: n1 = 0                         ! Size of 1st dimension
    integer(kind=data_k), public  :: n2 = 0                         ! Size of 2nd dimension
    integer(kind=data_k), public  :: n3 = 0                         ! (Useful) size of 3rd dimension
    integer(kind=code_k), public  :: allocated = code_pointer_null  !
    logical,              public  :: iscplx = .false.               ! R*4 or C*4?
    real(kind=sign_k),    public, pointer :: r4(:,:,:) => null()    ! [n1,n2,m3]
    complex(kind=sign_k), public, pointer :: c4(:,:,:) => null()    ! [n1,n2,m3]
  contains
    procedure, public :: get  => cubeio_get_subcube
    procedure, public :: put  => cubeio_put_subcube
    procedure, public :: free => cubeio_free_subcube
  end type cubeio_subcube_t

  private
  public :: cubeio_subcube_t
  public :: cubeio_iterate_subcube

contains

  subroutine cubeio_reallocate_subcube(subcube,iscplx,n1,n2,n3,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate a cubeio_subcube_t
    ! Do nothing when the array sizes do not need to change
    !-------------------------------------------------------------------
    type(cubeio_subcube_t), intent(inout) :: subcube
    logical,                intent(in)    :: iscplx
    integer(kind=data_k),   intent(in)    :: n1
    integer(kind=data_k),   intent(in)    :: n2
    integer(kind=data_k),   intent(in)    :: n3  ! Minimum desired (can be different from size of allocation)
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='REALLOCATE>SUBCUBE'
    integer(kind=4) :: ier
    integer(kind=data_k) :: m3
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    ! Sanity checks
    if (n1.le.0) then
      call cubeio_message(seve%e,rname,'Size of 1st dimension is null or negative')
      error = .true.
    endif
    if (n2.le.0) then
      call cubeio_message(seve%e,rname,'Size of 2nd dimension is null or negative')
      error = .true.
    endif
    if (n3.le.0) then
      call cubeio_message(seve%e,rname,'Size of 3rd dimension is null or negative')
      error = .true.
    endif
    if (error)  return
    !
    ! Allocation or reallocation?
    if (subcube%allocated.eq.code_pointer_allocated) then
      ! Reallocation?
      if (subcube%iscplx) then
        m3 = ubound(subcube%c4,3)
      else
        m3 = ubound(subcube%r4,3)
      endif
      if ((subcube%iscplx.eqv.iscplx) .and.  &
           subcube%n1.eq.n1           .and.  &
           subcube%n2.eq.n2           .and.  &
           m3.ge.n3) then
        ! Same type and same size (at least on 3rd dim) => Nothing to be done!
        call cubeio_message(ioseve%alloc,rname,'Subcube already allocated with correct size')
        goto 100
      else  ! Different type or different size => reallocation
        call cubeio_message(ioseve%alloc,rname,'Reallocating subcube')
        call cubeio_free_subcube(subcube,error)
        if (error)  return
      endif
    else
      ! Allocation
      call cubeio_message(ioseve%alloc,rname,'Creating subcube')
    endif
    !
    ! Reallocate memory of the right size
    if (iscplx) then
      allocate(subcube%c4(n1,n2,n3),stat=ier)
    else
      allocate(subcube%r4(n1,n2,n3),stat=ier)
    endif
    if (failed_allocate(rname,'Subcube',ier,error)) return
    !
  100 continue
    ! Operation success
    subcube%n1 = n1
    subcube%n2 = n2
    subcube%n3 = n3
    subcube%iscplx = iscplx
    subcube%allocated = code_pointer_allocated
    !
  end subroutine cubeio_reallocate_subcube

  subroutine cubeio_free_subcube(subcube,error)
    !---------------------------------------------------------------------
    ! Free a 'cubeio_subcube_t' instance
    !---------------------------------------------------------------------
    class(cubeio_subcube_t), intent(inout) :: subcube
    logical,                 intent(inout) :: error
    !
    if (subcube%allocated.eq.code_pointer_allocated) then
      if (subcube%iscplx) then
        deallocate(subcube%c4)
      else
        deallocate(subcube%r4)
      endif
    endif
    !
    subcube%f3 = 0
    subcube%n1 = 0
    subcube%n2 = 0
    subcube%n3 = 0
    subcube%allocated = code_pointer_null
    subcube%iscplx = .false.
    subcube%c4 => null()
    subcube%r4 => null()
  end subroutine cubeio_free_subcube

  subroutine cubeio_get_subcube(subcube,cubset,cubdef,dno,cub,f3,l3,order,error)
    use cubetools_access_types
    !---------------------------------------------------------------------
    ! Get all data (N1 x N2) for the desired range on 3rd dimension
    ! ---
    ! Usually called for a subcube in native order, if the requested order
    ! is different, implicit transposition will occur.
    !---------------------------------------------------------------------
    class(cubeio_subcube_t),      intent(inout) :: subcube
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: f3
    integer(kind=data_k),         intent(in)    :: l3
    integer(kind=code_k),         intent(in)    :: order   ! Desired order
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>SUBCUBE'
    integer(kind=data_k) :: n3
    character(len=message_length) :: mess
    !
    if (.not.cub%ready()) then
      call cubeio_message(seve%e,rname,'Internal error: cube data is not ready')
      error = .true.
      return
    endif
    select case (order)
    case (code_cube_imaset)
      n3 = cub%desc%nc
    case (code_cube_speset)
      n3 = cub%desc%ny
    case default
      write(mess,'(A,I0)')  'Unexpected subcube order: ',order
      call cubeio_message(seve%e,rname,mess)
      error = .true.
      return
    end select
    if (f3.le.0 .or. l3.gt.n3) then
      write(mess,'(3(A,I0),2A)')  'Subcube range ',f3,'-',l3,  &
        ' out of input cube range 1-',n3,' for order ',cubetools_ordername(order)
      call cubeio_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    subcube%f3 = f3  ! Bookkeeping at which position it was gotten
    select case (cub%desc%buffered)
    case (code_buffer_memory)
      call cubeio_get_subcube_from_memory(cubset,cub,f3,l3,order,subcube,error)
    case (code_buffer_disk)
      call cubeio_get_subcube_from_block(cubset,dno,cub,f3,l3,order,subcube,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected cube buffering')
      error = .true.
    end select
    if (error)  return
  end subroutine cubeio_get_subcube

  subroutine cubeio_get_subcube_from_memory(cubset,cub,f3,l3,order,subcube,error)
    !---------------------------------------------------------------------
    ! Get all data (N1 x N2) for the desired range, in the context of
    ! memory mode. In return, the 'subcube' points to the cube data buffer.
    ! --
    ! Do not call directly, use cubeio_get_subcube instead.
    !---------------------------------------------------------------------
    type(cube_setup_t),          intent(in)    :: cubset
    type(cubeio_cube_t), target, intent(in)    :: cub
    integer(kind=data_k),        intent(in)    :: f3
    integer(kind=data_k),        intent(in)    :: l3
    integer(kind=code_k),        intent(in)    :: order   ! Desired order
    type(cubeio_subcube_t),      intent(inout) :: subcube
    logical,                     intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>SUBCUBE>FROM>MEMORY'
    integer(kind=data_k) :: n3,ic,oc,iy,oy
    !
    n3 = l3-f3+1
    !
    if (order.eq.cub%desc%order) then  ! Native order
      ! Data is simply associated to memory buffer
      ! ZZZ deallocate if needed before associating!
      subcube%n1 = cub%desc%n1
      subcube%n2 = cub%desc%n2
      subcube%n3 = n3
      if (cub%memo%iscplx) then
        subcube%c4 => cub%memo%c4(:,:,f3:l3)
      else
        subcube%r4 => cub%memo%r4(:,:,f3:l3)
      endif
      subcube%iscplx = cub%memo%iscplx
      subcube%allocated = code_pointer_associated
      !
    elseif (order.eq.code_cube_speset .and.  &
            cub%desc%order.eq.code_cube_imaset) then
      ! Subcube is VLM, cube is LMV: transposition needed
      call cubeio_reallocate_subcube(subcube,cub%memo%iscplx,cub%desc%nc,cub%desc%nx,n3,error)
      if (error)  return
      if (cub%memo%iscplx) then
        do iy=f3,l3
          oy = iy-f3+1
          do ic=1,cub%desc%nc
            subcube%c4(ic,:,oy) = cub%memo%c4(:,iy,ic)
          enddo
        enddo
      else
        do iy=f3,l3
          oy = iy-f3+1
          do ic=1,cub%desc%nc
            subcube%r4(ic,:,oy) = cub%memo%r4(:,iy,ic)
          enddo
        enddo
      endif
      !
    elseif (order.eq.code_cube_imaset .and.  &
            cub%desc%order.eq.code_cube_speset) then
      ! Subcube is LMV, cube is VLM: transposition needed
      call cubeio_reallocate_subcube(subcube,cub%memo%iscplx,cub%desc%nx,cub%desc%ny,n3,error)
      if (error)  return
      if (cub%memo%iscplx) then
        do ic=f3,l3
          oc = ic-f3+1
          do iy=1,cub%desc%ny
            subcube%c4(:,iy,oc) = cub%memo%c4(ic,:,iy)
          enddo
        enddo
      else
        do ic=f3,l3
          oc = ic-f3+1
          do iy=1,cub%desc%ny
            subcube%r4(:,iy,oc) = cub%memo%r4(ic,:,iy)
          enddo
        enddo
      endif
      !
    else
      call cubeio_message(seve%e,rname,  &
        'No data available or transposition not implemented')
      error = .true.
      return
    endif
  end subroutine cubeio_get_subcube_from_memory

  subroutine cubeio_get_subcube_from_block(cubset,dno,cub,f3,l3,order,subcube,error)
    !---------------------------------------------------------------------
    ! Get all data (N1 x N2) for the desired range, in the context of
    ! disk mode. In return, the 'subcube' points to a memory buffer that is
    ! intended to disappear as others planes are accessed => no warranty
    ! the pointer remains valid after another call.
    ! --
    ! Do not call directly, use cubeio_get_subcube instead.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t), target,  intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: f3
    integer(kind=data_k),         intent(in)    :: l3
    integer(kind=code_k),         intent(in)    :: order   ! Desired order
    type(cubeio_subcube_t),       intent(inout) :: subcube
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>SUBCUBE>FROM>BLOCK'
    integer(kind=data_k) :: n3,bf3,bl3
    !
    n3 = l3-f3+1
    !
    if (order.eq.cub%desc%order) then
      ! Native order
      call cubeio_check_input_any_block(cubset,dno,cub,f3,l3,error)
      if (error)  return
    elseif (order.eq.code_cube_speset .and.  &
            cub%desc%order.eq.code_cube_imaset) then
      ! Subcube is VLM, cube is LMV: transposition needed. This is done
      ! when reading the block.
      call cubeio_check_input_pix_block(cubset,dno,cub,f3,l3,error)
      if (error)  return
    elseif (order.eq.code_cube_imaset .and.  &
            cub%desc%order.eq.code_cube_speset) then
      ! Subcube is LMV, cube is VLM: transposition needed. This is done
      ! when reading the block.
      call cubeio_check_input_chan_block(cubset,dno,cub,f3,l3,error)
      if (error)  return
    else
      call cubeio_message(seve%e,rname,  &
        'No data available or transposition not implemented')
      error = .true.
      return
    endif
    !
    ! Now the subcube is simply associated to the file block
    bf3 = f3-cub%file%block%first+1  ! First position in cub%file%block
    bl3 = l3-cub%file%block%first+1  ! Last position in cub%file%block
    ! ZZZ deallocate if needed before associating!
    subcube%n1 = cub%file%block%dim1
    subcube%n2 = cub%file%block%dim2
    subcube%n3 = n3
    if (cub%file%block%iscplx) then
      subcube%c4 => cub%file%block%c4(:,:,bf3:bl3)
    else
      subcube%r4 => cub%file%block%r4(:,:,bf3:bl3)
    endif
    subcube%iscplx = cub%file%block%iscplx
    subcube%allocated = code_pointer_associated
  end subroutine cubeio_get_subcube_from_block
  !
  subroutine cubeio_put_subcube(subcube,cubset,cubdef,dno,cub,f3,l3,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Put all data (N1 x N2) for the desired channel range
    ! (This is symetric to cubeio_get_subcube)
    ! ---
    ! Subcube data is always put in native order
    !-------------------------------------------------------------------
    class(cubeio_subcube_t),      intent(inout) :: subcube
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: f3
    integer(kind=data_k),         intent(in)    :: l3
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>SUBCUBE'
    character(len=message_length) :: mess
    !
    if (.not.cub%ready()) then
      call cubeio_message(seve%e,rname,'Internal error: cube data is not ready')
      error = .true.
      return
    endif
    if (f3.le.0 .or. l3.gt.cub%desc%n3) then
      write(mess,'(3(A,I0))')  'Subcube range ',f3,'-',l3,  &
        ' out of output cube range 1-',cub%desc%n3
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (subcube%n1.ne.cub%desc%n1 .or. subcube%n2.ne.cub%desc%n2) then
      write(mess,'(5(A,I0))')  'N1 or N2 mismatch: attempt to put ',  &
        subcube%n1,'x',subcube%n2,' sized plane(s) while output cube has ',  &
        cub%desc%n1,'x',cub%desc%n2,' planes'
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (subcube%iscplx.neqv.cub%desc%iscplx) then
      call cubeio_message(seve%e,rname,'Channel and output cube type mismatch (R*4/C*4)')
      error = .true.
    endif
    if (error)  return
    !
    subcube%f3 = f3  ! Bookkeeping at which position it was put
    select case (cub%desc%buffered)
    case (code_buffer_memory)
      call cubeio_put_subcube_to_data(cubset,cub,f3,l3,subcube,error)
    case (code_buffer_disk)
      call cubeio_put_subcube_to_block(cubset,dno,cub,f3,l3,subcube,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected cube data buffering')
      error = .true.
    end select
    if (error)  return
  end subroutine cubeio_put_subcube
  !
  subroutine cubeio_put_subcube_to_data(cubset,cub,f3,l3,subcube,error)
    !-------------------------------------------------------------------
    ! Write a data range to the cubeio_memory_t, in the context of
    ! memory mode.
    ! ---
    ! Do not call directly, use cubeio_put_subcube instead.
    !-------------------------------------------------------------------
    type(cube_setup_t),     intent(in)    :: cubset
    type(cubeio_cube_t),    intent(inout) :: cub
    integer(kind=data_k),   intent(in)    :: f3
    integer(kind=data_k),   intent(in)    :: l3
    type(cubeio_subcube_t), intent(in)    :: subcube
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>SUBCUBE'
    integer(kind=data_k) :: n3,i3,o3
    !
    n3 = l3-f3+1
    !
    select case (cub%desc%order)
    case (code_cube_imaset,code_cube_speset)
      if (cub%memo%iscplx) then
        do o3=f3,l3
          i3 = o3-f3+1
          cub%memo%c4(:,:,o3) = subcube%c4(:,:,i3)
        enddo
      else
        do o3=f3,l3
          i3 = o3-f3+1
          cub%memo%r4(:,:,o3) = subcube%r4(:,:,i3)
        enddo
      endif
    case default
      call cubeio_message(seve%e,rname,'No data available')
      error = .true.
      return
    end select
    !
  end subroutine cubeio_put_subcube_to_data
  !
  subroutine cubeio_put_subcube_to_block(cubset,dno,cub,f3,l3,subcube,error)
    !-------------------------------------------------------------------
    ! Write a data range to the cubeio_block_t, in the context of
    ! disk mode.
    ! ---
    ! Do not call directly, use cubeio_put_subcube instead.
    !-------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: f3
    integer(kind=data_k),         intent(in)    :: l3
    type(cubeio_subcube_t),       intent(in)    :: subcube
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>SUBCUBE'
    integer(kind=data_k) :: n3,bf3,bl3
    integer(kind=size_length) :: ndata
    !
    if (cub%file%block%iscplx.neqv.subcube%iscplx) then
      call cubeio_message(seve%e,rname,'Channel and output cube mismatch type (R*4/C*4)')
      error = .true.
      return
    endif
    !
    call cubeio_check_output_any_block(cubset,dno,cub,f3,l3,error)
    if (error)  return
    !
    ! Buffer might already be in memory but read-only: switch to read-write
    cub%file%block%readwrite = .true.
    !
    ! Write DATA to cub%file%block buffer
    n3 = l3-f3+1
    bf3 = f3-cub%file%block%first+1  ! First position in cub%file%block
    bl3 = l3-cub%file%block%first+1  ! Last position in cub%file%block
    ndata = cub%desc%n1*cub%desc%n2*n3
    if (cub%file%block%iscplx) then
      call c4toc4_sl(subcube%c4,cub%file%block%c4(1,1,bf3),ndata)
    else
      call r4tor4_sl(subcube%r4,cub%file%block%r4(1,1,bf3),ndata)
    endif
    !
  end subroutine cubeio_put_subcube_to_block
  !
  subroutine cubeio_iterate_subcube(cubset,cubdef,dno,cub,first,last,error)
    !---------------------------------------------------------------------
    ! Prepare buffers for working (at least) on the requested range.
    ! To be used when iterating the cube in native order. Otherwise use
    ! cubeio_iterate_pix or cubeio_iterate_chan.
    ! ZZZ All the 3 iteration procedures should be merged if the 3
    ! associated types are merged.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: first
    integer(kind=data_k),         intent(in)    :: last
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>SUBCUBE'
    !
    select case (cub%desc%action)
    case (code_read_head)
      call cubeio_message(seve%e,rname,'Access to data not allowed for action read-header')
      error = .true.
    case (code_read,code_update)
      call cubeio_iterate_read_subcube(cubset,cubdef,dno,cub,first,last,error)
    case (code_write)
      call cubeio_iterate_write_subcube(cubset,cubdef,dno,cub,first,last,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected action mode')
      error = .true.
    end select
  end subroutine cubeio_iterate_subcube

  subroutine cubeio_iterate_read_subcube(cubset,cubdef,dno,icub,first,last,error)
    !---------------------------------------------------------------------
    ! Pre-load all or part of the data from disk in a buffer which
    ! provides (at least) the requested range.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: icub
    integer(kind=data_k),         intent(in)    :: first
    integer(kind=data_k),         intent(in)    :: last
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>READ>SUBCUBE'
    !
    ! On first iteration, read or prepare the cube data (does nothing on
    ! subsequent iterations):
    call cubeio_read_cube_data(cubset,cubdef,icub,error)
    if (error)  return
    !
    ! Work to be done on next iterations
    select case (icub%desc%buffered)
    case (code_buffer_none)
      return
    case (code_buffer_memory)
      return
    case (code_buffer_disk)
      ! Ensure the proper buffer is available in memory
      call cubeio_check_input_any_block(cubset,dno,icub,first,last,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
  end subroutine cubeio_iterate_read_subcube

  subroutine cubeio_iterate_write_subcube(cubset,cubdef,dno,ocub,first,last,error)
    !---------------------------------------------------------------------
    ! Prepare a buffer covering all or part of the data, providing
    ! (at least) the requested range.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: ocub
    integer(kind=data_k),         intent(in)    :: first
    integer(kind=data_k),         intent(in)    :: last
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>WRITE>SUBCUBE'
    !
    ! On first iteration, prepare the cube data (does nothing on
    ! subsequent iterations):
    call cubeio_create_cube_data(cubset,cubdef,dno,ocub,error)
    if (error)  return
    !
    ! Work to be done on next iterations
    select case (ocub%desc%buffered)
    case (code_buffer_none)
      return
    case (code_buffer_memory)
      return
    case (code_buffer_disk)
      ! Ensure the proper buffer is available in memory
      call cubeio_check_output_any_block(cubset,dno,ocub,first,last,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
  end subroutine cubeio_iterate_write_subcube

end module cubeio_subcube

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_system_tool
  use gkernel_interfaces
  use cubetools_parameters
  !
  public :: cubetools_directory_create_for_file
  public :: cubetools_directory_create
  private
  !
contains
  !
  subroutine cubetools_directory_create_for_file(filename,error)
    !-------------------------------------------------------------------
    ! Create the directory for a file if it does not exist. The filename
    ! can be a full path or just a name. In the first case, the
    ! directory is created if it does not exist. In the second case,
    ! nothing is done.
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: filename
    logical,          intent(inout) :: error
    !
    character(len=base_l) :: basename
    character(len=file_l) :: dirname
    !
    call sic_parse_name(filename,basename,odir=dirname)
    if (dirname.ne.'') then
      call cubetools_directory_create(dirname,error)
      if (error) return
    endif
  end subroutine cubetools_directory_create_for_file
  !
  subroutine cubetools_directory_create(dirname,error)
    !-------------------------------------------------------------------
    ! Create a directory (mkdir -p) if it does not exist. If the
    ! directory already exists, nothing is done.
    !-------------------------------------------------------------------
    character(len=*), intent(inout) :: dirname
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: nlength
    !
    nlength = len_trim(dirname)
    if (gag_inquire(dirname,nlength).ne.0) then
      call gag_mkdir(dirname,error)
      if (error) return
    endif
  end subroutine cubetools_directory_create
end module cubetools_system_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

function a_lever(d,d0,el)
  !---------------------------------------------------------------------
  ! @ private
  !	Lever d'une etoile de declinaison D a latitude D0
  !	Ce code est different de "lever" de GreG, donc je l'appelle A_LEVER
  !	(sinon big problemes,...GD, 8-10-1992)
  !	D	Declination in radians
  !	D0	Latitude in degrees
  ! 	EL	elevation limit in degrees
  !	LEVER	Hour angle in Hours
  !
  !	PI/2-D0+EL < D	Circumpolaire
  !	D0-PI/2+EL < D < PI/2-D0+EL H = ACOS (TAN(D)/TAN(D0-PI/2))
  !	D < D0-PI/2+EL	Toujours couchee...
  !
  ! Formule applicable a la partie visible du ciel en projection
  ! sur un plan
  !---------------------------------------------------------------------
  real(kind=4) :: a_lever           !
  real(kind=4) :: d                 !
  real(kind=4) :: d0                !
  real(kind=4) :: el                !
  ! Local
  real(kind=4) :: dd,d1,d2,ee
  real(kind=8) :: pi
  parameter (pi=3.14159265358979323846d0)
  !
  if (d0.lt.0.) then
    d2 = -d
    d1 = -d0*pi/180.0
  else
    d2 = d
    d1 = d0*pi/180.0
  endif
  dd = d1-pi*0.5d0
  ee = el*pi/180.
  a_lever = (-sin(ee)+sin(d2)*cos(dd))/(cos(d2)*sin(dd))
  if (a_lever.le.-1.0) then
    a_lever = -12.0            ! Circumpolar
  elseif (a_lever.ge.1.0) then
    a_lever = 0.0              ! Not visible
  else
    a_lever = -12.0/pi* acos(a_lever)
  endif
end function a_lever

program make_mosaic
  use gildas_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  !   Make a mosaic cube from a set of original images.
  !
  ! The original images are assumed to have the same phase tracking center
  ! and hence the same map characterictics (pixel, size, coordinates)
  ! This program compute several images (rather data cubes) :
  !
  ! 'NAME'.LMV  a 3-d cube containing the uniform noise
  !     combined mosaic, i.e. the sum of the product
  !     of the fields by the primary beam.
  ! 'NAME'.LOBE the primary beams pseudo-cube (NF,NX,NY)
  ! 'NAME'.WEIGHT the sum of the square of the primary beams
  ! 'NAME'.BEAM a 3-d cube where each plane is the synthesised
  !     beam for one field
  !
  ! All images have the same X,Y sizes
  ! It is assumed that the names of the original field images follow
  ! the simple sequence 'NAME'-'I'.LMV
  !----------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: version = 'Version 2.0 08-May-2009'
  character(len=*), parameter :: pname = 'MAKE_MOSAIC'
  integer :: nf
  real :: bsize,bmin
  character(len=80) :: generic
  logical :: error
  !
  call gagout('I-'//pname//', '//version)
  !
  call gildas_open
  call gildas_inte('FIELDS$',nf,1)
  call gildas_char('NAME$',generic)
  call gildas_real('BEAM$',bsize,1)
  call gildas_real('BMIN$',bmin,1)
  call gildas_close
  !
  ! Do all the work in a subroutine...
  call sub_mosaic (trim(generic),nf,bsize,bmin,error)
  if (error) call sysexi(fatale)
  call gagout('I-'//pname//',  Successful completion')
  !
end program make_mosaic
!
subroutine sub_mosaic(generic,nf,bsize,bmin,error)
  use gkernel_interfaces
  use image_def
  use mapping_primary
  !
  ! Build a Mosaic from an ensemble of NF initial Images
  ! with a name following the convention name-'i' i=1,nf
  !
  character(len=*), intent(in) :: generic  ! Generic name
  integer, intent(in) :: nf                ! Number of field
  real, intent(in) :: bsize                ! Primary beam size (Radian)
  real, intent(in) :: bmin                 ! Truncation level
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname = 'MAKE_MOSAIC'
  type(gildas) :: field
  type(gildas) :: beam
  type(gildas) :: lobe
  type(gildas) :: mosaic
  type(gildas) :: tmp
  type(gildas) :: weight
  !
  real, allocatable :: dbeam(:,:,:)   ! Dirty and Primary beam arrays
  real, allocatable :: dmosaic(:,:,:) ! Mosaic
  real, allocatable :: dprim(:,:)     ! Current primary beam
  real, allocatable :: dtmp(:,:)      ! Temporary work space
  !
  character(len=filename_length) :: name
  integer :: nx,ny,nv, nn,ier
  integer :: if,iv
  real :: thre, rmin, rmax
  integer(kind=size_length) :: nelem, imin, imax
  character(len=3) :: chain
  !
  call gildas_null(field)
  call gildas_null(beam)
  call gildas_null(lobe)
  call gildas_null(mosaic)
  call gildas_null(weight)
  call gildas_null(tmp)
  !
  error = .false.
  nn = len_trim(generic)
  !
  name = generic
  name(nn+1:) = '-1'
  call sic_parsef (name,field%file,' ','.lmv')
  call gdf_read_header(field,error)
  if (error) then
    write(6,*) 'F-'//rname//',  Cannot open ',field%file
    return
  endif
  nx = field%gil%dim(1)
  ny = field%gil%dim(2)
  nv = field%gil%dim(3)
  !
  ! First pass: Produce the .BEAM Dirty Beam Cube
  call gdf_copy_header(field,beam,error)
  name = generic
  call sic_parsef (name,beam%file,' ','.beam')
  beam%gil%dim(3) = nf
  beam%gil%convert(:,3) = 1.d0
  beam%gil%extr_words = 0
  !
  allocate (dbeam(nx,ny,nf),stat=ier)
  !
  ! Loop over individual synthesized beams
  call gdf_copy_header(field,tmp,error)
  do if=1,nf
    name = generic
    call append_number(name,if)
    call sic_parsef (name,tmp%file,' ','.beam')
    call gdf_read_header (tmp,error)
    if (error) then
      write(6,*) 'F-'//rname//',  Cannot open ',tmp%file
      return
    endif
    if (tmp%gil%dim(1).ne.nx .or. tmp%gil%dim(2).ne.ny) then
      write(6,*) 'F-'//rname//',  Inconsistent size ',tmp%gil%dim
      error = .true.
      return
    endif
    call gdf_read_data(tmp,dbeam(:,:,if),error)
    call gdf_close_image(tmp,error) ! Free image after use
  enddo
  call gdf_write_image(beam,dbeam,error)
  deallocate(dbeam,stat=ier) ! Need and different shape later, so just free it
  if (error) then
    write(6,*) 'F-'//rname//',  Cannot create ',beam%file
    return
  endif
  !
  ! Create the primary beams  -- This is a transposed cube (NF,NX,NY)
  call gdf_transpose_header(beam,lobe,'312',error)
  if (error)  return
  name = generic
  call sic_parsef (name,lobe%file,' ','.lobe')
  !
  lobe%gil%inc(1) = bmin                ! Valeur conventionnelle
  lobe%gil%inc(4) = bsize               ! necessaire pour MRC_MOSAIC.
  allocate (dbeam(nf,nx,ny),dmosaic(nx,ny,nv),dprim(nx,ny),dtmp(nx,ny),stat=ier)  !
  if (ier.ne.0) then
     call gagout('E-'//rname//', Main array allocation error')
     error = .true.
     return
  endif
  !
  ! Create the .LMV cube
  print *,'Noise ',field%gil%noise,field%gil%rms
  call gdf_copy_header(field,mosaic,error)
  print *,'Noise ',mosaic%gil%noise,mosaic%gil%rms
  !
  ! loop over the various fields.
  name = generic(1:nn)
  call sic_parsef (name,mosaic%file,' ','.lmv')
  mosaic%gil%ra = mosaic%gil%a0
  mosaic%gil%dec  = mosaic%gil%d0
  !
  dmosaic = 0
  !
  do if=1,nf
    name = generic
    call append_number(name,if)
    call sic_parsef (name,field%file,' ','.lmv')
    call gdf_read_header (field,error)
    if (error) then
      write(6,*) 'F-'//rname//',  Cannot open ',field%file
      return
    endif
    !
    ! The non truncated primary beam is stored
    call mos_primary (field,dprim,bsize)
    dbeam(if,:,:) = dprim  ! Fill the primary beam array
    !
    ! But a truncated primary beam is used
    where(dprim.lt.bmin) dprim = 0
    !
    ! Make it Plane by Plane to save Memory ...
    do iv=1,nv
      field%blc(3) = iv
      field%trc(3) = iv
      call gdf_read_data (field, dtmp, error)
      dmosaic(:,:,iv) = dmosaic(:,:,iv) + dtmp*dprim  ! Apply the primary beam
    enddo
    call gdf_close_image (field,error) ! Free field image after use
  enddo
  !
  ! Write the primary beams
  call gdf_write_image (lobe,dbeam,error)
  if (error) then
    write(6,*) 'F-'//rname//',  Cannot create ',lobe%file
    return
  endif
  !
  ! Compute the extrema of the Mosaic and write it
  nelem = nx*ny*nv
  call gr4_extrema (nelem,dmosaic,mosaic%gil%bval,mosaic%gil%eval,   &
                    rmin,rmax,imin,imax)
  call t_setextrema(mosaic,rmin,imin,rmax,imax)
  print *,'Noise ',mosaic%gil%noise
  call gdf_write_image(mosaic,dmosaic,error)
  if (error) then
    write(6,*) 'F-'//rname//',  Cannot create ',mosaic%file
    return
  endif
  !
  ! Now the .WEIGHT file
  call gdf_copy_header(mosaic,weight,error)
  weight%gil%ndim = 2
  weight%gil%dim(3) = 1
  name = generic(1:nn)
  call sic_parsef(name,weight%file,' ','.weight')
  !
  ! Use DTMP as temporary space
  dtmp = 0
  call mos_addsq (nx*ny,nf,dtmp,dbeam)
  !
  thre = bmin**2
  call mos_inverse (nx*ny,dtmp,thre)
  nelem = nx*ny
  call gr4_extrema (nelem,dtmp,weight%gil%bval,weight%gil%eval,   &
                    rmin,rmax,imin,imax)
  call t_setextrema(weight,rmin,imin,rmax,imax)
  call gdf_write_image(weight,dtmp,error)
  !
  if (error) then
    write(6,*) 'F-'//rname//',  Cannot create ',weight%file
    return
  endif
end subroutine sub_mosaic

subroutine append_number(name,if)
  character(len=*), intent(inout) :: name
  integer, intent(in) :: if
  !
  character(len=12) :: rchain, lchain
  integer :: nn
  !
  nn = len_trim(name)
  !
  write(rchain,'(I12)') if
  lchain = adjustl(rchain)
  !
  name(nn+1:) = '-'//lchain
end subroutine append_number

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module minmax_tool
  public :: maxmap,maxlst
  private
  !
contains
  !
subroutine maxmap(ary,nx,ny,box,amax,imax,jmax,amin,imin,jmin)
  !--------------------------------------------------------------------
  ! Find max and min in specified region of real array
  !--------------------------------------------------------------------
  integer, intent(in) :: nx, ny         ! X,Y size
  real, intent(in) :: ary(nx,ny)        ! Array of values
  integer, intent(in) :: box(4)         ! Search box
  integer, intent(out) :: imax, jmax    ! Position of Max
  integer, intent(out) :: imin, jmin    ! Position of Min
  real, intent(out) :: amax, amin       ! Max and Min
  !
  integer i, j
  real a
  !
  amax = ary(box(1),box(2))
  amin = amax
  imax = box(1)
  jmax = box(2)
  imin = box(1)
  jmin = box(2)
  !
  do j = box(2), box(4)
    do i = box(1), box(3)
      a = ary(i,j)
      if (a .gt. amax) then
        amax = a
        imax = i
        jmax = j
      elseif (a .lt. amin) then
        amin = a
        imin = i
        jmin = j
      endif
    enddo
  enddo
end subroutine maxmap
!
subroutine maxlst(ary,nx,ny,list,nl,amax,imax,jmax,amin,imin,jmin)
  !--------------------------------------------------------------------
  ! Find max and min in specified region of real array using a list of
  ! valid pixels
  !--------------------------------------------------------------------
  integer, intent(in) :: nx, ny         ! X,Y size
  real, intent(in) :: ary(nx*ny)        ! Array of values
  integer, intent(in) :: nl             ! List size
  integer, intent(in) :: list(nl)       ! Search list 
  integer, intent(out) :: imax, jmax    ! Position of Max
  integer, intent(out) :: imin, jmin    ! Position of Min
  real, intent(out) :: amax, amin       ! Max and Min
  !
  integer i, k, kmin, kmax
  !
  amax = ary(list(1))
  amin = ary(list(1))
  kmin = list(1)
  kmax = list(1)
  !
  do i = 2,nl
    k = list(i)
    if (ary(k).gt.amax) then
      amax = ary(k)
      kmax = k
    elseif (ary(k).lt.amin) then
      amin = ary(k)
      kmin = k
    endif
  enddo
  !
  jmax = (kmax-1)/nx+1
  imax = kmax-(jmax-1)*nx
  jmin = (kmin-1)/nx+1
  imin = kmin-(jmin-1)*nx
end subroutine maxlst
end module minmax_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! *** JP: These types are obsolescent. Please use the one in
! *** JP: template/type-spectral-range.f90 when possible.
!
! range_scalar_t and range_array_t are the user types corresponding to the
! window_scalar_t and window_array_t prog types in the
! template/type-spectral-range-obsolescent.f90 file.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_windowing
  use cubetools_parameters
  use cubeadm_windowing_types
  use cubeobsolete_messaging
  !
  public :: window_scalar_t,window_array_t
  public :: cubemain_window_blank
  public :: cubemain_window2mask
  private
  !
  !
contains
  !
  function cubemain_window_blank(wind,iw) result(isblank)
    use cubetools_nan
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spectrum_t),     intent(in) :: wind
    integer(kind=wind_k), intent(in) :: iw
    logical                          :: isblank
    !
    isblank = ieee_is_nan(wind%t(2*iw-1)).or.ieee_is_nan(wind%t(2*iw))
  end function cubemain_window_blank
  !
  subroutine cubemain_window2mask(wind,spec,error)
    use cube_types
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(window_array_t), intent(in)    :: wind
    type(spectrum_t),     intent(inout) :: spec
    logical,              intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    !
    spec%w = 0.0
    do iw=1,wind%n
       spec%w(wind%val(iw)%o(1):wind%val(iw)%o(2)) = 1.0
    enddo
  end subroutine cubemain_window2mask
end module cubemain_windowing
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_range
  use cubetools_parameters
  use cubetools_structure
  use cubetools_unit_arg
  use cubeobsolete_messaging
  use cube_types
  !
  public :: range_opt_t,range_scalar_t,range_array_t
  public :: range_is_single,range_is_multiple
  private
  !
  logical, parameter :: range_is_single   = .true.
  logical, parameter :: range_is_multiple = .false.
  !
  type range_scalar_t
     real(kind=coor_k) :: val(2)
     logical :: truncate=.false.
  end type range_scalar_t
  type range_array_t
     integer(kind=wind_k) :: n = 0
     type(range_scalar_t), allocatable :: val(:)
     character(len=unit_l):: unit = strg_star
   contains
     procedure :: allocate => cubemain_range_allocate
  end type range_array_t
  !
  type range_opt_t
     logical                   :: single
     type(option_t),   pointer :: opt
     type(unit_arg_t), pointer :: unitarg
   contains
     procedure :: register  => cubemain_range_register
     procedure :: parse     => cubemain_range_parse
     procedure :: user2prog => cubemain_range_user2prog
  end type range_opt_t
  !
contains
  !
  subroutine cubemain_range_allocate(range,nr,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(range_array_t), intent(inout) :: range
    integer(kind=wind_k), intent(in)    :: nr
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='RANGE>ALLOCATE'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (nr.le.0) then
       call cubeobsolete_message(seve%e,rname,'Negative or zero number of ranges')
       error = .true.
       return
    endif
    !
    if (allocated(range%val)) deallocate(range%val)
    ! Allocate
    allocate(range%val(nr),stat=ier)
    if (failed_allocate(rname,'range',ier,error)) return
    ! Allocation success => range%n may be updated
    range%n = nr
  end subroutine cubemain_range_allocate
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_range_register(option,name,abstract,issingle,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    ! Register a /RANGE option that uses a single range according to a
    ! name and abstract provided by the command
    ! ----------------------------------------------------------------------
    class(range_opt_t), intent(out)   :: option
    character(len=*),   intent(in)    :: name
    character(len=*),   intent(in)    :: abstract
    logical,            intent(in)    :: issingle
    logical,            intent(inout) :: error
    !
    type(unit_arg_t) :: unitarg
    type(standard_arg_t) :: stdarg
    !
    character(len=*), parameter :: rname='RANGE>REGISTER'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    option%single = issingle
    if (issingle) then
       call cubetools_register_option(&
            name,'first last [unit]',&
            abstract,&
            'A single spectral range is accepted',&
            option%opt,error)
       if (error) return
       call stdarg%register( &
            'first',  &
            'Start of range', &
            strg_emp,&
            code_arg_mandatory, &
            error)
       if (error) return
       call stdarg%register( &
            'last',  &
            'End of range', &
            strg_emp,&
            code_arg_mandatory, &
            error)
       if (error) return
    else
       call cubetools_register_option(&
            name,'v11 v12 [... [vn1 vn2]] [unit]',&
            abstract,&
            'Use /RANGE to limit the velocity intervals used by the&
            & command. Multiple ranges are accepted.',&
            option%opt,error)
       if (error) return
       call stdarg%register( &
            'v11',  &
            'Start of first range', &
            strg_emp,&
            code_arg_mandatory, &
            error)
       if (error) return
       call stdarg%register( &
            'v12',  &
            'End of first range', &
            strg_emp,&
            code_arg_mandatory, &
            error)
       if (error) return
       call stdarg%register( &
            'vn1',  &
            'Start of n-eth range', &
            strg_emp,&
            code_arg_unlimited, &
            error)
       if (error) return
       call stdarg%register( &
            'vn2',  &
            'End of n-eth range', &
            strg_emp,&
            code_arg_unlimited, &
            error)
       if (error) return
    endif
    call unitarg%register( &
         'unit',  &
         'Range unit', &
         strg_emp,&
         code_arg_optional, &
         code_unit_velo, &
         option%unitarg,&
         error)
    if (error) return
  end subroutine cubemain_range_register
  !
  subroutine cubemain_range_parse(option,line,do,range,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(range_opt_t),  intent(in)    :: option
    character(len=*),    intent(in)    :: line
    logical,             intent(out)   :: do
    type(range_array_t), intent(inout) :: range
    logical,             intent(inout) :: error
    !
    integer(kind=wind_k) :: ir,nr,narg
    character(len=*), parameter :: rname='PARSE>RANGE'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    call option%opt%present(line,do,error)
    if (error) return
    if (do) then
       narg = option%opt%getnarg()
       nr = narg/2
       if (2*nr.ne.narg) then
          call cubeobsolete_message(seve%w,rname,'Odd number of arguments => Assumes that the last one is the unit')
          call cubetools_getarg(line,option%opt,narg,range%unit,mandatory,error)
          if (error) return
       endif
       call range%allocate(nr,error)
       if (error) return
       do ir=1,nr
          call cubetools_getarg(line,option%opt,1+2*(ir-1),range%val(ir)%val(1),mandatory,error)
          if (error) return
          call cubetools_getarg(line,option%opt,2*ir,range%val(ir)%val(2),mandatory,error)
          if (error) return
       enddo
    else
       nr = 1
       call range%allocate(nr,error)
       if (error) return
       range%val(1)%val(:) = (/ 0.0, 0.0 /)
       ! *** JP I probably should initialize range%unit here   
    endif
  end subroutine cubemain_range_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_range_user2prog(option,cube,user,prog,error)
    use cubetools_unit
    use cubemain_windowing
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(range_opt_t),   intent(in)    :: option
    type(cube_t),         intent(in)    :: cube
    type(range_array_t),  intent(in)    :: user
    type(window_array_t), intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    character(len=*), parameter :: rname='RANGE>USER2PROG'
    !
    type(unit_user_t) :: unit
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    call unit%get_from_name_for_code(user%unit,code_unit_velo,error)
    if (error) return
    call prog%allocate(user%n,error)
    if (error) return
    do iw=1,user%n
       call cubemain_range_user2prog_one(unit,cube,user%val(iw),prog%val(iw),error)
       if (error) return
    enddo
  end subroutine cubemain_range_user2prog
  !
  subroutine cubemain_range_user2prog_one(unit,cube,user,prog,error)
    use cubetools_axis_types
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_unit
    use cubemain_windowing
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(unit_user_t),     intent(in)    :: unit
    type(cube_t), target,  intent(in)    :: cube
    type(range_scalar_t),  intent(in)    :: user
    type(window_scalar_t), intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    integer(kind=wind_k) :: iw
    integer(kind=chan_k) :: nf
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='RANGE>USER2PROG>ONE'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_array_shape(cube%head,n,error)
    if (error) return
    prog%head => cube%head
    ! Define prog values
    if (user%val(1).ne.0.or.user%val(2).ne.0) then
       ! user%val(1) or user%val(2) != 0 => Use the user-defined range (ie assume that a zero value is valid)
       do iw=1,2
          call cubetools_axis_offset2pixel(&
               prog%head%spe%v,user%val(iw)*unit%prog_per_user,prog%p(iw),error)
          if (error) return
       enddo ! iw
    else
       ! user%val(1) = user%val(2) = 0
       ! => Default to full velocity range in lmv cube in increasing velocity order
       if (cube%head%spe%inc%v.gt.0) then
          ! Velocity increment > 0 => Plotted direction identical to natural direction
          prog%p = (/ 1_size_length,n%c /)
       else if (cube%head%spe%inc%v.lt.0) then
          ! Velocity increment < 0 => Plotted direction identical to natural direction
          prog%p = (/n%c,1_size_length /)
       else
          ! Velocity increment = 0 => Problem
          write(mess,'(a)') 'Velocity increment (cube%head%spe%inc%v) is zero valued'
          call cubeobsolete_message(seve%e,rname,mess)
          error = .true.
          return
       endif
    endif
    !
    ! Define other structure members accordingly
    if (user%truncate) then
       nf = n%c
       if (all(prog%p.lt.1)) then
          write(mess,'(a,i0,a,i0,a)') 'Both range edges lower than 1: [',prog%p(1),',',prog%p(2),']'
          call cubeobsolete_message(seve%e,rname,mess)
          error = .true.
       else if (all(prog%p.gt.nf)) then
          write(mess,'(a,i0,a,i0,a)') 'Both range edges greater than nf: [',prog%p(1),',',prog%p(2),']'
          call cubeobsolete_message(seve%e,rname,mess)
          error = .true.
       else
          if (prog%p(1).lt.1.or.prog%p(1).gt.nf) then
             write(mess,'(a,1pg14.7,a)') 'Range ',user%val(1),' goes beyond bounds, truncating'
             call cubeobsolete_message(obsoleteseve%others,rname,mess)
          endif
          if (prog%p(2).lt.1.or.prog%p(2).gt.nf) then
             write(mess,'(a,1pg14.7,a)') 'Range ',user%val(2),' goes beyond bounds, truncating'
             call cubeobsolete_message(obsoleteseve%others,rname,mess)
          endif
          prog%o(1) = max(min(prog%p(1),prog%p(2)),1)
          prog%o(2) = min(max(prog%p(1),prog%p(2)),nf)
       endif
    else
       prog%o(1) = min(prog%p(1),prog%p(2))
       prog%o(2) = max(prog%p(1),prog%p(2))
    endif
    prog%nc = prog%o(2)-prog%o(1)+1
  end subroutine cubemain_range_user2prog_one
end module cubemain_range
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program uv_stokes
  use gkernel_interfaces
  !
  ! Extract a polarization state from a UV table 
  !
  ! Input:
  !   A UV Table with visibilities containing Nstokes x Nchan or Nchan x Nstokes
  ! Output
  !   A UV Table with visibilities of size Nchan, but potentially different
  !   polarization states.
  !
  character(len=filename_length) :: nami,namo
  character(len=12) :: mystoke
  logical error
  !
  call gildas_open
  call gildas_char('INPUT$',nami)
  call gildas_char('OUTPUT$',namo)
  call gildas_char('STOKES$',mystoke)
  call sic_upper(mystoke)
  call gildas_close
  call sic_upper(mystoke)
  call sub_stokes (nami,namo,mystoke,error)
  if (error) then
     call gagout('E-UV_STOKES,  Extraction failed')
  else
     call gagout('I-UV_STOKES,  Successful completion')
  endif
end program uv_stokes
!
subroutine sub_stokes(nami,namo,mystoke,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  !
  character(len=*), intent(inout) :: nami     ! Input file name
  character(len=*), intent(inout) :: namo     ! Output file name
  character(len=*), intent(in)    :: mystoke  ! Desired Stoke parameterr
  logical,          intent(out)   :: error
  !
  character(len=*), parameter :: rname='UV_STOKES'
  type (gildas) :: hin, hou
  real(kind=4), allocatable :: uvin(:,:), uvou(:,:)
  !
  character(len=message_length) :: mess
  !
  integer(kind=index_length) :: icolstokes,invisi,ouvisi,nchan,iend,oend,nvisi,icol,kvisi,ipara
  integer(kind=4) :: natom, nlead, istoke, istok, nstok, ier,astoke(4),iloop
  integer(kind=4) :: nblock,mblock,multi,isign,intrail,ontrail
  logical extract
  !
  ! Interfaces for Routines below
  interface
     subroutine stokes_extract(inorder,uvin,uvou,nvisi,nlead,natom,nchan,nstok,ntrail,icolstokes)
       use image_def
       real(kind=4),               intent(in)    :: uvin(:,:)
       real(kind=4),               intent(out)   :: uvou(:,:)
       integer(kind=4),            intent(in)    :: inorder ! Code order
       integer(kind=index_length), intent(in)    :: nvisi  ! number of visibilities
       integer(kind=4),            intent(in)    :: nlead  ! number of leading columns
       integer(kind=4),            intent(in)    :: natom  ! Atomic length of a visibility (2 or 3)
       integer(kind=index_length), intent(in)    :: nchan  ! number of channels
       integer(kind=4),            intent(in)    :: nstok  ! number of input Stokes
       integer(kind=4),            intent(in)    :: ntrail ! number of trailing columns
       integer(kind=index_length), intent(in)    :: icolstokes  ! Pointer into Stokes parameter
     end subroutine stokes_extract
     !
     subroutine stokes_derive_stok(uvin,uvou,nvisi,nlead,natom,nchan,nstok,ntrail,istoke,&
          astoke,ipara,isign,error)
       use image_def
       use gbl_message
       real(kind=4),               intent(in)    :: uvin(:,:)
       real(kind=4),               intent(out)   :: uvou(:,:)
       integer(kind=index_length), intent(in)    :: nvisi  ! Number of visibilities
       integer(kind=4),            intent(in)    :: nlead  ! number of leauving columns
       integer(kind=4),            intent(in)    :: natom  ! Atomic length of a visibility (2 or 3)
       integer(kind=index_length), intent(in)    :: nchan  ! number of channels
       integer(kind=4),            intent(in)    :: nstok  ! number of input Stokes
       integer(kind=4),            intent(in)    :: ntrail ! number of trailing columns
       integer(kind=4),            intent(in)    :: istoke ! desired Stokes parameter
       integer(kind=4),            intent(in)    :: astoke(nstok)   ! Input Stokes parameters
       integer(kind=index_length), intent(in)    :: ipara  ! Parallactic angle column
       integer(kind=4),            intent(in)    :: isign  ! test integer for PA angle
       logical,                    intent(inout) :: error ! Error flag
     end subroutine stokes_derive_stok
     !
     subroutine stokes_derive_chan(uvin,uvou,nvisi,nlead,natom,nchan,nstok,ntrail,istoke,&
          astoke,ipara,isign,error)
       use image_def
       use gbl_message
       real(kind=4),               intent(in)    :: uvin(:,:)
       real(kind=4),               intent(out)   :: uvou(:,:)
       integer(kind=index_length), intent(in)    :: nvisi  ! Number of visibilities
       integer(kind=4),            intent(in)    :: nlead  ! number of leauving columns
       integer(kind=4),            intent(in)    :: natom  ! Atomic length of a visibility (2 or 3)
       integer(kind=index_length), intent(in)    :: nchan  ! number of channels
       integer(kind=4),            intent(in)    :: nstok  ! number of input Stokes
       integer(kind=4),            intent(in)    :: ntrail ! number of trailing columns
       integer(kind=4),            intent(in)    :: istoke ! desired Stokes parameter
       integer(kind=4),            intent(in)    :: astoke(nstok)   ! Input Stokes parameters
       integer(kind=index_length), intent(in)    :: ipara  ! Parallactic angle column
       integer(kind=4),            intent(in)    :: isign  ! test integer for PA angle
       logical,                    intent(inout) :: error ! Error flag
     end subroutine stokes_derive_chan
  end interface
  !
  error = .false.
  extract = .false.
  !
  ! Scan the requested polarization code
  if (mystoke.eq.'NONE') then
     istoke = code_stokes_none
  elseif (mystoke.eq.'ALL') then
     istoke = code_stokes_all
  else
     call gdf_stokes_code(mystoke,istoke,error)
     if (error) then
        call map_message(seve%e,rname,'Invalid Stokes '//mystoke)
        return
     endif
  endif
  !
  ! Read Header of a sorted, UV table
  call gildas_null(hin, type= 'UVT')
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (error) return
  !
  ipara = hin%gil%column_pointer(code_uvt_para)
  ! Test for debug
  call sic_get_inte('SIGN_PARA',isign,error)
  if (isign.ne.1) print *,'Using ISIGN ',ISIGN
  !
  call gildas_null(hou, type='UVT')
  call gdf_copy_header (hin, hou, error)
  call sic_parsef (namo,hou%file,'  ','.uvt')
  !
  hou%gil%nstokes = 1
  ! VVV What should be done here? Put the output stokes code?
  hou%gil%order = 0
  !
  call gdf_nitems('SPACE_GILDAS',nblock,hin%gil%dim(1))
  nblock = min(nblock,hin%gil%dim(2))
  !
  ! VVV In IMAGER there is a treatment of arbitrary frequency axes
  ! here, we however do not support arbitrary frequency axes.
  !
  ! Check it has more than 1 polarization
  if (hin%gil%nstokes.eq.1) then
     call map_message(seve%i,rname,'Already only 1 polar per visibility ')
     ! Here need to check if a Polar column is present, through the
     ! extra columns (code_uvt_stok)
     istok = hin%gil%column_pointer(code_uvt_stok)
     if (istok.eq.0) then
        call map_message(seve%i,rname,'Already only 1 polar in total')
        nstok = 1
        astoke(nstok) = hin%gil%order
        if (istoke.eq.astoke(1) .or. istoke.eq.0) then
           !
           ! OK copy the whole stuff...
           allocate (uvin(hin%gil%dim(1),nblock),stat=ier)
           if (failed_allocate(rname,'Input UV table',ier,error)) return
           hin%blc = 0
           hin%trc = 0
           hou%blc = 0
           hou%trc = 0
           call gdf_create_image(hou,error)
           if (error) return
           !
           call map_message(seve%i,rname,'Replicating UV table ')
           do iloop = 1,hin%gil%dim(2),nblock
              hin%blc(2) = iloop
              hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
              hou%blc(2) = iloop
              hou%trc(2) = hin%trc(2)
              call gdf_read_data (hin,uvin,error)
              if (error) return
              call gdf_write_data (hou, uvin, error)
              if (error) return
           enddo
           call gdf_close_image(hou,error)
        else
           call map_message(seve%i,rname,'Polar '//mystoke// &
                ' does not match '//gdf_stokes_name(astoke(1)) )
           error = .true.
        endif
        return
     else
        call map_message(seve%i,rname,'Perhaps more than 1 polar, scanning...')
        allocate (uvin(hin%gil%dim(1),nblock),uvou(hou%gil%dim(1),nblock),stat=ier)
        if (failed_allocate(rname,'Input and output UV tables',ier,error)) return
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        hou%blc(2) = 1
        ouvisi = 0
        call gdf_create_image(hou,error)
        if (error) return
        nstok = 0
        do iloop = 1,hin%gil%dim(2),nblock
           hin%blc(2) = iloop
           hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
           kvisi = hin%trc(2)-hin%blc(2)+1
           call gdf_read_data (hin,uvin,error)
           if (error) return
           ouvisi = 0
           do invisi = 1,kvisi
              if (uvin(istok,invisi).ne.istoke) cycle
              ouvisi = ouvisi+1
              uvou(:,ouvisi) = uvin(:,invisi)
           enddo
           if (ouvisi.gt.0) then
              hou%trc(2) = hou%blc(2)+ouvisi-1
              call gdf_write_data(hou,uvou,error)
              hou%blc(2) = hou%trc(2)+1
           endif
        enddo
        ! Finalize
        hou%gil%nvisi = hou%trc(2)
        hou%gil%dim(2) = hou%trc(2)
        call gdf_update_header(hou,error)
        call gdf_close_image(hou,error)
     endif
  else
     ! This means each Visi has Nstokes x Nchan or Nchan x Nstokes elements
     if (hin%gil%order.eq.code_chan_stok) then
        ! Nchan X Nstokes channels
        call map_message(seve%i,rname,'Nchan channels X Nstokes stokes')
     else if (hin%gil%order.eq.code_stok_chan) then
        call map_message(seve%i,rname,'Nstokes stokes X  Nchan channels')
        ! Nstokes x Nchan channels
     else
        call map_message(seve%e,rname,'Inconsistent UV table state for polarization')
        error = .true.
        return
     endif
     nstok = hin%gil%nstokes
     mess = 'Input Stokes: '
     do istok=1,nstok
        write(mess,'(2a)') trim(mess),gdf_stokes_name(hin%gil%stokes(istok))
        if (istok.ne.nstok) write(mess,'(2a)') trim(mess),', '
     enddo
     call map_message(seve%i,rname,mess)
     call map_message(seve%i,rname,'Output Stokes: '//gdf_stokes_name(istoke))
     !
     astoke(1:nstok) = hin%gil%stokes(1:nstok)
     natom = hin%gil%natom
     nchan = hin%gil%nchan
     nlead = hin%gil%nlead
     intrail = hin%gil%ntrail
     ontrail = intrail
     iend = hin%gil%dim(1)
     ! The useful cases are
     if (nstok.eq.2) then
        if (istoke.eq.code_stokes_i .or. istoke.eq.code_stokes_none &
             .or. istoke.eq.code_stokes_all) then
           ! Input: 2 Stokes, XX+YY or HH+VV or RR+LL, Output: I, NONE or ALL
           ! keep everything, make proper weighting
           if ( (astoke(1).eq.code_stokes_hh.and.astoke(2).eq.code_stokes_vv) &
                .or. (astoke(2).eq.code_stokes_hh.and.astoke(1).eq.code_stokes_vv) &
                .or. (astoke(1).eq.code_stokes_ll.and.astoke(2).eq.code_stokes_rr) &
                .or. (astoke(2).eq.code_stokes_ll.and.astoke(1).eq.code_stokes_rr) &
                .or. (astoke(1).eq.code_stokes_xx.and.astoke(2).eq.code_stokes_yy) &
                .or. (astoke(2).eq.code_stokes_xx.and.astoke(1).eq.code_stokes_yy) &
                ) then
              if (istoke.eq.code_stokes_all) then
                 hou%gil%nvisi = 2*hin%gil%nvisi
                 multi = 2
                 ontrail = ontrail+1
              else
                 multi = 1
                 hou%gil%nvisi = hin%gil%nvisi
              endif
              call map_message(seve%i,rname,'Deriving '//mystoke// &
                   ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
              ! Shift the trailing columns
              do icol=1,code_uvt_last
                 if (hou%gil%column_pointer(icol).gt.hin%gil%fcol) then
                    hou%gil%column_pointer(icol) =  hou%gil%column_pointer(icol) - &
                         & hin%gil%natom * hin%gil%nchan
                 endif
              enddo
           else
              call map_message(seve%e,rname,'Cannot derive '//mystoke// &
                   ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
              error = .true.
              return
           endif
           !
           hou%gil%dim(2) = hou%gil%nvisi
           hou%gil%dim(1) = hin%gil%dim(1) - hin%gil%nchan*hin%gil%natom + ontrail-intrail
           oend = hou%gil%dim(1)+intrail-ontrail
           if (istoke.eq.code_stokes_all) then
              hou%gil%column_pointer(code_uvt_stok) = hou%gil%dim(1)
           endif
           ! Here, we make the loop
           ! We make no assumption about the Stokes ordering, so allocate
           ! a block which may handle all input visibilities
           mblock = multi*nblock
           allocate (uvou(hou%gil%dim(1),mblock),uvin(hin%gil%dim(1),nblock),stat=ier)
           if (failed_allocate(rname,'Input and output UV tables',ier,error)) return
           !
           hin%blc = 0
           hin%trc = 0
           hou%blc = 0
           hou%trc = 0
           call gdf_create_image(hou,error)
           if (error) return
           !
           hou%blc(2) = 1
           do iloop = 1,hin%gil%dim(2),nblock
              write(mess,*) iloop,' / ',hin%gil%dim(2),nblock
              call map_message(seve%d,rname,mess)
              hin%blc(2) = iloop
              hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
              call gdf_read_data(hin,uvin,error)
              if (error) return
              nvisi = hin%trc(2)-hin%blc(2)+1
              !
              if (hin%gil%order.eq.code_chan_stok) then
                 ! Nchan X Nstokes channels  (ALL)
                 if (istoke.eq.code_stokes_all) then
                    ouvisi = 0
                    do invisi = 1,nvisi
                       ouvisi = ouvisi+1
                       uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
                       uvou(nlead+1:nlead+natom*nchan,ouvisi) = uvin(nlead+1:nlead+natom*nchan,invisi)
                       if (ontrail.ne.intrail) uvou(oend+1,ouvisi) = astoke(1)
                       if (intrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                            uvin(nlead+1+2*natom*nchan:iend,invisi)
                       ouvisi = ouvisi+1
                       uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
                       uvou(nlead+1:nlead+natom*nchan,ouvisi) = &
                            uvin(nlead+1+natom*nchan:nlead+2*natom*nchan,invisi)
                       if (ontrail.ne.intrail) uvou(oend+1,ouvisi) = astoke(2)
                       if (intrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                            uvin(nlead+1+2*natom*nchan:iend,invisi)
                    enddo
                 else
                    call map_message(seve%e,rname,'Nchan X Nstokes channel order only supported for code ALL')
                    error = .true.
                    return
                 endif
              else
                 ! Nstokes x Nchan channels
                 call stokes_derive_stok(uvin,uvou,nvisi,nlead,natom,nchan,nstok,intrail, &
                      & istoke,astoke,ipara,isign,error)
                 if (error) return
              endif
              hou%trc(2) = hou%blc(2)+ouvisi-1
              call gdf_write_data(hou,uvou,error)
              hou%blc(2) = hou%trc(2)+1
           enddo ! By block
        else
           ! Input: 2 Stokes, HH+VV or RR+LL, Output: one among these.
           ! keep only that one...
           if (istoke.eq.astoke(1)) then
              icolstokes = 1
           else if (istoke.eq.astoke(2)) then
              icolstokes = 2
           else
              call map_message(seve%e,rname,'Cannot extract '//mystoke// &
                   ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
              error = .true.
              return
           endif
           call map_message(seve%e,rname,'Extracting '//mystoke// &
                ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
           !
           hou%gil%dim(1) = hin%gil%dim(1)-hin%gil%nchan*hin%gil%natom
           extract = .true.
           ! Shift the trailing columnstok
           do icol=1,code_uvt_last
              if (hou%gil%column_pointer(icol).gt.hin%gil%fcol) then
                 hou%gil%column_pointer(icol) =  hou%gil%column_pointer(icol) - &
                      & hin%gil%natom * hin%gil%nchan
              endif
           enddo
        endif
     else if (nstok.eq.4) then
        ! 4 Stokes, extract one of them
        icolstokes = 0
        do istok=1,nstok
           if (istoke.eq.astoke(istok)) then
              icolstokes = istok
              exit
           endif
        enddo
        if (icolstokes.eq.0) then
           if ( (istoke.eq.code_stokes_none) .or. & 
                & ((istoke.ge.code_stokes_i).and.(istoke.le.code_stokes_v)) )  then
              !
              ! Is derivation possible ?
              if ( (astoke(1).eq.code_stokes_hh.and.astoke(2).eq.code_stokes_vv) &
                   .or. (astoke(2).eq.code_stokes_hh.and.astoke(1).eq.code_stokes_vv) &
                   .or. (astoke(1).eq.code_stokes_ll.and.astoke(2).eq.code_stokes_rr) &
                   .or. (astoke(2).eq.code_stokes_ll.and.astoke(1).eq.code_stokes_rr) &
                   .or. (astoke(1).eq.code_stokes_xx.and.astoke(2).eq.code_stokes_yy) &
                   .or. (astoke(2).eq.code_stokes_xx.and.astoke(1).eq.code_stokes_yy) &
                   ) then
                 continue
              else
                 call map_message(seve%e,rname, &
                      & 'Unsupported Stokes ordering ')
                 error = .true.
                 return
              endif
              !
              multi = 1   ! 1 output visibility per input Visibility      
              ! Shift the trailing columns
              do icol=1,code_uvt_last
                 if (hou%gil%column_pointer(icol).gt.hin%gil%fcol) then
                    hou%gil%column_pointer(icol) =  hou%gil%column_pointer(icol) - &
                         & 3 * hin%gil%natom * hin%gil%nchan
                 endif
              enddo
              !
              ! Figure out which case is to be compressed
              hou%gil%dim(2) = hou%gil%nvisi
              hou%gil%dim(1) = hin%gil%dim(1)-3*hin%gil%nchan*hin%gil%natom &
                   &        + ontrail-intrail
              oend = hou%gil%dim(1)+intrail-ontrail
              !
              ! Here, we make the loop
              ! We make no assumption about the Stokes ordering, so allocate
              ! a block which may handle all input visibilities
              mblock = multi*nblock
              allocate (uvou(hou%gil%dim(1),mblock),uvin(hin%gil%dim(1),nblock),stat=ier)
              if (failed_allocate(rname,'Input and output UV tables',ier,error)) return
              !
              hin%blc = 0
              hin%trc = 0
              hou%blc = 0
              hou%trc = 0
              call gdf_create_image(hou,error)
              if (error) return
              !
              hou%blc(2) = 1
              do iloop = 1,hin%gil%dim(2),nblock
                 write(mess,*) iloop,' / ',hin%gil%dim(2),nblock
                 call map_message(seve%i,rname,mess)
                 hin%blc(2) = iloop
                 hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
                 call gdf_read_data(hin,uvin,error)
                 if (error) return
                 nvisi = hin%trc(2)-hin%blc(2)+1
                 !
                 ! Nstokes x Nchan channels
                 if (hin%gil%order.eq.code_chan_stok) then
                    call stokes_derive_chan(uvin,uvou,nvisi,nlead,natom,nchan,nstok, &
                         & intrail,istoke,astoke,ipara,isign,error)            
                 else
                    call stokes_derive_stok(uvin,uvou,nvisi,nlead,natom,nchan,nstok, &
                         & intrail,istoke,astoke,ipara,isign,error)
                 endif
                 if (error) return
                 !
                 hou%trc(2) = hou%blc(2)+multi*nvisi-1
                 call gdf_write_data(hou,uvou,error)
                 hou%blc(2) = hou%trc(2)+1
              enddo ! Block
           else
              call map_message(seve%e,rname,'Cannot extract '//mystoke// &
                   ' from '//gdf_stokes_name(astoke(1))//gdf_stokes_name(astoke(2))// &
                   gdf_stokes_name(astoke(3))//' and '//gdf_stokes_name(astoke(4)) )
              error = .true.
              return
           endif
        else
           call map_message(seve%i,rname,'Extracting '//mystoke// &
                ' from '//gdf_stokes_name(astoke(1))//gdf_stokes_name(astoke(2))//  &
                gdf_stokes_name(astoke(3))//' and '//gdf_stokes_name(astoke(4)))
           hou%gil%dim(1) = hin%gil%dim(1)-3*hin%gil%nchan*hin%gil%natom
           extract = .true.
           ! Shift the trailing columns
           do icol=1,code_uvt_last
              if (hou%gil%column_pointer(icol).gt.hin%gil%fcol) then
                 hou%gil%column_pointer(icol) =  hou%gil%column_pointer(icol) - &
                      & 3 * hin%gil%natom * hin%gil%nchan
              endif
           enddo
        endif
     endif
     ! The extraction code makes no assumption about the Stokes order.
     if (extract) then
        call gdf_create_image(hou,error)
        if (error) return
        allocate (uvou(hou%gil%dim(1),nblock),uvin(hin%gil%dim(1),nblock),stat=ier)
        if (failed_allocate(rname,'Input and output UV tables',ier,error)) return
        hin%blc = 0
        hou%trc = 0
        !
        hou%blc(2) = 1
        do iloop = 1,hin%gil%dim(2),nblock
           hin%blc(2) = iloop
           hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
           nvisi = hin%trc(2)-hin%blc(2)+1
           call gdf_read_data(hin,uvin,error)
           if (error) return
           call stokes_extract(hin%gil%order,uvin,uvou,nvisi,nlead,natom,nchan,nstok,intrail,icolstokes)
           hou%trc(2) = hou%blc(2)+kvisi-1
           call gdf_write_data(hou,uvou,error)
           hou%blc(2) = hou%trc(2)+1
        enddo
     endif
     call gdf_close_image(hou,error)
  endif
end subroutine sub_stokes
!
subroutine stokes_extract(inorder,uvin,uvou,nvisi,nlead,natom,nchan,nstok,ntrail,icolstokes)
  use image_def
  !---------------------------------------------------------------------
  ! Support routine for UV_STOKES task: extract the relevant Stokes
  ! parameter from the input visibilities.
  !---------------------------------------------------------------------
  real(kind=4),               intent(in)    :: uvin(:,:)
  real(kind=4),               intent(out)   :: uvou(:,:)
  integer(kind=4),            intent(in)    :: inorder ! Code order
  integer(kind=index_length), intent(in)    :: nvisi  ! number of visibilities
  integer(kind=4),            intent(in)    :: nlead  ! number of leading columns
  integer(kind=4),            intent(in)    :: natom  ! Atomic length of a visibility (2 or 3)
  integer(kind=index_length), intent(in)    :: nchan  ! number of channels
  integer(kind=4),            intent(in)    :: nstok  ! number of input Stokes
  integer(kind=4),            intent(in)    :: ntrail ! number of trailing columns
  integer(kind=index_length), intent(in)    :: icolstokes  ! Pointer into Stokes parameter
  !
  integer(kind=index_length) :: ivisi,ichan,incol, oucol
  !
  if (inorder.eq.code_chan_stok) then
    ! Nchan X Nstokes channels
    do ivisi = 1,nvisi
      uvou(1:nlead,ivisi) = uvin(1:nlead,ivisi)
      uvou(nlead+1:nlead+natom*nchan,ivisi) = &
      & uvin(nlead+1+(icolstokes-1)*natom*nchan:nlead+icolstokes*natom*nchan,ivisi)
      if (ntrail.gt.0) uvou(1+nlead+natom*nchan:,ivisi) = uvin(nlead+1+nstok*natom*nchan:,ivisi)
    enddo
  else
    ! Nstokes x Nchan channels
    do ivisi = 1,nvisi 
      uvou(1:nlead,ivisi) = uvin(1:nlead,ivisi)
      incol = nlead+(icolstokes-1)*natom
      oucol = nlead
      do ichan=1,nchan
        uvou(oucol+1:oucol+natom,ivisi) = uvin(incol+1:incol+natom,ivisi)
        oucol = oucol + natom
        incol = incol + nstok*natom
      enddo
      if (ntrail.gt.0) uvou(1+nlead+natom*nchan:,ivisi) = uvin(nlead+1+nstok*natom*nchan:,ivisi)
    enddo
  endif
end subroutine stokes_extract
!
subroutine stokes_derive_stok(uvin,uvou,nvisi,nlead,natom,nchan,nstok,ntrail,istoke,astoke,ipara,isign,error)
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! Support routine for UV_STOKES task: Derive the relevant Stokes
  ! parameter from the input visibilities. This routine works with the
  ! CODE_STOKE_CHAN order, and 2 or 4 input Stokes parameters. Not all
  ! combinations of in and out stokes parameters are allowed.
  !---------------------------------------------------------------------
  real(kind=4),               intent(in)    :: uvin(:,:)
  real(kind=4),               intent(out)   :: uvou(:,:)
  integer(kind=index_length), intent(in)    :: nvisi  ! Number of visibilities
  integer(kind=4),            intent(in)    :: nlead  ! number of leauving columns
  integer(kind=4),            intent(in)    :: natom  ! Atomic length of a visibility (2 or 3)
  integer(kind=index_length), intent(in)    :: nchan  ! number of channels
  integer(kind=4),            intent(in)    :: nstok  ! number of input Stokes
  integer(kind=4),            intent(in)    :: ntrail ! number of trailing columns
  integer(kind=4),            intent(in)    :: istoke ! desired Stokes parameter
  integer(kind=4),            intent(in)    :: astoke(nstok)   ! Input Stokes parameters
  integer(kind=index_length), intent(in)    :: ipara  ! Parallactic angle column
  integer(kind=4),            intent(in)    :: isign  ! test integer for PA angle
  logical,                    intent(inout) :: error ! Error flag
  !
  character(len=*), parameter :: rname='STOKES>DERIVE>STOK'
  !
  character(len=message_length) :: mess
  integer(kind=index_length) :: invisi, ouvisi, incol, oucol, ichan, iend, oend
  integer(kind=4) :: ip, istok
  real(kind=4) :: re, im, we, da, db
  integer(kind=4)  ::  multi, jsign
  real(kind=4)  :: hh(2), hv(2), vv(2), vh(2), aa(2), bb(2), xx, yy
  real(kind=4)  :: rr(2), ll(2), rl(2), lr(2)
  logical :: good_order, circular
  !
  iend = ubound(uvin,1)
  oend = ubound(uvou,1)
  !
  if (istoke.eq.code_stokes_all) then
     multi = nstok
     oend = oend-1
  else
     multi = 1
  endif
  ouvisi = 0
  select case(istoke)
  case (code_stokes_none)  
     ! Stokes NONE: Unpolarized case - optimize sensitivity
     ouvisi = 0
     do invisi = 1,nvisi
        ouvisi = ouvisi+1
        uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
        incol = nlead
        oucol = nlead
        do ichan=1,nchan
           if (natom.eq.3) then ! Real, Image, Weight
              if (uvin(incol+3,invisi).gt.0) then
                 re = uvin(incol+1,invisi) * uvin(incol+3,invisi)
                 im = uvin(incol+2,invisi) * uvin(incol+3,invisi)
                 we = uvin(incol+3,invisi)
              else
                 re = 0
                 im = 0
                 we = 0
              endif
              incol = incol+natom
              if (uvin(incol+3,invisi).gt.0) then
                 re = re + uvin(incol+1,invisi) * uvin(incol+3,invisi)
                 im = im + uvin(incol+2,invisi) * uvin(incol+3,invisi)
                 we = we + uvin(incol+3,invisi)
              endif
              if (we.ne.0) then
                 uvou(oucol+1:oucol+1,ouvisi) = re/we
                 uvou(oucol+2:oucol+2,ouvisi) = im/we
                 uvou(oucol+3:oucol+3,ouvisi) = we
              else
                 uvou(oucol+1:oucol+3,ouvisi) = 0
              endif
           else if (natom.eq.2) then
              ! Only Real Weight
              if (uvin(incol+2,invisi).gt.0) then
                 re = uvin(incol+1,invisi) * uvin(incol+2,invisi)
                 we = uvin(incol+2,invisi)
              else
                 re = 0
                 we = 0
              endif
              incol = incol+natom
              if (uvin(incol+2,invisi).gt.0) then
                 re = re + uvin(incol+1,invisi) * uvin(incol+2,invisi)
                 we = we + uvin(incol+2,invisi)
              endif
              if (we.ne.0) then
                 uvou(oucol+1:oucol+1,ouvisi) = re/we
                 uvou(oucol+2:oucol+2,ouvisi) = we
              else
                 uvou(oucol+1:oucol+2,ouvisi) = 0
              endif
           endif
           ! Skip the HV and VH or LR and RL values
           incol = incol + (nstok-2)*natom
           oucol = oucol + natom
           incol = incol + natom
        enddo
        ! Fill trailing columns
        if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
             uvin(nlead+1+nstok*natom*nchan:iend,invisi)
     enddo
  case (code_stokes_i)
     ! Stokes I
     ! Stokes I is strictly Stokes I, i.e.   (HH+VV)/2 or (LL+RR)/2, not
     ! an arbitray weighted combination.
     ! For unpolarized signals, to maximize sensitivity, use Stokes NONE
     do invisi=1,nvisi
        ouvisi = ouvisi+1
        uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
        incol = nlead
        oucol = nlead
        do ichan=1,nchan
           if (uvin(incol+natom,invisi).gt.0)  then
              uvou(oucol+1:oucol+natom,ouvisi) = uvin(incol+1:incol+natom-1,invisi)  ! Visib
              da = 1.0/uvin(incol+natom,invisi) ! Noise**2
              ip = 1
           else
              da = 0.0
              ip = 0
           endif
           incol = incol+natom
           if (uvin(incol+natom,invisi).gt.0)  then
              uvou(oucol+1:oucol+natom-1,ouvisi) = uvou(oucol+1:oucol+natom-1,ouvisi) + &
                   uvin(incol+1:incol+natom-1,invisi)
              db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
              ip = ip+1
           else
              db = 0.0
           endif
           if (ip.eq.2) then
              uvou(oucol+1:oucol+natom-1,ouvisi) = uvou(oucol+1:oucol+natom-1,ouvisi) / ip
              uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
           else
              uvou(oucol+natom,ouvisi) = 0.0
           endif
           ! Skip the HV and VH or LR and RL values
           incol = incol + (nstok-2)*natom
           oucol = oucol + natom
           incol = incol + natom
        enddo
        ! Fill trailing columns
        if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
             uvin(nlead+1+nstok*natom*nchan:iend,invisi)
     enddo
  case (code_stokes_V)
     ! Stokes V is -j(HV-VH)/2 or -j(XY-YX)/2 or (RR-LL)/2
     ! a proper test on ordering would be good.
     ! Natom must be 3 in this case (we need complex numbers)
     if ( ((astoke(3).eq.code_stokes_hv).and.(astoke(4).eq.code_stokes_vh)) &
          & .or. ((astoke(3).eq.code_stokes_xy).and.(astoke(4).eq.code_stokes_yx)) &
          & ) then
        ! We only support HH VV HV VH and XX YY XY YX order for the time being
        ! V = -j (XY-YX)/2  =  -j (HV-VH)/2
        do invisi=1,nvisi
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           incol = incol+2*natom ! Skipp HH and VV 
           do ichan=1,nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 HV(1:2) = uvin(incol+1:incol+natom-1,invisi)  
                 da = 1.0/uvin(incol+natom,invisi) ! Noise**2
                 ip = 1
              else
                 da = 0.0
                 ip = 0
              endif
              incol = incol+natom
              if (uvin(incol+natom,invisi).gt.0)  then
                 VH(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
                 ip = ip+1
              else
                 db = 0.0
              endif
              if (ip.eq.2) then
                 uvou(oucol+1:oucol+1,ouvisi) = +(hv(2)-vh(2))/2          
                 uvou(oucol+2:oucol+2,ouvisi) = -(hv(1)-vh(1))/2
                 uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
              else
                 uvou(oucol+natom,ouvisi) = 0.0
              endif
              oucol = oucol + natom
              incol = incol + natom
           enddo
           ! Fill trailing columns
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
        enddo
        !
     elseif ( (astoke(1).eq.code_stokes_rr).and.(astoke(2).eq.code_stokes_ll) .and. & 
          &  (astoke(3).eq.code_stokes_rl).and.(astoke(4).eq.code_stokes_lr) ) then
        ! (RR - LL ) /2
        do invisi=1,nvisi
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           do ichan=1,nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 RR(1:2) = uvin(incol+1:incol+natom-1,invisi)  
                 da = 1.0/uvin(incol+natom,invisi) ! Noise**2
                 ip = 1
              else
                 da = 0.0
                 ip = 0
              endif
              incol = incol+natom
              if (uvin(incol+natom,invisi).gt.0)  then
                 LL(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
                 ip = ip+1
              else
                 db = 0.0
              endif
              if (ip.eq.2) then
                 uvou(oucol+1:oucol+2,ouvisi) = (rr-ll)/2
                 uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
              else
                 uvou(oucol+natom,ouvisi) = 0.0
              endif
              oucol = oucol + natom
              incol = incol + natom
              incol = incol+2*natom ! Skip RL and LR 
           enddo
           ! Fill trailing columns
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
        enddo
     else
        write(mess,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not supported'
        call map_message(seve%e,rname,mess)
        error = .true.
        return
     endif
  case (code_stokes_Q,code_stokes_U)
     ! Stokes Q and U are more complex
     ! From HH,VV etc..., they require the parallactic angle and HH,VV,HV,VH order
     ! From XX,YY etc..., they require XX,YY,XY,YX order, but no parallactic angle
     ! a proper test on ordering would be good.
     ! Natom must be 3 in this case (we need complex numbers)
     good_order = .false.
     circular = .false.
     if ( (astoke(1).eq.code_stokes_hh).and.(astoke(2).eq.code_stokes_vv) .and. & 
          &  (astoke(3).eq.code_stokes_hv).and.(astoke(4).eq.code_stokes_vh) ) then
        if (ipara.eq.0) then
           call map_message(seve%e,rname,'No parallactic angle column ')
           error = .true.
           return
        endif
        jsign = isign ! Temporary, normally should be 1
        good_order = .true.
     else if ( (astoke(1).eq.code_stokes_xx).and.(astoke(2).eq.code_stokes_yy) .and. & 
          &  (astoke(3).eq.code_stokes_xy).and.(astoke(4).eq.code_stokes_yx) ) then
        jsign = 0
        good_order = .true.
     elseif ( (astoke(1).eq.code_stokes_rr).and.(astoke(2).eq.code_stokes_ll) .and. & 
          &  (astoke(3).eq.code_stokes_rl).and.(astoke(4).eq.code_stokes_lr) ) then
        write(mess,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not fully tested'
        call map_message(seve%w,rname,mess)
        good_order = .false.
        circular = .true.
     else
        write(mess,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not supported '
        call map_message(seve%e,rname,mess)
        error = .true.
        return
     endif
     if (good_order) then
        ! compute aa = (HH-VV)/2   and bb = (HV+VH)/2 then
        !  Q = aa cos(2.phi) - bb sin(2.phi)
        !  U = aa sin(2.phi) + bb cos(2.phi)
        ! or
        ! compute aa = (XX-YY)/2   and bb = (XY+YX)/2 then
        !  Q = aa 
        !  U = bb
        db = 0 ! to avoid initialization warnings.
        do invisi=1,nvisi
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           !
           if (istoke.eq.code_stokes_q) then
              if (jsign.ne.0) then
                 xx =  cos(2*jsign*uvin(ipara,invisi))
                 yy = -sin(2*jsign*uvin(ipara,invisi))
              else
                 xx = 1.0
                 yy = 0.0
              endif
           else
              if (jsign.ne.0) then
                 xx = sin(2*jsign*uvin(ipara,invisi))
                 yy = cos(2*jsign*uvin(ipara,invisi))
              else
                 xx = 0.0
                 yy = 1.0
              endif
           endif
           do ichan=1,nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 HH(1:2) = uvin(incol+1:incol+natom-1,invisi)  
                 da = 1.0/uvin(incol+natom,invisi) ! Noise**2
                 ip = 1
              else
                 da = 0.0
                 ip = 0
              endif
              incol = incol+natom
              if (uvin(incol+natom,invisi).gt.0)  then
                 VV(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
                 ip = ip+1
              endif
              incol = incol+natom
              if (uvin(incol+natom,invisi).gt.0)  then
                 HV(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 ip = ip+1
              endif
              incol = incol+natom
              if (uvin(incol+natom,invisi).gt.0)  then
                 VH(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 ip = ip+1
              endif
              aa = (HH-VV)/2
              bb = (HV+VH)/2
              if (ip.eq.4) then
                 uvou(oucol+1:oucol+2,ouvisi) = xx*aa + yy*bb
                 uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
              else
                 uvou(oucol+natom,ouvisi) = 0.0
              endif
              oucol = oucol + natom
              incol = incol + natom
           enddo
           ! Fill trailing columns
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
        enddo
     else if (circular) then
        db = 0   ! Avoid initialization warning
        do invisi=1,nvisi
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           do ichan=1,nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 RR(1:2) = uvin(incol+1:incol+natom-1,invisi)  
                 da = 1.0/uvin(incol+natom,invisi) ! Noise**2
                 ip = 1
              else
                 da = 0.0
                 ip = 0
              endif
              incol = incol+natom
              if (uvin(incol+natom,invisi).gt.0)  then
                 LL(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
                 ip = ip+1
              endif
              incol = incol+natom
              if (uvin(incol+natom,invisi).gt.0)  then
                 RL(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 ip = ip+1
              endif
              incol = incol+natom
              if (uvin(incol+natom,invisi).gt.0)  then
                 LR(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 ip = ip+1
              endif
              if (istoke.eq.code_stokes_q) then
                 !  Q = (RL + LR)/2 
                 bb = (RL+LR)/2
              else if (istoke.eq.code_stokes_u) then              
                 !  U = -i (RL - LR)/2 
                 aa = (RL-LR)/2
                 bb(2) = -aa(1)
                 bb(1) =  aa(2)
              endif
              if (ip.eq.4) then
                 uvou(oucol+1:oucol+2,ouvisi) = bb !! 
                 uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
              else
                 uvou(oucol+natom,ouvisi) = 0.0
              endif
              oucol = oucol + natom
              incol = incol + natom
           enddo
           ! Fill trailing columns
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
        enddo
     endif
  case (code_stokes_all)
     ! Stokes ALL : explodes the Stokes / Channel visibilities
     ! into one visibility per Stokes. Add the Stokes column at
     ! end of each Visibility.  
     do invisi=1,nvisi
        do istok=1,nstok
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           do ichan=1,nchan
              uvou(oucol+1:oucol+natom,ouvisi) = uvin(incol+1:incol+natom,invisi)
              oucol = oucol + natom
              incol = incol + nstok*natom
           enddo
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
           uvou(oend+1,ouvisi) = astoke(istok)
        enddo
     enddo
  case default
     write(mess,'(a,i0,a)') 'Case ',istoke,' Not supported'
     call map_message(seve%e,rname,mess)
     error = .true.
     return
  end select
  ! Sanity check
  if (ouvisi.ne.multi*nvisi) then
     write(mess,'(2(a,i0))') 'Expecting up to ',nvisi,' visibilities, found ',ouvisi
     call map_message(seve%e,rname,mess)
     error = .true.
     return
  endif
end subroutine stokes_derive_stok
!
subroutine stokes_derive_chan(uvin,uvou,nvisi,nlead,natom,nchan,nstok,ntrail,istoke,astoke,ipara,isign,error)
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! Support routine for UV_STOKES task: Derive the relevant Stokes
  ! parameter from the input visibilities. This routine works with the
  ! CODE_CHAN_STOKE order, and 2 or 4 input Stokes parameters. Not all
  ! combinations of in and out stokes parameters are allowed.
  !---------------------------------------------------------------------
  real(kind=4),               intent(in)    :: uvin(:,:)
  real(kind=4),               intent(out)   :: uvou(:,:)
  integer(kind=index_length), intent(in)    :: nvisi  ! Number of visibilities
  integer(kind=4),            intent(in)    :: nlead  ! number of leauving columns
  integer(kind=4),            intent(in)    :: natom  ! Atomic length of a visibility (2 or 3)
  integer(kind=index_length), intent(in)    :: nchan  ! number of channels
  integer(kind=4),            intent(in)    :: nstok  ! number of input Stokes
  integer(kind=4),            intent(in)    :: ntrail ! number of trailing columns
  integer(kind=4),            intent(in)    :: istoke ! desired Stokes parameter
  integer(kind=4),            intent(in)    :: astoke(nstok)   ! Input Stokes parameters
  integer(kind=index_length), intent(in)    :: ipara  ! Parallactic angle column
  integer(kind=4),            intent(in)    :: isign  ! test integer for PA angle
  logical,                    intent(inout) :: error ! Error flag
  !
  character(len=*), parameter :: rname='STOKES>DERIVE>CHAN'
  !
  character(len=message_length) :: mess
  integer(kind=index_length) :: invisi, ouvisi, incol, oucol, ichan, iend, oend
  integer(kind=4) :: ip, istok
  real(kind=4) :: re, im, we, da, db
  integer(kind=4)  ::  multi, jsign
  real(kind=4)  :: hh(2), hv(2), vv(2), vh(2), aa(2), bb(2), xx, yy
  real(kind=4)  :: rr(2), ll(2), rl(2), lr(2)
  logical :: good_order, circular
  !
  if (istoke.eq.code_stokes_all) then
     multi = nstok
     oend = oend-1
  else
     multi = 1
  endif
  ouvisi = 0
  select case(istoke)
  case (code_stokes_none)  
     ! Stokes NONE: Unpolarized case - optimize sensitivity
     ! Order HH,VV  or LL,RR
     ouvisi = 0
     do invisi = 1,nvisi
        ouvisi = ouvisi+1
        uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
        incol = nlead
        oucol = nlead
        do ichan=1,nchan
           if (natom.eq.3) then ! Real, Image, Weight
              if (uvin(incol+3,invisi).gt.0) then
                 re = uvin(incol+1,invisi) * uvin(incol+3,invisi)
                 im = uvin(incol+2,invisi) * uvin(incol+3,invisi)
                 we = uvin(incol+3,invisi)
              else
                 re = 0
                 im = 0
                 we = 0
              endif
              incol = incol+natom*nchan  ! Skip NCHAN channels
              if (uvin(incol+3,invisi).gt.0) then
                 re = re + uvin(incol+1,invisi) * uvin(incol+3,invisi)
                 im = im + uvin(incol+2,invisi) * uvin(incol+3,invisi)
                 we = we + uvin(incol+3,invisi)
              endif
              if (we.ne.0) then
                 uvou(oucol+1:oucol+1,ouvisi) = re/we
                 uvou(oucol+2:oucol+2,ouvisi) = im/we
                 uvou(oucol+3:oucol+3,ouvisi) = we
              else
                 uvou(oucol+1:oucol+3,ouvisi) = 0
              endif
           else if (natom.eq.2) then
              ! Only Real Weight
              if (uvin(incol+2,invisi).gt.0) then
                 re = uvin(incol+1,invisi) * uvin(incol+2,invisi)
                 we = uvin(incol+2,invisi)
              else
                 re = 0
                 we = 0
              endif
              incol = incol+natom*nchan
              if (uvin(incol+2,invisi).gt.0) then
                 re = re + uvin(incol+1,invisi) * uvin(incol+2,invisi)
                 we = we + uvin(incol+2,invisi)
              endif
              if (we.ne.0) then
                 uvou(oucol+1:oucol+1,ouvisi) = re/we
                 uvou(oucol+2:oucol+2,ouvisi) = we
              else
                 uvou(oucol+1:oucol+2,ouvisi) = 0
              endif
           endif
           ! Skip the HV and VH or LR and RL values
           incol = incol - natom*nchan
           ! Increment by 1 channel
           oucol = oucol + natom
           incol = incol + natom
        enddo
        ! Fill trailing columns
        if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
             uvin(nlead+1+nstok*natom*nchan:iend,invisi)
     enddo
  case (code_stokes_i)
     ! Stokes I
     ! Stokes I is strictly Stokes I, i.e.   (HH+VV)/2 or (LL+RR)/2, not
     ! an arbitray weighted combination.
     ! For unpolarized signals, to maximize sensitinvisiity, use Stokes NONE
     do invisi=1,nvisi
        ouvisi = ouvisi+1
        uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
        incol = nlead
        oucol = nlead
        do ichan=1,nchan
           if (uvin(incol+natom,invisi).gt.0)  then
              uvou(oucol+1:oucol+natom,ouvisi) = uvin(incol+1:incol+natom-1,invisi)  ! Visib
              da = 1.0/uvin(incol+natom,invisi) ! Noise**2
              ip = 1
           else
              da = 0.0
              ip = 0
           endif
           incol = incol+natom*nchan
           if (uvin(incol+natom,invisi).gt.0)  then
              uvou(oucol+1:oucol+natom-1,ouvisi) = uvou(oucol+1:oucol+natom-1,ouvisi) + &
                   uvin(incol+1:incol+natom-1,invisi)
              db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
              ip = ip+1
           else
              db = 0.0
           endif
           if (ip.eq.2) then
              uvou(oucol+1:oucol+natom-1,ouvisi) = uvou(oucol+1:oucol+natom-1,ouvisi) / ip
              uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
           else
              uvou(oucol+natom,ouvisi) = 0.0
           endif
           ! Skip the HV and VH or LR and RL values
           incol = incol - natom*nchan
           oucol = oucol + natom
           incol = incol + natom
        enddo
        ! Fill trailing columns
        if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
             uvin(nlead+1+nstok*natom*nchan:iend,invisi)
     enddo
  case (code_stokes_V)
     ! Stokes V is -j(HV-VH)/2 or -j(XY-YX)/2 or (RR-LL)/2
     ! a proper test on ordering would be good.
     ! Natom must be 3 in this case (we need complex numbers)
     if ( ((astoke(3).eq.code_stokes_hv).and.(astoke(4).eq.code_stokes_vh)) &
          & .or. ((astoke(3).eq.code_stokes_xy).and.(astoke(4).eq.code_stokes_yx)) &
          & ) then
        ! We only support HH VV HV VH and XX YY XY YX order for the time being
        ! V = -j (XY-YX)/2  =  -j (HV-VH)/2
        do invisi=1,nvisi
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           incol = incol+2*nchan*natom ! Skipp HH and VV 
           do ichan=1,nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 HV(1:2) = uvin(incol+1:incol+natom-1,invisi)  
                 da = 1.0/uvin(incol+natom,invisi) ! Noise**2
                 ip = 1
              else
                 da = 0.0
                 ip = 0
              endif
              incol = incol+natom*nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 VH(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
                 ip = ip+1
              else
                 db = 0.0
              endif
              if (ip.eq.2) then
                 uvou(oucol+1:oucol+1,ouvisi) = +(hv(2)-vh(2))/2          
                 uvou(oucol+2:oucol+2,ouvisi) = -(hv(1)-vh(1))/2
                 uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
              else
                 uvou(oucol+natom,ouvisi) = 0.0
              endif
              incol = incol - natom*nchan
              oucol = oucol + natom
              incol = incol + natom
           enddo
           ! Fill trailing columns
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
        enddo
     elseif ( (astoke(1).eq.code_stokes_rr).and.(astoke(2).eq.code_stokes_ll) .and. & 
          &  (astoke(3).eq.code_stokes_rl).and.(astoke(4).eq.code_stokes_lr) ) then
        ! (RR - LL ) /2
        do invisi=1,nvisi
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           do ichan=1,nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 RR(1:2) = uvin(incol+1:incol+natom-1,invisi)  
                 da = 1.0/uvin(incol+natom,invisi) ! Noise**2
                 ip = 1
              else
                 da = 0.0
                 ip = 0
              endif
              incol = incol+natom*nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 LL(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
                 ip = ip+1
              else
                 db = 0.0
              endif
              if (ip.eq.2) then
                 uvou(oucol+1:oucol+2,ouvisi) = (rr-ll)/2
                 uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
              else
                 uvou(oucol+natom,ouvisi) = 0.0
              endif
              incol = incol - natom*nchan ! Skip RL and LR if present
              oucol = oucol + natom
              incol = incol + natom
           enddo
           ! Fill trailing columns
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
        enddo
     else
        write(mess,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not supported'
        call map_message(seve%e,rname,mess)
        error = .true.
        return
     endif
  case (code_stokes_Q,code_stokes_U)
     ! Stokes Q and U are more complex
     ! From HH,VV etc..., they require the parallactic angle and HH,VV,HV,VH order
     ! From XX,YY etc..., they require XX,YY,XY,YX order, but no parallactic angle
     ! a proper test on ordering would be good.
     ! Natom must be 3 in this case (we need complex numbers)
     good_order = .false.
     circular = .false.
     if ( (astoke(1).eq.code_stokes_hh).and.(astoke(2).eq.code_stokes_vv) .and. & 
          &  (astoke(3).eq.code_stokes_hv).and.(astoke(4).eq.code_stokes_vh) ) then
        if (ipara.eq.0) then
           call map_message(seve%e,rname,'No parallactic angle column ')
           error = .true.
           return
        endif
        jsign = isign ! Temporary, normally should be 1
        good_order = .true.
     else if ( (astoke(1).eq.code_stokes_xx).and.(astoke(2).eq.code_stokes_yy) .and. & 
          &  (astoke(3).eq.code_stokes_xy).and.(astoke(4).eq.code_stokes_yx) ) then
        jsign = 0
        good_order = .true.
     elseif ( (astoke(1).eq.code_stokes_rr).and.(astoke(2).eq.code_stokes_ll) .and. & 
          &  (astoke(3).eq.code_stokes_rl).and.(astoke(4).eq.code_stokes_lr) ) then
        write(mess,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not fully tested'
        call map_message(seve%w,rname,mess)
        good_order = .false.
        circular = .true.
     else
        write(mess,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not supported '
        call map_message(seve%e,rname,mess)
        error = .true.
        return
     endif
     !
     if (good_order) then
        ! compute aa = (HH-VV)/2   and bb = (HV+VH)/2 then
        !  Q = aa cos(2.phi) - bb sin(2.phi)
        !  U = aa sin(2.phi) + bb cos(2.phi)
        ! or
        ! compute aa = (XX-YY)/2   and bb = (XY+YX)/2 then
        !  Q = aa 
        !  U = bb
        db = 0 ! to avoid initialization warnings.
        do invisi=1,nvisi
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           if (istoke.eq.code_stokes_q) then
              if (jsign.ne.0) then
                 xx =  cos(2*jsign*uvin(ipara,invisi))
                 yy = -sin(2*jsign*uvin(ipara,invisi))
              else
                 xx = 1.0
                 yy = 0.0
              endif
           else
              if (jsign.ne.0) then
                 xx = sin(2*jsign*uvin(ipara,invisi))
                 yy = cos(2*jsign*uvin(ipara,invisi))
              else
                 xx = 0.0
                 yy = 1.0
              endif
           endif
           do ichan=1,nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 HH(1:2) = uvin(incol+1:incol+natom-1,invisi)  
                 da = 1.0/uvin(incol+natom,invisi) ! Noise**2
                 ip = 1
              else
                 da = 0.0
                 ip = 0
              endif
              incol = incol+natom*nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 VV(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
                 ip = ip+1
              endif
              incol = incol+natom*nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 HV(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 ip = ip+1
              endif
              incol = incol+natom*nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 VH(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 ip = ip+1
              endif
              aa = (HH-VV)/2
              bb = (HV+VH)/2
              if (ip.eq.4) then
                 uvou(oucol+1:oucol+2,ouvisi) = xx*aa + yy*bb
                 uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
              else
                 uvou(oucol+natom,ouvisi) = 0.0
              endif
              incol = incol - 3*natom*nchan
              oucol = oucol + natom
              incol = incol + natom
           enddo
           ! Fill trailing columns
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
        enddo
     else if (circular) then
        db = 0   ! Avoid initialization warning
        do invisi=1,nvisi
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead
           oucol = nlead
           do ichan=1,nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 RR(1:2) = uvin(incol+1:incol+natom-1,invisi)  
                 da = 1.0/uvin(incol+natom,invisi) ! Noise**2
                 ip = 1
              else
                 da = 0.0
                 ip = 0
              endif
              incol = incol+natom*nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 LL(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 db = 1.0/uvin(incol+natom,invisi)  ! Noise**2
                 ip = ip+1
              endif
              incol = incol+natom*nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 RL(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 ip = ip+1
              endif
              incol = incol+natom*nchan
              if (uvin(incol+natom,invisi).gt.0)  then
                 LR(1:2) = uvin(incol+1:incol+natom-1,invisi)
                 ip = ip+1
              endif
              if (istoke.eq.code_stokes_q) then
                 !  Q = (RL + LR)/2 
                 bb = (RL+LR)/2
              else if (istoke.eq.code_stokes_u) then              
                 !  U = -i (RL - LR)/2 
                 aa = (RL-LR)/2
                 bb(2) = -aa(1)
                 bb(1) =  aa(2)
              endif
              if (ip.eq.4) then
                 uvou(oucol+1:oucol+2,ouvisi) = bb !! 
                 uvou(oucol+natom,ouvisi) = 4.0/(da+db)   ! Weight = 1/noise^2
              else
                 uvou(oucol+natom,ouvisi) = 0.0
              endif
              incol = incol - 3*natom*nchan
              oucol = oucol + natom
              incol = incol + natom
           enddo
           ! Fill trailing columns
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
        enddo
     endif
  case (code_stokes_all)
     ! Stokes ALL : explodes the Stokes / Channel visibilities
     ! into one visibility per Stokes. Add the Stokes column at
     ! end of each Visibility.  
     do invisi=1,nvisi
        do istok=1,nstok
           ouvisi = ouvisi+1
           uvou(1:nlead,ouvisi) = uvin(1:nlead,invisi)
           incol = nlead+(istok-1)*nchan
           oucol = nlead
           uvou(oucol+1:oucol*natom*nchan,ouvisi) = uvin(incol+1:incol+natom*nchan,invisi)
           if (ntrail.gt.0) uvou(1+nlead+natom*nchan:oend,ouvisi) = &
                uvin(nlead+1+nstok*natom*nchan:iend,invisi)
           uvou(oend+1,ouvisi) = astoke(istok)
        enddo
     enddo
  case default
     write(mess,'(a,i0,a)') 'Case ',istoke,' Not supported'
     call map_message(seve%e,rname,mess)
     error = .true.
     return
  end select
  ! Sanity check
  if (ouvisi.ne.multi*nvisi) then
     write(mess,'(2(a,i0))') 'Expecting up to ',nvisi,' visibilities, found ',ouvisi
     call map_message(seve%e,rname,mess)
     error = .true.
     return
  endif
end subroutine stokes_derive_chan

program uv_splitpolar
  use gkernel_interfaces
  !
  ! Split a UV table by Polarization
  !
  ! Input:
  !   A UV Table with visibilities containing Nstokes x Nchan
  ! Output
  !   A UV Table with visibilities of size Nchan, but potentially different
  !   polarization states.
  !
  character(len=filename_length) :: nami,namo
  character(len=12) :: mystoke
  logical error
  !
  call gildas_open
  call gildas_char('INPUT$',nami)
  call gildas_char('OUTPUT$',namo)
  call gildas_char('STOKES$',mystoke)
  call sic_upper(mystoke)
  call gildas_close
  call sic_upper(mystoke)
  call sub_splitpolar (nami,namo,mystoke,error)
  call gagout('I-UV_SPLITPOLAR,  Successful completion')
end program uv_splitpolar
!<FF>
subroutine sub_splitpolar(nami,namo,mystoke,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  !
  character(len=*), intent(inout) :: nami  ! Input file name
  character(len=*), intent(inout) :: namo  ! Output file name
  character(len=*), intent(in) :: mystoke  ! Desired Stoke parameterr
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='UV_SPLITPOLAR'
  type (gildas) :: hin, hou
  real(kind=4), allocatable :: din(:,:), dou(:,:)
  !
  character(len=message_length) :: mess
  !
  integer i, istoke, ivisi, is, ns, iv, jv, ier
  integer astoke(4)
  integer natom, nlead, nchan, kin, kou, next
  logical extract
  real :: re, im, we
  integer intrail, ontrail, iend, oend
  real :: da, db
  integer :: ip
  integer :: kv, iloop, nblock, nvisi, mblock, multi
  !
  error = .false.
  extract = .false.
  !
  ! Scan the requested polarization code
  if (mystoke.eq.'NONE') then
    istoke = code_stokes_none
  elseif (mystoke.eq.'ALL') then
    istoke = code_stokes_all
  else
    call gdf_stokes_code(mystoke,istoke,error)
    if (error) then
      call map_message(seve%e,rname,'Invalid Stokes '//mystoke)
      return
    endif
  endif
  !
  ! Read Header of a sorted, UV table
  call gildas_null(hin, type= 'UVT')
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (error) return
  !
  !
  call gildas_null(hou, type='UVT')
  call gdf_copy_header (hin, hou, error)
  call sic_parsef (namo,hou%file,'  ','.uvt')
  !
  hou%gil%nstokes = 1
  hou%gil%order = 0
  !
  call gdf_nitems('SPACE_GILDAS',nblock,hin%gil%dim(1))
  nblock = min(nblock,hin%gil%dim(2))
  !
  ! Check it has more than 1 polarization
  if (hin%gil%nstokes.eq.1) then
    call map_message(seve%i,rname,'Already only 1 polar per visibility ')
    ! Here need to check if a Polar column is present, through the
    ! extra columns (code_uvt_stok)
    !
    is = hin%gil%column_pointer(code_uvt_stok)
    if (is.eq.0) then
      call map_message(seve%i,rname,'Already only 1 polar in total')
      ns = 1
      astoke(ns) = hin%gil%order
      if (istoke.eq.astoke(1) .or. istoke.eq.0) then
        !
        ! OK copy the whole stuff...
        allocate (din(hin%gil%dim(1),nblock),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error ')
          error = .true.
          return
        endif
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        call gdf_create_image(hou,error)
        if (error) return
        !
        call map_message(seve%i,rname,'Replicating UV table ')
        do iloop = 1,hin%gil%dim(2),nblock
          hin%blc(2) = iloop
          hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
          hou%blc(2) = iloop
          hou%trc(2) = hin%trc(2)
          call gdf_read_data (hin,din,error)
          if (error) return
          call gdf_write_data (hou, din, error)
          if (error) return
        enddo
        call gdf_close_image(hou,error)
      else
        call map_message(seve%i,rname,'Polar '//mystoke// &
        ' does not match '//gdf_stokes_name(astoke(1)) )
        error = .true.
      endif
      !
      return
    else
      call map_message(seve%i,rname,'Perhaps more than 1 polar, scanning...')
      allocate (din(hin%gil%dim(1),nblock),dou(hou%gil%dim(1),nblock),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%i,rname,'Memory allocation error ')
        error = .true.
        return
      endif
      !
      hin%blc = 0
      hin%trc = 0
      hou%blc = 0
      hou%trc = 0
      hou%blc(2) = 1
      jv = 0
      call gdf_create_image(hou,error)
      if (error) return
      !
      ns = 0
      do iloop = 1,hin%gil%dim(2),nblock
        hin%blc(2) = iloop
        hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
        kv = hin%trc(2)-hin%blc(2)+1
        call gdf_read_data (hin,din,error)
        if (error) return
        !
        jv = 0
        do iv = 1,kv
          if (din(is,iv).ne.istoke) cycle
          jv = jv+1
          dou(:,jv) = din(:,iv)
        enddo
        !
        if (jv.gt.0) then
          hou%trc(2) = hou%blc(2)+jv-1
          call gdf_write_data(hou,dou,error)
          hou%blc(2) = hou%trc(2)+1
        endif
      enddo
      !
      ! Finalize
      hou%gil%nvisi = hou%trc(2)
      hou%gil%dim(2) = hou%trc(2)
      call gdf_update_header(hou,error)
      call gdf_close_image(hou,error)
    endif
    !
  else
    !
    ! This means each Visi has Nstokes x Nchan or Nchan x Nstokes elements
    !
    if (hin%gil%order.eq.code_chan_stok) then
      ! Nchan X Nstokes channels
      !
      call map_message(seve%i,rname,'Nchan channels X Nstokes stokes')
    else if (hin%gil%order.eq.code_stok_chan) then
      call map_message(seve%i,rname,'Nstokes stokes X  Nchan channels')
      ! Nstokes x Nchan channels
    else
      call map_message(seve%e,rname,'Inconsistent UV table state for polarization')
      error = .true.
      return
    endif
    ns = hin%gil%nstokes
    mess = 'Stokes: '
    next = 10
    do i=1,ns
      mess(next:) = gdf_stokes_name(hin%gil%stokes(i))
      next = len_trim(mess)+3
    enddo
    call map_message(seve%i,rname,mess)
    !
    !!print *,'DIN ',(din(1:10,i),i=1,10)
    !
    astoke(1:ns) = hin%gil%stokes(1:ns)
    natom = hin%gil%natom
    nchan = hin%gil%nchan
    nlead = hin%gil%nlead
    intrail = hin%gil%ntrail
    ontrail = intrail
    iend = hin%gil%dim(1)
    !
    ! The useful cases are
    if (ns.eq.2) then
      if (istoke.eq.code_stokes_i .or. istoke.eq.code_stokes_none &
        .or. istoke.eq.code_stokes_all) then
        ! Input: 2 Stokes, XX+YY or HH+VV or RR+LL, Output: I, NONE or ALL
        ! keep everything, make proper weighting
        if ( (astoke(1).eq.code_stokes_hh.and.astoke(2).eq.code_stokes_vv) &
        .or. (astoke(2).eq.code_stokes_hh.and.astoke(1).eq.code_stokes_vv) &
        .or. (astoke(1).eq.code_stokes_ll.and.astoke(2).eq.code_stokes_rr) &
        .or. (astoke(2).eq.code_stokes_ll.and.astoke(1).eq.code_stokes_rr) &
        .or. (astoke(1).eq.code_stokes_xx.and.astoke(2).eq.code_stokes_yy) &
        .or. (astoke(2).eq.code_stokes_xx.and.astoke(1).eq.code_stokes_yy) &
        ) then
          if (istoke.eq.code_stokes_all) then
            hou%gil%nvisi = 2*hin%gil%nvisi
            multi = 2
            ontrail = ontrail+1
          else
            multi = 1
            hou%gil%nvisi = hin%gil%nvisi
          endif
          call map_message(seve%i,rname,'Deriving '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
          !
          ! Shift the trailing columns
          do i=1,code_uvt_last
            if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
              hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
                & hin%gil%natom * hin%gil%nchan
            endif
          enddo
          !
        else
          call map_message(seve%e,rname,'Cannot derive '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
          error = .true.
          return
        endif
        !
        hou%gil%dim(2) = hou%gil%nvisi
        hou%gil%dim(1) = hin%gil%dim(1) - hin%gil%nchan*hin%gil%natom &
                       + ontrail-intrail
        oend = hou%gil%dim(1)+intrail-ontrail
        !!print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
        !!print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
        !!print *,'OEND ',oend, intrail, ontrail
        if (istoke.eq.code_stokes_all) then
          hou%gil%column_pointer(code_uvt_stok) = hou%gil%dim(1)
        endif
        !
        ! Here, we make the loop
        ! We make no assumption about the Stokes ordering, so allocate
        ! a block which may handle all input visibilities
        mblock = multi*nblock
        allocate (dou(hou%gil%dim(1),mblock),din(hin%gil%dim(1),nblock),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
        endif
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        call gdf_create_image(hou,error)
        if (error) return
        !
        hou%blc(2) = 1
        do iloop = 1,hin%gil%dim(2),nblock
          write(mess,*) iloop,' / ',hin%gil%dim(2),nblock
          call map_message(seve%d,rname,mess)
          hin%blc(2) = iloop
          hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
          call gdf_read_data(hin,din,error)
          if (error) return
          nvisi = hin%trc(2)-hin%blc(2)+1
          !
          if (hin%gil%order.eq.code_chan_stok) then
            ! Nchan X Nstokes channels  (ALL)
            !
            if (istoke.eq.code_stokes_all) then
              !
              jv = 0
              do iv = 1,nvisi
                jv = jv+1
                dou(1:nlead,jv) = din(1:nlead,iv)
                dou(nlead+1:nlead+natom*nchan,jv) = din(nlead+1:nlead+natom*nchan,iv)
                if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(1)
                if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                     din(nlead+1+2*natom*nchan:iend,iv)
                !
                jv = jv+1
                dou(1:nlead,jv) = din(1:nlead,iv)
                dou(nlead+1:nlead+natom*nchan,jv) = din(nlead+1+natom*nchan:nlead+2*natom*nchan,iv)
                if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(2)
                if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                     din(nlead+1+2*natom*nchan:iend,iv)
              enddo
            else
              call map_message(seve%e,rname, &
              & 'Nchan X Nstokes channel order only supported for code ALL')
              error = .true.
              return
            endif
          else
            !
            ! Nstokes x Nchan channels
            jv = 0
            do iv = 1,nvisi
              jv = jv+1
              dou(1:nlead,jv) = din(1:nlead,iv)
              kin = nlead
              kou = nlead
              !
              if (istoke.eq.code_stokes_none) then  ! Unpolarized case
  ! Stokes NONE
                do i=1,nchan
                  if (natom.eq.3) then ! Real, Image, Weight
                    if (din(kin+3,iv).gt.0) then
                      re = din(kin+1,iv) * din(kin+3,iv)
                      im = din(kin+2,iv) * din(kin+3,iv)
                      we = din(kin+3,iv)
                    else
                      re = 0
                      im = 0
                      we = 0
                    endif
                    kin = kin+natom
                    if (din(kin+3,iv).gt.0) then
                      re = re + din(kin+1,iv) * din(kin+3,iv)
                      im = im + din(kin+2,iv) * din(kin+3,iv)
                      we = we + din(kin+3,iv)
                    endif
                    if (we.ne.0) then
                      dou(kou+1:kou+1,jv) = re/we
                      dou(kou+2:kou+2,jv) = im/we
                      dou(kou+3:kou+3,jv) = we
                    else
                      dou(kou+1:kou+3,jv) = 0
                    endif
                    !
                  else if (natom.eq.2) then
                    ! Only Real Weight
                    if (din(kin+2,iv).gt.0) then
                      re = din(kin+1,iv) * din(kin+2,iv)
                      we = din(kin+2,iv)
                    else
                      re = 0
                      we = 0
                    endif
                    kin = kin+natom
                    if (din(kin+2,iv).gt.0) then
                      re = re + din(kin+1,iv) * din(kin+2,iv)
                      we = we + din(kin+2,iv)
                    endif
                    if (we.ne.0) then
                      dou(kou+1:kou+1,jv) = re/we
                      dou(kou+2:kou+2,jv) = we
                    else
                      dou(kou+1:kou+2,jv) = 0
                    endif
                  endif
                  kou = kou + natom
                  kin = kin + natom
                enddo
                !
              else if (istoke.eq.code_stokes_i) then
! Stokes I
! Stokes I is strictly Stokes I, i.e.   HH+VV or LL+RR, not
! an arbitray weighted combination.
! For unpolarized signals, to maximize sensitivity, use Stokes NONE
                do i=1,nchan
                  if (din(kin+natom,iv).gt.0)  then
                    dou(kou+1:kou+natom,jv) = din(kin+1:kin+natom-1,iv)  ! Visib
                    da = 1.0/din(kin+natom,iv) ! Noise**2
                    ip = 1
                  else
                    da = 0.0
                    ip = 0
                  endif
                  kin = kin+natom
                  if (din(kin+natom,iv).gt.0)  then
                    dou(kou+1:kou+natom-1,jv) = dou(kou+1:kou+natom-1,jv) + &
                      din(kin+1:kin+natom-1,iv)
                    db = 1.0/din(kin+natom,iv)  ! Noise**2
                    ip = ip+1
                  else
                    db = 0.0
                  endif
                  if (ip.eq.2) then
                    dou(kou+1:kou+natom-1,jv) = dou(kou+1:kou+natom-1,jv) / ip
                    dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
                  else
                    dou(kou+natom,jv) = 0.0
                  endif
                  kou = kou + natom
                  kin = kin + natom
                enddo
  !
              else
  ! Stokes ALL
                do i=1,nchan
                  dou(kou+1:kou+natom,jv) = din(kin+1:kin+natom,iv)
                  kou = kou + natom
                  kin = kin + 2*natom
                enddo
                if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(1)
                if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                     din(nlead+1+2*natom*nchan:iend,iv)
                !
                jv = jv+1
                dou(1:nlead,jv) = din(1:nlead,iv)
                kin = nlead+natom
                kou = nlead
                do i=1,nchan
                  dou(kou+1:kou+natom,jv) = din(kin+1:kin+natom,iv)
                  kou = kou + natom
                  kin = kin + 2*natom
                enddo
                if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(2)
!
              endif
!
! Fill trailing columns
              if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                   din(nlead+1+2*natom*nchan:iend,iv)
              !
            enddo
          endif
          if (jv.ne.multi*nvisi) then
            write(mess,*) 'Expecting up to ',nvisi, &
            & ' visibilities, found ',jv
            call map_message(seve%w,rname,mess)
          endif
          hou%trc(2) = hou%blc(2)+jv-1
          call gdf_write_data(hou,dou,error)
          hou%blc(2) = hou%trc(2)+1
          !
        enddo ! By block
      else
        ! Input: 2 Stokes, HH+VV or RR+LL, Output: one among these.
        ! keep only that one...
        if (istoke.eq.astoke(1)) then
          ivisi = 1
        else if (istoke.eq.astoke(2)) then
          ivisi = 2
        else
          call map_message(seve%e,rname,'Cannot extract '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
          error = .true.
          return
        endif
        call map_message(seve%e,rname,'Extracting '//mystoke// &
        ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
        !
        hou%gil%dim(1) = hin%gil%dim(1)-hin%gil%nchan*hin%gil%natom
        extract = .true.
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & hin%gil%natom * hin%gil%nchan
          endif
        enddo
      endif
      !
    else if (ns.eq.4) then
      !
      ! 4 Stokes, extract one of them
      ivisi = 0
      do i=1,ns
        if (istoke.eq.astoke(i)) then
          ivisi = i
          exit
        endif
      enddo
      if (ivisi.eq.0) then
        if (istoke.ge.1 .and. istoke.le.4) then
          ! 4 Stokes, wanted any of I,Q,U,V
          ! apply matrix conversion to compute the desired stuff
          call map_message(seve%e,rname,'Cannot yet handle 4 Stokes ')
          error = .true.
          return
        else
          call map_message(seve%e,rname,'Cannot extract '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//gdf_stokes_name(astoke(2))// &
          gdf_stokes_name(astoke(3))//' and '//gdf_stokes_name(astoke(4)) )
          error = .true.
          return
        endif
      else
        call map_message(seve%i,rname,'Extracting '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//gdf_stokes_name(astoke(2))//  &
          gdf_stokes_name(astoke(3))//' and '//gdf_stokes_name(astoke(4)))
        extract = .true.
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & 3 * hin%gil%natom * hin%gil%nchan
          endif
        enddo
      endif
    endif
    !
    ! The extraction code makes no assumption about the Stokes order.
    !
    if (extract) then
      !
      call gdf_create_image(hou,error)
      if (error) return
      !
      allocate (dou(hou%gil%dim(1),nblock),din(hin%gil%dim(1),nblock),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error ')
        error = .true.
        return
      endif
      hin%blc = 0
      hou%trc = 0
      !
      hou%blc(2) = 1
      do iloop = 1,hin%gil%dim(2),nblock
        hin%blc(2) = iloop
        hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
        kv = hin%trc(2)-hin%blc(2)+1
        call gdf_read_data(hin,din,error)
        if (error) return
        !
        if (hin%gil%order.eq.code_chan_stok) then
          ! Nchan X Nstokes channels
          do iv = 1,hin%gil%nvisi
            dou(1:nlead,iv) = din(1:nlead,iv)
            dou(nlead+1:nlead+natom*nchan,iv) = &
            & din(nlead+1+(ivisi-1)*natom*nchan:nlead+ivisi*natom*nchan,iv)
            if (intrail.gt.0) dou(1+nlead+natom*nchan:,iv) = din(nlead+1+ns*natom*nchan:,iv)
          enddo
        else
          ! Nstokes x Nchan channels
          do iv = 1,hin%gil%nvisi
            dou(1:nlead,iv) = din(1:nlead,iv)
            kin = nlead+(ivisi-1)*natom
            kou = nlead
            do i=1,nchan
              dou(kou+1:kou+natom,iv) = din(kin+1:kin+natom,iv)
              kou = kou + natom
              kin = kin + ns*natom
            enddo
            if (intrail.gt.0) dou(1+nlead+natom*nchan:,iv) = din(nlead+1+ns*natom*nchan:,iv)
            !
          enddo
        endif
        hou%trc(2) = hou%blc(2)+kv-1
        call gdf_write_data(hou,dou,error)
        hou%blc(2) = hou%trc(2)+1
        !
      enddo
    endif
    call gdf_close_image(hou,error)
  endif
  !
end subroutine sub_splitpolar

program gauss_compress
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	COMPRESS a data cube along its TWO first dimensions, by Fourier
  !     Transform
  !---------------------------------------------------------------------
  ! Local
  real, parameter :: eps = 2.e-7
  !
  character(len=filename_length) :: namex,namey
  integer :: i,j,ier,n,nx,ny,lx,ly,mx,my,sx,sy,nexp
  real :: rexp
  real(8) :: bmaj,bmin,pa
  logical :: error
  integer :: ndim,dim(2)
  real, allocatable :: ipi(:,:), ipj(:,:)
  complex, allocatable :: ips(:,:), ipl(:,:) 
  real, allocatable :: work(:)
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('INPUT_MAP$',namey)
  call gildas_char('OUTPUT_MAP$',namex)
  call gildas_inte('COMPRESS$',nexp,1)
  call gildas_dble('MAJOR$',bmaj,1)
  call gildas_dble('MINOR$',bmin,1)
  call gildas_dble('PA$',pa,1)
  call gildas_close
  !
  if (nexp.lt.2. .or. nexp.gt.128) then
    write(6,*) 'E-GAUSS_COMPRESS,  Invalid compression ',nexp
    goto 100
  endif
  !
  n = len_trim(namey)
  if (n.eq.0) goto 100
  y%gil%ndim = 4
  y%gil%form = fmt_r4
  call gdf_read_gildas(y,namey(1:n),'.lmv',error, rank=4, data=.false.)
  if (error) then
    write(6,*) 'F-GAUSS_COMPRESS,  Cannot read input file'
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  !
  nx = y%gil%dim(1)
  ny = y%gil%dim(2)
  lx = 2*nx
  ly = 2*ny
  !
  ! Get work space
  rexp = nexp
  sx = nint(float(y%gil%dim(1))/rexp)
  sy = nint(float(y%gil%dim(2))/rexp)
  rexp = max( float(y%gil%dim(1))/float(sx) , float(y%gil%dim(2))/float(sy))
  x%gil%dim(1) = nint(y%gil%dim(1)/rexp)
  x%gil%dim(2) = nint(y%gil%dim(2)/rexp)
  mx = x%gil%dim(1)
  my = x%gil%dim(2)
  sx = 2*mx
  sy = 2*my
  !
  allocate(ips(sx,sy), ipj(sx,sy), ipi(lx,ly), ipl(lx,ly), work(2*max(lx,ly)), stat=ier)
  if (ier.ne.0) goto 100
  allocate(x%r2d(mx,my), y%r2d(nx,ny), stat=ier)
  if (ier.ne.0) goto 100
  !
  ! Transform coordinates (1,1) ---> (1,1)
  x%gil%inc(1:2) = y%gil%inc(1:2)*float(y%gil%dim(1:2))/float(x%gil%dim(1:2))
  x%gil%ref(1:2) = 1.0d0
  x%gil%val(1:2) = (1.0d0-y%gil%ref(1:2))*y%gil%inc(1:2)+y%gil%val(1:2)
  !
  ! Transform back
  x%gil%ref(1:2) = (y%gil%val(1:2) - x%gil%val(1:2)) / x%gil%inc(1:2) + x%gil%ref(1:2)
  x%gil%val(1:2) = y%gil%val(1:2)
  !
  ! Create Output file
  n = len_trim(namex)
  if (n.eq.0) goto 100
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  x%gil%extr_words = 0                   ! No extrema
  !
  ! Squeezee dummy trailing dimensions
  do i=4,1,-1
    if (x%gil%dim(i).le.1) then
      x%gil%ndim = i-1
    else
      exit
    endif
  enddo
  !
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-GAUSS_COMPRESS,  Cannot create output image'
    goto 100
  endif
  !
  ! Setup FFTW
  ndim = 2
  dim(1) = lx
  dim(2) = ly
  call fourt_plan(ipl,dim,ndim,1,0)
  dim(1) = sx
  dim(2) = sy
  call fourt_plan(ips,dim,ndim,-1,1)
  !
  ! Now loop over planes
  do j=1,y%gil%dim(4)
    y%blc(4) = j
    y%trc(4) = j
    do i=1,y%gil%dim(3)
      y%blc(3) = i
      y%trc(3) = i
      x%blc = y%blc
      x%trc = y%trc
      call gdf_read_data(y,y%r2d,error)
      call copyr (nx,ny,y%r2d,lx,ly,ipi)
      call compress_gauss (   &
     &      lx,ly,ipi,ipl,   &
     &      sx,sy,ipj,ips,   &
     &      work,bmaj,bmin,pa,x%gil%inc(1),x%gil%inc(2) )
      call copys (sx,sy,ipj,mx,my,x%r2d)
      call gdf_write_data(x,x%r2d,error)
    enddo
  enddo
  !
  call gagout('S-GAUSS_COMPRESS,  Successful completion')
  call sysexi (1)
100 call sysexi (fatale)
end program gauss_compress
!
subroutine compress_gauss(nx,ny,large,wl,mx,my,small,ws,work,   &
     &    bmaj,bmin,pa,incx,incy)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !	Compress an image through FT truncation
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real :: large(nx,ny)              !
  complex :: wl(nx,ny)              !
  integer :: mx                     !
  integer :: my                     !
  real :: small(mx,my)              !
  complex :: ws(mx,my)              !
  real :: work(*)                   !
  real(8) :: bmaj                    !
  real(8) :: bmin                    !
  real(8) :: pa                      !
  real(8) :: incx                    !
  real(8) :: incy                    !
  ! Local
  integer :: j,ndim,dim(2)
  real :: fact
  !
  wl = cmplx(large,0.0)
  !
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  call fourt(wl,dim,ndim,1,0,work)
  !
  ! Keep inner area
  do j=1,my/2
    call r4tor4 (wl(1,j),ws(1,j),mx)
    call r4tor4 (wl(1+nx-mx/2,j),ws(mx/2+1,j),mx)
  enddo
  do j=my/2+1,my
    call r4tor4 (wl(1,j+ny-my),ws(1,j),mx)
    call r4tor4 (wl(1+nx-mx/2,j+ny-my),ws(mx/2+1,j),mx)
  enddo
  !
  ! Gaussian Smoothing
  call mulgau(ws,mx,my,bmaj,bmin,pa,incx,incy)
  !
  ! Transform back
  dim(1) = mx
  dim(2) = my
  call fourt (ws,dim,ndim,-1,1,work)
  fact = 1.0/(nx*ny)
  small = real(ws)*fact
end subroutine compress_gauss
!
subroutine copyr(mx,my,r,nx,ny,c)
  !---------------------------------------------------------------------
  !     Insert Real array R(NX,NY) into Real array C(MX,MY)
  !---------------------------------------------------------------------
  integer :: mx                     !
  integer :: my                     !
  real :: r(mx,my)                  !
  integer :: nx                     !
  integer :: ny                     !
  real :: c(nx,ny)                  !
  ! Local
  integer :: i,j,i0,j0
  !
  c(:,:) = 0.0
  !
  i0 = nx/2-mx/2
  j0 = ny/2-my/2
  !
  do j=1,my
    do i=1,mx
      c(i+i0,j+j0) = r(i,j)
    enddo
  enddo
end subroutine copyr
!
subroutine copys (mx,my,r,nx,ny,c)
  !---------------------------------------------------------------------
  !     Extract from Real array R(NX,NY) the Real array C(MX,MY)
  !---------------------------------------------------------------------
  integer :: mx                     !
  integer :: my                     !
  real :: r(mx,my)                  !
  integer :: nx                     !
  integer :: ny                     !
  real :: c(nx,ny)                  !
  ! Local
  integer :: i,j,i0,j0
  !
  i0 = mx/2-nx/2
  j0 = my/2-ny/2
  !
  do j=1,ny
    do i=1,nx
      c(i,j) = r(i+i0,j+j0)
    enddo
  enddo
end subroutine copys
!
subroutine mulgau(data,nx,ny,bmaj,bmin,pa,x_inc1,x_inc2)
  !---------------------------------------------------------------------
  ! GDF	Multiply the TF of an image by the TF of
  !	a convolving gaussian function. BMAJ and BMIN are the
  !	widths of the original gaussian. PA is the position angle of major
  !	axis (from north towards east)
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  complex :: data(nx,ny)            !
  real(8) :: bmaj                    !
  real(8) :: bmin                    !
  real(8) :: pa                      !
  real(8) :: x_inc1                  !
  real(8) :: x_inc2                  !
  ! Local
  integer :: i,j,nx1,nx2
  real :: amaj,amin,fact,cx,cy,sx,sy
  logical :: norot,rot90
  real(8) :: rpa
  real(8), parameter :: pi=3.141592653589793d0
  real(4), parameter :: eps=1.e-7
  !
  norot = ( abs(mod(pa,180.d0)).le.eps)
  rot90 = ( abs(mod(pa,180.d0)-90.d0).le.eps)
  amaj = bmaj*pi/(2.*sqrt(log(2.)))
  amin = bmin*pi/(2.*sqrt(log(2.)))
  rpa = pa*pi/180.d0
  !
  cx = cos(rpa)/nx*amin
  cy = cos(rpa)/ny*amaj
  sx = sin(rpa)/nx*amaj
  sy = sin(rpa)/ny*amin
  !
  ! Convert map units to pixels
  cx = cx / x_inc1
  cy = cy / x_inc2
  sx = sx / x_inc1
  sy = sy / x_inc2
  nx2 = nx/2
  nx1 = nx2+1
  !
  ! Optimised code for Position Angle 0 degrees
  if (norot) then
    do j=1,ny/2
      do i=1,nx2
        fact = (float(j-1)*cy)**2 + (float(i-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(j-1)*cy)**2 + (float(i-nx-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(j-ny-1)*cy)**2 + (float(i-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(j-ny-1)*cy)**2 + (float(i-nx-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    !
    ! Optimised code for Position Angle 90 degrees
  elseif (rot90) then
    do j=1,ny/2
      do i=1,nx2
        fact = (float(i-1)*sx)**2 +(float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx)**2 + (float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(i-1)*sx)**2 + (float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx)**2 + (float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    !
    ! General case of a rotated elliptical gaussian
  else
    do j=1,ny/2
      do i=1,nx2
        fact = (float(i-1)*sx + float(j-1)*cy)**2 +   &
     &          (-float(i-1)*cx + float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx + float(j-1)*cy)**2 +   &
     &          ( -float(i-nx-1)*cx + float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(i-1)*sx + float(j-ny-1)*cy)**2 +   &
     &          ( -float(i-1)*cx + float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx   &
     &          + float(j-ny-1)*cy)**2 +   &
     &          ( -float(i-nx-1)*cx + float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
  endif
end subroutine mulgau

*DECK SODS
      SUBROUTINE SODS (A, X, B, NEQ, NUK, NRDA, IFLAG, WORK, IWORK)
C***BEGIN PROLOGUE  SODS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SODS-S)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     SODS solves the overdetermined system of linear equations A X = B,
C     where A is NEQ by NUK and NEQ .GE. NUK. If rank A = NUK,
C     X is the UNIQUE least squares solution vector. That is,
C              R(1)**2 + ..... + R(NEQ)**2 = minimum
C     where R is the residual vector  R = B - A X.
C     If rank A .LT. NUK , the least squares solution of minimal
C     length can be provided.
C     SODS is an interfacing routine which calls subroutine LSSODS
C     for the solution. LSSODS in turn calls subroutine ORTHOL and
C     possibly subroutine OHTROR for the decomposition of A by
C     orthogonal transformations. In the process, ORTHOL calls upon
C     subroutine CSCALE for scaling.
C
C **********************************************************************
C   Input
C **********************************************************************
C
C     A -- Contains the matrix of NEQ equations in NUK unknowns and must
C          be dimensioned NRDA by NUK. The original A is destroyed
C     X -- Solution array of length at least NUK
C     B -- Given constant vector of length NEQ, B is destroyed
C     NEQ -- Number of equations, NEQ greater or equal to 1
C     NUK -- Number of columns in the matrix (which is also the number
C            of unknowns), NUK not larger than NEQ
C     NRDA -- Row dimension of A, NRDA greater or equal to NEQ
C     IFLAG -- Status indicator
C            =0 For the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is treated as exact
C           =-K For the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is assumed to be
C               accurate to about K digits
C            =1 For subsequent calls whenever the matrix A has already
C               been decomposed (problems with new vectors B but
C               same matrix a can be handled efficiently)
C     WORK(*),IWORK(*) -- Arrays for storage of internal information,
C                     WORK must be dimensioned at least  2 + 5*NUK
C                     IWORK must be dimensioned at least NUK+2
C     IWORK(2) -- Scaling indicator
C                 =-1 If the matrix A is to be pre-scaled by
C                 columns when appropriate
C                 If the scaling indicator is not equal to -1
C                 no scaling will be attempted
C              For most problems scaling will probably not be necessary
C
C **********************************************************************
C   OUTPUT
C **********************************************************************
C
C     IFLAG -- Status indicator
C            =1 If solution was obtained
C            =2 If improper input is detected
C            =3 If rank of matrix is less than NUK
C               If the minimal length least squares solution is
C               desired, simply reset IFLAG=1 and call the code again
C     X -- Least squares solution of  A X = B
C     A -- Contains the strictly upper triangular part of the reduced
C           matrix and the transformation information
C     WORK(*),IWORK(*) -- Contains information needed on subsequent
C                         Calls (IFLAG=1 case on input) which must not
C                         be altered
C                         WORK(1) contains the Euclidean norm of
C                         the residual vector
C                         WORK(2) contains the Euclidean norm of
C                         the solution vector
C                         IWORK(1) contains the numerically determined
C                         rank of the matrix A
C
C **********************************************************************
C
C***SEE ALSO  BVSUP
C***REFERENCES  G. Golub, Numerical methods for solving linear least
C                 squares problems, Numerische Mathematik 7, (1965),
C                 pp. 206-216.
C               P. Businger and G. Golub, Linear least squares
C                 solutions by Householder transformations, Numerische
C                 Mathematik  7, (1965), pp. 269-276.
C               H. A. Watts, Solving linear least squares problems
C                 using SODS/SUDS/CODS, Sandia Report SAND77-0683,
C                 Sandia Laboratories, 1977.
C***ROUTINES CALLED  LSSODS
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SODS
      DIMENSION A(NRDA,*),X(*),B(*),WORK(*),IWORK(*)
C
C***FIRST EXECUTABLE STATEMENT  SODS
      ITER=0
      IS=2
      IP=3
      KS=2
      KD=3
      KZ=KD+NUK
      KV=KZ+NUK
      KT=KV+NUK
      KC=KT+NUK
C
      CALL LSSODS(A,X,B,NEQ,NUK,NRDA,IFLAG,IWORK(1),IWORK(IS),A,
     1            WORK(KD),IWORK(IP),ITER,WORK(1),WORK(KS),
     2            WORK(KZ),B,WORK(KV),WORK(KT),WORK(KC))
C
      RETURN
      END
*DECK SOMN
      SUBROUTINE SOMN (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, AP,
     +   EMAP, DZ, CSAV, RWORK, IWORK)
C***BEGIN PROLOGUE  SOMN
C***PURPOSE  Preconditioned Orthomin Sparse Iterative Ax=b Solver.
C            Routine to solve a general linear system  Ax = b  using
C            the Preconditioned Orthomin method.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SOMN-S, DOMN-D)
C***KEYWORDS  ITERATIVE PRECONDITION, NON-SYMMETRIC LINEAR SYSTEM,
C             ORTHOMIN, SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N, NELT, IA(NELT), JA(NELT), ISYM, NSAVE, ITOL, ITMAX
C     INTEGER  ITER, IERR, IUNIT, IWORK(USER DEFINED)
C     REAL     B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N)
C     REAL     P(N,0:NSAVE), AP(N,0:NSAVE), EMAP(N,0:NSAVE)
C     REAL     DZ(N), CSAV(NSAVE), RWORK(USER DEFINED)
C     EXTERNAL MATVEC, MSOLVE
C
C     CALL SOMN(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
C    $     NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R,
C    $     Z, P, AP, EMAP, DZ, CSAV, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer.
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right-hand side vector.
C X      :INOUT    Real X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below, for more
C         details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         Y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X
C         upon return X is an input vector, NELT is the number of
C         non-zeros in the SLAP IA, JA, A storage for the matrix A.
C         ISYM is a flag which, if non-zero, denotest that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R for
C         Z given R with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays).  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a real array that can
C         be used to pass necessary preconditioning information and/or
C         workspace to MSOLVE.  IWORK is an integer work array for
C         the same purpose as RWORK.
C NSAVE  :IN       Integer.
C         Number of  direction vectors to save and orthogonalize
C         against.  NSAVE >= 0.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /SSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /SSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Real.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Real.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*R1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Breakdown of method detected.
C                       (p,Ap) < epsilon**2.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Real R(N).
C Z      :WORK     Real Z(N).
C P      :WORK     Real P(N,0:NSAVE).
C AP     :WORK     Real AP(N,0:NSAVE).
C EMAP   :WORK     Real EMAP(N,0:NSAVE).
C DZ     :WORK     Real DZ(N).
C CSAV   :WORK     Real CSAV(NSAVE)
C         Real arrays used for workspace.
C RWORK  :WORK     Real RWORK(USER DEFINED).
C         Real array that can be used for workspace in MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used for workspace in MSOLVE.
C
C *Description
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK)  in  some fashion.   The SLAP
C       routines SSDOMN and SSLUOM are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first in each "column") and are  stored in the real array A.
C       In other words,  for  each column    in the matrix   put the
C       diagonal  entry  in A.   Then   put  in the  other  non-zero
C       elements going   down the  column (except  the  diagonal) in
C       order.  The IA array holds the row index  for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning   of   each  column.      That is,   IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)  points to the
C       end of the ICOL-th column.  Note that we always have JA(N+1)
C       = NELT+1, where N is the number of columns in the matrix and
C       NELT is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  SSDOMN, SSLUOM, ISSOMN
C***REFERENCES  1. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  ISSOMN, R1MACH, SAXPY, SCOPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC and MSOLVE from ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of reference.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C   921113  Corrected C***CATEGORY line.  (FNF)
C   930326  Removed unused variable.  (FNF)
C***END PROLOGUE  SOMN
C     .. Scalar Arguments ..
      REAL ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT, NSAVE
C     .. Array Arguments ..
      REAL A(NELT), AP(N,0:NSAVE), B(N), CSAV(NSAVE), DZ(N),
     +     EMAP(N,0:NSAVE), P(N,0:NSAVE), R(N), RWORK(*), X(N), Z(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      REAL AK, AKDEN, AKNUM, BKL, BNRM, FUZZ, SOLNRM
      INTEGER I, IP, IPO, K, L, LMAX
C     .. External Functions ..
      REAL R1MACH, SDOT
      INTEGER ISSOMN
      EXTERNAL R1MACH, SDOT, ISSOMN
C     .. External Subroutines ..
      EXTERNAL SAXPY, SCOPY
C     .. Intrinsic Functions ..
      INTRINSIC ABS, MIN, MOD
C***FIRST EXECUTABLE STATEMENT  SOMN
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      FUZZ = R1MACH(3)
      IF( TOL.LT.500*FUZZ ) THEN
         TOL = 500*FUZZ
         IERR = 4
      ENDIF
      FUZZ = FUZZ*FUZZ
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I)  = B(I) - R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISSOMN(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, NSAVE,
     $     ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $     R, Z, P, AP, EMAP, DZ, CSAV,
     $     RWORK, IWORK, AK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C
C         ***** iteration loop *****
C
CVD$R NOVECTOR
CVD$R NOCONCUR
      DO 100 K = 1, ITMAX
         ITER = K
         IP = MOD( ITER-1, NSAVE+1 )
C
C         calculate direction vector p, a*p, and (m-inv)*a*p,
C         and save if desired.
         CALL SCOPY(N, Z, 1, P(1,IP), 1)
         CALL MATVEC(N, P(1,IP), AP(1,IP), NELT, IA, JA, A, ISYM)
         CALL MSOLVE(N, AP(1,IP), EMAP(1,IP), NELT, IA, JA, A, ISYM,
     $        RWORK, IWORK)
         IF( NSAVE.EQ.0 ) THEN
            AKDEN = SDOT(N, EMAP, 1, EMAP, 1)
         ELSE
            IF( ITER.GT.1 ) THEN
               LMAX = MIN( NSAVE, ITER-1 )
               DO 20 L = 1, LMAX
                  IPO = MOD(IP+(NSAVE+1-L),NSAVE+1)
                  BKL = SDOT(N, EMAP(1,IP), 1, EMAP(1,IPO), 1)
                  BKL = BKL*CSAV(L)
                  CALL SAXPY(N, -BKL,    P(1,IPO), 1,    P(1,IP), 1)
                  CALL SAXPY(N, -BKL,   AP(1,IPO), 1,   AP(1,IP), 1)
                  CALL SAXPY(N, -BKL, EMAP(1,IPO), 1, EMAP(1,IP), 1)
 20            CONTINUE
               IF( NSAVE.GT.1 ) THEN
                  DO 30 L = NSAVE-1, 1, -1
                     CSAV(L+1) = CSAV(L)
 30               CONTINUE
               ENDIF
            ENDIF
            AKDEN = SDOT(N, EMAP(1,IP), 1, EMAP(1,IP), 1)
            IF( ABS(AKDEN).LT.FUZZ ) THEN
               IERR = 6
               RETURN
            ENDIF
            CSAV(1) = 1.0E0/AKDEN
C
C         calculate coefficient ak, new iterate x, new residual r, and
C         new pseudo-residual z.
         ENDIF
         AKNUM = SDOT(N, Z, 1, EMAP(1,IP), 1)
         AK = AKNUM/AKDEN
         CALL SAXPY(N,  AK,    P(1,IP), 1, X, 1)
         CALL SAXPY(N, -AK,   AP(1,IP), 1, R, 1)
         CALL SAXPY(N, -AK, EMAP(1,IP), 1, Z, 1)
C
C         check stopping criterion.
         IF( ISSOMN(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, NSAVE,
     $        ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $        R, Z, P, AP, EMAP, DZ, CSAV,
     $        RWORK, IWORK, AK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C
C         Stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
C
 200  RETURN
C------------- LAST LINE OF SOMN FOLLOWS ----------------------------
      END
*DECK SOPENM
      SUBROUTINE SOPENM (IPAGE, LPAGE)
C***BEGIN PROLOGUE  SOPENM
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      ALL (SOPENM-A)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     1. OPEN UNIT NUMBER IPAGEF AS A RANDOM ACCESS FILE.
C
C     2. THE RECORD LENGTH IS CONSTANT=LPG.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890605  Corrected references to XERRWV.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  SOPENM
      CHARACTER*8 XERN1
C
C***FIRST EXECUTABLE STATEMENT  SOPENM
      IPAGEF=IPAGE
      LPG   =LPAGE
      OPEN(UNIT=IPAGEF,IOSTAT=IOS,ERR=100,STATUS='UNKNOWN',
     *ACCESS='DIRECT',FORM='UNFORMATTED',RECL=LPG)
      RETURN
C
 100  WRITE (XERN1, '(I8)') IOS
      CALL XERMSG ('SLATEC', 'SOPENM',
     *   'IN SPLP, OPEN HAS ERROR FLAG = ' // XERN1, 100, 1)
      RETURN
      END
*DECK SORTH
      SUBROUTINE SORTH (VNEW, V, HES, N, LL, LDHES, KMP, SNORMW)
C***BEGIN PROLOGUE  SORTH
C***SUBSIDIARY
C***PURPOSE  Internal routine for SGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SORTH-S, DORTH-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This routine  orthogonalizes  the  vector  VNEW  against the
C        previous KMP  vectors in the   V array.  It uses  a modified
C        Gram-Schmidt   orthogonalization procedure with  conditional
C        reorthogonalization.
C
C *Usage:
C      INTEGER N, LL, LDHES, KMP
C      REAL VNEW(N), V(N,LL), HES(LDHES,LL), SNORMW
C
C      CALL SORTH(VNEW, V, HES, N, LL, LDHES, KMP, SNORMW)
C
C *Arguments:
C VNEW   :INOUT    Real VNEW(N)
C         On input, the vector of length N containing a scaled
C         product of the Jacobian and the vector V(*,LL).
C         On output, the new vector orthogonal to V(*,i0) to V(*,LL),
C         where i0 = max(1, LL-KMP+1).
C V      :IN       Real V(N,LL)
C         The N x LL array containing the previous LL
C         orthogonal vectors V(*,1) to V(*,LL).
C HES    :INOUT    Real HES(LDHES,LL)
C         On input, an LL x LL upper Hessenberg matrix containing,
C         in HES(I,K), K.lt.LL, the scaled inner products of
C         A*V(*,K) and V(*,i).
C         On return, column LL of HES is filled in with
C         the scaled inner products of A*V(*,LL) and V(*,i).
C N      :IN       Integer
C         The order of the matrix A, and the length of VNEW.
C LL     :IN       Integer
C         The current order of the matrix HES.
C LDHES  :IN       Integer
C         The leading dimension of the HES array.
C KMP    :IN       Integer
C         The number of previous vectors the new vector VNEW
C         must be made orthogonal to (KMP .le. MAXL).
C SNORMW :OUT      REAL
C         Scalar containing the l-2 norm of VNEW.
C
C***SEE ALSO  SGMRES
C***ROUTINES CALLED  SAXPY, SDOT, SNRM2
C***REVISION HISTORY  (YYMMDD)
C   871001  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910506  Made subsidiary to SGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  SORTH
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      REAL SNORMW
      INTEGER KMP, LDHES, LL, N
C     .. Array Arguments ..
      REAL HES(LDHES,*), V(N,*), VNEW(*)
C     .. Local Scalars ..
      REAL ARG, SUMDSQ, TEM, VNRM
      INTEGER I, I0
C     .. External Functions ..
      REAL SDOT, SNRM2
      EXTERNAL SDOT, SNRM2
C     .. External Subroutines ..
      EXTERNAL SAXPY
C     .. Intrinsic Functions ..
      INTRINSIC MAX, SQRT
C***FIRST EXECUTABLE STATEMENT  SORTH
C
C         Get norm of unaltered VNEW for later use.
C
      VNRM = SNRM2(N, VNEW, 1)
C   -------------------------------------------------------------------
C         Perform the modified Gram-Schmidt procedure on VNEW =A*V(LL).
C         Scaled inner products give new column of HES.
C         Projections of earlier vectors are subtracted from VNEW.
C   -------------------------------------------------------------------
      I0 = MAX(1,LL-KMP+1)
      DO 10 I = I0,LL
         HES(I,LL) = SDOT(N, V(1,I), 1, VNEW, 1)
         TEM = -HES(I,LL)
         CALL SAXPY(N, TEM, V(1,I), 1, VNEW, 1)
 10   CONTINUE
C   -------------------------------------------------------------------
C         Compute SNORMW = norm of VNEW.  If VNEW is small compared
C         to its input value (in norm), then reorthogonalize VNEW to
C         V(*,1) through V(*,LL).  Correct if relative correction
C         exceeds 1000*(unit roundoff).  Finally, correct SNORMW using
C         the dot products involved.
C   -------------------------------------------------------------------
      SNORMW = SNRM2(N, VNEW, 1)
      IF (VNRM + 0.001E0*SNORMW .NE. VNRM) RETURN
      SUMDSQ = 0
      DO 30 I = I0,LL
         TEM = -SDOT(N, V(1,I), 1, VNEW, 1)
         IF (HES(I,LL) + 0.001E0*TEM .EQ. HES(I,LL)) GO TO 30
         HES(I,LL) = HES(I,LL) - TEM
         CALL SAXPY(N, TEM, V(1,I), 1, VNEW, 1)
         SUMDSQ = SUMDSQ + TEM**2
 30   CONTINUE
      IF (SUMDSQ .EQ. 0.0E0) RETURN
      ARG = MAX(0.0E0,SNORMW**2 - SUMDSQ)
      SNORMW = SQRT(ARG)
C
      RETURN
C------------- LAST LINE OF SORTH FOLLOWS ----------------------------
      END
*DECK SOS
      SUBROUTINE SOS (FNC, NEQ, X, RTOLX, ATOLX, TOLF, IFLAG, RW, LRW,
     +   IW, LIW)
C***BEGIN PROLOGUE  SOS
C***PURPOSE  Solve a square system of nonlinear equations.
C***LIBRARY   SLATEC
C***CATEGORY  F2A
C***TYPE      SINGLE PRECISION (SOS-S, DSOS-D)
C***KEYWORDS  BROWN'S METHOD, NEWTON'S METHOD, NONLINEAR EQUATIONS,
C             ROOTS, SOLUTIONS
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     SOS solves a system of NEQ simultaneous nonlinear equations in
C     NEQ unknowns.  That is, it solves the problem   F(X)=0
C     where X is a vector with components  X(1),...,X(NEQ)  and  F
C     is a vector of nonlinear functions.  Each equation is of the form
C
C               F (X(1),...,X(NEQ))=0     for K=1,...,NEQ.
C                K
C
C     The algorithm is based on an iterative method which is a
C     variation of Newton's method using Gaussian elimination
C     in a manner similar to the Gauss-Seidel process.  Convergence
C     is roughly quadratic.  All partial derivatives required by
C     the algorithm are approximated by first difference quotients.
C     The convergence behavior of this code is affected by the
C     ordering of the equations, and it is advantageous to place linear
C     and mildly nonlinear equations first in the ordering.
C
C     Actually, SOS is merely an interfacing routine for
C     calling subroutine SOSEQS which embodies the solution
C     algorithm.  The purpose of this is to add greater
C     flexibility and ease of use for the prospective user.
C
C     SOSEQS calls the accompanying routine SOSSOL, which solves special
C     triangular linear systems by back-substitution.
C
C     The user must supply a function subprogram which evaluates the
C     K-th equation only (K specified by SOSEQS) for each call
C     to the subprogram.
C
C     SOS represents an implementation of the mathematical algorithm
C     described in the references below.  It is a modification of the
C     code SOSNLE written by H. A. Watts in 1973.
C
C **********************************************************************
C   -Input-
C
C     FNC -Name of the function program which evaluates the equations.
C          This name must be in an EXTERNAL statement in the calling
C          program.  The user must supply FNC in the form FNC(X,K),
C          where X is the solution vector (which must be dimensioned
C          in FNC) and FNC returns the value of the K-th function.
C
C     NEQ -Number of equations to be solved.
C
C     X   -Solution vector.  Initial guesses must be supplied.
C
C     RTOLX -Relative error tolerance used in the convergence criteria.
C          Each solution component X(I) is checked by an accuracy test
C          of the form   ABS(X(I)-XOLD(I)) .LE. RTOLX*ABS(X(I))+ATOLX,
C          where XOLD(I) represents the previous iteration value.
C          RTOLX must be non-negative.
C
C     ATOLX -Absolute error tolerance used in the convergence criteria.
C          ATOLX must be non-negative.  If the user suspects some
C          solution component may be zero, he should set ATOLX to an
C          appropriate (depends on the scale of the remaining variables)
C          positive value for better efficiency.
C
C     TOLF -Residual error tolerance used in the convergence criteria.
C          Convergence will be indicated if all residuals (values of the
C          functions or equations) are not bigger than TOLF in
C          magnitude.  Note that extreme care must be given in assigning
C          an appropriate value for TOLF because this convergence test
C          is dependent on the scaling of the equations.  An
C          inappropriate value can cause premature termination of the
C          iteration process.
C
C     IFLAG -Optional input indicator.  You must set  IFLAG=-1  if you
C          want to use any of the optional input items listed below.
C          Otherwise set it to zero.
C
C     RW  -A REAL work array which is split apart by SOS and used
C          internally by SOSEQS.
C
C     LRW -Dimension of the RW array.  LRW must be at least
C                    1 + 6*NEQ + NEQ*(NEQ+1)/2
C
C     IW  -An INTEGER work array which is split apart by SOS and used
C          internally by SOSEQS.
C
C     LIW -Dimension of the IW array. LIW must be at least  3 + NEQ.
C
C   -Optional Input-
C
C     IW(1) -Internal printing parameter.  You must set  IW(1)=-1  if
C          you want the intermediate solution iterates to be printed.
C
C     IW(2) -Iteration limit.  The maximum number of allowable
C          iterations can be specified, if desired.  To override the
C          default value of 50, set IW(2) to the number wanted.
C
C     Remember, if you tell the code that you are using one of the
C               options (by setting IFLAG=-1), you must supply values
C               for both IW(1) and IW(2).
C
C **********************************************************************
C   -Output-
C
C     X   -Solution vector.
C
C     IFLAG -Status indicator
C
C                         *** Convergence to a Solution ***
C
C          1 Means satisfactory convergence to a solution was achieved.
C            Each solution component X(I) satisfies the error tolerance
C            test   ABS(X(I)-XOLD(I)) .LE. RTOLX*ABS(X(I))+ATOLX.
C
C          2 Means procedure converged to a solution such that all
C            residuals are at most TOLF in magnitude,
C            ABS(FNC(X,I)) .LE. TOLF.
C
C          3 Means that conditions for both IFLAG=1 and IFLAG=2 hold.
C
C          4 Means possible numerical convergence.  Behavior indicates
C            limiting precision calculations as a result of user asking
C            for too much accuracy or else convergence is very slow.
C            Residual norms and solution increment norms have
C            remained roughly constant over several consecutive
C            iterations.
C
C                         *** Task Interrupted ***
C
C          5 Means the allowable number of iterations has been met
C            without obtaining a solution to the specified accuracy.
C            Very slow convergence may be indicated.  Examine the
C            approximate solution returned and see if the error
C            tolerances seem appropriate.
C
C          6 Means the allowable number of iterations has been met and
C            the iterative process does not appear to be converging.
C            A local minimum may have been encountered or there may be
C            limiting precision difficulties.
C
C          7 Means that the iterative scheme appears to be diverging.
C            Residual norms and solution increment norms have
C            increased over several consecutive iterations.
C
C                         *** Task Cannot Be Continued ***
C
C          8 Means that a Jacobian-related matrix was singular.
C
C          9 Means improper input parameters.
C
C          *** IFLAG should be examined after each call to   ***
C          *** SOS with the appropriate action being taken.  ***
C
C
C     RW(1) -Contains a norm of the residual.
C
C     IW(3) -Contains the number of iterations used by the process.
C
C **********************************************************************
C***REFERENCES  K. M. Brown, Solution of simultaneous nonlinear
C                 equations, Algorithm 316, Communications of the
C                 A.C.M. 10, (1967), pp. 728-729.
C               K. M. Brown, A quadratically convergent Newton-like
C                 method based upon Gaussian elimination, SIAM Journal
C                 on Numerical Analysis 6, (1969), pp. 560-569.
C***ROUTINES CALLED  SOSEQS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Convert XERRWV calls to XERMSG calls, changed Prologue
C           comments to agree with DSOS.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SOS
      DIMENSION X(*), RW(*), IW(*)
      CHARACTER*8 XERN1
      CHARACTER*16 XERN3, XERN4
      EXTERNAL FNC
C***FIRST EXECUTABLE STATEMENT  SOS
      INPFLG = IFLAG
C
C     CHECK FOR VALID INPUT
C
      IF (NEQ .LE. 0) THEN
         WRITE (XERN1, '(I8)') NEQ
         CALL XERMSG ('SLATEC', 'SOS', 'THE NUMBER OF EQUATIONS ' //
     *      'MUST BE A POSITIVE INTEGER.  YOU HAVE CALLED THE ' //
     *      'CODE WITH NEQ = ' // XERN1, 1, 1)
         IFLAG = 9
      ENDIF
C
      IF (RTOLX .LT. 0.0D0 .OR. ATOLX .LT. 0.0D0) THEN
         WRITE (XERN3, '(1PE15.6)') ATOLX
         WRITE (XERN4, '(1PE15.6)') RTOLX
         CALL XERMSG ('SLATEC', 'SOS', 'THE ERROR TOLERANCES FOR ' //
     *      'THE SOLUTION ITERATES CANNOT BE NEGATIVE. YOU HAVE ' //
     *      'CALLED THE CODE WITH  RTOLX = ' // XERN3 //
     *      ' AND ATOLX = ' // XERN4,2, 1)
            IFLAG = 9
      ENDIF
C
      IF (TOLF .LT. 0.0D0) THEN
         WRITE (XERN3, '(1PE15.6)') TOLF
         CALL XERMSG ('SLATEC', 'SOS', 'THE RESIDUAL ERROR ' //
     *      'TOLERANCE MUST BE NON-NEGATIVE.  YOU HAVE CALLED THE ' //
     *      'CODE WITH TOLF = ' // XERN3, 3, 1)
            IFLAG = 9
      ENDIF
C
      IPRINT = 0
      MXIT = 50
      IF (INPFLG .EQ. (-1)) THEN
         IF (IW(1) .EQ. (-1)) IPRINT = -1
         MXIT = IW(2)
         IF (MXIT .LE. 0) THEN
            WRITE (XERN1, '(I8)') MXIT
            CALL XERMSG ('SLATEC', 'SOS', 'YOU HAVE TOLD THE CODE ' //
     *         'TO USE OPTIONAL IN PUT ITEMS BY SETTING  IFLAG=-1. '//
     *         'HOWEVER YOU HAVE CALLED THE CODE WITH THE MAXIMUM ' //
     *         'ALLOWABLE NUMBER OF ITERATIONS SET TO  IW(2) = ' //
     *         XERN1, 4, 1)
            IFLAG = 9
         ENDIF
      ENDIF
C
      NC = (NEQ*(NEQ+1))/2
      IF (LRW .LT. 1 + 6*NEQ + NC) THEN
         WRITE (XERN1, '(I8)') LRW
         CALL XERMSG ('SLATEC', 'SOS', 'DIMENSION OF THE RW ARRAY ' //
     *      'MUST BE AT LEAST 1 + 6*NEQ + NEQ*(NEQ+1)/2 .  YOU HAVE ' //
     *      'CALLED THE CODE WITH LRW = ' // XERN1, 5, 1)
         IFLAG = 9
      ENDIF
C
      IF (LIW .LT. 3 + NEQ) THEN
         WRITE (XERN1, '(I8)') LIW
         CALL XERMSG ('SLATEC', 'SOS', 'DIMENSION OF THE IW ARRAY ' //
     *      'MUST BE AT LEAST   3 + NEQ.  YOU HAVE CALLED THE CODE ' //
     *      'WITH  LIW = ' // XERN1, 6, 1)
         IFLAG = 9
      ENDIF
C
      IF (IFLAG .NE. 9) THEN
         NCJS = 6
         NSRRC = 4
         NSRI = 5
C
         K1 = NC + 2
         K2 = K1 + NEQ
         K3 = K2 + NEQ
         K4 = K3 + NEQ
         K5 = K4 + NEQ
         K6 = K5 + NEQ
C
         CALL SOSEQS(FNC, NEQ, X, RTOLX, ATOLX, TOLF, IFLAG, MXIT, NCJS,
     1               NSRRC, NSRI, IPRINT, RW(1), RW(2), NC, RW(K1),
     2               RW(K2), RW(K3), RW(K4), RW(K5), RW(K6), IW(4))
C
         IW(3) = MXIT
      ENDIF
      RETURN
      END
*DECK SOSEQS
      SUBROUTINE SOSEQS (FNC, N, S, RTOLX, ATOLX, TOLF, IFLAG, MXIT,
     +   NCJS, NSRRC, NSRI, IPRINT, FMAX, C, NC, B, P, TEMP, X, Y, FAC,
     +   IS)
C***BEGIN PROLOGUE  SOSEQS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SOS
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SOSEQS-S, DSOSEQ-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     SOSEQS solves a system of N simultaneous nonlinear equations.
C     See the comments in the interfacing routine SOS for a more
C     detailed description of some of the items in the calling list.
C
C ********************************************************************
C
C   -INPUT-
C     FNC -Function subprogram which evaluates the equations
C     N   -Number of equations
C     S   -Solution vector of initial guesses
C     RTOLX-Relative error tolerance on solution components
C     ATOLX-Absolute error tolerance on solution components
C     TOLF-Residual error tolerance
C     MXIT-Maximum number of allowable iterations.
C     NCJS-Maximum number of consecutive iterative steps to perform
C          using the same triangular Jacobian matrix approximation.
C     NSRRC-Number of consecutive iterative steps for which the
C          limiting precision accuracy test must be satisfied
C          before the routine exits with IFLAG=4.
C     NSRI-Number of consecutive iterative steps for which the
C          diverging condition test must be satisfied before
C          the routine exits with IFLAG=7.
C     IPRINT-Internal printing parameter.  You must set IPRINT=-1 if you
C          want the intermediate solution iterates and a residual norm
C          to be printed.
C     C   -Internal work array, dimensioned at least N*(N+1)/2.
C     NC  -Dimension of C array. NC  .GE.  N*(N+1)/2.
C     B   -Internal work array, dimensioned N.
C     P   -Internal work array, dimensioned N.
C     TEMP-Internal work array, dimensioned N.
C     X   -Internal work array, dimensioned N.
C     Y   -Internal work array, dimensioned N.
C     FAC -Internal work array, dimensioned N.
C     IS  -Internal work array, dimensioned N.
C
C   -OUTPUT-
C     S   -Solution vector
C     IFLAG-Status indicator flag
C     MXIT-The actual number of iterations performed
C     FMAX-Residual norm
C     C   -Upper unit triangular matrix which approximates the
C          forward triangularization of the full Jacobian matrix.
C          stored in a vector with dimension at least N*(N+1)/2.
C     B   -Contains the residuals (function values) divided
C          by the corresponding components of the P vector
C     P   -Array used to store the partial derivatives. After
C          each iteration P(K) contains the maximal derivative
C          occurring in the K-th reduced equation.
C     TEMP-Array used to store the previous solution iterate.
C     X   -Solution vector. Contains the values achieved on the
C          last iteration loop upon exit from SOS.
C     Y   -Array containing the solution increments.
C     FAC -Array containing factors used in computing numerical
C          derivatives.
C     IS  -Records the pivotal information (column interchanges)
C
C **********************************************************************
C *** Three machine dependent parameters appear in this subroutine.
C
C *** The smallest positive magnitude, zero, is defined by the function
C *** routine R1MACH(1).
C
C *** URO, The computer unit roundoff value, is defined by R1MACH(3) for
C *** machines that round or R1MACH(4) for machines that truncate.
C *** URO is the smallest positive number such that 1.+URO  .GT.  1.
C
C *** The output tape unit number, LOUN, is defined by the function
C *** I1MACH(2).
C **********************************************************************
C
C***SEE ALSO  SOS
C***ROUTINES CALLED  I1MACH, R1MACH, SOSSOL
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  SOSEQS
C
C
      DIMENSION S(*), C(NC), B(*), IS(*), P(*), TEMP(*), X(*), Y(*),
     1          FAC(*)
C
C***FIRST EXECUTABLE STATEMENT  SOSEQS
      URO = R1MACH(4)
      LOUN = I1MACH(2)
      ZERO = R1MACH(1)
      RE = MAX(RTOLX,URO)
      SRURO = SQRT(URO)
C
      IFLAG = 0
      NP1 = N + 1
      ICR = 0
      IC = 0
      ITRY = NCJS
      YN1 = 0.
      YN2 = 0.
      YN3 = 0.
      YNS = 0.
      MIT = 0
      FN1 = 0.
      FN2 = 0.
      FMXS = 0.
C
C     INITIALIZE THE INTERCHANGE (PIVOTING) VECTOR AND
C     SAVE THE CURRENT SOLUTION APPROXIMATION FOR FUTURE USE.
C
      DO 10 K=1,N
        IS(K) = K
        X(K) = S(K)
        TEMP(K) = X(K)
   10 CONTINUE
C
C
C    *****************************************
C    **** BEGIN PRINCIPAL ITERATION LOOP  ****
C    *****************************************
C
      DO 330 M=1,MXIT
C
        DO 20 K=1,N
          FAC(K) = SRURO
   20   CONTINUE
C
   30   KN = 1
        FMAX = 0.
C
C
C    ******** BEGIN SUBITERATION LOOP DEFINING THE LINEARIZATION OF EACH
C    ******** EQUATION WHICH RESULTS IN THE CONSTRUCTION OF AN UPPER
C    ******** TRIANGULAR MATRIX APPROXIMATING THE FORWARD
C    ******** TRIANGULARIZATION OF THE FULL JACOBIAN MATRIX
C
        DO 170 K=1,N
          KM1 = K - 1
C
C     BACK-SOLVE A TRIANGULAR LINEAR SYSTEM OBTAINING
C     IMPROVED SOLUTION VALUES FOR K-1 OF THE VARIABLES
C     FROM THE FIRST K-1 EQUATIONS. THESE VARIABLES ARE THEN
C     ELIMINATED FROM THE K-TH EQUATION.
C
          IF (KM1 .EQ. 0) GO TO 50
          CALL SOSSOL(K, N, KM1, Y, C, B, KN)
          DO 40 J=1,KM1
            JS = IS(J)
            X(JS) = TEMP(JS) + Y(J)
   40     CONTINUE
C
C
C     EVALUATE THE K-TH EQUATION AND THE INTERMEDIATE COMPUTATION
C     FOR THE MAX NORM OF THE RESIDUAL VECTOR.
C
   50     F = FNC(X,K)
          FMAX = MAX(FMAX,ABS(F))
C
C     IF WE WISH TO PERFORM SEVERAL ITERATIONS USING A FIXED
C     FACTORIZATION OF AN APPROXIMATE JACOBIAN,WE NEED ONLY
C     UPDATE THE CONSTANT VECTOR.
C
          IF (ITRY .LT. NCJS) GO TO 160
C
C
          IT = 0
C
C     COMPUTE PARTIAL DERIVATIVES THAT ARE REQUIRED IN THE LINEARIZATION
C     OF THE K-TH REDUCED EQUATION
C
          DO 90 J=K,N
            ITEM = IS(J)
            HX = X(ITEM)
            H = FAC(ITEM)*HX
            IF (ABS(H) .LE. ZERO) H = FAC(ITEM)
            X(ITEM) = HX + H
            IF (KM1 .EQ. 0) GO TO 70
            Y(J) = H
            CALL SOSSOL(K, N, J, Y, C, B, KN)
            DO 60 L=1,KM1
              LS = IS(L)
              X(LS) = TEMP(LS) + Y(L)
   60       CONTINUE
   70       FP = FNC(X,K)
            X(ITEM) = HX
            FDIF = FP - F
            IF (ABS(FDIF) .GT. URO*ABS(F)) GO TO 80
            FDIF = 0.
            IT = IT + 1
   80       P(J) = FDIF/H
   90     CONTINUE
C
          IF (IT .LE. (N-K)) GO TO 110
C
C     ALL COMPUTED PARTIAL DERIVATIVES OF THE K-TH EQUATION
C     ARE EFFECTIVELY ZERO.TRY LARGER PERTURBATIONS OF THE
C     INDEPENDENT VARIABLES.
C
          DO 100 J=K,N
            ISJ = IS(J)
            FACT = 100.*FAC(ISJ)
            IF (FACT .GT. 1.E+10) GO TO 340
            FAC(ISJ) = FACT
  100     CONTINUE
          GO TO 30
C
  110     IF (K .EQ. N) GO TO 160
C
C     ACHIEVE A PIVOTING EFFECT BY CHOOSING THE MAXIMAL DERIVATIVE
C     ELEMENT
C
          PMAX = 0.
          DO 120 J=K,N
            TEST = ABS(P(J))
            IF (TEST .LE. PMAX) GO TO 120
            PMAX = TEST
            ISV = J
  120     CONTINUE
          IF (PMAX .EQ. 0.) GO TO 340
C
C     SET UP THE COEFFICIENTS FOR THE K-TH ROW OF THE TRIANGULAR
C     LINEAR SYSTEM AND SAVE THE PARTIAL DERIVATIVE OF
C     LARGEST MAGNITUDE
C
          PMAX = P(ISV)
          KK = KN
          DO 140 J=K,N
            IF (J .EQ. ISV) GO TO 130
            C(KK) = -P(J)/PMAX
  130       KK = KK + 1
  140     CONTINUE
          P(K) = PMAX
C
C
          IF (ISV .EQ. K) GO TO 160
C
C     INTERCHANGE THE TWO COLUMNS OF C DETERMINED BY THE
C     PIVOTAL STRATEGY
C
          KSV = IS(K)
          IS(K) = IS(ISV)
          IS(ISV) = KSV
C
          KD = ISV - K
          KJ = K
          DO 150 J=1,K
            CSV = C(KJ)
            JK = KJ + KD
            C(KJ) = C(JK)
            C(JK) = CSV
            KJ = KJ + N - J
  150     CONTINUE
C
  160     KN = KN + NP1 - K
C
C     STORE THE COMPONENTS FOR THE CONSTANT VECTOR
C
          B(K) = -F/P(K)
C
  170   CONTINUE
C
C    ********
C    ******** END OF LOOP CREATING THE TRIANGULAR LINEARIZATION MATRIX
C    ********
C
C
C     SOLVE THE RESULTING TRIANGULAR SYSTEM FOR A NEW SOLUTION
C     APPROXIMATION AND OBTAIN THE SOLUTION INCREMENT NORM.
C
        KN = KN - 1
        Y(N) = B(N)
        IF (N .GT. 1) CALL SOSSOL(N, N, N, Y, C, B, KN)
        XNORM = 0.
        YNORM = 0.
        DO 180 J=1,N
          YJ = Y(J)
          YNORM = MAX(YNORM,ABS(YJ))
          JS = IS(J)
          X(JS) = TEMP(JS) + YJ
          XNORM = MAX(XNORM,ABS(X(JS)))
  180   CONTINUE
C
C
C     PRINT INTERMEDIATE SOLUTION ITERATES AND RESIDUAL NORM IF DESIRED
C
        IF (IPRINT.NE.(-1)) GO TO 190
        MM = M - 1
        WRITE (LOUN,1234) FMAX, MM, (X(J),J=1,N)
 1234   FORMAT ('0RESIDUAL NORM =', E9.2, /1X, 'SOLUTION ITERATE',
     1   ' (', I3, ')', /(1X, 5E26.14))
  190   CONTINUE
C
C     TEST FOR CONVERGENCE TO A SOLUTION (RELATIVE AND/OR ABSOLUTE ERROR
C     COMPARISON ON SUCCESSIVE APPROXIMATIONS OF EACH SOLUTION VARIABLE)
C
        DO 200 J=1,N
          JS = IS(J)
          IF (ABS(Y(J)) .GT. RE*ABS(X(JS))+ATOLX) GO TO 210
  200   CONTINUE
        IF (FMAX .LE. FMXS) IFLAG = 1
C
C     TEST FOR CONVERGENCE TO A SOLUTION BASED ON RESIDUALS
C
  210   IF (FMAX .GT. TOLF) GO TO 220
        IFLAG = IFLAG + 2
  220   IF (IFLAG .GT. 0) GO TO 360
C
C
        IF (M .GT. 1) GO TO 230
        FMIN = FMAX
        GO TO 280
C
C     SAVE SOLUTION HAVING MINIMUM RESIDUAL NORM.
C
  230   IF (FMAX .GE. FMIN) GO TO 250
        MIT = M + 1
        YN1 = YNORM
        YN2 = YNS
        FN1 = FMXS
        FMIN = FMAX
        DO 240 J=1,N
          S(J) = X(J)
  240   CONTINUE
        IC = 0
C
C     TEST FOR LIMITING PRECISION CONVERGENCE.  VERY SLOWLY CONVERGENT
C     PROBLEMS MAY ALSO BE DETECTED.
C
  250   IF (YNORM .GT. SRURO*XNORM) GO TO 260
        IF ((FMAX .LT. 0.2*FMXS) .OR. (FMAX .GT. 5.*FMXS)) GO TO 260
        IF ((YNORM .LT. 0.2*YNS) .OR. (YNORM .GT. 5.*YNS)) GO TO 260
        ICR = ICR + 1
        IF (ICR .LT. NSRRC) GO TO 270
        IFLAG = 4
        FMAX = FMIN
        GO TO 380
  260   ICR = 0
C
C     TEST FOR DIVERGENCE OF THE ITERATIVE SCHEME.
C
        IF ((YNORM .LE. 2.*YNS) .AND. (FMAX .LE. 2.*FMXS)) GO TO 270
        IC = IC + 1
        IF (IC .LT. NSRI) GO TO 280
        IFLAG = 7
        GO TO 360
  270   IC = 0
C
C     CHECK TO SEE IF NEXT ITERATION CAN USE THE OLD JACOBIAN
C     FACTORIZATION
C
  280   ITRY = ITRY - 1
        IF (ITRY .EQ. 0) GO TO 290
        IF (20.*YNORM .GT. XNORM) GO TO 290
        IF (YNORM .GT. 2.*YNS) GO TO 290
        IF (FMAX .LT. 2.*FMXS) GO TO 300
  290   ITRY = NCJS
C
C     SAVE THE CURRENT SOLUTION APPROXIMATION AND THE RESIDUAL AND
C     SOLUTION INCREMENT NORMS FOR USE IN THE NEXT ITERATION.
C
  300   DO 310 J=1,N
          TEMP(J) = X(J)
  310   CONTINUE
        IF (M.NE.MIT) GO TO 320
        FN2 = FMAX
        YN3 = YNORM
  320   FMXS = FMAX
        YNS = YNORM
C
C
  330 CONTINUE
C
C    *****************************************
C    **** END OF PRINCIPAL ITERATION LOOP ****
C    *****************************************
C
C
C     TOO MANY ITERATIONS, CONVERGENCE WAS NOT ACHIEVED.
      M = MXIT
      IFLAG = 5
      IF (YN1 .GT. 10.0*YN2 .OR. YN3 .GT. 10.0*YN1) IFLAG = 6
      IF (FN1 .GT. 5.0*FMIN .OR. FN2 .GT. 5.0*FMIN) IFLAG = 6
      IF (FMAX .GT. 5.0*FMIN) IFLAG = 6
      GO TO 360
C
C
C     A JACOBIAN-RELATED MATRIX IS EFFECTIVELY SINGULAR.
  340 IFLAG = 8
      DO 350 J=1,N
        S(J) = TEMP(J)
  350 CONTINUE
      GO TO 380
C
C
  360 DO 370 J=1,N
        S(J) = X(J)
  370 CONTINUE
C
C
  380 MXIT = M
      RETURN
      END
*DECK SOSSOL
      SUBROUTINE SOSSOL (K, N, L, X, C, B, M)
C***BEGIN PROLOGUE  SOSSOL
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SOS
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SOSSOL-S, DSOSSL-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     SOSSOL solves an upper triangular type of linear system by back
C     substitution.
C
C     The matrix C is upper trapezoidal and stored as a linear array by
C     rows. The equations have been normalized so that the diagonal
C     entries of C are understood to be unity. The off diagonal entries
C     and the elements of the constant right hand side vector B have
C     already been stored as the negatives of the corresponding equation
C     values.
C     with each call to SOSSOL a (K-1) by (K-1) triangular system is
C     resolved. For L greater than K, column L of C is included in the
C     right hand side vector.
C
C***SEE ALSO  SOS
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  SOSSOL
C
C
      DIMENSION X(*), C(*), B(*)
C
C***FIRST EXECUTABLE STATEMENT  SOSSOL
      NP1 = N + 1
      KM1 = K - 1
      LK = KM1
      IF (L .EQ. K) LK = K
      KN = M
C
C
      DO 40 KJ=1,KM1
        KMM1 = K - KJ
        KM = KMM1 + 1
        XMAX = 0.
        KN = KN - NP1 + KMM1
        IF (KM .GT. LK) GO TO 20
        JKM = KN
C
        DO 10 J=KM,LK
          JKM = JKM + 1
          XMAX = XMAX + C(JKM)*X(J)
   10   CONTINUE
C
   20   IF (L .LE. K) GO TO 30
        JKM = KN + L - KMM1
        XMAX = XMAX + C(JKM)*X(L)
   30   X(KMM1) = XMAX + B(KMM1)
   40 CONTINUE
C
      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_list_column_types
  use cubelist_types
  use cubelist_list
  use cubedag_node_class
  use cubedag_history_buffer
  use cubedag_index_iterator_tool
  !---------------------------------------------------------------------
  ! This module offers support for the DAG-specific LIST, namely to
  ! describe the columns used in this context.
  !---------------------------------------------------------------------
  !
  public :: col_intrinsic_t
  public :: col_external_t
  public :: col_alias_t
  private
  !
  ! This type is able to 'list' an intrinsic value from a node, by calling
  ! its %get_repr() method.
  type, extends(list_column_t) :: col_intrinsic_t
  contains
    procedure         :: get_lrepr => col_intrinsic_lrepr  ! [private]
    procedure         :: get_repr  => col_intrinsic_repr   ! [private]
    procedure, public :: final     => col_intrinsic_final
  end type col_intrinsic_t
  !
  ! This type 'lists' a non-intrinsic property of a node, it requires some
  ! external information.
  type, extends(list_column_t) :: col_external_t
    integer(kind=list_k), private :: ient=0
  contains
    procedure         :: get_lrepr => col_external_lrepr  ! [private]
    procedure         :: get_repr  => col_external_repr   ! [private]
    procedure, public :: final     => col_external_final
  end type col_external_t
  !
  ! This type is not directly able to list values. It just provide an alias
  ! to other group of columns
  type, extends(list_column_t) :: col_alias_t
    integer(kind=4)                :: n
    character(len=16), allocatable :: aliased(:)
  contains
    procedure, public :: declare   => col_alias_declare
    procedure         :: get_lrepr => col_alias_lrepr  ! [private]
    procedure         :: get_repr  => col_alias_repr   ! [private]
    procedure, public :: final     => col_alias_final
  end type col_alias_t
  !
contains
  !
  !---------------------------------------------------------------------
  subroutine col_intrinsic_lrepr(col,obj,lrepr,error)
    class(col_intrinsic_t),        intent(in)    :: col
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=4),               intent(out)   :: lrepr
    logical,                       intent(inout) :: error
    call obj%get_lrepr(col%name,lrepr,error)
    if (error)  return
  end subroutine col_intrinsic_lrepr
  subroutine col_intrinsic_repr(col,obj,lrepr,repr,nline,error)
    class(col_intrinsic_t),        intent(inout) :: col
    class(list_object_advanced_t), intent(inout) :: obj
    integer(kind=4),               intent(in)    :: lrepr
    character(len=*),              intent(out)   :: repr(:)
    integer(kind=4),               intent(out)   :: nline
    logical,                       intent(inout) :: error
    call obj%get_repr(col%name,lrepr,repr,nline,error)
    if (error)  return
  end subroutine col_intrinsic_repr
  subroutine col_intrinsic_final(obj,error)
    class(col_intrinsic_t), intent(inout) :: obj
    logical,                intent(inout) :: error
  end subroutine col_intrinsic_final
  !---------------------------------------------------------------------
  subroutine col_external_lrepr(col,obj,lrepr,error)
    class(col_external_t),         intent(in)    :: col
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=4),               intent(out)   :: lrepr
    logical,                       intent(inout) :: error
    class(cubedag_node_object_t), pointer :: node
    character(len=24) :: str24
    select case (col%name)
    case ('ENTRY')
      lrepr = 5
    case ('HISTORY')
      node => cubedag_node_ptr(obj,error)
      if (error)  return
      call cubedag_history_tostr(node%node%history,str24,error)
      lrepr = len_trim(str24)
    case ('LEADING','TRAILING')
      lrepr = 3
    case ('SEPARATOR')
      lrepr = 1
    case default
      lrepr = 3
    end select
  end subroutine col_external_lrepr
  subroutine col_external_repr(col,obj,lrepr,repr,nline,error)
    class(col_external_t),         intent(inout) :: col
    class(list_object_advanced_t), intent(inout) :: obj
    integer(kind=4),               intent(in)    :: lrepr
    character(len=*),              intent(out)   :: repr(:)
    integer(kind=4),               intent(out)   :: nline
    logical,                       intent(inout) :: error
    class(cubedag_node_object_t), pointer :: node
    type(index_iterator_t) :: iter
    nline = 1
    col%ient = col%ient+1
    node => cubedag_node_ptr(obj,error)
    if (error)  return
    select case (col%name)
    case ('ENTRY')
      write(repr(1),'(I5)')   col%ient
    case ('HISTORY')
      call cubedag_history_tostr(node%node%history,repr(1),error)
      if (error)  return
    case ('LEADING')
      if (iter%is_current(node%node%id))  repr(1) = '>>>'
    case ('TRAILING')
      if (iter%is_current(node%node%id))  repr(1) = '<<<'
    case ('SEPARATOR')
      repr(1) = '|'
    case default
      repr(1) = 'N/A'
    end select
  end subroutine col_external_repr
  subroutine col_external_final(obj,error)
    class(col_external_t), intent(inout) :: obj
    logical,               intent(inout) :: error
  end subroutine col_external_final
  !---------------------------------------------------------------------
  subroutine col_alias_declare(col,aliased,error)
    class(col_alias_t), intent(inout) :: col
    character(len=*),   intent(in)    :: aliased(:)
    logical,            intent(inout) :: error
    col%n = size(aliased)
    allocate(col%aliased(col%n))
    col%aliased(:) = aliased(:)
  end subroutine col_alias_declare
  subroutine col_alias_lrepr(col,obj,lrepr,error)
    class(col_alias_t),            intent(in)    :: col
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=4),               intent(out)   :: lrepr
    logical,                       intent(inout) :: error
    ! Irrelevant
  end subroutine col_alias_lrepr
  subroutine col_alias_repr(col,obj,lrepr,repr,nline,error)
    class(col_alias_t),            intent(inout) :: col
    class(list_object_advanced_t), intent(inout) :: obj
    integer(kind=4),               intent(in)    :: lrepr
    character(len=*),              intent(out)   :: repr(:)
    integer(kind=4),               intent(out)   :: nline
    logical,                       intent(inout) :: error
    ! Irrelevant
  end subroutine col_alias_repr
  subroutine col_alias_final(obj,error)
    class(col_alias_t), intent(inout) :: obj
    logical,            intent(inout) :: error
    if (allocated(obj%aliased))  deallocate(obj%aliased)
  end subroutine col_alias_final
  !
end module cubedag_list_column_types
!
module cubedag_list_columns
  use cubelist_types
  use cubelist_list
  use cubedag_messaging
  use cubedag_list_column_types
  !---------------------------------------------------------------------
  ! This modules registers all the possible columns used for the
  ! DAG-related LIST
  !---------------------------------------------------------------------
  !
  public :: cubedag_list_columns_init
  public :: cubedag_list_columns_parse
  public :: cubedag_list_columns_fetch
  public :: list_column_names
  private
  !
  ! Intrinsic-kind columns
  type(col_intrinsic_t) :: col_id
  type(col_intrinsic_t) :: col_parents
  type(col_intrinsic_t) :: col_children
  type(col_intrinsic_t) :: col_twins
  type(col_intrinsic_t) :: col_unit
  type(col_intrinsic_t) :: col_source
  type(col_intrinsic_t) :: col_ptype
  type(col_intrinsic_t) :: col_l0
  type(col_intrinsic_t) :: col_m0
  type(col_intrinsic_t) :: col_pang
  type(col_intrinsic_t) :: col_lres
  type(col_intrinsic_t) :: col_mres
  type(col_intrinsic_t) :: col_line
  type(col_intrinsic_t) :: col_restf
  type(col_intrinsic_t) :: col_fres
  type(col_intrinsic_t) :: col_vsys
  type(col_intrinsic_t) :: col_rmaj
  type(col_intrinsic_t) :: col_rmin
  type(col_intrinsic_t) :: col_rang
  type(col_intrinsic_t) :: col_observatory
  type(col_intrinsic_t) :: col_location
  type(col_intrinsic_t) :: col_order
  type(col_intrinsic_t) :: col_access
  type(col_intrinsic_t) :: col_origin
  type(col_intrinsic_t) :: col_family
  type(col_intrinsic_t) :: col_flag
  type(col_intrinsic_t) :: col_cubeid
  type(col_intrinsic_t) :: col_type
  type(col_intrinsic_t) :: col_uservar
  type(col_intrinsic_t) :: col_memsize
  type(col_intrinsic_t) :: col_disksize
  type(col_intrinsic_t) :: col_datasize
  type(col_intrinsic_t) :: col_datatype
  !
  ! External columns
  type(col_external_t) :: col_entry
  type(col_external_t) :: col_history
  type(col_external_t) :: col_leading
  type(col_external_t) :: col_trailing
  type(col_external_t) :: col_separ
  !
  ! Alias names
  type(col_alias_t) :: col_default
  type(col_alias_t) :: col_beam
  type(col_alias_t) :: col_proj
  type(col_alias_t) :: col_graph
  type(col_alias_t) :: col_spec
  type(col_alias_t) :: col_spat
  type(col_alias_t) :: col_tuple
  type(col_alias_t) :: col_size
  type(col_alias_t) :: col_current
  !
  ! The global list of columns for LIST
  type(list_column_list_t) :: list_columns
  !
  ! The global list of column names for LIST
  character(len=16), allocatable :: list_column_names(:)
  !
contains
  !
  subroutine cubedag_list_columns_init(error)
    !-------------------------------------------------------------------
    ! Register all columns in the 'list_columns' global list
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    ! ORDER MATTERS HERE: column names will appear like this in LIST /COL ?
    !
    ! Intrinsic kind columns
    call list_columns%register(col_id,         'IDENTIFIER', 'Id',         error)
    call list_columns%register(col_parents,    'PARENTS',    'Parents',    error)
    call list_columns%register(col_children,   'CHILDREN',   'Children',   error)
    call list_columns%register(col_twins,      'TWINS',      'Twins',      error)
    call list_columns%register(col_unit,       'UNIT',       'Unit',       error)
    call list_columns%register(col_source,     'SOURCE',     'Source',     error)
    call list_columns%register(col_ptype,      'PROJTYPE',   'ProjType',   error)
    call list_columns%register(col_l0,         'L0',         'L0',         error)
    call list_columns%register(col_m0,         'M0',         'M0',         error)
    call list_columns%register(col_pang,       'PROJANGLE',  'ProjAngle',  error)
    call list_columns%register(col_lres,       'SPALINC',    'SpaLInc',    error)
    call list_columns%register(col_mres,       'SPAMINC',    'SpaMInc',    error)
    call list_columns%register(col_line,       'LINE',       'Line',       error)
    call list_columns%register(col_restf,      'SPEFREQVAL', 'SpeFreqVal', error)
    call list_columns%register(col_fres,       'SPEFREQINC', 'FreqIncr',   error)
    call list_columns%register(col_vsys,       'SPEVELOVAL', 'VeloValue',  error)
    call list_columns%register(col_rmaj,       'BMAJOR',     'BeaMajor',   error)
    call list_columns%register(col_rmin,       'BMINOR',     'BeaMinor',   error)
    call list_columns%register(col_rang,       'BPA',        'BeaPA',      error)
    call list_columns%register(col_observatory,'OBSERVATORY','Observatory',error)
    call list_columns%register(col_location,   'LOCATION',   'Location',   error)
    call list_columns%register(col_order,      'ORDER',      'Order',      error)
    call list_columns%register(col_access,     'ACCESS',     'Access',     error)
    call list_columns%register(col_origin,     'ORIGIN',     'Origin',     error)
    call list_columns%register(col_family,     'FAMILY',     'Family',     error)
    call list_columns%register(col_flag,       'FLAGS',      'Flags',      error)
    call list_columns%register(col_cubeid,     'CUBEID',     'CubeID',     error)
    call list_columns%register(col_type,       'TYPE',       'Type',       error)
    call list_columns%register(col_uservar,    'VARIABLE',   'Variable',   error)
    call list_columns%register(col_memsize,    'MEMSIZE',    'MemoSize',   error)
    call list_columns%register(col_disksize,   'DISKSIZE',   'DiskSize',   error)
    call list_columns%register(col_datasize,   'DATASIZE',   'DataSize',   error)
    call list_columns%register(col_datatype,   'DATATYPE',   'DataType',   error)
    if (error)  return
    !
    ! External-kind columns
    call list_columns%register(col_entry,   'ENTRY',    'Entry',  error)
    call list_columns%register(col_history, 'HISTORY',  'History',error)
    call list_columns%register(col_leading, 'LEADING',  '',       error)
    call list_columns%register(col_trailing,'TRAILING', '',       error)
    call list_columns%register(col_separ,   'SEPARATOR','|',      error)
    if (error)  return
    !
    ! Alias columns (headers are irrelevant)
    call list_columns%register(col_default,'DEFAULT',   '',error)
    call list_columns%register(col_beam,   'BEAM',      '',error)
    call list_columns%register(col_proj,   'PROJECTION','',error)
    call list_columns%register(col_graph,  'GRAPH',     '',error)
    call list_columns%register(col_spec,   'SPECTRAL',  '',error)
    call list_columns%register(col_spat,   'SPATIAL',   '',error)
    call list_columns%register(col_tuple,  'TUPLE',     '',error)
    call list_columns%register(col_size,   'SIZE',      '',error)
    call list_columns%register(col_current,'CURRENT',   '',error)
    if (error)  return
    !
    ! Alias translations
    call col_default%declare(['LEADING    ','IDENTIFIER ','TYPE       ',  &
                              'CUBEID     ','OBSERVATORY','SOURCE     ',  &
                              'LINE       ','HISTORY    ','TRAILING   '],error)
    call col_beam%declare   (['BMAJOR     ','BMINOR     ','BPA        '],error)
    call col_proj%declare   (['PROJTYPE   ','L0         ','M0         ',  &
                              'PROJANGLE  '],error)
    call col_graph%declare  (['FAMILY     ','PARENTS    ','CHILDREN   ',  &
                              'TWINS      '],error)
    call col_spec%declare   (['LINE       ','SPEFREQVAL ','SPEFREQINC ',  &
                              'SPEVELOVAL '],error)
    call col_spat%declare   (['SOURCE     ','L0         ','M0         ',  &
                              'SPALINC    ','SPAMINC    '],error)
    call col_tuple%declare  (['ACCESS     ','LOCATION   '],error)
    call col_size%declare   (['DATASIZE   ','MEMSIZE    ','DISKSIZE   '],error)
    call col_current%declare(['LEADING    ','TRAILING   '],error)
    !
    ! Gather all names in a simple list
    call cubedag_list_columns_names(list_column_names,error)
    if (error)  return
  end subroutine cubedag_list_columns_init
  !
  subroutine cubedag_list_columns_names(names,error)
    !-------------------------------------------------------------------
    ! Gather the names of standard columns and aliases in a list
    !-------------------------------------------------------------------
    character(len=*), allocatable, intent(out)   :: names(:)
    logical,                       intent(inout) :: error
    !
    class(list_column_t), pointer :: col
    integer(kind=4) :: icol
    !
    allocate(names(list_columns%n))
    do icol=1,list_columns%n
      col => cubelist_column_ptr(list_columns%list(icol)%p,error)
      if (error)  return
      names(icol) = col%name
    enddo
  end subroutine cubedag_list_columns_names
  !
  subroutine cubedag_list_columns_parse(ncol,ucols,pcols,error)
    !---------------------------------------------------------------------
    ! Convert a list of user inputs (disambiguate) to the proper list of
    ! columns
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: ncol      !
    character(len=*), intent(in)    :: ucols(:)  ! User inputs
    character(len=*), intent(out)   :: pcols(:)  ! Prog columns
    logical,          intent(inout) :: error     !
    !
    integer(kind=4) :: ukeys(ncol)
    !
    call cubedag_list_columns_disambiguate(ncol,ucols,ukeys,error)
    if (error)  return
    call cubedag_list_columns_set(ukeys,pcols,error)
    if (error)  return
  end subroutine cubedag_list_columns_parse
  !
  subroutine cubedag_list_columns_disambiguate(ncol,ucols,ukeys,error)
    use cubetools_disambiguate
    !---------------------------------------------------------------------
    ! Disambiguate list of user inputs into column indices
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: ncol      !
    character(len=*), intent(in)    :: ucols(:)  ! User inputs
    integer(kind=4),  intent(out)   :: ukeys(:)  ! User key indices
    logical,          intent(inout) :: error     !
    !
    integer(kind=4) :: iarg
    character(len=12) :: key
    !
    ukeys(:) = 0
    do iarg=1,ncol
      call cubetools_disambiguate_strict(ucols(iarg),list_column_names,  &
        ukeys(iarg),key,error)
      if (error)  return
    enddo
  end subroutine cubedag_list_columns_disambiguate
  !
  subroutine cubedag_list_columns_set(ukeys,ckeys,error)
    !---------------------------------------------------------------------
    ! Translate the list of columns to actual columns (i.e. including
    ! translation of aliases)
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: ukeys(:)  !
    character(len=*), intent(out)   :: ckeys(:)  !
    logical,          intent(inout) :: error     !
    ! Local
    character(len=*), parameter :: rname='LIST'
    integer(kind=4) :: ikey,iout,nnew,itmp
    character(len=16) :: new(10)
    character(len=16) :: ctmp(size(ckeys))
    !
    ctmp(:) = ''
    iout=0
    do ikey=1,size(ukeys)
      if (ukeys(ikey).le.0)  exit
      !
      select type (col => list_columns%list(ukeys(ikey))%p)
      type is (col_intrinsic_t)
        nnew = 1
        new(1) = col%name
      type is (col_external_t)
        nnew = 1
        new(1) = col%name
      type is (col_alias_t)
        nnew = col%n
        new(1:nnew) = col%aliased(:)
      class default
        call cubedag_message(seve%e,rname,'Unexpected column kind')
        error = .true.
        return
      end select
      !
      if (iout+nnew.gt.size(ctmp)) then
        call cubedag_message(seve%w,rname,'/COLUMNS list too long, truncated')
        return
      endif
      ctmp(iout+1:iout+nnew) = new(1:nnew)
      iout = iout+nnew
    enddo
    !
    ! Special: move current marker columns at first and last positions
    ckeys(:) = ''
    ikey = 0
    if (any(ctmp(1:iout).eq.'LEADING')) then
      ikey = ikey+1
      ckeys(ikey) = 'LEADING'
    endif
    do itmp=1,iout
      if (ctmp(itmp).eq.'LEADING')   cycle
      if (ctmp(itmp).eq.'TRAILING')  cycle
      ikey = ikey+1
      ckeys(ikey) = ctmp(itmp)
    enddo
    if (any(ctmp(1:iout).eq.'TRAILING')) then
      ikey = ikey+1
      ckeys(ikey) = 'TRAILING'
    endif
  end subroutine cubedag_list_columns_set
  !
  subroutine cubedag_list_columns_fetch(name,cols,error)
    !-------------------------------------------------------------------
    ! Return a pointer to the named column
    !-------------------------------------------------------------------
    character(len=*),         intent(in)    :: name
    type(list_column_list_t), intent(inout) :: cols
    logical,                  intent(inout) :: error
    !
    class(list_column_t), pointer :: model,col
    class(list_object_t), pointer :: lot
    !
    ! Fetch the column based on its name
    call list_columns%get(name,model,error)
    if (error)  return
    !
    ! Allocate a COPY because the 'list_column_t' are internally
    ! modified at each call. Copies allow for possible concurrent calls.
    call cols%allocate(model,lot,error)
    if (error)  return
    col => cubelist_column_ptr(lot,error)
    if (error)  return
    call model%copy(col,error)
    if (error)  return
  end subroutine cubedag_list_columns_fetch
end module cubedag_list_columns
!
module cubedag_list_types
  use cubelist_list
  use cubetools_parameters
  use cubedag_messaging
  use cubedag_link_type
  use cubedag_list_columns
  !
  public :: cubedag_list_link
  public :: cubedag_list_user_t
  public :: cubedag_list_prog_t
  private
  !
  type cubedag_list_user_t
    character(len=argu_l) :: ucols(20)
    integer(kind=4)       :: ncol
    logical               :: dopage
  contains
    procedure, public :: toprog => cubedag_list_user_toprog
  end type cubedag_list_user_t
  !
  type cubedag_list_prog_t
    type(list_column_list_t), private :: cols
  contains
    procedure, public :: do => cubedag_list_do
  end type cubedag_list_prog_t
  !
contains
  !
  subroutine cubedag_list_user_toprog(user,prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(cubedag_list_user_t), intent(in)    :: user
    type(cubedag_list_prog_t),  intent(out)   :: prog
    logical,                    intent(inout) :: error
    !
    character(len=16) :: custom(20)  ! Up to 20 custom columns
    !
    call cubedag_list_columns_parse(user%ncol,user%ucols,custom,error)
    if (error)  return
    call cubedag_list_register_columns(prog%cols,custom,.true.,stdout,user%dopage,error)
    if (error) then
      call prog%cols%final(error)
      return
    endif
  end subroutine cubedag_list_user_toprog
  !
  subroutine cubedag_list_do(prog,optx,optname,olun,error)
    !-------------------------------------------------------------------
    ! Execution routine for command LIST
    !-------------------------------------------------------------------
    class(cubedag_list_prog_t), intent(inout) :: prog
    type(cubedag_link_t),       intent(in)    :: optx
    character(len=*),           intent(in)    :: optname
    integer(kind=4),            intent(in)    :: olun
    logical,                    intent(inout) :: error
    !
    prog%cols%olun = olun
    call prog%cols%act(optx,optname,error)
    if (error)  continue
    call prog%cols%final(error)
    if (error)  return
  end subroutine cubedag_list_do
  !
  subroutine cubedag_list_link(link,lkname,ucols,doheader,olun,dopage,error)
    !-------------------------------------------------------------------
    ! List objects from a cubedag_link_t
    !-------------------------------------------------------------------
    type(cubedag_link_t), intent(in)    :: link
    character(len=*),     intent(in)    :: lkname
    character(len=*),     intent(in)    :: ucols(:)
    logical,              intent(in)    :: doheader
    integer(kind=4),      intent(in)    :: olun
    logical,              intent(in)    :: dopage
    logical,              intent(inout) :: error
    !
    character(len=16) :: custom(20)  ! Up to 20 custom columns
    type(list_column_list_t) :: cols
    !
    ! Set up columns
    call cubedag_list_columns_parse(size(ucols),ucols,custom,error)
    if (error)  return
    call cubedag_list_register_columns(cols,custom,doheader,olun,dopage,error)
    if (error)  goto 10
    call cols%act(link,lkname,error)
    if (error)  goto 10
  10 continue
    call cols%final(error)
    if (error)  return
  end subroutine cubedag_list_link
  !
  subroutine cubedag_list_register_columns(cols,custom,doheader,olun,dopage,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(list_column_list_t), intent(inout) :: cols
    character(len=*),         intent(in)    :: custom(:)  ! Custom list of columns
    logical,                  intent(in)    :: doheader
    integer(kind=4),          intent(in)    :: olun
    logical,                  intent(in)    :: dopage
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: icol
    !
    do icol=1,size(custom)
      if (custom(icol).eq.' ')  exit
      call cubedag_list_columns_fetch(custom(icol),cols,error)
      if (error)  return
    enddo
    !
    cols%doheader = doheader
    cols%olun     = olun
    cols%dopage   = dopage
  end subroutine cubedag_list_register_columns
end module cubedag_list_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeio_timing
  use gkernel_types
  use gkernel_interfaces
  use cubetools_parameters
  use cubetools_format
  use cubeio_messaging
  !---------------------------------------------------------------------
  ! Module to manage timing of I/O operations of one cube
  !---------------------------------------------------------------------
  !
  type cubeio_time_t
    type(cputime_t) :: total  ! Total execution time
    type(cputime_t) :: read   ! Reading data from disk
    type(cputime_t) :: writ   ! Writing data to disk
  contains
    procedure :: init     => cubeio_timing_init
    procedure :: feedback => cubeio_timing_feedback
  end type cubeio_time_t

  public :: cubeio_time_t
  private

contains

  subroutine cubeio_timing_init(time,error)
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    class(cubeio_time_t), intent(inout) :: time
    logical,              intent(inout) :: error
    !
    call gag_cputime_init(time%total)
    call gag_cputime_init(time%read)
    call gag_cputime_init(time%writ)
  end subroutine cubeio_timing_init

  subroutine cubeio_timing_feedback(time,siz)
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    class(cubeio_time_t), intent(in) :: time
    integer(kind=data_k), intent(in) :: siz
    !
    character(len=*), parameter :: rname='TIMING>FEEDBACK'
    character(len=mess_l) :: mess
    !
    print *,''
    !
  !!$ *** JP filename is not there anymore...
  !!$  write(mess,'(A,T45,A)')  trim(cub%head%gen%filename),cubetools_format_memsize(siz)
    write(mess,'(T45,A)') cubetools_format_memsize(siz)
    call cubeio_message(seve%r,rname,mess)
    !
    call print_it('Lifetime:',                     time%total%diff%elapsed,siz,.false.)
    call print_it('Time elapsed reading the cube:',time%read%curr%elapsed, siz,.true.)
    call print_it('Time elapsed writing the cube:',time%writ%curr%elapsed, siz,.true.)
    !
  end subroutine cubeio_timing_feedback

  subroutine print_it(prefix,elapsed,siz,dorate)
    character(len=*),     intent(in) :: prefix
    real(kind=8),         intent(in) :: elapsed
    integer(kind=data_k), intent(in) :: siz
    logical,              intent(in) :: dorate
    ! Local
    character(len=*), parameter :: rname='TIMING>FEEDBACK'
    character(len=mess_l) :: mess
    integer(kind=data_k) :: rate
    character(len=64) :: ratestr
    !
    if (dorate) then
      if (elapsed.le.0.d0) then
        rate = 0.d0
      else
        rate = siz/elapsed
      endif
      write(ratestr,'(3A)')  '(',trim(cubetools_format_memsize(rate)),'/sec)'
    else
      ratestr = ''
    endif
    write(mess,10)  prefix,elapsed,' sec ',ratestr
    call cubeio_message(seve%r,rname,mess)
    !
10  format(A,T40,F10.2,A,A)
  end subroutine print_it

end module cubeio_timing

module cubetools_ascii
  use cubetools_parameters
  use cubetools_messaging
  !
  public :: writ_l
  public :: ascii_file_t
  private
  !
  character(len=*), parameter :: readwrite(3) = &
       ['readonly ','writeonly','readwrite']
  integer(kind=code_k), parameter :: read_only  = 1
  integer(kind=code_k), parameter :: write_only = 2
  integer(kind=code_k), parameter :: read_write = 3
  !
  integer(kind=4), parameter :: lun_k = 4
  integer(kind=4), parameter :: line_k = 4
  integer(kind=4), parameter :: writ_l = 256
  !
  type ascii_file_t
     character(len=file_l),private :: name
     integer(kind=code_k), private :: status
     integer(kind=lun_k),  private :: lun
     integer(kind=line_k), private :: iline
     integer(kind=line_k), private :: nline
   contains
     procedure, public :: open       => cubetools_ascii_file_open
     procedure, public :: read_next  => cubetools_ascii_file_read_next
     procedure, public :: write_next => cubetools_ascii_file_write_next
     procedure, public :: get_nline  => cubetools_ascii_file_get_nline
     procedure, public :: close      => cubetools_ascii_file_close
  end type ascii_file_t
  !
contains
  !
  subroutine cubetools_ascii_file_open(file,name,status,error)
    use gkernel_interfaces
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    ! Opens an ASCII file 
    !----------------------------------------------------------------------
    class(ascii_file_t), intent(out)   :: file
    character(len=*),    intent(in)    :: name
    character(len=*),    intent(in)    :: status
    logical,             intent(inout) :: error
    !
    character(len=argu_l) :: argu
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='ASCII>FILE>OPEN'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    call cubetools_disambiguate_strict(status,readwrite,file%status,argu,error)
    if (error) return
    !
    ier = sic_getlun(file%lun)
    if (ier.ne.1) then
       call cubetools_message(seve%e,rname,'Cannot allocate LUN')
       error = .true.
       return
    endif
    select case(file%status)
    case(read_only)
       ier = sic_open(file%lun,name,'OLD',.true.)
    case(read_write)
       ier = sic_open(file%lun,name,'OLD',.false.)
    case(write_only)
       ier = sic_open(file%lun,name,'NEW',.false.)
    case default
       call cubetools_message(seve%e,rname,'Unrecognized status')
       error = .true.
       return
    end select
    if (ier.ne.0) then
       call cubetools_message(seve%e,rname,'Cannot open file '//name)
       error = .true.
       return
    endif
    file%name  = name
    file%iline = 0
    file%nline = 0
    !
    if (file%status.eq.read_only.or.file%status.eq.read_write) then
       do while (.true.)
          read(file%lun,*,iostat=ier)
          if (ier.ne.0) exit
          file%nline = file%nline+1
       enddo
       ier = sic_close(file%lun)
       ier = sic_open(file%lun,name,'OLD',.true.)
    endif
  end subroutine cubetools_ascii_file_open
  !
  subroutine cubetools_ascii_file_close(file,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Opens an ASCII file 
    !----------------------------------------------------------------------
    class(ascii_file_t), intent(inout) :: file
    logical,             intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='ASCII>FILE>OPEN'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    ier = sic_close(file%lun)
    call sic_frelun(file%lun)
    file%lun = 0
    file%iline = 0
    file%nline = 0
  end subroutine cubetools_ascii_file_close
  !
  function cubetools_ascii_file_get_nline(file) result(nline)
    !----------------------------------------------------------------------
    ! Gets the number of lines in an ASCII file
    !----------------------------------------------------------------------
    class(ascii_file_t),  intent(in) :: file
    integer(kind=line_k)             :: nline
    !
    character(len=*), parameter :: rname='ASCII>FILE>GET_NLINE'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    nline = file%nline
  end function cubetools_ascii_file_get_nline
  !
  subroutine cubetools_ascii_file_read_next(file,line,error)
    !----------------------------------------------------------------------
    ! reads next line from an ASCII file
    ! Caveat: Line can only be up to 100 characters
    !----------------------------------------------------------------------
    class(ascii_file_t),  intent(inout) :: file
    character(len=*),     intent(out)   :: line
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='ASCII>FILE>READ>NEXT'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    file%iline = file%iline+1
    if (file%iline.gt.file%nline) then
       call cubetools_message(seve%e,rname,'Trying to read beyond end of the file')
       error = .true.
       return
    endif
    read(file%lun,'(a)') line
  end subroutine cubetools_ascii_file_read_next
  !
  subroutine cubetools_ascii_file_write_next(file,line,error)
    !----------------------------------------------------------------------
    ! write next line to an ASCII file
    !----------------------------------------------------------------------
    class(ascii_file_t),  intent(inout) :: file
    character(len=*),     intent(in)    :: line
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='ASCII>FILE>WRITE>NEXT'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    write(file%lun,'(a)') trim(line)
    file%iline = file%iline+1
    file%nline = file%nline+1
  end subroutine cubetools_ascii_file_write_next
end module cubetools_ascii

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_modify
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cube_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_speline_types
  use cubetopology_spevsys_types
  use cubemain_messaging
  !
  public :: modify
  private
  !
  integer(kind=4), parameter :: axsetmode_l=16
  integer(kind=4), parameter :: naxsetmodes=1
  character(len=axsetmode_l), parameter :: axsetmodes(naxsetmodes) =  &
       (/ 'IGNOREDEGENERATE' /)
  integer(kind=4), parameter :: nrefspecaxes = 4
  character(len=*), parameter :: refspecaxes(nrefspecaxes) = &
       ['FREQUENCY ','WAVELENGTH','VELOCITY  ','REDSHIFT  ']
  integer(kind=4), parameter :: ifreq = 1
  integer(kind=4), parameter :: iwave = 2
  integer(kind=4), parameter :: ivelo = 3
  integer(kind=4), parameter :: ireds = 4
  !
  type :: modify_comm_t
     type(option_t),      pointer :: comm
     type(cubeid_arg_t),  pointer :: incube
     type(speline_opt_t)          :: freq
     type(spevsys_opt_t)          :: vsys
     type(option_t),      pointer :: axset
     type(keywordlist_comm_t), pointer :: axset_mode
     type(option_t),      pointer :: specaxis
     type(keywordlist_comm_t), pointer :: axis_arg
     type(option_t),      pointer :: redshift
     type(keywordlist_comm_t), pointer :: convention
     type(cube_prod_t),   pointer :: oucube
   contains
     procedure, public  :: register       => cubemain_modify_register
     procedure, private :: parse          => cubemain_modify_parse
     procedure, private :: parse_axset    => cubemain_modify_parse_axset
     procedure, private :: parse_specaxis => cubemain_modify_parse_specaxis
     procedure, private :: parse_redshift => cubemain_modify_parse_redshift
     procedure, private :: main           => cubemain_modify_main
  end type modify_comm_t
  type(modify_comm_t) :: modify
  !
  type modify_user_t
     type(cubeid_user_t)   :: cubeids
     logical               :: dospecaxis
     character(len=16)     :: specaxis
     type(speline_user_t)  :: freq
     type(spevsys_user_t)  :: vsys
     logical               :: doignoredegenerate
     logical               :: doredshift
     character(len=argu_l) :: redshift
     character(len=argu_l) :: convention
   contains
     procedure, private :: toprog => cubemain_modify_user_toprog
  end type modify_user_t
  !
  type modify_prog_t
     type(cube_t), pointer :: incube ! Input cube
     type(cube_t), pointer :: oucube ! Output cube
     type(speline_prog_t)  :: freq
     type(spevsys_prog_t)  :: vsys
     integer(kind=4)       :: ispecaxis
     real(kind=coor_k)     :: zval
     integer(kind=code_k)  :: conv_code
     logical               :: do     ! Is there something to de done?
     logical               :: dofreq
     logical               :: dovelocity
     logical               :: dospecaxis
     logical               :: doignoredegenerate
     logical               :: doredshift
   contains
     procedure, private :: header => cubemain_modify_prog_header 
  end type modify_prog_t
  !
contains
  !
  subroutine cubemain_modify_command(line,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(modify_user_t) :: user
    character(len=*), parameter :: rname='MODIFY>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call modify%parse(line,user,error)
    if (error) return
    call modify%main(user,error)
    if (error) return
  end subroutine cubemain_modify_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_modify_register(modify,error)
    use cubedag_allflags
    use cubetools_header_interface
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(modify_comm_t), intent(inout) :: modify
    logical,              intent(inout) :: error
    !
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    type(keywordlist_comm_t) :: keyarg
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='MODIFY>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'MODIFY','[cubeid]',&
         'Modify a header coherently',&
         'MODIFY applies coherent header updates and writes a modified cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Supported updates are /FREQUENCY, /VSYS, /AXSET, /SPECAXIS, and&
         & /REDSHIFT.'//strg_cr//&
         '- If no modifying option is provided, MODIFY reports "Nothing to be&
         & done".'//strg_cr//&
         '- /REDSHIFT is currently under development and currently logs that no&
         & header change is applied for this option.'//strg_cr//&
         '- Use EDIT for low-level manual header fixes when incoherences must be&
         & corrected directly.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> MODIFY 12co10:cube /FREQUENCY CO(1-0) 115.271 GHz'//strg_cr//&
         'CUBE> MODIFY 12co10:cube /VSYS 5 km/s /SPECAXIS VELOCITY'//strg_cr//&
         'CUBE> MODIFY 12co10:cube /AXSET IGNOREDEGENERATE',&
         cubemain_modify_command,&
         modify%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBE',&
         'Signal cube',&
         'If omitted, use the last matching cube (cube flag) in the default&
         & index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_subset,&
         modify%incube,&
         error)
    if (error) return
    !
    call modify%freq%register(&
         'Update line name/rest frequency and keep spectral coherence',&
         error)
    if (error) return
    !
    call modify%vsys%register(&
         'Update systemic velocity and keep spectral coherence',&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'AXSET','mode',&
         'Update axes-set structure',&
         'Update axes-set structure metadata.'//strg_cr//&
         'Current mode IGNOREDEGENERATE removes degenerate axes (size 1) from&
         & the output header axes set while keeping data values unchanged.',&
         modify%axset,error)
    if (error) return
    call keyarg%register(&
         'MODE',&
         'Axes set modification mode',&
         'Accepted value: IGNOREDEGENERATE.'//strg_cr//&
         'This mode removes degenerate axes (size 1) from the output header&
         & axes set.',&
         code_arg_mandatory,&
         axsetmodes,&
         .not.flexible,&
         modify%axset_mode,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'SPECAXIS','newaxis',&
         'Select active spectral axis representation',&
         'Set which spectral representation is used as the active spectral axis&
         & in the output header axes set.'//strg_cr//&
         'Accepted values are FREQUENCY, WAVELENGTH, VELOCITY, and REDSHIFT.',&
         modify%specaxis,error)
    if (error) return
    call keyarg%register(&
         'newaxis',&
         'Target spectral axis representation',&
         'Choose one of FREQUENCY, WAVELENGTH, VELOCITY, or REDSHIFT for the&
         & output header axes set.',&
         code_arg_mandatory,&
         refspecaxes,&
         .not.flexible,&
         modify%axis_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'REDSHIFT','z [convention]',&
         'Request systemic redshift update (under development)',&
         'Parse a systemic redshift value and an optional convention.'//strg_cr//&
         'If convention is omitted, RADIO is used.'//strg_cr//&
         '"*" for z keeps the current header redshift value.'//strg_cr//&
         'Current implementation logs a warning and does not modify the header&
         & yet.',&
         modify%redshift,error)
    if (error) return
    call stdarg%register(&
         'z',&
         'New systemic redshift',&
         'Requested systemic redshift value.'//strg_cr//&
         '"*" keeps the current header redshift value.'//strg_cr//&
         'Current implementation parses this value but does not apply header&
         & changes yet.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call keyarg%register(&
         'CONVENTION',&
         'Systemic redshift convention',&
         'Convention keyword for /REDSHIFT.'//strg_cr//&
         'If omitted, RADIO is used.'//strg_cr//&
         'Current implementation parses this value but does not apply header&
         & changes yet.',&
         code_arg_optional,&
         speconvnames,&
         .not.flexible,&
         modify%convention,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'MODIFY',&
         'Modified cube',&
         strg_emp,&
         [flag_modify],&
         modify%oucube,&
         error,&
         flagmode=keep_all)
    if (error) return
  end subroutine cubemain_modify_register
  !
  subroutine cubemain_modify_parse(modify,line,user,error)
    !-------------------------------------------------------------------
    ! Parsing facility for command
    !-------------------------------------------------------------------
    class(modify_comm_t), intent(in)    :: modify
    character(len=*),     intent(in)    :: line
    type(modify_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MODIFY>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,modify%comm,user%cubeids,error)
    if (error) return
    call modify%freq%parse(line,user%freq,error)
    if (error) return
    call modify%vsys%parse(line,user%vsys,error)
    if (error) return
    call modify%parse_axset(line,user,error)
    if (error) return
    call modify%parse_specaxis(line,user,error)
    if (error) return
    call modify%parse_redshift(line,user,error)
    if (error) return
    !
    ! VVV should this be an error?
    ! if (user%vsys%do.and.user%doredshift) then
    !    error = .true.?
    ! endif
  end subroutine cubemain_modify_parse
  !
  subroutine cubemain_modify_parse_axset(modify,line,user,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(modify_comm_t), intent(in)    :: modify
    character(len=*),     intent(in)    :: line
    type(modify_user_t),  intent(inout) :: user
    logical,              intent(inout) :: error
    !
    logical :: present
    integer(kind=4) :: imode
    character(len=argu_l) :: argum
    character(len=axsetmode_l) :: mode
    character(len=*), parameter :: rname='MODIFY>PARSE>AXSET'
    !
    call modify%axset%present(line,present,error)
    if (error) return
    if (present) then
       call cubetools_getarg(line,modify%axset,1,argum,mandatory,error)
       if (error) return
       call cubetools_disambiguate_strict(argum,axsetmodes,imode,mode,error)
       if (error) return
       user%doignoredegenerate = mode.eq.'IGNOREDEGENERATE'
    else
       user%doignoredegenerate = .false.
    endif
  end subroutine cubemain_modify_parse_axset
  !
  subroutine cubemain_modify_parse_specaxis(modify,line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(modify_comm_t), intent(in)    :: modify
    character(len=*),     intent(in)    :: line
    type(modify_user_t),  intent(inout) :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MODIFY>PARSE>SPECAXIS'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call modify%specaxis%present(line,user%dospecaxis,error)
    if (error) return
    if (user%dospecaxis) then
       call cubetools_getarg(line,modify%specaxis,1,user%specaxis,mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_modify_parse_specaxis
  !
  subroutine cubemain_modify_parse_redshift(modify,line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(modify_comm_t), intent(in)    :: modify
    character(len=*),     intent(in)    :: line
    type(modify_user_t),  intent(inout) :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MODIFY>PARSE>REDSHIFT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call modify%redshift%present(line,user%doredshift,error)
    if (error) return
    user%convention = 'RADIO'
    if (user%doredshift) then
       call cubetools_getarg(line,modify%redshift,1,user%redshift,mandatory,error)
       if (error) return
       call cubetools_getarg(line,modify%redshift,2,user%convention,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_modify_parse_redshift
  !
  subroutine cubemain_modify_main(modify,user,error)
    use cubeadm_copy_tool
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(modify_comm_t), intent(in)    :: modify
    type(modify_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(modify_prog_t) :: prog
    character(len=*), parameter :: rname='MODIFY>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    if (prog%do) then
       call prog%header(modify,error)
       if (error) return
       call cubeadm_copy_data(prog%incube,prog%oucube,error)
       if (error) return
    else
       call cubemain_message(seve%w,rname,"Nothing to be done")
    endif
  end subroutine cubemain_modify_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_modify_user_toprog(user,prog,error)
    use cubeadm_get
    use cubetools_unit
    use cubetools_user2prog
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(modify_user_t), intent(in)    :: user
    type(modify_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=16) :: kind
    type(unit_user_t) :: nounit
    character(len=*), parameter :: rname='MODIFY>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Is there something to do?
    prog%do = user%freq%do      .or.  &
              user%vsys%do      .or.  &
              user%dospecaxis   .or.  &
              user%doredshift   .or.  &
              user%doignoredegenerate
    !
    ! Read CUBE if there is something to be done with it and then
    ! define the work according to the parsing
    if (prog%do) then
        call cubeadm_get_header(modify%incube,user%cubeids,prog%incube,error)
        if (error) return
        !
        if (user%freq%do) then
           call user%freq%toprog(prog%incube,prog%freq,error)
           if (error) return
           prog%dofreq = .true.
        else
           prog%dofreq = .false.
        endif
        !
        if (user%vsys%do) then
           call user%vsys%toprog(prog%incube,prog%vsys,error)
           if (error) return
           prog%dovelocity = .true.
        else
           prog%dovelocity = .false.
        endif
        !
        prog%doignoredegenerate = user%doignoredegenerate
        !
        if (user%dospecaxis) then
           call cubetools_keywordlist_user2prog(modify%axis_arg,user%specaxis,prog%ispecaxis,kind,error)
           if (error) return
           prog%dospecaxis = .true.
        else
           prog%dospecaxis = .false.
        endif
        !
        prog%doredshift = user%doredshift
        if (prog%doredshift) then
           call nounit%get_from_code(code_unit_unk,error)
           if (error) return
           call cubetools_user2prog_resolve_star(user%redshift,nounit,prog%incube%head%spe%ref%z,prog%zval,error)
           if (error) return
           call cubetools_keywordlist_user2prog(modify%convention,user%convention,prog%conv_code,kind,error)
           if (error) return
        endif
    endif
  end subroutine cubemain_modify_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_modify_prog_header(prog,comm,error)
    use cubetools_axis_types
    use cubetools_axset_types
    use cubetools_header_methods
    use cubeadm_clone
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(modify_prog_t), intent(inout) :: prog
    type(modify_comm_t),  intent(in)    :: comm
    logical,              intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='MODIFY>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%oucube,prog%incube,prog%oucube,error)
    if (error) return
    !
    ! Modification of frequency must be done before other
    ! modifications do guarantee correct results when multiple options
    ! are given together
    !
    if (prog%dofreq) then
       call cubetools_header_modify_rest_frequency(prog%freq%freq,prog%oucube%head,error)
       if (error) return
       call cubetools_header_put_line(prog%freq%name,prog%oucube%head,error)
       if (error) return
       call cubetools_header_get_axis_head_f(prog%oucube%head,axis,error)
       if (error) return
       call cubetools_header_update_frequency_from_axis(axis,prog%oucube%head,error)
       if (error) return
    endif
    if (prog%dovelocity) then
       call cubetools_header_modify_frame_velocity(prog%vsys%velo,prog%oucube%head,error)
       if (error) return
       call cubetools_header_get_axis_head_v(prog%oucube%head,axis,error)
       if (error) return
       call cubetools_header_update_velocity_from_axis(axis,prog%oucube%head,error)
       if (error) return
    endif
    if (prog%doredshift) then
       call cubemain_message(seve%w,rname,'Under development, nothing modified')
       ! VVV This is the series of routines I estimate necessary to acomplish the job
       !
       ! call cubetools_header_modify_frame_redshift(prog%zval,prog%oucube%head,error)
       ! if (error) return
       ! call cubetools_header_modify_convention(prog%conv_code,prog%oucube%head,error)
       ! if (error) return
       ! call cubetools_header_get_axis_head_z(prog%oucube%head,axis,error)
       ! if (error) return
       ! call cubetools_header_update_redshift_from_axis(axis,prog%oucube%head,error)
       ! if (error) return
    endif
    if (prog%doignoredegenerate) then
       call cubetools_axset_ignore_degenerate(prog%oucube%head%set,error)
       if (error) return
    endif
    if (prog%dospecaxis) then
       select case(prog%ispecaxis)
       case(ifreq)
          call cubetools_header_update_axset_c(prog%oucube%head%spe%f,prog%oucube%head,error)
          if (error) return
       case(iwave)
          call cubetools_header_update_axset_c(prog%oucube%head%spe%l,prog%oucube%head,error)
          if (error) return
       case(ivelo)
          call cubetools_header_update_axset_c(prog%oucube%head%spe%v,prog%oucube%head,error)
          if (error) return
       case(ireds)
          call cubetools_header_update_axset_c(prog%oucube%head%spe%z,prog%oucube%head,error)
          if (error) return
       case default
          call cubemain_message(seve%e,rname,'Unrecognized axis type')
          error = .true.
          return
       end select
    endif
  end subroutine cubemain_modify_prog_header
end module cubemain_modify
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine class_resample(set,line,r,error)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_resample
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  !   RESAMPLE NX Xref Xval Xinc UNIT [shape] [width] [/FFT] [/NOFFT]
  ! [/LIKE GDFFile]
  ! Resamples a spectrum on a different grid
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='RESAMPLE'
  type(resampling) :: new
  logical :: dofft,dolike
  integer(kind=4), parameter :: optfft  =1
  integer(kind=4), parameter :: optnofft=2
  integer(kind=4), parameter :: optlike =3
  !
  ! Basic checks
  if (r%head%xnum.eq.0) then
     call class_message(seve%f,rname,'No spectrum in memory.')
     error = .true.
     return
  endif
  !
  ! Decode input line arguments
  dolike = sic_present(optlike,0)
  if (sic_present(0,1) .and. dolike) then
    call class_message(seve%e,rname,'Command takes no argument if /LIKE is present')
    error = .true.
    return
  endif
  if (dolike) then
    call resample_parse_like(rname,line,optlike,new,error)
  else
    call resample_parse_command(line,0,rname,r%head,new,error)
  endif
  if (error) return
  !
  if (sic_present(optfft,0).and.sic_present(optnofft,0)) then
     call class_message(seve%f,rname,'/FFT and /NOFFT are exclusive from each other')
     error = .true.
     return
  endif
  dofft = sic_present(optfft,0)
  !
  ! Resample the R buffer
  call do_resample(set,r,new,dofft,error)
  if (error)  return
  !
  ! Finish the work
  call newdat(set,r,error)
  call newdat_assoc(set,r,error)
  !
end subroutine class_resample
!
subroutine resample_parse_command(line,iopt,rname,ref,new,error)
  use gbl_message
  use gkernel_interfaces
  use classcore_interfaces, except_this=>resample_parse_command
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Parse resample parameters from command line
  !
  !  If frequency resampling, take care that the new resolution is
  ! returned in the current (usually observatory) frame of the reference
  ! header. BUT if the user invokes the command with an explicit value
  ! (i.e. something different from * or =), it is assumed to be given in
  ! the rest frame, and will be converted to the current frame. The idea
  ! behind this is that RESAMPLE does not modify the spectrum frame, but
  ! the user can RESAMPLE a serie of spectra to the same REST frequency
  ! resolution.
  !
  ! Default channel shapes and widths for 30-m (AOS unaccounted for)
  ! Shape is TPAR for telescopes other than the 30m
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  integer(kind=4),  intent(in)    :: iopt   ! Number of the RESAMPLE option
  character(len=*), intent(in)    :: rname  ! Calling routine name
  type(header),     intent(in)    :: ref    ! Reference header
  type(resampling), intent(out)   :: new    ! New definition of X-axis sampling
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=4) :: nc,nchain,nutype
  integer(kind=4), parameter :: mutype=3
  character(len=16) :: utype(mutype),name
  character(len=128) :: chain  ! Should be long enough to accomodate double
                               ! precision values, or even any formula
  character(len=message_length) :: mess
  real(kind=8) :: val,dnu
  logical :: specunit,speckind,reverted
  integer(kind=4), parameter :: iarg_nchan=1
  integer(kind=4), parameter :: iarg_ref  =2
  integer(kind=4), parameter :: iarg_val  =3
  integer(kind=4), parameter :: iarg_inc  =4
  integer(kind=4), parameter :: iarg_unit =5
  integer(kind=4), parameter :: iarg_shape=6
  integer(kind=4), parameter :: iarg_width=7
  ! Accepted type of units
  data utype/'VELOCITY','FREQUENCY','ANGLE'/
  !
  ! Order matters here, especially if using wildcards!
  !
  ! UNIT: Axis unit
  call sic_ke(line,iopt,iarg_unit,chain,nchain,.true.,error)
  if (error) return
  call sic_ambigs(rname,chain,name,nutype,utype,mutype,error)
  if (error) return
  new%unit = name(1:1)
  !
  ! Sanity
  specunit = new%unit.eq.'V' .or. new%unit.eq.'F'
  speckind = ref%gen%kind.eq.kind_spec
  if (specunit.neqv.speckind) then
    call class_message(seve%e,rname,'Unit '//new%unit//' is invalid for this data kind')
    error = .true.
    return
  endif
  !
  ! XVAL: Axis value at ref channel
  call sic_ch(line,iopt,iarg_val,chain,nchain,.true.,error)
  if (error)  return
  if (chain.eq.'=' .or. chain.eq.'*') then
    if (new%unit.eq.'V') then
      new%val = ref%spe%voff
    elseif (new%unit.eq.'F') then
      new%val = ref%spe%restf
    elseif (new%unit.eq.'A') then
      new%val = ref%dri%aref
    endif
  else
    call sic_math_dble(chain,nchain,new%val,error)
    if (error) return
  endif
  !
  ! XINC: Axis resolution
  call sic_ch(line,iopt,iarg_inc,chain,nchain,.true.,error)
  if (error)  return
  reverted = .false.  ! Reverted axis?
  if (chain.eq.'=' .or. chain.eq.'*') then
    if (new%unit.eq.'V') then
      new%inc = ref%spe%vres
    elseif (new%unit.eq.'F') then
      new%inc = ref%spe%fres  ! Reuse the value in the observatory frame
    elseif (new%unit.eq.'A') then
      new%inc = ref%dri%ares
    endif
  else
    call sic_math_dble(chain,nchain,new%inc,error)
    if (error) return
    if (new%unit.eq.'V') then
      reverted = new%inc*ref%spe%vres.lt.0.d0  ! Reverted axis?
    elseif (new%unit.eq.'F') then
      ! User value is given in the rest frame: apply Doppler correction (if
      ! available) to convert it to current (observatory) frame.
      if (ref%spe%doppler.ne.-1.d0)  new%inc = new%inc*(1.d0+ref%spe%doppler)
      reverted = new%inc*ref%spe%fres.lt.0.d0  ! Reverted axis?
    elseif (new%unit.eq.'A') then
      reverted = new%inc*ref%dri%ares.lt.0.d0  ! Reverted axis?
    endif
  endif
  if (new%unit.eq.'F') then
    if (ref%spe%doppler.ne.-1.d0) then
      dnu = new%inc/(1.d0+ref%spe%doppler)
      write(mess,'(A,2(F0.5,A))')  &
        'Frequency resolution: ',new%inc,' MHz (observatory), ',  &
        dnu,' MHz (rest frame)'
    else
      dnu = new%inc
      write(mess,'(A,F0.5,A)')  &
        'Frequency resolution: ',new%inc,' MHz (observatory, Doppler unknown)'
    endif
    call class_message(seve%i,rname,mess)
  endif
  !
  ! XREF: Axis reference channel
  call sic_ch(line,iopt,iarg_ref,chain,nchain,.true.,error)
  if (error)  return
  if (chain.eq.'=') then
    new%ref = ref%spe%rchan
  elseif (chain.eq.'*') then
    ! Automatic: define Xref such as new 1st channel and old 1st channel are
    ! aligned (more precisely: left side of 1st channels). If axis has to
    ! be reverted (opposite sign), align new first channel on old last channel.
    if (new%unit.eq.'V') then
      if (reverted) then
        call abscissa_velo_right(ref,val)
      else
        call abscissa_velo_left(ref,val)
      endif
      new%ref = .5d0 - (val-new%val)/new%inc
    elseif (new%unit.eq.'F') then
      if (reverted) then
        call abscissa_sigabs_right(ref,val)
      else
        call abscissa_sigabs_left(ref,val)
      endif
      new%ref = .5d0 - (val-new%val)/dnu
    elseif (new%unit.eq.'A') then
      if (reverted) then
        call abscissa_angl_right(ref,val)
      else
        call abscissa_angl_left(ref,val)
      endif
      new%ref = .5d0 - (val-new%val)/new%inc
    endif
  else
    call sic_math_dble(chain,nchain,new%ref,error)
    if (error) return
  endif
  !
  ! NCHAN: Axis number of channels
  call sic_ch(line,iopt,iarg_nchan,chain,nchain,.true.,error)
  if (error)  return
  if (chain.eq.'=') then
    new%nchan = ref%spe%nchan
  elseif (chain.eq.'*') then
    ! Automatic: define Nchan such as new last channel and old last channel
    ! are aligned (more precisely: right side of last channels). If axis has
    ! to be reverted (opposite sign), align new last channel on old fist
    ! channel.
    if (new%unit.eq.'V') then
      if (reverted) then
        call abscissa_velo_left(ref,val)
      else
        call abscissa_velo_right(ref,val)
      endif
      new%nchan = ceiling(new%ref - .5d0 + (val-new%val)/new%inc)
    elseif (new%unit.eq.'F') then
      if (reverted) then
        call abscissa_sigabs_left(ref,val)
      else
        call abscissa_sigabs_right(ref,val)
      endif
      new%nchan = ceiling(new%ref - .5d0 + (val-new%val)/dnu)
    elseif (new%unit.eq.'A') then
      if (reverted) then
        call abscissa_angl_left(ref,val)
      else
        call abscissa_angl_right(ref,val)
      endif
      new%nchan = ceiling(new%ref - .5d0 + (val-new%val)/new%inc)
    endif
  else
    call sic_math_inte(chain,nchain,new%nchan,error)
    if (error) return
    new%nchan = max(new%nchan,1)
  endif
  !
  ! SHAPE: Channel shape (optional)
  if (sic_present(iopt,iarg_shape)) then
    call sic_ch(line,iopt,iarg_shape,chain,nchain,.true.,error)
    if (error)  return
    if (chain.eq.'=' .or. chain.eq.'*') then
      new%shape = channel_shape(ref%gen%teles)
    else
      call sic_ke(line,iopt,iarg_shape,new%shape,nc,.true.,error)
      if (error) return
    endif
  else
    new%shape = channel_shape(ref%gen%teles)
  endif
  !
  ! WIDTH: Channel width (optional)
  if (sic_present(iopt,iarg_width)) then
    call sic_ch(line,iopt,iarg_width,chain,nchain,.true.,error)
    if (error)  return
    if (chain.eq.'=' .or. chain.eq.'*') then
      new%width = 1.0
    else
      call sic_math_real(chain,nchain,new%width,error)
      if (error) return
    endif
  else
    new%width = 1.0
  endif
  !
  write(mess,'(A,I0,3(A,F0.3),A,L1,5A,F0.3)')  &
    'Nchan: ',new%nchan,', Ref: ',new%ref,', Val: ',new%val,', Inc: ',  &
    new%inc,' (reverted: ',reverted,'), Unit: ',new%unit,', Shape: ',   &
    trim(new%shape),', Width: ',new%width
  call class_message(seve%d,rname,mess)
  !
end subroutine resample_parse_command
!
subroutine resample_parse_like(rname,line,iopt,new,error)
  use gbl_message
  use image_def
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>resample_parse_like
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Parse /LIKE GDFFile option and setup a resampling structure
  ! according to the GDF header (can be an LMV cube or a UVT)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname  ! Calling routine name
  character(len=*), intent(in)    :: line   ! Command line
  integer(kind=4),  intent(in)    :: iopt   ! Option number
  type(resampling), intent(out)   :: new    ! New definition of X-axis sampling
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  type(gildas) :: hgdf
  type(header) :: hclass
  integer(kind=4) :: nc
  !
  call gildas_null(hgdf)
  !
  ! Parse command line
  call sic_ch(line,iopt,1,hgdf%file,nc,.true.,error)
  if (error)  return
  !
  ! Read GDF header
  call gdf_read_header(hgdf,error)
  if (error) return
  call class_message(seve%i,rname,'/LIKE file is '//hgdf%file)
  !
  ! Build a Class spectro section from GDF header
  call gdf2class_spectro(hgdf,hclass,error)
  if (error)  return
  !
  ! Setup the resampling description
  new%nchan = hclass%spe%nchan
  new%ref   = hclass%spe%rchan
  new%val   = hclass%spe%voff
  new%inc   = hclass%spe%vres
  new%unit  = 'V'
  new%shape = '*'  ! Need the telescope name to guess the shape...
  new%width = 1.0
  !
end subroutine resample_parse_like
!
function channel_shape(teles)
  use gkernel_interfaces
  use classcore_interfaces, except_this=>channel_shape
  !---------------------------------------------------------------------
  ! @ private
  ! Return the channel shape given the telescope name.
  ! Test is not very robust as PI often temper with the telescope name
  ! to get other information like the used backend, the OTF scanning
  ! direction...
  !---------------------------------------------------------------------
  character(len=4) :: channel_shape  ! Function value on return
  character(len=*), intent(in) :: teles  ! Telescope name
  ! Local
  character(len=12) :: cteles
  integer(kind=4) :: backnum
  character(len=4) :: def_shape(9)
  ! Shape of the channel response for each 30m backend.
  data def_shape /3*'FBOX',2*'TPAR',4*'FBOX'/
  !
  cteles = teles
  call sic_upper(cteles)
  if (cteles(1:8).eq.'IRAM-30M') then
     read (cteles(11:11),'(i1)') backnum
     channel_shape = def_shape(backnum)
  else
     channel_shape = 'TPAR'
  endif
  !
end function channel_shape
!
subroutine do_resample(set,obs,new_in,dofft,error)
  use gildas_def
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>do_resample
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Resample the observation
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set     !
  type(observation),   intent(inout) :: obs     ! Observation before and after resampling
  type(resampling),    intent(in)    :: new_in  ! New definition of X-axis sampling
  logical,             intent(in)    :: dofft   ! In frequency or time domain (the default)
  logical,             intent(out)   :: error   ! Error flag
  ! Local
  character(len=*), parameter :: rname='RESAMPLE'
  logical          :: resample
  character(len=80) :: mess
  integer(kind=4)  :: ikappa
  type(resampling) :: old,new   ! Definition of X-axis sampling
  type(extract_t) :: extr  ! Description of the extraction, if relevant
  real(kind=8) :: kappa,old_restf
  real(kind=8), parameter :: precis=1.d-3  ! Would 1% of a channel on the total spectra bandwidth be enough?
  !
  error = .false.
  new = new_in  ! This avoids modifying the input 'new'
  !
  ! Channel shape and width
  old%shape = channel_shape(obs%head%gen%teles)
  old%width = 1.0  ! Why old%width is arbitrary set to 1? *** JP
  !
  ! Work space
  old%nchan = obs_nchan(obs%head)
  !
  ! Test whether a translation is enough instead of a full resampling
  if (obs%head%presec(class_sec_xcoo_id)) then
     ! Irregularly spaced data
     if (new%unit.ne.set%unitx(1)) then
        mess = 'Unit modification not supported for irregularly sampled data '
        call class_message(seve%f,rname,mess)
        error = .true.
        return
     endif
     resample = .true.
     if (new%unit.eq.'F') then
       ! Modify frequency
       old_restf = obs%head%spe%restf
       obs%head%spe%restf = new%val
       ! We should shift accordingly all the RDATAX. But we can also
       ! put this shift in new%val:
       new%val = obs%head%spe%restf-old_restf
     endif
  else
     ! Regularly spaced data
     if (new%unit.eq.'V') then
        ! Velocity unit
        call modify_velocity(obs,new%val,error)
        if (error)  return
        !
        old%ref = obs%head%spe%rchan
        old%val = obs%head%spe%voff
        old%inc = obs%head%spe%vres
        !
     elseif (new%unit.eq.'F') then
        ! Frequency unit => the reference frequency is set to 'new%val'
        call modify_frequency(obs,new%val,error)
        if (error)  return
        new%val = 0.d0  ! New FOFF
        !
        old%ref = obs%head%spe%rchan
        old%val = 0.d0
        old%inc = obs%head%spe%fres
        !
     elseif (new%unit.eq.'A') then
        ! Angle unit
        old%ref = obs%head%dri%rpoin
        old%val = obs%head%dri%aref
        old%inc = obs%head%dri%ares
        !
     else
        mess = 'Invalid unit type '//new%unit
        call class_message(seve%f,rname,mess)
        error = .true.
        return
     endif
     old%unit = new%unit
     !
     if (dofft) then
       ! Always resample, i.e. do not use the extraction mode if FFT is requested
       resample = .true.
       !
     else
       ! Should we really resample or just extract a subset?
       !    Test 1: Does the new resolution differ too much from old one?
       resample = abs((new%inc/old%inc-1.d0)*new%nchan).gt.precis
       !
       if (.not.resample) then
         ! Test 2: Are the value and reference channels changed inconsistently?
         !         so that: whatever old_i, new%i = old_i + kappa
         !                  with kappa integer
         !  Note that small offsets in value and reference channels do not
         !  amplify with increasing number of channels, i.e. the effect is the
         !  same on the 10th channel and on the 1000000th...
         kappa = (new%ref-old%ref) + (old%val-new%val)/old%inc
         ikappa = nint(kappa)
         resample = abs(kappa-ikappa).gt.precis
       endif
     endif
  endif
  !
  ! Do the real job
  if (resample) then
    ! Resampling (also resamples the Associated Arrays)
    call do_resample_sub(set,obs,old,new,dofft,error)
    if (error)  return
  else
     ! No resampling needed, only extract (also extracts the Associated Arrays)
     if ((1-ikappa).gt.old%nchan .or. (new%nchan-ikappa).lt.1) then
       ! Check is done out of do_extract for efficiency of the EXTRACT
       ! command.
       call do_resample_nointersecterror_regul(old,new)
       error = .true.
     else
       extr%rname = rname
       extr%c1 = 1-ikappa
       extr%c2 = new%nchan-ikappa
       extr%nc = new%nchan
       call do_extract(obs,extr,error)
     endif
  endif
  if (error)  return
  !
  ! Update header
  if (new%unit.eq.'V') then
    obs%head%spe%nchan = new%nchan
    obs%head%spe%rchan = new%ref
  ! obs%head%spe%doppler = unchanged (stay in the same frame)
    obs%head%spe%vres = new%inc
    obs%head%spe%voff = new%val
  ! obs%head%spe%restf = unchanged
    obs%head%spe%fres = -obs%head%spe%restf/clight_kms*obs%head%spe%vres
  elseif (new%unit.eq.'F') then
    obs%head%spe%nchan = new%nchan
    obs%head%spe%rchan = new%ref
  ! obs%head%spe%doppler = unchanged (stay in the same frame)
  ! obs%head%spe%restf = changed in modify_frequency
    obs%head%spe%fres = new%inc
    obs%head%spe%vres = -clight_kms/obs%head%spe%restf*obs%head%spe%fres
  ! obs%head%spe%voff = unchanged
  elseif (new%unit.eq.'A') then
    obs%head%dri%npoin = new%nchan
    obs%head%dri%rpoin = new%ref
    obs%head%dri%ares  = new%inc
    obs%head%dri%aref  = new%val
  ! obs%head%dri%tref  = unknown?
  ! obs%head%dri%tres  = unknown?
  endif
  !
end subroutine do_resample
!
subroutine do_resample_sub(set,obs,old,new,dofft,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>do_resample_sub
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(observation),   intent(inout) :: obs    !
  type(resampling),    intent(in)    :: old    ! Old X-axis sampling
  type(resampling),    intent(inout) :: new    ! New X-axis sampling (increment can be updated)
  logical,             intent(in)    :: dofft  ! In frequency or time domain (the default)
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RESAMPLE'
  real(kind=4), allocatable :: idatay(:)
  integer(kind=4) :: ier
  logical :: isirreg
  !
  ! Save input Y values in dedicated array
  allocate(idatay(old%nchan),stat=ier)
  if (failed_allocate(rname,'y value workspace',ier,error))  return
  idatay(1:old%nchan) = obs%spectre(1:old%nchan)
  !
  ! Enlarge data space when needed
  call reallocate_obs(obs,new%nchan,error)
  if (error) return
  obs%head%spe%nchan = new%nchan
  obs%cnchan = new%nchan
  !
  isirreg = obs%head%presec(class_sec_xcoo_id)
  call do_resample_generic(set,obs%datax,idatay,obs%spectre,obs%dataw,obs%cbad,  &
    isirreg,old,new,dofft,error)
  if (error)  return
  !
  if (obs%head%presec(class_sec_assoc_id)) then
    ! Also resample Associated Arrays
    isirreg = obs%head%presec(class_sec_xcoo_id)
    call resample_assoc(set,obs%assoc,obs%datax,isirreg,old,new,dofft,error)
    if (error) then
      call class_message(seve%w,rname,  &
        'Section Associated Array could not be resampled. Removed.')
      obs%head%presec(class_sec_assoc_id) = .false.
      call rzero_assoc(obs)
      error = .false.  ! Not fatal
    endif
  endif
  !
  ! Irregularly sampled X axis normally became regular
  obs%head%presec(class_sec_xcoo_id) = isirreg
  !
end subroutine do_resample_sub
!
subroutine do_resample_generic(set,idatax,idatay,odatay,odataw,bad,isirreg,  &
  old,new,dofft,error)
  use classcore_interfaces, except_this=>do_resample_generic
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Resample any kind of array
  !---------------------------------------------------------------------
  type(class_setup_t),   intent(in)    :: set        !
  real(kind=xdata_kind), intent(in)    :: idatax(:)  !
  real(kind=4),          intent(in)    :: idatay(:)  !
  real(kind=4),          intent(out)   :: odatay(:)  !
  real(kind=4),          intent(out)   :: odataw(:)  !
  real(kind=4),          intent(in)    :: bad        !
  logical,               intent(inout) :: isirreg    ! Is X axis regularly sampled?
  type(resampling),      intent(in)    :: old        ! Old X-axis sampling
  type(resampling),      intent(inout) :: new        ! New X-axis sampling
  logical,               intent(in)    :: dofft      !
  logical,               intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4) :: irmin,irmax
  !
  ! Look for first non-blanked channel
  irmin = obs_firstgood(idatay,old%nchan,bad)
  !
  if (irmin.eq.old%nchan) then
    ! All channels are blanked. Fill all channels with blanks and return
    odatay(1:new%nchan) = bad
    return
  endif
  !
  if (dofft) then
    ! Look for last non-blanked channel
    irmax = obs_lastgood(idatay,old%nchan,bad)
    call do_resample_fft(idatay,odatay,bad,isirreg,irmin,irmax,old,new,error)
  else
    call do_resample_direct(set,idatax,idatay,odatay,odataw,bad,isirreg,old,new,error)
  endif
  if (error)  return
  !
end subroutine do_resample_generic
!
subroutine do_resample_fft(idatay,odatay,bad,isirreg,irmin,irmax,  &
  old_in,new_in,error)
  use gbl_message
  use gkernel_interfaces
  use classcore_interfaces, except_this=>do_resample_fft
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! FFT resampling on a regularly spaced axis
  !---------------------------------------------------------------------
  real(kind=4),         intent(in)    :: idatay(:)  ! Size old%nchan
  real(kind=4), target, intent(out)   :: odatay(:)  ! Size new%nchan
  real(kind=4),         intent(in)    :: bad        !
  logical,              intent(in)    :: isirreg    !
  integer(kind=4),      intent(in)    :: irmin      ! First input channel to be used
  integer(kind=4),      intent(in)    :: irmax      ! Last input channel to be used
  type(resampling),     intent(in)    :: old_in     ! Old X-axis sampling
  type(resampling),     intent(inout) :: new_in     ! New X-axis sampling
  logical,              intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RESAMPLE'
  real(kind=4), allocatable :: yvalue(:)
  integer(kind=4) :: ier,ismin,ismax,richan
  type(resampling) :: old,new
  real(kind=4), pointer :: newspectre(:)
  !
  if (isirreg) then
    call class_message(seve%e,rname,  &
      '/FFT is not supported on an irregularly sampled X axis')
    error = .true.
    return
  endif
  !
  ! Compute the output range to be updated:
  old       = old_in
  old%nchan = irmax-irmin+1
  old%ref   = old_in%ref-real(irmin-1,kind=8)
  call resample_interpolate_range(old,new_in,.false.,ismin,ismax,error)
  if (error)  return
  !
  ! Copy input data with special treatment to blanked channels
  allocate (yvalue(old%nchan),stat=ier)
  if (failed_allocate(rname,'y value workspace',ier,error))  goto 100
  do richan=irmin,irmax
    yvalue(richan-irmin+1) = obs_good(idatay,bad,irmin,irmax,richan)
  enddo
  !
  ! Output spectrum: fill blank pixels at edges
  odatay(1:ismin-1) = bad
  odatay(ismax+1:new_in%nchan) = bad
  !
  new       = new_in
  new%nchan = ismax-ismin+1
  new%ref   = new_in%ref-real(ismin-1,kind=8)
  newspectre => odatay(ismin:ismax)
  call fft_interpolate(yvalue,old,newspectre,new,error)
  if (error)  goto 100
  new_in%inc = new%inc  ! May have been updated
  !
100 continue
  ! Free memory
  if (allocated(yvalue)) deallocate(yvalue)
  !
end subroutine do_resample_fft
!
subroutine do_resample_direct(set,idatax,idatay,odatay,odataw,bad,  &
  isirreg,old,new,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>do_resample_direct
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Direct interpolation
  !---------------------------------------------------------------------
  type(class_setup_t),   intent(in)    :: set        !
  real(kind=xdata_kind), intent(in)    :: idatax(:)  ! Size old%nchan
  real(kind=4),          intent(in)    :: idatay(:)  ! Size old%nchan
  real(kind=4),          intent(out)   :: odatay(:)  ! Size new%nchan
  real(kind=4),          intent(out)   :: odataw(:)  ! Size new%nchan
  real(kind=4),          intent(in)    :: bad        !
  logical,               intent(inout) :: isirreg    ! Is X axis regularly sampled?
  type(resampling),      intent(in)    :: old        ! Old X-axis sampling
  type(resampling),      intent(in)    :: new        ! New X-axis sampling
  logical,               intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RESAMPLE'
  real(kind=4), allocatable :: idataw(:)
  integer(kind=4) :: ier,ismin,ismax
  !
  allocate (idataw(old%nchan),stat=ier)
  if (failed_allocate(rname,'w value workspace',ier,error))  goto 100
  idataw(:) = 1.
  !
  if (isirreg) then
    ! Irregularly spaced axis
    call resample_interpolate_irreg(set,                          &
                                    idatax,idatay,bad,old%nchan,  &
                                    odatay,odataw,bad,new,error)
    if (error)  goto 100
    isirreg = .false.
    !
  else
    call resample_interpolate_regul(set,                    &
                                    idatay,idataw,bad,old,  &
                                    odatay,odataw,bad,new,  &
                                    ismin,ismax,error)
    if (error)  goto 100
  endif
  !
  ! odataw == 0 means no data or bad data: blank them
  where (odataw(1:new%nchan).eq.0.)
    odatay(1:new%nchan) = bad
  end where
  !
100 continue
  ! Free memory
  if (allocated(idataw)) deallocate(idataw)
  !
end subroutine do_resample_direct
!
subroutine do_resample_nointersecterror_regul(old,new)
  use gbl_message
  use classcore_interfaces, except_this=>do_resample_nointersecterror_regul
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(resampling), intent(in) :: old  ! Old X-axis sampling
  type(resampling), intent(in) :: new  ! New X-axis sampling
  ! Local
  character(len=*), parameter :: rname='RESAMPLE'
  real(kind=8) :: rxmin,rxmax,sxmin,sxmax
  character(len=message_length) :: mess
  !
  call class_message(seve%e,rname,  &
    'New spectrum does not intersect the original one')
  !
  rxmin = (           .5d0 -old%ref)*old%inc+old%val
  rxmax = ((old%nchan+.5d0)-old%ref)*old%inc+old%val
  sxmin = (           .5d0 -new%ref)*new%inc+new%val
  sxmax = ((new%nchan+.5d0)-new%ref)*new%inc+new%val
  !
  write(mess,'(A,A,2(A,F0.2,1X,F0.2))')                    &
           'Original ',new%unit,                           &
            ' range: ',min(rxmin,rxmax),max(rxmin,rxmax),  &
             ', new: ',min(sxmin,sxmax),max(sxmin,sxmax)
  call class_message(seve%e,rname,mess)
  !
end subroutine do_resample_nointersecterror_regul
!
subroutine do_resample_nointersecterror_irreg(rdatax,rnchan,new)
  use gbl_message
  use class_parameter
  use classcore_interfaces, except_this=>do_resample_nointersecterror_irreg
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(xdata_kind), intent(in) :: rdatax(:)  ! Old irregular X-axis
  integer(kind=4),  intent(in) :: rnchan     ! Number of channels
  type(resampling), intent(in) :: new        ! New X-axis sampling
  ! Local
  character(len=*), parameter :: rname='RESAMPLE'
  real(kind=8) :: rxmin,rxmax,sxmin,sxmax
  character(len=message_length) :: mess
  !
  call class_message(seve%e,rname,  &
    'New spectrum does not intersect the original one')
  !
  rxmin = rdatax(1)
  rxmax = rdatax(rnchan)
  sxmin = (           .5d0 -new%ref)*new%inc+new%val
  sxmax = ((new%nchan+.5d0)-new%ref)*new%inc+new%val
  !
  write(mess,'(A,A,2(A,F0.2,1X,F0.2))')                    &
           'Original ',new%unit,                           &
            ' range: ',min(rxmin,rxmax),max(rxmin,rxmax),  &
             ', new: ',min(sxmin,sxmax),max(sxmin,sxmax)
  call class_message(seve%e,rname,mess)
  !
end subroutine do_resample_nointersecterror_irreg
!
subroutine fft_interpolate(y,old,x,new,error)
  use gbl_message
  use classcore_interfaces, except_this=>fft_interpolate
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Performs the interpolation/integration, using FFT.
  ! SHAPE: Channel shape in TBox, TParabola, FBox or Ftriangle
  !  TBox means a box in delay space          (unsmoothed correlator, w=1)
  !  Ppar means a parabola in delay space     (smoothed correlator, w=1)
  !  FBox means a box in frequency space      (square filter, w=0.5)
  !  FTri means a triangle in frequency space (Hanning smoothed square filter, w=1)
  !---------------------------------------------------------------------
  real(kind=4),     intent(in)    :: y(:)     ! Input spectrum
  type(resampling), intent(in)    :: old      ! Old axis description
  real(kind=4),     intent(out)   :: x(:)     ! Output spectrum
  type(resampling), intent(inout) :: new      ! New axis description (increment can be rounded)
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FFT_INTERPOLATE'
  integer(kind=4) :: ier,nstep,nx,ioff,p
  complex(kind=4), allocatable :: yp(:), wp(:)
  real(kind=4) :: step,c1,roff,yval1
  character(len=message_length) :: chain
  !
  if (old%width.lt.1.0 .or. new%width.lt.1.0) then
    call class_message(seve%e,rname,'Channel width can not be lower than 1.0')
    error = .true.
    return
  endif
  !
  ! Steps in FFT space are 1/(old%nchan*old%inc)=step
  step = 1d0/(old%nchan*old%inc)
  nx = nint(1d0/step/new%inc)
  nx = abs(nx)
  call pfactor(nx,p)
  do while (p.gt.100)
     nx = nx+1
     call pfactor(nx,p)
  enddo
  nstep = max(nx,2*old%nchan)
  ! check for large prime factors
  if (new%inc.ne.1d0/step/nx) then
     new%inc = sign(1.d0/step/nx,new%inc)
     write(chain,'(a,1pg13.6)') 'Output channel separation rounded to ',new%inc
     call class_message(seve%i,rname,chain)
  endif
  !
  ! Do FFT of input spectrum
  allocate(yp(nstep),wp(nstep),stat=ier)
  if (ier.ne.0) then
     error = .true.
     return
  endif
  call r4toc4(y,yp,old%nchan)
  if (old%inc*new%inc.lt.0d0) then
     ! Ensure that the old and new axes increase in the same direction (channel-wise)
     call reverse(old%nchan,yp)
     yval1 = old%val+(old%nchan-old%ref)*old%inc  ! Value at first old channel
  else
     yval1 = old%val+(1.-old%ref)*old%inc  ! Value at first old channel
  endif
  call fourt(yp,old%nchan,1,1,0,wp)
  call fft_normalize(old%nchan,yp)
  !
  ! Deconvolve from input channel shape
  call fft_deconv(old%nchan,yp,old%width,old%shape)
  if (nstep.gt.old%nchan) then
     call fft_extend(yp,old%nchan,nstep)
  endif
  !
  ! Convolve to output channel shape
  if (nx.lt.nstep) then
     call fft_cutoff(yp,nstep,nx)
  endif
  call fft_reconv(nx,yp,new%width,new%shape)
  !
  ! Correct for channel offset
  c1 = (yval1-new%val)/new%inc+new%ref  ! Position of yval1 on the new axis (channel)
  roff = 1.-c1       ! Channel offset (old-new)
  ioff = nint(roff)  ! Channel offset (integer part)
  roff = roff-ioff   ! Channel offset (residual in the range [-.5,.5])
  call fft_offset(roff,nx,yp)
  !
  ! FFT to output spectrum
  call fourt(yp,nx,1,-1,1,wp)
  if (ioff.ge.0) then
    call c4tor4(yp(1+ioff),x,new%nchan)
  else
    ! This should never happen because when calling fft_interpolate, the
    ! command sends only the subpart of the spectrum to be filled, and
    ! modifies new%ref to loc_ref accordingly. Example:
    !      Xref  Xval Xinc
    ! Old   1.    1.   1.     1st channel has velocity 1.
    ! New  10.    1.   1.     10th channel has velocity 1.
    ! Sent  0.    1.   1.     0th channel has velocity 1.
    ! In the 'sent' spectrum, previous channels are first filled with
    ! blanks and then ignored, and the others are effectively filled here.
    call class_message(seve%e,rname,  &
      'Internal error, unsupported axes configuration')
    call class_message(seve%e,rname,  &
      'Please send your spectrum and the RESAMPLE command to gildas@iram.fr')
    error = .true.
    ! call c4tor4(yp,x,new%nchan)  ! CLASS77 implementation, probably wrong
  endif
  deallocate(wp,yp)
end subroutine fft_interpolate
!
subroutine fft_offset(x,nc,z)
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  ! Offset by x channels
  !---------------------------------------------------------------------
  real,    intent(in)    :: x     ! offset by x channels
  integer, intent(in)    :: nc    ! Dimension of input array
  complex, intent(inout) :: z(nc) ! Input array
  ! Local
  complex :: expiarg,expinarg
  integer :: ic
  real :: arg
  !
  arg = -2*pi/nc*x
  expiarg = cmplx(cos(arg),sin(arg))
  expinarg = cmplx(1.,0.)
  do ic=2,nc/2
     expinarg = expinarg*expiarg
     z(ic) = z(ic)*expinarg
     z(nc-ic+1) = z(nc-ic+1)/expinarg
  enddo
end subroutine fft_offset
!
subroutine fft_normalize(n,z)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer, intent(in)    :: n    ! Dimension of input array
  complex, intent(inout) :: z(n) ! Input array
  ! Local
  real :: norm
  !
  norm = 1.0/n
  z = z*norm
end subroutine fft_normalize
!
subroutine fft_reconv(n,y,w,shape)
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,          intent(in)    :: n     ! Dimension of input array
  complex,          intent(inout) :: y(n)  ! Input array
  real,             intent(in)    :: w     ! width (in terms of channel separation)
  character(len=*), intent(in)    :: shape ! Convolution function
  ! Local
  integer :: nmax,j,itab(n)
  real :: tmax,a,arg,fac(n)
  !
  tmax = n/w/2
  nmax = tmax
  a = 1./tmax**2
  arg = pi/tmax/2
  itab =  (/(mod(j-1+n/2,n)-n/2,j=1,n)/)
  select case (shape(1:2))
  case('TB')
     ! Raw Correlator channels (no smoothing, sin(pi f/w)/(pi x/w),
     !  w is the first zero, measured in channel spacings.)
     where (abs(itab).gt.nmax) y = (0.,0.)
  case('TP')
     ! Smoothed correlator channels (parabolic smoothing function)
     where (abs(itab).gt.nmax)
        y = (0.,0.)
     elsewhere
        y = y * (1.-a*itab**2)
     end where
  case('FB')
     ! Frequency Box of width = w * channel-spacing
     fac = arg*itab
     where (fac.ne.0.) y = y*sin(fac)/fac
  case('FT')
     ! Frequency Triangle of full-width = 2w * channel-spacing
     fac = arg*itab
     where (fac.ne.0.) y = y*(sin(fac)/fac)**2
  end select
end subroutine fft_reconv
!
subroutine fft_deconv(n,y,w,shape)
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,          intent(in)    :: n     ! Dimension of input array
  complex,          intent(inout) :: y(n)  ! Input array
  real,             intent(in)    :: w     ! width (in terms of channel separation)
  character(len=*), intent(in)    :: shape ! Convolution function
  ! Local
  integer :: j,itab(n)
  real :: tmax,a,arg,fac(n),sfac(n)
  !
  tmax = n/w/2
  a = 1./tmax**2
  arg = pi/tmax/2
  itab = (/(mod(j-1+n/2,n)-n/2,j=1,n)/)
  select case (shape(1:2))
  case('TB')
     ! Raw Correlator channels (no smoothing, sin(pi f/w)/(pi x/w),
     !  w is the first zero, measured in channel spacings.)
     ! nothing to do ...
     return
  case('TP')
     ! Smoothed correlator channels (parabolic smoothing function)
     where (a*itab**2.lt.1.) y = y/(1.-a*itab**2)
  case('FB')
     ! Frequency Box of half-width = w * channel-spacing
     fac = arg*itab
     sfac = sin(fac)
     where (sfac.ne.0.) y = y*fac/sfac
  case('FT')
     ! Frequency Triangle of half-full-width = 2w * channel-spacing
     fac = arg*itab
     sfac = sin(fac)
     where (sfac.ne.0.) y = y * (fac/sfac)**2
  end select
  !
end subroutine fft_deconv
!
subroutine reverse(n,r)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer, intent(in)    :: n
  complex, intent(inout) :: r(n)
  ! Local
  integer :: i
  complex :: temp
  !
  do i=1, n/2
     temp = r(i)
     r(i) = r(n-i+1)
     r(n-i+1) = temp
  enddo
end subroutine reverse
!
subroutine fft_extend(c,n,m)
  !---------------------------------------------------------------------
  ! @ private
  ! complete FFT with zeroes in high frequencies
  !   c[1:n/2]       : not touched
  !   c[n/2+1:m-n/2] = 0.
  !   c[m-n/2+1:m]   = c[n/2+1:n]
  !---------------------------------------------------------------------
  integer, intent(in)    :: n    ! Former dimension
  integer, intent(in)    :: m    ! New dimension
  complex, intent(inout) :: c(m) ! New array
  ! Local
  integer :: i,n2
  !
  n2 = n/2
  do i=1, n2
     c(m-i+1) = c(n-i+1)
  enddo
  do i=n2+1, m-n2
     c(i) = 0
  enddo
end subroutine fft_extend
!
subroutine fft_cutoff(c,m,n)
  !---------------------------------------------------------------------
  ! @ private
  ! Cutoff FFT in high frequencies
  !---------------------------------------------------------------------
  integer, intent(in)    :: n    ! Former dimension
  integer, intent(in)    :: m    ! New dimension
  complex, intent(inout) :: c(m) ! New array
  ! Local
  integer :: i,n2
  !
  n2 = n/2
  if (n.gt.2*n2) then
     c(n2+1) = (c(n2+1)+c(m-n2+1))/2.
  endif
  do i=n2, 1, -1
     c(n-i+1) = c(m-i+1)
  enddo
end subroutine fft_cutoff
!
subroutine resample_interpolate_range(old,new,edges,ismin,ismax,error)
  use classcore_interfaces, except_this=>resample_interpolate_range
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the range of channels to be updated in the output spectrum
  !---------------------------------------------------------------------
  type(resampling), intent(in)    :: old     ! Old X axis description
  type(resampling), intent(in)    :: new     ! New X axis description
  logical,          intent(in)    :: edges   ! Should we consider the edges?
  integer(kind=4),  intent(out)   :: ismin   ! Output channel range (min)
  integer(kind=4),  intent(out)   :: ismax   ! Output channel range (max)
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  real(kind=8) :: xr1,xr2,is1,is2
  !
  ! Look for the range of output channels we have to work on (no need to
  ! loop on is=1,new%nchan)
  if (edges) then
    xr1 = (          .5-old%ref)*old%inc+old%val
    xr2 = (old%nchan+.5-old%ref)*old%inc+old%val
  else
    xr1 = (       1.-old%ref)*old%inc+old%val
    xr2 = (old%nchan-old%ref)*old%inc+old%val
  endif
  is1 = (xr1-new%val)/new%inc+new%ref  ! Float value
  is2 = (xr2-new%val)/new%inc+new%ref  ! Float value
  ! - We know the range of S we want to work on, but at float channel
  ! values. Say 'eps' is a small value (<< 1). From N-0.5+eps to N+0.5-eps
  ! (float value) fall into channel #N (integer value): so this is the
  ! nint() definition!
  ! - Are there rounding problems at N-0.5 and N+0.5? Well, not really:
  ! in one case we add a channel in which R does not contribute, and in
  ! the other case we miss a channel in which R contributes but at most for
  ! an epsilon amount. So, no worry.
  if (is1.lt.is2) then
    ismin = nint(is1)
    ismax = nint(is2)
  else
    ismin = nint(is2)
    ismax = nint(is1)
  endif
  !
  ! - Is this range out of the spectrum limits?
  if (ismin.gt.new%nchan .or. ismax.lt.1) then
    call do_resample_nointersecterror_regul(old,new)
    error = .true.
    return
  endif
  !
  ! - Finally we minmax the values between 1 and new%nchan since R can be
  ! larger than S but we work only on the S channels.
  ismin = max(ismin,1)
  ismax = min(ismax,new%nchan)
  !
end subroutine resample_interpolate_range
!
subroutine resample_interpolate_regul(set,                     &
                                      rdata1,rdataw,rbad,old,  &
                                      sdata1,sdataw,sbad,new,  &
                                      ismin,ismax,error)
  use classcore_interfaces, except_this=>resample_interpolate_regul
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Main entry point for over- or under-sampling of a regularly
  ! spaced spectrum.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set        !
  real(kind=4),        intent(in)    :: rdata1(:)  ! Input spectrum
  real(kind=4),        intent(in)    :: rdataw(:)  ! Input weights
  real(kind=4),        intent(in)    :: rbad       ! Input bad value
  type(resampling),    intent(in)    :: old        ! Old axis description
  real(kind=4),        intent(out)   :: sdata1(:)  ! Output spectrum
  real(kind=4),        intent(out)   :: sdataw(:)  ! Output weights
  real(kind=4),        intent(in)    :: sbad       ! Output bad value
  type(resampling),    intent(in)    :: new        ! New axis description
  integer(kind=4),     intent(out)   :: ismin      ! Range of channels updated in...
  integer(kind=4),     intent(out)   :: ismax      ! ... the output spectrum.
  logical,             intent(inout) :: error      ! Logical error flag
  !
  if (new%shape.eq.'FBOX') then
    if (abs(new%inc).le.abs(old%inc)) then
      ! Regularly spaced axis, 3 point oversampling
      call resample_interpolate3_over(set,                     &
                                      rdata1,rdataw,rbad,old,  &
                                      sdata1,sdataw,sbad,new,  &
                                      ismin,ismax,error)
      if (error)  return
    else
      ! Regularly spaced axis, 3 point undersampling
      call resample_interpolate3_under(set,                     &
                                       rdata1,rdataw,rbad,old,  &
                                       sdata1,sdataw,sbad,new,  &
                                       ismin,ismax,error)
      if (error)  return
    endif
    !
  else
    if (abs(new%inc).le.abs(old%inc)) then
      ! Regularly spaced axis, 2 point oversampling
      call resample_interpolate2_over(set,                     &
                                      rdata1,rdataw,rbad,old,  &
                                      sdata1,sdataw,sbad,new,  &
                                      ismin,ismax,error)
      if (error)  return
    else
      ! Regularly spaced axis, 2 point undersampling
      call resample_interpolate2_under(set,                     &
                                       rdata1,rdataw,rbad,old,  &
                                       sdata1,sdataw,sbad,new,  &
                                       ismin,ismax,error)
      if (error)  return
    endif
  endif
  !
end subroutine resample_interpolate_regul
!
subroutine resample_interpolate3_under(set,                     &
                                       rdata1,rdataw,rbad,old,  &
                                       sdata1,sdataw,sbad,new,  &
                                       ismin,ismax,error)
  use classcore_interfaces, except_this=>resample_interpolate3_under
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  3 points undersampling routine.
  !  Performs the linear interpolation/integration.
  !  This routine integrates in a square output channel passband (width
  ! sinc) the piecewise linear interpolation of the original data.
  !   As a result the integration is always on 3 points (hence the name)
  ! and the effective resolution is degraded if the input spectrum was
  ! undersampled.
  !
  ! This is what is needed e.g. for square channel responses in the
  ! frequency domain (fbox) i.e. approximation of filter channels of
  ! separation equal to their width.
  ! * There is no restriction on the output range compared to the input
  !   range (i.e. output can be too large, overlap, or be off limits).
  !   For efficiency purpose, only the intersection is updated, and the
  !   channel range which is updated is returned in 2 variables. It is
  !   up to the caller to do something (or not) out of this range.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set        !
  real(kind=4),        intent(in)    :: rdata1(:)  ! Input spectrum
  real(kind=4),        intent(in)    :: rdataw(:)  ! Input weights
  real(kind=4),        intent(in)    :: rbad       ! Input bad value
  type(resampling),    intent(in)    :: old        ! Old axis description
  real(kind=4),        intent(out)   :: sdata1(:)  ! Output spectrum
  real(kind=4),        intent(out)   :: sdataw(:)  ! Output weights
  real(kind=4),        intent(in)    :: sbad       ! Output bad value
  type(resampling),    intent(in)    :: new        ! New axis description
  integer(kind=4),     intent(out)   :: ismin      ! Range of channels updated in...
  integer(kind=4),     intent(out)   :: ismax      ! ... the output spectrum.
  logical,             intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4) :: is,ir,irmax,irmin
  real(kind=8) :: minpix, maxpix, expand, ymax, ymin,rval0,sval0
  real(kind=4) :: scale,irf,vr,wr,xs
  logical :: contaminate
  !
  call resample_interpolate_range(old,new,.true.,ismin,ismax,error)
  if (error)  return
  !
  contaminate = set%bad.eq.'O'  ! Bad channels contaminate output or not?
  !
  ! Initialize the output (resampled) observation
  sdata1(:) = 0.  ! Avoid NaN
  sdataw(:) = 0.  ! No data available yet in the spectrum
  !
  ! The algorithm below works with the 0-th channels as references (simpler
  ! equations and faster computations). Compute the X value at these channels:
  rval0 = (0.d0-old%ref)*old%inc+old%val
  sval0 = (0.d0-new%ref)*new%inc+new%val
  !
  expand = abs(new%inc/old%inc)  ! Undersampling: expand>=1
  scale = 1.0d0/(2.0d0*expand)
  !
  do is = ismin,ismax
    ! Compute interval
    xs = new%inc*is+sval0  ! X position
    irf = (xs-rval0)/old%inc  ! Channel position in input spectrum
    !
    maxpix = irf + 0.5d0*expand
    minpix = irf - 0.5d0*expand
    irmin = int(minpix+1.0d0)
    irmax = int(maxpix)
    ! Undersampling: irmin<=irmax
    vr = 0.
    wr = 0.
    !
    ! Left part
    ymin = 0.
    if (rdata1(irmin-1).eq.rbad) then  ! Bad channels
      if (contaminate) then
        sdata1(is) = sbad
        sdataw(is) = 0.0
        cycle  ! Next output channel
      endif
    else
      ymin = rdata1(irmin-1)*(irmin-minpix)
    endif
    if (rdata1(irmin).eq.rbad) then
      if (contaminate) then
        sdata1(is) = sbad
        sdataw(is) = 0.0
        cycle  ! Next output channel
      endif
      if (ymin.ne.0.) then
        vr = (irmin-minpix) * ymin
        wr = (irmin-minpix)
      endif
    else
      ymin = ymin + rdata1(irmin)*(minpix-irmin+1)
      vr = (irmin-minpix) * (ymin+rdata1(irmin))
      wr = (irmin-minpix)
    endif
    !
    ! Central part (if any)
    do ir=irmin, irmax-1  ! Maybe 0 loop
      if (rdata1(ir).eq.rbad) then
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          goto 30  ! Next output channel
        endif
      else
        vr = vr + rdataw(ir)*rdata1(ir)
        wr = wr + rdataw(ir)
      endif
      if (rdata1(ir+1).eq.rbad) then
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          goto 30  ! Next output channel
        endif
      else
        vr = vr + rdataw(ir+1)*rdata1(ir+1)
        wr = wr + rdataw(ir+1)
      endif
    enddo
    !
    ! Right part
    ymax = 0.
    if (rdata1(irmax+1).eq.rbad) then
      if (contaminate) then
        sdata1(is) = sbad
        sdataw(is) = 0.0
        cycle  ! Next output channel
      endif
    else
      ymax = ymax + rdata1(irmax+1)*(maxpix-irmax)
    endif
    if (rdata1(irmax).eq.rbad) then
      if (contaminate) then
        sdata1(is) = sbad
        sdataw(is) = 0.0
        cycle  ! Next output channel
      endif
      if (ymax.ne.0.) then
        vr = vr + (maxpix-irmax)*ymax
        wr = wr + (maxpix-irmax)
      endif
    else
      ymax = ymax + rdata1(irmax)*(irmax+1-maxpix)
      vr = vr + (maxpix-irmax)*(ymax+rdata1(irmax))
      wr = wr + (maxpix-irmax)
    endif
    !
    if (wr.ne.0.) then
      sdata1(is) = vr/wr
      sdataw(is) = wr
    else
      sdata1(is) = 0.
    endif
    !
30  continue
  enddo
  !
end subroutine resample_interpolate3_under
!
subroutine resample_interpolate3_over(set,                     &
                                      rdata1,rdataw,rbad,old,  &
                                      sdata1,sdataw,sbad,new,  &
                                      ismin,ismax,error)
  use classcore_interfaces, except_this=>resample_interpolate3_over
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  3 points oversampling routine.
  !  Performs the linear interpolation/integration.
  !  This routine integrates in a square output channel passband (width
  ! sinc) the piecewise linear interpolation of the original data.
  !   As a result the integration is always on 3 points (hence the name)
  ! and the effective resolution is degraded if the input spectrum was
  ! undersampled.
  !
  ! This is what is needed e.g. for square channel responses in the
  ! frequency domain (fbox) i.e. approximation of filter channels of
  ! separation equal to their width.
  ! * There is no restriction on the output range compared to the input
  !   range (i.e. output can be too large, overlap, or be off limits).
  !   For efficiency purpose, only the intersection is updated, and the
  !   channel range which is updated is returned in 2 variables. It is
  !   up to the caller to do something (or not) out of this range.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set        !
  real(kind=4),        intent(in)    :: rdata1(:)  ! Input spectrum
  real(kind=4),        intent(in)    :: rdataw(:)  ! Input weights
  real(kind=4),        intent(in)    :: rbad       ! Input bad value
  type(resampling),    intent(in)    :: old        ! Old axis description
  real(kind=4),        intent(out)   :: sdata1(:)  ! Output spectrum
  real(kind=4),        intent(out)   :: sdataw(:)  ! Output weights
  real(kind=4),        intent(in)    :: sbad       ! Output bad value
  type(resampling),    intent(in)    :: new        ! New axis description
  integer(kind=4),     intent(out)   :: ismin      ! Range of channels updated in...
  integer(kind=4),     intent(out)   :: ismax      ! ... the output spectrum.
  logical,             intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4) :: is,irmax,irmin
  real(kind=8) :: minpix, maxpix, expand, ymax, ymin,rval0,sval0
  real(kind=4) :: scale,irf,vr,wr,xs
  logical :: contaminate
  !
  call resample_interpolate_range(old,new,.true.,ismin,ismax,error)
  if (error)  return
  !
  contaminate = set%bad.eq.'O'  ! Bad channels contaminate output or not?
  !
  ! Initialize the output (resampled) observation
  sdata1(:) = 0.  ! Avoid NaN
  sdataw(:) = 0.  ! No data available yet in the spectrum
  !
  ! The algorithm below works with the 0-th channels as references (simpler
  ! equations and faster computations). Compute the X value at these channels:
  rval0 = (0.d0-old%ref)*old%inc+old%val
  sval0 = (0.d0-new%ref)*new%inc+new%val
  !
  expand = abs(new%inc/old%inc)  ! Oversampling: expand<=1
  scale = 1.0d0/(2.0d0*expand)
  !
  do is = ismin,ismax
    ! Compute interval
    xs = new%inc*is+sval0  ! X position
    irf = (xs-rval0)/old%inc  ! Channel position in input spectrum
    !
    maxpix = irf + 0.5d0*expand
    minpix = irf - 0.5d0*expand
    irmin = int(minpix+1.0d0)
    irmax = int(maxpix)
    ! Oversampling: irmin>=irmax
    vr = 0.
    wr = 0.
    !
    if (irmax.eq.irmin) then
      ! New channel overlap the center of an old one
      ! Left part
      ymin = 0.
      if (rdata1(irmin-1).eq.rbad) then  ! Bad channels
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          cycle  ! Next output channel
        endif
      else
        ymin = rdata1(irmin-1)*(irmin-minpix)
      endif
      if (rdata1(irmin).eq.rbad) then
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          cycle  ! Next output channel
        endif
        if (ymin.ne.0.) then
          vr = (irmin-minpix) * ymin
          wr = (irmin-minpix)
        endif
      else
        ymin = ymin + rdata1(irmin)*(minpix-irmin+1)
        vr = (irmin-minpix) * (ymin+rdata1(irmin))
        wr = (irmin-minpix)
      endif
      !
      ! Right part
      ymax = 0.
      if (rdata1(irmax+1).eq.rbad) then
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          cycle  ! Next output channel
        endif
      else
        ymax = ymax + rdata1(irmax+1)*(maxpix-irmax)
      endif
      if (rdata1(irmax).eq.rbad) then
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          cycle  ! Next output channel
        endif
        if (ymax.ne.0.) then
          vr = vr + (maxpix-irmax)*ymax
          wr = wr + (maxpix-irmax)
        endif
      else
        ymax = ymax + rdata1(irmax)*(irmax+1-maxpix)
        vr = vr + (maxpix-irmax)*(ymax+rdata1(irmax))
        wr = wr + (maxpix-irmax)
      endif
      !
    else
      ! New channel does not overlap the center of an old one:
      !   2 points interpolation between the 2 channels
      if (rdata1(irmin-1).eq.rbad) then  ! Bad channels
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          cycle  ! Next output channel
        endif
      else
        vr = rdata1(irmin-1)*(irmin-irf)
        wr = irmin-irf
      endif
      !
      if (rdata1(irmin).eq.rbad) then
        ! Bad channels
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          cycle  ! Next output channel
        endif
      else
        vr = vr + rdata1(irmin)*(irf-irmin+1)
        wr = wr + irf-irmin+1.
      endif
    endif
    !
    if (wr.ne.0.) then
      sdata1(is) = vr/wr
      sdataw(is) = wr
    else
      sdata1(is) = 0.
    endif
    !
  enddo
  !
end subroutine resample_interpolate3_over
!
subroutine resample_interpolate2_under(set,                     &
                                       rdata1,rdataw,rbad,old,  &
                                       sdata1,sdataw,sbad,new,  &
                                       ismin,ismax,error)
  use gbl_constant
  use classcore_interfaces, except_this=>resample_interpolate2_under
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   2 points undersampling routine (i.e. reso(out) >= reso(in)).
  ! * This resampling engine is generic enough to work without
  !   knowing the X unit. This means in particular that the input
  !   resolutions must be in same units and same referential, e.g.
  !   if unit is frequency the Doppler must be identical OR the
  !   resolution must be provided in the LSR frame. Also if unit is
  !   offset frequency, take care that the 2 axes must have the same
  !   rest frequencies.
  ! * The engine assumes a linear representation of the axis, i.e. it
  !   can be described with:
  !     X(ichan) = (ichan-Xref)*Xinc+Xval
  ! * No global variables here (i.e. multithreading is possible)
  ! * Input weights must have been computed *before* resampling, since
  !   resampling also affect the output weights.
  ! * Blanked channels propagates or not in output sum according to SET
  !   BAD.
  ! * Output channels with 0 weights are *not* yet blanked: it is up to
  !   the caller to blank them or not depending on what it does with
  !   such channels. This is because 'no data' is not the same as 'bad
  !   data'.
  ! * There is no restriction on the output range compared to the input
  !   range (i.e. output can be too large, overlap, or be off limits).
  !   For efficiency purpose, only the intersection is updated, and the
  !   channel range which is updated is returned in 2 variables. It is
  !   up to the caller to do something (or not) out of this range.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set        !
  real(kind=4),        intent(in)    :: rdata1(:)  ! Input values
  real(kind=4),        intent(in)    :: rdataw(:)  ! Input weights
  real(kind=4),        intent(in)    :: rbad       ! Input bad value
  type(resampling),    intent(in)    :: old        ! Old axis description
  real(kind=4),        intent(out)   :: sdata1(:)  ! Output values
  real(kind=4),        intent(out)   :: sdataw(:)  ! Output weights
  real(kind=4),        intent(in)    :: sbad       ! Output bad value
  type(resampling),    intent(in)    :: new        ! New axis description
  integer(kind=4),     intent(out)   :: ismin      ! Range of channels updated in...
  integer(kind=4),     intent(out)   :: ismax      ! ... the output spectrum.
  logical,             intent(inout) :: error      ! Logical error flag
  ! Local
  logical :: contaminate,equal
  real(kind=4) :: dx,f,fs,nch,rdxmax,rdxmin
  real(kind=4) :: wr1,wr2,wr3,wr,vr
  real(kind=4) :: xs,xr
  real(kind=8) :: rval0,sval0
  integer(kind=4) :: is,ir,irmin,irmax
  !
  call resample_interpolate_range(old,new,.true.,ismin,ismax,error)
  if (error)  return
  !
  contaminate = set%bad.eq.'O'  ! Bad channels contaminate output or not?
  equal = set%weigh.eq.'E'      ! Weight is EQUAL or not?
  !
  ! Initialize the output (resampled) observation
  sdata1(:) = 0.  ! Avoid NaN
  sdataw(:) = 0.  ! No data available yet in the spectrum
  !
  ! The algorithm below works with the 0-th channels as references (simpler
  ! equations and faster computations). Compute the X value at these channels:
  rval0 = (0.d0-old%ref)*old%inc+old%val
  sval0 = (0.d0-new%ref)*new%inc+new%val
  !
  ! A word on the distances in this resampling:
  !
  ! S:      output spectrum
  ! R:      one of the input spectra
  !
  ! is:     number of the current output channel of S considered
  ! ir:     number of the current input channel of R considered
  !
  ! new%inc:   S resolution / channel width
  ! old%inc:   R resolution / channel width. In sumout_param we ensure
  !         that abs(new%inc) >= abs(old%inc)
  !
  ! sval0:  abscissa value in S at reference channel #0
  ! rval0:  abscissa value in R at reference channel #0
  !
  ! xs:     channel center considered in S (output sum)
  ! xr:     channel center considered in R (one of the input spectra)
  !
  ! irmin:  is the minimum channel number in R which contributes at
  !         least partially to the current output channel.
  ! irmax:  is the maximum channel number in R which contributes at
  !         least partially to the current output channel
  !
  !         The left side of channel S(is) is at abscissa
  !           x = xs-abs(new%inc)/2
  !         We search the channel R(irmin) which contains x, i.e.
  !         where the R contribution starts. It verifies:
  !           x = old%inc*(irmin-0)+rval0
  !         Thus:
  !           irmin =     (xs-abs(new%inc)/2-rval0)/old%inc            (float value)
  !           irmin = int((xs-abs(new%inc)/2-rval0)/old%inc + 1/2)     (int value)
  !           irmin = int((xs-abs(new%inc)/2-rval0+old%inc/2)/old%inc) (int value)
  !         Same for the right side of the channel S(is)
  !           irmax =     (xs+abs(new%inc)/2-rval0)/old%inc            (float value)
  !           irmax = int((xs+abs(new%inc)/2-rval0)/old%inc + 1/2)     (int value)
  !           irmax = int((xs+abs(new%inc)/2-rval0+old%inc/2)/old%inc) (int value)
  !
  ! dx:     is the distance between xs and xr
  ! rdxmax: is the highest dx such as the channel in S overlaps
  !         fully or *partially* the channel in R (rdxmax>0)
  ! rdxmin: is the highest dx such as the channel in S overlaps
  !         *fully* (only) the channel in R (rdxmin>0)
  !
  ! wr1:    a constant value in the irmin/irmax formulae above i.e.
  !           wr1 = -abs(new%inc)/2-rval0+old%inc/2
  ! wr2:      wr2 =  abs(new%inc)/2-rval0+old%inc/2
  ! wr3:    see comment in loop
  !
  ! Constants for 1st spectrum (prefix 'r')
  rdxmax = (abs(new%inc)+abs(old%inc))*0.5
  rdxmin = (abs(new%inc)-abs(old%inc))*0.5
  wr1 = -sign(1.d0,old%inc)*rdxmin-rval0  ! Take care of the resolution sign
  wr2 =  sign(1.d0,old%inc)*rdxmax-rval0  ! Idem
  wr3 = 1./(rdxmax-rdxmin)             ! = 1/abs(old%inc)
  !
  do is = ismin,ismax  ! Loop on output channels
     xs = new%inc*is+sval0
     !
     ! Local resample for input observation
     irmin = max(1        ,int((xs+wr1)/old%inc))
     irmax = min(old%nchan,int((xs+wr2)/old%inc))
     nch = 0.  ! Number of channels which contribute
     fs = 0.   ! Fraction sum
     wr = 0.   ! Weight of (possibly resampled) channel from R
     vr = 0.   ! Value of (possibly resampled) channel from R
     do ir = irmin,irmax
        xr = old%inc*ir + rval0
        dx = abs(xr-xs)
        if (dx.lt.rdxmax) then
           ! This channel in R is at least partially overlapped by the
           ! one in S
           if (rdata1(ir).eq.rbad) then
              ! Bad channels
              if (contaminate) then
                 sdata1(is) = sbad
                 sdataw(is) = 0.0
                 goto 30  ! Next output channel
              endif
              f = 0.
           elseif (dx.le.rdxmin) then
              ! This channel in R is fully overlapped by the one in S. It
              ! has a full contribution:
              f = 1.
           else
              ! This channel in R is partially overlapped by the one in S
              ! It contributes, but less. wr3 normalizes dx-rdxmin such as
              ! 0<f<1 . f is proportional to the overlapping.
              f = 1.-(dx-rdxmin)*wr3
           endif
           nch = nch+            f
           fs  = fs +          f*f*rdataw(ir)
           wr  = wr +            f*rdataw(ir)  ! beta
           vr  = vr + rdata1(ir)*f*rdataw(ir)
        endif
     enddo
     !
     if (wr.ne.0.0) then
        vr = vr/wr       ! Value of resampled channel
        if (equal) then
          wr = wr/nch    ! Normalize the weight of the resampled channel
        else
          wr = wr*wr/fs  ! Weight of resampled channel
        endif
     endif
     !
     ! Store new value
     sdata1(is) = vr
     sdataw(is) = wr  ! Possibly 0.0
     !
30   continue
  enddo
  !
end subroutine resample_interpolate2_under
!
subroutine resample_interpolate2_over(set,                     &
                                      rdata1,rdataw,rbad,old,  &
                                      sdata1,sdataw,sbad,new,  &
                                      ismin,ismax,error)
  use gbl_constant
  use classcore_interfaces, except_this=>resample_interpolate2_over
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   2 points oversampling routine (i.e. reso(out) >= reso(in)).
  ! * This resampling engine is generic enough to work without
  !   knowing the X unit. This means in particular that the input
  !   resolutions must be in same units and same referential, e.g.
  !   if unit is frequency the Doppler must be identical OR the
  !   resolution must be provided in the LSR frame. Also if unit is
  !   offset frequency, take care that the 2 axes must have the same
  !   rest frequencies.
  ! * The engine assumes a linear representation of the axis, i.e. it
  !   can be described with:
  !     X(ichan) = (ichan-Xref)*Xinc+Xval
  ! * No global variables here (i.e. multithreading is possible)
  ! * Input weights must have been computed *before* resampling, since
  !   resampling also affect the output weights.
  ! * Blanked channels propagates or not in output sum according to SET
  !   BAD.
  ! * Output channels with 0 weights are *not* yet blanked: it is up to
  !   the caller to blank them or not depending on what it does with
  !   such channels. This is because 'no data' is not the same as 'bad
  !   data'.
  ! * There is no restriction on the output range compared to the input
  !   range (i.e. output can be too large, overlap, or be off limits).
  !   For efficiency purpose, only the intersection is updated, and the
  !   channel range which is updated is returned in 2 variables. It is
  !   up to the caller to do something (or not) out of this range.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set        !
  real(kind=4),        intent(in)    :: rdata1(:)  ! Input values
  real(kind=4),        intent(in)    :: rdataw(:)  ! Input weights
  real(kind=4),        intent(in)    :: rbad       ! Input bad value
  type(resampling),    intent(in)    :: old        ! Old axis description
  real(kind=4),        intent(out)   :: sdata1(:)  ! Output values
  real(kind=4),        intent(out)   :: sdataw(:)  ! Output weights
  real(kind=4),        intent(in)    :: sbad       ! Input bad value
  type(resampling),    intent(in)    :: new        ! New axis description
  integer(kind=4),     intent(out)   :: ismin      ! Range of channels updated in...
  integer(kind=4),     intent(out)   :: ismax      ! ... the output spectrum.
  logical,             intent(inout) :: error      ! Logical error flag
  ! Local
  logical :: contaminate,equal
  real(kind=4) :: f,fs,nch,wr,vr
  real(kind=4) :: xs,irf
  real(kind=8) :: rval0,sval0
  integer(kind=4) :: is,ir
  !
  call resample_interpolate_range(old,new,.true.,ismin,ismax,error)
  if (error)  return
  !
  contaminate = set%bad.eq.'O'  ! Bad channels contaminate output or not?
  equal = set%weigh.eq.'E'      ! Weight is EQUAL or not?
  !
  ! Initialize the output (resampled) observation
  sdata1(:) = 0.  ! Avoid NaN
  sdataw(:) = 0.  ! No data available yet in the spectrum
  !
  ! The algorithm below works with the 0-th channels as references (simpler
  ! equations and faster computations). Compute the X value at these channels:
  rval0 = (0.d0-old%ref)*old%inc+old%val
  sval0 = (0.d0-new%ref)*new%inc+new%val
  !
  ! A word on the distances in this resampling:
  !
  ! S:      output spectrum
  ! R:      one of the input spectra
  !
  ! is:     number of the current output channel of S considered
  ! irf:    number of the current input channel of R considered (float)
  ! ir:     number of the current input channel of R considered (int)
  !
  ! sval0:  abscissa value in S at reference channel #0
  ! rval0:  abscissa value in R at reference channel #0
  !
  do is = ismin,ismax  ! Loop on output channels
    xs = new%inc*is+sval0  ! X position
    irf = (xs-rval0)/old%inc  ! Channel position in input spectrum
    !
    nch = 0.
    fs = 0.
    vr = 0.
    wr = 0.
    !
    ir = int(irf)  ! Left channel contribution
    if (ir.ge.1 .and. ir.le.old%nchan) then
      if (rdata1(ir).eq.rbad) then
        ! Bad channels
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          cycle  ! Next output channel
        endif
        f = 0.
      else
        f = real(ir+1)-irf
      endif
      nch = nch+            f
      fs  = fs +          f*f*rdataw(ir)
      wr  = wr +            f*rdataw(ir)  ! beta
      vr  = vr + rdata1(ir)*f*rdataw(ir)
      !
    endif
    !
    ir = ir+1  ! Right channel contribution
    if (ir.ge.1 .and. ir.le.old%nchan) then
      if (rdata1(ir).eq.rbad) then
        ! Bad channels
        if (contaminate) then
          sdata1(is) = sbad
          sdataw(is) = 0.0
          cycle  ! Next output channel
        endif
        f = 0.
      else
        f = irf-real(ir-1)
      endif
      nch = nch+            f
      fs  = fs +          f*f*rdataw(ir)
      wr  = wr +            f*rdataw(ir)  ! beta
      vr  = vr + rdata1(ir)*f*rdataw(ir)
      !
    endif
    !
    if (wr.ne.0.0) then
      vr = vr/wr       ! Value of resampled channel
      if (equal) then
        wr = wr/nch    ! Normalize the weight of the resampled channel
      else
        wr = wr*wr/fs  ! Weight of resampled channel
      endif
    endif
    !
    ! Store new value
    sdata1(is) = vr
    sdataw(is) = wr  ! Possibly 0.0
    !
  enddo
  !
end subroutine resample_interpolate2_over
!
subroutine resample_interpolate_irreg(set,                        &
                                      rdatax,rdata1,rbad,rnchan,  &
                                      sdata1,sdataw,sbad,new,     &
                                      error)
  use class_parameter
  use classcore_interfaces, except_this=>resample_interpolate_irreg
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Performs the linear interpolation/integration to resample on a
  ! Regular Grid. Edge handling should be improved one day
  ! * There is no restriction on the output range compared to the input
  !   range (i.e. output can be too large, overlap, or be off limits).
  !   For efficiency purpose, only the intersection is updated, and the
  !   channel range which is updated is returned in 2 variables. It is
  !   up to the caller to do something (or not) out of this range.
  !---------------------------------------------------------------------
  type(class_setup_t),   intent(in)    :: set        !
  real(kind=xdata_kind), intent(in)    :: rdatax(:)  ! Input abscissa
  real(kind=4),          intent(in)    :: rdata1(:)  ! Input spectrum
  real(kind=4),          intent(in)    :: rbad       ! Input bad value
  integer(kind=4),       intent(in)    :: rnchan     ! Input spectrum size
  real(kind=4),          intent(out)   :: sdata1(:)  ! Output spectrum
  real(kind=4),          intent(out)   :: sdataw(:)  ! Output weight
  real(kind=4),          intent(in)    :: sbad       ! Output bad value
  type(resampling),      intent(in)    :: new        ! Output axis
  logical,               intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4) :: is,ir,irlast,irstart,irmin,irmax,rstep
  integer(kind=4) :: ismin,ismax,isfirst,islast,sstep
  real(kind=8) :: xval1,xval2,xvalt,vdata,weight,is1,is2
  real(kind=8) :: xleft,xright,xover1,xover2,overlap
  logical :: contaminate
  !
  contaminate = set%bad.eq.'O'  ! Bad channels contaminate output or not?
  !
  ! Initialize the output (resampled) observation
  sdata1(:) = 0.  ! Avoid NaN
  sdataw(:) = 0.  ! No data available yet in the spectrum
  !
  ! Handle the various orderings
  if ((rdatax(2)-rdatax(1)).gt.0.) then
    irmin = 1
    irmax = rnchan
    rstep = 1
  else
    irmin = rnchan
    irmax = 1
    rstep = -1
  endif
  !
  ! X range is rdatax(irmin) to rdatax(irmax)  (sorted)
  !
  ! Convert to output channel range. The interpolation domain is limited
  ! to the first and last input abscissae: there is no extrapolation.
  is1 = (rdatax(irmin)-new%val)/new%inc+new%ref  ! Float value
  is2 = (rdatax(irmax)-new%val)/new%inc+new%ref  ! Float value
  ! - We know the range of S we want to work on, but at float channel
  ! values. Say 'eps' is a small value (<< 1). From N-0.5+eps to N+0.5-eps
  ! (float value) fall into channel #N (integer value): so this is the
  ! nint() definition!
  if (is1.lt.is2) then
    ismin = nint(is1)
    ismax = nint(is2)
    isfirst = max(ismin,1)
    islast = min(ismax,new%nchan)
    sstep = 1
  else
    ismin = nint(is2)
    ismax = nint(is1)
    isfirst = min(ismax,new%nchan)
    islast = max(ismin,1)
    sstep = -1
  endif
  ! Now isfirst to islast is the range of output channels overlapping
  ! the input interpolation domain, to be iterated for increasing X.
  !
  ! Is this range out of the spectrum limits?
  if (ismin.gt.new%nchan .or. ismax.lt.1) then
    call do_resample_nointersecterror_irreg(rdatax,rnchan,new)
    error = .true.
    return
  endif
  !
  ! Loop on output channels. This code works if traversed by increasing X
  ! values. This might mean traversing the input and/or the output axes
  ! in reverse.
  irlast = irmax-rstep
  irstart = irmin
  output_channel: do is = isfirst, islast, sstep
    ! Compute output interval in increasing X order
    xval1 = (is-0.5d0-new%ref)*new%inc+new%val
    xval2 = (is+0.5d0-new%ref)*new%inc+new%val
    if (xval1.gt.xval2) then
      xvalt = xval1
      xval1 = xval2
      xval2 = xvalt
    endif
    !
    ! Accumulate contributions from input segments. The signal is linearly
    ! interpolated between neighbouring input samples, and integrated over
    ! the output channel passband.
    vdata  = 0.
    weight = 0.
    !
    ! Move to the first input segment which can overlap the output cell.
    do
      call input_segment_edges(irstart,xleft,xright)
      if (xright.gt.xval1 .or. irstart.eq.irlast)  exit
      irstart = irstart+rstep
    enddo
    !
    ir = irstart
    do
      call input_segment_edges(ir,xleft,xright)
      if (xleft.ge.xval2)  exit
      xover1 = max(xleft,xval1)
      xover2 = min(xright,xval2)
      overlap = xover2-xover1
      if (overlap.gt.0.d0) then
        if (rdata1(ir).eq.rbad .or. rdata1(ir+rstep).eq.rbad) then
          ! A bad interpolation segment
          if (contaminate) then
            sdata1(is) = sbad
            sdataw(is) = 0.
            cycle output_channel
          endif
        else
          vdata  = vdata + input_segment_integral(ir,xover1,xover2)
          weight = weight + overlap
        endif
      endif
      if (xright.ge.xval2 .or. ir.eq.irlast)  exit
      ir = ir+rstep
    enddo
    !
    if (weight.ne.0.) then
      sdata1(is) = vdata/weight
      sdataw(is) = weight
    else
      sdata1(is) = 0.
    endif
    !
  enddo output_channel
  !
contains
  !
  subroutine input_segment_edges(ichan,cleft,cright)
    !-------------------------------------------------------------------
    ! Return an input interpolation segment in increasing X order.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)  :: ichan
    real(kind=8),    intent(out) :: cleft,cright
    !
    cleft  = rdatax(ichan)
    cright = rdatax(ichan+rstep)
    !
  end subroutine input_segment_edges
  !
  function input_segment_integral(ichan,cleft,cright) result(integ)
    !-------------------------------------------------------------------
    ! Integrate the linear interpolation segment over [cleft,cright].
    !-------------------------------------------------------------------
    integer(kind=4), intent(in) :: ichan
    real(kind=8),    intent(in) :: cleft,cright
    real(kind=8) :: integ
    real(kind=8) :: dx,slope,yleft,yright
    !
    dx = rdatax(ichan+rstep)-rdatax(ichan)
    slope = (rdata1(ichan+rstep)-rdata1(ichan))/dx
    yleft  = rdata1(ichan) + slope*(cleft -rdatax(ichan))
    yright = rdata1(ichan) + slope*(cright-rdatax(ichan))
    integ  = 0.5d0*(yleft+yright)*(cright-cleft)
    !
  end function input_segment_integral
  !
end subroutine resample_interpolate_irreg
!
subroutine pfactor(n,p)
  !---------------------------------------------------------------------
  ! @ private
  ! Returns in p the largest prime factor in n
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: n
  integer(kind=4), intent(out) :: p
  ! Local
  integer :: m,q,r
  logical :: prime
  !
  m = n
  p = 1
  do while (m .gt. p)
     if (prime(m,q)) then
        p = max(p,m)
        return
     else
        do while (.not.prime(q,r))
           q = q/r
        enddo
        p = max(p,q)
        m = m/q
     endif
  enddo
end subroutine pfactor
!
function prime(n,p)
  !---------------------------------------------------------------------
  ! @ private
  ! Find if n is prime, returns the smallest integer divisor p.
  !---------------------------------------------------------------------
  logical :: prime  ! Function value on return
  integer(kind=4), intent(in)  :: n  !
  integer(kind=4), intent(out) :: p  !
  ! Local
  integer(kind=4) :: i,nn
  !
  prime = .false.
  p=2
  i=n/2
  if (i.gt.1 .and. i*2.eq.n) return
  p = 3
  nn = sqrt(float(n))
  do while (p.le.nn)
     i = n/p
     if (p*i.eq.n) return
     p = p+2
  enddo
  prime = .true.
end function prime

subroutine sic_help(line,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_help
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !   Read the help file from a sequential text file where command texts
  ! start with the command name and additional text start with a TAB or
  ! a SPACE.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=80) :: topic,subtopic,utopic
  integer(kind=4) :: nt,ns
  character(len=24), parameter :: syntax='SYNTAX'
  character(len=24), parameter :: functio='FUNCTION'
  character(len=1), parameter :: backslash=char(92)
  !
  ! Get TOPIC and SUBTOPIC arguments
  if (.not.sic_present(0,1)) then
    topic = ' '
    nt = 0
  else
    subtopic = ' '
    call sic_ch (line,0,2,subtopic,ns,.false.,error)
    if (error) return
    call sic_ch (line,0,1,topic,nt,.false.,error)
    if (error) return
    utopic = topic
    call sic_upper(utopic)
  endif
  !
  if (nt.eq.0) then
    ! No TOPIC => General Help
    call help_general(error)
    !
  elseif (utopic(nt:nt).eq.backslash .and.  &
          utopic(1:nt-1).eq.syntax(1:nt-1)) then
    ! HELP SYNTAX\ (with backslash)
    call help_syntax
    !
  elseif (topic(nt:nt).eq.backslash) then
    ! HELP Language\ (with backslash)
    call help_language(topic,error)
    !
  elseif (utopic.eq.'TASK') then
    ! HELP TASK [Group]
    call help_task(subtopic,error)
    !
  elseif (utopic(1:nt).eq.functio(1:nt) .and. nt.ge.3) then  ! Accept FUN, FUNC, ...
    ! HELP FUNCTION [Name]
    call help_function(subtopic,error)
    !
  elseif (utopic.eq.'RUN' .and. subtopic.ne.'') then
    ! HELP RUN TaskName [VarName]
    topic = subtopic
    subtopic = ' '
    call sic_ch (line,0,3,subtopic,ns,.false.,error)
    if (error) return
    call help_run(topic,subtopic,1,error)
    if (error)  &
      call sic_message(seve%e,rname,'No such task '//topic)
    !
  elseif (utopic.eq.'GO' .and. subtopic.ne.'') then
    ! HELP GO Procedure [Subtopic]
    topic = subtopic
    subtopic = ' '
    call sic_ch (line,0,3,subtopic,ns,.false.,error)
    if (error) return
    call help_procedure(topic,subtopic,error)
    !
  else
    ! HELP Command [Subtopic]
    call help_command(topic,subtopic,error)
    !
  endif
  !
end subroutine sic_help
!
subroutine help_general(error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_general
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! General help
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=1), parameter :: backslash=char(92)
  integer(kind=4) :: ilang,jcom,ncom,mcom,lcom,nc
  integer(kind=4), allocatable :: ikeys(:)
  character(len=:), allocatable :: langlist(:)
  !
  ! First double-loop: find the best column width so that all
  ! the sub-loops are aligned. Find also the maximum number of
  ! commands per language
  nc = 0    ! Best column width
  mcom = 0  ! Maximum number of commands per language
  do ilang=1,nlang
    jcom = mbuilt(ilang-1)  ! Index of command-or-option
    lcom = mbuilt(ilang)    ! Last command-or-option in language
    ncom = 0                ! Number of commands found in language
    do
      jcom = jcom+1
      ncom = ncom+1
      nc = max(nc,len_trim(vocab(jcom)))
      jcom = jcom+nopt(jcom)  ! Index of last option before next command
      if (jcom.ge.lcom)  exit
    enddo
    mcom = max(mcom,ncom)
  enddo
  !
  ! Second double-loop: list commands for each language
  call sic_message(seve%r,rname,  &
    'HELP should be available on the following commands:')
  allocate(ikeys(mcom))
  do ilang=1,nlang
    jcom = mbuilt(ilang-1)
    lcom = mbuilt(ilang)
    ncom = 0  ! Number of commands found
    do
      jcom = jcom+1
      ncom = ncom+1
      ikeys(ncom) = jcom
      jcom = jcom+nopt(jcom)
      if (jcom.ge.lcom)  exit
    enddo
    call sic_ambigs_list(rname,seve%r,trim(languages(ilang)%name)//backslash,  &
      vocab,ikeys(1:ncom),2,nc)
  enddo
  deallocate(ikeys)
  !
  ! List of languages:
  call help_language_list(langlist,error)
  if (error)  return
  call sic_ambigs_list(rname,seve%r,  &
    'Additional help available (eg summaries):',langlist)
  deallocate(langlist)
  !
end subroutine help_general
!
subroutine help_syntax
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_syntax
  use gildas_def
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Special case: syntax
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: filename
  logical :: ok
  character(len=*), parameter :: syntax='SYNTAX'
  !
  if (help_mode.eq.help_html) then
    ok = html_help(syntax,' ',1)  ! 1: SIC language
    if (ok) return
  endif
  call sic_parse_file(languages(1)%help,' ','.hlp',filename)
  ok = sichelp(puthelp,syntax,' ',filename,.true.,.false.)
  !
end subroutine help_syntax
!
subroutine help_language(lname,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_language
  use gildas_def
  use gbl_message
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Topic is a language
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: lname  ! Language name
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=filename_length) :: filename,chain
  character(len=36) :: fullcommand
  character(len=24) :: topic,subtopic,resolved
  integer(kind=4) :: jlang,nt,i
  logical :: ok
  character(len=message_length) :: mess
  character(len=:), allocatable :: langlist(:)
  character(len=1), parameter :: backslash=char(92)
  !
  topic = lname
  call sic_upper(topic)
  nt = len_trim(topic)-1  ! Drop the trailing backslash
  subtopic = ' '
  !
  ! Search the language
  call help_language_list(langlist,error)
  if (error)  return
  call sic_ambigs(rname,topic(1:nt),resolved,jlang,langlist,nlang,error)
  if (error)  return
  deallocate(langlist)
  !
  ! Library mode?
  if (languages(jlang)%libmod) then
    write(mess,1010) trim(languages(jlang)%name),backslash
    call sic_message(seve%w,rname,mess)
  endif
  !
  ! HTML help
  if (help_mode.eq.help_html) then
    ok = html_help('Language',subtopic,jlang)
    if (ok) return
  endif
  !
  ! ASCII help
  if (languages(jlang)%help.ne.' ') then
    ! Display ASCII help
    call sic_parse_file(languages(jlang)%help,' ','.hlp',filename)
    ok = sichelp(puthelp,topic,subtopic,filename,.true.,.true.)
    if (.not.ok) ok = sichelp(puthelp,'Language',subtopic,filename,.true.,.false.)
    !
  elseif (languages(jlang)%user) then
    ! List symbol translations for the language
    do i=mbuilt(jlang-1)+1,mbuilt(jlang)
      fullcommand = trim(languages(jlang)%name)//backslash//vocab(i)(2:)
      call sic_symdict_get(languages(jlang)%usym,vocab(i)(2:),chain,error)
      write(6,1001) fullcommand,' = "',trim(chain),'"'
    enddo
  endif
  !
1001 format(a24,3a)
1010 format('Language ',a,a,' is in library only mode')
end subroutine help_language
!
subroutine help_language_list(llist,error)
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Build the list of languages
  !---------------------------------------------------------------------
  character(len=:), allocatable   :: llist(:)
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: ilang
  character(len=1), parameter :: backslash=char(92)
  !
  allocate(character(len=language_length+1)::llist(nlang))
  do ilang=1,nlang
    llist(ilang) = trim(languages(ilang)%name)//backslash
  enddo
  !
end subroutine help_language_list
!
subroutine help_command(cname,cnamesub,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_command
  use gildas_def
  use gbl_message
  use sic_dictionaries
  !--------------------------------------------------------------------
  ! @ private
  ! Topic is a command. Try to find associated language
  !--------------------------------------------------------------------
  character(len=*), intent(in)    :: cname     ! Command name
  character(len=*), intent(in)    :: cnamesub  ! Subtopic name
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=filename_length) :: filename,chain
  character(len=24) :: topic,subtopic
  character(len=36) :: fullcommand
  integer(kind=4) :: iquiet,ilang,icom,ocode,nt
  logical :: ok
  character(len=message_length) :: mess
  character(len=1), parameter :: backslash=char(92)
  !
  iquiet = 2
  ! if (help_mode.eq.help_html) then
  !    if (sic_present(0,1)) then
  !       call html_help(line,error)
  !       iquiet = 1
  !       if (.not.error) return
  !    endif
  ! elseif ((help_mode.ne.help_scroll).and.  &
  !         (help_mode.ne.help_page)) then
  !    help_mode = help_page
  ! endif
  !
  topic = cname
  call sic_upper(topic)
  nt = len_trim(topic)
  subtopic = cnamesub ! No UpperCase here: more subtle code in sichelp
  !
  ! Get translation of symbols: a valid command may be overloaded by
  ! something else => behave like SIC does.
  call sic_getsymbol(topic,chain,error)
  if (error) then
    ! Not a known symbol => not an error
    error = .false.
  else
    ! Found a symbol => feedback and replace
    write(*,1000) trim(topic),' is a symbol for "',trim(chain),'"'
    ! TO BE DONE: split topic and subtopic e.g. CD = "GTVL\CHANGE DIRECTORY"
    topic = chain
    nt = len_trim(topic)
    call sic_upper(topic)
  endif
  call sic_parse_command(topic,nt,iquiet,.true.,ilang,icom,ocode,error)
  if (error) then
    ! Something wrong when resolving the command name. Try a task name.
    if (ocode.eq.3) then
      ! Found several fully ambiguous commands. Check also for a fully
      ! ambiguous task.
      call help_run(cname,' ',2,error)  ! Use case-sensitive name
    else
      call help_run(cname,cnamesub,1,error)  ! Use case-sensitive name
      if (error)  &
        call sic_message(seve%e,rname,'No such command or task '//topic(1:nt))
    endif
    return
  endif
  !
  ! Command language found. Process the command help
  topic = vocab(icom)(2:)
  nt = len_trim(topic)
  if (languages(ilang)%user) then    ! Only ASCII help
    ! Print translation
    fullcommand = trim(languages(ilang)%name)//backslash//topic
    call sic_symdict_get(languages(ilang)%usym,topic,chain,error)
    write(*,1000) trim(fullcommand),' = "',trim(chain),'"'
    ! Print help file
    call sic_parse_file (help_text(icom),' ','.hlp',filename)
    ok = sichelp(puthelp,topic,subtopic,filename,.true.,.false.)
  else                       ! Either HTML or ASCII help
    if (languages(ilang)%libmod) then
      write(mess,1010) trim(languages(ilang)%name),backslash
      call sic_message(seve%w,rname,mess)
    endif
    if (help_mode.eq.help_html) then
      ok = html_help(topic,subtopic,ilang)
      if (ok) return
    endif
    call sic_parse_file (languages(ilang)%help,' ','.hlp',filename)
    ok = sichelp(puthelp,topic,subtopic,filename,.true.,.false.)
  endif
  !
  ! Try a Task even if command is found. Use case-sensitive name.
  call help_run (cname,' ',2,error)
  error = .false.
  !
1000 format(20(a))
1010 format('Language ',a,a,' is in library only mode')
end subroutine help_command
!
subroutine help_button(hlpfile,varname,buffer)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_button
  use sic_structures
  !---------------------------------------------------------------------
  ! @ public-mandatory (used by ggui, symbol is used elsewhere)
  !  Fill the help lines into the output buffer. This is suited
  ! only for the guis.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: hlpfile
  character(len=*), intent(in)  :: varname
  character(len=*), intent(out) :: buffer
  ! Local
  integer(kind=4) :: ier,nbuf
  character(len=1024) :: line
  logical :: found
  !
  buffer = ""
  nbuf = 0
  !
  ! Open help file
  ier = sic_open(luntem,hlpfile,'OLD',.true.)
  if (ier.ne.0) then
    buffer = 'Help file is not yet available: '//trim(hlpfile)
    return
  endif
  !
  if (varname.eq.'') then
    ! Search for the topic in help file (assume only one is declared)
    found = .false.
    do
      read(luntem,'(A)',end=20) line
      if (line(1:1).eq.'1') then
        found = .true.
        exit
      endif
    enddo
    if (.not.found) goto 20
    line = trim(line(3:))//':'
    call append_line(line)
    !
    ! All possible variables are requested
    do
      read(luntem,'(A)',end=20) line
      if (line(1:1).eq.'1') then
        exit
      elseif (line(1:1).eq.'2') then
        call append_line("")  ! Blank line
        call append_varname(line(3:))
      else
        call append_line(line)
      endif
    enddo
    !
  else
    ! A single variable is requested
    call append_varname(varname)
    found = .false.
    do
      read(luntem,'(A)',end=20) line
      if (line(1:1).eq.'1') then
        if (found)  exit
      elseif (line(1:1).eq.'2') then
        if (found)  exit  ! Already found, this is another variable
        found = line(3:).eq.varname
      elseif (found) then
        call append_line(line)
      endif
    enddo
  endif
  !
20 continue
  ! Close help file
  ier = sic_close(luntem)
  if (.not.found)  call append_line('Help is not yet available')
  !
contains
  subroutine append_varname(varname)
    character(len=*), intent(in) :: varname
    ! Local
    character(len=64) :: strtype
    logical :: error
    !
    error = .false.
    call sic_examine_strtype_byname(varname,.true.,.false.,strtype,error)
    if (error) then  ! Probably no such variable
      ! e.g. "Variable TOTO:"
      call append_line(  &
        'Variable '//trim(varname)//':')
    else
      ! e.g. "Variable TOTO (REAL[2,3]):"
      call append_line(  &
        'Variable '//trim(varname)//' ('//trim(strtype)//'):')
    endif
    !
  end subroutine append_varname
  !
  subroutine append_line(line)
    character(len=*), intent(in) :: line
    ! Local
    integer(kind=4) :: nl
    !
    nl = len_trim(line)
    buffer(nbuf+1:) = line(1:nl)
    nbuf = nbuf+nl+1
    buffer(nbuf:nbuf) = char(13)  ! Carriage return
  end subroutine append_line
end subroutine help_button
!
function sichelp(phelp,topic,subtopic,file,reset,quiet)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sichelp
  use sic_structures
  use sic_interactions
  use gbl_ansicodes
  !---------------------------------------------------------------------
  ! @ private
  !  Output help from a SIC Standard Help File
  !  Returns an error status
  !---------------------------------------------------------------------
  logical :: sichelp                        ! Function value on return
  external                     :: phelp     ! Subroutine to output text
  character(len=*), intent(in) :: topic     ! Help topic (case sensitive)
  character(len=*), intent(in) :: subtopic  ! Help subtopic (case sensitive)
  character(len=*), intent(in) :: file      ! Help file name
  logical,          intent(in) :: reset     ! Reset the line counter?
  logical,          intent(in) :: quiet     ! No error message if (sub)topic not found?
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=1), parameter :: backslash=char(92)
  character(len=256) :: line,chain
  character(len=32) :: uptopic,list(20)
  character(len=message_length) :: message
  integer(kind=4) :: n,status,ns,nch,lt,nfound
  logical :: found,more
  integer :: space
  !
  space = 12
  !
  sichelp = .false.
  found = .false.
  lt = len_trim(topic)
  ns = 0
  !
  ! Avoid empty file name
  if (file.eq.'.hlp') goto 20
  ! Open help file
  status = sic_open (luntem,file,'OLD',.true.)
  if (status.ne.0) then
    message = 'Error opening '//file
    call sic_message(seve%e,rname,message)
    call putios('E-HELP,  ',status)
    return
  endif
  ! Initialize
  if (reset)  call phelp(char(0))
  ! Search for TOPIC in help file
  call goto_topic(found)
  if (.not.found) goto 20
  !
  ! Search for SUBTOPIC
  more = .true.
  ns = len_trim(subtopic)
  uptopic = subtopic
  call sic_upper(uptopic)
  nch = 0
  !
  if (ns.eq.0) then
    ! No particular SUBTOPIC requested
    do while (more)
      read(luntem,'(A)',end=40) line
      n = len_trim(line)
      if (n.eq.0.and.found) then
        call phelp(' ')
      elseif (line(1:1).eq.'1') then
        more = .false.
      elseif (line(1:1).eq.'2') then
        if (nch.eq.0) then
          call phelp(' ')
          call phelp('Additional Help Available: ')
          nch = 1
        elseif (nch.ge.72) then
          call phelp (chain)
          nch = 1
        endif
        ! Locate if there is a semi-colon at end of next word
        ! if so, force a line break.
        if (line(n:n).eq.':') then
          space = 16              ! Variable names are often long
          call phelp(chain(1:nch)//c_clear)
          if (line.eq.'2 Variables:') then
            ! Automatic Syntax coloring of Variables:
            call phelp(c_blue//line(2:n))
          else
            call phelp(line(2:n))
          endif
          chain =  ' '
          nch = 1
        else
          chain(nch:) = line(2:n)  ! Keep a blank before subtopic name (2nd char is a blank)
          nch = nch+1+space        ! Space + 1 characters-wide columns (blanks included)
        endif
        found = .false.
      elseif (found) then
        call phelp(line)
      endif
    enddo
40  continue
    if (nch.gt.1) call phelp(chain(1:nch)//c_clear)   ! Reset color 
    found = .true.
    !
  elseif (subtopic(1:ns).ne.'*') then
    ! A particular SUBTOPIC is requested
    ! This is done in 2 steps:
    ! 1) check possible ambiguities for subtopics
    ! 2) actually display the help if there is no ambiguity
    !
    ! 1) Ambiguities
    found = .false.
    nfound = 0
    do
      read(luntem,'(A)',end=20) line
      n = len_trim(line)
      if (line(1:1).eq.'1')  exit  ! This is another topic
      if (line(1:1).eq.'2') then
        if (line(3:min(n,ns+2)).eq.subtopic(1:ns) .or.  &
            line(3:min(n,ns+2)).eq.uptopic(1:ns)) then
          ! Found a matching subtopic
          nfound = nfound+1
          list(nfound) = line(3:n)
        endif
      endif
    enddo
    if (nfound.eq.0) then
      goto 20
    elseif (nfound.gt.1) then
      call sic_ambigs_list(rname,seve%w,'Ambiguous subtopic can be:',list(1:nfound))
      goto 20
    endif
    !
    ! 2) Actual help
    call goto_topic(found)
    found = .false.
    do
      read(luntem,'(A)',end=20) line
      n = len_trim(line)
      if (line(1:1).eq.'1')  exit  ! This is another topic
      if (n.eq.0 .and. found) then
        call phelp(' ')
      elseif (line(1:1).eq.'2') then
        if (found)  exit  ! This is another subtopic
        if (line(3:min(n,ns+2)).eq.subtopic(1:ns) .or.  &
            line(3:min(n,ns+2)).eq.uptopic(1:ns)) then
          found = .true.
          chain = trim(topic)//line(2:n)
          call phelp(chain)
        endif
      elseif (found) then
        call phelp(line)
      endif
    enddo
    !
  else
    ! All possible SUBTOPICS are requested
    found = .false.
    do while (more)
      read(luntem,'(A)',end=20) line
      n = len_trim(line)
      if (n.eq.0.and.found) then
        call phelp(' ')
      elseif (line(1:1).eq.'1') then
        more = .false.
      elseif (line(1:1).eq.'2') then
        chain = trim(topic)//line(2:n)
        call phelp(chain)
        found = .true.
      elseif (found) then
        call phelp(line)
      endif
    enddo
  endif
  !
20 continue
  ! Close help file
  close(unit=luntem)
  !
  ! Analyze search results
  if (.not.found) then         ! Reach EOF without finding the expected help
    if (quiet)  return
    if (ns.eq.0) then  ! No subtopic
      line = 'No help for '//topic(1:lt)
    else
      line = 'No such subtopic '//subtopic(1:ns)//' for HELP '//topic(1:lt)
    endif
    call sic_message(seve%w,rname,line)
  else                         ! Help has been correctly found
    sichelp = .true.
  endif
  ! Output something (is this needed?)
  call phelp(char(1))
  !
contains
  subroutine goto_topic(found)
    !-------------------------------------------------------------------
    ! Move the logical unit to the beginning of the desired topic. i.e.
    ! line starting with:
    !  1 TOPIC
    !-------------------------------------------------------------------
    logical, intent(out) :: found
    ! Local
    integer(kind=4) :: ier
    !
    rewind(luntem)
    found = .false.
    do while (.not.found)
      read(luntem,'(A)',iostat=ier) line
      if (ier.ne.0)  exit
      if (line(1:1).eq.'1') then
        ! We check 1 more character in line, which should be blank
        ! for correct match
        found = line(3:3+lt).eq.topic(1:lt)
      endif
    enddo
  end subroutine goto_topic
end function sichelp
!
subroutine puthelp(line)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>puthelp
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Output a line on the current terminal taking into account the
  ! output mode (SCROLL or PAGE)
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !
  ! Local
  integer :: nl,kl,tt_lines
  logical :: print
  save nl,print
  !
  if (ichar(line(1:1)).eq.0) then
    nl = 0
    print = .true.
  elseif (.not.print) then
    return
  elseif (ichar(line(1:1)).eq.1) then
    return
  else
    tt_lines = sic_ttynlin()
    if (help_mode.eq.help_page .and. nl.ge.tt_lines-2) then
      if (hlp_more().ne.0) then
        print = .false.
        return
      endif
      nl = 0
    endif
    kl = len_trim(line)
    if (kl.eq.0) kl = 1
    write (*,'(A)') line(1:kl)
    nl = nl+1
  endif
end subroutine puthelp
!
function html_help(topic,subtopic,jlang)
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Read the help from html files starting with:
  !       GAG_HTML_program:node1.html
  !---------------------------------------------------------------------
  logical :: html_help                      ! Function value on return
  character(len=*), intent(in) :: topic     ! Help topic
  character(len=*), intent(in) :: subtopic  ! Help subtopic
  integer,          intent(in) :: jlang     ! Language number
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=filename_length) :: filename
  character(len=256) :: chain,string,root,home
  character(len=1024) :: netscape
  character(len=64) :: chain_1,chain_2,chain_0,navigator,uchain,lchain
  character(len=20) :: prefix
  character(len=4) :: post
  integer :: status
  integer :: ki,li,ni,lis,nc0,nc1,nc2
  integer :: ier,nl,nr
  character(len=1) :: dir_sep,ousep,insep, cprevious
  logical :: is_http, exist
  !
  call gag_separ(insep,ousep,dir_sep)
  html_help = .true.
  !
  ! Define html toc file and open it
  root = 'GAG_HTML_'//languages(jlang)%name
  nr = len_trim(root)+1
  root(nr:nr) = ':'
  ier = sic_getlog(root)
  if (ier.ne.0) then
    call sic_message(seve%w,rname,'Did not find translation of '//root(1:nr))
    call sic_message(seve%w,rname,'Fall back to terminal help')
    html_help = .false.
    return
  endif
  !
  ! Full (recursive) translation of ROOT only obtained through sic_parse_file
  call sic_parse_file (root,' ',' ',filename)
  root = filename
  !
  nr = len_trim(root)
  nl= nr+1
  filename = root
  !
  ! Remote Site case:
  is_http = (filename(1:4).eq.'http')
  !
  if (is_http) then
    home = '$HOME'
    ier = sic_getlog(home)
    filename = trim(home)//'/.gag/'//trim(languages(jlang)%name)//'-node1.html'
    inquire(file=filename,exist=exist)
    if (.not.exist) ier = gag_system &        
      & ('curl -s -o '//trim(filename)//' '//trim(root)//'node1.html')
    
  else
    !
    ! Unfortunately  TOPIC /SUBTOPIC not in this Table of Content
    ! even by specifying $TOC_DEPTH=4  in Latex2html
    filename(nl:) = 'node1.html'
    !
    ! and this only works for SIC (language names are not Doc names) 
    !! filename(nl:) = trim(languages(jlang)%name)//'.html'
  endif
  !
  nl = len_trim(filename)
  filename(nl+1:) = ' '
  !
  close(unit=luntem)
  !
  status = sic_open(luntem,filename,'OLD',.true.)
  if (status.ne.0) then
    call sic_message(seve%e,rname,'Error opening HTML Table of Contents')
    call sic_message(seve%e,rname,filename(1:nl)//'!')
    call putios('E-HELP,  ',status)
    call sic_message(seve%w,rname,'Fall back to terminal help')
    html_help = .false.
    return
  endif
  !
  ! A trick is to figure out the "previous" node, which tells you
  ! the overall Doc name, where all levels are included, so
  ! TOPIC /Subtopic can be found
  ki = 0
  do while (ki.eq.0)
    read(luntem,'(A)',iostat=ier) chain
    if (ier.lt.0) exit
    ki = index(chain,'previous') 
  enddo
  !
  if (ki.ne.0) then
    close(unit=luntem)
    !!Print *,'CHAIN '//trim(chain)
    ! <LINK REL="previous" HREF="sic.html">
    ki = index(chain,'HREF=') + 6
    string = chain(ki:)
    !!Print *,'STRING '//trim(string)
    ki = index(string,'"')-1
    !
    if (is_http) then
      filename = trim(home)//'/.gag/'//trim(languages(jlang)%name)//'-'//string(1:ki)
      inquire(file=filename,exist=exist)
      if (.not.exist) ier = gag_system &
        & ('curl -s -o '//trim(filename)//' '//trim(root)//string(1:ki))
    else
      filename = trim(root)//string(1:ki) 
    endif
    !!Print *,'FILENAME '//trim(filename)
    status = sic_open(luntem,filename,'OLD',.true.)
    !!Print *,status,' Open STATUS of '//trim(filename)
    if (status.ne.0) then
      call sic_message(seve%e,rname,'Error opening HTML main file')
      call sic_message(seve%e,rname,filename)
      call putios('E-HELP,  ',status)
      call sic_message(seve%w,rname,'Fall back to terminal help')
      html_help = .false.
      return
    endif
  endif
  !  
  !!Print *,'TOPIC '//topic
  !!Print *,'SUBTOPIC '//subtopic
  !
  ! HTML syntax to find help corresponding to "SIC> help sic help" command:
  !
  !<LI><A NAME="tex2html1938"
  !  HREF="node120.html">SIC HELP</A>
  !
  ! Look for "LANG Language Internal Help" and then for "TOPIC SUBTOPIC"
  !
  post = '</A'
  chain_1 = trim(topic)//post
  nc1 = len_trim(chain_1)
  if (subtopic.ne.' ') then
    !
    ! Up case conversion unless Mixed case or /Option
    uchain = subtopic
    call sic_upper(uchain)
    if (uchain(1:1).eq.'/') then
      chain_2 = uchain
    else
      lchain = uchain
      call sic_lower(lchain)
      if ((uchain.eq.subtopic)  .or. (lchain.eq.subtopic)) then
        chain_2 = uchain ! trim(topic)//' '//uchain
      else
        chain_2 = subtopic ! trim(topic)//' '//subtopic
      endif
    endif
    nc2 = len_trim(chain_2)
  else
    chain_2 = topic
    nc2 = 0
  endif
  !
  ! First look for "LANG Language Internal Help"
  chain_0 = trim(languages(jlang)%name)//' Language Internal Help'
  nc0 = len_trim(chain_0)
  ki = 0
  do while (ki.eq.0)
    read(luntem,'(A)',iostat=ier) chain
    if (ier.lt.0) exit
    ki = index(chain,chain_0(1:nc0))
  enddo
  !
  ! LANG not found, re-start from beginning (in case .hlp file was not
  ! fully compliant)
  if (ki.eq.0) rewind(unit=luntem)
  !
  ! Now look for "TOPIC SUBTOPIC"
  !
  ! Move to start of list
  ki = 0
  li = 0
  lis = 0
  do while (ki.eq.0)
    read(luntem,'(A)',iostat=ier) chain
    if (ier.lt.0) exit
    ki = index(chain,'<UL>')
  enddo
  !
  ! Explore list if it exists
  if (ier.eq.0) then
    do while (lis.eq.0)
      read(luntem,'(A)',iostat=ier) chain
      if (ier.lt.0) exit
      if (nc2.ne.0 .and. lis.eq.0) then
        ki = index(chain,chain_2(1:nc2))
        if (ki.eq.0) ki = index(chain,chain_2(1:nc2))
        if (ki.ne.0) then
          lis = index(chain,'HREF=')+5
          if (lis.ne.0) then
            ni = index(chain(li:),'>')+li-2
            li = lis
            if (chain(li:li).eq.'"') then
              li = li+1
              ni = ni-1
            endif
            string = chain
            !!Print *,'Located subtopic at '//trim(STRING)//' LIS ',lis
          endif
        endif
      endif
      if (li.eq.0) then
        ki = index(chain,chain_1(1:nc1))
        if (ki.ne.0) then
          ! Verify that this is not by accident a sub-topic with the same name as a Topic...
          if (chain(ki-1:ki-1).eq.' ') then
            cprevious = chain(ki-2:ki-2)
            if (cprevious.eq.'>') then
              continue
            else if (index('012356789',cprevious).ne.0) then
              continue
            else
              ki = 0
            endif
          else if (chain(ki-1:ki-1).ne.'>') then
            ki = 0
          endif
          !! if (ki.eq.0)  Print *,'Ignored false topic at '//trim(chain)
        endif
        if (ki.ne.0) then
          li = index(chain,'HREF=')+5
          if (li.ne.0) then
            ni = index(chain(li:),'>')+li-2
            if (chain(li:li).eq.'"') then
              li = li+1
              ni = ni-1
            endif
            string = chain
            if (nc2.eq.0) lis = li
            !!Print *,'Located topic in '//trim(STRING)//' LIS ',lis
          endif
        endif
      endif
    enddo
  endif
  close (unit=luntem)
  !
  ! Fallback to terminal help if needed
  if (li.eq.0) then
    call sic_message(seve%w,rname,'No documentation for '//  &
    chain_1(1:nc1-len_trim(post)))
    call sic_message(seve%w,rname,'Fall back to terminal help')
    html_help = .false.
    return
  endif
  !
  ! Calling the Browser is OS-dependent, but "gag_os" (in gys/sysfor.f90) 
  ! only returns LINUX or WIN32, not DARWIN
  !
  ! Use pre-processor directive so far - using gag_os would be better
#if defined(WIN32)
  ! WINDOWS, not Cygwin ...
  netscape = 'START "%SystemDrive%/progra~1/intern~1/iexplore.exe" '//  &
              root(1:nr)//string(li:ni)
#elif defined(DARWIN)
  ! Mac OS/X 
  navigator = ''
  ier = sic_getlog('GAG_BROWSER',navigator)
  if (navigator.eq.'OPEN'.or.navigator.eq.' ') then
    ! OS-X default
    netscape = 'open '//root(1:nr)//string(li:ni)    
  else if (navigator.eq.'SAFARI') then
    ! SAFARI display in the last active tab
    if (is_http) then
      netscape = "osascript -e 'tell application "//'"Safari"'  // &
        &  " to set URL of current tab of front window to "//'"' &
        & //root(1:nr) // string(li:ni)//'"'//"'"     
    else
      netscape = "osascript -e 'tell application "//'"Safari"'  // &
        &  " to set URL of current tab of front window to "//'"file://' &
        & //root(1:nr) // string(li:ni)//'"'//"'" 
    endif
  else if (navigator.ne.' ') then
    netscape = trim(navigator)//' '//root(1:nr)//  &
                 string(li:ni) //' &'
    !!        netscape = 'UNKNOWN '//root(1:Nr)//string(li:ni)
  endif
#else  
  ! Any Linux flavor, including Cygwin which has a special structure
  !
  navigator = ''
  ier = sic_getlog('GAG_BROWSER',navigator)
  if (is_http) then
    prefix = ' '
  else
    prefix = 'file://localhost/'
  endif
  if (navigator.eq.'NETSCAPE') then
    netscape = 'netscape -remote ''openURL('//trim(prefix)//root(1:nr)//  &
               string(li:ni)//')'''
  elseif  (navigator.eq.'IE') then
    if (root(1:10).eq.'/cygdrive/') then
      root = 'file:///'//root(11:11)//':'//root(12:nr)
      nr = len_trim(root)
      netscape = 'c:/progra~1/intern~1/iexplore.exe '//root(1:nr)//  &
                 string(li:ni) //' &'
    else
      html_help = .false.
    endif
  elseif  (navigator.eq.'FIREFOX') then
    if (root(1:10).eq.'/cygdrive/') then
      root = 'file:///'//root(11:11)//':'//root(12:nr)
      nr = len_trim(root)
      netscape = 'c:/progra~1/mozill~1/firefox.exe '//root(1:nr)//  &
                 string(li:ni) //' &'
    else
      netscape = 'firefox -url '//trim(prefix)//root(1:nr)//  &
               string(li:ni)
    endif
  else
    html_help = .false.
  endif
  if (.not.html_help) then
    call sic_message(seve%w,rname,'Unrecognized or unsupported browser '//navigator)
    call sic_message(seve%w,rname,'Fall back to terminal help')
    return
  endif
#endif
  ier = gag_system(netscape)
  !
  ! There is no guarantee that IER # 0 in case of failure, so no guarantee of fallback
  if (ier.ne.0) then
    call sic_message(seve%w,rname,trim(netscape)//' FAILED')
    call sic_message(seve%w,rname,'Fall back to terminal help')
    html_help = .false.
  endif
end function html_help
!
subroutine help_run(tname,vname,icode,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_run
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !  Display task help.
  !  Meaning of icode:
  !   1: normal mode i.e. search for the task and display its help
  !   2: Just check for tasks with the same name and warn about them
  !      (help not displayed)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: tname  ! Task name
  character(len=*), intent(in)    :: vname  ! Variable name
  integer(kind=4),  intent(in)    :: icode  ! Printout code (HELP, or HELP TASK)
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=80) :: topic,subtopic
  character(len=filename_length) :: file
  integer(kind=4) :: nf
  logical :: ok
  character(len=message_length) :: mess
  !
  topic = tname
  subtopic = vname
  ! Beware! No upcasing here: task name (i.e. file name) may be case-sensitive!
  !
  ! HTML mode if specified and existing
  if (help_mode.eq.help_html) then
    if (sic_present(0,1)) then
      call sic_parse_file (topic,'GAG_TASK_HTML:','.html',file)
      inquire(file=file,exist=ok)
    else
      ok = .true.
    endif
    if (ok) then
      call help_run_html(topic,subtopic,error)
      return
    endif
  endif
  !
  ! Fall back on PAGE mode in other cases
  !  call sic_parsef (topic,file,'GILDAS_HELP:','.hlp')
  ok = sic_findfile(topic,file,'TASK#DIR:','.hlp')
  nf = len_trim(file)
  !  inquire(file=file,exist=ok)
  error = .true.
  if (.not.ok) then
    ! topic.hlp file not found in TASK#DIR:
    if (icode.eq.1) then
      call sic_parse_file (topic,'GAG_PROC:','.hlp',file)
      inquire(file=file,exist=ok)
      if (.not.ok) return
      write(mess,102) trim(topic),trim(topic)
      call sic_message(seve%i,rname,mess)
    else
      call sic_parse_file (topic,'GILDAS_RUN:','.exe',file)
      inquire(file=file,exist=ok)
      if (icode.eq.1) then
        if (.not.ok) then
          call sic_message(seve%e,rname,'No such task '//topic)
        else
          call sic_message(seve%e,rname,'No help for '//topic)
        endif
      endif
      return
    endif
  else
    if (icode.eq.1) then
      if (file(nf-3:nf).eq.'.hlp') then
        write(mess,101) trim(topic),trim(topic)
        call sic_message(seve%i,rname,mess)
      else
        write(mess,102) trim(topic),trim(topic)
        call sic_message(seve%i,rname,mess)
      endif
      call sic_upper(topic)     ! Topic is upcased in hlp file
    elseif (icode.eq.2) then
      write(mess,103) trim(topic),trim(topic)
      call sic_message(seve%i,rname,mess)
      return
    endif
  endif
  !
  ! Put the help
  error = .false.
  ok = sichelp(puthelp,topic,subtopic,file,.true.,.false.)
  !
101 format('"',a,'" is a task, use command "RUN ',a,'" to activate it')
102 format('"',a,'" is a procedure, use command @ ',a,' to execute it')
103 format('There is also a task named "',a,'", use "HELP RUN ',a,'" for help on it')
end subroutine help_run
!
subroutine help_task(group,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_task
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Display a summary of all the available tasks
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: group  ! Group name (blank for all)
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=filename_length), allocatable :: filelist(:)
  character(len=filename_length) :: dirstring,hlpfile
  character(len=*), parameter :: logstring='gag_task:'
  character(len=*), parameter :: filestring='*-task-list.hlp'
  integer(kind=4) :: ifile,nfile,first,last
  integer(kind=4), allocatable :: it(:)
  character(len=30) :: topic  ! len=30 for nicer "HELP TASK ?", beware of truncation
  character(len=30), allocatable :: topics(:)
  logical :: ok
  !
  ! Find files *-task-list.hlp
  call sic_parse_file(logstring,'','',dirstring)  ! Translate Sic logicals and others
  call gag_directory(dirstring,filestring,filelist,nfile,error)
  if (error) return
  ! Sort by alphabetical order
  allocate(it(nfile),topics(nfile))
  call gch_trie(filelist,it,nfile,filename_length,error)
  if (error)  return
  do ifile=1,nfile
    ! Strip "-task-list.hlp" from the file name
    topics(ifile) = filelist(ifile)(:index(filelist(ifile),'-task-list.hlp')-1)
  enddo
  !
  if (group.eq.'') then
    first = 1
    last = nfile
  else
    call sic_ambigs(rname,group,topic,ifile,topics,nfile,error)
    if (error)  return
    first = ifile
    last = ifile
  endif
  !
  ! Initialize
  call puthelp(char(0))  ! Initialize the line counter
  do ifile=first,last
    hlpfile = trim(dirstring)//filelist(ifile)
    topic = topics(ifile)
    call puthelp(topic)
    ok = sichelp(puthelp,topic,'',hlpfile,.false.,.false.)
  enddo
  !
end subroutine help_task
!
subroutine help_function(fname,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_function
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !  Display a summary of all the available functions
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: fname  ! Function name (blank for all)
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=32) :: uname
  character(len=filename_length) :: hlpfile
  integer(kind=4) :: fcode,narg(2),ier,in
  logical :: ok
  !
  if (fname.eq.'') then
    ! List all available functions
    !
    ! Intrinsic functions (native support in SIC)
    call sic_ambigs_list(rname,seve%i,'Intrinsic functions are:',name_function)
    !
    ! Program-defined functions (added by the programs)
    call sic_list_func()
    !
    ! User-defined functions (added by the user)
    call sic_list_expr('',0,error)
    if (error)  return
    !
  else
    ! Help for the given function. NB: functions can not be abbreviated
    ! this would be non-sense.
    !
    ! Check if the function exists
    uname = fname
    call sic_upper(uname)
    fcode = sic_get_expr(uname,len_trim(uname))
    if (fcode.ne.0) then
      ! Found a user-defined function. No detailed help available for now,
      ! just give the translation:
      call sic_list_expr(uname,len_trim(uname),error)
      return  ! Always
    endif
    !
    ! Try a SIC intrinsic or a program-defined
    call get_funcode(uname,fcode,narg,error)
    if (error)  return
    !
    if (fcode.le.max_code_func) then
      ! Intrinsic function: help is in SIC logical gag_help_func_sic
      call sic_parse_file('gag_help_func_sic',' ','.hlp',hlpfile)
    elseif (fcode.eq.code_pyfunc) then
      call sic_message(seve%i,rname,trim(fname)//' is a Python function, check help in Python')
      return
    else
      ! Program-defined function: help is available per function
      ier = gag_hasfin(maxfun,pffun,pnfun,namfun,uname,in)
      call sic_parse_file(descfun(in)%help,' ','.hlp',hlpfile)
    endif
    !
    ! Type its help
    call puthelp(char(0))  ! Initialize the line counter
    ok = sichelp(puthelp,uname,'',hlpfile,.false.,.false.)
  endif
  !
end subroutine help_function
!
subroutine help_procedure(procname,subname,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_procedure
  !---------------------------------------------------------------------
  ! @ private
  !  Display procedure help (HELP GO ProcName)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: procname  ! Procedure name
  character(len=*), intent(in)    :: subname   ! Subtopic name
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HELP'
  character(len=80) :: chain,topic,subtopic
  character(len=filename_length) :: file
  logical :: ok,found
  !
  ! Beware! No upcasing here: procedure name (i.e. file name) are case-sensitive!
  chain = 'p_'//procname
  call find_procedure(chain,file,found)
  if (.not.found) then
    ! procname.* not found in MACRO#DIR:
    call sic_message(seve%e,rname,'No such procedure GO '//procname)
    error = .true.
    return
  endif
  !
  ok = sic_query_file(chain,'MACRO#DIR:','.hlp',file)
  if (.not.ok) then
    ! procname.hlp file not found in MACRO#DIR:
    call sic_message(seve%e,rname,'No help for procedure GO '//procname)
    error = .true.
    return
  endif
  !
  topic = procname
  call sic_upper(topic)     ! Topic is upcased in hlp file
  subtopic = subname
  ok = sichelp(puthelp,topic,subtopic,file,.true.,.false.)
  !
end subroutine help_procedure
!
subroutine tkeys(task,key)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>tkeys
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*) :: task             !
  character(len=*), intent(in) :: key  !
  ! Local
  character(len=filename_length) :: file
  integer :: n
  logical :: ok
  !
  call sic_parse_file (task,'GILDAS_HELP:','.hlp',file)
  n = len_trim(task)
  call sic_upper (task(1:n))
  ok = sichelp(puthelp,task,key,file,.true.,.false.)
end subroutine tkeys
!
subroutine help_run_html(task,argu,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>help_run_html
  !---------------------------------------------------------------------
  ! @ private
  ! Read the help file with the following structures :
  !   - HTML files in GAG_HTML: or GAG_HTML_language:
  !   - plus taskname.html in same area
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: task   ! Task name
  character(len=*), intent(in)    :: argu   ! Subtopic name
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=filename_length) :: html_file
  character(len=1024) :: netscape
  integer(kind=4) :: na,ier
  !
  na = len_trim(argu)
  !
  call sic_parse_file(task,'GAG_TASK_HTML:','.html',html_file)
  !
  ! Syntaxe HTML dans la liste
  ! <LI> <A NAME=BACKGROUND HREF=background.html#Main> BACKGROUND</A>
  !
  ! et dans les fichiers
  ! <LI> <A NAME=IN$> IN$</A>
  !
#if defined(WIN32)
  if (na.ne.0) then
    netscape = 'START %SystemDrive%\progra~1\intern~1\iexplore.exe '//  &
    trim(html_file)//'#'//argu
  else
    netscape = 'START %SystemDrive%\progra~1\intern~1\iexplore.exe '//  &
    trim(html_file)
  endif
#else
  if (na.ne.0) then
    netscape = 'netscape -remote ''openURL(file://localhost/'//  &
    trim(html_file)//'#'//trim(argu)//')'''
  else
    netscape = 'netscape -remote ''openURL(file://localhost/'//  &
    trim(html_file)//')'''
  endif
#endif
  ier = gag_system(netscape)
end subroutine help_run_html

subroutine ghisto(line,error)
  use gildas_def
  use gbl_format
  use phys_const
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>ghisto,  &
                       no_interface1=>gr8_histo,  &
                       no_interface2=>gr8_yxhisto,  &
                       no_interface3=>gr8_histo_base,  &
                       no_interface4=>gr8_yxhisto_base,  &
                       no_interface5=>gr8_histo_hatchfill,  &
                       no_interface6=>gr8_yxhisto_hatchfill
  use greg_kernel
  use greg_pen
  use greg_types
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   HISTOGRAM [Array_X Array_Y]
  ! 1   [/BLANKING  Bval Eval]
  ! 2   [/FILL [Icolor]]
  ! 3   [/BASE [Base]]
  ! 4   [/HATCH [Ipen] [Angle] [Separ] [Phase]]
  ! 5   [/Y]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='HISTOGRAM'
  integer(kind=size_length) :: ixy,nbase
  integer(kind=4) :: form,narg,icol_old,ipen_old,nxy4
  type(sic_descriptor_t) :: xinca,yinca,basedesc
  integer(kind=address_length) :: ipx,ipy
  real(kind=8) :: bval,eval
  type(polygon_drawing_t) :: drawing
  logical :: yxhisto
  real(kind=8), allocatable :: base(:)
  integer(kind=4), parameter :: optblank=1
  integer(kind=4), parameter :: optfill=2
  integer(kind=4), parameter :: optbase=3
  integer(kind=4), parameter :: opthatch=4
  integer(kind=4), parameter :: opty=5
  !
  save xinca,yinca
  !
  ! Command line parsing
  narg = sic_narg(0)
  if (narg.ne.0 .and. narg.ne.2)  return
  !
  ! /BLANK options
  bval = cblank
  call sic_r8 (line,optblank,1,bval,.false.,error)
  if (error) return
  eval = eblank
  call sic_r8 (line,optblank,2,eval,.false.,error)
  if (error) return
  !
  ! /FILL and /HATCH options
  if (penupd) call setpen(cpen)
  call inqcol(icol_old)
  call inqpen(ipen_old)
  call parse_polygon_drawing(rname,line,optfill,opthatch,drawing,error)
  if (error)  return
  !
  ! /Y option
  yxhisto = sic_present(opty,0)
  !
  ! Command arguments (X and Y arrays)
  form = fmt_r8
  call get_incarnation('HISTOGRAM',line,form,ixy,xinca,yinca,error)
  if (error) return
  ipx = gag_pointer(xinca%addr,memory)
  ipy = gag_pointer(yinca%addr,memory)
  call gr8_histo_sanity(ixy,memory(ipx),memory(ipy),yxhisto,error)
  if (error)  return
  !
  ! /BASE option: argument can be scalar or 1D
  if (.not.sic_present(optbase,1)) then
    nbase = 1
    allocate(base(nbase))
    base(:) = 0.d0
  else
    call sic_de(line,optbase,1,basedesc,.true.,error)
    if (error)  goto 10
    if (desc_nelem(basedesc).eq.1) then
      nbase = 1
      allocate(base(nbase))
      call sic_descriptor_getval(basedesc,base,error)
      if (error)  goto 10
    elseif (basedesc%ndim.eq.1) then
      nbase = basedesc%dims(1)
      if (nbase.ne.ixy) then
        call greg_message(seve%e,rname,  &
          '/BASE argument must be scalar or same size as X and Y arrays')
        error = .true.
        goto 10
      endif
      allocate(base(nbase))
      call sic_descriptor_getval(basedesc,base,error)
      if (error)  goto 10
    else
      call greg_message(seve%e,rname,'/BASE argument must scalar or 1D')
      error = .true.
      goto 10
    endif
  endif
  !
  call gr_segm(rname,error)
  if (error)  goto 10
  !
  if (drawing%hatched) then  ! /HATCH (+ maybe /FILL)
    if (drawing%filled) then
      ! Hatch+Fill = color filled histogram (base assumed)
      drawing%hatched = .false. ! Temporarily disable hatching (segment colour issue)
      call setcol(drawing%fcolor)
      if (yxhisto) then
        call gr8_yxhisto_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
      else
        call gr8_histo_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
      endif
      !
      ! New segment (may have different colors)
      call gtsegm_close(error)
      call setcol(icol_old)  ! Reset color *after* closing the segment
      call gr_segm(rname,error)
      drawing%hatched = .true. ! Reenabled
    endif
    !
    drawing%filled = .false. ! Disable filling (segment colour issue)
    call setpen(drawing%hpen)
    if (yxhisto) then
      call gr8_yxhisto_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
    else
      call gr8_histo_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
    endif
    if (error)  continue
    !
  elseif (sic_present(optbase,0)) then  ! /BASE
    if (drawing%filled) then  ! /FILL
      ! Base+Fill = color filled histogram
      call setcol(drawing%fcolor)
      if (yxhisto) then
        call gr8_yxhisto_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
      else
        call gr8_histo_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
      endif
    else
      if (yxhisto) then
        call gr8_yxhisto_base(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval)
      else
        call gr8_histo_base(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval)
      endif
    endif
    !
  else
    ! No Base (maybe fill): top of histogram (maybe colored)
    if (drawing%filled)  call setcol(drawing%fcolor)
    nxy4 = ixy
    if (yxhisto) then
      call gr8_yxhisto(nxy4,memory(ipx),memory(ipy),bval,eval)
    else
      call gr8_histo(nxy4,memory(ipx),memory(ipy),bval,eval)
    endif
  endif
  !
  call gtsegm_close(error)
  !
10 continue
  ! Reset pen *after* closing the segment
  call setpen(ipen_old)
  call setcol(icol_old)
  !
  call sic_volatile(xinca)
  call sic_volatile(yinca)
  call sic_volatile(basedesc)
end subroutine ghisto
!
subroutine gr8_histo_sanity(nxy,x,y,yxhisto,error)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Check if bin coordinates are monotoneous (HISTOGRAM does not work
  ! properly if not).
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy      ! Number of points
  real(kind=8),              intent(in)    :: x(nxy)   ! X array
  real(kind=8),              intent(in)    :: y(nxy)   ! Y array
  logical,                   intent(in)    :: yxhisto  ! XY or YX histogram?
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HISTOGRAM'
  character(len=1) :: bin_name,cnt_name
  logical :: cnt_monotonic
  !
  if (yxhisto) then
    ! XY histogram
    if (monotonic_array(nxy,y))  return
    bin_name = 'Y'
    cnt_monotonic = monotonic_array(nxy,x)
    cnt_name = 'X'
  else
    ! XY histogram
    if (monotonic_array(nxy,x))  return
    bin_name = 'X'
    cnt_monotonic = monotonic_array(nxy,y)
    cnt_name = 'Y'
  endif
  call greg_message(seve%e,rname,bin_name//' is not a monotonic array')
  if (cnt_monotonic)  call greg_message(seve%e,rname,  &
    cnt_name//' is monotonic: missing option /'//cnt_name//' ?')
  error = .true.
  return
  !
contains
  !
  function monotonic_array(nxy,array)
    logical :: monotonic_array
    integer(kind=size_length), intent(in) :: nxy
    real(kind=8),              intent(in) :: array(nxy)
    ! Local
    integer(kind=size_length) :: ixy
    !
    monotonic_array = .true.
    if (array(1).lt.array(nxy)) then
      do ixy=1,nxy-1
        if (array(ixy).gt.array(ixy+1)) then
          monotonic_array = .false.
          return
        endif
      enddo
    else
      do ixy=1,nxy-1
        if (array(ixy).lt.array(ixy+1)) then
          monotonic_array = .false.
          return
        endif
      enddo
    endif
  end function monotonic_array
  !
end subroutine gr8_histo_sanity
!
subroutine gr4_histo(nxy,x,y,bval,eval)
  use greg_interfaces, except_this=>gr4_histo
  !---------------------------------------------------------------------
  ! @ public
  !  Connect a set of points with blanked values using histogram (top of
  ! histogram is drawn). Support for blank values and NaN.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nxy     ! Number of points
  real(kind=4),    intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=4),    intent(in) :: y(nxy)  ! Array of Y coordinates
  real(kind=4),    intent(in) :: bval    ! Blanking value
  real(kind=4),    intent(in) :: eval    ! Tolerance on blanking
  ! Local
  real(kind=8) :: xav,yav
  integer(kind=4) :: j
  logical :: up
  !
  if (nxy.lt.2) return
  !
  xav = x(1) - 0.5*(x(2)-x(1))
  if (y(1).eq.y(1).and.abs(y(1)-bval) .gt. eval) then
    yav = y(1)
    call relocate(xav,yav)
    up = .false.
  else
    up = .true.
  endif
  !
  do j = 2,nxy
    xav = 0.5 * (x(j)+x(j-1))
    if (y(j).eq.y(j).and.abs(y(j)-bval) .gt. eval) then
      if (up) then
        yav = y(j)
        call relocate(xav,yav)
        up = .false.
      else
        yav = y(j-1)
        call draw(xav,yav)
        yav = y(j)
        call draw(xav,yav)
      endif
    elseif (.not.up) then
      yav = y(j-1)
      call draw(xav,yav)
      up = .true.
    endif
  enddo
  if (up) return
  xav = x(nxy) + 0.5*(x(nxy)-x(nxy-1))
  yav = y(nxy)
  call draw(xav,yav)
end subroutine gr4_histo
!
subroutine gr8_histo(nxy,x,y,bval,eval)
  use greg_interfaces, except_this=>gr8_histo
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Connect a set of points with blanked values using histogram (top of
  ! histogram is drawn). Support for blank values and NaN.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nxy     ! Number of points
  real(kind=8),    intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=8),    intent(in) :: y(nxy)  ! Array of Y coordinates
  real(kind=8),    intent(in) :: bval    ! Blanking value
  real(kind=8),    intent(in) :: eval    ! Tolerance on blanking
  ! Local
  integer(kind=4) :: j
  real(kind=8) :: xav
  logical :: up
  !
  if (nxy.lt.2) return
  !
  ! Left of first bin
  xav = x(1) - 0.5d0*(x(2)-x(1))
  if ((y(1).eq.y(1)).and.abs(y(1)-bval).gt.eval) then
    call relocate(xav,y(1))
    up = .false.
  else
    up = .true.
  endif
  !
  ! Central bins
  do j = 2,nxy
    xav = 0.5d0 * (x(j)+x(j-1))
    if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
      if (up) then
        call relocate(xav,y(j))
        up = .false.
      else
        call draw(xav,y(j-1))
        call draw(xav,y(j))
      endif
    elseif (.not.up) then
      call draw(xav,y(j-1))
      up = .true.
    endif
  enddo
  !
  ! Right of last bin
  xav = x(nxy) + 0.5d0*(x(nxy)-x(nxy-1))
  if (.not.up) call draw(xav,y(nxy))
end subroutine gr8_histo
!
subroutine gr8_yxhisto(nxy,x,y,bval,eval)
  use greg_interfaces, except_this=>gr8_yxhisto
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Same as gr8_histo, but binning is along Y, and X provides the
  ! counts per bin. Bval/Eval apply on X.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nxy     ! Number of points
  real(kind=8),    intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=8),    intent(in) :: y(nxy)  ! Array of Y coordinates
  real(kind=8),    intent(in) :: bval    ! Blanking value
  real(kind=8),    intent(in) :: eval    ! Tolerance on blanking
  ! Local
  integer(kind=4) :: j
  real(kind=8) :: yav
  logical :: up
  !
  if (nxy.lt.2) return
  !
  ! Left of first bin
  yav = y(1) - 0.5d0*(y(2)-y(1))
  if ((x(1).eq.x(1)).and.abs(x(1)-bval).gt.eval) then
    call relocate(x(1),yav)
    up = .false.
  else
    up = .true.
  endif
  !
  ! Central bins
  do j = 2,nxy
    yav = 0.5d0 * (y(j)+y(j-1))
    if (x(j).eq.x(j).and.abs(x(j)-bval).gt.eval) then
      if (up) then
        call relocate(x(j),yav)
        up = .false.
      else
        call draw(x(j-1),yav)
        call draw(x(j),yav)
      endif
    elseif (.not.up) then
      call draw(x(j-1),yav)
      up = .true.
    endif
  enddo
  !
  ! Right of last bin
  yav = y(nxy) + 0.5d0*(y(nxy)-y(nxy-1))
  if (.not.up) call draw(x(nxy),yav)
end subroutine gr8_yxhisto
!
subroutine gr8_histo_base(nxy,x,y,nbase,base,bval,eval)
  use gildas_def
  use greg_interfaces, except_this=>gr8_histo_base
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Connect a set of points with blanked values using histogram
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy          ! Number of points
  real(kind=8),              intent(in) :: x(nxy)       ! Array of X coordinates
  real(kind=8),              intent(in) :: y(nxy)       ! Array of Y coordinates
  integer(kind=size_length), intent(in) :: nbase        ! Number base points (1 or Nxy)
  real(kind=8),              intent(in) :: base(nbase)  ! Base value(s)
  real(kind=8),              intent(in) :: bval         ! Blanking value
  real(kind=8),              intent(in) :: eval         ! Tolerance on blanking
  ! Local
  real(kind=8) :: xav
  integer(kind=size_length) :: j
  integer(kind=4) :: sbase
  logical :: up
  integer(kind=size_length), parameter :: first=1
  !
  if (nxy.lt.2) return
  !
  xav = x(1) - 0.5d0*(x(2)-x(1))
  if (y(1).eq.y(1) .and. abs(y(1)-bval).gt.eval) then
    call relocate(xav,base(ibase(first)))
    call draw(xav,y(1))
    up = .false.
  else
    up = .true.
  endif
  !
  if (nbase.eq.nxy) then
    sbase = 1
  else
    sbase = 0
  endif
  !
  do j = 2,nxy
    xav = 0.5d0 * (x(j)+x(j-1))
    if (y(j).eq.y(j).and.abs(y(j)-bval) .gt. eval) then
      if (up) then
        call relocate(xav,base(ibase(j)))
        call draw(xav,y(j))
        up = .false.
      else
        call draw(xav,y(j-1))
        call draw(xav,base(ibase(j)))
        call draw(xav,y(j))
      endif
    elseif (.not.up) then
      call draw(xav,y(j-1))
      call draw(xav,base(ibase(j)))
      up = .true.
    endif
  enddo
  if (up) return
  xav = x(nxy) + 0.5d0*(x(nxy)-x(nxy-1))
  call draw(xav,y(nxy))
  call draw(xav,base(ibase(nxy)))
  !
contains
  function ibase(ival)
    !-------------------------------------------------------------------
    ! Return index in base arrray for ival-th of histogram
    !-------------------------------------------------------------------
    integer(kind=size_length) :: ibase
    integer(kind=size_length), intent(in) :: ival
    if (nbase.eq.nxy) then
      ibase = ival
    else
      ibase = 1
    endif
  end function ibase
end subroutine gr8_histo_base
!
subroutine gr8_yxhisto_base(nxy,x,y,nbase,base,bval,eval)
  use gildas_def
  use greg_interfaces, except_this=>gr8_yxhisto_base
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !  Same as gr8_histo_base, but binning is along Y, and X provides the
  ! counts per bin. Bval/Eval apply on X.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy          ! Number of points
  real(kind=8),              intent(in) :: x(nxy)       ! Array of X coordinates
  real(kind=8),              intent(in) :: y(nxy)       ! Array of Y coordinates
  integer(kind=size_length), intent(in) :: nbase        ! Number base points (1 or Nxy)
  real(kind=8),              intent(in) :: base(nbase)  ! Base value(s)
  real(kind=8),              intent(in) :: bval         ! Blanking value
  real(kind=8),              intent(in) :: eval         ! Tolerance on blanking
  ! Local
  real(kind=8) :: yav
  integer(kind=size_length) :: j
  integer(kind=4) :: sbase
  logical :: up
  integer(kind=size_length), parameter :: first=1
  !
  if (nxy.lt.2) return
  !
  yav = y(1) - 0.5d0*(y(2)-y(1))
  if (x(1).eq.x(1) .and. abs(x(1)-bval).gt.eval) then
    call relocate(base(ibase(first)),yav)
    call draw(x(1),yav)
    up = .false.
  else
    up = .true.
  endif
  !
  if (nbase.eq.nxy) then
    sbase = 1
  else
    sbase = 0
  endif
  !
  do j = 2,nxy
    yav = 0.5d0 * (y(j)+y(j-1))
    if (x(j).eq.x(j).and.abs(x(j)-bval) .gt. eval) then
      if (up) then
        call relocate(base(ibase(j)),yav)
        call draw(y(j),yav)
        up = .false.
      else
        call draw(x(j-1),yav)
        call draw(base(ibase(j)),yav)
        call draw(x(j),yav)
      endif
    elseif (.not.up) then
      call draw(x(j-1),yav)
      call draw(base(ibase(j)),yav)
      up = .true.
    endif
  enddo
  if (up) return
  yav = y(nxy) + 0.5d0*(y(nxy)-y(nxy-1))
  call draw(x(nxy),yav)
  call draw(base(ibase(nxy)),yav)
  !
contains
  function ibase(ival)
    !-------------------------------------------------------------------
    ! Return index in base arrray for ival-th of histogram
    !-------------------------------------------------------------------
    integer(kind=size_length) :: ibase
    integer(kind=size_length), intent(in) :: ival
    if (nbase.eq.nxy) then
      ibase = ival
    else
      ibase = 1
    endif
  end function ibase
end subroutine gr8_yxhisto_base
!
subroutine gr8_histo_hatchfill(nxy,x,y,nbase,base,bval,eval,drawing,error)
  use gildas_def
  use greg_interfaces, except_this=>gr8_histo_hatchfill
  use greg_types
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Build the histogram from the input X and Y values, and fill it
  ! with hatches and maybe color. Contour is not drawn.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy          ! Number of points
  real(kind=8),              intent(in)    :: x(nxy)       ! Array of X coordinates
  real(kind=8),              intent(in)    :: y(nxy)       ! Array of Y coordinates
  integer(kind=size_length), intent(in)    :: nbase        ! Number base points (1 or Nxy)
  real(kind=8),              intent(in)    :: base(nbase)  ! Base of histogram
  real(kind=8),              intent(in)    :: bval         ! Blanking value
  real(kind=8),              intent(in)    :: eval         ! Tolerance on blanking value
  type(polygon_drawing_t),   intent(in)    :: drawing      ! Drawing description
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  real(kind=8), allocatable :: x2(:),y2(:)
  real(kind=8) :: xav
  integer(kind=size_length) :: j,istart,nelem,inext,jbase,npts
  !
  if (nxy.lt.2) return
  !
  inext = 1
  do while (inext.ne.0)
    ! Read data by blocks of valid values (non blanks if eval>=0, and non NaNs)
    call find_blank8(y,bval,eval,nxy,istart,nelem,inext)
    if (nelem.le.0)  cycle
    !
    ! 1) Build the polygon histogram from the valid values
    npts = 0
    if (istart.eq.1) then
      xav = x(1) - 0.5d0*(x(2)-x(1))
    else
      xav = 0.5d0 * (x(istart-1)+x(istart))
    endif
    call new_point(xav,base(ibase(istart)))  ! First point
    call new_point(xav,y(istart))
    !
    ! Histogram top (left parts)
    do j=2,nelem
      xav = 0.5d0 * (x(istart+j-2)+x(istart+j-1))
      call new_point(xav,y(istart+j-2))
      call new_point(xav,y(istart+j-1))
    enddo
    ! Histogram top (right part)
    if (istart+nelem-1.eq.nxy) then
      xav = x(nxy) + 0.5d0*(x(nxy)-x(nxy-1))
    else
      xav = 0.5d0 * (x(istart+nelem-1)+x(istart+nelem))
    endif
    call new_point(xav,y(istart+nelem-1))
    !
    ! Base
    call new_point(xav,base(ibase(istart+nelem-1)))
    if (nbase.eq.nxy) then
      ! 1D base array
      do jbase=istart+nelem-1,istart+1,-1
        xav = 0.5d0 * (x(jbase-1)+x(jbase))
        call new_point(xav,base(ibase(jbase)))
        call new_point(xav,base(ibase(jbase-1)))
      enddo
    endif
    !
    ! Close the polygon
    call last_point()
    !
    ! 2) Drawings
    ! Contour:
    ! call gr8_connect(nxy2,x2,y2,bval,eval)
    !
    if (drawing%filled) then
      ! Fill the region
      call gr8_ufill(npts,x2,y2)
    endif
    !
    if (drawing%hatched) then
      ! Hatch the region
      call gr8_hatch('HISTO',npts,x2,y2,  &
                    drawing%hangle,drawing%hsepar,drawing%hphase,error)
      if (error)  return
    endif
    !
  enddo
  !
contains
  function ibase(ival)
    !-------------------------------------------------------------------
    ! Return index in base arrray for ival-th of histogram
    !-------------------------------------------------------------------
    integer(kind=size_length) :: ibase
    integer(kind=size_length), intent(in) :: ival
    if (nbase.eq.nxy) then
      ibase = ival
    else
      ibase = 1
    endif
  end function ibase
  !
  subroutine new_point(xx,yy)
    real(kind=8), intent(in) :: xx,yy
    npts = npts+1
    call reallocate_x2y2(npts)
    x2(npts) = xx
    y2(npts) = yy
  end subroutine new_point
  !
  subroutine last_point()
    npts = npts+1
    call reallocate_x2y2(npts)
    x2(npts) = x2(1)
    y2(npts) = y2(1)
  end subroutine last_point
  !
  subroutine reallocate_x2y2(nn)
    integer(kind=size_length), intent(in) :: nn
    integer(kind=size_length), parameter :: minalloc=100
    integer(kind=size_length) :: osize,nsize
    real(kind=8), allocatable :: xtmp(:),ytmp(:)
    nsize = max(nn,minalloc)
    if (allocated(x2)) then
      osize = size(x2)
      if (osize.ge.nn)  return  ! Resize not needed
      call move_alloc(from=x2,to=xtmp)
      call move_alloc(from=y2,to=ytmp)
      nsize = max(nsize,2*osize)
    endif
    allocate(x2(nsize),y2(nsize))
    if (allocated(xtmp)) then
      x2(1:osize) = xtmp(1:osize)
      y2(1:osize) = ytmp(1:osize)
      deallocate(xtmp,ytmp)
    endif
  end subroutine reallocate_x2y2
  !
end subroutine gr8_histo_hatchfill
!
subroutine gr8_yxhisto_hatchfill(nxy,x,y,nbase,base,bval,eval,drawing,error)
  use gildas_def
  use greg_interfaces, except_this=>gr8_yxhisto_hatchfill
  use greg_types
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Same as gr8_histo_hatchfill, but binning is along Y, and X provides
  ! the counts per bin. Bval/Eval apply on X.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy          ! Number of points
  real(kind=8),              intent(in)    :: x(nxy)       ! Array of X coordinates
  real(kind=8),              intent(in)    :: y(nxy)       ! Array of Y coordinates
  integer(kind=size_length), intent(in)    :: nbase        ! Number base points (1 or Nxy)
  real(kind=8),              intent(in)    :: base(nbase)  ! Base of histogram
  real(kind=8),              intent(in)    :: bval         ! Blanking value
  real(kind=8),              intent(in)    :: eval         ! Tolerance on blanking value
  type(polygon_drawing_t),   intent(in)    :: drawing      ! Drawing description
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  real(kind=8), allocatable :: x2(:),y2(:)
  real(kind=8) :: yav
  integer(kind=size_length) :: j,istart,nelem,inext,jbase,npts
  !
  if (nxy.lt.2) return
  !
  inext = 1
  do while (inext.ne.0)
    ! Read data by blocks of valid values (non blanks if eval>=0, and non NaNs)
    call find_blank8(x,bval,eval,nxy,istart,nelem,inext)
    if (nelem.le.0)  cycle
    !
    ! 1) Build the polygon histogram from the valid values
    npts = 0
    if (istart.eq.1) then
      yav = y(1) - 0.5d0*(y(2)-y(1))
    else
      yav = 0.5d0 * (y(istart-1)+y(istart))
    endif
    call new_point(base(ibase(istart)),yav)  ! First point
    call new_point(x(istart),yav)
    !
    ! Histogram top (left parts)
    do j=2,nelem
      yav = 0.5d0 * (y(istart+j-2)+y(istart+j-1))
      call new_point(x(istart+j-2),yav)
      call new_point(x(istart+j-1),yav)
    enddo
    ! Histogram top (right part)
    if (istart+nelem-1.eq.nxy) then
      yav = y(nxy) + 0.5d0*(y(nxy)-y(nxy-1))
    else
      yav = 0.5d0 * (y(istart+nelem-1)+y(istart+nelem))
    endif
    call new_point(x(istart+nelem-1),yav)
    !
    ! Base
    call new_point(base(ibase(istart+nelem-1)),yav)
    if (nbase.eq.nxy) then
      do jbase=istart+nelem-1,istart+1,-1
        yav = 0.5d0 * (y(jbase-1)+y(jbase))
        call new_point(base(ibase(jbase)),yav)
        call new_point(base(ibase(jbase-1)),yav)
      enddo
    endif
    !
    ! Close the polygon
    call last_point()
    !
    ! 2) Drawings
    ! Contour:
    ! call gr8_connect(nxy2,x2,y2,bval,eval)
    !
    if (drawing%filled) then
      ! Fill the region
      call gr8_ufill(npts,x2,y2)
    endif
    !
    if (drawing%hatched) then
      ! Hatch the region
      call gr8_hatch('HISTO',npts,x2,y2,  &
                    drawing%hangle,drawing%hsepar,drawing%hphase,error)
      if (error)  return
    endif
    !
  enddo
  !
contains
  function ibase(ival)
    !-------------------------------------------------------------------
    ! Return index in base arrray for ival-th of histogram
    !-------------------------------------------------------------------
    integer(kind=size_length) :: ibase
    integer(kind=size_length), intent(in) :: ival
    if (nbase.eq.nxy) then
      ibase = ival
    else
      ibase = 1
    endif
  end function ibase
  !
  subroutine new_point(xx,yy)
    real(kind=8), intent(in) :: xx,yy
    npts = npts+1
    call reallocate_x2y2(npts)
    x2(npts) = xx
    y2(npts) = yy
  end subroutine new_point
  !
  subroutine last_point()
    npts = npts+1
    call reallocate_x2y2(npts)
    x2(npts) = x2(1)
    y2(npts) = y2(1)
  end subroutine last_point
  !
  subroutine reallocate_x2y2(nn)
    integer(kind=size_length), intent(in) :: nn
    integer(kind=size_length), parameter :: minalloc=100
    integer(kind=size_length) :: osize,nsize
    real(kind=8), allocatable :: xtmp(:),ytmp(:)
    nsize = max(nn,minalloc)
    if (allocated(x2)) then
      osize = size(x2)
      if (osize.ge.nn)  return  ! Resize not needed
      call move_alloc(from=x2,to=xtmp)
      call move_alloc(from=y2,to=ytmp)
      nsize = max(nsize,2*osize)
    endif
    allocate(x2(nsize),y2(nsize))
    if (allocated(xtmp)) then
      x2(1:osize) = xtmp(1:osize)
      y2(1:osize) = ytmp(1:osize)
      deallocate(xtmp,ytmp)
    endif
  end subroutine reallocate_x2y2
  !
end subroutine gr8_yxhisto_hatchfill

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! TELCAL fitting methods
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module fit_association
  use fit_definitions
  !----------------------------------------------------------------------
  ! This module is "private" to this file. It should *NOT* be used outside.
  !
  ! Association of one instanciation of each fit definitions.
  !
  ! This module association will enable parameter sharing of all input
  ! parameters (in particular the fixed parameters that the general
  ! fitting routine never transmit).
  !----------------------------------------------------------------------
  type(simple_1d), save :: adat
  type(fit_fun),   save :: afun
  type(fit_var),   save :: avar
end module fit_association
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine fit_1d(dat,fun,verbose)
  use telcal_interfaces, except_this=>fit_1d
  use fit_definitions
  use fit_association
  !----------------------------------------------------------------------
  ! @ public
  ! General unidimensional fitting routine
  !----------------------------------------------------------------------
  type(simple_1d), intent(in)  :: dat ! Data vectors
  type(fit_fun), intent(inout) :: fun ! Fitting function description
  logical, intent(in)      :: verbose ! Verbose or quiet?
  ! Local variables
  real(8), allocatable :: fvec(:)
  real(8), allocatable :: wa(:)
  integer, allocatable :: iw(:)
  real(8), allocatable :: wa1(:),wa2(:),wa3(:),wa4(:),r(:,:)
  type(simple_1d) :: sol
  !
  integer :: i,k,ier
  integer :: nprint,info,lwa,iopt,w
  real(8) :: tol,chi2,s,m
  logical :: minimize,find_errors,debug
  !
  ! Initialize flag
  fun%flag = 0
  !
  ! Check if fitting method is known
  if (fun%method.ne."SLATEC") then
     call gagout('E-FIT1D, Unknown fitting library: '//fun%method)
     fun%flag = -1
     return
  endif
  call xsetf(0)
  !
  ! Check if fitting function is known
  !
  ! iopt = 1 ! Minimization routine should guess the Jacobian
  if (fun%name.eq.'GAUSSIAN') then
     iopt = 2 ! Full Jacobian provided by this program
  else if (fun%name.eq.'GAUSSIAN+BASE') then
     iopt = 2 ! Full Jacobian provided by this program
  else if (fun%name.eq.'2*GAUSSIAN+BASE') then
     iopt = 2 ! Full Jacobian provided by this program
  else if (fun%name.eq.'LORENTZIAN') then
     iopt = 2 ! Full Jacobian provided by this program
  else if (fun%name.eq.'POLYNOMIAL') then
     call fit_polynomial(dat,fun)
     return
  else
     call gagout('E-FIT1D, Unknown fitting function: '//fun%name)
     fun%flag = -2
     return
  endif
  !
  ! Initialize
  debug       = .false.
  minimize    = .true.
  find_errors = .true.
  fun%ncall = 0
  do i=1,fun%npar
     fun%par(i)%value = fun%par(i)%guess
  enddo
  !
  ! Copy data from input parameters to association module to enable
  ! exchange of fixed parameters with computation routine "min_dnls".
  allocate(adat%x(dat%n),adat%y(dat%n),adat%w(dat%n),stat=ier)
  if (ier.eq.0) then
     call copy_simple_1d(dat,adat)
  else
     call gagout('E-FIT1D, Error in data array allocation')
     fun%flag = -3
     return
  endif
  !
  allocate (afun%par(fun%npar),stat=ier)
  if (ier.eq.0) then
     call copy_function(fun,afun)
  else
     call gagout('E-FIT1D, Error in function array allocation')
     fun%flag = -3
     return
  endif
  ! From now on, use only associated variables
  !
  ! Setup the variable parameters
  k = 0
  do i=1,afun%npar
     if (.not.afun%par(i)%fixed) then
        k = k+1
     endif
  enddo
  if (k.eq.0) then
     call gagout('W-FIT_1D, All parameter are fixed: Nothing to be done!...')
     fun%flag = -4
     return
  endif
  !
  avar%n = k
  allocate(avar%x(k),avar%d(k),avar%idx(k),stat=ier)
  k = 0
  do i=1,afun%npar
     if (.not.afun%par(i)%fixed) then
        k = k+1
        avar%x(k) = afun%par(i)%guess
        avar%d(k) = afun%par(i)%error
        avar%idx(k) = i
     endif
  enddo
  !
  allocate (fvec(adat%n),stat=ier)
  tol = min(0.7d0/adat%n,1d-4)
  !
  ! The fit happens here
  if (minimize) then
     !
     lwa = avar%n*(adat%n+5)+adat%n
     allocate (wa(lwa),stat=ier)
     allocate (iw(adat%n),stat=ier)
     !
     if (debug) then
        nprint = 50
     else
        nprint = 0
     endif
     info = 0
     call dnls1e(    &
          min_dnls,  & ! Function to be minimized
          iopt,      & ! 1=No, 2=Full Jacobian provided
          adat%n,    & ! Number of data points
          avar%n,    & ! Number of variable fitted parameters
          avar%x,    & ! Values of variable fitted parameters
          fvec,      & !
          tol,       & ! Tolerance
          nprint,    & ! Print control every NPRINT iterations (IFLAG = 0 in FCN)
          info,      & ! Information on result quality
          iw,        & ! integer work array of length NPAR
          wa,        & !
          lwa)         !
     !
     if (info.eq.0) then
        if (verbose) then
           print *,'E-DNLS1E, Improper input parameters, info= ',info
        endif
        fun%flag = -5
     elseif (info.eq.6 .or. info.eq.7) then
        if (verbose) then
           print *,'E-DNLS1E, TOL too small, info= ',info
        endif
        fun%flag = -5
     elseif (info.eq.5) then
        if (verbose) then
           print *,'E-DNLS1E, Not converging, info= ',info
        endif
        fun%flag = -5
     elseif (info.eq.4) then
        if (verbose) then
           print *,'W-DNLS1E, Singular Jacobian, info= ',info
        endif
        fun%flag = -5
     elseif (info.eq.1 .or. info.eq.2 .or.info.eq.3) then
        if (verbose) then
           print *,'I-DNLS1E, Algorithm reaches convergence, info= ',info
        endif
     else
        if (verbose) then
           print *,'E-DNLS1E, Unknown info code, info= ',info
        endif
        fun%flag = -5
     endif
     !
     deallocate (iw,wa)
  endif
  !
  ! After fitting stuffs, if fitting is a success
  if (fun%flag.eq.0) then
     !
     call patch_pointing(afun,avar)
     !
     ! Compute uncertainties
     if (find_errors) then
        allocate(r(adat%n,avar%n),stat=ier)
        allocate(wa1(avar%n),wa2(avar%n),wa3(avar%n),wa4(adat%n),stat=ier)
        !
        info = 0
        call dcov(        &
             min_dnls,    &
             iopt,        &
             adat%n,      &
             avar%n,      &
             avar%x,      &
             fvec,        &
             r,           &
             adat%n,      &
             info,        &            ! Result condition
             wa1,wa2,wa3, &
             wa4)
        !
        if (info.eq.0) then
           if (verbose) then
              print *,'F-DCOV, Improper input parameters, info= ',info
           endif
           fun%flag = -6
        elseif (info.eq.2) then
           if (verbose) then
              print *,'W-DCOV, Singular Jacobian, info= ',info
           endif
           fun%flag = -6
        else
           do i=1,avar%n
              avar%d(i) = sqrt(abs(r(i,i)))
           enddo
        endif
        deallocate (r,wa1,wa2,wa3,wa4)
     endif
     !
     do i=1,avar%n
        afun%par(avar%idx(i))%value = avar%x(i)
        afun%par(avar%idx(i))%error = avar%d(i)
     enddo
     !
     ! Compute final chi2
     chi2 = 0.
     do i=1,adat%n
        chi2 = chi2 + fvec(i)**2
     enddo
     afun%chi2 = chi2
     !
     ! Compute final RMS
     ! 1 - Compute the solution profile
     sol%n = adat%n
     allocate(sol%x(sol%n),sol%y(sol%n),stat=ier)
     ! if (failed_allocate(rname,"solution",ier,error)) goto 100
     sol%x(:) = adat%x(:)
     call get_profile(afun,sol)
     ! 2 - Compute the difference
     ! call get_difference(adat,afun,fvec)  ! Note: values are weighted in return
     do i=1,adat%n
       fvec(i) = sol%y(i)-adat%y(i)  ! Unweighted difference
     enddo
     deallocate(sol%x,sol%y)
     ! 3 - Compute mean
     s = 0.
     w = 0
     do i=1,adat%n
       if (adat%w(i).gt.0.) then
         s = s+fvec(i)  ! Unweighted mean
         w = w+1
       endif
     enddo
     m = s/w
     ! 4 - Compute RMS
     s = 0.
     w = 0
     do i=1,adat%n
       if (adat%w(i).gt.0.) then
         s = s+(fvec(i)-m)**2  ! Unweighted RMS
         w = w+1
       endif
     enddo
     afun%rms = sqrt(s/w)  ! Actually the standard deviation
     !
     ! Print results
     if (verbose) then
        print *,'------'
        print *,'FINAL RESULT after ',afun%ncall,' calls'
        print *,' '
        do i=1,afun%npar
           if (afun%par(i)%fixed) then
              write(6,'(a20,f12.4,7x,a)') afun%par(i)%name, afun%par(i)%value, "Fixed"
           else
              write(6,'(a20,2f12.4)') afun%par(i)%name, afun%par(i)%value, afun%par(i)%error
           endif
        enddo
     endif
     !
     ! Return results: ie get back to input parameters from association module
     call copy_function(afun,fun)
     !
  endif
  !
  deallocate(afun%par)
  deallocate(adat%x,adat%y,adat%w)
  deallocate(avar%x,avar%d,avar%idx)
  !
end subroutine fit_1d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine min_dnls(iflag,mdat,npar,x,fvec,fjac,ldfjac)
  use telcal_interfaces, except_this=>min_dnls
  use fit_association ! Transmission of hidden (eg fixed) parameters
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !
  !----------------------------------------------------------------------
  integer, intent(in)  :: iflag          ! Input flag
  integer, intent(in)  :: mdat           ! Number of data points
  integer, intent(in)  :: npar           ! Number of variable (ie non-fixed) fitted parameters
  integer, intent(in)  :: ldfjac         ! First dimension of fjac
  real(8), intent(in)  :: x(npar)        ! Variable fitted parameters
  real(8), intent(out) :: fvec(mdat)     ! Difference between the function value and the data points
  real(8), intent(out) :: fjac(ldfjac,*) ! Jacobian (ie partial derivatives of f)
  !
  ! Local variables
  real(8) chi2
  integer i
  !
  ! From x to association module
  do i=1,avar%n
     afun%par(avar%idx(i))%value = x(i)
  enddo
  !
  if (iflag.eq.0) then         ! Print current values
     chi2 = 0.
     do i=1,mdat
        chi2 = chi2 + fvec(i)*fvec(i)
     enddo
     print *,'Val  ',x
     print '(1x,A,F12.2)','Chi2 ',chi2
  elseif  (iflag.eq.1) then    ! Compute the difference vector (fvec)
     call get_difference(adat,afun,fvec)
  elseif  (iflag.eq.2) then    ! Compute the Jacobian
     call get_jacobian(adat,afun,avar,fvec,fjac) ! ,ldfjac)
  else
     print *,'Do not know IFLAG ',iflag
  endif
end subroutine min_dnls
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine patch_pointing(fun,var)
  use fit_definitions
  !---------------------------------------------------------------------
  ! @ private
  ! Post-minimization patches
  !---------------------------------------------------------------------
  type(fit_fun), intent(in)    :: fun
  type(fit_var), intent(inout) :: var
  !
  integer(kind=4) :: ivar,iwidth,iarea
  !
  if (fun%name.eq.'GAUSSIAN' .or.  &
      fun%name.eq.'GAUSSIAN+BASE') then
    ! Patch for WIDTH and AREA signs:
    ! - the width of the minimized gaussian is insensitive to WIDTH
    !   sign => the WIDTH is forced positive.
    ! - the amplitude of the minimized gaussian is only sensitive to
    !   the WIDTH/AREA ratio sign (same sign: positive gaussian,
    !   opposite sign: negative gaussian) => if WIDTH sign is swapped
    !   AREA sign is swapped accordingly.
    iwidth = 0
    iarea  = 0
    do ivar=1,var%n
      if (fun%par(var%idx(ivar))%name.eq.'WIDTH')  iwidth=ivar
      if (fun%par(var%idx(ivar))%name.eq.'AREA')   iarea =ivar
    enddo
    if (iwidth.gt.0 .and. iarea.gt.0) then
      ! Both were free (fitted) parameters
      if (var%x(iwidth).lt.0.d0) then
        var%x(iwidth) = -var%x(iwidth)
        var%x(iarea) = -var%x(iarea)
      endif
    endif
  endif
end subroutine patch_pointing
!
subroutine get_difference(dat,fun,fvec)
  use telcal_interfaces, except_this=>get_difference
  use fit_definitions  ! Transmission of hidden (eg fixed) parameters
  !----------------------------------------------------------------------
  ! @ private
  !
  !----------------------------------------------------------------------
  type(simple_1d),  intent(in) :: dat ! Data vectors
  type(fit_fun), intent(inout) :: fun ! Fitting function description
  real(8), intent(out) :: fvec(dat%n) ! Difference between the function value and the data points
  !
  ! Local variables
  real(8) :: x01,y01,dx1
  real(8) :: x02,y02,dx2
  real(8) :: pi,xx
  integer i,j
  !
  fun%ncall = fun%ncall+1
  if (fun%name.eq.'GAUSSIAN') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     y01 = fun%par(1)%value / fun%par(3)%value * 2.d0*sqrt(log(2.d0)) / sqrt(pi)
     do i=1,dat%n
        xx = abs((dat%x(i)-x01)*dx1)
        if (xx.lt.5) then
           fvec(i) = dat%y(i) - y01 * exp(-(xx*xx))
        else
           fvec(i) = dat%y(i)
        endif
        fvec(i) = fvec(i) * dat%w(i)
     enddo
  else if (fun%name.eq.'GAUSSIAN+BASE') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     y01 = fun%par(1)%value / fun%par(3)%value * 2.d0*sqrt(log(2.d0)) / sqrt(pi)
     do i=1,dat%n
        xx = abs((dat%x(i)-x01)*dx1)
        if (xx.lt.5) then
           fvec(i) = dat%y(i) - y01 * exp(-(xx*xx))
        else
           fvec(i) = dat%y(i)
        endif
        fvec(i) = fvec(i) - (fun%par(4)%value + fun%par(5)%value*dat%x(i))
        fvec(i) = fvec(i) * dat%w(i)
     enddo
  else if (fun%name.eq.'2*GAUSSIAN+BASE') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     y01 = fun%par(1)%value / fun%par(3)%value * 2.d0*sqrt(log(2.d0)) / sqrt(pi)
     x02 = fun%par(2)%value+fun%par(5)%value
     dx2 = 2.d0*sqrt(log(2.d0)) / (fun%par(3)%value*fun%par(6)%value)
     y02 = (fun%par(1)%value*fun%par(4)%value) / (fun%par(3)%value*fun%par(6)%value) * 2.d0*sqrt(log(2.d0)) / sqrt(pi)
     do i=1,dat%n
        xx = (dat%x(i)-x01)*dx1
        if (xx.lt.5) then
           fvec(i) = dat%y(i) - y01 * exp(-xx*xx)
        else
           fvec(i) = dat%y(i)
        endif
        xx = (dat%x(i)-x02)*dx2
        if (xx.lt.5) then
           fvec(i) = fvec(i) - y02 * exp(-xx*xx)
        endif
        fvec(i) = fvec(i) - (fun%par(7)%value + fun%par(8)%value*dat%x(i))
        fvec(i) = fvec(i) * dat%w(i)
     enddo
  else if (fun%name.eq.'LORENTZIAN') then
    x01 = fun%par(2)%value
    dx1 = 1.d0 / fun%par(3)%value
    y01 = fun%par(1)%value
    do i=1,dat%n
       xx = (dat%x(i)-x01)*dx1
       fvec(i) = dat%y(i) - y01 / (1d0 + xx*xx)
       fvec(i) = fvec(i) * dat%w(i)
    enddo
  else if (fun%name.eq.'POLYNOMIAL') then
     do i=1,dat%n
        fvec(i) = fun%par(fun%npar)%value
        do j=fun%npar-1,1
           fvec(i) = fvec(i) * dat%x(i) + fun%par(j)%value
        enddo
        fvec(i) = (dat%y(i) - fvec(i)) * dat%w(i)
     enddo
  endif
end subroutine get_difference
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine get_jacobian(dat,fun,var,fvec,fjac)
  use telcal_interfaces, except_this=>get_jacobian
  use fit_definitions ! Transmission of hidden (eg fixed) parameters
  !----------------------------------------------------------------------
  ! @ private
  ! fvec must *NOT* be altered here (See dnsl1e documentation).
  !
  ! The difficulty here is that some parameters can be fixed, other
  ! variable. We calculate all derivatives in this version, and place
  ! them according to the indexing of the variable parameters ...
  !----------------------------------------------------------------------
  type(simple_1d),  intent(in) :: dat   ! Data vectors
  type(fit_var),    intent(in) :: var   !
  type(fit_fun), intent(inout) :: fun   ! Fitting function description
  real(8), intent(in)  :: fvec(dat%n)   ! Difference between the function value and the data points
  real(8), intent(out) :: fjac(dat%n,*) ! Jacobian (ie partial derivatives of f)
  !
  ! Local variables
  real(4) :: x01,y01,dx1,dy1
  real(4) :: x02,y02,dx2,dy2
  real(4) :: xx,y
  real(4) :: dy(8)
  integer :: i,j
  real(8) :: pi
  !
  fun%ncall = fun%ncall+1
  if (fun%name.eq.'GAUSSIAN') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     dy1 = dx1 / sqrt(pi)
     y01 = fun%par(1)%value
     do i=1,dat%n
        xx = (dat%x(i)-x01)*dx1
        if (abs(xx).lt.5) then
           y = dy1 * exp(-xx*xx)
           dy(1) = y
           dy(2) = y01 * y * dx1 * 2.d0 * xx
           dy(3) = y01 * y / fun%par(3)%value * (2d0*xx*xx - 1.d0)
           do j=1,var%n
              fjac(i,j) = - dy(var%idx(j)) * dat%w(i)
           enddo
        else
           do j=1,var%n
              fjac(i,j) = 0.0
           enddo
        endif
     enddo
  else if (fun%name.eq.'GAUSSIAN+BASE') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     dy1 = dx1 / sqrt(pi)
     y01 = fun%par(1)%value
     do i=1,dat%n
        xx = (dat%x(i)-x01)*dx1
        if (abs(xx).lt.5) then
           y = dy1 * exp(-xx*xx)
           dy(1) = y
           dy(2) = y01 * y * dx1 * 2.d0 * xx
           dy(3) = y01 * y / fun%par(3)%value * (2d0*xx*xx - 1.d0)
        else
           dy(1) = 0.0
           dy(2) = 0.0
           dy(3) = 0.0
        endif
        dy(4) = 1.0
        dy(5) = dat%x(i)
        do j=1,var%n
           fjac(i,j) = - dy(var%idx(j)) * dat%w(i)
        enddo
     enddo
  else if (fun%name.eq.'2*GAUSSIAN+BASE') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     y01 = fun%par(1)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     dy1 = dx1 / sqrt(pi)
     x02 = fun%par(2)%value+fun%par(5)%value
     y02 = fun%par(1)%value*fun%par(4)%value
     dx2 = 2.d0*sqrt(log(2.d0)) / (fun%par(3)%value*fun%par(6)%value)
     dy2 = dx2 / sqrt(pi)
     do i=1,dat%n
        xx = (dat%x(i)-x01)*dx1
        if (abs(xx).lt.5) then
           y = dy1 * exp(-xx*xx)
           dy(1) = y
           dy(2) = y01 * y * dx1 * 2.d0 * xx
           dy(3) = y01 * y / fun%par(3)%value * (2d0*xx*xx - 1.d0)
        else
           dy(1) = 0.0
           dy(2) = 0.0
           dy(3) = 0.0
        endif
        xx = (dat%x(i)-x02)*dx2
        if (abs(xx).lt.5) then
           y = dy2 * exp(-xx*xx)
           dy(4) = y
           dy(5) = y02 * y * dx2 * 2.d0 * xx
           dy(6) = y02 * y / (fun%par(3)%value*fun%par(6)%value) * (2d0*xx*xx - 1.d0)
           dy(1) = dy(1) + dy(4) * fun%par(4)%value
           dy(2) = dy(2) + dy(5)
           dy(3) = dy(3) + dy(6) * fun%par(6)%value
           dy(4) = dy(4) * fun%par(1)%value
           dy(6) = dy(6) * fun%par(3)%value
        else
           dy(4) = 0
           dy(5) = 0
           dy(6) = 0
        endif
        dy(7) = 1.0
        dy(8) = dat%x(i)
        do j=1,var%n
           fjac(i,j) = - dy(var%idx(j)) * dat%w(i)
        enddo
     enddo
  else if (fun%name.eq.'LORENTZIAN') then
    x01 = fun%par(2)%value
    dx1 = 1.d0 / fun%par(3)%value
    y01 = fun%par(1)%value
    do i=1,dat%n
       xx = (dat%x(i)-x01)*dx1
       y = 1.d0 / (1 + xx*xx)
       dy(1) = y
       y = y*y * y01
       dy(2) = 2.d0 * xx * y * dx1
       dy(3) = dy(2) * xx
       do j=1,var%n
          fjac(i,j) = - dy(var%idx(j)) * dat%w(i)
       enddo
    enddo
  endif
end subroutine get_jacobian
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine get_profile(fun,profile)
  use telcal_interfaces, except_this=>get_profile
  use fit_definitions ! Transmission of hidden (eg fixed) parameters
  !----------------------------------------------------------------------
  ! @ private
  !
  !----------------------------------------------------------------------
  type(fit_fun), intent(in)      :: fun     ! Fitting function description
  type(simple_1d), intent(inout) :: profile ! Solution profile
  !
  ! Local variables
  real(4) :: x01,y01,dx1,xx
  real(4) :: x02,y02,dx2
  real(8) :: pi
  integer i,j
  !
  if (fun%name.eq.'GAUSSIAN') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     y01 = fun%par(1)%value / fun%par(3)%value * 2.d0*sqrt(log(2.d0)) / sqrt(pi)
     do i=1,profile%n
        xx = (profile%x(i)-x01)*dx1
        if (xx.lt.5) then
           profile%y(i) = y01 * exp(-xx*xx)
        else
           profile%y(i) = 0
        endif
     enddo
  else if (fun%name.eq.'GAUSSIAN+BASE') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     y01 = fun%par(1)%value / fun%par(3)%value * 2.d0*sqrt(log(2.d0)) / sqrt(pi)
     do i=1,profile%n
        xx = (profile%x(i)-x01)*dx1
        if (xx.lt.5) then
           profile%y(i) = y01 * exp(-xx*xx)
        else
           profile%y(i) = 0
        endif
        profile%y(i) = profile%y(i) + fun%par(4)%value + fun%par(5)%value*profile%x(i)
     enddo
  else if (fun%name.eq.'2*GAUSSIAN+BASE') then
     pi = acos(-1.d0)
     x01 = fun%par(2)%value
     dx1 = 2.d0*sqrt(log(2.d0)) / fun%par(3)%value
     y01 = fun%par(1)%value / fun%par(3)%value * 2.d0*sqrt(log(2.d0)) / sqrt(pi)
     x02 = fun%par(2)%value+fun%par(5)%value
     dx2 = 2.d0*sqrt(log(2.d0)) / (fun%par(3)%value*fun%par(6)%value)
     y02 = (fun%par(1)%value*fun%par(4)%value) / (fun%par(3)%value*fun%par(6)%value) * 2.d0*sqrt(log(2.d0)) / sqrt(pi)
     do i=1,profile%n
        xx = (profile%x(i)-x01)*dx1
        if (xx.lt.5) then
           profile%y(i) = y01 * exp(-xx*xx)
        else
           profile%y(i) = 0
        endif
        xx = (profile%x(i)-x02)*dx2
        if (xx.lt.5) then
           profile%y(i) = profile%y(i) + y02 * exp(-xx*xx)
        endif
        profile%y(i) = profile%y(i) + fun%par(7)%value + fun%par(8)%value*profile%x(i)
     enddo
  else if (fun%name.eq.'LORENTZIAN') then
     x01 = fun%par(2)%value
     dx1 = 1.d0 / fun%par(3)%value
     y01 = fun%par(1)%value
     do i=1,profile%n
        xx = (profile%x(i)-x01)*dx1
        profile%y(i) = y01 / (1d0 + xx*xx)
     enddo
  else if (fun%name.eq.'POLYNOMIAL') then
     do i=1,profile%n
        profile%y(i) = fun%par(fun%npar)%value
        do j=fun%npar-1,1,-1
           profile%y(i) = profile%y(i) * profile%x(i) + fun%par(j)%value
        enddo
     enddo
  endif
end subroutine get_profile
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine fit_polynomial(dat,fun)
  use telcal_interfaces, except_this=>fit_polynomial
  use fit_definitions
  use fit_association
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(simple_1d), intent(in)  :: dat ! Data vectors
  type(fit_fun), intent(inout) :: fun ! Fitting function description
  !
  ! Local variables
  integer                             :: i,ier,info,maxdeg,ndeg
  real(8)                             :: eps
  real(8), dimension(dat%n)           :: r,tc
  real(8), dimension(3*dat%n+3*dat%n) :: a
  !
  call xsetf(0)
  !
  ! Copy data from input parameters to association module.
  allocate(adat%x(dat%n),adat%y(dat%n),adat%w(dat%n),stat=ier)
  if (ier.eq.0) then
     call copy_simple_1d(dat,adat)
  else
     call gagout('E-FIT1D, Error in data array allocation')
     fun%flag = -3
     return
  endif
  !
  allocate (afun%par(fun%npar),stat=ier)
  if (ier.eq.0) then
     call copy_function(fun,afun)
  else
     call gagout('E-FIT1D, Error in function array allocation')
     fun%flag = -3
     return
  endif
  ! From now on, use only associated variables
  !
  maxdeg = adat%n-1
  eps = 0.d0
  call dpolft(adat%n,adat%x,adat%y,adat%w,maxdeg,ndeg,eps,r,info,a)
  !
  if (info.eq.2) then
     print *, 'F-DPOLFT, invalid input parameter, info = ', info
     fun%flag = -5
     deallocate(afun%par)
     deallocate(adat%x,adat%y,adat%w)
     return
  endif
  call dpcoef(maxdeg,0.d0,tc,a)
  !
  do i=1,afun%npar
     afun%par(i)%value = tc(i)
  enddo
  ! Print results
  print *,'------'
  print *,'RESULT'
  print *,' '
  do i=1,afun%npar
     print *, afun%par(i)%name, afun%par(i)%value
  enddo
  print *, "RMS = ",eps
  !
  ! Return results: ie get back to input parameters from association module
  call copy_function(afun,fun)
  deallocate(afun%par)
  deallocate(adat%x,adat%y,adat%w)
  !
end subroutine fit_polynomial
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine null_simple_1d(dat)
  use fit_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine of its derived types
  ! Purpose: Initialize a simple precision data vector
  !----------------------------------------------------------------------
  type(simple_1d), intent(inout) :: dat ! Data vector
  !
  ! Local variables
  dat%n = 0
  if (associated(dat%x)) deallocate(dat%x)
  if (associated(dat%y)) deallocate(dat%y)
  if (associated(dat%w)) deallocate(dat%w)
  if (associated(dat%d)) deallocate(dat%d)
  nullify(dat%x)
  nullify(dat%y)
  nullify(dat%w)
  nullify(dat%d)
end subroutine null_simple_1d
!
subroutine null_parameter(par)
  use fit_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine of its derived types
  ! Purpose: Initialize a fitted parameter
  !----------------------------------------------------------------------
  type(fit_par), intent(inout) :: par ! Fitted parameter
  !
  ! Local variables
  par%guess = 0
  par%value = 0
  par%error = 0
  par%mini = -1e30
  par%maxi =  1e30
  par%fixed = .false.
  par%name = 'UNDEFINED'
end subroutine null_parameter
!
subroutine null_function(fun)
  use fit_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine of its derived types
  ! Purpose: Initialize a fitted function description
  !----------------------------------------------------------------------
  type(fit_fun), intent(inout) :: fun ! Description of the fitted function
  !
  ! Local variables
  fun%name   = 'UNDEFINED'
  fun%method = 'UNDEFINED'
  fun%chi2   = 0.
  fun%rms    = 0.
  fun%flag   = 1 ! Waiting for data
  fun%ncall  = 0
  fun%npar   = 0
  if (associated(fun%par)) deallocate(fun%par)
  nullify(fun%par)
end subroutine null_function
!
! Fit derived type copy routines
!
subroutine copy_simple_1d(in,out)
  use fit_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine of its derived types
  ! Purpose: Copy a simple precision data vector
  !----------------------------------------------------------------------
  type(simple_1d), intent(in)    :: in  ! Original vector
  type(simple_1d), intent(inout) :: out ! Copied vector
  !
  ! Local variables
  out%n = in%n
  if (associated(in%x).and.associated(out%x)) out%x = in%x
  if (associated(in%y).and.associated(out%y)) out%y = in%y
  if (associated(in%w).and.associated(out%w)) out%w = in%w
  if (associated(in%d).and.associated(out%d)) out%d = in%d
  !
end subroutine copy_simple_1d
!
subroutine copy_function(in,out)
  use fit_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine of its derived types
  ! Purpose: Copy the description of a fitted function
  !----------------------------------------------------------------------
  type(fit_fun), intent(in)    :: in  ! Original function
  type(fit_fun), intent(inout) :: out ! Copied function
  !
  ! Local variables
  integer i
  !
  out%name   = in%name
  out%method = in%method
  out%chi2   = in%chi2
  out%rms    = in%rms
  out%flag   = in%flag
  out%ncall  = in%ncall
  out%npar   = in%npar
  do i=1,in%npar
     call null_parameter(out%par(i))
     out%par(i) = in%par(i)
  enddo
  !
end subroutine copy_function
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! SLICE is not a standard case: while it iterates the input cube with
! images along the spectral axis, it creates an output cube (which has only
! 1 plane) with 1 spatial axis and 1 spectral axis (no 2nd spatial axis).
! This has consequences:
!  - header: the output header has IX=spatial axis and IY=spectral axis.
!    This way the IO engines and subsequent commands like LOAD know how to
!    deal with this cube.
!  - data: the output "cube" (single plane) is fully filled after all the
!    input planes are iterated. This means fullset access: 1 allocation for
!    the whole output "cube" (plane), fill it during the input plane
!    iterations (parallelization is allowed), write it once at the end.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_slice
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubetools_unit_arg
  use cubetools_shape_types
  use cubetopology_spapos_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: slice
  private
  !
  real(kind=coor_k), parameter :: spatol = 0.1 ! Spatial tolerance: 10% of a single pixel size
  !
  type :: slice_comm_t
     type(option_t), pointer :: comm
     type(spapos_comm_t) :: begin
     type(spapos_comm_t) :: end
     type(option_t),     pointer :: variable
     type(unit_arg_t),   pointer :: unit
     type(cubeid_arg_t), pointer :: cube
     type(cube_prod_t),  pointer :: slice
   contains
     procedure, public  :: register      => cubemain_slice_register
     procedure, private :: parse         => cubemain_slice_parse
     procedure, private :: parse_var     => cubemain_slice_parse_variable
     procedure, private :: main          => cubemain_slice_main
  end type slice_comm_t
  type(slice_comm_t) :: slice
  !
  type slice_user_t
     type(cubeid_user_t)   :: cubeids
     type(spapos_user_t)   :: begin    ! [absolute|relative] position for the beginning of the slice
     type(spapos_user_t)   :: end      ! [absolute|relative] position for the end of the slice
     character(len=argu_l) :: unit     ! Unit of the values in the variable
     character(len=varn_l) :: varname  ! Variable containing positions
     logical               :: dovar    ! Should a variable be used?
   contains
     procedure, private :: toprog => cubemain_slice_user_toprog
  end type slice_user_t
  !
  type slice_prog_t
     type(cube_t), pointer :: cube                 ! Input cube
     type(cube_t), pointer :: slice                ! Output slice
     logical               :: dopoints             ! Is it a point slice?
     type(spapos_prog_t)   :: begin                ! [rad] Position of the beginning of the slice
     type(spapos_prog_t)   :: end                  ! [rad] Position of the end of the slice
     type(shape_t)         :: ncube                ! [---] Shape of input cube                  
     integer(kind=pixe_k)  :: np = 0               ! [---] Number of pixels in the slice
     real(kind=coor_k)     :: ang = 0d0            ! [rad] Angle of the slice  
     real(kind=coor_k)     :: dx = 0d0             ! [rad] Increment of the slice along the x axis 
     real(kind=coor_k)     :: dy = 0d0             ! [rad] Increment of the slice along the y axis
     real(kind=coor_k), allocatable :: pixels(:,:) ! [pix] Fractional pixels in the slice
   contains
     procedure, private :: precompute_pixels => cubemain_slice_prog_precompute_pixels
     procedure, private :: pixels_from_var   => cubemain_slice_prog_pixels_from_var
     procedure, private :: header            => cubemain_slice_prog_header
     procedure, private :: data              => cubemain_slice_prog_data
     procedure, private :: loop              => cubemain_slice_prog_loop
     procedure, private :: act               => cubemain_slice_prog_act
  end type slice_prog_t
  !
contains
  !
  subroutine cubemain_slice_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(slice_user_t) :: user
    character(len=*), parameter :: rname='SLICE>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call slice%parse(line,user,error)
    if (error) return
    call slice%main(user,error)
    if (error) continue
  end subroutine cubemain_slice_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_slice_register(comm,error)
    use cubetools_unit
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(slice_comm_t), intent(inout) :: comm
    logical,             intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    type(unit_arg_t) :: unitarg
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='SLICE>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'SLICE','[cubeid]',&
         'Extract a 2D position-velocity slice along a path',&
         'Extract a 2D position-velocity slice either along a straight&
         & cut between /BEGIN and /END, or along a user-defined list of&
         & positions from /VARIABLE (including curved or disconnected&
         & paths).'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /BEGIN and /END define one straight cut with regularly spaced&
         & samples between the two endpoints.'//strg_cr//&
         '- /VARIABLE uses a [2,n] position list and extracts one sample&
         & per listed position.'//strg_cr//&
         '- Spatial values are computed with bilinear interpolation at&
         & each sampled position.'//strg_cr//&
         '- /VARIABLE is exclusive with /BEGIN and /END.'//strg_cr//&
         '- /BEGIN and /END are mandatory when /VARIABLE is not provided.'//strg_cr//&
         '- /VARIABLE coordinates are relative to the projection center&
         & by default; for cubes without meaningful sky coordinates,&
         & provide an explicit unit argument.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> SLICE cubeA /BEGIN 0 0 relative /END 30 0 relative'//strg_cr//&
         'CUBE> SLICE cubeA /BEGIN 12:00:00 10:00:00 absolute /END 12:00:20 10:00:20 absolute'//strg_cr//&
         'CUBE> SLICE cubeA /VARIABLE pathxy arcsec',&
         cubemain_slice_command,&
         comm%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Signal cube',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    !
    call comm%begin%register('BEGIN',&
         'Beginning point of the slice',&
         error)
    if (error) return
    call comm%end%register('END',&
         'End point of the slice',&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'VARIABLE','var [unit]',&
         'Variable containing positions for slice',&
         'The variable containing the positions must be REAL and have&
         & the shape [2,n], where n is the number of points in the&
         & slice and the first dimension correspond to the x and y&
         & positions of each point. The points are assumed to be in&
         & relative coordinates from the projection center. The&
         & default unit for the coordinates is the current FOV unit,&
         & this can be changed with the optional argument unit',&
         comm%variable,error)
    if (error) return
    call stdarg%register(&
         'var',&
         'SIC variable containing positions',&
          strg_emp,&
          code_arg_mandatory, error)
    if (error) return
    call unitarg%register(&
         'unit',&
         'Position coordinate unit',&
         strg_emp,&
         code_arg_optional,&
         code_unit_fov,&
         comm%unit,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'SLICE',&
         'The 2D slice',&
         strg_emp,&
         [flag_slice],&
         comm%slice,&
         error,&
         access=code_access_fullset)
    if (error) return
  end subroutine cubemain_slice_register
  !
  subroutine cubemain_slice_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! SLICE [cubeid]
    ! /BEGIN xpos ypos type [unit]
    ! /END xpos ypos type [unit]
    ! /VARIABLE varname [unit]
    !----------------------------------------------------------------------
    class(slice_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(slice_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SLICE>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%begin%parse(line,user%begin,error)
    if (error) return
    call comm%end%parse(line,user%end,error)
    if (error) return
    call comm%parse_var(line,user,error)
    if (error) return
    !
    if (user%dovar) then
       if (user%begin%present.or.user%end%present) then
          call cubemain_message(seve%e,rname,'The /BEGIN and /END keys conflict with the /VARIABLE key')
          error = .true.
          return
       endif
    else      
       if (.not.user%begin%present) then
          call cubemain_message(seve%e,rname,'Option /BEGIN is mandatory')
          error = .true.
       endif
       if (.not.user%end%present) then
          call cubemain_message(seve%e,rname,'Option /END is mandatory')
          error = .true.
       endif
    endif
  end subroutine cubemain_slice_parse
  !
  subroutine cubemain_slice_parse_variable(comm,line,user,error)
    !----------------------------------------------------------------------
    ! /VARIABLE var [unit]
    !----------------------------------------------------------------------
    class(slice_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(slice_user_t),  intent(inout) :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SLICE>PARSE>VARIABLE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call comm%variable%present(line,user%dovar,error)
    if (error) return
    if (user%dovar) then
       call cubetools_getarg(line,comm%variable,1,user%varname,mandatory,error)
       if (error) return
       user%unit = strg_star
       call cubetools_getarg(line,comm%variable,2,user%unit,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_slice_parse_variable
  !
  subroutine cubemain_slice_main(slice,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(slice_comm_t), intent(in)    :: slice
    type(slice_user_t),  intent(inout) :: user
    logical,             intent(inout) :: error
    !
    type(slice_prog_t) :: prog
    character(len=*), parameter :: rname='SLICE>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(slice,prog,error)
    if (error) return
    call prog%header(slice,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_slice_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_slice_user_toprog(user,comm,prog,error)
    use cubetools_header_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(slice_user_t), intent(in)    :: user
    type(slice_comm_t),  intent(in)    :: comm
    type(slice_prog_t),  intent(out)   :: prog
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SLICE>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    !
    prog%dopoints = user%dovar
    call cubetools_header_get_array_shape(prog%cube%head,prog%ncube,error)
    if (error) return
    if (user%dovar) then
       call prog%pixels_from_var(user%varname,user%unit,error)
       if (error) return
    else
       call user%begin%toprog(prog%cube,prog%begin,error)
       if (error) return
       call user%end%toprog(prog%cube,prog%end,error)
       if (error) return
       call prog%precompute_pixels(error)
       if (error) return
    endif
  end subroutine cubemain_slice_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_slice_prog_precompute_pixels(prog,error)
    use phys_const
    use gkernel_interfaces
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(slice_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    logical :: constl,constm
    integer(kind=4) :: ier
    integer(kind=pixe_k) :: ipix,nl,nm
    real(kind=coor_k) :: dpl,dpm ! Increment in the l and m directions in pixels
    integer(kind=ndim_k), parameter :: ix = 1
    integer(kind=ndim_k), parameter :: iy = 2
    character(len=*), parameter :: rname='SLICE>PROG>PRECOMPUTE_PIXELS'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Define number of points
    constl = abs(prog%begin%p(ix)-prog%end%p(ix)).le.spatol*prog%cube%head%spa%l%inc
    constm = abs(prog%begin%p(iy)-prog%end%p(iy)).le.spatol*prog%cube%head%spa%m%inc
    if (constl.and.constm) then
       ! VVV This could be a single spectrum extraction?
       ! *** JP: Yes. Why is it an error?
       call cubemain_message(seve%e,rname,'Slice would contain a single pixel')
       error =.true.
       return
    elseif (constl) then
       dpl = 0.
       dpm = 1.
       prog%np = ceiling(abs(prog%end%p(iy)-prog%begin%p(iy)))+1
       prog%ang = 90*rad_per_deg
       prog%dx  = prog%cube%head%spa%m%inc
       prog%dy  = prog%cube%head%spa%l%inc
    elseif (constm) then
       dpl = 1.
       dpm = 0.
       prog%np = ceiling(abs(prog%end%p(ix)-prog%begin%p(ix)))+1
       prog%ang = 0.0
       prog%dx  = prog%cube%head%spa%l%inc
       prog%dy  = prog%cube%head%spa%m%inc
    else
       nl = ceiling(abs(prog%end%p(ix)-prog%begin%p(ix)))+1
       nm = ceiling(abs(prog%end%p(iy)-prog%begin%p(iy)))+1
       prog%np = sqrt(1d0*(nl*nl+nm*nm))
       dpl = nl/dble(prog%np)
       dpm = nm/dble(prog%np)
       prog%ang = atan2(dpl*prog%cube%head%spa%l%inc,dpm*prog%cube%head%spa%m%inc)
       prog%dx  = sqrt((prog%cube%head%spa%l%inc*dpl)**2+(prog%cube%head%spa%m%inc*dpm)**2)
       prog%dy  = prog%dx
    endif
    if (prog%end%p(ix).lt.prog%begin%p(ix)) dpl = -dpl
    if (prog%end%p(iy).lt.prog%begin%p(iy)) dpm = -dpm
    !
    allocate(prog%pixels(2,prog%np),stat=ier)
    if (failed_allocate(rname,'Pixel array',ier,error)) then
       error = .true.
       return
    endif
    do ipix=1,prog%np
       prog%pixels(1,ipix) = prog%begin%p(ix)+(ipix-1)*dpl
       prog%pixels(2,ipix) = prog%begin%p(iy)+(ipix-1)*dpm
    enddo
  end subroutine cubemain_slice_prog_precompute_pixels
  !
  subroutine cubemain_slice_prog_pixels_from_var(prog,varname,unitname,error)
    use gkernel_interfaces
    use cubetools_uservar
    use cubetools_userspace
    use cubetools_header_methods
    use cubetools_unit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(slice_prog_t), intent(inout) :: prog
    character(len=*),    intent(in)    :: varname
    character(len=*),    intent(in)    :: unitname
    logical,             intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=pixe_k) :: ip
    integer(kind=ndim_k) :: ndim
    integer(kind=entr_k), allocatable :: dims(:)
    ! VVV For the moments this one is real*4 as to not oblige the user
    ! to create a real*8 on SIC
    real(kind=4), allocatable :: offsets(:,:)
    type(uservar_t) :: var
    character(len=mess_l) :: mess
    type(unit_user_t) :: unit
    integer(kind=4), parameter :: ix=1,iy=2
    character(len=*), parameter :: rname='SLICE>PROG>PIXELS>FROM>VAR'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(varname,var,error)
    if (error) return
    call var%get_dims(ndim,dims,error)
    if (error) return
    if (ndim.ne.2) then
       write(mess,'(a,i0,a)') 'Expected a 2D array got a ',ndim,'D array'
       call cubemain_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    if (dims(1).ne.2) then
       write(mess,'(2(a,i0))') 'Expected a 2 x n array, got ',dims(1),'x',dims(2)
       call cubemain_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    prog%np = dims(2)
    allocate(prog%pixels(2,prog%np),offsets(2,prog%np),stat=ier)
    if (failed_allocate(rname,'Pixel array',ier,error)) return 
    call var%get(offsets,error)
    if (error) return
    call unit%get_from_name_for_code(unitname,code_unit_fov,error)
    if (error) return
    !
    do ip=1,prog%np
       call cubetools_header_spatial_offset2pixel(prog%cube%head,offsets(:,ip)*unit%prog_per_user,&
            prog%pixels(:,ip),error)
       if (pixel_outofbounds(prog%pixels(:,ip),prog%ncube)) then
          call cubemain_message(seve%e,rname,'The following coordinates go out of bounds:')
          write (mess,'(2(a,1pg14.7),2a)') '(',offsets(ix,ip),',',offsets(iy,ip),') ',unit%name
          call cubemain_message(seve%r,rname,mess)
          error = .true.
       endif
    enddo
  end subroutine cubemain_slice_prog_pixels_from_var
  !
  function pixel_outofbounds(pixel,n) result(out)
    !----------------------------------------------------------------------
    ! Tests if a pixel is out of bounds
    !----------------------------------------------------------------------
    real(kind=coor_k), intent(in)   :: pixel(2)
    type(shape_t),     intent(in)   :: n
    logical                         :: out
    !
    integer(kind=4), parameter :: ix=1,iy=2
    !
    out = .false.
    out = pixel(ix).lt.0. ! *** JP: Bizarre. I would have put 1.0
    out = out.or.pixel(ix).gt.n%l
    out = out.or.pixel(iy).lt.0 ! *** JP: Bizarre. I would have put 1.0
    out = out.or.pixel(iy).gt.n%m
  end function pixel_outofbounds
  !
  subroutine cubemain_slice_prog_header(prog,comm,error)
    use gkernel_types, only: projection_t
    use gkernel_interfaces
    use cubetools_axis_types
    use cubetools_spapro_types
    use cubetools_header_methods
    use cubetools_unit
    use cubeadm_clone
    !----------------------------------------------------------------------
    ! Output cube is ordered as nx,nc
    !----------------------------------------------------------------------
    class(slice_prog_t), intent(inout) :: prog
    type(slice_comm_t),  intent(in)    :: comm
    logical,             intent(inout) :: error
    !
    type(axis_t) :: axis
    type(unit_user_t) :: pixeunit
    character(len=*), parameter :: rname='SLICE>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%slice,prog%cube,prog%slice,error)
    if (error) return
    call cubetools_header_get_axis_head_c(prog%slice%head,axis,error)
    if (error) return
    call cubetools_header_update_axset_m(axis,prog%slice%head,error)
    if (error) return
    call cubetools_header_nullify_axset_c(prog%slice%head,error)
    if (error) return
    !
    if (prog%dopoints) then
       call cubetools_header_get_axis_head_l(prog%slice%head,axis,error)
       if (error) return
       axis%name = 'SLICE'    
       axis%n = prog%np
       axis%ref = 1d0
       axis%val = 0d0
       axis%inc = 1d0
       axis%kind = code_unit_pixe
       call pixeunit%get_from_code(code_unit_pixe,error)
       if (error) return
       axis%unit = pixeunit%name
       call cubetools_header_update_axset_l(axis,prog%slice%head,error)
       if (error) return
    else
       call cubetools_header_get_axis_head_l(prog%slice%head,axis,error)
       if (error) return
       axis%name = 'SLICE'    
       axis%n = prog%np
       axis%ref = 1d0
       axis%val = 0d0
       axis%inc = abs(prog%dx)
       call cubetools_header_update_axset_l(axis,prog%slice%head,error)
       if (error) return
       !
       ! Projection has no more obvious meaning => Nullify it
       call cubetools_header_nullify_spapro(prog%slice%head,error)
       !***JP: What about the spatial frame?
    endif
  end subroutine cubemain_slice_prog_header
  !
  subroutine cubemain_slice_prog_data(prog,error)
    use cubeadm_opened
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! Non-standard case!
    !----------------------------------------------------------------------
    class(slice_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    type(fullcube_t) :: slice
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='SLICE>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    call slice%allocate('slice',prog%slice,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,slice,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,slice,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,slice,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
    !
    call slice%put(error)
    if (error) return
  end subroutine cubemain_slice_prog_data
  !
  subroutine cubemain_slice_prog_loop(prog,iter,slice,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! Non-standard case!
    !----------------------------------------------------------------------
    class(slice_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    type(fullcube_t),         intent(inout) :: slice
    logical,                  intent(inout) :: error
    !
    type(image_t) :: image
    character(len=*), parameter :: rname='SLICE>PROG>LOOP'
    !
    call image%associate('image',prog%cube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%act(iter%ie,image,slice,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_slice_prog_loop
  !
  subroutine cubemain_slice_prog_act(prog,ie,image,slice,error)
    use cubetools_nan
    use cubeadm_image_types
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! Non-standard case!
    !----------------------------------------------------------------------
    class(slice_prog_t),  intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(image_t),        intent(inout) :: image
    type(fullcube_t),     intent(inout) :: slice
    logical,              intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,inpix(2)
    real(coor_k) :: delta(2)
    character(len=*), parameter :: rname='SLICE>PROG>ACT'
    !
    call image%get(ie,error)
    if (error) return
    do ix=1,slice%nx
       inpix(:) = int(prog%pixels(:,ix))
       delta(:) = prog%pixels(:,ix)-dble(inpix(:))
       if ((inpix(1).lt.1).or.(inpix(2).lt.1).or.(inpix(1).ge.image%nx).or.(inpix(2).ge.image%ny)) then
          slice%val(ix,ie,1) = gr4nan
       else
          slice%val(ix,ie,1) = delta(1)*delta(2)*image%val(inpix(1)+1,inpix(2)+1)   &
               +(1.0-delta(1))*delta(2)* image%val(inpix(1),inpix(2)+1)   &
               +(1.0-delta(1))*(1.0-delta(2))*image%val(inpix(1),inpix(2))&
               +delta(1)*(1.0-delta(2))*image%val(inpix(1)+1,inpix(2))
       endif
    enddo ! ix
  end subroutine cubemain_slice_prog_act
end module cubemain_slice
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
module gio_uv
  use gio_params
  use gio_headers
  !
  type uv_head_type_t
     integer(kind=4) :: sort_order = code_null ! Sort order if any...
     integer(kind=8) :: ndata = 0     ! Number of read visibilities
     integer(kind=4) :: nchan = 0     ! Number of read channels
     integer(kind=4) :: range(2) = 0  ! First and last read channels
     real(kind=4) :: xmin  = +1e38 ! [rad]
     real(kind=4) :: xmax  = -1e38 ! [rad]
     real(kind=4) :: ymin  = +1e38 ! [rad]
     real(kind=4) :: ymax  = -1e38 ! [rad]
     real(kind=4) :: umin  = +1e38 ! [  m]
     real(kind=4) :: umax  = -1e38 ! [  m]
     real(kind=4) :: vmin  = +1e38 ! [  m]
     real(kind=4) :: vmax  = -1e38 ! [  m]
     real(kind=4) :: uvmax =   0.0 ! [  m]
     real(kind=4) :: uvmin = +1e38 ! [  m]
  end type uv_head_type_t
  !
  type uv_head_t
     type(gildas_v2)       :: gil  ! File header
     type(uv_head_type_t)  :: uvt  ! Type header
     real(kind=4), pointer :: u(:)    => null() ! [  m] U                    
     real(kind=4), pointer :: v(:)    => null() ! [  m] V                    
     real(kind=4), pointer :: w(:)    => null() ! [  m] W                    
     real(kind=4), pointer :: x(:)    => null() ! [rad] X pointing offset
     real(kind=4), pointer :: y(:)    => null() ! [rad] Y pointing offset
     real(kind=4), pointer :: l(:)    => null() ! [rad] L phase offset
     real(kind=4), pointer :: m(:)    => null() ! [rad] M phase offset
     real(kind=4), pointer :: scan(:) => null() ! [---] Scan                 
     real(kind=4), pointer :: date(:) => null() ! [gag] Observing date       
     real(kind=4), pointer :: time(:) => null() ! [sec] Time                 
     real(kind=4), pointer :: anti(:) => null() ! [---] First antenna number 
     real(kind=4), pointer :: antj(:) => null() ! [---] Second antenna number
     ! etc...
  end type uv_head_t
  !
  type uv_buffer_t
     real(kind=4), pointer :: uvp1(:,:)   => null() ! Columns 1 to nlead   => dimensions: nvisi x nlead
     real(kind=4), pointer :: uvp2(:,:,:) => null() ! Columns nlead+1 to ... 
     !             => dimensions: nvisi x 3 x (nchan x nstokes) for tuv order                                           
     !             => dimensions: 3 x (nchan x nstokes) x nvisi for uvt order
     real(kind=4), pointer :: uvp3(:,:)   => null() ! Columns n-ntrail+1 to n    => dimensions: nvisi x ntrail 
  end type uv_buffer_t
  !
  type uv_t
     type(uv_buffer_t) :: buff
     type(uv_head_t)   :: head
     real(kind=4), pointer :: data(:,:,:)     => null() ! ndata x (Real [Jy], Imaginary [Jy], Weight [???]) x nchan
     real(kind=4), pointer :: stokes(:,:,:,:) => null() ! ndata x (Real [Jy], Imaginary [Jy], Weight [???]) x nchan x nstokes
  end type uv_t

end module gio_uv
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_convert
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: convert
  private
  !
  type :: convert_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: incube
     type(option_t),     pointer :: unit
     type(option_t),     pointer :: efficiencies
     type(option_t),     pointer :: factor
     type(cube_prod_t),  pointer :: converted
   contains
     procedure, public  :: register           => cubemain_convert_register
     procedure, private :: parse              => cubemain_convert_parse
     procedure, private :: parse_unit         => cubemain_convert_parse_unit
     procedure, private :: parse_factor       => cubemain_convert_parse_factor
     procedure, private :: parse_efficiencies => cubemain_convert_parse_efficiencies
     procedure, private :: main               => cubemain_convert_main
  end type convert_comm_t  
  type(convert_comm_t) :: convert
  !
  type convert_user_t
     type(cubeid_user_t)   :: cubeids
     logical               :: dounit
     character(len=argu_l) :: unit
     logical               :: dofactor
     real(kind=sign_k)     :: factor     ! User defined convertion factor
     logical               :: doapplyeff
     real(kind=sign_k)     :: beff       ! Beam Efficiency
     real(kind=sign_k)     :: feff       ! Forward Efficiency
   contains
     procedure, private :: toprog => cubemain_convert_user_toprog
  end type convert_user_t
  !
  type convert_prog_t
     type(cube_t), pointer :: incube     ! Input cube
     type(cube_t), pointer :: converted  ! Output cube
     character(len=unit_l) :: unit_name  ! Name of output unit
     integer(kind=code_k)  :: unit_code  ! Code of output unit
     real(kind=sign_k)     :: factor     ! Convertion factor
   contains
     procedure, private :: header => cubemain_convert_prog_header
     procedure, private :: data   => cubemain_convert_prog_data
     procedure, private :: loop   => cubemain_convert_prog_loop
     procedure, private :: act    => cubemain_convert_prog_act
  end type convert_prog_t
  !
contains
  !
  subroutine cubemain_convert_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(convert_user_t) :: user
    character(len=*), parameter :: rname='CONVERT>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call convert%parse(line,user,error)
    if (error) return
    call convert%main(user,error)
    if (error) continue
  end subroutine cubemain_convert_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_convert_register(convert,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(inout) :: convert
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='CONVERT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'CONVERT','[cubeid]',&
         'Convert the unit of the cube data',&
         'CONVERT applies a multiplicative factor to cube data array in order to&
         &change the data unit.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- The input unit comes from the input cube header array unit&
         & field.'//strg_cr//&
         '- At least one of /UNIT or /EFFICIENCIES is required.'//strg_cr//&
         '- /UNIT selects the target output unit.'//strg_cr//&
         '- /FACTOR with /UNIT forces an explicit multiplicative conversion&
         &factor. Without /FACTOR, CONVERT infers a factor only for supported&
         &unit conversions.'//strg_cr//&
         '- /EFFICIENCIES Beff Feff applies beam and forward efficiencies for&
         &brightness-unit conversions involving "K (Ta*)".'//strg_bl//&
         'Note:'//strg_cr//&
         '- Use the EDIT language for low-level manual header fixes when&
         & incoherences must be corrected directly.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> CONVERT 12co10:cube /UNIT "K (Tmb)"'//strg_cr//&
         'CUBE> CONVERT 12co10:cube /UNIT Jy/beam /FACTOR 0.12'//strg_cr//&
         'CUBE> CONVERT 12co10:cube /UNIT "K (Ta*)" /EFFICIENCIES 0.7 0.9',&
         cubemain_convert_command,&
         convert%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Input cube identifier',&
         'If omitted, use the last matching cube (cube flag) in the default&
         & index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_subset,&
         convert%incube,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'UNIT',&
         'name',&
         'Select the desired output unit',&
         strg_emp,&
         convert%unit,&
         error)
    if (error) return
    call stdarg%register(&
         'NAME',&
         'A unit name either known or unknown by the program',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'FACTOR','value',&
         'Explicitly define a unit conversion factor',&
         'This key gives the user the ability to do unsupported conversions. The&
         &given value is used as a multiplicative factor over the whole cube and the&
         &new unit is taken to be the unit given with /UNIT key. WARNING: No checks&
         &about the validity of the conversion are performed.',&
         convert%factor,&
         error)
    if (error) return
    call stdarg%register(&
         'VALUE',&
         'Unit conversion factor',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'EFFICIENCIES','Beff Feff',&
         'Convert to and From "K (Ta*)"',&
         'Specify the Beam and Forward efficiencies to use when&
         & converting to and from "K (Ta*)".',&
         convert%efficiencies,&
         error)
    if (error) return
    call stdarg%register(&
         'Beff',&
         'Telescope beam efficiency',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'Feff',&
         'Telescope forward efficiency',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'CONVERTED',&
         'Converted cube',&
         strg_emp,&
         [flag_convert,flag_cube],&
         convert%converted,&
         error)
    if (error) return
  end subroutine cubemain_convert_register
  !
  !
  subroutine cubemain_convert_parse(convert,line,user,error)
    !----------------------------------------------------------------------
    ! CONVERT [cubeid]
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: convert
    character(len=*),      intent(in)    :: line
    type(convert_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,convert%comm,user%cubeids,error)
    if (error) return
    call convert%parse_unit(line,user,error)
    if (error) return
    call convert%parse_factor(line,user,error)
    if (error) return
    call convert%parse_efficiencies(line,user,error)
    if (error) return
    if (.not.(user%dounit.or.user%doapplyeff)) then
       call cubemain_message(seve%e,rname,"At least one option must be given")
       error = .true.
       return
    endif
  end subroutine cubemain_convert_parse
  !
  subroutine cubemain_convert_parse_unit(convert,line,user,error)
    !----------------------------------------------------------------------
    ! /UNIT name
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: convert
    character(len=*),      intent(in)    :: line
    type(convert_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PARSE>UNIT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call convert%unit%present(line,user%dounit,error)
    if (error) return
    if (user%dounit) then
       call cubetools_getarg(line,convert%unit,1,user%unit,mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_convert_parse_unit
  !
  subroutine cubemain_convert_parse_factor(convert,line,user,error)
    !----------------------------------------------------------------------
    ! /FACTOR value
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: convert
    character(len=*),      intent(in)    :: line
    type(convert_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PARSE>FACTOR'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call convert%factor%present(line,user%dofactor,error)
    if (error) return
    if (user%dofactor) then
       call cubetools_getarg(line,convert%factor,1,user%factor,mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_convert_parse_factor
  !
  subroutine cubemain_convert_parse_efficiencies(convert,line,user,error)
    !----------------------------------------------------------------------
    ! /EFFICIENCIES beff feff
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: convert
    character(len=*),      intent(in)    :: line
    type(convert_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PARSE>EFFICIENCIES'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call convert%efficiencies%present(line,user%doapplyeff,error)
    if (error) return
    if (user%doapplyeff) then
       call cubetools_getarg(line,convert%efficiencies,1,user%beff,mandatory,error)
       if (error) return
       call cubetools_getarg(line,convert%efficiencies,2,user%feff,mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_convert_parse_efficiencies
  !
  subroutine cubemain_convert_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: comm
    type(convert_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(convert_prog_t) :: prog
    character(len=*), parameter :: rname='CONVERT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_convert_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_convert_user_toprog(user,comm,prog,error)
    use cubetools_header_methods
    use cubetools_brightness
    use cubetools_disambiguate
    use cubetools_unit_setup
    use cubetools_unit
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_user_t), intent(in)    :: user
    type(convert_comm_t),  intent(in)    :: comm 
    type(convert_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    logical :: converror
    integer(kind=code_k) :: codein,codeou
    character(len=unit_l) :: unitin,unitou
    character(len=mess_l) :: mess
    type(unit_user_t) :: inunit,ouunit
    character(len=*), parameter :: rname='CONVERT>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    !
    call cubetools_header_get_array_unit(prog%incube%head,unitin,error)
    if (error) return
    call cubetools_unit_get_code(unitin,codein,error)
    if (error) return
    call cubetools_unit_get_code(user%unit,codeou,error)
    if (error) return
    !
    if (user%dofactor) then
       ! User has given a factor, simple case
       prog%factor = user%factor
       unitou = user%unit
       if (codeou.eq.code_unit_unk) &
            call cubemain_message(seve%w,rname,'Unsupported unit '//trim(user%unit))
    else
       ! Automatic convertion factor 
       converror = .false.
       !
       select case(codein)
       case(code_unit_unk)
          converror = .true.
       case(code_unit_brig)
          if (codeou.eq.code_unit_brig) then
             prog%unit_code = brightness_get(user%unit)  ! NB: user%unit was already tested for invalid names
             unitou = brightness_get(prog%unit_code)
             call cubetools_header_brightness2brightness(prog%incube%head,&
                  user%doapplyeff,user%feff,user%beff,&
                  prog%unit_code,prog%factor,error)
             if (error) return
          else
             converror = .true.
          endif
       case(code_unit_flux)
          if (codeou.eq.code_unit_flux) then
             prog%unit_code = flux_get(user%unit)
             unitou = flux_get(prog%unit_code)
             call cubetools_header_flux2flux(prog%incube%head,prog%unit_code,prog%factor,error)
             if (error) return
          else
             converror = .true.
          endif
       case default
          select case(codein)
          case(code_unit_freq,code_unit_velo,code_unit_wave&
               &,code_unit_pixe,code_unit_chan,code_unit_dist)
             ! Non equivalent units, convertion only possible if kind is
             ! the same
             converror = codein.ne.codeou
          case (code_unit_fov,code_unit_beam)
             ! All unit kinds here are angle units and can hence be
             ! treated together
             converror = .not.(codeou.eq.code_unit_fov.or.codeou.eq.code_unit_beam)
          case default
             call cubemain_message(seve%e,rname,'Programming error')
             error = .true.
             return
          end select
          if (.not.converror) then
             call inunit%get_from_name_for_code(unitin,codein,error)
             if (error) return
             call ouunit%get_from_name_for_code(user%unit,codeou,error)
             if (error) return
             prog%factor = inunit%prog_per_user*ouunit%user_per_prog
             unitou = ouunit%name
          else
             ! Do nothing
          endif
       end select
       !
       if (converror) then
          write(mess,'(8a)') 'Cannot convert from ',trim(unitin),' of kind ',trim(unitkinds(codein)),&
               ' to ',trim(user%unit),' of kind ',trim(unitkinds(codeou))
          call cubemain_message(seve%e,rname,mess)
          error = .true.
          return
       endif
    endif
    !
    ! User feedback
    write(mess,'(5a,1pg14.7)') 'Converting from ',trim(unitin),' to ',trim(unitou),&
         ', factor: ',prog%factor
    call cubemain_message(seve%i,rname,mess)
    prog%unit_name = unitou
  end subroutine cubemain_convert_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_convert_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_prog_t), intent(inout) :: prog
    type(convert_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%converted,prog%incube,prog%converted,error)
    if (error) return
    call cubetools_header_put_array_unit(prog%unit_name,prog%converted%head,error)
    if (error) return
  end subroutine cubemain_convert_prog_header
  !
  subroutine cubemain_convert_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(convert_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: itertask
    character(len=*), parameter :: rname='CONVERT>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(itertask,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(itertask)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(itertask,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(itertask)
       if (.not.error) &
         call prog%loop(itertask,error)
       !$OMP END TASK
    enddo ! itertask
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_convert_prog_data
  !   
  subroutine cubemain_convert_prog_loop(prog,itertask,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! The subcube iterator will be shared by all input and output subcubes
    !----------------------------------------------------------------------
    class(convert_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PROG>LOOP'
    !
    do while (itertask%iterate_entry(error))
       call prog%act(itertask,error)
       if (error) return
    enddo  ! ientry
  end subroutine cubemain_convert_prog_loop
  !   
  subroutine cubemain_convert_prog_act(prog,itertask,error)
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: itertask
    logical,                  intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    type(subcube_t) :: incube,converted
    character(len=*), parameter :: rname='CONVERT>PROG>ACT'
    !
    ! Converts are initialized here as their size (3rd dim) may change from
    ! from one convert to another.
    call incube%associate('incube',prog%incube,itertask,error)
    if (error) return
    call converted%allocate('converted',prog%converted,itertask,error)
    if (error) return
    !
    call incube%get(error)
    if (error) return
    do iz=1,incube%nz
       do iy=1,incube%ny
          do ix=1,incube%nx
             converted%val(ix,iy,iz) = incube%val(ix,iy,iz)*prog%factor
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call converted%put(error)
    if (error) return
  end subroutine cubemain_convert_prog_act
end module cubemain_convert
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_cycle_tool
  use gbl_message
  !
  public :: sub_major,major_cycle,minor_cycle
  private
  !
contains
  !
  subroutine sub_major(inout_method,hdirty,hresid,hclean,hbeam,hprim,hmask,&
       dcct,mask,list,error,major_plot,next_flux)
    use image_def
    use gkernel_interfaces
    use clean_support_tool
    use clean_beam_tool, only: beam_for_channel,get_beam
    use clean_flux_tool, only: init_plot
    use clean_types
    use cct_types
    use omp_buffers
    use clean_buffers, only: clean_buffer
    !$ use omp_lib
    !----------------------------------------------------------------------
    ! Perfom a CLEAN based on all CLEAN algorithms, except the MRC (Multi
    ! Resolution CLEAN) which requires a different tool Works for mosaic
    ! also, except for the Multi Scale clean (not yet implemented for this
    ! one, but feasible...)
    !----------------------------------------------------------------------
    type(clean_par), intent(inout) :: inout_method
    type(gildas),    intent(in)    :: hdirty
    type(gildas),    intent(inout) :: hbeam
    type(gildas),    intent(inout) :: hclean
    type(gildas),    intent(inout) :: hresid
    type(gildas),    intent(in)    :: hprim
    type(gildas),    intent(in)    :: hmask
    real,            intent(inout) :: dcct(:,:,:) ! (3,hclean%gil%dim(3),*)
    logical, target, intent(in)    :: mask(:,:)
    integer, target, intent(in)    :: list(:)
    logical,         intent(inout) ::  error
    external                       :: major_plot
    external                       :: next_flux
    !
    real, pointer :: dirty(:,:)    ! Dirty map
    real, pointer :: resid(:,:)    ! Iterated residual
    real, pointer :: clean(:,:)    ! Clean Map
    real, pointer :: d3prim(:,:,:) ! Primary beam
    real, pointer :: d3beam(:,:,:) ! Dirty beam (per field)
    real, pointer :: weight(:,:)   ! Mosaic weight
    !
    integer :: f_iter, m_iter
    logical, allocatable :: s_mask(:,:)
    integer, allocatable :: mymask(:,:)
    real, allocatable :: s_beam(:,:,:),t_beam(:,:),s_resi(:,:)
    real, allocatable :: tfbeam(:,:,:)
    real, allocatable :: w_cct(:,:)
    real, allocatable :: w_fft(:)       ! TF work area
    complex, allocatable :: w_work(:,:) ! Work area
    type(cct_par), allocatable :: w_comp(:)
    ! Mask & List per thread
    integer :: nmask,j
    logical, allocatable, target :: masks(:,:,:)
    integer, allocatable, target :: lists(:,:)
    logical, pointer :: lmask(:,:)
    integer, pointer :: llist(:)
    !
    type(clean_par), save :: method
    type(cct_par), allocatable :: tcc(:)
    !
    logical :: parallel,omp_nested
    logical :: dotruc,do_fft
    integer :: iplane
    integer :: nx,ny,np,nl,mx,my,nc
    integer :: ip,ier,ix,iy,i,jcode
    integer :: ibeam, ithread, mthread, nplane
    real :: fhat,limit,flux
    real, save :: major,minor,angle
    real, target :: dummy_prim(1,1,1), dummy_weight(1,1)
    character(len=16) :: cmethod
    character(len=48) :: cthread
    character(len=24) :: cname
    character(len=message_length) :: chain,mess
    character(len=*), parameter :: rname='SUB_MAJOR'
    !
    parallel = .false.
    !$ parallel = .true.
    error = .false.
    if (parallel) then
       mess = 'Using Open-MP parallel code'
    else
       mess = 'Using Open-MP capable code in Non-Parallel mode'
    endif
    call map_message(seve%i,rname,mess)
    !
    method = inout_method
    !
    cmethod = method%method
    do_fft = cmethod.ne.'HOGBOM'
    !
    ! Local variables
    nx = hclean%gil%dim(1)
    ny = hclean%gil%dim(2)
    mx = hbeam%gil%dim(1)
    my = hbeam%gil%dim(2)
    nl = method%nlist
    nc = nx*ny
    np = max(1,hprim%gil%dim(1))
    !
    ! TFBEAM cannot be on the Call sequence here because 
    ! it must be PRIVATE in parallel sections
    if (do_fft) then
       allocate(w_work(nx,ny),w_fft(2*max(nx,ny)),tfbeam(nx,ny,np),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error for TFBEAM')
          error = .true.
          return
       endif
    else
       allocate(w_work(1,1),w_fft(1),tfbeam(1,1,1),stat=ier)  
    endif
    if (ier.ne.0) then
       call map_message(seve%e,rname,'FFT Memory allocation failure')
       error = .true.
       return
    endif
    !
    ier = 0
    select case (cmethod)
    case ('CLARK')
       allocate(w_comp(nc),w_cct(1,1),mymask(1,1), &
            s_mask(1,1),s_resi(1,1),t_beam(1,1), &
            s_beam(1,1,3),stat=ier)
    case ('SDI')
       allocate(w_comp(nc),w_cct(nx,ny),mymask(nx,ny), &
            s_mask(1,1),s_resi(1,1),t_beam(1,1), &
            s_beam(1,1,3),stat=ier)
    case ('MULTI')
       allocate(w_comp(1),w_cct(nx,ny),mymask(nx,ny), &
            s_mask(nx,ny),s_resi(nx,ny),t_beam(nx,ny), &
            s_beam(nx,ny,3),stat=ier)
    case default
       allocate(w_comp(1),w_cct(1,1),mymask(1,1), &
            s_mask(1,1),s_resi(1,1),t_beam(1,1), &
            s_beam(1,1,3),stat=ier)
    end select
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Work Arrays Memory allocation failure')
       error = .true.
       return
    endif
    !
    ! Clean component work array
    allocate(tcc(method%m_iter),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error for TCC')
       error = .true.
       return
    endif
    !
    mthread = 1
    ithread = 1
    !$  mthread = omp_get_max_threads()
    nplane = method%last-method%first+1
    !$  omp_nested = omp_get_nested()
    if (nplane.eq.1) then
       !$  call omp_set_nested(.true.)
    else
       !$  call omp_set_nested(.false.)
    endif
    !
    ! Global aliases: SHARED here
    if (support_type.eq.support_mask) then
       ! Allocate the Masks and List per-thread
       nmask = min(hmask%gil%dim(3),nplane,mthread)
       if (nmask.gt.1) then
          allocate(masks(nx,ny,nmask),lists(nx*ny,nmask),stat=ier)
          if (ier.ne.0) then
             call map_message(seve%e,rname,'Mask & List memory allocation error')
             return
          endif
       endif
    else
       ! Keep the global association
       nmask = 0
    endif
    !
    cname = method%method
    ! 
    ! I had parallel block crashing if there were more threads
    ! than DO loop index (it should not but I could not find why).
    ! Seems to have disappeared with newer version of gfortran and/or
    ! extended stack
    !
    ! However, the common code is executed MTHREAD times
    ! Only loops are executed NPLANE times in this case,
    ! so limiting the MTHREAD would be good - but then
    ! number of threads must be reset at end.
    ! 
    !$ !  if (nplane.lt.mthread) call omp_set_num_threads(nplane)
    !$ !  print *,'Number of threads ',omp_get_num_threads()
    !
    !
    ! I need some CLEAN beam parameters
    if (omp%debug) print *,'Getting SOME beam parameters '
    iplane = method%first
    ibeam = beam_for_channel(iplane,hdirty,hbeam)
    d3beam  => hbeam%r4d(:,:,:,ibeam)
    call inout_method%fit_beam(hbeam,d3beam,error) !! TEST
    if (omp%debug) print *,'Got SOME beam parameters '
    !
    ! Loop here if needed
    !$OMP PARALLEL IF (nplane.gt.1) DEFAULT(none) & !! IF (nplane.ge.mthread) &
    !$OMP & SHARED(hdirty,hclean,hbeam,hprim,hresid,hmask) & ! Headers
    !$OMP & SHARED(dummy_prim,dummy_weight,dcct) & ! Big arrays
    !$OMP & SHARED(fhat, nx,ny,mx,my,np,nc, omp) &
    !$OMP & SHARED(inout_method)  & ! A modified structure
    !$OMP & SHARED(major,minor,angle,cmethod) &
    !$OMP & SHARED(nmask,masks,lists,mask,list) &
    !$OMP & SHARED(clean_buffer) &
    !$OMP & PRIVATE(method, dotruc)  &  ! A modified structure
    !$OMP & PRIVATE(iplane, ibeam, error, nl, chain, cthread, cname) &
    !$OMP & PRIVATE(tfbeam,w_work,w_fft,w_comp,w_cct,tcc) &   ! Arrays
    !$OMP & PRIVATE(flux,f_iter,m_iter,limit,ithread,jcode) &
    !$OMP & PRIVATE(ix,iy,i,j) &  ! These were NOT diagnosed by the DEFAULT(none)
    !$OMP & PRIVATE(d3beam,d3prim) &
    !$OMP & PRIVATE(mymask,s_mask,s_beam,s_resi,t_beam)  & ! Arrays
    !$OMP & PRIVATE(dirty,resid,clean) PRIVATE(weight,llist,lmask)  ! Pointers
    !
    ! Re-Define the method (in parallel mode, private entities are uninitialized)
    method = inout_method
    if (nmask.gt.1) then
       method%imask = 0 ! Mask is undefined at beginning if more than 1 plane
    endif
    !
    ! Global aliases: PRIVATE inside
    if (.not.method%mosaic) then
       weight => dummy_weight
    endif
    !
    ithread = 1
    !$  ithread = omp_get_thread_num()+1
    !
    !$OMP DO SCHEDULE(STATIC,1) !! SCHEDULE(DYNAMIC,1)
    do iplane = inout_method%first, inout_method%last
       method%iplane = iplane
       !
       call clean_buffer%get_stopping(method%m_iter,method%ares,iplane)
       !$ write(cthread,'(A,I2)') ', Thread ',ithread
       !$ write(cname,'(A,A,I0,A)') trim(cmethod),'(',iplane,')' 
       !
       if (omp%debug) then
          !$OMP CRITICAL
          print *,'Calling beam_plane '//cthread
          call method%list()
          print *,'Done beam_plane '//cthread
          !$OMP END CRITICAL
       endif
       !
       !THAT IS CRASHING ! call beam_plane(method,hbeam,hdirty)
       ibeam = beam_for_channel(iplane,hdirty,hbeam)
       method%ibeam = ibeam
       !
       ! Get the new mask
       if (nmask.gt.1) then
          lmask => masks(:,:,ithread)
          llist => lists(:,ithread)
       else
          lmask => mask
          llist => list
       endif
       !$ if (omp%debug) print *,'Calling get_maskplane - OMP'
       call get_maskplane(method,hmask,hdirty,lmask,llist)    
       nl = method%nlist
       !$ if (omp%debug) print *,'Thread ',ithread,' NL ',nl
       !
       ! Local aliases
       if (method%imask.ge.1) then
          write(chain,'(A,A,I0,A,I0,A,I0,1x,I0)') 'Planes: ', & 
               '  Image ',method%iplane, & 
               ', - Beam ', method%ibeam, & 
               ', - Mask ', method%imask, nl
       else
          write(chain,'(A,A,I0,A,I0,A,I0)') 'Planes: ', & 
               '  Image ',method%iplane, & 
               ', - Beam ', method%ibeam
       endif
       !$ chain = trim(chain)//cthread
       call map_message(seve%i,cname,chain)
       !
       ! Local aliases
       dirty => hdirty%r3d(:,:,iplane)
       resid => hresid%r3d(:,:,iplane)
       clean => hclean%r3d(:,:,iplane)
       !
       ! Initialize to Dirty map
       resid = dirty
       !
       d3beam  => hbeam%r4d(:,:,:,ibeam)
       if (method%mosaic) then
          d3prim => hprim%r4d(:,:,:,ibeam)
       else
          d3prim => dummy_prim
       endif
       !
       if (method%pcycle) call init_plot (method,hdirty,resid)
       !
       ! Prepare beam parameters - subroutine is not Thread safe though...
       !$OMP CRITICAL
       !$ if (omp%debug) print *,'Critical get_clean '//cthread
       error = .false.
       call method%fit_beam(hbeam,d3beam,error)
       !$ if (omp%debug) print *,'end Critical get_clean '//cthread
       !$OMP END CRITICAL
       if (error) then
          !return !Oops, cannot do that in a DO parallel...
          cycle
       endif
       !$ if (omp%debug) print *,'start get_beam '//cthread
       call get_beam(method,hbeam,hresid,hprim,&
            tfbeam,w_work,w_fft,fhat,error,lmask)
       !$ if (omp%debug) print *,'end get_beam '//cthread
       ! Empty beam case
       if (error) then
          error = .false.
          clean = resid
          !return !Oops, cannot do that in a DO parallel...
          cycle
       endif
       !
       ! Mosaic case
       if (method%mosaic) then
          !$ if (omp%debug) print *,'Setting weight for ',method%ibeam
          ! Reset search list as the mask may have been altered
          call lmask_to_list (lmask,nx*ny,llist,method%nlist)
          nl = method%nlist
          weight => method%weight(:,:,method%ibeam)
          !$ if (omp%debug) print *,'Done weight for ',method%ibeam
          resid = resid * weight
       endif
       !
       ! Performs decomposition into components only
       ! if NL # 0 
       if (nl.ne.0) then
          !$ if (omp%debug) print *,'Select case '//cmethod//cthread
          select case (cmethod)
          case('HOGBOM')
             call hogbom_cycle (cname,method%pflux,   &   ! Plot flux
                  d3beam,mx,my,   & ! Beam and size
                  resid,nx,ny,   & ! Residual and size
                  method%beam0(1),method%beam0(2),   & ! Beam center
                  method%box, method%fres, method%ares,   &
                  method%m_iter, method%p_iter, method%n_iter,   &
                  method%gain, method%keep,   &    !
                  tcc,   &         ! Component Structure
                  lmask,   & ! Search mask
                  llist,   & ! Search list
                  nl,   &          ! and its size
                  np,   &          ! Number of fields
                  d3prim,   &      ! Primary beams
                  weight,   &      ! Weight
                  method%trunca, flux, jcode, next_flux)
          case('CLARK')
             ! Find components
             call major_cycle (cname,method,hclean,   &   !
                  clean,   &       ! Final CLEAN image
                  d3beam,  &       ! Dirty beams
                  resid,nx,ny,   & ! Residual and size
                  tfbeam, w_work,   &  ! FT of dirty beam + Work area
                  w_comp, nc,       &  ! Component storage + Size
                  method%beam0(1),method%beam0(2),   & ! Beam center
                  method%patch(1), method%patch(2), method%bgain,   &
                  method%box,   &
                  w_fft,   &       ! Work space for FFTs
                  tcc,   &         ! Component table
                  llist, nl,   &   ! Search list (truncated...)
                  np,                & ! Number of fields
                  d3prim,            & ! Primary beams
                  weight,            & ! Weight
                  major_plot,        & ! Plotting routine
                  next_flux)
          case('SDI')
             ! Find components
             call major_sdi (cname,method,hclean,   &
                  clean,   &       ! Final CLEAN image
                  d3beam,  &       ! Dirty beams
                  resid,nx,ny,   & ! Residual and size
                  tfbeam, w_work,   &  ! FT of dirty beam + Work area
                  w_comp, nc,       &  ! Component storage + Size
                  method%beam0(1),method%beam0(2),   & ! Beam center
                  method%patch(1), method%patch(2), method%bgain,   &
                  method%box,   &
                  w_fft,   &       ! Work space for FFTs
                  w_cct,   &       ! Clean Component Image
                  llist, nl,   &   ! Search list (truncated...)
                  np,                & ! Number of fields
                  d3prim,            & ! Primary beams
                  weight,            & ! Weight
                  major_plot)          ! Plotting routine
          case('MULTI')
             ! Performs decomposition into components
             call amaxmask (resid,lmask,nx,ny,ix,iy)
             limit = max(method%ares,method%fres*abs(resid(ix,iy)))
             call map_message(seve%i,cname,chain)
             if (limit.eq.method%ares) then
                write (chain,'(A,1PG10.3,A)')  'Cleaning down to ',limit,' from ARES'
             else
                write (chain,'(A,1PG10.3,A,I7,I7)')  'Cleaning down to ',limit,' from FRES at ',ix,iy
             endif
             call map_message(seve%i,cname,chain)
             !
             call major_multi (cname,method,hclean,   &
                  hdirty%r3d(:,:,iplane),   &
                  hresid%r3d(:,:,iplane),   &
                  hbeam%r4d(:,:,:,method%ibeam),                  &
                  lmask,           & ! Check definition of this mask...
                  hclean%r3d(:,:,iplane),   &
                  nx,ny,                    &
                  tcc,   &         ! Clean component
                  method%m_iter,   &   ! Maximum number of components
                  limit,   &       ! Residual
                  method%n_iter,   &   ! Number of components
                  s_mask,   &      ! Smoothed mask
                  s_resi,   &      ! Smoothed residual,
                  t_beam,   &      ! Translated beam
                  w_work,   &      ! Complex work space
                  s_beam,   &      ! Smoothed beams
                  tfbeam,   &      ! Beam Fourier Transform (real)
                  w_fft)
             ! Need to add
             !             &        np,   &          ! Number of fields
             !             &        d3prim,   &      ! Primary beams
             !             &        weight)          ! Weight
             w_cct(:,:) = clean
          end select
          !$ if (omp%debug) print *,'End Select case '//cmethod//cthread
       else
          ! Empty search area: No Clean components...
          method%n_iter = 0
          flux = 0.0
       endif
       !
       ! Add clean components and residuals to produce clean map
       if (method%n_iter.ne.0) then
          !$ if (omp%debug) print *,'Critical clean_make '//cthread
          call clean_make (method, hclean, clean, tcc)
          !$ if (omp%debug) print *,'End clean_make '//cthread
          if (np.le.1) then
             clean = clean + resid
          else
             clean = clean + resid*weight
             where (weight.eq.0) clean = hclean%gil%bval ! Undefined pixel there
          endif
       else
          if (np.le.1) then
             clean = resid
          else
             clean = resid*weight
             where (weight.eq.0) clean = hclean%gil%bval ! Undefined pixel there
          endif
       endif
       !$ if (omp%debug) print *,'Finishing '//cthread
       !
       ! Put the TCC structure into its final place
       if (cmethod.eq.'MULTI' .or. cmethod.eq.'SDI') then
          if (method%n_iter.eq.0) then
             dcct(3,iplane,1) = 0
             write (chain,'(A,1PG10.3,A,I6,A,A,I6)')  'Cleaned ',0.0,   &
                  ' Jy with ',method%n_iter,' components ' &
                  ,' Plane ',iplane
          else
             if (cmethod.eq.'MULTI') then
                m_iter = method%ninflate*method%m_iter
             else
                m_iter = method%m_iter
             endif
             where (w_cct.ne.0)
                mymask = 1
             elsewhere
                mymask = 0
             end where
             f_iter = sum(mymask)
             if (f_iter.gt.m_iter) then
                write(chain,'(A,I8,A,I8)') 'Iterations overflow ',f_iter, &
                     ' > ',m_iter
                call map_message(seve%w,cname,chain)
                dcct(3,iplane,1) = 0
                chain = 'UV_RESTORE will not work, consider increasing INFLATE'
             else
                i = 0
                flux = 0
                do iy=1,ny
                   do ix=1,nx
                      if (w_cct(ix,iy).ne.0) then
                         i = i+1
                         dcct(1,iplane,i) = (dble(ix) -   &
                              hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
                              hclean%gil%convert(2,1)
                         dcct(2,iplane,i) = (dble(iy) -   &
                              hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
                              hclean%gil%convert(2,2)
                         dcct(3,iplane,i) = w_cct(ix,iy)
                         flux = flux+w_cct(ix,iy)
                      endif
                   enddo
                enddo
                method%n_iter = i
                write (chain,'(A,1PG10.3,A,I6,A,A,I6)')  'Cleaned ',flux,   &
                     ' Jy with ',method%n_iter,' components ' &
                     ,' Plane ',iplane
             endif
          endif
          !$ chain = trim(chain)//cthread
          call map_message(seve%i,cname,chain)
       else if (cmethod.ne.'MRC') then
          do i=1,method%n_iter
             dcct(1,iplane,i) = (dble(tcc(i)%ix) -   &
                  hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
                  hclean%gil%convert(2,1)
             dcct(2,iplane,i) = (dble(tcc(i)%iy) -   &
                  hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
                  hclean%gil%convert(2,2)
             dcct(3,iplane,i) = tcc(i)%value
          enddo
          if (method%n_iter.lt.method%m_iter) then
             dcct(3,iplane,method%n_iter+1) = 0
          endif
          if (cmethod.eq.'HOGBOM') then
             write (chain,'(A,1PG10.3,A,I6,A,A,I6)')  'Cleaned ',flux,   &
                  ' Jy with ',method%n_iter,' components ' &
                  ,' Plane ',iplane
             !$ chain = trim(chain)//cthread
             call map_message(seve%i,cname,chain)
          endif
          !
       endif
       !$ if (omp%debug) print *,'End loop '//cthread
    enddo
    !$OMP END DO
    ! There is no OMP FIRST_AND_LASTPRIVATE
    !$OMP MASTER
    major = method%major
    minor = method%minor
    angle = method%angle
    !$OMP END MASTER
    !!print *,'Major ',major,minor,angle
    !$OMP END PARALLEL
    inout_method%major = major
    inout_method%minor = minor
    inout_method%angle = angle
    !$  call omp_set_nested(omp_nested)
    !$  if (nplane.lt.mthread) call omp_set_num_threads(mthread)
    !
    if (allocated(masks)) then
       deallocate(masks,lists)
    endif
    !
    ! PHAT
    !!print *,'sub_major PHAT ',method%phat
    ! This logic is only valid for One beam for all...
    if (method%phat.ne.0) then
       fhat = 1.0/fhat
       if (method%mosaic) then
          d3beam = d3beam*fhat
          do ip=1,np
             d3beam(method%beam0(1),method%beam0(2),ip) =   &
                  d3beam(method%beam0(1),method%beam0(2),ip) -   &
                  method%phat
          enddo
       else
          d3beam = d3beam*fhat
       endif
    endif
    !
    ! Set the blanking value for Mosaics
    if (method%mosaic) then
       hclean%gil%eval = 0
    endif
    !
    ! Clean work space: in principle, Fortran 95 does it for you
    deallocate(w_comp,w_cct,mymask, &
         s_mask,s_resi,t_beam,s_beam, &
         w_work,w_fft,stat=ier)
  end subroutine sub_major
  !
  subroutine amaxmask(a,mask,nx,ny,ix,iy)
    !-----------------------------------------------------------------------
    ! Search the absolute maximum, in a masked region
    !-----------------------------------------------------------------------
    integer, intent(in)  :: nx          ! X size
    integer, intent(in)  :: ny          ! Y size
    real,    intent(in)  :: a(nx,ny)    ! Values
    logical, intent(in)  :: mask(nx,ny) ! Mask
    integer, intent(out) :: ix          ! X position of max
    integer, intent(out) :: iy          ! Y position of max
    !
    real :: rmax
    integer :: i,j
    !
    rmax = -1.0
    ix = 1
    iy = 1
    do j=1,ny
       do i=1,nx
          if (mask(i,j)) then
             if (abs(a(i,j)).gt.rmax) then
                rmax = abs(a(i,j))
                ix = i
                iy = j
             endif
          endif
       enddo
    enddo
  end subroutine amaxmask
  !
  !------------------------------------------------------------------------
  !
  subroutine hogbom_cycle(rname,pflux,beam,mx,my,resid,nx,ny,&
       ixbeam,iybeam,box,fracres,absres,miter,piter,niter,&
       gainloop,keep,cct,msk,list,nl,np,primary,weight,wtrun,&
       cflux,jcode,next_flux)
    use gkernel_interfaces
    use minmax_tool, only: maxlst
    use clean_types, only: clean_converge
    use cct_types
    !$ use omp_lib
    !----------------------------------------------------------------------
    ! Support routine for HOGBOM
    ! Deconvolve map into residual map and source list
    !-----------------------------------------------------------------------
    character(len=*), intent(in)    :: rname 
    logical,          intent(in)    :: pflux             ! Select only positive ?
    integer,          intent(in)    :: mx                ! X size of beam
    integer,          intent(in)    :: my                ! Y size of beam
    integer,          intent(in)    :: nx                ! X size of image
    integer,          intent(in)    :: ny                ! Y size of image
    integer,          intent(in)    :: np                ! Number of fields
    real,             intent(in)    :: beam(mx,my,np)    ! Primary beam(s)
    real,             intent(inout) :: resid(nx,ny)      ! residual image
    real,             intent(in)    :: fracres           ! Fractional residual
    real,             intent(in)    :: absres            ! Absolute residual
    integer,          intent(in)    :: miter             ! Maximum number of clean components
    integer,          intent(in)    :: ixbeam, iybeam    ! Beam maximum position
    integer,          intent(in)    :: box(4)            ! Cleaning box
    real,             intent(in)    :: gainloop          ! Clean loop gain
    logical,          intent(in)    :: keep              ! Keep cleaning after convergence
    integer,          intent(out)   :: niter             ! Iterations
    integer,          intent(out)   :: piter             ! Positive Iterations
    logical,          intent(in)    :: msk(nx,ny)        ! Mask for clean search
    integer,          intent(in)    :: nl                ! Size of search list
    integer,          intent(in)    :: list(nl)          ! Search list
    real,             intent(in)    :: primary(np,nx,ny) ! Primary beams
    real,             intent(in)    :: weight(nx,ny)     ! Weight function
    real,             intent(in)    :: wtrun             ! Safety threshold on primary beams
    type(cct_par),    intent(out)   :: cct(miter)
    integer,          intent(out)   :: jcode             ! Stopping code
    real,             intent(out)   :: cflux             ! Cleaned Flux
    external                        :: next_flux
    !
    logical :: ok
    integer :: dimcum
    integer :: i,j,ix,iy,ip,imax,jmax,imin,jmin,k,l
    integer :: it,ier,nthread,mthread,ithread
    real :: cum,converge,sign
    real :: valmax,valmin,f,vnew,borne,gain
    real, allocatable :: oldcum(:)
    real, allocatable :: vnew_it(:)
    integer, allocatable :: imax_it(:), jmax_it(:)
    character(len=message_length) :: chain
    !
    dimcum = clean_converge
    allocate(oldcum(dimcum),stat=ier)
    !
    ! Find highest point in region to be searched
    call maxlst(resid,nx,ny,list,nl,valmax,imax,jmax,valmin,imin,jmin)
    write(chain,'(A,1PG10.3,A,I6,I6,A,1PG10.3,A,I6,I6)') &
         'Map max. ',valmax,' at ',imax,jmax,  &
         ', Min. ',valmin,' at ',imin,jmin
    call map_message(seve%i,rname,chain)
    !
    ! Subtract +ve and -ve peaks
    niter = 0
    if (niter.lt.piter) then
       vnew = valmax
       ix = imax
       iy = jmax
       sign = 1.0
    elseif (abs(valmin) .gt. abs(valmax)) then
       vnew = valmin
       ix = imin
       iy = jmin
       sign = -1.0
    else
       vnew = valmax
       ix = imax
       iy = jmax
       sign = 1.0
    endif
    !
    ! Setup Subtraction loop
    cum    = 0.
    oldcum = 0.0
    niter  = 0
    converge=0.
    borne = max(absres,fracres*abs(vnew))
    if (np.le.1) then
       gain = gainloop / beam(ixbeam,iybeam,1)
    else
       gain = gainloop
    endif
    !
    ! Main subtraction loop
    mthread = 1
    !$  mthread = omp_get_max_threads()
!!$  print *,'OMP Already parallel ',omp_in_parallel(),' Nesting ',omp_get_nested(), mthread
    allocate(vnew_it(mthread),imax_it(mthread),jmax_it(mthread),stat=ier)
    if (ier.ne.0) then
       write(chain,'(A,I4)') 'Memory allocation error for Mthread ',mthread
       call map_message(seve%e,rname,chain)
       return
    endif
    !
    ok = niter.lt.miter .and. abs(vnew).gt.borne
    !
    do while (ok)
       ! Get the component flux
       niter = niter+1
       f = vnew * gain
       if (np.gt.1) then
          f = f * weight(ix,iy)    ! Convert to Clean component
       endif
       cct(niter)%value = f       ! Store as fractions of beam max
       cct(niter)%ix = ix
       cct(niter)%iy = iy
       cct(niter)%type = 0
       !
       ! Keep last 10 cumulative fluxes to test convergence
       cum = cum + f
       oldcum(mod(niter,dimcum)+1) = cum
       converge = sign * (cum - oldcum(mod(niter+1,dimcum)+1))
       !
       ! Plot the new point
       if (pflux) call next_flux(niter,cum)
       !
       ! Subtract previous component from residual map
       !$OMP PARALLEL DEFAULT(none) &
       !$OMP   &   SHARED(beam,resid,primary,weight,msk) &
       !$OMP   &   SHARED(nx,ny,mx,my,np,box,niter,piter,wtrun) &
       !$OMP   &   SHARED(vnew_it,imax_it,jmax_it) &
       !$OMP   &   SHARED(ixbeam,iybeam,f)  SHARED(ix,iy) &
       !$OMP   &   PRIVATE(j,l,i,k,ip,ithread) SHARED(nthread)
       !
       ithread = 1
       nthread = 1
       !$  nthread = omp_get_num_threads()
       !$  ithread = omp_get_thread_num()+1
       !
       vnew_it(ithread)  = 0
       !$OMP DO
       do j=1,ny
          ! Proceed Row by Row
          l = j-iy+iybeam
          if (l.ge.1 .and. l.le.my) then
             ! Along that row, subtract clean component if in beam
             do i = 1,nx
                k = i-ix+ixbeam
                if (k.ge.1 .and. k.le.mx) then
                   if (np.le.1) then
                      resid(i,j) = resid(i,j) - f*beam(k,l,1)
                   else
                      if (resid(i,j).ne.0) then
                         do ip = 1,np
                            !
                            ! Beware of truncating the primary beam.
                            if (primary(ip,i,j).gt.wtrun) then
                               resid(i,j) = resid(i,j) -   &
                                    f*beam(k,l,ip)*primary(ip,i,j)   &
                                    *primary(ip,ix,iy)*weight(i,j)
                            endif
                         enddo
                      endif
                   endif
                endif
             enddo
          endif
          !
          ! Find new maximum inside cleaning box in residual map for this row
          if ((j.ge.box(2)).and.(j.le.box(4))) then
             if (niter.lt.piter) then
                ! Force positive components
                do i = box(1), box(3)
                   if (msk(i,j)) then
                      if (vnew_it(ithread).lt.resid(i,j)) then
                         vnew_it(ithread)=resid(i,j)
                         imax_it(ithread)=i
                         jmax_it(ithread)=j
                      endif
                   endif
                enddo
             else
                ! Do not force positivity
                do i = box(1), box(3)
                   if (msk(i,j)) then
                      if (abs(vnew_it(ithread)).lt.abs(resid(i,j))) then
                         vnew_it(ithread)=resid(i,j)
                         imax_it(ithread)=i
                         jmax_it(ithread)=j
                      endif
                   endif
                enddo
             endif
          endif
          !
          ! Loop for next row
       enddo
       !$OMP END DO
       !$OMP END PARALLEL
       !
       ! Compute VNEW and Position for next iteration
       !print *,'Computing VNEW '
       vnew = 0.0
       it = 1
       do i=1,nthread
          if (abs(vnew).lt.abs(vnew_it(i))) then
             it = i
             vnew = vnew_it(i)
          endif
       enddo
       vnew = vnew_it(it)
       ix = imax_it(it)
       iy = jmax_it(it)
       !
       !!print *,'Niter ',niter,' < ',miter,niter.lt.miter
       !!print *,'Keep ',keep,' and Converge ',converge, ' > 0',keep.or.(converge.gt.0)
       !!print *,'Vnew = ',vnew,' > Borne = ',borne,abs(vnew).gt.borne
       !
       jcode = 0
       if (sic_ctrlc()) exit
       !
       if (niter.ge.miter) then
          jcode = 1
          exit
       endif
       if (.not.keep.and.(converge.le.0)) then
          jcode = 2
          exit
       endif
       if (abs(vnew) .le. borne) then
          jcode = 3
          exit
       endif
    enddo
    !
    cflux = cum
  end subroutine hogbom_cycle
  !
  !------------------------------------------------------------------------
  !
  subroutine major_cycle(rname,method,head,&
       clean,beam,resid,nx,ny,tfbeam,fcomp,&
       wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,&
       box,wfft,tcc,list,nl,np,primary,weight,&
       major_plot,next_flux)
    use image_def
    use gkernel_interfaces, only : fourt_plan
    use minmax_tool, only: maxlst
    use clean_types
    use cct_types
    !----------------------------------------------------------------------
    ! Major cycle loop according to B.Clark idea
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type(clean_par),  intent(inout) :: method
    type(gildas),     intent(in)    :: head
    integer,          intent(in)    :: np                 ! Number of pointings
    integer,          intent(in)    :: nx                 ! X size
    integer,          intent(in)    :: ny                 ! Y size
    integer,          intent(in)    :: mcl                ! Maximum number of clean components
    real,             intent(inout) :: clean(nx,ny)       ! Clean map
    real,             intent(inout) :: resid(nx,ny)       ! Residual map
    real,             intent(in)    :: beam(nx,ny,np)     ! Dirty beams (per pointing)
    real,             intent(in)    :: tfbeam(nx,ny,np)   ! T.F. du beam
    complex,          intent(inout) :: fcomp(nx,ny)       ! T.F. du vecteur modification
    real,             intent(in)    :: bgain              ! Maximum sidelobe level
    integer,          intent(in)    :: ixbeam, iybeam     ! Beam maximum position
    integer,          intent(in)    :: ixpatch, iypatch   ! Beam patch radius
    integer,          intent(in)    :: box(4)             ! Cleaning box
    real,             intent(inout) :: wfft(*)            ! Work space for FFT
    type(cct_par),    intent(inout) :: tcc(method%m_iter) ! Clean components array
    type(cct_par),    intent(inout) :: wcl(mcl)           ! Work space for Clean components
    integer,          intent(inout) :: list(nx*ny)        ! list of searchable pixels
    integer,          intent(inout) :: nl                 ! List size
    real,             intent(in)    :: primary(np,nx,ny)  ! Primary beams
    real,             intent(in)    :: weight (nx,ny)     ! Flat field response
    external                        :: major_plot
    external                        :: next_flux
    !
    logical :: fini                ! critere d'arret
    logical :: converge            ! Indique la conv par acc de flux
    integer :: ncl                 ! nb de pts reellement retenus
    integer :: k,kcl
    integer :: nn(2),ndim
    integer :: imax,jmax,imin,jmin ! leurs coordonnees
    real :: maxc,minc,maxabs       ! max et min de la carte, absolute
    real :: lastabs                ! Check for oscillations
    real :: borne                  ! fraction de la carte initiale
    real :: limite                 ! intensite minimum des pts retenus
    real :: clarkl                 ! Clark worry limit
    real :: flux                   ! Total clean flux density
    character(len=message_length) :: chain
    !
    ! Find maximum residual
    call maxlst (resid,nx,ny,list,nl,maxc,imax,jmax,minc,imin,jmin)
    !
    if (method%n_iter.lt.method%p_iter) then
       maxabs=abs(maxc)
    elseif ( abs(maxc).lt.abs(minc) ) then
       maxabs=abs(minc)
    else
       maxabs=abs(maxc)
    endif
    borne= max(method%fres*maxabs,method%ares)
    fini = maxabs.lt.borne
    method%n_iter= 0
    flux = 0.0
    !
    if (.not.fini) then
       ndim = 2
       nn(1) = nx
       nn(2) = ny
       call fourt_plan(fcomp,nn,ndim,-1,1)
       call fourt_plan(fcomp,nn,ndim,+1,1)
    endif
    !
    ! Major cycle
    k = 0
    do while (.not.fini)
       ! Define minor cycle limit
       k = k+1
       write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
       call map_message(seve%i,rname,chain)
       limite = max(maxabs*bgain,0.8*borne)
       clarkl = maxabs*bgain
       !
       kcl = mcl
       !
       ! Select points of maximum strength and load them in
       call choice (   &
            resid,   &         ! Current residuals
            nx,ny,   &         ! image size
            list, nl,   &      ! Search list
            limite,   &        ! Detection threshold
            kcl,         &     ! Maximum number of candidates
            wcl,         &     ! CCT
            ncl,   &           ! Selected Number of components
            maxabs, method%ngoal)
       !
       if (ncl.gt.0) then
          write(chain,100) 'Selected ',ncl,' points above ',limite
          call map_message(seve%i,rname,chain)
          !
          ! Make minor cycles
          call minor_cycle (method,   &
               wcl,            &    ! CCT
               ncl,            &    ! Number of candidates
               beam,nx,ny,     &    ! Dirty beams and Size
               ixbeam,iybeam,  &    ! Beam center
               ixpatch,iypatch,&    ! Beam patch
               clarkl,limite,  &
               converge,       &    !
               tcc,            &    ! Cumulated components
               np, primary, weight, method%trunca,   &
               flux,   &        ! Total Flux
               method%pflux, next_flux)
          !
          ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
          call remisajour (nx*ny,   &  ! Total size
               clean,       &    ! CLEAN map used as work space
               resid,       &    ! Updated residuals
               tfbeam,      &    ! Beam TF
               fcomp,       &    ! Work space for Component TF
               wcl,         &    ! CCT
               ncl,   &          ! Number of Clean Components
               nx,ny,   &        ! Map size
               wfft,   &         ! FFT work space
               np, primary, weight, method%trunca)
          write (chain,101)  'Cleaned ',flux,' Jy with ',method%n_iter,' clean components'
          call map_message(seve%i,rname,chain)
          !
          ! Find new extrema
          lastabs = maxabs
          call maxlst(resid,nx,ny,list,nl,maxc,imax,jmax,minc,imin,jmin)
          if (method%n_iter.lt.method%p_iter) then
             maxabs=abs(maxc)
          elseif ( abs(maxc).lt.abs(minc) ) then
             maxabs=abs(minc)
          else
             maxabs=abs(maxc)
          endif
          if (maxabs.gt.1.15*lastabs) then
             write(chain,'(a,1pg10.3,a,1pg10.3)') &
                  'Detected beginning of oscillations',maxabs,' > ',lastabs
             call map_message(seve%w,rname,chain)
          endif
          !
          ! Check if converge
          fini = (maxabs.le.borne)   &
               .or. (method%m_iter.le.method%n_iter)   &
               .or. converge
       else
          ! No component found: finish...
          write(chain,101) 'No points selected above ',limite
          call map_message(seve%i,rname,chain)
          fini = .true.
       endif
       !
       ! Intermediate or final PLOT
       converge = fini
       call major_plot (method,head,   &
            converge,method%n_iter,nx,ny,np,   &
            tcc,clean,resid,weight)
       fini = converge
       !
       ! Limit number of major cycles...
       if (k.gt.method%n_major) fini = .true.
       !
       ! Get new list
       !    if (.not.fini) then
       !      !
       !      ! Get a new list if in QUERY mode
       !      ! Query mode does not exist for MRC
       !      if (method%qcycle) then
       !        ! For MRC, method is s_method, while
       !        ! head is the normal stuff... This would create a problem
       !        call get_newmask (method,head,nl,error)
       !        !
       !        ! Reset the List in its defined range.
       !        list(1:nl) = method%list(1:nl)
       !      endif
       !    endif
    enddo
    !
    ! End
    if (maxabs.le.borne) then
       call map_message(seve%i,rname,'Reached minimum flux density')
    elseif (method%m_iter.le.method%n_iter) then
       call map_message(seve%i,rname,'Reached maximum number of components')
    elseif (converge) then
       call map_message(seve%i,rname,'Reached minor cycle convergence')
    elseif (k.gt.method%n_major) then
       call map_message(seve%i,rname,'Reached maximum number of cycles')
    else
       call map_message(seve%i,rname,'End of transcendental causes')
    endif
    write(chain,101)  'CLEAN found ',flux,' Jy in ',method%n_iter,' clean components'
    call map_message(seve%i,'CLEAN',chain)
    !
100 format (a,i6,a,1pg10.3,a)
101 format (a,1pg10.3,a,i7,a)
  end subroutine major_cycle
  !
  subroutine minor_cycle(method,wcl,ncl,&
       beam,nx,ny,ixbeam,iybeam,ixpatch,iypatch,&
       clarkmin,limite,converge,&
       tcc,np,primary,weight,wtrun,cum,pflux,next_flux)
    use gkernel_interfaces
    use clean_types
    use cct_types
    !----------------------------------------------------------------------
    ! B.Clark minor cycles
    ! Deconvolve as in standard clean a list of NCL points
    ! selected in the map until the residuals is less than CLARKMIN
    !----------------------------------------------------------------------
    type(clean_par), intent(inout) :: method
    integer,         intent(in)    :: np                   ! Number of fields in mosaic
    integer,         intent(in)    :: ncl                  ! nombre de points retenus
    integer,         intent(in)    :: nx,ny,ixbeam,iybeam  ! dimension et centre du beam
    integer,         intent(in)    :: ixpatch,iypatch      ! rayon utile du Beam
    real,            intent(in)    :: beam(nx,ny,np)       ! Dirty beam
    type(cct_par),   intent(inout) :: wcl(*)               ! Clean components
    type(cct_par),   intent(out)   :: tcc(*)               ! Effective clean components
    real,            intent(in)    :: clarkmin             ! borne d'arret de clean
    real,            intent(in)    :: limite               ! borne d'arret de clean
    logical,         intent(out)   :: converge             ! Controle de la convergence
    real,            intent(in)    :: primary(np,nx,ny)    ! Primary beams of mosaics
    real,            intent(in)    :: weight(nx,ny)        ! Effective weights on sky
    real,            intent(in)    :: wtrun                ! Threshold of primary beam
    real,            intent(inout) :: cum                  ! Cumulative flux
    logical,         intent(in)    :: pflux
    external                       :: next_flux
    !
    logical :: check             ! Controle de la convergence
    logical :: abor,goon
    integer :: n,ier,i
    integer :: kiter
    integer :: kcl               ! No de la composante courante
    integer :: nomax,nomin       ! No du max et min courant
    integer :: dimcum=10         ! par accumulation de flux positif
    real :: gain                 ! gain de clean
    real :: rmax,rmin,sign       ! Max et Min courant
    real :: worry,xfac           ! Conservative and speedup factor
    real :: f,bmax
    real, allocatable :: oldcum(:)
    character(len=20) :: comm
    !
    !call sic_get_inte('MAP_CONVERGE',dimcum,error)
    allocate(oldcum(dimcum),stat=ier)
    !
    abor = .false.
    do i=1,ncl
       wcl(i)%value = 0.0
    enddo
    oldcum = cum
    gain = method%gain
    check = .not.method%keep
    !
    call cct_par_minmax(wcl,ncl,nomin,rmin,nomax,rmax)
    !!print *,'Nomin ',nomin,rmin,nomax,rmax
    if (method%n_iter.lt.method%p_iter) then
       kcl=nomax
       rmax=abs(rmax)
       sign = 1.0
    elseif (abs(rmin).gt.rmax) then
       kcl=nomin
       rmax=abs(rmin)
       sign = -1.0
    else
       kcl=nomax
       rmax=abs(rmax)
       sign = 1.0
    endif
    !
    converge = rmax.le.limite
    worry = 1.0
    xfac = (clarkmin/rmax)**method%spexp
    kiter = 0
    goon = method%n_iter.lt.method%m_iter   &
         .and. .not.converge
    bmax = beam(ixbeam,iybeam,1)
    !
    do while (goon)
       method%n_iter = method%n_iter + 1
       kiter = kiter + 1
       if (np.gt.1) then
          f = gain * wcl(kcl)%influx* weight(wcl(kcl)%ix,wcl(kcl)%iy)
       else
          f = gain / bmax * wcl(kcl)%influx
       endif
       !
       ! Store clean component list
       cum = cum+f
       if (pflux) call next_flux(method%n_iter,cum)
       !
       wcl(kcl)%value = wcl(kcl)%value + f
       tcc(method%n_iter)%value = f    ! Store as fractions of beam max
       tcc(method%n_iter)%ix = wcl(kcl)%ix
       tcc(method%n_iter)%iy = wcl(kcl)%iy
       tcc(method%n_iter)%type = 0
       !
       ! Subtract from iterated values VCL
       call soustraire (wcl,ncl,           &
            beam,nx,ny,ixbeam,iybeam,   &
            ixpatch,iypatch,kcl,gain,   &
            np,primary,weight,wtrun)
       !
       ! Find maximum again
       call cct_par_minmax(wcl,ncl,nomin,rmin,nomax,rmax)
       if (method%n_iter.lt.method%p_iter) then
          kcl=nomax
          rmax=abs(rmax)
       elseif (abs(rmin).gt.rmax) then
          kcl=nomin
          rmax=abs(rmin)
       else
          kcl=nomax
          rmax=abs(rmax)
       endif
       !
       ! B.CLARK Magic confidence factor
       worry = worry+xfac/float(kiter)
       !
       ! Check convergence
       abor = sic_ctrlc()
       goon = (rmax.gt.worry*clarkmin) .and. (rmax.gt.limite)   &
            .and. (method%n_iter.lt.method%m_iter)
       goon = goon .and. .not.abor
       if (check) then
          oldcum(mod(method%n_iter,dimcum)+1) = cum
          if (method%n_iter.ge.dimcum) then
             converge =   &
                  sign*(cum-oldcum(mod(method%n_iter+1,dimcum)+1))   &
                  .lt.0.0
             goon = goon .and. .not.converge
          endif
       endif
    enddo
    !
    if (abor) then
       comm = ' '
       call sic_wprn('I-CLARK,  Enter last valid component ',comm,n)
       if (n.eq.0) return
       n = lenc(comm)
       if (n.eq.0) return
       read(comm(1:n),*,iostat=ier) method%n_iter
       converge = .true. ! It must be converged
    endif
  end subroutine minor_cycle
  !
  !------------------------------------------------------------------------
  !
  subroutine major_sdi(rname,method,head,clean,beam,resid,nx,ny,&
       tfbeam,fcomp,wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,&
       box,wfft,comp,list,nl,np,primary,weight,&
       major_plot)
    use image_def
    use minmax_tool, only: maxlst
    use clean_types
    use cct_types
    !----------------------------------------------------------------------
    ! Major cycle loop according to Steer Dewdney and Ito idea
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: rname 
    type(clean_par),  intent(inout) :: method
    type(gildas),     intent(in)    :: head
    integer,          intent(in)    :: np                ! Number of fields
    integer,          intent(in)    :: nx                ! X size
    integer,          intent(in)    :: ny                ! Y size
    integer,          intent(in)    :: mcl               ! Maximum number of clean components
    real,             intent(inout) :: clean(nx,ny)      ! Clean map
    real,             intent(inout) :: resid(nx,ny)      ! Residual map
    real,             intent(in)    :: beam(nx,ny,np)    ! Dirty beams (per field)
    real,             intent(in)    :: tfbeam(nx,ny,np)  ! T.F. du beam
    complex,          intent(inout) :: fcomp(nx,ny)      ! T.F. du vecteur modification
    type(cct_par),    intent(inout) :: wcl(mcl)          ! Work space for Clean components
    real,             intent(in)    :: bgain             ! Maximum sidelobe level
    integer,          intent(in)    :: ixbeam, iybeam    ! Beam maximum position
    integer,          intent(in)    :: ixpatch, iypatch  ! Beam patch radius
    integer,          intent(in)    :: box(4)            ! Cleaning box
    real,             intent(inout) :: wfft(*)           ! Work space for FFT
    integer,          intent(inout) :: list(nx*ny)       ! list of searchable pixels
    integer,          intent(inout) :: nl                ! List size
    real,             intent(inout) :: comp(nx,ny)       ! Clean components array
    real,             intent(in)    :: primary(np,nx,ny) ! Primary beams
    real,             intent(in)    :: weight (nx,ny)
    external                        :: major_plot
    !
    logical :: fini              ! critere d'arret
    logical :: converge          ! Indique la conv par acc de flux
    integer :: k
    integer :: ndim,nn(2)
    integer :: ncl               ! nb de pts reellement retenus
    integer imax,jmax,imin,jmin  ! leurs coordonnees
    real :: maxc,minc,maxabs     ! max et min de la carte, absolu
    real :: borne                ! fraction de la carte initiale
    real :: limite               ! intensite minimum des pts retenus
    real :: flux                 ! Total clean flux density
    real :: factor               ! Scaling factor
    type (cct_par) :: tcc(1)     ! Dummy argument for Major_PLOT
    character(len=message_length) :: chain
    !
    ! Find maximum residual
    call maxlst(resid,nx,ny,list,nl,maxc,imax,jmax,minc,imin,jmin)
    if (method%n_iter.lt.method%p_iter) then
       maxabs=abs(maxc)
    elseif ( abs(maxc).lt.abs(minc) ) then
       maxabs=abs(minc)
    else
       maxabs=abs(maxc)
    endif
    borne= max(method%fres*maxabs,method%ares)
    fini = maxabs.lt.borne
    method%n_iter= 0
    flux = 0.0
    !
    ! Initialize clean components
    comp = 0.0
    ndim = 2
    nn(1) = nx
    nn(2) = ny
    call fourt_plan(fcomp,nn,ndim,-1,1)
    call fourt_plan(fcomp,nn,ndim,+1,1)
    !
    ! Major cycle
    !
    converge = .false.
    k = 0
    do while (.not.fini)
       ! Define minor cycle limit
       k = k+1
       write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
       call map_message(seve%i,rname,chain)
       limite = max(maxabs*bgain,0.8*borne)
       !
       ! Select points of maximum strength and load them in
       call choice (   &
            resid,       &      ! Current residuals
            nx,ny,       &      ! image size
            list, nl,    &      ! Search list
            limite,      &      ! Detection threshold
            mcl,         &      ! Maximum number of candidates
            wcl,         &      ! Selected candidate components
            ncl,         &      ! Selected Number of components
            maxabs, 0)
       !
       if (ncl.gt.0) then
          write(chain,100) 'Selected ',ncl,' points above ',limite
          call map_message(seve%i,rname,chain)
          !
          ! No minor cycles. Compute scaling factor
          call normal (   &
               fcomp,       &    ! Work space for Component TF
               tfbeam,      &    ! Beam TF
               nx,ny,       &    ! image size
               wcl,         &    ! Selected candidate components
               ncl,   &          ! Selected Number of components
               wfft,   &         ! FFT work space
               factor)
          !!print *,'Done NORMAL '
          !
          ! Compute Clean Components
          factor = method%gain*maxabs/factor
          call scalec(   &
               wcl,         &    ! Selected candidate components
               ncl,factor,flux,   &
               comp, nx, ny)
          !!print *,'Done SCALEC '
          method%n_iter = method%n_iter+ncl
          !
          ! Remove all components by FT : RESIDU = RESIDU - BEAM # WCL(*,4)
          call remisajour (nx*ny,   &
               clean,       &    ! CLEAN map used as work space
               resid,       &    ! Updated residuals
               tfbeam,      &    ! Beam TF
               fcomp,       &    ! Work space for Component TF
               wcl,         &    ! Clean components
               ncl,         &    ! Number of Clean Components
               nx,ny,       &    ! Map size
               wfft,        &    ! FFT work space
               np, primary, weight, method%trunca)
          !!print *,'Done REMISAJOUR '
          write (chain,101)  'Cleaned ',flux,' Jy with ',   &
               method%n_iter,' clean components'
          call map_message(seve%i,rname,chain)
          !
          ! Find new extrema
          call maxlst (resid,nx,ny,list,nl,   &
               maxc,imax,jmax,minc,imin,jmin)
          if (method%n_iter.lt.method%p_iter) then
             maxabs=abs(maxc)
          elseif ( abs(maxc).lt.abs(minc) ) then
             maxabs=abs(minc)
          else
             maxabs=abs(maxc)
          endif
          !
          ! Check if converge
          fini = (maxabs.le.borne)   &
               .or. (k.gt.method%n_major)   &
               .or. converge
       else
          write(chain,101) 'No point selected above ',limite
          fini = .true.
          call map_message(seve%i,rname,chain)
       endif
       !
       ! Intermediate or final PLOT
       converge = fini
       clean(:,:) = comp               ! Use CLEAN as work space to plot it
       !!print *,'Doing MAJOR_PLOT '
       call major_plot(method,head,   &
            converge,method%n_iter,nx,ny,np,   &
            tcc,clean,resid,weight)
       !!print *,'Done MAJOR_PLOT '
       fini = converge
       !
       ! Get new list
       !    if (.not.fini) then
       !      ! Get a new list if in QUERY mode
       !      ! Query mode does not exist for MRC
       !      if (method%qcycle) then
       !        ! For MRC, method is s_method, while
       !        ! head is the normal stuff... This would create a problem
       !        call get_newmask (method,head,nl,error)
       !        !
       !        ! Reset the List in its defined range.
       !        list(1:nl) = method%list(1:nl)
       !      endif
       !    endif
    enddo
    !
    ! End
    if (maxabs.le.borne) then
       write(chain,100) 'Reached minimum flux density '
    elseif (k.ge.method%n_major) then
       write(chain,100) 'Reached maximum number of cycles'
    elseif (converge) then
       write(chain,100) 'Reached minor cycle convergence'
    else
       write(chain,100) 'End of transcendental causes'
    endif
    call map_message(seve%i,rname,chain)
    !
    ! Store the result
    clean(:,:) = comp
    !
100 format (a,i6,a,1pg10.3,a)
101 format (a,1pg10.3,a,i7,a)
  end subroutine major_sdi
  !
  subroutine normal(fcomp,tfbeam,nx,ny,wcl,ncl,wfft,factor)
    use gkernel_interfaces, only : fourt
    use cct_types
    !----------------------------------------------------------------------
    ! Support routine for SDI
    ! Subtract last major cycle components from residual map.
    !----------------------------------------------------------------------
    integer,       intent(in)    :: nx            ! X size
    integer,       intent(in)    :: ny            ! Y size
    integer,       intent(in)    :: ncl           ! Number of clean components
    type(cct_par), intent(in)    :: wcl(ncl)      ! Clean comp.
    real,          intent(in)    :: tfbeam(nx,ny) ! Beam TF
    complex,       intent(out)   :: fcomp(nx,ny)  ! TF of clean comp.
    real,          intent(inout) :: wfft(*)       ! Work array
    real,          intent(out)   :: factor        ! Max of clean
    !
    integer :: i,j,k,ndim,nn(2)
    !
    fcomp = 0.0
    do k=1,ncl
       fcomp(wcl(k)%ix,wcl(k)%iy) = cmplx(wcl(k)%influx,0.0)
    enddo
    ndim = 2
    nn(1) = nx
    nn(2) = ny
    call fourt(fcomp,nn,ndim,-1,0,wfft)
    fcomp = fcomp*tfbeam
    call fourt(fcomp,nn,ndim,1,1,wfft)
    factor = abs(real(fcomp(1,1)))
    do j=1,ny
       do i=1,nx
          factor = max(factor,abs(real(fcomp(i,j))))
       enddo
    enddo
  end subroutine normal
  !
  subroutine scalec(wcl,ncl,f,s,compon,nx,ny)
    use cct_types
    !----------------------------------------------------------------------
    ! Support routine for SDI
    ! Subtract last major cycle components from residual map.
    !----------------------------------------------------------------------
    integer,       intent(in)    :: nx            ! X size
    integer,       intent(in)    :: ny            ! Y size
    integer,       intent(in)    :: ncl           ! Number of clean components
    type(cct_par), intent(inout) :: wcl(ncl)      ! Clean comp.
    real,          intent(in)    :: f             ! Gain factor
    real,          intent(inout) :: s             ! Cumulative flux
    real,          intent(inout) :: compon(nx,ny) ! Cumulative clean component
    !
    integer :: i
    !
    do i=1,ncl
       wcl(i)%value = wcl(i)%influx*f
       s = s+wcl(i)%value
       compon(wcl(i)%ix,wcl(i)%iy) = compon(wcl(i)%ix,wcl(i)%iy) + wcl(i)%value
    enddo
  end subroutine scalec
  !
  !------------------------------------------------------------------------
  !
  subroutine major_multi(rname,method,head,&
       dirty,resid,beam,mask,clean,nx,ny,&
       tcc,miter,limit,niter,&
       smask,sresid,trans,cdata,sbeam,&
       tfbeam,wfft)
    ! Need to add
    !    &    nf, primary, weight)
    use image_def
    use gkernel_interfaces
    use mapping_interfaces
    use clean_types
    use cct_types
    use clean_multi_tool
    use clean_flux_tool, only: plot_multi
    !$  use omp_lib
    !-----------------------------------------------------------------------
    ! Multi-Resolution CLEAN - with NS (parameter) scales
    !
    ! Algorithm
    ! For each iteration, search at which scale the signal to noise is
    ! largest. Use the strongest S/N to determine the "component" intensity
    ! and shape at this iteration.
    !
    ! Restore the ("infinite" resolution) image from the list of location
    ! types, and intensities of the "components"
    !
    ! The noise level at each scale is computed from the Fourier transform of
    ! the smoothed dirty beams, since the FT is the weight distribution and
    ! the noise level is the inverse square root of the sum of the weights.
    !-----------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type(clean_par),  intent(inout) :: method
    type(gildas),     intent(inout) :: head           ! Unused, but here for consistency...
    integer,          intent(in)    :: nx,ny          ! Image size
    integer,          intent(in)    :: miter          ! Maximum number of clean components
    integer,          intent(out)   :: niter          ! Number of found components
    real,             intent(in)    :: dirty(nx,ny)   ! Dirty image
    real,             intent(inout) :: resid(nx,ny)   ! Residual image (initialized to Dirty image)
    real,             intent(in)    :: beam(nx,ny)    ! Dirty beam
    real,             intent(inout) :: clean(nx,ny)   ! "CLEAN" image (not convolved yet)
    logical,          intent(in)    :: mask(nx,ny)    ! Search area
    real,             intent(in)    :: limit          ! Maximum residual
    real,             intent(in)    :: tfbeam(nx,ny)  ! Real Beam TF
    real,             intent(inout) :: wfft(*)
    type(cct_par),    intent(out)   :: tcc(miter)
    real,             intent(inout) :: sbeam(nx,ny,*) ! Smoothed beams
    real,             intent(inout) :: sresid(nx,ny)  ! Smoothed residuals
    real,             intent(inout) :: trans(nx,ny)   ! Translated beam
    complex,          intent(inout) :: cdata(nx,ny)   ! Work array
    logical,          intent(inout) :: smask(nx,ny)   ! Smoothed mask
    !
    integer, parameter :: ms=3
    integer, parameter :: mk=11
    integer :: ncase(ms)
    integer :: ix(ms),iy(ms)     ! Coordinates of each iteration maximum
    integer :: nker(ms)          ! Kernel size
    integer :: ns                ! Number of Kernels
    real :: scale(ms)            ! Noise level for each beam
    real :: bruit(ms)            ! Residual level for each beam
    real :: sn(ms)               ! Signal / Noise
    real :: again(ms)            ! Gain per kernel
    real :: gains(ms)            ! same after noise correction
    real :: fluxes(ms)           ! Cumulative flux per kernel
    real :: loss(ms)             ! Noise degradation factor...
    real :: kernel(mk,mk,ms)     ! Smoothing kernels
    !
    logical :: ok,plot,keep,printout,interrupt
    integer, parameter :: mcum=10
    integer :: ncum
    integer :: nn(2),ndim,kx,ky
    integer :: is,i,j,oldis,goodis
    real :: value,oldcum(mcum),converge,sign
    real :: maxa,flux,smooth,gain,maxsn,worry
    character(len=24) :: string
    character(len=message_length) :: chain
    !
    smooth = method%smooth
    gain = method%gain
    plot = method%pflux
    keep = method%keep
    nker = method%nker
    printout = method%verbose  ! Default behaviour
    again = method%gains
    worry = method%worry
    !
    ! Initialize the kernel
    interrupt = .false.
    kernel = 0.0
    ns = 1
    nker(1) = 1
    kernel = 0.0
    kernel(1,1,1) = 1.0
    !
    if (nker(2).gt.0) then
       call init_kernel(kernel(:,:,2),mk,nker(2),smooth)
       ns = 2
       if (nker(3).gt.0) then
          smooth = smooth**2
          call init_kernel(kernel(:,:,3),mk,nker(3),smooth)
          ns = 3
       endif
    endif
    ncase(1:ms) = 0
    fluxes(:) = 0.0
    trans(:,:) = 0.0
    !
    ! Initialize smoothed beams & mask
    call smooth_mask (mask,smask,nx,ny,nker(ns))
    !
    sbeam(:,:,1) = beam
    loss(1) = 1.0
    scale(1) = 1.0
    gains(1) = again(1)
    !
    kx = nx/2+1
    ky = ny/2+1
    do is = 2,ns
       call smooth_kernel (beam,sbeam(:,:,is),nx,ny,mk,nker(is),kernel(:,:,is))
       value = 1.0/sbeam(kx,ky,is)
       loss(is) = sqrt(value)
       scale(is) = value
       sbeam(:,:,is) = sbeam(:,:,is)*value  ! Now normalized
       kernel(:,:,is) = kernel(:,:,is)*value    ! Corresponding Kernel
       gains(is) = again(is)
    enddo
    !
    write(chain,'(A,3(1X,1PG11.4))') 'Scales ',scale
    call map_message(seve%i,rname,chain)
    write(chain,'(A,3(1X,1PG11.4))') 'Noise ',loss
    call map_message(seve%i,rname,chain)
    !
    ! Main clean loop
    niter = 0
    ok = niter.lt.miter
    flux = 0.0
    !
    ! Initialize convergence test
    call amaxmask (resid,mask,nx,ny,ix(1),iy(1))
    if (resid(ix(1),iy(1)).gt.0.0) then
       sign = 1.0
    else
       sign =-1.0
    endif
    ncum = 1
    converge = 0.0
    oldcum = 0.0
    oldis = 0
    goodis = 1   ! To prevent compiler warning only..
    maxsn = 0    ! Also
    !
    do           ! For ever...
       do is = 1,ns
          if (is.eq.1) then
             call amaxmask (resid,mask,nx,ny,ix(1),iy(1))
             bruit(1) = resid(ix(1),iy(1))
          else
             !
             ! Smooth within (smoothed) mask
             call smooth_masked(nx,ny,sresid,resid,smask,mk,nker(is),kernel(:,:,is))
             !
             ! or (slower) anywhere
             !        call smooth_kernel(resid,sresid,nx,ny,mk,nker(is),kernel(:,:,is))
             !
             ! Use MASK or SMASK, more or less at will...
             call amaxmask (sresid,mask,nx,ny,ix(is),iy(is))
             bruit(is) = sresid(ix(is),iy(is))
          endif
       enddo
       !
       maxa = -1.0
       do is = 1,ns
          sn(is) = abs(bruit(is)/loss(is))
          if (sn(is).gt.maxa) then
             maxa = sn(is)
             goodis = is
          endif
       enddo
       !
       if (niter.eq.0) maxsn = sn(goodis)
       !
       ! Check criterium
       ok = niter.lt.miter
       ok = ok .and. abs(bruit(1)).ge.limit
       if (.not.ok) exit
       if (sn(goodis).gt.maxsn) then
          write(chain,'(a,f14.7,2(x,f14.7))') 'S/N has degraded: ',sn(goodis),maxsn,&
               abs(2*(sn(goodis)-maxsn)/(sn(goodis)+maxsn))
          call map_message(seve%d,rname,chain)
       endif
       maxsn = worry*sn(goodis)+(1.0-worry)*maxsn  ! Propagate S/N estimate
       !
       niter = niter+1
       !
       tcc(niter)%value = gains(goodis)*bruit(goodis)
       tcc(niter)%ix = ix(goodis)
       tcc(niter)%iy = iy(goodis)
       tcc(niter)%type = goodis
       !
       ! Do not Scale component flux : See Note Later
       flux = flux + tcc(niter)%value*scale(goodis)
       !
       oldcum(ncum) = flux
       ncum = ncum+1
       if (ncum.gt.mcum) ncum = 1
       converge = sign * (flux - oldcum(ncum))
       !
       ! Plot the new point
       if (printout.and.goodis.ne.oldis) then
          if (goodis.eq.1) then
             write(chain,101) niter,ix(goodis),iy(goodis),   &
                  sn(1),sn(2),sn(3),bruit(goodis)/loss(goodis)
          elseif (goodis.eq.2) then
             write(chain,102) niter,ix(goodis),iy(goodis),   &
                  sn(1),sn(2),sn(3),bruit(goodis)/loss(goodis)
          elseif (goodis.eq.3) then
             write(chain,103) niter,ix(goodis),iy(goodis),   &
                  sn(1),sn(2),sn(3),bruit(goodis)/loss(goodis)
          endif
          call map_message(seve%r,rname,chain)
          oldis = goodis
       endif
       ncase(goodis) = ncase(goodis)+1
       ! Scale cumulative flux : See Note Later
       fluxes(goodis) = fluxes(goodis) + gains(goodis)*bruit(goodis)*scale(goodis)
       if (plot) then
          is = goodis
          call plot_multi (niter,flux,is)
       endif
       !
       ! Subtract from residual
       maxa = -again(goodis)*bruit(goodis)
       !
       ! Translate appropriate beam
       kx = ix(goodis)-nx/2-1
       ky = iy(goodis)-ny/2-1
       !
       !$    ! print *,'In parallel ',omp_in_parallel()
       !$OMP PARALLEL &
       !$OMP  & SHARED(nx,ny,kx,ky,goodis,trans)  PRIVATE(i,j)
       !$OMP DO
       do j=max(1,ky+1),min(ny,ny+ky)
          do i=max(1,kx+1),min(nx,nx+kx)
             trans(i,j) = sbeam(i-kx,j-ky,goodis)
          enddo
       enddo
       !$OMP END DO
       !
       ! Why not subtract everywhere ?
       !     resid = resid + maxa*trans
       !    where (smask)
       !      resid = resid + maxa*trans
       !    end where
       !$OMP DO
       do j=1,ny
          do i=1,nx
             resid(i,j) = resid(i,j) + maxa * trans(i,j)
             trans(i,j) = 0.0
          enddo
       enddo
       !$OMP END DO
       !$OMP END PARALLEL
       if (.not.keep) ok = ok.and.(converge.ge.0.0)
       if (.not.ok) exit
       if (sic_ctrlc()) then
          interrupt = .true.
          exit
       endif
    enddo
    !
    if (niter.eq.miter) then
       string = 'iteration limit'
    else if (sn(goodis).gt.maxsn) then
       string = 'signal to noise stability'
    else if ((.not.keep).and.converge.lt.0.0) then
       string = 'flux convergence'
    else if (interrupt) then
       string = 'User ^C interrupt'
    else
       string = 'residual'
    endif
    write(chain,104) 'Stopped by ',trim(string),niter,bruit(1),limit
    call map_message(seve%i,rname,chain)
    do is=1,ns
       write(chain,105) '#',is,' Ncomp ',ncase(is),' Flux ',fluxes(is)
       call map_message(seve%i,rname,chain)
    enddo
    !
    ! Done: RESTORATION Process now
    clean = 0.0
    !
    ! If CCT component flux are not scaled, use the Kernel as they are
    ! If they are scaled,  normalize them to 1 back again...
    !
    ! Here they are NOT scaled
    !
    write(chain,'(A,1PG11.4)') 'Cleaned flux ',flux
    call map_message(seve%i,rname,chain)
    do i=1,niter
       value = tcc(i)%value
       kx = tcc(i)%ix
       ky = tcc(i)%iy
       is = tcc(i)%type
       if (is.eq.1) then
          clean (kx,ky) = clean(kx,ky) + value
       else
          call add_kernel (clean,nx,ny,value,kx,ky,mk,nker(is),kernel(:,:,is))
       endif
    enddo
    !
    ! Final residual
    cdata = cmplx(clean,0.0)
    ndim = 2
    nn(1) = nx
    nn(2) = ny
    call fourt(cdata,nn,ndim,-1,1,wfft)
    cdata = cdata*tfbeam            ! Complex by Real multiplication
    call fourt(cdata,nn,ndim,1,1,wfft)
    resid = dirty-real(cdata)
    !
    ! Convolution with clean beam is done outside
    return
    !
101 format(i6,i4,i4,' [',1pg11.4,'] ',1pg11.4,2x,1pg11.4,'  = ',1pg11.4)
102 format(i6,i4,i4,2x,1pg11.4,' [',1pg11.4,'] ',1pg11.4,'  = ',1pg11.4)
103 format(i6,i4,i4,2x,1pg11.4,2x,1pg11.4,' [',1pg11.4,'] = ',1pg11.4)
104 format(a,a,i6,1pg11.4,1x,1pg11.4)
105 format(a,i1,a,i5,a,1pg11.4)
  end subroutine major_multi
end module clean_cycle_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_uvsym_command(line,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvsym_command
  use wifisyn_cube_buffer
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  character(len=*), parameter :: rname='UVSYM/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
!  call wifisyn_uvsym_check_wifi(wifi,error)
!  if (error) return
  call wifisyn_uvsym_check_visi(visi,error)
  if (error) return
  !
end subroutine wifisyn_uvsym_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_uvsym_check_wifi(wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvsym_check_wifi
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  integer :: ic,nc
  integer :: ix,jx,nx
  integer :: iy,jy,ny
  integer :: iu,ju,nu
  integer :: iv,jv,nv,mv
  complex :: complx1,complx2
  character(len=*), parameter :: rname='CHECK/WIFI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nc = wifi%cub%nc
  nx = wifi%cub%nx
  ny = wifi%cub%ny
  nu = wifi%cub%nu
  nv = wifi%cub%nv
  mv = nv/2
  if (wifi%uvkind) then
     if (wifi%xykind) then
        call wifisyn_message(seve%i,rname,'Checking hermitian symmetry of wifi XYUV space')
        do iv=mv+1,nv
           jv = nv+2-iv
           do iu=2,nu
              ju = nu+2-iu
              do iy=1,ny
                 jy = ny+2-iy
                 do ix=1,nx
                    jx = nx+2-ix
                    do ic=1,nc
                       complx1 = wifi%cub%val(ic,ix,iy,iu,iv)
                       complx2 = conjg(wifi%cub%val(ic,jx,jy,ju,jv))
                       wifi%cub%val(ic,ix,iy,iu,iv) = complx1-complx2
                       wifi%cub%val(ic,jx,jy,ju,jv) = complx1-complx2
                    enddo ! ic
                 enddo ! ix
              enddo ! iy
           enddo ! iu
        enddo ! iv
     else
        call wifisyn_message(seve%i,rname,'Checking hermitian symmetry of wifi UV space')
        do iv=mv+1,nv
           jv = nv+2-iv
           do iu=2,nu
              ju = nu+2-iu
              do iy=1,ny
                 do ix=1,nx
                    do ic=1,nc
                       complx1 = wifi%cub%val(ic,ix,iy,iu,iv)
                       complx2 = conjg(wifi%cub%val(ic,ix,iy,ju,jv))
                       wifi%cub%val(ic,ix,iy,iu,iv) = complx1-complx2
                       wifi%cub%val(ic,ix,iy,ju,jv) = complx1-complx2
                    enddo ! ic
                 enddo ! ix
              enddo ! iy
           enddo ! iu
        enddo ! iv
     endif
  else
     call wifisyn_message(seve%i,rname,'Checking real character of wifi UV space')
  endif
  !
end subroutine wifisyn_uvsym_check_wifi
!
subroutine wifisyn_uvsym_check_visi(visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvsym_check_visi
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(visi_t), intent(inout) :: visi
  logical,      intent(inout) :: error
  !
  integer :: ic,nc
  integer :: iu,ju,nu
  integer :: iv,jv,nv,mv
  complex :: complx1,complx2
  character(len=*), parameter :: rname='CHECK/VISI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nc = visi%cub%nc
  nu = visi%cub%nx
  nv = visi%cub%ny
  mv = nv/2
  if (visi%uvkind) then
     call wifisyn_message(seve%i,rname,'Checking hermitian symmetry of visi cube')
     do iv=mv+1,nv
        jv = nv+2-iv
        do iu=2,nu
           ju = nu+2-iu
           do ic=1,nc
              complx1 = visi%cub%val(iu,iv,ic)
              complx2 = conjg(visi%cub%val(ju,jv,ic))
              visi%cub%val(iu,iv,ic) = complx1-complx2
              visi%cub%val(ju,jv,ic) = complx1-complx2
           enddo ! ic
       enddo ! iu
     enddo ! iv
  else
     call wifisyn_message(seve%i,rname,'Checking real character of visi cube')
  endif
  !
end subroutine wifisyn_uvsym_check_visi
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_buffers
  use mapping_types
  use clean_types
  use cct_types
  !------------------------------------------------------------------------
  ! Deconvolution arrays
  !------------------------------------------------------------------------
  !
  public :: clean_buffer
  public :: clean_user,clean_prog
  public :: niter_listsize,niter_list
  public :: ares_listsize,ares_list
  !
  public :: clean,resid,mask,cct
  public :: d_list,d_mask,tcc
  private
  !
  ! User part
  type(clean_par), target :: clean_prog,clean_user
  !
  integer :: niter_listsize=0
  integer, allocatable :: niter_list(:)
  !
  integer :: ares_listsize=0
  real, allocatable :: ares_list(:)
  !
  type clean_buffer_user_t
   contains
     procedure, public :: init         => clean_buffer_user_init
     procedure, public :: sicdef       => clean_buffer_user_sicdef
     procedure, public :: get_stopping => clean_buffer_user_get_stopping
  end type clean_buffer_user_t
  type(clean_buffer_user_t) :: clean_buffer
  !
  ! Prog part
  type(mapping_3d_t), target, save :: clean ! Clean cube
  type(mapping_3d_t), target, save :: resid ! Residual cube
  type(mapping_3d_t), target, save :: mask  ! Input mask cube, #0 mask
  type(mapping_3d_t), target, save :: cct   ! Clean component table
  !
  integer, allocatable, target, save :: d_list(:)     ! List of selected pixels
  logical, allocatable, target, save :: d_mask(:,:)   ! Logical mask for pixel selection
  type(cct_par), allocatable,   save :: tcc(:)        ! Clean component list
  !
contains
  !
  subroutine clean_buffer_user_init(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(clean_buffer_user_t), intent(out)   :: user
    logical,                    intent(inout) :: error
    !
    call clean_user%init(error)
    if (error) return
    !
    call gildas_null(clean%head)
    call gildas_null(resid%head)  
    call gildas_null(mask%head)
    call gildas_null(cct%head)
  end subroutine clean_buffer_user_init
  !
  subroutine clean_buffer_user_sicdef(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(clean_buffer_user_t), intent(inout) :: user
    logical,                    intent(inout) :: error
    !
    call clean_user%sicdef(error)
    if (error) return
    !
    call sic_defstructure('FITTED',.true.,error)
    if (error) return
    call sic_def_real('FITTED%MAJOR',clean_prog%major,0,0,.true.,error)
    if (error) return
    call sic_def_real('FITTED%MINOR',clean_prog%minor,0,0,.true.,error)
    if (error) return
    call sic_def_real('FITTED%ANGLE',clean_prog%angle,0,0,.true.,error)
    if (error) return
  end subroutine clean_buffer_user_sicdef
  !
  subroutine clean_buffer_user_get_stopping(user,miter,ares,iplane)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(clean_buffer_user_t), intent(inout) :: user
    integer,                    intent(inout) :: miter
    real,                       intent(inout) :: ares
    integer,                    intent(in)    :: iplane
    !
    if (iplane.ge.1 .and. iplane.le.niter_listsize) then
       miter = niter_list(iplane)
    endif
    if (iplane.ge.1 .and. iplane.le.ares_listsize) then
       ares = ares_list(iplane)
    endif
  end subroutine clean_buffer_user_get_stopping
end module clean_buffers
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_focus(error)
  !---------------------------------------------------------------------
  !     Write the Focus SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_focus
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (FocusRow) :: fRow
  type (FocusOpt) :: fOpt
  type (FocusKey) :: fKey
  !$$$      integer sdm_addFocusRow, ireturn
  integer ia
  logical doIt
  character, parameter ::  sdmTable*8='Focus'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting ...')
  call allocFocusRow(fRow, error)
  if (error) return
  call allocFocusOpt(fRow, fOpt, error)
  if (error) return
  !
  ! Use only the first point of not a focus measurement
  if (.not. r_presec(scanning_sec) .or. r_scaty.ne.1) then
    doIt = dh_dump.eq.1
  else
    doIt = .true.
  endif
  if (.not. doIt) return
  ! open-ended interval
  fKey%timeInterval = ArrayTimeInterval(time_Interval(1),-1)
  !!fKey%feedId = feed_Id
  ! now do it.
  !      call sdmMessage(1,1,sdmTable ,'starting...')
  do ia = 1, r_nant
    fRow%focusTracking = .true.
    ! x and y not tracked in Bure data...
!!!     fRow%xFocusPosition = 0.
!!!     fRow%yFocusPosition = 0.
!!!     fRow%zFocusPosition = r_corfoc(ia)/1000.
    fOpt%measuredFocusPosition = (/ 0., 0., r_corfoc(ia)/1000. /)
!!!     fRow%xFocusOffset = 0.
!!!     fRow%yFocusOffset = 0.
!!!     fRow%zFocusOffset = dh_offfoc(ia)/1000.
    fRow%FocusOffset = (/ 0., 0., dh_offfoc(ia)/1000. /)
    fKey%antennaId = antenna_Id(ia)
    ! not meaningful.
    fRow%focusModelId = focusmodel_id(ia)
    call addFocusRow(fKey, fRow, error)
    if (error) return
    call addFocusMeasuredFocusPosition(fKey, fOpt, error)
    if (error) return    
  !
  enddo
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_focus
!---------------------------------------------------------------------
subroutine get_sdm_focus(first,error)
  !---------------------------------------------------------------------
  !     Read the Focus SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_focus
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error, first, present
  ! Local
  type (FocusRow) :: fRow
  type (FocusKey) :: fKey
  type (FocusOpt) :: fOpt
  !$$$      integer sdm_addFocusRow, ireturn
  integer ia
  logical doIt
  character, parameter ::  sdmTable*8='Focus'
  real :: saved_corfoc(mnant), saved_offfoc(mnant)
  save saved_corfoc, saved_offfoc
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting ...')
  !
  call allocFocusRow(fRow, error)
  if (error) return
  call allocFocusOpt(fRow, fOpt, error)
  if (error) return

  fKey%timeInterval = ArrayTimeInterval(time_Interval(1)   &
    ,time_Interval(2)-1)
  !!fKey%feedId = feed_Id
  ! now do it.

  do ia = 1, r_nant
    fKey%antennaId = antenna_Id(ia)
    call getFocusRow(fKey, fRow, error)
    if (error) then
      r_corfoc(ia)  = saved_corfoc(ia)
      dh_offfoc(ia) = saved_offfoc(ia) 
      
      error = .false.
      call sdmMessage(8,3,sdmTable, 'Missing Focus table row.')
    else
      ! x and y not tracked in Bure data...
      call getFocusMeasuredFocusPosition(fKey, fOpt, present, error)
      if (error) return
      if (present) then
        r_corfoc(ia)  = fOpt%MeasuredFocusPosition(3)*1000.d0
        dh_offfoc(ia) = fRow%FocusOffset(3)*1000.d0
      else
        r_corfoc(ia)  = 0
        dh_offfoc(ia) = 0 
      endif
      saved_corfoc(ia) = r_corfoc(ia)
      saved_offfoc(ia) = dh_offfoc(ia)
    endif
  !         print *, r_scan, ia, r_corfoc(ia) , dh_offfoc(ia)
  enddo
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
!99 error = .true.
end subroutine get_sdm_focus
!---------------------------------------------------------------------

!-----------------------------------------------------------------------
! Support file for command PERSPECTIVE
!-----------------------------------------------------------------------
module greg_hautbas
  !---------------------------------------------------------------------
  ! Support module
  !---------------------------------------------------------------------
  logical :: lower      ! /LOWER is present
  logical :: vert_flag  ! /VERTICAL is present
end module greg_hautbas
!
module greg_nxtv1
  integer, parameter :: nn=3000
  integer :: kk,ll
  real :: xx(nn),yy(nn)
end module greg_nxtv1
!
subroutine threed (line,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>threed
  use greg_axes
  use greg_hautbas
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command
  !
  ! PERSPECTIVE [Altitude Azimuth]
  ! 1           [/FACTOR factor offset]
  ! 2           [/LOWER]
  ! 3           [/LINES]
  ! 4           [/STEP nx ny]
  ! 5           [/AXES Xmin Xmax Ymin Ymax]
  ! 6           [/CENTER]
  ! 7           [/VERTICAL Vmin Vmax]
  !
  ! 3D perspective plot, define the projective transformation
  !
  ! ALTitude      : degrees
  ! AZImuth       : degrees
  ! XLEN and YLEN : Length of X and Y axes (cf SET LOCATION)
  ! XOFF and YOFF : Origin position
  ! ZFACtor       : Conversion factor from Z to physical units
  ! ZOFF          : Origine offset along Z (physical units)
  !---------------------------------------------------------------------
  character(len=*) :: line          ! Command line               Input
  logical :: error                  ! Logical error flag         Output
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='PERSPECTIVE'
  integer :: l
  real*4 :: xlen,ylen,xoff,yoff,alt,az,goff,azi
  real*4 :: zfac,zoff,gxo1,gxo2,gyo1,gyo2,factor
  real*4 :: wsize,aaz,yoffset
  integer :: ier,nqx,nqy,nstx,nsty,ix1,ix2,ix3,iy1,iy2,iy3
  real(kind=4), pointer :: swdata(:,:)
  real(kind=4), allocatable :: xwork(:),ywork(:)
  real(kind=4), allocatable :: zdata(:,:)
  logical :: doswap
  real :: blnk3d,rcblank,reblank
  !
  save alt,az,factor,goff
  ! Data
  data alt /30./, az/45./, factor/1./, goff/0./
  ! Code
  ! Check whether one can do something
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%e,rname,'No map loaded')
    error = .true.
    return
  endif
  ! Get a R4 blanking value
  rcblank = cblank
  reblank = eblank
  !
  ! Define size approximately the one of box
  wsize = 0.8
  goff  = 0.0
  !
  ! Set up parameters
  lower = sic_present(2,0)
  vert_flag = sic_present(7,0)
  call sic_r4 (line,0,1,alt,.false.,error)
  if (error) return
  call sic_r4 (line,0,2,az,.false.,error)
  if (error) return
  call sic_r4 (line,1,1,factor,.false.,error)
  if (error) return
  call sic_r4 (line,1,2,goff,.false.,error)
  if (error) return
  !
  ! If /CENTER option, change size for a square box
  if (sic_present(6,0)) then
    aaz = abs(az)
    if (aaz.le.45) then
      wsize=(1.5+0.1*exp(-aaz))/2.5
    elseif (aaz.le.135) then
      wsize=(1.5+0.1*exp(-abs(aaz-90.)))/2.5
    elseif (aaz.le.225) then
      wsize=(1.5+0.1*exp(-abs(aaz-180.)))/2.5
    elseif (aaz.le.315) then
      wsize=(1.5+0.1*exp(-abs(aaz-270.0)))/2.5
    endif
    ! Change offset also
    yoffset=((90.0-abs(alt))/20.)*(gy2-gy1)/20.0
    if (abs(alt).le.90.0) then
      goff=goff-yoffset
    elseif (abs(alt).le.180.0) then
      goff=goff+yoffset
    endif
  endif
  xlen = wsize*(gx2-gx1)
  ylen = wsize*(gy2-gy1)
  !
  ! Compute Z scaling factor
  if (.not.sic_present(7,2)) then
    call rgextr (0,zmin,zmax,rg%data,rcblank,reblank,.false.)
  endif
  if (vert_flag) then
    call sic_r4 (line,7,1,zmin,.false.,error)
    if (error) return
    call sic_r4 (line,7,2,zmax,.false.,error)
    if (error) return
  endif
  if (zmax-zmin.gt.0.0) then
    zfac = ylen*factor/(zmax-zmin)/1.5
  else
    zfac = 1.0
  endif
  zoff = -zmin
  !
  ! Axis bounds
  xl1=rg%xval+(1.0d0-rg%xref)*rg%xinc   ! Pas 0.5 comme dans RGMAP ?
  xl2=rg%xval+(rg%nx-rg%xref)*rg%xinc      ! Pas NX+0.5 comme dans RGMAP ?
  yl2=rg%yval+(1.0d0-rg%yref)*rg%yinc
  yl1=rg%yval+(rg%ny-rg%yref)*rg%yinc
  ! Plot axe information. Logical DOAXES used elsewhere, not here.
  if (sic_present(5,0)) then
    call sic_r4 (line,5,1,xl1,.false.,error)
    if (error) return
    call sic_r4 (line,5,2,xl2,.false.,error)
    if (error) return
    call sic_r4 (line,5,4,yl1,.false.,error)
    if (error) return
    call sic_r4 (line,5,3,yl2,.false.,error)
    if (error) return
  endif
  !
  if (.not.sic_present(3,0)) then
    ! No /LINES option, use perspective with both line directions
    !
    ! Swap image if needed
    if ( (gux2-gux1)*sign(1.d0,rg%xinc).gt.0) then
      ix1 = rg%nx
      ix2 = 1
      ix3 = -1
      doswap = .true.
    else
      ix1 = 1
      ix2 = rg%nx
      ix3 = 1
      doswap = .false.
    endif
    if ( (guy2-guy1)*sign(1.d0,rg%yinc).gt.0) then
      iy1 = 1
      iy2 = rg%ny
      iy3 = 1
    else
      iy1 = rg%ny
      iy2 = 1
      iy3 = -1
      doswap = .true.
    endif
    !
    ! /STEP option : load subset of map in buffer
    if (sic_present(4,0)) then
      call sic_i4 (line,4,2,nsty,.true.,error)
      if (error) return
      call sic_i4 (line,4,1,nstx,.true.,error)
      if (error) return
      nstx = max(nstx,1)
      nsty = max(nsty,1)
      if (nstx.ge.rg%nx) then
        call greg_message(seve%e,rname,'Step in X too large')
        error = .true.
        return
      endif
      if (nsty.ge.rg%ny) then
        call greg_message(seve%e,rname,'Step in Y too large')
        error = .true.
        return
      endif
      nqx = rg%nx/nstx
      if (nqx*nstx.ne.rg%nx) nqx=nqx+1
      nqy = rg%ny/nsty
      if (nqy*nsty.ne.rg%ny) nqy=nqy+1
      ix3 = nstx*ix3
      iy3 = nsty*iy3
      doswap = .true.
    else
      nqx = rg%nx
      nqy = rg%ny
    endif
    !
    ! Get work space
    l = 2*min(nqx,nqy)+1
    allocate(xwork(l),ywork(l),stat=ier)
    if (failed_allocate(rname,'xwork and ywork buffers',ier,error))  return
    !
    ! Get swap area
    if (doswap) then
      allocate(swdata(nqx,nqy),stat=ier)
      if (failed_allocate(rname,'swdata buffer',ier,error)) then
        deallocate(xwork,ywork)
        return
      endif
      call pswap (rg%data,rg%nx,rg%ny,swdata,nqx,nqy,ix1,ix2,ix3,iy1,iy2,iy3)
    else
      swdata => rg%data
    endif
    ! use a patch for blanked values:
    blnk3d = zmin
    !
    ! Set full page clipping window for this command
    gxo1 = gx1
    gxo2 = gx2
    gyo1 = gy1
    gyo2 = gy2
    gx1  = lx1
    gx2  = lx2
    gy1  = ly1
    gy2  = ly2
    !
    ! Rotate extra 90.0 degrees
    azi = az+90.0
    !
    ! Take care of bottom view
    xoff = 0.5*(gx2+gx1)
    if (lower) then
      alt = -alt
      zfac = -zfac
      yoff = -goff-0.5*(gy2+gy1) + ly2+ly1
    else
      yoff = goff+0.5*(gy2+gy1)
    endif
    call plt3d (swdata,nqx,nqy,xwork,ywork,l,alt,azi,xlen,xoff,ylen,yoff,  &
      zfac,zoff,blnk3d,rcblank,reblank,ier)
    !
    ! Signal any error
    if (ier.ne.0) then
      error = .true.
      if (ier.eq.1) then
        call greg_message(seve%e,rname,'Internal buffer too small')
      elseif (ier.eq.2) then
        call greg_message(seve%e,rname,'Insufficient work space')
      elseif (ier.eq.-1) then
        call greg_message(seve%e,rname,'Aborted by ^C')
      else
        call greg_message(seve%e,rname,'Unknown Error')
      endif
    endif
    !
    ! Reset previous situation
    if (lower) then
      alt = -alt
      zfac = -zfac
      yoff = goff+0.5*(gy2+gy1)
    endif
    gx1  = gxo1
    gx2  = gxo2
    gy1  = gyo1
    gy2  = gyo2
    ! Plot axes After:
    doaxes = sic_present(5,0)
    if (doaxes) then
      call plt3d (swdata,nqx,nqy,xwork,ywork,l,alt,azi,xlen,xoff,ylen,yoff,  &
        zfac,zoff,blnk3d,rcblank,reblank,ier)
      doaxes=.false.
    endif
    if (doswap) then
      deallocate(swdata)
      doswap = .false.
    endif
    deallocate(xwork,ywork)
    !
  else
    ! /LINES option
    nqx  = rg%nx
    nqy  = rg%ny
    if (sic_present(2,0)) then
      call greg_message(seve%e,rname,'/LOWER not implemented for /LINES')
      error = .true.
      return
    endif
    xoff = 0.5*(gx2+gx1)
    yoff = goff+0.5*(gy2+gy1)
    gxo1 = gx1
    gxo2 = gx2
    gyo1 = gy1
    gyo2 = gy2
    gx1  = lx1
    gx2  = lx2
    gy1  = ly1
    gy2  = ly2
    allocate(zdata(nqx,nqy),stat=ier)
    if (failed_allocate(rname,'zdata buffer',ier,error))  return
    zdata(:,:) = rg%data(:,:)
    call zmont(zdata,nqx,1,nqx,1,nqy,xoff,yoff,xlen,ylen,az,alt,zfac)
    deallocate(zdata)
    gx1  = gxo1
    gx2  = gxo2
    gy1  = gyo1
    gy2  = gyo2
  endif
end subroutine threed
!
subroutine pswap (xin,nx,ny,xout,mx,my,ix1,ix2,ix3,iy1,iy2,iy3)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real :: xin(nx,ny)                !
  integer :: mx                     !
  integer :: my                     !
  real :: xout(mx,my)               !
  integer :: ix1                    !
  integer :: ix2                    !
  integer :: ix3                    !
  integer :: iy1                    !
  integer :: iy2                    !
  integer :: iy3                    !
  ! Local
  integer :: i,j,k,l
  !
  l = 0
  do j=iy1,iy2,iy3
    l = l+1
    k = 0
    do i=ix1,ix2,ix3
      k = k+1
      xout(k,l) = xin(i,j)
    enddo
  enddo
end subroutine pswap
!
subroutine plt3d(a,m,n,x,y,l,alt,az,xlen,xoff,ylen,yoff,zfac,zoff,blnk3d,  &
  rgblank,eblank,ier)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>plt3d
  use greg_axes
  !---------------------------------------------------------------------
  ! @ private
  ! 3D plot routine, adapted from SAS-3 routine of same name
  !---------------------------------------------------------------------
  integer :: m     ! Dimensions of data array A
  integer :: n     ! Dimensions of data array A
  real :: a(m,n)   ! Array, represents height of surface as function of location in plane
  integer :: l     ! Length of work arrays, .GE. 2*MIN(M,N)
  real :: x(l)     ! Real work array
  real :: y(l)     ! Real work array
  real :: alt      ! Altitude viewing angle in degrees
  real :: az       ! Azimuth viewing angle in degrees
  real :: xlen     ! Length of unprojected X axis in plot coordinates
  real :: xoff     ! Offset of origin in plot coordinates
  real :: ylen     ! Length of unprojected Y axis in plot coordinates
  real :: yoff     ! Offset of origin in plot coordinates
  real :: zfac     ! Scaling of Z-axis from data units to unprojected plot coordinates
  real :: zoff     ! Offset of Z-origin in plot coordinates
  real :: blnk3d   !
  real :: rgblank  !
  real :: eblank   !
  integer :: ier   ! Returns 0 for no error
  ! Local
  integer :: lmax,iaz,ifirst,istep,ilast,jfirst,jstep,jlast
  integer :: lli,ic,ibeg,lnth,ll,i,jbeg,j,lll
  real :: taz,talt,saz,sal,caz,cal,xsc,ysc
  real :: a1,a2,a3,b1,b2,b3,b4,xx,yy
  !
  logical :: error
  !
  ier = 0
  !
  taz = az*0.0174532925
  talt = alt*0.0174532925
  !
  saz = sin(taz)
  caz = cos(taz)
  sal = sin(talt)
  cal = cos(talt)
  !
  xsc = xlen/float(n-1)
  ysc = ylen/float(m-1)
  a1 = caz*xsc
  a2 = -saz*ysc
  a3 = xoff-0.5*(a1*float(n+1)+a2*float(m+1))
  b1 = saz*sal*xsc
  b2 = caz*sal*ysc
  b3 = zfac*cal
  b4 = b3*zoff+yoff-0.5*(b1*float(n+1)+b2*float(m+1))
  !
  ! Plot the axes if needed
  if (doaxes) then
    call sub_axes(a,m,n,a3,a2,a1,b1,b2,b3,b4,saz,caz,blnk3d)
    doaxes = .false.
    return
  endif
  error = .false.
  call gr_segm('PERSP',error)
  !
  ! Is buffer large enough ?
  lmax = 2*min(m,n)
  if (l.lt.lmax) then
    ier = 2
    return
  endif
  !
  iaz = 1
  if (a1 .le. 0.0) iaz = iaz+1
  if (a2 .le. 0.0) iaz = iaz+2
  !
  if (iaz.eq.2 .or. iaz.eq.4) then
    ifirst = m
    istep = -1
    ilast = 1
  else
    ifirst = 1
    istep = 1
    ilast = m
  endif
  !
  if (iaz.eq.1 .or. iaz.eq.2) then
    jfirst = n
    jstep = -1
    jlast = 1
  else
    jfirst = 1
    jstep = 1
    jlast = n
  endif
  !
  if (iaz.eq.1 .or. iaz.eq.4) then
    lli = -1
  else
    lli = 1
  endif
  !
  ic = 0
  ibeg = ifirst+istep
  !
  ! OK ready to go
  lll = 0
70 continue
  lnth = min(2*iabs(ibeg-ifirst)+1,lmax)
  if (lli.eq.-1) then
    ll = lnth+1
  else
    ll = 0
  endif
  i = ibeg
  j = jfirst
  xx = float(j)
  yy = float(i)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll=lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
80 i = i-istep
  yy = float(i)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll = lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
  if (j.eq.jlast) goto 85
  j = j+jstep
  xx = float(j)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll = lll+1
  else
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
  if (i.ne.ifirst) goto 80
  !
  !85    CALL NXTVU(IC,X,Y,LNTH,IER)
85 continue
  if (lll.gt.0) then
    if (lli.eq.-1) then
      call nxtvu(ic,x(ll),y(ll),lll,ier)
    else
      call nxtvu(ic,x(ll-lll+1),y(ll-lll+1),lll,ier)
    endif
    if (ier.ne.0) return
  endif
  lll=0
  ic = 1
  if (ibeg.eq.ilast) goto 90
  ibeg = ibeg+istep
  goto 70
  !
90 jbeg = jfirst
100 lnth = min(2*iabs(jbeg-jlast)+1,lmax)
  if (lli.eq.-1) then
    ll = lnth+1
  else
    ll = 0
  endif
  i = ilast
  j = jbeg
  xx = float(j)
  yy = float(i)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll=lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
110 j = j+jstep
  xx = float(j)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll=lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
  if (i.eq.ifirst) goto 120
  i = i-istep
  yy = float(i)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll=lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
  if (j.ne.jlast) goto 110
  !
  !120   CALL NXTVU(1,X,Y,LNTH,IER)
120 continue
  if(lll.gt.0) then
    if (lli.eq.-1) then
      call nxtvu(ic,x(ll),y(ll),lll,ier)
    else
      call nxtvu(ic,x(ll-lll+1),y(ll-lll+1),lll,ier)
    endif
    if (ier.ne.0) return
  endif
  lll=0
  jbeg = jbeg+jstep
  if (jbeg.eq.jlast) goto 999
  goto 100
  !
999 continue
  !
  call gtsegm_close(error)
  !
end subroutine plt3d
!
subroutine nxtvu(ic,x,y,n,ier)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>nxtvu
  use greg_kernel
  use greg_nxtv1
  use greg_hautbas
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Find the next vector visible and plot it.
  !---------------------------------------------------------------------
  integer :: ic           ! Integer code                         Input
  integer :: n            ! Length of X and Y arrays             Input
  real :: x(n)            ! Work array
  real :: y(n)            ! Work array
  integer :: ier          ! Error code                           Output
  ! Local
  integer :: i,j,jj,ii,iov0,isw,iov1
  real :: ya0,yb0,xl,yl,x0,x1,ya1,yb1,frac,xi,yi
  !
  if (sic_ctrlc()) then
    ier = -1
    return
  endif
  if (n.gt.nn) then
    ier = 1
    return
  endif
  !
  ! First: always visible...
  if (ic.eq.0) then
    ll = nn-n+1
    i = ll
    xx(i) = x(1)
    yy(i) = y(1)
    if (lower) then
      call grelocate(xx(ll),ly2-yy(ll))
    else
      call grelocate(xx(ll),yy(ll))
    endif
    do j = 2,n
      i = i+1
      xx(i) = x(j)
      yy(i) = y(j)
      if (lower) then
        call gdraw(xx(i),ly2-yy(i))
      else
        call gdraw(xx(i),yy(i))
      endif
    enddo
    ier = 0
    return
  endif
  !
  ! Case IC not 0: check what is hidden
  ii = 1
  jj = ll
  kk = 0
  ya0 = y(1)
  yb0 = yy(ll)
  if (x(1).le.xx(ll)) then
    !
    ! X(1) <= X(LL)
    if (lower) then
      call grelocate(x(1),ly2 - ya0)
    else
      call grelocate(x(1),ya0)
    endif
40  call outp(x(ii),y(ii),ier)
    if (ii.eq.n) goto 360
    ii = ii+1
    ya0 = y(ii)
    if (x(ii) .gt. xx(ll)) goto 50
    if (lower) then
      call gdraw(x(ii),ly2 - ya0)
    else
      call gdraw(x(ii),ya0)
    endif
    goto 40
    !
50  ii = ii-1
    xl = x(ii)
    yl = y(ii)
    ya0 = alin(x(ii),x(ii+1),y(ii),y(ii+1),xx(ll))
    x0 = xx(ll)
    if (ya0 .gt. yb0) then
      iov0 = 1
    else
      if (lower) then
        call gdraw(x0,ly2 - ya0)
      else
        call gdraw(x0,ya0)
      endif
      call outp(x0,ya0,ier)
      call outp(x0,yb0,ier)
      iov0 = 0
    endif
    !
    ! X(1) > X(LL)
  else
70  call outp(xx(jj),yy(jj),ier)
    if (jj.eq.nn) goto 380
    jj = jj+1
    yb0 = yy(jj)
    if (x(1).ge.xx(jj)) goto 70
    !
    jj = jj-1
    yb0 = alin(xx(jj),xx(jj+1),yy(jj),yy(jj+1),x(1))
    x0 = x(1)
    if (ya0 .le. yb0) then
      iov0 = 0
    else
      call outp(x0,yb0,ier)
      call outp(x0,ya0,ier)
      xl = x0
      yl = ya0
      iov0 = 1
    endif
  endif
  !
  ! Common block
120 continue
  if (ii.eq.n) goto 300
  if (jj.eq.nn) goto 310
  if (x(ii+1) .le. xx(jj+1)) then
    isw = +1
    ii = ii+1
    x1 = x(ii)
    ya1 = y(ii)
    yb1 = alin(xx(jj),xx(jj+1),yy(jj),yy(jj+1),x1)
  else
    if (xx(jj+1) .ge. x(n)) goto 340
    isw = -1
    jj = jj+1
    x1 = xx(jj)
    ya1 = alin(x(ii),x(ii+1),y(ii),y(ii+1),x1)
    yb1 = yy(jj)
  endif
  if (ya1 .le. yb1) goto 160
  iov1 = 1
  if (iov0.eq.0) goto 170
150 continue
  if (isw.eq.-1) goto 200
  call outp (x1,ya1,ier)
  if (lower) then
    call grelocate(xl,ly2-yl)
    call gdraw(x1,ly2-ya1)
  else
    call grelocate(xl,yl)
    call gdraw(x1,ya1)
  endif
  xl = x1
  yl = ya1
  goto 200
160 iov1 = 0
  if (iov0.eq.0) goto 190
170 frac = (yb0-ya0)/(ya1-yb1+yb0-ya0)
  xi = (x1-x0)*frac+x0
  yi = (ya1-ya0)*frac+ya0
  call outp(xi,yi,ier)
  if (iov0.eq.0) goto 180
  if (lower) then
    call grelocate(xl,ly2 - yl)
    call gdraw(xi,ly2 - yi)
  else
    call grelocate(xl,yl)
    call gdraw(xi,yi)
  endif
  xl = xi
  yl = yi
  goto 190
180 xl = xi
  yl = yi
  goto 150
  !
190 continue
  if (isw.eq.+1) goto 200
  call outp(xx(jj),yy(jj),ier)
200 continue
  if (ier.ne.0) return
  x0 = x1
  ya0 = ya1
  yb0 = yb1
  iov0 = iov1
  goto 120
  !
  ! Exit tests
310 x1 = xx(nn)
  ya1 = alin(x(ii),x(ii+1),y(ii),y(ii+1),x1)
  yb1 = yy(nn)
  if (ya1 .gt. yb1) goto 320
  call outp(x1,yb1,ier)
  call outp(x1,ya1,ier)
  if (lower) then
    call grelocate(x1,ly2 - ya1)
  else
    call grelocate(x1,ya1)
  endif
  goto 330
380 ii = 1
320 continue
  if (lower) then
    call grelocate(x(ii),ly2-y(ii))
  else
    call grelocate(x(ii),y(ii))
  endif
330 if (ii.eq.n) goto 400
  ii = ii+1
  call outp(x(ii),y(ii),ier)
  if (lower) then
    call gdraw(x(ii),ly2-y(ii))
  else
    call gdraw(x(ii),y(ii))
  endif
  goto 330
300 continue
  if (jj.eq.nn) goto 400
340 x1 = x(n)
  ya1 = y(n)
  yb1 = alin(xx(jj),xx(jj+1),yy(jj),yy(jj+1),x1)
  if (ya1 .le. yb1) goto 350
  call outp(x1,ya1,ier)
  call outp(x1,yb1,ier)
  if (lower) then
    call grelocate(xl,ly2 - yl)
    call gdraw(x1,ly2 - ya1)
  else
    call grelocate(xl,yl)
    call gdraw (x1,ya1)
  endif
350 continue
  if (jj.eq.nn) goto 400
  jj = jj+1
  call outp(xx(jj),yy(jj),ier)
  goto 350
360 jj = 0
  goto 350
400 ll = nn-kk+1
  i = ll
  do j = 1,kk
    xx(i) = xx(j)
    yy(i) = yy(j)
    i = i+1
  enddo
end subroutine nxtvu
!
subroutine outp(x,y,ier)
  use greg_nxtv1
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Buffers the vector to keep track of vectors plotted
  !---------------------------------------------------------------------
  real :: x                         !              Input
  real :: y                         !              Input
  integer :: ier                    ! Error code   Output
  ! Local
  real, parameter :: eps=.001
  !
  if (kk.eq.0) then
    kk = 1
    xx(1) = x
    yy(1) = y
  elseif (kk.eq.ll-1) then
    ier = 1
  elseif (abs(xx(kk)-x)+abs(yy(kk)-y) .ge. eps) then
    kk = kk+1
    xx(kk) = x
    yy(kk) = y
  endif
end subroutine outp
!
function alin(x0,x1,y0,y1,x)
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Find the Y coordinate of absissae X along line (X0,Y0)-->(X1,Y1)
  !---------------------------------------------------------------------
  real :: alin          ! Y coordinate of point                 Output
  real :: x0            ! X coordinate of start point           Input
  real :: x1            ! X coordinate of end point             Input
  real :: y0            ! Y coordinate of start point           Input
  real :: y1            ! Y coordinate of end point             Input
  real :: x             ! X coordinate of point                 Input
  !
  if (x0.ne.x1) then
    alin = (x-x0)*(y1-y0)/(x1-x0)+y0
  elseif (y1.gt.y0) then
    alin = y1
  else
    alin = y0
  endif
end function alin
!
subroutine sub_axes(a,m,n,a3,a2,a1,b1,b2,b3,b4,saz,caz,blnk3d)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>sub_axes
  use greg_pen
  use greg_axes
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Cette routine trace les axes sur la vue en perspective lorsque
  ! l'option /AXES est presente dans la commande PERSPECTIVE.
  !---------------------------------------------------------------------
  integer :: m                      !
  integer :: n                      !
  real :: a(m,n)                    !
  real :: a3                        !
  real :: a2                        !
  real :: a1                        !
  real :: b1                        !
  real :: b2                        !
  real :: b3                        !
  real :: b4                        !
  real :: saz                       !
  real :: caz                       !
  real :: blnk3d                    !
  ! Local
  real :: zz,ex1,ey1,ex2,ey2,ex3,ey3,ex4,ey4
  real :: eyy1,eyy2,eyy3,eyy4,zmin1,zmin2,zmin3,zmin4
  real :: zmax1,zmax2,zmax3,zmax4, aval
  real :: alpha1,beta1,alpha2,beta2,alpha3,beta3,alpha4,beta4
  real :: zlx1,zlx2,zlx3,zlx4, zly1,zly2,zly3,zly4, zlzz
  real, parameter :: pi=3.141592653
  logical :: error
  !
  ! Base thickness is proportional to ZMIN-ZMAX
  zz  =  zmin-0.1*(zmax-zmin)
  !
  ! The 8 corners of the box. Patched for INFs and NaNs
  ex1 = a3+a2+a1
  ey1 = b1+b2+b4+b3*a(1,1)
  if ((ey1.eq.ey1+1) .or. .not.(ey1.eq.ey1))  ey1=b1+b2+b4+b3*blnk3d
  ex3 = a1*n+a2*m+a3
  ey3 = b1*n+b2*m+b3*a(m,n)+b4
  if ((ey3.eq.ey3+1) .or. .not.(ey3.eq.ey3))  ey3=b1*n+b2*m+b3*blnk3d+b4
  ex2 = a1*n+a2+a3
  ey2 = b1*n+b2+b4+b3*a(1,n)
  if ((ey2.eq.ey2+1) .or. .not.(ey2.eq.ey2))  ey2=b1*n+b2+b4+b3*blnk3d
  ex4 = a1+a2*m+a3
  ey4 = b1+b2*m+b3*a(m,1)+b4
  if ((ey4.eq.ey4+1) .or. .not.(ey4.eq.ey4))  ey4=b1+b2*m+b3*blnk3d+b4
  eyy4 = b1+b2*m+b3*zz+b4
  eyy3 = b1*n+b2*m+b4+b3*zz
  eyy2 = b1*n+b2+b4+b3*zz
  eyy1 = b1+b2+b4+b3*zz
  !
  ! Define vertical axis
  zmin1 = b1+b2+b4+b3*zmin
  zmin2 = b1*n+b2+b4+b3*zmin
  zmin3 = b1*n+b2*m+b4+b3*zmin
  zmin4 = b1+b2*m+b4+b3*zmin
  zmax1 = b1+b2+b4+b3*zmax
  zmax2 = b1*n+b2+b4+b3*zmax
  zmax3 = b1*n+b2*m+b4+b3*zmax
  zmax4 = b1+b2*m+b4+b3*zmax
  zlzz  = zmax1-zmin1
  !
  ! Compute angles of axes
  if (ex1.eq.ex4) then
    alpha1 = 0.0
    beta4  =-90.0
  else
    aval  =  (eyy1-eyy4)/(ex1-ex4)
    alpha1= atan(aval)*180.0/pi
    beta4 =-atan(-aval)*180.0/pi
  endif
  if (ex3.eq.ex4) then
    alpha2 = 0.0
    beta1  =-90.0
  else
    aval  =  (eyy4-eyy3)/(ex4-ex3)
    alpha2= atan(aval)*180.0/pi
    beta1 =-atan(-aval)*180.0/pi
  endif
  if (ex3.eq.ex2) then
    alpha3=0.0
    beta2 = -90.
  else
    aval  =  (eyy3-eyy2)/(ex3-ex2)
    alpha3=atan(aval)*180./pi
    beta2 =-atan(-aval)*180./pi
  endif
  if (ex2.eq.ex1) then
    alpha4= 0.0
    beta3 =-90.
  else
    aval  = (eyy2-eyy1)/(ex2-ex1)
    alpha4= atan(aval)*180./pi
    beta3 =-atan(-aval)*180./pi
  endif
  !
  ! Compute length of axes
  zlx1 = sqrt((ex1-ex4)**2+(eyy1-eyy4)**2)
  zlx2 = sqrt((ex4-ex3)**2+(eyy4-eyy3)**2)
  zlx3 = sqrt((ex3-ex2)**2+(eyy3-eyy2)**2)
  zlx4 = sqrt((ex2-ex1)**2+(eyy2-eyy1)**2)
  zly1 = zlx2
  zly2 = zlx3
  zly3 = zlx4
  zly4 = zlx1
  !
  ! Plot the corners
  error = .false.
  call gr_segm('3BOX',error)
  if (saz.le.0.0) then
    if (caz.le.0.0) then
      call permute(xl1,xl2)
      call echange(xl1,xl2,yl1,yl2)
      call grline(ex4,ey4,ex4,eyy4)
      call grline(ex2,ey2,ex2,eyy2)
      call grline(ex3,ey3,ex3,eyy3)
      call echange(xl1,xl2,yl1,yl2)
      call permute(xl1,xl2)
    else
      call permute(xl1,xl2)
      call permute(yl1,yl2)
      call grline(ex1,ey1,ex1,eyy1)
      call grline(ex3,ey3,ex3,eyy3)
      call grline(ex2,ey2,ex2,eyy2)
      call permute(xl1,xl2)
      call permute(yl1,yl2)
    endif
  else
    if (caz.ge.0.0) then
      call permute(yl1,yl2)
      call echange(xl1,xl2,yl1,yl2)
      call grline(ex4,ey4,ex4,eyy4)
      call grline(ex2,ey2,ex2,eyy2)
      call grline(ex1,ey1,ex1,eyy1)
      call echange(xl1,xl2,yl1,yl2)
      call permute(yl1,yl2)
    else
      call grline(ex3,ey3,ex3,eyy3)
      call grline(ex1,ey1,ex1,eyy1)
      call grline(ex4,ey4,ex4,eyy4)
    endif
  endif
  call gtsegm_close(error)
  if (error)  return
  !
  ! Now the real axis
  if (saz.le.0.0) then
    if (caz.le.0.0) then
      call permute(xl1,xl2)
      call echange(xl1,xl2,yl1,yl2)
      call traxes(alpha2,beta2,ex3,eyy3,zlx2,zly2,ex2,eyy2,ex4,eyy4,zmin2,zlzz)
      call echange(xl1,xl2,yl1,yl2)
      call permute(xl1,xl2)
    else
      call permute(xl1,xl2)
      call permute(yl1,yl2)
      call traxes(alpha3,beta3,ex2,eyy2,zlx3,zly3,ex1,eyy1,ex3,eyy3,zmin1,zlzz)
      call permute(xl1,xl2)
      call permute(yl1,yl2)
    endif
  else
    if (caz.ge.0.0) then
      call permute(yl1,yl2)
      call echange(xl1,xl2,yl1,yl2)
      call traxes(alpha4,beta4,ex1,eyy1,zlx4,zly4,ex4,eyy4,ex2,eyy2,zmin4,zlzz)
      call echange(xl1,xl2,yl1,yl2)
      call permute(yl1,yl2)
    else
      call traxes(alpha1,beta1,ex4,eyy4,zlx1,zly1,ex3,eyy3,ex1,eyy1,zmin3,zlzz)
    endif
  endif
  !
end subroutine sub_axes
!
subroutine traxes (alpha,beta,ex,exx,zlxx,zlyy,ey,eyy,ez,ezz,vz,zlzz)
  use greg_interfaces, except_this=>traxes
  use greg_axes
  use greg_xyz
  use greg_hautbas
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Cette routine est utilisee par la routine SUB_AXES pour afficher ces
  ! axes
  !---------------------------------------------------------------------
  real :: alpha              ! Orientation de l'axe des abscisses
  real :: beta               ! Orientation de l'axe des ordonnees
  real :: ex                 ! abscisse du coin apparaissant au centre
  real :: exx                ! ordonnee du coin apparaissant au centre
  real :: zlxx               ! longueur de l'axe des abscisses
  real :: zlyy               ! longueur de l'axe des ordonnees
  real :: ey                 ! abscisse du coin apparaissant a gauche
  real :: eyy                ! ordonnee du coin apparaissant a gauche
  real :: ez                 ! abscisse du coin apparaissant a droite
  real :: ezz                ! ordonnee du coin apparaissant a droite
  real :: vz                 ! ordonnee du bas de l'axe vertical
  real :: zlzz               ! longueur de l'axe des donnees
  ! Local
  character(len=4) :: atype
  character(len=1) :: ochar
  character(len=120) :: line
  real :: esp,angsav1,angsav2
  real, parameter :: pi=3.141592653
  !
  call inqang(angsav1,angsav2)
  esp = abs(ez-ey)
  !
  ! X Axis : check visibility and plot
  if ((abs(ez-ex).ge.0.5) .or. (abs(ezz-exx).ge.0.2)) then
    call setang(alpha,angsav2)
    if (alpha.gt.60.0) then
      ochar = 'O'
    else
      ochar = 'P'
    endif
    write (line,100) ' XL ',xl1,xl2,ex,exx,zlxx,ochar
    call gr_exec1(line)
    if (gr_error()) goto 99
    !
    ! Text below X axis
    xposx = ex+0.5*(ez-ex)+(.5+esp/11.0)*sin(pi*alpha/180.0)
    xposy = exx+0.5*(ezz-exx)-(.5+esp/11.0)*cos(pi*alpha/180.0)
  endif
  !
  ! Y Axis: Check visibility and plot
  if ((abs(ey-ex).ge.0.5) .or. (abs(eyy-exx).ge.0.2)) then
    if (beta.gt.-60.0) then
      call setang(beta,angsav2)
      atype = ' XL '
      ochar = 'P'
      write(line,100) atype,yl1,yl2,ey,eyy,zlyy,ochar
    else
      !
      call setang(90.0+beta,angsav2)
      atype = ' YL '
      ochar = 'O'
      !
      !            WRITE(LINE,100) ATYPE,YL1,YL2,EY,EYY,ZLYY,OCHAR
      ! Note reverse axis starting from end
      write(line,100) atype,yl2,yl1,ex,exx,zlyy,ochar
    endif
    call gr_exec1(line)
    if (gr_error()) goto 99
    !
    ! Text below Y axis
    yposx=ey+0.5*(ex-ey)-(.5+esp/11.0)*sin(-beta*pi/180.0)
    yposy=exx+0.5*(eyy-exx)-(.5+esp/11.0)*cos(-beta*pi/180.0)
  endif
  !
  ! Z axis if required
  if (vert_flag) then
    call setang(0.0,angsav2)
    write(line,100) ' YL ',zmin,zmax,ey,vz,zlzz,'O'
    call gr_exec1(line)
    if (gr_error()) goto 99
  endif
99 call setang(angsav1,angsav2)
  return
100 format('AXIS',a,2(1x,e15.7),' /LOCATION ',3(1x,f8.2),  &
      ' /TICK OUT /LABEL ',a)
end subroutine traxes
!
subroutine echange (xl1,xl2,yl1,yl2)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real*4 :: xl1                     !
  real*4 :: xl2                     !
  real*4 :: yl1                     !
  real*4 :: yl2                     !
  ! Local
  real*4 :: varint
  !
  varint = xl1
  xl1 = yl1
  yl1 = varint
  varint = xl2
  xl2 = yl2
  yl2 = varint
end subroutine echange
!
subroutine permute (val1,val2)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real*4 :: val1                    !
  real*4 :: val2                    !
  ! Local
  real*4 :: varint
  !
  varint = val1
  val1 = val2
  val2 = varint
end subroutine permute

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_noise
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  use cubemain_range
  use cubemain_windowing
  !
  public :: noise
  private
  !
  type :: noise_comm_t
     type(option_t), pointer :: comm
     type(cubeid_arg_t), pointer :: sig
     type(cubeid_arg_t), pointer :: win
     type(cube_prod_t),  pointer :: noi
     type(option_t), pointer :: mad     
     type(option_t), pointer :: nchan
     type(range_opt_t)       :: range
   contains
     procedure, public  :: register => cubemain_noise_comm_register
     procedure, private :: parse    => cubemain_noise_comm_parse
     procedure, private :: main     => cubemain_noise_comm_main
  end type noise_comm_t
  type(noise_comm_t) :: noise
  !
  type noise_user_t
     type(cubeid_user_t)   :: cubeids           ! Signal and window cubeids
     logical               :: dorange = .false. ! Do range 
     type(range_array_t)   :: range             ! Range(s) to be ignored
     logical               :: domad = .false.   ! Do MAD noise
     character(len=argu_l) :: nchan             ! Number of channels to be used in mad mode
   contains
     procedure, private :: toprog => cubemain_noise_user_toprog
  end type noise_user_t
  !
  type noise_prog_t
     logical               :: domad = .false.
     logical               :: dowin = .false.
     logical               :: doloc = .false.
     integer(kind=chan_k)  :: nchan = 0  ! number of channels to be used
     integer(kind=chan_k)  :: nnois = 0  ! Number of noise estimates
     integer(kind=chan_k)  :: nhalf = 0  ! Half number of used channels
     type(window_array_t)  :: glowin     ! One set of windows for the full index
     type(cube_t), pointer :: locwin     ! Number and positions of windows depend on the spectrum
     type(cube_t), pointer :: sig
     type(cube_t), pointer :: noi
     procedure(cubemain_noise_prog_mad_loop), pointer :: loop => null()
   contains
     procedure, private :: header        => cubemain_noise_prog_header
     procedure, private :: data          => cubemain_noise_prog_data
     procedure, private :: mad_act       => cubemain_noise_prog_mad_act
     procedure, private :: glowin_act   => cubemain_noise_prog_glowin_act
     procedure, private :: locwin_act   => cubemain_noise_prog_locwin_act
     procedure, private :: compute_noise => cubemain_noise_prog_compute_noise
  end type noise_prog_t
  !
contains
  !
  subroutine cubemain_noise_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)  :: line
    logical,          intent(out) :: error
    !
    type(noise_user_t) :: user
    character(len=*), parameter :: rname='NOISE>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call noise%parse(line,user,error)
    if (error) return
    call noise%main(user,error)
    if (error) return
  end subroutine cubemain_noise_command
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_comm_t), intent(inout) :: comm
    logical,             intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='NOISE>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'NOISE','[signalid [windowid]]',&
         'Compute the noise RMS of each spectrum of a cube',&
         'Compute one noise value per spectrum using global or local&
         & spectral windows.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /RANGE defines global signal ranges excluded from noise&
         & estimation.'//strg_cr//&
         '- Without /RANGE, NOISE resolves WINDOW from the second&
         & positional argument (windowid) when provided; otherwise&
         & through standard WINDOW cubeid resolution.'//strg_cr//&
         '- /MAD computes median-absolute-deviation noise and ignores&
         & /RANGE and WINDOW inputs.'//strg_cr//&
         '- /NCHAN sets the number of channels per noise block in both&
         & RMS and /MAD modes.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> NOISE 12co10:cube /RANGE -5 5 km/s'//strg_cr//&
         'CUBE> NOISE 12co10:cube 12co10:window'//strg_cr//&
         'CUBE> NOISE 12co10:cube /NCHAN 31.'//strg_cr//&
         'CUBE> NOISE 12co10:cube /NCHAN 31 /MAD',&
         cubemain_noise_command,&
         noise%comm,error)
    if (error) return
    call incube%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         comm%sig,&
         error)
    if (error) return
    call incube%register(&
         'WINDOWID',&
         'Local spectral range(s) containing signal',&
         'Used only when /RANGE is absent: local per-spectrum windows&
         & are read from this cube (window flag). If omitted, use the&
         & last matching cube (window flag) in the default index (DAG&
         & by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_window],&
         code_read,&
         code_access_speset,&
         comm%win,&
         error)
    if (error) return
    !
    call noise%range%register(&
         'RANGE',&
         'Define global spectral range(s) containing signal',&
         range_is_multiple,error)
    if (error) return
    !
    call cubetools_register_option(&
         'MAD','',&
         'Compute Median Absolute Deviation noise instead of RMS',&
         strg_emp,&
         noise%mad,error)
    if (error) return
    !
    call cubetools_register_option(&
         'NCHAN','nchan',&
         'Number of channels per noise block (RMS and /MAD modes)',&
         strg_emp,&
         noise%nchan,error)
    if (error) return
    call stdarg%register(&
         'nchan',&
         'number of channels',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'NOISE',&
         'Cube of noise estimations',&
         strg_emp,&
         [flag_noise],&
         comm%noi,&
         error)
    if (error) return
  end subroutine cubemain_noise_comm_register
  !
  subroutine cubemain_noise_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! NOISE [signalid [windowid]]
    ! /NCHAN nchan
    ! /RANGE v11 v12 [... [vn1 vn2]] [unit]
    ! /MAD
    !----------------------------------------------------------------------
    class(noise_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(noise_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%mad%present(line,user%domad,error)
    if (error) return
    call cubemain_noise_comm_parse_nchan(line,comm%nchan,1,user%nchan,error)
    if (error) return
    call comm%range%parse(line,user%dorange,user%range,error)
    if (error) return
  end subroutine cubemain_noise_comm_parse
  !
  subroutine cubemain_noise_comm_parse_nchan(line,opt,iarg,nchan,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),      intent(in)    :: line
    type(option_t),        intent(in)    :: opt
    integer(kind=4),       intent(in)    :: iarg
    character(len=argu_l), intent(out)   :: nchan
    logical,               intent(inout) :: error
    !
    logical :: present
    character(len=*), parameter :: rname='NOISE>COMM>PARSE>NCHAN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call opt%present(line,present,error)
    if (error) return
    if (present) then
       call cubetools_getarg(line,opt,iarg,nchan,mandatory,error)
       if (error) return
    else
       nchan = strg_star
    endif
  end subroutine cubemain_noise_comm_parse_nchan
  !
  subroutine cubemain_noise_comm_main(comm,user,error)
    use cubeadm_timing
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_comm_t), intent(in)    :: comm
    type(noise_user_t),  intent(inout) :: user
    logical,             intent(inout) :: error
    !
    type(noise_prog_t) :: prog
    character(len=*), parameter :: rname='NOISE>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_noise_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_user_t), intent(inout) :: user
    class(noise_comm_t), intent(in)    :: comm
    type(noise_prog_t),  intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    logical :: conspb
    integer(kind=chan_k) :: default
    character(len=*), parameter :: rname='NOISE>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    default = 0
    call cubetools_user2prog_resolve_star(user%nchan,default,prog%nchan,error)
    if (error) return
    !
    call cubeadm_get_header(comm%sig,user%cubeids,prog%sig,error)
    if (error) return
    !
    prog%domad = user%domad
    if (user%domad) then
       ! No window searched
       prog%dowin = .false.
    else
       prog%dowin = .true.
       if (user%dorange) then
          ! Define a global window
          prog%doloc = .false.
          ! Ranges are truncated to avoid segfault
          user%range%val(:)%truncate = .true.
          call noise%range%user2prog(prog%sig,user%range,prog%glowin,error)
          if (error) return
       else
          prog%doloc = .true.
          conspb = .false.
          ! Search for a data cube with the definitions of the local windows
          call cubeadm_get_header(comm%win,user%cubeids,prog%locwin,error)
          if (error) return
          call cubetools_consistency_spatial(&
               'Input cube',prog%sig%head,&
               'Window',prog%locwin%head,&
               conspb,error)
          if (error) return
          if (cubetools_consistency_failed(rname,conspb,error)) return
       endif
    endif
    !
    if (prog%domad) then
       prog%loop => cubemain_noise_prog_mad_loop
    else if (prog%dowin) then
       if (prog%doloc) then
          prog%loop => cubemain_noise_prog_locwin_loop
       else
          prog%loop => cubemain_noise_prog_glowin_loop
       endif
    endif
  end subroutine cubemain_noise_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubeadm_clone
    !---------------------------------------------------------------------- 
    ! To deal with edge effects, we cheat on the last frequency segment
    ! that we attribute beyond the original frequency range while we 
    ! always compute the noise inside this range. This should have no 
    ! consequence as the noise should be interpolated in frequency
    ! in later use.
    !----------------------------------------------------------------------
    class(noise_prog_t), intent(inout) :: prog
    type(noise_comm_t),  intent(in)    :: comm
    logical,             intent(inout) :: error
    !
    integer(kind=chan_k) :: in_nchan,nhalf
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='NOISE>PROG>HEADER'
    !
    if ((prog%domad).and.(prog%dowin)) then
       call cubemain_message(seve%e,rname,'Options /RANGE and /MAD are exclusives')
       error = .true.
       return
    else if (.not.((prog%domad).or.(prog%dowin))) then
       call cubemain_message(seve%e,rname,'Do not understand what you want')
       error = .true.
       return
    endif
    !
    call cubetools_header_get_nchan(prog%sig%head,in_nchan,error)
    if (error) return
    call cubeadm_clone_header(comm%noi,prog%sig,prog%noi,error)
    if (error) return
    if ((prog%nchan.lt.0).or.(prog%nchan.gt.in_nchan)) then
       call cubemain_message(seve%e,rname,'Number of asked channels outside cube range')
       error = .true.
       return
    else if (prog%nchan.eq.0) then
       ! Default value
       prog%nchan = in_nchan
       nhalf = prog%nchan
       prog%nnois = 1
    else
       ! User value
       ! Ensure that prog%nchan will be odd in output because the median definition 
       ! is simpler
       if (mod(prog%nchan,2).eq.0) then
          prog%nchan = prog%nchan-1
       endif
       nhalf = floor(0.5*prog%nchan)
       prog%nnois  = floor(dble(in_nchan)/dble(nhalf))
       if (nhalf*prog%nnois.lt.in_nchan) then
          prog%nnois = prog%nnois+1
       endif
    endif
    if ((prog%nchan.lt.5)) then
       call cubemain_message(seve%e,rname,'Minimum number of channels must be 5')
       error = .true.
       return
    else if (prog%nchan.gt.in_nchan) then
          call cubemain_message(&
               seve%e,rname,&
               'You asked to compute the noise rms on more samples than '//&
               'channels in the spectrum!')
       error = .true.
       return
    endif
    prog%nhalf = floor(0.5*prog%nchan)
    ! Update noise header accordingly
    call cubetools_header_put_nchan(prog%nnois,prog%noi%head,error)
    if (error) return
    call cubetools_header_multiply_spectral_spacing(nhalf,prog%noi%head,error)
    if (error) return
    call cubetools_header_rederive_spectral_axes(prog%noi%head,error)
    if (error) return
    ! User feedback
    write(mess,'(a,i0,a,i0,a)') &
         'Computing ',prog%nnois,' noise values, each using ',prog%nchan,' channels'
    call cubemain_message(seve%i,rname,mess)
  end subroutine cubemain_noise_prog_header
  !
  subroutine cubemain_noise_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='NOISE>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,iter,error)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_noise_prog_data
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_mad_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(noise_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: spe,good,noi
    character(len=*), parameter :: rname='NOISE>PROG>MAD>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spe%associate('spe',prog%sig,iter,error)
    if (error) return
    call good%allocate('good',prog%sig,error)
    if (error) return
    call noi%allocate('noi',prog%noi,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%mad_act(iter%ie,spe,good,noi,error)
       if (error) return
    enddo
  end subroutine cubemain_noise_prog_mad_loop
  !
  subroutine cubemain_noise_prog_mad_act(prog,ie,spe,good,noi,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    use cubemain_spectrum_blanking
    use cubemain_statistics_tool
    !----------------------------------------------------------------------
    ! Compute a running median absolute deviation filter
    !----------------------------------------------------------------------
    class(noise_prog_t),  intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(spectrum_t),     intent(inout) :: spe
    type(spectrum_t),     intent(inout) :: good
    type(spectrum_t),     intent(inout) :: noi
    logical,              intent(inout) :: error
    !  
    type(spectrum_t) :: line ! We just make the line%y%val array to point => No allocation
    integer(kind=chan_k) :: in,nn,nc
    integer(kind=chan_k) :: first,last,nhalf,nchan
    real(kind=sign_k) :: median
    character(len=*), parameter :: rname='NOISE>PROG>MAD>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    nchan = prog%nchan
    nhalf = floor(0.5*nchan)
    nn = noi%n
    nc = spe%n
    !
    call spe%get(ie,error)
    if (error) return
    first = 1
    do in=1,nn
       ! The following ensures that
       !    1) we never get past the number of channels
       !    2) we always compute the mad on nchan contiguous samples
       last  = min(first+nchan-1,nc)
       first = last-nchan+1
       call line%point_to(spe,first,last,1.0,error)
       if (error) return
       call good%unblank(line,error)
       if (error) return
       if (good%n.ge.1) then
          median = statistics%median(good%y%val,good%n)
          noi%y%val(in) = statistics%mad(good%y%val,good%n,median)
       else
          noi%y%val(in) = gr4nan
       endif
       first = first+nhalf
    enddo ! in
    call noi%put(ie,error)
    if (error) return   
  end subroutine cubemain_noise_prog_mad_act
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_locwin_loop(prog,iter,error)
    use cubetools_parameters
    use cubetools_header_methods
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    use cubemain_window_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(noise_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    integer(kind=chan_k) :: nw
    type(window_t) :: win
    type(spectrum_t) :: spe,base,noi
    character(len=*), parameter :: rname='NOISE>LOCWIN>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_nchan(prog%locwin%head,nw,error)
    if (error) return
    if (nw.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of windows')
       error = .true.
       return
    endif
    !
    call win%associate('win',prog%locwin,iter,error)
    if (error) return
    call spe%allocate('spe',prog%sig,iter,error)
    if (error) return
    call base%allocate('base',prog%sig,error)
    if (error) return
    call noi%allocate('noi',prog%noi,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%locwin_act(iter%ie,win,spe,base,noi,error)
       if (error) return
    enddo
  end subroutine cubemain_noise_prog_locwin_loop
  !
  subroutine cubemain_noise_prog_locwin_act(prog,ie,win,spe,base,noi,error)
    use cubetools_nan
    use cubetopology_tool
    use cubeadm_spectrum_types
    use cubemain_window_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(noise_prog_t),  intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(window_t),       intent(inout) :: win
    type(spectrum_t),     intent(inout) :: spe
    type(spectrum_t),     intent(inout) :: base
    type(spectrum_t),     intent(inout) :: noi
    logical,              intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    integer(kind=chan_k) :: ichan(2)
    real(kind=coor_k) :: vrange(2)
    character(len=*), parameter :: rname='NOISE>LOCAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spe%get(ie,error)
    if (error) return
    call win%get(ie,error)
    if (error) return
    ! Blank signal
    do iw=1,win%n/2 ! *** JP: This is dangerous. It should be a method of the window_t
       if (win%isblank(iw)) cycle
       vrange(:) = win%y%val(2*iw-1:2*iw)
       call cubetopology_tool_vrange2crange(prog%sig,vrange,ichan,error)
       if (error) return
       spe%y%val(ichan(1):ichan(2)) = gr4nan
    enddo
    call prog%compute_noise(spe,base,noi,error)
    if (error) return
    call noi%put(ie,error)
    if (error) return
  end subroutine cubemain_noise_prog_locwin_act
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_glowin_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(noise_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: spe,base,noi
    character(len=*), parameter :: rname='NOISE>WIN>GLOBAL>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (prog%glowin%n.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of windows')
       error = .true.
       return
    endif
    !
    call spe%allocate('spe',prog%sig,iter,error)
    if (error) return
    call base%allocate('base',prog%sig,error)
    if (error) return
    call noi%allocate('noi',prog%noi,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%glowin_act(iter%ie,spe,base,noi,error)
       if (error) return
    enddo
  end subroutine cubemain_noise_prog_glowin_loop
  !
  subroutine cubemain_noise_prog_glowin_act(prog,ie,spe,base,noi,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_prog_t), target, intent(inout) :: prog
    integer(kind=entr_k),        intent(in)    :: ie
    type(spectrum_t),            intent(inout) :: spe
    type(spectrum_t),            intent(inout) :: base
    type(spectrum_t),            intent(inout) :: noi
    logical,                     intent(inout) :: error
    !
    integer(kind=chan_k) :: iw
    type(window_array_t), pointer :: win
    character(len=*), parameter :: rname='NOISE>PROG>GLOWIN>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    win => prog%glowin
    !
    call spe%get(ie,error)
    if (error) return
    ! Blank signal
    do iw=1,win%n
       spe%y%val(win%val(iw)%o(1):win%val(iw)%o(2)) = gr4nan
    enddo
    call prog%compute_noise(spe,base,noi,error)
    if (error) return
    call noi%put(ie,error)
    if (error) return
  end subroutine cubemain_noise_prog_glowin_act
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_compute_noise(prog,spe,base,noi,error)
    use cubeadm_spectrum_types
    use cubemain_spectrum_computation_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_prog_t), intent(inout) :: prog
    type(spectrum_t),    intent(inout) :: spe
    type(spectrum_t),    intent(inout) :: base
    type(spectrum_t),    intent(inout) :: noi
    logical,             intent(inout) :: error
    !
    type(spectrum_t) :: line
    integer(kind=chan_k) :: first,last,in
    character(len=*), parameter :: rname='NOISE>PROG>COMPUTE>NOISE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    first = 1
    do in=1,prog%nnois
       last  = min(first+prog%nchan-1,spe%n)
       first = last-prog%nchan+1
       call line%point_to(spe,first,last,1.0,error)
       if (error) return
       call base%unblank(line,error)
       if (error) return
       call spectrum_compute%rms(base,error)
       if (error) return
       noi%y%val(in) = base%noi
       first = first+prog%nhalf
    enddo
  end subroutine cubemain_noise_prog_compute_noise
end module cubemain_noise
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine mth_init
  call message(6,1,'MTH_INIT','Using NAG library')
end subroutine mth_init
!
subroutine mth_fitspl (name, nd, nk8, x, y, w, ks,   &
    wk1, wk2, cs, ss, error)
  character(len=*) :: name          !
  integer :: nd                     !
  integer :: nk8                    !
  real*8 :: x(nd)                   !
  real*8 :: y(nd)                   !
  real*8 :: w(nd)                   !
  real*8 :: ks(nk8)                 !
  real*8 :: wk1(nd)                 !
  real*8 :: wk2(4,nk8)              !
  real*8 :: cs(nk8)                 !
  real*8 :: ss                      !
  logical :: error                  !
  ! Local
  integer :: ifail, i
  character(len=60) :: chain
  !
  ! Fit splines
  ifail = 1
  error = .false.
  call e02baf(nd, nk8, x, y, w, ks, wk1, wk2, cs,   &
    ss, ifail)
  if (ifail.eq.5) then
    error = .true.
    call message(8,4,name,'Too many breaks')
    write(chain,*) 'Using ',nk8, ' breaks :'
    call message(4,1,name,chain)
    do i=1, nk8
      write(chain,*) i,' at ',ks(i+4)
      call message(4,1,name,chain)
    enddo
    error = .true.
  elseif (ifail.ne.0) then
    call mth_fail (name,'MTH_FITSPL',ifail,error)
  endif
end subroutine mth_fitspl
!
subroutine mth_fitpol(name,nd,ipol,m_pol,xxx,yyy,www,   &
    wk1,wk3,apol,spol,error)
  character(len=*) :: name          !
  integer :: nd                     !
  integer :: ipol                   !
  integer :: m_pol                  !
  real*8 :: xxx(nd)                 !
  real*8 :: yyy(nd)                 !
  real*8 :: www(nd)                 !
  real*8 :: wk1(3*nd)               !
  real*8 :: wk3(2*ipol)             !
  real*8 :: apol(m_pol,ipol)        !
  real*8 :: spol(ipol)              !
  logical :: error                  !
  ! Local
  integer :: ifail
  !
  call e02adf(nd,ipol,m_pol,xxx,yyy,www,wk1,wk3,   &
    apol,spol,ifail)
  call mth_fail (name,'MTH_FITPOL',ifail,error)
end subroutine mth_fitpol
!
subroutine mth_getspl(name,nk8, ks, cs, xx, yy, error)
  character(len=*) :: name          !
  integer :: nk8                    !
  real*8 :: ks(nk8)                 !
  real*8 :: cs(nk8)                 !
  real*8 :: xx                      !
  real*8 :: yy                      !
  logical :: error                  !
  ! Local
  integer :: ifail
  !
  call e02bbf(nk8, ks, cs, xx, yy, ifail)
  call nag_fail (name,'MTH_GETSPL',ifail,error)
end subroutine mth_getspl
!
subroutine mth_getspd(name,nk8, ks, cs, xx, left, yy, error)
  character(len=*) :: name          !
  integer :: nk8                    !
  real*8 :: ks(nk8)                 !
  real*8 :: cs(nk8)                 !
  real*8 :: xx                      !
  integer :: left                   !
  real*8 :: yy(4)                   !
  logical :: error                  !
  ! Local
  integer :: ifail
  !
  call e02bcf(nk8, ks, cs, xx, left, yy, ifail)
  call nag_fail (name,'MTH_GETSPD',ifail,error)
end subroutine mth_getspd
!
subroutine mth_getpol(name,ipol,aa,xx,yy,error)
  character(len=*) :: name          !
  integer :: ipol                   !
  real*8 :: aa(ipol)                !
  real*8 :: xx                      !
  real*8 :: yy                      !
  logical :: error                  !
  ! Local
  integer :: ifail
  !
  call e02aef(ipol,aa,xx,yy,ifail)
  call mth_fail (name,'MTH_GETPOL',ifail,error)
end subroutine mth_getpol
!
subroutine mth_fail (fac,prog,ifail,error)
  character(len=*) :: fac           !
  character(len=*) :: prog          !
  integer :: ifail                  !
  logical :: error                  !
  ! Local
  character(len=60) :: chain
  !
  if (ifail.eq.0) then
    error = .false.
  else
    write(chain,'(A,A,A,I4)')   &
      'ERROR in ',prog,', ifail = ',ifail
    call message(8,4,fac,chain)
    error = .true.
  endif
end subroutine mth_fail
!
subroutine mth_fitlin (name,ndd,nvar,a,b,nd,sigma)
  character(len=*) :: name          !
  integer :: ndd                    !
  integer :: nvar                   !
  integer :: nd                     !
  real*8 :: a(nd,nvar)              !
  real*8 :: b(nd)                   !
  real*8 :: sigma                   !
  ! Local
  logical :: error
  !
  integer :: mvar
  parameter (mvar=10)          ! 7 is required for baseline fit.
  integer :: ifail, irank, lwork
  parameter (lwork = 4*mvar)
  real*8 :: work(lwork), work2(mvar)
  !
  ifail = 1
  call f04jaf(ndd,nvar,a,nd,b,1d-5,sigma,irank,work,lwork,   &
    ifail)
  call mth_fail(name,'MTH_FILIN (fit)',ifail,error)
  ifail = 1
  call f04yaf(-1,nvar,sigma,a,nd,.true.,irank,work,work2,work2,   &
    ifail)
  call mth_fail(name,'MTH_FILIN (fit)',ifail,error)
end subroutine mth_fitlin
!
subroutine mth_dpotrf (name, uplo, n, a, lda, error)
  character(len=*) :: name           !
  character(len=*) :: uplo           !
  integer :: n                       !
  integer :: lda                     !
  real*8 :: a(lda,*)                 !
  logical :: error                   !
  ! Local
  integer :: info
  !
  ! Call NAG routine
  call f07fdf (uplo, n, a, lda, info )
  call mth_fail(name,'MTH_DPOTRF',info,error)
end subroutine mth_dpotrf
!
subroutine mth_dpotrs (name,   &
    uplo, n, nrhs, a, lda, b, ldb, info )
  character(len=*) :: name           !
  character(len=*) :: uplo           !
  integer :: n                       !
  integer :: nrhs                    !
  integer :: lda                     !
  real*8 :: a(lda,*)                 !
  integer :: ldb                     !
  real*8 :: b(ldb,*)                 !
  ! Local
  integer :: info
  logical :: error
  !
  ! Call NAG routine
  call f07fef( uplo, n, nrhs, a, lda, b, ldb, info )
  call mth_fail(name,'MTH_DPOTRF',info,error)
end subroutine mth_dpotrs
!
subroutine mth_dpbtrf (name, uplo, n, kd, ab, ldab, error)
  character(len=*) :: name             !
  character(len=*) :: uplo             !
  integer :: n                         !
  integer :: kd                        !
  integer :: ldab                      !
  real*8 :: ab(ldab,*)                 !
  logical :: error                     !
  ! Local
  integer :: info
  !
  ! Call NAG
  call f07hdf( uplo, n, kd, ab, ldab, info )
  call mth_fail(name,'MTH_DPBTRF',info,error)
end subroutine mth_dpbtrf
!
subroutine mth_dpbtrs (name,   &
    uplo, n, kd, nrhs, ab, ldab, b, ldb, error)
  character(len=*) :: name             !
  character(len=*) :: uplo             !
  integer :: n                         !
  integer :: kd                        !
  integer :: nrhs                      !
  integer :: ldab                      !
  real*8 :: ab(ldab,*)                 !
  integer :: ldb                       !
  real*8 :: b(ldb,*)                   !
  logical :: error                     !
  ! Local
  integer :: info
  !
  ! Call LAPACK
  call f07hef( uplo, n, kd, nrhs, ab, ldab, b, ldb, info )
  call mth_fail(name,'MTH_DPBTRS',info,error)
end subroutine mth_dpbtrs
!
function mth_bessj0 (x)
  !---------------------------------------------------------------------
  ! Compute Bessel function J0
  !---------------------------------------------------------------------
  real*8 :: mth_bessj0              !
  real*8 :: x                       !
  ! Local
  real*8 :: s17aef
  integer :: ifail
  !
  ifail = 0
  mth_bessj0 = s17aef(x,ifail)
end function mth_bessj0
!
function mth_bessj1 (x)
  !---------------------------------------------------------------------
  ! Compute Bessel function J1
  !---------------------------------------------------------------------
  real*8 :: mth_bessj1              !
  real*8 :: x                       !
  ! Local
  real*8 :: s17aff
  integer :: ifail
  !
  ifail = 0
  mth_bessj1 = s17aff(x,ifail)
end function mth_bessj1
!
subroutine mth_bessjn (x,j,n)
  !---------------------------------------------------------------------
  ! Compute Bessels functions from J1 to Jn
  !---------------------------------------------------------------------
  real*8 :: x                       !
  integer :: n                      !
  real*8 :: j(n)                    !
  ! Local
  integer :: i
  !
  ! Unefficient implementation, if you don't care
  !      REAL*8 MTH_BESSJ1,MTH_BESSJ
  !      J(1) = MTH_BESSJ1(X)
  !      DO I=2,N
  !         J(I) = MTH_BESSJ(I,X)
  !      ENDDO
  !      RETURN
  !
  ! NAG version
  integer m
  parameter (m=16)
  complex*16 z,jj(m)
  integer ifail
  !
  if (n.gt.m) then
    ifail = 6
  else
    z = cmplx(x,0d0)
    ifail = 0
    call s17def(1.d0,z,2,'U',jj,2,ifail)
    do i=1,n
      !            J(I) = REAL(JJ(I))
      j(i) = dble(jj(i))
    enddo
  endif
end subroutine mth_bessjn

subroutine sic_lunmac_init(error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_lunmac_init
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Initialise private logical units used by SIC
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MACRO'
  integer(kind=4) :: icode,i
  character(len=message_length) :: mess
  !
  ! Pre-allocate logical units for TEMporary files
  icode = sic_getlun(luntem)
  if (icode.ne.1) then
    call sic_message(seve%e,rname,  &
      'Failed to pre-allocate lun for temporary files')
    error = .true.
    return
  endif
  write(mess,'(A,I0,A)')  &
    'Preallocated 1 lun (#',luntem,') for temporary files'
  call sic_message(seve%d,rname,mess)
  !
  ! Pre-allocate MLUNPA logical units for macros
  do i=1,mlunpa
    icode = sic_getlun(lunmac(i))
    if (icode.ne.1)  error = .true.
  enddo
  if (error) then
    call sic_message(seve%e,rname,'Failed to pre-allocate luns for macros')
    return
  endif
  write(mess,'(A,I0,A,I0,A,I0,A)')  &
    'Preallocated ',mlunpa,' luns (between #',lunmac(1),' and #',  &
    lunmac(mlunpa),') for macros'
  call sic_message(seve%d,rname,mess)
  !
end subroutine sic_lunmac_init
!
subroutine sic_lunmac_exit(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_lunmac_exit
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Free all the pre-allocated LUNs
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  integer(kind=4) :: i
  !
  call sic_frelun(luntem)
  !
  do i=1,mlunpa
    call sic_frelun(lunmac(i))
  enddo
  !
end subroutine sic_lunmac_exit
!
subroutine sic_lunmac_get(imac,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_lunmac_get
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Entry to allocate one LUN for a macro call
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: imac
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='MACRO'
  integer(kind=4) :: icode
  !
  ! Can we use one of the preallocate LUNs?
  if (imac.le.mlunpa) return
  !
  if (imac.gt.mlun) then
    call sic_message(seve%e,rname,'Parameter MLUN is dimensioned too small')
    error=.true.
    return
  endif
  !
  icode = sic_getlun(lunmac(imac))
  if (mod(icode,2).eq.0)  error=.true.
  !
end subroutine sic_lunmac_get
!
subroutine sic_lunmac_free(imac)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_lunmac_free
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Entry to free one LUN for a macro call
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: imac
  !
  ! Never deallocate preallocated LUNs
  if (imac.le.mlunpa) return
  !
  call sic_frelun(lunmac(imac))
  !
end subroutine sic_lunmac_free

module cubetools_disambiguate
  use cubetools_parameters
  use cubetools_messaging
  !
  public :: cubetools_disambiguate_strict,cubetools_disambiguate_flexible,cubetools_disambiguate_toupper
  public :: cubetools_find_key
  private
  !
contains
  !
  subroutine cubetools_disambiguate_toupper(anycase,uppercase,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Shift anycase to uppercase
    !-------------------------------------------------------------------
    character(len=*),      intent(in)    :: anycase
    character(len=*),      intent(out)   :: uppercase
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='DISAMBIGUATE>TOUPPER'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    uppercase = anycase
    call sic_upper(uppercase)
  end subroutine cubetools_disambiguate_toupper
  !
  subroutine cubetools_disambiguate_list(cname,list,error)
    !-------------------------------------------------------------------
    ! List available keywords
    !-------------------------------------------------------------------
    character(len=*),      intent(in)    :: cname
    character(len=*),      intent(in)    :: list(:)
    logical,               intent(inout) :: error
    !
    character(len=mess_l) :: mess
    integer(kind=4) :: ikey,n
    character(len=*), parameter :: rname='DISAMBIGUATE>LIST'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    n = size(list)
    call cubetools_message(seve%r,cname,'  Available options are:')
    do ikey=1,n
       if (ikey.eq.1) then
          write (mess,'(4x,a)') trim(list(ikey))
       else if (ikey.eq.n) then
          write (mess,'(3a)') trim(mess),' and ',trim(list(ikey))
       else
          write (mess,'(3a)') trim(mess),', ',trim(list(ikey))
       endif
    enddo
    call cubetools_message(seve%r,cname,mess)
    error = .true.
  end subroutine cubetools_disambiguate_list
  !
  subroutine cubetools_disambiguate_sub(cname,keyword,list,ikey,solved,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Turns inputs into upper case, then calls sic_ambigs
    !-------------------------------------------------------------------
    character(len=*),      intent(in)    :: cname
    character(len=*),      intent(in)    :: keyword
    character(len=*),      intent(in)    :: list(:)
    integer(kind=4),       intent(out)   :: ikey
    character(len=*),      intent(out)   :: solved
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: nlist,list_l,str_l,ier,iwrd
    character(len=:),allocatable :: upper,upperlist(:)
    character(len=*), parameter :: rname='DISAMBIGUATE>SUB'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    nlist = size(list)
    str_l = len(keyword)
    list_l = len(list)
    allocate(character(len=str_l)::upper,stat=ier)
    if (failed_allocate(rname,'Upper case string',ier,error)) return
    allocate(character(len=list_l)::upperlist(nlist),stat=ier)
    if (failed_allocate(rname,'Upper case strings',ier,error)) return
    !
    call cubetools_disambiguate_toupper(keyword,upper,error)
    if (error) return
    do iwrd = 1,nlist
       call cubetools_disambiguate_toupper(list(iwrd),upperlist(iwrd),error)
       if (error) return
    enddo
    call sic_ambigs_sub(rname,upper,solved,ikey,upperlist,nlist,error)
    if (error) return
  end subroutine cubetools_disambiguate_sub
  
  subroutine cubetools_disambiguate_strict(keyword,list,ikey,solved,error)
    !-------------------------------------------------------------------
    ! Resolve a keyword returning ikey and the solved keyword and
    ! raising an error if word is not found in list
    !-------------------------------------------------------------------
    character(len=*),      intent(in)    :: keyword
    character(len=*),      intent(in)    :: list(:)
    integer(kind=4),       intent(out)   :: ikey
    character(len=*),      intent(out)   :: solved
    logical,               intent(inout) :: error
    !
    
    character(len=*), parameter :: rname='DISAMBIGUATE>STRICT'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    call cubetools_disambiguate_sub(rname,keyword,list,ikey,solved,error)
    if (error) return
    if (ikey.lt.1) then
       call cubetools_message(seve%e,rname,'Unknown keyword '//trim(keyword))
       call cubetools_disambiguate_list(rname,list,error)
       if (error) return
    endif
  end subroutine cubetools_disambiguate_strict
  !
  subroutine cubetools_disambiguate_flexible(keyword,list,ikey,solved,error)
    !-------------------------------------------------------------------
    ! Resolve a keyword returning ikey and the solved keyword and
    ! *NOT* raising an error if word is not found in list
    !-------------------------------------------------------------------
    character(len=*),      intent(in)    :: keyword
    character(len=*),      intent(in)    :: list(:)
    integer(kind=4),       intent(out)   :: ikey
    character(len=*),      intent(out)   :: solved
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='DISAMBIGUATE>FLEXIBLE'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    call cubetools_disambiguate_sub(rname,keyword,list,ikey,solved,error)
    if (error) return
    if (ikey.lt.1) then
       ikey = code_unresolved
       solved = strg_unresolved
    endif
  end subroutine cubetools_disambiguate_flexible
  !
  subroutine cubetools_find_key(keyword,list,okey,error)
    !-------------------------------------------------------------------
    ! Find if the input key is present in the list. The search is
    ! case-sensitive and not disambiguated. Return code_unresolved if
    ! not found.
    !
    ! Typical use-case is physical units:
    !   mJy is not the same as MJy (i.e. case-sensitive), and
    !   MJy is not the same as MJy/sr (no disambiguisation)
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: keyword
    character(len=*), intent(in)    :: list(:)
    integer(kind=4),  intent(out)   :: okey
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ikey
    character(len=*), parameter :: rname='FIND>KEY'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    do ikey=1,size(list)
      if (list(ikey).eq.keyword) then
        okey = ikey
        return
      endif
    enddo
    okey = code_unresolved
  end subroutine cubetools_find_key
  !
end module cubetools_disambiguate

program create_image
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     CREATE_IMAGE:  Create an IMAGE
  !
  !     This task create an image which can be read
  !     from a file or created from a function.
  !     The ouput filename is  FILEO$.
  !
  !     A- From a FILE:  if the logical variable IFILE$ is set to YES
  !     an image is read from the input formatted file FILEI$
  !     the column must ordered as :  x y z
  !     and expect standard gdf image structure
  !     For convenience, z should be in Brightness temperature as for B case.
  !
  !     B- From a FUNCTION: If one of the function is activated a
  !     corresponding image using the parameters PARAMETERS$ will be created.
  !     Intensity are in Brightness temperature.
  !
  !     1- Elliptical Disk             (E_DISK)
  !     2- Elliptical Ring             (E_RING)
  !     3- Elliptical Gaussian         (E_GAUS)
  !     6- Elliptical Exponential      (E_EXPO)
  !     4- Rectangle                   (RECT)
  !     5- Power law                   (POW)
  !     7- plan                        (PLAN)
  !
  !     Convertion to Jansky is possible if variable JANSKY$ is set to YES.
  !     The image can be mutiplied by a gaussian beam if BEAM$ is set to YES
  !     parameters are similar as for function GAUSS.
  !
  !     ONLY ONE function can be computed at the same time,
  !     Nevertheless more complex images can be produced using both
  !     CIMAGE and COMBINE tasks.
  !
  !     The 7 input  parameters are :
  !     E_DISK,E_GAUSS,E_EXPO,RECT,PLAN
  !     1,2     X,Y center relative coordinates (")
  !     3       Brightness Temperature (K)
  !     4       Position angle of the source (in DEGREES) , western direction
  !     5,6     Major and Minor axis (")
  !     7       NOT USED
  !
  !     E_RING
  !     1,2     X,Y center relative coordinates (")
  !     3       Brightness Temperature (K)
  !     4       Position angle of the source (in DEGREES)
  !     5,6     inner and outer equatorial radius (")
  !     7       FLATTENING FACTOR (RPOL/REQU)
  !
  !     FOR POW
  !     1,2     X,Y center relative coordinates (")
  !     3       Brightness Temperature (K)
  !     4       A: distance threshold  (")
  !     5       B: power
  !     6       not used
  !     7       NOT USED
  !
  !     FOR PLAN
  !     1,2     X,Y center relative coordinates (")
  !     3       Brightness Temperature (K)
  !     4       Position angle of the source (in DEGREES)
  !     5,6     A,B COEFFICIENT OF THE PLAN EQUATION (1/")
  !     7       NOT USED
  !
  !     R.Moreno & E.Dartois
  !     1st  version 08-Mar-2000
  !     last version 18-Nov-2003
  !---------------------------------------------------------------------
  ! Local
  logical :: error
  character(len=filename_length) :: filei,fileo
  character(len=16) :: linename,sourcename
  integer(kind=4) :: nx,ny,nv,nxyv(3)
  real(kind=8) :: size
  real(kind=8) :: xstep,ystep
  real(kind=8) :: frequency,fstep,vstep
  logical :: ifile,e_disk,e_ring,e_gaus,recta,pow,expo,beam,jansky,plan
  real(kind=8) :: param(7),pbeam(7)
  real(kind=8) :: clight
  real(kind=8) :: pi,arc
  integer(kind=4) :: ok,n,ier
  type(gildas) :: x
  !
  !     Initialisations
  !
  call gildas_open
  call gildas_logi('IFILE$',ifile,1)
  call gildas_char('FILEI$',filei)
  call gildas_char('FILEO$',fileo)
  call gildas_inte('NXYV$',nxyv,3)
  !
  call gildas_dble('SIZE$',size,1)
  call gildas_char('SOURCE$',sourcename)
  call gildas_char('LINE$',linename)
  call gildas_dble('FREQUENCY$',frequency,1)
  call gildas_dble('DF$',fstep,1)
  !
  call gildas_logi('E_DISK$',e_disk,1)
  call gildas_logi('E_RING$',e_ring,1)
  call gildas_logi('E_GAUS$',e_gaus,1)
  call gildas_logi('E_EXPO$',expo,1)
  call gildas_logi('RECT$',recta,1)
  call gildas_logi('POW$',pow,1)
  call gildas_logi('PLAN$',plan,1)
  call gildas_dble('PARAMETERS$',param,7)
  call gildas_logi('JANSKY$',jansky,1)
  call gildas_logi('BEAM$',beam,1)
  call gildas_dble('PARAMETERS2$',pbeam,7)
  !
  call gildas_close
  !
  call gildas_null(x)
  nx = nxyv(1)
  ny = nxyv(2)
  nv = nxyv(3)
  !     NZ = NXYV(4)
  !
  !     CONSTANTS
  !
  pi = 3.14159265358979323846d0
  arc = 1.0d0/(180.0d0*3600.0d0/pi)
  clight = 299792458.d0        ! LIGHT SPEED         (m/s)
  !
  xstep = size/nx*arc          ! IMAGE STEP IN X     (rad)
  ystep = size/ny*arc          ! IMAGE STEP IN Y     (rad)
  frequency = frequency*1d6   ! FREQUENCY           (Hz)
  vstep = -fstep*clight/frequency*1.d3    ! VELOCITY RESOLUTION (Km/s)
  !
  n = len_trim(fileo)
  if (n.eq.0) goto 100
  !
  call gildas_null(x)
  call sic_parsef(fileo,x%file,' ','.gdf')
  x%gil%ndim = 3
  x%gil%dim(1) = nx
  x%gil%dim(2) = ny
  x%gil%dim(3) = nv
  x%gil%dim(4) = 1
  x%gil%ref(1) = nx/2+1
  x%gil%val(1) = 0.d0
  x%gil%inc(1) = -xstep            ! assume RA  coordinate
  x%gil%ref(2) = ny/2+1
  x%gil%val(2) = 0.d0
  x%gil%inc(2) = ystep             ! assume Dec coordinate
  x%gil%ref(3) = nv/2
  x%gil%val(3) = 0.d0
  x%gil%inc(3) = vstep
  x%gil%extr_words = 0
  !
  x%char%syst = 'EQUATORIAL'
  x%char%name = sourcename
  x%gil%ra = 0.0d0
  x%gil%dec = 0.0d0
  x%gil%epoc = 2000.0
  x%gil%ptyp = p_azimuthal
  x%gil%a0 = x%gil%ra
  x%gil%d0 = x%gil%dec
  x%gil%pang = 0.0d0
  x%gil%xaxi = 1
  x%gil%yaxi = 2
  !
  x%char%unit = 'KELVIN'
  if (jansky) then
    x%char%unit = 'Jy'
  endif
  x%char%code(1) = 'RA'
  x%char%code(2) = 'DEC'
  x%char%code(3) = 'FREQUENCY'
  !
  x%char%line = linename
  x%gil%fres = fstep             ! in MHz
  x%gil%fima = 0.0d0
  x%gil%freq = frequency*1d-6    ! in MHz
  x%gil%vres = real(vstep)       ! in Km/s
  x%gil%voff = 0.0
  x%gil%faxi = 3
  !
  allocate (x%r3d(nx,ny,nv), stat=ier)
  x%r3d = 0.0
  !
  ok = 0
  if (ifile) then
    n = len_trim(filei)
    if (n.gt.0) then
      call lecture (nx,ny,nv,x%r3d,x%gil%convert,filei)
      ok = 1
    else
      write(*,*) ' '
      write(*,*) 'E-IMAGE: NO INPUT FILE '
      write(*,*) ' '
    endif
  endif
  if (e_disk) then
    if (ok.eq.0) then
      if ( (param(5).gt.0).and.(param(6).gt.0) ) then
        call edisk(nx,ny,nv,x%r3d,x%gil%convert,param)
        ok = 1
      else
        write(*,*) ' '
        write(*,*) 'E-IMAGE: PARAMETER 5 OR 6  < OR = 0'
        write(*,*) ' '
      endif
    else
      write(*,*) ' '
      write(*,*)   &
   &          'W-IMAGE: DISK NOT COMPUTED: Only one function'
      write(*,*) ' '
    endif
  endif
  if (e_ring) then
    if (ok.eq.0) then
      if ( (param(5).gt.0).and.(param(6).gt.0).and.   &
   &          (param(7).gt.0).and.(param(5).le.param(6)) ) then
        call ering(nx,ny,nv,x%r3d,x%gil%convert,param)
        ok = 1
      else
        write(*,*) ' '
        write(*,*) 'E-IMAGE: PARAMETER 5,6,7 < OR = 0'
        write(*,*) 'E-IMAGE: PARAM(5) must be <  PARAM(6)'
        write(*,*) ' '
      endif
    else
      write(*,*) ' '
      write(*,*)   &
   &          'W-IMAGE: RING NOT COMPUTED: Only one function'
      write(*,*) ' '
    endif
  endif
  if (e_gaus) then
    if (ok.eq.0) then
      if ( (param(5).gt.0).and.(param(6).gt.0) ) then
        call egaus(nx,ny,nv,x%r3d,x%gil%convert,param)
        ok = 1
      else
        write(*,*) ' '
        write(*,*) 'E-IMAGE: PARAMETER 5,6 < OR = 0'
        write(*,*) ' '
      endif
    else
      write(*,*) ' '
      write(*,*)   &
   &          'W-IMAGE: GAUSS NOT COMPUTED: Only one function'
      write(*,*) ' '
    endif
  endif
  if (expo) then
    if (ok.eq.0) then
      if ( (param(5).gt.0).and.(param(6).gt.0).and.   &
   &          (param(7).gt.0) ) then
        call expo2(nx,ny,nv,x%r3d,x%gil%convert,param)
        ok = 1
      else
        write(*,*) ' '
        write(*,*) 'E-IMAGE: PARAMETER  5,6,7 < OR = 0'
        write(*,*) ' '
      endif
    else
      write(*,*) ' '
      write(*,*) 'W-IMAGE: EXP NOT COMPUTED: Only one function'
      write(*,*) ' '
    endif
  endif
  if (recta) then
    if (ok.eq.0) then
      if ( (param(5).gt.0).and.(param(6).gt.0) ) then
        call rect2(nx,ny,nv,x%r3d,x%gil%convert,param)
        ok = 1
      else
        write(*,*) ' '
        write(*,*) 'E-IMAGE: PARAMETER 5,6 < OR = 0'
        write(*,*) ' '
      endif
    else
      write(*,*) ' '
      write(*,*)   &
   &          'W-IMAGE: RECT NOT COMPUTED: Only one function'
      write(*,*) ' '
    endif
  endif
  if (pow) then
    if (ok.eq.0) then
      if ( (param(4).gt.0).and.(param(5).gt.0) ) then
        call pow2(nx,ny,nv,x%r3d,x%gil%convert,param)
        ok = 1
      else
        write(*,*) ' '
        write(*,*) 'E-IMAGE: PARAMETER 4,5 < OR = 0'
        write(*,*) ' '
      endif
    else
      write(*,*) ' '
      write(*,*) 'W-IMAGE: POW NOT COMPUTED: Only one function'
      write(*,*) ' '
    endif
  endif
  if (plan) then
    if (ok.eq.0) then
      call plan2(nx,ny,nv,x%r3d,x%gil%convert,param)
      ok = 1
    else
      write(*,*) ' '
      write(*,*) 'W-IMAGE: EXP NOT COMPUTED: Only one function'
      write(*,*) ' '
    endif
  endif
  if (jansky) then
    call planck(nx,ny,nv,x%r3d,x%gil%convert,frequency)
  endif
  if (beam) then
    if ( (pbeam(5).gt.0).or.(pbeam(6).gt.0) ) then
      call ebeam(nx,ny,nv,x%r3d,x%gil%convert,pbeam,jansky)
    else
      write(*,*) ' '
      write(*,*) 'E-IMAGE: PARAMETER 5,6 < OR = 0'
      write(*,*) ' '
    endif
  endif
  !
  call gdf_write_image(x,x%r3d,error)
  if (error) goto 100
  call sysexi(1)
  !
  100 call sysexi(fatale)
  !
end program create_image
!
subroutine zini (x,n,t)
  integer(kind=4) :: n                      !
  real(kind=4) :: x(n)                      !
  real(kind=4) :: t                         !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    x(i) = t
  enddo
end subroutine zini
!
subroutine lecture(nxx,nyy,nvv,val,convert,fileii)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) :: convert(9)             !
  character(len=80) :: fileii       !
  ! Local
  real(kind=8) ::  xf,yf,zf
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc,vref,vval,vinc
  real(kind=8) ::  val_x,val_y,val_v,val_z
  logical :: error
  integer(kind=4) :: lch
  integer(kind=4) :: p_lun, ier
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  vref = convert(7)
  vval = convert(8)
  vinc = convert(9)
  !
  lch = lenc(fileii)
  ier = sic_getlun(p_lun)
  ier = sic_open(p_lun,fileii(1:lch),'OLD',.true.)
  if (ier.ne.0) then
    call gagout('W-CIMAGE, Cannot open file '//fileii(1:lch))
    call putios ('        ',ier)
    error = .true.
    call sic_frelun(p_lun)
  else
    do k=1,nvv
      do i=1,nxx
        do j=1,nyy
          read(p_lun,*) xf,yf,zf
          val_x = (i-xref)*xinc+xval
          val_y = (j-yref)*yinc+yval
          val_v = (k-vref)*vinc+vval
          val_z = zf
          val(i,j,k) = val(i,j,k)+val_z
        enddo
      enddo
    enddo
    close(unit=p_lun)
    call sic_frelun(p_lun)
  endif
end subroutine lecture
!
subroutine edisk(nxx,nyy,nvv,val,convert,parame)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: parame(7)               !
  ! Global
  real(kind=8), external :: disk_e
  ! Local
  !     no choice val is real.
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        val_z = disk_e(val_x,val_y,parame)
        val(i,j,k) = val(i,j,k)+real(val_z)
      enddo
    enddo
  enddo
end subroutine edisk
!
function disk_e(x1,y1,paramet)
  !---------------------------------------------------------------------
  !     Function computing a 2D ellipse
  !     f(x,y)=> (x/a)^2+(y/b)^2<=1
  !
  !     6 parameters (x0, y0, tb, theta, a, b)
  !---------------------------------------------------------------------
  real(kind=8) :: disk_e                  !
  real(kind=8) :: x1                      !
  real(kind=8) :: y1                      !
  real(kind=8) :: paramet(7)              !
  ! Local
  real(kind=8) :: dist
  real(kind=8) :: x0,y0,tb,theta,a,b
  real(kind=8) :: xr,yr,ct,st
  real(kind=8) :: arc,pi
  !
  pi=3.14159265358979323846
  arc = 1.0/(180.0*3600.0/pi)
  !
  x0=paramet(1)*arc            ! X RELATIVE CENTER COORDINATE (RAD)
  y0=paramet(2)*arc            ! Y RELATIVE CENTER COORDINATE (RAD)
  tb=paramet(3)                ! BRIGHTNESS TEMPERATURE        (K)
  theta=paramet(4)*pi/180.     ! INCLINATION ANGLE            (RAD)
  a=paramet(5)*0.5*arc         ! HALF BIG AXIS                (RAD)
  b=paramet(6)*0.5*arc         ! HALF SMALL AXIS              (RAD)
  !
  !     PARAMET(7) NOT USED
  !
  ct=cos(theta)
  st=sin(theta)
  !
  !     TRANSLATION
  !
  x1=x1-x0
  y1=y1-y0
  !
  !     ROTATION
  !
  xr=x1*ct+y1*st
  yr=y1*ct-x1*st
  !
  !     ELLIPTICAL DISK
  !
  dist=(xr/a)**2+(yr/b)**2
  if (dist.le.1.0) then
    disk_e=tb
  else
    disk_e=0.0
  endif
end function disk_e
!
subroutine ering(nxx,nyy,nvv,val,convert,parame)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: parame(7)               !
  ! Global
  real(kind=8), external :: ring_e
  ! Local
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        val_z = ring_e(val_x,val_y,parame)
        val(i,j,k) = val(i,j,k)+real(val_z)
      enddo
    enddo
  enddo
end subroutine ering
!
function ring_e(x1,y1,paramet)
  !---------------------------------------------------------------------
  !     Function computing a elliptical RING
  !     f(x,y)=> (x/a)^2+(y/(a*e))^2<=1 ; (x/b)^2+(y/(b*e))^2<=1
  !
  !
  !     7 parameters (x0, y0, tb, THETA, a, b, e)
  !---------------------------------------------------------------------
  real(kind=8) :: ring_e                  !
  real(kind=8) :: x1                      !
  real(kind=8) :: y1                      !
  real(kind=8) :: paramet(7)              !
  ! Local
  real(kind=8) :: dist_ext,dist_int
  real(kind=8) :: x0,y0,tb,theta,a,b,e
  real(kind=8) :: xr,yr,ct,st
  real(kind=8) :: arc,pi
  !
  pi=3.14159265358979323846d0
  arc = pi/(180.0d0*3600.0d0)
  !
  x0=paramet(1)*arc            ! X RELATIVE CENTER COORDINATE (RAD)
  y0=paramet(2)*arc            ! Y RELATIVE CENTER COORDINATE (RAD)
  tb=paramet(3)                ! BRIGHTNESS TEMPERATURE        (K)
  theta=paramet(4)*pi/180.     ! INCLINATION ANGLE            (RAD)
  a=paramet(5)*0.5*arc         ! HALF EQUATORIAL INNER RING   (RAD)
  b=paramet(6)*0.5*arc         ! HALF EQUATORIAL OUTER RING   (RAD)
  e=paramet(7)                 ! FLATTENING FACTOR (RPOL/REQU) ---
  !
  ct=cos(theta)
  st=sin(theta)
  !
  !     TRANSLATION
  !
  x1=x1-x0
  y1=y1-y0
  !
  !     ROTATION
  !
  xr=x1*ct+y1*st
  yr=y1*ct-x1*st
  !
  !     ELLIPTICAL DISK
  !
  dist_int=(xr/a)**2+(yr/(a*e))**2
  dist_ext=(xr/b)**2+(yr/(b*e))**2
  if ( (dist_ext.le.1.0).and.(dist_int.ge.1.0) ) then
    ring_e=tb
  else
    ring_e=0.0
  endif
end function ring_e
!
subroutine egaus(nxx,nyy,nvv,val,convert,parame)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: parame(7)               !
  ! Global
  real(kind=8), external :: gauss_e
  ! Local
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        val_z = gauss_e(val_x,val_y,parame)
        val(i,j,k) = val(i,j,k)+real(val_z)
      enddo
    enddo
  enddo
end subroutine egaus
!
function gauss_e(x1,y1,paramet)
  !---------------------------------------------------------------------
  !     Function computing elliptical 2D Gaussian
  !     f(x,y)=Tb*exp(-4ln2*[(x/a)^2+(y/b)^2])
  !
  !     6 parameters (x0, y0, tb, theta, a, b)
  !---------------------------------------------------------------------
  real(kind=8) :: gauss_e                 !
  real(kind=8) :: x1                      !
  real(kind=8) :: y1                      !
  real(kind=8) :: paramet(7)              !
  ! Local
  real(kind=8) :: dist
  real(kind=8) :: x0,y0,tb,theta,a,b
  real(kind=8) :: xr,yr,ct,st
  real(kind=8) :: arc,pi
  !
  pi=3.14159265358979323846d0
  arc = pi/(180.0d0*3600.0d0)
  !
  x0=paramet(1)*arc            ! X RELATIVE CENTER COORDINATE (RAD)
  y0=paramet(2)*arc            ! Y RELATIVE CENTER COORDINATE (RAD)
  tb=paramet(3)                ! BRIGHTNESS TEMPERATURE        (K)
  theta=paramet(4)*pi/180.     ! INCLINATION ANGLE            (RAD)
  a=paramet(5)*arc             ! HPBW IN X                    (RAD)
  b=paramet(6)*arc             ! HPBW IN Y                    (RAD)
  !
  !     PARAMET(7) NOT USED
  !
  ct=cos(theta)
  st=sin(theta)
  !
  !     TRANSLATION
  !
  x1=x1-x0
  y1=y1-y0
  !
  !     ROTATION
  !
  xr=x1*ct+y1*st
  yr=y1*ct-x1*st
  !
  !     ELLIPTICAL GAUSSIAN
  !
  dist=(xr/a)**2+(yr/b)**2
  gauss_e = tb*exp(-4.0*log(2.0)*dist)
end function gauss_e
!
subroutine rect2(nxx,nyy,nvv,val,convert,parame)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: parame(7)               !
  ! Global
  real(kind=8), external :: rect3
  ! Local
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        val_z = rect3(val_x,val_y,parame)
        val(i,j,k) = val(i,j,k)+real(val_z)
      enddo
    enddo
  enddo
end subroutine rect2
!
function rect3(x1,y1,paramet)
  !---------------------------------------------------------------------
  !     Function computing a rectangle
  !     f(x,y)=Tb  for  -a/2 < x < a/2
  !     and  -b/2 < x < b/2
  !     6 parameters (x0, y0, tb, theta, a, b)
  !---------------------------------------------------------------------
  real(kind=8) :: rect3                   !
  real(kind=8) :: x1                      !
  real(kind=8) :: y1                      !
  real(kind=8) :: paramet(7)              !
  ! Local
  real(kind=8) :: x0,y0,tb,theta,a,b
  real(kind=8) :: xr,yr,ct,st
  real(kind=8) :: arc,pi
  real(kind=8) :: xmin,xmax,ymin,ymax
  !
  pi=3.14159265358979323846d0
  arc = pi/(180.0d0*3600.0d0)
  !
  x0=paramet(1)*arc            ! X RELATIVE CENTER COORDINATE (RAD)
  y0=paramet(2)*arc            ! Y RELATIVE CENTER COORDINATE (RAD)
  tb=paramet(3)                ! BRIGHTNESS TEMPERATURE        (K)
  theta=paramet(4)*pi/180.     ! INCLINATION ANGLE            (RAD)
  a=paramet(5)*arc*0.5         ! HALF LENGHT IN X             (RAD)
  b=paramet(6)*arc*0.5         ! HALF LENGHT IN Y             (RAD)
  !
  !     PARAMET(7) NOT USED
  !
  ct=cos(theta)
  st=sin(theta)
  xmin=-a
  xmax=+a
  ymin=-b
  ymax=+b
  !
  !     TRANSLATION
  !
  x1=x1-x0
  y1=y1-y0
  !
  !     ROTATION
  !
  xr=x1*ct+y1*st
  yr=y1*ct-x1*st
  !
  !     RECTANGLE
  !
  if ( (xr.ge.xmin).and.(xr.le.xmax).and.   &
     &    (yr.ge.ymin).and.(yr.le.ymax)      ) then
    rect3=tb
  else
    rect3=0.0
  endif
end function rect3
!
subroutine pow2(nxx,nyy,nvv,val,convert,parame)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: parame(7)               !
  ! Global
  real(kind=8), external :: pow3
  ! Local
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        val_z = pow3(val_x,val_y,parame)
        val(i,j,k) = val(i,j,k)+real(val_z)
      enddo
    enddo
  enddo
end subroutine pow2
!
function pow3(x1,y1,paramet)
  !---------------------------------------------------------------------
  !     Function computing a power function of the radius
  !     f(r)=TB*(r/b)^c;
  !     a: r distance threshold  f(r<a)=f(a)
  !     B: WIDTH
  !     TB: VALUE AT R=B
  !     in order to exclude division by 0.0 when b=-1
  !     6 parameters (x0, y0, TB, a, b, c )
  !---------------------------------------------------------------------
  real(kind=8) :: pow3                    !
  real(kind=8) :: x1                      !
  real(kind=8) :: y1                      !
  real(kind=8) :: paramet(7)              !
  ! Local
  real(kind=8) :: x0,y0,tb,a,b,c
  real(kind=8) :: arc,pi
  real(kind=8) :: rmin,radius
  !
  pi=3.14159265358979323846d0
  arc = pi/(180.0d0*3600.0d0)
  !
  x0=paramet(1)*arc            ! X RELATIVE CENTER COORDINATE (RAD)
  y0=paramet(2)*arc            ! Y RELATIVE CENTER COORDINATE (RAD)
  tb=paramet(3)                ! BRIGHTNESS TEMPERATURE        (K)
  a=paramet(4)*arc             ! DISTANCE THRESHOLD IN R      (RAD)
  b=paramet(5)*arc             ! WIDTH                        (RAD)
  c=paramet(6)                 ! POWER IN R                    --
  !
  !     PARAMET 7 NOT USED
  !
  rmin=abs(a)
  !
  !     TRANSLATION
  !
  x1=x1-x0
  y1=y1-y0
  !
  !     POWER
  !
  radius=sqrt(x1**2+y1**2)
  if (radius.ge.rmin) then
    pow3=tb*(radius/b)**c
  else
    pow3=tb*(rmin/b)**c
  endif
end function pow3
!
subroutine expo2(nxx,nyy,nvv,val,convert,parame)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: parame(7)               !
  ! Global
  real(kind=8), external :: expo3
  ! Local
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        val_z = expo3(val_x,val_y,parame)
        val(i,j,k) = val(i,j,k)+real(val_z)
      enddo
    enddo
  enddo
end subroutine expo2
!
function expo3(x1,y1,paramet)
  !---------------------------------------------------------------------
  !     Function computing an exponantial decreasing function of the radius
  !     F(r)=TB*EXP(-2^C.log2.0*[(x/a)^c+(y/b)^c]) ;
  !     7 parameters (x0, y0, TB, theta, a, b, c)
  !---------------------------------------------------------------------
  real(kind=8) :: expo3                    !
  real(kind=8) :: x1                      !
  real(kind=8) :: y1                      !
  real(kind=8) :: paramet(7)              !
  ! Local
  real(kind=8) :: radius
  real(kind=8) :: x0,y0,tb,theta,a,b,c
  real(kind=8) :: xr,yr,ct,st
  real(kind=8) :: arc,pi
  !
  pi=3.14159265358979323846d0
  arc = pi/(180.0d0*3600.0d0)
  !
  x0=paramet(1)*arc            ! X RELATIVE CENTER COORDINATE (RAD)
  y0=paramet(2)*arc            ! Y RELATIVE CENTER COORDINATE (RAD)
  tb=paramet(3)                ! BRIGHTNESS TEMPERATURE        (K)
  theta=paramet(4)*pi/180.     ! INCLINATION ANGLE            (RAD)
  a=paramet(5)*arc             ! HPBW IN X                    (RAD)
  b=paramet(6)*arc             ! HPBW IN Y                    (RAD)
  c=paramet(7)                 ! POWER IN R
  !
  ct=cos(theta)
  st=sin(theta)
  !
  !     TRANSLATION
  !
  x1=x1-x0
  y1=y1-y0
  !
  !     ROTATION
  !
  xr=x1*ct+y1*st
  yr=y1*ct-x1*st
  !
  !     EXPONENTIAL
  !
  radius=sqrt((xr/a)**2+(yr/b)**2)
  expo3=tb*exp(-(2.0**c)*log(2.0)*radius**c)
end function expo3
!
subroutine plan2(nxx,nyy,nvv,val,convert,parame)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: parame(7)               !
  ! Global
  real(kind=8), external :: plan3
  ! Local
  !     no choice val is real.
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        val_z = plan3(val_x,val_y,parame)
        val(i,j,k) = val(i,j,k)+real(val_z)
      enddo
    enddo
  enddo
end subroutine plan2
!
function plan3(x1,y1,paramet)
  !---------------------------------------------------------------------
  !     Function computing a 2D PLAN
  !     f(x,y)=> ax+by+tb
  !
  !     6 parameters (x0, y0, tb, theta, a, b)
  !---------------------------------------------------------------------
  real(kind=8) :: plan3                   !
  real(kind=8) :: x1                      !
  real(kind=8) :: y1                      !
  real(kind=8) :: paramet(7)              !
  ! Local
  real(kind=8) :: x0,y0,tb,theta,a,b
  real(kind=8) :: xr,yr,ct,st
  real(kind=8) :: arc,pi
  !
  pi=3.14159265358979323846d0
  arc = pi/(180.0d0*3600.0d0)
  !
  x0=paramet(1)*arc            ! X RELATIVE CENTER COORDINATE (RAD)
  y0=paramet(2)*arc            ! Y RELATIVE CENTER COORDINATE (RAD)
  tb=paramet(3)                ! BRIGHTNESS TEMPERATURE        (K)
  theta=paramet(4)*pi/180.     ! INCLINATION ANGLE            (RAD)
  a=paramet(5)/arc             ! A COEFFICIENT                (RAD^-1)
  b=paramet(6)/arc             ! B COEFFICIENT                (RAD^-1)
  !
  !     PARAMET(7) NOT USED
  !
  ct=cos(theta)
  st=sin(theta)
  !
  !     TRANSLATION
  !
  x1=x1-x0
  y1=y1-y0
  !
  !     ROTATION
  !
  xr=x1*ct+y1*st
  yr=y1*ct-x1*st
  !
  !     ELLIPTICAL DISK
  !
  plan3=a*xr+b*yr+tb
end function plan3
!
subroutine ebeam(nxx,nyy,nvv,val,convert,paramb,jansky)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: paramb(6)               !
  logical :: jansky                 !
  ! Global
  real(kind=8), external :: beam_e
  ! Local
  real(kind=8) :: fluxbeam
  integer(kind=4) :: i,j,k
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  fluxbeam=0.0
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        val_z = beam_e(val_x,val_y,paramb,jansky,xinc,yinc)
        val(i,j,k) = val(i,j,k)*real(val_z)
        fluxbeam=fluxbeam+val(i,j,k)
      enddo
    enddo
  enddo
  !
  if (jansky) then
    write(*,*) 'FLUX/BEAM  : ',real(fluxbeam/nvv),' Jy'
  else
    write(*,*) 'TMB : ',real(fluxbeam/nvv),' K'
  endif
end subroutine ebeam
!
function beam_e(x1,y1,paramet2,jansky,xinc,yinc)
  !---------------------------------------------------------------------
  !     Function computing elliptical 2D Gaussian beam attenuation
  !     f(x,y)=Tb*K*exp(-4ln2*[(x/a)^2+(y/b)^2])
  !     K is function of the unity (K, Jy)
  !
  !     6 parameters (x0, y0, tb, theta, a, b)
  !---------------------------------------------------------------------
  real(kind=8) :: beam_e                  !
  real(kind=8) :: x1                      !
  real(kind=8) :: y1                      !
  real(kind=8) :: paramet2(6)             !
  logical :: jansky                  !
  real(kind=8) :: xinc                    !
  real(kind=8) :: yinc                    !
  ! Local
  real(kind=8) :: dist
  real(kind=8) :: x0,y0,tb,theta,a,b,sa,sb
  real(kind=8) :: xr,yr,ct,st
  real(kind=8) :: arc,pi
  real(kind=8) :: sstep
  !
  pi=3.14159265358979323846d0
  arc = pi/(180.0d0*3600.0d0)
  !
  x0=paramet2(1)*arc           ! X RELATIVE CENTER COORDINATE (RAD)
  y0=paramet2(2)*arc           ! Y RELATIVE CENTER COORDINATE (RAD)
  tb=paramet2(3)               ! BRIGHTNESS TEMPERATURE        (K)
  theta=paramet2(4)*pi/180.    ! INCLINATION ANGLE            (RAD)
  a=paramet2(5)*arc            ! HPBW IN X                    (RAD)
  b=paramet2(6)*arc            ! HPBW IN Y                    (RAD)
  !
  !     PARAMET 7 NOT USED
  !
  sstep=xinc*yinc              ! PIXEL SIZE                   (STE)
  !
  ct=cos(theta)
  st=sin(theta)
  !
  !     TRANSLATION
  !
  x1=x1-x0
  y1=y1-y0
  !
  !     ROTATION
  !
  xr=x1*ct+y1*st
  yr=y1*ct-x1*st
  !
  !     ELLIPTICAL GAUSSIAN
  !
  sa=(a/2.0)/(sqrt(2.0*log(2.0)))
  sb=(b/2.0)/(sqrt(2.0*log(2.0)))
  dist=(xr/sa)**2+(yr/sb)**2
  if (jansky) then
    beam_e=tb*exp(-0.5*dist)
  else
    beam_e=tb*sstep/(2.0*pi*sa*sb)*exp(-0.5*dist)
  endif
end function beam_e
!
subroutine planck(nxx,nyy,nvv,val,convert,freq)
  integer(kind=4) :: nxx                    !
  integer(kind=4) :: nyy                    !
  integer(kind=4) :: nvv                    !
  real(kind=4) :: val(nxx,nyy,nvv)          !
  real(kind=8) ::  convert(6)               !
  real(kind=8) :: freq                    !
  ! Global
  real(kind=8), external :: planck2
  ! Local
  real(kind=4) :: temp,fluxtot,tmin
  integer(kind=4) :: i,j,k,temp0
  real(kind=8) ::  xref,xval,xinc,yref,yval,yinc
  real(kind=8) ::  val_x,val_y,val_z
  !
  freq = freq*1.0d-09
  !
  xref = convert(1)
  xval = convert(2)
  xinc = convert(3)
  yref = convert(4)
  yval = convert(5)
  yinc = convert(6)
  !
  fluxtot = 0.0
  temp0=0
  tmin=0.01
  !
  do i=1,nxx
    do j=1,nyy
      do k=1,nvv
        val_x = (i-xref)*xinc+xval
        val_y = (j-yref)*yinc+yval
        temp = val(i,j,k)
        if ( (temp.le.tmin).and.(temp.ne.0.0) ) then
          temp=0.0
          temp0=temp0+1
        end if
        val_z = planck2(freq,xinc,yinc,temp)
        val(i,j,k) = real(val_z)
        fluxtot = fluxtot+val(i,j,k)
      enddo
    enddo
  enddo
  !
  write(*,*) 'TOTAL FLUX : ',real(fluxtot/nvv),' Jy'
  if (temp0.gt.0) then
    write(*,*)   &
     &      'APPROXIMATION T<0.01K TO T=0 K, DONE ',temp0,' TIMES'
  end if
end subroutine planck
!
function planck2(nu,dx,dy,t)
  !---------------------------------------------------------------------
  !     This function compute the flux (Jy) per pixel
  !     using the planck law.
  !     frequency nu is in GHz.
  !---------------------------------------------------------------------
  real(kind=8) :: planck2                 !
  ! Local
  real(kind=8) :: hnuk,hnu3c2,jy,hnu3c2jy
  parameter(hnuk=4.799274d-2,hnu3c2=7.372615d-24,jy=1.0d-26,   &
            hnu3c2jy=7.372615d2)
  !
  real(kind=8) :: nu,asp,tb,f,dx,dy
  real(kind=4) :: t
  !
  if (t.gt.0.0) then
    tb=dble(t)
    !
    !     Flux of the planck function in Jy  (1.0e-26 Watt/m^2/Hz)
    !
    f=(2.0*hnu3c2jy*nu**3)/(exp(hnuk*nu/tb)-1.0)
    !
    !     solide angle of a  pixel in arcsec**2
    !
    asp=abs(dx*dy)
    !
    !     flux per pixel
    !
    planck2=f*asp
    !
  else
    planck2=0.0
  endif
end function planck2

subroutine sic_dcl(line,error)
  use sic_dependencies_interfaces
  use gbl_message
  use sic_interfaces, except_this=>sic_dcl
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Support routine for command
  !       SYSTEM ["commands"]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SYSTEM'
  character(len=512) :: chain,arg
  integer(kind=4) :: lc,ier,sev
  character(len=512) :: namshell
  !
  if (.not.sic_present(0,1)) then
    ! SYSTEM without argument : switch to current shell
    ier = sic_getlog('GAG_PROCESS',chain)
    if (ier.ne.0) then
      ! get the SHELL environment variable
      namshell=' '
      ! Note by DB: raz NAMSHELL (otherwise LC= LEN_TRIM(NAMSHELL)+1
      !    may be incoherent if compiler don't initialize
      !    local data
      call sic_getenv('SHELL',namshell)
      if (namshell.eq.' ')  namshell = '/bin/sh'
      chain = namshell
    endif
    ier = gag_system(chain)
    if (ier.ne.0 .and. sicsystemerror)  error = .true.
    !
  elseif (sic_present(0,2)) then
    ! More than one argument: unsupported
    call sic_message(seve%e,rname,'Supported syntax is : SYSTEM')
    call sic_message(seve%e,rname,'                 or : SYSTEM file')
    call sic_message(seve%e,rname,  &
           '                 or : SYSTEM "args" (ex: SYSTEM "ls -l")')
    error = .true.
    !
  else
    ! SYSTEM command execute a single command with -c option
    call sic_ch (line,0,1,arg,lc,.false.,error)
    if (error) return
    ! The following is provided for compatibility with a previous version
    ! of SYSTEM, when the ! was sometimes inserted to prevent lowercase
    ! conversion of the command line.
    if (arg(1:1).eq.'!') then
      chain = arg(2:)
    else
      chain = arg
    endif
    ier = gag_system(chain)
    if (ier.ne.0) then
      if (sicsystemerror) then
        sev = seve%e
        error = .true.
      else
        sev = seve%w
      endif
      call sic_message(sev,rname,'Non-zero status returned by command: '//chain)
    endif
  endif
  !
end subroutine sic_dcl

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_cumulant
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubecompute_messaging
  use cubecompute_operdir_types
  !
  public :: cumulant
  private
  !
  type :: cumulant_comm_t
     type(option_t), pointer :: comm
     type(cuberegion_comm_t) :: region
     type(operdir_comm_t)    :: direction
     type(cubeid_arg_t), pointer :: cube
     type(cube_prod_t),  pointer :: cumulant ! Approx cube prod registered at start-up
   contains
     procedure, public  :: register => cubecompute_cumulant_comm_register
     procedure, private :: parse    => cubecompute_cumulant_comm_parse
     procedure, private :: main     => cubecompute_cumulant_comm_main
  end type cumulant_comm_t
  type(cumulant_comm_t) :: cumulant  
  !
  type cumulant_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
     type(operdir_user_t)    :: direction
   contains
     procedure, private :: toprog => cubecompute_cumulant_user_toprog
  end type cumulant_user_t
  !
  type cumulant_prog_t
     !***JP: Why cubeprod needs to be global?
     type(cube_prod_t)       :: cubeprod ! Exact cube product evaluated at run time
     type(cuberegion_prog_t) :: region
     type(operdir_prog_t)    :: direction
     type(cube_t), pointer   :: cube
     type(cube_t), pointer   :: cumulant
     procedure(cubecompute_cumulant_prog_act_from_blc), pointer :: act => null()
   contains
     procedure, private :: header => cubecompute_cumulant_prog_header
     procedure, private :: data   => cubecompute_cumulant_prog_data
     procedure, private :: loop   => cubecompute_cumulant_prog_loop
  end type cumulant_prog_t
  !
contains
  !
  subroutine cubecompute_cumulant_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(cumulant_user_t) :: user
    character(len=*), parameter :: rname='CUMULANT>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cumulant%parse(line,user,error)
    if (error) return
    call cumulant%main(user,error)
    if (error) continue
  end subroutine cubecompute_cumulant_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_cumulant_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cumulant_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: cube
    type(cube_prod_t) :: cumulant
    character(len=*), parameter :: rname='CUMULANT>COMM>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'CUMULANT','[cubeid]',&
         'Compute cumulative sums in each image plane of a real cube',&
         'Compute 2D cumulative sums within each selected image plane of a&
         & real cube. The output cube matches the selected region of the&
         & input cube. Each output pixel stores the cumulative sum from the&
         & chosen corner to that pixel.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /DIRECT accumulates from the bottom-left corner. If neither&
         & /DIRECT nor /INVERSE is given, the command defaults to /DIRECT.'&
         //strg_cr//&
         '- /INVERSE accumulates from the top-right corner.'//strg_cr//&
         '- In inverse mode, zero cumulative values are converted to NaN by&
         & the current implementation.'//strg_bl//&
         'Examples:'//strg_cr//&
         '- CUBE> CUMULANT cube /DIRECT.'//strg_cr//&
         '- CUBE> CUMULANT cube /INVERSE /RANGE -5km/s 5km/s.',&
         cubecompute_cumulant_command,&
         comm%comm,&
         error)
    if (error) return
    call cube%register(&
         'INPUT',&
         'Signal cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    call comm%direction%register(&
         'Cumulate from bottom left  corner',&
         'Cumulate from    top right corner',&
         error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call cumulant%register(&
         'CUMULANT',&
         'CUMULANT cube',&
         strg_emp,&
         [flag_any,flag_cumulant],&! flag_any resolved at run time
         comm%cumulant,&
         error)
    if (error)  return
  end subroutine cubecompute_cumulant_comm_register
  !
  subroutine cubecompute_cumulant_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! CUMULANT cubname [ /DIRECT | /INVERSE ]
    !----------------------------------------------------------------------
    class(cumulant_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(cumulant_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUMULANT>COMM>PARSE'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%direction%parse(line,user%direction,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubecompute_cumulant_comm_parse
  !
  subroutine cubecompute_cumulant_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cumulant_comm_t), intent(in)    :: comm
    type(cumulant_user_t),  intent(inout) :: user
    logical,                intent(inout) :: error
    !
    type(cumulant_prog_t) :: prog
    character(len=*), parameter :: rname='CUMULANT>MAIN'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubecompute_cumulant_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_cumulant_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cumulant_user_t), intent(in)    :: user
    type(cumulant_comm_t),  intent(in)    :: comm
    type(cumulant_prog_t),  intent(out)   :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUMULANT>USER>TOPROG'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call user%region%toprog(prog%cube,prog%region,error)
    if (error) return
    !
    call user%direction%toprog(comm%direction,prog%direction,error)
    if (error) return
    select case (prog%direction%code)
    case (code_operdir_direct,code_operdir_default)
       prog%direction%code = code_operdir_direct
       prog%act => cubecompute_cumulant_prog_act_from_blc
    case (code_operdir_inverse)
       prog%act => cubecompute_cumulant_prog_act_from_trc
    case default
       call cubecompute_message(seve%e,rname,'Unknown operation direction')
       error = .true.
       return
    end select
    ! User feedback about the interpretation of his command line
    call prog%direction%list(error)
    if (error) return
    call prog%region%list(error)
    if (error) return
  end subroutine cubecompute_cumulant_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_cumulant_prog_header(prog,comm,error)
    use cubedag_allflags
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !***JP: Maybe this one could be factorized in type-operdir.f90???
    ! Create cumulant cube with proper flags
    !----------------------------------------------------------------------
    class(cumulant_prog_t), intent(inout) :: prog
    type(cumulant_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    !***JP: Why cubeprod needs to be global?
    !type(cube_prod_t) :: cubeprod ! Exact cube product evaluated at run time
    character(len=*), parameter :: rname='CUMULANT>PROG>HEADER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call comm%cumulant%copy(prog%cubeprod,error)
    if (error) return
    if (prog%direction%code.eq.code_operdir_direct) then
      call prog%cubeprod%flag_to_flag(flag_any,flag_direct,error)
      if (error) return
    else
      call prog%cubeprod%flag_to_flag(flag_any,flag_inverse,error)
      if (error) return
    endif
    call cubeadm_clone_header_with_region(prog%cubeprod,&
      prog%cube,prog%region,prog%cumulant,error)
    if (error) return
  end subroutine cubecompute_cumulant_prog_header
  !
  subroutine cubecompute_cumulant_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(cumulant_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='CUMULANT>PROG>DATA'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubecompute_cumulant_prog_data
  !   
  subroutine cubecompute_cumulant_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cumulant_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: image
    type(image_t) :: cumul
    character(len=*), parameter :: rname='CUMULANT>PROG>LOOP'
    !
    call image%associate('image',prog%cube,iter,error)
    if (error) return
    call cumul%allocate('cumul',prog%cumulant,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,image,cumul,error)
      if (error) return
    enddo ! ie
  end subroutine cubecompute_cumulant_prog_loop
  !
  subroutine cubecompute_cumulant_prog_act_from_blc(prog,ie,image,cumul,error)
    use cubetools_nan
    use cubetools_parameters
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! Start computation from bottom left corner
    !----------------------------------------------------------------------
    class(cumulant_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(image_t),          intent(inout) :: image
    type(image_t),          intent(inout) :: cumul
    logical,                intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    real(kind=sign_k) :: value
    character(len=*), parameter :: rname='CUMULANT>PROG>ACT>FROM>BLC'
    !
    call image%get(ie,error)
    if (error) return
    call cumul%set(0.0,error)
    if (error) return
    ! Bottom left corner
    if (ieee_is_nan(image%val(1,1))) then
       cumul%val(1,1) = 0.0
    else
       cumul%val(1,1) = image%val(1,1)
    endif
    ! First row
    do ix=2,image%nx
       if (ieee_is_nan(image%val(ix,1))) then
          value = 0.0
       else
          value = image%val(ix,1)
       endif
       cumul%val(ix,1) = cumul%val(ix-1,1)+value
    enddo ! ix
    ! Other raws
    do iy=2,image%ny
       ! Cumulate along x axis
       if (ieee_is_nan(image%val(1,iy))) then
          cumul%val(1,iy) = 0.0
       else
          cumul%val(1,iy) = image%val(1,iy)
       endif
       do ix=2,image%nx
          if (ieee_is_nan(image%val(ix,iy))) then
             value = 0.0
          else
             value = image%val(ix,iy)
          endif
          cumul%val(ix,iy) = cumul%val(ix-1,iy)+value
       enddo ! ix
       ! Now cumulate current and previous raw
       do ix=1,image%nx
          cumul%val(ix,iy) = cumul%val(ix,iy)+cumul%val(ix,iy-1)
       enddo ! ix
    enddo ! iy
    do iy=1,image%ny
       do ix=1,image%nx
          if (ieee_is_nan(image%val(ix,iy))) cumul%val(ix,iy) = gr4nan
       enddo !ix
    enddo !iy
    call cumul%put(ie,error)
    if (error) return
  end subroutine cubecompute_cumulant_prog_act_from_blc
  !
  subroutine cubecompute_cumulant_prog_act_from_trc(prog,ie,image,cumul,error)
    use cubetools_nan
    use cubetools_parameters
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! Start computation from top right corner
    !----------------------------------------------------------------------
    class(cumulant_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(image_t),          intent(inout) :: image
    type(image_t),          intent(inout) :: cumul
    logical,                intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,nx
    integer(kind=pixe_k) :: iy,ny
    real(kind=sign_k) :: value
    character(len=*), parameter :: rname='CUMULANT>PROG>ACT>FROM>TRC'
    !
    call image%get(ie,error)
    if (error) return
    call cumul%set(0.0,error)
    if (error) return
    ! Top right corner
    nx = image%nx
    ny = image%ny
    if (ieee_is_nan(image%val(nx,ny))) then
       cumul%val(nx,ny) = 0.0
    else
       cumul%val(nx,ny) = image%val(nx,ny)
    endif
    ! Last raw
    do ix=image%nx-1,1,-1
       if (ieee_is_nan(image%val(ix,ny))) then
          value = 0.0
       else
          value = image%val(ix,ny)
       endif
       cumul%val(ix,ny) = cumul%val(ix+1,ny)+value
    enddo ! ix
    ! Other raws
    do iy=image%ny-1,1,-1
       ! Cumulate along x axis
       if (ieee_is_nan(image%val(nx,iy))) then
          cumul%val(nx,iy) = 0.0
       else
          cumul%val(nx,iy) = image%val(nx,iy)
       endif
       do ix=image%nx-1,1,-1
          if (ieee_is_nan(image%val(ix,iy))) then
             value = 0.0
          else
             value = image%val(ix,iy)
          endif
          cumul%val(ix,iy) = cumul%val(ix+1,iy)+value
       enddo ! ix
       ! Now cumulate current and previous raw
       do ix=1,image%nx
          cumul%val(ix,iy) = cumul%val(ix,iy)+cumul%val(ix,iy+1)
       enddo ! ix
    enddo ! iy
    do iy=1,image%ny
       do ix=1,image%nx
          !if (ieee_is_nan(image%val(ix,iy))) cumul%val(ix,iy) = gr4nan
          if (cumul%val(ix,iy).eq.0) cumul%val(ix,iy) = gr4nan
       enddo !ix
    enddo !iy
    call cumul%put(ie,error)
    if (error) return
  end subroutine cubecompute_cumulant_prog_act_from_trc
end module cubecompute_cumulant
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE GAUSSJ(A,N,NP,B,M,MP,QUIET,WARNING,ERROR)
      INTEGER N,NP,M,MP
      REAL*4 A(NP,NP),B(NP,MP)
      LOGICAL QUIET,WARNING,ERROR
*
      INTEGER NMAX
      PARAMETER (NMAX=512)  ! Dangerously large value, but the covariance
                            ! matrix is normally well conditioned
      INTEGER IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      INTEGER I,J,K,L,LL,IROW,ICOL
      REAL*4 BIG,DUM,PIVINV
*
      WARNING = .FALSE.
      ERROR = .FALSE.
      ICOL = -1E8  ! Cause an access violation if not set later 
      IROW = -1E8
      IF (N.GT.NMAX) THEN
         WRITE(6,*) 'F-GAUSSJ,  Insufficient internal work space'
         ERROR = .TRUE.
         RETURN
      ENDIF
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSEIF (IPIV(K).GT.1) THEN
                IF (.NOT.QUIET) THEN
                   WRITE(6,*) 'E-GAUSSJ,  Singular matrix'
                ENDIF
                ERROR = .TRUE.
                RETURN
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.) THEN
           IF (.NOT.QUIET) THEN
              WRITE(6,'(A)') 'E-GAUSSJ,  Singular matrix.'
           ENDIF
           ERROR = .TRUE.
           RETURN
        ENDIF
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END

*DECK E1
      FUNCTION E1 (X)
C***BEGIN PROLOGUE  E1
C***PURPOSE  Compute the exponential integral E1(X).
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C5
C***TYPE      SINGLE PRECISION (E1-S, DE1-D)
C***KEYWORDS  E1 FUNCTION, EXPONENTIAL INTEGRAL, FNLIB,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C E1 calculates the single precision exponential integral, E1(X), for
C positive single precision argument X and the Cauchy principal value
C for negative X.  If principal values are used everywhere, then, for
C all X,
C
C    E1(X) = -Ei(-X)
C or
C    Ei(X) = -E1(-X).
C
C
C Series for AE11       on the interval -1.00000D-01 to  0.
C                                        with weighted error   1.76E-17
C                                         log weighted error  16.75
C                               significant figures required  15.70
C                                    decimal places required  17.55
C
C
C Series for AE12       on the interval -2.50000D-01 to -1.00000D-01
C                                        with weighted error   5.83E-17
C                                         log weighted error  16.23
C                               significant figures required  15.76
C                                    decimal places required  16.93
C
C
C Series for E11        on the interval -4.00000D+00 to -1.00000D+00
C                                        with weighted error   1.08E-18
C                                         log weighted error  17.97
C                               significant figures required  19.02
C                                    decimal places required  18.61
C
C
C Series for E12        on the interval -1.00000D+00 to  1.00000D+00
C                                        with weighted error   3.15E-18
C                                         log weighted error  17.50
C                        approx significant figures required  15.8
C                                    decimal places required  18.10
C
C
C Series for AE13       on the interval  2.50000D-01 to  1.00000D+00
C                                        with weighted error   2.34E-17
C                                         log weighted error  16.63
C                               significant figures required  16.14
C                                    decimal places required  17.33
C
C
C Series for AE14       on the interval  0.          to  2.50000D-01
C                                        with weighted error   5.41E-17
C                                         log weighted error  16.27
C                               significant figures required  15.38
C                                    decimal places required  16.97
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CSEVL, INITS, R1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891115  Modified prologue description.  (WRB)
C   891115  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920618  Removed space from variable names.  (RWC, WRB)
C***END PROLOGUE  E1
      DIMENSION AE11CS(39), AE12CS(25), E11CS(19), E12CS(16),
     1  AE13CS(25), AE14CS(26)
      LOGICAL FIRST
      SAVE AE11CS, AE12CS, E11CS, E12CS, AE13CS, AE14CS,
     1 NTAE11, NTAE12, NTE11, NTE12, NTAE13, NTAE14, XMAX, FIRST
      DATA AE11CS( 1) /    .1215032397 1606579E0 /
      DATA AE11CS( 2) /   -.0650887785 13550150E0 /
      DATA AE11CS( 3) /    .0048976513 57459670E0 /
      DATA AE11CS( 4) /   -.0006492378 43027216E0 /
      DATA AE11CS( 5) /    .0000938404 34587471E0 /
      DATA AE11CS( 6) /    .0000004202 36380882E0 /
      DATA AE11CS( 7) /   -.0000081133 74735904E0 /
      DATA AE11CS( 8) /    .0000028042 47688663E0 /
      DATA AE11CS( 9) /    .0000000564 87164441E0 /
      DATA AE11CS(10) /   -.0000003448 09174450E0 /
      DATA AE11CS(11) /    .0000000582 09273578E0 /
      DATA AE11CS(12) /    .0000000387 11426349E0 /
      DATA AE11CS(13) /   -.0000000124 53235014E0 /
      DATA AE11CS(14) /   -.0000000051 18504888E0 /
      DATA AE11CS(15) /    .0000000021 48771527E0 /
      DATA AE11CS(16) /    .0000000008 68459898E0 /
      DATA AE11CS(17) /   -.0000000003 43650105E0 /
      DATA AE11CS(18) /   -.0000000001 79796603E0 /
      DATA AE11CS(19) /    .0000000000 47442060E0 /
      DATA AE11CS(20) /    .0000000000 40423282E0 /
      DATA AE11CS(21) /   -.0000000000 03543928E0 /
      DATA AE11CS(22) /   -.0000000000 08853444E0 /
      DATA AE11CS(23) /   -.0000000000 00960151E0 /
      DATA AE11CS(24) /    .0000000000 01692921E0 /
      DATA AE11CS(25) /    .0000000000 00607990E0 /
      DATA AE11CS(26) /   -.0000000000 00224338E0 /
      DATA AE11CS(27) /   -.0000000000 00200327E0 /
      DATA AE11CS(28) /   -.0000000000 00006246E0 /
      DATA AE11CS(29) /    .0000000000 00045571E0 /
      DATA AE11CS(30) /    .0000000000 00016383E0 /
      DATA AE11CS(31) /   -.0000000000 00005561E0 /
      DATA AE11CS(32) /   -.0000000000 00006074E0 /
      DATA AE11CS(33) /   -.0000000000 00000862E0 /
      DATA AE11CS(34) /    .0000000000 00001223E0 /
      DATA AE11CS(35) /    .0000000000 00000716E0 /
      DATA AE11CS(36) /   -.0000000000 00000024E0 /
      DATA AE11CS(37) /   -.0000000000 00000201E0 /
      DATA AE11CS(38) /   -.0000000000 00000082E0 /
      DATA AE11CS(39) /    .0000000000 00000017E0 /
      DATA AE12CS( 1) /    .5824174951 3472674E0 /
      DATA AE12CS( 2) /   -.1583488509 0578275E0 /
      DATA AE12CS( 3) /   -.0067642755 90323141E0 /
      DATA AE12CS( 4) /    .0051258439 50185725E0 /
      DATA AE12CS( 5) /    .0004352324 92169391E0 /
      DATA AE12CS( 6) /   -.0001436133 66305483E0 /
      DATA AE12CS( 7) /   -.0000418013 20556301E0 /
      DATA AE12CS( 8) /   -.0000027133 95758640E0 /
      DATA AE12CS( 9) /    .0000011513 81913647E0 /
      DATA AE12CS(10) /    .0000004206 50022012E0 /
      DATA AE12CS(11) /    .0000000665 81901391E0 /
      DATA AE12CS(12) /    .0000000006 62143777E0 /
      DATA AE12CS(13) /   -.0000000028 44104870E0 /
      DATA AE12CS(14) /   -.0000000009 40724197E0 /
      DATA AE12CS(15) /   -.0000000001 77476602E0 /
      DATA AE12CS(16) /   -.0000000000 15830222E0 /
      DATA AE12CS(17) /    .0000000000 02905732E0 /
      DATA AE12CS(18) /    .0000000000 01769356E0 /
      DATA AE12CS(19) /    .0000000000 00492735E0 /
      DATA AE12CS(20) /    .0000000000 00093709E0 /
      DATA AE12CS(21) /    .0000000000 00010707E0 /
      DATA AE12CS(22) /   -.0000000000 00000537E0 /
      DATA AE12CS(23) /   -.0000000000 00000716E0 /
      DATA AE12CS(24) /   -.0000000000 00000244E0 /
      DATA AE12CS(25) /   -.0000000000 00000058E0 /
      DATA E11CS( 1) / -16.1134616555 71494026E0 /
      DATA E11CS( 2) /   7.7940727787 426802769E0 /
      DATA E11CS( 3) /  -1.9554058188 631419507E0 /
      DATA E11CS( 4) /    .3733729386 6277945612E0 /
      DATA E11CS( 5) /   -.0569250319 1092901938E0 /
      DATA E11CS( 6) /    .0072110777 6966009185E0 /
      DATA E11CS( 7) /   -.0007810490 1449841593E0 /
      DATA E11CS( 8) /    .0000738809 3356262168E0 /
      DATA E11CS( 9) /   -.0000062028 6187580820E0 /
      DATA E11CS(10) /    .0000004681 6002303176E0 /
      DATA E11CS(11) /   -.0000000320 9288853329E0 /
      DATA E11CS(12) /    .0000000020 1519974874E0 /
      DATA E11CS(13) /   -.0000000001 1673686816E0 /
      DATA E11CS(14) /    .0000000000 0627627066E0 /
      DATA E11CS(15) /   -.0000000000 0031481541E0 /
      DATA E11CS(16) /    .0000000000 0001479904E0 /
      DATA E11CS(17) /   -.0000000000 0000065457E0 /
      DATA E11CS(18) /    .0000000000 0000002733E0 /
      DATA E11CS(19) /   -.0000000000 0000000108E0 /
      DATA E12CS( 1) /  -0.0373902147 92202795E0 /
      DATA E12CS( 2) /   0.0427239860 62209577E0 /
      DATA E12CS( 3) /   -.1303182079 849700544E0 /
      DATA E12CS( 4) /    .0144191240 2469889073E0 /
      DATA E12CS( 5) /   -.0013461707 8051068022E0 /
      DATA E12CS( 6) /    .0001073102 9253063780E0 /
      DATA E12CS( 7) /   -.0000074299 9951611943E0 /
      DATA E12CS( 8) /    .0000004537 7325690753E0 /
      DATA E12CS( 9) /   -.0000000247 6417211390E0 /
      DATA E12CS(10) /    .0000000012 2076581374E0 /
      DATA E12CS(11) /   -.0000000000 5485141480E0 /
      DATA E12CS(12) /    .0000000000 0226362142E0 /
      DATA E12CS(13) /   -.0000000000 0008635897E0 /
      DATA E12CS(14) /    .0000000000 0000306291E0 /
      DATA E12CS(15) /   -.0000000000 0000010148E0 /
      DATA E12CS(16) /    .0000000000 0000000315E0 /
      DATA AE13CS( 1) /   -.6057732466 4060346E0 /
      DATA AE13CS( 2) /   -.1125352434 8366090E0 /
      DATA AE13CS( 3) /    .0134322662 47902779E0 /
      DATA AE13CS( 4) /   -.0019268451 87381145E0 /
      DATA AE13CS( 5) /    .0003091183 37720603E0 /
      DATA AE13CS( 6) /   -.0000535641 32129618E0 /
      DATA AE13CS( 7) /    .0000098278 12880247E0 /
      DATA AE13CS( 8) /   -.0000018853 68984916E0 /
      DATA AE13CS( 9) /    .0000003749 43193568E0 /
      DATA AE13CS(10) /   -.0000000768 23455870E0 /
      DATA AE13CS(11) /    .0000000161 43270567E0 /
      DATA AE13CS(12) /   -.0000000034 66802211E0 /
      DATA AE13CS(13) /    .0000000007 58754209E0 /
      DATA AE13CS(14) /   -.0000000001 68864333E0 /
      DATA AE13CS(15) /    .0000000000 38145706E0 /
      DATA AE13CS(16) /   -.0000000000 08733026E0 /
      DATA AE13CS(17) /    .0000000000 02023672E0 /
      DATA AE13CS(18) /   -.0000000000 00474132E0 /
      DATA AE13CS(19) /    .0000000000 00112211E0 /
      DATA AE13CS(20) /   -.0000000000 00026804E0 /
      DATA AE13CS(21) /    .0000000000 00006457E0 /
      DATA AE13CS(22) /   -.0000000000 00001568E0 /
      DATA AE13CS(23) /    .0000000000 00000383E0 /
      DATA AE13CS(24) /   -.0000000000 00000094E0 /
      DATA AE13CS(25) /    .0000000000 00000023E0 /
      DATA AE14CS( 1) /   -.1892918000 753017E0 /
      DATA AE14CS( 2) /   -.0864811785 5259871E0 /
      DATA AE14CS( 3) /    .0072241015 4374659E0 /
      DATA AE14CS( 4) /   -.0008097559 4575573E0 /
      DATA AE14CS( 5) /    .0001099913 4432661E0 /
      DATA AE14CS( 6) /   -.0000171733 2998937E0 /
      DATA AE14CS( 7) /    .0000029856 2751447E0 /
      DATA AE14CS( 8) /   -.0000005659 6491457E0 /
      DATA AE14CS( 9) /    .0000001152 6808397E0 /
      DATA AE14CS(10) /   -.0000000249 5030440E0 /
      DATA AE14CS(11) /    .0000000056 9232420E0 /
      DATA AE14CS(12) /   -.0000000013 5995766E0 /
      DATA AE14CS(13) /    .0000000003 3846628E0 /
      DATA AE14CS(14) /   -.0000000000 8737853E0 /
      DATA AE14CS(15) /    .0000000000 2331588E0 /
      DATA AE14CS(16) /   -.0000000000 0641148E0 /
      DATA AE14CS(17) /    .0000000000 0181224E0 /
      DATA AE14CS(18) /   -.0000000000 0052538E0 /
      DATA AE14CS(19) /    .0000000000 0015592E0 /
      DATA AE14CS(20) /   -.0000000000 0004729E0 /
      DATA AE14CS(21) /    .0000000000 0001463E0 /
      DATA AE14CS(22) /   -.0000000000 0000461E0 /
      DATA AE14CS(23) /    .0000000000 0000148E0 /
      DATA AE14CS(24) /   -.0000000000 0000048E0 /
      DATA AE14CS(25) /    .0000000000 0000016E0 /
      DATA AE14CS(26) /   -.0000000000 0000005E0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  E1
      IF (FIRST) THEN
         ETA = 0.1*R1MACH(3)
         NTAE11 = INITS (AE11CS, 39, ETA)
         NTAE12 = INITS (AE12CS, 25, ETA)
         NTE11 = INITS (E11CS, 19, ETA)
         NTE12 = INITS (E12CS, 16, ETA)
         NTAE13 = INITS (AE13CS, 25, ETA)
         NTAE14 = INITS (AE14CS, 26, ETA)
C
         XMAXT = -LOG (R1MACH(1))
         XMAX = XMAXT - LOG(XMAXT)
      ENDIF
      FIRST = .FALSE.
C
      IF (X.GT.(-10.)) GO TO 20
C
C E1(X) = -EI(-X) FOR X .LE. -10.
C
      E1 = EXP(-X)/X * (1.+CSEVL (20./X+1., AE11CS, NTAE11))
      RETURN
C
 20   IF (X.GT.(-4.0)) GO TO 30
C
C E1(X) = -EI(-X) FOR -10. .LT. X .LE. -4.
C
      E1 = EXP(-X)/X * (1.+CSEVL ((40./X+7.)/3., AE12CS, NTAE12))
      RETURN
C
 30   IF (X.GT.(-1.0)) GO TO 40
C
C E1(X) = -EI(-X) FOR -4. .LT. X .LE. -1.
C
      E1 = -LOG(ABS(X)) + CSEVL ((2.*X+5.)/3., E11CS, NTE11)
      RETURN
C
 40   IF (X.GT.1.) GO TO 50
      IF (X .EQ. 0.) CALL XERMSG ('SLATEC', 'E1', 'X IS 0', 2, 2)
C
C E1(X) = -EI(-X) FOR -1. .LT. X .LE. 1.,  X .NE. 0.
C
      E1 = (-LOG(ABS(X)) - 0.6875 + X) + CSEVL (X, E12CS, NTE12)
      RETURN
C
 50   IF (X.GT.4.) GO TO 60
C
C E1(X) = -EI(-X) FOR 1. .LT. X .LE. 4.
C
      E1 = EXP(-X)/X * (1.+CSEVL ((8./X-5.)/3., AE13CS, NTAE13))
      RETURN
C
 60   IF (X.GT.XMAX) GO TO 70
C
C E1(X) = -EI(-X) FOR 4. .LT. X .LE. XMAX
C
      E1 = EXP(-X)/X * (1. + CSEVL (8./X-1., AE14CS, NTAE14))
      RETURN
C
C E1(X) = -EI(-X) FOR X .GT. XMAX
C
 70   CALL XERMSG ('SLATEC', 'E1', 'X SO BIG E1 UNDERFLOWS', 1, 1)
      E1 = 0.
      RETURN
C
      END
*DECK EFC
      SUBROUTINE EFC (NDATA, XDATA, YDATA, SDDATA, NORD, NBKPT, BKPT,
     +   MDEIN, MDEOUT, COEFF, LW, W)
C***BEGIN PROLOGUE  EFC
C***PURPOSE  Fit a piecewise polynomial curve to discrete data.
C            The piecewise polynomials are represented as B-splines.
C            The fitting is done in a weighted least squares sense.
C***LIBRARY   SLATEC
C***CATEGORY  K1A1A1, K1A2A, L8A3
C***TYPE      SINGLE PRECISION (EFC-S, DEFC-D)
C***KEYWORDS  B-SPLINE, CURVE FITTING, WEIGHTED LEAST SQUARES
C***AUTHOR  Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C      This subprogram fits a piecewise polynomial curve
C      to discrete data.  The piecewise polynomials are
C      represented as B-splines.
C      The fitting is done in a weighted least squares sense.
C
C      The data can be processed in groups of modest size.
C      The size of the group is chosen by the user.  This feature
C      may be necessary for purposes of using constrained curve fitting
C      with subprogram FC( ) on a very large data set.
C
C      For a description of the B-splines and usage instructions to
C      evaluate them, see
C
C      C. W. de Boor, Package for Calculating with B-Splines.
C                     SIAM J. Numer. Anal., p. 441, (June, 1977).
C
C      For further discussion of (constrained) curve fitting using
C      B-splines, see
C
C      R. J. Hanson, Constrained Least Squares Curve Fitting
C                   to Discrete Data Using B-Splines, a User's
C                   Guide. Sandia Labs. Tech. Rept. SAND-78-1291,
C                   December, (1978).
C
C  Input..
C      NDATA,XDATA(*),
C      YDATA(*),
C      SDDATA(*)
C                         The NDATA discrete (X,Y) pairs and the Y value
C                         standard deviation or uncertainty, SD, are in
C                         the respective arrays XDATA(*), YDATA(*), and
C                         SDDATA(*).  No sorting of XDATA(*) is
C                         required.  Any non-negative value of NDATA is
C                         allowed.  A negative value of NDATA is an
C                         error.  A zero value for any entry of
C                         SDDATA(*) will weight that data point as 1.
C                         Otherwise the weight of that data point is
C                         the reciprocal of this entry.
C
C      NORD,NBKPT,
C      BKPT(*)
C                         The NBKPT knots of the B-spline of order NORD
C                         are in the array BKPT(*).  Normally the
C                         problem data interval will be included between
C                         the limits BKPT(NORD) and BKPT(NBKPT-NORD+1).
C                         The additional end knots BKPT(I),I=1,...,
C                         NORD-1 and I=NBKPT-NORD+2,...,NBKPT, are
C                         required to compute the functions used to fit
C                         the data.  No sorting of BKPT(*) is required.
C                         Internal to  EFC( ) the extreme end knots may
C                         be reduced and increased respectively to
C                         accommodate any data values that are exterior
C                         to the given knot values.  The contents of
C                         BKPT(*) is not changed.
C
C                         NORD must be in the range 1 .LE. NORD .LE. 20.
C                         The value of NBKPT must satisfy the condition
C                         NBKPT .GE. 2*NORD.
C                         Other values are considered errors.
C
C                         (The order of the spline is one more than the
C                         degree of the piecewise polynomial defined on
C                         each interval.  This is consistent with the
C                         B-spline package convention.  For example,
C                         NORD=4 when we are using piecewise cubics.)
C
C        MDEIN
C                         An integer flag, with one of two possible
C                         values (1 or 2), that directs the subprogram
C                         action with regard to new data points provided
C                         by the user.
C
C                         =1  The first time that EFC( ) has been
C                         entered.  There are NDATA points to process.
C
C                         =2  This is another entry to EFC( ).  The sub-
C                         program EFC( ) has been entered with MDEIN=1
C                         exactly once before for this problem.  There
C                         are NDATA new additional points to merge and
C                         process with any previous points.
C                         (When using EFC( ) with MDEIN=2 it is import-
C                         ant that the set of knots remain fixed at the
C                         same values for all entries to EFC( ).)
C       LW
C                         The amount of working storage actually
C                         allocated for the working array W(*).
C                         This quantity is compared with the
C                         actual amount of storage needed in EFC( ).
C                         Insufficient storage allocated for W(*) is
C                         an error.  This feature was included in EFC( )
C                         because misreading the storage formula
C                         for W(*) might very well lead to subtle
C                         and hard-to-find programming bugs.
C
C                         The length of the array W(*) must satisfy
C
C                         LW .GE. (NBKPT-NORD+3)*(NORD+1)+
C                                 (NBKPT+1)*(NORD+1)+
C                               2*MAX(NDATA,NBKPT)+NBKPT+NORD**2
C
C  Output..
C      MDEOUT
C                         An output flag that indicates the status
C                         of the curve fit.
C
C                         =-1  A usage error of EFC( ) occurred.  The
C                         offending condition is noted with the SLATEC
C                         library error processor, XERMSG( ).  In case
C                         the working array W(*) is not long enough, the
C                         minimal acceptable length is printed.
C
C                         =1  The B-spline coefficients for the fitted
C                         curve have been returned in array COEFF(*).
C
C                         =2  Not enough data has been processed to
C                         determine the B-spline coefficients.
C                         The user has one of two options.  Continue
C                         to process more data until a unique set
C                         of coefficients is obtained, or use the
C                         subprogram FC( ) to obtain a specific
C                         set of coefficients.  The user should read
C                         the usage instructions for FC( ) for further
C                         details if this second option is chosen.
C      COEFF(*)
C                         If the output value of MDEOUT=1, this array
C                         contains the unknowns obtained from the least
C                         squares fitting process.  These N=NBKPT-NORD
C                         parameters are the B-spline coefficients.
C                         For MDEOUT=2, not enough data was processed to
C                         uniquely determine the B-spline coefficients.
C                         In this case, and also when MDEOUT=-1, all
C                         values of COEFF(*) are set to zero.
C
C                         If the user is not satisfied with the fitted
C                         curve returned by EFC( ), the constrained
C                         least squares curve fitting subprogram FC( )
C                         may be required.  The work done within EFC( )
C                         to accumulate the data can be utilized by
C                         the user, if so desired.  This involves
C                         saving the first (NBKPT-NORD+3)*(NORD+1)
C                         entries of W(*) and providing this data
C                         to FC( ) with the "old problem" designation.
C                         The user should read the usage instructions
C                         for subprogram FC( ) for further details.
C
C  Working Array..
C      W(*)
C                         This array is typed REAL.
C                         Its length is  specified as an input parameter
C                         in LW as noted above.  The contents of W(*)
C                         must not be modified by the user between calls
C                         to EFC( ) with values of MDEIN=1,2,2,... .
C                         The first (NBKPT-NORD+3)*(NORD+1) entries of
C                         W(*) are acceptable as direct input to FC( )
C                         for an "old problem" only when MDEOUT=1 or 2.
C
C  Evaluating the
C  Fitted Curve..
C                         To evaluate derivative number IDER at XVAL,
C                         use the function subprogram BVALU( ).
C
C                         F = BVALU(BKPT,COEFF,NBKPT-NORD,NORD,IDER,
C                                      XVAL,INBV,WORKB)
C
C                         The output of this subprogram will not be
C                         defined unless an output value of MDEOUT=1
C                         was obtained from EFC( ), XVAL is in the data
C                         interval, and IDER is nonnegative and .LT.
C                         NORD.
C
C                         The first time BVALU( ) is called, INBV=1
C                         must be specified.  This value of INBV is the
C                         overwritten by BVALU( ).  The array WORKB(*)
C                         must be of length at least 3*NORD, and must
C                         not be the same as the W(*) array used in the
C                         call to EFC( ).
C
C                         BVALU( ) expects the breakpoint array BKPT(*)
C                         to be sorted.
C
C***REFERENCES  R. J. Hanson, Constrained least squares curve fitting
C                 to discrete data using B-splines, a users guide,
C                 Report SAND78-1291, Sandia Laboratories, December
C                 1978.
C***ROUTINES CALLED  EFCMN
C***REVISION HISTORY  (YYMMDD)
C   800801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Change Prologue comments to refer to XERMSG.  (RWC)
C   900607  Editorial changes to Prologue to make Prologues for EFC,
C           DEFC, FC, and DFC look as much the same as possible.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  EFC
C
C      SUBROUTINE           FUNCTION/REMARKS
C
C      BSPLVN( )          COMPUTE FUNCTION VALUES OF B-SPLINES.  FROM
C                         THE B-SPLINE PACKAGE OF DE BOOR NOTED ABOVE.
C
C      BNDACC( ),         BANDED LEAST SQUARES MATRIX PROCESSORS.
C      BNDSOL( )          FROM LAWSON-HANSON, SOLVING LEAST
C                         SQUARES PROBLEMS.
C
C      SSORT( )           DATA SORTING SUBROUTINE, FROM THE
C                         SANDIA MATH. LIBRARY, SAND77-1441.
C
C      XERMSG( )          ERROR HANDLING ROUTINE
C                         FOR THE SLATEC MATH. LIBRARY.
C                         SEE SAND78-1189, BY R. E. JONES.
C
C      SCOPY( ),SSCAL( )  SUBROUTINES FROM THE BLAS PACKAGE.
C
C                         WRITTEN BY R. HANSON, SANDIA NATL. LABS.,
C                         ALB., N. M., AUGUST-SEPTEMBER, 1980.
C
      REAL BKPT(*),COEFF(*),SDDATA(*),W(*),XDATA(*),YDATA(*)
      INTEGER LW, MDEIN, MDEOUT, NBKPT, NDATA, NORD
C
      EXTERNAL EFCMN
C
      INTEGER LBF, LBKPT, LG, LPTEMP, LWW, LXTEMP, MDG, MDW
C
C***FIRST EXECUTABLE STATEMENT  EFC
C     LWW=1               USAGE IN EFCMN( ) OF W(*)..
C     LWW,...,LG-1        W(*,*)
C
C     LG,...,LXTEMP-1     G(*,*)
C
C     LXTEMP,...,LPTEMP-1 XTEMP(*)
C
C     LPTEMP,...,LBKPT-1  PTEMP(*)
C
C     LBKPT,...,LBF       BKPT(*) (LOCAL TO EFCMN( ))
C
C     LBF,...,LBF+NORD**2 BF(*,*)
C
      MDG = NBKPT+1
      MDW = NBKPT-NORD+3
      LWW = 1
      LG = LWW + MDW*(NORD+1)
      LXTEMP = LG + MDG*(NORD+1)
      LPTEMP = LXTEMP + MAX(NDATA,NBKPT)
      LBKPT  = LPTEMP + MAX(NDATA,NBKPT)
      LBF = LBKPT + NBKPT
      CALL EFCMN(NDATA,XDATA,YDATA,SDDATA,
     1         NORD,NBKPT,BKPT,
     2         MDEIN,MDEOUT,
     3         COEFF,
     4         W(LBF),W(LXTEMP),W(LPTEMP),W(LBKPT),
     5         W(LG),MDG,W(LWW),MDW,LW)
      RETURN
      END
*DECK EFCMN
      SUBROUTINE EFCMN (NDATA, XDATA, YDATA, SDDATA, NORD, NBKPT,
     +   BKPTIN, MDEIN, MDEOUT, COEFF, BF, XTEMP, PTEMP, BKPT, G, MDG,
     +   W, MDW, LW)
C***BEGIN PROLOGUE  EFCMN
C***SUBSIDIARY
C***PURPOSE  Subsidiary to EFC
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (EFCMN-S, DEFCMN-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C     This is a companion subprogram to EFC( ).
C     This subprogram does weighted least squares fitting of data by
C     B-spline curves.
C     The documentation for EFC( ) has complete usage instructions.
C
C***SEE ALSO  EFC
C***ROUTINES CALLED  BNDACC, BNDSOL, BSPLVN, SCOPY, SSCAL, SSORT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and extensively revised (WRB & RWC)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  EFCMN
      INTEGER LW, MDEIN, MDEOUT, MDG, MDW, NBKPT, NDATA, NORD
      REAL             BF(NORD,*), BKPT(*), BKPTIN(*), COEFF(*),
     *   G(MDG,*), PTEMP(*), SDDATA(*), W(MDW,*), XDATA(*), XTEMP(*),
     *   YDATA(*)
C
      EXTERNAL BNDACC, BNDSOL, BSPLVN, SCOPY, SSCAL, SSORT, XERMSG
C
      REAL             DUMMY, RNORM, XMAX, XMIN, XVAL
      INTEGER I, IDATA, ILEFT, INTSEQ, IP, IR, IROW, L, MT, N, NB,
     *   NORDM1, NORDP1, NP1
      CHARACTER*8 XERN1, XERN2
C
C***FIRST EXECUTABLE STATEMENT  EFCMN
C
C     Initialize variables and analyze input.
C
      N = NBKPT - NORD
      NP1 = N + 1
C
C     Initially set all output coefficients to zero.
C
      CALL SCOPY (N, 0.E0, 0, COEFF, 1)
      MDEOUT = -1
      IF (NORD.LT.1 .OR. NORD.GT.20) THEN
         CALL XERMSG ('SLATEC', 'EFCMN',
     +      'IN EFC, THE ORDER OF THE B-SPLINE MUST BE 1 THRU 20.',
     +      3, 1)
         RETURN
      ENDIF
C
      IF (NBKPT.LT.2*NORD) THEN
         CALL XERMSG ('SLATEC', 'EFCMN',
     +      'IN EFC, THE NUMBER OF KNOTS MUST BE AT LEAST TWICE ' //
     +      'THE B-SPLINE ORDER.', 4, 1)
         RETURN
      ENDIF
C
      IF (NDATA.LT.0) THEN
         CALL XERMSG ('SLATEC', 'EFCMN',
     +      'IN EFC, THE NUMBER OF DATA POINTS MUST BE NONNEGATIVE.',
     +      5, 1)
         RETURN
      ENDIF
C
      NB = (NBKPT-NORD+3)*(NORD+1) + (NBKPT+1)*(NORD+1) +
     +     2*MAX(NBKPT,NDATA) + NBKPT + NORD**2
      IF (LW .LT. NB) THEN
         WRITE (XERN1, '(I8)') NB
         WRITE (XERN2, '(I8)') LW
         CALL XERMSG ('SLATEC', 'EFCMN',
     *      'IN EFC, INSUFFICIENT STORAGE FOR W(*).  CHECK FORMULA ' //
     *      'THAT READS LW.GE. ... .  NEED = ' // XERN1 //
     *      ' GIVEN = ' // XERN2, 6, 1)
         MDEOUT = -1
         RETURN
      ENDIF
C
      IF (MDEIN.NE.1 .AND. MDEIN.NE.2) THEN
         CALL XERMSG ('SLATEC', 'EFCMN',
     +      'IN EFC, INPUT VALUE OF MDEIN MUST BE 1-2.', 7, 1)
         RETURN
      ENDIF
C
C     Sort the breakpoints.
C
      CALL SCOPY (NBKPT, BKPTIN, 1, BKPT, 1)
      CALL SSORT (BKPT, DUMMY, NBKPT, 1)
C
C     Save interval containing knots.
C
      XMIN = BKPT(NORD)
      XMAX = BKPT(NP1)
      NORDM1 = NORD - 1
      NORDP1 = NORD + 1
C
C     Process least squares equations.
C
C     Sort data and an array of pointers.
C
      CALL SCOPY (NDATA, XDATA, 1, XTEMP, 1)
      DO 100 I = 1,NDATA
         PTEMP(I) = I
  100 CONTINUE
C
      IF (NDATA.GT.0) THEN
         CALL SSORT (XTEMP, PTEMP, NDATA, 2)
         XMIN = MIN(XMIN,XTEMP(1))
         XMAX = MAX(XMAX,XTEMP(NDATA))
      ENDIF
C
C     Fix breakpoint array if needed. This should only involve very
C     minor differences with the input array of breakpoints.
C
      DO 110 I = 1,NORD
         BKPT(I) = MIN(BKPT(I),XMIN)
  110 CONTINUE
C
      DO 120 I = NP1,NBKPT
         BKPT(I) = MAX(BKPT(I),XMAX)
  120 CONTINUE
C
C     Initialize parameters of banded matrix processor, BNDACC( ).
C
      MT = 0
      IP = 1
      IR = 1
      ILEFT = NORD
      INTSEQ = 1
      DO 150 IDATA = 1,NDATA
C
C        Sorted indices are in PTEMP(*).
C
         L = PTEMP(IDATA)
         XVAL = XDATA(L)
C
C        When interval changes, process equations in the last block.
C
         IF (XVAL.GE.BKPT(ILEFT+1)) THEN
            CALL BNDACC (G, MDG, NORD, IP, IR, MT, ILEFT-NORDM1)
            MT = 0
C
C           Move pointer up to have BKPT(ILEFT).LE.XVAL, ILEFT.LE.N.
C
            DO 130 ILEFT = ILEFT,N
               IF (XVAL.LT.BKPT(ILEFT+1)) GO TO 140
               IF (MDEIN.EQ.2) THEN
C
C                 Data is being sequentially accumulated.
C                 Transfer previously accumulated rows from W(*,*) to
C                 G(*,*) and process them.
C
                  CALL SCOPY (NORDP1, W(INTSEQ,1), MDW, G(IR,1), MDG)
                  CALL BNDACC (G, MDG, NORD, IP, IR, 1, INTSEQ)
                  INTSEQ = INTSEQ + 1
               ENDIF
  130       CONTINUE
         ENDIF
C
C        Obtain B-spline function value.
C
  140    CALL BSPLVN (BKPT, NORD, 1, XVAL, ILEFT, BF)
C
C        Move row into place.
C
         IROW = IR + MT
         MT = MT + 1
         CALL SCOPY (NORD, BF, 1, G(IROW,1), MDG)
         G(IROW,NORDP1) = YDATA(L)
C
C        Scale data if uncertainty is nonzero.
C
         IF (SDDATA(L).NE.0.E0) CALL SSCAL (NORDP1, 1.E0/SDDATA(L),
     +                               G(IROW,1), MDG)
C
C        When staging work area is exhausted, process rows.
C
         IF (IROW.EQ.MDG-1) THEN
            CALL BNDACC (G, MDG, NORD, IP, IR, MT, ILEFT-NORDM1)
            MT = 0
         ENDIF
  150 CONTINUE
C
C     Process last block of equations.
C
      CALL BNDACC (G, MDG, NORD, IP, IR, MT, ILEFT-NORDM1)
C
C     Finish processing any previously accumulated rows from W(*,*)
C     to G(*,*).
C
      IF (MDEIN.EQ.2) THEN
         DO 160 I = INTSEQ,NP1
            CALL SCOPY (NORDP1, W(I,1), MDW, G(IR,1), MDG)
            CALL BNDACC (G, MDG, NORD, IP, IR, 1, MIN(N,I))
  160    CONTINUE
      ENDIF
C
C     Last call to adjust block positioning.
C
      CALL SCOPY (NORDP1, 0.E0, 0, G(IR,1), MDG)
      CALL BNDACC (G, MDG, NORD, IP, IR, 1, NP1)
C
C     Transfer accumulated rows from G(*,*) to W(*,*) for
C     possible later sequential accumulation.
C
      DO 170 I = 1,NP1
         CALL SCOPY (NORDP1, G(I,1), MDG, W(I,1), MDW)
  170 CONTINUE
C
C     Solve for coefficients when possible.
C
      DO 180 I = 1,N
         IF (G(I,1).EQ.0.E0) THEN
            MDEOUT = 2
            RETURN
         ENDIF
  180 CONTINUE
C
C     All the diagonal terms in the accumulated triangular
C     matrix are nonzero.  The solution can be computed but
C     it may be unsuitable for further use due to poor
C     conditioning or the lack of constraints.  No checking
C     for either of these is done here.
C
      CALL BNDSOL (1, G, MDG, NORD, IP, IR, COEFF, N, RNORM)
      MDEOUT = 1
      RETURN
      END
*DECK EI
      FUNCTION EI (X)
C***BEGIN PROLOGUE  EI
C***PURPOSE  Compute the exponential integral Ei(X).
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C5
C***TYPE      SINGLE PRECISION (EI-S, DEI-D)
C***KEYWORDS  EI FUNCTION, EXPONENTIAL INTEGRAL, FNLIB,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C EI calculates the single precision exponential integral, Ei(X), for
C positive single precision argument X and the Cauchy principal value
C for negative X.  If principal values are used everywhere, then, for
C all X,
C
C    Ei(X) = -E1(-X)
C or
C    E1(X) = -Ei(-X).
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  E1
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   891115  Modified prologue description.  (WRB)
C   891115  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  EI
C***FIRST EXECUTABLE STATEMENT  EI
      EI = -E1(-X)
C
      RETURN
      END
*DECK EISDOC
      SUBROUTINE EISDOC
C***BEGIN PROLOGUE  EISDOC
C***PURPOSE  Documentation for EISPACK, a collection of subprograms for
C            solving matrix eigen-problems.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4, Z
C***TYPE      ALL (EISDOC-A)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Vandevender, W. H., (SNLA)
C***DESCRIPTION
C
C                 **********EISPACK Routines**********
C
C single double complx
C ------ ------ ------
C
C RS       -    CH     Computes eigenvalues and, optionally,
C                      eigenvectors of real symmetric
C                      (complex Hermitian) matrix.
C
C RSP      -      -    Compute eigenvalues and, optionally,
C                      eigenvectors of real symmetric matrix
C                      packed into a one dimensional array.
C
C RG       -    CG     Computes eigenvalues and, optionally,
C                      eigenvectors of a real (complex) general
C                      matrix.
C
C BISECT   -      -    Compute eigenvalues of symmetric tridiagonal
C                      matrix given interval using Sturm sequencing.
C
C IMTQL1   -      -    Computes eigenvalues of symmetric tridiagonal
C                      matrix implicit QL method.
C
C IMTQL2   -      -    Computes eigenvalues and eigenvectors of
C                      symmetric tridiagonal matrix using
C                      implicit QL method.
C
C IMTQLV   -      -    Computes eigenvalues of symmetric tridiagonal
C                      matrix by the implicit QL method.
C                      Eigenvectors may be computed later.
C
C RATQR    -      -    Computes largest or smallest eigenvalues
C                      of symmetric tridiagonal matrix using
C                      rational QR method with Newton correction.
C
C RST      -      -    Compute eigenvalues and, optionally,
C                      eigenvectors of real symmetric tridiagonal
C                      matrix.
C
C RT       -      -    Compute eigenvalues and eigenvectors of
C                      a special real tridiagonal matrix.
C
C TQL1     -      -    Compute eigenvalues of symmetric tridiagonal
C                      matrix by QL method.
C
C TQL2     -      -    Compute eigenvalues and eigenvectors
C                      of symmetric tridiagonal matrix.
C
C TQLRAT   -      -    Computes eigenvalues of symmetric
C                      tridiagonal matrix a rational variant
C                      of the QL method.
C
C TRIDIB   -      -    Computes eigenvalues of symmetric
C                      tridiagonal matrix given interval using
C                      Sturm sequencing.
C
C TSTURM   -      -    Computes eigenvalues of symmetric tridiagonal
C                      matrix given interval and eigenvectors
C                      by Sturm sequencing.  This subroutine
C                      is a translation of the ALGOL procedure
C                      TRISTURM by Peters and Wilkinson. HANDBOOK
C                      FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA,
C                      418-439(1971).
C
C BQR      -      -    Computes some of the eigenvalues of a real
C                      symmetric matrix using the QR method with
C                      shifts of origin.
C
C RSB      -      -    Computes eigenvalues and, optionally,
C                      eigenvectors of symmetric band matrix.
C
C RSG      -      -    Computes eigenvalues and, optionally,
C                      eigenvectors of symmetric generalized
C                      eigenproblem: A*X=(LAMBDA)*B*X
C
C RSGAB    -      -    Computes eigenvalues and, optionally,
C                      eigenvectors of symmetric generalized
C                      eigenproblem: A*B*X=(LAMBDA)*X
C
C RSGBA    -      -    Computes eigenvalues and, optionally,
C                      eigenvectors of symmetric generalized
C                      eigenproblem: B*A*X=(LAMBDA)*X
C
C RGG      -      -    Computes eigenvalues and eigenvectors
C                      for real generalized eigenproblem:
C                      A*X=(LAMBDA)*B*X.
C
C BALANC   -    CBAL   Balances a general real (complex)
C                      matrix and isolates eigenvalues whenever
C                      possible.
C
C BANDR    -      -    Reduces real symmetric band matrix
C                      to symmetric tridiagonal matrix and,
C                      optionally, accumulates orthogonal similarity
C                      transformations.
C
C HTRID3   -      -    Reduces complex Hermitian (packed) matrix
C                      to real symmetric tridiagonal matrix by unitary
C                      similarity transformations.
C
C HTRIDI   -      -    Reduces complex Hermitian matrix to real
C                      symmetric tridiagonal matrix using unitary
C                      similarity transformations.
C
C TRED1    -      -    Reduce real symmetric matrix to symmetric
C                      tridiagonal matrix using orthogonal
C                      similarity transformations.
C
C TRED2    -      -    Reduce real symmetric matrix to symmetric
C                      tridiagonal matrix using and accumulating
C                      orthogonal transformations.
C
C TRED3    -      -    Reduce  symmetric matrix stored in packed
C                      form to symmetric tridiagonal matrix using
C                      orthogonal transformations.
C
C ELMHES   -    COMHES Reduces real (complex) general matrix to
C                      upper Hessenberg form using stabilized
C                      elementary similarity transformations.
C
C ORTHES   -    CORTH  Reduces real (complex) general matrix to upper
C                      Hessenberg form orthogonal (unitary)
C                      similarity transformations.
C
C QZHES    -      -    The first step of the QZ algorithm for solving
C                      generalized matrix eigenproblems.  Accepts
C                      a pair of real general matrices and reduces
C                      one of them to upper Hessenberg and the other
C                      to upper triangular form using orthogonal
C                      transformations. Usually followed by QZIT,
C                      QZVAL, QZ
C
C QZIT     -      -    The second step of the QZ algorithm for
C                      generalized eigenproblems.  Accepts an upper
C                      Hessenberg and an upper triangular matrix
C                      and reduces the former to quasi-triangular
C                      form while preserving the form of the latter.
C                      Usually preceded by QZHES and followed by QZVAL
C                      and QZVEC.
C
C FIGI     -      -    Transforms certain real non-symmetric
C                      tridiagonal matrix to symmetric tridiagonal
C                      matrix.
C
C FIGI2    -      -    Transforms certain real non-symmetric
C                      tridiagonal matrix to symmetric tridiagonal
C                      matrix.
C
C REDUC    -      -    Reduces generalized symmetric eigenproblem
C                      A*X=(LAMBDA)*B*X, to standard symmetric
C                      eigenproblem using Cholesky factorization.
C
C REDUC2   -      -    Reduces certain generalized symmetric
C                      eigenproblems standard symmetric eigenproblem,
C                      using Cholesky factorization.
C
C   -      -    COMLR  Computes eigenvalues of a complex upper
C                      Hessenberg matrix using the modified LR method.
C
C   -      -    COMLR2 Computes eigenvalues and eigenvectors of
C                      complex upper Hessenberg matrix using
C                      modified LR method.
C
C HQR      -    COMQR  Computes eigenvalues of a real (complex)
C                      upper Hessenberg matrix using the QR method.
C
C HQR2     -    COMQR2 Computes eigenvalues and eigenvectors of
C                      real (complex) upper Hessenberg matrix
C                      using QR method.
C
C INVIT    -    CINVIT Computes eigenvectors of real (complex)
C                      Hessenberg matrix associated with specified
C                      eigenvalues by inverse iteration.
C
C QZVAL    -      -    The third step of the QZ algorithm for
C                      generalized eigenproblems.  Accepts a pair
C                      of real matrices, one quasi-triangular form
C                      and the other in upper triangular form and
C                      computes the eigenvalues of the associated
C                      eigenproblem.  Usually preceded by QZHES,
C                      QZIT, and followed by QZVEC.
C
C BANDV    -      -    Forms eigenvectors of real symmetric band
C                      matrix associated with a set of ordered
C                      approximate eigenvalue by inverse iteration.
C
C QZVEC    -      -    The optional fourth step of the QZ algorithm
C                      for generalized eigenproblems.  Accepts
C                      a matrix in quasi-triangular form and another
C                      in upper triangular and computes the
C                      eigenvectors of the triangular problem
C                      and transforms them back to the original
C                      coordinates Usually preceded by QZHES, QZIT,
C                      QZVAL.
C
C TINVIT   -      -    Eigenvectors of symmetric tridiagonal
C                      matrix corresponding to some specified
C                      eigenvalues, using inverse iteration.
C
C BAKVEC   -      -    Forms eigenvectors of certain real
C                      non-symmetric tridiagonal matrix from
C                      symmetric tridiagonal matrix output from FIGI.
C
C BALBAK   -    CBABK2 Forms eigenvectors of real (complex) general
C                      matrix from eigenvectors of matrix output
C                      from BALANC (CBAL).
C
C ELMBAK   -    COMBAK Forms eigenvectors of real (complex) general
C                      matrix from eigenvectors of upper Hessenberg
C                      matrix output from ELMHES (COMHES).
C
C ELTRAN   -      -    Accumulates the stabilized elementary
C                      similarity transformations used in the
C                      reduction of a real general matrix to upper
C                      Hessenberg form by ELMHES.
C
C HTRIB3   -      -    Computes eigenvectors of complex Hermitian
C                      matrix from eigenvectors of real symmetric
C                      tridiagonal matrix output from HTRID3.
C
C HTRIBK   -      -    Forms eigenvectors of complex Hermitian
C                      matrix from eigenvectors of real symmetric
C                      tridiagonal matrix output from HTRIDI.
C
C ORTBAK   -    CORTB  Forms eigenvectors of general real (complex)
C                      matrix from eigenvectors of upper Hessenberg
C                      matrix output from ORTHES (CORTH).
C
C ORTRAN   -      -    Accumulates orthogonal similarity
C                      transformations in reduction of real general
C                      matrix by ORTHES.
C
C REBAK    -      -    Forms eigenvectors of generalized symmetric
C                      eigensystem from eigenvectors of derived
C                      matrix output from REDUC or REDUC2.
C
C REBAKB   -      -    Forms eigenvectors of generalized symmetric
C                      eigensystem from eigenvectors of derived
C                      matrix output from REDUC2
C
C TRBAK1   -      -    Forms the eigenvectors of real symmetric
C                      matrix from eigenvectors of symmetric
C                      tridiagonal matrix formed by TRED1.
C
C TRBAK3   -      -    Forms eigenvectors of real symmetric matrix
C                      from the eigenvectors of symmetric tridiagonal
C                      matrix formed by TRED3.
C
C MINFIT   -      -    Compute Singular Value Decomposition
C                      of rectangular matrix and solve related
C                      Linear Least Squares problem.
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   811101  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900723  PURPOSE section revised.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  EISDOC
C***FIRST EXECUTABLE STATEMENT  EISDOC
      RETURN
      END
*DECK ELMBAK
      SUBROUTINE ELMBAK (NM, LOW, IGH, A, INT, M, Z)
C***BEGIN PROLOGUE  ELMBAK
C***PURPOSE  Form the eigenvectors of a real general matrix from the
C            eigenvectors of the upper Hessenberg matrix output from
C            ELMHES.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      SINGLE PRECISION (ELMBAK-S, COMBAK-C)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure ELMBAK,
C     NUM. MATH. 12, 349-368(1968) by Martin and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 339-358(1971).
C
C     This subroutine forms the eigenvectors of a REAL GENERAL
C     matrix by back transforming those of the corresponding
C     upper Hessenberg matrix determined by  ELMHES.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        LOW and IGH are two INTEGER variables determined by the
C          balancing subroutine  BALANC.  If  BALANC  has not been
C          used, set LOW=1 and IGH equal to the order of the matrix.
C
C        A contains the multipliers which were used in the reduction
C          by  ELMHES  in its lower triangle below the subdiagonal.
C          A is a two-dimensional REAL array, dimensioned A(NM,IGH).
C
C        INT contains information on the rows and columns interchanged
C          in the reduction by  ELMHES.  Only elements LOW through IGH
C          are used.  INT is a one-dimensional INTEGER array,
C          dimensioned INT(IGH).
C
C        M is the number of columns of Z to be back transformed.
C          M is an INTEGER variable.
C
C        Z contains the real and imaginary parts of the eigenvectors
C          to be back transformed in its first M columns.  Z is a
C          two-dimensional REAL array, dimensioned Z(NM,M).
C
C     On OUTPUT
C
C        Z contains the real and imaginary parts of the transformed
C          eigenvectors in its first M columns.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ELMBAK
C
      INTEGER I,J,M,LA,MM,MP,NM,IGH,KP1,LOW,MP1
      REAL A(NM,*),Z(NM,*)
      REAL X
      INTEGER INT(*)
C
C***FIRST EXECUTABLE STATEMENT  ELMBAK
      IF (M .EQ. 0) GO TO 200
      LA = IGH - 1
      KP1 = LOW + 1
      IF (LA .LT. KP1) GO TO 200
C     .......... FOR MP=IGH-1 STEP -1 UNTIL LOW+1 DO -- ..........
      DO 140 MM = KP1, LA
         MP = LOW + IGH - MM
         MP1 = MP + 1
C
         DO 110 I = MP1, IGH
            X = A(I,MP-1)
            IF (X .EQ. 0.0E0) GO TO 110
C
            DO 100 J = 1, M
  100       Z(I,J) = Z(I,J) + X * Z(MP,J)
C
  110    CONTINUE
C
         I = INT(MP)
         IF (I .EQ. MP) GO TO 140
C
         DO 130 J = 1, M
            X = Z(I,J)
            Z(I,J) = Z(MP,J)
            Z(MP,J) = X
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END
*DECK ELMHES
      SUBROUTINE ELMHES (NM, N, LOW, IGH, A, INT)
C***BEGIN PROLOGUE  ELMHES
C***PURPOSE  Reduce a real general matrix to upper Hessenberg form
C            using stabilized elementary similarity transformations.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1B2
C***TYPE      SINGLE PRECISION (ELMHES-S, COMHES-C)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure ELMHES,
C     NUM. MATH. 12, 349-368(1968) by Martin and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 339-358(1971).
C
C     Given a REAL GENERAL matrix, this subroutine
C     reduces a submatrix situated in rows and columns
C     LOW through IGH to upper Hessenberg form by
C     stabilized elementary similarity transformations.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, A, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix, A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        LOW and IGH are two INTEGER variables determined by the
C          balancing subroutine  BALANC.  If  BALANC  has not been
C          used, set LOW=1 and IGH equal to the order of the matrix, N.
C
C        A contains the input matrix.  A is a two-dimensional REAL
C          array, dimensioned A(NM,N).
C
C     On OUTPUT
C
C        A contains the upper Hessenberg matrix.  The multipliers which
C          were used in the reduction are stored in the remaining
C          triangle under the Hessenberg matrix.
C
C        INT contains information on the rows and columns interchanged
C          in the reduction.  Only elements LOW through IGH are used.
C          INT is a one-dimensional INTEGER array, dimensioned INT(IGH).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ELMHES
C
      INTEGER I,J,M,N,LA,NM,IGH,KP1,LOW,MM1,MP1
      REAL A(NM,*)
      REAL X,Y
      INTEGER INT(*)
C
C***FIRST EXECUTABLE STATEMENT  ELMHES
      LA = IGH - 1
      KP1 = LOW + 1
      IF (LA .LT. KP1) GO TO 200
C
      DO 180 M = KP1, LA
         MM1 = M - 1
         X = 0.0E0
         I = M
C
         DO 100 J = M, IGH
            IF (ABS(A(J,MM1)) .LE. ABS(X)) GO TO 100
            X = A(J,MM1)
            I = J
  100    CONTINUE
C
         INT(M) = I
         IF (I .EQ. M) GO TO 130
C    .......... INTERCHANGE ROWS AND COLUMNS OF A ..........
         DO 110 J = MM1, N
            Y = A(I,J)
            A(I,J) = A(M,J)
            A(M,J) = Y
  110    CONTINUE
C
         DO 120 J = 1, IGH
            Y = A(J,I)
            A(J,I) = A(J,M)
            A(J,M) = Y
  120    CONTINUE
C    .......... END INTERCHANGE ..........
  130    IF (X .EQ. 0.0E0) GO TO 180
         MP1 = M + 1
C
         DO 160 I = MP1, IGH
            Y = A(I,MM1)
            IF (Y .EQ. 0.0E0) GO TO 160
            Y = Y / X
            A(I,MM1) = Y
C
            DO 140 J = M, N
  140       A(I,J) = A(I,J) - Y * A(M,J)
C
            DO 150 J = 1, IGH
  150       A(J,M) = A(J,M) + Y * A(J,I)
C
  160    CONTINUE
C
  180 CONTINUE
C
  200 RETURN
      END
*DECK ELTRAN
      SUBROUTINE ELTRAN (NM, N, LOW, IGH, A, INT, Z)
C***BEGIN PROLOGUE  ELTRAN
C***PURPOSE  Accumulates the stabilized elementary similarity
C            transformations used in the reduction of a real general
C            matrix to upper Hessenberg form by ELMHES.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      SINGLE PRECISION (ELTRAN-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure ELMTRANS,
C     NUM. MATH. 16, 181-204(1970) by Peters and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 372-395(1971).
C
C     This subroutine accumulates the stabilized elementary
C     similarity transformations used in the reduction of a
C     REAL GENERAL matrix to upper Hessenberg form by  ELMHES.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        LOW and IGH are two INTEGER variables determined by the
C          balancing subroutine  BALANC.  If  BALANC  has not been
C          used, set LOW=1 and IGH equal to the order of the matrix, N.
C
C        A contains the multipliers which were used in the reduction
C          by  ELMHES  in its lower triangle below the subdiagonal.
C          A is a two-dimensional REAL array, dimensioned A(NM,IGH).
C
C        INT contains information on the rows and columns interchanged
C          in the reduction by  ELMHES.  Only elements LOW through IGH
C          are used.  INT is a one-dimensional INTEGER array,
C          dimensioned INT(IGH).
C
C     On OUTPUT
C
C        Z contains the transformation matrix produced in the reduction
C          by  ELMHES.  Z is a two-dimensional REAL array, dimensioned
C          Z(NM,N).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ELTRAN
C
      INTEGER I,J,N,KL,MM,MP,NM,IGH,LOW,MP1
      REAL A(NM,*),Z(NM,*)
      INTEGER INT(*)
C
C***FIRST EXECUTABLE STATEMENT  ELTRAN
      DO 80 I = 1, N
C
         DO 60 J = 1, N
   60    Z(I,J) = 0.0E0
C
         Z(I,I) = 1.0E0
   80 CONTINUE
C
      KL = IGH - LOW - 1
      IF (KL .LT. 1) GO TO 200
C     .......... FOR MP=IGH-1 STEP -1 UNTIL LOW+1 DO -- ..........
      DO 140 MM = 1, KL
         MP = IGH - MM
         MP1 = MP + 1
C
         DO 100 I = MP1, IGH
  100    Z(I,MP) = A(I,MP-1)
C
         I = INT(MP)
         IF (I .EQ. MP) GO TO 140
C
         DO 130 J = MP, IGH
            Z(MP,J) = Z(I,J)
            Z(I,J) = 0.0E0
  130    CONTINUE
C
         Z(I,MP) = 1.0E0
  140 CONTINUE
C
  200 RETURN
      END
*DECK ENORM
      REAL FUNCTION ENORM (N, X)
C***BEGIN PROLOGUE  ENORM
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SNLS1, SNLS1E, SNSQ and SNSQE
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (ENORM-S, DENORM-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     Given an N-vector X, this function calculates the
C     Euclidean norm of X.
C
C     The Euclidean norm is computed by accumulating the sum of
C     squares in three different sums. The sums of squares for the
C     small and large components are scaled so that no overflows
C     occur. Non-destructive underflows are permitted. Underflows
C     and overflows do not occur in the computation of the unscaled
C     sum of squares for the intermediate components.
C     The definitions of small, intermediate and large components
C     depend on two constants, RDWARF and RGIANT. The main
C     restrictions on these constants are that RDWARF**2 not
C     underflow and RGIANT**2 not overflow. The constants
C     given here are suitable for every known computer.
C
C     The function statement is
C
C       REAL FUNCTION ENORM(N,X)
C
C     where
C
C       N is a positive integer input variable.
C
C       X is an input array of length N.
C
C***SEE ALSO  SNLS1, SNLS1E, SNSQ, SNSQE
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  ENORM
      INTEGER N
      REAL X(*)
      INTEGER I
      REAL AGIANT,FLOATN,ONE,RDWARF,RGIANT,S1,S2,S3,XABS,X1MAX,X3MAX,
     1     ZERO
      SAVE ONE, ZERO, RDWARF, RGIANT
      DATA ONE,ZERO,RDWARF,RGIANT /1.0E0,0.0E0,3.834E-20,1.304E19/
C***FIRST EXECUTABLE STATEMENT  ENORM
      S1 = ZERO
      S2 = ZERO
      S3 = ZERO
      X1MAX = ZERO
      X3MAX = ZERO
      FLOATN = N
      AGIANT = RGIANT/FLOATN
      DO 90 I = 1, N
         XABS = ABS(X(I))
         IF (XABS .GT. RDWARF .AND. XABS .LT. AGIANT) GO TO 70
            IF (XABS .LE. RDWARF) GO TO 30
C
C              SUM FOR LARGE COMPONENTS.
C
               IF (XABS .LE. X1MAX) GO TO 10
                  S1 = ONE + S1*(X1MAX/XABS)**2
                  X1MAX = XABS
                  GO TO 20
   10          CONTINUE
                  S1 = S1 + (XABS/X1MAX)**2
   20          CONTINUE
               GO TO 60
   30       CONTINUE
C
C              SUM FOR SMALL COMPONENTS.
C
               IF (XABS .LE. X3MAX) GO TO 40
                  S3 = ONE + S3*(X3MAX/XABS)**2
                  X3MAX = XABS
                  GO TO 50
   40          CONTINUE
                  IF (XABS .NE. ZERO) S3 = S3 + (XABS/X3MAX)**2
   50          CONTINUE
   60       CONTINUE
            GO TO 80
   70    CONTINUE
C
C           SUM FOR INTERMEDIATE COMPONENTS.
C
            S2 = S2 + XABS**2
   80    CONTINUE
   90    CONTINUE
C
C     CALCULATION OF NORM.
C
      IF (S1 .EQ. ZERO) GO TO 100
         ENORM = X1MAX*SQRT(S1+(S2/X1MAX)/X1MAX)
         GO TO 130
  100 CONTINUE
         IF (S2 .EQ. ZERO) GO TO 110
            IF (S2 .GE. X3MAX)
     1         ENORM = SQRT(S2*(ONE+(X3MAX/S2)*(X3MAX*S3)))
            IF (S2 .LT. X3MAX)
     1         ENORM = SQRT(X3MAX*((S2/X3MAX)+(X3MAX*S3)))
            GO TO 120
  110    CONTINUE
            ENORM = X3MAX*SQRT(S3)
  120    CONTINUE
  130 CONTINUE
      RETURN
C
C     LAST CARD OF FUNCTION ENORM.
C
      END
*DECK ERF
      FUNCTION ERF (X)
C***BEGIN PROLOGUE  ERF
C***PURPOSE  Compute the error function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C8A, L5A1E
C***TYPE      SINGLE PRECISION (ERF-S, DERF-D)
C***KEYWORDS  ERF, ERROR FUNCTION, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ERF(X) calculates the single precision error function for
C single precision argument X.
C
C Series for ERF        on the interval  0.          to  1.00000D+00
C                                        with weighted error   7.10E-18
C                                         log weighted error  17.15
C                               significant figures required  16.31
C                                    decimal places required  17.71
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CSEVL, ERFC, INITS, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900727  Added EXTERNAL statement.  (WRB)
C   920618  Removed space from variable name.  (RWC, WRB)
C***END PROLOGUE  ERF
      DIMENSION ERFCS(13)
      LOGICAL FIRST
      EXTERNAL ERFC
      SAVE ERFCS, SQRTPI, NTERF, XBIG, SQEPS, FIRST
      DATA ERFCS( 1) /   -.0490461212 34691808E0 /
      DATA ERFCS( 2) /   -.1422612051 0371364E0 /
      DATA ERFCS( 3) /    .0100355821 87599796E0 /
      DATA ERFCS( 4) /   -.0005768764 69976748E0 /
      DATA ERFCS( 5) /    .0000274199 31252196E0 /
      DATA ERFCS( 6) /   -.0000011043 17550734E0 /
      DATA ERFCS( 7) /    .0000000384 88755420E0 /
      DATA ERFCS( 8) /   -.0000000011 80858253E0 /
      DATA ERFCS( 9) /    .0000000000 32334215E0 /
      DATA ERFCS(10) /   -.0000000000 00799101E0 /
      DATA ERFCS(11) /    .0000000000 00017990E0 /
      DATA ERFCS(12) /   -.0000000000 00000371E0 /
      DATA ERFCS(13) /    .0000000000 00000007E0 /
      DATA SQRTPI /1.772453850 9055160E0/
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  ERF
      IF (FIRST) THEN
         NTERF = INITS (ERFCS, 13, 0.1*R1MACH(3))
         XBIG = SQRT(-LOG(SQRTPI*R1MACH(3)))
         SQEPS = SQRT(2.0*R1MACH(3))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.1.) GO TO 20
C
C ERF(X) = 1. - ERFC(X) FOR -1. .LE. X .LE. 1.
C
      IF (Y.LE.SQEPS) ERF = 2.0*X/SQRTPI
      IF (Y.GT.SQEPS) ERF = X*(1.0 + CSEVL(2.*X**2-1., ERFCS, NTERF))
      RETURN
C
C ERF(X) = 1. - ERFC(X) FOR  ABS(X) .GT. 1.
C
 20   IF (Y.LE.XBIG) ERF = SIGN (1.0-ERFC(Y), X)
      IF (Y.GT.XBIG) ERF = SIGN (1.0, X)
C
      RETURN
      END
*DECK ERFC
      FUNCTION ERFC (X)
C***BEGIN PROLOGUE  ERFC
C***PURPOSE  Compute the complementary error function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C8A, L5A1E
C***TYPE      SINGLE PRECISION (ERFC-S, DERFC-D)
C***KEYWORDS  COMPLEMENTARY ERROR FUNCTION, ERFC, FNLIB,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ERFC(X) calculates the single precision complementary error
C function for single precision argument X.
C
C Series for ERF        on the interval  0.          to  1.00000D+00
C                                        with weighted error   7.10E-18
C                                         log weighted error  17.15
C                               significant figures required  16.31
C                                    decimal places required  17.71
C
C Series for ERFC       on the interval  0.          to  2.50000D-01
C                                        with weighted error   4.81E-17
C                                         log weighted error  16.32
C                        approx significant figures required  15.0
C
C
C Series for ERC2       on the interval  2.50000D-01 to  1.00000D+00
C                                        with weighted error   5.22E-17
C                                         log weighted error  16.28
C                        approx significant figures required  15.0
C                                    decimal places required  16.96
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CSEVL, INITS, R1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920618  Removed space from variable names.  (RWC, WRB)
C***END PROLOGUE  ERFC
      DIMENSION ERFCS(13), ERFCCS(24), ERC2CS(23)
      LOGICAL FIRST
      SAVE ERFCS, ERC2CS, ERFCCS, SQRTPI, NTERF, NTERFC,
     1 NTERC2, XSML, XMAX, SQEPS, FIRST
      DATA ERFCS( 1) /   -.0490461212 34691808E0 /
      DATA ERFCS( 2) /   -.1422612051 0371364E0 /
      DATA ERFCS( 3) /    .0100355821 87599796E0 /
      DATA ERFCS( 4) /   -.0005768764 69976748E0 /
      DATA ERFCS( 5) /    .0000274199 31252196E0 /
      DATA ERFCS( 6) /   -.0000011043 17550734E0 /
      DATA ERFCS( 7) /    .0000000384 88755420E0 /
      DATA ERFCS( 8) /   -.0000000011 80858253E0 /
      DATA ERFCS( 9) /    .0000000000 32334215E0 /
      DATA ERFCS(10) /   -.0000000000 00799101E0 /
      DATA ERFCS(11) /    .0000000000 00017990E0 /
      DATA ERFCS(12) /   -.0000000000 00000371E0 /
      DATA ERFCS(13) /    .0000000000 00000007E0 /
      DATA ERC2CS( 1) /   -.0696013466 02309501E0 /
      DATA ERC2CS( 2) /   -.0411013393 62620893E0 /
      DATA ERC2CS( 3) /    .0039144958 66689626E0 /
      DATA ERC2CS( 4) /   -.0004906395 65054897E0 /
      DATA ERC2CS( 5) /    .0000715747 90013770E0 /
      DATA ERC2CS( 6) /   -.0000115307 16341312E0 /
      DATA ERC2CS( 7) /    .0000019946 70590201E0 /
      DATA ERC2CS( 8) /   -.0000003642 66647159E0 /
      DATA ERC2CS( 9) /    .0000000694 43726100E0 /
      DATA ERC2CS(10) /   -.0000000137 12209021E0 /
      DATA ERC2CS(11) /    .0000000027 88389661E0 /
      DATA ERC2CS(12) /   -.0000000005 81416472E0 /
      DATA ERC2CS(13) /    .0000000001 23892049E0 /
      DATA ERC2CS(14) /   -.0000000000 26906391E0 /
      DATA ERC2CS(15) /    .0000000000 05942614E0 /
      DATA ERC2CS(16) /   -.0000000000 01332386E0 /
      DATA ERC2CS(17) /    .0000000000 00302804E0 /
      DATA ERC2CS(18) /   -.0000000000 00069666E0 /
      DATA ERC2CS(19) /    .0000000000 00016208E0 /
      DATA ERC2CS(20) /   -.0000000000 00003809E0 /
      DATA ERC2CS(21) /    .0000000000 00000904E0 /
      DATA ERC2CS(22) /   -.0000000000 00000216E0 /
      DATA ERC2CS(23) /    .0000000000 00000052E0 /
      DATA ERFCCS( 1) /   0.0715179310 202925E0 /
      DATA ERFCCS( 2) /   -.0265324343 37606719E0 /
      DATA ERFCCS( 3) /    .0017111539 77920853E0 /
      DATA ERFCCS( 4) /   -.0001637516 63458512E0 /
      DATA ERFCCS( 5) /    .0000198712 93500549E0 /
      DATA ERFCCS( 6) /   -.0000028437 12412769E0 /
      DATA ERFCCS( 7) /    .0000004606 16130901E0 /
      DATA ERFCCS( 8) /   -.0000000822 77530261E0 /
      DATA ERFCCS( 9) /    .0000000159 21418724E0 /
      DATA ERFCCS(10) /   -.0000000032 95071356E0 /
      DATA ERFCCS(11) /    .0000000007 22343973E0 /
      DATA ERFCCS(12) /   -.0000000001 66485584E0 /
      DATA ERFCCS(13) /    .0000000000 40103931E0 /
      DATA ERFCCS(14) /   -.0000000000 10048164E0 /
      DATA ERFCCS(15) /    .0000000000 02608272E0 /
      DATA ERFCCS(16) /   -.0000000000 00699105E0 /
      DATA ERFCCS(17) /    .0000000000 00192946E0 /
      DATA ERFCCS(18) /   -.0000000000 00054704E0 /
      DATA ERFCCS(19) /    .0000000000 00015901E0 /
      DATA ERFCCS(20) /   -.0000000000 00004729E0 /
      DATA ERFCCS(21) /    .0000000000 00001432E0 /
      DATA ERFCCS(22) /   -.0000000000 00000439E0 /
      DATA ERFCCS(23) /    .0000000000 00000138E0 /
      DATA ERFCCS(24) /   -.0000000000 00000048E0 /
      DATA SQRTPI /1.772453850 9055160E0/
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  ERFC
      IF (FIRST) THEN
         ETA = 0.1*R1MACH(3)
         NTERF = INITS (ERFCS, 13, ETA)
         NTERFC = INITS (ERFCCS, 24, ETA)
         NTERC2 = INITS (ERC2CS, 23, ETA)
C
         XSML = -SQRT (-LOG(SQRTPI*R1MACH(3)))
         TXMAX = SQRT (-LOG(SQRTPI*R1MACH(1)))
         XMAX = TXMAX - 0.5*LOG(TXMAX)/TXMAX - 0.01
         SQEPS = SQRT (2.0*R1MACH(3))
      ENDIF
      FIRST = .FALSE.
C
      IF (X.GT.XSML) GO TO 20
C
C ERFC(X) = 1.0 - ERF(X) FOR X .LT. XSML
C
      ERFC = 2.
      RETURN
C
 20   IF (X.GT.XMAX) GO TO 40
      Y = ABS(X)
      IF (Y.GT.1.0) GO TO 30
C
C ERFC(X) = 1.0 - ERF(X) FOR -1. .LE. X .LE. 1.
C
      IF (Y.LT.SQEPS) ERFC = 1.0 - 2.0*X/SQRTPI
      IF (Y.GE.SQEPS) ERFC = 1.0 -
     1  X*(1.0 + CSEVL (2.*X*X-1., ERFCS, NTERF) )
      RETURN
C
C ERFC(X) = 1.0 - ERF(X) FOR 1. .LT. ABS(X) .LE. XMAX
C
 30   Y = Y*Y
      IF (Y.LE.4.) ERFC = EXP(-Y)/ABS(X) * (0.5 + CSEVL ((8./Y-5.)/3.,
     1  ERC2CS, NTERC2) )
      IF (Y.GT.4.) ERFC = EXP(-Y)/ABS(X) * (0.5 + CSEVL (8./Y-1.,
     1  ERFCCS, NTERFC) )
      IF (X.LT.0.) ERFC = 2.0 - ERFC
      RETURN
C
 40   CALL XERMSG ('SLATEC', 'ERFC', 'X SO BIG ERFC UNDERFLOWS', 1, 1)
      ERFC = 0.
      RETURN
C
      END
*DECK EXBVP
      SUBROUTINE EXBVP (Y, NROWY, XPTS, A, NROWA, ALPHA, B, NROWB, BETA,
     +   IFLAG, WORK, IWORK)
C***BEGIN PROLOGUE  EXBVP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (EXBVP-S, DEXBVP-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C  This subroutine is used to execute the basic technique for solving
C  the two-point boundary value problem
C
C***SEE ALSO  BVSUP
C***ROUTINES CALLED  BVPOR, XERMSG
C***COMMON BLOCKS    ML15TO, ML17BW, ML18JR, ML5MCO, ML8SZ
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  EXBVP
C
      DIMENSION Y(NROWY,*),A(NROWA,*),ALPHA(*),B(NROWB,*),BETA(*),
     1         WORK(*),IWORK(*),XPTS(*)
      CHARACTER*8 XERN1, XERN2
C
C     ****************************************************************
C
      COMMON /ML8SZ/ C,XSAV,IGOFX,INHOMO,IVP,NCOMP,NFC
      COMMON /ML18JR/ AE,RE,TOL,NXPTS,NIC,NOPG,MXNON,NDISK,NTAPE,NEQ,
     1                INDPVT,INTEG,NPS,NTP,NEQIVP,NUMORT,NFCC,
     2                ICOCO
      COMMON /ML15TO/ PX,PWCND,TND,X,XBEG,XEND,XOT,XOP,INFO(15),ISTKOP,
     1                KNSWOT,KOP,LOTJP,MNSWOT,NSWOT
      COMMON /ML17BW/ KKKZPW,NEEDW,NEEDIW,K1,K2,K3,K4,K5,K6,K7,K8,K9,
     1                K10,K11,L1,L2,KKKINT,LLLINT
C
      COMMON /ML5MCO/ URO,SRU,EPS,SQOVFL,TWOU,FOURU,LPAR
C
C***FIRST EXECUTABLE STATEMENT  EXBVP
      KOTC = 1
      IEXP = 0
      IF (IWORK(7) .EQ. -1) IEXP = IWORK(8)
C
C     COMPUTE ORTHONORMALIZATION TOLERANCES.
C
   10 TOL = 10.0**((-LPAR-IEXP)*2)
C
      IWORK(8) = IEXP
      MXNON = IWORK(2)
C
C **********************************************************************
C **********************************************************************
C
      CALL BVPOR(Y,NROWY,NCOMP,XPTS,NXPTS,A,NROWA,ALPHA,NIC,B,
     1           NROWB,BETA,NFC,IFLAG,WORK(1),MXNON,WORK(K1),NTP,
     2           IWORK(18),WORK(K2),IWORK(16),WORK(K3),WORK(K4),
     3           WORK(K5),WORK(K6),WORK(K7),WORK(K8),WORK(K9),
     4           WORK(K10),IWORK(L1),NFCC)
C
C **********************************************************************
C **********************************************************************
C     IF MGSBV RETURNS WITH MESSAGE OF DEPENDENT VECTORS, WE REDUCE
C     ORTHONORMALIZATION TOLERANCE AND TRY AGAIN. THIS IS DONE
C     A MAXIMUM OF 2 TIMES.
C
      IF (IFLAG .NE. 30) GO TO 20
      IF (KOTC .EQ. 3  .OR.  NOPG .EQ. 1) GO TO 30
      KOTC = KOTC + 1
      IEXP = IEXP - 2
      GO TO 10
C
C **********************************************************************
C     IF BVPOR RETURNS MESSAGE THAT THE MAXIMUM NUMBER OF
C     ORTHONORMALIZATIONS HAS BEEN ATTAINED AND WE CANNOT CONTINUE, THEN
C     WE ESTIMATE THE NEW STORAGE REQUIREMENTS IN ORDER TO SOLVE PROBLEM
C
   20 IF (IFLAG .NE. 13) GO TO 30
      XL = ABS(XEND-XBEG)
      ZQUIT = ABS(X-XBEG)
      INC = 1.5 * XL/ZQUIT * (MXNON+1)
      IF (NDISK .NE. 1) THEN
         NSAFW = INC*KKKZPW + NEEDW
         NSAFIW = INC*NFCC + NEEDIW
      ELSE
         NSAFW = NEEDW + INC
         NSAFIW = NEEDIW
      ENDIF
C
      WRITE (XERN1, '(I8)') NSAFW
      WRITE (XERN2, '(I8)') NSAFIW
      CALL XERMSG ('SLATEC', 'EXBVP',
     *   'IN BVSUP, PREDICTED STORAGE ALLOCATION FOR WORK ARRAY IS ' //
     *   XERN1 // ', PREDICTED STORAGE ALLOCATION FOR IWORK ARRAY IS '
     *   // XERN2, 1, 0)
C
   30 IWORK(1) = MXNON
      RETURN
      END
*DECK EXINT
      SUBROUTINE EXINT (X, N, KODE, M, TOL, EN, NZ, IERR)
C***BEGIN PROLOGUE  EXINT
C***PURPOSE  Compute an M member sequence of exponential integrals
C            E(N+K,X), K=0,1,...,M-1 for N .GE. 1 and X .GE. 0.
C***LIBRARY   SLATEC
C***CATEGORY  C5
C***TYPE      SINGLE PRECISION (EXINT-S, DEXINT-D)
C***KEYWORDS  EXPONENTIAL INTEGRAL, SPECIAL FUNCTIONS
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C         EXINT computes M member sequences of exponential integrals
C         E(N+K,X), K=0,1,...,M-1 for N .GE. 1 and X .GE. 0.  The
C         exponential integral is defined by
C
C         E(N,X)=integral on (1,infinity) of EXP(-XT)/T**N
C
C         where X=0.0 and N=1 cannot occur simultaneously.  Formulas
C         and notation are found in the NBS Handbook of Mathematical
C         Functions (ref. 1).
C
C         The power series is implemented for X .LE. XCUT and the
C         confluent hypergeometric representation
C
C                     E(A,X) = EXP(-X)*(X**(A-1))*U(A,A,X)
C
C         is computed for X .GT. XCUT.  Since sequences are computed in
C         a stable fashion by recurring away from X, A is selected as
C         the integer closest to X within the constraint N .LE. A .LE.
C         N+M-1.  For the U computation, A is further modified to be the
C         nearest even integer.  Indices are carried forward or
C         backward by the two term recursion relation
C
C                     K*E(K+1,X) + X*E(K,X) = EXP(-X)
C
C         once E(A,X) is computed.  The U function is computed by means
C         of the backward recursive Miller algorithm applied to the
C         three term contiguous relation for U(A+K,A,X), K=0,1,...
C         This produces accurate ratios and determines U(A+K,A,X), and
C         hence E(A,X), to within a multiplicative constant C.
C         Another contiguous relation applied to C*U(A,A,X) and
C         C*U(A+1,A,X) gets C*U(A+1,A+1,X), a quantity proportional to
C         E(A+1,X).  The normalizing constant C is obtained from the
C         two term recursion relation above with K=A.
C
C     Description of Arguments
C
C         Input
C           X       X .GT. 0.0 for N=1 and  X .GE. 0.0 for N .GE. 2
C           N       order of the first member of the sequence, N .GE. 1
C                   (X=0.0 and N=1 is an error)
C           KODE    a selection parameter for scaled values
C                   KODE=1   returns        E(N+K,X), K=0,1,...,M-1.
C                       =2   returns EXP(X)*E(N+K,X), K=0,1,...,M-1.
C           M       number of exponential integrals in the sequence,
C                   M .GE. 1
C           TOL     relative accuracy wanted, ETOL .LE. TOL .LE. 0.1
C                   ETOL = single precision unit roundoff = R1MACH(4)
C
C         Output
C           EN      a vector of dimension at least M containing values
C                   EN(K) = E(N+K-1,X) or EXP(X)*E(N+K-1,X), K=1,M
C                   depending on KODE
C           NZ      underflow indicator
C                   NZ=0   a normal return
C                   NZ=M   X exceeds XLIM and an underflow occurs.
C                          EN(K)=0.0E0 , K=1,M returned on KODE=1
C           IERR    error flag
C                   IERR=0, normal return, computation completed
C                   IERR=1, input error,   no computation
C                   IERR=2, error,         no computation
C                           algorithm termination condition not met
C
C***REFERENCES  M. Abramowitz and I. A. Stegun, Handbook of
C                 Mathematical Functions, NBS AMS Series 55, U.S. Dept.
C                 of Commerce, 1955.
C               D. E. Amos, Computation of exponential integrals, ACM
C                 Transactions on Mathematical Software 6, (1980),
C                 pp. 365-377 and pp. 420-428.
C***ROUTINES CALLED  I1MACH, PSIXN, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   800501  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   910408  Updated the REFERENCES section.  (WRB)
C   920207  Updated with code with a revision date of 880811 from
C           D. Amos.  Included correction of argument list.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  EXINT
      REAL             A,AA,AAMS,AH,AK,AT,B,BK,BT,CC,CNORM,CT,EM,EMX,EN,
     1                 ETOL,FNM,FX,PT,P1,P2,S,TOL,TX,X,XCUT,XLIM,XTOL,Y,
     2                 YT,Y1,Y2
      REAL             R1MACH,PSIXN
      INTEGER I,IC,ICASE,ICT,IERR,IK,IND,IX,I1M,JSET,K,KK,KN,KODE,KS,M,
     1        ML,MU,N,ND,NM,NZ
      INTEGER I1MACH
      DIMENSION EN(*), A(99), B(99), Y(2)
C***FIRST EXECUTABLE STATEMENT  EXINT
      IERR = 0
      NZ = 0
      ETOL = MAX(R1MACH(4),0.5E-18)
      IF (X.LT.0.0E0) IERR = 1
      IF (N.LT.1) IERR = 1
      IF (KODE.LT.1 .OR. KODE.GT.2) IERR = 1
      IF (M.LT.1) IERR = 1
      IF (TOL.LT.ETOL .OR. TOL.GT.0.1E0) IERR = 1
      IF (X.EQ.0.0E0 .AND. N.EQ.1) IERR = 1
      IF (IERR.NE.0) RETURN
      I1M = -I1MACH(12)
      PT = 2.3026E0*R1MACH(5)*I1M
      XLIM = PT - 6.907755E0
      BT = PT + (N+M-1)
      IF (BT.GT.1000.0E0) XLIM = PT - LOG(BT)
C
      XCUT = 2.0E0
      IF (ETOL.GT.2.0E-7) XCUT = 1.0E0
      IF (X.GT.XCUT) GO TO 100
      IF (X.EQ.0.0E0 .AND. N.GT.1) GO TO 80
C-----------------------------------------------------------------------
C     SERIES FOR E(N,X) FOR X.LE.XCUT
C-----------------------------------------------------------------------
      TX = X + 0.5E0
      IX = TX
C-----------------------------------------------------------------------
C     ICASE=1 MEANS INTEGER CLOSEST TO X IS 2 AND N=1
C     ICASE=2 MEANS INTEGER CLOSEST TO X IS 0,1, OR 2 AND N.GE.2
C-----------------------------------------------------------------------
      ICASE = 2
      IF (IX.GT.N) ICASE = 1
      NM = N - ICASE + 1
      ND = NM + 1
      IND = 3 - ICASE
      MU = M - IND
      ML = 1
      KS = ND
      FNM = NM
      S = 0.0E0
      XTOL = 3.0E0*TOL
      IF (ND.EQ.1) GO TO 10
      XTOL = 0.3333E0*TOL
      S = 1.0E0/FNM
   10 CONTINUE
      AA = 1.0E0
      AK = 1.0E0
      IC = 35
      IF (X.LT.ETOL) IC = 1
      DO 50 I=1,IC
        AA = -AA*X/AK
        IF (I.EQ.NM) GO TO 30
        S = S - AA/(AK-FNM)
        IF (ABS(AA).LE.XTOL*ABS(S)) GO TO 20
        AK = AK + 1.0E0
        GO TO 50
   20   CONTINUE
        IF (I.LT.2) GO TO 40
        IF (ND-2.GT.I .OR. I.GT.ND-1) GO TO 60
        AK = AK + 1.0E0
        GO TO 50
   30   S = S + AA*(-LOG(X)+PSIXN(ND))
        XTOL = 3.0E0*TOL
   40   AK = AK + 1.0E0
   50 CONTINUE
      IF (IC.NE.1) GO TO 340
   60 IF (ND.EQ.1) S = S + (-LOG(X)+PSIXN(1))
      IF (KODE.EQ.2) S = S*EXP(X)
      EN(1) = S
      EMX = 1.0E0
      IF (M.EQ.1) GO TO 70
      EN(IND) = S
      AA = KS
      IF (KODE.EQ.1) EMX = EXP(-X)
      GO TO (220, 240), ICASE
   70 IF (ICASE.EQ.2) RETURN
      IF (KODE.EQ.1) EMX = EXP(-X)
      EN(1) = (EMX-S)/X
      RETURN
   80 CONTINUE
      DO 90 I=1,M
        EN(I) = 1.0E0/(N+I-2)
   90 CONTINUE
      RETURN
C-----------------------------------------------------------------------
C     BACKWARD RECURSIVE MILLER ALGORITHM FOR
C              E(N,X)=EXP(-X)*(X**(N-1))*U(N,N,X)
C     WITH RECURSION AWAY FROM N=INTEGER CLOSEST TO X.
C     U(A,B,X) IS THE SECOND CONFLUENT HYPERGEOMETRIC FUNCTION
C-----------------------------------------------------------------------
  100 CONTINUE
      EMX = 1.0E0
      IF (KODE.EQ.2) GO TO 130
      IF (X.LE.XLIM) GO TO 120
      NZ = M
      DO 110 I=1,M
        EN(I) = 0.0E0
  110 CONTINUE
      RETURN
  120 EMX = EXP(-X)
  130 CONTINUE
      IX = X+0.5E0
      KN = N + M - 1
      IF (KN.LE.IX) GO TO 140
      IF (N.LT.IX .AND. IX.LT.KN) GO TO 170
      IF (N.GE.IX) GO TO 160
      GO TO 340
  140 ICASE = 1
      KS = KN
      ML = M - 1
      MU = -1
      IND = M
      IF (KN.GT.1) GO TO 180
  150 KS = 2
      ICASE = 3
      GO TO 180
  160 ICASE = 2
      IND = 1
      KS = N
      MU = M - 1
      IF (N.GT.1) GO TO 180
      IF (KN.EQ.1) GO TO 150
      IX = 2
  170 ICASE = 1
      KS = IX
      ML = IX - N
      IND = ML + 1
      MU = KN - IX
  180 CONTINUE
      IK = KS/2
      AH = IK
      JSET = 1 + KS - (IK+IK)
C-----------------------------------------------------------------------
C     START COMPUTATION FOR
C              EN(IND) = C*U( A , A ,X)    JSET=1
C              EN(IND) = C*U(A+1,A+1,X)    JSET=2
C     FOR AN EVEN INTEGER A.
C-----------------------------------------------------------------------
      IC = 0
      AA = AH + AH
      AAMS = AA - 1.0E0
      AAMS = AAMS*AAMS
      TX = X + X
      FX = TX + TX
      AK = AH
      XTOL = TOL
      IF (TOL.LE.1.0E-3) XTOL = 20.0E0*TOL
      CT = AAMS + FX*AH
      EM = (AH+1.0E0)/((X+AA)*XTOL*SQRT(CT))
      BK = AA
      CC = AH*AH
C-----------------------------------------------------------------------
C     FORWARD RECURSION FOR P(IC),P(IC+1) AND INDEX IC FOR BACKWARD
C     RECURSION
C-----------------------------------------------------------------------
      P1 = 0.0E0
      P2 = 1.0E0
  190 CONTINUE
      IF (IC.EQ.99) GO TO 340
      IC = IC + 1
      AK = AK + 1.0E0
      AT = BK/(BK+AK+CC+IC)
      BK = BK + AK + AK
      A(IC) = AT
      BT = (AK+AK+X)/(AK+1.0E0)
      B(IC) = BT
      PT = P2
      P2 = BT*P2 - AT*P1
      P1 = PT
      CT = CT + FX
      EM = EM*AT*(1.0E0-TX/CT)
      IF (EM*(AK+1.0E0).GT.P1*P1) GO TO 190
      ICT = IC
      KK = IC + 1
      BT = TX/(CT+FX)
      Y2 = (BK/(BK+CC+KK))*(P1/P2)*(1.0E0-BT+0.375E0*BT*BT)
      Y1 = 1.0E0
C-----------------------------------------------------------------------
C     BACKWARD RECURRENCE FOR
C              Y1=             C*U( A ,A,X)
C              Y2= C*(A/(1+A/2))*U(A+1,A,X)
C-----------------------------------------------------------------------
      DO 200 K=1,ICT
        KK = KK - 1
        YT = Y1
        Y1 = (B(KK)*Y1-Y2)/A(KK)
        Y2 = YT
  200 CONTINUE
C-----------------------------------------------------------------------
C     THE CONTIGUOUS RELATION
C              X*U(B,C+1,X)=(C-B)*U(B,C,X)+U(B-1,C,X)
C     WITH  B=A+1 , C=A IS USED FOR
C              Y(2) = C * U(A+1,A+1,X)
C     X IS INCORPORATED INTO THE NORMALIZING RELATION
C-----------------------------------------------------------------------
      PT = Y2/Y1
      CNORM = 1.0E0 - PT*(AH+1.0E0)/AA
      Y(1) = 1.0E0/(CNORM*AA+X)
      Y(2) = CNORM*Y(1)
      IF (ICASE.EQ.3) GO TO 210
      EN(IND) = EMX*Y(JSET)
      IF (M.EQ.1) RETURN
      AA = KS
      GO TO (220, 240), ICASE
C-----------------------------------------------------------------------
C     RECURSION SECTION  N*E(N+1,X) + X*E(N,X)=EMX
C-----------------------------------------------------------------------
  210 EN(1) = EMX*(1.0E0-Y(1))/X
      RETURN
  220 K = IND - 1
      DO 230 I=1,ML
        AA = AA - 1.0E0
        EN(K) = (EMX-AA*EN(K+1))/X
        K = K - 1
  230 CONTINUE
      IF (MU.LE.0) RETURN
      AA = KS
  240 K = IND
      DO 250 I=1,MU
        EN(K+1) = (EMX-X*EN(K))/AA
        AA = AA + 1.0E0
        K = K + 1
  250 CONTINUE
      RETURN
  340 CONTINUE
      IERR = 2
      RETURN
      END
*DECK EXPREL
      FUNCTION EXPREL (X)
C***BEGIN PROLOGUE  EXPREL
C***PURPOSE  Calculate the relative error exponential (EXP(X)-1)/X.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C4B
C***TYPE      SINGLE PRECISION (EXPREL-S, DEXPRL-D, CEXPRL-C)
C***KEYWORDS  ELEMENTARY FUNCTIONS, EXPONENTIAL, FIRST ORDER, FNLIB
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Evaluate  EXPREL(X) = (EXP(X) - 1.0) / X.   For small ABS(X) the
C Taylor series is used.  If X is negative, the reflection formula
C         EXPREL(X) = EXP(X) * EXPREL(ABS(X))
C may be used.  This reflection formula will be of use when the
C evaluation for small ABS(X) is done by Chebyshev series rather than
C Taylor series.  EXPREL and X are single precision.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   770801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  EXPREL
      LOGICAL FIRST
      SAVE NTERMS, XBND, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  EXPREL
      IF (FIRST) THEN
         ALNEPS = LOG(R1MACH(3))
         XN = 3.72 - 0.3*ALNEPS
         XLN = LOG((XN+1.0)/1.36)
         NTERMS = XN - (XN*XLN+ALNEPS)/(XLN+1.36) + 1.5
         XBND = R1MACH(3)
      ENDIF
      FIRST = .FALSE.
C
      ABSX = ABS(X)
      IF (ABSX.GT.0.5) EXPREL = (EXP(X) - 1.0) / X
      IF (ABSX.GT.0.5) RETURN
C
      EXPREL = 1.0
      IF (ABSX.LT.XBND) RETURN
C
      EXPREL = 0.0
      DO 20 I=1,NTERMS
        EXPREL = 1.0 + EXPREL*X/(NTERMS+2-I)
 20   CONTINUE
C
      RETURN
      END
*DECK EZFFT1
      SUBROUTINE EZFFT1 (N, WA, IFAC)
C***BEGIN PROLOGUE  EZFFT1
C***SUBSIDIARY
C***PURPOSE  EZFFTI calls EZFFT1 with appropriate work array
C            partitioning.
C***LIBRARY   SLATEC (FFTPACK)
C***TYPE      SINGLE PRECISION (EZFFT1-S)
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           (a) changing dummy array size declarations (1) to (*),
C           (b) changing references to intrinsic function FLOAT
C               to REAL, and
C           (c) changing definition of variable TPI by using
C               FORTRAN intrinsic function ATAN instead of a DATA
C               statement.
C   881128  Modified by Dick Valent to meet prologue standards.
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  EZFFT1
      DIMENSION WA(*), IFAC(*), NTRYH(4)
      SAVE NTRYH
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
C***FIRST EXECUTABLE STATEMENT  EZFFT1
      TPI = 8.*ATAN(1.)
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      ARGH = TPI/N
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
      DO 111 K1=1,NFM1
         IP = IFAC(K1+2)
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         ARG1 = L1*ARGH
         CH1 = 1.
         SH1 = 0.
         DCH1 = COS(ARG1)
         DSH1 = SIN(ARG1)
         DO 110 J=1,IPM
            CH1H = DCH1*CH1-DSH1*SH1
            SH1 = DCH1*SH1+DSH1*CH1
            CH1 = CH1H
            I = IS+2
            WA(I-1) = CH1
            WA(I) = SH1
            IF (IDO .LT. 5) GO TO 109
            DO 108 II=5,IDO,2
               I = I+2
               WA(I-1) = CH1*WA(I-3)-SH1*WA(I-2)
               WA(I) = CH1*WA(I-2)+SH1*WA(I-3)
  108       CONTINUE
  109       IS = IS+IDO
  110    CONTINUE
         L1 = L2
  111 CONTINUE
      RETURN
      END
*DECK EZFFTB
      SUBROUTINE EZFFTB (N, R, AZERO, A, B, WSAVE)
C***BEGIN PROLOGUE  EZFFTB
C***PURPOSE  A simplified real, periodic, backward fast Fourier
C            transform.
C***LIBRARY   SLATEC (FFTPACK)
C***CATEGORY  J1A1
C***TYPE      SINGLE PRECISION (EZFFTB-S)
C***KEYWORDS  FFTPACK, FOURIER TRANSFORM
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C  Subroutine EZFFTB computes a real periodic sequence from its
C  Fourier coefficients (Fourier synthesis).  The transform is
C  defined below at Output Parameter R.  EZFFTB is a simplified
C  but slower version of RFFTB.
C
C  Input Parameters
C
C  N       the length of the output array R.  The method is most
C          efficient when N is the product of small primes.
C
C  AZERO   the constant Fourier coefficient
C
C  A,B     arrays which contain the remaining Fourier coefficients.
C          These arrays are not destroyed.
C
C          The length of these arrays depends on whether N is even or
C          odd.
C
C          If N is even, N/2    locations are required.
C          If N is odd, (N-1)/2 locations are required
C
C  WSAVE   a work array which must be dimensioned at least 3*N+15
C          in the program that calls EZFFTB.  The WSAVE array must be
C          initialized by calling subroutine EZFFTI(N,WSAVE), and a
C          different WSAVE array must be used for each different
C          value of N.  This initialization does not have to be
C          repeated so long as N remains unchanged.  Thus subsequent
C          transforms can be obtained faster than the first.
C          The same WSAVE array can be used by EZFFTF and EZFFTB.
C
C  Output Parameters
C
C  R       if N is even, define KMAX=N/2
C          if N is odd,  define KMAX=(N-1)/2
C
C          Then for I=1,...,N
C
C               R(I)=AZERO plus the sum from K=1 to K=KMAX of
C
C               A(K)*COS(K*(I-1)*2*PI/N)+B(K)*SIN(K*(I-1)*2*PI/N)
C
C  ********************* Complex Notation **************************
C
C          For J=1,...,N
C
C          R(J) equals the sum from K=-KMAX to K=KMAX of
C
C               C(K)*EXP(I*K*(J-1)*2*PI/N)
C
C          where
C
C               C(K) = .5*CMPLX(A(K),-B(K))   for K=1,...,KMAX
C
C               C(-K) = CONJG(C(K))
C
C               C(0) = AZERO
C
C                    and I=SQRT(-1)
C
C  *************** Amplitude - Phase Notation ***********************
C
C          For I=1,...,N
C
C          R(I) equals AZERO plus the sum from K=1 to K=KMAX of
C
C               ALPHA(K)*COS(K*(I-1)*2*PI/N+BETA(K))
C
C          where
C
C               ALPHA(K) = SQRT(A(K)*A(K)+B(K)*B(K))
C
C               COS(BETA(K))=A(K)/ALPHA(K)
C
C               SIN(BETA(K))=-B(K)/ALPHA(K)
C
C***REFERENCES  P. N. Swarztrauber, Vectorizing the FFTs, in Parallel
C                 Computations (G. Rodrigue, ed.), Academic Press,
C                 1982, pp. 51-83.
C***ROUTINES CALLED  RFFTB
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           changing dummy array size declarations (1) to (*)
C   861211  REVISION DATE from Version 3.2
C   881128  Modified by Dick Valent to meet prologue standards.
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  EZFFTB
      DIMENSION R(*), A(*), B(*), WSAVE(*)
C***FIRST EXECUTABLE STATEMENT  EZFFTB
      IF (N-2) 101,102,103
  101 R(1) = AZERO
      RETURN
  102 R(1) = AZERO+A(1)
      R(2) = AZERO-A(1)
      RETURN
  103 NS2 = (N-1)/2
      DO 104 I=1,NS2
         R(2*I) = .5*A(I)
         R(2*I+1) = -.5*B(I)
  104 CONTINUE
      R(1) = AZERO
      IF (MOD(N,2) .EQ. 0) R(N) = A(NS2+1)
      CALL RFFTB (N,R,WSAVE(N+1))
      RETURN
      END
*DECK EZFFTF
      SUBROUTINE EZFFTF (N, R, AZERO, A, B, WSAVE)
C***BEGIN PROLOGUE  EZFFTF
C***PURPOSE  Compute a simplified real, periodic, fast Fourier forward
C            transform.
C***LIBRARY   SLATEC (FFTPACK)
C***CATEGORY  J1A1
C***TYPE      SINGLE PRECISION (EZFFTF-S)
C***KEYWORDS  FFTPACK, FOURIER TRANSFORM
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C  Subroutine EZFFTF computes the Fourier coefficients of a real
C  periodic sequence (Fourier analysis).  The transform is defined
C  below at Output Parameters AZERO, A and B.  EZFFTF is a simplified
C  but slower version of RFFTF.
C
C  Input Parameters
C
C  N       the length of the array R to be transformed.  The method
C          is most efficient when N is the product of small primes.
C
C  R       a real array of length N which contains the sequence
C          to be transformed.  R is not destroyed.
C
C
C  WSAVE   a work array which must be dimensioned at least 3*N+15
C          in the program that calls EZFFTF.  The WSAVE array must be
C          initialized by calling subroutine EZFFTI(N,WSAVE), and a
C          different WSAVE array must be used for each different
C          value of N.  This initialization does not have to be
C          repeated so long as N remains unchanged.  Thus subsequent
C          transforms can be obtained faster than the first.
C          The same WSAVE array can be used by EZFFTF and EZFFTB.
C
C  Output Parameters
C
C  AZERO   the sum from I=1 to I=N of R(I)/N
C
C  A,B     for N even B(N/2)=0. and A(N/2) is the sum from I=1 to
C          I=N of (-1)**(I-1)*R(I)/N
C
C          for N even define KMAX=N/2-1
C          for N odd  define KMAX=(N-1)/2
C
C          then for  K=1,...,KMAX
C
C               A(K) equals the sum from I=1 to I=N of
C
C                    2./N*R(I)*COS(K*(I-1)*2*PI/N)
C
C               B(K) equals the sum from I=1 to I=N of
C
C                    2./N*R(I)*SIN(K*(I-1)*2*PI/N)
C
C***REFERENCES  P. N. Swarztrauber, Vectorizing the FFTs, in Parallel
C                 Computations (G. Rodrigue, ed.), Academic Press,
C                 1982, pp. 51-83.
C***ROUTINES CALLED  RFFTF
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           (a) changing dummy array size declarations (1) to (*),
C           (b) changing references to intrinsic function FLOAT
C               to REAL.
C   881128  Modified by Dick Valent to meet prologue standards.
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  EZFFTF
      DIMENSION R(*), A(*), B(*), WSAVE(*)
C***FIRST EXECUTABLE STATEMENT  EZFFTF
      IF (N-2) 101,102,103
  101 AZERO = R(1)
      RETURN
  102 AZERO = .5*(R(1)+R(2))
      A(1) = .5*(R(1)-R(2))
      RETURN
  103 DO 104 I=1,N
         WSAVE(I) = R(I)
  104 CONTINUE
      CALL RFFTF (N,WSAVE,WSAVE(N+1))
      CF = 2./N
      CFM = -CF
      AZERO = .5*CF*WSAVE(1)
      NS2 = (N+1)/2
      NS2M = NS2-1
      DO 105 I=1,NS2M
         A(I) = CF*WSAVE(2*I)
         B(I) = CFM*WSAVE(2*I+1)
  105 CONTINUE
      IF (MOD(N,2) .EQ. 0) A(NS2) = .5*CF*WSAVE(N)
      RETURN
      END
*DECK EZFFTI
      SUBROUTINE EZFFTI (N, WSAVE)
C***BEGIN PROLOGUE  EZFFTI
C***PURPOSE  Initialize a work array for EZFFTF and EZFFTB.
C***LIBRARY   SLATEC (FFTPACK)
C***CATEGORY  J1A1
C***TYPE      SINGLE PRECISION (EZFFTI-S)
C***KEYWORDS  FFTPACK, FOURIER TRANSFORM
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C  Subroutine EZFFTI initializes the work array WSAVE which is used in
C  both EZFFTF and EZFFTB.  The prime factorization of N together with
C  a tabulation of the trigonometric functions are computed and
C  stored in WSAVE.
C
C  Input Parameter
C
C  N       the length of the sequence to be transformed.
C
C  Output Parameter
C
C  WSAVE   a work array which must be dimensioned at least 3*N+15.
C          The same work array can be used for both EZFFTF and EZFFTB
C          as long as N remains unchanged.  Different WSAVE arrays
C          are required for different values of N.
C
C***REFERENCES  P. N. Swarztrauber, Vectorizing the FFTs, in Parallel
C                 Computations (G. Rodrigue, ed.), Academic Press,
C                 1982, pp. 51-83.
C***ROUTINES CALLED  EZFFT1
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           changing dummy array size declarations (1) to (*).
C   861211  REVISION DATE from Version 3.2
C   881128  Modified by Dick Valent to meet prologue standards.
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  EZFFTI
      DIMENSION WSAVE(*)
C***FIRST EXECUTABLE STATEMENT  EZFFTI
      IF (N .EQ. 1) RETURN
      CALL EZFFT1 (N,WSAVE(2*N+1),WSAVE(3*N+1))
      RETURN
      END

!
subroutine adjust_mcmc (comm,line,error)
  use gildas_def
  use gbl_format
  use sic_adjust
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>adjust_mcmc
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !     Support for commands
  !
  !     EMCEE [Data Command] [/BEGIN] [/START A1 B1 C1 ...] [/STEP A2 B2 C2 ...]
  !     [/Bounds Par Low Up [...]] [/Parameters Va Vb Vc ...]
  !     [/ROOT  Name] [/WALKERS NWalk] [/LENGTH Length]
  !
  ! Allows fitting arbitrary data with arbitrary number of parameters
  ! using a MCMC routine
  !---------------------------------------------------------------------
  character(len=*)                :: comm   !
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='EMCEE'
  !
  !  ' EMCEE', '/BEGIN', '/BOUNDS', '/LENGTH', '/PARAMETERS', '/ROOT_NAME', &
  !  '/START', '/STEP', '/WALKERS'/
  integer, parameter :: O_BEGIN = 1
  integer, parameter :: O_BOUND = 2
  integer, parameter :: O_LENGTH = 3
  integer, parameter :: O_PAR = 4
  integer, parameter :: O_ROOT = 5
  integer, parameter :: O_START = 6
  integer, parameter :: O_STEP = 7
  integer, parameter :: O_WALK = 8
  !
  character(len=formula_length) :: aprint,bprint
  character(len=commandline_length) :: cprint, chi2_expression
  character(len=varname_length) :: avar,cvar,argum
  character(len=64) :: work
  character(len=16) :: ch
  integer :: i,narg,ivar
  real(4), save :: xstart(adj_m),xstep(adj_m)
  type(sic_descriptor_t) :: ddesc,default
  integer :: nc,pdim
  integer :: lun,n,lk
  !
  integer :: ier
  logical :: resume, begin
  character(len=filename_length) :: file
  character(len=message_length) :: mess
  !
  logical, save :: first=.true.
  logical, save :: setup=.false.
  logical, save :: load_emcee=.false.
  integer, save :: adj_all, adj_counter
  !
  if (first) then
    xstart = 0.0
    xstep  = 1.0
    adj_lower = -5.0
    adj_upper = 5.0
    first = .false.
    call sic_defstructure('EMCEE',.true.,error)
    call sic_def_dble('EMCEE%CHI2',adj_chi2,0,0,.false.,error)
    call sic_def_inte('EMCEE%ALL',adj_all,0,0,.false.,error)
    call sic_def_inte('EMCEE%COUNTER',adj_counter,0,0,.false.,error)
    call sic_def_login('EMCEE%RESTART',adj_restart,0,0,.true.,error)
    call sic_def_inte('EMCEE_LENGTH',adj_length,0,0,.true.,error)
    call sic_def_inte('EMCEE_WALKERS',adj_walkers,0,0,.true.,error)
    call sic_def_inte('EMCEE_PARAMS',adj_n,0,0,.true.,error)
    call sic_def_char('EMCEE_ROOT',adj_root,.true.,error)
    adj_root = 'EMCEE'
    load_emcee = .true.
  endif
  adj_all = 0
  adj_counter = 0
  !
  ! No argument, No option /BEGIN
  begin = sic_present(O_BEGIN,0)
  if (begin) then
    resume = .false.
  else if (sic_narg(0).eq.0) then
    if (.not.setup) then
      call sic_message(seve%e,rname,'MCMC parameters have not been defined')
      error = .true.
      return
    else
      resume = .true.
    endif
  else
    resume = .false.
  endif
  !
  ! /LENGTH option (can be changed in all cases)
  call sic_i4 (line,O_LENGTH,1,adj_length,.false.,error)
  !
  if (.not.resume) then
    !
    ! Delete the generic structure name
    call sic_delvariable(adj_root(1:adj_lroot),.false.,error)
    error = .false.
    !
    cur_exec = adj_exec
    pdim = sic_narg(O_PAR)
    if (pdim.le.0) then
      call sic_message(seve%e,rname,'No variable specified')
      error = .true.
      return
    endif
    !
    ! Option /ROOT : Root name
    if (sic_present(O_ROOT,1)) then
       call sic_ch(line,O_ROOT,1,adj_root,adj_lroot,.true.,error)
       if (error) return
    endif
    !
    ! Main arguments
    !
    default%type = fmt_r8
    default%readonly = .false.
    default%addr = 0
    default%ndim = 0
    default%dims(:) = 0
    default%size = 0
    default%status = 0
    call sic_desc (line,0,1,ddesc,default,.true.,error)
    if (error) return
    !
    call sic_ch(line,0,2,chi2_expression,nc,.true.,error)
    if (error) return
    !
    ! Option /PARAMETER : parameter names, must be parsed before /BOUND
    pdim = sic_narg(O_PAR)
    if (pdim.gt.adj_m) then
      write(work,'(I0)') adj_m
      call sic_message(seve%e,rname,'Too many parameters, maximum allowed is '//work)
      error = .true.
      return
    endif
    !
    do i=1,pdim
      call sic_ke(line,O_PAR,i,work,nc,.true.,error)
      if (error) return
      if (.not.sic_varexist(work(1:nc))) then
         call sic_message(seve%e,rname,'Parameter'//work(1:nc)//' does not exist')
         error = .true.
         return
      endif
      call sic_lower(work)
      adj_names(i) = work
    enddo
    adj_n = pdim
    !
    ! Option Starting values : must be parsed before STEPS and BOUNDS
    narg = min(sic_narg(O_START),pdim)
    do i=1,narg
      call sic_r4 (line,O_START,i,xstart(i),.false.,error)
      if (error) return
    enddo
    !
    ! Option Steps: must be parsed before BOUNDS
    narg = min(sic_narg(O_STEP),pdim) ! Hum pas bon, mais on patche
    do i=1,narg
      call sic_r4 (line,O_STEP,i,xstep(i),.false.,error)
      if (error) return
      adj_lower(i) = xstart(i)-5*xstep(i)
      adj_upper(i) = xstart(i)+5*xstep(i)
    enddo
    !
    ! Option /BOUND : Allowed range for parameter values
    narg = max(0,min(sic_narg(O_BOUND),3*pdim)) ! is -1 if no argument
    if (mod(narg,3).ne.0) then
      call sic_message(seve%e,rname,'/BOUND requires N times 3 arguments')
      error = .true.
      return
    endif
    do i=1,narg,3
      call sic_ke (line,O_BOUND,i,avar,lk,.false.,error)
      ! Parameter names have been defined
      call sic_lower(avar)
      call sic_ambigs('/BOUNDS',avar,cvar,ivar,adj_names,pdim,error)
      if (error) return
      !      
      call sic_ke (line,O_BOUND,i+1,argum,lk,.false.,error)
      if (argum.eq.'*') then
        call sic_message(seve%e,rname,'Free Lower bound not yet supported')
        error = .true.
        return
      else
        call sic_r8 (line,O_BOUND,i+1,adj_lower(ivar),.false.,error)
      endif
      call sic_ke (line,O_BOUND,i+2,argum,lk,.false.,error)
      if (argum.eq.'*') then
        call sic_message(seve%e,rname,'Free Upper bound not yet supported')
        error = .true.
        return
      else
        call sic_r8 (line,O_BOUND,i+2,adj_upper(ivar),.false.,error)
      endif
      adj_bound(ivar) = 3
      write (mess,*) trim(adj_names(ivar)),' bounds ',real(adj_lower(ivar)),real(adj_upper(ivar))
      call sic_message(seve%i,rname,mess)
    enddo
    !
    ! Number of Walkers
    call sic_i4 (line,O_WALK,1,adj_over,.false.,error)
    adj_walkers = adj_over*adj_n
    !
    ! Write the mcmc-adjust.py
    ier = sic_getlun(lun)
    file = 'adjust-emcee.py'
    ier = sic_open(lun,file,'UNKNOWN',.false.)
    write(lun,'(A)') '#'
    write(lun,'(A)') 'import numpy as np'
    write(lun,'(A)') 'import sys'
    write(lun,'(A)') 'import math'
    write(lun,'(A)') 'import pysic'
    write(lun,'(A)') 'pysic.get()'
    write(lun,'(A)') 'sic = pysic.gdict'
    write(lun,'(A)') '#'
    write(lun,'(A)') '# list of variables'
    !
    do i=1,adj_n
      ! name + guess, min, max
      write(lun,'(A)') trim(adj_names(i))//"_guess = sic."//trim(adj_names(i))
      write(lun,'(A,1pg16.7)') trim(adj_names(i))//"_min = ",adj_lower(i)
      write(lun,'(A,1pg16.7)') trim(adj_names(i))//"_max = ",adj_upper(i)
    enddo
    !
    write(lun,'(A)') '# Likelihood and Prior'
    write(lun,'(A)') 'def lnlike(theta) : '
    aprint = "  "//adj_names(1)
    n = len_trim(aprint)+1
    do i=2,adj_n
      aprint(n:) = ","//adj_names(i)
      n = len_trim(aprint)+1
    enddo
    aprint(n:) = " = theta"
    !
    write(lun,'(A)') trim(aprint)
    do i=1,adj_n
      write(lun,'(A)') "  sic."//trim(adj_names(i))//" = "//adj_names(i)
    enddo
    write(lun,'(A)') "  Sic.comm('"//trim(chi2_expression)//"')"
    write(lun,'(A)') "  return -0.5*sic.emcee.chi2[0]"
    !
    write(lun,'(A)')
    write(lun,'(A)') "nll=lambda *args: -lnlike(*args)"
    !
    write(lun,'(A)') "def lnprior(theta):"
    write(lun,'(A)') trim(aprint)
    do i=1,adj_n
      write(lun,'(A)') "  if "//trim(adj_names(i))//"<"//trim(adj_names(i))//"_min : "
      write(lun,'(A)') "    return -np.inf "
      write(lun,'(A)') "  if "//trim(adj_names(i))//"_max<"//trim(adj_names(i))//" : "
      write(lun,'(A)') "    return -np.inf "
    enddo
    write(lun,'(A)') "  return 0.0"
    !
    write(lun,'(A)') " "
    write(lun,'(A)') "def lnprob(theta): "
    write(lun,'(A)') "  lp=lnprior(theta) "
    write(lun,'(A)') "  if not np.isfinite(lp): "
    write(lun,'(A)') "    return -np.inf "
    write(lun,'(A)') "  return lp+lnlike(theta) "
    !
    write(lun,'(A)')
    bprint = "start = ["//trim(adj_names(1))//"_guess"
    n = len_trim(bprint)+1
    do i=2,adj_n
      bprint(n:) = ", "//trim(adj_names(i))//"_guess"
      n = len_trim(bprint)+1
    enddo
    bprint(n:n) = "]"
    write(lun,'(A)') trim(bprint)
    write(lun,'(A)') " "
    !
    write(lun,'(A)') "# Prepare MCMC"
    write(lun,'(A)') "import emcee "
    write(lun,'(A)') "import pickle "
    write(lun,'(A)') "import sys"
    write(lun,'(A)') " "
    write(lun,'(A)') "# Use EMCEE to find the distribution "
    write(lun,'(A)') "# "
    write(lun,'(A)') "# Initialize the walkers "
    !
    ! pos_random = [   1.0,  0.10]  # Comes from the steps ?
    cprint = "pos_random = [ "
    n = len_trim(cprint)+1
    do i=1,adj_n
      write(cprint(n:),'(1pg12.4,a)') xstep(i),','
      n = len_trim(cprint)+1
    enddo
    cprint(n-1:n) = "]"
    write(lun,'(A)') cprint(1:n)
    write(lun,"(a,(i4,a,i4))") "numdim, nwalkers = ",adj_n,",",adj_walkers
    write(lun,'(A)') "pos=[start+pos_random*np.random.randn(numdim) for i in range(nwalkers)]"
    write(lun,'(A)') " "
    write(lun,'(A)') "# or get the starting point from the saved value"
    write(lun,'(A)') "restart = sic.emcee.restart"
    write(lun,'(A)') "if restart:"
    write(lun,'(A)') "  if sys.version_info[:1] == (2,):"
    write(lun,'(A)') "    input = open('emcee-last.pkl', 'r')"
    write(lun,'(A)') "    pos = pickle.load(input)"
    write(lun,'(A)') "  else:"
    write(lun,'(A)') "    input = open('emcee-last.pkl', 'rb')"
    write(lun,'(A)') "    pos = pickle.load(input,encoding='latin1')"
    write(lun,'(A)') " "
    write(lun,'(A)') "# Run the EMCEE sampler"

    write(lun,'(A)') "clength = sic.emcee_length "
    write(lun,'(A)') "sampler = emcee.EnsembleSampler(nwalkers, numdim, lnprob)"
    write(lun,'(A)') "sampler.run_mcmc(pos, clength) "
    write(lun,'(A)') "# Save the full chains in Pickle format"
    write(lun,'(A)') "if sys.version_info[:1] == (2,):"
    write(lun,'(A)') "  output = open('emcee-chain.pkl', 'w')"
    write(lun,'(A)') "else:"
    write(lun,'(A)') "  output = open('emcee-chain.pkl', 'wb')"
    write(lun,'(A)') "pickle.dump(sampler.chain, output)"
    write(lun,'(A)') "output.close()"
    write(lun,'(A)') "#"
    write(lun,'(A)') "# Export result as a Gildas file too"
!!    write(lun,'(A,A,A)') "Sic.comm('define image ", &
!!      & "adjust_current[adjust_length,adjust_walkers,adjust_params] ", &
!!      & "adjust-current.tab real /global')"
    write(lun,'(A)') "for i in range(sic.emcee_params):"
    write(lun,'(A)') "  for j in range(sic.emcee_walkers):"
    write(lun,'(A)') "    sic.emcee_current[i,j,:] = sampler.chain[j,:,i]"
!!    write(lun,'(A)') "Sic.comm('delete /variable adjust_current')"
    write(lun,'(A)') "#"

    write(lun,'(A)') "# Export the last point of the chain as a Pickle file "
    write(lun,'(A)') "clength = clength-1 "
    write(lun,'(A)') "last = sampler.chain[:,clength,:]"
    write(lun,'(A)') "if sys.version_info[:1] == (2,):"
    write(lun,'(A)') "  output = open('emcee-last.pkl', 'w')"
    write(lun,'(A)') "else:"
    write(lun,'(A)') "  output = open('emcee-last.pkl', 'wb')"
    write(lun,'(A)') "pickle.dump(last, output) "
    write(lun,'(A)') "output.close()"

    write(lun,'(A)') "#"
    write(lun,'(A)') "# Printing checkup"
    write(lun,'(A)') 'print("Mean acceptance fraction: {0:.3f}"'
    write(lun,'(A)') "              .format(np.mean(sampler.acceptance_fraction)))"
    close(unit=lun)
    call sic_frelun(lun)
    !
    setup = .true.
  endif
  !
  call sic_delvariable('emcee_current',.false.,error)
  error = .false.
  call exec_program('define image '// &
    'emcee_current[emcee_length,emcee_walkers,emcee_params] '// &
    'emcee-current.tab real /global')
  !
  if (load_emcee) then
    call exec_program('@ emcee-tools.sic')
    load_emcee = .false.
  endif
  !
  if (.not.(begin.or.resume)) then
    if (sic_lire().eq.0) call sic_insert(line)
    return
  endif
  !
  adj_all = adj_walkers * adj_length
  !
  ! Restart from last point in case of RESUME.
  adj_restart = resume
  !
  call exec_program('SIC CPU')
  call exec_program('python adjust-emcee.py')
  call exec_program('delete /variable emcee_current')
  if (error) return
  if (adj_restart) then
    call exec_program('@ emcee-append emcee')
  else
    call exec_program('SIC RENAME emcee-current.tab emcee-chain.tab')
  endif
  if (sic_lire().eq.0) call sic_insert(line)
  !
  ier = sic_getlun(lun)
  ier = sic_open(lun,'emcee-args.greg','UNKNOWN',.false.)
  !
  write(lun,'(A)') "define character*16 nn"
  write(lun,'(A,I6)') "let nn ",adj_n
  write(lun,'(A)') "if (pro%arg[1].ne.nn) then"
  write(lun,'(A)') "  SAY emcee-args.greg does not match the expected arguments"
  write(lun,'(A)') "  return"
  write(lun,'(A)') "endif"
  write(lun,'(A)') "if .not.exist(s_) then"
  write(lun,'(A)') "  define structure s_ /global"
  write(lun,'(A)') "endif"
  write(ch,*) adj_n
  ch = adjustl(ch)
  write(lun,'(A)') "define character*16 s_%arguments["//trim(ch)//"] /global"
  do i =1,adj_n
    write(ch,*) i
    ch = adjustl(ch)
    write(lun,'(A)') "let s_%arguments["//trim(ch)//"] "//trim(adj_names(i))
  enddo
  close(unit=lun)
  call sic_frelun(lun)
end subroutine adjust_mcmc
!
subroutine adjust_display(comm,line,error)
  use gildas_def
  use sic_adjust
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>adjust_display
  use sic_types
  use gbl_message
  !------------------------------------------------------------------
  ! @ private
  !   ADJUST support for ESHOW
  !   ESHOW AUTOCORR|CHAINS|ERRORS|RESULTS|TRIANGLES [Args]
  !     [/BURN] [/SPLIT]
  !------------------------------------------------------------------
  character(len=*), intent(in) :: line
  character(len=*), intent(in) :: comm
  logical, intent(out) :: error
  !
  integer, parameter :: o_split=2
  integer, parameter :: o_burn=1
  integer :: na,iarg,iburn,ispli
  character(len=12) :: arg, argument
  character(len=32) :: trail
  logical :: do_init
  integer, parameter :: mpar=5
  character(len=12) :: cpar(mpar)
  data cpar /'AUTOCORR','CHAINS','ERRORS','RESULTS','TRIANGLES'/
  !
  trail = ' '
  iburn = sic_start(o_burn,0)
  if (iburn.ne.0) then
    ispli = sic_start(o_split,0)
    if (ispli.gt.iburn) then
      trail = line(iburn:ispli-1)
    else
      trail = line(iburn:)
    endif
  endif
  !
  error = .false.
  call sic_ch(line,0,1,arg,na,.false.,error)
  call sic_upper (arg)
  call sic_ambigs('ESHOW',arg,argument,iarg,cpar,mpar,error)
  if (error) return
  !
  do_init = .not.sic_varexist('EMCEE_LOADED')  
  !
  select case (argument)
  case ('AUTOCORR')
    arg = '100'
    call sic_ch(line,0,2,arg,na,.false.,error)
    trail = trim(arg)//' '//trim(trail)
    if (do_init) call exec_program('@ emcee-tools') 
    if (sic_present(o_split,0)) then
      call exec_program('@ emcee-corr '//trail)
    else
      call exec_program('@ emcee-auto '//trail)
    endif
  case ('CHAINS')
    if (do_init) call exec_program('@ emcee-tools') 
    call exec_program('@ emcee-plot CHAINS '//trail)
  case ('ERRORS')
    if (do_init) call exec_program('@ emcee-tools') 
    call exec_program('@ emcee-display * '//trail)
  case ('RESULTS')
    arg = 'results'
    call sic_ch(line,0,2,arg,na,.false.,error)
    if (do_init) call exec_program('@ emcee-tools') 
    call exec_program('@ emcee-display '//trim(arg)//' '//trail)
  case ('TRIANGLES')
    if (do_init) call exec_program('@ emcee-tools') 
    call exec_program('@ emcee-plot TRIANGLES '//trail)
  case default
    error = .true.
    return
  end select
  if (sic_lire().eq.0) call sic_insert(line)
end subroutine adjust_display
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_close
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_keyval_types
  use cubeadm_identifier
  use cubeedit_messaging
  !
  public :: close
  private
  !
  type :: close_comm_t
     type(option_t), pointer :: comm
     type(value_strg_comm_t) :: edid
     type(identifier_opt_t)  :: as
   contains
     procedure, public  :: register => cubeedit_close_comm_register
     procedure, private :: parse    => cubeedit_close_comm_parse
     procedure, private :: main     => cubeedit_close_comm_main
  end type close_comm_t
  type(close_comm_t) :: close
  !
  type close_user_t
     type(value_strg_user_t) :: edid
     type(identifier_user_t) :: as
   contains
     procedure, private :: toprog => cubeedit_close_user_toprog
  end type close_user_t
  !
  type :: close_prog_t
     character(len=base_l) :: edid = strg_unk
     character(len=base_l) :: ouid = strg_unk
   contains
     procedure, private :: act => cubeedit_close_prog_act
  end type close_prog_t
  !
contains
  !
  subroutine cubeedit_close_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command CLOSE
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(close_user_t) :: user
    character(len=*), parameter :: rname='CLOSE>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call close%parse(line,user,error)
    if (error) return
    call close%main(user,error)
    if (error) return
  end subroutine cubeedit_close_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_close_comm_register(comm,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(close_comm_t), intent(inout) :: comm
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>COMM>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'CLOSE','[bufferid]',&
         'Close an opened edited buffer',&
         'Close an opened edited buffer. The edited buffer is registered in&
         & the DAG only after CLOSE. By default, CLOSE uses the resolved&
         & edited buffer identifier as output cube&
         & identifier.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- CLOSE resolves bufferid. When omitted, it closes the most&
         & recently opened edited buffer.'//strg_cr//&
         '- Without /AS, the output cube identifier is the resolved&
         & edited buffer identifier.'//strg_cr//&
         '- With /AS outcubeid, CLOSE uses outcubeid as output cube&
         & identifier.'//strg_cr//&
         '- During close, family/flags are finalized before DAG&
         & registration.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- /AS changes only the output cube identifier and does not change&
         & which&
         & edited buffer is selected.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> CLOSE'//strg_cr//&
         'CUBE> CLOSE myedit'//strg_cr//&
         'CUBE> CLOSE myedit /AS final_cube'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> OPEN myedit /LIKE source_cube'//strg_cr//&
         'CUBE> PUT myedit ...'//strg_cr//&
         'CUBE> CLOSE myedit /AS final_cube'//strg_bl//&
         'The edited buffer is registered in the DAG only after CLOSE.',&
         cubeedit_close_command,&
         comm%comm,&
         error)
    if (error) return
    call comm%edid%register(&
         'BUFFERID',&
         'Edited buffer identifier',&
         strg_star,&
         code_arg_optional,&
         strg_emp,&
         error)
    if (error) return
    call comm%as%register(&
         'Output cube identifier',&
         changeflags,&
         error)
    if (error) return
  end subroutine cubeedit_close_comm_register
  !
  subroutine cubeedit_close_comm_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(close_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(close_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>COMM>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call comm%edid%parse(line,comm%comm,user%edid,error)
    if (error) return
    call close%as%parse(line,user%as,error)
    if (error) return
  end subroutine cubeedit_close_comm_parse
  !
  subroutine cubeedit_close_comm_main(comm,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(close_comm_t), intent(in)    :: comm
    type(close_user_t),  intent(in)    :: user
    logical,             intent(inout) :: error
    !
    type(close_prog_t) :: prog
    character(len=*), parameter :: rname='CLOSE>COMM>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubeedit_close_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeedit_close_user_toprog(user,comm,prog,error)
    use cubeedit_opened_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(close_user_t), intent(in)    :: user
    type(close_comm_t),  intent(in)    :: comm    
    type(close_prog_t),  intent(out)   :: prog
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>USER>TOPROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%get_editedid(user%edid%val,prog%edid,error)
    if (error) return
    if (user%as%do) then
       prog%ouid = user%as%identifier
    else
       prog%ouid = prog%edid
    endif
  end subroutine cubeedit_close_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeedit_close_prog_act(prog,error)
    use cubeedit_opened_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(close_prog_t), intent(in)    :: prog
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>PROG>ACT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%close(prog%edid,prog%ouid,error)
    if (error) return
  end subroutine cubeedit_close_prog_act
end module cubeedit_close
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sicset(line,lire,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use gsys_types
  use sic_dependencies_interfaces
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use sic_interfaces, except_this=>sicset
  !---------------------------------------------------------------------
  ! @ private
  !  SIC Internal routine
  ! Modifies the current status of SIC monitor:
  !     MEMORY       Switch
  !     VERIFY       Switch
  !     EDIT         Status or Editor
  !     HELP         Status
  !     PRECISION    Default mathematic precision
  !     DIRECTORY    Working directory
  !     EXTENSION    Default macro extension
  !     OUTPUT       Output file name
  !     DATE         Current date
  !     USER         Current user
  !     SEARCH       Search for file existence
  !     LOGICAL      Logical name translation
  !     BEEP n       Beep n times
  !     SYNTAX       Select Free/Fixed syntax for assignment
  !     VERSION      Give the program version...
  !     WAIT         Wait n seconds
  !     WINDOW       Activate / de-activate the Window mode
  !     MACRO        Procedure search path
  !     APPEND       Append Small_file Appended_file
  !     SAVE         File Command : Save all variable in File with Command
  !     CPU          Compute CPU time (for debugging purpose)
  !     FIND         Find list of files
  !     GREP         Grep a pattern from a file
  !     EXPAND       Expand command in a macro file
  !     PARSE File Name Ext Dir
  !     MESSAGE <Filters>  Alter on-screen and to-logfile verbosity
  !     FLUSH        Force flushing message and log files buffers onto disk
  !     WHICH Proc   Print full path of the Procedure which will be executed
  !     LOCK <FileName>  Create the lock-file, or exit if it exists
  !     HEADERS      GILDAS Header version
  !     INTEGER      Default SIC INTEGER kind (short or long)
  !     DELAY        Delay execution of next command
  !     SYSTEM       Switch: error from command SIC\SYSTEM should be ignored or not?
  !     TIMER        Set/Get the timer for automatic logout after inactivity
  !     MODIFIED     Set/get the modification status of a file
  !     RANDOM_SEED  (Re)set the Fortran random seed generator
  !     PARALLEL     Set the number of Open-MP threads
  !     <noarg>      Language in active scope
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Command line
  integer(kind=4),  intent(in)    :: lire   ! Execution level
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=40) :: argum
  character(len=16) :: name,ext
  character(len=12) :: action
  character(len=filename_length) :: fich,file,filo
  integer(kind=4) :: j,n,kl,nc,ier,nact,nf,tmp
  integer(kind=4) :: khelp,krecs
  integer(kind=4) :: i,iext,ip,sev
  real(kind=4) :: t,rste
  character(len=8) :: keyw
  character(len=30) :: user,date
  character(len=message_length-30) :: chain
  logical :: found,logi,fourt_status(2)
  character(len=1), parameter :: backslash=char(92)
  character(len=message_length) :: mess
  character(len=language_length) :: langs(mlang)
  ! Keyword lists
  integer(kind=4), parameter :: mact=46,nhelp=3,nrecs=5,ndebug=12,ninteg=2
  integer(kind=4), parameter :: nsystem=2
  character(len=5) :: psynt(2),pinteg(ninteg)
  character(len=6) :: precs(nrecs),phelp(nhelp),dictionary(3)
  character(len=7) :: system(nsystem)
  character(len=9) :: debug(ndebug)
  character(len=12) :: acts(mact)
  ! Data
  data acts /'APPEND','BEEP','COPY','CPU','DATE','DEBUG','DELAY','DELETE',   &
    'DIRECTORY','EDIT','ERROR','EXPAND','EXTENSION','FFT','FIND','FLUSH',    &
    'GREP','HEADERS','HELP','INTEGER','LOCK','LOGICAL','MACRO','MEMORY',     &
    'MESSAGE','MKDIR','MODIFIED','OUTPUT','PARALLEL','PARSE','PRECISION',    &
    'PRIORITY','RANDOM_SEED','RENAME','SAVE','SEARCH','SYNTAX','SYSTEM',     &
    'TIMER','USER','UVT_VERSION','VERIFY','VERSION','WAIT','WHICH',          &
    'WINDOW'/
  data precs/'SINGLE','REAL','DOUBLE','LONG','AUTO'/                    ! C*6
  data phelp/'SCROLL','PAGE','HTML'/                                    ! C*6
  data psynt/'FIXED','FREE'/                                            ! C*5
  data dictionary /'GLOBAL','LOCAL','USER'/                             ! C*6
  data debug /'LUN','IMAGE','MESSAGE','SHARED','GFORTRAN','RESOURCES',  &
              'PYTHON','VARIABLES','MEMALIGN','GIO_ALLOC','LOCALE',     &
              'SYSTEM'/                                                 ! C*9
  data pinteg /'SHORT','LONG'/                                          ! C*5
  data system /'ERROR','NOERROR'/                                       ! C*7
  !
  ! Code ----------------------------------------------------------------
  !
  ! No argument, List current status
  if (.not.sic_present(0,1)) then
    do j=1,nlang
      if (languages(j)%libmod) then
        write(mess,1005) 'Language '//trim(languages(j)%name)//backslash,  &
               'in LIBRARY ONLY'
      elseif (languages(j)%asleep) then
        write(mess,1005) 'Language '//trim(languages(j)%name)//backslash,'OFF'
      else
        write(mess,1005) 'Language '//trim(languages(j)%name)//backslash,'ON'
      endif
      call sic_message(seve%i,rname,mess)
    enddo
    !
    if (logbuf) then
      write(mess,1005) 'MEMORY switch','ON'
    else
      write(mess,1005) 'MEMORY switch','OFF'
    endif
    call sic_message(seve%i,rname,mess)
    !
    if (lverif) then
      write(mess,1005) 'VERIFY switch','ON'
    else
      write(mess,1005) 'VERIFY switch','OFF'
    endif
    call sic_message(seve%i,rname,mess)
    !
    if (edit_mode) then
      write(mess,1005) 'EDIT Mode','ON'
      call sic_message(seve%i,rname,mess)
      write(mess,1005) 'Selected editor',tt_edit
    else
      write(mess,1005) 'EDIT Mode','OFF'
    endif
    call sic_message(seve%i,rname,mess)
    !
    write(mess,1005) 'HELP Mode',phelp(help_mode)
    call sic_message(seve%i,rname,mess)
    !
    write(mess,1005) 'Precision of arithmetic',sic_precis
    call sic_message(seve%i,rname,mess)
    !
    ip = 1
    do i=1,maxext
      if (lext(i).eq.0) exit
      chain(ip:) = sicext(i)(1:lext(i))
      ip = ip+lext(i)+1
      if (ip.ge.message_length-30) exit
    enddo
    write (mess,1005) 'Macro extension',chain
    call sic_message(seve%i,rname,mess)
    !
    write (mess,1005) 'Syntax',psynt(lsynt)
    call sic_message(seve%i,rname,mess)
    !
    if (siclun.eq.0) then
      write(mess,1005) 'SIC OUTPUT','on terminal'
    else
      inquire (unit=siclun,name=fich,iostat=ier)
      write(mess,1005) 'SIC OUTPUT file',trim(fich)
    endif
    call sic_message(seve%i,rname,mess)
    !
    call sicapropos
    call sic_error_command
    return
  endif
  !
  ! Retrieve first argument
  call sic_ke (line,0,1,name,n,.true.,error)
  if (error) return
  !
  ! Set default severity: I)nfo with no arg (i.e. list value), D)ebug
  ! with an arg (i.e. set value).
  sev = seve%i
  !
  ! Languages
  if (name(n:n).eq.backslash) then
    langs(1:nlang) = languages(1:nlang)%name
    call sic_ambigs(rname,name(1:n-1),action,kl,langs,nlang,error)
    if (error) then
      call sic_message(seve%e,rname,'Could not modify status for language '//name(1:n))
      return
    endif
    if (action.eq.'SIC' .and. sic_present(0,2)) then
      call sic_message(seve%w,rname,'Cannot change SIC'//backslash//  &
      ' language status')
    elseif (languages(kl)%libmod) then
      if (sic_present(0,2)) then
        sev = seve%e
        error = .true.
      endif
      call sic_message(sev,rname,'Language '//trim(action)//backslash//  &
      ' is in LIBRARY ONLY')
    else
      if (sic_present(0,2)) then
        call sic_ke (line,0,2,argum,nc,.false.,error)
        if (error) return
        sev = seve%d
        if (argum.eq.'ON') then
          languages(kl)%asleep = .false.
          line = 'SIC'//backslash//'SIC '//trim(action)//backslash//' ON'
        elseif (argum.eq.'OFF') then
          languages(kl)%asleep = .true.
          line = 'SIC'//backslash//'SIC '//trim(action)//backslash//' OFF'
        else
          call sic_message(seve%w,rname,'Cannot set '//trim(action)//  &
          backslash//' language '//argum)
          error = .true.
        endif
      endif
      if (lire.eq.0) then
        if (languages(kl)%asleep) then
          argum = 'OFF'
        else
          argum = 'ON'
        endif
        call sic_message(sev,rname,trim(action)//backslash//' language is '//  &
        argum)
      endif
    endif
    return
  endif
  !
  ! Other actions
  call sic_ambigs('SIC',name,action,nact,acts,mact,error)
  if (error) return
  !
  select case (action)
  !
  case('MEMORY')
    call sic_switch(line,action,logbuf,lire,error)
  !
  case('VERIFY')
    call sic_setverify(line,lire,error)
  !
  case('EDIT')
    if (sic_present(0,2)) then
      call sic_ch (line,0,2,argum,nc,.false.,error)
      if (error) return
      sev = seve%d
      if (sic_eqchain(argum,'ON')) then
        call find_edit
        if (edit_mode) then
          line = 'SIC'//backslash//'SIC EDIT ON'
        else
          call sic_message(seve%w,rname,'Edit mode requires an ANSI-CRT')
          line = 'SIC'//backslash//'SIC EDIT OFF'
        endif
      elseif (sic_eqchain(argum,'OFF')) then
        edit_mode = .false.
        line = 'SIC'//backslash//'SIC EDIT OFF'
      else
        tt_edit = argum
        line = 'SIC'//backslash//'SIC EDIT "'//trim(argum)//'"'
      endif
      ier = sic_getlog(tt_edit)
    endif
    if (lire.eq.0) then
      call sic_message(sev,rname,'Editor is '//tt_edit)
    endif
  !
  case('HELP')
    if (sic_present(0,2)) then
      call sic_ke (line,0,2,argum,n,.false.,error)
      if (error) return
      sev = seve%d
      call sic_ambigs('HELP',argum,keyw,khelp,phelp,nhelp,error)
      if (error) return
      help_mode = khelp
      line = 'SIC'//backslash//'SIC HELP '//keyw
    endif
    if (lire.eq.0) then
      call sic_message(sev,rname,'HELP mode is '//phelp(help_mode))
    endif
  !
  case('PRECISION')
    if (sic_present(0,2)) then
      call sic_ke (line,0,2,argum,n,.false.,error)
      call sic_ambigs('PRECISION',argum,keyw,krecs,precs,nrecs,error)
      if (error) return
      sev = seve%d
      if (krecs.le.2) then
        sicprecis = fmt_r4
      elseif (krecs.eq.3) then
        sicprecis = fmt_r8
      elseif (krecs.eq.4) then
        sicprecis = fmt_i8
      elseif (krecs.eq.5) then
        sicprecis = 0
      endif
      line = 'SIC'//backslash//'SIC PRECISION '//keyw
      sic_precis = keyw
    endif
    if (lire.eq.0) then
      call sic_message(sev,rname,'Precision of arithmetic is '//sic_precis)
    endif
  !
  case('DIRECTORY')
    file = ' '
    nc = 0
    call sic_ch (line,0,2,file,nc,.false.,error)
    if (error) return
    if (sic_present(0,2)) sev = seve%d
    call sic_setdir(file,nc,error) ! Set or get working directory
    cur_dir = file(1:nc)
    call sic_message(sev,rname,'Default directory is '//cur_dir(1:nc))
  !
  case('OUTPUT')
    call sic_output(line,error)
    if (error)  return
  !
  case('EXTENSION')
    ! New behavior: extensions are added to previous list
    ! Pushes them at beginning of list, and removes duplicates
    if (sic_narg(0).gt.1) sev = seve%d
    do iext=min(sic_narg(0)-1,maxext),1,-1
      ! Get arg:
      call sic_ch (line,0,iext+1,argum,n,.true.,error)
      if (error) return
      ! Correct it:
      if (argum(1:1).ne.'.') then
        argum = '.'//argum
        n = n+1
      endif
      ! Remove from list if already registered:
      do i=1,maxext
        if (argum.eq.sicext(i)) then
          sicext(i) = ''
          lext(i) = 0
        endif
      enddo
      ! Remove blank (there should be currently only one):
      do i=1,maxext-1
        if (sicext(i).eq.'') then
          sicext(i) = sicext(i+1)
          lext(i) = lext(i+1)
          sicext(i+1) = ''
          lext(i+1) = 0
        endif
      enddo
      ! Push old values:
      do i=maxext,2,-1
        sicext(i) = sicext(i-1)
        lext(i) = lext(i-1)
      enddo
      ! Register:
      sicext(1) = argum
      lext(1) = n
    enddo
    ! Build a message:
    ip = 1
    n = 0
    do i=1,maxext
      if (lext(i).eq.0) then
        n = i-1
        exit
      endif
      if (ip.le.message_length) then
        chain(ip:) = sicext(i)(1:lext(i))
      endif
      ip = ip+lext(i)+1
    enddo
    call sic_message(sev,rname,'Default macro extensions: '//chain)
    !
    call sic_delvariable('SIC%EXTENSION',.false.,error)
    call sic_def_charn('SIC%EXTENSION',sicext,1,n,.true.,error)
  !
  case('DATE')
    call sic_date(date)
    call sic_setsymbol ('SYS_DATE',date,error)
  !
  case('USER')
    call sic_user(user)
    call sic_setsymbol('SYS_INFO',user,error)
  !
  case('SEARCH')
    call sic_ch (line,0,2,file,nc,.true.,error)
    if (error) return
    lexist = sic_findfile(file,fich,' ',' ')
    call sic_message(seve%w,rname,'You are using the obsolete command '//  &
    'SIC SEARCH')
    call sic_message(seve%w,rname,'Use the FILE(filename) function instead')
  !
  case('LOCK')
    if (sic_narg(0).eq.1) then
      call sic_message(seve%r,rname,'Lock files are:')
      call gag_show_locked_files()
    else
      call sic_ch(line,0,2,file,nc,.true.,error)
      if (error)  return
      call sic_parse_file(file,'','',fich)
      !
      ! Translate to an absolute path
      found = gag_which(fich,'',file)
      !
      ! (Try to) lock
      ier = gag_lock_file(file)
      if (ier.ne.0) then
         call sic_message(seve%f,rname,'Locked by file '//file)
         call sic_message(seve%f,rname,  &
           'Check the other sessions before freeing this lock')
         call sysexi(fatale)
      endif
    endif
  !
  case('LOGICAL')
    if (sic_present(0,3)) then
      call sic_ch (line,0,3,fich,nc,.true.,error)
      if (error) return
      call sic_parse_file(fich,'','',fich)
      call sic_ch (line,0,2,file,nc,.true.,error)
      if (error) return
      ier = sic_setlog(file,fich)
    else
      if (sic_present(0,2)) then
        call sic_ch (line,0,2,file,nf,.true.,error)
        if (error) return
      else
        file = '*'
        nf = 1
      endif
      if (index(file(1:nf),'*').eq.0) then
        ! Explicit name, no wilcard
        call sic_parse_file(file,'','',fich)
        if (fich.ne.file) then
          call sic_message(seve%r,rname,file(1:nf)//' = '//fich)
        else
          call sic_message(seve%w,rname,'No such logical name '//file(1:nf))
        endif
      else
        ! Wilcarded search, default '*'
        call sic_listlog(file)
      endif
    endif
  !
  case('BEEP')
    nf = 1
    call sic_i4 (line,0,2,nf,.false.,error)
    if (error) return
    nf = max(1,min(6,nf))
    do j=1,nf
      write(6,1001) char(7)
    enddo
  !
  case('SYNTAX')
    if (sic_present(0,2)) then
      call sic_ke (line,0,2,argum,n,.false.,error)
      if (error) return
      sev = seve%d
      if (n.gt.8) then
        call sic_message(seve%w,rname,'Invalid syntax '//argum(1:n))
      elseif (argum(1:n).eq.psynt(1)(1:n)) then
        if (n.eq.1) then
          call sic_message(seve%w,rname,'Ambiguous keyword')
        else
          lsynt = 1            ! Fixed syntax
        endif
        line = 'SIC'//backslash//'SIC SYNTAX FIXED'
      elseif (argum(1:n).eq.psynt(2)(1:n)) then
        lsynt = 2
        line = 'SIC'//backslash//'SIC SYNTAX FREE'
      else
        call sic_message(seve%w,rname,'Invalid syntax '//argum(1:n))
      endif
    endif
    call sic_message(sev,rname,'Syntax is '//psynt(lsynt))
  !
  case('ERROR')
    ! SIC ERROR : List the error command
    call sic_error_command
  !
  case('WAIT')
    t = 1.0
    !reads a real, sleeps howmany microseconds on several systems
    !checks the CTRL_C every seconds or at end of procedure (we are most
    ! often in a waiting LOOP, so exiting from the loop is required.)
    call sic_r4 (line,0,2,t,.false.,error)
    if (error) return
    nf = int(t)
    rste=t-float(nf)
    !
    ! wait the rste if not zero:
    ! SIC_WAIT must ensure a minimum Waiting (see sysc.c)
    if (rste.gt.0.0) call sic_wait(rste)
    ! then, if applicable, the NF seconds
    do j=1,nf
      if (sic_ctrlc()) then
        error=.true.
        return
      endif
      call sic_wait(1.0)
    enddo
    if (sic_ctrlc()) then
      error=.true.
      return
    endif
  !
  case('WINDOW')
    call sic_switch(line,'WINDOW',sic_window,lire,error)
  !
  case('DELETE')  ! DELETE File
    do i=2,sic_narg(0)
      call sic_ch (line,0,i,fich,n,.false.,error)
      call sic_parse_file(fich,'','',file)  ! Expand logicals in the string
      call gag_delete(file)
    enddo
  !
  case('COPY')  ! COPY File_in File_out
    call sic_ch (line,0,2,fich,n,.true.,error)
    if (error) return
    call sic_parse_file(fich,'','',file)
    !
    call sic_ch (line,0,3,fich,n,.true.,error)
    if (error) return
    call sic_parse_file(fich,'','',filo)
    !
    if (gag_isdir(filo).eq.0) then
      ! Target is an existing directory: copy the file there
      call sic_parse_name(file,fich,oext=ext)  ! Get 'short' name and extension
      filo = trim(filo)//'/'//trim(fich)//'.'//ext
    endif
    !
    if (gag_filcopy(file,filo).ne.0) then
      if (sicsystemerror) then
        call sic_message(seve%e,rname,  &
          'Failed to COPY '//trim(file)//' to '//trim(filo))
        error = .true.
        return
      else
        call sic_message(seve%w,rname,  &
          'Failed to COPY '//trim(file)//' to '//trim(filo))
      endif
    endif
    !
  case('RENAME')  ! RENAME File_in File_out
    if (sic_narg(0).eq.3) then
      call sic_ch (line,0,2,fich,n,.false.,error)
      if (error) return
      call sic_parse_file(fich,'','',file)
      !
      call sic_ch (line,0,3,fich,n,.false.,error)
      if (error) return
      call sic_parse_file(fich,'','',filo)
      !
      ier = gag_filmove(file,filo)
    else
      call sic_message(seve%e,rname,'RENAME File_old File_new')
    endif
  !
  case('VERSION')
    call sicapropos
  !
  case('MACRO')  ! MACRO Path
    if (sic_present(0,2)) then
      call sic_ch(line,0,2,fich,n,.true.,error)
      ier = sic_setlog('MACRO#DIR:',fich(1:n))
    else
      fich = ''
      ier = sic_getlog('MACRO#DIR:',fich)
      call sic_message(seve%i,rname,'Procedure search path:')
      call sic_message(seve%r,rname,fich)
    endif
    !
  case('APPEND')
    call sic_ch (line,0,2,fich,n,.true.,error)
    if (error) return
    call sic_parse_file(fich,'','',file)
    !
    call sic_ch (line,0,3,fich,n,.true.,error)
    if (error) return
    call sic_parse_file(fich,'','',filo)
    !
    if (gag_filappend(file,filo).ne.0) then
      if (sicsystemerror) then
        call sic_message(seve%e,rname,  &
          'Failed to APPEND '//trim(file)//' to '//trim(filo))
        error = .true.
        return
      else
        call sic_message(seve%w,rname,  &
          'Failed to APPEND '//trim(file)//' to '//trim(filo))
      endif
    endif
    !
  case('MKDIR')
    call sic_ch(line,0,2,fich,n,.true.,error)
    if (error) return
    call gag_mkdir(fich(1:n),error)
    !
  case('PARALLEL')
    call sic_openmp(line,error)
  case('DEBUG')  ! DEBUG LUN|IMAGE [Number], DEBUG MESSAGE, DEBUG SHARED
    call sic_ke(line,0,2,argum,n,.true.,error)
    if (error)  return
    call sic_ambigs('SIC DEBUG',argum,fich,n,debug,ndebug,error)
    if (error)  return
    !
    select case (fich)
    case ('LUN')
      n = 0
      call sic_i4(line,0,3,n,.false.,error)
      ier = gag_stalun(n)
      !
    case ('IMAGE')
      n = 0
      call sic_i4(line,0,3,n,.false.,error)
      if (n.eq.0) then
        call gio_lsis('',error)
      else
        tmp = gdf_stis(n)
        if (tmp.eq.-1) then
          write(mess,*) 'No such image slot ',n
        else
          write(mess,*) 'Image slot ',n,' status ',tmp
        endif
        call sic_message(seve%i,'SIC DEBUG',mess)
      endif
      !
    case ('MESSAGE')
      call gmessage_debug_swap
      !
    case ('GFORTRAN')
      call sic_debug_gfortran(error)
      if (error)  return
      !
    case ('RESOURCES')
      call gag_resources
      !
    case ('MEMALIGN')
      call sic_debug_memalign
      !
    case ('PYTHON')
#if defined(GAG_USE_PYTHON)
      call sic_debug_python
#else
      call sic_message(seve%w,rname,'SIC not compiled with Python binding')
#endif
      !
    case ('VARIABLES')
      call sic_debug_variables
      !
    case ('GIO_ALLOC')
      logi = .false.
      call sic_l4(line,0,3,logi,.false.,error)
      call gdf_prealloc(logi)
      !
    case ('LOCALE')
      if (sic_present(0,3)) then
        call sic_ch(line,0,3,argum,n,.true.,error)
        if (error)  return
        ier = gag_setlocale(argum)
        if (ier.ne.0) error = .true.
      else
        call gag_printlocale()
      endif
      !
    case ('SYSTEM')
      call sic_ke (line,0,3,argum,nc,.true.,error)
      if (error) return
      if (argum.eq.'ON') then
        call sic_debug_system(1)
      elseif (argum.eq.'OFF') then
        call sic_debug_system(0)
      else
        call sic_message(seve%e,rname,'SIC DEBUG SYSTEM argument must be ON or OFF')
        error = .true.
        return
      endif
      !
    case default
      call sic_message(seve%e,'SIC DEBUG','Unknown keyword '//fich)
      error=.true.
      return
      !
    end select
  !
  case('SAVE')  ! SAVE File Command
    if (.not.sic_present(0,2)) then
      if (lunsav.ne.0) then
        close(unit=lunsav)
        call sic_frelun (lunsav)
        lunsav = 0
      endif
    else
      if (lunsav.ne.0) then
        call sic_message(seve%w,'SIC SAVE','Closing previous file')
        close(unit=lunsav)
        call sic_frelun (lunsav)
        lunsav = 0
      endif
      call sic_ch(line,0,2,name,n,.true.,error)
      if (error) return
      call sic_ch(line,0,3,savcom,lsavcom,.true.,error)
      if (error) return
      !
      ier = sic_getlun(lunsav)
      if (ier.ne.1) then
        error = .true.
        return
      endif
      call sic_parsef (name,file,'GAG_PROC:',sicext(1)(1:lext(1)))
      ier = sic_open(lunsav,file,'UNKNOWN',.false.)
      if (ier.ne.0) then
        call sic_message(seve%e,rname,'Cannot open file for Save procedure')
        call putios('E-SIC,  ',ier)
        error = .true.
        return
      endif
    endif
  !
  case('CPU')
    call sic_cpu(line,error)
  !
  case('DELAY')
    call sic_delay(line,error)
  !
  case('FIND')  ! FIND files*.ext [Directory]
    call sic_directory(line,error)
  !
  case('GREP')  ! GREP Pattern File
    call sic_grep(line,error)
  !
  case('EXPAND')  ! EXPAND inmacro outmacro
    call expand_macro (line,error)
  !
  case('PRIORITY')
    call parse_priority(line,error)
  !
  case('PARSE')
    call parse_filename(line,error)
  !
  case('FFT')  ! FFT (for debug only)
    if (sic_narg(0).eq.1) then
      call fourt_get_usage(fourt_status)
    else
      call sic_ke(line,0,2,fich,n,.true.,error)
      fourt_status(1) = fich(1:n).eq.'FAST' .or. fich(1:n).eq.'FFTW'
      fourt_status(2) = sic_present(0,3)
      call fourt_set_usage(fourt_status)
    endif
    !
    if (fourt_status(1)) then
      write(mess,*) 'Using FFTW, Debug ',fourt_status(2)
    else
      write(mess,*) 'Using FOURT'
    endif
    call sic_message(seve%i,rname,mess)
  !
  case('MESSAGE')  ! Handle messages output
    call sicset_message(line,error)
  !
  case('FLUSH')  ! Force flushing message and log files buffers onto disk
#if defined(FORTRAN2003)
    call sic_flush_log(error)
    call gmessage_flush(error)
#else
    call sic_message(seve%w,rname,'FLUSH not done. Please enable Fortran '//  &
    '2003 features')
#endif
  !
  case('WHICH')  ! WHICH Procedure
    call sic_ch(line,0,2,fich,n,.true.,error)
    if (error) return
    call find_procedure(fich,file,found)
    if (found) then
      call sic_message(seve%r,rname,file)
    else
      call sic_message(seve%w,rname,'No such procedure '//fich)
    endif
    !
  case('HEADERS')
    call sic_i4(line,0,2,n,.true.,error)
    if (error)  return
    call gdf_stbl(n,error)
    !
  case('INTEGER')
    if (sic_present(0,2)) then
      call sic_ke(line,0,2,argum,n,.true.,error)
      if (error)  return
      call sic_ambigs('SIC INTEGER',argum,name,n,pinteg,ninteg,error)
      if (error)  return
      if (n.eq.2) then
        sicinteger = fmt_i8
      else
        sicinteger = fmt_i4
      endif
    endif
    if (sicinteger.eq.fmt_i4) then
      call sic_message(seve%i,rname,'Default SIC INTEGER is '//pinteg(1))
    elseif (sicinteger.eq.fmt_i8) then
      call sic_message(seve%i,rname,'Default SIC INTEGER is '//pinteg(2))
    endif
    !
  case('SYSTEM')
    if (sic_present(0,2)) then
      call sic_ke(line,0,2,argum,n,.true.,error)
      if (error)  return
      call sic_ambigs('SIC SYSTEM',argum,name,n,system,nsystem,error)
      if (error)  return
      sicsystemerror = n.eq.1
    endif
    if (sicsystemerror) then
      call sic_message(seve%i,rname,'SIC\SYSTEM, SIC COPY and SIC APPEND can raise errors')
    else
      call sic_message(seve%i,rname,'SIC\SYSTEM, SIC COPY and SIC APPEND won''t raise errors')
    endif
    !
  case('TIMER')
    if (sic_present(0,2)) then
      call sic_timer_dotime(line,2,3,error)
    else
      call sic_timer_show(error)
    endif
    if (error)  return
    !
  case('MODIFIED')
    call sic_modified(line,error)
    if (error)  return
    !
  case('RANDOM_SEED')
    if (sic_present(0,2)) then
      call sic_ke(line,0,2,argum,n,.true.,error)
      if (error)  return
      call gmath_random_seed_set(argum,error)
      if (error)  return
    else
      call gmath_random_seed_print(error)
      if (error)  return
    endif
    !
  case('UVT_VERSION')
    argum = ' '
    call sic_ch(line,0,2,argum,n,.false.,error)
    if (error)  return
    call gdf_set_uvt_version(argum)
    !
  case default
    error = .true.
    call sic_message(seve%e,rname,'No code for '//action)
    return
  end select
  !
1001 format (a,$)
1005 format (a,t25,' is  ',a)
end subroutine sicset
!
subroutine sicapropos
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sicapropos
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Display the versions of various elements of the Gildas executables
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer :: i
  character(len=32) :: version
  character(len=256) :: release
  character(len=message_length) :: mess
  real(kind=4) :: gdf_in,gdf_out,rversion
  !
  ! Version
  call gag_release(release)
  write(*,'(a)') trim(release)
  !
  write(mess,'(a,t20,5a)')  'Compiling system ',OS_KIND,' ',OS_NAME,' ',OS_VERSION
  call sic_message(seve%r,rname,mess)
  !
  ! Translate preprocessing symbols as integers. Unable to quote them so
  ! that we can print them as strings!
#if defined(GFORTRAN)
  write(mess,102)  'Compiler','gfortran',GFORTRAN_VERSION
  call sic_message(seve%r,rname,mess)
#elif defined(IFORT)
  write(mess,102)  'Compiler','ifort',IFORT_VERSION
  call sic_message(seve%r,rname,mess)
#endif
  !
  ! External libraries
#if defined(GAG_USE_GTK)
  call gtk_get_version(version)
  write(mess,100)  'Library','GTK+',version
  call sic_message(seve%r,rname,mess)
#endif
#if defined(CFITSIO)
  call sicapropos_cfitsio_vers(rversion)
  write(mess,101)  'Library','CFITSIO',rversion
  call sic_message(seve%r,rname,mess)
#endif
  !
  ! Languages
  do i=1,nlang
    write(mess,100)  'Language',languages(i)%name,languages(i)%mess
    call sic_message(seve%r,rname,mess)
  enddo
  !
  gdf_in = 2.0
  if (gdf_stbl_get().gt.1) then
    gdf_out = 2.0
  else
    gdf_out = 1.0
  endif
  write(mess,'(A,F3.1)')  &
    'Internal Gildas Data Format Version ',gdf_in
  call sic_message(seve%r,rname,mess)
  write(mess,'(A,F3.1,A)')  &
    'External Gildas Data Format Version ',gdf_out,' (default)'
  call sic_message(seve%r,rname,mess)
  !
  if (index_length.eq.8) then
    write(mess,'(A)')  'Array indices length: up to 2**63-1 (INTEGER*8)'
  else
    write(mess,'(A)')  'Array indices length: up to 2**31-1 (INTEGER*4)'
  endif
  call sic_message(seve%r,rname,mess)
  !
  call sic_get_openmp
  !
100 format(a,t10,a,t20,a)
101 format(a,t10,a,t20,f5.3)
102 format(a,t10,a,t20,i0)
  !
end subroutine sicapropos
!
#if defined(CFITSIO)
subroutine sicapropos_cfitsio_vers(version)
  use cfitsio_api
  !---------------------------------------------------------------------
  ! @ private
  ! Return the CFITSIO version.
  !---------------------------------------------------------------------
  real(kind=4), intent(out) :: version
  call ftvers(version)
end subroutine sicapropos_cfitsio_vers
#endif
!
subroutine sic_directory(line,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>sic_directory
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   SIC\SIC FIND [Filter [Directory]]
  ! Define  DIR%NFILE and DIR%FILE variables.
  !-----------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: nc
  integer(kind=4) :: dir_nfile
  logical :: first
  character(len=filename_length), allocatable :: dir_file(:)
  character(len=filename_length) :: filestring,tmpstring,dirstring
  save dir_nfile,dir_file,first
  data first /.true./
  !
  if (first) then
    call sic_defstructure('DIR',.true.,error)
    if (error)  return
    call sic_def_inte('DIR%NFILE',dir_nfile,0,1,.true.,error)
    if (error)  return
    first = .false.
  endif
  call sic_delvariable('DIR%FILE',.false.,error)
  dir_nfile = 0
  !
  filestring = '*.*'
  call sic_ch(line,0,2,filestring,nc,.false.,error)
  if (error) return
  tmpstring = ' '
  call sic_ch(line,0,3,tmpstring,nc,.false.,error)
  if (error) return
  call sic_parse_file(tmpstring,'','',dirstring)  ! Translate Sic logicals and others
  call gag_directory(dirstring,filestring,dir_file,dir_nfile,error)
  if (error) return
  !
  if (dir_nfile.gt.0) then
    error = .false.
    call sic_def_charn('DIR%FILE',dir_file,1,dir_nfile,.true.,error)
  endif
end subroutine sic_directory
!
subroutine sic_error_command
  use sic_interfaces, except_this=>sic_error_command
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! List the current ON ERROR Command
  !---------------------------------------------------------------------
  integer :: lerr
  character(len=message_length) :: mess
  !
  lerr = nerr(0)
  if (lerr.eq.e_pause) then
    write (mess,1000) 'Interactive: ON ERROR PAUSE'
  elseif (lerr.eq.e_cont) then
    write (mess,1000) 'Interactive: ON ERROR CONTINUE'
  elseif (lerr.eq.e_quit) then
    write (mess,1000) 'Interactive: ON ERROR QUIT'
  elseif (lerr.eq.e_retu) then
    write (mess,1000) 'Interactive: ON ERROR RETURN'
  else
    write (mess,1000) 'Interactive: ON ERROR ',errcom(0)(1:lerr)
  endif
  call sic_message(seve%i,'SIC',mess)
  if (var_level.gt.0) then
    lerr = nerr(var_level)
    if (lerr.eq.e_pause) then
      write (mess,1003) 'Level ',var_level,': ON ERROR PAUSE'
    elseif (lerr.eq.e_cont) then
      write (mess,1003) 'Level ',var_level,': ON ERROR CONTINUE'
    elseif (lerr.eq.e_quit) then
      write (mess,1003) 'Level ',var_level,': ON ERROR QUIT'
    elseif (lerr.eq.e_retu) then
      write (mess,1003) 'Level ',var_level,': ON ERROR RETURN'
    else
      write (mess,1003) 'Level ',var_level,': ON ERROR ',  &
      errcom(var_level)(1:lerr)
    endif
    call sic_message(seve%i,'SIC',mess)
  endif
1000 format (20(a))
1003 format (a,i2,a,a,a)
end subroutine sic_error_command
!
subroutine sic_switch(line,action,switch,lire,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_switch
  !---------------------------------------------------------------------
  ! @ private
  ! List and/or Toggle an internal SIC switch
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !
  character(len=*), intent(in)    :: action  !
  logical,          intent(inout) :: switch  !
  integer(kind=4),  intent(in)    :: lire    !
  logical,          intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=1), parameter :: backslash=char(92)
  character(len=4) :: argum,found
  integer(kind=4) :: n,sev
  integer(kind=4), parameter :: monoff=2
  character(len=3), parameter :: onoff(monoff)= (/ 'ON ','OFF' /)
  !
  sev = seve%i
  !
  if (sic_present(0,2)) then
    call sic_ke (line,0,2,argum,n,.false.,error)
    if (error) return
    call sic_ambigs(rname,argum,found,n,onoff,monoff,error)
    if (error)  return
    sev = seve%d
    switch = n.eq.1
    line = 'SIC'//backslash//'SIC '//action//' '//onoff(n)
  endif
  if (lire.eq.0) then
    if (switch) then
      argum = 'ON'
    else
      argum = 'OFF'
    endif
    call sic_message(sev,rname,action//' is '//argum)
  endif
end subroutine sic_switch
!
subroutine parse_priority(line,error)
  use sic_dependencies_interfaces
  use sic_interactions
  use sic_interfaces, except_this=>parse_priority
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='SIC PRIORITY'
  integer :: na,nc,i,j,iprio,nl,sev
  character(len=language_length) :: argum,lang,langs(mlang)
  character(len=1) :: wildcard    ! Synomym for all languages
  character(len=message_length) :: mess
  ! Data
  data wildcard /'*'/
  !
  na = sic_narg(0)
  sev = seve%i
  !
  if (na.ge.2) then
    !
    sev = seve%d
    !
    ! Get first argument (must be a level)
    call sic_i4(line,0,2,iprio,.true.,error)
    if (iprio.lt.-mprio .or. iprio.gt.mprio) then
      call sic_message(seve%e,rname,'Invalid priority level')
      error =.true.
    endif
    if (error) return
    !
    ! Get next arguments
    langs(1:nlang) = languages(1:nlang)%name
    do i=3,na
      !
      ! Try a language name
      call sic_ke(line,0,i,argum,nc,.true.,error)
      if (error) return
      !
      call sic_ambigs_sub(rname,argum,lang,nl,langs,nlang,error)
      if (error) return        ! There was an ambiguity
      !
      if (nl.ne.0) then        ! Found a language
        languages(nl)%prio = iprio
      elseif (argum.eq.wildcard) then
        languages(1:nlang)%prio = iprio
      else                     ! Not a recognized language, try a level
        call sic_i4(line,0,i,iprio,.true.,error)
        if (error) then
          call sic_message(seve%e,rname,'No such language '//argum(1:nc))
          return
        endif
        if (iprio.lt.-mprio .or. iprio.gt.mprio) then
          call sic_message(seve%e,rname,'Invalid priority level')
          error =.true.
          return
        endif
      endif
      !
    enddo
    !
  endif
  !
  call parse_priority_recompute(error)
  if (error)  return
  !
  ! Print priorities
  do i=1,nprio
    write (mess,'(A,I3,2X,30(A,1X))') 'Priority Level #',i,  &
    (languages(olang(j,i))%name,j=1,klang(i))
    call sic_message(sev,rname,mess)
  enddo
  !
end subroutine parse_priority
!
subroutine parse_priority_recompute(error)
  use gbl_message
  use eclass_types
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>parse_priority_recompute
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !   Recompute the priority structures according to the (new)
  ! priorities in 'languages(:)%prio'
  !   Sorting rules (example):
  !    Prio   Level
  !     1       1
  !     2       2
  !     3       3
  !     0       4  (automatic = after the explicit positive priorities
  !                         and before the negative ones)
  !    -2       5
  !    -1       6  (negative = position from the end)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SIC PRIORITY'
  type(eclass_inte_t) :: eclass
  integer(kind=4) :: cval(nlang),ckey(nlang),cbak(nlang)  ! Automatic arrays
  integer(kind=4) :: il,iu,is,lprio,nneg,npos
  !
  ! Compute equivalence classes to gather the priorities by family
  call reallocate_eclass_inte(eclass,nlang,error)
  if (error)  return
  eclass%val(1:nlang) = languages(1:nlang)%prio
  eclass%cnt(:) = 1
  call eclass_inte(eclass_inte_eq,eclass)
  !
  if (eclass%nequ.gt.mprio) then
    call sic_message(seve%e,rname,'Too many priority levels')
    error = .true.
    goto 10
  endif
  !
  ! Sort the classes
  cval(1:eclass%nequ) = eclass%val(1:eclass%nequ)
  call gi4_trie(cval,ckey,eclass%nequ,error)
  if (error)  goto 10
  do is=1,eclass%nequ
    cbak(ckey(is)) = is
  enddo
  !
  ! Locate the negative-or-null and positive priorities
  nneg = 0
  npos = 0
  do is=1,eclass%nequ
    if (eclass%val(is).le.0) then
      nneg=nneg+1
    else
      npos=npos+1
    endif
  enddo
  !
  ! Recompute the priority structures.
  nprio = eclass%nequ
  klang(:) = 0    ! Reset arrays
  olang(:,:) = 0  !
  do il=1,nlang
    iu = eclass%bak(il)  ! Language #i goes into equiv-class #iu (unsorted)...
    is = cbak(iu)        ! ...which is priority #is (sorted)
    if (eclass%val(iu).gt.0) then
      lprio = is-nneg
    elseif (eclass%val(iu).eq.0) then
      lprio = npos+1
    else
      lprio = npos+1+is
    endif
    klang(lprio) = klang(lprio)+1
    olang(klang(lprio),lprio) = il
  enddo
  !
10 continue
  call free_eclass_inte(eclass,error)
  !
end subroutine parse_priority_recompute
!
subroutine parse_filename (line,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>parse_filename
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC PARSE Filename Name [Ext [Dir]]
  ! Parse an input filename, and return the short Name, and optionally
  ! the Extension and Directory as SIC variables. The name of the
  ! corresponding variables are given in the command line.
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=filename_length) :: file,dir,name
  character(len=32) :: ext
  integer(kind=4) :: nc
  type(sic_descriptor_t) :: desc
  !
  call sic_ch(line,0,2,name,nc,.true.,error)
  if (error)  return
  call sic_parse_name(name,file,ext,dir)
  !
  call get_achar_desc(line,0,3,desc,error)
  if (error) return
  call ctodes(file,desc%type,desc%addr)
  !
  if (.not.sic_present(0,4)) return
  call get_achar_desc(line,0,4,desc,error)
  if (error) return
  call ctodes(ext,desc%type,desc%addr)
  !
  if (.not.sic_present(0,5)) return
  call get_achar_desc(line,0,5,desc,error)
  if (error) return
  call ctodes(dir,desc%type,desc%addr)
end subroutine parse_filename
!
subroutine get_achar_desc(line,iopt,iarg,desc,error)
  use gildas_def
  use sic_interfaces, except_this=>get_achar_desc
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Get the descriptor of an (existing, writeable) character string
  ! whose name is the Iarg argument of option Iopt of the command line
  !---------------------------------------------------------------------
  character(len=*)                      :: line   !
  integer                               :: iopt   !
  integer                               :: iarg   !
  type(sic_descriptor_t)                :: desc   !
  logical,                intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='PARSE'
  character(len=128) :: var
  integer :: nc
  logical :: found
  !
  call sic_ch(line,iopt,iarg,var,nc,.true.,error)
  if (error) return
  call sic_descriptor(var,desc,found)
  if (.not.found) then
    call sic_message(seve%e,rname,'No such variable '//var)
    error = .true.
    return
  endif
  if (desc%type.lt.0) then
    call sic_message(seve%e,rname,'Wrong variable type')
    error = .true.
    return
  endif
  if (desc%readonly) then
    call sic_message(seve%e,rname,'Variable is ReadOnly')
    error = .true.
    return
  endif
end subroutine get_achar_desc
!
subroutine sic_debug_gfortran(error)
  use sic_interfaces, except_this=>sic_debug_gfortran
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Try to reproduce the bug observed with gfortran when writing
  ! Gildas binary files.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SIC DEBUG'
  character(len=message_length) :: before
  integer(kind=4), parameter :: vin=2147483647  ! Value to be converted
  integer(kind=4), parameter :: vout=-129       ! Expected value on return
  integer(kind=8) :: din=9223372036854775807_8  ! Value to be converted
  integer(kind=8), parameter :: dout=-129       ! Expected value on return
  integer(kind=4) :: in4,out4
  integer(kind=8) :: in8,out8
  integer(kind=1) :: in1(4),out1(4),in2(8),out2(8)
  equivalence (in4,in1(1)), (out4,out1(1))
  equivalence (in8,in2(1)), (out8,out2(1))
  !
  ! First check if the conversion works properly
  in4 = vin
  in8 = din
  Print *,' DIN ',din,' VIN ',vin
#if defined(IEEE) || defined(VAX)
  call iei4ei(in4,out4,1)
  if (out4.ne.vout) then
    call sic_message(seve%e,rname,'IEEE to EEEI conversion error:')
    write (6,*) 'Input:  ',in4, ' (int4) = ',in1, ' (4 int1)'
    write (6,*) 'Output: ',out4,' (int4) = ',out1,' (4 int1)'
    error = .true.
  endif
  call iei8ei(in8,out8,1)
  if (out8.ne.dout) then
    call sic_message(seve%e,rname,'IEEE to EEEI conversion error:')
    write (6,*) 'In: ',in8, ' (int4) ',in2, ' (8 int1)'
    write (6,*) 'Out:',out8,' (int8) ',out2,' (8 int1)'
    error = .true.
  endif
#endif
  !
  ! Then check the conversion inplace ('in' is used in and out). It seems
  ! that some versions of gfortran do not like this inplace modification.
  ! The problem is observed at least in subroutine real_to_int4, file
  ! kernel/lib/gio/rescale.f90
  in4 = vin
#if defined(IEEE) || defined(VAX)
  write (before,*) 'Input:  ',in4,' (int4) = ',in1,' (4 int1)'
  call iei4ei(in4,in4,1)
  if (in4.ne.vout) then
    call sic_message(seve%e,rname,  &
      'Call to subroutine IEI4EI with single I/O variable failed:')
    write (6,'(a)') trim(before)
    write (6,*) 'Output: ',in4,' (int4) = ',in1,' (4 int1)'
    error = .true.
  endif
  write (before,*) 'In: ',in8,' (int8) = ',in2,' (8 int1)'
  call iei8ei(in8,in8,1)
  if (in8.ne.dout) then
    call sic_message(seve%e,rname,  &
      'Call to subroutine IEI8EI with single I/O variable failed:')
    write (6,'(a)') trim(before)
    write (6,*) 'Out:',in8,' (int8) = ',in2,' (8 int1)'
    error = .true.
  endif
#endif
  !
  if (error)  return
  !
  call sic_message(seve%i,rname,'No problem during the IEEE to EEEI conversion')
  !
end subroutine sic_debug_gfortran
!
subroutine sic_debug_memalign
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !  Check how:
  !   1) Fortran allocatables,
  !   2) malloc-ed buffers,
  !   3) and fftw_malloc-ed buffers
  !  are aligned in memory
  !---------------------------------------------------------------------
  ! Local
  integer(kind=4) :: i,ier
  integer(kind=size_length) :: siz
  integer(kind=4), allocatable :: i4(:)
  integer(kind=address_length) :: addr
  !
  write(*,'(A)')
  write(*,'(A)')  'Fortran allocatables:'
  do i=5,14
    siz = 4**i  ! Buffer size, in words
    allocate(i4(siz))
    addr = locwrd(i4)  ! Address in bytes
    write(*,'(I10,A,I16,A,4(1X,L))') siz,' words, address ',addr,  &
      ', aligned on 4, 8, 16, 32 bytes:',  &
      mod(addr,4).eq.0, &
      mod(addr,8).eq.0, &
      mod(addr,16).eq.0, &
      mod(addr,32).eq.0
    deallocate(i4)
  enddo
  !
  write(*,'(A)')
  write(*,'(A)')  'Malloc buffers:'
  do i=5,14
    siz = 4**i  ! Buffer size, in words
    ier = sic_getvm(siz,addr)  ! Return address in bytes
    write(*,'(I10,A,I16,A,4(1X,L))') siz,' words, address ',addr,  &
      ', aligned on 4, 8, 16, 32 bytes:',  &
      mod(addr,4).eq.0, &
      mod(addr,8).eq.0, &
      mod(addr,16).eq.0, &
      mod(addr,32).eq.0
    call free_vm(siz,addr)
  enddo
  !
end subroutine sic_debug_memalign
!
subroutine sic_debug_system(switch)
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: switch
  call gag_debug_system(switch)
end subroutine sic_debug_system
!
subroutine sic_cpu(line,error)
  use gbl_message
  use gsys_types
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_cpu
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  SIC\SIC CPU [VERBOSE]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SIC CPU'
  character(len=7), parameter :: verbose(1) = (/ 'VERBOSE' /)
  character(len=12) :: arg,keyw
  integer(kind=4) :: nc,ikey
  logical :: dofeedback
  character(len=message_length) :: mess
  type(cputime_t), save :: cputime
  logical, save :: firstt
  data firstt /.true./
  !
  ! Parsing
  if (sic_present(0,2)) then
    call sic_ke(line,0,2,arg,nc,.true.,error)
    if (error)  return
    call sic_ambigs(rname,arg,keyw,ikey,verbose,1,error)
    if (error)  return
    dofeedback = ikey.eq.1
  else
    dofeedback = .false.
  endif
  !
  ! Execution
  if (firstt) then
    call gag_cputime_init(cputime)
    !
    ! Parent structures
    call sic_defstructure('SIC%CPU',      .true.,error)
    if (error) return
    call sic_defstructure('SIC%CPU%RAW',  .true.,error)
    if (error) return
    call sic_defstructure('SIC%CPU%CUMUL',.true.,error)
    if (error) return
    ! System times
    call sic_def_dble('SIC%CPU%RAW%SYSTEM',  cputime%diff%system,0,1,.true.,error)
    call sic_def_dble('SIC%CPU%CUMUL%SYSTEM',cputime%curr%system,0,1,.true.,error)
    ! User times
    call sic_def_dble('SIC%CPU%RAW%USER',  cputime%diff%user,0,1,.true.,error)
    call sic_def_dble('SIC%CPU%CUMUL%USER',cputime%curr%user,0,1,.true.,error)
    ! Elapsed times
    call sic_def_dble('SIC%CPU%RAW%ELAPSED',  cputime%diff%elapsed,0,1,.true.,error)
    call sic_def_dble('SIC%CPU%CUMUL%ELAPSED',cputime%curr%elapsed,0,1,.true.,error)
    if (error) return
    !
    firstt = .false.
  else
    call gag_cputime_get(cputime)
  endif
  !
  ! Feedback
  if (dofeedback) then
    write(mess,'(A)')   '            System      User       Elapsed'
    call sic_message(seve%r,rname,mess)
    write(mess,'(4A)')  ' Raw   ',pr(cputime%diff%system),  &
                                  pr(cputime%diff%user),    &
                                  pr(cputime%diff%elapsed)
    call sic_message(seve%r,rname,mess)
    write(mess,'(4A)')  ' Cumul ',pr(cputime%curr%system),  &
                                  pr(cputime%curr%user),    &
                                  pr(cputime%curr%elapsed)
    call sic_message(seve%r,rname,mess)
  endif
  !
contains
  function pr(v)  ! Print!
    character(len=12) :: pr
    real(kind=8), intent(in) :: v
    !
    if (v.gt.6000.d0) then  ! > 100 min
      write(pr,'(F9.2,A3)')  v/3600.d0,'hr '
    elseif (v.gt.100.d0) then  ! > 100 sec
      write(pr,'(F9.2,A3)')  v/60.d0,'min'
    else
      write(pr,'(F9.2,A3)')  v,'sec'
    endif
    !
  end function pr
  !
end subroutine sic_cpu
!
subroutine sic_delay(line,error)
  use sic_dependencies_interfaces
  use gbl_message
  use gsys_types
  use sic_interfaces, except_this=>sic_delay
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for commande SIC\SIC DELAY
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SIC DELAY'
  type(cputime_t) :: cputime
  real(kind=8) :: delay
  character(len=message_length) :: mess
  integer(kind=4) :: itime
  real(kind=8), save :: goal
  data goal /0.d0/
  !
  if (sic_present(0,2)) then
    ! SIC\SIC DELAY Time: give the minimum time to wait
    call sic_r8 (line,0,2,delay,.true.,error)
    if (error) return
    !
    call gag_cputime_init(cputime)  ! Get current date-time in cputime%refe%elapsed
    goal = cputime%refe%elapsed+delay
  else
    ! SIC\SIC DELAY (no argument): wait until new time is reached
    call gag_cputime_init(cputime)
    delay = goal-cputime%refe%elapsed
    !
    if (delay.le.0.d0)  return
    !
    if (delay.gt.10.d0) then
      write(mess,'(A,F0.2,A)')  &
        'Still have to wait for ',delay,' seconds'
      call sic_message(seve%i,rname,mess)
    endif
    !
    do itime=1,floor(delay)  ! Can be 0
      call sic_wait(1.0)
      if (sic_ctrlc())  return
    enddo
    !
    ! Remaining fraction of second
    delay = delay-real(floor(delay),kind=8)  ! Compute in double precision
    call sic_wait(real(delay,kind=4))
    !
  endif
  !
end subroutine sic_delay
!
subroutine sic_modified(line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use gsys_types
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_modified
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   SIC MODIFIED FileName StructName
  ! Check if File has been modified or not
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MODIFIED'
  type(mfile_t) :: modif
  character(len=filename_length) :: file, fich
  integer(kind=4) :: n
  character(len=varname_length) :: strname,varname
  type(sic_descriptor_t) :: desc
  logical :: found
  integer(kind=address_length) :: ipnt
  integer(kind=4) :: memory(2)
  !
  call sic_ke(line,0,3,strname,n,.true.,error)
  if (error)  return
  !
  ! STRUCTURE
  call my_get_descr(strname,0,found,desc,error)
  if (error)  return
  if (.not.found) then
    ! Structure does not exist. Create a user-defined structure
    call sic_crestructure(strname,.true.,error)
    if (error)  return
  endif
  !
  ! STRUCTURE%FILE
  varname = trim(strname)//'%FILE'
  call my_get_descr(varname,1,found,desc,error)
  if (error)  return
  if (found) then
    call destoc(desc%type,desc%addr,modif%file)
  else
    call sic_defvariable(filename_length,varname,.true.,error)
    if (error)  return
    modif%file = ''
  endif
  !
  ! STRUCTURE%MTIME
  varname = trim(strname)//'%MTIME'
  call my_get_descr(varname,fmt_i8,found,desc,error)
  if (error)  return
  if (found) then
    ipnt = gag_pointer(desc%addr,memory)
    call i8toi8(memory(ipnt),modif%mtime,1)
  else
    call sic_defvariable(fmt_i8,varname,.true.,error)
    if (error)  return
    modif%mtime = 0
  endif
  !
  ! STRUCTURE%PTIME
  varname = trim(strname)//'%PTIME'
  call my_get_descr(varname,fmt_i8,found,desc,error)
  if (error)  return
  if (found) then
    ipnt = gag_pointer(desc%addr,memory)
    call i8toi8(memory(ipnt),modif%ptime,1)
  else
    call sic_defvariable(fmt_i8,varname,.true.,error)
    if (error)  return
    modif%ptime = 0
  endif
  !
  ! STRUCTURE%MODIF
  varname = trim(strname)//'%MODIF'
  call my_get_descr(varname,fmt_l,found,desc,error)
  if (error)  return
  if (.not.found) then
    call sic_defvariable(fmt_l,varname,.true.,error)
    if (error)  return
    ! Do not copy struct%modif (forced below)
  endif
  !
  call sic_ch(line,0,2,fich,n,.true.,error)
  if (error)  return
  file = fich
  call sic_parsef(fich,file,' ',' ')
  !
  ! Evaluation
  modif%modif = .true.  ! Default in case of ambiguity
  call gag_filmodif(file,modif,error)
  if (error)  return
  !
  ! Copy the values back into the Sic structure
  varname = trim(strname)//'%FILE'
  found = .false.  ! Not verbose
  call sic_descriptor(varname,desc,found)
  call ctodes(file,filename_length,desc%addr)
  !
  varname = trim(strname)//'%MTIME'
  found = .false.  ! Not verbose
  call sic_descriptor(varname,desc,found)
  ipnt = gag_pointer(desc%addr,memory)
  call i8toi8(modif%mtime,memory(ipnt),1)
  !
  varname = trim(strname)//'%PTIME'
  found = .false.  ! Not verbose
  call sic_descriptor(varname,desc,found)
  ipnt = gag_pointer(desc%addr,memory)
  call i8toi8(modif%ptime,memory(ipnt),1)
  !
  varname = trim(strname)//'%MODIF'
  found = .false.  ! Not verbose
  call sic_descriptor(varname,desc,found)
  ipnt = gag_pointer(desc%addr,memory)
  call l4tol4(modif%modif,memory(ipnt),1)
  !
contains
  subroutine my_get_descr(varname,vtype,found,desc,error)
    !-------------------------------------------------------------------
    ! Get descriptor + make some checks if variable exists
    !-------------------------------------------------------------------
    character(len=*),       intent(in)    :: varname
    integer(kind=4),        intent(in)    :: vtype
    logical,                intent(out)   :: found
    type(sic_descriptor_t), intent(out)   :: desc
    logical,                intent(inout) :: error
    ! Local
    logical :: myfound
    character(len=12) :: strtype
    !
    myfound = .false.  ! Not verbose
    call sic_descriptor(varname,desc,myfound)
    found = myfound
    if (found) then
      ! VARIABLE must be a scalar, user-defined, of given type
      if (desc%ndim.ne.0) then
        call sic_message(seve%e,rname,trim(varname)//' must be a scalar variable')
        error = .true.
      elseif (desc%status.ne.user_defined) then
        call sic_message(seve%e,rname,'Output variable must be user-defined')
        error = .true.
      elseif (vtype.gt.0) then
        if (desc%type.le.0) then
          call sic_message(seve%e,rname,trim(varname)//' must be a character variable')
          error = .true.
        endif
      elseif (desc%type.ne.vtype) then
        if (vtype.eq.0) then
          strtype = 'structure'
        elseif (vtype.eq.fmt_i8) then
          strtype = 'long integer'
        elseif (vtype.eq.fmt_l) then
          strtype = 'logical'
        endif
        call sic_message(seve%e,rname,trim(varname)//' must be a '//strtype)
        error = .true.
      endif
    endif
  end subroutine my_get_descr
  !
end subroutine sic_modified
!
subroutine sic_output(line,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_output
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    SIC OUTPUT [FileName [NEW|APPEND]]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=filename_length) :: fich,file
  integer(kind=4) :: nc,ier,imode
  character(len=7) :: argum,mode
  integer(kind=4), parameter :: nmodes=2
  character(len=6), parameter :: modes(nmodes) = (/ 'NEW   ','APPEND' /)
  !
  if (.not.sic_present(0,2)) then
    call sic_output_close(error)
    return
  endif
  !
  call sic_ch(line,0,2,fich,nc,.true.,error)
  if (error) return
  !
  if (fich(1:nc).eq.'?') then
    if (siclun.eq.0) then
      call sic_message(seve%i,rname,'SIC OUTPUT is on Terminal')
    else
      inquire (unit=siclun,name=file,iostat=ier)
      call sic_message(seve%i,rname,'SIC OUTPUT to file '//file)
    endif
    return
  endif
  !
  argum = 'NEW'  ! Default
  call sic_ke(line,0,3,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,argum,mode,imode,modes,nmodes,error)
  if (error)  return
  !
  ! Close previous file, if any
  call sic_output_close(error)
  if (error)  return
  ! Open new one
  ier = sic_getlun(siclun)
  if (mod(ier,2).eq.0) then
    error=.true.
    return
  endif
  call sic_parse_file(fich,' ','.dat',file)
  !
  if (mode.eq.'APPEND' .and. gag_inquire(file,len_trim(file)).ne.0) then
    ! APPEND mode but file does nos exist: create a new empty one as NEW
    mode = 'NEW'
  endif
  !
  ier = sic_open(siclun,file,mode,.false.)
  if (ier.ne.0) then
    call putios('E-SIC, ',ier)
    call sic_output_close(error)
    error = .true.
  endif
  !
end subroutine sic_output
!
subroutine sic_output_close(error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_output_close
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    SIC OUTPUT (no arg)
  !  Close the SIC OUTPUT file, if any
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SAY'
  character(len=filename_length) :: fich
  integer(kind=4) :: ier
  !
  if (siclun.ne.0) then
    inquire (unit=siclun,name=fich,iostat=ier)
    call sic_message(seve%d,rname,'Closing output file '//fich)
    !
    ! Close the unit
    ier = sic_close(siclun)
    if (ier.ne.0) then
      call putios('E-SAY, ',ier)
      error = .true.
      ! continue
    endif
    !
    ! Free the unit
    call sic_frelun(siclun)
    siclun = 0
  endif
  !
end subroutine sic_output_close
!
subroutine sic_openmp(line,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>sic_openmp
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  !
  if (sic_present(0,2)) then
    call sic_set_openmp(line,error)
    if (error)  return
  endif
  call sic_get_openmp
  !
end subroutine sic_openmp
!
subroutine sic_get_openmp
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_get_openmp
  use sic_interactions
  !$  use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=message_length) :: mess
  character(len=24) :: chain
  integer(kind=4) :: version
  integer(kind=4) :: mthread,  nt, ns, ier
  !
  if (sic_omp_compiled) then
    ! Current value for OpenMP nthreads. This can be set/changed with:
    ! - environment variable $OMP_NUM_THREADS at startup,
    ! - default value set by SIC init at startup,
    ! - SIC PARALLEL at run time,
    ! - Fortran program call to omp_set_num_threads() at run time.
    ! All in all, get updated value and show it (NB: SIC should provide a
    ! programmer API which sets nthreads (omp_set_num_threads()) AND updates
    ! sic_omp_nthreads; this would avoid this update and ensure
    ! SIC%OPENMP%NTHREADS is always up-to-date):
    !$ sic_omp_nthreads = omp_get_max_threads()  ! "This value is an upper bound on the
                                                 ! number of threads that could be used
                                                 ! to form a new team if a parallel region
                                                 ! without a num_threads clause."
    call sic_getenv('OMP_STACKSIZE',chain)
    if (chain.eq.'')  chain = 'unset'
    !$ version = openmp_version
    write(mess,'(A,I0,A,I0,3A)')  'Parallelization with Open-MP version ',  &
      version,' is enabled (',sic_omp_nthreads,' threads, stack size ',trim(chain),')'
    call sic_message(seve%i,rname,mess)
    !
    !$ mthread = sic_omp_mthreads  ! The maximum allowed at program start, NOT omp_get_num_procs()
    nt = 0
    ier = sic_getlog('$OMP_NUM_THREADS',nt)
    ns = 0
    ier = sic_getlog('$SLURM_CPUS_PER_TASK',ns)
    write(mess,'(A,I0,A,I0,A,I0,A,I0)') "Allowed Thread Number: Cores ",sic_omp_ncores, &
      & ", System ",sic_omp_mthreads,", OpenMP ",nt,", Slurm ",ns
    call sic_message(seve%i,rname,mess)
  else
    call sic_message(seve%i,rname,'Open-MP parallelization is NOT enabled')
  endif
  !
end subroutine sic_get_openmp
!
subroutine sic_set_openmp(line,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this => sic_set_openmp
  use sic_interactions
  !$  use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SIC PARALLEL'
  integer(kind=4) :: nc,ier
  character(len=64) :: chain
  !
  if (.not.sic_omp_compiled) then
    call sic_message(seve%e,rname,'GILDAS not compiled in Open-MP mode')
    error = .true.
    return
  endif
  !
  ! This section is only used when compiled with Open-MP
  call sic_ch(line,0,2,chain,nc,.true.,error)
  if (error)  return
  if (chain.eq.'*') then
    sic_omp_nthreads = sic_omp_ncores ! Default is to avoid hyper-threading
  else
    call sic_i4(line,0,2,sic_omp_nthreads,.true.,error)
    if (error)  return
  endif
  !$ call omp_set_num_threads(sic_omp_nthreads)
  !
  if (sic_present(0,3)) then
    call sic_ch(line,0,3,chain,nc,.true.,error)
    ier = sic_setenv('OMP_STACKSIZE',chain(1:nc))
    if (ier.ne.0) then
      call sic_message(seve%e,rname,'Error setting environment variable OMP_STACKSIZE')
      error = .true.
      return
    endif
  endif
  !
end subroutine sic_set_openmp
!
subroutine sic_setverify(line,lire,error)
  use gbl_message
  use sic_structures
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_setverify
  !---------------------------------------------------------------------
  ! @ private
  ! List and/or Toggle the VERIFY switches
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !
  integer,          intent(in)    :: lire    !
  logical,          intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=1), parameter :: backslash=char(92)
  character(len=8) :: argum,found1,found2
  integer(kind=4) :: n,sev
  integer(kind=4), parameter :: monoff=3
  character(len=5), parameter :: onof1(monoff)= [ 'ON   ','OFF  ','MACRO']
  character(len=5), parameter :: onof2(monoff)= [ 'ON   ','OFF  ','STEP ']
  character(len=60), save :: mess='VERIF MACRO is OFF                               '
  !
  sev = seve%i
  !
  if (sic_present(0,2)) then
    call sic_ke (line,0,2,argum,n,.false.,error)
    if (error) return
    call sic_ambigs(rname,argum,found1,n,onof1,monoff,error)
    if (error)  return
    sev = seve%d
    select case (found1)
    case ('ON')
      lverif = .true.
      line = 'SIC'//backslash//'SIC VERIFY ON'
    case ('OFF')
      line = 'SIC'//backslash//'SIC VERIFY OFF'
      lverif = .false.
    case ('MACRO')
      argum = 'ON'
      call sic_ke (line,0,3,argum,n,.false.,error)
      if (error) return
      call sic_ambigs(rname,argum,found2,n,onof2,monoff,error)
      if (error)  return
      select case (found2)
      case ('OFF')
        line = 'SIC'//backslash//'SIC VERIFY MACRO OFF'
        mess = 'VERIFY MACRO is OFF'
        sic_stepin = 0
      case ('ON')
        line = 'SIC'//backslash//'SIC VERIFY MACRO ON'
        sic_stepin = -1
        mess = 'VERIFY MACRO is  ON (at enter/exit)'
      case ('STEP')
        line = 'SIC'//backslash//'SIC VERIFY MACRO ON'
        sic_stepin = +1
        mess = 'VERIFY MACRO is STEP (at each command)'
      end select
    end select
  endif
  if (lire.eq.0) then
    if (lverif) then
      call sic_message(sev,rname,'VERIFY is ON')
    else
      call sic_message(sev,rname,'VERIFY is OFF')
    endif
    call sic_message(sev,rname,mess)
  endif
end subroutine sic_setverify
!
subroutine sic_user(user)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_user
  !---------------------------------------------------------------------
  ! @ public
  ! Return "user[@host]" in output string
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: user  ! Output string
  ! Local
  character(len=20) :: node
  !
  call sic_username(user)
  call sic_hostname(node)
  if (node.ne.' ')  user = trim(user)//'@'//node
end subroutine sic_user

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_checksum
  use cube_types
  use cubetools_structure
  use cubetools_checksum
  use cubeadm_cubeid_types
  use cubeadm_messaging
  !
  public :: checksum
  private
  !
  type :: checksum_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
   contains
     procedure, public  :: register => cubeadm_checksum_register
     procedure, private :: parse    => cubeadm_checksum_parse
     procedure, private :: main     => cubeadm_checksum_main
  end type checksum_comm_t
  type(checksum_comm_t) :: checksum
  !
  type checksum_user_t
     type(cubeid_user_t) :: cubeids
   contains
     procedure, private :: toprog => cubeadm_checksum_user_toprog
  end type checksum_user_t
  !
  type checksum_prog_t
     type(cube_t), pointer :: cube
   contains
     procedure, private :: data => cubeadm_checksum_prog_data
     procedure, private :: loop => cubeadm_checksum_prog_loop
     procedure, private :: act  => cubeadm_checksum_prog_act
  end type checksum_prog_t
  !
contains
  !
  subroutine cubeadm_checksum_command(line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(checksum_user_t) :: user
    character(len=*), parameter :: rname='CHECKSUM>COMMAND'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call checksum%parse(line,user,error)
    if (error) return
    call checksum%main(user,error)
    if (error) continue
  end subroutine cubeadm_checksum_command
  !
  subroutine cubeadm_checksum_register(comm,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(checksum_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: cube
    character(len=*), parameter :: rname='CHECKSUM>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'CHECKSUM','[CubeId]',&
         'Compute SHA1 checksum of cube data array',&
         'Compute a SHA1 checksum of cube data values only. Use it to verify&
         & data integrity or compare cubes independently of header metadata.',&
         cubeadm_checksum_command,&
         comm%comm,&
         error)
    if (error) return
    call cube%register(&
         'CUBE',&
         'Any cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         comm%cube,&
         error)
    if (error) return
  end subroutine cubeadm_checksum_register
  !
  subroutine cubeadm_checksum_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(checksum_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(checksum_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='CHECKSUM>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubeadm_checksum_parse
  !
  subroutine cubeadm_checksum_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(checksum_comm_t), intent(in)    :: comm
    type(checksum_user_t),  intent(inout) :: user
    logical,                intent(inout) :: error
    !
    type(checksum_prog_t) :: prog
    character(len=*), parameter :: rname='CHECKSUM>MAIN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubeadm_checksum_main
  !
  subroutine cubeadm_checksum_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(checksum_user_t), intent(in)    :: user
    type(checksum_comm_t),  intent(in)    :: comm
    type(checksum_prog_t),  intent(out)   :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='CHECKSUM>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
  end subroutine cubeadm_checksum_user_toprog
  !
  subroutine cubeadm_checksum_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(checksum_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ier
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='CHECKSUM>PROG>DATA'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ier = cubetools_sha1sum_init()
    if (ier.ne.0) then
      error = .true.
      return
    endif
    !
    ! Note: parallelization can not be enabled here
    call cubeadm_datainit_all(iter,error)
    if (error) return
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       if (.not.error) &
         call prog%loop(iter,error)
    enddo
    if (error)  return
    !
    call cubeadm_message(seve%i,rname,'Data SHA1 sum is '//cubetools_sha1sum_get())
  end subroutine cubeadm_checksum_prog_data
  !
  subroutine cubeadm_checksum_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(checksum_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CHECKSUM>PROG>LOOP'
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter,error)
      if (error) return
    enddo
  end subroutine cubeadm_checksum_prog_loop
  !
  subroutine cubeadm_checksum_prog_act(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(checksum_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: iter
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>ACT'
    !
    if (prog%cube%iscplx()) then
      call cubeadm_checksum_prog_act_c4(prog,iter,error)
      if (error)  return
    else
      call cubeadm_checksum_prog_act_r4(prog,iter,error)
      if (error)  return
    endif
  end subroutine cubeadm_checksum_prog_act
  !
  subroutine cubeadm_checksum_prog_act_r4(prog,iter,error)
    use iso_c_binding, only: c_loc
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(checksum_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: iter
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: ier
    type(subcube_t) :: insub
    integer(kind=8) :: nbytes
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>ACT>R4'
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube to another.
    call insub%associate('insub',prog%cube,iter,error)
    if (error) return
    call insub%get(error)
    if (error) return
    nbytes = insub%nx*insub%ny*insub%nz*4
    ier = cubetools_sha1sum_update(c_loc(insub%val),nbytes)
    if (ier.ne.0) then
      call cubeadm_message(seve%e,rname,'Could not process subcube')
      error = .true.
      return
    endif
  end subroutine cubeadm_checksum_prog_act_r4
  !
  subroutine cubeadm_checksum_prog_act_c4(prog,iter,error)
    use iso_c_binding, only: c_loc
    use cubeadm_taskloop
    use cubeadm_subcube_cplx_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(checksum_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: iter
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: ier
    type(subcube_cplx_t) :: insub
    integer(kind=8) :: nbytes
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>ACT>C4'
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube to another.
    call insub%associate('insub',prog%cube,iter,error)
    if (error) return
    call insub%get(error)
    if (error) return
    nbytes = insub%nx*insub%ny*insub%nz*8
    ier = cubetools_sha1sum_update(c_loc(insub%val),nbytes)
    if (ier.ne.0) then
      call cubeadm_message(seve%e,rname,'Could not process subcube')
      error = .true.
      return
    endif
  end subroutine cubeadm_checksum_prog_act_c4
  !
end module cubeadm_checksum
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_holoTables (ldata, data, error)
  !---------------------------------------------------------------------
  !     holodata: write SD holography data
  !
  !     nsubant, subant: number of antennas and antennas to use (for
  !     holography so far)
  !---------------------------------------------------------------------
  USE GILDAS_DEF
  !
  !     Global variables:
  INCLUDE 'clic_parameter.inc'
  INCLUDE 'clic_clic.inc'
  INCLUDE 'clic_display.inc'
  INCLUDE 'clic_par.inc'
  INCLUDE 'clic_dheader.inc'
  INCLUDE 'clic_constant.inc'
  INCLUDE 'clic_proc_par.inc'
  INCLUDE 'gbl_pi.inc'
  INCLUDE 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  !
  !     dummy variables :
  integer :: ldata, data(ldata)
  logical :: holodata, error
  !
  !     local variables :
  integer scanNumber, pointingSize, totalPowerSize
  integer k, kc, kpc, klu, klc,  kl, ir, h_offset, c_offset,   &
    l_offset
  character :: ch*12, uid*40, obsMode*256
  character :: dattim*20

  !---------------------------------------------------------------------
  holodata = .true.
  r_scan = 1
  r_typec = type_ho
  call message(1,1,'Write_sdm_holoTables','Starting ...')
  ir = r_ndump+1
  k = 1+ h_offset(ir)
  call decode_header (data(k))

  !
  !     Define time_Interval:
  !     - the interval center in MJD nano seconds...
  !     - the interval length in MJD nanoseconds...
  !     !      dh_utc = nint(2*dh_utc)*0.5d0
  !      dh_utc = nint(dh_utc/.001d0)*0.001d0
  !     print *, (dh_obs+60549.0d0)*86400.d0, dh_utc, dh_integ
  !      time_interval(1) = ((dh_obs+60549.0d0)*86400.d0+dh_utc-0.5d0
  !     &     *dh_integ)*1d9
  !      time_interval(2) = dh_integ*1d9
  !      print *, ' holotables time_interval ',time_interval, dh_utc
  !     print *, time_interval
  !
  !     --------------------------------------------------------------------------
  !     tables that change during one Bure observation : loop on data
  !     header parameters.


  !     c    Tables for the average record (= ASDM INtegration), uncorrected
  klu = 1 + l_offset(r_ndump+1)
  !
  !     for corrected spectral data:
  klc = 1 + l_offset(r_ndump+2)
  !
  !     for uncorrected channel average data:
  kc = 1 + c_offset(r_ndump+1)
  !
  !
  !     TotalPower Table -
  !
  !     No TotalPower for the integration record as we have a
  !     single ConfigDescriptionId for Total power.
  !     except for holography data...
  !
  !
  !     Loop on records (NOW = ASDM integrations)
  do ir=1, r_ndump
    write (ch,'(i4.0,1h/,i4.0)') ir, r_ndump
    call message(1,1,'Write_sdm_holoTables','Record '//ch)
    k = 1+ h_offset(ir)
    call decode_header (data(k))
    if (error) return
    call get_time_interval
    if ((ir.lt.10).or.((r_ndump -ir) .lt.10)) then
      !print *, dh_obs, dh_integ, dh_utc
      !print *, ir, time_interval
    endif
    !
    !     Define timeInterval:
    !     - the interval start in MJD nanoseconds...
    !     - the interval length in MJD nanoseconds...
    !
    !     force the times to be multiples of 1ms as dh_utc has not enough
    !     precision
    !
!!!     dh_utc = nint(dh_utc/.001d0)*0.001d0
!!!     !     print *, (dh_obs+60549.0d0)*86400., dh_utc, dh_integ
!!!     time_interval(1) = ((dh_obs+60549.0d0)*86400.d0+dh_utc-dh_integ   &
!!!       /2)*1d9
!!!     time_interval(1) = time_interval(1) + 33.*1d9
!!!     time_interval(2) = dh_integ*1d9
!!!     if (time_start(1).lt.0) then
!!!       time_start(1) = time_interval(1)
!!!       time_start(2) = -1
!!!     endif
    !     Tables for the individual records (= ASDM SubIntegration),
    !     uncorrected channel average data:
    kc = 1 + c_offset(ir)
    !     tables with timeInterval as a key cannot be used for the 'average
    !     record' of CLIC. So they must be written here.
    if (ir.eq.1) then
      !     deal with scan/subscan  numbers.
      if (r_scan.ne.scan_Number) then
        if (scan_Number.ge.0) then
          call write_sdm_scan(error)
          if (error) return
        endif
        subScan_Number = 1
        num_subscan = 1
        scan_startTime = time_Interval(1)
        scan_endTime = time_Interval(1)+time_Interval(2)
      else
        num_subscan = num_subscan + 1
        subScan_Number = subScan_Number + 1
        scan_endTime = time_Interval(1)+time_Interval(2)
      endif
      !print *, 'scan_startTime, scan_endTime'
      !print *, scan_startTime, scan_endTime
      scan_Number = r_scan
      call set_intent(scan_Intent, subScan_Intent, obsMode, data_type, holodata)
      !     subscan_startTime = time_Interval(1)
      !     subscan_endTime = time_Interval(1)+time_Interval(2)
      !
      !     tables that hold parameters unchanged during one Bure observation
      !     each call returns the pointers in the last item in the call list
      !
      !     --- Hardware setup information:
      !
      !     Station table ++ + 90
      call write_sdm_Station (error)
      if (error) return
      !
      !     Antenna Table ++ +  90
      call write_sdm_Antenna (error)
      if (error) return
      !
      !     FocusModel Table ++ Not implemented
      !$$$  call write_sdm_FocusModel(error)
      !$$$  if (error) return
      !
      !     PointingModel Table ++ (TBD)  +
      !$$$  call write_sdm_PointingModel(error)
      !$$$  if (error) return
      !
      !     SpectralWindow Tables (line and continuum) ++ + 90
      call write_sdm_SpectralWindow(holodata, error)
      if (error) return
      !
      !     Polarization Table ++ + 90
      !
      !     For holography, we write this in polarization table for the time
      !     being.
      !$$$
      !$$$            call write_sdm_Polarization(error)
      !$$$            if (error) return
      call write_sdm_holography(error)
      if (error) return
      !
      !     DataDescription Table ++  + 90
      call write_sdm_DataDescription (holodata, error)
      if (error) return
      !
      !     CorrelatorMode table ++ + 90
      if (.not. holodata) then
        call write_sdm_CorrelatorMode(error)
        if (error) return
      else
        call write_sdm_SquareLawDetector(error)
        if (error) return
      endif
      !
      !     Processor Table ++  + 90
      call write_sdm_Processor(holodata, error)
      if (error) return
      !
      !     Receiver Table ++  + 90
      call write_sdm_Receiver(holodata, error)
      if (error) return
      !
      !     Beam Table ++
      !     call write_sdm_Beam (error)
      !     if (error) return
      beam_Id = 0              ! instead...
      !
      !     Feed Table ++  + 90
      call write_sdm_Feed(holodata, error)
      if (error) return
      !
      !     FreqOffset Table ++  + 90
      call write_sdm_FreqOffset(holodata, error)
      if (error) return
      !
      !     SwitchCycle Table ++  + 90
      call write_sdm_SwitchCycle(error)
      if (error) return
      !
      !     ConfigDescription Table ++  + 90
      !     2nd arg is for Tp in the main table...
      call write_sdm_ConfigDescription(holodata, .false., error)
      if (error) return
      !
      !     --- Source information:
      !
      !     Source Table ++  + 90
      call write_sdm_Source(holodata, error)
      if (error) return
      !
      !     Source Parameter Table (??) ++  +
      !cc   call write_sdm_SourceParameter(error)
      if (error) return
      !
      !     Doppler Table ++  + 90
      if (.not. holodata) then
        call write_sdm_Doppler (error)
        if (error) return
      endif
      !
      !     Ephemeris Table ++  +
      !     c      call write_sdm_Ephemeris(error)
      !     c      if (error) return
      !
      !     Field Table ++   + 90
      call write_sdm_Field(error)
      if (error) return
      !
      !     ExecBlock Table ++  + 90
      call write_sdm_ExecBlock(error)
      if (error) return
      !     Seeing Table (deprecated)
      !
      !     SquareLawDetector Table (??)
      !
      !     Weather Table ++  + 90
      call write_sdm_Weather(error)
      if (error) return
      !
      !     State Table ++ + 90
      call write_sdm_State(error)
      if (error) return
      !     SBSummary Table (not needed?)
      !     Scan and subscan Tables ++  + 90
      call write_sdm_subScan(holodata, error)
      if (error) return
      !
      !     History Table (irrelevant?) ++  + 90
      call write_sdm_History(error)
      if (error) return
    endif
    !
    !     Pointing Table ++ + 90
    !!call write_sdm_Pointing(error)
    !!if (error) return
    !
    !     Focus Table ++ + 90
    call write_sdm_Focus(error)
    if (error) return
    !  print *, dh_obs, dh_integ, dh_utc

    !     State Table ++ (because subintegration) + 90
    call write_sdm_State(error)
    if (error) return
    !
    !     TotalPower Table  ++ +
    !$$$         if (ir.le.5) then
    !$$$            print *, 'ir, TotalPower, time_interval ',ir,
    !$$$     &           time_interval, dh_utc
    !$$$         endif
    !$$$         print *, 'WRITE_SDM_TOTPM ',holo_type
    call write_sdm_TotalPower(holodata, r_ldatc, data(kc)   &
      , error)
    if (error) return
  !     endif
  enddo
  
  call write_sdm_Pointing(ldata, data, error)
  if (error) return
  !$$$      call sic_date(dattim)
  !$$$      call getPointingTableSize(pointingSize, error)
  !$$$      call getTotalPowerTableSize(totalPowerSize, error)
  !$$$      print 1000, dattim, ' pointingSize ', pointingSize,
  !$$$     &     ' totalPowerSize ', totalPowerSize
  !$$$ 1000 format (a20, a, i10, a , i10)
  call message(1,1,'Write_sdm_tables','Ended.')
  return
  !
  !     error return
99 error = .true.
end subroutine write_sdm_holoTables

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_complex_command(line,error)
  use gbl_message
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_complex_command
  use wifisyn_sic_buffer
  use wifisyn_cube_buffer
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    COMPLEX VISICUBE|WIFICUBE TO|FROM AMPLITUDE|PHASE|REAL|IMAGINARY
  !      1 /LOGSCALE
  !      2 /NORMALIZE
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  logical :: logscale
  integer :: narg,ioper,icube,idire
  character(len=*), parameter :: rname='COMPLEX/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Sanity check
  narg = sic_narg(0)
  if (narg.ne.3) then
     call wifisyn_message(seve%e,rname,'Three arguments needed')
     error = .true.
     return
  endif
  ! Parse
  call wifisyn_parse_cube_kind(line,icube,error)
  if (error) return
  call wifisyn_parse_dire_kind(line,idire,error)
  if (error) return
  call wifisyn_parse_oper_kind(line,ioper,error)
  if (error) return
  if (ioper.eq.code_ampl) then
     ! Currently logscale enabled only for AMPLITUDE...
     logscale = sic_present(1,0)
  endif
  ! Dispatch work
  if (idire.eq.code_complex2real) then
     if (icube.eq.code_cube_visi) then
        call wifisyn_visi_complex2real(logscale,ioper,progmap%win%cur(1),progmap,visi,error)
        if (error) return
     else if (icube.eq.code_cube_wifi) then
        call wifisyn_wifi_complex2real(logscale,ioper,1,progmap,wifi,error)
        if (error) return
     else
        call wifisyn_message(seve%e,rname,'Unknown cube kind')
        error = .true.
        return
     endif
  else if (idire.eq.code_real2complex) then
     if (icube.eq.code_cube_visi) then
        call wifisyn_visi_real2complex(ioper,progmap%win%cur(1),visi,error)
        if (error) return
     else if (icube.eq.code_cube_wifi) then
        call wifisyn_wifi_real2complex(ioper,1,wifi,error)
        if (error) return
     else
        call wifisyn_message(seve%e,rname,'Unknown cube kind')
        error = .true.
        return
     endif
  else
     call wifisyn_message(seve%e,rname,'Unknown cube kind')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_complex_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_wifi_complex2real(logscale,ioper,ichan,map,wifi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_wifi_complex2real
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical,      intent(in)    :: logscale
  integer,      intent(in)    :: ioper
  integer,      intent(in)    :: ichan
  type(map_t),  intent(in)    :: map
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  real(kind=4) :: wreal,wimag
  integer :: ix,iy,iu,iv
  character(len=*), parameter :: rname='WIFI/COMPLEX2REAL'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_wifi_header(map,wifi,error)
  if (error) return
  call wifisyn_cube_reallocate_r4d('wifi%amp',wifi%amp,error)
  if (error) return
  do iv=1,wifi%cub%nv
     do iu=1,wifi%cub%nu
        do iy=1,wifi%cub%ny
           do ix=1,wifi%cub%nx
              if (ioper.eq.code_ampl) then
                 wifi%amp%r4d(ix,iy,iu,iv) = abs(wifi%cub%val(ichan,ix,iy,iu,iv))
              else if (ioper.eq.code_phas) then
                 wreal = real(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wimag = aimag(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wifi%amp%r4d(ix,iy,iu,iv) = atan2(wimag,wreal)*deg_per_rad
              else if (ioper.eq.code_real) then
                 wifi%amp%r4d(ix,iy,iu,iv) = real(wifi%cub%val(ichan,ix,iy,iu,iv))
              else if (ioper.eq.code_imag) then
                 wifi%amp%r4d(ix,iy,iu,iv) = aimag(wifi%cub%val(ichan,ix,iy,iu,iv))
              else
                 call wifisyn_message(seve%e,rname,'Unknown operation')
                 error = .true.
                 return
              endif
           enddo ! ix
        enddo ! iy
     enddo ! iu
  enddo ! iv
  call wifisyn_cube_minmax_r4d(logscale,wifi%amp,error)
  if (error) return
  call wifisyn_cube_sicdef(code_readwrite,'xyuv',wifi%amp,error)
  if (error) return
  !
end subroutine wifisyn_wifi_complex2real
!
subroutine wifisyn_visi_complex2real(logscale,ioper,win,map,visi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_visi_complex2real
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical,        intent(in)    :: logscale
  integer,        intent(in)    :: ioper
  type(window_t), intent(in)    :: win
  type(map_t),    intent(in)    :: map
  type(visi_t),   intent(inout) :: visi
  logical,        intent(inout) :: error
  !
  integer :: ic,iu,iv
  real(kind=4) :: wreal,wimag
  character(len=*), parameter :: rname='VISI/COMPLEX2REAL'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_visi_header(map,visi,error)
  if (error) return
  call wifisyn_cube_reallocate_r3d(win%nchan,'visi%amp',visi%amp,error)
  if (error) return
  do ic=1,visi%cub%nc
     do iv=1,visi%cub%ny
        do iu=1,visi%cub%nx
           if (ioper.eq.code_ampl) then
              visi%amp%r3d(iu,iv,ic) = abs(visi%cub%val(iu,iv,ic))
           else if (ioper.eq.code_phas) then
              wreal = real(visi%cub%val(iu,iv,ic))
              wimag = aimag(visi%cub%val(iu,iv,ic))
              visi%amp%r3d(iu,iv,ic) = atan2(wimag,wreal)*deg_per_rad
           else if (ioper.eq.code_real) then
              visi%amp%r3d(iu,iv,ic) = real(visi%cub%val(iu,iv,ic))
           else if (ioper.eq.code_imag) then
              visi%amp%r3d(iu,iv,ic) = aimag(visi%cub%val(iu,iv,ic))
           else
              call wifisyn_message(seve%e,rname,'Unknown operation')
              error = .true.
              return
           endif
        enddo ! iu
     enddo ! iv
  enddo ! ic
  call wifisyn_cube_minmax_r3d(logscale,win,visi%amp,error)
  if (error) return
  call wifisyn_cube_sicdef(code_readwrite,'uv',visi%amp,error)
  if (error) return
  !
end subroutine wifisyn_visi_complex2real
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_wifi_header(map,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi_header
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(map_t),  intent(in)    :: map
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='WIFI/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_common_header(map,wifi%amp,error)
  if (error) return
  wifi%amp%gil%xaxi = 0
  wifi%amp%gil%yaxi = 0
  if (wifi%xykind) then
     ! 1st axis
     wifi%amp%char%code(1) = 'RA'
     wifi%amp%gil%dim(1) = map%axes(1)%x%sky%n
     wifi%amp%gil%ref(1) = map%axes(1)%x%sky%ref
     wifi%amp%gil%val(1) = map%axes(1)%x%sky%val
     wifi%amp%gil%inc(1) = map%axes(1)%x%sky%inc
     ! 2nd axis
     wifi%amp%char%code(2) = 'DEC'
     wifi%amp%gil%dim(2) = map%axes(2)%x%sky%n
     wifi%amp%gil%ref(2) = map%axes(2)%x%sky%ref
     wifi%amp%gil%val(2) = map%axes(2)%x%sky%val
     wifi%amp%gil%inc(2) = map%axes(2)%x%sky%inc
  else
     ! 1st axis
     wifi%amp%char%code(1) = 'Us'
     wifi%amp%gil%dim(1) = map%axes(1)%x%uvp%n
     wifi%amp%gil%ref(1) = map%axes(1)%x%uvp%ref
     wifi%amp%gil%val(1) = map%axes(1)%x%uvp%val
     wifi%amp%gil%inc(1) = map%axes(1)%x%uvp%inc
     ! 2nd axis
     wifi%amp%char%code(2) = 'Vs'
     wifi%amp%gil%dim(2) = map%axes(2)%x%uvp%n
     wifi%amp%gil%ref(2) = map%axes(2)%x%uvp%ref
     wifi%amp%gil%val(2) = map%axes(2)%x%uvp%val
     wifi%amp%gil%inc(2) = map%axes(2)%x%uvp%inc
  endif
  if (wifi%uvkind) then
     ! 3rd axis
     wifi%amp%char%code(3) = 'Up'
     wifi%amp%gil%dim(3) = map%axes(1)%u%uvp%n
     wifi%amp%gil%ref(3) = map%axes(1)%u%uvp%ref
     wifi%amp%gil%val(3) = map%axes(1)%u%uvp%val
     wifi%amp%gil%inc(3) = map%axes(1)%u%uvp%inc
     ! 4th axis
     wifi%amp%char%code(4) = 'Vp'
     wifi%amp%gil%dim(4) = map%axes(2)%u%uvp%n
     wifi%amp%gil%ref(4) = map%axes(2)%u%uvp%ref
     wifi%amp%gil%val(4) = map%axes(2)%u%uvp%val
     wifi%amp%gil%inc(4) = map%axes(2)%u%uvp%inc
  else
     ! 3rd axis
     wifi%amp%char%code(3) = 'RA'
     wifi%amp%gil%dim(3) = map%axes(1)%u%sky%n
     wifi%amp%gil%ref(3) = map%axes(1)%u%sky%ref
     wifi%amp%gil%val(3) = map%axes(1)%u%sky%val
     wifi%amp%gil%inc(3) = map%axes(1)%u%sky%inc
     ! 4th axis
     wifi%amp%char%code(4) = 'DEC'
     wifi%amp%gil%dim(4) = map%axes(2)%u%sky%n
     wifi%amp%gil%ref(4) = map%axes(2)%u%sky%ref
     wifi%amp%gil%val(4) = map%axes(2)%u%sky%val
     wifi%amp%gil%inc(4) = map%axes(2)%u%sky%inc
  endif
  !
end subroutine wifisyn_wifi_header
!
subroutine wifisyn_visi_header(map,visi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_visi_header
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(map_t),  intent(in)    :: map
  type(visi_t), intent(inout) :: visi
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='VISI/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_common_header(map,visi%amp,error)
  if (error) return
  visi%amp%gil%ndim = 3
  if (visi%uvkind) then
     ! 1st axis
     visi%amp%char%code(1) = 'U'
     visi%amp%gil%dim(1) = map%axes(1)%a%uvp%n
     visi%amp%gil%ref(1) = map%axes(1)%a%uvp%ref
     visi%amp%gil%val(1) = map%axes(1)%a%uvp%val
     visi%amp%gil%inc(1) = map%axes(1)%a%uvp%inc
     visi%amp%gil%xaxi = 0
     ! 2nd axis
     visi%amp%char%code(2) = 'V'
     visi%amp%gil%dim(2) = map%axes(2)%a%uvp%n
     visi%amp%gil%ref(2) = map%axes(2)%a%uvp%ref
     visi%amp%gil%val(2) = map%axes(2)%a%uvp%val
     visi%amp%gil%inc(2) = map%axes(2)%a%uvp%inc
     visi%amp%gil%yaxi = 0
  else
     ! 1st axis
     visi%amp%char%code(1) = 'RA'
     visi%amp%gil%dim(1) = map%axes(1)%a%sky%n
     visi%amp%gil%ref(1) = map%axes(1)%a%sky%ref
     visi%amp%gil%val(1) = map%axes(1)%a%sky%val
     visi%amp%gil%inc(1) = map%axes(1)%a%sky%inc
     visi%amp%gil%xaxi = 1
     ! 2nd axis
     visi%amp%char%code(2) = 'DEC'
     visi%amp%gil%dim(2) = map%axes(2)%a%sky%n
     visi%amp%gil%ref(2) = map%axes(2)%a%sky%ref
     visi%amp%gil%val(2) = map%axes(2)%a%sky%val
     visi%amp%gil%inc(2) = map%axes(2)%a%sky%inc
     visi%amp%gil%yaxi = 2
  endif
  ! 3rd axis
  ! *** JP The following information should be stored in a freq/velo axis component of map
  visi%amp%char%code(3) = 'VELOCITY'
  visi%amp%gil%dim(3) = map%win%cur(map%win%n)%last-map%win%cur(1)%first+1
  visi%amp%gil%ref(3) = map%huv%gil%ref(2) - map%win%cur(1)%first +1
  visi%amp%gil%val(3) = map%huv%gil%voff
  visi%amp%gil%inc(3) = -(clight/1000d0)*map%huv%gil%fres/map%huv%gil%freq ! *** JP doppler not taken into account
!  visi%amp%gil%inc(3) = map%huv%gil%vres
  visi%amp%gil%faxi = 3
  !
end subroutine wifisyn_visi_header
!
subroutine wifisyn_common_header(map,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_common_header
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(map_t),  intent(in)    :: map
  type(gildas), intent(inout) :: cube
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='COMMON/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call gdf_copy_header(map%huv,cube,error)
  if (error)  return
  !
  ! Cube unit
  cube%char%unit = 'Jy/beam'
  ! Projection information (assume equatorial system)
  cube%gil%proj_words = 9
! *** JP Should use the map%shift information.
!  cube%gil%ra  = map%huv%gil%ra
!  cube%gil%dec = map%huv%gil%dec
!  cube%gil%lii = map%huv%gil%lii
!  cube%gil%bii = map%huv%gil%bii
  cube%gil%ptyp = p_azimuthal ! Azimuthal (Sin)
  cube%gil%pang = map%shift%pang
  cube%gil%a0 = map%shift%a0
  cube%gil%d0 = map%shift%d0
  cube%char%syst = 'EQUATORIAL'
  ! Noise section
  cube%gil%nois_words = 0
  ! Initialized extrema section
  cube%gil%extr_words = 10
  cube%gil%rmin = +1e38
  cube%gil%rmax = -1e38
  ! No beam yet
  cube%gil%reso_words = 0
  ! Others
  cube%char%type = 'GILDAS_IMAGE'
  cube%loca%size = cube%gil%dim(1)*cube%gil%dim(2)*cube%gil%dim(3)*cube%gil%dim(4)
  !
end subroutine wifisyn_common_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_wifi_real2complex(ioper,ichan,wifi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_wifi_real2complex
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer,      intent(in)    :: ioper
  integer,      intent(in)    :: ichan
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  real(kind=4) :: wreal,wimag,wampl,wphas
  integer :: ix,iy,iu,iv
  character(len=*), parameter :: rname='WIFI/REAL2COMPLEX'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  do iv=1,wifi%cub%nv
     do iu=1,wifi%cub%nu
        do iy=1,wifi%cub%ny
           do ix=1,wifi%cub%nx
              if (ioper.eq.code_ampl) then
                 wampl = wifi%amp%r4d(ix,iy,iu,iv)
                 wreal = real(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wimag = aimag(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wphas = atan2(wimag,wreal)
                 wreal = wampl*cos(wphas)
                 wimag = wampl*sin(wphas)
              else if (ioper.eq.code_phas) then
                 wampl = abs(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wphas = wifi%amp%r4d(ix,iy,iu,iv)*rad_per_deg
                 wreal = wampl*cos(wphas)
                 wimag = wampl*sin(wphas)
              else if (ioper.eq.code_real) then
                 wreal = wifi%amp%r4d(ix,iy,iu,iv)
                 wimag = aimag(wifi%cub%val(ichan,ix,iy,iu,iv))
              else if (ioper.eq.code_imag) then
                 wreal = real(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wimag = wifi%amp%r4d(ix,iy,iu,iv)
              else
                 call wifisyn_message(seve%e,rname,'Unknown operation')
                 error = .true.
                 return
              endif
              wifi%cub%val(ichan,ix,iy,iu,iv) = cmplx(wreal,wimag)
           enddo ! ix
        enddo ! iy
     enddo ! iu
  enddo ! iv
  !
end subroutine wifisyn_wifi_real2complex
!
subroutine wifisyn_visi_real2complex(ioper,win,visi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_visi_real2complex
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer,        intent(in)    :: ioper
  type(window_t), intent(in)    :: win
  type(visi_t),   intent(inout) :: visi
  logical,        intent(inout) :: error
  !
  integer :: ic,iu,iv
  real(kind=4) :: wreal,wimag,wampl,wphas
  character(len=*), parameter :: rname='VISI/REAL2COMPLEX'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  do ic=1,visi%cub%nc
     do iv=1,visi%cub%ny
        do iu=1,visi%cub%nx
           if (ioper.eq.code_ampl) then
              wampl = visi%amp%r3d(iu,iv,ic)
              wreal = real(visi%cub%val(iu,iv,ic))
              wimag = aimag(visi%cub%val(iu,iv,ic))
              wphas = atan2(wimag,wreal)
              wreal = wampl*cos(wphas)
              wimag = wampl*sin(wphas)
           else if (ioper.eq.code_phas) then
              wampl = abs(visi%cub%val(iu,iv,ic))
              wphas = visi%amp%r3d(iu,iv,ic)*rad_per_deg
              wreal = wampl*cos(wphas)
              wimag = wampl*sin(wphas)
           else if (ioper.eq.code_real) then
              wreal = visi%amp%r3d(iu,iv,ic)
              wimag = aimag(visi%cub%val(iu,iv,ic))
           else if (ioper.eq.code_imag) then
              wreal = real(visi%cub%val(iu,iv,ic))
              wimag = visi%amp%r3d(iu,iv,ic)
           else
              call wifisyn_message(seve%e,rname,'Unknown operation')
              error = .true.
              return
           endif
           visi%cub%val(iu,iv,ic) = cmplx(wreal,wimag)
        enddo ! iu
     enddo ! iv
  enddo ! ic
  !
end subroutine wifisyn_visi_real2complex
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_multi
  use gbl_message
  !
  public :: multi_comm
  private
  !
contains
  !
  subroutine multi_comm(line,error)
    use gkernel_interfaces
    use mapping_interfaces
    use clean_tool, only: sub_clean,clean_data
    use clean_types, only: beam_unit_conversion
    use clean_buffers, only: clean_user,clean_prog
    !----------------------------------------------------------------------
    ! Implementation of Multi Scale Clean
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    if (clean_user%mosaic) then
       call map_message(seve%e,'MULTI','Not yet implemented for mosaic')
       error = .true.
       return
    endif
    !
    ! Data checkup
    clean_user%method = 'MULTI'
    call clean_data (error)
    if (error) return
    !
    ! Parameter Definitions
    call beam_unit_conversion(clean_user)
    call clean_user%copyto(clean_prog)
    clean_prog%pflux = sic_present(1,0)
    clean_prog%pcycle = .false.
    clean_prog%qcycle = .false.
    !
    clean_prog%gains = clean_prog%gain
    call sic_get_real('GAINS[1]',clean_prog%gains(1),error)
    call sic_get_real('GAINS[2]',clean_prog%gains(2),error)
    call sic_get_real('GAINS[3]',clean_prog%gains(3),error)
    !
    call sub_clean(line,error)
  end subroutine multi_comm
end module clean_multi
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clic_modify(line,error)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Command MODIFY args
  ! options :
  ! 1 	/BEFORE
  ! 2 	/AFTER
  ! 3	[ANTENNA|BASELINE] /OFFSET
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  ! Local
  logical :: end, do_data, do_write
  integer :: mvocab, nkey, nch
  parameter (mvocab=22)
  character(len=12) :: vocab(mvocab), argum, keywor
  ! Data
  data vocab/   &
    'BASELINE',    'HEADER',  'RECORD',   'FREQUENCIES',       &  !4
    'FLUX',        'SCALE',   'DOPPLER',  'REFERENCE',         &  !8
    'SIGN_PHASE',  'ANTENNA', 'VELOCITY', 'POSITION',          &  !12
    'TIME',        'DATA',    'DELAY',    'CABLE',             &  !16
    'BUG',         'AXES_OFFSET',         'TELESCOPE', 'FOCUS',&  !20
    'SPIDX',       'PHASE' /                                      !22
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  call check_output_file(error)
  if (error) return
  !
  ! Get argument
  call sic_ke(line,0,1,argum,nch,.true.,error)
  if (error) return
  call sic_ambigs('MODIFY',argum,keywor,nkey,vocab,mvocab,error)
  ! Variable
  if (error) return
  !
  ! Get first observation
  call get_first(.true.,error)
  if (error) return
  !
  !      GOTO (1,2,3,4,5,6,7,8,6,1,9,10,11,3,12,13,18,19) NKEY
  ! Baseline & Antenna
  if (keywor.eq.'BASELINE' .or. keywor.eq.'ANTENNA') then
    call ini_base(line,0,error)
    if (error) return
  ! Header
  elseif (keywor.eq.'HEADER') then
    call ini_header(line,0,error)
    if (error) return
  ! Record & Data
  elseif (keywor.eq.'RECORD' .or. keywor.eq.'DATA') then
    call ini_data(line,0,error)
    if (error) return
  !
  ! Frequencies
  elseif (keywor.eq.'FREQUENCIES') then
    call ini_freq(line,0,error)
    if (error) return
  ! Flux
  elseif (keywor.eq.'FLUX') then
    call ini_flux(line,0,error)
    if (error) return
  ! Scale & Phase_Sign
  elseif (keywor.eq.'SCALE' .or. keywor.eq.'SIGN_PHASE') then
    call ini_scale(line,0,error)
    if (error) return
  ! Doppler
  elseif (keywor.eq.'DOPPLER') then
    call ini_doppler(line,0,error)
    if (error) return
  ! Reference channel
  elseif (keywor.eq.'REFERENCE') then
    call ini_reference(line,0,error)
    if (error) return
  ! Velocity
  elseif (keywor.eq.'VELOCITY') then
    call ini_velocity(line,0,error)
    if (error) return
  ! Position
  elseif (keywor.eq.'POSITION') then
    call ini_position(line,0,error)
    if (error) return
  ! Time
  elseif (keywor.eq.'TIME') then
    call ini_time(line,0,error)
    if (error) return
  ! Delay
  elseif (keywor.eq.'DELAY') then
    call ini_delay(line,0,error)
    if (error) return
  ! Cable
  elseif (keywor.eq.'CABLE') then
    call ini_cable(line,0,error)
    if (error) return
  ! Focus
  elseif (keywor.eq.'FOCUS') then
    call ini_focus(line,0,error)
    if (error) return
  ! Bug
  elseif (keywor.eq.'BUG') then
    call ini_bug(line,0,error)
    if (error) return
  ! Axes
  elseif (keywor.eq.'AXES_OFFSET') then
    call ini_axes(line,0,error)
    if (error) return
  ! Telescope
  elseif (keywor.eq.'TELESCOPE') then
    call ini_telescope(line,0,error)
    if (error) return
  ! Spectral index
  elseif (keywor.eq.'SPIDX') then
    call ini_spidx(line,0,error)
    if (error) return
  ! Phase
  elseif (keywor.eq.'PHASE') then
    call ini_phase(line,0,error)
    if (error) return
  ! Other
  else
    call message(6,3,'CLIC_MODIFY',keywor//' not implemented')
    error = .true.
    return
  endif
  !
  ! For delays and phases stop there if /NOWRITE
  if ((keywor.eq.'DELAY'.and.sic_present(13,0)).or. &
      (keywor.eq.'PHASE'.and.sic_present(13,0))) then
    call message(6,1,'CLIC_MODIFY',' No data update')
    return
  endif
  !
  ! Loop on current index
  end = .false.
  do_write = .true.
  do_data = .false.
  do while (.not.end)
    if (keywor.eq.'BASELINE' .or. keywor.eq.'ANTENNA') then
      call mod_base(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'HEADER') then
      call mod_header(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'RECORD') then
      call mod_data_r(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'FREQUENCIES') then
      call mod_freq(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'FLUX') then
      call mod_flux(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'SCALE' .or. keywor.eq.'SIGN_PHASE') then
      call mod_scale(argum,do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'DOPPLER') then
      call mod_doppler(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'REFERENCE') then
      call mod_reference(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'VELOCITY') then
      call mod_velocity(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'POSITION') then
      call mod_position(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'TIME') then
      call mod_time(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'DATA') then
      call mod_data_a(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'DELAY') then
      call mod_delay(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'CABLE') then
      call mod_cable(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'FOCUS') then
      call mod_focus(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'BUG') then
      call mod_bug(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'AXES_OFFSET') then
      call mod_axes(do_write,do_data,error)
      if (error) return
    elseif (keywor.eq.'TELESCOPE') then
      call mod_telescope(error)
      if (error) return
    elseif (keywor.eq.'SPIDX') then
      call mod_spidx(error)
      if (error) return
    elseif (keywor.eq.'PHASE') then
      call mod_phase(do_write,do_data,error)
      if (error) return
    endif
    !
    ! Next observation
    if (do_write) call write_scan (do_data,error)
    if (error) return
    if (sic_ctrlc()) error = .true.
    call get_next(end,error)
    if (error) return
  enddo
  return
error = .true.
  return
!
end subroutine clic_modify
!
subroutine ini_header(line,iopt,error)
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY HEADER [procedure]
  !	Execute a SIC procedure (involving variables) for
  !	each header read in the index, and rewrite.
  !	default is "HEADER.CLIC"
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  ! Local
  common /modify/ loaded
  logical :: do_write, do_data, local_do_data
  integer :: nch
  integer(kind=data_length)    :: ndata
  integer(kind=address_length) :: data_in
  logical :: loaded, end
  character(len=160) :: command
  save command,local_do_data
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  call sic_ch(line,iopt,2,command,nch,.true.,error)
  if (error) return
  local_do_data = .true.
  if (sic_present(11,0))  local_do_data = .false.
  if (.not.loaded) then
    call load_modify
    loaded = .true.
  endif
  return
  !
entry mod_header(do_write,do_data,error)
  ! Get storage and data
  if (write_mode.eq.'NEW') call get_data (ndata,data_in,error)
  if (error) return
  end = .false.
  do_write = .false.
  do_data = local_do_data
  call exec_modify('@ '//command(1:lenc(command)),end,do_write)
  if (.not.end) then
    call message(8,4,'MOD_HEADER','Operation aborted')
    error = .true.
    return
  endif
  return
!
end subroutine ini_header
!
subroutine ini_data(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! 	MODIFY DATA [procedure] /ATM
  !	Execute a SIC command procedure (involving variables) for
  !	each data average record read in the index, and rewrite.
  !	default is "DATA.CLIC"
  ! 	MODIFY RECORD [procedure]
  !       same thing but every data record ...
  ! 24-oct-01, RM: add possibility to modify record by record :
  !       MODIFY RECORD [procedure]  /record idump
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'gbl_memory.inc'
  common /modify/ loaded
  ! Local
  logical :: do_write, do_data
  integer(kind=address_length) :: data_in, kin, ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: i, ir, k, isb, ib, nch
  logical :: loaded, end, atm_rec
  real*8 :: t, before, after, test
  character(len=160) :: command
  character(len=80) :: chain
  integer :: idump,irmin,irmax
  !
  save atm_rec
  save before,after
  save command
  ! RM
  save irmin,irmax
  ! Data
  data before/32767./, after/-32768./
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  if (.not.do_write_data) then
    call message (8,4,'INI_DATA',   &
      'MODIFY DATA needs the SET WRITE DATA mode')
    error = .true.
    return
  endif
  command = 'DATA'
  ! /BEFORE date time
  if (sic_present(1,1)) then
    call sic_ke(line,1,1,chain,nch,.true.,error)
    if (error) return
    call cdate(chain,i,error)
    t = 0.
    call sic_ke(line,1,2,chain,nch,.false.,error)
    if (error) return
    call sic_sexa(chain,lenc(chain),t,error)
    before = t/24d0 + i        ! in days
  else
    before = 32767.
  endif
  ! /AFTER date time
  if (sic_present(2,1)) then
    call sic_ke(line,2,1,chain,nch,.true.,error)
    if (error) return
    call cdate(chain,i,error)
    t = 0.
    call sic_ke(line,2,2,chain,nch,.false.,error)
    if (error) return
    call sic_sexa(chain,lenc(chain),t,error)
    after = t/24d0 + i         ! in days
  else
    after = -32768.
  endif
  call sic_ch(line,iopt,2,command,nch,.true.,error)
  if (error) return
  if (.not.loaded) then
    call load_modify
    loaded = .true.
  endif
  ! /RECORD idump
  idump = 0
  irmin = 1
  irmax = r_ndump
  if (sic_present(4,1)) then
    call sic_i4(line,4,1,idump,.true.,error)
    if (error) return
    irmin = idump
    irmax = idump
  endif
  ! /ATM
  if (sic_present(6,0)) then
    atm_rec = .true.
    call message(4,1,'INI_DATA',   &
      'Modifying atm. phase corrected record')
  else
    atm_rec = .false.
    call message(4,1,'INI_DATA',   &
      'Modifying no atm. average record')
  endif
  return
  !
entry mod_data_r(do_write,do_data,error)
  ! Prepare passband
  if (do_pass) call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
    r_lntch, passc, passl, error)
  if (error) return
  call get_data (ndata,data_in,error)
  if (irmin.ne.irmax) irmax = r_ndump
  if (error) return
  do_data = .true.
  ! Loop on records (not including average record)
  do ir = irmin, irmax
    !
    ! Next record
    ipk = gag_pointer(data_in,memory)+h_offset(ir)
    call decode_header(memory(ipk))
    test = dble(dh_obs)+dh_utc/86400.d0
    if (test.le.before .and. test.gt.after) then
      ipk = ipk + r_ldpar
      k = 1
      do ib = 1, r_nbas
        do isb=1, r_nsb
          call r4tor4 (memory(ipk),datac(k),2*r_nband)
          k = k + r_nband
          ipk = ipk+2*r_nband
        enddo
      enddo
      call data_variables(.true.)
      call data_variables(.false.)
      end = .false.
      do_write = .false.
      call exec_modify('@ '//command(1:lenc(command)),   &
        end,do_write)
      if (.not.end) then
        call message(8,4,'MOD_HEADER','Operation aborted')
        error = .true.
        return
      endif
      ipk = gag_pointer(data_in,memory)+h_offset(ir)
      call encode_header (memory(ipk))
      ipk = ipk + r_ldpar
      k = 1
      do ib = 1, r_nbas
        do isb=1, r_lnsb
          call r4tor4 (datac(k),memory(ipk),2*r_nband)
          k = k + r_nband
          ipk = ipk+2*r_nband
        enddo
      enddo
    endif
  enddo
  do_data = .true.
  return
  !
entry mod_data_a(do_write,do_data,error)
  ! Prepare passband
  if (do_pass) call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
    r_lntch, passc, passl, error)
  if (error) return
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in,memory)
  do_data = .true.
  ! Get only average record
  if (atm_rec) then
    if (r_ndatl.eq.2) then
      ir = r_ndump + 2
    else
      call message(6,3,'MOD_HEADER',   &
        'no pha. corrected average record')
      error = .true.
      return
    endif
  else
    ir = r_ndump + 1
  endif
  ipk = kin + h_offset(ir)
  call decode_header(memory(ipk))
  test = dble(dh_obs)+dh_utc/86400.d0
  if (test.le.before .and. test.gt.after) then
    ipk = ipk + r_ldpar
    k = 1
    do ib = 1, r_nbas
      do isb=1, r_nsb
        call r4tor4 (memory(ipk),datac(k),2*r_nband)
        k = k + r_nband
        ipk = ipk+2*r_nband
      enddo
    enddo
    ! line data on average record
    k = 1
    do ib = 1, r_nbas
      do isb=1, r_lnsb
        call r4tor4 (memory(ipk),datal(k),2*r_lntch)
        k = k + r_lntch
        ipk = ipk+2*r_lntch
      enddo
    enddo
    call data_variables(.true.)
    call data_variables(.false.)
    end = .false.
    do_write = .false.
    call exec_modify('@ '//command(1:lenc(command)),   &
      end,do_write)
    if (.not.end) then
      call message(8,4,'MOD_HEADER','Operation aborted')
      error = .true.
      return
    endif
    kin = data_in + h_offset(ir)*4
    ipk = gag_pointer(kin,memory)
    call encode_header (memory(ipk))
    ipk = ipk + r_ldpar
    k = 1
    do ib = 1, r_nbas
      do isb=1, r_nsb
        call r4tor4 (datac(k),memory(ipk),2*r_nband)
        k = k + r_nband
        ipk = ipk+2*r_nband
      enddo
    enddo
    k = 1
    do ib = 1, r_nbas
      do isb=1, r_lnsb
        call r4tor4 (datal(k),memory(ipk),2*r_lntch)
        k = k + r_lntch
        ipk = ipk+2*r_lntch
      enddo
    enddo
    do_data = .true.
  endif
  return
end subroutine ini_data
!
subroutine ini_reference(line,iopt,error)
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY REFERENCE UPPER|LOWER r1 r2 r3 r4
  ! 	       VELOCITY  UPPER|LOWER v1 v2 v3 v4
  !	       NOTHING
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  logical :: do_write, do_data
  integer :: i, nref(2), j, ij, nch, mvoc1
  parameter (mvoc1=2)
  real*4 :: new_ref(2,mrlband)
  character(len=12) :: arg, arg1
  character(len=80) :: chain
  !------------------------------------------------------------------------
  ! Code:
  call check_equal_file(error)
  if (error) return
  call sic_ke(line,iopt,1,arg1,nch,.false.,error)
  if (error) return
  i=1
  j = 0
  nref(1) = 0
  nref(2) = 0
  do while (sic_present(iopt,i+1))
    call sic_ke(line,iopt,i+1,arg,nch,.false.,error)
    if (error) return
    if (arg(1:1).eq.'U') then
      if (j.gt.0) nref(j) = ij
      j = 1
      ij = 0
    elseif (arg(1:1).eq.'L') then
      if (j.gt.0) nref(j) = ij
      j = 2
      ij = 0
    elseif (j.gt.0) then
      call sic_r4(line,iopt,i+1,new_ref(j,ij+1),.true.,error)
      if (error) return
      ij = ij + 1
    endif
    i = i + 1
  enddo
  if (j.gt.0) then
    nref(j) = ij
  else
    error = .true.
    return
  endif
  if (arg1.eq.'R') then
    call message (6,1,'INI_REFERENCE',   &
      'Modifying reference channels to :')
  endif
  if (nref(1).gt.0) then
    write(chain,*) 'UPPER ',(new_ref(1,i),i=1,nref(1))
    call message(6,1,'INI_REFERENCE',chain(1:lenc(chain)))
  endif
  if (nref(2).gt.0) then
    write(chain,*) 'LOWER ',(new_ref(2,i),i=1,nref(2))
    call message(6,1,'INI_REFERENCE',chain(1:lenc(chain)))
  endif
  return
  !
entry mod_reference(do_write,do_data,error)
  do i=1, 2
    if (nref(i).gt.0) then
      do j=1, min(nref(i),r_lband)
        r_lrch(i,j) = new_ref(i,j)
      enddo
    endif
  enddo
  return
end subroutine ini_reference
!
subroutine ini_velocity(line,iopt,error)
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY VELOCITY value
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  logical :: do_write, do_data
  real*4 :: new_vel
  character(len=80) :: chain
  save new_vel
  ! Data
  data new_vel/0.0/
  !------------------------------------------------------------------------
  ! Code:
  call check_equal_file(error)
  if (error) return
  call sic_r4(line,iopt,2,new_vel,.true.,error)
  if (error) return
  write(chain,*) new_vel,' km/s LSR'
  call message (6,1,'INI_VELOCITY',   &
    'Modifying velocity to '//chain(1:lenc(chain)))
  return
  !
entry mod_velocity(do_write,do_data,error)
  ! Doesm't depend on side band ...
  r_restf = r_restf+(new_vel-r_veloc)*r_restf/299792.458
  r_veloc = new_vel
  call vel_scale
  return
end subroutine ini_velocity
!
subroutine ini_flux(line,iopt,error)
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY FLUX new_value
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  logical :: do_write, do_data
  real*4 :: new_flux
  !------------------------------------------------------------------------
  save new_flux
  ! Data
  data new_flux/0.0/
  ! Code:
  call check_equal_file(error)
  if (error) return
  call sic_r4(line,iopt,2,new_flux,.true.,error)
  if (error) return
  if (new_flux.le.0) then
    call message (8,4,'INI_FLUX','Invalid argument')
    error = .true.
    return
  endif
  return
  !
entry mod_flux(do_write,do_data,error)
  r_flux = new_flux
  return
end subroutine ini_flux
!
subroutine ini_freq(line,iopt,error)
  use classic_api
  !---------------------------------------------------------------------
  ! MODIFY FREQUENCIES
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! Local
  logical :: do_write, do_data
  integer :: isb, isub
  !------------------------------------------------------------------------
  ! Code:
  call check_equal_file(error)
  if (error) return
  return
  !
entry mod_freq(do_write,do_data,error)
  do isb=1, 2
    if (c_line(isb).ne.'*') then
      r_crfoff(isb) = c_freq(isb)
      r_cnam(isb) = c_line(isb)
    elseif (r_restf.gt.0) then
      r_crfoff(isb) = r_restf
      r_cnam(isb) = r_line
    else
      r_crfoff(isb) = 100000.
      r_cnam(isb) = 'DUMMY'
    endif
    do isub=1, r_lband
      if (l_line(isub,isb).ne.'*') then
        r_lrfoff(isb,isub) = l_freq(isub,isb)
        r_lnam(isb,isub) = l_line(isub,isb)
      elseif (r_restf.gt.0) then
        r_lrfoff(isb,isub) = r_restf
        r_lnam(isb,isub) = r_line
      else
        r_lrfoff(isb,isub) = 100000.
        r_lnam(isb,isub) = 'DUMMY'
      endif
    enddo
  enddo
  call vel_scale
  return
end subroutine ini_freq
!
subroutine ini_scale(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY SCALE amplitude phase
  ! Multiply all data by the given scale factor (complex)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: data_in, kin, ipk
  integer(kind=data_length)    :: ndata, l_offset, c_offset
  character(len=*) :: arg
  logical :: do_write, do_data
  integer :: nch, ir, ibas, isb, is
  character(len=80) :: chain
  character(len=4) :: arg1
  real*4 :: amp_factor, phase_factor
  complex :: factor
  save amp_factor, phase_factor, factor
  !------------------------------------------------------------------------
  ! Code:
  call sic_ke(line,iopt,1,arg1,nch,.false.,error)
  if (error) return
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  error = .false.
  if (arg1.eq.'SCAL') then
    phase_factor = 0.
    call sic_r4(line,iopt,2,amp_factor,.true.,error)
    if (error) return
    call sic_r4(line,iopt,3,phase_factor,.false.,error)
    if (error) return
    if (degrees) then
      phase_factor = phase_factor * pi / 180.
    endif
    factor = amp_factor * exp(cmplx(0.,phase_factor))
    call message(6,1,'INI_SCALE','Multiplying data by : ')
    write(chain,'(2(a,1pg12.5),a,2(1pg12.5))')   &
      ' Amplitude : ',amp_factor,'   Phase : ',phase_factor,   &
      '   Complex : ',factor
    call message(6,1,'INI_SCALE',chain(1:lenc(chain)))
  else
    if (.not.do_write_data) then
      call message (8,4,'INI_DATA',   &
        'MODIFY PHASE_SIGN needs the SET WRITE DATA mode')
      error = .true.
      return
    endif
    write (chain,*) 'Changing the sign of all phases'
    call message(6,1,'INI_SCALE',chain(1:lenc(chain)))
  endif
  return
  !
entry mod_scale(arg,do_write,do_data,error)
  !
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  !
  ! Loop on records
  kin = gag_pointer(data_in,memory)
  do ir = 1, r_ndump + max(1,r_ndatl)
    ipk = kin + c_offset(ir)
    call sub_scale(arg,r_ldatc/2,factor,memory(ipk))
  enddo
  ! line data
  do ir = 1, max(1,r_ndatl)
    ipk = kin + l_offset(r_ndump+ir)
    call sub_scale(arg,r_ldatl/2,factor,memory(ipk))
  enddo
  !
  !     Save factors
  !
  !     This is most probably ly unused, and is wrong for the phases
  !     (adding a phase factor to all phases will destroy the closure
  !     relations).
  !
  do ibas = 1, r_nbas
    do isb = 1, 2
      do is =1, r_nband
        r_dmcamp(isb,ibas,is) = r_dmcamp(isb,ibas,is   &
          ) * amp_factor
        r_dmcpha(isb,ibas,is) = r_dmcpha(isb,ibas,is   &
          ) + phase_factor
      enddo
      do is = 1, r_lband
        r_dmlamp(isb,ibas,is) = r_dmlamp(isb,ibas,is   &
          ) * amp_factor
        r_dmlpha(isb,ibas,is) = r_dmlpha(isb,ibas,is   &
          ) + phase_factor
      enddo
    enddo
  enddo
  do_data = .true.
  return
end subroutine ini_scale
!
subroutine sub_scale(arg,n,f,c)
  !---------------------------------------------------------------------
  ! Multiply complex array C of length N by factor F, or take its complex
  !  conjugate, according to ARG.
  !---------------------------------------------------------------------
  character(len=*) :: arg           !
  integer :: n                      !
  complex :: f                      !
  complex :: c(n)                   !
  ! Local
  integer :: i
  !------------------------------------------------------------------------
  ! Code:
  if (arg(1:2).eq.'SC') then
    do i=1, n
      c(i) = c(i) * f
    enddo
  elseif (arg(1:2).eq.'PH') then
    do i=1, n
      c(i) = conjg(c(i))
    enddo
  endif
  return
end subroutine sub_scale
!
subroutine ini_doppler(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY DOPPLER
  ! Recompute Doppler correction
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_display.inc'
  ! Local
  logical :: do_write, do_data
  logical :: old
  integer :: nh, isub, isb, sky(2), nch, nt
  real*8 :: dop, lsr, test, corr, svec(3), f100mhz
  real*8 :: c, s_2(2), s_3(3), x_0(3), ut, parang
  parameter (c=299792.458d0)
  character(len=80) :: chain
  character(len=3) :: argum
  character(len=2) :: cs(7),cv(4)
  !
  save old
  !
  data cs /'UN','EQ','GA','HO','BD','EC','DA'/
  data cv /'LS','HE','EA','NU'/
  data sky/+1,-1/              ! Usb, Lsb
  data old/.false./
  !------------------------------------------------------------------------
  !
  ! Code:
  if (write_mode.eq.'UPDA') then
    call check_equal_file(error)
    if (error) return
  else
    call message(8,4,'MOD_DOPPLER','Write Mode must be UPDATE')
    error = .true.
    return
  endif
  argum = '*'
  call sic_ke(line,iopt,2,argum,nch,.false.,error)
  if (error) return
  old = argum(1:3).eq.'OLD'    ! actually VERY old ....
  return
  !
entry mod_doppler(do_write,do_data,error)
  ! Set time
  ut = mod(r_dobs+32768,65536)-32768+2460549.5d0+r_ut/2d0/pi
  !
  ! new subroutine calls from astro
  call do_astro_time(ut, 0.0d0, 56.184d0, error)
  if (error) return
  call do_object(cs(r_typec), r_epoch, r_lam, r_bet,   &
    s_2, s_3, dop, lsr, svec, x_0, parang, error)
  if (r_typev .eq. 1) then
    corr = dop + lsr
  elseif (r_typev .eq. 2) then
    corr = dop
  else
    corr = 0
  endif
  r_doppl = (corr + r_veloc) / c
  write(chain,'(2A3,4(A,1PG12.5))')   &
    cs(r_typec), cv(r_typev),' DOP ',   &
    dop,' LSR ', lsr,' COR ',corr,' FACT ', r_doppl
  call message(4,1,'MOD_DOPPLER',chain(1:lenc(chain)))
  nt = 1
  if (r_flo1.gt.200000.) nt = 3
  nh = nint((r_flo1/nt+100.175*r_lock)/r_flo1_ref)
  ! compute f100mhz since it was not so constant after all... (2001-10-15)
  f100mhz = (nh*r_flo1_ref-r_flo1/nt)/r_lock
  if (f100mhz .gt. 100.175) then
    f100mhz = 100.25d0
  else
    f100mhz = 100.09765625d0
  endif
  ! now check that it works exactly ...
  nh = nint((r_flo1/nt+r_lock*f100mhz)/r_flo1_ref)
  test = (r_flo1_ref*nh-r_lock*f100mhz)*nt
  if ((abs(test-r_flo1)/test).gt.1d-10) then
    write(chain,*) 'Wrong FLO1 ',r_flo1, test
    call message(6,2,'MOD_DOPPLER',chain(1:lenc(chain)))
  endif
  do isb = 1, 2
    !
    ! Continuum
    if (c_line(isb).ne.'*') then
      r_crfoff(isb) = c_freq(isb)
      r_cnam(isb) = c_line(isb)
    elseif (r_restf.gt.0) then
      r_crfoff(isb) = r_restf
      r_cnam(isb) = r_line
    else
      r_crfoff(isb) = 100000.
      r_cnam(isb) = 'DUMMY'
    endif
    r_crfres(isb) = -sky(isb)*50.  ! channel width
    r_cvoff(isb) = r_veloc     ! source velocity
    r_cvres(isb) = -r_crfres(isb)/r_crfoff(isb)*c
    r_crch(isb) = 5.5   &
      + (r_crfoff(isb)*(1.-r_doppl)   &
      - r_flo1-sky(isb)*(r_flo1_ref-350.))   &
      !     +	    + (r_crfoff(isb)*(1.-r_doppl)-test-sky(isb)*(r_flo2-350.))
      /r_crfres(isb)
    !
    ! Line
    do isub=1, r_lband
      if (l_line(isub,isb).ne.'*') then
        r_lrfoff(isb,isub) = l_freq(isub,isb)
        r_lnam(isb,isub) = l_line(isub,isb)
      elseif (r_restf.gt.0) then
        r_lrfoff(isb,isub) = r_restf
        r_lnam(isb,isub) = r_line
      else
        r_lrfoff(isb,isub) = 100000.
        r_lnam(isb,isub) = 'DUMMY'
      endif
      r_lrfres(isb,isub) = sky(isb)*r_lfres(isub)   &
          * r_band2(isub) * r_band2bis(isub)
      r_lvoff(isb,isub) = r_veloc  ! source velocity
      r_lvres(isb,isub) = -r_lrfres(isb,isub)   &
        /r_lrfoff(isb,isub)*c
      if (new_receivers) then
        print *,"E-MODIFY DOPPLER not yet implemented for NGRx"
        return
      else
        if(.not.old .or. r_lrfres(isb,isub).gt.0) then
          r_lrch(isb,isub) = r_lcench(isub) +   &  ! CEN in channel 1
            (r_lrfoff(isb,isub)*(1.-r_doppl)-r_flo1   &
            !     $         (R_LRFOFF(ISB,ISUB)*(1.-R_DOPPL)-TEST
            - sky(isb)*(r_flo1_ref-r_lfcen(isub)))   &
            / r_lrfres(isb,isub)
        else
          r_lrch(isb,isub) = 0.0 +   &
            (r_lrfoff(isb,isub)*(1.-r_doppl)-r_flo1   &
            !     $         (R_LRFOFF(ISB,ISUB)*(1.-R_DOPPL)-TEST
            - sky(isb)*(r_flo1_ref-r_lfcen(isub)))   &
            / r_lrfres(isb,isub)
        endif
      endif
    enddo
  enddo
  return
!
end subroutine ini_doppler
!
subroutine exec_modify (buffer,end,write)
  use gkernel_interfaces
  character(len=*) :: buffer        !
  logical :: end                    !
  logical :: write                  !
  ! Local
  character(len=1) :: argum
  character(len=255) :: line
  character(len=12) :: comm,lang
  logical :: error
  integer :: icode, ocode, nch
  !------------------------------------------------------------------------
  ! Code:
  !
  call gprompt_set('MODIFY')
  line = buffer
  icode = -1
  goto 10
  !
entry play_modify(buffer)
  line = buffer
  icode = 2
  goto 10
  !
entry enter_modify
  icode = 1
  goto 10
  !
10 call sic_run(line,lang,comm,error,icode,ocode)
  if (ocode.ne.0) then
    call gprompt_set('CLIC')
    return
  endif
  icode = 0
if (lang.eq. 'MODIFY') then
    if (comm.eq.'GO') then
      end = .true.
      write = .false.
      call sic_ke(line,0,1,argum,nch,.false.,error)
      if (error) goto 10
      write = argum(1:1).eq.'W'
    else
      call message(8,4,'EXEC_MODIFY','No code for '//comm)
      error = .true.
    endif
  elseif (lang.eq. 'CLIC') then
    if (comm.eq.'DUMP') then
      argum = ' '
      call sic_ke(line,0,1,argum,nch,.false.,error)
      if (error) goto 10
      if (argum(1:1) .eq. 'F') then
        call filedump(error)
      elseif (argum(1:1) .eq. 'I') then
        call idump(error)
      elseif (argum(1:1) .eq. 'D') then
        call dhdump(error)
      elseif (argum(1:1) .eq. 'C') then
        call dcdump(line,error)
      elseif (argum(1:1) .eq. 'L') then
        call dldump(line,error)
      elseif (argum(1:1) .eq. 'V') then
        call vdump(error)
      else
        call rdump(line,error)
      endif
    elseif (comm.eq.'MINMAX') then
      call clic_minmax(error)
    elseif (comm.eq.'FLAG') then
      call clic_flag(line,error)
    elseif (comm.eq.'HEADER') then
      call clic_header(line,error)
    elseif (comm.eq.'SHOW') then
      call clic_show(line,error)
    else
      call message(8,4,'EXEC_MODIFY','No code for '//comm)
      error = .true.
    endif
  elseif (lang.eq.'SIC') then
    call run_sic(line,comm,error)
  else
    call message(8,4,'EXEC_MODIFY',   &
      'Language invalid in this context '//lang)
    error = .true.
  endif
  goto 10
end subroutine exec_modify
!
subroutine load_modify
  use gkernel_interfaces
  integer :: mmodify
  parameter (mmodify=1)
  character(len=*) :: vers
  parameter (vers='1.1-01 05-JAN-1990   R.Lucas')
  character(len=12) :: vocab(mmodify)
  data vocab /' GO'/
  !------------------------------------------------------------------------
  ! Code:
  call sic_load ('MODIFY','GAG_HELP_CLIC',mmodify,vocab,vers)
end subroutine load_modify
!
subroutine clic_minmax(error)
  use classic_api
  use clic_rdata
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  !------------------------------------------------------------------------
  ! Code:
  call sub_minmax (r_nsb, r_nband, r_nbas, r_lntch,   &
    datac, datal, passc, passl,error)
  if (error) return
  error = .false.
  return
end subroutine clic_minmax
!
subroutine sub_minmax (qsb, qband, qbas, qntch,   &
    data_c, data_l, pass_c, pass_l, error)
  use classic_api
  use clic_rdata
  integer :: qsb                       !
  integer :: qband                     !
  integer :: qbas                      !
  integer :: qntch                     !
  complex :: data_c(qsb, qband, qbas)  !
  complex :: data_l(qntch, qsb, qbas)  !
  complex :: pass_c(qsb, qband, qbas)  !
  complex :: pass_l(qntch, qsb, qbas)  !
  logical :: error                     !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: ib, is, isb, i, k
  real :: afac
  complex :: zz(2)
  !------------------------------------------------------------------------
  ! Code:
  call set_scaling(error)
  do ib=1, mnbas
    campmaxu(ib) = 0
    campminu(ib) = 1e37
    campmaxl(ib) = 0
    campminl(ib) = 1e37
    lampmaxu(ib) = 0
    lampminu(ib) = 1e37
    lampmaxl(ib) = 0
    lampminl(ib) = 1e37
    do is = 1, r_nband
      do isb = 1,2
        zz(isb) = data_c(isb,is,ib)
        if (do_pass) then
          zz(isb) = zz(isb)*pass_c(isb,is,ib)
        endif
        call scaling (is,isb,ib,zz(isb),afac,error)
        if (.not.error) then
          if (isb.eq.1) then
            campmaxu(ib) = max(campmaxu(ib),abs(zz(1)))
            campminu(ib) = min(campminu(ib),abs(zz(1)))
          else
            campmaxl(ib) = max(campmaxl(ib),abs(zz(2)))
            campminl(ib) = min(campminl(ib),abs(zz(2)))
          endif
        endif
      enddo
    enddo
    k = 0
    do is =1, r_lband
      do i = 1, r_lnch(is)
        k = k + 1
        do isb = 1,2
          zz(isb) = data_l(k,isb,ib)
          if (do_pass) then
             zz(isb) = zz(isb)*pass_l(k,isb,ib)
          endif
          call scaling (is,isb,ib,zz(isb),afac,error)
          if (.not.error) then
            if (isb.eq.1) then
              lampmaxu(ib) = max(lampmaxu(ib),abs(zz(1)))
              lampminu(ib) = min(lampminu(ib),abs(zz(1)))
            else
              lampmaxl(ib) = max(lampmaxl(ib),abs(zz(2)))
              lampminl(ib) = min(lampminl(ib),abs(zz(2)))
            endif
          endif
        enddo
      enddo
    enddo
  enddo
  return
end subroutine sub_minmax
!
subroutine ini_cable (line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY Cable a1 a2 a3 a4 :
  !        correct for a permutation of the cables to the phasemeters
  ! 	MODIFY Cable CONTINUUOUS :
  !        correct the cable phases to be continuous
  !        (should use only the correlations, without LOCK flag,
  !          for which the phases have a meaning)
  ! 	MODIFY Cable FACTOR f:
  !        Assume the phase correction applied  has to be multiplied by f
  !        (replaces the old MODIFY CABL2)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_constant.inc'
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  character(len=80) :: chain, nombre
  real*8 :: fi2, f, x
  integer :: ir,ibas,i,isub,iside
  integer(kind=address_length) :: data_in,kin,ipk, ipk1
  integer(kind=data_length)    :: ndata,h_offset, c_offset, l_offset

  integer :: ia, ja
  integer :: iconn(mnant), nch, isign
  real :: used(mnant), old(mnant), f_factor
  logical :: continuous, factor
  save iconn, continuous, old, factor, f_factor, nharm
  real*8 :: f100mhz
  real*4 :: blhvhl, if2_hiq, lo2_ant, f100mhz_mult
  integer :: nharm, mult, ref_mult
  parameter(blhvhl=9.92)
  ! Data
  data old/mnant*0.0/
  !------------------------------------------------------------------------
  ! Code:
  call check_equal_file(error)
  if (error) return
  if (.not.do_write_data) then
    call message (8,4,'INI_DATA',   &
      'MODIFY CABLE needs the SET WRITE DATA mode')
    error = .true.
    return
  endif
  !
  call sic_ke(line,iopt,2,chain,nch,.true.,error)
  if (chain(1:2).eq.'CO') then
    continuous = .true.
    call message (6,1,'INI_CABLE',   &
      'Assuming cable phase was continuous')
  elseif (chain(1:2).eq.'FA') then
    factor = .true.
    call sic_r4(line,iopt,3,f_factor,.true.,error)
    write (nombre,'(F6.3)') f_factor
    call message (6,1,'INI_CABLE',   &
      'Multiply the phase correction by '//nombre(1:lenc(nombre)))
  else
    continuous = .false.
    do i=1, mnant
      iconn(i) = i
      call sic_i4(line,iopt,1+i,iconn(i),.false.,error)
      if (error) return
    enddo
    chain = ' '
    write (chain,'(6i3)') iconn
    call message (6,1,'INI_CABLE',   &
      'Assuming phasemeters 1 2 3 4 5 6 connected to '//chain)
  endif
  return
  !
entry mod_cable (do_write,do_data,error)
  ! Test
  !      DO_WRITE = .FALSE.
  !      DO_DATA = .FALSE.
  !
  ! Set time
  ! Modify observation
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five .and. r_proc.ne.p_flux    &
    .and. r_proc.ne.p_otf) then
    goto 500
  endif
  if (r_lmode.ne.1) then
    goto 500
  endif
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  !
  ! See what frequency plan/cabling applies
  ! OGR or NGR ?
  if (new_receivers) then
    if2_hiq = 0.0           ! Signal transported back through optical fibers
    lo2_ant = 0.0           ! LO2 conversion in IF processor
    mult = 3
    if (r_nrec.eq.2) mult = 2
    if (r_nrec.eq.1) mult = 1
  else
    if2_hiq = 1.0           ! Signal transported back through high-q cable
    lo2_ant = 1.0           ! LO2 conversion in IF antenna
    mult = 1
    if (r_nrec.eq.2) mult = 3
  endif
  ! New LO system in 2010
  if (r_dobs.lt.-5109) then ! New LO on 01-sep-2010
    f100mhz_mult = blhvhl   ! 100 MHz carried by low-Q 
    ref_mult    = 1         ! FLO1_REF = FSYNT-0.5MHz
  else
    f100mhz_mult = 1        ! 100 MHz carried by
    ref_mult    = 8         ! FLO1_REF = 8*(FSYNT-0.5 MHz)
  endif
  ! Now gets harmonic number
  nharm = nint((r_flo1/mult+100.175*r_lock)/r_flo1_ref)
  ! compute f100mhz since it was not so constant after all... (2001-10-15)
  f100mhz = (nharm*r_flo1_ref-r_flo1/mult)/r_lock
  if (f100mhz .gt. 100.175) then
    f100mhz = 100.25d0
  else
    f100mhz = 100.09765625d0
  endif
  ! Loop on records (including average)
  ! a corrected record may be present
  kin = gag_pointer(data_in,memory)
  do ir = 1, r_ndump + max(1,r_ndatl)
    ipk = kin + h_offset(ir)
    call decode_header (memory(ipk))
    do i=1, r_nant
      used(i) = dh_cable(i)
      if (continuous .and. old(i).eq.0) then
        old(i) = used(i)
      endif
    enddo
    do i=1, r_nant
      if (continuous) then
        dh_cable(i) = mod(used(i)-old(i)+100.25,0.5)-0.25+old(i)
      elseif (factor) then
        dh_cable(i) = used(i)*f_factor
      else
        dh_cable(i) = used(iconn(i))
      endif
    enddo
    call encode_header(memory(ipk))
    ipk = kin + c_offset(ir)
    ! Continuum
    ! Loop on baselines
    do ibas = 1, r_nbas
      ia = r_iant(ibas)
      ja = r_jant(ibas)
      x = dh_cable(ja)-used(ja)-dh_cable(ia)+used(ia)
      do iside=1, r_nsb
        do isub =1, r_nband
          fi2 = r_cfcen(i)
          isign = 3-2*r_lsband(iside,isub)
          ! these are the various terms as applied in delay_phase_total (task correl)
          f =  r_lock*nharm*ref_mult*mult               & ! LO1
              -f100mhz*ref_mult/r_flo1_ref*f100mhz_mult & ! 100MHz signal
              -isign*fi2/r_flo1_ref*if2_hiq             & ! IF2
              -isign*lo2_ant                              ! LO2
          call rotate(memory(ipk),2*3.14159*f*x)
          ipk = ipk + 2        ! 1 complex
        enddo
      enddo
    enddo
  enddo
  ! Line ...
  ! Loop on baselines
  ! do uncorrected and corrected data
  do ir = 1, max(1,r_ndatl)
    ipk = kin + l_offset(ir+r_ndump)
    if (r_lfour) then
      do ibas = 1, r_nbas
        ia = r_iant(ibas)
        ja = r_jant(ibas)
        x = dh_cable(ja)-used(ja)-dh_cable(ia)+used(ia)
        do iside = 1, r_lnsb
          do isub = 1, r_lband
            ipk1 = ipk+2*r_lich(isub)
            do i = 1, r_lnch(isub)
              fi2 = (r_lfcen(isub)+   &
                (i-r_lcench(isub))*r_lfres(isub))
              isign = 3-2*r_lsband(iside,isub)
              ! these are the various terms as applied in delay_phase_total (task correl)
              f =  r_lock*nharm*ref_mult*mult                &
                  -f100mhz*ref_mult/r_flo1_ref*f100mhz_mult  &
                  -isign*fi2/r_flo1_ref*if2_hiq              & 
                  -isign*lo2_ant
              call rotate(memory(ipk1),2*3.14159*f*x)
              ipk1 = ipk1 + 2  ! 1 complex
            enddo
          enddo
          ipk = ipk+2*r_lntch
        enddo
      enddo
    endif
  enddo
  !
  ! Real life
  do_data = .true.
  do_write = .true.
500 continue
  return
end subroutine ini_cable
!
subroutine ini_bug (line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! 	MODIFY BUG number
  ! NUMBER   DATE         Description
  !
  ! 1        11/Nov 95    C02 to C06 badly calibrated.
  !                       (counter CC not init.d properly in DO_AUTOL)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_constant.inc'
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data, need_action, rf, rfhr, some_mod
  character(len=80) :: chain
  integer :: number
  integer :: i,isign
  integer(kind=address_length) :: data_in,kin,k,ipk,ipk1
  integer(kind=data_length)    :: ndata,h_offset,c_offset,l_offset
  integer :: istart, iend, ia, ical, ic, ip, ir, ibas, iside, isub
  integer :: ib, is, isb
  real(kind=8)    :: ns, phi0,phi
  real :: x(mnbas), x0(mnbas, mrlband), x0p(mnbas, mrlband)
  real :: x1(mnbas, mrlband), df, lpha, ldph 
  parameter (ns=220/299792458d0)
  real(kind=8) :: freqcorr(mrlband), f0, f0p 
  real, parameter :: tol = 1e-4
  !
  save number
  !------------------------------------------------------------------------
  ! Code:
  call check_equal_file(error)
  if (error) return
  call sic_i4(line,iopt,2,number,.true.,error)
  if (error) return
!  number= min(1,max(1,number))
  write(chain,'(A,I4.4,A)') 'Correcting BUG number ', number
  call message (6,1,'INI_BUG',chain)
  return
  !
entry mod_bug (do_write,do_data,error)
  ! Test
  do_write = .false.
  do_data = .false.
  !
  if (number.eq.1) then
    call cdate('11-nov-1995',istart,error)
    call cdate('09-jan-1996',iend,error)
    ! NOte: the hour is not checked,
    ! actually the correction was introduced at 3pm on 09-jan-1996.
    if (r_dobs.lt.istart .or. r_dobs.gt.iend) return
    !
    !  Calibration scan
    ! Modify observation
    if (r_proc.eq.p_cal.and.r_scaty.eq.4) then
      ! Get storage and data
      call get_data (ndata,data_in,error)
      if (error) return
      ! average record
      kin = gag_pointer(data_in,memory)+r_ndump*r_ldump
      call decode_header (memory(kin))
      k = kin+r_ldpar+r_ldatc
      do ia = 1, r_nant
        do ical = 1, r_nbb
          ic = r_mapbb(ical)
          ip = r_mappol(ia,ical)
          integ(ia,r_nrec,ic,ip,chop) = 0
        enddo
      enddo
      k = kin + r_ldpar
      k = k + r_ldatc
      call redo_autol (chop,memory(k), error)
      if (error) return
    elseif (r_proc.eq.p_source .or. r_proc.eq.p_delay   &
      .or. r_proc.eq.p_gain .or. r_proc.eq.p_focus   &
      .or. r_proc.eq.p_point .or. r_proc.eq.p_holog   &
      .or. r_proc.eq.p_five .or. r_proc.eq.p_flux    &
      .and. r_proc.ne.p_otf) then
      !
      ! Get storage and data
      call get_data (ndata,data_in,error)
      if (error) return
      do i = 1, r_ndump          ! Next record
        kin = gag_pointer(data_in,memory)+ (i-1)*r_ldump
        call decode_header (memory(kin))
        k = kin + r_ldpar
        call redo_atmosc (memory(k), error, i)
        if (error) return
      enddo
      kin = gag_pointer(data_in,memory)+r_ldump*r_ndump
      call decode_header (memory(kin))
      k = kin + r_ldpar
      call redo_atmosc (memory(k), error, 0)
      if (error) return
      k = k + r_ldatc
      ! Corrected data if present
      if (r_ndatl.gt.1) then
        kin = gag_pointer(data_in,memory)+r_ldump*r_ndump   &
          + r_ldpar+r_ldatc+r_ldatl
        call decode_header (memory(kin))
        k = kin + r_ldpar
        call redo_atmosc (memory(k), error, 0)
        if (error) return
      endif
    endif
    ! 
    ! Real life
    do_data = .true.
    do_write = .true.
continue
    return
  elseif (number.eq.2) then
    call cdate('26-jan-2015',istart,error)
    call cdate('05-mar-2015',iend,error)
    !
    if (r_dobs.lt.istart .or. r_dobs.gt.iend) then
      call message(3,2,'MODIFY_BUG','Data not affected')
      return
    endif
    !
    ! Only deals with cross-correlation
    if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
      .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
      .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
      .and. r_proc.ne.p_five .and. r_proc.ne.p_flux    &
      .and. r_proc.ne.p_otf) then
      goto 501
    endif
    if (r_lmode.ne.1) then
      goto 501
    endif
    ! Get storage and data
    call get_data (ndata,data_in,error)
    if (error) return
    ! Loop on records (including average)
    ! a corrected record may be present
    kin = gag_pointer(data_in,memory)
    !
    ! First compute frequencies
    do i = 1, r_lband
      freqcorr(i)=r_band2bis(i)*r_flo2bis(i)+r_flo3(i)-r_flo4(i)
    enddo
    !
    ! Correct data
    do ir = 1, r_ndump + max(1,r_ndatl)
      ipk = kin + h_offset(ir)
      call decode_header (memory(ipk))
      !
      ! Ensure that correction is applied only once
      if (dh_test0(6).ne.0) then
        call message(3,2,'MODIFY_BUG','Data already corrected')
        return
      endif
      dh_test0(6) = 2
      call encode_header (memory(ipk))
      ipk = kin + c_offset(ir)
      ! Continuum
      ! Loop on baselines
      do ibas = 1, r_nbas
        phi0 = ns*r_bas(2,ibas)*dh_svec(2)*2*pi
        do iside=1,2
          isign = 3-2*iside
          do isub =1, r_nband
            phi = phi0*freqcorr(isub)*isign
            call rotate(memory(ipk),phi)
            ipk = ipk + 2        ! 1 complex
          enddo
        enddo
      enddo
    enddo
    ! Line 
    ! Loop on baselines
    ! do uncorrected and corrected data
    do ir = 1, max(1,r_ndatl)
      ipk = kin + l_offset(ir+r_ndump)
      if (r_lfour) then
        do ibas = 1, r_nbas
          phi0 = ns*r_bas(2,ibas)*dh_svec(2)*2*pi
          do iside = 1, 2
            isign = 3-2*iside
            do isub = 1, r_lband
              phi = phi0*freqcorr(isub)*isign
              ipk1 = ipk+2*r_lich(isub)
              do i = 1, r_lnch(isub)
                call rotate(memory(ipk1),phi)
                ipk1 = ipk1 + 2  ! 1 complex
              enddo
            enddo
            ipk = ipk+2*r_lntch
          enddo
        enddo
      endif
    enddo
    !
    ! Compute data modifiers
    do ibas = 1, r_nbas
      phi0 = ns*r_bas(2,ibas)*dh_svec(2)*2*pi
      do iside = 1, 2
        isign = 3-2*iside
        do isub = 1, r_nband
          r_dmcpha(iside,ibas,isub) = r_dmcpha(iside,ibas,isub) &
              + phi0*freqcorr(isub)*isign
        enddo       
        do isub = 1, r_lband
          r_dmlpha(iside,ibas,isub) = r_dmlpha(iside,ibas,isub) &
              + phi0*freqcorr(isub)*isign
        enddo       
      enddo
    enddo
    !
    ! Real life
    do_data = .true.
    do_write = .true.
501 continue
    return
  elseif (number.eq.3) then
    call cdate('15-jun-2023',istart,error)
    !
    ! No back to the future
    if (r_dred.lt.istart) then
      call message(3,2,'MODIFY_BUG','Data not affected')
      return
    endif
    !
    ! Only deals with cross-correlation
    if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
      .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
      .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
      .and. r_proc.ne.p_five .and. r_proc.ne.p_flux    &
      .and. r_proc.ne.p_otf) then
      goto 502
    endif
    if (r_lmode.ne.1) then
      goto 502
    endif
    ! Nothing to do if no HR spw 
    if (r_lband.le.r_nbb) return
    !
    x0 = 0 
    x0p = 0
    x1 = 0
    x =  0
    ! Get storage and data
    call get_data (ndata,data_in,error)
    if (error) return
    ! Loop on records (including average)
    ! a corrected record may be present
    kin = gag_pointer(data_in,memory)
    ipk = kin + h_offset(r_ndump+1)
    call decode_header (memory(ipk))
    !
    ! First compute x0,x0p and x1 from lpha and ldph
    do is=1, lband_original
      do ib=1, r_nbas
        isb = r_lsband(1,is)
        df = (3-2*isb)*r_band2bis(is)*r_band2(is)*r_lfres(is) 
        f0 =  r_flo1+(3-2*isb)*(r_flo2(is)   &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_lfcen(is)))
        f0p = (3-2*isb)*(r_flo2(is)          &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_lfcen(is)))
        if (f0.ne.0)  x0(ib,is) =r_dmlpha(1,ib,is)/f0
        if (f0p.ne.0) x0p(ib,is)=r_dmlpha(1,ib,is)/f0p
        if (df.ne.0)  x1(ib,is) =r_dmldph(1,ib,is)/df
      enddo
    enddo
    !
    ! Check if hr spw have the same x than lr
    ! If not, if hr was modified and how (rf or not)
    need_action = .false.
    some_mod = .false.
    do is=r_nbb+1, lband_original
      ical = r_bb(is)
      if (.not.nearly_equal(x0(1:r_nbas,is),x0(1:r_nbas,ical),int(r_nbas,kind=size_length),tol)) then
        need_action = .true.
        if (any(x0(1:r_nbas,is).ne.0)) some_mod = .true.
        if (some_mod) then
          if (nearly_equal(x0(1:r_nbas,is),x1(1:r_nbas,is),int(r_nbas,kind=size_length),tol)) then
            rfhr = .true.
          elseif(nearly_equal(x0p(1:r_nbas,is),x1(1:r_nbas,is),&
                   int(r_nbas,kind=size_length),tol)) then
            rfhr = .false.
          else
            call message(3,3,'MODIFY_BUG','Cannot correct bug')
            error = .true.
            return 
          endif  
        endif 
      endif
    enddo
    if (.not.need_action) then 
       goto 502   
    endif
    call message(3,1,'MODIFY_BUG','Bug is present in data')
    !
    ! Compute phase factors per subband (for crossed pol case)
    do is  = r_nbb+1,lband_original
      ical = r_bb(is)
      isb = r_lsband(1,ical)
      isign = 3-2*isb
      do ib = 1, r_nbas
        ldph = r_dmldph(1,ib,ical)
        lpha = r_dmlpha(1,ib,ical)
        if (some_mod) then
        ! 1) remove correction already applied in hr from lr
          df = (3-2*isb)*r_band2bis(ical)*r_band2(ical)*r_lfres(ical) 
          f0 =  r_flo1+(3-2*isb)*(r_flo2(ical)   &
              + r_band2(ical) * (r_flo2bis(ical)   &
              + r_band2bis(ical)*r_lfcen(ical)))
          f0p = (3-2*ical)*(r_flo2(ical)   &
              + r_band2(ical) * (r_flo2bis(ical)   &
              + r_band2bis(ical)*r_lfcen(ical)))
          ldph = ldph-df*x1(ib,is)
          if (rfhr) then
            lpha = lpha-f0*x0(ib,is)
          else
            lpha = lpha-f0p*x0p(ib,is)
          endif
        endif
        ! 2) check if remaining is rf, not rf, or a problem
        x(ib) =  &
                ldph*isign*r_band2bis(ical)*r_band2(ical)/r_lfres(ical)
        if (abs(lpha).gt.tol) then    ! nearly_equal does not do the job here
          if (nearly_equal(lpha, &
              real(x(ib)*(r_flo1+isign*(r_flo2(ical)   &
              + r_band2(ical) * (r_flo2bis(ical)   &
              + r_band2bis(ical)*r_lfcen(ical)))),kind=4),tol)) then
            rf = .true.
          elseif (nearly_equal(lpha, &
              real(x(ib)*isign*(r_flo2(ical)   &
              + r_band2(ical) * (r_flo2bis(ical)   &
              + r_band2bis(ical)*r_lfcen(ical))),kind=4),tol)) then
            rf = .false.
          else
            call message(3,2,'MODIFY_BUG','This is wrong')
            error = .true.
            return
          endif
        else
          x(ib)=0
        endif
      enddo
      !
      ! Actually modify data:
      if (any(x.ne.0)) call modify_ph(memory(kin),x,is,rf)
    enddo
    ! 
    ! Real life
    do_data = .true.
    do_write = .true.
502 continue
    return
  else
    return
  endif 
end subroutine ini_bug
!
subroutine ini_spidx(line,iopt,error)
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY SPIDX value
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  logical :: do_write, do_data
  real*4 :: new_spidx
  character(len=80) :: chain
  save new_spidx
  ! Data
  data new_spidx/0.0/
  !------------------------------------------------------------------------
  ! Code:
  call check_equal_file(error)
  if (error) return
  call sic_r4(line,iopt,2,new_spidx,.true.,error)
  if (error) return
  write(chain,*) new_spidx
  call message (6,1,'INI_VELOCITY',   &
    'Modifying spectral index to '//chain(1:lenc(chain)))
  return
  !
entry mod_spidx(do_write,do_data,error)
  ! Doesm't depend on side band ...
  r_spidx = new_spidx
  return
end subroutine ini_spidx
!
subroutine redo_autol  (mes, data, error)
  use gildas_def
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     Read in auto correlation function
  !     Increment the C_L and C_C buffers for the specified cal phase "mes".
  ! Input
  !     mes      I           Calibration phase
  !     DATA     REAL(*)     The data.
  !---------------------------------------------------------------------
  integer :: mes                    !
  real :: data(*)                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_proc_par.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  real :: calli(mlch)
  real :: c1, c2, cs, cc, ccwrong
  integer :: ia, ic, k, nc, n1, n2, is, n3, n4, kk, ncwrong, ip, ical
  !------------------------------------------------------------------------
  ! Code:
  ! Increment autocorrelation buffers
  ! The right values are in CHOP, the wrong ones in COLD
  k = 1
  do ia=1, r_nant
    do ic =1, r_lntch
      c2 = dh_integ
      call pol_chan(ip,ical,ic,error)
      if (error) return
      c1 = integ(ia,r_nrec,ical,ip,mes)
      integ(ia,r_nrec,ical,ip,mes) = c1 + c2
      cs = c1+c2
      if (cs.eq.0) then
        error = .true.
        return
      endif
      c1 = c1/cs
      c2 = c2/cs
      calli(ic) = data(k)
      k = k + 1
      c_l(ic,ia,r_nrec,ip,mes) =   &
        c1 * c_l(ic,ia,r_nrec,ip,mes) + c2 * calli(ic)
    enddo
    ! Ne doit pas etre ici         CC = 0
    ! Ne doit pas etre ici         NC = 0
    ccwrong = 0
    ncwrong = 0
    kk = 0
    do is = 1, r_lband
      !
      ! With polarisation, not factorized anymore
      ical = r_bb(is)
      ip = r_lpolentry(ia,is)
      c1 = integ(ia,r_nrec,ical,ip,mes)
      c2 = dh_integ
      cs = c1+c2
      c1 = c1/cs
      c2 = c2/cs
      !
      cc = 0.0                 ! Doit etre ici 09-Jan-1996
      nc = 0                   ! Doit etre ici 09-Jan-1996
      !
      ! avoid center and edges ...
      n1 = nint(r_lnch(is)*0.1)
      n2 = r_lnch(is)/2-1
      n3 = r_lnch(is)/2+2
      n4 = nint(r_lnch(is)*0.9)
      do ic=1, r_lnch(is)
        kk = kk + 1
        if ((ic.ge.n1 .and. ic.le.n2) .or.   &
          (ic.ge.n3 .and. ic.le.n4)) then
          cc = cc + calli(kk)
          nc = nc + 1
          ccwrong = ccwrong + calli(kk)
          ncwrong = ncwrong + 1
        endif
      enddo
      c_c(is,ia,r_nrec,ip,chop) =   &
        c1*c_c(is,ia,r_nrec,ip,chop) + c2*cc/nc
      c_c(is,ia,r_nrec,ip,cold) =   &
        c1*c_c(is,ia,r_nrec,ip,cold) + c2*ccwrong/ncwrong
    enddo
  enddo
  return
end subroutine redo_autol
!
!
subroutine redo_atmosc (data, error, ido)
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     REProcess temporal data: after a BUG # 1
  !     The right calibration factor is in CHOP, the wrong in COLD.
  ! Input
  !     DATA    COMPLEX(*)
  !---------------------------------------------------------------------
  complex :: data(*)                !
  logical :: error                  !
  integer :: ido                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  integer :: ib, ia, ja, is, k, ip
  real :: norm
  !------------------------------------------------------------------------
  ! Code:
  ! Continuum
  k = 1
  do ib=1, r_nbas
    ia = r_iant(ib)
    ja = r_jant(ib)
    do is = 1, r_nband
      ip = r_lpolentry(ia,is)
      if (c_c(is,ia,r_nrec,ip,cold).ne.0   &
        .and. c_c(is,ja,r_nrec,ip,cold).ne.0) then
        norm = sqrt(abs(c_c(is,ia,r_nrec,ip,chop)   &
          *c_c(is,ja,r_nrec,ip,chop)   &
          /c_c(is,ia,r_nrec,ip,cold)   &
          /c_c(is,ja,r_nrec,ip,cold)))
        if (ido.eq.1) then
          r_dmcamp(1,ib,is) = r_dmcamp(1,ib,is) /norm
          r_dmcamp(2,ib,is) = r_dmcamp(2,ib,is) /norm
        endif
        data(k) = data(k) / norm
        data(k+r_nband) = data(k+r_nband) / norm
      endif
      k = k + 1
    enddo
    k = k + r_nband
  enddo
  return
end subroutine redo_atmosc

subroutine pol_chan(ipola,inbc,ichan,error)
  use classic_api
  integer :: ipola                  ! Output: polarisation
  integer :: inbc                   ! Output: correlator entry
  integer :: ichan                  ! Input: channel
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: i, ifirst, ilast, isub
  logical :: found
  found = .false.
  isub = 0
  !
  ! If old receivers, always return horizontal polarisation
  if (.not.new_receivers) then
  ! TBA
    ipola = 1
    return
  endif
  !
  ! Determine unit to which the channel belongs to
  do i = 1, r_lband
    ifirst = r_lich(i)+ 1
    ilast = r_lich(i) + r_lnch(i)
    if (ichan.ge.ifirst.and.ichan.le.ilast) then
      if (found) then
        if (isub.ne.i) then
          call message(2,3,'POL_CHAN',   &
            'Channel belonging to more than 1 unit')
          error = .true.
          return
        endif
      endif
      found = .true.
      isub = i
    endif
  enddo
  !
  ipola = r_lpolentry(1,isub)  ! Same pol. entry for all antennas
  inbc = r_bb(isub)
end subroutine pol_chan

subroutine astro_uv_doppler(line,error)
  use image_def
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_uv_doppler
  use gbl_format
  use gbl_message
  !-----------------------------------------------------------------------
  ! @ private
  !   Support for command UV_DOPPLER
  ! Task to compute the Doppler correction and apply it (by changing
  ! the u,v coordinates) to an UV Table.
  !-----------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=filename_length) :: file
  character(len=12) :: telescope
  character(len=*), parameter :: rname='UV_DOPPLER'
  type (gildas) :: uvin, uvou
  integer(kind=4) :: nf, i, ier, ib
  real(kind=4) :: rdate, rtime, doppler
  real(kind=8), parameter :: clight_kms=299792.458d0
  character(len=2) :: coord
  character(len=80) :: mess
  real(kind=4) :: equinox
  real(kind=8) :: lambda, beta
  integer(kind=4) :: nblock, nvisi, idate, itime
  logical :: output
  integer(kind=4) :: mode
  integer(kind=4) :: idopp
  !
  call sic_ke(line,0,1,telescope,nf,.true.,error)
  if (error)  return
  call astro_observatory(telescope,error)
  if (error) return
  !
  call sic_ch(line,0,2,file,nf,.true.,error)
  if (error)  return
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, file, '.uvt', error, data=.false.)
  if (error) then
    call astro_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvin%gil%dim(2))
  ! Allocate respective space for each file
  allocate (uvin%r2d(uvin%gil%dim(1),nblock),stat=ier)
  if (failed_allocate(rname,'UV input data',ier,error))  return
  !
  ! Here modify the header of the output UV table according
  ! to the desired goal
  !
  output = sic_present(0,3)
  call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_copy_header(uvin,uvou,error)
  !
  mode = 0
  call sic_i4(line,0,4,mode,.false.,error)
  if (error)  return
  if (mode.ne.0) then
    idopp = 3
    do i = 1,code_uvt_last
      if (uvou%gil%column_pointer(i).eq.idopp)  then
        uvou%gil%column_size(i) = 0
        uvou%gil%column_pointer(i) = 0
      endif
    enddo
    uvou%gil%column_pointer(code_uvt_topo) = idopp
    uvou%gil%column_size(code_uvt_topo) = 1
  endif
  !
  if (output) then
    call sic_ch(line,0,3,file,nf,.true.,error)
    call sic_parse_file(file,' ','.uvt',uvou%file)
    !
    ! create the image
    uvou%gil%dopp = 0.d0
    uvou%gil%version_uv = code_version_uvt_syst
    call gdf_create_image(uvou,error)
    if (error) then
      call gdf_close_image(uvin,error)
      deallocate(uvin%r2d,stat=ier)
      error = .true.
      return
    endif
  endif
  !
  coord = uvin%char%syst
  if (coord.eq.'EQ') then
    equinox = uvin%gil%epoc
    lambda = uvin%gil%ra
    beta   = uvin%gil%dec
  else if (coord.eq.'GA') then
    equinox = uvin%gil%epoc
    lambda = uvin%gil%lii
    beta   = uvin%gil%bii
  else
    coord = 'EQ'
    call astro_message(seve%w,rname,'Unsupported system '//coord)
    call astro_message(seve%w,rname,'Assuming EQUATORIAL')
    equinox = 2000.0
    lambda = uvin%gil%ra
    beta   = uvin%gil%dec
  endif
  !
  ! Loop over line table
  uvou%blc = 0
  uvou%trc = 0
  uvin%blc = 0
  uvin%trc = 0
  rdate = -1e38
  rtime = -1e38
  idate = uvin%gil%column_pointer(code_uvt_date)
  itime = uvin%gil%column_pointer(code_uvt_time)
  !
  do ib = 1,uvou%gil%dim(2),nblock
    write(mess,*) ib,' / ',uvou%gil%dim(2),nblock
    call astro_message(seve%d,rname,mess)
    uvin%blc(2) = ib
    uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
    uvou%blc(2) = ib
    uvou%trc(2) = uvin%trc(2)
    call gdf_read_data(uvin,uvin%r2d,error)
    nvisi = uvin%trc(2)-uvin%blc(2)+1
    !
    ! Here do the job
    do i=1,nvisi
      !
      if (uvin%r2d(idate,i).ne.rdate .or. uvin%r2d(itime,i).ne.rtime) then
        rdate = uvin%r2d(idate,i)
        rtime = uvin%r2d(itime,i)
        call sub_uv_doppler(uvin%gil%vtyp,rdate,rtime,doppler,&
          coord,equinox,lambda,beta,error)
        !! factor = (1.d0 + doppler)
        if (.not.output) then
          Print *,' Visi ',i+nblock*(ib-1),rdate,rtime,clight_kms*doppler
        endif
      endif
      if (idopp.ne.0) uvin%r2d(idopp,i) = doppler
    enddo
    !
    if (output) then
      call gdf_write_data (uvou,uvin%r2d,error)
      if (error) then
        call gdf_close_image(uvou,error)
        call gdf_close_image(uvin,error)
        deallocate(uvin%r2d,stat=ier)
        error = .true.
        return
      endif
    endif
  enddo
  !
  call gdf_close_image(uvin,error)
  if (output) call gdf_close_image(uvou,error)
  deallocate(uvin%r2d,stat=ier)
end subroutine astro_uv_doppler
!
subroutine sub_uv_doppler(vtype,rdate,rtime,doppler, &
        & coord,equinox,lambda,beta,error)
  use image_def
  use astro_interfaces, except_this => sub_uv_doppler
  use gbl_message
  use gbl_constant
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  ! Compute the Doppler correction, calling ASTRO routine, according to:
  ! * observatory location
  ! * reference frame (LSR, Helio...)
  ! Radio convention is used
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: vtype    ! Type of referential
  real(kind=4),     intent(in)  :: rdate    ! GAG Date
  real(kind=4),     intent(in)  :: rtime    ! UT Time
  real(kind=4),     intent(out) :: doppler  ! Doppler factor
  character(len=2), intent(in)  :: coord    !
  real(kind=4),     intent(in)  :: equinox  !
  real(kind=8),     intent(in)  :: lambda   !
  real(kind=8),     intent(in)  :: beta     !
  logical,          intent(out) :: error    ! flag
  ! Local
  real(kind=8) :: vshift
  real(kind=8) :: s_2(2), s_3(3), dop, lsr, svec(3), x_0(3), parang
  real(kind=8) :: jtdt, jut1, jutc
  !
  doppler = -1d0
  !
  ! Reset the time
  jutc = rdate + rtime/86400.d0 +  2460549.5d0
  !
  ! For what we want to do, these are negligible
  jut1 = 0.d0
  Jtdt = 0.
  call do_astro_time(jutc,jut1,jtdt,error)
  if (error) return
  !
  ! Call ASTRO
  call do_object(coord,equinox,lambda,beta,s_2,s_3,dop,lsr,svec, &
      &   x_0,parang,error)
  if (error) return
  !
  ! Now retrieve the Doppler value
  !
  select case (vtype)
  case (vel_lsr)
     vshift = dop+lsr
  case (vel_hel)
     vshift = dop
  case (vel_ear)
     vshift = 0.0d0
  case default
     vshift = 0.0d0
  end select
  !
  ! This follows the CLASS convention, but it seems that the
  ! CLIC convention is WRONG ...
  doppler = - vshift / clight * 1d3
end subroutine sub_uv_doppler

subroutine init_alma_sdm(file,error)
  character *(*) file          ! the root file (directory) of the SDM
  logical error                ! error return
  print *,'I-SDM, init ',file
end subroutine init_alma_sdm
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_tracked_wsw(mrtset,backcal,backsci,filebuf,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_level_codes
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_tracked_wsw
  !---------------------------------------------------------------------
  ! @ private
  ! Gather all needed steps to read, calibrate, and write a 
  ! tracked wobbler switched scan for a given backend
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: ion,non
  integer(kind=4) :: iref,nref
  character(len=*), parameter :: rname='CALIB>TRACKED>WSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_init_refloop(backsci,nref,error)
  if (error) return
  do iref=1,nref
     call mrtcal_get_nextref(backsci,error)
     if (error) return
     call mrtcal_init_onloop(backsci,non,error)
     if (error) return
     do ion=1,non
        call mrtcal_get_nexton(backsci,error)
        if (error) return
        call mrtcal_init_dumpcycle_loop('track',mrtset,filebuf,backsci,error)
        if (error) return
        do while (backsci%switch%book%idump.le.backsci%switch%book%ndump)
           call mrtcal_get_next_dumpcycle(mrtset,filebuf,backsci,error)
           if (error) return
           if (backsci%switch%book%found) then
              call mrtcal_on_minus_off_new(nototfmap,notfsw,backcal,backsci,error)
              if (error) return
              call mrtcal_tscale_computation(backcal,backsci,error)
              if (error) return
              call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
              if (error) return
              call mrtcal_accumulate_or_write(level_cycl_code,mrtset,backsci,error)
              if (error) return
           endif
           ! User can interrupt the pipeline
           if (sic_ctrlc_status()) then
              error = .true.
              exit
           endif
        enddo ! switch%book%idump
        call mrtcal_switch_book_list(backsci%switch%book,error)
        if (error) return
        call mrtcal_accumulate_or_write(level_subs_code,mrtset,backsci,error)
        if (error) return
     enddo ! ion
  enddo ! iref
  call mrtcal_accumulate_or_write(level_scan_code,mrtset,backsci,error)
  if (error) return
  !
end subroutine mrtcal_calib_tracked_wsw
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtcal_calib_types
  use imbfits_types
  use mrtcal_chunk_types
  use mrtcal_chunkset_types
  use mrtcal_chunkset_nd_types
  use mrtcal_chopperset_types
  use mrtindex_types
  use mrtindex_parse_types
  use mrtcal_obs_list
  use mrtcal_science_types
  use mrtcal_calibration_types
end module mrtcal_calib_types
!
module mrtcal_sicidx
  !---------------------------------------------------------------------
  ! Support module for
  !  Sic structure  IDX%USER%
  !  Command        VARIABLE USER /INDEX
  !---------------------------------------------------------------------
  !
  type mrtcal_classuser_arr_t
    integer(kind=4), allocatable :: obstype(:)  ! Observation type
    real(kind=4),    allocatable :: noise(:)    ! Theoretical noise (rms) from calibration
    real(kind=4),    allocatable :: backeff(:)  ! Backend efficiency
    real(kind=4),    allocatable :: airmass(:)  ! Airmass
    real(kind=4),    allocatable :: expatau(:)  ! exp( airmass * tauzen )
  end type mrtcal_classuser_arr_t
  !
  ! Support variable for command "SET VARIABLE Section /INDEX"
  type(mrtcal_classuser_arr_t), save :: idxuser
  !
end module mrtcal_sicidx
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! This file to be updated if GIO supports mxdim>4
module sic_bintable
  use gildas_def
  !---------------------------------------------------------------------
  ! FITS Binary tables support
  !---------------------------------------------------------------------
  integer, parameter :: mcols=999      ! Maximum number of columns in a 3D table
  integer(kind=address_length) :: vmaddr(mcols)   ! Address of variable got by SIC_GETVM
  integer :: varformat(mcols)          ! Format of variable
  real :: colscal(mcols)               ! Scaling of column
  real :: colzero(mcols)               ! Offset of column
  integer :: ncols                     ! Number of columns in table
  integer :: coladdr(mcols+1)          ! Start of column i (in bytes)
  integer :: colfmt(mcols)             ! Format of column i (SIC codes)
  integer :: nitem(mcols)              ! Repeat count for column i
  integer :: coldim(4,mcols)           ! Possible 'shape' of column
  integer :: colndim(mcols)            ! Corresponding multi-dimensionality
  ! Still in limbo for very good and true reasons by GD.
  !     INTEGER COLNULL(MCOLS)         ! Value Taken As Blanked
  logical :: usescal(mcols)       !
  character(len=64) :: collabl(mcols)  ! LABEL (type information) of column i
  character(len=20) :: colform(mcols)  ! Format of column i (FITS syntax)
  character(len=20) :: colunit(mcols)  ! Unit of data in column i
  logical :: transposevar              ! Tells if we want arrays transposed
end module sic_bintable
!
subroutine sic_fits(line,global,error)
  use gildas_def
  use sic_types
  use sic_dependencies_interfaces, no_interface=>gfits_getbuf
  use sic_interfaces, except_this=>sic_fits
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !
  !     Support routine for command DEFINE FITS
  !
  ! SIC\DEFINE FITS  Var File.fits  [Key1 Key2 Key3 Key4]
  !    where the optional Key is any of [index#|Header|Transpose|Basic]
  !    index# being the extension number
  !
  ! READS a FITS FILE, and defines/load SIC variables according to
  ! what is found.
  !      if index# is present, only load this Xtension number
  !      if Header is present, do not load the main data
  !      if Transpose is present, transpose Tables in Xtension
  !      if Basic is present, only load basic keywords, no fancy ones
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! Command line
  logical, intent(in) :: global                  ! Global status of variable
  logical, intent(out) :: error                  ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer, parameter :: o_glob=1  ! /GLOBAL
  integer, parameter :: o_like=2  ! /LIKE
  integer, parameter :: o_trim=3  ! /TRIM
  character(len=*), parameter :: rname='FITS'
  integer :: nf,ns,fmt
  character(len=8) :: dummy
  character(len=256) :: name
  character(len=256), target :: chain
  character(len=16) :: headofstruct
  integer(kind=address_length) :: ibuf,jbuf
  logical :: extend,rgroups,xtension,define
  integer :: i,naxis,intg,pcount,gcount,nbits,rndmgrpsz
  integer(kind=size_length) :: mainsiz,skipsz,nsize
  logical :: eof,transpo,ldata
  integer :: iext,mext
  integer :: ndim, therank, maxis
  integer(kind=index_length) :: dim(sic_maxdims)
  integer(kind=4), save :: naxes(sic_maxdims)
  type(sic_descriptor_t) :: desc
  integer(kind=address_length) :: ip
  integer :: n
  logical :: found
  character(len=message_length) :: mess
  integer(kind=size_length), parameter :: lcard=80
  !
  integer, parameter :: nkey=3
  integer :: ikey
  character(len=12) :: key, keys(nkey)
  data keys/'BRIEF','HEADER','TRANSPOSE'/
  !
  mext = 0                     ! All extensions by default
  transpo=.false.
  error=.false.
  ldata = .true.               ! Have data and header
  !
  do i=4,6
    if (sic_present(0,i)) then
      call sic_ke (line,0,i,name,nf,.true.,error)
      if (error) return
      call sic_ambigs_sub(rname,name,key,ikey,keys,nkey,error)
      select case(key)
      case ('TRANSPOSE')
        transpo=.true.
      case ('BRIEF')
        call sic_message(seve%w,rname,'BRIEF keyword is obsolete')
      case ('HEADER')
        ldata = .false.
      case default
        call sic_i4(line,0,i,mext,.true.,error)
        if (error) return
      end select
    endif
  enddo
  !
  ! Do not read data if a specific extension is desired
  if (mext.ne.0) ldata = .false.
  !
  ! Trim all or specified dimensions
  if (sic_present(o_trim,0)) then
    therank = -10  ! Trim all dimensions
    call sic_i4(line,o_trim,1,therank,.false.,error)
    if (error) return
  else
    therank = 0
  endif
  !
  ! Reset
  extend = .false.
  rgroups = .false.
  xtension = .false.
  mainsiz = 0
  rndmgrpsz= 0
  skipsz = 0
  pcount = 0
  gcount = 0
  nbits  = 0
  ! Retrieve HEAD of structure name
  call sic_ke (line,0,2,headofstruct,ns,.true.,error)
  if (error) then
    call sic_message(seve%e,rname,'Missing structure name')
    return
  endif
  ! Retrieve FITS file name
  call sic_ch (line,0,3,chain,nf,.true.,error)
  if (error) return
  call sic_parse_file (chain(1:nf),' ','.fits',name)
  !
  jbuf = locstr(chain)
  ibuf = bytpnt(jbuf,membyt)
  !
  ! Open
  call gfits_open(name,'IN',error)
  if (error) then
    call sic_message(seve%e,rname,'Error opening file '//name)
    return
  endif
  ! SIMPLE
  call gfits_getbuf(membyt(ibuf),lcard,error)
  if (error) goto 99
  if (chain(1:8).ne.'SIMPLE') then
    call sic_message(seve%e,rname,'SIMPLE keyword not found')
    error=.true.
    goto 99
  elseif (chain(29:30).eq.' F') then
    call sic_message(seve%w,rname,'Not a SIMPLE FITS file, trying...')
  elseif (chain(29:30).ne.' T') then
    call sic_message(seve%e,rname,'Not a standard FITS file')
    error=.true.
    goto 99
  elseif (chain(9:10).ne.'= ') then
    call sic_message(seve%w,rname,'Not a standard FITS file')
    call sic_message(seve%w,rname,'"=" should occur in column 9, and '//  &
    'column 10 should be blank')
    call sic_message(seve%w,rname,'Proceeding with fingers crossed...')
  endif
  ! BITPIX
  call gfits_getbuf(membyt(ibuf),lcard,error)
  if (error) goto 99
  if (chain(1:8).ne.'BITPIX') then
    call sic_message(seve%e,rname,'Second keyword not BITPIX '//chain(1:8))
    error = .true.
    goto 99
  endif
  read(chain(11:30),'(I20)') intg
  if (intg.eq.8) then
    fmt = fmt_by
  elseif  (intg.eq.16) then
    fmt = eei_i2
  elseif  (intg.eq.32) then
    fmt = eei_i4
  elseif  (intg.eq.-32) then
    fmt = eei_r4
  elseif  (intg.eq.-64) then
    fmt = eei_r8
  else
    write(mess,*) 'Unsupported word size: ',intg
    call sic_message(seve%e,rname,mess)
    error=.true.
    goto 99
  endif
  nbits = intg
  ! NAXIS
  call gfits_getbuf(membyt(ibuf),lcard,error)
  if (error) goto 99
  if (chain(1:8).ne.'NAXIS') then
    call sic_message(seve%e,rname,'NAXIS keyword not found')
    error=.true.
    goto 99
  endif
  read(chain(11:30),'(I20)') naxis
  !
  ! Define SIC Structure
  call sic_crestructure(headofstruct(1:ns),global,error)
  if (error) goto 99
  !
  dim = 0
  naxes = 0
  if (naxis.eq.0) then
    rgroups = .false.  ! Just no main data, not a Random Group
    mainsiz = 0
    maxis = 0
  else
    if (naxis.gt.sic_maxdims) then
      call sic_message(seve%w,rname,'More than SIC_MAXDIMS dimensions in FITS file')
      maxis = sic_maxdims
    else
      maxis = naxis
    endif
    ! NAXIS1
    call gfits_getbuf(membyt(ibuf),lcard,error)
    if (error) goto 99
    if (chain(1:8).ne.'NAXIS1') then
      call sic_message(seve%e,rname,'NAXIS1 keyword not found')
      error=.true.
      goto 99
    endif
    read(chain(11:30),'(I20)') intg
    if (intg.ne.0) then
      mainsiz= intg
      dim(1) = intg
    else                       ! random group is present
      rgroups = .true.
      rndmgrpsz = 1
      naxes(1) = intg
    endif
  endif
  ! NAXIS2-N
  do i=2,naxis
    call gfits_getbuf(membyt(ibuf),lcard,error)
    if (error) goto 99
    dummy = 'NAXIS'//char(48+i)
    if (chain(1:8).ne.dummy(1:8)) then
      call sic_message(seve%e,rname,dummy//' keyword not found')
      error=.true.
      goto 99
    endif
    read(chain(11:30),'(I20)') intg
    if (rgroups) then
      rndmgrpsz = rndmgrpsz*intg
      if (i.le.sic_maxdims) naxes(i) = intg
    else
      mainsiz = mainsiz*intg
      if (i.le.sic_maxdims) dim(i) = intg
    endif
  enddo
  ndim = min(naxis,sic_maxdims)
  if (.not.rgroups) naxes = dim
  !
  ! Define the NAXIS variable (required for any test in Scripts)
  if (maxis.gt.0) then
    write(name,'(A,A,I0,A)') headofstruct(1:ns),'%NAXIS[',maxis,']'
    n = len_trim(name)
    call sic_defvariable(fmt_i4,name(1:n),global,error)
    if (error) return  
    n = index(name,'[')-1                     ! Must Skip the dimension
    call sic_descriptor(name(1:n),desc,found)
    ip = gag_pointer(desc%addr,memory)
    call r4tor4(naxes,memory(ip),maxis)
  endif
  !
  ! EXTEND Keyword should be here
  ! However, many FITS writer (IRAF at ST-ECF for example) are not
  ! very conformant, and insert other keywords before it
  ! It actually does not harm to set the EXTEND value whenever
  ! the keyword is found...
  extend = .false.
  !
  ! Rest of 1st header
  if (rgroups) then
    skipsz = 0
    ! S.Guilloteau 24-Jan-2022
    ! Do not skip anything here, because the keywords may be after 
    ! many other useful ones. The corresponding variables
    ! (skipsr, pcount, gcount, etc... will be defined in
    ! fits_read_rndm
    !
    !!do while (pcount.eq.0 .or. gcount.eq.0)
    !!  call gfits_getbuf(membyt(ibuf),lcard,error)
    !!  if (error) goto 99
    !!  ! check if random groups ala NRAO VLA.
    !!  ! if GROUPS=T, then we MUST have read NAXIS1=0 to compute size...
    !!  if (chain(1:8).eq.'EXTEND') then
    !!    if (chain(30:30).eq.'T') extend = .true.
    !!  elseif  (chain(1:8).eq.'GROUPS') then
    !!    if (chain(30:30).ne.'T') goto 98
    !!  elseif  (chain(1:8).eq.'PCOUNT') then
    !!    read(chain(11:30),'(I20)') intg
    !!    pcount=intg
    !!  elseif  (chain(1:8).eq.'GCOUNT') then
    !!    read(chain(11:30),'(I20)') intg
    !!    gcount=intg
    !!  endif
    !!enddo
    !!skipsz = gcount   ! Force I*8 operation for next statement
    !!skipsz = skipsz*(pcount+rndmgrpsz)
  else
    skipsz = mainsiz
  endif
  !
  ! convert in bytes now
  nsize = skipsz                !! In words
  skipsz = skipsz*abs(nbits)/8  !! In Bytes
  !
  if (rgroups) then
    ! Read RANDOM group data here...
    ndim = 0
    ! S.Guilloteau 24-Jan-2022 - Add "nbits" to list, and change status
    ! of some arguments to "inout" (These arguments should eventually be removed) 
    call fits_read_rndm(headofstruct,ns,global,fmt,nsize,ndim,dim,error,  &
    extend,gcount,pcount,rndmgrpsz,ldata,skipsz, nbits)
    if (error) goto 99
  else
    ! This should be the place where we READ the Main body of data.
    ! Define DIM, NDIM, etc...
    call fits_read_basic(headofstruct,ns,global,fmt,nsize,ndim,dim,error,  &
    extend,therank,ldata,skipsz)
    if (error) goto 99
  endif
  !
  ! here we can repeatedly explore the extensions
  ! This should be the place where we READ the various extensions.
  if (extend) then
    error = .false.
    eof = .false.
    iext = 0
    define = .true.
    do while (.not.(error.or.eof))
      iext = iext+1
      if (mext.ne.0) define = iext.eq.mext
      call fits_read_extension(headofstruct,ns,global,error,eof,iext,define,  &
      transpo)
      if (iext.eq.mext) eof = .true.
    enddo
    if (.not.eof) then
      call sic_message(seve%e,rname,'Specified extension not found')
      call sic_delvariable(headofstruct,.false.,error)
      error = .true.
    endif
  else if (mext.ne.0) then
    call sic_message(seve%e,rname,'No FITS Extensions')
    call sic_delvariable(headofstruct,.false.,error)
    error = .true.
  else
    call sic_message(seve%i,rname,'No FITS Extensions')
    error = .false.
  endif
  !
99 continue
  call gfits_close(error)
  return
  !
98 call sic_message(seve%e,rname,'Inconsistent Random Group Information')
  call gfits_close(error)
  error = .true.
  return
end subroutine sic_fits
!
subroutine fits_read_extension(headofstruct,ns,global,error,eof,iext,define,  &
  transpo)
  use gildas_def
  use gfits_types
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fits_read_extension
  use sic_bintable
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS
  !     Support routine for reading extensions
  !   DEFINE FITS  /EXTENSION extension_id
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: headofstruct  !  Structure name
  integer, intent(in) :: ns                     !
  logical, intent(in) :: global                 !  Global status
  logical, intent(out) :: error                 !  Error flag
  logical, intent(out) :: eof                   !  End of File indicator
  integer, intent(in) :: iext                   !  Extension number
  logical, intent(in) :: define                 !  Define or skip variables ?
  logical, intent(in) :: transpo                !  Transpose array ?
  !
  ! Local
  character(len=*), parameter :: rname='FITS'
  logical :: table,bintable,image,avoid
  character(len=8) :: comm,fits_kind
  character(len=16) :: key
  character(len=70) :: chain,extname
  logical :: check,found
  integer :: i,j,jj,i1,i2,k,icard
  integer(kind=size_length) :: skipsz,naxis1
  integer(kind=8) :: intg
  integer :: nbits,pcount,nrows,nss
  character(len=80) :: name,string
  character(len=160) :: struct
  integer :: count,mxcount,ier
  character(len=1) :: quote,openbrace,closebrace,comma
  character(len=message_length) :: mess
  type(gfits_hdict_t) :: hdict
  ! Data
  data quote/''''/
  data openbrace/'('/
  data closebrace/')'/
  data comma/','/
  !
  pcount = 0 ! Was uninitialized until 27-Jul-2017
  count = 0
  mxcount = 1000
  !
  skipsz= 0
  transposevar=transpo          !pass argument to common
  check = .false.              ! for READ
  !      CHECK = .TRUE.                    ! for READ
  table = .false.
  bintable = .false.
  avoid = .false.
  image = .false.
  error = .false.
  eof = .false.
  !
  ! XTENSION. May be EOF since there is nothing in FITS telling
  ! where the extension stops.
  !
  ! The code if voluntarily generous vis-a-vis FITS conforming standard
  ! FITS rule indicate 'XTENSION' should be the first keyword, but
  ! some lazy writers (specially HST) don't respect that...
  !
  comm = ' '
  k = 0
  do while (comm.ne.'XTENSION')
    call gfits_get(comm,chain,check,error,quiet=.true.,eof=eof)
    if (eof) return
    if (error) return
    k = k+1
  enddo
  !
  if (comm.ne.'XTENSION') then
    error =.true.
    call sic_message(seve%e,rname,'Misplaced Keyword: '//comm)
    call sic_message(seve%e,rname,chain)
    goto 100
  else
    if (chain(2:9).eq.'TABLE   ') then
      table=.true.
      fits_kind='TABLE   '
      call sic_message(seve%i,rname,'Reading an ASCII table')
    elseif (chain(2:9).eq.'BINTABLE') then
      bintable=.true.
      fits_kind='BINTABLE'
      call sic_message(seve%i,rname,'Reading a BINARY table')
    elseif (chain(2:9).eq.'A3DTABLE') then
      call sic_message(seve%w,rname,'Obsolete XTENSION type: '//chain(2:9))
      bintable=.true.
      fits_kind='A3DTABLE'
    elseif (chain(2:9).eq.'IMAGE') then
      image=.true.
      fits_kind='IMAGE'
      call sic_message(seve%i,rname,'Reading an IMAGE table')
    else
      call sic_message(seve%i,rname,'Skipping Invalid XTENSION type: '//  &
      chain(2:9))
      avoid =.true.
    endif
  endif
  !
  ! Treat IMAGE case in another subroutine
  if (image) then
    call fits_read_image(headofstruct,ns,global,error,eof,iext,define)
    return
  endif
  !
  !Common XTENSION decoding...
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.ne.'BITPIX') then
    goto 100
  else
    read(chain,'(I20)') intg
    if (intg.ne.8) then
      write(mess,*) 'Wrong ',fits_kind,' table BITPIX:',intg
      call sic_message(seve%e,rname,mess)
      return
    endif
    nbits = 8
  endif
  !
  !NAXIS
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.ne.'NAXIS   ') then
    goto 100
  else
    read(chain,'(I20)') intg
    if (intg.ne.2) then
      write(mess,*) 'Wrong ',fits_kind,' table NAXIS:',intg
      call sic_message(seve%e,rname,mess)
      return
    endif
  endif
  !
  !NAXIS1
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.ne.'NAXIS1  ') then
    goto 100
  else
    read(chain,'(I20)') naxis1
  endif
  !NAXIS2 = NROW
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.ne.'NAXIS2  ') then
    goto 100
  else
    read(chain,'(I20)',iostat=ier) nrows
    if (ier.ne.0) print *,'IER ',ier,comm,chain
  endif
  ! PCOUNT
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.eq.'PCOUNT  ') then
    read(chain,'(I20)',iostat=ier) pcount
    if (ier.ne.0) print *,'IER ',ier,comm,chain
    skipsz=pcount
  endif
  !
  ! If it should be ignored, ignore it...
  if (.not.define.or.avoid) then
    ! Presumably this is in Bytes to accomodate any type of data
    skipsz=naxis1*nrows+pcount   
    comm = ' '
    do while(comm.ne.'END     ')
      call gfits_get(comm,chain,check,error)
    enddo
    call gfits_flush_header(error)
    if (error) return
    !!Print *,'SKIBUF #1 ',skipsz
    call gfits_skibuf(skipsz,error)
    if (error) return
    call gfits_flush_data(error)
    return
  endif
  !
  ! GCOUNT
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.ne.'GCOUNT  ') then
    call sic_message(seve%w,rname,'XTENSION Header does not follow norm')
  endif
  ! TFIELDS
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.eq.'TFIELDS ') then
    read(chain,'(I20)') ncols
    if (ncols.gt.mcols) then
      write (mess,*) 'XTENSION has more than ',mcols,' columns, skipping it...'
      call sic_message(seve%w,rname,mess)
      skipsz=naxis1*nrows+pcount
      comm = ' '
      do while(comm.ne.'END     ')
        call gfits_get(comm,chain,check,error)
      enddo
      call gfits_flush_header(error)
      if (error) return
      !!Print *,'SKIBUF #2 ',skipsz
      call gfits_skibuf(skipsz,error)
      if (error) return
      call gfits_flush_data(error)
      return
    endif
  endif
  ! RAZ information
  do i=1,ncols
    usescal(i)=.false.
    colscal(i)=1.0
    colzero(i)=0.0
    colfmt(i)=0
    ! colnull(i)=0  ! COLNULL is still in limbo for reasons stated below.
    collabl(i)=''
    colunit(i)='UNKNOWN'
    colform(i)=''
    coldim(:,i)=0
    colndim(i)=0
  enddo
  coladdr(ncols+1)=naxis1+1    !because subtract-1 if ascii table
  !
  ! LOOP on CHAINMENTS
  ! NB: we should read the dictionary right from the beginning...
  call gfits_load_header(hdict,check,gfits_getnosymbol,error)
  if (error)  return
  call gfits_flush_header(error)
  if (error) return
  !
  ! Define the Head of Structure
  extname = fits_kind  ! As default name if EXTNAME not found
  call gfits_get_value(hdict,'EXTNAME',found,extname,error)
  if (error)  return
  ! NB: we should also account for EXTVER if available
  call sic_underscore(extname)
  call sic_upper(extname)
  struct = headofstruct(1:ns)//'%'//extname
  call fits_defstructure(struct,global,error)
  if (error) return
  nss = len_trim(struct)  ! note struct is returned with the last %
  !
  do icard=1,hdict%ncard
    key = hdict%card(icard)%key  ! > 8 because of HIERARCH translations
    chain = hdict%card(icard)%val
    !!Print *,'Key '//key//trim(chain)
    !
    if (key.eq.'EXTNAME')  cycle  ! Already parsed
    !
    if (key(1:5).eq.'TBCOL') then
      read(key(6:8),'(BN,I3.1)') i
      if (i.le.ncols) then
        read(chain,'(I20)') coladdr(i)
      endif
    elseif (key(1:4).eq.'TDIM') then
      read(key(5:8),'(BN,I4.1)') i
      if (i.le.ncols) then
        i1 = index(chain,openbrace)+1
        i2 = index(chain,closebrace)-1
        if (i2.gt.i1) then
          string = chain(i1:i2)
          i1=index(string,comma)
          j=1
          do while (i1.gt.0)
            chain=string(1:i1-1)
            read (chain,'(BN,I8.1)') coldim(j,i)
            j=j+1
            string=string(i1+1:)
            i1=index(string,comma)
            if (j.gt.4) exit
          enddo
          if (j.le.4) then
            read (string,'(BN,I8.1)') coldim(j,i)
            colndim(i)=j
          else
            call sic_message(seve%w,rname,'Array has more dimension than '//  &
            'supported, option ignored')
            do jj=1,4
              coldim(jj,i)=0
            enddo
          endif
        endif
      endif
    elseif (key(1:5).eq.'TFORM') then
      read(key(6:8),'(BN,I3.1)') i
      if (i.le.ncols) then
        i1 = index(chain,quote)+1
        i2 = index(chain(i1:),quote)-2+i1
        colform(i) = chain(i1:i2)
      endif
    elseif (key(1:5).eq.'TTYPE') then
      read(key(6:8),'(BN,I3.1)') i
      if (i.le.ncols) then
        i1 = index(chain,quote)+1
        i2 = index(chain(i1:),quote)-2+i1
        collabl(i) = chain(i1:i2)
        call sic_underscore(collabl(i))
        call sic_upper(collabl(i))
      endif
    elseif (key(1:5).eq.'TUNIT') then
      read(key(6:8),'(BN,I3.1)') i
      if (i.le.ncols) then
        i1 = index(chain,quote)+1
        i2 = index(chain(i1:),quote)-2+i1
        colunit(i) = chain(i1:i2)
        call sic_upper(colunit(i))
      endif
    elseif (key(1:5).eq.'TSCAL') then
      read(key(6:8),'(BN,I3.1)') i
      if (i.le.ncols) then
        usescal(i)=.true.
        read(chain,'(F20.0)') colscal(i)
      endif
    elseif (key(1:5).eq.'TZERO') then
      read(key(6:8),'(BN,I3.1)') i
      if (i.le.ncols) then
        usescal(i)=.true.
        read(chain,'(F20.0)') colzero(i)
      endif
      ! TNULLnnn is a Character Array for ASCII Tables. It is also an INTEGER
      ! Value for Integer entries in a BINARY table (since NaNs are THE "blanked"
      ! values for floating-point entries). I do not see how to handle that in a
      ! general way. I choose to IGNORE NULL VALUES, and check the rare
      ! formatted-read error whenever appropriate. People will have to handle
      ! the rare integer blanked values by themselves at the interpreter's math
      ! level. Signed: Gilles.
      !         ELSEIF (key(1:5).EQ.'TNULL') THEN
      !            READ(key(6:8),'(BN,I3.1)') I
      !            IF (I.LE.NCOLS) THEN
      !               I1 = INDEX(CHAIN,quote)+1
      !               I2 = INDEX(CHAIN(I1:),quote)-2+I1
      !               READ(CHAIN(I1:I2),'(F20.0)',IOSTAT=I1) COLNULL(I)
      !            ENDIF
    elseif (count.lt.mxcount) then   !SG
      ! Define all other FITS keywords
      call sic_underscore(key)
      name = struct(1:nss)//key
      call fits_sicvariable(name,chain,global)
      count = count+1
    endif
  enddo
  ! Decode recently read parameters:
  if (table) then
    !!!    Print *,'FITS_DECODE_PAR '
    call fits_decode_par(error)
  else
    !!    Print *,'Calling fits_decode_binpar'
    call fits_decode_binpar(error)
  endif
  if (error) then
    call sic_message(seve%e,rname,'Error decoding binary table parameters')
    return
  endif
  !!Print *,'Done '
  !
  ! Define Corresponding sic variables
  !!Print *,'FITS_DEFVARIABLE '
  call fits_defvariable(struct,nrows,global,error)
  if (error) then
    call sic_message(seve%e,rname,'Error defining SIC variable(s)')
    ! Skip all the data block
    skipsz=naxis1*nrows+pcount
    !!Print *,'SKIBUF #3 ',skipsz
    call gfits_skibuf(skipsz,error)
    call gfits_flush_data(error)
    return
  endif
  !
  ! SKIP extension data
  if (skipsz.gt.0) then
    !!Print *,'SKIBUF #4 ',skipsz
    call gfits_skibuf(skipsz,error)
    if (error) return
  endif
  ! Decode and fill the (now defined) variables
  !!Print *,'FITS_READVARIABLE '
  call fits_readvariable(error,naxis1,nrows,bintable)
  !
  if (error) then
    ! we should destroy the variables...
    call sic_message(seve%e,rname,'Error in readvariable')
  endif
  ! Flush last buffer,return
  call gfits_flush_data(error)
  return                       ! with ERROR or not...
100 call sic_message(seve%e,rname,'Error reading extension...')
  call gfits_flush_data(error)
  error = .true.
  return
end subroutine fits_read_extension
!
subroutine fits_read_image(head,ns,global,error,eof,iext,define)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fits_read_image
  use sic_bintable
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS
  !     Support routine for XTENSION of type IMAGE
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: head          !  Structure name
  integer, intent(in) :: ns                     !  Length of name
  logical, intent(in) :: global                 !  Global status
  logical, intent(out) :: error                 !  Error flag
  logical, intent(out) :: eof                   !  End of File indicator
  integer, intent(in) :: iext                   !  Extension number
  logical, intent(in) :: define                 !  Define or skip variables ?
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=8) :: comm,strname
  character(len=70) :: chain
  character(len=64) :: subhead
  character(len=1) :: quote
  logical :: check
  integer :: i,ii,n,nss
  integer :: intg,nbits,pcount,gcount,ndim
  integer(kind=index_length) :: dim(sic_maxdims)
  integer :: fmt
  integer(kind=size_length) :: mainsiz, nsize
  logical :: data,extend,supported
  character(len=message_length) :: mess
  ! Data
  data quote/''''/
  !
  data   = .true.              ! Should be in Call Sequence
  !
  ! Treat IMAGE case in another subroutine
  check = .false.              ! for READ
  error = .false.
  eof = .false.
  write(strname,'(A,I4)') 'IMAG',iext
  n = 8
  call sic_black(strname,n)
  !
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.ne.'BITPIX') then
    goto 100
  else
    read(chain,'(I20)') intg
    if (intg.eq.8) then
      fmt = fmt_by
    elseif  (intg.eq.16) then
      fmt = eei_i2
    elseif  (intg.eq.32) then
      fmt = eei_i4
    elseif  (intg.eq.-32) then
      fmt = eei_r4
    elseif  (intg.eq.-64) then
      fmt = eei_r8
    else
      write(mess,*) 'Unsupported word size: ',intg
      call sic_message(seve%e,rname,mess)
      goto 100
    endif
    nbits = intg
  endif
  !
  !NAXIS
  supported=.true.
  mainsiz = 1
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.ne.'NAXIS   ') then
    goto 100
  else
    read(chain,'(I20)') intg
    ndim = intg
    if (intg.eq.0) then
      call sic_message(seve%w,rname,'No image data')
      mainsiz = 0
      supported=.false.
    elseif  (intg.lt.2.or.intg.gt.4) then
      write(mess,*) 'Skipping Wrong or Unsupported IMAGE NAXIS:',intg
      call sic_message(seve%e,rname,mess)
      supported=.false.
    endif
  endif
  !
  do i=1,ndim
    call gfits_get(comm,chain,check,error)
    if (error) return
    if (comm(1:5).ne.'NAXIS') then
      goto 100
    else
      read(comm(6:6),'(I1.1)') ii
      read(chain,'(I20)') intg
      mainsiz = mainsiz*intg
      if (ii.le.sic_maxdims) then
        dim(ii)=intg
      else
        supported=.false.
      endif
    endif
  enddo
  ! PCOUNT
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.eq.'PCOUNT  ') then
    read(chain,'(I20)') pcount
    if (pcount.ne.0) then
      call sic_message(seve%w,rname,'IMAGE with non 0 PCOUNT')
      goto 100
    endif
  endif
  ! GCOUNT
  call gfits_get(comm,chain,check,error)
  if (error) return
  if (comm.ne.'GCOUNT  ') then
    call sic_message(seve%w,rname,'XTENSION Header does not follow norm')
  else
    read(chain,'(I20)') gcount
    if (gcount.ne.1) then
      call sic_message(seve%w,rname,'IMAGE with non 1 GCOUNT')
      goto 100
    endif
  endif
  !
  ! Define structure of name extname
  nsize = mainsiz                     ! Size in Real*4 words
  mainsiz = mainsiz*abs(nbits/8)      ! Size in Bytes in FITS file
  !
  if (define.and.supported) then
    subhead = head(1:ns)//'%'//strname
    nss = len_trim(subhead)
    call sic_message(seve%i,rname,'Defining Structure ... '//subhead(1:nss))
    call sic_crestructure(subhead,global,error)
    !
    ! re-use the "normal" header routine
    data  = .true.             ! Read the data ?
    call fits_read_basic(subhead,nss,global,fmt,nsize,ndim,dim,error,extend,  &
    0,data,mainsiz)
  else
    !
    ! Just skip
    call sic_message(seve%w,rname,'Skipping extension')
    comm = ' '
    do while(comm.ne.'END     ')
      call gfits_get(comm,chain,check,error)
    enddo
    call gfits_flush_header(error)
    if (error) return
    !!Print *,'SKIBUF #5 ',mainsiz 
    ! Size is definitely in Bytes here
    call gfits_skibuf(mainsiz,error)
    if (error) return
    call gfits_flush_data(error)
  endif
  return                       ! with ERROR or not...
  !
100 call sic_message(seve%e,rname,'Error reading extension...')
  call gfits_flush_data(error)
  error = .true.
  return
end subroutine fits_read_image
!
subroutine fits_readvariable(error,bufsize,nrows,btabl)
  use sic_interfaces
  use gildas_def
  use sic_dependencies_interfaces
  use sic_bintable
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! SIC\DEFINE FITS command
  !   Repeatedly fills all the defined variables by reading the
  !   Table's lines and decoding the Arguments.
  !   Multiply by  Scaling and Zero, Check Blanked values
  !---------------------------------------------------------------------
  logical,                   intent(out) :: error    ! Error flag
  integer(kind=size_length), intent(in)  :: bufsize  ! Number of bytes
  integer,                   intent(in)  :: nrows    ! Number of rows
  logical,                   intent(in)  :: btabl    ! Binary table indicator
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer :: i,j
  !
  ! Automatic array
  integer(kind=1) :: buf(bufsize)
  !
  character(len=1024) :: cbuf
  integer(kind=address_length) :: ic,tmpaddr(mcols)  ! Address of variable got by SIC_GETVM
  integer :: istart,iend
  real :: notanum
  !
  error = .false.
  call gag_notanum(notanum)
  !
  ! Convert VMADDR (absolute addresses) to offset in array MEMBYT
  ! (solves alignment problems)
  do j=1,ncols
    tmpaddr(j)=bytpnt(vmaddr(j),membyt)
  enddo
  !
  ! LOOP on rows
  do i=1,nrows
    call gfits_getbuf(buf,bufsize,error)
    if (error) then
      call sic_message(seve%e,'READ','Error Reading FITS file')
      return
    endif
    do j=1,ncols
      if (btabl) then
        !! if (i.eq.1) !!Print *,i,'tmp J ',j,' addr ',tmpaddr(j),' Nitem ',nitem(j),' Format ',varformat(j) &
        !!  ,'Column ',coladdr(j),' Format ',colfmt(j)
        call get_btable_item (membyt(tmpaddr(j)),nitem(j),varformat(j),  &
        &   buf(coladdr(j)),colfmt(j),error,i)
        if (error) then
          write (*,'(A)') '         for variable '//collabl(j)
          error = .false.
        endif
      else
        istart = coladdr(j)
        iend = coladdr(j+1)-1
        ic = bytpnt(locstr(cbuf),membyt)
        call bytoby(buf,membyt(ic),iend)
        call get_table_item(membyt(tmpaddr(j)),varformat(j),cbuf, &
        istart,iend,colform(j),notanum,error)
      endif
      if (error) goto 99
      ! increment offset in array:
      if (varformat(j).gt.0) then
        tmpaddr(j)=tmpaddr(j)+varformat(j)*nitem(j)
      elseif (varformat(j).eq.fmt_r8 .or.  &
              varformat(j).eq.fmt_c4 .or.  &
              varformat(j).eq.fmt_i8) then
        tmpaddr(j)=tmpaddr(j)+8*nitem(j)
      elseif (varformat(j).eq.fmt_c8) then
        tmpaddr(j)=tmpaddr(j)+8*nitem(j)
      else
        ! Rest is converted in reals or integers...
        tmpaddr(j)=tmpaddr(j)+4*nitem(j)
      endif
    enddo
  enddo
  ! Offset, Blanking and Scaling If needed:
  do j=1,ncols
    if (usescal(j)) then
      tmpaddr(j)= gag_pointer(vmaddr(j),memory)
      if (varformat(j).eq.fmt_r8) then
        call scale_table8(memory(tmpaddr(j)),nrows*nitem(j),colscal(j),  &
        colzero(j))
      elseif (varformat(j).eq.fmt_r4) then
        call scale_table4(memory(tmpaddr(j)),nrows*nitem(j),colscal(j),  &
        colzero(j))
      endif
    endif
  enddo
  ! Transpose multi-dimensional arrays (because usually we prefer to have
  ! nrows as 1st dimension for them)
  if (transposevar) then
    do j=1,ncols
      if (nitem(j).gt.1) then
        tmpaddr(j)= gag_pointer(vmaddr(j),memory)
        if (varformat(j).eq.fmt_r8 .or. varformat(j).eq.fmt_c4) then
          call transpose_table8(memory(tmpaddr(j)),nitem(j),nrows)
        elseif (varformat(j).eq.fmt_c8) then
          call transpose_tablec8(memory(tmpaddr(j)),nitem(j),nrows)
        elseif (varformat(j).eq.fmt_r4 .or. varformat(j).eq.fmt_i4.or.  &
                varformat(j).eq.fmt_l) then
          call transpose_table4(memory(tmpaddr(j)),nitem(j),nrows)
        endif
      endif
    enddo
  endif
  return
  !
99 error=.true.
  return
end subroutine fits_readvariable
!
subroutine get_btable_item(item,nitem,fmtout,buffer,fmtin,error,jrow)
  use sic_interfaces, except_this=>get_btable_item
  use gbl_message
  use gbl_format
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  ! Transfers (and translate) a data vector from BINTABLE row.
  !---------------------------------------------------------------------
  integer(kind=1), intent(out)   :: item(*)    ! Requested information
  integer(kind=4), intent(in)    :: nitem      ! Number of requested items
  integer(kind=4), intent(in)    :: fmtout     ! Format for requested items
  integer(kind=1), intent(in)    :: buffer(*)  ! Row buffer
  integer(kind=4), intent(in)    :: fmtin      ! Format of data in buffer
  logical,         intent(inout) :: error      ! Error flag
  integer(kind=4), intent(in)    :: jrow       ! Row number
  !
  integer, external :: gdf_conv
  ! Local
  character(len=*), parameter :: rname='READ'
  integer :: fmt
  integer :: i
  real(8) :: r8buf(2)              !extra space for Double Complex...
  integer(4) :: mybuf(4)           !
  equivalence (mybuf,r8buf)        ! To force alignment and memory location
  real(4) :: reel(2)               !extra real for Complex...
  real(8) :: double(2)
  integer(4) :: onebuf(4)
  equivalence (onebuf,reel)
  equivalence (onebuf,double)
  !
  integer :: status,n
  logical :: log
  integer(8) :: inbuf, oubuf
  integer(4) :: i4
  integer(2) :: i2
  character(len=80) :: chain
  equivalence (i2,mybuf)
  !
  ! First convert from IEEE format to corresponding local format. Force R8 TO I2
  ! alignment in the process to avoid later problems on HPs, SUNs and ALPHAs
  !
  ! All FMTIN must be checked against the EEI_j formats (our "normal" IEEE)
  if (fmtin.gt.0) then
    if (fmtout.gt.0) then
      n = nitem*fmtin
      if (error) return
      call bytoby(buffer,item,n)
    else
      call sic_message(seve%e,rname,'Invalid conversion CHAR')
      goto 99
    endif
  elseif (fmtin.eq.eei_i4) then
    if (fmtout.eq.eei_i4) then !direct no conversion
      call bytoby(buffer,item,4*nitem)
    else
      fmt = fmt_i4
      if (fmt.eq.iee_i4) then
        do i=1,nitem
          n=4*(i-1)+1
          call bytoby(buffer(n),mybuf,4)
          call eii4ie(mybuf,item(n),1)
        enddo
      elseif (fmt.eq.vax_i4) then
        do i=1,nitem
          n=4*(i-1)+1
          call bytoby(buffer(n),mybuf,4)
          call eii4va(mybuf,item(n),1)
        enddo
      else
        call sic_message(seve%e,rname,'Invalid conversion I4')
        goto 99
      endif
    endif
  elseif (fmtin.eq.fmt_by) then
    if (fmtout.eq.fmt_by) then
      call bytoby(buffer,item,nitem)
    elseif (fmtout.eq.fmt_i4) then
      do i=1,nitem
        i4=buffer(i)
        n=4*(i-1)+1
        call i4toi4(i4,item(n),1)
      enddo
    elseif (fmtout.eq.fmt_i2) then
      do i=1,nitem
        i2=buffer(i)
        n=2*(i-1)+1
        call bytoby(i2,item(n),2)
      enddo
    else
      call sic_message(seve%e,rname,'Invalid conversion BY')
      goto 99
    endif
  elseif (fmtin.eq.eei_i2) then
    if (fmtout.eq.eei_i2) then
      call bytoby(buffer,item,2*nitem)
    else                       !provide conversion to I4 also
      fmt=fmt_i2
      do i=1,nitem
        n=2*(i-1)+1
        if (fmt.eq.iee_i2) then
          call bytoby(buffer(n),mybuf,2)
          call eii2ie(mybuf,mybuf,1)
        elseif (fmt.eq.eei_i2) then
          call bytoby(buffer(n),mybuf,2)
        elseif (fmt.eq.vax_i2) then
          call bytoby(buffer(n),mybuf,2)
          call eii2va(mybuf,mybuf,1)
        else
          call sic_message(seve%e,rname,'Invalid conversion code')
          goto 99
        endif
        if (fmtout.eq.fmt_i2) then
          n=2*(i-1)+1
          call bytoby(mybuf,item(n),2)
        elseif (fmtout.eq.fmt_i4) then
          n=4*(i-1)+1
          call i2toi4(mybuf,item(n),1)
        elseif (fmtout.eq.fmt_r4) then
          n=4*(i-1)+1
          call i2tor4(mybuf,item(n),1)
        elseif (fmtout.eq.fmt_r8) then
          n=8*(i-1)+1
          call i2tor8(mybuf,item(n),1)
        else
          call sic_message(seve%e,rname,'Conversion not supported')
          goto 99
        endif
      enddo
    endif
  elseif (fmtin.eq.eei_i8) then
    if (fmtout.eq.eei_i8) then ! direct no conversion
      !!Print *,'I8 no conversion ',nitem
      call bytoby(buffer,item,8*nitem)
    else
      !!Print *,'I8 with conversion ',nitem
      fmt = fmt_i8
      if (fmt.eq.iee_i8) then
        do i=1,nitem
          n=8*(i-1)+1
          call bytoby(buffer(n),inbuf,8)
          call eii8ie(inbuf,oubuf,1)
          call bytoby(oubuf,item(n),8)
        enddo
      else
        call sic_message(seve%e,rname,'Invalid conversion I8')
        goto 99
      endif
    endif
  elseif (fmtin.eq.eei_l) then
    if (fmtout.eq.fmt_l) then
      do i=1,nitem
        if (buffer(i).eq.ichar('T')) then
          log = .true.
          n=4*(i-1)+1
          call l4tol4(log,item(n),1)
        elseif (buffer(i).eq.ichar('F') .or. buffer(i).eq.ichar('U')) then
          log = .false.
          n=4*(i-1)+1
          call l4tol4(log,item(n),1)
        else
          write(chain,1001) buffer(i)
          call sic_message(seve%e,rname,chain)
          goto 99
        endif
      enddo
    elseif (fmtout.eq.fmt_i4) then
      do i=1,nitem
        if (buffer(i).eq.ichar('T')) then
          i4 = 1
          n=4*(i-1)+1
          call i4toi4(i4,item(n),1)
        elseif (buffer(i).eq.ichar('F') .or. buffer(i).eq.ichar('U')) then
          i4 = 0
          n=4*(i-1)+1
          call i4toi4(i4,item(n),1)
        else
          chain = 'Invalid value for logical. Must be T or F or U.'
          call sic_message(seve%e,rname,chain)
          goto 99
        endif
      enddo
    elseif (fmtout.eq.fmt_i2) then
      do i=1,nitem
        if (buffer(i).eq.ichar('T')) then
          i2 = 1
          n=2*(i-1)+1
          call bytoby(i2,item(n),2)
        elseif (buffer(i).eq.ichar('F') .or. buffer(i).eq.ichar('U')) then
          i2 = 0
          n=2*(i-1)+1
          call bytoby(i2,item(n),2)
        else
          chain = 'Invalid value for logical. Must be T or F or U.'
          call sic_message(seve%e,rname,chain)
          goto 99
        endif
      enddo
    else
      call sic_message(seve%e,rname,'Invalid conversion of Logical')
      goto 99
    endif
  elseif (fmtin.eq.eei_r4) then
    if (fmtout.eq.eei_r4) then
      call bytoby(buffer,item,4*nitem)
    else
      fmt = fmt_r4
      do i=1,nitem
        n=4*(i-1)+1
        call bytoby(buffer(n),mybuf,4)
        status = gdf_conv(mybuf,onebuf,1,fmt_r4,eei_r4)
        if (status.ne.1) then
          call sic_message(seve%e,rname,'Invalid conversion in GDF_CONV,R4')
          goto 99
        endif
        if (fmtout.eq.fmt_i4) then
          n=4*(i-1)+1
          call r4toi4_fini(reel,item(n),1,error)
        elseif (fmtout.eq.fmt_r4) then
          n=4*(i-1)+1
          call r4tor4(reel,item(n),1)
        elseif (fmtout.eq.fmt_r8) then
          n=8*(i-1)+1
          call r4tor8(reel,item(n),1)
        else
          call sic_message(seve%e,rname,'Conversion not supported')
          error = .true.
        endif
        if (error)  goto 99
      enddo
    endif
  elseif (fmtin.eq.eei_r8) then
    if (fmtout.eq.eei_r8) then
      call bytoby(buffer,item,8*nitem)
    else
      fmt = fmt_r8
      do i=1,nitem
        n=8*(i-1)+1
        call bytoby(buffer(n),mybuf,8)
        status = gdf_conv(mybuf,onebuf,1*2,fmt_r8,eei_r8)
        if (status.ne.1) then
          call sic_message(seve%e,rname,'Invalid conversion in GDF_CONV,R8')
          goto 99
        endif
        if (fmtout.eq.fmt_i4) then
          n=4*(i-1)+1
          call r8toi4_fini(double,item(n),1,error)
        elseif (fmtout.eq.fmt_r4) then
          n=4*(i-1)+1
          call r8tor4(double,item(n),1)
        elseif (fmtout.eq.fmt_r8) then
          n=8*(i-1)+1
          call r8tor8(double,item(n),1)
        else
          call sic_message(seve%e,rname,'Conversion not supported')
          error = .true.
        endif
        if (error)  goto 99
      enddo
    endif
  elseif (fmtin.eq.eei_c4) then
    if (fmtout.eq.eei_c4) then
      call bytoby(buffer,item,8*nitem)
    else
      fmt = fmt_c4
      do i=1,nitem
        n=8*(i-1)+1
        call bytoby(buffer(n),mybuf,8)
        status = gdf_conv(mybuf,onebuf,2*1,fmt_r4,eei_r4)
        if (status.ne.1) then
          call sic_message(seve%e,rname,'Invalid conversion in GDF_CONV,C4')
          goto 99
        endif
        if (fmtout.eq.fmt_c4) then
          n=8*(i-1)+1
          call c4toc4(reel,item(n),1)
        elseif (fmtout.eq.fmt_c8) then
          n=16*(i-1)+1
          call r4tor8(reel,item(n),2)
        else
          call sic_message(seve%e,rname,'Conversion not supported')
          goto 99
        endif
      enddo
    endif
  elseif (fmtin.eq.eei_c8) then
    if (fmtout.eq.eei_c8) then
      call bytoby(buffer,item,16*nitem)
    else
      fmt = fmt_c8
      do i=1,nitem
        n=16*(i-1)+1
        call bytoby(buffer(n),mybuf,16)
        status = gdf_conv(mybuf,onebuf,2*2,fmt_r8,eei_r8)
        if (status.ne.1) then
          call sic_message(seve%e,rname,'Invalid conversion in GDF_CONV,C8')
          goto 99
        endif
        if (fmtout.eq.fmt_c8) then
          n=16*(i-1)+1
          call r8tor8(double,item(n),2)
        elseif (fmtout.eq.fmt_c4) then
          n=8*(i-1)+1
          call r8tor4(double,item(n),2)
        else
          call sic_message(seve%e,rname,'Conversion not supported')
          goto 99
        endif
      enddo
    endif
  elseif (fmtin.eq.0) then
    continue
  else
    if (jrow.eq.1) then
      write(chain,1000) fmtin,fmtout
      call sic_message(seve%w,rname,chain)
      goto 99
    endif
  endif
  error = .false.
  return
  !
99 error = .true.
  return
  !
1000 format('Unsupported format in BINARY table:',i6,i6)
1001 format('Invalid value for logical. (',i1.1,') Must be T, F, or U.')
end subroutine get_btable_item
!
subroutine get_table_item(item,fmtout,line,i,j,fmt,blank,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>get_table_item
  use gildas_def
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Transfers (and translate) a data vector from TABLE row.
  !---------------------------------------------------------------------
  integer(kind=1), intent(out) :: item(*)       ! Requested information
  integer, intent(in) :: fmtout                 ! Output Format
  character(len=*), intent(in) :: line          ! Row buffer
  integer, intent(in) :: i                      ! Start position
  integer, intent(in) :: j                      ! End position
  character(len=12), intent(in) :: fmt          ! Input format
  real, intent(in) :: blank                     ! Blanking value
  logical, intent(inout) :: error               ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='READ'
  ! (Not a) number for blanked (and unreadable) values.
  ! We use it as blanked value for undecipherable Reals, since FITS TABLE
  ! extension defines a blanked value as ascii text, which could be unreadable.
  real(8) :: dblnk
  integer :: ier
  character(len=80) :: chain
  real(4) :: r4
  integer(4) :: i4
  integer(2) :: i2
  real(8) :: r8
  logical :: log
  integer(kind=address_length) :: il
  !
  dblnk=blank
  !
  ier = 0
  if (fmtout.gt.0) then
    il = bytpnt(locstr(line),membyt)
    call bytoby(membyt(il+i-1),item,fmtout)
  elseif (fmtout.eq.fmt_by) then
    il = bytpnt(locstr(line),membyt)
    call bytoby(membyt(il+i-1),item,1)
  elseif (fmtout.eq.fmt_i4) then
    read (line(i:j),fmt=fmt,iostat=ier) i4
    if (ier.ne.0) then
      call i4toi4(i4,item,1)
      ier = 0
    endif
  elseif (fmtout.eq.fmt_i2) then
    read (line(i:j),fmt=fmt,iostat=ier) i2
    if (ier.ne.0) then
      call bytoby(i2,item,2)
      ier = 0
    endif
  elseif (fmtout.eq.fmt_r4) then
    read (line(i:j),fmt=fmt,iostat=ier) r4
    if (ier.ne.0) then
      call r4tor4(blank,item,1)
      ier = 0
    else
      call r4tor4(r4,item,1)
    endif
  elseif (fmtout.eq.fmt_r8) then
    read (line(i:j),fmt=fmt,iostat=ier) r8
    if (ier.ne.0) then
      call r8tor8(dblnk,item,1)
      ier = 0
    else
      call r8tor8(r8,item,1)
    endif
  elseif (fmtout.eq.fmt_l) then
    read (line(i:j),fmt=fmt,iostat=ier) log
    if (ier.eq.0) then
      call l4tol4(log,item,1)
    else
      ier = 0
    endif
  else
    write(chain,1000) fmtout
    call sic_message(seve%e,rname,chain)
    error = .true.
    return
  endif
  if (ier.ne.0) then
    write(chain,999) fmt
    call sic_message(seve%e,rname,chain)
    call putios('E-READ,  ',ier)
    error =.true.
  endif
  return
  !
999 format('Unable to decode format: "',a,'"')
1000 format('Unsupported format in ASCII table:',a)
end subroutine get_table_item
!
subroutine fits_defstructure(strname,global,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fits_defstructure
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Define a new Structure, with an unambiguous name/version
  !---------------------------------------------------------------------
  character(len=*)                :: strname  !
  logical                         :: global   !
  logical,          intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer :: np,i,nn
  logical :: quiet
  character(len=80) :: name
  !
  ! Define structure of name extname
  quiet = sic_quiet
  sic_quiet = .true.
  name = strname
  np = len_trim(name)
  call sic_black(strname,np)
  call sic_underscore(strname)
  np = np+1
  call sic_crestructure(name,global,error)
  i = 0
  do while (error)
    i = i+1
    write(name(np:),'(''_'',I3)') i ! Don't put a dot here
    nn = len_trim(name)
    call sic_black(name,nn)
    call sic_crestructure(name,global,error)
    if (i.eq.100.and.error) then
      call sic_message(seve%e,rname,'Too many extensions, aborting')
      sic_quiet = quiet
      error = .true.
      return
    endif
  enddo
  sic_quiet = quiet
  nn = len_trim(name)+1
  name(nn:) = '%'
  if(i.gt.0)then
    call sic_message(seve%i,rname,'Defined Structure '//name(1:nn)//  &
    ' (new version)')
  else
    call sic_message(seve%i,rname,'Defined Structure ... '//name(1:nn))
  endif
  !
  ! Return the name, with the % included ...
  strname = name
end subroutine fits_defstructure
!
subroutine fits_defvariable(strname,nrows,global,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_bintable
  use sic_interfaces, except_this=>fits_defvariable
  use sic_structures
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   This version passes a character description of the variable
  !   to the generic SIC function SIC_DEFVARIABLE.
  !   This solves problems of allocation and character arrays
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: strname  ! Structure name
  integer,          intent(in)    :: nrows    ! Number of rows
  logical,          intent(in)    :: global   ! Global flag
  logical,          intent(inout) :: error    ! Error flag
  ! Local
  character(len=256) :: name
  integer :: ndim,i,j
  integer(kind=index_length) :: dim(sic_maxdims)
  integer :: nn,np,nnn, kk
  logical :: found
  !
  type(sic_descriptor_t) :: desc
  !
  ! Prepare variable names...
  name = strname
  nn = len_trim(name)+1
  name(nn:) = 'COL%'
  nn = nn+4
  call sic_crestructure (name(1:nn-1),global,error)
  if (error) return
  !
  do i=1,ncols
    ! Zero DIM to default value
    dim(:) = 0
    dim(1) = nrows
    ndim = 0
    if (dim(1).gt.1) ndim=1
    !
    ! Variable Name.
    if (len_trim(collabl(i)).eq.0) write (collabl(i),'(I6)') i
    name(nn:)=collabl(i)
    np = len_trim(name)
    !
    ! break loop (do not define variable) if NITEM=0, i.e., the column
    ! was a zero-size array:
    if (nitem(i).le.0) cycle
    !
    ! Variable size & transposition
    if (nitem(i).gt.1) then
      if (transposevar) then
        if (dim(1).gt.1) then
          ndim=2
          dim(2)=nitem(i)
        else
          ndim=1
          dim(1)=nitem(i)
        endif
        !!Print *,'Transpose ',i,ndim,dim(1:2)
      else
        if (dim(1).gt.1) then
          ndim=2
          dim(2)=dim(1)
          dim(1)=nitem(i)
        else
          ndim=1
          dim(1)=nitem(i)
        endif
        !!Print *,'Direct ',i,ndim,dim(1:2)
      endif
    endif
    !
    ! Possible multidimensional TDIMnn supplementary info:
    ! - Reshape 1-D arrays to other form
    if (colndim(i).gt.0) then
      !!Print *,'Before Colndim ',ndim,dim(1:ndim)
      !!Print *,'Colndim ',colndim(i),' nitem ',nitem(i), ' colfmt ',colfmt(i)
      !
      ! SG Character arrays are a little special ? May be not
      ! but I have not yet seen  a repeat count in other types.
      !
      if (colfmt(i).gt.0) then
        ! - Behaviour is different for Character strings than other
        !   arrays, because a N-element "byte" array  in FITS is a
        !   character*n string in SIC
        !
        ! - The *n is stored in colfmt, not in nitem for characters...
        kk = 1
        do j = 1,colndim(i)
          kk = kk*coldim(j,i)
        enddo
        if (kk.ne.colfmt(i)) then
          Print *,'Mismatch between TFORM ',colfmt(i),' and TDIM ',kk
        else if (transposevar.and.colndim(i).eq.2) then
          ! here the Nitem would be coldim(2,i), and the dimensions
          ! but I am not sure what sense this has...
          ! Can we transpose such items ?????
          colfmt(i) = coldim(2,i)
          ndim = colndim(i)
          dim(2) = dim(1)
          dim(1) = coldim(1,i)
        else
          ! here the Nitem would be coldim(1,i), and the dimensions
          colfmt(i) = coldim(1,i)
          ndim = colndim(i)
          dim(ndim) = dim(1)
          do j=2,ndim
            dim(j) = coldim(j,i)
          enddo
        endif
      else
        ! I am not convinced this is correct. I think
        ! in this case, a dimension should be added in all cases.
        if (transposevar.and.ndim.eq.2) then
          ndim=1+colndim(i)
          do j=1,colndim(i)
            dim(j+1)=coldim(j,i)
          enddo
        else
          if (ndim.eq.2) then
            ndim=1+colndim(i)
            dim(ndim)=dim(2)
            do j=1,colndim(i)
              dim(j)=coldim(j,i)
            enddo
          else
            ndim=colndim(i)
            do j=1,ndim
              dim(j)=coldim(j,i)
            enddo
          endif
        endif
      endif
      !!Print *,'After Colndim ',ndim,dim(1:ndim)
    endif
    ! The variable type:
    if (colfmt(i).eq.eei_r8) then
      varformat(i)=fmt_r8
    elseif (colfmt(i).eq.eei_c8) then
      !            VARFORMAT(I)=FMT_C8
      varformat(i)=fmt_c4      !SIC does not handle correctly C8
    elseif (colfmt(i).eq.eei_r4) then
      varformat(i)=fmt_r4
    elseif (colfmt(i).eq.eei_c4) then
      varformat(i)=fmt_c4
    elseif (colfmt(i).eq.eei_i4) then
      varformat(i)=fmt_i4
    elseif (colfmt(i).eq.eei_i8) then
      varformat(i)=fmt_i8
    elseif (colfmt(i).eq.eei_i2) then
      varformat(i)=fmt_i4
    elseif (colfmt(i).eq.eei_l) then
      varformat(i)=fmt_l
    elseif (colfmt(i).eq.fmt_by) then
      varformat(i)=fmt_i4
    elseif (colfmt(i).gt.0) then
      varformat(i)=colfmt(i)
    else                       ! This if for the '1Px(nnn)' variable type
      varformat(i) = fmt_i4
    endif
    !
    !!         IF (COLFMT(I).NE.0) THEN
    ! Encode variable characteristics in NAME, pass to SIC, get back
    ! address
    !
    if (ndim.eq.0) then
      nnn=np
    else
      !! Print *,'Nrow ',nrows,' Dims ',ndim,dim(1:ndim)
      name(np+1:np+1) = '['
      write(name(np+2:),"(7(I12,','))") (dim(j),j=1,ndim)
      nnn = len_trim(name)
      name(nnn:nnn) = ']'
      call sic_black(name,nnn)
    endif
    !
    !! Print *,'defining ',i, varformat(i),trim(name)
    call sic_defvariable(varformat(i),name,global,error)
    if (error) then
      call sic_message(seve%e,'FITS','Error defining '//name(1:nnn))
      goto 99
    endif
    ! Retrieve Pointer, store address
    call sic_descriptor(name(1:np),desc,found)
    if (.not.found) then
      call sic_message(seve%e,'READ','invalid descriptor ?')
      goto 99
    endif
    call adtoad(desc%addr,vmaddr(i),1)
    if (colfmt(i).eq.0) then
      call sic_message(seve%w,'FITS','Data pointer ignored')
    endif
  enddo
  return
  !
99 error=.true.
  return
end subroutine fits_defvariable
!
subroutine fits_decode_binpar(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fits_decode_binpar
  use sic_bintable
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Try to decode the column description (for binary tables).
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer :: i,j,m,n,k,length
  character(len=20) :: format
  character(len=message_length) :: mess
  !
  !Print *,'Into fits_decode_binpar'
  coladdr(1) = 1
  !
  ! Decode FITS format of each column into a length, a repeat count and
  ! a SIC format code.
  do i=1,ncols
    format = colform(i)
    n = len(format)
    call sic_black(format,n)
    if (n.eq.0) then
      write(mess,'(A,I0)') 'Format not specified for column ',i
      call sic_message(seve%e,rname,mess)
      call sic_message(seve%e,rname,  &
        'Unable to determine alignment of further columns')
      error = .true.
      return
    endif
    !
    ! Test about strange things like 1PE(1024)
    ! M is normally the first non numeric character index
    j = 1
    m = 0
    do while (m.eq.0)
      k = ichar(format(j:j))
      if (k.lt.ichar('0') .or. k.gt.ichar('9')) then
        m = j
      else
        j = j+1
      endif
    enddo
    !Print *,'Row ',i,m,format
    m = m-1
    if (m.gt.0) then
      read(format(1:m),*,err=10) nitem(i)
      if (nitem(i).le.0) then  ! protect for zerolength array
        length = 0
        colfmt(i) = 0
        goto 33
      endif
    else
      nitem(i) = 1
    endif
    !
    n = m+1
    select case (format(n:n))
    case ('A')  ! Ascii chain
      length = nitem(i)
      colfmt(i) = nitem(i)
      nitem(i) = 1
    case ('D')  ! Real*8
      length = nitem(i)*8
      colfmt(i) = eei_r8
    case ('E')  ! Real*4
      length = nitem(i)*4
      colfmt(i) = eei_r4
    case ('K')  ! Integer*8
      length = nitem(i)*8
      colfmt(i) = eei_i8
    case ('J')  ! Integer*4
      length = nitem(i)*4
      colfmt(i) = eei_i4
    case ('I')  ! Integer*2
      length = nitem(i)*2
      colfmt(i) = eei_i2
    case ('L')  ! Logical = one character 'T' or 'F'
      length = nitem(i)
      colfmt(i) = eei_l
    case ('B')  ! Byte
      length = nitem(i)
      colfmt(i) = fmt_by
    case ('X')  ! Bit Field (imagine that!)
      length = (nitem(i)+7)/8
      colfmt(i) = length
      nitem(i) = 1
    case ('M')  ! Complex*8
      length = nitem(i)*16
      colfmt(i) = eei_c8
    case ('C')  ! Complex*4
      length = nitem(i)*8
      colfmt(i) = eei_c4
    case ('P')  ! Pointer to variable array
      length = 4
      colfmt(i) = 0            ! TEST
      nitem = 2
    case default
      write(mess,'(A,A,A,I0)') 'Unsupported format ',format(1:n),' in column ',i
      call sic_message(seve%e,rname,mess)
      call sic_message(seve%e,rname,  &
        'Unable to determine alignment of further columns')
      error = .true.
      return
    end select
33  coladdr(i+1) = coladdr(i)+length
  enddo
  !
  return
  !
10 call sic_message(seve%e,rname,'Error decoding '//format)
  return
end subroutine fits_decode_binpar
!
subroutine fits_decode_par(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fits_decode_par
  use sic_bintable
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !     Try to decode the column description (for ascii tables).
  !     Adds the '(' around the format for further use
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer :: i,n,m
  character(len=20) :: format
  character(len=1) :: what
  character(len=message_length) :: mess
  !
  ! Decode FITS format of each column into a length, a repeat count and
  ! a SIC format code.
  do i=1,ncols
    format = colform(i)
    call sic_black (format,n)
    colform(i)='('//format(1:n)//')'
    if (n.eq.0) then
      write(mess,'(A,I3)') 'Format not specified for column',i
      call sic_message(seve%e,rname,mess)
      call sic_message(seve%e,rname,'Unable to determine alignment of '//  &
      'further columns')
      goto 99
    endif
    what=format(1:1)
    m=n-1
    ! Ascii chain
    if (what.eq.'A') then
      read(format(2:n),*,err=10) nitem(i)
      colfmt(i) = nitem(i)
      nitem(i)  = 1
      ! Integer
    elseif (what.eq.'I') then
      colfmt(i) = eei_i4
      ! Real*8
    elseif (what.eq.'D') then
      colfmt(i) = eei_r8
      ! Real*4
    elseif (what.eq.'E') then
      colfmt(i) = eei_r4
      ! Real*4 again...
    elseif (what.eq.'F') then
      colfmt(i) = eei_r4
    else
      write(mess,'(A,A,A,I3)') 'Unsupported format ',format(1:n),' in column',i
      call sic_message(seve%e,rname,mess)
      call sic_message(seve%e,rname,'Unable to determine alignment of '//  &
      'further columns')
      goto 99
    endif
    ! Nitem = 1 for TABLES...
    nitem(i)  = 1
  enddo
  !
  return
  !
99 error = .true.
  return
10 call sic_message(seve%e,rname,'Error decoding '//format(1:n-1))
  return
end subroutine fits_decode_par
!
subroutine scale_table8(a,n,s,z)
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer, intent(in) :: n                      ! Array size
  real(8), intent(inout) :: a(n)                ! Array
  real(4), intent(in) :: s                      ! Scaling factor
  real(4), intent(in) :: z                      ! Offset
  ! Local
  integer :: i
  !
  do i=1,n
    a(i)=a(i)*s+z
  enddo
end subroutine scale_table8
!
subroutine scale_table4(a,n,s,z)
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer, intent(in) :: n                      ! Array size
  real(4), intent(inout) :: a(n)                ! Array
  real(4), intent(in) :: s                      ! Scaling factor
  real(4), intent(in) :: z                      ! Offset
  ! Local
  integer :: i
  !
  do i=1,n
    a(i)=a(i)*s+z
  enddo
  return
end subroutine scale_table4
!
subroutine transpose_table8(a,n,m)
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type & rank mismatch)
  ! transpose A using workspace W and dimensions N and M
  !---------------------------------------------------------------------
  integer, intent(in) :: n                      ! Dimensions
  integer, intent(in) :: m                      ! Dimensions
  integer(8), intent(inout) :: a(m,n)                ! Array
  integer(8) :: w(n,m)                ! Automatic array
  integer :: i,j
  !
  ! Copy in work
  call i8toi8(a,w,n*m)
  ! transpose
  do j=1,n
    do i=1,m
      a(i,j) = w(j,i)
    enddo
  enddo
end subroutine transpose_table8
!
subroutine transpose_tablec8(a,n,m)
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! transpose A using workspace W and dimensions N and M for Complex values
  !---------------------------------------------------------------------
  integer, intent(in) :: n                      ! Dimensions
  integer, intent(in) :: m                      ! Dimensions
  real(8), intent(out) :: a(2,m,n)              ! Array
  real(8) :: w(2,n,m)              ! Automatic array
  ! Local
  integer :: i,j
  ! Copy in work
  call r8tor8(a,w,2*m*n)
  ! transpose
  do j=1,n
    do i=1,m
      a(:,i,j) = w(:,j,i)
    enddo
  enddo
end subroutine transpose_tablec8
!
subroutine transpose_table4(a,n,m)
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! transpose A using workspace W and dimensions N and M
  !---------------------------------------------------------------------
  integer, intent(in) :: n                      ! Dimensions
  integer, intent(in) :: m                      ! Dimensions
  integer(4), intent(out) :: a(m,n)                ! Array
  integer(4) :: w(n,m)                ! Automatic array
  ! Local
  integer :: i,j
  ! Copy in work
  call i4toi4(a,w,m*n)
  ! transpose
  do j=1,n
    do i=1,m
      a(i,j) = w(j,i)
    enddo
  enddo
end subroutine transpose_table4
!
subroutine sic_underscore(a)
  !---------------------------------------------------------------------
  ! @ private
  !  Replace all SIC reserved characters by "_" to produce a valid SIC
  ! variable name. Length of string not modified.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: a  ! Variable name to be checked
  ! Local
  integer(kind=4) :: n,i
  !
  n = len_trim(a)
  do i=1,n
    if (a(i:i).eq.' ' .or. a(i:i).eq.'(' .or. a(i:i).eq.')' .or.  &
        a(i:i).eq.'.' .or. a(i:i).eq.'%' .or. a(i:i).eq.'[' .or.  &
        a(i:i).eq.']' .or. a(i:i).eq.'+' .or. a(i:i).eq.'-')  a(i:i)='_'
  enddo
  !
end subroutine sic_underscore
!
subroutine read_mainfits(array,nsize,bscal,bzero,fmtin,blank,error)
  use sic_interfaces
  use sic_dependencies_interfaces
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! SIC\DEFINE FITS command
  !     Read the "standard" FITS header and data and define main FITS data
  !     as a SIC variable
  !---------------------------------------------------------------------
  integer, intent(in)    :: nsize         ! Size of data array
  real(4), intent(inout) :: array(nsize)  ! Data array
  real(4), intent(in)    :: bscal         ! Scaling factor
  real(4), intent(in)    :: bzero         ! Offset
  integer, intent(in)    :: fmtin         ! Format of data
  real(4), intent(inout) :: blank(2)      ! Blanking Value
  logical, intent(inout) :: error         ! Error flag
  !
  integer, external :: gdf_conv
  !
  ! Local
  integer, parameter :: nbufsiz=2880
  integer :: nfill,nitem,i,fmt,status
  integer(kind=size_length) :: nbyt
  integer(kind=1) :: buffer(nbufsiz)
  integer(kind=4) :: ibuffer(nbufsiz/4)
  equivalence (ibuffer,buffer)
  real :: ritem(nbufsiz)          ! Must be as long as BUFFER in elements
  integer(4) :: iritem(720)       ! But this one only needs the buffer size
  equivalence (iritem,ritem)
  !
  integer(4) :: item(720)
  integer(2) :: item2(1440)
  !
  real(8) :: ditem(360)
  integer(4) :: jditem(720)
  equivalence (jditem,ditem)
  character(len=80) :: chain
  character(len=message_length) :: mess
  logical :: check_blank
  !
  nfill = 0
  if ((fmtin.eq.eei_r4).or.(fmtin.eq.eei_r8)) then
    check_blank = .true.
  else
    check_blank = .false.
    blank(1) = blank(1)*bscal+bzero
  endif
  !
  do while (.true.)
    nbyt = nbufsiz
    call gfits_getbuf(buffer,nbyt,error)
    if ((nbyt.eq.0).or.error) then
      call sic_message(seve%e,'READ','Error reading FITS file')
      error = .true.
      return
    endif
    !
    if (fmtin.eq.eei_i4) then
      fmt = fmt_i4
      nitem = min(nbyt/4,nsize-nfill)
      if (fmt.eq.iee_i4) then
        call eii4ie(buffer,item,nitem)
      elseif  (fmt.eq.vax_i4) then
        call eii4va(buffer,item,nitem)
      else
        call bytoby_sl(buffer,item,nbyt)
      endif
      call i4tor4(item,ritem,nitem)
      !
    elseif (fmtin.eq.eei_i2) then
      fmt = fmt_i2
      nitem = min(nbyt/2,nsize-nfill)
      if (fmt.eq.iee_i2) then
        call eii2ie(buffer,item2,nitem)
      elseif  (fmt.eq.vax_i2) then
        call eii2va(buffer,item2,nitem)
      else
        call bytoby_sl(buffer,item2,nbyt)
      endif
      call i2tor4(item2,ritem,nitem)
      !
    elseif (fmtin.eq.eei_r4) then
      fmt = fmt_r4
      nitem = min(nbyt/4,nsize-nfill)
      if (fmtin.eq.fmt_r4) then
        call r4tor4(buffer,ritem,nitem)
      else
        status = gdf_conv(ibuffer,iritem,nitem,fmt_r4,eei_r4)
        if (status.ne.1) then
          write(mess,*) 'Convert error R*4 ',fmt_r4,eei_r4
          call sic_message(seve%e,'FITS',mess)
        endif
      endif
    elseif (fmtin.eq.eei_r8) then
      fmt = fmt_r4
      nitem = min(nbyt/8,nsize-nfill)
      if (fmtin.eq.fmt_r8) then
        call r8tor4(buffer,ritem,nitem)
      else
        status = gdf_conv(ibuffer,jditem,nitem*2,fmt_r8,eei_r8)
        if (status.ne.1) then
          write(mess,*) 'Convert error R*8 ',fmt_r8,eei_r4
          call sic_message(seve%e,'FITS',mess)
        endif
        call r8tor4(ditem,ritem,nitem)
      endif
    elseif (fmtin.eq.fmt_by) then
      nitem = min(nbyt,nsize-nfill)
      do i = 1,nitem
        ritem(i) = buffer(i)
      enddo
    else
      write(chain,1000) fmtin
      call sic_message(seve%e,'READ',chain)
      goto 99
    endif
    !
    ! Scale and zero
    if (check_blank) then
      do i = 1,nitem
        nfill = nfill+1
        if (ritem(i).ne.ritem(i)) then
          array(nfill) = blank(1)
          blank(2) = 0.0
        else
          array(nfill) = ritem(i)*bscal+bzero
        endif
      enddo
    else
      do i = 1,nitem
        nfill = nfill+1
        array(nfill) = ritem(i)*bscal+bzero
      enddo
    endif
    if (nfill.ge.nsize) return
  enddo
  return
  !
99 error = .true.
  return
  !
1000 format('Unsupported format in main data: ',i6)
end subroutine read_mainfits
!
subroutine fits_read_basic(head,ns,global,fmt,nsize,ndim,dim,error,extend,  &
  therank,data,skipsz)
  use gildas_def
  use gbl_constant
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fits_read_basic
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Read a basic FITS header
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: head              ! Header name
  integer(kind=4),            intent(in)    :: ns                ! Length of name
  logical,                    intent(in)    :: global            ! Global / Local status
  integer(kind=4),            intent(in)    :: fmt               ! Format of data
  integer(kind=size_length),  intent(in)    :: nsize             ! Size in output words 
  integer(kind=4),            intent(inout) :: ndim              ! Number of dimensions
  integer(kind=index_length), intent(inout) :: dim(sic_maxdims)  ! Dimensions
  logical,                    intent(inout) :: error             ! Error flag
  logical,                    intent(out)   :: extend            ! Are there extensions ?
  integer(kind=4),            intent(in)    :: therank           ! Desired trimming
  logical,                    intent(in)    :: data              ! Do you want the data ?
  integer(kind=size_length),  intent(in)    :: skipsz            ! Size in bytes in FITS data
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: routname='FITS'
  real(kind=4) :: bscal,bzero
  character(len=80) :: name,chain
  character(len=8) :: comm, trans
  integer(kind=4) :: nnn,i,ier
  integer(kind=address_length) :: ip
  type(sic_descriptor_t) :: desc
  logical :: found
  real(kind=4) :: blank(2)
  !
  blank(1) = -1.23456E+38
  blank(2) = -1.0
  !
  ! Define data size if non zero
  if (ndim.ne.0) then
    if (data)  call sic_message(seve%i,routname,'Loading the basic array')
    !
    bscal = 1.0
    bzero = 0.0
    !
    call fits_trim(ndim,dim,therank)
  endif
  !
  do
    call gfits_get(comm,chain,.false.,error)
    if (error)  return
    !
    ! Translate symbols if any
    call sic_getsymbol (comm,trans,error)
    if (error) then
       error = .false.
    else
       comm = trans
    endif
    !
    select case (comm)
    case ('EXTEND')  ! Test the EXTEND keyword even if it is misplaced
      if (index(chain,'T').ne.0) extend = .true.
    case ('GROUPS')
      if (chain(20:20).eq.'T')  return
    case ('PCOUNT','GCOUNT')
      return
    case ('HISTORY','COMMENT','BLOCKED','','DATA')
      continue
    case ('HIERARCH')
      ! print *,'Hierarch keyword ',comm
      call do_hierarch(head,ns,chain,global)
      ! print *,'Hierarch keyword ',comm,' done '
    case ('BSCALE')
      read(chain,*,iostat=ier) bscal
    case ('BZERO')
      read(chain,*,iostat=ier) bzero
    case ('BLANK')
      read(chain,*,iostat=ier) blank(1)  ! The Blanking Value is in Scaled Units
      blank(2) = 0.0
    case ('END')
      exit
    case default
      call sic_underscore(comm)
      name = head(1:ns)//'%'//comm
      call fits_sicvariable(name,chain,global)
    end select
  enddo
  !
  ! Skip to next FITS record
  !
  ! Skip only if there is some data
  if (ndim.ne.0) call gfits_flush_data(error)
  !
  ! Return if no data
  if (ndim.eq.0) return
  !
  if (data) then
    ! Define the data array
    name = head(1:ns)//'%DATA['
    nnn = len_trim(name)+1
    write(name(nnn:),"(20(I12,','))") (dim(i),i=1,ndim)
    nnn = len_trim(name)
    name(nnn:nnn) = ']'
    call sic_black(name,nnn)
    call sic_defvariable(fmt_r4,name(1:nnn),global,error)
    if (error)  return
    !
    ! Read the file
    nnn = ns+5
    call sic_descriptor(name(1:nnn),desc,found)
    ip = gag_pointer(desc%addr,memory)
    call read_mainfits(memory(ip),nsize,bscal,bzero,fmt,blank,error)
    !
    if (blank(2).ge.0.0) then
      name = head(1:ns)//'%BLANK[2]'
      nnn = len_trim(name)
      call sic_defvariable(fmt_r4,name(1:nnn),global,error)
      if (error)  return
      nnn = nnn-3
      call sic_descriptor(name(1:nnn),desc,found)
      ip = gag_pointer(desc%addr,memory)
      call r4tor4(blank,memory(ip),2)
    endif
  else
    ! Skip the DATA array
    !!Print *,'SKIBUF #6 ',skipsz,' Bytes'
    call gfits_skibuf(skipsz,error)
    if (error) return
    call gfits_flush_data(error)
  endif
  !
end subroutine fits_read_basic
!
subroutine fits_read_rndm(head,ns,global,fmt,nsize,ndim,dim,error,extend,  &
  gcount,pcount,rndmsize,data,skipsz, nbits)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fits_read_rndm
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Read a Random Group
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: head              ! Header name
  integer(kind=4),            intent(in)    :: ns                ! Length of name
  logical,                    intent(in)    :: global            ! Global / Local status
  integer(kind=4),            intent(in)    :: fmt               ! Format of data
  integer(kind=size_length),  intent(inout) :: nsize             ! Size in words of data
  integer(kind=4),            intent(inout) :: ndim              ! Number of dimensions
  integer(kind=index_length), intent(inout) :: dim(sic_maxdims)  ! Dimensions
  logical,                    intent(inout) :: error             ! Error flag
  logical,                    intent(out)   :: extend            ! Are there extensions ?
  integer(kind=4),            intent(inout)    :: gcount            ! GCOUNT value
  integer(kind=4),            intent(inout)    :: pcount            ! PCOUNT value
  integer(kind=4),            intent(inout)    :: rndmsize          ! Random group size
  logical,                    intent(in)    :: data              ! Read data ?
  integer(kind=size_length),  intent(inout)    :: skipsz            ! Size in Bytes in FITS file
  integer(kind=4),            intent(in)    :: nbits             ! Number of Bits in data
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: routname='FITS'
  real(kind=4) :: bscal,bzero,x
  real(kind=4) :: rscal(10),rzero(10)
  character(len=80) :: name,chain
  character(len=8) :: comm
  integer(kind=4) :: nnn,i,ier,igroup
  integer(kind=address_length) :: ip
  integer(kind=size_length) :: intg
  type(sic_descriptor_t) :: desc
  logical :: found
  real(kind=4) :: blank(2)
  !
  blank(1) = 1.23456E+38
  blank(2) = -1.0
  !
  ! Define data size if non zero
  bscal = 1.0
  bzero = 0.0
  !
  do
    call gfits_get(comm,chain,.false.,error)
    if (error)  return
    !
    ! Test the EXTEND keyword even if it is misplaced
    if (comm.eq.'EXTEND') then
      if (index(chain,'T').ne.0) extend = .true.
    elseif (comm.eq.'GROUPS') then
      if (chain(20:20).ne.'T') then
        error = .true.
        return
      endif
    elseif  (comm.eq.'PCOUNT') then
      read(chain(1:20),'(I20)') intg
      pcount=intg
    elseif  (comm.eq.'GCOUNT') then
      read(chain(1:20),'(I20)') intg
      gcount=intg
    elseif (comm.eq.'BLANK') then
      ! The Blanking Value is in Scaled Units
      read(chain,*,iostat=IER) blank(1)
      blank(2) = 0.0
      !
      ! Random group scaling factors
    elseif (comm(1:5).eq.'PTYPE') then
      continue
    elseif (comm(1:5).eq.'PSCAL') then
      read(comm(6:6),'(I1)',iostat=ier) igroup
      if (igroup.lt.9) then
        read(chain,*,iostat=ier) x
        rscal(igroup) = x
      endif
    elseif (comm(1:5).eq.'PZERO') then
      read(comm(6:6),'(I1)',iostat=ier) igroup
      if (igroup.le.9) then
        read(chain,*,iostat=ier) x
        rzero(igroup) = x
      endif
      !
    elseif  (comm.eq.'HISTORY') then
      continue
    elseif  (comm.eq.'COMMENT') then
      continue
    elseif  (comm.eq.'HIERARCH') then
      call do_hierarch(head,ns,chain,global)
    elseif  (comm.eq.'BLOCKED') then
      continue
    elseif  (comm.eq.'        ') then
      continue
    elseif  (comm.eq.'DATA') then  ! Reserved for main array
      continue
    elseif  (comm.eq.'END') then
      exit
      !
    else
      call sic_underscore(comm)
      name = head(1:ns)//'%'//comm
      call fits_sicvariable(name,chain,global)
    endif
  enddo
  !
  ! Set data skip size
  skipsz = gcount               ! Force I*8 operation for next statement
  skipsz = skipsz*(pcount+rndmsize)
  ! convert in bytes now
  nsize = skipsz                !! In words
  skipsz = skipsz*abs(nbits)/8  !! In Bytes
  !
  !!Print *,'DATA ',data,' PCOUNT ',pcount,' GCOUNT ',gcount,' NDIM ',ndim
  !
  if (ndim.ne.0 .or. gcount.ne.0) then
    if (ndim.ne.0) then
      if (data) call sic_message(seve%i,routname,'Loading the basic array')
    else
      if (data) call sic_message(seve%i,routname,'Loading the random group array')
      ndim = 2
      dim(1) = pcount+rndmsize   ! Not PCOUNT, also data here...
      dim(2) = gcount
      dim(3:) = 0
    endif
  endif
  !
  ! Skip to next FITS record
  !
  ! Skip only if there is some data, but there must be
  if (ndim.ne.0 .or. gcount.ne.0) call gfits_flush_data(error)
  !
  ! Test if Random or Normal data
  if (data) then
    if (pcount.eq.0) then
      !
      ! Define the data array
      name = head(1:ns)//'%DATA['
      nnn = len_trim(name)+1
      write(name(nnn:),"(20(I12,','))") (dim(i),i=1,ndim)
      nnn = len_trim(name)
      name(nnn:nnn) = ']'
      call sic_black(name,nnn)
      call sic_defvariable(fmt_r4,name(1:nnn),global,error)
      !!Print *,'Main Name ',name(1:nnn)
      if (error)  return
      !
      ! Read the file
      nnn = ns+5
      call sic_descriptor(name(1:nnn),desc,found)
      ip = gag_pointer(desc%addr,memory)
      call read_mainfits(memory(ip),nsize,bscal,bzero,fmt,blank,error)
      !
      if (blank(2).ge.0.0) then
        name = head(1:ns)//'%BLANK[2]'
        nnn = len_trim(name)
        call sic_defvariable(fmt_r4,name(1:nnn),global,error)
        if (error)  return
        nnn = nnn-3
        call sic_descriptor(name(1:nnn),desc,found)
        ip = gag_pointer(desc%addr,memory)
        call r4tor4(blank,memory(ip),2)
      endif
    elseif  (gcount.ne.0) then
      !
      ! Define the data array
      name = head(1:ns)//'%DATA['
      nnn = len_trim(name)+1
      write(name(nnn:),"(20(I12,','))") (dim(i),i=1,ndim)
      nnn = len_trim(name)
      name(nnn:nnn) = ']'
      call sic_black(name,nnn)
      name(nnn:nnn) = ']'
      call sic_black(name,nnn)
      call sic_defvariable(fmt_r4,name(1:nnn),global,error)
      if (error)  return
      !
      ! Read the file
      nnn = ns+5
      call sic_descriptor(name(1:nnn),desc,found)
      ip = gag_pointer(desc%addr,memory)
      rscal(10) = bscal
      rzero(10) = bzero
      !!Print *,'Calling READ_RNDMFITS', pcount+rndmsize,gcount,pcount
      call read_rndmfits(memory(ip),pcount+rndmsize,gcount,pcount,rscal,rzero,  &
      fmt,error)
    else
      call sic_message(seve%w,routname,'No data at all')
    endif
  else
    ! Sizes are already in Bytes here 
    !!Print *,'SKIBUF #7 ',skipsz,' Bytes or ',nsize, gcount*(pcount+rndmsize),' Words'
    call gfits_skibuf(skipsz,error)
    if (error) return
    call gfits_flush_data(error)
  endif
  !
end subroutine fits_read_rndm
!
subroutine read_rndmfits(array,kc,gc,pc,rscal,rzero,fmt,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! SIC\DEFINE FITS
  !      Read a Random group
  !---------------------------------------------------------------------
  integer, intent(in)    :: kc            ! First dimension of Array
  integer, intent(in)    :: gc            ! Second dimension of Array
  real,    intent(out)   :: array(kc,gc)  ! Array
  integer, intent(in)    :: pc            ! Pcount offset
  real,    intent(in)    :: rscal(10)     ! Scaling
  real,    intent(in)    :: rzero(10)     ! Offset
  integer, intent(in)    :: fmt           ! Data format
  logical, intent(inout) :: error         ! Error flag
  ! Local
  integer :: ig,ip,kp,mp,istart
  integer(kind=size_length) :: lp
  !
  ! FMT is the format of input...
  kp = kc-pc
  mp = min(pc,9)
  !
  do ig=1,gc
    ! The 9 first with appropriate scaling
    lp = 1
    do ip=1,mp
      call sgetreal(lp,array(ip,ig),rscal(ip),rzero(ip),error,fmt)
    enddo
    ! The next ones up to PC with 1. and 0.
    if (pc.gt.9) then
      lp = pc-mp
      call sgetreal(lp,array(10,ig),1.0,0.0,error,fmt)
    endif
    ! The last ones with their scaling
    if (kp.gt.0) then
      istart = pc+1
      do ip=1,kp,720
        lp = min(kp-ip+1,720)
        call sgetreal(lp,array(istart,ig),rscal(10),rzero(10),error,fmt)
        istart = istart+720
      enddo
    endif
  enddo
end subroutine read_rndmfits
!
subroutine sgetreal(ndat,data,scale,zero,error,fmt)
  use gildas_def
  use gbl_message
  use gbl_format
  use sic_interfaces, except_this=>sgetreal
  use sic_dependencies_interfaces, no_interface=>gfits_getbuf
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Read NDAT data values in FITS data area,
  !   with scaling SCALE and offset ZERO
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ndat        ! Number of data
  real(kind=4),              intent(out)   :: data(ndat)  ! Data array
  real(kind=4),              intent(in)    :: scale       ! Scaling factor
  real(kind=4),              intent(in)    :: zero        ! Offset
  logical,                   intent(inout) :: error       ! Error flag
  integer(kind=4),           intent(in)    :: fmt         ! Data format
  ! Local
  logical :: err
  integer(kind=size_length) :: i,nbyt,nfill
  real(kind=4) :: vtest
  real(kind=4) :: buffer(720)
  integer(kind=2) :: i2buf(1440)
  integer(kind=4) :: i4buf(720)
  equivalence (buffer,i2buf,i4buf)  ! Needed, but possibly causing problems
  !                                 ! because of argument overlap
  !                                 ! Must be removed using appropriate GDF_CONV
  !
  err = .false.
  !
  !  Print *,'FMTIN ',fmt,eei_i2,eei_i4
  !  Print *,'FMTOU ',fmt,fmt_i2,fmt_i4
  !
  ! I*2
  if (fmt.eq.eei_i2) then
    nbyt = 2_8*ndat
    call gfits_getbuf(buffer,nbyt,err)
    if (fmt_i2.ne.eei_i2) then
      call iei2ei_sl(buffer,i2buf,ndat)
    endif
    do i=1,ndat
      vtest = i2buf(i)
      data(i) = scale*vtest+zero
    enddo
  elseif (fmt.eq.eei_i4) then
    nbyt = 4_8*ndat
    call gfits_getbuf(buffer,nbyt,err)
    if (fmt_i4.ne.eei_i4) then
      call iei4ei_sl(buffer,i4buf,ndat)
    endif
    do i = 1, ndat
      vtest = i4buf(i)
      data(i) = scale*vtest+zero
    enddo
  elseif (fmt.eq.eei_r4) then
    nbyt = 4_8*ndat
    call gfits_getbuf(buffer,nbyt,err)
    !
    ! To be replaced by appropriate call to GDF_CONV
    ! if some conversion is needed...
    !
    !        STATUS = GDF_CONV(BUFFER,RITEM,NITEM,FMT_R4,EEI_R4)
    !
    nfill = 0
    call ieee32_to_real(buffer,ndat,data,ndat,nfill,scale,zero,vtest)
  else
    call sic_message(seve%e,'SGETREAL','Wrong NBIT')
    error = .true.
  endif
end subroutine sgetreal
!
subroutine do_hierarch(s,n,val,global)
  use gildas_def
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>do_hierarch
  !---------------------------------------------------------------------
  ! @ private
  ! Support for command
  !   SIC\DEFINE FITS
  ! Support for HIERARCH keywords (ESO certainly, most possibly all
  ! others). Note that due to the nature of the SIC variables, blanks in
  ! the keyword are translated to underscores.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: s       ! Header name
  integer(kind=4),  intent(in)    :: n       ! Length of name
  character(len=*), intent(inout) :: val     ! HIERARCH value
  logical,          intent(in)    :: global  ! Global flag
  ! Local
  integer(kind=4) :: i1,i2,nn,nnn,ier
  character(len=varname_length) :: struct
  character(len=80) :: string,key
  logical :: error,logi
  real(kind=8) :: double
  character(len=1), parameter :: quote=''''
  !
  error = .false.
  !
  ! Should do Nothing until a special flag '/DO_HIERARCH' for example
  ! has been inserted since the numerous ESO keywords simply overflow
  ! the max num of sic variables.
  !
  call gfits_hierarch(key,val,error)
  if (error)  return
  !
  ! Replace blank chars with underscores:
  call sic_underscore(key)
  struct = s(1:n)//'%'//key
  nnn = len_trim(struct)
  !
  ! Use of sic_makestructhier avoid unpleasant warnings and insure structure
  ! existence.
  call sic_makestructhier(struct,global,error)
  if (error) return
  !
  ! Look val more closely for string or real value. reals are mapped to doubles
  ! ZZZ should use fits_sicvariable but the logical letter are not aligned
  ! as in the other cases.
  i1 = index(val,quote)
  if (i1.ne.0) then
    string = val(i1+1:)
    i2 = index(string,quote)
    string(i2:) = ' '
    i2 = i2-1
    if (i2.gt.0) then
      call fits_sicstr(string,i2,struct,global)
    endif
  else
    nn = len_trim(val)
    call sic_black(val,nn)
    if  (val(1:1).ne.'T' .and. val(1:1).ne.'F' .and. val(1:1).ne.'U') then
      ! Define a double value
      read(val,*,iostat=ier) double
      call fits_sicnum(double,fmt_r8,struct,global)
    else
      ! Define a logical value
      logi = val(1:1).eq.'T'
      call fits_sicnum(logi,fmt_l,struct,global)
    endif
  endif
  !
end subroutine do_hierarch
!
subroutine sic_blanktostruct(a,n)
  use sic_interfaces, except_this=>sic_blanktostruct
  !---------------------------------------------------------------------
  ! @ private
  !   Replace spaces by % sign
  !---------------------------------------------------------------------
  character(len=*) :: a             !
  integer :: n                      !
  ! Local
  integer :: i
  n=len_trim(a)
  !
  do i=1,n
    if (a(i:i).eq.' ') a(i:i) = '%'
  enddo
end subroutine sic_blanktostruct
!
subroutine sic_makestructhier(namein,global,error)
  use sic_interfaces, except_this=>sic_makestructhier
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Create a SIC structure from a HIERARCH keyword
  !   Creates all intermediate structures if needed
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: namein        ! Structure name
  logical, intent(in)  :: global                 ! Global status
  logical, intent(out)  :: error                 ! Error flag
  ! Local
  integer :: in
  integer :: n,i,ier
  type(sic_identifier_t) :: var
  !
  ! test structure existence
  error = .false.
  n = len_trim(namein)
  if (namein(n:n).eq.'%') then
    call sic_message(seve%e,'CHECK','Invalid structure member name '//  &
    namein(1:n-1))
    error = .true.
    return
  endif
  !
  do i=1,n
    if (namein(i:i).eq.'%') then
      ! Seems to be a structure
      var%name = namein(1:i-1)
      var%lname = i-1
      if (global) then
        var%level = 0
      else
        var%level = var_level
      endif
      ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
      if (ier.ne.1) then
        call sic_crestructure(namein(1:i-1),global,error)
        if (error) return
      endif
    endif
  enddo
  !
end subroutine sic_makestructhier
!
subroutine fits_sicvariable(name,chain,global)
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Create a Sic variable from a FITS value string
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name    ! Variable name
  character(len=*), intent(in) :: chain   ! Value to be decoded
  logical,          intent(in) :: global  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=1), parameter :: quote='''',dot='.',eexp='E',dexp='D'
  integer(kind=4) :: i1,i2,ier
  logical :: intformatted
  ! Support for actual values:
  character(len=80) :: string
  integer(kind=8) :: intg
  real(kind=8) :: doubl
  logical :: logi
  !
  i1 = index(chain,quote)
  if (i1.ne.0) then
    string = chain(i1+1:)
    i2 = index(string,quote)
    string(i2:) = ' '
    i2 = i2-1
    ! Define a character string
    if (i2.gt.0) then
      call fits_sicstr(string,i2,name,global)
    else
      ! Empty string... Should we define a Sic variable?
    endif
    !
  elseif (chain(20:20).ne.'T' .and. chain(20:20).ne.'F' .and.  &
          chain(20:20).ne.'U') then
    ! Define numeric variable (real or integer)
    intformatted = index(chain,dot).eq.0  .and.  &
                   index(chain,eexp).eq.0 .and.  &
                   index(chain,dexp).eq.0
    if (intformatted) then
      read(chain,'(I20)',iostat=ier) intg
      if (ier.eq.0) then
        call fits_sicnum(intg,fmt_i8,name,global)
      else
        call sic_message(seve%w,rname,'Error decoding '//chain)
      endif
    else
      read(chain,*,iostat=ier) doubl
      if (ier.eq.0) then
        call fits_sicnum(doubl,fmt_r8,name,global)
      else
        call sic_message(seve%w,rname,'Error decoding '//chain)
      endif
    endif
  else
    ! Define a logical value
    logi = chain(20:20).eq.'T'
    call fits_sicnum(logi,fmt_l,name,global)
  endif
  !
end subroutine fits_sicvariable
!
subroutine fits_sicnum(in,fmt,name,global)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch - on purpose - )
  ! SIC\DEFINE FITS command
  !   Fill a SIC variable of specified (numerical) type
  !   from a FITS keyword number value
  !---------------------------------------------------------------------
  real(kind=8),     intent(in) :: in      ! Input value
  integer(kind=4),  intent(in) :: fmt     ! Type of SIC variable
  character(len=*), intent(in) :: name    ! Variable name
  logical,          intent(in) :: global  ! Global flag
  ! Local
  logical :: error
  integer :: n
  logical :: found
  integer(kind=address_length) :: ip
  type(sic_descriptor_t) :: desc
  include 'gbl_memory.inc'
  !
  error = .false.
  n = len_trim(name)
  call sic_defvariable(fmt,name(1:n),global,error)
  if (error) return
  !
  call sic_descriptor(name(1:n),desc,found)
  ip = gag_pointer(desc%addr,memory)
  !
  select case (fmt)
  case (fmt_r8,fmt_i8)
     call r8tor8(in,memory(ip),1)
  case default
     call r4tor4(in,memory(ip),1)
  end select
end subroutine fits_sicnum
!
subroutine fits_sicstr(str,lstr,name,global)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>fits_sicstr
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Fill a SIC character variable from a FITS keyword value
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: str
  integer, intent(in) :: lstr
  character(len=*), intent(in) :: name
  logical, intent(in) :: global
  !
  logical :: error
  integer :: n
  logical :: found
  type(sic_descriptor_t) :: desc
  !
  error = .false.
  n = len_trim(name)
  call sic_defvariable(lstr,name(1:n),global,error)
  if (error) return
  call sic_descriptor(name(1:n),desc,found)
  !
  call ctodes(str,desc%type,desc%addr)
end subroutine fits_sicstr
!
subroutine fits_trim(ndim,dim,therank)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! SIC\DEFINE FITS command
  !   Support for option /TRIM
  !   Truncate degenerate dimensions
  !---------------------------------------------------------------------
  integer(kind=4), intent(inout) :: ndim
  integer(kind=index_length), intent(in) :: dim(sic_maxdims)
  integer(kind=4), intent(in) :: therank
  !
  integer :: i, thedim
  !
  if (therank.gt.0) then
    ndim = therank
  else if (therank.eq.-10) then
    thedim = ndim
    do i=ndim,1,-1
      if (dim(i).gt.1) then
        thedim = i
        exit
      endif
    enddo
    ndim = thedim
  endif
end subroutine fits_trim

* DECK scsum1.f
      REAL             FUNCTION SCSUM1( N, CX, INCX )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
*     ..
*     .. Array Arguments ..
      COMPLEX            CX( * )
*     ..
*
*  Purpose
*  =======
*
*  SCSUM1 takes the sum of the absolute values of a complex
*  vector and returns a single precision result.
*
*  Based on SCASUM from the Level 1 BLAS.
*  The change is to use the 'genuine' absolute value.
*
*  Contributed by Nick Higham for use with CLACON.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of elements in the vector CX.
*
*  CX      (input) COMPLEX array, dimension (N)
*          The vector whose elements will be summed.
*
*  INCX    (input) INTEGER
*          The spacing between successive values of CX.  INCX > 0.
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, NINCX
      REAL               STEMP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
      SCSUM1 = 0.0E0
      STEMP = 0.0E0
      IF( N.LE.0 )
     $   RETURN
      IF( INCX.EQ.1 )
     $   GO TO 20
*
*     CODE FOR INCREMENT NOT EQUAL TO 1
*
      NINCX = N*INCX
      DO 10 I = 1, NINCX, INCX
*
*        NEXT LINE MODIFIED.
*
         STEMP = STEMP + ABS( CX( I ) )
   10 CONTINUE
      SCSUM1 = STEMP
      RETURN
*
*     CODE FOR INCREMENT EQUAL TO 1
*
   20 CONTINUE
      DO 30 I = 1, N
*
*        NEXT LINE MODIFIED.
*
         STEMP = STEMP + ABS( CX( I ) )
   30 CONTINUE
      SCSUM1 = STEMP
      RETURN
*
*     End of SCSUM1
*
      END

subroutine minabs(npar,g,f,x,iflag,obs)
  use classfit_interfaces, except_this=>minabs
  use class_types
  use gauss_parameter
  use hyperfine_structure
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Function to be minimised for Absorption profile fitting
  ! Caution: R*8 and R*4 values are carefully mixed for speed
  !----------------------------------------------------------------------
  integer(kind=4),   intent(in)  :: npar
  real(kind=8),      intent(out) :: g(npar)
  real(kind=8),      intent(out) :: f
  real(kind=8),      intent(in)  :: x(npar)
  integer(kind=4),   intent(in)  :: iflag
  type(observation), intent(in)  :: obs
  ! Local
  logical :: dobase
  real(kind=4) :: gg(nabspar*mabslin)
  real(kind=4) :: al,bl,cl,ti,fi,aux,arg,ta,seuil,ybas,yrai,vi,vv,tt,dv
  integer(kind=4) :: i,j,kbas,krai,il,it,iv,id,ip
  !
  ! Final computations
  if (iflag.eq.3) goto 20
  !
  g = 0
  f = 0.
  !
  do i=obs%cimin,obs%cimax
     !
     ! Skip over masked area or bad channels
     if (wfit(i).gt.0) then
        vi = obs%datax(i)
        ti = 0
        do il = 1, nline
           al = 0
           bl = 0
           cl = 0
           it = (il-1)*3+2
           iv = it+1
           id = iv+1
           tt = x(it)
           vv = x(iv)
           dv = x(id)
           do j=1, nhyp
              arg = (vi-vhfs(j)-vv)/dv
              if (abs(arg).lt.4.) then
                 aux = rhfs(j)*exp(-arg**2)
                 al = al + aux
                 aux = aux*2.*arg/dv
                 bl = bl + aux
                 cl = cl + aux*arg
              endif
           enddo
           ti = ti+al*tt
           gg(it) = al
           gg(iv) = bl*tt
           gg(id) = cl*tt
        enddo
        ti = exp(-ti)
        fi = obs%spectre(i) - ti*x(1)
        f = f + fi**2
        ti = 2*ti*fi
        g(1) = g(1) - ti
        do ip =2, 3*nline+1
           g(ip) = g(ip)+ti*gg(ip)
        enddo
     endif
  enddo
  !
  ! Residuals if needed
  !
  if (iflag.ne.1) return
  !
20 continue
  ! Sigma after Minimisation
  kbas=0
  ybas=0.
  krai=0
  yrai=0.
  seuil= sigbas/3.
  !
  do i=obs%cimin,obs%cimax
     if (wfit(i).gt.0) then
        vi = real(obs%datax(i),4)
        ta = proabs(obs,vi,0,dobase)
        if (abs(ta).lt.seuil) then
           kbas=kbas+1
           ybas=ybas+obs%spectre(i)**2
        else
           krai=krai+1
           yrai=yrai+(ta-obs%spectre(i))**2
        endif
     endif
  enddo
  !
  if (krai.ne.0) then
     sigrai=sqrt(yrai/krai)
  else
     sigrai=0.
  endif
  if (kbas.ne.0) then
     sigbas=sqrt(ybas/kbas)
  else
     sigbas=sigrai
  endif
  !
end subroutine minabs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_keyval_types
  use cubesyntax_value_strg_types
  !
  use cubesyntax_keyval_list_tool
  use cubesyntax_keyval_real_types
  use cubesyntax_keyval_dble_types
  use cubesyntax_keyval_strg_types
  use cubesyntax_keyval_keyword_types
  !
  use cubesyntax_keyvalunit_list_tool
  use cubesyntax_keyvalunit_real_types
  use cubesyntax_keyvalunit_dble_types
  !
  public :: value_strg_comm_t,value_strg_user_t ! In order to propose the "COMMAND strg" syntax
  !
  public :: keyval_list_t
  public :: keyval_real_comm_t,keyval_real_user_t,keyval_real_prog_t
  public :: keyval_dble_comm_t,keyval_dble_user_t,keyval_dble_prog_t
  public :: keyval_strg_comm_t,keyval_strg_user_t,keyval_strg_prog_t
  public :: keyval_keyword_comm_t,keyval_keyword_user_t,keyval_keyword_prog_t
  !
  public :: keyvalunit_list_t
  public :: keyvalunit_real_comm_t,keyvalunit_real_user_t,keyvalunit_real_prog_t
  public :: keyvalunit_dble_comm_t,keyvalunit_dble_user_t,keyvalunit_dble_prog_t
  private
end module cubesyntax_keyval_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_factor_types
  use cubetools_parameters
  use cubetools_structure
  use cubetemplate_messaging
  !
  public :: factor_comm_t,factor_user_t,factor_prog_t
  private
  !
  type factor_comm_t
     type(option_t), pointer :: key
   contains
     procedure, public :: register => cubetemplate_factor_comm_register
     procedure, public :: parse    => cubetemplate_factor_comm_parse
  end type factor_comm_t
  !
  type factor_user_t
     logical               :: do = .false.
     character(len=argu_l) :: val = strg_star
   contains
     procedure, public :: init   => cubetemplate_factor_user_init
     procedure, public :: toprog => cubetemplate_factor_user_toprog
     procedure, public :: list   => cubetemplate_factor_user_list
  end type factor_user_t
  !
  type factor_prog_t
     real(kind=sign_k) :: val
   contains
     procedure, public :: list   => cubetemplate_factor_prog_list
     procedure, public :: header => cubetemplate_factor_prog_header
  end type factor_prog_t
  !
contains
  !
  subroutine cubetemplate_factor_comm_register(comm,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(factor_comm_t), intent(inout) :: comm
    logical,              intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='FACTOR>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'FACTOR','value',&
         'Multiply data by a factor',&
         strg_emp,&
         comm%key,error)
    if (error) return
    call stdarg%register(&
         'value',&
         'Multiplicative factor value',&
         'It defaults to 1.0 when the /FACTOR key is omitted.',&
         code_arg_mandatory,&
         error)
    if (error) return
  end subroutine cubetemplate_factor_comm_register
  !
  subroutine cubetemplate_factor_comm_parse(comm,line,user,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! /FACTOR factor
    !----------------------------------------------------------------------
    class(factor_comm_t), intent(in)    :: comm
    character(len=*),     intent(in)    :: line
    type(factor_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    integer(kind=argu_k), parameter :: iarg=1
    character(len=*), parameter :: rname='FACTOR>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,comm%key,iarg,user%val,mandatory,error)
       if (error) return
    else
       user%val = strg_star
    endif
  end subroutine cubetemplate_factor_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetemplate_factor_user_init(user,error)
    !----------------------------------------------------------------------
    ! Initialize by setting the intent of factor to out
    !----------------------------------------------------------------------
    class(factor_user_t), intent(out)   :: user 
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='FACTOR>USER>INIT'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
  end subroutine cubetemplate_factor_user_init
  !
  subroutine cubetemplate_factor_user_toprog(user,prog,error)
    use cubetools_unit
    use cubetools_user2prog
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(factor_user_t), intent(in)    :: user
    type(factor_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(unit_user_t) :: nounit
    real(kind=sign_k), parameter :: default=1.0
    character(len=*), parameter :: rname='FACTOR>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! *** JP This syntax seems very strange to me because we transfer a
    ! *** JP constant object named nounit!
    call nounit%get_from_code(code_unit_unk,error)
    if (error) return
    call cubetools_user2prog_resolve_star(user%val,nounit,default,prog%val,error)
    if (error) return
  end subroutine cubetemplate_factor_user_toprog
  !
  subroutine cubetemplate_factor_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging purpose
    !----------------------------------------------------------------------
    class(factor_user_t), intent(in)    :: user 
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='FACTOR>USER>LIST'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    write(mess,'(2a)') &
         'Factor  : (',trim(user%val)
    call cubetemplate_message(seve%r,rname,mess)
  end subroutine cubetemplate_factor_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetemplate_factor_prog_header(prog,cube,error)
    use cubetuple_format_class
    use cubetools_axis_types
    use cubetools_header_methods
    !-------------------------------------------------------------------
    ! Update cube header according to the factor
    ! Nothing to be done in this specific case
    !-------------------------------------------------------------------
    class(factor_prog_t), intent(inout) :: prog
    class(format_t),      intent(inout) :: cube
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='FACTOR>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
  end subroutine cubetemplate_factor_prog_header
  !
  subroutine cubetemplate_factor_prog_list(prog,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! List the factor information in a user friendly way
    !-------------------------------------------------------------------
    class(factor_prog_t), intent(in)    :: prog
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='FACTOR>PROG>LIST'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    mess = cubetools_format_stdkey_boldval('Factor',prog%val,fsimple,nsimple)
    call cubetemplate_message(seve%r,rname,mess)
  end subroutine cubetemplate_factor_prog_list
end module cubetemplate_factor_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clic_drop(line,error)
  use gkernel_interfaces
  use clic_index
  !---------------------------------------------------------------------
  ! CLIC 	Support routine for command
  !	DROP Number [Version]
  !	Deletes an observation from current index
  ! Arguments :
  !	LINE	C*(*)	Command line		Input
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  logical :: lst,found
  integer :: versio
  character(len=20) :: nombre
  integer :: tver
  integer(kind=entry_length) :: i, number
  !------------------------------------------------------------------------
  ! Code:
  call check_index(error)
  if (error) return
  if (sic_present(0,1)) then
    call sic_i8(line,0,1,number,.true.,error)
    if (error) return
    versio = 0
    call sic_i4(line,0,2,versio,.false.,error)
    if (error) return
    lst = versio .eq. 0
  else
    number=r_num
    versio=abs(r_ver)
    lst = .false.
  endif
  found = .false.
  do 200 i=1,cxnext-1
    if (.not.found) then
      if (lst) then
        found = cx_num(i).eq.number .and. cx_ver(i).ge.0
      else
        tver = abs(cx_ver(i))
        found = cx_num(i).eq.number .and. tver.eq.versio
      endif
      if (found) then
        if (knext .ge. i) knext = knext-1
      endif
    else
      cx_ind(i-1)  = cx_ind(i)
      cx_num(i-1)  = cx_num(i)
      cx_ver(i-1)  = cx_ver(i)
      cx_bloc(i-1) = cx_bloc(i)
      cx_word(i-1) = cx_word(i)
    endif
200 continue
  if (found) then
    cxnext = cxnext - 1
  else
    write(nombre,1001) number,versio
    call message(8,1,'DROP',nombre//' not in current index')
    error = .true.
    return
  endif
  call index_variable
  return
1001 format(i10,';',i6)
end subroutine clic_drop

subroutine fitpnl(x,y,n,nterms,ipar,a,niter,   &
     &    num,yfit,sigma,sigmaa,eps,bavard, good)
  !---------------------------------------------------------------------
  !	Fit non lineaire
  !
  !	N est le nombre de points
  !       NTERMS est le nombre de terms a fitter
  !       A(J),J=1,NTERMS sont les estimations initiales des parametres
  !       X(K,J),J=1,N K=1,NVAR et Y(J),J=1,N sont les valeurs des X et Y
  !       NITER est le nombre maximal d'iterations tolere
  !       NUM est le nombre d'iterations effectuees
  !       YFIT(J),J=1,N  sont les valeurs fittees
  !	SIGMA est le sigma du fit (S(Y(J)-YFIT(J))**2)/N
  !	SIGMAA(J),J=1,NTERMS sont les sigmas sur les parametres
  !	EPS est la tolerance sur SQRT(CHISQ)
  !---------------------------------------------------------------------
  ! Global
  include 'size.inc'
  !
  integer :: n                      ! Number of data points
  real*8 :: x(3,n)                  ! Data points coordinates
  real*8 :: y(n)                    ! Data points values
  integer :: nterms                 ! Number of parameters
  integer :: ipar(mvar)             !
  real*8 :: a(mvar)                 ! Parameters
  integer :: niter                  ! Maximum Number of iterations
  integer :: num                    ! Current Number of iterations
  real*8 :: yfit(n)                 ! Fitted values
  real*8 :: sigma                   ! Rms of residuals
  real*8 :: sigmaa(nterms)          ! Errors on parameters
  real*8 :: eps                     ! Stability of minimum
  logical :: bavard                 ! Write down progress
  logical :: good(n)                !
  ! Global
  real*8 :: funpnl,fchisq
  external :: funpnl,fchisq
  ! Local
  real*8 :: alpha(mvar,mvar),array(mvar,mvar),beta(mvar)
  real*8 :: deriv(mvar),b(mvar),aa(mvar)
  integer :: ntermx,i,j,k,jj,kk
  real*8 :: flamda,rts,chisq1,chisqr
  !
  ntermx=mvar
  flamda=0.001
  rts=57.29577951*3600.
  !
  do num=1,niter
    do j=1,nterms
      beta(j)=0.
      do k=1,j
        alpha(j,k)=0.
      enddo
    enddo
    do i=1,n
      if (good(i)) then
        call dpoinl(x(1,i),a,deriv)
        do  j=1,nterms
          jj=ipar(j)
          beta(j)=beta(j)+(y(i)-funpnl(x(1,i),a))*deriv(jj)
          do k=1,j
            kk=ipar(k)
            alpha(j,k)=alpha(j,k)+deriv(jj)*deriv(kk)
          enddo
        enddo
      endif
    enddo
    do j=1,nterms
      do k=1,j
        alpha(k,j)=alpha(j,k)
      enddo
    enddo
    do i=1,n
      if (good(i)) yfit(i)=funpnl(x(1,i),a)
    enddo
    chisq1=fchisq(y,n,nterms,yfit,good)
    !
    100      continue
    do j=1,nterms
      do k=1,nterms
        array(j,k)=alpha(j,k)/dsqrt(alpha(j,j)*alpha(k,k))
      enddo
      array(j,j)=1.+flamda
    enddo
    call amtinv(array,nterms)
    do j=1,nterms
      jj=ipar(j)
      b(j)=a(jj)
      do  k=1,nterms
        b(j)=b(j)+beta(k)*array(j,k)/dsqrt(alpha(j,j)*alpha(k,k))
      enddo
    enddo
    do j=1,ntermx
      aa(j)=a(j)
    enddo
    do j=1,nterms
      jj=ipar(j)
      aa(jj)=b(j)
    enddo
    do i=1,n
      if (good(i)) yfit(i)=funpnl(x(1,i),aa)
    enddo
    chisqr=fchisq(y,n,nterms,yfit,good)
    if (chisq1.lt.chisqr) then
      flamda = 10*flamda
      goto 100
    endif
    !
    ! Converged ...
    flamda=flamda/10.
    sigma=dsqrt(chisqr)
    do j=1,nterms
      jj=ipar(j)
      a(jj)=b(j)
      sigmaa(j)=dsqrt(array(j,j)/alpha(j,j))*sigma
    enddo
    if (bavard) then
      write(6,1001) num,sigma*rts
      do k=1,nterms
        jj=ipar(k)
        write(6,1000) num,jj,a(jj)*rts,sigmaa(k)*rts
      enddo
    endif
    if ((chisq1-chisqr).lt.eps*chisq1) return
  enddo
  1000  format(' ite = ',i3,' a(',i2,') =',f12.2,' err = ',f12.3)
  1001  format(' ite = ',i3,' sigma = ',f12.2)
end

subroutine setup(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>setup
  use greg_kernel
  use greg_pen
  use greg_xyz
  use greg_axes
  use greg_image
  use greg_wcs
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  GREG Support routine for command
  !  SET ...
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Command line
  logical,          intent(out)   :: error  !
  ! Local
  character(len=*), parameter :: rname='SETUP'
  integer, parameter:: h_square=3
  !
  real, parameter :: cheight_d=1.0
  real, parameter :: cwidth_d=0.8
  real, parameter :: cdef_d=0.6
  !
  real, parameter :: csymb_d=0.3
  real, parameter :: ctick_d=0.3
  real, parameter :: cmtick_d=0.15
  !
  integer, parameter :: istyle_d=0
  integer, parameter :: nsides_d=0
  !
  logical, parameter :: axis_xdecim_brief_d=.false.
  logical, parameter :: axis_xsexag_brief_d=.true.
  logical, parameter :: axis_ydecim_brief_d=.false.
  logical, parameter :: axis_ysexag_brief_d=.false.
  logical, parameter :: axis_xexpo_d=.false.
  logical, parameter :: axis_yexpo_d=.false.
  logical, parameter :: axis_zexpo_d=.false.
  !
  real, parameter :: label_xoff_d=2.0
  real, parameter :: label_yoff_d=6.0
  !
  integer(kind=4), parameter :: nwhat=21,ncoord=3,npage=4,nangu=4,nsyst=5
  integer(kind=4), parameter :: naxist=4,naxisn=3,naxisk=4,nexpot=4
  character(len=12) :: what(nwhat),coord(ncoord),page(npage),angu(nangu)
  character(len=12) :: syst(nsyst),axis_type(naxist),axis_name(naxisn)
  character(len=12) :: axis_kind(naxisk)
  character(len=12) :: chain,keyw,cfont1,cfont2,name
  character(len=32) :: argum
  character(len=256) :: local_line
  real(4), save :: lxs,lys
  real(4) :: bxs,bys,size,p1,p2,p3,p4,tangl4
  real(4) :: ratio,aspect
  real(8) :: p81,p82
  logical :: ldef,strict2011
  integer :: xsix,ysix,sever
  integer :: nl,n,i1,i2,i,ip,nc
  character(len=message_length) :: mess
  !
  ! Data
  data what /'ACCURACY','ANGLE_UNIT','AXIS','BLANKING','BOX_LOCATION',         &
             'CENTERING','CHARACTER','COORDINATES','DECIMAL','EXPAND','FONT',  &
             'LABEL','MARKER','ORIENTATION','PLOT_PAGE','SEXAGESIMAL',         &
             'SYSTEM','TICKSIZE','VIEWPORT','DRAW','COMMENT'/
  data cfont1/'SIMPLEX'/, cfont2/'DUPLEX'/
  data coord/'USER','BOX','CHARACTER'/
  data page/'LANDSCAPE','PORTRAIT','SQUARE','MATCH'/
  data angu/'SECOND','MINUTE','DEGREE','RADIAN'/
  data syst/'UNKNOWN','EQUATORIAL','GALACTIC','HORIZONTAL','ICRS'/
  data axis_type/'NOBRIEF','BRIEF','EXPONENT','NOEXPONENT'/
  data axis_name/'X','Y','Z'/
  data axis_kind/'XDECIMAL','YDECIMAL','XSEXAGESIMAL','YSEXAGESIMAL'/
  data lxs/lxs_d/, lys/lys_d/
  !
  ! Default
  error = .false.
  ldef = sic_present(1,0)
  if (.not.sic_present(0,1)) then
    if (ldef) then
      !
      ! Default Values
      accurd  = 0.01
      u_angle = 4
      tangle = 0.0d0
      axis_xdecim_brief = axis_xdecim_brief_d
      axis_xsexag_brief = axis_xsexag_brief_d
      axis_ydecim_brief = axis_ydecim_brief_d
      axis_ysexag_brief = axis_ysexag_brief_d
      axis_xexpo = axis_xexpo_d
      axis_yexpo = axis_yexpo_d
      axis_zexpo = axis_zexpo_d
      cdef  = cdef_d
      cwidth = cwidth_d
      cheight = cheight_d
      csymb = csymb_d
      ctick = ctick_d
      cmtick = cmtick_d
      gx1  = gx1_d
      gy1  = gy1_d
      gx2  = gx2_d
      gy2  = gy2_d
      istyle = istyle_d
      nsides = nsides_d
      expand  = 1.0
      icente = 0
      iboxd  = 0
      xsixty = format_decimal
      ysixty = format_decimal
      ndecimx = 1
      ndecimy = 0
      call setphysical(lxs_d,lys_d)
      call setlim(gux1,gux2,guy1,guy2)
      call setrem              ! Helps if even no projection
      h_mode  = h_landscape
      cblank = 0.d0
      eblank = -1.d0
      i_system = type_un
      i_equinox = equinox_null  ! Not relevant for UNKNOWN system
      smallx = 0               ! Automatic ticking
      bigx = 0
      smally = 0
      bigy = 0
      i_font = 0               ! This is not very consistent indeed
      penupd = .true.
      label_xoff = label_xoff_d
      label_yoff = label_yoff_d
      return
    else
      call greg_message(seve%e,'SET','Missing argument')
      error = .true.
      return
    endif
  endif
  !
  call sic_ke (line,0,1,chain,nc,.true.,error)
  if (error) return
  call sic_ambigs('SET',chain,keyw,n,what,nwhat,error)
  if (error) return
  if (ldef .and. sic_present(0,2)) then
    call greg_message(seve%e,'SET','No parameter value allowed with '//  &
    '/DEFAULT option')
    error = .true.
    return
  elseif (.not.ldef .and. .not.sic_present(0,2)) then
    call greg_message(seve%e,'SET','Missing parameter value(s)')
    error = .true.
    return
  endif
  ip = index(line,' ') + 1
  nl = ip + lenc(chain)
  !
  select case(keyw)
  !
  ! Accuracy of plot
  case('ACCURACY')
    if (ldef) then
      accurd = 0.01
    else
      call sic_r4 (line,0,2,accurd,.true.,error)
      if (error) return
      accurd = max(0.0001,(min(1.,accurd)))
    endif
  !
  ! Angle unit of projection
  case('ANGLE_UNIT')
    if (ldef) then
      u_angle = 4
    else
      call sic_ke (line,0,2,name,nc,.true.,error)
      if (error) return
      call sic_ambigs('SET ANGLE',name,argum,n,angu,nangu,error)
      if (error) return
      u_angle = n
      if (gproj%type.eq.p_none .and. u_angle.ne.4) then
        call greg_message(seve%w,'SETUP','Angular unit ignored when no '//  &
        'projection defined')
        u_angle = 4
      endif
    endif
  !
  ! Axis
  case('AXIS')
    if (ldef) then
      axis_xdecim_brief = axis_xdecim_brief_d
      axis_xsexag_brief = axis_xsexag_brief_d
      axis_ydecim_brief = axis_ydecim_brief_d
      axis_ysexag_brief = axis_ysexag_brief_d
      axis_xexpo = axis_xexpo_d
      axis_yexpo = axis_yexpo_d
      axis_zexpo = axis_zexpo_d
    else
      call sic_ke (line,0,2,name,nc,.true.,error)
      if (error) return
      call sic_ambigs('SET AXIS',name,argum,i,axis_type,naxist,error)
      if (error) return
      !
      if (i.le.2) then  ! BRIEF|NOBRIEF
        if (sic_present(0,3)) then
          call sic_ke (line,0,3,name,nc,.true.,error)
          if (error) return
          call sic_ambigs('SET AXIS',name,argum,n,axis_kind,naxisk,error)
          if (error) return
          !
          if (n.eq.1) then
            axis_xdecim_brief = i.eq.2
          elseif (n.eq.2) then
            axis_ydecim_brief = i.eq.2
          elseif (n.eq.3) then
            axis_xsexag_brief = i.eq.2
          elseif (n.eq.4) then
            axis_ysexag_brief = i.eq.2
          endif
          !
        else
          axis_xdecim_brief = i.eq.2
          axis_xsexag_brief = i.eq.2
          axis_ydecim_brief = i.eq.2
          axis_ysexag_brief = i.eq.2
        endif
        !
      else  ! EXPO|NOEXPO
        if (sic_present(0,3)) then
          call sic_ke (line,0,3,name,nc,.true.,error)
          if (error) return
          call sic_ambigs('SET AXIS',name,argum,n,axis_name,naxisn,error)
          if (error) return
          !
          if (n.eq.1) then
            axis_xexpo = i.eq.3
          elseif (n.eq.2) then
            axis_yexpo = i.eq.3
          elseif (n.eq.3) then
            axis_zexpo = i.eq.3
          endif
        else
          axis_xexpo = i.eq.3
          axis_yexpo = i.eq.3
          axis_zexpo = i.eq.3
        endif
      endif
    endif
  !
  ! Blanking value
  case('BLANKING')
    if (ldef) then
      eblank = -1.d0
    else
      call sic_r8 (line,0,2,p81,.true.,error)
      if (error) return
      call sic_r8 (line,0,3,p82,.true.,error)
      if (error) return
      cblank = p81
      eblank = p82
    endif
  !
  ! Box position
  case('BOX_LOCATION')
    p1 = gx1
    p2 = gx2
    p3 = gy1
    p4 = gy2
    if (.not.ldef) then
      call sic_ke (line,0,2,name,nc,.true.,error)
      if (error) return
      n = lenc(name)
    endif
    if (ldef .or. name(1:n).eq.page(4)(1:n)) then
      if (h_mode.eq.h_landscape) then
        gx1 = gx1_d
        gy1 = gy1_d
        gx2 = gx2_d
        gy2 = gy2_d
      elseif (h_mode.eq.h_portrait) then
        gx1 = gy1_d
        gx2 = gy2_d
        gy1 = gx1_d
        gy2 = gx2_d
      elseif (h_mode.eq.h_square) then
        gx1 = 0.150*lxs
        gx2 = 0.925*lxs
        gy1 = 0.125*lxs
        gy2 = 0.900*lxs
      else
        bxs = lx2-lx1
        bys = ly2-ly1
        gx1 = 0.150*bxs
        gx2 = 0.925*bxs
        gy1 = 0.125*bys
        gy2 = 0.900*bys
      endif
      ! SET BOX_LOCATION MATCH X Y Ratio
      if (ldef) then
        line(ip:) = 'BOX_LOCATION /DEFAULT'
      else
        call sic_r4 (line,0,3,gx1,.false.,error)
        if (error) return
        call sic_r4 (line,0,4,gy1,.false.,error)
        if (error) return
        ratio = 1.0
        call sic_r4 (line,0,5,ratio,.false.,error)
        if (error) return
        aspect = abs((guy2-guy1)/(gux2-gux1)*ratio)
        if (aspect.gt.1e2 .or. aspect.lt.1e-2) then
          call greg_message(seve%e,'SET BOX MATCH','Invalid aspect ratio')
          error = .true.
          return
        endif
        if ((gx2-gx1)*aspect.gt.(gy2-gy1)) then
          gx2 = gx1 + (gy2-gy1)/aspect
        else
          gy2 = gy1 + (gx2-gx1)*aspect
        endif
        local_line = line(nl:)
        line(ip:) = 'BOX_LOCATION'//local_line
      endif
    else
      call sic_ke (line,0,2,name,nc,.true.,error)
      if (error) return
      n = lenc(name)
      ! Landscape style box
      if (name(1:n).eq.page(1)(1:n)) then
        gx1 = gx1_d
        gx2 = gx2_d
        gy1 = gy1_d
        gy2 = gy2_d
        line(ip:) = 'BOX_LOCATION LANDSCAPE'
        ! Portrait style box
      elseif (name(1:n).eq.page(2)(1:n)) then
        gx1 = gy1_d
        gx2 = gy2_d
        gy1 = gx1_d
        gy2 = gx2_d
        line(ip:) = 'BOX_LOCATION PORTRAIT'
        ! Square box
      elseif (name(1:n).eq.page(3)(1:n)) then
        size = min(lx2-lx1,ly2-ly1)
        if (lx2-lx1.gt.ly2-ly1) then
          gx2 = 0.900*lx2
          gx1 = gx2 - 0.750*size
          gy1 = 0.150*size
          gy2 = 0.900*size
        else
          gy1 = 0.125*lx2
          gy2 = gy1 + 0.750*size
          gx1 = 0.150*size
          gx2 = 0.900*size
        endif
        line(ip:) = 'BOX_LOCATION SQUARE'
        ! Error
      elseif (.not.sic_present(0,5)) then
        call greg_message(seve%e,'SET BOX_LOCATION','Four arguments required')
        error = .true.
        return
      else
        ! Given size box
        call sic_r4 (line,0,2,gx1,.false.,error)
        if (error) return
        call sic_r4 (line,0,3,gx2,.false.,error)
        if (error) return
        call sic_r4 (line,0,4,gy1,.false.,error)
        if (error) return
        call sic_r4 (line,0,5,gy2,.false.,error)
        if (error) return
        local_line = line(nl:)
        line(ip:) = 'BOX_LOCATION'//local_line
      endif
      if (gx1.ge.gx2 .or. gy1.ge.gy2 .or. gx1.lt.lx1 .or. gx2.gt.lx2 .or.  &
          gy1.lt.ly1 .or. gy2.gt.ly2) then
        write(mess,'(A,4(2X,F0.2))') 'Invalid BOX_LOCATION',gx1,gx2,gy1,gy2
        call greg_message(seve%e,rname,mess)
        gx1 = p1
        gx2 = p2
        gy1 = p3
        gy2 = p4
        error = .true.
        return
      endif
    endif
    call setlim(gux1,gux2,guy1,guy2)
    return
  !
  ! Centering Option
  case('CENTERING')
    if (ldef) then
      icente = 0
    else
      call sic_i4 (line,0,2,icente,.true.,error)
      if (error) return
      icente = min( max(icente,0),9)
    endif
  !
  ! Character Size
  case('CHARACTER')
    if (ldef) then
      cdef = cdef_d
    else
      call sic_r4 (line,0,2,cdef,.true.,error)
      if (error) return
    endif
  !
  ! Coordinate System
  case('COORDINATES')
    if (.not.sic_present(0,2)) then  ! /DEFAULT case
      iboxd = 0
      line(ip:) = 'COORDINATE BOX 0'
    else
      call sic_ke (line,0,2,name,nc,.true.,error)
      if (error) return
      call sic_ambigs('SET COORDINATE',name,argum,n,coord,ncoord,error)
      if (error) return
      if (n.eq.1) then
        iboxd = -1
        line(ip:) = 'COORDINATE USER'
      else
        iboxd = 10*(n-2)
        i = 0
        call sic_i4 (line,0,3,i,.false.,error)
        if (error) return
        if (n.ge.0 .and. n.le.9) then
          name(1:1) = char(i+ichar('0'))
          if (n.eq.2) then
            line(ip:) = 'COORDINATE BOX '//name(1:1)
          else
            line(ip:) = 'COORDINATE CHARACTER '//name(1:1)
          endif
          iboxd = iboxd+i
        else
          call greg_message(seve%e,'SET','Coordinate reference out of range')
          error = .true.
          return
        endif
      endif
    endif
    return
  !
  ! Decimal labels
  case('DECIMAL')
    if (ldef) then
      xsixty = format_decimal  ! SET DECIMAL /DEFAULT
      ysixty = format_decimal
    else
      xsix = xsixty
      ysix = ysixty
      if (sic_present(0,3)) then
        call sic_ke (line,0,3,name,nc,.true.,error)
        if (error) return
        if (name.eq.'X') then
          xsix = format_decimal
        elseif (name.eq.'Y') then
          ysix = format_decimal
        else
          call greg_message(seve%e,'SET','SET DECIMAL [X] [Y]')
          error = .true.
          return
        endif
      endif
      if (sic_present(0,2)) then
        call sic_ke (line,0,2,name,nc,.true.,error)
        if (error) return
        if (name.eq.'X') then
          xsix = format_decimal
        elseif (name.eq.'Y') then
          ysix = format_decimal
        else
          call greg_message(seve%e,'SET','SET DECIMAL [X] [Y]')
          error = .true.
          return
        endif
      endif
      xsixty = xsix
      ysixty = ysix
    endif
  !
  ! Expansion Factor
  case('EXPAND')
    if (ldef) then
      expand = 1.0
    else
      call sic_r4 (line,0,2,expand,.true.,error)
      if (error) return
    endif
  !
  ! Font Type
  case('FONT')
    if (ldef) then
      name = 'SIMPLEX'
      i_font = 0
    else
      call sic_ke (line,0,2,name,nc,.true.,error)
      if (error) return
      n = lenc(name)
      if (name(1:n).eq.cfont1(1:n)) then
        i_font = 0
      elseif (name(1:n).eq.cfont2(1:n)) then
        i_font = 1
      else
        call greg_message(seve%e,'SET','SET FONT SIMPLEX or DUPLEX')
        error = .true.
        return
      endif
    endif
    penupd = .true.
  !
  ! Labeling
  case('LABEL')
    if (ldef) then
      label_xoff = label_xoff_d
      label_yoff = label_yoff_d
    else
      call sic_ke (line,0,2,name,nc,.true.,error)
      if (error) return
      call sic_ambigs('SET LABEL',name,argum,i,axis_name,naxisn,error)
      if (error) return
      if (i.eq.1) then
        label_xoff = label_xoff_d
        call sic_r4 (line,0,3,label_xoff,.false.,error)
      else if (i.eq.2) then
        label_yoff = label_yoff_d
        call sic_r4 (line,0,3,label_yoff,.false.,error)
      endif
    endif
  !
  ! Style of Markers
  case('MARKER')
    if (ldef) then
      nsides = nsides_d
      istyle = istyle_d
      csymb = csymb_d
      sangle = 0.d0
    elseif (.not.sic_present(0,4)) then
      call greg_message(seve%e,'SET MARKER','4 arguments (or *) required')
      error = .true.
      return
    else
      i1 = nsides
      i2 = istyle
      p3 = csymb
      p4 = sangle
      argum = '*'
      call sic_ch (line,0,2,argum,nc,.false.,error)
      if (argum.ne.'*') then
        call sic_math_inte(argum,nc,i1,error)
        if (error) return
      endif
      argum = '*'
      call sic_ch (line,0,3,argum,nc,.false.,error)
      if (argum.ne.'*') then
        call sic_math_inte(argum,nc,i2,error)
        if (error) return
      endif
      argum = '*'
      call sic_ch (line,0,4,argum,nc,.false.,error)
      if (argum.ne.'*') then
        call sic_math_real(argum,nc,p3,error)
        if (error) return
      endif
      argum = '*'
      call sic_ch (line,0,5,argum,nc,.false.,error)
      if (argum.ne.'*') then
        call sic_math_real(argum,nc,p4,error)
        if (error) return
      endif
      call setnsides(i1)         ! check and set nsides
      call setsty(i2)            ! check and set istyle
      call setsym(p3)            ! check and set csymb
      tangl4 = tangle            ! setang() requires R*4 arguments:
      call setang(tangl4,p4)     ! set sangle
    endif
  !
  ! Orientation of character strings
  case('ORIENTATION')
    if (ldef) then
      tangle = 0.0d0
      sangle = 0.0d0
    else
      call sic_r8 (line,0,2,tangle,.true.,error)
      sangle = tangle
      call sic_r8 (line,0,3,sangle,.false.,error)
      if (error) return
    endif
  !
  ! Plot_page size
  case('PLOT_PAGE')
    if (ldef) then
      lxs = lxs_d                ! Landscape Style by default
      lys = lys_d
      line(ip:) = 'PLOT_PAGE LANDSCAPE'
      h_mode = h_landscape
    else
      call sic_ch (line,0,2,name,nc,.true.,error)
      if (error) return
      n = lenc(name)
      call sic_upper(name)
      ! Landscape style box
      if (name(1:n).eq.page(1)(1:n)) then
        lxs = lxs_d
        lys = lys_d
        line(ip:) = 'PLOT_PAGE LANDSCAPE'
        h_mode = h_landscape
        ! Portrait style box
      elseif (name(1:n).eq.page(2)(1:n)) then
        lxs = lys_d
        lys = lxs_d
        line(ip:) = 'PLOT_PAGE PORTRAIT'
        h_mode = h_portrait
      elseif (name(1:n).eq.page(3)(1:n)) then
        lxs = lxs_d
        lys = lxs_d
        line(ip:) = 'PLOT_PAGE SQUARE'
        h_mode = h_square
        ! Error
      elseif (.not.sic_present(0,3)) then
        call greg_message(seve%e,'SET PLOT_PAGE','2 arguments required')
        error = .true.
        return
      else
        ! Given size page
        chain = '*'
        call sic_ch (line,0,2,chain,nc,.true.,error)
        if (error) return
        if (chain.eq.'*') then
          lxs = lx2
        else
          call sic_r4 (line,0,2,lxs,.true.,error)
          if (error) return
        endif
        chain = '*'
        call sic_ch (line,0,3,chain,nc,.true.,error)
        if (error) return
        if (chain.eq.'*') then
          lys = ly2
        else
          call sic_r4 (line,0,3,lys,.true.,error)
          if (error) return
        endif
        local_line = line(nl:)
        line(ip:) = 'PLOT_PAGE'//local_line
        h_mode = h_nonstandard
      endif
      !
      if (lxs.lt.0 .or. lys.lt.0) then
        call greg_message(seve%e,'SET','Invalid PLOT_PAGE')
        error = .true.
        return
      endif
    endif
    !
    call greg_message(seve%i,'SET','Clearing the tree and resetting BOX_LOCATION')
    call setphysical(lxs,lys)
    if (h_mode.eq.h_landscape) then
      gx1 = gx1_d
      gy1 = gy1_d
      gx2 = gx2_d
      gy2 = gy2_d
    elseif (h_mode.eq.h_portrait) then
      gx1 = gy1_d
      gx2 = gy2_d
      gy1 = gx1_d
      gy2 = gx2_d
    elseif (h_mode.eq.h_square) then
      gx1 = 0.150*lxs
      gx2 = 0.925*lxs
      gy1 = 0.125*lxs
      gy2 = 0.900*lxs
    else
      bxs = lx2-lx1
      bys = ly2-ly1
      gx1 = 0.150*bxs
      gx2 = 0.925*bxs
      gy1 = 0.125*bys
      gy2 = 0.900*bys
    endif
    call setlim(gux1,gux2,guy1,guy2)
    return
  !
  ! Sexagesimal labels
  case('SEXAGESIMAL')
    if (ldef) then               ! SET SEXAGESIMAL /DEFAULT
      ndecimx = 1
      ndecimy = 0
      xsixty = format_sexage_none
      ysixty = format_sexage_none
    else
      xsix = xsixty
      ysix = ysixty
      if (sic_present(0,4)) then
        call sic_ke (line,0,4,name,nc,.true.,error)
        if (error) return
        if (name.eq.'X') then
          call sic_i4 (line,0,5,ndecimx,.true.,error)
          if (error) return
          xsix = format_sexage_none
        elseif (name.eq.'Y') then
          call sic_i4 (line,0,5,ndecimy,.true.,error)
          if (error) return
          ysix = format_sexage_none
        else
          call greg_message(seve%e,'SET','SET SEXAGESIMAL [X NX] [Y NY]')
          error = .true.
          return
        endif
      endif
      if (sic_present(0,2)) then
        call sic_ke (line,0,2,name,nc,.true.,error)
        if (error) return
        if (name.eq.'X') then
          call sic_i4 (line,0,3,ndecimx,.true.,error)
          if (error) return
          xsix = format_sexage_none
        elseif (name.eq.'Y') then
          call sic_i4 (line,0,3,ndecimy,.true.,error)
          if (error) return
          ysix = format_sexage_none
        else
          call greg_message(seve%e,'SET','SET SEXAGESIMAL [X NX] [Y NY]')
          error = .true.
          return
        endif
      endif
      ndecimx = max(0,ndecimx)
      ndecimy = max(0,ndecimy)
      xsixty = xsix
      ysixty = ysix
    endif
  !
  ! System for projections
  case('SYSTEM')
    if (ldef) then
      i_system = type_un
      i_equinox = equinox_null  ! Not relevant for UNKNOWN system
    else
      call sic_ke (line,0,2,name,nc,.true.,error)
      if (error) return
      call sic_ambigs('SET SYSTEM',name,argum,n,syst,nsyst,error)
      if (error) return
      i_system = n
      if (i_system.eq.type_eq) then
        i_equinox = i_equinox_def
        call sic_r4(line,0,3,i_equinox,.false.,error)
        if (error)  return
      else
        i_equinox = equinox_null  ! Not relevant for UNKNOWN system
      endif
    endif
  !
  ! Size of Ticks
  case('TICKSIZE')
    if (ldef) then
      ctick = ctick_d
      cmtick = cmtick_d
    else
      call sic_r4 (line,0,2,ctick,.true.,error)
      if (error) return
      if (sic_present(0,3)) then
        call sic_r4 (line,0,3,cmtick,.true.,error)
      else
        cmtick = 0.5*ctick
      endif
      if (error) return
    endif
  !
  ! View port : relative size
  case('VIEWPORT')
    bxs = lx2-lx1
    bys = ly2-ly1
    p1 = gx1
    p2 = gx2
    p3 = gy1
    p4 = gy2
    if (ldef) then
      gx1 = 0.150*bxs
      gx2 = 0.925*bxs
      gy1 = 0.125*bys
      gy2 = 0.900*bys
    elseif (.not.sic_present(0,5)) then
      call greg_message(seve%e,'SET VIEW_PORT','Four arguments required')
      error = .true.
      return
    else
      call sic_r4 (line,0,2,gx1,.false.,error)
      if (error) return
      call sic_r4 (line,0,3,gx2,.false.,error)
      if (error) return
      call sic_r4 (line,0,4,gy1,.false.,error)
      if (error) return
      call sic_r4 (line,0,5,gy2,.false.,error)
      if (error) return
      gx1 = gx1*bxs
      gx2 = gx2*bxs
      gy1 = gy1*bys
      gy2 = gy2*bys
    endif
    if (gx1.ge.gx2 .or. gy1.ge.gy2 .or. gx1.lt.lx1 .or. gx2.gt.lx2 .or.  &
        gy1.lt.ly1 .or. gy2.gt.ly2) then
      call greg_message(seve%e,'SET','Invalid VIEWPORT')
      gx1 = p1
      gx2 = p2
      gy1 = p3
      gy2 = p4
      error = .true.
      return
    endif
    call setlim(gux1,gux2,guy1,guy2)
  !
  ! Drawing State : ON or OFF (obsolete)
  case('DRAW')
    call sic_get_logi('GTV%STRICT2011',strict2011,error)
    if (strict2011) then
      sever = seve%e
    else
      sever = seve%w
    endif
    call greg_message(sever,rname,'GREG1\SET DRAW is obsolete. GTVirt is always awake.')
    if (strict2011) then
      error = .true.
      return
    endif
  !
  ! COMMENT indicator (for COLUMN)
  case('COMMENT')
    call sic_ch (line,0,2,argum,nc,.true.,error)
    if (error) return
    if (nc.ne.1) then
      call greg_message(seve%e,'SET','Comment separator must be 1 char')
      error = .true.
    else
      comment = argum
    endif
  !
  case default
    call greg_message(seve%e,'SET','Internal error, unknown keyword '//keyw)
    error=.true.
    return
  end select
  !
  ! O.K. Expand the line
  local_line = line(nl:)
  line(ip:) = trim(keyw)//local_line
end subroutine setup

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_convert
  use cubetools_parameters
  use cubetools_messaging
  !
  public :: cubetools_convert_val2zero,cubetools_convert_fres2vres,cubetools_convert_vres2fres
  private
  !
contains
  !
  subroutine cubetools_convert_val2zero(inref,inval,ininc,ouref)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    real(kind=coor_k), intent(in)  :: inref
    real(kind=coor_k), intent(in)  :: inval
    real(kind=coor_k), intent(in)  :: ininc
    real(kind=coor_k), intent(out) :: ouref
    !
    character(len=*), parameter :: rname='CONVERT>VAL2ZERO'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    ouref = inref-(inval/ininc)
  end subroutine cubetools_convert_val2zero
  !
  function cubetools_convert_fres2vres(fres,freq) result(vres)
    use phys_const
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    real(kind=coor_k)            :: vres
    real(kind=coor_k),intent(in) :: fres
    real(kind=coor_k),intent(in) :: freq
    !
    vres=-fres*clight_kms/freq
  end function cubetools_convert_fres2vres
  !
  function cubetools_convert_vres2fres(vres,freq) result(fres)
    use phys_const
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    real(kind=coor_k)            :: fres
    real(kind=coor_k),intent(in) :: vres
    real(kind=coor_k),intent(in) :: freq
    !
    fres=-freq*vres/clight_kms
  end function cubetools_convert_vres2fres
end module cubetools_convert
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_Feed(holodata,error)
  !---------------------------------------------------------------------
  ! Write the Feed SDM table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_enumerations
  use sdm_feed
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical holodata, error
  ! Local
  type (FeedRow) :: fRow
  type (FeedKey) :: fKey
  type (FeedOpt) :: fOpt
  integer ia, ic, isb, ilc, ier
  integer, parameter :: minalloc = 1
  character, parameter  :: sdmTable*4 = 'Feed'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  !     normal case
  !
  if (.not.holodata) then
    !
    !         fRow%numReceptors = 2
    ! one only for CURRENT Bure data !!!
    ! now get from r_npol_rec
    !cc         fRow%numReceptors = 1
    fRow%numReceptor = r_npol_rec
    call allocFeedRow(frow, fRow%numReceptor,  error)
    if (error) return
    !     NOW OPTIONAL IN SS2 fRow%feedNum = 0
    !     loop on antennas
    do ia=1, r_nant
      ! *TBD* *Check*
      !     These should be in Bure data for the new receivers. They are not
      !     at this time.
      fRow%beamOffset = 0.     !! (/ 0.d0, 0.d0  /)
      !     *TBD* What is Focus Reference?
      !     Useless entry I guess ...
      fRow%focusReference = 0.0d0
      !     *TBD* It's the set of illumOffset, illumOffsetPa which is optional.
      !     *TBD* the frame system for illumOffsetPA is not obvious.
      !     May be this is crossed...
      fRow%polarizationTypes(1) = PolarizationType_X
      if (fRow%numReceptor.ge.2) fRow%polarizationTypes(2) =   &
        PolarizationType_Y
      !            fRow%polarizationType(2) = 'Y'//char(0)
      !     *TBD* meaning not understood (relative complex gains of products?)
      !     Then this is a derived quantity from calibration... and probably
      !     very much frequency dependent.
      fRow%polResponse = 0
      !     *TBD* Do not understand the meaning of these numbers. Coordinate
      !     system should be precised
      !     NOW OPTIONAL IN SS2             fRow%xPosition = 0
      !     NOW OPTIONAL IN SS2             fRow%yPosition = 0
      !     NOW OPTIONAL IN SS2             fRow%zPosition = 0
      !     *TBD* With respect to what??
      !            fRow%receptorAngle = (/ 0.d0, (pi/2.d0) /)
      fRow%receptorAngle = 0.d0
      !     loops on spectral windows:
      !     loop on side bands, line/continuum
      do isb = 1, r_lnsb
        !     loop on line subbands
        do ic = 1, r_lband
          do ilc = 1, 2
            fKey%antennaId = antenna_Id(ia)
            fKey%spectralWindowId = spectralWindow_Id(isb,ic   &
              ,ilc)
            fKey%timeInterval = ArrayTimeInterval(time_Start(1)   &
              ,time_Start(2))
            !     NOW OPTIONAL IN SS2                      fRow%beamId = beam_Id
            fRow%receiverId = receiver_Id(ia, isb, ic, ilc)
            call addFeedRow(fKey, fRow, error)
            if (error) return
            feed_Id = fKey%feedId
            if (feed_Id.ne.0) then
              call sdmMessageI(6,3,sdmTable   &
                ,'FeedId is not zero: ',feed_Id)
              print *, 'fKey ', fKey
            !     c                     goto 99
            endif
          enddo
        enddo
        !     Total Power
        fKey%spectralWindowId = TotPowSpectralWindow_Id(isb)
        fRow%receiverId = TotPowReceiver_Id(ia, isb)
        call addFeedRow(fKey, fRow, error)
        if (error) return
        feed_Id = fKey%feedId
        if (feed_Id.ne.0) then
          call sdmMessageI(6,3,sdmTable   &
            ,'- FeedId is not zero: ',feed_Id)
          print *, 'fKey ', fKey
        !     c                     goto 99
        endif
      enddo
    enddo
  !
  !     Holography case
  !
  else
    fRow%numReceptor = 1
    call allocFeedRow(frow, fRow%numReceptor,  error)
    if (error) return
    !     NOW OPTIONAL IN SS2          fRow%feedNum = 0
    !     loop on antennas
    do ia=1, r_nant
      fRow%beamOffset = 0.     !! (/ 0.d0, 0.d0  /)
      fRow%polarizationTypes(1) = PolarizationType_X   ! 'X'//char(0)
      fRow%polResponse = 0
      !     NOW OPTIONAL IN SS2             fRow%xPosition = 0
      !     NOW OPTIONAL IN SS2             fRow%yPosition = 0
      !     NOW OPTIONAL IN SS2             fRow%zPosition = 0
      fRow%receptorAngle = (/ 0.d0, (pi/2.d0) /)
      fRow%focusReference = 0.0d0
      fKey%antennaId = antenna_Id(ia)
      fKey%spectralWindowId = totPowSpectralWindow_Id(1)
      fKey%timeInterval = ArrayTimeInterval(time_Start(1),   &
        time_Start(2))
      !     NOW OPTIONAL IN SS2             fRow%beamId = beam_Id
      fRow%receiverId = totPowReceiver_Id(ia, 1)
      !$$$            print *, 'feed time_Interval ', time_Interval
      !$$$            print *, 'feed time_start ', time_start
      call addFeedRow(fKey, fRow, error)
      if (error) return
      feed_Id = fKey%feedId
      if (feed_Id.ne.0) then
        call sdmMessageI(6,3,sdmTable   &
          ,'FeedId is not zero: ',feed_Id)
      endif
    enddo
  endif
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_Feed
!---------------------------------------------------------------------
subroutine get_sdm_Feed(error)
  !---------------------------------------------------------------------
  ! Read the Feed SDM table.
  ! Key: antennaId spectralWindowId timeInterval  ...
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_feed
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (FeedRow) :: fRow
  type (FeedKey) :: fKey
  type (FeedOpt) :: fOpt
  integer mreceptors
  parameter (mreceptors = 2)
  integer ia, ic, isb, ilc, i, ier
  character, parameter  :: sdmTable*4 = 'Feed'
  !      integer, parameter :: minalloc = 1
  !---------------------------------------------------------------------
  ier = 0
  call sdmMessage(1,1,sdmTable ,'starting...')
  fRow%numReceptor = mreceptors
  call allocFeedRow(frow, error)
  if (error) return
  !      numReceptors = 2
  !      feedNum = 0
  !     loop on antennas
  do ia=1, r_nant
    ! *TBD* *Check* the dimensions of BeamId and ReceiverId...
    !     loops on spectral windows:
    do i=1, ddId_Size
      ! semble necessaire...
      feed_Id = 0
      fKey%feedId = feed_Id
      fKey%antennaId = antenna_Id(ia)
      fKey%spectralWindowId = swId_List(i)
      fKey%timeInterval = ArrayTimeInterval(time_Interval(1),   &
        time_Interval(2))
      call getFeedRow(fKey, fRow, error)
      if (error) then
        print *, 'fKey: ',fKey
      endif
      receiverId_List(ia, i) = fRow%receiverId(1)
      ! numReceptor is now set to 2 in ALMA. 
      ! we need the actual number of polarizations whuch is in the 
      ! CorrelatorMode table.
      ! r_npol_rec = fRow%numReceptor
    enddo
  enddo
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
end subroutine get_sdm_Feed
!---------------------------------------------------------------------
!!! subroutine allocFeedRow(row, numReceptor,  error)
!!!   !---------------------------------------------------------------------
!!!   !$$$    integer, allocatable :: beamId(:)
!!!   !$$$    integer, allocatable :: receiverId(:)
!!!   !$$$    real*8, allocatable :: beamOffset(:,:)
!!!   !$$$    character*256, allocatable :: polarizationType(:)
!!!   !$$$    Complex, allocatable :: polResponse(:,:)
!!!   !$$$    real*8, allocatable :: receptorAngle(:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_Feed
!!!   type(FeedRow) :: row
!!!   integer :: numReceptor, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*4 = 'Feed'
!!!   !
!!!   ! beamId
!!!   !     NOW OPTIONAL IN SS2       if (allocated(row%beamId)) then
!!!   !     NOW OPTIONAL IN SS2          deallocate(row%beamId, stat=ier)
!!!   !     NOW OPTIONAL IN SS2          if (ier.ne.0) goto 98
!!!   !     NOW OPTIONAL IN SS2       endif
!!!   !     NOW OPTIONAL IN SS2       allocate(row%beamId(numReceptor), stat=ier)
!!!   !     NOW OPTIONAL IN SS2       if (ier.ne.0) goto 99
!!!   !
!!!   ! receiverId
!!!   if (allocated(row%receiverId)) then
!!!     deallocate(row%receiverId, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%receiverId(numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! beamOffset
!!!   if (allocated(row%beamOffset)) then
!!!     deallocate(row%beamOffset, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%beamOffset(2, numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! focusReference
!!!   if (allocated(row%focusReference)) then
!!!     deallocate(row%focusReference, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%focusReference(3, numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! polarizationType
!!!   if (allocated(row%polarizationTypes)) then
!!!     deallocate(row%polarizationTypes, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%polarizationTypes(numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! polResponse
!!!   if (allocated(row%polResponse)) then
!!!     deallocate(row%polResponse, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%polResponse(numReceptor, numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! receptorAngle
!!!   if (allocated(row%receptorAngle)) then
!!!     deallocate(row%receptorAngle, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%receptorAngle(numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end

*DECK DWNLIT
      SUBROUTINE DWNLIT (W, MDW, M, N, L, IPIVOT, ITYPE, H, SCALE,
     +   RNORM, IDOPE, DOPE, DONE)
C***BEGIN PROLOGUE  DWNLIT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DWNNLS
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (WNLIT-S, DWNLIT-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     This is a companion subprogram to DWNNLS( ).
C     The documentation for DWNNLS( ) has complete usage instructions.
C
C     Note  The M by (N+1) matrix W( , ) contains the rt. hand side
C           B as the (N+1)st col.
C
C     Triangularize L1 by L1 subsystem, where L1=MIN(M,L), with
C     col interchanges.
C
C***SEE ALSO  DWNNLS
C***ROUTINES CALLED  DCOPY, DH12, DROTM, DROTMG, DSCAL, DSWAP, DWNLT1,
C                    DWNLT2, DWNLT3, IDAMAX
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and revised.  (WRB & RWC)
C   890620  Revised to make WNLT1, WNLT2, and WNLT3 subroutines.  (RWC)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900604  DP version created from SP version. .  (RWC)
C***END PROLOGUE  DWNLIT
      INTEGER IDOPE(*), IPIVOT(*), ITYPE(*), L, M, MDW, N
      DOUBLE PRECISION DOPE(*), H(*), RNORM, SCALE(*), W(MDW,*)
      LOGICAL DONE
C
      EXTERNAL DCOPY, DH12, DROTM, DROTMG, DSCAL, DSWAP, DWNLT1,
     *   DWNLT2, DWNLT3, IDAMAX
      INTEGER IDAMAX
      LOGICAL DWNLT2
C
      DOUBLE PRECISION ALSQ, AMAX, EANORM, FACTOR, HBAR, RN, SPARAM(5),
     *   T, TAU
      INTEGER I, I1, IMAX, IR, J, J1, JJ, JP, KRANK, L1, LB, LEND, ME,
     *   MEND, NIV, NSOLN
      LOGICAL INDEP, RECALC
C
C***FIRST EXECUTABLE STATEMENT  DWNLIT
      ME    = IDOPE(1)
      NSOLN = IDOPE(2)
      L1    = IDOPE(3)
C
      ALSQ   = DOPE(1)
      EANORM = DOPE(2)
      TAU    = DOPE(3)
C
      LB     = MIN(M-1,L)
      RECALC = .TRUE.
      RNORM  = 0.D0
      KRANK  = 0
C
C     We set FACTOR=1.0 so that the heavy weight ALAMDA will be
C     included in the test for column independence.
C
      FACTOR = 1.D0
      LEND = L
      DO 180 I=1,LB
C
C        Set IR to point to the I-th row.
C
         IR = I
         MEND = M
         CALL DWNLT1 (I, LEND, M, IR, MDW, RECALC, IMAX, HBAR, H, SCALE,
     +                W)
C
C        Update column SS and find pivot column.
C
         CALL DWNLT3 (I, IMAX, M, MDW, IPIVOT, H, W)
C
C        Perform column interchange.
C        Test independence of incoming column.
C
  130    IF (DWNLT2(ME, MEND, IR, FACTOR, TAU, SCALE, W(1,I))) THEN
C
C           Eliminate I-th column below diagonal using modified Givens
C           transformations applied to (A B).
C
C           When operating near the ME line, use the largest element
C           above it as the pivot.
C
            DO 160 J=M,I+1,-1
               JP = J-1
               IF (J.EQ.ME+1) THEN
                  IMAX = ME
                  AMAX = SCALE(ME)*W(ME,I)**2
                  DO 150 JP=J-1,I,-1
                     T = SCALE(JP)*W(JP,I)**2
                     IF (T.GT.AMAX) THEN
                        IMAX = JP
                        AMAX = T
                     ENDIF
  150             CONTINUE
                  JP = IMAX
               ENDIF
C
               IF (W(J,I).NE.0.D0) THEN
                  CALL DROTMG (SCALE(JP), SCALE(J), W(JP,I), W(J,I),
     +                         SPARAM)
                  W(J,I) = 0.D0
                  CALL DROTM (N+1-I, W(JP,I+1), MDW, W(J,I+1), MDW,
     +                        SPARAM)
               ENDIF
  160       CONTINUE
         ELSE IF (LEND.GT.I) THEN
C
C           Column I is dependent.  Swap with column LEND.
C           Perform column interchange,
C           and find column in remaining set with largest SS.
C
            CALL DWNLT3 (I, LEND, M, MDW, IPIVOT, H, W)
            LEND = LEND - 1
            IMAX = IDAMAX(LEND-I+1, H(I), 1) + I - 1
            HBAR = H(IMAX)
            GO TO 130
         ELSE
            KRANK = I - 1
            GO TO 190
         ENDIF
  180 CONTINUE
      KRANK = L1
C
  190 IF (KRANK.LT.ME) THEN
         FACTOR = ALSQ
         DO 200 I=KRANK+1,ME
            CALL DCOPY (L, 0.D0, 0, W(I,1), MDW)
  200    CONTINUE
C
C        Determine the rank of the remaining equality constraint
C        equations by eliminating within the block of constrained
C        variables.  Remove any redundant constraints.
C
         RECALC = .TRUE.
         LB = MIN(L+ME-KRANK, N)
         DO 270 I=L+1,LB
            IR = KRANK + I - L
            LEND = N
            MEND = ME
            CALL DWNLT1 (I, LEND, ME, IR, MDW, RECALC, IMAX, HBAR, H,
     +                   SCALE, W)
C
C           Update col ss and find pivot col
C
            CALL DWNLT3 (I, IMAX, M, MDW, IPIVOT, H, W)
C
C           Perform column interchange
C           Eliminate elements in the I-th col.
C
            DO 240 J=ME,IR+1,-1
               IF (W(J,I).NE.0.D0) THEN
                 CALL DROTMG (SCALE(J-1), SCALE(J), W(J-1,I), W(J,I),
     +                        SPARAM)
                  W(J,I) = 0.D0
                  CALL DROTM (N+1-I, W(J-1,I+1), MDW,W(J,I+1), MDW,
     +                        SPARAM)
               ENDIF
  240       CONTINUE
C
C           I=column being eliminated.
C           Test independence of incoming column.
C           Remove any redundant or dependent equality constraints.
C
            IF (.NOT.DWNLT2(ME, MEND, IR, FACTOR,TAU,SCALE,W(1,I))) THEN
               JJ = IR
               DO 260 IR=JJ,ME
                  CALL DCOPY (N, 0.D0, 0, W(IR,1), MDW)
                  RNORM = RNORM + (SCALE(IR)*W(IR,N+1)/ALSQ)*W(IR,N+1)
                  W(IR,N+1) = 0.D0
                  SCALE(IR) = 1.D0
C
C                 Reclassify the zeroed row as a least squares equation.
C
                  ITYPE(IR) = 1
  260          CONTINUE
C
C              Reduce ME to reflect any discovered dependent equality
C              constraints.
C
               ME = JJ - 1
               GO TO 280
            ENDIF
  270    CONTINUE
      ENDIF
C
C     Try to determine the variables KRANK+1 through L1 from the
C     least squares equations.  Continue the triangularization with
C     pivot element W(ME+1,I).
C
  280 IF (KRANK.LT.L1) THEN
         RECALC = .TRUE.
C
C        Set FACTOR=ALSQ to remove effect of heavy weight from
C        test for column independence.
C
         FACTOR = ALSQ
         DO 350 I=KRANK+1,L1
C
C           Set IR to point to the ME+1-st row.
C
            IR = ME+1
            LEND = L
            MEND = M
            CALL DWNLT1 (I, L, M, IR, MDW, RECALC, IMAX, HBAR, H, SCALE,
     +                   W)
C
C           Update column SS and find pivot column.
C
            CALL DWNLT3 (I, IMAX, M, MDW, IPIVOT, H, W)
C
C           Perform column interchange.
C           Eliminate I-th column below the IR-th element.
C
            DO 320 J=M,IR+1,-1
               IF (W(J,I).NE.0.D0) THEN
                 CALL DROTMG (SCALE(J-1), SCALE(J), W(J-1,I), W(J,I),
     +                        SPARAM)
                  W(J,I) = 0.D0
                  CALL DROTM (N+1-I, W(J-1,I+1),  MDW, W(J,I+1), MDW,
     +                        SPARAM)
               ENDIF
  320       CONTINUE
C
C           Test if new pivot element is near zero.
C           If so, the column is dependent.
C           Then check row norm test to be classified as independent.
C
            T = SCALE(IR)*W(IR,I)**2
            INDEP = T .GT. (TAU*EANORM)**2
            IF (INDEP) THEN
               RN = 0.D0
               DO 340 I1=IR,M
                  DO 330 J1=I+1,N
                     RN = MAX(RN, SCALE(I1)*W(I1,J1)**2)
  330             CONTINUE
  340          CONTINUE
               INDEP = T .GT. RN*TAU**2
            ENDIF
C
C           If independent, swap the IR-th and KRANK+1-th rows to
C           maintain the triangular form.  Update the rank indicator
C           KRANK and the equality constraint pointer ME.
C
            IF (.NOT.INDEP) GO TO 360
            CALL DSWAP(N+1, W(KRANK+1,1), MDW, W(IR,1), MDW)
            CALL DSWAP(1, SCALE(KRANK+1), 1, SCALE(IR), 1)
C
C           Reclassify the least square equation as an equality
C           constraint and rescale it.
C
            ITYPE(IR) = 0
            T = SQRT(SCALE(KRANK+1))
            CALL DSCAL(N+1, T, W(KRANK+1,1), MDW)
            SCALE(KRANK+1) = ALSQ
            ME = ME+1
            KRANK = KRANK+1
  350    CONTINUE
      ENDIF
C
C     If pseudorank is less than L, apply Householder transformation.
C     from right.
C
  360 IF (KRANK.LT.L) THEN
         DO 370 J=KRANK,1,-1
            CALL DH12 (1, J, KRANK+1, L, W(J,1), MDW, H(J), W, MDW, 1,
     +                J-1)
  370    CONTINUE
      ENDIF
C
      NIV = KRANK + NSOLN - L
      IF (L.EQ.N) DONE = .TRUE.
C
C     End of initial triangularization.
C
      IDOPE(1) = ME
      IDOPE(2) = KRANK
      IDOPE(3) = NIV
      RETURN
      END
*DECK DWNLSM
      SUBROUTINE DWNLSM (W, MDW, MME, MA, N, L, PRGOPT, X, RNORM, MODE,
     +   IPIVOT, ITYPE, WD, H, SCALE, Z, TEMP, D)
C***BEGIN PROLOGUE  DWNLSM
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DWNNLS
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (WNLSM-S, DWNLSM-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     This is a companion subprogram to DWNNLS.
C     The documentation for DWNNLS has complete usage instructions.
C
C     In addition to the parameters discussed in the prologue to
C     subroutine DWNNLS, the following work arrays are used in
C     subroutine DWNLSM  (they are passed through the calling
C     sequence from DWNNLS for purposes of variable dimensioning).
C     Their contents will in general be of no interest to the user.
C
C     Variables of type REAL are DOUBLE PRECISION.
C
C         IPIVOT(*)
C            An array of length N.  Upon completion it contains the
C         pivoting information for the cols of W(*,*).
C
C         ITYPE(*)
C            An array of length M which is used to keep track
C         of the classification of the equations.  ITYPE(I)=0
C         denotes equation I as an equality constraint.
C         ITYPE(I)=1 denotes equation I as a least squares
C         equation.
C
C         WD(*)
C            An array of length N.  Upon completion it contains the
C         dual solution vector.
C
C         H(*)
C            An array of length N.  Upon completion it contains the
C         pivot scalars of the Householder transformations performed
C         in the case KRANK.LT.L.
C
C         SCALE(*)
C            An array of length M which is used by the subroutine
C         to store the diagonal matrix of weights.
C         These are used to apply the modified Givens
C         transformations.
C
C         Z(*),TEMP(*)
C            Working arrays of length N.
C
C         D(*)
C            An array of length N that contains the
C         column scaling for the matrix (E).
C                                       (A)
C
C***SEE ALSO  DWNNLS
C***ROUTINES CALLED  D1MACH, DASUM, DAXPY, DCOPY, DH12, DNRM2, DROTM,
C                    DROTMG, DSCAL, DSWAP, DWNLIT, IDAMAX, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and revised.  (WRB & RWC)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C   900510  Fixed an error message.  (RWC)
C   900604  DP version created from SP version.  (RWC)
C   900911  Restriction on value of ALAMDA included.  (WRB)
C***END PROLOGUE  DWNLSM
      INTEGER IPIVOT(*), ITYPE(*), L, MA, MDW, MME, MODE, N
      DOUBLE PRECISION D(*), H(*), PRGOPT(*), RNORM, SCALE(*), TEMP(*),
     *   W(MDW,*), WD(*), X(*), Z(*)
C
      EXTERNAL D1MACH, DASUM, DAXPY, DCOPY, DH12, DNRM2, DROTM, DROTMG,
     *   DSCAL, DSWAP, DWNLIT, IDAMAX, XERMSG
      DOUBLE PRECISION D1MACH, DASUM, DNRM2
      INTEGER IDAMAX
C
      DOUBLE PRECISION ALAMDA, ALPHA, ALSQ, AMAX, BLOWUP, BNORM,
     *   DOPE(3), DRELPR, EANORM, FAC, SM, SPARAM(5), T, TAU, WMAX, Z2,
     *   ZZ
      INTEGER I, IDOPE(3), IMAX, ISOL, ITEMP, ITER, ITMAX, IWMAX, J,
     *   JCON, JP, KEY, KRANK, L1, LAST, LINK, M, ME, NEXT, NIV, NLINK,
     *   NOPT, NSOLN, NTIMES
      LOGICAL DONE, FEASBL, FIRST, HITCON, POS
C
      SAVE DRELPR, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DWNLSM
C
C     Initialize variables.
C     DRELPR is the precision for the particular machine
C     being used.  This logic avoids resetting it every entry.
C
      IF (FIRST) DRELPR = D1MACH(4)
      FIRST = .FALSE.
C
C     Set the nominal tolerance used in the code.
C
      TAU = SQRT(DRELPR)
C
      M = MA + MME
      ME = MME
      MODE = 2
C
C     To process option vector
C
      FAC = 1.D-4
C
C     Set the nominal blow up factor used in the code.
C
      BLOWUP = TAU
C
C     The nominal column scaling used in the code is
C     the identity scaling.
C
      CALL DCOPY (N, 1.D0, 0, D, 1)
C
C     Define bound for number of options to change.
C
      NOPT = 1000
C
C     Define bound for positive value of LINK.
C
      NLINK = 100000
      NTIMES = 0
      LAST = 1
      LINK = PRGOPT(1)
      IF (LINK.LE.0 .OR. LINK.GT.NLINK) THEN
         CALL XERMSG ('SLATEC', 'DWNLSM',
     +      'IN DWNNLS, THE OPTION VECTOR IS UNDEFINED', 3, 1)
         RETURN
      ENDIF
C
  100 IF (LINK.GT.1) THEN
         NTIMES = NTIMES + 1
         IF (NTIMES.GT.NOPT) THEN
         CALL XERMSG ('SLATEC', 'DWNLSM',
     +      'IN DWNNLS, THE LINKS IN THE OPTION VECTOR ARE CYCLING.',
     +      3, 1)
            RETURN
         ENDIF
C
         KEY = PRGOPT(LAST+1)
         IF (KEY.EQ.6 .AND. PRGOPT(LAST+2).NE.0.D0) THEN
            DO 110 J = 1,N
               T = DNRM2(M,W(1,J),1)
               IF (T.NE.0.D0) T = 1.D0/T
               D(J) = T
  110       CONTINUE
         ENDIF
C
         IF (KEY.EQ.7) CALL DCOPY (N, PRGOPT(LAST+2), 1, D, 1)
         IF (KEY.EQ.8) TAU = MAX(DRELPR,PRGOPT(LAST+2))
         IF (KEY.EQ.9) BLOWUP = MAX(DRELPR,PRGOPT(LAST+2))
C
         NEXT = PRGOPT(LINK)
         IF (NEXT.LE.0 .OR. NEXT.GT.NLINK) THEN
            CALL XERMSG ('SLATEC', 'DWNLSM',
     +         'IN DWNNLS, THE OPTION VECTOR IS UNDEFINED', 3, 1)
            RETURN
         ENDIF
C
         LAST = LINK
         LINK = NEXT
         GO TO 100
      ENDIF
C
      DO 120 J = 1,N
         CALL DSCAL (M, D(J), W(1,J), 1)
  120 CONTINUE
C
C     Process option vector
C
      DONE = .FALSE.
      ITER = 0
      ITMAX = 3*(N-L)
      MODE = 0
      NSOLN = L
      L1 = MIN(M,L)
C
C     Compute scale factor to apply to equality constraint equations.
C
      DO 130 J = 1,N
         WD(J) = DASUM(M,W(1,J),1)
  130 CONTINUE
C
      IMAX = IDAMAX(N,WD,1)
      EANORM = WD(IMAX)
      BNORM = DASUM(M,W(1,N+1),1)
      ALAMDA = EANORM/(DRELPR*FAC)
C
C     On machines, such as the VAXes using D floating, with a very
C     limited exponent range for double precision values, the previously
C     computed value of ALAMDA may cause an overflow condition.
C     Therefore, this code further limits the value of ALAMDA.
C
      ALAMDA = MIN(ALAMDA,SQRT(D1MACH(2)))
C
C     Define scaling diagonal matrix for modified Givens usage and
C     classify equation types.
C
      ALSQ = ALAMDA**2
      DO 140 I = 1,M
C
C        When equation I is heavily weighted ITYPE(I)=0,
C        else ITYPE(I)=1.
C
         IF (I.LE.ME) THEN
            T = ALSQ
            ITEMP = 0
         ELSE
            T = 1.D0
            ITEMP = 1
         ENDIF
         SCALE(I) = T
         ITYPE(I) = ITEMP
  140 CONTINUE
C
C     Set the solution vector X(*) to zero and the column interchange
C     matrix to the identity.
C
      CALL DCOPY (N, 0.D0, 0, X, 1)
      DO 150 I = 1,N
         IPIVOT(I) = I
  150 CONTINUE
C
C     Perform initial triangularization in the submatrix
C     corresponding to the unconstrained variables.
C     Set first L components of dual vector to zero because
C     these correspond to the unconstrained variables.
C
      CALL DCOPY (L, 0.D0, 0, WD, 1)
C
C     The arrays IDOPE(*) and DOPE(*) are used to pass
C     information to DWNLIT().  This was done to avoid
C     a long calling sequence or the use of COMMON.
C
      IDOPE(1) = ME
      IDOPE(2) = NSOLN
      IDOPE(3) = L1
C
      DOPE(1) = ALSQ
      DOPE(2) = EANORM
      DOPE(3) = TAU
      CALL DWNLIT (W, MDW, M, N, L, IPIVOT, ITYPE, H, SCALE, RNORM,
     +            IDOPE, DOPE, DONE)
      ME    = IDOPE(1)
      KRANK = IDOPE(2)
      NIV   = IDOPE(3)
C
C     Perform WNNLS algorithm using the following steps.
C
C     Until(DONE)
C        compute search direction and feasible point
C        when (HITCON) add constraints
C        else perform multiplier test and drop a constraint
C        fin
C     Compute-Final-Solution
C
C     To compute search direction and feasible point,
C     solve the triangular system of currently non-active
C     variables and store the solution in Z(*).
C
C     To solve system
C     Copy right hand side into TEMP vector to use overwriting method.
C
  160 IF (DONE) GO TO 330
      ISOL = L + 1
      IF (NSOLN.GE.ISOL) THEN
         CALL DCOPY (NIV, W(1,N+1), 1, TEMP, 1)
         DO 170 J = NSOLN,ISOL,-1
            IF (J.GT.KRANK) THEN
               I = NIV - NSOLN + J
            ELSE
               I = J
            ENDIF
C
            IF (J.GT.KRANK .AND. J.LE.L) THEN
               Z(J) = 0.D0
            ELSE
               Z(J) = TEMP(I)/W(I,J)
               CALL DAXPY (I-1, -Z(J), W(1,J), 1, TEMP, 1)
            ENDIF
  170    CONTINUE
      ENDIF
C
C     Increment iteration counter and check against maximum number
C     of iterations.
C
      ITER = ITER + 1
      IF (ITER.GT.ITMAX) THEN
         MODE = 1
         DONE = .TRUE.
      ENDIF
C
C     Check to see if any constraints have become active.
C     If so, calculate an interpolation factor so that all
C     active constraints are removed from the basis.
C
      ALPHA = 2.D0
      HITCON = .FALSE.
      DO 180 J = L+1,NSOLN
         ZZ = Z(J)
         IF (ZZ.LE.0.D0) THEN
            T = X(J)/(X(J)-ZZ)
            IF (T.LT.ALPHA) THEN
               ALPHA = T
               JCON = J
            ENDIF
            HITCON = .TRUE.
         ENDIF
  180 CONTINUE
C
C     Compute search direction and feasible point
C
      IF (HITCON) THEN
C
C        To add constraints, use computed ALPHA to interpolate between
C        last feasible solution X(*) and current unconstrained (and
C        infeasible) solution Z(*).
C
         DO 190 J = L+1,NSOLN
            X(J) = X(J) + ALPHA*(Z(J)-X(J))
  190    CONTINUE
         FEASBL = .FALSE.
C
C        Remove column JCON and shift columns JCON+1 through N to the
C        left.  Swap column JCON into the N th position.  This achieves
C        upper Hessenberg form for the nonactive constraints and
C        leaves an upper Hessenberg matrix to retriangularize.
C
  200    DO 210 I = 1,M
            T = W(I,JCON)
            CALL DCOPY (N-JCON, W(I, JCON+1), MDW, W(I, JCON), MDW)
            W(I,N) = T
  210    CONTINUE
C
C        Update permuted index vector to reflect this shift and swap.
C
         ITEMP = IPIVOT(JCON)
         DO 220 I = JCON,N - 1
            IPIVOT(I) = IPIVOT(I+1)
  220    CONTINUE
         IPIVOT(N) = ITEMP
C
C        Similarly permute X(*) vector.
C
         CALL DCOPY (N-JCON, X(JCON+1), 1, X(JCON), 1)
         X(N) = 0.D0
         NSOLN = NSOLN - 1
         NIV = NIV - 1
C
C        Retriangularize upper Hessenberg matrix after adding
C        constraints.
C
         I = KRANK + JCON - L
         DO 230 J = JCON,NSOLN
            IF (ITYPE(I).EQ.0 .AND. ITYPE(I+1).EQ.0) THEN
C
C              Zero IP1 to I in column J
C
               IF (W(I+1,J).NE.0.D0) THEN
                  CALL DROTMG (SCALE(I), SCALE(I+1), W(I,J), W(I+1,J),
     +                         SPARAM)
                  W(I+1,J) = 0.D0
                  CALL DROTM (N+1-J, W(I,J+1), MDW, W(I+1,J+1), MDW,
     +                        SPARAM)
               ENDIF
            ELSEIF (ITYPE(I).EQ.1 .AND. ITYPE(I+1).EQ.1) THEN
C
C              Zero IP1 to I in column J
C
               IF (W(I+1,J).NE.0.D0) THEN
                  CALL DROTMG (SCALE(I), SCALE(I+1), W(I,J), W(I+1,J),
     +                         SPARAM)
                  W(I+1,J) = 0.D0
                  CALL DROTM (N+1-J, W(I,J+1), MDW, W(I+1,J+1), MDW,
     +                        SPARAM)
               ENDIF
            ELSEIF (ITYPE(I).EQ.1 .AND. ITYPE(I+1).EQ.0) THEN
               CALL DSWAP (N+1, W(I,1), MDW, W(I+1,1), MDW)
               CALL DSWAP (1, SCALE(I), 1, SCALE(I+1), 1)
               ITEMP = ITYPE(I+1)
               ITYPE(I+1) = ITYPE(I)
               ITYPE(I) = ITEMP
C
C              Swapped row was formerly a pivot element, so it will
C              be large enough to perform elimination.
C              Zero IP1 to I in column J.
C
               IF (W(I+1,J).NE.0.D0) THEN
                  CALL DROTMG (SCALE(I), SCALE(I+1), W(I,J), W(I+1,J),
     +                         SPARAM)
                  W(I+1,J) = 0.D0
                  CALL DROTM (N+1-J, W(I,J+1), MDW, W(I+1,J+1), MDW,
     +                        SPARAM)
               ENDIF
            ELSEIF (ITYPE(I).EQ.0 .AND. ITYPE(I+1).EQ.1) THEN
               IF (SCALE(I)*W(I,J)**2/ALSQ.GT.(TAU*EANORM)**2) THEN
C
C                 Zero IP1 to I in column J
C
                  IF (W(I+1,J).NE.0.D0) THEN
                     CALL DROTMG (SCALE(I), SCALE(I+1), W(I,J),
     +                            W(I+1,J), SPARAM)
                     W(I+1,J) = 0.D0
                     CALL DROTM (N+1-J, W(I,J+1), MDW, W(I+1,J+1), MDW,
     +                           SPARAM)
                  ENDIF
               ELSE
                  CALL DSWAP (N+1, W(I,1), MDW, W(I+1,1), MDW)
                  CALL DSWAP (1, SCALE(I), 1, SCALE(I+1), 1)
                  ITEMP = ITYPE(I+1)
                  ITYPE(I+1) = ITYPE(I)
                  ITYPE(I) = ITEMP
                  W(I+1,J) = 0.D0
               ENDIF
            ENDIF
            I = I + 1
  230    CONTINUE
C
C        See if the remaining coefficients in the solution set are
C        feasible.  They should be because of the way ALPHA was
C        determined.  If any are infeasible, it is due to roundoff
C        error.  Any that are non-positive will be set to zero and
C        removed from the solution set.
C
         DO 240 JCON = L+1,NSOLN
            IF (X(JCON).LE.0.D0) GO TO 250
  240    CONTINUE
         FEASBL = .TRUE.
  250    IF (.NOT.FEASBL) GO TO 200
      ELSE
C
C        To perform multiplier test and drop a constraint.
C
         CALL DCOPY (NSOLN, Z, 1, X, 1)
         IF (NSOLN.LT.N) CALL DCOPY (N-NSOLN, 0.D0, 0, X(NSOLN+1), 1)
C
C        Reclassify least squares equations as equalities as necessary.
C
         I = NIV + 1
  260    IF (I.LE.ME) THEN
            IF (ITYPE(I).EQ.0) THEN
               I = I + 1
            ELSE
               CALL DSWAP (N+1, W(I,1), MDW, W(ME,1), MDW)
               CALL DSWAP (1, SCALE(I), 1, SCALE(ME), 1)
               ITEMP = ITYPE(I)
               ITYPE(I) = ITYPE(ME)
               ITYPE(ME) = ITEMP
               ME = ME - 1
            ENDIF
            GO TO 260
         ENDIF
C
C        Form inner product vector WD(*) of dual coefficients.
C
         DO 280 J = NSOLN+1,N
            SM = 0.D0
            DO 270 I = NSOLN+1,M
               SM = SM + SCALE(I)*W(I,J)*W(I,N+1)
  270       CONTINUE
            WD(J) = SM
  280    CONTINUE
C
C        Find J such that WD(J)=WMAX is maximum.  This determines
C        that the incoming column J will reduce the residual vector
C        and be positive.
C
  290    WMAX = 0.D0
         IWMAX = NSOLN + 1
         DO 300 J = NSOLN+1,N
            IF (WD(J).GT.WMAX) THEN
               WMAX = WD(J)
               IWMAX = J
            ENDIF
  300    CONTINUE
         IF (WMAX.LE.0.D0) GO TO 330
C
C        Set dual coefficients to zero for incoming column.
C
         WD(IWMAX) = 0.D0
C
C        WMAX .GT. 0.D0, so okay to move column IWMAX to solution set.
C        Perform transformation to retriangularize, and test for near
C        linear dependence.
C
C        Swap column IWMAX into NSOLN-th position to maintain upper
C        Hessenberg form of adjacent columns, and add new column to
C        triangular decomposition.
C
         NSOLN = NSOLN + 1
         NIV = NIV + 1
         IF (NSOLN.NE.IWMAX) THEN
            CALL DSWAP (M, W(1,NSOLN), 1, W(1,IWMAX), 1)
            WD(IWMAX) = WD(NSOLN)
            WD(NSOLN) = 0.D0
            ITEMP = IPIVOT(NSOLN)
            IPIVOT(NSOLN) = IPIVOT(IWMAX)
            IPIVOT(IWMAX) = ITEMP
         ENDIF
C
C        Reduce column NSOLN so that the matrix of nonactive constraints
C        variables is triangular.
C
         DO 320 J = M,NIV+1,-1
            JP = J - 1
C
C           When operating near the ME line, test to see if the pivot
C           element is near zero.  If so, use the largest element above
C           it as the pivot.  This is to maintain the sharp interface
C           between weighted and non-weighted rows in all cases.
C
            IF (J.EQ.ME+1) THEN
               IMAX = ME
               AMAX = SCALE(ME)*W(ME,NSOLN)**2
               DO 310 JP = J - 1,NIV,-1
                  T = SCALE(JP)*W(JP,NSOLN)**2
                  IF (T.GT.AMAX) THEN
                     IMAX = JP
                     AMAX = T
                  ENDIF
  310          CONTINUE
               JP = IMAX
            ENDIF
C
            IF (W(J,NSOLN).NE.0.D0) THEN
               CALL DROTMG (SCALE(JP), SCALE(J), W(JP,NSOLN),
     +                      W(J,NSOLN), SPARAM)
               W(J,NSOLN) = 0.D0
               CALL DROTM (N+1-NSOLN, W(JP,NSOLN+1), MDW, W(J,NSOLN+1),
     +                     MDW, SPARAM)
            ENDIF
  320    CONTINUE
C
C        Solve for Z(NSOLN)=proposed new value for X(NSOLN).  Test if
C        this is nonpositive or too large.  If this was true or if the
C        pivot term was zero, reject the column as dependent.
C
         IF (W(NIV,NSOLN).NE.0.D0) THEN
            ISOL = NIV
            Z2 = W(ISOL,N+1)/W(ISOL,NSOLN)
            Z(NSOLN) = Z2
            POS = Z2 .GT. 0.D0
            IF (Z2*EANORM.GE.BNORM .AND. POS) THEN
               POS = .NOT. (BLOWUP*Z2*EANORM.GE.BNORM)
            ENDIF
C
C           Try to add row ME+1 as an additional equality constraint.
C           Check size of proposed new solution component.
C           Reject it if it is too large.
C
         ELSEIF (NIV.LE.ME .AND. W(ME+1,NSOLN).NE.0.D0) THEN
            ISOL = ME + 1
            IF (POS) THEN
C
C              Swap rows ME+1 and NIV, and scale factors for these rows.
C
               CALL DSWAP (N+1, W(ME+1,1), MDW, W(NIV,1), MDW)
               CALL DSWAP (1, SCALE(ME+1), 1, SCALE(NIV), 1)
               ITEMP = ITYPE(ME+1)
               ITYPE(ME+1) = ITYPE(NIV)
               ITYPE(NIV) = ITEMP
               ME = ME + 1
            ENDIF
         ELSE
            POS = .FALSE.
         ENDIF
C
         IF (.NOT.POS) THEN
            NSOLN = NSOLN - 1
            NIV = NIV - 1
         ENDIF
         IF (.NOT.(POS.OR.DONE)) GO TO 290
      ENDIF
      GO TO 160
C
C     Else perform multiplier test and drop a constraint.  To compute
C     final solution.  Solve system, store results in X(*).
C
C     Copy right hand side into TEMP vector to use overwriting method.
C
  330 ISOL = 1
      IF (NSOLN.GE.ISOL) THEN
         CALL DCOPY (NIV, W(1,N+1), 1, TEMP, 1)
         DO 340 J = NSOLN,ISOL,-1
            IF (J.GT.KRANK) THEN
               I = NIV - NSOLN + J
            ELSE
               I = J
            ENDIF
C
            IF (J.GT.KRANK .AND. J.LE.L) THEN
               Z(J) = 0.D0
            ELSE
               Z(J) = TEMP(I)/W(I,J)
               CALL DAXPY (I-1, -Z(J), W(1,J), 1, TEMP, 1)
            ENDIF
  340    CONTINUE
      ENDIF
C
C     Solve system.
C
      CALL DCOPY (NSOLN, Z, 1, X, 1)
C
C     Apply Householder transformations to X(*) if KRANK.LT.L
C
      IF (KRANK.LT.L) THEN
         DO 350 I = 1,KRANK
            CALL DH12 (2, I, KRANK+1, L, W(I,1), MDW, H(I), X, 1, 1, 1)
  350    CONTINUE
      ENDIF
C
C     Fill in trailing zeroes for constrained variables not in solution.
C
      IF (NSOLN.LT.N) CALL DCOPY (N-NSOLN, 0.D0, 0, X(NSOLN+1), 1)
C
C     Permute solution vector to natural order.
C
      DO 380 I = 1,N
         J = I
  360    IF (IPIVOT(J).EQ.I) GO TO 370
         J = J + 1
         GO TO 360
C
  370    IPIVOT(J) = IPIVOT(I)
         IPIVOT(I) = J
         CALL DSWAP (1, X(J), 1, X(I), 1)
  380 CONTINUE
C
C     Rescale the solution using the column scaling.
C
      DO 390 J = 1,N
         X(J) = X(J)*D(J)
  390 CONTINUE
C
      DO 400 I = NSOLN+1,M
         T = W(I,N+1)
         IF (I.LE.ME) T = T/ALAMDA
         T = (SCALE(I)*T)*T
         RNORM = RNORM + T
  400 CONTINUE
C
      RNORM = SQRT(RNORM)
      RETURN
      END
*DECK DWNLT1
      SUBROUTINE DWNLT1 (I, LEND, MEND, IR, MDW, RECALC, IMAX, HBAR, H,
     +   SCALE, W)
C***BEGIN PROLOGUE  DWNLT1
C***SUBSIDIARY
C***PURPOSE  Subsidiary to WNLIT
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (WNLT1-S, DWNLT1-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     To update the column Sum Of Squares and find the pivot column.
C     The column Sum of Squares Vector will be updated at each step.
C     When numerically necessary, these values will be recomputed.
C
C***SEE ALSO  DWNLIT
C***ROUTINES CALLED  IDAMAX
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890620  Code extracted from WNLIT and made a subroutine.  (RWC))
C   900604  DP version created from SP version.  (RWC)
C***END PROLOGUE  DWNLT1
      INTEGER I, IMAX, IR, LEND, MDW, MEND
      DOUBLE PRECISION H(*), HBAR, SCALE(*), W(MDW,*)
      LOGICAL RECALC
C
      EXTERNAL IDAMAX
      INTEGER IDAMAX
C
      INTEGER J, K
C
C***FIRST EXECUTABLE STATEMENT  DWNLT1
      IF (IR.NE.1 .AND. (.NOT.RECALC)) THEN
C
C        Update column SS=sum of squares.
C
         DO 10 J=I,LEND
            H(J) = H(J) - SCALE(IR-1)*W(IR-1,J)**2
   10    CONTINUE
C
C        Test for numerical accuracy.
C
         IMAX = IDAMAX(LEND-I+1, H(I), 1) + I - 1
         RECALC = (HBAR+1.E-3*H(IMAX)) .EQ. HBAR
      ENDIF
C
C     If required, recalculate column SS, using rows IR through MEND.
C
      IF (RECALC) THEN
         DO 30 J=I,LEND
            H(J) = 0.D0
            DO 20 K=IR,MEND
               H(J) = H(J) + SCALE(K)*W(K,J)**2
   20       CONTINUE
   30    CONTINUE
C
C        Find column with largest SS.
C
         IMAX = IDAMAX(LEND-I+1, H(I), 1) + I - 1
         HBAR = H(IMAX)
      ENDIF
      RETURN
      END
*DECK DWNLT2
      LOGICAL FUNCTION DWNLT2 (ME, MEND, IR, FACTOR, TAU, SCALE, WIC)
C***BEGIN PROLOGUE  DWNLT2
C***SUBSIDIARY
C***PURPOSE  Subsidiary to WNLIT
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (WNLT2-S, DWNLT2-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     To test independence of incoming column.
C
C     Test the column IC to determine if it is linearly independent
C     of the columns already in the basis.  In the initial tri. step,
C     we usually want the heavy weight ALAMDA to be included in the
C     test for independence.  In this case, the value of FACTOR will
C     have been set to 1.E0 before this procedure is invoked.
C     In the potentially rank deficient problem, the value of FACTOR
C     will have been set to ALSQ=ALAMDA**2 to remove the effect of the
C     heavy weight from the test for independence.
C
C     Write new column as partitioned vector
C           (A1)  number of components in solution so far = NIV
C           (A2)  M-NIV components
C     And compute  SN = inverse weighted length of A1
C                  RN = inverse weighted length of A2
C     Call the column independent when RN .GT. TAU*SN
C
C***SEE ALSO  DWNLIT
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890620  Code extracted from WNLIT and made a subroutine.  (RWC))
C   900604  DP version created from SP version.  (RWC)
C***END PROLOGUE  DWNLT2
      DOUBLE PRECISION FACTOR, SCALE(*), TAU, WIC(*)
      INTEGER IR, ME, MEND
C
      DOUBLE PRECISION RN, SN, T
      INTEGER J
C
C***FIRST EXECUTABLE STATEMENT  DWNLT2
      SN = 0.E0
      RN = 0.E0
      DO 10 J=1,MEND
         T = SCALE(J)
         IF (J.LE.ME) T = T/FACTOR
         T = T*WIC(J)**2
C
         IF (J.LT.IR) THEN
            SN = SN + T
         ELSE
            RN = RN + T
         ENDIF
   10 CONTINUE
      DWNLT2 = RN .GT. SN*TAU**2
      RETURN
      END
*DECK DWNLT3
      SUBROUTINE DWNLT3 (I, IMAX, M, MDW, IPIVOT, H, W)
C***BEGIN PROLOGUE  DWNLT3
C***SUBSIDIARY
C***PURPOSE  Subsidiary to WNLIT
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (WNLT3-S, DWNLT3-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     Perform column interchange.
C     Exchange elements of permuted index vector and perform column
C     interchanges.
C
C***SEE ALSO  DWNLIT
C***ROUTINES CALLED  DSWAP
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890620  Code extracted from WNLIT and made a subroutine.  (RWC))
C   900604  DP version created from SP version.  (RWC)
C***END PROLOGUE  DWNLT3
      INTEGER I, IMAX, IPIVOT(*), M, MDW
      DOUBLE PRECISION H(*), W(MDW,*)
C
      EXTERNAL DSWAP
C
      DOUBLE PRECISION T
      INTEGER ITEMP
C
C***FIRST EXECUTABLE STATEMENT  DWNLT3
      IF (IMAX.NE.I) THEN
         ITEMP        = IPIVOT(I)
         IPIVOT(I)    = IPIVOT(IMAX)
         IPIVOT(IMAX) = ITEMP
C
         CALL DSWAP(M, W(1,IMAX), 1, W(1,I), 1)
C
         T       = H(IMAX)
         H(IMAX) = H(I)
         H(I)    = T
      ENDIF
      RETURN
      END
*DECK DWNNLS
      SUBROUTINE DWNNLS (W, MDW, ME, MA, N, L, PRGOPT, X, RNORM, MODE,
     +   IWORK, WORK)
C***BEGIN PROLOGUE  DWNNLS
C***PURPOSE  Solve a linearly constrained least squares problem with
C            equality constraints and nonnegativity constraints on
C            selected variables.
C***LIBRARY   SLATEC
C***CATEGORY  K1A2A
C***TYPE      DOUBLE PRECISION (WNNLS-S, DWNNLS-D)
C***KEYWORDS  CONSTRAINED LEAST SQUARES, CURVE FITTING, DATA FITTING,
C             EQUALITY CONSTRAINTS, INEQUALITY CONSTRAINTS,
C             NONNEGATIVITY CONSTRAINTS, QUADRATIC PROGRAMMING
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     Abstract
C
C     This subprogram solves a linearly constrained least squares
C     problem.  Suppose there are given matrices E and A of
C     respective dimensions ME by N and MA by N, and vectors F
C     and B of respective lengths ME and MA.  This subroutine
C     solves the problem
C
C               EX = F, (equations to be exactly satisfied)
C
C               AX = B, (equations to be approximately satisfied,
C                        in the least squares sense)
C
C               subject to components L+1,...,N nonnegative
C
C     Any values ME.GE.0, MA.GE.0 and 0.LE. L .LE.N are permitted.
C
C     The problem is reposed as problem DWNNLS
C
C               (WT*E)X = (WT*F)
C               (   A)    (   B), (least squares)
C               subject to components L+1,...,N nonnegative.
C
C     The subprogram chooses the heavy weight (or penalty parameter) WT.
C
C     The parameters for DWNNLS are
C
C     INPUT.. All TYPE REAL variables are DOUBLE PRECISION
C
C     W(*,*),MDW,  The array W(*,*) is double subscripted with first
C     ME,MA,N,L    dimensioning parameter equal to MDW.  For this
C                  discussion let us call M = ME + MA.  Then MDW
C                  must satisfy MDW.GE.M.  The condition MDW.LT.M
C                  is an error.
C
C                  The array W(*,*) contains the matrices and vectors
C
C                       (E  F)
C                       (A  B)
C
C                  in rows and columns 1,...,M and 1,...,N+1
C                  respectively.  Columns 1,...,L correspond to
C                  unconstrained variables X(1),...,X(L).  The
C                  remaining variables are constrained to be
C                  nonnegative. The condition L.LT.0 or L.GT.N is
C                  an error.
C
C     PRGOPT(*)    This double precision array is the option vector.
C                  If the user is satisfied with the nominal
C                  subprogram features set
C
C                  PRGOPT(1)=1 (or PRGOPT(1)=1.0)
C
C                  Otherwise PRGOPT(*) is a linked list consisting of
C                  groups of data of the following form
C
C                  LINK
C                  KEY
C                  DATA SET
C
C                  The parameters LINK and KEY are each one word.
C                  The DATA SET can be comprised of several words.
C                  The number of items depends on the value of KEY.
C                  The value of LINK points to the first
C                  entry of the next group of data within
C                  PRGOPT(*).  The exception is when there are
C                  no more options to change.  In that
C                  case LINK=1 and the values KEY and DATA SET
C                  are not referenced. The general layout of
C                  PRGOPT(*) is as follows.
C
C               ...PRGOPT(1)=LINK1 (link to first entry of next group)
C               .  PRGOPT(2)=KEY1 (key to the option change)
C               .  PRGOPT(3)=DATA VALUE (data value for this change)
C               .       .
C               .       .
C               .       .
C               ...PRGOPT(LINK1)=LINK2 (link to the first entry of
C               .                       next group)
C               .  PRGOPT(LINK1+1)=KEY2 (key to the option change)
C               .  PRGOPT(LINK1+2)=DATA VALUE
C               ...     .
C               .       .
C               .       .
C               ...PRGOPT(LINK)=1 (no more options to change)
C
C                  Values of LINK that are nonpositive are errors.
C                  A value of LINK.GT.NLINK=100000 is also an error.
C                  This helps prevent using invalid but positive
C                  values of LINK that will probably extend
C                  beyond the program limits of PRGOPT(*).
C                  Unrecognized values of KEY are ignored.  The
C                  order of the options is arbitrary and any number
C                  of options can be changed with the following
C                  restriction.  To prevent cycling in the
C                  processing of the option array a count of the
C                  number of options changed is maintained.
C                  Whenever this count exceeds NOPT=1000 an error
C                  message is printed and the subprogram returns.
C
C                  OPTIONS..
C
C                  KEY=6
C                         Scale the nonzero columns of the
C                  entire data matrix
C                  (E)
C                  (A)
C                  to have length one. The DATA SET for
C                  this option is a single value.  It must
C                  be nonzero if unit length column scaling is
C                  desired.
C
C                  KEY=7
C                         Scale columns of the entire data matrix
C                  (E)
C                  (A)
C                  with a user-provided diagonal matrix.
C                  The DATA SET for this option consists
C                  of the N diagonal scaling factors, one for
C                  each matrix column.
C
C                  KEY=8
C                         Change the rank determination tolerance from
C                  the nominal value of SQRT(SRELPR).  This quantity
C                  can be no smaller than SRELPR, The arithmetic-
C                  storage precision.  The quantity used
C                  here is internally restricted to be at
C                  least SRELPR.  The DATA SET for this option
C                  is the new tolerance.
C
C                  KEY=9
C                         Change the blow-up parameter from the
C                  nominal value of SQRT(SRELPR).  The reciprocal of
C                  this parameter is used in rejecting solution
C                  components as too large when a variable is
C                  first brought into the active set.  Too large
C                  means that the proposed component times the
C                  reciprocal of the parameter is not less than
C                  the ratio of the norms of the right-side
C                  vector and the data matrix.
C                  This parameter can be no smaller than SRELPR,
C                  the arithmetic-storage precision.
C
C                  For example, suppose we want to provide
C                  a diagonal matrix to scale the problem
C                  matrix and change the tolerance used for
C                  determining linear dependence of dropped col
C                  vectors.  For these options the dimensions of
C                  PRGOPT(*) must be at least N+6.  The FORTRAN
C                  statements defining these options would
C                  be as follows.
C
C                  PRGOPT(1)=N+3 (link to entry N+3 in PRGOPT(*))
C                  PRGOPT(2)=7 (user-provided scaling key)
C
C                  CALL DCOPY(N,D,1,PRGOPT(3),1) (copy the N
C                  scaling factors from a user array called D(*)
C                  into PRGOPT(3)-PRGOPT(N+2))
C
C                  PRGOPT(N+3)=N+6 (link to entry N+6 of PRGOPT(*))
C                  PRGOPT(N+4)=8 (linear dependence tolerance key)
C                  PRGOPT(N+5)=... (new value of the tolerance)
C
C                  PRGOPT(N+6)=1 (no more options to change)
C
C
C     IWORK(1),    The amounts of working storage actually allocated
C     IWORK(2)     for the working arrays WORK(*) and IWORK(*),
C                  respectively.  These quantities are compared with
C                  the actual amounts of storage needed for DWNNLS( ).
C                  Insufficient storage allocated for either WORK(*)
C                  or IWORK(*) is considered an error.  This feature
C                  was included in DWNNLS( ) because miscalculating
C                  the storage formulas for WORK(*) and IWORK(*)
C                  might very well lead to subtle and hard-to-find
C                  execution errors.
C
C                  The length of WORK(*) must be at least
C
C                  LW = ME+MA+5*N
C                  This test will not be made if IWORK(1).LE.0.
C
C                  The length of IWORK(*) must be at least
C
C                  LIW = ME+MA+N
C                  This test will not be made if IWORK(2).LE.0.
C
C     OUTPUT.. All TYPE REAL variables are DOUBLE PRECISION
C
C     X(*)         An array dimensioned at least N, which will
C                  contain the N components of the solution vector
C                  on output.
C
C     RNORM        The residual norm of the solution.  The value of
C                  RNORM contains the residual vector length of the
C                  equality constraints and least squares equations.
C
C     MODE         The value of MODE indicates the success or failure
C                  of the subprogram.
C
C                  MODE = 0  Subprogram completed successfully.
C
C                       = 1  Max. number of iterations (equal to
C                            3*(N-L)) exceeded. Nearly all problems
C                            should complete in fewer than this
C                            number of iterations. An approximate
C                            solution and its corresponding residual
C                            vector length are in X(*) and RNORM.
C
C                       = 2  Usage error occurred.  The offending
C                            condition is noted with the error
C                            processing subprogram, XERMSG( ).
C
C     User-designated
C     Working arrays..
C
C     WORK(*)      A double precision working array of length at least
C                  M + 5*N.
C
C     IWORK(*)     An integer-valued working array of length at least
C                  M+N.
C
C***REFERENCES  K. H. Haskell and R. J. Hanson, An algorithm for
C                 linear least squares problems with equality and
C                 nonnegativity constraints, Report SAND77-0552, Sandia
C                 Laboratories, June 1978.
C               K. H. Haskell and R. J. Hanson, Selected algorithms for
C                 the linearly constrained least squares problem - a
C                 users guide, Report SAND78-1290, Sandia Laboratories,
C                 August 1979.
C               K. H. Haskell and R. J. Hanson, An algorithm for
C                 linear least squares problems with equality and
C                 nonnegativity constraints, Mathematical Programming
C                 21 (1981), pp. 98-118.
C               R. J. Hanson and K. H. Haskell, Two algorithms for the
C                 linearly constrained least squares problem, ACM
C                 Transactions on Mathematical Software, September 1982.
C               C. L. Lawson and R. J. Hanson, Solving Least Squares
C                 Problems, Prentice-Hall, Inc., 1974.
C***ROUTINES CALLED  DWNLSM, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and revised.  (WRB & RWC)
C   891006  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls, change Prologue
C           comments to agree with WNNLS.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DWNNLS
      INTEGER IWORK(*), L, L1, L2, L3, L4, L5, LIW, LW, MA, MDW, ME,
     *     MODE, N
      DOUBLE PRECISION  PRGOPT(*), RNORM, W(MDW,*), WORK(*), X(*)
      CHARACTER*8 XERN1
C***FIRST EXECUTABLE STATEMENT  DWNNLS
      MODE = 0
      IF (MA+ME.LE.0 .OR. N.LE.0) RETURN
C
      IF (IWORK(1).GT.0) THEN
         LW = ME + MA + 5*N
         IF (IWORK(1).LT.LW) THEN
            WRITE (XERN1, '(I8)') LW
            CALL XERMSG ('SLATEC', 'DWNNLS', 'INSUFFICIENT STORAGE ' //
     *         'ALLOCATED FOR WORK(*), NEED LW = ' // XERN1, 2, 1)
            MODE = 2
            RETURN
         ENDIF
      ENDIF
C
      IF (IWORK(2).GT.0) THEN
         LIW = ME + MA + N
         IF (IWORK(2).LT.LIW) THEN
            WRITE (XERN1, '(I8)') LIW
            CALL XERMSG ('SLATEC', 'DWNNLS', 'INSUFFICIENT STORAGE ' //
     *         'ALLOCATED FOR IWORK(*), NEED LIW = ' // XERN1, 2, 1)
            MODE = 2
            RETURN
         ENDIF
      ENDIF
C
      IF (MDW.LT.ME+MA) THEN
         CALL XERMSG ('SLATEC', 'DWNNLS',
     *      'THE VALUE MDW.LT.ME+MA IS AN ERROR', 1, 1)
         MODE = 2
         RETURN
      ENDIF
C
      IF (L.LT.0 .OR. L.GT.N) THEN
         CALL XERMSG ('SLATEC', 'DWNNLS',
     *      'L.GE.0 .AND. L.LE.N IS REQUIRED', 2, 1)
         MODE = 2
         RETURN
      ENDIF
C
C     THE PURPOSE OF THIS SUBROUTINE IS TO BREAK UP THE ARRAYS
C     WORK(*) AND IWORK(*) INTO SEPARATE WORK ARRAYS
C     REQUIRED BY THE MAIN SUBROUTINE DWNLSM( ).
C
      L1 = N + 1
      L2 = L1 + N
      L3 = L2 + ME + MA
      L4 = L3 + N
      L5 = L4 + N
C
      CALL DWNLSM(W, MDW, ME, MA, N, L, PRGOPT, X, RNORM, MODE, IWORK,
     *            IWORK(L1), WORK(1), WORK(L1), WORK(L2), WORK(L3),
     *            WORK(L4), WORK(L5))
      RETURN
      END
*DECK DWRITP
      SUBROUTINE DWRITP (IPAGE, LIST, RLIST, LPAGE, IREC)
C***BEGIN PROLOGUE  DWRITP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DSPLP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SWRITP-S, DWRITP-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     WRITE RECORD NUMBER IRECN, OF LENGTH LPG, FROM STORAGE
C     ARRAY LIST(*) ONTO UNIT NUMBER IPAGEF.
C     WRITE RECORD NUMBER IRECN+1, OF LENGTH LPG, ONTO UNIT
C     NUMBER IPAGEF FROM THE STORAGE ARRAY RLIST(*).
C
C     TO CHANGE THIS PROGRAM UNIT TO DOUBLE PRECISION CHANGE
C     /REAL (12 BLANKS)/ TO /DOUBLE PRECISION/.
C
C***SEE ALSO  DSPLP
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890605  Corrected references to XERRWV.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  DWRITP
      INTEGER LIST(*)
      DOUBLE PRECISION RLIST(*)
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  DWRITP
      IPAGEF=IPAGE
      LPG   =LPAGE
      IRECN =IREC
      WRITE(IPAGEF,REC=IRECN,ERR=100)(LIST(I),I=1,LPG)
      WRITE(IPAGEF,REC=IRECN+1,ERR=100)(RLIST(I),I=1,LPG)
      RETURN
C
  100 WRITE (XERN1, '(I8)') LPG
      WRITE (XERN2, '(I8)') IRECN
      CALL XERMSG ('SLATEC', 'DWRITP', 'IN DSPLP, LGP = ' // XERN1 //
     *   ' IRECN = ' // XERN2, 100, 1)
      RETURN
      END
*DECK DWUPDT
      SUBROUTINE DWUPDT (N, R, LDR, W, B, ALPHA, COS, SIN)
C***BEGIN PROLOGUE  DWUPDT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DNLS1 and DNLS1E
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (RWUPDT-S, DWUPDT-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     Given an N by N upper triangular matrix R, this subroutine
C     computes the QR decomposition of the matrix formed when a row
C     is added to R. If the row is specified by the vector W, then
C     DWUPDT determines an orthogonal matrix Q such that when the
C     N+1 by N matrix composed of R augmented by W is premultiplied
C     by (Q TRANSPOSE), the resulting matrix is upper trapezoidal.
C     The orthogonal matrix Q is the product of N transformations
C
C           G(1)*G(2)* ... *G(N)
C
C     where G(I) is a Givens rotation in the (I,N+1) plane which
C     eliminates elements in the I-th plane. DWUPDT also
C     computes the product (Q TRANSPOSE)*C where C is the
C     (N+1)-vector (b,alpha). Q itself is not accumulated, rather
C     the information to recover the G rotations is supplied.
C
C     The subroutine statement is
C
C       SUBROUTINE DWUPDT(N,R,LDR,W,B,ALPHA,COS,SIN)
C
C     where
C
C       N is a positive integer input variable set to the order of R.
C
C       R is an N by N array. On input the upper triangular part of
C         R must contain the matrix to be updated. On output R
C         contains the updated triangular matrix.
C
C       LDR is a positive integer input variable not less than N
C         which specifies the leading dimension of the array R.
C
C       W is an input array of length N which must contain the row
C         vector to be added to R.
C
C       B is an array of length N. On input B must contain the
C         first N elements of the vector C. On output B contains
C         the first N elements of the vector (Q TRANSPOSE)*C.
C
C       ALPHA is a variable. On input ALPHA must contain the
C         (N+1)-st element of the vector C. On output ALPHA contains
C         the (N+1)-st element of the vector (Q TRANSPOSE)*C.
C
C       COS is an output array of length N which contains the
C         cosines of the transforming Givens rotations.
C
C       SIN is an output array of length N which contains the
C         sines of the transforming Givens rotations.
C
C     **********
C
C***SEE ALSO  DNLS1, DNLS1E
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  DWUPDT
      INTEGER N,LDR
      DOUBLE PRECISION ALPHA
      DOUBLE PRECISION R(LDR,*),W(*),B(*),COS(*),SIN(*)
      INTEGER I,J,JM1
      DOUBLE PRECISION COTAN,ONE,P5,P25,ROWJ,TAN,TEMP,ZERO
      SAVE ONE, P5, P25, ZERO
      DATA ONE,P5,P25,ZERO /1.0D0,5.0D-1,2.5D-1,0.0D0/
C***FIRST EXECUTABLE STATEMENT  DWUPDT
      DO 60 J = 1, N
         ROWJ = W(J)
         JM1 = J - 1
C
C        APPLY THE PREVIOUS TRANSFORMATIONS TO
C        R(I,J), I=1,2,...,J-1, AND TO W(J).
C
         IF (JM1 .LT. 1) GO TO 20
         DO 10 I = 1, JM1
            TEMP = COS(I)*R(I,J) + SIN(I)*ROWJ
            ROWJ = -SIN(I)*R(I,J) + COS(I)*ROWJ
            R(I,J) = TEMP
   10       CONTINUE
   20    CONTINUE
C
C        DETERMINE A GIVENS ROTATION WHICH ELIMINATES W(J).
C
         COS(J) = ONE
         SIN(J) = ZERO
         IF (ROWJ .EQ. ZERO) GO TO 50
         IF (ABS(R(J,J)) .GE. ABS(ROWJ)) GO TO 30
            COTAN = R(J,J)/ROWJ
            SIN(J) = P5/SQRT(P25+P25*COTAN**2)
            COS(J) = SIN(J)*COTAN
            GO TO 40
   30    CONTINUE
            TAN = ROWJ/R(J,J)
            COS(J) = P5/SQRT(P25+P25*TAN**2)
            SIN(J) = COS(J)*TAN
   40    CONTINUE
C
C        APPLY THE CURRENT TRANSFORMATION TO R(J,J), B(J), AND ALPHA.
C
         R(J,J) = COS(J)*R(J,J) + SIN(J)*ROWJ
         TEMP = COS(J)*B(J) + SIN(J)*ALPHA
         ALPHA = -SIN(J)*B(J) + COS(J)*ALPHA
         B(J) = TEMP
   50    CONTINUE
   60    CONTINUE
      RETURN
C
C     LAST CARD OF SUBROUTINE DWUPDT.
C
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_uvgrid_command(line,error)
  use gbl_message
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_uvgrid_command
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    UVGRID
  !       1. /SHIFT
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  logical :: doshift
  integer, parameter :: ishift = 1
  character(len=*), parameter :: rname='UVGRID/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  doshift = sic_present(ishift,0)
  call wifisyn_uvgrid_inter(doshift,error)
  if (error) return
  !
end subroutine wifisyn_uvgrid_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_uvgrid_inter(doshift,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvgrid_inter
  use wifisyn_uv_buffer
  use wifisyn_cube_buffer
  use wifisyn_sic_buffer
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical, intent(in)    :: doshift
  logical, intent(inout) :: error
  !
  type(uv_t) :: uvtmp
  type(window_t) :: win
  character(len=*), parameter :: rname='UVGRID/INTER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_setup_main(usermap,uvr,progmap,uvtmp,error)
  if (error) return
  win = progmap%win%cur(1)
  call wifisyn_uvgrid_main(doshift,win,uvr,uvtmp,progmap,wifi,error)
  if (error) return
  call wifisyn_free_uv(uvtmp,error)
  if (error) return
  !
end subroutine wifisyn_uvgrid_inter
!
subroutine wifisyn_uvgrid_main(doshift,win,uvin,uvout,map,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvgrid_main
  use wifisyn_gridding_types
  use wifisyn_uv_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical,        intent(in)    :: doshift
  type(window_t), intent(in)    :: win
  type(uv_t),     intent(in)    :: uvin
  type(uv_t),     intent(inout) :: uvout
  type(map_t),    intent(inout) :: map
  type(wifi_t),   intent(inout) :: wifi
  logical,        intent(inout) :: error
  !
  integer :: ndata,nchan
  character(len=*), parameter :: rname='UVGRID/MAIN'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ndata = map%n%data
  nchan = map%n%chan
  ! Get header ready for convolution
  call wifisyn_uvgrid_sort_and_weight(uvin,uvout,map,error)
  if (error) return
  ! Get data ready for convolution
  call wifisyn_reallocate_uv_data(uvout,ndata,nchan,code_uvt,error)
  if (error) return
  call wifisyn_uvgrid_shift_sort_transpose_data(win,map%shift,map%sort,uvin,uvout,error)
  if (error) return
  call wifisyn_reallocate_wifi(map,wifi,error)
  if (error) return
  if (doshift) then
    call wifisyn_uvgrid_shift(win,map,uvout,wifi,error)
     if (error) return
  else
     call wifisyn_uvgrid_convolve(win,map,uvout,wifi,error)
     if (error) return
  endif
  !
end subroutine wifisyn_uvgrid_main
!
subroutine wifisyn_reallocate_wifi(map,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_reallocate_wifi
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(map_t),  intent(in)    :: map
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  integer :: nchan,nx,ny,nu,nv
  character(len=*), parameter :: rname='REALLOCATE/WIFI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nchan = map%n%chan
  nx = map%axes(1)%x%sky%n
  ny = map%axes(2)%x%sky%n
  nu = map%axes(1)%u%uvp%n
  nv = map%axes(2)%u%uvp%n
  !
  wifi%xykind = .true.
  wifi%uvkind = .true.
  call wifisyn_wifi_header(map,wifi,error)
  if (error) return
  call wifisyn_cube_free_r3d(wifi%amp,error)
  if (error) return
  call wifisyn_reallocate_complex_cxyuv("wifi%cub",nchan,nx,ny,nu,nv,wifi%cub,error)
  if (error) return
  call wifisyn_wifi_weight_header(map,wifi,error)
  if (error) return
  call wifisyn_cube_reallocate_r4d("wifi%wei",wifi%wei,error)
  if (error) return
  !
end subroutine wifisyn_reallocate_wifi
!
subroutine wifisyn_wifi_weight_header(map,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi_weight_header
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  ! Should be merged with wifi_header *** JP
  !----------------------------------------------------------------------
  type(map_t),  intent(in)    :: map
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='WIFI/WEIGHT/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_common_header(map,wifi%wei,error)
  if (error) return
  wifi%wei%gil%xaxi = 0
  wifi%wei%gil%yaxi = 0
  if (wifi%xykind) then
     ! 1st axis
     wifi%wei%char%code(1) = 'RA'
     wifi%wei%gil%dim(1) = map%axes(1)%x%sky%n
     wifi%wei%gil%ref(1) = map%axes(1)%x%sky%ref
     wifi%wei%gil%val(1) = map%axes(1)%x%sky%val
     wifi%wei%gil%inc(1) = map%axes(1)%x%sky%inc
     ! 2nd axis
     wifi%wei%char%code(2) = 'DEC'
     wifi%wei%gil%dim(2) = map%axes(2)%x%sky%n
     wifi%wei%gil%ref(2) = map%axes(2)%x%sky%ref
     wifi%wei%gil%val(2) = map%axes(2)%x%sky%val
     wifi%wei%gil%inc(2) = map%axes(2)%x%sky%inc
  else
     ! 1st axis
     wifi%wei%char%code(1) = 'Us'
     wifi%wei%gil%dim(1) = map%axes(1)%x%uvp%n
     wifi%wei%gil%ref(1) = map%axes(1)%x%uvp%ref
     wifi%wei%gil%val(1) = map%axes(1)%x%uvp%val
     wifi%wei%gil%inc(1) = map%axes(1)%x%uvp%inc
     ! 2nd axis
     wifi%wei%char%code(2) = 'Vs'
     wifi%wei%gil%dim(2) = map%axes(2)%x%uvp%n
     wifi%wei%gil%ref(2) = map%axes(2)%x%uvp%ref
     wifi%wei%gil%val(2) = map%axes(2)%x%uvp%val
     wifi%wei%gil%inc(2) = map%axes(2)%x%uvp%inc
  endif
  if (wifi%uvkind) then
     ! 3rd axis
     wifi%wei%char%code(3) = 'Up'
     wifi%wei%gil%dim(3) = map%axes(1)%u%uvp%n
     wifi%wei%gil%ref(3) = map%axes(1)%u%uvp%ref
     wifi%wei%gil%val(3) = map%axes(1)%u%uvp%val
     wifi%wei%gil%inc(3) = map%axes(1)%u%uvp%inc
     ! 4th axis
     wifi%wei%char%code(4) = 'Vp'
     wifi%wei%gil%dim(4) = map%axes(2)%u%uvp%n
     wifi%wei%gil%ref(4) = map%axes(2)%u%uvp%ref
     wifi%wei%gil%val(4) = map%axes(2)%u%uvp%val
     wifi%wei%gil%inc(4) = map%axes(2)%u%uvp%inc
  else
     ! 3rd axis
     wifi%wei%char%code(3) = 'RA'
     wifi%wei%gil%dim(3) = map%axes(1)%u%sky%n
     wifi%wei%gil%ref(3) = map%axes(1)%u%sky%ref
     wifi%wei%gil%val(3) = map%axes(1)%u%sky%val
     wifi%wei%gil%inc(3) = map%axes(1)%u%sky%inc
     ! 4th axis
     wifi%wei%char%code(4) = 'DEC'
     wifi%wei%gil%dim(4) = map%axes(2)%u%sky%n
     wifi%wei%gil%ref(4) = map%axes(2)%u%sky%ref
     wifi%wei%gil%val(4) = map%axes(2)%u%sky%val
     wifi%wei%gil%inc(4) = map%axes(2)%u%sky%inc
  endif
  !
end subroutine wifisyn_wifi_weight_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_uvgrid_sort_and_weight(uvin,uvout,map,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvgrid_sort_and_weight
  use wifisyn_uv_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(uv_t),  intent(in)    :: uvin
  type(uv_t),  intent(inout) :: uvout
  type(map_t), intent(inout) :: map
  logical,     intent(inout) :: error
  !
  integer :: ndata
  character(len=*), parameter :: rname='UVGRID/SORT+WEIGHT'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ndata = uvin%head%type%ndata
  ! Sorting
  call wifisyn_set_index(ndata,map%sort,error)
  if (error) return
  call wifisyn_sort_head(map%sort,uvout,error)
  if (error) return
  ! Weighting
  call wifisyn_weighting_extract_sort(map%win%cur(1)%wchan,uvin,map%sort,map%weight,error)
  if (error) return
  call wifisyn_weighting_taper(uvout%head,map%taper,map%weight%mod,error)
  if (error) return
  call wifisyn_weighting_noise(map%weight,map%noise,error)
  if (error) return
  !
end subroutine wifisyn_uvgrid_sort_and_weight
!
subroutine wifisyn_uvgrid_shift_sort_transpose_data(win,shift,sort,tabin,tabout,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvgrid_shift_sort_transpose_data
  use wifisyn_uv_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  ! The output visibilities are a rotated, phase shifted, transposed, sorted
  ! copy of the input ones. This is the sorting and the transposition
  ! which makes it different from wifisyn_shift_uv_data. All the operations
  ! are grouped here to avoid copying 3 times the same data... Note that
  ! only the visibility are changed, the header data (U,V,X,Y,...)
  ! stays untouched. Weights are not carried over.
  !----------------------------------------------------------------------
  type(window_t),   intent(in)    :: win
  type(shift_t),    intent(inout) :: shift
  type(sort_t),     intent(inout) :: sort
  type(uv_t),       intent(in)    :: tabin
  type(uv_t),       intent(inout) :: tabout
  logical,          intent(inout) :: error
  !
  integer :: nchan,first,last
  integer :: ndata,idata,is
  real :: phi,cphi,sphi
  character(len=*), parameter :: rname='UVGRID/SHIFT+SORT+TRANS/DATA'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ndata = tabin%head%type%ndata
  nchan = tabin%head%type%nchan
  first = win%first
  last  = win%last
  !
  ! Sanity check
  if (inconsistent_size(rname,'input  table',ndata,'output table',tabout%head%type%ndata,error)) return
  if (inconsistent_size(rname,'input  table',tabin%head%type%nchan,'output table',tabout%head%type%nchan,error)) return
  if (inconsistent_size(rname,'input  table',ndata,'v sign',shift%vsign%n,error)) return
  if (inconsistent_size(rname,'input  table',ndata,'sort index',sort%idx%n,error)) return
  if (tabin%head%type%order.ne.code_tuv) then
     call wifisyn_message(seve%e,rname,'Input table order must be TUV')
     error = .true.
     return
  endif
  if (tabout%head%type%order.ne.code_uvt) then
     call wifisyn_message(seve%e,rname,'Output table order must be UVT')
     error = .true.
     return
  endif
  if (first.lt.1) then
     call wifisyn_message(seve%e,rname,'First channel lower than 1')
     error = .true.
     return
  endif
  if (last.gt.nchan) then
     call wifisyn_message(seve%e,rname,'Last channel greater than nchan')
     error = .true.
     return
  endif
  !
  if (shift%xy(1).eq.0 .and. shift%xy(2).eq.0) then
     ! Simple case: No phase shift
     do idata=1,ndata
        is = sort%idx%val(idata)
        if (shift%vsign%val(is)) then
           tabout%data(1:2,first:last,idata) = tabin%data(is,1:2,first:last)
        else
           tabout%data(1,first:last,idata) =  tabin%data(is,1,first:last)
           tabout%data(2,first:last,idata) = -tabin%data(is,2,first:last)
        endif
     enddo
  else
     ! Complex case: Phase center has been shifted
     do idata=1,ndata
        is = sort%idx%val(idata)
        phi = shift%xy(1)*tabout%head%u(is)+shift%xy(2)*tabout%head%v(is)
        cphi = cos(phi)
        sphi = sin(phi)
        if (shift%vsign%val(is)) then
           tabout%data(1,first:last,idata) = tabin%data(is,1,first:last)*cphi - tabin%data(is,2,first:last)*sphi
           tabout%data(2,first:last,idata) = tabin%data(is,1,first:last)*sphi + tabin%data(is,2,first:last)*cphi
        else
           tabout%data(1,first:last,idata) = tabin%data(is,1,first:last)*cphi + tabin%data(is,2,first:last)*sphi
           tabout%data(2,first:last,idata) = tabin%data(is,1,first:last)*sphi - tabin%data(is,2,first:last)*cphi
        endif
     enddo
  endif
  !
  ! Clean up
  call wifisyn_free_inte_1d(sort%idx,error)
  if (error) return
  call wifisyn_free_logi_1d(shift%vsign,error)
  if (error) return
  !
end subroutine wifisyn_uvgrid_shift_sort_transpose_data
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_output
  use cubetools_structure
  use cubetools_switch_types
  use cubesyntax_key_types
  use cubeset_messaging
  !
  public :: output
  private
  !
  type :: output_comm_t
     type(option_t), pointer :: comm
     type(switch_comm_t) :: extrema
     type(switch_comm_t) :: todisk
     type(switch_comm_t) :: radio2sfl
     type(key_comm_t)    :: default
   contains
     procedure, public  :: register => cubeset_output_register
     procedure, private :: parse    => cubeset_output_parse
     procedure, private :: main     => cubeset_output_main
  end type output_comm_t
  type(output_comm_t) :: output
  !
  type :: output_user_t
     logical :: list
     type(switch_user_t) :: extrema
     type(switch_user_t) :: todisk
     type(switch_user_t) :: radio2sfl
     type(key_user_t)    :: default
   contains
     procedure, private :: toprog => cubeset_output_user_toprog
  end type output_user_t
  !
  type :: output_prog_t
     logical :: list
     type(switch_prog_t) :: extrema
     type(switch_prog_t) :: todisk
     type(switch_prog_t) :: radio2sfl
     type(key_prog_t)    :: default
   contains
     procedure, private :: act => cubeset_output_prog_act
  end type output_prog_t
  !
contains
  !
  subroutine cubeset_output_command(line,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(output_user_t) :: user
    character(len=*), parameter :: rname='OUTPUT>COMMAND'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call output%parse(line,user,error)
    if (error) return
    call output%main(user,error)
    if (error) return
  end subroutine cubeset_output_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeset_output_register(output,error)
    use cubetools_parameters
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(output_comm_t), intent(inout) :: output
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OUTPUT>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'OUTPUT','',&
         'Set how output cubes are handled',&
         'The /EXTREMA key enables or disables the automatic computation&
         &/update of the extrema section in the header of the output&
         & cubes. Default is ON.'&
         //strg_bl//&
         '/TODISK Enables or disables writing the cubes from memory to&
         & disk at the end of the processing. This makes sense for&
         & memory mode only. Default is ON.'&
         //strg_bl//&
         &'/RADIO2SFL Enables or disables the automatic conversion from&
         & radio a.k.a. GLobal-Sinusoidal (GLS) to Sanson-Flamsteed&
         & (SFL) projection. Any GLS projection can be mathematically&
         & expressed as an equivalent SFL projection with no need to&
         & reproject the data. The drawback is that the reference&
         & point is moved on the Equator, resulting in possibly large&
         & offsets from reference in the map. This tuning applies only&
         & for FITS headers because GLS is deprecated in this format.&
         & Default is ON. Use /DEFAULT to reset output settings. When&
         & /DEFAULT is combined with other keys on the same command line,&
         & reset is applied first.',&
         cubeset_output_command,&
         output%comm,error)
    if (error) return
    !
    call output%extrema%register(&
         'EXTREMA',&
         'automatic extrema calculation',&
         'ON',&
         strg_emp,&
         error)
    if (error) return
    call output%todisk%register(&
         'TODISK',&
         'flushing to disk in disk mode',&
         'ON',&
         strg_emp,&
         error)
    if (error) return
    call output%radio2sfl%register(&
         'RADIO2SFL',&
         'automatic conversion of RADIO to SFL projection',&
         'ON',&
         strg_emp,&
         error)
    if (error) return
    call output%default%register(&
         'DEFAULT',&
         'Reset settings',&
         'Reset output settings before applying other keys from the same&
         & command line.',&
         error)
    if (error) return
  end subroutine cubeset_output_register
  !
  subroutine cubeset_output_parse(comm,line,user,error)
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(output_comm_t), intent(inout) :: comm
    character(len=*),     intent(in)    :: line
    type(output_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OUTPUT>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    user%list = cubetools_nopt().eq.0
    !
    if (user%list) then
       ! nothing to do
    else
       call comm%extrema%parse(line,user%extrema,error)
       if (error) return
       call comm%todisk%parse(line,user%todisk,error)
       if (error) return
       call comm%radio2sfl%parse(line,user%radio2sfl,error)
       if (error) return
       call comm%default%parse(line,user%default,error)
       if (error) return
    endif
  end subroutine cubeset_output_parse
  !
  subroutine cubeset_output_main(comm,user,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(output_comm_t), intent(inout) :: comm
    type(output_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(output_prog_t) :: prog
    character(len=*), parameter :: rname='OUTPUT>MAIN'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubeset_output_main
  !
  !-----------------------------------------------------------------------
  !
  subroutine cubeset_output_user_toprog(user,comm,prog,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(output_user_t), intent(in)    :: user
    type(output_comm_t),  intent(in)    :: comm
    type(output_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OUTPUT>USER>TOPROG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    prog%list = user%list
    call user%extrema%toprog(comm%extrema,prog%extrema,error)
    if (error) return
    call user%todisk%toprog(comm%todisk,prog%todisk,error)
    if (error) return
    call user%radio2sfl%toprog(comm%radio2sfl,prog%radio2sfl,error)
    if (error) return
    call user%default%toprog(comm%default,prog%default,error)
    if (error) return
  end subroutine cubeset_output_user_toprog
  !
  !-----------------------------------------------------------------------
  !
  subroutine cubeset_output_prog_act(prog,error)
    use cubetools_setup_types
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(output_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(cube_setup_output_t) :: defaults
    type(cube_setup_api_t) :: setup
    character(len=*), parameter :: rname='OUTPUT>PROG>ACT'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (prog%default%act) then
      call setup%output%reset()  ! New scheme
      cubset%output = defaults   ! Obsolescent scheme
    endif
    if (prog%extrema%act) cubset%output%extrema = prog%extrema%enabled
    if (prog%todisk%act)  cubset%output%write   = prog%todisk%enabled
    if (prog%radio2sfl%act)  call setup%output%radio2sfl%set(prog%radio2sfl%enabled,error)
    if (prog%list) then
       call cubeset_message(seve%r,rname,'  Output')
       prog%extrema%action = 'EXTREMA'
       prog%extrema%enabled = cubset%output%extrema
       call prog%extrema%list(error)
       if (error) return
       prog%todisk%action = 'TODISK'
       prog%todisk%enabled = cubset%output%write
       call prog%todisk%list(error)
       if (error) return
       prog%radio2sfl%action = 'RADIO2SFL'
       call setup%output%radio2sfl%get(prog%radio2sfl%enabled)
       call prog%radio2sfl%list(error)
       if (error) return
    endif
  end subroutine cubeset_output_prog_act
end module cubeset_output
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_cube_reallocate_r4d(kind,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_reallocate_r4d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: kind
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  !
  integer :: ier,nx,ny,nu,nv
  character(len=80) :: mess
  character(len=*), parameter :: rname='CUBE/REALLOCATE/R4D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Free when needed
  call wifisyn_cube_free_r4d(cube,error)
  ! Allocate
  nx = cube%gil%dim(1)
  ny = cube%gil%dim(2)
  nu = cube%gil%dim(3)
  nv = cube%gil%dim(4)
  allocate(cube%r4d(nx,ny,nu,nv),stat=ier)
  if (failed_allocate(rname,kind,ier,error)) return
  ! User feedback
  write(mess,'(a,a,a,i0,a,i0,a,i0,a,i0)') 'Allocated ',kind,' array of size: ',nx,' x ',ny,' x ',nu,' x ',nv
  call wifisyn_message(seve%i,rname,mess)
  cube%gil%ndim = 4
  ! Initialize
  cube%r4d = cube%gil%bval
  !
end subroutine wifisyn_cube_reallocate_r4d
!
subroutine wifisyn_cube_free_r4d(cube,error)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_cube_free_r4d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: cube
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='CUBE/FREE/R4D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (associated(cube%r4d)) deallocate(cube%r4d)
  nullify(cube%r4d)
  !
end subroutine wifisyn_cube_free_r4d
!
subroutine wifisyn_cube_reallocate_r3d(nc,kind,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_reallocate_r3d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer,          intent(in)    :: nc
  character(len=*), intent(in)    :: kind
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  !
  integer :: ier,nx,ny
  character(len=80) :: mess
  character(len=*), parameter :: rname='CUBE/REALLOCATE/R3D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Free when needed
  call wifisyn_cube_free_r3d(cube,error)
  ! Allocate
  nx = cube%gil%dim(1)
  ny = cube%gil%dim(2)
  if (nc.gt.cube%gil%dim(3)) then
     write(mess,'(a,i0,a,i0,a)') 'Trying to allocate more channels (',nc,') than expected in file (',cube%gil%dim(3),')'
     call wifisyn_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  allocate(cube%r3d(nx,ny,nc),stat=ier)
  if (failed_allocate(rname,kind,ier,error)) return
  ! User feedback
  write(mess,'(a,a,a,i0,a,i0,a,i0)') 'Allocated ',kind,' array of size: ',nx,' x ',ny,' x ',nc
  call wifisyn_message(seve%i,rname,mess)
  ! Header update (do *not* update the 3rd header dimensions here...)
  cube%gil%ndim = 3
  cube%gil%dim(4) = 1
  ! Initialize
  cube%r3d = cube%gil%bval
  !
end subroutine wifisyn_cube_reallocate_r3d
!
subroutine wifisyn_cube_free_r3d(cube,error)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_cube_free_r3d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: cube
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='CUBE/FREE/R3D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (associated(cube%r3d)) deallocate(cube%r3d)
  nullify(cube%r3d)
  !
end subroutine wifisyn_cube_free_r3d
!
subroutine wifisyn_cube_reallocate_r2d(kind,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_reallocate_r2d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: kind
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  !
  integer :: ier,nx,ny
  character(len=80) :: mess
  character(len=*), parameter :: rname='CUBE/REALLOCATE/R2D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Free when needed
  call wifisyn_cube_free_r2d(cube,error)
  ! Allocate
  nx = cube%gil%dim(1)
  ny = cube%gil%dim(2)
  allocate(cube%r2d(nx,ny),stat=ier)
  if (failed_allocate(rname,kind,ier,error)) return
  ! User feedback
  write(mess,'(a,a,a,i0,a,i0)') 'Allocated ',kind,' array of size: ',nx,' x ',ny
  call wifisyn_message(seve%i,rname,mess)
  ! Header update
  cube%gil%ndim = 2
  cube%gil%dim(3) = 1
  cube%gil%dim(4) = 1
  ! Initialize
  cube%r2d = cube%gil%bval
  !
end subroutine wifisyn_cube_reallocate_r2d
!
subroutine wifisyn_cube_free_r2d(cube,error)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_cube_free_r2d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: cube
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='CUBE/FREE/R2D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (associated(cube%r2d)) deallocate(cube%r2d)
  nullify(cube%r2d)
  !
end subroutine wifisyn_cube_free_r2d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_cube_minmax_r4d(logscale,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_minmax_r4d
  use wifisyn_gridding_types
  !--------------------------------------------------------------------
  ! @ private
  ! Update the minimum and maximum value of a cube and
  ! their locations. We here assume that the initializations
  ! were done when the cube was initialized...
  !--------------------------------------------------------------------
  logical,        intent(in)    :: logscale
  type(gildas),   intent(inout) :: cube
  logical,        intent(inout) :: error
  !
  real(kind=4) :: cubval
  integer(kind=index_length) :: ix,iy,iu,iv
  character(len=*), parameter :: rname='CUBE/MINMAX/R4D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (cube%gil%ndim.ne.4) then
     call wifisyn_message(seve%e,rname,'Cube rank is not 4')
     error = .true.
     return
  endif
  !
  do iv=1,cube%gil%dim(4)
     do iu=1,cube%gil%dim(3)
        do iy=1,cube%gil%dim(2)
           do ix=1,cube%gil%dim(1)
              cubval = cube%r4d(ix,iy,iu,iv)
              if (logscale.and.(cubval.eq.0.0)) cycle
              if (cubval.gt.cube%gil%rmax) then
                 cube%gil%rmax = cubval
                 cube%gil%maxloc(1) = ix
                 cube%gil%maxloc(2) = iy
                 cube%gil%maxloc(3) = iu
                 cube%gil%maxloc(4) = iv
              endif
              if (cubval.lt.cube%gil%rmin) then
                 cube%gil%rmin = cubval
                 cube%gil%minloc(1) = ix
                 cube%gil%minloc(2) = iy
                 cube%gil%minloc(3) = iu
                 cube%gil%minloc(4) = iv
              endif
           enddo ! ix
        enddo ! iy
     enddo ! iu
  enddo ! iv
  if (logscale.and.(cube%gil%rmin.eq.cube%gil%rmax)) cube%gil%rmin = cube%gil%rmax/10.0
  !
  print *,"max:",cube%gil%rmax,cube%gil%maxloc(1:4)
  print *,"min:",cube%gil%rmin,cube%gil%minloc(1:4)
  !
end subroutine wifisyn_cube_minmax_r4d
!
subroutine wifisyn_cube_minmax_r3d(logscale,win,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_minmax_r3d
  use wifisyn_gridding_types
  !--------------------------------------------------------------------
  ! @ private
  ! Update the minimum and maximum value of a cube and
  ! their locations. We here assume that the initializations
  ! were done when the cube was initialized...
  !--------------------------------------------------------------------
  logical,        intent(in)    :: logscale
  type(window_t), intent(in)    :: win
  type(gildas),   intent(inout) :: cube
  logical,        intent(inout) :: error
  !
  real(kind=4) :: cubval
  integer(kind=index_length) :: ix,iy,ic
  character(len=*), parameter :: rname='CUBE/MINMAX/R3D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (cube%gil%ndim.ne.3) then
     call wifisyn_message(seve%e,rname,'Cube rank is not 3')
     error = .true.
     return
  endif
  !
  do ic=win%first,win%last
     do iy=1,cube%gil%dim(2)
        do ix=1,cube%gil%dim(1)
           cubval = cube%r3d(ix,iy,ic)
           if (logscale.and.(cubval.eq.0.0)) cycle
           if (cubval.gt.cube%gil%rmax) then
              cube%gil%rmax = cubval
              cube%gil%maxloc(1) = ix
              cube%gil%maxloc(2) = iy
              cube%gil%maxloc(3) = ic
           endif
           if (cubval.lt.cube%gil%rmin) then
              cube%gil%rmin = cubval
              cube%gil%minloc(1) = ix
              cube%gil%minloc(2) = iy
              cube%gil%minloc(3) = ic
           endif
        enddo ! ix
     enddo ! iy
  enddo ! ic
  if (logscale.and.(cube%gil%rmin.eq.cube%gil%rmax)) cube%gil%rmin = cube%gil%rmax/10.0
  !
  print *,"max:",cube%gil%rmax,cube%gil%maxloc(1:3)
  print *,"min:",cube%gil%rmin,cube%gil%minloc(1:3)
  !
end subroutine wifisyn_cube_minmax_r3d
!
subroutine wifisyn_cube_minmax_r2d(logscale,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_minmax_r2d
  use wifisyn_gridding_types
  !--------------------------------------------------------------------
  ! @ private
  ! Update the minimum and maximum value of a cube and
  ! their locations. We here assume that the initializations
  ! were done when the cube was initialized...
  !--------------------------------------------------------------------
  logical,        intent(in)    :: logscale
  type(gildas),   intent(inout) :: cube
  logical,        intent(inout) :: error
  !
  real(kind=4) :: cubval
  integer(kind=index_length) :: ix,iy
  character(len=*), parameter :: rname='CUBE/MINMAX/R2D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (cube%gil%ndim.ne.2) then
     call wifisyn_message(seve%e,rname,'Cube rank is not 2')
     error = .true.
     return
  endif
  do iy=1,cube%gil%dim(2)
     do ix=1,cube%gil%dim(1)
        cubval = cube%r2d(ix,iy)
        if (logscale.and.(cubval.eq.0.0)) cycle
        if (cubval.gt.cube%gil%rmax) then
           cube%gil%rmax = cubval
           cube%gil%maxloc(1) = ix
           cube%gil%maxloc(2) = iy
        endif
        if (cubval.lt.cube%gil%rmin) then
           cube%gil%rmin = cubval
           cube%gil%minloc(1) = ix
           cube%gil%minloc(2) = iy
        endif
     enddo ! ix
  enddo ! iy
  !
end subroutine wifisyn_cube_minmax_r2d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_cube_open(name,ibuffer,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_open
  use wifisyn_buffer_parameters
  !----------------------------------------------------------------------
  ! @ private
  ! *** JP should probably here use the readwrite_t
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: name
  integer,          intent(in)    :: ibuffer
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CUBE/OPEN'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if ((ibuffer.lt.1).or.(mbuffer.lt.ibuffer)) then
     call wifisyn_message(seve%e,rname,'Unknown buffer')
     error = .true.
     return
  endif
  call sic_parse_file(name,' ',known_buffer_type(ibuffer),cube%file)
  call gdf_create_image(cube,error)
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_open
!
subroutine wifisyn_cube_read(do,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_read
  use wifisyn_readwrite_types
  use wifisyn_cube_types
  !------------------------------------------------------------------
  ! @ private
  ! Read input cube header and data
  !------------------------------------------------------------------
  type(readwrite_t), intent(in)    :: do
  type(gildas),      intent(inout) :: cube
  logical,           intent(inout) :: error
  ! Local
  integer :: nchan
  character(len=*), parameter :: rname = 'CUBE/READ'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call sic_parse_file(do%name,' ',do%type,cube%file)
  cube%blc = 0
  cube%trc = 0
  call gdf_read_header(cube,error)
  if (gildas_error(cube,rname,error)) return
  if (cube%gil%ndim.eq.3) then
     nchan = max(1,do%last-do%first)
     call wifisyn_cube_reallocate_r3d(nchan,do%kind,cube,error)
     if (error) return
     call gdf_read_data(cube,cube%r3d,error)
     if (gildas_error(cube,rname,error)) return
  else if (cube%gil%ndim.eq.4) then
     call wifisyn_cube_reallocate_r4d(do%kind,cube,error)
     if (error) return
     call gdf_read_data(cube,cube%r4d,error)
     if (gildas_error(cube,rname,error)) return
  endif
  call gdf_close_image(cube,error) ! Free image slot
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_read
!
subroutine wifisyn_cube_write_r4d(i3,i4,cube,error)
  use gbl_message
  use gildas_def
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_write_r4d
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer,              intent(in)    :: i3
  integer,              intent(in)    :: i4
  type(gildas), target, intent(inout) :: cube
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CUBE/WRITE/R4D'
  !
  real, pointer :: cube_r2d(:,:) => null()
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  cube%blc(:) = 0
  cube%blc(3) = i3
  cube%blc(4) = i4
  cube%trc(:) = 0
  cube%trc(3) = i3
  cube%trc(4) = i4
  cube_r2d => cube%r4d(:,:,i3,i4)
  call gdf_write_data(cube,cube_r2d,error)
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_write_r4d
!
subroutine wifisyn_cube_write(win,cube,error)
  use gbl_message
  use gildas_def
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_write
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(window_t), intent(in)    :: win
  type(gildas),   intent(inout) :: cube
  logical,        intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CUBE/WRITE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  cube%blc(:) = 0
  cube%blc(3) = win%first
  cube%trc(:) = 0
  cube%trc(3) = win%last
  call gdf_write_data(cube,cube%r3d,error)
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_write
!
subroutine wifisyn_cube_close(cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_close
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CUBE/CLOSE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call gdf_update_header(cube,error)
  if (gildas_error(cube,rname,error)) return
  call gdf_close_image(cube,error)
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_close
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_cube_sicdef(readonly,name,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_sicdef
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical,          intent(in)    :: readonly
  character(len=*), intent(in)    :: name ! sic name
  type(gildas),     intent(inout) :: cube ! buffer
  logical,          intent(inout) :: error
  !
  integer :: ndim
  character(len=80) :: mess
  character(len=*), parameter :: rname='CUBE/SICDEF'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  call wifisyn_message(seve%i,rname,'Defining '//trim(name)//' SIC structure')
  !
  if (sic_varexist(name)) then
     call wifisyn_message(seve%d,rname,trim(name)//' SIC structure already exists')
     call wifisyn_cube_sicdel_header(name,error)
     if (error) return
     call sic_delvariable(name,.false.,error)
     if (error) return
  endif
  ndim = cube%gil%ndim
  if (ndim.eq.2) then
     call sic_def_real(name,cube%r2d,ndim,cube%gil%dim,readonly,error)
     if (error) return
  else if (ndim.eq.3) then
     call sic_def_real(name,cube%r3d,ndim,cube%gil%dim,readonly,error)
     if (error) return
  else if (ndim.eq.4) then
     call sic_def_real(name,cube%r4d,ndim,cube%gil%dim,readonly,error)
     if (error) return
  else
     write(mess,*) ndim,' dimensions in ',trim(name),' while expecting at least 2'
     call wifisyn_message(seve%e,rname,mess)
     error = readonly
     return
  endif
  call sic_def_header(name,cube,readonly,error)
  if (error) return
  !
end subroutine wifisyn_cube_sicdef
!
subroutine wifisyn_cube_sicdel_header(name,error)
  use gbl_message
  use gildas_def
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_cube_sicdel_header
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name
  logical,          intent(inout) :: error
  !
  integer :: nn
  character(len=varname_length) :: pre
  character(len=*), parameter :: rname='CUBE/SICDEL/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nn = len_trim(name)+1
  pre = name
  pre(nn:nn) = '%'
  !
  ! GENERAL section
  call sic_delvariable(pre(1:nn)//'GENE',.false.,error)
  call sic_delvariable(pre(1:nn)//'NDIM',.false.,error)
  call sic_delvariable(pre(1:nn)//'DIM',.false.,error)
  call sic_delvariable(pre(1:nn)//'CONVERT',.false.,error)
  ! Blanking section
  call sic_delvariable(pre(1:nn)//'BLAN',.false.,error)
  call sic_delvariable(pre(1:nn)//'BLANK',.false.,error)
  ! Extrema
  call sic_delvariable(pre(1:nn)//'EXTREMA',.false.,error)
  call sic_delvariable(pre(1:nn)//'MIN',.false.,error)
  call sic_delvariable(pre(1:nn)//'MAX',.false.,error)
  call sic_delvariable(pre(1:nn)//'MAXLOC',.false.,error)
  call sic_delvariable(pre(1:nn)//'MINLOC',.false.,error)
  ! Units and cooreadonlyinate system
  call sic_delvariable(pre(1:nn)//'DESC',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT1',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT2',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT3',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT4',.false.,error)
  call sic_delvariable(pre(1:nn)//'SYSTEM',.false.,error)
  !
  ! Astronomical position
  call sic_delvariable(pre(1:nn)//'POSI',.false.,error)
  call sic_delvariable(pre(1:nn)//'SOURCE',.false.,error)
  call sic_delvariable(pre(1:nn)//'RA',.false.,error)
  call sic_delvariable(pre(1:nn)//'DEC',.false.,error)
  call sic_delvariable(pre(1:nn)//'LII',.false.,error)
  call sic_delvariable(pre(1:nn)//'BII',.false.,error)
  !
  call sic_delvariable(pre(1:nn)//'EPOCH',.false.,error)
  !
  ! Projection
  call sic_delvariable(pre(1:nn)//'PROJ',.false.,error)
  call sic_delvariable(pre(1:nn)//'PTYPE',.false.,error)
  call sic_delvariable(pre(1:nn)//'A0',.false.,error)
  call sic_delvariable(pre(1:nn)//'D0',.false.,error)
  call sic_delvariable(pre(1:nn)//'ANGLE',.false.,error)
  call sic_delvariable(pre(1:nn)//'X_AXIS',.false.,error)
  call sic_delvariable(pre(1:nn)//'Y_AXIS',.false.,error)
  !
  ! Spectroscopy
  call sic_delvariable(pre(1:nn)//'SPEC',.false.,error)
  call sic_delvariable(pre(1:nn)//'LINE',.false.,error)
  call sic_delvariable(pre(1:nn)//'FREQRES',.false.,error)
  call sic_delvariable(pre(1:nn)//'IMAGFRE',.false.,error)
  call sic_delvariable(pre(1:nn)//'RESTFRE',.false.,error)
  call sic_delvariable(pre(1:nn)//'VELRES',.false.,error)
  call sic_delvariable(pre(1:nn)//'VELOFF',.false.,error)
  call sic_delvariable(pre(1:nn)//'F_AXIS',.false.,error)
  !
  ! Beam size
  call sic_delvariable(pre(1:nn)//'BEAM',.false.,error)
  call sic_delvariable(pre(1:nn)//'MAJOR',.false.,error)
  call sic_delvariable(pre(1:nn)//'MINOR',.false.,error)
  call sic_delvariable(pre(1:nn)//'PA',.false.,error)
  !
  ! Noise
  call sic_delvariable(pre(1:nn)//'SIGMA',.false.,error)
  call sic_delvariable(pre(1:nn)//'NOISE',.false.,error)
  call sic_delvariable(pre(1:nn)//'RMS',.false.,error)
  !
  call sic_delvariable(pre(1:nn)//'PROPER',.false.,error)
  call sic_delvariable(pre(1:nn)//'MU',.false.,error)
  call sic_delvariable(pre(1:nn)//'PARALLAX',.false.,error)

  !
end subroutine wifisyn_cube_sicdel_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module astro_specsweep_types
  use gbl_message
  use astro_types
  !
  public
  private :: specsweep_reallocate
  ! For spectral sweep tool
  type noema_spsweep_in_t
    logical :: in_range=.false.
    logical :: in_ntune=.false.
    ! Range mode
    real(kind=8) :: restlim(2)=[undef_freq,undef_freq] ! frequency limits in rest
    real(kind=8) :: rflim(2)=[undef_freq,undef_freq] ! frequency limits in rf
    real(kind=8) :: width=undef_freq
    logical :: do_limrange
    ! n tuning mode
    integer(kind=4) :: n_tunings=undef_freq ! integer number of tuning to co
    real(kind=8) :: restref=undef_freq     ! frequency to align the tuning
    real(kind=8) :: rfref=undef_freq     ! frequency to align the tuning, in RF
    character(len=8) :: align='MIN'   ! how to align tuning on ref freq
  end type noema_spsweep_in_t
  !
  type noema_spsweep_param_t
    real(kind=8) :: tuning_width=undef_freq
    real(kind=8) :: if_width=undef_freq !
    real(kind=8) :: couple_width=undef_freq
  end type noema_spsweep_param_t
  !
  type noema_spsweep_out_t
    integer(kind=4)    :: iband=0             ! band where sweep is done
    type(receiver_source_t) :: srsou
    type(receiver_desc_t)    :: srdesc                 ! receiver type = source, desc, and n_tunings
    integer(kind=4)         :: n_sweep=0
    type(noema_febe_t), allocatable :: sfebe(:)
  contains
    procedure, public :: addtuning => noema_specsweep_addtuning
  end type noema_spsweep_out_t
  !
  type noema_spsweep_t
    type(noema_spsweep_in_t) :: in
    type(noema_spsweep_param_t) :: param
    type(noema_spsweep_out_t) :: out
  contains
    procedure, public :: free => specsweep_free
    procedure, public :: reallocate => specsweep_reallocate
    procedure, public :: reset => noema_reset_spsweep
    procedure, public :: dorange => noema_specsweep_range
    procedure, public :: donumber => noema_specsweep_number
    procedure, public :: plot => noema_specsweep_plot
  end type noema_spsweep_t
  !
contains
  subroutine specsweep_reallocate(specsweep,n_sweep,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! allocate sweep structure to the right size
    !-----------------------------------------------------------------------
    class(noema_spsweep_t), intent(inout) :: specsweep
    integer(kind=4), intent(in) :: n_sweep
    logical, intent(inout)      :: error
    !
    character(len=*), parameter :: rname='SPECSWEEP>REALLOCATE'
    integer(kind=4) :: ier
    logical         :: alloc
    !
    alloc=.true.
    ! First check if alloc already
    if (allocated(specsweep%out%sfebe)) then
      if (specsweep%out%n_sweep.eq.n_sweep) then
        ! Already allocated at the right size
        alloc = .false.
      else
        ! Not the right size: deallocate
        call specsweep%free(error)
        if (error) return
        alloc=.true.
      endif
    endif
    if (alloc) then
      ! Allocate to right size
      allocate(specsweep%out%sfebe(n_sweep),stat=ier)
      if (failed_allocate(rname,'SPECSWEEP SIZE',ier,error))  return
      specsweep%out%n_sweep=n_sweep
    endif
    !
  end subroutine specsweep_reallocate
  !
  subroutine specsweep_free(specsweep,error)
    ! Deallocate pfx%unit
    class(noema_spsweep_t), intent(inout) :: specsweep
    logical, intent(inout)      :: error
    !
    if (allocated(specsweep%out%sfebe)) deallocate(specsweep%out%sfebe)
    !
  end subroutine specsweep_free
  !
  subroutine noema_reset_spsweep(specsweep,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! initialize spectral sweep structure (mainly inputs defaults)
    !-----------------------------------------------------------------------
    class(noema_spsweep_t), intent(inout) :: specsweep
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='SPECSWEEP>RESET'
    !
    specsweep%param%tuning_width=0d0
    specsweep%param%if_width=0d0
    specsweep%param%couple_width=0d0
    !
    specsweep%in%rflim(1)=0d0
    specsweep%in%rflim(2)=0d0
    specsweep%in%restlim(1)=0d0
    specsweep%in%restlim(2)=0d0
    specsweep%in%width=0d0
    specsweep%in%restref=0d0
    specsweep%in%rfref=0d0
    specsweep%in%align='NULL'
    specsweep%in%n_tunings=0
    !
    specsweep%out%iband=0
    specsweep%out%n_sweep=0
    !
  end subroutine noema_reset_spsweep
  !
  subroutine noema_specsweep_range(ssweep,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! find combination of tuning to cover an input range
    !-----------------------------------------------------------------------
    class(noema_spsweep_t), intent(inout) :: ssweep ! ssweep description
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='SPECSWEEP>DORANGE'
    integer(kind=4),parameter :: m_add=2 ! max number of additional tunings to complete the ssweep
    logical :: add_fold(m_add),add_right(m_add)
    integer(kind=4) :: it,ia,n_tune_couple,n_add,band1,band2
    real(kind=8) :: flo,fedge,couplewidth,wleft,check_bandup,ncouple,add_shift_off(m_add)
    real(kind=8) :: percent_freq,percent_tuning
    real(kind=8), parameter :: percent_lim=30d0  !percent of freq in last tuning (to trigger warning)
    character(len=256) :: mess
    !
    ssweep%in%rflim(1) = ssweep%in%restlim(1)*ssweep%out%srsou%dopshift   !MHz
    call rec_find_band(rname,ssweep%out%srdesc,ssweep%in%rflim(1),band1,error)
    if (error) return
    ssweep%in%rflim(2) = ssweep%in%restlim(2)*ssweep%out%srsou%dopshift   !MHz
    call rec_find_band(rname,ssweep%out%srdesc,ssweep%in%rflim(2),band2,error)
    if (error) return
    if (band1.ne.band2) then
        call astro_message(seve%e,rname,'Fmin and Fmax are not in the same receiver band')
        error=.true.
        return
    endif
    ssweep%out%iband=band1
    ssweep%in%width=abs(ssweep%in%rflim(2)-ssweep%in%rflim(1))
    if (ssweep%in%width.le.ssweep%param%if_width) then
        call astro_message(seve%e,rname,'Spectral sweep can be done in a single tuning')
        error=.true.
        return
    endif
    ! Compute number of tuning
    ! Fist full combinations of 2 tunings
    couplewidth=4*ssweep%param%if_width
    ncouple=floor(ssweep%in%width/couplewidth)
    if (ncouple.eq.0) then
        ssweep%in%do_limrange=.false.
    endif
    n_tune_couple=ncouple*2
    ! Then remaining tunings
    wleft=mod(ssweep%in%width,couplewidth)
    check_bandup=ssweep%out%srdesc%rflim(2,ssweep%out%iband)-ssweep%in%rflim(2)+wleft
    n_add=0
    add_fold(1)=.false.
    add_fold(2)=.false.
    add_right(1)=.false.
    add_right(2)=.false.
    add_shift_off(1)=0d0
    add_shift_off(2)=0d0
    if (wleft.lt.ssweep%param%if_width) then
        n_add=1
        add_fold(1)=.true.
        if (check_bandup.lt.ssweep%param%if_width.or.ssweep%in%do_limrange) then
        add_right=.true.
        endif
    else if (wleft.lt.2*ssweep%param%if_width) then
        n_add=2
        if (ncouple.eq.0) then
        if (ssweep%out%srdesc%rflim(2,ssweep%out%iband)-ssweep%in%rflim(1).ge.3*ssweep%param%if_width) then
            add_fold(1)=.false.
        else
            add_fold(1)=.true.
        endif
        if (ssweep%out%srdesc%rflim(2,ssweep%out%iband)-ssweep%in%rflim(1)-ssweep%param%if_width  &
            .ge.3*ssweep%param%if_width) then
            add_fold(2)=.false.
        else
            add_fold(2)=.true.
        endif
        else
        add_fold(1)=.true.
        add_fold(2)=.true.
        endif
        if (check_bandup.lt.2*ssweep%param%if_width.or.ssweep%in%do_limrange) then
        add_right(1)=.true.
        add_shift_off(1)=-ssweep%param%if_width
        add_right(2)=.true.
        add_shift_off(2)=0d0
        endif
    !     endif
    else if (wleft.lt.3*ssweep%param%if_width) then
        n_add=2
        add_fold(1)=.false.
        if (ncouple.eq.0) then
        if (ssweep%out%srdesc%rflim(2,ssweep%out%iband)-ssweep%in%rflim(1).ge.3*ssweep%param%if_width) then
            add_fold(1)=.false.
        else
            add_fold(1)=.true.
        endif
        if (ssweep%out%srdesc%rflim(2,ssweep%out%iband)-ssweep%in%rflim(1)-ssweep%param%if_width &
            .ge.3*ssweep%param%if_width) then
            add_fold(2)=.false.
        else
            add_fold(2)=.true.
        endif
        else
        add_fold(2)=.true.
        if (check_bandup.lt.3*ssweep%param%if_width.or.ssweep%in%do_limrange) then
            add_right(1)=.true.
            add_shift_off(1)=0d0
            add_right(2)=.true.
            add_shift_off(2)=-ssweep%param%if_width
        endif
        endif
    else if (wleft.lt.4*ssweep%param%if_width) then
        n_add=2
        add_fold(1)=.false.
        add_fold(2)=.false.
        if (check_bandup.lt.4*ssweep%param%if_width.or.ssweep%in%do_limrange) then
        add_right(1)=.true.
        add_shift_off(1)=-ssweep%param%if_width
        add_right(2)=.true.
        add_shift_off(2)=0
        endif
    else
        call astro_message(seve%e,rname,'Problem with wleft')
        error=.true.
        return
    endif
    ssweep%in%n_tunings=ncouple*2+n_add
    ! Allocate the structure
    call ssweep%reallocate(ssweep%in%n_tunings,error)
    if (error) return
    ! Start aligned on lower frequency
    fedge=ssweep%in%rflim(1)
    ! Do the full couples of tunings
    do it=1,n_tune_couple
        flo=fedge+ssweep%out%srdesc%iflim(2)
        call ssweep%out%addtuning(it,flo,error)
        if (error) return
        print *,'Tuning done  #',it
        if (mod(it,2).eq.0) then
        ! even number
        fedge=fedge+ssweep%param%tuning_width
        else
        ! odd number
        fedge=fedge+ssweep%param%if_width
        endif
    enddo
    !
    ! Do the last tunings (0,1 or 2)
    it=n_tune_couple
    if (n_add.gt.0) then
        do ia=1,n_add
        it=it+1
        if (ssweep%in%do_limrange) then
            flo=ssweep%in%rflim(2)-ssweep%out%srdesc%iflim(2)+add_shift_off(ia)
        else
            if (.not.add_right(ia)) then
            ! Not close to band edge
            if (add_fold(ia)) then
                flo=fedge-ssweep%out%srdesc%iflim(1)
            else
                flo=fedge+ssweep%out%srdesc%iflim(2)
            endif
            else
            flo=ssweep%out%srdesc%rflim(2,ssweep%out%iband)-ssweep%out%srdesc%iflim(2)+add_shift_off(ia)
            endif
        endif
        call ssweep%out%addtuning(it,flo,error)
        if (error) return
        if (ia.eq.1) then
            fedge=fedge+ssweep%param%if_width
        else if (ia.eq.2) then
            fedge=fedge+ssweep%param%tuning_width
        endif
        enddo
    endif
    !
    ! Check if 1 tuning is added for small increase of total coverage
    percent_freq=(wleft-(n_add-1)*ssweep%param%if_width)/ssweep%in%width*100d0
    if (percent_freq.lt.percent_lim) then
        percent_tuning=100d0/(ssweep%in%n_tunings)
        write (mess,'(a,1x,f0.3,1x,a)') 'Last Tuning added to cover missing', &
                                        wleft-(n_add-1)*ssweep%param%if_width,'MHz'
        call astro_message(seve%w,rname,mess)
        write (mess,'(f0.1,a,1x,f0.1,a)') percent_tuning,'% supplementary time to get' &
                                        ,percent_freq,'% wider coverage'
        call astro_message(seve%w,rname,mess)
    endif
    !
  end subroutine noema_specsweep_range
  !
  subroutine noema_specsweep_addtuning(s_out,it,flo,error)
    !-----------------------------------------------------------------------
    ! do tuning #it in a spectral sweep
    !-----------------------------------------------------------------------
    class(noema_spsweep_out_t), intent(inout) :: s_out
    integer(kind=4), intent(in) :: it ! id of the current tuning
    real(kind=8), intent(in) :: flo ! LO freq for the tuning
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='SPECSWEEP>ADDTUNING'
    type(receiver_comm_t) :: rcomm
    real(kind=8) :: ifcent  !IF position for tuning
    !
    ifcent=(s_out%srdesc%iflim(1)+s_out%srdesc%iflim(2))/2d0
    rcomm%fcent=ifcent
    rcomm%rec_name=s_out%srdesc%name
    write (rcomm%name,'(a,i0)') 'SpecSweep',it
    rcomm%frest=(flo-ifcent)*ghzpermhz/s_out%srsou%dopshift ! back in rest frame
    rcomm%sideband="LSB"
    call astro_tune_receiver(rname,s_out%srdesc,s_out%srsou,rcomm,s_out%sfebe(it)%rectune,error)
    if (error) return
    s_out%sfebe(it)%defined=.true.
    s_out%sfebe(it)%rectune%ongrid=.false.
    !
  end subroutine noema_specsweep_addtuning
  !
  subroutine noema_specsweep_number(ssweep,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! find combination of tuning to cover an input range
    !-----------------------------------------------------------------------
    class(noema_spsweep_t), intent(inout) :: ssweep ! spectral sweep description
    logical, intent(inout) :: error
    ! local
    character(len=*),parameter :: rname='SPECSWEEP>DONUMBER'
    integer(kind=4) :: it
    real(kind=8) :: flo,fedge
    integer(kind=4) :: n_couple,n_add
    ! Compute width
    n_add=mod(ssweep%in%n_tunings,2)
    n_couple=floor(ssweep%in%n_tunings/2d0)
    if (n_add.eq.0) then
        ssweep%in%width=n_couple*ssweep%param%couple_width
    else if (n_add.eq.1) then
        ssweep%in%width=n_couple*ssweep%param%couple_width+ssweep%param%if_width
    else if (n_add.gt.1) then
        call astro_message(seve%e,rname,'Problem with number of tuning')
        error=.true.
        return
    endif
    !
    ! Compute lowest frequency
    select case (ssweep%in%align)
    case ('MIN')
        fedge=ssweep%in%rfref
    case ('MAX')
        fedge=ssweep%in%rfref-ssweep%in%width
    case ('CENTER')
        fedge=ssweep%in%rfref-ssweep%in%width/2d0
    case default
        call astro_message(seve%e,rname,'Problem with the alignment code')
        error = .true.
        return
    end select
    ! Check that lowest freq is in the band
    if (fedge.lt.ssweep%out%srdesc%rflim(1,ssweep%out%iband)) then
        call astro_message(seve%e,rname,'Spectral sweep goes to frequency lower than the band edge')
        error = .true.
        return
    endif
    ssweep%in%rflim(1)=fedge
    ssweep%in%restlim(1)=ssweep%in%rflim(1)/ssweep%out%srsou%dopshift
    !
    ! Check that hisghest freq is in the band
    ssweep%in%rflim(2)=fedge+ssweep%in%width
    ssweep%in%restlim(2)=ssweep%in%rflim(2)/ssweep%out%srsou%dopshift
    if (ssweep%in%rflim(2).gt.ssweep%out%srdesc%rflim(2,ssweep%out%iband)) then
        call astro_message(seve%e,rname,'Spectral sweep goes to frequency higher than the band edge')
        error = .true.
        return
    endif
    !
    ! Allocate the structure
    call ssweep%reallocate(ssweep%in%n_tunings,error)
    if (error) return
    !
    do it=1,ssweep%in%n_tunings
        flo=fedge+ssweep%out%srdesc%iflim(2)
        call ssweep%out%addtuning(it,flo,error)
        if (error) return
        if (mod(it,2).eq.0.and.ssweep%in%n_tunings.gt.it+1) then
        fedge=fedge+ssweep%param%tuning_width
        else
        fedge=fedge+ssweep%param%if_width
        endif
    enddo
    !
  end subroutine noema_specsweep_number
  !
  subroutine noema_specsweep_plot(ssweep,plotmode,cata,cplot,drawaxis,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! Displays the frequency coverage of a multi tuning spectral sweep
    !-----------------------------------------------------------------------
    class(noema_spsweep_t), intent(inout) :: ssweep ! spectral sweep description
    character(len=*), intent(in) :: plotmode
    type(plot_molecules_t), intent(in)   :: cata     !plot known lines from current catalog
    type(current_boxes_t), intent(inout) :: cplot
    type(frequency_axis_t), intent(in) :: drawaxis
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter      :: rname='SPECSWEEP>PLOT'
    integer(kind=4)       :: i,j,iband,sb_code(m_sideband),ip,is,it,lmess
    real(kind=8)          :: px,py,yoff,boxsize,frf,xt,yt
    real(kind=8) ::fmin,fmax,maxb,maxs,minb,mins
    real(kind=4) :: smess
    character(len=200)    :: comm,defchar,molchar,mess,mess2
    type(draw_rect_t)     :: sbrect
    type(draw_line_t)     :: line
    type(draw_mark_t)     :: mark
    !
    ! Clear the current window, and ONLY the current window
    call gr_execl('CHANGE DIRECTORY') ! No arg = go to the top directory
    call gr_execl('CLEAR DIRECTORY') ! No arg = clear the whole window
    call gr_exec1('TICKSPACE 0 0 0 0')
    call gr_pen(colour=adefcol,error=error)
    if (error) return
    ! get page info
    call sic_get_dble('page_x',px,error)
    if (error) return
    call sic_get_dble('page_y',py,error)
    if (error) return
    if (px.lt.29) then
        call astro_message(seve%w,rname,'PLOT is optimized for LANDSCAPE orientation of the display')
    endif
    ! set plot parameters
    cplot%nbox = ssweep%in%n_tunings
    do i=1,cplot%nbox
        call rec_reset_box(cplot%box(i),error)
    enddo
    cplot%desc%defchar = 0.4
    write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%defchar
    cplot%desc%molchar = 0.2
    write (molchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%molchar
    if (px.gt.25) then
        cplot%desc%smallchar = 0.3
    else if (px.le.25) then
        cplot%desc%smallchar = 0.2
    else
        call astro_message(seve%e,rname,'Problem with page size')
        error = .true.
        return
    endif
    call gr_exec1(defchar)
    yoff = 2d0
    boxsize = min((py-3.d0)/cplot%nbox-yoff,4.)
    !Loop on tunings
    iband=ssweep%out%iband
    !limits of the plot
    if (plotmode.eq.'RECEIVER') then
        fmin=ssweep%out%srdesc%restlim(1,iband)
        fmax=ssweep%out%srdesc%restlim(2,iband)
    else if (plotmode.eq.'RANGE') then
        maxs=-1d3
        mins=1d30
        do it=1,ssweep%in%n_tunings
        maxb=-1d3
        minb=1d30
        do is=1,ssweep%out%sfebe(it)%spw%out%n_spw
            if (ssweep%out%sfebe(it)%spw%out%win(is)%restmax.gt.maxb)  maxb=ssweep%out%sfebe(it)%spw%out%win(is)%restmax
            if (ssweep%out%sfebe(it)%spw%out%win(is)%restmin.lt.minb)  minb=ssweep%out%sfebe(it)%spw%out%win(is)%restmin
        enddo
        if (maxb.gt.maxs)  maxs=maxb
        if (minb.lt.mins)  mins=minb
        enddo
        fmin=min(ssweep%in%restlim(1),mins)
        fmax=max(ssweep%in%restlim(2),maxs)
    else
        call astro_message(seve%e,rname,'Problem with Plot Mode')
        error=.true.
        return
    endif
    do i=1,cplot%nbox
        ! Physical description of the box
        cplot%box(i)%phys%sx = px-4.5d0
        cplot%box(i)%phys%sy = boxsize
        cplot%box(i)%phys%xmin = 3d0
        cplot%box(i)%phys%xmax = cplot%box(i)%phys%xmin+cplot%box(i)%phys%sx
        cplot%box(i)%phys%ymax = py-yoff-(i-1)*(boxsize+yoff)
        cplot%box(i)%phys%ymin = cplot%box(i)%phys%ymax-boxsize
        write (comm,'(a,i0)') 'CREATE DIRECTORY BOX',i
        call gr_execl(comm)
        write (comm,'(a,i0)') 'CHANGE DIRECTORY BOX',i
        call gr_execl(comm)
        cplot%box(i)%iband = iband
        !define the box limits in all freq frames
        call rec_def_fbox(fmin,fmax,'REST',cplot%box(i),ssweep%out%srdesc, &
                        ssweep%out%srsou,ssweep%out%sfebe(i)%rectune%flo1,error)
        if (error) return
        !locate the box
        call rec_locate_fbox(cplot%box(i)%phys,error)
        if (error) return
        if (i.eq.1) then
        call rec_draw_source(rname,ssweep%out%srsou,error)
        if (error) return
        endif
        sbrect%xmin = cplot%box(i)%rest%xmin
        sbrect%xmax = cplot%box(i)%rest%xmax
        sbrect%ymin = cplot%box(i)%rest%ymin
        sbrect%ymax = cplot%box(i)%rest%ymax
        sbrect%col = aavailcol
        call rec_draw_frect(sbrect,cplot%box(i)%rest,error)
        if (error) return
        !ID sidebands
        if (ssweep%out%srdesc%n_sbands.eq.2) then
        sb_code(1) = usb_code !usb first
        sb_code(2) = lsb_code !lsb
        else if (ssweep%out%srdesc%n_sbands.eq.1) then
        sb_code(1) = ssweep%out%sfebe(i)%rectune%sb_code ! tuned side band for single sideband
        else
        call astro_message(seve%e,rname,'We should have 1 or 2 sidebands')
        error = .true.
        return
        endif
        do j=1,ssweep%out%srdesc%n_sbands
        call if1torf(ssweep%out%sfebe(i)%rectune%flo1,ssweep%out%srdesc%iflim(2),sb_code(j),frf,error)
        if (error) return
        call rftorest(ssweep%out%srsou%dopshift,frf,sbrect%xmax,error)
        if (error) return
        call if1torf(ssweep%out%sfebe(i)%rectune%flo1,ssweep%out%srdesc%iflim(1),sb_code(j),frf,error)
        if (error) return
        call rftorest(ssweep%out%srsou%dopshift,frf,sbrect%xmin,error)
        if (error) return
        sbrect%ymin = cplot%box(i)%rest%ymin
        sbrect%ymax = cplot%box(i)%rest%ymax
        sbrect%col = atunedcol
        call rec_draw_frect(sbrect,cplot%box(i)%rest,error)
        if (error) return
        enddo
        !ID areas outside call for proposal
        sbrect%ymin = cplot%box(i)%rest%ymin
        sbrect%ymax = cplot%box(i)%rest%ymax
        sbrect%col = adefcol
        sbrect%hang = hatch_info
        sbrect%xmin = ssweep%out%srdesc%restlim(1,iband)
        sbrect%xmax = ssweep%out%srdesc%restcall(1,iband)
        call rec_draw_hrect(sbrect,cplot%box(i)%rest,error)
        if (error) return
        sbrect%xmax = ssweep%out%srdesc%restlim(2,iband)
        sbrect%xmin = ssweep%out%srdesc%restcall(2,iband)
        call rec_draw_hrect(sbrect,cplot%box(i)%rest,error)
        if (error) return
        ! Draw the SPW
        call noema_sweep_draw_spw(ssweep%out%sfebe(i)%spw%out,ssweep%out%sfebe(i)%pfx,cplot,i,cata,drawaxis,error)
        if (error) return
        !Draw the box
        call rec_draw_fbox(cplot,i,drawaxis,error)
        if (error) return
        ! Show the edges of the coverage
        if (ssweep%in%in_range.and.plotmode.eq.'RECEIVER') then
        do ip=1,2
            line%xmax = ssweep%in%restlim(ip)
            line%xmin = ((ssweep%in%restlim(1)+ssweep%in%restlim(2))/2)
            line%ymax = cplot%box(i)%rest%ymin+(cplot%box(i)%rest%ymax-cplot%box(i)%rest%ymin)*0.5
            line%ymin = line%ymax
            line%col   = asweepfcol
            line%dash = 1
            call rec_draw_arrow(line,cplot%box(i)%rest,error)
            if (error) return
        enddo
        endif
        ! show tuning line
        call rec_draw_linetune(ssweep%out%sfebe(i)%rectune,cplot%box(i)%rest,error)
        if (error) return
        if (ssweep%out%srsou%z.ne.0) then
        call gr_pen(colour=azcol,error=error)
        if (error) return
        else
        call gr_pen(colour=adefcol,error=error)
        if (error) return
        endif
        write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT -1.5 0 "',trim(ssweep%out%srdesc%bandname(iband)),'" 5 90 /CHARACTER 4'
        call gr_exec1(comm)
        ! Draw tuning name
        xt=0d0
        yt=2d0
        call rec_make_title(ssweep%out%sfebe(i)%rectune,mess,error)
        if (error) return
        if (ssweep%out%sfebe(i)%rectune%outlo) then
        call gr_pen(colour=aconflictcol,error=error)
        if (error) return
        write (mess2,'(a,1x,a)') trim(mess),'(out of LO range)'
        call gr_exec1(comm)
        else
        mess2=trim(mess)
        call gr_pen(colour=adefcol,error=error)
        if (error) return
        endif
        write (comm,'(a,1x,f0.3,1x,f0.3,1x,a,1x,a,1x,a)') &
            'DRAW TEXT',xt,yt,'"',trim(mess2),'" 6 0 /CHARACTER 7'
        call gr_exec1(comm)
        call gr_pen(colour=adefcol,error=error)
        if (error) return
        ! plot molecular lines
        call gr_exec1(molchar)
        call rec_draw_molecules(cata,cplot%box(i)%rest,error)
        if (error) return
        ! Draw resolution caption
        if (i.eq.ssweep%in%n_tunings) then
        call gr_exec1(defchar)
        xt=0
        yt=-2*cplot%desc%defchar
        write (mess,'(a,1x,f0.1,1x,a)') 'df =',ssweep%out%sfebe(i)%spw%out%win(1)%resol,'kHz'
        call gr_pen(colour=adefcol,error=error)
        if (error) return
        write (comm,'(a,1x,f0.3,1x,f0.3,1x,a,a,a)') 'DRAW TEXT', &
                xt,yt,'"',trim(mess),'" 4 0 /BOX 3'
        call gr_exec1(comm)
        call gr_pen(colour=adefcol,error=error)
        if (error) return
        ! draw the marker
        lmess=len(trim(mess))
        call gtg_charlen(lmess,trim(mess),cplot%desc%defchar,smess,0)
        xt=xt-smess-cplot%desc%defchar
        call noema_spw_getcol(rname,ssweep%out%sfebe(i)%spw%out%win(1),ssweep%out%sfebe(i)%pfx &
                                ,icol_fill,mark%col,error)
        mark%nside=4
        mark%style=3
        mark%s=cplot%desc%smallchar
        mark%x=xt
        mark%y=-2*cplot%desc%defchar
        mark%ref='BOX'
        mark%iref=3
        call rec_draw_mark(mark,error)
        if (error) return
        mark%col=adefcol
        mark%style=0
        call rec_draw_mark(mark,error)
        endif
        call gr_exec1(defchar)
        call gr_execl('CHANGE DIRECTORY')
        cplot%desc%plotmode = pm_tunedbands
    enddo
    !
  end subroutine noema_specsweep_plot
  !
  subroutine noema_sweep_draw_spw(spwout,pfx,cplot,ib,molecules,drawaxis,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! Draw coverage of spectral units in global view (for spectral sweep)
    !-----------------------------------------------------------------------
    type(spw_output_t), intent(in) :: spwout
    type(pfx_t), intent(in) :: pfx
    type(current_boxes_t), intent(inout) :: cplot
    integer(kind=4), intent(in) :: ib
    type(plot_molecules_t), intent(in) :: molecules
    type(frequency_axis_t), intent(in) :: drawaxis
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='PLOT'
    integer(kind=4) :: ispw
    real(kind=8)  :: srect,sbox,soff,spos,yh,yv
    type(draw_rect_t) :: sprec
    character(len=256) :: molchar,defchar
    !
    write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%defchar
    write (molchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%molchar
    do ispw=1,spwout%n_spw
        if ((spwout%win(ispw)%restmin.lt.cplot%box(ib)%rest%xmin) &
        .or. (spwout%win(ispw)%restmax.gt.cplot%box(ib)%rest%xmax)) cycle
        ! Parameters for the plot
        sbox=cplot%box(ib)%rest%ymax-cplot%box(ib)%rest%ymin
        soff=3*sbox/50d0
        spos=sbox
        srect=(spos-4d0*soff)/2d0
        ! get color according to SPW mode/resolution
        call noema_spw_getcol(rname,spwout%win(ispw),pfx,icol_fill,sprec%col,error)
        if (error) return
        spos=sbox
        soff=sbox/10d0
        srect=(spos-4d0*soff)/2d0
        sprec%xmin=spwout%win(ispw)%restmin
        sprec%xmax=spwout%win(ispw)%restmax
        if (spwout%win(ispw)%pol_code.eq.hpol_code) then
        sprec%ymax=spos-soff
        sprec%ymin=sprec%ymax-srect
        yh=(sprec%ymax+sprec%ymin)/2d0
        else if (spwout%win(ispw)%pol_code.eq.vpol_code) then
        sprec%ymin=cplot%box(ib)%rest%ymin+soff
        sprec%ymax=sprec%ymin+srect
        yv=(sprec%ymax+sprec%ymin)/2d0
        else
        call astro_message(seve%e,rname,'Problem with polarizations')
        error=.true.
        return
        endif
        call rec_draw_frect(sprec,cplot%box(ib)%rest,error)
        if (error) return
        call noema_spw_getcol(rname,spwout%win(ispw),pfx,icol_border,sprec%col,error)
        if (error) return
        sprec%dash=1
        call rec_draw_rect(sprec,cplot%box(ib)%rest,error)
        if (error) return
    enddo ! ispw
    ! Draw molecules
    call gr_exec1(molchar)
    call rec_draw_molecules(molecules,cplot%box(ib)%rest,error)
    if (error) return
    call gr_exec1(defchar)
    call rec_draw_fbox(cplot,ib,drawaxis,error)
    if (error) return
    call gr_pen(colour=adefcol,error=error)
    if (error) return
    !
  end subroutine noema_sweep_draw_spw
  !
end module astro_specsweep_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine load_2d(set,line,error,user_function)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>load_2d
  use class_types
  use class_index
  use class_data
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  !   LOAD /NOCHECK
  ! Convert the entire index in a single 2-D data set for further plot
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set            !
  character(len=*),    intent(in)  :: line           ! Command Line
  logical,             intent(out) :: error          ! Return error code
  logical,             external    :: user_function  ! handling of user defined sections, intent(in)
  ! Local
  character(len=*), parameter :: rname='LOAD'
  type(observation) :: obs
  type(header) :: ref_head
  integer(kind=index_length) :: dim(4)
  integer(kind=entry_length) :: iobs,nobs,ksave
  integer(kind=4) :: iline,nchan
  character(len=message_length) :: mess
  character(len=12) :: stele  ! Telescope name for the index
  logical :: stele_c(12)  ! Characters to be compared
  !
  if (set%kind.ne.kind_spec) then
    call class_message(seve%e,rname,'Unsupported kind of data')
    error = .true.
    return
  endif
  !
  ! Initialization
  error = .false.
  call init_obs(obs)
  call init_obs(p)
  !
  ! Select what will be checked according to user input
  call consistency_check_selection(set,line,1,cx%cons,error)
  if (error) return  ! Ignore cx%cons%prob since we ignore cx%cons%off%prob
  cx%cons%off%check = .false.
  !
  ! Sanity check
  if (cx%next.le.1) then
     call class_message(seve%f,rname,'Index is empty')
     error = .true.
     return
  endif
  !
  ! Read first index spectrum to set its header as reference
  ksave = knext
  call get_first(set,obs,user_function,error)
  knext = ksave
  if (error) return
  ref_head = obs%head
  !
  ! Set checking tolerances
  call consistency_tole(ref_head,cx%cons)
  !
  ! Give user feedback on what will be done
  call consistency_print(set,ref_head,cx%cons)
  !
  ! Clean associated SIC variable
  call sic_delvariable('P',.false.,error)
  error = .false.
  !
  ! Allocation of P arrays
  nobs = cx%next-1
  nchan = ref_head%spe%nchan
  call reallocate_pq(nchan,nobs,error)
  if (error) return
  write(mess,*) 'Found ',nobs,' spectra of ',nchan,' channels'
  call class_message(seve%i,rname,mess)
  !
  ! Initialize header and x arrays
  p%head = ref_head
  call abscissa(set,p,error)
  if (error) return
  p%head%des%ndump = nobs
  p%head%xnum = -1 ! Is that correct ??? JP
  !
  ! Initialize telescope variables
  stele = ref_head%gen%teles
  stele_c(:) = .true.  ! At start, compare the 12 characters
  !
  ! Initialization of p
  p%data2 = ref_head%spe%bad
  !
  ! Loop on observation
  iline = 0
  do iobs = 1,nobs
     if (sic_ctrlc()) exit
     ! Read into buffer header section from file
     call robs(obs,cx%ind(iobs),error)
     if (error) cycle
     ! Read only interesting sections
     call rgen(set,obs,error)  ! General section
     if (error) cycle
     call rpos(set,obs,error)  ! Position section
     if (error) cycle
     call rspec(set,obs,error) ! Spectroscopic section
     if (error) cycle
     if (obs%head%presec(class_sec_cal_id)) then
       call rcal(set,obs,error)
       if (error) cycle
     endif
     if (obs%head%presec(class_sec_swi_id)) then
       call rswi(set,obs,error)  ! Switching section
       if (error) cycle
     endif
     ! Consistency checks
     if (cx%cons%check) then
        call spectrum_consistency_check(set,ref_head,obs%head,cx%cons)
        if (cx%cons%prob)  exit
     endif
     ! Telescope
     call sumlin_header_telescope(obs%head%gen%teles,stele_c,stele)
     ! Get data
     if (obs%head%spe%nchan.ne.nchan) then
       ! This can happen if user has disabled SPECTROSCOPY check. This leads
       ! to segfaults in rdata() and p%data2 assignments.
       write (mess,'(A,I0,A,I0,A,I0,A)')  &
         'Obs #',obs%head%gen%num,' has an unexpected number of channels (',  &
         obs%head%spe%nchan,' instead of ',nchan,')'
       call class_message(seve%e,rname,mess)
       if (.not.cx%cons%spe%check) then
         call class_message(seve%e,rname,  &
           'Check of spectroscopy sections is disabled but they differ too much')
       endif
       error = .true.
       goto 100
     endif
     call rdata(set,obs,obs%head%spe%nchan,obs%data1,error)
     if (error) cycle
     iline = iline+1
     p%data2(:,iline) = obs%data1
  enddo
  !
  p%head%gen%teles = stele
  !
  ! Compute limits
  call newlim(set,p,error)
  if (error) return
  !
  ! Define associated SIC structure
  dim(1) = nchan
  dim(2) = nobs
  if (.not.sic_varexist('p')) then
     call sic_defstructure('p%',.true.,error)
     if (error) return
  endif
  call sic_delvariable('p%x',.false.,error)
  call sic_delvariable('p%y',.false.,error)
  error = .false.
  call sic_def_dble('p%x',p%datax,1,dim,.true.,error)
  call sic_def_real('p%y',p%data2,2,dim,.false.,error)
  error = .false.
  !
  ! Feedback
  call index_consistency_analysis(set,cx%cons,rname)
  if (cx%cons%prob) then
     error = .true.
  endif
  !
100 continue
  !
  ! Cleaning
  call free_obs(obs)
end subroutine load_2d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_putdata
  use cubetools_parameters
  use cubetools_structure
  use cubetopology_spapos_types
  use cubetopology_spechannel_types
  use cubeedit_messaging
  use cubeedit_entry
  use cubeedit_which_data
  !
  public :: putdata_comm_t,putdata_user_t
  private
  !
  integer(kind=4), parameter :: izero=1
  integer(kind=4), parameter :: ifirst=2
  integer(kind=4), parameter :: ilast=3
  integer(kind=4), parameter :: inext=4
  integer(kind=4), parameter :: iprevious=5
  integer(kind=4), parameter :: iafter=6
  integer(kind=4), parameter :: icurrent=7
  integer(kind=4), parameter :: nwhich = icurrent
  !
  character(len=*), parameter :: options(nwhich) = &
       ['ZERO     ','FIRST    ','LAST     ','NEXT     ','PREVIOUS ','AFTERLAST','CURRENT  ']
  !
  logical, parameter :: access_is_fixed  = .true.
  !
  type :: putdata_comm_t
     type(entry_opt_t)       :: entry
     type(spapos_comm_t)     :: pixel
     type(spechannel_opt_t)  :: channel
     type(which_comm_t)      :: which(1:nwhich)
     type(option_t), pointer :: from
   contains
     procedure, public :: register => cubeedit_putdata_register
     procedure, public :: parse    => cubeedit_putdata_parse
     procedure, public :: main     => cubeedit_putdata_main
  end type putdata_comm_t
  !
  type putdata_user_t
     type(which_user_t)      :: which(1:nwhich)
     type(entry_user_t)      :: entry     
     type(spapos_user_t)     :: pixel
     type(spechannel_user_t) :: channel
     logical                 :: dofrom
     character(len=varn_l)   :: varname
     logical                 :: do
  end type putdata_user_t
  !
contains
  !
  subroutine cubeedit_putdata_register(putdata,error)
    !----------------------------------------------------------------------
    ! Register options related to data edition
    !----------------------------------------------------------------------
    class(putdata_comm_t), intent(inout) :: putdata
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iwhich
    type(standard_arg_t) :: stdarg
    logical, parameter :: access_is_fixed = .true.
    logical, parameter :: active = .true.
    character(len=*), parameter :: rname='PUTDATA>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    do iwhich=1, nwhich
       call putdata%which(iwhich)%register(options(iwhich), &
            'Put the '//trim(options(iwhich))//' entry into the cube',&
            access_is_fixed,active,error)
       if (error) return
    enddo
    !
    call putdata%entry%register(&
         'Define the entry to be put in the cube',access_is_fixed,error)
    if (error) return
    ! 
    call putdata%pixel%register('PIXEL',&
         'Define the position of the pixel to be put',&
         error)
    if (error) return
    !
    call putdata%channel%register('CHANNEL',&
         'Define the velocity of the channel to be put',&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'FROM','varname',&
         'Define from which variable we fetch data',&
         strg_emp,&
         putdata%from,error)
    if (error) return
    call stdarg%register(&
         'varname',&
         'Variable name containing data to be put',&
         strg_emp,&
         code_arg_mandatory,error)
    if (error) return
  end subroutine cubeedit_putdata_register
  !
  subroutine cubeedit_putdata_parse(putdata,line,user,error)
    !-------------------------------------------------------------------
    ! Parse routine for data part of command PUT
    !-------------------------------------------------------------------
    class(putdata_comm_t), intent(in)    :: putdata
    character(len=*),      intent(in)    :: line
    type(putdata_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: nopt,iwhich
    character(len=mess_l) :: optmess
    character(len=*), parameter :: rname='PUTDATA>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    nopt = 0
    do iwhich=1, nwhich
       call putdata%which(iwhich)%parse(line,user%which(iwhich),error)
       if (error) return
       if (user%which(iwhich)%do) nopt = nopt+1 
    enddo
    ! /ENTRY
    call putdata%entry%parse(line,user%entry,error)
    if (error) return
    if (user%entry%do)   nopt = nopt+1
    ! /PIXEL
    call putdata%pixel%parse(line,user%pixel,error)
    if (error) return
    if (user%pixel%present)   nopt = nopt+1
    ! /CHANNEL
    call putdata%channel%parse(line,user%channel,error)
    if (error) return
    if (user%channel%do) nopt = nopt+1
    !
    ! FROM
    call putdata%from%present(line,user%dofrom,error)
    if (error) return
    !
    optmess = 'Options'
    do iwhich=1,nwhich
       optmess = trim(optmess)//' /'//trim(options(iwhich))//','
    enddo
    optmess = trim(optmess)//' /ENTRY, /CHANNEL and /PIXEL'
    
    user%do = .false.
    if (nopt.eq.1) then
       if (user%dofrom) then
          call cubetools_getarg(line,putdata%from,1,user%varname,mandatory,error)
          if (error) return
          user%do = .true.
       else
          call cubeedit_message(seve%e,rname,trim(optmess)//' Require option /FROM')
          error = .true.
          return
       endif
    else if (nopt.gt.1) then ! Problem, Conflicting options
       call cubeedit_message(seve%e,rname,trim(optmess)//' conflict with each other')
       error = .true.
       return
    else ! Nothing to be done
       if (user%dofrom) call cubeedit_message(seve%w,rname,'Option &
            &/FROM only applies to '//trim(optmess))
    endif
  end subroutine cubeedit_putdata_parse
  !
  subroutine cubeedit_putdata_main(putdata,user,cube,ie,error)
    use cube_types
    use cubeadm_get
    !-------------------------------------------------------------------
    ! Main routine for data part of command PUT
    !-------------------------------------------------------------------
    class(putdata_comm_t), intent(in)    :: putdata
    type(putdata_user_t),  intent(in)    :: user
    type(cube_t), pointer, intent(inout) :: cube
    integer(kind=entr_k),  intent(inout) :: ie
    logical,               intent(inout) :: error
    !
    logical :: doima,put
    integer(kind=4) :: iwhich
    type(spapos_prog_t) :: pixel
    type(spechannel_prog_t) :: channel
    character(len=*), parameter :: rname='PUTDATA>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (user%do) then
       doima = cube%order().eq.code_access_imaset
       if (user%pixel%present.and.doima) then
          call cubeedit_message(seve%e,rname,'Cannot put a pixel in a cube that is accessed by images')
          error = .true.
          return
       endif
       if (user%channel%do.and..not.doima) then
          call cubeedit_message(seve%e,rname,'Cannot put a channel in a cube that is accessed by spectra')
          error = .true.
          return
       endif
       !
       put = .true.
       if (user%pixel%present) then
          call user%pixel%toprog(cube,pixel,error)
          if (error) return
          ie = pixel%nearest_entry()
       else if (user%channel%do) then
          call user%channel%toprog(putdata%channel,cube,channel,error)
          if (error) return
          ie = channel%ic
       else if (user%entry%do) then
          ie = user%entry%ientry
       else
          do iwhich=1,nwhich
             if (.not.user%which(iwhich)%do)  cycle
             select case (iwhich)
             case (izero)
                put = .false.
                ie = 0
             case (ifirst)
                ie = 1
             case (ilast)
                ie = cube%nentry()
             case (inext)
                ie = ie+1
             case (iprevious)
                ie = ie-1
             case (iafter)
                put = .false.
                ie = cube%nentry()+1
             case(icurrent)
                ! No change to ie
             end select
          enddo
       endif
       if (ie.lt.0) then
          call cubeedit_message(seve%e,rname,'Trying to put data before the start of the cube')
          error = .true.
          return
       elseif (ie.gt.cube%nentry()) then
          call cubeedit_message(seve%e,rname,'Trying to put data beyond number of entries')
          error = .true.
          return
       endif
       !
       if (put) then
          if (doima) then
             if (cube%iscplx()) then
                call cubeedit_putdata_image_cplx(cube,user%varname,ie,error)
                if (error) return
             else
                call cubeedit_putdata_image_real(cube,user%varname,ie,error)
                if (error) return
             endif
          else
             if (cube%iscplx()) then
                call cubeedit_message(seve%e,rname,'Putting complex spectra is unsupported')
                error = .true.
                return
!!$                call cubeedit_putdata_spectrum_cplx(cube,user%varname,ie,error)
!!$                if (error) return
             else
                call cubeedit_putdata_spectrum_real(cube,user%varname,ie,error)
                if (error) return
             endif
          endif
       else
          ! Nothing to be put
       endif
    else
       ! Nothing to be done
    endif
  end subroutine cubeedit_putdata_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_putdata_image_real(cube,varname,ie,error)
    use cube_types
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_uservar
    use cubeadm_ioloop
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: cube
    character(len=*),      intent(in)    :: varname
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    type(image_t) :: ima
    type(uservar_t) :: var
    integer(kind=4) :: ndim
    integer(kind=entr_k), allocatable :: dims(:)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PUTDATA>IMAGE>REAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(varname,var,error)
    if (error) return
    call var%get_dims(ndim,dims,error)
    if (error) return
    if (ndim.ne.2) then
       write(mess,'(a,i0,a)') 'Expected a 2D array got a ',ndim,'D array'
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    call cubetools_header_get_array_shape(cube%head,n,error)
    if (error) return
    if (dims(1).ne.n%l.or.dims(2).ne.n%m) then
       write(mess,'(4(a,i0))') 'Expected a ',n%l,'x',n%m,' array got ',dims(1),'x',dims(2)
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    call ima%allocate('ima from var',cube,error)
    if (error) return
    call var%get(ima%val,error)
    if (error) return
    call cubeadm_io_iterate(ie,ie,cube,error)
    if (error) return
    call ima%put(ie,error)
    if (error) return
  end subroutine cubeedit_putdata_image_real
  !
  subroutine cubeedit_putdata_image_cplx(cube,varname,ie,error)
    use cube_types
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_uservar
    use cubeadm_ioloop
    use cubeadm_taskloop
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: cube
    character(len=*),      intent(in)    :: varname
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    type(visi_t) :: ima
    type(uservar_t) :: var
    integer(kind=4) :: ndim
    integer(kind=entr_k), allocatable :: dims(:)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PUTDATA>IMAGE>CPLX'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(varname,var,error)
    if (error) return
    call var%get_dims(ndim,dims,error)
    if (error) return
    if (ndim.ne.2) then
       write(mess,'(a,i0,a)') 'Expected a 2D array got a ',ndim,'D array'
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    call cubetools_header_get_array_shape(cube%head,n,error)
    if (error) return
    if (dims(1).ne.n%l.or.dims(2).ne.n%m) then
       write(mess,'(4(a,i0))') 'Expected a ',n%l,'x',n%m,' array got ',dims(1),'x',dims(2)
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    call ima%allocate('ima from var',cube,error)
    if (error) return
    call var%get(ima%val,error)
    if (error) return
    call cubeadm_io_iterate(ie,ie,cube,error)
    if (error) return
    call ima%put(ie,error)
    if (error) return
  end subroutine cubeedit_putdata_image_cplx
  !
  subroutine cubeedit_putdata_spectrum_real(cube,varname,ie,error)
    use cube_types
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_uservar
    use cubeadm_ioloop
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: cube
    character(len=*),      intent(in)    :: varname
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    type(spectrum_t) :: spe
    type(uservar_t) :: var
    integer(kind=4) :: ndim
    integer(kind=entr_k), allocatable :: dims(:)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PUTDATA>SPECTRUM>REAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(varname,var,error)
    if (error) return
    call var%get_dims(ndim,dims,error)
    if (error) return
    if (ndim.ne.1) then
       write(mess,'(a,i0,a)') 'Expected a 1D array got a ',ndim,'D array'
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    call cubetools_header_get_array_shape(cube%head,n,error)
    if (error) return
    if (dims(1).ne.n%c) then
       write(mess,'(2(a,i0))') 'Expected an array of size ',n%c,' got ',dims(1)
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    call spe%allocate('spe from var',cube,error)
    if (error) return
    call var%get(spe%y%val,error)
    if (error) return
    call cubeadm_io_iterate(ie,ie,cube,error)
    if (error) return
    call spe%put(ie,error)
    if (error) return
  end subroutine cubeedit_putdata_spectrum_real
  !
!!$  subroutine cubeedit_putdata_spectrum_cplx(cube,varname,ie,error)
!!$    use cube_types
!!$    use cubetools_shape_types
!!$    use cubetools_header_methods
!!$    use cubetools_uservar
!!$    use cubeadm_ioloop
!!$    use cubemain_spectrum_cplx
!!$    !----------------------------------------------------------------------
!!$    !
!!$    !----------------------------------------------------------------------
!!$    type(cube_t), pointer, intent(inout) :: cube
!!$    character(len=*),      intent(in)    :: varname
!!$    integer(kind=entr_k),  intent(in)    :: ie
!!$    logical,               intent(inout) :: error
!!$    !
!!$    type(shape_t) :: n
!!$    type(spectrum_cplx_t) :: spec
!!$    type(uservar_t) :: var
!!$    integer(kind=4) :: ndim
!!$    integer(kind=entr_k), allocatable :: dims(:)
!!$    character(len=mess_l) :: mess
!!$    character(len=*), parameter :: rname='PUTDATA>SPECTRUM>CPLX'
!!$    !
!!$    call cubeedit_message(edseve%trace,rname,'Welcome')
!!$    !
!!$    call cubetools_userspace_get(varname,var,error)
!!$    if (error) return
!!$    call var%get_dims(ndim,dims,error)
!!$    if (error) return
!!$    if (ndim.ne.1) then
!!$       write(mess,'(a,i0,a)') 'Expected a 1D array got a ',ndim,'D array'
!!$       call cubeedit_message(seve%e,rname,mess)
!!$       error = .true.
!!$       return
!!$    endif
!!$    !
!!$    call cubetools_header_get_array_shape(cube%head,n,error)
!!$    if (error) return
!!$    if (dims(1).ne.nc) then
!!$       write(mess,'(2(a,i0))') 'Expected an array of size ',nc,' got ',dims(1)
!!$       call cubeedit_message(seve%e,rname,mess)
!!$       error = .true.
!!$       return
!!$    endif
!!$    !
!!$    call spec%reallocate('fromvar',nc,error)
!!$    if (error) return
!!$    call var%get(spec%t,error)
!!$    if (error) return
!!$    call cubeadm_io_iterate(ie,ie,cube,error)
!!$    if (error) return
!!$    call spec%put(cube,ie,error)
!!$    if (error) return
!!$  end subroutine cubeedit_putdata_spectrum_cplx
end module cubeedit_putdata
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
!----------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoFocus">
!   <VERSION>
!                Id: modulePakoFocus.f90,v 1.2.3 2014-12-15 Hans Ungerechts
!                Id: modulePakoFocus.f90,v 1.2.3 2014-12-04 Hans Ungerechts
!                Id: modulePakoFocus.f90,v 1.2.3 2014-10-27 Hans Ungerechts
!                Id: modulePakoFocus.f90,v 1.2.3 2014-09-24 Hans Ungerechts
!                Id: modulePakoFocus.f90,v 1.2.3 2014-02-03 Hans Ungerechts
!                                          1.2.1 2012-08-16 Hans Ungerechts 
!                based on
!                Id: modulePakoFocus.f90,v 1.1.0 2009-03-25 Hans Ungerechts
!   </VERSION>
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>
!                Calibrate
!                Focus
!                OnOff
!                OtfMap
!                Pointing
!                Tip
!                Track
!                VLBI
!   </SIBLINGS>        
!
!   Pako module for command: FOCUS
!
! </DOCUMENTATION> <!-- name="modulePakoFocus" -->
!
!----------------------------------------------------------------------
!
Module modulePakoFocus
  !
  Use modulePakoTypes
  Use modulePakoMessages
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  Use modulePakoDIYlist
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  Public :: Focus, displayFocus, saveFocus, startFocus
  !     
  ! *** Variables for Focus ***
  Include 'inc/variables/variablesFocus.inc'
  !
  Real    :: swWobblerAmplitude       = 0.0
  Real    :: swWobblerShiftAzimuth    = 0.0       !   Shift in Azimuth when Wobbler Switching
  Real    :: swWobblerShiftElevation  = 0.0       !   Shift in Elevation when Wobbler Switching
  !
!!!   
!!!   
Contains
!!!
!!!
  Subroutine FOCUS(programName,line,command, ERROR)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical :: isConnected   = .False.
    !
    Character (len=lenCh) ::  bolometerName
    !
    ! *** special working variables:   ***
    !
    !     TBD: the following shall be replaced by a SR reading from XML:
    Include 'inc/ranges/rangesFocus.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Focus, v 1.2.3 2014-09-24 ---> SR: Focus ")                 ! trace execution
    !
    ! *** initialize:   ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    Call checkNofParameters(command,                                             &
         &     0, 1,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    ! *** read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/parameters/parametersLengthFocus.inc'
       Include 'inc/options/readOptionsFocus.inc'
    End If
    !
    ! *** set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          Include 'inc/variables/setDefaults.inc'
       Endif
    Endif
    !
    ! *** Read Parameters, Options (again, after defaults!)   ***
    ! *** and check for validity and ranges                   ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/parameters/parametersLengthFocus.inc'
       Include 'inc/options/readOptionsFocus.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.ERROR) Then
       !
       errorInconsistent = .False.
       !
       If (vars(iIn)%tSubscan .Lt. 5*GV%tRecord) Then
          If (vars(iIn)%tSubscan .Lt. 3*GV%tRecord) Then
             errorInconsistent = .True.
             Write (messageText,*)    "must be at least 3 times "                &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityE,severityE,                               &
                  &           command(1:l)//"/"//"tSubscan",messageText)         !
          Else
             Write (messageText,*)    "should be at least 5 times "              &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityW,severityW,                               &
                  &           command(1:l)//"/"//"tSubscan",messageText)         !
          End If
       End If
       !
       If (GV%switchingMode.Eq.swMode%Freq) Then
          errorInconsistent = .True.
          GV%notReadyFocus  = .True.
          Write (messageText,*)  "will not work with switching mode ",           &
               &                  swModePako%Freq                                !
          Call PakoMessage(priorityE,severityE,command,messageText)
       End If
       !
       If (.Not. errorInconsistent) Then
          vars(iTemp) = vars(iIn)
       End If
       !
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)  = vars(iTemp)
    End If
    !
    ! *** display values ***
    If (.Not.ERROR) Then
       Call displayFocus
    End If
    !
    ! *** set "selected" observing mode, analyze & plot ***
    If (.Not.error) Then
       GV%observingMode     = OM%Focus
       GV%observingModePako = OMpako%Focus
       GV%omSystemName      = GPnone
       GV%notReadySecondaryRafterOM = .False.
       !D       Write (6,*) '      GV%notReadySecondaryRafterOM: ',                    &
       !D            &             GV%notReadySecondaryRafterOM
       GV%notReadySWafterOM = .False.
       GV%notReadyFocus     = .False.
       focusCommand         = line(1:lenc(line))
       Call analyzeFocus (errorA)
       Call plotFocus (errorP)
       !
       ! TBD:
!!$       Call listDIYlist (error)
    End If
    !
    Return
  End Subroutine FOCUS
!!!
!!!
  Subroutine displayFocus
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Include 'inc/display/commandDisplayFocus.inc'
    !
  End Subroutine displayFocus
!!!
!!!
  Subroutine analyzeFocus (errorA)
    !
    ! <DOCUMENTATION name="analyzeFocus">
    !
    ! The sequence of focus subscans is determined by 
    ! lengthFocus /nSubscans /otfFocus
    !
    !  lengthFocus     ! total length [mm] of the focus scan 
    !  /nSubscans      ! number of focus subscans
    !  /otfFocus       ! not yet implemented
    !
    !  focus subscan 1 is at offset  0.0
    !  focus subscan 2 is at offset  lengthFocus/2
    !  in case /nSubscans 3:
    !  focus subscan 3 is at offset -lengthFocus/2
    !  in case /nSubscans >3:
    !  focus subscan 3 is at offset  lengthFocus/2
    !  focus subscan 4 is at offset -lengthFocus/2
    !  focus subscan 5 is at offset -lengthFocus/2
    !  focus subscan 6 is at offset  0.0
    !  (etc.)
    !
    ! </DOCUMENTATION> <!-- name="analyzeFocus" -->
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer              :: nScan 
    Character (len=12)   :: aUnit, sUnit
    Integer              :: iSS           = 0     ! counts subcans/segment
    !
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module Focus, v 1.2.3 2014-09-24  --> SR: analyzeFocus ")          !                      
    !
    errorA = .False.
    !
    ! TBD:  proper scan numbers
    nScan     = 1111
    aUnit     = GV%angleUnitC
    sUnit     = GV%speedUnitC
    !
    swWobblerAmplitude       =  0.0
    swWobblerShiftAzimuth    =  0.0
    swWobblerShiftElevation  =  0.0
    iSS  = 0
    !
    If (GV%switchingMode .Eq. swMode%wobb) Then   
       swWobblerAmplitude = 0.5*Abs(GV%wOffset(2)-GV%wOffset(1))
       swWobblerShiftAzimuth   =                                                 &
            &          -swWobblerAmplitude*Cos(GV%secondaryRotation/180.0*Pi)    !
       swWobblerShiftElevation =                                                 &
            &           swWobblerAmplitude*Sin(GV%secondaryRotation/180.0*Pi)    !
       If (Abs(swWobblerShiftAzimuth)  .Lt.0.1e-11) swWobblerShiftAzimuth   = 0.0
       If (Abs(swWobblerShiftElevation).Lt.0.1e-11) swWobblerShiftElevation = 0.0
       Write (messageText,*)                                                     &
            &      "SWWOBBLER implies: subscans will be shifted by: "            !
       Call pakoMessage(priorityI,severityI,'FOCUS',messageText)
       Write (messageText,*)                                                     &
            &      swWobblerShiftAzimuth, " [arc sec] in azimuth"                !
       Call pakoMessage(priorityI,severityI,'FOCUS',messageText)
       Write (messageText,*)                                                     &
            &      swWobblerShiftElevation, " [arc sec] in elevation"            !
       Call pakoMessage(priorityI,severityI,'FOCUS',messageText)
    End If
    !
    ! TBD: calibration subscans
    !
    ! ***
    !
    If (vars(iValue)%doTune) Then
       iSS = iSS+1                                                               !  !!  tune subscan
       segList(iSS)            =  segDefault  
       segList(iSS)%newSubscan =  .True.
       segList(iSS)%scanNumber =  nScan
       segList(iSS)%ssNumber   =  iSS
       segList(iSS)%segNumber  =  1
       segList(iSS)%ssType     =  ss%tune
       segList(iSS)%segType    =  seg%track
       segList(iSS)%angleUnit  =  aUnit
       segList(iSS)%speedUnit  =  sUnit
       segList(iSS)%flagOn     =  .True.
       segList(iSS)%flagRef    =  .False.
       !
       segList(iSS)%flagDropin =  .False.
       segList(iSS)%flagTune   =  vars(iIn)%doTune
       !
       segList(iSS)%pStart     =  vars(iValue)%offsetTune
       segList(iSS)%pEnd       =  segList(iSS)%pStart
       ! TBD: system from source command
       segList(iSS)%systemName =  offsetSystemChoices(iHORIZONTRUE)
       segList(iSS)%altOption  =  'tSegment'
       segList(iSS)%speedStart =  0.0
       segList(iSS)%speedEnd   =  0.0
       segList(iSS)%tSegment   =  vars(iValue)%tTune
       ! TBD:        segList(iSS)%tRecord    =  
       Write (messageText,*)  "  subscan #:   ", iSS, " ",                       &
            &           segList(iSS)%ssType,                                     &
            &           segList(iSS)%pStart, segList(iSS)%tSegment               !
       Call pakoMessage(priorityI,severityI,"Focus  Analyze",messageText)
       !
    End If
    !
    ! ***
    If (vars(iValue)%nSubscans .Ge. 1) Then
       !
       iSS = iSS+1                                                               !  !!  1st Focus subscan
       segList(iSS)            =  segDefault                    ! 
       segList(iSS)%newSubscan =  .True.
       segList(iSS)%scanNumber =  nScan
       segList(iSS)%ssNumber   =  iSS
       segList(iSS)%segNumber  =  1
       segList(iSS)%ssType     =  ss%onFocus
       segList(iSS)%segType    =  seg%track
       segList(iSS)%angleUnit  =  aUnit
       segList(iSS)%speedUnit  =  sUnit
       segList(iSS)%flagOn     =  .True.
       segList(iSS)%flagRef    =  .False.
       segList(iSS)%pStart     =  xyPointType(0.0,0.0)
       segList(iSS)%pEnd       =  segList(iSS)%pStart
       ! TBD: system from source command
       segList(iSS)%systemName =  offsetSystemChoices(iHORIZONTRUE)
       segList(iSS)%altOption  =  'tSegment'
       segList(iSS)%speedStart =  0.0
       segList(iSS)%speedEnd   =  0.0
       segList(iSS)%tSegment   =  vars(iValue)%tSubscan
       ! TBD:        segList(iSS)%tRecord    =  
       segList(iSS)%focusOffset = 0.0
       segList(iSS)%directionFocus = vars(iValue)%directionFocus
       !
       If (GV%switchingMode .Eq. swMode%wobb) Then   
          segList(iSS)%pStart%x  = segList(iSS)%pStart%x +swWobblerShiftAzimuth
          segList(iSS)%pEnd%x    = segList(iSS)%pEnd%x   +swWobblerShiftAzimuth
          segList(iSS)%pStart%y  = segList(iSS)%pStart%y +swWobblerShiftElevation 
          segList(iSS)%pEnd%y    = segList(iSS)%pEnd%y   +swWobblerShiftElevation
       End If
       !
       Write (messageText,*)  "  subscan #:   ", iSS, " ",                       &
            &           segList(iSS)%ssType,                                     &
            &           segList(iSS)%directionFocus, segList(iSS)%focusOffset    !
       Call pakoMessage(priorityI,severityI,"Focus  Analyze",messageText)
       !
    End If
    !
    If (vars(iValue)%nSubscans .Ge. 2) Then
       !
       iSS = iSS+1
       segList(iSS)            =  segList(iSS-1)
       segList(iSS)%focusOffset = vars(iValue)%lengthFocus/2.0
       !
       Write (messageText,*)  "  subscan #:   ", iSS, " ",                       &
            &           segList(iSS)%ssType,                                     &
            &           segList(iSS)%directionFocus, segList(iSS)%focusOffset    !
       Call pakoMessage(priorityI,severityI,"Focus  Analyze",messageText)
       !
    End If
    !
    If (vars(iValue)%nSubscans .Eq. 3) Then
       !
       iSS = iSS+1
       segList(iSS)            =  segList(iSS-1)
       segList(iSS)%focusOffset = -vars(iValue)%lengthFocus/2.0
       !
       Write (messageText,*)  "  subscan #:   ", iSS, " ",                       &
            &           segList(iSS)%ssType,                                     &
            &           segList(iSS)%directionFocus, segList(iSS)%focusOffset    !
       Call pakoMessage(priorityI,severityI,"Focus  Analyze",messageText)
       !
    End If
    !
    If (vars(iValue)%nSubscans .Gt. 3) Then
       !
       Do ii = 3, vars(iValue)%nSubscans, 1
          !
          iSS = iSS+1
          segList(iSS)             =  segList(iSS-1)
          !
          Select Case (Mod(ii,6))
             !
          Case (0)
             segList(iSS)%focusOffset = 0.0
          Case (1)
             segList(iSS)%focusOffset = 0.0
          Case (2)
             segList(iSS)%focusOffset = vars(iValue)%lengthFocus/2.0
          Case (3)
             segList(iSS)%focusOffset = vars(iValue)%lengthFocus/2.0
          Case (4)
             segList(iSS)%focusOffset = -vars(iValue)%lengthFocus/2.0
          Case (5)
             segList(iSS)%focusOffset = -vars(iValue)%lengthFocus/2.0
          Case Default
             !
          End Select
          !
          Write (messageText,*)  "  subscan #:   ", iSS,  " ",                   &
               &           segList(iSS)%ssType,                                  &
               &           segList(iSS)%directionFocus, segList(iSS)%focusOffset !
          Call pakoMessage(priorityI,severityI,"Focus  Analyze",messageText)
          !
       End Do
       !
    End If
    !
    ! ***
    nSegments = iSS
    !
    Write (messageText,*)  "   number of Subscans/Segments: ", nSegments
    Call pakoMessage(priorityI,severityI,"Focus "//" Analyze",messageText)
    !
    Return 
    !
  End Subroutine analyzeFocus
!!!
!!!
  Subroutine plotFocus (errorP)
    !
    !**   Variables  for Plots   ***
    Include 'inc/variables/headerForPlotMethods.inc'
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    errorP = .False.
    !
    Call pako_message(seve%t,"FOCUS",                                            &
         &  " module Focus, v 1.2.3 2014-12-15 --> SR: plotFocus ")              ! trace execution
    !
    Call configurePlots
    !
    Call plotTrackP( xyPointType(0.0,0.0),                                       &
         &           errorP,                                                     &
         &           Type=ss%on)                                                 !
    !
    If (vars(iValue)%doTune) Then
       Call plotTrackP( vars(iValue)%offsetTune,                                 &
            &           errorP,                                                  &
            &           Type=ss%tune)                                            !
    End If
    !
    ! TBD:
!!$    Call plotDIYlist(errorP)
!!$    !
    !
    If (errorP)                                                                  &
         &        Call pakoMessage(priorityE,severityE,                          &
         &        'Focus',' could not plot ')                                    !
    !
    Return
  End Subroutine plotFocus
!!!
!!!
  Subroutine saveFocus(programName,LINE,commandToSave,                           &
       &         iUnit, ERROR)                                                   !
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    contC = contNN
    !
    Include 'inc/commands/saveCommand.inc'
    !
!!OLD      doContinue = .True.
    !
    contC = contCC
    !
    Include 'inc/parameters/saveLengthFocus.inc'
    !
    !TBD:      Include 'inc/options/saveCalibrate.inc'
    Include 'inc/options/saveDirectionFocus.inc'
    Include 'inc/options/saveFeBe.inc'
    Include 'inc/options/saveNsubscans.inc'
    !
    If (.Not.vars(iValue)%doTuneSet) Then
       contC = contCN
    End If
    !
    Include 'inc/options/saveTsubscan.inc'
    !TBD:      Include 'inc/options/saveOtfFocus.inc'
    !
    If (vars(iValue)%doTuneSet) Then
       If ( vars(iValue)%doTune) Then
          Include 'inc/options/saveTuneOffsets.inc'
          doContinue = .False.
          contC = contCN
          Include 'inc/options/saveTuneTime.inc'
       Else 
          doContinue = .False.
          contC = contCN
          Include 'inc/options/saveTuneOffsets.inc'
       End If
    End If
    !
    contC = contCN
    !
    !TBD:      Include 'inc/options/saveUpdate.inc'

    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveFocus
!!!
!!!
  Subroutine startFocus(programName,LINE,commandToSave,iUnit, ERROR)
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: ii
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: valueComment
    Character (len=lenLine) :: messageText
    Logical                 :: errorL, errorXML
    ! 
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module Focus, v 1.2.1  --> SR: startFocus ")                       !                      
    !
    ERROR = .False.
    !
    !
    Call pakoXMLsetOutputUnit(iunit=iunit)
    Call pakoXMLsetIndent(iIndent=2)
!!OLD   Call pakoXMLsetLevel(1)
    !
    Include 'inc/startXML/generalHead.inc'
    !
    Call writeXMLset(programName,LINE,commandToSave,iUnit, ERROR)
    !
    !!! Call writeXMLversion !!! incorporated in generalHead above
    !
    Call pakoXMLwriteStartElement("RESOURCE","pakoScript",                       &
         &                         comment="save from pako",                     &
         &                         error=errorXML)                               !
    Call pakoXMLwriteStartElement("DESCRIPTION",                                 &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/savePakoScriptFirst.inc'
    !
    Call saveFocus        (programName,LINE,commandToSave, iUnit, errorL)
    !                                                                       
    Call pakoXMLwriteEndElement("DESCRIPTION",                                   &
         &      error=errorXML)                                                  !
    Call pakoXMLwriteEndElement("RESOURCE", "pakoScript",                        &
         &      error=errorXML)                                                  !
    !
    Call writeXMLantenna(programName,LINE,commandToSave,                         &
         &         iUnit, ERROR)                                                 !
    !
    Call writeXMLreceiver(programName,LINE,commandToSave,                        &
         &         iUnit, ERROR)                                                 !
    !
    Call writeXMLbackend(programName,LINE,commandToSave,                         &
         &         iUnit, ERROR)                                                 !
    !
    Include 'inc/startXML/switchingMode.inc'
    !
    Call writeXMLsource(programName,LINE,commandToSave,                          &
         &         iUnit, ERROR)                                                 !
    !
    Include 'inc/startXML/generalScanHead.inc'
    !
    ! **  Observing Mode to XML
    If (gv%doXMLobservingMode) Then
       messageText = "writing observing mode in XML format"
       Call PakoMessage(priorityI,severityI,                                     &
               &           commandToSave,messageText)                            !
       Call writeXMLfocus(programName,LINE,commandToSave,                        &
         &         iUnit, ERROR)                                                 !
    End If
    !
    ! **  subscan list to XML
    Include 'inc/startXML/focusSubscansXML.inc'
    !   
    Include 'inc/startXML/generalTail.inc'
    !
    Return
  End Subroutine startFocus
!!!
!!!
  Subroutine writeXMLfocus(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: iMatch, nMatch, len1, len2
    Character (len=lenCh)   :: valueC, errorCode
    Character (len=lenLine) :: valueComment
    Logical                 :: errorM, errorXML
    Character (len=lenCh)   :: systemName
    !
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module Focus, v 1.2.3 ---> SR: writeXMLfocus 2014-10-27")          !
    !
    ERROR = .False.
    !
    Call pakoXMLwriteStartElement("RESOURCE","observingMode",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    valueC = GV%observingMode
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/parametersLengthFocusXML.inc'
    Include 'inc/startXML/optionNsubscansXML.inc'
    Include 'inc/startXML/optionTsubscanXML.inc'
    !
    systemName = offsPako%tru
    If (vars(iValue)%doTune) Then 
       Include 'inc/startXML/optionTuneXML.inc'
       Include 'inc/startXML/optionTtuneXML.inc'
    End If
    !D     Write (6,*) " systemName: --> ", systemName, "<-- "
    !D     Write (6,*) " offs%tru:   --> ", offs%tru,   "<-- "
    !
    Include 'inc/startXML/annotationsXML.inc'
    !
    Call pakoXMLwriteEndElement("RESOURCE","observingMode",                      &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLfocus
!!!
!!!
End Module modulePakoFocus

subroutine write_fits_dobs (unit, error)
  use classic_api  
  implicit none
  integer :: unit                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  integer :: status, date(7)
  character(len=40) :: chain
  !
  ! Write scan number, obs number and date in a HDU.
  status = 0
  call ftpkyj(unit,'SCAN-NUM',r_scan,'Scan number',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'OBS-NUM',r_num,'Observation number',status)
  if (status .gt. 0) goto 99
  call jjdate (r_dobs+2460549.5d0+r_ut/pi/2,date)
  call fttm2s(date(1),date(2),date(3),date(4),date(5),   &
    date(6)+date(7)*0.001d0,   &
    3,chain,status)
  if (status .gt. 0) goto 99
  call ftpkys(unit,'DATE-OBS',chain,'Date',status)
  if (status .gt. 0) goto 99
  return
  ! error return
99 call printerror('WRITE_FITS_DOBS',status)
  error = .true.
end subroutine write_fits_dobs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_unit_magnitude
  public :: unit_magnitude_t
  public :: cubetools_unit_magnitude_parse
  public :: exa,peta,tera,giga,mega,kilo,unity,centi,milli,micro,nano,pico,femto
  private
  !
  type :: unit_magnitude_t
    character(len=1), public  :: prefix     ! Standard prefix
    character(len=1), private :: alternate  ! Case insensitive alternate prefix
    real(kind=8),     public  :: factor     ! Multiplicative factor
  end type unit_magnitude_t
  !
  ! NB: in case of case-sensitive prefix, the alternate prefix is set identical
  !     to the standard prefix for simplicity of declaration and parsing.
  type(unit_magnitude_t), parameter :: exa   = unit_magnitude_t( 'E','e',1d18  )  ! Case-insensitive
  type(unit_magnitude_t), parameter :: peta  = unit_magnitude_t( 'P','P',1d15  )  ! Case-sensitive (conflict)
  type(unit_magnitude_t), parameter :: tera  = unit_magnitude_t( 'T','t',1d12  )  ! Case-insensitive
  type(unit_magnitude_t), parameter :: giga  = unit_magnitude_t( 'G','g',1d9   )  ! Case-insensitive
  type(unit_magnitude_t), parameter :: mega  = unit_magnitude_t( 'M','M',1d6   )  ! Case-sensitive (conflict)
  type(unit_magnitude_t), parameter :: kilo  = unit_magnitude_t( 'k','K',1d3   )  ! Case-insensitive
  type(unit_magnitude_t), parameter :: unity = unit_magnitude_t( ' ',' ',1d0   )  !
  type(unit_magnitude_t), parameter :: centi = unit_magnitude_t( 'c','C',1d-2  )  ! Case-insensitive
  type(unit_magnitude_t), parameter :: milli = unit_magnitude_t( 'm','m',1d-3  )  ! Case-sensitive (conflict)
  type(unit_magnitude_t), parameter :: micro = unit_magnitude_t( 'u','U',1d-6  )  ! Case-insensitive
  type(unit_magnitude_t), parameter :: nano  = unit_magnitude_t( 'n','N',1d-9  )  ! Case-insensitive
  type(unit_magnitude_t), parameter :: pico  = unit_magnitude_t( 'p','p',1d-12 )  ! Case-sensitive (conflict)
  type(unit_magnitude_t), parameter :: femto = unit_magnitude_t( 'f','F',1d-15 )  ! Case-insensitive
  !
  integer(kind=4), parameter :: nmagnitude=13
  type(unit_magnitude_t), parameter :: magnitudes(nmagnitude) =  &
    [ exa,peta,tera,giga,mega,kilo,unity,centi,milli,micro,nano,pico,femto ]
  !
contains
  !
  function cubetools_unit_magnitude_parse(prefix,magnitude)
    !-------------------------------------------------------------------
    ! Check if prefix is a known magnitude letter, and return this
    ! magnitude. Function evaluates as .true. or .false. if a matching
    ! magnitude is found.
    ! Case-sensitive search. Note that blank (or null-size) string
    ! matches unity.
    !-------------------------------------------------------------------
    logical :: cubetools_unit_magnitude_parse
    character(len=*),       intent(in)  :: prefix
    type(unit_magnitude_t), intent(out) :: magnitude
    !
    integer(kind=4) :: imagnitude
    !
    cubetools_unit_magnitude_parse = .false.
    do imagnitude=1,nmagnitude
      if (prefix.eq.magnitudes(imagnitude)%prefix .or. &
          prefix.eq.magnitudes(imagnitude)%alternate) then
        magnitude = magnitudes(imagnitude)
        cubetools_unit_magnitude_parse = .true.
        return
      endif
    enddo
  end function cubetools_unit_magnitude_parse
end module cubetools_unit_magnitude
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_unit_setup
  use cubetools_parameters
  use cubesyntax_messaging
  use cubetools_unit_magnitude
  !
  ! Constants
  public :: unitkinds,nunitkinds
  public :: code_unit_uv,unit_uv
  public :: code_unit_fov,unit_fov
  public :: code_unit_pang,unit_pang
  public :: code_unit_beam,unit_beam
  public :: code_unit_velo,unit_velo
  public :: code_unit_freq,unit_freq
  public :: code_unit_wave,unit_wave
  public :: code_unit_dist,unit_dist
  public :: code_unit_chan,unit_chan
  public :: code_unit_pixe,unit_pixe
  public :: code_unit_unk,unit_unk
  public :: code_unit_brig,code_unit_flux
  ! Types
  public :: unit_desc_t,unit_kind_t
  ! Methods
  public :: cubetools_unit_name,cubetools_unit_pperu
  public :: cubetools_unit_get_code,cubetools_unit_get_list_for_code
  public :: cubetools_unit_parse
  public :: operator(.eq.)
  ! Global variables
  public :: unitbuffer
  !
  private
  !
  ! *** JP: Should unit_l also be defined here?
  integer(kind=4), parameter :: unit_k = 4
  integer(kind=4), parameter :: keys_l = 10*unit_l  ! Store several variants of the same unit
  !
  ! Description of a unit default
  type :: unit_desc_t
     integer(kind=code_k),   public :: dimension  ! Backpointer to the list of associated units (e.g. to Hz)
     type(unit_magnitude_t), public :: magnitude  ! Possible extra factor (e.g. mega)
  end type unit_desc_t
  !
  ! Description of variants for a given unit
  type :: unit_variant_t
     integer(kind=unit_k),  private              :: n        ! Number of keys
     character(len=unit_l), private, allocatable :: keys(:)  ! List of keys
  end type unit_variant_t
  !
  ! Description of a unit kind
  type :: unit_kind_t
     integer(kind=code_k),  public               :: code     ! Unit code
     integer(kind=unit_k),  private              :: n        ! Number of different units supported
     character(len=unit_l), private, allocatable :: name(:)  ! Unit name for output
     character(len=keys_l), private, allocatable :: keys(:)  ! Blank-separated list of allowed input name for each unit
     type(unit_variant_t),  public,  allocatable :: vars(:)  ! Keys processed to list of variants
     real(kind=coor_k),     private, allocatable :: conv(:)  ! Relative conversion factor between supported units
     type(unit_desc_t),     private              :: prog     ! Program internal unit description
     type(unit_desc_t),     private              :: user     ! User default unit
   contains
     procedure, private :: alloc     => cubetools_unit_kind_alloc
     procedure, private :: init      => cubetools_unit_kind_init
     procedure, private :: debug     => cubetools_unit_kind_debug
     procedure, public  :: prog_name => cubetools_unit_kind_prog_name
  end type unit_kind_t
  !
  interface operator(.eq.)  ! Offers syntax e.g. "myunit.eq.unit_unk" to programmers
    module procedure cubetools_unit_kind_eq
  end interface
  !
  integer(kind=unit_k),  parameter :: nunitkinds = 11
  !
  ! Brightness and Flux units codes are included here as negative
  ! indexes because they are treated in a separate module
  ! (cubetools_brightness). Hence All loops from 1 to nunitkinds will
  ! treat only statical units, i.e. units whose convertions do not
  ! depend on cube information.
  !
  character(len=unit_l), parameter :: unitkinds(-1:nunitkinds) = [&
       'FLUX      ','BRIGHTNESS','UV        ','FOV       ','POSANGLE  ',&
       'BEAM      ','FREQUENCY ','VELOCITY  ','WAVELENGTH','CHANNEL   ',&
       'PIXEL     ','DISTANCE  ','UNKNOWN   ']
  !
  integer(kind=code_k), parameter :: code_unit_flux = -1
  integer(kind=code_k), parameter :: code_unit_brig = 0
  integer(kind=code_k), parameter :: code_unit_uv=1
  integer(kind=code_k), parameter :: code_unit_fov=2
  integer(kind=code_k), parameter :: code_unit_pang=3
  integer(kind=code_k), parameter :: code_unit_beam=4
  integer(kind=code_k), parameter :: code_unit_freq=5
  integer(kind=code_k), parameter :: code_unit_velo=6
  integer(kind=code_k), parameter :: code_unit_wave=7
  integer(kind=code_k), parameter :: code_unit_chan=8
  integer(kind=code_k), parameter :: code_unit_pixe=9
  integer(kind=code_k), parameter :: code_unit_dist=10
  integer(kind=code_k), parameter :: code_unit_unk=11
  !
  type(unit_kind_t), pointer :: unit_uv
  type(unit_kind_t), pointer :: unit_fov
  type(unit_kind_t), pointer :: unit_pang
  type(unit_kind_t), pointer :: unit_beam
  type(unit_kind_t), pointer :: unit_freq
  type(unit_kind_t), pointer :: unit_velo
  type(unit_kind_t), pointer :: unit_wave
  type(unit_kind_t), pointer :: unit_chan
  type(unit_kind_t), pointer :: unit_pixe
  type(unit_kind_t), pointer :: unit_dist
  type(unit_kind_t), pointer :: unit_unk
  !
  type unit_buffer_t
     type(unit_kind_t),     public  :: kind(nunitkinds)           !
     type(unit_desc_t),     private :: program(nunitkinds)        ! Internal program unit
     type(unit_desc_t),     private :: default(nunitkinds)        ! User default unit
     type(unit_desc_t),     public  :: current(nunitkinds)        ! User current unit
     character(len=unit_l), private :: prognames(nunitkinds)      ! Internal program unit names
     character(len=unit_l), public  :: usernames(nunitkinds)      ! User current unit names
     real(kind=coor_k),     public  :: prog_per_user(nunitkinds)  ! User current conversion (ppu)
     real(kind=coor_k),     public  :: user_per_prog(nunitkinds)  ! User current conversion (upp)
   contains
     procedure, public  :: init      => cubetools_unit_buffer_init
     procedure, public  :: defaults  => cubetools_unit_buffer_defaults
     procedure, private :: debug     => cubetools_unit_buffer_debug
     procedure, public  :: list      => cubetools_unit_buffer_list
     procedure, public  :: prog_name => cubetools_unit_buffer_prog_name
  end type unit_buffer_t
  !
  type(unit_buffer_t), target :: unitbuffer
  !
contains
  !
  subroutine cubetools_unit_buffer_init(buffer,error)
    use phys_const
    !---------------------------------------------------------------------
    ! Re(define) all individual units and user current units
    !---------------------------------------------------------------------
    class(unit_buffer_t), target, intent(inout) :: buffer
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='UNIT>BUFFER>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    unit_uv => buffer%kind(code_unit_uv)
    unit_uv%code = code_unit_uv
    call unit_uv%alloc(1,error)
    if (error)  return
    unit_uv%name(:) = ['meter']
    unit_uv%keys(:) = ['METER']
    unit_uv%conv(:) = [ 1.d0  ]
    unit_uv%prog%dimension = 1
    unit_uv%prog%magnitude = unity
    unit_uv%user%dimension = 1
    unit_uv%user%magnitude = unity
    call unit_uv%init(error)
    !
    unit_fov => buffer%kind(code_unit_fov)
    unit_fov%code = code_unit_fov
    call unit_fov%alloc(4,error)
    if (error)  return
    unit_fov%name(:) = ['radian',    'degree',    'arcmin',    'arcsec'    ]
    unit_fov%keys(:) = ['RADIAN;RAD','DEGREE;DEG','ARCMIN    ','ARCSEC    ']
    unit_fov%conv(:) = [ 1d0,        rad_per_deg, rad_per_min, rad_per_sec ]
    unit_fov%prog%dimension = 1
    unit_fov%prog%magnitude = unity
    unit_fov%user%dimension = 4
    unit_fov%user%magnitude = unity
    call unit_fov%init(error)
    !
    unit_pang => buffer%kind(code_unit_pang)
    unit_pang%code = code_unit_pang
    call unit_pang%alloc(2,error)
    if (error)  return
    unit_pang%name(:) = ['radian',   'degree']
    unit_pang%keys(:) = ['RADIAN',   'DEGREE']
    unit_pang%conv(:) = [     1d0,rad_per_deg]
    unit_pang%prog%dimension = 1
    unit_pang%prog%magnitude = unity
    unit_pang%user%dimension = 2
    unit_pang%user%magnitude = unity
    call unit_pang%init(error)
    !
    unit_beam => buffer%kind(code_unit_beam)
    unit_beam%code = code_unit_beam
    call unit_beam%alloc(4,error)
    if (error)  return
    unit_beam%name(:) = ['radian',    'degree',    'arcmin',    'arcsec'    ]
    unit_beam%keys(:) = ['RADIAN;RAD','DEGREE;DEG','ARCMIN    ','ARCSEC    ']
    unit_beam%conv(:) = [ 1d0,        rad_per_deg, rad_per_min, rad_per_sec ]
    unit_beam%prog%dimension = 1
    unit_beam%prog%magnitude = unity
    unit_beam%user%dimension = 4
    unit_beam%user%magnitude = unity
    call unit_beam%init(error)
    !
    unit_freq => buffer%kind(code_unit_freq)
    unit_freq%code = code_unit_freq
    call unit_freq%alloc(1,error)
    if (error)  return
    unit_freq%name(:) = ['Hz']
    unit_freq%keys(:) = ['HZ']
    unit_freq%conv(:) = [ 1d0]
    unit_freq%prog%dimension = 1
    unit_freq%prog%magnitude = mega
    unit_freq%user%dimension = 1
    unit_freq%user%magnitude = mega
    call unit_freq%init(error)
    !
    unit_velo => buffer%kind(code_unit_velo)
    unit_velo%code = code_unit_velo
    call unit_velo%alloc(1,error)
    if (error)  return
    unit_velo%name(:) = ['m/s']
    unit_velo%keys(:) = ['M/S']
    unit_velo%conv(:) = [  1d0]
    unit_velo%prog%dimension = 1
    unit_velo%prog%magnitude = kilo
    unit_velo%user%dimension = 1
    unit_velo%user%magnitude = kilo
    call unit_velo%init(error)
    !
    unit_wave => buffer%kind(code_unit_wave)
    unit_wave%code = code_unit_wave
    call unit_wave%alloc(2,error)
    if (error)  return
    unit_wave%name(:) = ['m  ','Ang']
    unit_wave%keys(:) = ['M  ','ANG']
    unit_wave%conv(:) = [  1d0,1d-10]
    unit_wave%prog%dimension = 1
    unit_wave%prog%magnitude = micro
    unit_wave%user%dimension = 1
    unit_wave%user%magnitude = milli
    call unit_wave%init(error)
    !
    unit_chan => buffer%kind(code_unit_chan)
    unit_chan%code = code_unit_chan
    call unit_chan%alloc(1,error)
    if (error)  return
    unit_chan%name(:) = ['channel']
    unit_chan%keys(:) = ['CHANNEL']
    unit_chan%conv(:) = [      1d0]
    unit_chan%prog%dimension = 1
    unit_chan%prog%magnitude = unity
    unit_chan%user%dimension = 1
    unit_chan%user%magnitude = unity
    call unit_chan%init(error)
    !
    unit_pixe => buffer%kind(code_unit_pixe)
    unit_pixe%code = code_unit_pixe
    call unit_pixe%alloc(1,error)
    if (error)  return
    unit_pixe%name(:) = ['pixel']
    unit_pixe%keys(:) = ['PIXEL']
    unit_pixe%conv(:) = [    1d0]
    unit_pixe%prog%dimension = 1
    unit_pixe%prog%magnitude = unity
    unit_pixe%user%dimension = 1
    unit_pixe%user%magnitude = unity
    call unit_pixe%init(error)
    !
    unit_dist => buffer%kind(code_unit_dist)
    unit_dist%code = code_unit_dist
    call unit_dist%alloc(1,error)
    if (error)  return
    unit_dist%name(:) = ['pc']
    unit_dist%keys(:) = ['PC']
    unit_dist%conv(:) = [ 1d0]
    unit_dist%prog%dimension = 1
    unit_dist%prog%magnitude = unity
    unit_dist%user%dimension = 1
    unit_dist%user%magnitude = unity
    call unit_dist%init(error)
    !
    unit_unk => buffer%kind(code_unit_unk)
    unit_unk%code = code_unit_unk
    call unit_unk%alloc(1,error)
    if (error)  return
    unit_unk%name(:) = [ strg_unk]
    unit_unk%keys(:) = ['UNKNOWN']
    unit_unk%conv(:) = [      1d0]
    unit_unk%prog%dimension = 1
    unit_unk%prog%magnitude = unity
    unit_unk%user%dimension = 1
    unit_unk%user%magnitude = unity
    call unit_unk%init(error)
    !
    call buffer%defaults(error)
    if (error)  return
    !
    ! call buffer%debug()  ! Debug
  end subroutine cubetools_unit_buffer_init
  !
  subroutine cubetools_unit_buffer_defaults(buffer,error)
    !---------------------------------------------------------------------
    ! Reset prog and user units to defaults
    !---------------------------------------------------------------------
    class(unit_buffer_t), intent(inout) :: buffer
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='UNIT>BUFFER>DEFAULTS'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    buffer%program(unit_uv%code)   = unit_uv%prog
    buffer%program(unit_fov%code)  = unit_fov%prog
    buffer%program(unit_pang%code) = unit_pang%prog
    buffer%program(unit_beam%code) = unit_beam%prog
    buffer%program(unit_freq%code) = unit_freq%prog
    buffer%program(unit_velo%code) = unit_velo%prog
    buffer%program(unit_wave%code) = unit_wave%prog
    buffer%program(unit_chan%code) = unit_chan%prog
    buffer%program(unit_pixe%code) = unit_pixe%prog
    buffer%program(unit_dist%code) = unit_dist%prog
    buffer%program(unit_unk%code)  = unit_unk%prog
    !
    buffer%default(unit_uv%code)   = unit_uv%user
    buffer%default(unit_fov%code)  = unit_fov%user
    buffer%default(unit_pang%code) = unit_pang%user
    buffer%default(unit_beam%code) = unit_beam%user
    buffer%default(unit_freq%code) = unit_freq%user
    buffer%default(unit_velo%code) = unit_velo%user
    buffer%default(unit_wave%code) = unit_wave%user
    buffer%default(unit_chan%code) = unit_chan%user
    buffer%default(unit_pixe%code) = unit_pixe%user
    buffer%default(unit_dist%code) = unit_dist%user
    buffer%default(unit_unk%code)  = unit_unk%user
    !
    buffer%current(unit_uv%code)   = unit_uv%user
    buffer%current(unit_fov%code)  = unit_fov%user
    buffer%current(unit_pang%code) = unit_pang%user
    buffer%current(unit_beam%code) = unit_beam%user
    buffer%current(unit_freq%code) = unit_freq%user
    buffer%current(unit_velo%code) = unit_velo%user
    buffer%current(unit_wave%code) = unit_wave%user
    buffer%current(unit_chan%code) = unit_chan%user
    buffer%current(unit_pixe%code) = unit_pixe%user
    buffer%current(unit_dist%code) = unit_dist%user
    buffer%current(unit_unk%code)  = unit_unk%user
    !
    buffer%prognames(unit_uv%code)   = cubetools_unit_name(unit_uv,unit_uv%prog)
    buffer%prognames(unit_fov%code)  = cubetools_unit_name(unit_fov,unit_fov%prog)
    buffer%prognames(unit_pang%code) = cubetools_unit_name(unit_pang,unit_pang%prog)
    buffer%prognames(unit_beam%code) = cubetools_unit_name(unit_beam,unit_beam%prog)
    buffer%prognames(unit_freq%code) = cubetools_unit_name(unit_freq,unit_freq%prog)
    buffer%prognames(unit_velo%code) = cubetools_unit_name(unit_velo,unit_velo%prog)
    buffer%prognames(unit_wave%code) = cubetools_unit_name(unit_wave,unit_wave%prog)
    buffer%prognames(unit_chan%code) = cubetools_unit_name(unit_chan,unit_chan%prog)
    buffer%prognames(unit_pixe%code) = cubetools_unit_name(unit_pixe,unit_pixe%prog)
    buffer%prognames(unit_dist%code) = cubetools_unit_name(unit_dist,unit_dist%prog)
    buffer%prognames(unit_unk%code)  = cubetools_unit_name(unit_unk,unit_unk%prog)
    !
    buffer%usernames(unit_uv%code)   = cubetools_unit_name(unit_uv,unit_uv%user)
    buffer%usernames(unit_fov%code)  = cubetools_unit_name(unit_fov,unit_fov%user)
    buffer%usernames(unit_pang%code) = cubetools_unit_name(unit_pang,unit_pang%user)
    buffer%usernames(unit_beam%code) = cubetools_unit_name(unit_beam,unit_beam%user)
    buffer%usernames(unit_freq%code) = cubetools_unit_name(unit_freq,unit_freq%user)
    buffer%usernames(unit_velo%code) = cubetools_unit_name(unit_velo,unit_velo%user)
    buffer%usernames(unit_wave%code) = cubetools_unit_name(unit_wave,unit_wave%user)
    buffer%usernames(unit_chan%code) = cubetools_unit_name(unit_chan,unit_chan%user)
    buffer%usernames(unit_pixe%code) = cubetools_unit_name(unit_pixe,unit_pixe%user)
    buffer%usernames(unit_dist%code) = cubetools_unit_name(unit_dist,unit_dist%user)
    buffer%usernames(unit_unk%code)  = cubetools_unit_name(unit_unk,unit_unk%user)
    !
    buffer%prog_per_user(unit_uv%code)   = cubetools_unit_pperu(unit_uv,unit_uv%user)
    buffer%prog_per_user(unit_fov%code)  = cubetools_unit_pperu(unit_fov,unit_fov%user)
    buffer%prog_per_user(unit_pang%code) = cubetools_unit_pperu(unit_pang,unit_pang%user)
    buffer%prog_per_user(unit_beam%code) = cubetools_unit_pperu(unit_beam,unit_beam%user)
    buffer%prog_per_user(unit_freq%code) = cubetools_unit_pperu(unit_freq,unit_freq%user)
    buffer%prog_per_user(unit_velo%code) = cubetools_unit_pperu(unit_velo,unit_velo%user)
    buffer%prog_per_user(unit_wave%code) = cubetools_unit_pperu(unit_wave,unit_wave%user)
    buffer%prog_per_user(unit_chan%code) = cubetools_unit_pperu(unit_chan,unit_chan%user)
    buffer%prog_per_user(unit_pixe%code) = cubetools_unit_pperu(unit_pixe,unit_pixe%user)
    buffer%prog_per_user(unit_dist%code) = cubetools_unit_pperu(unit_dist,unit_dist%user)
    buffer%prog_per_user(unit_unk%code)  = cubetools_unit_pperu(unit_unk,unit_unk%user)
    !
    buffer%user_per_prog(unit_uv%code)   = 1d0/buffer%prog_per_user(unit_uv%code)
    buffer%user_per_prog(unit_fov%code)  = 1d0/buffer%prog_per_user(unit_fov%code)
    buffer%user_per_prog(unit_pang%code) = 1d0/buffer%prog_per_user(unit_pang%code)
    buffer%user_per_prog(unit_beam%code) = 1d0/buffer%prog_per_user(unit_beam%code)
    buffer%user_per_prog(unit_freq%code) = 1d0/buffer%prog_per_user(unit_freq%code)
    buffer%user_per_prog(unit_velo%code) = 1d0/buffer%prog_per_user(unit_velo%code)
    buffer%user_per_prog(unit_wave%code) = 1d0/buffer%prog_per_user(unit_wave%code)
    buffer%user_per_prog(unit_chan%code) = 1d0/buffer%prog_per_user(unit_chan%code)
    buffer%user_per_prog(unit_pixe%code) = 1d0/buffer%prog_per_user(unit_pixe%code)
    buffer%user_per_prog(unit_dist%code) = 1d0/buffer%prog_per_user(unit_dist%code)
    buffer%user_per_prog(unit_unk%code)  = 1d0/buffer%prog_per_user(unit_unk%code)
  end subroutine cubetools_unit_buffer_defaults
  !
  subroutine cubetools_unit_buffer_debug(buffer)
    !---------------------------------------------------------------------
    ! For debugging purpose
    !---------------------------------------------------------------------
    class(unit_buffer_t), intent(inout) :: buffer
    !
    call unit_uv%debug()
    call unit_fov%debug()
    call unit_pang%debug()
    call unit_beam%debug()
    call unit_freq%debug()
    call unit_velo%debug()
    call unit_wave%debug()
    call unit_chan%debug()
    call unit_pixe%debug()
    call unit_dist%debug()
    call unit_unk%debug()
  end subroutine cubetools_unit_buffer_debug
  !
  subroutine cubetools_unit_buffer_list(buffer,error)
    !---------------------------------------------------------------------
    ! User feedback
    !---------------------------------------------------------------------
    class(unit_buffer_t), intent(inout) :: buffer
    logical,              intent(inout) :: error
    !
    character(len=message_length) :: mess
    integer(kind=unit_k) :: iunit
    character(len=*), parameter :: rname='UNIT>SETUP>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    write(mess,'(3x,a,10x,a,9x,a,5x,a)') 'KIND','USER','INTERNAL','CONVERSION'
    call cubesyntax_message(seve%r,rname,mess)
    call cubesyntax_message(seve%r,rname,'')
    do iunit=1,nunitkinds
       write(mess,'(3x,a,2x,2(a,1x),1pg23.16)') unitkinds(iunit),buffer%usernames(iunit),&
            buffer%prognames(iunit),buffer%prog_per_user(iunit)
       call cubesyntax_message(seve%r,rname,mess)
    enddo ! iunit
  end subroutine cubetools_unit_buffer_list
  !
  function cubetools_unit_name(unit,desc)
    !-------------------------------------------------------------------
    ! Build the unit name given its description (which base unit and which
    ! magnitude)
    ! -------------------------------------------------------------------
    character(len=unit_l) :: cubetools_unit_name
    type(unit_kind_t), intent(in) :: unit
    type(unit_desc_t), intent(in) :: desc
    cubetools_unit_name = trim(desc%magnitude%prefix)//unit%name(desc%dimension)
  end function cubetools_unit_name
  !
  function cubetools_unit_pperu(unit,desc)
    !-------------------------------------------------------------------
    ! Build the conversion factor from prog to user, given the description
    ! (which base unit and which magnitude in both) cases.
    ! -------------------------------------------------------------------
    real(kind=coor_k) :: cubetools_unit_pperu
    type(unit_kind_t), intent(in) :: unit
    type(unit_desc_t), intent(in) :: desc
    !
    cubetools_unit_pperu = (desc%magnitude%factor/unit%prog%magnitude%factor) *  &
                           (unit%conv(desc%dimension)/unit%conv(unit%prog%dimension))
  end function cubetools_unit_pperu
  !
  !-----------------------------------------------------------------------
  !
  subroutine cubetools_unit_kind_alloc(kind,n,error)
    !---------------------------------------------------------------------
    ! Allocate to requested size
    !---------------------------------------------------------------------
    class(unit_kind_t),   intent(inout) :: kind
    integer(kind=unit_k), intent(in)    :: n
    logical,              intent(inout) :: error
    !
    ! No test for reallocation as this type is expected to be allocated
    ! only once
    allocate(kind%name(n),kind%keys(n),kind%vars(n),kind%conv(n))
    kind%n = n
  end subroutine cubetools_unit_kind_alloc
  !
  subroutine cubetools_unit_kind_init(kind,error)
    use cubetools_string
    !---------------------------------------------------------------------
    ! Called once at startup
    !---------------------------------------------------------------------
    class(unit_kind_t), intent(inout) :: kind
    logical,            intent(inout) :: error
    !
    integer(kind=unit_k) :: ikey
    !
    do ikey=1,kind%n
      call cubetools_string_split(kind%keys(ikey),';',kind%vars(ikey)%keys,error)
      if (error)  return
      kind%vars(ikey)%n = size(kind%vars(ikey)%keys)
    enddo
  end subroutine cubetools_unit_kind_init
  !
  subroutine cubetools_unit_kind_debug(kind)
    !---------------------------------------------------------------------
    ! For debugging purpose
    !---------------------------------------------------------------------
    class(unit_kind_t), intent(in) :: kind
    !
    integer(kind=unit_k) :: ikey,ivar
    !
    write(*,'(t3,a,t10,i0)')  'Id:',kind%code
    write(*,'(t3,a,t10,i0)')  'N:', kind%n
    do ikey=1,kind%n
      write(*,'(t3,i0,a1,t10,a)')         ikey,':',kind%name(ikey)
      write(*,'(         t10,1pg23.16)')           kind%conv(ikey)
      write(*,'(         t10,a)')                  kind%keys(ikey)
      do ivar=1,kind%vars(ikey)%n
        write(*,'(t13,i0,a1,a)')          ivar,':',kind%vars(ikey)%keys(ivar)
      enddo ! ivar
    enddo ! ikey
    write(*,*)
  end subroutine cubetools_unit_kind_debug
  !
  function cubetools_unit_kind_eq(kind1,kind2) result(equal)
    type(unit_kind_t), intent(in) :: kind1,kind2
    logical                       :: equal
    equal = kind1%code.eq.kind2%code
  end function cubetools_unit_kind_eq
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_unit_get_code(name,code,error)
    use cubetools_disambiguate
    use cubetools_brightness
    !------------------------------------------------------------------------
    ! Guess unit code based on unit name, returns unknown for unrecognized
    ! units.
    ! ---
    ! This subroutine returns only the unit code. Most (all) the uses
    ! requires to parse again the name to get a user_unit_t. Consider using
    ! cubetools_unit_get with code = code_unit_auto.
    ! ---
    ! ***JP: This is is mostly used to handle intensity units.
    ! ***JP: Work on this remains to be done!
    !------------------------------------------------------------------------
    character(len=*),     intent(in)    :: name
    integer(kind=code_k), intent(out)   :: code
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: ikey
    character(len=*), parameter :: rname='UNIT>GET>CODE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    code = unit_unk%code  ! Default if not found
    !
    if (unit_found(unit_uv))    return
    ! Angular units except for msecond are going to be returned as a
    ! FOV unit. This is a choice maybe because all angular other units
    ! are fully ambiguous between POSANG, FOV and BEAM. The choice of
    ! FOV as the main angular unit in this case is dictated by the
    ! main use case. It is left to the calling routine to disambiguate
    ! between FOV,POSANGLE and BEAM based on their specific use case.
    if (unit_found(unit_fov))   return
    if (unit_found(unit_beam))  return
    if (unit_found(unit_freq))  return
    if (unit_found(unit_velo))  return
    if (unit_found(unit_wave))  return
    if (unit_found(unit_chan))  return
    if (unit_found(unit_pixe))  return
    if (unit_found(unit_dist))  return
    !
    ! BRIGHTNESS and FLUX here
    ikey = flux_get(name)
    if (unit_found2(code_unit_flux,ikey)) return
    ikey = brightness_get(name)
    if (unit_found2(code_unit_brig,ikey)) return
    !
  contains
    !
    function unit_found(unit) result(found)
      logical :: found  ! Function value on return
      type(unit_kind_t), intent(in) :: unit
      !
      type(unit_desc_t) :: user
      !
      call cubetools_unit_parse(name,unit%vars,user)
      found = user%dimension.ne.code_unresolved
      if (found) code = unit%code
    end function unit_found
    !
    function unit_found2(thiscode,ikey) result(found)
      logical :: found  ! Function value on return
      integer(kind=code_k), intent(in) :: thiscode
      integer(kind=4),      intent(in) :: ikey
      !
      found = ikey.ne.code_unresolved
      if (found) code = thiscode
    end function unit_found2
  end subroutine cubetools_unit_get_code
  !
  subroutine cubetools_unit_parse(name,variants,desc)
    !-------------------------------------------------------------------
    ! From a unit name and a list of authorized units, return which
    ! unit is matched and its magnitude.
    ! Match on the base unit name is case-insensitive.
    ! Return desc%dimension = code_unresolved if no match. It is the
    ! choice of the caller to raise an error/warning or not if relevant.
    !-------------------------------------------------------------------
    character(len=*),     intent(in)  :: name
    type(unit_variant_t), intent(in)  :: variants(:)
    type(unit_desc_t),    intent(out) :: desc
    !
    integer(kind=4) :: lname,lunit
    integer(kind=unit_k) :: iunit,ivar
    character(len=unit_l) :: uname
    character(len=*), parameter :: rname='UNIT>PARSE'
    !
    desc%magnitude = unity
    desc%dimension = code_unresolved
    !
    uname = name
    call sic_upper(uname)
    lname = len_trim(name)
    !
    do iunit=1,size(variants)  ! For all supported units
      do ivar=1,variants(iunit)%n
        lunit = len_trim(variants(iunit)%keys(ivar))
        !
        ! If input name is too short, it can not match this unit
        if (lunit.gt.lname)  cycle
        !
        ! Check if base unit matches (upper => case-insensitive!!!)
        if (uname(lname-lunit+1:lname).ne.variants(iunit)%keys(ivar)(1:lunit))  cycle
        !
        ! Check if a valid prefix matches (case-sensitive!!!)
        if (.not.cubetools_unit_magnitude_parse(name(1:lname-lunit),desc%magnitude))  cycle
        !
        ! Found it!
        desc%dimension = iunit
        return
      enddo ! ivar
    enddo ! iunit
  end subroutine cubetools_unit_parse
  !
  subroutine cubetools_unit_get_list_for_code(code,list,error)
    use cubetools_brightness
    !------------------------------------------------------------------------
    ! Returns the list of supported units for a given kind code
    !------------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: code
    character(len=*),     allocatable   :: list(:)
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='UNIT>GET>LIST>FOR>CODE'
    !
    select case (code)
    case (code_unit_uv)
      list = unit_uv%name
    case (code_unit_fov)
      list = unit_fov%name
    case (code_unit_pang)
      list = unit_pang%name
    case (code_unit_beam)
      list = unit_beam%name
    case (code_unit_freq)
      list = unit_freq%name
    case (code_unit_velo)
      list = unit_velo%name
    case (code_unit_wave)
      list = unit_wave%name
    case (code_unit_chan)
      list = unit_chan%name
    case (code_unit_pixe)
      list = unit_pixe%name
    case (code_unit_dist)
      list = unit_dist%name
    case (code_unit_unk)
      list = unit_unk%name
    case default
      write(mess,'(a,i0)') 'Unknown unit code ',code
      call cubesyntax_message(seve%e,rname,mess)
      error = .true.
      return
    end select
  end subroutine cubetools_unit_get_list_for_code
  !
  function cubetools_unit_kind_prog_name(unit)
    !-------------------------------------------------------------------
    ! Return the name of the program internal unit name
    !-------------------------------------------------------------------
    character(len=unit_l) :: cubetools_unit_kind_prog_name
    class(unit_kind_t), intent(in) :: unit
    cubetools_unit_kind_prog_name = unitbuffer%prognames(unit%code)  ! Pre-computed
  end function cubetools_unit_kind_prog_name
  !
  function cubetools_unit_buffer_prog_name(buffer,code)
    !-------------------------------------------------------------------
    ! Return the name of the program internal unit name
    !-------------------------------------------------------------------
    character(len=unit_l) :: cubetools_unit_buffer_prog_name
    class(unit_buffer_t), intent(in) :: buffer
    integer(kind=code_k), intent(in) :: code
    cubetools_unit_buffer_prog_name = buffer%prognames(code)  ! Pre-computed
  end function cubetools_unit_buffer_prog_name
end module cubetools_unit_setup
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_unit
  use cubetools_parameters
  use cubesyntax_messaging
  use cubetools_unit_magnitude
  use cubetools_unit_setup
  !
  ! Constants
  public :: code_unit_uv
  public :: code_unit_fov
  public :: code_unit_pang
  public :: code_unit_beam
  public :: code_unit_velo
  public :: code_unit_freq
  public :: code_unit_wave
  public :: code_unit_dist
  public :: code_unit_chan
  public :: code_unit_pixe
  public :: code_unit_unk
  public :: code_unit_brig
  public :: code_unit_flux
  ! Types
  public :: unit_user_t
  public :: cubetools_unit_set!,cubetools_unit_get_code
  !
  private
  !
  type unit_t
     type(unit_desc_t),          private :: desc                 ! Unit and magnitude description
     character(len=unit_l),      public  :: name = strg_unk      ! Unit name
     real(kind=coor_k),          public  :: user_per_prog = 1d0  ! Conversion factor
     real(kind=coor_k),          public  :: prog_per_user = 1d0  ! Reverse conversion factor
     type(unit_kind_t), pointer, public  :: kind => null()       ! Associated kind
   contains
     procedure, public  :: list               => cubetools_unit_list
     procedure, public  :: is_consistent_with => cubetools_unit_is_consistent_with
  end type unit_t
  !
  type, extends(unit_t) :: unit_user_t
   contains
     procedure, public :: get_from_name          => cubetools_unit_user_get_from_name
     procedure, public :: get_from_code          => cubetools_unit_user_get_from_code
     procedure, public :: get_from_name_for_code => cubetools_unit_user_get_from_name_for_code
  end type unit_user_t
  !
!!$  type, extends(unit_t) unit_prog_t
!!$   contains
!!$     procedure, public  :: get_from_code => cubetools_unit_prog_get_from_code
!!$  end type unit_prog_t
  !
contains
  !  
  subroutine cubetools_unit_list(user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(unit_t), intent(in)    :: user
    logical,       intent(inout) :: error
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='UNIT>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    write(mess,'(3x,a,2x,a,2x,2(1pg23.16,1x))') unitkinds(user%kind%code),user%name,user%user_per_prog,user%prog_per_user
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubetools_unit_list
  !
  subroutine cubetools_unit_is_consistent_with(unit1,unit2,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(unit_t), intent(in)    :: unit1
    class(unit_t), intent(in)    :: unit2
    logical,       intent(inout) :: error
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='UNIT>IS>CONSISTENT>WITH'
    !
    if (unit1%kind%code.ne.unit2%kind%code) then
       write(mess,'(a,x,a,2x,a)') 'Inconsistent unit kinds:',unit1%name,unit2%name
       call cubesyntax_message(seve%e,rname,mess)
       error = .true.
       return
    endif
  end subroutine cubetools_unit_is_consistent_with
  !
  !-----------------------------------------------------------------------
  !
  subroutine cubetools_unit_user_get_from_name(user,name,error)
    !------------------------------------------------------------------------
    ! Fill the output unit_user_t structure by parsing the given name
    !------------------------------------------------------------------------
    class(unit_user_t), intent(out)   :: user
    character(len=*),   intent(in)    :: name
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='UNIT>USER>GET>NAME'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    user%kind => unit_unk  ! Default if not found
    !
    if (unit_found(unit_uv))    return
    ! Angular units except for msecond are going to be returned as a
    ! FOV unit. This is a choice maybe because all angular other units
    ! are fully ambiguous between FOV, BEAM and POSANGLE. The choice of
    ! FOV as the main angular unit in this case is dictated by the
    ! main use case. It is left to the calling routine to disambiguate
    ! between FOV, BEAM, and POSANGLE based on their specific use case.
    if (unit_found(unit_fov))   return
    if (unit_found(unit_beam))  return
    if (unit_found(unit_freq))  return
    if (unit_found(unit_velo))  return
    if (unit_found(unit_wave))  return
    if (unit_found(unit_chan))  return
    if (unit_found(unit_pixe))  return
    if (unit_found(unit_dist))  return
    !
    ! BRIGHTNESS and FLUX not yet supported
    !
  contains
    !
    function unit_found(unit) result(found)
      logical :: found  ! Function value on return
      type(unit_kind_t), intent(in), target :: unit
      !
      call cubetools_unit_parse(name,unit%vars,user%desc)
      found = .false.
      if (user%desc%dimension.ne.code_unresolved) then
        found = .true.
        user%name          = cubetools_unit_name(unit,user%desc)
        user%prog_per_user = cubetools_unit_pperu(unit,user%desc)
        user%user_per_prog = 1d0/user%prog_per_user
        user%kind          => unit
      endif
    end function unit_found
  end subroutine cubetools_unit_user_get_from_name
  !
  subroutine cubetools_unit_user_get_from_code(user,code,error)
    !---------------------------------------------------------------------
    ! Fill the output unit_user_t structure according to current user
    ! unit.
    !---------------------------------------------------------------------
    class(unit_user_t),   intent(out)   :: user
    integer(kind=code_k), intent(in)    :: code
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='UNIT>USER>GET>FROM>CODE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (code.lt.0 .or. code.gt.nunitkinds) then
       write(mess,'(a,i0)') 'Unknown unit code ',code
       call cubesyntax_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    user%desc = unitbuffer%current(code)
    user%name = unitbuffer%usernames(code)              ! From pre-computed
    user%user_per_prog = unitbuffer%user_per_prog(code) ! From pre-computed
    user%prog_per_user = unitbuffer%prog_per_user(code) ! From pre-computed
    user%kind => unitbuffer%kind(code)
  end subroutine cubetools_unit_user_get_from_code
  !
  subroutine cubetools_unit_user_get_from_name_for_code(user,name,code,error)
    !---------------------------------------------------------------------
    ! Parse the given unit name for given code (e.g. parse 'marcsec' for
    ! code_fov).
    ! This subroutine is useful when user gives an explicit unit which
    ! overrides the user current default.
    !---------------------------------------------------------------------
    class(unit_user_t),   intent(out)   :: user
    character(len=*),     intent(in)    :: name
    integer(kind=code_k), intent(in)    :: code
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='UNIT>USER>GET>FROM>NAME>OR>CODE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (name.eq.strg_star .or. name.eq.strg_equal) then
      ! If user provides a * or a = (explicit or implicit), return its
      ! default current unit.
      call user%get_from_code(code,error)
      return
    endif
    !
    select case(code)
    case (code_unit_uv:code_unit_dist)
      call cubetools_unit_parse(name,unitbuffer%kind(code)%vars,user%desc)
      if (user%desc%dimension.ne.code_unresolved) then
        user%name          = cubetools_unit_name(unitbuffer%kind(code),user%desc)
        user%prog_per_user = cubetools_unit_pperu(unitbuffer%kind(code),user%desc)
        user%user_per_prog = 1d0/user%prog_per_user
        user%kind          => unitbuffer%kind(code)
      endif
   case (code_unit_unk)
      ! *** JP: user may know better the unit than the program
      ! call cubesyntax_message(seve%w,rname,'UNKNOWN unit code')
      user%desc%dimension = 1
      user%desc%magnitude = unity
      ! user%name           = cubetools_unit_name(unit_unk,user%desc)
      user%name           = name
      user%prog_per_user  = cubetools_unit_pperu(unit_unk,user%desc)
      user%user_per_prog  = 1d0/user%prog_per_user
      user%kind           => unit_unk
    case default
      write(mess,'(a,i0)') 'Unknown unit kind code ',code
      call cubesyntax_message(seve%e,rname,mess)
      error = .true.
      return
    end select
    !
    if (user%desc%dimension.eq.code_unresolved) then
      ! Nothing found
      call cubesyntax_message(seve%e,rname,trim(name)//' is not a valid unit')
      error = .true.
      return
    endif
  end subroutine cubetools_unit_user_get_from_name_for_code
  !
  subroutine cubetools_unit_set(name,code,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: name
    integer(kind=code_k), intent(in)    :: code
    logical,              intent(inout) :: error
    !
    type(unit_user_t) :: user
    character(len=*), parameter :: rname='UNIT>SET'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call user%get_from_name_for_code(name,code,error)
    if (error) return
    !
    unitbuffer%current(code)       = user%desc
    unitbuffer%usernames(code)     = user%name
    unitbuffer%prog_per_user(code) = user%prog_per_user
    unitbuffer%user_per_prog(code) = user%user_per_prog
  end subroutine cubetools_unit_set
end module cubetools_unit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine class_plot(set,line,r,error)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_plot
  use class_data
  use class_types
  !----------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  !      PLOT [ArrayName]
  ! 1         [/INDEX]
  ! 2         [/OBS]
  ! Plot specified observation for command
  !----------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Error status
  ! Local
  character(len=*), parameter :: rname='PLOT'
  logical :: doindex
  character(len=16) :: aline,comm,aaname
  integer(kind=4) :: nline,nc
  !
  ! Parse input line
  doindex = set%action.eq.'I'
  if (sic_present(1,0).and.sic_present(2,0)) then
     call class_message(seve%e,rname,'/INDEX and /OBS are not compatible')
     error = .true.
     return
  else if (sic_present(1,0)) then
     if (.not.associated(p%data2)) then
        call class_message(seve%e,rname,'No index loaded')
        error = .true.
        return
     endif
     doindex = .true.
  else if (sic_present(2,0)) then
     doindex = .false.
  endif
  !
  if (doindex) then
     call plot_index(set,error)
  else
     if (r%head%xnum.eq.0) then
        call class_message(seve%e,rname,'No such spectrum in memory.')
        error = .true.
        return
     endif
     if (r%head%gen%kind.eq.kind_sky) then
        call class_message(seve%e,rname,'Not yet implemented for SKYDIP.')
        error = .true.
        !!call plot_sky(line,error)
     elseif (r%head%gen%kind.eq.kind_onoff) then
        call class_message(seve%e,rname,'Not yet implemented for ON/OFF.')
        error = .true.
     else
        call gtv_clear_directory('^',error)  ! ^ = ancestor of current tree
        if (error)  return
        call newlim(set,r,error)
        ! Spectrum
        aaname = 'Y'  ! Plot RY
        call sic_ke(line,0,1,aaname,nc,.false.,error)
        if (error)  return
        call spectr1d(rname,set,r,error,aaname=aaname)
        if (error)  return
        ! Box
        call class_box_default(set,.false.,r,aaname,error)
        if (error)  return
        ! Title
        aline = 'LAS'//CHAR(92)//'TITLE /OBS'
        nline = len_trim(aline)
        call sic_analyse(comm,aline,nline,error)
        call class_title(set,aline,r,error)
     endif
  endif
  !
  ! Set space to direct
  set%fft = .false.
  !
end subroutine class_plot
!
subroutine plot_index(set,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>plot_index
  use class_data
  use class_index
  use class_popup
  use class_types
  use plot_formula
  !-----------------------------------------------------------------------
  ! @ private
  ! CLASS Support routine for command
  !     PLOT /INDEX
  ! Plot the currently loaded 2-D array as an image
  !-----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PLOT'
  character(len=16) :: aline,comm
  character(len=1) :: unit_up,unit_low
  integer(kind=entry_length) :: i
  integer(kind=4) :: ier,nline
  !
  if (.not.associated(p%data2)) then
     call class_message(seve%e,rname,'No 2-D data loaded')
     error = .true.
     return
  endif
  !
  ! Compute plot limits
  call newlim(set,p,error)
  if (error) return
  !
  ! Clear plot
  call geunit(set,p%head,unit_low, unit_up)
  call gtclear
  !
  ! Spectrum
  call spectr2d(p,error)
  !
  ! Box and wedge
  call class_box_default(set,.true.,p,'Y',error)
  if (error)  return
  call gr_exec2('WEDGE')
  !
  ! Title
  aline = 'LAS'//CHAR(92)//'TITLE /INDEX'
  nline = len_trim(aline)
  call sic_analyse(comm,aline,nline,error)
  call class_title(set,aline,p,error)
  !
  ! Save for POPUP commands.
  npop = p%head%des%ndump
  if (allocated(ipop)) deallocate(ipop,xpop,ypop)
  allocate(ipop(npop),xpop(npop),ypop(npop),stat=ier)
  if (ier.ne.0) then
     call class_message(seve%f,rname,'Allocation error')
     error = .true.
     npop = 0
  else
     do i=1, npop
        ipop(i) = cx%num(i) !! r%head%gen%num
     enddo
  endif
  cpop = cpop_plotindex
  pgx1 = gx1
  pgx2 = gx2
  pgz1 = gy1
  pgz2 = gy2
  pux1 = 0.5
  pux2 = p%head%spe%nchan+0.5
  if (set%modez.eq.'A'.or.set%modez.eq.'T') then
     puz1 = 0.5
     puz2 = p%head%des%ndump+0.5
  endif
  !
end subroutine plot_index

module gbl_message_private
  use gpack_def
  use gbl_ansicodes
  !---------------------------------------------------------------------
  ! @private
  ! Support parameters and variables for message printing to screen and
  ! message file
  !---------------------------------------------------------------------
  !
  ! 1/ SEVERITIES
  !
  integer(kind=4),      parameter :: nseve = 9       ! Number of severities
  character(len=1),     parameter :: seve_levels(nseve) = &
    (/ 'F','E','W','R','I','D','T','C','U' /)        ! Severity letters. Order matters
  character(len=nseve), parameter :: seve_allflags = 'FEWRIDTCU'
  !
  ! 2/ OUTPUTS
  !
  ! General message file unit number. Packages do not have their own
  ! message file, and write into the general one
  integer(kind=4) :: meslun = 0
  !
  ! A "messaging-rules type" (message_rules_t) is provided. Each package
  ! can use it to define a structure which contains its customizable
  ! rules
  type :: message_rules_t
     !       F      E      W      R      I      D       T       C       U
     logical :: toscreen(nseve) =  &  ! FEWRI---U
        (/ .true.,.true.,.true.,.true.,.true.,.false.,.false.,.false.,.true. /)
     logical :: tofile(nseve)   =  &  ! FEWRI--CU
        (/ .true.,.true.,.true.,.true.,.true.,.false.,.false.,.true., .true. /)
  end type message_rules_t
  !
  ! Define the structure which stores all logical filters. Index 0 is
  ! the global rules which may override ALL packages rules.
  type(message_rules_t), save :: message_rules(0:gpack_max_count)
  !
  integer(kind=4), parameter :: ncolors=10
  type :: colors_t
    character(len=7) :: name(ncolors) =  &
      (/ 'NONE   ',  &
         'BLACK  ',  &
         'RED    ',  &
         'GREEN  ',  &
         'YELLOW ',  &
         'BLUE   ',  &
         'MAGENTA',  &
         'CYAN   ',  &
         'WHITE  ',  &
         'ORANGE ' /)
    character(len=11) :: code(ncolors) =  &
        (/ '           ',        &
           c_black  //'      ',  &  ! (do not forget blank padding for array constructor!)
           c_red    //'      ',  &
           c_green  //'      ',  &
           c_yellow //'      ',  &
           c_blue   //'      ',  &
           c_magenta//'      ',  &
           c_cyan   //'      ',  &
           c_white  //'      ',  &
           c_orange /)
  end type colors_t
  type(colors_t) :: colors
  !
  ! Add a "messaging-color type":
  type :: message_colors_t
     !        F      E      W       R       I       D       T       C       U
     logical :: enabled(nseve) =  &
        (/ .true.,.true.,.true.,.false.,.false.,.false.,.false.,.false.,.false. /)
     character(len=7) :: name(nseve) =  &
        (/ 'RED    ',  &  ! F
           'RED    ',  &  ! E
           'ORANGE ',  &  ! W
           'NONE   ',  &  ! R
           'NONE   ',  &  ! I
           'NONE   ',  &  ! D
           'NONE   ',  &  ! T
           'NONE   ',  &  ! C
           'NONE   '  /)  ! U
     character(len=11) :: code(nseve) =  &
        (/ c_red//'      ',  &  ! F (do not forget blank padding for array constructor!)
           c_red//'      ',  &  ! E
           c_orange,         &  ! W
           '           ',    &  ! R
           '           ',    &  ! I
           '           ',    &  ! D
           '           ',    &  ! T
           '           ',    &  ! C
           '           '    /)  ! U
     integer(kind=4) :: lcode(nseve) =  &
        (/  5, 5, 11, 0, 0, 0, 0, 0, 0 /)
  end type message_colors_t
  type(message_colors_t) :: message_colors
  !
  logical :: mes_gbl_rules  = .true.   ! Use global rules
  logical :: mes_gbl_colors = .true.   ! Use global colors
  logical :: mes_use_debug  = .false.  ! Debug (high verbosity) is in use
  logical :: mes_log_date   = .false.  ! Print date in file
  logical :: mes_log_append = .false.  ! Append file if already existing
  !
end module gbl_message_private
!
subroutine gmessage_init(logname,error)
  use gsys_interfaces, except_this=>gmessage_init
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Initialization routine for gmessage facility:
  !  - close previously opened message file (useful to change the file
  !    during a session)
  !  - open the (new) message file
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: logname
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='GMESSAGE>INIT'
  character(len=256) :: release
  !
  if (meslun.ne.0) then
    ! That's a close-and-open action. Warn
    call gsys_message(seve%w,rname,  &
      'Closing and reopening message file under name '//logname)
  endif
  !
  call gmessage_close(error)
  if (error) return
  !
  call gmessage_open(logname,error)
  if (error) return
  !
  ! First line of the message file is the Gildas version (always, whatever
  ! the filtering rules)
  call gag_release(release)
  write(meslun,'(A)')  trim(release)
  !
end subroutine gmessage_init
!
subroutine gmessage_parse_and_set(inid,infilter,error)
  use gsys_interfaces, except_this=>gmessage_parse_and_set
  use gbl_message
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Alter the message filters for input package. Inputs are:
  ! 1) The package id,
  ! 2) The alteration rule, as used in SIC command line, e.g. "s-dtu",
  !    "l=fewri", ...
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: inid      ! Package id
  character(len=*), intent(in)    :: infilter  ! Filter rule
  logical,          intent(inout) :: error     ! Error flag
  ! Local
  character(len=*), parameter :: rname='MESSAGE'
  integer(kind=4) :: iseve
  logical :: reset,tofil,toscr,toflag,found,lfilter(nseve)
  character(len=1)  :: letter
  character(len=filter_length) :: filter
  character(len=message_length) :: mess
  !
  ! Local copy
  filter = infilter
  call sic_upper(filter)
  !
  ! Check if input id is correct
  if (inid .gt. gpack_get_count()) then
    write(mess,*) "Unknown package id #",inid
    call gsys_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Affects which messages? These are exclusive letters, ie parse only
  ! once.
  letter = filter(1:1)
  filter = filter(2:)
  found  = .false.
  toscr  = .true.   ! Default is to screen
  tofil  = .false.
  if (letter.eq.'L') then
    found = .true.
    toscr = .false.
    tofil = .true.
  elseif (letter.eq.'S') then
    found = .true.
    toscr = .true.
    tofil = .false.
  elseif (letter.eq.'A') then
    found = .true.
    tofil = .true.
    toscr = .true.
  endif
  if (found) then
    letter = filter(1:1)
    filter = filter(2:)
    found  = .false.
  endif
  !
  ! Which kind of modification? These are exclusive symbols, ie parse
  ! only once.
  toflag = .true.    ! Default is '+'
  reset  = .false.   ! Default is no reset (.true. if '=')
  if (letter.eq.'-') then
    found  = .true.
    toflag = .false.
  elseif (letter.eq.'=') then
    found  = .true.
    reset  = .true.
    toflag = .true.
  elseif (letter.eq.'+') then
    found  = .true.
    toflag = .true.
  endif
  if (found) then
    letter = filter(1:1)
    filter = filter(2:)
    found = .false.
  endif
  !
  ! Reset?
  ! Forbid syntax "s=" (which redefines filter as empty)
  if (reset .and. letter.eq.' ') then
    call gsys_message(seve%e,rname,'Erasing all flags with = operator is forbidden')
    call gsys_message(seve%e,rname,'Use - operator and explicitely remove them')
    error = .true.
    return
  endif
  !
  ! Translate filter string in logical array. lfilter stores which message
  ! kinds we want to toggle, NOT the destination value.
  lfilter = .false.
  do
    if (letter.eq.' ') exit  ! All done
    do iseve=1,nseve
      if (letter.eq.seve_levels(iseve)) then
        found = .true.
        lfilter(iseve) = .true.
      endif
    enddo
    if (found) then
      letter = filter(1:1)
      filter = filter(2:)
      found  = .false.
    else
      call gsys_message(seve%e,rname,'Malformed message filter rule near '''//letter//'''')
      error = .true.
      return
    endif
  enddo
  !
  ! Finally, alter filters for current package
  if (reset.and.tofil) message_rules(inid)%tofile   = .false.
  if (reset.and.toscr) message_rules(inid)%toscreen = .false.
  !
  do iseve=1,nseve
    if (lfilter(iseve)) then
      if (toscr) message_rules(inid)%toscreen(iseve) = toflag
      if (tofil) message_rules(inid)%tofile(iseve)   = toflag
    endif
  enddo
  !
end subroutine gmessage_parse_and_set
!
subroutine gmessage_parse_and_set_all(infilter,error)
  use gsys_interfaces, except_this=>gmessage_parse_and_set_all
  !---------------------------------------------------------------------
  ! @ public
  ! Updates all filters for all packages (excluding "Global" ones),
  ! given the input alteration rule
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: infilter  ! Filter rule
  logical,          intent(inout) :: error     ! Error flag
  ! Local
  integer(kind=4) :: ipack
  !
  do ipack=1,gpack_get_count()
    call gmessage_parse_and_set(ipack,infilter,error)
    if (error)  return
  enddo
  !
end subroutine gmessage_parse_and_set_all
!
subroutine gmessage_print_active(sev,error)
  use gsys_interfaces, except_this=>gmessage_print_active
  use gpack_def
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Prints all filters for all ACTIVE packages (i.e. "Global" or "per
  ! package")
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: sev    ! Severity used to write output
  logical,         intent(inout) :: error  ! Error flag
  !
  if (mes_gbl_rules) then
    call gmessage_print_id(gpack_global_id,sev,error)
  else
    call gmessage_print_all(sev,error)
  endif
  !
end subroutine gmessage_print_active
!
subroutine gmessage_print_all(sev,error)
  use gsys_interfaces, except_this=>gmessage_print_all
  !---------------------------------------------------------------------
  ! @ public
  ! Prints filters for all packages (excluding "Global" ones)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: sev    ! Severity used to write output
  logical,         intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=4) :: ipack
  !
  do ipack=1,gpack_get_count()
    call gmessage_print_id(ipack,sev,error)
    if (error)  return
  enddo
  !
end subroutine gmessage_print_all
!
subroutine gmessage_print_id(id,sev,error)
  use gsys_interfaces, except_this=>gmessage_print_id
  use gpack_def
  use gbl_message
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Prints filters for the input package. Input is the package id.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: id     ! Package id
  integer(kind=4), intent(in)    :: sev    ! Severity used to write output
  logical,         intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='MESSAGE'
  integer(kind=4) :: iseve
  character(len=nseve) :: scr_filter,fil_filter
  character(len=8) :: activity
  character(len=message_length) :: mess
  character(len=gpack_name_length) :: packname
  !
  do iseve=1,nseve
    if (message_rules(id)%toscreen(iseve)) then
      scr_filter(iseve:iseve) = seve_levels(iseve)
    else
      scr_filter(iseve:iseve) = '-'
    endif
    if (message_rules(id)%tofile(iseve)) then
      fil_filter(iseve:iseve) = seve_levels(iseve)
    else
      fil_filter(iseve:iseve) = '-'
    endif
  enddo ! iseve
  !
  ! Show filter strings
  call gpack_get_name(id,packname,error)
  if (error) return
  !
  ! Active or inactive?
  if ( (id.eq.0 .and. .not.mes_gbl_rules) .or. (id.ne.0 .and. mes_gbl_rules) ) then
    activity = 'inactive'
  else
    activity = 'active  '
  endif
  !
  ! Print
  write (mess,100) packname,'on-screen ',activity,scr_filter
  call gsys_message(sev,rname,mess)
  write (mess,100) packname,'to-mesfile',activity,fil_filter
  call gsys_message(sev,rname,mess)
  !
100  format(A,1X,A,1X,A,' filter: ',A)
  !
end subroutine gmessage_print_id
!
subroutine gmessage_print(packname,error)
  use gsys_interfaces, except_this=>gmessage_print
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Prints filters for the input package. Input is the package name.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: packname  ! Package name
  logical,          intent(inout) :: error     ! Error flag
  ! Local
  integer(kind=4) :: id
  !
  id = gpack_get_id(packname,.true.,error)
  if (error)  return
  !
  call gmessage_print_id(id,seve%i,error)
  if (error) return
  !
end subroutine gmessage_print
!
subroutine gmessage_translate(seve_leve,seve_code,error)
  use gsys_interfaces, except_this=>gmessage_translate
  use gbl_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Translate a message severity letter into its corresponding integer
  ! code, as a call to gmessage_write needs.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: seve_leve  ! Input severity letter
  integer(kind=4),  intent(out)   :: seve_code  ! Translated code
  logical,          intent(inout) :: error      ! Error flag
  ! Local
  character(len=*), parameter :: rname='MESSAGE'
  character(len=1) :: letter
  !
  letter = seve_leve
  call sic_upper(letter)
  !
  do seve_code=1,nseve
    if (letter.eq.seve_levels(seve_code)) return
  enddo
  !
  call gsys_message(seve%e,rname,'Unknown message kind '''//seve_leve//'''')
  error = .true.
  !
end subroutine gmessage_translate
!
subroutine gmessage_log_append(flag)
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Message file will be appended if already existing. Must be called
  ! before opening the message file.
  !---------------------------------------------------------------------
  logical, intent(in) :: flag
  !
  mes_log_append = flag
  !
end subroutine gmessage_log_append
!
subroutine gmessage_open(mesname,error)
  use gildas_def
  use gbl_message_private
  use gsys_interfaces, except_this=>gmessage_open
  !---------------------------------------------------------------------
  ! @ private
  ! Opens message file in GAG_LOG: directory. Must be called only once.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: mesname  ! Message base filename
  logical,          intent(inout) :: error    ! Error flag
  ! Local
  integer(kind=4) :: status,ml
  character(len=17) :: failure_message='F-MESSAGE_INIT,  '
  character(len=filename_length) :: mesfile
  !
  ! Should be called only once
  if (meslun.ne.0) then
    write(*,'(A,A)') failure_message,'Message file is already opened'
    error = .true.
    return
  endif
  !
  ! Build the name of the message file
  call sic_parse_file(mesname,'GAG_LOG:','.mes',mesfile)
  !
  ! Get rid of older versions
  status = sic_purge(mesfile,2)
  ml = lenc(mesfile)
  if (mod(status,2).eq.0) then
    write(*,'(A,A,A)') failure_message,'Error purging message file ',mesfile(1:ml)
    error = .true.
    return
  endif
  !
  ! Get lun
  status = sic_getlun(meslun)
  if (status.ne.1) then
    write(*,'(A,A,A)') failure_message,'Error getting LUN for ',mesfile(1:ml)
    error = .true.
    return
  endif
  !
  ! Open file
  if (gag_inquire(mesfile,ml).eq.0 .and. mes_log_append) then
    status = sic_open(meslun,mesfile,'APPEND',.false.)
  else
    status = sic_open(meslun,mesfile,'NEW',.false.)
  endif
  if (status.ne.0) then
    write(*,'(A,A,A)') failure_message,'Error opening message file ',mesfile(1:ml)
    call putios(failure_message,status)
    error = .true.
    return
  endif
  !
end subroutine gmessage_open
!
subroutine gmessage_flush(error)
  use gbl_message
  use gbl_message_private
  use gsys_interfaces, except_this=>gmessage_flush
  !---------------------------------------------------------------------
  ! @private
  ! Closes message file and reset its logical unit for a clean handling
  ! of very last messages.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error    ! Error flag
  ! Local
  character(len=*), parameter :: rname='MESSAGE_FLUSH'
  integer(kind=4) :: status
  !
  if (meslun.eq.0) return
  !
  status = sic_flush(meslun)
  if (status.ne.0) then
    error = .true.
    call gsys_message(seve%e,rname,'Error flushing message file '//  &
       'buffer onto disk')
    return
  endif
  !
end subroutine gmessage_flush
!
subroutine gmessage_close(error)
  use gbl_message
  use gbl_message_private
  use gsys_interfaces, except_this=>gmessage_close
  !---------------------------------------------------------------------
  ! @ public
  ! Closes message file and reset its logical unit for a clean handling
  ! of very last messages. Do not produce an error if no message file
  ! is opened.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error    ! Error flag
  ! Local
  character(len=*), parameter :: rname='MESSAGE_CLOSE'
  integer(kind=4) :: status
  character(len=18) :: failure_message='E-MESSAGE_CLOSE,  '
  !
  if (meslun.eq.0) return
  !
  call gsys_message(seve%t,rname,'Closing message file. Bye.')
  !
  ! Close file
  status = sic_close(meslun)
  if (status.ne.0) then
    write(*,'(A,A)') failure_message,'Error closing message file'
    error = .true.
    return
  endif
  !
  ! Free lun
  status = gag_frelun(meslun)
  if (status.ne.1) then
    write(*,'(A,A)') failure_message,'Error freeing LUN for message file'
    error = .true.
    return
  endif
  !
  ! Success, reset meslun
  meslun=0
  !
  call gsys_message(seve%d,rname,'Successfully closed message file')
  !
end subroutine gmessage_close
!
subroutine gmessage_write(id,mkind,procname,message)
  use gsys_interfaces, except_this=>gmessage_write
  use gpack_def
  use gbl_message
  use gbl_message_private
  use gbl_ansicodes
  !---------------------------------------------------------------------
  ! @ public
  ! Output procname and message, with severity kind "mkind", according
  ! to current messaging filters of input package.
  !  - input id is the identifier given to the package when it
  !    registered, or the one from another package if current package
  !    wants to appear as an other into the message file (e.g. 'gio'
  !    messages appear as 'sic' messages in message file).
  !  - mkind is an integer which should be set with the severity
  !    structure provided by gbl_message module.
  !  Although this routine is public, you should call it only once (with
  !  the 4 arguments) in your <packname>-message routine, and then call
  !  everywhere in your package your <packname>-message routine with
  !  3 arguments. Your package id should be known only in the
  ! <packname>-message routine.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: id        ! Package id
  integer(kind=4),  intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  ! Local
  character(len=*), parameter :: rname='GMESSAGE'
  logical :: error
  character(len=gpack_name_length) :: packname
  character(len=message_length) :: string_s  ! To screen
  character(len=30) :: prefix                ! e.g. "I-SIC,  "
  character(len=32) :: procname_u            ! Upcased. Length should be a parameter...
  character(len=20) :: datetime = ' '        !
  integer(kind=4) :: ckind,cid               ! Corrected kind and id
  integer(kind=4) :: nl                      ! Character lengths
  !
  ! Check input kind
  ckind = mkind
  if ( mkind.lt.1 .or. mkind.gt.nseve ) then
     write (string_s, *) 'Unknown message kind ',mkind
     call gsys_message(seve%w,rname,string_s)
     ckind = seve%u  ! Keep going on with kind "Unknown"
  endif
  !
  ! Check input id?
  cid = id
  !
  ! Check which filter applies: global or private?
  if (mes_gbl_rules) cid = gpack_global_id
  !
  ! Do nothing if verbosities are disabled by filters. Must be called ASAP
  if ( gmessage_isoff(cid,ckind) ) return
  !
  ! Find packname(id) (not cid) in mesfile, because even if we use
  ! global rules, we do not want 'global' to appear in mesfile:
  error = .false.
  call gpack_get_name(id,packname,error)
  if (error) then
     cid = gpack_global_id
     packname = gpack_global_name
  endif
  nl = max(7,lenc(packname))  ! 7 at least for a better alignment in mesfile
  !
  ! Format prefix
  if (mes_gbl_rules .and. id.ne.gpack_global_id) then
    !  In debug mode, add the package name to the subroutine prefix (debug
    ! mode uses global filtering rules)
    !  No point adding the "GLOBAL>" prefix, for messages owned by no
    ! declared package (this happens if libraries have no message owner,
    ! e.g. when executing tasks)
    procname_u = trim(packname)//'>'//procname
    call sic_upper(procname_u)
  else
    procname_u = procname
    call sic_upper(procname_u)
  endif
  prefix = seve_levels(ckind)//'-'//trim(procname_u)//','
  !
  ! To screen
  if ( message_rules(cid)%toscreen(ckind) ) then
    if (mes_gbl_colors.and.message_colors%enabled(ckind)) then
      if (ckind.eq.seve%r) then  ! Without prefix
        write(*,'(A,A,A)')  &
          message_colors%code(ckind)(1:message_colors%lcode(ckind)),  &
          trim(message),  &
          c_clear
      else                       ! With prefix
        write(*,'(A,A,2X,A,A)')  &
          message_colors%code(ckind)(1:message_colors%lcode(ckind)),  &
          trim(prefix),  &
          trim(message),  &
          c_clear
      endif
    else
      if (ckind.eq.seve%r) then  ! Without prefix
        write(*,'(A)') trim(message)
      else                       ! With prefix
        write(*,'(A,2X,A)') trim(prefix), trim(message)
      endif
    endif
  endif
  !
  ! To file ("meslun.ne.0" is useful at init time)
  if ( message_rules(cid)%tofile(ckind) .and. meslun.ne.0 ) then
    !
    ! Optionally add date
    if (mes_log_date) call sic_date(datetime)
    !
    write(meslun,'(A,1X,A,A,2X,A)')  &
      trim(datetime), packname(1:nl)//': ', trim(prefix), trim(message)
    !
  endif
  !
end subroutine gmessage_write
!
subroutine gmessage_write_in_mesfile(id,mkind,procname,message)
  use gsys_interfaces, except_this=>gmessage_write_in_mesfile
  use gpack_def
  use gbl_message
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public TEMPORARY FOR CLIC ONLY (SB, 02-jun-2008)
  ! Rewrite of gmessage_write. It writes to mesfile only and ignores
  ! filters.
  !---------------------------------------------------------------------
  ! Output procname and message, with severity kind "mkind", according
  ! to current messaging filters of input package.
  !  - input id is the identifier given to the package when it
  !    registered, or the one from another package if current package
  !    wants to appear as an other into the message file (e.g. 'gio'
  !    messages appear as 'sic' messages in message file).
  !  - mkind is an integer which should be set with the severity
  !    structure provided by gbl_message module.
  !  Although this routine is public, you should call it only once (with
  !  the 4 arguments) in your <packname>-message routine, and then call
  !  everywhere in your package your <packname>-message routine with
  !  3 arguments. Your package id should be known only in the
  ! <packname>-message routine.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: id        ! Package id
  integer(kind=4),  intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  ! Local
  logical :: error
  character(len=gpack_name_length) :: packname
  character(len=30) :: prefix                ! e.g. "I-SIC,  "
  character(len=25) :: procname_u            ! Upcased. Length should be a parameter...
  character(len=20) :: datetime = ' '        !
  integer(kind=4) :: ckind,cid               ! Corrected kind and id
  integer(kind=4) :: nl                      ! Character lengths
  !
  ! Check input kind
  ckind = mkind
  if ( mkind.lt.1 .or. mkind.gt.nseve ) then
     ckind = seve%u  ! Keep going on with kind "Unknown"
  endif
  !
  ! Check input id?
  cid = id
  !
  ! Check which filter applies: global or private?
  if (mes_gbl_rules) cid = gpack_global_id
  !
  ! Do nothing if verbosities are disabled by filters. Must be called ASAP
  ! if ( gmessage_isoff(cid,ckind) ) return
  if ( .not.message_rules(cid)%tofile(ckind) ) return
  !
  ! Find packname(id) (not cid) in mesfile, because even if we use
  ! global rules, we do not want 'global' to appear in mesfile:
  error = .false.
  call gpack_get_name(id,packname,error)
  if (error) then
     cid = gpack_global_id
     packname = gpack_global_name
  endif
  nl = max(7,lenc(packname))
  !
  ! Format prefix
  procname_u = procname
  call sic_upper(procname_u)
  prefix = seve_levels(ckind)//'-'//trim(procname_u)//','
  !
  ! To file ("meslun.ne.0" is useful at init time)
  if (meslun.ne.0 ) then
    !
    ! Optionally add date
    if (mes_log_date) call sic_date(datetime)
    !
    write(meslun,'(A,1X,A,A,2X,A)')  &
      trim(datetime), packname(1:nl)//': ', trim(prefix), trim(message)
    !
  endif
  !
end subroutine gmessage_write_in_mesfile
!
subroutine gag_message(mkind,procname,message)
  use gsys_interfaces, except_this=>gag_message
  use gpack_def
  !---------------------------------------------------------------------
  ! @ public (obsolete)
  ! Outputs procname and message, with severity kind "mkind", according
  ! to current GLOBAL messaging filters. mkind is an integer which
  ! should be set with the severity structure provided by gbl_message
  ! module.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(gpack_global_id,mkind,procname,message)
  !
end subroutine gag_message
!
function gmessage_isoff(id,mkind)
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ private
  ! Checks if the message sent to gmessage_write is intended to be
  ! printed to at least one of the outputs (screen or message file).
  ! Should be used if you want to skip string formatting (for example)
  ! in order to save CPU time.
  !---------------------------------------------------------------------
  logical :: gmessage_isoff
  integer(kind=4), intent(in) :: id     ! Package id
  integer(kind=4), intent(in) :: mkind  ! Message kind
  !
  ! id and mkind are corrected before calling gmessage_isoff. No
  ! duplicate checks in order to save time.
  gmessage_isoff = .not.( message_rules(id)%toscreen(mkind) .or. &
                          message_rules(id)%tofile(mkind) )
  !
end function gmessage_isoff
!
subroutine gmessage_use_gbl_rules(flag)
  use gsys_interfaces, except_this=>gmessage_use_gbl_rules
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Activates or deactivates use of global messaging filters instead of
  ! local (per package) ones.
  !---------------------------------------------------------------------
  logical, intent(in) :: flag  ! Activate if .true.
  !
  if (flag .and. .not.mes_gbl_rules) then
     call gsys_message(seve%d,"GMESSAGE","Turned ON global filtering rules")
  elseif (.not.flag .and. mes_gbl_rules) then
     call gsys_message(seve%d,"GMESSAGE","Turned OFF global filtering rules")
  endif
  !
  mes_gbl_rules = flag
  !
end subroutine gmessage_use_gbl_rules
!
subroutine gmessage_log_date(flag)
  use gsys_interfaces, except_this=>gmessage_log_date
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Activates or deactivates printing date-time in message file.
  !---------------------------------------------------------------------
  logical, intent(in) :: flag  ! Activate if .true.
  !
  if (flag .and. .not.mes_log_date) then
     call gsys_message(seve%d,"GMESSAGE","Turned ON printing date-time in logfile")
  elseif (.not.flag .and. mes_log_date) then
     call gsys_message(seve%d,"GMESSAGE","Turned OFF printing date-time in logfile")
  endif
  !
  mes_log_date = flag
  !
end subroutine gmessage_log_date
!
subroutine gmessage_gbl_filters_on(rule)
  use gsys_interfaces, except_this=>gmessage_gbl_filters_on
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ private
  ! Set Global filters and activate its use.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rule  ! Optional rule to alter filters
  ! Local
  logical :: error
  !
  if (rule.ne.' ') then
     error = .false.
     call gmessage_parse_and_set(gpack_global_id,rule,error)
  endif
  !
  mes_gbl_rules = .true.
  !
end subroutine gmessage_gbl_filters_on
!
subroutine gmessage_gbl_filters_off
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ private
  ! Deactivate use of Global filters
  !---------------------------------------------------------------------
  !
  mes_gbl_rules = .false.
  !
end subroutine gmessage_gbl_filters_off
!
subroutine gmessage_quiet
  use gsys_interfaces, except_this=>gmessage_quiet
  !---------------------------------------------------------------------
  ! @ public
  ! Ensure almost-quiet messaging mode to Screen.
  ! This is done by setting Global onscreen filter to FE------, and
  ! using Global filters.
  !---------------------------------------------------------------------
  !
  call gmessage_gbl_filters_on('s=fe')
  !
end subroutine gmessage_quiet
!
subroutine gmessage_standard
  use gsys_interfaces, except_this=>gmessage_standard
  !---------------------------------------------------------------------
  ! @ public
  ! Restore normal verbosity.
  ! This is done by stopping using Global filters.
  !---------------------------------------------------------------------
  !
  call gmessage_gbl_filters_off()
  !
end subroutine gmessage_standard
!
subroutine gmessage_verbose
  use gsys_interfaces, except_this=>gmessage_verbose
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Provide a maximal verbose messaging mode for Screen and Message
  ! file.
  ! This is done by turning on all the kind of messages, to both Screen
  ! and Message file.
  !---------------------------------------------------------------------
  !
  call gmessage_gbl_filters_on('a='//seve_allflags)
  !
end subroutine gmessage_verbose
!
#if defined(CYGWIN) || defined(MINGW)
! trick to deal between Windows and Cygwin in win-gsys.def
subroutine gbl_message_mp_seve
end subroutine gbl_message_mp_seve
#endif
!
subroutine gmessage_debug_swap
  use gsys_interfaces, except_this=>gmessage_debug_swap
  use gbl_message
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Provide a maximal verbose messaging mode for Screen and Message
  ! file.
  ! This is done by turning on all the kind of messages, to both Screen
  ! and Message file.
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='MESSAGE'
  !
  mes_use_debug = .not.mes_use_debug
  if (mes_use_debug) then
    call gsys_message(seve%r,rname,"Turning ON messages debug mode")
    call gmessage_verbose
  else
    call gsys_message(seve%r,rname,"Turning OFF messages debug mode")
    call gmessage_standard
  endif
  !
end subroutine gmessage_debug_swap
!
subroutine gmessage_print_colors(error)
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Show the current status of message colors
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SIC MESSAGE'
  integer(kind=4) :: iseve,icolor
  !
  if (mes_gbl_colors) then
    do iseve=1,nseve
      if (message_colors%enabled(iseve)) then
        write(*,'(2X,A1,A,A)')  seve_levels(iseve),  &
                                ' messages coloring is active using ',  &
                                message_colors%name(iseve)
      else
        write(*,'(2X,A1,A,A)')  seve_levels(iseve),  &
                                ' messages coloring is inactive'
      endif
    enddo
  else
    call gsys_message(seve%i,rname,'Coloring is disabled for all messages')
  endif
  !
  call gsys_message(seve%r,rname,'')
  call gsys_message(seve%i,rname,'Possible colors are:')
  do icolor=1,ncolors
    write(*,'(2X,A,T10,4A)')  colors%name(icolor),': ',            &
                              trim(colors%code(icolor)),           &
                              'abcd efgh ijkl mnop qrst uvwx yz',  &
                              c_clear
  enddo
  !
end subroutine gmessage_print_colors
!
subroutine gmessage_colors_swap(flag)
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Enable or disable the message coloring
  !---------------------------------------------------------------------
  logical, intent(in) :: flag
  mes_gbl_colors = flag
end subroutine gmessage_colors_swap
!
subroutine gmessage_colors_parse(argum,error)
  use gbl_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Parse argument for changing a message kind color
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: argum
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SIC MESSAGE'
  integer(kind=4) :: iseve,kseve,ikey
  character(len=7) :: key
  logical :: found
  !
  found = .false.
  do iseve=1,nseve
    if (argum(1:1).eq.seve_levels(iseve)) then
      found = .true.
      kseve = iseve
    endif
  enddo
  if (.not.found)  goto 10
  !
  if (argum(2:2).ne.'=')  goto 10
  !
  call sic_ambigs(rname,argum(3:),key,ikey,colors%name,ncolors,error)
  if (error)  return
  !
  message_colors%enabled(kseve) = key.ne.'NONE'
  message_colors%name(kseve)    = key
  message_colors%code(kseve)    = colors%code(ikey)
  message_colors%lcode(kseve)   = len_trim(colors%code(ikey))
  !
  return  ! Success
  !
10 continue
  call gsys_message(seve%e,rname,'Malformed argument '//argum)
  error = .true.
  return
  !
end subroutine gmessage_colors_parse

subroutine sub_major_lin(method,hdirty,hresid,hclean,   &
     &    hbeam,hprim,hmask,dcct,mask,list,error,        &
     &    major_plot, next_flux)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_major_lin
  use cct_types
  use clean_types
  use clean_support_tool
  use clean_flux_tool, only: init_plot
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the MRC (Multi Resolution CLEAN)
  !     which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  external :: major_plot
  external :: next_flux
  !
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: hdirty
  type (gildas), intent(inout) :: hbeam
  type (gildas), intent(inout) :: hclean
  type (gildas), intent(inout) :: hresid
  type (gildas), intent(in) :: hprim
  type (gildas), intent(in) :: hmask
  real, intent(inout) :: dcct(:,:,:) ! (3,hclean%gil%dim(3),*)
  logical, intent(in), target :: mask(:,:)
  integer, intent(in), target :: list(:)
  logical, intent(inout) ::  error
  !
  real, pointer :: dirty(:,:)  ! Dirty map
  real, pointer :: resid(:,:)  ! Iterated residual
  real, pointer :: clean(:,:)  ! Clean Map
  real, pointer :: d3prim(:,:,:)   ! Primary beam (for one frequency)
  real, pointer :: d3beam(:,:,:)   ! Dirty beam (for one frequency)
  real, pointer :: weight(:,:)     ! Mosaic weight
  !
  real, allocatable :: tfbeam(:,:,:)
  real, allocatable :: w_fft(:)    ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable :: w_cct(:,:)
  logical, allocatable :: s_mask(:,:)
  real, allocatable :: s_beam(:,:,:), t_beam(:,:), s_resi(:,:)
  integer, allocatable :: mymask(:,:)
  integer :: f_iter, m_iter
  !
  real, target :: dummy_prim(1,1,1), dummy_weight(1,1)
  integer iplane
  integer nx,ny,np,nl,mx,my,nc
  integer ip,ier,ix,iy,i,jcode
  real fhat, limit, flux
  logical do_fft
  character(len=message_length) :: chain
  character(len=12) :: cname 
  integer :: nplane
  !
  type (cct_par), allocatable :: tcc(:)
  !
  integer, pointer :: llist(:)
  logical, pointer :: lmask(:,:)
  !
  error = .false.
  do_fft = method%method.ne.'HOGBOM'
  cname = method%method
  !
  llist => list
  lmask => mask
  !
  ! Local variables
  nx = hclean%gil%dim(1)
  ny = hclean%gil%dim(2)
  mx = hbeam%gil%dim(1)
  my = hbeam%gil%dim(2)
  nl = method%nlist
  nc = nx*ny
  np = max(1,hprim%gil%dim(1)) ! or ! np = hbeam%gil%dim(3)
  !
  if (do_fft) then
    allocate(w_work(nx,ny),w_fft(2*max(nx,ny)),tfbeam(nx,ny,np),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,cname,'Memory allocation error for TFBEAM')
      error = .true.
      return
    endif
  else
    allocate(w_work(1,1),w_fft(1),tfbeam(1,1,1),stat=ier)  
  endif
  if (ier.ne.0) then
    call map_message(seve%e,cname,'FFT Memory allocation failure')
    error = .true.
    return
  endif
  !
  if (method%method.eq.'CLARK') then
    allocate(w_comp(nc), &
    & w_cct(1,1),mymask(1,1),s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  elseif  (method%method.eq.'SDI') then
    allocate(w_comp(nc),w_cct(nx,ny),mymask(nx,ny), &
    & s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  elseif  (method%method.eq.'MULTI') then
    allocate (s_mask(nx,ny),s_resi(nx,ny),t_beam(nx,ny), &
      & s_beam(nx,ny,3),w_cct(nx,ny),mymask(nx,ny), &
      & w_comp(1), stat=ier)
  else
    allocate(w_comp(1), &
    & w_cct(1,1),mymask(1,1),s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  endif
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Work Arrays Memory allocation failure')
    error = .true.
    return
  endif
  !
  ! Clean component work array
  allocate(tcc(method%m_iter),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Memory allocation error for TCC')
    error = .true.
    return
  endif
  !
  nplane = method%last-method%first+1
  !
  ! Global aliases
  if (method%mosaic) then
    d3prim => dummy_prim
  else
    d3prim => dummy_prim
    weight => dummy_weight
  endif
  !
  cname = method%method
  !
  do iplane = method%first, method%last
    !
    method%iplane = iplane
    call beam_plane(method,hbeam,hdirty)
    ! Get the new mask (if any...)
    call get_maskplane(method,hmask,hdirty,lmask,llist)    
    nl = method%nlist
    !
    ! Local aliases
    if (method%imask.ge.1) then
      write(chain,'(A,I6,I6,I6,A,I2)') 'Image, Beam & Mask planes ',   &
          &      method%iplane,method%ibeam,method%imask
    else
      write(chain,'(A,I6,I6,A,I2)') 'Image & Beam planes ',   &
          &      method%iplane,method%ibeam
    endif
    call map_message(seve%i,cname,chain)
    dirty => hdirty%r3d(:,:,iplane)
    resid => hresid%r3d(:,:,iplane)
    clean => hclean%r3d(:,:,iplane)
    d3beam => hbeam%r4d(:,:,:,method%ibeam)
    if (method%mosaic) d3prim => hprim%r4d(:,:,:,method%ibeam)
    !
    ! Initialize to Dirty map
    resid = dirty
    if (method%pcycle) call init_plot (method,hdirty,resid)
    !
    ! Prepare beam parameters - subroutine is not Thread safe though...
    call method%fit_beam(hbeam,d3beam,error)
    if (error) then
      !return !Oops, cannot do that in a DO parallel...
      cycle
    endif
    call get_beam (method,hbeam,hresid,hprim,   &
        &        tfbeam,w_work,w_fft,fhat,error, lmask)
    ! Empty beam case
    if (error) then
      error = .false.
      clean = resid
      !return !Oops, cannot do that in a DO parallel...
      cycle
    endif
    !
    ! Mosaic case
    if (method%mosaic) then
      ! Reset search list as the mask may have been altered
      call lmask_to_list (lmask,nx*ny,llist,method%nlist)
      weight=> method%weight(:,:,method%ibeam)
      resid = resid * weight
    endif
    !
    !
    ! Performs decomposition into components
    select case (method%method)
    case('HOGBOM')
      call hogbom_cycle (cname,method%pflux,   &   ! Plot flux
           &        d3beam,mx,my,   & ! Beam and size
           &        resid,nx,ny,   & ! Residual and size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%box, method%fres, method%ares,   &
           &        method%m_iter,  method%p_iter, method%n_iter,   &
           &        method%gain, method%keep,   &    !
           &        tcc,   &         ! Component Structure
           &        lmask,   & ! Search mask
           &        llist,   & ! Search list
           &        nl,   &          ! and its size
           &        np,   &          ! Number of fields
           &        d3prim,   &       ! Primary beams
           &        weight,   &      ! Weight
           &        method%trunca, flux, jcode, next_flux)
    case('CLARK')
      !
      ! Find components
      call major_cycle (cname,method,hclean,   &   !
           &        clean,   &       ! Final CLEAN image
           &        d3beam,   &       ! Dirty beams
           &        resid,nx,ny,   & ! Residual and size
           &        tfbeam, w_work,   &  ! FT of dirty beam + Work area
           &        w_comp, nc,       &  ! Component storage + Size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%patch(1), method%patch(2), method%bgain,   &
           &        method%box,   &
           &        w_fft,   &       ! Work space for FFTs
           &        tcc,   &         ! Component table
           &        llist, nl,   &   ! Search list (truncated...)
           &        np,                & ! Number of fields
           &        d3prim,            & ! Primary beams
           &        weight,            & ! Weight
           &        major_plot,        & ! Plotting routine
           &        next_flux)
    case('SDI')
      !
      ! Find components
      call major_sdi (cname,method,hclean,   &
           &        clean,   &       ! Final CLEAN image
           &        d3beam(:,:,method%ibeam),   & ! Dirty beams
           &        resid,nx,ny,   & ! Residual and size
           &        tfbeam, w_work,   &  ! FT of dirty beam + Work area
           &        w_comp, nc,       &  ! Component storage + Size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%patch(1), method%patch(2), method%bgain,   &
           &        method%box,   &
           &        w_fft,   &       ! Work space for FFTs
           &        w_cct,   &       ! Clean Component Image
           &        llist, nl,   &   ! Search list (truncated...)
           &        np,                & ! Number of fields
           &        d3prim,            & ! Primary beams
           &        weight,            & ! Weight
           &        major_plot)          ! Plotting routine
    case('MULTI')
      !
      ! Performs decomposition into components
      call amaxmask (resid,lmask,nx,ny,ix,iy)
      limit = max(method%ares,method%fres*abs(resid(ix,iy)))
      call map_message(seve%i,method%method,chain)
      if (limit.eq.method%ares) then
        write (chain,'(A,1PG10.3,A)')  'Cleaning down to ',limit,' from ARES'
      else
        write (chain,'(A,1PG10.3,A,I7,I7)')  'Cleaning down to ',limit,' from FRES at ',ix,iy
      endif
      call map_message(seve%i,cname,chain)
      !
      call major_multi (cname,method,hclean,   &
           &        hdirty%r3d(:,:,iplane),   &
           &        hresid%r3d(:,:,iplane),   &
           &        hbeam%r4d(:,:,:,method%ibeam),                  &
           &        lmask,              & ! Check definition of this mask...
           &        hclean%r3d(:,:,iplane),   &
           &        nx,ny,                    &
           &        tcc,   &         ! Clean component
           &        method%m_iter,   &   ! Maximum number of components
           &        limit,   &       ! Residual
           &        method%n_iter,   &   ! Number of components
           &        s_mask,   &      ! Smoothed mask
           &        s_resi,   &      ! Smoothed residual,
           &        t_beam,   &      ! Translated beam
           &        w_work,   &      ! Complex work space
           &        s_beam,   &      ! Smoothed beams
           &        tfbeam,   &      ! Beam Fourier Transform (real)
           &        w_fft)
    ! Need to add
    !             &        np,   &          ! Number of fields
    !             &        d3prim,   &      ! Primary beams
    !             &        weight)          ! Weight
      w_cct(:,:) = clean
    end select
    !
    ! Add clean components and residuals to produce clean map
    if (method%n_iter.ne.0) then
      call clean_make (method, hclean, clean, tcc)
      if (np.le.1) then
        clean = clean + resid
      else
        clean = clean + resid*weight
        where (weight.eq.0) clean = hclean%gil%bval ! Undefined pixel there
      endif
    else
      if (np.le.1) then
        clean = resid
      else
        clean = resid*weight
      endif
    endif
    !
    ! Put the TCC structure into its final place
    if (method%method.eq.'MULTI' .or. method%method.eq.'SDI') then
      if (method%method.eq.'MULTI') then
        m_iter = method%ninflate*method%m_iter
      else
        m_iter = method%m_iter
      endif
      where (w_cct.ne.0)
        mymask = 1
      elsewhere
        mymask = 0
      end where
      f_iter = sum(mymask)
      if (f_iter.gt.m_iter) then
        write(chain,'(A,I8,A,I8)') 'Iterations overflow ',f_iter, &
            &  ' > ',m_iter
        call map_message(seve%w,cname,chain)
        dcct(3,iplane,1) = 0
        chain = 'UV_RESTORE will not work, consider increasing INFLATE'
        call map_message(seve%i,cname,chain)
      else
        i = 0
        flux = 0
        do iy=1,ny
          do ix=1,nx
            if (w_cct(ix,iy).ne.0) then
              i = i+1
              dcct(1,iplane,i) = (dble(ix) -   &
               & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
               & hclean%gil%convert(2,1)
              dcct(2,iplane,i) = (dble(iy) -   &
               & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
               & hclean%gil%convert(2,2)
              dcct(3,iplane,i) = w_cct(ix,iy)
              flux = flux+w_cct(ix,iy)
            endif
          enddo
        enddo
        method%n_iter = i
        write (chain,'(A,1PG10.3,A,I6,A,A,I6,A,I2)')  'Cleaned ',flux,   &
            &        ' Jy with ',method%n_iter,' components ' &
            &       ,' Plane ',iplane
        call map_message(seve%i,cname,chain)
      endif
    else if (method%method.ne.'MRC') then
      do i=1,method%n_iter
        dcct(1,iplane,i) = (dble(tcc(i)%ix) -   &
            & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
            & hclean%gil%convert(2,1)
        dcct(2,iplane,i) = (dble(tcc(i)%iy) -   &
            & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
            & hclean%gil%convert(2,2)
        dcct(3,iplane,i) = tcc(i)%value
      enddo
      if (method%n_iter.lt.method%m_iter) then
        dcct(3,iplane,method%n_iter+1) = 0
      endif
      if (method%method.eq.'HOGBOM') then
        write (chain,'(A,1PG10.3,A,I6,A,A,I6,A,I2)')  'Cleaned ',flux,   &
          &        ' Jy with ',method%n_iter,' components ' &
          &       ,' Plane ',iplane
        call map_message(seve%i,cname,chain)
      endif
      !
    endif
  enddo
  !
  ! PHAT
  if (method%phat.ne.0) then
    fhat = 1.0/fhat
    if (method%mosaic) then
      d3beam = d3beam*fhat
      do ip=1,np
        d3beam(method%beam0(1),method%beam0(2),ip) =   &
            &          d3beam(method%beam0(1),method%beam0(2),ip) -   &
            &          method%phat
      enddo
    else
      d3beam = d3beam*fhat
    endif
  endif
  !
  ! Set the blanking value for Mosaics
  if (method%mosaic) then
    hclean%gil%eval = 0
  endif
  !
  ! Clean work space: in principle, Fortran 95 does it for you
  if (method%method.eq.'CLARK') then
    deallocate(w_comp,stat=ier)
  elseif  (method%method.eq.'SDI') then
    deallocate(w_comp,w_cct,mymask)
  elseif  (method%method.eq.'MULTI') then
    deallocate (s_mask,s_resi,t_beam,s_beam,w_cct,mymask)
  endif
  if (do_fft) then
    deallocate(w_work,w_fft)
  endif
  !
end subroutine sub_major_lin

*DECK OHTROL
      SUBROUTINE OHTROL (Q, N, NRDA, DIAG, IRANK, DIV, TD)
C***BEGIN PROLOGUE  OHTROL
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (OHTROL-S, DOHTRL-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     For a rank deficient problem, additional orthogonal
C     HOUSEHOLDER transformations are applied to the left side
C     of Q to further reduce the triangular form.
C     Thus, after application of the routines ORTHOR and OHTROL
C     to the original matrix, the result is a nonsingular
C     triangular matrix while the remainder of the matrix
C     has been zeroed out.
C
C***SEE ALSO  BVSUP
C***ROUTINES CALLED  SDOT
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  OHTROL
      DIMENSION Q(NRDA,*),DIAG(*),DIV(*),TD(*)
C***FIRST EXECUTABLE STATEMENT  OHTROL
      NMIR=N-IRANK
      IRP=IRANK+1
      DO 30 K=1,IRANK
         KIR=IRP-K
         DIAGK=DIAG(KIR)
         SIG=(DIAGK*DIAGK)+SDOT(NMIR,Q(IRP,KIR),1,Q(IRP,KIR),1)
         DD=SIGN(SQRT(SIG),-DIAGK)
         DIV(KIR)=DD
         TDV=DIAGK-DD
         TD(KIR)=TDV
         IF (K .EQ. IRANK) GO TO 30
         KIRM=KIR-1
         SQD=DD*DIAGK-SIG
         DO 20 J=1,KIRM
            QS=((TDV*Q(KIR,J))+SDOT(NMIR,Q(IRP,J),1,Q(IRP,KIR),1))
     1               /SQD
            Q(KIR,J)=Q(KIR,J)+QS*TDV
            DO 10 L=IRP,N
   10          Q(L,J)=Q(L,J)+QS*Q(L,KIR)
   20    CONTINUE
   30 CONTINUE
      RETURN
      END
*DECK OHTROR
      SUBROUTINE OHTROR (Q, N, NRDA, DIAG, IRANK, DIV, TD)
C***BEGIN PROLOGUE  OHTROR
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (OHTROR-S)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     For a rank deficient problem, additional orthogonal
C     HOUSEHOLDER transformations are applied to the right side
C     of Q to further reduce the triangular form.
C     Thus, after application of the routines ORTHOL and OHTROR
C     to the original matrix, the result is a nonsingular
C     triangular matrix while the remainder of the matrix
C     has been zeroed out.
C
C***SEE ALSO  BVSUP
C***ROUTINES CALLED  SDOT
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  OHTROR
      DIMENSION Q(NRDA,*),DIAG(*),DIV(*),TD(*)
C***FIRST EXECUTABLE STATEMENT  OHTROR
      NMIR=N-IRANK
      IRP=IRANK+1
      DO 30 K=1,IRANK
         KIR=IRP-K
         DIAGK=DIAG(KIR)
         SIG=(DIAGK*DIAGK)+SDOT(NMIR,Q(KIR,IRP),NRDA,Q(KIR,IRP),NRDA)
         DD=SIGN(SQRT(SIG),-DIAGK)
         DIV(KIR)=DD
         TDV=DIAGK-DD
         TD(KIR)=TDV
         IF (K .EQ. IRANK) GO TO 30
         KIRM=KIR-1
         SQD=DD*DIAGK-SIG
         DO 20 J=1,KIRM
            QS=((TDV*Q(J,KIR))+SDOT(NMIR,Q(J,IRP),NRDA,Q(KIR,IRP),NRDA))
     1               /SQD
            Q(J,KIR)=Q(J,KIR)+QS*TDV
            DO 10 L=IRP,N
   10          Q(J,L)=Q(J,L)+QS*Q(KIR,L)
   20    CONTINUE
   30 CONTINUE
      RETURN
      END
*DECK ORTBAK
      SUBROUTINE ORTBAK (NM, LOW, IGH, A, ORT, M, Z)
C***BEGIN PROLOGUE  ORTBAK
C***PURPOSE  Form the eigenvectors of a general real matrix from the
C            eigenvectors of the upper Hessenberg matrix output from
C            ORTHES.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      SINGLE PRECISION (ORTBAK-S, CORTB-C)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure ORTBAK,
C     NUM. MATH. 12, 349-368(1968) by Martin and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 339-358(1971).
C
C     This subroutine forms the eigenvectors of a REAL GENERAL
C     matrix by back transforming those of the corresponding
C     upper Hessenberg matrix determined by  ORTHES.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        LOW and IGH are two INTEGER variables determined by the
C          balancing subroutine  BALANC.  If  BALANC  has not been
C          used, set LOW=1 and IGH equal to the order of the matrix.
C
C        A contains some information about the orthogonal trans-
C          formations used in the reduction to Hessenberg form by
C          ORTHES  in its strict lower triangle.  A is a two-dimensional
C          REAL array, dimensioned A(NM,IGH).
C
C        ORT contains further information about the orthogonal trans-
C          formations used in the reduction by  ORTHES.  Only elements
C          LOW through IGH are used.  ORT is a one-dimensional REAL
C          array, dimensioned ORT(IGH).
C
C        M is the number of columns of Z to be back transformed.
C          M is an INTEGER variable.
C
C        Z contains the real and imaginary parts of the eigenvectors to
C          be back transformed in its first M columns.  Z is a two-
C          dimensional REAL array, dimensioned Z(NM,M).
C
C     On OUTPUT
C
C        Z contains the real and imaginary parts of the transformed
C          eigenvectors in its first M columns.
C
C        ORT has been used for temporary storage as is not restored.
C
C     NOTE that ORTBAK preserves vector Euclidean norms.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ORTBAK
C
      INTEGER I,J,M,LA,MM,MP,NM,IGH,KP1,LOW,MP1
      REAL A(NM,*),ORT(*),Z(NM,*)
      REAL G
C
C***FIRST EXECUTABLE STATEMENT  ORTBAK
      IF (M .EQ. 0) GO TO 200
      LA = IGH - 1
      KP1 = LOW + 1
      IF (LA .LT. KP1) GO TO 200
C     .......... FOR MP=IGH-1 STEP -1 UNTIL LOW+1 DO -- ..........
      DO 140 MM = KP1, LA
         MP = LOW + IGH - MM
         IF (A(MP,MP-1) .EQ. 0.0E0) GO TO 140
         MP1 = MP + 1
C
         DO 100 I = MP1, IGH
  100    ORT(I) = A(I,MP-1)
C
         DO 130 J = 1, M
            G = 0.0E0
C
            DO 110 I = MP, IGH
  110       G = G + ORT(I) * Z(I,J)
C     .......... DIVISOR BELOW IS NEGATIVE OF H FORMED IN ORTHES.
C                DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            G = (G / ORT(MP)) / A(MP,MP-1)
C
            DO 120 I = MP, IGH
  120       Z(I,J) = Z(I,J) + G * ORT(I)
C
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END
*DECK ORTHES
      SUBROUTINE ORTHES (NM, N, LOW, IGH, A, ORT)
C***BEGIN PROLOGUE  ORTHES
C***PURPOSE  Reduce a real general matrix to upper Hessenberg form
C            using orthogonal similarity transformations.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1B2
C***TYPE      SINGLE PRECISION (ORTHES-S, CORTH-C)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure ORTHES,
C     NUM. MATH. 12, 349-368(1968) by Martin and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 339-358(1971).
C
C     Given a REAL GENERAL matrix, this subroutine
C     reduces a submatrix situated in rows and columns
C     LOW through IGH to upper Hessenberg form by
C     orthogonal similarity transformations.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, A, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        LOW and IGH are two INTEGER variables determined by the
C          balancing subroutine  BALANC.  If  BALANC  has not been
C          used, set LOW=1 and IGH equal to the order of the matrix, N.
C
C        A contains the general matrix to be reduced to upper
C          Hessenberg form.  A is a two-dimensional REAL array,
C          dimensioned A(NM,N).
C
C     On OUTPUT
C
C        A contains the upper Hessenberg matrix.  Some information about
C          the orthogonal transformations used in the reduction
C          is stored in the remaining triangle under the Hessenberg
C          matrix.
C
C        ORT contains further information about the orthogonal trans-
C          formations used in the reduction.  Only elements LOW+1
C          through IGH are used.  ORT is a one-dimensional REAL array,
C          dimensioned ORT(IGH).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ORTHES
C
      INTEGER I,J,M,N,II,JJ,LA,MP,NM,IGH,KP1,LOW
      REAL A(NM,*),ORT(*)
      REAL F,G,H,SCALE
C
C***FIRST EXECUTABLE STATEMENT  ORTHES
      LA = IGH - 1
      KP1 = LOW + 1
      IF (LA .LT. KP1) GO TO 200
C
      DO 180 M = KP1, LA
         H = 0.0E0
         ORT(M) = 0.0E0
         SCALE = 0.0E0
C     .......... SCALE COLUMN (ALGOL TOL THEN NOT NEEDED) ..........
         DO 90 I = M, IGH
   90    SCALE = SCALE + ABS(A(I,M-1))
C
         IF (SCALE .EQ. 0.0E0) GO TO 180
         MP = M + IGH
C     .......... FOR I=IGH STEP -1 UNTIL M DO -- ..........
         DO 100 II = M, IGH
            I = MP - II
            ORT(I) = A(I,M-1) / SCALE
            H = H + ORT(I) * ORT(I)
  100    CONTINUE
C
         G = -SIGN(SQRT(H),ORT(M))
         H = H - ORT(M) * G
         ORT(M) = ORT(M) - G
C     .......... FORM (I-(U*UT)/H) * A ..........
         DO 130 J = M, N
            F = 0.0E0
C     .......... FOR I=IGH STEP -1 UNTIL M DO -- ..........
            DO 110 II = M, IGH
               I = MP - II
               F = F + ORT(I) * A(I,J)
  110       CONTINUE
C
            F = F / H
C
            DO 120 I = M, IGH
  120       A(I,J) = A(I,J) - F * ORT(I)
C
  130    CONTINUE
C     .......... FORM (I-(U*UT)/H)*A*(I-(U*UT)/H) ..........
         DO 160 I = 1, IGH
            F = 0.0E0
C     .......... FOR J=IGH STEP -1 UNTIL M DO -- ..........
            DO 140 JJ = M, IGH
               J = MP - JJ
               F = F + ORT(J) * A(I,J)
  140       CONTINUE
C
            F = F / H
C
            DO 150 J = M, IGH
  150       A(I,J) = A(I,J) - F * ORT(J)
C
  160    CONTINUE
C
         ORT(M) = SCALE * ORT(M)
         A(M,M-1) = SCALE * G
  180 CONTINUE
C
  200 RETURN
      END
*DECK ORTHO4
      SUBROUTINE ORTHO4 (USOL, IDMN, ZN, ZM, PERTRB)
C***BEGIN PROLOGUE  ORTHO4
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPX4
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (ORTHO4-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine orthogonalizes the array USOL with respect to
C     the constant array in a weighted least squares norm.
C
C***SEE ALSO  SEPX4
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    SPL4
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  ORTHO4
C
      COMMON /SPL4/   KSWX       ,KSWY       ,K          ,L          ,
     1                AIT        ,BIT        ,CIT        ,DIT        ,
     2                MIT        ,NIT        ,IS         ,MS         ,
     3                JS         ,NS         ,DLX        ,DLY        ,
     4                TDLX3      ,TDLY3      ,DLX4       ,DLY4
      DIMENSION       USOL(IDMN,*)           ,ZN(*)      ,ZM(*)
C***FIRST EXECUTABLE STATEMENT  ORTHO4
      ISTR = IS
      IFNL = MS
      JSTR = JS
      JFNL = NS
C
C     COMPUTE WEIGHTED INNER PRODUCTS
C
      UTE = 0.0
      ETE = 0.0
      DO  20 I=IS,MS
         II = I-IS+1
         DO  10 J=JS,NS
            JJ = J-JS+1
            ETE = ETE+ZM(II)*ZN(JJ)
            UTE = UTE+USOL(I,J)*ZM(II)*ZN(JJ)
   10    CONTINUE
   20 CONTINUE
C
C     SET PERTURBATION PARAMETER
C
      PERTRB = UTE/ETE
C
C     SUBTRACT OFF CONSTANT PERTRB
C
      DO  40 I=ISTR,IFNL
         DO  30 J=JSTR,JFNL
            USOL(I,J) = USOL(I,J)-PERTRB
   30    CONTINUE
   40 CONTINUE
      RETURN
      END
*DECK ORTHOG
      SUBROUTINE ORTHOG (USOL, IDMN, ZN, ZM, PERTRB)
C***BEGIN PROLOGUE  ORTHOG
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPELI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (ORTHOG-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine orthogonalizes the array USOL with respect to
C     the constant array in a weighted least squares norm.
C
C***SEE ALSO  SEPELI
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    SPLPCM
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  ORTHOG
C
      COMMON /SPLPCM/ KSWX       ,KSWY       ,K          ,L          ,
     1                AIT        ,BIT        ,CIT        ,DIT        ,
     2                MIT        ,NIT        ,IS         ,MS         ,
     3                JS         ,NS         ,DLX        ,DLY        ,
     4                TDLX3      ,TDLY3      ,DLX4       ,DLY4
      DIMENSION       USOL(IDMN,*)           ,ZN(*)      ,ZM(*)
C***FIRST EXECUTABLE STATEMENT  ORTHOG
      ISTR = IS
      IFNL = MS
      JSTR = JS
      JFNL = NS
C
C     COMPUTE WEIGHTED INNER PRODUCTS
C
      UTE = 0.0
      ETE = 0.0
      DO  20 I=IS,MS
         II = I-IS+1
         DO  10 J=JS,NS
            JJ = J-JS+1
            ETE = ETE+ZM(II)*ZN(JJ)
            UTE = UTE+USOL(I,J)*ZM(II)*ZN(JJ)
   10    CONTINUE
   20 CONTINUE
C
C     SET PERTURBATION PARAMETER
C
      PERTRB = UTE/ETE
C
C     SUBTRACT OFF CONSTANT PERTRB
C
      DO  40 I=ISTR,IFNL
         DO  30 J=JSTR,JFNL
            USOL(I,J) = USOL(I,J)-PERTRB
   30    CONTINUE
   40 CONTINUE
      RETURN
      END
*DECK ORTHOL
      SUBROUTINE ORTHOL (A, M, N, NRDA, IFLAG, IRANK, ISCALE, DIAG,
     +   KPIVOT, SCALES, COLS, CS)
C***BEGIN PROLOGUE  ORTHOL
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (ORTHOL-S)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   Reduction of the matrix A to upper triangular form by a sequence of
C   orthogonal HOUSEHOLDER transformations pre-multiplying A
C
C   Modeled after the ALGOL codes in the articles in the REFERENCES
C   section.
C
C **********************************************************************
C   INPUT
C **********************************************************************
C
C     A -- Contains the matrix to be decomposed, must be dimensioned
C           NRDA by N
C     M -- Number of rows in the matrix, M greater or equal to N
C     N -- Number of columns in the matrix, N greater or equal to 1
C     IFLAG -- Indicates the uncertainty in the matrix data
C             = 0 when the data is to be treated as exact
C             =-K when the data is assumed to be accurate to about
C                 K digits
C     ISCALE -- Scaling indicator
C               =-1 if the matrix A is to be pre-scaled by
C               columns when appropriate.
C               Otherwise no scaling will be attempted
C     NRDA -- Row dimension of A, NRDA greater or equal to M
C     DIAG,KPIVOT,COLS -- Arrays of length at least n used internally
C         ,CS,SCALES
C
C **********************************************************************
C   OUTPUT
C **********************************************************************
C
C     IFLAG - Status indicator
C            =1 for successful decomposition
C            =2 if improper input is detected
C            =3 if rank of the matrix is less than N
C     A -- Contains the reduced matrix in the strictly upper triangular
C          part and transformation information in the lower part
C     IRANK -- Contains the numerically determined matrix rank
C     DIAG -- Contains the diagonal elements of the reduced
C             triangular matrix
C     KPIVOT -- Contains the pivotal information, the column
C               interchanges performed on the original matrix are
C               recorded here.
C     SCALES -- Contains the column scaling parameters
C
C **********************************************************************
C
C***SEE ALSO  BVSUP
C***REFERENCES  G. Golub, Numerical methods for solving linear least
C                 squares problems, Numerische Mathematik 7, (1965),
C                 pp. 206-216.
C               P. Businger and G. Golub, Linear least squares
C                 solutions by Householder transformations, Numerische
C                 Mathematik  7, (1965), pp. 269-276.
C***ROUTINES CALLED  CSCALE, R1MACH, SDOT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900402  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ORTHOL
      DIMENSION A(NRDA,*),DIAG(*),KPIVOT(*),COLS(*),CS(*),SCALES(*)
C
C **********************************************************************
C
C     MACHINE PRECISION (COMPUTER UNIT ROUNDOFF VALUE) IS DEFINED
C     BY THE FUNCTION R1MACH.
C
C***FIRST EXECUTABLE STATEMENT  ORTHOL
      URO = R1MACH(3)
C
C **********************************************************************
C
      IF (M .GE. N  .AND.  N .GE. 1  .AND.  NRDA .GE. M) GO TO 1
      IFLAG=2
      CALL XERMSG ('SLATEC', 'ORTHOL', 'INVALID INPUT PARAMETERS.', 2,
     +   1)
      RETURN
C
    1 ACC=10.*URO
      IF (IFLAG .LT. 0) ACC=MAX(ACC,10.**IFLAG)
      SRURO=SQRT(URO)
      IFLAG=1
      IRANK=N
C
C     COMPUTE NORM**2 OF JTH COLUMN AND A MATRIX NORM
C
      ANORM=0.
      DO 2 J=1,N
         KPIVOT(J)=J
         COLS(J)=SDOT(M,A(1,J),1,A(1,J),1)
         CS(J)=COLS(J)
         ANORM=ANORM+COLS(J)
    2 CONTINUE
C
C     PERFORM COLUMN SCALING ON A WHEN SPECIFIED
C
      CALL CSCALE(A,NRDA,M,N,COLS,CS,DUM,DUM,ANORM,SCALES,ISCALE,0)
C
      ANORM=SQRT(ANORM)
C
C
C     CONSTRUCTION OF UPPER TRIANGULAR MATRIX AND RECORDING OF
C     ORTHOGONAL TRANSFORMATIONS
C
C
      DO 50 K=1,N
         MK=M-K+1
         IF (K .EQ. N) GO TO 25
         KP=K+1
C
C        SEARCHING FOR PIVOTAL COLUMN
C
         DO 10 J=K,N
            IF (COLS(J) .GE. SRURO*CS(J)) GO TO 5
            COLS(J)=SDOT(MK,A(K,J),1,A(K,J),1)
            CS(J)=COLS(J)
    5       IF (J .EQ. K) GO TO 7
            IF (SIGMA .GE. 0.99*COLS(J)) GO TO 10
    7       SIGMA=COLS(J)
            JCOL=J
   10    CONTINUE
         IF (JCOL .EQ. K) GO TO 25
C
C        PERFORM COLUMN INTERCHANGE
C
         L=KPIVOT(K)
         KPIVOT(K)=KPIVOT(JCOL)
         KPIVOT(JCOL)=L
         COLS(JCOL)=COLS(K)
         COLS(K)=SIGMA
         CSS=CS(K)
         CS(K)=CS(JCOL)
         CS(JCOL)=CSS
         SC=SCALES(K)
         SCALES(K)=SCALES(JCOL)
         SCALES(JCOL)=SC
         DO 20 L=1,M
            ASAVE=A(L,K)
            A(L,K)=A(L,JCOL)
   20       A(L,JCOL)=ASAVE
C
C        CHECK RANK OF THE MATRIX
C
   25    SIG=SDOT(MK,A(K,K),1,A(K,K),1)
         DIAGK=SQRT(SIG)
         IF (DIAGK .GT. ACC*ANORM) GO TO 30
C
C        RANK DEFICIENT PROBLEM
         IFLAG=3
         IRANK=K-1
         CALL XERMSG ('SLATEC', 'ORTHOL',
     +      'RANK OF MATRIX IS LESS THAN THE NUMBER OF COLUMNS.', 1, 1)
         RETURN
C
C        CONSTRUCT AND APPLY TRANSFORMATION TO MATRIX A
C
   30    AKK=A(K,K)
         IF (AKK .GT. 0.) DIAGK=-DIAGK
         DIAG(K)=DIAGK
         A(K,K)=AKK-DIAGK
         IF (K .EQ. N) GO TO 50
         SAD=DIAGK*AKK-SIG
         DO 40 J=KP,N
            AS=SDOT(MK,A(K,K),1,A(K,J),1)/SAD
            DO 35 L=K,M
   35          A(L,J)=A(L,J)+AS*A(L,K)
   40       COLS(J)=COLS(J)-A(K,J)**2
   50 CONTINUE
C
C
      RETURN
      END
*DECK ORTHOR
      SUBROUTINE ORTHOR (A, N, M, NRDA, IFLAG, IRANK, ISCALE, DIAG,
     +   KPIVOT, SCALES, ROWS, RS)
C***BEGIN PROLOGUE  ORTHOR
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (ORTHOR-S, DORTHR-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   Reduction of the matrix A to lower triangular form by a sequence of
C   orthogonal HOUSEHOLDER transformations post-multiplying A
C
C   Modeled after the ALGOL codes in the articles in the REFERENCES
C   section.
C
C **********************************************************************
C   INPUT
C **********************************************************************
C
C     A -- Contains the matrix to be decomposed, must be dimensioned
C           NRDA by N
C     N -- Number of rows in the matrix, N greater or equal to 1
C     M -- Number of columns in the matrix, M greater or equal to N
C     IFLAG -- Indicates the uncertainty in the matrix data
C             = 0 when the data is to be treated as exact
C             =-K when the data is assumed to be accurate to about
C                 K digits
C     ISCALE -- Scaling indicator
C               =-1 if the matrix is to be pre-scaled by
C               columns when appropriate.
C               Otherwise no scaling will be attempted
C     NRDA -- Row dimension of A, NRDA greater or equal to N
C     DIAG,KPIVOT,ROWS -- Arrays of length at least N used internally
C         ,RS,SCALES         (except for SCALES which is M)
C
C **********************************************************************
C   OUTPUT
C **********************************************************************
C
C     IFLAG - status indicator
C            =1 for successful decomposition
C            =2 if improper input is detected
C            =3 if rank of the matrix is less than N
C     A -- contains the reduced matrix in the strictly lower triangular
C          part and transformation information
C     IRANK -- contains the numerically determined matrix rank
C     DIAG -- contains the diagonal elements of the reduced
C             triangular matrix
C     KPIVOT -- Contains the pivotal information, the column
C               interchanges performed on the original matrix are
C               recorded here.
C     SCALES -- contains the column scaling parameters
C
C **********************************************************************
C
C***SEE ALSO  BVSUP
C***REFERENCES  G. Golub, Numerical methods for solving linear least
C                 squares problems, Numerische Mathematik 7, (1965),
C                 pp. 206-216.
C               P. Businger and G. Golub, Linear least squares
C                 solutions by Householder transformations, Numerische
C                 Mathematik  7, (1965), pp. 269-276.
C***ROUTINES CALLED  CSCALE, R1MACH, SDOT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ORTHOR
      DIMENSION A(NRDA,*),DIAG(*),KPIVOT(*),ROWS(*),RS(*),SCALES(*)
C
C END OF ABSTRACT
C
C **********************************************************************
C
C     MACHINE PRECISION (COMPUTER UNIT ROUNDOFF VALUE) IS DEFINED
C     BY THE FUNCTION R1MACH.
C
C **********************************************************************
C
C***FIRST EXECUTABLE STATEMENT  ORTHOR
      URO = R1MACH(4)
      IF (M .GE. N  .AND.  N .GE. 1  .AND.  NRDA .GE. N) GO TO 1
      IFLAG=2
      CALL XERMSG ('SLATEC', 'ORTHOR', 'INVALID INPUT PARAMETERS.', 2,
     +   1)
      RETURN
C
    1 ACC=10.*URO
      IF (IFLAG .LT. 0) ACC=MAX(ACC,10.**IFLAG)
      SRURO=SQRT(URO)
      IFLAG=1
      IRANK=N
C
C     COMPUTE NORM**2 OF JTH ROW AND A MATRIX NORM
C
      ANORM=0.
      DO 2 J=1,N
         KPIVOT(J)=J
         ROWS(J)=SDOT(M,A(J,1),NRDA,A(J,1),NRDA)
         RS(J)=ROWS(J)
         ANORM=ANORM+ROWS(J)
    2 CONTINUE
C
C     PERFORM COLUMN SCALING ON A WHEN SPECIFIED
C
      CALL CSCALE(A,NRDA,N,M,SCALES,DUM,ROWS,RS,ANORM,SCALES,ISCALE,1)
C
      ANORM=SQRT(ANORM)
C
C
C     CONSTRUCTION OF LOWER TRIANGULAR MATRIX AND RECORDING OF
C     ORTHOGONAL TRANSFORMATIONS
C
C
      DO 50 K=1,N
         MK=M-K+1
         IF (K .EQ. N) GO TO 25
         KP=K+1
C
C        SEARCHING FOR PIVOTAL ROW
C
         DO 10 J=K,N
            IF (ROWS(J) .GE. SRURO*RS(J)) GO TO 5
            ROWS(J)=SDOT(MK,A(J,K),NRDA,A(J,K),NRDA)
            RS(J)=ROWS(J)
    5       IF (J .EQ. K) GO TO 7
            IF (SIGMA .GE. 0.99*ROWS(J)) GO TO 10
    7       SIGMA=ROWS(J)
            JROW=J
   10    CONTINUE
         IF (JROW .EQ. K) GO TO 25
C
C        PERFORM ROW INTERCHANGE
C
         L=KPIVOT(K)
         KPIVOT(K)=KPIVOT(JROW)
         KPIVOT(JROW)=L
         ROWS(JROW)=ROWS(K)
         ROWS(K)=SIGMA
         RSS=RS(K)
         RS(K)=RS(JROW)
         RS(JROW)=RSS
         DO 20 L=1,M
            ASAVE=A(K,L)
            A(K,L)=A(JROW,L)
   20       A(JROW,L)=ASAVE
C
C        CHECK RANK OF THE MATRIX
C
   25    SIG=SDOT(MK,A(K,K),NRDA,A(K,K),NRDA)
         DIAGK=SQRT(SIG)
         IF (DIAGK .GT. ACC*ANORM) GO TO 30
C
C        RANK DEFICIENT PROBLEM
         IFLAG=3
         IRANK=K-1
         CALL XERMSG ('SLATEC', 'ORTHOR',
     +      'RANK OF MATRIX IS LESS THAN THE NUMBER OF ROWS.', 1, 1)
         RETURN
C
C        CONSTRUCT AND APPLY TRANSFORMATION TO MATRIX A
C
   30    AKK=A(K,K)
         IF (AKK .GT. 0.) DIAGK=-DIAGK
         DIAG(K)=DIAGK
         A(K,K)=AKK-DIAGK
         IF (K .EQ. N) GO TO 50
         SAD=DIAGK*AKK-SIG
         DO 40 J=KP,N
            AS=SDOT(MK,A(K,K),NRDA,A(J,K),NRDA)/SAD
            DO 35 L=K,M
   35          A(J,L)=A(J,L)+AS*A(K,L)
   40       ROWS(J)=ROWS(J)-A(J,K)**2
   50 CONTINUE
C
C
      RETURN
      END
*DECK ORTRAN
      SUBROUTINE ORTRAN (NM, N, LOW, IGH, A, ORT, Z)
C***BEGIN PROLOGUE  ORTRAN
C***PURPOSE  Accumulate orthogonal similarity transformations in the
C            reduction of real general matrix by ORTHES.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      SINGLE PRECISION (ORTRAN-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure ORTRANS,
C     NUM. MATH. 16, 181-204(1970) by Peters and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 372-395(1971).
C
C     This subroutine accumulates the orthogonal similarity
C     transformations used in the reduction of a REAL GENERAL
C     matrix to upper Hessenberg form by  ORTHES.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        LOW and IGH are two INTEGER variables determined by the
C          balancing subroutine  BALANC.  If  BALANC  has not been
C          used, set LOW=1 and IGH equal to the order of the matrix, N.
C
C        A contains some information about the orthogonal trans-
C          formations used in the reduction to Hessenberg form by
C          ORTHES  in its strict lower triangle.  A is a two-dimensional
C          REAL array, dimensioned A(NM,IGH).
C
C        ORT contains further information about the orthogonal trans-
C          formations used in the reduction by  ORTHES.  Only elements
C          LOW through IGH are used.  ORT is a one-dimensional REAL
C          array, dimensioned ORT(IGH).
C
C     On OUTPUT
C
C        Z contains the transformation matrix produced in the reduction
C          by  ORTHES  to the upper Hessenberg form.  Z is a two-
C          dimensional REAL array, dimensioned Z(NM,N).
C
C        ORT has been used for temporary storage as is not restored.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ORTRAN
C
      INTEGER I,J,N,KL,MM,MP,NM,IGH,LOW,MP1
      REAL A(NM,*),ORT(*),Z(NM,*)
      REAL G
C
C     .......... INITIALIZE Z TO IDENTITY MATRIX ..........
C***FIRST EXECUTABLE STATEMENT  ORTRAN
      DO 80 I = 1, N
C
         DO 60 J = 1, N
   60    Z(I,J) = 0.0E0
C
         Z(I,I) = 1.0E0
   80 CONTINUE
C
      KL = IGH - LOW - 1
      IF (KL .LT. 1) GO TO 200
C     .......... FOR MP=IGH-1 STEP -1 UNTIL LOW+1 DO -- ..........
      DO 140 MM = 1, KL
         MP = IGH - MM
         IF (A(MP,MP-1) .EQ. 0.0E0) GO TO 140
         MP1 = MP + 1
C
         DO 100 I = MP1, IGH
  100    ORT(I) = A(I,MP-1)
C
         DO 130 J = MP, IGH
            G = 0.0E0
C
            DO 110 I = MP, IGH
  110       G = G + ORT(I) * Z(I,J)
C     .......... DIVISOR BELOW IS NEGATIVE OF H FORMED IN ORTHES.
C                DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            G = (G / ORT(MP)) / A(MP,MP-1)
C
            DO 120 I = MP, IGH
  120       Z(I,J) = Z(I,J) + G * ORT(I)
C
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_merging
  use cubetools_parameters
  use cubetools_structure
  use cubetools_axis_types
  use cubetools_keywordlist_types
  use cubetools_spapro_types
  use cube_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubeadm_index
  use cubemain_messaging
  use cubemain_auxiliary
  use cubetopology_speline_types
  use cubeadm_identifier
  use cubemain_average_tool
  !---------------------------------------------------------------------
  ! Support module for commands which need to reproject+resample cubes
  ! from an index before "merging" them (typical use case is averaging
  ! them, but other uses might be implemented thanks to the proper
  ! switch).
  !---------------------------------------------------------------------
  !
  public :: merging_comm_t, merging_user_t, merging_prog_t
  private
  !
  integer(kind=4), parameter :: ione = 1
  !
  integer(kind=code_k), parameter :: align_freq = 1
  integer(kind=code_k), parameter :: align_velo = 2
  integer(kind=code_k), parameter :: align_chan = 3
  character(len=*), parameter :: atype(3)=['FREQUENCY','VELOCITY ','CHANNEL  ']
  !
  integer(kind=code_k), parameter :: combi_union = 1
  integer(kind=code_k), parameter :: combi_inter = 2
  character(len=*), parameter :: ctype(2)=['UNION       ','INTERSECTION']
  !
  integer(kind=code_k), parameter :: kind_data=1
  integer(kind=code_k), parameter :: kind_weight=2
  integer(kind=code_k), parameter :: kind_noise=3
  !
  type merging_comm_t
     type(identifier_opt_t)       :: family
     type(option_t),      pointer :: like
     type(cubeid_arg_t),  pointer :: like_arg
     type(axis_opt_t)             :: faxis
     type(axis_opt_t)             :: vaxis
     type(speline_opt_t)          :: freq
     type(spapro_type_opt_t)      :: ptype
     type(spapro_center_opt_t)    :: pcenter
     type(spapro_angle_opt_t)     :: pangle
     type(axis_opt_t)             :: laxis
     type(axis_opt_t)             :: maxis
     type(option_t),      pointer :: align ! To control spectral axis alignment
     type(keywordlist_comm_t), pointer :: alignment
     type(keywordlist_comm_t), pointer :: combination
     type(cube_prod_t),        pointer :: merged   ! Not an actual product, just the merged reference header
     type(average_comm_t)         :: prod  ! Provide the actual products (average + weight)
   contains
     procedure, public  :: register     => cubemain_merging_register
     procedure, public  :: parse        => cubemain_merging_parse
  end type merging_comm_t
  !
  type merging_user_t
     type(axis_user_t)          :: faxis         ! User faxis description
     type(axis_user_t)          :: vaxis  ! User vaxis description
     type(speline_user_t)       :: line          ! Optional line name and freq
     type(spapro_type_user_t)   :: ptype         ! New projection type
     type(spapro_center_user_t) :: pcenter       ! New projection center
     type(spapro_angle_user_t)  :: pangle        ! New projection angle
     type(axis_user_t)          :: laxis         ! User laxis description
     type(axis_user_t)          :: maxis         ! User maxis description     
     type(auxiliary_user_t)     :: like
     type(identifier_user_t)    :: family
     integer(kind=code_k)       :: align  ! Alignment
     integer(kind=code_k)       :: combi  ! Combination
   contains
     procedure, public :: toprog => cubemain_merging_user_toprog
  end type merging_user_t
  !
  ! *   to be resolved at header time
  ! **  used for resampling in velocity in velociy and channel alignments
  ! *** Stored to be passed to CUBE\AVERAGE
  type merging_prog_t
     type(index_t)         :: index
     type(index_t)         :: resampled
     type(cube_t), pointer :: merged
     type(cube_t), pointer :: ref
     integer(kind=code_k)  :: align        ! Alignment
     integer(kind=4)       :: mergedid     ! Merged cube id
     !
     type(axis_user_t)          :: faxis   ! faxis description *
     type(axis_user_t)          :: vaxis   ! vaxis description *,** 
     type(speline_prog_t)       :: line    ! New line name
     type(spapro_type_user_t)   :: ptype   ! New projection type *
     type(spapro_center_user_t) :: pcenter ! New projection center *
     type(spapro_angle_user_t)  :: pangle  ! New projection angle *
     type(axis_user_t)          :: laxis   ! laxis description *
     type(axis_user_t)          :: maxis   ! maxis description *
     type(identifier_prog_t)    :: family  ! Resolved family description
     type(identifier_user_t)    :: ufamily ! User family decription ***
     logical                    :: dolike
     !
     ! Index description
     integer(kind=code_k), allocatable :: cube_kind(:)  ! Data, weight, or noise
     integer(kind=code_k)              :: aver_kind     ! Average kind to be applied
     !
     ! This is to be decided at run time
     procedure(cubemain_merging_prog_resample_like), private, pointer :: resample => null()
   contains
     procedure, private :: ref_head      => cubemain_merging_prog_ref_head
     procedure, private :: ref_head_spat => cubemain_merging_prog_ref_head_spatial
     procedure, private :: ref_head_spec => cubemain_merging_prog_ref_head_spectral
     procedure, private :: ref_head_like => cubemain_merging_prog_ref_head_like
     procedure, private :: ref_data      => cubemain_merging_prog_ref_data
     procedure, private :: ref_data_loop => cubemain_merging_prog_ref_data_loop
     procedure, private :: ref_data_act  => cubemain_merging_prog_ref_data_act
     !
     procedure, private :: analyze       => cubemain_merging_prog_analyze
     procedure, private :: reproject     => cubemain_merging_prog_reproject
     procedure, private :: average       => cubemain_merging_prog_average
     procedure, private :: loop          => cubemain_merging_prog_loop
     !
     procedure, public  :: main          => cubemain_merging_prog_main
  end type merging_prog_t
  !
contains
  !
  subroutine cubemain_merging_register(merge,adjective,ouflag,error)
    use cubetools_unit
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_comm_t), intent(inout) :: merge
    character(len=*),      intent(in)    :: adjective
    type(flag_t),          intent(in)    :: ouflag
    logical,               intent(inout) :: error
    !
    type(keywordlist_comm_t)  :: keyarg
    type(cube_prod_t) :: oucube
    character(len=:), allocatable :: uadjective
    character(len=*), parameter :: rname='MERGING>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    uadjective = adjective
    call sic_upper(uadjective)
    !
    call merge%family%register(&
         'Define the new family name for '//adjective//' products',&
         .not.changeflags,error)
    if (error) return
    !
    call cubemain_auxiliary_register(&
         'LIKE',&
         'Merge headers onto a template cube',&
         'Use a reference cube as template for output spatial and spectral&
         & metadata.'//strg_cr//&
         'Explicit axis/projection options (/LAXIS, /MAXIS, /FAXIS,&
         & /VAXIS, /PTYPE, /PCENTER, /PANGLE, /FREQUENCY) override values&
         & inherited from the template.',&
         merge%like,&
         'Reference cube',&
         [flag_cube],&
         code_arg_mandatory, &
         code_access_subset, &
         merge%like_arg, &
         error)
    if (error) return
    !
    call merge%freq%register(&
         'Define line name and frequency of the '//adjective//' cube',&
         error)
    if (error) return
    !
    call merge%faxis%register(&
         code_unit_freq, &
         'FAXIS',&
         'Define the frequency axis of the '//adjective//' cube',&
         error)
    if (error) return
    !
    call merge%vaxis%register(&
         code_unit_freq, &
         'VAXIS',&
         'Define the velocity axis of the '//adjective//' cube',&
         error)
    if (error) return

    !
    call merge%ptype%register(&
         'PTYPE',&
         'Define the new projection type',&
         error)
    if (error) return
    call merge%pcenter%register(&
         'PCENTER',&
         'Define the new projection center',&
         error)
    if (error) return
    call merge%pangle%register(&
         'PANGLE',&
         'Define the new projection angle',&
         error)
    if (error) return
    !
    call merge%laxis%register(&
         code_unit_fov, &
         'LAXIS',&
         'Define the L axis of the '//adjective//' cube',&
         error)
    if (error) return
    call merge%maxis%register(&
         code_unit_fov, &
         'MAXIS',&
         'Define the M axis of the '//adjective//' cube',&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'ALIGN','FREQUENCY|VELOCITY|CHANNEL',&
         'Define the spectral axis alignment',&
         'Define over which spectral axes the cubes will be aligned&
         & to produce the '//adjective//' cube. The default alignment &
         & is FREQUENCY. When the alignment is FREQUENCY option /VAXIS &
         & is ignored, When the aligment is VELOCITY option /FAXIS is&
         & ignored, and finally when the alignment is CHANNEL both &
         & /VAXIS and /FAXIS are ignored.', merge%align,error)
    if (error) return
    call keyarg%register(&
         'alignment',&
         'Alignment type',&
         strg_emp,&
         code_arg_mandatory,&
         atype,&
         .not.flexible,&
         merge%alignment,&
         error)
    if (error) return
    ! call keyarg%register(&
    !      'combination',&
    !      'combination type',&
    !      strg_id,&
    !      code_arg_optional,&
    !      ctype,&
    !      .not.flexible,&
    !      merge%combination,&
    !      error)
    ! if (error) return
    !
    ! Products
    call oucube%register(&
         uadjective,&
         adjective//' cube',&
         strg_emp,&
         [flag_merge,flag_cube],&
         merge%merged,&
         error)
    if (error) return
    call merge%prod%register(ouflag,error)
    if (error)  return
  end subroutine cubemain_merging_register
  !
  subroutine cubemain_merging_parse(merge,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_comm_t), intent(in)    :: merge
    character(len=*),      intent(in)    :: line
    class(merging_user_t), intent(out)   :: user
    logical,               intent(inout) :: error
    !
    logical :: doalign
    character(len=argu_l) :: argu,solved
    character(len=*), parameter :: rname='MERGING>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call merge%family%parse(line,user%family,error)
    if (error) return
    call cubemain_auxiliary_parse(line,merge%like,user%like,error)
    if (error) return
    !
    ! Spectral
    call merge%faxis%parse(line,user%faxis,error)
    if (error) return
    call merge%vaxis%parse(line,user%vaxis,error)
    if (error) return
    call merge%freq%parse(line,user%line,error)
    if (error) return
    !
    ! Projection
    call merge%ptype%parse(line,user%ptype,error)
    if (error) return
    call merge%pcenter%parse(line,user%pcenter,error)
    if (error) return
    call merge%pangle%parse(line,user%pangle,error)
    if (error) return
    !
    ! Spatial axes
    call merge%laxis%parse(line,user%laxis,error)
    if (error) return
    call merge%maxis%parse(line,user%maxis,error)
    if (error) return
    !
    ! Alignment
    user%align = align_freq
    user%combi = combi_union
    call merge%align%present(line,doalign,error)
    if (error) return
    if (doalign) then
       call cubetools_getarg(line,merge%align,1,argu,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(merge%alignment,argu,&
            user%align,solved,error)
       if (error) return
       ! argu = 'UNION'
       ! call cubetools_getarg(line,merge%align,2,argu,.not.mandatory,error)
       ! if (error) return
       ! call cubetools_keywordlist_user2prog(merge%combination,argu,&
       !      user%combi,solved,error)
       ! if (error) return
    endif
  end subroutine cubemain_merging_parse
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_merging_user_toprog(user,merge,prog,error)
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_user_t), intent(in)    :: user
    type(merging_comm_t),  intent(in)    :: merge
    type(merging_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    type(cube_t), pointer :: pcub
    character(len=*), parameter :: rname='MERGE>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call prog%index%get_from_current(code_access_subset,code_read_head,error)
    if (error) return
    !
    prog%dolike = user%like%do
    if (prog%dolike) then
       call cubemain_auxiliary_user2prog(merge%like_arg,user%like,prog%ref,error)
       if (error) return
    endif
    !
    ! Spectral part
    pcub => prog%index%get_cube(ione,error)
    if (error) return
    call user%line%toprog(pcub,prog%line,error)
    if (error) return
    prog%faxis = user%faxis
    prog%vaxis = user%vaxis
    !
    ! Projection part
    prog%ptype   = user%ptype
    prog%pcenter = user%pcenter
    prog%pangle  = user%pangle
    !
    ! Spatial axes
    prog%laxis = user%laxis
    prog%maxis = user%maxis
    !
    call user%family%toprog(pcub,prog%family,error)
    if (error) return
    prog%ufamily = user%family
    !
    ! Alignment
    prog%align = user%align
  end subroutine cubemain_merging_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_merging_prog_ref_head(prog,comm,error)
    use cubetools_header_methods
    use cubetools_header_types
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    type(merging_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: icub
    type(cube_t), pointer :: pcub
    character(len=*), parameter :: rname='MERGING>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    pcub => prog%index%get_cube(ione,error)
    if (error) return
    call cubeadm_clone_header(comm%merged,pcub,prog%merged,error)
    if (error) return
    !
    call prog%family%apply(prog%merged,error)
    if (error) return
    !
    if (prog%dolike) then
       call prog%ref_head_like(error)
       if (error) return
    else
       call prog%ref_head_spat(comm,error)
       if (error) return
       call prog%ref_head_spec(comm,error)
       if (error) return
    endif
    !
    do icub=1,prog%index%n
       pcub => prog%index%get_cube(icub,error)
       if (error) return
       call cubetools_header_add_observatories(pcub%head,prog%merged%head,error)
       if (error) return
    enddo
    !
    call cubemain_message(seve%r,rname,blankstr)
    call cubemain_message(seve%r,rname,'Output header:')
    call prog%merged%head%list(error)
    if (error) return
    !
  end subroutine cubemain_merging_prog_ref_head
  !
  subroutine cubemain_merging_prog_ref_head_spatial(prog,comm,error)
    use cubetools_header_methods
    use cubetools_axis_types
    use cubetopology_spatial_coordinates
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    type(merging_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    type(axis_t) :: laxis,maxis,laxisloc,maxisloc
    real(kind=coor_k) :: absmin(2),absmax(2)
    character(len=*), parameter :: rname='MERGING>PROG>HEADER>SPATIAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Set up new projection
    call comm%ptype%user2prog(prog%ptype,prog%merged%head%spa%pro,error)
    if (error) return
    call comm%pcenter%user2prog(prog%merged%head%spa%fra,prog%pcenter,prog%merged%head%spa%pro,error)
    if (error) return
    call comm%pangle%user2prog(prog%pangle,prog%merged%head%spa%pro,error)
    if (error) return
    !
    !
    if (.not.(prog%laxis%do.and.prog%maxis%do)) then ! At least one axis to be guessed
       call compute_spa_region(error)
       if (error) return
    endif
    if (prog%laxis%do) then
       call cubetools_header_get_axis_head_l(prog%merged%head,laxisloc,error)
       if (error) return
       call comm%laxis%user2prog(prog%laxis,laxisloc,laxis,error)
       if (error) return
    else
       call compute_spa_axis(absmin(1),absmax(1),laxis,error)
       if (error) return
    endif
    if (prog%maxis%do) then
       call cubetools_header_get_axis_head_m(prog%merged%head,maxisloc,error)
       if (error) return
       call comm%maxis%user2prog(prog%maxis,maxisloc,maxis,error)
       if (error) return
    else
       call compute_spa_axis(absmin(2),absmax(2),maxis,error)
       if (error) return
    endif
    !
    call cubetools_header_update_axset_l(laxis,prog%merged%head,error)
    if (error) return
    call cubetools_header_update_axset_m(maxis,prog%merged%head,error)
    if (error) return
  contains
    subroutine compute_spa_axis(mini,maxi,axis,error)
      !----------------------------------------------------------------------
      ! 
      !----------------------------------------------------------------------
      real(kind=coor_k), intent(in)    :: mini
      real(kind=coor_k), intent(in)    :: maxi
      type(axis_t),      intent(inout) :: axis
      logical,           intent(inout) :: error
      !
      real(kind=coor_k) :: nrea, diff
      integer(kind=pixe_k) :: nnint
      real(kind=coor_k), parameter :: spatol = 0.1
      character(len=*), parameter :: rname='MERGING>COMPUTE>SPA>AXIS'
      !
      call cubemain_message(mainseve%trace,rname,'Welcome')
      !
      nrea  = abs((maxi-mini)/axis%inc)
      nnint = nint(nrea)
      diff = abs((nnint-nrea)*abs(axis%inc))
      if (diff.le.abs(spatol*axis%inc)) then
         axis%n = nnint
      else
         axis%n = ceiling(nrea)
      endif
      if (axis%inc.lt.0) then
         axis%ref = -(maxi-0.5*axis%inc)/axis%inc
      else
         axis%ref = (-mini+0.5*axis%inc)/axis%inc
      endif
      axis%val = 0d0
    end subroutine compute_spa_axis
    !
    subroutine compute_spa_region(error)
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      logical, intent (inout) :: error
      !
      integer(kind=4) :: iax,icub
      real(kind=coor_k) :: corners(2,4),projcorners(2,4)
      type(cube_t), pointer :: pcub
      integer(kind=8), parameter :: four=4
      !
      call cubetools_header_get_axis_head_l(prog%merged%head,laxis,error)
      if (error) return
      call cubetools_header_get_axis_head_m(prog%merged%head,maxis,error)
      if (error) return       
      call cubetopology_spatial_corners(prog%merged,corners,error)
      if (error) return
      do iax=1,2
         absmin(iax) = minval(corners(iax,:))
         absmax(iax) = maxval(corners(iax,:))
      enddo
      do icub=1,prog%index%n
         pcub => prog%index%get_cube(icub,error)
         if (error) return
         call cubetopology_spatial_corners(pcub,corners,error)
         if (error) return
         call cubetools_header_get_axis_head_l(pcub%head,laxisloc,error)
         if (error) return
         call cubetools_header_get_axis_head_m(pcub%head,maxisloc,error)
         if (error) return
         call cubetopology_spatial_reprojcoords(pcub,corners,&
              prog%merged,four,projcorners,error) 
         if (error) return
         do iax=1,2
            absmin(iax) = min(absmin(iax),minval(projcorners(iax,:)))
            absmax(iax) = max(absmax(iax),maxval(projcorners(iax,:)))
         enddo
         if (abs(laxisloc%inc).gt.abs(laxis%inc)) laxis%inc = laxisloc%inc
         if (abs(maxisloc%inc).gt.abs(maxis%inc)) maxis%inc = maxisloc%inc
      enddo
    end subroutine compute_spa_region
  end subroutine cubemain_merging_prog_ref_head_spatial
  !
  subroutine cubemain_merging_prog_ref_head_spectral(prog,comm,error)
    use cubetools_header_methods
    use cubetools_axis_types
    use cubetopology_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    type(merging_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    real(kind=coor_k) :: fmin,fmax,lfmin,lfmax,inc
    type(axis_t) :: faxis,vaxis,axisloc
    integer(kind=4) :: icub
    integer(kind=chan_k) :: nchan
    type(cube_t), pointer :: pcub
    character(len=*), parameter :: rname='MERGING>PROG>HEADER>SPECTRAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Set the new rest frequency
    call cubetools_header_modify_rest_frequency(prog%line%freq,prog%merged%head,error)
    if (error) return
    call cubetools_header_put_line(prog%line%name,prog%merged%head,error)
    if (error) return
    !
    select case(prog%align)
    case(align_freq)
       prog%resample => cubemain_merging_prog_resample_like
       if (prog%faxis%do) then ! User has given a desired frequency axis
          call cubetools_header_get_axis_head_f(prog%merged%head,axisloc,error)
          if (error) return
          call comm%faxis%user2prog(prog%faxis,axisloc,faxis,error)
          if (error) return
          if (faxis%val.ne.prog%line%freq) then
             call cubemain_message(seve%w,rname,'Two different rest frequencies given')
             call cubemain_message(seve%w,rname,'Using the one from the frequency axis')
          endif
       else ! No input on frequency axis from user, merge all frequency ranges
          call cubetools_header_get_axis_head_f(prog%merged%head,faxis,error)
          if (error) return
          call cubetopology_tool_fminfmax(prog%merged,fmin,fmax,error)
          if (error) return
          !
          do icub=1,prog%index%n
             pcub => prog%index%get_cube(icub,error)
             if (error) return
             call cubetopology_tool_fminfmax(pcub,lfmin,lfmax,error)
             if (error) return
             call cubetools_header_get_axis_head_f(pcub%head,axisloc,error)
             if (error) return
             fmin = min(fmin,lfmin)
             fmax = max(fmax,lfmax)
             if (abs(axisloc%inc).gt.abs(faxis%inc)) faxis%inc = axisloc%inc
          enddo ! icub
          faxis%n = ceiling((fmax-fmin)/abs(faxis%inc))
          if (faxis%inc.lt.0) then
             faxis%ref  = -(fmax-faxis%val-0.5*faxis%inc)/faxis%inc
          else
             faxis%ref  = (faxis%val-fmin+0.5*faxis%inc)/faxis%inc
          endif
       endif
       call cubetools_header_update_frequency_from_axis(faxis,prog%merged%head,error)
       if (error) return
    case(align_velo)
       prog%resample => cubemain_merging_prog_resample_vaxis
       if (prog%vaxis%do) then
          call cubetools_header_get_axis_head_v(prog%merged%head,axisloc,error)
          if (error) return
          call comm%vaxis%user2prog(prog%vaxis,axisloc,vaxis,error)
          if (error) return
       ! Second case user has not given a velocity axis, use the one
       ! with the worst velocity resolution
       else
          inc = tiny(1d0)
          do icub=1,prog%index%n
             pcub => prog%index%get_cube(1,error)
             if (error) return
             call cubetools_header_get_axis_head_v(pcub%head,axisloc,error)
             if (error) return
             if (abs(axisloc%inc).gt.abs(inc)) then
                inc = axisloc%inc
                call cubetools_axis_copy(axisloc,vaxis,error)
                if (error) return
             endif
          enddo
       endif
       call cubetools_header_update_velocity_from_axis(vaxis,prog%merged%head,error)
       if (error) return
       call axis2user(vaxis,prog%vaxis,error)
       if (error) return
    case(align_chan)
       prog%resample => cubemain_merging_prog_resample_vaxis
       ! Here we simply find the cube with the most channels and we
       ! will resample the cubes to simply add more channels at the
       ! end.
       nchan = 0
       do icub=1,prog%index%n
          pcub => prog%index%get_cube(1,error)
          if (error) return
          call cubetools_header_get_axis_head_v(pcub%head,axisloc,error)
          if (error) return
          if (axisloc%n.gt.nchan) then
             nchan = axisloc%n
          endif
       enddo
       prog%vaxis%do = .true.
       write(prog%vaxis%n,'(i0)') nchan
       prog%vaxis%ref  = strg_equal
       prog%vaxis%val  = strg_equal
       prog%vaxis%inc  = strg_equal
       prog%vaxis%unit = strg_equal
       call cubetools_header_update_velocity_from_user(prog%vaxis,prog%merged%head,error)
       if (error) return
    case default
       call cubemain_message(seve%e,rname,'Programming error code should be unreachable')
       error = .true.
       return
    end select
    !
  contains
    subroutine axis2user(axis,user,error)
      type(axis_t),      intent(in)    :: axis
      type(axis_user_t), intent(out)   :: user
      logical,           intent(inout) :: error
      !
      user%do = .true.
      write(user%n,'(i0)') axis%n
      write(user%ref,'(1PG23.16)') axis%ref
      write(user%val,'(1PG23.16)') axis%val
      write(user%inc,'(1PG23.16)') axis%inc
      user%unit = axis%unit
    end subroutine axis2user
  end subroutine cubemain_merging_prog_ref_head_spectral
  !
  subroutine cubemain_merging_prog_ref_head_like(prog,error)
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='MERGING>PROG>HEADER>LIKE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_header_spectral_like(prog%ref%head,prog%merged%head,error)
    if (error) return
    call cubetools_header_spatial_like(prog%ref%head,prog%merged%head,error)
    if (error) return
    !
    prog%resample => cubemain_merging_prog_resample_like
    !
  end subroutine cubemain_merging_prog_ref_head_like
  !
  subroutine cubemain_merging_prog_ref_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='MERGING>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! return
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
          call prog%ref_data_loop(iter,error)
       !$OMP END TASK
    enddo ! ie
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_merging_prog_ref_data
  !
  subroutine cubemain_merging_prog_ref_data_loop(prog,itertask,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! The subcube iterator will be shared by all input and output subcubes
    !----------------------------------------------------------------------
    class(merging_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MERGING>PROG>LOOP'
    !
    do while (itertask%iterate_entry(error))
      call prog%ref_data_act(itertask,error)
      if (error) return
    enddo  ! ientry
  end subroutine cubemain_merging_prog_ref_data_loop
  !   
  subroutine cubemain_merging_prog_ref_data_act(prog,itertask,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: itertask
    logical,                  intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    type(subcube_t) :: ousub
    character(len=*), parameter :: rname='MERGING>PROG>ACT'
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube to another.
    call ousub%allocate('ousub',prog%merged,itertask,error)
    if (error) return
    !
    do iz=1,ousub%nz
       do iy=1,ousub%ny
          do ix=1,ousub%nx
             ousub%val(ix,iy,iz) = gr4nan
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call ousub%put(error)
    if (error) return
  end subroutine cubemain_merging_prog_ref_data_act
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_merging_prog_reproject(prog,inid,error)
    use cubeadm_opened
    use cubemain_reproject
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    integer(kind=4),       intent(in)    :: inid
    logical,               intent(inout) :: error
    !
    type(reproject_user_t) :: user
    character(len=16) :: writeid
    character(len=*), parameter :: rname='MERGING>PROG>REPROJECT'
    !
    write(writeid,'(i0)') inid
    call user%comm%cubeids%fill(writeid,error)
    if (error) return
    write(writeid,'(i0)') prog%mergedid
    call user%like%id%fill(writeid,error)
    if (error) return
    user%like%do    = .true.
    user%spafra%do  = .false.
    user%ptype%do   = .false.
    user%pcenter%do = .false.
    user%pangle%do  = .false.
    user%newx%do    = .false.
    user%newy%do    = .false.
    user%newx%n     = strg_star
    user%newx%ref   = strg_star
    user%newx%val   = strg_star
    user%newx%inc   = strg_star
    user%newx%unit  = strg_star
    user%newy%n     = strg_star
    user%newy%ref   = strg_star
    user%newy%val   = strg_star
    user%newy%inc   = strg_star
    user%newy%unit  = strg_star
    !
    call reproject%main(user,error)
    if (error) return
    call cubeadm_finish_all('TMP','MERGING REPROJECT',error)
    if (error) continue 
  end subroutine cubemain_merging_prog_reproject
  !
  subroutine cubemain_merging_prog_resample_like(prog,inid,error)
    use cubetools_header_methods
    use cubeadm_get
    use cubeadm_opened
    use cubemain_resample
    !----------------------------------------------------------------------
    ! Here we resample the cubes exactly like the reference cube
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    integer(kind=4),       intent(in)    :: inid
    logical,               intent(inout) :: error
    !
    type(resample_user_t) :: user
    character(len=16) :: writeid
    character(len=*), parameter :: rname='MERGING>PROG>RESAMPLE>LIKE'
    !
    write(writeid,'(i0)') inid
    call user%cubeids%fill(writeid,error)
    if (error) return
    !
    write(writeid,'(i0)') prog%mergedid
    call user%reference%id%fill(writeid,error)
    if (error) return
    user%reference%present = .true.
    user%dofreq    = .true.
    user%axis%do   = .false.
    user%axis%n    = strg_star
    user%axis%ref  = strg_star
    user%axis%val  = strg_star
    user%axis%inc  = strg_star
    user%axis%unit = strg_star
    !
    call resample%main(user,error)
    if (error) return
    call cubeadm_finish_all('TMP','MERGING RESAMPLE',error)
    if (error) return
  end subroutine cubemain_merging_prog_resample_like
  !
  subroutine cubemain_merging_prog_resample_vaxis(prog,inid,error)
    use cubetools_header_methods
    use cubeadm_get
    use cubeadm_opened
    use cubemain_resample
    !----------------------------------------------------------------------
    ! Here we resample cubes according to a pre-specified Velocity axis
    ! to warrant velocity or channel alignments
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    integer(kind=4),       intent(in)    :: inid
    logical,               intent(inout) :: error
    !
    type(resample_user_t) :: user
    character(len=16) :: writeid
    type(cube_t), pointer :: cube,merged
    character(len=*), parameter :: rname='MERGING>PROG>RESAMPLE>VAXIS'
    !
    write(writeid,'(i0)') inid
    call user%cubeids%fill(writeid,error)
    if (error) return
    !
    user%reference%present = .false.
    user%dofreq = .false.
    user%axis = prog%vaxis
    !
    call resample%main(user,error)
    if (error) return
    call cubeadm_finish_all('TMP','MERGING RESAMPLE',error)
    if (error) return
    !
    ! When not resampling like the merged cube we need to modify
    ! the header of the resampled cube so that it can have the same
    ! spectral section as the merged cube
    !
    ! VVV However this causes weird behaviours on the sizes of the
    ! output cubes and incoherences in the spectral sections
    call cubeadm_get_header(prog%mergedid,code_access_imaset,&
         code_read_head,merged,error)
    call cubeadm_get_last_cube(cube,error)
    if (error) return
    call cubetools_header_spectral_like(merged%head,cube%head,error)
    if (error) return
    call cubeadm_finish_all('TMP','MERGING SPECTRAL LIKE',error)
    if (error) continue
  end subroutine cubemain_merging_prog_resample_vaxis
  !
  subroutine cubemain_merging_prog_average(prog,comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(in)    :: prog
    type(merging_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    type(average_user_t) :: user
    character(len=*), parameter :: rname='MERGING>PROG>AVERAGE'
    !
    user%data_mode = code_user_index_custom
    call prog%resampled%copy(user%datind,error)
    if (error) return
    !
    user%weight_mode = prog%aver_kind
    user%family      = prog%ufamily
    !
    call comm%prod%main(user,error)
    if (error) return
  end subroutine cubemain_merging_prog_average
  !
  subroutine cubemain_merging_prog_analyze(prog,error)
    use gkernel_interfaces
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! Guess which cubes are data cubes, vs weight cubes or noise cubes
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: icub,ier,ndata,nwei,nnoi
    type(cube_t), pointer :: cube
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='MERGING>PROG>ANALYZE'
    !
    allocate(prog%cube_kind(prog%index%n),stat=ier)
    if (failed_allocate(rname,'cube kind array',ier,error)) return
    !
    ! Automatic guess based on flags. It could be made explicit with a
    ! dedicated syntax
    ndata = 0
    nwei = 0
    nnoi = 0
    do icub=1,prog%index%n
       cube => prog%index%get_cube(icub,error)
       if (error) return
       if (cube%node%flag%contains(flag_weight)) then
         nwei = nwei+1
         prog%cube_kind(icub) = kind_weight
       elseif (cube%node%flag%contains(flag_noise)) then
         nnoi = nnoi+1
         prog%cube_kind(icub) = kind_noise
       else
         ndata = ndata+1
         prog%cube_kind(icub) = kind_data
       endif
    enddo
    !
    if (nnoi.ge.1) then
      ! The rest of the code works, but we have doubt on the previous
      ! resampling and reprojection of noise cubes. Reject for now.
      call cubemain_message(seve%e,rname,'The index contains noise cubes')
      call cubemain_message(seve%e,rname,'reprojection or resampling of noise cubes is not implemented')
      error = .true.
      return
    endif
    !
    ! Minimal sanity check which we can not avoid before averaging. Note
    ! that the average engine will perform more extensive checks (and
    ! proper pairing).
    if (nwei.ge.1 .and. nnoi.ge.1) then
      write(mess,'(4(a,i0))')  &
        'Invalid mixture of ',ndata,' data cubes, ',  &
                              nwei,' weight cubes, and ',  &
                              nnoi,' noise cubes'
      call cubemain_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    if (nwei.gt.1) then
      prog%aver_kind = code_user_weight_datweiind
    elseif (nnoi.gt.1) then
      prog%aver_kind = code_user_weight_datnoiind
    else
      prog%aver_kind = code_user_weight_none
    endif
  end subroutine cubemain_merging_prog_analyze
  !
  subroutine cubemain_merging_prog_loop(prog,error)
    use cubedag_allflags
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: icub
    type(cube_t), pointer :: cube
    character(len=*), parameter :: rname='MERGING>PROG>LOOP'
    !
    do icub=1, prog%index%n
       cube => prog%index%get_cube(icub,error)
       if (error) return
       ! Data, noise, or weight cubes always resampled to the same
       ! reference.
       call prog%reproject(cube%node%id,error)
       if (error) return
       call cubeadm_get_last_cube(cube,error)
       if (error) return
       ! The reproject engine flags any cube as "reprojected,cube", which is
       ! unsatisfying:
       if (prog%cube_kind(icub).eq.kind_weight) then
        call cube%set_flags([flag_reproject,flag_weight],error)
         if (error) return
       elseif (prog%cube_kind(icub).eq.kind_noise) then
        call cube%set_flags([flag_reproject,flag_noise],error)
         if (error) return
       endif
       ! Only data cubes are resampled in spectral axis.
       if (prog%cube_kind(icub).eq.kind_data) then
         call prog%resample(cube%node%id,error)
         if (error) return
         call cubeadm_get_last_cube(cube,error)
         if (error) return
       endif
       call prog%resampled%put_cube(icub,cube,error)
       if (error) return
    enddo
  end subroutine cubemain_merging_prog_loop
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_merging_prog_main(prog,comm,error)
    use cubeadm_get
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! Routine to be called externaly to execute code
    !----------------------------------------------------------------------
    class(merging_prog_t), intent(inout) :: prog
    type(merging_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    type(cube_t), pointer :: cube
    character(len=*), parameter :: rname='MERGING>PROG>MAIN'
    !
    ! Produce reference cube and store its ID
    call prog%ref_head(comm,error)
    if (error) return
    call prog%ref_data(error)
    if (error) return
    call cubeadm_finish_all('TMP','MERGED REFERENCE',error)
    if (error) return
    call cubeadm_get_last_cube(cube,error)
    if (error) return
    prog%mergedid = cube%node%id
    !
    ! Analysis of the index
    call prog%analyze(error)
    if (error) return
    !
    ! Produce properly sampled cubes
    call prog%loop(error)
    if (error) return
    !
    ! Average them
    call prog%average(comm,error)
    if (error) return
  end subroutine cubemain_merging_prog_main
end module cubemain_merging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_primitive_opt
  use cubetools_parameters
  use cubelist_types
  use cubesyntax_messaging
  use cubetools_primitive_arg
  use cubetools_terminal_tool
  !
  public :: primitive_opt_t,opti_k,narg_k,strg_quest
  public :: cubetools_primitive_opt_ptr
  !
  private
  !
  integer(kind=code_k), parameter :: help_src_unkn=0  ! Unknown
  integer(kind=code_k), parameter :: help_src_none=1  ! No help => look at abstract
  integer(kind=code_k), parameter :: help_src_strg=2  ! From string
  integer(kind=code_k), parameter :: help_src_file=3  ! From file
  !
  integer(kind=4), parameter :: opti_k = 4
  integer(kind=4), parameter :: opti_l = 16
  integer(kind=4), parameter :: abst_l = 80
  integer(kind=4), parameter :: synt_l = 60
  !
  character(len=*), parameter :: strg_quest = '?' ! Short help
  !
  type, extends(list_object_t) :: primitive_opt_t
     integer(kind=opti_k)          :: inum     = code_abs  ! Option number in command
     character(len=opti_l)         :: name     = strg_unk
     character(len=synt_l)         :: syntax   = strg_emp
     character(len=abst_l)         :: abstract = strg_emp  ! One-line abstract help
     integer(kind=code_k)          :: help_src = help_src_unkn
     character(len=:), allocatable :: help_strg            ! Long/multiline help OR
     character(len=file_l)         :: help_file            ! File name for help
     integer(kind=narg_k)          :: nargmin  = code_abs
     integer(kind=narg_k)          :: nargmax  = code_abs
     type(list_t)                  :: arg                  ! List of arguments to the option
     procedure(opt_check_interface),          pointer :: check => null()
     procedure(opt_build_syntax_interface),   pointer :: build_syntax => null()
     procedure(opt_print_abstract_interface), pointer :: print_abstract => null()
   contains
     ! Parsing
     procedure :: getnarg      => cubetools_option_getnarg
     procedure :: present      => cubetools_option_present
     procedure, private :: traphelp  => cubetools_option_traphelp
     procedure, private :: getarg_i4 => cubetools_option_getarg_i4
     procedure, private :: getarg_i8 => cubetools_option_getarg_i8
     procedure, private :: getarg_r4 => cubetools_option_getarg_r4
     procedure, private :: getarg_r8 => cubetools_option_getarg_r8
     procedure, private :: getarg_st => cubetools_option_getarg_st
     generic   :: getarg       => getarg_i4, getarg_i8, getarg_r4, getarg_r8, getarg_st
     !
     ! General
     procedure :: init  => cubetools_option_init
     procedure :: final => cubetools_option_final
     procedure :: free  => cubetools_option_free
     !
     ! Registering
     procedure :: put          => cubetools_option_put
     !
     ! Listing and Help
     procedure :: list           => cubetools_option_list
     procedure :: help           => cubetools_option_help
     procedure :: summary        => cubetools_option_summary
     procedure :: show_syntax    => cubetools_option_show_syntax
     procedure :: help_iterate   => cubetools_option_help_iterate
     procedure, private :: print_syntax    => cubetools_option_print_syntax
     procedure, private :: print_help_strg => cubetools_option_print_help_strg
     procedure, private :: print_help_file => cubetools_option_print_help_file
  end type primitive_opt_t
  !
  abstract interface
    subroutine opt_check_interface(opt,command,line,error)
      import primitive_opt_t
      class(primitive_opt_t), intent(in)    :: opt
      character(len=*),       intent(in)    :: command
      character(len=*),       intent(in)    :: line
      logical,                intent(inout) :: error
    end subroutine opt_check_interface
    subroutine opt_build_syntax_interface(opt,syntax,lprint,lnoprint,error)
      import primitive_opt_t
      class(primitive_opt_t), intent(in)    :: opt
      character(len=*),       intent(out)   :: syntax
      integer(kind=4),        intent(out)   :: lprint
      integer(kind=4),        intent(out)   :: lnoprint
      logical,                intent(inout) :: error
    end subroutine opt_build_syntax_interface
    subroutine opt_print_abstract_interface(opt,error)
      import primitive_opt_t
      class(primitive_opt_t), intent(in)    :: opt
      logical,                intent(inout) :: error
    end subroutine opt_print_abstract_interface
  end interface
  !
contains
  !
  !---Parsing-utilities--------------------------------------------------
  !
  function cubetools_option_getnarg(opt)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Returns number of arguments given to option
    !-------------------------------------------------------------------
    integer(kind=narg_k) :: cubetools_option_getnarg
    class(primitive_opt_t), intent(in) :: opt
    !
    cubetools_option_getnarg = sic_narg(opt%inum)
  end function cubetools_option_getnarg
  !
  subroutine cubetools_option_present(opt,line,present,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Returns if option is present.
    ! If the option has a question mark (?) argument, show the either
    ! the option or the argument help.
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    logical,                intent(out)   :: present
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nc,narg
    character(len=1) :: arg1
    character(len=argu_l) :: arg
    character(len=*), parameter :: rname='OPTION>PRESENT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    present = sic_present(opt%inum,icomm)
    if (.not.present)  return
    !
    ! Trap ? on last argument
    narg = opt%getnarg()
    if (narg.le.0)  return  ! No argument present
    !
    if (sic_len(opt%inum,narg).ne.1)  return  ! Argument can not be ?
    !
    call sic_ch(line,opt%inum,narg,arg1,nc,mandatory,error)
    if (error) return
    if (arg1.ne.strg_quest)  return  ! Not a question mark
    !
    if (narg.eq.1) then
      ! Question mark follows the option: show help summary
      call opt%summary(error)
      if (error) return
    else
      ! Question mark follows an argument: show its full summary
      call sic_ke(line,opt%inum,narg-1,arg,nc,mandatory,error)
      if (error) return
      call cubetools_option_help_onearg(opt,arg(1:nc),error)
      if (error) return
    endif
    !
    ! Raise error to ensure the whole calling cascade is exited.
    error = .true.
    return
  end subroutine cubetools_option_present
  !
  subroutine cubetools_option_traphelp(opt,line,iarg,argum,nc,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Get the iarg-th argument (as a string) of the option from the command
    ! line. If the argument is a question mark (?), show the option help.
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    character(len=*),       intent(out)   :: argum
    integer(kind=4),        intent(out)   :: nc
    logical,                intent(inout) :: error
    !
    logical :: obligatory
    type(primitive_arg_t), pointer :: parg
    character(len=*), parameter :: rname='GET>ARG>TRAP>HELP'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    parg => cubetools_primitive_arg_ptr(opt%arg%list(iarg)%p,error)
    obligatory = parg%mandatory.eq.code_arg_mandatory.or.parg%mandatory.eq.code_arg_optional
    call sic_ch(line,opt%inum,iarg,argum,nc,obligatory,error)
    if (error) return
    if (argum.eq.strg_quest) then
       call opt%summary(error)
       if (error) return
       error = .true.
       return
    endif
  end subroutine cubetools_option_traphelp
  !
  subroutine cubetools_option_getarg_i4(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    integer(kind=4),        intent(inout) :: value
    logical,                intent(inout) :: error
    !
    character(len=base_l) :: argum
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>I4'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,argum,nc,error)
    if (error) return
    call sic_math_inte(argum,nc,value,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_option_getarg_i4
  !
  subroutine cubetools_option_getarg_i8(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    integer(kind=8),        intent(inout) :: value
    logical,                intent(inout) :: error
    !
    character(len=base_l) :: argum
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>I8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,argum,nc,error)
    if (error) return
    call sic_math_long(argum,nc,value,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_option_getarg_i8
  !
  subroutine cubetools_option_getarg_r4(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    real(kind=4),           intent(inout) :: value
    logical,                intent(inout) :: error
    !
    character(len=base_l) :: argum
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>I8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,argum,nc,error)
    if (error) return
    call sic_math_real(argum,nc,value,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_option_getarg_r4
  !
  subroutine cubetools_option_getarg_r8(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    real(kind=8),           intent(inout) :: value
    logical,                intent(inout) :: error
    !
    character(len=base_l) :: argum
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>I8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,argum,nc,error)
    if (error) return
    call sic_math_dble(argum,nc,value,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_option_getarg_r8
  !
  subroutine cubetools_option_getarg_st(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    character(len=*),       intent(inout) :: value
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>ST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,value,nc,error)
    if (error) return
  end subroutine cubetools_option_getarg_st
  !
  !---General-routines-----------------------------------------------------
  !
  subroutine cubetools_option_init(opt,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(out)   :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_option_init
  !
  subroutine cubetools_option_final(obj,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(inout) :: obj
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>FINAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_option_free(obj,error)
    if (error) return
  end subroutine cubetools_option_final
  !
  function cubetools_primitive_opt_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(primitive_opt_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(primitive_opt_t), pointer :: cubetools_primitive_opt_ptr  ! Function value on return
    class(list_object_t), pointer       :: tot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRIMITIVE>OPT>PTR'
    !
    select type(tot)
    class is (primitive_opt_t)
      cubetools_primitive_opt_ptr => tot
    class default
      cubetools_primitive_opt_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a primitive_opt_t type')
      error = .true.
      return
    end select
  end function cubetools_primitive_opt_ptr
  !
  subroutine cubetools_option_free(opt,error)
    !----------------------------------------------------------------------
    ! Free the contents of an 'primitive_opt_t'
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(inout) :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>FREE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%arg%final(error)
    if (error) return
  end subroutine cubetools_option_free
  !
  !---Registering----------------------------------------------------------
  !
  subroutine cubetools_option_put(opt,inum,name,syntax,abstract,help,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(inout) :: opt
    integer(kind=opti_k),   intent(in)    :: inum
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: syntax
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    logical,                intent(inout) :: error
    !
    character(len=file_l) :: filename
    character(len=*), parameter :: rname='OPTION>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_option_final(opt,error)
    if (error) return
    call cubetools_option_init(opt,error)
    if (error) return
    !
    opt%inum     = inum
    opt%name     = name
    opt%syntax   = syntax
    opt%abstract = abstract
    if (help.eq.strg_emp) then
      opt%help_src = help_src_none
    else
      call sic_parse_file(help,'','',filename)
      if (gag_inquire(filename,len_trim(filename)).eq.0) then
         opt%help_src = help_src_file
         opt%help_file = filename
      else
         opt%help_src = help_src_strg
         opt%help_strg = help
      endif
    endif
    opt%nargmin  = 0
    opt%nargmax  = 0
  end subroutine cubetools_option_put
  !
  !---Listing-and-Help---------------------------------------------------
  !
  subroutine cubetools_option_print_syntax(opt,error)
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: width,nmess,lprint,lnoprint
    character(len=mess_l) :: mess,key
    character(len=synt_l) :: optsyntax
    character(len=*), parameter :: rname='OPTION>PRINT>SYNTAX'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = ''
    nmess = 0
    width = terminal%width()
    key = 'Syntax'
    call opt%build_syntax(optsyntax,lprint,lnoprint,error)
    if (error)  return
    width = width+lnoprint
    mess = '  '//cubetools_format_stdkey_stdval(key,optsyntax,width)
    call cubesyntax_message(syntaxseve%help,rname,mess)
  end subroutine cubetools_option_print_syntax
  !
  subroutine cubetools_option_list(opt,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=mess_l) :: mess
    integer(kind=narg_k) :: iarg
    class(primitive_arg_t), pointer :: arg
    character(len=*), parameter :: rname='OPTION>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (opt%arg%n.le.0) return
    !
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    write(mess,'(a)') '  Arguments'
    call cubesyntax_message(syntaxseve%help,rname,mess)
    do iarg=1,opt%arg%n
       arg => cubetools_primitive_arg_ptr(opt%arg%list(iarg)%p,error)
       if (error) return
       call arg%print_abstract(iarg,error)
       if (error) return
    enddo !iarg
  end subroutine cubetools_option_list
  !
  subroutine cubetools_option_help(opt,error)
    !-------------------------------------------------------------------
    ! Print option help
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>HELP'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    select case (opt%help_src)
    case (help_src_none)
      ! Only abstract is available
      return
    case (help_src_strg)
      call opt%print_help_strg(error)
      if (error) return
    case (help_src_file)
      call opt%print_help_file(error)
      if (error) return
    case default
      call cubesyntax_message(seve%e,rname,'Unexpected help source')
      error = .true.
      return
    end select
    !
  end subroutine cubetools_option_help
  !
  subroutine cubetools_option_print_help_strg(opt,error)
    !-------------------------------------------------------------------
    ! Print option help from opt%help_strg
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>PRINT>HELP>STRG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    if (.not.allocated(opt%help_strg)) return
    if (len_trim(opt%help_strg).le.0) return
    if (opt%help_strg.eq.strg_emp) return
    !
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    call terminal%print_strg(syntaxseve%help,opt%help_strg)
  end subroutine cubetools_option_print_help_strg
  !
  subroutine cubetools_option_print_help_file(opt,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Print option help from file opt%help_file
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>PRINT>HELP>FILE'
    character(len=256) :: line
    integer(kind=4) :: ier,ilun
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    !
    ier = sic_getlun(ilun)
    if (ier.ne.1) then
      call cubesyntax_message(seve%e,rname,'No logical unit left')
      error = .true.
      return
    endif
    ier = sic_open(ilun,opt%help_file,'OLD',.true.)
    if (ier.ne.0) then
      call cubesyntax_message(seve%e,rname,'Cannot open '//opt%help_file)
      call putios('E-OPTION>HELP>FILE,  ',ier)
      error = .true.
      return
    endif
    do while (.true.)
      read(ilun,'(A)',end=40,err=50) line
      if (line.eq.'ENDOFHELP')  goto 40
      call cubesyntax_message(syntaxseve%help,rname,line)
    enddo
    !
    ! Error
50  call cubesyntax_message(seve%e,rname,'Error reading '//opt%help_file)
    error = .true.
    !
    ! Error and success
40  ier = sic_close(ilun)
    call sic_frelun(ilun)
  end subroutine cubetools_option_print_help_file
  !
  subroutine cubetools_option_summary(opt,error)
    !-------------------------------------------------------------------
    ! Short option summary
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>SUMMARY'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%print_syntax(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    call opt%print_abstract(error)
    if (error) return
    call opt%help(error)
    if (error) return
    call opt%list(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_option_summary
  !
  subroutine cubetools_option_show_syntax(opt,error)
    !-------------------------------------------------------------------
    ! Short option syntax reminder
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>SHOW>SYNTAX'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%print_syntax(error)
    call opt%list(error)
    call cubesyntax_message(syntaxseve%help,rname,'')
  end subroutine cubetools_option_show_syntax
  !
  subroutine cubetools_option_help_onearg(opt,arg,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    ! Disambiguate and show the help for one argument of the option
    ! (among all the other arguments). Might show the option help as
    ! fallback.
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: arg
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: iarg,ikey
    character(len=argu_l) :: solved
    class(primitive_arg_t), pointer :: parg
    character(len=argu_l), allocatable :: arglist(:)
    character(len=*), parameter :: rname='OPTION>PRESENT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! Build the list of argument names
    allocate(arglist(opt%arg%n))
    do iarg=1,opt%arg%n
      parg => cubetools_primitive_arg_ptr(opt%arg%list(iarg)%p,error)
      if (error) return
      arglist(iarg) = parg%name
    enddo
    !
    ! Identify and show help
    call cubetools_disambiguate_flexible(arg,arglist,ikey,solved,error)
    if (error) return
    if (ikey.eq.code_unresolved) then
      ! Not a known argument
      call cubesyntax_message(seve%w,rname,  &
        'Unrecognized argument '//arg//'. Possible arguments are:')
      call opt%list(error)
      if (error) return
    else
      ! Show argument help summary
      parg => cubetools_primitive_arg_ptr(opt%arg%list(ikey)%p,error)
      call parg%summary(error)
      if (error) return
    endif
  end subroutine cubetools_option_help_onearg
  !
  subroutine cubetools_option_help_iterate(opt,forma,langname,commname,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=code_k),   intent(in)    :: forma
    character(len=*),       intent(in)    :: langname
    character(len=*),       intent(in)    :: commname
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>HELP>ITERATE'
    !
    select case (forma)
    case (help_format_tex)
      call cubetools_option_help_iterate_tex(opt,langname,commname,error)
      if (error)  return
    case default
      call cubesyntax_message(seve%e,rname,'Help format not implemented')
      error = .true.
      return
    end select
  end subroutine cubetools_option_help_iterate
  !
  subroutine cubetools_option_help_iterate_tex(opt,langname,commname,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: langname
    character(len=*),       intent(in)    :: commname
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>HELP>ITERATE>TEX'
    !
    call cubesyntax_message(syntaxseve%help,rname,'\subsubsection{'//trim(commname)//' /'//trim(opt%name)//'}')
    call cubesyntax_message(syntaxseve%help,rname,'\label{sec:'//trim(langname)//':'//trim(commname)//&
         ':'//trim(opt%name)//':help}')
    call cubesyntax_message(syntaxseve%help,rname,'\index{'//trim(langname)//' '//trim(commname)//&
         ' /'//trim(opt%name)//' option}')
    !
    call cubesyntax_message(syntaxseve%help,rname,'\begin{PlusVerbatim}')
    call opt%summary(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,'\end{PlusVerbatim}')
  end subroutine cubetools_option_help_iterate_tex
  !
end module cubetools_primitive_opt
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

function funpnl(xv,a)
  !---------------------------------------------------------------------
  ! POINT
  !	Compute the pointing function
  ! V-2.0
  !	Changed sign of excentricity corrections
  !---------------------------------------------------------------------
  ! Global
  include 'size.inc'
  !
  real*8 :: funpnl                  !
  real*8 :: xv(3)                   !
  real*8 :: a(mvar)                 !
  ! Local
  real*8 :: az,el,cosel,sinel,tanel,cosaz,sinaz
  !
  az=xv(1)
  el=xv(2)
  cosel=cos(el)
  sinel=sin(el)
  cosaz=cos(az)
  sinaz=sin(az)
  if (xv(3).eq.0) then
    funpnl=-a( 1)*cosel   &
     &      +cosel*asin(max(-1d0,min(1d0,-a(3)/cosel)))   &
     &      -a( 4)*cosaz*sinel   &
     &      +a( 5)*sinaz*sinel   &
     &      +a( 6)*sinel   &
     &      -a(11)*sinaz*cosel   &
     &      -a(12)*cosaz*cosel
    if (kvar.le.12) return
    funpnl = funpnl   &
     &      +a(13)*cosel*sin(2.d0*az)   &
     &      +a(14)*cosel*cos(2.d0*az)
  else
    tanel = sinel/cosel
    funpnl=-a( 2)   &
     &      -  el+   &
     &      asin(max(-1d0,min(1d0,sinel/sqrt(1d0-a(3)**2))))   &
     &      +a( 4)*sinaz   &
     &      +a( 5)*cosaz   &
     &      +a( 7)/tanel   &
     &      +a( 8)/tanel**3   &
     &      -a( 9)*sinel   &
     &      -a(10)*cosel
    if (kvar.le.12) return
    funpnl = funpnl   &
     &      +a(15)*sin(2.d0*el)   &
     &      +a(16)*cos(2.d0*el)
  endif
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetopology_sperange_set_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_unit_arg
  use cubetools_axis_types
  use cubetopology_messaging
  use cubetopology_sperange_types
  !
  public :: sperange_set_comm_t,sperange_set_user_t,sperange_set_prog_t
  private
  !
  type sperange_set_comm_t
     type(option_t),   pointer :: key
     type(unit_arg_t), pointer :: unit
   contains
     procedure :: register => cubetopology_sperange_set_comm_register
     procedure :: parse    => cubetopology_sperange_set_comm_parse
  end type sperange_set_comm_t
  !
  type sperange_set_user_t
     logical,               public           :: present = .false.
     integer(kind=wind_k),  private          :: n = 0                         ! Size
     type(sperange_user_t), private, pointer :: val(:) => null()              ! Address
     integer(kind=code_k),  private          :: pointeris = code_pointer_null ! Null, allocated, or associated?
   contains
     procedure, private :: reallocate => cubetopology_sperange_set_user_reallocate
     procedure, private :: free       => cubetopology_sperange_set_user_free
     procedure, public  :: toprog     => cubetopology_sperange_set_user_toprog
     procedure, public  :: list       => cubetopology_sperange_set_user_list
     final :: cubetopology_sperange_set_user_final
  end type sperange_set_user_t
  !
  type sperange_set_prog_t
     integer(kind=wind_k),  public           :: n = 0                         ! Size
     type(sperange_prog_t), private, pointer :: val(:) => null()              ! Address
     integer(kind=code_k),  private          :: pointeris = code_pointer_null ! Null, allocated, or associated?
   contains
     procedure, private :: reallocate => cubetopology_sperange_set_prog_reallocate
     procedure, private :: free       => cubetopology_sperange_set_prog_free
     procedure, public  :: list       => cubetopology_sperange_set_prog_list
     procedure, public  :: get_into   => cubetopology_sperange_set_prog_get_into
     final :: cubetopology_sperange_set_prog_final
  end type sperange_set_prog_t
  !
contains
  !
  subroutine cubetopology_sperange_set_comm_register(comm,name,abstract,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    ! Register a /NAME key for a set of spectral ranges. The abstract is
    ! customizable by the caller.
    !----------------------------------------------------------------------
    class(sperange_set_comm_t), intent(out)   :: comm
    character(len=*),           intent(in)    :: name
    character(len=*),           intent(in)    :: abstract
    logical,                    intent(inout) :: error
    !
    type(unit_arg_t) :: unitarg
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='SPERANGE>SET>COMM>REGISTER'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'l1 h1 [... [ln hn]] [unit]',&
         abstract,&
         'Enable to define one or more spectral ranges',&
         comm%key,error)
    if (error) return
    call stdarg%register(&
         'l1', &
         'Low edge of first range',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'h1', &
         'High edge of first range',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'ln', &
         'Low edge of n-th range',&
         strg_emp,&
         code_arg_unlimited,&
         error)
    if (error) return
    call stdarg%register(&
         'hn', &
         'High edge of n-th range',&
         strg_emp,&
         code_arg_unlimited,&
         error)
    if (error) return
    call unitarg%register(&
         'unit',&
         'Range unit',&
         'Omitted or "*" uses cube spectral axis unit; CHANNEL/PIXEL can be used for channel/pixel units',&
         code_arg_optional,&
         code_unit_velo,&
         comm%unit,&
         error)
    if (error) return
  end subroutine cubetopology_sperange_set_comm_register
  !
  subroutine cubetopology_sperange_set_comm_parse(comm,line,user,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(sperange_set_comm_t), intent(in)    :: comm
    character(len=*),           intent(in)    :: line
    type(sperange_set_user_t),  intent(inout) :: user
    logical,                    intent(inout) :: error
    !
    integer(kind=argu_k) :: narg
    integer(kind=wind_k) :: ir,jr,nr
    character(len=unit_l) :: userunit
    character(len=*), parameter :: rname='SPERANGE>SET>COMM>PARSE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%present,error)
    if (error) return
    if (user%present) then
       userunit = strg_star
       ! Compute number of ranges
       narg = comm%key%getnarg()
       nr = narg/2
       ! Unit when present
       if (modulo(narg,2).eq.1) then
          ! Odd number of arguments => Last argument must be a unit
          call cubetools_getarg(line,comm%key,narg,userunit,mandatory,error)
          if (error) return
       endif
       ! Ranges
       call user%reallocate(nr,error)
       if (error) return
       jr = 0 ! argument counter
       do ir=1,nr
          user%val(ir)%do = user%present
          user%val(ir)%unit = userunit
          call get_next_arg(user%val(ir)%val(1))
          if (error) return
          call get_next_arg(user%val(ir)%val(2))
          if (error) return
       enddo ! ir
    endif
    !
  contains
    !
    subroutine get_next_arg(value)
      ! Use this one as a C macro
      character(len=*), intent(inout) :: value
      !
      jr = jr+1
      call cubetools_getarg(line,comm%key,jr,value,mandatory,error)
    end subroutine get_next_arg
  end subroutine cubetopology_sperange_set_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetopology_sperange_set_user_reallocate(array,n,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sperange_set_user_t), intent(inout) :: array
    integer(kind=wind_k),       intent(in)    :: n
    logical,                    intent(inout) :: error
    !
    logical :: alloc
    integer(kind=4) :: ier
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPERANGE>SET>USER>REALLOCATE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (n.le.0) then
       call cubetopology_message(seve%e,rname,'Negative or zero number of ranges')
       error = .true.
      return
    endif
    !
    if (array%pointeris.eq.code_pointer_allocated) then
       ! The request is to get an allocated pointer
       if (array%n.eq.n) then
          write(mess,'(a,i0)') &
               'sperange_set_user pointer already allocated at the right size: ',n
          call cubetopology_message(toposeve%alloc,rname,mess)
          alloc = .false.
       else
          write(mess,'(a)') &
               'sperange_set_user pointer already allocated but with a different size => Freeing it first'
          call cubetopology_message(toposeve%alloc,rname,mess)
          call cubetopology_sperange_set_user_free(array)
          alloc = .true.
       endif
    else
       ! array%val is either null or associated => need to allocate it anyway
       alloc = .true.
    endif
    if (alloc) then
       allocate(array%val(n),stat=ier)
       if (failed_allocate(rname,'sperange_set_user pointer',ier,error)) return
    endif
    ! Allocation success => array%pointeris may be updated
    array%n = n
    array%pointeris = code_pointer_allocated
  end subroutine cubetopology_sperange_set_user_reallocate
  !
  subroutine cubetopology_sperange_set_user_free(array)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sperange_set_user_t), intent(inout) :: array
    !
    character(len=*), parameter :: rname='ARRAY>LONG>1D>FREE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    if (array%pointeris.eq.code_pointer_allocated) then
       if (associated(array%val)) deallocate(array%val)
    else
       array%val => null()
    endif
    array%n = 0
    array%pointeris = code_pointer_null
  end subroutine cubetopology_sperange_set_user_free
  !
  subroutine cubetopology_sperange_set_user_final(array)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(sperange_set_user_t), intent(inout) :: array
    !
    call cubetopology_sperange_set_user_free(array)
  end subroutine cubetopology_sperange_set_user_final
  !
  subroutine cubetopology_sperange_set_user_toprog(user,cube,prog,error)
    use cube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sperange_set_user_t), intent(in)    :: user
    type(cube_t),               intent(in)    :: cube
    type(sperange_set_prog_t),  intent(inout) :: prog
    logical,                    intent(inout) :: error
    !
    integer(kind=wind_k) :: ir
    character(len=*), parameter :: rname='SPERANGE>SET>USER>TOPROG'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call prog%reallocate(user%n,error)
    if (error) return
    do ir=1,user%n
       call user%val(ir)%toprog(cube,code_sperange_truncated,prog%val(ir),error)
       if (error) return
    enddo ! ir
  end subroutine cubetopology_sperange_set_user_toprog
  !
  subroutine cubetopology_sperange_set_user_list(user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sperange_set_user_t), intent(in)    :: user 
    logical,                    intent(inout) :: error
    !
    integer(kind=wind_k) :: ir
    character(len=*), parameter :: rname='SPERANGE>SET>USER>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    do ir=1,user%n
       call user%val(ir)%list(error)
       if (error) return
    enddo ! ir
  end subroutine cubetopology_sperange_set_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetopology_sperange_set_prog_reallocate(array,n,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sperange_set_prog_t), intent(inout) :: array
    integer(kind=wind_k),       intent(in)    :: n
    logical,                    intent(inout) :: error
    !
    logical :: alloc
    integer(kind=4) :: ier
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPERANGE>SET>PROG>REALLOCATE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (n.le.0) then
       call cubetopology_message(seve%e,rname,'Negative or zero number of ranges')
       error = .true.
      return
    endif
    !
    if (array%pointeris.eq.code_pointer_allocated) then
       ! The request is to get an allocated pointer
       if (array%n.eq.n) then
          write(mess,'(a,i0)') &
               'sperange_set_prog pointer already allocated at the right size: ',n
          call cubetopology_message(toposeve%alloc,rname,mess)
          alloc = .false.
       else
          write(mess,'(a)') &
               'sperange_set_prog pointer already allocated but with a different size => Freeing it first'
          call cubetopology_message(toposeve%alloc,rname,mess)
          call cubetopology_sperange_set_prog_free(array)
          alloc = .true.
       endif
    else
       ! array%val is either null or associated => need to allocate it anyway
       alloc = .true.
    endif
    if (alloc) then
       allocate(array%val(n),stat=ier)
       if (failed_allocate(rname,'sperange_set_prog pointer',ier,error)) return
    endif
    ! Allocation success => array%pointeris may be updated
    array%n = n
    array%pointeris = code_pointer_allocated
  end subroutine cubetopology_sperange_set_prog_reallocate
  !
  subroutine cubetopology_sperange_set_prog_free(array)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sperange_set_prog_t), intent(inout) :: array
    !
    character(len=*), parameter :: rname='ARRAY>LONG>1D>FREE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    if (array%pointeris.eq.code_pointer_allocated) then
       if (associated(array%val)) deallocate(array%val)
    else
       array%val => null()
    endif
    array%n = 0
    array%pointeris = code_pointer_null
  end subroutine cubetopology_sperange_set_prog_free
  !
  subroutine cubetopology_sperange_set_prog_final(array)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(sperange_set_prog_t), intent(inout) :: array
    !
    call cubetopology_sperange_set_prog_free(array)
  end subroutine cubetopology_sperange_set_prog_final
  !
  subroutine cubetopology_sperange_set_prog_list(prog,key,error)
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sperange_set_prog_t), intent(in)    :: prog
    character(len=*),           intent(in)    :: key
    logical,                    intent(inout) :: error
    !
    character(len=mess_l) :: mess
    integer(kind=wind_k) :: ir
    character(len=*), parameter :: rname='SPERANGE>SET>PROG>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetopology_message(seve%r,rname,'')
    mess = cubetools_format_stdkey_boldval(key,'Global Window',40)
    call cubetopology_message(seve%r,rname,mess)
    do ir=1,prog%n
       call prog%val(ir)%list(error)
       if (error) return
    enddo ! ir
  end subroutine cubetopology_sperange_set_prog_list
  !
  subroutine cubetopology_sperange_set_prog_get_into(prog,ir,range,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sperange_set_prog_t), intent(in)    :: prog
    integer(kind=wind_k),       intent(in)    :: ir
    type(sperange_prog_t),      intent(inout) :: range
    logical,                    intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPERANGE>SET>PROG>GET>INTO'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    if ((1.le.ir).and.(ir.le.prog%n)) then
       range = prog%val(ir)
    else
       call cubetopology_message(toposeve%trace,rname,'Trying to get a range outside the available rangeset list')
       error = .true.
       return
    endif
  end subroutine cubetopology_sperange_set_prog_get_into
end module cubetopology_sperange_set_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gtemplate_void
  use gtemplate_messaging
  !
  public :: gtemplate_void_main
  private
  !
contains
  !
  subroutine gtemplate_void_main(line,error)
    !---------------------------------------------------------------------
    ! Does nothing more than returning asap
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line   ! Command line
    logical,          intent(inout) :: error  ! Error flag
    !
    return
  end subroutine gtemplate_void_main
end module gtemplate_void

subroutine sinus_obs(set,obs,sinuspar,last,work,error)
  use gildas_def
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>sinus_obs
  use class_types
  use sinus_parameter
  !---------------------------------------------------------------------
  ! @ private
  ! This version for a single observation.
  ! Subtract a sinusoidal baseline to the input observation
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set          !
  type(observation),   intent(inout) :: obs          ! The observation to work on
  real(kind=4),        intent(in)    :: sinuspar(3)  ! Amplitude Period Phase
  logical,             intent(in)    :: last         ! Subtract last fitted baseline
  real(kind=4),        intent(inout) :: work(*)      ! Working array
  logical,             intent(inout) :: error        ! Error flag
  ! Local
  integer(kind=4) :: ier,nchan
  real(kind=4) :: result(5)
  real(kind=8) :: xoff,dxoff
  !
  save result,xoff  ! Save for BASE LAST
  !
  nchan = obs%cnchan
  ! Remark: obs%cnchan can be different from e.g. size(obs%datax) since
  ! reallocate_obs does not shrink the arrays when loading a smaller
  ! observation.
  !
  ! Initialization
  if (mxcan.lt.nchan) then
     if (allocated(wfit)) deallocate(wfit)
  endif
  if (.not.allocated(wfit)) then
     mxcan = nchan
     allocate(wfit(mxcan),stat=ier)
     if (failed_allocate('SINUS','WFIT',ier,error))  return
  endif
  !
  if (last) then
    ! Compute Delta-X-offset, i.e. the difference of offsets between
    ! the LAST and the current X values, since these offsets are not
    ! in obs%datax
    if (set%unitx(1).eq.'F') then
      dxoff = obs%head%spe%restf - xoff
    elseif (set%unitx(1).eq.'I') then
      dxoff = obs%head%spe%image - xoff
    else
      dxoff = 0.d0
    endif
  else
     if (set%unitx(1).eq.'F') then
       xoff = obs%head%spe%restf
     elseif (set%unitx(1).eq.'I') then
       xoff = obs%head%spe%image
     else
       xoff = 0.d0
     endif
     dxoff = 0.d0
     !
     result(:) = 0.
     par(1:3) = sinuspar(:)
     call fitsinus(set,obs,minsinus,.false.,error)
     result(:) = par(:)
  endif
  !
  work(1:nchan) = result(5) + result(4)*(obs%datax(1:nchan)+dxoff) +  &
    result(1)*sin(2.0*pis*(obs%datax(1:nchan)+dxoff-result(3))/result(2))
  !
  ! Subtract the baseline
  where (obs%spectre(1:nchan).ne.obs%cbad)
    obs%spectre(1:nchan) = obs%spectre(1:nchan) - work(1:nchan)
  end where
  !
  ! Store the fitted values in the header
  obs%head%bas%sigfi = sigbas
  obs%head%bas%sinus(1:2) = result(1:2)
  obs%head%bas%sinus(3) = result(3)-dxoff
  !
end subroutine sinus_obs
!
subroutine fitsinus(set,obs,fcn,liter,error)
  use gildas_def
  use gbl_message
  use fit_minuit
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fitsinus
  use class_types
  use sinus_parameter
  !---------------------------------------------------------------------
  ! @ private
  ! Setup and starts a gauss fit minimisation using minuit
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set  !
  type(observation),   intent(in) :: obs  ! The observation to work on
  interface
    subroutine fcn(npar,g,f,x,iflag,obs)  ! Function to be mininized
    use class_types
    integer(kind=4),   intent(in)  :: npar
    real(kind=8),      intent(out) :: g(npar)
    real(kind=8),      intent(out) :: f
    real(kind=8),      intent(in)  :: x(npar)
    integer(kind=4),   intent(in)  :: iflag
    type(observation), intent(in)  :: obs
    end subroutine fcn
  end interface
  logical,           intent(in)  :: liter  ! Iterate fit
  logical,           intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='BASE SINUS'
  integer(kind=4) :: i,l,ier
  real(kind=8) :: dx,al,ba,du1,du2
  character(len=100) :: mess
  type(fit_minuit_t) :: fit
  !
  ! Added error patch for initialisation
  error = .false.
  ier = 0
  if (set%slev.le.1) then
     fit%verbose = .true.
  else
     fit%verbose = .false.
  endif
  fit%owner = gpack_get_id('class',.true.,error)
  if (error)  return
  fit%maxext=ntot
  fit%maxint=nvar
  !
  ! Initialize values for 1st order polynom component
  call init_sinus(set,obs)
  !
  deltav = abs(obs%datax(obs%cimin+1)-obs%datax(obs%cimin))
  call midsinus(obs,fit,ier,liter)
  if (ier.ne.0) then
     error = .true.
     return
  endif
  call intoex(fit,fit%x)
  fit%up      = sigbas**2
  fit%nfcnmx  = 1000
  fit%epsi    = 0.1d0 * fit%up
  fit%newmin  = 0
  fit%itaur   = 0
  fit%isw(1)  = 0
  fit%isw(3)  = 1
  fit%nfcn    = 1
  fit%vtest   = 0.04
  call fcn(fit%npar,fit%g,fit%amin,fit%u,1,obs)
  !
  ! Simplex minimization
  if (.not.liter) then
     ier = 0
     call simplx(fit,fcn,ier)
     if (ier.ne.0) then
        error = .true.
        return
     endif
  endif
  !
  ! Gradient minimization
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3,obs)
  fit%up = sigbas**2
  fit%epsi  = 0.1d0 * fit%up
  fit%apsi  = fit%epsi
  call hesse(fit,fcn)
  call migrad(fit,fcn,ier)
  if (ier.eq.1) then
     call hesse(fit,fcn)
     ier = 0
  elseif (ier.eq.3) then
     ier = 0
     call migrad(fit,fcn,ier)
     if (ier.eq.1) then
        call hesse(fit,fcn)
     else if (ier.eq.3) then
        call class_message(seve%w,rname,'Sinus did not converged')
     endif
  endif
  if (ier.eq.4) then
     call class_message(seve%e,rname,'Sinus did not converged')
     error =.true.
     return
  endif
  !
  ! Save results for printing
  par(1) = fit%u(1)
  par(2) = fit%u(2)
  par(3) = fit%u(3)
  par(4) = fit%u(4)
  par(5) = fit%u(5)
  fit%nu = 5
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3,obs)
  fit%up = sigbas**2
  !
  ! calculate external errors
  do i=1,fit%nu
     l  = fit%lcorsp(i)
     if (l.eq.0)  then
        fit%werr(i)=0.
     else
        if (fit%isw(2).ge.1)  then
           dx = sqrt(abs(fit%v(l,l)*fit%up))
           if (fit%lcode(i) .gt. 1) then
              al = fit%alim(i)
              ba = fit%blim(i) - al
              du1 = al + 0.5d0 *(sin(fit%x(l)+dx) +1.0d0) * ba - fit%u(i)
              du2 = al + 0.5d0 *(sin(fit%x(l)-dx) +1.0d0) * ba - fit%u(i)
              if (dx.gt.1.0d0)  du1 = ba
              dx = 0.5d0 * (abs(du1) + abs(du2))
           endif
           fit%werr(i) = dx
        endif
     endif
  enddo
  !
  write(mess,1000) sigbas,  &
                   par(1),fit%werr(1),  &
                   par(2),fit%werr(2),  &
                   par(3),fit%werr(3)
  call class_message(seve%i,rname,mess)
  !
1000 format(1x,'bas: ',f7.3,               &
            3x,'I0: ', f8.3,'(',f7.3,')',  &
            4x,'PER: ',f8.3,'(',f7.3,')',  &
            4x,'PHI: ',f8.3,'(',f7.3,')')
end subroutine fitsinus
!
subroutine init_sinus(set,obs)
  use gildas_def
  use sinus_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Initializes parameters for 1st order polynom component of sine fit
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set  !
  type(observation),   intent(in) :: obs  ! The observation to work on
  ! Local
  real(kind=4) :: ainf,asup,xinf,xsup,vv
  integer(kind=4) :: i,kbas,kinf,ksup,iw,imed
  !
  ! Set the weights in wfit
  ! mask window part of the spectrum
  do i=1, obs%cnchan
     wfit(i) = 0
     if (i.lt.obs%cimin.or.i.gt.obs%cimax) goto 30
     if (set%nwind.gt.0) then
        vv = obs%datax(i)
        do iw = 1,set%nwind
           if ((vv-set%wind1(iw))*(vv-set%wind2(iw)).le.0) goto 30
        enddo
     endif
     ! avoid bad channels
     if (obs%spectre(i).eq.obs%cbad) then
        wfit(i)=0
     else
        wfit(i)=1
     endif
30   continue
  enddo
  !
  ! Compute the sigma
  kinf=0
  ksup=0
  ainf = 0.0
  asup = 0.0
  xinf = 0.0
  xsup = 0.0
  imed = (obs%cimax+obs%cimin)/2
  do i=obs%cimin,imed
     if (wfit(i).ne.0) then
        kinf = kinf+1
        ainf = ainf+obs%spectre(i)
        xinf = xinf+obs%datax(i)
     endif
  enddo
  do i=imed,obs%cimax
     if (wfit(i).ne.0) then
        ksup = ksup+1
        asup = asup+obs%spectre(i)
        xsup = xsup+obs%datax(i)
     endif
  enddo
  !
  ! par(4): slope
  ! par(5): ordinate
  if (kinf.ne.0 .and. ksup.ne.0) then
     par(4) = (asup/ksup-ainf/kinf)/(xsup/ksup-xinf/kinf)
     par(5) = (ksup*asup+kinf*ainf)/(ksup+kinf)
  elseif (kinf.ne.0 .or. ksup.ne.0) then
     par(4) = 0.0
     par(5) = (ksup*asup+kinf*ainf)/(ksup+kinf)
  else
     par(4) = 0.0
     par(5) = 0.0
  endif
  !
  ! Compute rms of (spectrum-1st order polynom)
  kbas = 0
  sigbas = 0.0
  do i=obs%cimin,obs%cimax
     if (wfit(i).ne.0) then
        kbas = kbas+1
        sigbas = sigbas + (obs%spectre(i)-par(4)*obs%datax(i)-par(5))**2
     endif
  enddo
  if (kbas.ne.0) then
     sigbas=sqrt(sigbas/kbas)
  else
     sigbas=1.0
  endif
end subroutine init_sinus
!
subroutine sinus_obs_new(set,obs,dosinus,sinuspar,work,error)
  use gbl_message
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>sinus_obs_new
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! This version for a single observation.
  ! Subtract a sinusoidal baseline to the input observation, knowing
  ! its period.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set          !
  type(observation),   intent(inout) :: obs          ! The observation to work on
  logical,             intent(in)    :: dosinus(3)   ! Which parameters are to be fitted?
  real(kind=4),        intent(in)    :: sinuspar(3)  ! Ampli Period Phase
  real(kind=4),        intent(inout) :: work(*)      ! The fitted model
  logical,             intent(inout) :: error        ! Error flag
  ! Local
  character(len=*), parameter :: rname='BASE'
  real(kind=4) :: conti,ampli,period,pulsa,phase
  real(kind=8) :: co,si,sigbas
  real(kind=8) :: A(3,3),B(3,3),V(3),W(3)
  integer(kind=4) :: iw,ichan,nchan
  character(len=message_length) :: mess
  !
  if (dosinus(1) .and. .not.dosinus(2) .and. dosinus(3)) then
    ! Period is fixed, amplitude and phase are free. Compute analytic solution
    ! for formula:
    !   Y[i] = ampli * sin(2*pi*X[i] + phase)
    period = sinuspar(2)
    pulsa = 2.*pis/period
    A(:,:) = 0.d0
    V(:) = 0.d0
CHANLOOP: do ichan=obs%cimin,obs%cimax
      if (obs%spectre(ichan).eq.obs%cbad)  cycle
      do iw=1,set%nwind
        ! Ignore channels in windows. NB: upper and lower bounds may not be ordered
        if ( (obs%datax(ichan)-set%wind1(iw)) *     &
             (obs%datax(ichan)-set%wind2(iw)).le.0. )  cycle CHANLOOP
      enddo
      !
      si = sin(pulsa*obs%datax(ichan))
      co = cos(pulsa*obs%datax(ichan))
      !
      A(1,1) = A(1,1) + 1
      A(1,2) = A(1,2) + si
      A(1,3) = A(1,3) + co
      !
      A(2,1) = A(2,1) + si
      A(2,2) = A(2,2) + si*si
      A(2,3) = A(2,3) + si*co
      !
      A(3,1) = A(3,1) + co
      A(3,2) = A(3,2) + si*co
      A(3,3) = A(3,3) + co*co
      !
      V(1) = V(1) + obs%spectre(ichan)
      V(2) = V(2) + obs%spectre(ichan)*si
      V(3) = V(3) + obs%spectre(ichan)*co
    enddo CHANLOOP
    !
    if (A(1,1).le.0.d0) then
      call class_message(seve%e,rname,'No valid data in range')
      error = .true.
      return
    endif
    !
    call matinv3(A,B)
    !
    call matvec(V,B,W)
    !
    conti = W(1)  ! Continuum level
    ampli = sqrt( W(2)*W(2) + W(3)*W(3) )
    phase = atan2(W(3),W(2))
    !
!   elseif (.not.dosinus(1) .and. .not.dosinus(2) .and. .not.dosinus(3)) then
!     ! All parameters are fixed. Just fit a continuum and apply the values
!     conti =  ZZZ
!     ampli = sinuspar(1)
!     period = sinuspar(2)
!     pulsa = 2.*pis/period
!     phase = sinuspar(3)
    !
  else
    write(mess,'(3(A,L1))')  'NEWSINUS does not support fitting Amplitude ',  &
                             dosinus(1),', Period ',dosinus(2),', Phase ',dosinus(3)
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Convert to the data format formula (in particular the phase is in the same
  ! unit as the period, usually km/s or MHz), from:
  !  Y[i] = ampli * sin(2*pi*X[i] + phase)
  !     to:
  !  Y[i] = ampli * sin(2*pi* (X[i]-phase)/period)
  phase = -phase/pulsa
  !
  ! Feedback
  write(mess,'(4(A,F0.3))') 'NEWSINUS fitted continuum ',conti,', amplitude ',  &
                            ampli,', period ',period,', phase ',phase
  call class_message(seve%i,rname,mess)
  !
  ! Post-processing
  nchan = 0
  sigbas = 0.d0
  do ichan=1,obs%cnchan
    ! Compute the model for all channels (not only cimin to cimax)
    work(ichan) = conti + ampli*sin(pulsa*(obs%datax(ichan)-phase))
    !
    ! Remove model (only for non-bad data)
    if (obs%spectre(ichan).eq.obs%cbad)  cycle
    obs%spectre(ichan) = obs%spectre(ichan)-work(ichan)
    !
    ! Compute sigma (only from cimin to cimax)
    if (ichan.lt.obs%cimin .or. ichan.gt.obs%cimax)  cycle
    nchan = nchan+1
    sigbas = sigbas + obs%spectre(ichan)**2
  enddo
  if (nchan.gt.0)  sigbas = sqrt(sigbas/nchan)
  !
  ! Store the fitted values in the header
  obs%head%bas%sigfi = sigbas
  obs%head%bas%deg = -1
  obs%head%bas%sinus(1) = ampli
  obs%head%bas%sinus(2) = period
  obs%head%bas%sinus(3) = phase
  !
end subroutine sinus_obs_new

function progauss (obs,x0,m,dobase)
  use class_types
  !----------------------------------------------------------------------
  ! @ public (for libclass only)
  ! FIT\ Internal routine
  ! M.eq.0:  Computes the composite profile from sum of all gaussians.
  ! M.ne.0:  Computes the profile from gaussian number M
  !----------------------------------------------------------------------
  real(kind=4) :: progauss  ! Function value on return
  type(observation), intent(in)  :: obs     ! Input observation
  real(kind=4),      intent(in)  :: x0      ! Abscissa
  integer(kind=4),   intent(in)  :: m       ! Sum of components or component num.
  logical,           intent(out) :: dobase  ! Dummy argument for compatibility with PROPOI
  ! Local
  integer(kind=4) :: ifi,ila,i,k
  real(kind=4) :: arg
  !
  progauss=0.
  arg=0.
  dobase = .false.
  !
  if (m.eq.0) then
     ifi = 1
     ila = max(obs%head%gau%nline,1)
  else
     ifi = m
     ila = m
  endif
  !
  do i = ifi,ila
     k = 3*(i-1)+1
     arg = abs((x0-obs%head%gau%nfit(k+1)) / obs%head%gau%nfit(k+2)*1.665109)
     if (arg.lt.4.) then
        progauss = progauss + exp(-arg**2)*obs%head%gau%nfit(k)/obs%head%gau%nfit(k+2)/1.064467
     endif
  enddo
  !
end function progauss
!
function pronh3(obs,vi,m,dobase)
  use class_types
  use hyperfine_structure
  !----------------------------------------------------------------------
  ! @ public (for libclass only)
  ! FIT\ Internal routine
  ! M.eq.0:  Computes the composite profile from sum of all NH3 profiles
  ! M.ne.0:  Computes the profile from gaussian number M
  !----------------------------------------------------------------------
  real(kind=4) :: pronh3  ! Function value on return
  type(observation), intent(in)  :: obs     ! Input observation
  real(kind=4),      intent(in)  :: vi      ! Velocity
  integer(kind=4),   intent(in)  :: m       ! Line number
  logical,           intent(out) :: dobase  ! Dummy argument for compatibility with PROPOI
  ! Local
  real(kind=4) :: t1,o1,toi,arg,v1,d1
  integer(kind=4) :: j
  integer(kind=4) :: ifi,ila,i,ki
  !
  if (m.eq.0) then
    ifi = 1
    ila = max(obs%head%hfs%nline,1)
  else
    ifi = m
    ila = m
  endif
  !
  pronh3=0.
  dobase = .false.
  !
  do i = ifi,ila
    ki = 4*(i-1)
    t1=obs%head%hfs%nfit(1+ki)              ! Tant*Tau
    v1=obs%head%hfs%nfit(2+ki)              ! Velocity
    d1=obs%head%hfs%nfit(3+ki)/1.665109     ! Line width
    o1=obs%head%hfs%nfit(4+ki)              ! Opacity
    toi = 0.
    if (t1.ne.0 .and. d1.ne.0) then
      do j=1,nhyp
        arg = abs ((vi-vhfs(j)-v1)/d1)
        if (arg.lt.4.) then
          toi = toi + o1*rhfs(j)*exp(-(arg**2))
        endif
      enddo
      pronh3 = pronh3 + t1 * (1.-exp(-toi)) / o1
    endif
  enddo
end function pronh3
!
function proabs(obs,vi,m,dobase)
  use classfit_interfaces, except_this=>proabs
  use class_types
  !----------------------------------------------------------------------
  ! @ public (for libclass only)
  ! FIT\ Internal routine
  ! M.eq.0:  Computes the composite profile from sum of all ABS profiles
  ! M.ne.0:  Computes the profile from gaussian number M
  !----------------------------------------------------------------------
  real(kind=4) :: proabs  ! Function value on return
  type(observation), intent(in)  :: obs    ! Input observation
  real(kind=4),      intent(in)  :: vi     ! Velocity
  integer,           intent(in)  :: m      ! Line number
  logical,           intent(out) :: dobase ! Dummy argument for compatibility with PROPOI
  ! Local
  integer :: i
  !
  proabs=0.
  dobase = .false.
  if (m.eq.0) then
     do i=1,obs%head%abs%nline
        proabs = proabs+proabs1(obs,vi,i)
     enddo
     proabs = exp(-proabs)
  else
     proabs = exp(-proabs1(obs,vi,m))
  endif
  ! multiply by continuum level
  proabs = proabs*obs%head%abs%nfit(1)
end function proabs
!
function proabs1(obs,vi,m)
  use class_types
  use hyperfine_structure
  !----------------------------------------------------------------------
  ! @ private
  ! FIT\ internal routine
  !----------------------------------------------------------------------
  real(kind=4) :: proabs1  ! Function value on return
  type(observation), intent(in) :: obs  ! Input observation
  real(kind=4),      intent(in) :: vi   ! abscissa
  integer(kind=4),   intent(in) :: m    ! which component
  ! Local
  real(kind=4) :: t1, v1, d1, arg
  integer(kind=4) :: j
  !
  t1=obs%head%abs%nfit((m-1)*3+2)
  v1=obs%head%abs%nfit((m-1)*3+3)
  d1=obs%head%abs%nfit((m-1)*3+4)/1.665109
  proabs1 = 0.
  if (t1.ne.0 .and. d1.ne.0) then
     do j=1,nhyp
        arg = abs ((vi-vhfs(j)-v1)/d1)
        if (arg.lt.4.) then
           proabs1 = proabs1 + rhfs(j)*exp(-(arg**2))
        endif
     enddo
  endif
  proabs1 = proabs1*t1
end function proabs1
!
function proshell(obs,a,m,error)
  use classfit_interfaces, except_this=>proshell
  use class_types
  !----------------------------------------------------------------------
  ! @ public (for libclass only)
  ! FIT\ Internal routine
  ! M.eq.0:  Computes the composite profile from sum of all NH3 profiles
  ! M.ne.0:  Computes the profile from gaussian number M
  !
  ! Note: X unit is FREQUENCY
  !----------------------------------------------------------------------
  real(kind=4) :: proshell  ! Function value on return
  type(observation), intent(in) :: obs      ! Input observation
  real(kind=4),      intent(in)  :: a       ! Velocity
  integer(kind=4),   intent(in)  :: m       ! Line number
  logical,           intent(out) :: error   ! Logical error flag
  ! Local
  integer(kind=4) :: ifi,ila,i,k,l
  !
  proshell=0.
  !
  if (m.eq.0) then
     ifi = 1
     ila = max(obs%head%she%nline,1)
  else
     ifi = m
     ila = m
  endif
  !
  do i = ifi,ila
     k = 4*(i-1)+1
     l = k+2
     if (obs%head%she%nfit(k).ne.0 .and.obs%head%she%nfit(l).ne.0) then
        call kshell(a,abs(obs%head%spe%fres),obs%head%she%nfit(k),proshell,error)
     endif
  enddo
  !
contains
  subroutine kshell(x0,dx,xp,ff,error)
    use gbl_message
    real(kind=4), intent(in)    :: x0     ! Absissa
    real(kind=8), intent(in)    :: dx     ! Channel width
    real(kind=4), intent(in)    :: xp(4)  ! Profile parameters
    real(kind=4), intent(inout) :: ff     ! Output composite value
    logical,      intent(out)   :: error  ! Logical error flag
    ! Local
    real(kind=4) :: arg,arg0,arg1,f
    character(len=message_length) :: chain
    !
    error = .false.
    if (xp(3).eq.0 .or. xp(1).eq.0) then
      write(chain,*) 'Wrong Arguments :',xp
      call class_message(seve%e,'KSHELL',chain)
      error = .true.
      return
    endif
    !
    ! Define 3 regimes:
    ! 1) Central regime (in the shell model itself),
    ! 2) intermediate regime (1-channel wide) to avoid discontinuity
    !    with the 0-regime,
    ! 3) outer regime (zero-valued) out of the shell.
    !
    ! Say the X axis is normalized with center (0 value) on nu0 and the
    ! horns are found at +-1. The intermediate regime (right side) expands
    ! from 1-halfchannel to 1+halfchannel:
    arg  = abs((xp(2)-x0)/xp(3))  ! Normalized distance from center
    arg0 =      1.-0.5*dx/xp(3)   ! Start of intermediate regime
    arg1 =      1.+0.5*dx/xp(3)   ! End of intermediate regime
    !
    ! xp(1) Area
    ! xp(2) Central frequency
    ! xp(3) Half-width at zero level
    ! xp(4) H parameter
    if (arg.lt.arg0) then      ! Central regime
      f = xp(1)*0.5/xp(3)/(1.+xp(4)/3.) * (1.+xp(4)*arg**2)
    elseif (arg.lt.arg1) then  ! Intermediate regime: continuity between the 2 regimes
      f = xp(1)*0.5/xp(3)/(1.+xp(4)/3.) * (1.+xp(4)*arg0**2) * (arg-arg1)/(arg0-arg1)
    else                       ! Outer regime
      f = 0.
    endif
    ff = ff + f
  end subroutine kshell
end function proshell
!
function propoi(obs,x0,m,dobase)
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! FIT\ Internal routine
  ! M.eq.0:  Computes the composite profile from sum of all ABS profiles
  ! M.ne.0:  Computes the profile from gaussian number M
  ! Computes the profile from gaussian number M
  ! Modified version with a linear baseline. Note that it is called
  ! by GAUSSFIT with a dummy argument DOBASE after M.
  !----------------------------------------------------------------------
  real(kind=4) :: propoi  ! Function value on return
  type(observation), intent(in)  :: obs     ! Input observation
  real(kind=4),      intent(in)  :: x0      ! Value at which the profile should be computed
  integer(kind=4),   intent(in)  :: m       ! Component number (0 = all)
  logical,           intent(out) :: dobase  ! Is A on the line or on the baseline ?
  ! Local
  real(kind=4) :: arg
  integer(kind=4) :: ifi,ila,i,k
  !
  ! Initialization
  ! - linear baseline
  propoi = obs%head%poi%nfit(1) + x0*obs%head%poi%nfit(2)
  arg=0.
  dobase = .true.
  !
  if (m.eq.0) then
     ifi = 1
     ila = max(obs%head%poi%nline,1)
  else
     ifi = m
     ila = m
  endif
  !
  do i = ifi,ila
     k = 3*(i-1)+3
     arg = abs((x0-obs%head%poi%nfit(k+1)) / obs%head%poi%nfit(k+2)*1.665109)
     if (arg.lt.4.) then
        propoi = propoi + exp(-arg**2)*obs%head%poi%nfit(k)/obs%head%poi%nfit(k+2)/1.064467
     endif
     if (arg.lt.2) dobase = .false.
  enddo
end function propoi
!
function propoibased(obs,x0,m,dobase)
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Same as PROPOI but does not fit the baseline, i.e. ignore poi%nfit(1)
  ! and poi%nfit(2).
  !----------------------------------------------------------------------
  real(kind=4) :: propoibased  ! Function value on return
  type(observation), intent(in)  :: obs     ! Input observation
  real(kind=4),      intent(in)  :: x0      ! Value at which the profile should be computed
  integer(kind=4),   intent(in)  :: m       ! Component number (0 = all)
  logical,           intent(out) :: dobase  ! Is A on the line or on the baseline ?
  ! Local
  real(kind=4) :: arg
  integer(kind=4) :: ifi,ila,i,k
  !
  ! Initialization
  propoibased = 0.
  arg=0.
  dobase = .true.
  !
  if (m.eq.0) then
     ifi = 1
     ila = max(obs%head%poi%nline,1)
  else
     ifi = m
     ila = m
  endif
  !
  do i = ifi,ila
     k = 3*(i-1)+3
     arg = abs((x0-obs%head%poi%nfit(k+1)) / obs%head%poi%nfit(k+2)*1.665109)
     if (arg.lt.4.) then
        propoibased = propoibased + exp(-arg**2)*obs%head%poi%nfit(k)/obs%head%poi%nfit(k+2)/1.064467
     endif
     if (arg.lt.2) dobase = .false.
  enddo
end function propoibased

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_sicvar
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubego_messaging
  !
  public :: sicvar_user_t, sicvar_t,sicvar_opt_t
  private
  !
  type sicvar_opt_t
     type(option_t),      pointer :: opt
     type(keywordlist_comm_t), pointer :: status
   contains
     procedure :: register  => cubego_sicvar_register
     procedure :: parse     => cubego_sicvar_parse
     procedure :: user2prog => cubego_sicvar_user2prog
  end type sicvar_opt_t
  !
  type sicvar_user_t
     character(len=varn_l) :: name   = strg_unk
     character(len=argu_l) :: status = strg_unk
  end type sicvar_user_t
  !
  type sicvar_t
     character(len=varn_l) :: name
     logical               :: readonly
   contains
     procedure :: exists => cubego_sicvar_exists
  end type sicvar_t
  !
contains
  !
  subroutine cubego_sicvar_register(opt,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(sicvar_opt_t), intent(out)   :: opt
    logical,             intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: status(2) = ['READ ','WRITE']
    character(len=*), parameter :: rname='SICVAR>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'INTO','varname [status]',&
         'Define the SIC variable name and its status',&
         strg_emp,&
         opt%opt,error)
    if (error) return
    call stdarg%register( &
         'varname',  &
         'Variable name', &
         strg_emp,&
         code_arg_mandatory, &
         error)
    if (error) return
    call keyarg%register( &
         'status',  &
         'READ or WRITE status for variable', &
         'Default is READ',&
         code_arg_optional, &
         status, &
         .not.flexible, &
         opt%status, &
         error)
    if (error) return
  end subroutine cubego_sicvar_register
  !
  subroutine cubego_sicvar_parse(opt,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sicvar_opt_t), intent(in)    :: opt
    character(len=*),    intent(in)    :: line
    type(sicvar_user_t), intent(out)   :: user
    logical,             intent(inout) :: error
    !
    logical dovar
    character(len=*), parameter :: rname='SICVAR>PARSE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call opt%opt%present(line,dovar,error)
    if (error) return
    if (.not.dovar) then
       call cubego_message(seve%e,rname,'Option /INTO is mandatory')
       error = .true.
       return
    else
       call cubetools_getarg(line,opt%opt,1,user%name,mandatory,error)
       if (error) return
       user%status = 'READ'
       call cubetools_getarg(line,opt%opt,2,user%status,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubego_sicvar_parse
  !
  subroutine cubego_sicvar_user2prog(opt,user,prog,error)
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sicvar_opt_t), intent(in)    :: opt
    type(sicvar_user_t), intent(in)    :: user
    type(sicvar_t),      intent(out)   :: prog
    logical,             intent(inout) :: error
    !
    character(len=argu_l) :: status
    integer(kind=4) :: ikey
    character(len=*), parameter :: rname='SICVAR>USER2PROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_disambiguate_toupper(user%name,prog%name,error)
    if (error) return
    call cubetools_keywordlist_user2prog(opt%status,user%status,ikey,status,error)
    if (error) return
    prog%readonly = status.eq.'READ'
  end subroutine cubego_sicvar_user2prog
  !
  subroutine cubego_sicvar_exists(sicvar,error)
    use gkernel_interfaces
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(sicvar_t), intent(in)    :: sicvar
    logical,         intent(inout) :: error
    !
    character(len=*), parameter :: rname='SICVAR>EXISTS'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    if (sic_varexist(trim(sicvar%name))) then
       call cubego_message(goseve%others,rname,trim(sicvar%name)//' user structure already exists')
       call sic_delvariable(trim(sicvar%name),.false.,error)
       if (error) return
    endif
  end subroutine cubego_sicvar_exists
end module cubego_sicvar
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mapping_gaussian_tool
  public :: mulgau
  private
  !
contains
  !
  subroutine mulgau(data,nx,ny,bmaj,bmin,pa,scale,xinc,yinc)
    use phys_const
    !----------------------------------------------------------------------
    ! Multiply the TF of an image by the TF of a convolving gaussian
    ! function. BMAJ and BMIN are the widths of the original gaussian. PA
    ! is the position angle of major axis (from north towards east). SCALE
    ! is a scaling factor.
    !----------------------------------------------------------------------
    integer, intent(in)    :: nx,ny       ! X,Y size
    real,    intent(in)    :: bmaj        ! Major axis
    real,    intent(in)    :: bmin        ! Minor axis
    real,    intent(in)    :: pa          ! Position Angle
    real,    intent(in)    :: scale       ! Flux scale factor
    real,    intent(in)    :: xinc        ! X pixel size
    real,    intent(in)    :: yinc        ! Y pixel size
    complex, intent(inout) :: data(nx,ny) ! TF of Data to be smoothed
    !
    logical :: norot,rot90
    integer :: i,j,nx1,nx2
    real :: amaj,amin,fact,cx,cy,sx,sy,gain,seuil
    real, parameter :: eps=1.e-7
    !
    norot = ( abs(mod(pa,180.)).le.eps)
    rot90 = ( abs(mod(pa,180.)-90.).le.eps)
    amaj = bmaj*pi/(2.*sqrt(log(2.)))
    amin = bmin*pi/(2.*sqrt(log(2.)))
    !
    gain = scale ! For brightness norm.
    seuil = 40.0
    !
    cx = cos(pa*pi/180.0d0)/nx*amin
    cy = cos(pa*pi/180.0d0)/ny*amaj
    sx = sin(pa*pi/180.0d0)/nx*amaj
    sy = sin(pa*pi/180.0d0)/ny*amin
    !
    ! Convert map units to pixels
    cx = cx / xinc
    cy = cy / yinc
    sx = sx / xinc
    sy = sy / yinc
    nx2 = nx/2
    nx1 = nx2+1
    !
    ! Optimised code for Position Angle 0 degrees
    if (norot) then
       do j=1,ny/2
          do i=1,nx2
             fact = (float(j-1)*cy)**2 + (float(i-1)*cx)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
          do i=nx1,nx
             fact = (float(j-1)*cy)**2 + (float(i-nx-1)*cx)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
       enddo
       do j=ny/2+1,ny
          do i=1,nx2
             fact = (float(j-ny-1)*cy)**2 + (float(i-1)*cx)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
          do i=nx1,nx
             fact = (float(j-ny-1)*cy)**2 + (float(i-nx-1)*cx)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
       enddo
       !
       ! Optimised code for Position Angle 90 degrees
    elseif (rot90) then
       do j=1,ny/2
          do i=1,nx2
             fact = (float(i-1)*sx)**2 + (float(j-1)*sy)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
          do i=nx1,nx
             fact = (float(i-nx-1)*sx)**2 + (float(j-1)*sy)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
       enddo
       do j=ny/2+1,ny
          do i=1,nx2
             fact = (float(i-1)*sx)**2 + (float(j-ny-1)*sy)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
          do i=nx1,nx
             fact = (float(i-nx-1)*sx)**2 + (float(j-ny-1)*sy)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
       enddo
    else
       ! General case of a rotated elliptical gaussian
       do j=1,ny/2
          do i=1,nx2
             fact = ( float(i-1)*sx + float(j-1)*cy)**2  &
                  + (-float(i-1)*cx + float(j-1)*sy)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
          do i=nx1,nx
             fact = (  float(i-nx-1)*sx + float(j-1)*cy)**2   &
                  + ( -float(i-nx-1)*cx + float(j-1)*sy)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
       enddo
       do j=ny/2+1,ny
          do i=1,nx2
             fact = ( float(i-1)*sx + float(j-ny-1)*cy)**2   &
                  + (-float(i-1)*cx + float(j-ny-1)*sy)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
          do i=nx1,nx
             fact = ( float(i-nx-1)*sx + float(j-ny-1)*cy)**2 &
                  + (-float(i-nx-1)*cx + float(j-ny-1)*sy)**2
             if (fact.gt.seuil) then
                data(i,j) = 0.0
             else
                data(i,j) = data(i,j)*exp(-fact)*gain
             endif
          enddo
       enddo
    endif
  end subroutine mulgau
end module mapping_gaussian_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK U11LS
      SUBROUTINE U11LS (A, MDA, M, N, UB, DB, MODE, NP, KRANK, KSURE, H,
     +   W, EB, IC, IR)
C***BEGIN PROLOGUE  U11LS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to LLSIA
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (U11LS-S, DU11LS-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C       This routine performs a QR factorization of A
C       using Householder transformations. Row and
C       column pivots are chosen to reduce the growth
C       of round-off and to help detect possible rank
C       deficiency.
C
C***SEE ALSO  LLSIA
C***ROUTINES CALLED  ISAMAX, ISWAP, SAXPY, SDOT, SNRM2, SSCAL, SSWAP,
C                    XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891009  Removed unreferenced variable.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  U11LS
      DIMENSION A(MDA,*),UB(*),DB(*),H(*),W(*),EB(*)
      INTEGER IC(*),IR(*)
C
C        INITIALIZATION
C
C***FIRST EXECUTABLE STATEMENT  U11LS
      J=0
      KRANK=N
      DO 10 I=1,N
      IC(I)=I
   10 CONTINUE
      DO 12 I=1,M
      IR(I)=I
   12 CONTINUE
C
C        DETERMINE REL AND ABS ERROR VECTORS
C
C
C
C        CALCULATE COL LENGTH
C
      DO 30 I=1,N
      H(I)=SNRM2(M,A(1,I),1)
      W(I)=H(I)
   30 CONTINUE
C
C         INITIALIZE ERROR BOUNDS
C
      DO  40 I=1,N
      EB(I)=MAX(DB(I),UB(I)*H(I))
      UB(I)=EB(I)
      DB(I)=0.0
   40 CONTINUE
C
C          DISCARD SELF DEPENDENT COLUMNS
C
      I=1
   50 IF(EB(I).GE.H(I)) GO TO 60
      IF(I.EQ.KRANK) GO TO 70
      I=I+1
      GO TO 50
C
C          MATRIX REDUCTION
C
   60 CONTINUE
      KK=KRANK
      KRANK=KRANK-1
      IF(MODE.EQ.0) RETURN
      IF(I.GT.NP) GO TO  64
      CALL XERMSG ('SLATEC', 'U11LS',
     +   'FIRST NP COLUMNS ARE LINEARLY DEPENDENT', 8, 0)
      KRANK=I-1
      RETURN
   64 CONTINUE
      IF(I.GT.KRANK) GO TO 70
      CALL SSWAP(1,EB(I),1,EB(KK),1)
      CALL SSWAP(1,UB(I),1,UB(KK),1)
      CALL SSWAP(1,W(I),1,W(KK),1)
      CALL SSWAP(1,H(I),1,H(KK),1)
      CALL ISWAP(1,IC(I),1,IC(KK),1)
      CALL SSWAP(M,A(1,I),1,A(1,KK),1)
      GO TO 50
C
C           TEST FOR ZERO RANK
C
   70 IF(KRANK.GT.0) GO TO 80
      KRANK=0
      KSURE=0
      RETURN
   80 CONTINUE
C
C        M A I N    L O O P
C
  110 CONTINUE
      J=J+1
      JP1=J+1
      JM1=J-1
      KZ=KRANK
      IF(J.LE.NP) KZ=J
C
C        EACH COL HAS MM=M-J+1 COMPONENTS
C
      MM=M-J+1
C
C         UB DETERMINES COLUMN PIVOT
C
  115 IMIN=J
      IF(H(J).EQ.0.) GO TO 170
      RMIN=UB(J)/H(J)
      DO 120 I=J,KZ
      IF(UB(I).GE.H(I)*RMIN) GO TO 120
      RMIN=UB(I)/H(I)
      IMIN=I
  120 CONTINUE
C
C     TEST FOR RANK DEFICIENCY
C
      IF(RMIN.LT.1.0) GO TO 200
      TT=(EB(IMIN)+ABS(DB(IMIN)))/H(IMIN)
      IF(TT.GE.1.0) GO TO 170
C     COMPUTE EXACT UB
      DO 125 I=1,JM1
      W(I)=A(I,IMIN)
  125 CONTINUE
      L=JM1
  130 W(L)=W(L)/A(L,L)
      IF(L.EQ.1) GO TO 150
      LM1=L-1
      DO 140 I=L,JM1
      W(LM1)=W(LM1)-A(LM1,I)*W(I)
  140 CONTINUE
      L=LM1
      GO TO 130
  150 TT=EB(IMIN)
      DO 160 I=1,JM1
      TT=TT+ABS(W(I))*EB(I)
  160 CONTINUE
      UB(IMIN)=TT
      IF(UB(IMIN)/H(IMIN).GE.1.0) GO TO 170
      GO TO 200
C
C        MATRIX REDUCTION
C
  170 CONTINUE
      KK=KRANK
      KRANK=KRANK-1
      KZ=KRANK
      IF(MODE.EQ.0) RETURN
      IF(J.GT.NP) GO TO 172
      CALL XERMSG ('SLATEC', 'U11LS',
     +   'FIRST NP COLUMNS ARE LINEARLY DEPENDENT', 8, 0)
      KRANK=J-1
      RETURN
  172 CONTINUE
      IF(IMIN.GT.KRANK) GO TO 180
      CALL ISWAP(1,IC(IMIN),1,IC(KK),1)
      CALL SSWAP(M,A(1,IMIN),1,A(1,KK),1)
      CALL SSWAP(1,EB(IMIN),1,EB(KK),1)
      CALL SSWAP(1,UB(IMIN),1,UB(KK),1)
      CALL SSWAP(1,DB(IMIN),1,DB(KK),1)
      CALL SSWAP(1,W(IMIN),1,W(KK),1)
      CALL SSWAP(1,H(IMIN),1,H(KK),1)
  180 IF(J.GT.KRANK) GO TO 300
      GO TO 115
C
C        COLUMN PIVOT
C
  200 IF(IMIN.EQ.J) GO TO 230
      CALL SSWAP(1,H(J),1,H(IMIN),1)
      CALL SSWAP(M,A(1,J),1,A(1,IMIN),1)
      CALL SSWAP(1,EB(J),1,EB(IMIN),1)
      CALL SSWAP(1,UB(J),1,UB(IMIN),1)
      CALL SSWAP(1,DB(J),1,DB(IMIN),1)
      CALL SSWAP(1,W(J),1,W(IMIN),1)
      CALL ISWAP(1,IC(J),1,IC(IMIN),1)
C
C        ROW PIVOT
C
  230 CONTINUE
      JMAX=ISAMAX(MM,A(J,J),1)
      JMAX=JMAX+J-1
      IF(JMAX.EQ.J) GO TO 240
      CALL SSWAP(N,A(J,1),MDA,A(JMAX,1),MDA)
      CALL ISWAP(1,IR(J),1,IR(JMAX),1)
  240 CONTINUE
C
C     APPLY HOUSEHOLDER TRANSFORMATION
C
      TN=SNRM2(MM,A(J,J),1)
      IF(TN.EQ.0.0) GO TO 170
      IF(A(J,J).NE.0.0) TN=SIGN(TN,A(J,J))
      CALL SSCAL(MM,1.0/TN,A(J,J),1)
      A(J,J)=A(J,J)+1.0
      IF(J.EQ.N) GO TO 250
      DO 248 I=JP1,N
      BB=-SDOT(MM,A(J,J),1,A(J,I),1)/A(J,J)
      CALL SAXPY(MM,BB,A(J,J),1,A(J,I),1)
      IF(I.LE.NP) GO TO 248
      IF(H(I).EQ.0.0) GO TO 248
      TT=1.0-(ABS(A(J,I))/H(I))**2
      TT=MAX(TT,0.0)
      T=TT
      TT=1.0+.05*TT*(H(I)/W(I))**2
      IF(TT.EQ.1.0) GO TO 244
      H(I)=H(I)*SQRT(T)
      GO TO 246
  244 CONTINUE
      H(I)=SNRM2(M-J,A(J+1,I),1)
      W(I)=H(I)
  246 CONTINUE
  248 CONTINUE
  250 CONTINUE
      H(J)=A(J,J)
      A(J,J)=-TN
C
C
C          UPDATE UB, DB
C
      UB(J)=UB(J)/ABS(A(J,J))
      DB(J)=(SIGN(EB(J),DB(J))+DB(J))/A(J,J)
      IF(J.EQ.KRANK) GO TO 300
      DO 260 I=JP1,KRANK
      UB(I)=UB(I)+ABS(A(J,I))*UB(J)
      DB(I)=DB(I)-A(J,I)*DB(J)
  260 CONTINUE
      GO TO 110
C
C        E N D    M A I N    L O O P
C
  300 CONTINUE
C
C        COMPUTE KSURE
C
      KM1=KRANK-1
      DO 318 I=1,KM1
      IS=0
      KMI=KRANK-I
      DO 315 II=1,KMI
      IF(UB(II).LE.UB(II+1)) GO TO 315
      IS=1
      TEMP=UB(II)
      UB(II)=UB(II+1)
      UB(II+1)=TEMP
  315 CONTINUE
      IF(IS.EQ.0) GO TO 320
  318 CONTINUE
  320 CONTINUE
      KSURE=0
      SUM=0.0
      DO 328 I=1,KRANK
      R2=UB(I)*UB(I)
      IF(R2+SUM.GE.1.0) GO TO 330
      SUM=SUM+R2
      KSURE=KSURE+1
  328 CONTINUE
  330 CONTINUE
C
C     IF SYSTEM IS OF REDUCED RANK AND MODE = 2
C     COMPLETE THE DECOMPOSITION FOR SHORTEST LEAST SQUARES SOLUTION
C
      IF(KRANK.EQ.N .OR. MODE.LT.2) GO TO 360
      NMK=N-KRANK
      KP1=KRANK+1
      I=KRANK
  340 TN=SNRM2(NMK,A(I,KP1),MDA)/A(I,I)
      TN=A(I,I)*SQRT(1.0+TN*TN)
      CALL SSCAL(NMK,1.0/TN,A(I,KP1),MDA)
      W(I)=A(I,I)/TN+1.0
      A(I,I)=-TN
      IF(I.EQ.1) GO TO 350
      IM1=I-1
      DO 345 II=1,IM1
      TT=-SDOT(NMK,A(II,KP1),MDA,A(I,KP1),MDA)/W(I)
      TT=TT-A(II,I)
      CALL SAXPY(NMK,TT,A(I,KP1),MDA,A(II,KP1),MDA)
      A(II,I)=A(II,I)+TT*W(I)
  345 CONTINUE
      I=I-1
      GO TO 340
  350 CONTINUE
  360 CONTINUE
      RETURN
      END
*DECK U11US
      SUBROUTINE U11US (A, MDA, M, N, UB, DB, MODE, NP, KRANK, KSURE, H,
     +   W, EB, IR, IC)
C***BEGIN PROLOGUE  U11US
C***SUBSIDIARY
C***PURPOSE  Subsidiary to ULSIA
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (U11US-S, DU11US-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C       This routine performs an LQ factorization of the
C       matrix A using Householder transformations. Row
C       and column pivots are chosen to reduce the growth
C       of round-off and to help detect possible rank
C       deficiency.
C
C***SEE ALSO  ULSIA
C***ROUTINES CALLED  ISAMAX, ISWAP, SAXPY, SDOT, SNRM2, SSCAL, SSWAP,
C                    XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  U11US
      DIMENSION A(MDA,*),UB(*),DB(*),H(*),W(*),EB(*)
      INTEGER IC(*),IR(*)
C
C        INITIALIZATION
C
C***FIRST EXECUTABLE STATEMENT  U11US
      J=0
      KRANK=M
      DO 10 I=1,N
      IC(I)=I
   10 CONTINUE
      DO 12 I=1,M
      IR(I)=I
   12 CONTINUE
C
C        DETERMINE REL AND ABS ERROR VECTORS
C
C
C
C        CALCULATE ROW LENGTH
C
      DO 30 I=1,M
      H(I)=SNRM2(N,A(I,1),MDA)
      W(I)=H(I)
   30 CONTINUE
C
C         INITIALIZE ERROR BOUNDS
C
      DO  40 I=1,M
      EB(I)=MAX(DB(I),UB(I)*H(I))
      UB(I)=EB(I)
      DB(I)=0.0
   40 CONTINUE
C
C          DISCARD SELF DEPENDENT ROWS
C
      I=1
   50 IF(EB(I).GE.H(I)) GO TO 60
      IF(I.EQ.KRANK) GO TO 70
      I=I+1
      GO TO 50
C
C          MATRIX REDUCTION
C
   60 CONTINUE
      KK=KRANK
      KRANK=KRANK-1
      IF(MODE.EQ.0) RETURN
      IF(I.GT.NP) GO TO  64
      CALL XERMSG ('SLATEC', 'U11US',
     +   'FIRST NP ROWS ARE LINEARLY DEPENDENT', 8, 0)
      KRANK=I-1
      RETURN
   64 CONTINUE
      IF(I.GT.KRANK) GO TO 70
      CALL SSWAP(1,EB(I),1,EB(KK),1)
      CALL SSWAP(1,UB(I),1,UB(KK),1)
      CALL SSWAP(1,W(I),1,W(KK),1)
      CALL SSWAP(1,H(I),1,H(KK),1)
      CALL ISWAP(1,IR(I),1,IR(KK),1)
      CALL SSWAP(N,A(I,1),MDA,A(KK,1),MDA)
      GO TO 50
C
C           TEST FOR ZERO RANK
C
   70 IF(KRANK.GT.0) GO TO 80
      KRANK=0
      KSURE=0
      RETURN
   80 CONTINUE
C
C        M A I N    L O O P
C
  110 CONTINUE
      J=J+1
      JP1=J+1
      JM1=J-1
      KZ=KRANK
      IF(J.LE.NP) KZ=J
C
C        EACH ROW HAS NN=N-J+1 COMPONENTS
C
      NN=N-J+1
C
C         UB DETERMINES ROW PIVOT
C
  115 IMIN=J
      IF(H(J).EQ.0.) GO TO 170
      RMIN=UB(J)/H(J)
      DO 120 I=J,KZ
      IF(UB(I).GE.H(I)*RMIN) GO TO 120
      RMIN=UB(I)/H(I)
      IMIN=I
  120 CONTINUE
C
C     TEST FOR RANK DEFICIENCY
C
      IF(RMIN.LT.1.0) GO TO 200
      TT=(EB(IMIN)+ABS(DB(IMIN)))/H(IMIN)
      IF(TT.GE.1.0) GO TO 170
C     COMPUTE EXACT UB
      DO 125 I=1,JM1
      W(I)=A(IMIN,I)
  125 CONTINUE
      L=JM1
  130 W(L)=W(L)/A(L,L)
      IF(L.EQ.1) GO TO 150
      LM1=L-1
      DO 140 I=L,JM1
      W(LM1)=W(LM1)-A(I,LM1)*W(I)
  140 CONTINUE
      L=LM1
      GO TO 130
  150 TT=EB(IMIN)
      DO 160 I=1,JM1
      TT=TT+ABS(W(I))*EB(I)
  160 CONTINUE
      UB(IMIN)=TT
      IF(UB(IMIN)/H(IMIN).GE.1.0) GO TO 170
      GO TO 200
C
C        MATRIX REDUCTION
C
  170 CONTINUE
      KK=KRANK
      KRANK=KRANK-1
      KZ=KRANK
      IF(MODE.EQ.0) RETURN
      IF(J.GT.NP) GO TO 172
      CALL XERMSG ('SLATEC', 'U11US',
     +   'FIRST NP ROWS ARE LINEARLY DEPENDENT', 8, 0)
      KRANK=J-1
      RETURN
  172 CONTINUE
      IF(IMIN.GT.KRANK) GO TO 180
      CALL ISWAP(1,IR(IMIN),1,IR(KK),1)
      CALL SSWAP(N,A(IMIN,1),MDA,A(KK,1),MDA)
      CALL SSWAP(1,EB(IMIN),1,EB(KK),1)
      CALL SSWAP(1,UB(IMIN),1,UB(KK),1)
      CALL SSWAP(1,DB(IMIN),1,DB(KK),1)
      CALL SSWAP(1,W(IMIN),1,W(KK),1)
      CALL SSWAP(1,H(IMIN),1,H(KK),1)
  180 IF(J.GT.KRANK) GO TO 300
      GO TO 115
C
C        ROW PIVOT
C
  200 IF(IMIN.EQ.J) GO TO 230
      CALL SSWAP(1,H(J),1,H(IMIN),1)
      CALL SSWAP(N,A(J,1),MDA,A(IMIN,1),MDA)
      CALL SSWAP(1,EB(J),1,EB(IMIN),1)
      CALL SSWAP(1,UB(J),1,UB(IMIN),1)
      CALL SSWAP(1,DB(J),1,DB(IMIN),1)
      CALL SSWAP(1,W(J),1,W(IMIN),1)
      CALL ISWAP(1,IR(J),1,IR(IMIN),1)
C
C        COLUMN PIVOT
C
  230 CONTINUE
      JMAX=ISAMAX(NN,A(J,J),MDA)
      JMAX=JMAX+J-1
      IF(JMAX.EQ.J) GO TO 240
      CALL SSWAP(M,A(1,J),1,A(1,JMAX),1)
      CALL ISWAP(1,IC(J),1,IC(JMAX),1)
  240 CONTINUE
C
C     APPLY HOUSEHOLDER TRANSFORMATION
C
      TN=SNRM2(NN,A(J,J),MDA)
      IF(TN.EQ.0.0) GO TO 170
      IF(A(J,J).NE.0.0) TN=SIGN(TN,A(J,J))
      CALL SSCAL(NN,1.0/TN,A(J,J),MDA)
      A(J,J)=A(J,J)+1.0
      IF(J.EQ.M) GO TO 250
      DO 248 I=JP1,M
      BB=-SDOT(NN,A(J,J),MDA,A(I,J),MDA)/A(J,J)
      CALL SAXPY(NN,BB,A(J,J),MDA,A(I,J),MDA)
      IF(I.LE.NP) GO TO 248
      IF(H(I).EQ.0.0) GO TO 248
      TT=1.0-(ABS(A(I,J))/H(I))**2
      TT=MAX(TT,0.0)
      T=TT
      TT=1.0+.05*TT*(H(I)/W(I))**2
      IF(TT.EQ.1.0) GO TO 244
      H(I)=H(I)*SQRT(T)
      GO TO 246
  244 CONTINUE
      H(I)=SNRM2(N-J,A(I,J+1),MDA)
      W(I)=H(I)
  246 CONTINUE
  248 CONTINUE
  250 CONTINUE
      H(J)=A(J,J)
      A(J,J)=-TN
C
C
C          UPDATE UB, DB
C
      UB(J)=UB(J)/ABS(A(J,J))
      DB(J)=(SIGN(EB(J),DB(J))+DB(J))/A(J,J)
      IF(J.EQ.KRANK) GO TO 300
      DO 260 I=JP1,KRANK
      UB(I)=UB(I)+ABS(A(I,J))*UB(J)
      DB(I)=DB(I)-A(I,J)*DB(J)
  260 CONTINUE
      GO TO 110
C
C        E N D    M A I N    L O O P
C
  300 CONTINUE
C
C        COMPUTE KSURE
C
      KM1=KRANK-1
      DO 318 I=1,KM1
      IS=0
      KMI=KRANK-I
      DO 315 II=1,KMI
      IF(UB(II).LE.UB(II+1)) GO TO 315
      IS=1
      TEMP=UB(II)
      UB(II)=UB(II+1)
      UB(II+1)=TEMP
  315 CONTINUE
      IF(IS.EQ.0) GO TO 320
  318 CONTINUE
  320 CONTINUE
      KSURE=0
      SUM=0.0
      DO 328 I=1,KRANK
      R2=UB(I)*UB(I)
      IF(R2+SUM.GE.1.0) GO TO 330
      SUM=SUM+R2
      KSURE=KSURE+1
  328 CONTINUE
  330 CONTINUE
C
C     IF SYSTEM IS OF REDUCED RANK AND MODE = 2
C     COMPLETE THE DECOMPOSITION FOR SHORTEST LEAST SQUARES SOLUTION
C
      IF(KRANK.EQ.M .OR. MODE.LT.2) GO TO 360
      MMK=M-KRANK
      KP1=KRANK+1
      I=KRANK
  340 TN=SNRM2(MMK,A(KP1,I),1)/A(I,I)
      TN=A(I,I)*SQRT(1.0+TN*TN)
      CALL SSCAL(MMK,1.0/TN,A(KP1,I),1)
      W(I)=A(I,I)/TN+1.0
      A(I,I)=-TN
      IF(I.EQ.1) GO TO 350
      IM1=I-1
      DO 345 II=1,IM1
      TT=-SDOT(MMK,A(KP1,II),1,A(KP1,I),1)/W(I)
      TT=TT-A(I,II)
      CALL SAXPY(MMK,TT,A(KP1,I),1,A(KP1,II),1)
      A(I,II)=A(I,II)+TT*W(I)
  345 CONTINUE
      I=I-1
      GO TO 340
  350 CONTINUE
  360 CONTINUE
      RETURN
      END
*DECK U12LS
      SUBROUTINE U12LS (A, MDA, M, N, B, MDB, NB, MODE, KRANK, RNORM, H,
     +   W, IC, IR)
C***BEGIN PROLOGUE  U12LS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to LLSIA
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (U12LS-S, DU12LS-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C        Given the Householder QR factorization of A, this
C        subroutine solves the system AX=B. If the system
C        is of reduced rank, this routine returns a solution
C        according to the selected mode.
C
C       Note - If MODE.NE.2, W is never accessed.
C
C***SEE ALSO  LLSIA
C***ROUTINES CALLED  SAXPY, SDOT, SNRM2, SSWAP
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  U12LS
      DIMENSION A(MDA,*),B(MDB,*),RNORM(*),H(*),W(*)
      INTEGER IC(*),IR(*)
C***FIRST EXECUTABLE STATEMENT  U12LS
      K=KRANK
      KP1=K+1
C
C        RANK=0
C
      IF(K.GT.0) GO TO 410
      DO 404 JB=1,NB
      RNORM(JB)=SNRM2(M,B(1,JB),1)
  404 CONTINUE
      DO 406 JB=1,NB
      DO 406 I=1,N
      B(I,JB)=0.0
  406 CONTINUE
      RETURN
C
C     REORDER B TO REFLECT ROW INTERCHANGES
C
  410 CONTINUE
      I=0
  412 I=I+1
      IF(I.EQ.M) GO TO 418
      J=IR(I)
      IF(J.EQ.I) GO TO 412
      IF(J.LT.0) GO TO 412
      IR(I)=-IR(I)
      DO 413 JB=1,NB
      RNORM(JB)=B(I,JB)
  413 CONTINUE
      IJ=I
  414 DO 415 JB=1,NB
      B(IJ,JB)=B(J,JB)
  415 CONTINUE
      IJ=J
      J=IR(IJ)
      IR(IJ)=-IR(IJ)
      IF(J.NE.I) GO TO 414
      DO 416 JB=1,NB
      B(IJ,JB)=RNORM(JB)
  416 CONTINUE
      GO TO 412
  418 CONTINUE
      DO 420 I=1,M
      IR(I)=ABS(IR(I))
  420 CONTINUE
C
C     APPLY HOUSEHOLDER TRANSFORMATIONS TO B
C
      DO 430 J=1,K
      TT=A(J,J)
      A(J,J)=H(J)
      DO 425 I=1,NB
      BB=-SDOT(M-J+1,A(J,J),1,B(J,I),1)/H(J)
      CALL SAXPY(M-J+1,BB,A(J,J),1,B(J,I),1)
  425 CONTINUE
      A(J,J)=TT
  430 CONTINUE
C
C        FIND NORMS OF RESIDUAL VECTOR(S)..(BEFORE OVERWRITE B)
C
      DO 440 JB=1,NB
      RNORM(JB)=SNRM2((M-K),B(KP1,JB),1)
  440 CONTINUE
C
C     BACK SOLVE UPPER TRIANGULAR R
C
      I=K
  442 DO 444 JB=1,NB
      B(I,JB)=B(I,JB)/A(I,I)
  444 CONTINUE
      IF(I.EQ.1) GO TO 450
      IM1=I-1
      DO 448 JB=1,NB
      CALL SAXPY(IM1,-B(I,JB),A(1,I),1,B(1,JB),1)
  448 CONTINUE
      I=IM1
      GO TO 442
  450 CONTINUE
C
C     RANK LT N
C
C      TRUNCATED SOLUTION
C
      IF(K.EQ.N) GO TO 480
      DO 460 JB=1,NB
      DO 460 I=KP1,N
      B(I,JB)=0.0
  460 CONTINUE
      IF(MODE.EQ.1) GO TO 480
C
C      MINIMAL LENGTH SOLUTION
C
      NMK=N-K
      DO 470 JB=1,NB
      DO 465 I=1,K
      TT=-SDOT(NMK,A(I,KP1),MDA,B(KP1,JB),1)/W(I)
      TT=TT-B(I,JB)
      CALL SAXPY(NMK,TT,A(I,KP1),MDA,B(KP1,JB),1)
      B(I,JB)=B(I,JB)+TT*W(I)
  465 CONTINUE
  470 CONTINUE
C
C
C     REORDER B TO REFLECT COLUMN INTERCHANGES
C
  480 CONTINUE
      I=0
  482 I=I+1
      IF(I.EQ.N) GO TO 488
      J=IC(I)
      IF(J.EQ.I) GO TO 482
      IF(J.LT.0) GO TO 482
      IC(I)=-IC(I)
  484 CALL SSWAP(NB,B(J,1),MDB,B(I,1),MDB)
      IJ=IC(J)
      IC(J)=-IC(J)
      J=IJ
      IF(J.EQ.I) GO TO 482
      GO TO 484
  488 CONTINUE
      DO 490 I=1,N
      IC(I)=ABS(IC(I))
  490 CONTINUE
C
C        SOLUTION VECTORS ARE IN FIRST N ROWS OF B(,)
C
      RETURN
      END
*DECK U12US
      SUBROUTINE U12US (A, MDA, M, N, B, MDB, NB, MODE, KRANK, RNORM, H,
     +   W, IR, IC)
C***BEGIN PROLOGUE  U12US
C***SUBSIDIARY
C***PURPOSE  Subsidiary to ULSIA
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (U12US-S, DU12US-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C        Given the Householder LQ factorization of A, this
C        subroutine solves the system AX=B. If the system
C        is of reduced rank, this routine returns a solution
C        according to the selected mode.
C
C       Note - If MODE.NE.2, W is never accessed.
C
C***SEE ALSO  ULSIA
C***ROUTINES CALLED  SAXPY, SDOT, SNRM2, SSWAP
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  U12US
      DIMENSION A(MDA,*),B(MDB,*),RNORM(*),H(*),W(*)
      INTEGER IC(*),IR(*)
C***FIRST EXECUTABLE STATEMENT  U12US
      K=KRANK
      KP1=K+1
C
C        RANK=0
C
      IF(K.GT.0) GO TO 410
      DO 404 JB=1,NB
      RNORM(JB)=SNRM2(M,B(1,JB),1)
  404 CONTINUE
      DO 406 JB=1,NB
      DO 406 I=1,N
      B(I,JB)=0.0
  406 CONTINUE
      RETURN
C
C     REORDER B TO REFLECT ROW INTERCHANGES
C
  410 CONTINUE
      I=0
  412 I=I+1
      IF(I.EQ.M) GO TO 418
      J=IR(I)
      IF(J.EQ.I) GO TO 412
      IF(J.LT.0) GO TO 412
      IR(I)=-IR(I)
      DO 413 JB=1,NB
      RNORM(JB)=B(I,JB)
  413 CONTINUE
      IJ=I
  414 DO 415 JB=1,NB
      B(IJ,JB)=B(J,JB)
  415 CONTINUE
      IJ=J
      J=IR(IJ)
      IR(IJ)=-IR(IJ)
      IF(J.NE.I) GO TO 414
      DO 416 JB=1,NB
      B(IJ,JB)=RNORM(JB)
  416 CONTINUE
      GO TO 412
  418 CONTINUE
      DO 420 I=1,M
      IR(I)=ABS(IR(I))
  420 CONTINUE
C
C     IF A IS OF REDUCED RANK AND MODE=2,
C     APPLY HOUSEHOLDER TRANSFORMATIONS TO B
C
      IF(MODE.LT.2 .OR. K.EQ.M) GO TO 440
      MMK=M-K
      DO 430 JB=1,NB
      DO 425 J=1,K
      I=KP1-J
      TT=-SDOT(MMK,A(KP1,I),1,B(KP1,JB),1)/W(I)
      TT=TT-B(I,JB)
      CALL SAXPY(MMK,TT,A(KP1,I),1,B(KP1,JB),1)
      B(I,JB)=B(I,JB)+TT*W(I)
  425 CONTINUE
  430 CONTINUE
C
C     FIND NORMS OF RESIDUAL VECTOR(S)..(BEFORE OVERWRITE B)
C
  440 DO 442 JB=1,NB
      RNORM(JB)=SNRM2((M-K),B(KP1,JB),1)
  442 CONTINUE
C
C     BACK SOLVE LOWER TRIANGULAR L
C
      DO 450 JB=1,NB
      DO 448 I=1,K
      B(I,JB)=B(I,JB)/A(I,I)
      IF(I.EQ.K) GO TO 450
      IP1=I+1
      CALL SAXPY(K-I,-B(I,JB),A(IP1,I),1,B(IP1,JB),1)
  448 CONTINUE
  450 CONTINUE
C
C
C      TRUNCATED SOLUTION
C
      IF(K.EQ.N) GO TO 462
      DO 460 JB=1,NB
      DO 460 I=KP1,N
      B(I,JB)=0.0
  460 CONTINUE
C
C     APPLY HOUSEHOLDER TRANSFORMATIONS TO B
C
  462 DO 470 I=1,K
      J=KP1-I
      TT=A(J,J)
      A(J,J)=H(J)
      DO 465 JB=1,NB
      BB=-SDOT(N-J+1,A(J,J),MDA,B(J,JB),1)/H(J)
      CALL SAXPY(N-J+1,BB,A(J,J),MDA,B(J,JB),1)
  465 CONTINUE
      A(J,J)=TT
  470 CONTINUE
C
C
C     REORDER B TO REFLECT COLUMN INTERCHANGES
C
      I=0
  482 I=I+1
      IF(I.EQ.N) GO TO 488
      J=IC(I)
      IF(J.EQ.I) GO TO 482
      IF(J.LT.0) GO TO 482
      IC(I)=-IC(I)
  484 CALL SSWAP(NB,B(J,1),MDB,B(I,1),MDB)
      IJ=IC(J)
      IC(J)=-IC(J)
      J=IJ
      IF(J.EQ.I) GO TO 482
      GO TO 484
  488 CONTINUE
      DO 490 I=1,N
      IC(I)=ABS(IC(I))
  490 CONTINUE
C
C        SOLUTION VECTORS ARE IN FIRST N ROWS OF B(,)
C
      RETURN
      END
*DECK ULSIA
      SUBROUTINE ULSIA (A, MDA, M, N, B, MDB, NB, RE, AE, KEY, MODE, NP,
     +   KRANK, KSURE, RNORM, W, LW, IWORK, LIW, INFO)
C***BEGIN PROLOGUE  ULSIA
C***PURPOSE  Solve an underdetermined linear system of equations by
C            performing an LQ factorization of the matrix using
C            Householder transformations.  Emphasis is put on detecting
C            possible rank deficiency.
C***LIBRARY   SLATEC
C***CATEGORY  D9
C***TYPE      SINGLE PRECISION (ULSIA-S, DULSIA-D)
C***KEYWORDS  LINEAR LEAST SQUARES, LQ FACTORIZATION,
C             UNDERDETERMINED LINEAR SYSTEM
C***AUTHOR  Manteuffel, T. A., (LANL)
C***DESCRIPTION
C
C     ULSIA computes the minimal length solution(s) to the problem AX=B
C     where A is an M by N matrix with M.LE.N and B is the M by NB
C     matrix of right hand sides.  User input bounds on the uncertainty
C     in the elements of A are used to detect numerical rank deficiency.
C     The algorithm employs a row and column pivot strategy to
C     minimize the growth of uncertainty and round-off errors.
C
C     ULSIA requires (MDA+1)*N + (MDB+1)*NB + 6*M dimensioned space
C
C   ******************************************************************
C   *                                                                *
C   *         WARNING - All input arrays are changed on exit.        *
C   *                                                                *
C   ******************************************************************
C
C     Input..
C
C     A(,)          Linear coefficient matrix of AX=B, with MDA the
C      MDA,M,N      actual first dimension of A in the calling program.
C                   M is the row dimension (no. of EQUATIONS of the
C                   problem) and N the col dimension (no. of UNKNOWNS).
C                   Must have MDA.GE.M and M.LE.N.
C
C     B(,)          Right hand side(s), with MDB the actual first
C      MDB,NB       dimension of B in the calling program. NB is the
C                   number of M by 1 right hand sides.  Since the
C                   solution is returned in B, must have MDB.GE.N. If
C                   NB = 0, B is never accessed.
C
C   ******************************************************************
C   *                                                                *
C   *         Note - Use of RE and AE are what make this             *
C   *                code significantly different from               *
C   *                other linear least squares solvers.             *
C   *                However, the inexperienced user is              *
C   *                advised to set RE=0.,AE=0.,KEY=0.               *
C   *                                                                *
C   ******************************************************************
C
C     RE(),AE(),KEY
C     RE()          RE() is a vector of length N such that RE(I) is
C                   the maximum relative uncertainty in row I of
C                   the matrix A. The values of RE() must be between
C                   0 and 1. A minimum of 10*machine precision will
C                   be enforced.
C
C     AE()          AE() is a vector of length N such that AE(I) is
C                   the maximum absolute uncertainty in row I of
C                   the matrix A. The values of AE() must be greater
C                   than or equal to 0.
C
C     KEY           For ease of use, RE and AE may be input as either
C                   vectors or scalars. If a scalar is input, the algo-
C                   rithm will use that value for each column of A.
C                   The parameter KEY indicates whether scalars or
C                   vectors are being input.
C                        KEY=0     RE scalar  AE scalar
C                        KEY=1     RE vector  AE scalar
C                        KEY=2     RE scalar  AE vector
C                        KEY=3     RE vector  AE vector
C
C
C     MODE          The integer MODE indicates how the routine
C                   is to react if rank deficiency is detected.
C                   If MODE = 0 return immediately, no solution
C                             1 compute truncated solution
C                             2 compute minimal length least squares sol
C                   The inexperienced user is advised to set MODE=0
C
C     NP            The first NP rows of A will not be interchanged
C                   with other rows even though the pivot strategy
C                   would suggest otherwise.
C                   The inexperienced user is advised to set NP=0.
C
C     WORK()        A real work array dimensioned 5*M.  However, if
C                   RE or AE have been specified as vectors, dimension
C                   WORK 4*M. If both RE and AE have been specified
C                   as vectors, dimension WORK 3*M.
C
C     LW            Actual dimension of WORK
C
C     IWORK()       Integer work array dimensioned at least N+M.
C
C     LIW           Actual dimension of IWORK.
C
C
C     INFO          Is a flag which provides for the efficient
C                   solution of subsequent problems involving the
C                   same A but different B.
C                   If INFO = 0 original call
C                      INFO = 1 subsequent calls
C                   On subsequent calls, the user must supply A, KRANK,
C                   LW, IWORK, LIW, and the first 2*M locations of WORK
C                   as output by the original call to ULSIA. MODE must
C                   be equal to the value of MODE in the original call.
C                   If MODE.LT.2, only the first N locations of WORK
C                   are accessed. AE, RE, KEY, and NP are not accessed.
C
C
C
C
C     Output..
C
C     A(,)          Contains the lower triangular part of the reduced
C                   matrix and the transformation information. It togeth
C                   with the first M elements of WORK (see below)
C                   completely specify the LQ factorization of A.
C
C     B(,)          Contains the N by NB solution matrix for X.
C
C     KRANK,KSURE   The numerical rank of A,  based upon the relative
C                   and absolute bounds on uncertainty, is bounded
C                   above by KRANK and below by KSURE. The algorithm
C                   returns a solution based on KRANK. KSURE provides
C                   an indication of the precision of the rank.
C
C     RNORM()       Contains the Euclidean length of the NB residual
C                   vectors  B(I)-AX(I), I=1,NB. If the matrix A is of
C                   full rank, then RNORM=0.0.
C
C     WORK()        The first M locations of WORK contain values
C                   necessary to reproduce the Householder
C                   transformation.
C
C     IWORK()       The first N locations contain the order in
C                   which the columns of A were used. The next
C                   M locations contain the order in which the
C                   rows of A were used.
C
C     INFO          Flag to indicate status of computation on completion
C                  -1   Parameter error(s)
C                   0 - Rank deficient, no solution
C                   1 - Rank deficient, truncated solution
C                   2 - Rank deficient, minimal length least squares sol
C                   3 - Numerical rank 0, zero solution
C                   4 - Rank .LT. NP
C                   5 - Full rank
C
C***REFERENCES  T. Manteuffel, An interval analysis approach to rank
C                 determination in linear least squares problems,
C                 Report SAND80-0655, Sandia Laboratories, June 1980.
C***ROUTINES CALLED  R1MACH, U11US, U12US, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891009  Removed unreferenced variable.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Fixed an error message.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  ULSIA
      DIMENSION A(MDA,*),B(MDB,*),RE(*),AE(*),RNORM(*),W(*)
      INTEGER IWORK(*)
C
C***FIRST EXECUTABLE STATEMENT  ULSIA
      IF(INFO.LT.0 .OR. INFO.GT.1) GO TO 514
      IT=INFO
      INFO=-1
      IF(NB.EQ.0 .AND. IT.EQ.1) GO TO 501
      IF(M.LT.1) GO TO 502
      IF(N.LT.1) GO TO 503
      IF(N.LT.M) GO TO 504
      IF(MDA.LT.M) GO TO 505
      IF(LIW.LT.M+N) GO TO 506
      IF(MODE.LT.0 .OR. MODE.GT.3) GO TO 515
      IF(NB.EQ.0) GO TO 4
      IF(NB.LT.0) GO TO 507
      IF(MDB.LT.N) GO TO 508
      IF(IT.EQ.0) GO TO 4
      GO TO 400
    4 IF(KEY.LT.0.OR.KEY.GT.3) GO TO 509
      IF(KEY.EQ.0 .AND. LW.LT.5*M) GO TO 510
      IF(KEY.EQ.1 .AND. LW.LT.4*M) GO TO 510
      IF(KEY.EQ.2 .AND. LW.LT.4*M) GO TO 510
      IF(KEY.EQ.3 .AND. LW.LT.3*M) GO TO 510
      IF(NP.LT.0 .OR. NP.GT.M) GO TO 516
C
      EPS=10.*R1MACH(4)
      M1=1
      M2=M1+M
      M3=M2+M
      M4=M3+M
      M5=M4+M
C
      IF(KEY.EQ.1) GO TO 100
      IF(KEY.EQ.2) GO TO 200
      IF(KEY.EQ.3) GO TO 300
C
      IF(RE(1).LT.0.0) GO TO 511
      IF(RE(1).GT.1.0) GO TO 512
      IF(RE(1).LT.EPS) RE(1)=EPS
      IF(AE(1).LT.0.0) GO TO 513
      DO 20 I=1,M
      W(M4-1+I)=RE(1)
      W(M5-1+I)=AE(1)
   20 CONTINUE
      CALL U11US(A,MDA,M,N,W(M4),W(M5),MODE,NP,KRANK,KSURE,
     1            W(M1),W(M2),W(M3),IWORK(M1),IWORK(M2))
      GO TO 400
C
  100 CONTINUE
      IF(AE(1).LT.0.0) GO TO 513
      DO 120 I=1,M
      IF(RE(I).LT.0.0) GO TO 511
      IF(RE(I).GT.1.0) GO TO 512
      IF(RE(I).LT.EPS) RE(I)=EPS
      W(M4-1+I)=AE(1)
  120 CONTINUE
      CALL U11US(A,MDA,M,N,RE,W(M4),MODE,NP,KRANK,KSURE,
     1            W(M1),W(M2),W(M3),IWORK(M1),IWORK(M2))
      GO TO 400
C
  200 CONTINUE
      IF(RE(1).LT.0.0) GO TO 511
      IF(RE(1).GT.1.0) GO TO 512
      IF(RE(1).LT.EPS) RE(1)=EPS
      DO 220 I=1,M
      W(M4-1+I)=RE(1)
      IF(AE(I).LT.0.0) GO TO 513
  220 CONTINUE
      CALL U11US(A,MDA,M,N,W(M4),AE,MODE,NP,KRANK,KSURE,
     1            W(M1),W(M2),W(M3),IWORK(M1),IWORK(M2))
      GO TO 400
C
  300 CONTINUE
      DO 320 I=1,M
      IF(RE(I).LT.0.0) GO TO 511
      IF(RE(I).GT.1.0) GO TO 512
      IF(RE(I).LT.EPS) RE(I)=EPS
      IF(AE(I).LT.0.0) GO TO 513
  320 CONTINUE
      CALL U11US(A,MDA,M,N,RE,AE,MODE,NP,KRANK,KSURE,
     1            W(M1),W(M2),W(M3),IWORK(M1),IWORK(M2))
C
C     DETERMINE INFO
C
  400 IF(KRANK.NE.M) GO TO 402
          INFO=5
          GO TO 410
  402 IF(KRANK.NE.0) GO TO 404
          INFO=3
          GO TO 410
  404 IF(KRANK.GE.NP) GO TO 406
          INFO=4
          RETURN
  406 INFO=MODE
      IF(MODE.EQ.0) RETURN
  410 IF(NB.EQ.0) RETURN
C
C
C     SOLUTION PHASE
C
      M1=1
      M2=M1+M
      M3=M2+M
      IF(INFO.EQ.2) GO TO 420
      IF(LW.LT.M2-1) GO TO 510
      CALL U12US(A,MDA,M,N,B,MDB,NB,MODE,KRANK,
     1            RNORM,W(M1),W(M1),IWORK(M1),IWORK(M2))
      RETURN
C
  420 IF(LW.LT.M3-1) GO TO 510
      CALL U12US(A,MDA,M,N,B,MDB,NB,MODE,KRANK,
     1            RNORM,W(M1),W(M2),IWORK(M1),IWORK(M2))
      RETURN
C
C     ERROR MESSAGES
C
  501 CALL XERMSG ('SLATEC', 'ULSIA',
     +   'SOLUTION ONLY (INFO=1) BUT NO RIGHT HAND SIDE (NB=0)', 1, 0)
      RETURN
  502 CALL XERMSG ('SLATEC', 'ULSIA', 'M.LT.1', 2, 1)
      RETURN
  503 CALL XERMSG ('SLATEC', 'ULSIA', 'N.LT.1', 2, 1)
      RETURN
  504 CALL XERMSG ('SLATEC', 'ULSIA', 'N.LT.M', 2, 1)
      RETURN
  505 CALL XERMSG ('SLATEC', 'ULSIA', 'MDA.LT.M', 2, 1)
      RETURN
  506 CALL XERMSG ('SLATEC', 'ULSIA', 'LIW.LT.M+N', 2, 1)
      RETURN
  507 CALL XERMSG ('SLATEC', 'ULSIA', 'NB.LT.0', 2, 1)
      RETURN
  508 CALL XERMSG ('SLATEC', 'ULSIA', 'MDB.LT.N', 2, 1)
      RETURN
  509 CALL XERMSG ('SLATEC', 'ULSIA', 'KEY OUT OF RANGE', 2, 1)
      RETURN
  510 CALL XERMSG ('SLATEC', 'ULSIA', 'INSUFFICIENT WORK SPACE', 8, 1)
      INFO=-1
      RETURN
  511 CALL XERMSG ('SLATEC', 'ULSIA', 'RE(I) .LT. 0', 2, 1)
      RETURN
  512 CALL XERMSG ('SLATEC', 'ULSIA', 'RE(I) .GT. 1', 2, 1)
      RETURN
  513 CALL XERMSG ('SLATEC', 'ULSIA', 'AE(I) .LT. 0', 2, 1)
      RETURN
  514 CALL XERMSG ('SLATEC', 'ULSIA', 'INFO OUT OF RANGE', 2, 1)
      RETURN
  515 CALL XERMSG ('SLATEC', 'ULSIA', 'MODE OUT OF RANGE', 2, 1)
      RETURN
  516 CALL XERMSG ('SLATEC', 'ULSIA', 'NP OUT OF RANGE', 2, 1)
      RETURN
      END
*DECK USRMAT
      SUBROUTINE USRMAT (I, J, AIJ, INDCAT, PRGOPT, DATTRV, IFLAG)
C***BEGIN PROLOGUE  USRMAT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (USRMAT-S, DUSRMT-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   The user may supply this code
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  USRMAT
      DIMENSION PRGOPT(*),DATTRV(*),IFLAG(10)
C
C***FIRST EXECUTABLE STATEMENT  USRMAT
      IF(IFLAG(1).EQ.1) THEN
C
C     THIS IS THE INITIALIZATION STEP.  THE VALUES OF IFLAG(K),K=2,3,4,
C     ARE RESPECTIVELY THE COLUMN INDEX, THE ROW INDEX (OR THE NEXT COL.
C     INDEX), AND THE POINTER TO THE MATRIX ENTRY'S VALUE WITHIN
C     DATTRV(*).  ALSO CHECK (DATTRV(1)=0.) SIGNIFYING NO DATA.
           IF(DATTRV(1).EQ.0.) THEN
           I = 0
           J = 0
           IFLAG(1) = 3
           ELSE
           IFLAG(2)=-DATTRV(1)
           IFLAG(3)= DATTRV(2)
           IFLAG(4)= 3
           ENDIF
C
           RETURN
      ELSE
           J=IFLAG(2)
           I=IFLAG(3)
           L=IFLAG(4)
           IF(I.EQ.0) THEN
C
C     SIGNAL THAT ALL OF THE NONZERO ENTRIES HAVE BEEN DEFINED.
                IFLAG(1)=3
                RETURN
           ELSE IF(I.LT.0) THEN
C
C     SIGNAL THAT A SWITCH IS MADE TO A NEW COLUMN.
                J=-I
                I=DATTRV(L)
                L=L+1
           ENDIF
C
           AIJ=DATTRV(L)
C
C     UPDATE THE INDICES AND POINTERS FOR THE NEXT ENTRY.
           IFLAG(2)=J
           IFLAG(3)=DATTRV(L+1)
           IFLAG(4)=L+2
C
C     INDCAT=0 DENOTES THAT ENTRIES OF THE MATRIX ARE ASSIGNED THE
C     VALUES FROM DATTRV(*).  NO ACCUMULATION IS PERFORMED.
           INDCAT=0
           RETURN
      ENDIF
      END

subroutine labels(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>labels
  use greg_kernel
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Support routine for command
  !	LABEL "Un texte quelconque" [Orien] /APPEND /CENTERING n 
  !       /X [Yoffset] /Y [Xoffset]
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line          ! Command line
  logical, intent(inout) :: error               ! Error flag
  ! Local
  character(len=*), parameter :: rname='LABEL'
  integer(4) :: lcar,iset,iloc,i
  real(8) :: angsa
  real(4) :: off
  character(len=256) :: chain
  !
  if (.not.sic_present(0,1)) then
    call greg_message(seve%e,rname,'No string given')
    error = .true.
    return
  endif
  !
  ! Check the options present
  iset = 0
  do i=1,4
    if (sic_present(i,0)) then
      if (iset.ne.0) then
        call greg_message(seve%e,rname,'Conflicting options')
        error = .true.
        return
      else
        iset = i
      endif
    endif
  enddo
  call sic_ch (line,0,1,chain,lcar,.true.,error)
  if (error) return
  angsa = tangle
  call sic_r8 (line,0,2,tangle,.false.,error)
  if (error) return
  !
  iloc = icente
  if (iset.eq.1) then
    off = label_xoff
    call sic_r4(line,1,1,off,.false.,error)
    call xlabel(lcar,chain,off)    ! /X
  elseif (iset.eq.2) then
    off = label_yoff
    call sic_r4(line,2,1,off,.false.,error)
    call ylabel(lcar,chain,off)    ! /Y
  elseif (iset.eq.4) then
    call label(lcar,chain,tangle,.false.)  ! /APPEND
  else
    if (iset.eq.3) then
      call sic_i4 (line,3,1,iloc,.false.,error)
      if (error) then
        tangle = angsa
        return
      endif
    endif
    if (iloc.eq.0) iloc = 6
    call putlabel(lcar,chain,iloc,tangle,.false.) ! /CENTER Iloc
  endif
  tangle = angsa
end subroutine labels
!
subroutine xlabel(nchar,string,off)
  use greg_interfaces, except_this=>xlabel
  use greg_kernel
  use greg_pen
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !	  Write an X label
  !---------------------------------------------------------------------
  integer(4), intent(in) :: nchar                ! Number of characters
  character(len=*), intent(in) :: string         ! String
  real(4), intent(in) :: off                     ! Offset in Y from axis
  ! Local
  real(4) :: ch,xstart,ystart,slength
  real(8) :: angle
  !
  call setdas(1)
  angle = 0.d0
  ch = cdef * expand * cheight
  call gstrlen(nchar,string,slength)
  xstart = gx1 + (gx2 - gx1 - slength) / 2
  ystart = gy1 - off * ch
  if (ystart.lt.ch/2) then
    call greg_message(seve%w,'XLABEL','Label brought back within PLOT_PAGE')
    ystart = ch/2
  endif
  call grelocate(xstart,ystart)
  call gstring(nchar,string,angle,.false.)
end subroutine xlabel
!
subroutine ylabel(nchar,string,off)
  use phys_const
  use gbl_message
  use greg_interfaces, except_this=>ylabel
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !	Write an Y label at proper position
  !---------------------------------------------------------------------
  integer(4), intent(in) :: nchar                ! Number of characters
  character(len=*), intent(in) :: string         ! String
  real(4), intent(in) :: off                     ! Offset in X from axis
  ! Local
  real(4) :: ch,cw,xstart,ystart,slength
  real(8) :: angle
  !
  call setdas(1)
  angle = pi/2.d0
  cw = cdef * expand * cwidth
  ch = cdef * expand * cheight / 2
  call gstrlen(nchar,string,slength)
  ystart = gy1 + (gy2 - gy1 - slength) / 2
  xstart = gx1 - off * cw
  if (xstart.lt.ch*0.7) then
    call greg_message(seve%w,'YLABEL','Label brought back within PLOT_PAGE')
    xstart = ch*0.7
  endif
  call grelocate(xstart,ystart)
  call gstring(nchar,string,angle,.false.)
end subroutine ylabel
!
subroutine putlabel(nchar,string,loc,angle,doclip)
  use phys_const
  use greg_interfaces, except_this=>putlabel
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ private
  !  Puts a label according to location (VT100 numeric Keypad...)
  !     7 8 9
  !     4 5 6
  !     1 2 3
  ! Left, center or right in X and Y
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: nchar   ! Number of characters
  character(len=*), intent(in) :: string  ! String
  integer(kind=4),  intent(in) :: loc     ! Centering option
  real(kind=8),     intent(in) :: angle   ! [deg] Text angle
  logical,          intent(in) :: doclip  ! Clip the text to the current box?
  ! Local
  real(kind=4) :: ch,slength,xstart,ystart,dx,dy
  real(kind=8) :: alpha
  integer(kind=4) :: xsign,ysign
  !
  if (loc.ne.6) then
    ch = cdef * expand * cheight
    call gstrlen(nchar,string,slength)
    xsign = mod(loc-1,3) - 1
    ysign = (loc-1)/3 - 1
    dx = (xsign - 1) * .5 * slength
    dy = ysign * .5 * ch
    alpha = angle*pi/180.d0
    xstart = xp + dx * cos(alpha) - dy * sin(alpha)
    ystart = yp + dx * sin(alpha) + dy * cos(alpha)
    call grelocate(xstart,ystart)
  endif
  !
  call label(nchar,string,angle,doclip)
  !
end subroutine putlabel
!
subroutine label(nchar,string,angle,doclip)
  use phys_const
  use greg_interfaces, except_this=>label
  !---------------------------------------------------------------------
  ! @ private
  ! Puts a label at current location, with current angle
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: nchar   ! Number of characters
  character(len=*), intent(in) :: string  ! String
  real(kind=8),     intent(in) :: angle   ! [deg] Text angle
  logical,          intent(in) :: doclip  ! Soft clipping?
  ! Local
  real(kind=8) :: alpha
  !
  call setdas(1)
  alpha = angle*pi/180.d0
  call gstring(nchar,string,alpha,doclip)
end subroutine label
!
subroutine greg_draw_label(string,nc,error)
  use greg_interfaces, except_this=>greg_draw_label
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  ! Public subroutine which draws some text at current location, with
  ! current centering and orientation. This is equivalent to
  !   G\LABEL "Text"
  ! with no options.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: string
  integer(kind=4),  intent(in)    :: nc
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: loc
  !
  if (icente.eq.0) then
    loc = 6
  else
    loc = icente
  endif
  call putlabel(nc,string,loc,tangle,.false.)
end subroutine greg_draw_label

!
subroutine t_uvsort (np,nv,vin,vout,inxy,incs,uvmax,uvmin,sort,error)
  use gildas_def 
  use gbl_message
  use gkernel_interfaces
  use mapping_interfaces
  use uv_rotate_shift_and_sort_tool, only: loaduv,sortuv,chksuv
  !----------------------------------------------------------------------
  ! UV_MAP
  !     Rotate, Shift and Sort a UV table for map making
  !     Differential precession should have been applied before.
  !----------------------------------------------------------------------
  !
  integer, intent(in) :: np                   ! Size of a visibility
  integer, intent(in) :: nv                   ! Number of visibilities
  real, intent(in) :: vin(np,nv)              ! Input visibilities
  real, intent(out) :: vout(np,nv)            ! Output visibilities
  real(8), intent(in) :: inxy(2)              ! Phase shift
  real(8), intent(in) :: incs(2)              ! Frame Rotation
  real, intent(out) :: uvmax                  ! Max UV value
  real, intent(out) :: uvmin                  ! Min UV value
  logical, intent(inout) :: sort              ! Data has been sorted
  logical, intent(out) :: error
  !
  logical, allocatable :: suv(:) ! Sign
  real, allocatable :: uuv(:) ! U
  real, allocatable :: vuv(:) ! V
  integer, allocatable :: iuv(:) ! Index
  !
  integer ier 
  logical sorted
  real(4) :: xy(2)                   ! Real*4 Phase shift for SortUV
  real(4) :: cs(2)                   ! Real*4 Frame Rotation for LoadUV
  !
  sorted = .false.
  xy = inxy
  cs = incs
  !
  ! Load U,V coordinates, applying possible rotation (CS), and
  ! making all V negative
  allocate (suv(nv),uuv(nv),vuv(nv),iuv(nv),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  call loaduv (vin,np,nv,cs,uuv,vuv,suv,uvmax,uvmin)
  !
  ! Sort if needed
  call chksuv (nv,vuv,iuv,sorted)
  if (.not.sorted) then
     sort = .true.
     call gr4_trie (vuv,iuv,nv,error)
     if (error) return
  endif
  !
  ! Apply phase shift and copy to output visibilities
  call sortuv (vin,vout,np,nv,0,xy,uuv,vuv,suv,iuv) 
  !
  deallocate(suv,uuv,vuv,iuv)
end subroutine t_uvsort

  

	subroutine findmax (image,nimage,imax,npts,points,badpts,
     &    rms,sum)
	integer(kind=4), intent(in) :: nimage
	real*4    image(nimage),points(3,nimage)
	integer*2 badpts (nimage)
	real*4    max,min

	max=-1.e30
	min=1.e30
	sum=0.

	do 1 i=1,npts
	if (max.lt.image(i) .and. badpts(i).ne.1) then
	 imax=i
	 max=image(i)
	endif
	if (min.gt.image(i)) then
	 imin=i
	 min=image(i)
	endif
	sum=sum+image(i)
1	continue

	write (2,*) 'I-FINDMAX, maximum found at ',
     &    points(1,imax),points(2,imax),points(3,imax),' ',max*rms
	write (2,*) 'I-FINDMAX, minimum found at ',
     &    points(1,imin),points(2,imin),points(3,imin),' ',min*rms
	write (2,*) 'I-FINDMAX, integral ',sum*rms
	write (6,*) 'I-FINDMAX, integral ',sum*rms

	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_baseline_chebyshev
  use cubetools_parameters
  use cubetools_structure
  use cubetools_unit_arg
  use cubetools_array_types
  use cubetools_axis_types
  use cubemain_messaging
  use cubemain_baseline_cubes_types
  use cubemain_lineset_or_mask_types
  !
  public :: baseline_chebyshev_comm_t,baseline_chebyshev_user_t
  private
  !
  type baseline_chebyshev_comm_t
     type(option_t),   pointer :: key
     type(unit_arg_t), pointer :: unit
     type(lineset_or_mask_comm_t), pointer :: lineregion => null()
     type(baseline_cubes_comm_t),  pointer :: cubes => null()
   contains
     procedure, public :: register     => cubemain_baseline_chebyshev_comm_register
     procedure, public :: parse_key    => cubemain_baseline_chebyshev_comm_parse_key
     procedure, public :: parse_others => cubemain_baseline_chebyshev_comm_parse_others
     procedure, public :: main         => cubemain_baseline_chebyshev_comm_main
  end type baseline_chebyshev_comm_t
  !
  type baseline_chebyshev_user_t
     logical               :: present = .false.
     type(strg_1d_t)       :: degree
     type(strg_1d_t)       :: transi
     character(len=unit_l) :: unit = strg_star
     type(lineset_or_mask_user_t) :: lineregion
     type(baseline_cubes_user_t)  :: cubes
   contains
     procedure, public :: toprog => cubemain_baseline_chebyshev_user_toprog
     procedure, public :: list   => cubemain_baseline_chebyshev_user_list
  end type baseline_chebyshev_user_t
  !
  type baseline_chebyshev_prog_t
     type(axis_t), pointer :: axis => null()    ! [----] Associated axis
     type(inte_1d_t)       :: degree
     type(long_1d_t)       :: transi
     type(lineset_or_mask_prog_t) :: lineregion !
     type(baseline_cubes_prog_t)  :: cubes      ! Input and output cubes
   contains
     procedure :: list   => cubemain_baseline_chebyshev_prog_list
     procedure :: header => cubemain_baseline_chebyshev_prog_header
     procedure :: data   => cubemain_baseline_chebyshev_prog_data
     procedure :: loop   => cubemain_baseline_chebyshev_prog_loop
     procedure :: act    => cubemain_baseline_chebyshev_prog_act
  end type baseline_chebyshev_prog_t
  !
contains
  !
  subroutine cubemain_baseline_chebyshev_comm_register(comm,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(baseline_chebyshev_comm_t), intent(inout) :: comm
    logical,                          intent(inout) :: error
    !
    type(unit_arg_t) :: unitarg
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'POLYNOMIAL','deg1 [tr12 deg2 [... [trij degj [unit]]]]',&
         'Fit Chebyshev polynomials to define the baseline',&
         strg_emp,&
         comm%key,error)
    if (error) return
    call stdarg%register(&
         'deg1',&
         'Degree for the first polynomial',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'tr12',&
         'Transition between first and second polynomial',&
         strg_emp,&
         code_arg_unlimited,&
         error)
    if (error) return
    call stdarg%register(&
         'deg2',&
         'Degree for the second polynomial',&
         strg_emp,&
         code_arg_unlimited,&
         error)
    if (error) return
    call stdarg%register(&
         'trij',&
         'Transition between ith and jth polynomial',&
         strg_emp,&
         code_arg_unlimited,&
         error)
    if (error) return
    call stdarg%register(&
         'degj',&
         'Degree for the jth polynomial',&
         strg_emp,&
         code_arg_unlimited,&
         error)
    if (error) return
    call unitarg%register(&
         'UNIT',&
         'Unit of the transitions between two chebyshev polynomial',&
         '"*" or "=" mean internal unit of the spectral axis',&
         code_arg_optional,&
         code_unit_velo,&
         comm%unit,&
         error)
    if (error) return
  end subroutine cubemain_baseline_chebyshev_comm_register
  !
  subroutine cubemain_baseline_chebyshev_comm_parse_key(comm,line,user,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! /POLYNOMIAL deg1 [tr12 deg2 [... [trij degj [unit]]]]
    !----------------------------------------------------------------------
    class(baseline_chebyshev_comm_t), intent(inout) :: comm
    character(len=*),                 intent(in)    :: line
    type(baseline_chebyshev_user_t),  intent(out)   :: user
    logical,                          intent(inout) :: error
    !
    integer(kind=argu_k), parameter :: one=1
    integer(kind=argu_k) :: iarg,narg
    integer(kind=indx_k) :: ideg,itra,npoly
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>COMM>PARSE>KEY'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%present,error)
    if (error) return
    if (user%present) then
       ! Get number of arguments and analyze it
       narg = comm%key%getnarg()
       if (narg.lt.0) then
          call cubemain_message(seve%e,rname,'Negative number of arguments')
          error = .true.
          return
       else if ((narg.eq.0).or.(narg.eq.1)) then
          ! Only one argument
          npoly = 1
          call user%degree%reallocate('chebyshev degree',npoly,error)
          if (error) return
       else if (narg.eq.2) then
          call cubemain_message(seve%e,rname,'1 or more than 3 arguments are required')
          error = .true.
          return
       else
          if (modulo(narg,2).eq.0) then
             ! Even number of arguments
             npoly = narg/2
             ! Last argument must be a unit
             call cubetools_getarg(line,comm%key,narg,user%unit,mandatory,error)
             if (error) return
          else
             ! Odd number of arguments
             npoly = narg/2+1
          endif
          ! Allocate npoly degrees and npoly-1 transitions
          call user%degree%reallocate('chebyshev degree',npoly,error)
          if (error) return
          call user%transi%reallocate('chebyshev transition',npoly-1,error)
          if (error) return
       endif
       ! Now get argument values
       if (narg.eq.0) then
          ! Default value
          user%degree%val(one) = strg_star
       else
          ! Parse degrees and transitions
          do ideg=1,user%degree%n
             iarg = 2*ideg-1
             call cubetools_getarg(line,comm%key,iarg,user%degree%val(ideg),mandatory,error)
             if (error) return
          enddo ! ideg
          do itra=1,user%transi%n
             iarg = 2*itra
             call cubetools_getarg(line,comm%key,iarg,user%transi%val(itra),mandatory,error)
             if (error) return          
          enddo ! itra
       endif
    endif
  end subroutine cubemain_baseline_chebyshev_comm_parse_key
  !
  subroutine cubemain_baseline_chebyshev_comm_parse_others(comm,cubes,lineregion,line,user,error)
    !----------------------------------------------------------------------
    ! Parse the others useful keys of the commands in this case
    !----------------------------------------------------------------------
    class(baseline_chebyshev_comm_t),     intent(inout) :: comm
    type(baseline_cubes_comm_t),  target, intent(inout) :: cubes
    type(lineset_or_mask_comm_t), target, intent(inout) :: lineregion
    character(len=*),                     intent(in)    :: line
    type(baseline_chebyshev_user_t),      intent(inout) :: user
    logical,                              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>COMM>PARSE>OTHERS'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    comm%cubes => cubes
    call comm%cubes%parse(line,user%cubes,error)
    if (error) return
    !
    comm%lineregion => lineregion
    call comm%lineregion%parse(line,user%lineregion,error)
    if (error) return
  end subroutine cubemain_baseline_chebyshev_comm_parse_others
  !
  subroutine cubemain_baseline_chebyshev_comm_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Parsing call is done in command_baseline.f90. Reminder calls are done
    ! here!
    !----------------------------------------------------------------------
    class(baseline_chebyshev_comm_t), intent(in)    :: comm
    type(baseline_chebyshev_user_t),  intent(inout) :: user
    logical,                          intent(inout) :: error
    !
    type(baseline_chebyshev_prog_t) :: prog
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>COMM>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%list(error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_baseline_chebyshev_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_baseline_chebyshev_user_toprog(user,comm,prog,error)
    use cube_types
    use cubetools_unit
    use cubetools_user2prog
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(baseline_chebyshev_user_t), intent(inout) :: user
    type(baseline_chebyshev_comm_t),  intent(in)    :: comm
    type(baseline_chebyshev_prog_t),  intent(inout) :: prog
    logical,                          intent(inout) :: error
    !
    integer(kind=chan_k) :: ideg,nchan
    integer(kind=chan_k) :: itran,ntran
    real(kind=coor_k) :: transival
    type(unit_user_t) :: default_unit,user_unit
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Get input and output cubes
    call user%cubes%toprog(comm%cubes,prog%cubes,error)
    if (error) return
    !
    ! 1. Chebyshev degrees
    call prog%degree%reallocate('chebyshev degree',user%degree%n,error)
    if (error) return
    do ideg=1,prog%degree%n
       call cubetools_user2prog_resolve_unk(user%degree%val(ideg),prog%degree%val(ideg),error)
       if (error) return
       if (prog%degree%val(ideg).lt.0) then
          call cubemain_message(seve%e,rname,'Polynomial degree must be positive')
          error = .true.
          return
       endif
    enddo ! ideg
    !
    ! 2. Transition between chebyshev polynomials
    ! 2.a Associate the cube spectral axis
    call cubetools_header_point2axis(prog%cubes%cube%head%set%ic,prog%cubes%cube%head,prog%axis,error)
    if (error) return
    ! 2.b Get units of the problem
    ! 2.b.1 Default unit will depend on the axis kind
    call default_unit%get_from_code(prog%axis%kind,error)
    if (error) return
    ! 2.b.2 Get user unit from user input
    call user_unit%get_from_name(user%unit,error)
    if (error) return
    ! 2.b.3 Sanity check
    select case(user_unit%kind%code)
    case(code_unit_chan,code_unit_pixe,code_unit_unk)
       ! Does nothing
    case default
       ! Check whether user and default units are consistent
       call user_unit%is_consistent_with(default_unit,error)
    end select
    ! 2.c Allocate transition array with an additional first and last element
    ntran = user%transi%n+2
    nchan = prog%axis%n
    call prog%transi%reallocate('chebyshev transition',ntran,error)
    if (error) return
    prog%transi%val(1) = 1
    prog%transi%val(ntran) = nchan
    ! 2.d Process the ith transition
    do itran=1,user%transi%n
       call cubetools_user2prog_resolve_unk(user%transi%val(itran),transival,error)
       if (error) return
       call transition_user2prog(prog%axis,user_unit,transival,prog%transi%val(itran+1),error)
       if (error) return
    enddo ! itran
    ! 2.e Sanity checks
    do itran=1,prog%transi%n
       if ((prog%transi%val(itran).lt.1).or.(prog%transi%val(itran).gt.nchan)) then
          write(mess,'(a,1pg14.7,x,2a)') &
               'Transition at ',user%transi%val(itran-1),trim(user_unit%name),&
               ' goes beyond spectrum boundaries'
          call cubemain_message(seve%e,rname,mess)
          error = .true.
          return
       endif
    enddo ! itran
    ! ***JP: Ascending or descending order should be OK!
    do itran=2,prog%transi%n
       if (prog%transi%val(itran).le.prog%transi%val(itran-1)) then
          call cubemain_message(seve%e,rname,'Transitions must be sorted in ascending order of channels')
          error = .true.
          return
       endif
    enddo ! itran
    !
    ! 3  Define the regions where the lines are
    call user%lineregion%toprog(prog%cubes%cube,comm%lineregion,prog%lineregion,error)
    if (error) return
    !
  contains
    !
    subroutine transition_user2prog(axis,userunit,userval,progval,error)
      type(axis_t),         intent(in)    :: axis
      type(unit_user_t),    intent(in)    :: userunit
      real(kind=coor_k),    intent(in)    :: userval
      integer(kind=chan_k), intent(out)   :: progval
      logical,              intent(inout) :: error
      !
      real(kind=coor_k) :: converted
      !
      select case(userunit%kind%code)
      case(code_unit_chan,code_unit_pixe)
         ! Directly use the values
         progval = nint(userval)
      case(code_unit_unk)
         ! No unit conversion can be done => Directly use the axis conversion formula
         call cubetools_axis_offset2pixel(axis,userval,progval,error)
         if (error) return
      case default
         ! Convert from user to prog unit
         converted = userunit%prog_per_user*userval
         ! Now use the axis conversion formula
         call cubetools_axis_offset2pixel(axis,converted,progval,error)
         if (error) return
      end select
    end subroutine transition_user2prog
  end subroutine cubemain_baseline_chebyshev_user_toprog
  !
  subroutine cubemain_baseline_chebyshev_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging purpose
    !----------------------------------------------------------------------
    class(baseline_chebyshev_user_t), intent(in)    :: user 
    logical,                          intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>USER>LIST'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! *** JP: To be written
    call cubemain_message(seve%r,rname,mess)
  end subroutine cubemain_baseline_chebyshev_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_baseline_chebyshev_prog_list(prog,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! List the baseline_chebyshev_prog information in a user friendly way
    !-------------------------------------------------------------------
    class(baseline_chebyshev_prog_t), intent(in)    :: prog
    logical,                          intent(inout) :: error
    !
    integer(kind=chan_k) :: ideg,itra
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>PROG>LIST'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubemain_message(seve%r,rname,'')
    mess = cubetools_format_stdkey_boldval('Baselining method','Chebyshev Polynomial',40)
    call cubemain_message(seve%r,rname,mess)
    itra = 1
    do ideg=1,prog%degree%n
       mess = '  '//cubetools_format_stdkey_boldval('#',ideg,'i2',4)
       mess = trim(mess)//': '//cubetools_format_stdkey_boldval('degree',prog%degree%val(ideg),'i3',12)
       call transition_list(mess,'from',itra,prog%transi,prog%axis,error)
       if (error) return
       itra = itra+1
       call transition_list(mess,'to',itra,prog%transi,prog%axis,error)
       if (error) return
       call cubemain_message(seve%r,rname,mess)
    enddo ! ideg
    !
    call prog%lineregion%list(error)
    if (error) return
    !
    call prog%cubes%list(error)
    if (error) return
    !
  contains
    !
    subroutine transition_list(mess,key,itra,prog,axis,error)
      character(len=*),     intent(inout) :: mess
      character(len=*),     intent(in)    :: key
      integer(kind=chan_k), intent(inout) :: itra
      type(long_1d_t),      intent(in)    :: prog
      type(axis_t),         intent(in)    :: axis
      logical,              intent(inout) :: error
      !
      real(kind=coor_k) :: user
      !
      if (itra.le.prog%n) then
         call cubetools_axis_pixel2offset(axis,prog%val(itra),user,error)
         if (error) return
         mess = trim(mess)//' '//cubetools_format_stdkey_boldval(key,user,fsimple,nsimple)
      else
         call cubemain_message(seve%e,rname,'Not enough transitions for ith degree')
         error = .true.
         return
      endif
    end subroutine transition_list
  end subroutine cubemain_baseline_chebyshev_prog_list
  !
  subroutine cubemain_baseline_chebyshev_prog_header(prog,comm,error)
    use cube_types
    use cubetools_axis_types
    use cubetools_header_methods
    !-------------------------------------------------------------------
    ! Update cube header according to the polynomial fit
    !-------------------------------------------------------------------
    class(baseline_chebyshev_prog_t), intent(inout) :: prog
    type(baseline_chebyshev_comm_t),  intent(in)    :: comm
    logical,                          intent(inout) :: error
    !
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call prog%cubes%header(comm%cubes,error)
    if (error) return
  end subroutine cubemain_baseline_chebyshev_prog_header
  !
  subroutine cubemain_baseline_chebyshev_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(baseline_chebyshev_prog_t), intent(inout) :: prog
    logical,                          intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
            call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_baseline_chebyshev_prog_data
  !
  subroutine cubemain_baseline_chebyshev_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(baseline_chebyshev_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),         intent(inout) :: iter
    logical,                          intent(inout) :: error
    !
    type(spectrum_t) :: input,mask,good,line,base
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>PROG>LOOP'
    !
    ! input with associated x and allocated w
    call input%associate('input',prog%cubes%cube,iter,error)
    if (error) return
    call input%associate_x(error)
    if (error) return
    call input%allocate_w(error)
    if (error) return
    ! good with allocated x and w
    call good%allocate('good',prog%cubes%cube,iter,error)
    if (error) return
    call good%allocate_xw(error)
    if (error) return
    ! The other ones do not need x or w arrays
    ! base and line products
    call line%allocate('line',prog%cubes%line,iter,error)
    if (error) return
    call base%allocate('base',prog%cubes%base,iter,error)
    if (error) return
    !
    ! Process lineregion method
    select case (prog%lineregion%method)
    case (code_line_none)
       input%w%val(:) = 1.0
       do while (iter%iterate_entry(error))
          call prog%act(iter%ie,input,good,base,line,error)
          if (error) return
       enddo ! ie
    case (code_line_set)
       call input%set_base_channels(prog%lineregion%lineset,error)
       if (error) return
       do while (iter%iterate_entry(error))
          call prog%act(iter%ie,input,good,base,line,error)
          if (error) return
       enddo ! ie
    case (code_line_mask)
       call mask%associate('mask',prog%lineregion%mask%cube,iter,error)
       if (error) return
       do while (iter%iterate_entry(error))
          ! Get mask and set input weight accordingly
          call mask%get(iter%ie,error)
          if (error) return
          call input%set_base_channels_from_mask(mask,error)
          if (error) return
          ! Fit
          call prog%act(iter%ie,input,good,base,line,error)
          if (error) return
       enddo ! ie
    case default
       call cubemain_message(seve%e,rname,'Unknown line method code')
       error = .true.
       return
    end select
  end subroutine cubemain_baseline_chebyshev_prog_loop
  !
  subroutine cubemain_baseline_chebyshev_prog_act(prog,ie,input,good,base,line,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    use cubemain_svd_tool
    use cubemain_chebyshev_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(baseline_chebyshev_prog_t), intent(inout) :: prog
    integer(kind=entr_k),             intent(in)    :: ie
    type(spectrum_t),                 intent(inout) :: input
    type(spectrum_t),                 intent(inout) :: good
    type(spectrum_t),                 intent(inout) :: base
    type(spectrum_t),                 intent(inout) :: line
    logical,                          intent(inout) :: error
    !
    integer(kind=4) :: ifit
    integer(kind=chan_k) :: ifirst,ilast
    type(chebyshev_t) :: poly
    type(svd_t)       :: svd
    type(spectrum_t)  :: extracted
    character(len=*), parameter :: rname='BASELINE>CHEBYSHEV>PROG>ACT'
    !
    ! Get input spectrum
    call input%get(ie,error)
    if (error) return
    ! Process it
    if (input%y%isblanked()) then
       ! Spectrum is blanked => blank output
       line%y%val(:) = gr4nan
       base%y%val(:) = gr4nan
    else
       ! Loop on fits
       do ifit=1,prog%transi%n-1
          ! Extral spectral region to fit the baseline
          ifirst = prog%transi%val(ifit)
          ilast  = prog%transi%val(ifit+1)
          call extracted%point_to(input,ifirst,ilast,input%noi,error)
          if (error) return
          ! Remove NaN
          call good%mask(extracted,error)
          if (error) return
          ! Fit
          if (good%n.gt.prog%degree%val(ifit)) then
             call poly%fit(prog%degree%val(ifit),good,svd,error)
             if (error) return
             call poly%subtract(input,ifirst,ilast,base,line,error)
             if (error) return
          else
             line%y%val(:) = input%y%val(:)
             base%y%val(:) = gr4nan
          endif
       enddo ! ifit
    endif
    ! Put output spectra
    call base%put(ie,error)
    if (error) return
    call line%put(ie,error)
    if (error) return
  end subroutine cubemain_baseline_chebyshev_prog_act
end module cubemain_baseline_chebyshev
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! *** JP: It should use directly the method instead of trying to select the
! *** JP: right method in the middle of the execution.
!
module cubeadm_copy_tool
  use cubetuple_format_class
  use cubeadm_messaging
  use cubeadm_taskloop
  !
  public :: cubeadm_copy_data
  private
  !
  type copy_prog_t
     class(format_t), pointer :: in
     class(format_t), pointer :: ou
   contains
     procedure, private :: data              => cubeadm_copy_prog_data
     procedure, private :: loop              => cubeadm_copy_prog_loop
     procedure, private :: loop_subcube_real => cubeadm_copy_prog_loop_subcube_real
     procedure, private :: loop_subcube_cplx => cubeadm_copy_prog_loop_subcube_cplx
  end type copy_prog_t
  !
contains
  !
  subroutine cubeadm_copy_data(in,ou,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(format_t), target, intent(inout) :: in
    class(format_t), target, intent(inout) :: ou
    logical,                 intent(inout) :: error
    !
    type(copy_prog_t) :: copy
    character(len=*), parameter :: rname='COPY>DATA'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    copy%in => in
    copy%ou => ou
    call copy%data(error)
    if (error) return
  end subroutine cubeadm_copy_data
  !  
  subroutine cubeadm_copy_prog_data(prog,error)
    use cubetuple_iterator
    use cubeadm_opened
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(copy_prog_t), intent(inout) :: prog
    logical,            intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='COPY>PROG>DATA'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error,align=code_align_channel)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
          call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubeadm_copy_prog_data
  !
  subroutine cubeadm_copy_prog_loop(prog,iter,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(copy_prog_t),       intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='COPY>PROG>LOOP'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    if (prog%in%iscplx()) then
      call prog%loop_subcube_cplx(iter,error)
      if (error) return
    else
      call prog%loop_subcube_real(iter,error)
      if (error) return
    endif
  end subroutine cubeadm_copy_prog_loop
  !
  subroutine cubeadm_copy_prog_loop_subcube_real(prog,iter,error)
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(copy_prog_t),       intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(subcube_t) :: subcube
    character(len=*), parameter :: rname='COPY>DATA>SUBCUBE>REAL'
    !
    do while (iter%iterate_entry(error))
      ! Subcubes are initialized here as their size (3rd dim) may change
      ! from one subcube to another.
      call subcube%associate('in',prog%in,iter,error)
      if (error) return
      call subcube%get(error)
      if (error) return
      call subcube%put_in(prog%ou,error)
      if (error) return
    enddo ! ie
  end subroutine cubeadm_copy_prog_loop_subcube_real
  !
  subroutine cubeadm_copy_prog_loop_subcube_cplx(prog,iter,error)
    use cubeadm_subcube_cplx_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(copy_prog_t),       intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(subcube_cplx_t) :: subcube
    character(len=*), parameter :: rname='COPY>DATA>SUBCUBE>CPLX'
    !
    do while (iter%iterate_entry(error))
      ! Subcubes are initialized here as their size (3rd dim) may change
      ! from one subcube to another.
      call subcube%associate('in',prog%in,iter,error)
      if (error) return
      call subcube%get(error)
      if (error) return
      call subcube%put_in(prog%ou,error)
      if (error) return
    enddo ! ie
  end subroutine cubeadm_copy_prog_loop_subcube_cplx
end module cubeadm_copy_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeadm_taskloop_iteration
  use cubetools_parameters
  !
  ! Description of one task iteration
  type taskloop_iteration_t
    integer(kind=entr_k) :: num         ! This task number
    integer(kind=entr_k) :: ie          ! The entry number iterated in this task
    integer(kind=data_k) :: firstdata   ! First data  to be processed
    integer(kind=data_k) :: lastdata    ! Last  data  to be processed
    integer(kind=entr_k) :: firstplane  ! First plane to be processed
    integer(kind=entr_k) :: lastplane   ! Last  plane to be processed
    integer(kind=entr_k) :: first       ! First entry to be processed (kept for backward compatibility)
    integer(kind=entr_k) :: last        ! Last  entry to be processed (kept for backward compatibility)
  end type taskloop_iteration_t
  !
  public :: taskloop_iteration_t
  private
  !
end module cubeadm_taskloop_iteration

!
!----------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoPointing">
!   <VERSION>
!                Id: modulePakoPointing.f90,v 1.2.3  2014-12-15 Hans Ungerechts
!                Id: modulePakoPointing.f90,v 1.2.3  2014-10-27 Hans Ungerechts
!                Id: modulePakoPointing.f90,v 1.2.3  2014-09-23 Hans Ungerechts
!                Id: modulePakoPointing.f90,v 1.2.3  2014-02-03 Hans Ungerechts
!                                           v 1.2.1  2012-09-21 Hans Ungerechts
!                Id: modulePakoPointing.f90,v 1.2.0  2012-08-16 Hans Ungerechts
!                based on
!                Id: modulePakoPointing.f90,v 1.1.12 2012-05-30 Hans Ungerechts
!   </VERSION>
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>
!                Calibrate
!                Focus
!                OnOff
!                OtfMap
!                Pointing
!                Tip
!                Track
!                VLBI
!   </SIBLINGS>        
!
!   Pako module for command: POINTING
!
! </DOCUMENTATION> <!-- name="modulePakoPointing" -->
!
!----------------------------------------------------------------------
!
Module modulePakoPointing
  !
  Use modulePakoTypes
  Use modulePakoMessages
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  Use modulePakoDIYlist
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  Public :: pointing
  Public :: savePointing
  Public :: startPointing
  Public :: displayPointing
  Public :: plotPointing
  !     
  ! *** Variables for pointing ***
  Include 'inc/variables/variablesPointing.inc'
  !
  Real    :: swWobblerAmplitude       = 0.0
  Real    :: swWobblerShiftAzimuth    = 0.0       !   Shift in Azimuth when Wobbler Switching
  Real    :: swWobblerShiftElevation  = 0.0       !   Shift in Elevation when Wobbler Switching
  !
!!OLD  Real (kind=kindSingle) :: angleFactorR
!!OLD  Real (kind=kindDouble) :: angleFactorD
!!!   
!!!   
Contains
!!!   
!!!
  Subroutine pointing(programName,line,command,                    &
       &        error)
    !
    ! *** Arguments: ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical :: isConnected   = .False.
    !
    Character (len=lenCh) ::  bolometerName
    !
    Real                  :: vIn, vStdMin, vStdMax, vLimitMin, vLimitMax
    !     
    Real                  :: vMaxX,   vMaxY, vLimit
    Real                  ::                 vLimitAz, vLimitEl
    Real                  :: vMaxXel, vMaxYel, MaxEl
    !
    Character(len=lenCh)   ::  sysName  = GPnone
    !
    Type(conditionMinMax)  ::  condElevation                                     &
         &                     = conditionMinMax("elevation",                    &
         &                                        0.0, Pi/2.0,                   &
         &                                       "rad",                          &
         &                                       .False.         )               ! 
    !
    Include 'inc/ranges/rangesPointing.inc'
    !
    !D    Write (6,*) " modulePako pointing ---> SR: pointing 21"
    !D    Write (6,*) "                          "
    !D    Write (6,*) " programName:  ->", programName(1:lenc(programName)), "<-"
    !D    Write (6,*) " line:         ->", line(1:lenc(line)), "<-"
    !D    Write (6,*) " command:      ->", command(1:lenc(command)), "<-"
    !D    Write (6,*) " error:        ->", error
    !
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Pointing, v 1.2.3  2014-02-03 ---> SR: Pointing ")          ! trace execution
    !
    !  **   initialize:   ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    !  **   set In-values = previous Values   ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    ! *** read Parameters, Options (to detect errors)         ***
    ! *** and check for validity and ranges                   ***
    Call checkNofParameters(command,                                             &
         &     0, 1,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/parameters/parametersLength.inc'
       Include 'inc/options/readOptionsPointing.inc'
    End If
    !
    !**   set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          Include 'inc/variables/setDefaults.inc'
       Endif
    Endif
    !
    ! ***   read Parameters, Options (again, after defaults!)   ***
    ! ***   and check for validity and ranges                   ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       !
       !   old style v < 2
       Include 'inc/parameters/parametersLength.inc'
       Include 'inc/options/readOptionsPointing.inc'
!!$       !  test style v >= 2 (2012-08-10):
!!$       !  ** to support /default /doubleBeam --> doubleBeam **
!!$       Include 'inc/options/optionDoubleBeam.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** check consistency and                           ***
    ! ***   store from In into persistent variables       ***
    If (.Not.error) Then
       errorInconsistent = .False.
       !
       !! following check (speed) compare OM OTFMAP / alternativeSpeedTotfEnd.inc
       !
       vars(iIn)%speedStart = vars(iIn)%length/vars(iIn)%tOtf
       vars(iIn)%speedEnd   = vars(iIn)%length/vars(iIn)%tOtf
       !
       vIn       = vars(iIn)%speedStart
       vStdMin   = Min(vars(iStd1)%speedStart,  vars(iStd2)%speedStart)
       vStdMax   = Max(vars(iStd1)%speedStart,  vars(iStd2)%speedStart)     
       vLimitMin = Min(vars(iLimit1)%speedStart,vars(iLimit2)%speedStart)
       vLimitMax = Max(vars(iLimit1)%speedStart,vars(iLimit2)%speedStart)
       !
       If (vIn.Lt.vLimitMin .Or. vIn.Gt.vLimitMax) Then
          errorInconsistent = .True.
          Write (messageText,'(a,F8.1,a,F8.1,a,F8.1,a,F8.1)')                    &
               &           ' value ',                  vars(iIn)%tOtf,           &
               &           ' implies /speed ',         vIn,                      &
               &           ' outside limits ',         vLimitMin,                &
               &           ' to ',                     vLimitMax                 !
          Call pakoMessage(priorityE,severityE,                                  &
               &                command//" /tOtf", messageText)                  !
       Else If (vIn.Lt.vStdMin .Or. vIn.Gt.vStdMax) Then
          Write (messageText,'(a,F8.1,a,F8.1,a,F8.1,a,F8.1)')                    &
               &           ' value ',                  vars(iIn)%tOtf,           &
               &           ' implies /speed ',         vIn,                      &
               &           ' outside standard range ', vStdMin,                  &
               &           ' to ',                     vStdMax                   !
          Call pakoMessage(priorityW,severityW,                                  &
               &                command//" /tOtf", messageText)                  !
       End If
       !
       If (vars(iIn)%tOtf .Lt. 10*GV%tRecord) Then
          errorInconsistent = .True.
          Write (messageText,*)    "must be at least 10 times "                  &
               &                // "tRecord = tPhase*nPhases*nCycles = "         &
               &                 ,  GV%tRecord                                   &
               &                 , "of switching mode "//GV%switchingMode        !
          Call pakoMessage(priorityE,severityE,                                  &
               &           command(1:l)//"/"//"tOtf",messageText)                !
       End If
       !
       !! TBD 2.0: !!$       Call queryReceiver(rec%bolo, isBolometer)
       !! TBD 2.0: !!$       !D Write (6,*) "BOLOMETER isBolometer", isBolometer
       !! TBD 2.0: !!$       If (vars(iIn)%doCalibrate .And. isBolometer) Then
       !! TBD 2.0: !!$          Write (messageText,*)  "/CALIBRATE will not be used with BOLOMETER"
       !! TBD 2.0: !!$          Call PakoMessage(priorityW,severityW,command//"",messageText)
       !! TBD 2.0: !!$       End If
       !
!!OLD       If (GV%privilege.Eq.setPrivilege%user                                     &
!!OLD            &   .And. vars(iIn)%doDoubleBeam .And. .Not.isBolometer) Then        !
!!OLD          errorInconsistent   = .True.
!!OLD          Write (messageText,*)  "/DOUBLEBEAM can only be used with BOLOMETER"
!!OLD          Call PakoMessage(priorityE,severityE,command//"",messageText)
!!OLD       End If
       !
       If (vars(iIn)%doDoubleBeam .And. .Not.GV%switchingMode.Eq.swMode%Wobb) Then
          errorInconsistent   = .True.
          Write (messageText,*)  "/DOUBLEBEAM can only be used with SWWOBBLER"
          Call PakoMessage(priorityE,severityE,command//"",messageText)
       End If
       !
       If (GV%switchingMode.Eq.swMode%Freq) Then
          errorInconsistent   = .True.
          GV%notReadyPointing = .True.
          Write (messageText,*)  "will not work with switching mode ", swModePako%Freq
          Call PakoMessage(priorityE,severityE,command,messageText)
       End If
       !
       If (.Not. errorInconsistent) Then
          vars(iTemp) = vars(iIn)
       End If
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    If (.Not.error) Then
       !
       vMaxX  =   vars(iTemp)%length/vars(iTemp)%tOtf
       vMaxY  =   vars(iTemp)%length/vars(iTemp)%tOtf
       !
!!OLD       !! NOTE: this code replaced on 2012-05-30 by code from OTFMAP (2012-03-28)
!!OLD       !!
!!OLD       !! aMaxX  =   vars(iTemp)%xAmplitude*GV%angleUnit * vars(iTemp)%omegaX**2
!!OLD       !! aMaxY  =   vars(iTemp)%yAmplitude*GV%angleUnit * vars(iTemp)%omegay**2
!!OLD       !
!!OLD       !! vLimit = 300.0
!!OLD       !! aLimit = 108.0*arcsec
!!OLD       !
!!OLD       Write (6,*) " vMaxX:   ", vMaxX
!!OLD       Write (6,*) " vMaxY:   ", vMaxY
!!OLD       Write (6,*) " vLimit:  ", vLimit
!!OLD       !
!!OLD       vMaxXel = Acos(vMaxX/(2*vLimit))
!!OLD       vMaxYel = Acos(vMaxY/(2*vLimit))
!!OLD       !
!!OLD       Write (6,*) " max el vMaxXel: ", vMaxXel/deg
!!OLD       Write (6,*) " max el vMaxYel: ", vMaxYel/deg
!!OLD       !
!!OLD       !! aMaxXel = Acos(aMaxX/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
!!OLD       !! aMaxYel = Acos(aMaxY/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
!!OLD       !
!!OLD       MaxEl   = min(vMaxXel,vMaxYel)
!!OLD       !
!!OLD       Write (6,*) " max el  MaxEl:  ", MaxEl/deg
!!OLD       !
!!OLD       ! 2010-04-08 HU: force safe limit on maximum elevation
!!OLD       !                for GISMO run, based on TT-NCS
!!OLD       MaxEl = MaxEl-2.0*deg
!!OLD       !
!!OLD       Write (6,*) " max el  MaxEl:  ", MaxEl/deg
!!OLD       !
!!OLD       MaxEl   = min(MaxEl,85.0*deg)
!!OLD       !
!!OLD       Write (6,*) " max el  MaxEl:  ", MaxEl/deg
!!OLD       !
!!OLD       !!             If (MaxEl.Ge.60.0*deg) Then
!!OLD       !
!!OLD       condElevation%isSet     = .True.
!!OLD       condElevation%maximum   = MaxEl
!!OLD       !
!!OLD       Write (6,*) " condElevation%isSet:   ", condElevation%isSet
!!OLD       Write (6,*) " condElevation%maximum: ", condElevation%maximum/deg
!!OLD       !
       !
       sysName = offsPako%tru
       !
       !! NOTE:  code from here --> copied on 2012-05-30 from OTFMAP (2012-03-28)
       !! TBD:   extract this code, also use in OTFMAP, SUBSCAN OTF LINEAR
       !!        --> define / use local variable sysName in OTFMAP, SUBSCAN OTF LINEAR
       !! TBD:   long-term: ramp-up!
       !
       !                        !!  speed limit az. axis, el. axis
       vLimit   = 200.0         !!  based on tests 2012-03-15 to -20
       !                                 
       !
       If      (     GV%privilege.Eq.setPrivilege%ncsTeam                        &
            &  .Or.  GV%userLevel.Eq.setUserLevel%experienced                    &
            &  ) Then                                                            !
          If (GV%limitCheck.Eq.setLimitCheck%loose)   vLimit = 300.0 
          If (GV%limitCheck.Eq.setLimitCheck%relaxed) vLimit = 220.0
       End If
       !
       vLimitAz = vLimit        !!  speed limit az axis
       vLimitEl = vLimit        !!  speed limit el axis
       !
       !! aLimit = 108.0*arcsec
       !
       If (GV%doDebugMessages) Then
          Write (6,*) " vMaxX:     ", vMaxX
          Write (6,*) " vMaxY:     ", vMaxY
          Write (6,*) " vLimit:    ", vLimit
          Write (6,*) " vLimitAz:  ", vLimitAz
          Write (6,*) " vLimitEl:  ", vLimitEl
       End If
       !
       !! NOTE: use local variable sysName instead of vars(iTemp)%systemName:
       If (         sysName.Eq.offsPako%tru                                      &  
            &  .Or. sysName.Eq.offsPako%hor) Then                                !
          !
          If (vMaxX.Le.vLimitAz) Then
             vMaxXel = Acos(vMaxX/(vLimitAz))
          Else
             errorInconsistent = .true.
             Write (messageText,*) "Azimuth speed ", vMaxX,                      &
                  &                " too large for safe tracking"                !
             Call PakoMessage(priorityE,severityE,command,messageText)
          End If
          !
          If (vMaxY.Le.vLimitEl) Then
             vMaxYel = 90.0*deg
          Else
             errorInconsistent = .true.
             Write (messageText,*) "Elevation speed ", vMaxY,                    &
                  &                " too large for safe tracking"                !
             Call PakoMessage(priorityE,severityE,command,messageText)
          End If
          !
       Else
          !
          If (vMaxX.Le.vLimit .And. vMaxY.Le.vLimit) Then
             vMaxXel = Acos(vMaxX/(vLimit))
             vMaxYel = Acos(vMaxY/(vLimit))
          Else
             errorInconsistent = .true.
             Write (messageText,*) "Speed ", max(vMaxX,vMaxY),                   &
                  &                " too large for safe tracking"                !
             Call PakoMessage(priorityE,severityE,command,messageText)
          End If
          !
       End If
       !
       If (GV%doDebugMessages) Then
          Write (6,*) " max el vMaxXel: ", vMaxXel/deg
          Write (6,*) " max el vMaxYel: ", vMaxYel/deg
       End If
       !
       !! <<-- 2012-03-25
       !
       !! aMaxXel = Acos(aMaxX/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
       !! aMaxYel = Acos(aMaxY/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
       !
       MaxEl   = min(vMaxXel,vMaxYel)
       !
       ! 2010-04-08 HU: force safe limit on maximum elevation
       !                for GISMO run, based on TT-NCS
       MaxEl = MaxEl-2.0*deg
       !
       !D        Write (6,*) " max el  MaxEl:  ", MaxEl/deg
       !
       MaxEl   = max(0.0*deg,MaxEl) 
       MaxEl   = min(MaxEl,85.0*deg)
       !
       !D        Write (6,*) " max el vMaxXel: ", vMaxXel/deg
       !D        Write (6,*) " max el vMaxYel: ", vMaxYel/deg
       !D        Write (6,*) " max el aMaxXel: ", aMaxXel/deg
       !D        Write (6,*) " max el aMaxYel: ", aMaxYel/deg
       !D        !
       !D        Write (6,*) " max el  MaxEl:  ", MaxEl/deg
       !
       !!             If (MaxEl.Ge.60.0*deg) Then
       !
       condElevation%isSet     = .True.
       condElevation%maximum   = MaxEl
       !
       If (GV%doDebugMessages) Then
          Write (6,*) " condElevation%isSet:   ", condElevation%isSet
          Write (6,*) " condElevation%maximum: ", condElevation%maximum/deg
       End If
       !
       !! NOTE =: <-- copied on 2012-05-30 from OTFMAP (2012-03-28)
       !
       Write (messageText, fmt =                                           &
            &  '("WARNING--CONDITION: Elevation must be less than ",       &
            &     F10.2,                                                   &
            &    " [deg] ")' )                                             &
            & condElevation%maximum/deg                                    !
       Call pakoMESSAGE(priorityW,severityW,"POINTING",messageText)
       !
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)  = vars(iTemp)
    End If
    !
    !**   set "selected" observing mode & plot  ***
    If (.Not.error) Then
       GV%observingMode     = OM%Pointing
       GV%observingModePako = OMpako%Pointing
       GV%omSystemName      = offsPako%tru
       GV%condElevation     = condElevation
       !D        Write (6,*) "GV%condElevation: ", GV%condElevation                      !
       GV%notReadySWafterOM = .False.
       GV%notReadySecondaryRafterOM = .False.
       !D       Write (6,*) '      GV%notReadySecondaryRafterOM: ',                       &
       !D            &             GV%notReadySecondaryRafterOM
       GV%notReadyPointing  = .False.
       pointingCommand      = line(1:lenc(line))
       Call analyzePointing (errorA)
!!$       Call listSegmentList (errorA)
       Call plotPointing (errorP)
    End If
    !
    !**   display values  ***
    If (.Not.ERROR) Then
       Call displayPointing
       Call listDIYlist (error)
    End If
    !
    Return
  End Subroutine pointing
!!!
!!!
  Subroutine analyzePointing (errorA)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer                :: nScan 
    Character (len=lenCh)  :: aUnit, sUnit
    Integer                :: iSS           = 0     ! counts subcans/segment
    !
    Logical :: isBolometer   = .False.
    !
    Integer :: mm = 0
    !
    Real    ::  tAzFactor
    !
    errorA    = .False.
    iSS       = 0
    nScan     = 1111
    aUnit     = GV%angleUnitC                        ! 
    sUnit     = GV%speedUnitC                        ! 
    !
    !D     Write (6,*) "   --> analyzePointing   "
    !D Write (6,*) "       aeCode:      ", vars(iValue)%aeCode
    !D Write (6,*) "       aeCodeBites: ", vars(iValue)%aeCodeBites
    !D Write (6,*) "       nAeCode:     ", vars(iValue)%nAeCode
    !
    Call pako_message(seve%t,"paKo",                                             &
         &  " module Pointing, v 1.2.3  2014-09-23  --> SR: analyzePointing ")   ! trace execution
    !
    !D     Write (6,*) "       vars(iValue)%doDoubleBeam: ", vars(iValue)%doDoubleBeam
    !
    isBolometer = .False.
    !! TBD 2.0:    Call queryReceiver(rec%bolo, isBolometer)
    !
    !D    Write (6,*) " rec%bolo? ", isBolometer
    !
    swWobblerAmplitude       =  0.0
    swWobblerShiftAzimuth    =  0.0
    swWobblerShiftElevation  =  0.0
    If (GV%switchingMode .Eq. swMode%wobb) Then   
       !D       Write (6,*) '   GV%secondaryRotation: ', GV%secondaryRotation
       swWobblerAmplitude = 0.5*Abs(GV%wOffset(2)-GV%wOffset(1))
       swWobblerShiftAzimuth   =                                                 &
            &        -swWobblerAmplitude*Cos(GV%secondaryRotation/180.0*Pi)      !
       swWobblerShiftElevation =                                                 &
            &         swWobblerAmplitude*Sin(GV%secondaryRotation/180.0*Pi)      !
       If (Abs(swWobblerShiftAzimuth)  .Lt.0.1e-11) swWobblerShiftAzimuth  =0.0
       If (Abs(swWobblerShiftElevation).Lt.0.1e-11) swWobblerShiftElevation=0.0
          Write (messageText,*)                                                  &
               &      "SWWOBBLER implies: pointing cross will be shifted by: "   !
          Call pakoMessage(priorityI,severityI,'POINTING',messageText)
          Write (messageText,*)                                                  &
               &      swWobblerShiftAzimuth, " [arc sec] in azimuth"             !
          Call pakoMessage(priorityI,severityI,'POINTING',messageText)
          Write (messageText,*)                                                  &
               &      swWobblerShiftElevation, " [arc sec] in elevation"         !
          Call pakoMessage(priorityI,severityI,'POINTING',messageText)
          !
          If (           vars(iValue)%doDoubleBeam                               &
               &  .And.  .Not.isBolometer) Then                                  !
             tAzFactor  =                                                        &
                  & (                                                            &
                  &  1.0 +                                                       &
                  &  Abs(GV%wOffset(2)-GV%wOffset(1))/vars(iValue)%length        &
                  & )                                                            !
             Write (messageText,*)                                               &
                  &    "for azimuth subscans tSegment will be multiplied by ",   &
                  &    tAzFactor                                                 !
             Call pakoMessage(priorityI,severityI,'POINTING',messageText)
          Else
             tAzFactor = 1.0
          End If
          !
    End If
    !
    segList(:) = segDefault
    !
    Call countSubscans(value=0)
    Call countSegments(value=0)
    !

    !
    If (vars(ivalue)%doTune) Then
       !
       If (GV%doDebugMessages) Then
          Write (6,*) "  --> Tune Subscan "
          Write (6,*) "      vars(iValue)%doTune : ", vars(iValue)%doTune
          Write (6,*) "      vars(iValue)%tTune :  ", vars(iValue)%tTune
       End If
       !
       Call countSubscans(ii)
       Call countSegments(jj)
       !            
       iSS = iSS+1
       !
       segList(iSS)            =  segDefault                    ! TUNE
       !
       segList(iSS)%newSubscan =  .True.
       segList(iSS)%scanNumber =  nScan
       segList(iSS)%ssNumber   =  iSS
       segList(iSS)%segNumber  =  1
       segList(iSS)%ssType     =  ss%tune
       segList(iSS)%segType    =  seg%track
       segList(iSS)%angleUnit  =  aUnit
       segList(iSS)%speedUnit  =  sUnit
       !
       segList(iSS)%flagOn     =  .True.
       segList(iSS)%flagRef    =  .False.
       !
       segList(iSS)%flagDropin =  .False.
       !
       segList(iSS)%flagTune   =  vars(iIn)%doTune
       !
!!$       If (vars(ivalue)%doReference) Then
!!$          segList(iSS)%pStart     =  vars(iValue)%offsetR
!!$       Else
!!$          segList(iSS)%pStart     =  vars(iValue)%pStart
!!$       End If
       !
       segList(iSS)%pStart     =  vars(iValue)%offsetTune
       !
       segList(iSS)%pEnd       =  segList(iSS)%pStart
       segList(iSS)%speedStart =  0.0
       segList(iSS)%speedEnd   =  0.0
       segList(iSS)%systemName =  offs%tru
       segList(iSS)%altOption  =  'tSegment'
       segList(iSS)%tSegment   =  vars(iValue)%tTune
       segList(iSS)%tRecord    =  0.1
       !
!!$          iQuery    = iPro
!!$          nameQuery = GPnone
!!$          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
       !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
       !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
       !
       ! TBD: clever /proper handling of Doppler 
       segList(iSS)%upDateDoppler = .False.
       !
       If (GV%doDebugMessages) Then
          Write (messageText,*)  "  subscan #:   ", iSS, " ",                    &
               &             segList(iSS)%ssType, " ", segList(iSS)%pStart       !
!!$            &           " segList(iSS)%flagTune: ", segList(iSS)%flagTune        !
          Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
          !
          Write (6,*) "  <-- Tune Subscan "
       End If
       !
    End If   !!   (vars(ivalue)%doTune)
    !





    If (vars(iValue)%doCalibrate .And. .Not.isBolometer) Then
       !
       !                                                        Cal Sky
       Call countSubscans(ii)
       Call countSegments(jj)
       !D       Write (6,*) " Cal Sky    ii, jj ", ii, jj
       segList(ii)%newSubscan = .True.
       segList(ii)%ssNumber   =  ii
       segList(ii)%segNumber  =  1
       segList(ii)%ssType     =  ss%cs
       segList(ii)%segType    =  seg%track
       segList(ii)%angleUnit  =  aUnit
       segList(ii)%speedUnit  =  sUnit
       segList(ii)%flagOn     =  .True.
       segList(ii)%flagRef    =  .False.
       segList(ii)%pStart%x   = -vars(iValue)%length/2.0
       segList(ii)%pStart%y   =  0.0
       segList(ii)%pEnd       =  segList(ii)%pStart
       segList(ii)%systemName =  offsetSystemChoices(iHORIZONTRUE)
       segList(ii)%tSegment   =  3.0
       segList(ii)%tRecord    =  1.0
       !
       If (GV%switchingMode .Eq. swMode%wobb) Then   
          segList(ii)%pStart%x  = segList(ii)%pStart%x +swWobblerShiftAzimuth  
          segList(ii)%pEnd%x    = segList(ii)%pEnd%x   +swWobblerShiftAzimuth  
          segList(ii)%pStart%y  = segList(ii)%pStart%y +swWobblerShiftElevation 
          segList(ii)%pEnd%y    = segList(ii)%pEnd%y   +swWobblerShiftElevation
       End If
       !
       !                                                        Cal Cold
       Call countSubscans(ii)
       Call countSegments(jj)
       !D       Write (6,*) " Cal Cold   ii, jj ", ii, jj
       segList(ii)            =  segList(1)
       segList(ii)%ssNumber   =  ii
       segList(ii)%segNumber  =  1
       segList(ii)%ssType     =  ss%cc
       segList(ii)%segType    =  seg%track
       !                                                        Cal Ambient
       Call countSubscans(ii)
       Call countSegments(jj)
       !D       Write (6,*) " Cal Amb    ii, jj ", ii, jj
       segList(ii)            =  segList(1)
       segList(ii)%ssNumber   =  ii
       segList(ii)%segNumber  =  1
       segList(ii)%ssType     =  ss%ca
       segList(ii)%segType    =  seg%track
       !
    End If
    !
    If (vars(iValue)%aeCode .Eq.GPnone) Then                        ! normal sequence
       !
       If (vars(iValue)%nOtf .Ge. 1) Then                           ! first OTF incr. in Az
          Call countSubscans(ii)
          Call countSegments(jj)
          !D       Write (6,*) " 1st OTF    ii, jj ", ii, jj
          segList(ii)%newSubscan  =  .True.
          segList(ii)%scanNumber  =  nScan
          segList(ii)%ssNumber    =  ii
          segList(ii)%segNumber   =  1
          segList(ii)%ssType      =  ss%otf
          segList(ii)%segType     =  seg%linear
          segList(ii)%angleUnit   =  aUnit
          segList(ii)%speedUnit   =  sUnit
          segList(ii)%flagOn      =  .True.
          segList(ii)%flagRef     =  .False.
          segList(ii)%pStart%x    = -vars(iValue)%length/2.0
          segList(ii)%pStart%y    =  0.0
          segList(ii)%pEnd%x      =  vars(iValue)%length/2.0
          segList(ii)%pEnd%y      =  0.0
          segList(ii)%lengthOtf   =  vars(iValue)%length
          segList(ii)%systemName  =  offsetSystemChoices(iHORIZONTRUE)
          segList(ii)%altOption   =  "TOTF"
          segList(ii)%speedStart  =  vars(iValue)%length/vars(iValue)%tOtf
          segList(ii)%speedEnd    =  vars(iValue)%length/vars(iValue)%tOtf
          segList(ii)%tSegment    =  vars(iValue)%tOtf
          segList(ii)%tRecord     =  vars(iValue)%tRecord
          !
          If (GV%switchingMode .Eq. swMode%wobb) Then   
             segList(ii)%pStart%x  = segList(ii)%pStart%x+swWobblerShiftAzimuth  
             segList(ii)%pEnd%x    = segList(ii)%pEnd%x  +swWobblerShiftAzimuth  
             segList(ii)%pStart%y  = segList(ii)%pStart%y+swWobblerShiftElevation 
             segList(ii)%pEnd%y    = segList(ii)%pEnd%y  +swWobblerShiftElevation
             If (vars(iValue)%doDoubleBeam                                       &
                  & .And. Abs(GV%secondaryRotation).Lt.0.05) Then                !
                segList(ii)%pEnd%x = segList(ii)%pEnd%x                          &
                     &             + Abs(GV%wOffset(2)-GV%wOffset(1))            !
!!$             segList(ii)%tSegment = vars(iValue)%tOtf * tAzFactor
                segList(ii)%tSegment   = Nint(vars(iValue)%tOtf * tAzFactor)
                segList(ii)%speedStart = ( Abs(  segList(ii)%pEnd%x              &
                     &                          -segList(ii)%pStart%x)           &
                     &                        /  segList(ii)%tSegment  )         !
                segList(ii)%speedEnd   = segList(ii)%speedStart 
             End If
          End If
          !
       End If
       !
       If (vars(iValue)%nOtf .Eq. 2) Then                               ! 2nd OTF if only 2 incr. in El.
          Call countSubscans(ii)
          Call countSegments(jj)
          !D       Write (6,*) " 2nd OTF El ii, jj ", ii, jj
          segList(ii)             =  segList(ii-1)                     
          segList(ii)%ssNumber    =  ii
          segList(ii)%segNumber   =  1
          !
          segList(ii)%pStart%x    =  0.0
          segList(ii)%pStart%y    =  -vars(iValue)%length/2.0
          segList(ii)%pEnd%x      =  0.0
          segList(ii)%pEnd%y      =   vars(iValue)%length/2.0
          !
          !!
          segList(ii)%lengthOtf   =  vars(iValue)%length
          segList(ii)%speedStart  =  vars(iValue)%length/vars(iValue)%tOtf
          segList(ii)%speedEnd    =  vars(iValue)%length/vars(iValue)%tOtf
          segList(ii)%tSegment    =  vars(iValue)%tOtf
          !!
          !
          If (GV%switchingMode .Eq. swMode%wobb) Then   
             segList(ii)%pStart%x  = segList(ii)%pStart%x +swWobblerShiftAzimuth  
             segList(ii)%pEnd%x    = segList(ii)%pEnd%x   +swWobblerShiftAzimuth  
             segList(ii)%pStart%y  = segList(ii)%pStart%y +swWobblerShiftElevation 
             segList(ii)%pEnd%y    = segList(ii)%pEnd%y   +swWobblerShiftElevation
          End If
          !
       Else If (vars(iValue)%nOtf .Ge. 2) Then
          !
          Do kk = 2, vars(iValue)%nOtf, 1
             !
             If (Mod(kk,4).Eq.1) Then                                   ! incr. in Az.
                Call countSubscans(ii)
                Call countSegments(jj)
                !D             Write (6,*) " nth OTF    ii, jj, kk ", ii, jj, kk
                segList(ii)             =  segList(ii-1)                     
                segList(ii)%ssNumber    =  ii
                segList(ii)%segNumber   =  1
                !
                segList(ii)%pStart%x    =  -vars(iValue)%length/2.0
                segList(ii)%pStart%y    =  0.0                     
                segList(ii)%pEnd%x      =   vars(iValue)%length/2.0
                segList(ii)%pEnd%y      =  0.0                     
                !
                !!
                segList(ii)%lengthOtf   =  vars(iValue)%length
                segList(ii)%speedStart  =  vars(iValue)%length/vars(iValue)%tOtf
                segList(ii)%speedEnd    =  vars(iValue)%length/vars(iValue)%tOtf
                segList(ii)%tSegment    =  vars(iValue)%tOtf
                !!
                !
             End If
             !
             If (Mod(kk,4).Eq.2) Then                                   ! decr. in Az.
                Call countSubscans(ii)
                Call countSegments(jj)
                !D             Write (6,*) " nth OTF    ii, jj, kk ", ii, jj, kk
                segList(ii)             =  segList(ii-1)                 
                segList(ii)%ssNumber    =  ii
                segList(ii)%segNumber   =  1
                !
                segList(ii)%pStart%x    =   vars(iValue)%length/2.0
                segList(ii)%pStart%y    =  0.0                     
                segList(ii)%pEnd%x      =  -vars(iValue)%length/2.0
                segList(ii)%pEnd%y      =  0.0                     
                !
                !!
                segList(ii)%lengthOtf   =  vars(iValue)%length
                segList(ii)%speedStart  =  vars(iValue)%length/vars(iValue)%tOtf
                segList(ii)%speedEnd    =  vars(iValue)%length/vars(iValue)%tOtf
                segList(ii)%tSegment    =  vars(iValue)%tOtf
                !!
                !
             End If
             !
             If (Mod(kk,4).Eq.3) Then                                   ! incr. in El.
                Call countSubscans(ii)
                Call countSegments(jj)
                segList(ii)             =  segList(ii-1)
                !D             Write (6,*) " nth OTF    ii, jj, kk ", ii, jj, kk
                segList(ii)%ssNumber    =  ii
                segList(ii)%segNumber   =  1
                !
                segList(ii)%pStart%x    =  0.0                     
                segList(ii)%pStart%y    =  -vars(iValue)%length/2.0
                segList(ii)%pEnd%x      =  0.0                     
                segList(ii)%pEnd%y      =   vars(iValue)%length/2.0
                !
                !!
                segList(ii)%lengthOtf   =  vars(iValue)%length
                segList(ii)%speedStart  =  vars(iValue)%length/vars(iValue)%tOtf
                segList(ii)%speedEnd    =  vars(iValue)%length/vars(iValue)%tOtf
                segList(ii)%tSegment    =  vars(iValue)%tOtf
                !!
                !
             End If
             !
             If (Mod(kk,4).Eq.0) Then                                   ! decr. in El.
                Call countSubscans(ii)
                Call countSegments(jj)
                !D             Write (6,*) " nth OTF    ii, jj, kk ", ii, jj, kk
                segList(ii)             =  segList(ii-1)
                segList(ii)%ssNumber    =  ii
                segList(ii)%segNumber   =  1
                !
                segList(ii)%pStart%x    =  0.0                     
                segList(ii)%pStart%y    =   vars(iValue)%length/2.0
                segList(ii)%pEnd%x      =  0.0                     
                segList(ii)%pEnd%y      =  -vars(iValue)%length/2.0
                !
                !!
                segList(ii)%lengthOtf   =  vars(iValue)%length
                segList(ii)%speedStart  =  vars(iValue)%length/vars(iValue)%tOtf
                segList(ii)%speedEnd    =  vars(iValue)%length/vars(iValue)%tOtf
                segList(ii)%tSegment    =  vars(iValue)%tOtf
                !!
                !
             End If
             !
             If (GV%switchingMode .Eq. swMode%wobb) Then   
                segList(ii)%pStart%x  = segList(ii)%pStart%x+swWobblerShiftAzimuth  
                segList(ii)%pEnd%x    = segList(ii)%pEnd%x  +swWobblerShiftAzimuth  
                segList(ii)%pStart%y  = segList(ii)%pStart%y+swWobblerShiftElevation 
                segList(ii)%pEnd%y    = segList(ii)%pEnd%y  +swWobblerShiftElevation
                If (vars(iValue)%doDoubleBeam                                       &
                     & .And. Abs(GV%secondaryRotation).Lt.0.05                      &
                     & .And. Mod(kk,4).Eq.1) Then                                   !
                   segList(ii)%pEnd%x = segList(ii)%pEnd%x                          &
                        &             + Abs(GV%wOffset(2)-GV%wOffset(1))            !
!!$                segList(ii)%tSegment = vars(iValue)%tOtf * tAzFactor
                   segList(ii)%tSegment = Nint(vars(iValue)%tOtf * tAzFactor)
                   segList(ii)%speedStart = ( Abs(  segList(ii)%pEnd%x           &
                        &                          -segList(ii)%pStart%x)        &
                        &                        /  segList(ii)%tSegment  )      !
                   segList(ii)%speedEnd   = segList(ii)%speedStart 
                End If
                If (vars(iValue)%doDoubleBeam                                       &
                     & .And. Abs(GV%secondaryRotation).Lt.0.05                      &
                     & .And. Mod(kk,4).Eq.2) Then                                   !
                   segList(ii)%pStart%x = segList(ii)%pStart%x                      &
                        &               + Abs(GV%wOffset(2)-GV%wOffset(1))          !
!!$                segList(ii)%tSegment = vars(iValue)%tOtf * tAzFactor
                   segList(ii)%tSegment = Nint(vars(iValue)%tOtf * tAzFactor)
                   segList(ii)%speedStart = ( Abs(  segList(ii)%pEnd%x           &
                        &                          -segList(ii)%pStart%x)        &
                        &                        /  segList(ii)%tSegment  )      !
                   segList(ii)%speedEnd   = segList(ii)%speedStart 
                End If
             End If
             !
          End Do
          !
       End If
       !
    Else                                                                ! use /aeLoop aeCode
       !
       mm    = 0
       !
       Do kk = 1, vars(iValue)%nOtf, 1
          mm = mm+1
          If (mm.Gt.vars(iValue)%nAeCode) mm = mm - vars(iValue)%nAeCode
          !D       Write (6,*)  "      subscan kk:        ", kk
          !D       Write (6,*)  "      aeLoop  mm:        ", mm
          !D       Write (6,*)  "      aeCodeBites(mm):   ", vars(iValue)%aeCodeBites(2*mm-1:2*mm)
          !
          Call countSubscans(ii)
          Call countSegments(jj)
          !D       Write (6,*) " nth OTF    ii, jj, kk ", ii, jj, kk
          !
          segList(ii)%newSubscan  =  .True.
          segList(ii)%scanNumber  =  nScan
          segList(ii)%ssNumber    =  ii
          segList(ii)%segNumber   =  1
          segList(ii)%ssType      =  ss%otf
          segList(ii)%segType     =  seg%linear
          segList(ii)%angleUnit   =  aUnit
          segList(ii)%speedUnit   =  sUnit
          segList(ii)%flagOn      =  .True.
          segList(ii)%flagRef     =  .False.
          segList(ii)%lengthOtf   =  vars(iValue)%length
          segList(ii)%systemName  =  offsetSystemChoices(iHORIZONTRUE)
          segList(ii)%altOption   =  "TOTF"
          segList(ii)%speedStart  =  vars(iValue)%length/vars(iValue)%tOtf
          segList(ii)%speedEnd    =  vars(iValue)%length/vars(iValue)%tOtf
          segList(ii)%tSegment    =  vars(iValue)%tOtf
          segList(ii)%tRecord     =  vars(iValue)%tRecord
          !
          Call pakoUmatchKey (                                              &
               &              keys=azelChoices,                             &
               &              key=vars(iValue)%aeCodeBites(2*mm-1:2*mm),    &
               &              command='POINTING',                           &
               &              howto='Start Upper',                          &
               &              iMatch=iMatch,                                &
               &              nMatch=nMatch,                                &
               &              error=errorM,                                 &
               &              errorCode=errorCode                           &
               &             )

          !
          !D       Write (6,*) ii
          !D       Write (6,*) azElChoices(iMatch)
          !D       Write (6,*) azel%pa
          !
          If (azElChoices(iMatch).Eq.azel%pa) Then                               ! incr. in Az.
             !
             segList(ii)%pStart%x    =  -vars(iValue)%length/2.0
             segList(ii)%pStart%y    =  0.0                     
             segList(ii)%pEnd%x      =   vars(iValue)%length/2.0
             segList(ii)%pEnd%y      =  0.0                     
             !
             !D          Write (6,*) segList(ii)%pStart%x, segList(ii)%pStart%y
             !D          Write (6,*) segList(ii)%pEnd%x ,  segList(ii)%pEnd%y
             !
          End If
          !
          If (azElChoices(iMatch).Eq.azel%ma) Then                               ! decr. in Az.
             !
             segList(ii)%pStart%x    =   vars(iValue)%length/2.0
             segList(ii)%pStart%y    =  0.0                     
             segList(ii)%pEnd%x      =  -vars(iValue)%length/2.0
             segList(ii)%pEnd%y      =  0.0                     
             !
          End If
          !
          If (azElChoices(iMatch).Eq.azel%pe) Then                               ! incr. in El.
             !
             segList(ii)%pStart%x    =  0.0                     
             segList(ii)%pStart%y    =  -vars(iValue)%length/2.0
             segList(ii)%pEnd%x      =  0.0                     
             segList(ii)%pEnd%y      =   vars(iValue)%length/2.0
             !
          End If
          !
          If (azElChoices(iMatch).Eq.azel%me) Then                               ! decr. in El.
             !
             segList(ii)%pStart%x    =  0.0                     
             segList(ii)%pStart%y    =   vars(iValue)%length/2.0
             segList(ii)%pEnd%x      =  0.0                     
             segList(ii)%pEnd%y      =  -vars(iValue)%length/2.0
             !
          End If
          !
          If (GV%switchingMode .Eq. swMode%wobb) Then   
             segList(ii)%pStart%x  = segList(ii)%pStart%x+swWobblerShiftAzimuth  
             segList(ii)%pEnd%x    = segList(ii)%pEnd%x  +swWobblerShiftAzimuth  
             segList(ii)%pStart%y  = segList(ii)%pStart%y+swWobblerShiftElevation 
             segList(ii)%pEnd%y    = segList(ii)%pEnd%y  +swWobblerShiftElevation
             If (vars(iValue)%doDoubleBeam                                       &
                  & .And. Abs(GV%secondaryRotation).Lt.0.05                      &
                  & .And. azElChoices(iMatch).Eq.azel%pa) Then                   !
                segList(ii)%pEnd%x = segList(ii)%pEnd%x                          &
                     &             + Abs(GV%wOffset(2)-GV%wOffset(1))            !
!!$             segList(ii)%tSegment = vars(iValue)%tOtf * tAzFactor
                segList(ii)%tSegment = Nint(vars(iValue)%tOtf * tAzFactor)
                segList(ii)%speedStart = ( Abs(  segList(ii)%pEnd%x              &
                     &                          -segList(ii)%pStart%x)           &
                     &                        /  segList(ii)%tSegment  )         !
                segList(ii)%speedEnd   = segList(ii)%speedStart 
             End If
             If (vars(iValue)%doDoubleBeam                                       &
                  & .And. Abs(GV%secondaryRotation).Lt.0.05                      &
                  & .And. azElChoices(iMatch).Eq.azel%ma) Then                   !
                segList(ii)%pStart%x = segList(ii)%pStart%x                      &
                     &               + Abs(GV%wOffset(2)-GV%wOffset(1))          !
!!$             segList(ii)%tSegment = vars(iValue)%tOtf * tAzFactor
                segList(ii)%tSegment = Nint(vars(iValue)%tOtf * tAzFactor)
                segList(ii)%speedStart = ( Abs(  segList(ii)%pEnd%x              &
                     &                          -segList(ii)%pStart%x)           &
                     &                        /  segList(ii)%tSegment  )         !
                segList(ii)%speedEnd   = segList(ii)%speedStart 
             End If
          End If
          !
       End Do
       !
    End If
    !
    Call getCountSegments(nSegments)
    !
    Return 
    !
  End Subroutine analyzePointing
!!!
!!!
  Subroutine displayPointing
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    !D     Write (6,*) "      --> SR displayPointing "
    !
    Include 'inc/display/commandDisplayPointing.inc'
    !
  End Subroutine displayPointing
!!!
!!!
  Subroutine plotPointing (errorP)
    !
    !**   Variables  for Plots   ***
    Include 'inc/variables/headerForPlotMethods.inc'
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer :: nSegments
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Pointing, v 1.2.3  2014-12-15 ---> SR: plotPointing ")      ! trace execution
    !
    errorP = .False.
    !
    Call configurePlots
    !
    Call plotPointingStart(errorP)
    !
    Call getCountSegments(nSegments)
    !D     Write (6,*) '      number of segments: ', nSegments
    !
    Do ii = 1, nSegments, 1
       !
       !D        Write (6,*) ii, segList(ii)%ssType, segList(ii)%segType,                  &
       !D             &          segList(ii)%flagOn, segList(ii)%flagRef,                  &
       !D             &          segList(ii)%flagTune                                      !
       !
       If (segList(ii)%ssType .Eq.ss%cs .And.                                    &
            &       segList(ii)%segType.Eq.seg%track) Then                       !
          Call plotCalSky(segList(ii)%pStart%x,segList(ii)%pStart%y,             &
               &                    errorP,                                      &
               &                    number=segList(ii)%ssNumber,                 &
               &                    Type=segList(ii)%ssType)                     !
          !
       Else If (segList(ii)%ssType .Eq.ss%tune                                   &
            &   .And. segList(ii)%segType.Eq.seg%track                           &
            &   .And. segList(ii)%flagTune) Then                                 !  !!  TRACK tune
          !!D  Write (6,*) "      ii: ", ii, " -> plot Track /Tune "
          Call plotTrackP( segList(ii)%pStart,                                   &
               &           errorP,                                               &
               &           number=segList(ii)%ssNumber,                          &
               &           Type=ss%tune)                                         !
          !
       End If
       !
    End Do
    !
    If (GV%switchingMode .Ne. swMode%wobb) Then   
       jj = 0
       Do ii = 1, nSegments, 1
          !
          If (segList(ii)%ssType .Eq.ss%otf .And.                                &
               segList(ii)%segType.Eq.seg%linear) Then                           !
             jj = jj+1
             If (jj.Le.4) Then
                Call plotOtfLinear(segList(ii)%pStart%x,segList(ii)%pStart%y,    &
                     &                    segList(ii)%pEnd%x,segList(ii)%pEnd%y, &
                     &                    errorP,                                &
                     &                    number=jj,                             &
                     &                    Type='pointing')                       !
             Else
                Call plotOtfLinear(segList(ii)%pStart%x,segList(ii)%pStart%y,    &
                     &                    segList(ii)%pEnd%x,segList(ii)%pEnd%y, &
                     &                    errorP,                                &
                     &                    Type='pointing')                       !
             End If
          End If
       End Do
    End If
    !
    If (GV%switchingMode .Eq. swMode%wobb) Then   
       !
       jj = 0
       Do ii = 1, nSegments, 1
          If (segList(ii)%ssType .Eq.ss%otf .And.                                &
               segList(ii)%segType.Eq.seg%linear) Then                           !
             jj = jj+1
             If (jj.Le.4) Then
                Call plotOtfLinear(segList(ii)%pStart%x,segList(ii)%pStart%y,    &
                     &                    segList(ii)%pEnd%x,segList(ii)%pEnd%y, &
                     &                    errorP,                                &
                     &                    number=jj,                             &
                     &                    Type='extra')                          !
                Call plotOtfLinear(segList(ii)%pStart%x-swWobblerShiftAzimuth,   &
                     &             segList(ii)%pStart%y-swWobblerShiftElevation, &
                     &             segList(ii)%pEnd%x  -swWobblerShiftAzimuth,   &
                     &             segList(ii)%pEnd%y  -swWobblerShiftElevation, &
                     &                    errorP,                                &
                     &                    number=jj,                             &
                     &                    Type='pointing')                       !
             Else
                Call plotOtfLinear(segList(ii)%pStart%x,segList(ii)%pStart%y,    &
                     &                    segList(ii)%pEnd%x,segList(ii)%pEnd%y, &
                     &                    errorP,                                &
                     &                    Type='extra')                          !
                Call plotOtfLinear(segList(ii)%pStart%x-swWobblerShiftAzimuth,   &
                     &             segList(ii)%pStart%y-swWobblerShiftElevation, &
                     &             segList(ii)%pEnd%x  -swWobblerShiftAzimuth,   &
                     &             segList(ii)%pEnd%y  -swWobblerShiftElevation, &
                     &                    errorP,                                &
                     &                    Type='pointing')                       !
             End If
          End If
       End Do
    End If
    !
    Call gr_exec(      'set character 0.6' )
    Call gr_exec(      'pen 0'             )
    !
    errorP =  errorP .Or. GR_ERROR()
    !
    If (errorP)                                                                 &
         &        Call PakoMessage(priorityE,severityE,                         &
         &        'Pointing',' could not plot ')                                !
    !
    Return
  End Subroutine plotPointing
!!!
!!!
  Subroutine savePointing(programName,LINE,commandToSave, iUnit, ERROR)                           
    !
    !**   Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    contC = contNN
    !
    error = .False.
    !
    Include 'inc/commands/saveCommand.inc'
    !
    contC = contCC
    !
    Include 'inc/parameters/saveLength.inc'
    !
    Include 'inc/options/saveDoubleBeam.inc'
    !TBD:      Include 'inc/options/saveCalibrate.inc'
    !TBD:      Include 'inc/options/saveFeBe.inc'
    !TBD:      Include 'inc/options/saveMore.inc'
    Include 'inc/options/saveNotf.inc'
    !TBD:      Include 'inc/options/saveTrecord.inc'
    !TBD:      Include 'inc/options/saveUpdate.inc'
    !
    !D     Write (6,*) "      vars(iValue)%doTuneSet:   ", vars(iValue)%doTuneSet
    !
    If (.Not.vars(iValue)%doTuneSet .And. vars(iValue)%aeCode.Eq.GPnone) Then
       contC = contCN
    End If
    !
    Include 'inc/options/saveTotf.inc'
    !
    If (vars(iValue)%aeCode.Ne.GPnone) Then
       !
       If (.Not. vars(iValue)%doTuneSet ) Then
          contC = contCN
       End If
       !
       Include'inc/options/saveAeLoop.inc'
       !
    End If
    !
    If (vars(iValue)%doTuneSet) Then
       If ( vars(iValue)%doTune) Then
          Include 'inc/options/saveTuneOffsets.inc'
          doContinue = .False.
          contC = contCN
          Include 'inc/options/saveTuneTime.inc'
       Else 
          doContinue = .False.
          contC = contCN
          Include 'inc/options/saveTuneOffsets.inc'
       End If
    End If
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine savePointing
!!!
!!!
  Subroutine startPointing(programName,LINE,commandToSave,         &
       &        iUnit, ERROR)
    !
    !**   Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: valueComment
    Character (len=lenLine) :: messageText
    Logical                 :: errorL, errorXML
    !
    !D      Write (6,*) "   --> modulePakoPointing: SR startPointing "
    !
    ERROR = .False.
    !
    Call pakoXMLsetOutputUnit(iunit=iunit)
    Call pakoXMLsetIndent(iIndent=2)
    !
    Include 'inc/startXML/generalHead.inc'
!!OLD    Include 'inc/startXML/pointingHead.inc'
    !
    Call writeXMLset(programName,LINE,commandToSave,                  &
         &           iUnit, ERROR)
    !
    !!! Call writeXMLversion !!! incorporated in generalHead above
    !
    Call pakoXMLwriteStartElement("RESOURCE","pakoScript",             &
         &                         comment="save from pako",                 &
         &                         error=errorXML)
    Call pakoXMLwriteStartElement("DESCRIPTION",                      &
         &                         doCdata=.True.,                          &
         &                         error=errorXML)
    !
    Include 'inc/startXML/savePakoScriptFirst.inc'
    !
    Call savePointing     (programName,LINE,commandToSave, iUnit, errorL)
    !
    Call pakoXMLwriteEndElement("DESCRIPTION",                         &
         &                         doCdata=.True.,                           &
         &                         error=errorXML)
    Call pakoXMLwriteEndElement  ("RESOURCE","pakoScript",             &
         &                         space="after",                            &
         &                         error=errorXML)
    !
    Call writeXMLantenna(programName,LINE,commandToSave,              &
         &         iUnit, ERROR)
    !
    Call writeXMLreceiver(programName,LINE,commandToSave,              &
         &        iUnit, ERROR)
    !
    Call writeXMLbackend(programName,LINE,commandToSave,               &
         &        iUnit, ERROR)
    !
    Include 'inc/startXML/switchingMode.inc'
    !
    Call writeXMLsource(programName,LINE,commandToSave,                &
         &        iUnit, ERROR)
    !
    Include 'inc/startXML/generalScanHead.inc'
    !    
    Include 'inc/startXML/conditions.inc'
    !
    ! **  Observing Mode to XML
    If (gv%doXMLobservingMode) Then
       messageText = "writing observing mode in XML format"
       Call PakoMessage(priorityI,severityI,                                     &
               &           commandToSave,messageText)                            !
       Call writeXMLpointing(programName,LINE,commandToSave,                     &
         &         iUnit, ERROR)                                                 !
    End If
    !
    ! **  subscan list to XML
    Call writeXMLsubscanList(programName,LINE,commandToSave,         &
         &        iUnit, ERROR)
    !   
    Include 'inc/startXML/generalTail.inc'
    !
    Return
  End Subroutine startPointing
!!!
!!!
  Subroutine writeXMLpointing(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: iMatch, nMatch, len1, len2
    Character (len=lenCh)   :: valueC, errorCode
    Character (len=lenLine) :: valueComment
    Logical                 :: errorM, errorXML
    Character (len=lenCh)   :: systemName
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Pointing, v 1.2.3 ---> SR: writeXMLpointing 2014-10-27")    ! trace execution
    !
    Call pakoXMLwriteStartElement("RESOURCE","observingMode",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    valueC = GV%observingMode
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/parametersLengthXML.inc'
    !
    !! TBD 2.0:    option aeLoop
    !
    Include 'inc/startXML/optionDoubleBeamXML.inc'
    Include 'inc/startXML/optionNotfXML.inc'
    Include 'inc/startXML/optionTotfXML.inc'
    !
    systemName = offsPako%tru
    If (vars(iValue)%doTune) Then 
       Include 'inc/startXML/optionTuneXML.inc'
       Include 'inc/startXML/optionTtuneXML.inc'
    End If
    !D     Write (6,*) " systemName: --> ", systemName, "<-- "
    !D     Write (6,*) " offs%tru:   --> ", offs%tru,   "<-- "
    !
    Include 'inc/startXML/annotationsXML.inc'
    !
    Call pakoXMLwriteEndElement("RESOURCE","observingMode",                      &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLpointing
!!!
!!!
End Module modulePakoPointing
!!!

subroutine mrtcal_find_comm(line,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_find_comm
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command:
  !   MFIND
  ! Read the index file
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND'
  !
  mfound = 0
  !
  call mrtindex_find_comm(line,ix,cx,error)
  if (error)  return
  !
  mfound = cx%next-1
  kcurr_cx = 0  ! For READ ZERO|FIRST|LAST|NEXT|PREV
  kcurr_ix = 0
  !
  call sic_def_long('mdx%curr',kcurr_cx,0,1,.false.,error)
  !
end subroutine mrtcal_find_comm

module plot_molecules_globals
  use astro_types
  !
  type(plot_molecules_t), save :: molecules
  !
end module plot_molecules_globals
!
module frequency_axis_globals
  use astro_types
  !
  type(frequency_axis_t), save :: freq_axis
  !
end module frequency_axis_globals
!
!
module my_receiver_globals
  use astro_noema_type
  !
  type(noema_t), save          :: noema          ! everything about NOEMA
  type(emir_t),  save          :: emir           ! emir global
  type(current_boxes_t),  save :: cplot          ! current plot
  type(spw_t)                  :: spw2           ! spw collection 2nd list (when comparison are done)
  !
end module my_receiver_globals

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_snr
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: snr
  private
  !
  type :: snr_comm_t
     type(option_t), pointer :: comm
     type(cubeid_arg_t), pointer :: sig
     type(cubeid_arg_t), pointer :: noi
     type(cube_prod_t),  pointer :: snr
   contains
     procedure, public  :: register => cubemain_snr_comm_register
     procedure, private :: parse    => cubemain_snr_comm_parse
     procedure, private :: main     => cubemain_snr_comm_main
  end type snr_comm_t
  type(snr_comm_t) :: snr
  !
  type snr_user_t
     type(cubeid_user_t) :: cubeids
   contains
     procedure, private :: toprog => cubemain_snr_user_toprog
  end type snr_user_t
  !
  type snr_prog_t
     type(cube_t), pointer :: sig
     type(cube_t), pointer :: noi
     type(cube_t), pointer :: snr
     procedure(cubemain_snr_prog_singlenoise_loop), pointer :: loop => null()
   contains
     procedure, private :: header          => cubemain_snr_prog_header
     procedure, private :: data            => cubemain_snr_prog_data
     procedure, private :: singlenoise_act => cubemain_snr_prog_singlenoise_act
     procedure, private :: multinoise_act  => cubemain_snr_prog_multinoise_act
  end type snr_prog_t
  !
contains
  !
  subroutine cubemain_snr_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(snr_user_t) :: user
    character(len=*), parameter :: rname='SNR>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call snr%parse(line,user,error)
    if (error) return
    call snr%main(user,error)
    if (error) continue
  end subroutine cubemain_snr_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_snr_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(snr_comm_t), intent(inout) :: comm
    logical,           intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='SNR>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'SNR','[signalid [noiseid]]',&
         'Compute the signal to noise ratio',&
         'SNR divides SIGNALID by NOISEID to produce an SNR cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- If NOISEID has one channel, that single value is used for&
         & all SIGNALID channels.'//strg_cr//&
         '- If NOISEID has multiple channels, it is interpolated on the&
         & SIGNALID spectral axis before division.',&
         cubemain_snr_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         comm%sig,&
        error)
    if (error) return
    call incube%register(&
         'NOISEID',&
         'Noise cube identifier',&
         'If omitted, use the last matching cube (noise flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_noise],&
         code_read,&
         code_access_speset,&
         comm%noi,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'SNR',&
         'Cube of Signal-to-Noise Ratios',&
         strg_emp,&
         [flag_snr],&
         comm%snr,&
         error)
    if (error) return
  end subroutine cubemain_snr_comm_register
  !
  subroutine cubemain_snr_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! SNR [signalid [noiseid]]
    !----------------------------------------------------------------------
    class(snr_comm_t), intent(in)    :: comm
    character(len=*),  intent(in)    :: line
    type(snr_user_t),  intent(out)   :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='SNR>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubemain_snr_comm_parse
  !
  subroutine cubemain_snr_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(snr_comm_t), intent(in)    :: comm
    type(snr_user_t),  intent(in)    :: user
    logical,           intent(inout) :: error
    !
    type(snr_prog_t) :: prog
    character(len=*), parameter :: rname='SNR>COMM>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_snr_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_snr_user_toprog(user,comm,prog,error)
    use cubetools_consistency_methods
    use cubetools_header_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(snr_user_t), intent(in)    :: user
    type(snr_comm_t),  intent(in)    :: comm
    type(snr_prog_t),  intent(out)   :: prog
    logical,           intent(inout) :: error
    !
    logical :: conspb
    integer(kind=chan_k) :: nnoi
    character(len=*), parameter :: rname='SNR>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !    
    call cubeadm_get_header(comm%sig,user%cubeids,prog%sig,error)
    if (error) return
    call cubeadm_get_header(comm%noi,user%cubeids,prog%noi,error)
    if (error) return
    !
    conspb = .false.
    call cubetools_consistency_signal_noise(&
         'Input cube',prog%sig%head,&
         'Noise',prog%noi%head,&
         conspb,error)
    if (error) return
    if (cubetools_consistency_failed(rname,conspb,error)) return
    !
    call cubetools_header_get_nchan(prog%noi%head,nnoi,error)
    if (error) return
    if (nnoi.eq.1) then
       prog%loop => cubemain_snr_prog_singlenoise_loop
    else
       prog%loop => cubemain_snr_prog_multinoise_loop
    endif
  end subroutine cubemain_snr_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_snr_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(snr_prog_t), intent(inout) :: prog
    class(snr_comm_t), intent(in)    :: comm
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='SNR>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%snr,prog%sig,prog%snr,error)
    if (error) return
    call cubetools_header_put_array_unit('---',prog%snr%head,error)
    if (error) return
  end subroutine cubemain_snr_prog_header
  !
  subroutine cubemain_snr_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='SNR>PROG>DATA'
    type(cubeadm_iterator_t) :: iter
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) then
          call prog%loop(iter,error)
       endif
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_snr_prog_data
  !
  subroutine cubemain_snr_prog_singlenoise_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t),        intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: sig,noi,snr
    character(len=*), parameter :: rname='SNR>PROG>SINGLENOISE>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    ! 
    call sig%associate('sig',prog%sig,iter,error)
    if (error) return
    call noi%associate('noi',prog%noi,iter,error)
    if (error) return
    call snr%allocate('snr',prog%snr,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%singlenoise_act(iter%ie,sig,noi,snr,error)
      if (error) return
    enddo ! iter
  end subroutine cubemain_snr_prog_singlenoise_loop
  !
  subroutine cubemain_snr_prog_singlenoise_act(prog,ie,sig,noi,snr,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t),    intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(spectrum_t),     intent(inout) :: sig
    type(spectrum_t),     intent(inout) :: noi
    type(spectrum_t),     intent(inout) :: snr
    logical,              intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    real(kind=sign_k), pointer :: noise
    character(len=*), parameter :: rname='SNR>PROG>SINGLENOISE>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call sig%get(ie,error)
    if (error) return
    call noi%get(ie,error)
    if (error) return
    noise => noi%y%val(1)
    if ((noise.gt.0).and.(.not.ieee_is_nan(noise))) then
       do ic=1,snr%n
          if (.not.ieee_is_nan(sig%y%val(ic))) then
             snr%y%val(ic) = sig%y%val(ic)/noise
          else
             snr%y%val(ic) = gr4nan 
          endif
       enddo ! ic
    else
       snr%y%val(:) = gr4nan
    endif
    call snr%put(ie,error)
    if (error) return
  end subroutine cubemain_snr_prog_singlenoise_act
  !
  subroutine cubemain_snr_prog_multinoise_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    use cubemain_interpolate_spectrum_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t),        intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: sig,rawnoi,intnoi,snr
    type(interpolate_spectrum_prog_t) :: interp
    character(len=*), parameter :: rname='SNR>PROG>MULTINOISE>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call sig%associate('sig',prog%sig,iter,error)
    if (error) return
    call intnoi%allocate('intnoi',prog%sig,iter,error)
    if (error) return
    call intnoi%get_header(error)
    if (error) return
    call rawnoi%associate('rawnoi',prog%noi,iter,error)
    if (error) return
    call rawnoi%get_header(error)
    if (error) return
    call snr%allocate('snr',prog%snr,iter,error)
    if (error) return
    call interp%init(rawnoi,intnoi,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%multinoise_act(iter%ie,sig,rawnoi,intnoi,snr,interp,error)
       if (error) return
    enddo ! iter
  end subroutine cubemain_snr_prog_multinoise_loop
  !
  subroutine cubemain_snr_prog_multinoise_act(prog,ie,sig,rawnoi,intnoi,snr,interp,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    use cubemain_interpolate_spectrum_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t),                 intent(inout) :: prog
    integer(kind=entr_k),              intent(in)    :: ie
    type(spectrum_t),                  intent(inout) :: sig
    type(spectrum_t),                  intent(inout) :: rawnoi
    type(spectrum_t),                  intent(inout) :: intnoi
    type(spectrum_t),                  intent(inout) :: snr
    type(interpolate_spectrum_prog_t), intent(in)    :: interp
    logical,                           intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    real(kind=sign_k), pointer :: noise
    character(len=*), parameter :: rname='SNR>PROG>MULTINOISE>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call sig%get(ie,error)
    if (error) return
    call rawnoi%get(ie,error)
    if (error) return
    snr%y%val(:) = gr4nan
    if (rawnoi%y%isblanked()) then
       ! Nothing to do
    else
       call interp%spectrum(rawnoi,intnoi,error)
       if (error) return
       do ic=1,snr%n
          noise => intnoi%y%val(ic) 
          if ((noise.gt.0).and.(.not.ieee_is_nan(noise))) then
             if (.not.ieee_is_nan(sig%y%val(ic))) then
                ! *** JP: The fact that only positive or both
                ! *** JP: positive and negative values should be considered
                ! *** JP: signal should be a user-domain decision
                snr%y%val(ic) = sig%y%val(ic)/noise
             endif
          endif
       enddo ! ic
    endif
    call snr%put(ie,error)
    if (error) return
  end subroutine cubemain_snr_prog_multinoise_act
end module cubemain_snr
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program main_map_expand
  use gbl_format
  use gkernel_interfaces
  !
  logical error
  !
  error = .false.
  call map_expand(error)
  if (error) call sysexi(fatale)
end program
!
subroutine map_expand(error)
  use gildas_def
  use gbl_format
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  !	Expand a data cube along its TWO first dimensions, by Fourier
  !     Transform
  !---------------------------------------------------------------------
  logical, intent(out) :: error
  ! Local
  real, parameter :: eps = 2.e-7
  character(len=filename_length) :: mapin, mapout
  integer :: i,j,ier,n,nexp, ndim, dim(2)
  complex, allocatable :: ipl(:,:), ips(:,:)
  real, allocatable :: ipw(:)
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('INPUT_MAP$',mapin)
  call gildas_char('OUTPUT_MAP$',mapout)
  call gildas_inte('EXPAND$',nexp,1)
  call gildas_close
  !
  if (nexp.lt.2. .or. nexp.gt.8) then
    write(6,*) 'E-MAP_EXPAND,  Invalid expansion ',nexp
    error = .true.
    return
  endif
  !
  ! Input file
  n = len_trim(mapin)
  call gildas_null(y)
  y%gil%ndim = 3
  call gdf_read_gildas(y,mapin,'.lmv',error, data=.false.)
  if (error) then
    call gagout('F-MAP_EXPAND,  Cannot read input cube')
    error = .true.
    return
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(mapout,x%file,' ','.lmv')
  !
  x%gil%dim(1:2) = y%gil%dim(1:2)*nexp
  !
  allocate(ips(y%gil%dim(1),y%gil%dim(2)), ipl(x%gil%dim(1),x%gil%dim(2)), &
  & ipw(2*max(x%gil%dim(1),x%gil%dim(2))), stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  allocate(y%r2d(y%gil%dim(1),y%gil%dim(2)), x%r2d(x%gil%dim(1),x%gil%dim(2)), & 
  & stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  ! Transform coordinates (1,1) ---> (1,1)
  x%gil%inc(1:2) = y%gil%inc(1:2)/nexp
  x%gil%ref(1:2) = 1.0d0
  x%gil%val(1:2) = (x%gil%ref(1:2)-y%gil%ref(1:2))*y%gil%inc(1:2)+y%gil%val(1:2)
  !
  ! Create Output file
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-MAP_EXPAND,  Cannot create output image'
    error = .true.
    return
  endif
  !
  ! Use the NX/2+1 pixel as reference value for convenience
  x%gil%val(1:2)  = (x%gil%dim(1:2)/2+1.d0-x%gil%ref(1:2))*x%gil%inc(1:2) + x%gil%val(1:2)
  x%gil%ref(1:2) = x%gil%dim(1:2)/2+1.d0
  !
  !
  ! Setup FFTW
  ndim = 2
  dim(1) = x%gil%dim(1)
  dim(2) = x%gil%dim(2)
  call fourt_plan(ipl,dim,ndim,-1,0)
  dim(1) = y%gil%dim(1)
  dim(2) = y%gil%dim(2)
  call fourt_plan(ips,dim,ndim,1,1)
  !
  ! Now loop over planes
  do j = 1,x%gil%dim(4)
    y%blc(4) = j
    y%trc(4) = j  
    do i = 1,x%gil%dim(3)
      y%blc(3) = i
      y%trc(3) = i
      x%blc = y%blc
      x%trc = y%trc
      call gdf_read_data(y,y%r2d,error)
      call expand (   &
     &      x%gil%dim(1),x%gil%dim(2),x%r2d,ipl,   &
     &      y%gil%dim(1),y%gil%dim(2),y%r2d,ips,   &
     &      ipw )
      call gdf_write_data(x,x%r2d,error)
    enddo
  enddo
  !
  deallocate(ips,ipl,ipw,x%r2d,y%r2d,stat=ier)
  call gdf_close_image(x,error)
  call gdf_close_image(y,error)
  call gagout ('S-EXPAND,  Successful completion')
  error = .false.
end subroutine map_expand
!
subroutine expand (nx,ny,large,wl,mx,my,small,ws,work)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !	Expand an image through FT zero extension
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nx   ! Large X size
  integer(kind=index_length), intent(in) :: ny   ! Large Y size
  real, intent(out) :: large(nx,ny)              ! Output (expanded) image
  complex, intent(inout) :: wl(nx,ny)            ! Work array
  integer(kind=index_length), intent(in) :: mx   ! Small X size
  integer(kind=index_length), intent(in) :: my   ! Small Y size
  real, intent(in) :: small(mx,my)               ! Input (small) image
  complex, intent(inout) :: ws(mx,my)            ! Work array
  real, intent(inout) :: work(*)                 ! FFT work space
  ! Local
  integer :: j,ndim,dim(2)
  real :: fact
  !
  ws = small
  !
  ndim = 2
  dim(1) = mx
  dim(2) = my
  call fourt(ws,dim,ndim,-1,0,work)
  !
  ! Clear output FT
  wl = 0.0
  ! Load inner quarter
  do j=1,my/2
    call r4tor4 (ws(1,j),wl(1,j),mx)
    call r4tor4 (ws(mx/2+1,j),wl(1+nx-mx/2,j),mx)
  enddo
  do j=my/2+1,my
    call r4tor4 (ws(1,j),wl(1,j+ny-my),mx)
    call r4tor4 (ws(mx/2+1,j),wl(1+nx-mx/2,j+ny-my),mx)
  enddo
  dim(1) = nx
  dim(2) = ny
  call fourt (wl,dim,ndim,1,1,work)
  !
  fact = 1.0/(mx*my)
  large = real(wl)*fact
end subroutine expand

program fill_cube
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone program
  !	Resample a partially filled input cube to a different
  !	finer filled one...
  ! Subroutines
  !	(IMAGE),(SIC)
  !	REGRID
  !---------------------------------------------------------------------
  ! Local
  real(8), parameter :: pi=3.141592653589793d0
  !
  character(len=filename_length) :: namey,namex
  character(len=4) :: method
  integer(kind=index_length) :: i,j,ndp
  integer :: n,ier
  logical :: error,auto,extrapol,logran(7)
  real(8) :: conv(3,2)
  integer :: dim(2),nxy
  real, allocatable :: xd(:),yd(:),zd(:),ipw(:)
  integer, allocatable :: ia(:),ja(:), ipi(:)
  type(gildas) :: x,y
  !
  data logran/7*.false./
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_inte('PIXELS$',dim,2)
  call gildas_logi('MODE$',auto,1)
  if (.not.auto) then
    call gildas_dble('AXIS_1$',conv(:,1),3)
    call gildas_dble('AXIS_2$',conv(:,2),3)
  endif
  call gildas_char('METHOD$',method)
  call gildas_logi('EXTRAPOLATE$',extrapol,1)
  call gildas_close
  !
  n = len_trim(namey)
  call gildas_null(y)
  y%gil%form = fmt_r4
  call gdf_read_gildas(y, namey, '.gdf', error, rank=4, data=.false.)
  !
  ! Now define output
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  n = len_trim(namex)
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  if (dim(1).lt.1 .or. dim(2).lt.1) then
    write(6,*) 'F-FILL_CUBE,  Invalid dimensions'
    goto 100
  else
    x%gil%dim(1) = dim(1)
    x%gil%dim(2) = dim(2)
  endif
  if (auto) then
    write(6,*) 'W-FILL_CUBE,  Computing conversion formulae'
    x%gil%ref(1) = 0.5d0
    x%gil%val(1) = (0.5d0-y%gil%ref(1))*y%gil%inc(1) + y%gil%val(1)  ! Pixel 0.5 of input
    x%gil%inc(1) = y%gil%dim(1)*y%gil%inc(1)/x%gil%dim(1)  ! Total scale
    x%gil%ref(2) = 0.5d0
    x%gil%val(2) = (0.5d0-y%gil%ref(2))*y%gil%inc(2) + y%gil%val(2)  ! Pixel 0.5 of input
    x%gil%inc(2) = y%gil%dim(2)*y%gil%inc(2)/x%gil%dim(2)  ! Total scale
  else
    x%gil%convert(:,1:2) = conv
  endif
  !
  ! Create the image
  call gdf_create_image(x,error)
  !
  allocate(x%r2d(x%gil%dim(1),x%gil%dim(2)),y%r2d(y%gil%dim(1),y%gil%dim(2)),stat=ier)
  !
  ! Method of solution
  if (method.eq.'SLOW') then
    write(6,*) 'W-FILL_CUBE,  Using SLOW general method'
  else
    method = 'FAST'
    write(6,*) 'W-FILL_CUBE,  Using FAST method, input blanking ignored'
  endif
  !
  !
  if (method.eq.'FAST') then
    do j=1,x%gil%dim(4)
      x%blc(4) = j
      x%trc(4) = j
      do i=1,x%gil%dim(3)
        x%blc(3) = i
        x%trc(3) = i
        !
        y%blc = x%blc
        y%trc = x%trc
        call gdf_read_data(y,y%r2d,error)
        call fill_cube_fast (   &
     &          y%r2d,y%gil%dim(1),y%gil%dim(2),y%gil%convert,   &
     &          x%r2d,x%gil%dim(1),x%gil%dim(2),x%gil%convert,   &
     &          x%gil%bval)
        call gdf_write_data(x,x%r2d,error)
      enddo
    enddo
  else
    nxy = y%gil%dim(1)*y%gil%dim(2)
    allocate (xd(nxy),yd(nxy),zd(nxy),ia(nxy),ja(nxy),stat=ier)
    if (ier.ne.0) goto 99
    x%gil%eval = max(x%gil%eval,abs(x%gil%bval*1e-7))
    !
    y%blc(4) = max(1,y%gil%dim(4)/2)
    y%trc(4) = y%blc(4)
    y%blc(3) = max(1,y%gil%dim(3)/2)
    y%trc(3) = y%blc(3)
    call gdf_read_data(y,y%r2d,error)
    if (error) goto 100
    !
    call init_cube_slow (y%r2d,   &
     &      y%gil%dim(1),y%gil%dim(2),y%gil%convert,   &
     &      x%gil%dim(1),x%gil%dim(2),x%gil%convert,   &
     &      x%gil%bval,x%gil%eval,   &
     &      xd,yd,zd,ia,ja,          &
     &      ndp,error)
    if (error) goto 100
    logran(3) = .false.
    logran(7) = extrapol
    !
    allocate (ipw(13*ndp), ipi(35*ndp), stat=ier)
    if (ier.ne.0) goto 99
    !
    do j=1,y%gil%dim(4)
      x%blc(4) = j
      x%trc(4) = j
      do i=1,y%gil%dim(3)
        x%blc(3) = i
        x%trc(3) = i
        x%r2d = 0.0
        y%blc = x%blc
        y%trc = x%trc
        call gdf_read_data(y,y%r2d,error)
        if (error) goto 100
        call fill_cube_slow (   &
     &          y%r2d,y%gil%dim(1),y%gil%dim(2),   &
     &          x%r2d,x%gil%dim(1),x%gil%dim(2),   &
     &          x%gil%bval,   &
     &          xd,yd,zd,ia,ja,  &
     &          ipi, ipw, ndp,   &
     &          logran,error)
        if (error) goto 100
        call gdf_write_data(x,x%r2d,error)
      enddo
    enddo
  endif
  stop 'E-FILL_CUBE,  Successful completion'
  !
99 write(6,*) 'F-FILL_CUBE,  Memory allocation failure'
100 call sysexi(fatale)
end program fill_cube
!
subroutine init_cube_slow (a,mx,my,aconv,   &
     &    nx,ny,bconv,blank,eblank,   &
     &    xd,yd,zd,ia,ja,ndp,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone subroutine
  !	Regrid an input cube with blanking values to an output
  !	regular cube on a finer grid.
  ! Arguments
  !	A		R*4(*)	Input map of dimensions MX MY
  !	MX,MY		I
  !	ACONV		R*8(6)	Pixel conversion formulae
  !			CONV(1) = Xref, CONV(2)=Xval, CONV(3)=Xinc
  !	NX,NY		I	Output dimensions
  !	BCONV		R*8(6)
  !	BLANK		R*4	Blanking value
  !	EBLANK		R*4	Blanking tolerance
  !	XD,YD,ZD	R*4	Work arrays of dimension MX*MY
  !	IA,JA		I*4	Work arrays of dimensions MX*MY
  !	NDP		I*4	Number of selected points
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mx                     !
  integer(kind=index_length) :: my                     !
  real(4) :: a(mx,my)                !
  real(8) :: aconv(6)                !
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: ny                     !
  real(8) :: bconv(6)                !
  real(4) :: blank                   !
  real(4) :: eblank                  !
  real(4) :: xd(nx*ny)               !
  real(4) :: yd(nx*ny)               !
  real(4) :: zd(nx*ny)               !
  integer :: ia(mx*my)              !
  integer :: ja(mx*my)              !
  integer(kind=index_length) :: ndp                    !
  logical :: error                  !
  ! Local
  integer :: i,j,ncp
  real(8) :: axref,axval,axinc, ayref,ayval,ayinc
  real(8) :: bxref,bxval,bxinc, byref,byval,byinc
  !
  ! Preliminary processing
  ncp = 4
  axref = aconv(1)
  axval = aconv(2)
  axinc = aconv(3)
  ayref = aconv(4)
  ayval = aconv(5)
  ayinc = aconv(6)
  bxref = bconv(1)
  bxval = bconv(2)
  bxinc = bconv(3)
  byref = bconv(4)
  byval = bconv(5)
  byinc = bconv(6)
  !
  ! Load XD,YD,ZD arrays with current plane (or mask array)
  ndp = 0
  do j=1,my
    do i=1,mx
      if (abs(a(i,j)-blank).gt.eblank) then
        ndp = ndp +1
        xd(ndp) = (i-axref)*axinc + axval
        yd(ndp) = (j-ayref)*ayinc + ayval
        zd(ndp) = a(i,j)
        ia(ndp) = i
        ja(ndp) = j
      endif
    enddo
  enddo
  if (ndp.le.0) then
    write(6,*) 'F-SLOW,  No data point in input'
    error = .true.
    return
  endif
  !
  ! Initialize Gridding
  call gridini(nx,bxref,bxval,bxinc, ny,byref,byval,byinc)
end subroutine init_cube_slow
!
subroutine fill_cube_slow (a,mx,my,   &
     &    b,nx,ny,blank,   &
     &    xd,yd,zd,ia,ja,   &
     &    ipi,ipw,ndp,   &
     &    logran,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone subroutine
  !	Regrid an input cube with blanking values to an output
  !	regular cube on a finer grid.
  ! Arguments
  !	A		R*4(*)	Input map of dimensions MX MY
  !	MX,MY		I
  !	B		R*4(*)	Output map of dimensions NX,NY
  !	NX,NY		I
  !	BLANK		R*4	Blanking value
  !	XD,YD,ZD	R*4	Work arrays of dimension MX*MY
  !	IA,JA		I*4	Work arrays of dimensions MX*MY
  !	IPI		I*4	Work arrays
  !	IPW		I*4	Work arrays
  !	NDP		I*4	Number of good points
  !	LOGRAN		L(7)	Control interpolation behaviour
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mx                     !
  integer(kind=index_length) :: my                     !
  real(4) :: a(mx,my)                !
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: ny                     !
  real(4) :: b(nx,ny)                !
  real(4) :: blank                   !
  real(4) :: xd(nx*ny)               !
  real(4) :: yd(nx*ny)               !
  real(4) :: zd(nx*ny)               !
  integer :: ia(mx*my)              !
  integer :: ja(mx*my)              !
  integer :: ipi(*)                 !
  real(4) :: ipw(*)                 !
  integer(kind=index_length) :: ndp                    !
  logical :: logran(7)              !
  logical :: error                  !
  ! Local
  external :: dummy
  integer :: i,ncp
  !
  ncp = 4
  call gridset (ncp,blank,logran)
  !
  ! Process plane
  do i=1,ndp
    zd(i) = a(ia(i),ja(i))
  enddo
  call gridran (xd,yd,zd,ndp,ipw,ipi,b   &
     &    ,dummy,dummy,dummy,error)
  if (error) then
    write(6,*) 'F-FILL_CUBE_SLOW,  Failure in GRIDRAN ...'
    return
  endif
  logran(3) = .true.           ! Repeat for next one
end subroutine fill_cube_slow
!
subroutine dummy
end subroutine dummy
!
subroutine fill_cube_fast (a,mx,my,aconv,   &
     &    b,nx,ny,bconv,blank)
  use gildas_def
  !---------------------------------------------------------------------
  ! GILDAS 	Stand alone subroutine
  !	Regrid an input data cube on a finer one for the 2 first input
  !	dimensions.
  ! Arguments
  !	A		R*4(*)	Input map of dimensions MX MY
  !	MX,MY		I
  !	ACONV		R*8(6)	Pixel conversion formulae
  !			CONV(1) = Xref, CONV(2)=Xval, CONV(3)=Xinc
  !	B		R*4(*)	Output map of dimensions NX,NY
  !	NX,NY		I
  !	BCONV		R*8(6)
  !	BLANK	R*4	Blanking value
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mx                     !
  integer(kind=index_length) :: my                     !
  real(4) :: a(mx,my)                !
  real(8) :: aconv(6)                !
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: ny                     !
  real(4) :: b(nx,ny)                !
  real(8) :: bconv(6)                !
  real(4) :: blank                   !
  ! Local
  integer :: ib,jb,ia,ja
  real(8) :: axref,axval,axinc, ayref,ayval,ayinc
  real(8) :: bxref,bxval,bxinc, byref,byval,byinc
  real(8) :: xa,ya
  real(4) :: aplus,amoin,azero,xr,yr
  !
  ! Preliminary processing
  axref = aconv(1)
  axval = aconv(2)
  axinc = aconv(3)
  ayref = aconv(4)
  ayval = aconv(5)
  ayinc = aconv(6)
  bxref = bconv(1)
  bxval = bconv(2)
  bxinc = bconv(3)
  byref = bconv(4)
  byval = bconv(5)
  byinc = bconv(6)
  !
  ! Loop over Output data points
  do jb = 1,ny
    do ib = 1,nx
      !
      ! Find pixel coordinate in input map
      xa = (ib-bxref)*bxinc + bxval
      ya = (jb-byref)*byinc + byval
      xr = (xa-axval)/axinc + axref
      yr = (ya-ayval)/ayinc + ayref
      ia = nint (xr)
      ja = nint (yr)
      xr = xr - ia
      yr = yr - ja
      !
      ! Avoid edges
      if (ia.le.1 .or. ia.ge.mx .or. ja.le.1 .or. ja.ge.my) then
        b(ib,jb) = blank
      else
        !
        ! Interpolate (X or Y first, does not matter in this case)
        aplus = ( (a(ia+1,ja+1)+a(ia-1,ja+1)-2.*a(ia,ja+1))   &
     &          *xr + a(ia+1,ja+1)-a(ia-1,ja+1) )*xr*0.5   &
     &          + a(ia,ja+1)
        azero = ( (a(ia+1,ja)+a(ia-1,ja)-2.*a(ia,ja))   &
     &          *xr + a(ia+1,ja)-a(ia-1,ja) )*xr*0.5   &
     &          + a(ia,ja)
        amoin = ( (a(ia+1,ja-1)+a(ia-1,ja-1)-2.*a(ia,ja-1))   &
     &          *xr + a(ia+1,ja-1)-a(ia-1,ja-1) )*xr*0.5   &
     &          + a(ia,ja-1)
        ! Then Y (or X)
        b(ib,jb) = ( (aplus+amoin-2.*azero)   &
     &          *yr + aplus-amoin )*yr*0.5 + azero
      endif
    enddo
  enddo
end subroutine fill_cube_fast

module cubeadm_verify
  use cubetools_structure
  use cubetuple_format_class
  use cubeadm_cubeid_types
  use cubeadm_messaging
  !
  public :: verify
  private
  !
  type :: verify_comm_t
    type(option_t),      pointer :: comm
    type(cubeid_arg_t),  pointer :: cube
  contains
    procedure, public  :: register => cubeadm_verify_register
    procedure, private :: parse    => cubeadm_verify_parse
    procedure, private :: main     => cubeadm_verify_main
  end type verify_comm_t
  type(verify_comm_t) :: verify
  !
  type verify_user_t
    type(cubeid_user_t)   :: cubeids
  contains
    procedure, private :: toprog => cubeadm_verify_user_toprog
  end type verify_user_t
  !
  type verify_prog_t
    class(format_t), pointer :: cube
  contains
    procedure, private :: do => cubeadm_verify_do
  end type verify_prog_t
  !
  interface cubeadm_verify_and_get
    module procedure cubeadm_verify_and_get_i4
  end interface cubeadm_verify_and_get
  !
  interface cubeadm_verify_and_compare
    module procedure cubeadm_verify_and_compare_ch
  end interface cubeadm_verify_and_compare
  !
contains
  !
  subroutine cubeadm_verify_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command VERIFY
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(verify_user_t) :: user
    character(len=*), parameter :: rname='VERIFY>COMMAND'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call verify%parse(line,user,error)
    if (error) return
    call verify%main(user,error)
    if (error) return
  end subroutine cubeadm_verify_command
  !
  subroutine cubeadm_verify_register(verify,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! Register ADM\VERIFY command and its options
    !-------------------------------------------------------------------
    class(verify_comm_t), intent(in)    :: verify
    logical,              intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    character(len=*), parameter :: rname='VERIFY>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Command
    call cubetools_register_command(&
         'VERIFY','[cubeid]',&
         'Check whether a cube header is CUBE-conformant',&
         'Check whether the selected object satisfies current CUBE&
         & conformity checks. This commands is used in the DMS part&
         & of the Observatory Management System ( https://oms.iram.fr ).'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Verification path depends on detected object kind.'//strg_cr//&
         '- For cube-like objects, fatal prerequisites stop verification and'//strg_cr//&
         '  the command execution with an error. Other checks report missing'//strg_cr//&
         '  or non-conformant metadata.'//strg_cr//&
         '- For UV tables, detailed key-by-key conformity checks are&
         & currently not implemented.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- An empty output means that the cube header is conformant.'//strg_bl//&
         'Examples:'//strg_cr//&
         '  CUBE> VERIFY'//strg_cr//&
         '  CUBE> VERIFY mycube'//strg_cr//&
         'Without argument, VERIFY checks the current object.',&
         cubeadm_verify_command,&
         verify%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBE',&
         '[cubeid]',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read_head,&  ! Data not needed
         code_access_any,&
         verify%cube,&
         error)
    if (error) return
  end subroutine cubeadm_verify_register
  !
  subroutine cubeadm_verify_parse(verify,line,user,error)
    !-------------------------------------------------------------------
    ! Parsing facility for command
    !   VERIFY CubeID
    !-------------------------------------------------------------------
    class(verify_comm_t), intent(in)    :: verify
    character(len=*),     intent(in)    :: line
    type(verify_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='VERIFY>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,verify%comm,user%cubeids,error)
    if (error) return
  end subroutine cubeadm_verify_parse
  !
  subroutine cubeadm_verify_main(verify,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(verify_comm_t), intent(in)    :: verify
    type(verify_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(verify_prog_t) :: prog
    character(len=*), parameter :: rname='verify>MAIN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call user%toprog(verify,prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubeadm_verify_main
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeadm_verify_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(verify_user_t), intent(in)    :: user
    type(verify_comm_t),  intent(in)    :: comm
    type(verify_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='VERIFY>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_get_fheader(verify%cube,user%cubeids,prog%cube,error)
    if (error) return
  end subroutine cubeadm_verify_user_toprog
  !
  subroutine cubeadm_verify_do(prog,error)
    use gkernel_types
    use cubeformats_uv
    use cube_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(verify_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='VERIFY>CHECK'
    !
    class(format_t), pointer :: format
    !
    format => prog%cube
    select type (format)
    type is (cube_t)
      call cubeadm_verify_check_cube(format,error)
      if (error) return
    type is (uv_t)
      call cubeadm_verify_check_uvt(format,error)
      if (error) return
    class default
      call cubeadm_message(seve%e,rname,'Unexpected file kind')
      error = .true.
      return
    end select
  end subroutine cubeadm_verify_do
  !
  subroutine cubeadm_verify_check_cube(cube,error)
    use gkernel_types
    use cubeio_dataformat_types
    use cube_types
    !-------------------------------------------------------------------
    ! Verify if a cube_t is CUBE conformant
    !-------------------------------------------------------------------
    type(cube_t), intent(in)    :: cube
    logical,      intent(inout) :: error
    !
    type(gfits_hdict_t), pointer :: hdict
    integer(kind=4) :: naxis
    character(len=*), parameter :: rname='VERIFY>CHECK>CUBE'
    !
    if (.not.cube%tuple%haskind(code_dataformat_fits)) then
      call cubeadm_message(seve%e,rname,'Cube is not a FITS file')
      error = .true.
      return
    endif
    !
    hdict => cube%tuple%current%file%hfits%dict
    !
    ! Convert information
    call cubeadm_verify_and_get(hdict,'NAXIS',naxis,error)
    if (error)  return
    if (naxis.ge.1) then
      call cubeadm_verify_one(hdict,'CTYPE1',error)
      call cubeadm_verify_one(hdict,'CRVAL1',error)
      call cubeadm_verify_one(hdict,'CDELT1',error)
      call cubeadm_verify_one(hdict,'CRPIX1',error)
    endif
    if (naxis.ge.2) then
      call cubeadm_verify_one(hdict,'CTYPE2',error)
      call cubeadm_verify_one(hdict,'CRVAL2',error)
      call cubeadm_verify_one(hdict,'CDELT2',error)
      call cubeadm_verify_one(hdict,'CRPIX2',error)
    endif
    if (naxis.ge.3) then
      call cubeadm_verify_one(hdict,'CTYPE3',error)
      call cubeadm_verify_one(hdict,'CRVAL3',error)
      call cubeadm_verify_one(hdict,'CDELT3',error)
      call cubeadm_verify_one(hdict,'CRPIX3',error)
    endif
    if (error)  return
    !
    ! Data information
    call cubeadm_verify_one(hdict,'DATAMIN', error)
    call cubeadm_verify_one(hdict,'DATAMAX', error)
    call cubeadm_verify_one(hdict,'BUNIT',   error)
   !call cubeadm_verify_one(hdict,'NOISETHE',error)  Might be absent if no value available
   !call cubeadm_verify_one(hdict,'NOISEMEA',error)  Might be absent if no value available
    if (error)  return
    !
    ! Spatial information
    call cubeadm_verify_one(hdict,'OBJECT', error)
    call cubeadm_verify_one(hdict,'RA',     error)
    call cubeadm_verify_one(hdict,'DEC',    error)
   !call cubeadm_verify_one(hdict,'RADESYS',error)  Not mandatory, because equinox could be arbitrary
    if (error)  return
    !
    ! Spectral information
    call cubeadm_verify_one(hdict,'LINE',    error)
    call cubeadm_verify_one(hdict,'RESTFREQ',error)
    call cubeadm_verify_one(hdict,'VELREF',  error)
   !call cubeadm_verify_one(hdict,'SPECSYS', error)  Redundant with VELREF but less information
   !call cubeadm_verify_one(hdict,'VELO-XXX',error)  Suffix depends on spectral frame (VELREF)
    call cubeadm_verify_one(hdict,'FREQRESO',error)  ! or WAVERESO depends on spectral kind
    if (error)  return
    !
    ! Resolution information
    call cubeadm_verify_one(hdict,'BMAJ',error)
    call cubeadm_verify_one(hdict,'BMIN',error)
    call cubeadm_verify_one(hdict,'BPA', error)
    if (error)  return
    !
    ! Misc
    call cubeadm_verify_one(hdict,'TELESCOP',error)
    if (error)  return
    !
    ! Origin
    call cubeadm_verify_and_compare(hdict,'ORIGIN','GILDAS CUBE',error)
    if (error)  return
  end subroutine cubeadm_verify_check_cube
  !
  subroutine cubeadm_verify_and_get_i4(hdict,key,value,error)
    use gkernel_types
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Verify if a key is present and get its value (error if absent)
    !-------------------------------------------------------------------
    type(gfits_hdict_t), intent(in)    :: hdict
    character(len=*),    intent(in)    :: key
    integer(kind=4),     intent(out)   :: value
    logical,             intent(inout) :: error
    !
    logical :: found
    character(len=*), parameter :: rname='VERIFY>AND>GET'
    !
    call gfits_get_value(hdict,key,found,value,error)
    if (error)  return
    if (.not.found) then
      call cubeadm_message(seve%e,rname,'Missing key '''//trim(key)//''', can not verify more')
      error = .true.
      return
    endif
  end subroutine cubeadm_verify_and_get_i4
  !
  subroutine cubeadm_verify_and_compare_ch(hdict,key,expected,error)
    use gkernel_types
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Verify if a key is present and if its value is as expected
    !-------------------------------------------------------------------
    type(gfits_hdict_t), intent(in)    :: hdict
    character(len=*),    intent(in)    :: key
    character(len=*),    intent(in)    :: expected
    logical,             intent(inout) :: error
    !
    logical :: found
    character(len=char0d_length) :: value
    character(len=*), parameter :: rname='VERIFY>AND>COMPARE'
    !
    call gfits_get_value(hdict,key,found,value,error)
    if (error)  return
    if (.not.found) then
      call cubeadm_message(seve%w,rname,'Missing key '''//trim(key)//'''')
      return
    endif
    if (value.ne.expected) then
      call cubeadm_message(seve%w,rname,'Key '''//trim(key)//''' is '''//  &
        trim(value)//''' (expected '''//trim(expected)//''')')
      return
    endif
  end subroutine cubeadm_verify_and_compare_ch
  !
  subroutine cubeadm_verify_one(hdict,key,error)
    use gkernel_types
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Verify if a key is present
    !-------------------------------------------------------------------
    type(gfits_hdict_t), intent(in)    :: hdict
    character(len=*),    intent(in)    :: key
    logical,             intent(inout) :: error
    !
    logical :: found
    character(len=char0d_length) :: value
    character(len=*), parameter :: rname='VERIFY>ONE'
    !
    call gfits_get_value(hdict,key,found,value,error)
    if (error)  return
    if (.not.found)  &
      call cubeadm_message(seve%w,rname,'Missing key '''//trim(key)//'''')
  end subroutine cubeadm_verify_one
  !
  subroutine cubeadm_verify_check_uvt(uv,error)
    use cubeformats_uv
    !-------------------------------------------------------------------
    ! Verify if a uv_t is CUBE conformat
    !-------------------------------------------------------------------
    type(uv_t), intent(in)    :: uv
    logical,    intent(inout) :: error
    !
    character(len=*), parameter :: rname='VERIFY>CHECK>UV'
    !
    ! For now on we don't check anything as we only support GDF
    ! UV tables
  end subroutine cubeadm_verify_check_uvt
  !
end module cubeadm_verify

subroutine store_flux(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  !	Stores internal fluxes and efficiencies
  !	into observations from current index
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: end
  integer :: i, if
  character(len=80) :: chain
  integer :: dtol
  real :: frtol
  parameter (frtol=1e3, dtol=7)    ! 1 GHz ... 1 week ...
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  call check_output_file(error)
  if (error) return
  call check_equal_file(error)
  if (error) return
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  !
  ! Check the flux list
  call sort_fluxes(error)
  if (error) return
  do i = 1, n_flux
    if (abs(flux(i)).gt.1e6 .or. abs(flux(i)).lt.1e-6) then
      write (chain,'(a,1pg12.5)')   &
        'Unlikely flux for '//c_flux(i)//' : ',flux(i)
      call message (8,3,'STORE_FLUX',chain(1:lenc(chain)))
      error = .true.
      return
    endif
  enddo
  !
  ! Loop on current index
  call get_first(.false.,error)
  if (error) return
  end = .false.
  do while (.not.end)
    !
    ! Store Fluxes
    ! Fluxes with undetermined date or frequency come first in the list.
    ! so they are overridden by values with precise frequency or date.
    if = 0
    !
    !Give priority to FIXED fluxes.
    ! exact frequency or date ? (FRTOL and DTOL should be tunable parameters)
    do i = 1, n_flux
      if (f_flux(i) .and. r_sourc.eq.c_flux(i) .and.   &
        ((freq_flux(i).le.0)  .or.   &
        abs(r_restf-freq_flux(i)).lt.frtol) .and.   &
        ((date_flux(i).lt.-100000)   &
        .or. (abs(date_flux(i)-r_dobs).le.dtol))) then
        if = i
      endif
    enddo
    ! or any frequency,
    if (if.eq.0) then
      do i = 1, n_flux
        if (f_flux(i) .and. c_flux(i).eq.r_sourc) then
          if = i
        endif
      enddo
    endif
    ! now free fluxes
    ! exact frequency or date ? (FRTOL and DTOL should be tunable parameters)
    if (if.eq.0) then
      do i = 1, n_flux
        if (r_sourc.eq.c_flux(i) .and.   &
          ((freq_flux(i).le.0)  .or.   &
          abs(r_restf-freq_flux(i)).lt.frtol) .and.   &
          ((date_flux(i).lt.-100000)   &
          .or. (abs(date_flux(i)-r_dobs).le.dtol))) then
          if = i
        endif
      enddo
    endif
    ! or any frequency,
    if (if.eq.0) then
      do i = 1, n_flux
        if (c_flux(i).eq.r_sourc) then
          if = i
        endif
      enddo
    endif
    if (if.ne.0) then
      if (f_flux(if)) then
        r_flux = abs(flux(if))
      else
        r_flux = -abs(flux(if))
      endif
    endif
    ! Store efficiencies
    !         DO J=1, R_NANT
    !            R_JYKEL(J) = JY_TO_KEL(J)
    !         ENDDO
    !
    ! Update scan
    call write_scan (.false.,error)    ! data not changed
    if (error) return
    !
    ! Next observation
    if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) return
  enddo
  return
  !
999 error = .true.
  return
end subroutine store_flux
!
subroutine store_spidx(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  !	Stores internal spidx
  !	into observations from current index
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: end
  integer :: i, if
  character(len=80) :: chain
  integer :: dtol
  real :: frtol
  parameter (frtol=1e3, dtol=7)    ! 1 GHz ... 1 week ...
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  call check_output_file(error)
  if (error) return
  call check_equal_file(error)
  if (error) return
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  !
  ! Check the spidx list
  call sort_spidx(error)
  if (error) return
  do i = 1, n_spidx
    if (abs(spidx(i)).gt.100) then
      write (chain,'(a,1pg12.5)')   &
        'Unlikely spidx for '//c_spidx(i)//' : ',spidx(i)
      call message (8,3,'STORE_SPIDX',chain(1:lenc(chain)))
      error = .true.
      return
    endif
  enddo
  !
  ! Loop on current index
  call get_first(.false.,error)
  if (error) return
  end = .false.
  do while (.not.end)
    !
    ! Store Spidx
    ! Spidx with undetermined date or frequency come first in the list.
    ! so they are overridden by values with precise frequency or date.
    if = 0
    !
    !Give priority to FIXED spidxes.
    ! exact frequency or date ? (FRTOL and DTOL should be tunable parameters)
    do i = 1, n_spidx
      if (f_spidx(i) .and. r_sourc.eq.c_spidx(i) .and.   &
        ((freq_spidx(i).le.0)  .or.   &
        abs(r_restf-freq_spidx(i)).lt.frtol) .and.   &
        ((date_spidx(i).lt.-100000)   &
        .or. (abs(date_spidx(i)-r_dobs).le.dtol))) then
        if = i
      endif
    enddo
    ! or any frequency,
    if (if.eq.0) then
      do i = 1, n_spidx
        if (f_spidx(i) .and. c_spidx(i).eq.r_sourc) then
          if = i
        endif
      enddo
    endif
    ! now free spidxes
    ! exact frequency or date ? (FRTOL and DTOL should be tunable parameters)
    if (if.eq.0) then
      do i = 1, n_spidx
        if (r_sourc.eq.c_spidx(i) .and.   &
          ((freq_spidx(i).le.0)  .or.   &
          abs(r_restf-freq_spidx(i)).lt.frtol) .and.   &
          ((date_spidx(i).lt.-100000)   &
          .or. (abs(date_spidx(i)-r_dobs).le.dtol))) then
          if = i
        endif
      enddo
    endif
    ! or any frequency,
    if (if.eq.0) then
      do i = 1, n_spidx
        if (c_spidx(i).eq.r_sourc) then
          if = i
        endif
      enddo
    endif
    if (if.ne.0) then
      r_spidx = spidx(if)
    endif
    ! Store efficiencies
    !         DO J=1, R_NANT
    !            R_JYKEL(J) = JY_TO_KEL(J)
    !         ENDDO
    !
    ! Update scan
    call write_scan (.false.,error)    ! data not changed
    if (error) return
    !
    ! Next observation
    if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) return
  enddo
  return
  !
999 error = .true.
  return
end subroutine store_spidx
!
subroutine store_stokes(line,error)
  use gildas_def
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  !	Stores Stokes parameters
  !	into observations from current index
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: iarg,narg
  real :: arg(4)
  logical :: end
  ! Code:
  error = .false.
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  call check_output_file(error)
  if (error) return
  call check_equal_file(error)
  if (error) return
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  !
  !
  narg = sic_narg(0)
  if (narg.lt.4) then
    call message(8,3,'STORE_STOKES','At least 3 Stokes parameter required')
    error = .true.
    return
  endif
  if (narg.gt.5) return
  !
  do iarg=1, narg
    call sic_r4(line,0,iarg+1,arg(iarg),.false.,error)
    if (error) then 
      call message(8,3,'STORE_STOKES','Error reading input parameters')
      error = .true.
      return
    endif
  enddo
  r_stokes_i = arg(1)
  r_stokes_q = arg(2)
  r_stokes_u = arg(3)
  if (narg.eq.4) r_stokes_v = arg(4)
print *,"arg",arg
  !
  !
  ! Loop on current index
  call get_first(.false.,error)
  if (error) return
  end = .false.
  do while (.not.end)
    r_stokes_i = arg(1)
    r_stokes_q = arg(2)
    r_stokes_u = arg(3)
    if (narg.eq.5) r_stokes_v = arg(4)
    ! Update scan
    call write_scan (.false.,error)    ! data not changed
    if (error) return
    !
    ! Next observation
    if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) return
  enddo

  return
999 error = .true.
  return
end subroutine store_stokes
!
subroutine store_dterm(line,error)
  use gildas_def
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  !	Stores "D terms" (polarisation)
  !	into observations from current index
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: iopt, i, j, k, ibb
  real :: dum(4,mnant)
  logical :: end,dterm(mnant)
  ! Code:
  dterm = .false.
  error = .false.
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  call check_output_file(error)
  if (error) return
  call check_equal_file(error)
  if (error) return
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  !
  !
  iopt = 0
  !
  ! /BBAND option
  if (sic_present(13,0)) then
    call sic_i4(line,13,1,ibb,.true.,error)
  else
    call message(8,3,'STORE_DTERM','/BBAND option is mandatory')
    error = .true.
    return
  endif
  !
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    if (j.gt.0.and.j.le.mnant) then
      dterm(j) = .true.
    else
      call message(8,3,'STORE_DTERM','Wrong antenna number')
      error = .true.
      return
    endif
    do k=1, 4
      call sic_r4(line,iopt,i+k,dum(k,j),.true.,error)
      if (error) return
    enddo
    i = i+5
  enddo
  !
  ! Loop on current index
  call get_first(.false.,error)
  if (error) return
  if (ibb.lt.1.or.ibb.gt.r_nbb) then
    call message(8,3,'STORE_DTERM','Wrong baseband number')
    error = .true.
    return
  endif
  end = .false.
  do while (.not.end)
    do i=1, mnant
      if (dterm(i)) then
        r_dx(i,ibb) = cmplx(dum(1,i),dum(2,i))
        r_dy(i,ibb) = cmplx(dum(3,i),dum(4,i))
      endif
    enddo
    ! Update scan
    call write_scan (.false.,error)    ! data not changed
    if (error) return
    !
    ! Next observation
    if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) return
  enddo

  return
999 error = .true.
  return
end subroutine store_dterm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the POINT package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine point_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! Public package definition routine.
  ! It defines package methods and dependencies to other packages.
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack ! Package info structure
  !
  external :: point_pack_init
  external :: point_pack_clean
  !
  pack%name='point'
  pack%ext='.point'
  pack%depend(1:1) = (/ locwrd(greg_pack_set) /)
  pack%init=locwrd(point_pack_init)
  pack%clean=locwrd(point_pack_clean)
  !
end subroutine point_pack_set
!
subroutine point_pack_init(gpack_id,error)
  use sic_def
  !----------------------------------------------------------------------
  ! Private routine to set the POINT environment.
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Set libraries id's
  !call point_message_set_id(gpack_id)
  !
  ! Local language
  call load_point
  call sic_setsymbol('set','point'//backslash//'set',error)
  call sic_setsymbol('sh*ow','point'//backslash//'show',error)
  !
end subroutine point_pack_init
!
subroutine point_pack_clean(error)
  !----------------------------------------------------------------------
  ! Private routine to clean the POINT environment
  ! (e.g. Remove temporary buffers, unregister languages...)
  !----------------------------------------------------------------------
  logical :: error
  !
end subroutine point_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_tracked_psw(mrtset,backcal,backsci,filebuf,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_tracked_psw
  !---------------------------------------------------------------------
  ! @ private
  ! Gather all needed steps to read, calibrate, and write a 
  ! tracked position switched scan for a given backend
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>TRACKED>PSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_iterate_subscancycle(mrtset,filebuf%imbf, &
    filebuf%subscanbuf,backcal,backsci,error)
  if (error) return
  !
end subroutine mrtcal_calib_tracked_psw
!
subroutine mrtcal_calib_tracked_psw_cycle(mrtset,imbf,ifirst,nswitch,  &
  subscanbuf,backcal,backsci,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_tracked_psw_cycle
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  ! Calibrate a TRACKED PSW cycle of subscans
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)            :: mrtset      !
  type(imbfits_t),         intent(in)            :: imbf        !
  integer(kind=4),         intent(in)            :: ifirst      ! First subscan in cycle
  integer(kind=4),         intent(in)            :: nswitch     ! Number of subscans in cycle
  type(subscan_buffer_t),  intent(inout)         :: subscanbuf  !
  type(calib_backend_t),   intent(in)            :: backcal     !
  type(science_backend_t), intent(inout), target :: backsci     !
  logical,                 intent(inout)         :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CALIB>TRACKED>PSW>CYCLE'
  integer(kind=4) :: isub
  logical, parameter :: iscal=.false.
  type(chunkset_2d_t) :: curr  ! Buffer for reading a ON or OFF subscan
  type(chunkset_2d_t), pointer :: cumul  ! Pointer to current ON or OFF cumulation
  logical :: initon,initoff
  character(len=23) :: iso
  character(len=message_length) :: mess
  !
  initon = .true.
  initoff = .true.
  do isub=ifirst,ifirst+nswitch-1
    call mrtcal_average_times(mrtset,iscal,isub,'track',imbf,subscanbuf,curr,error)
    if (error)  goto 10
    !
    if (backsci%list%onoff%bak(isub).eq.backsci%list%on) then
      if (initon) then
        ! Use first ON subscan to initialize the ON structure (in particular
        ! regarding offsets)
        call mrtcal_chunkset_2d_accumulate_init(curr,backsci%on%curr,error)
        if (error)  goto 10
        initon = .false.
      endif
      cumul => backsci%on%curr
    else
      if (initoff) then
        ! Use first OFF subscan to initialize the OFF structure (in particular
        ! regarding offsets)
        backsci%off%curr => backsci%off%computed  ! Use the 'computed' buffer
        call mrtcal_chunkset_2d_accumulate_init(curr,backsci%off%curr,error)
        if (error)  goto 10
        initoff = .false.
      endif
      cumul => backsci%off%curr
    endif
    !
    call mrtcal_chunkset_2d_accumulate_setweight(curr,backsci%tscale,  &
      mrtset%out%weight,error)
    if (error)  goto 10
    call mrtcal_chunkset_2d_accumulate_do(curr,cumul,error)
    if (error)  goto 10
  enddo
  !
  call mrtcal_on_minus_off(nototfmap,notfsw,backsci,error)
  if (error)  goto 10
  call mrtcal_tscale_computation(backcal,backsci,error)
  if (error)  goto 10
  call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
  if (error)  goto 10
  !
  call gag_mjd2isodate(backsci%off%curr%chunkset(1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average OFF    date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  call gag_mjd2isodate(backsci%on%curr%chunkset(1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average ON     date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  call gag_mjd2isodate(backsci%diff%chunkset(1,1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average ON-OFF date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  !
  if (mrtset%out%accmode.eq.accmode_cycl) then
    call mrtcal_write_toclass(backsci%diff,mrtset%out,backsci%nobs,error)
    if (error)  goto 10
  endif
  !
10 continue
  call curr%free(error)
  if (error)  return
  !
end subroutine mrtcal_calib_tracked_psw_cycle
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! (re)allocation routines
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reallocate_calib_scan(n,calarray,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>reallocate_calib_scan
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate calibration arrays
  !-------------------------------------------------------------------
  integer(kind=4),    intent(in)    :: n
  type(calib_scan_t), intent(inout) :: calarray
  logical,            intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier,iarray
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>CALIB>SCAN'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
     write(mess,'(a,i0,a)') 'Array size can not negative (got ',n,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  else if (n.eq.0) then
     write(mess,'(a)') 'Array size is zero'
     call mrtcal_message(seve%d,rname,mess)
     call calarray%free(error)
     if (error)  return
  else
     alloc = .true.
     if (allocated(calarray%val)) then
        if (calarray%n.eq.n) then
           write(mess,'(a,i0)')  &
             'Calibration arrays already associated at the right size: ',n
           call mrtcal_message(seve%d,rname,mess)
           alloc = .false.
        else
           write(mess,'(a)') 'Calibration pointers already associated but with a different size => Freeing it first'
           call mrtcal_message(seve%d,rname,mess)
           call calarray%free(error)
           if (error)  return
        endif
     endif
     !
     if (alloc) then
        allocate(calarray%val(n),stat=ier)
        if (failed_allocate(rname,'calibration arrays',ier,error)) then
           call calarray%free(error)
           return
        endif
        ! Also initialize its contents
        do iarray=1,n
          call calarray%val(iarray)%init(error)
          if (error)  return
        enddo
        write(mess,'(a,i0)') 'Allocated calibration arrays of size: ',n
        call mrtcal_message(seve%d,rname,mess)
     endif
  endif
  !
  ! Allocation success => Initialize
  calarray%n = n
  !
end subroutine reallocate_calib_scan
!
subroutine reallocate_science_scan(n,sciarray,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>reallocate_science_scan
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate science arrays
  !-------------------------------------------------------------------
  integer(kind=4),              intent(in)    :: n
  type(science_scan_t), target, intent(inout) :: sciarray
  logical,                      intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier,iarray
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SCIENCE>SCAN'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
     write(mess,'(a,i0,a)') 'Array size can not negative (got ',n,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  else if (n.eq.0) then
     write(mess,'(a)') 'Array size is zero'
     call mrtcal_message(seve%d,rname,mess)
     call sciarray%free(error)
     if (error)  return
  else
     alloc = .true.
     if (associated(sciarray%val)) then
        if (sciarray%n.eq.n) then
           write(mess,'(a,i0)')  &
             'Science arrays already associated at the right size: ',n
           call mrtcal_message(seve%d,rname,mess)
           alloc = .false.
        else
           write(mess,'(a)') 'Science pointers already associated but with a different size => Freeing it first'
           call mrtcal_message(seve%d,rname,mess)
           call sciarray%free(error)
           if (error)  return
        endif
     endif
     !
     if (alloc) then
        allocate(sciarray%val(n),stat=ier)
        if (failed_allocate(rname,'science arrays',ier,error)) then
           call sciarray%free(error)
           return
        endif
        ! Important initialization here!...
        do iarray=1,n
           call mrtindex_entry_zheader(sciarray%val(iarray)%head,error)
           if (error)  return
           sciarray%val(iarray)%off%prev => sciarray%val(iarray)%off%stack(1)
           sciarray%val(iarray)%off%next => sciarray%val(iarray)%off%stack(2)
        enddo ! iarray
        write(mess,'(a,i0)') 'Allocated science arrays of size: ',n
        call mrtcal_message(seve%d,rname,mess)
     endif
  endif
  !
  ! Allocation success => Initialize
  sciarray%n = n
  !
end subroutine reallocate_science_scan
!
subroutine reallocate_backend_list(n,backarray,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_backend_list
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate backend list arrays
  !-------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: n
  type(backend_list_t), intent(inout) :: backarray
  logical,              intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>BACKEND>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
    write(mess,'(a,i0,a)') 'Array size can not be negative (got ',n,')'
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  else if (n.eq.0) then
     write(mess,'(a)') 'Array size is zero'
     call mrtcal_message(seve%d,rname,mess)
     call free_backend_list(backarray,error)
     if (error) return
  else
     alloc = .true.
     if (associated(backarray%backcode)) then
        if (backarray%n.eq.n) then
           write(mess,'(a,i0)')  &
             'Backend list arrays already associated at the right size: ',n
           call mrtcal_message(seve%d,rname,mess)
           alloc = .false.
        else
           write(mess,'(a)') 'Backend list pointers already associated but with a different size => Freeing it first'
           call mrtcal_message(seve%d,rname,mess)
           call free_backend_list(backarray,error)
           if (error)  return
        endif
     endif
     !
     if (alloc) then
        allocate(backarray%backcode(n),backarray%file(n),stat=ier)
        if (failed_allocate(rname,'calibration arrays',ier,error)) then
           call free_backend_list(backarray,error)
           return
        endif
        write(mess,'(a,i0)') 'Allocated backend list arrays of size: ',n
        call mrtcal_message(seve%d,rname,mess)
     endif
  endif
  !
  ! Allocation success => Initialize
  backarray%n = n
  !
end subroutine reallocate_backend_list
!
subroutine reallocate_subscan_list(n,list,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_subscan_list
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate subscan list arrays
  !-------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: n
  type(subscan_list_t), intent(inout) :: list
  logical,              intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SUBSCAN>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.le.0) then
     write(mess,'(a,i0,a)') 'Array size can not be zero nor negative (got ',n,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  alloc = .true.
  if (associated(list%mjd)) then
     if (list%nsub.eq.n) then
        write(mess,'(a,i0)')  &
             'SUBSCAN LIST arrays already associated at the right size: ',n
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'SUBSCAN LIST pointers already associated but with a different size => Freeing it first'
        call mrtcal_message(seve%d,rname,mess)
        call list%free(error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(list%isub(n),list%mjd(n),list%time(n),list%empty(n),stat=ier)
     if (failed_allocate(rname,'SUBSCAN LIST arrays',ier,error)) then
        call list%free(error)
        return
     endif
     call reallocate_eclass_char(list%scanning,n,error)
     if (error)  return
     call reallocate_eclass_2dble1char(list%onoff,n,error)
     if (error)  return
     write(mess,'(a,i0)') 'Allocated SUBSCAN LIST arrays of size: ',n
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  list%nsub = n
  list%tracked = 0
  list%otf = 0
  list%on  = 0
  list%off = 0
  list%scanning%cnt(:) = 1 ! *** JP This default should be factorized in the reallocate_eclass routines
  list%onoff%cnt(:) = 1 ! *** JP This default should be factorized in the reallocate_eclass routines
  !
end subroutine reallocate_subscan_list
!
subroutine reallocate_switch_desc(noffset,nfront,desc,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_switch_desc
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate switch desc arrays
  !-------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: noffset
  integer(kind=4),     intent(in)    :: nfront
  type(switch_desc_t), intent(inout) :: desc
  logical,             intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SWITCH>DESC'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if ((noffset.le.0).or.(nfront.le.0)) then
     write(mess,'(a,i0,a,i0,a)') 'Array size can not be zero nor negative (got ',noffset,'x',nfront,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  alloc = .true.
  if (associated(desc%off)) then
     if ((desc%noffset.eq.noffset).and.(desc%nfront.eq.nfront)) then
        write(mess,'(a,i0,a,i0)')  &
             'switch desc arrays already associated at the right size: ',noffset,'x',nfront
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'switch desc pointers already associated but with a different size => Freeing it first'
        call mrtcal_message(seve%d,rname,mess)
        call desc%free(error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(desc%off(noffset,nfront),desc%wei(nfront),stat=ier)
     if (failed_allocate(rname,'switch desc arrays',ier,error)) then
        call desc%free(error)
        return
     endif
     write(mess,'(a,i0,a,i0)') 'Allocated switch desc arrays of size: ',noffset,'x',nfront
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  desc%nfront = nfront
  desc%noffset = noffset
  !
end subroutine reallocate_switch_desc
!
subroutine reallocate_switch_on_or_off_index(n,idx,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_switch_on_or_off_index
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate switch on or off index arrays
  !-------------------------------------------------------------------
  integer(kind=4),                intent(in)    :: n
  type(switch_on_or_off_index_t), intent(inout) :: idx
  logical,                        intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SWITCH>ON>OR>OFF>INDEX'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.le.0) then
     write(mess,'(a,i0,a)') 'Array size can not be zero nor negative (got ',n,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  if (idx%n.eq.n) then
     write(mess,'(a,i0)')  &
          'switch on or off index arrays already associated at the right size: ',n
     call mrtcal_message(seve%d,rname,mess)
     alloc = .false.
  else
     write(mess,'(a)') 'switch on or off index arrays already allocated but with a different size => Freeing it first'
     call mrtcal_message(seve%d,rname,mess)
     call idx%free(error)
     if (error)  return
     alloc = .true.
  endif
  !
  if (alloc) then
     allocate(idx%i(n),stat=ier)
     if (failed_allocate(rname,'switch on or off index arrays',ier,error)) then
        return
     endif
     write(mess,'(a,i0)') 'Allocated switch on or off index arrays of size: ',n
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  idx%n = n
  !
end subroutine reallocate_switch_on_or_off_index
!
subroutine reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_switch_cycle
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate cycle arrays
  !-------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: ndump
  integer(kind=4),      intent(in)    :: npha
  integer(kind=4),      intent(in)    :: non
  integer(kind=4),      intent(in)    :: noff
  integer(kind=4),      intent(in)    :: nfront
  type(switch_cycle_t), intent(inout) :: cycle
  logical,              intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier,ipha
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SWITCH>CYCLE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (npha.le.0) then
     write(mess,'(a,i0,a)') 'Array size can not be zero nor negative (got ',npha,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  if (npha.lt.ndump) then
     write(mess,'(a,i0,a,i0,a)')  &
       'Number of dumps (',ndump,') in cycle can not be lower than number of phases (',npha,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  if (npha.ne.non+noff) then
     write(mess,'(a,i0,a,i0,a,i0,a)')  &
       'Number of ON (',non,') + OFF (',noff,') in cycle must be equal to the number of phases (',npha,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  alloc = .true.
  if (associated(cycle%data)) then
     if (cycle%npha.eq.npha) then
        write(mess,'(a,i0)')  &
             'CYCLE arrays already associated at the right size: ',npha
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'CYCLE pointers already associated but with a different size => Freeing it first'
        call mrtcal_message(seve%d,rname,mess)
        call cycle%free(error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(cycle%data(npha),cycle%desc(npha),stat=ier)
     if (failed_allocate(rname,'CYCLE arrays',ier,error)) then
        call cycle%free(error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated CYCLE arrays of size: ',npha
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  do ipha=1,npha
     call reallocate_switch_desc(npha,nfront,cycle%desc(ipha),error)
     if (error) return
  enddo ! ipha
  call reallocate_switch_on_or_off_index(non,cycle%on,error)
  if (error) return
  call reallocate_switch_on_or_off_index(noff,cycle%off,error)
  if (error) return
  !
  ! Allocation success => Initialize
  cycle%ndump = ndump
  cycle%npha  = npha
  !
end subroutine reallocate_switch_cycle
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Deallocation routines
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine free_backend_list(backarray,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => free_backend_list
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(backend_list_t), intent(inout) :: backarray
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>BACKEND>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  backarray%n = 0
  if (associated(backarray%backcode)) deallocate(backarray%backcode)
  if (associated(backarray%file))     deallocate(backarray%file)
  ! Nullification is implicit with deallocate
  !
end subroutine free_backend_list
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reallocate_dble_1d(r8,newndata,keep,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Reallocate a simple 1D REAL*8 pointer
  !---------------------------------------------------------------------
  real(kind=8),    pointer       :: r8(:)     !
  integer(kind=4), intent(in)    :: newndata  !
  logical,         intent(in)    :: keep      !
  logical,         intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>DBLE>1D'
  integer(kind=4) :: oldndata,ier
  real(kind=8), pointer :: tmp(:)
  !
  tmp => null()
  if (associated(r8)) then
    oldndata = size(r8)
    if (oldndata.ge.newndata) then
      ! Enough space, nothing to be done
      return
    endif
    if (keep) then
      allocate(tmp(oldndata),stat=ier)
      if (failed_allocate(rname,'tmp array',ier,error)) then
        error = .true.
        return
      endif
      tmp(:) = r8(:)
    endif
    deallocate(r8,stat=ier)
    if (failed_allocate(rname,'r8 array',ier,error)) then
      error = .true.
      return
    endif
  endif
  !
  allocate(r8(newndata),stat=ier)
  if (failed_allocate(rname,'r8 array',ier,error)) then
    error = .true.
    return
  endif
  if (keep .and. associated(tmp)) then
    r8(1:oldndata) = tmp(1:oldndata)
    deallocate(tmp)
  endif
  !
end subroutine reallocate_dble_1d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine mrtcal_copy_command(line,error)
  use gildas_def
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_copy_command
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Support routine for command
  !   MCOPY [IN|CURRENT] /FILE FileName
  !  Copy the named index from memory to disk
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='MCOPY'
  character(len=filename_length) :: file
  integer(kind=4) :: nc
  type(mrtindex_optimize_t), pointer :: optx
  character(len=12) :: optname
  integer(kind=4), parameter :: optcomm=0
  integer(kind=4), parameter :: optfile=1
  !
  call mrtcal_index_parse(rname,line,optcomm,1,optx,optname,error)
  if (error)  return
  call sic_ch(line,optfile,1,file,nc,.true.,error)
  if (error)  return
  !
  call mrtindex_copy_index(file,optx,error)
  if (error) then
    call mrtcal_message(seve%e,rname,  &
      'Error copying '//trim(optname)//' index to file '//file)
    return
  endif
  !
end subroutine mrtcal_copy_command

subroutine sense_inter_state
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sense_inter_state
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Sense automatically whether SIC has an interactive access or not.
  ! Action is different from sic_isatty() since there is also a special
  ! patch for XML widgets.
  ! + Compute some other global variables.
  !---------------------------------------------------------------------
  ! Local
  character(len=60) :: name
  integer(kind=4) :: ier
  !
  ! Special patch for XML widgets
  name = ''
  ier = sic_getlog('GAG_WIDGETS',name)
  if (name(1:3).ne."XML") then
    inter_state = sic_isatty().eq.1
  else
    inter_state = .true.      ! Force interstate for XML Widgets.
  endif
  !
  if (.not.inter_state) then
    edit_mode = .false.
    logbuf = .false.
    call gmessage_colors_swap(.false.)
    call sic_message(seve%w,'SIC',  &
      'Session is not interactive, SIC EDIT and SIC MEMORY off')
  else
    call find_edit  ! Check if line editing is possible
  endif
  !
  ! Determine prefered page editor
  ier = sic_getlog('GAG_EDIT',name)
  if (ier.ne.0) then
    tt_edit = 'AUTO'
  else
    tt_edit = name
  endif
  !
end subroutine sense_inter_state
!
subroutine set_inter_state(flag)
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Force the inter_state status.
  !---------------------------------------------------------------------
  logical, intent(in) :: flag
  !
  inter_state = flag
end subroutine set_inter_state
!
function sic_inter_state(dummy)
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  ! Return the inter_state status.
  !---------------------------------------------------------------------
  logical             :: sic_inter_state  ! Value on return
  integer, intent(in) :: dummy            ! Unused
  !
  sic_inter_state = inter_state
end function sic_inter_state

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_minmax
  use cubetools_parameters
  use cubetemplate_one2two_image_template
  use cubefield_messaging
  !
  public :: cubefield_minmax_register
  private
  !
  type(one2two_image_comm_t) :: minmax
  !
contains
  !
  subroutine cubefield_minmax_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: comm_abstract = &
         'Detect local minima and maxima in image slices'
    character(len=*), parameter :: comm_help = &
         'Detect strict local minima and maxima on each selected image&
         & slice of the input 3D cube by comparing every interior pixel&
         & with its 8 neighbors. The min output keeps only strict minima&
         & and the max output keeps only strict maxima. Border pixels&
         & and flat plateaus remain blank.'
    character(len=*), parameter :: incube_help = &
         'Use the input 3D cube. If omitted, use the last matching cube&
         & in the default index (DAG by default; see SET\INDEX).'
    character(len=*), parameter :: ou1help = 'Local minimum values'
    character(len=*), parameter :: ou2help = 'Local maximum values'
    character(len=*), parameter :: rname='MINMAX>REGISTER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call minmax%register_syntax(&
         'MINMAX','cubeid','3D cube',[flag_any],cubefield_minmax_command,&
         'min',[flag_local,flag_2d,flag_minimum],&
         'max',[flag_local,flag_2d,flag_maximum],&
         error,&
         comm_abstract=comm_abstract,&
         comm_help=comm_help,&
         incube_help=incube_help,&
         ou1help=ou1help,&
         ou2help=ou2help)
    if (error) return
    call minmax%register_act(cubefield_minmax_prog_act,error)
    if (error) return
  end subroutine cubefield_minmax_register
  !
  subroutine cubefield_minmax_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(one2two_image_user_t) :: user
    character(len=*), parameter :: rname='MINMAX>COMMAND'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call minmax%parse(line,user,error)
    if (error) return
    call minmax%main(user,error)
    if (error) continue
  end subroutine cubefield_minmax_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefield_minmax_prog_act(prog,ie,ima,min,max,error)
    !    use cubetools_parameters
    use cubetools_nan
    use cubeadm_image_types
    use cubefield_pixel_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_image_prog_t), intent(inout) :: prog
    integer(kind=entr_k),        intent(in)    :: ie
    type(image_t),               intent(inout) :: ima
    type(image_t),               intent(inout) :: min
    type(image_t),               intent(inout) :: max
    logical,                     intent(inout) :: error
    !
    logical :: ismin,ismax
    integer(kind=pixe_k) :: ix,iy
    integer(kind=indx_k) :: ilist
    type(pixprop_t) :: list(8)
    character(len=*), parameter :: rname='MINMAX>PROG>ACT'
    !
    !***JP: Should be parameter initialization
    list(1)%ix =  0
    list(1)%iy = +1
    list(2)%ix = +1
    list(2)%iy = +1
    list(3)%ix = +1
    list(3)%iy =  0
    list(4)%ix = +1
    list(4)%iy = -1
    list(5)%ix =  0
    list(5)%iy = -1
    list(6)%ix = -1
    list(6)%iy = -1
    list(7)%ix = -1
    list(7)%iy =  0
    list(8)%ix = -1
    list(8)%iy = +1
    !
!!$    do ilist=1,8
!!$       print *,'pixel #',ilist,'(ix,iy) = ',list(ilist)%ix,list(ilist)%iy
!!$    enddo
    !      
    call ima%get(ie,error)
    if (error) return
    call min%set(gr4nan,error)
    if (error) return
    call max%set(gr4nan,error)
    if (error) return
    do ix=2,ima%nx-1
       do iy=2,ima%ny-1
          ismin = .true.
          do ilist=1,8
             if (ima%val(ix,iy).ge.ima%val(ix+list(ilist)%ix,iy+list(ilist)%iy)) then
                ismin = .false.
                exit
             endif
          enddo
          if (ismin) then
             min%val(ix,iy) = ima%val(ix,iy)
          endif
          !
          ismax = .true.
          do ilist=1,8
             if (ima%val(ix,iy).le.ima%val(ix+list(ilist)%ix,iy+list(ilist)%iy)) then
                ismax = .false.
                exit
             endif
          enddo
          if (ismax) then
             max%val(ix,iy) = ima%val(ix,iy)
          endif
       enddo ! iy
    enddo ! ix
    call min%put(ie,error)
    if (error) return
    call max%put(ie,error)
    if (error) return
  end subroutine cubefield_minmax_prog_act
end module cubefield_minmax
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine run_point (line,comm,error)
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  !
  if (comm.eq.'IGNORE') then
    call ignore (line,comm,error)
  elseif (comm.eq.'INCLUDE') then
    call include (line,comm,error)
  elseif (comm.eq.'PARAMETER') then
    call param (line,comm,error)
  elseif (comm.eq.'PLOT') then
    call plot_result (line,comm,error)
  elseif (comm.eq.'PRINT') then
    call print (line,comm,error)
  elseif (comm.eq.'FILE') then
    call input_file (line,comm,error)
  elseif (comm.eq.'LIST') then
    call listpo (line,error)
  elseif (comm.eq.'READ') then
    call read_data (line,comm,error)
  elseif (comm.eq.'REJECT') then
    call reject (line,comm,error)
  elseif (comm.eq.'SET') then
    call set  (line,comm,error)
  elseif (comm.eq.'SHOW') then
    call show (line,comm,error)
  elseif (comm.eq.'SOLVE') then
    call solve (line,comm,error)
  elseif (comm.eq.'FLAG') then
    call flag(line,comm,error)
  else
    write(6,*) 'E-POINT,  No code for ',comm
  endif
end
!<FF>
subroutine load_point
  ! Global
  logical, external :: gr_error
  external :: run_point
  ! Local
  integer :: mpoint
  logical :: error
  !
  parameter (mpoint=25)
  character(len=12) :: cpoint(mpoint)
  data cpoint/   &
     &    ' IGNORE', '/SCAN', '/SOURCE', '/TIME',   &
     &    ' INCLUDE', '/SCAN', '/SOURCE', '/TIME',   &
     &    ' FILE', ' FLAG', ' LIST', '/OUTPUT',   &
     &    ' PARAMETER', '/FREE', ' PLOT', '/BAD',   &
     &    ' PRINT', '/OUTPUT', '/HEADER', '/30M',   &
     &    ' READ', ' REJECT',   &
     &    ' SET', ' SHOW', ' SOLVE'/
  !
  error = gr_error()
  call sic_begin('POINT','GAG_HELP_POINT',mpoint,cpoint,   &
     &    '1.0-00  15-JAN-1991  S.G.',run_point,gr_error)
  call gr_exec1 ('SET MARKER 4 0 .15')
  call gr_exec1 ('SET EXPAND 0.8')
end

function gr_clip(clip)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  ! Toggle Clipping
  !---------------------------------------------------------------------
  logical :: gr_clip                !
  logical :: clip                   !
  !
  gr_clip = .not.noclip
  noclip = .not.clip
end function gr_clip
!
subroutine gr4_phys_user (xi,yi,xu,yu,nxy)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !  Convert Physical units to User units
  !---------------------------------------------------------------------
  real(4), intent(in) :: xi(*)      ! X plot coordinates
  real(4), intent(in) :: yi(*)      ! Y plot coordinates
  real(4), intent(out) :: xu(*)     ! X User coordinates
  real(4), intent(out) :: yu(*)     ! Y User coordinates
  integer(4), intent(in) :: nxy     ! Number of points
  ! Local
  integer(4) :: i
  !
  if (axis_xlog) then
    do i=1,nxy
      xu(i) = exp((xi(i)-gx1)/gux + lux)
    enddo
  else
    do i=1,nxy
      xu(i) = (xi(i)-gx1)/gux + gux1
    enddo
  endif
  if (axis_ylog) then
    do i=1,nxy
      yu(i) = exp((yi(i)-gy1)/guy + luy)
    enddo
  else
    do i=1,nxy
      yu(i) = (yi(i)-gy1)/guy + guy1
    enddo
  endif
end subroutine gr4_phys_user
!
subroutine gr8_phys_user (xi,yi,xu,yu,nxy)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface (because of rank mismatch)
  !  Convert Physical units to User units
  !---------------------------------------------------------------------
  real(4), intent(in) :: xi(*)      ! X plot coordinates
  real(4), intent(in) :: yi(*)      ! Y plot coordinates
  real(8), intent(out) :: xu(*)     ! X User coordinates
  real(8), intent(out) :: yu(*)     ! Y User coordinates
  integer(4), intent(in) :: nxy     ! Number of points
  ! Local
  integer(4) :: i
  !
  if (axis_xlog) then
    do i=1,nxy
      xu(i) = exp((xi(i)-gx1)/gux + lux)
    enddo
  else
    do i=1,nxy
      xu(i) = (xi(i)-gx1)/gux + gux1
    enddo
  endif
  if (axis_ylog) then
    do i=1,nxy
      yu(i) = exp((yi(i)-gy1)/guy + luy)
    enddo
  else
    do i=1,nxy
      yu(i) = (yi(i)-gy1)/guy + guy1
    enddo
  endif
end subroutine gr8_phys_user
!
subroutine us8_to_int(xu,yu,xi,yi,nxy)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument rank mismatch)
  ! GREG	Internal routine
  !	Converts XU array in user coordinates into XI array in plot
  !	coordinates
  ! No subroutine referenced
  !---------------------------------------------------------------------
  real(8), intent(in) :: xu(*)       ! X User coordinates
  real(8), intent(in) :: yu(*)       ! Y User coordinates
  real(4), intent(out) :: xi(*)      ! X Plot coordinates
  real(4), intent(out) :: yi(*)      ! Y plot coordinates
  integer(4), intent(in) :: nxy      ! Number of points
  ! Local
  integer(4) :: i
  !
entry gr8_user_phys (xu,yu,xi,yi,nxy)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  if (axis_xlog) then
    do i=1,nxy
      if (xu(i).gt.0) then
        xi(i) = gx1 + gux * (log(xu(i))-lux)
      else if (gux.gt.0) then
        xi(i) = gx1
     else
        xi(i) = gx2
      endif
    enddo
  else
    do i=1,nxy
      xi(i) = gx1 + gux * (xu(i)-gux1)
    enddo
  endif
  !
  if (axis_ylog) then
    do i=1,nxy
      if (yu(i).gt.0) then
        yi(i) = gy1 + guy * (log(yu(i))-luy)
      else if (guy.gt.0) then
        yi(i) = gy1
     else
        yi(i) = gy2
      endif
    enddo
  else
    do i=1,nxy
      yi(i) = gy1 + guy * (yu(i)-guy1)
    enddo
  endif
end subroutine us8_to_int
!
subroutine us4_to_int(xu,yu,xi,yi,nxy)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface
  ! GREG	Internal routine
  !	Converts XU array in user coordinates into XI array in plot
  !	coordinates
  !---------------------------------------------------------------------
  real(4), intent(in) :: xu(*)       ! X User coordinates
  real(4), intent(in) :: yu(*)       ! Y User coordinates
  real(4), intent(out) :: xi(*)      ! X Plot coordinates
  real(4), intent(out) :: yi(*)      ! Y Plot coordinates
  integer(4), intent(in) :: nxy      ! Number of points
  ! Local
  integer(4) :: i
  !
entry gr4_user_phys (xu,yu,xi,yi,nxy)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  if (axis_xlog) then
    do i=1,nxy
      if (xu(i).gt.0) then
        xi(i) = gx1 + gux * (log(xu(i))-lux)
      else if (gux.gt.0) then
        xi(i) = gx1
     else
        xi(i) = gx2
      endif
    enddo
  else
    do i=1,nxy
      xi(i) = gx1 + gux * (xu(i)-gux1)
    enddo
  endif
  !
  if (axis_ylog) then
    do i=1,nxy
      if (yu(i).gt.0) then
        yi(i) = gy1 + guy * (log(yu(i))-luy)
      else if (guy.gt.0) then
        yi(i) = gy1
     else
        yi(i) = gy2
      endif
    enddo
  else
    do i=1,nxy
      yi(i) = gy1 + guy * (yu(i)-guy1)
    enddo
  endif
end subroutine us4_to_int

program primary
  use image_def
  use gkernel_interfaces
  use gbl_format
  use mapping_primary
  !---------------------------------------------------------------------
  ! Make primary beam division OR multiplication
  !---------------------------------------------------------------------
  ! Local
  character(len=80) :: namex,namey
  type(gildas) :: sky
  type(gildas) :: raw
  real :: bsize,bgood
  real, allocatable :: dprim(:,:)
  real, allocatable :: dtmp(:,:)
  !
  integer :: i,j,nx,ny, ier
  logical :: error, divide
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('BEAM$',bsize,1)
  call gildas_real('RADIUS$',bgood,1)
  call gildas_close
  !
  if (bsize.gt.0) then
     divide = .true.
  else
     divide = .false.
  endif
  !
  if (bgood.eq.0) then
     bgood = 0.5*sqrt(log(5.0)/log(2.0))*bsize
  endif
  bgood = exp(-2.0*log(2.0)*(bgood/bsize)**2)
  print *,'Bgood ',bgood
  !
  call gildas_null(raw)
  call gildas_null(sky)
  !
  call sic_parsef(namey,raw%file,' ','.lmv-clean')
  call gdf_read_header(raw,error)
  if (error) then
     call gagout('F-PRIMARY,  Cannot read input file')
     goto 100
  endif
  nx = raw%gil%dim(1)
  ny = raw%gil%dim(2)
  !
  ! Create output image
  call gdf_copy_header(raw,sky,error)
  call sic_parsef(namex,sky%file,' ','.lmv-sky')
  call gdf_create_image(sky,error)
  if (error) then
     call gagout('F-PRIMARY,  Cannot create output image')
     goto 100
  endif
  !
  allocate (dprim(nx,ny),dtmp(nx,ny),stat=ier)
  if (ier.ne.0) goto 100
  call mos_primary (sky,dprim,bsize) 
  if (divide) then
     where (dprim.lt.bgood) 
        dprim = 0
     else where
        dprim = 1.0/dprim
     end where
  else
     where (dprim.lt.bgood) 
        dprim = 0
     end where
  endif
  !
  do j=1,raw%gil%dim(4)
     raw%trc(4) = j
     raw%blc(4) = j
     do i=1,raw%gil%dim(3)
        raw%trc(3) = i
        raw%blc(3) = i
        call gdf_read_data(raw,dtmp,error)
        dtmp(:,:) = dtmp*dprim
        sky%trc = raw%trc
        sky%blc = raw%blc
        call gdf_write_data (sky,dtmp,error)
     enddo
  enddo
  call gdf_close_image (sky,error) 
  call gagout('S-PRIMARY,   Successful completion')
  call sysexi(1)
  !
100 call sysexi(fatale)
end program primary
!

SUBROUTINE protoResultsCalibration(error)

   Use mira
   Use modulePakoXML
   Use moduleResultsToNCS
   Use gbl_format
   Use gkernel_interfaces

   Implicit None

   Integer            :: idPart, ibd, ier, ifb, iobs, ipix, k1, k2,            &
             &           LF, lun, mxchan, nfebe, nLam, nBet, nbd, nchan, npix, &
             &           scanN
   Real*4             :: bandwidth, imbftsve, peakError
   Real*8             :: frequency, frequencyImage, offset
   Real*8             :: foffx, foffy
   Real*8             :: tatms, tatmi, trx, tsys, tcal, tauzen, tauzenImage,&
             &           h2omm, phot, psky, pcold
   Character(len=256) :: vis_data
   Character(len=200) :: filename
   Character(len=128) :: site
   Character(len=20)  :: switchingMode, tmpString
   Character(len=15)  :: scanId
   Character(len=13)  :: backendName, frontendName, frontendNameCal
   Character(len=7)   :: scale
   Character(len=7)   :: doppler
   Character(len=4)   :: year
   Character(len=2)   :: day, month 
   Logical            :: error, ex, foundCal, lError, resetBe, resetCal, resetRx
   Logical, dimension(:,:), allocatable :: calMask


!   Call Message(2,1,'protoResults','runs')
!   Call Message(2,1,'protoResultsPointing',' starts writing')

   year  = scan%header%date_obs(1:4)
   month = scan%header%date_obs(6:7)
   day   = scan%header%date_obs(9:10)

   if (scan%header%scannum.lt.10) then
      write(filename,'(a20,a4,a2,a2,a1,i1,a4)') 'iram30m-calibration-',     &
 &                              year,month,day,'s',scan%header%scannum,'.xml'
   else if (scan%header%scannum.lt.100) then
      write(filename,'(a20,a4,a2,a2,a1,i2,a4)') 'iram30m-calibration-',     &
 &                              year,month,day,'s',scan%header%scannum,'.xml'
   else if (scan%header%scannum.lt.1000) then
      write(filename,'(a20,a4,a2,a2,a1,i3,a4)') 'iram30m-calibration-',     &
 &                              year,month,day,'s',scan%header%scannum,'.xml'
   else
      write(filename,'(a20,a4,a2,a2,a1,i4,a4)') 'iram30m-calibration-',     &
 &                              year,month,day,'s',scan%header%scannum,'.xml'
   endif
   call sic_get_char('visData',vis_data,ier,error)
   if (vis_data.eq.'.') then
      filename = './'//trim(filename)
   else
      inquire(file=trim(vis_data)//'/mira/results',exist=ex)
      if (.not.ex) then
        call gagout(' ')
        call gagout('W-SOLVE: subdirectory for XML file does not exist.')
        call gagout('         Reset to default (working directory).')
        call gagout(' ')
      else
         filename = trim(vis_data)//'/mira/results/'//trim(filename)
      endif
   endif

   ier = sic_getlun(lun)
   Open (unit=lun,file=filename, recl=facunf*512,     &
        &   status='unknown')
   Call pakoXMLsetOutputUnit(iUnit = lun, error = lError)
   Call pakoXMLsetIndent(iIndent = 2, error = lError)
   Call resultsToNCSwriteProlog(error = lError)

   tmpString = febe(1)%header%swtchmod
   call sic_upper(tmpString)
   if (index(tmpString,'WOB').ne.0) then
      switchingMode = 'wobblerSwitching'
   else if (index(tmpString,'TOT').ne.0) then
      switchingMode = 'totalPower'
   else if (index(tmpString,'BEAM').ne.0) then
      switchingMode = 'beamSwitching'
   endif

   if (index(scan%header%telescop,"30M").ne.0.or.                      &
   &   index(scan%header%telescop,"30m").ne.0)                         &
   &                site = "Pico Veleta"
   Call resultsToNCSsetOdpHeader(                                      &
        &              telescope   = scan%header%telescop,             &
        &              observatory = site,                             &
        &              odpSoftware = prim%header%creator,              &
        &              reset       = .True.,                           &
        &              error       = lError                            &
        &                       ) 
   Call resultsToNCSwriteOdpHeader(error = lError) 

   Call resultsToNCSsetMeasurementHeader(                              &
                       measurement        = "Calibration",             &
        &              sourceName         = trim(scan%header%object),  & 
        &              timeStamp          = scan%header%date_obs,      &
        &              azimuth            =                            &
	&                       real(mon(1)%data%encoder_az_el(1,1)),&
        &              elevation          =                            &
	&                       real(mon(1)%data%encoder_az_el(1,2)),&
        &              refraction         =                            &
	&                       real(mon(1)%data%refractio(1)),      &
        &              pressureAmbient    =                            &
	&                       real(mon(1)%data%tamb_p_humid(1,2)), &
        &              temperatureAmbient = 273.16+                    &
	&                       real(mon(1)%data%tamb_p_humid(1,1)), &
        &              humidityAmbient    =                            &
	&                       real(mon(1)%data%tamb_p_humid(1,3)), &
        &              switchingMode      = switchingMode,             &
        &              observingMode      = "calibrate",               &
        &              reset              = .True.,                    &
        &              error              = lError                     &
	&                        )
!
   write(scanId,'(a11,i4.4)') scan%header%date_obs(1:10)//'.', &
         &                    scan%header%scannum 

   resetRx  = .true.
   resetBe  = .true.
   resetCal = .true.

   Call resultsToNCSsetScanId(                       &
        &              scanId = scanId,              &
        &              scanN  = scan%header%scannum, &
!        &              reset  = .not.foundCal,       &
        &              reset  = .true.,              &
        &              error  = lError               &
        &              ) 
   Call resultsToNCSwriteMeasurementHeader(error = lError)
   
   nfebe  = scan%header%nfebe
   read(pr%header%mbftsver,'(f3.1)') imbftsve

   febeLoop1: do ifb = 1, nfebe
     
      npix   = febe(ifb)%header%febefeed 
      if (index(febe(ifb)%header%febe(1:4),'HERA').ne.0) then
         frontendName = febe(ifb)%header%febe(1:5)//" Pixel "
         write(frontendName(13:13),'(i1)') ipix
         frontendNameCal(1:5) = frontendName(1:5)
         LF = 13
      else if (imbftsve.lt.2) then
         frontendName(1:4) = febe(ifb)%header%febe(1:4)
         frontendNameCal(1:4) = frontendName(1:4)
         LF = 4
      else
         frontendName(1:5) = febe(ifb)%header%febe(1:5)
         frontendNameCal(1:5) = frontendName(1:5)
         LF = 5
      endif


      frequency = array(ifb)%header(1)%restfreq*1.d-9
      offset = ((data(ifb)%header%channels/2.+0.5-data(ifb)%header%crpx4f_2)  &
 &              *data(ifb)%header%cd4f_21)*1.d-9

      if (index(array(ifb)%header(1)%sideband,'LSB').ne.0) then
         frequencyImage = frequency+array(ifb)%header(1)%sbsep*1.d-9
      else
         frequencyImage = frequency-array(ifb)%header(1)%sbsep*1.d-9
      endif

      if (scan%header%movefram) then
         doppler = 'fixed'
      else
         doppler = 'Doppler'
      endif

      if (reduce(ifb)%calibration_done(1)) then
         scale = 'antenna'
      else
         scale = 'none'
      endif

      if (index(frontendName(1:4),'HERA').ne.0) then
         foffx = 0.
         foffy = 0.
      else
         foffx       = febe(ifb)%data%feedoffx(1)*3600.
         foffy       = febe(ifb)%data%feedoffy(1)*3600.
      endif

      Call resultsToNCSsetReceiver(                                       &
           &       name           = frontendName(1:LF),                   &
           &       frequency      = frequency,                            &   
           &       lineName       = array(ifb)%header(1)%transiti,        &   
           &       sideBand       = array(ifb)%header(1)%sideband,        &
           &       doppler        = Doppler,                              &
           &       width          = febe(ifb)%header%widenar,             &
           &       effForward     = febe(ifb)%data%etafss(1,1),           &
           &       effBeam        = febe(ifb)%data%beameff(1,1),          &
           &       scale          = scale,                                &
           &       gainImage      = febe(ifb)%data%gainimag(1,1),         &
           &       tempAmbient    = real(mon(ifb)%data%thotcold(1,1)),    &
           &       tempCold       = real(mon(ifb)%data%thotcold(1,2)),    &
           &       offset         = offset,                               &
           &       centerIF       = febe(ifb)%header%ifcenter*1.d-9,      &   
           &       frequencyImage = frequencyImage,                       &
           &       xOffsetNasmyth = real(foffx),                          &
           &       yOffsetNasmyth = real(foffy),                          &
           &       reset          = resetRx,                              &
           &       error          = lError                                &
           &                      )

      resetRx = .false.

      if (index(febe(ifb)%header%febe,'VESPA').ne.0) then
         backendName = 'VESPA'
      else if (index(febe(ifb)%header%febe,'FTS').ne.0) then
         backendName = 'FTS'
      else if (index(febe(ifb)%header%febe,'CONT').ne.0) then
         backendName = 'continuum' 
      else if (index(febe(ifb)%header%febe,'BBC').ne.0) then
         backendName = 'BBC' 
      else if (index(febe(ifb)%header%febe,'NBC').ne.0) then
         backendName = 'NBC' 
      else if (index(febe(ifb)%header%febe,'4MHZ').ne.0) then
         backendName = '4MHZ' 
      else if (index(febe(ifb)%header%febe,'1MHZ').ne.0) then
         backendName = '1MHZ' 
      else if (index(febe(ifb)%header%febe,'100KHZ').ne.0) then
         backendName = '100KHZ' 
      else if (index(febe(ifb)%header%febe,'WILMA').ne.0) then
         backendName = 'WILMA'
      endif

      k1 = index(febe(ifb)%header%febe,'/')+1
      if (k1.eq.1) then
         idPart = 1
      else
         k2 = len_trim(febe(ifb)%header%febe)
         read(febe(ifb)%header%febe(k1:k2),'(i3)') idPart
      endif   

      if (index(backendName,'continuum').eq.0) then
         bandwidth = real(array(ifb)%header(1)%cd4f_21                    &
           &              *data(ifb)%header%channels)*1.e-6
      else
         bandwidth = 1000. !need to distinguish here bb mode and nb mode
      endif

      Call resultsToNCSsetBackend(                                           &
           &       name  = backendName,                                      &
           &       nPart = idPart,                                           &
           &       resolution=abs(real(array(ifb)%header(1)%freqres))*1.e-6, &
           &       bandwidth  = bandwidth,                                   &
           &       fShift = real(offset),                                    &
           &       receiver = frontendName(1:LF),                            &
           &       nChannels = data(ifb)%header%channels,                    &
           &       reset     = resetBe,                                      &
           &       error = lError                                            &
           &       )


      resetBe = .false.

   enddo febeLoop1
   Call resultsToNCSwriteReceivers(error = lError)
   Call resultsToNCSwriteBackends(error = lError) 

   febeLoop2: do ifb = 1, nfebe

      pixelLoop: do ipix = 1, npix

         if (index(febe(ifb)%header%febe(1:4),'HERA').ne.0) then
            frontendNameCal = febe(ifb)%header%febe(1:5)//" Pixel "
            write(frontendNameCal(13:13),'(i1)') ipix
         else if (imbftsve.le.2.0) then
            frontendNameCal(1:4) = febe(ifb)%header%febe(1:4)
         else
            frontendNameCal(1:5) = febe(ifb)%header%febe(1:5)
         endif
        
         mxchan = size(gains(ifb)%trx,3)
         nbd    = febe(ifb)%header%febeband
         allocate (calMask(nbd,mxchan),stat=ier)
         calMask = gains(ifb)%trx(1:nbd,ipix,1:mxchan).ne.-1.
         trx     = sum(gains(ifb)%trx(1:nbd,ipix,1:mxchan),calMask)      &
 &                 /count(calMask)
         calMask = gains(ifb)%tcal(1:nbd,ipix,1:mxchan).ne.-1.
         tcal     = sum(gains(ifb)%tcal(1:nbd,ipix,1:mxchan),calMask)    &
 &                  /count(calMask)
         calMask = gains(ifb)%tsys(1:nbd,ipix,1:mxchan).ne.-1.
         tsys    = sum(gains(ifb)%tsys(1:nbd,ipix,1:mxchan),calMask)     &
 &                 /count(calMask)
         h2omm       = sum(gains(ifb)%h2omm(1:nbd,ipix,1:mxchan),calmask)&
 &                     /count(calMask)
         tatms       = sum(gains(ifb)%tatms(1:nbd,ipix,1:mxchan),calmask)&
 &                     /count(calMask)
         tatmi       = sum(gains(ifb)%tatmi(1:nbd,ipix,1:mxchan),calmask)&
 &                     /count(calMask)
         tauzen      = sum(gains(ifb)%tauzen(1:nbd,ipix,1:mxchan),calmask)&
 &                     /count(calMask)
         tauzenImage = sum(gains(ifb)%tauzenImage(1:nbd,ipix,1:mxchan),calmask)    &
 &                     /count(calMask)
         deallocate(calMask)
         phot        = 0.0
         psky        = 0.0
         pcold       = 0.0
         do ibd = 1, nbd
            nchan       = array(ifb)%header(ibd)%usedchan
            k1          = array(ifb)%header(ibd)%dropchan+1
            k2          = array(ifb)%header(ibd)%dropchan+nchan
            phot        = phot+sum(gains(ifb)%phot(ibd,ipix,k1:k2))/nchan
            psky        = psky+sum(gains(ifb)%psky(ibd,ipix,k1:k2))/nchan
            pcold       = pcold+sum(gains(ifb)%pcold(ibd,ipix,k1:k2))/nchan
         enddo
         psky        = psky/nbd
         phot        = phot/nbd
         pcold       = pcold/nbd

         foffx       = febe(ifb)%data%feedoffx(ipix)*3600.
         foffy       = febe(ifb)%data%feedoffy(ipix)*3600.

         frequency = array(ifb)%header(1)%restfreq*1.d-9
         offset =((data(ifb)%header%channels/2.+0.5-data(ifb)%header%crpx4f_2) &
 &               *data(ifb)%header%cd4f_21)*1.d-9

         if (index(array(ifb)%header(1)%sideband,'LSB').ne.0) then
            frequencyImage = frequency+array(ifb)%header(1)%sbsep*1.d-9
         else
            frequencyImage = frequency-array(ifb)%header(1)%sbsep*1.d-9
         endif

         Call resultsToNCSsetCalibrationResults(                       &
        &       name           = frontendNameCal(1:LF),                &
        &       frequency      = frequency,                            &   
        &       lineName       = array(ifb)%header(1)%transiti,        &   
        &       sideBand       = array(ifb)%header(1)%sideband,        &
        &       effForward     = febe(ifb)%data%etafss(ipix,1),        &
        &       effBeam        = febe(ifb)%data%beameff(ipix,1),       &
        &       gainImage      = febe(ifb)%data%gainimag(ipix,1),      &
        &       tempAmbient    = real(mon(ifb)%data%thotcold(1,1)),    &
        &       tempCold       = real(mon(ifb)%data%thotcold(1,2)),    &
        &       frequencyImage = frequencyImage,                       &
        &       xOffsetNasmyth = real(foffx),                          &
        &       yOffsetNasmyth = real(foffy),                          &
        &       lcalof         = real(gains(ifb)%lcalof*3600),         &
        &       bcalof         = real(gains(ifb)%bcalof*3600),         &
        &       h2omm          = real(h2omm),                          &
        &       trx            = real(trx),                            &
        &       tsys           = real(tsys),                           &
        &       tcal           = real(tcal),                           &
        &       tatms          = real(tatms),                          &
        &       tatmi          = real(tatmi),                          &
        &       tauzen         = real(tauzen),                         &
        &       tauzenImage    = real(tauzenImage),                    &
        &       pcold          = real(pcold),                          &
        &       phot           = real(phot),                           &
        &       psky           = real(psky),                           &
        &       reset          = resetCal,                             &
        &       error          = lError                                &
        &       )

         resetCal = .false.

      enddo pixelLoop

   enddo febeLoop2

   Call resultsToNCSwriteCalibrationResults(error = lError)

   Call resultsToNCSwriteMeasurementEnd(error = lError)

   Call resultsToNCSwriteEnd(error = lError)

   Close(Unit=lun)
   ier = gag_frelun(lun)

!  Call Message(2,1,'protoResultsCalibration',' finished writing')

   return

END SUBROUTINE protoResultsCalibration

subroutine solve_spidx(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! 	Calculate the flux of sources in the current index,
  !	or the efficiency (JY_TO_KEL) if the flux is known
  !       /RESET : reset all unknown fluxes to zero.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  ! Local
  character(len=6) :: ch
  character(len=80) :: snam,filnam
  logical :: new, output, iznogoud, usereal
  integer :: iband, iant, ix, iy, jw1, jw2, old_base, p_lun, ipol, kb, kif
  integer :: i, ia, ns,  if, is, if1, ier, nch, ir, ignored, ifr, iif, ibb
  real :: frtol
  integer :: dtol
  parameter (frtol=1e3, dtol=7)    ! 1 GHz ... 1 week ...
  real :: visi(mnif,mnant,m_spidx), wisi(mnif,mnant,m_spidx),solspidx(mnant,m_spidx)
  real :: eff_in(2,mnant,m_spidx),fif(2)
  real :: aspidx, sspidx(m_spidx), weff(2,mnant), seff(2,mnant), seffs(2,mnant),wspidx
  real :: fff(mnant), wfff(mnant), ssp(2), wsp(2), weffs(2,mnant)
  real :: vsspidx, wsspidx, vt(4,3), wt(4,3), fspidx(m_spidx)
  real :: sseff(mnant)
  logical :: end, do_phcorr, reset
  logical :: do_reference, is_sorted, checked
  character(len=132) :: chain
  character(len=12) :: argum, sname(m_spidx), tsource, rf_chain
  integer(kind=address_length) :: k, ipk, ipkc, ipkl, data_in, kin
  integer(kind=data_length)    :: ldata_in, h_offset, c_offset, l_offset
  integer :: sdate(m_spidx), iv, im, n_best, ind(mnant), nbb(mnif),nsp(2)
  integer(kind=index_length) :: dim(4)
  !
  integer :: mvoc1, mvoc2, nkey, iscan
  parameter (mvoc1=6, mvoc2=3)
  character(len=12) :: kw, voc1(mvoc1), voc2(mvoc2)
  data voc1/'CORRECTED','UNCORRECTED','REFERENCED',   &
    'NOREFERENCED','BEST','REAL'/
  data voc2/'OLD','NEW','FLUX'/
  !
  common /thespidx/  seff, sspidx, ns
  save /thespidx/
  save sname
  !------------------------------------------------------------------------
  ! Code:
  ipol = 1 ! Dummy
  kb = 1   
  kif =1 
  checked = .false.
  save_scale = do_scale
  ! Verify if any input file
  call check_input_file(error)
  if (error) return
  !
  call check_index(error)
  if (error) return
  !
  output = .false.
  do_phcorr = .false.
  do_reference = .true.
  n_best = 3
  usereal = .false.
  if (sic_narg(0).ge.2) then
    i = 2
    do while (i.le.sic_narg(0))
      argum = 'UNCORRECTED'
      call sic_ke(line,0,i,argum,nch,.false.,error)
      i = i+1
      if (error) goto 999
      call sic_ambigs('SOLVE FLUX',argum,kw,nkey,voc1,mvoc1,error)
      if (error) goto 999
      if (kw.eq.'CORRECTED') then
        do_phcorr = .true.
      elseif (kw.eq.'UNCORRECTED') then
        do_phcorr = .false.
      elseif (kw.eq.'REFERENCED') then
        do_reference = .true.
      elseif (kw.eq.'NOREFERENCED') then
        do_reference = .false.
      elseif (kw.eq.'BEST') then
        call sic_i4(line,0,i,n_best,.true.,error)
        i = i+1
      elseif (kw.eq.'REAL') then
        usereal = .true.
        write (chain,'(a,i1,a)') 'Using visibility real part'   &
          //' instead of amplitude'
        call message(8,2,'SOLVE_INDEX',chain(1:lenc(chain)))
      endif
    enddo
  endif
  write (chain,'(a,i0,a)') 'Average spidx will use the best ',   &
    n_best,' antennas'
  call message(8,1,'SOLVE_INDEX',chain(1:lenc(chain)))
  !
  reset = sic_present(4,0)
  !
  output = sic_present(3,0)
  if (output) then
    call sic_ch(line,3,1,snam,nch,.true.,error)
    if (error) goto 999
    new = .false.
    i = 2
    do while (i.le.sic_narg(3))
      call sic_ke(line,3,i,ch,nch,.true.,error)
      if (error) goto 999
      call sic_ambigs('SOLVE_INDEX',ch,kw,nkey,voc2,mvoc2,error)
      if (error) goto 999
      new = new.or.(kw.eq.'NEW')
      i = i+1
    enddo
    call sic_parsef(snam,filnam,' ','.int')
    ier = sic_getlun(p_lun)
    if (new) then
      ier = sic_open (p_lun,filnam,'NEW',.false.)
      if (ier.eq.0) then
        call user_info(snam)
        write(p_lun,2001) '! '
        write(p_lun,2001) '! CLIC\SOLVE FLUX /OUT '   &
          //filnam(1:lenc(filnam))//   ' FLUX NEW '
        write(p_lun,2001) '! '//snam(1:70)
        write(p_lun,2010)
      endif
    else
      ier = sic_open (p_lun,filnam,'APPEND',.false.)
    endif
    if (ier.ne.0) then
      call message(6,3,'SOLVE_INDEX','Cannot open file '//filnam)
      call messios(6,3,'SOLVE_INDEX',ier)
      error = .true.
      call sic_frelun(p_lun)
      return
    endif
  endif
  !
  if (reset) then
    k = 1
    do i=1, n_spidx
      if (f_spidx(i)) then
        f_spidx(k) = .true.
        spidx(k) = spidx(i)
        c_spidx(k) = c_spidx(i)
        freq_spidx(k) = freq_spidx(i)
        date_spidx(k) = date_spidx(i)
        k = k+1
      endif
    enddo
    n_spidx = k-1
  endif
  ! check if spidx list contains a reference spidx
  if (do_reference) then
    k = 0
    do i=1, n_spidx
      if (f_spidx(i)) then
        k = k+1
      endif
    enddo
    if (k.eq.0) then
      call message(6,3,'SOLVE_INDEX',   &
        'No source of known spidx in spidx list')
      error = .true.
      return
    endif
  else
    call message(4,1,'SOLVE_INDEX',   &
      'Using stored efficiencies to compute spidx')
  endif
  jw1 = iw1(k_subb(1))
  jw2 = iw2(k_subb(1))
  !
  ! Select either real part (IY=3) or amplitude (IY=1, default)
  ix = 10
  iy = 1
  if (usereal) then
    iy = 3
  endif
  iband = i_band(k_band(1))
  ignored = 0
  !
  do_scale = .true.
  do_amplitude = .false.
  do_flux = .false.
  call show_general('AMPLITUDE',.false.,line,error)
  if (error) goto 999
  !
  old_base = i_base(1)
  if (i_base(1).gt.0) call switch_antenna
  call set_display(error)
  !
  ! Count sources in current index, store known spidxes and visibilities
  call get_first(.true.,error)
  if (error) goto 999
  call check_subb(1,.true.,error)
  if (error) goto 999
  ns = 0
  tsource = ' '
  end = .false.
  do while (.not. end)
    is = 0
    if (ns.ge.1) then
      do i=1, ns
        if (r_sourc.eq.sname(i)   &
          .and. abs(r_restf-fspidx(i)).lt.frtol) then
          is = i
        endif
      enddo
    endif
    if (is.eq.0) then
      ns = ns + 1
      sname(ns) = r_sourc
      fspidx(ns) = r_restf
      sdate(ns) = r_dobs
      sspidx(ns) = r_spidx+200
      !
      ! Check if by chance spidx is already known
      do if = 1, n_spidx
        if (f_spidx(if) .and. c_spidx(if).eq.sname(ns) .and.   &
          ((freq_spidx(if).le.0)  .or.   &
          (abs(fspidx(ns)-freq_spidx(if)).lt.frtol)) .and.   &
          ((date_spidx(if).lt.-100000)   &
          .or. (abs(date_spidx(if)-sdate(ns)).le.dtol))) then
          sspidx(ns) = spidx(if)
        endif
      enddo
      !
      ! Compute average sideband efficiencies and frequencies
      do ia = 1, r_nant
        nbb(:) = 0
        fif(:) = 0
        do ibb = 1, r_nbb
          iif = r_if(ibb)
          if (r_sb(ibb).eq.1) then
            ifr = 2
          else
            ifr = 1
          endif
          eff_in(ifr,ia,ns) = eff_in(ifr,ia,ns)+r_jykel(ibb,ia)
          fif(ifr) = fif(ifr)+r_flo1+r_sb(ibb)*(r_flo2(ibb)+ &
                     r_band2(ibb)*r_lfcen(ibb))

          nbb(ifr) = nbb(ifr)+1 
        enddo
        do iif = 1, r_nif
          visi(iif,ia,ns) = 0
          wisi(iif,ia,ns) = 0
        enddo
        !
        ! Need both sidebands
        do ifr = 1, 2
          if (nbb(ifr).ne.0) then
            eff_in(ifr,ia,ns) = eff_in(ifr,ia,ns)/nbb(ifr)
            fif(ifr) = fif(ifr)/nbb(ifr)
          else 
            call message(8,3,'SOLVE_INDEX',   &
                         'Missing sideband')
            error = .true.
            return
          endif
        enddo
        !
      enddo
      is = ns
    endif
    ! Following to check
    if (do_pass.and..not.do_pass_memory) then
      if (do_pass_spectrum.and..not.checked) then
        iscan = 0
        call get_pass_scan(rf_chain,iscan,error)
        if (error) then
          call message(8,2,'SOLVE_FLUX','No BANDPASS scan found')
          ignored = ignored + 1
          goto 200
        endif
        checked = .true.
      else
        if (do_pass_antenna .and. r_abpc.eq.0) then
          call message(6,2,'SOLVE_INDEX',   &
            'No Antenna RF Passband Calibration, data ignored')
          ignored = ignored + 1
          goto 200
        elseif (.not.do_pass_antenna .and. r_bpc.eq.0) then
          call message(6,2,'SOLVE_INDEX',   &
            'No Baseline RF Passband Calibration, data ignored')
          ignored = ignored + 1
          goto 200
        endif
      endif
    endif
    if (r_lmode.gt.1) then
      call message(6,2,'SOLVE_INDEX',   &
        'Autocorrelation scan ignored.')
      ignored = ignored + 1
      goto 200
    endif
    call get_data (ldata_in,data_in,error)
    if (error) goto 200
    if (do_pass) then
      call set_pass(r_nsb,r_nband,r_nbas+r_ntri,   &
        r_lntch, passc, passl, error)
      if (error) goto 200
    endif
    call set_corr(error)
    !
    ! Do not loop on records : use average for scan
    !
    call spectral_dump(ir,0,0)
    kin = gag_pointer(data_in,memory)
    ipk = kin  + h_offset(ir)
    call decode_header(memory(ipk))
    call set_scaling (error)
    if (error) return
    !
    do ia = 1, n_base
      iant = -i_base(ia)
      call spectral_dump(ir,iant,0)
      ipkc = kin + c_offset(ir)
      ipkl = kin + l_offset(ir)
      do iif = 1, r_nif
        n_if = 1
        l_if(n_if) = 1
        i_if(n_if,l_if(n_if)) =  iif
        call set_if_subbands(error)
        iband = 1
        if (r_ifname(iif)(2:2).eq."L") iband = 2 
        if (error) return
        do iv=1,4
          do im=1,3
            vt(iv,im) = 0
            wt(iv,im) = 0
          enddo
        enddo
        call arecord (r_nsb, r_nband, r_nbas, r_lntch,   &
          memory(ipkc),memory(ipkl),   &
          passc, passl, iant, iband, ipol, kb, iif, l_subb(1), i_subb(1,1),   &
          jw1,jw2,ix,iy, vt, wt, do_phcorr,error)
        if (error) goto 999
        visi(iif,ia,is) = visi(iif,ia,is) + vt(2,2)
        wisi(iif,ia,is) = wisi(iif,ia,is) + wt(2,2)
      enddo
      !
      ! For flux output : printout 2 lines for each scan, and each antenna
      ! (compatibility with CLASS printouts)
!!      if (output.and.wt(2,2).gt.0) then
!!        call datec (r_dobs,chain,error)
!!        fl = vt(2,2)/wt(2,2)*abs(sflux(is))
!!        efl = abs(sflux(is))*1e-3/sqrt(wt(2,2))
!!        !cc NGRX: Give the efficiency for Polar 1 !!!!!!!!!!!!!!!
!!        do k=1,0,-1
!!          write(p_lun,2011) r_num, r_scan, k, 0d0, 0d0, 0d0,   &
!!            0.0, 0.0, iant, 1.0, 0.0, fl, efl,   &
!!            r_gim(1,iant), ff, fi, sname(is),chain(1:11)
!!        enddo
!!      endif
    enddo
200 error = .false.
    call get_next(end,error)
    if (error) goto 999
    if (sic_ctrlc()) then
      error = .true.
      goto 900
    endif
  enddo
  if (ignored.gt.0) then
    write(chain,'(i6,a)') ignored, ' ignored scans.'
    call message(6,2,'SOLVE_INDEX',chain(1:lenc(chain)))
  endif
  !
!!2011 format(1x,i8,i6,i3,3(1x,f8.3),1x,   &
!!    f9.2,1x,f8.2,1x,i2,1x,f9.2,1x,f8.2,1x,   &
!!    1pg10.3,1x,1pg10.3,1x,0pf6.2,2(1x,f8.3),1x,'''',a,'''',   &
!!    1x,'''',a,'''')
  do i = 1, ns
    do ia = 1, n_base
      do iif = 1, r_nif
        if (wisi(iif,ia,i).ne.0) then
          visi(iif,ia,i) = visi(iif,ia,i)/wisi(iif,ia,i)
        elseif (sspidx(i).le.100) then
          write(chain,'(a,i2,a)') sname(i)//' antenna ',ia,   &
            ' cannot be used'
          call message(4,2,'SOLVE_INDEX',chain(1:lenc(chain)))
        endif
      enddo
    enddo
  enddo
  !
  ! Get efficiencies (for sources with known spidx)
  if (do_reference) then
    call sic_delvariable ('JY_PER_K_IF',.false.,error)
    dim(1) = r_nif
    dim(2) = n_base
    call sic_def_real ('JY_PER_K_IF',seff,2,dim,.false.,error)
    do ia = 1, n_base
      do ifr=1, 2
        weff(ifr,ia) = 0
        seff(ifr,ia) = 0
      enddo
    enddo
    if (do_phcorr) call message(6,1,'SOLVE_INDEX',   &
      'Amplitudes are corrected for r.m.s. phase errors')
    call message(6,1,'SOLVE_INDEX','Reference sources:')
    !
    ! Compute "efficiencies" (relative to LSB)
    sseff(:) = 0
    do i=1, ns
      if (sspidx(i).lt.100) then
        write(chain,1000) sname(i),sspidx(i)
        call message(6,1,'SOLVE_INDEX',chain(1:lenc(chain)))
        ! Original formula  [ (visi/flux)*(wisi*flux**2) ]
        ! and in Scaled mode [ Scale*wisi ]
        seffs(:,:) = 0 
        weffs(:,:) = 0
        do ia=1, n_base
          do iif=1, r_nif
            if (r_ifname(iif)(2:2).eq."L") then
              ifr = 1
            else
              ifr =2
            endif
            ! Compute Stokes I
            seffs(ifr,ia) = seffs(ifr,ia) + visi(iif,ia,i) 
            weffs(ifr,ia) = weffs(ifr,ia) + 1
            sseff(ia) = sseff(ia)+visi(iif,ia,i)
          enddo
          !
          ! Normalize by LSB amp and correct for spectral index
          if (any(weffs(:,ia).eq.0).or.any(seffs(:,ia).eq.0)) then
            call message(8,3,'SOLVE_INDEX',   &
            'Cannot compute efficiencies')
            error = .true.
            return
          else
            seffs(:,ia) = seffs(:,ia)*weffs(1,ia)/seffs(1,ia)/weffs(:,ia)   
            seff(:,ia) = seffs(:,ia)*(fif(:)/fif(1))**(-sspidx(i))                   
            weff(:,ia) = weff(:,ia) + 1
          endif
        enddo
      endif
    enddo
    !
    ! Check if any good efficiency:
    iznogoud = .true.
    do ia=1, n_base
      do ifr=1, 2
        iznogoud = iznogoud .and. weff(ifr,ia).le.0
      enddo
    enddo
    if (iznogoud) then
      call message(8,3,'SOLVE_INDEX',   &
        'No usable data with known spidx')
      error = .true.
      if (output) then
        close (unit=p_lun)
        call sic_frelun(p_lun)
      endif
      do_scale = save_scale
      return
    endif
    call message(6,1,'SOLVE_INDEX','Average efficiencies:')
    !
    do ia=1, n_base
      do ifr=1, 2
        if (weff(ifr,ia).gt.0) then
          iant = -i_base(ia)
          seff(ifr,ia) = seff(ifr,ia)/weff(ifr,ia)
          write(chain,1001,iostat=ier)   &
            iant, ifr, seff(ifr,ia)
          call message(6,1,'SOLVE_INDEX',chain(1:lenc(chain)))
        else
          seff(iif,ia) = 0
          write(chain,'(a,i2,a)') 'Efficiency for antenna ',ia,   &
            ' cannot be computed'
          call message(4,2,'SOLVE_INDEX',chain(1:lenc(chain)))
        endif
      enddo
    enddo
  endif
  !
  ! Get spidxes (for other sources)
  is_sorted = .false.
  do ia = 1, n_base
    if (sseff(ia).ne.0) then
      sseff(ia)=1/sseff(ia)
    else
      sseff(ia)=1.23456e34
    endif
  enddo
  call message(6,1,'SOLVE_INDEX','Sources, Spidxes and errors : ')
  do is=1, ns
    aspidx = 0
    wspidx = 0
    do ia=1, n_base
      iant = -i_base(ia)
      ! Average polarisation (this is Stokes I)
      ssp(:) = 0
      wsp(:) = 0
      do iif = 1, r_nif
        if (r_ifname(iif)(2:2).eq."L") then
          ifr = 1
        else
          ifr =2
        endif
        ssp(ifr) = ssp(ifr)+visi(iif,ia,is)
        wsp(ifr) = wsp(ifr)+1
        nsp(ifr) = nsp(1)+1
      enddo
      ! Use "efficiencies"
        if (do_reference) then ! .and. seff(ifr,ia).gt.0) then
          eff_in(:,ia,is) = seff(:,ia)
        endif
        if (all(eff_in(:,ia,is).ne.0)) then
          ssp(:) = ssp(:)/eff_in(:,ia,is)
        else
          error = .true.
          return
        endif
      !
      if (all(wsp(:).ne.0).and.ssp(1).ne.0)  ssp(:)=ssp(:)*wsp(1)/ssp(1)/wsp(:)
      vsspidx = log(ssp(2)/ssp(1))/log(fif(2)/fif(1))
      wsspidx = 1
      if (wsspidx.ne.0) then
        write(chain,1004,iostat=ier) sname(is), iant, vsspidx
        call message(6,1,'SOLVE_INDEX',chain(1:lenc(chain)))
      endif
      fff(ia) = vsspidx
      solspidx(ia,is)= vsspidx
      wfff(ia) = wsspidx
    enddo
    !         CALL GR4_TRIE(FFF,IND,N_BASE,ERROR)
    if (.not.is_sorted) then
      call gr4_trie(sseff,ind,n_base,error)
      is_sorted = .true.
    endif
    !
    do ia= 1, n_best           !N_BASE, MAX(1,N_BASE-N_BEST+1), -1
      i = ind(ia)
      aspidx = aspidx + fff(i)*wfff(i)
      wspidx = wspidx + wfff(i)
    enddo
    if (wspidx.ne.0) then
      aspidx = aspidx / wspidx
      write(chain,1003,iostat=ier)   &
        sname(is), aspidx
      call message(6,1,'SOLVE_INDEX',chain(1:lenc(chain)))
    endif
    !
    ! Compute the new spidxes for "free" sources
    if (sspidx(is).gt.100) then
      sspidx(is) = aspidx
      if1 = 0
      do if = 1, n_spidx
        if (.not.f_spidx(if) .and. c_spidx(if).eq.sname(is)   &
          .and. (freq_spidx(if).le.0 .or.   &
          (abs(freq_spidx(if)-fspidx(is)).lt.frtol))) then
          spidx(if) = sspidx(is)
          if (freq_spidx(if).le.0) freq_spidx(if) = fspidx(is)
          date_spidx(if) = sdate(is)
          f_spidx(if) = .false.
          if1 = if
        endif
      enddo
      if (if1.le.0 .and. n_spidx.lt.m_spidx) then
        n_spidx = n_spidx+1
        f_spidx(n_spidx) = .false.
        spidx(n_spidx) = sspidx(is)
        freq_spidx(n_spidx) = fspidx(is)
        c_spidx(n_spidx) = sname(is)
        date_spidx(if) = sdate(is)
      endif
    endif
  enddo
  !
  ! Keep the results in variables for calibration procedures.
  call sic_delvariable ('SOLVED',.false.,error)
  call sic_delvariable ('N_SOLVED',.false.,error)
  call sic_delvariable ('F_SOLVED',.false.,error)
  call sic_delvariable ('AF_SOLVED',.false.,error)
  call sic_def_inte    ('N_SOLVED',ns,0,0,.false.,error)
  call sic_def_charn   ('SOLVED',sname,1,ns,.false.,error)
  call sic_def_real    ('F_SOLVED',sspidx,1,ns,.false.,error)
  dim(2) = ns
  dim(1) = mnant
  call sic_def_real    ('AF_SOLVED',solspidx,2,dim,.false.,error)
  call sort_spidx(error)
!  do i=1, n_base
!    iant = -i_base(i)
!    jy_to_kel(iant) = eff_in(iant,is)
!  enddo
  !
900 if (old_base.gt.0) call switch_baseline
  call set_display(error)
  if (output) then
    close (unit=p_lun)
    call sic_frelun(p_lun)
  endif
  do_scale = save_scale
  return
  !
999 error = .true.
  goto 900
  !
1000 format(1x,a,1x,'Spidx = ',f8.4)
1001 format(1x,'Ant. ',i0,' IF ',i0,2x,f7.3)
1003 format(1x,a,' Aver.',1x,f8.4)
1004 format(1x,a,' Ant ',i0,1x,f8.4)
2010 format(   &
    '!   Obs.#  Scan Code Azimuth   Elevation  Time  ',   &
    '     Position  ..  A#     Width      ..     Intensity',   &
    '     ..  Gain   Fsignal  Fimage Source  Date')
2001 format(a)
end subroutine solve_spidx

subroutine rec_define_noema(rdesc,mode,error)
  use gbl_message
  use astro_interfaces, except_this=>rec_define_noema
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! fill in the receiver type according to input name
  !-----------------------------------------------------------------------
  type(receiver_desc_t), intent(inout) :: rdesc ! receiver desc parameters
  character(len=*), intent(in) :: mode ! OFFLINE or ONLINE
  logical, intent(inout)        :: error
  ! local
  integer(kind=4)       :: i
  !
  rdesc%name = 'NOEMA'
  rdesc%defined = .true.
  if (mode.eq.'OFFLINE') then
    rdesc%n_rbands = 3
  else if (mode.eq.'ONLINE') then
    rdesc%n_rbands = 4
  endif
  rdesc%bandname(1) = 'Band_1'
  rdesc%bandname(2) = 'Band_2'
  rdesc%bandname(3) = 'Band_3'
  rdesc%bandname(4) = 'Band_4'
  rdesc%rejection(1) = 30
  rdesc%rejection(2) = 30
  rdesc%rejection(3) = 30
  rdesc%rejection(4) = 30
  rdesc%n_sbands = 2
  rdesc%n_bbands = 2
  rdesc%n_polar = 2
  rdesc%n_backends = 1
  rdesc%iflim(1) = 3872d0
  rdesc%iflim(2) = 11616d0
  rdesc%ifband = rdesc%iflim(2)-rdesc%iflim(1)
  !basebands
  rdesc%flo2 = 7744d0
  ! LO2 separation zone: (from commissioning output)
  ! Mark only the strong parasite
  !Attenuation 1.5chunk in INNER and OUTER defined in IF1 - not yet plotted
  rdesc%if1conf(1) = rdesc%flo2-10d0
  rdesc%if1conf(2) = rdesc%flo2+10d0
  rdesc%bbname(1) = 'OUTER'
  rdesc%bblim(1,1) = 7744d0
  rdesc%bblim(2,1) = 11616d0
  rdesc%bbref(1) = 10000d0
  rdesc%bbname(2) = 'INNER'
  rdesc%bblim(1,2) = 3872d0
  rdesc%bblim(2,2) = 7744d0
  rdesc%bbref(2) = 6000d0
  ! Polars
  rdesc%polname(1) = 'HORIZONTAL'
  rdesc%polname(2) = 'VERTICAL'
  !
  ! Limits as stated in the tuning tables  (Jan2017)
  rdesc%lohard(1,1) = 82.0d3
  rdesc%lohard(2,1) = 110d3
  rdesc%lohard(1,2) = 136d3
  rdesc%lohard(2,2) = 172d3
  rdesc%lohard(1,3) = 207.744d3
  rdesc%lohard(2,3) = 268d3
  rdesc%lohard(1,4) = 280d3
  rdesc%lohard(2,4) = 370d3
  !
  ! Limits from ACC = Specs from SVN noema (may2018)
  rdesc%locall(1,1) = 82.0d3 ! to match the specs 20dec2017 (was 82.5)
  rdesc%locall(2,1) = 107.700d3 ! update W20 (from MK)
  rdesc%locall(1,2) = 138.616d3
  rdesc%locall(2,2) = 171.256d3
  rdesc%locall(1,3) = 207.744d3
  rdesc%locall(2,3) = 264.384d3
  rdesc%locall(1,4) = 280d3
  rdesc%locall(2,4) = 370d3
  !
  rdesc%lotol = 100d0
  !
  ! Wider limits to let some margin to explore the edge of the bands
  do i=1,rdesc%n_rbands
      rdesc%lolim(1,i) = min(rdesc%locall(1,i),rdesc%lohard(1,i))
      rdesc%lolim(2,i) = max(rdesc%locall(2,i),rdesc%lohard(2,i))
  enddo
  !
  ! RF limits from LOLIM +- IFmax
  do i=1,rdesc%n_rbands
    rdesc%rflim(1,i) = rdesc%lolim(1,i)-rdesc%iflim(2)
    rdesc%rflim(2,i) = rdesc%lolim(2,i)+rdesc%iflim(2)
    ! same values for limits on the requested freq (which can be anywhere in the basebands)
    rdesc%rfcallreq(1,i) = rdesc%rflim(1,i)
    rdesc%rfcallreq(2,i) = rdesc%rflim(2,i)
  enddo
  ! RF limits from LOCALL +- IFmax
  do i=1,rdesc%n_rbands
    rdesc%rfcall(1,i) = rdesc%locall(1,i)-rdesc%iflim(2)
    rdesc%rfcall(2,i) = rdesc%locall(2,i)+rdesc%iflim(2)
  enddo

  !
  rdesc%tuninggrid = .true.
  rdesc%gridbin = 500d0 ! MHz
  rdesc%gridtol = 1d0     ! MHz
  !
end subroutine rec_define_noema
!
subroutine rec_define_noema_ifproc(noemaif,error)
  use gbl_message
  use astro_interfaces, except_this=>rec_define_noema_ifproc
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! if proc characteristics
  !-----------------------------------------------------------------------
  type(correlator_input_t), intent(inout) :: noemaif !
  logical, intent(inout)        :: error
  ! local
  integer(kind=4) :: i
  ! Ifproc
  noemaif%n_ifcables = 8
  noemaif%m_usercables = 0
  noemaif%mode = ''
  noemaif%defined = .false.
  do i=1,m_ifcables
    noemaif%ifc(i)%label = ''
    noemaif%ifc(i)%iband = 0
    noemaif%ifc(i)%sb_code = 0
    noemaif%ifc(i)%bb_code = 0
    noemaif%ifc(i)%pol_code = 0
  enddo
  !
end subroutine rec_define_noema_ifproc
!
subroutine noema_reset_setup(tunecomm,noema_if,error)
  use astro_interfaces, except_this=>noema_reset_setup
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! reset noema specific parameters
  !-----------------------------------------------------------------------
  type(noema_tuning_comm_t), intent(inout) :: tunecomm
  type(noema_if_t), intent(inout) :: noema_if
  logical, intent(inout)        :: error
  ! Local
  integer(kind=4) :: i
  !
  !Command parameters
  tunecomm%dotune=.false.
  tunecomm%frest = 0
  tunecomm%fcent = 0
  tunecomm%zoommode = ''
  tunecomm%fz1 = 0
  tunecomm%fz2 = 0
  tunecomm%fixed_scale = .false. 
  !
  !IF PROCESSOR
  noema_if%ifproc%mode = ''
  noema_if%ifproc%defined = .false.
  do i=1,m_ifcables
    noema_if%ifproc%ifc(i)%label = ''
    noema_if%ifproc%ifc(i)%iband = 0
    noema_if%ifproc%ifc(i)%sb_code = 0
    noema_if%ifproc%ifc(i)%bb_code = 0
    noema_if%ifproc%ifc(i)%pol_code = 0
  enddo
  !
  !Baseband selection
  noema_if%selunit%n_ifsel=-1
  noema_if%selunit%polmode='NULL'
  do i=1,m_backunits
    noema_if%selunit%usel(i)=-1
  enddo
  !
end subroutine noema_reset_setup
!
subroutine rec_noema(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>rec_noema
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Command to define and visualize NOEMA receiver coverage
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='TUNING'
  integer(kind=4),parameter :: optzoom=1 ! option /ZOOM
  integer(kind=4),parameter :: optpagewidth=2 ! option /PAGEWIDTH
  integer(kind=4),parameter :: optfixfreq=3 ! option /FIXED_FREQ
  integer(kind=4),parameter :: optinfo=4 ! option /INFO
  integer(kind=4) :: lpar,izoom
  integer(kind=4), parameter :: m_zmodes=2
  integer(kind=4), parameter :: marg=3
  real(kind=8) :: fcomm
  character(len=20) ::  zmodes(m_zmodes),zmode
  logical :: noarg,doinfo,doauto
  integer(kind=4) :: it
  data zmodes/'ID','BOTH'/
  !
  error = .false.
  !
  if (obsname.ne.'NOEMA') then
    call astro_message(seve%e,rname,'Inconsistency between Receiver Name and Observatory')
    error = .true.
    return
  endif
  !
  !Define receiver parameters
  call astro_def_receiver(rname,'NOEMA',noema%recdesc,error)
  if (error) return
  !Define ifproc parameters
  call rec_define_noema_ifproc(noema%cfebe%i_f%ifproc,error)
  if (error) return
  !Define backend parameters


  ! Put in memory the current ASTRO%SOURCE parameters
  noema%recdesc%redshift = .true. ! tuning takes into accound source redshift
  call astro_def_recsource(rname,noema%recdesc,noema%source,error)
  if (error) return
  !
  !Print Receiver info in the terminal
  doinfo=sic_present(optinfo,0)
  !
  !Decoding Line Command
  ! Tuning parameters
  zmode='ID'
  izoom=0
  it=0
  noema%cfebe%tune%dotune=.false.
  doauto=.false.
  if (sic_narg(0).gt.marg) then
    call astro_message(seve%e,rname,'Too many arguments')
    error=.true.
    return
  else  if (sic_narg(0).eq.0) then
    noarg=.true.
    call astro_message(seve%i,rname,'Showing the coverage of NOEMA receiver bands')
  else
    noarg=.false.
    call astro_message(seve%i,rname,'Resetting previous tuning and FEBES')
    ! define polyfix
    call noema_define_pfx(noema%cfebe%pfx,error)
    if (error) return
    call noema_reset_backend(noema%cfebe%pfx,noema%cfebe%spw%out,error)
    if (error) return
    call noema_reset_setup(noema%cfebe%tune,noema%cfebe%i_f,error)
    if (error) return
    call noema_reset_febe_info(noema%cfebe%uinfo,error)
    if (error) return
    it=1 ! to be removed with reorgnization
    noema%cfebe%tune%dotune=.true.
    noema%cfebe%tune%name=''
    ! Get the user value
    call sic_r8(line,0,1,fcomm,.true.,error)
    if (error) return
    ! Convert input freq to rest
    call rec_inputtorest(rname,fcomm,freq_axis%main,noema%source,noema%cfebe%tune%frest,error)
    if (error) return
    if (sic_narg(0).eq.marg) then
      ! full command
      call sic_ke (line,0,2,noema%cfebe%tune%sideband,lpar,.true.,error)
      if (error) return
      call sic_r8(line,0,3,noema%cfebe%tune%fcent,.true.,error)
      if (error) return
    else  if (sic_narg(0).eq.2) then
      call astro_message(seve%e,rname,'Mode not implemented. Command accepts 0,1 or 3 arguments')
      error=.true.
      return
    else 
      ! use default tuning
      doauto=.true.
    endif
  endif
  ! Options
  ! Zoom parameter
  if (sic_present(optzoom,0)) then
    if (sic_narg(optzoom).eq.0) then
      ! No arg = zoom on tuned band
      if (.not.noema%cfebe%tune%dotune) then
        call astro_message(seve%e,rname,'Try to zoom on a not tune band')
        error = .true.
        return
      endif
      zmode='SINGLE'
      izoom=1
    else if (sic_narg(optzoom).eq.2) then
      ! Freq limits explicitely given
      zmode='FREQ'
      call sic_r8(line,optzoom,1,fcomm,.true.,error)
      if (error) return
      fcomm=fcomm*mhzperghz
      call rec_inputtorest(rname,fcomm,freq_axis%main,noema%source,noema%cfebe%tune%fz1,error)
      if (error) return
      call sic_r8(line,optzoom,2,fcomm,.true.,error)
      if (error) return
      fcomm=fcomm*mhzperghz
      call rec_inputtorest(rname,fcomm,freq_axis%main,noema%source,noema%cfebe%tune%fz2,error)
        if (error) return
    else
      call astro_message(seve%e,rname,'/ZOOM option accepts 0 or 2 arguments')
      error = .true.
      return
    endif  
  endif
  ! /pagewidth option
  if (sic_present(optpagewidth,0)) then
    noema%cfebe%tune%fixed_scale = .false.
  else
    noema%cfebe%tune%fixed_scale = .true.
  endif
  !
  ! /fixed_freq option
  if (sic_present(optfixfreq,0)) then
    noema%cfebe%tune%fixedfreq = .true.
  else
    noema%cfebe%tune%fixedfreq = .false.
  endif
  !
  if (doauto) then
    call noema_default_tuning(rname,noema%recdesc,noema%source%dopshift,noema%cfebe%tune,error)
    if (error) return
  endif
  !Prepare for the plot and tune  
  if (noema%cfebe%tune%dotune) then
    call noema_setup(rname,noema%cfebe%tune,noema%cfebe%reccomm,noema%recdesc,noema%source, &
                      noema%cfebe%rectune,error)
    if (error) return
    noema%cfebe%defined=.true.
  endif  
  !
  if (zmode.eq.'ID') then
    call rec_plot_mbands(noema%recdesc,noema%source, &
                        molecules,noema%cfebe%tune%fixed_scale,cplot,freq_axis,error)
    if (error) return
    if (noema%cfebe%defined) then
      call rec_plot_tuned(noema%recdesc,noema%source,noema%cfebe%rectune, &
                      molecules,cplot,freq_axis,error)
      if (error) return
    endif
  else if (zmode.eq.'SINGLE') then
    if (izoom.le.0.or.(.not.noema%cfebe%tune%dotune)) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_sidebands(noema%recdesc,noema%source,noema%cfebe%rectune, &
                            cplot,molecules,freq_axis,error)
    if (error) return
  else if (zmode.eq.'FREQ') then
    call rec_zoom(molecules,noema%cfebe%tune%fz1,noema%cfebe%tune%fz2, &
                      noema%recdesc,noema%source,cplot,freq_axis,error)
    if (error) return
    
    if (noema%cfebe%defined) then
      call rec_plot_tuned(noema%recdesc,noema%source,noema%cfebe%rectune, &
                      molecules,cplot,freq_axis,error)
      if (error) return
    endif
  endif
  !
  if (noarg) then
    ! if no tuning was entered, reset the rec%n_tuning to 0
    ! like this ifproc/backend command will not work (need at least 1 tuning)
    noema%cfebe%defined=.false.
  else
    ! define if ranges transported
    call noema_ifproc(rname,noema%recdesc,noema%cfebe%rectune,noema%cfebe%i_f%ifproc,error)
    if (error) return
    ! Update the plot
    call noema_ifproc_plot(rname,noema%cfebe%tune%fixed_scale,noema%cfebe%i_f,molecules, &
          noema%recdesc,noema%source,noema%cfebe%rectune,cplot,freq_axis,error)
    if (error) return
    ! Assign IF "cables" to correlator units [only input, no mode yet]
    noema%cfebe%spw%comm%itype=-1
    if (error) return
    call noema_assign_units(rname,noema%cfebe%i_f%ifproc,noema%cfebe%pfx,noema%recdesc,error)
    if (error) return
  endif
  !
  if (doinfo) then
    call astro_receiver_info(noema%recdesc,rname,error)
    if (error) return
  endif
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  call gtview('U')
  !
end subroutine rec_noema
!
subroutine noema_default_tuning(rname,rdesc,sdopshift,ncomm,error)
  use gbl_message
  use astro_interfaces, except_this=>noema_default_tuning
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! Find default tuning parameters for NOEMA receiver
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_desc_t), intent(in) :: rdesc   ! all receiver info
  real(kind=8), intent(in)      :: sdopshift
  type(noema_tuning_comm_t), intent(inout) :: ncomm ! command-related stuff
  logical, intent(inout)        :: error
  ! Local
  integer(kind=4)       :: iband,sbcode
  real(kind=8)          :: frf,fumin,limit(2)
  real(kind=8), parameter :: ifmargin=600d0 !to avoid placing the requested freq too close to the band edge
  !
  !
  ! Find Band
  frf = ncomm%frest*sdopshift*mhzperghz
  call rec_find_band(rname,rdesc,frf,iband,error)
  if (error) return
  !Check whether the requested frequency is in the call for proposal limits 
  ! and chose the right LO range to consider
  if (frf.ge.rdesc%rfcall(1,iband)+ifmargin.and.frf.le.rdesc%rfcall(2,iband)-ifmargin) then
    limit(1) = rdesc%locall(1,iband)
    limit(2) = rdesc%locall(2,iband)
  else
    limit(1) = rdesc%lohard(1,iband)
    limit(2) = rdesc%lohard(2,iband)
  endif
  !
  !Find SideBand
  fumin=rdesc%locall(1,iband)+rdesc%iflim(1)+rdesc%ifband/4d0
  !Choose to switch from LSB to USB at the center of the band
  sbcode=usb_code
  if (frf.lt.fumin) then
    sbcode=lsb_code
  endif
  ncomm%sideband=sideband(sbcode)
  !
  !Find FIF
  ncomm%fcent=rdesc%bbref(2) ! Inner baseband by default
  ! Check band edge
  ! LSB case
  if (sbcode.eq.lsb_code) then
    if ((frf+ncomm%fcent).lt.limit(1)) then
      ncomm%fcent=limit(1)-frf
    else if ((frf+ncomm%fcent).gt.limit(2)) then
      ncomm%fcent=limit(2)-frf
    endif
  ! USB case
  else if (sbcode.eq.usb_code) then
    if ((frf-ncomm%fcent).lt.limit(1)) then
      ncomm%fcent=frf-limit(1)
    else if ((frf-ncomm%fcent).gt.limit(2)) then
      ncomm%fcent=frf-limit(2)
    endif
  endif
  !
end subroutine noema_default_tuning
!
subroutine rec_noema_online(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>rec_noema_online
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! ASTRO implementation of the tuning command in OBS\LINE
  ! Decode the line and fill noematune structure used as input for true tuning routines
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*),parameter :: rname='LINE'
  integer(kind=4), parameter :: optrec=1        ! /RECEIVER option
  integer(kind=4) :: inputrec,izoom,lname
  character(len=128) :: mess
  ! taken form obs:
  logical :: sideband_entered,fcent_entered
  integer :: ipar,lpar,harm
  real(kind=8) :: fcent,tmpnum
  character(len=12) :: par
  character(len=4) :: band
  !
  error = .false.
  !
  if (obsname.ne.'NOEMA') then
    call astro_message(seve%e,rname,'Inconsistency between Receiver Name and Observatory')
    error = .true.
    return
  endif
  !
  !Define receiver parameters
  call astro_def_receiver(rname,'NOEMA',noema%recdesc,error)
  if (error) return
  !Define ifproc parameters
  call rec_define_noema_ifproc(noema%cfebe%i_f%ifproc,error)
  if (error) return
  ! Put in memory the current ASTRO%SOURCE parameters
  noema%recdesc%redshift=.false.           ! source redshift not taken into account
  call astro_def_recsource(rname,noema%recdesc,noema%source,error)
  if (error) return
  ! Warning in redshift because line does not handle this
  if (noema%source%sourcetype.ne.soukind_none.and.noema%source%z.ne.0) then
    call astro_message(seve%e,rname,'LINE command does not take into account source redshift')
    call astro_message(seve%e,rname,'Change your source and try again')
    error=.true.
    return
  endif
  !
  ! Defaults for some parameters in the NOEMA_OBS case:
  call noema_reset_setup(noema%cfebe%tune,noema%cfebe%i_f,error)
  if (error) return
  noema%cfebe%tune%dotune=.true.
  noema%cfebe%tune%fixedfreq=.true.           ! no concept of tuning grid in OBS
  noema%cfebe%tune%zoommode='SINGLE'
  izoom=1
  !
  ! Now parse the command line
  ! Line name
  call sic_ch(line,0,1,noema%cfebe%tune%name,lname,.true.,error)
  if (error) return
  ! Frequency
  call sic_r8(line,0,2,noema%cfebe%tune%frest,.true.,error)
  if (error) return
  !Option /RECEIVER
  inputrec=0
  call sic_i4(line,optrec,1,inputrec,.false.,error)
  if (error) return
  !
  noema%cfebe%tune%sideband='USB '
  noema%cfebe%tune%fcent=noema%recdesc%bbref(2) !center of inner baseband
  ! OBS variables - some will not be used but must be parsed
  harm = 0
  sideband_entered = .false.
  fcent_entered =  .false.
  do ipar=3,sic_narg(0)
    call sic_ke(line,0,ipar,par,lpar,.true.,error)
    if (error) return
    !
    if (par(1:1).eq.'H') then
      !
      ! HIGH
      call astro_message(seve%w,rname,  &
            'LOCK LOW|HIGH is not an input parameter anymore')
      !
    elseif (par(1:1).eq.'L') then
      !
      ! LOW
      if (lpar.ge.2.and.par(1:2).eq.'LO') then
          call astro_message(seve%w,rname, &
              'LOCK LOW|HIGH is not an input parameter anymore')
          cycle
      endif
      !
      ! LSB
      if (sideband_entered) then
        call astro_message(seve%e,rname,'Ambiguous entries: LSB or USB?')
        error = .true.
        return
      endif
! TO BE CHECKED AFTER TUNING (LIKE /RECE and found rec)
!         if (band(1:1).eq.'U') then
!            call astro_message(seve%w,rname,'Default tuning (USB) forced to LSB')
!         endif
      band = 'LSB '
      sideband_entered = .true.
      !
    elseif (par(1:1).eq.'U') then
       !
       ! USB
      if (sideband_entered) then
        call astro_message(seve%e,rname,'Ambiguous entries: LSB or USB?')
        error = .true.
        return
      endif
!         if (band(1:1).eq.'L') then
!            call astro_message(seve%w,rname,'Default tuning (LSB) forced to USB')
!         endif
      band = 'USB '
      sideband_entered = .true.
        !
    else
      ! A number...
      call sic_math_dble (par,lpar,tmpnum,error)
      if (error) then
        write (mess,'(a,1x,a)') 'Error decoding input:',par(1:lpar)
        call astro_message(seve%e,rname,mess)
        error=.true.
        return
      endif
      if (tmpnum.gt.noema%recdesc%iflim(1).and.tmpnum.lt.noema%recdesc%iflim(2)) then
        if (fcent_entered) then
          call astro_message(seve%e,rname,'IF center frequency already entered')
          error = .true.
          return
        else
          ! Fcent in MHz
          fcent = tmpnum
          fcent_entered = .true.
        endif
      elseif (tmpnum.ge.32 .and. tmpnum.le.70) then
        ! Harmonic number - old system  (<2010)
        call astro_message(seve%e,rname,'Invalid harmonic number 1')
        error = .true.
        return
      elseif (tmpnum.ge.5 .and. tmpnum.le.9) then
        ! Harmonic number - new system  (>2010)
        harm = tmpnum
      else
        write (mess,'(a,1x,a)') 'Error decoding input:',par(1:lpar)
        call astro_message(seve%e,rname,mess)
        error=.true.
        return
      endif
    endif
  enddo
  if (sideband_entered) then
    noema%cfebe%tune%sideband=band
  endif
  if (fcent_entered) then
    noema%cfebe%tune%fcent=fcent
  endif
  !
  !Do the tuning
  call noema_setup(rname,noema%cfebe%tune,noema%cfebe%reccomm,noema%recdesc, &
                  noema%source,noema%cfebe%rectune,error)
  if (error) return
  noema%cfebe%defined=.true.
  !
  !Check that receiver band is OK with /RECEIVER option
  if (inputrec.ne.0.and.inputrec.ne.noema%cfebe%rectune%iband) then
    call astro_message(seve%e,rname,'Frequency/ReceiverBand mismatch:')
    write (mess,'(f0.3,1x,a,1x,i0)') noema%cfebe%tune%frest,'is not in Band',inputrec
    call astro_message(seve%e,rname,mess)
    error=.true.
    return
  endif
  !
  ! Now the plotting
  !
  if (noema%cfebe%tune%zoommode.eq.'SINGLE') then
    if (izoom.le.0.or.(.not.noema%cfebe%tune%dotune)) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_sidebands(noema%recdesc,noema%source,noema%cfebe%rectune, &
                            cplot,molecules,freq_axis,error)
    if (error) return
  else 
    call astro_message(seve%e,rname,'Plot mode not understood')
    error = .true.
    return
  endif
  !
  ! IF transport
  ! define if ranges transported
  call noema_ifproc(rname,noema%recdesc,noema%CFEBE%rectune,noema%CFEBE%i_f%ifproc,error)
  if (error) return
  ! Update the plot
  call noema_ifproc_plot(rname,noema%CFEBE%tune%fixed_scale,noema%CFEBE%i_f,molecules, &
          noema%recdesc,noema%source,noema%CFEBE%rectune,cplot,freq_axis,error)
  if (error) return
  ! define polyfix and assign if "cables" to correlator units [only input, no mode yet]
  call noema_define_pfx(noema%cfebe%pfx,error)
  if (error) return
  call noema_reset_backend(noema%cfebe%pfx,noema%cfebe%spw%out,error)
  if (error) return
  noema%cfebe%spw%comm%itype=-1
  call noema_assign_units(rname,noema%cfebe%i_f%ifproc,noema%cfebe%pfx,noema%recdesc,error)
  if (error) return
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine rec_noema_online
!
subroutine noema_setup(rname,noematune,rcomm,rdesc,rsou,rtune,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_setup
  use astro_types
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Check feasability and tune noema requested bands
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(noema_tuning_comm_t), intent(inout) :: noematune !command line parameters
  type(receiver_desc_t), intent(in) :: rdesc ! receiver description and tuning
  type(receiver_comm_t), intent(inout) :: rcomm ! receiver description and tuning
  type(receiver_source_t), intent(in) :: rsou ! receiver description and tuning
  type(receiver_tune_t), intent(inout) :: rtune ! receiver description and tuning
  logical, intent(inout)        :: error
  ! Local
  logical       :: ongrid,bandedge
  type(receiver_comm_t) :: gridcomm
  real(kind=8)  :: newfcent,ftune
  character(len=200) :: mess
  !
  rcomm%rec_name = 'NOEMA'
  rcomm%frest = noematune%frest
  call sic_upper(noematune%sideband)
  if (noematune%sideband(1:1).eq.'U') then
    rcomm%sideband = 'USB'
  else if (noematune%sideband(1:1).eq.'L') then
    rcomm%sideband = 'LSB'
  else
    call astro_message(seve%e,rname,'Problem decoding tuning sideband code (LSB or USB)')
    error = .true.
    return
  endif
  rcomm%fcent = noematune%fcent
  rcomm%name = noematune%name
  ! tune the bands
  call rec_resttooutput(rname,noematune%frest,freq_axis%main,rsou,ftune,error)
  if (error) return
  if (noematune%fixedfreq) then
    ! ignore the grid
    rtune%ongrid=.false.
    call astro_tune_receiver(rname,rdesc,rsou,rcomm,rtune,error)
    if (error) return
  else ! we shift the tuning to the grid
    ongrid = .false.
    bandedge = .false.
    gridcomm = rcomm
    do while (.not.ongrid.and..not.bandedge)
      call astro_tune_receiver(rname,rdesc,rsou,gridcomm,rtune,error)
      if (error) return
      write(mess,'(a,f10.5,a)') ' FLOTUNE = ',rtune%flotune*ghzpermhz,' GHz'
      call astro_message(seve%i,rname,mess)
      call astro_tunegrid(rname,rdesc,rtune,rsou, &
                          bandedge,ongrid,newfcent,error)
      if (error) return
      gridcomm%fcent = newfcent
    enddo
    rtune%ongrid=ongrid
  endif
  !
end subroutine noema_setup
!
subroutine astro_tunegrid(rname,rdesc,rtune,rsou,bandedge,ongrid,newfcent,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_tunegrid
  use astro_types
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Check that LO is on the tuning grid, propose the right if freq
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_desc_t), intent(in) :: rdesc ! receiver description 
  type(receiver_tune_t), intent(in) :: rtune ! receiver tuning
  type(receiver_source_t), intent(in) :: rsou ! receiver tuning
  logical, intent(inout)            :: bandedge
  logical, intent(inout)            :: ongrid
  real(kind=8), intent(inout)       :: newfcent
  logical, intent(inout)        :: error
  character(len=32) :: cname
  ! Local
  real(kind=8)  :: fgrid,foutput
  character(len=200) :: mess
  !
  fgrid = nint(rtune%flotune/rdesc%gridbin)*rdesc%gridbin
  if ((fgrid.lt.rdesc%locall(1,rtune%iband).and.rtune%flotune.ge.rdesc%locall(1,rtune%iband)) &
       .or.(fgrid.gt.rdesc%locall(2,rtune%iband).and.rtune%flotune.le.rdesc%locall(2,rtune%iband)) &
       .or.(fgrid.lt.rdesc%lohard(1,rtune%iband).or.fgrid.gt.rdesc%locall(2,rtune%iband))) then
    ! don't shift to the grid if this push the LO out of the recommended or possible ranges
    bandedge=.true.
    newfcent = rtune%fcent
    call astro_message(seve%i,rname,'Tuning close to band edge. Not shifted to the grid')
    return
  endif
  if (abs(fgrid-rtune%flotune).lt.rdesc%gridtol) then
    ! Tuning is on the grid
    newfcent = rtune%fcent
    ongrid = .true.
    return
  endif
  ! Compute new IF freq to be on the tuning grid
  call astro_message(seve%i,rname,'Original tuning does not match the grid')
  newfcent = (rtune%flsr-fgrid)/sb_sign(rtune%sb_code)
  ! Check that new IF stays in the IF range
  if (newfcent.lt.rdesc%iflim(1).or.newfcent.gt.rdesc%iflim(2)) then
    ! Too close to band edge to move
    bandedge=.true.
    newfcent = rtune%fcent
  endif
  ! Write information
  write(mess,'(a,f0.3,a)') 'Tuning automatically shifted to the IF Frequency = ',newfcent,' MHz'
  call astro_message(seve%i,rname,mess)
  write(mess,'(a,f0.3,a)') 'This corresponds to a shift of ',abs(rtune%fcent-newfcent),' MHz'
  call astro_message(seve%i,rname,mess)
  call astro_message(seve%i,rname,'Actual command:')
  if (rname.eq.'NEWVEL') then
    cname='TUNING'
  else
    cname=rname
  endif
  call rec_resttooutput(rname,rtune%frest,freq_axis%main,rsou,foutput,error)
  if (error) return
  write (mess,'(a,1x,f0.3,1x,a,1x,f0.3)') trim(cname),foutput/1d3,sideband(rtune%sb_code),newfcent
  call astro_message(seve%r,rname,mess)
  !
end subroutine astro_tunegrid
!
subroutine noema_ifproc(rname,rdesc,rtune,ifproc,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_ifproc
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! define the basebands brought to the backends
  ! no flxibility with noema for the time being
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_desc_t), intent(inout) :: rdesc
  type(receiver_tune_t), intent(inout) :: rtune
  type(correlator_input_t), intent(inout) :: ifproc
  logical, intent(inout)        :: error
  ! local
  integer(kind=4)       :: is,ip,icable
  integer(kind=4)       :: polcode(rdesc%n_polar),sb_code(rdesc%n_sbands)
  character(len=200)    :: comm
  !
  polcode(1) = hpol_code
  polcode(2) = vpol_code
  !
  icable = 0
  do ip = 1,rdesc%n_polar
    if (rdesc%n_sbands.eq.2) then
      sb_code(1) = lsb_code !lsb first to match the agreement about ordering (VP 2017)
      sb_code(2) = usb_code
    else if (rdesc%n_sbands.eq.1) then
      sb_code(1) = rtune%sb_code
    else
      call astro_message(seve%e,rname,'Problem with number of sidebands')
      error = .true.
      return
    endif
    do is = 1,rdesc%n_sbands
      icable = icable+1
      if (icable.gt.ifproc%n_ifcables) then
        call astro_message(seve%e,rname,'More IF than available cables')
        error=.true.
        return
      endif
      ifproc%ifc(icable)%iband = rtune%iband
      ifproc%ifc(icable)%sb_code = sb_code(is)
      ifproc%ifc(icable)%pol_code = polcode(ip)
      write (ifproc%ifc(icable)%label,'(a,i0,a,a,a)')                 &
              rdesc%bandname(rtune%iband)(1:1),                   &
              rtune%iband,rdesc%polname(ip)(1:1),                 &
              sideband(sb_code(is))(1:1)
    enddo ! sidebands
  enddo ! polar
  !
  ifproc%defined = .true.
  !
  do icable=1,ifproc%n_ifcables
    write (comm,'(a,1x,i0,1x,a,1x,a)') 'Correlator input #',icable,'contains',ifproc%ifc(icable)%label
    call astro_message(seve%d,rname,comm)
  enddo
  !
end subroutine noema_ifproc
!
subroutine noema_ifproc_plot(rname,fixed_scale,noema_if,molecules,rdesc,rsou,rtune,cplot,drawaxis,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_ifproc_plot
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! identifies the correlator inputs on the plot
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  logical, intent(in) :: fixed_scale
  type(noema_if_t), intent(in) :: noema_if
  type(plot_molecules_t), intent(in) :: molecules
  type(receiver_desc_t), intent(inout) :: rdesc
  type(receiver_source_t), intent(inout) :: rsou
  type(receiver_tune_t), intent(inout) :: rtune
  type(current_boxes_t), intent(inout) :: cplot
  type(frequency_axis_t), intent(in) :: drawaxis
  logical, intent(inout) :: error
  ! local
  integer(kind=4) :: i,k,sb_code(m_sideband),ip,ib,ic
  character(len=200) :: comm,defchar,smallchar,molchar
  character(len=5) :: cablecode
  real(kind=8) :: fif1,frf,frest,yt,l1,l2,l3,l4,b1,b2,b3,b4
  type(draw_line_t)     :: linebb
  !
  sb_code(1) = usb_code
  sb_code(2) = lsb_code
  !
  write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%defchar
  write (smallchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%smallchar
  write (molchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%molchar
  !
  call gr_exec1(defchar)
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  !
  write (comm,'(a)') 'CHANGE DIRECTORY'
  call gr_execl(comm)
  if (gtexist('IFPROC')) then
    write (comm,'(a)') 'DESTROY DIRECTORY IFPROC'
    call gr_execl(comm)
  endif
  write (comm,'(a)') 'CREATE DIRECTORY IFPROC'
  call gr_execl(comm)
  do i=1,cplot%nbox
    write (comm,'(a,i0)') 'CHANGE DIRECTORY <GREG<BOX',i
    call gr_execl(comm)
    l1 = cplot%box(i)%rest%xmin
    l2 = cplot%box(i)%rest%xmax
    l3 = cplot%box(i)%rest%ymin
    l4 = cplot%box(i)%rest%ymax
    b1 = cplot%box(i)%phys%xmin
    b2 = cplot%box(i)%phys%xmax
    b3 = cplot%box(i)%phys%ymin
    b4 = cplot%box(i)%phys%ymax
    write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
    write (comm,'(a)') 'CHANGE DIRECTORY IFPROC'
    call gr_execl(comm)
    write (comm,'(a,4(1x,f0.3))') 'SET BOX_LOCATION',b1,b2,b3,b4
    call gr_exec1(comm)
    write (comm,'(a,4(1x,f0.3))') 'LIMITS',l1,l2,l3,l4
    call gr_exec1(comm)
    if (rtune%iband.ne.cplot%box(i)%iband) cycle
    do k=1,rdesc%n_sbands
        do ib=1,rdesc%n_bbands
          do ip=1,rdesc%n_polar
            write (cablecode,'(a,i0,a,a,a,a)') rdesc%bandname(rtune%iband)(1:1),            &
                rtune%iband,rdesc%polname(ip)(1:1),sideband(sb_code(k))(1:1),rdesc%bbname(ib)(1:1)
            do ic=1,noema_if%ifproc%n_ifcables
              if (noema_if%ifproc%ifc(ic)%label.ne.cablecode(1:4)) cycle
              fif1 = (rdesc%bblim(2,ib)+rdesc%bblim(1,ib))/2d0
              yt = l3+((l4-l3)/6)*ip
              call if1torf(rtune%flo1,fif1,sb_code(k),frf,error)
              if (error) return
              call rftorest(rsou%dopshift,frf,frest,error)
              if (error) return
              call gr_pen(colour=abbifproccol,error=error)
              if (error) return
              call gr_exec1(smallchar)
              write (comm,'(a,1x,f0.6,1x,f0.3,1x,a,a,1x,a)')               &
                'DRAW TEXT',frest,yt,'"',trim(cablecode),'" 5 0 /USER /CLIP'
              call gr_exec1(comm)
              call gr_exec(defchar)
              call noema_draw_confusion(rname,rdesc,rtune%flo1,rsou%dopshift, &
                                        ib,sb_code(k),cplot%box(i)%rest,cplot%desc,error)
              if (error) return
              call gr_pen(colour=adefcol,error=error)
              if (error) return
              !draw the limit of the baseband
              call if1torf(rtune%flo1,rdesc%bblim(1,ib),sb_code(k),frf,error)
              if (error) return
              call rftorest(rsou%dopshift,frf,linebb%xmin,error)
              if (error) return
              call if1torf(rtune%flo1,rdesc%bblim(2,ib),sb_code(k),frf,error)
              if (error) return
              call rftorest(rsou%dopshift,frf,linebb%xmax,error)
              if (error) return
              linebb%ymin = cplot%box(i)%rest%ymin+(cplot%box(i)%rest%ymax-cplot%box(i)%rest%ymin)/10
              linebb%ymax = linebb%ymin
              linebb%col   = abbifproccol
              linebb%dash  = 1
              call gr_exec1(smallchar)
              call rec_draw_arrow(linebb,cplot%box(i)%rest,error)
              if (error) return
              call gr_exec1(defchar)
              frest = linebb%xmin
              linebb%xmin = linebb%xmax
              linebb%xmax = frest
              call rec_draw_arrow(linebb,cplot%box(i)%rest,error)
              if (error) return
              call gr_pen(colour=adefcol,error=error)
              if (error) return
              call gr_exec1(defchar)
            enddo ! cable
          enddo ! polar
          !
        enddo !baseband
!        endif
    enddo !sideband
    !plot again molecules
    call gr_exec1(molchar)
    call rec_draw_molecules(molecules,cplot%box(i)%rest,error)
    if (error) return
    call gr_exec1(defchar)
    ! plot tuning frequency
    call rec_draw_linetune(rtune,cplot%box(i)%rest,error)
    if (error) return
    !
      write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
    write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
  enddo ! boxes
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  !
end subroutine noema_ifproc_plot
!
subroutine noema_draw_confusion(rname,rdesc,flo1,sdop,bb_code,sb_code,fbox,cpdesc,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_draw_confusion
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! identifies the confusion zone of NOEMA
  ! S18 version: only the 10MHz of the LO2 parasite
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_desc_t), intent(in) :: rdesc
  real(kind=8), intent(in)   :: flo1
  real(kind=8), intent(in)   :: sdop
  integer(kind=4), intent(in)   :: bb_code
  integer(kind=4), intent(in)   :: sb_code
  type(frequency_box_user_t), intent(in) :: fbox ! must be rest
  type(current_boxes_desc_t), intent(in) :: cpdesc 
  logical, intent(inout) :: error
  ! Local
  real(kind=8)  :: frf,xt,yt
  type(draw_rect_t) :: confrect
  character(len=200) :: comm,smallchar,defchar
  integer(kind=4) :: iplotmode,ipos
  !
  iplotmode=cpdesc%plotmode
  !Compute Confusion zone in rest frame to draw rectangle
  call if1torf(flo1,rdesc%if1conf(1),sb_code,frf,error)
  if (error) return
  call rftorest(sdop,frf,confrect%xmin,error)
  if (error) return
  call if1torf(flo1,rdesc%if1conf(2),sb_code,frf,error)
  if (error) return
  call rftorest(sdop,frf,confrect%xmax,error)
  if (error) return
  confrect%ymin = fbox%ymin
  confrect%ymax = fbox%ymax
  confrect%col=aconfucol
  ! Draw rectangle
  call gr_pen(colour=aconfucol,error=error)
  if (error) return
  call rec_draw_frect(confrect,fbox,error)
  if (error) return
  ! Write label (depends on plotmode)
  write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cpdesc%defchar
  write (smallchar,'(a,1x,f0.3)') 'SET CHARACTER',cpdesc%smallchar
  !
  call gr_exec1(smallchar)
  if (iplotmode.eq.pm_basebands) then
    if (sb_code.eq.lsb_code.and.bb_code.eq.outer_code) ipos = 3
    if (sb_code.eq.lsb_code.and.bb_code.eq.inner_code) ipos = 1
    if (sb_code.eq.usb_code.and.bb_code.eq.inner_code) ipos = 3
    if (sb_code.eq.usb_code.and.bb_code.eq.outer_code) ipos = 1
    write (comm,'(a,1x,i0)') 'DRAW TEXT 0 -0.5 "LO2" 5 0 /character',ipos
    call gr_exec1(comm)
  else if (iplotmode.eq.pm_receiver) then
    write (comm,'(a)') 'DRAW TEXT 0 -0.75 "LO2" 5 0 /character 2'
    call gr_exec1(comm)
  else if (iplotmode.eq.pm_allbands.or.iplotmode.eq.pm_tunedbands) then
    xt=(confrect%xmax+confrect%xmin)/2d0
    yt=confrect%ymin-(confrect%ymax-confrect%ymin)/20d0
    write (comm,'(a,1x,f0.3,1x,f0.3,1x,a)') 'DRAW TEXT',xt,yt,'"LO2" 5 0 /user'
    call gr_exec1(comm)
  else if (iplotmode.eq.pm_proposal) then
    if (bb_code.eq.1) then
      xt=(confrect%xmax+confrect%xmin)/2d0
      yt=confrect%ymin-(confrect%ymax-confrect%ymin)/20d0
      write (comm,'(a,1x,f0.3,1x,f0.3,1x,a)') 'DRAW TEXT',xt,yt,'"LO2" 5 0 /user'
      call gr_exec1(comm)
    endif
  else
    call astro_message(seve%e,rname,'Problem with plot mode')
    error=.true.
    return
  endif
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  call gr_exec1(defchar)
  !
end subroutine noema_draw_confusion
!
subroutine noema_baseband(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_baseband
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use string_parser_types
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Baseband and mode selection (in preparation for SPW definition)
  !
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='BASEBAND'
  integer(kind=4), parameter :: optreset=1
  integer(kind=4), parameter :: optmode=2
  character(len=200) :: mess
  type(string_parser_t) :: sp
  integer(kind=4) :: lpar,narg,selmode
  integer(kind=4) :: pol_sel,bb_sel,sb_sel,selband,isel,iu
  character(len=12) :: selcode
  character(len=argument_length) :: par
  character(len=argument_length), parameter :: mode_key="OFF"
  integer(kind=4) :: iunit
  real(kind=4) :: res1,res2,resmin,resmax
  real(kind=4), parameter :: resmed=250d0
  real(kind=4), parameter :: reslow=2000d0
  real(kind=4), parameter :: reshigh1=62.5d0
  logical       :: doreset,dopchanged,dooff,domode
  integer(kind=4), parameter :: ipband=1
  integer(kind=4), parameter :: ippol=2
  integer(kind=4), parameter :: ipsb=3
  integer(kind=4), parameter :: ipbb=4
  integer(kind=4), parameter :: nband=3
  integer(kind=4), parameter :: npol=2
  integer(kind=4), parameter :: nsb=2
  integer(kind=4), parameter :: nbb=2
  integer(kind=4)       :: parsecode(4)
  character(len=2) :: bb_band(nband)
  character(len=1) :: bb_pol(npol),bb_sb(nsb),bb_bb(nbb)
  data bb_band/'B1','B2','B3'/
  data bb_pol/'H','V'/
  data bb_sb/'U','L'/
  data bb_bb/'O','I'/
  !
  !Preliminary checks
  if (obsname.ne.'NOEMA') then
    call astro_message(seve%e,rname,'Observatory changed since last tuning - Please define a new tuning')
    error = .true.
    return
  endif
  !
  if (.not.noema%cfebe%defined) then
    call astro_message(seve%e,rname,'Please define a tuning (TUNING command) before setting up backends')
    error = .true.
    return
  endif
  if (.not.noema%cfebe%i_f%ifproc%defined) then
    call astro_message(seve%e,rname,'Problem with IF Processor part')
    error = .true.
    return
  endif
  !
  !check that doppler did not changed since last tuning
  call rec_check_doppler(noema%source,noema%recdesc%redshift,dopchanged,error)
  if (dopchanged) then
    call astro_message(seve%e,rname,'Source changed since last tuning')
    call astro_message(seve%i,rname,'You should set again the tuning before working with backends')
    call rec_display_error('Source changed since last tuning',error)
    error = .true.
    return
  endif
  !
  narg=sic_narg(0)
  doreset=sic_present(optreset,0)
  domode=sic_present(optmode,0)
  !
  noema%cfebe%i_f%selunit%n_ifsel=0
  do iu=1,m_backunits
    noema%cfebe%i_f%selunit%usel(iu)=-1
  enddo
  !
  !Read correl mode
  selmode=-1
  dooff=.false.
  if (domode) then
    call sic_ke(line,optmode,1,par,lpar,.true.,error)
    if (error) return    
    if (par(1:lpar).eq.mode_key(1:lpar)) then
      selmode=-1
      dooff=.true.
    else
      ! Mode entered through resolution
      res1=undef_freq
      res2=undef_freq
      call sic_r4(line,optmode,1,res1,.true.,error)
      if (error) return
      call sic_r4(line,optmode,2,res2,.false.,error)
      if (error) return
      if (res2.eq.undef_freq) then 
        if (res1.eq.reshigh1.or.res1.eq.reslow) then
          call astro_message(seve%w,rname,'Channel spacing is ambiguous. Please enter 2 values')
          call astro_message(seve%w,rname,'Correlator mode unchanged')
          domode=.false.
        else
          res2=res1
        endif
      endif
      !
      resmin=min(res1,res2)
      resmax=max(res1,res2)
      !
      if (resmin.eq.resmed.and.resmax.eq.resmed) then
        selmode=3
      else if (resmin.eq.reshigh1.and.resmax.eq.reslow) then
        selmode=1
      else
        call astro_message(seve%w,rname,'Channel spacing values do not match any correlator mode')
        call astro_message(seve%w,rname,'Correlator mode unchanged')
        domode=.false.
      endif        
    endif
  endif
  !Reading arguments
  selcode=''
  if (narg.gt.2) then
    call astro_message(seve%e,rname,'Too many arguments')
    error=.true.
    return
  else if (narg.eq.2) then
    ! Handle PMS syntax for first polyfix deadlines
    call astro_message(seve%w,rname,'2 Arguments syntax is obsolescent, please use /MODE option instead')
    if (sic_present(optmode,0)) then
      call astro_message(seve%w,rname,'2 arguments syntax cannot be combined with /MODE option.')
      call astro_message(seve%w,rname,'Correlator mode unchanged')
      domode=.false.
    else
      call sic_ke(line,0,1,selcode,lpar,.true.,error)
      if (error) return
      call sic_r4(line,0,2,res1,.true.,error)
      if (error) return
      if (res1.ne.reshigh1) then
        call astro_message(seve%w,rname,'Only 62.5 accepted as second argument. Use /MODE option.')
        call astro_message(seve%w,rname,'Correlator mode unchanged')
        domode=.false.
      else
        selmode=1
        domode=.true.
      endif
    endif
  else if (narg.eq.1) then
    call sic_ke(line,0,1,selcode,lpar,.true.,error)
    if (error) return
  endif 
  !
  ! Check mode selection
  if (selmode.gt.3) then
    call astro_message(seve%w,rname,'Mode not yet implemented (only modes 1 and 2)')
    call astro_message(seve%w,rname,'Correlator mode unchanged')
    domode=.false.
  endif
  !
  !Defaults codes
  pol_sel=0
  bb_sel=0
  sb_sel=0
  selband=0
  !Parse the user code
  if (len_trim(selcode).ne.0) then
    call string_parser_addlist(sp,ipband,bb_band,error)
    if (error) return
    call string_parser_addlist(sp,ippol,bb_pol,error)
    if (error) return
    call string_parser_addlist(sp,ipsb,bb_sb,error)
    if (error) return
    call string_parser_addlist(sp,ipbb,bb_bb,error)
    if (error) return
    call string_parser_parse('BASEBAND',sp,selcode,.false.,parsecode,error)
    if (error) return
  else 
    parsecode(ipband)=0
    parsecode(ippol)=0
    parsecode(ipsb)=0
    parsecode(ipbb)=0
  endif
  !
  if (parsecode(ippol).eq.0) then
    noema%cfebe%i_f%selunit%polmode = "B" ! BOTH polar same config
  else
    noema%cfebe%i_f%selunit%polmode = "S"
  endif
  !
  ! Loop over pfx%units to put the right numbers in ifsel() and define the mode when needed
  isel=0
  iunit=0
  do iu=1,noema%cfebe%pfx%n_units
    if (noema%cfebe%pfx%unit(iu)%iband.ne.parsecode(ipband).and.parsecode(ipband).ne.0) cycle
    if (noema%cfebe%pfx%unit(iu)%pol_code.ne.parsecode(ippol).and.parsecode(ippol).ne.0) cycle
    if (noema%cfebe%pfx%unit(iu)%sb_code.ne.parsecode(ipsb).and.parsecode(ipsb).ne.0) cycle
    if (noema%cfebe%pfx%unit(iu)%bb_code.ne.parsecode(ipbb).and.parsecode(ipbb).ne.0) cycle
    isel=isel+1
    noema%cfebe%i_f%selunit%usel(isel)=iu
    if (dooff.or.doreset.or.(domode.and.selmode.ne.noema%cfebe%pfx%unit(iu)%imode)) then
      write (mess,'(a,1x,i0)') 'Resetting unit ',iu
      call astro_message(seve%i,rname,mess)
      call pfx_reset_unit(noema%cfebe%pfx%unit(iu),noema%cfebe%spw%out,error)
      if (error) return
      ! Change mode when needed
      if (domode.or.dooff) noema%cfebe%pfx%unit(iu)%imode=selmode
      iunit=iu
      if (.not.dooff) then
        call pfx_fixed_spw(rname,noema%recdesc,noema%source,noema%cfebe%rectune,  &
                            noema%cfebe%pfx%unit(iu),noema%cfebe%spw,error)
        if (error) return
      endif
    endif
  enddo !iu
  if (isel.eq.0) then
    call astro_message(seve%e,rname,'The selection returns nothing')
    error = .true.
    return
  endif
  ! remove empty spw (if there was a reset)
  call noema_compress_spw(noema%cfebe%spw%out,error)
  if (error) return
  ! sort spw
  call noema_sort_spw(noema%cfebe%spw%out,error)
  if (error) return
  ! look for conflicts
  call noema_check_conflicts(rname,noema%cfebe%spw%out,noema%cfebe%pfx,error)
  if (error) return
  !
  noema%cfebe%i_f%selunit%n_ifsel=isel
  write (mess,'(a)') 'Selected Basebands are:'
  do iu=1,m_backunits
    if (noema%cfebe%i_f%selunit%usel(iu).ne.-1) then
!      write (mess,'(a,1x,a)') trim(mess),trim(noema%ifproc%ifc(noema%selunit%usel(iu))%label)
      write (mess,'(a,1x,a)') trim(mess),  &
          trim(noema%cfebe%pfx%unit(noema%cfebe%i_f%selunit%usel(iu))%label)
    endif
  enddo !iu
  call astro_message(seve%i,rname,mess)
  if (iunit.ne.0.and.selmode.gt.0) then
    call noema_pfx_mode_message(rname,noema%cfebe%pfx%unit(iunit)%mode(selmode),error)
    if (error) return
  endif
  !
  call noema_plot_selpfx(rname,noema,cplot,molecules,freq_axis,error)
  if (error) return
  !
  if (noema%source%sourcetype.eq.soukind_full) then
    call noema_oplot_dopminmax(noema,cplot,freq_axis,error)
    if (error) return
  endif
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine noema_baseband
!
subroutine noema_baseband_online(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_baseband_online
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use string_parser_types
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! online Baseband and mode selection: as done in OBS
  ! Give a mode to the PFX units
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='BASEBAND'
  type(string_parser_t) :: sp
  integer(kind=4) :: iarg,lpar,narg,ncorrmode,selmode
  integer(kind=4) :: pol_sel,bb_sel,sb_sel,selband,isel,iu,inputrec
  integer(kind=4),parameter :: m_corrmodes = 4
  character(len=12) :: par,corrmode,selcode
  character(len=12) :: corrmodes(m_corrmodes)
  character(len=200) :: mess
  integer(kind=4), parameter :: optrec=1
  logical       :: dopchanged,gotcode,gotmode,dorec
  data corrmodes/'1','2','3','OFF'/
  integer(kind=4), parameter :: ipband=1
  integer(kind=4), parameter :: ippol=2
  integer(kind=4), parameter :: ipsb=3
  integer(kind=4), parameter :: ipbb=4
  integer(kind=4), parameter :: nband=3
  integer(kind=4), parameter :: npol=2
  integer(kind=4), parameter :: nsb=2
  integer(kind=4), parameter :: nbb=2
  integer(kind=4), parameter :: m_keys=1
  integer(kind=4)       :: parsecode(4),nkey
  character(len=2) :: bb_band(nband)
  character(len=1) :: bb_pol(npol),bb_sb(nsb),bb_bb(nbb)
  character(len=1) :: keys(m_keys),key
  data keys/'*'/
  data bb_band/'B1','B2','B3'/
  data bb_pol/'H','V'/
  data bb_sb/'U','L'/
  data bb_bb/'O','I'/
  !
  !Preliminary checks
  if (obsname.ne.'NOEMA') then
    call astro_message(seve%e,rname,'Observatory changed since last tuning - Please define a new tuning')
    error = .true.
    return
  endif
  !
  if (.not.noema%cfebe%defined) then
    call astro_message(seve%e,rname,'Please define a tuning (TUNING command) before setting up backends')
    error = .true.
    return
  endif
  if (.not.noema%cfebe%i_f%ifproc%defined) then
    call astro_message(seve%e,rname,'Problem with IF Processor part')
    error = .true.
    return
  endif
  !
  !check that doppler did not changed since last tuning ! SHOULD DISAPPEAR in the FUTURE
  call rec_check_doppler(noema%source,noema%recdesc%redshift,dopchanged,error)
  if (dopchanged) then
    call astro_message(seve%e,rname,'Source changed since last tuning')
    call astro_message(seve%i,rname,'You should set again the tuning before working with backends')
    call rec_display_error('Source changed since last tuning',error)
    error = .true.
    return
  endif
  !
  narg=sic_narg(0)
  dorec=sic_present(optrec,0)
  inputrec=0
  call sic_i4(line,optrec,1,inputrec,.false.,error)
  if (error) return
  !
  !Defaults codes
  pol_sel=0
  bb_sel=0
  sb_sel=0
  selband=0
  selcode=''
  selmode=1 ! defaults is mode 1
  corrmode='1'
  do iu=1,m_backunits
    noema%cfebe%i_f%selunit%usel(iu)=-1
  enddo
  !
  ! Input checks
  if (narg.ne.2) then
    call astro_message(seve%i,rname,'BASEBAND needs 2 arguments. Current state:')
    call noema_list_pfx(rname,noema%cfebe%pfx,freq_axis%main,noema%source,error)
    if (error) return
    return
  endif
  !Reading arguments
  gotmode=.false.
  gotcode=.false.
  do iarg=1,sic_narg(0)
    call sic_ke(line,0,iarg,par,lpar,.true.,error)
    if (error) return
    ! First try to recognize a correlator mode
    call sic_ambigs_sub(rname,par,corrmode,ncorrmode,corrmodes,m_corrmodes,error)
    if (error) return
    if (ncorrmode.eq.0) then ! correlator mode not recognized
      if (gotcode) then
        call astro_message(seve%e,rname,'Selection Code already entered. Problem with correlator mode choice')
        error=.true.
        return
      endif
      call sic_ambigs_sub(rname,par,key,nkey,keys,m_keys,error)
      if (error) return
      if (nkey.eq.0) then !key '*' not recognized
        selcode=par ! parameter is thus a selection code 
      else
        selcode=''
      endif
      gotcode=.true.
    else
      ! correlator mode recognized
      if (gotmode) then
        call astro_message(seve%e,rname,'Only one mode at a once !')
        error=.true.
        return
      endif
      selmode=ncorrmode
      gotmode=.true.
    endif
  enddo
  !
  ! Check mode selection
  corrmode=corrmodes(selmode)
  if (corrmode.eq.'OFF') then
    ! OFF CASE
    selmode=-1
  else if (corrmode.eq.'2')then
    ! VLBI: nothing in ASTRO
    call astro_message(seve%e,rname,'VLBI mode not supported in ASTRO')
    error=.true.
    return
  endif
  !
  !Parse the user code
  if (len_trim(selcode).ne.0) then
    call string_parser_addlist(sp,ipband,bb_band,error)
    if (error) return
    call string_parser_addlist(sp,ippol,bb_pol,error)
    if (error) return
    call string_parser_addlist(sp,ipsb,bb_sb,error)
    if (error) return
    call string_parser_addlist(sp,ipbb,bb_bb,error)
    if (error) return
    call string_parser_parse('BASEBAND',sp,selcode,.false.,parsecode,error)
    if (error) return
  else 
    parsecode(ipband)=0
    parsecode(ippol)=0
    parsecode(ipsb)=0
    parsecode(ipbb)=0
  endif
  !
  ! Case with /RECEIVER option
  if (dorec) then
    if (parsecode(ipband).ne.0) then
      if (parsecode(ipband).ne.inputrec) then
        call astro_message(seve%e,rname,'Inconsistency in Band selection')
        error=.true.
        return
      endif
    else if (parsecode(ipband).eq.0) then
      ! use the option input instead of the code
      parsecode(ipband)=inputrec
    endif
  endif
  !
  ! Loop over pfx%units to put the right numbers in ifsel() and define the mode when needed
  isel=0
  do iu=1,noema%cfebe%pfx%n_units
    if (noema%cfebe%pfx%unit(iu)%iband.ne.parsecode(ipband).and.parsecode(ipband).ne.0) cycle
    if (noema%cfebe%pfx%unit(iu)%pol_code.ne.parsecode(ippol).and.parsecode(ippol).ne.0) cycle
    if (noema%cfebe%pfx%unit(iu)%sb_code.ne.parsecode(ipsb).and.parsecode(ipsb).ne.0) cycle
    if (noema%cfebe%pfx%unit(iu)%bb_code.ne.parsecode(ipbb).and.parsecode(ipbb).ne.0) cycle
    isel=isel+1
    write (mess,'(a,1x,i0)') 'Resetting unit ',iu
    call astro_message(seve%i,rname,mess)
    ! Reset unit
    call pfx_reset_unit(noema%cfebe%pfx%unit(iu),noema%cfebe%spw%out,error)
    if (error) return
    if (selmode.ne.noema%cfebe%pfx%unit(iu)%imode) then
      noema%cfebe%pfx%unit(iu)%imode=selmode
    endif
    if (selmode.ne.-1) then
      call pfx_fixed_spw(rname,noema%recdesc,noema%source,noema%cfebe%rectune, &
                          noema%cfebe%pfx%unit(iu),noema%cfebe%spw,error)
      if (error) return
    endif
  enddo !iu
  if (isel.eq.0) then
    call astro_message(seve%e,rname,'The selection returns nothing')
    error = .true.
    return
  endif
  ! remove empty spw (if there was a reset)
  call noema_compress_spw(noema%cfebe%spw%out,error)
  if (error) return
  ! sort spw
  call noema_sort_spw(noema%cfebe%spw%out,error)
  if (error) return
  ! look for conflicts
  call noema_check_conflicts(rname,noema%cfebe%spw%out,noema%cfebe%pfx,error)
  if (error) return
  !
  ! Now the plotting
  ! PLOT
  !Select all the units for the plot
  noema%cfebe%i_f%selunit%n_ifsel=noema%cfebe%pfx%n_units
  noema%cfebe%i_f%selunit%polmode='B'
  do iu=1,noema%cfebe%pfx%n_units
    noema%cfebe%i_f%selunit%usel(iu)=iu
  enddo
  !
  call noema_plot_selpfx(rname,noema,cplot,molecules,freq_axis,error)
  if (error) return
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine noema_baseband_online

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_taskloop
  use gkernel_interfaces
  use cubetools_parameters
  use cubetuple_format_class
  use cubedag_link_type
  use cubetopology_cuberegion_types
  use cube_types
  use cubeadm_messaging
  use cubeadm_entryloop
  use cubeadm_taskloop_iteration
  !
  integer(kind=code_k), parameter :: code_1entry_for_allplanes=-1
  !
  type :: cubeadm_iterator_cubedesc_t
    ! Convenient type which gathers temporarily all the cubes relevant
    ! information needed to compute the iterator.
    logical                          :: input   ! Is this an input or output cube?
    class(format_t),         pointer :: cube    ! The associated cube
    type(cuberegion_prog_t), pointer :: region  ! The associated region, if relevant
    integer(kind=code_k)             :: access  ! Iterator access mode
  end type cubeadm_iterator_cubedesc_t
  !
  type :: cubeadm_iterator_t
    ! Entries
    integer(kind=entr_k), public  :: ne          ! Total number of entries
    integer(kind=entr_k), private :: neperplane  ! Number of output entries per plane
    ! Tasks
    integer(kind=entr_k), public  :: nt          ! Total number of tasks
    ! Planes
    integer(kind=entr_k), private :: np          ! Total number of reference planes
    integer(kind=entr_k), private :: nppertask   ! Number of planes per task
    ! Current task iteration
    ! NB: this is a duplicate of taskloop_iteration_t. Ifort 13 and 18 have
    !     a bug which does not correctly duplicates sub-types components in
    !     FIRSTPRIVATE statements. No better way than duplicating the type
    !     here
    integer(kind=entr_k), public  :: num         ! This task number
    integer(kind=entr_k), public  :: ie          ! The output entry number iterated in this task
    integer(kind=entr_k), private :: ofe,ole     ! Output first/last entry to be processed by this task
    integer(kind=entr_k), public  :: prange(2)   ! Ref    first/last plane to be processed by this task
  contains
    procedure, public :: iterate_entry => cubeadm_iterator_iterate_entry
  end type cubeadm_iterator_t
  !
  public :: cubeadm_iterator_t
  public :: cubeadm_taskloop_init,cubeadm_taskloop_iterate
  private
  !
contains
  !
  subroutine cubeadm_taskloop_init(incubes,oucubes,align,region,iter,error)
    use cubedag_node_class
    !----------------------------------------------------------------------
    ! Set up the iterator suited for the input and the output cubes
    !----------------------------------------------------------------------
    type(cubedag_link_t),     intent(in)    :: incubes  ! In cube list
    type(cubedag_link_t),     intent(in)    :: oucubes  ! Out cube list
    integer(kind=code_k),     intent(in)    :: align    !
    type(cuberegion_prog_t),  pointer       :: region   !
    type(cubeadm_iterator_t), intent(out)   :: iter
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TASKLOOP>INIT'
    type(cubeadm_iterator_cubedesc_t), allocatable :: myiter(:)
    integer(kind=entr_k) :: icube,ncube
    class(format_t), pointer :: cube
    integer(kind=4) :: ier
    class(cubedag_node_object_t), pointer :: dno
    character(len=message_length) :: mess
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Compute one iterator per cube
    allocate(myiter(incubes%n+oucubes%n),stat=ier)
    if (failed_allocate(rname,'iterator',ier,error)) return
    ncube = 0
    !
    ! Input cubes
    do icube=1,incubes%n
      dno => cubedag_node_ptr(incubes%list(icube)%p,error)
      if (error) return
      cube => cubetuple_format_ptr(dno,error)
      if (error) return
      ! Skip cubes for which we won't iterate data
      if (cube%tuple%current%desc%action.eq.code_read_head)  cycle
      ! Set up an iterator suited for this cube
      ncube = ncube+1
      write(mess,'(A,I0)') '--- Computing iterator for cube #',ncube
      call cubeadm_message(admseve%others,rname,mess)
      call cubeadm_taskloop_cubedesc_fill(cube,.true.,region,myiter(ncube),error)
      if (error) return
    enddo
    !
    ! Output cubes
    do icube=1,oucubes%n
      dno => cubedag_node_ptr(oucubes%list(icube)%p,error)
      if (error) return
      cube => cubetuple_format_ptr(dno,error)
      if (error) return
      ! Set up an iterator suited for this cube
      ncube = ncube+1
      write(mess,'(A,I0)') '--- Computing iterator for cube #',ncube
      call cubeadm_message(admseve%others,rname,mess)
      call cubeadm_taskloop_cubedesc_fill(cube,.false.,null(),myiter(ncube),error)
      if (error) return
    enddo
    !
    ! Cubes consistency: number of entries must be the same or 1
    ! me = maxval(myiter(1:ncube)%ne)
    ! do icube=1,ncube
    !   if (myiter(icube)%ne.ne.1 .and. myiter(icube)%ne.ne.me) then
    !     write(mess,'(A,I0,A,I0)')  &
    !       'Iterated cubes have different number of entries: ',myiter(icube)%ne,',',me
    !     call cubeadm_message(seve%e,rname,mess)
    !     error = .true.
    !     return
    !   endif
    ! enddo
    !
    ! Compute the global iterator by merging all the individual ones
    call cubeadm_message(admseve%others,rname,'--- Computing global iterator')
    call cubeadm_taskloop_iterator_compute(myiter,ncube,align,iter,error)
    if (error) return
    call cubeadm_message(admseve%others,rname,'--- Done')
  end subroutine cubeadm_taskloop_init
  !
  subroutine cubeadm_taskloop_cubedesc_fill(cub,input,region,iter,error)
    use cubetools_access_types
    !----------------------------------------------------------------------
    ! Set up the iterator suited for a single cube.
    !----------------------------------------------------------------------
    class(format_t), target,           intent(in)    :: cub
    logical,                           intent(in)    :: input
    type(cuberegion_prog_t),           pointer       :: region
    type(cubeadm_iterator_cubedesc_t), intent(out)   :: iter
    logical,                           intent(inout) :: error
    !
    character(len=*), parameter :: rname='TASKLOOP>ITERATOR'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    iter%input  = input
    iter%cube   => cub
    iter%region => region
    !
    ! Which access?
    select case (cub%access())
    case (code_access_subset,code_access_fullset)
      iter%access = cub%access()
    case (code_access_blobset)
      call cubeadm_message(seve%e,rname,'Blob access mode is not implemented')
      error = .true.
      return
    case default
      ! Other accesses based on actual data order
      select case (cub%order())
      case (code_access_imaset)
        iter%access = code_access_imaset
      case (code_access_speset)
        iter%access = code_access_speset
      case default
        call cubeadm_message(seve%e,rname,'Unsupported access mode')
        error = .true.
        return
      end select
    end select
    call cubeadm_message(admseve%others,rname,  &
      'Cube is ordered '//cubetools_accessname(cub%order())//  &
      ' and will be iterated with access '//cubetools_accessname(iter%access))
  end subroutine cubeadm_taskloop_cubedesc_fill
  !
  subroutine cubeadm_taskloop_iterator_compute(iter,ncube,align,merged,error)
    !-------------------------------------------------------------------
    ! Merge all the iterators to produce the final iterator
    !-------------------------------------------------------------------
    integer(kind=entr_k),              intent(in)    :: ncube
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter(ncube)
    integer(kind=code_k),              intent(in)    :: align
    type(cubeadm_iterator_t),          intent(out)   :: merged
    logical,                           intent(inout) :: error
    !
    integer(kind=4) :: ref
    logical :: parallel
    real(kind=4) :: buftask
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='TASKLOOP>MERGE'
    !
    ! This subroutine is the core of the problem. It is intended to
    ! scale properly the entries and tasks, knowing all the input and
    ! output cubes. The main goal is to compute the number of planes
    ! per task, which must fit in the user limit (max task size).
    !
    ! However there are some tricky details like mixed accesses. For
    ! example HISTO3D reads three 2D images (imaset) and creates one 2D
    ! image (imaset) and one 3D cube (fullset).
    !
    ! Because of this, fullset-accessed cubes are excluded in the analysis
    ! below as they are not involved in the task sizing (100% of data
    ! treated by a single task).
    !
    ! Select the reference cube
    ref = cubeadm_taskloop_get_reference(iter,ncube,error)
    if (error)  return
    !
    ! Set the reference axes to each iterated cube
    call cubeadm_tuple_iterator_axes(iter,ncube,iter(ref)%cube,align,error)
    if (error)  return
    !
    ! Search for best nplane-per-task
    parallel = .false.
    !$ parallel = .true.
    if (parallel .and. .not.iter(ref)%access.eq.code_access_fullset) then
      buftask = iter(ref)%cube%user%buff%task
    else
      buftask = huge(0.)
    endif
    call cubeadm_taskloop_nrpperbuf(iter,ncube,buftask,merged%nppertask,error)
    if (error)  return
    call cubeadm_taskloop_neperplane(iter(ref),merged%neperplane,error)
    if (error)  return
    merged%np = iter(ref)%cube%iter%compute_nplane_total(error)
    if (error)  return
    !
    ! Total number of tasks and entries. Can not guess by simple divisions.
    ! Apply iterator for exact values.
    call cubeadm_taskloop_reset(merged,error)
    if (error) return
    do while (cubeadm_taskloop_iterate(merged,error))
      continue
    enddo
    if (error)  return
    merged%nt = merged%num
    merged%ne = merged%ole
    !
    write(mess,'(4(a,i0))')   &
      'Split job using ',merged%nt, &
      ' tasks (',merged%nppertask, &
      ' planes per task) for ',merged%ne, &
      ' entries'
    call cubeadm_message(admseve%others,rname,mess)
    !
    ! Reset iteration before real use
    call cubeadm_taskloop_reset(merged,error)
    if (error) return
  end subroutine cubeadm_taskloop_iterator_compute
  !
  subroutine cubeadm_tuple_iterator_axes(iter,ncube,refcube,align,error)
    !-------------------------------------------------------------------
    ! Set the current and reference axes for the given cube
    !-------------------------------------------------------------------
    integer(kind=entr_k),              intent(in)    :: ncube
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter(ncube)
    class(format_t),                   intent(in)    :: refcube
    integer(kind=code_k),              intent(in)    :: align
    logical,                           intent(inout) :: error
    !
    integer(kind=entr_k) :: iiter
    class(format_t), pointer :: thiscube
    type(cuberegion_prog_t), pointer :: thisregion
    !
    do iiter=1,ncube
      thiscube   => iter(iiter)%cube
      thisregion => iter(iiter)%region
      if (associated(thisregion)) then
        call thisregion%apply_to_cube(thiscube,error,align)
        if (error)  return
      else
        call thiscube%default_region(error,align)
        if (error)  return
      endif
      call thiscube%iter%set_reference(refcube%iter,error)
      if (error)  return
    enddo
  end subroutine cubeadm_tuple_iterator_axes
  !
  subroutine cubeadm_taskloop_neperplane(iter,neperplane,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter
    integer(kind=entr_k),              intent(out)   :: neperplane
    logical,                           intent(inout) :: error
    !
    select case (iter%access)
    case (code_access_subset)
      neperplane = code_1entry_for_allplanes
    case (code_access_fullset)
      neperplane = code_1entry_for_allplanes
    case (code_access_imaset)
      neperplane = 1
    case (code_access_speset)
      neperplane = iter%cube%tuple%current%desc%nx
    end select
  end subroutine cubeadm_taskloop_neperplane
  !
  subroutine cubeadm_taskloop_nrpperbuf(iter,ncube,bufsize,nrpperbuf,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! Find the best (smallest) "Number of Reference Plane Per Block"
    !-------------------------------------------------------------------
    integer(kind=entr_k),              intent(in)    :: ncube
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter(ncube)
    real(kind=4),                      intent(in)    :: bufsize  ! [Bytes]
    integer(kind=entr_k),              intent(out)   :: nrpperbuf
    logical,                           intent(inout) :: error
    !
    integer(kind=entr_k) :: iiter,thisnrp
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='TASKLOOP>NRPERBUF'
    !
    nrpperbuf = huge(0_entr_k)
    do iiter=1,ncube
      ! Fullset-accessed cubes are not involved in the best value
      if (iter(iiter)%access.eq.code_access_fullset)  cycle
      thisnrp = iter(iiter)%cube%iter%compute_nplane_per_buffer(bufsize,error)
      if (error)  return
      if (thisnrp.lt.nrpperbuf)  nrpperbuf = thisnrp
    enddo
    write(mess,'(i0,a,a)')  &
      nrpperbuf,' ref. planes per ',cubetools_format_memsize(bufsize)
    call cubeadm_message(admseve%others,rname,mess)
  end subroutine cubeadm_taskloop_nrpperbuf
  !
  function cubeadm_taskloop_get_reference(iter,ncube,error) result(ref_cube)
    !-------------------------------------------------------------------
    ! From the list of all cubes, choose the reference cube (i.e. used
    ! as reference for the iterations)
    !-------------------------------------------------------------------
    integer(kind=4) :: ref_cube  ! Function value on return
    integer(kind=entr_k),              intent(in)    :: ncube
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter(ncube)
    logical,                           intent(inout) :: error
    !
    integer(kind=4) :: iiter
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='TASKLOOP>GET>REFERENCE'
    !
    ref_cube = 0
    !
    ! 1) Preferably select an output cube with non-fullset access
    do iiter=1,ncube
      if (iter(iiter)%input)                          cycle
      if (iter(iiter)%access.eq.code_access_fullset)  cycle
      ref_cube = iiter
      exit
    enddo
    if (ref_cube.ne.0)  goto 10
    !
    ! 2) Otherwise select an input cube with non-fullset access
    do iiter=1,ncube
      if (.not.iter(iiter)%input)                     cycle
      if (iter(iiter)%access.eq.code_access_fullset)  cycle
      ref_cube = iiter
      exit
    enddo
    if (ref_cube.ne.0)  goto 10
    !
    ! 3) Otherwise select an output cube possibly with fullset access
    do iiter=1,ncube
      if (iter(iiter)%input)                          cycle
      ref_cube = iiter
      exit
    enddo
    if (ref_cube.ne.0)  goto 10
    !
    ! 4) Otherwise select an input cube possibly with fullset access
    do iiter=1,ncube
      if (.not.iter(iiter)%input)                     cycle
      ref_cube = iiter
      exit
    enddo
    if (ref_cube.ne.0)  goto 10
    !
    call cubeadm_message(seve%e,rname,'Internal error: no cube reference cube found')
    error = .true.
    return
    !
10  continue
    write(mess,'(a,i0)')  'Reference cube is #',ref_cube
    call cubeadm_message(admseve%others,rname,mess)
  end function cubeadm_taskloop_get_reference
  !
  subroutine cubeadm_taskloop_reset(iter,error)
    !-------------------------------------------------------------------
    ! Reset iterator before iterating with cubeadm_taskloop_iterate
    !-------------------------------------------------------------------
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    iter%num = 0
    iter%prange(2) = 0  ! So that 1st iteration starts at correct position
  end subroutine cubeadm_taskloop_reset
  !
  function cubeadm_taskloop_iterate(iter,error)
    !----------------------------------------------------------------------
    ! Iterate the iterator for next range of entries to be processed.
    ! Return .false. if no more data is to be processed.
    !----------------------------------------------------------------------
    logical :: cubeadm_taskloop_iterate
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TASKLOOP>ITERATE'
    !
    if (.true.) then
      ! Plane-iterating mode
      cubeadm_taskloop_iterate = cubeadm_taskloop_iterate_planes(iter,error)
      if (error) return
    else
      ! Data-iterating mode
      ! cubeadm_taskloop_iterate = cubeadm_taskloop_iterate_data(iter,error)
      ! if (error) return
    endif
  end function cubeadm_taskloop_iterate
  !
  function cubeadm_taskloop_iterate_planes(iter,error)
    !----------------------------------------------------------------------
    ! Iterate the iterator for next range of PLANES to be processed.
    !
    ! Return .false. if no more data is to be processed.
    !----------------------------------------------------------------------
    logical :: cubeadm_taskloop_iterate_planes
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TASKLOOP>ITERATE>PLANES'
    integer(kind=entr_k) :: nplane,nentry
    character(len=message_length) :: mess
    !
    ! No welcome on purpose here!
    if (iter%prange(2).ge.iter%np) then
      ! Last entry iteration was processed on previous iteration: all done
      cubeadm_taskloop_iterate_planes = .false.
      return
    endif
    !
    ! Current task
    iter%num = iter%num+1
    !
    ! Reference planes
    iter%prange(1) = iter%prange(2)+1
    iter%prange(2) = min(iter%prange(1)+iter%nppertask-1,iter%np)
    nplane = iter%prange(2)-iter%prange(1)+1
    !
    ! Reference entries
    if (iter%neperplane.eq.code_1entry_for_allplanes) then
      ! 1 subcube for all planes in the task
      iter%ofe = iter%num
      iter%ole = iter%ofe
    else
      iter%ofe = (iter%num-1)*iter%nppertask*iter%neperplane+1
      iter%ole = iter%ofe + nplane*iter%neperplane - 1
    endif
    !
    ! Entries
    nentry = iter%ole-iter%ofe+1
    iter%ie = iter%ofe-1  ! Current entry, to be iterated with cubeadm_iterator_iterate_entry
    !
    cubeadm_taskloop_iterate_planes = .true.
    !
    write(mess,'(8(a,i0))')  &
      'Iterating task ',iter%num,  &
      ', entries ',iter%ofe,  &
      ' to ',iter%ole,  &
      ' (',nentry, &
      ' entries), planes ',iter%prange(1),  &
      ' to ',iter%prange(2),  &
      ' (',nplane, &
      ' planes)'
    call cubeadm_message(admseve%others,rname,mess)
  end function cubeadm_taskloop_iterate_planes
  !
  function cubeadm_iterator_iterate_entry(itertask,error)
    !-------------------------------------------------------------------
    ! Iterate the entry known by the current task iterator
    !-------------------------------------------------------------------
    logical :: cubeadm_iterator_iterate_entry
    class(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                   intent(inout) :: error
    !
    cubeadm_iterator_iterate_entry = .false.
    !
    if (itertask%ie.eq.itertask%ole)  return  ! All done
    !
    itertask%ie = itertask%ie+1
    call cubeadm_entryloop_iterate(itertask%ie,error)
    if (error)  return
    cubeadm_iterator_iterate_entry = .true.  ! New entry and no error
  end function cubeadm_iterator_iterate_entry
  !
end module cubeadm_taskloop
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine solve_wvr(line,error)
  use gildas_def
  use gkernel_interfaces
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_xy_code.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: m_wvr
  integer(kind=address_length) :: ipx,ipy,ipw,ips,ipwvr,data_wvr
  integer :: ipol
  real :: airmin, dtmax, dtmaxsec
  logical :: poly, reset, plot
  integer :: mvoc1, nkey
  parameter (mvoc1=2)
  character(len=12) :: kw, voc1(mvoc1)
  data voc1 /'JUMPS','CAL'/
  !------------------------------------------------------------------------
  ! Code:
  ! get main argument (second, as first was WVR)
  kw = 'JUMPS'
  call clic_kw(line,0,2,kw,nkey,voc1,mvoc1,.false.,error,.true.)
  ! Jumps in Delta  T Triple
  if (kw.eq.'JUMPS') then
    !
    ! airmin
    airmin = 0.05
    call sic_r4(line,0,3,airmin,.false.,error)
    if (error) goto 999
    ! dtmaxsec
    dtmaxsec = 300.
    call sic_r4(line,0,4,dtmaxsec,.false.,error)
    if (error) goto 999
    dtmax = dtmaxsec/3600.
  elseif (kw.eq.'CAL') then
  ! no specific input so far.
  endif
  ! degree
  ipol = 0
  call sic_i4(line,9,1,ipol,.false.,error)
  if (error) goto 999
  ipol = max(min(ipol+1,m_pol),1)  ! degree+1
  !
  reset = sic_present(4,0)
  if (reset) then
    call reset_time
  endif
  !
  ! Switch to antennas
  call switch_antenna
  !
  ! Time in X
  n_x = 1
  i_x(1) = xy_time
  sm_x1(1) = '='
  sm_x2(1) = '='
  do_bin = .false.
  change_display = .true.
  !
  ! Jumps setup
  if (kw.eq.'JUMPS') then
    !
    ! Y variables: wvrdtri and airmass
    n_y = 2
    i_y(1) = xy_wvr_dtri
    sm_y1(1) = '*'
    gu1_y(1) = 0.
    sm_y2(1) = '*'
    i_y(2) = xy_airmass
    sm_y1(2) = '*'
    gu1_y(2) = 0.
    sm_y2(2) = '*'
  elseif (kw.eq.'CAL') then
    n_y = 3
    i_y(1) = xy_wvrtcal1
    sm_y1(1) = '*'
    sm_y2(1) = '*'
    i_y(2) = xy_wvrtcal2
    sm_y1(2) = '*'
    sm_y2(2) = '*'
    i_y(3) = xy_wvrtcal3
    sm_y1(3) = '*'
    sm_y2(3) = '*'
  endif
  change_display = .true.
  call set_display(error)
  if (error) return
  !
  poly = sic_present(9,0)
  ipol = 1
  if (poly) then
    call sic_i4(line,9,1,ipol,.false.,error)
    if (error) goto 999
    ipol = max(min(ipol+1,m_pol),1)    ! degree+1
  endif
  reset = sic_present(4,0)
  if (reset) then
    call reset_time
  endif
  !
  if (change_display) then
    ! plot all scans in index, sorted, plot buffer re-initialized.
    call read_data('ALL',.true.,.true., error)
    plotted = .false.
    if (error) goto 999
    change_display = .false.
  else
    plotted = .true.
  endif
  plot = sic_present(1,0)
  !
  ipx = gag_pointer(data_x,memory)
  ipy = gag_pointer(data_y,memory)
  ipw = gag_pointer(data_w,memory)
  ips = gag_pointer(data_s,memory)
  !
  ! just in case m_data has changed
  call get_first(.true.,error)
  !
  if (kw.eq.'JUMPS') then
    call  get_wvr_jumps(m_data,m_boxes,memory(ipx),   &
      memory(ipy),memory(ipw), airmin, dtmax, error)
    !
    ! Redimension variables
    call resetvar(error)
  endif
  if (plot) then
    clear = .true.
    call sub_plot('A',.false.,.false.,0,error)
    if (error) goto 999
    plotted = .true.
  endif
  m_wvr = m_data*8
  error = sic_getvm(m_wvr,data_wvr).ne.1
  if (error) goto 999
  ipwvr = gag_pointer(data_wvr,memory)
  call sub_solve_wvr(m_data,m_boxes,memory(ipx),   &
    memory(ipy), memory(ipw),   &
    memory(ipwvr+6*m_data),   &
    memory(ipwvr),   &
    memory(ipwvr+2*m_data), memory(ipwvr+4*m_data),   &
    line, plot, ipol, nkey, error)
  call free_vm(m_wvr,data_wvr)
  return
  !
999 error = .true.
  return
end subroutine solve_wvr
!
subroutine get_wvr_jumps(md,mb,x_data,y_data,w_data,   &
    airmin, dtmax,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  real :: airmin                    !
  real :: dtmax                     !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: iy, ib, i, nd
  integer :: ia, jb, kb
  integer :: old_pen, itt, iair
  real :: s
  real :: ymean, wmean, air0, tt0, t0, dair, dt, dtt
  !------------------------------------------------------------------------
  ! Code:
  t_splwvr = t_step
  old_pen = -1
  !
  ! Loop on antennas
  do jb = 1, n_base
    ia = -i_base(jb)
    ! Loop on boxes
    do ib = 1, n_boxes
      if (k_base(ib).eq.jb) then
        iy = i_y(k_y(ib))
        if (iy.eq.xy_wvr_dtri) then
          itt = ib
        elseif (iy.eq.xy_airmass) then
          iair = ib
        endif
      endif
    enddo
    if (n_data(iair).eq.0) then
      call message(4,3,'SOLVE_WVR','No airmass data')
      goto 999
    endif
    !
    ! Look for jumps
    nd = 0
    ymean = 0
    wmean = 0
    air0 = y_data(1,iair)
    tt0 = y_data(1,itt)
    t0 = x_data(1,iair)
    do i=1, n_data(iair)
      if (y_data(i,iair) .ne. blank4 .and.   &
        w_data(i,iair).gt.0) then
        dair = abs(y_data(i,iair)-air0)
        dt = abs(x_data(i,iair)-t0)
        dtt = abs(y_data(i,itt)-tt0)
        air0 = y_data(i,iair)
        tt0 = y_data(i,itt)
        t0 = x_data(i,iair)
        if (dair.gt.airmin .and. dt.lt.dtmax) then
          nd = nd+1
          !                  X_data(ND,it) = X_DATA(I,Iair)
          y_data(i,iair) = dtt/dair
          ! The MTH_FITPOL routine requires 1/sigma values
          w_data(i,iair) = dair
        else
          w_data(i,iair) = 0
          y_data(i,iair) = blank4
        endif
      endif
    enddo
    if (nd.eq.0) goto 999
  !
  ! Second box  per antenna
  enddo
  !
  ! normalize
  do i=1, n_data(2)
    if (w_data(i,2).gt.0) then
      s = 0
      do kb = 2, n_boxes, 2
        s = s + y_data(i,kb)
      enddo
      s = s*2/n_boxes
      do kb = 2, n_boxes, 2
        y_data(i,kb) = y_data(i,kb) / s
      enddo
    endif
  enddo
  return
  !
999 error = .true.
  return
end subroutine get_wvr_jumps
!
subroutine  sub_solve_wvr(md,mb, x_data, y_data, w_data,   &
    wk1, xxx, yyy, www, line, plot, ipol, nkey, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  real*8 :: wk1(3*md)               !
  real*8 :: xxx(md)                 !
  real*8 :: yyy(md)                 !
  real*8 :: www(md)                 !
  character(len=*) :: line          !
  logical :: plot                   !
  integer :: ipol                   !
  integer :: nkey                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  ! Local
  real*8 :: wk3(2*m_pol), apol(m_pol,m_pol), spol(m_pol), aa(m_pol)
  real*8 :: rss, sss
  real*8 :: xx(10*m_spl), yy(10*m_spl), xx1
  real*4 :: step
  character(len=256) :: chain
  integer :: ib, ia, nd, i, l, l1, l2, l3, nn, old_pen
  integer :: iy, ich
  logical :: ok
  !
  !------------------------------------------------------------------------
  ! Code:
  if (plot) then
    old_pen = gr_spen (1)
    call gr_segm('FIT',error)
  endif
  !
  ! Loop on boxes
  do ib = 1, n_boxes
    ia = - i_base(k_base(ib))
    iy = i_y(k_y(ib))
    ok = (nkey.eq.1 .and. iy.eq.xy_airmass)
    ok = ok .or.   &
      (nkey.eq.2   &
      .and. iy.ge.xy_wvrtcal1 .and. iy.le.xy_wvrtcal3)
    if (ok) then
      nd = 0
      do i=1, n_data(ib)
        if (y_data(i,ib) .ne. blank4) then
          nd = nd+1
          xxx(nd) = x_data(i,ib)
          yyy(nd) = y_data(i,ib)
          www(nd) = sqrt(w_data(i,ib))
        endif
      enddo
      if (nd.eq.0) goto 999
      sss = 0
      do i=1, nd
        sss = sss + www(i)**2
      enddo
      ipol = min(ipol,nd)
      call mth_fitpol('SOLVE_WVR',nd,ipol,m_pol,   &
        xxx,yyy,www,wk1,wk3,apol,spol,error)
      if (error) goto 999
      rss = sqrt(sss/nd)       ! rms obtenu
      rss = spol(ipol)/rss
      !
      l = min(lenc(y_label(ib)),5)
      l1 = lenc(header_1(ib))
      l2 = lenc(header_2(ib))
      l3 = lenc(header_3(ib))
      write(chain,1000) y_label(ib)(1:3), header_1(ib)(1:l1),   &
        rss, 2*rss/apol(ipol,1)
1000  format(a,'. ',a,' rms: ',1pg10.3,' (rel ',1pg10.3,')')
      call message(6,1,'SOLVE_WVR',chain(1:lenc(chain)))
      if (plot) then
        nn = 10.*m_spl
        step = (gb2_x(ib)-gb1_x(ib)) / (nn-1)
        if (step.eq.0) step = 0.1
        do i=1, ipol
          aa(i) = apol(ipol,i)
        enddo
        do i=1, nn
          xx(i) = gb1_x(ib) + (i-1) * step
          xx1 = min(max(xx(i),xxx(1)),xxx(nd))
          xx1 = ((xx1-xxx(1))-(xxx(nd)-xx1))   &
            /(xxx(nd)-xxx(1))
          call mth_getpol('SOLVE_WVR',   &
            ipol,aa,xx1,yy(i),error)
          if (error) goto 999
        enddo
        write(chain,'(I4.4)') ib
        call gr_execl('CHANGE DIRECTORY BOX'//chain)
        error = gr_error()
        if (error) goto 999
        call gr8_connect (nn,xx,yy,0.0d0,-1.0d0)
        call gr_execl('CHANGE DIRECTORY')
      endif
      !
      ! Save results
      n_polwvr(ia) = ipol
      if (nkey.eq.1) then
        ich = 1
      !     in proper channel ... (for tcal)
      elseif (nkey.eq.2) then
        ich = 1+iy-xy_wvrtcal1
      endif
      do i=1, ipol
        c_polwvr(i,ia,ich) = apol(ipol,i)
      enddo
      t_polwvr(1,ia) = xxx(1)
      t_polwvr(2,ia) = xxx(nd)
      rms_polwvr(ia,ich) = rss
      f_polwvr(ia) = nkey
      f_splwvr(ia) = 0
    endif
  enddo
  !      CALL SIC_DELVARIABLE ('RMS_ERR',.FALSE.,ERROR)
  !      ERROR = .FALSE.
  !      CALL SIC_DEF_REAL ('RMS_ERR',RMS_ERR,1,N_BOXES,.FALSE.,ERROR)
  !      ERROR = .FALSE.
998 continue
  if (old_pen.ne.-1)  then
    call gr_segm_close(error)
    i = gr_spen(old_pen)
  endif
  return
  !
999 error = .true.
  goto 998
end subroutine sub_solve_wvr

module gtv_ps
  use gtv_types
  !---------------------------------------------------------------------
  ! Support for Postscript laser printers
  !---------------------------------------------------------------------
  !
  integer(kind=4), parameter :: psmap_size = 65536  ! i.e. the most we
    ! can encode in integers of KIND=BITMAP_DEPTH == 2
  integer(kind=4), parameter :: psmap_offset = -32768  ! i.e. encode
    ! the 65536 colors from -32768 to 32767
  !
  ! Variables for PostScript plotter
  real(kind=4) :: margin_xl_cm,margin_xr_cm,margin_yb_cm,margin_yt_cm
  real(kind=4) :: margin_xl_pt,margin_xr_pt,margin_yb_pt,margin_yt_pt
  real(kind=4) :: page_xw_pt,page_yw_pt
  real(kind=4) :: plot_xmin_cm,plot_xmax_cm
  real(kind=4) :: plot_ymin_cm,plot_ymax_cm
  real(kind=8) :: scale_x_plot2pt,scale_y_plot2pt  ! Scaling factor from GTV plot to point units
  real(kind=4) :: x_first_pt,y_first_pt  ! Coordinates of first usable pixel
  ! Conversion factors: 1 pt is 1/72 inch. 1 inch is 2.54 cm. 1 vec unit is 50
  ! microns. Our PostScripts are filled in vec units (instead of pts by default),
  ! using the appropriate scaling factor in the PostScript prolog.
  real(kind=8), parameter :: cm2pt=72.d0/2.54d0
  real(kind=4), parameter :: cm2vec=200. ! 1cm = 200 * 50microns
  !
  integer :: nnchar,olun,counter,pen_old
  logical :: ps_rotate,ps_color
  integer, parameter :: maxbuf=80
  integer(kind=1) :: bbuf(maxbuf)
  !
  ! Definitions
  integer(kind=1), parameter :: l=ichar('l')
  integer(kind=1), parameter :: m=ichar('m')
  integer(kind=1), parameter :: s=ichar('s')
  integer(kind=1), parameter :: blanc=ichar(' ')
  integer(kind=4), parameter :: zero=ichar('0')
  integer(kind=1), parameter :: bigs=ichar('S')
  !
end module gtv_ps
!
subroutine ps_open(output,dir,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>ps_open
  use gildas_def
  use gtv_types
  use gtv_ps
  use gtv_protocol
  use gtv_tree
  use gtv_buffers
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display)                  :: output  ! Output instance
  type(gt_directory), intent(in)    :: dir     ! The directory to print
  logical,            intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PS'
  character(len=64) :: version
  integer :: ier
  character(len=message_length) :: mess
  !
  if (output%ps%exact) then
    write(mess,'(3(A,1X,L1,1X))')  &
      'Encapsulated:',output%ps%encapsulated,  &
      ', Autorotate:',output%autorotate,     &
      ', Exact:', output%ps%exact
  else
    write(mess,'(3(A,1X,L1,1X))')  &
      'Encapsulated:',output%ps%encapsulated,  &
      ', Autorotate:',output%autorotate,     &
      ', Autoscale:', output%autoscale
  endif
  call gtv_message(seve%d,rname,mess)
  !
  ps_color = output%color
  !
  output%background = 1  ! White background
  output%dev%rxy = 1.0
  olun = output%iunit
  nnchar = 0
  !
  if (output%iunit.ne.6) then
    open (unit=olun,file=output%file,status='NEW',iostat=ier )
    if (ier.ne.0) then
      error = .true.
      call putios ('E-PS,  ',ier)
      return
    endif
  endif
  !
  ! Write Prolog
  write (olun,'(A)') '%!PS-Adobe-3.0 EPSF-3.0'
  version = ''
  ier = sic_getlog('GAG_VERSION',version)
  if (version(1:4).eq."dev ") then
    write (olun,'(A)')  &
      '%%Creator: GTVIRT 1.3 GILDAS dev GILDAS_GROUP 15-Dec-2010'
  else
    write (olun,'(A,A,A)')  &
      '%%Creator: GTVIRT 1.3 GILDAS ',version(1:5),' GILDAS_GROUP 15-Dec-2010'
  endif
  write (olun,'(A)') '%%Title: Hardcopy GTVIRT metacode on PostScript driver'
  call sic_date(version)
  write (olun,'(A)') '%%CreationDate: '//trim(version)
  write (olun,'(A)') '%%Pages: 1'
  write (olun,'(A)') '%%DocumentsFonts: none'
  !
  margin_xl_cm = output%dev%px1/100.
  margin_xr_cm = output%dev%py2/100.  ! Inverted, unknown reason
  margin_yb_cm = output%dev%py1/100.
  margin_yt_cm = output%dev%px2/100.  ! Inverted, unknown reason
  margin_xl_pt = margin_xl_cm * cm2pt
  margin_xr_pt = margin_xr_cm * cm2pt
  margin_yb_pt = margin_yb_cm * cm2pt
  margin_yt_pt = margin_yt_cm * cm2pt
  page_xw_pt = margin_xr_pt-margin_xl_pt
  page_yw_pt = margin_yt_pt-margin_yb_pt
  ! Debug
  write(mess,'(A,4(F6.2))') 'Paper limits (cm): ',  &
    margin_xl_cm,margin_yb_cm,margin_xr_cm,margin_yt_cm
  call gtv_message(seve%d,rname,mess)
  !
  if (output%ps%encapsulated) then
    call ps_prolog_eps(output,dir)
  else
    call ps_prolog_ps(output,dir)
  endif
  !
  write (olun,'(A)') '%%EndComments'
  !
  ! This comment lines is a patch for a bug in DVIALW.
  ! This is old stuff but does not harm... They were needed
  ! for correct insertion of plots within a TEX page.
  write (olun,'(A)') '%begin(plot)'
  write (olun,'(A)') '% Will remember original state'
  write (olun,'(A)') 'save'
  write (olun,'(A)') '% Use a temporary dictionary'
  write (olun,'(A)') '50 dict begin'
  !
  call ps_prolog_gagheader(error)
  if (error)  return
  !
  ! The Prolog must be finished before the scaling factors
  write (olun,'(A)') '%%EndProlog'
  !
  ! Start the new (unique in EPS) page:
  write (olun,'(A)') '%%Page: 1 1'
  !
  ! Scaling Factors must be before the "gsave"
  ! Empirical tests on screen displays and printer drivers show that
  ! 'translate' and 'scale' operators must be in each local page setup
  ! (%%BeginPageSetup). They are (often) ignored if they are in the global
  ! setup (%%BeginSetup).
  write (olun,'(A)') '%%BeginPageSetup'
  write (olun,'(1X,F9.3,1X,F9.3,A)') x_first_pt,y_first_pt,' translate'
  !
  ! Scale along X axis (points/.VEC unit). The internal unit of .VEC files is
  ! 50 microns. Postscript uses the point (1/72 inch) as internal unit.
  scale_x_plot2pt = scale_x_plot2pt/cm2vec
  scale_y_plot2pt = scale_x_plot2pt*output%dev%rxy
  write (olun,'(2(F15.12,1X),A)') scale_x_plot2pt,scale_y_plot2pt ,'scale'
  write (olun,'(A)') '%%EndPageSetup'
  !
  write (olun,'(A)') 'gsave'
  !
end subroutine ps_open
!
subroutine ps_prolog_ps(output,dir)
  use gtv_interfaces, except_this=>ps_prolog_ps
  use gbl_message
  use gtv_ps
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display)               :: output  ! Output instance
  type(gt_directory), intent(in) :: dir     ! The directory to print
  ! Local
  character(len=*), parameter :: rname='PS'
  ! Device dependent parameters. They are defined to an accuracy of about 1%,
  ! set by the engine rather than by the electronics. Be conservative, if you
  ! don't want to occasionnaly clip a plot.
  real(kind=4) :: page_xref_pt,page_yref_pt
  real(kind=4) :: plot_xref_cm,plot_yref_cm
  real(kind=4) :: plot_xrange_cm,plot_yrange_cm
  ! Ratio of scales along X and Y. This is not exactly 1, since Y scale is
  ! defined by paper motion. There is a weak dependence on paper quality...
  ! But probably a STRONG dependence on machine, so this is taken
  ! from the GAG_TERMINAL file
  integer(kind=4) :: bbox(4)
  character(len=message_length) :: mess
  !
  ! Check PORTRAIT / LANDSCAPE mode
  if (output%autorotate) then
    ps_rotate = dir%phys_size(1).gt.dir%phys_size(2)
  else
    ps_rotate = .false.
  endif
  !
  if (ps_rotate) then
    plot_xmin_cm = 0.
    plot_xmax_cm = dir%phys_size(2)
    plot_ymin_cm = 0.
    plot_ymax_cm = dir%phys_size(1)
  else
    plot_xmin_cm = 0.
    plot_xmax_cm = dir%phys_size(1)
    plot_ymin_cm = 0.
    plot_ymax_cm = dir%phys_size(2)
  endif
  plot_xrange_cm = plot_xmax_cm-plot_xmin_cm
  plot_yrange_cm = plot_ymax_cm-plot_ymin_cm
  !
  ! Check if size is determined by X or Y size.
  if (.not.output%autoscale .or. output%ps%exact) then
    scale_x_plot2pt = cm2pt
  else
    if ((plot_xrange_cm/plot_yrange_cm) .le. (page_xw_pt/page_yw_pt)) then
      scale_x_plot2pt = page_yw_pt/plot_yrange_cm
    else
      scale_x_plot2pt = page_xw_pt/plot_xrange_cm
    endif
  endif
  !
  ! Debug
  write(mess,'(A,1X,L,A,F8.3)')  &
    'Rotation:',ps_rotate,', Scaling factor: ',scale_x_plot2pt/cm2pt
  call gtv_message(seve%d,rname,mess)
  !
  ! Portrait or Landscape?
  if (ps_rotate) then
    ! Empirical tests show that these line are recognized by PostScript
    ! viewers, but not by Latex, MS/Open/Libre-Office or eps2jpg. They
    ! must also be ignored by printers, else automatic rotation has no
    ! more meaning.
    if (plot_xrange_cm.gt.plot_yrange_cm) then
      write (olun,'(A)')  '%%Orientation: Portrait'
    else
      write (olun,'(A)')  '%%Orientation: Landscape'
    endif
  endif
  !
  ! Normally the following Bounding Box should be Absolutely OK
  ! as long as the GTVIRT keeps track of its own bounding Box !
  ! PS: reference point: the lower left corner of the paper will
  !     match the lower left corner of the (rotated) GTV plot.
  if (output%autoscale .and. .not.output%ps%exact) then
    ! Lower left corner of the usable part of the paper
    page_xref_pt = margin_xl_pt
    page_yref_pt = margin_yb_pt
  else
    ! Lower left corner of the paper
    page_xref_pt = 0.
    page_yref_pt = 0.
  endif
  if (.not.ps_rotate) then
    plot_xref_cm = plot_xmin_cm  ! Lower left corner
    plot_yref_cm = plot_ymin_cm  ! of the GTV plot
    x_first_pt = page_xref_pt - plot_xref_cm*scale_x_plot2pt
    y_first_pt = page_yref_pt - plot_yref_cm*scale_x_plot2pt
    !
    write (olun,'(A,4(1x,I10))')  '%GregBounding: ',  &
      int(plot_xmin_cm * scale_x_plot2pt + x_first_pt),    &
      int(plot_ymin_cm * scale_x_plot2pt + y_first_pt),    &
      int(plot_xmax_cm * scale_x_plot2pt + x_first_pt)+1,  &
      int(plot_ymax_cm * scale_x_plot2pt + y_first_pt)+1
  else
    plot_xref_cm = plot_xmax_cm-plot_xmax_cm  ! Lower left corner
    plot_yref_cm = plot_ymin_cm               ! of the GTV plot
    x_first_pt = page_xref_pt - plot_xref_cm*scale_x_plot2pt
    y_first_pt = page_yref_pt - plot_yref_cm*scale_x_plot2pt
    !
    write (olun,'(A,4(1x,I10))')  '%GregBounding: ',  &
      int((plot_xmax_cm-plot_xmax_cm)*scale_x_plot2pt + x_first_pt),    &
      int( plot_ymin_cm              *scale_x_plot2pt + y_first_pt),    &
      int((plot_xmax_cm-plot_xmin_cm)*scale_x_plot2pt + x_first_pt)+1,  &
      int( plot_ymax_cm              *scale_x_plot2pt + y_first_pt)+1
  endif
  !
  bbox(1) = int(x_first_pt)
  bbox(2) = int(y_first_pt)
  bbox(3) = int(plot_xrange_cm*scale_x_plot2pt + x_first_pt)+1
  bbox(4) = int(plot_yrange_cm*scale_x_plot2pt + y_first_pt)+1
  write (olun,'(A,4(1x,I10))')  '%%BoundingBox: ',bbox
  !
  ! Debug
  write(mess,'(A,4(1X,F8.3))') 'BoundingBox (cm):',  &
    bbox(1)/cm2pt,bbox(2)/cm2pt,bbox(3)/cm2pt,bbox(4)/cm2pt
  call gtv_message(seve%d,rname,mess)
  !
end subroutine ps_prolog_ps
!
subroutine ps_prolog_eps(output,dir)
  use gtv_interfaces, except_this=>ps_prolog_eps
  use gbl_message
  use gtv_ps
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display)               :: output  ! Output instance
  type(gt_directory), intent(in) :: dir     ! The directory to print
  ! Local
  character(len=*), parameter :: rname='EPS'
  ! Device dependent parameters. They are defined to an accuracy of about 1%,
  ! set by the engine rather than by the electronics. Be conservative, if you
  ! don't want to occasionnaly clip a plot.
  real(kind=4) :: page_xref_pt,page_yref_pt
  real(kind=4) :: plot_xref_cm,plot_yref_cm
  real(kind=4) :: plot_xrange_cm,plot_yrange_cm
  ! Ratio of scales along X and Y. This is not exactly 1, since Y scale is
  ! defined by paper motion. There is a weak dependence on paper quality...
  ! But probably a STRONG dependence on machine, so this is taken
  ! from the GAG_TERMINAL file
  integer(kind=4) :: bbox(4)
  character(len=message_length) :: mess
  !
  ! Check PORTRAIT / LANDSCAPE mode
  if (output%autorotate) then
    ps_rotate = (dir%gen%minmax(2)-dir%gen%minmax(1)).gt.  &
                (dir%gen%minmax(4)-dir%gen%minmax(3))
  else
    ps_rotate = .false.
  endif
  !
  if (ps_rotate) then
    ! This will clip the Bounding Box to the plot page:
    plot_xmin_cm = max(dir%gen%minmax(3),0.)
    plot_xmax_cm = min(dir%gen%minmax(4),dir%phys_size(2))
    plot_ymin_cm = max(dir%gen%minmax(1),0.)
    plot_ymax_cm = min(dir%gen%minmax(2),dir%phys_size(1))
  else
    ! This will clip the Bounding Box to the plot page:
    plot_xmin_cm = max(dir%gen%minmax(1),0.)
    plot_xmax_cm = min(dir%gen%minmax(2),dir%phys_size(1))
    plot_ymin_cm = max(dir%gen%minmax(3),0.)
    plot_ymax_cm = min(dir%gen%minmax(4),dir%phys_size(2))
  endif
  plot_xrange_cm = plot_xmax_cm-plot_xmin_cm
  plot_yrange_cm = plot_ymax_cm-plot_ymin_cm
  !
  ! Check if size is determined by X or Y size.
  if (.not.output%autoscale .or. output%ps%exact) then
    scale_x_plot2pt = cm2pt
  else
    if ((plot_xrange_cm/plot_yrange_cm) .le. (page_xw_pt/page_yw_pt)) then
      scale_x_plot2pt = page_yw_pt/plot_yrange_cm
    else
      scale_x_plot2pt = page_xw_pt/plot_xrange_cm
    endif
  endif
  !
  ! Debug
  write(mess,'(A,1X,L,A,F8.3)')  &
    'Rotation:',ps_rotate,', Scaling factor: ',scale_x_plot2pt/cm2pt
  call gtv_message(seve%d,rname,mess)
  !
  ! Portrait or Landscape?
  if (ps_rotate) then
    ! Empirical tests show that these line are recognized by PostScript
    ! viewers, but not by Latex, MS/Open/Libre-Office or eps2jpg. They
    ! must also be ignored by printers, else automatic rotation has no
    ! more meaning.
    if (plot_xrange_cm.gt.plot_yrange_cm) then
      write (olun,'(A)')  '%%Orientation: Portrait'
    else
      write (olun,'(A)')  '%%Orientation: Landscape'
    endif
  endif
  !
  ! Normally the following Bounding Box should be Absolutely OK
  ! as long as the GTVIRT keeps track of its own bounding Box !
  if (output%ps%exact) then
    ! Lower left corner of the paper
    page_xref_pt = 0.
    page_yref_pt = 0.
  else
    ! EPS: reference point: the center of the usable part of the paper
    !      will match the center of the GTV plot.
    page_xref_pt = margin_xl_pt + page_xw_pt/2.  ! Center of the usable
    page_yref_pt = margin_yb_pt + page_yw_pt/2.  ! part of the paper
  endif
  if (.not.ps_rotate) then
    if (output%ps%exact) then
      plot_xref_cm = 0.
      plot_yref_cm = 0.
    else
      plot_xref_cm = plot_xmin_cm + (plot_xmax_cm-plot_xmin_cm)/2.  ! Center of the
      plot_yref_cm = plot_ymin_cm + (plot_ymax_cm-plot_ymin_cm)/2.  ! GTV plot
    endif
    x_first_pt = page_xref_pt - plot_xref_cm*scale_x_plot2pt
    y_first_pt = page_yref_pt - plot_yref_cm*scale_x_plot2pt
    !
    ! The following can happen if autoscaling is disabled: aligning the
    ! center of the plot with the center of the page can lead to negative
    ! Bounding Box. If so, shift.
    if ((plot_xmin_cm*scale_x_plot2pt + x_first_pt).le.0.)  &  ! bbox(1)
      x_first_pt = 1. - plot_xmin_cm*scale_x_plot2pt
    if ((plot_ymin_cm*scale_x_plot2pt + y_first_pt).le.0.)  &  ! bbox(3)
      y_first_pt = 1. - plot_ymin_cm*scale_x_plot2pt
    !
    bbox(1) = int(plot_xmin_cm * scale_x_plot2pt + x_first_pt)
    bbox(2) = int(plot_ymin_cm * scale_x_plot2pt + y_first_pt)
    bbox(3) = int(plot_xmax_cm * scale_x_plot2pt + x_first_pt)+1
    bbox(4) = int(plot_ymax_cm * scale_x_plot2pt + y_first_pt)+1
  else
    if (output%ps%exact) then
      plot_xref_cm = 0.
      plot_yref_cm = 0.
    else
      plot_xref_cm =                (plot_xmax_cm-plot_xmin_cm)/2.  ! Center of the
      plot_yref_cm = plot_ymin_cm + (plot_ymax_cm-plot_ymin_cm)/2.  ! GTV plot
    endif
    x_first_pt = page_xref_pt - plot_xref_cm*scale_x_plot2pt
    y_first_pt = page_yref_pt - plot_yref_cm*scale_x_plot2pt
    !
    ! The following can happen if autoscaling is disabled: aligning the
    ! center of the plot with the center of the page can lead to negative
    ! Bounding Box. If so, shift.
    if (((plot_xmax_cm-plot_xmax_cm)*scale_x_plot2pt + x_first_pt).le.0.)  &  ! bbox(1)
      x_first_pt = 1. - (plot_xmax_cm-plot_xmax_cm)*scale_x_plot2pt
    if ((plot_ymin_cm*scale_x_plot2pt + y_first_pt).le.0.)  &  ! bbox(3)
      y_first_pt = 1. - plot_ymin_cm*scale_x_plot2pt
    !
    bbox(1) = int((plot_xmax_cm-plot_xmax_cm)*scale_x_plot2pt + x_first_pt)
    bbox(2) = int( plot_ymin_cm              *scale_x_plot2pt + y_first_pt)
    bbox(3) = int((plot_xmax_cm-plot_xmin_cm)*scale_x_plot2pt + x_first_pt)+1
    bbox(4) = int( plot_ymax_cm              *scale_x_plot2pt + y_first_pt)+1
  endif
  write(olun,'(A,4(1x,I8))')  '%%BoundingBox: ',bbox
  !
  ! Debug
  write(mess,'(A,4(1X,F8.3))') 'BoundingBox (cm):',  &
    bbox(1)/cm2pt,bbox(2)/cm2pt,bbox(3)/cm2pt,bbox(4)/cm2pt
  call gtv_message(seve%d,rname,mess)
  !
  write (olun,'(A,4(1x,F15.3))')  '%%GregPage: ',  &
    x_first_pt,                                 &
    y_first_pt,                                 &
    plot_xmax_cm*scale_x_plot2pt + x_first_pt,  &
    plot_ymax_cm*scale_x_plot2pt + y_first_pt
  !
end subroutine ps_prolog_eps
!
subroutine ps_prolog_gagheader(error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>ps_prolog_gagheader
  use gildas_def
  use gtv_ps
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PS'
  character(len=filename_length) :: file
  integer :: ier,alun
  character(len=256) :: line
  !
  ! Here are local definitions of the "GAG Style"
  ier = sic_getlun(alun)
  if (.not.sic_query_file('gag_ps_header','data#dir:','',file)) then
    call gtv_message(seve%e,rname,'gag_ps_header not found')
    error = .true.
    return
  endif
  ier = sic_open(alun,file,'OLD',.true.)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Cannot open '//file)
    call putios('E-PS,  ',ier)
    call sic_frelun (alun)
    error = .true.
    return
  endif
  do while (.true.)
    read(alun,'(A)',end=10) line
    write(olun,'(A)') trim(line)
  enddo
10 close (unit=alun)
  call sic_frelun(alun)
  !
end subroutine ps_prolog_gagheader
!
subroutine ps_pen_rgb(r,g,b)
  use gtv_interfaces, except_this=>ps_pen_rgb
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current pen from the input R G B values (0-255)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: r,g,b
  !
  write(olun,'(3(F5.3,1X),A)') r/255.,g/255.,b/255.,'setrgbcolor'
  !
end subroutine ps_pen_rgb
!
subroutine ps_dash (dashed,pattern)
  use gtv_interfaces, except_this=>ps_dash
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical :: dashed                 !
  real :: pattern(4)                !
  ! Local
  integer :: i
  real :: a(4)
  !
  call ps_out(s)
  !
  if (dashed) then
    do i=1,4
      a(i) = pattern(i)*cm2vec
    enddo
    write(olun,100) (a(i),i=1,4)
100 format('[ ',4f7.2,' ] DS ')
  else
    write(olun,'(A)') '[] DS '
  endif
  !
end subroutine ps_dash
!
subroutine ps_weigh(width)
  use gtv_interfaces, except_this=>ps_weigh
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: width  ! Line width, in centimeter
  !
  call ps_out(s)
  !
  write(olun,'(F5.2,A)') cm2vec*width,' WS'
end subroutine ps_weigh
!
subroutine ps_moveto(x,y)
  use gtv_interfaces, except_this=>ps_moveto
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  ! Elemental 'moveto'
  !---------------------------------------------------------------------
  real, intent(in) :: x  ! X value
  real, intent(in) :: y  ! Y value
  ! Local
  integer :: ix,iy
  integer :: i1,xx
  logical :: found
  !
  ! Damned NaN
  if (x.ne.x) return
  if (y.ne.y) return
  !
  if (.not.ps_rotate) then
    ix = int(x*cm2vec)
    iy = int(y*cm2vec)
  else
    ix = int((plot_xmax_cm-y)*cm2vec)
    iy = int(x*cm2vec)
  endif
  counter = 0
  !
  ! optimisation ecriture plume haute
  ! write (olun, '(a,i5,1x,i5,a)') 's ', ix, iy, ' m'
  if (nnchar .gt. (maxbuf-17)) call ps_out(blanc)
  !
  ! First IX
  xx = ix
  found = .false.
  i1 = xx/10000
  if (i1.ne.0.or.found) then
    xx = xx-10000*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/1000
  if (i1.ne.0.or.found) then
    xx = xx-1000*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/100
  if (i1.ne.0.or.found) then
    xx = xx-100*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/10
  if (i1.ne.0.or.found) then
    xx = xx-10*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  nnchar = nnchar+1
  bbuf(nnchar) = ior(xx,zero)
  !
  ! Space
  nnchar = nnchar+1
  bbuf(nnchar) = blanc
  !
  ! Now IY
  xx = iy
  found = .false.
  i1 = xx/10000
  if (i1.ne.0.or.found) then
    xx = xx-10000*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/1000
  if (i1.ne.0.or.found) then
    xx = xx-1000*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/100
  if (i1.ne.0.or.found) then
    xx = xx-100*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/10
  if (i1.ne.0.or.found) then
    xx = xx-10*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  nnchar = nnchar+1
  bbuf(nnchar) = ior(xx,zero)
  nnchar = nnchar+1
  !
  ! Moveto
  bbuf(nnchar) = blanc
  nnchar = nnchar+1
  bbuf(nnchar) = m
  nnchar = nnchar+1
  bbuf(nnchar) = blanc
  !
end subroutine ps_moveto
!
subroutine ps_lineto(x,y)
  use gtv_interfaces, except_this=>ps_lineto
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  ! Elemental 'lineto'
  !---------------------------------------------------------------------
  real, intent(in) :: x  ! X value
  real, intent(in) :: y  ! Y value
  ! Local
  integer :: ix,iy
  integer :: i1,xx
  logical :: found
  !
  ! Damned NaN
  if (x.ne.x) return
  if (y.ne.y) return
  !
  if (.not.ps_rotate) then
    ix = int(x*cm2vec)
    iy = int(y*cm2vec)
  else
    ix = int((plot_xmax_cm-y)*cm2vec)
    iy = int(x*cm2vec)
  endif
  counter = counter+1
  !
  ! write (olun, '(i5,1x,i5,a)') ix, iy, ' l '
  if (nnchar .gt. (maxbuf-15)) call ps_out(blanc)
  xx = ix
  !
  found = .false.
  i1 = xx/10000
  if (i1.ne.0.or.found) then
    xx = xx-10000*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/1000
  if (i1.ne.0.or.found) then
    xx = xx-1000*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/100
  if (i1.ne.0.or.found) then
    xx = xx-100*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/10
  if (i1.ne.0.or.found) then
    xx = xx-10*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  nnchar = nnchar+1
  bbuf(nnchar) = ior(xx,zero)
  !
  nnchar = nnchar+1
  bbuf(nnchar) = blanc
  !
  xx = iy
  found = .false.
  i1 = xx/10000
  if (i1.ne.0.or.found) then
    xx = xx-10000*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/1000
  if (i1.ne.0.or.found) then
    xx = xx-1000*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/100
  if (i1.ne.0.or.found) then
    xx = xx-100*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  i1 = xx/10
  if (i1.ne.0.or.found) then
    xx = xx-10*i1
    nnchar = nnchar+1
    bbuf(nnchar) = ior(i1,zero)
    found = .true.
  endif
  nnchar = nnchar+1
  bbuf(nnchar) = ior(xx,zero)
  !
  nnchar = nnchar+1
  bbuf(nnchar) = blanc
  nnchar = nnchar+1
  bbuf(nnchar) = l
  nnchar = nnchar+1
  bbuf(nnchar) = blanc
  !
end subroutine ps_lineto
!
subroutine ps_close
  use gtv_interfaces, except_this=>ps_close
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  !
  call ps_out(blanc)
  write (olun,'(A)') 'stroke grestore'
  write (olun,'(A)') '%end(plot)'
  write (olun,'(A)') 'showpage'
  write (olun,'(A)') '%%Trailer'
  write (olun,'(A)') '% End of temporary dictionary'
  write (olun,'(A)') 'end'
  write (olun,'(A)') '% restore original state'
  write (olun,'(A)') 'restore'
  write (olun,'(A)') '%%EOF'
  !
  if (olun.ne.6)  close (olun)
  !
end subroutine ps_close
!
subroutine ps_trace(trace)
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: trace
  !
  call ps_out(blanc)
  write (olun,'(A,A)') '% ',trim(trace)
end subroutine ps_trace
!
subroutine ps_stroke
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  !
  if (counter.gt.0) then
    write(olun,'(A)') 's '
    counter = 0
  endif
end subroutine ps_stroke
!
subroutine ps_out(what)
  use gtv_interfaces, except_this=>ps_out
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=1) :: what           !
  !
  if(what.ne.blanc)then
    if (counter.gt.0) then
      nnchar = nnchar+1
      bbuf(nnchar) = blanc
      nnchar = nnchar+1
      bbuf(nnchar) = what
      nnchar = nnchar+1
      bbuf(nnchar) = blanc
      counter=0
    endif
  endif
  if (nnchar.gt.0) then
    call ps_write(bbuf,nnchar,olun)
    nnchar = 0
  endif
end subroutine ps_out
!
subroutine ps_write(buf,n,olun)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: n                      !
  integer(kind=1) :: buf(n)         !
  integer :: olun                   !
  ! Local
  integer :: i
  write (olun,'(512A1)') (char(buf(i)), i=1, n)
end subroutine ps_write
!
subroutine ps_image_inquire(map_size,map_offset,map_color,map_static)
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer, intent(out) :: map_size    !
  integer, intent(out) :: map_offset  !
  logical, intent(out) :: map_color   !
  logical, intent(out) :: map_static  !
  !
  map_size = psmap_size
  map_offset = psmap_offset
  map_color = ps_color
  map_static = .false.  ! PS filler is not able to provide one LUT per
                        ! image of the plot.
  !
end subroutine ps_image_inquire
!
subroutine ps_fill(n,x,y)
  use gtv_interfaces, except_this=>ps_fill
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  ! Draw a filled polygon in the PostScript
  !---------------------------------------------------------------------
  integer, intent(in) :: n          ! Number of summits
  real,    intent(in) :: x(n)       ! X array
  real,    intent(in) :: y(n)       ! Y array
  ! Local
  character(len=*), parameter :: rname='PS_FILL'
  integer :: i
  !
  ! Close current line
  call ps_out(s)
  !
  write(olun,'(A)') 'NP '
  call ps_moveto(x(1),y(1))
  do i=2,n
    call ps_lineto(x(i),y(i))
  enddo
  call ps_out(blanc)
  ! the fill operation is a stroke. Thus nothing else is left to
  ! be stroked after a fill==> COUNTER=0 .
  counter = 0
  write(olun,'(A)') 'CPF '
  !
end subroutine ps_fill
!
subroutine ps_points(n,x,y)
  use gbl_message
  use gtv_interfaces, except_this=>ps_points
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !  Draw a list of dot-points in the PostScript
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: n     ! Number of summits
  real(kind=4),    intent(in) :: x(n)  ! X array
  real(kind=4),    intent(in) :: y(n)  ! Y array
  ! Local
  integer(kind=4) :: i
  !
  do i=1,n
    ! This is probably unefficient i.e. it duplicates the number of
    ! coordinates in the PostScript. Can't we draw a dot instead?
    call ps_moveto(x(i),y(i))
    call ps_lineto(x(i),y(i))
  enddo
  !
end subroutine ps_points
!
subroutine gti_psimage(out,image)
  use gtv_interfaces, except_this=>gti_psimage
  use gildas_def
  use gtv_bitmap
  use gtv_buffers
  use gtv_plot
  use gtv_types
  use gtv_tree
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Specifique au protole PostScript
  !---------------------------------------------------------------------
  type(gt_display)           :: out    ! Output instance
  type(gt_image), intent(in) :: image  ! Image instance
  ! Local
  character(len=*), parameter :: rname='PSIMAGE'
  real(kind=4) :: clip(4),trans(4)
  integer(kind=4) :: window(4),ier
  type(gt_lut), pointer :: lut
  type(gt_bitmap) :: bitmap
  logical :: visible
  character(len=message_length) :: mess
  !
  ! Check the clipping box
  call clip_image(out,  &
    image%r%taille(1),  &
    image%r%taille(2),  &
    image%conv,         &
    image%position,     &
    image%limits,       &
    .false.,            &  ! Do not resample if possible
    2.0,                &  ! Extra resampling factor if resampling (=> 2x72 dpi)
    visible,clip,window,trans)
  if (.not.visible)  return
  !
  write(mess,'(5(A,I0))')  'Image size is ',window(1),'x',window(2),  &
    ', corner at position (',window(3),',',window(4),') "pseudo-pixel" in the PS'
  call gtv_message(seve%d,rname,mess)
  write(mess,'(A,F0.7,A,F0.7,A)')  'Ximag(Xps) = ',trans(2),' + ',trans(1),'*Xps'
  call gtv_message(seve%d,rname,mess)
  write(mess,'(A,F0.7,A,F0.7,A)')  'Yimag(Xps) = ',trans(4),' + ',trans(3),'*Yps'
  call gtv_message(seve%d,rname,mess)
  !
  ! Which LUT use?
  if (associated(image%lut)) then
    lut => image%lut  ! Custom LUT
    call gti_lut(out,lut)  ! Load this LUT, in case it is not yet
  else
    lut => gbl_colormap  ! Global LUT
  endif
  !
  call ps_box(clip)
  !
  ! Allocate the new resampled image
  bitmap%size(1) = window(1)
  bitmap%size(2) = window(2)
  bitmap%position(1) = window(3)
  bitmap%position(2) = window(4)
  bitmap%trans = trans
  if (image%isrgb) then
    allocate(bitmap%irvalues(window(1),window(2)),  &
             bitmap%igvalues(window(1),window(2)),  &
             bitmap%ibvalues(window(1),window(2)),stat=ier)
  else
    allocate(bitmap%irvalues(window(1),window(2)),stat=ier)
    bitmap%igvalues => null()
    bitmap%ibvalues => null()
  endif
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Memory allocation failure')
    return
  endif
  !
  ! Get it from memory...
  call gti_psmap(image,out,bitmap,lut)
  !
  if (associated(bitmap%irvalues))  deallocate(bitmap%irvalues)
  if (associated(bitmap%igvalues))  deallocate(bitmap%igvalues)
  if (associated(bitmap%ibvalues))  deallocate(bitmap%ibvalues)
  !
end subroutine gti_psimage
!
subroutine ps_box(box)
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real :: box(4)                    !
  ! Local
  integer :: ix,iy,offx,offy
  !
  ix=nint( cm2vec*(box(2)-box(1)) )
  iy=nint( cm2vec*(box(4)-box(3)) )
  write (olun,100) 'save '
  if (.not.ps_rotate) then
    offx=cm2vec*box(1)
    offy=cm2vec*box(3)
    write (olun,'(I8,1X,I8,'' translate'')') offx,offy
  else
    offx=(plot_xmax_cm-box(3))*cm2vec
    offy=box(1)*cm2vec
    write (olun,'(I8,1X,I8,'' translate'')') offx,offy
    write (olun,'('' 90 rotate '')')
  endif
  write (olun,'(I8,1X,I8,'' scale'')') ix,iy
100 format(a)
end subroutine ps_box
!
subroutine gti_psmap(image,output,bitmap,lut)
  use gtv_interfaces, except_this=>gti_psmap
  use gildas_def
  use gtv_ps
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_image),   intent(in)    :: image   ! The image to be displayed
  type(gt_display), intent(in)    :: output  ! gt_display instance
  type(gt_bitmap),  intent(inout) :: bitmap  !
  type(gt_lut),     intent(in)    :: lut     ! Colormap to use
  ! Local
  integer :: ncol,offset
  !
  ! Use colour MAP_SIZE for blanking, so there are MAP_SIZE-1 colour
  ! available, from 1 to MAP_SIZE-1...
  ncol = output%dev%map_size-1
  !
  if (ncol.le.2) then
    ncol = 127
    offset = 0
  else
    offset = output%dev%map_offset
  endif
  !
  ! Scaling mode
  call compute_bitmap(image,bitmap,ncol,offset)
  !
  if (ps_color) then
    if (image%isrgb) then
      call ps_image_rgb_color(bitmap)
    else
      call ps_image_ind_color(bitmap,lut)
    endif
  else
    if (image%isrgb) then
      call ps_image_rgb_grey(bitmap)
    else
      call ps_image_ind_grey(bitmap,lut)
    endif
  endif
  !
end subroutine gti_psmap
!
subroutine ps_image_rgb_color(bitmap)
  use gtv_interfaces, except_this=>ps_image_rgb_color
  use gtv_plot
  use gtv_ps
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_bitmap), intent(in) :: bitmap  !
  ! Local
  integer, parameter :: padlen=96   ! Ne pas oublier de changer le format
  integer(kind=1) :: pad(padlen)
  integer(kind=1) :: br(psmap_size),bg(psmap_size),bb(psmap_size)
  integer(kind=4) :: index
  ! Device dependent
  ! Version for 8-bit  Bitmap
  integer(kind=2) :: entier
  integer(kind=1) :: bitval
#if defined(VAX) || defined(IEEE)
  equivalence (entier,bitval)
#endif
#if defined(EEEI)
  integer(kind=1) bitarr(2)
  equivalence (entier,bitarr(1)),(bitarr(2),bitval)
#endif
  integer :: i,j,k
  !
  ! Prepare Byte values for R, G and B
  do i=1,psmap_size
    entier = nint(real(i-1)*255.0/real(psmap_size-1),kind=1)
    br(i) = bitval
    bg(i) = bitval
    bb(i) = bitval
  enddo
  !
  write (olun,100) '%%BeginObject: True Color Image'
  write (olun,100) '/pix 96 string def'
  write (olun,'(I8,1X,I8,'' 8 % NX, NY'')') bitmap%size(1),bitmap%size(2)
  write (olun,'(''[ '',I8,'' 0 0 '',I8,'' 0 '',I8,'' ]'')') bitmap%size(1),-bitmap%size(2),bitmap%size(2)
  write (olun,100) '{currentfile pix readhexstring pop}'
  write (olun,100) 'false 3 colorimage'  ! 3 color planes
  !
  ! write truecolor RGB array in Z format,
  ! cut in 96 bytes, with padding at end.
  k=0
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      index = bitmap%irvalues(i,j)+1-psmap_offset  ! +1 because the values were
                                                   ! shifted by 1 for C indices
      k=k+1
      pad(k)=br(index)
      if(k.ge.padlen)then
        write (olun,'(96Z2.2)') pad
        k=0
      endif
      !
      index = bitmap%igvalues(i,j)+1-psmap_offset  ! +1 because the values were
                                                   ! shifted by 1 for C indices
      k=k+1
      pad(k)=bg(index)
      if(k.ge.padlen)then
        write (olun,'(96Z2.2)') pad
        k=0
      endif
      !
      index = bitmap%ibvalues(i,j)+1-psmap_offset  ! +1 because the values were
                                                   ! shifted by 1 for C indices
      k=k+1
      pad(k)=bb(index)
      if(k.ge.padlen)then
        write (olun,'(96Z2.2)') pad
        k=0
      endif
    enddo
  enddo
  if(k.gt.0)then
    write (olun,'(96Z2.2)') pad
    k=0
  endif
  ! Finish padding image
  write (olun,100) 'restore '
  write (olun,100) '%%EndObject: False Color Image '
  !
100 format(a)
end subroutine ps_image_rgb_color
!
subroutine ps_image_rgb_grey(bitmap)
  use gtv_interfaces, except_this=>ps_image_rgb_grey
  use gtv_plot
  use gtv_ps
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_bitmap), intent(in) :: bitmap  !
  ! Local
  integer, parameter :: padlen=96   ! Ne pas oublier de changer le format
  integer(kind=1) :: pad(padlen)
  integer(kind=1) :: bg(psmap_size)
  real(kind=4) :: lumi
  integer(kind=4) :: index
  ! Device dependent
  ! Version for 8-bit  Bitmap
  integer(kind=2) :: entier
  integer(kind=1) :: bitval
#if defined(VAX) || defined(IEEE)
  equivalence (entier,bitval)
#endif
#if defined(EEEI)
  integer(kind=1) bitarr(2)
  equivalence (entier,bitarr(1)),(bitarr(2),bitval)
#endif
  integer :: i,j,k
  !
  ! Prepare Byte values for grey plane
  do i=1,psmap_size
    entier = nint(real(i-1)*255.0/real(psmap_size-1),kind=1)
    bg(i) = bitval
  enddo
  !
  write (olun,100) '%%BeginObject: True Color Image'
  write (olun,100) '/pix 96 string def'
  write (olun,'(I8,1X,I8,'' 8 % NX, NY'')') bitmap%size(1),bitmap%size(2)
  write (olun,'(''[ '',I8,'' 0 0 '',I8,'' 0 '',I8,'' ]'')') bitmap%size(1),-bitmap%size(2),bitmap%size(2)
  write (olun,100) '{currentfile pix readhexstring pop}'
  write (olun,100) 'false 1 colorimage'  ! 1 color plane
  !
  ! write truecolor grey array in Z format,
  ! cut in 96 bytes, with padding at end.
  k=0
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      lumi = rgb_to_grey(real(bitmap%irvalues(i,j)-psmap_offset+1,kind=4),  &
                         real(bitmap%igvalues(i,j)-psmap_offset+1,kind=4),  &
                         real(bitmap%ibvalues(i,j)-psmap_offset+1,kind=4))
      index = nint(lumi)
      k=k+1
      pad(k)=bg(index)
      if(k.ge.padlen)then
        write (olun,'(96Z2.2)') pad
        k=0
      endif
      !
    enddo
  enddo
  if(k.gt.0)then
    write (olun,'(96Z2.2)') pad
    k=0
  endif
  ! Finish padding image
  write (olun,100) 'restore '
  write (olun,100) '%%EndObject: False Color Image '
  !
100 format(a)
end subroutine ps_image_rgb_grey
!
subroutine ps_image_ind_color(bitmap,lut)
  use gtv_interfaces, except_this=>ps_image_ind_color
  use gtv_ps
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_bitmap), intent(in) :: bitmap  !
  type(gt_lut),    intent(in) :: lut     ! Colormap to use
  ! Local
  integer, parameter :: padlen=96    ! Ne pas oublier de changer le format
  integer(kind=1) :: pad(padlen)
  integer(kind=1) :: br(lut%size),bg(lut%size),bb(lut%size)
  integer :: index
  ! Device dependent
  ! Version for 8-bit  Bitmap
  integer(kind=2) :: entier
  integer(kind=1) :: bitval
#if defined(VAX) || defined(IEEE)
  equivalence (entier,bitval)
#endif
#if defined(EEEI)
  integer(kind=1) bitarr(2)
  equivalence (entier,bitarr(1)),(bitarr(2),bitval)
#endif
  integer :: i,j,k
  !
  ! Prepare Byte values for R, G and B
  do i=1,lut%size
    entier=int(lut%r(i)*255.0)
    br(i)=bitval
    entier=int(lut%g(i)*255.0)
    bg(i)=bitval
    entier=int(lut%b(i)*255.0)
    bb(i)=bitval
  enddo
  !
  write (olun,100) '%%BeginObject: False Color Image'
  write (olun,100) '/pix 96 string def'
  write (olun,'(I8,1X,I8,'' 8 % NX, NY'')') bitmap%size(1),bitmap%size(2)
  write (olun,'(''[ '',I8,'' 0 0 '',I8,'' 0 '',I8,'' ]'')') bitmap%size(1),-bitmap%size(2),bitmap%size(2)
  write (olun,100) '{currentfile pix readhexstring pop}'
  write (olun,100) 'false 3 colorimage'
  !
  ! write tricolor RGB array in Z format,
  ! cut in 96 bytes, with padding at end.
  k=0
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      index = bitmap%irvalues(i,j)+1-psmap_offset  ! +1 because the values were
                                                   ! shifted by 1 for C indices
      k=k+1
      pad(k)=br(index)
      if(k.ge.padlen)then
        write (olun,'(96Z2.2)') pad
        k=0
      endif
      k=k+1
      pad(k)=bg(index)
      if(k.ge.padlen)then
        write (olun,'(96Z2.2)') pad
        k=0
      endif
      k=k+1
      pad(k)=bb(index)
      if(k.ge.padlen)then
        write (olun,'(96Z2.2)') pad
        k=0
      endif
    enddo
  enddo
  if (k.gt.0)then
    write (olun,'(96Z2.2)') pad
    k=0
  endif
  ! Finish padding image
  write (olun,100) 'restore '
  write (olun,100) '%%EndObject: False Color Image '
  !
100 format(a)
end subroutine ps_image_ind_color
!
subroutine ps_image_ind_grey(bitmap,lut)
  use gtv_interfaces, except_this=>ps_image_ind_grey
  use gtv_plot
  use gtv_ps
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_bitmap), intent(in) :: bitmap  !
  type(gt_lut),    intent(in) :: lut     ! Colormap to use
  ! Local
  integer, parameter :: padlen=96    ! Ne pas oublier de changer le format
  integer(kind=1) :: pad(padlen)
  integer(kind=1) :: bg(lut%size)
  integer :: index
  ! Device dependent
  ! Version for 8-bit  Bitmap
  integer(kind=2) :: entier
  integer(kind=1) :: bitval
#if defined(VAX) || defined(IEEE)
  equivalence (entier,bitval)
#endif
#if defined(EEEI)
  integer(kind=1) bitarr(2)
  equivalence (entier,bitarr(1)),(bitarr(2),bitval)
#endif
  integer :: i,j,k
  !
  ! Prepare Byte values for grey plane
  do i=1,lut%size
    entier = nint(rgb_to_grey(lut%r(i),lut%g(i),lut%b(i))*255.)
    bg(i) = bitval
  enddo
  !
  write (olun,100) '%%BeginObject: Grey Scale Image'
  write (olun,100) '/pix 96 string def'
  write (olun,'(I8,1X,I8,'' 8 % NX, NY'')') bitmap%size(1),bitmap%size(2)
  write (olun,'(''[ '',I8,'' 0 0 '',I8,'' 0 '',I8,'' ]'')') bitmap%size(1),-bitmap%size(2),bitmap%size(2)
  write (olun,100) '{currentfile pix readhexstring pop}'
  write (olun,100) 'image'
  !
  ! write monochrom array in Z format,
  ! cut in 96 bytes, with padding at end.
  k=0
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      index = bitmap%irvalues(i,j)+1-psmap_offset  ! +1 because the values were
                                                   ! shifted by 1 for C indices
      k=k+1
      pad(k)=bg(index)
      if(k.ge.padlen)then
        write (olun,'(96Z2.2)') pad
        k=0
      endif
    enddo
  enddo
  if (k.gt.0)then
    write (olun,'(96Z2.2)') pad
    k=0
  endif
  ! Finish padding image
  write (olun,100) 'restore '
  write (olun,100) '%%EndObject: Grey Scale Image '
  !
100 format(a)
end subroutine ps_image_ind_grey
!
subroutine ps_hard(out)
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  !
  !
  ! Dash
  if (out%ps%fast) then
    out%dev%hardw_line_dash = .true.
  elseif (out%idashe.ne.1) then
    out%dev%hardw_line_dash = .false.
  else
    out%dev%hardw_line_dash = .true.
  endif
  !
  ! Weight. Always use hardware thickness generator. Take care
  ! that simulating thickness with gtx_chopper draws several lines
  ! on each side of the original line, which can lead to negative
  ! positions in EPS (i.e. cropped) PostScripts => error!
  out%dev%hardw_line_weig = .true.
  !
end subroutine ps_hard
!
! subroutine ps_rgbbit
!   use gtv_ps
!   !---------------------------------------------------------------------
!   ! @ private
!   ! Note: this is no longer called
!   !---------------------------------------------------------------------
!   integer :: i
!   !
!   ! Close current line
!   call ps_out(s)
!   !
!   ! Old simple code:
!   write (olun,100) '%%BeginObject: Image '
!   write (olun,100) 'gsave '
!   write (olun,'(''/LUTsize '',I3,'' def'')') cmap%size
!   write (olun,100) '/Red LUTsize array def '
!   write (olun,100) '/Green LUTsize array def '
!   write (olun,100) '/Blue LUTsize array def '
!   write (olun,'(18(F6.4,1X))') (cmap%r(i),i=1,cmap%size)
!   write (olun,100) 'Red astore pop'
!   write (olun,'(18(F6.4,1X))') (cmap%g(i),i=1,cmap%size)
!   write (olun,100) 'Green astore pop'
!   write (olun,'(18(F6.4,1X))') (cmap%b(i),i=1,cmap%size)
!   write (olun,100) 'Blue astore pop'
!   !
! 100 format(a)
! end subroutine ps_rgbbit

module cubeset_buffering
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetools_setup_types
  use cubetools_datasize
  use cubeset_messaging
  !
  public :: bufferingcomm
  private
  !
  type :: buffering_comm_t
     type(option_t),      pointer :: comm
     type(option_t),      pointer :: input
     type(keywordlist_comm_t), pointer :: input_arg
     type(option_t),      pointer :: output
     type(keywordlist_comm_t), pointer :: output_arg
     type(option_t),      pointer :: block
     type(option_t),      pointer :: limit
     type(option_t),      pointer :: task
     type(option_t),      pointer :: defaults
   contains
     procedure, public  :: register => cubeset_buffering_register
     procedure, private :: parse    => cubeset_buffering_parse
     procedure, private :: print    => cubeset_buffering_print
  end type buffering_comm_t
  type(buffering_comm_t) :: bufferingcomm
  !
contains
  subroutine cubeset_buffering_command(line,error)
    !---------------------------------------------------------------------
    ! Support routine for command
    ! BUFFERING Mode
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='BUFFERING>COMMAND'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    if (cubetools_nopt().eq.0) then
       call bufferingcomm%print(error)
       return
    endif
    call bufferingcomm%parse(line,error)
    if (error) return
  end subroutine cubeset_buffering_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeset_buffering_register(bufferingcomm,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(buffering_comm_t), intent(inout) :: bufferingcomm
    logical,                 intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: rname='BUFFERING>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'BUFFERING','',&
         'Set how input and output files are buffered',&
         'Large input/output files may not fit in RAM memory.&
         & This command allows the user to tune the CUBE&
         & behavior in such a case. The MEMORY only mode will&
         & return an error, while the DISK mode will read/write&
         & only part of the data in RAM memory at a given time.&
         & The AUTOMATIC mode decides which method to use for&
         & each cube depending on its size. Use /DEFAULT to reset&
         & buffering settings. When /DEFAULT is combined with other&
         & keys on the same command line, reset is applied first.',&
         cubeset_buffering_command,&
         bufferingcomm%comm,error)
    if (error) return
    !
    call cubetools_register_option(&
         'INPUT','value',&
         'Define buffering mode for input files',&
         'Choose whether the input files should be stored entirely in&
         & memory (MEMORY mode), or processed by blocks (DISK mode).&
         & Another possibility is to automatically switch between memory&
         & and disk mode depending on the cube size (AUTOMATIC mode).',&
         bufferingcomm%input,error)
    if (error) return
    call keyarg%register(&
         'value',&
         'Input buffering mode',&
         strg_emp,&
         code_arg_mandatory,&
         buffering,&
         .not.flexible,&
         bufferingcomm%input_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'OUTPUT','value',&
         'Define buffering for output files',&
         'Choose whether the output files should be stored entirely in&
         & memory (MEMORY mode), or processed by blocks (DISK mode).&
         & Another possibility is to automatically switch between memory&
         & and disk mode depending on the cube size (AUTOMATIC mode).',&
         bufferingcomm%output,error)
    if (error) return
    call keyarg%register(&
         'value',&
         'Output buffering mode',&
         strg_emp,&
         code_arg_mandatory,&
         buffering,&
         .not.flexible,&
         bufferingcomm%output_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'BLOCK','size [unit]',&
         'Block size for disk access',&
         'In MEMORY mode, files are read from disk to memory all at&
         & once in a single buffer, but this process is done by blocks&
         & of the given size.'//strg_bl//&
         'In DISK mode files are accessed by contiguous blocks of&
         & limited size. This allows processing of files larger than&
         & the available memory. In serial mode, keeping this&
         & parameter relatively small (e.g. 1% of the file size)&
         & saves memory with marginal file access overheads (e.g. 1%&
         & means 100 accesses to the file). In parallel mode, however&
         &, one might want to increase this value so that a large&
         & slice of the file is loaded in memory and is processed by&
         & several parallelisation tasks: the ideal value is Nthread&
         & times the /TASK size parameter.',&
         bufferingcomm%block,error)
    if (error) return
    call stdarg%register(&
         'size',&
         'Block size for disk mode',&
         'Default is 0.1 GiB.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'unit for block size',&
         'Default is GiB.',&
         code_arg_optional,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'LIMIT','size [unit]',&
         'Define the threshold for DISK use in automatic mode',&
         'In AUTOMATIC mode, define the cube size threshold above&
         & which the file is processed by blocks on disk.',&
         bufferingcomm%limit,error)
    if (error) return
    call stdarg%register(&
         'size',&
         'Limit between DISK access and MEMORY access',&
         'Default is 1 GiB.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'unit for limit',&
         'Default is GiB.',&
         code_arg_optional,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'TASK','size [unit]',&
         'Define parallel task size',&
         'When parallel processing is available, the entries (either&
         &images, spectra, or subcubes) are grouped in different tasks,&
         &and the tasks are executed in parallel.'&
         //strg_bl//&
         'The larger the task, the smaller the task overheads. On the&
         &other hand, if tasks are too large, the currently processed&
         &data block (full file or file block) might not be divided in&
         &enough tasks to occupy all the parallel threads.',&
         bufferingcomm%task,error)
    if (error) return
    call stdarg%register(&
         'size',&
         'Size for parallelisation tasks',&
         'Default is 100 KiB.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'unit for task size',&
         'Default is KiB.',&
         code_arg_optional,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'DEFAULT','',&
         'Reset buffering settings',&
         'Reset BUFFERING settings before applying other keys from the&
         & same command line.',&
         bufferingcomm%defaults,error)
    if (error) return
  end subroutine cubeset_buffering_register
  !
  subroutine cubeset_buffering_parse(bufferingcomm,line,error)
    use cubeadm_setup
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(buffering_comm_t), intent(in)    :: bufferingcomm
    character(len=*),        intent(in)    :: line
    logical,                 intent(inout) :: error
    !
    type(cube_setup_buffer_t) :: defaults
    ! Topics
    logical :: dodefaults
    character(len=*), parameter :: rname='BUFFERING>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call bufferingcomm%defaults%present(line,dodefaults,error)
    if (error) return
    if (dodefaults) then  
       cubset%buff%input   = defaults%input
       cubset%buff%output  = defaults%output
       cubset%buff%limit   = defaults%limit
       cubset%buff%block   = defaults%block
       cubset%buff%task    = defaults%task
    endif
    !
    call cubeset_buffering_parse_mode(line,bufferingcomm%input,bufferingcomm%input_arg,cubset%buff%input,error)
    if (error) return
    call cubeset_buffering_parse_mode(line,bufferingcomm%output,bufferingcomm%output_arg,cubset%buff%output,error)
    if (error) return
    !
    call cubeset_buffering_parse_size(line,bufferingcomm%block,defaults%block,dataunit(iGiB),cubset%buff%block,error)
    if (error) return
    call cubeset_buffering_parse_size(line,bufferingcomm%limit,defaults%limit,dataunit(iGiB),cubset%buff%limit,error)
    if (error) return
    call cubeset_buffering_parse_size(line,bufferingcomm%task,defaults%task,dataunit(ikiB),cubset%buff%task,error)
    if (error) return
  end subroutine cubeset_buffering_parse
  !
  subroutine cubeset_buffering_parse_mode(line,opt,keyarg,mode,error)
    use cubetools_disambiguate
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    type(option_t),       intent(in)    :: opt
    type(keywordlist_comm_t),  intent(in)    :: keyarg
    integer(kind=code_k), intent(out)   :: mode
    logical,              intent(inout) :: error
    !
    logical :: do
    character(len=argu_l) :: argu, key
    character(len=*), parameter :: rname='BUFFERING>PARSE>MODE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call opt%present(line,do,error)
    if (error) return
    if (do) then
       call cubetools_getarg(line,opt,1,argu,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(keyarg,argu,mode,key,error)
       if (error) return
    endif
  end subroutine cubeset_buffering_parse_mode
  !
  subroutine cubeset_buffering_parse_size(line,opt,defsize,defunit,size,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    type(option_t),       intent(in)    :: opt
    real(kind=size_k),    intent(in)    :: defsize
    character(len=*),     intent(in)    :: defunit
    real(kind=size_k),    intent(inout) :: size
    logical,              intent(inout) :: error
    !
    logical :: do
    character(len=argu_l) :: usize, uunit
    character(len=*), parameter :: rname='BUFFERING>PARSE>MODE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call opt%present(line,do,error)
    if (error) return
    if (do) then
       call cubetools_getarg(line,opt,1,usize,mandatory,error)
       if (error) return
       uunit = defunit
       call cubetools_getarg(line,opt,2,uunit,.not.mandatory,error)
       if (error) return
       !
       call cubetools_datasize_user2prog(usize,uunit,defsize,size,error)
       if (error) return
    endif
  end subroutine cubeset_buffering_parse_size
  !
  subroutine cubeset_buffering_print(bufferingcomm,error)
    use cubetools_format
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(buffering_comm_t), intent(in)    :: bufferingcomm
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='BUFFERING>PRINT'
    !
    character(len=message_length) :: mess
    !
    call cubeset_message(seve%r,rname,'  Buffering')
    write(mess,'(2A)')  '    INPUT:  ',buffering(cubset%buff%input)
    call cubeset_message(seve%r,rname,mess)
    write(mess,'(2A)')  '    OUTPUT: ',buffering(cubset%buff%output)
    call cubeset_message(seve%r,rname,mess)
    write(mess,'(2A)')  '    LIMIT:  ',cubetools_format_memsize(cubset%buff%limit)
    call cubeset_message(seve%r,rname,mess)
    write(mess,'(2A)')  '    BLOCK:  ',cubetools_format_memsize(cubset%buff%block)
    call cubeset_message(seve%r,rname,mess)
    write(mess,'(2A)')  '    TASK:   ',cubetools_format_memsize(cubset%buff%task)
    call cubeset_message(seve%r,rname,mess)
  end subroutine cubeset_buffering_print
end module cubeset_buffering

subroutine polyant(iy, m, nbas, iant, jant, iref,   &
    kplus1, nant, x, y, w,   &
    wk1, wk2, wk3, ss, wss, c, error)
  !---------------------------------------------------------------------
  !     polyant computes a weighted least-squares polynimial approximation
  !     to the antenna amplitudes or phases
  !     for an arbitrary set of baseline data points.
  ! parameters:
  !     iy             I   Input    1 for log(amplitude), 2 for phase
  !     m              I   Input    the number of data points for each baseline
  !     nbas           I   Input    the number of baselines
  !     iant(nbas)     I   Input    start antenna for each baseline
  !     jant(nbas)     I   Input    end  antenna for each baseline
  !     iref           i   Input    Reference antenna for phases
  !     kplus1         I   Input    degree of polynomials + 1
  !     nant           I   Input    the number of antennas
  !     x(m)           R8  Input    the data abscissae
  !     y(m,nbas)      R8  Input    the data values
  !     w(m,mbas)      R8  Input    weights
  !     wk1(kplus1)    R8  Output   work space
  !     wk2(kplus1**2*nant**2)
  !                    R8  Output   work space
  !     wk3(kplus1*nant)
  !                    R8  Output   work space
  !     ss(nbas)       R8  Output   rms of fit for each baseline
  !     c(nant,kplus1) R8  Output   the polynomial coefficients
  !---------------------------------------------------------------------
  integer :: iy                           !
  integer :: m                            !
  integer :: nbas                         !
  integer :: iant(nbas)                   !
  integer :: jant(nbas)                   !
  integer :: iref                         !
  integer :: kplus1                       !
  integer :: nant                         !
  real*8 :: x(m)                          !
  real*8 :: y(m,nbas)                     !
  real*8 :: w(m,nbas)                     !
  real*8 :: wk1(kplus1)                   !
  real*8 :: wk2(kplus1*nant,kplus1*nant)  !
  real*8 :: wk3(kplus1*nant)              !
  real*8 :: ss(nbas)                      !
  real*8 :: wss(nbas)                     !
  real*8 :: c(nant,kplus1)                !
  logical :: error                        !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 :: norm, tol
  parameter (tol=1d-14)
  integer :: zant, i, ia, ib, nantm1, j
  integer :: ja, ic, il, kn, kp, k, l, iter
  real*8 ::  wi, xi, wn, ww, www, test, yi, xcap, x1, xn, d
  !------------------------------------------------------------------------
  ! Code
  !
  ! Check that the weights are positive.
  !
  do  i=1,m
    do ib = 1, nbas
      if (w(i,ib).lt.0.0d0) then
        call message(6,4,'POLYANT','Weights not positive')
        error = .true.
        return
      endif
    enddo
  enddo
  x1 = x(1)
  xn = x(m)
  d = xn-x1
  !
  ! Amplitude case is simple...
  !
  if (iy.eq.1) then
    do i=1,nant*kplus1
      do l=1,nant*kplus1
        wk2(l,i) = 0.0d0
      enddo
      wk3(i) = 0.0d0
    enddo
    do i=1, m
      xi = x(i)
      xcap = ((xi-x1)-(xn-xi))/d
      ! compute the chebychev polynomials at point xi.
      call cheb (kplus1, xcap, wk1, error)
      if (error) goto 999
      !
      ! store the upper-triangular part of the normal equations in wk2
      ! and the right-hand side in wk3.
      !
      do k=1, kplus1
        wn = wk1(k)
        il = (k-1)*nant
        do kp = 1, kplus1
          ww = wn*wk1(kp)
          ic = (kp-1)*nant
          do ib=1,nbas
            wi = w(i,ib)
            if (wi.gt.0) then
              ia = iant(ib)
              ja = jant(ib)
              www = wi*ww
              wk2(il+ia,ic+ia) = wk2(il+ia,ic+ia)+www
              wk2(il+ia,ic+ja) = wk2(il+ia,ic+ja)+www
              wk2(il+ja,ic+ia) = wk2(il+ja,ic+ia)+www
              wk2(il+ja,ic+ja) = wk2(il+ja,ic+ja)+www
            endif
          enddo
        enddo
        do ib=1, nbas
          ia = iant(ib)
          ja = jant(ib)
          wi = w(i,ib)*wn*y(i,ib)
          !                  wi = w(i,ib)*wn*xcap*(ja+ia) !**!
          wk3(il+ia) = wk3(il+ia) + wi
          wk3(il+ja) = wk3(il+ja) + wi
        enddo
      enddo
    enddo
    !
    ! Solve the system of normal equations by first computing the Cholesky
    ! factorization
    !
    call mth_dpotrf ('POLYANT',   &
      'U',kplus1*nant,wk2,kplus1*nant,error)
    if (error) goto 999
    call mth_dpotrs ('POLYANT',   &
      'U',kplus1*nant,1,wk2,kplus1*nant,   &
      wk3,kplus1*nant,error)
    if (error) goto 999
    do j=1,kplus1
      do i=1,nant
        c(i,j) = wk3(i+(j-1)*nant)
      enddo
    enddo
  !
  ! Phase is more complicated ...
  elseif (iy.eq.2) then
    nantm1 = nant-1
    do i=1,nant
      do j=1,kplus1
        c(i,j) = 0.0d0
      enddo
    enddo
    !
    ! start iterating
    norm = 1e10
    iter = 0
    do while (norm.gt.tol .and. iter.lt.100)
      iter = iter + 1
      do i=1,nantm1*kplus1
        do l=1,nantm1*kplus1
          wk2(l,i) = 0.0d0
        enddo
        wk3(i) = 0.0d0
      enddo
      do i=1, m
        xi = x(i)
        xcap = ((xi-x1)-(xn-xi))/d
        ! compute the chebychev polynomials at point xi.
        call cheb (kplus1, xcap, wk1, error)
        if (error) goto 999
        !
        do k=1, kplus1
          wn = wk1(k)
          il = (k-1)*nantm1
          do kp = 1, kplus1
            ww = wn*wk1(kp)
            ic = (kp-1)*nantm1
            do ib=1,nbas
              wi = w(i,ib)
              if (wi.gt.0) then
                ia = zant(iant(ib),iref)
                ja = zant(jant(ib),iref)
                www = wi*ww
                if (ia.ne.0) then
                  wk2(il+ia,ic+ia) = wk2(il+ia,ic+ia)+www
                endif
                if (ja.ne.0) then
                  wk2(il+ja,ic+ja) = wk2(il+ja,ic+ja)+www
                endif
                if (ia.ne.0 .and. ja.ne.0) then
                  wk2(il+ja,ic+ia) = wk2(il+ja,ic+ia)-www
                  wk2(il+ia,ic+ja) = wk2(il+ia,ic+ja)-www
                endif
              endif
            enddo
          enddo
          do ib=1, nbas
            if (w(i,ib).gt.0) then
              yi = y(i,ib)
              ia = iant(ib)
              ja = jant(ib)
              do kp=1, kplus1
                yi = yi+(c(ia,kp)-c(ja,kp))*wk1(kp)
              enddo
            !                  yi = xcap*(ja-ia) !**!
            else
              yi = 0
            endif
            !                     if (norm.lt.1e9) then
            yi = sin(yi)
            !                     endif
            ia = zant(iant(ib),iref)
            ja = zant(jant(ib),iref)
            wi = w(i,ib)*wn*yi
            if (ia.ne.0) then
              wk3(ia+il) = wk3(ia+il) - wi
            endif
            if (ja.ne.0) then
              wk3(ja+il) = wk3(ja+il) + wi
            endif
          enddo
        enddo
      enddo
      !            type *, ' wk2 '
      !            do j=1, kplus1*nantm1
      !               type *, j, (wk2(j,i),i=1,nantm1*kplus1)
      !            enddo
      !         type *, ' wk3 ',(wk3(i),i=1,nantm1*kplus1)
      !
      ! Solve the system of normal equations by first computing the Cholesky
      ! factorization
      call mth_dpotrf('POLYANT',   &
        'U',kplus1*nantm1,wk2,kplus1*nant,error)
      if (error) goto 999
      call mth_dpotrs ('POLYANT',   &
        'U',kplus1*nantm1,1,wk2,kplus1*nant,   &
        wk3,kplus1*nantm1,error)
      if (error) goto 999
      !         type *, ' wk3 ',(wk3(i),i=1,nantm1*kplus1)
      !
      !     Add the result to c:
      norm = 0
      do j=1,kplus1
        do ia=1,nant
          i = zant(ia,iref)
          if (i.ne.0) then
            ww = wk3(i+(j-1)*nantm1)
            c(ia,j) = c(ia,j)+ww
            norm = norm+ww**2
          endif
        enddo
      enddo
    !            write(6,*) 'norm' , norm
    enddo
  endif
  !      write(6,*) 'kplus1, j,(c(i,j),i=1, nant)'
  !      do j=1,kplus1
  !         write(6,*) kplus1, j,(c(i,j),i=1, nant)
  !      enddo
  !
  ! loop over data points to get rms
  do ib=1, nbas
    ss(ib) = 0
    wss(ib) = 0
  enddo
  do i = 1, m
    xi = x(i)
    xcap = ((xi-x1)-(xn-xi))/d
    call cheb (kplus1, xcap, wk1, error)
    if (error) goto 999
    do ib=1,nbas
      if (w(i,ib).gt.0) then
        ia = iant(ib)
        ja = jant(ib)
        test = 0
        do kn = 1, kplus1
          wn = wk1(kn)
          if (iy.eq.1) then
            test = test+(c(ia,kn)+c(ja,kn))*wn
          else
            test = test+(-c(ia,kn)+c(ja,kn))*wn
          endif
        enddo
        test = y(i,ib)-test
        if (iy.eq.2) test = mod(test+11*pi,2*pi)-pi
        ss(ib) = ss(ib)+w(i,ib)*test**2
        wss(ib) = wss(ib)+w(i,ib)
      endif
    enddo
  enddo
  do ib=1, nbas
    if (wss(ib).ne.0) then
      ss(ib) = sqrt(ss(ib)/wss(ib))
    else
      ss(ib) = 0
    endif
  enddo
  !      type *,' ss ',(ss(ib),ib=1, nbas)
  !      write(6,*) 'kplus1, j,(c(i,j),i=1, nant)'
  !      do j=1,kplus1
  !         write(6,*) kplus1, j,(c(i,j),i=1, nant)
  !      enddo
  !
  return
999 error = .true.
  return
end subroutine polyant
!
subroutine cheb(nplus1, xcap, p, error)
  !---------------------------------------------------------------------
  !  Compute nplus1 Chebishev Polynomials at x = xcap
  !---------------------------------------------------------------------
  integer :: nplus1                 !
  real*8 :: xcap                    !
  real*8 :: p(nplus1)               !
  logical :: error                  !
  ! Local
  real*8 :: bk, bkp1, bkp2, dk, eta, factor
  integer :: n, k
  !
  !     eta  is the smallest positive number such that
  !     the computed value of  1.0 + eta  exceeds unity.
  !          with NAG,  ETA = X02AAF(1.0D0)
  data eta/1.110223024625156d-16/
  !
  if (nplus1.lt.1) then
    write(6,*) 'F-CHEB, nplus1.lt.1'
    error = .true.
    return
  endif
  if (dabs(xcap).gt.1.0d0+4.0d0*eta) then
    write(6,*) 'F-CHEB, abs(xcap).gt.1'
  endif
  p(1) = 0.5d0
  if (nplus1.le.1) return
  n = nplus1 - 1
  k = n + 2
  if (xcap.lt.-0.5d0) then
    !
    ! Gentleman*s modified recurrence.
    factor = 2.0d0*(1.0d0+xcap)
    dk = -1.0d0
    bk = 0.0d0
    do  k=1,n
      dk = - dk + factor*bk
      bk = dk - bk
      p(k+1) = - dk + 0.5d0*factor*bk
    enddo
  elseif (xcap.le.0.5d0) then
    !
    ! Clenshaw*s original recurrence.
    !
    factor = 2.0d0*xcap
    bkp1 = 0.0d0
    bkp2 = -1.0d0
    do k=1,n
      bk = - bkp2 + factor*bkp1
      p(k+1) = - bkp1 + 0.5d0*factor*bk
      bkp2 = bkp1
      bkp1 = bk
    enddo
  else
    !
    ! Reinsch*s modified recurrence.
    !
    factor = 2.0d0*(1.0d0-xcap)
    dk = 1.0d0
    bk = 0.0d0
    do k=1,n
      dk = dk - factor*bk
      bk = bk + dk
      p(k+1) = dk - 0.5d0*factor*bk
    enddo
  endif
  p(1) = 0.5d0
  return
end subroutine cheb

module sic_hashing_types
  use gmath_quicksort_types
  use sic_types
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  ! Type for sorting type(sic_variable_t) dictionaries
  type, extends(gi4_quicksort_t) :: sic_hassort_t
    type(sic_variable_t), pointer :: dict(:)
  contains
    procedure, public :: compare => sic_hassort_compare
  end type sic_hassort_t
  !
  ! Type for sorting character string dictionaries
  type, extends(gi4_quicksort_t) :: gag_hassort_t
    character(len=:), pointer :: dict(:)
  contains
    procedure, public :: compare => gag_hassort_compare
  end type gag_hassort_t
  !
contains
  !
  function sic_hassort_compare(self,m,l)
    !-------------------------------------------------------------------
    ! Variable comparison function: just compare the variable names
    !-------------------------------------------------------------------
    integer(kind=4) :: sic_hassort_compare
    class(sic_hassort_t), intent(in) :: self
    integer(kind=4),      intent(in) :: m,l
    if (self%dict(m)%id%name.eq.self%dict(l)%id%name) then
      sic_hassort_compare = 0
    elseif (lgt(self%dict(m)%id%name,self%dict(l)%id%name)) then
      sic_hassort_compare = 1
    else
      sic_hassort_compare = -1
    endif
  end function sic_hassort_compare
  !
  function gag_hassort_compare(self,m,l)
    !-------------------------------------------------------------------
    ! Variable comparison function: just compare the variable names
    !-------------------------------------------------------------------
    integer(kind=4) :: gag_hassort_compare
    class(gag_hassort_t), intent(in) :: self
    integer(kind=4),      intent(in) :: m,l
    if (self%dict(m).eq.self%dict(l)) then
      gag_hassort_compare = 0
    elseif (lgt(self%dict(m),self%dict(l))) then
      gag_hassort_compare = 1
    else
      gag_hassort_compare = -1
    endif
  end function gag_hassort_compare
end module sic_hashing_types
!
function sic_hasins(rname,mdim,pf,pn,dict,var,in)
  use gbl_message
  use sic_interfaces, except_this=>sic_hasins
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Insert a new name or replace an existing name
  !       in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASINS      0       E  Invalid name
  !                       1       S  Successfully inserted
  !                       2       E  Too many names
  !                       3       S  Successfully replaced
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasins  ! Function value on return
  character(len=*),       intent(in)    :: rname       ! Calling routine name
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(inout) :: pf(0:27)    !
  integer(kind=4),        intent(inout) :: pn(mdim)    !
  type(sic_variable_t),   intent(inout) :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be inserted
  integer(kind=4),        intent(out)   :: in          ! Address of this variable
  ! Local
  integer(kind=4) :: j,k
  character(len=message_length) :: mess
  !
  in = 0
  sic_hasins = 0
  !
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) then
    call sic_message(seve%e,rname,'Invalid variable name '//var%name)
    return
  endif
  !
  ! Find if it exits already
  k = pf(j)
  do while (k.gt.0)
    if (var%level.eq.dict(k)%id%level .and. var%lname.eq.dict(k)%id%lname) then
      if (var%name(1:var%lname).eq.dict(k)%id%name(1:var%lname)) then
        in = k
        sic_hasins = 3
        return
      endif
    endif
    k = pn(k)
  enddo
  !
  ! Find if place left
  if (pf(26).eq.0) then
    write(mess,'(A,I0,A)')  'Too many variables, set SIC_MAXVAR to more than ',  &
      mdim,' in your $HOME/.gag.dico'
    call sic_message(seve%e,rname,mess)
    sic_hasins = 2
    return
  endif
  !
  ! Insert NAME in place and set pointers
  k = pf(26)
  pf(26) = pn(k)
  pn(k) = pf(j)
  pf(j) = k
  dict(k)%id = var
  in = k
  pf(27) = pf(27)+1
  sic_hasins = 1
  !
end function sic_hasins
!
function sic_hasdel(mdim,pf,pn,dict,var)
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Delete a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASDEL      1       Name deleted
  !                       3       Name does not exist
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasdel  ! Function value on return
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(inout) :: pf(0:27)    !
  integer(kind=4),        intent(inout) :: pn(mdim)    !
  type(sic_variable_t),   intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be deleted
  ! Local
  integer(kind=4) :: j,kl,k
  !
  sic_hasdel = 3
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine if it is a known symbol
  kl = 0
  k = pf(j)
  do while (k.ne.0)
    if (var%level.eq.dict(k)%id%level .and. var%lname.eq.dict(k)%id%lname) then
      if (var%name(1:var%lname).eq.dict(k)%id%name(1:var%lname)) then
        exit
      endif
    endif
    kl = k
    k = pn(k)
  enddo
  if (k.eq.0)  return  ! Nothing found (reached end of dictionary with no matching
                       ! variable)
  !
  ! Now delete it
  sic_hasdel = 1
  if (kl.ne.0) then
    pn(kl) = pn(k)
  else
    pf(j) = pn(k)
  endif
  pn(k) = pf(26)
  pf(26) = k
  pf(27) = pf(27)-1
end function sic_hasdel
!
function sic_hasfin(mdim,pf,pn,dict,var,in)
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Find a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASFIN      0       No such name
  !                       1       Name found
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasfin                          ! Function value on return
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(in)    :: pf(0:27)    !
  integer(kind=4),        intent(in)    :: pn(mdim)    !
  type(sic_variable_t),   intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be found
  integer(kind=4),        intent(out)   :: in          ! Address of this variable
  ! Local
  integer(kind=4) :: j
  !
  ! If no symbol return
  in = 0
  sic_hasfin = 0
  if (pf(27).eq.0) return
  !
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine the chained structure from this point
  j = pf(j)
  do while (j.ne.0)
    if (var%level.eq.dict(j)%id%level .and. var%lname.eq.dict(j)%id%lname) then
      if (var%name(1:var%lname).eq.dict(j)%id%name(1:var%lname)) then
        in = j
        sic_hasfin = 1
        return
      endif
    endif
    j = pn(j)
  enddo
  !
end function sic_hasfin
!
function sic_hasambigs(mdim,pf,pn,dict,name,if,il)
  use sic_dependencies_interfaces
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Find all names beginning with the letters of NAME
  !       in  a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASAMBIGS   0       No such name
  !                       n       N Names found
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasambigs                     ! Value on return
  integer(kind=4),      intent(in)  :: mdim        ! Size of dictionary
  integer(kind=4),      intent(in)  :: pf(0:27)    !
  integer(kind=4),      intent(in)  :: pn(mdim)    !
  type(sic_variable_t), intent(in)  :: dict(mdim)  ! Dictionary array
  character(len=*),     intent(in)  :: name        ! Name against whom search
  integer(kind=4),      intent(out) :: if          ! Adress of first Match
  integer(kind=4),      intent(out) :: il          ! Adress of  last Match
  ! Local
  integer(kind=4) :: j,l
  character(len=varname_length) :: uname
  !
  ! If no symbol return
  if = 0
  il = 0
  sic_hasambigs = 0
  !
  ! Find the place in PF
  l = len_trim(name)
  uname = name
  call sic_upper(uname)
  j = ichar(uname(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  if (pf(27).eq.0) return
  !
  ! Now examine the chained structure from this point
  j = pf(j)
  do while (j.ne.0)
    if (uname(1:l).eq.dict(j)%id%name(1:l)) then
      if (if.eq.0) if = j
      il = j
      sic_hasambigs = sic_hasambigs+1
    endif
    j = pn(j)
  enddo
  if (if.eq.0) return
  !
  if (if.eq.il .and. uname.eq.dict(if)%id%name) return
  !
  call sic_message(seve%w,'SIC','Ambiguous Name, Could be:')
  j = ichar(uname(1:1))-ichar('A')
  j = pf(j)
  !
  do while (j.ne.0)
    if (uname(1:l).eq.dict(j)%id%name(1:l)) then
      write (*,'(A)') trim(dict(j)%id%name)
    endif
    j = pn(j)
  enddo
  !
end function sic_hasambigs
!
subroutine sic_hassort(mdim,pf,pn,dict,list,leng)
  use sic_dependencies_interfaces
  use sic_hashing_types
  use sic_interfaces, except_this=>sic_hassort
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !
  !  List alphabetically a dictionnary using a hashing structure and a
  ! list of pointers. This routine just builds the list of pointers to
  ! current entries.
  !
  !   PF(0:27)   PF(0:25) Address of first name beginning with
  !                       CHAR(J-ICHAR('A')) in dictionnary.
  !              PF(26)   is the address of the first available place.
  !              PF(27)   the number of symbols
  !   PN(MDIM)            Address of next name with same first letter.
  !                       If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4),              intent(in)  :: mdim        ! Size of dictionnary
  integer(kind=4),              intent(in)  :: pf(0:27)    !
  integer(kind=4),              intent(in)  :: pn(mdim)    !
  type(sic_variable_t), target, intent(in)  :: dict(mdim)  ! Dictionary array
  integer(kind=4),              intent(out) :: list(mdim)  ! List of entries in dictionnary
  integer(kind=4),              intent(out) :: leng        ! Current number of entries
  ! Local
  integer(kind=4) :: i,j,first,last
  type(sic_hassort_t) :: hassort
  logical :: error
  !
  leng = 0
  if (pf(27).eq.0)  return  ! Empty dictionnary
  !
  error = .false.
  hassort%dict => dict
  !
  do i=0,25
    if (pf(i).le.0)  cycle  ! Next letter
    !
    j = pf(i)
    leng = leng+1
    list(leng) = j
    first = leng  ! First index for the current letter
    do while (pn(j).gt.0)
      j = pn(j)
      leng = leng+1
      list(leng) = j
    enddo
    last = leng  ! Last index for the current letter
    !
    ! Now sort the list for this letter
    call hassort%sort(list(first:last),last-first+1,error)
    if (error)  return
    !
  enddo
  !
end subroutine sic_hassort
!
subroutine gag_hassort(mdim,pf,pn,dict,list,leng)
  use sic_dependencies_interfaces
  use sic_hashing_types
  use sic_interfaces, except_this=>gag_hassort
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as character string arrays ***
  !  (This subroutine should go in kernel/lib/gsys/hashing.f90 but
  !   the module gmath_quicksort_types is needed.)
  !
  !  List alphabetically a dictionnary using a hashing structure and a
  ! list of pointers. This routine just builds the list of pointers to
  ! current entries.
  !
  !   PF(0:27)   PF(0:25) Address of first name beginning with
  !                       CHAR(J-ICHAR('A')) in dictionnary.
  !              PF(26)   is the address of the first available place.
  !              PF(27)   the number of symbols
  !   PN(MDIM)            Address of next name with same first letter.
  !                       If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)  :: mdim        ! Size of dictionnary
  integer(kind=4),          intent(in)  :: pf(0:27)    !
  integer(kind=4),          intent(in)  :: pn(mdim)    !
  character(len=*), target, intent(in)  :: dict(mdim)  ! Dictionary array
  integer(kind=4),          intent(out) :: list(mdim)  ! List of entries in dictionnary
  integer(kind=4),          intent(out) :: leng        ! Current number of entries
  ! Local
  integer(kind=4) :: i,j,first,last
  type(gag_hassort_t) :: hassort
  logical :: error
  !
  leng = 0
  if (pf(27).eq.0)  return  ! Empty dictionary
  !
  error = .false.
  hassort%dict => dict
  !
  do i=0,25
    if (pf(i).le.0)  cycle  ! Next letter
    !
    j = pf(i)
    leng = leng+1
    list(leng) = j
    first = leng  ! First index for the current letter
    do while (pn(j).gt.0)
      j = pn(j)
      leng = leng+1
      list(leng) = j
    enddo
    last = leng  ! Last index for the current letter
    !
    ! Now sort the list for this letter
    call hassort%sort(list(first:last),last-first+1,error)
    if (error)  return
    !
  enddo
  !
end subroutine gag_hassort

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetuple_get
  use gkernel_interfaces
  use cubetools_parameters
  use cubetools_access_types
  use cubetools_setup_types
  use cubedag_tuple
  use cubeio_cube_define
  use cubetuple_messaging
  use cubetuple_format_class
  use cubetuple_tuple
  !
  public :: cubetuple_get_cube_header
  private
  !
contains
  !
  subroutine cubetuple_get_cube_header(cub,error)
    !-------------------------------------------------------------------
    ! Get the header of a tuple. Basically 2 possibilities:
    ! 1) already loaded in memory => nothing to do
    ! 2) not yet loaded => read from disk
    ! Also set the desired access as current default. Take care of
    ! possible transposition involved.
    !-------------------------------------------------------------------
    class(format_t), intent(inout) :: cub
    logical,         intent(inout) :: error
    ! Local
    logical :: found
    character(len=file_l) :: cubename
    integer(kind=4) :: hdu
    character(len=maxdim) :: iorder
    character(len=*), parameter :: rname='GET>CUBE>HEADER'
    !
    if (.not.cub%prog%doaccess) then
      call cubetuple_message(seve%e,rname,'Expected cube access is not set')
      error = .true.
      return
    endif
    !
    ! Search for header in memory
    call cubetuple_get_cube_header_from_memory(cub%user,cub%prog,cub,found,error)
    if (error)  return
    if (found) then
      call cubetuple_message(seve%d,rname,  &
        'Header already available in memory => not reloaded')
      return
    endif
    !
    ! Search for data in memory (should not happen!)
    call cubetuple_search_dagcube(cub%node%tuple,cub%prog%access,  &
      code_buffer_memory,found,iorder,cubename,hdu,error)
    if (error) return
    if (found) then
      call cubetuple_message(seve%e,rname,'Internal error: cube data '//  &
        'is declared found in memory but its header is not available')
      error = .true.
      return
    endif

    ! Search for header on disk and load it
    call cubedag_tuple_diskupdate(cub%node%tuple,error)
    if (error)  return
    call cubetuple_search_dagcube(cub%node%tuple,cub%prog%access,  &
      code_buffer_disk,found,iorder,cubename,hdu,error)
    if (error) return
    if (found) then
      ! Note that the 'iorder' (intrinsic order) fetched from the DAG is
      ! valid for the returned cubename[hdu] (not its transposed)
      call cubetuple_message(seve%d,rname,  &
        'Header not yet available in memory => loading from disk')
      call cubetuple_read_cube_header(cubename,hdu,'???',iorder,cub,error)
      return
    endif

    ! Last fallback: file is not loaded in memory and was not found on
    ! disk. Likely the disk file was removed. Header interface was saved in
    ! the DAG file and was loaded in the DAG node.
    ! Note the data is lost and will not be accessible later on.
    call cubetuple_get_cube_header_from_dag(cub%user,cub%prog,cub,error)
    if (error)  return
  end subroutine cubetuple_get_cube_header
  !
  subroutine cubetuple_read_cube_header(cubename,hdu,cubeid,iorder,cub,error)
    !-------------------------------------------------------------------
    ! Read the header of a tuple, (re)loaded from disk.
    ! Also set the desired access as current default. Take care of
    ! possible transposition involved.
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: cubename
    integer(kind=4),  intent(in)    :: hdu
    character(len=*), intent(in)    :: cubeid  ! Identifier (feedback only)
    character(len=*), intent(in)    :: iorder  ! Associated intrinsic order for cubename[hdu]
    class(format_t),  intent(inout) :: cub     ! In return might be the direct or transposed cube
    logical,          intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='READ>CUBE>HEADER'
    !
    call cub%prog%set_filename(cubename,hdu,error)
    if (error)  return
    call cub%prog%set_id(cubeid,error)
    if (error)  return
    call cubetuple_get_cube_header_from_disk(cub%user,cub%prog,iorder,cub,error)
    if (error)  return
  end subroutine cubetuple_read_cube_header
  !
  subroutine cubetuple_search_dagcube(tuple,access,location,found,  &
    iorder,cubename,hdu,error)
    !-------------------------------------------------------------------
    ! Search if the DAG references an up-to-date version of the data,
    ! either in memory or disk, either direct or transposed.
    !-------------------------------------------------------------------
    type(cubedag_tuple_t), intent(in)    :: tuple
    integer(kind=code_k),  intent(in)    :: access    ! Per spectrum/image/any?
    integer(kind=code_k),  intent(in)    :: location  ! Memory or disk?
    logical,               intent(out)   :: found     !
    character(len=*),      intent(out)   :: iorder    ! If found, associated intrinsic order
    character(len=*),      intent(out)   :: cubename  ! Cube name on disk, if relevant
    integer(kind=4),       intent(out)   :: hdu       ! HDU number in the disk file, if relevant
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='SEARCH>DAGCUBE'
    integer(kind=code_k) :: laccess(3)
    integer(kind=4) :: naccess,iaccess
    !
    select case (access)
    case (code_access_imaset,code_access_speset)
      naccess = 2
      laccess(1) = access
      laccess(2) = cubetools_transpose_access(access)
    case (code_access_imaset_or_speset)
      naccess = 2
      laccess(1) = code_cube_speset  ! ZZZ Is this the default?
      laccess(2) = code_cube_imaset
    case (code_access_any,code_access_subset,code_access_fullset)
      naccess = 3
      laccess(1) = code_cube_speset  ! ZZZ Is this the default?
      laccess(2) = code_cube_imaset
      laccess(3) = code_cube_unkset
    case (code_access_user)
      call cubetuple_message(seve%e,rname,  &
        'Internal error: code_access_user should have been resolved at run time')
      error = .true.
      return
    case default
      call cubetuple_message(seve%e,rname,'Internal error: unsupported access code')
      error = .true.
      return
    end select
    !
    do iaccess=1,naccess
      found = cubedag_tuple_hasuptodatefile(tuple,laccess(iaccess),location,  &
        iorder,cubename,hdu)
      if (found)  return
    enddo
  end subroutine cubetuple_search_dagcube
  !
  subroutine cubetuple_get_cube_header_from_memory(cubset,cubdef,cub,found,error)
    use cubeio_desc_setup
    !----------------------------------------------------------------------
    ! From a cube already in memory, set the desired access as the default
    ! one
    !----------------------------------------------------------------------
    type(cube_setup_t),      intent(in)    :: cubset
    type(cube_define_t),     intent(in)    :: cubdef
    class(format_t), target, intent(inout) :: cub
    logical,                 intent(out)   :: found
    logical,                 intent(inout) :: error
    ! Local
    integer(kind=4) :: dcube
    character(len=*), parameter :: rname='GET>CUBE>HEADER>FROM>MEMORY'
    !
    call cubetuple_message(seve%t,rname,'Welcome')
    !
    found = .false.
    !
    ! Search in memory
    call cubetuple_search_tuplecube(rname,cubset,cubdef,cub,dcube,error)
    if (error)  return
    !
    if (dcube.eq.0)  return
    !
    ! Set this access as the current one
    found = .true.
    call cub%tuple%set_current(dcube,error)
    if (error)  return
    !
    ! Update the descriptor (external components which might need changes)
    call cubeio_set_descriptor_external(cubset,cubdef,.true.,cub%tuple%current,error)
    if (error)  return
  end subroutine cubetuple_get_cube_header_from_memory
  !
  subroutine cubetuple_get_cube_header_from_disk(cubset,cubdef,iorder,cub,error)
    use cubeio_highlevel
    !----------------------------------------------------------------------
    ! Get the type(cube_header_t) of a cube, and set the current access
    ! mode for future get_chan or get_pix
    !----------------------------------------------------------------------
    type(cube_setup_t),      intent(in)    :: cubset
    type(cube_define_t),     intent(in)    :: cubdef
    character(len=*),        intent(in)    :: iorder
    class(format_t), target, intent(inout) :: cub
    logical,                 intent(inout) :: error
    ! Local
    integer(kind=4) :: dcube
    character(len=*), parameter :: rname='GET>CUBE>HEADER>FROM>DISK'
    !
    call cubetuple_message(seve%t,rname,'Welcome')
    !
    ! Read header from disk
    call cubeio_get_header(cubset,cubdef,cub,cub%tuple%cube(1),error)
    if (error)  return
    ! The iorder is valid for the input cubdef%filename and hdu => set it for
    ! this cube:
    call cub%tuple%cube(1)%set_iorder(iorder,error)
    if (error)  return
    !
    ! Search if it is direct or transposed cube
    call cubetuple_search_tuplecube(rname,cubset,cubdef,cub,dcube,error)
    if (error)  return
    !
    ! Sanity: should not happen
    if (dcube.eq.0) then
      call cubetuple_message(seve%e,rname,'Internal error: could not get proper access')
      error = .true.
      return
    endif
    !
    ! Set this access as the current one
    call cub%tuple%set_current(dcube,error)
    if (error)  return
  end subroutine cubetuple_get_cube_header_from_disk
  !
  subroutine cubetuple_get_cube_header_from_dag(cubset,cubdef,cub,error)
    use cubeio_highlevel
    use cubeio_desc_setup
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_setup_t),      intent(in)    :: cubset
    type(cube_define_t),     intent(in)    :: cubdef
    class(format_t), target, intent(inout) :: cub
    logical,                 intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>CUBE>HEADER>FROM>DAG'
    !
    call cubetuple_message(seve%t,rname,'Welcome')
    !
    call cubeio_interface_put(cub,cub%prog%access,cub%tuple%current,error)
    if (error) return
    !
    ! Update the descriptor (external components which might need changes)
    call cubeio_set_descriptor_external(cubset,cubdef,.true.,cub%tuple%current,error)
    if (error)  return
  end subroutine cubetuple_get_cube_header_from_dag
  !
  subroutine cubetuple_search_tuplecube(rname,cubset,cubdef,cub,dcube,error)
    use cubeio_transpose
    !-------------------------------------------------------------------
    ! Find which cube in the cub%tuple structure is the 'direct' one for
    ! cubdef%access
    !-------------------------------------------------------------------
    character(len=*),    intent(in)    :: rname
    type(cube_setup_t),  intent(in)    :: cubset
    type(cube_define_t), intent(in)    :: cubdef
    class(format_t),     intent(inout) :: cub
    integer(kind=4),     intent(out)   :: dcube  ! Direct cube. Return 0 if not available
    logical,             intent(inout) :: error  !
    ! Local
    integer(kind=4) :: tcube  ! Transposed cube
    integer(kind=code_k) :: fromorder
    logical :: already_in_memory
    !
    ! Search direct access in cubes already in memory
    dcube = cubetuple_find_access(cub%tuple,cubdef%access)
    if (dcube.ne.0) then
      ! The direct cube is found
      return  ! Already loaded: nothing more to do
    endif
    !
    if (cubdef%access.ne.code_access_imaset .and.  &
        cubdef%access.ne.code_access_speset) then
      ! If we are searching for exact image or spectrum access, the direct
      ! access was not found, try to search for its transposed. Otherwise,
      ! there is nothing more we can search => leave
      return
    endif
    !
    ! Not found: search transposed access in cubes already in memory
    tcube = cubetuple_find_access(cub%tuple,cubetools_transpose_access(cubdef%access))
    if (tcube.eq.0)  return  ! The transposed cube is not available => nothing more we can do
    !
    ! The transposed cube was found in the tuple. Derive the direct cube
    ! from it:
    ! 1) Memory-to-memory transposition of header
    fromorder = cub%tuple%cube(tcube)%order()
    call cubetools_transpose_operator(  &
      fromorder,  &
      cubetools_access2order(cubdef%access),  &
      cub%tuple%trans%code,error)
    if (error)  return
    dcube = cubetuple_norder+1-tcube  ! Swap 1 <-> 2
    call cubeio_transpose_cube_desc(cubset,cubdef,  &
                                    cub%tuple%cube(tcube),  &
                                    cub%tuple%cube(dcube),  &
                                    error)
    if (error)  return
    ! 2) Enable later transposition of data
    already_in_memory = cub%tuple%cube(tcube)%desc%buffered.eq.code_buffer_memory .and.  &
                        cub%tuple%cube(tcube)%ready()
    if (already_in_memory .or. cubset%buff%input.eq.code_buffer_memory) then
      call cubetuple_message(tupleseve%trans,rname,  &
        'Data will be transposed in memory')
      cub%tuple%trans%do = code_trans_memo
    else
      call cubetuple_message(tupleseve%trans,rname,  &
        'Data will be transposed on disk to file '//trim(cub%tuple%cube(dcube)%file%name))
      cub%tuple%trans%do = code_trans_disk
    endif
    cub%tuple%trans%from = tcube
    cub%tuple%trans%to   = dcube
    !
  end subroutine cubetuple_search_tuplecube
  !
  function cubetuple_find_access(tuple,access)
    use cubetuple_tuple
    !---------------------------------------------------------------------
    ! Find which cube in the cubetuple_t (return its index in this
    ! structure) provides the desired access.
    !
    ! This subroutine precisely offers the heuristic to choose the proper
    ! order corresponding to the requested access.
    !---------------------------------------------------------------------
    integer(kind=4) :: cubetuple_find_access
    type(cubetuple_t), intent(in) :: tuple
    integer(kind=4),   intent(in) :: access  ! Desired access, can be code for any
    ! Local
    integer(kind=4) :: iorder
    !
    ! print *,">>> Searching for ",cubetools_accessname(access)
    cubetuple_find_access = 0
    !
    ! Search in the cubes list, i.e. in
    !    tuple%cube(1)
    !    tuple%cube(2)
    !    etc (should there be more)
    ! which cube matches the desired access. When the access is flexible
    ! (like code_access_any), precedence is given to the 'current' order.
    ! ZZZ If we are flexible, we should also give precedence to the cubes
    !     with data already available.
    !
    if (tuple%icurrent.ne.0) then  ! Can it really be 0?
      ! Try current cube first:
      if (this_cube_matches(tuple%icurrent)) then
        cubetuple_find_access = tuple%icurrent
        return
      endif
    endif
    !
    ! Then try all cubes (except current, already tested)
    do iorder=1,cubetuple_norder
      if (iorder.eq.tuple%icurrent)  cycle
      if (this_cube_matches(iorder)) then
        cubetuple_find_access = iorder
        return
      endif
    enddo
    !
  contains
    !
    function this_cube_matches(iorder)
      logical :: this_cube_matches
      integer(kind=4), intent(in) :: iorder
      ! Local
      integer(kind=code_k) :: thisorder
      !
      this_cube_matches = .false.
      ! Sanity
      if (tuple%trans%do.ne.code_trans_none .and. tuple%trans%to.eq.iorder) then
        ! A transposition for this access is pending: this access is not
        ! ready for use.
        return
      endif
      thisorder = tuple%cube(iorder)%order()
      ! print *,">>> Testing for ",cubetools_ordername(thisorder)
      select case (access)
      case (code_access_any,code_access_subset,code_access_fullset)  ! Any access is accepted
        this_cube_matches = thisorder.ne.code_null
      case (code_access_imaset_or_speset)
        this_cube_matches = thisorder.eq.code_cube_imaset .or.  &
                            thisorder.eq.code_cube_speset
      case (code_access_imaset,code_access_speset)  ! A specific access is requested
        this_cube_matches = thisorder.eq.cubetools_access2order(access)
      end select
    end function this_cube_matches
  end function cubetuple_find_access
end module cubetuple_get
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
!-------------------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoOtfMap">
!   <VERSION>
!                Id: modulePakoOtfMap.f90,v 1.2.4  2015-06-17 Hans Ungerechts
!                Id: modulePakoOtfMap.f90,v 1.2.3  2014-12-15 Hans Ungerechts
!                Id: modulePakoOtfMap.f90,v 1.2.3  2014-10-27 Hans Ungerechts
!                Id: modulePakoOtfMap.f90,v 1.2.3  2013-10-17 Hans Ungerechts
!                Id: modulePakoOtfMap.f90,v 1.2.3  2013-09-29 Hans Ungerechts
!                Id: modulePakoOtfMap.f90,v 1.2.3  2013-09-23 Hans Ungerechts
!                                           1.2.3  2013-08-28 Hans Ungerechts
!                                           1.2.3  2013-07-18 Hans Ungerechts
!                                           1.2.3  2013-07-11 Hans Ungerechts
!                                           1.2.3  2013-06-18 Hans Ungerechts
!                                           1.2.3  2013-05-29 Hans Ungerechts
!                                           1.2.1  2013-04-10 Hans Ungerechts
!                    review against pako           2012-11-30
!                    modulePakoOtfMap.f90,v 1.1.12 2012-03-28
!
!                !!  1.2.1 review wrt pako 1.1.14 2012-11-30; modulePakoOtfMap.f90,v 1.1.12 2012-03-28          
!                !!        diff -W 200 -y -b -B modulePakoOtfMap.f90 ~/Pako/pako-2012-11-30/lib/                         
!
!                Id: modulePakoOtfMap.f90,v 1.2.0  2012-08-16 Hans Ungerechts
!
!   </VERSION>
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>
!                Calibrate
!                Focus
!                OnOff
!                OtfMap
!                Pointing
!                Tip
!                Track
!                VLBI
!   </SIBLINGS>        
!
!   Pako module for command: OTFMAP
!
! </DOCUMENTATION> <!-- name="modulePakoOtfMap" -->
!
!-------------------------------------------------------------------------------
!
Module modulePakoOtfmap
  !
  Use modulePakoTypes
  Use modulePakoMessages
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  Use modulePakoDIYlist
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  Public :: otfMap, displayOtfMap, saveOtfMap, startOtfMap
  !     
  ! *** Variables for otfmap ***
  Include 'inc/variables/variablesOtfMap.inc'
!!!   
!!!   
Contains
!!!
!!!
  Subroutine OTFMAP(programName,line,command,error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
!!OLD      Integer              ::  iMatch = 0 , nMatch = 0
!!OLD      Character (len=128)  ::  errorCode = 'none'
!!OLD      Logical              ::  errorM = .False.
    !
    ! *** special working variables:   ***
    Logical               :: optionSpeedIsPresent, optionTotfIsPresent
    Logical, Dimension(3) :: alternative
    Real                  :: vIn, vStdMin, vStdMax, vLimitMin, vLimitMax
    !
    Real                  :: vMaxX,   vMaxY
    Real                  :: vLimit, vLimitAz, vLimitEl
    Real                  :: vMaxXel, vMaxYel, MaxEl
    !
    Logical               :: isConnected   = .False.
    Real                  :: mapRotation   = 0.0
    !
    Character (len=lenCh) ::  bolometerName
    !
    Logical               :: errorCount
    Integer               :: nSubscansCal, nSubscansReference
    Integer               :: nSubscansOTF, nSubscansTotal
    !
    Type(conditionMinMax)  ::  condElevation                                     &
         &                     = conditionMinMax("elevation",                    &
         &                                        0.0, Pi/2.0,                   &
         &                                       "rad",                          &
         &                                       .False.         )               ! 
    !
    optionSpeedIsPresent = .False.
    optionTotfIsPresent  = .False.
    alternative          = .False.
    !
    errorCount           = .False.
    nSubscansCal         = 0
    nSubscansReference   = 0
    nSubscansOTF         = 0
    nSubscansTotal       = 0
    !
    !     TBD: the following shall be replaced by a SR reading from XML:
    Include 'inc/ranges/rangesOtfMap.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module OtfMap, v 1.2.3 2013-07-11---> SR: OtfMap ")                ! trace execution
    !
    ! *** initialize:   ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    Call checkNofParameters(command,                                             &
         &     0, 4,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    ! *** check for alternative Options   ***
    If (.Not. ERROR) Then
       Include 'inc/options/alternativeSpeedTotf.inc'
    End If
    !
    ! *** read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/parameters/parametersStartEnd.inc'
       Include 'inc/parameters/parametersLengthOtf.inc'
       Include 'inc/options/readOptionsOtfMap.inc'
    End If
    !
    ! *** set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          Include 'inc/variables/setDefaults.inc'
       Endif
    Endif
    !
    ! *** Read Parameters, Options (again, after defaults!)   ***
    ! *** and check for validity and ranges                   ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/parameters/parametersStartEnd.inc'
       Include 'inc/parameters/parametersLengthOtf.inc'
       Include 'inc/options/readOptionsOtfMap.inc'
       Include 'inc/options/alternativeSpeedTotfSet.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.ERROR) Then    !!   check consistency
       !
       errorInconsistent = .False.
       !
       Include 'inc/options/checkConsistentLengthOtfSpeedTotf.inc'
       !
       If (.Not. errorInconsistent) Then
          Include 'inc/options/checkConsistentNresumeNotf.inc'
       End If
       !
       !D       Write (6,*) "      vars(iIn)%tOtf:   ", vars(iIn)%tOtf
       !D       Write (6,*) "      GV%tRecord:       ", GV%tRecord
       If (vars(iIn)%tOtf .Lt. 5*GV%tRecord) Then
          If (vars(iIn)%tOtf .Lt. 3*GV%tRecord) Then
             errorInconsistent = .True.
             Write (messageText,*)    "must be at least 3 times "                &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityE,severityE,                               &
                  &           command(1:l)//"/"//"tOtf",messageText)             !
          Else
             Write (messageText,*)    "should be at least 5 times "              &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityW,severityW,                               &
                  &           command(1:l)//"/"//"tOtf",messageText)             !
          End If
       End If
       !
       If (vars(iIn)%doReference                                                 &
            &  .And.   vars(iIn)%tReference .Lt. 5*GV%tRecord) Then              !
          If (vars(iIn)%tReference .Lt. 3*GV%tRecord) Then
             errorInconsistent = .True.
             Write (messageText,*)    "must be at least 3 times "                &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityE,severityE,                               &
                  &           command(1:l)//"/"//"tReference",messageText)       !
          Else
             Write (messageText,*)    "should be at least 5 times "              &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityW,severityW,                               &
                  &           command(1:l)//"/"//"tReference",messageText)       !
          End If
       End If
       !
       If (vars(iIn)%doReference                                                 &
            &  .And. vars(iIn)%systemNameRef.Ne.vars(iIn)%systemName) Then       !
          errorInconsistent = .True.
          GV%notReadyOtfMap = .True.
          Write (messageText,*) "different values for /SYSTEM ",                 &  
               &  "and /REFERENCE are not yet allowed "                          !
          Call pakoMessage(priorityE,severityE,                                  &
               &           command//"/"//"REFERENCE",messageText)                !
       End If
       !
       If (    .Not. (GV%privilege.Eq.setPrivilege%staff                         &
            &  .Or.   GV%privilege.Eq.setPrivilege%ncsTeam)) Then                !
          If (GV%switchingMode.Eq.swMode%Beam) Then
             errorInconsistent = .True.
             GV%notReadyOtfMap = .True.
             Write (messageText,*)  "not compatible with with switching mode ",  &
                  &                 swModePako%Beam                              !
             Call PakoMessage(priorityE,severityE,command,messageText)
          End If
       End If
       !

!!$!! possible new code to consider as replacement (2014-10-17)
!!$       !D        Write (6,*) "      GV%switchingMode:   ", GV%switchingMode
!!$       !D        Write (6,*) "      GV%privilege:       ", GV%privilege
!!$       !D        Write (6,*) "      GV%iPrivilege:       ", GV%iPrivilege
!!$       !D        Write (6,*) "      GV%userLevel:       ", GV%userLevel
!!$       !D        Write (6,*) "      GV%iUserLevel:      ", GV%iUserLevel
!!$       !
!!$       If (           GV%switchingMode.Eq.swMode%Beam                            &
!!$            &  .And. .Not.(      GV%iUserLevel.Ge.iexperienced                   &
!!$            &               .Or. GV%privilege.Eq.setPrivilege%ncsTeam            &
!!$            &             )                                                      &
!!$            & ) Then                                                             !
!!$          !
!!$          errorInconsistent = .True.
!!$          Write (messageText,*)  "not compatible with with switching mode ",  &
!!$               &                 swModePako%Beam                              !
!!$          !
!!$       End If

       !
       If (        vars(iIn)%doReference .And. GV%switchingMode.Eq.swMode%Freq   &
            & .Or. vars(iIn)%doReference .And. GV%switchingMode.Eq.swMode%Wobb ) &
            & Then                                                               !
          errorInconsistent = .True.
          GV%notReadyOtfMap = .True.
          Write (messageText,*)  "will not work with switching mode ",           &
               &                 GV%switchingMode                                !
          Call PakoMessage(priorityE,severityE,command//" /reference",           &
               &                 messageText)                                    !
          Write (messageText,*)  "consider to use: /reference no" 
          Call PakoMessage(priorityI,severityI,command,                          &
               &                 messageText)                                    !
       End If
       !
       Call queryReceiver(rec%bolo, isConnected)
       !D       Write (6,*) "vars(iIn)%systemName : ", vars(iIn)%systemName
       !D       Write (6,*) "offsPako%tru :         ", offsPako%tru
       If (isConnected .And. GV%switchingMode.Eq.swMode%Wobb                     &
            &          .And. vars(iIn)%systemName .Eq. offsPako%tru) Then        !
          !D          Write (6,*) "GV%secondaryRotation:", GV%secondaryRotation
          !D          Write (6,*) "vars(iIn)%pStart:    ", vars(iIn)%pStart
          !D          Write (6,*) "vars(iIn)%pEnd:      ", vars(iIn)%pEnd
          !D          Write (6,*) "rotation angle of OTF map: ",         &
          !D               &       vars(iIn)%pEnd%y,vars(iIn)%pStart%y,  &
          !D               &       vars(iIn)%pEnd%x,vars(iIn)%pStart%x
          mapRotation =                                                          &
               & -atan((vars(iIn)%pEnd%y-vars(iIn)%pStart%y)                     &
               &      /(vars(iIn)%pEnd%x-vars(iIn)%pStart%x))/deg                !
          !D          Write (6,*) "rotation angle of OTF map: ",         &
          !D               & mapRotation
          If (Abs(GV%secondaryRotation-mapRotation).GT.0.005) Then
             errorInconsistent = .True.
             GV%notReadyOtfMap = .True.
             Write (messageText,*)      "map rotation ", mapRotation,            &
                  &   " inconsistent with 2ndRotation ", GV%secondaryRotation    !
             Call PakoMessage(priorityE,severityE,command,messageText)      
          End If
       End If
       !
       Call countSubscansOtfMap                                                  &
            &   ( nSubscansCal, nSubscansReference, nSubscansOTF, nSubscansTotal,&
            &     errorCount )                                                   !
       !
       If (               errorCount                                             &
            &  .And. .Not.GV%privilege.Eq.setPrivilege%ncsTeam ) Then            ! allow "too many" subscans
          !                                                                      ! (only for tests of antMD)
          errorInconsistent = .True.
          Write (messageText,*)     " too many subscans. OTF: ",                 &
               &                      vars(iIn)%nOtf,                            &
               &                    " + Reference: ",                            &
               &                      nSubscansReference                         !
          Call PakoMessage(priorityE,severityE,command,messageText)      
          Write (messageText,*)     " maximum OTF + Reference: ",                &
               &                      vars(iLimit2)%nOtf                         !
          Call PakoMessage(priorityE,severityW,command,messageText)      
       End If
       !
       If (.Not. errorInconsistent) Then
          vars(iTemp) = vars(iIn)
       End If
       !
    End If   !!   check consistency
    !
    !D     Write (6,*) "       errorInconsistent:  ", errorInconsistent
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** conclude alternative options   ***
    If (.Not.error) Then
       Include 'inc/options/alternativeSpeedTotfEnd.inc'
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    If (.Not.error) Then     !!    speed limit and elevation condition
       !
       vMaxX  =   max(vars(iTemp)%speedStart, vars(iTemp)%speedEnd)
       vMaxY  =   max(vars(iTemp)%speedStart, vars(iTemp)%speedEnd)
       !
       !! TBD: (2012-03-17) more sophisticated criterium
       !! --> 2012-03-25:
       !
       If (         vars(iTemp)%systemName.Eq.offsPako%tru                       &
            &  .Or. vars(iTemp)%systemName.Eq.offsPako%hor) Then                 !
          !
          vMaxX  =   Abs(vars(iTemp)%pEnd%x-vars(iTemp)%pStart%x)                &
               &        /vars(iTemp)%tOtf                                        !
          vMaxY  =   Abs(vars(iTemp)%pEnd%y-vars(iTemp)%pStart%y)                &
               &        /vars(iTemp)%tOtf                                        !
          !
       Else
          vMaxX  =   max(vars(iTemp)%speedStart, vars(iTemp)%speedEnd)
          vMaxY  =   max(vars(iTemp)%speedStart, vars(iTemp)%speedEnd)
       End If
       !
       !! TBD: use same code (ectract!) as in POINTING (see!). note added 2012-05-30
       !! TBD: long-term: ramp-up!
       !
       !                        !!  speed limit az. axis, el. axis
       vLimit   = 200.0         !!  based on tests 2012-03-15 to -20
       !                                 
       !
       If      (     GV%privilege.Eq.setPrivilege%ncsTeam                        &
            &  .Or.  GV%userLevel.Eq.setUserLevel%experienced                    &
            &  ) Then                                                            !
          If (GV%limitCheck.Eq.setLimitCheck%loose)   vLimit = 300.0 
          If (GV%limitCheck.Eq.setLimitCheck%relaxed) vLimit = 220.0
       End If
       !
       vLimitAz = vLimit        !!  speed limit az axis
       vLimitEl = vLimit        !!  speed limit el axis
       !
       !! aLimit = 108.0*arcsec
       !
       If (GV%doDebugMessages) Then
          Write (6,*) " vMaxX:     ", vMaxX
          Write (6,*) " vMaxY:     ", vMaxY
          Write (6,*) " vLimit:    ", vLimit
          Write (6,*) " vLimitAz:  ", vLimitAz
          Write (6,*) " vLimitEl:  ", vLimitEl
       End If
       !
       If (         vars(iTemp)%systemName.Eq.offsPako%tru                       &
            &  .Or. vars(iTemp)%systemName.Eq.offsPako%hor) Then                 !
          !
          If (vMaxX.Le.vLimitAz) Then
             vMaxXel = Acos(vMaxX/(vLimitAz))
          Else
             errorInconsistent = .true.
             Write (messageText,*) "Azimuth speed ", vMaxX,                      &
                  &                " too large for safe tracking"                !
             Call PakoMessage(priorityE,severityE,command,messageText)
          End If
          !
          If (vMaxY.Le.vLimitEl) Then
             vMaxYel = 90.0*deg
          Else
             errorInconsistent = .true.
             Write (messageText,*) "Elevation speed ", vMaxY,                    &
                  &                " too large for safe tracking"                !
             Call PakoMessage(priorityE,severityE,command,messageText)
          End If
          !
       Else
          !
          If (vMaxX.Le.vLimit .And. vMaxY.Le.vLimit) Then
             vMaxXel = Acos(vMaxX/(vLimit))
             vMaxYel = Acos(vMaxY/(vLimit))
          Else
             errorInconsistent = .true.
             Write (messageText,*) "Speed ", max(vMaxX,vMaxY),                   &
                  &                " too large for safe tracking"                !
             Call PakoMessage(priorityE,severityE,command,messageText)
          End If
          !
       End If
       !
       If (GV%doDebugMessages) Then
          Write (6,*) " max el vMaxXel: ", vMaxXel/deg
          Write (6,*) " max el vMaxYel: ", vMaxYel/deg
       End If
       !
       !! <<-- 2012-03-25
       !
       !! aMaxXel = Acos(aMaxX/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
       !! aMaxYel = Acos(aMaxY/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
       !
       MaxEl   = min(vMaxXel,vMaxYel)
       !
       ! 2010-04-08 HU: force safe limit on maximum elevation
       !                for GISMO run, based on TT-NCS
       MaxEl = MaxEl-2.0*deg
       !
       !D        Write (6,*) " max el  MaxEl:  ", MaxEl/deg
       !
       MaxEl   = max(0.0*deg,MaxEl) 
       MaxEl   = min(MaxEl,85.0*deg)
       !
       !D        Write (6,*) " max el vMaxXel: ", vMaxXel/deg
       !D        Write (6,*) " max el vMaxYel: ", vMaxYel/deg
       !D        Write (6,*) " max el aMaxXel: ", aMaxXel/deg
       !D        Write (6,*) " max el aMaxYel: ", aMaxYel/deg
       !D        !
       !D        Write (6,*) " max el  MaxEl:  ", MaxEl/deg
       !
       !!             If (MaxEl.Ge.60.0*deg) Then
       !
       condElevation%isSet     = .True.
       condElevation%maximum   = MaxEl
       !
       If (GV%doDebugMessages) Then
          Write (6,*) " condElevation%isSet:   ", condElevation%isSet
          Write (6,*) " condElevation%maximum: ", condElevation%maximum/deg
       End If
       !
       Write (messageText, fmt =                                           &
            &  '("WARNING--CONDITION: Elevation must be less than ",       &
            &     F10.2,                                                   &
            &    " [deg] ")' )                                             &
            & condElevation%maximum/deg                                    !
       Call pakoMESSAGE(priorityW,severityW,"OTFMAP",messageText)
       !
    End If     !!    speed limit and elevation condition
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)  = vars(iTemp)
    End If
    !
    If (.Not.error) Then
       GV%observingMode     = OM%OtfMap
       GV%observingModePako = OMpako%OtfMap
       !D       Write (6,*) "   GV%observingMode: ", GV%observingMode
    End If
    !
    ! *** set "selected" observing mode & plot ***
    If (.Not.error) Then
       GV%observingMode     = OM%OtfMap
       GV%observingModePako = OMpako%OtfMap
       GV%omSystemName      = vars(iValue)%systemName 
       GV%condElevation     = condElevation
       If (GV%doDebugMessages) Then
          Write (6,*) "GV%condElevation: ", GV%condElevation
       End If
       !
       GV%notReadySWafterOM = .False.
       GV%notReadySecondaryRafterOM = .False.
       !D       Write (6,*) '      GV%notReadySecondaryRafterOM: ',                       &
       !D            &             GV%notReadySecondaryRafterOM
       GV%notReadyOtfMap    = .False.
       otfMapCommand        = line(1:lenc(line))
       Call analyzeOtfMap (errorA)
       Call plotOtfMap (errorP)
    End If
    !
    ! *** display values ***
    If (.Not. ERROR) Then
       Call displayOtfMap
       Call listDIYlist (error)
    End If
    !
    Return
  End Subroutine OTFMAP
!!!
!!!
  Subroutine displayOtfMap
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Call pako_message(seve%t,"OTFMAP",                                           &
         &  " module OtfMap, v 1.2.0  --> SR: displayOtfMap ")                   ! trace execution
    !
    Include 'inc/display/commandDisplayOtfMap.inc'
    !
  End Subroutine displayOtfMap
!!!
!!!
  Subroutine countSubscansOtfMap                                                 &
       &   ( nSubscansCal, nSubscansReference, nSubscansOTF, nSubscansTotal,     &
       &     errorCount )                                                        !
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical, Intent(OUT) :: errorCount
    Integer, Intent(OUT) :: nSubscansCal, nSubscansReference
    Integer, Intent(OUT) :: nSubscansOTF, nSubscansTotal
    !
    !! NOTE: the following counting of subscans must reflect analyzeOtfMap
    !
    Integer              :: iCRO          = 0       ! counts through CRO loop
    Integer              :: iCROnext      = 0       !        next iCRO
    Integer              :: iSS           = 0       ! counts subcans/segment
    Integer              :: iOTF          = 0       ! counts OTF subscans
    Integer              :: iREF          = 0       ! counts REF subscans
    Integer              :: iCAL          = 0       ! counts CAL subscans
    !
    Logical              :: lastIsCAL     = .False. ! tracks if last subscans
    !                                               !   added in loop is CAL
    Logical              :: lastIsOTF     = .False. ! tracks if last subscans
    !                                               !   added in loop is OTF
    Character (len=1)    :: cCroII        = ''      ! stores previous CRO code    
    !
    errorCount           = .False.
    nSubscansCal         = 0
    nSubscansReference   = 0
    nSubscansOTF         = 0
    nSubscansTotal       = 0
    !
    lastIsCAL            = .False.
    lastIsOTF            = .False.
    !
    If (GV%doDebugMessages) Then
       Write (6,*) "  "
       Write (6,*) "   ---> SR countSubscansOtfMap "
       Write (6,*) "  "
       Write (6,*) "      vars(iIn)%croCodeCount: ", vars(iIn)%croCodeCount
       Write (6,*) "      vars(iIn)%croCodeBites: ", vars(iIn)%croCodeBites
    End If
    !
    iCRO = 0
    iSS  = 0
    iOTF = 0
    iREF = 0
    iCAL = 0
    !
    cCroII = ''
    !
    Do While (iOTF .Lt. vars(iIn)%nOtf)
       !
       iCRO     = iCRO+1
       iCROnext = iCRO+1
       !
       iCRO = Modulo(iCRO,vars(iIn)%croCodeCount)
       If (iCRO.Eq.0) iCRO = vars(iIn)%croCodeCount
       iCROnext = Modulo(iCROnext,vars(iIn)%croCodeCount)
       If (iCROnext.Eq.0) iCROnext = vars(iIn)%croCodeCount
       !
       If (vars(iIn)%croCodeBites(iCRO:iCRO).Eq."C") Then
          !
          iSS  = iSS  +1            !! CAL SKY
          iCAL = iCAL +1
          iSS  = iSS  +1            !! CAL AMBIENT
          iCAL = iCAL +1
          iSS  = iSS  +1            !! CAL COLD
          iCAL = iCAL +1
          !
          lastIsCAL            = .True.
          lastIsOTF            = .False.
          !
          If (GV%doDebugMessages) Then
             Write (6,*) "      loop: added CAL "
             Write (6,*) "      iCRO: ", iCRO, " iSS: ", iSS, " iCAL: ", iCAL
          End If
          !
       End If
       !
       If (vars(iIn)%doReference .And.                            &
            &         vars(iIn)%croCodeBites(iCRO:iCRO).Eq."R") Then
          !
          iSS  = iSS  +1            !! REFERENCE
          iREF = iREF +1
          !
          cCroII = vars(iIn)%croCodeBites(iCRO:iCRO)
          !
          lastIsCAL            = .False.
          lastIsOTF            = .False.
          !
          If (GV%doDebugMessages) Then
             Write (6,*) "      loop: added REF "
             Write (6,*) "      iCRO: ", iCRO, " iSS: ", iSS, " iREF: ", iREF
          End If
          !
       End If
       !
       If (vars(iIn)%croCodeBites(iCRO:iCRO).Eq."O") Then
          !
          iSS  = iSS  +1            !! OTF
          iOTF = iOTF +1
          !
          cCroII = vars(iIn)%croCodeBites(iCRO:iCRO)
          !
          lastIsCAL            = .False.
          lastIsOTF            = .True.
          !
          If (GV%doDebugMessages) Then
             Write (6,*) "      loop: added OTF "
             Write (6,*) "      iCRO: ", iCRO, " iSS: ", iSS, " iOTF: ", iOTF
          End If
          !
       End If
       !
    End Do
    !
    nSegments = iSS
    !
    ii = vars(iIn)%croCodeCount
    If (vars(iIn)%doReference                                                    &
         &         .And.((vars(iIn)%croCodeBites(ii:ii).Eq."R"                   &      
         &                   .And. lastIsOTF)                                    &
         &               .Or.                                                    &
         &               (vars(iIn)%croCodeBites(ii-1:ii).Eq."RC"                &      
         &                   .And. lastIsOTF)                                    &
         &              )                                                        &
         &        ) Then                                                         !
       !
       iSS  = iSS  +1            !! add REFERENCE at end
       iREF = iREF +1
       !
       cCroII = vars(iIn)%croCodeBites(iCRO:iCRO)
       !
       If (GV%doDebugMessages) Then
          Write (6,*) "      end:  added REF "
          Write (6,*) "      iCRO: ", iCRO, " iSS: ", iSS, " iREF: ", iREF
       End If
       !
    End If
    !
    nSegments = iSS
    !
    ii = vars(iIn)%croCodeCount
    If ( vars(iIn)%croCodeBites(ii:ii).Eq."C"                                    &      
         &         .And. .Not. lastIsCal                                         &
         &        ) Then                                                         !
       !                         !! add CAL at end
       iSS  = iSS  +1            !! CAL SKY
       iCAL = iCAL +1
       iSS  = iSS  +1            !! CAL AMBIENT
       iCAL = iCAL +1
       iSS  = iSS  +1            !! CAL COLD
       iCAL = iCAL +1
       !
       If (GV%doDebugMessages) Then
          Write (6,*) "      end:  added CAL "
          Write (6,*) "      iCRO: ", iCRO, " iSS: ", iSS, " iCAL: ", iCAL
       End If
       !
    End If
    !
    nSegments = iSS
    !
!!$    Write (messageText,*)  "   number of Subscans/Segments: ", nSegments
!!$    Call pakoMessage(priorityI,severityI,                                        &
!!$         &           "OTFMAP "//" countSubscansOtfMap",messageText)              !
    !
    nSubscansCal        =  iCal
    nSubscansReference  =  iREF
    nSubscansOTF        =  iOTF
    nSubscansTotal      =  iSS
    !
    If (GV%doDebugMessages) Then
       Write (6,*) "  "
       !D        Write (6,*) "      vars(iIn)%croCodeCount: ", vars(iIn)%croCodeCount
       !D        Write (6,*) "      vars(iIn)%croCodeBites: ", vars(iIn)%croCodeBites
       Write (6,*) "      nSegments:              ", nSegments
       Write (6,*) "      nSubscansCal:           ", nSubscanscal
       Write (6,*) "      nSubscansReference:     ", nSubscansReference
       Write (6,*) "      nSubscansOTF:           ", nSubscansOTF
       Write (6,*) "      nSubscansTotal:         ", nSubscansTotal
       Write (6,*) "      vars(iLimit2)%nOtf:     ", vars(iLimit2)%nOtf
    End If
    !
    If (nSubscansTotal.Gt.vars(iLimit2)%nOtf ) Then
       errorCount = .True.
    End If
    !
    If (GV%doDebugMessages) Then
       Write (6,*) "  "
       Write (6,*) "   <--- SR countSubscansOtfMap "
       Write (6,*) "  "
    End If
    !
    Return
    !
  End Subroutine countSubscansOtfMap
!!!
!!!
  Subroutine analyzeOtfMap (errorA)
    !
    ! TBD:  support of several reference positions
    ! TBD:  support of /RESUME
    !
    ! <DOCUMENTATION name="analyzeOtfMap">
    !
    ! 
    ! The sequence of subscans is determined by 
    ! /croLoop /nOtf /reference /step /zigzag
    !
    ! TBD 2014: document /tune
    ! 
    ! /croLoop     sequence of 
    !              C Calibration
    !              R off-source Reference
    !              O on-source OTF
    ! /nOtf        number of OTF subscans
    ! /reference   off-source reference position
    ! /step        step in x and y between OTF subscans
    !              = translation of one OTF subscans to the next
    ! /zigzag      option to scan back-and-forth
    ! 
    ! The scan analysis loops through the letter codes in croLoop
    ! until nOtf OTF subscans have been generated, starting with 
    ! first letter in the croLoop.
    !    
    !    IF THE CROCODE LETTER IS "C":
    !    
    !    3 calibration subscans on cold load, ambient load, and sky
    !    are generated. The position of the (sky) calibration subscan is:
    !     - the (next) reference position if /reference is true, else:
    !       - if there is one calibration between 2 OTF subscans,
    !         the start position of the next OTF subscan
    !       - if there are two calibrations between 2 OTF subscans,
    !         the first (sky) calibration will be at the end 
    !         the end of the previous OTF subscan
    !    
    !    IF THE CROCODE LETTER IS "R" AND /REFERENCE IS TRUE:
    !    
    !    1 subscan tracking the fixed off-source reference position
    !    is generated
    !    
    !    IF THE CROCODE LETTER IS "O":
    !    
    !    1 linear OTF subscan is generated. 
    !    - The start and end positions of the first OTF subscan are:
    !      parameters xStart yStart xEnd yEnd of the OTFMAP command
    !    - For the second all following OTF subscans:
    !      xStart yStart xEnd yEnd of the previous OTF subscan are
    !      incremented by parameters dx and dy of option /step
    !      If /zigzag is true, xStart yStart and xEnd yEnd are
    !      interchanged
    !    
    ! Then the next letter code in the croLoop is considered
    ! in the same way.
    ! 
    ! If /reference is true,
    ! a croCode ending in "RC" or "R" will ensure that an off-source
    ! reference subscan follows the last OTF subscan.
    ! 
    ! A croCode ending in "C" will ensure that the subscan sequence
    ! ends with 3 calibration subscans on cold load, ambient load, and sky.
    ! - The position of the calibration sky subscan will be that of
    !   the last off-source reference position if /reference is true, else:
    ! - the end(!)  position of the last OTF subscan
    !
    ! </DOCUMENTATION> <!-- name="analyzeOtfMap" -->
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer              :: nScan 
    Character (len=12)   :: aUnit, sUnit
    Integer              :: iCRO          = 0     ! counts through CRO loop
    Integer              :: iCROnext      = 0     !        next iCRO
    Integer              :: iSS           = 0     ! counts subcans/segment
    Integer              :: iOTF          = 0     ! counts OTF subscans
    !
    Character (len=1)    :: cCroII        = ''    ! stores previous CRO code    
    !
    Real                 :: tQuant, vQuant
    !
    errorA = .False.
    !
    Call pako_message(seve%t,"OTFMAP",                                           &
         &  " module OtfMap, v 1.2.4  2015-06-17 --> SR: analyzeOtfMap ")        ! trace execution
    !
    If (GV%doDebugMessages) Then
       !
       Write (6,*) "     "
       Write (6,*) "     vars(iValue)%tOtf:         ",  vars(iValue)%tOtf
       Write (6,*) "     vars(iValue)%lengthOtf     ",  vars(iValue)%lengthOtf
       Write (6,*) "     vars(iValue)%speedStart:   ",  vars(iValue)%speedStart
       Write (6,*) "     vars(iValue)%speedEnd:     ",  vars(iValue)%speedEnd
       Write (6,*) "     "
       !
    End If
       !
       tQuant  =  vars(iValue)%tOtf
       vQuant  =  vars(iValue)%speedStart 
       !
    If (GV%doDebugMessages) Then
       !
       Write (6,*) "     tQuant:                    ",  tQuant
       Write (6,*) "     vQuant:                    ",  vQuant
       Write (6,*) "     "
       !
    End If
       !  
    If ( Index(GV%testMode,"quant").Ge.1 ) Then                                                      !  
       !
       If (GV%doDebugMessages) Then
          Write (6,*) "      analyzeOtfMap: GV%testMode:   ", GV%testMode
          Write (6,*) "      --> will apply quantisation of OTF time, speed "
       End If
       !
       tQuant  =  tQuant - Mod(tQuant,0.125) !!  + 0.125   !! ??                 !  !!  TBD 2014: test
       !       
       If (GV%doDebugMessages) Then
          Write (6,*) "     tQuant:                    ",  tQuant
          Write (6,*) "     vQuant:                    ",  vQuant
          Write (6,*) "     "
       End If
       !
       tQuant  =  tQuant + 0.001
       !
       vQuant  =  vars(iValue)%lengthOtf  /  tQuant
       !
       If (GV%doDebugMessages) Then
          Write (6,*) "     tQuant:                    ",  tQuant
          Write (6,*) "     vQuant:                    ",  vQuant
          Write (6,*) "     "
       End If
       !
    End If
    !
    ! TBD:  proper scan numbers
    nScan     = 1111
    aUnit     = GV%angleUnitC
    sUnit     = GV%speedUnitC
    !
    Call countSubscans(value=0)
    Call countSegments(value=0)
    !
    iCRO = 0
    iSS  = 0
    iOTF = 0
    !
    cCroII = ''
    !
    If (vars(ivalue)%doTune) Then
       !
       If (GV%doDebugMessages) Then
          Write (6,*) "  --> Tune Subscan "
          Write (6,*) "      vars(iValue)%doTune : ", vars(iValue)%doTune
          Write (6,*) "      vars(iValue)%tTune :  ", vars(iValue)%tTune
       End If
       !
       Call countSubscans(ii)
       Call countSegments(jj)
       !            
       iSS = iSS+1
       !
       segList(iSS)            =  segDefault                    ! TUNE
       !
       segList(iSS)%newSubscan =  .True.
       segList(iSS)%scanNumber =  nScan
       segList(iSS)%ssNumber   =  iSS
       segList(iSS)%segNumber  =  1
       segList(iSS)%ssType     =  ss%tune
       segList(iSS)%segType    =  seg%track
       segList(iSS)%angleUnit  =  aUnit
       segList(iSS)%speedUnit  =  sUnit
       !
       segList(iSS)%flagOn     =  .True.
       segList(iSS)%flagRef    =  .False.
       !
       segList(iSS)%flagDropin =  .False.
       !
       segList(iSS)%flagTune   =  vars(iIn)%doTune
       !
!!$       If (vars(ivalue)%doReference) Then
!!$          segList(iSS)%pStart     =  vars(iValue)%offsetR
!!$       Else
!!$          segList(iSS)%pStart     =  vars(iValue)%pStart
!!$       End If
       !
       segList(iSS)%pStart     =  vars(iValue)%offsetTune
       !
       segList(iSS)%pEnd       =  segList(iSS)%pStart
       segList(iSS)%speedStart =  0.0
       segList(iSS)%speedEnd   =  0.0
       segList(iSS)%systemName =  vars(iValue)%systemName
       segList(iSS)%altOption  =  'tSegment'
       segList(iSS)%tSegment   =  vars(iValue)%tTune
       segList(iSS)%tRecord    =  0.1
       !
!!$          iQuery    = iPro
!!$          nameQuery = GPnone
!!$          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
       !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
       !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
       !
       ! TBD: clever /proper handling of Doppler 
       segList(iSS)%upDateDoppler = .False.
       !
       If (GV%doDebugMessages) Then
          Write (messageText,*)  "  subscan #:   ", iSS, " ",                    &
               &             segList(iSS)%ssType, " ", segList(iSS)%pStart       !
!!$            &           " segList(iSS)%flagTune: ", segList(iSS)%flagTune        !
          Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
          !
          Write (6,*) "  <-- Tune Subscan "
       End If
       !
    End If   !!   (vars(ivalue)%doTune)
    !
    Do While (iOTF .Lt. vars(iValue)%nOtf)
       !
       iCRO     = iCRO+1
       iCROnext = iCRO+1
       !
       !D           write (6,*) "   ++iCRO: ", iCRO
       !
       iCRO = Modulo(iCRO,vars(iValue)%croCodeCount)
       If (iCRO.Eq.0) iCRO = vars(iValue)%croCodeCount
       iCROnext = Modulo(iCROnext,vars(iValue)%croCodeCount)
       If (iCROnext.Eq.0) iCROnext = vars(iValue)%croCodeCount
       !
       !D           write (6,*) "     iCRO:     ", iCRO
       !D           write (6,*) "      CRO(",iCRO,"):   ->",                      &
       !D     &                 vars(iValue)%croCodeBites(iCRO:iCRO),"<-"
       !D           write (6,*) "     iCROnext: ", iCROnext
       !D           write (6,*) "      CRO(",iCROnext,"):   ->",                  &
       !D     &                 vars(iValue)%croCodeBites(iCROnext:iCROnext),"<-"
       !D
       !D           write (6,*) "     iSS:  ", iSS
       !D           write (6,*) "     iOTF: ", iOTF
       !D!
       !D           write (6,*) " is C? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."C"
       !D           write (6,*) " is c? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."c"
       !D           write (6,*) " is R? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."R"
       !D           write (6,*) " is r? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."r"
       !D           write (6,*) " is O? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."O"
       !D           write (6,*) " is o? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."o"
       !
       !D           write (6,*) '      cCroII: ', cCroII
       !
       If (vars(iValue)%croCodeBites(iCRO:iCRO).Eq."C") Then
          !
          iSS = iSS+1
          segList(iSS)            =  segDefault                    ! CAL COLD
          segList(iSS)%newSubscan =  .True.
          segList(iSS)%scanNumber =  nScan
          segList(iSS)%ssNumber   =  iSS
          segList(iSS)%segNumber  =  1
          segList(iSS)%ssType     =  ss%cc
          segList(iSS)%segType    =  seg%track
          segList(iSS)%angleUnit  =  aUnit
          segList(iSS)%speedUnit  =  sUnit
          segList(iSS)%flagOn     =  .False.
          segList(iSS)%flagRef    =  .False.
          If (vars(iValue)%doReference) Then
             segList(iSS)%pStart     =  vars(iValue)%offsetR
          Else If (iOTF.Eq.0) Then
             segList(iSS)%pStart     =  vars(iValue)%pStart
          Else If (vars(iValue)%croCodeBites(iCROnext:iCROnext).Eq."C") Then
             segList(iSS)%pStart%x   =  segOtfII%pEnd%x
             segList(iSS)%pStart%y   =  segOtfII%pEnd%y
          Else If (vars(iValue)%doZigzag) Then
             segList(iSS)%pStart%x   =  segOtfII%pEnd%x+vars(iValue)%delta%x
             segList(iSS)%pStart%y   =  segOtfII%pEnd%y+vars(iValue)%delta%y
          Else
             segList(iSS)%pStart%x   =  segOtfII%pStart%x+vars(iValue)%delta%x
             segList(iSS)%pStart%y   =  segOtfII%pStart%y+vars(iValue)%delta%y
          End If
          segList(iSS)%pEnd       =  segList(iSS)%pStart
          segList(iSS)%speedStart =  0.0
          segList(iSS)%speedEnd   =  0.0
          ! TBD: systemName in case of REF sysem .NE. OTF system
          segList(iSS)%systemName =  vars(iValue)%systemName
          segList(iSS)%altOption  =  'tSegment'
          ! TBD: time from CALIBRATE
          segList(iSS)%tSegment   =  5.0
          segList(iSS)%tRecord    =  vars(iValue)%tRecord
          Write (messageText,*)  "  subscan #:   ", iSS, " ",                    &
               &           segList(iSS)%ssType                                   !
          Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
          !
          iSS = iSS+1
          segList(iSS)            =  segList(iSS-1)                ! CAL AMBIENT
          segList(iSS)%ssNumber   =  iSS
          segList(iSS)%ssType     =  ss%ca
          Write (messageText,*)  "  subscan #:   ", iSS, " ",                    &
               &           segList(iSS)%ssType                                   !
          Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
          !
          iSS = iSS+1
          segList(iSS)            =  segList(iSS-1)                ! CAL SKY
          segList(iSS)%ssNumber   =  iSS
          segList(iSS)%ssType     =  ss%cs
          Write (messageText,*)  "  subscan #:   ", iSS, " ",                    &
               &           segList(iSS)%ssType, segList(iSS)%pStart              !
          Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
          !
          cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
          !
       End If
       !
       If (vars(iValue)%doReference .And.                            &
            &         vars(iValue)%croCodeBites(iCRO:iCRO).Eq."R") Then
          !
          Call countSubscans(ii)
          Call countSegments(jj)
          !
          iSS = iSS+1
          segList(iSS)            =  segDefault                    ! REFERENCE
          segList(iSS)%newSubscan =  .True.
          segList(iSS)%scanNumber =  nScan
          segList(iSS)%ssNumber   =  iSS
          segList(iSS)%segNumber  =  1
          segList(iSS)%ssType     =  ss%ref
          segList(iSS)%segType    =  seg%track
          segList(iSS)%angleUnit  =  aUnit
          segList(iSS)%speedUnit  =  sUnit
          segList(iSS)%flagOn     =  .False.
          segList(iSS)%flagRef    =  .True.
          segList(iSS)%pStart     =  vars(iValue)%offsetR
          segList(iSS)%pEnd       =  vars(iValue)%offsetR
          ! TBD: system name for REF
          segList(iSS)%systemName =  vars(iValue)%systemName
          segList(iSS)%altOption  =  'tSegment'
          segList(iSS)%speedStart =  0.0
          segList(iSS)%speedEnd   =  0.0
          segList(iSS)%tSegment   =  vars(iValue)%tReference
          segList(iSS)%tRecord    =  vars(iValue)%tRecord
          !
          If (GV%doDebugMessages) Then
             Write (messageText,*)  " s #:   ", iSS, " ", segList(iSS)%ssType
             Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
             Write (messageText,*)  "  ___ flagOn ",   segList(iSS)%flagOn,      &
                  &                        " flagRef ",  segList(iSS)%flagRef    !
             Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
             Write (messageText,*)  "  ___ position [arcsec] ",                  &
                  &                             segList(iSS)%pStart              !
             Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
             Write (messageText,*)  "  ___ tSegment [s]",                        &
                  &                                        segList(iSS)%tSegment !
             Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
          End If
          !
          cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
          !
       End If
       !
       If (vars(iValue)%croCodeBites(iCRO:iCRO).Eq."O") Then
          !
!!$          Call countSubscans(ii)
!!$          Call countSegments(jj)
          !
          iSS  = iSS+1
          iOTF = iOTF+1
          If (iOTF.Eq.1) Then
             segOtfII            =  segDefault                    ! first OTF
             segList(iSS)%newSubscan =  .True.
             segOtfII%scanNumber =  nScan
             segOtfII%ssNumber   =  iSS
             segOtfII%segNumber  =  1
             segOtfII%ssType     =  ss%otf
             segOtfII%segType    =  seg%linear
             segOtfII%angleUnit  =  aUnit
             segOtfII%speedUnit  =  sUnit
             segOtfII%flagOn     =  .True.
             segOtfII%flagRef    =  .False.
             segOtfII%pStart     =  vars(iValue)%pStart  
             segOtfII%pEnd       =  vars(iValue)%pEnd  
             segOtfII%lengthOtf  =  vars(iValue)%lengthOtf
             segOtfII%systemName =  vars(iValue)%systemName
             segOtfII%altOption  =  vars(iValue)%altOption
             segOtfII%speedStart =  vQuant
             segOtfII%speedEnd   =  vQuant
             segOtfII%tSegment   =  tQuant
!!$             segOtfII%speedStart =  vars(iValue)%speedStart
!!$             segOtfII%speedEnd   =  vars(iValue)%speedEnd
!!$             segOtfII%tSegment   =  vars(iValue)%tOtf
             segOtfII%tRecord    =  vars(iValue)%tRecord
!!$             segList(iSS)        =  segOtfII
          Else                                                 ! More OTF
             segOtfII%ssNumber   =  iSS
             If (vars(iValue)%doZigzag) Then
                pII              =  segOtfII%pStart
                segOtfII%pStart  =  segOtfII%pEnd
                segOtfII%pEnd    =  pII
             End If
             segOtfII%pStart%x   =  segOtfII%pStart%x+vars(iValue)%delta%x
             segOtfII%pStart%y   =  segOtfII%pStart%y+vars(iValue)%delta%y
             segOtfII%pEnd%x     =  segOtfII%pEnd%x  +vars(iValue)%delta%x
             segOtfII%pEnd%y     =  segOtfII%pEnd%y  +vars(iValue)%delta%y
!!$             segList(iSS)        =  segOtfII
          End If
          !

          !    ** lead-in and ramps 2014-09                                      !  !! 
          !
          If ( Index(GV%testMode,"lead").Ge.1 ) Then                             !  !!    lead-in
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "      analyzeOtfMap: GV%testMode:   ", GV%testMode
                Write (6,*) "      --> will prepare lead-in before OTF subscans "
             End If
             !
             pStart   = segOtfII%pStart
             vStart%x = vars(iValue)%speedStart                                  &
                  &        * (segOtfII%pEnd%x-segOtfII%pStart%x)                 &
                  &        / segOtfII%lengthOtf                                  !
             vStart%y = vars(iValue)%speedStart                                  &
                  &        * (segOtfII%pEnd%y-segOtfII%pStart%y)                 &
                  &        / segOtfII%lengthOtf                                  !
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             tLead  =  1.5                                                       !  !!  TBD: test /optimize
             !
             If ( tLead.Lt.1.0 ) Then
                tLead = 1.0
             End If
             !
             pLead %x = pStart%x -vstart%x*tLead
             pLead %y = pStart%y -vstart%y*tLead
             !
             lLead  = sqrt((pStart%x-pLead %x)**2 + (pStart%y-pLead %y)**2 )
             !
          Else
             !
             pStart   = segOtfII%pStart
             vStart%x = vars(iValue)%speedStart                                  &
                  &        * (segOtfII%pEnd%x-segOtfII%pStart%x)                 &
                  &        / segOtfII%lengthOtf                                  !
             vStart%y = vars(iValue)%speedStart                                  &
                  &        * (segOtfII%pEnd%y-segOtfII%pStart%y)                 &
                  &        / segOtfII%lengthOtf                                  !
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             tLead    =  0.0
             !
             pLead %x = pStart%x
             pLead %y = pStart%y
             !
             lLead    = 0.0
             !
          End If   !!   ( Index(GV%testMode,"lead").Ge.1 )
          !
          If (GV%doDebugMessages) Then
             Write (6,*) "            pStart    ", pStart
             Write (6,*) "            vStart    ", vStart
             Write (6,*) "            tLead     ", tLead
             Write (6,*) "            pLead     ", pLead 
             Write (6,*) "            lLead     ", lLead 
          End If
          !
          If ( Index(GV%testMode,"rampup").Ge.1 ) Then                           !  !!    
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "      analyzeOtfMap: GV%testMode:   ", GV%testMode
                Write (6,*) "      --> will insert ramp up before OTF subscans "
             End If
             !
             pStart   = pLead
             vStart%x = vars(iValue)%speedStart                                  &
                  &        * (segOtfII%pEnd%x-segOtfII%pStart%x)                 &
                  &        / segOtfII%lengthOtf                                  !
             vStart%y = vars(iValue)%speedStart                                  &
                  &        * (segOtfII%pEnd%y-segOtfII%pStart%y)                 &
                  &        / segOtfII%lengthOtf                                  !
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             accelMax = 0.03*degree                                       !  maximum aceleration in [rad/s^2]
             tAccel   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If ( tAccel.Lt.3.0 ) Then
                tAccel = 3.0
             End If
             !
             pAccel%x = pLead%x -0.5*vstart%x*tAccel
             pAccel%y = pLead%y -0.5*vstart%y*tAccel
             !
             lAccel = sqrt((pLead%x-pAccel%x)**2 + (pLead%y-pAccel%y)**2 )
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "            pStart          ", pStart
                Write (6,*) "            vStart          ", vStart
                Write (6,*) "            vStart%speed    ", vStart%speed
                Write (6,*) "            tAccel          ", tAccel
                Write (6,*) "            pAccel          ", pAccel
                Write (6,*) "            lAccel          ", lAccel
             End If
             !
             Call countSubscans(ii)
             Call countSegments(jj)
             !
             segList(jj)              =  segOtfII
             segList(jj)%newSubscan   =  .True.
             !
             segList(jj)%pStart       =  pAccel 
             segList(jj)%pEnd         =  pLead
             segList(jj)%speedStart   =  0.0
             segList(jj)%speedEnd     =  vStart%speed   + 0.01                   !  !!  TBD 2014: experiment /test how much to add
             segList(jj)%tSegment     =  tAccel
             !
             segList(jj)%flagDropin   =  .True.
             segList(jj)%lengthOtf    =  lAccel
             !
          End If   !!   ( Index(GV%testMode,"rampup").Ge.1 )

          If ( Index(GV%testMode,"lead").Ge.1 ) Then                             !  !!    lead-in
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "      analyzeOtfMap: GV%testMode:   ", GV%testMode
                Write (6,*) "      --> will insert lead-in before OTF subscans "
             End If
             !
             Call countSubscans(ii)
             Call countSegments(jj)
             !
             segList(jj)              =  segOtfII
             segList(jj)%newSubscan   =  .False.
             !
             segList(jj)%pEnd         =  segList(jj)%pStart
             segList(jj)%pStart       =  pLead  
             segList(jj)%speedEnd     =  segList(jj)%speedStart   + 0.01         !  !!  TBD 2014: experiment /test how much to add
             segList(jj)%speedStart   =  segList(jj)%speedEnd
             segList(jj)%tSegment     =  tLead
             segList(jj)%flagDropin   =  .True.
             !
             If ( Index(GV%testMode,"rampup").Ge.1 ) Then
                segList(jj)%newSubscan =  .False.
             Else
                segList(jj)%newSubscan =  .True.
             End If
             segList(jj)%lengthOtf    =  lLead 
             !
          End If

          !
          Call countSubscans(ii)
          Call countSegments(jj)
          !
          segList(jj)              =  segOtfII
          !
          If       (       Index(GV%testMode,"lead").Ge.1                        &
               &      .Or. Index(GV%testMode,"rampup").Ge.1                      &
               &   )  Then                                                       !
             segList(jj)%newSubscan =  .False.
          Else
             segList(jj)%newSubscan =  .True.
          End If
          !



!!OLD !!$          vStart%x = segOtfII%speedStart                                      &
!!OLD !!$          vStart%y = segOtfII%speedStart                                      &
!!OLD !!$             If ( tAccel.Lt.vars(ivalue)%tRampUp ) Then
!!OLD !!$                !D                 Write (6,*) "             tAccel:    ", tAccel,                  &
!!OLD !!$                !D                      &      " will be increased to ", vars(ivalue)%tRampUp       !
!!OLD !!$                tAccel = vars(ivalue)%tRampUp
!!OLD !!$             If (vars(ivalue)%doInternal) Then 
!!OLD !!$                pAccel%x = pStart%x +0.5*vstart%x*tAccel
!!OLD !!$                pAccel%y = pStart%y +0.5*vstart%y*tAccel
!!OLD !!$             Else
!!OLD !!$             End If
!!OLD !!$             !


!!$          If ( Index(GV%testMode,"lead").Ge.1 ) Then                             !  !!    
!!$             !
!!$             Write (6,*) "      analyzeOtfMap: GV%testMode:   ", GV%testMode
!!$             Write (6,*) "      --> will insert lead-in before OTF subscans "
!!$             !
!!$             pStart   = segOtfII%pStart
!!$!!OLD !!$          vStart%x = segOtfII%speedStart                                      &
!!$             vStart%x = vars(iValue)%speedStart                                  &
!!$                  &        * (segOtfII%pEnd%x-segOtfII%pStart%x)                 &
!!$                  &        / segOtfII%lengthOtf                                  !
!!$!!OLD !!$          vStart%y = segOtfII%speedStart                                      &
!!$             vStart%y = vars(iValue)%speedStart                                  &
!!$                  &        * (segOtfII%pEnd%y-segOtfII%pStart%y)                 &
!!$                  &        / segOtfII%lengthOtf                                  !
!!$             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
!!$             !
!!$             Write (6,*) "            pStart    ", pStart
!!$             Write (6,*) "            vStart    ", vStart
!!$             !
!!$             tLead  =  1.5                                                       !  !!  TBD: test /investigate
!!$             !
!!$             If ( tLead.Lt.1.0 ) Then
!!$                tLead = 1.0
!!$             End If
!!$             !
!!$             pLead %x = pStart%x -vstart%x*tLead
!!$             pLead %y = pStart%y -vstart%y*tLead
!!$             !
!!$             Write (6,*) "            tLead     ", tLead
!!$             Write (6,*) "            pLead     ", pLead 
!!$             !
!!$             lLead  = sqrt((pStart%x-pLead %x)**2 + (pStart%y-pLead %y)**2 )
!!$             !
!!$             Write (6,*) "            lLead     ", lLead 
!!$             !
!!$             Call countSubscans(ii)
!!$             Call countSegments(jj)
!!$             !
!!$             segList(jj)              =  segOtfII
!!$             segList(jj)%newSubscan   =  .True.
!!$             !
!!$             segList(jj)%pEnd         =  segList(jj)%pStart
!!$             segList(jj)%pStart       =  pLead  
!!$             segList(jj)%speedEnd     =  segList(jj)%speedStart   + 0.01         !  !!  TBD 2014: experiment /test how much to add
!!$             segList(jj)%speedStart   =  segList(jj)%speedEnd
!!$             segList(jj)%tSegment     =  tLead
!!$             !
!!$             segList(jj)%flagDropin   =  .True.
!!$             segList(jj)%lengthOtf    =  lLead 
!!$             !
!!$          End If
!!$          !



!!$          If ( Index(GV%testMode,"rampup").Ge.1 ) Then                           !  !!    
!!$             !
!!$             Write (6,*) "      analyzeOtfMap: GV%testMode:   ", GV%testMode
!!$             Write (6,*) "      --> will insert ramp up before OTF subscans "
!!$             !
!!$             pStart   = segOtfII%pStart
!!$!!OLD !!$          vStart%x = segOtfII%speedStart                                      &
!!$             vStart%x = vars(iValue)%speedStart                                  &
!!$                  &        * (segOtfII%pEnd%x-segOtfII%pStart%x)                 &
!!$                  &        / segOtfII%lengthOtf                                  !
!!$!!OLD !!$          vStart%y = segOtfII%speedStart                                      &
!!$             vStart%y = vars(iValue)%speedStart                                  &
!!$                  &        * (segOtfII%pEnd%y-segOtfII%pStart%y)                 &
!!$                  &        / segOtfII%lengthOtf                                  !
!!$             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
!!$             !
!!$             Write (6,*) "            pStart    ", pStart
!!$             Write (6,*) "            vStart    ", vStart
!!$             !
!!$             accelMax = 0.03*degree                                       !  maximum aceleration in [rad/s^2]
!!$             tAccel   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
!!$             !
!!$             If ( tAccel.Lt.3.0 ) Then
!!$!!OLD !!$             If ( tAccel.Lt.vars(ivalue)%tRampUp ) Then
!!$                !D                 Write (6,*) "             tAccel:    ", tAccel,                  &
!!$                !D                      &      " will be increased to ", vars(ivalue)%tRampUp       !
!!$                tAccel = 3.0
!!$!!OLD !!$                tAccel = vars(ivalue)%tRampUp
!!$             End If
!!$             !
!!$!!OLD !!$             If (vars(ivalue)%doInternal) Then 
!!$!!OLD !!$                pAccel%x = pStart%x +0.5*vstart%x*tAccel
!!$!!OLD !!$                pAccel%y = pStart%y +0.5*vstart%y*tAccel
!!$!!OLD !!$             Else
!!$             pAccel%x = pStart%x -0.5*vstart%x*tAccel
!!$             pAccel%y = pStart%y -0.5*vstart%y*tAccel
!!$!!OLD !!$             End If
!!$!!OLD !!$             !
!!$             Write (6,*) "            tAccel    ", tAccel
!!$             Write (6,*) "            pAccel    ", pAccel
!!$             !
!!$             lAccel = sqrt((pStart%x-pAccel%x)**2 + (pStart%y-pAccel%y)**2 )
!!$             !
!!$             Write (6,*) "            lAccel    ", lAccel
!!$             !
!!$             Call countSubscans(ii)
!!$             Call countSegments(jj)
!!$             !
!!$             segList(jj)              =  segOtfII
!!$             segList(jj)%newSubscan   =  .True.
!!$             !
!!$             segList(jj)%pEnd         =  segList(jj)%pStart
!!$             segList(jj)%pStart       =  pAccel 
!!$             segList(jj)%speedEnd     =  segList(jj)%speedStart   + 0.01         !  !!  TBD 2014: experiment /test how much to add
!!$             segList(jj)%speedStart   =  0.0
!!$             segList(jj)%tSegment     =  tAccel
!!$             !
!!$             segList(jj)%flagDropin   =  .True.
!!$             segList(jj)%lengthOtf    =  lAccel
!!$             !
!!$
!!$          End If   !!   ( Index(GV%testMode,"rampup").Ge.1 )



          
          If (GV%doDebugMessages) Then
             Write (messageText,*)  " s #:   ", iSS, " ", segList(iSS)%ssType
             Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
             Write (messageText,*)  "  ___ position [arcsec] from ",             &
                  &                             segList(iSS)%pStart,             &
                  &                                           " to ",            &
                  &                             segList(iSS)%pEnd                !
             Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
             Write (messageText,*)  "  ___ tSegment [s]",                        &
                  &                                        segList(iSS)%tSegment !
             Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
             Write (messageText,*)  "  ___ speed [arcsec/s] from ",              &
                  &                             segList(iSS)%speedStart,         &
                  &                                           " to ",            &
                  &                             segList(iSS)%speedEnd            !
             Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
          End If
          !
          cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
          !
       End If   !!   (vars(iValue)%croCodeBites(iCRO:iCRO).Eq."O") 
       !
    End Do   !!   While (iOTF .Lt. vars(iValue)%nOtf)
    !
    If (iSS.Ge.1) Then
       If ( .Not. vars(iIn)%doTune) Then
          segList(1)%updateDoppler = .True.                                      !  !!  normal case
          segList(1)%pDoppler      = xyPointType(0.0,0.0)
       Else
          segList(2)%updateDoppler = .True.                                      !  !!  1st subscan: NIKA tune
          segList(2)%pDoppler      = xyPointType(0.0,0.0)
       End If
    End If
    !
    nSegments = iSS
    !
    ii = vars(iValue)%croCodeCount
    If (vars(iValue)%doReference                                                 &
         &         .And.((vars(iValue)%croCodeBites(ii:ii).Eq."R"                &      
         &                   .And. (segList(nSegments)%ssType.Eq.ss%otf))        &
         &               .Or.                                                    &
         &               (vars(iValue)%croCodeBites(ii-1:ii).Eq."RC"             &      
         &                   .And. (segList(nSegments)%ssType.Eq.ss%otf))        &
         &              )                                                        &
         &        ) Then                                                         !
       !
       Call countSubscans(ii)
       Call countSegments(jj)  
       !
       iSS  = iSS+1
       segList(iSS)            =  segDefault                    ! add REFERENCE at end
       segList(iSS)%newSubscan =  .True.
       segList(iSS)%scanNumber =  nScan
       segList(iSS)%ssNumber   =  iSS
       segList(iSS)%segNumber  =  1
       segList(iSS)%ssType     =  ss%ref
       segList(iSS)%segType    =  seg%track
       segList(iSS)%angleUnit  =  aUnit
       segList(iSS)%speedUnit  =  sUnit
       segList(iSS)%flagOn     =  .False.
       segList(iSS)%flagRef    =  .True.
       segList(iSS)%pStart     =  vars(iValue)%offsetR  
       segList(iSS)%pEnd       =  vars(iValue)%offsetR  
       segList(iSS)%systemName =  vars(iValue)%systemName
       segList(iSS)%altOption  =  'tSegment'
       segList(iSS)%speedStart =  0.0
       segList(iSS)%speedEnd   =  0.0
       segList(iSS)%tSegment   =  vars(iValue)%tReference
       segList(iSS)%tRecord    =  vars(iValue)%tRecord
       !
       If (GV%doDebugMessages) Then
          Write (messageText,*)  " s #:   ", iSS, " ", segList(iSS)%ssType
          Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
          Write (messageText,*)  "  ___ position [arcsec] ",                     &
               &                             segList(iSS)%pStart                 !
          Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
          Write (messageText,*)  "  ___ tSegment [s]",                           &
               &                                        segList(iSS)%tSegment    !
          Call pakoMessage(priorityI,severityI,"OTFMAP - Analyze",messageText)
       End If
       !
       cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
       !
    End If
    !
    nSegments = iSS
    !
    ii = vars(iValue)%croCodeCount
    If ( vars(iValue)%croCodeBites(ii:ii).Eq."C"                  &      
         &         .And. .Not. (segList(nSegments)%ssType.Eq.ss%cs)          &
         &        ) Then
       !                                                                      ! add CAL at end
       iSS  = iSS+1
       segList(iSS)            =  segDefault                    ! CAL COLD
       segList(iSS)%newSubscan =  .True.
       segList(iSS)%scanNumber =  nScan
       segList(iSS)%ssNumber   =  iSS
       segList(iSS)%segNumber  =  1
       segList(iSS)%ssType     =  ss%cc
       segList(iSS)%segType    =  seg%track
       segList(iSS)%angleUnit  =  aUnit
       segList(iSS)%speedUnit  =  sUnit
       segList(iSS)%flagOn     =  .False.
       segList(iSS)%flagRef    =  .False.
       If (vars(iValue)%doReference) Then
          segList(iSS)%pStart  =  vars(iValue)%offsetR  
       Else
          segList(iSS)%pStart  =  segOtfII%pEnd  
       End If
       segList(iSS)%pEnd       =  segList(iSS)%pStart  
       segList(iSS)%speedStart =  0.0
       segList(iSS)%speedEnd   =  0.0
       ! TBD: case ref system
       segList(iSS)%systemName =  vars(iValue)%systemName
       segList(iSS)%altOption  =  'tSegment'
       ! TBD: time from CALIBRATE
       segList(iSS)%tSegment   =  5.0
       segList(iSS)%tRecord    =  vars(iValue)%tRecord
       Write (messageText,*)  "  subscan #:   ", iSS, " ",                       &
            &           segList(iSS)%ssType                                      !
       Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
       !
       iSS = iSS+1
       segList(iSS)            =  segList(iSS-1)                ! CAL AMBIENT
       segList(iSS)%ssType     =  ss%ca
       Write (messageText,*)  "  subscan #:   ", iSS, " ",                       &
            &           segList(iSS)%ssType                                      !
       Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
       !
       iSS = iSS+1
       segList(iSS)            =  segList(iSS-1)                ! CAL SKY
       segList(iSS)%ssType     =  ss%cs
       Write (messageText,*)  "  subscan #:   ", iSS, " ",                       &
            &           segList(iSS)%ssType, segList(iSS)%pStart                 !
       Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
       !
       cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
       !
    End If
    !
    nSegments = iSS
    !
    Write (messageText,*)  "   number of Subscans/Segments: ", nSegments
    Call pakoMessage(priorityI,severityI,"OTFMAP "//" Analyze",messageText)
    !
    Return 
    !
  End Subroutine analyzeOtfMap
!!!
!!!
  Subroutine plotOtfMap (errorP)
    !
    !**   Variables  for Plots   ***
    Include 'inc/variables/headerForPlotMethods.inc'
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Call pako_message(seve%t,"OTFMAP",                                           &
         &  " module OtfMap, v 1.2.3 2014-12-15 --> SR: plotOtfMap ")            ! trace execution
    !
    errorP = .False.
    !
    Call configurePlots
    !
    Call plotOtfMapStart(errorP)
    !
    Call plotDIYlist(errorP)
    !
    If (errorP)                                                                  &
         &        Call pakoMessage(priorityE,severityE,                          &
         &        'OtfMap',' could not plot ')                                   !
    !
    Return
    !
  End Subroutine plotOtfMap
!!!
!!!
  Subroutine saveOtfMap(programName,LINE,commandToSave,              &
       &        iUnit, ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module OtfMap, v 1.2.3 2014-08-28 --> SR: saveOtfMap ")            ! trace execution
    !
    ERROR = .False.
    !
    contC = contNN
    !
    Include 'inc/commands/saveCommand.inc'
    !
    doContinue = .True.
    !
    contC = contCC
    !
    Include 'inc/parameters/saveStartEnd.inc'
    !
    !TBD:      Include 'inc/options/saveBalance.inc'
    Include 'inc/options/saveCroLoop.inc'
    Include 'inc/options/saveNotf.inc'
    Include 'inc/options/saveReference.inc'
    !TBD      Include 'inc/options/saveResume.inc'
    Include 'inc/options/saveStep.inc'
    Include 'inc/options/saveSystem.inc'
    Include 'inc/options/saveSpeedTotf.inc'
    ! TBD:      Include 'inc/options/saveTrecord.inc'
    Include 'inc/options/saveTreference.inc'
    !
    !D     Write (6,*) "      vars(iValue)%doTuneSet:   ", vars(iValue)%doTuneSet 
    If (.Not. vars(iValue)%doTuneSet) Then
       doContinue = .False.
       contC = contCN
    End If
    Include 'inc/options/saveZigzag.inc'
    !
    If (vars(iValue)%doTuneSet) Then
       If ( vars(iValue)%doTune) Then
          Include 'inc/options/saveTuneOffsets.inc'
          doContinue = .False.
          contC = contCN
          Include 'inc/options/saveTuneTime.inc'
       Else 
          doContinue = .False.
          contC = contCN
          Include 'inc/options/saveTuneOffsets.inc'
       End If
    End If
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveOtfMap
!!!
!!!
  Subroutine startOtfMap(programName,LINE,commandToSave,             &
       &         iUnit, ERROR)
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: ii
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: valueComment
    Character (len=lenLine) :: messageText
    Logical                 :: errorL, errorXML
    ! 
    Logical            :: inOtfSubscan
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module OtfMap, v 1.2.0 2012-02-15 ---> SR: startOtfMap ")          ! trace execution
    !
    ERROR = .False.
    ! 
    !D    Write (6,*) "   --> startOtfMap   "
    !D    Write (6,*) "   GV%observingMode ->", GV%observingMode(1:len_trim(GV%observingMode)), "<-"        
    !D    Write (6,*) "   GV%observingModePako ->", GV%observingModePako(1:len_trim(GV%observingModePako)), "<-"        
    !
    Call pakoXMLsetOutputUnit(iunit=iunit)
    Call pakoXMLsetIndent(iIndent=2)
!!OLD   Call pakoXMLsetLevel(1)
    !
    Include 'inc/startXML/generalHead.inc'
    !
    Call writeXMLset(programName,LINE,commandToSave,iUnit, ERROR)
    !
    !!! Call writeXMLversion !!! incorporated in generalHead above
    !
    Call pakoXMLwriteStartElement("RESOURCE","pakoScript",                       &
         &                         comment="save from pako",                     &
         &                         error=errorXML)                               !
    Call pakoXMLwriteStartElement("DESCRIPTION",                                 &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/savePakoScriptFirst.inc'
    !
    Call saveOtfMap(programName,LINE,commandToSave, iUnit, errorL)
    !                                                                       
    Call pakoXMLwriteEndElement("DESCRIPTION", error=errorXML)                                             
    Call pakoXMLwriteEndElement("RESOURCE", "pakoScript",error=errorXML)
    !
    Call writeXMLantenna(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call writeXMLreceiver(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call writeXMLbackend(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Include 'inc/startXML/switchingMode.inc'
    !
    Call writeXMLsource(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Include 'inc/startXML/generalScanHead.inc'
    !
    Include 'inc/startXML/conditions.inc'
    !
    ! **  Observing Mode to XML
    If (gv%doXMLobservingMode) Then
       messageText = "writing observing mode in XML format"
       Call PakoMessage(priorityI,severityI,                                     &
               &           commandToSave,messageText)                            !
       Call writeXMLotfMap(programName,LINE,commandToSave,                       &
         &         iUnit, ERROR)                                                 !
    End If
    !
    ! **  subscan list to XML
    Include 'inc/startXML/otfMapSubscansXML.inc'
    !   
    Include 'inc/startXML/generalTail.inc'
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module OtfMap, <--- SR: startOtfMap ")                             ! trace execution
    !
    Return
  End Subroutine startOtfMap
!!!
!!!
  Subroutine writeXMLotfMap(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: iMatch, nMatch, len1, len2
    Character (len=lenCh)   :: valueC, errorCode
    Character (len=lenLine) :: valueComment
    Logical                 :: errorM, errorXML
    Character (len=lenCh)   :: systemName
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module OtfMap, v 1.2.3 ---> SR: writeXMLotfMap 2014-10-27")        ! trace execution
    !
    ERROR = .False.
    !
    Call pakoXMLwriteStartElement("RESOURCE","observingMode",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    valueC = GV%observingMode
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/parametersStartEndXML.inc'
    !
    Include 'inc/startXML/optionSystemXML.inc'
    Include 'inc/startXML/optionReferenceXML.inc'
    Include 'inc/startXML/optionCroLoopXML.inc'
    Include 'inc/startXML/optionNotfXML.inc'
    Include 'inc/startXML/optionStepXML.inc'
    Include 'inc/startXML/otfmapAltOption.inc'
    Include 'inc/startXML/optionSpeedXML.inc'
    Include 'inc/startXML/optionTotfXML.inc'
    Include 'inc/startXML/optionTreferenceXML.inc'
    Include 'inc/startXML/optionZigzagXML.inc'
    !
    systemName = vars(iValue)%systemName
    If (vars(iValue)%doTune) Then 
       Include 'inc/startXML/optionTuneXML.inc'
       Include 'inc/startXML/optionTtuneXML.inc'
    End If
    !
    Include 'inc/startXML/annotationsXML.inc'
    !
    Call pakoXMLwriteEndElement("RESOURCE","observingMode",                      &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLotfMap
!!!
!!!
End Module modulePakoOtfmap

module cubeio_highlevel
  use cubetools_parameters
  use cubetools_setup_types
  use cubedag_node_class
  use cubeio_messaging
  use cubeio_cube_define
  use cubeio_cube
  use cubeio_desc_setup
  use cubeio_interface
  use cubeio_header_iodesc
  use cubeio_header_interface
  use cubeio_flush
  !---------------------------------------------------------------------
  ! High level API which makes sense for outer libraries
  !---------------------------------------------------------------------

  public :: cubeio_get_header
  public :: cubeio_interface_put
  public :: cubeio_clone_header
  public :: cubeio_dump_cube
  public :: cubeio_cube_finish
  private

contains

  subroutine cubeio_get_header(cubset,cubdef,dno,cub,error)
    !----------------------------------------------------------------------
    ! Get the file header, derived from the file header on disk (whatever
    ! the file kind).
    ! Also set up the IO-descriptor internal structure.
    !----------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>HEADER'
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    call cubeio_cube_read_header(cubdef,dno,cub,error)
    if (error)  return
    !
    ! Set up descriptor
    call cubeio_set_descriptor_intrinsic(dno,cub,error)
    if (error)  return
    call cubeio_set_descriptor_external(cubset,cubdef,.true.,cub,error)
    if (error)  return
  end subroutine cubeio_get_header

  subroutine cubeio_interface_put(dno,order,cub,error)
    !-------------------------------------------------------------------
    ! From interface_t to header_t and iodesc_t
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=code_k),         intent(in)    :: order  ! code_order_*
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    !
    call cubeio_header_interface_transpose(dno%node%head,order,error)  ! Inplace
    if (error) return
    call dno%node%interf2head(error)
    if (error) return
    call cubeio_iodesc_import(dno%node%head,cub%desc,error)
    if (error) return
  end subroutine cubeio_interface_put

  subroutine cubeio_clone_header(cubset,cubdef,dno,cout,error)
    !---------------------------------------------------------------------
    ! Prepare the output descriptor according to input reference and
    ! optional changes
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cout
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='CLONE>HEADER'
    !
    ! Sanity
    if (.not.cubdef%dofilename) then
      call cubeio_message(seve%e,rname,'Internal error: cube file name must be set')
      error = .true.
      return
    endif
    if (.not.cubdef%doorder) then
      call cubeio_message(seve%e,rname,'Internal error: output order must be set')
      error = .true.
      return
    endif
    if (.not.cubdef%doaccess) then
      call cubeio_message(seve%e,rname,'Internal error: output access mode must be set')
      error = .true.
      return
    endif
    !
    ! Set up the IO descriptor
    cout%file%name = cubdef%filename
    cout%file%hdu = cubdef%hdu
    call cubeio_header_put(dno,cubdef%order,cout%desc,error)
    if (error)  return
    call cubeio_set_descriptor_external(cubset,cubdef,.false.,cout,error)
    if (error)  return
  end subroutine cubeio_clone_header

  subroutine cubeio_dump_cube(cubset,cubdef,dno,cub,error)
    !---------------------------------------------------------------------
    ! Dump (i.e. write or update) all-at-once a cube from memory to disk,
    ! if relevant (i.e. nothing done for a read-only cube).
    ! ---
    ! ZZZ This all-at-once toolbox is a bit ad-hoc. Should it be ported
    ! to a more standard internal API (with blocks iteration)?
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='DUMP>CUBE'
    !
    call cubeio_set_descriptor_external(cubset,cubdef,.false.,cub,error)
    if (error)  return
    !
    select case (cub%desc%action)
    case (code_read_head,code_read)
      ! Nothing to be done
    case (code_write)
      call cubeio_write_cube(cubset,cubdef,dno,cub,error)
    case (code_update)
      call cubeio_message(seve%e,rname,'Update mode not implemented')
      error = .true.
    case default
      call cubeio_message(seve%e,rname,'Invalid action code')
      error = .true.
    end select
    !
  end subroutine cubeio_dump_cube

  subroutine cubeio_write_cube(cubset,cubdef,dno,cub,error)
    !---------------------------------------------------------------------
    ! Write a cube from memory to disk
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='WRITE>CUBE'
    !
    select case (cub%desc%buffered)
    case (code_buffer_none)
      call cubeio_message(seve%e,rname,'No data available')
      error = .true.
      return
      !
    case (code_buffer_memory)
      if (.not.cubset%output%write)  return  ! Writing is disabled
      !
      ! Sanity
      if (.not.cubdef%dofilename) then
        call cubeio_message(seve%e,rname,'Missing file name')
        error = .true.
        return
      endif
      if (.not.cubdef%doaccess) then
        call cubeio_message(seve%e,rname,'Internal error: output access mode must be set')
        error = .true.
        return
      endif
      !
      ! Write everything (header+data) from memory to disk
      call cubeio_cube_write_cube(cub,cubdef,dno,error)
      if (error)  return
      call cubeio_message(seve%i,rname,'Cube written to file '//cubdef%filename)
      !
    case (code_buffer_disk)
      ! Already on disk... might need flushing the last buffer.
      call cubeio_flush_block(dno,cub,cub%file%block,error)
      if (error)  return
      call cubeio_message(seve%i,rname,'Cube flushed to file '//cub%file%hgdf%file)
      !
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
  end subroutine cubeio_write_cube

  subroutine cubeio_cube_finish(cubset,dno,cub,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! This subroutine is to be invoked once the cube is fully read or
    ! created or modified, to leave it in a 'better' state.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    !
    ! Might need flushing of last block in case of disk mode
    call cubeio_flush_block(dno,cub,cub%file%block,error)
    if (error)  continue
    !
    ! Free temporary buffers as they are not needed anymore
    call cub%file%block%free(error)
    if (error)  continue
    !
    if (cub%desc%action.eq.code_write .or.  &
        cub%desc%action.eq.code_update) then
      ! Reload FITS header for extra entries
      call cubeio_cube_reload_header(cub,error)
      if (error)  return
    endif
    !
    ! Timing feedback?
    call gag_cputime_get(cub%time%total)  ! Get total time on this cube
    call cub%feedback()
  end subroutine cubeio_cube_finish

end module cubeio_highlevel

module cubedag_digraph
  use gkernel_interfaces
  use cubetools_parameters
  use cubedag_node_class
  use cubedag_messaging
  use cubedag_walker_types

  public :: cubedag_digraph_create
  private

  integer(kind=4) :: lun,mode
  logical :: noroot

contains
  !
  subroutine cubedag_digraph_create(start,childwalk,ofile,imode,error,inoroot)
    !-------------------------------------------------------------------
    ! Build the digraph (.dot file) by recursing children from the root
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: start
    logical,                      intent(in)    :: childwalk
    character(len=*),             intent(in)    :: ofile
    integer(kind=4),              intent(in)    :: imode
    logical,                      intent(inout) :: error
    logical, optional,            intent(in)    :: inoroot
    ! Local
    character(len=*), parameter :: rname='DIGRAPH>CREATE'
    integer(kind=4) :: ier
    class(cubedag_node_object_t), pointer :: object
    type(parentwalker_t) :: parentwalker
    type(childwalker_t) :: childwalker
    !
    mode = imode
    if (present(inoroot)) then
      noroot = inoroot
    else
      noroot = .true.
    endif
    !
    ier = sic_getlun(lun)
    if (mod(ier,2).eq.0) then
      call cubedag_message(seve%e,rname,'Cannot allocate LUN')
      error = .true.
      return
    endif
    ier = sic_open(lun,ofile,'NEW',.false.)
    if (ier.ne.0) then
      call putios('E-SIC, ',ier)
      error = .true.
      return
    endif
    !
    write(lun,'(A)')  'digraph CUBE {'
    write(lun,'(A)')  '  rankdir=BT;'
    write(lun,'(A)')  '  node [shape = ellipse];'
    !
    if (childwalk) then
      call childwalker%reset(start,cubedag_digraph_link,error)
      if (error)  return
      do while (childwalker%next(object))
        ! print *,'Found child: ',object%node%id
      enddo
    else
      call parentwalker%reset(start,cubedag_digraph_link,error)
      if (error)  return
      do while (parentwalker%next(object))
        ! print *,'Found parent: ',object%node%id
      enddo
    endif
    !
    write(lun,'(A)')  '}'
    !
    ier = sic_close(lun)
    call sic_frelun(lun)
  end subroutine cubedag_digraph_create
  !
  subroutine cubedag_digraph_link(par,chi,error)
    !-------------------------------------------------------------------
    ! Link a parent to its child in the digraph
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: par
    class(cubedag_node_object_t), intent(in)    :: chi
    logical,                      intent(inout) :: error
    !
    if (noroot .and. (par%node%id.eq.0 .or. chi%node%id.eq.0) )  return
    !
    write(lun,'(5A)')  '  "',trim(cubedag_digraph_nodename(chi,error)),  &
                    '" -> "',trim(cubedag_digraph_nodename(par,error)),'";'
  end subroutine cubedag_digraph_link
  !
  function cubedag_digraph_nodename(no,error)
    use cubetools_flag_types
    !-------------------------------------------------------------------
    ! Return the node name under various format depending on 'mode'
    ! 1:  id
    ! 2:  family\n
    !     flag1,flag2,flag3
    ! 3:  id: family\n
    !     flag1,flag2,flag3
    ! 4:  id: family\n
    !     flag1,\n
    !     flag2,\n
    !     flag3
    !-------------------------------------------------------------------
    character(len=base_l) :: cubedag_digraph_nodename
    class(cubedag_node_object_t), intent(in)    :: no
    logical,                      intent(inout) :: error
    ! Local
    character(len=8) :: id
    character(len=128) :: flagoneline,flagsevline
    character(len=base_l) :: family
    integer(kind=4) :: nc,iflag
    type(flag_t), pointer :: flag
    !
    write(id,'(I0)')  no%node%id
    family = no%node%family
    flagoneline = ''
    flagsevline = ''
    if (no%node%flag%n.gt.0) then
      !
      flagoneline(1:2) = '\n'
      call no%node%flag%repr(flagoneline(3:),nc,error)
      if (error)  return
      !
      nc = 0
      do iflag=1,no%node%flag%n
        flag => cubetools_flag_ptr(no%node%flag%list(iflag)%p,error)
        if (error)  return
        flagsevline = trim(flagsevline)//'\n'//flag%get_name()
      enddo
    endif
    !
    select case (mode)
    case (1)
      cubedag_digraph_nodename = id
    case (2)
      cubedag_digraph_nodename = trim(family)//flagoneline
    case (3)
      cubedag_digraph_nodename = trim(id)//': '//trim(family)//flagoneline
    case (4)
      cubedag_digraph_nodename = trim(id)//': '//trim(family)//flagsevline
    case default
      cubedag_digraph_nodename = id
    end select
  end function cubedag_digraph_nodename
  !
end module cubedag_digraph

module gwcs_types
  !---------------------------------------------------------------------
  ! Projection definitions
  !---------------------------------------------------------------------
  !
  ! The following type is not specific to SFL but only implemented for
  ! SFL for now. See Calabretta & Greisen 2002, table 1.
  type :: projection_sfl_t
    real(kind=8) :: phi_p    ! Native longitude of the celestial pole
    real(kind=8) :: alpha_p  ! Celestial longitude of the native pole
    real(kind=8) :: delta_p  ! Celestial latitude of the native pole
    real(kind=8) :: cosdp    ! Cosinus of delta_p
    real(kind=8) :: sindp    ! Sinus of delta_p
  end type projection_sfl_t
  !
  type :: projection_t
    ! Projection definition
    real(kind=8)    :: a0     ! X Coordinate of projection point
    real(kind=8)    :: d0     ! Y Coordinate of projection point
    real(kind=8)    :: angle  ! Angle of projection line
    integer(kind=4) :: type   ! Projection type
    ! Derived parameters
    real(kind=8)    :: sina0  ! Sinus and
    real(kind=8)    :: cosa0  ! Cosinus of A0
    real(kind=8)    :: sind0  ! Sinus and
    real(kind=8)    :: cosd0  ! Cosinus of D0
    real(kind=8)    :: npole  ! Position of North pole
    real(kind=8)    :: spole  ! Position of South pole
    ! SFL support
    type(projection_sfl_t) :: sfl
  end type projection_t
end module gwcs_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_complex
  use cubecompute_two2one_template
  use cubecompute_messaging
  !
  public :: cubecompute_complex_register
  private
  !
  type(two2one_comm_t) :: complex
  !
contains
  !
  subroutine cubecompute_complex_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='COMPLEX>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call complex%register_syntax(&
         'COMPLEX','real','imaginary',&
         'Build a complex cube from two aligned real cubes',&
         'Build a complex cube from two aligned real&
         & input cubes over the selected region.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- The first input fills the real part and the second input fills&
         & the imaginary part for each selected pixel.'//strg_cr//&
         '- Both inputs must be real image-set cubes with matching shapes.'&
         //strg_cr//&
         '- The output is a complex visibility cube.'//strg_bl//&
         'Examples:'//strg_cr//&
         '- CUBE> COMPLEX realcube imagcube.'//strg_cr//&
         '- CUBE> COMPLEX realcube imagcube /RANGE -5km/s 5km/s.',&
         code_access_imaset,[flag_complex],cubecompute_complex_command,error)
    if (error) return
    call complex%act%register_imaima2vis(cubecompute_complex_prog_act,error)
    if (error) return
  end subroutine cubecompute_complex_register
  !
  subroutine cubecompute_complex_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(two2one_user_t) :: user
    character(len=*), parameter :: rname='COMPLEX>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call complex%parse(line,user,error)
    if (error) return
    call complex%main(user,error)
    if (error) continue
  end subroutine cubecompute_complex_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_complex_prog_act(ie,real,imaginary,complex,error)
    use cubetools_parameters
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(image_t),        intent(inout) :: real
    type(image_t),        intent(inout) :: imaginary
    type(visi_t ),        intent(inout) :: complex
    logical,              intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    character(len=*), parameter :: rname='COMPLEX>PROG>ACT'
    !
    call real%get(ie,error)
    if (error) return
    call imaginary%get(ie,error)
    if (error) return
    do iy=1,complex%ny
       do ix=1,complex%nx
          complex%val(ix,iy) = cmplx(real%val(ix,iy),imaginary%val(ix,iy))
       enddo ! ix
    enddo ! iy
    call complex%put(ie,error)
    if (error) return
  end subroutine cubecompute_complex_prog_act
end module cubecompute_complex
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK XADD
      SUBROUTINE XADD (X, IX, Y, IY, Z, IZ, IERROR)
C***BEGIN PROLOGUE  XADD
C***PURPOSE  To provide single-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      SINGLE PRECISION (XADD-S, DXADD-D)
C***KEYWORDS  EXTENDED-RANGE SINGLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     REAL X, Y, Z
C     INTEGER IX, IY, IZ
C
C                  FORMS THE EXTENDED-RANGE SUM  (Z,IZ) =
C                  (X,IX) + (Y,IY).  (Z,IZ) IS ADJUSTED
C                  BEFORE RETURNING. THE INPUT OPERANDS
C                  NEED NOT BE IN ADJUSTED FORM, BUT THEIR
C                  PRINCIPAL PARTS MUST SATISFY
C                  RADIX**(-2L).LE.ABS(X).LE.RADIX**(2L),
C                  RADIX**(-2L).LE.ABS(Y).LE.RADIX**(2L).
C
C***SEE ALSO  XSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XADJ
C***COMMON BLOCKS    XBLK2
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XADD
      REAL X, Y, Z
      INTEGER IX, IY, IZ
      REAL RADIX, RADIXL, RAD2L, DLG10R
      INTEGER L, L2, KMAX
      COMMON /XBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /XBLK2/
C
C
C   THE CONDITIONS IMPOSED ON L AND KMAX BY THIS SUBROUTINE
C ARE
C     (1) 1 .LT. L .LE. 0.5*LOGR(0.5*DZERO)
C
C     (2) NRADPL .LT. L .LE. KMAX/6
C
C     (3) KMAX .LE. (2**NBITS - 4*L - 1)/2
C
C THESE CONDITIONS MUST BE MET BY APPROPRIATE CODING
C IN SUBROUTINE XSET.
C
C***FIRST EXECUTABLE STATEMENT  XADD
      IERROR=0
      IF (X.NE.0.0) GO TO 10
      Z = Y
      IZ = IY
      GO TO 220
   10 IF (Y.NE.0.0) GO TO 20
      Z = X
      IZ = IX
      GO TO 220
   20 CONTINUE
      IF (IX.GE.0 .AND. IY.GE.0) GO TO 40
      IF (IX.LT.0 .AND. IY.LT.0) GO TO 40
      IF (ABS(IX).LE.6*L .AND. ABS(IY).LE.6*L) GO TO 40
      IF (IX.GE.0) GO TO 30
      Z = Y
      IZ = IY
      GO TO 220
   30 CONTINUE
      Z = X
      IZ = IX
      GO TO 220
   40 I = IX - IY
      IF (I) 80, 50, 90
   50 IF (ABS(X).GT.1.0 .AND. ABS(Y).GT.1.0) GO TO 60
      IF (ABS(X).LT.1.0 .AND. ABS(Y).LT.1.0) GO TO 70
      Z = X + Y
      IZ = IX
      GO TO 220
   60 S = X/RADIXL
      T = Y/RADIXL
      Z = S + T
      IZ = IX + L
      GO TO 220
   70 S = X*RADIXL
      T = Y*RADIXL
      Z = S + T
      IZ = IX - L
      GO TO 220
   80 S = Y
      IS = IY
      T = X
      GO TO 100
   90 S = X
      IS = IX
      T = Y
  100 CONTINUE
C
C  AT THIS POINT, THE ONE OF (X,IX) OR (Y,IY) THAT HAS THE
C LARGER AUXILIARY INDEX IS STORED IN (S,IS). THE PRINCIPAL
C PART OF THE OTHER INPUT IS STORED IN T.
C
      I1 = ABS(I)/L
      I2 = MOD(ABS(I),L)
      IF (ABS(T).GE.RADIXL) GO TO 130
      IF (ABS(T).GE.1.0) GO TO 120
      IF (RADIXL*ABS(T).GE.1.0) GO TO 110
      J = I1 + 1
      T = T*RADIX**(L-I2)
      GO TO 140
  110 J = I1
      T = T*RADIX**(-I2)
      GO TO 140
  120 J = I1 - 1
      IF (J.LT.0) GO TO 110
      T = T*RADIX**(-I2)/RADIXL
      GO TO 140
  130 J = I1 - 2
      IF (J.LT.0) GO TO 120
      T = T*RADIX**(-I2)/RAD2L
  140 CONTINUE
C
C  AT THIS POINT, SOME OR ALL OF THE DIFFERENCE IN THE
C AUXILIARY INDICES HAS BEEN USED TO EFFECT A LEFT SHIFT
C OF T.  THE SHIFTED VALUE OF T SATISFIES
C
C       RADIX**(-2*L) .LE. ABS(T) .LE. 1.0
C
C AND, IF J=0, NO FURTHER SHIFTING REMAINS TO BE DONE.
C
      IF (J.EQ.0) GO TO 190
      IF (ABS(S).GE.RADIXL .OR. J.GT.3) GO TO 150
      IF (ABS(S).GE.1.0) GO TO (180, 150, 150), J
      IF (RADIXL*ABS(S).GE.1.0) GO TO (180, 170, 150), J
      GO TO (180, 170, 160), J
  150 Z = S
      IZ = IS
      GO TO 220
  160 S = S*RADIXL
  170 S = S*RADIXL
  180 S = S*RADIXL
  190 CONTINUE
C
C   AT THIS POINT, THE REMAINING DIFFERENCE IN THE
C AUXILIARY INDICES HAS BEEN USED TO EFFECT A RIGHT SHIFT
C OF S.  IF THE SHIFTED VALUE OF S WOULD HAVE EXCEEDED
C RADIX**L, THEN (S,IS) IS RETURNED AS THE VALUE OF THE
C SUM.
C
      IF (ABS(S).GT.1.0 .AND. ABS(T).GT.1.0) GO TO 200
      IF (ABS(S).LT.1.0 .AND. ABS(T).LT.1.0) GO TO 210
      Z = S + T
      IZ = IS - J*L
      GO TO 220
  200 S = S/RADIXL
      T = T/RADIXL
      Z = S + T
      IZ = IS - J*L + L
      GO TO 220
  210 S = S*RADIXL
      T = T*RADIXL
      Z = S + T
      IZ = IS - J*L - L
  220 CALL XADJ(Z, IZ,IERROR)
      RETURN
      END
*DECK XADJ
      SUBROUTINE XADJ (X, IX, IERROR)
C***BEGIN PROLOGUE  XADJ
C***PURPOSE  To provide single-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      SINGLE PRECISION (XADJ-S, DXADJ-D)
C***KEYWORDS  EXTENDED-RANGE SINGLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     REAL X
C     INTEGER IX
C
C                  TRANSFORMS (X,IX) SO THAT
C                  RADIX**(-L) .LE. ABS(X) .LT. RADIX**L.
C                  ON MOST COMPUTERS THIS TRANSFORMATION DOES
C                  NOT CHANGE THE MANTISSA OF X PROVIDED RADIX IS
C                  THE NUMBER BASE OF SINGLE-PRECISION ARITHMETIC.
C
C***SEE ALSO  XSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERMSG
C***COMMON BLOCKS    XBLK2
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XADJ
      REAL X
      INTEGER IX
      REAL RADIX, RADIXL, RAD2L, DLG10R
      INTEGER L, L2, KMAX
      COMMON /XBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /XBLK2/
C
C   THE CONDITION IMPOSED ON L AND KMAX BY THIS SUBROUTINE
C IS
C     2*L .LE. KMAX
C
C THIS CONDITION MUST BE MET BY APPROPRIATE CODING
C IN SUBROUTINE XSET.
C
C***FIRST EXECUTABLE STATEMENT  XADJ
      IERROR=0
      IF (X.EQ.0.0) GO TO 50
      IF (ABS(X).GE.1.0) GO TO 20
      IF (RADIXL*ABS(X).GE.1.0) GO TO 60
      X = X*RAD2L
      IF (IX.LT.0) GO TO 10
      IX = IX - L2
      GO TO 70
   10 IF (IX.LT.-KMAX+L2) GO TO 40
      IX = IX - L2
      GO TO 70
   20 IF (ABS(X).LT.RADIXL) GO TO 60
      X = X/RAD2L
      IF (IX.GT.0) GO TO 30
      IX = IX + L2
      GO TO 70
   30 IF (IX.GT.KMAX-L2) GO TO 40
      IX = IX + L2
      GO TO 70
   40 CALL XERMSG ('SLATEC', 'XADJ', 'overflow in auxiliary index', 107,
     +             1)
      IERROR=107
      RETURN
   50 IX = 0
   60 IF (ABS(IX).GT.KMAX) GO TO 40
   70 RETURN
      END
*DECK XC210
      SUBROUTINE XC210 (K, Z, J, IERROR)
C***BEGIN PROLOGUE  XC210
C***PURPOSE  To provide single-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      SINGLE PRECISION (XC210-S, DXC210-D)
C***KEYWORDS  EXTENDED-RANGE SINGLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     INTEGER K, J
C     REAL Z
C
C                  GIVEN K THIS SUBROUTINE COMPUTES J AND Z
C                  SUCH THAT  RADIX**K = Z*10**J, WHERE Z IS IN
C                  THE RANGE 1/10 .LE. Z .LT. 1.
C                  THE VALUE OF Z WILL BE ACCURATE TO FULL
C                  SINGLE-PRECISION PROVIDED THE NUMBER
C                  OF DECIMAL PLACES IN THE LARGEST
C                  INTEGER PLUS THE NUMBER OF DECIMAL
C                  PLACES CARRIED IN SINGLE-PRECISION DOES NOT
C                  EXCEED 60. XC210 IS CALLED BY SUBROUTINE
C                  XCON WHEN NECESSARY. THE USER SHOULD
C                  NEVER NEED TO CALL XC210 DIRECTLY.
C
C***SEE ALSO  XSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERMSG
C***COMMON BLOCKS    XBLK3
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XC210
      INTEGER K, J
      REAL Z
      INTEGER NLG102, MLG102, LG102
      COMMON /XBLK3/ NLG102, MLG102, LG102(21)
      SAVE /XBLK3/
C
C   THE CONDITIONS IMPOSED ON NLG102, MLG102, AND LG102 BY
C THIS SUBROUTINE ARE
C
C     (1) NLG102 .GE. 2
C
C     (2) MLG102 .GE. 1
C
C     (3) 2*MLG102*(MLG102 - 1) .LE. 2**NBITS - 1
C
C THESE CONDITIONS MUST BE MET BY APPROPRIATE CODING
C IN SUBROUTINE XSET.
C
C***FIRST EXECUTABLE STATEMENT  XC210
      IERROR=0
      IF (K.EQ.0) GO TO 70
      M = MLG102
      KA = ABS(K)
      KA1 = KA/M
      KA2 = MOD(KA,M)
      IF (KA1.GE.M) GO TO 60
      NM1 = NLG102 - 1
      NP1 = NLG102 + 1
      IT = KA2*LG102(NP1)
      IC = IT/M
      ID = MOD(IT,M)
      Z = ID
      IF (KA1.GT.0) GO TO 20
      DO 10 II=1,NM1
        I = NP1 - II
        IT = KA2*LG102(I) + IC
        IC = IT/M
        ID = MOD(IT,M)
        Z = Z/M + ID
   10 CONTINUE
      JA = KA*LG102(1) + IC
      GO TO 40
   20 CONTINUE
      DO 30 II=1,NM1
        I = NP1 - II
        IT = KA2*LG102(I) + KA1*LG102(I+1) + IC
        IC = IT/M
        ID = MOD(IT,M)
        Z = Z/M + ID
   30 CONTINUE
      JA = KA*LG102(1) + KA1*LG102(2) + IC
   40 CONTINUE
      Z = Z/M
      IF (K.GT.0) GO TO 50
      J = -JA
      Z = 10.0**(-Z)
      GO TO 80
   50 CONTINUE
      J = JA + 1
      Z = 10.0**(Z-1.0)
      GO TO 80
   60 CONTINUE
C   THIS ERROR OCCURS IF K EXCEEDS  MLG102**2 - 1  IN MAGNITUDE.
C
      CALL XERMSG ('SLATEC', 'XC210', 'K too large', 108, 1)
      IERROR=108
      RETURN
   70 CONTINUE
      J = 0
      Z = 1.0
   80 RETURN
      END
*DECK XCON
      SUBROUTINE XCON (X, IX, IERROR)
C***BEGIN PROLOGUE  XCON
C***PURPOSE  To provide single-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      SINGLE PRECISION (XCON-S, DXCON-D)
C***KEYWORDS  EXTENDED-RANGE SINGLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     REAL X
C     INTEGER IX
C
C                  CONVERTS (X,IX) = X*RADIX**IX
C                  TO DECIMAL FORM IN PREPARATION FOR
C                  PRINTING, SO THAT (X,IX) = X*10**IX
C                  WHERE 1/10 .LE. ABS(X) .LT. 1
C                  IS RETURNED, EXCEPT THAT IF
C                  (ABS(X),IX) IS BETWEEN RADIX**(-2L)
C                  AND RADIX**(2L) THEN THE REDUCED
C                  FORM WITH IX = 0 IS RETURNED.
C
C***SEE ALSO  XSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XADJ, XC210, XRED
C***COMMON BLOCKS    XBLK2
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XCON
      REAL X
      INTEGER IX
C
C   THE CONDITIONS IMPOSED ON L AND KMAX BY THIS SUBROUTINE
C ARE
C    (1) 4 .LE. L .LE. 2**NBITS - 1 - KMAX
C
C    (2) KMAX .LE. ((2**NBITS)-2)/LOG10R - L
C
C THESE CONDITIONS MUST BE MET BY APPROPRIATE CODING
C IN SUBROUTINE XSET.
C
      REAL RADIX, RADIXL, RAD2L, DLG10R
      INTEGER L, L2, KMAX
      COMMON /XBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /XBLK2/, ISPACE
C
      REAL A, B, Z
C
      DATA ISPACE /1/
C   THE PARAMETER ISPACE IS THE INCREMENT USED IN FORM-
C ING THE AUXILIARY INDEX OF THE DECIMAL EXTENDED-RANGE
C FORM. THE RETURNED VALUE OF IX WILL BE AN INTEGER MULT-
C IPLE OF ISPACE. ISPACE MUST SATISFY 1 .LE. ISPACE .LE.
C L/2. IF A VALUE GREATER THAN 1 IS TAKEN, THE RETURNED
C VALUE OF X WILL SATISFY 10**(-ISPACE) .LE. ABS(X) .LE. 1
C WHEN (ABS(X),IX) .LT. RADIX**(-2L) AND 1/10 .LE. ABS(X)
C .LT. 10**(ISPACE-1) WHEN (ABS(X),IX) .GT. RADIX**(2L).
C
C***FIRST EXECUTABLE STATEMENT  XCON
      IERROR=0
      CALL XRED(X, IX,IERROR)
      IF (IERROR.NE.0) RETURN
      IF (IX.EQ.0) GO TO 150
      CALL XADJ(X, IX,IERROR)
      IF (IERROR.NE.0) RETURN
C
C CASE 1 IS WHEN (X,IX) IS LESS THAN RADIX**(-2L) IN MAGNITUDE,
C CASE 2 IS WHEN (X,IX) IS GREATER THAN RADIX**(2L) IN MAGNITUDE.
      ITEMP = 1
      ICASE = (3+SIGN(ITEMP,IX))/2
      GO TO (10, 20), ICASE
   10 IF (ABS(X).LT.1.0) GO TO 30
      X = X/RADIXL
      IX = IX + L
      GO TO 30
   20 IF (ABS(X).GE.1.0) GO TO 30
      X = X*RADIXL
      IX = IX - L
   30 CONTINUE
C
C AT THIS POINT, RADIX**(-L) .LE. ABS(X) .LT. 1.0     IN CASE 1,
C                      1.0 .LE. ABS(X) .LT. RADIX**L  IN CASE 2.
      I = LOG10(ABS(X))/DLG10R
      A = RADIX**I
      GO TO (40, 60), ICASE
   40 IF (A.LE.RADIX*ABS(X)) GO TO 50
      I = I - 1
      A = A/RADIX
      GO TO 40
   50 IF (ABS(X).LT.A) GO TO 80
      I = I + 1
      A = A*RADIX
      GO TO 50
   60 IF (A.LE.ABS(X)) GO TO 70
      I = I - 1
      A = A/RADIX
      GO TO 60
   70 IF (ABS(X).LT.RADIX*A) GO TO 80
      I = I + 1
      A = A*RADIX
      GO TO 70
   80 CONTINUE
C
C AT THIS POINT I IS SUCH THAT
C RADIX**(I-1) .LE. ABS(X) .LT. RADIX**I      IN CASE 1,
C     RADIX**I .LE. ABS(X) .LT. RADIX**(I+1)  IN CASE 2.
      ITEMP = ISPACE/DLG10R
      A = RADIX**ITEMP
      B = 10.0**ISPACE
   90 IF (A.LE.B) GO TO 100
      ITEMP = ITEMP - 1
      A = A/RADIX
      GO TO 90
  100 IF (B.LT.A*RADIX) GO TO 110
      ITEMP = ITEMP + 1
      A = A*RADIX
      GO TO 100
  110 CONTINUE
C
C AT THIS POINT ITEMP IS SUCH THAT
C RADIX**ITEMP .LE. 10**ISPACE .LT. RADIX**(ITEMP+1).
      IF (ITEMP.GT.0) GO TO 120
C ITEMP = 0 IF, AND ONLY IF, ISPACE = 1 AND RADIX = 16.0
      X = X*RADIX**(-I)
      IX = IX + I
      CALL XC210(IX, Z, J,IERROR)
      IF (IERROR.NE.0) RETURN
      X = X*Z
      IX = J
      GO TO (130, 140), ICASE
  120 CONTINUE
      I1 = I/ITEMP
      X = X*RADIX**(-I1*ITEMP)
      IX = IX + I1*ITEMP
C
C AT THIS POINT,
C RADIX**(-ITEMP) .LE. ABS(X) .LT. 1.0        IN CASE 1,
C           1.0 .LE. ABS(X) .LT. RADIX**ITEMP IN CASE 2.
      CALL XC210(IX, Z, J,IERROR)
      IF (IERROR.NE.0) RETURN
      J1 = J/ISPACE
      J2 = J - J1*ISPACE
      X = X*Z*10.0**J2
      IX = J1*ISPACE
C
C AT THIS POINT,
C  10.0**(-2*ISPACE) .LE. ABS(X) .LT. 1.0                IN CASE 1,
C           10.0**-1 .LE. ABS(X) .LT. 10.0**(2*ISPACE-1) IN CASE 2.
      GO TO (130, 140), ICASE
  130 IF (B*ABS(X).GE.1.0) GO TO 150
      X = X*B
      IX = IX - ISPACE
      GO TO 130
  140 IF (10.0*ABS(X).LT.B) GO TO 150
      X = X/B
      IX = IX + ISPACE
      GO TO 140
  150 RETURN
      END
*DECK XERBLA
      SUBROUTINE XERBLA (SRNAME, INFO)
C***BEGIN PROLOGUE  XERBLA
C***SUBSIDIARY
C***PURPOSE  Error handler for the Level 2 and Level 3 BLAS Routines.
C***LIBRARY   SLATEC
C***CATEGORY  R3
C***TYPE      ALL (XERBLA-A)
C***KEYWORDS  ERROR MESSAGE
C***AUTHOR  Dongarra, J. J., (ANL)
C***DESCRIPTION
C
C  Purpose
C  =======
C
C  It is called by Level 2 and 3 BLAS routines if an input parameter
C  is invalid.
C
C  Parameters
C  ==========
C
C  SRNAME - CHARACTER*6.
C           On entry, SRNAME specifies the name of the routine which
C           called XERBLA.
C
C  INFO   - INTEGER.
C           On entry, INFO specifies the position of the invalid
C           parameter in the parameter-list of the calling routine.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   860720  DATE WRITTEN
C   910610  Routine rewritten to serve as an interface between the
C           Level 2 and Level 3 BLAS routines and the SLATEC error
C           handler XERMSG.  (BKS)
C***END PROLOGUE  XERBLA
C
C     ..    Scalar Arguments ..
      INTEGER            INFO
      CHARACTER*6        SRNAME
      CHARACTER*2        XERN1
C
C***FIRST EXECUTABLE STATEMENT  XERBLA
C
      WRITE (XERN1, '(I2)') INFO
      CALL XERMSG ('SLATEC', SRNAME, 'On entry to '//SRNAME//
     $             ' parameter number '//XERN1//' had an illegal value',
     $             INFO,1)
C
      RETURN
C
C     End of XERBLA.
C
      END
*DECK XERCLR
      SUBROUTINE XERCLR
C***BEGIN PROLOGUE  XERCLR
C***PURPOSE  Reset current error number to zero.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERCLR-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        This routine simply resets the current error number to zero.
C        This may be necessary in order to determine that a certain
C        error has occurred again since the last time NUMXER was
C        referenced.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERCLR
C***FIRST EXECUTABLE STATEMENT  XERCLR
      JUNK = J4SAVE(1,0,.TRUE.)
      RETURN
      END
*DECK XERCNT
      SUBROUTINE XERCNT (LIBRAR, SUBROU, MESSG, NERR, LEVEL, KONTRL)
C***BEGIN PROLOGUE  XERCNT
C***SUBSIDIARY
C***PURPOSE  Allow user control over handling of errors.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERCNT-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        Allows user control over handling of individual errors.
C        Just after each message is recorded, but before it is
C        processed any further (i.e., before it is printed or
C        a decision to abort is made), a call is made to XERCNT.
C        If the user has provided his own version of XERCNT, he
C        can then override the value of KONTROL used in processing
C        this message by redefining its value.
C        KONTRL may be set to any value from -2 to 2.
C        The meanings for KONTRL are the same as in XSETF, except
C        that the value of KONTRL changes only for this message.
C        If KONTRL is set to a value outside the range from -2 to 2,
C        it will be moved back into that range.
C
C     Description of Parameters
C
C      --Input--
C        LIBRAR - the library that the routine is in.
C        SUBROU - the subroutine that XERMSG is being called from
C        MESSG  - the first 20 characters of the error message.
C        NERR   - same as in the call to XERMSG.
C        LEVEL  - same as in the call to XERMSG.
C        KONTRL - the current value of the control flag as set
C                 by a call to XSETF.
C
C      --Output--
C        KONTRL - the new value of KONTRL.  If KONTRL is not
C                 defined, it will remain at its original value.
C                 This changed value of control affects only
C                 the current occurrence of the current message.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900206  Routine changed from user-callable to subsidiary.  (WRB)
C   900510  Changed calling sequence to include LIBRARY and SUBROUTINE
C           names, changed routine name from XERCTL to XERCNT.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERCNT
      CHARACTER*(*) LIBRAR, SUBROU, MESSG
C***FIRST EXECUTABLE STATEMENT  XERCNT
      RETURN
      END
*DECK XERDMP
      SUBROUTINE XERDMP
C***BEGIN PROLOGUE  XERDMP
C***PURPOSE  Print the error tables and then clear them.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERDMP-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        XERDMP prints the error tables, then clears them.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  XERSVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Changed call of XERSAV to XERSVE.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERDMP
C***FIRST EXECUTABLE STATEMENT  XERDMP
      CALL XERSVE (' ',' ',' ',0,0,0,KOUNT)
      RETURN
      END
*DECK XERHLT
      SUBROUTINE XERHLT (MESSG)
C***BEGIN PROLOGUE  XERHLT
C***SUBSIDIARY
C***PURPOSE  Abort program execution and print error message.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERHLT-A)
C***KEYWORDS  ABORT PROGRAM EXECUTION, ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        ***Note*** machine dependent routine
C        XERHLT aborts the execution of the program.
C        The error message causing the abort is given in the calling
C        sequence, in case one needs it for printing on a dayfile,
C        for example.
C
C     Description of Parameters
C        MESSG is as in XERMSG.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900206  Routine changed from user-callable to subsidiary.  (WRB)
C   900510  Changed calling sequence to delete length of character
C           and changed routine name from XERABT to XERHLT.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERHLT
      CHARACTER*(*) MESSG
C***FIRST EXECUTABLE STATEMENT  XERHLT
      STOP
      END
*DECK XERMAX
      SUBROUTINE XERMAX (MAX)
C***BEGIN PROLOGUE  XERMAX
C***PURPOSE  Set maximum number of times any error message is to be
C            printed.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERMAX-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        XERMAX sets the maximum number of times any message
C        is to be printed.  That is, non-fatal messages are
C        not to be printed after they have occurred MAX times.
C        Such non-fatal messages may be printed less than
C        MAX times even if they occur MAX times, if error
C        suppression mode (KONTRL=0) is ever in effect.
C
C     Description of Parameter
C      --Input--
C        MAX - the maximum number of times any one message
C              is to be printed.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERMAX
C***FIRST EXECUTABLE STATEMENT  XERMAX
      JUNK = J4SAVE(4,MAX,.TRUE.)
      RETURN
      END
*DECK XERMSG
      SUBROUTINE XERMSG (LIBRAR, SUBROU, MESSG, NERR, LEVEL)
C***BEGIN PROLOGUE  XERMSG
C***PURPOSE  Process error messages for SLATEC and other libraries.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERMSG-A)
C***KEYWORDS  ERROR MESSAGE, XERROR
C***AUTHOR  Fong, Kirby, (NMFECC at LLNL)
C***DESCRIPTION
C
C   XERMSG processes a diagnostic message in a manner determined by the
C   value of LEVEL and the current value of the library error control
C   flag, KONTRL.  See subroutine XSETF for details.
C
C    LIBRAR   A character constant (or character variable) with the name
C             of the library.  This will be 'SLATEC' for the SLATEC
C             Common Math Library.  The error handling package is
C             general enough to be used by many libraries
C             simultaneously, so it is desirable for the routine that
C             detects and reports an error to identify the library name
C             as well as the routine name.
C
C    SUBROU   A character constant (or character variable) with the name
C             of the routine that detected the error.  Usually it is the
C             name of the routine that is calling XERMSG.  There are
C             some instances where a user callable library routine calls
C             lower level subsidiary routines where the error is
C             detected.  In such cases it may be more informative to
C             supply the name of the routine the user called rather than
C             the name of the subsidiary routine that detected the
C             error.
C
C    MESSG    A character constant (or character variable) with the text
C             of the error or warning message.  In the example below,
C             the message is a character constant that contains a
C             generic message.
C
C                   CALL XERMSG ('SLATEC', 'MMPY',
C                  *'THE ORDER OF THE MATRIX EXCEEDS THE ROW DIMENSION',
C                  *3, 1)
C
C             It is possible (and is sometimes desirable) to generate a
C             specific message--e.g., one that contains actual numeric
C             values.  Specific numeric values can be converted into
C             character strings using formatted WRITE statements into
C             character variables.  This is called standard Fortran
C             internal file I/O and is exemplified in the first three
C             lines of the following example.  You can also catenate
C             substrings of characters to construct the error message.
C             Here is an example showing the use of both writing to
C             an internal file and catenating character strings.
C
C                   CHARACTER*5 CHARN, CHARL
C                   WRITE (CHARN,10) N
C                   WRITE (CHARL,10) LDA
C                10 FORMAT(I5)
C                   CALL XERMSG ('SLATEC', 'MMPY', 'THE ORDER'//CHARN//
C                  *   ' OF THE MATRIX EXCEEDS ITS ROW DIMENSION OF'//
C                  *   CHARL, 3, 1)
C
C             There are two subtleties worth mentioning.  One is that
C             the // for character catenation is used to construct the
C             error message so that no single character constant is
C             continued to the next line.  This avoids confusion as to
C             whether there are trailing blanks at the end of the line.
C             The second is that by catenating the parts of the message
C             as an actual argument rather than encoding the entire
C             message into one large character variable, we avoid
C             having to know how long the message will be in order to
C             declare an adequate length for that large character
C             variable.  XERMSG calls XERPRN to print the message using
C             multiple lines if necessary.  If the message is very long,
C             XERPRN will break it into pieces of 72 characters (as
C             requested by XERMSG) for printing on multiple lines.
C             Also, XERMSG asks XERPRN to prefix each line with ' *  '
C             so that the total line length could be 76 characters.
C             Note also that XERPRN scans the error message backwards
C             to ignore trailing blanks.  Another feature is that
C             the substring '$$' is treated as a new line sentinel
C             by XERPRN.  If you want to construct a multiline
C             message without having to count out multiples of 72
C             characters, just use '$$' as a separator.  '$$'
C             obviously must occur within 72 characters of the
C             start of each line to have its intended effect since
C             XERPRN is asked to wrap around at 72 characters in
C             addition to looking for '$$'.
C
C    NERR     An integer value that is chosen by the library routine's
C             author.  It must be in the range -99 to 999 (three
C             printable digits).  Each distinct error should have its
C             own error number.  These error numbers should be described
C             in the machine readable documentation for the routine.
C             The error numbers need be unique only within each routine,
C             so it is reasonable for each routine to start enumerating
C             errors from 1 and proceeding to the next integer.
C
C    LEVEL    An integer value in the range 0 to 2 that indicates the
C             level (severity) of the error.  Their meanings are
C
C            -1  A warning message.  This is used if it is not clear
C                that there really is an error, but the user's attention
C                may be needed.  An attempt is made to only print this
C                message once.
C
C             0  A warning message.  This is used if it is not clear
C                that there really is an error, but the user's attention
C                may be needed.
C
C             1  A recoverable error.  This is used even if the error is
C                so serious that the routine cannot return any useful
C                answer.  If the user has told the error package to
C                return after recoverable errors, then XERMSG will
C                return to the Library routine which can then return to
C                the user's routine.  The user may also permit the error
C                package to terminate the program upon encountering a
C                recoverable error.
C
C             2  A fatal error.  XERMSG will not return to its caller
C                after it receives a fatal error.  This level should
C                hardly ever be used; it is much better to allow the
C                user a chance to recover.  An example of one of the few
C                cases in which it is permissible to declare a level 2
C                error is a reverse communication Library routine that
C                is likely to be called repeatedly until it integrates
C                across some interval.  If there is a serious error in
C                the input such that another step cannot be taken and
C                the Library routine is called again without the input
C                error having been corrected by the caller, the Library
C                routine will probably be called forever with improper
C                input.  In this case, it is reasonable to declare the
C                error to be fatal.
C
C    Each of the arguments to XERMSG is input; none will be modified by
C    XERMSG.  A routine may make multiple calls to XERMSG with warning
C    level messages; however, after a call to XERMSG with a recoverable
C    error, the routine should return to the user.  Do not try to call
C    XERMSG with a second recoverable error after the first recoverable
C    error because the error package saves the error number.  The user
C    can retrieve this error number by calling another entry point in
C    the error handling package and then clear the error number when
C    recovering from the error.  Calling XERMSG in succession causes the
C    old error number to be overwritten by the latest error number.
C    This is considered harmless for error numbers associated with
C    warning messages but must not be done for error numbers of serious
C    errors.  After a call to XERMSG with a recoverable error, the user
C    must be given a chance to call NUMXER or XERCLR to retrieve or
C    clear the error number.
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  FDUMP, J4SAVE, XERCNT, XERHLT, XERPRN, XERSVE
C***REVISION HISTORY  (YYMMDD)
C   880101  DATE WRITTEN
C   880621  REVISED AS DIRECTED AT SLATEC CML MEETING OF FEBRUARY 1988.
C           THERE ARE TWO BASIC CHANGES.
C           1.  A NEW ROUTINE, XERPRN, IS USED INSTEAD OF XERPRT TO
C               PRINT MESSAGES.  THIS ROUTINE WILL BREAK LONG MESSAGES
C               INTO PIECES FOR PRINTING ON MULTIPLE LINES.  '$$' IS
C               ACCEPTED AS A NEW LINE SENTINEL.  A PREFIX CAN BE
C               ADDED TO EACH LINE TO BE PRINTED.  XERMSG USES EITHER
C               ' ***' OR ' *  ' AND LONG MESSAGES ARE BROKEN EVERY
C               72 CHARACTERS (AT MOST) SO THAT THE MAXIMUM LINE
C               LENGTH OUTPUT CAN NOW BE AS GREAT AS 76.
C           2.  THE TEXT OF ALL MESSAGES IS NOW IN UPPER CASE SINCE THE
C               FORTRAN STANDARD DOCUMENT DOES NOT ADMIT THE EXISTENCE
C               OF LOWER CASE.
C   880708  REVISED AFTER THE SLATEC CML MEETING OF JUNE 29 AND 30.
C           THE PRINCIPAL CHANGES ARE
C           1.  CLARIFY COMMENTS IN THE PROLOGUES
C           2.  RENAME XRPRNT TO XERPRN
C           3.  REWORK HANDLING OF '$$' IN XERPRN TO HANDLE BLANK LINES
C               SIMILAR TO THE WAY FORMAT STATEMENTS HANDLE THE /
C               CHARACTER FOR NEW RECORDS.
C   890706  REVISED WITH THE HELP OF FRED FRITSCH AND REG CLEMENS TO
C           CLEAN UP THE CODING.
C   890721  REVISED TO USE NEW FEATURE IN XERPRN TO COUNT CHARACTERS IN
C           PREFIX.
C   891013  REVISED TO CORRECT COMMENTS.
C   891214  Prologue converted to Version 4.0 format.  (WRB)
C   900510  Changed test on NERR to be -9999999 < NERR < 99999999, but
C           NERR .ne. 0, and on LEVEL to be -2 < LEVEL < 3.  Added
C           LEVEL=-1 logic, changed calls to XERSAV to XERSVE, and
C           XERCTL to XERCNT.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERMSG
      CHARACTER*(*) LIBRAR, SUBROU, MESSG
      CHARACTER*8 XLIBR, XSUBR
      CHARACTER*72  TEMP
      CHARACTER*20  LFIRST
C***FIRST EXECUTABLE STATEMENT  XERMSG
      LKNTRL = J4SAVE (2, 0, .FALSE.)
      MAXMES = J4SAVE (4, 0, .FALSE.)
C
C       LKNTRL IS A LOCAL COPY OF THE CONTROL FLAG KONTRL.
C       MAXMES IS THE MAXIMUM NUMBER OF TIMES ANY PARTICULAR MESSAGE
C          SHOULD BE PRINTED.
C
C       WE PRINT A FATAL ERROR MESSAGE AND TERMINATE FOR AN ERROR IN
C          CALLING XERMSG.  THE ERROR NUMBER SHOULD BE POSITIVE,
C          AND THE LEVEL SHOULD BE BETWEEN 0 AND 2.
C
      IF (NERR.LT.-9999999 .OR. NERR.GT.99999999 .OR. NERR.EQ.0 .OR.
     *   LEVEL.LT.-1 .OR. LEVEL.GT.2) THEN
         CALL XERPRN (' ***', -1, 'FATAL ERROR IN...$$ ' //
     *      'XERMSG -- INVALID ERROR NUMBER OR LEVEL$$ '//
     *      'JOB ABORT DUE TO FATAL ERROR.', 72)
         CALL XERSVE (' ', ' ', ' ', 0, 0, 0, KDUMMY)
         CALL XERHLT (' ***XERMSG -- INVALID INPUT')
         RETURN
      ENDIF
C
C       RECORD THE MESSAGE.
C
      I = J4SAVE (1, NERR, .TRUE.)
      CALL XERSVE (LIBRAR, SUBROU, MESSG, 1, NERR, LEVEL, KOUNT)
C
C       HANDLE PRINT-ONCE WARNING MESSAGES.
C
      IF (LEVEL.EQ.-1 .AND. KOUNT.GT.1) RETURN
C
C       ALLOW TEMPORARY USER OVERRIDE OF THE CONTROL FLAG.
C
      XLIBR  = LIBRAR
      XSUBR  = SUBROU
      LFIRST = MESSG
      LERR   = NERR
      LLEVEL = LEVEL
      CALL XERCNT (XLIBR, XSUBR, LFIRST, LERR, LLEVEL, LKNTRL)
C
      LKNTRL = MAX(-2, MIN(2,LKNTRL))
      MKNTRL = ABS(LKNTRL)
C
C       SKIP PRINTING IF THE CONTROL FLAG VALUE AS RESET IN XERCNT IS
C       ZERO AND THE ERROR IS NOT FATAL.
C
      IF (LEVEL.LT.2 .AND. LKNTRL.EQ.0) GO TO 30
      IF (LEVEL.EQ.0 .AND. KOUNT.GT.MAXMES) GO TO 30
      IF (LEVEL.EQ.1 .AND. KOUNT.GT.MAXMES .AND. MKNTRL.EQ.1) GO TO 30
      IF (LEVEL.EQ.2 .AND. KOUNT.GT.MAX(1,MAXMES)) GO TO 30
C
C       ANNOUNCE THE NAMES OF THE LIBRARY AND SUBROUTINE BY BUILDING A
C       MESSAGE IN CHARACTER VARIABLE TEMP (NOT EXCEEDING 66 CHARACTERS)
C       AND SENDING IT OUT VIA XERPRN.  PRINT ONLY IF CONTROL FLAG
C       IS NOT ZERO.
C
      IF (LKNTRL .NE. 0) THEN
         TEMP(1:21) = 'MESSAGE FROM ROUTINE '
         I = MIN(LEN(SUBROU), 16)
         TEMP(22:21+I) = SUBROU(1:I)
         TEMP(22+I:33+I) = ' IN LIBRARY '
         LTEMP = 33 + I
         I = MIN(LEN(LIBRAR), 16)
         TEMP(LTEMP+1:LTEMP+I) = LIBRAR (1:I)
         TEMP(LTEMP+I+1:LTEMP+I+1) = '.'
         LTEMP = LTEMP + I + 1
         CALL XERPRN (' ***', -1, TEMP(1:LTEMP), 72)
      ENDIF
C
C       IF LKNTRL IS POSITIVE, PRINT AN INTRODUCTORY LINE BEFORE
C       PRINTING THE MESSAGE.  THE INTRODUCTORY LINE TELLS THE CHOICE
C       FROM EACH OF THE FOLLOWING THREE OPTIONS.
C       1.  LEVEL OF THE MESSAGE
C              'INFORMATIVE MESSAGE'
C              'POTENTIALLY RECOVERABLE ERROR'
C              'FATAL ERROR'
C       2.  WHETHER CONTROL FLAG WILL ALLOW PROGRAM TO CONTINUE
C              'PROG CONTINUES'
C              'PROG ABORTED'
C       3.  WHETHER OR NOT A TRACEBACK WAS REQUESTED.  (THE TRACEBACK
C           MAY NOT BE IMPLEMENTED AT SOME SITES, SO THIS ONLY TELLS
C           WHAT WAS REQUESTED, NOT WHAT WAS DELIVERED.)
C              'TRACEBACK REQUESTED'
C              'TRACEBACK NOT REQUESTED'
C       NOTICE THAT THE LINE INCLUDING FOUR PREFIX CHARACTERS WILL NOT
C       EXCEED 74 CHARACTERS.
C       WE SKIP THE NEXT BLOCK IF THE INTRODUCTORY LINE IS NOT NEEDED.
C
      IF (LKNTRL .GT. 0) THEN
C
C       THE FIRST PART OF THE MESSAGE TELLS ABOUT THE LEVEL.
C
         IF (LEVEL .LE. 0) THEN
            TEMP(1:20) = 'INFORMATIVE MESSAGE,'
            LTEMP = 20
         ELSEIF (LEVEL .EQ. 1) THEN
            TEMP(1:30) = 'POTENTIALLY RECOVERABLE ERROR,'
            LTEMP = 30
         ELSE
            TEMP(1:12) = 'FATAL ERROR,'
            LTEMP = 12
         ENDIF
C
C       THEN WHETHER THE PROGRAM WILL CONTINUE.
C
         IF ((MKNTRL.EQ.2 .AND. LEVEL.GE.1) .OR.
     *       (MKNTRL.EQ.1 .AND. LEVEL.EQ.2)) THEN
            TEMP(LTEMP+1:LTEMP+14) = ' PROG ABORTED,'
            LTEMP = LTEMP + 14
         ELSE
            TEMP(LTEMP+1:LTEMP+16) = ' PROG CONTINUES,'
            LTEMP = LTEMP + 16
         ENDIF
C
C       FINALLY TELL WHETHER THERE SHOULD BE A TRACEBACK.
C
         IF (LKNTRL .GT. 0) THEN
            TEMP(LTEMP+1:LTEMP+20) = ' TRACEBACK REQUESTED'
            LTEMP = LTEMP + 20
         ELSE
            TEMP(LTEMP+1:LTEMP+24) = ' TRACEBACK NOT REQUESTED'
            LTEMP = LTEMP + 24
         ENDIF
         CALL XERPRN (' ***', -1, TEMP(1:LTEMP), 72)
      ENDIF
C
C       NOW SEND OUT THE MESSAGE.
C
      CALL XERPRN (' *  ', -1, MESSG, 72)
C
C       IF LKNTRL IS POSITIVE, WRITE THE ERROR NUMBER AND REQUEST A
C          TRACEBACK.
C
      IF (LKNTRL .GT. 0) THEN
         WRITE (TEMP, '(''ERROR NUMBER = '', I8)') NERR
         DO 10 I=16,22
            IF (TEMP(I:I) .NE. ' ') GO TO 20
   10    CONTINUE
C
   20    CALL XERPRN (' *  ', -1, TEMP(1:15) // TEMP(I:23), 72)
         CALL FDUMP
      ENDIF
C
C       IF LKNTRL IS NOT ZERO, PRINT A BLANK LINE AND AN END OF MESSAGE.
C
      IF (LKNTRL .NE. 0) THEN
         CALL XERPRN (' *  ', -1, ' ', 72)
         CALL XERPRN (' ***', -1, 'END OF MESSAGE', 72)
         CALL XERPRN ('    ',  0, ' ', 72)
      ENDIF
C
C       IF THE ERROR IS NOT FATAL OR THE ERROR IS RECOVERABLE AND THE
C       CONTROL FLAG IS SET FOR RECOVERY, THEN RETURN.
C
   30 IF (LEVEL.LE.0 .OR. (LEVEL.EQ.1 .AND. MKNTRL.LE.1)) RETURN
C
C       THE PROGRAM WILL BE STOPPED DUE TO AN UNRECOVERED ERROR OR A
C       FATAL ERROR.  PRINT THE REASON FOR THE ABORT AND THE ERROR
C       SUMMARY IF THE CONTROL FLAG AND THE MAXIMUM ERROR COUNT PERMIT.
C
      IF (LKNTRL.GT.0 .AND. KOUNT.LT.MAX(1,MAXMES)) THEN
         IF (LEVEL .EQ. 1) THEN
            CALL XERPRN
     *         (' ***', -1, 'JOB ABORT DUE TO UNRECOVERED ERROR.', 72)
         ELSE
            CALL XERPRN(' ***', -1, 'JOB ABORT DUE TO FATAL ERROR.', 72)
         ENDIF
         CALL XERSVE (' ', ' ', ' ', -1, 0, 0, KDUMMY)
         CALL XERHLT (' ')
      ELSE
         CALL XERPRN(' ***', -1, 'JOB ABORT DUE TO FATAL ERROR.', 72)  ! SB 20-apr-2012
         CALL XERHLT (MESSG)
      ENDIF
      RETURN
      END
*DECK XERPRN
      SUBROUTINE XERPRN (PREFIX, NPREF, MESSG, NWRAP)
C***BEGIN PROLOGUE  XERPRN
C***SUBSIDIARY
C***PURPOSE  Print error messages processed by XERMSG.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERPRN-A)
C***KEYWORDS  ERROR MESSAGES, PRINTING, XERROR
C***AUTHOR  Fong, Kirby, (NMFECC at LLNL)
C***DESCRIPTION
C
C This routine sends one or more lines to each of the (up to five)
C logical units to which error messages are to be sent.  This routine
C is called several times by XERMSG, sometimes with a single line to
C print and sometimes with a (potentially very long) message that may
C wrap around into multiple lines.
C
C PREFIX  Input argument of type CHARACTER.  This argument contains
C         characters to be put at the beginning of each line before
C         the body of the message.  No more than 16 characters of
C         PREFIX will be used.
C
C NPREF   Input argument of type INTEGER.  This argument is the number
C         of characters to use from PREFIX.  If it is negative, the
C         intrinsic function LEN is used to determine its length.  If
C         it is zero, PREFIX is not used.  If it exceeds 16 or if
C         LEN(PREFIX) exceeds 16, only the first 16 characters will be
C         used.  If NPREF is positive and the length of PREFIX is less
C         than NPREF, a copy of PREFIX extended with blanks to length
C         NPREF will be used.
C
C MESSG   Input argument of type CHARACTER.  This is the text of a
C         message to be printed.  If it is a long message, it will be
C         broken into pieces for printing on multiple lines.  Each line
C         will start with the appropriate prefix and be followed by a
C         piece of the message.  NWRAP is the number of characters per
C         piece; that is, after each NWRAP characters, we break and
C         start a new line.  In addition the characters '$$' embedded
C         in MESSG are a sentinel for a new line.  The counting of
C         characters up to NWRAP starts over for each new line.  The
C         value of NWRAP typically used by XERMSG is 72 since many
C         older error messages in the SLATEC Library are laid out to
C         rely on wrap-around every 72 characters.
C
C NWRAP   Input argument of type INTEGER.  This gives the maximum size
C         piece into which to break MESSG for printing on multiple
C         lines.  An embedded '$$' ends a line, and the count restarts
C         at the following character.  If a line break does not occur
C         on a blank (it would split a word) that word is moved to the
C         next line.  Values of NWRAP less than 16 will be treated as
C         16.  Values of NWRAP greater than 132 will be treated as 132.
C         The actual line length will be NPREF + NWRAP after NPREF has
C         been adjusted to fall between 0 and 16 and NWRAP has been
C         adjusted to fall between 16 and 132.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  I1MACH, XGETUA
C***REVISION HISTORY  (YYMMDD)
C   880621  DATE WRITTEN
C   880708  REVISED AFTER THE SLATEC CML SUBCOMMITTEE MEETING OF
C           JUNE 29 AND 30 TO CHANGE THE NAME TO XERPRN AND TO REWORK
C           THE HANDLING OF THE NEW LINE SENTINEL TO BEHAVE LIKE THE
C           SLASH CHARACTER IN FORMAT STATEMENTS.
C   890706  REVISED WITH THE HELP OF FRED FRITSCH AND REG CLEMENS TO
C           STREAMLINE THE CODING AND FIX A BUG THAT CAUSED EXTRA BLANK
C           LINES TO BE PRINTED.
C   890721  REVISED TO ADD A NEW FEATURE.  A NEGATIVE VALUE OF NPREF
C           CAUSES LEN(PREFIX) TO BE USED AS THE LENGTH.
C   891013  REVISED TO CORRECT ERROR IN CALCULATING PREFIX LENGTH.
C   891214  Prologue converted to Version 4.0 format.  (WRB)
C   900510  Added code to break messages between words.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERPRN
      CHARACTER*(*) PREFIX, MESSG
      INTEGER NPREF, NWRAP
      CHARACTER*148 CBUFF
      INTEGER IU(5), NUNIT
      CHARACTER*2 NEWLIN
      PARAMETER (NEWLIN = '$$')
C***FIRST EXECUTABLE STATEMENT  XERPRN
      CALL XGETUA(IU,NUNIT)
C
C       A ZERO VALUE FOR A LOGICAL UNIT NUMBER MEANS TO USE THE STANDARD
C       ERROR MESSAGE UNIT INSTEAD.  I1MACH(4) RETRIEVES THE STANDARD
C       ERROR MESSAGE UNIT.
C
      N = I1MACH(4)
      DO 10 I=1,NUNIT
         IF (IU(I) .EQ. 0) IU(I) = N
   10 CONTINUE
C
C       LPREF IS THE LENGTH OF THE PREFIX.  THE PREFIX IS PLACED AT THE
C       BEGINNING OF CBUFF, THE CHARACTER BUFFER, AND KEPT THERE DURING
C       THE REST OF THIS ROUTINE.
C
      IF ( NPREF .LT. 0 ) THEN
         LPREF = LEN(PREFIX)
      ELSE
         LPREF = NPREF
      ENDIF
      LPREF = MIN(16, LPREF)
      IF (LPREF .NE. 0) CBUFF(1:LPREF) = PREFIX
C
C       LWRAP IS THE MAXIMUM NUMBER OF CHARACTERS WE WANT TO TAKE AT ONE
C       TIME FROM MESSG TO PRINT ON ONE LINE.
C
      LWRAP = MAX(16, MIN(132, NWRAP))
C
C       SET LENMSG TO THE LENGTH OF MESSG, IGNORE ANY TRAILING BLANKS.
C
      LENMSG = LEN(MESSG)
      N = LENMSG
      DO 20 I=1,N
         IF (MESSG(LENMSG:LENMSG) .NE. ' ') GO TO 30
         LENMSG = LENMSG - 1
   20 CONTINUE
   30 CONTINUE
C
C       IF THE MESSAGE IS ALL BLANKS, THEN PRINT ONE BLANK LINE.
C
      IF (LENMSG .EQ. 0) THEN
         CBUFF(LPREF+1:LPREF+1) = ' '
         DO 40 I=1,NUNIT
            WRITE(IU(I), '(A)') CBUFF(1:LPREF+1)
   40    CONTINUE
         RETURN
      ENDIF
C
C       SET NEXTC TO THE POSITION IN MESSG WHERE THE NEXT SUBSTRING
C       STARTS.  FROM THIS POSITION WE SCAN FOR THE NEW LINE SENTINEL.
C       WHEN NEXTC EXCEEDS LENMSG, THERE IS NO MORE TO PRINT.
C       WE LOOP BACK TO LABEL 50 UNTIL ALL PIECES HAVE BEEN PRINTED.
C
C       WE LOOK FOR THE NEXT OCCURRENCE OF THE NEW LINE SENTINEL.  THE
C       INDEX INTRINSIC FUNCTION RETURNS ZERO IF THERE IS NO OCCURRENCE
C       OR IF THE LENGTH OF THE FIRST ARGUMENT IS LESS THAN THE LENGTH
C       OF THE SECOND ARGUMENT.
C
C       THERE ARE SEVERAL CASES WHICH SHOULD BE CHECKED FOR IN THE
C       FOLLOWING ORDER.  WE ARE ATTEMPTING TO SET LPIECE TO THE NUMBER
C       OF CHARACTERS THAT SHOULD BE TAKEN FROM MESSG STARTING AT
C       POSITION NEXTC.
C
C       LPIECE .EQ. 0   THE NEW LINE SENTINEL DOES NOT OCCUR IN THE
C                       REMAINDER OF THE CHARACTER STRING.  LPIECE
C                       SHOULD BE SET TO LWRAP OR LENMSG+1-NEXTC,
C                       WHICHEVER IS LESS.
C
C       LPIECE .EQ. 1   THE NEW LINE SENTINEL STARTS AT MESSG(NEXTC:
C                       NEXTC).  LPIECE IS EFFECTIVELY ZERO, AND WE
C                       PRINT NOTHING TO AVOID PRODUCING UNNECESSARY
C                       BLANK LINES.  THIS TAKES CARE OF THE SITUATION
C                       WHERE THE LIBRARY ROUTINE HAS A MESSAGE OF
C                       EXACTLY 72 CHARACTERS FOLLOWED BY A NEW LINE
C                       SENTINEL FOLLOWED BY MORE CHARACTERS.  NEXTC
C                       SHOULD BE INCREMENTED BY 2.
C
C       LPIECE .GT. LWRAP+1  REDUCE LPIECE TO LWRAP.
C
C       ELSE            THIS LAST CASE MEANS 2 .LE. LPIECE .LE. LWRAP+1
C                       RESET LPIECE = LPIECE-1.  NOTE THAT THIS
C                       PROPERLY HANDLES THE END CASE WHERE LPIECE .EQ.
C                       LWRAP+1.  THAT IS, THE SENTINEL FALLS EXACTLY
C                       AT THE END OF A LINE.
C
      NEXTC = 1
   50 LPIECE = INDEX(MESSG(NEXTC:LENMSG), NEWLIN)
      IF (LPIECE .EQ. 0) THEN
C
C       THERE WAS NO NEW LINE SENTINEL FOUND.
C
         IDELTA = 0
         LPIECE = MIN(LWRAP, LENMSG+1-NEXTC)
         IF (LPIECE .LT. LENMSG+1-NEXTC) THEN
            DO 52 I=LPIECE+1,2,-1
               IF (MESSG(NEXTC+I-1:NEXTC+I-1) .EQ. ' ') THEN
                  LPIECE = I-1
                  IDELTA = 1
                  GOTO 54
               ENDIF
   52       CONTINUE
         ENDIF
   54    CBUFF(LPREF+1:LPREF+LPIECE) = MESSG(NEXTC:NEXTC+LPIECE-1)
         NEXTC = NEXTC + LPIECE + IDELTA
      ELSEIF (LPIECE .EQ. 1) THEN
C
C       WE HAVE A NEW LINE SENTINEL AT MESSG(NEXTC:NEXTC+1).
C       DON'T PRINT A BLANK LINE.
C
         NEXTC = NEXTC + 2
         GO TO 50
      ELSEIF (LPIECE .GT. LWRAP+1) THEN
C
C       LPIECE SHOULD BE SET DOWN TO LWRAP.
C
         IDELTA = 0
         LPIECE = LWRAP
         DO 56 I=LPIECE+1,2,-1
            IF (MESSG(NEXTC+I-1:NEXTC+I-1) .EQ. ' ') THEN
               LPIECE = I-1
               IDELTA = 1
               GOTO 58
            ENDIF
   56    CONTINUE
   58    CBUFF(LPREF+1:LPREF+LPIECE) = MESSG(NEXTC:NEXTC+LPIECE-1)
         NEXTC = NEXTC + LPIECE + IDELTA
      ELSE
C
C       IF WE ARRIVE HERE, IT MEANS 2 .LE. LPIECE .LE. LWRAP+1.
C       WE SHOULD DECREMENT LPIECE BY ONE.
C
         LPIECE = LPIECE - 1
         CBUFF(LPREF+1:LPREF+LPIECE) = MESSG(NEXTC:NEXTC+LPIECE-1)
         NEXTC  = NEXTC + LPIECE + 2
      ENDIF
C
C       PRINT
C
      DO 60 I=1,NUNIT
         WRITE(IU(I), '(A)') CBUFF(1:LPREF+LPIECE)
   60 CONTINUE
C
      IF (NEXTC .LE. LENMSG) GO TO 50
      RETURN
      END
*DECK XERSVE
      SUBROUTINE XERSVE (LIBRAR, SUBROU, MESSG, KFLAG, NERR, LEVEL,
     +   ICOUNT)
C***BEGIN PROLOGUE  XERSVE
C***SUBSIDIARY
C***PURPOSE  Record that an error has occurred.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3
C***TYPE      ALL (XERSVE-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  KFLAG, NERR, LEVEL, ICOUNT
C        CHARACTER * (len) LIBRAR, SUBROU, MESSG
C
C        CALL XERSVE (LIBRAR, SUBROU, MESSG, KFLAG, NERR, LEVEL, ICOUNT)
C
C *Arguments:
C
C        LIBRAR :IN    is the library that the message is from.
C        SUBROU :IN    is the subroutine that the message is from.
C        MESSG  :IN    is the message to be saved.
C        KFLAG  :IN    indicates the action to be performed.
C                      when KFLAG > 0, the message in MESSG is saved.
C                      when KFLAG=0 the tables will be dumped and
C                      cleared.
C                      when KFLAG < 0, the tables will be dumped and
C                      not cleared.
C        NERR   :IN    is the error number.
C        LEVEL  :IN    is the error severity.
C        ICOUNT :OUT   the number of times this message has been seen,
C                      or zero if the table has overflowed and does not
C                      contain this message specifically.  When KFLAG=0,
C                      ICOUNT will not be altered.
C
C *Description:
C
C   Record that this error occurred and possibly dump and clear the
C   tables.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  I1MACH, XGETUA
C***REVISION HISTORY  (YYMMDD)
C   800319  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900413  Routine modified to remove reference to KFLAG.  (WRB)
C   900510  Changed to add LIBRARY NAME and SUBROUTINE to calling
C           sequence, use IF-THEN-ELSE, make number of saved entries
C           easily changeable, changed routine name from XERSAV to
C           XERSVE.  (RWC)
C   910626  Added LIBTAB and SUBTAB to SAVE statement.  (BKS)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERSVE
      PARAMETER (LENTAB=10)
      INTEGER LUN(5)
      CHARACTER*(*) LIBRAR, SUBROU, MESSG
      CHARACTER*8  LIBTAB(LENTAB), SUBTAB(LENTAB), LIB, SUB
      CHARACTER*20 MESTAB(LENTAB), MES
      DIMENSION NERTAB(LENTAB), LEVTAB(LENTAB), KOUNT(LENTAB)
      SAVE LIBTAB, SUBTAB, MESTAB, NERTAB, LEVTAB, KOUNT, KOUNTX, NMSG
      DATA KOUNTX/0/, NMSG/0/
C***FIRST EXECUTABLE STATEMENT  XERSVE
C
      IF (KFLAG.LE.0) THEN
C
C        Dump the table.
C
         IF (NMSG.EQ.0) RETURN
C
C        Print to each unit.
C
         CALL XGETUA (LUN, NUNIT)
         DO 20 KUNIT = 1,NUNIT
            IUNIT = LUN(KUNIT)
            IF (IUNIT.EQ.0) IUNIT = I1MACH(4)
C
C           Print the table header.
C
            WRITE (IUNIT,9000)
C
C           Print body of table.
C
            DO 10 I = 1,NMSG
               WRITE (IUNIT,9010) LIBTAB(I), SUBTAB(I), MESTAB(I),
     *            NERTAB(I),LEVTAB(I),KOUNT(I)
   10       CONTINUE
C
C           Print number of other errors.
C
            IF (KOUNTX.NE.0) WRITE (IUNIT,9020) KOUNTX
            WRITE (IUNIT,9030)
   20    CONTINUE
C
C        Clear the error tables.
C
         IF (KFLAG.EQ.0) THEN
            NMSG = 0
            KOUNTX = 0
         ENDIF
      ELSE
C
C        PROCESS A MESSAGE...
C        SEARCH FOR THIS MESSG, OR ELSE AN EMPTY SLOT FOR THIS MESSG,
C        OR ELSE DETERMINE THAT THE ERROR TABLE IS FULL.
C
         LIB = LIBRAR
         SUB = SUBROU
         MES = MESSG
         DO 30 I = 1,NMSG
            IF (LIB.EQ.LIBTAB(I) .AND. SUB.EQ.SUBTAB(I) .AND.
     *         MES.EQ.MESTAB(I) .AND. NERR.EQ.NERTAB(I) .AND.
     *         LEVEL.EQ.LEVTAB(I)) THEN
                  KOUNT(I) = KOUNT(I) + 1
                  ICOUNT = KOUNT(I)
                  RETURN
            ENDIF
   30    CONTINUE
C
         IF (NMSG.LT.LENTAB) THEN
C
C           Empty slot found for new message.
C
            NMSG = NMSG + 1
            LIBTAB(I) = LIB
            SUBTAB(I) = SUB
            MESTAB(I) = MES
            NERTAB(I) = NERR
            LEVTAB(I) = LEVEL
            KOUNT (I) = 1
            ICOUNT    = 1
         ELSE
C
C           Table is full.
C
            KOUNTX = KOUNTX+1
            ICOUNT = 0
         ENDIF
      ENDIF
      RETURN
C
C     Formats.
C
 9000 FORMAT ('0          ERROR MESSAGE SUMMARY' /
     +   ' LIBRARY    SUBROUTINE MESSAGE START             NERR',
     +   '     LEVEL     COUNT')
 9010 FORMAT (1X,A,3X,A,3X,A,3I10)
 9020 FORMAT ('0OTHER ERRORS NOT INDIVIDUALLY TABULATED = ', I10)
 9030 FORMAT (1X)
      END
*DECK XGETF
      SUBROUTINE XGETF (KONTRL)
C***BEGIN PROLOGUE  XGETF
C***PURPOSE  Return the current value of the error control flag.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XGETF-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C   Abstract
C        XGETF returns the current value of the error control flag
C        in KONTRL.  See subroutine XSETF for flag value meanings.
C        (KONTRL is an output parameter only.)
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XGETF
C***FIRST EXECUTABLE STATEMENT  XGETF
      KONTRL = J4SAVE(2,0,.FALSE.)
      RETURN
      END
*DECK XGETUA
      SUBROUTINE XGETUA (IUNITA, N)
C***BEGIN PROLOGUE  XGETUA
C***PURPOSE  Return unit number(s) to which error messages are being
C            sent.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XGETUA-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        XGETUA may be called to determine the unit number or numbers
C        to which error messages are being sent.
C        These unit numbers may have been set by a call to XSETUN,
C        or a call to XSETUA, or may be a default value.
C
C     Description of Parameters
C      --Output--
C        IUNIT - an array of one to five unit numbers, depending
C                on the value of N.  A value of zero refers to the
C                default unit, as defined by the I1MACH machine
C                constant routine.  Only IUNIT(1),...,IUNIT(N) are
C                defined by XGETUA.  The values of IUNIT(N+1),...,
C                IUNIT(5) are not defined (for N .LT. 5) or altered
C                in any way by XGETUA.
C        N     - the number of units to which copies of the
C                error messages are being sent.  N will be in the
C                range from 1 to 5.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XGETUA
      DIMENSION IUNITA(5)
C***FIRST EXECUTABLE STATEMENT  XGETUA
      N = J4SAVE(5,0,.FALSE.)
      DO 30 I=1,N
         INDEX = I+4
         IF (I.EQ.1) INDEX = 3
         IUNITA(I) = J4SAVE(INDEX,0,.FALSE.)
   30 CONTINUE
      RETURN
      END
*DECK XGETUN
      SUBROUTINE XGETUN (IUNIT)
C***BEGIN PROLOGUE  XGETUN
C***PURPOSE  Return the (first) output file to which error messages
C            are being sent.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XGETUN-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        XGETUN gets the (first) output file to which error messages
C        are being sent.  To find out if more than one file is being
C        used, one must use the XGETUA routine.
C
C     Description of Parameter
C      --Output--
C        IUNIT - the logical unit number of the  (first) unit to
C                which error messages are being sent.
C                A value of zero means that the default file, as
C                defined by the I1MACH routine, is being used.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XGETUN
C***FIRST EXECUTABLE STATEMENT  XGETUN
      IUNIT = J4SAVE(3,0,.FALSE.)
      RETURN
      END
*DECK XLEGF
      SUBROUTINE XLEGF (DNU1, NUDIFF, MU1, MU2, THETA, ID, PQA, IPQA,
     1   IERROR)
C***BEGIN PROLOGUE  XLEGF
C***PURPOSE  Compute normalized Legendre polynomials and associated
C            Legendre functions.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XLEGF-S, DXLEGF-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C
C   XLEGF: Extended-range Single-precision Legendre Functions
C
C   A feature of the XLEGF subroutine for Legendre functions is
C the use of extended-range arithmetic, a software extension of
C ordinary floating-point arithmetic that greatly increases the
C exponent range of the representable numbers. This avoids the
C need for scaling the solutions to lie within the exponent range
C of the most restrictive manufacturer's hardware. The increased
C exponent range is achieved by allocating an integer storage
C location together with each floating-point storage location.
C
C   The interpretation of the pair (X,I) where X is floating-point
C and I is integer is X*(IR**I) where IR is the internal radix of
C the computer arithmetic.
C
C   This subroutine computes one of the following vectors:
C
C 1. Legendre function of the first kind of negative order, either
C    a. P(-MU1,NU,X), P(-MU1-1,NU,X), ..., P(-MU2,NU,X) or
C    b. P(-MU,NU1,X), P(-MU,NU1+1,X), ..., P(-MU,NU2,X)
C 2. Legendre function of the second kind, either
C    a. Q(MU1,NU,X), Q(MU1+1,NU,X), ..., Q(MU2,NU,X) or
C    b. Q(MU,NU1,X), Q(MU,NU1+1,X), ..., Q(MU,NU2,X)
C 3. Legendre function of the first kind of positive order, either
C    a. P(MU1,NU,X), P(MU1+1,NU,X), ..., P(MU2,NU,X) or
C    b. P(MU,NU1,X), P(MU,NU1+1,X), ..., P(MU,NU2,X)
C 4. Normalized Legendre polynomials, either
C    a. PN(MU1,NU,X), PN(MU1+1,NU,X), ..., PN(MU2,NU,X) or
C    b. PN(MU,NU1,X), PN(MU,NU1+1,X), ..., PN(MU,NU2,X)
C
C where X = COS(THETA).
C
C   The input values to XLEGF are DNU1, NUDIFF, MU1, MU2, THETA,
C and ID. These must satisfy
C
C    DNU1 is REAL and greater than or equal to -0.5;
C    NUDIFF is INTEGER and non-negative;
C    MU1 is INTEGER and non-negative;
C    MU2 is INTEGER and greater than or equal to MU1;
C    THETA is REAL and in the half-open interval (0,PI/2];
C    ID is INTEGER and equal to 1, 2, 3 or 4;
C
C and  additionally either NUDIFF = 0 or MU2 = MU1.
C
C   If ID=1 and NUDIFF=0, a vector of type 1a above is computed
C with NU=DNU1.
C
C   If ID=1 and MU1=MU2, a vector of type 1b above is computed
C with NU1=DNU1, NU2=DNU1+NUDIFF and MU=MU1.
C
C   If ID=2 and NUDIFF=0, a vector of type 2a above is computed
C with NU=DNU1.
C
C   If ID=2 and MU1=MU2, a vector of type 2b above is computed
C with NU1=DNU1, NU2=DNU1+NUDIFF and MU=MU1.
C
C   If ID=3 and NUDIFF=0, a vector of type 3a above is computed
C with NU=DNU1.
C
C   If ID=3 and MU1=MU2, a vector of type 3b above is computed
C with NU1=DNU1, NU2=DNU1+NUDIFF and MU=MU1.
C
C   If ID=4 and NUDIFF=0, a vector of type 4a above is computed
C with NU=DNU1.
C
C   If ID=4 and MU1=MU2, a vector of type 4b above is computed
C with NU1=DNU1, NU2=DNU1+NUDIFF and MU=MU1.
C
C   In each case the vector of computed Legendre function values
C is returned in the extended-range vector (PQA(I),IPQA(I)). The
C length of this vector is either MU2-MU1+1 or NUDIFF+1.
C
C   Where possible, XLEGF returns IPQA(I) as zero. In this case the
C value of the Legendre function is contained entirely in PQA(I),
C so it can be used in subsequent computations without further
C consideration of extended-range arithmetic. If IPQA(I) is nonzero,
C then the value of the Legendre function is not representable in
C floating-point because of underflow or overflow. The program that
C calls XLEGF must test IPQA(I) to ensure correct usage.
C
C   IERROR is an error indicator. If no errors are detected, IERROR=0
C when control returns to the calling routine. If an error is detected,
C IERROR is returned as nonzero. The calling routine must check the
C value of IERROR.
C
C   If IERROR=110 or 111, invalid input was provided to XLEGF.
C   If IERROR=101,102,103, or 104, invalid input was provided to XSET.
C   If IERROR=105 or 106, an internal consistency error occurred in
C XSET (probably due to a software malfunction in the library routine
C I1MACH).
C   If IERROR=107, an overflow or underflow of an extended-range number
C was detected in XADJ.
C   If IERROR=108, an overflow or underflow of an extended-range number
C was detected in XC210.
C
C***SEE ALSO  XSET
C***REFERENCES  Olver and Smith, Associated Legendre Functions on the
C                 Cut, J Comp Phys, v 51, n 3, Sept 1983, pp 502--518.
C               Smith, Olver and Lozier, Extended-Range Arithmetic and
C                 Normalized Legendre Polynomials, ACM Trans on Math
C                 Softw, v 7, n 1, March 1981, pp 93--105.
C***ROUTINES CALLED  XERMSG, XPMU, XPMUP, XPNRM, XPQNU, XQMU, XQNU,
C                    XRED, XSET
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XLEGF
      REAL PQA,DNU1,DNU2,SX,THETA,X,PI2
      DIMENSION PQA(*),IPQA(*)
C
C***FIRST EXECUTABLE STATEMENT  XLEGF
      IERROR=0
      CALL XSET (0, 0, 0.0, 0,IERROR)
      IF (IERROR.NE.0) RETURN
      PI2=2.*ATAN(1.)
C
C        ZERO OUTPUT ARRAYS
C
      L=(MU2-MU1)+NUDIFF+1
      DO 290 I=1,L
      PQA(I)=0.
  290 IPQA(I)=0
C
C        CHECK FOR VALID INPUT VALUES
C
      IF(NUDIFF.LT.0) GO TO 400
      IF(DNU1.LT.-.5) GO TO 400
      IF(MU2.LT.MU1) GO TO 400
      IF(MU1.LT.0) GO TO 400
      IF(THETA.LE.0..OR.THETA.GT.PI2) GO TO 420
      IF(ID.LT.1.OR.ID.GT.4) GO TO 400
      IF((MU1.NE.MU2).AND.(NUDIFF.GT.0)) GO TO 400
C
C        IF DNU1 IS NOT AN INTEGER, NORMALIZED P(MU,DNU,X)
C        CANNOT BE CALCULATED.  IF DNU1 IS AN INTEGER AND
C        MU1.GT.DNU2 THEN ALL VALUES OF P(+MU,DNU,X) AND
C        NORMALIZED P(MU,NU,X) WILL BE ZERO.
C
      DNU2=DNU1+NUDIFF
      IF((ID.EQ.3).AND.(MOD(DNU1,1.).NE.0.)) GO TO 295
      IF((ID.EQ.4).AND.(MOD(DNU1,1.).NE.0.)) GO TO 400
      IF((ID.EQ.3.OR.ID.EQ.4).AND.MU1.GT.DNU2) RETURN
  295 CONTINUE
C
      X=COS(THETA)
      SX=1./SIN(THETA)
      IF(ID.EQ.2) GO TO 300
      IF(MU2-MU1.LE.0) GO TO 360
C
C        FIXED NU, VARIABLE MU
C        CALL XPMU TO CALCULATE P(-MU1,NU,X),....,P(-MU2,NU,X)
C
      CALL XPMU(DNU1,DNU2,MU1,MU2,THETA,X,SX,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 380
C
  300 IF(MU2.EQ.MU1) GO TO 320
C
C        FIXED NU, VARIABLE MU
C        CALL XQMU TO CALCULATE Q(MU1,NU,X),....,Q(MU2,NU,X)
C
      CALL XQMU(DNU1,DNU2,MU1,MU2,THETA,X,SX,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 390
C
C        FIXED MU, VARIABLE NU
C        CALL XQNU TO CALCULATE Q(MU,DNU1,X),....,Q(MU,DNU2,X)
C
  320 CALL XQNU(DNU1,DNU2,MU1,THETA,X,SX,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 390
C
C        FIXED MU, VARIABLE NU
C        CALL XPQNU TO CALCULATE P(-MU,DNU1,X),....,P(-MU,DNU2,X)
C
  360 CALL XPQNU(DNU1,DNU2,MU1,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
C
C        IF ID = 3, TRANSFORM P(-MU,NU,X) VECTOR INTO
C        P(MU,NU,X) VECTOR.
C
  380 IF(ID.EQ.3) CALL XPMUP(DNU1,DNU2,MU1,MU2,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
C
C        IF ID = 4, TRANSFORM P(-MU,NU,X) VECTOR INTO
C        NORMALIZED P(MU,NU,X) VECTOR.
C
      IF(ID.EQ.4) CALL XPNRM(DNU1,DNU2,MU1,MU2,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
C
C        PLACE RESULTS IN REDUCED FORM IF POSSIBLE
C        AND RETURN TO MAIN PROGRAM.
C
  390 DO 395 I=1,L
      CALL XRED(PQA(I),IPQA(I),IERROR)
      IF (IERROR.NE.0) RETURN
  395 CONTINUE
      RETURN
C
C        *****     ERROR TERMINATION     *****
C
  400 CALL XERMSG ('SLATEC', 'XLEGF',
     +             'DNU1, NUDIFF, MU1, MU2, or ID not valid', 110, 1)
      IERROR=110
      RETURN
  420 CALL XERMSG ('SLATEC', 'XLEGF', 'THETA out of range', 111, 1)
      IERROR=111
      RETURN
      END
*DECK XNRMP
      SUBROUTINE XNRMP (NU, MU1, MU2, SARG, MODE, SPN, IPN, ISIG,
     1   IERROR)
C***BEGIN PROLOGUE  XNRMP
C***PURPOSE  Compute normalized Legendre polynomials.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XNRMP-S, DXNRMP-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C
C        SUBROUTINE TO CALCULATE NORMALIZED LEGENDRE POLYNOMIALS
C        (DXNRMP is double-precision version)
C        XNRMP calculates normalized Legendre polynomials of varying
C        order and fixed argument and degree. The order MU and degree
C        NU are non-negative integers and the argument is real. Because
C        the algorithm requires the use of numbers outside the normal
C        machine range, this subroutine employs a special arithmetic
C        called extended-range arithmetic. See J.M. Smith, F.W.J. Olver,
C        and D.W. Lozier, Extended-Range Arithmetic and Normalized
C        Legendre Polynomials, ACM Transactions on Mathematical Soft-
C        ware, 93-105, March 1981, for a complete description of the
C        algorithm and special arithmetic. Also see program comments
C        in XSET.
C
C        The normalized Legendre polynomials are multiples of the
C        associated Legendre polynomials of the first kind where the
C        normalizing coefficients are chosen so as to make the integral
C        from -1 to 1 of the square of each function equal to 1. See
C        E. Jahnke, F. Emde and F. Losch, Tables of Higher Functions,
C        McGraw-Hill, New York, 1960, p. 121.
C
C        The input values to XNRMP are NU, MU1, MU2, SARG, and MODE.
C        These must satisfy
C          1. NU .GE. 0 specifies the degree of the normalized Legendre
C             polynomial that is wanted.
C          2. MU1 .GE. 0 specifies the lowest-order normalized Legendre
C             polynomial that is wanted.
C          3. MU2 .GE. MU1 specifies the highest-order normalized Leg-
C             endre polynomial that is wanted.
C         4a. MODE = 1 and -1.0 .LE. SARG .LE. 1.0 specifies that
C             Normalized Legendre(NU, MU, SARG) is wanted for MU = MU1,
C             MU1 + 1, ..., MU2.
C         4b. MODE = 2 and -3.14159... .LT. SARG .LT. 3.14159... spec-
C             ifies that Normalized Legendre(NU, MU, COS(SARG)) is want-
C             ed for MU = MU1, MU1 + 1, ..., MU2.
C
C        The output of XNRMP consists of the two vectors SPN and IPN
C        and the error estimate ISIG. The computed values are stored as
C        extended-range numbers such that
C             (SPN(1),IPN(1))=NORMALIZED LEGENDRE(NU,MU1,X)
C             (SPN(2),IPN(2))=NORMALIZED LEGENDRE(NU,MU1+1,X)
C                .
C                .
C             (SPN(K),IPN(K))=NORMALIZED LEGENDRE(NU,MU2,X)
C        where K = MU2 - MU1 + 1 and X = SARG or COS(SARG) according
C        to whether MODE = 1 or 2. Finally, ISIG is an estimate of the
C        number of decimal digits lost through rounding errors in the
C        computation. For example if SARG is accurate to 12 significant
C        decimals, then the computed function values are accurate to
C        12 - ISIG significant decimals (except in neighborhoods of
C        zeros).
C
C        The interpretation of (SPN(I),IPN(I)) is SPN(I)*(IR**IPN(I))
C        where IR is the internal radix of the computer arithmetic. When
C        IPN(I) = 0 the value of the normalized Legendre polynomial is
C        contained entirely in SPN(I) and subsequent single-precision
C        computations can be performed without further consideration of
C        extended-range arithmetic. However, if IPN(I) .NE. 0 the corre-
C        sponding value of the normalized Legendre polynomial cannot be
C        represented in single-precision because of overflow or under-
C        flow. THE USER MUST TEST IPN(I) IN HIS/HER PROGRAM. In the case
C        that IPN(I) is nonzero, the user should try using double pre-
C        cision if it has a wider exponent range. If double precision
C        fails, the user could rewrite his/her program to use extended-
C        range arithmetic.
C
C        The interpretation of (SPN(I),IPN(I)) can be changed to
C        SPN(I)*(10**IPN(I)) by calling the extended-range subroutine
C        XCON. This should be done before printing the computed values.
C        As an example of usage, the Fortran coding
C              J = K
C              DO 20 I = 1, K
C              CALL XCON(SPN(I), IPN(I),IERROR)
C              IF (IERROR.NE.0) RETURN
C              PRINT 10, SPN(I), IPN(I)
C           10 FORMAT(1X, E30.8 , I15)
C              IF ((IPN(I) .EQ. 0) .OR. (J .LT. K)) GO TO 20
C              J = I - 1
C           20 CONTINUE
C        will print all computed values and determine the largest J
C        such that IPN(1) = IPN(2) = ... = IPN(J) = 0. Because of the
C        change of representation caused by calling XCON, (SPN(I),
C        IPN(I)) for I = J+1, J+2, ... cannot be used in subsequent
C        extended-range computations.
C
C        IERROR is an error indicator. If no errors are detected,
C        IERROR=0 when control returns to the calling routine. If
C        an error is detected, IERROR is returned as nonzero. The
C        calling routine must check the value of IERROR.
C
C        If IERROR=112 or 113, invalid input was provided to XNRMP.
C        If IERROR=101,102,103, or 104, invalid input was provided
C        to XSET.
C        If IERROR=105 or 106, an internal consistency error occurred
C        in XSET (probably due to a software malfunction in the
C        library routine I1MACH).
C        If IERROR=107, an overflow or underflow of an extended-range
C        number was detected in XADJ.
C        If IERROR=108, an overflow or underflow of an extended-range
C        number was detected in XC210.
C
C***SEE ALSO  XSET
C***REFERENCES  Smith, Olver and Lozier, Extended-Range Arithmetic and
C                 Normalized Legendre Polynomials, ACM Trans on Math
C                 Softw, v 7, n 1, March 1981, pp 93--105.
C***ROUTINES CALLED  XADD, XADJ, XERMSG, XRED, XSET
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XNRMP
      INTEGER NU, MU1, MU2, MODE, IPN, ISIG
      REAL SARG, SPN
      DIMENSION SPN(*), IPN(*)
      REAL C1,C2,P,P1,P2,P3,S,SX,T,TX,X,RK
C CALL XSET TO INITIALIZE EXTENDED-RANGE ARITHMETIC (SEE XSET
C LISTING FOR DETAILS)
C***FIRST EXECUTABLE STATEMENT  XNRMP
      IERROR=0
      CALL XSET (0, 0, 0.0, 0,IERROR)
      IF (IERROR.NE.0) RETURN
C
C        TEST FOR PROPER INPUT VALUES.
C
      IF (NU.LT.0) GO TO 110
      IF (MU1.LT.0) GO TO 110
      IF (MU1.GT.MU2) GO TO 110
      IF (NU.EQ.0) GO TO 90
      IF (MODE.LT.1 .OR. MODE.GT.2) GO TO 110
      GO TO (10, 20), MODE
   10 IF (ABS(SARG).GT.1.0) GO TO 120
      IF (ABS(SARG).EQ.1.0) GO TO 90
      X = SARG
      SX = SQRT((1.0+ABS(X))*((0.5-ABS(X))+0.5))
      TX = X/SX
      ISIG = LOG10(2.0*NU*(5.0+TX**2))
      GO TO 30
   20 IF (ABS(SARG).GT.4.0*ATAN(1.0)) GO TO 120
      IF (SARG.EQ.0.0) GO TO 90
      X = COS(SARG)
      SX = ABS(SIN(SARG))
      TX = X/SX
      ISIG = LOG10(2.0*NU*(5.0+ABS(SARG*TX)))
C
C        BEGIN CALCULATION
C
   30 MU = MU2
      I = MU2 - MU1 + 1
C
C        IF MU.GT.NU, NORMALIZED LEGENDRE(NU,MU,X)=0.
C
   40 IF (MU.LE.NU) GO TO 50
      SPN(I) = 0.0
      IPN(I) = 0
      I = I - 1
      MU = MU - 1
      IF (I .GT. 0) GO TO 40
      ISIG = 0
      GO TO 160
   50 MU = NU
C
C        P1 = 0. = NORMALIZED LEGENDRE(NU,NU+1,X)
C
      P1 = 0.0
      IP1 = 0
C
C        CALCULATE P2 = NORMALIZED LEGENDRE(NU,NU,X)
C
      P2 = 1.0
      IP2 = 0
      P3 = 0.5
      RK = 2.0
      DO 60 J=1,NU
        P3 = ((RK+1.0)/RK)*P3
        P2 = P2*SX
        CALL XADJ(P2, IP2,IERROR)
        IF (IERROR.NE.0) RETURN
        RK = RK + 2.0
   60 CONTINUE
      P2 = P2*SQRT(P3)
      CALL XADJ(P2, IP2,IERROR)
      IF (IERROR.NE.0) RETURN
      S = 2.0*TX
      T = 1.0/NU
      IF (MU2.LT.NU) GO TO 70
      SPN(I) = P2
      IPN(I) = IP2
      I = I - 1
      IF (I .EQ. 0) GO TO 140
C
C        RECURRENCE PROCESS
C
   70 P = MU*T
      C1 = 1.0/SQRT((1.0-P+T)*(1.0+P))
      C2 = S*P*C1*P2
      C1 = -SQRT((1.0+P+T)*(1.0-P))*C1*P1
      CALL XADD(C2, IP2, C1, IP1, P, IP,IERROR)
      IF (IERROR.NE.0) RETURN
      MU = MU - 1
      IF (MU.GT.MU2) GO TO 80
C
C        STORE IN ARRAY SPN FOR RETURN TO CALLING ROUTINE.
C
      SPN(I) = P
      IPN(I) = IP
      I = I - 1
      IF (I .EQ. 0) GO TO 140
   80 P1 = P2
      IP1 = IP2
      P2 = P
      IP2 = IP
      IF (MU.LE.MU1) GO TO 140
      GO TO 70
C
C        SPECIAL CASE WHEN X=-1 OR +1, OR NU=0.
C
   90 K = MU2 - MU1 + 1
      DO 100 I=1,K
        SPN(I) = 0.0
        IPN(I) = 0
  100 CONTINUE
      ISIG = 0
      IF (MU1.GT.0) GO TO 160
      ISIG = 1
      SPN(1) = SQRT(NU+0.5)
      IPN(1) = 0
      IF (MOD(NU,2).EQ.0) GO TO 160
      IF (MODE.EQ.1 .AND. SARG.EQ.1.0) GO TO 160
      IF (MODE.EQ.2) GO TO 160
      SPN(1) = -SPN(1)
      GO TO 160
C
C          ERROR PRINTOUTS AND TERMINATION.
C
  110 CALL XERMSG ('SLATEC', 'XNRMP', 'NU, MU1, MU2 or MODE not valid',
     +             112, 1)
      IERROR=112
      RETURN
  120 CALL XERMSG ('SLATEC', 'XNRMP', 'SARG out of range', 113, 1)
      IERROR=113
      RETURN
C
C        RETURN TO CALLING PROGRAM
C
  140 K = MU2 - MU1 + 1
      DO 150 I=1,K
        CALL XRED(SPN(I),IPN(I),IERROR)
        IF (IERROR.NE.0) RETURN
  150 CONTINUE
  160 RETURN
      END
*DECK XPMU
      SUBROUTINE XPMU (NU1, NU2, MU1, MU2, THETA, X, SX, ID, PQA, IPQA,
     1   IERROR)
C***BEGIN PROLOGUE  XPMU
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for XLEGF.
C            Method: backward mu-wise recurrence for P(-MU,NU,X) for
C            fixed nu to obtain P(-MU2,NU1,X), P(-(MU2-1),NU1,X), ...,
C            P(-MU1,NU1,X) and store in ascending mu order.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XPMU-S, DXPMU-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  XADD, XADJ, XPQNU
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XPMU
      REAL PQA,NU1,NU2,P0,X,SX,THETA,X1,X2
      DIMENSION PQA(*),IPQA(*)
C
C        CALL XPQNU TO OBTAIN P(-MU2,NU,X)
C
C***FIRST EXECUTABLE STATEMENT  XPMU
      IERROR=0
      CALL XPQNU(NU1,NU2,MU2,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      P0=PQA(1)
      IP0=IPQA(1)
      MU=MU2-1
C
C        CALL XPQNU TO OBTAIN P(-MU2-1,NU,X)
C
      CALL XPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      N=MU2-MU1+1
      PQA(N)=P0
      IPQA(N)=IP0
      IF(N.EQ.1) GO TO 300
      PQA(N-1)=PQA(1)
      IPQA(N-1)=IPQA(1)
      IF(N.EQ.2) GO TO 300
      J=N-2
  290 CONTINUE
C
C        BACKWARD RECURRENCE IN MU TO OBTAIN
C              P(-MU2,NU1,X),P(-(MU2-1),NU1,X),....P(-MU1,NU1,X)
C              USING
C              (NU-MU)*(NU+MU+1.)*P(-(MU+1),NU,X)=
C                2.*MU*X*SQRT((1./(1.-X**2))*P(-MU,NU,X)-P(-(MU-1),NU,X)
C
      X1=2.*MU*X*SX*PQA(J+1)
      X2=-(NU1-MU)*(NU1+MU+1.)*PQA(J+2)
      CALL XADD(X1,IPQA(J+1),X2,IPQA(J+2),PQA(J),IPQA(J),IERROR)
      IF (IERROR.NE.0) RETURN
      CALL XADJ(PQA(J),IPQA(J),IERROR)
      IF (IERROR.NE.0) RETURN
      IF(J.EQ.1) GO TO 300
      J=J-1
      MU=MU-1
      GO TO 290
  300 RETURN
      END
*DECK XPMUP
      SUBROUTINE XPMUP (NU1, NU2, MU1, MU2, PQA, IPQA, IERROR)
C***BEGIN PROLOGUE  XPMUP
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for XLEGF.
C            This subroutine transforms an array of Legendre functions
C            of the first kind of negative order stored in array PQA
C            into Legendre functions of the first kind of positive
C            order stored in array PQA. The original array is destroyed.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XPMUP-S, DXPMUP-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  XADJ
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XPMUP
      REAL DMU,NU,NU1,NU2,PQA,PROD
      DIMENSION PQA(*),IPQA(*)
C***FIRST EXECUTABLE STATEMENT  XPMUP
      IERROR=0
      NU=NU1
      MU=MU1
      DMU=MU
      N=INT(NU2-NU1+.1)+(MU2-MU1)+1
      J=1
      IF(MOD(NU,1.).NE.0.) GO TO 210
  200 IF(DMU.LT.NU+1.) GO TO 210
      PQA(J)=0.
      IPQA(J)=0
      J=J+1
      IF(J.GT.N) RETURN
C        INCREMENT EITHER MU OR NU AS APPROPRIATE.
      IF(NU2-NU1.GT..5) NU=NU+1.
      IF(MU2.GT.MU1) MU=MU+1
      GO TO 200
C
C        TRANSFORM P(-MU,NU,X) TO P(MU,NU,X) USING
C        P(MU,NU,X)=(NU-MU+1)*(NU-MU+2)*...*(NU+MU)*P(-MU,NU,X)*(-1)**MU
C
  210 PROD=1.
      IPROD=0
      K=2*MU
      IF(K.EQ.0) GO TO 222
      DO 220 L=1,K
      PROD=PROD*(DMU-NU-L)
  220 CALL XADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
  222 CONTINUE
      DO 240 I=J,N
      IF(MU.EQ.0) GO TO 225
      PQA(I)=PQA(I)*PROD*(-1)**MU
      IPQA(I)=IPQA(I)+IPROD
      CALL XADJ(PQA(I),IPQA(I),IERROR)
      IF (IERROR.NE.0) RETURN
  225 IF(NU2-NU1.GT..5) GO TO 230
      PROD=(DMU-NU)*PROD*(-DMU-NU-1.)
      CALL XADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
      MU=MU+1
      DMU=DMU+1.
      GO TO 240
  230 PROD=PROD*(-DMU-NU-1.)/(DMU-NU-1.)
      CALL XADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
      NU=NU+1.
  240 CONTINUE
      RETURN
      END
*DECK XPNRM
      SUBROUTINE XPNRM (NU1, NU2, MU1, MU2, PQA, IPQA, IERROR)
C***BEGIN PROLOGUE  XPNRM
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for XLEGF.
C            This subroutine transforms an array of Legendre functions
C            of the first kind of negative order stored in array PQA
C            into normalized Legendre polynomials stored in array PQA.
C            The original array is destroyed.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XPNRM-S, DXPNRM-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  XADJ
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XPNRM
      REAL C1,DMU,NU,NU1,NU2,PQA,PROD
      DIMENSION PQA(*),IPQA(*)
C***FIRST EXECUTABLE STATEMENT  XPNRM
      IERROR=0
      L=(MU2-MU1)+(NU2-NU1+1.5)
      MU=MU1
      DMU=MU1
      NU=NU1
C
C         IF MU .GT.NU, NORM P =0.
C
      J=1
  500 IF(DMU.LE.NU) GO TO 505
      PQA(J)=0.
      IPQA(J)=0
      J=J+1
      IF(J.GT.L) RETURN
C
C        INCREMENT EITHER MU OR NU AS APPROPRIATE.
C
      IF(MU2.GT.MU1) DMU=DMU+1.
      IF(NU2-NU1.GT..5) NU=NU+1.
      GO TO 500
C
C         TRANSFORM P(-MU,NU,X) INTO NORMALIZED P(MU,NU,X) USING
C              NORM P(MU,NU,X)=
C                 SQRT((NU+.5)*FACTORIAL(NU+MU)/FACTORIAL(NU-MU))
C                              *P(-MU,NU,X)
C
  505 PROD=1.
      IPROD=0
      K=2*MU
      IF(K.LE.0) GO TO 520
      DO 510 I=1,K
      PROD=PROD*SQRT(NU+DMU+1.-I)
  510 CALL XADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
  520 DO 540 I=J,L
      C1=PROD*SQRT(NU+.5)
      PQA(I)=PQA(I)*C1
      IPQA(I)=IPQA(I)+IPROD
      CALL XADJ(PQA(I),IPQA(I),IERROR)
      IF (IERROR.NE.0) RETURN
      IF(NU2-NU1.GT..5) GO TO 530
      IF(DMU.GE.NU) GO TO 525
      PROD=SQRT(NU+DMU+1.)*PROD
      IF(NU.GT.DMU) PROD=PROD*SQRT(NU-DMU)
      CALL XADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
      MU=MU+1
      DMU=DMU+1.
      GO TO 540
  525 PROD=0.
      IPROD=0
      MU=MU+1
      DMU=DMU+1.
      GO TO 540
  530 PROD=SQRT(NU+DMU+1.)*PROD
      IF(NU.NE.DMU-1.) PROD=PROD/SQRT(NU-DMU+1.)
      CALL XADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
      NU=NU+1.
  540 CONTINUE
      RETURN
      END
*DECK XPQNU
      SUBROUTINE XPQNU (NU1, NU2, MU, THETA, ID, PQA, IPQA, IERROR)
C***BEGIN PROLOGUE  XPQNU
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for XLEGF.
C            This subroutine calculates initial values of P or Q using
C            power series, then performs forward nu-wise recurrence to
C            obtain P(-MU,NU,X), Q(0,NU,X), or Q(1,NU,X). The nu-wise
C            recurrence is stable for P for all mu and for Q for mu=0,1.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XPQNU-S, DXPQNU-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  XADD, XADJ, XPSI
C***COMMON BLOCKS    XBLK1
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XPQNU
      REAL A,NU,NU1,NU2,PQ,PQA,XPSI,R,THETA,W,X,X1,X2,XS,
     1 Y,Z
      REAL DI,DMU,PQ1,PQ2,FACTMU,FLOK
      DIMENSION PQA(*),IPQA(*)
      COMMON /XBLK1/ NBITSF
      SAVE /XBLK1/
C
C        J0, IPSIK, AND IPSIX ARE INITIALIZED IN THIS SUBROUTINE.
C        J0 IS THE NUMBER OF TERMS USED IN SERIES EXPANSION
C        IN SUBROUTINE XPQNU.
C        IPSIK, IPSIX ARE VALUES OF K AND X RESPECTIVELY
C        USED IN THE CALCULATION OF THE XPSI FUNCTION.
C
C***FIRST EXECUTABLE STATEMENT  XPQNU
      IERROR=0
      J0=NBITSF
      IPSIK=1+(NBITSF/10)
      IPSIX=5*IPSIK
      IPQ=0
C        FIND NU IN INTERVAL [-.5,.5) IF ID=2  ( CALCULATION OF Q )
      NU=MOD(NU1,1.)
      IF(NU.GE..5) NU=NU-1.
C        FIND NU IN INTERVAL (-1.5,-.5] IF ID=1,3, OR 4  ( CALC. OF P )
      IF(ID.NE.2.AND.NU.GT.-.5) NU=NU-1.
C        CALCULATE MU FACTORIAL
      K=MU
      DMU=MU
      IF(MU.LE.0) GO TO 60
      FACTMU=1.
      IF=0
      DO 50 I=1,K
      FACTMU=FACTMU*I
   50 CALL XADJ(FACTMU,IF,IERROR)
      IF (IERROR.NE.0) RETURN
   60 IF(K.EQ.0) FACTMU=1.
      IF(K.EQ.0) IF=0
C
C        X=COS(THETA)
C        Y=SIN(THETA/2)**2=(1-X)/2=.5-.5*X
C        R=TAN(THETA/2)=SQRT((1-X)/(1+X)
C
      X=COS(THETA)
      Y=SIN(THETA/2.)**2
      R=TAN(THETA/2.)
C
C        USE ASCENDING SERIES TO CALCULATE TWO VALUES OF P OR Q
C        FOR USE AS STARTING VALUES IN RECURRENCE RELATION.
C
      PQ2=0.0
      DO 100 J=1,2
      IPQ1=0
      IF(ID.EQ.2) GO TO 80
C
C        SERIES FOR P ( ID = 1, 3, OR 4 )
C        P(-MU,NU,X)=1./FACTORIAL(MU)*SQRT(((1.-X)/(1.+X))**MU)
C                *SUM(FROM 0 TO J0-1)A(J)*(.5-.5*X)**J
C
      IPQ=0
      PQ=1.
      A=1.
      IA=0
      DO 65 I=2,J0
      DI=I
      A=A*Y*(DI-2.-NU)*(DI-1.+NU)/((DI-1.+DMU)*(DI-1.))
      CALL XADJ(A,IA,IERROR)
      IF (IERROR.NE.0) RETURN
      IF(A.EQ.0.) GO TO 66
      CALL XADD(PQ,IPQ,A,IA,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
   65 CONTINUE
   66 CONTINUE
      IF(MU.LE.0) GO TO 90
      X2=R
      X1=PQ
      K=MU
      DO 77 I=1,K
      X1=X1*X2
   77 CALL XADJ(X1,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ=X1/FACTMU
      IPQ=IPQ-IF
      CALL XADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 90
C
C        Z=-LN(R)=.5*LN((1+X)/(1-X))
C
   80 Z=-LOG(R)
      W=XPSI(NU+1.,IPSIK,IPSIX)
      XS=1./SIN(THETA)
C
C        SERIES SUMMATION FOR Q ( ID = 2 )
C        Q(0,NU,X)=SUM(FROM 0 TO J0-1)((.5*LN((1+X)/(1-X))
C    +XPSI(J+1,IPSIK,IPSIX)-XPSI(NU+1,IPSIK,IPSIX)))*A(J)*(.5-.5*X)**J
C
C        Q(1,NU,X)=-SQRT(1./(1.-X**2))+SQRT((1-X)/(1+X))
C             *SUM(FROM 0 T0 J0-1)(-NU*(NU+1)/2*LN((1+X)/(1-X))
C                 +(J-NU)*(J+NU+1)/(2*(J+1))+NU*(NU+1)*
C     (XPSI(NU+1,IPSIK,IPSIX)-XPSI(J+1,IPSIK,IPSIX))*A(J)*(.5-.5*X)**J
C
C        NOTE, IN THIS LOOP K=J+1
C
      PQ=0.
      IPQ=0
      IA=0
      A=1.
      DO 85 K=1,J0
      FLOK=K
      IF(K.EQ.1) GO TO 81
      A=A*Y*(FLOK-2.-NU)*(FLOK-1.+NU)/((FLOK-1.+DMU)*(FLOK-1.))
      CALL XADJ(A,IA,IERROR)
      IF (IERROR.NE.0) RETURN
   81 CONTINUE
      IF(MU.GE.1) GO TO 83
      X1=(XPSI(FLOK,IPSIK,IPSIX)-W+Z)*A
      IX1=IA
      CALL XADD(PQ,IPQ,X1,IX1,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 85
   83 X1=(NU*(NU+1.)*(Z-W+XPSI(FLOK,IPSIK,IPSIX))+(NU-FLOK+1.)
     1  *(NU+FLOK)/(2.*FLOK))*A
      IX1=IA
      CALL XADD(PQ,IPQ,X1,IX1,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
   85 CONTINUE
      IF(MU.GE.1) PQ=-R*PQ
      IXS=0
      IF(MU.GE.1) CALL XADD(PQ,IPQ,-XS,IXS,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      IF(J.EQ.2) MU=-MU
      IF(J.EQ.2) DMU=-DMU
   90 IF(J.EQ.1) PQ2=PQ
      IF(J.EQ.1) IPQ2=IPQ
      NU=NU+1.
  100 CONTINUE
      K=0
      IF(NU-1.5.LT.NU1) GO TO 120
      K=K+1
      PQA(K)=PQ2
      IPQA(K)=IPQ2
      IF(NU.GT.NU2+.5) RETURN
  120 PQ1=PQ
      IPQ1=IPQ
      IF(NU.LT.NU1+.5) GO TO 130
      K=K+1
      PQA(K)=PQ
      IPQA(K)=IPQ
      IF(NU.GT.NU2+.5) RETURN
C
C        FORWARD NU-WISE RECURRENCE FOR F(MU,NU,X) FOR FIXED MU
C        USING
C        (NU+MU+1)*F(MU,NU,X)=(2.*NU+1)*F(MU,NU,X)-(NU-MU)*F(MU,NU-1,X)
C        WHERE F(MU,NU,X) MAY BE P(-MU,NU,X) OR IF MU IS REPLACED
C        BY -MU THEN F(MU,NU,X) MAY BE Q(MU,NU,X).
C        NOTE, IN THIS LOOP, NU=NU+1
C
  130 X1=(2.*NU-1.)/(NU+DMU)*X*PQ1
      X2=(NU-1.-DMU)/(NU+DMU)*PQ2
      CALL XADD(X1,IPQ1,-X2,IPQ2,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL XADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      NU=NU+1.
      PQ2=PQ1
      IPQ2=IPQ1
      GO TO 120
C
      END
*DECK XPSI
      REAL FUNCTION XPSI (A, IPSIK, IPSIX)
C***BEGIN PROLOGUE  XPSI
C***SUBSIDIARY
C***PURPOSE  To compute values of the Psi function for XLEGF.
C***LIBRARY   SLATEC
C***CATEGORY  C7C
C***TYPE      SINGLE PRECISION (XPSI-S, DXPSI-D)
C***KEYWORDS  PSI FUNCTION
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XPSI
      REAL A,B,C,CNUM,CDENOM
      DIMENSION CNUM(12),CDENOM(12)
      SAVE CNUM, CDENOM
C
C        CNUM(I) AND CDENOM(I) ARE THE ( REDUCED ) NUMERATOR
C        AND 2*I*DENOMINATOR RESPECTIVELY OF THE 2*I TH BERNOULLI
C        NUMBER.
C
      DATA CNUM(1),CNUM(2),CNUM(3),CNUM(4),CNUM(5),CNUM(6),CNUM(7),
     1CNUM(8),CNUM(9),CNUM(10),CNUM(11),CNUM(12)
     2    / 1.,     -1.,    1.,     -1., 1.,
     3   -691.,  1.,     -3617., 43867., -174611., 77683.,
     4   -236364091./
      DATA CDENOM(1),CDENOM(2),CDENOM(3),CDENOM(4),CDENOM(5),CDENOM(6),
     1 CDENOM(7),CDENOM(8),CDENOM(9),CDENOM(10),CDENOM(11),CDENOM(12)
     2/12.,120.,   252.,   240.,132.,
     3  32760., 12.,  8160., 14364., 6600., 276., 65520./
C***FIRST EXECUTABLE STATEMENT  XPSI
      N=MAX(0,IPSIX-INT(A))
      B=N+A
      K1=IPSIK-1
C
C        SERIES EXPANSION FOR A .GT. IPSIX USING IPSIK-1 TERMS.
C
      C=0.
      DO 12 I=1,K1
      K=IPSIK-I
   12 C=(C+CNUM(K)/CDENOM(K))/B**2
      XPSI=LOG(B)-(C+.5/B)
      IF(N.EQ.0) GO TO 20
      B=0.
C
C        RECURRENCE FOR A .LE. IPSIX.
C
      DO 15 M=1,N
   15 B=B+1./(N-M+A)
      XPSI=XPSI-B
   20 RETURN
      END
*DECK XQMU
      SUBROUTINE XQMU (NU1, NU2, MU1, MU2, THETA, X, SX, ID, PQA, IPQA,
     1   IERROR)
C***BEGIN PROLOGUE  XQMU
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for XLEGF.
C            Method: forward mu-wise recurrence for Q(MU,NU,X) for fixed
C            nu to obtain Q(MU1,NU,X), Q(MU1+1,NU,X), ..., Q(MU2,NU,X).
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XQMU-S, DXQMU-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  XADD, XADJ, XPQNU
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XQMU
      DIMENSION PQA(*),IPQA(*)
      REAL DMU,NU,NU1,NU2,PQ,PQA,PQ1,PQ2,SX,X,X1,X2
      REAL THETA
C***FIRST EXECUTABLE STATEMENT  XQMU
      IERROR=0
      MU=0
C
C        CALL XPQNU TO OBTAIN Q(0.,NU1,X)
C
      CALL XPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ2=PQA(1)
      IPQ2=IPQA(1)
      MU=1
C
C        CALL XPQNU TO OBTAIN Q(1.,NU1,X)
C
      CALL XPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      NU=NU1
      K=0
      MU=1
      DMU=1.
      PQ1=PQA(1)
      IPQ1=IPQA(1)
      IF(MU1.GT.0) GO TO 310
      K=K+1
      PQA(K)=PQ2
      IPQA(K)=IPQ2
      IF(MU2.LT.1) GO TO 330
  310 IF(MU1.GT.1) GO TO 320
      K=K+1
      PQA(K)=PQ1
      IPQA(K)=IPQ1
      IF(MU2.LE.1) GO TO 330
  320 CONTINUE
C
C        FORWARD RECURRENCE IN MU TO OBTAIN
C                  Q(MU1,NU,X),Q(MU1+1,NU,X),....,Q(MU2,NU,X) USING
C             Q(MU+1,NU,X)=-2.*MU*X*SQRT(1./(1.-X**2))*Q(MU,NU,X)
C                               -(NU+MU)*(NU-MU+1.)*Q(MU-1,NU,X)
C
      X1=-2.*DMU*X*SX*PQ1
      X2=(NU+DMU)*(NU-DMU+1.)*PQ2
      CALL XADD(X1,IPQ1,-X2,IPQ2,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL XADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ2=PQ1
      IPQ2=IPQ1
      PQ1=PQ
      IPQ1=IPQ
      MU=MU+1
      DMU=DMU+1.
      IF(MU.LT.MU1) GO TO 320
      K=K+1
      PQA(K)=PQ
      IPQA(K)=IPQ
      IF(MU2.GT.MU) GO TO 320
  330 RETURN
      END
*DECK XQNU
      SUBROUTINE XQNU (NU1, NU2, MU1, THETA, X, SX, ID, PQA, IPQA,
     1   IERROR)
C***BEGIN PROLOGUE  XQNU
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for XLEGF.
C            Method: backward nu-wise recurrence for Q(MU,NU,X) for
C            fixed mu to obtain Q(MU1,NU1,X), Q(MU1,NU1+1,X), ...,
C            Q(MU1,NU2,X).
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XQNU-S, DXQNU-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  XADD, XADJ, XPQNU
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XQNU
      DIMENSION PQA(*),IPQA(*)
      REAL DMU,NU,NU1,NU2,PQ,PQA,PQ1,PQ2,SX,X,X1,X2
      REAL THETA,PQL1,PQL2
C***FIRST EXECUTABLE STATEMENT  XQNU
      IERROR=0
      K=0
      PQ2=0.0
      IPQ2=0
      PQL2=0.0
      IPQL2=0
      IF(MU1.EQ.1) GO TO 290
      MU=0
C
C        CALL XPQNU TO OBTAIN Q(0.,NU2,X) AND Q(0.,NU2-1,X)
C
      CALL XPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      IF(MU1.EQ.0) RETURN
      K=(NU2-NU1+1.5)
      PQ2=PQA(K)
      IPQ2=IPQA(K)
      PQL2=PQA(K-1)
      IPQL2=IPQA(K-1)
  290 MU=1
C
C        CALL XPQNU TO OBTAIN Q(1.,NU2,X) AND Q(1.,NU2-1,X)
C
      CALL XPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      IF(MU1.EQ.1) RETURN
      NU=NU2
      PQ1=PQA(K)
      IPQ1=IPQA(K)
      PQL1=PQA(K-1)
      IPQL1=IPQA(K-1)
  300 MU=1
      DMU=1.
  320 CONTINUE
C
C        FORWARD RECURRENCE IN MU TO OBTAIN Q(MU1,NU2,X) AND
C              Q(MU1,NU2-1,X) USING
C              Q(MU+1,NU,X)=-2.*MU*X*SQRT(1./(1.-X**2))*Q(MU,NU,X)
C                   -(NU+MU)*(NU-MU+1.)*Q(MU-1,NU,X)
C
C              FIRST FOR NU=NU2
C
      X1=-2.*DMU*X*SX*PQ1
      X2=(NU+DMU)*(NU-DMU+1.)*PQ2
      CALL XADD(X1,IPQ1,-X2,IPQ2,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL XADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ2=PQ1
      IPQ2=IPQ1
      PQ1=PQ
      IPQ1=IPQ
      MU=MU+1
      DMU=DMU+1.
      IF(MU.LT.MU1) GO TO 320
      PQA(K)=PQ
      IPQA(K)=IPQ
      IF(K.EQ.1) RETURN
      IF(NU.LT.NU2) GO TO 340
C
C              THEN FOR NU=NU2-1
C
      NU=NU-1.
      PQ2=PQL2
      IPQ2=IPQL2
      PQ1=PQL1
      IPQ1=IPQL1
      K=K-1
      GO TO 300
C
C         BACKWARD RECURRENCE IN NU TO OBTAIN
C              Q(MU1,NU1,X),Q(MU1,NU1+1,X),....,Q(MU1,NU2,X)
C              USING
C              (NU-MU+1.)*Q(MU,NU+1,X)=
C                       (2.*NU+1.)*X*Q(MU,NU,X)-(NU+MU)*Q(MU,NU-1,X)
C
  340 PQ1=PQA(K)
      IPQ1=IPQA(K)
      PQ2=PQA(K+1)
      IPQ2=IPQA(K+1)
  350 IF(NU.LE.NU1) RETURN
      K=K-1
      X1=(2.*NU+1.)*X*PQ1/(NU+DMU)
      X2=-(NU-DMU+1.)*PQ2/(NU+DMU)
      CALL XADD(X1,IPQ1,X2,IPQ2,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL XADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ2=PQ1
      IPQ2=IPQ1
      PQ1=PQ
      IPQ1=IPQ
      PQA(K)=PQ
      IPQA(K)=IPQ
      NU=NU-1.
      GO TO 350
      END
*DECK XRED
      SUBROUTINE XRED (X, IX, IERROR)
C***BEGIN PROLOGUE  XRED
C***PURPOSE  To provide single-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      SINGLE PRECISION (XRED-S, DXRED-D)
C***KEYWORDS  EXTENDED-RANGE SINGLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     REAL X
C     INTEGER IX
C
C                  IF
C                  RADIX**(-2L) .LE. (ABS(X),IX) .LE. RADIX**(2L)
C                  THEN XRED TRANSFORMS (X,IX) SO THAT IX=0.
C                  IF (X,IX) IS OUTSIDE THE ABOVE RANGE,
C                  THEN XRED TAKES NO ACTION.
C                  THIS SUBROUTINE IS USEFUL IF THE
C                  RESULTS OF EXTENDED-RANGE CALCULATIONS
C                  ARE TO BE USED IN SUBSEQUENT ORDINARY
C                  SINGLE-PRECISION CALCULATIONS.
C
C***SEE ALSO  XSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    XBLK2
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XRED
      REAL X
      INTEGER IX
      REAL RADIX, RADIXL, RAD2L, DLG10R, XA
      INTEGER L, L2, KMAX
      COMMON /XBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /XBLK2/
C
C***FIRST EXECUTABLE STATEMENT  XRED
      IERROR=0
      IF (X.EQ.0.0) GO TO 90
      XA = ABS(X)
      IF (IX.EQ.0) GO TO 70
      IXA = ABS(IX)
      IXA1 = IXA/L2
      IXA2 = MOD(IXA,L2)
      IF (IX.GT.0) GO TO 40
   10 CONTINUE
      IF (XA.GT.1.0) GO TO 20
      XA = XA*RAD2L
      IXA1 = IXA1 + 1
      GO TO 10
   20 XA = XA/RADIX**IXA2
      IF (IXA1.EQ.0) GO TO 70
      DO 30 I=1,IXA1
        IF (XA.LT.1.0) GO TO 100
        XA = XA/RAD2L
   30 CONTINUE
      GO TO 70
C
   40 CONTINUE
      IF (XA.LT.1.0) GO TO 50
      XA = XA/RAD2L
      IXA1 = IXA1 + 1
      GO TO 40
   50 XA = XA*RADIX**IXA2
      IF (IXA1.EQ.0) GO TO 70
      DO 60 I=1,IXA1
        IF (XA.GT.1.0) GO TO 100
        XA = XA*RAD2L
   60 CONTINUE
   70 IF (XA.GT.RAD2L) GO TO 100
      IF (XA.GT.1.0) GO TO 80
      IF (RAD2L*XA.LT.1.0) GO TO 100
   80 X = SIGN(XA,X)
   90 IX = 0
  100 RETURN
      END
*DECK XSET
      SUBROUTINE XSET (IRAD, NRADPL, DZERO, NBITS, IERROR)
C***BEGIN PROLOGUE  XSET
C***PURPOSE  To provide single-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      SINGLE PRECISION (XSET-S, DXSET-D)
C***KEYWORDS  EXTENDED-RANGE SINGLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C
C   SUBROUTINE  XSET  MUST BE CALLED PRIOR TO CALLING ANY OTHER
C EXTENDED-RANGE SUBROUTINE. IT CALCULATES AND STORES SEVERAL
C MACHINE-DEPENDENT CONSTANTS IN COMMON BLOCKS. THE USER MUST
C SUPPLY FOUR CONSTANTS THAT PERTAIN TO HIS PARTICULAR COMPUTER.
C THE CONSTANTS ARE
C
C          IRAD = THE INTERNAL BASE OF SINGLE-PRECISION
C                 ARITHMETIC IN THE COMPUTER.
C        NRADPL = THE NUMBER OF RADIX PLACES CARRIED IN
C                 THE SINGLE-PRECISION REPRESENTATION.
C         DZERO = THE SMALLEST OF 1/DMIN, DMAX, DMAXLN WHERE
C                 DMIN = THE SMALLEST POSITIVE SINGLE-PRECISION
C                 NUMBER OR AN UPPER BOUND TO THIS NUMBER,
C                 DMAX = THE LARGEST SINGLE-PRECISION NUMBER
C                 OR A LOWER BOUND TO THIS NUMBER,
C                 DMAXLN = THE LARGEST SINGLE-PRECISION NUMBER
C                 SUCH THAT LOG10(DMAXLN) CAN BE COMPUTED BY THE
C                 FORTRAN SYSTEM (ON MOST SYSTEMS DMAXLN = DMAX).
C         NBITS = THE NUMBER OF BITS (EXCLUSIVE OF SIGN) IN
C                 AN INTEGER COMPUTER WORD.
C
C ALTERNATIVELY, ANY OR ALL OF THE CONSTANTS CAN BE GIVEN
C THE VALUE 0 (0.0 FOR DZERO). IF A CONSTANT IS ZERO, XSET TRIES
C TO ASSIGN AN APPROPRIATE VALUE BY CALLING I1MACH
C (SEE P.A.FOX, A.D.HALL, N.L.SCHRYER, ALGORITHM 528 FRAMEWORK
C FOR A PORTABLE LIBRARY, ACM TRANSACTIONS ON MATH SOFTWARE,
C V.4, NO.2, JUNE 1978, 177-188).
C
C   THIS IS THE SETTING-UP SUBROUTINE FOR A PACKAGE OF SUBROUTINES
C THAT FACILITATE THE USE OF EXTENDED-RANGE ARITHMETIC. EXTENDED-RANGE
C ARITHMETIC ON A PARTICULAR COMPUTER IS DEFINED ON THE SET OF NUMBERS
C OF THE FORM
C
C               (X,IX) = X*RADIX**IX
C
C WHERE X IS A SINGLE-PRECISION NUMBER CALLED THE PRINCIPAL PART,
C IX IS AN INTEGER CALLED THE AUXILIARY INDEX, AND RADIX IS THE
C INTERNAL BASE OF THE SINGLE-PRECISION ARITHMETIC.  OBVIOUSLY,
C EACH REAL NUMBER IS REPRESENTABLE WITHOUT ERROR BY MORE THAN ONE
C EXTENDED-RANGE FORM.  CONVERSIONS BETWEEN  DIFFERENT FORMS ARE
C ESSENTIAL IN CARRYING OUT ARITHMETIC OPERATIONS.  WITH THE CHOICE
C OF RADIX WE HAVE MADE, AND THE SUBROUTINES WE HAVE WRITTEN, THESE
C CONVERSIONS ARE PERFORMED WITHOUT ERROR (AT LEAST ON MOST COMPUTERS).
C (SEE SMITH, J.M., OLVER, F.W.J., AND LOZIER, D.W., EXTENDED-RANGE
C ARITHMETIC AND NORMALIZED LEGENDRE POLYNOMIALS, ACM TRANSACTIONS ON
C MATHEMATICAL SOFTWARE, MARCH 1981).
C
C   AN EXTENDED-RANGE NUMBER  (X,IX)  IS SAID TO BE IN ADJUSTED FORM IF
C X AND IX ARE ZERO OR
C
C           RADIX**(-L) .LE. ABS(X) .LT. RADIX**L
C
C IS SATISFIED, WHERE L IS A COMPUTER-DEPENDENT INTEGER DEFINED IN THIS
C SUBROUTINE. TWO EXTENDED-RANGE NUMBERS IN ADJUSTED FORM CAN BE ADDED,
C SUBTRACTED, MULTIPLIED OR DIVIDED (IF THE DIVISOR IS NONZERO) WITHOUT
C CAUSING OVERFLOW OR UNDERFLOW IN THE PRINCIPAL PART OF THE RESULT.
C WITH PROPER USE OF THE EXTENDED-RANGE SUBROUTINES, THE ONLY OVERFLOW
C THAT CAN OCCUR IS INTEGER OVERFLOW IN THE AUXILIARY INDEX. IF THIS
C IS DETECTED, THE SOFTWARE CALLS XERROR (A GENERAL ERROR-HANDLING
C FORTRAN SUBROUTINE PACKAGE).
C
C   MULTIPLICATION AND DIVISION IS PERFORMED BY SETTING
C
C                 (X,IX)*(Y,IY) = (X*Y,IX+IY)
C OR
C                 (X,IX)/(Y,IY) = (X/Y,IX-IY).
C
C PRE-ADJUSTMENT OF THE OPERANDS IS ESSENTIAL TO AVOID
C OVERFLOW OR  UNDERFLOW OF THE PRINCIPAL PART. SUBROUTINE
C XADJ (SEE BELOW) MAY BE CALLED TO TRANSFORM ANY EXTENDED-
C RANGE NUMBER INTO ADJUSTED FORM.
C
C   ADDITION AND SUBTRACTION REQUIRE THE USE OF SUBROUTINE XADD
C (SEE BELOW).  THE INPUT OPERANDS NEED NOT BE IN ADJUSTED FORM.
C HOWEVER, THE RESULT OF ADDITION OR SUBTRACTION IS RETURNED
C IN ADJUSTED FORM.  THUS, FOR EXAMPLE, IF (X,IX),(Y,IY),
C (U,IU),  AND (V,IV) ARE IN ADJUSTED FORM, THEN
C
C                 (X,IX)*(Y,IY) + (U,IU)*(V,IV)
C
C CAN BE COMPUTED AND STORED IN ADJUSTED FORM WITH NO EXPLICIT
C CALLS TO XADJ.
C
C   WHEN AN EXTENDED-RANGE NUMBER IS TO BE PRINTED, IT MUST BE
C CONVERTED TO AN EXTENDED-RANGE FORM WITH DECIMAL RADIX.  SUBROUTINE
C XCON IS PROVIDED FOR THIS PURPOSE.
C
C   THE SUBROUTINES CONTAINED IN THIS PACKAGE ARE
C
C     SUBROUTINE XADD
C USAGE
C                  CALL XADD(X,IX,Y,IY,Z,IZ,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  FORMS THE EXTENDED-RANGE SUM  (Z,IZ) =
C                  (X,IX) + (Y,IY).  (Z,IZ) IS ADJUSTED
C                  BEFORE RETURNING. THE INPUT OPERANDS
C                  NEED NOT BE IN ADJUSTED FORM, BUT THEIR
C                  PRINCIPAL PARTS MUST SATISFY
C                  RADIX**(-2L).LE.ABS(X).LE.RADIX**(2L),
C                  RADIX**(-2L).LE.ABS(Y).LE.RADIX**(2L).
C
C     SUBROUTINE XADJ
C USAGE
C                  CALL XADJ(X,IX,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  TRANSFORMS (X,IX) SO THAT
C                  RADIX**(-L) .LE. ABS(X) .LT. RADIX**L.
C                  ON MOST COMPUTERS THIS TRANSFORMATION DOES
C                  NOT CHANGE THE MANTISSA OF X PROVIDED RADIX IS
C                  THE NUMBER BASE OF SINGLE-PRECISION ARITHMETIC.
C
C     SUBROUTINE XC210
C USAGE
C                  CALL XC210(K,Z,J,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  GIVEN K THIS SUBROUTINE COMPUTES J AND Z
C                  SUCH THAT  RADIX**K = Z*10**J, WHERE Z IS IN
C                  THE RANGE 1/10 .LE. Z .LT. 1.
C                  THE VALUE OF Z WILL BE ACCURATE TO FULL
C                  SINGLE-PRECISION PROVIDED THE NUMBER
C                  OF DECIMAL PLACES IN THE LARGEST
C                  INTEGER PLUS THE NUMBER OF DECIMAL
C                  PLACES CARRIED IN SINGLE-PRECISION DOES NOT
C                  EXCEED 60. XC210 IS CALLED BY SUBROUTINE
C                  XCON WHEN NECESSARY. THE USER SHOULD
C                  NEVER NEED TO CALL XC210 DIRECTLY.
C
C     SUBROUTINE XCON
C USAGE
C                  CALL XCON(X,IX,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  CONVERTS (X,IX) = X*RADIX**IX
C                  TO DECIMAL FORM IN PREPARATION FOR
C                  PRINTING, SO THAT (X,IX) = X*10**IX
C                  WHERE 1/10 .LE. ABS(X) .LT. 1
C                  IS RETURNED, EXCEPT THAT IF
C                  (ABS(X),IX) IS BETWEEN RADIX**(-2L)
C                  AND RADIX**(2L) THEN THE REDUCED
C                  FORM WITH IX = 0 IS RETURNED.
C
C     SUBROUTINE XRED
C USAGE
C                  CALL XRED(X,IX,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  IF
C                  RADIX**(-2L) .LE. (ABS(X),IX) .LE. RADIX**(2L)
C                  THEN XRED TRANSFORMS (X,IX) SO THAT IX=0.
C                  IF (X,IX) IS OUTSIDE THE ABOVE RANGE,
C                  THEN XRED TAKES NO ACTION.
C                  THIS SUBROUTINE IS USEFUL IF THE
C                  RESULTS OF EXTENDED-RANGE CALCULATIONS
C                  ARE TO BE USED IN SUBSEQUENT ORDINARY
C                  SINGLE-PRECISION CALCULATIONS.
C
C***REFERENCES  Smith, Olver and Lozier, Extended-Range Arithmetic and
C                 Normalized Legendre Polynomials, ACM Trans on Math
C                 Softw, v 7, n 1, March 1981, pp 93--105.
C***ROUTINES CALLED  I1MACH, XERMSG
C***COMMON BLOCKS    XBLK1, XBLK2, XBLK3
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  XSET
      INTEGER IRAD, NRADPL, NBITS
      REAL DZERO, DZEROX
      COMMON /XBLK1/ NBITSF
      SAVE /XBLK1/
      REAL RADIX, RADIXL, RAD2L, DLG10R
      INTEGER L, L2, KMAX
      COMMON /XBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /XBLK2/
      INTEGER NLG102, MLG102, LG102
      COMMON /XBLK3/ NLG102, MLG102, LG102(21)
      SAVE /XBLK3/
      INTEGER IFLAG
      SAVE IFLAG
C
      DIMENSION LOG102(20), LGTEMP(20)
      SAVE LOG102
C
C   LOG102 CONTAINS THE FIRST 60 DIGITS OF LOG10(2) FOR USE IN
C CONVERSION OF EXTENDED-RANGE NUMBERS TO BASE 10 .
      DATA LOG102 /301,029,995,663,981,195,213,738,894,724,493,026,768,
     * 189,881,462,108,541,310,428/
C
C FOLLOWING CODING PREVENTS XSET FROM BEING EXECUTED MORE THAN ONCE.
C THIS IS IMPORTANT BECAUSE SOME SUBROUTINES (SUCH AS XNRMP AND
C XLEGF) CALL XSET TO MAKE SURE EXTENDED-RANGE ARITHMETIC HAS
C BEEN INITIALIZED. THE USER MAY WANT TO PRE-EMPT THIS CALL, FOR
C EXAMPLE WHEN I1MACH IS NOT AVAILABLE. SEE CODING BELOW.
      DATA IFLAG /0/
C***FIRST EXECUTABLE STATEMENT  XSET
      IERROR=0
      IF (IFLAG .NE. 0) RETURN
      IRADX = IRAD
      NRDPLC = NRADPL
      DZEROX = DZERO
      IMINEX = 0
      IMAXEX = 0
      NBITSX = NBITS
C FOLLOWING 5 STATEMENTS SHOULD BE DELETED IF I1MACH IS
C NOT AVAILABLE OR NOT CONFIGURED TO RETURN THE CORRECT
C MACHINE-DEPENDENT VALUES.
      IF (IRADX .EQ. 0) IRADX = I1MACH (10)
      IF (NRDPLC .EQ. 0) NRDPLC = I1MACH (11)
      IF (DZEROX .EQ. 0.0) IMINEX = I1MACH (12)
      IF (DZEROX .EQ. 0.0) IMAXEX = I1MACH (13)
      IF (NBITSX .EQ. 0) NBITSX = I1MACH (8)
      IF (IRADX.EQ.2) GO TO 10
      IF (IRADX.EQ.4) GO TO 10
      IF (IRADX.EQ.8) GO TO 10
      IF (IRADX.EQ.16) GO TO 10
      CALL XERMSG ('SLATEC', 'XSET', 'IMPROPER VALUE OF IRAD', 101, 1)
      IERROR=101
      RETURN
   10 CONTINUE
      LOG2R=0
      IF (IRADX.EQ.2) LOG2R = 1
      IF (IRADX.EQ.4) LOG2R = 2
      IF (IRADX.EQ.8) LOG2R = 3
      IF (IRADX.EQ.16) LOG2R = 4
      NBITSF=LOG2R*NRDPLC
      RADIX = IRADX
      DLG10R = LOG10(RADIX)
      IF (DZEROX .NE. 0.0) GO TO 14
      LX = MIN ((1-IMINEX)/2, (IMAXEX-1)/2)
      GO TO 16
   14 LX = 0.5*LOG10(DZEROX)/DLG10R
C RADIX**(2*L) SHOULD NOT OVERFLOW, BUT REDUCE L BY 1 FOR FURTHER
C PROTECTION.
      LX=LX-1
   16 L2 = 2*LX
      IF (LX.GE.4) GO TO 20
      CALL XERMSG ('SLATEC', 'XSET', 'IMPROPER VALUE OF DZERO', 102, 1)
      IERROR=102
      RETURN
   20 L = LX
      RADIXL = RADIX**L
      RAD2L = RADIXL**2
C    IT IS NECESSARY TO RESTRICT NBITS (OR NBITSX) TO BE LESS THAN SOME
C UPPER LIMIT BECAUSE OF BINARY-TO-DECIMAL CONVERSION. SUCH CONVERSION
C IS DONE BY XC210 AND REQUIRES A CONSTANT THAT IS STORED TO SOME FIXED
C PRECISION. THE STORED CONSTANT (LOG102 IN THIS ROUTINE) PROVIDES
C FOR CONVERSIONS ACCURATE TO THE LAST DECIMAL DIGIT WHEN THE INTEGER
C WORD LENGTH DOES NOT EXCEED 63. A LOWER LIMIT OF 15 BITS IS IMPOSED
C BECAUSE THE SOFTWARE IS DESIGNED TO RUN ON COMPUTERS WITH INTEGER WORD
C LENGTH OF AT LEAST 16 BITS.
      IF (15.LE.NBITSX .AND. NBITSX.LE.63) GO TO 30
      CALL XERMSG ('SLATEC', 'XSET', 'IMPROPER VALUE OF NBITS', 103, 1)
      IERROR=103
      RETURN
   30 CONTINUE
      KMAX = 2**(NBITSX-1) - L2
      NB = (NBITSX-1)/2
      MLG102 = 2**NB
      IF (1.LE.NRDPLC*LOG2R .AND. NRDPLC*LOG2R.LE.120) GO TO 40
      CALL XERMSG ('SLATEC', 'XSET', 'IMPROPER VALUE OF NRADPL', 104, 1)
      IERROR=104
      RETURN
   40 CONTINUE
      NLG102 = NRDPLC*LOG2R/NB + 3
      NP1 = NLG102 + 1
C
C   AFTER COMPLETION OF THE FOLLOWING LOOP, IC CONTAINS
C THE INTEGER PART AND LGTEMP CONTAINS THE FRACTIONAL PART
C OF LOG10(IRADX) IN RADIX 1000.
      IC = 0
      DO 50 II=1,20
        I = 21 - II
        IT = LOG2R*LOG102(I) + IC
        IC = IT/1000
        LGTEMP(I) = MOD(IT,1000)
   50 CONTINUE
C
C   AFTER COMPLETION OF THE FOLLOWING LOOP, LG102 CONTAINS
C LOG10(IRADX) IN RADIX MLG102. THE RADIX POINT IS
C BETWEEN LG102(1) AND LG102(2).
      LG102(1) = IC
      DO 80 I=2,NP1
        LG102X = 0
        DO 70 J=1,NB
          IC = 0
          DO 60 KK=1,20
            K = 21 - KK
            IT = 2*LGTEMP(K) + IC
            IC = IT/1000
            LGTEMP(K) = MOD(IT,1000)
   60     CONTINUE
          LG102X = 2*LG102X + IC
   70   CONTINUE
        LG102(I) = LG102X
   80 CONTINUE
C
C CHECK SPECIAL CONDITIONS REQUIRED BY SUBROUTINES...
      IF (NRDPLC.LT.L) GO TO 90
      CALL XERMSG ('SLATEC', 'XSET', 'NRADPL .GE. L', 105, 1)
      IERROR=105
      RETURN
   90 IF (6*L.LE.KMAX) GO TO 100
      CALL XERMSG ('SLATEC', 'XSET', '6*L .GT. KMAX', 106, 1)
      IERROR=106
      RETURN
  100 CONTINUE
      IFLAG = 1
      RETURN
      END
*DECK XSETF
      SUBROUTINE XSETF (KONTRL)
C***BEGIN PROLOGUE  XSETF
C***PURPOSE  Set the error control flag.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3A
C***TYPE      ALL (XSETF-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        XSETF sets the error control flag value to KONTRL.
C        (KONTRL is an input parameter only.)
C        The following table shows how each message is treated,
C        depending on the values of KONTRL and LEVEL.  (See XERMSG
C        for description of LEVEL.)
C
C        If KONTRL is zero or negative, no information other than the
C        message itself (including numeric values, if any) will be
C        printed.  If KONTRL is positive, introductory messages,
C        trace-backs, etc., will be printed in addition to the message.
C
C              ABS(KONTRL)
C        LEVEL        0              1              2
C        value
C          2        fatal          fatal          fatal
C
C          1     not printed      printed         fatal
C
C          0     not printed      printed        printed
C
C         -1     not printed      printed        printed
C                                  only           only
C                                  once           once
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Change call to XERRWV to XERMSG.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XSETF
      CHARACTER *8 XERN1
C***FIRST EXECUTABLE STATEMENT  XSETF
      IF (ABS(KONTRL) .GT. 2) THEN
         WRITE (XERN1, '(I8)') KONTRL
         CALL XERMSG ('SLATEC', 'XSETF',
     *      'INVALID ARGUMENT = ' // XERN1, 1, 2)
         RETURN
      ENDIF
C
      JUNK = J4SAVE(2,KONTRL,.TRUE.)
      RETURN
      END
*DECK XSETUA
      SUBROUTINE XSETUA (IUNITA, N)
C***BEGIN PROLOGUE  XSETUA
C***PURPOSE  Set logical unit numbers (up to 5) to which error
C            messages are to be sent.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3B
C***TYPE      ALL (XSETUA-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        XSETUA may be called to declare a list of up to five
C        logical units, each of which is to receive a copy of
C        each error message processed by this package.
C        The purpose of XSETUA is to allow simultaneous printing
C        of each error message on, say, a main output file,
C        an interactive terminal, and other files such as graphics
C        communication files.
C
C     Description of Parameters
C      --Input--
C        IUNIT - an array of up to five unit numbers.
C                Normally these numbers should all be different
C                (but duplicates are not prohibited.)
C        N     - the number of unit numbers provided in IUNIT
C                must have 1 .LE. N .LE. 5.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Change call to XERRWV to XERMSG.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XSETUA
      DIMENSION IUNITA(5)
      CHARACTER *8 XERN1
C***FIRST EXECUTABLE STATEMENT  XSETUA
C
      IF (N.LT.1 .OR. N.GT.5) THEN
         WRITE (XERN1, '(I8)') N
         CALL XERMSG ('SLATEC', 'XSETUA',
     *      'INVALID NUMBER OF UNITS, N = ' // XERN1, 1, 2)
         RETURN
      ENDIF
C
      DO 10 I=1,N
         INDEX = I+4
         IF (I.EQ.1) INDEX = 3
         JUNK = J4SAVE(INDEX,IUNITA(I),.TRUE.)
   10 CONTINUE
      JUNK = J4SAVE(5,N,.TRUE.)
      RETURN
      END
*DECK XSETUN
      SUBROUTINE XSETUN (IUNIT)
C***BEGIN PROLOGUE  XSETUN
C***PURPOSE  Set output file to which error messages are to be sent.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3B
C***TYPE      ALL (XSETUN-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        XSETUN sets the output file to which error messages are to
C        be sent.  Only one file will be used.  See XSETUA for
C        how to declare more than one file.
C
C     Description of Parameter
C      --Input--
C        IUNIT - an input parameter giving the logical unit number
C                to which error messages are to be sent.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XSETUN
C***FIRST EXECUTABLE STATEMENT  XSETUN
      JUNK = J4SAVE(3,IUNIT,.TRUE.)
      JUNK = J4SAVE(5,1,.TRUE.)
      RETURN
      END

!-----------------------------------------------------------------------
! Support file for PYCLASS extensions, Fortran part
!-----------------------------------------------------------------------
!  Always compile this file, even if Python binding is disabled. This
! avoids different interface files when Python is enabled or not, and
! subsequent troubles when compiling in this 2 modes with the same
! sources.
!-----------------------------------------------------------------------
subroutine pyclass_obsx_val(obs,ival,iunitin,oval,ounitin,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>pyclass_obsx_val
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Convert the input value from input unit to the output unit, for
  ! the current R spectrum in memory. Frequency (signal or image) units
  ! (in and out) assumed to be absolute frequencies.
  !---------------------------------------------------------------------
  type(observation), intent(in)  :: obs      !
  real(kind=8),      intent(in)  :: ival     ! Input value
  character(len=*),  intent(in)  :: iunitin  ! Input unit
  real(kind=8),      intent(out) :: oval     ! Output value
  character(len=*),  intent(in)  :: ounitin  ! Output unit
  logical,           intent(out) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RX_VAL'
  character(len=1) :: iunit,ounit
  real(kind=8) :: cval
  !
  error = .false.
  !
  ! Convert input value to channel value
  iunit = iunitin
  call sic_upper(iunit)
  select case (iunit)
  case ('F')
    call abscissa_sigabs2chan(obs%head,ival,cval)
  case ('I')
    call abscissa_imaabs2chan(obs%head,ival,cval)
  case ('V')
    call abscissa_velo2chan(obs%head,ival,cval)
  case ('C')
    cval = ival
  case default
    call class_message(seve%e,rname,trim(iunit)//' is not a supported unit')
    error = .true.
    return
  end select
  !
  ! Convert channel value to output value
  ounit = ounitin
  call sic_upper(ounit)
  select case (ounit)
  case ('F')
    call abscissa_chan2sigabs(obs%head,cval,oval)
  case ('I')
    call abscissa_chan2imaabs(obs%head,cval,oval)
  case ('V')
    call abscissa_chan2velo(obs%head,cval,oval)
  case ('C')
    oval = cval
  case default
    call class_message(seve%e,rname,trim(iunit)//' is not a supported unit')
    error = .true.
    return
  end select
  !
end subroutine pyclass_obsx_val
!
subroutine pyclass_obsx_minmax(set,obs,unitin,mini,maxi,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>pyclass_obsx_minmax
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Return the X range of the R spectrum
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set     !
  type(observation),   intent(in)  :: obs     !
  character(len=*),    intent(in)  :: unitin  ! Unit for returning values. Blank means current unit
  real(kind=8),        intent(out) :: mini    !
  real(kind=8),        intent(out) :: maxi    !
  logical,             intent(out) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RX_MINMAX'
  character(len=1) :: unit
  real(kind=8) :: vl,vr
  !
  error = .false.
  !
  ! Blank: default to current lower X unit
  if (unitin.eq.' ') then
    unit = set%unitx(1)
  else
    unit = unitin
  endif
  call sic_upper(unit)
  !
  select case (unit)
  case ('F')
    call abscissa_sigabs_left(obs%head,vl)
    call abscissa_sigabs_right(obs%head,vr)
  case ('I')
    call abscissa_imaabs_left(obs%head,vl)
    call abscissa_imaabs_right(obs%head,vr)
  case ('V')
    call abscissa_velo_left(obs%head,vl)
    call abscissa_velo_right(obs%head,vr)
  case ('C')
    vl = .5d0
    vr = dble(obs%head%spe%nchan)+.5d0
  case default
    call class_message(seve%e,rname,trim(unit)//' is not a supported unit')
    error = .true.
    return
  end select
  !
  if (vl.lt.vr) then
    mini = vl
    maxi = vr
  else
    mini = vr
    maxi = vl
  endif
  !
end subroutine pyclass_obsx_minmax
!
subroutine pyclass_plotx_minmax(set,unitin,mini,maxi,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>pyclass_plotx_minmax
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ public
  ! Return the X range of the plot
  ! NB: the subroutine returns actually the SET MODE X range, not
  ! the effective PLOT range (they are the same AFTER the command PLOT).
  ! But the command ANA\DRAW has the same bug-feature, and since the
  ! cursor is used by Weeds to identify lines, we are consistent...
  ! ---
  ! Entry point with a 'class_setup_t' as argument
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set     !
  character(len=*),    intent(in)  :: unitin  ! Unit for returning values. Blank means current unit
  real(kind=8),        intent(out) :: mini    !
  real(kind=8),        intent(out) :: maxi    !
  logical,             intent(out) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PX_MINMAX'
  character(len=1) :: unit
  real(kind=8) :: vl,vr
  !
  error = .false.
  !
  ! Blank: default to current lower X unit
  if (unitin.eq.' ') then
    unit = set%unitx(1)
  else
    unit = unitin
  endif
  call sic_upper(unit)
  !
  select case (unit)
  case ('F')
    vl = gfx1+gfxo
    vr = gfx2+gfxo
  case ('I')
    vl = gix1+gixo
    vr = gix2+gixo
  case ('V')
    vl = gvx1
    vr = gvx2
  case ('C')
    vl = gcx1
    vr = gcx2
  case default
    call class_message(seve%e,rname,trim(unit)//' is not a supported unit')
    error = .true.
    return
  end select
  !
  if (vl.lt.vr) then
    mini = vl
    maxi = vr
  else
    mini = vr
    maxi = vl
  endif
  !
end subroutine pyclass_plotx_minmax

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_init
  use cubeset_buffer
  use cubeset_spatial
  use cubeset_spectral
  use cubeset_messaging
  !
  public :: cubeset_library_init
  private
  !
contains
  !
  subroutine cubeset_library_init(error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='LIBRARY>INIT'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubeset%init('cubeset',error)
    if (error) return
    call userspe%init(error)
    if (error) return
    call userspa%init(error)
    if (error) return
  end subroutine cubeset_library_init
end module cubeset_init
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_time
  use gbl_message
  !
  public :: uv_time_comm
  private
  !
contains
  !
  subroutine uv_time_comm(line,error)
    use phys_const
    use image_def
    use gkernel_interfaces
    use uvmosaic_tool, only: mosaic_sort
    use file_buffers
    use uv_buffers
    use uvmap_buffers, only: uvmap_prog
    !---------------------------------------------------------------------
    ! Time-Average the UV Table (usefull for ALMA data, although
    ! it is more efficient to do that on the original UV table
    ! before reading it).
    !
    ! UV_TIME Time /Weight Wcol
    !
    ! Works on the "current" UV data set: Uses UVS or UVR as needed.
    !---------------------------------------------------------------------
    character(len=*), intent(in)  :: line
    logical,          intent(out) :: error
    !
    logical :: shift,sorted
    integer(4) :: wcol
    integer :: ntime,mtime,first_time,last_time
    integer :: nu,nv,mv
    integer :: first,fstart,fend
    integer :: iv,jv,kv,lv,it,ier,mvisi,maxant
    integer :: ifield,np,nvout,ixoff,iyoff
    integer, allocatable :: voff(:)
    integer, allocatable :: ip(:),ftime(:),ltime(:)
    real(4) :: mytime
    real :: uvmax,uvmin
    real :: rmax,diam
    real(8) :: new(3)
    real(8) :: old_time,t0
    real, pointer :: duv_previous(:,:),duv_next(:,:)
    real, allocatable :: din(:,:)
    real(4), allocatable :: doff(:,:)
    real(8), allocatable :: times(:),ttime(:)
    type (gildas) :: hcuv
    character(len=64) :: mychain
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='UV>TIME>COMM'
    !
    if (uvmap_prog%nfields.ne.0) call map_message(seve%w,rname,'UV data is a Mosaic')
    !
    shift = .false.
    new = 0.d0
    !
    !
    if (.not.sic_present(0,1)) then
       call uvgmax(huv,duv,uvmax,uvmin)
       !
       call sic_get_real('UV_CELL[1]',diam,error)
       if (diam.eq.0) then
          call map_message(seve%e,rname,'UV_CELL[1] is not specified')
          error = .true.
          return
       endif
       mytime = nint(diam/(4*pi*uvmax)*86400)
       write(mychain,*) 'Smoothing to ',mytime
       call map_message(seve%i,rname,mychain)
    else
       call sic_r4(line,0,1,mytime,.true.,error)
       if (error) return
    endif
    !
    wcol = 0
    call sic_i4(line,1,1,wcol,.false.,error)
    if (error) return
    !
    ! The UV table is available in HUV%
    if (huv%loca%size.eq.0) then
       call map_message(seve%e,rname,'No UV data loaded')
       error = .true.
       return
    endif
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    !
    if (uvmap_prog%nfields.eq.0) then
       ! Read the Time Baseline information, and verify it is sorted
       allocate (times(nv), ip(nv), stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
       endif
       !
       t0 = duv(4,1) ! First date
       maxant = 0
       do iv = 1, nv
          times(iv) = (duv(4,iv)-t0)*86400.d0+duv(5,iv)-duv(5,1)
          rmax = max(duv(6,iv),duv(7,iv))
          maxant = max(maxant,nint(rmax))
       enddo
       !
       ! So here is the maximum number of visibilities per time range
       mvisi = (maxant*(maxant-1))/2
       !
       ! Sort the time array
       call gr8_trie(times,ip,nv,error)
       !
       ! Figure out how many output times
       old_time = -1d10
       ntime = 0
       do iv = 1, nv
          if ((times(iv)-old_time).ge.mytime) then
             old_time = times(iv)
             ntime = ntime+1
          endif
       enddo
       mtime = ntime
       !
       allocate (ttime(mtime), ftime(mtime), ltime(mtime), stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
       endif
       !
       ! Find out the time boundaries
       jv = 0
       ntime = 0
       old_time = -1d10
       do iv = 1, nv
          if ((times(iv)-old_time).ge.mytime) then
             if (ntime.gt.0) ltime(ntime) = iv-1
             old_time = times(iv)
             ntime = ntime+1
             ftime(ntime) = iv
             ttime(ntime) = times(iv)
          endif
       enddo
       ltime(ntime) = nv   ! The last is a time change
       !
       ! Prepare header and allocate buffers
       call gildas_null(hcuv,type='UVT')
       call gdf_copy_header(huv,hcuv,error)
       mvisi = ntime*mvisi     
       hcuv%gil%dim(2) = mvisi
       hcuv%gil%nvisi = mvisi     ! For the time being...
       nullify (duv_previous, duv_next)
       call uv_find_buffers (rname,nu,mvisi,duv_previous,duv_next,error)
       if (error) return
       !
       ! Setup the Weight column
       if (wcol.eq.0) wcol = max(3,huv%gil%nchan)/3
       !
       ! Now do the job
       old_time = ttime(1)
       jv = 1  ! Initialize here
       do it=1,ntime
          !
          first_time = ftime(it)
          last_time = ltime(it)
          ! Some useless debugging...
          !write(mess,*) 'Time ',old_time,' range ',first_time,last_time, ' / ',nv
          !call map_message(seve%i,rname,mess)
          mv = last_time-first_time+1
          allocate (din(nu,mv),stat=ier)
          if (ier.ne.0) then
             call map_message(seve%e,rname,'Memory allocation error')
             error = .true.
             return
          endif
          kv = 0
          do lv = first_time,last_time
             kv = kv+1
             din(:,kv) = duv(:,ip(lv))
          enddo
          if (mv.ne.kv) print *,'Missing antennas on time ',it,kv,mv
          kv = jv
          call time_compress(din,nu,1,mv, &
               wcol, hcuv, duv_next, jv, mvisi, error)
          if (error) then
             write(mess,*) 'Programming error or strange UV table ',jv,' > ',mvisi
             call map_message(seve%e,rname,mess)
             return
          endif
          if (jv.lt.kv) then
             write(mess,*) 'No valid averaged visibility for ',old_time
             call map_message(seve%w,rname,mess)
          endif
          jv = jv+1     ! Point to next one, then...
          old_time = ttime(it)
          deallocate (din)
       enddo
       !
       ! Finalize the UV Table with the right numbers
       hcuv%gil%dim(2)= jv-1 ! Is this allowed ?...
       hcuv%gil%nvisi = jv-1
    else
       ! Make sure the UV table has been sorted by fields first
       call map_message(seve%w,rname,'Sorting mosaic UV table')
       ixoff = huv%gil%column_pointer(code_uvt_xoff)
       iyoff = huv%gil%column_pointer(code_uvt_yoff)
       if (ixoff.eq.0) then
          ixoff = uvi%head%gil%column_pointer(code_uvt_loff)
          iyoff = uvi%head%gil%column_pointer(code_uvt_moff)
       endif
       call mosaic_sort(error,sorted,shift,new,uvmax,uvmin, &
            ixoff,iyoff,np,doff,voff)
       if (error) return
       !
       ! Prepare header and allocate buffers
       call gildas_null(hcuv,type='UVT')
       call gdf_copy_header(huv,hcuv,error)
       nullify (duv_previous, duv_next)
       call uv_find_buffers (rname,nu,nv,duv_previous,duv_next,error)
       if (error) return
       !
       if (wcol.eq.0) wcol = max(3,huv%gil%nchan)/3
       !
       ! Loop over fields to sort each data
       first = 1
       ! This loop cannot be parallelized ...
       do ifield = 1,np
          !
          fstart = voff(ifield)       ! Starting Visibility of field
          fend   = voff(ifield+1)-1   ! Ending Visibility of field
          !
          call time_integrate(rname,huv,mytime,wcol,nu,fend-fstart+1, &
               & duv(:,fstart:fend),duv_next(:,first:),nvout,error)
          if (error) return
          print *,'Field ',ifield,nvout, ' Visibilities from range ',fstart,fend
          first = first+nvout
       enddo
       !
       hcuv%gil%dim(2)= first-1 ! Is this allowed ?...
       hcuv%gil%nvisi = first-1
    endif
    !
    write(mess,'(i12,a,i12,a)') hcuv%gil%nvisi,' Visibilities created (', &
         & huv%gil%nvisi,' before)'
    call map_message(seve%i,rname,mess)
    call uv_clean_buffers (duv_previous, duv_next,error)
    if (error) return
    !
    ! Copy back to UV data set
    call gdf_copy_header(hcuv,huv,error)
    !
    ! Indicate Weights have changed, optimization and save status
    do_weig = .true.
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
    ! Redefine SIC variables (mandatory)
    call sic_delvariable ('UV',.false.,error)
    call sic_mapgildas ('UV',huv,error,duv)
  end subroutine uv_time_comm
  !
  subroutine time_compress(invisi,nd,first,last,wcol,out,ovisi,jv,mvisi,error)
    use gildas_def
    use image_def
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Time compress a UV table
    ! Compute visibilities for a single output time
    !---------------------------------------------------------------------
    type(gildas), intent(in) :: out
    integer,      intent(in) :: nd             ! Visibility size
    real,         intent(in) :: invisi(:,:)    ! Input visibilities
    integer,      intent(in) :: wcol           ! Weight column
    real,         intent(inout) :: ovisi(:,:)  ! Output visibilities
    integer,      intent(in) :: first, last    ! First and last input visibilities
    integer,      intent(inout) :: jv          ! Current output visibility number
    integer,      intent(in) :: mvisi
    logical,      intent(inout) :: error
    !
    real, allocatable, target :: avisi(:,:), bvisi(:,:)
    real, pointer :: my_visi(:,:)
    integer, allocatable :: tb(:), indx(:)
    integer :: vmax, iant, jant
    integer :: iv, kv, nvisi, ier, icol, ic
    logical :: sorted
    real :: sw
    character(len=*), parameter :: rname='TIME_COMPRESS'
    !
    ! Extract the relevant - A copy is needed in all cases...
    nvisi = last-first+1
    allocate (avisi(nd,nvisi),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error')
       error = .true.
       return
    endif
    avisi(1:nd,1:nvisi) = invisi(:,first:last)
    !
    ! Sort it by BASELINE.
    ! We do not care about time here, since we are time averaging
    !
    ! Check the order
    allocate (tb(nvisi),stat=ier)
    do iv=1,nvisi
       ! Use the baseline number code as major driver
       if (avisi(7,iv).lt.avisi(6,iv)) then
          tb(iv) = (256*avisi(6,iv)+avisi(7,iv))
       else if (avisi(7,iv).gt.avisi(6,iv)) then
          tb(iv) = (256*avisi(7,iv)+avisi(6,iv))
       else
          ! No Baseline code for Short spacings which have Iant = Jant
          tb(iv) = 0
       endif
    enddo
    sorted = .true.
    vmax = tb(1)
    do iv = 1,nvisi
       if (tb(iv).lt.vmax) then
          sorted = .false.
          exit
       endif
       vmax = tb(iv)
    enddo
    !
    ! Sort it if needed
    if (.not.sorted) then
       allocate(indx(nvisi),bvisi(nd,nvisi),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
       endif
       do iv = 1,nvisi
          indx(iv) = iv
       enddo
       call gi4_trie(tb,indx,nvisi,error)
       if (error) then
          call map_message(seve%e,rname,'Sorting error')
          return
       endif
       do iv=1,nvisi
          kv = indx(iv)
          bvisi(:,iv) = avisi(:,kv)
       enddo
       my_visi => bvisi
    else
       my_visi => avisi
    endif
    !
    ! Now do the real work for each baseline
    icol = out%gil%nlead+out%gil%natom*wcol
    !
    kv = jv ! Output visibility pointer
    ovisi(:,jv) = 0      ! Current visibility
    sw = 0.0             ! Current running weight
    iant = my_visi(6,1)  ! First antenna
    jant = my_visi(7,1)  ! Last antenna
    do iv=1,nvisi
       if (iant.eq.my_visi(6,iv) .and. jant.eq.my_visi(7,iv)) then
          ! Same antennas... Continue adding 
          ! ... unless it is a Short spacing stuff...
          if (iant.eq.-1 .and. sw.ne.0.0) then
             call mean_visiw(out,ovisi(:,kv),sw)
             kv = kv+1
             if (kv.gt.mvisi) then  ! Test for overflow (normally none...)
                print *,'MVISI ',mvisi,' First ',first, ' Overflow ...'
                print *,'KV ',kv, ' -- Visi ',iv+first-1,' changing from ',iant,jant, &
                     & ' to ',my_visi(6,iv),my_visi(7,iv)
                error = .true.
                return
             endif
          endif
       else if (iant.eq.my_visi(7,iv) .and. jant.eq.my_visi(6,iv)) then
          ! Same antennas, but reversed order...
          !
          ! We take care of reversed visibilities, which could happen
          ! when V is close to zero, and the UV table has been already
          ! sorted. This can be done by changing the Imaginary part of
          ! my_visi as well as u,v (and w in principle...)
          ! print *,iv,' Reversed ',my_visi(1:7,iv)
          my_visi(1,iv) = -my_visi(1,iv)
          my_visi(2,iv) = -my_visi(2,iv)
          my_visi(6,iv) = iant
          my_visi(7,iv) = jant
          do ic=out%gil%fcol+1,out%gil%lcol,3
             my_visi(ic,iv) = -my_visi(ic,iv)
          enddo
       else
          !!     print *,'KV ',kv, ' -- Visi ',iv,' changing from ',iant,jant, &
          !!     & ' to ',my_visi(6,iv),my_visi(7,iv)
          if (sw.ne.0.0) then
             call mean_visiw(out,ovisi(:,kv),sw)
             kv = kv+1
             if (kv.gt.mvisi) then
                print *,'MVISI ',mvisi,' First ',first
                print *,'KV ',kv, ' -- Visi ',iv+first-1,' changing from ',iant,jant, &
                     & ' to ',my_visi(6,iv),my_visi(7,iv)
                error = .true.
                return
             endif
             ovisi(:,kv) = 0.0
          endif
          iant = my_visi(6,iv)
          jant = my_visi(7,iv)
          sw = 0.0
       endif
       !
       ! Once done, Add to Current visibility - 
       ! For the first one, it simply copies it to the output place
       call add_visiw(out,ovisi(:,kv),my_visi(icol,iv),my_visi(:,iv),sw)
    enddo
    !
    if (sw.ne.0.0) then
       jv = kv
       call mean_visiw(out,ovisi(:,kv),sw)
    else
       jv = kv-1
    endif
  end subroutine time_compress
  !
  subroutine add_visiw(out,ovisi,aw,avisi,sw)
    use image_def
    !---------------------------------------------------------------------
    ! Add a visibility to current output one
    !---------------------------------------------------------------------
    type(gildas), intent(in)    :: out      ! Input image header
    real,         intent(inout) :: ovisi(:) ! Output visibilities
    real,         intent(in)    :: aw       ! Input weight
    real,         intent(inout) :: avisi(:) ! Input visibilities
    real,         intent(inout) :: sw       ! Output weight
    !
    integer i
    real :: uv2
    real :: uv2max=12.0**2
    !
    if (aw.le.0) return
    !
    ! This is a patch for old files which have been incorrectly
    ! sorted, without the antennas being swapped...
    if (sw.gt.0) then
       uv2 = (ovisi(1)/sw-avisi(1))**2 + (ovisi(2)/sw-avisi(2))**2
       if (uv2.gt.uv2max) then
          if (ovisi(1)*avisi(1).lt.0) then
             print *,'Continuity problem',sqrt(uv2), &
                  & '(Bad Antenna order ?), Patching data'
             print *,ovisi(1:2)/sw,avisi(1:2)
             avisi(1) = -avisi(1)
             avisi(2) = -avisi(2)
             do i = out%gil%nlead+2,out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
                avisi(i) = -avisi(i)
             enddo
          endif
       endif
    endif
    !
    ovisi(1:3) = ovisi(1:3)+aw*avisi(1:3)
    ovisi(4:out%gil%nlead) = avisi(4:out%gil%nlead)
    do i = out%gil%nlead+1,out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
       ovisi(i) = ovisi(i) + aw*avisi(i)
       ovisi(i+1) = ovisi(i+1) + aw*avisi(i+1)
       ovisi(i+2) = ovisi(i+2) + avisi(i+2)   ! Sum the weights
    enddo
    do i=out%gil%lcol+1,out%gil%dim(1)
       ovisi(i) = avisi(i)
    enddo
    sw = sw+aw
  end subroutine add_visiw
  !
  subroutine mean_visiw(out,ovisi,sw)
    use image_def
    !---------------------------------------------------------------------
    ! Normalize the final visibility
    !---------------------------------------------------------------------
    type(gildas), intent(in)    :: out      ! Input image header
    real,         intent(inout) :: ovisi(:) ! Output visibilities
    real,         intent(inout) :: sw       ! Output weight
    !
    integer i
    !
    if (sw.le.0) return
    !
    ovisi(1:3) = ovisi(1:3)/sw
    do i = out%gil%nlead+1,out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
       ovisi(i) = ovisi(i)/sw
       ovisi(i+1) = ovisi(i+1)/sw
    enddo
  end subroutine mean_visiw
  !
  subroutine time_integrate(rname,huv,mytime,wcol,nu,nv,vin,vout,nvout,error)
    use image_def
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Time-Average a UV data set
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: rname     ! Calling routine
    type(gildas),     intent(in)    :: huv       ! UV Header
    real(4),          intent(in)    :: mytime    ! Integration time
    integer,          intent(in)    :: wcol      ! Weight column
    integer,          intent(in)    :: nu        ! Size of a visibility
    integer,          intent(in)    :: nv        ! Number of input visibilities
    real,             intent(in)    :: vin(:,:)  ! input visibilities
    real,             intent(inout) :: vout(:,:) ! output visibilities
    integer,          intent(out)   :: nvout     ! Number of output visibilities
    logical,          intent(inout) :: error     ! Error flag
    !
    real(8), allocatable :: times(:), ttime(:)
    integer, allocatable :: ip(:), ftime(:), ltime(:)
    real, allocatable :: din(:,:)
    integer :: ier, ntime, mtime
    real(8) :: t0, old_time
    integer :: first_time, last_time
    integer :: it,iv,jv,kv,lv,mv
    integer :: mvisi
    character(len=80) :: mess
    !
    ! Read the Time Baseline information, and verify it is sorted
    allocate (times(nv), ip(nv), stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error')
       error = .true.
       return
    endif
    mvisi = ubound(vout,2)
    !
    t0 = vin(4,1) ! First date
    do iv = 1, nv
       times(iv) = (vin(4,iv)-t0)*86400.d0+vin(5,iv)-vin(5,1)
    enddo
    !
    ! Sort the time array
    call gr8_trie(times,ip,nv,error)
    !
    ! Figure out how many output times
    old_time = -1d10
    ntime = 0
    do iv = 1, nv
       if ((times(iv)-old_time).ge.mytime) then
          old_time = times(iv)
          ntime = ntime+1
       endif
    enddo
    mtime = ntime
    !
    allocate (ttime(mtime), ftime(mtime), ltime(mtime), stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error')
       error = .true.
       return
    endif
    !
    ! Find out the time boundaries
    jv = 0
    ntime = 0
    old_time = -1d10
    do iv = 1, nv
       if ((times(iv)-old_time).ge.mytime) then
          if (ntime.gt.0) ltime(ntime) = iv-1
          old_time = times(iv)
          ntime = ntime+1
          ftime(ntime) = iv
          ttime(ntime) = times(iv)
       endif
    enddo
    ltime(ntime) = nv   ! The last is a time change
    !
    ! Now do the job
    old_time = ttime(1)
    jv = 1  ! Initialize here
    do it=1,ntime
       !
       first_time = ftime(it)
       last_time = ltime(it)
       ! Some useless debugging...
       !!print *,'Time ',old_time,' range ',first_time,last_time, ' / ',nv
       mv = last_time-first_time+1
       allocate (din(nu,mv),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
       endif
       kv = 0
       do lv = first_time,last_time
          kv = kv+1
          din(:,kv) = vin(:,ip(lv))
       enddo
       if (mv.ne.kv) print *,'Missing antennas on time ',it,kv,mv
       kv = jv
       call time_compress(din,nu,1,mv, wcol, huv, vout, jv, mvisi, error)
       if (error) then
          write(mess,*) 'Programming error or strange UV table ',jv,' > ',mvisi
          call map_message(seve%e,rname,mess)
          return
       endif
       if (jv.lt.kv) then
          write(mess,*) 'No valid averaged visibility for ',old_time
          call map_message(seve%w,rname,mess)
       endif
       jv = jv+1     ! Point to next one, then...
       old_time = ttime(it)
       deallocate (din)
    enddo
    nvout = jv-1
  end subroutine time_integrate
end module uv_time
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!;

module imbfits_dependencies_interfaces
  use gkernel_interfaces
  use class_interfaces_public
end module imbfits_dependencies_interfaces
!
module imbfits_interfaces
  use imbfits_interfaces_private
  use imbfits_interfaces_public
end module imbfits_interfaces

subroutine vel_scale_2 (name,freq)
  use classic_api
  !---------------------------------------------------------------------
  ! Updates frequencies in header according to last 'SET FREQUENCY' command
  !---------------------------------------------------------------------
  character(len=*) :: name          !
  real*8 :: freq                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! Local
  integer :: isb, sky(2), isub 
  real*8 :: c
  parameter (c=299792.458d0)
  !
  data sky/+1,-1/              ! Usb, Lsb
  !------------------------------------------------------------------------
  ! Code:
  ! Defaults from Input Header:
  if (name.eq.'*') then
    name = r_line
  endif
  if (freq.eq.0) then
    freq = r_restf
  endif
  ! Loop on sidebands
  do isb = 1, 2
    !
    ! Continuum
    r_crfoff(isb) = freq
    r_cnam(isb) = name
    !
    ! Line
    do isub=1, r_lband
      r_lrfoff(isb,isub) = freq
      r_lnam(isb,isub) = name
    enddo
  enddo
  call vel_scale
  return
  !
end subroutine vel_scale_2
!
subroutine interpolate_2(x,xdim,xinc,xref,xval,w,   &
    y,ydim,yinc,yref,yval)
  !---------------------------------------------------------------------
  ! LAS	Internal routine
  !	Performs the linear interpolation/integration
  !
  ! 1) if actual interpolation (XINC <= YINC)
  !     this is a 2-point linear interpolation formula.
  !     the data is untouched if the resolution is unchanged and the shift
  !     is an integer number of channels.
  !
  ! 2) if not (XINC > YINC)
  !     boxcar convolution (width xinc-yinc) followed by linear interpolation
  !
  ! Arguments:
  !	X	R*4(*)	Output spectrum
  !	XDIM	I*4	Output pixel number
  !	XINC	R*8	Output first axis increment
  !	XREF	R*4	Output first axis reference pixel
  !	XVAL	R*4	Output first axis value at reference pixel
  ! 	Y	R*4(*)	Input spectrum
  !---------------------------------------------------------------------
  integer :: xdim                   !
  complex :: x(xdim)                !
  real*8 :: xinc                    !
  real :: xref                      !
  real*8 :: xval                    !
  real :: w(xdim)                   !
  integer :: ydim                   !
  complex :: y(ydim)                !
  real :: yinc                      !
  real :: yref                      !
  real*8 :: yval                    !
  ! Local
  integer :: i,imax,imin, j
  real*8 :: pix, val, expand
  real :: scale, ww
  !-----------------------------------------------------------------------
  !
  expand = abs(xinc/yinc)
  do i = 1, xdim
    !
    ! Compute interval
    val = xval + (i-xref)*xinc
    pix = (val-yval)/yinc + yref
    if (expand.gt.1.) then
      imin = int(pix-expand/2d0+0.5d0)
      imax = int(pix+expand/2d0+0.5d0)
      ! This initial test was stupid.... It rejected ANY channel which did not match
      ! the exact final sampling...
      !      IF ((MIN(IMIN,IMAX).LT.1).OR.(MAX(IMIN,IMAX).GT.YDIM)) THEN
      !      Print *,'Rejecting ',imin,imax,ydim
      !         W(I) = 0
      !         X(I) = 0
      ! We are here ADDING channels together to produce wider ones.
      ! Edge channels must be accounted for with their weight corresponding to the
      ! fraction of the final channel width covered by the initial sampling.
      !
      ! The band stitching will then be done properly in FILL_VISI, since this
      ! contribution  is added to the final visibility
      if (imin.lt.1) then
        imin = 1
        ww = 1.0               ! The whole channel is in...
      else
        ww = imin-(pix-expand/2d0-0.5d0)
      endif
      x(i) = y(imin)*ww
      scale = ww
      !
      if (imax.gt.ydim) then
        imax = ydim
        ww = 1.0
      else
        ww = pix+expand/2d0+0.5d0-imax
      endif
      x(i) = x(i) + y(imax)*ww
      scale = scale + ww
      !
      do j=imin+1, imax-1
        x(i) = x(i) + y(j)
        scale = scale+1.
      enddo
      ! Normalize
      w(i) = scale/expand      ! This is the fraction of channel covered
      x(i) = x(i)/scale
    else
      imin = int(pix)
      imax = imin+1
      if ((imin.lt.1).or.(imax.gt.ydim)) then
        w(i) = 0
        x(i) = 0
      else
        w(i) = 1
        x(i) = y(imin)*(imin+1-pix) + y(imin+1)*(pix-imin)
      endif
    endif
  enddo
end subroutine interpolate_2
!
subroutine fft_interpolate(x,xdim,xinc,xref,xval,xwid,xshape,   &
    w,y,ydim,yinc,yref,yval,ywid,yshape,error)
  use gildas_def
  use gkernel_interfaces, no_interface=>fourt
  !---------------------------------------------------------------------
  ! CLIC	Internal routine
  ! (from CLASS, but complex input/ouput)
  !	Performs the  interpolation/integration, using FFT.
  ! Arguments:
  !	X	C*8(*)	Output spectrum
  !	XDIM	I*4	Output pixel number
  !	XINC	R*8	Output first axis increment
  !	XREF	R*4	Output first axis reference pixel
  !	XVAL	R*4	Output first axis value at reference pixel
  !	XWID	R*4	Output channel width, in terms of channel separation.
  !           (e.g. oversampling parameter)
  !	XSHAPE  C*      Channel shape (TBox, TParabola, FBox, Ftriangle)
  !           TBox means a box in delay space (unsmoothed correlator, w=1)
  !           Ppar means a parabola in delay space (smoothed "      , w=1)
  !           FBox means a box in frequency space (square filter,     w=0.5)
  !           FTri means a triangle in frequency space
  !                       (Hanning smoothed square filter,            w=1)
  ! 	Y	C*8(*)	Input spectrum, same parameters ...
  !---------------------------------------------------------------------
  integer :: xdim                   !
  complex :: x(xdim)                !
  real*8 :: xinc                    !
  real :: xref                      !
  real*8 :: xval                    !
  real :: xwid                      !
  character(len=*) :: xshape        !
  real :: w(xdim)                   !
  integer :: ydim                   !
  complex :: y(ydim)                !
  real :: yinc                      !
  real :: yref                      !
  real*8 :: yval                    !
  real :: ywid                      !
  character(len=*) :: yshape        !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: addr, yp, wp
  integer :: i, nstep, nx, noff, p
  real :: step, off, oxinc
  real*8 :: vx, y1
  !-----------------------------------------------------------------------------
  !
  ! Steps in  FFT space are 1/(ydim*yinc)=step
  step = 1d0/(ydim*yinc)
  nx = nint(1d0/step/xinc)
  nx = abs(nx)
  call pfactor(nx,p)
  do while (p.gt.100)
    nx = nx+1
    call pfactor(nx,p)
  enddo
  if (xinc.ne.1d0/step/nx) then
    oxinc = xinc
    xinc = sign(1d0/step/nx,xinc)
  endif
  nstep = max(nx,2*ydim)
  !
  ! Do FFT of input spectrum:
  error = (sic_getvm(4*nstep, addr).ne.1)
  if (error) return
  yp = gag_pointer(addr,memory)
  wp = yp + 2*nstep
  call r4tor4(y,memory(yp),2*ydim)
  if (yinc*xinc.lt.0d0) then
    call reverse(ydim,memory(yp))
    y1 = yval+(ydim-yref)*yinc
  else
    y1 = yval+(1-yref)*yinc
  endif
  call fourt(memory(yp),ydim,1,1,1,memory(wp))
  call fft_factor(ydim,memory(yp),1./ydim)
  !
  ! Deconvolve from input channel shape
  call fft_deconv(ydim,memory(yp),ywid,yshape)
  if (nstep.gt.ydim) then
    call  fft_extend(memory(yp),ydim,nstep)
  endif
  !
  ! Convolve to output channel shape
  if (nx.lt.nstep) then
    call fft_cutoff(memory(yp),nstep,nx)
  endif
  call fft_reconv(nx,memory(yp),xwid,xshape)
  !
  ! Correct for channel offset
  vx = (y1-xval)/xinc+xref-1
  vx = -vx
  noff = nint(vx)
  off = vx-noff
  call fft_offset(nx,memory(yp),-off)
  !
  ! FFT to output spectrum:
  call fourt(memory(yp),nx,1,-1,1,memory(wp))
  do i=1, xdim
    w(i) = 1
  enddo
  if (noff.lt.0) then
    call r4tor4(memory(yp),x(1-noff),2*(xdim+noff))
    do i=1, -noff
      w(i) = 0
    enddo
  elseif  (noff.gt.0) then
    call r4tor4(memory(yp+2*noff),x,2*(xdim-noff))
    do i=1, noff
      w(xdim-i+1) = 0
    enddo
  else
    call r4tor4(memory(yp),x,2*xdim)
  endif
  call free_vm(4*nstep, addr)
end subroutine fft_interpolate
!
subroutine reverse(n,r)
  !---------------------------------------------------------------------
  ! Reverses complex array R
  !---------------------------------------------------------------------
  integer :: n                      !
  complex :: r(n)                   !
  ! Local
  integer :: i
  complex :: temp
  !-----------------------------------------------------------------------
  do i=1, n/2
    temp = r(i)
    r(i) = r(n-i+1)
    r(n-i+1) = temp
  enddo
end subroutine reverse
!
subroutine fft_offset(n,z,x)
  !---------------------------------------------------------------------
  ! offset by x channels
  !---------------------------------------------------------------------
  integer :: n                      !
  complex :: z(n)                   !
  real :: x                         !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  integer :: i, n2
  complex :: f, fn
  real ::  arg
  !-----------------------------------------------------------------------
  !
  arg = 2*pi/n*x
  n2 = n/2
  f = cmplx(cos(arg),sin(arg))
  fn = cmplx(1.,0.)
  do i = 2, n2
    fn = fn*f
    z(i) = z(i)*fn
    z(n-i+2)=z(n-i+2)/fn
  !         Z(N-I+1)=Z(N-I+1)/FN
  enddo
  fn = fn*f
  z(n2+1) = z(n2+1)*fn
  if (2*n2.lt.n) z(n2+2) = z(n2+2)/fn
end subroutine fft_offset
!
subroutine fft_factor(n,z,x)
  !---------------------------------------------------------------------
  ! Multiply Z complex array by X
  !---------------------------------------------------------------------
  integer :: n                      !
  complex :: z(n)                   !
  real :: x                         !
  ! Local
  !-----------------------------------------------------------------------
  integer :: i
  do i = 1, n
    z(i) = z(i)*x
  enddo
end subroutine fft_factor
!
subroutine fft_reconv(n,y,w,shape)
  !---------------------------------------------------------------------
  ! Reconvolution according to shape
  ! 'TB'    Time Box
  ! 'TP'    Time Parabola
  ! 'FB'    Frequency Box
  ! 'FT'    Frequency Triangle
  !---------------------------------------------------------------------
  integer :: n                      !
  complex :: y(n)                   !
  real :: w                         !
  character(len=*) :: shape         !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  integer :: nmax, i, j
  real :: tmax, a, arg, fac
  !--------------------------------------------------------------------
  ! W = width (in terms of channel separation)
  tmax = n/w/2
  nmax = tmax
  a = 1./tmax**2
  arg = pi/tmax/2
  do j=1, n
    i = mod(j-1+n/2,n)-n/2
    ! Raw Correlator channels (no smoothing, sin(pi f/w)/(pi x/w),
    !  w is the first zero, measured in channel spacings.)
    if (shape(1:2).eq.'TB') then
      if (abs(i).ge.tmax) then
        y(j) = 0
      endif
    ! Smoothed correlator channels (parabolic smoothing function)
    elseif (shape(1:2).eq.'TP') then
      if (abs(i).ge.tmax) then
        y(j) = 0
      else
        y(j) = y(j)*(1.-a*i**2)
      endif
    ! Frequency Box of width = w * channel-spacing
    elseif (shape(1:2).eq.'FB') then
      fac = arg*i
      if (fac.ne.0) y(j) = y(j)*sin(fac)/fac
    ! Frequency Triangle of full-width = 2w * channel-spacing
    elseif (shape(1:2).eq.'FT') then
      fac = arg*i
      if (fac.ne.0) y(j) = y(j)*(sin(fac)/fac)**2
    endif
  enddo
end subroutine fft_reconv
!
subroutine fft_deconv(n,y,w,shape)
  !---------------------------------------------------------------------
  ! Deconvolution according to shape
  ! 'TB'    Time Box
  ! 'TP'    Time Parabola
  ! 'FB'    Frequency Box
  ! 'FT'    Frequency Triangle
  !---------------------------------------------------------------------
  integer :: n                      !
  complex :: y(n)                   !
  real :: w                         !
  character(len=*) :: shape         !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  !-----------------------------------------------------------------------
  integer :: nmax, i, j
  real :: tmax, a, arg, fac, sfac
  !--------------------------------------------------------------------
  ! W = width (in terms of channel separation)
  tmax = n/w/2
  nmax = tmax
  a = 1./tmax**2
  arg = pi/tmax/2
  do j=1, n
    i = mod(j-1+n/2,n)-n/2
    ! Raw Correlator channels (no smoothing, sin(pi f/w)/(pi x/w),
    !  w is the first zero, measured in channel spacings.)
    ! nothing to do ...
    if (shape(1:2).eq.'TB') then
      return
    ! Smoothed correlator channels (parabolic smoothing function)
    elseif (shape(1:2).eq.'TP') then
      if (abs(i).lt.tmax) then
        y(j) = y(j)/(1.-a*i**2)
      endif
    ! Frequency Box of half-width = w * channel-spacing
    elseif (shape(1:2).eq.'FB') then
      fac = arg*i
      sfac = sin(fac)
      if (sfac.ne.0) y(j) = y(j)/(sfac/fac)
    ! Frequency Triangle of half-full-width = 2w * channel-spacing
    elseif (shape(1:2).eq.'FT') then
      fac = arg*i
      sfac = sin(fac)
      if (sfac.ne.0) y(j) = y(j)/(sfac/fac)**2
    endif
  enddo
end subroutine fft_deconv
!
subroutine fft_extend(c,n,m)
  !---------------------------------------------------------------------
  ! complete FFT with zeroes in high frequencies
  !---------------------------------------------------------------------
  integer :: m                      !
  complex :: c(m)                   !
  integer :: n                      !
  ! Local
  integer :: i, n2
  !-----------------------------------------------------------------------
  n2 = n/2
  do i=1, n2
    c(m-i+1) = c(n-i+1)
  enddo
  if (n.gt.2*n2) then
    c(m-n2)= c(n-n2)
  else
    c(m-n2)= 0
  endif
  do i=n2+1, m-n2-1
    c(i) = 0
  enddo
end subroutine fft_extend
!
subroutine fft_cutoff(c,m,n)
  !---------------------------------------------------------------------
  ! cutoff FFT in high frequencies
  !---------------------------------------------------------------------
  integer :: m                      !
  complex :: c(m)                   !
  integer :: n                      !
  ! Local
  integer :: i, n2
  !-----------------------------------------------------------------------
  n2 = n/2
  if (n.gt.2*n2) then
    c(n2+1) = (c(n2+1)+c(m-n2+1))/2.
  endif
  do i=n2, 1, -1
    c(n-i+1) = c(m-i+1)
  enddo
end subroutine fft_cutoff
!
subroutine pfactor(n,p)
  !---------------------------------------------------------------------
  ! Returns in p the largest prime factor in n
  !---------------------------------------------------------------------
  integer :: n                      !
  integer :: p                      !
  ! Global
  logical :: prime
  ! Local
  integer :: m, q, r
  !------------------------------------------------------------------------
  m = n
  p = 1
  do while (m .gt. p)
    if (prime(m,q)) then
      p = max(p,m)
      return
    else
      do while (.not.prime(q,r))
        q = q/r
      enddo
      p = max(p,q)
      m = m/q
    endif
  enddo
end subroutine pfactor
!
function prime(n,p)
  !---------------------------------------------------------------------
  ! Find if n is prime, returns the smallest integer divisor p.
  !---------------------------------------------------------------------
  logical :: prime                  !
  integer :: n                      !
  integer :: p                      !
  ! Local
  integer :: i, nn
  !------------------------------------------------------------------------
  prime = .false.
  p=2
  i=n/2
  if (i.gt.1 .and. i*2.eq.n) return
  p = 3
  nn = sqrt(float(n))
  do while (p.le.nn)
    i = n/p
    if (p*i.eq.n) return
    p = p+2
  enddo
  prime = .true.
  return
end function prime
!

subroutine header_ra
  !---------------------------------------------------------------------
  ! POINTING
  !	Read CLASS ANALYSE\PRINT POINTING output files
  !---------------------------------------------------------------------
  character(len=80) :: chain
  !
  ! Skip header lines (4)
  read(2,*)
  read(2,*)
  read(2,*)
  read(2,'(A)') chain
end
!<FF>
subroutine header_op
  !---------------------------------------------------------------------
  ! POINTING
  !	Read optical data files.
  !---------------------------------------------------------------------
  ! Global
  integer :: lenc
  ! Local
  character(len=80) :: chain
  character(len=3) :: station(4)
  integer :: i,iant
  !
  read(2,'(A)') chain          ! Antenna and Station
  call sic_upper (chain)
  !
  ! Single-dish format
  write(6,*) 'I-POINTING,  Reading optical data file'
  if (index(chain,'ANT').ne.0) then
    write(6,'(1x,a,a)') 'I-POINTING,  Found single antenna data '   &
     &      ,chain(1:lenc(chain))
  else
    write(6,'(1x,a,a)') 'I-POINTING,  Found multi-antenna data '   &
     &      ,chain(1:lenc(chain))
    read(2,*)                  ! Plateau de Bure coordinates
    do i=1,4
      read(2,'(A)') chain
      station(i) = chain(12:14)
      read(2,*)                ! IAZ IEL
      read(2,*)                ! etc...
      read(2,*)                ! etc...
      read(2,*)                ! etc...
    enddo
    iant = 0
    do i=1,4
      if (station(i).ne.'0  ') then
        iant = iant+1
      endif
    enddo
    if (iant.eq.0) then
      write(6,*) 'E-POINTING,  No antenna on station'
    else
      do i=1,4
        if (station(i).ne.'0  ') then
          write(6,'(1X,A,I1,A,A)') 'I-POINTING,  Antenna ',   &
     &            i,' on station ',station(i)
        endif
      enddo
    endif
  endif
end
!<FF>
subroutine header_in
  !---------------------------------------------------------------------
  ! POINTING
  !	Read CLIC SOLVE POINTING /OUTPUT output files
  !---------------------------------------------------------------------
end

module wifisyn_interfaces_private
  interface
    subroutine wifisyn_apodize_command(line,error)
      use gbl_message
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! Support routine for command
      !     APODIZE WIFI|VISI
      !       1 /DIRECT
      !       2 /INVERSE
      !       3 /UV
      !       4 /XY
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_apodize_command
  end interface
  !
  interface
    subroutine wifisyn_apodize_main(do,error)
      use gbl_message
      use wifisyn_transform_types
      use wifisyn_sic_buffer
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(action_t), intent(in)    :: do
      logical,        intent(inout) :: error
    end subroutine wifisyn_apodize_main
  end interface
  !
  interface
    subroutine wifisyn_apodize_wifi_uv(idir,map,wifi,error)
      use gbl_message
      use wifisyn_transform_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,             intent(in)    :: idir
      type(map_t), target, intent(in)    :: map
      type(wifi_t),        intent(inout) :: wifi
      logical,             intent(inout) :: error
    end subroutine wifisyn_apodize_wifi_uv
  end interface
  !
  interface
    subroutine wifisyn_apodize_wifi_xy(idir,map,wifi,error)
      use gbl_message
      use wifisyn_transform_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,             intent(in)    :: idir
      type(map_t), target, intent(in)    :: map
      type(wifi_t),        intent(inout) :: wifi
      logical,             intent(inout) :: error
    end subroutine wifisyn_apodize_wifi_xy
  end interface
  !
  interface
    subroutine wifisyn_complex_command(line,error)
      use gbl_message
      use wifisyn_sic_buffer
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    COMPLEX VISICUBE|WIFICUBE TO|FROM AMPLITUDE|PHASE|REAL|IMAGINARY
      !      1 /LOGSCALE
      !      2 /NORMALIZE
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_complex_command
  end interface
  !
  interface
    subroutine wifisyn_wifi_complex2real(logscale,ioper,ichan,map,wifi,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical,      intent(in)    :: logscale
      integer,      intent(in)    :: ioper
      integer,      intent(in)    :: ichan
      type(map_t),  intent(in)    :: map
      type(wifi_t), intent(inout) :: wifi
      logical,      intent(inout) :: error
    end subroutine wifisyn_wifi_complex2real
  end interface
  !
  interface
    subroutine wifisyn_visi_complex2real(logscale,ioper,win,map,visi,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical,        intent(in)    :: logscale
      integer,        intent(in)    :: ioper
      type(window_t), intent(in)    :: win
      type(map_t),    intent(in)    :: map
      type(visi_t),   intent(inout) :: visi
      logical,        intent(inout) :: error
    end subroutine wifisyn_visi_complex2real
  end interface
  !
  interface
    subroutine wifisyn_wifi_header(map,wifi,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t),  intent(in)    :: map
      type(wifi_t), intent(inout) :: wifi
      logical,      intent(inout) :: error
    end subroutine wifisyn_wifi_header
  end interface
  !
  interface
    subroutine wifisyn_visi_header(map,visi,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t),  intent(in)    :: map
      type(visi_t), intent(inout) :: visi
      logical,      intent(inout) :: error
    end subroutine wifisyn_visi_header
  end interface
  !
  interface
    subroutine wifisyn_common_header(map,cube,error)
      use gbl_message
      use image_def
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t),  intent(in)    :: map
      type(gildas), intent(inout) :: cube
      logical,      intent(inout) :: error
    end subroutine wifisyn_common_header
  end interface
  !
  interface
    subroutine wifisyn_wifi_real2complex(ioper,ichan,wifi,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      integer,      intent(in)    :: ioper
      integer,      intent(in)    :: ichan
      type(wifi_t), intent(inout) :: wifi
      logical,      intent(inout) :: error
    end subroutine wifisyn_wifi_real2complex
  end interface
  !
  interface
    subroutine wifisyn_visi_real2complex(ioper,win,visi,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      integer,        intent(in)    :: ioper
      type(window_t), intent(in)    :: win
      type(visi_t),   intent(inout) :: visi
      logical,        intent(inout) :: error
    end subroutine wifisyn_visi_real2complex
  end interface
  !
  interface
    subroutine wifisyn_convolution_definition(pixinc,kern,error)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! Determine default parameters for the convolution functions when
      ! they are not specified. Default convolving type is a spheroidal
      ! function. Any other unspecified values (= 0.0) will be set to
      ! some value.
      !----------------------------------------------------------------------
      real(kind=8),      intent(in)    :: pixinc
      type(kernel_1d_t), intent(inout) :: kern
      logical,           intent(inout) :: error
    end subroutine wifisyn_convolution_definition
  end interface
  !
  interface
    subroutine wifisyn_convolution_computation(kern,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! Compute the convolving functions and stores them in the supplied
      ! buffer. Values are tabulated every 1/100th of grid pixel.
      ! PARM(1) = radius of support in grid pixel unit
      !----------------------------------------------------------------------
      type(kernel_1d_t), intent(inout) :: kern
      logical,           intent(inout) :: error
    end subroutine wifisyn_convolution_computation
  end interface
  !
  interface
    subroutine sphfn(ialf,im,iflag,eta,psi,ier)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! SPHFN is a subroutine to evaluate rational approximations to selected
      ! zero-order spheroidal functions, psi(c,eta), which are, in a
      ! sense defined in VLA Scientific Memorandum No. 132, optimal for
      ! gridding interferometer data.  The approximations are taken from
      ! VLA Computer Memorandum No. 156.  The parameter c is related to the
      ! support width, m, of the convoluting function according to c=
      ! pi*m/2.  The parameter alpha determines a weight function in the
      ! definition of the criterion by which the function is optimal.
      ! SPHFN incorporates approximations to 25 of the spheroidal functions,
      ! corresponding to 5 choices of m (4, 5, 6, 7, or 8 cells)
      ! and 5 choices of the weighting exponent (0, 1/2, 1, 3/2, or 2).
      ! 
      ! Input:
      !   IALF    I*4   Selects the weighting exponent, alpha.  IALF =
      !                 1, 2, 3, 4, and 5 correspond, respectively, to
      !                 alpha = 0, 1/2, 1, 3/2, and 2.
      !   IM      I*4   Selects the support width m, (=IM) and, correspond-
      !                 ingly, the parameter c of the spheroidal function.
      !                 Only the choices 4, 5, 6, 7, and 8 are allowed.
      !   IFLAG   I*4   Chooses whether the spheroidal function itself, or
      !                 its Fourier transform, is to be approximated.  The
      !                 latter is appropriate for gridding, and the former
      !                 for the u-v plane convolution.  The two differ on-
      !                 by a factor (1-eta**2)**alpha.  IFLAG less than or
      !                 equal to zero chooses the function appropriate for
      !                 gridding, and IFLAG positive chooses its F.T.
      !   ETA     R*4   Eta, as the argument of the spheroidal function, is
      !                 a variable which ranges from 0 at the center of the
      !                 convoluting function to 1 at its edge (also from 0
      !                 at the center of the gridding correction function
      !                 to unity at the edge of the map).
      ! 
      ! Output:
      !   PSI      R*4  The function value which, on entry to the subrou-
      !                 tine, was to have been computed.
      !   IER      I*4  An error flag whose meaning is as follows:
      !                    IER = 0  =>  No evident problem.
      !                          1  =>  IALF is outside the allowed range.
      !                          2  =>  IM is outside of the allowed range.
      !                          3  =>  ETA is larger than 1 in absolute
      !                                    value.
      !                         12  =>  IALF and IM are out of bounds.
      !                         13  =>  IALF and ETA are both illegal.
      !                         23  =>  IM and ETA are both illegal.
      !                        123  =>  IALF, IM, and ETA all are illegal.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: ialf
      integer(kind=4), intent(in)  :: im
      integer(kind=4), intent(in)  :: iflag
      real(kind=4),    intent(in)  :: eta
      real(kind=4),    intent(out) :: psi
      integer(kind=4), intent(out) :: ier
    end subroutine sphfn
  end interface
  !
  interface
    subroutine wifisyn_convolve_wifi_uvkern(map,wifi,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_transform_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t), target, intent(in)    :: map
      type(wifi_t),        intent(inout) :: wifi
      logical,             intent(inout) :: error
    end subroutine wifisyn_convolve_wifi_uvkern
  end interface
  !
  interface
    subroutine wifisyn_deconvolve_wifi_uvkern(map,wifi,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_transform_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t), target, intent(in)    :: map
      type(wifi_t),        intent(inout) :: wifi
      logical,             intent(inout) :: error
    end subroutine wifisyn_deconvolve_wifi_uvkern
  end interface
  !
  interface
    subroutine wifisyn_cube_reallocate_r4d(kind,cube,error)
      use gbl_message
      use image_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: kind
      type(gildas),     intent(inout) :: cube
      logical,          intent(inout) :: error
    end subroutine wifisyn_cube_reallocate_r4d
  end interface
  !
  interface
    subroutine wifisyn_cube_free_r4d(cube,error)
      use gbl_message
      use image_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(gildas), intent(inout) :: cube
      logical,      intent(inout) :: error
    end subroutine wifisyn_cube_free_r4d
  end interface
  !
  interface
    subroutine wifisyn_cube_reallocate_r3d(nc,kind,cube,error)
      use gbl_message
      use image_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      integer,          intent(in)    :: nc
      character(len=*), intent(in)    :: kind
      type(gildas),     intent(inout) :: cube
      logical,          intent(inout) :: error
    end subroutine wifisyn_cube_reallocate_r3d
  end interface
  !
  interface
    subroutine wifisyn_cube_free_r3d(cube,error)
      use gbl_message
      use image_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(gildas), intent(inout) :: cube
      logical,      intent(inout) :: error
    end subroutine wifisyn_cube_free_r3d
  end interface
  !
  interface
    subroutine wifisyn_cube_reallocate_r2d(kind,cube,error)
      use gbl_message
      use image_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: kind
      type(gildas),     intent(inout) :: cube
      logical,          intent(inout) :: error
    end subroutine wifisyn_cube_reallocate_r2d
  end interface
  !
  interface
    subroutine wifisyn_cube_free_r2d(cube,error)
      use gbl_message
      use image_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(gildas), intent(inout) :: cube
      logical,      intent(inout) :: error
    end subroutine wifisyn_cube_free_r2d
  end interface
  !
  interface
    subroutine wifisyn_cube_minmax_r4d(logscale,cube,error)
      use gbl_message
      use image_def
      use wifisyn_gridding_types
      !--------------------------------------------------------------------
      ! @ private
      ! Update the minimum and maximum value of a cube and
      ! their locations. We here assume that the initializations
      ! were done when the cube was initialized...
      !--------------------------------------------------------------------
      logical,        intent(in)    :: logscale
      type(gildas),   intent(inout) :: cube
      logical,        intent(inout) :: error
    end subroutine wifisyn_cube_minmax_r4d
  end interface
  !
  interface
    subroutine wifisyn_cube_minmax_r3d(logscale,win,cube,error)
      use gbl_message
      use image_def
      use wifisyn_gridding_types
      !--------------------------------------------------------------------
      ! @ private
      ! Update the minimum and maximum value of a cube and
      ! their locations. We here assume that the initializations
      ! were done when the cube was initialized...
      !--------------------------------------------------------------------
      logical,        intent(in)    :: logscale
      type(window_t), intent(in)    :: win
      type(gildas),   intent(inout) :: cube
      logical,        intent(inout) :: error
    end subroutine wifisyn_cube_minmax_r3d
  end interface
  !
  interface
    subroutine wifisyn_cube_minmax_r2d(logscale,cube,error)
      use gbl_message
      use image_def
      use wifisyn_gridding_types
      !--------------------------------------------------------------------
      ! @ private
      ! Update the minimum and maximum value of a cube and
      ! their locations. We here assume that the initializations
      ! were done when the cube was initialized...
      !--------------------------------------------------------------------
      logical,        intent(in)    :: logscale
      type(gildas),   intent(inout) :: cube
      logical,        intent(inout) :: error
    end subroutine wifisyn_cube_minmax_r2d
  end interface
  !
  interface
    subroutine wifisyn_cube_open(name,ibuffer,cube,error)
      use gbl_message
      use image_def
      use wifisyn_buffer_parameters
      !----------------------------------------------------------------------
      ! @ private
      ! *** JP should probably here use the readwrite_t
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: name
      integer,          intent(in)    :: ibuffer
      type(gildas),     intent(inout) :: cube
      logical,          intent(inout) :: error
    end subroutine wifisyn_cube_open
  end interface
  !
  interface
    subroutine wifisyn_cube_read(do,cube,error)
      use gbl_message
      use image_def
      use wifisyn_readwrite_types
      use wifisyn_cube_types
      !------------------------------------------------------------------
      ! @ private
      ! Read input cube header and data
      !------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(gildas),      intent(inout) :: cube
      logical,           intent(inout) :: error
    end subroutine wifisyn_cube_read
  end interface
  !
  interface
    subroutine wifisyn_cube_write_r4d(i3,i4,cube,error)
      use gbl_message
      use gildas_def
      use image_def
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      integer,              intent(in)    :: i3
      integer,              intent(in)    :: i4
      type(gildas), target, intent(inout) :: cube
      logical,              intent(inout) :: error
    end subroutine wifisyn_cube_write_r4d
  end interface
  !
  interface
    subroutine wifisyn_cube_write(win,cube,error)
      use gbl_message
      use gildas_def
      use image_def
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(window_t), intent(in)    :: win
      type(gildas),   intent(inout) :: cube
      logical,        intent(inout) :: error
    end subroutine wifisyn_cube_write
  end interface
  !
  interface
    subroutine wifisyn_cube_close(cube,error)
      use gbl_message
      use image_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(gildas),     intent(inout) :: cube
      logical,          intent(inout) :: error
    end subroutine wifisyn_cube_close
  end interface
  !
  interface
    subroutine wifisyn_cube_sicdef(readonly,name,cube,error)
      use gbl_message
      use image_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical,          intent(in)    :: readonly
      character(len=*), intent(in)    :: name ! sic name
      type(gildas),     intent(inout) :: cube ! buffer
      logical,          intent(inout) :: error
    end subroutine wifisyn_cube_sicdef
  end interface
  !
  interface
    subroutine wifisyn_cube_sicdel_header(name,error)
      use gbl_message
      use gildas_def
      use image_def
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: name
      logical,          intent(inout) :: error
    end subroutine wifisyn_cube_sicdel_header
  end interface
  !
  interface
    subroutine wifisyn_allocate_fft_wifi(ispace,wifi,fft,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_transform_types
      use wifisyn_gridding_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      integer,              intent(in)    :: ispace
      type(wifi_t), target, intent(in)    :: wifi
      type(fft_t),          intent(out)   :: fft
      logical,              intent(inout) :: error
    end subroutine wifisyn_allocate_fft_wifi
  end interface
  !
  interface
    subroutine wifisyn_allocate_fft_visi(visi,fft,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_transform_types
      use wifisyn_gridding_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(visi_t), target, intent(in)    :: visi
      type(fft_t),          intent(out)   :: fft
      logical,              intent(inout) :: error
    end subroutine wifisyn_allocate_fft_visi
  end interface
  !
  interface
    subroutine wifisyn_free_fft(fft,error)
      use gbl_message
      use wifisyn_transform_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(fft_t), intent(inout) :: fft
      logical,     intent(inout) :: error
    end subroutine wifisyn_free_fft
  end interface
  !
  interface
    subroutine wifisyn_fft_command(line,error)
      use gbl_message
      use wifisyn_sic_buffer
      use wifisyn_cube_buffer
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !     FFT WIFI|VISI
      !       1 /DIRECT
      !       2 /INVERSE
      !       3 /UV
      !       4 /XY
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_fft_command
  end interface
  !
  interface
    subroutine wifisyn_fft_wifi(idir,ispace,win,wifi,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_cube_types
      use wifisyn_transform_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,        intent(in)    :: idir
      integer,        intent(in)    :: ispace
      type(window_t), intent(in)    :: win
      type(wifi_t),   intent(inout) :: wifi
      logical,        intent(inout) :: error
    end subroutine wifisyn_fft_wifi
  end interface
  !
  interface
    subroutine wifisyn_fft_wifi_xy(idir,win,fft,error)
      use gbl_message
      use gkernel_types
      use wifisyn_transform_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,        intent(in)    :: idir
      type(window_t), intent(in)    :: win
      type(fft_t),    intent(inout) :: fft
      logical,        intent(inout) :: error
    end subroutine wifisyn_fft_wifi_xy
  end interface
  !
  interface
    subroutine wifisyn_fft_xyuv2xy(ic,iu,iv,fft)
      use gbl_message
      use wifisyn_transform_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,     intent(in)    :: ic
      integer,     intent(in)    :: iu
      integer,     intent(in)    :: iv
      type(fft_t), intent(inout) :: fft
    end subroutine wifisyn_fft_xyuv2xy
  end interface
  !
  interface
    subroutine wifisyn_fft_xy2xyuv(ic,iu,iv,fft)
      use gbl_message
      use image_def
      use wifisyn_transform_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,     intent(in)    :: ic
      integer,     intent(in)    :: iu
      integer,     intent(in)    :: iv
      type(fft_t), intent(inout) :: fft
    end subroutine wifisyn_fft_xy2xyuv
  end interface
  !
  interface
    subroutine wifisyn_fft_wifi_uv(idir,win,fft,error)
      use gbl_message
      use gkernel_types
      use wifisyn_transform_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,        intent(in)    :: idir
      type(window_t), intent(in)    :: win
      type(fft_t),    intent(inout) :: fft
      logical,        intent(inout) :: error
    end subroutine wifisyn_fft_wifi_uv
  end interface
  !
  interface
    subroutine wifisyn_fft_xyuv2uv(ic,ix,iy,fft)
      use gbl_message
      use wifisyn_transform_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,     intent(in)    :: ic
      integer,     intent(in)    :: ix
      integer,     intent(in)    :: iy
      type(fft_t), intent(inout) :: fft
    end subroutine wifisyn_fft_xyuv2uv
  end interface
  !
  interface
    subroutine wifisyn_fft_uv2xyuv(ic,ix,iy,fft)
      use gbl_message
      use image_def
      use wifisyn_transform_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,     intent(in)    :: ic
      integer,     intent(in)    :: ix
      integer,     intent(in)    :: iy
      type(fft_t), intent(inout) :: fft
    end subroutine wifisyn_fft_uv2xyuv
  end interface
  !
  interface
    subroutine wifisyn_fft_visi(idir,win,visi,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_cube_types
      use wifisyn_transform_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,        intent(in)    :: idir
      type(window_t), intent(in)    :: win
      type(visi_t),   intent(inout) :: visi
      logical,        intent(inout) :: error
    end subroutine wifisyn_fft_visi
  end interface
  !
  interface
    subroutine wifisyn_fft_visi_uv(idir,win,fft,error)
      use gbl_message
      use gkernel_types
      use wifisyn_transform_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,        intent(in)    :: idir
      type(window_t), intent(in)    :: win
      type(fft_t),    intent(inout) :: fft
      logical,        intent(inout) :: error
    end subroutine wifisyn_fft_visi_uv
  end interface
  !
  interface
    subroutine wifisyn_fft_visi2plane(ic,fft)
      use gbl_message
      use wifisyn_transform_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,     intent(in)    :: ic
      type(fft_t), intent(inout) :: fft
    end subroutine wifisyn_fft_visi2plane
  end interface
  !
  interface
    subroutine wifisyn_fft_plane2visi(ic,fft)
      use gbl_message
      use image_def
      use wifisyn_transform_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,     intent(in)    :: ic
      type(fft_t), intent(inout) :: fft
    end subroutine wifisyn_fft_plane2visi
  end interface
  !
  interface
    subroutine wifisyn_gridding_nullify_axis_1d(axis)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(axis_1d_t), target, intent(inout) :: axis
    end subroutine wifisyn_gridding_nullify_axis_1d
  end interface
  !
  interface
    subroutine wifisyn_gridding_nullify_axis_pair(kind,axis)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      integer,           intent(in)    :: kind
      type(axis_pair_t), intent(inout) :: axis
    end subroutine wifisyn_gridding_nullify_axis_pair
  end interface
  !
  interface
    subroutine wifisyn_gridding_nullify_axes(axes)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(axis_t), intent(inout) :: axes(2)
    end subroutine wifisyn_gridding_nullify_axes
  end interface
  !
  interface
    subroutine wifisyn_gridding_nullify_map(map)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(map_t), intent(inout) :: map
    end subroutine wifisyn_gridding_nullify_map
  end interface
  !
  interface
    subroutine wifisyn_free_map(map,error)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(map_t), intent(inout) :: map
      logical,     intent(inout) :: error
    end subroutine wifisyn_free_map
  end interface
  !
  interface
    subroutine wifisyn_gridding_sicdef_user(error)
      use gildas_def
      use gbl_message
      use wifisyn_sic_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine wifisyn_gridding_sicdef_user
  end interface
  !
  interface
    subroutine wifisyn_gridding_sicdef_prog(prog_request,error)
      use gildas_def
      use gbl_message
      use wifisyn_sic_buffer
      !----------------------------------------------------------------------
      ! @ private
      ! *** JP Can not yet define readwrite or readonly
      !----------------------------------------------------------------------
      logical, intent(in)    :: prog_request
      logical, intent(inout) :: error
    end subroutine wifisyn_gridding_sicdef_prog
  end interface
  !
  interface
    subroutine wifisyn_gridding_sicdef_prog_axes(name,axes,error)
      use gbl_message
      use gildas_def
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: name
      type(axis_t),     intent(in)    :: axes(2)
      logical,          intent(inout) :: error
    end subroutine wifisyn_gridding_sicdef_prog_axes
  end interface
  !
  interface
    subroutine wifisyn_gridding_sicdef_prog_axis_pair(name,axis,error)
      use gildas_def
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*),  intent(in)    :: name
      type(axis_pair_t), intent(in)    :: axis
      logical,           intent(inout) :: error
    end subroutine wifisyn_gridding_sicdef_prog_axis_pair
  end interface
  !
  interface
    subroutine wifisyn_gridding_sicdef_prog_axis_1d(name,axis,error)
      use gildas_def
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: name
      type(axis_1d_t),  intent(in)    :: axis
      logical,          intent(inout) :: error
    end subroutine wifisyn_gridding_sicdef_prog_axis_1d
  end interface
  !
  interface
    subroutine wifisyn_gridding_sicdef_prog_kern(name,kern,error)
      use gildas_def
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: name
      type(kernel_t),   intent(in)    :: kern(2)
      logical,          intent(inout) :: error
    end subroutine wifisyn_gridding_sicdef_prog_kern
  end interface
  !
  interface
    subroutine wifisyn_gridding_sicdef_prog_kernel_1d(name,kern,error)
      use gildas_def
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*),  intent(in)    :: name
      type(kernel_1d_t), intent(in)    :: kern
      logical,           intent(inout) :: error
    end subroutine wifisyn_gridding_sicdef_prog_kernel_1d
  end interface
  !
  interface
    subroutine wifisyn_sicdef_dble_1d(name,val,nval,readonly,error)
      use gildas_def
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: name
      integer,          intent(in)    :: nval
      real(kind=8),     intent(in)    :: val(nval)
      logical,          intent(in)    :: readonly
      logical,          intent(inout) :: error
    end subroutine wifisyn_sicdef_dble_1d
  end interface
  !
  interface
    subroutine wifisyn_sicdef_real_1d(name,val,nval,readonly,error)
      use gildas_def
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: name
      integer,          intent(in)    :: nval
      real(kind=4),     intent(in)    :: val(nval)
      logical,          intent(in)    :: readonly
      logical,          intent(inout) :: error
    end subroutine wifisyn_sicdef_real_1d
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_huv(huv,map,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(uv_head_t), intent(in)    :: huv
      type(map_t),     intent(inout) :: map
      logical,         intent(inout) :: error
    end subroutine wifisyn_gridding_set_huv
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_tabdim(huv,n,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(uv_head_t), intent(in)    :: huv
      type(tabdim_t),  intent(out)   :: n
      logical,         intent(inout) :: error
    end subroutine wifisyn_gridding_set_tabdim
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_winlist(user,nchan,winlist,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(sicmap_t),  intent(in)    :: user
      integer,         intent(in)    :: nchan
      type(winlist_t), intent(inout) :: winlist
      logical,         intent(inout) :: error
    end subroutine wifisyn_gridding_set_winlist
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_rchan(huv,rchan,error)
      use gbl_message
      use phys_const
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(uv_head_t), intent(in)    :: huv
      type(channel_t), intent(out)   :: rchan
      logical,         intent(inout) :: error
    end subroutine wifisyn_gridding_set_rchan
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_shift(user,hin,rchan,shift,error)
      use gbl_message
      use gbl_constant
      use phys_const
      use image_def
      use gkernel_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(sicmap_t),  intent(in)  :: user
      type(gildas),    intent(in)  :: hin
      type(channel_t), intent(in)  :: rchan
      type(shift_t),   intent(out) :: shift
      logical,         intent(out) :: error
    end subroutine wifisyn_gridding_set_shift
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_topology(huv,topo,error)
      use gbl_message
      use phys_const
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(uv_head_t),  intent(in)    :: huv
      type(topology_t), intent(out)   :: topo(2)
      logical,          intent(inout) :: error
    end subroutine wifisyn_gridding_set_topology
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_1d_scale(hin,rchan,topo,scale,error)
      use gbl_message
      use phys_const
      use image_def
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(gildas),     intent(in)    :: hin
      type(channel_t),  intent(in)    :: rchan
      type(topology_t), intent(in)    :: topo
      type(scale_t),    intent(out)   :: scale
      logical,          intent(inout) :: error
    end subroutine wifisyn_gridding_set_1d_scale
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_1d_axis(rchan,scale,axis,error)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(channel_t), intent(in)    :: rchan
      type(scale_t),   intent(in)    :: scale
      type(axis_t),    intent(inout) :: axis
      logical,         intent(inout) :: error
    end subroutine wifisyn_gridding_set_1d_axis
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_1d_axis_pair(rchan,npix,incuvp,axis,error)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(channel_t),   intent(in)    :: rchan
      integer,           intent(in)    :: npix
      real(kind=8),      intent(in)    :: incuvp
      type(axis_pair_t), intent(inout) :: axis
      logical,           intent(inout) :: error
    end subroutine wifisyn_gridding_set_1d_axis_pair
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_1d_coord(axis,error)
      use gbl_message
      use wifisyn_gridding_types
      !------------------------------------------------------------------------
      ! @ private
      ! Allocate and compute coordinate array from conversion formula
      !------------------------------------------------------------------------
      type(axis_1d_t), intent(inout) :: axis
      logical,         intent(inout) :: error
    end subroutine wifisyn_gridding_set_1d_coord
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_1d_kernel(user,axis,kern,error)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(sicmap_t),    intent(in)    :: user
      type(axis_pair_t), intent(in)    :: axis
      type(kernel_1d_t), intent(inout) :: kern
      logical,           intent(inout) :: error
    end subroutine wifisyn_gridding_set_1d_kernel
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_taper(user,taper,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(sicmap_t), intent(in)    :: user
      type(taper_t),  intent(inout) :: taper
      logical,        intent(inout) :: error
    end subroutine wifisyn_gridding_set_taper
  end interface
  !
  interface
    subroutine wifisyn_gridding_set_buffer(map,error)
      use gbl_message
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t), intent(inout) :: map
      logical,     intent(inout) :: error
    end subroutine wifisyn_gridding_set_buffer
  end interface
  !
  interface
    subroutine wifisyn_gridding_print(map,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      !----------------------------------------------------------
      ! @ private
      !----------------------------------------------------------
      type(map_t), target, intent(inout) :: map   ! Gridding parameters
      logical,             intent(inout) :: error ! Return status
    end subroutine wifisyn_gridding_print
  end interface
  !
  interface
    subroutine wifisyn_ift_kern(nift,kern,error)
      use gbl_message
      use phys_const
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute the inverse Fourier transform of the gridding function
      ! on the full image support (i.e. much larger number of pixels than the
      ! initial definition). The result is centered on kern%ft%n/2+1.
      ! I guess that kern%ft%n must be even (not checked...).
      !---------------------------------------------------------------------
      integer,           intent(in)    :: nift
      type(kernel_1d_t), intent(inout) :: kern
      logical,           intent(inout) :: error
    end subroutine wifisyn_ift_kern
  end interface
  !
  interface
    subroutine wifisyn_ift_shift_and_plunge(ic,cube,image)
      use gbl_message
      use wifisyn_array_types
      !---------------------------------------------------------------------
      ! @ private
      ! Extract a Fourier plane from the FFT cube
      !---------------------------------------------------------------------
      integer,            intent(in)    :: ic
      type(complex_3d_t), intent(in)    :: cube
      type(complex_2d_t), intent(inout) :: image
    end subroutine wifisyn_ift_shift_and_plunge
  end interface
  !
  interface
    subroutine wifisyn_ift_shift_and_real(ic,image,cube)
      use gbl_message
      use image_def
      use wifisyn_array_types
      !---------------------------------------------------------------------
      ! @ private
      ! Extract real image from an IFT image with appropriate recentering
      !---------------------------------------------------------------------
      integer,            intent(in)    :: ic
      type(complex_2d_t), intent(in)    :: image
      type(gildas),       intent(inout) :: cube
    end subroutine wifisyn_ift_shift_and_real
  end interface
  !
  interface
    subroutine wifisyn_ift_compute_grid_correction(beam,ukern,vkern,corr,error)
      use gbl_message
      use image_def
      use wifisyn_array_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute grid correction array, with normalisation of beam to 1.0
      ! at maximum pixel
      !---------------------------------------------------------------------
      type(gildas),      intent(in)    :: beam  ! Beam before normalization
      type(kernel_1d_t), intent(in)    :: ukern ! U gridding kernel
      type(kernel_1d_t), intent(in)    :: vkern ! V gridding kernel
      type(real_2d_t),   intent(inout) :: corr  ! Beam-normalized 2D grid correction
      logical,           intent(inout) :: error
    end subroutine wifisyn_ift_compute_grid_correction
  end interface
  !
  interface
    subroutine wifisyn_ift_apply_grid_correction(win,corr,cube,error)
      use gbl_message
      use image_def
      use wifisyn_array_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      ! Apply gridding kernel correction to map
      !---------------------------------------------------------------------
      type(window_t),  intent(in)    :: win
      type(real_2d_t), intent(in)    :: corr
      type(gildas),    intent(inout) :: cube
      logical,         intent(inout) :: error
    end subroutine wifisyn_ift_apply_grid_correction
  end interface
  !
  interface
    subroutine wifisyn_init(error)
      use wifisyn_uv_types
      !----------------------------------------------------------------------
      ! @ private
      ! WIFISYN Initialization
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine wifisyn_init
  end interface
  !
  interface
    subroutine wifisyn_exit(error)
      use wifisyn_uv_buffer
      !----------------------------------------------------------------------
      ! @ private
      ! WIFISYN Initialization
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine wifisyn_exit
  end interface
  !
  interface
    subroutine wifisyn_load
      !----------------------------------------------------------------------
      ! @ private
      ! WIFISYN language definition
      !----------------------------------------------------------------------
    end subroutine wifisyn_load
  end interface
  !
  interface
    subroutine wifisyn_run(line,command,error)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      ! WIFISYN Main routine: Call appropriate subroutine according to COMMAND
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      character(len=*), intent(in)    :: command
      logical,          intent(out)   :: error
    end subroutine wifisyn_run
  end interface
  !
  interface
    subroutine wifisyn_write_visi(do,map,visi,error)
      use gbl_message
      use wifisyn_readwrite_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(map_t),       intent(in)    :: map
      type(visi_t),      intent(inout) :: visi
      logical,           intent(inout) :: error
    end subroutine wifisyn_write_visi
  end interface
  !
  interface
    subroutine wifisyn_write_wifi(do,map,wifi,error)
      use gbl_message
      use wifisyn_readwrite_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(map_t),       intent(in)    :: map
      type(wifi_t),      intent(inout) :: wifi
      logical,           intent(inout) :: error
    end subroutine wifisyn_write_wifi
  end interface
  !
  interface
    subroutine wifisyn_read_wifi(do,wifi,error)
      use gbl_message
      use wifisyn_readwrite_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! *** JP1 The progmap structure should be set as well to ensure consistency
      ! *** JP2 There is no consistency check between real and imaginary part...
      ! *** JP3 The xykind and uvkind should be set according to the file units
      !----------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(wifi_t),      intent(inout) :: wifi
      logical,           intent(inout) :: error
    end subroutine wifisyn_read_wifi
  end interface
  !
  interface
    subroutine wifisyn_load_command(line,error)
      use gbl_message
      use wifisyn_load_types
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command LOAD
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_load_command
  end interface
  !
  interface
    subroutine wifisyn_load_parse(line,do,error)
      use gbl_message
      use wifisyn_load_types
      !----------------------------------------------------------------------
      ! @ private
      ! Parsing routine for command
      !    LOAD buffer [varname]
      !      1. [/AMPLITUDE [LOGSCALE | LINSCALE]]
      !      2. [/NORMALIZE]
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      type(load_t),     intent(inout) :: do
      logical,          intent(inout) :: error
    end subroutine wifisyn_load_parse
  end interface
  !
  interface
    subroutine wifisyn_load_main(do,error)
      use gbl_message
      use wifisyn_load_types
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(load_t), intent(in)    :: do
      logical,      intent(inout) :: error
    end subroutine wifisyn_load_main
  end interface
  !
  interface
    subroutine wifisyn_message_set_id(id)
      use gbl_message
      use wifisyn_message_private
      !---------------------------------------------------------------------
      ! @ private
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine wifisyn_message_set_id
  end interface
  !
  interface
    subroutine wifisyn_message(mkind,procname,mymessage)
      use wifisyn_message_private
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind    ! Message kind
      character(len=*), intent(in) :: procname ! Name of calling procedure
      character(len=*), intent(in) :: mymessage  ! Message string
    end subroutine wifisyn_message
  end interface
  !
  interface
    subroutine wifisyn_pack_set(pack)
      use gpack_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(gpack_info_t), intent(out) :: pack
    end subroutine wifisyn_pack_set
  end interface
  !
  interface
    subroutine wifisyn_pack_init(gpack_id,error)
      use sic_def
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine wifisyn_pack_init
  end interface
  !
  interface
    subroutine wifisyn_pack_on_exit(error)
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical :: error
    end subroutine wifisyn_pack_on_exit
  end interface
  !
  interface
    subroutine wifisyn_parse_unit_kind(line,iopt,iarg,iunit,error)
      use gbl_message
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(in)    :: iopt
      integer,          intent(in)    :: iarg
      integer,          intent(out)   :: iunit
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_unit_kind
  end interface
  !
  interface
    subroutine wifisyn_parse_cube_kind(line,icube,error)
      use gbl_message
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(out)   :: icube
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_cube_kind
  end interface
  !
  interface
    subroutine wifisyn_parse_dire_kind(line,idire,error)
      use gbl_message
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(out)   :: idire
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_dire_kind
  end interface
  !
  interface
    subroutine wifisyn_parse_oper_kind(line,ioper,error)
      use gbl_message
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(out)   :: ioper
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_oper_kind
  end interface
  !
  interface
    subroutine wifisyn_parse_cube_amplitude(line,iopt,amplitude,logscale,error)
      use gbl_message
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(in)    :: iopt
      logical,          intent(out)   :: amplitude
      logical,          intent(out)   :: logscale
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_cube_amplitude
  end interface
  !
  interface
    subroutine wifisyn_parse_buffer(line,iopt,iarg,id,kind,type,error)
      use gbl_message
      use wifisyn_buffer_parameters
      !----------------------------------------------------------------------
      ! @ private
      ! *** JP Buffer parsing should be merged with wifisyn_parse_cube_kind
      !----------------------------------------------------------------------
      character(len=*),                  intent(inout) :: line
      integer,                           intent(in)    :: iopt
      integer,                           intent(in)    :: iarg
      integer,                           intent(out)   :: id
      character(len=buffer_kind_length), intent(out)   :: kind
      character(len=buffer_type_length), intent(out)   :: type
      logical,                           intent(inout) :: error
    end subroutine wifisyn_parse_buffer
  end interface
  !
  interface
    subroutine wifisyn_parse_filename(line,iopt,iarg,filename,error)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(in)    :: iopt
      integer,          intent(in)    :: iarg
      character(len=*), intent(inout) :: filename
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_filename
  end interface
  !
  interface
    subroutine wifisyn_parse_varname(line,iopt,iarg,vardefault,varname,error)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(in)    :: iopt
      integer,          intent(in)    :: iarg
      character(len=*), intent(in)    :: vardefault
      character(len=*), intent(inout) :: varname
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_varname
  end interface
  !
  interface
    subroutine wifisyn_parse_channels(line,iopt,first,last,error)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(in)    :: iopt
      integer,          intent(out)   :: first
      integer,          intent(out)   :: last
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_channels
  end interface
  !
  interface
    subroutine wifisyn_parse_readwrite(line,do,error)
      use gbl_message
      use wifisyn_readwrite_types
      !----------------------------------------------------------------------
      ! @ private
      ! Parsing routine for commands
      !    READ|WRITE buffer filename
      !      1. [/CHANNELS first last]
      !----------------------------------------------------------------------
      character(len=*),  intent(inout) :: line
      type(readwrite_t), intent(inout) :: do
      logical,           intent(inout) :: error
    end subroutine wifisyn_parse_readwrite
  end interface
  !
  interface
    subroutine wifisyn_parse_transform(line,do,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      type(action_t),   intent(inout) :: do
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_transform
  end interface
  !
  interface
    subroutine wifisyn_parse_transform_direction(do,error)
      use gbl_message
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      ! Parsing routine for commands
      !    TRANSFORM
      !       1 /DIRECT
      !       2 /INVERSE
      !----------------------------------------------------------------------
      type(action_t),   intent(inout) :: do
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_transform_direction
  end interface
  !
  interface
    subroutine wifisyn_parse_transform_buffer(do,error)
      use gbl_message
      use wifisyn_buffer_parameters
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      ! Parsing routine for commands
      !    TRANSFORM
      !       3 /UV
      !       4 /VISI
      !       5 /WIFI
      !----------------------------------------------------------------------
      type(action_t), intent(inout) :: do
      logical,        intent(inout) :: error
    end subroutine wifisyn_parse_transform_buffer
  end interface
  !
  interface
    subroutine wifisyn_parse_transform_space(line,iopt,iarg,do,error)
      use gbl_message
      use wifisyn_buffer_parameters
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      integer,          intent(in)    :: iopt
      integer,          intent(in)    :: iarg
      type(action_t),   intent(inout) :: do
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_transform_space
  end interface
  !
  interface
    subroutine wifisyn_parse_transform_bis(line,do,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      ! Parsing routine for commands
      !    TRANSFORM
      !       1 /DIRECT
      !       2 /INVERSE
      !       3 /UV
      !       4 /VISI
      !       5 /WIFI UV|XY
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      type(action_t),   intent(inout) :: do
      logical,          intent(inout) :: error
    end subroutine wifisyn_parse_transform_bis
  end interface
  !
  interface
    subroutine wifisyn_read_command(line,error)
      use gbl_message
      use wifisyn_readwrite_types
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command READ
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_read_command
  end interface
  !
  interface
    subroutine wifisyn_read_main(do,error)
      use gbl_message
      use wifisyn_readwrite_types
      use wifisyn_uv_buffer
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(readwrite_t), intent(inout) :: do
      logical,           intent(inout) :: error
    end subroutine wifisyn_read_main
  end interface
  !
  interface
    subroutine wifisyn_read_uv(do,uv,error)
      use gbl_message
      use wifisyn_readwrite_types
      use wifisyn_uv_types
      !------------------------------------------------------------------
      ! @ private
      ! Read input UV header and data
      !------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(uv_t),        intent(inout) :: uv
      logical,           intent(inout) :: error
    end subroutine wifisyn_read_uv
  end interface
  !
  interface
    subroutine wifisyn_setup_command(line,error)
      use gbl_message
      use wifisyn_uv_buffer
      use wifisyn_sic_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_setup_command
  end interface
  !
  interface
    subroutine wifisyn_setup_main(user,uvin,map,uvout,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(sicmap_t), intent(in)    :: user
      type(uv_t),     intent(in)    :: uvin
      type(map_t),    intent(inout) :: map
      type(uv_t),     intent(inout) :: uvout
      logical,        intent(inout) :: error
    end subroutine wifisyn_setup_main
  end interface
  !
  interface
    subroutine wifisyn_setup_uvtmp(uvin,uvout,error)
      use gbl_message
      use wifisyn_uv_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(uv_t), intent(in)    :: uvin
      type(uv_t), intent(inout) :: uvout
      logical,    intent(inout) :: error
    end subroutine wifisyn_setup_uvtmp
  end interface
  !
  interface
    subroutine wifisyn_setup_map_and_shift_header(user,map,huv,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(sicmap_t),  intent(in)    :: user
      type(map_t),     intent(inout) :: map
      type(uv_head_t), intent(inout) :: huv
      logical,         intent(inout) :: error
    end subroutine wifisyn_setup_map_and_shift_header
  end interface
  !
  interface
    subroutine wifisyn_shift_command(line,error)
      use gbl_message
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      ! Entry point for command SHIFT
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_shift_command
  end interface
  !
  interface
    subroutine wifisyn_shift_parse(line,user_trans,user_shift,error)
      use gbl_message
      use wifisyn_buffer_parameters
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*),   intent(inout) :: line
      type(action_t),     intent(in)    :: user_trans
      type(user_shift_t), intent(out)   :: user_shift
      logical,            intent(inout) :: error
    end subroutine wifisyn_shift_parse
  end interface
  !
  interface
    subroutine wifisyn_shift_main(user_trans,user_shift,error)
      use gbl_message
      use wifisyn_transform_types
      use wifisyn_sic_buffer
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(action_t),     intent(in)    :: user_trans
      type(user_shift_t), intent(in)    :: user_shift
      logical,            intent(inout) :: error
    end subroutine wifisyn_shift_main
  end interface
  !
  interface
    subroutine wifisyn_shift_wifi_uv(idir,map,wifi,error)
      use gbl_message
      use phys_const
      use gkernel_types
      use wifisyn_transform_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,             intent(in)    :: idir
      type(map_t), target, intent(in)    :: map
      type(wifi_t),        intent(inout) :: wifi
      logical,             intent(inout) :: error
    end subroutine wifisyn_shift_wifi_uv
  end interface
  !
  interface
    subroutine wifisyn_shift_visi(idire,user,map,visi,error)
      use gbl_message
      use wifisyn_transform_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !  *** JP Should we change a0 and d0???
      !---------------------------------------------------------------------
      integer,            intent(in)    :: idire
      type(user_shift_t), intent(in)    :: user
      type(map_t),        intent(in)    :: map
      type(visi_t),       intent(inout) :: visi
      logical,            intent(inout) :: error
    end subroutine wifisyn_shift_visi
  end interface
  !
  interface
    subroutine wifisyn_shift_visi_set(map,visi,idire,user,shift,error)
      use gbl_message
      use phys_const
      use wifisyn_cube_types
      use wifisyn_transform_types
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(map_t), target, intent(in)    :: map
      type(visi_t),        intent(in)    :: visi
      integer,             intent(in)    :: idire
      type(user_shift_t),  intent(in)    :: user
      type(myshift_t),     intent(out)   :: shift
      logical,             intent(inout) :: error
    end subroutine wifisyn_shift_visi_set
  end interface
  !
  interface
    subroutine wifisyn_shift_visi_phase(shift,visi,error)
      use gbl_message
      use phys_const
      use gkernel_types
      use wifisyn_transform_types
      use wifisyn_cube_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(myshift_t), intent(in)    :: shift
      type(visi_t),    intent(inout) :: visi
      logical,         intent(inout) :: error
    end subroutine wifisyn_shift_visi_phase
  end interface
  !
  interface
    subroutine wifisyn_shift_visi_grid(shift,visi,error)
      use gbl_message
      use wifisyn_transform_types
      use wifisyn_cube_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(myshift_t), intent(in)    :: shift
      type(visi_t),    intent(inout) :: visi
      logical,         intent(inout) :: error
    end subroutine wifisyn_shift_visi_grid
  end interface
  !
  interface
    subroutine wifisyn_shift_uv_head(shift,htab,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! The output table has its U and V shifted and rotated
      ! All V values are flip to be negative
      ! UVMIN and UVMAX are computed
      !----------------------------------------------------------------------
      type(shift_t),   intent(inout) :: shift
      type(uv_head_t), intent(inout) :: htab
      logical,         intent(inout) :: error
    end subroutine wifisyn_shift_uv_head
  end interface
  !
  interface
    subroutine wifisyn_shift_uv_data(shift,tabin,tabout,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! The output UV table is a rotated, phase shifted copy of
      ! the input one
      !----------------------------------------------------------------------
      type(shift_t), intent(inout) :: shift
      type(uv_t),    intent(in)    :: tabin
      type(uv_t),    intent(inout) :: tabout
      logical,       intent(inout) :: error
    end subroutine wifisyn_shift_uv_data
  end interface
  !
  interface
    subroutine wifisyn_uvsort_command(line,error)
      use wifisyn_sort_types
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !	UVSORT [U|V|X|Y]
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_uvsort_command
  end interface
  !
  interface
    subroutine wifisyn_sort_getargs(line,args,error)
      use gbl_message
      use gio_params
      use wifisyn_gridding_types
      use wifisyn_sort_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      integer,          intent(out)   :: args(m_tot_key)
      logical,          intent(inout) :: error
    end subroutine wifisyn_sort_getargs
  end interface
  !
  interface
    subroutine wifisyn_set_index(ndata,sort,error)
      use gbl_message
      use wifisyn_gridding_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,      intent(in)    :: ndata
      type(sort_t), intent(out)   :: sort
      logical,      intent(inout) :: error ! Error status
    end subroutine wifisyn_set_index
  end interface
  !
  interface
    subroutine wifisyn_sort_index(args,sort,error)
      use gbl_message
      use gio_params
      use wifisyn_gridding_types
      use wifisyn_sort_buffer
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer,              intent(in)    :: args(m_tot_key)
      type(sort_t), target, intent(inout) :: sort
      logical,              intent(inout) :: error
    end subroutine wifisyn_sort_index
  end interface
  !
  interface
    function wifisyn_eq(m,l)
      use wifisyn_sort_buffer
      !---------------------------------------------------------------------
      ! @ private
      ! This routine is optimized because it is called many times
      ! Do not modify
      !---------------------------------------------------------------------
      logical             :: wifisyn_eq
      integer, intent(in) :: m ! Data #m
      integer, intent(in) :: l ! Data #l
    end function wifisyn_eq
  end interface
  !
  interface
    function wifisyn_ge(m,l)
      use wifisyn_sort_buffer
      !---------------------------------------------------------------------
      ! @ private
      ! This routine is optimized because it is called many times
      ! Do not modify
      !---------------------------------------------------------------------
      logical             :: wifisyn_ge
      integer, intent(in) :: m ! Data #m
      integer, intent(in) :: l ! Data #l
    end function wifisyn_ge
  end interface
  !
  interface
    function wifisyn_gt(m,l)
      use wifisyn_sort_buffer
      !---------------------------------------------------------------------
      ! @ private
      ! This routine is optimized because it is called many times
      ! Do not modify
      !---------------------------------------------------------------------
      logical             :: wifisyn_gt
      integer, intent(in) :: m ! Data #m
      integer, intent(in) :: l ! Data #l
    end function wifisyn_gt
  end interface
  !
  interface
    subroutine wifisyn_sort_head(sort,table,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_uv_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(sort_t), intent(in)    :: sort
      type(uv_t),   intent(inout) :: table
      logical,      intent(inout) :: error
    end subroutine wifisyn_sort_head
  end interface
  !
  interface
    subroutine wifisyn_sort_data(sort,tabin,tabout,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_uv_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(sort_t), intent(in)    :: sort
      type(uv_t),   intent(in)    :: tabin
      type(uv_t),   intent(inout) :: tabout
      logical,      intent(inout) :: error
    end subroutine wifisyn_sort_data
  end interface
  !
  interface
    subroutine wifisyn_statistics_command(line,error)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !     STATISTICS
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_statistics_command
  end interface
  !
  interface
    subroutine wifisyn_statistics_main(error)
      use gbl_message
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine wifisyn_statistics_main
  end interface
  !
  interface
    subroutine wifisyn_statistics_wifi(wifi,error)
      use gbl_message
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(wifi_t), intent(inout) :: wifi
      logical,      intent(inout) :: error
    end subroutine wifisyn_statistics_wifi
  end interface
  !
  interface
    subroutine wifisyn_uvbeam_command(line,error)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !     UVBEAM
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_uvbeam_command
  end interface
  !
  interface
    subroutine wifisyn_uvbeam_inter(error)
      use gbl_message
      use wifisyn_uv_buffer
      use wifisyn_cube_buffer
      use wifisyn_sic_buffer
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine wifisyn_uvbeam_inter
  end interface
  !
  interface
    subroutine wifisyn_uvbeam_main(win,uvin,uvout,map,wifi,dirty,error)
      use gbl_message
      use gkernel_types
      use wifisyn_buffer_parameters
      use wifisyn_gridding_types
      use wifisyn_uv_types
      use wifisyn_cube_types
      use wifisyn_uvbeam_types
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(window_t),      intent(in)    :: win
      type(uv_t),          intent(in)    :: uvin
      type(uv_t),          intent(inout) :: uvout
      type(map_t), target, intent(inout) :: map
      type(wifi_t),        intent(inout) :: wifi
      type(dirty_t),       intent(inout) :: dirty
      logical,             intent(inout) :: error
    end subroutine wifisyn_uvbeam_main
  end interface
  !
  interface
    subroutine wifisyn_reallocate_dirty_beam(map,dirty,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t),   intent(in)    :: map
      type(dirty_t), intent(inout) :: dirty
      logical,       intent(inout) :: error
    end subroutine wifisyn_reallocate_dirty_beam
  end interface
  !
  interface
    subroutine wifisyn_wifi_dirty_header(map,dirty,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      ! Should be merged with wifi_header *** JP
      !----------------------------------------------------------------------
      type(map_t),   intent(in)    :: map
      type(dirty_t), intent(inout) :: dirty
      logical,       intent(inout) :: error
    end subroutine wifisyn_wifi_dirty_header
  end interface
  !
  interface
    subroutine wifisyn_uvbeam_fill_uv(rchan,fwhm,sou,uv,error)
      use gbl_message
      use phys_const
      use gkernel_types
      use wifisyn_uv_types
      use wifisyn_gridding_types
      use wifisyn_uvbeam_types
      !----------------------------------------------------------------------
      ! @ private
      ! Note: This looks like the computation of clean component visibilities...
      !----------------------------------------------------------------------
      type(channel_t),     intent(in)    :: rchan
      type(scale_pairs_t), intent(in)    :: fwhm
      type(source_t),      intent(in)    :: sou
      type(uv_t),          intent(inout) :: uv
      logical,             intent(inout) :: error
    end subroutine wifisyn_uvbeam_fill_uv
  end interface
  !
  interface
    subroutine wifisyn_uvgrid_command(line,error)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    UVGRID
      !       1. /SHIFT
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_uvgrid_command
  end interface
  !
  interface
    subroutine wifisyn_uvgrid_inter(doshift,error)
      use gbl_message
      use wifisyn_uv_buffer
      use wifisyn_cube_buffer
      use wifisyn_sic_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical, intent(in)    :: doshift
      logical, intent(inout) :: error
    end subroutine wifisyn_uvgrid_inter
  end interface
  !
  interface
    subroutine wifisyn_uvgrid_main(doshift,win,uvin,uvout,map,wifi,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_uv_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical,        intent(in)    :: doshift
      type(window_t), intent(in)    :: win
      type(uv_t),     intent(in)    :: uvin
      type(uv_t),     intent(inout) :: uvout
      type(map_t),    intent(inout) :: map
      type(wifi_t),   intent(inout) :: wifi
      logical,        intent(inout) :: error
    end subroutine wifisyn_uvgrid_main
  end interface
  !
  interface
    subroutine wifisyn_reallocate_wifi(map,wifi,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t),  intent(in)    :: map
      type(wifi_t), intent(inout) :: wifi
      logical,      intent(inout) :: error
    end subroutine wifisyn_reallocate_wifi
  end interface
  !
  interface
    subroutine wifisyn_wifi_weight_header(map,wifi,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      ! Should be merged with wifi_header *** JP
      !----------------------------------------------------------------------
      type(map_t),  intent(in)    :: map
      type(wifi_t), intent(inout) :: wifi
      logical,      intent(inout) :: error
    end subroutine wifisyn_wifi_weight_header
  end interface
  !
  interface
    subroutine wifisyn_uvgrid_sort_and_weight(uvin,uvout,map,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(uv_t),  intent(in)    :: uvin
      type(uv_t),  intent(inout) :: uvout
      type(map_t), intent(inout) :: map
      logical,     intent(inout) :: error
    end subroutine wifisyn_uvgrid_sort_and_weight
  end interface
  !
  interface
    subroutine wifisyn_uvgrid_shift_sort_transpose_data(win,shift,sort,tabin,tabout,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! The output visibilities are a rotated, phase shifted, transposed, sorted
      ! copy of the input ones. This is the sorting and the transposition
      ! which makes it different from wifisyn_shift_uv_data. All the operations
      ! are grouped here to avoid copying 3 times the same data... Note that
      ! only the visibility are changed, the header data (U,V,X,Y,...)
      ! stays untouched. Weights are not carried over.
      !----------------------------------------------------------------------
      type(window_t),   intent(in)    :: win
      type(shift_t),    intent(inout) :: shift
      type(sort_t),     intent(inout) :: sort
      type(uv_t),       intent(in)    :: tabin
      type(uv_t),       intent(inout) :: tabout
      logical,          intent(inout) :: error
    end subroutine wifisyn_uvgrid_shift_sort_transpose_data
  end interface
  !
  interface
    subroutine wifisyn_uvmap_command(line,error)
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_uvmap_command
  end interface
  !
  interface
    subroutine wifisyn_uvmap_inter(error)
      use gbl_message
      use wifisyn_uv_buffer
      use wifisyn_cube_buffer
      use wifisyn_sic_buffer
      use wifisyn_transform_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine wifisyn_uvmap_inter
  end interface
  !
  interface
    subroutine wifisyn_uvmap_pipe(error)
      use gbl_message
      use wifisyn_uv_buffer
      use wifisyn_cube_buffer
      use wifisyn_sic_buffer
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine wifisyn_uvmap_pipe
  end interface
  !
  interface
    subroutine wifisyn_uvmap_cube_header(map,huv,itype,cube,error)
      use gbl_message
      use wifisyn_buffer_parameters
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !-----------------------------------------------------
      ! @ private
      ! Set beam or dirty header
      ! Note: Contrary to MAPPING, we here copy the projection information also
      !       in the beam header.
      !-----------------------------------------------------
      type(map_t),     intent(in)    :: map
      type(uv_head_t), intent(in)    :: huv
      integer,         intent(in)    :: itype ! cube type (beam or dirty)
      type (gildas),   intent(inout) :: cube
      logical,         intent(inout) :: error
    end subroutine wifisyn_uvmap_cube_header
  end interface
  !
  interface
    subroutine wifisyn_uvsym_command(line,error)
      use gbl_message
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_uvsym_command
  end interface
  !
  interface
    subroutine wifisyn_uvsym_check_wifi(wifi,error)
      use gbl_message
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(wifi_t), intent(inout) :: wifi
      logical,      intent(inout) :: error
    end subroutine wifisyn_uvsym_check_wifi
  end interface
  !
  interface
    subroutine wifisyn_uvsym_check_visi(visi,error)
      use gbl_message
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(visi_t), intent(inout) :: visi
      logical,      intent(inout) :: error
    end subroutine wifisyn_uvsym_check_visi
  end interface
  !
  interface
    subroutine wifisyn_uvswap_command(error)
      use wifisyn_uv_buffer
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      logical, intent(out) :: error
    end subroutine wifisyn_uvswap_command
  end interface
  !
  interface
    subroutine wifisyn_uvrt_sicdef(uvbuffer,uvname,error)
      use gbl_message
      use wifisyn_uv_buffer
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(uv_t),       intent(inout) :: uvbuffer
      character(len=3), intent(in)    :: uvname
      logical,          intent(out)   :: error
    end subroutine wifisyn_uvrt_sicdef
  end interface
  !
  interface
    subroutine wifisyn_free_uv(uv,error)
      use gbl_message
      use gio_params
      use wifisyn_uv_buffer
      !-------------------------------------------------------------------
      ! @ private
      ! Free a UV type
      ! Must not touch the Header, which may have been previously defined
      !-------------------------------------------------------------------
      type(uv_t), intent(inout) :: uv
      logical,    intent(inout) :: error
    end subroutine wifisyn_free_uv
  end interface
  !
  interface
    subroutine wifisyn_free_uvrt(error)
      use gbl_message
      use wifisyn_uv_buffer
      !-------------------------------------------------------------------
      ! @ private
      ! Free the UVRT buffers
      !-------------------------------------------------------------------
      logical,    intent(inout) :: error
    end subroutine wifisyn_free_uvrt
  end interface
  !
  interface
    subroutine wifisyn_reallocate_uvrt(ndata,nchan,order,error)
      use gbl_message
      use wifisyn_uv_buffer
      !-------------------------------------------------------------------
      ! @ private
      ! (Re)allocate pointers and targets for the UVR and UVT buffers
      ! The headers are not modified at all
      ! These buffers are always in the TUV order
      !-------------------------------------------------------------------
      integer,    intent(in)    :: ndata
      integer,    intent(in)    :: nchan
      integer,    intent(in)    :: order ! uvt or tuv
      logical,    intent(out)   :: error
    end subroutine wifisyn_reallocate_uvrt
  end interface
  !
  interface
    subroutine wifisyn_reallocate_uv_header(uv,ndata,error)
      use gbl_message
      use wifisyn_uv_buffer
      !-------------------------------------------------------------------
      ! @ private
      ! (Re)allocate uv header arrays
      ! The headers are not modified at all
      !-------------------------------------------------------------------
      type(uv_t), intent(inout) :: uv
      integer,    intent(in)    :: ndata
      logical,    intent(out)   :: error
    end subroutine wifisyn_reallocate_uv_header
  end interface
  !
  interface
    subroutine wifisyn_reallocate_uv_data(uv,ndata,nchan,order,error)
      use gbl_message
      use wifisyn_uv_buffer
      !-------------------------------------------------------------------
      ! @ private
      ! (Re)allocate uv data arrays
      ! Do nothing when the array sizes did not changed
      !-------------------------------------------------------------------
      type(uv_t), intent(inout) :: uv
      integer,    intent(in)    :: ndata
      integer,    intent(in)    :: nchan
      integer,    intent(in)    :: order ! uvt or tuv
      logical,    intent(out)   :: error
    end subroutine wifisyn_reallocate_uv_data
  end interface
  !
  interface
    subroutine wifisyn_reallocate_uv(uv,ndata,nchan,order,error)
      use gbl_message
      use wifisyn_uv_buffer
      !-------------------------------------------------------------------
      ! @ private
      ! (Re)allocate uv header and data arrays
      !-------------------------------------------------------------------
      type(uv_t), intent(inout) :: uv
      integer,    intent(in)    :: ndata
      integer,    intent(in)    :: nchan
      integer,    intent(in)    :: order ! tuv or uvt
      logical,    intent(out)   :: error
    end subroutine wifisyn_reallocate_uv
  end interface
  !
  interface
    subroutine wifisyn_read_uv_header(do,uv,ndata,nchan,nc,error)
      use gbl_message
      use wifisyn_readwrite_types
      use wifisyn_uv_types
      !------------------------------------------------------------------
      ! @ private
      ! Read input UV header
      !------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(uv_t),        intent(inout) :: uv
      integer,           intent(out)   :: ndata
      integer,           intent(out)   :: nchan
      integer,           intent(out)   :: nc(2)
      logical,           intent(inout) :: error
    end subroutine wifisyn_read_uv_header
  end interface
  !
  interface
    subroutine wifisyn_read_uv_data(uv,ndata,nchan,nc,error)
      use gbl_message
      use wifisyn_uv_types
      !-------------------------------------------------------------------
      ! @ private
      ! Read uv data
      !-------------------------------------------------------------------
      type(uv_t), intent(inout) :: uv
      integer,    intent(in)    :: ndata
      integer,    intent(in)    :: nchan
      integer,    intent(in)    :: nc(2)
      logical,    intent(out)   :: error
    end subroutine wifisyn_read_uv_data
  end interface
  !
  interface
    subroutine wifisyn_write_uv_header(do,uv,error)
      use gbl_message
      use gildas_def
      use wifisyn_readwrite_types
      use wifisyn_uv_types
      !------------------------------------------------------------------
      ! @ private
      ! Write UV header
      !------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(uv_t),        intent(inout) :: uv
      logical,           intent(inout) :: error
    end subroutine wifisyn_write_uv_header
  end interface
  !
  interface
    subroutine wifisyn_write_uv_data(do,uv,error)
      use gbl_message
      use wifisyn_readwrite_types
      use wifisyn_uv_types
      !-------------------------------------------------------------------
      ! @ private
      ! Write uv data
      !-------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(uv_t),        intent(inout) :: uv
      logical,           intent(inout) :: error
    end subroutine wifisyn_write_uv_data
  end interface
  !
  interface
    subroutine wifisyn_write_uv(do,uv,error)
      use gbl_message
      use gildas_def
      use wifisyn_readwrite_types
      use wifisyn_uv_types
      !------------------------------------------------------------------
      ! @ private
      ! Read input UV header
      !------------------------------------------------------------------
      type(readwrite_t), intent(in)    :: do
      type(uv_t),        intent(inout) :: uv
      logical,           intent(inout) :: error
    end subroutine wifisyn_write_uv
  end interface
  !
  interface
    subroutine wifisyn_copy_uv_header(in,out,error)
      use gbl_message
      use wifisyn_uv_types
      !------------------------------------------------------------------
      ! @ private
      ! Copy header information
      !------------------------------------------------------------------
      type(uv_t), intent(in)    :: in
      type(uv_t), intent(inout) :: out
      logical,    intent(inout) :: error
    end subroutine wifisyn_copy_uv_header
  end interface
  !
  interface
    subroutine wifisyn_variable_command(line,error)
      use gbl_message
      use wifisyn_parameters
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    VARIABLE
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_variable_command
  end interface
  !
  interface
    subroutine wifisyn_weighting_extract_sort(wchan,tabin,sort,weight,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! Extract the used weights from the input data
      !----------------------------------------------------------------------
      integer,        intent(in)    :: wchan
      type(uv_t),     intent(in)    :: tabin
      type(sort_t),   intent(in)    :: sort
      type(weight_t), intent(out)   :: weight
      logical,        intent(inout) :: error
    end subroutine wifisyn_weighting_extract_sort
  end interface
  !
  interface
    subroutine wifisyn_weighting_taper(htab,taper,modwei,error)
      use gbl_message
      use phys_const
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! Taper the weights of the visibility points
      !----------------------------------------------------------------------
      type(uv_head_t), intent(in)    :: htab
      type(taper_t),   intent(in)    :: taper
      type(real_1d_t), intent(inout) :: modwei
      logical,         intent(inout) :: error
    end subroutine wifisyn_weighting_taper
  end interface
  !
  interface
    subroutine wifisyn_weighting_noise(weight,noise,error)
      use gbl_message
      use wifisyn_uv_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! Compute and print natural and weighted/tapered noise levels
      ! The formula used to compute the weighted/tapered noise comes from
      ! Thompson et al. Interferometry and Synthesis in Radio Astronomy
      ! (section "Response to the noise")
      !----------------------------------------------------------------------
      type(weight_t),  intent(in)    :: weight
      type(noise_t),   intent(out)   :: noise
      logical,         intent(inout) :: error
    end subroutine wifisyn_weighting_noise
  end interface
  !
  interface
    subroutine wifisyn_weighting_print_noise(cname,wmode,wsum,noise)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(in)  :: cname
      character(len=*), intent(in)  :: wmode
      real(kind=8),     intent(in)  :: wsum
      real(kind=4),     intent(out) :: noise
    end subroutine wifisyn_weighting_print_noise
  end interface
  !
  interface
    subroutine wifisyn_wifi2visi_command(line,error)
      use gbl_message
      use wifisyn_sic_buffer
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_wifi2visi_command
  end interface
  !
  interface
    subroutine wifisyn_wifi2visi_main(map,wifi,visi,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(map_t),     intent(in)    :: map
      type(wifi_t),    intent(in)    :: wifi
      type(visi_t),    intent(inout) :: visi
      logical,         intent(inout) :: error
    end subroutine wifisyn_wifi2visi_main
  end interface
  !
  interface
    subroutine wifisyn_visi_wei_header(map,visi,error)
      use gbl_message
      use wifisyn_gridding_types
      use wifisyn_cube_types
      !----------------------------------------------------------------------
      ! @ private
      ! This one should be merged with wifisyn_wifi_header *** JP
      !----------------------------------------------------------------------
      type(map_t),     intent(in)    :: map
      type(visi_t),    intent(inout) :: visi
      logical,         intent(inout) :: error
    end subroutine wifisyn_visi_wei_header
  end interface
  !
  interface
    subroutine wifisyn_wifi2visi_average(axes,wifi,visi,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(axis_t), intent(in)    :: axes(2)
      type(wifi_t), intent(in)    :: wifi
      type(visi_t), intent(inout) :: visi
      logical,      intent(inout) :: error
    end subroutine wifisyn_wifi2visi_average
  end interface
  !
  interface
    subroutine wifisyn_wifi2visi_average_and_symmetry(axes,wifi,visi,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(axis_t), intent(in)    :: axes(2)
      type(wifi_t), intent(in)    :: wifi
      type(visi_t), intent(inout) :: visi
      logical,      intent(inout) :: error
    end subroutine wifisyn_wifi2visi_average_and_symmetry
  end interface
  !
  interface
    subroutine wifisyn_wifi2visi_shift_and_sum(axes,wifi,visi,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(axis_t), intent(in)    :: axes(2)
      type(wifi_t), intent(in)    :: wifi
      type(visi_t), intent(inout) :: visi
      logical,      intent(inout) :: error
    end subroutine wifisyn_wifi2visi_shift_and_sum
  end interface
  !
  interface
    subroutine wifisyn_wifi2visi_sum(axes,wifi,visi,error)
      use gbl_message
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      ! *** JP This requires the same us and uf axes to actually work...
      !----------------------------------------------------------------------
      type(axis_t), intent(in)    :: axes(2)
      type(wifi_t), intent(in)    :: wifi
      type(visi_t), intent(inout) :: visi
      logical,      intent(inout) :: error
    end subroutine wifisyn_wifi2visi_sum
  end interface
  !
  interface
    subroutine wifisyn_write_command(line,error)
      use gbl_message
      use wifisyn_readwrite_types
      !----------------------------------------------------------------------
      ! @ private
      ! Support routine for command WRITE
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line
      logical,          intent(inout) :: error
    end subroutine wifisyn_write_command
  end interface
  !
  interface
    subroutine wifisyn_write_main(do,error)
      use gbl_message
      use wifisyn_readwrite_types
      use wifisyn_sic_buffer
      use wifisyn_uv_buffer
      use wifisyn_cube_buffer
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(readwrite_t), intent(inout) :: do
      logical,           intent(inout) :: error
    end subroutine wifisyn_write_main
  end interface
  !
  interface
    subroutine wifisyn_uvgrid_convolve(win,map,visitab,wifi,error)
      use gbl_message
      use phys_const
      use gkernel_types
      use wifisyn_uv_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(window_t),         intent(in)    :: win
      type(map_t),    target, intent(in)    :: map
      type(uv_t),             intent(in)    :: visitab
      type(wifi_t),           intent(inout) :: wifi
      logical,                intent(inout) :: error
    end subroutine wifisyn_uvgrid_convolve
  end interface
  !
  interface
    subroutine wifisyn_uvgrid_shift(win,map,visitab,wifi,error)
      use gbl_message
      use phys_const
      use gkernel_types
      use wifisyn_uv_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(window_t),         intent(in)    :: win
      type(map_t),    target, intent(in)    :: map
      type(uv_t),             intent(in)    :: visitab
      type(wifi_t),           intent(inout) :: wifi
      logical,                intent(inout) :: error
    end subroutine wifisyn_uvgrid_shift
  end interface
  !
  interface
    subroutine wifisyn_uvgrid_shift_unshift(win,map,visitab,wifi,error)
      use gbl_message
      use phys_const
      use gkernel_types
      use wifisyn_uv_types
      use wifisyn_cube_types
      use wifisyn_gridding_types
      !----------------------------------------------------------------------
      ! @ private
      !----------------------------------------------------------------------
      type(window_t),         intent(in)    :: win
      type(map_t),    target, intent(in)    :: map
      type(uv_t),             intent(in)    :: visitab
      type(wifi_t),           intent(inout) :: wifi
      logical,                intent(inout) :: error
    end subroutine wifisyn_uvgrid_shift_unshift
  end interface
  !
end module wifisyn_interfaces_private

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine define_sic_xymap(error)
  use gildas_def
  use gkernel_interfaces
  use xymap_def
  !---------------------------------------------------------------------
  ! @ private
  ! MAP Internal routine
  !---------------------------------------------------------------------
  logical, intent(out) :: error     ! Error status
  !
  if (.not.sic_varexist('map')) then
     call sic_defstructure('map%',.true.,error)
     call sic_def_char('map%tele',sic_xymap_user%tele,.false.,error)
     call sic_def_real('map%diam',sic_xymap_user%diam,0,0,.false.,error)
     call sic_def_real('map%beam',sic_xymap_user%beam,0,0,.false.,error)
     call sic_def_real('map%support',sic_xymap_user%support,1,2,.false.,error)
     call sic_def_inte('map%ctype',sic_xymap_user%ctype,0,0,.false.,error)
     call sic_def_char('map%like',sic_xymap_user%like,.false.,error)
     call sic_def_inte('map%ptype',sic_xymap_user%ptype,0,0,.false.,error)
     call sic_def_char('map%dec',sic_xymap_user%dec,.false.,error)
     call sic_def_char('map%ra',sic_xymap_user%ra,.false.,error)
     call sic_def_dble('map%angle',sic_xymap_user%pang,0,0,.false.,error)
     call sic_def_logi('map%shift',sic_xymap_user%shift,.false.,error)
     call sic_def_real('map%tole',sic_xymap_user%tole,0,0,.false.,error)
     call sic_def_real('map%reso',sic_xymap_user%reso,1,2,.false.,error)
     call sic_def_real('map%cell',sic_xymap_user%cell,1,2,.false.,error)
     call sic_def_inte('map%size',sic_xymap_user%size,1,2,.false.,error)
     call sic_def_inte('map%wcol',sic_xymap_user%wcol,0,0,.false.,error)
     call sic_def_inte('map%col',sic_xymap_user%col,1,2,.false.,error)
  endif
  !
end subroutine define_sic_xymap
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine init_xymap_struct(xymap)
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  ! MAP Internal routine
  !---------------------------------------------------------------------
  type(xymap_user_t), intent(out) :: xymap  !
  !
  xymap%xcol = 1
  xymap%ycol = 2
  xymap%wcol = 3
  xymap%col(1) = 4
  xymap%col(2) = 0
  xymap%size  = 0.
  xymap%cell  = 0.
  xymap%pang  = 0d0
  xymap%shift = .false.
  xymap%ptype = p_none
  xymap%ra   = ""
  xymap%dec  = ""
  xymap%like = ""
  xymap%wmode = "NATURAL"
  xymap%ctype = ctype_gaussian
  xymap%support = 0.
  xymap%reso = 0.
  xymap%beam = 0.
  xymap%diam = 0.
  xymap%tele = ""
  !
end subroutine init_xymap_struct
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine xymap(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! MAP Support routine for command
  !     XY_MAP [TableName]
  ! 1          [/NOGRID]
  ! 2          [/TYPE LMV|VLM|...]
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  logical :: nogrid
  integer(kind=4) :: nc
  character(len=4) :: otype
  character(len=filename_length) :: cubename
  !
  ! Ideally 'tablename' should be the only saved parameter.
  ! All other parameters should be deduced from the old cube.
  ! This way, we ensure that the user can achieve the same results
  ! between two consecutive sessions.
  character(len=filename_length), save :: tablename
  !
  ! Parse input line for XY_MAP options
  if (sic_present(0,1)) then  ! Get table name
    nc = 0
    call sic_ch(line,0,1,tablename,nc,.true.,error)
    if (error) return
  else  ! No table name => Current table
    if (tablename.eq.'') then
      call class_message(seve%e,rname,'Empty filename')
      error = .true.
      return
    endif
  endif
  !
  ! Optionally get cube name (blank will reuse table name prefix)
  cubename = ''
  call sic_ch(line,0,2,cubename,nc,.false.,error)
  if (error) return
  !
  ! Parse input line for /NOGRID option
  if (sic_present(1,0)) then
     nogrid = .true.
  else
     nogrid = .false.
  endif
  !
  ! /TYPE
  otype = 'LMV'  ! Default
  call sic_ke(line,2,1,otype,nc,.false.,error)
  if (error) return
  !
  call sub_xymap(tablename,cubename,nogrid,otype,error)
  if (error) return
  !
end subroutine xymap
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine sub_xymap(tablename,cubename,nogrid,lmvcode,error)
  use gbl_message
  use gildas_def
  use image_def
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>sub_xymap
  use xymap_def
  !---------------------------------------------------------------------
  ! @ private
  ! Do the job
  !------------------------------------------------------------------------
  character(len=*), intent(in)  :: tablename  ! Name of input table
  character(len=*), intent(in)  :: cubename   ! Name of output cube
  logical,          intent(in)  :: nogrid     ! Do not convolve, just place
  character(len=*), intent(in)  :: lmvcode    ! LMV or VLM or any...
  logical,          intent(out) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  type(xymap_user_t) :: xymap_user  ! Local version of sic_xymap_user
  type(xymap_prog_t) :: map         ! Gridding parameters
  character(len=filename_length) :: prefixname
  !
  ! Timing
  call gag_cputime_init(map%time%total)
  call gag_cputime_init(map%time%read)
  call gag_cputime_init(map%time%sort)
  call gag_cputime_init(map%time%tran)
  call gag_cputime_init(map%time%conv)
  call gag_cputime_init(map%time%writ)
  !
  ! General initialization
  error = .false.
  xymap_user = sic_xymap_user
  !
  call table_open(tablename,prefixname,map%tab,error)
  if (error)  goto 100
  !
  ! Sanity checks
  call check_table_format(xymap_user,map,error)
  if (error)  goto 100
  !
  ! Define gridding parameters (grid + convolution function)
  ! During this step, the table coordinates are rotated and sorted
  ! and the weight array is extracted
  call define_gridding_parameters(xymap_user,map,map%tab%hmem,nogrid,error)
  if (error)  goto 100
  call print_gridding_parameters(map)
  !
  if (cubename.eq.'') then
    call table_to_cube_headers(map,prefixname,lmvcode,error)
  else
    call table_to_cube_headers(map,cubename,lmvcode,error)
  endif
  if (error)  goto 100
  !
  ! Grid data and weights
  call table_to_cube_data(map,nogrid,error)
  if (error)  goto 100
  !
100 continue
  call my_close_image(map%tab%hdisk,error)
  if (error)  continue
  !
  ! Free memory
  if (allocated(map%tab%data))  deallocate(map%tab%data)
  if (allocated(map%tab%buff))  deallocate(map%tab%buff)
  if (allocated(map%tab%x))     deallocate(map%tab%x,map%tab%y,map%tab%w)
  if (allocated(map%tab%sort))  deallocate(map%tab%sort)
  if (allocated(map%cub%data))  deallocate(map%cub%data)
  if (allocated(map%cub%buff))  deallocate(map%cub%buff)
  if (allocated(map%cub%dout))  deallocate(map%cub%dout)
  if (allocated(map%cub%dwei))  deallocate(map%cub%dwei)
  !
  if (error)  return
  !
  ! Success: print timing statistics
  call gag_cputime_get(map%time%total)  ! Get total command time
  call print_cputime_feedback(map%time)
  !
end subroutine sub_xymap
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine table_open(tablename,prefixname,tab,error)
  use image_def
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>table_open
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !  Read the table header
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: tablename   ! Table name e.g. 'foo.tab'
  character(len=*),  intent(out)   :: prefixname  ! Prefix shared with the cube e.g. 'foo'
  type(xymap_tab_t), intent(inout) :: tab         !
  logical,           intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  integer(kind=4) :: nl
  !
  ! Read table header
  nl = len_trim(tablename)
  if (nl.le.0) then
    call class_message(seve%e,rname,'Empty filename')
    error = .true.
    return
  endif
  !
  call gildas_null(tab%hdisk)
  !
  ! Table name and prefix for the future cube
  if (nl.ge.5 .and. (tablename(nl-3:).eq.'.tab' .or. tablename(nl-3:).eq.'.bat')) then
    ! Explicit extension provided by the user. Still need decoding e.g.
    ! sic logicals
    call sic_parse_file(tablename,'','',tab%hdisk%file)
  else
    ! No extension: first try a .bat table
    call sic_parse_file(tablename,' ','.bat',tab%hdisk%file)
    if (gag_inquire(tab%hdisk%file,len_trim(tab%hdisk%file)).ne.0) then
      ! Else try default .tab
      call sic_parse_file(tablename,' ','.tab',tab%hdisk%file)
    endif
  endif
  ! Check if table exists
  nl = len_trim(tab%hdisk%file)
  if (gag_inquire(tab%hdisk%file,nl).ne.0) then
    call class_message(seve%e,rname,'No such file '//tab%hdisk%file)
    error = .true.
    return
  endif
  prefixname = tab%hdisk%file(1:nl-4)  ! Strip off .bat or .tab
  !
  ! Read disk header
  call gdf_read_header(tab%hdisk,error)
  if (gildas_error(tab%hdisk,rname,error)) return
  tab%velofirst = tab%hdisk%gil%faxi.eq.1
  !
  ! Set up memory header
  call gildas_null(tab%hmem)
  if (tab%velofirst) then
    ! Same header
    call gdf_copy_header(tab%hdisk,tab%hmem,error)
    if (error)  return
  else
    ! Transpose header
    call gdf_transpose_header(tab%hdisk,tab%hmem,'21',error)
    if (error)  return
  endif
  !
end subroutine table_open
!
subroutine table_read_xyw(tab,time,error)
  use gbl_message
  use gkernel_types
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>table_read_xyw
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the X, Y, and weights arrays
  !---------------------------------------------------------------------
  type(xymap_tab_t), intent(inout) :: tab
  type(cputime_t),   intent(inout) :: time
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  character(len=message_length) :: mess
  integer(kind=index_length), parameter :: one=1
  integer(kind=4) :: ier
  real(kind=4), allocatable :: buff(:,:)
  !
  call class_message(seve%i,rname,'Reading columns X Y W')
  !
  call gag_cputime_init(time)
  !
  ! Sanity checks
  if (tab%xcol.ne.1) then
    write(mess,*) 'X column at position ',tab%xcol,' is not implemented'
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  if (tab%ycol.ne.2) then
    write(mess,*) 'Y column at position ',tab%ycol,' is not implemented'
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (allocated(tab%x))  deallocate(tab%x,tab%y,tab%w)
  allocate(tab%x(tab%nposi),tab%y(tab%nposi),tab%w(tab%nposi),stat=ier)
  if (failed_allocate(rname,'XYW columns',ier,error))  return
  !
  ! For .tab/vxy tables, the X values are not contiguous in memory. Same
  ! for Y and W. In order to avoid traversing the file 3 times, read the
  ! 3 columns at once
  if (tab%wcol.eq.tab%ycol+1) then
    ! X Y W are contiguous
    if (tab%velofirst) then
      allocate(buff(3,tab%nposi),stat=ier)
      call read_vector(tab%xcol,tab%wcol,buff,error)
      if (error)  return
      ! Non contiguous copies, this is done once and then we are done
      tab%x(:) = buff(tab%xcol,:)
      tab%y(:) = buff(tab%ycol,:)
      tab%w(:) = buff(tab%wcol,:)
    else
      allocate(buff(tab%nposi,3),stat=ier)
      call read_vector(tab%xcol,tab%wcol,buff,error)
      if (error)  return
      ! Contiguous copies
      tab%x(:) = buff(:,tab%xcol)
      tab%y(:) = buff(:,tab%ycol)
      tab%w(:) = buff(:,tab%wcol)
    endif
    deallocate(buff)
    !
  else
    ! W is "somewhere else", in the table or no where at all. Split
    ! the job. First X and Y:
    if (tab%velofirst) then
      allocate(buff(2,tab%nposi),stat=ier)
      call read_vector(tab%xcol,tab%ycol,buff,error)
      if (error)  return
      ! Non contiguous copies, this is done once and then we are done
      tab%x(:) = buff(tab%xcol,:)
      tab%y(:) = buff(tab%ycol,:)
    else
      allocate(buff(tab%nposi,2),stat=ier)
      call read_vector(tab%xcol,tab%ycol,buff,error)
      if (error)  return
      ! Contiguous copies
      tab%x(:) = buff(:,tab%xcol)
      tab%y(:) = buff(:,tab%ycol)
    endif
    deallocate(buff)
    ! W?
    if (tab%wcol.ge.1 .or. tab%wcol.le.tab%ndata) then
      call read_vector(tab%wcol,tab%wcol,tab%w,error)
      if (error)  return
    else
      ! Weight column does not exist => Set all weights to 1
      tab%w(:) = 1.0
      write(mess,*) 'Weight column ',tab%wcol,' is outside the column range'
      call class_message(seve%i,rname,mess)
    endif
  endif
  !
  call gag_cputime_get(time)
  !
contains
  subroutine read_vector(first,last,val,error)
    integer(kind=index_length), intent(in)    :: first,last
    real(kind=4),               intent(out)   :: val(*)
    logical,                    intent(inout) :: error
    !
    if (tab%velofirst) then
      tab%hdisk%blc(1:2) = (/ first,      one /)
      tab%hdisk%trc(1:2) = (/  last,tab%nposi /)
    else
      tab%hdisk%blc(1:2) = (/       one,first /)
      tab%hdisk%trc(1:2) = (/ tab%nposi, last /)
    endif
    call gdf_read_data(tab%hdisk,val,error)
    ! if (error)  continue
    ! Reset to avoid later troubles
    tab%hdisk%blc(:) = 0
    tab%hdisk%trc(:) = 0
  end subroutine read_vector
  !
end subroutine table_read_xyw
!
subroutine table_read_data(tab,v1,v2,time,error)
  use gbl_message
  use gkernel_types
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>table_read_data
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  ! Read the data in order VELOCITY - POSITION
  !---------------------------------------------------------------------
  type(xymap_tab_t),          intent(inout) :: tab
  integer(kind=index_length), intent(in)    :: v1,v2  ! [chan] Range to read
  type(xymap_time_t),         intent(inout) :: time   !
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  integer(kind=index_length) :: iposi,first,last
  integer(kind=index_length), parameter :: one=1
  character(len=message_length) :: mess
  type(cputime_t) :: tmp
  !
  if (v1.lt.1 .or. v2.gt.tab%ndata .or. v1.gt.v2) then
    write(mess,'(2(A,I0))') 'Invalid channel range: ',v1,' to ',v2
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  tab%nchan = v2-v1+1
  if (tab%wcol.eq.3) then
    first = v1+3
    last = v2+3
  else
    first = v1+2
    last = v2+2
  endif
  !
  call reallocate_tab(tab%data,tab%nchan,tab%nposi,error)
  if (error)  return
  !
  ! Transpose table if needed: the gridding algorithm works in
  ! order [VELOCITY,POSITION]
  if (tab%velofirst) then
    ! Order is correct, read the table as is
    tab%hdisk%blc(1:2) = (/ first,       one /)
    tab%hdisk%trc(1:2) = (/ last,  tab%nposi /)
    call class_message(seve%d,rname,'Reading table...')
    call gag_cputime_init(tmp)
    call gdf_read_data(tab%hdisk,tab%data,error)
    if (gildas_error(tab%hdisk,rname,error))  return
    call gag_cputime_add(time%read,tmp)
    !
  else
    ! Needs transposition. Do it in memory
    tab%hdisk%blc(1:2) = (/       one,first /)
    tab%hdisk%trc(1:2) = (/ tab%nposi, last /)
    ! Read data
    call class_message(seve%d,rname,'Reading table...')
    call gag_cputime_init(tmp)
    call reallocate_tab(tab%buff,tab%nposi,tab%nchan,error)
    if (error)  return
    call gdf_read_data(tab%hdisk,tab%buff,error)
    if (gildas_error(tab%hdisk,rname,error))  return
    call gag_cputime_add(time%read,tmp)
    ! Transpose data. ZZZ check most efficient order
    call class_message(seve%d,rname,'Transposing table...')
    call gag_cputime_init(tmp)
    do iposi=1,tab%nposi
      tab%data(:,iposi) = tab%buff(iposi,:)
    enddo
    call gag_cputime_add(time%tran,tmp)
  endif
  !
end subroutine table_read_data
!
subroutine my_close_image(h,error)
  use image_def
  use classmap_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !  GDF-close the input GDF image, if it is opened
  !  Input error status is also preserved on output
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: h
  logical,      intent(inout) :: error
  ! Local
  logical :: error2
  !
  ! Do nothing if image is not yet opened (e.g. on error recovery)
  if (h%loca%islo.eq.0)  return
  !
  error2 = .false.
  call gdf_close_image(h,error2)
  if (gildas_error(h,'XY_MAP',error2))  error = .true.
  !
end subroutine my_close_image
!
subroutine check_table_format(xymap_user,map,error)
  use gbl_message
  use image_def
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  ! MAP internal routine
  !---------------------------------------------------------------------
  type(xymap_user_t), intent(in)    :: xymap_user  ! Input user parameters
  type(xymap_prog_t), intent(inout) :: map         ! Gridding parameters
  logical,            intent(out)   :: error       ! Return status
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  character(len=message_length) :: mess
  integer(kind=4) :: tmp
  !
  ! Initialization
  error = .false.
  !
  ! Table format. Must be velo first / position second in memory.
  if (map%tab%hmem%gil%faxi.eq.1) then
    map%tab%ndata = map%tab%hmem%gil%dim(1)
    map%tab%nposi = map%tab%hmem%gil%dim(2)
  else
    write(mess,'(A,I0)')  'Unexpected frequency axis: ',map%tab%hmem%gil%faxi
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Column of X coordinates
  if (xymap_user%xcol.ne.0) then
     map%tab%xcol = xymap_user%xcol
  else
     map%tab%xcol = 1
  endif
  if (map%tab%xcol.lt.1 .or. map%tab%xcol.gt.map%tab%ndata) then
     write(mess,*) 'X column #',map%tab%xcol,' does not exist'
     call class_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  ! Column of Y coordinates
  if (xymap_user%ycol.ne.0) then
     map%tab%ycol = xymap_user%ycol
  else
     map%tab%ycol = 2
  endif
  if (map%tab%ycol.lt.1 .or. map%tab%ycol.gt.map%tab%ndata) then
     write(mess,*) 'Y column #',map%tab%ycol,' does not exist'
     call class_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  ! Column of weight
  if (xymap_user%wcol.ne.0) then
     map%tab%wcol = xymap_user%wcol
  else
     map%tab%wcol = 3
  endif
  if (map%tab%wcol.lt.1 .or. map%tab%wcol.gt.map%tab%ndata) then
     write(mess,*) 'Weight column #',map%tab%wcol,' does not exist'
     call class_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  ! First column of data (absolute position in table)
  if (xymap_user%col(1).ne.0) then
     map%col(1) = xymap_user%col(1)
  else
     map%col(1) = 4
  endif
  if (map%col(1).lt.1 .or. map%col(1).gt.map%tab%ndata) then
     write(mess,*) 'Data column #',map%col(1),' does not exist'
     call class_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  ! Last column of data (absolute position in table)
  if (xymap_user%col(2).ne.0) then
     map%col(2) = xymap_user%col(2)
  else
     map%col(2) = map%tab%ndata
  endif
  if (map%col(2).lt.1 .or. map%col(2).gt.map%tab%ndata) then
     write(mess,*) 'Data column #',map%col(2),' does not exist'
     call class_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  ! Protection against wrong ordering
  if (map%col(1).gt.map%col(2)) then
    tmp = map%col(1)
    map%col(1) = map%col(2)
    map%col(2) = tmp
  endif
  !
end subroutine check_table_format
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reproject_table(tab,system,                        &
                           oldproj,olda0,oldd0,oldangle,      &
                           newproj,newa0,newd0,newangle,error)
  use phys_const
  use gbl_constant
  use gbl_message
  use gkernel_types
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>reproject_table
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  ! Shift-rotate-reproject the table coordinates with a new projection
  ! type and/or new projection center and/or new projection angle.
  !---------------------------------------------------------------------
  type(xymap_tab_t), intent(inout) :: tab          !
  character(len=*),  intent(in)    :: system       ! Coordinate system (for feedback)
  integer(kind=4),   intent(in)    :: oldproj      ! Table projection code
  real(kind=8),      intent(in)    :: olda0,oldd0  ! Table projection center
  real(kind=8),      intent(in)    :: oldangle     ! Table projection angle
  integer(kind=4),   intent(in)    :: newproj      ! Map projection code
  real(kind=8),      intent(in)    :: newa0,newd0  ! Map projection center
  real(kind=8),      intent(in)    :: newangle     ! Map projection angle
  logical,           intent(inout) :: error        ! Returned status
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  character(len=16) :: newa0c,newd0c
  character(len=message_length) :: mess
  type(projection_t) :: oproj,nproj
  integer(kind=4) :: ier
  real(kind=8), allocatable :: xbuf(:),ybuf(:)
  !
  ! ZZZ Ensure early exit if nothing changed! Add some tolerance e.g. on the
  ! center (remember user gives sexag strings and we compare them with r*8)?
  !
  ! We came here because at least one of A0 and/or D0 and/or ANGLE have
  ! changed. Feedback:
  if (system.eq.'EQUATORIAL') then
    call sexag(newa0c,newa0,24)
  else
    call sexag(newa0c,newa0,360)
  endif
  call sexag(newd0c,newd0,360)
  write(mess,'(A,A,1X,A,A,F0.1)')  'Reproject for center ',trim(newa0c),  &
    trim(newd0c),' with angle ',newangle*deg_per_rad
  call class_message(seve%i,rname,mess)
  !
  ! Setup Input projection
  call gwcs_projec(olda0,oldd0,oldangle,oldproj,oproj,error)
  if (error)  return
  !
  ! Setup Output projection
  call gwcs_projec(newa0,newd0,newangle,newproj,nproj,error)
  if (error)  return
  !
  ! Allocate temporary R*8 buffers needed by rel_to_abs and abs_to_rel.
  allocate(xbuf(tab%nposi),ybuf(tab%nposi),stat=ier)
  if (failed_allocate(rname,'coordinate buffers',ier,error))  return
  !
  ! Convert to absolute coordinates. Note that the subroutine allows to
  ! use the same buffers as input and output.
  xbuf(:) = tab%x(1:tab%nposi)
  ybuf(:) = tab%y(1:tab%nposi)
  call rel_to_abs(oproj,xbuf,ybuf,xbuf,ybuf,tab%nposi)
  !
  ! Convert to new projection. Note that the subroutine allows to
  ! use the same buffers as input and output.
  call abs_to_rel(nproj,xbuf,ybuf,xbuf,ybuf,tab%nposi)
  tab%x(1:tab%nposi) = xbuf(:)
  tab%y(1:tab%nposi) = ybuf(:)
  !
  deallocate(xbuf,ybuf)
  !
end subroutine reproject_table
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine define_gridding_parameters(xymap_user,map,hin,nogrid,error)
  use phys_const
  use image_def
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>define_gridding_parameters
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  ! MAP internal routine
  ! Compute the map characterictics:
  !  - resolution
  !  - position angle
  !  - pixel size
  !  - gridding function (if not placing)
  !  - map size
  !  - axes
  ! either from (in priority order):
  !  - xymap_user% (i.e. elements of SIC structure map% customized by user)
  !  - xymap_user%like (another map used as reference)
  !  - data positions (if placing is used)
  !  - defaults
  !---------------------------------------------------------------------
  type(xymap_user_t), intent(inout) :: xymap_user  ! Input user parameters
  type(xymap_prog_t), intent(inout) :: map         ! Gridding parameters
  type(gildas),       intent(in)    :: hin         ! Input table header
  logical,            intent(in)    :: nogrid      ! Use placing instead of gridding
  logical,            intent(out)   :: error       ! Return status
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  type(gildas) :: href
  logical :: use_ref,reproject,found,error2,warn
  character(len=filename_length) :: ref_name
  character(len=message_length) :: mess
  real(kind=4) :: xmin,xmax,ymin,ymax,xinc,yinc
  real(kind=4) :: fwhm(2)
  integer(kind=4) :: ndiv
  real(kind=8) :: r8
  !
  ! Initialization
  error = .false.
  use_ref = .false.
  reproject = .false.
  !
  ! Take care of the possibility to choose the grid from a reference file
  if (xymap_user%like.ne.'') then
     ! From reference lmv cube
     use_ref = .true.
     ref_name = xymap_user%like
     call gildas_null(href)
     call sic_parse_file(ref_name,' ','.lmv',href%file)
     call gdf_read_header(href,error)
     if (gildas_error(href,rname,error)) return
     xymap_user%size  = href%gil%dim(1:2)
     xymap_user%cell(1) = href%gil%convert(3,1)*sec_per_rad
     xymap_user%cell(2) = href%gil%convert(3,2)*sec_per_rad
     if (href%char%syst.eq.'EQUATORIAL') then
        ndiv = 24
     else
        ndiv = 360
     endif
     call sexag(xymap_user%ra, href%gil%a0,ndiv)
     call sexag(xymap_user%dec,href%gil%d0,360)
     xymap_user%ptype = href%gil%ptyp
     xymap_user%pang  = href%gil%pang*deg_per_rad
  endif
  !
  ! Telescope beam, sorted by precedence
  if (hin%gil%reso_words.ne.0) then
    ! From table
    map%beam = hin%gil%majo
    map%beam_origin = "table header"
    !
  elseif (xymap_user%tele.ne.'') then
    ! From telescope name (given by user)
    ! Here it should be the sky frequency...
    call my_get_beam(xymap_user%tele,hin%gil%freq,found,map%beam,error)
    if (.not.found) then
      call class_message(seve%e,rname,'Unknown telescope name '//xymap_user%tele)
      error = .true.
      ! Return later
    else
      map%beam_origin = "MAP%TELE"
    endif
    !
  elseif (xymap_user%diam.ne.0.) then
    ! From diameter (given by user)
    map%beam = 1.22d0*(clight_mhz/hin%gil%freq)/xymap_user%diam
    map%beam_origin = "MAP%DIAM"
    !
  elseif (xymap_user%beam.ne.0.) then
    ! Directly given by user
    map%beam = xymap_user%beam*rad_per_sec
    map%beam_origin = "MAP%BEAM"
    !
  elseif (nogrid) then
    ! In /NOGRID mode, the beam is not strictly needed, as we don't need
    ! to compute the resolution and convolution kernel. We need it only for
    ! the matching tolerance (find_xy_increment).
    map%beam = 0.
    map%beam_origin = "NONE"
    !
  else
    call class_message(seve%e,rname,  &
      'The table resolution and the variables MAP%TELE, MAP%DIAM and MAP%BEAM are not defined')
    error = .true.
  endif
  if (error) then
    call class_message(seve%e,rname,  &
      'Impossible to find a correct default for the beam size')
    goto 100
  endif
  !
  ! Map resolution
  warn = .false.
  if (xymap_user%reso(1).ne.0) then
     ! User value
     map%reso(1) = xymap_user%reso(1)*rad_per_sec
     warn = map%reso(1).lt.map%beam  ! Should even warn at map%beam+5.4% for gaussian gridding function
  else
     ! Default: Telescope natural resolution
     map%reso(1) = map%beam
  endif
  if (xymap_user%reso(2).ne.0) then
     ! User value
     map%reso(2) = xymap_user%reso(2)*rad_per_sec
     warn = warn .or. map%reso(2).lt.map%beam
  else
     ! Default: Telescope natural resolution
     map%reso(2) = map%beam
  endif
  if (warn) then
    write(mess,'(5(A,F0.1))')  'Spatial resolution ',map%reso(1)/rad_per_sec,  &
      '" x ',map%reso(2)/rad_per_sec,'" can not be smaller than the beam size (',  &
      map%beam/rad_per_sec,'")'
    call class_message(seve%w,rname,mess)
    ! NB: the resolution will be fixed when computing the gridding function FWHM
  endif
  !
  ! Position tolerance (needed only if /NOGRID)
  if (.not.nogrid) then
    ! Not needed
    map%tole = 0.
  elseif (xymap_user%tole.ne.0.) then
    ! User defined
    map%tole = xymap_user%tole*rad_per_sec
  elseif (map%beam.ne.0.) then
    ! Default: a fraction of the telescope beam
    map%tole = map%beam/10
  else
    call class_message(seve%e,rname,  &
      '/NOGRID needs a tolerance in order to find X and Y increments')
    call class_message(seve%e,rname,  &
      'Set up MAP%TOLE to a fraction of your pixel increments, or')
    call class_message(seve%e,rname,  &
      'set up MAP%TELE, MAP%DIAM or MAP%BEAM and XY_MAP will use a fraction of the beam as tolerance')
    error = .true.
    return
  endif
  !
  ! Type of projection:
  if (use_ref .or. (xymap_user%shift .and. xymap_user%ptype.ne.p_none)) then
    map%ptyp = xymap_user%ptype  ! Can enforce whatever projection kind
    reproject = .true.
  else
    ! Reuse table input type if possible
    if (hin%gil%ptyp.eq.p_radio) then
      ! Force projection to azimuthal because:
      ! 1) radio does not support a rotation angle while azimuthal does,
      ! 2) we export (V\FITS) radio-projected cubes as SFL but with side
      !    effect, it is better to create them non-radio at first place.
      call class_message(seve%w,rname,'Map projection forced to AZIMUTHAL instead of RADIO')
      map%ptyp = p_azimuthal
      reproject = .true.
    else
      map%ptyp = hin%gil%ptyp
    endif
  endif
  ! New projection center (RA):
  !  - if MAP%LIKE is used (MAP%RA always set from reference)
  !  - if MAP%SHIFT is yes and MAP%RA is set
  if (use_ref .or. (xymap_user%shift .and. xymap_user%ra.ne.' ')) then
     call sic_sexa(xymap_user%ra,len(xymap_user%ra),r8,error)
     if (error)  goto 100
     if (hin%char%syst.eq.'EQUATORIAL') then
        map%a0 = r8*pi/12.d0
     else
        map%a0 = r8*pi/180.d0
     endif
     reproject = .true.
  else
     map%a0 = hin%gil%a0
  endif
  ! New projection center (Dec):
  !  - if MAP%LIKE is used (MAP%DEC always set from reference)
  !  - if MAP%SHIFT is yes and MAP%DEC is set
  if (use_ref .or. (xymap_user%shift .and. xymap_user%dec.ne.' ')) then
     call sic_sexa(xymap_user%dec,len(xymap_user%dec),r8,error)
     if (error)  goto 100
     map%d0 = r8*pi/180.d0
     reproject = .true.
  else
     map%d0 = hin%gil%d0
  endif
  ! Grid position angle:
  !  - if MAP%LIKE is used (MAP%ANGLE always set from reference)
  !  - if MAP%SHIFT is yes (no 'null' value available to user)
  if (use_ref .or. xymap_user%shift) then
     map%pang = xymap_user%pang*rad_per_deg
     reproject = .true.
  else
     map%pang = hin%gil%pang
  endif
  !
  call table_read_xyw(map%tab,map%time%xyw,error)
  if (error)  return
  !
  if (reproject) then
    ! Reproject (X,Y) coordinates if needed. This step must be done
    ! before sorting.
    call reproject_table(map%tab,hin%char%syst,                            &
                         hin%gil%ptyp,hin%gil%a0,hin%gil%d0,hin%gil%pang,  &
                         map%ptyp,    map%a0,    map%d0,    map%pang,      &
                         error)
    if (error)  goto 100
  endif
  !
  ! Sort input X Y W buffers, and fill the sorting array
  call sort_xyw(map%tab,error)
  if (error)  goto 100
  !
  ! Compute table x and y range
  ! This step must be done *after* rotation and sorting
  call find_xy_range(map%tab,xmin,xmax,ymin,ymax,error)
  if (error)  goto 100
  !
  ! Compute data smallest increments when needed
  if ((.not.use_ref).and.(nogrid)) then
     xinc = xmax-xmin
     yinc = ymax-ymin
     call find_xy_increment(map%tab,xinc,yinc,map%tole)
  endif
  !
  ! Pixel size
  if (xymap_user%cell(1).ne.0.0) then
     ! User defined
     map%cell(1) = xymap_user%cell(1)*rad_per_sec
  else
     ! Default
     if (nogrid) then
        ! Intrinsic increment
        map%cell(1) = -xinc
     else
        ! Nyquist sampling
        map%cell(1) = -map%reso(1)/2.0
     endif
  endif
  if (xymap_user%cell(2).ne.0.0) then
     ! User defined
     map%cell(2) = xymap_user%cell(2)*rad_per_sec
  else
     ! Default
     if (nogrid) then
        ! Intrinsic increment
        map%cell(2) = yinc
     else
        ! Nyquist sampling
        map%cell(2) = map%reso(2)/2.0
     endif
  endif
  !
  ! Define gridding function.
  if (xymap_user%ctype.eq.ctype_gaussian) then
     !
     ! Gaussian case:
     ! * ctyp = 2, i.e. exponential with parm(3) = 2,
     !   i.e the argument is first squared.
     ! * The FWHM is at least beam/3 resulting in a 5.4% beamsize increase
     ! * At 3 FWHM (support = 3 FWHM), the convolved signal can be
     !   neglected as the Gaussian value is 1.45e-11
     if ((map%reso(1)**2-map%beam**2).gt.(map%beam**2/9.0)) then
        ! User defined: sqrt(reso^2-beam^2)
        fwhm(1) = sqrt(map%reso(1)**2-map%beam**2)
     elseif (nogrid) then
        ! /NOGRID: map%reso(1) already set to map%beam
        fwhm(1) = 0.  ! Unused
     else
        ! Default: beam/3.0
        fwhm(1) = map%beam/3.0
        map%reso(1) = sqrt(map%beam**2+fwhm(1)**2)
     endif
     if ((map%reso(2)**2-map%beam**2).gt.(map%beam**2/9.0)) then
        ! User defined: sqrt(reso^2-beam^2)
        fwhm(2) = sqrt(map%reso(2)**2-map%beam**2)
     elseif (nogrid) then
        ! /NOGRID: map%reso(2) already set to map%beam
        fwhm(2) = 0.  ! Unused
     else
        ! Default: beam/3.0
        fwhm(2) = map%beam/3.0
        map%reso(2) = sqrt(map%beam**2+fwhm(2)**2)
     endif
     if (xymap_user%support(1).ne.0.0) then
        ! User defined
        map%support(1) = xymap_user%support(1)*rad_per_sec
     else
        ! Default
        map%support(1) = 3.0*fwhm(1)
     endif
     if (xymap_user%support(2).ne.0.0) then
        ! User defined
        map%support(2) = xymap_user%support(2)*rad_per_sec
     else
        ! Default
        map%support(2) = 3.0*fwhm(2)
     endif
     map%conv%x%parm(1) = map%support(1)/abs(map%cell(1))
     map%conv%y%parm(1) = map%support(2)/abs(map%cell(2))
     map%conv%x%parm(2) = fwhm(1)/(2*sqrt(log(2.0)))/abs(map%cell(1))
     map%conv%y%parm(2) = fwhm(2)/(2*sqrt(log(2.0)))/abs(map%cell(2))
     map%conv%x%parm(3) = 2
     map%conv%y%parm(3) = 2
     map%conv%x%ctype = ctype_exponential
     map%conv%y%ctype = ctype_exponential
     !
  else if (xymap_user%ctype.gt.7) then
     !
     write(mess,*) "Unknown convolution function: ",xymap_user%ctype
     call class_message(seve%e,rname,mess)
     error = .true.
     !
  else
     !
     write(mess,*) "Convolution function not yet implemented: ",xymap_user%ctype
     call class_message(seve%i,rname,mess)
     error = .true.
     !
  endif
  !
  ! Cube size
  if (xymap_user%size(1).ne.0) then
     ! User defined
     map%cub%nx = xymap_user%size(1)
  elseif (nogrid) then
     ! Use data values pixels, no more since there is no convolution
     map%cub%nx = int((xmax-xmin)/abs(map%cell(1)))+1
  else
     ! Default: X data range + X convolution support size (to ensure that
     !          all the convolution will be available when combining
     !          several cubes gridded at different moments)
     map%cub%nx = nint((xmax-xmin+2*map%support(1))/abs(map%cell(1)))+2
  endif
  if (xymap_user%size(2).ne.0) then
     ! User defined
     map%cub%ny = xymap_user%size(2)
  elseif (nogrid) then
     ! Use data values pixels, no more since there is no convolution
     map%cub%ny = int((ymax-ymin)/abs(map%cell(2)))+1
  else
     ! Default: Y data range + Y convolution support size (to ensure that
     !          all the convolution will be available when combining
     !          several cubes gridded at different moments)
     map%cub%ny = nint((ymax-ymin+2*map%support(2))/abs(map%cell(2)))+2
  endif
  !
  map%cub%nc = map%col(2)-map%col(1)+1
  !
  ! Here the reference pixel and value should take care of xymap_user%ra
  ! and xymap_user%dec ??? JP
  !
  ! Fill conversion formulae
  if (use_ref) then
     ! From reference header
     map%xconv = href%gil%convert(:,1)
     map%yconv = href%gil%convert(:,2)
  elseif (nogrid) then
     ! Center pixels at data places
     map%xconv(3) = map%cell(1)
     if (map%xconv(3).gt.0) then
        map%xconv(1) = 1.0d0 - xmin/map%xconv(3)  ! xmin <=> pixel number 1
     else
        map%xconv(1) = 1.0d0 - xmax/map%xconv(3)
     endif
     map%xconv(2) = 0.0d0
     !
     map%yconv(3) = map%cell(2)
     if (map%yconv(3).gt.0) then
        map%yconv(1) = 1.0d0 - ymin/map%yconv(3)
     else
        map%yconv(1) = 1.0d0 - ymax/map%yconv(3)
     endif
     map%yconv(2) = 0.0d0
  else
     ! From previous parameters
     map%xconv(3) = map%cell(1)
     map%xconv(1) = map%cub%nx/2+1-(xmin+xmax)/2/map%xconv(3)
     map%xconv(2) = 0.0d0
     !
     map%yconv(3) = map%cell(2)
     map%yconv(1) = map%cub%ny/2+1-(ymin+ymax)/2/map%yconv(3)
     map%yconv(2) = 0.0d0
  endif
  map%vconv(1) = hin%gil%convert(1,1)-map%col(1)+1
  map%vconv(2) = hin%gil%voff
  map%vconv(3) = hin%gil%vres
  !
100 continue
  error2 = error
  if (use_ref)  call gdf_close_image(href,error)
  error = error2 .or. error
  !
end subroutine define_gridding_parameters
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine find_xy_range(tab,xmin,xmax,ymin,ymax,error)
  use gbl_message
  use classmap_interfaces, except_this=>find_xy_range
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !     Search for the limits of the x and y coordinates.
  !     The algorithm assumes that the input table is sorted in increasing
  !     order according to the Y coordinate.
  !---------------------------------------------------------------------
  type(xymap_tab_t), intent(in)    :: tab    !
  real(kind=4),      intent(out)   :: xmin   ! Minimum of X coordinates
  real(kind=4),      intent(out)   :: xmax   ! Maximum of X coordinates
  real(kind=4),      intent(out)   :: ymin   ! Minimum of Y coordinates
  real(kind=4),      intent(out)   :: ymax   ! Maximum of Y coordinates
  logical,           intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  integer(kind=4) :: ilin,valid1
  !
  ! Find first valid data point
  valid1 = 0
  do ilin=1,tab%nposi
    if (tab%w(ilin).ne.0.) then
      valid1 = ilin
      ! As the table is sorted according to y, this is ymin
      ymin = tab%y(valid1)
      ! Initialize search of x minimum and maximum
      xmin = tab%x(valid1)
      xmax = xmin
      exit
    endif
  enddo
  if (valid1.eq.0) then
    call class_message(seve%e,rname,'No valid data points')
    error = .true.
    return
  endif
  !
  ! Search the x minimum and maximum only among valid data points
  do ilin=valid1,tab%nposi
    if (tab%w(ilin).ne.0.) then
      if (tab%x(ilin).lt.xmin) then
        xmin = tab%x(ilin)
      elseif (tab%x(ilin).gt.xmax) then
        xmax = tab%x(ilin)
      endif
    endif
  enddo
  !
  ! Search last valid data point
  do ilin=tab%nposi,valid1,-1
    if (tab%w(ilin).ne.0.) then
      ! As the table is sorted according to y, this is ymax
      ymax = tab%y(ilin)
      exit
    endif
  enddo
  !
end subroutine find_xy_range
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine find_xy_increment(tab,xinc,yinc,tole)
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  ! Find minimum increment in the X and Y coordinates.
  ! If this minimum is lower than the X-Y position tolerance, then send
  ! back this tolerance instead.
  ! Warning: xinc and yinc are assumed to be initialized outside this
  !          subroutine.
  ! *** JP ***
  ! The current algorithm takes forever when the number of table lines
  ! increases. A better way would be to assume that the data coordinates
  ! are indeed already on a grid (this is the use case in which to call
  ! this subroutine!). In this case, finding first the equivalent classes
  ! of the x offsets will be extremely fast because there is not so many
  ! different x offsets! We can then sort them and find the minimum
  ! distance between them. Once this is done, we use exactly the same
  ! algorithm but for the y offsets. To be fully generic, we can use the
  ! same positioning tolerance as used in other parts of this code. Hence,
  ! if the data offsets are not already positioned on a grid, we still
  ! limit the number of equivalence classes and the algorithm should stay fast.
  ! *** JP ***
  !---------------------------------------------------------------------
  type(xymap_tab_t), intent(in)    :: tab   !
  real(kind=4),      intent(inout) :: xinc  ! X minimum increment (initialized to xmax-xmin)
  real(kind=4),      intent(inout) :: yinc  ! Y minimum increment (initialized to ymax-ymin)
  real(kind=4),      intent(in)    :: tole  ! X-Y position tolerance
  ! Local
  integer(kind=4) :: ilin,jlin
  real(kind=4) :: dist
  !
  do ilin = 1,tab%nposi-1
    if (tab%w(ilin).eq.0.)  cycle
    !
    do jlin=ilin+1,tab%nposi
      if (tab%w(jlin).eq.0.)  cycle
      !
      dist = abs(tab%x(jlin)-tab%x(ilin))
      if (dist.gt.tole .and. dist.lt.xinc) xinc = dist
      !
      dist = tab%y(jlin)-tab%y(ilin)
      if (dist.gt.tole .and. dist.lt.yinc) yinc = dist
      !
    enddo
  enddo
end subroutine find_xy_increment
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine print_gridding_parameters(map)
  use gbl_message
  use phys_const
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  ! MAP internal routine
  !---------------------------------------------------------------------
  type(xymap_prog_t), intent(inout) :: map  ! Cube description
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  character(len=message_length) :: mess
  !
  ! User feedback
  write(mess,'(a,i5,f9.1,2es15.3)')  &
    'X axis definition: ',map%cub%nx,map%xconv
  call class_message(seve%r,rname,mess)
  write(mess,'(a,i5,f9.1,2es15.3)')  &
    'Y axis definition: ',map%cub%ny,map%yconv
  call class_message(seve%r,rname,mess)
  write(mess,'(a,i5,f9.1,2es15.3)')  &
    'V axis definition: ',map%cub%nc,map%vconv
  call class_message(seve%r,rname,mess)
  write(mess,'(3(a,i0))')  &
    'Table size: ',map%tab%nposi," positions x ",map%tab%ndata," values"
  call class_message(seve%r,rname,mess)
  write(mess,'(3(a,i0))')  &
    'X, Y and W columns: ',map%tab%xcol,", ",map%tab%ycol," and ",map%tab%wcol
  call class_message(seve%r,rname,mess)
  write(mess,'(2(a,i0))')  &
    'First and last gridded columns: ',map%col(1)," and ",map%col(2)
  call class_message(seve%r,rname,mess)
  write(mess,'(4(a,i0))')  &
    'Cube size: ',map%cub%nx,' by ',map%cub%ny,' pixels x ',map%cub%nc,' channels'
  call class_message(seve%r,rname,mess)
  write(mess,*)  &
    'Grid position angle: ',nint(map%pang*deg_per_rad),' degree'
  call class_message(seve%r,rname,mess)
  write(mess,'(a,f9.1,a,f9.1,a)')  &
    'Field of View: ',0.1*nint(10*map%cub%nx*map%cell(1)*sec_per_rad),'" x ',0.1*nint(10*map%cub%ny*map%cell(2)*sec_per_rad),'"'
  call class_message(seve%i,rname,mess)
  write(mess,'(a,f9.1,a,f9.1,a)')  &
    'Pixel size: ',0.1*nint(10*map%cell(1)*sec_per_rad),'" x ',0.1*nint(10*map%cell(2)*sec_per_rad),'"'
  call class_message(seve%r,rname,mess)
  if (map%reso(1).eq.map%reso(2)) then
     write(mess,'(a,f9.1,a)')  &
       'Spatial resolution: ',0.1*nint(10*map%reso(1)*sec_per_rad),'"'
  else
     write(mess,'(a,f9.1,a,f9.1,a)')  &
       'Spatial resolution: ',0.1*nint(10*map%reso(1)*sec_per_rad),'" x ',0.1*nint(10*map%reso(2)*sec_per_rad),'"'
  endif
  call class_message(seve%r,rname,mess)
  write(mess,'(a,f9.1,3a)')  &
    'Telescope Beam: ',0.1*nint(10*map%beam*sec_per_rad),'" (from ',trim(map%beam_origin),')'
  call class_message(seve%r,rname,mess)
  !
end subroutine print_gridding_parameters
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine table_to_cube_headers(map,basename,lmvcode,error)
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>table_to_cube_headers
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  ! Set up the headers for the output data cube and weight image
  !---------------------------------------------------------------------
  type(xymap_prog_t), intent(inout) :: map
  character(len=*),   intent(in)    :: basename
  character(len=*),   intent(in)    :: lmvcode
  logical,            intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  integer(kind=4) :: ier,iext,pos
  character(len=3) :: trcode  ! Transposition code (e.g. '231' for VLM to LMV)
  character(len=4) :: defext,knownext(2)
  character(len=filename_length) :: prefixname,cubename,weiname
  !
  ! Get transposition code from lmvcode. Input table is ordered VLM=123 in memory
  call transpose_getcode('VLM',lmvcode,trcode,error)
  if (error)  return
  !
  ! File names. Two cases which can be mixed:
  ! 1) the user has provided or not the cube extension (.lmv, .vlm,
  !    .lmv-test, etc)
  ! 2) the basename (without extension) contains or not a dot, e.g.
  !    13co10-10.5asec
  ! Need correct parsing which adds or not an extension.
  !
  ! Decode sic logicals, do not deal for extension for now
  call sic_parse_file(basename,'','',prefixname)
  !
  ! Default extension (depends on lmvcode)
  defext = '.'//lmvcode
  call sic_lower(defext)  ! Default cube extension
  !
  ! Search for known extensions (.lmv, .vlm, .lmv2, .gdf...)
  knownext(1) = defext
  knownext(2) = '.gdf'
  do iext=1,2
    pos = index(prefixname,knownext(iext))
    if (pos.gt.1)  exit
  enddo
  if (pos.gt.1) then
    ! The user has already provided an extension.
    cubename = prefixname
    prefixname(pos:) = ''  ! Strip off .lmv, .vlm, .lmv2, etc
  else
    ! No cube extension yet
    cubename = trim(prefixname)//defext
  endif
  weiname = trim(prefixname)//'.wei'
  !
  ! Cube header
  call table_to_cube_header(cubename,map%tab%hmem,map,trcode,map%cub%hout,error)
  if (error)  return
  map%cub%velofirst = map%cub%hout%gil%faxi.eq.1
  !
  ! Create weight image header as LMV=231 (always)...
  call table_to_cube_header(weiname,map%tab%hmem,map,'231',map%cub%hwei,error)
  if (error)  return
  ! ... and drop the 3rd (V) axis:
  map%cub%hwei%gil%ndim = 2
  map%cub%hwei%gil%dim(3) = 1
  map%cub%hwei%gil%convert(:,3) = 1.d0
  map%cub%hwei%char%code(3) = 'UNKNOWN'
  map%cub%hwei%gil%faxi = 0
  !
  allocate(map%cub%dwei(map%cub%hwei%gil%dim(1),map%cub%hwei%gil%dim(2)),stat=ier)
  if (failed_allocate(rname,"weight image",ier,error))  return
  !
end subroutine table_to_cube_headers
!
subroutine table_to_cube_header(filename,hin,map,trcode,hout,error)
  use image_def
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>table_to_cube_header
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the output cube (header part)
  !---------------------------------------------------------------------
  character(len=*),   intent(in)    :: filename  !
  type(gildas),       intent(in)    :: hin       !
  type(xymap_prog_t), intent(in)    :: map       !
  character(len=*),   intent(in)    :: trcode    ! Transposition code e.g. '231'
  type(gildas),       intent(inout) :: hout      !
  logical,            intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  type(gildas) :: htmp
  !
  ! Initialize header
  call gildas_null(htmp)
  !
  call gdf_copy_header(hin,htmp,error)
  if (error)  return
  !
  ! Fill data cube header as VLM (natural data ordering)
  htmp%gil%ndim = 3
  htmp%gil%dim(:) = 0
  htmp%gil%dim(1) = map%cub%nc
  htmp%gil%dim(2) = map%cub%nx
  htmp%gil%dim(3) = map%cub%ny
  htmp%gil%convert(:,1) = map%vconv
  htmp%gil%convert(:,2) = map%xconv
  htmp%gil%convert(:,3) = map%yconv
  ! Table has only 2 dimensions, guess the spatial dimensions of the cube.
  ! Code below supports GDFV1 (providing explicitly a 3rd code but unused
  ! now) and GDFV2 tables
  htmp%char%code(1) = hin%char%code(1)
  if (hin%char%code(2)(1:2).eq.'RA') then
    htmp%char%code(2) = 'RA'
    htmp%char%code(3) = 'DEC'
  elseif (hin%char%code(2)(1:3).eq.'LII') then
    htmp%char%code(2) = 'LII'
    htmp%char%code(3) = 'BII'
  else
    call class_message(seve%e,rname,  &
      'Second axis code not recognized: '//hin%char%code(2))
    error = .true.
    return
  endif
  htmp%gil%faxi = 1
  htmp%gil%xaxi = 2
  htmp%gil%yaxi = 3
  htmp%gil%ptyp = map%ptyp
  htmp%gil%a0   = map%a0
  htmp%gil%d0   = map%d0
  htmp%gil%pang = map%pang
  htmp%gil%majo = max(map%reso(1),map%reso(2))
  htmp%gil%mino = min(map%reso(1),map%reso(2))
  htmp%gil%posa = 0.
  htmp%gil%coor_words = 6*gdf_maxdims
  htmp%gil%extr_words = 0
  htmp%gil%uvda_words = 0
  if (htmp%gil%majo.gt.0.) then  ! No need to check htmp%gil%mino
    htmp%gil%reso_words = 3
  else
    ! This can happen in /NOGRID, where the beam is not needed.
    htmp%gil%reso_words = 0
  endif
  !
  ! And now transpose the header
  call gdf_transpose_header(htmp,hout,trcode,error)
  if (error)  return
  !
  ! File name
  hout%file = filename
  call class_message(seve%i,rname,'Creating file: '//hout%file)
  !
end subroutine table_to_cube_header
!
subroutine table_to_cube_data(map,nogrid,error)
  use gbl_message
  use gildas_def
  use gkernel_types
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>table_to_cube_data
  use image_def
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the output cube and weight (data part)
  !---------------------------------------------------------------------
  type(xymap_prog_t), intent(inout) :: map     ! Gridding parameters
  logical,            intent(in)    :: nogrid  ! Do not convolve, just place
  logical,            intent(out)   :: error   ! Return status
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  integer(kind=index_length) :: first_channel,last_channel
  integer(kind=4) :: iblock,mblocks,mc
  real(kind=4) :: bf,mcfloat
  real(kind=4), allocatable :: xcoord(:),ycoord(:)
  integer(kind=4) :: ier,cfcol
  character(len=message_length) :: mess
  type(time_t) :: time
  type(cputime_t) :: tmp
  !
  ! Initialization
  error = .false.
  map%cub%dwei(:,:) = 0.d0
  !
  if (.not.nogrid) then
    ! Pre-compute gridding kernel
    call conv_fn_default(map%conv%x%ctype,map%conv%y%ctype,  &
      map%conv%x%parm,map%conv%y%parm)
    call conv_fn_computation(map%conv%x,error)
    if (error)  return
    call conv_fn_computation(map%conv%y,error)
    if (error)  return
    !
    ! Allocate workspace and x and y gridded coordinates
    allocate(xcoord(map%cub%nx),ycoord(map%cub%ny),stat=ier)
    if (failed_allocate(rname,"xy gridded arrays",ier,error)) return
    ! Compute arrays of x and y gridded coordinates
    call docoor(map%cub%nx,map%xconv(1),map%xconv(2),map%xconv(3),xcoord)
    call docoor(map%cub%ny,map%yconv(1),map%yconv(2),map%yconv(3),ycoord)
  endif
  !
  ! Blocking factor: how many slices do we have to use (at least) to remain
  ! below the Sic logical VOLATILE_MEMORY?
  bf = blocking_factor(map,error)
  if (error)  return
  if (bf.gt.map%cub%nc) then
    ! We need more blocks than channels. This means that if we want to remain
    ! below VOLATILE_MEMORY, we have to process less than 1 channel per
    ! block... We do not round to 1 channel:
    ! - either it is a user mistake, processing channel per channel will be
    !   highly unefficient. User can just fix VOLATILE_MEMORY,
    ! - or this is not a mistake, its data set is huge, and rounding to the
    !   upper value means using more memory than requested while user may
    !   have carefully chosen its VOLATILE_MEMORY.
    ! In any case, stop here
    call class_message(seve%e,rname,  &
      'Less than 1 channel to be processed per block. Increase VOLATILE_MEMORY.')
    error = .true.
    return
  endif
  ! Some considerations about blocking factor: we want an integer number of
  ! blocks and integer number of channels per block and tolerate last block
  ! to be partially used. This may be impossible. Example:
  !  921 channels in total, blocking_factor() proposes to use 38.0 blocks
  !   => 24.23 channels per block
  ! * If we use 24 channels per block, we need 39 blocks
  ! * If we use 25 channels per block, we need 37 blocks...
  ! As the purpose it to remain below a given amount of memory, we prefer
  ! the first solution (do not use one more channel per block), which
  ! means using a more blocks than recommanded in this example.
  mcfloat = map%cub%nc/bf  ! Number of channels per block (float value)
  if (10.*mcfloat.gt.huge(mc)) then
    ! Very small cube and/or huge amount of memory
    mc = huge(mc)/10  ! Just a huge value usable for computations below
  else
    ! Use floor function as argued above
    mc = floor(mcfloat)  ! Number of channels per block (integer)
  endif
  mblocks = map%cub%nc/mc
  if (mc*mblocks.lt.map%cub%nc) mblocks = mblocks+1
  write(mess,'(A,I0,A,I0,A,I0,1X,I0)')  &
    'Mblocks: ',mblocks,', MC: ',mc,', Size: ',mc*mblocks,map%cub%nc
  call class_message(seve%d,rname,mess)
  !
  ! Computing time statistics: counter will be incremented in the convolution
  ! loop, which is itself embedded in the blocks loop. This is not perfect
  ! as there are other operations within a block loop (i.e. the progress in
  ! percentage will be correct but the remaining time projection will not be
  ! correctly estimated), but not that bad as convolution dominates the
  ! processing time.
  call gtime_init(time,mblocks*map%cub%ny,error)
  if (error)  return
  !
  ! Set first channel to read (NB: map%col(1) is absolute position in table)
  if (map%tab%wcol.eq.3) then
    cfcol = 3
  else
    cfcol = 2
  endif
  first_channel = map%col(1)-cfcol
  !
  ! Loop on blocks
  do iblock = 1, mblocks
     call class_message(seve%d,rname,'--------------------')
     last_channel = min(first_channel+mc-1 , map%col(2)-cfcol)
     write(mess,'(5(A,I0))')  'Doing block ',iblock,'/',mblocks,', channels ',  &
       first_channel,':',last_channel,', Nchan = ',last_channel-first_channel+1
     call class_message(seve%d,rname,mess)
     !
     call table_to_cube_datasub(map,iblock.eq.1,first_channel,last_channel,  &
       nogrid,xcoord,ycoord,time,error)
     if (error)  exit
     !
     ! Prepare next subset
     first_channel = last_channel + 1
  enddo
  call class_message(seve%d,rname,'--------------------')
  !
  if (allocated(xcoord))  deallocate(xcoord,ycoord)
  !
  if (allocated(map%cub%dout)) then
    ! The output cube has been saved in memory: now flush to disk
    call class_message(seve%d,rname,'Writing whole cube at once...')
    call gag_cputime_init(tmp)
    ! Open-write-close image at once
    call gdf_write_image(map%cub%hout,map%cub%dout,error)
    if (gildas_error(map%cub%hout,rname,error))  continue
    call gag_cputime_add(map%time%writ,tmp)
  endif
  !
  ! Write gridded weights
  call class_message(seve%d,rname,'Writing weight image...')
  call gdf_write_image(map%cub%hwei,map%cub%dwei,error)
  if (gildas_error(map%cub%hwei,rname,error))  return
  !
contains
  function blocking_factor(map,error)
    use gbl_message
    use classmap_dependencies_interfaces
    use classmap_interfaces
    use xymap_types
    !-------------------------------------------------------------------
    ! Compute blocking factor, using logical name VOLATILE_MEMORY for
    ! the maximum memory available for gridding.
    !-------------------------------------------------------------------
    real(kind=4) :: blocking_factor
    type(xymap_prog_t), intent(in)    :: map
    logical,            intent(inout) :: error
    ! Local
    real(kind=4) :: vmemory
    integer(kind=size_length) :: swords,mwords,twords,cwords
    character(len=message_length) :: mess
    real(kind=4) :: ofact
    !
    twords = map%tab%nposi*map%cub%nc          ! Input table size [words]
    cwords = map%cub%nx*map%cub%ny*map%cub%nc  ! Ouput cube size  [words]
    !
    ! How many memory words are needed for the buffers?
    ! Note that map%cub%nc is used because user may ask for a subset.
    ! TABLE:
    mwords = twords
    if (.not.map%tab%velofirst .or. map%tab%dosort)  &
      mwords = mwords + twords  ! Transposition/sorting buffer
    ! CUBE:
    mwords = mwords + cwords
    if (.not.map%cub%velofirst)  &
      mwords = mwords + cwords  ! Transposition buffer
    ! The other allocatable buffers should be neglictible, and they do not
    ! scale as number of channels
    !
    ier = sic_ramlog('VOLATILE_MEMORY',vmemory)  ! MBytes
    if (ier.ne.0) then
      call class_message(seve%e,rname,'Error decoding logical VOLATILE_MEMORY')
      error = .true.
      return
    endif
    swords = nint(vmemory*1024_8*256_8,kind=size_length)  ! Space words
    write(mess,'(2A)')  'Using at most VOLATILE_MEMORY = ',pretty_size(swords)
    call class_message(seve%d,rname,mess)
    !
    blocking_factor = real(mwords,kind=4)/swords
    !
    if (blocking_factor.le.1.) then
      ! This is the best case where all the problem fits in memory. In
      ! particular, the output cube fits in memory and will be written
      ! at once, whatever its order
      return
    endif
    !
    if (map%cub%velofirst) then  ! VLM
      ! This cube can not be gdf-extended by block, let see if it fits
      ! in memory so that we can write it at once at the very end. Let's
      ! use max 50% for the output cube, the rest for the per-block buffers
      if (cwords.lt.swords/2) then
        call reallocate_cub(map%cub%dout,map%cub%nc,map%cub%nx,map%cub%ny,error)
        if (error)  return
        ! 'cwords' allocate above, independently of the blocking factor
        ! This is as less remaining in VOLATILE_MEMORY:
        swords = swords-cwords
        ! One buffer is already allocated, decrease mwords:
        mwords = mwords-cwords
        ofact = blocking_factor
        blocking_factor = real(mwords,kind=4)/swords
        write(mess,'(4A,F0.2,A,F0.2)')  'Allocated ',trim(pretty_size(cwords)),  &
          ' of memory for the whole VLM cube,',  &
          ' number of blocks changed from ',ofact,' to ',blocking_factor
        call class_message(seve%d,rname,mess)
      else
        write(mess,'(3A)')  'The output VLM cube (',trim(pretty_size(cwords)),  &
          ') does not fit in memory (50% of logical VOLATILE_MEMORY at most)'
        call class_message(seve%e,rname,mess)
        call class_message(seve%e,rname,  &
          'Increase logical VOLATILE_MEMORY or use a LMV cube as output')
        error = .true.
        return
      endif
    else  ! LMV
      ! This cube can be gdf-extended by block, we don't save it in memory
      ! Return without modifying the blocking_factor
    endif
    !
  end function blocking_factor
  !
end subroutine table_to_cube_data
!
subroutine table_to_cube_datasub(map,firstblock,fc,lc,nogrid,xcoord,ycoord,  &
  time,error)
  use gildas_def
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>table_to_cube_datasub
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !  Process 1 block of channels
  !---------------------------------------------------------------------
  type(xymap_prog_t),         intent(inout) :: map             !
  logical,                    intent(in)    :: firstblock      ! First block written?
  integer(kind=index_length), intent(in)    :: fc,lc           ! First and last channels
  logical,                    intent(in)    :: nogrid          !
  real(kind=4)                              :: xcoord(map%cub%nx)  ! Working buffer
  real(kind=4)                              :: ycoord(map%cub%ny)  ! Working buffer
  type(time_t),               intent(inout) :: time            !
  logical,                    intent(inout) :: error           !
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  integer(kind=index_length) :: ix,iy
  type(cputime_t) :: tmp
  !
  call table_read_data(map%tab,fc,lc,map%time,error)
  if (error)  return
  !
  if (map%tab%dosort) then
    call gag_cputime_init(tmp)
    call sort_tab(map%tab%data,map%tab%nchan,map%tab%nposi,map%tab%sort,  &
      map%tab%buff,error)
    if (error)  return
    call gag_cputime_add(map%time%sort,tmp)
  endif
  !
  map%cub%nchan = lc-fc+1
  call reallocate_cub(map%cub%data,map%cub%nchan,map%cub%nx,map%cub%ny,error)
  if (error)  return
  !
  call gag_cputime_init(tmp)
  if (nogrid) then
    call doplace(map,map%tab%data,map%cub%data,map%cub%dwei,time,error)
    if (error)  return
  else
    ! Grid (i.e. convolve using above gridding function)
    call doconv(                          &
          map%tab%nchan,map%tab%nposi,    &  ! Number of input points
          map%tab%data,                   &  ! Input Values
          map%tab%x,map%tab%y,map%tab%w,  &  ! Coordinates and weights
          map%cub%dwei,                   &  ! Gridded weights
          map%cub%nx,map%cub%ny,          &  ! Cube size
          map%cub%data,                   &  ! RAW Cube
          xcoord,ycoord,                  &  ! Cube coordinates
          map%support,map%cell,           &  !
          map%conv,                       &  ! Pre-computed convolution kernel
          time,error)                        ! Timer
    if (error)  return
  endif
  call gag_cputime_add(map%time%conv,tmp)
  !
  ! Blank pixels with zero-valued weights
  do iy=1,map%cub%ny
    do ix=1,map%cub%nx
      if (map%cub%dwei(ix,iy).eq.0.0) then
        map%cub%data(1:map%tab%nchan,ix,iy) = map%cub%hout%gil%bval
      endif
    enddo ! ix
  enddo ! iy
  !
  call cube_write_data(map%cub,firstblock,fc,lc,map%time,error)
  if (error)  continue  ! Need to close image even in case of error
  !
  ! Free the image slot and its lun (else we would accumulate them
  ! e.g. when extending)
  call my_close_image(map%cub%hout,error)
  if (error)  return
  !
end subroutine table_to_cube_datasub
!
subroutine cube_write_data(cub,firstblock,fc,lc,time,error)
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>cube_write_data
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !  Write the block of data, either directly on disk, either in memory
  ! depending on the cube order and memory size.
  !---------------------------------------------------------------------
  type(xymap_cub_t),          intent(inout) :: cub         !
  logical,                    intent(in)    :: firstblock  ! First block written?
  integer(kind=index_length), intent(in)    :: fc,lc       ! First and last channels
  type(xymap_time_t),         intent(inout) :: time        !
  logical,                    intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  integer(kind=index_length) :: ix,iy
  integer(kind=index_length), parameter :: one=1
  type(cputime_t) :: tmp
  !
  if (cub%velofirst) then  ! VELO-POSI-POSI
    !
    if (allocated(cub%dout)) then
      call class_message(seve%d,rname,'Writing VLM cube to memory...')
      do iy=1,cub%ny
        do ix=1,cub%nx
          cub%dout(fc:lc,ix,iy) = cub%data(1:cub%nchan,ix,iy)
        enddo
      enddo
      return
      ! Do not cputime this action, this is not "writing data" scope
      !
    elseif (firstblock) then
      ! Image is not yet opened
      call class_message(seve%d,rname,'Writing VLM cube to disk...')
      call gag_cputime_init(tmp)
      cub%hout%gil%dim(1) = cub%nchan
      call gdf_create_image(cub%hout,error)
      if (gildas_error(cub%hout,rname,error))  return
      call gdf_write_data(cub%hout,cub%data,error)
      if (gildas_error(cub%hout,rname,error))  continue
      call gag_cputime_add(time%writ,tmp)
      !
    else
      ! Adding a new block of velocities. Need to extend the cube, but V is
      ! not the last dimension. This is probably possible with gio, but what
      ! about efficiency?
      ! Anyway this should not happen, trapped when computing blocking factor.
      call class_message(seve%e,rname,'Extending a VLM cube is not implemented')
      error = .true.
      return
    endif
    !
  else  ! POSI-POSI-VELO
    call class_message(seve%d,rname,'Transposing to LMV...')
    call gag_cputime_init(tmp)
    call reallocate_cub(cub%buff,cub%nx,cub%ny,cub%nchan,error)
    if (error)  return
    do iy=1,cub%ny
      do ix=1,cub%nx
        cub%buff(ix,iy,1:cub%nchan) = cub%data(1:cub%nchan,ix,iy)
      enddo ! ix
    enddo ! iy
    call gag_cputime_add(time%tran,tmp)
    !
    call gag_cputime_init(tmp)
    if (firstblock) then
      ! Image is not created
      call class_message(seve%d,rname,'Writing LMV cube...')
      cub%hout%gil%dim(3) = cub%nchan
      call gdf_create_image(cub%hout,error)
      if (gildas_error(cub%hout,rname,error))  return
    else
      call class_message(seve%d,rname,'Extending LMV cube...')
      call gdf_extend_image(cub%hout,lc,error)
      if (error)  return
      cub%hout%blc(1:3) = (/ one                ,one                ,fc /)
      cub%hout%trc(1:3) = (/ cub%hout%gil%dim(1),cub%hout%gil%dim(2),lc /)
    endif
    call gdf_write_data(cub%hout,cub%buff,error)
    if (gildas_error(cub%hout,rname,error))  continue
    call gag_cputime_add(time%writ,tmp)
    !
  endif
  !
end subroutine cube_write_data

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_reproject_opt
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !---------------------------------------------------------------------
  ! Support module for commands which need to call the reproject engine:
  ! they must share the same command (option 0) type (= option_t +
  ! cubeid_arg_t)
  !---------------------------------------------------------------------
  !
  public :: reproject_opt_comm_t,reproject_opt_user_t
  private
  !
  type :: reproject_opt_comm_t
    type(option_t),     pointer :: comm
    type(cubeid_arg_t), pointer :: cube
    type(cube_prod_t),  pointer :: reprojected
  contains
    procedure, public :: register => cubemain_reproject_opt_register
    procedure, public :: parse    => cubemain_reproject_opt_parse
  end type reproject_opt_comm_t
  !
  type reproject_opt_user_t
    type(cubeid_user_t) :: cubeids ! Input cube
  end type reproject_opt_user_t
  !
contains
  !
  subroutine cubemain_reproject_opt_register(comm,name,abstract,help,run, &
    ouname,ouflag,error)
    use cubedag_allflags
    use cubedag_parameters
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_opt_comm_t), intent(inout) :: comm
    character(len=*),            intent(in)    :: name      ! Command name
    character(len=*),            intent(in)    :: abstract  ! Command abstract
    character(len=*),            intent(in)    :: help      ! Command help
    external                                   :: run       !
    character(len=*),            intent(in)    :: ouname    ! Output cube qualifier
    type(flag_t),                intent(in)    :: ouflag    ! Output cube flag
    logical,                     intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='REPROJECT>OPT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         name,'[cube]',&
         abstract,&
         help,&
         run,&
         comm%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBE',&
         'Signal cube',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         name,&
         ouname//' cube',&
         strg_emp,&
         [ouflag,flag_cube],&
         comm%reprojected,&
         error)
    if (error) return
  end subroutine cubemain_reproject_opt_register
  !
  subroutine cubemain_reproject_opt_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_opt_comm_t), intent(in)    :: comm
    character(len=*),            intent(in)    :: line
    type(reproject_opt_user_t),  intent(out)   :: user
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>OPT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubemain_reproject_opt_parse
end module cubemain_reproject_opt
!
module cubemain_reproject
  use gbl_constant
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubetools_axis_types
  use cubetools_spatial_types
  use cubetools_header_types
  use cubeadm_cubeid_types
  use cubemain_messaging
  use cubemain_auxiliary
  use cubemain_reproject_opt
  !
  public :: reproject
  public :: code_conv_none,code_conv_equ2gal,code_conv_gal2equ,code_conv_equ2equ
  public :: reproject_comm_t,reproject_user_t,reproject_prog_t
  public :: cubemain_reproject_user_toprog_find_conv
  private
  !
  ! Coordinate system conversion codes
  integer(kind=code_k), parameter :: code_conv_none    =  0
  integer(kind=code_k), parameter :: code_conv_equ2gal =  1
  integer(kind=code_k), parameter :: code_conv_gal2equ = -1
  integer(kind=code_k), parameter :: code_conv_equ2equ = -2
  type :: reproject_conv_t  ! Conversion description
    integer(kind=code_k) :: code  = code_conv_none
    real(kind=4)         :: eqin  = equinox_null  ! Input equinox, if relevant
    real(kind=4)         :: eqout = equinox_null  ! Output equinox, if relevant
  end type reproject_conv_t
  !
  type :: reproject_comm_t
     type(reproject_opt_comm_t)  :: comm   ! Command (option 0) description
     type(option_t),     pointer :: like
     type(cubeid_arg_t), pointer :: like_arg
     type(spafra_opt_t)          :: spafra
     type(spapro_type_opt_t)     :: ptype
     type(spapro_center_opt_t)   :: pcenter
     type(spapro_angle_opt_t)    :: pangle
     type(axis_opt_t)            :: laxis
     type(axis_opt_t)            :: maxis
   contains
     procedure, public  :: register => cubemain_reproject_register
     procedure, private :: parse    => cubemain_reproject_parse
     procedure, public  :: main     => cubemain_reproject_main
  end type reproject_comm_t
  type(reproject_comm_t) :: reproject
  !
  type reproject_user_t
     type(reproject_opt_user_t) :: comm    ! Command (option 0) arguments
     type(auxiliary_user_t)     :: like    ! Use another cube as reference
     type(spafra_user_t)        :: spafra  ! User Spatial frame
     type(spapro_type_user_t)   :: ptype   ! Projection type
     type(spapro_center_user_t) :: pcenter ! Projection center
     type(spapro_angle_user_t)  :: pangle  ! Projection angle
     type(axis_user_t)          :: newx    ! [sec|min|deg|rad] User l axis description
     type(axis_user_t)          :: newy    ! [sec|min|deg|rad] User m axis description
   contains
     procedure, public  :: init   => cubemain_reproject_user_init 
     procedure, private :: toprog => cubemain_reproject_user_toprog
  end type reproject_user_t
  !
  type reproject_prog_t
     type(cube_t), pointer  :: cube                  ! Input cube
     type(cube_t), pointer  :: reprojected           ! Reprojected cube
     type(cube_header_t)    :: ouhead
     type(reproject_conv_t) :: conv
     type(axis_t)           :: oldx                  ! [rad] old l axis description
     type(axis_t)           :: oldy                  ! [rad] old m axis description
     type(axis_t)           :: newx                  ! [rad] new l axis description 
     type(axis_t)           :: newy                  ! [rad] new m axis description
     real(kind=coor_k), allocatable :: xfrac(:,:)   ! [---] Fraction of input pixel in output pixel
     real(kind=coor_k), allocatable :: yfrac(:,:)   ! [---] Fraction of input pixel in output pixel
     integer(kind=pixe_k), allocatable :: ix(:,:)   ! Output pixel number in input cube
     integer(kind=pixe_k), allocatable :: iy(:,:)   ! Output pixel number in input cube
   contains
     procedure, public  :: header     => cubemain_reproject_prog_header
     procedure, public  :: precompute => cubemain_reproject_prog_precompute
     procedure, public  :: data       => cubemain_reproject_prog_data
     procedure, private :: loop       => cubemain_reproject_prog_loop
     procedure, private :: act        => cubemain_reproject_prog_act
  end type reproject_prog_t
  !
contains
  !
  subroutine cubemain_reproject_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(reproject_user_t) :: user
    character(len=*), parameter :: rname='REPROJECT>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call reproject%parse(line,user,error)
    if (error) return
    call reproject%main(user,error)
    if (error) continue
  end subroutine cubemain_reproject_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_reproject_register(comm,error)
    use cubetools_unit
    use cubedag_parameters
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_comm_t), intent(inout) :: comm
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call comm%comm%register(&
         'REPROJECT',&
         'Reproject the spatial grid of a cube',&
         'Reproject the spatial axes of an input image or cube to a&
         & different projection or coordinate system.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Spatial resampling uses bilinear interpolation. For best interpolation&
         & fidelity, choose output pixel increments smaller than the input ones.'//strg_cr//&
         '- At least one target-definition option must be provided.'//strg_cr//&
         '- /SPATIALFRAME, /PTYPE, /PCENTER, /PANGLE, /LAXIS, and /MAXIS can be&
         & combined to define the output projection and coordinates.'//strg_cr//&
         '- If /LIKE is provided, all other target-definition options are ignored&
         & and output projection and coordinates are copied from the&
         & reference cube.'//strg_cr//&
         '- REPROJECT changes the spatial grid while keeping non-spatial&
         & axes unchanged.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> REPROJECT cubeA /SPATIALFRAME EQUATORIAL /PTYPE TAN'//strg_cr//&
         'CUBE> REPROJECT cubeA /LAXIS 512 256 0 1 arcsec /MAXIS 512&
         & 256 0 1 arcsec'//strg_cr//&
         'CUBE> REPROJECT cubeA /LIKE refcube'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> HEADER cubeA'//strg_cr//&
         'CUBE> REPROJECT cubeA /LIKE refcube'//strg_cr//&
         'CUBE> HEADER reprojected'//strg_cr//&
         'CUBE> CONSISTENCY refcube reprojected',&
         cubemain_reproject_command,&
         'Reprojected',flag_reproject,error)
    if (error)  return
    !
    call comm%spafra%register(&
         'Define the spatial frame of the reprojected cube',&
         error)
    if (error) return
    !
    call comm%ptype%register(&
         'PTYPE',&
         'Define the new projection type',&
         error)
    if (error) return
    call comm%pcenter%register(&
         'PCENTER',&
         'Define the new projection center',&
         error)
    if (error) return
    call comm%pangle%register(&
         'PANGLE',&
         'Define the new projection angle',&
         error)
    if (error) return
    !
    call comm%laxis%register(&
         code_unit_fov,&
         'LAXIS',&
         'Define the l axis of the reprojected cube',&
         error)
    if (error) return
    call comm%maxis%register(&
         code_unit_fov,&
         'MAXIS',&
         'Define the m axis of the reprojected cube',&
         error)
    if (error) return
    !
    call cubemain_auxiliary_register(&
         'LIKE',&
         'Reproject onto the same grid as a reference cube',&
         strg_emp,&
         comm%like,&
         'Reference cube',&
         [flag_cube],&
         code_arg_mandatory, &
         code_access_imaset, &
         comm%like_arg, &
         error)
    if (error) return
  end subroutine cubemain_reproject_register
  !
  subroutine cubemain_reproject_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! REPROJECT [cubeid]
    ! /SPATIALFRAME name [equinox]
    ! /PTYPE type
    ! /PCENTER l0 m0 relative|absolute [unit]
    ! /PANGLE  pang [pangunit]
    ! /LAXIS n ref val inc [unit]
    ! /MAXIS n ref val inc [unit]
    ! /LIKE refcube
    !----------------------------------------------------------------------
    class(reproject_comm_t), intent(in)    :: comm
    character(len=*),        intent(in)    :: line
    type(reproject_user_t),  intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%init(error)
    if (error) return
    call comm%comm%parse(line,user%comm,error)
    if (error)  return
    call cubemain_auxiliary_parse(line,comm%like,user%like,error)
    if (error) return
    call comm%ptype%parse(line,user%ptype,error)
    if (error) return
    call comm%pcenter%parse(line,user%pcenter,error)
    if (error) return
    call comm%pangle%parse(line,user%pangle,error)
    if (error) return
    call comm%spafra%parse(line,user%spafra,error)
    if (error) return
    call comm%laxis%parse(line,user%newx,error)
    if (error) return
    call comm%maxis%parse(line,user%newy,error)
    if (error) return
  end subroutine cubemain_reproject_parse
  !
  subroutine cubemain_reproject_main(comm,user,error)
    use cubetools_header_types
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_comm_t), intent(in)    :: comm
    type(reproject_user_t),  intent(in)    :: user
    logical,                 intent(inout) :: error
    !
    type(reproject_prog_t) :: prog
    character(len=*), parameter :: rname='REPROJECT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) goto 10
    call prog%header(comm,error)
    if (error) goto 10
    call cubeadm_timing_prepro2process()
    call prog%data(prog%cube,prog%reprojected,error)
    if (error) goto 10
    call cubeadm_timing_process2postpro()
10  call cubetools_header_final(prog%ouhead,error)
  end subroutine cubemain_reproject_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_reproject_user_init(user,error)
    !----------------------------------------------------------------------
    ! Initialize at strg_star things that are should be kept as default in
    ! the case of the rotate command
    !----------------------------------------------------------------------
    class(reproject_user_t), intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>USER>INIT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    user%newx%n    = strg_star
    user%newx%ref  = strg_star
    user%newx%val  = strg_star
    user%newx%inc  = strg_star
    user%newx%unit = strg_star
    user%newy%n    = strg_star
    user%newy%ref  = strg_star
    user%newy%val  = strg_star
    user%newy%inc  = strg_star
    user%newy%unit = strg_star
  end subroutine cubemain_reproject_user_init
  !
  subroutine cubemain_reproject_user_toprog(user,reproject,prog,error)
    use cubetools_header_types
    use cubetools_header_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_user_t), intent(in)    :: user
    type(reproject_comm_t),  intent(in)    :: reproject
    type(reproject_prog_t),  intent(inout) :: prog
    logical,                 intent(inout) :: error
    !
    type(cube_t), pointer :: refcube
    character(len=*), parameter :: rname='REPROJECT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(reproject%comm%cube,user%comm%cubeids,prog%cube,error)
    if (error) return
    call cubetools_header_copy(prog%cube%head,prog%ouhead,error)
    if (error) return
    !
    ! Get input cube axes description in the prog%oldx and prog%oldy description
    call cubetools_header_get_axis_head_l(prog%cube%head,prog%oldx,error)
    if (error) return
    call cubetools_header_get_axis_head_m(prog%cube%head,prog%oldy,error)
    if (error) return
    !
    if (user%like%do) then
       ! Simple case => The grid is completly defined by the reference cube
       call cubemain_auxiliary_user2prog(reproject%like_arg,user%like,refcube,error)
       if (error) return
       call cubetools_header_spatial_like(refcube%head,prog%ouhead,error)
       if (error) return
       call cubemain_reproject_user_toprog_find_conv(&
            prog%cube%head%spa%fra,&
            prog%ouhead%spa%fra,&
            prog%conv,error)
       if (error) return
       !
       call cubetools_header_get_axis_head_l(prog%ouhead,prog%newx,error)
       if (error) return
       call cubetools_header_get_axis_head_m(prog%ouhead,prog%newy,error)
       if (error) return
    else      
       ! Complex case => We may need clear default when the user does not define everything
       ! First: User2prog user inputs
       call cubetools_header_get_axis_head_l(prog%ouhead,prog%newx,error)
       if (error) return
       call cubetools_header_get_axis_head_m(prog%ouhead,prog%newy,error)
       if (error) return
       call reproject%spafra%user2prog(user%spafra,prog%ouhead%spa%fra,error)
       if (error) return
       call reproject%ptype%user2prog(user%ptype,prog%ouhead%spa%pro,error)
       if (error) return
       call reproject%pcenter%user2prog(prog%ouhead%spa%fra,user%pcenter,prog%ouhead%spa%pro,error)
       if (error) return
       call reproject%pangle%user2prog(user%pangle,prog%ouhead%spa%pro,error)
       if (error) return
       !
       ! Second: Change of referential
       call cubemain_reproject_user_toprog_find_conv(&
            prog%cube%head%spa%fra,&
            prog%ouhead%spa%fra,&
            prog%conv,error)
       if (error) return
       call cubemain_reproject_user_toprog_center(prog%conv,prog%cube%head%spa,prog%ouhead%spa,error)
       if (error) return
       ! Third: Axis redefinition
       call cubemain_reproject_user_toprog_find_grid(user%newx,user%newy,prog,error)
       if (error) return
    endif
  end subroutine cubemain_reproject_user_toprog
  !
  subroutine cubemain_reproject_user_toprog_center(conv,old,new,error)
    use gkernel_interfaces
    use cubetools_spatial_types
    !----------------------------------------------------------------------
    ! Update projection center according to new spatial frame
    !----------------------------------------------------------------------
    type(reproject_conv_t), intent(in)    :: conv
    type(spatial_t),        intent(in)    :: old
    type(spatial_t),        intent(inout) :: new
    logical,                intent(inout) :: error
    !
    character(len=fram_l) :: frame
    character(len=*), parameter :: rname='REPROJECT>USER>TOPROG>CENTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (conv%code.eq.code_conv_none) return
    ! If The user has given explicit l0 and m0 no need to compute
    ! coordinates in new spatial frame, user can change just l0 or
    ! just m0.
    if ((new%pro%l0.ne.old%pro%l0).or.(new%pro%m0.ne.old%pro%m0)) return
    !
    if (conv%code.eq.code_conv_equ2gal) then
       call equ_gal(old%pro%l0,old%pro%m0,conv%eqin,  &
                    new%pro%l0,new%pro%m0,            &
                    error)
       if (error) return
    else if (conv%code.eq.code_conv_gal2equ) then
       call gal_equ(old%pro%l0,old%pro%m0,             &
                    new%pro%l0,new%pro%m0,conv%eqout,  &
                    error)
       if (error) return
    else if (conv%code.eq.code_conv_equ2equ) then
       call equ_equ(old%pro%l0,old%pro%m0,conv%eqin,  &
                    new%pro%l0,new%pro%m0,conv%eqout, &
                    error)
       if (error) return
    else
       call cubemain_message(seve%e,rname,'Unrecognized conversion code: '//trim(frame))
       error = .true.
       return
    endif
  end subroutine cubemain_reproject_user_toprog_center
  !
  subroutine cubemain_reproject_user_toprog_find_conv(oldframe,newframe,&
       conv,error)
    use cubetools_header_interface
    use cubetools_spafra_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spafra_t),         intent(in)    :: oldframe
    type(spafra_t),         intent(in)    :: newframe
    type(reproject_conv_t), intent(out)   :: conv
    logical,                intent(inout) :: error
    !
    logical :: converror,convicrs
    character(len=fram_l) :: newname, oldname
    real(kind=4), parameter :: eqicrs=2000.0  ! ICRS equinox when approximated to Equatorial
    character(len=*), parameter :: rname='REPROJECT>USER>TOPROG>FIND>CONV'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    converror = .false.
    convicrs = .false.
    select case (newframe%code)
    case (code_spaframe_icrs)
       if (oldframe%code.eq.code_spaframe_equatorial) then
          conv%code = code_conv_equ2equ
          convicrs = .true.
       elseif (oldframe%code.eq.code_spaframe_galactic) then
          conv%code = code_conv_gal2equ
          convicrs = .true.
       elseif (oldframe%code.eq.code_spaframe_icrs) then
          conv%code = code_conv_none
       else
          converror = .true.
       endif
    case (code_spaframe_galactic)
       if (oldframe%code.eq.code_spaframe_equatorial) then
          conv%code = code_conv_equ2gal
       elseif (oldframe%code.eq.code_spaframe_galactic) then
          conv%code = code_conv_none
       else if (oldframe%code.eq.code_spaframe_icrs) then
          conv%code = code_conv_equ2gal
          convicrs = .true.
       else
          converror = .true.
       endif
    case (code_spaframe_equatorial)
       if (oldframe%code.eq.code_spaframe_equatorial) then
          if (oldframe%equinox.ne.newframe%equinox) then
             ! Both Equatorial, but different equinox
             call cubemain_message(seve%i,rname,'Converting from equinox '//&
                  trim(equinox_name(oldframe%equinox))//  &
                  ' to '//trim(equinox_name(newframe%equinox)))
             conv%code = code_conv_equ2equ
          else
             ! Both Equatorial, same equinox
             conv%code = code_conv_none
          endif
       elseif (oldframe%code.eq.code_spaframe_galactic) then
          conv%code = code_conv_gal2equ
       else if (oldframe%code.eq.code_spaframe_icrs) then
          if (newframe%equinox.ne.eqicrs) then
             ! From ICRS to Equatorial but improper equinox
             call cubemain_message(seve%i,rname,'Converting from equinox '//&
                  trim(equinox_name(eqicrs))//  &
                  ' to '//trim(equinox_name(newframe%equinox)))
             conv%code = code_conv_equ2equ
          else
             ! From ICRS to EQ 2000: no conversion
             conv%code = code_conv_none
          endif
          convicrs = .true.
       else
          converror = .true.
       endif
    case (code_spaframe_unknown)
       if (oldframe%code.eq.code_spaframe_icrs) then
          converror = .true.
       elseif (oldframe%code.eq.code_spaframe_galactic) then
          converror = .true.
       elseif (oldframe%code.eq.code_spaframe_equatorial) then
          converror = .true.
       else
          conv%code = code_conv_none
       endif
    case default
       call cubemain_message(seve%w,rname,'Unknown spatial frame code, no conversion applied')
       conv%code = code_conv_none
    end select
    !
    if (converror) then
       call cubetools_convert_code2spaframe(oldframe%code,oldname,error)
       if (error) return
       call cubetools_convert_code2spaframe(newframe%code,newname,error)
       if (error) return
       call cubemain_message(seve%e,rname,'Cannot convert from '//oldname//' to '//newname)
       error = .true.
       return
    endif
    !
    ! Set up the from/to equinoxes
    if (oldframe%code.eq.code_spaframe_equatorial)  conv%eqin  = oldframe%equinox
    if (newframe%code.eq.code_spaframe_equatorial)  conv%eqout = newframe%equinox
    if (convicrs) then
      call cubemain_message(seve%w,rname,  &
        'Approximating ICRS system to equatorial '//equinox_name(eqicrs))
      if (oldframe%code.eq.code_spaframe_icrs)  conv%eqin  = eqicrs
      if (newframe%code.eq.code_spaframe_icrs)  conv%eqout = eqicrs
    endif
    !
  contains
    function equinox_name(equinox)
      real(kind=4), intent(in) :: equinox
      character(len=10) :: equinox_name
      !
      if (equinox.eq.equinox_null) then
         equinox_name = 'Unknown'
      else
         write(equinox_name,'(F0.2)') equinox
      endif
    end function equinox_name
  end subroutine cubemain_reproject_user_toprog_find_conv
  !
  subroutine cubemain_reproject_user_toprog_find_grid(newx,newy,prog,error)
    use gkernel_interfaces
    use gkernel_types
    use cubetools_spapro_types
    use cubetools_header_methods
    use cubetools_header_interface
    use cubetools_unit
    use cubetools_user2prog
    !----------------------------------------------------------------------
    ! Compute n, inc, and ref for X and Y reprojected axes.  The X and Y
    ! val are left unmodified. val.eq.0 means aligned on projection center.
    ! 
    ! *** JP should we use float or dble in this routine?
    !----------------------------------------------------------------------
    type(axis_user_t),      intent(in)    :: newx
    type(axis_user_t),      intent(in)    :: newy
    type(reproject_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    integer(kind=8), parameter :: one=1
    !
    logical :: warn,doxinc,doyinc,findgrid,doxref,doyref,doxn,doyn
    ! VVV has to be integer 4 for interface reasons...
    integer(kind=4) :: ier,ndp
    integer(kind=pixe_k) :: ix,iy,smartn
    real(kind=coor_k), allocatable :: dxd(:),indxd(:),oudxd(:)
    real(kind=coor_k), allocatable :: dyd(:),indyd(:),oudyd(:)
    real(kind=coor_k) :: sizex,sizey,ratio
    real(kind=coor_k) :: dxmin,dxmax
    real(kind=coor_k) :: dymin,dymax,boundary
    type(projection_t) :: proj
    type(unit_user_t) :: xunit, yunit
    real(kind=coor_k) :: default
    character(len=*), parameter :: rname='REPROJECT>USER>TOPROG>FIND>GRID'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    doxn   = newx%n.eq.strg_star
    doyn   = newy%n.eq.strg_star
    doxref = newx%ref.eq.strg_star
    doyref = newy%ref.eq.strg_star
    doxinc = newx%inc.eq.strg_star
    doyinc = newy%inc.eq.strg_star
    findgrid = doxinc.or.doyinc.or.doxref.or.doyref.or.doxn.or.doyn
    if (.not.findgrid) return
    !
    ! Allocation of work arrays
    allocate(dxd(prog%oldx%n*prog%oldy%n),dyd(prog%oldx%n*prog%oldy%n), stat=ier)
    if (failed_allocate(rname,'work arrays',ier,error)) return
    !
    ! Convert input projection to absolute coordinates
    call prog%cube%head%spa%pro%gwcs(proj,error)
    if (error) return
    ! Load data points
    ndp=0
    do iy=1,prog%oldy%n
       do ix=1,prog%oldx%n
          ndp = ndp+1
          dxd(ndp) = prog%oldx%coord(ix)
          dyd(ndp) = prog%oldy%coord(iy)
       enddo
    enddo
    !
    if (prog%conv%code.ne.code_conv_none) then
       ! Change coordinate spaframe and use new equinox
       allocate(indxd(ndp),indyd(ndp),oudxd(ndp),oudyd(ndp),stat=ier)
       if (failed_allocate(rname,'work arrays',ier,error)) return
       call rel_to_abs(proj,dxd,dyd,oudxd,oudyd,ndp)
       if (prog%conv%code.eq.code_conv_equ2gal) then
          call equ_gal(oudxd,oudyd,prog%conv%eqin,  &
                       indxd,indyd,                 &
                       ndp,error)
       elseif (prog%conv%code.eq.code_conv_gal2equ) then
          call gal_equ(oudxd,oudyd,                     &
                       indxd,indyd,prog%conv%eqout,     &
                       ndp,error)
       elseif (prog%conv%code.eq.code_conv_equ2equ) then
          call equ_equ(oudxd,oudyd,prog%conv%eqin,   &
                       indxd,indyd,prog%conv%eqout,  &
                       ndp,error)
       endif
       deallocate(oudxd,oudyd)
       if (error) return
    else
       allocate(indxd(ndp),indyd(ndp),stat=ier) 
       if (failed_allocate(rname,'work arrays',ier,error)) return
       call rel_to_abs(proj,dxd,dyd,indxd,indyd,ndp)
    endif
    !
    ! Setup Output projection
    call prog%ouhead%spa%pro%gwcs(proj,error)
    if (error) return
    !
    ! Convert Absolute coordinates to input projection
    call abs_to_rel(proj,indxd,indyd,dxd,dyd,ndp)
    !
    dxmin = minval(dxd(1:ndp))
    dymin = minval(dyd(1:ndp))
    dxmax = maxval(dxd(1:ndp))
    dymax = maxval(dyd(1:ndp))
    !
    ! Test extreme cases of unbound projections
    if (prog%ouhead%spa%pro%code.eq.p_gnomonic) then
       boundary = 1.5d0
    elseif (prog%ouhead%spa%pro%code.eq.p_stereo) then
       boundary = 1.0d0
    endif
    if (prog%ouhead%spa%pro%code.eq.p_gnomonic .or. &
         prog%ouhead%spa%pro%code.eq.p_stereo) then
       if (dxmin.lt.-boundary) then
          warn = .true.
          dxmin = -boundary
       endif
       if (dymin.lt.-boundary) then
          warn = .true.
          dymin = -boundary
       endif
       if (dxmax.gt.boundary) then
          warn = .true.
          dxmax = boundary
       endif
       if (dymax.gt.boundary) then
          warn = .true.
          dymax = boundary
       endif
       if (warn) then
          call cubemain_message(seve%w,rname,'Output Projection is unbound')
          call cubemain_message(seve%w,rname,'Will be limited to one hemisphere')
       endif
    endif
    !
    ! Image dimension and spatial increments
    sizex = dxmax-dxmin
    sizey = dymax-dymin
    ratio = sizex/sizey
    !
    call yunit%get_from_name_for_code(newy%unit,prog%newy%kind,error)
    if (error) return
    default = 0d0
    call cubetools_user2prog_resolve_all(newy%val,yunit,default,prog%oldy%val,prog%newy%val,error)
    if (error) return
    call xunit%get_from_name_for_code(newx%unit,prog%newx%kind,error)
    if (error) return
    default = 0d0
    call cubetools_user2prog_resolve_all(newx%val,xunit,default,prog%oldx%val,prog%newx%val,error)
    if (error) return
    !
    ! If user gave number of pixels, use it
    if (doyinc) then
       smartn = nint(sqrt(dble(prog%oldx%n*prog%oldy%n)*2d0/ratio))
       call cubetools_user2prog_resolve_all(newy%n,smartn,prog%oldy%n,prog%newy%n,error)
       if (error) return
    else
       default = prog%oldy%inc
       call cubetools_user2prog_resolve_all(newy%inc,yunit,default,prog%oldy%inc,prog%newy%inc,error)
       if (error) return
       prog%newy%n = sizey/abs(prog%newy%inc)+1
    endif  
    if (doxinc) then
       smartn = nint(dble(prog%newy%n)*ratio)
       call cubetools_user2prog_resolve_all(newx%n,smartn,prog%oldx%n,prog%newx%n,error)
       if (error) return
    else
       default = prog%oldx%inc
       call cubetools_user2prog_resolve_all(newx%inc,xunit,default,prog%oldx%inc,prog%newx%inc,error)
       if (error) return
       prog%newx%n = sizex/abs(prog%newx%inc)+1
    endif
    ! Sanity check
    if (prog%newx%n.le.0.or.prog%newy%n.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero sized image')
       error = .true.
       return
    endif
    ! Compute increments from dimensions if requested
    if (doxinc) prog%newx%inc = sizex/(prog%newx%n-1)
    if (doyinc) prog%newy%inc = sizey/(prog%newy%n-1)
    if (doxinc.and.doyinc) then
       ! Both Xinc and Yinc are automatic => At this stage the automatic
       ! increments may be slightly different because
       ! prog%newx%n/prog%newy%n differs slightly from sizex/sizey (nint()
       ! rounding). Equal increments are desirable. Select the one which
       ! ensures no loss of map coverage.
       if (prog%newx%inc.gt.prog%newy%inc) then
          prog%newy%inc = prog%newx%inc
       else
          prog%newx%inc = prog%newy%inc
       endif
    endif
    ! Keep input map conventions, if any
    if (doxinc .and. prog%oldx%inc.lt.0.d0) prog%newx%inc = -prog%newx%inc
    if (doyinc .and. prog%oldy%inc.lt.0.d0) prog%newy%inc = -prog%newy%inc
    !
    ! Reference pixels
    call cubemain_reproject_user_toprog_find_grid_ref(newx%ref,dxmin,dxmax,prog%newx,error)
    if (error) return
    call cubemain_reproject_user_toprog_find_grid_ref(newy%ref,dymin,dymax,prog%newy,error)
    if (error) return
    !
    select case(prog%ouhead%spa%fra%code)
    case (code_spaframe_galactic)
       prog%newx%name = 'Lii'
       prog%newy%name = 'Bii'
    case (code_spaframe_equatorial,code_spaframe_icrs)
       prog%newx%name = 'RA'
       prog%newy%name = 'DEC'
    case default
       prog%newx%name = 'L'
       prog%newy%name = 'M'
    end select
    !
    ! Update reprojected header
    call cubetools_header_update_axset_l(prog%newx,prog%ouhead,error)
    if (error) return
    call cubetools_header_update_axset_m(prog%newy,prog%ouhead,error)
    if (error) return
  end subroutine cubemain_reproject_user_toprog_find_grid
  !
  subroutine cubemain_reproject_user_toprog_find_grid_ref(user,min,max,new,error)
    use cubetools_user2prog
    use cubetools_unit
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    character(len=*),  intent(in)    :: user
    real(kind=coor_k), intent(in)    :: min
    real(kind=coor_k), intent(in)    :: max
    type(axis_t),      intent(inout) :: new
    logical,           intent(inout) :: error
    !
    real(kind=coor_k) :: smartref,previous
    type(unit_user_t) :: nounit
    character(len=*), parameter :: rname='REPROJECT>USER>TOPROG>FIND>GRID>REF'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (new%inc.gt.0.d0) then
       smartref = 1.d0-min/new%inc  ! ref so that 1st pixel (1.0) is aligned on dxmin
    else
       smartref = 1.d0-max/new%inc  ! ref (same at dmax)
    endif
    call nounit%get_from_code(code_unit_unk,error)
    if (error) return
    previous = new%ref
    call cubetools_user2prog_resolve_all(user,nounit,smartref,previous,new%ref,error)
    if (error) return
    ! Round ref to an integer value so that the projection center at the
    ! middle of a pixel. Use nearest value towards Nx/2+1 so that we stay as
    ! near as possible to the Fourier Transform solution.
    if (new%ref.lt.new%n/2.d0+1.d0) then
       new%ref = ceiling(new%ref)
    else
       new%ref = floor(new%ref)
    endif
  end subroutine cubemain_reproject_user_toprog_find_grid_ref
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_reproject_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_prog_t), intent(inout) :: prog
    class(reproject_comm_t), intent(in)    :: comm
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%comm%reprojected,prog%cube,prog%reprojected,error)
    if (error) return
    call cubetools_header_copy(prog%ouhead,prog%reprojected%head,error)
    if (error) return
  end subroutine cubemain_reproject_prog_header
  !
  subroutine cubemain_reproject_prog_precompute(prog,error)
    use gkernel_interfaces
    use gkernel_types
    use cubetools_spapro_types
    !----------------------------------------------------------------------
    ! Precomputes coordinates to speed up reprojection
    !----------------------------------------------------------------------
    class(reproject_prog_t), intent(inout) :: prog
    logical,                 intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=4) :: npoints
    integer(kind=pixe_k) :: ixou,iyou
    real(kind=coor_k) :: xvalin,yvalin,xpixin,ypixin,oldxref,oldxval,oldyref,oldyval
    real(kind=coor_k), allocatable :: xou(:,:),you(:,:),inxou(:),inyou(:),ouxou(:),ouyou(:)
    type(projection_t) :: proj
    character(len=*), parameter :: rname='REPROJECT>PROG>PRECOMPUTE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    npoints = prog%newx%n*prog%newy%n
    ! Setup Output projection
    call prog%reprojected%head%spa%pro%gwcs(proj,error)
    if (error) return
    !
    allocate(xou(prog%newx%n,prog%newy%n),you(prog%newx%n,prog%newy%n),stat=ier)
    if (failed_allocate(rname,'work arrays',ier,error)) return
    !
    ! Convert Output projection to Absolute coordinates
    do iyou=1,prog%newy%n
       do ixou=1,prog%newx%n
          xou(ixou,iyou) = prog%reprojected%head%spa%l%coord(ixou)
          you(ixou,iyou) = prog%reprojected%head%spa%m%coord(iyou)
       enddo
    enddo
    if (prog%conv%code.ne.code_conv_none) then
       allocate(inxou(npoints),inyou(npoints),ouxou(npoints),ouyou(npoints),stat=ier)
       if (failed_allocate(rname,'work arrays',ier,error)) return
       call rel_to_abs_1dn4(proj,xou,you,ouxou,ouyou,npoints)
       ! Change coordinate
       ! Warning: codes are reversed on purpose because we here
       !          start from the output map...
       if (prog%conv%code.eq.code_conv_equ2gal) then
          call gal_equ(ouxou,ouyou,                 &
                       inxou,inyou,prog%conv%eqin,  &
                       npoints,error)
       elseif (prog%conv%code.eq.code_conv_gal2equ) then
          call equ_gal(ouxou,ouyou,prog%conv%eqout,  &
                       inxou,inyou,                  &
                       npoints,error)
       elseif (prog%conv%code.eq.code_conv_equ2equ) then
          call equ_equ(ouxou,ouyou,prog%conv%eqout,  &
                       inxou,inyou,prog%conv%eqin,   &
                       npoints,error)
       endif
       if (error) return
    else
       allocate(inxou(npoints),inyou(npoints),stat=ier)
       if (failed_allocate(rname,'work arrays',ier,error)) return
       call rel_to_abs_1dn4(proj,xou,you,inxou,inyou,npoints)
    endif
    !
    ! Setup input projection
    call prog%cube%head%spa%pro%gwcs(proj,error)
    if (error) return    
    !
    ! Convert absolute coordinates to input projection
    call abs_to_rel_1dn4(proj,inxou,inyou,xou,you,npoints)
    !
    ! Force the conversion formula for input to be adapted to the
    ! NINT function that will be used on the reprojection. Now Xref=1.0
    oldxval = (1.0-prog%oldx%ref)*prog%oldx%inc+prog%oldx%val
    oldxref = 1.0
    oldyval = (1.0-prog%oldy%ref)*prog%oldy%inc+prog%oldy%val
    oldyref = 1.0
    !
    allocate(prog%ix(prog%newx%n,prog%newy%n),prog%iy(prog%newx%n,prog%newy%n),stat=ier)
    if (failed_allocate(rname,'Pixels',ier,error)) return
    allocate(prog%xfrac(prog%newx%n,prog%newy%n),prog%yfrac(prog%newx%n,prog%newy%n),stat=ier)
    if (failed_allocate(rname,'Pixel fractions',ier,error)) return
    !
    ! Precompute pixel fractions
    do iyou = 1,prog%newy%n
       do ixou = 1,prog%newx%n
          xvalin = xou(ixou,iyou)
          yvalin = you(ixou,iyou)
          xpixin = (xvalin-oldxval)/prog%oldx%inc+oldxref
          ypixin = (yvalin-oldyval)/prog%oldy%inc+oldyref
          prog%ix(ixou,iyou)    = int(xpixin)
          prog%iy(ixou,iyou)    = int(ypixin)
          prog%xfrac(ixou,iyou) = xpixin-dble(prog%ix(ixou,iyou))
          prog%yfrac(ixou,iyou) = ypixin-dble(prog%iy(ixou,iyou))
       enddo !ixou
    enddo ! iyou  
  end subroutine cubemain_reproject_prog_precompute
  !
  subroutine cubemain_reproject_prog_data(prog,incube,oucube,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! This function takes as arguments two cubes so that it can be
    ! used by an exterior caller
    !----------------------------------------------------------------------
    class(reproject_prog_t), intent(inout) :: prog
    type(cube_t),            intent(inout) :: incube
    type(cube_t),            intent(inout) :: oucube
    logical,                 intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='REPROJECT>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call prog%precompute(error)
    if (error) return
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,incube,oucube,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,incube,oucube,error) FIRSTPRIVATE(iter)
       if (.not.error) & 
          call prog%loop(incube,oucube,iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_reproject_prog_data
  !
  subroutine cubemain_reproject_prog_loop(prog,incube,oucube,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(reproject_prog_t),  intent(inout) :: prog
    type(cube_t),             intent(inout) :: incube
    type(cube_t),             intent(inout) :: oucube
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: inima,ouima
    character(len=*), parameter :: rname='REPROJECT>DATA>LOOP'
    !
    call inima%associate('inima',incube,iter,error)
    if (error) return
    call ouima%allocate('ouima',oucube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%act(iter%ie,inima,ouima,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_reproject_prog_loop
  !
  subroutine cubemain_reproject_prog_act(prog,ie,inima,ouima,error)
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(reproject_prog_t), intent(in)    :: prog
    integer(kind=entr_k),    intent(in)    :: ie
    type(image_t),           intent(inout) :: inima
    type(image_t),           intent(inout) :: ouima
    logical,                 intent(inout) :: error
    !
    integer(kind=pixe_k) :: ixou,iyou
    character(len=*), parameter :: rname='REPROJECT>PROG>ACT'
    !
    call inima%get(ie,error)
    if (error) return
    !
    do iyou=1,prog%newy%n
       do ixou=1,prog%newx%n
          if (prog%ix(ixou,iyou).lt.1 .or. prog%ix(ixou,iyou).ge.prog%oldx%n .or.&
               prog%iy(ixou,iyou).lt.1 .or. prog%iy(ixou,iyou).ge.prog%oldy%n) then
             ouima%val(ixou,iyou) = gr4nan
          else
             ouima%val(ixou,iyou) = &
             (1-prog%xfrac(ixou,iyou))*(1-prog%yfrac(ixou,iyou))*inima%val(prog%ix(ixou,iyou),prog%iy(ixou,iyou))+&
             prog%xfrac(ixou,iyou)*(1-prog%yfrac(ixou,iyou))*inima%val(prog%ix(ixou,iyou)+1,prog%iy(ixou,iyou))+&
             prog%xfrac(ixou,iyou)*prog%yfrac(ixou,iyou)*inima%val(prog%ix(ixou,iyou)+1,prog%iy(ixou,iyou)+1)+ &
             (1-prog%xfrac(ixou,iyou))*prog%yfrac(ixou,iyou)*inima%val(prog%ix(ixou,iyou),prog%iy(ixou,iyou)+1)
          endif
       enddo ! ixou
    enddo ! iyou
    !
    call ouima%put(ie,error)
    if (error) return
  end subroutine cubemain_reproject_prog_act
end module cubemain_reproject
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--- Entry subroutines -------------------------------------------------
!
subroutine classic_entry_init(file,xnum,maxsec,version,full,ed,error)
  use classic_interfaces, except_this=>classic_entry_init
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  ! Initialize the Entry for a new observation
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(inout) :: file     !
  integer(kind=entry_length), intent(in)    :: xnum     ! The corresponding Entry number
  integer(kind=4),            intent(in)    :: maxsec   ! Maximum number of sections the ed can describe
  integer(kind=4),            intent(in)    :: version  ! Observation version
  logical,                    intent(out)   :: full     ! File is full?
  type(classic_entrydesc_t),  intent(out)   :: ed       ! The new Entry Descriptor
  logical,                    intent(inout) :: error    ! Logical error flag
  !
  ! Allocate room for the entry index
  call entryindex_new(file,xnum,full,error)
  if (full.or.error)  return
  !
  ! Initialize the entry descriptor
  if (file%desc%version.eq.1) then
    call entrydesc_init_v1(ed,xnum,maxsec,version,error)
  else
    call entrydesc_init_v2(ed,xnum,maxsec,version,error)
  endif
  !
  ! Something else?
  !
end subroutine classic_entry_init
!
subroutine classic_entry_section_read(isec,lsec,sec,ed,buf,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_entry_section_read
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Read a section from an entry
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: isec    ! Section id
  integer(kind=data_length), intent(inout) :: lsec    ! Length of section (updated on return)
  integer(kind=4),           intent(inout) :: sec(*)  ! Section buffer
  type(classic_entrydesc_t), intent(in)    :: ed      ! The Entry Descriptor
  type(classic_recordbuf_t), intent(inout) :: buf     ! Working buffer
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RSEC'
  logical :: found
  integer(kind=4) :: jsec
  integer(kind=data_length) :: psec,i
  character(len=message_length) :: mess
  !
  call classic_entrydesc_secfind_one(ed,isec,found,jsec)
  !
  if (.not.found) then ! No section found
    write(mess,'(A,I0)') 'Absent section ',isec
    call classic_message(seve%w,rname,mess)
    error = .true.
    return
  endif
  !
  psec = lsec  ! Input length of buffer
  !
  ! lsec is updated to actual length read from disk.
  ! If the input buffer is too small, fill the buffer with only the
  ! beginning of the section. It is the responsibility of the caller
  ! to know that he may have missed some words (no warning here).
  lsec = min(lsec,ed%secleng(jsec))
  call recordbuf_read(ed%secaddr(jsec),lsec,sec,buf,error)
  !
  ! Fill end of buffer with zeroes
  do i=lsec+1,psec
    sec(i) = 0
  enddo
  !
end subroutine classic_entry_section_read
!
subroutine classic_entry_data_read(array,ndata,ed,buf,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_entry_data_read
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Read the 'data' block from the entry
  !---------------------------------------------------------------------
  integer(kind=data_length), intent(inout) :: ndata         ! Length in 32_bit words (updated)
  real(kind=4),              intent(out)   :: array(ndata)  ! Data itself
  type(classic_entrydesc_t), intent(in)    :: ed            ! The Entry Descriptor
  type(classic_recordbuf_t), intent(inout) :: buf           ! Working buffer
  logical,                   intent(inout) :: error         ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RDATA'
  character(len=message_length) :: mess
  !
  if (ndata.lt.ed%ldata) then
    ! Data array in memory is too short, it makes no sense to truncate implicitely
    write(mess,'(A,I0,A,I0,A)')  &
      'Data buffer too short in memory (',ndata,'<',ed%ldata,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ndata = ed%ldata
  call recordbuf_read(ed%adata,ndata,array,buf,error)
  if (error)  return
  !
end subroutine classic_entry_data_read
!
subroutine classic_entry_data_readsub(array,ndata,first,last,ed,buf,error)
  use classic_interfaces, except_this=>classic_entry_data_readsub
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Read a subset of the 'data' block from the entry
  !---------------------------------------------------------------------
  integer(kind=data_length), intent(inout) :: ndata         ! Length in 32_bit words (updated)
  real(kind=4),              intent(out)   :: array(ndata)  ! Data itself
  integer(kind=data_length), intent(in)    :: first         ! First data word to read
  integer(kind=data_length), intent(in)    :: last          ! Last data word to read
  type(classic_entrydesc_t), intent(in)    :: ed            ! The Entry Descriptor
  type(classic_recordbuf_t), intent(inout) :: buf           ! Working buffer
  logical,                   intent(inout) :: error         ! Logical error flag
  ! Local
  integer(kind=data_length) :: first2,last2,istart
  !
  ! Normal data: implicit truncate to appropriate size
  first2 = max(first,1_8)     ! Corrected first word (can not read before first data
                              ! word): is this really needed?
  last2 = min(last,ed%ldata)  ! Corrected last word (can not read beyond last data
                              ! word): is this really needed?
  istart = ed%adata+first2-1  ! First word address in entry
  ndata = last2-first2+1      ! Number of data words to read
  !
  call recordbuf_read(istart,ndata,array,buf,error)
  if (error)  return
  !
end subroutine classic_entry_data_readsub
!
subroutine classic_entry_section_add(isec,lsec,sec,ed,buf,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_entry_section_add
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Add a new section to an entry. Must not exist before.
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: isec    ! Section id
  integer(kind=data_length), intent(in)    :: lsec    ! Length of section
  integer(kind=4),           intent(in)    :: sec(*)  ! Section buffer
  type(classic_entrydesc_t), intent(inout) :: ed      ! The Entry Descriptor
  type(classic_recordbuf_t), intent(inout) :: buf     ! Working buffer
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WSEC'
  logical :: found
  integer(kind=4) :: jsec
  character(len=message_length) :: mess
  !
  ! Search for section id 'isec'
  call classic_entrydesc_secfind_one(ed,isec,found,jsec)
  if (found) then
    write(mess,'(A,I0,A)') 'Section ',isec,' already written'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  call entrydesc_section_add(ed,isec,lsec,error)
  if (error) then
    write(mess,'(A,I6)') 'Could not add section ',isec
    call classic_message(seve%e,rname,mess)
    return
  endif
  !
  call recordbuf_write(ed%secaddr(ed%nsec),lsec,sec,buf,error)
  if (error) return
  !
  ! Update nextrec/nextword? Not here, this will be done once
  ! when finalizing the observation (classic_entrydesc_write)
  !
end subroutine classic_entry_section_add
!
subroutine classic_entry_section_update(isec,lsec,sec,ed,buf,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_entry_section_update
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Update an old section in an entry. Must exist before.
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: isec    ! Section id
  integer(kind=data_length), intent(in)    :: lsec    ! Length of section
  integer(kind=4),           intent(in)    :: sec(*)  ! Section buffer
  type(classic_entrydesc_t), intent(in)    :: ed      ! The Entry Descriptor
  type(classic_recordbuf_t), intent(inout) :: buf     ! Working buffer
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WSEC'
  logical :: found
  integer(kind=4) :: jsec
  character(len=message_length) :: mess
  !
  ! Search for section id 'isec'
  call classic_entrydesc_secfind_one(ed,isec,found,jsec)
  if (.not.found) then
    write(mess,'(A,I0)') 'Absent section ',isec
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Sanity checks
  if (lsec.gt.ed%secleng(jsec)) then
    write(mess,'(A,I0)') 'Insufficient room available for section ',isec
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  call recordbuf_write(ed%secaddr(jsec),lsec,sec,buf,error)
  if (error) return
  !
  ! No need to update nextrec/nextword: we just updated data which already
  ! existed, and we did not exceeded its old size
  !
end subroutine classic_entry_section_update
!
subroutine classic_entry_data_add(array,ndata,ed,buf,error)
  use classic_interfaces, except_this=>classic_entry_data_add
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Write the 'data' block to the entry. Must not exist before.
  !---------------------------------------------------------------------
  integer(kind=data_length), intent(in)    :: ndata         ! Length in 32_bit words
  real(kind=4),              intent(in)    :: array(ndata)  ! Data itself
  type(classic_entrydesc_t), intent(inout) :: ed            ! The Entry Descriptor
  type(classic_recordbuf_t), intent(inout) :: buf           ! Working buffer
  logical,                   intent(inout) :: error         ! Logical error flag
  ! Local
  integer(kind=data_length) :: addr
  !
  addr = ed%nword+1
  !
  call recordbuf_write(addr,ndata,array,buf,error)
  if (error)  return
  !
  ed%ldata = ndata
  ed%adata = addr
  ed%nword = ed%nword+ndata
  !
  ! Update nextrec/nextword? Not here, this will be done once
  ! when finalizing the observation (classic_entrydesc_write)
  !
end subroutine classic_entry_data_add
!
subroutine classic_entry_data_update(array,ndata,ed,buf,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_entry_data_update
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Update the 'data' block to the entry. Must exist before.
  !---------------------------------------------------------------------
  integer(kind=data_length), intent(in)    :: ndata         ! Length in 32_bit words
  real(kind=4),              intent(in)    :: array(ndata)  ! Data itself
  type(classic_entrydesc_t), intent(inout) :: ed            ! The Entry Descriptor
  type(classic_recordbuf_t), intent(inout) :: buf           ! Working buffer
  logical,                   intent(inout) :: error         ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WDATA'
  integer(kind=data_length) :: addr
  !
  if (ndata.gt.ed%ldata) then
    call classic_message(seve%e,rname,  &
      'Insufficient space available for data array')
    error = .true.
    return
  endif
  !
  addr = ed%adata
  !
  call recordbuf_write(addr,ndata,array,buf,error)
  if (error)  return
  !
  ed%ldata = ndata
  ! ed%adata = data location unchanged
  ! ed%nword = entry size unchanged even if we use less words for data
  !
end subroutine classic_entry_data_update
!
subroutine classic_entry_close(file,buf,error)
  use classic_interfaces, except_this=>classic_entry_close
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Perform the needed operations when all the entry elements have
  ! been written.
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(inout) :: file   !
  type(classic_recordbuf_t), intent(in)    :: buf    !
  logical,                   intent(inout) :: error  !
  !
  if (file%desc%version.eq.1 .and. file%desc%nextword.ne.1) then
    ! If V1, realign free area at beginning of the next record
    file%desc%nextrec = file%desc%nextrec+1
    file%desc%nextword = 1
  endif
  !
  call recordbuf_close(buf,error)  ! Flush the working buffer
  if (error) return
  !
end subroutine classic_entry_close
!
!--- Entry Descriptor subroutines --------------------------------------
!
subroutine entrydesc_init_v1(ed,xnum,maxsec,version,error)
  use gbl_message
  use classic_interfaces, except_this=>entrydesc_init_v1
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !   Initialize the Entry Descriptor of a new observation, suited for
  ! a version 1 file
  !---------------------------------------------------------------------
  type(classic_entrydesc_t),  intent(out)   :: ed       ! The new Entry Descriptor
  integer(kind=entry_length), intent(in)    :: xnum     ! The corresponding Entry number
  integer(kind=4),            intent(in)    :: maxsec   ! Maximum number of sections the ed can describe
  integer(kind=4),            intent(in)    :: version  ! Observation version
  logical,                    intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ENTRYDESC_INIT'
  !
  if (version.ne.classic_vobs_v1) then
    call classic_message(seve%e,rname,'Wrong observation version number for V1 entry')
    error = .true.
    return
  endif
  !
  ed%msec = min(maxsec,classic_maxsec)  ! Decrease to what the memory can hold
  !
  ed%code  = code_entry
  ed%nword = entrydescv1_nw1+entrydescv1_nw2*ed%msec
  ed%adata = 0
  ed%ldata = 0
  ed%nsec = 0
  ed%xnum = xnum
  ed%version = classic_vobs_v1
  !
  ! Do not init these arrays: useless
  ! ed%seciden(:) = 0
  ! ed%secleng(:) = 0
  ! ed%secaddr(:) = 0
  !
end subroutine entrydesc_init_v1
!
subroutine entrydesc_init_v2(ed,xnum,maxsec,version,error)
  use classic_interfaces, except_this=>entrydesc_init_v2
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !   Initialize the Entry Descriptor of a new observation, suited for
  ! a version 2 file
  !---------------------------------------------------------------------
  type(classic_entrydesc_t),  intent(out)   :: ed       ! The new Entry Descriptor
  integer(kind=entry_length), intent(in)    :: xnum     ! The corresponding Entry number
  integer(kind=4),            intent(in)    :: maxsec   ! Maximum number of sections the ed can describe
  integer(kind=4),            intent(in)    :: version  ! Observation version
  logical,                    intent(inout) :: error    ! Logical error flag
  !
  ed%msec = min(maxsec,classic_maxsec)  ! Decrease to what the memory can hold
  !
  ed%code    = code_entry
  ed%version = version
  ed%nword   = entrydescv2_nw1+entrydescv2_nw2*ed%msec  ! Number of INTEGER*4 words
  ed%adata   = 0
  ed%ldata   = 0
  ed%nsec    = 0
  ed%xnum    = xnum
  !
  ! Do not init these arrays: useless
  ! ed%seciden(:) = 0
  ! ed%secleng(:) = 0
  ! ed%secaddr(:) = 0
  !
end subroutine entrydesc_init_v2
!
subroutine classic_entrydesc_read(file,buf,ed,error)
  use classic_interfaces, except_this=>classic_entrydesc_read
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  !   Read the Entry Descriptor
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: file   !
  type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
  type(classic_entrydesc_t), intent(inout) :: ed     ! The Entry Descriptor read
  logical,                   intent(inout) :: error  ! Logical error flag
  !
  if (file%desc%version.eq.1) then
    call entrydesc_read_v1(file,buf,ed,error)
  else
    call entrydesc_read_v2(file,buf,ed,error)
  endif
  !
end subroutine classic_entrydesc_read
!
subroutine entrydesc_read_v1(file,buf,edv2,error)
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>entrydesc_read_v1
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !   Read the Entry Descriptor, Version 1
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: file   !
  type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
  type(classic_entrydesc_t), intent(inout) :: edv2   ! The Entry Descriptor read
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ENTRYDESC_READ'
  integer(kind=4) :: len4
  integer(kind=4) :: ih(entrydescv1_nw1),isec(classic_maxsec)  ! Intermediate buffers
  integer(kind=data_length) :: addr,len8
  character(len=message_length) :: mess
  type(entrydesc_v1_t) :: ed
  !
  error = .false.
  !
  ! Read the beginning of the Entry Descriptor
  addr = 1
  len8 = entrydescv1_nw1  ! The first words of the Entry Descriptor
  len4 = len8
  if (file%conv%code.le.2) then
    ! Read directly the 9 I*4 values
    call recordbuf_read(addr,len8,ed%code,buf,error)
  else
    ! Can not convert inplace (not Fortran standard!), use an intermediate buffer (ih)
    call recordbuf_read(addr,len8,ih,buf,error)
    ed%code = ih(1)
    call file%conv%read%i4(ih(2),ed%nbloc,len4-1)
  endif
  if (error) return
  ed%msec = 0  ! Not in data. Play safe.
  !
  if (ed%code.ne.code_entry) then  ! Check this is the start of an entry (beginning of Entry Descriptor)
     error = .true.
     write(mess,'(A,I0,A,I0,A,I0)')  &
       'Attempt to read non-standard entry at record ',buf%rstart,': code ',  &
       ed%code,' instead of code ',code_entry
     call classic_message(seve%e,rname,mess)
     return
  endif
  !
  ! Read the Header Section Description
  buf%nrec = ed%nbloc
  addr = addr+len8
  len8 = ed%nsec  ! Number of sections
  len4 = len8
  !
  if (file%conv%code.le.2) then
    call recordbuf_read(addr,len8,ed%seciden,buf,error)  ! SecIden: section numbers
  else
    call recordbuf_read(addr,len8,isec,buf,error)
    call file%conv%read%i4(isec,ed%seciden,len4)
  endif
  if (error) return
  addr = addr+len8
  !
  if (file%conv%code.le.2) then
    call recordbuf_read(addr,len8,ed%secleng,buf,error)  ! SecLeng: section lengths
  else
    call recordbuf_read(addr,len8,isec,buf,error)
    call file%conv%read%i4(isec,ed%secleng,len4)
  endif
  if (error) return
  addr = addr+len8
  !
  if (file%conv%code.le.2) then
    call recordbuf_read(addr,len8,ed%secaddr,buf,error)  ! SecAddr: section address in observation
  else
    call recordbuf_read(addr,len8,isec,buf,error)
    call file%conv%read%i4(isec,ed%secaddr,len4)
  endif
  if (error) return
  ! addr = addr+len8
  !
  ! Fill the V2 memory structure
  call entrydesc_v1tov2(ed,edv2,error)
  if (error)  return
  !
end subroutine entrydesc_read_v1
!
subroutine entrydesc_v1tov2(ed1,ed2,error)
  use classic_interfaces, except_this=>entrydesc_v1tov2
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Convert a Version 1 Entry Descriptor to a Version 2
  !---------------------------------------------------------------------
  type(entrydesc_v1_t),      intent(in)    :: ed1    ! Version 1
  type(classic_entrydesc_t), intent(out)   :: ed2    ! Version 2
  logical,                   intent(inout) :: error  ! Logical error flag
  !
  ed2%code    = ed1%code
  ed2%version = classic_vobs_v1
  ed2%nword   = ed1%nword
  ed2%adata   = ed1%adata
  ed2%ldata   = ed1%ldata
  ed2%nsec    = ed1%nsec
  ed2%xnum    = ed1%xnum
  ed2%msec    = ed1%msec
  ed2%seciden(1:ed1%nsec) = ed1%seciden(1:ed1%nsec)
  ed2%secleng(1:ed1%nsec) = ed1%secleng(1:ed1%nsec)
  ed2%secaddr(1:ed1%nsec) = ed1%secaddr(1:ed1%nsec)
  !
end subroutine entrydesc_v1tov2
!
subroutine entrydesc_read_v2(file,buf,ed,error)
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>entrydesc_read_v2
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !   Read the Entry Descriptor, Version 2
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: file   !
  type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
  type(classic_entrydesc_t), intent(inout) :: ed     ! The Entry Descriptor read
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ENTRYDESC_READ'
  integer(kind=4) :: len4
  integer(kind=4) :: ih(entrydescv2_nw1)    ! Intermediate buffer for the entry descriptor
  integer(kind=4) :: isec4(classic_maxsec)  ! Intermediate buffer for seciden
  integer(kind=8) :: isec8(classic_maxsec)  ! Intermediate buffer for secaddr/secleng
  integer(kind=data_length) :: addr,len8
  character(len=message_length) :: mess
  !
  error = .false.
  !
  ! Read the beginning of the Entry Descriptor
  addr = 1
  len8 = entrydescv2_nw1  ! The first words of the Entry Descriptor
  len4 = len8
  !
  ! Can not convert inplace (not Fortran standard!), use an intermediate buffer (ih)
  ! Tricky part (part 1): we have to read the first 'entrydescv2_nw1' elements in
  ! the entry descriptor, but they can overlap 2 records. 'buf%nrec' should reflect
  ! this, else 'recordbuf_read' will stop with an error.
  buf%nrec = (buf%wstart+entrydescv2_nw1-2)/file%desc%reclen+1
  call recordbuf_read(addr,len8,ih,buf,error)
  if (error) return
  !
  ed%code = ih(1)
  if (ed%code.ne.code_entry) then  ! Check this is the start of an entry (beginning of Entry Descriptor)
     error = .true.
     write(mess,'(A,I0,A,I0,A,I0)')  &
       'Attempt to read non-standard entry at record ',buf%rstart,': code ',  &
       ed%code,' instead of code ',code_entry
     call classic_message(seve%e,rname,mess)
     return
  endif
  !
  call file%conv%read%i4(ih(2),ed%version,2)
  call file%conv%read%i8(ih(4),ed%nword,  4)
  ed%msec = 0  ! Not in data. Play safe.
  ! Tricky part (part 2): Now we know the exact size of the entry, use correct
  ! nrec.
  buf%nrec = (buf%wstart+ed%nword-2)/file%desc%reclen+1
  !
  ! Read the Header Section Description
  addr = addr+len8
  len8 = ed%nsec  ! Number of sections
  len4 = len8
  !
  ! Read the 'seciden' INTEGER*4 array
  if (file%conv%code.le.2) then
    call recordbuf_read(addr,len8,ed%seciden,buf,error)  ! SecIden: section numbers
  else
    call recordbuf_read(addr,len8,isec4,buf,error)
    call file%conv%read%i4(isec4,ed%seciden,len4)
  endif
  if (error) return
  addr = addr+len8
  !
  ! Read the 'secleng' INTEGER*8 array
  if (file%conv%code.le.2) then
    call recordbuf_read(addr,2*len8,ed%secleng,buf,error)  ! SecLeng: section lengths
  else
    call recordbuf_read(addr,2*len8,isec8,buf,error)
    call file%conv%read%i8(isec8,ed%secleng,len4)
  endif
  if (error) return
  addr = addr+2*len8
  !
  ! Read the 'secaddr' INTEGER*8 array
  if (file%conv%code.le.2) then
    call recordbuf_read(addr,2*len8,ed%secaddr,buf,error)  ! SecAddr: section address in observation
  else
    call recordbuf_read(addr,2*len8,isec8,buf,error)
    call file%conv%read%i8(isec8,ed%secaddr,len4)
  endif
  if (error) return
  ! addr = addr+2*len8
  !
end subroutine entrydesc_read_v2
!
subroutine classic_entrydesc_write(file,buf,ed,error)
  use classic_interfaces, except_this=>classic_entrydesc_write
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  !   Write the input Entry Descriptor
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(inout) :: file   !
  type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
  type(classic_entrydesc_t), intent(in)    :: ed     ! The Entry Descriptor to be written
  logical,                   intent(inout) :: error  ! Logical error flag
  !
! write (*,'(A,I0,1X,I0)') '>>> Write entry descriptor @ ',buf%rstart,buf%wstart
  if (file%desc%version.eq.1) then
    call entrydesc_write_v1(file,buf,ed,error)
  else
    call entrydesc_write_v2(file,buf,ed,error)
  endif
! write (*,'(A,I0,1x,I0)') '>>> Wrote entry descriptor @ ',buf%rstart,buf%wstart
  !
  ! Update the FILE descriptor about the fact that we wrote an entry
  ! (descriptor+sections+data) with nwords elements. Remark: we are not able
  ! to know if we wrote a new entry or updated an old one, but subroutine
  ! below is protected about this:
  call filedesc_update(buf,ed%nword,file%desc,error)
  if (error)  return
  !
end subroutine classic_entrydesc_write
!
subroutine entrydesc_write_v1(file,buf,edv2,error)
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>entrydesc_write_v1
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !   Write the input Entry Descriptor, Version 1
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: file   !
  type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
  type(classic_entrydesc_t), intent(in)    :: edv2   ! The Entry Descriptor to be written
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ENTRYDESC_WRITE'
  integer(kind=4) :: len4
  integer(kind=4) :: ih(entrydescv1_nw1),isec(classic_maxsec)  ! Intermediate buffers
  integer(kind=data_length) :: addr,len8
  character(len=message_length) :: mess
  type(entrydesc_v1_t) :: ed
  !
  if (buf%wstart.ne.1) then
    write(mess,'(A,I0,A)')  &
      'Entry descriptor should be written at beginning of record for V1 file (got ',buf%wstart,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  error = .false.
  !
  call entrydesc_v2tov1(edv2,ed,error)
  if (error)  return
  !
  if (ed%code.ne.code_entry) then
    error = .true.
    write(mess,'(A,I0,A,I0,A,I0)')  &
      'Attempt to write non-standard entry at record ',buf%rstart,': code ',  &
      ed%code,' instead of code ',code_entry
    call classic_message(seve%e,rname,mess)
    return
  endif
  !
  ! Write the beginning of the Entry Descriptor
  addr = 1
  len8 = entrydescv1_nw1  ! The first words of the Entry Descriptor
  len4 = len8
  if (file%conv%code.le.2) then
    ! Write directly the 9 I*4 values
    call recordbuf_write(addr,len8,ed%code,buf,error)
  else
    ! Can not convert inplace (not Fortran standard!), use an intermediate buffer.
    ih(1) = ed%code
    call file%conv%writ%i4(ed%nbloc,ih(2),len4-1)
    call recordbuf_write(addr,len8,ih,buf,error)
  endif
  if (error) return
  !
  ! Write the Header Section Description
  addr = addr+len8
  len8 = ed%nsec  ! Number of sections
  len4 = len8
  !
  if (file%conv%code.le.2) then
    call recordbuf_write(addr,len8,ed%seciden,buf,error)  ! SecIden: section numbers
  else
    call file%conv%writ%i4(ed%seciden,isec,len4)
    call recordbuf_write(addr,len8,isec,buf,error)
  endif
  if (error) return
  addr = addr+len8
  !
  if (file%conv%code.le.2) then
    call recordbuf_write(addr,len8,ed%secleng,buf,error)  ! SecLeng: section lengths
  else
    call file%conv%writ%i4(ed%secleng,isec,len4)
    call recordbuf_write(addr,len8,isec,buf,error)
  endif
  if (error) return
  addr = addr+len8
  !
  if (file%conv%code.le.2) then
    call recordbuf_write(addr,len8,ed%secaddr,buf,error)  ! SecAddr: section address in observation
  else
    call file%conv%writ%i4(ed%secaddr,isec,len4)
    call recordbuf_write(addr,len8,isec,buf,error)
  endif
  if (error) return
  ! addr = addr+len8
  !
end subroutine entrydesc_write_v1
!
subroutine entrydesc_v2tov1(ed2,ed1,error)
  use classic_interfaces, except_this=>entrydesc_v2tov1
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Convert a Version 2 Entry Descriptor to a Version 1
  !---------------------------------------------------------------------
  type(classic_entrydesc_t), intent(in)    :: ed2    ! Version 2
  type(entrydesc_v1_t),      intent(out)   :: ed1    ! Version 1
  logical,                   intent(inout) :: error  ! Logical error flag
  !
  ed1%code  = ed2%code
  call i8toi4_fini(ed2%nword,ed1%nword,1,error)
  if (error)  return
  ed1%nbloc = (ed2%nword-1)/classic_reclen_v1+1
  ed1%dumm4 = 0
  ed1%adata = ed2%adata
  ed1%ldata = ed2%ldata
  ed1%dumm7 = 0
  ed1%nsec  = ed2%nsec
  call i8toi4_fini(ed2%xnum,ed1%xnum,1,error)
  if (error)  return
  ed1%msec  = ed2%msec
  ed1%seciden(1:ed2%nsec) = ed2%seciden(1:ed2%nsec)
  ed1%secleng(1:ed2%nsec) = ed2%secleng(1:ed2%nsec)
  ed1%secaddr(1:ed2%nsec) = ed2%secaddr(1:ed2%nsec)
  !
end subroutine entrydesc_v2tov1
!
subroutine entrydesc_write_v2(file,buf,ed,error)
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>entrydesc_write_v2
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !   Write the input Entry Descriptor, Version 2
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: file   !
  type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
  type(classic_entrydesc_t), intent(in)    :: ed     ! The Entry Descriptor to be written
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ENTRYDESC_WRITE'
  integer(kind=4) :: len4
  integer(kind=data_length) :: addr,len8
  integer(kind=4) :: ih(entrydescv2_nw1)    ! Intermediate buffer for the entry descriptor
  integer(kind=4) :: isec4(classic_maxsec)  ! Intermediate buffer for seciden
  integer(kind=8) :: isec8(classic_maxsec)  ! Intermediate buffer for secaddr/secleng
  character(len=message_length) :: mess
  !
  error = .false.
  !
  if (ed%code.ne.code_entry) then
    error = .true.
    write(mess,'(A,I0,A,I0,A,I0)')  &
      'Attempt to write non-standard entry at record ',buf%rstart,': code ',  &
      ed%code,' instead of code ',code_entry
    call classic_message(seve%e,rname,mess)
    return
  endif
  !
  ! Write the beginning of the Entry Descriptor
  addr = 1
  len8 = entrydescv2_nw1  ! The first words of the Entry Descriptor
  !
  ! Can not convert inplace (not Fortran standard!), use an intermediate buffer.
  ih(1) = ed%code
  call file%conv%writ%i4(ed%version,ih(2),2)
  call file%conv%writ%i8(ed%nword,  ih(4),4)
  call recordbuf_write(addr,len8,ih,buf,error)
  if (error) return
  !
  ! Write the Header Section Description
  addr = addr+len8
  len8 = ed%nsec  ! Number of sections
  len4 = len8
  !
  ! Write the 'seciden' INTEGER*4 array
  if (file%conv%code.le.2) then
    call recordbuf_write(addr,len8,ed%seciden,buf,error)  ! SecIden: section numbers
  else
    call file%conv%writ%i4(ed%seciden,isec4,len4)
    call recordbuf_write(addr,len8,isec4,buf,error)
  endif
  if (error) return
  addr = addr+len8
  !
  ! Write the 'secleng' INTEGER*8 array
  if (file%conv%code.le.2) then
    call recordbuf_write(addr,2*len8,ed%secleng,buf,error)  ! SecLeng: section lengths
  else
    call file%conv%writ%i8(ed%secleng,isec8,len4)
    call recordbuf_write(addr,2*len8,isec8,buf,error)
  endif
  if (error) return
  addr = addr+2*len8
  !
  ! Write the 'secaddr' INTEGER*8 array
  if (file%conv%code.le.2) then
    call recordbuf_write(addr,2*len8,ed%secaddr,buf,error)  ! SecAddr: section address in observation
  else
    call file%conv%writ%i8(ed%secaddr,isec8,len4)
    call recordbuf_write(addr,2*len8,isec8,buf,error)
  endif
  if (error) return
  ! addr = addr+2*len8
  !
end subroutine entrydesc_write_v2
!
function classic_entrydesc_seclen(ed,iden)
  use classic_interfaces, except_this=>classic_entrydesc_seclen
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Return the length of the identified section (or 0 if missing).
  ! Unefficient if you call each section one by one.
  !---------------------------------------------------------------------
  integer(kind=4) :: classic_entrydesc_seclen
  type(classic_entrydesc_t), intent(in)  :: ed    ! The Entry Descriptor
  integer(kind=4),           intent(in)  :: iden  ! The section identifier
  ! Local
  logical :: found
  integer(kind=4) :: isec
  !
  call classic_entrydesc_secfind_one(ed,iden,found,isec)
  if (found) then
    classic_entrydesc_seclen = ed%secleng(isec)
  else
    classic_entrydesc_seclen = 0
  endif
  !
end function classic_entrydesc_seclen
!
subroutine classic_entrydesc_secfind_one(ed,iden,found,num)
  use classic_interfaces, except_this=>classic_entrydesc_secfind_one
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Find if 1 section is present in the input Entry Descriptor.
  ! Inefficient if you test each section one by one.
  !---------------------------------------------------------------------
  type(classic_entrydesc_t), intent(in)  :: ed     ! The Entry Descriptor
  integer(kind=4),           intent(in)  :: iden   ! The section identifier
  logical,                   intent(out) :: found  ! Section was found or not?
  integer(kind=4),           intent(out) :: num    ! The section number (if found)
  ! Local
  integer(kind=4) :: isec
  !
  found = .false.
  num = 0
  !
  do isec=1,ed%nsec
    if (ed%seciden(isec).eq.iden) then
      found = .true.
      num = isec
      exit
    endif
  enddo
  !
end subroutine classic_entrydesc_secfind_one
!
subroutine classic_entrydesc_secfind_all(ed,found,first,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_entrydesc_secfind_all
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !   Fill a 'found' array for all sections present or not. This assumes
  ! that the section identifiers (seciden(:) values) can be used as
  ! position index (maybe with an offset) in the 'found' array.
  !---------------------------------------------------------------------
  type(classic_entrydesc_t), intent(in)    :: ed        ! The Entry Descriptor
  logical,                   intent(out)   :: found(:)  ! Sections were found or not?
  integer(kind=4),           intent(in)    :: first     ! First index in the array (offset)
  logical,                   intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ENTRYDESC_FIND'
  character(len=message_length) :: mess
  integer(kind=4) :: isec,ind
  !
  found(:) = .false.
  !
  do isec=1,ed%nsec
    ind = ed%seciden(isec)-first+1
    !
    if (ind.lt.1 .or. ind.gt.ubound(found,1)) then
      write(mess,'(A,I0,A)')  &
        'Out of bounds section identifier (got ',ed%seciden(isec),')'
      call classic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    found(ind) = .true.
  enddo
  !
end subroutine classic_entrydesc_secfind_all
!
subroutine entrydesc_section_add(ed,iden,leng,error)
  use gbl_message
  use classic_interfaces, except_this=>entrydesc_section_add
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Add a new section in the Entry Descriptor. Assume it does not
  ! exist yet
  !---------------------------------------------------------------------
  type(classic_entrydesc_t), intent(inout) :: ed     ! The Entry Descriptor
  integer(kind=4),           intent(in)    :: iden   ! The section identifier
  integer(kind=data_length), intent(in)    :: leng   ! The section length
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WSEC'
  integer(kind=data_length) :: addr
  !
  if (ed%nsec.ge.ed%msec) then
    call classic_message(seve%e,rname,'Too many sections')
    error = .true.
    return
  endif
  !
  addr = ed%nword+1
  ed%nsec = ed%nsec+1
  ed%nword = ed%nword+leng
  ed%seciden(ed%nsec) = iden
  ed%secleng(ed%nsec) = leng
  ed%secaddr(ed%nsec) = addr
  !
end subroutine entrydesc_section_add
!
subroutine classic_entrydesc_dump(ed)
  use gbl_message
  use classic_interfaces, except_this=>classic_entrydesc_dump
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Dump the input Entry Descriptor
  !---------------------------------------------------------------------
  type(classic_entrydesc_t), intent(in) :: ed  ! The Entry Descriptor
  ! Local
  character(len=*), parameter :: rname='ENTRYDESC_DUMP'
  character(len=message_length) :: mess
  integer(kind=4) :: i
  !
  write(mess,100) 'Length in words ',     ed%nword
  call classic_message(seve%r,rname,mess)
  write(mess,100) 'Data address ',        ed%adata
  call classic_message(seve%r,rname,mess)
  write(mess,100) 'Data length (words) ', ed%ldata
  call classic_message(seve%r,rname,mess)
  write(mess,100) 'Obs. version ',        ed%version
  call classic_message(seve%r,rname,mess)
  write(mess,100) 'Number of sections ',  ed%nsec
  call classic_message(seve%r,rname,mess)
  if (ed%nsec.gt.0)  then
    write(mess,'(A,15(I0,1X))') 'Allocated sections ',(ed%seciden(i),i=1,ed%nsec)
    call classic_message(seve%r,rname,mess)
  endif
  do i=1,ed%nsec
    write(mess,'(4(A,I0))') '#',i,' code #',ed%seciden(i),  &
                                  ' addr ',ed%secaddr(i),    &
                                  ' leng ',ed%secleng(i)
    call classic_message(seve%r,rname,mess)
  enddo
  !
100 format(a,t21,i0)
end subroutine classic_entrydesc_dump

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehelp_check
  use sic_def
  use sic_types
  use cubetools_parameters
  use cubetools_structure
  use cube_messaging
  !
  public :: cubehelp_check_register
  private
  !
  type :: check_comm_t
    type(option_t), pointer :: check
  end type check_comm_t
  type(check_comm_t) :: comm
  !
  type :: check_user_t
    character(len=argu_l) :: topic
  contains
    procedure, private :: toprog => cubehelp_check_user_toprog
  end type check_user_t
  !
  type :: check_prog_t
    integer(kind=lang_k)   :: ilang
    integer(kind=comm_k)   :: icomm
    character(len=name_l)  :: lang
    character(len=name_l)  :: command
  contains
    procedure, private :: run => cubehelp_check_prog_run
  end type check_prog_t
  !
contains
  !
  subroutine cubehelp_check_register(error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='CHECK>REGISTER'
    !
    call cube_message(seve%t,rname,'Welcome')
    !
    call cubetools_register_command( &
         'CHECK','[LANG\]COMMAND',&
         'Print all online-help surfaces of one command',&
         'Display-only audit helper: CHECK prints command, option, and option-argument help surfaces for one target command.'&
         //strg_bl//&
         'Automation output contract:'//strg_cr//&
         '- emits one marker per rendered surface: Help surface: <surface-query>.'//strg_cr//&
         '- emits one final summary line: Help surfaces total: N.'//strg_cr//&
         '- invariant: N equals marker count and N >= 1 for successful runs.'//strg_bl//&
         'Associated commands: HELP\HELP, HELP\COLLECT.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         '  CUBE> HELP\CHECK SET\SPECTRAL',&
         cubehelp_check_command,&
         comm%check,error,&
         allowopt=.false.)
    if (error) return
    !
    call stdarg%register( &
         'COMMAND',&
         'Command name',&
         'Target command in COMMAND or LANG\COMMAND syntax (for example: SPECTRAL or SET\SPECTRAL).'//strg_cr//&
         'For audit automation, prefer fully-qualified LANG\COMMAND.',&
         code_arg_mandatory,&
         error)
    if (error) return
  end subroutine cubehelp_check_register
  !
  subroutine cubehelp_check_command(line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(check_user_t) :: user
    type(check_prog_t) :: prog
    !
    call cubehelp_check_parse(line,user,error)
    if (error) return
    call user%toprog(prog,error)
    if (error) return
    call prog%run(error)
    if (error) return
  end subroutine cubehelp_check_command
  !
  subroutine cubehelp_check_parse(line,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*),  intent(in)    :: line
    type(check_user_t),intent(out)   :: user
    logical,           intent(inout) :: error
    !
    user%topic = strg_emp
    call cubetools_getarg(line,comm%check,1,user%topic,mandatory,error)
    if (error) return
  end subroutine cubehelp_check_parse
  !
  subroutine cubehelp_check_user_toprog(user,prog,error)
    use cubetools_disambiguate
    use cubetools_language
    use cubetools_standard_comm
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(check_user_t), intent(in)    :: user
    type(check_prog_t),  intent(out)   :: prog
    logical,             intent(inout) :: error
    !
    integer(kind=inte_k) :: iquiet,isiccomm,ocode,ibsl,ier
    integer(kind=lang_k) :: ilang
    integer(kind=comm_k) :: icomm
    type(language_t), pointer :: language
    type(command_t),  pointer :: command
    character(len=name_l) :: lang
    character(len=argu_l) :: topic
    character(len=name_l) :: token_command,solved
    character(len=name_l), allocatable :: cnames(:)
    character(len=*), parameter :: rname='CHECK>USER>TOPROG'
    !
    call cubetools_disambiguate_toupper(user%topic,topic,error)
    if (error) return
    !
    iquiet = 1
    call sic_parse_command(topic,len_trim(topic),iquiet,.true.,ilang,isiccomm,ocode,error)
    if (error) then
      call cube_message(seve%e,rname,'Unable to resolve target '//trim(topic)//'. Use LANG\COMMAND when ambiguous.')
      return
    endif
    if (isiccomm.lt.1) then
      call cube_message(seve%e,rname,'Failed to resolve command target '//trim(topic))
      error = .true.
      return
    endif
    !
    ibsl = index(topic,backslash)
    if (ibsl.eq.0) then
      token_command = topic
    else if (ibsl.ge.len_trim(topic)) then
      call cube_message(seve%e,rname,'Missing command name in target '//trim(topic))
      error = .true.
      return
    else
      token_command = adjustl(topic(ibsl+1:len_trim(topic)))
    endif
    if (len_trim(token_command).le.0) then
      call cube_message(seve%e,rname,'Missing command name in target '//trim(topic))
      error = .true.
      return
    endif
    !
    call sic_ilang(ilang,lang)
    if (.not.cubetools_pack_has_language(lang)) then
      call cube_message(seve%e,rname,'Unknown package language '//trim(lang))
      error = .true.
      return
    endif
    !
    call pack%get_language_id(lang,prog%ilang,error)
    if (error) return
    language => cubetools_language_ptr(pack%lang%list(prog%ilang)%p,error)
    if (error) return
    !
    allocate(cnames(language%comm%n),stat=ier)
    if (ier.ne.0) then
      call cube_message(seve%e,rname,'Failed to allocate command list for disambiguation')
      error = .true.
      return
    endif
    do icomm=1,language%comm%n
      command => cubetools_command_ptr(language%comm%list(icomm)%p,error)
      if (error) return
      cnames(icomm) = command%name
    enddo
    !
    call cubetools_disambiguate_strict(token_command,cnames,prog%icomm,solved,error)
    if (error) return
    command => cubetools_command_ptr(language%comm%list(prog%icomm)%p,error)
    if (error) return
    prog%lang    = language%name
    prog%command = command%name
  end subroutine cubehelp_check_user_toprog
  !
  subroutine cubehelp_check_prog_run(prog,error)
    use cubetools_language
    use cubetools_standard_comm
    use cubetools_primitive_opt
    use cubetools_primitive_arg
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(check_prog_t), intent(in)    :: prog
    logical,             intent(inout) :: error
    !
    integer(kind=opti_k) :: iopt
    integer(kind=narg_k) :: iarg
    integer(kind=inte_k) :: nsurface
    type(language_t), pointer :: language
    type(command_t),  pointer :: command
    class(primitive_opt_t), pointer :: option
    class(primitive_arg_t), pointer :: argument
    character(len=mess_l) :: surface
    character(len=*), parameter :: rname='CHECK>PROG>RUN'
    !
    language => cubetools_language_ptr(pack%lang%list(prog%ilang)%p,error)
    if (error) return
    command => cubetools_command_ptr(language%comm%list(prog%icomm)%p,error)
    if (error) return
    !
    nsurface = 0
    !
    surface = trim(prog%lang)//backslash//trim(prog%command)//' ?'
    nsurface = nsurface+1
    call cubehelp_check_show_surface(surface)
    call cubehelp_check_prog_command_surface(prog,command,error)
    if (error) return
    !
    do iopt=1,command%opt%n
      option => cubetools_primitive_opt_ptr(command%opt%list(iopt)%p,error)
      if (error) return
      surface = trim(prog%lang)//backslash//trim(prog%command)//' /'//trim(option%name)//' ?'
      nsurface = nsurface+1
      call cubehelp_check_show_surface(surface)
      call option%summary(error)
      if (error) return
      !
      do iarg=1,option%arg%n
        argument => cubetools_primitive_arg_ptr(option%arg%list(iarg)%p,error)
        if (error) return
        surface = trim(prog%lang)//backslash//trim(prog%command)//' /'//trim(option%name) &
             //' '//trim(argument%name)//' ?'
        nsurface = nsurface+1
        call cubehelp_check_show_surface(surface)
        call argument%summary(error)
        if (error) return
      enddo
    enddo
    !
    if (nsurface.le.0) then
      call cube_message(seve%e,rname,'Internal error: HELP\\CHECK produced no help surface marker')
      error = .true.
      return
    endif
    !
    call cubehelp_check_show_count(nsurface)
  end subroutine cubehelp_check_prog_run
  !
  subroutine cubehelp_check_prog_command_surface(prog,command,error)
    use cubetools_terminal_tool
    use cubetools_primitive_opt
    use cubetools_primitive_prod
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(check_prog_t), intent(in)    :: prog
    type(command_t),      intent(in)    :: command
    logical,             intent(inout) :: error
    !
    integer(kind=opti_k) :: iopt
    integer(kind=prod_k) :: iprod
    class(primitive_opt_t), pointer :: option
    class(primitive_prod_t), pointer :: product
    character(len=*), parameter :: rname='CHECK>COMMAND>SURFACE'
    !
    call command%show_minimum(prog%lang,error)
    if (error) return
    !
    option => cubetools_primitive_opt_ptr(command%opt%list(0)%p,error)
    if (error) return
    call option%list(error)
    if (error) return
    !
    if (command%opt%n.gt.0) then
      call cube_message(seve%r,rname,terminal%dash_strg())
      do iopt=1,command%opt%n
        option => cubetools_primitive_opt_ptr(command%opt%list(iopt)%p,error)
        if (error) return
        call option%print_abstract(error)
        if (error) return
      enddo
    endif
    !
    if (command%prod%n.gt.0) then
      call cube_message(seve%r,rname,terminal%dash_strg())
      call cube_message(seve%r,rname,'  Products')
      do iprod=1,command%prod%n
        product => cubetools_primitive_prod_ptr(command%prod%list(iprod)%p,error)
        if (error) return
        call product%print_abstract(iprod,error)
        if (error) return
      enddo
    endif
    !
    call cube_message(seve%r,rname,blankstr)
  end subroutine cubehelp_check_prog_command_surface
  !
  subroutine cubehelp_check_show_surface(surface)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in) :: surface
    !
    character(len=*), parameter :: rname='CHECK>SURFACE'
    !
    ! Stable marker token for audit automation; keep literal prefix unchanged
    call cube_message(seve%r,rname,blankstr)
    call cube_message(seve%r,rname,'Help surface: '//trim(surface))
  end subroutine cubehelp_check_show_surface
  !
  subroutine cubehelp_check_show_count(nsurface)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=inte_k), intent(in) :: nsurface
    !
    character(len=argu_l) :: nstr
    character(len=*), parameter :: rname='CHECK>SUMMARY'
    !
    ! Contract: count must equal the number of emitted "Help surface:" markers
    write(nstr,'(i0)') nsurface
    call cube_message(seve%r,rname,'Help surfaces total: '//trim(nstr))
  end subroutine cubehelp_check_show_count
end module cubehelp_check
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine polyno_obs(set,obs,last,cont,flux,z,error)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>polyno_obs
  use class_types
  !---------------------------------------------------------------------
  ! @ private (?)
  ! Support routine for command BASE.
  ! This version for a single observation.
  ! Computes and remove a polynomial baseline. This version uses
  ! singular value decomposition, with fall back to Gauss Jordan if not
  ! possible.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(observation),   intent(inout) :: obs    ! The input observation to work on
  logical,             intent(inout) :: last   ! Use last baseline determination
  logical,             intent(in)    :: cont   ! Divide rather than subtract baseline
  real(kind=4),        intent(inout) :: flux   ! Flux value (if 0, average of base channels)
  real(kind=4),        intent(inout) :: z(*)   ! Working array
  logical,             intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='POLYNO'
  real(kind=4) :: m0,m1,m2
  real(kind=8) :: x_inc,x_off
  real(kind=4) :: s0,s1,s2,alim,s12,rd,s11,resid
  integer(kind=4) :: i,j,mmm,np,w2,status
  real(kind=4) :: a_coef(mdeg),pp(mdeg),chisq,xi,xx,yy
  real(kind=4) :: xmin,xmax,ymin,ymax
  real(kind=8) :: xoff,dxoff
  real(kind=4), allocatable, save :: x(:)
  integer(kind=4), allocatable, save :: w1(:)
  real(kind=4), allocatable, save :: weight(:),y(:)
  real(kind=4), allocatable :: ipu(:,:), ipv(:,:), ipw(:)
  character(len=80) :: chain
  !
  ! Don't like this, but it is for BASE LAST ... Warning: can not work
  ! for parallel processing
  save a_coef,mmm,xmin,xmax,xoff
  !
  if (allocated(x)) then
     if (ubound(x,1).ne.obs%cnchan) then
        if (last) then
           call class_message(seve%w,rname,'Number of channels changed, LAST mode ignored')
           last = .false.
        endif
        deallocate(x,y,weight,w1)
     endif
  endif
  if (.not.allocated(x)) then
     allocate(x(obs%cnchan),y(obs%cnchan))
     allocate(weight(obs%cnchan),w1(obs%cnchan))
  endif
  !
  ! Set up the arrays to be minimized
  if (obs%head%gen%kind.ne.kind_onoff) then
    call polyno_obs_arrays_spec(obs,last,x,y,weight,w1,np,error)
    if (error)  return
  else
    call polyno_obs_arrays_cont(obs,x,y,weight,w1,np,error)
    if (error)  return
  endif
  !
  ! Check that we have enough points: #(points) > polynom degree
  ! Note: np = sum(weight) NOT sum(w1)
  ! Note: polynom degree>=0 implies np>0
  if (np.le.obs%head%bas%deg.and..not.last) then
     error = .true.
     write(chain,*) 'Not enough channels to fit baseline: ',np,obs%head%bas%deg
     call class_message(seve%e,rname,chain)
     return
  endif
  !
  !  Determine the baseline
  if (last) then
    ! Compute Delta-X-offset, i.e. the difference of offsets between
    ! the LAST and the current X values, since these offsets are not
    ! in obs%datax
    if (set%unitx(1).eq.'F') then
      dxoff = obs%head%spe%restf - xoff
    elseif (set%unitx(1).eq.'I') then
      dxoff = obs%head%spe%image - xoff
    else
      dxoff = 0.d0
    endif
    !
  else
     mmm = min(obs%head%bas%deg+1,mdeg)
     xmin = x(1)
     xmax = x(np)
     if (set%unitx(1).eq.'F') then
       xoff = obs%head%spe%restf
     elseif (set%unitx(1).eq.'I') then
       xoff = obs%head%spe%image
     else
       xoff = 0.d0
     endif
     dxoff = 0.d0
     !
     !  Normalize range to [-1,1]
     do i=1,np
        x(i) = (2*x(i)-xmin-xmax)/(xmax-xmin)
     enddo
     !  Allocate work space for both methods
     allocate (ipv(mmm,mmm),stat=status)
     if (status.ne.0) then
        call class_message(seve%f,rname,'Insufficient memory for work space')
        error = .true.
        return
     endif
     allocate(ipu(np,mmm),ipw(mmm),stat=status)
     if (status.eq.0) then
        ! If possible, use singular value decomposition
        ! The 'mmm' coefficients are in array 'a_coef'
        call svdfit(x,y,weight,np,a_coef,mmm,ipu,ipv,ipw,np,mmm,chisq,fcheb,error)
        if (error) then
           call class_message(seve%e,rname,'Error in singular value decomposition')
        else
           !  Check for too high a degree
           call mindeg (ipw,mmm)
        endif
        deallocate(ipu,ipw)
        deallocate(ipv)
        if (error) return
     else
        !  Fall back on gauss-jordan inversion of the normal
        !  Equations when there is not enough memory
        call lfit(x,y,weight,np,a_coef,mmm,ipv,mmm,chisq,fcheb,error)
        deallocate(ipv)
        if (error) then
           call class_message(seve%e,rname,'Error during least square fit.')
           return
        endif
     endif
  endif
  !
  !  Compute baseline value for edges
  xx = -1.0
  call fcheb(xx,pp,mmm)
  yy = 0
  do j=1,mmm
     yy = yy+a_coef(j)*pp(j)
  enddo
  ymin = yy
  !
  xx = 1.0
  call fcheb(xx,pp,mmm)
  yy = 0
  do j=1,mmm
     yy = yy+a_coef(j)*pp(j)
  enddo
  ymax = yy
  !
  if (mmm.gt.2) then
     !  Degree > 1 => mmm.gt.2
     ! Compute polynomial in fitting range, constant value outside
     ! this range
     do i=1, obs%cnchan
        xi = obs%datax(i)+dxoff
        xx = ((xi-xmin)-(xmax-xi))/(xmax-xmin)
        if (xx.le.-1.0) then
           yy = ymin
        elseif (xx.ge.1.0) then
           yy = ymax
        else
           call fcheb(xx,pp,mmm)
           yy = 0
           do j=1,mmm
              yy = yy+a_coef(j)*pp(j)
           enddo
        endif
        z(i) = yy
     enddo
  else
     ! Degree 0 or 1 : compute polynomial everywhere (including
     ! extrapolation beyond edges)
     do i=1, obs%cnchan
        xi = obs%datax(i)+dxoff
        xx = ((xi-xmin)-(xmax-xi))/(xmax-xmin)
        yy = ymin + (xx+1.0)*(ymax-ymin)/2.0
        z(i) = yy
     enddo
  endif
  !
  !  Subtract the baseline and find the sigma
  s0 = 0.
  s1 = 0.
  s2 = 0.
  s11 = 0
  do i = 1, obs%cnchan
     !  Avoid bad channels
     if (obs%spectre(i).ne.obs%head%spe%bad) then
        resid = obs%spectre(i)-z(i)
        !  Continuum or spectral data
        if (.not.cont) then
           obs%spectre(i) = resid
        else
           obs%spectre(i) = obs%spectre(i)/z(i)
        endif
        if (w1(i).ne.0) then
           s0 = s0 + w1(i)
           s1 = s1 + w1(i)*resid
           s2 = s2 + w1(i)*resid**2
           if (cont) s11 = s11+w1(i)*z(i)
        endif
     endif
  enddo
  if (cont) then
     if (flux.eq.0 .and. s0.gt.0) then
        flux = s11/s0
        s11 = 1
     else
        s11 = flux/s11*s0
     endif
     write(chain,'(A,F0.3)') 'Average flux value: ',flux
     call class_message(seve%i,rname,chain)
     do i = 1, obs%cnchan
        if (obs%spectre(i).ne.obs%cbad) then
           obs%spectre(i) = obs%spectre(i)*flux
        endif
     enddo
     obs%head%gen%tsys = obs%head%gen%tsys*abs(s11)
     s1 = s1 * s11
     s2 = s2 * s11**2
  endif
  if (s0.ne.0) then
     s1 = s1 / s0          ! 1st order moment
     s2 = s2 / s0          ! 2bd order moment
     obs%head%bas%sigfi = sqrt(s2-s1**2)
  else
     obs%head%bas%sigfi = 0.
  endif
  !
  !  Area, velocity, width
  obs%head%bas%aire = 0.
  m0 = 0.  ! area
  m1 = 0.  ! 1st order moment
  m2 = 0.  ! 2nd order moment
  alim = obs%head%bas%sigfi * 3.0
  s0 = 0.
  s1 = 0.
  s2 = 0.
  do i = obs%cimin, obs%cimax
     !  Avoid bad channels
     w2 = 1-w1(i)       ! w2=1 means channel in window(s)
     if (w2.ne.0) then
        rd = obs_good(obs,i)  ! if channel is bad, repair it
        if (cont) then
           resid = rd-flux
        else
           resid = rd
        endif
        obs%head%bas%aire = obs%head%bas%aire + resid * w2
        if (abs(resid).ge.alim) then
           s0 = s0 + resid * w2
           s1 = s1 + resid * i * w2
           s2 = s2 + resid * float(i)**2 * w2
        endif
     endif
  enddo
  !
  ! Type out result according to kind
  ! - units of outputs (area,width,position) depend on X axis unit
  ! - obs%head%bas%area is stored with X unit in km/s
  if (obs%head%gen%kind.eq.kind_spec) then
     if (set%unitx(1).eq."V") then
        x_inc = obs%head%spe%vres
        x_off = obs%head%spe%voff
     else if (set%unitx(1).eq."F" .or. set%unitx(1).eq."I") then
        x_inc = obs%head%spe%fres
        x_off = 0.d0
     else if (set%unitx(1).eq."C") then
        x_inc = 1.d0
        x_off = obs%head%spe%rchan
     endif
     m0 = obs%head%bas%aire*abs(x_inc)
     obs%head%bas%aire = obs%head%bas%aire * abs(obs%head%spe%vres)
     if (s0.ne.0) then
        s1 = s1 / s0
        m1 = (s1-obs%head%spe%rchan)*x_inc+x_off
        s2 = s2 / s0
        s12 = s1**2
        if (s2.le.s12) s2 = s12
        m2 = abs(x_inc)*sqrt((s2-s12)*8.*alog(2.))
     endif
  else
     obs%head%bas%aire = obs%head%bas%aire * abs (obs%head%dri%ares)
     m0 = obs%head%bas%aire
     if (s0.ne.0) then
        s1 = s1 / s0
        m1 = (s1-obs%head%dri%rpoin) * obs%head%dri%ares + obs%head%dri%aref
        s2 = s2 / s0
        s12 = s1**2
        if (s2.le.s12) s2 = s12
        m2  =  abs (obs%head%dri%ares) * sqrt((s2-s12)*8.*alog(2.))
     endif
  endif
  !
  ! Output
  if (obs%head%bas%sigfi.ne.0.) then
     write(chain,'(a,i3,a,1pg10.3,a,1pg10.3,a,1pg11.4,a,1pg10.4)')  &
          'degree: ',obs%head%bas%deg,    &
          ' rms:',   obs%head%bas%sigfi,  &
          ' area:',  m0,                  &
          ' v0:',    m1,                  &
          ' width:', m2
  else
     write(chain,'(a,i3,a,a,1pg10.3,a,1pg11.4,a,1pg10.4)')  &
          'degree: ',obs%head%bas%deg,  &
          ' rms: not measured',         &
          ' area:',  m0,                &
          ' v0:',    m1,                &
          ' width:', m2
  endif
  call class_message(seve%i,rname,chain)
end subroutine polyno_obs
!
subroutine polyno_obs_arrays_spec(obs,last,x,y,weight,w1,np,error)
  use gbl_message
  use classcore_interfaces, except_this=>polyno_obs_arrays_spec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the X, Y, WEIGHT arrays with the valid points to be used for
  ! baselining. A valid point is not in a signal window and is not
  ! bad. The number of valid points is set in NP.
  !  Also fill the W1 array with 0 (in a signal window) or 1 (out a
  ! signal window), i.e. W1 is the representation of the signal windows
  ! as an array of channels.
  !  X, Y, WEIGHT and W1 must have been preallocated to the size
  ! obs%cnchan (i.e. the number of channels currently covered by SET
  ! MODE X), even if they are not entirely used in return.
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs        !
  logical,           intent(in)    :: last       ! Do we reuse the last fitting results?
  real(kind=4),      intent(out)   :: x(:)       ! X positions, in current DATAX units
  real(kind=4),      intent(out)   :: y(:)       ! Y intensities
  real(kind=4),      intent(out)   :: weight(:)  !
  integer(kind=4),   intent(out)   :: w1(:)      ! In or out the signal windows
  integer(kind=4),   intent(out)   :: np         !
  logical,           intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='POLYNO'
  integer(kind=4) :: i,i1,i2,i3,iw
  real(kind=4) :: vv
  integer(kind=4), pointer :: line(:)
  !
  ! Velocity increases or decreases with channel number, increment I3 = +/- 1
  if (obs%datax(obs%cnchan).gt.obs%datax(1)) then
    i1 = 1
    i2 = obs%cnchan
    i3 = 1
  else
    i1 = obs%cnchan
    i2 = 1
    i3 = -1
  endif
  !
  ! Loop on channels
  ! w1(i)=1 if channel i not in window
  ! weight(i)=1 if w1(i)=1 AND channel i not bad
  ! np = sum(weight)
  np = 0
  !
  if (obs%head%bas%nwind.eq.basnwind_assoc) then
    ! Automatic mode: no spectral windows; use Associated Array named "LINE"
    ! which provides, for each channel, 0 (out of a line) or 1 (in a line).
    if (.not.class_assoc_exists(obs,'LINE',line)) then
      call class_message(seve%e,rname,'Associated Array LINE does not exists')
      error = .true.
      return
    endif
    do i=i1, i2, i3
      w1(i) = 0
      if (i.lt.obs%cimin .or. i.gt.obs%cimax)  cycle
      if (line(i).eq.1)  cycle
      if (obs%spectre(i).ne.obs%head%spe%bad) then  !  Avoid bad channels
        np = np + 1
        weight(np)= +1.0
        x(np) = obs%datax(i)
        y(np) = obs%spectre(i)
      endif
      w1(i) = 1
    enddo
    !
  else
    ! Spectral windows are found in obs%head%bas%w1 and w2, which have been
    ! preset.
chanloop: do i=i1, i2, i3
      w1(i) = 0
      if (i.lt.obs%cimin .or. i.gt.obs%cimax)  cycle
      vv = obs%datax(i)
      !  Loop on spectral window(s)
      do iw = 1, obs%head%bas%nwind  ! Nwind can be zero
        ! Dichotomy-like test to check whether in or out of the signal window
        if ( (vv-obs%head%bas%w1(iw))*(vv-obs%head%bas%w2(iw)).lt.0.) then
          ! In a signal window. Skip this channel, but warn for
          ! extrapolation.
          if (i.ne.obs%cimin .and. i.ne.obs%cimax) then
            cycle chanloop
          elseif (.not.last .and. obs%head%bas%deg.gt.1) then
            ! This means a window overlaps a boundary of the SET MODE X
            ! range. What happens to the baselining in this boundary window?
            !  - degrees 0, 1 or sinus are extrapolated
            !  - degrees >=2 are not extrapolated, i.e. a constant value
            !    is used.
            ! In other words, when a window overlaps a SET MODE X boundary,
            ! the fitting range is not SET MODE X, but SET MODE X less the
            ! window. Out of the fitting range, the usual extrapolation rules
            ! apply.
            call class_message(seve%w,rname,'Baseline extrapolation is hazardous')
            cycle chanloop
          else
            cycle chanloop
          endif
        endif
      enddo
      if (obs%spectre(i).ne.obs%head%spe%bad) then  !  Avoid bad channels
        np = np + 1
        weight(np)= +1.0
        x(np) = obs%datax(i)
        y(np) = obs%spectre(i)
      endif
      w1(i) = 1
    enddo chanloop
  endif
  !
end subroutine polyno_obs_arrays_spec
!
subroutine polyno_obs_arrays_cont(obs,x,y,weight,w1,np,error)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Handle the special case of continuum on/off
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs        !
  real(kind=4),      intent(out)   :: x(:)       ! X positions, in current DATAX units
  real(kind=4),      intent(out)   :: y(:)       ! Y intensities
  real(kind=4),      intent(out)   :: weight(:)  !
  integer(kind=4),   intent(out)   :: w1(:)      ! In or out the signal windows
  integer(kind=4),   intent(out)   :: np         !
  logical,           intent(inout) :: error      !
  ! Global
  include 'gbl_pi.inc'  ! For epsr4
  ! Local
  integer(kind=4) :: i
  !
  ! Group the data points in pairs, and ignore windows.
  np = 1
  x(1) = obs%datax(1)
  y(1) = (obs%spectre(1)+obs%spectre(2))/2
  weight(1) = epsr4
  do i=1,obs%cnchan/2
    if (obs%spectre(2*i-1).ne.obs%cbad .and. obs%spectre(2*i).ne.obs%cbad) then
      np = np + 1
      weight(np)= +1.0
      x(np) = (obs%datax(2*i-1)+obs%datax(2*i))/2
      y(np) = (obs%spectre(2*i-1)+obs%spectre(2*i))/2
    endif
    w1(2*i)   = 1
    w1(2*i-1) = 1
  enddo
  np = np+1
  x(np) = obs%datax(obs%cnchan)
  y(np) = (obs%spectre(obs%cnchan)+obs%spectre(obs%cnchan-1))/2
  weight(np) = epsr4
  !
end subroutine polyno_obs_arrays_cont
!
subroutine mindeg(a,n)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS  Internal routine
  !    Warn if the polynomial degree is too high
  !---------------------------------------------------------------------
  integer, intent(in) :: n     ! Polynom degree + 1
  real,    intent(in) :: a(n)  ! RMS for each degree
  !
  ! Local variables
  integer :: imin
  character(len=32) :: chain
  !
  imin = minloc(a,1)
  if (imin.lt.n) then
     write(chain,'(A,I2,A)') 'Degree ',imin-1,' would be even better'
     call class_message(seve%i,'POLYNO',chain)
  endif
end subroutine mindeg

subroutine fit_message(fit,mseve,rname,message)
  use fit_minuit
  use gmath_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !  Print messages as usual, but they are owned by fit%owner, i.e.
  ! the message filter rules are those of the owner, not those of gmath
  ! ---
  !  Private to this file (i.e. to be used by MINUIT fitting routines
  ! only).
  !---------------------------------------------------------------------
  type(fit_minuit_t), intent(in) :: fit      !
  integer(kind=4),    intent(in) :: mseve    ! Message severity
  character(len=*),   intent(in) :: rname    ! Calling routine name
  character(len=*),   intent(in) :: message  !
  !
  ! if (fit%verbose) ... ???
  ! What about a "fit%rname" for a unique calling command name in messages?
  !
  call gmessage_write(fit%owner,mseve,rname,message)
  !
end subroutine fit_message
!
subroutine derive(fit,gg,gg2,fcn)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>derive
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ private
  ! Internal routine
  !      Calculates the first derivatives of FCN (GG),
  !      either by finite differences or by transforming the user-
  !      supplied derivatives to internal coordinates,
  !      according to whether ISW(3) is zero or one.
  !      if ISW(3) = 0, an error estimate GG2  is available
  !
  !      External routine FCN added to allow use of various
  !      minimization functions.
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit        !
  real(kind=8),       intent(inout) :: gg(ntot)   ! First derivatives of function FCN
  real(kind=8),       intent(out)   :: gg2(nvar)  ! Error estimate for variables
  external                          :: fcn        ! Function to minimise
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: iflag,i,lc
  real(kind=8) :: eps,xtf,fs1,fs2,dd
  real(kind=8) :: gy(ntot)
  logical :: passdata
  integer(kind=address_length) :: ipnt
  !
  passdata = fit%data.ne.0
  if (passdata)  ipnt = gag_pointer(fit%data,memory)
  !
  if (fit%isw(3).ne.1) then
     iflag = 4
     do i=1,fit%npar
        eps = 0.1d0 * dabs(fit%dirin(i))
        if (fit%isw(2) .ge. 1) eps = eps + 0.005d0*dsqrt(fit%v(i,i)*fit%up)
        !
        if (eps.lt.theprec*dabs(fit%x(i)))  eps = theprec*fit%x(i)
        xtf = fit%x(i)
        fit%x(i) = xtf + eps
        call intoex(fit,fit%x)
        if (passdata) then
          call fcn(fit%npar,gy,fs1,fit%u ,iflag,memory(ipnt))
        else
          call fcn(fit%npar,gy,fs1,fit%u ,iflag)
        endif
        fit%nfcn=fit%nfcn+1
        fit%x(i) = xtf - eps
        call intoex(fit,fit%x)
        if (passdata) then
          call fcn(fit%npar,gy,fs2,fit%u,iflag,memory(ipnt))
        else
          call fcn(fit%npar,gy,fs2,fit%u,iflag)
        endif
        fit%nfcn=fit%nfcn+1
        ! First derivative
        gg(i)= (fs1-fs2)/(2.0d0*eps)
        ! Error on first derivative
        gg2(i)= (fs1+fs2-2.0d0*fit%amin)/(2.0d0*eps)
        fit%x(i) = xtf
     enddo
     call intoex(fit,fit%x)
  else
     !
     ! Derivatives calculated by FCN
     do i= 1, fit%nu
        lc=fit%lcorsp(i)
        if (lc.ge.1) then
           if (fit%lcode(i) .le. 1) then
              gg(lc)=gg(i)
           else
              dd = (fit%blim(i)-fit%alim(i))*0.5d0 *dcos(fit%x(lc))
              gg(lc)=gg(i)*dd
           endif
        endif
     enddo
  endif
end subroutine derive
!
subroutine extoin(fit,pint)
  use gmath_interfaces, except_this=>extoin
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ public
  !      Transforms the external parameter values X  to internal
  !      values in the dense array PINT.   Function PINTF is used.
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit      !
  real(kind=8),       intent(out)   :: pint(2)  ! Dense array
  ! Local
  integer(kind=4) ::  i,j
  !
  fit%limset=0
  do i= 1, fit%nu
     j = fit%lcorsp(i)
     if (j.gt.0) then
        pint(j) = pintf(fit,fit%u(i),i)
     endif
  enddo
end subroutine extoin
!
subroutine fixpar(fit,i2,kode,ilax)
  use gbl_message
  use gmath_interfaces, except_this=>fixpar
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ private
  ! MINUIT      Internal routine
  !      Removes parameter I2 from the internal (variable) parameter
  !      list, and arranges the rest of the list to fill the hole.
  !      If KODE=0, I2 is an external number, otherwise internal.
  !      ILAX is returned as the external number of the parameter.
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit   !
  integer(kind=4),    intent(in)    :: kode  ! Indicates Internal (1) or External (0)
  integer(kind=4),    intent(in)    :: i2    ! Internal or external parameter number
  integer(kind=4),    intent(out)   :: ilax  ! External number
  ! Local
  character(len=*), parameter :: rname='FIXPAR'
  integer(kind=4) :: lc,it,ik,iq,kon,kon2,i,j
  real(kind=8) :: eps,yy(nvar)
  ! real(kind=8) :: v1(2)
  ! equivalence (v(1,1) , v1(1))  ! Removed (see below)
  integer(kind=4) :: ion,jon
  character(len=message_length) :: mess
  !
  if (kode.ge.0) then
     if (kode.eq.0) then
        !
        ! External parameter number specified
        i = i2
        if (i .gt. fit%nu)  goto 70
        if (i .lt. 1)  goto 70
     elseif  (kode.gt.0) then
        !
        ! Internal parameter number specified
        i = 0
        do iq= 1, fit%nu
           if (fit%lcorsp(iq).eq.i2) then
              i = iq
           endif
        enddo
        if (i.eq.0) goto 70
     endif
     !
     if (fit%lcorsp(i).le.0) goto 70
     !
     lc = fit%lcorsp(i)
     it = lc
     fit%lcorsp(i) = 0
     ilax = i
     fit%npar = fit%npar - 1
     fit%npfix = fit%npfix + 1
     fit%ipfix(fit%npfix) = i
     fit%xs(fit%npfix) = fit%x(lc)
     fit%xts(fit%npfix) = fit%xt(lc)
     eps = dabs(fit%dirin(lc)) * 10.d0
     if (fit%isw(2).ge.1)  eps = eps + dsqrt(dabs(fit%v(lc,lc))*fit%up)
     if (eps .lt. 0.01*theprec*dabs(fit%x(lc)))  eps = theprec*fit%x(lc)
     fit%wts(fit%npfix) = eps*0.1d0
     do ik= i, fit%nu
        if (fit%lcorsp(ik).gt.0)  then
           lc = fit%lcorsp(ik) - 1
           fit%lcorsp(ik) = lc
           fit%x(lc) = fit%x(lc+1)
           fit%xt(lc) = fit%xt(lc+1)
           fit%dirin(lc) = fit%dirin(lc+1)
        endif
     enddo
     !
     if (fit%isw(2) .le. 1) then
        fit%isw(2) = 0
        return
     endif
  endif
  !
  ! Remove one row and one column from variance matrix
  kon = 0
  if (fit%npar.le.0) return
  kon2 = 0
  do i= 1, fit%npar+1
     yy(i)=fit%v(i,it)
  enddo
  !
  do i= 1, fit%npar+1
     if (i.ne.it) then
        kon2 = kon2 + 1
        do j= 1, fit%npar+1
           if (j.ne.it)  then
              kon = kon + 1
              ! Replace this code with Equivalence between v1(1) and v(1,1)
              !          v1(kon)=v(j,i) - yy(j)*yy(i)/yy(it)
              ! by true index computation
              ion = (kon-1) / nvar  + 1
              jon = kon - nvar*jon
              fit%v(jon,ion) = fit%v(j,i) - yy(j)*yy(i)/yy(it)
           endif
        enddo
        kon = fit%maxint*kon2
     endif
  enddo
  !
  ! Check for well-behaved final matrix
  do i= 1, fit%npar
     if (fit%v(i,i) .le. 0.d0) then
        fit%isw(2) = 0
        if (fit%verbose)  &
          call fit_message(fit,seve%e,rname,'Covariance matrix ill-conditioned, Destroyed')
        return
     endif
     do j= 1, fit%npar
        if (i .ne. j)  then
           if (fit%v(i,j)**2 .ge. fit%v(i,i)*fit%v(j,j))  fit%v(i,j) = 0.d0
        endif
     enddo
  enddo
  return
  !
  ! Error return:   parameter already fixed
70 ilax = 0
  if (fit%verbose)  then
    write(mess,'(A,I0,A)')  'Parameter ',i,' was not variable'
    call fit_message(fit,seve%e,rname,mess)
  endif
end subroutine fixpar
!
subroutine hesse(fit,fcn)
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>hesse
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ public
  !      Calculates the full second-derivative matrix of FCN
  !      by taking finite differences.   Includes some safeguards
  !      against non-positive-definite matrices, and it may set
  !       off-diagonal elements to zero in attempt to force
  !      positiveness.
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit  !
  external                          :: fcn  ! Function to minimise
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='HESSE'
  character(len=message_length) :: mess
  logical :: goon
  integer(kind=4) :: ifaut1,ifaut2,iflag,npfn,npard,mdiag,id,i,j,icyc
  integer(kind=4) :: ifail,ifix
  real(kind=8) :: d,xtf,fs1,fs2,df,chan,xti,xtj,elem,r
  real(kind=8) :: yy(nvar),gy(ntot)
  real(kind=8) :: dfwant,dfzero,dfmin,dfmax
  logical :: passdata
  integer(kind=address_length) :: ipnt
  ! Data
  data dfwant, dfzero,       dfmin,   dfmax  &
     / 0.01d0, 0.00000001d0, 0.001d0, 0.1d0 /
  !
  passdata = fit%data.ne.0
  if (passdata)  ipnt = gag_pointer(fit%data,memory)
  ifaut2=0
  ifaut1=0
  iflag = 4
  npfn = fit%nfcn
  npard = fit%npar
  !                                        . . . . . . DIAGONAL ELEMENTS .
  mdiag = 0
  do id= 1, npard
     i = id + fit%npar - npard
     d = 0.02d0* dabs(fit%dirin(i))
     if (fit%isw(2) .ge. 1)  d = 0.02d0* dsqrt(dabs(fit%v(i,i))*fit%up)
     if (d.lt.theprec*dabs(fit%x(i)))  d = theprec*dabs(fit%x(i))
     do j= 1, fit%npar
        fit%v(i,j) = 0.d0
     enddo
     icyc = 0
     !
     ! Loop here
     goon = .true.
     do while (goon)
        fit%dirin(i) = d
        xtf = fit%x(i)
        fit%x(i) = xtf + d
        call intoex(fit,fit%x)
        if (passdata) then
          call fcn(fit%npar, gy, fs1, fit%u, iflag, memory(ipnt))
        else
          call fcn(fit%npar, gy, fs1, fit%u, iflag)
        endif
        fit%nfcn = fit%nfcn + 1
        fit%x(i) = xtf - d
        call intoex(fit,fit%x)
        if (passdata) then
          call fcn (fit%npar, gy, fs2, fit%u, iflag, memory(ipnt))
        else
          call fcn (fit%npar, gy, fs2, fit%u, iflag)
        endif
        fit%nfcn = fit%nfcn + 1
        fit%x(i) = xtf
        !
        ! Check if step sizes appropriate
        icyc = icyc + 1
        if (icyc.lt.4) then
           df = dmax1(dabs(fs1-fit%amin),dabs(fs2-fit%amin))/fit%up
           if (df.gt.dfmin) then
              if (df.lt.dfmax) then
                 goon = .false.
              else
                 chan = dsqrt(dfwant/df)
                 if (chan .lt. 0.001d0)  chan = 0.001d0
                 d = d*chan
              endif
           else
              if (df.gt.dfzero) then
                 chan = dsqrt(dfwant/df)
                 if (chan .lt. 0.001d0)  chan = 0.001d0
                 d = d*chan
              else
                 d = d*1000.d0
              endif
           endif
        else
           goon = .false.
        endif
     enddo
     !
     ! Get first and second derivative
     fit%g(i) = (fs1-fs2)/(2.0d0 * d)
     fit%g2(i) = (fs1 + fs2 - 2.0d0*fit%amin) / d**2
     yy(i) = fs1
     if (dabs(fit%g(i))+dabs(fit%g2(i)).gt.1.0d-30) then
        if (fit%g2(i) .le. 1.0d-30) then
           mdiag = 1
           ! write (fit%isyswr,510)  i
           ifaut2=ifaut2+1
        endif
        fit%v(i,i) = fit%g2(i)
     else
        !
        ! Fix a parameter if  G = G2 = 0.0 .
        if (fit%itaur .ge. 1) then
           mdiag = 1
           ! write (fit%isyswr,510)  i
           ifaut2=ifaut2+1
           fit%v(i,i) = fit%g2(i)
        else
           fit%isw(2) = 0
           call fixpar(fit,i,1,ifix)
           if (fit%verbose) then
              write (mess,460) ifix,fit%g(i),fit%g2(i)
              call fit_message(fit,seve%i,rname,mess)
           endif
           if (fit%npar .eq. 0)  mdiag = 1
        endif
     endif
  enddo
  !
  call intoex(fit,fit%x)
  if (mdiag .eq. 1)  go to 390
  fit%isw(2) = 1
  !
  ! Off-diagonal elements
  do i= 1, fit%npar-1
     do j= i+1, fit%npar
        if (fit%nfcnmx-fit%nfcn+npfn .lt. fit%npar) then
           if (fit%verbose) then
              write (mess,490) i,j-1
              call fit_message(fit,seve%i,rname,mess)
           endif
        else
           xti = fit%x(i)
           xtj = fit%x(j)
           fit%x(i) = xti + fit%dirin(i)
           fit%x(j) = xtj + fit%dirin(j)
           call intoex(fit,fit%x)
           if (passdata) then
             call fcn(fit%npar, gy, fs1, fit%u, iflag, memory(ipnt))
           else
             call fcn(fit%npar, gy, fs1, fit%u, iflag)
           endif
           fit%nfcn = fit%nfcn + 1
           fit%x(i) = xti
           fit%x(j) = xtj
           elem = (fs1+fit%amin-yy(i)-yy(j)) / (fit%dirin(i)*fit%dirin(j))
           if (elem**2 .ge. fit%g2(i)*fit%g2(j)) then
              elem = 0.d0
              ! write (mess,470)  i,j
              ! call fit_message(fit,seve%i,rname,mess)
              ifaut1=ifaut1+1
           endif
           fit%v(i,j) = elem
           fit%v(j,i) = elem
        endif
     enddo
  enddo
  !
  call intoex(fit,fit%x)
  call vermin(fit,fit%v,fit%maxint,fit%maxint,fit%npar,ifail)
  if (ifail .lt. 1)  go to 222
  if (fit%verbose)  &
     call fit_message(fit,seve%w,rname,'HESSE Matrix inversion fails')
  !
  ! Diagonal matrix only
216 continue
  if (fit%verbose)  &
     call fit_message(fit,seve%w,rname,'Only diagonal matrix produced')
  fit%isw(2) = 1
  do i= 1, fit%npar
     do j= 1, fit%npar
        fit%v(i,j) = 0.d0
     enddo
     fit%v(i,i) = 1.0d0/fit%g2(i)
  enddo
  mdiag = 1                    ! Was zero before...
  go to 223
  !
222 continue
  if (fit%verbose)  &
     call fit_message(fit,seve%i,rname,'Second derivative matrix inverted')
  fit%isw(2) = 2
  !
  ! Calculate  Estimated Distance to Mimimum
223 continue
  do i= 1, fit%npar
     do j= 1, fit%npar
        fit%v(i,j) = 2.0d0 * fit%v(i,j)
     enddo
  enddo
  fit%sigma = 0.d0
  do i= 1, fit%npar
     if (fit%v(i,i) .le. 0.d0) then
        ! write (fit%isyswr,510)  i
        ifaut2=ifaut2+1
        mdiag = 1
     endif
     r = 0.d0
     do j= 1, fit%npar
        if (i.ne.j) then
           if (fit%v(i,j)**2 .ge. dabs(fit%v(i,i)*fit%v(j,j))) then
              ! write (fit%isyswr, 470)  i,j
              ifaut1=ifaut1+1
              fit%v(i,j) = 0.d0
              fit%v(j,i) = 0.d0
           endif
        endif
        r = r + fit%v(i,j) * fit%g(j)
     enddo
     fit%sigma = fit%sigma + 0.5d0 *r *fit%g(i)
  enddo
  if (mdiag .eq. 1)  go to 390
  if (fit%sigma .gt. 0.d0)  go to 400
  if (fit%verbose)  &
     call fit_message(fit,seve%i,rname,'Matrix not positive-definite')
  go to 216
  !
390 continue
  fit%isw(2) = 0
  !
400 continue
  if (fit%verbose) then
     if (ifaut1.ne.0) then
        write(mess,600) ifaut1
        call fit_message(fit,seve%w,rname,mess)
     endif
     if (ifaut2.ne.0) then
      write(mess,610) ifaut2
      call fit_message(fit,seve%w,rname,mess)
     endif
  endif
  !
  return
  !
460 format (1x,'HESSE Parameter',i3,' has been fixed. ', &
          'First derivative ',e11.3,' Second derivative ',e11.3)
! 470 format (1x,'HESSE Covariance matrix not positive-definite. ', &
!           'Faulty element in position',2i3)
490 format (1x,'HESSE Call limit. Off-diagonal elements calculated', &
          ' only up to ',2i3)
! 510 format (1x,'HESSE Diagonal element',i5,' is zero or negative')
600 format (1x,'HESSE Covariance matrix not positive-definite.',i4,  &
           ' Faulty elements')
610 format (1x,'HESSE',i4,' Non-positive diagonal elements ')
end subroutine hesse
!
subroutine intoex(fit,pint)
  use gmath_interfaces, except_this=>intoex
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ public
  !      Transforms from internal coordinates (PINT) to external
  !      parameters (U).   The minimizing routines which work in
  !      internal coordinates call this routine before calling FCN.
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit      !
  real(kind=8),       intent(in)    :: pint(2)  ! Dense array
  ! Local
  integer(kind=4) :: i,j
  real(kind=8) :: al
  !
  do i= 1, fit%nu
     j = fit%lcorsp(i)
     if (j.gt.0) then
        if (fit%lcode(i) .eq. 1)  then
           fit%u(i) = pint(j)
        else
           al = fit%alim(i)
           fit%u(i) = al + 0.5d0*(dsin(pint(j))+1.0d0) * (fit%blim(i)-al)
        endif
     endif
  enddo
end subroutine intoex
!
subroutine migrad(fit,fcn,ier)
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>migrad
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ public
  !      Performs a local function minimization using basically the
  !      method of DAVIDON-FLETCHER-POWELL as modified by FLETCHER
  !      Ref. -- FLETCHER, COMP.J. 13,317 (1970)   "Switching method"
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit  !
  external                          :: fcn  ! Function to minimise
  integer(kind=4),    intent(out)   :: ier  ! Error condition flag for HESSE
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MIGRAD'
  character(len=message_length) :: mess
  integer(kind=4) :: ifaut1,iswtr,npfn,iflag,npard,i,ntry,negg2
  integer(kind=4) :: id,kg,nf,ns,j,iter,npargd,matgd
  real(kind=8) :: parn,rho2,rostop,trace,fs,d,xtf,fs1,fs2,xbeg,f
  real(kind=8) :: ri,gdel,denom,slam,f2,aa,bb,cc,tlam,f3,gvg,delgam,vgi
  real(kind=8) :: gami
  real(kind=8) :: gs(ntot) , r(nvar),xxs(nvar)
  real(kind=8) :: flnu(nvar), vg(nvar), vii(nvar)
  real(kind=8) :: slamin,slamax,tlamin,tlamax
  logical :: passdata
  integer(kind=address_length) :: ipnt
  ! Data
  data slamin,slamax,tlamin,tlamax/0.2d0, 3.0d0, 0.05d0, 6.0d0/
  !
  ier=0
  ifaut1=0
  if (fit%npar .le. 0)  return
  !
  passdata = fit%data.ne.0
  if (passdata)  ipnt = gag_pointer(fit%data,memory)
  iswtr = fit%isw(5) - fit%itaur
  npfn = fit%nfcn
  parn = fit%npar
  rho2 = 10.d0*fit%apsi
  rostop = sqrt(theprec) * fit%apsi
  trace=1.d0
  iflag=4
  if (fit%isw(3) .eq. 1)  iflag = 2
  fs = fit%amin
  go to 2
  !
  !   1 write (fit%isyswr,520)
1 ifaut1=ifaut1+1
  !
  ! Step sizes dirin
2 npard = fit%npar
  do i= 1, fit%npar
     d = 0.02d0* dabs(fit%dirin(i))
     if (fit%isw(2) .ge. 1)  d = 0.02d0 * dsqrt(dabs(fit%v(i,i))*fit%up)
     if (d.lt.theprec*dabs(fit%x(i)))  d = theprec*fit%x(i)
     fit%dirin(i) = d
  enddo
  !
  ! Starting gradient
  ntry = 0
4 negg2 = 0
  !      DO 10  ID= 1, NPARD
  do id=1, npard
     i = id + fit%npar - npard
     d = fit%dirin(i)
     xtf = fit%x(i)
     fit%x(i) = xtf + d
     call intoex(fit,fit%x)
     if (passdata) then
       call fcn(fit%npar,fit%g,fs1,fit%u,4,memory(ipnt))
     else
       call fcn(fit%npar,fit%g,fs1,fit%u,4)
     endif
     fit%nfcn = fit%nfcn + 1
     fit%x(i) = xtf - d
     call intoex(fit,fit%x)
     if (passdata) then
       call fcn(fit%npar,fit%g,fs2,fit%u,4,memory(ipnt))
     else
       call fcn(fit%npar,fit%g,fs2,fit%u,4)
     endif
     fit%nfcn = fit%nfcn + 1
     fit%x(i) = xtf
     gs(i) = (fs1-fs2)/(2.0d0 * d)
     fit%g2(i) = (fs1 + fs2 - 2.0d0*fit%amin) / d**2
     if (fit%g2(i) .gt. 1.0d-30)  go to 10
     !
     ! Search if G2 .LE. 0.
     !     write (fit%isyswr,520)
     ifaut1=ifaut1+1
     negg2 = negg2 + 1
     ntry = ntry + 1
     if (ntry .gt. 4)  go to 230
     d = 50.d0*dabs(fit%dirin(i))
     xbeg = xtf
     if (gs(i) .lt. 0.d0)  fit%dirin(i) = -fit%dirin(i)
     kg = 0
     nf = 0
     ns = 0
5    fit%x(i) = xtf + d
     call intoex(fit,fit%x)
     if (passdata) then
       call fcn(fit%npar,fit%g,f,fit%u,4,memory(ipnt))
     else
       call fcn(fit%npar,fit%g,f,fit%u,4)
     endif
     fit%nfcn = fit%nfcn + 1
     if (f .le. fit%amin)  go to 6
     !
     ! Failure
     if (kg .eq. 1)  go to 8
     kg = -1
     nf = nf + 1
     d = -0.4d0*d
     if (nf .lt. 10)  go to 5
     d = 1000.d0*d
     go to 7
     !
     ! Success
6    xtf = fit%x(i)
     d = 3.0d0*d
     fit%amin = f
     kg = 1
     ns = ns + 1
     if (ns .lt. 10)  go to 5
     if (fit%amin .lt. fs)  go to 8
     d = 0.001d0*d
7    xtf = xbeg
     fit%g2(i) = 1.0d0
     negg2 = negg2 - 1
8    fit%x(i) = xtf
     fit%dirin(i) = 0.1d0*d
     fs = fit%amin
10   continue
  enddo
  if (negg2 .ge. 1)  go to 4
  ntry = 0
  matgd = 1
  !
  ! Diagonal matrix
  if (fit%isw(2) .gt. 1)  go to 15
  !
11 ntry = 1
  matgd = 0
  do i= 1, fit%npar
     do j= 1, fit%npar
        fit%v(i,j) = 0.d0
     enddo
     fit%v(i,i) = 2.0d0/fit%g2(i)
  enddo
  !
  ! Get sigma and set up loop
15 fit%sigma = 0.d0
  do i= 1, fit%npar
     if (fit%v(i,i) .le. 0.d0)  go to 11
     ri = 0.d0
     do j= 1, fit%npar
        xxs(i) = fit%x(i)
        ri= ri+ fit%v(i,j) * gs(j)
     enddo
     fit%sigma = fit%sigma + gs(i) *ri *0.5d0
  enddo
  if (fit%sigma .ge. 0.d0)  go to 20
  !     write (fit%isyswr,520)
  ifaut1=ifaut1+1
  if (ntry.eq.0)  go to 11
  fit%isw(2) = 0
  go to 230
  !
20 fit%isw(2) = 1
  iter = 0
  call intoex(fit,fit%x)
  !
  ! Start main loop
24 continue
  gdel = 0.d0
  do i=1,fit%npar
     ri = 0.d0
     do j=1,fit%npar
        ri = ri + fit%v(i,j) *gs(j)
     enddo
     fit%dirin(i) = -0.5d0*ri
     gdel = gdel + fit%dirin(i)*gs(i)
     !
     ! Linear search along -VG
     fit%x(i) =xxs(i) + fit%dirin(i)
  enddo
  call intoex(fit,fit%x)
  if (passdata) then
    call fcn (fit%npar, fit%g, f, fit%u, 4, memory(ipnt))
  else
    call fcn (fit%npar, fit%g, f, fit%u, 4)
  endif
  fit%nfcn=fit%nfcn+1
  !
  ! Quadrupole interpolation using slope GDEL
  denom = 2.0d0*(f-fit%amin-gdel)
  if (denom .le. 0.d0) then
     slam = slamax
  else
     slam = -gdel/denom
     if (slam .gt. slamax) then
        slam = slamax
     elseif  (slam.lt.slamin) then
        slam = slamin
     endif
  endif
  if (dabs(slam-1.0d0) .lt. 0.1d0)  go to 70
  !
  do i= 1, fit%npar
     fit%x(i) = xxs(i) + slam*fit%dirin(i)
  enddo
  call intoex(fit,fit%x)
  if (passdata) then
    call fcn(fit%npar,fit%g,f2,fit%u,4,memory(ipnt))
  else
    call fcn(fit%npar,fit%g,f2,fit%u,4)
  endif
  fit%nfcn = fit%nfcn + 1
  !
  ! Quadrupole interpolation using 3 points
  aa = fs/slam
  bb = f/(1.0d0-slam)
  cc = f2/ (slam*(slam-1.0d0))
  denom = 2.0d0*(aa+bb+cc)
  if (denom .le. 0.d0) then
     tlam = tlamax
  else
     tlam = (aa*(slam+1.0d0) + bb*slam + cc)/denom
     if (tlam .gt. tlamax) then
        tlam = tlamax
     elseif  (tlam.lt.tlamin) then
        tlam = tlamin
     endif
  endif
  !
  !!50    CONTINUE
  do i= 1, fit%npar
     fit%x(i) = xxs(i)+tlam*fit%dirin(i)
  enddo
  call intoex(fit,fit%x)
  if (passdata) then
    call fcn(fit%npar,fit%g,f3,fit%u,4,memory(ipnt))
  else
    call fcn(fit%npar,fit%g,f3,fit%u,4)
  endif
  fit%nfcn = fit%nfcn + 1
  if (f.ge.fit%amin .and. f2.ge.fit%amin .and. f3.ge.fit%amin) go to 200
  !
  if (f.lt.f2 .and. f.lt.f3) then
     slam = 1.0d0
  elseif  (f.lt.f3) then
     f = f2
  else
     f = f3
     slam = tlam
  endif
  !
  do i= 1, fit%npar
     fit%dirin(i) = fit%dirin(i)*slam
     fit%x(i) = xxs(i) + fit%dirin(i)
  enddo
  !
70 fit%amin = f
  fit%isw(2) = 2
  if (fit%sigma+fs-fit%amin .lt. rostop)  go to 170
  if (fit%sigma+rho2+fs-fit%amin .gt. fit%apsi)  go to 75
  if (trace .lt. fit%vtest)  go to 170
75 continue
  if (fit%nfcn-npfn .ge. fit%nfcnmx)  go to 190
  iter = iter + 1
  !
  ! Get gradient and sigma
  if (fit%isw(3).eq.1) then
     call intoex(fit,fit%x)
     if (passdata) then
       call fcn(fit%npar,fit%g,fit%amin,fit%u,iflag,memory(ipnt))
     else
       call fcn(fit%npar,fit%g,fit%amin,fit%u,iflag)
     endif
     fit%nfcn = fit%nfcn + 1
  endif
  !
  call derive(fit,fit%g,fit%g2,fcn)
  rho2 = fit%sigma
  fit%sigma = 0.d0
  gvg = 0.d0
  delgam = 0.d0
  do i= 1, fit%npar
     ri = 0.d0
     vgi = 0.d0
     do j= 1, fit%npar
        vgi = vgi + fit%v(i,j)*(fit%g(j)-gs(j))
        ri = ri + fit%v(i,j) *fit%g (j)
     enddo
     r(i) = ri * 0.5d0
     vg(i) = vgi*0.5d0
     gami = fit%g(i) - gs(i)
     gvg = gvg + gami*vg(i)
     delgam = delgam + fit%dirin(i)*gami
     fit%sigma = fit%sigma + fit%g(i)*r(i)
  enddo
  if (fit%sigma .lt. 0.d0)  go to 1
  if (gvg .le. 0.d0)  go to 105
  if (delgam .le. 0.d0)  go to 105
  go to 107
105 if (fit%sigma .lt. 0.1d0*rostop)  go to 170
  go to 1
107 continue
  !
  ! Update covariance matrix
  trace=0.d0
  do i= 1, fit%npar
     vii(i) = fit%v(i,i)
     do j=1,fit%npar
        d = fit%dirin(i)*fit%dirin(j)/delgam - vg(i)*vg(j)/gvg
        fit%v(i,j) = fit%v(i,j) + 2.0d0*d
     enddo
  enddo
  if (delgam .gt. gvg) then
     do i= 1, fit%npar
        flnu(i) = fit%dirin(i)/delgam - vg(i)/gvg
     enddo
     do i= 1, fit%npar
        do j= 1, fit%npar
           fit%v(i,j) = fit%v(i,j) + 2.0d0*gvg*flnu(i)*flnu(j)
        enddo
     enddo
  endif
  do i= 1, fit%npar
     trace = trace + ((fit%v(i,i)-vii(i))/(fit%v(i,i)+vii(i)))**2
  enddo
  trace = dsqrt(trace/parn)
  xxs(1:fit%npar) = fit%x(1:fit%npar)
  gs(1:fit%npar)  = fit%g(1:fit%npar)
  fs = f
  go to 24
  !
  ! End main loop
170 continue
  if (fit%verbose)  &
     call fit_message(fit,seve%i,rname,'Minimization has converged')
  fit%isw(2) = 3
  iswtr = iswtr - 3*fit%itaur
  if (fit%itaur .gt. 0)  go to 435
  if (matgd .gt. 0)  go to 435
  npargd = fit%npar*(fit%npar+5)/2
  if (fit%nfcn-npfn .ge. npargd)  go to 435
  !
  if (fit%verbose)  &
     call fit_message(fit,seve%i,rname,  &
     'Covariance matrix inaccurate. HESSE will recalculate')
  !
  ! CALL HESSE fait par FITGAU si IER = 1
  if (fit%isw(2).ge.2)  fit%isw(2) = 3
  ier = 1
  go to 435
190 fit%isw(1) = 1
  go to 230
  !
200 continue
  if (fit%verbose)  &
     call fit_message(fit,seve%w,rname,'Fails to find improvement')
  fit%x(1:fit%npar) = xxs(1:fit%npar)
  fit%isw(2) = 1
  if (fit%sigma .lt. rostop)  go to 170
  if (matgd .gt. 0)  go to 2
  !
230 continue
  if (fit%verbose)  &
     call fit_message(fit,seve%i,rname,'Terminated without convergence')
  call intoex(fit,fit%x)
  iswtr = fit%isw(5) - fit%itaur*3
  ier = 3
  !
435 continue
  if (fit%verbose) then
     if (ifaut1.ne.0) then
        write(mess,700) ifaut1
        call fit_message(fit,seve%w,rname,mess)
     endif
  endif
  return
  !
700 format (1x,'MIGRAD Covariance matrix is not positive-definite ('  &
           ,i3,') times.')
end subroutine migrad
!
function pintf(fit,pexti,i)
  use gbl_message
  use gmath_interfaces, except_this=>pintf
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ public
  !      Calculates the internal parameter value PINTF corresponding
  !      to the external value PEXTI for parameter I.
  !----------------------------------------------------------------------
  real(kind=8) :: pintf  ! Function value on return
  type(fit_minuit_t), intent(inout) :: fit    !
  real(kind=8),       intent(inout) :: pexti  ! External value
  integer(kind=4),    intent(in)    :: i      ! Parameter number
  ! Local
  character(len=*), parameter :: rname='PINTF'
  integer(kind=4) :: igo
  real(kind=8) :: yy,alimi,blimi,a
  character(len=message_length) :: mess
  real(kind=8) :: big, small
  ! Data
  data big,small/ 1.570796326794897d0, -1.570796326794897d0/
  !
  igo = fit%lcode(i)
  !
  ! IGO = 1  means no limits
  if (igo.le.1) then
     pintf = pexti
  else
     !
     ! Others mean some limits
     alimi = fit%alim(i)
     blimi = fit%blim(i)
     if (pexti.lt.alimi) then
        a = small
     elseif  (pexti.eq.alimi) then
        pintf = small
        return
     elseif  (pexti.gt.blimi) then
        a = big
     elseif  (pexti.eq.blimi) then
        pintf = big
        return
     else
        yy=2.0d0*(pexti-alimi)/(blimi-alimi) - 1.0d0
        pintf = datan(yy/dsqrt(1.d0- yy**2) )
        return
     endif
     pintf = a
     pexti = alimi + 0.5d0* (blimi-alimi) *(dsin(a) +1.0d0)
     fit%limset=1
     if (fit%verbose) then
       write(mess,'(A,I0,A)') 'Variable ',i,' has been brought back inside limits'
       call fit_message(fit,seve%w,rname,mess)
     endif
  endif
  !
end function pintf
!
subroutine razzia(fit,ynew,pnew,ier)
  use gbl_message
  use gmath_interfaces, except_this=>razzia
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ private
  ! MINUIT      Internal routine
  !      Called only by SIMPLEX (and IMPROV) to add a new point
  !      and remove an old one from the current simplex, and get the
  !      estimated distance to minimum.
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit         !
  real(kind=8),       intent(in)    :: ynew        !
  real(kind=8),       intent(in)    :: pnew(nvar)  !
  integer(kind=4),    intent(out)   :: ier         !
  ! Local
  character(len=*), parameter :: rname='RAZZIA'
  integer(kind=4) :: i,j
  real(kind=8) :: us,pbig,plit
  character(len=message_length) :: mess
  !
  do i=1,fit%npar
     fit%p(i,fit%jh)=pnew(i)
  enddo
  fit%y(fit%jh)=ynew
  !
  if (ynew.lt.fit%amin) then
     do i=1,fit%npar
        fit%x(i)=pnew(i)
     enddo
     call intoex(fit,fit%x)
     fit%amin=ynew
     fit%jl=fit%jh
  endif
  !
  fit%jh=1
  do j=2,fit%npar+1
     if (fit%y(j) .gt. fit%y(fit%jh))  fit%jh = j
  enddo
  !
  fit%sigma = fit%y(fit%jh) - fit%y(fit%jl)
  if (fit%sigma .le. 0.d0)  then
     write (mess,'(A,I0,A)') 'Function value does not seem to depend on any of the ',  &
       fit%npar,' variable parameters'
     call fit_message(fit,seve%w,rname,mess)
     call fit_message(fit,seve%w,rname,'Check input parameters and try again')
     ier = 4
  else
     us = 1.0d0/fit%sigma
     do i = 1, fit%npar
        pbig = fit%p(i,1)
        plit = pbig
        do j= 2, fit%npar+1
           if (fit%p(i,j) .gt. pbig)  pbig = fit%p(i,j)
           if (fit%p(i,j) .lt. plit)  plit = fit%p(i,j)
        enddo
        fit%dirin(i) = pbig - plit
        if (fit%itaur .lt. 1 )  fit%v(i,i) = 0.5d0*(fit%v(i,i) +us*fit%dirin(i)**2)
     enddo
  endif
  !
end subroutine razzia
!
subroutine restor(fit,k)
  use gbl_message
  use gmath_interfaces, except_this=>restor
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ private
  ! MINUIT      Internal routine
  !      Restores a fixed parameter to variable status
  !      by inserting it into the internal parameter list at the
  !      appropriate place.
  !
  !       K = 0 means restore all parameters
  !       K = 1 means restore the last parameter fixed
  !       K = -I means restore external parameter I (if possible)
  !       IQ = fix-location where internal parameters were stored
  !       IR = external number of parameter being restored
  !       IS = internal number of parameter being restored
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit  !
  integer(kind=4),    intent(in)    :: k    ! Code for operation
  ! Local
  character(len=*), parameter :: rname='RESTORE'
  integer(kind=4) :: ka,ik,ipsav,i,ir,is,ij,lc,iq
  real(kind=8) :: xssav,xtssav,wtssav
  logical :: goon
  character(len=message_length) :: mess
  !
  if (fit%npfix.lt.1 .and. fit%verbose)  &
    call fit_message(fit,seve%i,rname,'There are no more fixed parameters')
  !
  ! Not the last one in list
  if (k.gt.1) then
     !
     ! Release parameter with specified external number
     ka = iabs(k)
     if (fit%lcorsp(ka) .ne. 0) return  ! not fixed
     ik = 0
     do i = 1, fit%npfix
        if (fit%ipfix(i) .eq. ka)  ik = i
     enddo
     if (ik.eq.0) then
        if (fit%verbose)  &
          call fit_message(fit,seve%i,rname,'Parameter specified has never been variable')
        return
     endif
     !
     ! Not the last one in list ?
     if (ik.ne.fit%npfix) then
        !
        ! Move specified parameter to end of list
        ipsav = fit%ipfix(ik)
        xssav = fit%xs(ik)
        xtssav = fit%xts(ik)
        wtssav = fit%wts(ik)
        do i= ik+1,fit%npfix
           fit%ipfix(i-1) = fit%ipfix(i)
           fit%xs(i-1) = fit%xs(i)
           fit%xts(i-1) = fit%xts(i)
           fit%wts(i-1) = fit%wts(i)
        enddo
        fit%ipfix(fit%npfix) = ipsav
        fit%xs(fit%npfix) = xssav
        fit%xts(fit%npfix) = xtssav
        fit%wts(fit%npfix) = wtssav
     endif
  endif
  !
  ! Restore last parameter in list  -- IPFIX(NPFIX)
  goon = fit%npfix.ge.1
  do while (goon)
     ir = fit%ipfix(fit%npfix)
     is = 0
     do ij= ir, fit%nu
        ik = fit%nu + ir - ij
        if (fit%lcorsp(ik).gt.0) then
           lc = fit%lcorsp(ik) + 1
           is = lc - 1
           fit%lcorsp(ik) = lc
           fit%x(lc) = fit%x(lc-1)
           fit%xt(lc) = fit%xt(lc-1)
           fit%dirin(lc) = fit%dirin(lc-1)
        endif
     enddo
     !
     fit%npar = fit%npar + 1
     if (is .eq. 0)   is = fit%npar
     fit%lcorsp(ir) = is
     iq = fit%npfix
     fit%x(is) = fit%xs(iq)
     fit%xt(is) = fit%xts(iq)
     fit%dirin(is) = fit%wts(iq)
     fit%npfix = fit%npfix - 1
     fit%isw(2) = 0
     if (fit%itaur.lt.1 .and. fit%verbose) then
       write(mess,'(A,I0,A)')  'Parameter ',ir,' restored to variable'
       call fit_message(fit,seve%i,rname,mess)
     endif
     !
     if (k.ne.0) goon = .false.
     if (fit%npfix.lt.1) goon = .false.
  enddo
  !
end subroutine restor
!
subroutine simplx(fit,fcn,ier)
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>simplx
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ public
  !      Performs a minimization using the SIMPLEX method of NELDER
  !      and MEAD (REF. -- COMP. J. 7,308 (1965)).
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit  !
  external                          :: fcn  ! Function to minimize
  integer(kind=4),    intent(out)   :: ier  ! Error condition flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='SIMPLX'
  integer(kind=4) :: npfn,nparp1,iflag,i,j,k,kg,ns,nf,ignal,ncycl,jhold
  real(kind=8) :: rho1,rho2,wg,ynpp1,absmin,aming,bestx,sig2,pb
  real(kind=8) :: ystar,ystst,y1,y2,rho,yrho,ypbar,f
  real(kind=8) :: alpha, beta, gamma, rhomin, rhomax
  logical :: passdata
  integer(kind=address_length) :: ipnt
  ! Data
  data  alpha, beta,  gamma, rhomin, rhomax  &
      / 1.0d0, 0.5d0, 2.0d0, 4.0d0,  8.0d0 /
  !
  ier=0
  if (fit%npar .le. 0)  return
  !
  passdata = fit%data.ne.0
  if (passdata)  ipnt = gag_pointer(fit%data,memory)
  npfn = fit%nfcn
  nparp1=fit%npar+1
  rho1 = 1.0d0 + alpha
  rho2 = rho1 + alpha*gamma
  wg = 1.0d0/dble(fit%npar)
  iflag=4
  do i= 1, fit%npar
     if (fit%isw(2).ge.1)  fit%dirin(i) = dsqrt(fit%v(i,i)*fit%up)
     if (dabs(fit%dirin(i)) .lt. 0.01*theprec*dabs(fit%x(i)))  &
          &   fit%dirin(i)=theprec*fit%x(i)
     if (fit%itaur.lt.1)  fit%v(i,i) =    fit%dirin(i)**2/fit%up
  enddo
  if (fit%itaur.lt.1)  fit%isw(2) = 1
  !
  ! Choose the initial Simplex using single-parameter searches
1 continue
  ynpp1 = fit%amin
  fit%jl = nparp1
  fit%y(nparp1) = fit%amin
  absmin = fit%amin
  do i= 1, fit%npar
     aming = fit%amin
     fit%pbar(i) = fit%x(i)
     bestx = fit%x(i)
     kg = 0
     ns = 0
     nf = 0
4    fit%x(i) = bestx + fit%dirin(i)
     call intoex(fit,fit%x)
     if (passdata) then
       call fcn(fit%npar,fit%g, f, fit%u, 4, memory(ipnt))
     else
       call fcn(fit%npar,fit%g, f, fit%u, 4)
     endif
     fit%nfcn = fit%nfcn + 1
     if (f .le. aming)  go to 6
     !
     ! Failure
     if (kg .eq. 1)  go to 8
     kg = -1
     nf = nf + 1
     fit%dirin(i) = fit%dirin(i) * (-0.4d0)
     if (nf .lt. 3)  go to 4
     ns = 6
     !
     ! Success
6    bestx = fit%x(i)
     fit%dirin(i) = fit%dirin(i) * 3.0d0
     aming = f
     kg = 1
     ns = ns + 1
     if (ns .lt. 6)  go to 4
     !
     ! Local minimum found in Ith direction
8    fit%y(i) = aming
     if (aming .lt. absmin)  fit%jl = i
     if (aming .lt. absmin)  absmin = aming
     fit%x(i) = bestx
     do k= 1, fit%npar
        fit%p(k,i) = fit%x(k)
     enddo
  enddo
  fit%jh = nparp1
  fit%amin=fit%y(fit%jl)
  call razzia(fit,ynpp1,fit%pbar,ier)
  !
  ! Error Patch in Case of bad behaved Function
  if (ier.ne.0) return
  do i= 1, fit%npar
     fit%x(i) = fit%p(i,fit%jl)
  enddo
  call intoex(fit,fit%x)
  fit%sigma = fit%sigma * 10.d0
  sig2 = fit%sigma
  ignal = 0
  ncycl=0
  !
  ! Start main loop
50 continue
  if (ignal .ge. 10)  go to 1
  if (sig2 .lt. fit%epsi .and. fit%sigma.lt.fit%epsi)     go to 76
  sig2 = fit%sigma
  if ((fit%nfcn-npfn) .gt. fit%nfcnmx)  go to 78
  !
  ! Calculate new point * by reflection
  do i= 1, fit%npar
     pb = 0.d0
     do j= 1, nparp1
        pb = pb + wg * fit%p(i,j)
     enddo
     fit%pbar(i) = pb - wg * fit%p(i,fit%jh)
     fit%pstar(i)=(1.d0+alpha)*fit%pbar(i)-alpha*fit%p(i,fit%jh)
  enddo
  call intoex(fit,fit%pstar)
  if (passdata) then
    call fcn(fit%npar,fit%g,ystar,fit%u,4,memory(ipnt))
  else
    call fcn(fit%npar,fit%g,ystar,fit%u,4)
  endif
  fit%nfcn=fit%nfcn+1
  if (ystar.ge.fit%amin) go to 70
  !
  ! Point * better than JL, calculate new point **
  do i=1,fit%npar
     fit%pstst(i)=gamma*fit%pstar(i)+(1.d0-gamma)*fit%pbar(i)
  enddo
  call intoex(fit,fit%pstst)
  if (passdata) then
    call fcn(fit%npar,fit%g,ystst,fit%u,4,memory(ipnt))
  else
    call fcn(fit%npar,fit%g,ystst,fit%u,4)
  endif
  fit%nfcn=fit%nfcn+1
  !
  ! Try a parabola through PH, PSTAR, PSTST.  min = PRHO
  y1 = (ystar-fit%y(fit%jh)) * rho2
  y2 = (ystst-fit%y(fit%jh)) * rho1
  rho = 0.5d0 * (rho2*y1 -rho1*y2) / (y1 -y2)
  if (rho .lt. rhomin)  go to 66
  if (rho .gt. rhomax)  rho = rhomax
  do i= 1, fit%npar
     fit%prho(i) = rho*fit%pstar(i) + (1.d0 -rho)*fit%p(i,fit%jh)
  enddo
  call intoex(fit,fit%prho)
  if (passdata) then
    call fcn(fit%npar, fit%g, yrho, fit%u, 4, memory(ipnt))
  else
    call fcn(fit%npar, fit%g, yrho, fit%u, 4)
  endif
  fit%nfcn = fit%nfcn + 1
  if (yrho .lt. fit%y(fit%jl) .and. yrho .lt. ystst)  go to 65
  if (ystst .lt. fit%y(fit%jl))  go to 67
  if (yrho .gt. fit%y(fit%jl))  go to 66
  !
  ! Accept minimum point of parabola, PRHO
65 call razzia(fit,yrho,fit%prho,ier)
  !
  ! Error Patch in Case of bad behaved Function
  if (ier.ne.0) return
  ignal = max(ignal-2, 0)
  go to 68
66 if (ystst .lt. fit%y(fit%jl))  go to 67
  ignal = max(ignal-1, 0)
  call razzia(fit,ystar,fit%pstar,ier)
  !
  ! Error Patch in Case of bad behaved Function
  if (ier.ne.0) return
  go to 68
67 ignal = max(ignal-2, 0)
675 call razzia(fit,ystst,fit%pstst,ier)
  !
  ! Error Patch in Case of bad behaved Function
  if (ier.ne.0) return
68 ncycl=ncycl+1
  go to 50
  !
  ! Point * is not as good as JL
70 if (ystar .ge. fit%y(fit%jh))  go to 73
  jhold = fit%jh
  call razzia(fit,ystar,fit%pstar,ier)
  !
  ! Error Patch in Case of bad behaved Function
  if (ier.ne.0) return
  if (jhold .ne. fit%jh)  go to 50
  !
  ! Calculate new point **
73 continue
  do i=1,fit%npar
     fit%pstst(i)=beta*fit%p(i,fit%jh)+(1.d0-beta)*fit%pbar(i)
  enddo
  call intoex(fit,fit%pstst)
  if (passdata) then
    call fcn(fit%npar,fit%g,ystst,fit%u,4,memory(ipnt))
  else
    call fcn(fit%npar,fit%g,ystst,fit%u,4)
  endif
  fit%nfcn=fit%nfcn+1
  if (ystst.gt.fit%y(fit%jh)) go to 1
  !
  ! Point ** is better than JH
  if (ystst .lt. fit%amin)  go to 675
  ignal = ignal + 1
  call razzia(fit,ystst,fit%pstst,ier)
  !
  ! Error Patch in Case of bad behaved Function
  if (ier.ne.0) return
  go to 50
  !
  ! End main loop
76 continue
  if (fit%verbose)  &
     call fit_message(fit,seve%i,rname,'Minimization has converged')
  go to 80
  !
78 continue
  if (fit%verbose)  &
     call fit_message(fit,seve%i,rname,'Terminates without convergence')
  fit%isw(1) = 1
  !
80 continue
  do i=1,fit%npar
     pb = 0.d0
     do j=1,nparp1
        pb = pb + wg * fit%p(i,j)
     enddo
     fit%pbar(i) = pb - wg * fit%p(i,fit%jh)
  enddo
  call intoex(fit,fit%pbar)
  if (passdata) then
    call fcn(fit%npar,fit%g,ypbar,fit%u,iflag,memory(ipnt))
  else
    call fcn(fit%npar,fit%g,ypbar,fit%u,iflag)
  endif
  fit%nfcn=fit%nfcn+1
  if (ypbar .lt. fit%amin)  call razzia(fit,ypbar,fit%pbar,ier)
  !
  ! Error Patch in Case of bad behaved Function
  if (ier.ne.0) return
  call intoex(fit,fit%x)
  if (fit%nfcnmx+npfn-fit%nfcn .lt. 3*fit%npar)  return
  if (fit%sigma .gt. 2.0d0*fit%epsi)  go to 1
  !
end subroutine simplx
!
subroutine vermin(fit,a,l,m,n,ifail)
  use gmath_interfaces, except_this=>vermin
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ private
  ! MINUIT      Internal routine
  !      Inverts a symmetric matrix.   Matrix is first scaled to
  !      have all ones on the diagonal (equivalent to change of units)
  !      but no pivoting is done since matrix is positive-definite.
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(in)    :: fit     !
  integer(kind=4),    intent(in)    :: l       ! 1st dim of matrix A
  integer(kind=4),    intent(in)    :: m       ! 2nd dim of matrix A
  integer(kind=4),    intent(in)    :: n       !
  real(kind=8),       intent(inout) :: a(l,m)  ! Matrix to be inverted
  integer(kind=4),    intent(out)   :: ifail   ! Error code
  ! Local
  integer(kind=4) :: i,j,k
  real(kind=8) :: si,s(nvar),q(nvar),pp(nvar)
  !
  ifail=1
  if (n.lt.1 .or. n.gt.fit%maxint) return
  !
  ! Scale matrix by sqrt of diagonal elements
  do i=1,n
     si = a(i,i)
     if (si.le.0d0) return
     s(i) = 1.0d0/dsqrt(si)
  enddo
  ifail=0
  !
  do i= 1, n
     do j= 1, n
        a(i,j) = a(i,j) *s(i)*s(j)
     enddo
  enddo
  !
  ! Start main loop
  do i=1,n
     k = i
     !
     ! Preparation for elimination step1
     q(k) = 1.d0/a(k,k)
     pp(k)= 1.0d0
     a(k,k)=0.0d0
     do j=1,k-1
        pp(j)=a(j,k)
        q(j)=a(j,k)*q(k)
        a(j,k)=0.d0
     enddo
     do j=k+1,n
        pp(j)=a(k,j)
        q(j)=-a(k,j)*q(k)
        a(k,j)=0.0d0
     enddo
     !
     ! Elimination proper
     do j=1,n
        do k=j,n
           a(j,k)=a(j,k)+pp(j)*q(k)
        enddo
     enddo
  enddo
  !
  ! Elements of left diagonal and unscaling
  do j= 1, n
     do k= 1, j
        a(k,j) = a(k,j) *s(k)*s(j)
        a(j,k) = a(k,j)
     enddo
  enddo
end subroutine vermin

!-----------------------------------------------------------------------
! Support file for command SIC\LET
!-----------------------------------------------------------------------
subroutine let_variable (line,nline,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>let_variable
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  !       Support routine for command
  !       LET Variable [=] Arithmetic expression
  !     [/NEW Type [Attr]]
  !     [/PROMPT "Prompt text"]
  !     [/WHERE Logical_Expression]
  !     [/RANGE Min Max]
  !     [/CHOICE C1 .. CN [*]]
  !     [/FILE Filter ]
  !     [/INDEX C1 .. CN]
  !     [/SEXAGESIMAL]
  !     [/LOWER]
  !     [/UPPER]
  !     [/FORMAT String]
  !     [/FORMULA]
  !     [/REPLACE]
  !     [/STATUS Read|Write]
  !     [/NOQUOTE]
  !     [/RESIZE]
  !
  ! Upper level to allow HEADER and STRUCTURE assignment
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  integer(kind=4),  intent(in)    :: nline  !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='LET'
  integer(kind=4) :: nchar
  character(len=varname_length) :: var
  !
  call sic_ke (line,0,1,var,nchar,.true.,error)
  if (error) return
  !
  if (sic_present(optreplace,0)) then
    call let_replace(line,var,error)
    if (error) return
    !
  elseif (sic_present(optstatus,0)) then
    call let_status(line,error)
    if (error)  return
    !
  else
    if (var(nchar:nchar).ne.'%') then
      call let_avar(line,var,error)
    else if (sic_present(optresize,0)) then
      call sic_message(seve%e,rname,'/RESIZE cannot apply to Structures')
      error = .true.
    else
      ! Header assignement: special case
      call let_header(line,var,error)
    endif
  endif
end subroutine let_variable
!
subroutine let_avar(line,nameout,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>let_avar
  use sic_structures
  use sic_dictionaries
  use sic_expressions
  use sic_interactions
  use sic_types
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  LET Variable [=] Arithmetic expression [/OPTIONS]
  !
  ! Lower level for individual variable assignment
  !---------------------------------------------------------------------
  character(len=*)                :: line     !
  character(len=*), intent(inout) :: nameout  ! Variable name
  logical,          intent(inout) :: error    !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LET'
  integer(kind=4) :: ier,in,iarg,nc,np
  type(sic_dimensions_t) :: spec
  integer(kind=4) :: impndim,impvars(sic_maxdims),nline,i,kn,i_command
  character(len=12) :: command
  character(len=4) :: equal
  character(len=28) :: chain
  character(len=80) :: ptext,do_new_type
  type(sic_identifier_t) :: varout
  character(len=1024) :: expres
  logical :: do_new,do_where,do_many,do_upper,do_lower,do_sexage,do_format
  logical :: do_resize
  !
  ! Code
  i_command = 0
  !
  ! /NEW Type
  do_new = sic_present(optnew,0)
  if (do_new) then
    call let_new(line,nameout,do_new_type,error)
    if (error)  return
  endif
  !
  ! Parse dimensions
  spec%do%strict   = .true.   ! 'nameout' must refer to a valid specifier, not e.g. an expression
  spec%do%range    = .true.
  spec%do%subset   = .true.
  spec%do%implicit = .true.
  spec%do%twospec  = .true.   ! LET A[i][j:k] "AB" allowed
  call sic_parse_var(nameout,varout,spec,impvars,error)
  if (error) return
  if (spec%done(1)%implicit) then
    impndim = spec%done(1)%ndim  ! Useful size of 'impvars'
  else
    impndim = 0
  endif
  !
  ! Search first in local table
  varout%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varout,in)
  if (ier.ne.1 .and. var_level.ne.0) then
    varout%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varout,in)
  endif
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'No such variable '//nameout)
    error =.true.
    goto 98
  endif
  !
  ! Check number of dimensions
  if (dicvar(in)%desc%type.le.0 .and. spec%done(1)%ndim.gt.dicvar(in)%desc%ndim) then
    ! This test is disabled for strings (type>0), it is checked in extract_descr
    call sic_message(seve%e,rname,'Too many dimensions for variable '//  &
      nameout)
    error = .true.
    goto 98
  endif
  !
  ! Check whether it is readonly
  if (dicvar(in)%desc%readonly) then
    call sic_message(seve%e,rname,'Readonly variables cannot be modified')
    error = .true.
    goto 98
  endif
  !
  do_format = sic_present(optformat,0)
  do_upper = sic_present(optupper,0)
  do_lower = sic_present(optlower,0)
  do_sexage = sic_present(optsexage,0)
  do_where = sic_present(optwhere,0)
  do_many = sic_present(optnoquote,0) ! Multiple arguments for one string...
  do_resize = sic_present(optresize,0)
  !
  ! Check conflicting options
  if (do_resize) then
    if (do_format .or. do_many .or. do_sexage .or. do_where) then
      call sic_message(seve%e,rname,'Conflicting options')
      error = .true.
    endif
  endif
  if (do_where) then
    if (sic_narg(optwhere).gt.1) then
      call sic_message(seve%e,rname,'/WHERE has trailing arguments')
      error = .true.
    endif
    if (do_upper.or.do_lower.or.do_sexage.or.do_format) then
      call sic_message(seve%e,rname,'Conflicting options')
      error = .true.
    endif
    if (dicvar(in)%desc%type.gt.0) then
      call sic_message(seve%e,rname,'Option not valid for Character string')
      error = .true.
    endif
  elseif (do_upper.and.do_lower) then
    call sic_message(seve%e,rname,'Conflicting options')
    error = .true.
  elseif (do_upper.or.do_lower) then
    if (do_sexage.or.do_format.or.do_many) then
      call sic_message(seve%e,rname,'Conflicting options')
      error = .true.
    elseif  (dicvar(in)%desc%type.le.0) then
      call sic_message(seve%e,rname,'Option only valid for Character string')
      error = .true.
    endif
  elseif (do_sexage) then
    if (do_format.or.do_many) then
      call sic_message(seve%e,rname,'Conflicting options')
      error = .true.
    endif
  elseif (do_format.or.do_many) then
    if (dicvar(in)%desc%type.le.0) then
      call sic_message(seve%e,rname,'Option only valid for Character string')
      error = .true.
    endif
  endif
  if (error) goto 98
  !
  ! Check for = sign and ignore it
  iarg = 2
  if (sic_present(0,2)) then
    equal = line(sic_start(0,2):sic_end(0,2))
    if (equal.eq.'=') iarg = 3
  endif
  !
  ! If no further argument, prompt for text
  if (.not.sic_present(0,iarg)) then
    if (sic_present(optprompt,1)) then
      nline = index (line,'/PROMPT')
      if (do_new) nline = min(nline, index(line,'/NEW'))
      call sic_ch (line,optprompt,1,ptext,np,.true.,error)
      if (error) goto 98
      line(nline:nline) = ' '
      call sic_wprn(ptext(1:np)//': '//trim(varout%name)//' = ',line(nline+1:),nc)
    else
      if (do_new) then
        nline = index (line,'/NEW')
        line(nline:) = ' '
      else
        nline = len_trim(line)+1
      endif
      call sic_wprn(trim(varout%name)//' = ',line(nline+1:),nc)
    endif
    if (nc.eq.0) then
      error = .true.
      goto 98
    endif
    nline = min(nline+nc,len(line))
    call sic_format(line,nline)
    call sic_analyse (command,line,nline,error)
    if (error) goto 98
    if (do_new) then
      chain = ' /NEW '//do_new_type
      line(nline+1:) = chain
      nline = len_trim(line)
    endif
  endif
  !
  ! Check if variable should (and can) be resized
  if (do_resize) then
    call let_resize(in,varout,iarg,error)
    if (error)  goto 98
  endif
  !
  ! Check the X-Window mode if set
  ! if X_WINDOW is not set, X_COMMANDS will be zero, so will be I_COMMAND
  i_command = 0
  if (x_commands.ge.1)  &
    call let_xwindow(line,varout%name,in,i_command,error)
  !
  ! Now assign the value
  if (do_sexage) then
    ! Sexagesimal mode valid only for scalar real variables
    call let_avar_sexag(line,dicvar(in),spec,error)
    goto 98
    !
  elseif (dicvar(in)%desc%type.eq.0) then
    ! Headers...
    call sic_message(seve%e,rname,'Header structures cannot be assigned')
    error = .true.
    goto 98
    !
  elseif (dicvar(in)%desc%type.gt.0) then
    ! Characters
    call let_avar_character(line,dicvar(in),spec,iarg,error)
    if (error)  goto 98
    !
  else
    ! Arithmetic (in general, including logicals)
    call let_avar_numeric(line,dicvar(in),spec,impvars,iarg,error)
    if (error)  goto 98
  endif
  !
  ! Final cleanup
98 continue
  !
  ! If /NEW, we created a variable but something went wrong during
  ! assignement: delete it
  if (error .and. do_new) then
    call sic_delvariable(varout%name,.true.,error)
    if (error)  return
  endif
  !
  ! Clean implicit variables
  if (spec%done(1)%implicit) then
    do i=1,impndim
      kn = impvars(i)
      if (kn.eq.0)  cycle  ! No variable defined (unnamed dimension)
      ! Clean their memory, if it was allocated
      if (dicvar(kn)%desc%status.ne.empty_operand)  &
        call free_vm(dicvar(kn)%desc%size,dicvar(kn)%desc%addr)
      ! Clean them from dictionary
      call sic_zapvariable(kn,.true.,.true.,error)
    enddo
  endif
  !
  ! Deferred update...
  ! if X_WINDOW mode is not set, I_COMMAND will be 0.
  if (i_command.ne.0) then
    call sic_var_to_string(dicvar(in)%desc,expres)
    call xgag_update(varout%name,expres)
  endif
  !
end subroutine let_avar
!
subroutine let_avar_numeric(line,var,spec,impvars,argfirst,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>let_avar_numeric
  use sic_dictionaries
  use sic_expressions
  use sic_types
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for LET (numeric or logical output variable)
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: line                  ! Input command line
  type(sic_variable_t),   intent(in)    :: var                   ! Output variable
  type(sic_dimensions_t), intent(inout) :: spec                  !
  integer(kind=4),        intent(in)    :: impvars(sic_maxdims)  !
  integer(kind=4),        intent(in)    :: argfirst              !
  logical,                intent(inout) :: error                 !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LET'
  integer(kind=address_length) :: ipnt
  type(sic_descriptor_t) :: ldesc,tdesc
  type(sic_dimensions_done_t) :: vspec(2)
  character(len=1024) :: argum,expres
  type(sic_descriptor_t) :: rdesc
  logical :: by_one,found,simple,do_where
  character(len=message_length) :: mess
  integer(kind=size_length) :: lsize,tsize,size,step
  integer(kind=4) :: i,ier,ilen,itype,jarg,j,kn,max_level,min_level,nletarg
  integer(kind=4), save :: tree(formula_length*2)
  type(sic_descriptor_t), save :: operand(0:maxoper)
  integer(kind=4), save :: last_node
  integer(kind=4) :: i4
  integer(kind=8) :: i8
  real(kind=4) :: r4
  real(kind=8) :: r8
  logical :: l
  integer(kind=8), parameter :: maxi4=2147483647_8
  !
  rdesc%status = empty_operand
  !
  if (spec%done(2)%ndim.gt.0) then
    call sic_message(seve%e,rname,  &
      'Invalid substring specification on non-character string')
    error = .true.
    return
  endif
  !
  if (spec%done(1)%implicit) then
    ! Implicit loops
    if (sic_narg(0).ne.argfirst) then
      error = .true.
      call sic_message(seve%e,rname,'Trailing arguments in assignment')
      return
    endif
    !
    if (var%desc%type.eq.fmt_r8 .or.  &
        var%desc%type.eq.fmt_i8 .or.  &
        var%desc%type.eq.fmt_c4) then
      size = var%desc%size/2
    else
      size = var%desc%size
    endif
    !
    ! Allocate and fill implicit variables
    do i=1,spec%done(1)%ndim
      if (impvars(i).eq.0)  cycle  ! No variable defined (unnamed dimension)
      !
      j = var%desc%ndim-spec%done(1)%ndim+i  ! The dimension
      kn = impvars(i)
      ! Automatic integer kind. Integers are prefered rather than 'SIC PRECISION'
      ! reals, since REAL*4 give approximate results beyond 16777216, and REAL*8
      ! use too much memory most of the time. In order to save memory, use long
      ! integers only when needed.
      if (var%desc%dims(j).le.maxi4) then
        dicvar(kn)%desc%type = fmt_i4
        dicvar(kn)%desc%size = size
      else
        dicvar(kn)%desc%type = fmt_i8
        dicvar(kn)%desc%size = size*2
      endif
      ier = sic_getvm (dicvar(kn)%desc%size,dicvar(kn)%desc%addr)
      if (ier.ne.1) then
        call sic_message(seve%e,rname,'Could not allocate memory for implicit variables')
        error = .true.
        return
      endif
      ipnt = gag_pointer(dicvar(kn)%desc%addr,memory)
      if (dicvar(kn)%desc%type.eq.fmt_i4) then
        call i4_index (j,memory(ipnt),var%desc%dims)
      else
        call i8_index (j,memory(ipnt),var%desc%dims)
      endif
      dicvar(kn)%desc%readonly = .false.
      dicvar(kn)%desc%ndim     = var%desc%ndim
      dicvar(kn)%desc%dims(:)  = var%desc%dims(:)
      dicvar(kn)%desc%status   = user_defined    !
    enddo
    spec%done(1)%ndim = 0    ! To ask for a full copy (no sub-array)
  endif  ! Of implicit variables...
  !
  ldesc%size = 0
  tdesc%size = 0
  !
  ! /WHERE option
  ! print *,'DO_WHERE ',do_where
  do_where = sic_present(optwhere,0)
  if (do_where) then
    !
    ! First, check the size of the desired result...
    vspec(1)%ndim = spec%done(1)%ndim
    vspec(2)%ndim = 0
    do i=1,spec%done(1)%ndim
      vspec(1)%dims(i,1) = spec%done(1)%dims(i,1)
      vspec(1)%dims(i,2) = spec%done(1)%dims(i,2)
    enddo
    do i=spec%done(1)%ndim+1,sic_maxdims
      vspec(1)%dims(i,1) = 0
      vspec(1)%dims(i,2) = 0
    enddo
    ! print *,'Calling EXTRACT_DESCR'
    ! Allow transposition:
    call extract_descr(ldesc,var%desc,vspec,var%id%name,.true.,0,error)
    ! print *,'Done'
    if (error) goto 98
    tsize  = ldesc%size
    tdesc%type = ldesc%type
    tdesc%readonly = ldesc%readonly
    if (ldesc%type.eq.fmt_r8 .or.  &
        ldesc%type.eq.fmt_i8 .or.  &
        ldesc%type.eq.fmt_c4) then
      lsize = ldesc%size/2
    else
      lsize = ldesc%size
    endif
    call sic_volatile(ldesc) ! If it was a transposition, free it ...
    !
    ! Get logical expression name
    ! print *,'Calling SIC_ST'
    call sic_st (line,optwhere,1,argum,ilen,.true.,error)
    ! print *,'Done'
    if (error) goto 98
    ! Get logical array descriptor
    found = .true.
    ! print *,'LET_AVAR, /WHERE'
    call sic_descriptor (argum(1:ilen),ldesc,found)  ! Checked
    if (found .and. lsize.eq.ldesc%size) then
      ! Found a variable of identical size
      if (ldesc%type.ne.fmt_l) then
        call sic_message(seve%e,'LET /WHERE','Variable is not a logical '//  &
        'array')
        error = .true.
        goto 98
      endif
    else
      ! Not a variable, or a variable of different size (this may be valid
      ! e.g. LET /WHERE YES). Try to evaluate a vectorized logical expression.
      ! lsize => desired size of result
      call sic_math_desc(argum,ilen,fmt_l,lsize,ldesc,error)
      if (error) then
        call sic_message(seve%e,'/WHERE','Invalid logical expression '//  &
          argum(1:ilen))
        ldesc%size = 0  ! Memory already freed by sic_math_desc, avoid double free
        goto 98
      endif
    endif
    !
    ! Get some memory for the temporary result
    ier = sic_getvm (tsize,tdesc%addr)
    if (ier.ne.1) then
      call sic_message(seve%e,rname,'Memory allocation failure')
      error = .true.
      goto 98
    endif
    tdesc%size = tsize
    tdesc%status = user_defined  ! Eh non, pas "SCRATCH"
  endif  ! Of /WHERE option
  !
  ! Get incarnation of variable: allow transposition in same format
  call extract_descr(rdesc,var%desc,spec%done,var%id%name,.true.,0,error)
  if (error) goto 98
  !
  ! Check for element per element assignment
  nletarg = sic_narg(0)
  by_one = .false.
  if (.not.spec%done(1)%implicit .or. rdesc%ndim.ne.0) then
    step = desc_nelem(rdesc)
    by_one = nletarg.eq.(step+argfirst-1)
    if (by_one.and.do_where) then
      if (step.gt.1) then
        call sic_message(seve%e,rname,'Cannot assign element per element '//  &
        'with /WHERE option')
        error = .true.
        goto 98
      else
        by_one = .false. ! Do not go through the element by element case if /WHERE is used
      endif
    elseif ((nletarg.ne.argfirst).and..not.by_one) then
      call sic_message(seve%e,rname,'Wrong number of arguments in assignment')
      error = .true.
      goto 98
    endif
  elseif (nletarg.ne.argfirst) then
    call sic_message(seve%e,rname,'Trailing arguments in assignment')
    error = .true.
    goto 98
  endif
  !
  ! If exact number of arguments
  if (by_one) then
    !
    ipnt = gag_pointer(rdesc%addr,memory)
    do jarg=argfirst,nletarg
      call sic_st (line,0,jarg,argum,ilen,.true.,error)
      if (rdesc%type.eq.fmt_l) then
        call sic_math_logi (argum,ilen,l,error)
        if (error) goto 98
        call l4tol4(l,memory(ipnt),1)
        ipnt = ipnt+1
      elseif (rdesc%type.eq.fmt_i4) then
        call sic_math_inte (argum,ilen,i4,error)
        if (error) goto 98
        call i4toi4(i4,memory(ipnt),1)
        ipnt = ipnt+1
      elseif (rdesc%type.eq.fmt_r4) then
        call sic_math_real (argum,ilen,r4,error)
        if (error) goto 98
        call r4tor4(r4,memory(ipnt),1)
        ipnt = ipnt+1
      elseif (rdesc%type.eq.fmt_r8) then
        call sic_math_dble (argum,ilen,r8,error)
        if (error) goto 98
        call r8tor8(r8,memory(ipnt),1)
        ipnt = ipnt+2
      elseif (rdesc%type.eq.fmt_i8) then
        call sic_math_long (argum,ilen,i8,error)
        if (error) goto 98
        call i8toi8(i8,memory(ipnt),1)
        ipnt = ipnt+2
      elseif (rdesc%type.eq.fmt_c4) then
        call sic_math_real (argum,ilen,r4,error)
        if (error) goto 98
        call r4toc4(r4,memory(ipnt),1)
        ipnt = ipnt+2
      else
        call sic_message(seve%e,rname,'Output type not supported (1)')
        error = .true.
        goto 98
      endif
    enddo
  else
    !
    ! General case, not an element by element assignment
    !            IF (SPEC%DONE(1)%IMPLICIT) THEN
    !
    ! Implicit loops: beware of not formatting the expression !...
    ! Note that B.Lazareff may still find a "bug" in the syntax
    ! in this way !...
    !
    !               ISTART = SIC_START(0,ARGFIRST)
    !               IF (LINE(ISTART:ISTART).EQ."'") THEN
    !                  IEND   = ISTART + SIC_LEN(0,ARGFIRST) - 1
    !                  IF (LINE(IEND:IEND).EQ."'") THEN
    !                     ISTART = ISTART+1
    !                     IEND = IEND-1
    !                     ARGUM  = LINE(ISTART:IEND)
    !                     ILEN = IEND-ISTART+1
    !                     Print *,'B Lazareff case ',ILEN,ARGUM(1:ILEN)
    !                  ELSE
    !                     CALL SIC_ST (LINE,0,ARGFIRST,ARGUM,ILEN,.TRUE.,ERROR)
    !                     IF (ERROR) GOTO 98
    !                  ENDIF
    !               ELSE
    !                  CALL SIC_ST (LINE,0,ARGFIRST,ARGUM,ILEN,.TRUE.,ERROR)
    !                  IF (ERROR) GOTO 98
    !               ENDIF
    !            ELSE
    ! Normal assignment: get the string
    !               CALL SIC_CH(LINE,0,ARGFIRST,ARGUM,ILEN,.TRUE.,ERROR)
    !               IF (ERROR) GOTO 98
    !            ENDIF
    ! Simple code: get the argument
    call sic_st (line,0,argfirst,argum,ilen,.true.,error)
    if (error) goto 98
    call sic_add_expr(argum,ilen,expres,ilen,error)
    if (error) goto 98
    !
    ! Scalar
    if (.not.spec%done(1)%implicit .and. rdesc%ndim.eq.0 .and. rdesc%type.ne.fmt_l) then
      simple = .not.do_where
      if (expres(1:1).lt.'0'.or.expres(1:1).gt.'9') then
        simple = .false.
      elseif (index(expres(2:ilen),'+').ne.0) then
        simple = .false.
      elseif (index(expres(2:ilen),'-').ne.0) then
        simple = .false.
      elseif (index(expres(2:ilen),'*').ne.0) then
        simple = .false.
      elseif (index(expres(2:ilen),'|').ne.0) then
        simple = .false.
      endif
      ! Try a plain real number
      if (simple) then
        read (expres(1:ilen),*,iostat=ier)  r8
        ! If this does not work, try a SIC expression
        if (ier.ne.0) then
          call sic_get_dble (expres(1:ilen),r8,error)
          if (error) then
            error = .false.
            simple = .false.
          endif
        endif
      endif
      ! Move result to target location
      if (simple) then
        ipnt = gag_pointer(rdesc%addr,memory)
        if (rdesc%type.eq.fmt_i4) then
          call r8toi4_fini(r8,memory(ipnt),1,error)
        elseif (rdesc%type.eq.fmt_r4) then
          call r8tor4(r8,memory(ipnt),1)
        elseif (rdesc%type.eq.fmt_r8) then
          call r8tor8(r8,memory(ipnt),1)
        elseif (rdesc%type.eq.fmt_i8) then
          call r8toi8_fini(r8,memory(ipnt),1,error)
        else
          call sic_message(seve%e,rname,'Output type not supported (2)')
          error = .true.
        endif
        if (error)  goto 98
      endif
    else
      simple = .false.
    endif
    !
    ! In the most general case, analyse arithmetic expression
    if (.not.simple) then
      call build_tree(expres(1:ilen),ilen,operand,tree,last_node,max_level,  &
      min_level,error)
      if (error) then
        if (rdesc%type.eq.fmt_l) then
          mess = 'Invalid logical expression '//expres(1:ilen)
        else
          mess = 'Invalid arithmetic expression '//expres(1:ilen)
        endif
        call sic_message(seve%e,'DECODE',mess)
      else
        if (.not.do_where) then
          ! On peut y aller directement
          call evaluate_tree(operand,tree,last_node,max_level,min_level,  &
            rdesc,itype,error)
        else
          ! Il suffit de remplacer RDESC par la variable temporaire TDESC
          call evaluate_tree(operand,tree,last_node,max_level,min_level,  &
            tdesc,itype,error)
          ! Puis de remplir selon le masque LDESC
          call mask_fill(tdesc,rdesc,ldesc)
        endif
      endif
    endif
  endif
  !
  ! Descriptor can point to a copy if implicit transpose is used. Copy
  ! back to final location and free the memory
  if (rdesc%status.eq.scratch_operand) then
    call copy_back(rdesc,var%desc,spec%done(1)%ndim,  &
      spec%done(1)%dims(:,:),var%id%name,error)
    if (error) goto 98
  endif
  !
98 continue
  !
  call sic_volatile(rdesc)
  !
  if (tdesc%size.ne.0) call free_vm (tdesc%size,tdesc%addr)
  if (ldesc%status.eq.scratch_operand) then
    if (ldesc%size.ne.0) then
      call free_vm (ldesc%size,ldesc%addr)
      ldesc%size = 0
      ldesc%status = empty_operand
    endif
  endif
  !
end subroutine let_avar_numeric
!
subroutine let_avar_character(line,var,spec,argfirst,error)
  use gbl_message
  use sic_interfaces, except_this=>let_avar_character
  use sic_dictionaries
  use sic_types
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for LET (numeric or logical output variable)
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: line      ! Input command line
  type(sic_variable_t),   intent(in)    :: var       ! Output variable
  type(sic_dimensions_t), intent(inout) :: spec      !
  integer(kind=4),        intent(in)    :: argfirst  !
  logical,                intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='LET'
  type(sic_descriptor_t) :: rdesc
  integer(kind=4) :: jarg,nc,nletarg
  character(len=commandline_length) :: local_line
  integer(kind=size_length) :: step,ielem
  integer(kind=address_length) :: addr
  logical :: by_one,do_where,do_format,do_upper,do_lower,do_noquote
  !
  do_where = sic_present(optwhere,0)
  do_format = sic_present(optformat,0)
  do_upper = sic_present(optupper,0)
  do_lower = sic_present(optlower,0)
  do_noquote = sic_present(optnoquote,0)
  !
  call extract_descr(rdesc,var%desc,spec%done,var%id%name,.true.,0,error)
  if (error) goto 98
  if (rdesc%ndim.eq.0 .and. .not.spec%done(1)%implicit) then
    if (do_noquote) then
      local_line = line(sic_start(0,argfirst):sic_end(0,sic_narg(0)))
    else
      call sic_ch (line,0,argfirst,local_line,nc,.true.,error)
    endif
    if (error) goto 98
    if (do_upper) then
      call sic_upper(local_line)
    elseif (do_lower) then
      call sic_lower(local_line)
    elseif (do_format) then
      call sic_letformat(line,argfirst,local_line,error)
    endif
    call ctodes(local_line,rdesc%type,rdesc%addr)
  else
    !
    ! Check for element per element assignment
    nletarg = sic_narg(0)
    by_one = .false.
    if (.not.spec%done(1)%implicit .or. rdesc%ndim.ne.0) then
      step = desc_nelem(rdesc)
      by_one = nletarg.eq.(step+argfirst-1)
      if (by_one.and.do_where) then
        if (step.gt.1) then ! If not scalar too
          call sic_message(seve%e,rname,'Cannot assign element per '//  &
          'element with /WHERE option')
          error = .true.
          goto 98
        else
          by_one = .false.  ! Use array assignement, even though it is just one scalar
        endif
      elseif ((nletarg.ne.argfirst).and..not.by_one) then
        call sic_message(seve%e,rname,'Wrong number of arguments in assignment')
        error = .true.
        goto 98
      endif
    elseif (nletarg.ne.argfirst) then
      call sic_message(seve%e,rname,'Trailing arguments in assignment')
      error = .true.
      goto 98
    endif
    !
    if (by_one) then
      addr = rdesc%addr
      do jarg=argfirst,nletarg
        call sic_ch (line,0,jarg,local_line,nc,.true.,error)
        if (error) goto 98
        if (do_upper) then
          call sic_upper(local_line)
        elseif (do_lower) then
          call sic_lower(local_line)
        elseif (do_format) then
          call sic_letformat(line,jarg,local_line,error)
        endif
        call ctodes(local_line,rdesc%type,addr)
        ! Increment the address
        addr = addr+rdesc%type
      enddo
    else
      call sic_ch(line,0,argfirst,local_line,nc,.true.,error)
      if (error) goto 98
      if (do_upper) then
        call sic_upper(local_line)
      elseif (do_lower) then
        call sic_lower(local_line)
      elseif (do_format) then
        call sic_letformat(line,argfirst,local_line,error)
      endif
      addr = rdesc%addr
      do ielem=1,desc_nelem(rdesc)
        call ctodes(local_line,rdesc%type,addr)
        addr = addr+rdesc%type
      enddo
    endif
  endif
  !
  ! Descriptor can point to a copy if implicit transpose is used. Copy
  ! back to final location and free the memory
  if (rdesc%status.eq.scratch_operand) then
    ! e.g. define char*4 a[2,2]; let a[1,] "AA" "BB"
    call copy_back(rdesc,var%desc,spec%done(1)%ndim,  &
      spec%done(1)%dims(:,:),var%id%name,error)
    if (error) goto 98
  endif
  !
98 continue
  call sic_volatile(rdesc)
  !
end subroutine let_avar_character
!
subroutine let_new(line,varname,new_type,error)
  use gbl_format
  use gbl_message
  use sic_interfaces, except_this=>let_new
  use sic_dictionaries
  use sic_interactions
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  LET Var Arg1 ... ArgN /NEW Type [GLOBAL|LOCAL]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line      !
  character(len=*), intent(inout) :: varname   ! Variable name
  character(len=*), intent(out)   :: new_type  !
  logical,          intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='LET'
  integer(kind=4), parameter :: nwhat=5
  character(len=12) :: what(nwhat),keyw,atype
  character(len=32) :: type
  integer(kind=4) :: dtype(nwhat),i,j,k,nc,ntype
  logical :: global
  character(len=8) :: attr
  ! Data. NB: INTEGER kind is ruled by SIC INTEGER SHORT|LONG
  data what /'REAL','DOUBLE','INTEGER','LOGICAL','CHARACTER'/
  data dtype /fmt_r4,fmt_r8,fmt_i4,fmt_l,0/
  !
  ! GLOBAL or LOCAL?
  attr = 'LOCAL'
  call sic_ke (line,optnew,2,attr,nc,.false.,error)
  if (error) return
  if (attr.eq.'GLOBAL') then
    global = .true.
  elseif (attr.ne.'LOCAL') then
    call sic_message(seve%e,rname,'Invalid attribute '//attr)
    error = .true.
    return
  else
    global = (var_level.le.0)
  endif
  !
  ! Get variable type
  call sic_ke(line,optnew,1,type,nc,.true.,error)
  if (error) return
  ! A little trick to support
  !   LET CHAIN*length " " /NEW CHAR
  ! and
  !   LET CHAIN " " /NEW CHAR*length
  i = index(type,'*')
  if (i.ne.0) then
    j = index(varname,'*')
    if (j.eq.0) then
      ! There is no *length specification in the variable name: add it
      k = index(varname,'[')
      if (k.eq.0) then
        ! There is no [N] array specification in the variable name: add the
        ! length as suffix
        j = len_trim(varname)+1
        varname(j:) = type(i:)
      else
        ! There is a [N] array specification in the variable name, e.g.
        !   let toto[2] "QWE" "RTY" /new char*12
        ! => insert the length at correct position
        varname(k:) = trim(type(i:))//varname(k:)
      endif
    endif
    atype = type(1:i-1)
  else
    atype = type
  endif
  !
  call sic_ambigs('DEFINE',atype,keyw,ntype,what,nwhat,error)
  if (error) return
  !
  new_type = trim(keyw)//' '//attr
  !
  ! Verify the CHAR*length issue
  if (i.ne.0) then
    if (ntype.ne.5) then
      call sic_message(seve%e,rname,'Invalid keyword '//type)
      error = .true.
      return
    endif
  endif
  !
  ! Set up the INTEGER kind (as this is a variable this can not be
  ! set at compilation time).
  dtype(3) = sicinteger
  !
  ! Define the new variable
  call sic_defvariable(dtype(ntype),varname,global,error)
  if (error) return
  !
  ! Strip off dimension and character specifications, if any
  if (ntype.eq.5) then
    i = index(varname,'*')
    if (i.gt.0)  varname(i:) = ' '
  endif
  i = index(varname,'[')
  if (i.gt.0)  varname(i:) = ' '

end subroutine let_new
!
subroutine let_replace(line,varout,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>let_replace
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   LET NewName [=] OldName /REPLACE
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  character(len=*), intent(in)    :: varout
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='LET'
  character(len=varname_length) :: varin
  integer(kind=4) :: iopt,nin
  !
  ! Sanity check
  do iopt=1,mopt
    if (iopt.ne.optreplace) then
      if (sic_present(iopt,0)) then
        call sic_message(seve%e,rname,  &
          'Option '//trim(optnames(iopt))//' conflicts with /REPLACE')
        error = .true.
        return
      endif
    endif
  enddo
  !
  ! Get old variable name
  call sic_ke(line,0,2,varin,nin,.true.,error)
  if (error)  return
  if (varin(1:nin).eq.'=') then
    call sic_ke(line,0,3,varin,nin,.true.,error)
    if (error)  return
  endif
  !
  call rename_variable(varin,varout,error)
  if (error)  return
  !
end subroutine let_replace
!
subroutine let_status(line,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>let_status
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   LET Variable /STATUS READ|WRITE
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='LET'
  integer(kind=4) :: iopt,ntype
  character(len=12) :: keyw,ctype
  integer(kind=4), parameter :: nwhat=2
  character(len=6), parameter :: what(nwhat) = (/ 'READ  ','WRITE ' /)
  !
  character(len=varname_length) :: cvar
  integer :: i, nvar
  logical :: rdonly
  !
  ! Sanity check
  do iopt=1,mopt
    if (iopt.ne.optstatus) then
      if (sic_present(iopt,0)) then
        call sic_message(seve%e,rname,  &
          'Option '//trim(optnames(iopt))//' conflicts with /STATUS')
        error = .true.
        return
      endif
    endif
  enddo
  !
  ! Get keyword
  call sic_ke (line,optstatus,1,ctype,ntype,.true.,error)
  if (error) return
  call sic_ambigs('LET /STATUS',ctype,keyw,ntype,what,nwhat,error)
  if (error) return
  !
  rdonly = ntype.eq.1  ! Make it READ or WRITE
  do i=1,sic_narg(0)
    call sic_ke(line,0,i,cvar,nvar,.true.,error)
    if (error) return
    call sic_changevariable(cvar,rdonly,error)    
    if (error) return
  enddo
  !
end subroutine let_status
!
subroutine let_resize(in,var,firstarg,error)
  use gbl_message
  use sic_interfaces, except_this=>let_resize
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Support subroutine for command
  !  LET Var [=] Arg1 ... ArgN /RESIZE
  !---------------------------------------------------------------------
  integer(kind=4),        intent(inout) :: in        ! Variable index (updated in return)
  type(sic_identifier_t), intent(inout) :: var       ! Variable identifier
  integer(kind=4),        intent(in)    :: firstarg  ! Position of Arg1 in command line
  logical,                intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LET'
  character(len=message_length) :: chain
  integer(kind=4) :: ier,nelements,vartype
  character(len=varname_length) :: newname
  !
  ! Sanity check
  if (dicvar(in)%desc%status.eq.program_defined) then
    call sic_message(seve%e,rname,'Program defined variables cannot be resized')
    error = .true.
    return
  endif
  if (dicvar(in)%desc%ndim.ne.1) then
    call sic_message(seve%e,rname,'Only Rank-1 arrays can be resized')
    error = .true.
    return
  endif
  !
  nelements = sic_narg(0)-firstarg+1
  !
  if (nelements.eq.dicvar(in)%desc%dims(1)) return  ! Nothing to do
  !
  ! Feedback
  write(chain,'(3A,I0)')  'Resizing array ',trim(var%name),' to length ',nelements
  call sic_message(seve%w,rname,chain)
  !
  ! Keep memory of some elements before deletion from dictionary
  vartype = dicvar(in)%desc%type
  !
  ! Delete the variable
  call sic_delvariable(var%name,.true.,error)
  if (error)  return
  !
  ! Re-define the variable with new size
  write(newname,'(A,A,I0,A)') trim(var%name),'[',nelements,']'
  call sic_defvariable(vartype,newname,var%level.eq.0,error)
  if (error)  return
  !
  ! Re-locate the variable
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    call sic_message(seve%w,rname,'Error relocating the array during /RESIZE')
    error = .true.
    return
  endif
  !
end subroutine let_resize
!
subroutine let_xwindow(line,nameout,iout,i_command,error)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>let_xwindow
  use sic_dictionaries
  use sic_interactions
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  !  Update the variable value seen in the widget, when this value is
  ! changed from the command line, e.g.
  !   @ gag_demo:demo-widget
  !   exa demo%widget%main%winteger      ! returns 123
  !   let demo%widget%main%winteger 456  ! value in the widget turns to 456
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       ! Input command line
  character(len=*), intent(in)    :: nameout    ! Output variable (name)
  integer(kind=4),  intent(in)    :: iout       ! Output variable (index in dicvar)
  integer(kind=4),  intent(out)   :: i_command  !
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4) :: i,nar,na,ist
  logical :: ok,formula
  character(len=1024) :: expres,argum
  !
  i_command = 0
  i = 1
  formula = sic_present(optformula,0)
  ok = .true.
  do while (ok)
    if (x_number(i).eq.iout) then
      ! Defer update for sliders and logicals
      if (dicvar(iout)%desc%type.eq.fmt_l) then
        i_command = i
        ok = .false.
        ! Sliders
      elseif (x_vtypes(i).gt.(slider_offset-100)) then
        i_command = i
        ok = .false.
      elseif (.not.formula) then
        i_command = i
        ok = .false.
      else
        ! Immediate update for other variables
        ! Beware: not obvious for upper / lower case...
        nar = sic_narg(0)
        ist = 1
        if (dicvar(iout)%desc%type.gt.0) then
          ! Character variables: format completely
          do i=2,nar
            call sic_ch (line,0,i,argum,na,.true.,error)
            expres(ist:) = argum(1:na)
            ist = ist+na+1
          enddo
        else
          ! Other variables : only SIC_ST required ????
          do i=2,nar
            call sic_st (line,0,i,argum,na,.true.,error)
            expres(ist:) = argum
            ist = ist+len_trim(argum)+1
          enddo
        endif
        expres(ist:ist) = char(0)
        call xgag_update(nameout,expres)
        ok = .false.
      endif
    endif
    i = i+1
    if (i.gt.x_commands) ok = .false.
  enddo
  !
end subroutine let_xwindow
!
subroutine let_header(line,nameout,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>let_header
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use sic_types
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  character(len=*) :: nameout       !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='LET'
  type(sic_identifier_t) :: varin,varout
  integer(kind=4) :: nc,in,ou,ier
  logical :: linp,lout
  !
  nc = len_trim(nameout)-1  ! Drop the trailing '%'
  varout%name = nameout(1:nc)
  varout%lname = nc
  !
  ! Search first in local table
  varout%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varout,ou)
  if (ier.ne.1 .and. var_level.ne.0) then
    varout%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varout,ou)
  endif
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'No such header/structure '//nameout)
    error =.true.
    return
  endif
  !!Print *,'found output '//trim(varout%name)//' at ',ou,dicvar(ou)%desc%status
  !
  ! Check if it is a structure
  lout = dicvar(ou)%desc%status.le.0
  !
  ! Check whether it is readonly
  if (dicvar(ou)%desc%readonly) then
    call sic_message(seve%e,rname,'Readonly headers cannot be modified')
    error = .true.
    return
  endif
  !
  ! Input header now
  call sic_ke (line,0,2,varin%name,nc,.true.,error)
  if (error) return
  varin%lname = len_trim(varin%name)  ! Should it be nc?
  if (varin%name(varin%lname:varin%lname).eq.'%') then
    varin%name(varin%lname:varin%lname) = ' '
    varin%lname = varin%lname-1
  endif
  varin%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varin,in)
  if (ier.ne.1 .and. var_level.ne.0) then
    varin%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varin,in)
  endif
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'No such header '//varin%name)
    error =.true.
    return
  endif
  !!Print *,'found input '//trim(varin%name)//' at ',in,dicvar(in)%desc%status
  linp = dicvar(in)%desc%status.le.0
  !
  if (linp.or.lout) then
    call sic_message(seve%d,rname,'Doing my best to assign structures')
    call assign_structure(varin,varout,error)
  else
    ! Assign headers
    call let_copyheader(dicvar(in)%desc%head,dicvar(ou)%desc%head)
  endif
  !
end subroutine let_header
!
subroutine let_copyheader(in,out)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>let_copyheader
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: in
  type(gildas), intent(inout) :: out
  ! Local
  integer(kind=4) :: ndim
  integer(index_length) :: dims(gdf_maxdims),nvisi
  logical :: error
  !
  ! Dimensions must not be overwritten: save them
  ndim = out%gil%ndim
  dims(:) = 1
  dims(1:ndim) = out%gil%dim(1:ndim)
  ! Same for Nvisi (relevant only for UV tables)
  nvisi = out%gil%nvisi
  !
  error = .false.
  call gdf_copy_gil (in,out,error)
  out%char = in%char
  !
  ! Copy back protected elements
  out%gil%ndim = ndim
  out%gil%dim(:) = dims(:)
  out%gil%nvisi = nvisi
end subroutine let_copyheader
!
subroutine assign_structure(input,output,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>assign_structure
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(sic_identifier_t) :: input         !
  type(sic_identifier_t) :: output        !
  logical                :: error         !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LET'
  integer(kind=address_length) :: ipi,ipl
  integer(kind=4) :: list(maxvar)
  integer(kind=4) :: idim,ldim,kdim
  integer(kind=4) :: i,j,l,ik,lk,in,nout,ninp
  integer(kind=size_length) :: size
  character(len=varname_length) :: ctype,dtype
  integer(kind=4) :: levout,levinp
  integer(kind=4) :: vti,vtl
  logical :: match,wrong_type,loose
  character(len=message_length) :: mess
  !
  loose = .false.
  levout = output%level
  nout = output%lname+1
  levinp = input%level
  ninp = input%lname+1
  input%name(ninp:ninp) = '%'
  output%name(nout:nout) = '%'
  !
  ! Loop on output variables
  call gag_haslis(maxvar,pfvar,pnvar,list,in)
  do i=1,in
    ik = list(i)
    ! Output match first...
    if (dicvar(ik)%id%level.eq.levout) then
      !
      ! If it is ReadOnly, do not change it...
      if (dicvar(ik)%desc%readonly)  cycle
      ctype = dicvar(ik)%id%name
      ! If variable is matched, get input variable
      if (output%name(1:nout).eq.ctype(1:nout)) then
        if (dicvar(ik)%desc%type.ne.0) then    ! If 0 means a structure
          do l=1,in
            lk = list(l)
            if (dicvar(lk)%id%level.eq.levinp) then
              dtype = dicvar(lk)%id%name
              if (input%name(1:ninp).eq.dtype(1:ninp)) then
                if (ctype(nout:).eq.dtype(ninp:)) then
                  match = .true.
                  idim = dicvar(ik)%desc%ndim
                  ldim = dicvar(lk)%desc%ndim
                  kdim = min(ldim,idim)
                  do j=1,kdim
                    if (dicvar(ik)%desc%dims(j).ne.dicvar(lk)%desc%dims(j)) then
                      match = .false.
                      write(mess,*) 'Dimension mismatch ',j
                      call sic_message(seve%w,rname,mess)
                    endif
                    !
                    ! Patch %convert size
                    if (j.eq.kdim) loose = .true.
                  enddo
                  if (idim.ne.ldim) then
                    match = .false.
                    write(mess,*) 'Shape mismatch ',idim,ldim
                    call sic_message(seve%w,rname,mess)
                  endif
                  !
                  ! Type Match can be made more generous
                  vti = dicvar(ik)%desc%type
                  vtl = dicvar(lk)%desc%type
                  if (vti.ne.vtl) then
                    if (vti.gt.0 .and. vtl.lt.0) then
                      wrong_type = .true.
                    elseif  (vti.eq.fmt_l) then
                      wrong_type = .true.
                    elseif  (vti.eq.fmt_i4) then
                      wrong_type = .true.
                      ! For real, apply automatic conversion
                    elseif ((vti.eq.fmt_r4.and.vtl.eq.fmt_r8) .or.  &
                            (vti.eq.fmt_r8.and.vtl.eq.fmt_r4) ) then
                      wrong_type = .false.
                    else
                      wrong_type = .true.
                    endif
                    if (wrong_type) then
                      match = .false.
                      write(mess,*) 'Type mismatch',vti,vtl
                      call sic_message(seve%w,rname,mess)
                    endif
                  else
                    wrong_type = .false.
                  endif
                  !
                  ! Make the assignment now
                  if (match) then
                    ! call gagout('let '//trim(ctype)//' '//trim(dtype)
                    ipi = gag_pointer(dicvar(ik)%desc%addr,memory)
                    ipl = gag_pointer(dicvar(lk)%desc%addr,memory)
                    if (vti.eq.vtl) then
                      size = dicvar(ik)%desc%size
                      call w4tow4_sl(memory(ipl),memory(ipi),size)
                    else
                      if (vti.eq.fmt_r4) then
                        size = dicvar(ik)%desc%size
                        call r8tor4_sl(memory(ipl),memory(ipi),size)
                      elseif  (vtl.eq.fmt_r4) then
                        size = dicvar(lk)%desc%size
                        call r4tor8_sl(memory(ipl),memory(ipi),size)
                      else
                        write(mess,*) 'Strange case ',vti,vtl
                        call sic_message(seve%w,rname,mess)
                      endif
                    endif
                  else if (loose) then
                    ! call gagout('let '//trim(ctype)//' '//trim(dtype)
                    ipi = gag_pointer(dicvar(ik)%desc%addr,memory)
                    ipl = gag_pointer(dicvar(lk)%desc%addr,memory)
                    if (vti.eq.vtl) then
                      size = min(dicvar(ik)%desc%size,dicvar(lk)%desc%size)
                      call w4tow4_sl(memory(ipl),memory(ipi),size)
                    else
                      if (vti.eq.fmt_r4) then
                        size = min(dicvar(ik)%desc%size,dicvar(lk)%desc%size/2)
                        call r8tor4_sl(memory(ipl),memory(ipi),size)
                      elseif  (vtl.eq.fmt_r4) then
                        size = min(dicvar(ik)%desc%size/2,dicvar(lk)%desc%size)
                        call r4tor8_sl(memory(ipl),memory(ipi),size)
                      else
                        write(mess,*) 'Strange case ',vti,vtl
                        call sic_message(seve%w,rname,mess)
                      endif
                    endif
                  else
                    call sic_message(seve%w,rname,'Mismatch between '//  &
                    trim(ctype)//' '//trim(dtype))
                  endif
                endif
              endif
            endif
          enddo
          ! else
          !   call gagout('W-LET, Ignoring sub-structure '//ctype)
        endif
      endif
    endif
  enddo
end subroutine assign_structure
!
subroutine sic_letformat (line,iarg,argum,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_letformat
  use sic_types
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  integer(kind=4)                 :: iarg   !
  character(len=*)                :: argum  !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='LET'
  type(sic_descriptor_t) :: ldesc
  integer(kind=4) :: nchar,n,i,ier,is,il
  real(kind=8) :: r
  character(len=80) :: chain
  character(len=1) :: f_type
  logical :: ok,found
  !
#if defined(IFORT)
  character(len=len(argum)) :: tmparg
#endif
  !
  call sic_ch (line,optformat,1,chain(2:),nchar,.true.,error)
  if (error) return
  chain(1:1) =  '('
  ! append a "?" to get the true length even with empty char variables.
  chain(nchar+2:nchar+4) = ',A)'
  nchar = nchar+4
  ok = .true.
  i = 2
  f_type = 'R'
  do while (ok)
    if (sic_eqchain(chain(i:i),'A')) then
      f_type = 'C'
      ok = .false.
    elseif  (sic_eqchain(chain(i:i),'I')) then
      f_type = 'I'
      ok = .false.
    elseif  (sic_eqchain(chain(i:i),'F')) then
      f_type = 'R'
      ok = .false.
    elseif  (sic_eqchain(chain(i:i),'G')) then
      f_type = 'R'
      ok = .false.
    elseif  (sic_eqchain(chain(i:i),'E')) then
      f_type = 'R'
      ok = .false.
    elseif  (sic_eqchain(chain(i:i),'D')) then
      f_type = 'R'
      ok = .false.
    endif
    if (i.lt.nchar) then
      i = i+1
    else
      ok = .false.
    endif
  enddo
  !
  if (f_type.eq.'C') then
    is = sic_start(0,iarg)
    il = sic_end(0,iarg)
    if (index(line(is:il),'"').eq.0) then
      found = .false.
      call sic_descriptor (argum,ldesc,found)  ! Checked
      if (found) call destoc(ldesc%type,ldesc%addr,argum)
    endif
    il = len(argum)
    ! "il-1" preserves 1 place for the "?" at the end, else we can have
    ! an overflow when writing argum+? into argum if the "A" format is
    ! larger than len(argum) ("A" means also everything).
    !
#if defined(IFORT)
      ! Re-Write in place is not allowed on IFORT 
      ! It returns undocumented error 768 (last documented value is 759)
      tmparg = argum
      write(argum,trim(chain),iostat=ier)  tmparg(1:il-1),'?'    
#else
      write(argum,trim(chain),iostat=ier)  argum(1:il-1),'?'
#endif      
  else
    if (f_type.eq.'I') then
      call sic_i4 (line,0,iarg,n,.true.,error)
      if (.not.error) write(argum,chain(1:nchar),iostat=ier) n,'?'
    else
      call sic_r8 (line,0,iarg,r,.true.,error)
      if (.not.error) write(argum,chain(1:nchar),iostat=ier) r,'?'
    endif
    if (error) then
      call sic_message(seve%e,rname,'Format / Variable type mismatch')
      return
    endif
  endif
  if (ier.ne.0) then
    call putios('E-LET,  ',ier)
    call sic_message(seve%e,rname,'Error executing LET /FORMAT')
    error = .true.
    return
  endif
  nchar = len_trim(argum)         ! drop the "?"
  argum(nchar:nchar) = ' '
end subroutine sic_letformat
!
subroutine let_avar_sexag(line,var,spec,error)
  use gildas_def
  use gbl_format
  use phys_const
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>let_avar_sexag
  use sic_types
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command LET Out [=] In /SEXA [D|H|R] [D|H|R]
  ! In and Out may be Numeric and String or vice-versa.
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: line   ! Input command line
  type(sic_variable_t),   intent(in)    :: var    ! Output variable
  type(sic_dimensions_t), intent(inout) :: spec   !
  logical,                intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LET'
  character(len=1024) :: local_line
  type(sic_descriptor_t) :: rdesc
  integer(kind=4) :: nc,ndiv
  real(kind=8) :: value
  integer(kind=address_length) :: ipnt
  character(len=12) :: argum
  character(len=1) :: unit_in,unit_out
  integer(kind=4), parameter :: nunits=3
  character(len=1), parameter :: units(nunits)=(/'D','H','R'/)
  !
  ! Incarnation not allowed, sic_volatile not needed
  call extract_descr(rdesc,var%desc,spec%done,var%id%name,.false.,0,error)
  if (error)  return
  !
  ! Reject unsupported cases
  if (spec%done(1)%implicit .or. rdesc%ndim.ne.0) then
    call sic_message(seve%e,rname,'Sexagesimal mode only valid for '//  &
    'scalar variables')
    error = .true.
    return
  endif
  !
  ! Check if in/out units are present
  argum = 'D'  ! Degrees for input by default
  call sic_ch(line,optsexage,1,argum,nc,.false.,error)
  if (error) return
  call sic_upper(argum)
  call sic_ambigs(rname,argum(1:1),unit_out,nc,units,nunits,error)
  if (error) return
  !
  argum = 'D'  ! Degrees for output by default
  call sic_ch(line,optsexage,2,argum,nc,.false.,error)
  if (error) return
  call sic_upper(argum)
  call sic_ambigs(rname,argum(1:1),unit_in,nc,units,nunits,error)
  if (error) return
  !
  if (rdesc%type.eq.fmt_i4 .or.  &
      rdesc%type.eq.fmt_i8 .or.  &
      rdesc%type.eq.fmt_r4 .or.  &
      rdesc%type.eq.fmt_r8) then
    ! Output is numeric
    call sic_ch (line,0,2,local_line,nc,.true.,error)
    if (error) return
    !
    if (local_line(1:nc).eq.'=') then
      ! Syntax used was: [LET] OUT = IN /SEXA
      call sic_ch (line,0,3,local_line,nc,.true.,error)
      if (error) return
    endif
    !
    call sic_sexa(local_line,nc,value,error)
    if (error) return
    !
    ! Convert input value to degrees
    select case (unit_in)
    case('D')
      continue
    case('H')
      value = value*15.d0
    case('R')
      call sic_message(seve%e,rname,  &
        'Illegal Radian unit for input sexagesimal string')
      error = .true.
      return
    end select
    !
    ! Convert input degrees to output value
    select case (unit_out)
    case('D')
      continue
    case('H')
      value = value/15.d0
    case('R')
      value = value*pi/180.d0
    end select
    !
    ipnt = gag_pointer(rdesc%addr,memory)
    if (rdesc%type.eq.fmt_i4) then
      call r8toi4(value,memory(ipnt),1)
    elseif (rdesc%type.eq.fmt_r4) then
      call r8tor4(value,memory(ipnt),1)
    elseif (rdesc%type.eq.fmt_r8) then
      call r8tor8(value,memory(ipnt),1)
    elseif (rdesc%type.eq.fmt_i8) then
      call r8toi8(value,memory(ipnt),1)
    endif
    !
  elseif (rdesc%type.gt.0) then
    ! Output is character string
    call sic_r8(line,0,2,value,.true.,error)
    if (error) return
    !
    ! Convert input value to radians ('sexag' expects angles in radians).
    select case (unit_in)
    case('D')
      value = value*pi/180.d0
    case('H')
      value = value*pi/12.d0
    case('R')
      continue
    end select
    !
    ! Select the number of divisions per turn for the output string
    select case (unit_out)
    case('D')
      ndiv = 360
    case('H')
      ndiv = 24
    case('R')
      call sic_message(seve%e,rname,  &
        'Illegal Radian unit for output sexagesimal string')
      error = .true.
      return
    end select
    !
    ! Compute the string
    call rad2sexa(value,ndiv,local_line(1:rdesc%type))
    if (error) return
    !
    ipnt = gag_pointer(rdesc%addr,memory)
    nc=min(len(local_line),rdesc%type)
    call bytoby(local_line,memory(ipnt),nc)
    !
  else
    ! Trap remaining unsupported cases (e.g. logical)
    call sic_message(seve%e,rname,  &
      'Unsupported output type in sexagesimal mode')
    error = .true.
    return
  endif
  !
end subroutine let_avar_sexag

!-----------------------------------------------------------------------
! This file provides routines which return useful values of Any Working
! (GTV) Directory or Device.
!-----------------------------------------------------------------------
subroutine get_free_slot_output(output,error)
  use gtv_interfaces, except_this=>get_free_slot_output
  use gtv_types
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Get a free slot for a 'output' instance.
  ! ---
  !  Thread status: not thread safe. Should the 'all_outputs' structure
  ! be protected?
  !---------------------------------------------------------------------
  type(gt_display), pointer :: output  ! The 'gt_display' instance found
  logical,    intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GET_FREE_SLOT_OUTPUT'
  integer :: iout
  !
  do iout=1,moutputs
    if (.not.all_outputs(iout)%used) then
      ! Found an available slot at iout position
      all_outputs(iout)%used = .true.
      output => all_outputs(iout)
      return
    endif
  enddo
  !
  ! No free instance available
  ! call gtv_message(seve%e,rname,'Internal error: no free output instance')
  ! The following message is currently biased to X windows as it is the
  ! only device which uses the 'all_outputs' array.
  call gtv_message(seve%e,'DEVICE','Can not create more than 20 windows')
  output => null()
  error = .true.
  !
end subroutine get_free_slot_output
!
subroutine get_slot_output_by_num(dir,win_num,output,error)
  use gbl_message
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>get_slot_output_by_num
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Return the index of the output instance which is identified by
  ! the input directory and window number.
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe
  !---------------------------------------------------------------------
  type(gt_directory)              :: dir      ! Input directory
  integer(kind=4),  intent(in)    :: win_num  ! Window number
  type(gt_display), pointer       :: output   ! The 'gt_display' instance found
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GET_SLOT_OUTPUT_BY_NUM'
  integer(kind=address_length) :: graph_env
  character(len=message_length) :: mess
  logical :: found
  !
  graph_env = c_get_win_genv(dir%x%genv_array,win_num)
  !
  call get_slot_output_by_genv(graph_env,output,.true.,found,error)
  if (error) then
    write(mess,*) 'Internal error: output instance not found (num = ',  &
      win_num,')'
    call gtv_message(seve%e,rname,mess)
    return
  endif
  !
end subroutine get_slot_output_by_num
!
subroutine get_slot_output_by_genv(graph_env,output,present,found,error)
  use gtv_interfaces, except_this=>get_slot_output_by_genv
  use gildas_def
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Return the index of the output instance which is identified by
  ! the input graph_env.
  ! ---
  !  Thread status: not thread safe. Should the 'all_outputs' structure
  ! be protected?
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)    :: graph_env  ! Identifier
  type(gt_display),             pointer       :: output     ! The 'gt_display' instance found
  logical,                      intent(in)    :: present    ! Must the graph_env exist?
  logical,                      intent(out)   :: found      ! .true. if found
  logical,                      intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GET_SLOT_OUTPUT_BY_GENV'
  integer :: iout
  character(len=message_length) :: mess
  !
  do iout=1,moutputs
    if (all_outputs(iout)%used) then
      if (all_outputs(iout)%x%graph_env.eq.graph_env) then
        found = .true.
        output => all_outputs(iout)
        return
      endif
    endif
  enddo
  !
  ! Not found...
  found = .false.
  output => null()
  if (present) then
    write(mess,*) 'Internal error: output instance not found (genv = ',  &
      graph_env,')'
    call gtv_message(seve%e,rname,mess)
    error = .true.
  endif
  !
end subroutine get_slot_output_by_genv
!
function get_window_cnum_byname(dir,rname,line,iopt,iarg,error)
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>get_window_cnum_byname
  use gtv_types
  use gtv_tree
  !---------------------------------------------------------------------
  ! @ private
  !  Return the window instance in the input directory which is
  ! identified by its name (can be "ZOOM") or window number (as seen
  ! by user).
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe
  !---------------------------------------------------------------------
  integer(kind=4) :: get_window_cnum_byname  ! Function value on return
  type(gt_directory), intent(in)    :: dir    ! Directory to search in
  character(len=*),   intent(in)    :: rname  ! Calling routine name
  character(len=*),   intent(in)    :: line   ! Command line
  integer(kind=4),    intent(in)    :: iopt   ! Option number in command line
  integer(kind=4),    intent(in)    :: iarg   ! Argument number in option
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: zoom='ZOOM'
  character(len=gtvpath_length) :: wname
  logical :: found
  integer(kind=4) :: nc,win_num
  !
  call sic_ke(line,iopt,iarg,wname,nc,.true.,error)
  if (error) return
  !
  if (wname(1:nc).eq.zoom(1:min(nc,4))) then
    call get_zoom_win(dir,get_window_cnum_byname,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,  &
        'No zoom window attached to current directory')
      error = .true.
      return
    endif
  else
    call sic_math_inte(wname,nc,win_num,error)
    ! Translate the user number into internal number
    get_window_cnum_byname = get_window_cnum(dir,win_num,error)
  endif
  !
end function get_window_cnum_byname
!
function get_window_cnum(dir,usernum,error)
  use gbl_message
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>get_window_cnum
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Return the window instance which is identified by its parent
  ! directory and window number (as seen by user).
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe
  !---------------------------------------------------------------------
  integer(kind=4) :: get_window_cnum  ! Function value on return
  type(gt_directory), intent(in)    :: dir      ! Input directory
  integer(kind=4),    intent(in)    :: usernum  ! Window number (as seen by user)
  logical,            intent(inout) :: error    ! Logical error flag
  ! Local
  integer :: iwin
  type(gt_display), pointer :: output
  !
  if (error)  return
  !
  if (dir%x%nbwin.eq.0) then
    get_window_cnum = 0
    return
  else
    get_window_cnum = -1
  endif
  !
  do iwin=0,dir%x%nbwin-1
    call get_slot_output_by_num(dir,iwin,output,error)
    if (error)  return
    if (output%x%number.eq.usernum) then
      get_window_cnum = iwin
      return
    endif
  enddo
  !
  ! Not found... Error will be detected later.
  !
end function get_window_cnum
!
function get_window_usernum(dir,cnum,error)
  use gtv_types
  use gtv_interfaces, except_this=>get_window_usernum
  !---------------------------------------------------------------------
  ! @ private
  !  Return the window number in the user system of numbering, given
  ! the internal number in the C-and-continuous internal system of
  ! numbering.
  !---------------------------------------------------------------------
  integer(kind=4) :: get_window_usernum  ! Function value on return
  type(gt_directory), intent(in)    :: dir    ! The directory the window is attached on
  integer(kind=4),    intent(in)    :: cnum   ! The C number of the window we look for
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_display), pointer :: output
  !
  get_window_usernum = 0
  !
  call get_slot_output_by_num(dir,cnum,output,error)
  if (error)  return
  !
  get_window_usernum = output%x%number
  !
end function get_window_usernum
!
subroutine free_slot_output_by_genv(graph_env,error)
  use gtv_interfaces, except_this=>free_slot_output_by_genv
  use gildas_def
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Free the output instance which is identified by the input
  ! graph_env.
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)  :: graph_env  ! Identifier
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FREE_SLOT_OUTPUT_BY_GENV'
  integer :: iout
  !
  do iout=1,moutputs
    if (all_outputs(iout)%used) then
      if (all_outputs(iout)%x%graph_env.eq.graph_env) then
        call gt_output_reset(all_outputs(iout))
        return
      endif
    endif
  enddo
  !
  ! Not found...
  call gtv_message(seve%e,rname,'Internal error: output instance not found')
  error = .true.
  !
end subroutine free_slot_output_by_genv
!
subroutine gt_output_reset(output)
  use gtv_interfaces, except_this=>gt_output_reset
  use gtv_types
  use gtv_bitmap
  !---------------------------------------------------------------------
  ! @ private
  !   Reset the instance parameters, set it unused, and free the
  ! allocated memory it was using for images.
  !---------------------------------------------------------------------
  type(gt_display) :: output  ! Output instance
  !
  output%used = .false.
  output%autorotate = .false.
  output%autoscale = .true.
  !
  output%px1 = 0  ! Reset actual size ensures that device defaults will
  output%px2 = 0  ! be used instead.
  output%py1 = 0
  output%py2 = 0
  !
  output%idashe = 1
  output%iweigh = graisse(1)
  output%icolou = 1
  !
  call x_display_reset(output%x)
  !
end subroutine gt_output_reset
!
subroutine x_display_reset(xdisplay)
  use gtv_interfaces, except_this=>x_display_reset
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(x_output), intent(inout) :: xdisplay  ! Instance to be reset
  ! Local
  type(gt_bitmap), pointer :: xbitmap,next
  !
  xdisplay%name = ' '
  xdisplay%graph_env = 0
  xdisplay%is_zoom = .false.
  !
  ! 0 values (invalid for size) mean unset
  xdisplay%geometry%x = 0.
  xdisplay%geometry%unitx = ' '
  xdisplay%geometry%y = 0.
  xdisplay%geometry%unity = ' '
  !
  ! -1 values (invalid for position) mean unset
  xdisplay%position%x = -1.
  xdisplay%position%unitx = ' '
  xdisplay%position%y = -1.
  xdisplay%position%unity = ' '
  !
  ! Clean the X bitmaps
  xbitmap => xdisplay%bitmap_first
  do while (associated(xbitmap))
    ! Keep track of next before deletion
    next => xbitmap%next
    !
    call gt_bitmap_deallocate(xbitmap)
    xbitmap => next
  enddo
  xdisplay%bitmap_first => null()
  xdisplay%bitmap_last => null()
  !
end subroutine x_display_reset
!
subroutine gt_bitmap_deallocate(bitmap)
  use gtv_interfaces, except_this=>gt_bitmap_deallocate
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Elemental routine which deallocates the input 'gt_bitmap' and
  ! frees the data associated. This routine does NOT take care of the
  ! pointers to this instance: it is up to the calling routine to
  ! remake the chain, if required.
  !---------------------------------------------------------------------
  type(gt_bitmap), pointer :: bitmap  !
  !
  if (associated(bitmap%irvalues))  deallocate(bitmap%irvalues)
  if (associated(bitmap%igvalues))  deallocate(bitmap%igvalues)
  if (associated(bitmap%ibvalues))  deallocate(bitmap%ibvalues)
  !
  ! No need: we destroy the instance right after
  ! bitmap%irvalues => null()
  ! bitmap%igvalues => null()
  ! bitmap%ibvalues => null()
  ! bitmap%image => null()
  ! bitmap%next => null()
  !
  deallocate(bitmap)
  !
end subroutine gt_bitmap_deallocate
!
subroutine print_gt_device(dev)
  use gtv_interfaces, except_this=>print_gt_device
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print the content various variables attached to the input gt_device
  ! structure. For debugging purpose.
  !---------------------------------------------------------------------
  type(gt_device), intent(in) :: dev  ! Input gt_device
  !
  write(*,101) 'Protocol:',dev%protocol
  write(*,101) 'Linit1:',  dev%linit1
  write(*,100) 'Init1:',   trim(dev%init1)
  write(*,101) 'Linit2:',  dev%linit2
  write(*,100) 'Init2:',   trim(dev%init2)
  !
  write(*,101) 'Px1 (default):',dev%px1
  write(*,101) 'Px2 (default):',dev%px2
  write(*,101) 'Py1 (default):',dev%py1
  write(*,101) 'Py2 (default):',dev%py2
  write(*,102) 'Rxy:',          dev%rxy
  !
  ! To be continued
  !
100 format(2X,A,T25,A)     ! Character string
101 format(2X,A,T25,I8)    ! Integer value
102 format(2X,A,T25,F8.3)  ! Float value
end subroutine print_gt_device
!
subroutine print_gt_output(output)
  use gtv_interfaces, except_this=>print_gt_output
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print the content of various variables attached to the input
  ! gt_device structure. For debugging purpose.
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: output  ! Input gt_display instance
  !
  write(*,111) 'Px1, Px2 (actual):',output%px1,output%px2
  write(*,111) 'Py1, Py2 (actual):',output%py1,output%py2
  !
  write(*,112) 'Gx1, Gx2:',         output%gx1,output%gx2
  write(*,112) 'Gy1, Gy2:',         output%gy1,output%gy2
  !
  ! To be continued
  !
! 103 format(2X,A,T25,L1,  T35,L1)    ! 1 Logical value
! 110 format(2X,A,T25,A,   T35,A)     ! 2 Character strings
111 format(2X,A,T25,I8,  T35,I8)    ! 2 Integer values
112 format(2X,A,T25,F8.3,T35,F8.3)  ! 2 Float values
end subroutine print_gt_output
!
subroutine get_scale_awd(out,scalex,scaley)
  use gtv_interfaces, except_this=>get_scale_awd
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the X and Y scaling relation between physical and pixel
  ! units, for Input Working Device.
  !  Note that the range of pixels [out%px1:out%px2] is fully mapped
  ! on the physical range [out%gx1:out%gx2]. Pixels have a finite size:
  ! the left border of the first pixel is aligned on the left border of
  ! the physical range, and the right border of the last pixel is
  ! aligned on the right border of the physical range.
  !  This is very useful for images: when you ask a 100 pixels image to
  ! be displayed on a 100 pixels device, you except a 1 to 1 pixel
  ! alignment (not 100 image pixels on 99 device pixels). Note also that
  ! you want to align the boundaries of the side pixels, NOT the center
  ! of the side pixels. Example:
  ! 1) Same number of pixels
  !  Image:  |--.--|--.--|--.--|--.--|--.--|--.--|--.--|--.--|  8 pixels
  !  Device: |--.--|--.--|--.--|--.--|--.--|--.--|--.--|--.--|  8 pixels
  ! 2a) Twice more, we want boundaries aligned:
  !  Image:  |-----.-----|-----.-----|-----.-----|-----.-----|  4 pixels
  !  Device: |--.--|--.--|--.--|--.--|--.--|--.--|--.--|--.--|  8 pixels
  ! 2b) Twice more, we DO NOT want centers aligned because this truncate
  !     the original pixels:
  !  Image:  |-----.-----|-----.-----|-----.-----|-----.-----|  4 pixels
  !  Device:     |-.--|--.-|--.-|--.-|--.-|--.-|--.-|--.-|      8 pixels
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out     ! Input gt_display
  real(kind=4),     intent(out) :: scalex  ! Number of pixels per world unit in X
  real(kind=4),     intent(out) :: scaley  ! Number of pixels per world unit in Y
  ! Local
  real(kind=4) :: gx,gy,kxy
  !
  if (out%py1.lt.out%py2) then
    ! out%py2-out%py1+1 > 0 = +(number of pixels)
    gy = (out%gy2-out%gy1)/float(out%py2-out%py1+1)
  else
    ! out%py2-out%py1-1 < 0 = -(number of pixels)
    gy = (out%gy2-out%gy1)/float(out%py2-out%py1-1)
  endif
  if (out%px1.lt.out%px2) then
    gx = (out%gx2-out%gx1)/float(out%px2-out%px1+1)
  else
    gx = (out%gx2-out%gx1)/float(out%px2-out%px1-1)
  endif
  kxy = gx/gy
  if (abs(gy*out%dev%rxy) .ge. abs(gx)) then
    scaley = 1./gy
    if (kxy.gt.0.) then
      scalex = scaley / out%dev%rxy
    else
      scalex = - scaley / out%dev%rxy
    endif
  else
    scalex = 1./gx
    if (kxy.gt.0.) then
      scaley = scalex * out%dev%rxy
    else
      scaley = - scalex * out%dev%rxy
    endif
  endif
  !
end subroutine get_scale_awd
!
subroutine get_central_pixel_awd(out,xpix_center,ypix_center)
  use gtv_interfaces, except_this=>get_central_pixel_awd
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the center pixel of Input Working Device. Should be dynamic
  ! at some point i.e. will dynamically get the device size (and NOT
  ! from some global variable), and then compute this center.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out          ! Input gt_display
  real(kind=4),     intent(out) :: xpix_center  ! Central pixel X coordinate
  real(kind=4),     intent(out) :: ypix_center  ! Central pixel X coordinate
  !
  xpix_center = float(out%px1+out%px2)/2. + (0.5-out%dev%poff)
  ypix_center = float(out%py1+out%py2)/2. + (0.5-out%dev%poff)
  !
end subroutine get_central_pixel_awd
!
subroutine get_central_clipping_awd(out,x_center,y_center)
  use gtv_interfaces, except_this=>get_central_clipping_awd
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the center of the clipping window of the Input Working
  ! Device. Should be dynamic at some point i.e. will dynamically get
  ! the current device clipping window (and NOT from some global
  ! variable), and then compute this center.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out       ! Input gt_display
  real(kind=4),     intent(out) :: x_center  ! Center X point of plot space
  real(kind=4),     intent(out) :: y_center  ! Center Y point of plot space
  !
  x_center = (out%gx1+out%gx2)/2.
  y_center = (out%gy1+out%gy2)/2.
  !
end subroutine get_central_clipping_awd
!
subroutine world_to_pixel_size_i4(out,wx,wy,px,py)
  use gtv_interfaces, except_this=>world_to_pixel_size_i4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic world_to_pixel_size
  ! Convert world SIZE into pixel size for the input working device.
  ! ---
  !  Integer(kind=4) version: do not call directly. Use generic
  ! interface 'world_to_pixel_size' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: wx,wy  ! Input size in world coordinates
  integer(kind=4),  intent(out) :: px,py  ! Output size in pixels
  ! Local
  real(kind=4) :: rpx,rpy
  !
  call world_to_pixel_size_r4(out,wx,wy,rpx,rpy)
  !
  px = nint(rpx)
  py = nint(rpy)
  !
end subroutine world_to_pixel_size_i4
!
subroutine world_to_pixel_size_r4(out,wx,wy,px,py)
  use gtv_interfaces, except_this=>world_to_pixel_size_r4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic world_to_pixel_size
  ! Convert world SIZE into pixel size for the input working device.
  ! ---
  !  Real(kind=4) version: do not call directly. Use generic
  ! interface 'world_to_pixel_size' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: wx,wy  ! Input size in world coordinates
  real(kind=4),     intent(out) :: px,py  ! Output size in pixels
  ! Local
  real(kind=4) :: gsclx,gscly
  !
  ! Get the Current Working Device parameters:
  call get_scale_awd(out,gsclx,gscly)
  !
  px = wx*abs(gsclx)
  py = wy*abs(gscly)
  !
end subroutine world_to_pixel_size_r4
!
subroutine pixel_to_world_size_i4(out,px,py,wx,wy)
  use gtv_interfaces, except_this=>pixel_to_world_size_i4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic pixel_to_world_size
  !  Convert pixel SIZE into world size for the input working device.
  ! ---
  !  Integer(kind=4) version: do not call directly. Use generic
  ! interface 'pixel_to_world_size' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  integer(kind=4),  intent(in)  :: px,py  ! Input pixel size
  real(kind=4),     intent(out) :: wx,wy  ! Output world size
  !
  call pixel_to_world_size_r4(out,real(px,kind=4),real(py,kind=4),wx,wy)
  !
end subroutine pixel_to_world_size_i4
!
subroutine pixel_to_world_size_r4(out,px,py,wx,wy)
  use gtv_interfaces, except_this=>pixel_to_world_size_r4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic pixel_to_world_size
  !  Convert pixel SIZE into world size for the input working device.
  ! ---
  !  Real(kind=4) version: do not call directly. Use generic
  ! interface 'pixel_to_world_size' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: px,py  ! Input pixel size
  real(kind=4),     intent(out) :: wx,wy  ! Output world size
  ! Local
  real(kind=4) :: gsclx,gscly
  !
  ! Get the Current Working Device parameters:
  call get_scale_awd(out,gsclx,gscly)
  !
  wx = px/gsclx
  wy = py/gscly
  !
end subroutine pixel_to_world_size_r4
!
subroutine world_to_pixel_i4(out,wx,wy,px,py)
  use gtv_interfaces, except_this=>world_to_pixel_i4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic world_to_pixel
  ! Convert world COORDINATES into pixel coordinates for the input
  ! working device.
  ! ---
  !  Integer(kind=4) version: do not call directly. Use generic
  ! interface 'world_to_pixel' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: wx,wy  ! Input world coordinates
  integer(kind=4),  intent(out) :: px,py  ! Output pixel coordinates
  ! Local
  real(kind=4) :: rpx,rpy
  !
  call world_to_pixel_r4(out,wx,wy,rpx,rpy)
  !
  px = nint(rpx)
  py = nint(rpy)
  !
end subroutine world_to_pixel_i4
!
subroutine world_to_pixel_r4(out,wx,wy,px,py)
  use gtv_interfaces, except_this=>world_to_pixel_r4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic world_to_pixel
  ! Convert world COORDINATES into pixel coordinates for the input
  ! working device.
  ! ---
  !  Real(kind=4) version: do not call directly. Use generic
  ! interface 'world_to_pixel' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: wx,wy  ! Input world coordinates
  real(kind=4),     intent(out) :: px,py  ! Output pixel coordinates
  ! Local
  real(kind=4) :: gsclx,gscly,pox,poy,gox,goy
  !
  ! Get the Current Working Device parameters:
  call get_scale_awd(out,gsclx,gscly)
  call get_central_pixel_awd(out,pox,poy)
  call get_central_clipping_awd(out,gox,goy)
  !
  px = (wx-gox)*gsclx + pox
  py = (wy-goy)*gscly + poy
  !
  ! Description of the above formula:
  ! - we want to align out%gx1 to the left border  of the letf  pixel, and
  !                    out%gx2 to the right border of the right pixel
  !   (i.e. the physical range covers all the pixels).
  ! - This writes as:
  !    out%gx1 <=> out%px1-1/2
  !    out%gx2 <=> out%px2+1/2  if  out%px1<out%px2, OR
  !    out%gx1 <=> out%px2-1/2
  !    out%gx2 <=> out%px1+1/2  if  out%px1>out%px2
  ! - in get_scale_awd, we get easily the slope of the relationship
  !   formula (something like px = wx*m+p)
  ! - Now we have m but we need p. Instead of choosing p aligned on gx1
  !   or gx2, we choose p at the center of them. This makes our life
  !   easier, because it nullifies the +-1/2 problem depending on the
  !   pixel axis sign.
  !
end subroutine world_to_pixel_r4
!
subroutine pixel_to_world_i4(out,px,py,wx,wy)
  use gtv_interfaces, except_this=>pixel_to_world_i4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic pixel_to_world
  !  Convert pixel coordinates into world coordinates for the input
  ! working device.
  ! ---
  !  Integer(kind=4) version: do not call directly. Use generic
  ! interface 'pixel_to_world' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  integer(kind=4),  intent(in)  :: px,py  ! Input pixel coordinates
  real(kind=4),     intent(out) :: wx,wy  ! Output world coordinates
  !
  call pixel_to_world_r4(out,real(px,kind=4),real(py,kind=4),wx,wy)
  !
end subroutine pixel_to_world_i4
!
subroutine pixel_to_world_r4(out,px,py,wx,wy)
  use gtv_interfaces, except_this=>pixel_to_world_r4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic pixel_to_world
  !  Convert pixel coordinates into world coordinates for the input
  ! working device.
  ! ---
  !  Real(kind=4) version: do not call directly. Use generic
  ! interface 'pixel_to_world' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: px,py  ! Input pixel coordinates
  real(kind=4),     intent(out) :: wx,wy  ! Output world coordinates
  ! Local
  real(kind=4) :: gsclx,gscly,pox,poy,gox,goy
  !
  ! Get the Current Working Device parameters:
  call get_scale_awd(out,gsclx,gscly)
  call get_central_pixel_awd(out,pox,poy)
  call get_central_clipping_awd(out,gox,goy)
  !
  wx = (px-pox)/gsclx + gox
  wy = (py-poy)/gscly + goy
  !
end subroutine pixel_to_world_r4

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_language
  use cubetools_parameters
  use cubetools_structure
  use cubetemplate_messaging
  !
  use cubetemplate_format2format
  use cubetemplate_fullcube2fullcube
  use cubetemplate_image2image
  use cubetemplate_image2visi
  use cubetemplate_list
  use cubetemplate_spectrum2spectrum
  use cubetemplate_spectrum2spectrum_onechan
  use cubetemplate_subcube2subcube
  use cubetemplate_table2cube
  use cubetemplate_visi2visi
  !
  public :: cubetemplate_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubetemplate_register_language(error)
    !----------------------------------------------------------------------
    ! Register the CUBE\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'TEMPLATE',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'COMMAND templates',&
         'TEMPLATE provides developer scaffolds for CUBE command implementations.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Commands illustrate the standard register/parse/main command flow.'//strg_cr//&
         '- Template variants cover multiple input/output data granularities.'//strg_cr//&
         '- Execution follows interface timing and finish wrappers used in production.'//strg_cr//&
         '- LIST demonstrates typed list and session-structure utilities.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> TEMPLATE\LIST'//strg_cr//&
         'CUBE> TEMPLATE\IMAGE2IMAGE cube_in'//strg_cr//&
         'CUBE> TEMPLATE\SPEC2SPEC cube_in'//strg_bl//&
         'Warning:'//strg_cr//&
         'TEMPLATE commands are development examples, not production processing tools.',&
         'gag_doc:hlp/cube-help-template.hlp',&
         cubetemplate_execute_command,&
         langid,&
         error)
    if (error) return
    !----------------------------------------------------------------------
    !
    call format2format%register(error)
    if (error) return
    call fullcube2fullcube%register(error)
    if (error) return
    call image2image%register(error)
    if (error) return
    call image2visi%register(error)
    if (error) return
    call list%register(error)
    if (error) return
    call spectrum2spectrum%register(error)
    if (error) return
    call spectrum2spectrum_onechan%register(error)
    if (error) return
    call subcube2subcube%register(error)
    if (error) return
    call table2cube%register(error)
    if (error) return
    call visi2visi%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubetemplate_register_language
  !
  subroutine cubetemplate_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the CUBE\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'TEMPLATE?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubeadm_finish_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubetemplate_execute_command
end module cubetemplate_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehelp_collect
  use sic_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_ascii
  use cube_messaging
  !
  public :: collect
  private
  !
  type :: collect_comm_t
     type(option_t),           pointer :: comm
     type(option_t),           pointer :: format
     type(keywordlist_comm_t), pointer :: format_arg
   contains
     procedure, public  :: register  => cubehelp_collect_register
     procedure, private :: parse     => cubehelp_collect_parse
     procedure, private :: main      => cubehelp_collect_main
  end type collect_comm_t
  type(collect_comm_t) :: collect
  !
  character(len=*), parameter :: collect_basename_default='cube'
  type :: collect_user_t
     character(len=file_l) :: filename
     character(len=argu_l) :: format
   contains
     procedure, private :: toprog => cubehelp_collect_user_toprog
  end type collect_user_t
  !
  type :: collect_prog_t
     character(len=file_l) :: filename
     integer(kind=code_k)  :: iformat
     type(ascii_file_t)    :: file
   contains
     procedure, private :: collect_help  => cubehelp_collect_prog_help
     procedure, private :: collect_flags => cubehelp_collect_prog_flags
     procedure, private :: language      => cubehelp_collect_flags_language
     procedure, private :: command       => cubehelp_collect_flags_command 
     procedure, private :: option        => cubehelp_collect_flags_option
     procedure, private :: arguments     => cubehelp_collect_flags_arguments
     procedure, private :: argument      => cubehelp_collect_flags_argument
  end type collect_prog_t
  type(collect_prog_t) :: prog
  !
contains
  !
  subroutine cubehelp_collect_command(line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(collect_user_t) :: user
    !
    call collect%parse(line,user,error)
    if (error) return
    call collect%main(user,error)
    if (error) return
  end subroutine cubehelp_collect_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehelp_collect_register(collect,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(collect_comm_t), intent(inout) :: collect
    logical,               intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='COLLECT>REGISTER'
    !
    call cube_message(seve%t,rname,'Welcome')
    !
    call cubetools_register_command(&
         'COLLECT','[File]',&
         'Collect all the helps in a single file',&
         strg_id,&
         cubehelp_collect_command,&
         collect%comm,error)
    if (error) return
    call stdarg%register( &
         'FILE',  &
         'Output file name', &
         'Output file name (default is "cube.hlp" in the current working directory).',&
         code_arg_optional, &
         error)
    if (error) return
    !
    ! /FORMAT
    call cubetools_register_option(&
         'FORMAT','Kind',&
         'Collect options, arguments, and flags under the named kind',&
         strg_id,&
         collect%format,error)
    if (error) return
    call keyarg%register( &
         'Kind',  &
         'Format kind', &
         'TEX: TeX format for inclusion in LaTeX files'&
         //strg_cr//&
         'FLAGS: ASCII format showing expected flags for command and &
         &option arguments',&
         code_arg_mandatory, &
         help_formats, &
         .not.flexible, &
         collect%format_arg, &
         error)
    if (error) return
    !
  end subroutine cubehelp_collect_register
  !
  subroutine cubehelp_collect_parse(collect,line,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_comm_t), intent(in)    :: collect
    character(len=*),      intent(in)    :: line
    type(collect_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    user%filename = collect_basename_default
    call cubetools_getarg(line,collect%comm,1,user%filename,.not.mandatory,error)
    if (error) return
    !
    user%format = help_formats(help_format_tex)
    call cubetools_getarg(line,collect%format,1,user%format,.not.mandatory,error)
    if (error) return
  end subroutine cubehelp_collect_parse
  !
  subroutine cubehelp_collect_main(collect,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_comm_t), intent(in)    :: collect
    type(collect_user_t),  intent(in)    :: user
    logical,               intent(inout) :: error
    !
    type(collect_prog_t) :: prog
    !
    call user%toprog(prog,error)
    if (error) return
    select case (prog%iformat)
    case (help_format_flags)
      call prog%collect_flags(error)
      if (error) return
    case (help_format_tex)
      call prog%collect_help(error)
      if (error) return
    end select
  end subroutine cubehelp_collect_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehelp_collect_user_toprog(user,prog,error)
    use gkernel_interfaces
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(collect_user_t), intent(in)    :: user
    type(collect_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    character(len=32) :: solved
    character(len=*), parameter :: rname='COLLECT>USER>TOPROG'
    !
    call cubetools_disambiguate_strict(user%format,help_formats,  &
      prog%iformat,solved,error)
    if (error)  return
    !
    call sic_parse_file(user%filename,' ',help_extensions(prog%iformat),prog%filename)
  end subroutine cubehelp_collect_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehelp_collect_prog_help(prog,error)
    use gkernel_interfaces
    use cubetools_help_tool
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(in)    :: prog
    logical,               intent(inout) :: error
    !
    type(help_tool_t) :: help
    character(len=*), parameter :: rname='COLLECT>HELP'
    !
    call file%set_width() ! Default file width
    call file%set_format(help_format_tex)
    call help%open_file(prog%filename,error)
    if (error) goto 10
    call cubetools_structure_help_iterate(help_format_tex,error)
    if (error) goto 10
10  continue
    call help%close_file(error)
    if (error) return
    call terminal%set_width()  ! Dynamic terminal width
    call terminal%set_format()  ! Specific terminal format
  end subroutine cubehelp_collect_prog_help
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehelp_collect_prog_flags(prog,error)
    use cubetools_language
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    integer(kind=lang_k) :: ilang
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='COLLECT>FLAGS'
    !
    ! Note this help format can not use the generic help collector in
    ! libcubesyntax because it needs properties of cubeid_arg_t
    !
    call prog%file%open(prog%filename,'write',error)
    if (error) return
    !
    call prog%file%write_next('List of Flags demanded by commands',error)
    if (error) return
    call prog%file%write_next('* Package: '//pack%name,error)
    if (error) return
    !
    do ilang=1,pack%lang%n
       lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
       if (error) return
       call prog%language(lang,error)
       if (error) return
    enddo
    !
    call prog%file%close(error)
    if (error) return
  end subroutine cubehelp_collect_prog_flags
  !
  subroutine cubehelp_collect_flags_language(prog,lang,error)
    use cubetools_standard_comm
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(inout) :: prog
    type(language_t),      intent(in)    :: lang
    logical,               intent(inout) :: error
    !
    integer(kind=comm_k) :: icomm
    type(command_t), pointer :: comm
    character(len=*), parameter :: rname='COLLECT>FLAGS>LANGUAGE'
    !
    call prog%file%write_next('** Language: '//lang%name,error)
    if (error) return
    do icomm=1,lang%comm%n
      comm => cubetools_command_ptr(lang%comm%list(icomm)%p,error)
      if (error) return
      call prog%command(comm,lang%name,error)
      if (error) return
    enddo
  end subroutine cubehelp_collect_flags_language
  !
  subroutine cubehelp_collect_flags_command(prog,comm,langname,error)
    use sic_def
    use cubetools_primitive_opt
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(inout) :: prog
    type(command_t),       intent(in)    :: comm
    character(len=*),      intent(in)    :: langname
    logical,               intent(inout) :: error
    !
    character(len=2048) :: outbuffer
    character(len=512) :: chain
    integer(kind=opti_k) :: iopt
    class(primitive_opt_t), pointer :: opt
    character(len=*), parameter :: rname='COLLECT>FLAGS>COMMAND'
    !
    outbuffer = '*** Command '//trim(langname)//backslash//trim(comm%name)//strg_cr
    opt => cubetools_primitive_opt_ptr(comm%opt%list(0)%p,error)
    if (error) return
    !
    call prog%option(opt,'Command ',chain,error)
    if (error)  return
    outbuffer = trim(outbuffer)//chain
    !
    do iopt=1,comm%opt%n
       opt => cubetools_primitive_opt_ptr(comm%opt%list(iopt)%p,error)
       if (error) return
       call prog%option(opt,'Option /',chain,error)
       if (error) return
       outbuffer = trim(outbuffer)//chain
    enddo
    !
    call prog%file%write_next(outbuffer,error)
    if (error) return
  end subroutine cubehelp_collect_flags_command
  !
  subroutine cubehelp_collect_flags_option(prog,opt,optkind,chain,error)
    use cubetools_primitive_opt
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(collect_prog_t),  intent(in)    :: prog
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: optkind
    character(len=*),       intent(out)   :: chain
    logical,                intent(inout) :: error
    !
    integer(kind=narg_k) :: ncubes
    character(len=256) :: optargs
    !
    call prog%arguments(opt%arg,ncubes,optargs,error)
    if (error) return
    write(chain,'(4a,i0,a,i0,2a)')  &
      '    ',optkind,trim(opt%name),' has ',opt%arg%n,  &
      ' arguments (',ncubes
    if (ncubes.eq.0) then
      chain = trim(chain)//' cube)'//strg_cr
    elseif (ncubes.eq.1) then
      chain = trim(chain)//' cube):'//strg_cr//trim(optargs)
    else
      chain = trim(chain)//' cubes):'//strg_cr//trim(optargs)
    endif
  end subroutine cubehelp_collect_flags_option
  !
  subroutine cubehelp_collect_flags_arguments(prog,arglist,ncubes,optargs,error)
    use cubelist_types
    use cubeadm_cubeid_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(in)    :: prog
    type(list_t),          intent(in)    :: arglist
    integer(kind=narg_k),  intent(out)   :: ncubes   ! Number of cubes for this option
    character(len=*),      intent(out)   :: optargs  ! Description
    logical,               intent(inout) :: error
    !
    integer(kind=narg_k) :: iarg
    character(len=128) :: argflags
    class(list_object_t), pointer :: arg
    character(len=*), parameter :: rname='COLLECT>FLAGS>ARGUMENTS'
    !
    ncubes = 0
    optargs = ''
    do iarg=1,arglist%n
       arg => arglist%list(iarg)%p
       select type(arg)
       type is (cubeid_arg_t)
          ncubes = ncubes+1
          call prog%argument(arg,argflags,error)
          if (error) return
          optargs = trim(optargs)//trim(argflags)//strg_cr
       class default
          ! do nothing
       end select
    enddo
  end subroutine cubehelp_collect_flags_arguments
  !
  subroutine cubehelp_collect_flags_argument(prog,arg,argflags,error)
    use cubedag_allflags
    use cubeadm_cubeid_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(in)    :: prog
    type(cubeid_arg_t),    intent(in)    :: arg
    character(len=*),      intent(out)   :: argflags
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iflag
    character(len=*), parameter :: rname='COLLECT>FLAGS>ARGUMENT'
    !
    write(argflags,'(3a)') '       ',trim(arg%name),':'
    do iflag=1,arg%nflag
       if (arg%flag(iflag).eq.flag_any) then
          write(argflags,'(2a)') trim(argflags),' any'
       else
          write(argflags,'(3a)') trim(argflags),' ',arg%flag(iflag)%get_name()
       endif
       if (iflag.lt.arg%nflag) write(argflags,'(2a)') trim(argflags),','
    enddo
  end subroutine cubehelp_collect_flags_argument
end module cubehelp_collect
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine consistency_defaults(set,cons)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>consistency_defaults
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set   !
  type(consistency_t), intent(inout) :: cons  ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  select case (set%kind)
  case (kind_spec)
    call consistency_defaults_spec(cons)
  case (kind_cont)
    call consistency_defaults_cont(cons)
  ! case default
    ! No default set at this stage (i.e. can be called from FIND with any
    ! kind). Non supported kinds will be trappped when actually trying to
    ! check their consistency.
  end select
  !
end subroutine consistency_defaults
!
subroutine consistency_check_selection(set,line,iopt,cons,error)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>consistency_check_selection
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  integer(kind=4),     intent(in)    :: iopt   ! Number of the /NOCHECK option
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  select case (set%kind)
  case (kind_spec)
    call consistency_check_selection_spec(set,line,iopt,cons,error)
  case (kind_cont)
    call consistency_check_selection_cont(set,line,iopt,cons,error)
  case default
    call class_message(seve%e,rname,'Unsupported kind of data')
    error = .true.
  end select
  !
end subroutine consistency_check_selection
!
subroutine consistency_check_gen(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'general' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%gen%check.and.cons%gen%done) then
     if (cons%gen%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%gen%check = .false.
     endif
     write(mess,100) 'Data type',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_gen
!
subroutine consistency_check_sou(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'source' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%sou%check.and.cons%sou%done) then
     if (cons%sou%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%sou%check = .false.
     endif
     write(mess,100) 'Source name',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_sou
!
subroutine consistency_check_pos(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'position' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%pos%check.and.cons%pos%done) then
     if (cons%pos%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%pos%check = .false.
     endif
     write(mess,100) 'Position information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_pos
!
subroutine consistency_check_off(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'offset' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%off%check.and.cons%off%done) then
     if (cons%off%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%off%check = .false.
     endif
     write(mess,100) 'Offset position',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_off
!
subroutine consistency_check_lin(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'line' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%lin%check.and.cons%lin%done) then
     if (cons%lin%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%lin%check = .false.
     endif
     write(mess,100) 'Line name',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_lin
!
subroutine consistency_check_spe(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'spectroscopy' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%spe%check.and.cons%spe%done) then
     if (cons%spe%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%spe%check = .false.
     endif
     write(mess,100) 'Spectroscopic information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_spe
!
subroutine consistency_check_cal(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'calibration' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%cal%check.and.cons%cal%done) then
     if (cons%cal%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%cal%check = .false.
     endif
     write(mess,100) 'Calibration information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_cal
!
subroutine consistency_check_swi(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'switching' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%swi%check.and.cons%swi%done) then
     if (cons%swi%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%swi%check = .false.
     endif
     write(mess,100) 'Switching information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_swi
!
subroutine consistency_check_dri(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'drift' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%dri%check.and.cons%dri%done) then
     if (cons%dri%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%dri%check = .false.
     endif
     write(mess,100) 'Drift information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_dri
!
subroutine consistency_print(set,ref_head,cons)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>consistency_print
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  select case (set%kind)
  case (kind_spec)
    call consistency_print_spec(ref_head,cons)
  case (kind_cont)
    call consistency_print_cont(ref_head,cons)
  case default
    call class_message(seve%e,rname,'Unsupported kind of data')
    ! error = .true.
  end select
  !
end subroutine consistency_print
!
subroutine consistency_print_gen(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'general' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%gen%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Data type and regular x-axis sampling')
  !
end subroutine consistency_print_gen
!
subroutine consistency_print_sou(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'source' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%sou%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Source Name')
  !
end subroutine consistency_print_sou
!
subroutine consistency_print_pos(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'position' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%pos%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Position information')
  !
end subroutine consistency_print_pos
!
subroutine consistency_print_off(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'offset' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%off%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Offset position')
  !
end subroutine consistency_print_off
!
subroutine consistency_print_lin(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'line' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%lin%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Line Name')
  !
end subroutine consistency_print_lin
!
subroutine consistency_print_spe(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'spectroscopy' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%spe%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Spectroscopic information')
  !
end subroutine consistency_print_spe
!
subroutine consistency_print_cal(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'calibration' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%cal%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Calibration information')
  !
end subroutine consistency_print_cal
!
subroutine consistency_print_swi(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'switching' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%swi%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Switching information')
  !
end subroutine consistency_print_swi
!
subroutine consistency_print_dri(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'drift' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%dri%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Drift information')
  !
end subroutine consistency_print_dri
!
subroutine observation_consistency_check(set,ref_head,obs_head,cons)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(header),        intent(in)    :: obs_head  ! Header to be checked
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  select case (set%kind)
  case (kind_spec)
    call spectrum_consistency_check(set,ref_head,obs_head,cons)
  case (kind_cont)
    call continuum_consistency_check(set,ref_head,obs_head,cons)
  case default
    call class_message(seve%e,rname,'Unsupported kind of data')
    ! error = .true.
  end select
  !
end subroutine observation_consistency_check
!
subroutine observation_consistency_check_gen(kind,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_gen
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'general' consistency of the input observation header
  !---------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: kind      ! Expected kind of data
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  if (cons%gen%check) then
     cons%gen%prob = .false.
     if (obs_head%gen%kind.ne.kind) then
        if (cons%gen%mess) then
           call observation_consistency_warn(obs_head,warned)
           call class_message(seve%w,rname,  &
             '  Kind of data not supported')
        endif
        cons%gen%prob = .true.
        cons%prob = .true.
     endif
     if (obs_head%presec(class_sec_xcoo_id)) then
        if (cons%gen%mess) then
           call observation_consistency_warn(obs_head,warned)
           call class_message(seve%w,rname,  &
             '  Irregular sampling along the x-axis data unsupported')
        endif
        cons%gen%prob = .true.
        cons%prob = .true.
     endif
     if (cons%gen%prob) then
        cons%gen%num = obs_head%gen%num
     endif
  endif
  !
end subroutine observation_consistency_check_gen
!
subroutine observation_consistency_check_sou(ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_sou
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'source' consistency of the input observation header
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (cons%sou%check) then
     cons%sou%prob = .false.
     if (obs_head%pos%sourc.ne.ref_head%pos%sourc) then
        if (cons%sou%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,101) 'Source Name: ',ref_head%pos%sourc,obs_head%pos%sourc
           call class_message(seve%w,rname,mess)
        endif
        cons%sou%num = obs_head%gen%num
        cons%sou%prob = .true.
        cons%prob = .true.
     endif
  endif
  !
101 format(2x,a,a,    ', ',a)      ! Strings
end subroutine observation_consistency_check_sou
!
subroutine observation_consistency_check_pos(set,ref_head,obs_head,cons,warned)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_pos
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'position' consistency of the input observation header
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (cons%pos%check) then
     cons%pos%prob = .false.
     if (obs_head%pos%system.ne.ref_head%pos%system) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,102) 'Coordinate System: ',ref_head%pos%system,obs_head%pos%system
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (obs_head%pos%system.eq.type_eq.and.(obs_head%pos%equinox.ne.ref_head%pos%equinox)) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,103) 'Equinox: ',ref_head%pos%equinox,obs_head%pos%equinox
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (obs_head%pos%proj.ne.ref_head%pos%proj) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,102) 'Projection System: ',ref_head%pos%proj,obs_head%pos%proj
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (abs(obs_head%pos%lam-ref_head%pos%lam).gt.cons%ptole) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,104) 'Lambda Proj Centers: ',ref_head%pos%lam,obs_head%pos%lam
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (abs(obs_head%pos%bet-ref_head%pos%bet).gt.cons%ptole) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,104) 'Beta Proj Centers: ',ref_head%pos%bet,obs_head%pos%bet
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (obs_head%pos%projang.ne.ref_head%pos%projang) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,104) 'Proj. Angles: ',ref_head%pos%projang,obs_head%pos%projang
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     !
     call observation_consistency_check_off(set,ref_head,obs_head,cons,warned)
     !
     if (cons%pos%prob) then
        cons%pos%num = obs_head%gen%num
        cons%prob = .true.
     endif
  endif
  !
  ! Formats. Display all digits for floating points for best understanding
  ! of the mismatch, if any.
102 format(2x,a,i0,     ', ',i0)       ! Integers
103 format(2x,a,1pg14.7, ', ',1pg14.7)   ! Single precision
104 format(2x,a,1pg23.16,', ',1pg23.16)  ! Double precision
end subroutine observation_consistency_check_pos
!
subroutine observation_consistency_check_off(set,ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_off
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'offset' consistency of the input observation header
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  real(kind=4) :: dpos2
  !
  if (cons%off%check) then
    ! Also check the offset positions. Check distance around reference:
    cons%off%prob = .false.
    dpos2 = (  &
      (ref_head%pos%lam+ref_head%pos%lamof-obs_head%pos%lam-obs_head%pos%lamof)  &
      *cos(ref_head%pos%bet))**2 +  &
      (ref_head%pos%bet+ref_head%pos%betof-obs_head%pos%bet-obs_head%pos%betof)**2
    if (dpos2.gt.set%tole**2) then
      if (cons%off%mess) then
        call observation_consistency_warn(obs_head,warned)
        call class_message(seve%w,rname,'Position offsets are not compatible')
      endif
      cons%off%prob = .true.
    endif
    if (cons%off%prob) then
      cons%off%num = obs_head%gen%num
      cons%prob = .true.
    endif
  endif
  !
end subroutine observation_consistency_check_off
!
subroutine observation_consistency_check_lin(ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_lin
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'line' consistency of the input observation header
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (cons%lin%check) then
     cons%lin%prob = .false.
     if (obs_head%spe%line.ne.ref_head%spe%line) then
        if (cons%lin%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,101) 'Line Name: ',ref_head%spe%line,obs_head%spe%line
           call class_message(seve%w,rname,mess)
        endif
        cons%lin%num = obs_head%gen%num
        cons%lin%prob = .true.
        cons%prob = .true.
     endif
  endif
  !
101 format(2x,a,a,    ', ',a)      ! Strings
end subroutine observation_consistency_check_lin
!
subroutine observation_consistency_check_spe(ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_spe
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'spectroscopy' consistency of the input observation header
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  real(kind=8) :: ref_val,spe_val,cha_val
  integer(kind=4) :: nc
  !
  if (cons%spe%check) then
     cons%spe%prob = .false.
     if (obs_head%spe%nchan.ne.ref_head%spe%nchan) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,102) 'Number of channels: ',ref_head%spe%nchan,obs_head%spe%nchan
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     if (obs_head%spe%fres*ref_head%spe%fres.le.0.d0) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,105) 'F resolution sign: ',ref_head%spe%fres,obs_head%spe%fres
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     ! Signal frequency range
     call abscissa_sigabs_left(obs_head,spe_val)          ! Freq at left of spectrum
     call abscissa_sigabs2chan(ref_head,spe_val,cha_val)  ! Chan position in ref
     if (abs(cha_val-.5d0).gt.cons%ctole) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call abscissa_sigabs_left(ref_head,ref_val)
           write(mess,106) 'F range (left) : ',  &
             ref_val,spe_val,cha_val-.5d0
           call sic_noir(mess,nc)
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     call abscissa_sigabs_right(obs_head,spe_val)         ! Freq at right of spectrum
     call abscissa_sigabs2chan(ref_head,spe_val,cha_val)  ! Chan position in ref
     if (abs(cha_val-ref_head%spe%nchan-.5d0).gt.cons%ctole) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call abscissa_sigabs_right(ref_head,ref_val)
           write(mess,106) 'F range (right): ',  &
             ref_val,spe_val,cha_val-ref_head%spe%nchan-.5d0
           call sic_noir(mess,nc)
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     ! Velocity range
     call abscissa_velo_left(obs_head,spe_val)          ! Velo at left of spectrum
     call abscissa_velo2chan(ref_head,spe_val,cha_val)  ! Chan position in ref
     if (abs(cha_val-.5d0).gt.cons%ctole) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call abscissa_velo_left(ref_head,ref_val)
           write(mess,106) 'V range (left) : ',  &
             ref_val,spe_val,cha_val-.5d0
           call sic_noir(mess,nc)
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     call abscissa_velo_right(obs_head,spe_val)         ! Velo at right of spectrum
     call abscissa_velo2chan(ref_head,spe_val,cha_val)  ! Chan position in ref
     if (abs(cha_val-ref_head%spe%nchan-.5d0).gt.cons%ctole) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call abscissa_velo_right(ref_head,ref_val)
           write(mess,106) 'V range (right): ',  &
             ref_val,spe_val,cha_val-ref_head%spe%nchan-.5d0
           call sic_noir(mess,nc)
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     ! Velocity types
     if (obs_head%spe%vtype.ne.ref_head%spe%vtype) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call class_message(seve%w,rname,'  V type')
        endif
        cons%spe%prob = .true.
     endif
     ! Velocity conventions
     if (obs_head%spe%vconv.ne.ref_head%spe%vconv) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call class_message(seve%w,rname,'  V convention')
        endif
        cons%spe%prob = .true.
     endif
     if (cons%spe%prob) then
        cons%spe%num = obs_head%gen%num
        cons%prob = .true.
     endif
  endif
  !
102 format(2x,a,i0,   ', ',i0)     ! Integers
105 format(2x,a,e13.6,', ',e13.6)  ! Floats (e13.6 digits)
! Frequency resolution: down to 1 kHz
! Velocity resolution: down to 1 m/s @ 300 GHz
106 format(2x,a,f0.3,', ',f0.3,' (',f9.2,' channels)')
end subroutine observation_consistency_check_spe
!
subroutine observation_consistency_check_cal(set,ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_cal
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'calibration' consistency of the input observation header
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (cons%cal%check                    .and.  &
      obs_head%presec(class_sec_cal_id) .and.  &
      ref_head%presec(class_sec_cal_id)) then
    cons%cal%prob = .false.
    if (set%beamt.gt.0.) then
      if (abs(obs_head%cal%beeff-ref_head%cal%beeff).gt.set%beamt) then
        if (cons%cal%mess) then
          call observation_consistency_warn(obs_head,warned)
          write(mess,108) 'Beam efficiencies',ref_head%cal%beeff,obs_head%cal%beeff
          call class_message(seve%w,rname,mess)
        endif
        cons%cal%prob = .true.
      endif
    endif
    if (set%gaint.gt.0.) then
      if (abs(obs_head%cal%gaini-ref_head%cal%gaini).gt.set%gaint) then
        if (cons%cal%mess) then
          call observation_consistency_warn(obs_head,warned)
          write(mess,108) 'Gain ratios',ref_head%cal%gaini,obs_head%cal%gaini
          call class_message(seve%w,rname,mess)
        endif
        cons%cal%prob = .true.
      endif
    endif
    if (cons%cal%prob) then
      cons%cal%num = obs_head%gen%num
      cons%prob = .true.
    endif
  endif
  !
108 format(2x,a,f7.3, ', ',f7.3)   ! Floats (f7.3 digit)
end subroutine observation_consistency_check_cal
!
subroutine observation_consistency_check_swi(ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_swi
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'switching' consistency of the input observation header
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  integer(kind=4) :: iphas
  !
  if (cons%swi%check                    .and.  &
      obs_head%presec(class_sec_swi_id) .and.  &
      ref_head%presec(class_sec_swi_id)) then
    cons%swi%prob = .false.
    if (ref_head%swi%swmod.ne.obs_head%swi%swmod) then  ! Different modes
      ! Only a problem if combining unfolded fsw to something else
      cons%swi%prob = ref_head%swi%swmod.eq.mod_freq .or.  &
                      obs_head%swi%swmod.eq.mod_freq
      if (cons%swi%prob .and. cons%swi%mess) then
        call observation_consistency_warn(obs_head,warned)
        write(mess,101) 'Switching modes: ',trim(obs_swmod(ref_head%swi%swmod)),  &
                                            trim(obs_swmod(obs_head%swi%swmod))
        call class_message(seve%w,rname,mess)
      endif
    elseif (ref_head%swi%swmod.eq.mod_freq) then  ! Both are unfolded FSW
      if (ref_head%swi%nphas.ne.obs_head%swi%nphas) then
        ! Not the same number of phases
        if (cons%swi%mess) then
          call observation_consistency_warn(obs_head,warned)
          write(mess,102) 'Number of phases: ',ref_head%swi%nphas,obs_head%swi%nphas
          call class_message(seve%w,rname,mess)
        endif
        cons%swi%prob = .true.
      else
        ! Same number of phases
        do iphas=1,ref_head%swi%nphas
          if (ref_head%swi%decal(iphas).ne.obs_head%swi%decal(iphas)) then
            if (cons%swi%mess) then
              call observation_consistency_warn(obs_head,warned)
              write(mess,103) 'Frequency switching offsets: ',iphas,ref_head%swi%decal(iphas),obs_head%swi%decal(iphas)
              call class_message(seve%w,rname,mess)
            endif
            cons%swi%prob = .true.
          endif
        enddo
      endif
    elseif (ref_head%swi%swmod.eq.mod_pos) then   ! Both are PSW
      ! Is this fully safe?
    elseif (ref_head%swi%swmod.eq.mod_fold) then  ! Both are folded FSW
      ! Is this fully safe?
    elseif (ref_head%swi%swmod.eq.mod_wob) then   ! Both are WSW
      ! Is this fully safe?
    elseif (ref_head%swi%swmod.eq.mod_mix) then   ! Both are mixed modes
      ! Is this fully safe? By construction, CLASS builds "mixed" spectra
      ! from a consistent index, so it should be safe.
    endif
    if (cons%swi%prob) then
      cons%swi%num = obs_head%gen%num
      cons%prob = .true.
    endif
  endif
  !
101 format(2x,a,a,             ', ',a)     ! Characters
102 format(2x,a,i0,            ', ',i0)    ! Integers
103 format(2x,a,'#',i0,1x,f7.3,', ',f7.3)  ! Floats (f7.3 digit)
end subroutine observation_consistency_check_swi
!
subroutine observation_consistency_check_dri(set,ref_head,obs_head,cons,warned)
  use phys_const
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_dri
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'drift' consistency of the input observation header
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  real(kind=8) :: ref_val,ang_val,cha_val
  integer(kind=4) :: nc
  real(kind=8) :: apos1,apos2
  logical :: notsame,notopposite
  !
  if (cons%dri%check) then
    cons%dri%prob = .false.
    if (obs_head%dri%npoin.ne.ref_head%dri%npoin) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        write(mess,102) 'Number of points: ',ref_head%dri%npoin,obs_head%dri%npoin
        call class_message(seve%w,rname,mess)
      endif
      cons%dri%prob = .true.
    endif
    if (obs_head%dri%ares*ref_head%dri%ares.le.0.d0) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        write(mess,105) 'A resolution sign: ',ref_head%dri%ares,obs_head%dri%ares
        call class_message(seve%w,rname,mess)
      endif
      cons%dri%prob = .true.
    endif
    ! Angle range
    call abscissa_angl_left(obs_head,ang_val)          ! Angle at left of drift
    call abscissa_angl2chan(ref_head,ang_val,cha_val)  ! Chan position in ref
    if (abs(cha_val-.5d0).gt.cons%ptole) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        call abscissa_angl_left(ref_head,ref_val)
        write(mess,106) 'A range (left) : ',  &
          ref_val*class_setup_get_fangle(),   &
          ang_val*class_setup_get_fangle(),   &
          cha_val-.5d0
        call sic_noir(mess,nc)
        call class_message(seve%w,rname,mess)
      endif
      cons%dri%prob = .true.
    endif
    call abscissa_angl_right(obs_head,ang_val)         ! Angle at right of drift
    call abscissa_angl2chan(ref_head,ang_val,cha_val)  ! Chan position in ref
    if (abs(cha_val-ref_head%dri%npoin-.5d0).gt.cons%ptole) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        call abscissa_angl_right(ref_head,ref_val)
        write(mess,106) 'A range (right): ',  &
          ref_val*class_setup_get_fangle(),   &
          ang_val*class_setup_get_fangle(),   &
          cha_val-ref_head%dri%npoin-.5d0
        call sic_noir(mess,nc)
        call class_message(seve%w,rname,mess)
      endif
      cons%dri%prob = .true.
    endif
    ! Position angles are consistent if equal +- pi. Do not use modulo as value
    ! 'pi-eps' is not reduced to '0-eps' almost equal to 0.
    apos1 = abs(ref_head%dri%apos-obs_head%dri%apos)
    apos2 = abs(apos1-pi)
    notsame = apos1.gt.cons%atole
    notopposite = apos2.gt.cons%atole
    if (notsame.and.notopposite) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        call class_message(seve%w,rname,'Drift angles are not compatible')
      endif
      cons%dri%prob = .true.
    endif
    if (cons%dri%prob) then
      cons%dri%num = obs_head%gen%num
      cons%prob = .true.
    endif
  endif
  !
102 format(2x,a,i0,   ', ',i0)     ! Integers
105 format(2x,a,e13.6,', ',e13.6)  ! Floats (e13.6 digits)
! Angle resolution: down to 1 mas
106 format(2x,a,f0.3,', ',f0.3,' (',f9.2,' channels)')
end subroutine observation_consistency_check_dri
!
subroutine observation_consistency_warn(obs_head,warned)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  ! Warn user about inconsistant spectrum, if not yet done
  !---------------------------------------------------------------------
  type(header), intent(in)    :: obs_head  !
  logical,      intent(inout) :: warned    !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (warned)  return  ! Already done
  !
  write(mess,'(a,i0,a)') 'Obs #',obs_head%gen%num,' differs. Inconsistent:'
  call class_message(seve%w,rname,mess)
  warned = .true.
  !
end subroutine observation_consistency_warn
!
subroutine consistency_tole(ref_head,cons)
  use phys_const
  use classcore_interfaces, except_this=>consistency_tole
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  !
  ! Tolerance 10% of channel at spectrum edges
  cons%ctole = 1.d-1
  !
  ! Tolerance 10 milli-arcsec for position/projection center
  cons%ptole = 1.d-2 * rad_per_sec
  !
  ! Tolerance 0.01 degree for position angles
  cons%atole = 1.d-2 * rad_per_deg
  !
end subroutine consistency_tole
!
subroutine index_consistency_analysis(set,cons,rname)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>index_consistency_analysis
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  character(len=*),    intent(in)    :: rname  ! Calling routine name
  !
  select case (set%kind)
  case (kind_spec)
    call index_consistency_analysis_spec(cons,rname)
  case (kind_cont)
    call index_consistency_analysis_cont(cons,rname)
  case default
    call class_message(seve%e,rname,'Unsupported kind of data')
    ! error = .true.
  end select
  !
end subroutine index_consistency_analysis
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine consistency_defaults_spec(cons)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  ! Performed actions, tolerances and results
  !
  ! Default is to check everything
  cons%gen%check = .true.
  cons%sou%check = .true.
  cons%pos%check = .true.
  cons%off%check = .true.
  cons%lin%check = .true.
  cons%spe%check = .true.
  cons%cal%check = .true.
  cons%swi%check = .true.
  !
  ! Default is to give feedback to users
  cons%gen%mess = .true.
  cons%sou%mess = .true.
  cons%pos%mess = .true.
  cons%off%mess = .true.
  cons%lin%mess = .true.
  cons%spe%mess = .true.
  cons%cal%mess = .true.
  cons%swi%mess = .true.
  !
  ! At start, there is no problem
  cons%prob     = .false.
  cons%gen%prob = .false.
  cons%sou%prob = .false.
  cons%pos%prob = .false.
  cons%off%prob = .false.
  cons%lin%prob = .false.
  cons%spe%prob = .false.
  cons%cal%prob = .false.
  cons%swi%prob = .false.
  !
  ! At start, nothing has been checked
  cons%gen%done = .false.
  cons%sou%done = .false.
  cons%pos%done = .false.
  cons%off%done = .false.
  cons%lin%done = .false.
  cons%spe%done = .false.
  cons%cal%done = .false.
  cons%swi%done = .false.
  !
  ! At start, no spectrum is faulty
  cons%gen%num = -1
  cons%sou%num = -1
  cons%pos%num = -1
  cons%off%num = -1
  cons%lin%num = -1
  cons%spe%num = -1
  cons%cal%num = -1
  cons%swi%num = -1
  !
end subroutine consistency_defaults_spec
!
subroutine consistency_check_selection_spec(set,line,iopt,cons,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>consistency_check_selection_spec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  integer(kind=4),     intent(in)    :: iopt   ! Number of the /NOCHECK option
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1,chain2
  integer(kind=4) :: iarg,nchain,nctype
  integer(kind=4), parameter :: mctype=7
  character(len=12) :: ctype(mctype)
  data ctype/'SOURCE','POSITION','OFFSET','LINE','SPECTROSCOPY','CALIBRATION','SWITCHING'/
  !
  ! Default checks are ruled by the general SET [NO]CHECK tuning
  cons%gen%check = .true.
  cons%sou%check = set%check%sou
  cons%pos%check = set%check%pos
  cons%off%check = set%check%pos.and.set%check%off.and.set%match
  cons%lin%check = set%check%lin
  cons%spe%check = set%check%spe
  cons%cal%check = set%check%cal.and.(set%beamt.gt.0..or.set%gaint.gt.0.)
  cons%swi%check = set%check%swi
  !
  ! Parse line for the /NOCHECK option
  if (sic_present(iopt,0)) then
     if (sic_narg(iopt).eq.0) then
        cons%sou%check = .false.
        cons%pos%check = .false.
        cons%off%check = .false.
        cons%lin%check = .false.
        cons%spe%check = .false.
        cons%cal%check = .false.
        cons%swi%check = .false.
     else
        do iarg = 1, sic_narg(iopt)
           call sic_ke(line,iopt,iarg,chain1,nchain,.true.,error)
           call sic_ambigs('/NOCHECK',chain1,chain2,nctype,ctype,mctype,error)
           if (error) return
           select case (nctype)
           case(1) ! SOURCE
              cons%sou%check = .false.
           case(2) ! POSITION+OFFSET
              cons%pos%check = .false.
              cons%off%check = .false.
           case(3) ! OFFSET
              cons%off%check = .false.
           case(4) ! LINE
              cons%lin%check = .false.
           case(5) ! SPECTROSCOPY
              cons%spe%check = .false.
           case(6) ! CALIBRATION
              cons%cal%check = .false.
           case(7) ! SWITCHING
              cons%swi%check = .false.
           end select
        enddo
     endif
  endif
  !
  ! Avoid checking again when consistency is proved
  call consistency_check_gen(cons)
  call consistency_check_sou(cons)
  call consistency_check_pos(cons)
  call consistency_check_off(cons)
  call consistency_check_lin(cons)
  call consistency_check_spe(cons)
  call consistency_check_cal(cons)
  call consistency_check_swi(cons)
  !
  ! This subroutine is called before a new check. So cons%prob must be
  ! reset. Now there is NO problem if the user says so, e.g. if the user
  ! turns off all the checks even though there may be an already located
  ! inconsistency...
  cons%prob = (cons%gen%check.and.cons%gen%done.and.cons%gen%prob) .or.  &
              (cons%sou%check.and.cons%sou%done.and.cons%sou%prob) .or.  &
              (cons%pos%check.and.cons%pos%done.and.cons%pos%prob) .or.  &
              (cons%off%check.and.cons%off%done.and.cons%off%prob) .or.  &
              (cons%lin%check.and.cons%lin%done.and.cons%lin%prob) .or.  &
              (cons%spe%check.and.cons%spe%done.and.cons%spe%prob) .or.  &
              (cons%cal%check.and.cons%cal%done.and.cons%cal%prob) .or.  &
              (cons%swi%check.and.cons%swi%done.and.cons%swi%prob)
  !
  ! Is there anything left to be checked?
  cons%check = cons%gen%check .or.  &
               cons%sou%check .or.  &
               cons%pos%check .or.  &
               cons%off%check .or.  &
               cons%lin%check .or.  &
               cons%spe%check .or.  &
               cons%cal%check .or.  &
               cons%swi%check
  !
  ! User feedback
  if (.not.cons%check) then
     if (cons%prob) then
        call class_message(seve%e,rname,'Index is inconsistent')
     else
        call class_message(seve%i,rname,'Index is consistent')
     endif
  endif
  !
end subroutine consistency_check_selection_spec
!
subroutine consistency_print_spec(ref_head,cons)
  use gbl_constant
  use phys_const
  use gbl_message
  use classcore_interfaces, except_this=>consistency_print_spec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=256) :: chain
  !
  ! First: What will be checked
  call class_message(seve%r,rname,'Consistency checks:')
  call consistency_print_gen(cons)  ! General
  call consistency_print_sou(cons)  ! Source name
  call consistency_print_pos(cons)  ! Position information
  call consistency_print_off(cons)  ! Offset positions
  call consistency_print_lin(cons)  ! Line name
  call consistency_print_spe(cons)  ! Spectroscopy information
  call consistency_print_cal(cons)  ! Calibration information
  call consistency_print_swi(cons)  ! Switching information
  !
  ! Second: Reference information
  call class_message(seve%r,rname,'Reference spectrum:')
  !
  ! Source name
  write(chain,101) 'Source Name',ref_head%pos%sourc
  call class_message(seve%r,rname,chain)
  !
  ! Position information
  if (ref_head%pos%system.eq.type_eq) then
     write(chain,102) 'Coordinate System','EQUATORIAL ',ref_head%pos%equinox
     call class_message(seve%r,rname,chain)
  elseif (ref_head%pos%system.eq.type_ga) then
     write(chain,101) 'Coordinate System','GALACTIC'
     call class_message(seve%r,rname,chain)
  elseif (ref_head%pos%system.eq.type_ic) then
     write(chain,101) 'Coordinate System','ICRS'
     call class_message(seve%r,rname,chain)
  endif
  write(chain,103) 'Proj. Center (rad)','lambda ',ref_head%pos%lam,  &
                                      ', beta ',ref_head%pos%bet,    &
                                      ', tolerance ',cons%ptole
  call class_message(seve%r,rname,chain)
  !
  ! Line name
  write(chain,101) 'Line Name',ref_head%spe%line
  call class_message(seve%r,rname,chain)
  !
  ! Spectroscopic information
  write(chain,105) 'Frequency (MHz)','rest ',ref_head%spe%restf,  &
                                   ', resol ',ref_head%spe%fres
  call class_message(seve%r,rname,chain)
  write(chain,105) 'Velocity (km/s)','resol ',ref_head%spe%vres,  &
                                   ', offset ',ref_head%spe%voff
  call class_message(seve%r,rname,chain)
  write(chain,106) 'Alignment (chan)','tolerance ',cons%ctole*1.d2
  call class_message(seve%r,rname,chain)
  !
  ! Calibration information
  if (ref_head%presec(class_sec_cal_id)) then
    write(chain,107) 'Calibration','beeff',ref_head%cal%beeff,  &
                                  ',gain',ref_head%cal%gaini
    call class_message(seve%r,rname,chain)
  endif
  !
  ! Switching information
  if (ref_head%presec(class_sec_swi_id)) then
    ! The kind of data displayed is the same as the kind of data
    ! diff'ed in observation_consistency_check_swi
    if (ref_head%swi%swmod.eq.mod_freq) then
      write(chain,108) 'Switching',trim(obs_swmod(ref_head%swi%swmod)),  &
                       ', nphase ',ref_head%swi%nphas, &
                       ', offsets',ref_head%swi%decal(1:ref_head%swi%nphas)
    else
      write(chain,108) 'Switching',trim(obs_swmod(ref_head%swi%swmod))
    endif
    call class_message(seve%r,rname,chain)
  endif
  !
101 format(2x,a,t21,': ',a)
102 format(2x,a,t21,': ',a,f7.1)
107 format(2x,a,t21,': ',a,f7.3,a,f7.3)  ! 2 floats (f7.3 digit)
103 format(2x,a,t21,': ',a,f12.6, a,f12.6, a,1pg7.1)
105 format(2x,a,t21,': ',a,es12.3,a,es12.3)
106 format(2x,a,t21,': ',a,f7.1,'%')  ! Percents
108 format(2x,a,t21,': ',a,a,i0,a,8(1x,f0.3))
end subroutine consistency_print_spec
!
subroutine spectrum_consistency_check(set,ref_head,spe_head,cons)
  use gbl_constant
  use classcore_interfaces, except_this=>spectrum_consistency_check
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(header),        intent(in)    :: spe_head  ! Header to be checked
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  logical :: warned
  !
  ! If the program arrived here, it means that something must be checked and
  ! the basic assumption is there is no problem... On the other hand, the subsection
  ! problem variables are initialized to .false. only when the subsection is checked
  ! to avoid loosing the history
  warned = .false.
  cons%prob = .false.
  !
  call observation_consistency_check_gen(kind_spec,spe_head,cons,warned)
  call observation_consistency_check_sou(ref_head,spe_head,cons,warned)
  call observation_consistency_check_pos(set,ref_head,spe_head,cons,warned)
  ! Offsets checked above, if enabled
  call observation_consistency_check_lin(ref_head,spe_head,cons,warned)
  call observation_consistency_check_spe(ref_head,spe_head,cons,warned)
  call observation_consistency_check_cal(set,ref_head,spe_head,cons,warned)
  call observation_consistency_check_swi(ref_head,spe_head,cons,warned)
  !
end subroutine spectrum_consistency_check
!
subroutine index_consistency_analysis_spec(cons,rname)
  use gbl_message
  use classcore_interfaces, except_this=>index_consistency_analysis_spec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  character(len=*),    intent(in)    :: rname  ! Calling routine name
  !
  if (cons%prob) then
     ! Only the parts that are inconsistent can be marked as checked
     if (cons%gen%prob) cons%gen%done = .true.
     if (cons%sou%prob) cons%sou%done = .true.
     if (cons%pos%prob) cons%pos%done = .true.
     if (cons%off%prob) cons%off%done = .true.
     if (cons%lin%prob) cons%lin%done = .true.
     if (cons%spe%prob) cons%spe%done = .true.
     if (cons%cal%prob) cons%cal%done = .true.
     if (cons%swi%prob) cons%swi%done = .true.
     call class_message(seve%e,rname,'Index is inconsistent')
  else
     ! The parts that have been checked are consistent
     if (cons%gen%check) cons%gen%done = .true.
     if (cons%sou%check) cons%sou%done = .true.
     if (cons%pos%check) cons%pos%done = .true.
     if (cons%off%check) cons%off%done = .true.
     if (cons%lin%check) cons%lin%done = .true.
     if (cons%spe%check) cons%spe%done = .true.
     if (cons%cal%check) cons%cal%done = .true.
     if (cons%swi%check) cons%swi%done = .true.
     call class_message(seve%i,rname,'Index is consistent')
  endif
  !
end subroutine index_consistency_analysis_spec
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine consistency_defaults_cont(cons)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  ! Performed actions, tolerances and results
  !
  ! Default is to check everything
  cons%gen%check = .true.
  cons%sou%check = .true.
  cons%pos%check = .true.
  cons%off%check = .true.
  cons%dri%check = .true.
  !
  ! Default is to give feedback to users
  cons%gen%mess = .true.
  cons%sou%mess = .true.
  cons%pos%mess = .true.
  cons%off%mess = .true.
  cons%dri%mess = .true.
  !
  ! At start, there is no problem
  cons%prob     = .false.
  cons%gen%prob = .false.
  cons%sou%prob = .false.
  cons%pos%prob = .false.
  cons%off%prob = .false.
  cons%dri%prob = .false.
  !
  ! At start, nothing has been checked
  cons%gen%done = .false.
  cons%sou%done = .false.
  cons%pos%done = .false.
  cons%off%done = .false.
  cons%dri%done = .false.
  !
  ! At start, no spectrum is faulty
  cons%gen%num = -1
  cons%sou%num = -1
  cons%pos%num = -1
  cons%off%num = -1
  cons%dri%num = -1
  !
end subroutine consistency_defaults_cont
!
subroutine consistency_check_selection_cont(set,line,iopt,cons,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>consistency_check_selection_cont
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  integer(kind=4),     intent(in)    :: iopt   ! Number of the /NOCHECK option
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1,chain2
  integer(kind=4) :: iarg,nchain,nctype
  integer(kind=4), parameter :: mctype=4
  character(len=12) :: ctype(mctype)
  data ctype/'SOURCE','POSITION','OFFSET','DRIFT'/
  !
  ! Check everything by default
  cons%gen%check = .true.
  cons%sou%check = .true.
  cons%pos%check = .true.
  cons%off%check = set%match
  cons%dri%check = .true.
  !
  ! Parse line for the /NOCHECK option
  if (sic_present(iopt,0)) then
     if (sic_narg(iopt).eq.0) then
        cons%sou%check = .false.
        cons%pos%check = .false.
        cons%off%check = .false.
        cons%dri%check = .false.
     else
        do iarg = 1, sic_narg(iopt)
           call sic_ke(line,iopt,iarg,chain1,nchain,.true.,error)
           call sic_ambigs('/NOCHECK',chain1,chain2,nctype,ctype,mctype,error)
           if (error) return
           select case (nctype)
           case(1) ! SOURCE
              cons%sou%check = .false.
           case(2) ! POSITION
              cons%pos%check = .false.
           case(3) ! OFFSET
              cons%off%check = .false.
           case(4) ! DRIFT
              cons%dri%check = .false.
           end select
        enddo
     endif
  endif
  !
  ! Avoid checking again when consistency is proved
  call consistency_check_gen(cons)
  call consistency_check_sou(cons)
  call consistency_check_pos(cons)
  call consistency_check_off(cons)
  call consistency_check_dri(cons)
  !
  ! This subroutine is called before a new check. So cons%prob must be
  ! reset. Now there is NO problem if the user says so, e.g. if the user
  ! turns off all the checks even though there may be an already located
  ! inconsistency...
  cons%prob = (cons%gen%check.and.cons%gen%done.and.cons%gen%prob) .or.  &
              (cons%sou%check.and.cons%sou%done.and.cons%sou%prob) .or.  &
              (cons%pos%check.and.cons%pos%done.and.cons%pos%prob) .or.  &
              (cons%off%check.and.cons%off%done.and.cons%off%prob) .or.  &
              (cons%dri%check.and.cons%dri%done.and.cons%dri%prob)
  !
  ! Is there anything left to be checked?
  cons%check = cons%gen%check .or.  &
               cons%sou%check .or.  &
               cons%pos%check .or.  &
               cons%off%check .or.  &
               cons%dri%check
  !
  ! User feedback
  if (.not.cons%check) then
     if (cons%prob) then
        call class_message(seve%e,rname,'Index is inconsistent')
     else
        call class_message(seve%i,rname,'Index is consistent')
     endif
  endif
  !
end subroutine consistency_check_selection_cont
!
subroutine consistency_print_cont(ref_head,cons)
  use gbl_constant
  use phys_const
  use gbl_message
  use classcore_interfaces, except_this=>consistency_print_cont
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=256) :: chain
  !
  ! First: What will be checked
  call class_message(seve%r,rname,'Consistency checks:')
  call consistency_print_gen(cons)  ! General
  call consistency_print_sou(cons)  ! Source name
  call consistency_print_pos(cons)  ! Position information
  call consistency_print_off(cons)  ! Offset positions
  call consistency_print_dri(cons)  ! Offset positions
  !
  ! Second: Reference information
  call class_message(seve%r,rname,'Reference drift:')
  !
  ! Source name
  write(chain,101) 'Source Name',ref_head%pos%sourc
  call class_message(seve%r,rname,chain)
  !
  ! Position information
  if (ref_head%pos%system.eq.type_eq) then
     write(chain,102) 'Coordinate System','EQUATORIAL ',ref_head%pos%equinox
     call class_message(seve%r,rname,chain)
  elseif (ref_head%pos%system.eq.type_ga) then
     write(chain,101) 'Coordinate System','GALACTIC'
     call class_message(seve%r,rname,chain)
  elseif (ref_head%pos%system.eq.type_ic) then
     write(chain,101) 'Coordinate System','ICRS'
     call class_message(seve%r,rname,chain)
  endif
  write(chain,103) 'Proj. Center (rad)','lambda ',ref_head%pos%lam,  &
                                      ', beta ',ref_head%pos%bet,    &
                                      ', tolerance ',cons%ptole
  call class_message(seve%r,rname,chain)
  !
101 format(2x,a,t21,': ',a)
102 format(2x,a,t21,': ',a,f7.1)
103 format(2x,a,t21,': ',a,f12.6, a,f12.6, a,1pg7.1)
end subroutine consistency_print_cont
!
subroutine continuum_consistency_check(set,ref_head,dri_head,cons)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>continuum_consistency_check
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(header),        intent(in)    :: dri_head  ! Header to be checked
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  logical :: warned
  !
  ! If the program arrived here, it means that something must be checked and
  ! the basic assumption is there is no problem... On the other hand, the subsection
  ! problem variables are initialized to .false. only when the subsection is checked
  ! to avoid loosing the history
  warned = .false.
  cons%prob = .false.
  !
  call observation_consistency_check_gen(kind_cont,dri_head,cons,warned)
  call observation_consistency_check_sou(ref_head,dri_head,cons,warned)
  call observation_consistency_check_pos(set,ref_head,dri_head,cons,warned)
  ! Offsets checked above, if enabled
  call observation_consistency_check_dri(set,ref_head,dri_head,cons,warned)
  !
end subroutine continuum_consistency_check
!
subroutine index_consistency_analysis_cont(cons,rname)
  use gbl_message
  use classcore_interfaces, except_this=>index_consistency_analysis_cont
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  character(len=*),    intent(in)    :: rname  ! Calling routine name
  !
  if (cons%prob) then
     ! Only the parts that are inconsistent can be marked as checked
     if (cons%gen%prob) cons%gen%done = .true.
     if (cons%sou%prob) cons%sou%done = .true.
     if (cons%pos%prob) cons%pos%done = .true.
     if (cons%off%prob) cons%off%done = .true.
     if (cons%dri%prob) cons%dri%done = .true.
     call class_message(seve%e,rname,'Index is inconsistent')
  else
     ! The parts that have been checked are consistent
     if (cons%gen%check) cons%gen%done = .true.
     if (cons%sou%check) cons%sou%done = .true.
     if (cons%pos%check) cons%pos%done = .true.
     if (cons%off%check) cons%off%done = .true.
     if (cons%dri%check) cons%dri%done = .true.
     call class_message(seve%i,rname,'Index is consistent')
  endif
  !
end subroutine index_consistency_analysis_cont
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine index_consistency_check(set,line,error,user_function)
  use classcore_interfaces, except_this=>index_consistency_check
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Generic for spectroscopic or continuum data
  ! Support routine for command
  !     CONSISTENCY [/NOCHECK [SOURCE|POSITION|OFFSET|LINE|SPECTROSCOPY|
  !                            CALIBRATION|SWITCHING]]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Command line
  logical,             intent(inout) :: error          ! Logical error flag
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  ! Select what will be checked according to user input
  call consistency_check_selection(set,line,1,cx%cons,error)
  if (error .or. cx%cons%prob) return
  !
  ! It happens after analysis that nothing needs to be checked...
  if (.not.cx%cons%check)  return
  !
  ! Check consistency according to selection
  call consistency_check_do(set,rname,cx,error,user_function)
  if (error)  return
  !
end subroutine index_consistency_check
!
subroutine consistency_check_do(set,rname,idx,error,user_function)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>consistency_check_do
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  character(len=*),    intent(in)    :: rname
  type(optimize),      intent(inout) :: idx
  logical,             intent(inout) :: error
  logical,             external      :: user_function
  ! Local
  type(observation) :: obs
  integer(kind=entry_length) :: iobs,nobs
  type(time_t) :: time
  !
  ! Sanity check
  nobs = idx%next-1
  if (nobs.le.0) then
     call class_message(seve%e,rname,'Index is empty')
     error = .true.
     return
  endif
  !
  ! Read first index spectrum to set its header as reference
  call init_obs(obs)
  call get_it(set,obs,idx%ind(1),user_function,error)
  if (error) return
  call sic_upper(obs%head%gen%teles)
  call sic_upper(obs%head%pos%sourc)
  call sic_upper(obs%head%spe%line)
  call copy_header(obs%head,idx%cons%head)
  !
  ! Set checking tolerances
  call consistency_tole(idx%cons%head,idx%cons)
  !
  ! Give user feedback on what will be done
  call consistency_print(set,idx%cons%head,idx%cons)
  !
  ! Loop on observations
  call gtime_init(time,nobs,error)
  if (error)  goto 100
  if (set%kind.eq.kind_spec) then
    do iobs = 1,nobs
      call gtime_current(time)
      ! Exit when asked by user
      call class_controlc(rname,error)
      if (error)  exit
      ! Read useful header sections
      call robs(obs,idx%ind(iobs),error)
      if (error) exit
      call rgen(set,obs,error)
      if (error) exit
      call rpos(set,obs,error)
      if (error) exit
      call rspec(set,obs,error)
      if (error) exit
      if (obs%head%presec(class_sec_cal_id)) then
        call rcal(set,obs,error)
        if (error) exit
      endif
      if (obs%head%presec(class_sec_swi_id)) then
        call rswi(set,obs,error)
        if (error) exit
      endif
      call sic_upper(obs%head%gen%teles)
      call sic_upper(obs%head%pos%sourc)
      call sic_upper(obs%head%spe%line)
      call spectrum_consistency_check(set,idx%cons%head,obs%head,idx%cons)
      ! There is a consistency problem => Exit the loop
      if (idx%cons%prob)  exit
    enddo
  elseif (set%kind.eq.kind_cont) then
    do iobs = 1,nobs
      call gtime_current(time)
      ! Exit when asked by user
      call class_controlc(rname,error)
      if (error)  exit
      ! Read useful header sections
      call robs(obs,idx%ind(iobs),error)
      if (error) exit
      call rgen(set,obs,error)
      if (error) exit
      call rpos(set,obs,error)
      if (error) exit
      call rcont(set,obs,error)
      if (error)  exit
      call sic_upper(obs%head%gen%teles)
      call sic_upper(obs%head%pos%sourc)
      call continuum_consistency_check(set,idx%cons%head,obs%head,idx%cons)
      ! There is a consistency problem => Exit the loop
      if (idx%cons%prob)  exit
    enddo
  else
    call class_message(seve%e,rname,'Unsupported kind of data')
    error = .true.
    goto 100
  endif
  !
  ! Feedback
  call index_consistency_analysis(set,idx%cons,rname)
  !
100 continue
  call free_obs(obs)
  !
end subroutine consistency_check_do
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program uv_cal
  use gildas_def
  use gkernel_interfaces
  !
  real(8) :: phase_gain, ampli_gain
  character(len=filename_length) :: uvdata, uvgain, uvcal
  logical :: flag
  logical :: error=.false.
  !
  ! Code:
  call gildas_open
  call gildas_char('UVDATA$',uvdata)
  call gildas_char('UVGAIN$',uvgain)
  call gildas_char('UVCAL$',uvcal)
  call gildas_dble('AMPLI_GAIN$',ampli_gain,1)
  call gildas_dble('PHASE_GAIN$',phase_gain,1)
  call gildas_logi('FLAG$',flag,1)
  call gildas_close
  !
  call sub_uv_cal(uvdata,uvgain,uvcal,ampli_gain,phase_gain,flag,error)
  if (error) call sysexi(fatale)
end program 
!
subroutine sub_uv_cal(uvdata,uvgain,uvcal,ampli_gain,phase_gain,flag,error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  ! Apply gains from a table to another table.
  !       The antenna numbers must match  those of the GAIN Table.
  !       There is no specific verification about this.
  ! Input : a UV table (observed)
  ! Input : a UV table, with the gains.
  ! Output: a UV calibrated table
  !---------------------------------------------------------------------
  real(8), intent(in) :: phase_gain ! Phase Gain
  real(8), intent(in) :: ampli_gain ! Amplitude Gain
  character(len=filename_length), intent(in) :: uvdata ! Raw data
  character(len=filename_length), intent(in) :: uvgain ! Gain table
  character(len=filename_length), intent(in) :: uvcal  ! Calibrated data
  logical, intent(in) :: flag       ! Flag or Keep uncalibrated data
  logical, intent(out) :: error     ! Error return value
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  character(len=*), parameter :: rname='UV_CAL'
  ! Local
  type(gildas) :: gain,raw,self
  integer(4) ::  ib, n, nvis, ncol, nvg, ndc, ier, nblock
  character(len=filename_length) :: name
  character(len=message_length) :: mess
  !
  ! print *,'Phase Gain ',phase_gain
  error = .false.
  !
  ! Input file RAW / name UVDATA 
  n = len_trim(uvdata)
  if (n.le.0) goto 999
  name = uvdata(1:n)
  call gildas_null(raw, type = 'UVT')
  call gdf_read_gildas(raw, name, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table ')
    return
  endif
  !
  nvis = raw%gil%dim(2)
  ncol = raw%gil%dim(1)
  ndc = raw%gil%nchan
  !
  ! Prepare output calibrated table  SELF / name UVCAL
  call gildas_null (self, type = 'UVT')
  call gdf_copy_header(raw,self,error)
  n = len_trim(uvcal)
  if (n.eq.0) goto 999
  name  = uvcal(1:n)
  call sic_parsef(name,self%file,' ','.uvt')
  call gagout('I-UV_CAL,  Creating UV table '//trim(self%file))
  call gdf_create_image (self,error)
  if (error) then
    call map_message(seve%e,rname,'Cannot create Calibrated Table')
    return
  endif
  !
  ! Input file GAIN / name UVGAIN
  n = len_trim(uvgain)
  if (n.le.0) goto 999
  call gildas_null(gain, type = 'UVT')
  name = uvgain(1:n)
  call sic_parse_file(name,' ','.uvt',gain%file)
  call gagout('I-UV_CAL,  Reading Gain table '//trim(gain%file))
  call gdf_read_gildas(gain, name, '.uvt', error, data=.true.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read gain Table')
    return
  endif
  nvg = gain%gil%dim(2)
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,raw%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,raw%gil%dim(2))
  ! Allocate respective space for each file
  allocate (raw%r2d(raw%gil%dim(1),nblock), self%r2d(self%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',raw%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! create the image
  call gdf_create_image(self,error)
  if (error) return
  !
  ! Loop over line table - The example assumes the same
  ! number of visibilities in Input and Output, which may not
  ! be true...
  raw%blc = 0
  raw%trc = 0
  self%blc = 0
  self%trc = 0
  !
  do ib = 1,raw%gil%dim(2),nblock
    write(mess,*) ib,' / ',raw%gil%dim(2),nblock
    call map_message(seve%d,rname,mess)
    raw%blc(2) = ib
    raw%trc(2) = min(raw%gil%dim(2),ib-1+nblock)
    self%blc = raw%blc
    self%trc = raw%trc
    nvis = raw%trc(2)-raw%blc(2)+1
    call gdf_read_data(raw,raw%r2d,error)
    !
    call do_outer_cal(ncol,nvis,raw%r2d,ndc,self%r2d,nvg,gain%r2d,  &
                      ampli_gain,phase_gain,flag,error)
    !print *,'Done do_cal ',self%blc(2),self%trc(2),self%gil%dim(2),error
    call gdf_write_data (self,self%r2d,error)
    if (error) return
  enddo
  !
  ! Enfin libre ...
  call gdf_close_image(self, error)
  call gdf_close_image(raw, error)
  if (associated(raw%r2d))   deallocate(raw%r2d)
  if (associated(self%r2d))  deallocate(self%r2d)
  if (associated(gain%r2d))  deallocate(gain%r2d)
  if  (.not.error) call map_message(seve%i,rname,'Successful completion')
  return
  !
  999 call map_message(seve%e,rname,'Missing filename')
  error = .true.
end subroutine sub_uv_cal
!
subroutine do_outer_cal(ncol,nvis,data,ndc,cal,nvg,gain,ampli_gain,  &
  phase_gain,flag,error)
  use gbl_message
  use gkernel_interfaces
  use mapping_interfaces
  use uv_sort, only: uv_findtb
  !---------------------------------------------------------------------
  !  Apply phase and/or amplitude calibration to the "raw" UV data.
  ! Phase and Amplitudes are stored in the "gain" UV table, and usually
  ! come from a previous use of Task uv_gain. This subroutine allows to
  ! apply the corrections to a spectral line table, whatever the way the
  ! gains were computed before.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: ncol             ! Visibility size
  integer(kind=4), intent(in)    :: nvis             ! Number of visibilities
  real(kind=4),    intent(in)    :: data(ncol,nvis)  ! Visibility array
  integer(kind=4), intent(in)    :: ndc              ! Number of channels
  real(kind=4),    intent(out)   :: cal(ncol,nvis)   ! Calibrated visibilities
  integer(kind=4), intent(in)    :: nvg              ! Number of gains
  real(kind=4),    intent(in)    :: gain(10,nvg)     ! Gain array
  real(kind=8),    intent(in)    :: ampli_gain       ! Amplitude gain
  real(kind=8),    intent(in)    :: phase_gain       ! Phase gain
  logical,         intent(in)    :: flag             ! Keep or Flag uncalibrated data
  logical,         intent(inout) :: error            ! Error flag
  ! Local
  integer(kind=4) :: anticol,antjcol,datecol,timecol
  integer(kind=4) :: ivg,jvg,iantg,jantg,minantg,maxantg,dateg
  integer(kind=4) :: ivd,jvd,iantd,jantd,minantd,maxantd,dated
  real(kind=4) :: timeg,timed
  integer(kind=4) :: k,lastivd,diff,cnt
  complex(kind=4) :: zdata,zgain,zcal,zg
  real(kind=4) :: wg
  real(kind=8) :: ampli,phase
  real(kind=8), parameter :: time_tol=1.0d0
  logical :: flagged(nvis),sorted,conj
  integer(kind=4), parameter :: code_sort_ubt=3  ! See module uv_sort_codes
  character(len=message_length) :: mess
  ! Automatic arrays
  integer(kind=4) :: indd(nvis),indg(nvg)
  integer(kind=4) :: rindd(nvis),rindg(nvg)
  real(kind=8) :: keyd(nvis),keyg(nvg)
  !
  datecol = 4  ! hx%gil%column_pointer(code_uvt_date)
  timecol = 5  ! hx%gil%column_pointer(code_uvt_time)
  anticol = 6  ! hx%gil%column_pointer(code_uvt_anti)
  antjcol = 7  ! hx%gil%column_pointer(code_uvt_antj)
  !
  ! Get the chronological order, for both input tables. Tables are
  ! ordered by UNIQUE-BASE then TIME because time is a fuzzy argument,
  ! with a tolerance when matching. This ensures that matches will be
  ! contiguous, and they can also be optimized.
  call uv_findtb(code_sort_ubt,data,nvis,ncol,keyd,indd,rindd,sorted,error)
  if (error)  return
  call uv_findtb(code_sort_ubt,gain,nvg, 10,  keyg,indg,rindg,sorted,error)
  if (error)  return
  ! NB: keyd and keyg can not be correlated in return because they can use
  !     different relative dates.
  !
  ! First setup CAL = DATA by default 
  ! Uncalibrated data will be kept or flagged as desired
  cal(:,:) = data(:,:)
  !
  ! The loop is done on calibration times, so
  ! there is no guarantee that a given data visibility is treated.
  !
  ! To handle this, we set a counter for each visibility, to
  ! check whether it has indeed been affected...
  !
  flagged(1:nvis) = .true.
  lastivd = 0
  !
  do ivg=1,nvg ! For all visibilities in gain table
    jvg = indg(ivg)
    iantg = nint(gain(anticol,jvg))
    jantg = nint(gain(antjcol,jvg))
    if (iantg.lt.jantg) then
      minantg = iantg
      maxantg = jantg
    else
      minantg = jantg
      maxantg = iantg
    endif
    dateg = nint(gain(datecol,jvg))
    timeg = gain(timecol,jvg)
    !
    ! Set up the gain for this time and baseline
    ampli = sqrt(gain(8,jvg)**2+gain(9,jvg)**2)
    phase = atan2(gain(9,jvg),gain(8,jvg))
    if (gain(10,jvg).le.0) ampli = 0.d0
    if (ampli.ne.0.d0) then
      ! Correct (a fraction of) the phase
      phase = phase_gain*phase
      zg = cmplx(cos(phase),sin(phase))
      ampli = 1d0-ampli_gain+ampli*ampli_gain
      zgain = ampli*zg
    else
      ! Reset Zgain to 0
      zgain = 0.0
    endif
    !
    ! Find the data visibilities which have exactly same baseline,
    ! and about the same datetime.
    ivd = lastivd
    do while (ivd.lt.nvis)
      ivd = ivd+1
      jvd = indd(ivd)
      !
      iantd = nint(data(anticol,jvd))
      jantd = nint(data(antjcol,jvd))
      if (iantd.lt.jantd) then
        minantd = iantd
        maxantd = jantd
      else
        minantd = jantd
        maxantd = iantd
      endif
      dated = nint(data(datecol,jvd))
      timed = data(timecol,jvd)
      !
      diff = compare_visi(minantg,maxantg,dateg,timeg,  &
                          minantd,maxantd,dated,timed)
      if (diff.lt.0) then
        ! Data visibility is before current gain visibility
        lastivd = ivd  ! We can safely restart from this one (+1) next time.
        cycle          ! Need to continue iterating data times.
      elseif (diff.gt.0) then
        ! Data visibility is after current gain visibility. No need to go
        ! further we won't find anything useful after this.
        exit
      endif
      ! Ok, this data visibility matches the gain visibility.
      conj = iantd.eq.jantg
      !
      if (zgain.ne.0.0) then
        flagged(jvd) = .false.
        wg = abs(zgain)**2
        do k=8,3*ndc+7,3
          zdata = cmplx(data(k,jvd),data(k+1,jvd))
          if (conj) then
            zcal = zdata/conjg(zgain)
          else
            zcal = zdata/zgain
          endif
          cal(k,  jvd) = real(zcal)
          cal(k+1,jvd) = aimag(zcal)
          cal(k+2,jvd) = data(k+2,jvd)*wg
        enddo
      endif
      !
    enddo
    !
  enddo
  !
  ! Finish by checking what has not been calibrated...
  if (any(flagged)) then
    cnt = 0
    if (flag) then
      ! Uncalibrated data are nullified
      do jvd=1,nvis
        if (flagged(jvd)) then
          ! print *,jvd  ! Too verbose...
          cnt = cnt+1
          cal(8:3*ndc+7,jvd) = 0.0
        endif
      enddo
      write(mess,'(3(A,I0))')  &
        'W-UV_CAL, Flagged ',cnt,' uncalibrated visibilities (total ',nvis,')'
    else
      ! Uncalibrated data is left unmodified
      do jvd=1,nvis
        if (flagged(jvd)) then
          cnt = cnt+1
          ! print *,jvd  ! Too verbose...
        endif
      enddo
      write(mess,'(3(A,I0))')  &
        'W-UV_CAL, ',cnt,' uncalibrated visibilities (total ',nvis,')'
    endif
    call gagout(mess)
  endif
  !
contains
  function compare_visi(a1,a2,ad,at,  &
                        b1,b2,bd,bt)
    !-------------------------------------------------------------------
    ! Compare A and B visibilities according to their first antenna,
    ! then second antenna, then date, then time within tolerance.
    ! Return -1 if A>B, 0 if A=B, +1 if A<B
    !-------------------------------------------------------------------
    integer(kind=4) :: compare_visi
    integer(kind=4), intent(in) :: a1,a2,ad
    real(kind=4),    intent(in) :: at
    integer(kind=4), intent(in) :: b1,b2,bd
    real(kind=4),    intent(in) :: bt
    ! Local
    real(kind=4) :: diff
    !
    ! Compare first antennas
    if (a1.gt.b1) then
      compare_visi = -1
      return
    elseif (a1.lt.b1) then
      compare_visi = +1
      return
    endif
    ! Compare second antennas
    if (a2.gt.b2) then
      compare_visi = -1
      return
    elseif (a2.lt.b2) then
      compare_visi = +1
      return
    endif
    ! Compare dates
    if (ad.gt.bd) then
      compare_visi = -1
      return
    elseif (ad.lt.bd) then
      compare_visi = +1
      return
    endif
    ! Compare times within tolerance
    diff = at-bt
    if (diff.gt.time_tol) then
      compare_visi = -1
    elseif (diff.lt.-time_tol) then
      compare_visi = +1
    else
      compare_visi = 0
    endif
    !
  end function compare_visi
  !
end subroutine do_outer_cal

* DECK icmax1.f
      INTEGER          FUNCTION ICMAX1( N, CX, INCX )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
*     ..
*     .. Array Arguments ..
      COMPLEX            CX( * )
*     ..
*
*  Purpose
*  =======
*
*  ICMAX1 finds the index of the element whose real part has maximum
*  absolute value.
*
*  Based on ICAMAX from Level 1 BLAS.
*  The change is to use the 'genuine' absolute value.
*
*  Contributed by Nick Higham for use with CLACON.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of elements in the vector CX.
*
*  CX      (input) COMPLEX array, dimension (N)
*          The vector whose elements will be summed.
*
*  INCX    (input) INTEGER
*          The spacing between successive values of CX.  INCX >= 1.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IX
      REAL               SMAX
      COMPLEX            ZDUM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, REAL
*     ..
*     .. Statement Functions ..
      REAL               CABS1
*     ..
*     .. Statement Function definitions ..
*
*     NEXT LINE IS THE ONLY MODIFICATION.
      CABS1( ZDUM ) = ABS( REAL( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
      ICMAX1 = 0
      IF( N.LT.1 )
     $   RETURN
      ICMAX1 = 1
      IF( N.EQ.1 )
     $   RETURN
      IF( INCX.EQ.1 )
     $   GO TO 30
*
*     CODE FOR INCREMENT NOT EQUAL TO 1
*
      IX = 1
      SMAX = CABS1( CX( 1 ) )
      IX = IX + INCX
      DO 20 I = 2, N
         IF( CABS1( CX( IX ) ).LE.SMAX )
     $      GO TO 10
         ICMAX1 = I
         SMAX = CABS1( CX( IX ) )
   10    CONTINUE
         IX = IX + INCX
   20 CONTINUE
      RETURN
*
*     CODE FOR INCREMENT EQUAL TO 1
*
   30 CONTINUE
      SMAX = CABS1( CX( 1 ) )
      DO 40 I = 2, N
         IF( CABS1( CX( I ) ).LE.SMAX )
     $      GO TO 40
         ICMAX1 = I
         SMAX = CABS1( CX( I ) )
   40 CONTINUE
      RETURN
*
*     End of ICMAX1
*
      END
* DECK ilaenv.f
      INTEGER          FUNCTION ILAENV( ISPEC, NAME, OPTS, N1, N2, N3,
     $                 N4 )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER*( * )    NAME, OPTS
      INTEGER            ISPEC, N1, N2, N3, N4
*     ..
*
*  Purpose
*  =======
*
*  ILAENV is called from the LAPACK routines to choose problem-dependent
*  parameters for the local environment.  See ISPEC for a description of
*  the parameters.
*
*  This version provides a set of parameters which should give good,
*  but not optimal, performance on many of the currently available
*  computers.  Users are encouraged to modify this subroutine to set
*  the tuning parameters for their particular machine using the option
*  and problem size information in the arguments.
*
*  This routine will not function correctly if it is converted to all
*  lower case.  Converting it to all upper case is allowed.
*
*  Arguments
*  =========
*
*  ISPEC   (input) INTEGER
*          Specifies the parameter to be returned as the value of
*          ILAENV.
*          = 1: the optimal blocksize; if this value is 1, an unblocked
*               algorithm will give the best performance.
*          = 2: the minimum block size for which the block routine
*               should be used; if the usable block size is less than
*               this value, an unblocked routine should be used.
*          = 3: the crossover point (in a block routine, for N less
*               than this value, an unblocked routine should be used)
*          = 4: the number of shifts, used in the nonsymmetric
*               eigenvalue routines
*          = 5: the minimum column dimension for blocking to be used;
*               rectangular blocks must have dimension at least k by m,
*               where k is given by ILAENV(2,...) and m by ILAENV(5,...)
*          = 6: the crossover point for the SVD (when reducing an m by n
*               matrix to bidiagonal form, if max(m,n)/min(m,n) exceeds
*               this value, a QR factorization is used first to reduce
*               the matrix to a triangular form.)
*          = 7: the number of processors
*          = 8: the crossover point for the multishift QR and QZ methods
*               for nonsymmetric eigenvalue problems.
*
*  NAME    (input) CHARACTER*(*)
*          The name of the calling subroutine, in either upper case or
*          lower case.
*
*  OPTS    (input) CHARACTER*(*)
*          The character options to the subroutine NAME, concatenated
*          into a single character string.  For example, UPLO = 'U',
*          TRANS = 'T', and DIAG = 'N' for a triangular routine would
*          be specified as OPTS = 'UTN'.
*
*  N1      (input) INTEGER
*  N2      (input) INTEGER
*  N3      (input) INTEGER
*  N4      (input) INTEGER
*          Problem dimensions for the subroutine NAME; these may not all
*          be required.
*
* (ILAENV) (output) INTEGER
*          >= 0: the value of the parameter specified by ISPEC
*          < 0:  if ILAENV = -k, the k-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The following conventions have been used when calling ILAENV from the
*  LAPACK routines:
*  1)  OPTS is a concatenation of all of the character options to
*      subroutine NAME, in the same order that they appear in the
*      argument list for NAME, even if they are not used in determining
*      the value of the parameter specified by ISPEC.
*  2)  The problem dimensions N1, N2, N3, N4 are specified in the order
*      that they appear in the argument list for NAME.  N1 is used
*      first, N2 second, and so on, and unused problem dimensions are
*      passed a value of -1.
*  3)  The parameter value returned by ILAENV is checked for validity in
*      the calling subroutine.  For example, ILAENV is used to retrieve
*      the optimal blocksize for STRTRI as follows:
*
*      NB = ILAENV( 1, 'STRTRI', UPLO // DIAG, N, -1, -1, -1 )
*      IF( NB.LE.1 ) NB = MAX( 1, N )
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            CNAME, SNAME
      CHARACTER*1        C1
      CHARACTER*2        C2, C4
      CHARACTER*3        C3
      CHARACTER*6        SUBNAM
      INTEGER            I, IC, IZ, NB, NBMIN, NX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CHAR, ICHAR, INT, MIN, REAL
*     ..
*     .. Executable Statements ..
*
      GO TO ( 100, 100, 100, 400, 500, 600, 700, 800 ) ISPEC
*
*     Invalid value for ISPEC
*
      ILAENV = -1
      RETURN
*
  100 CONTINUE
*
*     Convert NAME to upper case if the first character is lower case.
*
      ILAENV = 1
      SUBNAM = NAME
      IC = ICHAR( SUBNAM( 1:1 ) )
      IZ = ICHAR( 'Z' )
      IF( IZ.EQ.90 .OR. IZ.EQ.122 ) THEN
*
*        ASCII character set
*
         IF( IC.GE.97 .AND. IC.LE.122 ) THEN
            SUBNAM( 1:1 ) = CHAR( IC-32 )
            DO 10 I = 2, 6
               IC = ICHAR( SUBNAM( I:I ) )
               IF( IC.GE.97 .AND. IC.LE.122 )
     $            SUBNAM( I:I ) = CHAR( IC-32 )
   10       CONTINUE
         END IF
*
      ELSE IF( IZ.EQ.233 .OR. IZ.EQ.169 ) THEN
*
*        EBCDIC character set
*
         IF( ( IC.GE.129 .AND. IC.LE.137 ) .OR.
     $       ( IC.GE.145 .AND. IC.LE.153 ) .OR.
     $       ( IC.GE.162 .AND. IC.LE.169 ) ) THEN
            SUBNAM( 1:1 ) = CHAR( IC+64 )
            DO 20 I = 2, 6
               IC = ICHAR( SUBNAM( I:I ) )
               IF( ( IC.GE.129 .AND. IC.LE.137 ) .OR.
     $             ( IC.GE.145 .AND. IC.LE.153 ) .OR.
     $             ( IC.GE.162 .AND. IC.LE.169 ) )
     $            SUBNAM( I:I ) = CHAR( IC+64 )
   20       CONTINUE
         END IF
*
      ELSE IF( IZ.EQ.218 .OR. IZ.EQ.250 ) THEN
*
*        Prime machines:  ASCII+128
*
         IF( IC.GE.225 .AND. IC.LE.250 ) THEN
            SUBNAM( 1:1 ) = CHAR( IC-32 )
            DO 30 I = 2, 6
               IC = ICHAR( SUBNAM( I:I ) )
               IF( IC.GE.225 .AND. IC.LE.250 )
     $            SUBNAM( I:I ) = CHAR( IC-32 )
   30       CONTINUE
         END IF
      END IF
*
      C1 = SUBNAM( 1:1 )
      SNAME = C1.EQ.'S' .OR. C1.EQ.'D'
      CNAME = C1.EQ.'C' .OR. C1.EQ.'Z'
      IF( .NOT.( CNAME .OR. SNAME ) )
     $   RETURN
      C2 = SUBNAM( 2:3 )
      C3 = SUBNAM( 4:6 )
      C4 = C3( 2:3 )
*
      GO TO ( 110, 200, 300 ) ISPEC
*
  110 CONTINUE
*
*     ISPEC = 1:  block size
*
*     In these examples, separate code is provided for setting NB for
*     real and complex.  We assume that NB will take the same value in
*     single or double precision.
*
      NB = 1
*
      IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         ELSE IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR.
     $            C3.EQ.'QLF' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( C2.EQ.'PO' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         ELSE IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NB = 1
         ELSE IF( SNAME .AND. C3.EQ.'GST' ) THEN
            NB = 64
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            NB = 64
         ELSE IF( C3.EQ.'TRD' ) THEN
            NB = 1
         ELSE IF( C3.EQ.'GST' ) THEN
            NB = 64
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NB = 32
            END IF
         ELSE IF( C3( 1:1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NB = 32
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NB = 32
            END IF
         ELSE IF( C3( 1:1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NB = 32
            END IF
         END IF
      ELSE IF( C2.EQ.'GB' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               IF( N4.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            ELSE
               IF( N4.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            END IF
         END IF
      ELSE IF( C2.EQ.'PB' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               IF( N2.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            ELSE
               IF( N2.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            END IF
         END IF
      ELSE IF( C2.EQ.'TR' ) THEN
         IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( C2.EQ.'LA' ) THEN
         IF( C3.EQ.'UUM' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'ST' ) THEN
         IF( C3.EQ.'EBZ' ) THEN
            NB = 1
         END IF
      END IF
      ILAENV = NB
      RETURN
*
  200 CONTINUE
*
*     ISPEC = 2:  minimum block size
*
      NBMIN = 2
      IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR.
     $       C3.EQ.'QLF' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NBMIN = 8
            ELSE
               NBMIN = 8
            END IF
         ELSE IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NBMIN = 2
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRD' ) THEN
            NBMIN = 2
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NBMIN = 2
            END IF
         ELSE IF( C3( 1:1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NBMIN = 2
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NBMIN = 2
            END IF
         ELSE IF( C3( 1:1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NBMIN = 2
            END IF
         END IF
      END IF
      ILAENV = NBMIN
      RETURN
*
  300 CONTINUE
*
*     ISPEC = 3:  crossover point
*
      NX = 0
      IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR.
     $       C3.EQ.'QLF' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NX = 1
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRD' ) THEN
            NX = 1
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NX = 128
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NX = 128
            END IF
         END IF
      END IF
      ILAENV = NX
      RETURN
*
  400 CONTINUE
*
*     ISPEC = 4:  number of shifts (used by xHSEQR)
*
      ILAENV = 6
      RETURN
*
  500 CONTINUE
*
*     ISPEC = 5:  minimum column dimension (not used)
*
      ILAENV = 2
      RETURN
*
  600 CONTINUE 
*
*     ISPEC = 6:  crossover point for SVD (used by xGELSS and xGESVD)
*
      ILAENV = INT( REAL( MIN( N1, N2 ) )*1.6E0 )
      RETURN
*
  700 CONTINUE
*
*     ISPEC = 7:  number of processors (not used)
*
      ILAENV = 1
      RETURN
*
  800 CONTINUE
*
*     ISPEC = 8:  crossover point for multishift (used by xHSEQR)
*
      ILAENV = 50
      RETURN
*
*     End of ILAENV
*
      END
* DECK izmax1.f
      INTEGER          FUNCTION IZMAX1( N, CX, INCX )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         CX( * )
*     ..
*
*  Purpose
*  =======
*
*  IZMAX1 finds the index of the element whose real part has maximum
*  absolute value.
*
*  Based on IZAMAX from Level 1 BLAS.
*  The change is to use the 'genuine' absolute value.
*
*  Contributed by Nick Higham for use with ZLACON.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of elements in the vector CX.
*
*  CX      (input) COMPLEX*16 array, dimension (N)
*          The vector whose elements will be summed.
*
*  INCX    (input) INTEGER
*          The spacing between successive values of CX.  INCX >= 1.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IX
      DOUBLE PRECISION   SMAX
      COMPLEX*16         ZDUM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
*
*     NEXT LINE IS THE ONLY MODIFICATION.
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
      IZMAX1 = 0
      IF( N.LT.1 )
     $   RETURN
      IZMAX1 = 1
      IF( N.EQ.1 )
     $   RETURN
      IF( INCX.EQ.1 )
     $   GO TO 30
*
*     CODE FOR INCREMENT NOT EQUAL TO 1
*
      IX = 1
      SMAX = CABS1( CX( 1 ) )
      IX = IX + INCX
      DO 20 I = 2, N
         IF( CABS1( CX( IX ) ).LE.SMAX )
     $      GO TO 10
         IZMAX1 = I
         SMAX = CABS1( CX( IX ) )
   10    CONTINUE
         IX = IX + INCX
   20 CONTINUE
      RETURN
*
*     CODE FOR INCREMENT EQUAL TO 1
*
   30 CONTINUE
      SMAX = CABS1( CX( 1 ) )
      DO 40 I = 2, N
         IF( CABS1( CX( I ) ).LE.SMAX )
     $      GO TO 40
         IZMAX1 = I
         SMAX = CABS1( CX( I ) )
   40 CONTINUE
      RETURN
*
*     End of IZMAX1
*
      END

subroutine ellipse(line,error)
  use phys_const
  use gbl_constant
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>ellipse
  use greg_kernel
  use greg_pen
  use greg_types
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command:
  !   ELLIPSE Major Minor PA
  ! 1  /BOX  X Y
  ! 2  /USER X Y
  ! 3  /ARC THETA1 THETA2
  ! 4  /FILL [Icolor]
  ! 5  /HATCH [Ipen] [Angle] [Separ] [Phase]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ELLIPSE'
  logical :: arc,box,user,abso
  integer(kind=4) :: nc,icol_old,ipen_old
  type(polygon_drawing_t) :: drawing
  real(kind=8) :: uscale
  integer(kind=4) :: usunit
  character(len=12) :: ctype(5),name,dummy
  ! Data: order is essential here
  data ctype/'SECONDS','MINUTES','DEGREES','RADIANS','ABSOLUTE'/
  !
  ! Options
  user = sic_present(2,0)
  abso = sic_present(2,3)
  box  = sic_present(1,0)
  arc  = sic_present(3,0)
  !
  ! /FILL and /HATCH options
  call inqcol(icol_old)
  call inqpen(ipen_old)
  call parse_polygon_drawing(rname,line,4,5,drawing,error)
  if (error)  return
  !
  if (user .and. box) then
    call greg_message(seve%e,rname,'Conflicting options /BOX and /USER')
    goto 99
  endif
  !
  ! Angle Unit
  usunit = u_angle
  if (abso) then
    if (gproj%type.eq.p_none) then
      call greg_message(seve%w,rname,'User unit forbidden when no projection')
      goto 99
    else
      call sic_ke (line,2,3,dummy,nc,.true.,error)
      if (error) goto 99
      call sic_ambigs(rname,dummy,name,usunit,ctype,5,error)
      if (error) goto 99
    endif
  endif
  !
  uscale = 1.d0
  if (usunit.eq.u_second) then
    uscale = pi/180.d0/3600.d0
  elseif (usunit.eq.u_minute) then
    uscale = pi/180.d0/60.d0
  elseif (usunit.eq.u_degree) then
    uscale = pi/180.d0
  else
    uscale = 1.d0
  endif
  !
  ! Pen or color to be used. Note: color-filling and hatch-filling can not
  ! be done at the same time, mostly because this would imply to create
  ! 2 segments with 2 colors
  if (penupd)  call setpen(cpen)
  if (drawing%filled) then
    call setcol(drawing%fcolor)
  elseif (drawing%hatched) then
    call setpen(drawing%hpen)
  endif
  !
  call gtsegm(rname,error)
  !
  if (.not.user .or. usunit.eq.5) then
    ! No array mode if /BOX or /USER x y ABSOLUTE
    call ellipse_scalar(line,box,user,abso,usunit,uscale,arc,drawing,error)
  else
    ! /USER support arrays
    call ellipse_array(line,uscale,arc,drawing,error)
  endif
  if (error)  goto 99
  !
  call gtsegm_close(error)
  ! Reset pen *after* closing the segment
  call setpen(ipen_old)
  call setcol(icol_old)
  return
  !
99 continue
  !
  error = .false.
  call gtsegm_close(error)
  ! Reset pen *after* closing the segment
  call setpen(ipen_old)
  call setcol(icol_old)
  error = .true.
end subroutine ellipse
!
subroutine ellipse_scalar(line,box,user,abso,usunit,uscale,arc,drawing,error)
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>ellipse_scalar
  use greg_kernel
  use greg_types
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! Draw a single ellipse, command line arguments must be scalar
  !---------------------------------------------------------------------
  character(len=*),        intent(in)    :: line     ! Input command line
  logical,                 intent(in)    :: box      !
  logical,                 intent(in)    :: user     ! /USER
  logical,                 intent(in)    :: abso     ! /USER ABSO
  integer(kind=4),         intent(in)    :: usunit   !
  real(kind=8),            intent(in)    :: uscale   !
  logical,                 intent(in)    :: arc      ! /ARC
  type(polygon_drawing_t), intent(in)    :: drawing  ! Drawing description
  logical,                 intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: istart,length
  real(kind=4) :: amin,amaj,pa,xpos,ypos
  real(kind=8) :: xus,yus,theta1,theta2,sux,suy
  !
  ! Arguments
  call sic_r4 (line,0,1,amaj,.true.,error)
  if (error) return
  amin = amaj
  call sic_r4 (line,0,2,amin,.false.,error)
  if (error) return
  pa = 0.
  call sic_r4 (line,0,3,pa,.false.,error)
  if (error) return
  ! PA MUST be in degrees , trigonometric , not in radians. I report the con-
  ! version to radians in the subroutine sub_ellipse, since it will then
  ! be compatible with the array mode
  !
  if (box) then
    call sic_r4 (line,1,2,ypos,.true.,error)
    if (error) return
    call sic_r4 (line,1,1,xpos,.true.,error)
    if (error) return
    if (axis_xlog) then
      xus = exp((xpos)/gux + lux)
    else
      xus = (xpos)/gux + gux1
    endif
    if (axis_ylog) then
      yus = exp((ypos)/guy + luy)
    else
      yus = (ypos)/guy + guy1
    endif
    !
    ! What about /BOX with U_ANGLE not radian ?
    xus = xus/uscale
    yus = yus/uscale
  elseif (abso) then
    ! USER with ABSOLUTE
    if (usunit.eq.5) then
      istart = sic_start(2,1)
      length = sic_len(2,1)
      call sic_sexa(line(istart:),length,xus,error)
      if (error) return
      if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
        xus = xus*pi/12.0d0
      else
        xus = xus*pi/180.0d0
      endif
      istart = sic_start(2,2)
      length = sic_len(2,2)
      call sic_sexa(line(istart:),length,yus,error)
      if (error) return
      yus = yus*pi/180.0d0
      sux = xus
      suy = yus
      call abs_to_rel(gproj,sux,suy,xus,yus,1)
    else
      ! Unreachable code ...
      call sic_r8 (line,2,2,yus,.true.,error)
      if (error) return
      call sic_r8 (line,2,1,xus,.true.,error)
      if (error) return
    endif
  elseif (user) then
    ! Unreachable code ...
    call sic_r8 (line,2,2,yus,.true.,error)
    if (error) return
    call sic_r8 (line,2,1,xus,.true.,error)
    if (error) return
  else
    !
    ! Current pen position
    if (axis_xlog) then
      xus = exp((xp-gx1)/gux + lux)
    else
      xus = (xp-gx1)/gux + gux1
    endif
    if (axis_ylog) then
      yus = exp((yp-gy1)/guy + luy)
    else
      yus = (yp-gy1)/guy + guy1
    endif
    !
    ! What happens if U_ANGLE is not radian ?
    xus = xus/uscale
    yus = yus/uscale
  endif
  !
  ! /ARC option
  if (arc) then
    call sic_r8 (line,3,2,theta2,.true.,error)
    if (error) return
    call sic_r8 (line,3,1,theta1,.true.,error)
    if (error) return
  endif
  call sub_ellipse(amaj,amin,pa,arc,theta1,theta2,xus,yus,drawing,uscale,error)
  !
end subroutine ellipse_scalar
!
subroutine ellipse_array(line,uscale,arc,drawing,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>ellipse_array
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  use greg_types
  !---------------------------------------------------------------------
  ! @ private
  !  Draw one or several ellipses, command line arguments can be scalar
  ! or array
  !---------------------------------------------------------------------
  character(len=*),        intent(in)    :: line     ! Input command line
  real(kind=8),            intent(in)    :: uscale   !
  logical,                 intent(in)    :: arc      ! /ARC
  type(polygon_drawing_t), intent(in)    :: drawing  ! Drawing description
  logical,                 intent(inout) :: error    ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ELLIPSE'
  type(sic_descriptor_t) :: inca1,inca2,inca3,inca4,inca5,default
  integer(kind=index_length) :: np(5),nmaj,nmin,npa,npx,npy,ntot,i
  integer(kind=4) :: kmaj,kmin,kpa,kpx,kpy
  integer(kind=address_length) :: imaj,imin,ipa,ipx,ipy
  real(kind=4) :: pa
  real(kind=8) :: theta1,theta2
  !
  ntot = 0
  default%readonly = .false.
  default%ndim = 0
  default%dims(:) = 0
  default%addr = 0
  default%size = 0
  default%status = 0
  !
  ! MAJ MIN and ORI must be R*4, X and Y positions must be R*8.
  ! That is not necessary what the user got. So we use SIC_INCARNATE
  default%type = fmt_r4
  call sic_inca (line,0,1,inca1,default,.true.,error)
  if (error) return
  imaj = gag_pointer(inca1%addr,memory)
  nmaj = inca1%dims(1)
  if (nmaj.le.1) then
    kmaj = 0
  else
    ntot = nmaj
    kmaj = 1
  endif
  !
  ! Min Axis, default INCA1
  call sic_inca (line,0,2,inca2,inca1,.false.,error)
  if (error) then
    call sic_volatile(inca1)
    return
  endif
  imin = gag_pointer(inca2%addr,memory)
  nmin = inca2%dims(1)
  if (nmin.gt.1) then
    if (ntot.eq.0) ntot = nmin
    kmin = 1
  else
    kmin = 0
  endif
  !
  ! PA: default 0.0
  pa = 0.0
  default%addr = locwrd(pa)
  default%ndim = 0
  call sic_inca (line,0,3,inca3,default,.false.,error)
  if (error) then
    if (sic_notsamedesc(inca1,inca2)) call sic_volatile(inca2)
    call sic_volatile(inca1)
    return
  endif
  ipa = gag_pointer(inca3%addr,memory)
  npa = inca3%dims(1)
  if (npa.gt.1) then
    if (ntot.eq.0) ntot = npa
    kpa = 1
  else
    kpa = 0
  endif
  !
  ! X
  default%type = fmt_r8
  call sic_inca (line,2,1,inca4,default,.true.,error)
  if (error) then
    call sic_volatile(inca3)
    if (sic_notsamedesc(inca1,inca2)) call sic_volatile(inca2)
    call sic_volatile(inca1)
    return
  endif
  if (error) return
  npx = inca4%dims(1)
  if (npx.gt.1) then
    if (ntot.eq.0) ntot = npx
    kpx = 2
  else
    kpx = 0
  endif
  ipx = gag_pointer(inca4%addr,memory)
  ! Y
  default%type = fmt_r8
  if (error) then
    call sic_volatile(inca4)
    call sic_volatile(inca3)
    if (sic_notsamedesc(inca1,inca2)) call sic_volatile(inca2)
    call sic_volatile(inca1)
    return
  endif
  call sic_inca (line,2,2,inca5,default,.true.,error)
  if (error) return
  npy = inca5%dims(1)
  if (npy.gt.1) then
    if (ntot.eq.0) ntot = npy
    kpy = 2
  else
    kpy = 0
  endif
  ipy = gag_pointer(inca5%addr,memory)
  !
  ! /ARC option to be treated properly some time
  if (arc) then
    call sic_r8 (line,3,2,theta2,.true.,error)
    call sic_r8 (line,3,1,theta1,.true.,error)
  endif
  !
  ! Check array compatibilities
  np = (/nmaj,nmin,npa,npx,npy/)
  do i=1,5
    if (np(i).gt.1 .and. np(i).ne.ntot) then
      call greg_message(seve%e,rname,'Arrays have incompatible sizes')
      error = .true.
    endif
  enddo
  ntot = max(ntot,1)         ! Scalar have size 0
  !
  do i=1,ntot
    if (error)  exit
    call sub_ellipse(memory(imaj),memory(imin),memory(ipa),arc,theta1,  &
      theta2,memory(ipx),memory(ipy),drawing,uscale,error)
    imaj = imaj+kmaj
    imin = imin+kmin
    ipa  = ipa+kpa
    ipx  = ipx+kpx
    ipy  = ipy+kpx
  enddo
  !
  ! Volatilize the incarnations
  call sic_volatile(inca5)
  call sic_volatile(inca4)
  call sic_volatile(inca3)
  if (sic_notsamedesc(inca1,inca2)) call sic_volatile(inca2)
  call sic_volatile(inca1)
  !
end subroutine ellipse_array
!
subroutine sub_ellipse(amaj,amin,pa,arc,thet1,thet2,xus,yus,drawing,scale,error)
  use gildas_def
  use phys_const
  use greg_interfaces
  use greg_kernel
  use greg_types
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),            intent(in)    :: amaj     ! Major axis
  real(kind=4),            intent(in)    :: amin     ! Minor axis
  real(kind=4),            intent(in)    :: pa       ! Position angle
  logical,                 intent(in)    :: arc      ! Arc or full ellipse?
  real(kind=8),            intent(in)    :: thet1    ! If arc, starting angle
  real(kind=8),            intent(in)    :: thet2    ! If arc, ending angle
  real(kind=8),            intent(in)    :: xus      ! Ellipse X center
  real(kind=8),            intent(in)    :: yus      ! Ellipse Y center
  type(polygon_drawing_t), intent(in)    :: drawing  ! Drawing description
  real(kind=8),            intent(in)    :: scale    ! Conversion factor from Current Unit to User Unit
  logical,                 intent(inout) :: error    ! Logical error flag
  ! Global
  external :: gdraw
  ! Local
  real(kind=4) :: ppa
  integer(kind=size_length) :: nxy
  integer(kind=4), parameter :: mxy=51
  character(len=1) :: variable
  character(len=12) :: algorithm
  logical :: periodic
  real(kind=8) :: theta1,theta2,x(mxy),y(mxy),z(mxy)
  real(kind=4) :: cosa,sina,rx,ry
  integer(kind=4) :: i
  ! Data
  data algorithm /'CUBIC_SPLINE'/, variable /'Z'/
  !
  ! PA must be in degrees at subroutine call (same as THETA*). converted
  ! internally to radians
  ppa = pa*rad_per_deg
  !
  if (drawing%filled .or. drawing%hatched) then
    nxy = mxy
  else
    nxy = 21
  endif
  !
  cosa = cos(ppa)
  sina = sin(ppa)
  if (arc) then
    theta1 = thet1*rad_per_deg
    theta2 = thet2*rad_per_deg
    do while(theta2.lt.theta1)
      theta2 = theta2+2.d0*pi
    enddo
    if (drawing%filled .or. drawing%hatched) then
      x(1) = xus
      y(1) = yus
      do i=2,nxy-1
        z(i) = theta1 + (theta2-theta1)*(i-2.)/(nxy-3.)
        rx = amaj*cos(z(i))
        ry = amin*sin(z(i))
        x(i) = rx*cosa - ry*sina + xus
        y(i) = rx*sina + ry*cosa + yus
      enddo
      x(nxy) = xus
      y(nxy) = yus
    else
      do i=1,nxy
        z(i) = theta1 + (theta2-theta1)*(i-1.)/(nxy-1.)
        rx = amaj*cos(z(i))
        ry = amin*sin(z(i))
        x(i) = rx*cosa - ry*sina + xus
        y(i) = rx*sina + ry*cosa + yus
      enddo
    endif
    periodic = .false.
  else
    do i=1,nxy
      z(i) = 2.*pi*(i-1.)/(nxy-1.)
      rx = amaj*cos(z(i))
      ry = amin*sin(z(i))
      x(i) = rx*cosa - ry*sina + xus
      y(i) = rx*sina + ry*cosa + yus
    enddo
    x(nxy) = x(1)
    y(nxy) = y(1)
    periodic = .true.
  endif
  !
  ! Plot the curve using Spline
  x(1:nxy) = x(1:nxy)*scale
  y(1:nxy) = y(1:nxy)*scale
  !
  if (drawing%hatched) then
    call gr8_hatch('ELLIPSE',nxy,x,y,  &
                   drawing%hangle,drawing%hsepar,drawing%hphase,error)
  elseif (drawing%filled) then
    call gr8_ufill (nxy,x,y)
  else
    call plcurv (nxy,x,y,z,accurd,algorithm,variable,periodic,grelocate,  &
      gdraw,error)
  endif
  x(1) = xus*scale
  y(1) = yus*scale
  call relocate (x(1),y(1))
end subroutine sub_ellipse

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_index
  use cubetools_parameters
  use cubedag_link_type
  use cube_types
  use cubeadm_messaging
  !---------------------------------------------------------------------
  ! Support module for an index (list) of type(cube_t)
  !---------------------------------------------------------------------
  !
  public :: index_t, ncub_k
  private
  !
  integer(kind=4), parameter :: ncub_k = 4
  !
  type, extends(cubedag_link_t) :: index_t
     ! No more components added
   contains
     procedure, public :: get_cube         => cubeadm_index_get_cube_ptr
     procedure, public :: put_cube         => cubeadm_index_put_cube_ptr
     procedure, public :: get_from_current => cubeadm_index_get_from_current
     procedure, public :: get_from_cubeid  => cubeadm_index_get_from_cubeid
     final             ::                     cubeadm_index_final
  end type index_t
  !
contains
  !
  subroutine cubeadm_index_get_from_current(index,access,action,error)
    use cubedag_node_class
    use cubedag_find_types
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(index_t),       intent(inout) :: index
    integer(kind=code_k), intent(in)    :: access  ! code_access_*
    integer(kind=code_k), intent(in)    :: action  ! Read/write/update?
    logical,              intent(inout) :: error
    !
    type(dag_find_t) :: find
    type(cubedag_link_t) :: mycx
    integer(kind=ncub_k) :: icub
    class(cubedag_node_object_t), pointer :: dno
    type(cube_t), pointer :: cube
    character(len=*), parameter :: rname='INDEX>GET>FROM>CURRENT'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call find%cx2optx(mycx,error)
    if (error) return
    if (mycx%n.le.0)  call cubeadm_message(seve%w,rname,'Index is empty')
    do icub=1,mycx%n
       dno => cubedag_node_ptr(mycx%list(icub)%p,error)
       if (error) return
       call cubeadm_get_header(dno%node%id,access,action,cube,error)
       if (error) return
       call index%put_cube(icub,cube,error)
       if (error) return
    enddo
  end subroutine cubeadm_index_get_from_current
  !
  subroutine cubeadm_index_get_from_cubeid(index,opt,cubeids,error)
    use cubetools_structure
    use cubeadm_get
    use cubeadm_cubeid_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(index_t),       intent(inout) :: index
    type(option_t),       intent(in)    :: opt
    type(cubeid_user_t),  intent(in)    :: cubeids
    logical,              intent(inout) :: error
    !
    integer(kind=ncub_k) :: icub
    type(cubeid_arg_t), pointer :: arg
    type(cube_t), pointer :: cube
    character(len=*), parameter :: rname='INDEX>GET>FROM>CUBEID'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    do icub=1,cubeids%ncube
       ! Fetch the cubeid_arg_t from the option_t list of arguments
       arg => cubedag_cubeid_arg_ptr(opt%arg%list(icub)%p,error)
       if (error)  return
       ! Fetch the corresponding cube_t
       call cubeadm_get_header(arg,cubeids,cube,error)
       if (error) return
       call index%put_cube(icub,cube,error)
       if (error) return
    enddo
  end subroutine cubeadm_index_get_from_cubeid
  !
  function cubeadm_index_get_cube_ptr(index,icub,error)
    use cubelist_types
    !-------------------------------------------------------------------
    ! Return a pointer to a cube_t at index icub in the index
    !-------------------------------------------------------------------
    type(cube_t), pointer :: cubeadm_index_get_cube_ptr
    class(index_t),       intent(in)    :: index
    integer(kind=ncub_k), intent(in)    :: icub
    logical,              intent(inout) :: error
    !
    class(list_object_t), pointer :: not
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='INDEX>GET>CUBE'
    !
    if (index%n.lt.icub) then
      write(mess,'(A,I0,A)')  'No such cube #',icub,' in index'
      call cubeadm_message(seve%e,rname,mess)
      cubeadm_index_get_cube_ptr => null()
      error = .true.
      return
    endif
    !
    not => index%list(icub)%p
    select type(not)
    type is (cube_t)
      cubeadm_index_get_cube_ptr => not
    class default
      cubeadm_index_get_cube_ptr => null()
      call cubeadm_message(seve%e,rname,  &
        'Internal error: object is not a cube_t type')
      error = .true.
      return
    end select
  end function cubeadm_index_get_cube_ptr
  !
  subroutine cubeadm_index_put_cube_ptr(index,icub,cube,error)
    !-------------------------------------------------------------------
    ! Put a pointer to a cube_t in the index
    !-------------------------------------------------------------------
    class(index_t),       intent(inout) :: index
    integer(kind=ncub_k), intent(in)    :: icub
    type(cube_t), target, intent(in)    :: cube
    logical,              intent(inout) :: error
    !
    ! Increase index size if needed
    call index%reallocate(icub,error)
    if (error) return
    !
    index%list(icub)%p => cube
    index%n = max(index%n,icub)
  end subroutine cubeadm_index_put_cube_ptr
  !
  subroutine cubeadm_index_final(index)
    type(index_t), intent(inout) :: index
    logical :: error
    error = .false.
    call index%cubedag_link_t%final(error)
  end subroutine cubeadm_index_final
end module cubeadm_index
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!                                                                                  !! NCSstd
! Id: modulePakoGlobalParameters.f90 ,v 1.3.0  2018-06-06 Hans Ungerechts          !! NCSstd
!                                    ,v 1.3.0  2017-11-11 Hans Ungerechts          !! NCSstd
!                                    ,v 1.2.6  2017-08-17 Hans Ungerechts          !! NCSstd
!                                    ,v 1.2.5  2016-06-09 Hans Ungerechts          !! 
!                                              2016-05-18 Hans Ungerechts          !! 
!                                              2016-04-04
!                                    ,v 1.2.3  2014-10-29 Hans Ungerechts          !! 
!                                    ,v 1.2.3  2014-07-17 Hans Ungerechts          !! 
!                                    ,v 1.2.3  2014-04-24 Hans Ungerechts          !! 
!                                     v 1.2.2  2013-01-21 Hans Ungerechts          !! 
!                                     v 1.2.1  2012-06-22 Hans Ungerechts          !! 
!     from:                                                                        !!
!     modulePakoGlobalParameters.f90 ,v 1.1.12 2012-03-26 Hans Ungerechts          !! 
!                                                                                  !! 
!----------------------------------------------------------------------------------!! 
! PAKO 
!
! <DOCUMENTATION name="moduleGlobalParameters">
!
! constants  (parameters in the FORTRAN sense),
!    including unit conversion factors
!
! integer codes for SIC error messages
! 
! character strings for "choice" keywords
!    lenCH : length of these strings 
!    they come in 2 flavors:
!    *%* :  
!       derived data types, 
!          e.g., rec%Bolo                =   "Bolometer"
!          short, recognizable by their peculiar construction
!    *Choices(i) :
!       elements of arrays of char strings, 
!          e.g., receiverChoices(iBolo)  =   "Bolometer"
!          more elaborate, suitable for general matching routine
!    nDim*Choices : number of available choices in each case
!    i*           : predefined indices 
!    The strings normally are in mixed case, e.g., "horizontalTrue",
!    but use standard spelling, e.g., "Doppler" or standard 
!    abbreviations, e.g., "HERA", where appropriate.
!
! print* subroutines to print the choice keywords
!
! </DOCUMENTATION> <!-- name="moduleGlobalParameters" -->
!
Module modulePakoGlobalParameters
  !
  Implicit None
  Save
  Public
  !
  ! *** Sizes, kinds for variables ***     
  Include 'inc/parameters/sizes.inc'
  !
  ! ********* Global Version Id *********
  !Character (len=lenCh),  Parameter :: pakoVersion       = "v 1.3.0 for 2017-11-11"
  !Character (len=lenCh),  Parameter :: pakoVersionString = "v 1.3.0"
  !Character (len=lenCh),  Parameter :: pakoVersionDate   = "2017-11-11"
  !Character (len=lenCh),  Parameter :: pakoSubversion    = "s 1.3.0.4 2018-06-06"
  !
  Character (len=lenCh),  Parameter :: pakoVersion       = "v 2.0.1 for 2018-07-11"
  Character (len=lenCh),  Parameter :: pakoVersionString = "v 2.0.1"
  Character (len=lenCh),  Parameter :: pakoVersionDate   = "2018-07-11"
  Character (len=lenCh),  Parameter :: pakoSubversion    = "s 2.0.1.1 2018-07-11"
  !
  Real(Kind=kindDouble),  Parameter :: Pi     = 3.141592653589793D0
  !
  ! *** conversion factors
  !   * for frequencies:
  Real(Kind=kindDouble),  Parameter :: MHz      = 1.0D6
  Real(Kind=kindDouble),  Parameter :: MHzToGhz = 1.0D-3
  !
  !   * to rad:
  Real(Kind=kindDouble),  Parameter :: rad    = 1.0D0
  Real(Kind=kindDouble),  Parameter :: radian = 1.0D0
  Real(Kind=kindDouble),  Parameter :: arcsec = Pi/(180.0D0*60.0D0*60.0D0)
  Real(Kind=kindDouble),  Parameter :: arcmin = Pi/(180.0D0*60.0D0)
  Real(Kind=kindDouble),  Parameter :: deg    = Pi/(180.0D0)
  Real(Kind=kindDouble),  Parameter :: degree = Pi/(180.0D0)
  Real(Kind=kindDouble),  Parameter :: degs   = Pi/(180.0D0)
  Real(Kind=kindDouble),  Parameter :: second = Pi/( 12.0D0*60.0D0*60.0D0)
  Real(Kind=kindDouble),  Parameter :: minute = Pi/( 12.0D0*60.0D0)
  Real(Kind=kindDouble),  Parameter :: hour   = Pi/( 12.0D0)
  !
  ! *** for special codes:
  Character (len=1),      Parameter :: asterisk = '*'
  Character (len=1),      Parameter :: fit      = 'f'
  Character (len=1),      Parameter :: lookup   = 'l'
  !
  ! *** for SIC messages:
  !
  Integer, Parameter :: severityI = 1
  Integer, Parameter :: severityW = 2
  Integer, Parameter :: severityE = 3
  Integer, Parameter :: severityF = 4
  !
  Integer, Parameter :: priorityI = severityI*2
  Integer, Parameter :: priorityW = severityW*2
  Integer, Parameter :: priorityE = severityE*2
  Integer, Parameter :: priorityF = severityF*2
  !
  ! *** for display styles:
  !
  Character (len=lenCh), Parameter  ::  DScommand    =  "#0F0"
  Character (len=lenCh), Parameter  ::  DSok         =  "#0F0"
  Character (len=lenCh), Parameter  ::  DSinactive   =  "#CCC"
  Character (len=lenCh), Parameter  ::  DShighlight  =  "#AAF"
  Character (len=lenCh), Parameter  ::  DSwarning    =  "#FE0"
  Character (len=lenCh), Parameter  ::  DSerror      =  "#E00"
  !
  !                                                                                  !! NCSstd
  ! *** CHARACTER STRINGS / KEYWORDS FOR CHOICES                                     !! NCSstd
  !                                                                                  !! NCSstd
  ! *** RECEIVERS                                                                    !! NCSstd
  !                                                                                  !! NCSstd
  ! style: line up in column: 30                            60                       85 88
  !
  Integer, Parameter      :: nDimReceiverChoices  =  16
  Integer, Parameter      :: iA100          =  1       !   "A100"            
  Integer, Parameter      :: iA230          =  2       !   "A230"              
  Integer, Parameter      :: iB100          =  3       !   "B100"              
  Integer, Parameter      :: iB230          =  4       !   "B230"              
  Integer, Parameter      :: iC150          =  5       !   "C150"              
  Integer, Parameter      :: iC270          =  6       !   "C270"              
  Integer, Parameter      :: iD150          =  7       !   "D150"              
  Integer, Parameter      :: iD270          =  8       !   "D270"              
  Integer, Parameter      :: iBolo          =  9       !   "Bolometer"         
  Integer, Parameter      :: iHERA          = 10       !   "HERAall"              
  Integer, Parameter      :: iHERA1         = 11       !   "HERA1vertical"    
  Integer, Parameter      :: iHERA2         = 12       !   "HERA2horizontal"  
  !  ** EMIR
  Integer, Parameter      :: iE090          = 13       !   "E090"            
  Integer, Parameter      :: iE150          = 14       !   "E150"            
  Integer, Parameter      :: iE230          = 15       !   "E230"            
  Integer, Parameter      :: iE300          = 16       !   "E330"            
  !  ** test / technical receiver
  Integer, Parameter      :: iRxTest        = 17       !   "    "
  !
  Type :: receiverChoicesType
     Character(len=lenCh) ::  A100                     =   "A100"            
     Character(len=lenCh) ::  A230                     =   "A230"            
     Character(len=lenCh) ::  B100                     =   "B100"            
     Character(len=lenCh) ::  B230                     =   "B230"            
     Character(len=lenCh) ::  C150                     =   "C150"            
     Character(len=lenCh) ::  C270                     =   "C270"            
     Character(len=lenCh) ::  D150                     =   "D150"            
     Character(len=lenCh) ::  D270                     =   "D270"            
     Character(len=lenCh) ::  Bolo                     =   "Bolometer"       
     Character(len=lenCh) ::  HERA                     =   "HERAall"            
     Character(len=lenCh) ::  HERA1                    =   "HERA1vertical"  
     Character(len=lenCh) ::  HERA2                    =   "HERA2horizontal"
     !  ** EMIR
     Character(len=lenCh) ::  E090                     =   "E090"            
     Character(len=lenCh) ::  E150                     =   "E150"            
     Character(len=lenCh) ::  E230                     =   "E230"            
     Character(len=lenCh) ::  E300                     =   "E330"            
  End Type receiverChoicesType
  !
  ! style: line up in column: 30                            60                    82 85 88
  Type (receiverChoicesType), Parameter ::                                        &  !! NCSstd
       &  rec = receiverChoicesType                                               &
       &                                                 (                        &
       &                                                   "A100           "   ,  &  !! NCSstd
       &                                                   "A230           "   ,  &  !! NCSstd
       &                                                   "B100           "   ,  &  !! NCSstd
       &                                                   "B230           "   ,  &  !! NCSstd
       &                                                   "C150           "   ,  &  !! NCSstd
       &                                                   "C270           "   ,  &  !! NCSstd
       &                                                   "D150           "   ,  &  !! NCSstd
       &                                                   "D270           "   ,  &  !! NCSstd
       &                                                   "Bolometer      "   ,  &  !! NCSstd
       &                                                   "HERAall        "   ,  &  !! NCSstd
       &                                                   "HERA1vertical  "   ,  &  !! NCSstd
       &                                                   "HERA2horizontal"   ,  &  !! NCSstd
       !  ** EMIR
       &                                                   "E090           "   ,  &  !! NCSstd
       &                                                   "E150           "   ,  &  !! NCSstd
       &                                                   "E230           "   ,  &  !! NCSstd
       &                                                   "E330           "      &  !! NCSstd
       &                                                 ) 
  !
  Character(len=lenCh), Dimension(nDimReceiverChoices), Parameter ::              &
       &  receiverChoices =                                                       &
       &               (/                                                         &
       &                  rec%A100   ,                                            &
       &                  rec%A230   ,                                            &
       &                  rec%B100   ,                                            &
       &                  rec%B230   ,                                            &
       &                  rec%C150   ,                                            &
       &                  rec%C270   ,                                            &
       &                  rec%D150   ,                                            &
       &                  rec%D270   ,                                            &
       &                  rec%Bolo   ,                                            &
       &                  rec%HERA   ,                                            &
       &                  rec%HERA1  ,                                            &
       &                  rec%HERA2  ,                                            &
       !  ** EMIR                                                                 
       &                  rec%E090   ,                                            &
       &                  rec%E150   ,                                            &
       &                  rec%E230   ,                                            &
       &                  rec%E300                                                &
       &               /)
  !
     Character(len=lenCh) ::  RxHolography             = "HOLOGRAPHY"            !  !!  receiver name for holography
  !
  !                                                                                  !! NCSstd
  ! *   sidebands                                                                    !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimSidebandChoices  =  2
  Integer, Parameter      :: ilsb           =  1       !   "LSB"
  Integer, Parameter      :: iusb           =  2       !   "USB"
  !
  Type :: sidebandChoicesType
     Character(len=lenCh) ::  lsb                      =   "LSB"
     Character(len=lenCh) ::  usb                      =   "USB"
  End Type sidebandChoicesType
  !
  Type (sidebandChoicesType), Parameter ::                                        &  !! NCSstd
       &  sb =                                                                    &  !! NCSstd
       &                         sidebandChoicesType (     "LSB"     ,            &  !! NCSstd
       &                                                   "USB"  )                  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimSidebandChoices), Parameter ::              &
       &  sidebandChoices =                                                       &
       &                (/ sb%lsb    ,                                            &
       &                   sb%usb   /)
  !
  !                                                                                  !! NCSstd
  !  ** EMIR                                                                         !! NCSstd
  !   * subbands                                                                     !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimSubbandChoices  =  7  !   count continued from sidebands!
  Integer, Parameter      :: ilo            =  3       !   "LO" 
  Integer, Parameter      :: ili            =  4       !   "LI" 
  Integer, Parameter      :: iui            =  5       !   "UI" 
  Integer, Parameter      :: iuo            =  6       !   "UO" 
  Integer, Parameter      :: iESBnone       =  7       !   GPnone
  !
  Type :: subbandChoicesType
     Character(len=lenCh) ::  lsb                      =   "LSB"
     Character(len=lenCh) ::  usb                      =   "USB"
     Character(len=lenCh) ::  lo                       =   "LO" 
     Character(len=lenCh) ::  li                       =   "LI" 
     Character(len=lenCh) ::  ui                       =   "UI" 
     Character(len=lenCh) ::  uo                       =   "UO" 
     Character(len=lenCh) ::  none                     =   GPnone
  End Type subbandChoicesType
  !
  ! style: line up in column: 30                            60                    82 85 88
  Type (subbandChoicesType), Parameter ::                                         &  !! NCSstd
       &  esb = subbandChoicesType                                                &
       &                                                 (                        &
       &                                                   "LSB "    ,            &  !! NCSstd
       &                                                   "USB "    ,            &  !! NCSstd
       &                                                   "LO  "    ,            &  !! NCSstd
       &                                                   "LI  "    ,            &  !! NCSstd
       &                                                   "UI  "    ,            &  !! NCSstd
       &                                                   "UO  "    ,            &  !! NCSstd
       &                                                   GPnone                 &
       &                                                 )                        !
  !
  ! style: line up in column: 30                            60                    82 85 88
  Character(len=lenCh), Dimension(nDimSubbandChoices), Parameter ::               &
       &  subbandChoices =                                                        &
       &                (/                                                        &
       &                  esb%lsb    ,                                            &
       &                  esb%usb    ,                                            &
       &                  esb%lo     ,                                            &
       &                  esb%li     ,                                            &
       &                  esb%ui     ,                                            &
       &                  esb%uo     ,                                            &
       &                  esb%none                                                &
       &                /)                                                        !
  !
  !                                                                                  !! NCSstd
  ! *   EMIR inner/outer                                                             !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimEMIRioChoices  =  2
  Integer, Parameter      :: iInner             =  1   !   "inner"
  Integer, Parameter      :: iOuter             =  2   !   "outer"
  !
  Type :: EMIRioChoicesType
     Character(len=lenCh) ::  inner                    =   "inner"
     Character(len=lenCh) ::  outer                    =   "outer"
  End Type EMIRioChoicesType
  !
  ! style: line up in column: 30                            60                    82 85 88
  Type (EMIRioChoicesType), Parameter ::                                          &  !! NCSstd
       &  eio =                                                                   &  !! NCSstd
       &                         EMIRioChoicesType (       "inner"     ,          &  !! NCSstd
       &                                                   "outer"  )             !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimEMIRioChoices), Parameter ::                &
       &  EMIRioChoices =                                                         &
       &               (/ eio%inner  ,                                            &
       &                  eio%outer /)                                            !
  !
  !                                                                                  !! NCSstd
  ! *   choices for EMIR rules                                                       !! NCSstd
  !                                                                                  !! NCSstd
  Integer, Parameter      :: nDimEMIRruleChoices=  3
  Integer, Parameter      :: iUnder             =  1   !   "under"    
  Integer, Parameter      :: iInRange           =  2   !   "in range" 
  Integer, Parameter      :: iOver              =  3   !   "over"     
  !
  Type :: EMIRruleChoicesType
     Character(len=lenCh) ::  Under                    =   "under"    
     Character(len=lenCh) ::  InRange                  =   "in range" 
     Character(len=lenCh) ::  Over                     =   "over"     
  End Type EMIRruleChoicesType
  !
  ! style: line up in column: 30                            60                    82 85 88
  Type (EMIRruleChoicesType), Parameter ::                                        &  !! NCSstd
       &  EMIRtest =                                                              &  !! NCSstd
       &                   EMIRruleChoicesType     (       "under   "  ,          &  !! NCSstd
       &                                                   "in range"  ,          &  !! NCSstd
       &                                                   "over    " )           !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimEMIRruleChoices), Parameter ::              &
       &  EMIRruleChoices  =                                                      &
       &          (/ EMIRtest%Under    ,                                          &
       &             EMIRtest%InRange  ,                                          &
       &             EMIRtest%Over    /)                                          !
  !
  !                                                                                  !! NCSstd
  ! *   doppler (apply Doppler correction for RX or keep frequency fixed)            !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimDopplerChoices  =  2
  Integer, Parameter      :: idoppler       =  1       !   "Doppler"
  Integer, Parameter      :: ifixed         =  2       !   "fixed"  
  !
  Type :: dopplerChoicesType
     Character(len=lenCh) ::  doppler                  =   "Doppler"
     Character(len=lenCh) ::  fixed                    =   "fixed"  
  End Type dopplerChoicesType
  !
  Type (dopplerChoicesType), Parameter ::                                         &  !! NCSstd
       &  doppler =                                                               &  !! NCSstd
       &                          dopplerChoicesType (     "Doppler"  ,           &  !! NCSstd
       &                                                   "fixed  "  )              !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimDopplerChoices), Parameter ::               &
       &  dopplerChoices =                                                        &
       &           (/ doppler%doppler ,                                           &
       &              doppler%fixed   /)
  !
  !                                                                                  !! NCSstd
  ! *   width (effective RX bandwidth used with spectrometers)                       !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimWidthChoices  =  2
  Integer, Parameter      :: inarrow        =  1       !   "narrow"
  Integer, Parameter      :: iwide          =  2       !   "wide"  
  !
  Type :: widthChoicesType
     Character(len=lenCh) ::  narrow                   =   "narrow" 
     Character(len=lenCh) ::  wide                     =   "wide"  
  End Type widthChoicesType
  !
  Type (widthChoicesType), Parameter ::                                           &  !! NCSstd
       &  width =                                                                 &  !! NCSstd
       &                            widthChoicesType (     "narrow"  ,            &  !! NCSstd
       &                                                   "wide  "  )               !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimWidthChoices), Parameter ::                 &
       &  widthChoices =                                                          &
       &             (/ width%narrow ,                                            &
       &                width%wide   /)
  !
  ! *   bandWidth
  ! **  EMIR: TBS: review values!
  !
  Integer, Parameter      :: nDimBWChoices   =  4
  Integer, Parameter      :: iBWNarrow       =  1
  Integer, Parameter      :: iBWWide         =  2
  Integer, Parameter      :: iBwEMIRsubband  =  3
  Integer, Parameter      :: iBwEMIRsideband =  4

  !
  Type :: BWChoicesType
     Real(kind=kindDouble) ::   narrow       =  0.500D0  ! narrow mode high freq.      
     Real(kind=kindDouble) ::   wide         =  1.000D0  ! wide   mode high freq.      
     Real(kind=kindDouble) ::   EMIRsubband  =  4.000D0  ! EMIR sub band
     Real(kind=kindDouble) ::   EMIRsideband =  8.000D0  ! EMIR full sideband
  End Type BWChoicesType
  !
  Type (BWChoicesType), Parameter ::                                             &
       &  BW =                                                                   &
       &                       BWChoicesType (                                   &
       &                                        0.500D0,                         &
       &                                        1.000D0,                         &
       &                                        4.000D0,                         &
       &                                        8.000D0                          &
       &                                     )                                   !
  !
  Real(kind=kindDouble), Dimension(nDimBWChoices), Parameter ::                  &
       &  BWChoices =                                                            &
       &           (/        BW%narrow,                                          &
       &                     BW%wide,                                            &
       &                     BW%EMIRsubband,                                     &
       &                     BW%EMIRsideband                                     &
       &           /)                                                            !
  !
  !                                                                                  !! NCSstd
  ! *   calibration scale                                                            !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimScaleChoices  =  2
  Integer, Parameter      :: iScaleAntenna  =  1        !  "antenna"
  Integer, Parameter      :: iScaleBeam     =  2        !  "beam"  
  !
  Type :: scaleChoicesType
     Character(len=lenCh) ::       antenna              =  "antenna" 
     Character(len=lenCh) ::       beam                 =  "beam"  
  End Type scaleChoicesType
  !
  Type (scaleChoicesType), Parameter ::                                           &  !! NCSstd
       &  scale =                                                                 &  !! NCSstd
       &                            scaleChoicesType (     "antenna" ,            &  !! NCSstd
       &                                                   "beam   " )               !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimScaleChoices), Parameter ::                 &
       &  scaleChoices =                                                          &
       &             (/      scale%antenna ,                                      &
       &                     scale%beam   /)
  !
  !                                                                                  !! NCSstd
  ! *   polarization of RX in Nasmyth system (RX cabin)                              !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimPolarizationChoices  =  2
  Integer, Parameter      :: ihorizontalPol    =  1    !   "horizontal"
  Integer, Parameter      :: iverticalPol      =  2    !   "vertical"  
  !
  Type :: polarizationChoicesType
     Character(len=lenCh) ::  hor                      =   "horizontal"
     Character(len=lenCh) ::  ver                      =   "vertical"  
  End Type polarizationChoicesType
  !
  Type (polarizationChoicesType), Parameter ::                                    &  !! NCSstd
       &  pol =                                                                   &  !! NCSstd
       &                     polarizationChoicesType (     "horizontal",          &  !! NCSstd
       &                                                   "vertical  " )            !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimPolarizationChoices), Parameter ::          &
       &  polarizationChoices =                                                   &
       &           (/     pol%hor      ,                                          &
       &                  pol%ver      /)
  !
  ! *   IF
  ! **  EMIR: TBD: review values!
  !
  Integer, Parameter      :: nDimIFChoices  =  6
  Integer, Parameter      :: iIFNarrow      =  1
  Integer, Parameter      :: iIFWide        =  2
  Integer, Parameter      :: iIFlow         =  3
  Integer, Parameter      :: iIfEMIRinner   =  4
  Integer, Parameter      :: iIfEMIRio      =  5
  Integer, Parameter      :: iIfEMIRouter   =  6
  !
  Type :: IFChoicesType
     Real(kind=kindDouble) ::   narrow      =  4.258D0  ! narrow mode high freq.      
     Real(kind=kindDouble) ::   wide        =  4.002D0  ! wide   mode high freq.      
     Real(kind=kindDouble) ::   low         =  1.498D0  !             low  freq. (3mm)
     Real(kind=kindDouble) ::   EMIRinner   =  6.25D0   ! EMIR "inner" subbands
     Real(kind=kindDouble) ::   EMIRio      =  7.84D0   ! EMIR "inner+outer" subbands (full sidebands)
     Real(kind=kindDouble) ::   EMIRouter   =  9.43D0   ! EMIR "outer" subbands
  End Type IFChoicesType
  !
  Type (IFChoicesType), Parameter ::                                             &
       &  If =                                                                   &
       &                       IFChoicesType ( 4.258D0,                          &
       &                                       4.002D0,                          &
       &                                       1.498D0,                          &
       &                                       6.25D0,                           &
       &                                       7.84D0,                           &
       &                                       9.43D0                            &
       &                                     )                                   !
  !
  Real(kind=kindDouble), Dimension(nDimIFChoices), Parameter ::                  &
       &  IFChoices =                                                            &
       &           (/        IF%narrow,                                          &
       &                     IF%wide,                                            &
       &                     IF%low,                                             &
       &                     IF%EMIRinner,                                       &
       &                     IF%EMIRio,                                          &
       &                     IF%EMIRouter                                        &
       &           /)                                                            !
  !
  ! *   IF2
  ! **  EMIR: TBD: review values!
  !
  Integer, Parameter      :: nDimIF2Choices  =  6
  Integer, Parameter      :: iIF2Narrow      =  1
  Integer, Parameter      :: iIF2Wide        =  2
  Integer, Parameter      :: iIF2low         =  3
  Integer, Parameter      :: iIf2EMIRinner   =  4
  Integer, Parameter      :: iIf2EMIRio      =  5
  Integer, Parameter      :: iIf2EMIRouter   =  6
  !
  Type :: IF2ChoicesType
     Real(kind=kindDouble) ::    narrow      =  0.342D0  ! narrow mode high freq.      
     Real(kind=kindDouble) ::    wide        =  0.598D0  ! wide   mode high freq.      
     Real(kind=kindDouble) ::    low         =  0.342D0  !             low  freq. (3mm)
     Real(kind=kindDouble) ::    EMIRinner   =  0.35D0   ! EMIR "inner" subbands
     Real(kind=kindDouble) ::    EMIRio      =  0.35D0   ! EMIR "inner+outer" subbands (full sidebands)
     Real(kind=kindDouble) ::    EMIRouter   =  0.35D0   ! EMIR "outer" subbands
  End Type IF2ChoicesType
  !
  Type (IF2ChoicesType), Parameter ::                                            &
       &  IF2 =                                                                  &
       &                      IF2ChoicesType (  0.342D0,                         &
       &                                        0.598D0,                         &
       &                                        0.342D0,                         &
       &                                        0.35D0 ,                         &
       &                                        0.35D0 ,                         &
       &                                        0.35D0                           &
       &                                     )                                   !
  !
  Real(kind=kindDouble), Dimension(nDimIF2Choices), Parameter ::                 &
       &  IF2Choices =                                                           &
       &           (/        IF2%narrow,                                         &
       &                     IF2%wide,                                           &
       &                     IF2%low,                                            &
       &                     IF2%EMIRinner,                                      &
       &                     IF2%EMIRio,                                         &
       &                     IF2%EMIRouter                                       &
       &           /)                                                            !
  !
  !                                                                                  !! NCSstd
  ! *   derotator systems for HERA                                                   !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimDerotatorSystemChoices  =  4
  Integer, Parameter      :: iDerotFra      =  1       !   "frame"                   
  Integer, Parameter      :: iDerotSky      =  2       !   "sky"                     
  Integer, Parameter      :: iDerotHor      =  3       !   "horizontal"                 
  Integer, Parameter      :: iDerotEqu      =  4       !   "equatorial"              
  !
  Type :: derotatorSystemChoicesType
     Character(len=lenCh) ::       fra                 =   "frame"                 
     Character(len=lenCh) ::       sky                 =   "sky"                   
     Character(len=lenCh) ::       hor                 =   "horizontal"               
     Character(len=lenCh) ::       equ                 =   "equatorial"            
  End Type derotatorSystemChoicesType
  !
  Type (derotatorSystemChoicesType), Parameter ::                                 &  !! NCSstd
       &  derot =                                                                 &  !! NCSstd
       &                  derotatorSystemChoicesType (                            &  !! NCSstd
       &                                                   "frame     "    ,      &  !! NCSstd
       &                                                   "sky       "    ,      &  !! NCSstd
       &                                                   "horizontal"    ,      &  !! NCSstd
       &                                                   "equatorial"           &  !! NCSstd same as "sky"
       &                                             )                               !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimDerotatorSystemChoices), Parameter ::       &
       &  derotatorSystemChoices =                                                &
       &               (/                                                         &
       &                     derot%fra  ,                                         &
       &                     derot%sky  ,                                         &
       &                     derot%hor  ,                                         &
       &                     derot%equ                                            &
       &               /)
  !
  !                                                                                  !! NCSstd
  ! **  Bolometers                                                                   !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimBolometerChoices  =  4
  Integer, Parameter      :: imambo1        =  1       !   "MAMBO1"
  Integer, Parameter      :: imambo2        =  2       !   "MAMBO2"
  Integer, Parameter      :: iGISMO         =  3       !   "GISMO"
  Integer, Parameter      :: iNIKA          =  4       !   "NIKA" 
  !
  Type :: bolometerChoicesType
     Character(len=lenCh) ::  mambo1                   =   "MAMBO1" 
     Character(len=lenCh) ::  mambo2                   =   "MAMBO2"
     Character(len=lenCh) ::  GISMO                    =   "GISMO"
     Character(len=lenCh) ::  NIKA                     =   "NIKA" 
  End Type bolometerChoicesType
  !
  Type (bolometerChoicesType), Parameter ::                                      &  !! NCSstd
       &  bolo =                                                                 &  !! NCSstd
       &                        bolometerChoicesType (     "MAMBO1"     ,        &  !! NCSstd
       &                                                   "MAMBO2"     ,        &  !! NCSstd
       &                                                   "GISMO "     ,        &  !! NCSstd
       &                                                   "NIKA  "  )           !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimBolometerChoices), Parameter ::            &
       &  bolometerChoices =                                                     &
       &              (/ bolo%mambo1    ,                                        &
       &                 bolo%mambo2    ,                                        &
       &                 bolo%GISMO     ,                                        &
       &                 bolo%NIKA      /)                                       ! 
  !
  !                                                                                  !! NCSstd
  ! *** BACKENDS                                                                     !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimBackendChoices  =  10
  Integer, Parameter      :: iContinuum     =  1       !   "NBC"
  Integer, Parameter      :: iBBC           =  2       !   "BBC"
  Integer, Parameter      :: iFB4MHz        =  3       !   "4MHz"     
  Integer, Parameter      :: iFB1MHz        =  4       !   "1MHz"     
  Integer, Parameter      :: iFB100kHz      =  5       !   "100kHz"                  !! deprecated
  Integer, Parameter      :: iFTS           =  6       !   "FTS"
  Integer, Parameter      :: iWILMA         =  7       !   "WILMA"    
  Integer, Parameter      :: iVESPA         =  8       !   "VESPA"
  Integer, Parameter      :: iABBA          =  9       !   "ABBA"
  Integer, Parameter      :: iUSBack        = 10       !   "USB"
 
  !
  Type :: backendChoicesType
     Character(len=lenCh) ::  Continuum                =   "NBC"
     Character(len=lenCh) ::  BBC                      =   "BBC"      
     Character(len=lenCh) ::  FB4MHz                   =   "4MHz"     
     Character(len=lenCh) ::  FB1MHz                   =   "1MHz"     
     Character(len=lenCh) ::  FB100kHz                 =   "100kHz"   
     Character(len=lenCh) ::  FTS                      =   "FTS"
     Character(len=lenCh) ::  WILMA                    =   "WILMA"    
     Character(len=lenCh) ::  VESPA                    =   "VESPA"
     Character(len=lenCh) ::  ABBA                     =   "ABBA"
     Character(len=lenCh) ::  USB                      =   "USB"
  End Type backendChoicesType
  !
  Type (backendChoicesType), Parameter ::                                         &  !! NCSstd
       &  bac =                                                                   &  !! NCSstd
       &                          backendChoicesType (     "NBC   "      ,        &  !! NCSstd
       &                                                   "BBC   "      ,        &  !! NCSstd
       &                                                   "4MHz  "      ,        &  !! NCSstd
       &                                                   "1MHz  "      ,        &  !! NCSstd
       &                                                   "100kHz"      ,        &  !! deprecated
       &                                                   "FTS   "      ,        &  !! NCSstd
       &                                                   "WILMA "      ,        &  !! NCSstd
       &                                                   "VESPA "      ,        &  !! NCSstd
       &                                                   "ABBA  "      ,        &  !! NCSstd
       &                                                   "USB   "  )   ! for tests !! NCSstd 

  !
  Character(len=lenCh), Dimension(nDimBackendChoices), Parameter ::               &
       &  backendChoices =                                                        &
       &           (/     bac%Continuum ,                                         &
       &                  bac%BBC       ,                                         &
       &                  bac%FB4MHz    ,                                         &
       &                  bac%FB1MHz    ,                                         &
       &                  bac%FB100kHz  ,                                         &
       &                  bac%FTS       ,                                         &
       &                  bac%WILMA     ,                                         &
       &                  bac%VESPA     ,                                         &
       &                  bac%ABBA      ,                                         &
       &                  bac%USB       /)
  !
  !                                                                                  !! NCSstd
  ! *   backendModes (VESPA)                                                         !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimBEmodeChoices  =  3
  Integer, Parameter      :: iSimp          =  1       !   "simple"      
  Integer, Parameter      :: iPara          =  2       !   "parallel"    
  Integer, Parameter      :: iPola          =  3       !   "polarization"
  !
  Type :: BEmodeChoicesType
     Character(len=lenCh) ::  Simp                     =   "simple"      
     Character(len=lenCh) ::  Para                     =   "parallel"    
     Character(len=lenCh) ::  Pola                     =   "polarization"
  End Type BEmodeChoicesType
  !
  Type (BEmodeChoicesType), Parameter ::                                          &  !! NCSstd
       &  BEmode =                                                                &  !! NCSstd
       &                          BEmodeChoicesType (      "simple      ",        &  !! NCSstd
       &                                                   "parallel    ",        &  !! NCSstd
       &                                                   "polarization" )          !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimBEmodeChoices), Parameter ::                &
       &  BEmodeChoices =                                                         &
       &           (/  BEmode%Simp      ,                                         &
       &               BEmode%Para      ,                                         &
       &               BEmode%Pola      /)
  !
  ! *   FTS  backend                                                                 !! NCSstd                       
  ! *   FTS: resolutions (MHz)                                                       !! NCSstd
  !
  Integer, Parameter      :: nDimFTSChoices  =  4
  Integer, Parameter      :: iFTSfine        =  1
  Integer, Parameter      :: iFTSwide        =  2
  Integer, Parameter      :: iFTSfineHERA    =  3
  Integer, Parameter      :: iFTSwideHERA    =  4
  !
  ! style: line up in column: 30                            60                   81  85 88  
  !
  Type ::FTSresChoicesType
     Real(kind=kindDouble) :: fine         =  100.0D0/512.0/4.0                      !! fine / high resolution   EMIR
     Real(kind=kindDouble) :: wide         =  100.0D0/512.0                          !! wide / low  resolution   EMIR
     Real(kind=kindDouble) :: fineHERA     =  100.0D0/512.0/4.0                      !! fine / high resolution   HERA
     Real(kind=kindDouble) :: wideHERA     =  100.0D0/512.0                          !! wide / low  resolution   HERA
  End Type FTSresChoicesType
  !
  Type (FTSresChoicesType), Parameter ::                                         &   !! NCSstd
       &  FTSres =                                                               &   !! NCSstd
       &                   FTSresChoicesType (                                   &   !! NCSstd
       &                                        100.0D0/512.0/4.0,               &   !! NCSstd fine / high resolution   EMIR
       &                                        100.0D0/512.0,                   &   !! NCSstd wide / low  resolution   EMIR
       &                                        100.0D0/512.0/4.0,               &   !! NCSstd fine / high resolution   HERA
       &                                        100.0D0/512.0                    &   !! NCSstd wide / low  resolution   HERA
       &                                     )                                   !   !! NCSstd
  !
  Real(kind=kindDouble), Dimension(nDimFTSChoices), Parameter ::                 &
       &  FTSresChoices =                                                        &
       &           (/  FTSres%fine,                                              &
       &               FTSres%wide,                                              &
       &               FTSres%fineHERA,                                          &
       &               FTSres%wideHERA                                           &
       &           /)                                                            !
  !
  ! *   FTS: maximum bandwidths (MHz)                                                !! NCSstd
  !
  Type ::FTSbwChoicesType
     Real(kind=kindDouble) :: fine           =  1820.0D0                             !! fine / high resolution   EMIR
     Real(kind=kindDouble) :: wide           =  4050.0D0                             !! wide / low  resolution   EMIR
     Real(kind=kindDouble) :: fineHERA       =   512.0D0                             !! fine / high resolution   HERA
     Real(kind=kindDouble) :: wideHERA       =  1024.0D0                             !! wide / low  resolution   HERA
  End Type FTSbwChoicesType
  !
  Type (FTSbwChoicesType), Parameter ::                                          &   !! NCSstd
       &  FTSbw =                                                                &   !! NCSstd
       &                     FTSbwChoicesType (                                  &   !! NCSstd
       &                                        1820.0D0,                        &   !! NCSstd fine / high resolution   EMIR
       &                                        4050.0D0,                        &   !! NCSstd wide / low  resolution   EMIR
       &                                         512.0D0,                        &   !! NCSstd fine / high resolution   HERA
       &                                        1024.0D0                         &   !! NCSstd wide / low  resolution   HERA
       &                                     )                                   !   !! NCSstd
  !
  Real(kind=kindDouble), Dimension(nDimFTSChoices), Parameter ::                 &
       &  FTSbwChoices =                                                         &
       &           (/   FTSbw%fine,                                              &
       &                FTSbw%wide,                                              &
       &                FTSbw%fineHERA,                                          &
       &                FTSbw%wideHERA                                           &
       &           /)                                                            !
  !
  !                                                                                  !! NCSstd
  ! *** SWITCHING MODES                                                              !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimSwModeChoices  =  4
  Integer, Parameter      :: iSwTotal       =  1       !   "totalPower"        
  Integer, Parameter      :: iSwBeam        =  2       !   "beamSwitching"     
  Integer, Parameter      :: iSwWobb        =  3       !   "wobblerSwitching"  
  Integer, Parameter      :: iSwFreq        =  4       !   "frequencySwitching"
  !
  Type :: swModeChoicesType
     Character(len=lenCh) ::    Total                  =   "totalPower"        
     Character(len=lenCh) ::    Beam                   =   "beamSwitching"     
     Character(len=lenCh) ::    Wobb                   =   "wobblerSwitching"  
     Character(len=lenCh) ::    Freq                   =   "frequencySwitching"
  End Type swModeChoicesType
  !
  Type (swModeChoicesType), Parameter ::                                          &  !! NCSstd
       &  swMode =                                                                &  !! NCSstd
       &                          swModeChoicesType (      "totalPower        " , &  !! NCSstd
       &                                                   "beamSwitching     " , &  !! NCSstd
       &                                                   "wobblerSwitching  " , &  !! NCSstd
       &                                                   "frequencySwitching" )    !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimswModeChoices), Parameter ::                &
       &  swModeChoices =                                                         &
       &           (/    swMode%Total     ,                                       &
       &                 swMode%Beam      ,                                       &
       &                 swMode%Wobb      ,                                       &
       &                 swMode%Freq      /)
  !
  Type (swModeChoicesType), Parameter ::                                          &  !! NCSstd
       &  swModePako =                                                            &  !! NCSstd
       &                          swModeChoicesType (      "swTotal    "        , &  !! NCSstd
       &                                                   "swBeam     "        , &  !! NCSstd
       &                                                   "swWobbler  "        , &  !! NCSstd
       &                                                   "swFrequency" )           !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimswModeChoices), Parameter ::                &
       &  swModeChoicesPako =                                                     &
       &           (/    swModePako%Total     ,                                   &
       &                 swModePako%Beam      ,                                   &
       &                 swModePako%Wobb      ,                                   &
       &                 swModePako%Freq      /)
  !
  !                                                                                  !! 
  ! *** paKo COMMANDS (for SAVE etc.)                                                !! 
  !                                                                                  !! 
  ! style: line up in column: 30                            60                       85 88
  !
  !TBD: add "STOP"
  !
  Integer, Parameter      :: nDimCOMChoices  = 32
  Integer, Parameter      :: iComCal         =  1       !  "calibrate"  
  Integer, Parameter      :: iComPointing    =  2       !  "pointing"   
  Integer, Parameter      :: iComFocus       =  3       !  "focus"      
  Integer, Parameter      :: iComTip         =  4       !  "tip"        
  Integer, Parameter      :: iComTrack       =  5       !  "track"      
  Integer, Parameter      :: iComOnOff       =  6       !  "onOff"      
  Integer, Parameter      :: iComOtfMap      =  7       !  "OTFmap"     
  Integer, Parameter      :: iComRaster      =  8       !  "raster"     
  Integer, Parameter      :: iComOtfTip      =  9       !  "OTFtip"     
  Integer, Parameter      :: iComCross       = 10       !  "crossRaster"
  Integer, Parameter      :: iComOtfCross    = 11       !  "OTFcross"   
  Integer, Parameter      :: iComOtfFocus    = 12       !  "OTFfocus"   
  Integer, Parameter      :: iComVLBI        = 13       !  "VLBI"       
  Integer, Parameter      :: iCombackend     = 14       !  "backend"    
  Integer, Parameter      :: iComcatalog     = 15       !  "catalog"    
  Integer, Parameter      :: iComoffsets     = 16       !  "offsets"    
  Integer, Parameter      :: iComsegment     = 17       !  "segment"    
  Integer, Parameter      :: iComsubscan     = 18       !  "subscan"    
  Integer, Parameter      :: iComreceiver    = 19       !  "receiver"   
  Integer, Parameter      :: iComsave        = 20       !  "save"       
  Integer, Parameter      :: iComset         = 21       !  "set"        
  Integer, Parameter      :: iComshow        = 22       !  "show"       
  Integer, Parameter      :: iComsource      = 23       !  "source"     
  Integer, Parameter      :: iComswBeam      = 24       !  "swBeam"     
  Integer, Parameter      :: iComswFrequency = 25       !  "swFrequency"
  Integer, Parameter      :: iComswTotal     = 26       !  "swTotal"    
  Integer, Parameter      :: iComswWobbler   = 27       !  "swWobbler"  
  Integer, Parameter      :: iComswitching   = 28       !  "switching"  
  Integer, Parameter      :: iComoptions     = 29       !  "options"    
  Integer, Parameter      :: iComall         = 30       !  "all"        
  Integer, Parameter      :: iComDIY         = 31       !  "DIY"        
  Integer, Parameter      :: iComLissajous   = 32       !  "Lissajous"        
  !
  Type :: COMChoicesType
     Character(len=lenCh) ::     Cal                    =  "calibrate"    
     Character(len=lenCh) ::     Pointing               =  "pointing"     
     Character(len=lenCh) ::     Focus                  =  "focus"        
     Character(len=lenCh) ::     Tip                    =  "tip"          
     Character(len=lenCh) ::     Track                  =  "track"        
     Character(len=lenCh) ::     OnOff                  =  "onOff"        
     Character(len=lenCh) ::     OtfMap                 =  "onTheFlyMap"  
     Character(len=lenCh) ::     Raster                 =  "raster"       
     Character(len=lenCh) ::     OtfTip                 =  "onTheFlyTip"  
     Character(len=lenCh) ::     Cross                  =  "crossRaster"  
     Character(len=lenCh) ::     OtfCross               =  "onTheFlyCross"
     Character(len=lenCh) ::     OtfFocus               =  "onTheFlyFocus"
     Character(len=lenCh) ::     VLBI                   =  "VLBI"
     Character(len=lenCh) ::     backend                =  "backend"    
     Character(len=lenCh) ::     catalog                =  "catalog"    
     Character(len=lenCh) ::     offsets                =  "offsets"    
     Character(len=lenCh) ::     segment                =  "segment"    
     Character(len=lenCh) ::     subscan                =  "subscan"    
     Character(len=lenCh) ::     receiver               =  "receiver"   
     Character(len=lenCh) ::     save                   =  "save"       
     Character(len=lenCh) ::     set                    =  "set"        
     Character(len=lenCh) ::     show                   =  "show"       
     Character(len=lenCh) ::     source                 =  "source"     
     Character(len=lenCh) ::     swBeam                 =  "swBeam"     
     Character(len=lenCh) ::     swFrequency            =  "swFrequency"
     Character(len=lenCh) ::     swTotal                =  "swTotal"    
     Character(len=lenCh) ::     swWobbler              =  "swWobbler"  
     Character(len=lenCh) ::     switching              =  "switching"  
     Character(len=lenCh) ::     options                =  "options"    
     Character(len=lenCh) ::     all                    =  "all"        
     Character(len=lenCh) ::     DIY                    =  "DIY"        
     Character(len=lenCh) ::     Lissajous              =  "Lissajous"        
  End Type COMChoicesType
  !
  ! **  
  !
  Type (COMChoicesType), Parameter ::                                             &  
       &  COMpako =                                                               &  
       &                        COMChoicesType (           "calibrate  "   ,      &  
       &                                                   "pointing   "   ,      &  
       &                                                   "focus      "   ,      &  
       &                                                   "tip        "   ,      &  
       &                                                   "track      "   ,      &  
       &                                                   "onOff      "   ,      &  
       &                                                   "OTFmap     "   ,      &  
       &                                                   "raster     "   ,      &  
       &                                                   "OTFtip     "   ,      &  
       &                                                   "crossRaster"   ,      &  
       &                                                   "OTFcross   "   ,      &  
       &                                                   "OTFfocus   "   ,      &  
       &                                                   "VLBI       "   ,      &
       &                                                   "backend    "   ,      &
       &                                                   "catalog    "   ,      &
       &                                                   "offsets    "   ,      &
       &                                                   "segment    "   ,      &
       &                                                   "subscan    "   ,      &
       &                                                   "receiver   "   ,      &
       &                                                   "save       "   ,      &
       &                                                   "set        "   ,      &
       &                                                   "show       "   ,      &
       &                                                   "source     "   ,      &
       &                                                   "swBeam     "   ,      &
       &                                                   "swFrequency"   ,      &
       &                                                   "swTotal    "   ,      &
       &                                                   "swWobbler  "   ,      &
       &                                                   "switching  "   ,      &
       &                                                   "options    "   ,      &
       &                                                   "all        "   ,      &
       &                                                   "DIY        "   ,      &
       &                                                   "Lissajous  "   )      !
  !
  Character(len=lenCh), Dimension(nDimCOMChoices), Parameter ::                   &
       &  COMChoicesPako =                                                        &
       &           (/         COMpako%Cal             ,                           &
       &                      COMpako%Pointing        ,                           &
       &                      COMpako%Focus           ,                           &
       &                      COMpako%Tip             ,                           &
       &                      COMpako%Track           ,                           &
       &                      COMpako%OnOff           ,                           &
       &                      COMpako%OtfMap          ,                           &
       &                      COMpako%Raster          ,                           &
       &                      COMpako%OtfTip          ,                           &
       &                      COMpako%Cross           ,                           &
       &                      COMpako%OtfCross        ,                           &
       &                      COMpako%OtfFocus        ,                           &
       &                      COMpako%VLBI            ,                           &
       &                      COMpako%backend         ,                           &
       &                      COMpako%catalog         ,                           &
       &                      COMpako%offsets         ,                           &
       &                      COMpako%segment         ,                           &
       &                      COMpako%subscan         ,                           &
       &                      COMpako%receiver        ,                           &
       &                      COMpako%save            ,                           &
       &                      COMpako%set             ,                           &
       &                      COMpako%show            ,                           &
       &                      COMpako%source          ,                           &
       &                      COMpako%swBeam          ,                           &
       &                      COMpako%swFrequency     ,                           &
       &                      COMpako%swTotal         ,                           &
       &                      COMpako%swWobbler       ,                           &
       &                      COMpako%switching       ,                           &
       &                      COMpako%options         ,                           &
       &                      COMpako%all             ,                           &
       &                      COMpako%DIY             ,                           &
       &                      COMpako%Lissajous                                   &
       &                                             /)                           !

  !
  !                                                                                  !! NCSstd
  ! *** OBSERVING MODES                                                              !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimOMChoices  =  16
  Integer, Parameter      :: iOmCal         =  1       !   "calibrate"    
  Integer, Parameter      :: iOmPointing    =  2       !   "pointing"     
  Integer, Parameter      :: iOmFocus       =  3       !   "focus"        
  Integer, Parameter      :: iOmTip         =  4       !   "tip"          
  Integer, Parameter      :: iOmTrack       =  5       !   "track"        
  Integer, Parameter      :: iOmOnOff       =  6       !   "onOff"        
  Integer, Parameter      :: iOmOtfMap      =  7       !   "onTheFlyMap"  
  Integer, Parameter      :: iOmRaster      =  8       !   "raster"       
  Integer, Parameter      :: iOmOtfTip      =  9       !   "onTheFlyTip"  
  Integer, Parameter      :: iOmCross       = 10       !   "crossRaster"  
  Integer, Parameter      :: iOmOtfCross    = 11       !   "onTheFlyCross"
  Integer, Parameter      :: iOmOtfFocus    = 12       !   "onTheFlyFocus"
  Integer, Parameter      :: iOmVLBI        = 13       !   "VLBI"
  Integer, Parameter      :: iOmSubscanList = 14       !   "subscanList"
  Integer, Parameter      :: iOmDIY         = 15       !   "DIY"
  Integer, Parameter      :: iOmLissajous   = 16       !   "Lissajous"
  !
  Type :: OMChoicesType
     Character(len=lenCh) ::    Cal                    =   "calibrate"    
     Character(len=lenCh) ::    Pointing               =   "pointing"     
     Character(len=lenCh) ::    Focus                  =   "focus"        
     Character(len=lenCh) ::    Tip                    =   "tip"          
     Character(len=lenCh) ::    Track                  =   "track"        
     Character(len=lenCh) ::    OnOff                  =   "onOff"        
     Character(len=lenCh) ::    OtfMap                 =   "onTheFlyMap"  
     Character(len=lenCh) ::    Raster                 =   "raster"       
     Character(len=lenCh) ::    OtfTip                 =   "onTheFlyTip"  
     Character(len=lenCh) ::    Cross                  =   "crossRaster"  
     Character(len=lenCh) ::    OtfCross               =   "onTheFlyCross"
     Character(len=lenCh) ::    OtfFocus               =   "onTheFlyFocus"
     Character(len=lenCh) ::    VLBI                   =   "VLBI"
     Character(len=lenCh) ::    SubscanList            =   "subscanList"
     Character(len=lenCh) ::    DIY                    =   "DIY"
     Character(len=lenCh) ::    Lissajous              =   "Lissajous"
  End Type OMChoicesType
  !
  Type (OMChoicesType), Parameter ::                                              &  !! NCSstd
       &  OM =                                                                    &  !! NCSstd
       &                        OMChoicesType (            "calibrate    " ,      &  !! NCSstd
       &                                                   "pointing     " ,      &  !! NCSstd
       &                                                   "focus        " ,      &  !! NCSstd
       &                                                   "tip          " ,      &  !! NCSstd
       &                                                   "track        " ,      &  !! NCSstd
       &                                                   "onOff        " ,      &  !! NCSstd
       &                                                   "onTheFlyMap  " ,      &  !! NCSstd
       &                                                   "raster       " ,      &  !! NCSstd ! TBD soon   
       &                                                   "onTheFlyTip  " ,      &  !! NCSstd ! TBD soon ?  
       &                                                   "crossRaster  " ,      &  !! NCSstd ! future
       &                                                   "onTheFlyCross" ,      &  !! NCSstd ! future   
       &                                                   "onTheFlyFocus" ,      &  !! NCSstd ! future?
       &                                                   "VLBI         " ,      &  !! NCSstd
       &                                                   "subscanList  " ,      &  !! NCSstd
       &                                                   "DIY          " ,      &  !! NCSstd
       &                                                   "Lissajous    " )      !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimOMChoices), Parameter ::                    &
       &  OMChoices =                                                             &
       &           (/        OM%Cal                 ,                             &
       &                     OM%Pointing            ,                             &
       &                     OM%Focus               ,                             &
       &                     OM%Tip                 ,                             &
       &                     OM%Track               ,                             &
       &                     OM%OnOff               ,                             &
       &                     OM%OtfMap              ,                             &
       &                     OM%Raster              ,                             &
       &                     OM%OtfTip              ,                             &
       &                     OM%Cross               ,                             &
       &                     OM%OtfCross            ,                             &
       &                     OM%OtfFocus            ,                             &
       &                     OM%VLBI                ,                             &
       &                     OM%subscanList         ,                             &
       &                     OM%DIY                 ,                             &
       &                     OM%Lissajous           /)                            !
  !
  ! **  the following is a variation corresponding to the paKo commands:
  !
  Type (OMChoicesType), Parameter ::                                              &  
       &  OMpako =                                                                &  
       &                        OMChoicesType (            "calibrate  "   ,      &  
       &                                                   "pointing   "   ,      &  
       &                                                   "focus      "   ,      &  
       &                                                   "tip        "   ,      &  
       &                                                   "track      "   ,      &  
       &                                                   "onOff      "   ,      &  
       &                                                   "OTFmap     "   ,      &  
       &                                                   "raster     "   ,      &  
       &                                                   "OTFtip     "   ,      &  
       &                                                   "crossRaster"   ,      &  
       &                                                   "OTFcross   "   ,      &  
       &                                                   "OTFfocus   "   ,      &  
       &                                                   "VLBI       "   ,      &  
       &                                                   "subscanList"   ,      &  
       &                                                   "DIY        "   ,      &  
       &                                                   "Lissajous  "   )      !  
  !
  Character(len=lenCh), Dimension(nDimOMChoices), Parameter ::                    &
       &  OMChoicesPako =                                                         &
       &           (/        OMpako%Cal             ,                             &
       &                     OMpako%Pointing        ,                             &
       &                     OMpako%Focus           ,                             &
       &                     OMpako%Tip             ,                             &
       &                     OMpako%Track           ,                             &
       &                     OMpako%OnOff           ,                             &
       &                     OMpako%OtfMap          ,                             &
       &                     OMpako%Raster          ,                             &
       &                     OMpako%OtfTip          ,                             &
       &                     OMpako%Cross           ,                             &
       &                     OMpako%OtfCross        ,                             &
       &                     OMpako%OtfFocus        ,                             &
       &                     OMpako%VLBI            ,                             &
       &                     OMpako%subscanList     ,                             &
       &                     OMpako%DIY             ,                             &
       &                     OMpako%Lissajous       /)                            !

  !                                                                                  !! NCSstd
  ! *** choices for Purpose                                                          !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimPurposeChoices  =  5
  Integer, Parameter      :: iPurposeCal         =  1       !   "calibrate"    
  Integer, Parameter      :: iPurposePointing    =  2       !   "pointing"     
  Integer, Parameter      :: iPurposeFocus       =  3       !   "focus"        
  Integer, Parameter      :: iPurposeTip         =  4       !   "tip"          
  Integer, Parameter      :: iPurposeMap         =  5       !   "map"          
  !
  Type :: PurposeChoicesType
     Character(len=lenCh) ::         Cal                    =   "calibrate"
     Character(len=lenCh) ::         Pointing               =   "pointing" 
     Character(len=lenCh) ::         Focus                  =   "focus"    
     Character(len=lenCh) ::         Tip                    =   "tip"      
     Character(len=lenCh) ::         Map                    =   "map"      
  End Type PurposeChoicesType
  !
  Type (PurposeChoicesType), Parameter ::                                        &  !! NCSstd
       &  Purpose =                                                              &  !! NCSstd
       &                        PurposeChoicesType (            "calibrate"  ,   &  !! NCSstd
       &                                                        "pointing "  ,   &  !! NCSstd
       &                                                        "focus    "  ,   &  !! NCSstd
       &                                                        "tip      "  ,   &  !! NCSstd
       &                                                        "map      "  )   !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimPurposeChoices), Parameter ::              &
       &  PurposeChoices =                                                       &
       &           (/        Purpose%Cal                 ,                       &
       &                     Purpose%Pointing            ,                       &
       &                     Purpose%Focus               ,                       &
       &                     Purpose%Tip                 ,                       &
       &                     Purpose%Map                 /)                      !
  !

  !
  !                                                                                  !! NCSstd
  ! **  Subscans                                                                     !! NCSstd
  !                                                                                  !! NCSstd
  !
    Integer, Parameter      :: nDimSubscanChoices  =  14
  Integer, Parameter      :: iSSca          =  1       !   "calAmbient"  
  Integer, Parameter      :: iSScc          =  2       !   "calCold"     
  Integer, Parameter      :: iSScs          =  3       !   "calSky"      
  Integer, Parameter      :: iSScp          =  4       !   "calPaddle"   
  Integer, Parameter      :: iSSam          =  5       !   "airmass"     
  Integer, Parameter      :: iSSonFocus     =  6       !   "onFocus"     
  Integer, Parameter      :: iSStrack       =  7       !   "track"       
  Integer, Parameter      :: iSSotf         =  8       !   "onTheFly"    
  Integer, Parameter      :: iSSon          =  9       !   "on"          
  Integer, Parameter      :: iSSref         = 10       !   "reference" 
  Integer, Parameter      :: iSSVLBI        = 11       !   "VLBI" 
  Integer, Parameter      :: iSScg          = 12       !   "calGrid"  
  Integer, Parameter      :: iSSse          = 13       !   "slewElevation"
  Integer, Parameter      :: iSStune        = 14       !   "tune"
  !
  Type :: subscanChoicesType
     Character(len=lenCh) ::    ca                     =   "calAmbient"
     Character(len=lenCh) ::    cc                     =   "calCold"     
     Character(len=lenCh) ::    cs                     =   "calSky"      
     Character(len=lenCh) ::    cp                     =   "calPaddle"   
     Character(len=lenCh) ::    am                     =   "airmass"   
     Character(len=lenCh) ::    onFocus                =   "onFocus"     
     Character(len=lenCh) ::    track                  =   "track"       
     Character(len=lenCh) ::    otf                    =   "onTheFly"    
     Character(len=lenCh) ::    on                     =   "on"            
     Character(len=lenCh) ::    ref                    =   "reference" 
     Character(len=lenCh) ::    VLBI                   =   "VLBI"
     Character(len=lenCh) ::    cg                     =   "calGrid"
     Character(len=lenCh) ::    se                     =   "slewElevation"
     Character(len=lenCh) ::    tune                   =   "tune"
  End Type subscanChoicesType
  !
  Type (subscanChoicesType), Parameter ::                                         &  !! NCSstd
       &  ss =                                                                    &  !! NCSstd
       &                          subscanChoicesType (     "calAmbient   ",       &  !! NCSstd
       &                                                   "calCold      ",       &  !! NCSstd
       &                                                   "calSky       ",       &  !! NCSstd
       &                                                   "calPaddle    ",       &  !! NCSstd
       &                                                   "airmass      ",       &  !! NCSstd
       &                                                   "onFocus      ",       &  !! NCSstd
       &                                                   "track        ",       &  !! NCSstd
       &                                                   "onTheFly     ",       &  !! NCSstd
       &                                                   "on           ",       &  !! NCSstd
       &                                                   "reference    ",       &  !! NCSstd
       &                                                   "VLBI         ",       &  !! NCSstd
       &                                                   "calGrid      ",       &  !! NCSstd
       &                                                   "slewElevation",       &  !! NCSstd
       &                                                   "tune         ")       !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimSubscanChoices), Parameter ::               &
       &  subscanChoices =                                                        &
       &                (/   ss%ca      ,                                         &
       &                     ss%cc      ,                                         &
       &                     ss%cs      ,                                         &
       &                     ss%cp      ,                                         &
       &                     ss%am      ,                                         &
       &                     ss%onFocus ,                                         &
       &                     ss%track   ,                                         &
       &                     ss%otf     ,                                         &
       &                     ss%on      ,                                         &
       &                     ss%ref     ,                                         &
       &                     ss%VLBI    ,                                         &
       &                     ss%cg      ,                                         &
       &                     ss%se      ,                                         &
       &                     ss%tune   /)                                         !
  !
  !                                                                                  !! NCSstd
  ! **  Segments (sub-units of OTF subscans)                                         !! NCSstd     
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimSegmentChoices  =  5
  Integer, Parameter      :: iSegtrack      =  1       !   "track" 
  Integer, Parameter      :: iSeglinear     =  2       !   "linear"
  Integer, Parameter      :: iSegcircle     =  3       !   "circle"
  Integer, Parameter      :: iSegcurve      =  4       !   "curve" 
  Integer, Parameter      :: iSegLissajous  =  5       !   "lissajous" 
  !
  Type :: segmentChoicesType
     Character(len=lenCh) ::     track                 =   "track" 
     Character(len=lenCh) ::     linear                =   "linear"
     Character(len=lenCh) ::     circle                =   "circle"
     Character(len=lenCh) ::     curve                 =   "curve" 
     Character(len=lenCh) ::     lissajous             =   "lissajous" 
  End Type segmentChoicesType
  !
  Type (segmentChoicesType), Parameter ::                                         &  !! NCSstd
       &  seg =                                                                   &  !! NCSstd
       &                          segmentChoicesType (     "track    "   ,        &  !! NCSstd
       &                                                   "linear   "   ,        &  !! NCSstd
       &                                                   "circle   "   ,        &  !! NCSstd  TBD later
       &                                                   "curve    "   ,        &  !! NCSstd  TBD later
       &                                                   "lissajous"  )         !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimSegmentChoices), Parameter ::               &
       &  segmentChoices =                                                        &
       &                (/   seg%track   ,                                        &
       &                     seg%linear  ,                                        &
       &                     seg%circle  ,                                        &
       &                     seg%curve   ,                                        &
       &                     seg%lissajous   /)                                   !
  !
  !                                                                                  !! NCSstd
  ! **  ramp (at start and end of OTF subscans)                                      !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimRampChoices  =  4
  Integer, Parameter      :: irampUp     =  1         !   "Up"       
  Integer, Parameter      :: irampDown   =  2         !   "Down"
  Integer, Parameter      :: irampBoth   =  3         !   "Both"  
  Integer, Parameter      :: irampNone   =  4         !   "none"
  !
  Type :: rampChoicesType
     Character(len=lenCh) ::      Up                  =   "Up"  
     Character(len=lenCh) ::      Down                =   "Down"
     Character(len=lenCh) ::      Both                =   "Both"  
     Character(len=lenCh) ::      None                =   "none"
  End Type rampChoicesType
  !
  Type (rampChoicesType), Parameter ::                                           &  !! NCSstd
       &  ramp =                                                                 &  !! NCSstd
       &                          rampChoicesType (       "Up  "       ,         &  !! NCSstd
       &                                                  "Down"       ,         &  !! NCSstd
       &                                                  "Both"       ,         &  !! NCSstd
       &                                                  "none"       )         !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimrampChoices), Parameter ::                 &
       &  rampChoices =                                                          &
       &              (/     ramp%Up  ,                                          &
       &                     ramp%Down ,                                         &
       &                     ramp%Both ,                                         &
       &                     ramp%None  /)                                       !
  !
  !                                                                                  !! NCSstd
  ! **  traceFlag (to flag "on" and "reference" in segments of OTF subscans)         !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimtraceflagChoices  =  3
  Integer, Parameter      :: itraceOn     =  1         !   "on"       
  Integer, Parameter      :: itraceRef    =  2         !   "reference"
  Integer, Parameter      :: itraceNone   =  3         !   "none"
  !
  Type :: traceflagChoicesType
     Character(len=lenCh) ::       on                  =   "on"       
     Character(len=lenCh) ::       ref                 =   "reference"
     Character(len=lenCh) ::       none                =   "none"
  End Type traceflagChoicesType
  !
  Type (traceflagChoicesType), Parameter ::                                       &  !! NCSstd
       &  traceflag =                                                             &  !! NCSstd
       &                          traceflagChoicesType (   "on       "  ,         &  !! NCSstd
       &                                                   "reference"  ,         &  !! NCSstd
       &                                                   "none     "  )            !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimtraceflagChoices), Parameter ::             &
       &  traceflagChoices =                                                      &
       &              (/ traceflag%on   ,                                         &
       &                 traceflag%ref  ,                                         &
       &                 traceflag%none  /)
  !
  !                                                                                  !! NCSstd
  ! *** UNITS                                                                        !! NCSstd
  ! *   units for angles                                                             !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimAngleChoices  =  7
  Integer, Parameter      :: iradian        =  1       !      
  Integer, Parameter      :: iarcsec        =  2       !   
  Integer, Parameter      :: iarcmin        =  3       !   
  Integer, Parameter      :: idegree        =  4       !    
  Integer, Parameter      :: isecond        =  5       !   
  Integer, Parameter      :: iminute        =  6       !   
  Integer, Parameter      :: ihour          =  7       !      
  !
  Type :: angleChoicesType
     Character(len=lenCh) ::  radian                   =   "radian"   
     Character(len=lenCh) ::  arcsec                   =   "arcsec"
     Character(len=lenCh) ::  arcmin                   =   "arcmin"
     Character(len=lenCh) ::  degree                   =   "degree"
     Character(len=lenCh) ::  second                   =   "second"     
     Character(len=lenCh) ::  minute                   =   "minute"     
     Character(len=lenCh) ::  hour                     =   "hour"     
  End Type angleChoicesType
  !
  Type (angleChoicesType), Parameter ::                                           &  !! 
       &  au =                                                                    &  !! 
       &                            angleChoicesType (     "radian"  ,            &  !! 
       &                                                   "arcsec"  ,            &  !! 
       &                                                   "arcmin"  ,            &  !! 
       &                                                   "degree"  ,            &  !! 
       &                                                   "second"  ,            &  !! 
       &                                                   "minute"  ,            &  !! 
       &                                                   "hour  "  )               !! 
  !
  Character(len=lenCh), Dimension(nDimAngleChoices), Parameter ::                &
       &  angleChoices =                                                         &
       &                (/ au%radian ,                                           &
       &                   au%arcsec ,                                           &
       &                   au%arcmin ,                                           &
       &                   au%degree ,                                           &
       &                   au%second ,                                           &
       &                   au%minute ,                                           &
       &                   au%hour   /)
  !
  Real (Kind=kindDouble), Dimension(nDimAngleChoices), Parameter ::              &
       &  auConv =                                                               &
       &                (/    radian    ,                                        &
       &                      arcsec    ,                                        &
       &                      arcmin    ,                                        &
       &                      degree    ,                                        &
       &                      second    ,                                        &
       &                      minute    ,                                        &
       &                      hour      /)
  !
  !  -- following are our XML conventions (~VOTable)                                 !! NCSstd
  Type (angleChoicesType), Parameter ::                                           &  !! NCSstd
       &  auXML =                                                                 &  !! NCSstd
       &                            angleChoicesType (     "rad   "    ,          &  !! NCSstd
       &                                                   "arcsec"    ,          &  !! NCSstd
       &                                                   "arcmin"    ,          &  !! NCSstd
       &                                                   "deg   "    ,          &  !! NCSstd
       &                                                   "s     "    ,          &  !! NCSstd
       &                                                   "min   "    ,          &  !! NCSstd
       &                                                   "h     "    )             !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimAngleChoices), Parameter ::                &
       &  angleChoicesXML =                                                      &
       &             (/ auXML%radian ,                                           &
       &                auXML%arcsec ,                                           &
       &                auXML%arcmin ,                                           &
       &                auXML%degree ,                                           &
       &                auXML%second ,                                           &
       &                auXML%minute ,                                           &
       &                auXML%hour   /)
  !
  !                                                                                  !! NCSstd
  ! *   units for angular speeds                                                     !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimSpeedChoices  =  nDimAngleChoices
  ! NB: indices i* are the same as for  angle units above
  !
  Type :: speedChoicesType
     Character(len=lenCh) ::  radian                   =   "radian/s"   
     Character(len=lenCh) ::  arcsec                   =   "arcsec/s"
     Character(len=lenCh) ::  arcmin                   =   "arcmin/s"
     Character(len=lenCh) ::  degree                   =   "degree/s"
     Character(len=lenCh) ::  second                   =   "second/s"     
     Character(len=lenCh) ::  minute                   =   "minute/s"     
     Character(len=lenCh) ::  hour                     =   "hour/s"     
  End Type speedChoicesType
  !
  Type (speedChoicesType), Parameter ::                                           &  !! 
       &  su =                                                                    &  !! 
       &                            speedChoicesType (     "radian/s"  ,          &  !! 
       &                                                   "arcsec/s"  ,          &  !! 
       &                                                   "arcmin/s"  ,          &  !! 
       &                                                   "degree/s"  ,          &  !! 
       &                                                   "second/s"  ,          &  !! 
       &                                                   "minute/s"  ,          &  !! 
       &                                                   "hour/s  "   )            !! 
  !
  !  -- following are our XML conventions (~VOTable)                                 !! NCSstd
  Type (speedChoicesType), Parameter ::                                           &  !! NCSstd
       &  suXML =                                                                 &  !! NCSstd
       &                            speedChoicesType (     "rad/s   "  ,          &  !! NCSstd
       &                                                   "arcsec/s"  ,          &  !! NCSstd
       &                                                   "arcmin/s"  ,          &  !! NCSstd
       &                                                   "deg/s   "  ,          &  !! NCSstd
       &                                                   "s/s     "  ,          &  !! NCSstd
       &                                                   "min/s   "  ,          &  !! NCSstd
       &                                                   "h/s     "  )             !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimSpeedChoices), Parameter ::                &
       &  speedChoices =                                                         &
       &                (/ su%radian ,                                           &
       &                   su%arcsec ,                                           &
       &                   su%arcmin ,                                           &
       &                   su%degree ,                                           &
       &                   su%second ,                                           &
       &                   su%minute ,                                           &
       &                   su%hour   /)
  !
  Character(len=lenCh), Dimension(nDimSpeedChoices), Parameter ::                &
       &  speedChoicesXML =                                                      &
       &             (/ suXML%radian ,                                           &
       &                suXML%arcsec ,                                           &
       &                suXML%arcmin ,                                           &
       &                suXML%degree ,                                           &
       &                suXML%second ,                                           &
       &                suXML%minute ,                                           &
       &                suXML%hour   /)
  !
  !                                                                                  !! NCSstd
  ! *   units for Frequencies                                                        !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimFrequencyChoices  =  5
  Integer, Parameter      :: iTHz           =  1       !   "THz"
  Integer, Parameter      :: iGHz           =  2       !   "GHz"   
  Integer, Parameter      :: iMHz           =  3       !   "MHz"   
  Integer, Parameter      :: ikHz           =  4       !   "kHz"   
  Integer, Parameter      :: iHz            =  5       !   "Hz" 
  !                                                         
  Type :: frequencyChoicesType
     Character(len=lench) ::  THz                      =   "THz"
     Character(len=lench) ::  GHz                      =   "GHz"
     Character(len=lench) ::  MHz                      =   "MHz"
     Character(len=lench) ::  kHz                      =   "kHz"
     Character(len=lench) ::  Hz                       =   "Hz" 
  End Type frequencyChoicesType
  !
  Type (frequencyChoicesType), Parameter ::                                       &  !! NCSstd
       &  FU =                                                                    &  !! NCSstd
       &                        frequencyChoicesType (     "THz"      ,           &  !! NCSstd
       &                                                   "GHz"      ,           &  !! NCSstd
       &                                                   "MHz"      ,           &  !! NCSstd
       &                                                   "kHz"      ,           &  !! NCSstd
       &                                                   "Hz " )                   !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimFrequencyChoices), Parameter ::            &
       &  frequencyChoices =                                                     &
       &                (/ fu%THz ,                                              &
       &                   fu%GHz ,                                              &
       &                   fu%MHz ,                                              &
       &                   fu%kHz ,                                              &
       &                   fu%Hz  /)
  !
  !
  !                                                                                  !! NCSstd
  ! *** SOURCES:                                                                     !! NCSstd
  ! **  Planets                                                                      !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimPlanetChoices  = 10
  Integer, Parameter      :: imercury       =  1       !   "Mercury"
  Integer, Parameter      :: ivenus         =  2       !   "Venus"  
  Integer, Parameter      :: iearth         =  3       !   "Earth"  
  Integer, Parameter      :: imars          =  4       !   "Mars"   
  Integer, Parameter      :: ijupiter       =  5       !   "Jupiter"
  Integer, Parameter      :: iuranus        =  6       !   "Saturn" 
  Integer, Parameter      :: isaturn        =  7       !   "Uranus" 
  Integer, Parameter      :: ineptune       =  8       !   "Neptune"
  Integer, Parameter      :: ipluto         =  9       !   "Pluto"  
  Integer, Parameter      :: isun           = 10       !   "Sun"    
  !
  Type :: planetChoicesType
     Character(len=lenCh) ::  mercury                  =   "Mercury"
     Character(len=lenCh) ::  venus                    =   "Venus"  
     Character(len=lenCh) ::  earth                    =   "Earth"  
     Character(len=lenCh) ::  mars                     =   "Mars"   
     Character(len=lenCh) ::  jupiter                  =   "Jupiter"
     Character(len=lenCh) ::  uranus                   =   "Saturn" 
     Character(len=lenCh) ::  saturn                   =   "Uranus" 
     Character(len=lenCh) ::  neptune                  =   "Neptune"
     Character(len=lenCh) ::  pluto                    =   "Pluto"  
     Character(len=lenCh) ::  sun                      =   "Sun"    
  End Type planetChoicesType
  !
  Type (planetChoicesType), Parameter ::                                          &  !! NCSstd
       &  planets =                                                               &  !! NCSstd
       &                          planetChoicesType (      "Mercury"       ,      &  !! NCSstd
       &                                                   "Venus  "       ,      &  !! NCSstd
       &                                                   "Earth  "       ,      &  !! NCSstd
       &                                                   "Mars   "       ,      &  !! NCSstd
       &                                                   "Jupiter"       ,      &  !! NCSstd
       &                                                   "Saturn "       ,      &  !! NCSstd
       &                                                   "Uranus "       ,      &  !! NCSstd
       &                                                   "Neptune"       ,      &  !! NCSstd
       &                                                   "Pluto  "       ,      &  !! NCSstd
       &                                                   "Sun    "  )              !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimPlanetChoices), Parameter ::               &
       &  planetChoices =                                                        &
       &           (/ planets%mercury          ,                                 &
       &              planets%venus            ,                                 &
       &              planets%earth            ,                                 &
       &              planets%mars             ,                                 &
       &              planets%jupiter          ,                                 &
       &              planets%uranus           ,                                 &
       &              planets%saturn           ,                                 &
       &              planets%neptune          ,                                 &
       &              planets%pluto            ,                                 &
       &              planets%sun              /)
  !
  !                                                                                  !! NCSstd
  ! **  Satellites                                                                   !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimSatChoices  = 22
  Integer, Parameter      :: iPhobos         =  1      !   "Phobos"   
  Integer, Parameter      :: iDeimos         =  2      !   "Deimos"   
  Integer, Parameter      :: iIo             =  3      !   "Io"       
  Integer, Parameter      :: iEuropa         =  4      !   "Europa"   
  Integer, Parameter      :: iGanymede       =  5      !   "Ganymede" 
  Integer, Parameter      :: iCallisto       =  6      !   "Callisto" 
  Integer, Parameter      :: iMimas          =  7      !   "Mimas"    
  Integer, Parameter      :: iEnceladus      =  8      !   "Enceladus"
  Integer, Parameter      :: iTethys         =  9      !   "Tethys"   
  Integer, Parameter      :: iDione          = 10      !   "Dione"    
  Integer, Parameter      :: iRhea           = 11      !   "Rhea"     
  Integer, Parameter      :: iTitan          = 12      !   "Titan"    
  Integer, Parameter      :: iHyperion       = 13      !   "Hyperion" 
  Integer, Parameter      :: iIapetus        = 14      !   "Iapetus"  
  Integer, Parameter      :: iMiranda        = 15      !   "Miranda"  
  Integer, Parameter      :: iAriel          = 16      !   "Ariel"    
  Integer, Parameter      :: iUmbriel        = 17      !   "Umbriel"  
  Integer, Parameter      :: iTitania        = 18      !   "Titania"  
  Integer, Parameter      :: iOberon         = 19      !   "Oberon"   
  Integer, Parameter      :: iGabriel        = 20      !   "Gabriel"  
  Integer, Parameter      :: iMoon           = 21      !   "Moon"      
  Integer, Parameter      :: iHolography     = 22      !   "2013-038A"     
  !
  Type :: satChoicesType
     Character(len=lenCh) ::  Phobos                   =   "Phobos"   
     Character(len=lenCh) ::  Deimos                   =   "Deimos"   
     Character(len=lenCh) ::  Io                       =   "Io"       
     Character(len=lenCh) ::  Europa                   =   "Europa"   
     Character(len=lenCh) ::  Ganymede                 =   "Ganymede" 
     Character(len=lenCh) ::  Callisto                 =   "Callisto" 
     Character(len=lenCh) ::  Mimas                    =   "Mimas"    
     Character(len=lenCh) ::  Enceladus                =   "Enceladus"
     Character(len=lenCh) ::  Tethys                   =   "Tethys"   
     Character(len=lenCh) ::  Dione                    =   "Dione"    
     Character(len=lenCh) ::  Rhea                     =   "Rhea"     
     Character(len=lenCh) ::  Titan                    =   "Titan"    
     Character(len=lenCh) ::  Hyperion                 =   "Hyperion" 
     Character(len=lenCh) ::  Iapetus                  =   "Iapetus"  
     Character(len=lenCh) ::  Miranda                  =   "Miranda"  
     Character(len=lenCh) ::  Ariel                    =   "Ariel"    
     Character(len=lenCh) ::  Umbriel                  =   "Umbriel"  
     Character(len=lenCh) ::  Titania                  =   "Titania"  
     Character(len=lenCh) ::  Oberon                   =   "Oberon"   
     Character(len=lenCh) ::  Gabriel                  =   "Gabriel"  
     Character(len=lenCh) ::  Moon                     =   "Moon"     
     Character(len=lenCh) ::  Holography               =   "2013-038A"
  End Type satChoicesType
  !
  Type (satChoicesType), Parameter ::                                            &  !! NCSstd
       &  sats =                                                                 &  !! NCSstd
       &                       satChoicesType (            "Phobos   "     ,     &  !! NCSstd ! Mars
       &                                                   "Deimos   "     ,     &  !! NCSstd
       &                                                   "Io       "     ,     &  !! NCSstd ! Jupiter
       &                                                   "Europa   "     ,     &  !! NCSstd
       &                                                   "Ganymede "     ,     &  !! NCSstd
       &                                                   "Callisto "     ,     &  !! NCSstd
       &                                                   "Mimas    "     ,     &  !! NCSstd ! Saturn
       &                                                   "Enceladus"     ,     &  !! NCSstd
       &                                                   "Tethys   "     ,     &  !! NCSstd
       &                                                   "Dione    "     ,     &  !! NCSstd
       &                                                   "Rhea     "     ,     &  !! NCSstd
       &                                                   "Titan    "     ,     &  !! NCSstd
       &                                                   "Hyperion "     ,     &  !! NCSstd
       &                                                   "Iapetus  "     ,     &  !! NCSstd
       &                                                   "Miranda  "     ,     &  !! NCSstd ! Uranus
       &                                                   "Ariel    "     ,     &  !! NCSstd
       &                                                   "Umbriel  "     ,     &  !! NCSstd
       &                                                   "Titania  "     ,     &  !! NCSstd
       &                                                   "Oberon   "     ,     &  !! NCSstd
       &                                                   "Gabriel  "     ,     &  !! NCSstd
       &                                                   "Moon     "     ,     &  !! NCSstd ! Earth
       &                                                   "2013-038A"     )     !  !! NCSstd 
  !
  Character(len=lenCh), Dimension(nDimSatChoices), Parameter ::                  &
       &  satChoices =                                                           &
       &              (/ sats%Phobos           ,                                 &
       &                 sats%Deimos           ,                                 &
       &                 sats%Io               ,                                 &
       &                 sats%Europa           ,                                 &
       &                 sats%Ganymede         ,                                 &
       &                 sats%Callisto         ,                                 &
       &                 sats%Mimas            ,                                 &
       &                 sats%Enceladus        ,                                 &
       &                 sats%Tethys           ,                                 &
       &                 sats%Dione            ,                                 &
       &                 sats%Rhea             ,                                 &
       &                 sats%Titan            ,                                 &
       &                 sats%Hyperion         ,                                 &
       &                 sats%Iapetus          ,                                 &
       &                 sats%Miranda          ,                                 &
       &                 sats%Ariel            ,                                 &
       &                 sats%Umbriel          ,                                 &
       &                 sats%Titania          ,                                 &
       &                 sats%Oberon           ,                                 &
       &                 sats%Gabriel          ,                                 &
       &                 sats%Moon             ,                                 &
       &                 sats%Holography       /)                                !
  !
  !                                                                                  !! NCSstd

  !                                                                                  !! NCSstd
  ! **  Special Source Names                                                         !! NCSstd
  !                                                                                  !! NCSstd
  Integer, Parameter      :: nDimSpecialSourceChoices  =  2
  Integer, Parameter      :: iTipCurAzi        =  1    !   "TipCurrentAzimuth"
  Integer, Parameter      :: ispecialTest      =  2    !   "SpecialTest"    
  !
  Type :: SpecialSourceChoicesType
     Character(len=lenCh) ::  TipCurAzi                =   "TipCurrentAzimuth"
     Character(len=lenCh) ::  specialTest              =   "SpecialTest"    
  End Type SpecialSourceChoicesType
  !
  Type (SpecialSourceChoicesType), Parameter ::                                  &  !! NCSstd
       &  SpecialSources =                                                       &  !! NCSstd
       &          SpecialSourceChoicesType (               "TipCurrentAzimuth",  &  !! NCSstd
       &                                                   "SpecialTest      ")  !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimSpecialSourceChoices), Parameter ::        &
       &  SpecialSourceChoices =                                                 &
       &    (/ SpecialSources%TipCurAzi          ,                               &
       &       SpecialSources%specialTest              /)                        !
  !



  ! **  equinox systems for sources                                                  !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimEquinoxChoices  = 2
  Integer, Parameter      :: iJ             =  1       !   "J"
  Integer, Parameter      :: iB             =  2       !   "B"
  !
  Type :: equinoxChoicesType
     Character(len=lenCh) ::  J                        =   "J"
     Character(len=lenCh) ::  B                        =   "B"
  End Type equinoxChoicesType
  !
  Type (equinoxChoicesType), Parameter ::                                         &  !! NCSstd
       &  equ =                                                                   &  !! NCSstd
       &                          equinoxChoicesType (     "J"         ,          &  !! NCSstd
       &                                                   "B"         )             !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimEquinoxChoices), Parameter ::              &
       &  equinoxChoices =                                                       &
       &               (/ equ%J                           ,                      &
       &                  equ%B                           /)                                
  !
  !                                                                                  !! NCSstd
  ! **  coordinate systems for sources                                               !! NCSstd
  !                                                                                  !! NCSstd
  Integer, Parameter      :: nDimSystemChoices    =  7
  Integer, Parameter      :: igalactic            =  1  !  "galactic"          
  Integer, Parameter      :: iequatorial          =  2  !  "equatorial"        
  Integer, Parameter      :: iapparentEquatorial  =  3  !  "apparentEquatorial"
  Integer, Parameter      :: iecliptic            =  4  !  "ecliptic"          
  Integer, Parameter      :: iapparentEcliptic    =  5  !  "apparentEcliptic"  
  Integer, Parameter      :: ihaDec               =  6  !  "haDec "            
  Integer, Parameter      :: ihorizontal          =  7  !  "horizontal"        
  !
  Type :: systemChoicesType
     Character(len=lenCh) ::  galactic                  =  "galactic"          
     Character(len=lenCh) ::  equatorial                =  "equatorial"        
     Character(len=lenCh) ::  apparentEquatorial        =  "apparentEquatorial"
     Character(len=lenCh) ::  ecliptic                  =  "ecliptic"          
     Character(len=lenCh) ::  apparentEcliptic          =  "apparentEcliptic"  
     Character(len=lenCh) ::  haDec                     =  "haDec "            
     Character(len=lenCh) ::  horizontal                =  "horizontal"        
  End Type systemChoicesType
  !
  Type (systemChoicesType), Parameter ::                                          &  !! NCSstd
       &  sys =                                                                   &  !! NCSstd
       &                            systemChoicesType (    "galactic          " , &  !! NCSstd
       &                                                   "equatorial        " , &  !! NCSstd
       &                                                   "apparentEquatorial" , &  !! NCSstd
       &                                                   "ecliptic          " , &  !! NCSstd
       &                                                   "apparentEcliptic  " , &  !! NCSstd
       &                                                   "haDec             " , &  !! NCSstd
       &                                                   "horizontal        " )    !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimSystemChoices), Parameter ::                &
       &  systemChoices =                                                         &
       &               (/ sys%galactic                  ,                         &
       &                  sys%equatorial                ,                         &
       &                  sys%apparentEquatorial        ,                         &
       &                  sys%ecliptic                  ,                         &
       &                  sys%apparentEcliptic          ,                         &
       &                  sys%haDec                     ,                         &
       &                  sys%horizontal                /)                                
  !
  ! style: line up in column: 30                            60                       85 88
  !                                                                                  !! NCSstd
  ! **  descriptive systems for sources                                              !! NCSstd
  !                                                                                  !! NCSstd
  Integer, Parameter      :: nDimDescriptiveChoices  =  4
  Integer, Parameter      :: inone                =  1  !  "none"  
  Integer, Parameter      :: iorigin              =  2  !  "origin"
  Integer, Parameter      :: ipolar               =  3  !  "polar" 
  Integer, Parameter      :: iEuler               =  4  !  "Euler" 
  !
  Type :: descriptiveChoicesType
     Character(len=lenCh) ::  none                      =  "none"  
     Character(len=lenCh) ::  origin                    =  "origin"
     Character(len=lenCh) ::  polar                     =  "polar" 
     Character(len=lenCh) ::  Euler                     =  "Euler" 
  End Type descriptiveChoicesType
  !
  Type (descriptiveChoicesType), Parameter ::                                     &  !! NCSstd
       &  des =                                                                   &  !! NCSstd
       &                       descriptiveChoicesType (    "none  "             , &  !! NCSstd
       &                                                   "origin"             , &  !! NCSstd
       &                                                   "polar "             , &  !! NCSstd
       &                                                   "Euler "             )    !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimDescriptiveChoices), Parameter ::           &
       &  descriptiveChoices =                                                    &
       &               (/ des%none                      ,                         &
       &                  des%origin                    ,                         &
       &                  des%polar                     ,                         &
       &                  des%Euler                     /)                                
  !                                                                                  !! NCSstd
  ! **  projections for sources                                                      !! NCSstd
  !                                                                                  !! NCSstd
  Integer, Parameter      :: nDimProjectionChoices  =  12
  !! Integer, Parameter   :: inone                =  1  !  "none"                    ! already defined
  Integer, Parameter      :: iradio               =  2  !  "radio"
  Integer, Parameter      :: iTAN                 =  3  !  "TAN"  
  Integer, Parameter      :: iSIN                 =  4  !  "SIN"  
  Integer, Parameter      :: iSTG                 =  5  !  "STG"  
  Integer, Parameter      :: iARC                 =  6  !  "ARC"  
  Integer, Parameter      :: iZEA                 =  7  !  "ZEA"  
  Integer, Parameter      :: iCAR                 =  8  !  "CAR"  
  Integer, Parameter      :: iMER                 =  9  !  "MER"  
  Integer, Parameter      :: iCEA                 = 10  !  "CEA"  
  Integer, Parameter      :: iGLS                 = 11  !  "GLS"  
  Integer, Parameter      :: iAIT                 = 12  !  "AIT"  
  !
  Type :: projectionChoicesType
     Character(len=lenCh) ::  none                      =  "none" 
     Character(len=lenCh) ::  radio                     =  "radio"
     Character(len=lenCh) ::  TAN                       =  "TAN"  
     Character(len=lenCh) ::  SIN                       =  "SIN"  
     Character(len=lenCh) ::  STG                       =  "STG"  
     Character(len=lenCh) ::  ARC                       =  "ARC"  
     Character(len=lenCh) ::  ZEA                       =  "ZEA"  
     Character(len=lenCh) ::  CAR                       =  "CAR"  
     Character(len=lenCh) ::  MER                       =  "MER"  
     Character(len=lenCh) ::  CEA                       =  "CEA"  
     Character(len=lenCh) ::  GLS                       =  "GLS"  
     Character(len=lenCh) ::  AIT                       =  "AIT"  
  End Type projectionChoicesType
  !
  Type (projectionChoicesType), Parameter ::                                      &  !! NCSstd
       &  pro =                                                                   &  !! NCSstd
       &                       projectionChoicesType (     "none "              , &  !! NCSstd
       &                                                   "radio"              , &  !! NCSstd
       &                                                   "TAN  "              , &  !! NCSstd
       &                                                   "SIN  "              , &  !! NCSstd
       &                                                   "STG  "              , &  !! NCSstd
       &                                                   "ARC  "              , &  !! NCSstd
       &                                                   "ZEA  "              , &  !! NCSstd
       &                                                   "CAR  "              , &  !! NCSstd
       &                                                   "MER  "              , &  !! NCSstd
       &                                                   "CEA  "              , &  !! NCSstd
       &                                                   "GLS  "              , &  !! NCSstd
       &                                                   "AIT  "              )    !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimProjectionChoices), Parameter ::            &
       &  projectionChoices =                                                     &
       &               (/ pro%none                      ,                         &
       &                  pro%radio                     ,                         &
       &                  pro%TAN                       ,                         &
       &                  pro%SIN                       ,                         &
       &                  pro%STG                       ,                         &
       &                  pro%ARC                       ,                         &
       &                  pro%ZEA                       ,                         &
       &                  pro%CAR                       ,                         &
       &                  pro%MER                       ,                         &
       &                  pro%CEA                       ,                         &
       &                  pro%GLS                       ,                         &
       &                  pro%AIT                       /)                                
  !
  ! **  reference rames for radial velocities                                        !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimRefFrameChoices  =  3
  Integer, Parameter      :: iLSR              =  1    !   "LSR"           
  Integer, Parameter      :: iheliocentric     =  2    !   "heliocentric"  
  Integer, Parameter      :: ibarycentric      =  3    !   "barycentric"   
  !
  Type :: refFrameChoicesType
     Character(len=lenCh) ::  LSR                      =   "LSR"           
     Character(len=lenCh) ::  heliocentric             =   "heliocentric"  
     Character(len=lenCh) ::  barycentric              =   "barycentric"   
  End Type refFrameChoicesType
  !
  Type (refFrameChoicesType), Parameter ::                                        &  !! NCSstd
       &  refFrame =                                                              &  !! NCSstd
       &                           refFrameChoicesType (                          &  !! NCSstd
       &                                                   "LSR         "       , &  !! NCSstd
       &                                                   "heliocentric"       , &  !! NCSstd 
       &                                                   "barycentric "         &  !! NCSstd
       &                                               )                          !  !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimRefFrameChoices), Parameter ::              &
       &  refFrameChoices =                                                       &
       &          (/ refFrame%LSR                      ,                          &
       &             refFrame%heliocentric             ,                          &
       &             refFrame%barycentric             /)                          !
  !
!!$  ! **  reference rames for radial velocities                                        !! NCSstd
!!$  !                                                                                  !! NCSstd
!!$  !
!!$  Integer, Parameter      :: nDimRefFrameChoices  =  9
!!$  Integer, Parameter      :: inull             =  1    !   "null"          
!!$  Integer, Parameter      :: itopocentric      =  2    !   "topocentric"   
!!$  Integer, Parameter      :: igeocentric       =  3    !   "geocentric"    
!!$  Integer, Parameter      :: iheliocentric     =  4    !   "heliocentric"  
!!$  Integer, Parameter      :: ibarycentric      =  5    !   "barycentric"   
!!$  Integer, Parameter      :: ibody             =  6    !   "body"          
!!$  Integer, Parameter      :: iLSR              =  7    !   "LSR"           
!!$  Integer, Parameter      :: igalactocentric   =  8    !   "galactocentric"
!!$  Integer, Parameter      :: imwb3K            =  9    !   "3K"            
!!$  !
!!$  Type :: refFrameChoicesType
!!$     Character(len=lenCh) ::  null                     =   "null"          
!!$     Character(len=lenCh) ::  topocentric              =   "topocentric"   
!!$     Character(len=lenCh) ::  geocentric               =   "geocentric"    
!!$     Character(len=lenCh) ::  heliocentric             =   "heliocentric"  
!!$     Character(len=lenCh) ::  barycentric              =   "barycentric"   
!!$     Character(len=lenCh) ::  body                     =   "body"          
!!$     Character(len=lenCh) ::  LSR                      =   "LSR"           
!!$     Character(len=lenCh) ::  galactocentric           =   "galactocentric"
!!$     Character(len=lenCh) ::  mwb3K                    =   "3K"            
!!$  End Type refFrameChoicesType
!!$  !
!!$  Type (refFrameChoicesType), Parameter ::                                        &  !! NCSstd
!!$       &  refFrame =                                                              &  !! NCSstd
!!$       &                            refFrameChoicesType (                         &  !! NCSstd
!!$       &                                                   "null"               , &  !! NCSstd --> no Doppler corr.
!!$       &                                                   "topocentric"        , &  !! NCSstd TBD later
!!$       &                                                   "geocentric"         , &  !! NCSstd TBD later
!!$       &                                                   "heliocentric"       , &  !! NCSstd 
!!$       &                                                   "barycentric"        , &  !! NCSstd
!!$       &                                                   "body"               , &  !! NCSstd --> use ephemeris
!!$       &                                                   "LSR"                , &  !! NCSstd Default
!!$       &                                                   "galactocentric"     , &  !! NCSstd TBD later
!!$       &                                                   "3K"                   &  !! NCSstd TBD later           
!!$       )    !! NCSstd
!!$  !
!!$  Character(len=lenCh), Dimension(nDimRefFrameChoices), Parameter ::              &
!!$       &  refFrameChoices =                                                       &
!!$       &          (/ refFrame%null                     ,                          &
!!$       &             refFrame%topocentric              ,                          &
!!$       &             refFrame%geocentric               ,                          &
!!$       &             refFrame%heliocentric             ,                          &
!!$       &             refFrame%barycentric              ,                          &
!!$       &             refFrame%body                     ,                          &
!!$       &             refFrame%LSR                      ,                          &
!!$       &             refFrame%galactocentric           ,                          &
!!$       &             refFrame%mwb3K                    /)                                
!!$  !
  !                                                                                  !! NCSstd
  ! **  conventions for Doppler corrections                                          !! NCSstd
  !                                                                                  !! NCSstd
  Integer, Parameter      :: nDimDopplerConventionChoices  = 2
  Integer, Parameter      :: iDCradio       =  1       !   "radio"  
  Integer, Parameter      :: iDCoptical     =  2       !   "optical"
  !
  Type :: DopplerConventionChoicesType
     Character(len=lenCh) ::    radio                  =   "radio"  
     Character(len=lenCh) ::    optical                =   "optical"
  End Type DopplerConventionChoicesType
  !
  Type (DopplerConventionChoicesType), Parameter ::                               &  !! NCSstd
       &  dc  =                                                                   &  !! NCSstd
       &                DopplerConventionChoicesType (     "radio  "   ,          &  !! NCSstd
       &                                                   "optical"   )             !! NCSstd Default
  !
  Character(len=lenCh), Dimension(nDimDopplerConventionChoices), Parameter ::     &
       &  DopplerConventionChoices =                                              &
       &               (/    dc%radio                  ,                          &
       &                     dc%optical                /)                                
  !
  !                                                                                  !! NCSstd
  ! **  systems for offsets                                                          !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimOffsetChoices  = 8
  Integer, Parameter      :: ipro           =  1       !   "projection" 
  Integer, Parameter      :: ides           =  2       !   "descriptive"
  Integer, Parameter      :: ibas           =  3       !   "basis"      
  Integer, Parameter      :: iequ           =  4       !   "equatorial" 
  Integer, Parameter      :: ihad           =  5       !   "haDec "     
  Integer, Parameter      :: itru           =  6       !   "trueHorizon"
  Integer, Parameter      :: ihor           =  7       !   "horizontal" 
  Integer, Parameter      :: inas           =  8       !   "Nasmyth"    
  !
  Type :: offsetChoicesType
     Character(len=lenCh) ::  pro                      =   "projection" 
     Character(len=lenCh) ::  des                      =   "descriptive"
     Character(len=lenCh) ::  bas                      =   "basis"      
     Character(len=lenCh) ::  equ                      =   "equatorial" 
     Character(len=lenCh) ::  had                      =   "haDec "     
     Character(len=lenCh) ::  tru                      =   "trueHorizon"
     Character(len=lenCh) ::  hor                      =   "horizontal" 
     Character(len=lenCh) ::  nas                      =   "Nasmyth"    
  End Type offsetChoicesType
  !
  Type (offsetChoicesType), Parameter ::                                          &  !! NCSstd
       &  offs =                                                                  &  !! NCSstd
       &                          offsetChoicesType (      "projection    ",      &  !! NCSstd
       &                                                   "descriptive   ",      &  !! NCSstd
       &                                                   "basis         ",      &  !! NCSstd
       &                                                   "equatorial    ",      &  !! NCSstd
       &                                                   "haDec         ",      &  !! NCSstd
       &                                                   "horizontalTrue",      &  !! NCSstd
       &                                                   "horizontal    ",      &  !! NCSstd
       &                                                   "Nasmyth       ")         !! NCSstd
  !
  Character(len=lenCh), Dimension(nDimOffsetChoices), Parameter ::               &
       &  offsetChoices =                                                        &
       &              (/ offs%pro          ,                                     &
       &                 offs%des          ,                                     &
       &                 offs%bas          ,                                     &
       &                 offs%equ          ,                                     &
       &                 offs%had          ,                                     &
       &                 offs%tru          ,                                     &
       &                 offs%hor          ,                                     &
       &                 offs%nas          /)
  !
  ! The following is a variation to be used in evaluating pako commands:
  !     This is necessary to offer an easy match /distinction between 
  !     trueHorizon and horizontal
  !
  Type (offsetChoicesType), Parameter ::                                         &
       &  offsPako =                                                             &
       &                              offsetChoicesType (  "projection " ,       &
       &                                                   "descriptive" ,       &
       &                                                   "basis      " ,       &
       &                                                   "equatorial " ,       &
       &                                                   "haDec      " ,       &
       &                                                   "trueHorizon" ,       &
       &                                                   "horizontal " ,       &
       &                                                   "Nasmyth    " )
  !
  Character(len=lenCh), Dimension(nDimOffsetChoices), Parameter ::               &
       &  offsetChoicesPako =                                                    &
       &          (/ offsPako%pro          ,                                     &
       &             offsPako%des          ,                                     &
       &             offsPako%bas          ,                                     &
       &             offsPako%equ          ,                                     &
       &             offsPako%had          ,                                     &
       &             offsPako%tru          ,                                     &
       &             offsPako%hor          ,                                     &
       &             offsPako%nas          /)
  !
  !                                                                                  !! NCSstd
  ! *   topology (for azimuth wrap)                                                  !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimTopologyChoices  = 5
  Integer, Parameter      :: ilow           = 1        !   "low"    
  Integer, Parameter      :: ihigh          = 2        !   "high"   
  Integer, Parameter      :: inearest       = 3        !   "nearest"
  Integer, Parameter      :: isouth         = 4        !   "south"  
  Integer, Parameter      :: inorth         = 5        !   "north"  
  !
  Type :: topologyChoicesType
     Character(len=lenCh) ::  low                      =   "low"    
     Character(len=lenCh) ::  high                     =   "high"   
     Character(len=lenCh) ::  nearest                  =   "nearest"
     Character(len=lenCh) ::  south                    =   "south"  
     Character(len=lenCh) ::  north                    =   "north"  
  End Type topologyChoicesType
  !
  Type   (topologyChoicesType), Parameter ::                                      &  !! NCSstd
       &  topo =                                                                  &  !! NCSstd
       &                         topologyChoicesType (     "low    "   ,          &  !! NCSstd   available
       &                                                   "high   "   ,          &  !! NCSstd   available
       &                                                   "nearest"   ,          &  !! NCSstd   available
       &                                                   "south  "   ,          &  !! NCSstd   TBD later
       &                                                   "north  ")                !! NCSstd   TBD later
  !
  Character(len=lenCh), Dimension(nDimTopologyChoices), Parameter ::              &
       &  topologyChoices =                                                       &
       &              (/ topo%low     ,                                           &
       &                 topo%high    ,                                           &
       &                 topo%nearest ,                                           &
       &                 topo%south   ,                                           &
       &                 topo%north   /)
  !
  !                                                                                  !! NCSstd
  ! style: line up in column: 30                            60                       85 88
  ! *   az.-el. direction (for Pointing)                                             !! NCSstd
  !                                                                                  !! NCSstd
  Integer, Parameter      :: nDimAzelChoices  = 4
  Integer, Parameter      :: ipa            = 1        !   "+a"     
  Integer, Parameter      :: ima            = 2        !   "-a"     
  Integer, Parameter      :: ipe            = 3        !   "+e"     
  Integer, Parameter      :: ime            = 4        !   "-e"     
  !
  Type :: azelChoicesType
     Character(len=lenCh) ::  pa                       =   "+a"
     Character(len=lenCh) ::  ma                       =   "-a"
     Character(len=lenCh) ::  pe                       =   "+e"
     Character(len=lenCh) ::  me                       =   "-e"
  End Type azelChoicesType
  !
  Type   (azelChoicesType), Parameter ::                                          &  !! NCSstd
       &  azel =                                                                  &  !! NCSstd
       &                         azelChoicesType (         "+a"   ,               &  !! NCSstd   
       &                                                   "-a"   ,               &  !! NCSstd   
       &                                                   "+e"   ,               &  !! NCSstd   
       &                                                   "-e"   )                  !! NCSstd   
  !
  Character(len=lenCh), Dimension(nDimAzelChoices), Parameter ::                  &
       &  azelChoices =                                                           &
       &              (/ azel%pa   ,                                              &
       &                 azel%ma   ,                                              &
       &                 azel%pe   ,                                              &
       &                 azel%me   /)
  !
  ! style: line up in column: 30                            60                       85 88
  !                                                                                  !! NCSstd
  ! *** SET keywords (supported by "SET" command)                                    !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimSetChoices = 26
  Integer, Parameter      :: iproject                  =  1  !   "project" 
  Integer, Parameter      :: iPI                       =  2  !   "PI"      
  Integer, Parameter      :: iobserver                 =  3  !   "observer"
  Integer, Parameter      :: ioperator                 =  4  !   "operator"
  Integer, Parameter      :: ilevel                    =  5  !   "level"   
  Integer, Parameter      :: ipointing                 =  6  !   "pointing"
  Integer, Parameter      :: ifocus                    =  7  !   "focus"   
  Integer, Parameter      :: itopology                 =  8  !   "topology"
  Integer, Parameter      :: iAngleUnit                =  9  !   "angleUnit"
  Integer, Parameter      :: iAutomatic                = 10  !   "automatic"
  Integer, Parameter      :: iDoSubmit                 = 11  !   "doSubmit"
  Integer, Parameter      :: iDoDopplerUpdates         = 12  !   "doDopplerUpdates"
  Integer, Parameter      :: isecondaryRotation        = 13  !   "2ndRotation"
  Integer, Parameter      :: iPlotStyle                = 14  !   "plotStyle"
  Integer, Parameter      :: iDoXMLobservingMode       = 15  !   "XMLobservingMode"
  Integer, Parameter      :: iPrivilege                = 16  !   "privilege"
  Integer, Parameter      :: iLimitCheck               = 17  !   "limitCheck"
  Integer, Parameter      :: iEMIRcheck                = 18  !   "EMIRcheck"
  Integer, Parameter      :: imatchSource              = 19  !   "matchSource"
  Integer, Parameter      :: iTransitionAcceleration   = 20  !   "transitionAcceleration"
  Integer, Parameter      :: iSlowRateAMD              = 21  !   "slowRateAMD"
  Integer, Parameter      :: iDoDebugMessages          = 22  !   "doDebugMessages"
  Integer, Parameter      :: iUserLevel                = 23  !   "userLevel"
  Integer, Parameter      :: iTestMode                 = 24  !   "testMode"
  Integer, Parameter      :: iComment                  = 25  !   "comment"
  Integer, Parameter      :: iPurpose                  = 26  !   "purpose"
  !
  Type :: setChoicesType
     Character(len=lench) ::  project                  =   "project" 
     Character(len=lench) ::  PI                       =   "PI"      
     Character(len=lench) ::  observer                 =   "observer"
     Character(len=lench) ::  Operator                 =   "operator"
     Character(len=lench) ::  level                    =   "level"   
     Character(len=lench) ::  pointing                 =   "pointing"
     Character(len=lench) ::  focus                    =   "focus"   
     Character(len=lench) ::  topology                 =   "topology"
     Character(len=lench) ::  angleUnit                =   "angleUnit"
     Character(len=lench) ::  automatic                =   "automatic"
     Character(len=lench) ::  doSubmit                 =   "doSubmit"
     Character(len=lench) ::  doDopplerUpdates         =   "doDopplerUpdates"
     Character(len=lench) ::  secondaryRotation        =   "2ndRotation"
     Character(len=lench) ::  plotStyle                =   "plotStyle"
     Character(len=lench) ::  doXMLobservingMode       =   "doXMLobservingMode"
     Character(len=lench) ::  privilege                =   "privilege"
     Character(len=lench) ::  limitCheck               =   "limitCheck"
     Character(len=lench) ::  EMIRcheck                =   "EMIRcheck"
     Character(len=lench) ::  matchSource              =   "matchSource"
     Character(len=lench) ::  transitionAcceleration   =   "transitionAcceleration"
     Character(len=lench) ::  slowRateAMD              =   "slowRateAMD"
     Character(len=lench) ::  doDebugMessages          =   "doDebugMessages"
     Character(len=lench) ::  userlevel                =   "userLevel"
     Character(len=lench) ::  testMode                 =   "testMode"
     Character(len=lench) ::  comment                  =   "comment"
     Character(len=lench) ::  purpose                  =   "purpose"
  End Type setChoicesType     
  !
  Type (setChoicesType), Parameter ::                                          &  !! NCSstd
       &  set =                                                                &  !! NCSstd
       &                           setChoicesType (  "project               ", &  !! NCSstd
       &                                             "PI                    ", &  !! NCSstd
       &                                             "observer              ", &  !! NCSstd
       &                                             "operator              ", &  !! NCSstd
       &                                             "level                 ", &  !! NCSstd
       &                                             "pointing              ", &  !! NCSstd
       &                                             "focus                 ", &  !! NCSstd
       &                                             "topology              ", &  !! NCSstd
       &                                             "angleUnit             ", &  !! NCSstd
       &                                             "automatic             ", &  !! NCSstd
       &                                             "doSubmit              ", &  !! NCSstd
       &                                             "doDopplerUpdates      ", &  !! NCSstd
       &                                             "2ndRotation           ", &  !! NCSstd
       &                                             "plotStyle             ", &  !! NCSstd
       &                                             "doXMLobservingMode    ", &  !! NCSstd
       &                                             "privilege             ", &  !! NCSstd
       &                                             "limitCheck            ", &  !! NCSstd
       &                                             "EMIRcheck             ", &  !! NCSstd
       &                                             "matchSource           ", &  !! NCSstd
       &                                             "transitionAcceleration", &  !! NCSstd
       &                                             "slowRateAMD           ", &  !! NCSstd
       &                                             "doDebugMessages       ", &  !! NCSstd
       &                                             "userLevel             ", &  !! NCSstd
       &                                             "testMode              ", &  !! NCSstd
       &                                             "comment               ", &  !! NCSstd
       &                                             "purpose               "  &  !! NCSstd
       &                                                               )          !  !! NCSstd to be extended!
  !                                                     
  !
  Character(len=lenCh), Dimension(nDimSetChoices), Parameter ::                   &
       &  setChoices =                                                            &
       &               (/ set%project  ,                                          &
       &                  set%PI       ,                                          &
       &                  set%observer ,                                          &
       &                  set%operator ,                                          &
       &                  set%level    ,                                          &
       &                  set%pointing ,                                          &
       &                  set%focus    ,                                          &
       &                  set%topology ,                                          &
       &                  set%angleUnit,                                          &
       &                  set%automatic,                                          &
       &                  set%doSubmit ,                                          &
       &                  set%doDopplerUpdates  ,                                 &
       &                  set%secondaryRotation ,                                 &
       &                  set%plotStyle         ,                                 &
       &                  set%doXMLobservingMode,                                 &
       &                  set%privilege         ,                                 &
       &                  set%limitCheck        ,                                 &
       &                  set%EMIRcheck         ,                                 &
       &                  set%matchSource       ,                                 &
       &                  set%transitionAcceleration,                             &
       &                  set%slowRateAMD       ,                                 &
       &                  set%doDebugMessages   ,                                 &
       &                  set%userlevel         ,                                 &
       &                  set%testMode          ,                                 &
       &                  set%comment           ,                                 &
       &                  set%purpose                                             &
       &               /)                                                         !
  !
  !                                                                                  !! NCSstd
  ! *** SET plotStyle keywords                                                       !! NCSstd
  !                                                                                  !! NCSstd
  !
  Integer, Parameter      :: nDimSetPlotChoices =  3
  Integer, Parameter      :: ifancy         =  1       !   "fancy"
  Integer, Parameter      :: isimple        =  2       !   "simple"  
  Integer, Parameter      :: ioff           =  3       !   "off"     
  !
  Type :: setPlotChoicesType
     Character(len=lench) ::  fancy                    =   "fancy"
     Character(len=lench) ::  simple                   =   "simple"  
     Character(len=lench) ::  off                      =   "off"     
  End Type setPlotChoicesType
  !
  Type (setPlotChoicesType), Parameter ::                                         &  !! NCSstd
       &  setPlot =                                                               &  !! NCSstd
       &                          setPlotChoicesType (     "fancy "    ,          &  !! NCSstd
       &                                                   "simple"    ,          &  !! NCSstd
       &                                                   "off   "               &  !! NCSstd
       &                                                               )             !! NCSstd 
  !                                                     
  Character(len=lenCh), Dimension(nDimSetPlotChoices), Parameter ::               &
       &  setPlotChoices =                                                        &
       &           (/ setPlot%fancy    ,                                          &
       &              setPlot%simple   ,                                          &
       &              setPlot%off                                                 &
       &               /)
  !
  !                                                                                  !! NCSstd
  ! *** SET privilege keywords                                                       !! NCSstd
  !                                                                                  !! NCSstd
  ! style: line up in column: 30                            60                       85 88  !
  Integer, Parameter      :: nDimSetPrivilegeChoices =  8
  Integer, Parameter      :: iuser          =  1       !   "user"
  Integer, Parameter      :: iVLBI          =  2       !   "VLBI"
  Integer, Parameter      :: ibolometerPool =  3       !   "bolometerPool"
  Integer, Parameter      :: ipNIKA         =  4       !   "NIKA"
  Integer, Parameter      :: iprivileged    =  5       !   "privileged"
  Integer, Parameter      :: istaff         =  6       !   "mrtStaff"  
  Integer, Parameter      :: incsTeam       =  7       !   "csTeam"
  Integer, Parameter      :: iHU            =  8       !   "HansUngerechts"
  !
!!$  Integer, Parameter      :: iGISMOpriv     = 7       !   "GISMO"
  !
  Type :: setPrivilegeChoicesType
     Character(len=lench) ::  user                     =   "user"          
     Character(len=lench) ::  VLBI                     =   "VLBI"          
     Character(len=lench) ::  bolometerPool            =   "bolometerPool" 
     Character(len=lench) ::  NIKA                     =   "NIKA"          
     Character(len=lench) ::  privileged               =   "privileged"    
     Character(len=lench) ::  staff                    =   "mrtStaff"      
     Character(len=lench) ::  ncsTeam                  =   "csTeam"        
     Character(len=lench) ::  HU                       =   "HansUngerechts"          
     !
!!$     Character(len=lench) ::  GISMO                   =   "GISMO"
     !
  End Type setPrivilegeChoicesType
  !
  Type (setPrivilegeChoicesType), Parameter ::                                   &   !! NCSstd
       &  setPrivilege =                                                         &   !! NCSstd
       &                       setPrivilegeChoicesType(                          &   !! NCSstd
       &                                                   "user          " ,    &   !! NCSstd
       &                                                   "VLBI          " ,    &   !! NCSstd
       &                                                   "bolometerPool " ,    &   !! NCSstd
       &                                                   "NIKA          " ,    &   !! NCSstd
       &                                                   "privileged    " ,    &   !! NCSstd
       &                                                   "mrtStaff      " ,    &   !! NCSstd
       &                                                   "csTeam        " ,    &   !! NCSstd
       &                                                   "HansUngerechts"      &   
       &                                              )                          !   !! NCSstd
  !
!!$       &                            "GISMO"               &  !! NCSstd
  !                                
  Character(len=lenCh), Dimension(nDimSetPrivilegeChoices), Parameter ::         &
       &  setPrivilegeChoices =                                                  &
       &      (/ setPrivilege%user           ,                                   &
       &         setPrivilege%VLBI           ,                                   &        
       &         setPrivilege%bolometerPool  ,                                   &
       &         setPrivilege%NIKA           ,                                   &
       &         setPrivilege%privileged     ,                                   &
       &         setPrivilege%staff          ,                                   &
       &         setPrivilege%ncsTeam        ,                                   &
       &         setPrivilege%HU                                                 &
       &      /)                                                                 !
  !
!!$       &              setPrivilege%GISMO                                          &
  !
  !
  !                                                                                  !! NCSstd
  ! *** SET userLevel keywords                                                       !! NCSstd
  !                                                                                  !! NCSstd
  ! style: line up in column: 30                            60                       85 88  !
  Integer, Parameter      :: nDimSetUserLevelChoices =  6
  Integer, Parameter      :: ivirgenExtra  =  1         !   "virgenExtra"    
  Integer, Parameter      :: ibeginner     =  2         !   "beginner"       
  Integer, Parameter      :: inormal       =  3         !   "normal"          
  Integer, Parameter      :: iexperienced  =  4         !   "experienced"    
  Integer, Parameter      :: iguru         =  5         !   "guru"             
  Integer, Parameter      :: iprimaDonna   =  6         !   "primaDonna"     
  !
  Type :: setUserLevelChoicesType
     Character(len=lench) ::  virgenExtra               =   "virgenExtra"
     Character(len=lench) ::  beginner                  =   "beginner"  
     Character(len=lench) ::  normal                    =   "normal"     
     Character(len=lench) ::  experienced               =   "experienced"
     Character(len=lench) ::  guru                      =   "guru"       
     Character(len=lench) ::  primaDonna                =   "primaDonna" 
  End Type setUserLevelChoicesType
  !
  Type (setUserLevelChoicesType), Parameter ::                                   &   !! NCSstd
       &  setUserLevel =                                                         &   !! NCSstd
       &                          setUserLevelChoicesType (                      &   !! NCSstd
       &                                                    "virgenExtra"  ,     &   !! 
       &                                                    "beginner   "  ,     &   !! NCSstd
       &                                                    "normal     "  ,     &   !! NCSstd
       &                                                    "experienced"  ,     &   !! NCSstd
       &                                                    "guru       "  ,     &   !! NCSstd
       &                                                    "primaDonna "        &           
       &                                                               )         !   !! NCSstd 
  !                                                     
  Character(len=lenCh), Dimension(nDimSetUserLevelChoices), Parameter ::         &
       &  setUserLevelChoices =                                                  &
       &           (/ setUserLevel%virgenExtra ,                                 &
       &              setUserLevel%beginner    ,                                 &        
       &              setUserLevel%normal      ,                                 &
       &              setUserLevel%experienced ,                                 &
       &              setUserLevel%guru        ,                                 &
       &              setUserLevel%primaDonna                                    &
       &               /)                                                        !
  !
  !                                                                                  !! NCSstd
  ! *** SET limitCheck keywords                                                      !! NCSstd
  !                                                                                  !! NCSstd
  ! style: line up in column: 30                            60                       85 88  !
  Integer, Parameter      :: nDimSetLimitCheckChoices =  5
  Integer, Parameter      :: ianal         =  1         !  "anal"   
  Integer, Parameter      :: istrict       =  2         !  "strict" 
  Integer, Parameter      :: irelaxed      =  3         !  "relaxed"
  Integer, Parameter      :: iloose        =  4         !  "loose"  
  Integer, Parameter      :: itest         =  5         !  "test "  
  !
  Type :: setLimitCheckChoicesType
     Character(len=lench) ::  anal                      =  "anal"    
     Character(len=lench) ::  strict                    =  "strict"  
     Character(len=lench) ::  relaxed                   =  "relaxed" 
     Character(len=lench) ::  loose                     =  "loose"  
     Character(len=lench) ::  test                      =  "test "  
  End Type setLimitCheckChoicesType
  !
  Type (setLimitCheckChoicesType), Parameter ::                                  &  !! NCSstd
       &  setLimitCheck =                                                        &  !! NCSstd
       &                         setLimitCheckChoicesType ("anal   "   ,         &  
       &                                                   "strict "   ,         &  !! NCSstd
       &                                                   "relaxed"   ,         &  !! NCSstd
       &                                                   "loose  "   ,         &  !! NCSstd
       &                                                   "test   "   )         !  !! NCSstd 
  !                                                     
  Character(len=lenCh), Dimension(nDimSetLimitCheckChoices), Parameter ::        &
       &  setLimitCheckChoices =                                                 &
       &           (/ setLimitCheck%anal     ,                                   &
       &              setLimitCheck%strict   ,                                   &        
       &              setLimitCheck%relaxed  ,                                   &
       &              setLimitCheck%loose    ,                                   &
       &              setLimitCheck%test                                         &
       &               /)                                                        !
  !
  !                                                                                  !! NCSstd
  ! *** SET matchSource keywords                                                     !! NCSstd
  !                                                                                  !! NCSstd
  ! style: line up in column: 30                            60                       85 88  !
  Integer, Parameter      :: nDimSetMatchSourceChoices =  3
  Integer, Parameter      :: iExact        =  1         !  "exact" 
  Integer, Parameter      :: iStart        =  2         !  "start"
  Integer, Parameter      :: iMatch        =  3         !  "match"  
  !
  Type :: setMatchSourceChoicesType
     Character(len=lench) ::  Exact                     =  "exact" 
     Character(len=lench) ::  Start                     =  "start"
     Character(len=lench) ::  Match                     =  "match"  
  End Type setMatchSourceChoicesType
  !
  Type (setMatchSourceChoicesType), Parameter ::                                 &  !! NCSstd
       &  setMatchSource =                                                       &  !! NCSstd
       &                       setMatchSourceChoicesType ( "exact"    ,          &  !! NCSstd
       &                                                   "start"   ,           &  !! NCSstd
       &                                                   "match"     )         !  !! NCSstd 
  !                                                     
  Character(len=lenCh), Dimension(nDimSetMatchSourceChoices), Parameter ::       &
       &  setMatchSourceChoices =                                                &
       &           (/ setMatchSource%Exact  ,                                    &
       &              setMatchSource%Start  ,                                    &
       &              setMatchSource%Match                                       &
       &               /)                                                        !
  !
  ! ***
  Integer :: ii
!!!
!!! >>> TBD: the rest down to <<< is deprecated or obsolete
  Integer, Parameter :: nDimSegmentTypes = 4
  Character(len=lenCh),  Dimension(nDimSegmentTypes)                      &
       &                                   :: segmentTypeChoices="none"
  !
  Integer, Parameter :: nDimSystemNameChoices = 7
  Character(len=lenCh),  Dimension(nDimSystemNameChoices)                 &
       &                                   :: systemNameChoices="none"
  !
  Character(len=lenCh),  Dimension(nDimOffsetChoices)                     &
       &     ::  offsetSystemChoices="none"
  Integer, Parameter :: iPROJECTION   = 1
  Integer, Parameter :: iDESCRIPTIVE  = 2
  Integer, Parameter :: iBASIS        = 3
  Integer, Parameter :: iEQUATORIALobsolete   = 4
  Integer, Parameter :: iHADECobsolete        = 5
  Integer, Parameter :: iHORIZONTRUE  = 6
  Integer, Parameter :: iHORIZON      = 7
  Integer, Parameter :: iNASMYTH      = 8
  !
!!! <<<
!!!
!!!
Contains
!!!
!!!
  Subroutine printAngleChoices
    !
    Write (6,*) " "
    Do ii = 1, nDimAngleChoices, 1
       Write (6,*) "    angleChoices   ( ",ii,") = ", angleChoices(ii)
    End Do
    !
  End Subroutine printAngleChoices
!!!
!!!
  Subroutine printSpeedChoices
    !
    Write (6,*) " "
    Do ii = 1, nDimSpeedChoices, 1
       Write (6,*) "    speedChoices   ( ",ii,") = ", speedChoices(ii)
    End Do
    !
  End Subroutine printSpeedChoices
!!!
!!!
  Subroutine printReceiverChoices
    !
    Write (6,*) " "
    Do ii = 1, nDimReceiverChoices, 1
       Write (6,*) " receiverChoices   ( ",ii,") = ", receiverChoices(ii)
    End Do
    !
    Write (6,*) " "
    Do ii = 1, nDimBolometerChoices, 1
       Write (6,*) "bolometerChoices   ( ",ii,") = ", bolometerChoices(ii)
    End Do
    !
    Write (6,*) " "
    Do ii = 1, nDimSidebandChoices, 1
       Write (6,*) " sidebandChoices   ( ",ii,") = ", sidebandChoices(ii)
    End Do
    !
    Write (6,*) " "
    Do ii = 1, nDimWidthChoices, 1
       Write (6,*) "    widthChoices   ( ",ii,") = ", widthChoices(ii)
    End Do
    !
    Write (6,*) " "
    Do ii = 1, nDimScaleChoices, 1
       Write (6,*) "    scaleChoices   ( ",ii,") = ", scaleChoices(ii)
    End Do
    !
    Write (6,*) " "
    Do ii = 1, nDimDopplerChoices, 1
       Write (6,*) "  dopplerChoices   ( ",ii,") = ", dopplerChoices(ii)
    End Do
    !
  End Subroutine printReceiverChoices
!!!
!!!
  Subroutine printOffsetChoices
    !
    Write (6,*) " "
    Do ii = 1, nDimOffsetChoices, 1
       Write (6,*) "   offsetChoices   ( ",ii,") = ", offsetChoices(ii)
    End Do
    !
  End Subroutine printOffsetChoices
!!!
!!!
  Subroutine printTopologyChoices
    !
    Write (6,*) " "
    Do ii = 1, nDimTopologyChoices, 1
       Write (6,*) "   topologyChoices ( ",ii,") = ", topologyChoices(ii)
    End Do
    !
  End Subroutine printTopologyChoices
!!!
!!!
  Subroutine printSubscanChoices
    !
    Write (6,*) " "
    Do ii = 1, nDimSubscanChoices, 1
       Write (6,*) "   subscanChoices  ( ",ii,") = ", subscanChoices(ii)
    End Do
    !
  End Subroutine printSubscanChoices
!!!
!!!
  Subroutine printSegmentChoices
    !
    Write (6,*) " "
    Do ii = 1, nDimSegmentChoices, 1
       Write (6,*) "   segmentChoices  ( ",ii,") = ", segmentChoices(ii)
    End Do
    !
  End Subroutine printSegmentChoices
!!!
!!!
  Subroutine printSetChoices
    !
    Write (6,*) " "
    Do ii = 1, nDimSetChoices, 1
       Write (6,*) "       setChoices  ( ",ii,") = ", setChoices(ii)
    End Do
    !
  End Subroutine printSetChoices
!!!
!!!
  Subroutine initializeReceiverChoices
    ! TBD: SR IS OBSOLETE
    !
!!$    receiverNameChoices(iA100)       =  "A100"      
!!$    receiverNameChoices(iA230)       =  "A230"      
!!$    receiverNameChoices(iB100)       =  "B100"      
!!$    receiverNameChoices(iB230)       =  "B230"      
!!$    receiverNameChoices(iC150)       =  "C150"      
!!$    receiverNameChoices(iC270)       =  "C270"      
!!$    receiverNameChoices(iD150)       =  "D150"      
!!$    receiverNameChoices(iD270)       =  "D270"      
!!$    receiverNameChoices(iBOLO)       =  "BOLOMETER" 
!!$    receiverNameChoices(iHERA)       =  "HERA"      
!!$    receiverNameChoices(iVERTICAL)   =  "VERTICAL"  
!!$    receiverNameChoices(iHORIZONTAL) =  "HORIZONTAL"
!!$    !
!!$    bolometerNameChoices(i37)        =  "37"
!!$    bolometerNameChoices(i117)       =  "117"
!!$    !
!!$    dopplerChoices(1)     =  "DOPPLER"
!!$    dopplerChoices(2)     =  "FIXED"
!!$    !
!!$    scaleChoices(1)       =  "ANTENNA"
!!$    scaleChoices(2)       =  "BEAM"
!!$    !
!!$    widthChoices(1)       =  "NARROW"
!!$    widthChoices(2)       =  "WIDE"
    !
  End Subroutine initializeReceiverChoices
!!!
!!!
  Subroutine initializeSystemNameChoices
    ! TBD: SR IS DEPRECATED
    !
    !D          Write (6,*) "   moduleGlobalParameters: SR initializeSystemNameChoices"
    !
    ! TBD: SYSTEMNAMECHOICES IS OBSOLETE
    systemNameChoices(1)    = "PROJECTION"
    systemNameChoices(2)    = "DESCRIPTIVE"
    systemNameChoices(3)    = "BASIS"
    systemNameChoices(4)    = "EQUATORIAL"
    systemNameChoices(5)    = "HA/DECL"
    systemNameChoices(6)    = "HORIZONTAL"
    systemNameChoices(7)    = "NASMYTH"
    !
    ! TBD: OFFSETSYSTEMNAMECHOICES IS OBSOLETE
    offsetSystemChoices(iPROJECTION ) = "PROJECTION" 
    offsetSystemChoices(iDESCRIPTIVE) = "DESCRIPTIVE"
    offsetSystemChoices(iBASIS      ) = "BASIS"      
    offsetSystemChoices(iEQUATORIAL ) = "EQUATORIAL" 
    offsetSystemChoices(iHADEC      ) = "HADEC "     
    offsetSystemChoices(iHORIZONTRUE) = "TRUEHORIZON"
    offsetSystemChoices(iHORIZON    ) = "HORIZONTAL" 
    offsetSystemChoices(iNASMYTH    ) = "NASMYTH"    
    !
    !D          do ii = 1, nDimOffsets, 1
    !D             Write (6,*) ii, offsetSystemChoices(ii)
    !D          end do
    !
  End Subroutine initializeSystemNameChoices
!!!
!!!
End Module modulePakoGlobalParameters

subroutine contng (ndp,xd,yd,ntr,ipt,nli,ipl,iwl,iwp,wk)
  use gcont_interfaces, except_this=>contng
  use gcont_contour
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !	This subroutine performs triangulation.  It divides the X-Y
  !	plane into a number of triangles according to given data
  !	points in the plane, determines line segments that form the
  !	border of data area, and determines the triangle numbers
  !	corresponding to the border line segments.
  !	At completion, point numbers of the vertexes of each triangle
  !	are listed counter-clockwise.  Point numbers of the end points
  !	of each border line segment are listed counter-clockwise,
  !	listing order of the line segments being counter-clockwise.
  ! Arguments :
  !	NDP 	I	Number of data points			Input
  !	XD  	R*4 (*)	Array of dimension NDP containing the
  !			X coordinates of the data points	Input
  !	YD  	R*4 (*) Array of Y coordinates			Input
  !	NTR  	I	Number of triangles			Output
  !	IPT 	I (*)	Array of dimension 6*NDP-15, where the
  !			point numbers of the vertexes of the
  !			(IT)th triangle are to be stored as the
  !			(3*IT-2)nd, (3*IT-1)st, and (3*IT)th
  !			elements, IT=1,2,...,NTR		Output
  !	NLI  	I	Number of border line segments		Output
  !	IPL 	I (*)	Array of dimension 6*NDP, where the point
  !			numbers of the end points of the (IL)th
  !			border line segment and its respective
  !			triangle number are to be stored as the
  !			(3*IL-2)nd, (3*IL-1)st, and (3*IL)th
  !			elements, IL=1,2,..., NLI.		Output
  !	IWL 	I (*)	Array of dimension 18*NDP used
  !			internally as a work area
  !	IWP 	I (*)	Array of dimension NDP used
  !			internally as a work area
  !	WK  	R*4 (*)	Array of dimension NDP used
  !			internally as a work area.
  ! No subroutine referenced
  !---------------------------------------------------------------------
  integer :: ndp                    !
  real :: xd(*)                     !
  real :: yd(*)                     !
  integer :: ntr                    !
  integer :: ipt(*)                 !
  integer :: nli                    !
  integer :: ipl(*)                 !
  integer :: iwl(*)                 !
  integer :: iwp(*)                 !
  real :: wk(*)                     !
  ! Local
  character(len=*), parameter :: rname='RANDOM'
  ! real dsqf,u1,v1,u2,v2,u3,v3,side
  character(len=72) :: messag
  integer :: itf(2)
  integer :: nrep, ndpm1, ipmn1, ipmn2, ip1, ip1p1, ip2
  real :: ratio, dsqmn, x1, y1, dsqi, dsq12, xdmp, ydmp, dsqmx
  integer :: jp1, jpmn, jp2, its, jp, ip, jpmx, jpc, ip3
  integer :: nt0, ntt3, nl0, nlt3, nsh, nsht3, jp2t3
  real :: ar, dx21, dy21, dxmn, dymn, armn, dxmx, dymx, armx
  integer :: jp3t3, jwl, ipl1, ipl2, it, nln, nlnt3, itt3
  real :: dx, dy
  integer :: ipti, nlf, ntt3p3, irep, ilf, ilft2, ntf
  integer :: itt3r, ipt1, ipt2, ipt3, it1t3, ipti1, it2t3, ipti2
  integer :: jlt3, iplj1, iplj2, nlfc, jwl1mn, nlft2, jwl1
  ! Data
  data ratio /1.0e-6/, nrep/100/
  !
  ! Statement functions
  !      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
  !      SIDE(U1,V1,U2,V2,U3,V3) = (V3-V1)*(U2-U1)-(U3-U1)*(V2-V1)
  !
  ! Preliminary processing
  ndpm1 = ndp-1
  !
  ! Determines the closest pair of data points and their midpoint.
  dsqmn = dsqf(xd(1),yd(1),xd(2),yd(2))
  ipmn1 = 1
  ipmn2 = 2
  do ip1=1,ndpm1
    x1 = xd(ip1)
    y1 = yd(ip1)
    ip1p1 = ip1+1
    do ip2=ip1p1,ndp
      dsqi = dsqf(x1,y1,xd(ip2),yd(ip2))
      if (dsqi .ne. 0.) go to  120
      !
      ! Error, identical input data points
      write(messag,1000) ip1,ip2
      call gcont_message(seve%e,rname,messag)
      irec = 4
      return
      !
120   continue
      if (dsqi .ge. dsqmn) go to  130
      dsqmn = dsqi
      ipmn1 = ip1
      ipmn2 = ip2
130   continue
    enddo                      ! 130
  enddo
  dsq12 = dsqmn
  xdmp = (xd(ipmn1)+xd(ipmn2))/2.0
  ydmp = (yd(ipmn1)+yd(ipmn2))/2.0
  !
  ! Sorts the other (NDP-2) data points in ascending order of
  ! distance from the midpoint and stores the sorted data point
  ! numbers in the IWP array.
  jp1 = 2
  do ip1=1,ndp
    if (ip1.eq.ipmn1 .or. ip1.eq.ipmn2)  go to 150
    jp1 = jp1+1
    iwp(jp1) = ip1
    wk(jp1) = dsqf(xdmp,ydmp,xd(ip1),yd(ip1))
150 continue
  enddo
  do jp1=3,ndpm1
    dsqmn = wk(jp1)
    jpmn = jp1
    do jp2=jp1,ndp
      if (wk(jp2) .ge. dsqmn)  go to 160
      dsqmn = wk(jp2)
      jpmn = jp2
160   continue
    enddo
    its = iwp(jp1)
    iwp(jp1) = iwp(jpmn)
    iwp(jpmn) = its
    wk(jpmn) = wk(jp1)
  enddo
  !
  ! If necessary, modifies the ordering in such a way that the
  ! first three data points are not collinear.
  ar = dsq12*ratio
  x1 = xd(ipmn1)
  y1 = yd(ipmn1)
  dx21 = xd(ipmn2)-x1
  dy21 = yd(ipmn2)-y1
  do jp=3,ndp
    ip = iwp(jp)
    if (abs((yd(ip)-y1)*dx21-(xd(ip)-x1)*dy21) .gt. ar) then
      jpmx = jp
      go to 190
    endif
  enddo
  !
  ! Error: Collinear data points
  call gcont_message(seve%e,rname,'All data points are collinear')
  irec = 3
190 continue
  if (jpmx.eq.3)  go to 210
  !      jpmx = jp
  jp = jpmx+1
  do jpc=4,jpmx
    jp = jp-1
    iwp(jp) = iwp(jp-1)
  enddo
  iwp(3) = ip
  !
  ! Forms the first triangle.  stores point numbers of the ver-
  ! texes of the triangle in the IPT array, and stores point num-
  ! bers of the border line segments and the triangle number in
  ! the IPL array.
210 ip1 = ipmn1
  ip2 = ipmn2
  ip3 = iwp(3)
  if (side(xd(ip1),yd(ip1),xd(ip2),yd(ip2),xd(ip3),yd(ip3)).ge.0.0)  go to 220
  ip1 = ipmn2
  ip2 = ipmn1
220 nt0 = 1
  ntt3 = 3
  ipt(1) = ip1
  ipt(2) = ip2
  ipt(3) = ip3
  nl0 = 3
  nlt3 = 9
  ipl(1) = ip1
  ipl(2) = ip2
  ipl(3) = 1
  ipl(4) = ip2
  ipl(5) = ip3
  ipl(6) = 1
  ipl(7) = ip3
  ipl(8) = ip1
  ipl(9) = 1
  !
  ! Adds the remaining (NDP-3) data points, one by one.
  do jp1=4,ndp                 ! DO 400
    ip1 = iwp(jp1)
    x1 = xd(ip1)
    y1 = yd(ip1)
    !
    ! Determines the visible border line segments.
    ip2 = ipl(1)
    jpmn = 1
    dxmn = xd(ip2)-x1
    dymn = yd(ip2)-y1
    dsqmn = dxmn*dxmn+dymn*dymn
    armn = dsqmn*ratio
    jpmx = 1
    dxmx = dxmn
    dymx = dymn
    dsqmx = dsqmn
    armx = armn
    do jp2=2,nl0               ! DO 240
      ip2 = ipl(3*jp2-2)
      dx = xd(ip2)-x1
      dy = yd(ip2)-y1
      ar = dy*dxmn-dx*dymn
      if (ar.gt.armn)  go to 230
      dsqi = dx*dx+dy*dy
      if (ar.ge.(-armn) .and. dsqi.ge.dsqmn)  go to 230
      jpmn = jp2
      dxmn = dx
      dymn = dy
      dsqmn = dsqi
      armn = dsqmn*ratio
230   ar = dy*dxmx-dx*dymx
      if (ar.lt.(-armx))  go to 240
      dsqi = dx*dx+dy*dy
      if (ar.le.armx .and. dsqi.ge.dsqmx)  go to 240
      jpmx = jp2
      dxmx = dx
      dymx = dy
      dsqmx = dsqi
      armx = dsqmx*ratio
240   continue
    enddo
    if (jpmx .lt. jpmn) jpmx = jpmx+nl0
    nsh = jpmn-1
    if (nsh .le. 0)  go to 270
    !
    ! Shifts (rotates) the IPL array to have the invisible border
    ! line segments contained in the first part of the IPL array.
    nsht3 = nsh*3
    do  jp2t3=3,nsht3,3
      jp3t3 = jp2t3+nlt3
      ipl(jp3t3-2) = ipl(jp2t3-2)
      ipl(jp3t3-1) = ipl(jp2t3-1)
      ipl(jp3t3) = ipl(jp2t3)
    enddo
    do  jp2t3=3,nlt3,3
      jp3t3 = jp2t3+nsht3
      ipl(jp2t3-2) = ipl(jp3t3-2)
      ipl(jp2t3-1) = ipl(jp3t3-1)
      ipl(jp2t3) = ipl(jp3t3)
    enddo
    jpmx = jpmx-nsh
    !
    ! Adds triangles to the IPT array, updates border line
    ! segments in the IPL array, and sets flags for the border
    ! line segments to be reexamined in the IWL array.
270 jwl = 0
    do jp2=jpmx,nl0
      jp2t3 = jp2*3
      ipl1 = ipl(jp2t3-2)
      ipl2 = ipl(jp2t3-1)
      it = ipl(jp2t3)
      !
      ! Adds a triangle to the IPT array.
      nt0 = nt0+1
      ntt3 = ntt3+3
      ipt(ntt3-2) = ipl2
      ipt(ntt3-1) = ipl1
      ipt(ntt3) = ip1
      !
      ! Updates border line segments in the IPL array.
      if (jp2 .ne. jpmx)  go to 280
      ipl(jp2t3-1) = ip1
      ipl(jp2t3) = nt0
280   continue
      if (jp2 .ne. nl0)  go to 290
      nln = jpmx+1
      nlnt3 = nln*3
      ipl(nlnt3-2) = ip1
      ipl(nlnt3-1) = ipl(1)
      ipl(nlnt3) = nt0
      !
      ! Determines the vertex that does not lie on the border
      ! line segments.
290   itt3 = it*3
      ipti = ipt(itt3-2)
      if (ipti.ne.ipl1 .and. ipti.ne.ipl2)  go to 300
      ipti = ipt(itt3-1)
      if (ipti.ne.ipl1 .and. ipti.ne.ipl2)  go to 300
      ipti = ipt(itt3)
      !
      ! Checks if the exchange is necessary.
300   continue
      if (conxch(xd,yd,ip1,ipti,ipl1,ipl2).eq.0)  go to 310
      !
      ! Modifies the IPT array when necessary.
      ipt(itt3-2) = ipti
      ipt(itt3-1) = ipl1
      ipt(itt3) = ip1
      ipt(ntt3-1) = ipti
      if (jp2 .eq. jpmx) ipl(jp2t3) = it
      if (jp2.eq.nl0 .and. ipl(3).eq.it) ipl(3) = nt0
      !
      ! Sets flags in the IWL array.
      jwl = jwl+4
      iwl(jwl-3) = ipl1
      iwl(jwl-2) = ipti
      iwl(jwl-1) = ipti
      iwl(jwl) = ipl2
310   continue
    enddo
    nl0 = nln
    nlt3 = nlnt3
    nlf = jwl/2
    if (nlf .eq. 0)  go to 400
    !
    ! Improves triangulation.
    ntt3p3 = ntt3+3
    do irep=1,nrep
      do ilf=1,nlf
        ilft2 = ilf*2
        ipl1 = iwl(ilft2-1)
        ipl2 = iwl(ilft2)
        !
        ! Locates in the IPT array two triangles on both sides of
        ! the flagged line segment.
        ntf = 0
        do itt3r=3,ntt3,3
          itt3 = ntt3p3-itt3r
          ipt1 = ipt(itt3-2)
          ipt2 = ipt(itt3-1)
          ipt3 = ipt(itt3)
          if (ipl1.ne.ipt1 .and. ipl1.ne.ipt2 .and. ipl1.ne.ipt3)  go to 320
          if (ipl2.ne.ipt1 .and. ipl2.ne.ipt2 .and. ipl2.ne.ipt3)  go to 320
          ntf = ntf+1
          itf(ntf) = itt3/3
          if (ntf.eq.2)  go to 330
320       continue
        enddo
        if (ntf.lt.2) go to 370
        !
        ! Determines the vertexes of the triangles that do not lie
        ! on the line segment.
330     it1t3 = itf(1)*3
        ipti1 = ipt(it1t3-2)
        if (ipti1.ne.ipl1 .and. ipti1.ne.ipl2) go to  340
        ipti1 = ipt(it1t3-1)
        if (ipti1.ne.ipl1 .and. ipti1.ne.ipl2) go to  340
        ipti1 = ipt(it1t3)
340     it2t3 = itf(2)*3
        ipti2 = ipt(it2t3-2)
        if (ipti2.ne.ipl1 .and. ipti2.ne.ipl2) go to  350
        ipti2 = ipt(it2t3-1)
        if (ipti2.ne.ipl1 .and. ipti2.ne.ipl2) go to  350
        ipti2 = ipt(it2t3)
        !
        ! Checks if the exchange is necessary.
350     continue
        if (conxch(xd,yd,ipti1,ipti2,ipl1,ipl2).eq.0)  go to 370
        !
        ! Modifies the IPT array when necessary.
        ipt(it1t3-2) = ipti1
        ipt(it1t3-1) = ipti2
        ipt(it1t3) = ipl1
        ipt(it2t3-2) = ipti2
        ipt(it2t3-1) = ipti1
        ipt(it2t3) = ipl2
        !
        ! Sets new flags.
        jwl = jwl+8
        iwl(jwl-7) = ipl1
        iwl(jwl-6) = ipti1
        iwl(jwl-5) = ipti1
        iwl(jwl-4) = ipl2
        iwl(jwl-3) = ipl2
        iwl(jwl-2) = ipti2
        iwl(jwl-1) = ipti2
        iwl(jwl) = ipl1
        do jlt3=3,nlt3,3
          iplj1 = ipl(jlt3-2)
          iplj2 = ipl(jlt3-1)
          if ((iplj1.eq.ipl1 .and. iplj2.eq.ipti2) .or.  &
              (iplj2.eq.ipl1 .and. iplj1.eq.ipti2))  ipl(jlt3) = itf(1)
          if ((iplj1.eq.ipl2 .and. iplj2.eq.ipti1) .or.  &
              (iplj2.eq.ipl2 .and. iplj1.eq.ipti1))  ipl(jlt3) = itf(2)
        enddo
370     continue
      enddo
      nlfc = nlf
      nlf = jwl/2
      if (nlf.eq.nlfc)  go to 400
      !
      ! Resets the IWL array for the next round.
      !
      jwl = 0
      jwl1mn = (nlfc+1)*2
      nlft2 = nlf*2
      do jwl1=jwl1mn,nlft2,2
        jwl = jwl+2
        iwl(jwl-1) = iwl(jwl1-1)
        iwl(jwl) = iwl(jwl1)
      enddo
      nlf = jwl/2
    enddo
400 continue
  enddo
  !
  ! Rearrange the IPT array so that the vertexes of each triangle
  ! are listed counter-clockwise.
  do  itt3=3,ntt3,3
    ip1 = ipt(itt3-2)
    ip2 = ipt(itt3-1)
    ip3 = ipt(itt3)
    if (side(xd(ip1),yd(ip1),xd(ip2),yd(ip2),xd(ip3),yd(ip3)).ge.0.0)  go to 410
    ipt(itt3-2) = ip2
    ipt(itt3-1) = ip1
410 continue
  enddo
  ntr = nt0
  nli = nl0
  return
1000 format('Identical input data points found at ',i5,' and ',i5)
  !
contains
  real function dsqf(u1,v1,u2,v2)
    real :: u1                      !
    real :: v1                      !
    real :: u2                      !
    real :: v2                      !
    dsqf  = (u2-u1)**2+(v2-v1)**2
  end function dsqf
  !
  real function side(u1,v1,u2,v2,u3,v3)
    real :: u1                      !
    real :: v1                      !
    real :: u2                      !
    real :: v2                      !
    real :: u3                      !
    real :: v3                      !
    side = (v3-v1)*(u2-u1)-(u3-u1)*(v2-v1)
  end function side
  !
end subroutine contng

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_touch
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_messaging
  !
  public :: touch
  private
  !
  type :: touch_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
   contains
     procedure, public  :: register => cubeadm_touch_register
     procedure, private :: parse    => cubeadm_touch_parse
     procedure, private :: main     => cubeadm_touch_main
  end type touch_comm_t
  type(touch_comm_t) :: touch
  !
  type touch_user_t
     type(cubeid_user_t) :: cubeids
   contains
     procedure, private :: toprog => cubeadm_touch_user_toprog
  end type touch_user_t
  !
  type touch_prog_t
     type(cube_t), pointer :: cube
   contains
     procedure, private :: data => cubeadm_touch_prog_data
  end type touch_prog_t
  !
contains
  !
  subroutine cubeadm_touch_command(line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(touch_user_t) :: user
    character(len=*), parameter :: rname='TOUCH>COMMAND'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call touch%parse(line,user,error)
    if (error) return
    call touch%main(user,error)
    if (error) continue
  end subroutine cubeadm_touch_command
  !
  subroutine cubeadm_touch_register(comm,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(touch_comm_t), intent(inout) :: comm
    logical,             intent(inout) :: error
    !
    type(cubeid_arg_t) :: cube
    character(len=*), parameter :: rname='TOUCH>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'TOUCH','[CubeId]',&
         'Touch the file so that its data is pre-loaded in memory',&
         'This only makes sense if the input files are accessible in memory mode.',&
         cubeadm_touch_command,&
         comm%comm,&
         error)
    if (error) return
    call cube%register(&
         'CUBE',&
         'Any cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&  ! An access with no enforced order
         comm%cube,&
         error)
    if (error) return
  end subroutine cubeadm_touch_register
  !
  subroutine cubeadm_touch_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(touch_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(touch_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOUCH>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubeadm_touch_parse
  !
  subroutine cubeadm_touch_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(touch_comm_t), intent(in)    :: comm
    type(touch_user_t),  intent(inout) :: user
    logical,             intent(inout) :: error
    !
    type(touch_prog_t) :: prog
    character(len=*), parameter :: rname='TOUCH>MAIN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubeadm_touch_main
  !
  subroutine cubeadm_touch_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(touch_user_t), intent(in)    :: user
    type(touch_comm_t),  intent(in)    :: comm
    type(touch_prog_t),  intent(out)   :: prog
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOUCH>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
  end subroutine cubeadm_touch_user_toprog
  !
  subroutine cubeadm_touch_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(touch_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    logical :: status
    character(len=*), parameter :: rname='TOUCH>PROG>DATA'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    ! Touch is done by preparing a first iteration (i.e. prepare
    ! the appropriate buffers, namely load the cube in memory)
    status = cubeadm_dataiterate_all(iter,error)
    if (error)  return
  end subroutine cubeadm_touch_prog_data
  !
end module cubeadm_touch
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_read_subscan_data(imbf,subs,tochunk,databuf,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_read_subscan_data
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ public
  ! Read part of the DATA column from the current subscan (i.e. the
  ! current one CFITSIO is positioned in), and implicitely convert it
  ! in chunksets.
  !---------------------------------------------------------------------
  type(imbfits_t),         intent(in)    :: imbf
  type(imbfits_subscan_t), intent(in)    :: subs
  logical,                 intent(in)    :: tochunk
  type(data_buffer_t),     intent(inout) :: databuf
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='READ>SUBSCAN>DATA'
  integer(kind=4) :: nchan,npix
  type(range_t) :: drange
  !
  if (databuf%time%cur%n.eq.0) then
    ! We actually want a warning (no error), but we have to check twice
    ! the subsequent protection for 0-sized arrays...
    call mrtcal_message(seve%e,rname,'Nothing to read')
    error = .true.
    return
  endif
  !
  ! 1) Data only
  nchan = subs%backdata%head%channels%val
  npix  = 1  ! ZZZ TBD: set correctly
  ! Compute DATA range to read from compressed range:
  call mrtcal_bookkeeping_compr2uncompr(databuf%time%cur,  &
    subs%backdata%table%backpoin%val,drange,error)
  if (error)  return
  call imbfits_read_data(rname,         &
                         imbf%file,     &
                         nchan,         &
                         npix,          &
                         drange%first,  &
                         drange%n,      &  ! Number of non-compressed DATA rows to read
                         databuf%imbf,  &
                         error)
  if (error)  return
  !
  if (tochunk) then
    ! 2) Convert in chunk sets
    call mrtcal_chunksets_from_data(imbf,subs,databuf,error)
    if (error)  return
  endif
  !
end subroutine mrtcal_read_subscan_data
!
subroutine mrtcal_free_subscan_data(databuf,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_free_subscan_data
  use mrtcal_buffer_types
  !---------------------------------------------------------------------
  ! @ private
  ! Free of the DATA column from the current subscan, and its conversion
  ! in chunksets.
  !---------------------------------------------------------------------
  type(data_buffer_t), intent(inout) :: databuf
  logical,             intent(inout) :: error
  !
  ! 1) Data only
  call imbfits_free_data(databuf%imbf,error)
  if (error)  return
  !
  ! 2) Conversion in chunk sets
  call databuf%mrtc%free(error)
  if (error)  return
  !
end subroutine mrtcal_free_subscan_data
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_list
  use cubetools_parameters
  use cubelist_types
  use cubetools_structure
  use cubetemplate_messaging
  !---------------------------------------------------------------------
  ! This template shows how to use the generic list types available in
  !   cube/lib/core/list/type-list.f90
  ! Such lists rely on 3 types:
  !   1) list_object_t:
  !      all objects you want to reference in the list must be extended
  !      from this type. This type is completely empty, you can do
  !      nothing with it except extending for your use case.
  !   2) list_object_p_t:
  !      pointer to a class(list_object_t). The main goal of this
  !      object is that it is much more efficient to deal with a list
  !      of pointers (in particular to increase the size of the list
  !      below). It provides 3 important methods:
  !        p%allocate(model,error): allocate a new object based on the
  !                                 model passed as argument. The model
  !                                 is a dummy object of the type to be
  !                                 stored.
  !        p%associate(target,error): same as allocate but the object is
  !                                   already allocated on your side, you
  !                                   just want to associate the pointer
  !                                   to the given target.
  !        p%nullify(error): nullify the pointer, performing the proper
  !                          cleaning, in particular deallocating the
  !                          object if it was allocated.
  !   3) list_t:
  !      the list of objects, more precisely list of pointers to objects
  !      of class(list_object_t). Its basic contents are:
  !        type(list_t) :: a
  !          a%n:         number of useful components in the list
  !          a%list(i)    the i-th list_object_p_t
  !          a%list(i)%p: pointer to the i-th object of class(list_object_t)
  !      Note that the list can store pointers to differents types,
  !      this is possible as long as they are all of
  !      class(list_object_t). The list_t also provides public methods
  !      shown in this template.
  !      You can extend the list_t if you want more features, e.g.
  !      to add an additional descriptive array of the same size of the
  !      list.
  !
  ! All in all, main pros and cons are:
  !  - pros: we have a generic list type which factorizes features and
  !          methods like (re)allocation/deallocation, dealing with
  !          allocated or associated targets.
  !  - cons: the drawback is that we deal with generic objects of class
  !          list_object_t. We can not do anything with these, we have
  !          to get the pointer to the actual type to work on it.
  !---------------------------------------------------------------------
  !
  public :: list
  private
  !
  ! --- Data-related types ---
  !
  ! A custom object with just a name:
  type, extends(list_object_t) :: template_object_t
    character(len=16) :: name=''
  contains
    procedure, private :: dump  => cubetemplate_object_dump
    procedure, public  :: final => cubetemplate_object_final
  end type template_object_t
  !
  ! A custom list with custom methods. Extending the basic type or not
  ! depends if you need extra features.
  type, extends(list_t) :: template_list_t
  contains
    procedure, private :: dump => cubetemplate_list_dump
  end type template_list_t
  !
  ! A list of objects; in this example this list has a permanent life
  ! and is hosted in the current module.
  type(template_list_t) :: collection
  !
  ! --- Command-related types ---
  type :: list_comm_t
    type(option_t), pointer :: comm
    type(option_t), pointer :: allocate
    type(option_t), pointer :: associate
    type(option_t), pointer :: free
  contains
    procedure, public  :: register => cubetemplate_list_comm_register
    procedure, private :: parse    => cubetemplate_list_comm_parse
    procedure, private :: main     => cubetemplate_list_comm_main
  end type list_comm_t
  type(list_comm_t) :: list
  !
  type :: list_user_t
    logical :: doallocate
    logical :: doassociate
    logical :: dofree
  contains
    procedure, private :: toprog => cubetemplate_list_user_toprog
  end type list_user_t
  !
  type :: list_prog_t
    logical :: doallocate
    logical :: doassociate
    logical :: dofree
  contains
    procedure, private :: act       => cubetemplate_list_prog_act
    procedure, private :: allocate  => cubetemplate_list_prog_allocate
    procedure, private :: associate => cubetemplate_list_prog_associate
    procedure, private :: free      => cubetemplate_list_prog_free
  end type list_prog_t
  !
contains
  !
  subroutine cubetemplate_list_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(list_user_t) :: user
    character(len=*), parameter :: rname='LIST>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call list%parse(line,user,error)
    if (error) return
    call list%main(user,error)
    if (error) continue
  end subroutine cubetemplate_list_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_list_comm_register(comm,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(list_comm_t), intent(inout) :: comm
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='LIST>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'LIST','',&
         'Test the Fortran list type',&
         'Exercise the internal Fortran list type used by template code&
         & paths.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Without option, LIST dumps current the list contents.'//strg_cr//&
         '- The /ALLOCATE key adds one newly allocated object to the list.'//strg_cr//&
         '- The /ASSOCIATE key links one external object in the list.'//strg_cr//&
         '- The /FREE key releases allocated targets and resets the list.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         '  CUBE> LIST            ! Empty at first'//strg_cr//&
         '  CUBE> LIST /ALLOCATE  ! Allocate a 1st object'//strg_cr//&
         '  CUBE> LIST /ALLOCATE  ! Allocate a 2nd object'//strg_cr//&
         '  CUBE> LIST /ASSOCIATE ! Associate a 3rd object'//strg_cr//&
         '  CUBE> LIST /ALLOCATE  ! Allocate a 4th object'//strg_cr//&
         '  CUBE> LIST            ! Dump the contents'//strg_cr//&
         '  CUBE> LIST /FREE      ! Free the list'//strg_cr//&
         '  CUBE> LIST            ! Empty at last.',&
         cubetemplate_list_command,&
         comm%comm,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'ALLOCATE','',&
         'Allocate a new object in the list',&
         strg_emp,&
         comm%allocate,error)
    if (error) return
    !
    call cubetools_register_option(&
         'ASSOCIATE','',&
         'Associate a new object in the list',&
         strg_emp,&
         comm%associate,error)
    if (error) return
    !
    call cubetools_register_option(&
         'FREE','',&
         'Free the allocated targets and the list itself',&
         strg_emp,&
         comm%free,error)
    if (error) return
  end subroutine cubetemplate_list_comm_register
  !
  subroutine cubetemplate_list_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! LIST
    !  /ALLOCATE
    !  /ASSOCIATE
    !  /FREE
    !----------------------------------------------------------------------
    class(list_comm_t), intent(in)    :: comm
    character(len=*),   intent(in)    :: line
    type(list_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='LIST>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! ZZZ the options are exclusive
    call comm%allocate%present(line,user%doallocate,error)
    if (error)  return
    call comm%associate%present(line,user%doassociate,error)
    if (error)  return
    call comm%free%present(line,user%dofree,error)
    if (error)  return
  end subroutine cubetemplate_list_comm_parse
  !
  subroutine cubetemplate_list_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(list_comm_t), intent(in)    :: comm
    type(list_user_t),  intent(inout) :: user
    logical,            intent(inout) :: error
    !
    type(list_prog_t) :: prog
    character(len=*), parameter :: rname='LIST>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%act(error)
    if (error) continue
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_list_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_list_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !--------------------------------------------------------------------
    !
    !--------------------------------------------------------------------
    class(list_user_t), intent(in)    :: user
    type(list_comm_t),  intent(in)    :: comm
    type(list_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='LIST>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    prog%doallocate  = user%doallocate
    prog%doassociate = user%doassociate
    prog%dofree      = user%dofree
  end subroutine cubetemplate_list_user_toprog
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetemplate_list_prog_act(prog,error)
    !-------------------------------------------------------------------
    ! Actual work
    !-------------------------------------------------------------------
    class(list_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    if (prog%doallocate) then
      ! Add a new allocated object
      call prog%allocate(collection,error)
      if (error)  return
    elseif (prog%doassociate) then
      ! Add a new associated object
      call prog%associate(collection,error)
      if (error)  return
    elseif (prog%dofree) then
      ! Free the list
      call prog%free(collection,error)
      if (error)  return
    else
      ! Default: dump the list
      call collection%dump(error)
      if (error)  return
    endif
  end subroutine cubetemplate_list_prog_act
  !
  subroutine cubetemplate_list_prog_allocate(prog,list,error)
    !-------------------------------------------------------------------
    ! Allocate a new object in the list and fill it with some value.
    ! Main advantage: I do not have to deal with the allocation of the
    ! object and save it in a way or another; the number of allocations
    ! is virtually unlimited.
    !-------------------------------------------------------------------
    class(list_prog_t),    intent(in)    :: prog
    type(template_list_t), intent(inout) :: list
    logical,               intent(inout) :: error
    !
    type(template_object_t) :: model  ! Just a dummy model (template) for the Fortran allocation
    class(list_object_t), pointer :: lot
    type(template_object_t), pointer :: obj  ! Pointer to the actual object
    character(len=*), parameter :: rname='LIST>PROG>ALLOCATE'
    !
    ! Allocate a new object at the end of the list
    call list%allocate(model,lot,error)
    if (error)  return
    !
    ! On return 'lot' is a pointer to this newly allocated object,
    ! but of basic class: fetch a pointer of proper type
    obj => cubetemplate_object_ptr(lot,error)
    if (error)  return
    !
    ! Now work with the object
    write(obj%name,'(a,i0,a)') '#',list%n,' allocated'
  end subroutine cubetemplate_list_prog_allocate
  !
  subroutine cubetemplate_list_prog_associate(prog,list,error)
    !-------------------------------------------------------------------
    ! Associate a new object in the list and fill it with some value.
    ! Main advantage: I directly have the object at hand to work on it.
    ! But: I have to deal by myself with the life of my objects.
    !-------------------------------------------------------------------
    class(list_prog_t),    intent(in)    :: prog
    type(template_list_t), intent(inout) :: list
    logical,               intent(inout) :: error
    !
    type(template_object_t), save :: myobject
    character(len=*), parameter :: rname='LIST>PROG>ASSOCIATE'
    !
    ! For this example, I have only one target object available (note the
    ! SAVE attribute). In a real use-case, you would have to ensure that
    ! each target exists as long as the list references it.
    if (index(myobject%name,'associated').ne.0) then
      call cubetemplate_message(seve%e,rname,  &
        'This example can not associate more than 1 object in list')
      error = .true.
      return
    endif
    !
    ! Associate the object at the end of the list
    call list%associate(myobject,error)
    if (error)  return
    !
    ! Work with the object
    write(myobject%name,'(a,i0,a)') '#',list%n,' associated'
  end subroutine cubetemplate_list_prog_associate
  !
  subroutine cubetemplate_list_prog_free(prog,list,error)
    !-------------------------------------------------------------------
    ! Free the list. Main actions:
    !  - free the objects allocated in the list, if any.
    !  - nullify the associated pointers to target objects, if any.
    !    Obviously the targets are not modified.
    !  - free the list array itself.
    !-------------------------------------------------------------------
    class(list_prog_t),    intent(in)    :: prog
    type(template_list_t), intent(inout) :: list
    logical,               intent(inout) :: error
    !
    call list%final(error)
    if (error)  return
  end subroutine cubetemplate_list_prog_free
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetemplate_list_dump(list,error)
    !-------------------------------------------------------------------
    ! Dump the whole list
    !-------------------------------------------------------------------
    class(template_list_t), intent(in)    :: list
    logical,                intent(inout) :: error
    !
    integer(kind=list_k) :: i
    type(template_object_t), pointer :: obj
    !
    print *,list%n,' elements in list'
    do i=1,list%n
      obj => cubetemplate_object_ptr(list%list(i)%p,error)
      if (error)  return
      call obj%dump(error)
      if (error)  return
    enddo
  end subroutine cubetemplate_list_dump
  !
  !---------------------------------------------------------------------
  !
  function cubetemplate_object_ptr(obj,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(template_object_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    type(template_object_t), pointer :: cubetemplate_object_ptr
    class(list_object_t),    pointer       :: obj
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBJECT>PTR'
    !
    select type(obj)
    type is (template_object_t)
      cubetemplate_object_ptr => obj
    class default
      cubetemplate_object_ptr => null()
      call cubetemplate_message(seve%e,rname,  &
        'Internal error: object is not a template_object_t type')
      error = .true.
      return
    end select
  end function cubetemplate_object_ptr
  !
  subroutine cubetemplate_object_dump(obj,error)
    !-------------------------------------------------------------------
    ! Dump one object
    !-------------------------------------------------------------------
    class(template_object_t), intent(in)    :: obj
    logical,                  intent(inout) :: error
    !
    print *,'Name: ',obj%name
  end subroutine cubetemplate_object_dump
  !
  subroutine cubetemplate_object_final(obj,error)
    !-------------------------------------------------------------------
    ! Finalize one object.
    !
    ! The types extended from list_object_t must provides an explicit
    ! 'final' method of the following form. It is typically relevant if
    ! your type contains data which should be properly cleaned (e.g.
    ! deallocation, buffer flushing, etc) before the object itself is
    ! destroyed.
    !
    ! This method is implicitly called by the 'list_t' methods which
    ! destroy one (or all) nodes.
    !-------------------------------------------------------------------
    class(template_object_t), intent(inout) :: obj
    logical,                  intent(inout) :: error
    !
    ! Nothing to do in this example
  end subroutine cubetemplate_object_final
  !
end module cubetemplate_list
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program table
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone program
  !	Builds a table from list-directed input file
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: outfile,infile,filein
  integer :: nline,ncol, ier
  logical :: error
  type(gildas) :: x
  real, allocatable :: array(:,:)
  !
  error = .false.
  !
  call gildas_open
  call gildas_char('FILE$',filein)
  call gildas_char('TABLE$',outfile)
  call gildas_inte('LINES$',nline,1)
  call gildas_inte('COLUMNS$',ncol,1)
  call gildas_close
  !
  call sic_parsef(filein,infile,' ','.dat')
  ier = sic_open (1,infile,'OLD',.true.)
  if (ier.ne.0) then
    call gagout('F-TABLE,  Cannot read data file ')
    call putios('E-TABLE,  ',ier)
    goto 100
  endif
  if (nline.le.0) then
    call gagout ('W-TABLE,  Trying to guess how many lines')
	allocate(array(1,ncol),stat=ier)
	if (ier.ne.0) then
		call gagout('E-TABLE,  Memory allocation error')
		goto 100
	endif
    call subread_one(nline,ncol,array,error)
    if (error) goto 100
    deallocate(array)
    rewind(1)
  else
    call gagout ('W-TABLE,  Assuming exact number of lines')
  endif
  !
  allocate(array(nline,ncol),stat=ier)
  if (ier.ne.0) then
    call gagout('E-TABLE, Memory allocation error')
    error = .true.
	  goto 100
  endif
  call subread_all(nline,ncol,array,error)
  if (error) goto 100
  !
  ! Create new file
  call gildas_null (x, TYPE = 'TABLE')
  x%gil%dim(1) = nline
  x%gil%dim(2) = ncol
  call sic_parsef(outfile,x%file,' ','.dat')
  !
  call gdf_write_image(x,array,error)
  if (error) goto 100
  call gagout ('S-TABLE,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program table
!
subroutine subread_one(nline,ncol,work,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     Modif GD (27/11/92) permettant de lire des fichiers avec commentaires
  !     Cleaned-up by S.G.
  !---------------------------------------------------------------------
  integer, intent(out)   :: nline                  !
  integer, intent(in)    :: ncol                   !
  real,    intent(out)   :: work(ncol)             !
  logical, intent(inout) :: error                  !
  ! Local
  character(len=80) :: line
  integer :: i,ier
  !
  i = 0
  do while(.true.)
    read(1,*,iostat=ier,end=10) work
    if (ier.eq.0) i = i+1
  enddo
10 continue
  if (i.eq.0) then
    call gagout('E-TABLE,  No Valid Lines Found')
    error = .true.
    return
  endif
  nline = i
  write (line,1000) nline
  call  gagout(line)
1000 format('I-TABLE,  Found ',i8,' valid lines')
end subroutine subread_one
!
subroutine subread_all(nline,ncol,work,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     Modif GD (27/11/92) permettant de lire des fichiers avec commentaires
  !     Cleaned-up by S.G.
  !---------------------------------------------------------------------
  integer                :: nline
  integer                :: ncol
  real                   :: work(nline,ncol)
  logical, intent(inout) :: error
  ! Local
  character(len=80) :: line
  integer :: igood,iline,j,ier
  !
  igood=0
  iline=0
  do while (.true.)
    iline = iline+1
    igood = igood+1
    read(1,*,iostat=ier,end=98) (work(igood,j),j=1,ncol)
    if (ier.ne.0) then
      write (line,1000) iline
      igood=igood-1
      call gagout(line)
    endif
    if (igood.eq.nline) return
  enddo
98 call gagout('E-TABLE,  End of file during read')
  error = .true.
1000 format('E-TABLE,  List directed I/O syntax error at line #',i8)
end subroutine subread_all

subroutine ctrlc_check (error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>ctrlc_check
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Pause if ^C has been pressed and reset CONTROLC flag to false.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  !
  if (.not.sic_ctrlc()) return
  if (mlire(nlire).eq.0) then  ! At the terminal prompt
    call sic_message(seve%i,'SIC','^C')
  elseif (nlire.lt.maxlev) then  ! During a command execution
    call sic_message(seve%i,'PAUSE','Generated by pressing ^C')
    if (error) then
      call sic_message(seve%w,'PAUSE','Error returned by aborted command '//  &
      'ignored')
      error = .false.
    endif
    call break
  else  ! During a command execution but too deep
    call sic_message(seve%w,'SIC','<^C> Ignored, level too deep')
  endif
end subroutine ctrlc_check

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubestatistics_mean
  use cubetemplate_one2two_real_template
  use cubestatistics_messaging
  !
  public :: cubestatistics_mean_register
  private
  !
  type(one2two_real_comm_t) :: mean
  !
contains
  !
  subroutine cubestatistics_mean_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEAN>REGISTER'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call mean%register_syntax(&
         'MEAN','cubeid','3D cube',[flag_any],cubestatistics_mean_command,&
         'mean',[flag_mean,flag_image],&
         'rms', [flag_rms ,flag_image],&
         error)
    if (error) return
    call mean%register_act(cubestatistics_mean_prog_act,error)
    if (error) return
  end subroutine cubestatistics_mean_register
  !
  subroutine cubestatistics_mean_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(one2two_real_user_t) :: user
    character(len=*), parameter :: rname='MEAN>COMMAND'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call mean%parse(line,user,error)
    if (error) return
    call mean%main(user,error)
    if (error) continue
  end subroutine cubestatistics_mean_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubestatistics_mean_prog_act(prog,ie,spec,good,mean,rms,error)
    use cubetools_parameters
    use cubeadm_spectrum_types
    use cubemain_statistics_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_real_prog_t), intent(inout) :: prog
    integer(kind=entr_k),       intent(in)    :: ie
    type(spectrum_t),           intent(inout) :: spec
    type(spectrum_t),           intent(inout) :: good
    type(spectrum_t),           intent(inout) :: mean
    type(spectrum_t),           intent(inout) :: rms
    logical,                    intent(inout) :: error
    !
    type(spectrum_t) :: line
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='MEAN>PROG>ACT'
    !
    call spec%get(ie,error)
    if (error) return
    call line%point_to(spec,prog%region%iz%first,prog%region%iz%last,1.0,error)
    if (error) return
    call good%unblank(line,error)
    if (error) return
    !
    mean%y%val(one) = statistics%mean(good%y%val,good%n)
    call mean%put(ie,error)
    if (error) return
    !
    rms%y%val(one) = statistics%rms(good%y%val,good%n,mean%y%val(one))
    call rms%put(ie,error)
    if (error) return
  end subroutine cubestatistics_mean_prog_act
end module cubestatistics_mean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_difference
  use cubecompute_two2one_template
  use cubecompute_messaging
  !
  public :: cubecompute_difference_register
  private
  !
  type(two2one_comm_t) :: difference
  !
contains
  !
  subroutine cubecompute_difference_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='DIFFERENCE>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call difference%register_syntax(&
         'DIFFERENCE','subtrahend','minuend',&
         'Subtract two aligned cubes',&
         'Subtract two aligned cubes entry-by-entry over the&
         & selected region.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- The result is subtrahend-minuend in the same order as the&
         & command line.'//strg_cr//&
         '- The two inputs must have matching shapes. The output is real only&
         & when both inputs are real. Otherwise it is complex.'//strg_cr//&
         '- If units differ, a warning is emitted and the output unit keeps&
         & subtrahend naming.'//strg_bl//&
         'Examples:'//strg_cr//&
         '- CUBE> DIFFERENCE cube1 cube2.'//strg_cr//&
         '- CUBE> DIFFERENCE cube1 cube2 /RANGE -10km/s 10km/s.',&
         code_access_imaset,[flag_difference],cubecompute_difference_command,&
         error)
    if (error) return
    !
    call difference%unit%register(cubecompute_difference_prog_unit,error)
    if (error) return
    !
    call difference%act%register_imaima2ima(cubecompute_difference_prog_act_imaima,error)
    if (error) return
    call difference%act%register_imavis2vis(cubecompute_difference_prog_act_imavis,error)
    if (error) return
    call difference%act%register_visima2vis(cubecompute_difference_prog_act_visima,error)
    if (error) return
    call difference%act%register_visvis2vis(cubecompute_difference_prog_act_visvis,error)
    if (error) return
  end subroutine cubecompute_difference_register
  !
  subroutine cubecompute_difference_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(two2one_user_t) :: user
    character(len=*), parameter :: rname='DIFFERENCE>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call difference%parse(line,user,error)
    if (error) return
    call difference%main(user,error)
    if (error) continue
  end subroutine cubecompute_difference_command
  !
  subroutine cubecompute_difference_prog_unit(unit1,unit2,ouunit,error)
    !----------------------------------------------------------------------
    ! Set the proper unit of the output cube
    !----------------------------------------------------------------------
    character(len=*), intent(inout) :: unit1
    character(len=*), intent(inout) :: unit2
    character(len=*), intent(inout) :: ouunit
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: data_unit_null='---'  ! To be factorized
    character(len=*), parameter :: rname='DIFFERENCE>UNIT'
    !
    if (unit1.ne.unit2) then
       call cubecompute_message(seve%w,rname,'Mixing units '//trim(unit1)//' and '//unit2)
    endif
    ouunit = unit1
  end subroutine cubecompute_difference_prog_unit
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_difference_prog_act_imaima(ie,subtrahend,minuend,difference,error)
    use cubetools_parameters
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(image_t),        intent(inout) :: subtrahend
    type(image_t),        intent(inout) :: minuend
    type(image_t),        intent(inout) :: difference
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='DIFFERENCE>PROG>ACT>IMAIMA'
    !
    include 'action-difference.inc'
  end subroutine cubecompute_difference_prog_act_imaima
  !
  subroutine cubecompute_difference_prog_act_imavis(ie,subtrahend,minuend,difference,error)
    use cubetools_parameters
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(image_t),        intent(inout) :: subtrahend
    type(visi_t),         intent(inout) :: minuend
    type(visi_t),         intent(inout) :: difference
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='DIFFERENCE>PROG>ACT>IMAVIS'
    !
    include 'action-difference.inc'
  end subroutine cubecompute_difference_prog_act_imavis
  !
  subroutine cubecompute_difference_prog_act_visima(ie,subtrahend,minuend,difference,error)
    use cubetools_parameters
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(visi_t),         intent(inout) :: subtrahend
    type(image_t),        intent(inout) :: minuend
    type(visi_t),         intent(inout) :: difference
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='DIFFERENCE>PROG>ACT>VISIMA'
    !
    include 'action-difference.inc'
  end subroutine cubecompute_difference_prog_act_visima
  !
  subroutine cubecompute_difference_prog_act_visvis(ie,subtrahend,minuend,difference,error)
    use cubetools_parameters
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(visi_t),         intent(inout) :: subtrahend
    type(visi_t),         intent(inout) :: minuend
    type(visi_t),         intent(inout) :: difference
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='DIFFERENCE>PROG>ACT>VISVIS'
    !
    include 'action-difference.inc'
  end subroutine cubecompute_difference_prog_act_visvis
end module cubecompute_difference
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine contlk (xd,yd,ndp,ipt,vectd,frstd)
  use gcont_contour
  !---------------------------------------------------------------------
  ! @ private
  !	Draw the triangles created by CONTNG
  ! Arguments :
  !	XD	R*4 (*)	Array of X coordinates			Input
  !	YD	R*4 (*)	Array of Y coordinates			Input
  !	NDP	I	Number of data points			Input
  !	IPT	I (*)	Array of triangle pointers		Input
  !	VECTD	Ext	Vector drawing routine
  !	FRSTD	Ext	Pen up drawing routine
  ! Subroutines :
  !	VECTD, FRSTD
  !---------------------------------------------------------------------
  real :: xd(1)                     !
  real :: yd(1)                     !
  integer :: ndp                    !
  integer :: ipt(1)                 !
  external :: vectd                 !
  external :: frstd                 !
  ! Local
  integer :: i,k, i1,i2,i3
  !
  !  Draw triangles
  i = 1
  do k=1,nt
    i3 = ipt(i)
    i = i+1
    i2 = ipt(i)
    i = i+1
    i1 = ipt(i)
    i = i+1
    call frstd(xd(i1),yd(i1))
    call vectd(xd(i2),yd(i2))
    call vectd(xd(i3),yd(i3))
    call vectd(xd(i1),yd(i1))
  enddo
end subroutine contlk

subroutine gtx_setup(name,dev,error)
  use gbl_message
  use gtv_interfaces, except_this=>gtx_setup
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Set up the device instance according to its identifier
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   ! Terminal identifier (name)
  type(gt_device),  intent(inout) :: dev    ! The device instance to be set up
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTOPEN'
  character(len=80) :: found,paper_size
  integer(kind=4) :: ifound,idev
  !
  idev = 0
  call sic_ambigs(rname,name,found,ifound,device_list,1+ndevices,error)
  if (error)  return
  idev = ifound-1  ! because device_list numbering starts at 0
  !
  ! Reset everything
  call gtv_default(dev)
  !
  ! Then the specific values
  dev%ident = idev
  select case (device_list(idev))
  case ('NONE')
    dev%protocol = p_null
    dev%map_size = 128
    !
  case ('IMAGE')
    dev%protocol = p_x      !
    dev%init1    = "B"      ! Initialisation sequences init1 = B(ig cursor), B(lack)
                            !                                  S(mall cursor), W(hite)
    dev%linit1   = 1        ! Length of init1
    dev%init2    = "ZZ"     ! Initialisation sequences init2 = lotsofcolors because more than 1 char
    dev%linit2   = 2        ! Length of init2
    dev%px1      = 1        !
    dev%px2      = 750      !
    dev%py1      = 1        !
    dev%py2      = 545      !
    !
  case ('XPORTRAIT')
    dev%protocol = p_x      !
    dev%px1      = 1        !
    dev%px2      = 500      !
    dev%py1      = 1        !
    dev%py2      = 750      !
    !
  case ('XLANDSCAPE')
    dev%protocol = p_x      !
    dev%px1      = 1        !
    dev%px2      = 715      !
    dev%py1      = 1        !
    dev%py2      = 545      !
    !
  case ('PS','PDF')
    dev%protocol = p_postscript
    call gtx_paper_size
    if (paper_size.eq.'A4') then
      dev%px1    = 180      ! 65
      dev%px2    = 2600     ! 2850
      dev%py1    = 60       ! 60
      dev%py2    = 1960     ! 1960
    elseif (paper_size.eq."8.5x11".or.paper_size.eq."US_LETTER") then
      dev%px1    = 180      !
      dev%px2    = 2500     !
      dev%py1    = 60       !
      dev%py2    = 1900     !
    else
      call gtv_message(seve%e,rname,'Unknown paper format '//paper_size)
      error = .true.
      return
    endif
    dev%rxy      = 1.00503  !
    !
  case ('EPS','EPDF')
    dev%protocol = p_postscript
    call gtx_paper_size
    if (paper_size.eq.'A4') then
      dev%px1    = 180      ! 65
      dev%px2    = 2600     ! 2850
      dev%py1    = 60       ! 60
      dev%py2    = 1960     ! 1960
    elseif (paper_size.eq."8.5x11".or.paper_size.eq."US_LETTER") then
      dev%px1    = 180      !
      dev%px2    = 2500     !
      dev%py1    = 60       !
      dev%py2    = 1900     !
    else
      call gtv_message(seve%e,rname,'Unknown paper format '//paper_size)
      error = .true.
      return
    endif
    dev%rxy      = 1.0      !
    !
  case ('SVG')
    dev%protocol = p_svg    !
    dev%px1      = 0        !
    dev%px2      = 799      !
    dev%py1      = 559      ! Y scale increases from top to bottom in SVG
    dev%py2      = 0        !
    dev%rxy      = 1.0      !
    dev%poff     = 0.0      ! pixel #1 runs from 0.0 to 1.0
    !
  case ('PNG')
    dev%protocol = p_png    !
    dev%px1      = 1        !
    dev%px2      = 800      !
    dev%py1      = 1        !
    dev%py2      = 560      !
    dev%rxy      = 1.0      !
    !
  case default
    call gtv_message(seve%e,rname,  &
      'Device '//trim(device_list(idev))//' is not implemented')
    error = .true.
    return
  end select
  !
contains
  subroutine gtx_paper_size
    use gtv_dependencies_interfaces
    integer(kind=4) :: ier
    paper_size = 'A4'  ! Default
    ier = sic_getlog('GAG_PAPER_SIZE',paper_size)
    call sic_upper(paper_size)
  end subroutine gtx_paper_size
  !
end subroutine gtx_setup
!
subroutine gtv_default(dev)
  use gtv_interfaces, except_this=>gtv_default
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Reset a gt_device instance
  !---------------------------------------------------------------------
  type(gt_device), intent(inout) :: dev
  !
  dev%protocol = 0
  dev%defout = ' '
  dev%linit1 = -1
  dev%init1 = ' '
  dev%linit2 = -1
  dev%init2 = ' '
  dev%background = 1  ! White
  dev%px1 = 0
  dev%px2 = 250
  dev%py1 = 0
  dev%py2 = 200
  dev%rxy  = 1.00
  dev%poff = 0.5  ! pixel #1 runs from 0.5 to 1.5
  !
  dev%map_size = 128
  dev%map_offset = 0
  dev%map_color = .true.
  dev%map_static = .false.
  !
  dev%hardw_line_weig = .true.
  dev%hardw_line_dash = .true.
  dev%hardw_cursor = .false.
  !
end subroutine gtv_default

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_language
  use cubetools_parameters
  use cubetools_structure
  use cubedag_debug
  use cubedag_messaging
  use cubedag_find
  use cubedag_free
  use cubedag_history
  use cubedag_list
  use cubedag_memory
  use cubedag_remove
  use cubedag_snapshot
  use cubedag_undo
  !
  public :: cubedag_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubedag_register_language(error)
    !----------------------------------------------------------------------
    ! Register the DAG\ language. This language provides interactions
    ! with the DAG. In particular, there is no access to the node data.
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'DAG',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Commands to manage the DAG',&
         strg_emp,&
         'gag_doc:hlp/cube-help-dag.hlp',&
         cubedag_execute_command,&
         langid,&
         error)
    if (error) return
    !
    call find%register(error)
    if (error) return
    call free%register(error)
    if (error) return
    call history%register(error)
    if (error) return
    call list%register(error)
    if (error) return
    call memory%register(error)
    if (error) return
    call remove%register(error)
    if (error) return
    call snapshot%register(error)
    if (error) return
    call undo%register(error)
    if (error) return
    if (cube_dev_mode()) then
      call debug%register(error)
      if (error) return
    endif
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubedag_register_language
  !
  subroutine cubedag_execute_command(line,comm,error)
    !use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the DAG\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'DAG?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubedag_finish_all
       !call cubeadm_finish_all(comm,line,error)
       !if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubedag_execute_command
end module cubedag_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_calHolography(nmode, rmsu, rmsw, bmes, nscrew   &
    ,screwName, screwMotion, screwMotionError, surfaceMapUid,   &
    beamMapUid, error)
  use gildas_def
  use gkernel_interfaces
  use sdm_CalHolography
  use sdm_CalData
  use sdm_CalReduction
  use sdm_Enumerations
  !---------------------------------------------------------------------
  ! Write the calHolography SDM table, and related tables.
  !---------------------------------------------------------------------
  ! Dummy
  integer :: nmode, nscrew
  logical :: error
  real*8 bmes(7)
  real rmsu, rmsw, screwMotion(nscrew),   &
    screwMotionError(nscrew)
  character*12 screwName(nscrew)
  character*(*) surfaceMapUid, beamMapUid
  integer :: luid
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  include 'gbl_xpar.inc'
  include 'gbl_ypar.inc'
  include 'sdm_identifiers.inc'
  character :: version*20
  ! Local
  type(CalHolographyRow) :: chRow
  type(CalHolographyKey) :: chKey
  type(CalHolographyOpt) :: chOpt
  type(CalDataRow) :: cdRow
  type(CalDataKey) :: cdKey
  type(CalReductionRow) :: crRow
  type(CalReductionKey) :: crKey
  integer sig, ima, nfreq, ia, isb, ier, i, l
  integer ireturn, sdm_addCalDataRow, sdm_addCalReductionRow,   &
    sdm_addCalHolographyRow
  character sdmTable*16, uid*80
  parameter (sdmTable = 'calHolography')
  !---------------------------------------------------------------------
  include 'clic_version.inc'
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  ! cal data table:
  cdRow%numScan = 1
!!  call allocCalDataRow(cdRow, cdRow%numScan, error)
  call allocCalDataRow(cdRow, error)
  if (error) return
  !
  cdRow%scanSet(1) = r_scan
  cdRow%calType = CalType_CAL_HOLOGRAPHY
  !     this is not stricly true, but we lost track of the time of actual
  !     load observations...
  !
  cdRow%startTimeObserved = time_interval(1)
  cdRow%endTimeObserved = time_interval(1)+time_interval(2)
  call addCalDataRow(cdKey, cdRow, error)
  if (error) goto 99
  !
  ! cal reduction table:
  !
  crRow%numApplied = 1
  crRow%numParam = 1
  crRow%numInvalidConditions = 1
!!!   call allocCalReductionRow(crRow, crRow%numApplied, crRow%numParam,   &
!!!     crRow%numInvalidConditions, error)
  call allocCalReductionRow(crRow, error)
  if (error) goto 99
  !
  !!crRow%calAppliedArray(1) = 'None'
  crRow%AppliedCalibrations(1) = 'None'
  crRow%paramSet(1) = 'None'
  !
  ! That's now! calculate...
  crRow%timeReduced = time_Interval(1) + time_Interval(2)
  crRow%messages = 'None'
  crRow%software = 'CLIC'
  crRow%softwareVersion = version
  crRow%invalidConditions = InvalidatingCondition_RECEIVER_EXCHANGE
  !
  call addCalReductionRow(crKey, crRow, error)
  if (error) goto 99
  !
  ! calHolography  table:
  !     TODO antenna name must somehow be saved in CLIC file! (holography
  !     section)
  if (r_kant(1).lt.100) then
    ia = r_kant(1)
    write (chKey%antennaName,'(a4,i2.2)')  'BURE',ia
  elseif (r_kant(1).lt.200) then
    ia = r_kant(1)-100
    write (chKey%antennaName,'(a4,i2.2)')  'ALMA',ia
  endif
  !
  chKey%CalReductionId = crKey%CalReductionId
  chKey%CalDataId = cdKey%CalDataId
  !
  ! in Data:
  !    integer :: numScrew
  ! this will be 2 for astronomical holography, probably.
  chRow%numReceptor = 1
!!!   call allocCalHolographyRow(chRow, chRow%numReceptor,   &
!!!     chRow%numScrew, error)
  call allocCalHolographyRow(chRow, error)
  if (error) return
  chOpt%numScrew = nscrew
  call allocCalHolographyOpt(chRow, chOpt, error)
  if (error) return
  !    integer*8 :: startValidTime
  !    integer*8 :: endValidTime
  chRow%startValidTime = cdRow%startTimeObserved
  chRow%endValidTime = -1      !???
  !    real*8, allocatable :: focusPosition(:) X, Y, Z
  chRow%focusPosition(1) = bmes(5)
  chRow%focusPosition(2) = bmes(6)
  chRow%focusPosition(3) = bmes(4)
  chRow%rawRms = rmsu
  chRow%weightedRms = rmsw
  ! could be X, I'm not sure
  chRow%polarizationTypes(1) = PolarizationType_Y
  do i=1, nscrew
    chOpt%screwName(i) = screwName(i)//char(0)
    chOpt%screwMotion(i) = screwMotion(i)
    chOpt%screwMotionError(i) = screwMotionError(i)
  enddo
  chRow%direction(1) = r_az
  chRow%direction(2) = r_el
  chRow%ambientTemperature = r_tamb
!!  chrow%panelModes = nmode
  chrow%numPanelModes = nmode
  !
  !     real*8 :: frequency
  if (i_band(1).eq.1) then
    chrow%frequencyRange = r_flo1+r_fif1
  elseif (i_band(1).eq.2) then
    chrow%frequencyRange = r_flo1-r_fif1
  else
    chrow%frequencyRange = r_flo1
  endif
  luid = lenc(surfaceMapUid)
  chrow%surfaceMapUID = '<EntityRef '//   &
    'entityId="'//surfaceMapuid(1:luid)//   &
    '" partId="X00000002" '//   &
    'entityTypeName="holographyMap" '//   &
    'documentVersion="1"/>'
  luid = lenc(beamMapUid)
  chrow%beamMapUID = '<EntityRef '//   &
    'entityId="'//beamMapuid(1:luid)//   &
    '" partId="X00000002" '//   &
    'entityTypeName="beamMap" '//   &
    'documentVersion="1"/>'
  call addCalHolographyRow(chkey, chRow, error)
  if (error) return
  call addCalHolographyNumScrew(chkey, chOpt, error)
  if (error) return
  call addCalHolographyScrewName(chkey, chOpt, error)
  if (error) return
  call addCalHolographyScrewMotion(chkey, chOpt, error)
  if (error) return
  call addCalHolographyScrewMotionError(chkey, chOpt, error)
  if (error) return
  call sdmMessage(1,1,sdmTable ,'Written.')
99 return
end subroutine write_sdm_calHolography
!---------------------------------------------------------------------
!---------------------------------------------------------------------
!!! subroutine allocCalHolographyRow(row, numReceptor, numScrew,   &
!!!     error)
!!!   !
!!!   ! Allocate memory for a CalHolography Row.
!!!   !
!!!   use sdm_CalHolography
!!!   type(CalHolographyRow) :: row
!!!   integer :: numReceptor, numScrew, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*16 = 'calHolography'
!!!   ! focusPosition
!!!   if (allocated(row%focusPosition)) then
!!!     deallocate(row%focusPosition, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%focusPosition(3), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! frequencyRange
!!!   if (allocated(row%frequencyRange)) then
!!!     deallocate(row%frequencyRange, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%frequencyRange(2), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! direction
!!!   if (allocated(row%direction)) then
!!!     deallocate(row%direction, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%direction(2), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! screwName
!!!   if (allocated(row%screwName)) then
!!!     deallocate(row%screwName, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%screwName(numScrew), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! screwMotion
!!!   if (allocated(row%screwMotion)) then
!!!     deallocate(row%screwMotion, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%screwMotion(numScrew), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! screwMotionError
!!!   if (allocated(row%screwMotionError)) then
!!!     deallocate(row%screwMotionError, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%screwMotionError(numScrew), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! polarizationTypes
!!!   if (allocated(row%polarizationTypes)) then
!!!     deallocate(row%polarizationTypes, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%polarizationTypes(numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!!! !
subroutine sdm_holoTimes(first, error)
  logical :: error, first
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  integer*8 times(2)
  !
  times(1) = ((dh_obs+60549.0d0)*86400.d0+dh_utc-0.5d0*dh_integ)   &
    *1d9
  times(2) = dh_integ*1d9
  if (first) then
    time_interval(1) = times(1)
    time_interval(2) = times(2)
  else
    time_interval(1) = min(time_interval(1), times(1))
    time_interval(2) = max(time_interval(1)+time_interval(2),   &
      times(1)+times(2)) - time_interval(1)
  endif
  return
end subroutine sdm_holoTimes

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_keyval_dble_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_value_dble_types
  use cubesyntax_messaging
  !
  public :: keyval_dble_comm_t,keyval_dble_user_t,keyval_dble_prog_t
  private
  !
  type keyval_dble_comm_t
     type(option_t), pointer :: key
     type(value_dble_comm_t) :: value
   contains
     procedure, public :: register => cubesyntax_keyval_dble_comm_register
     procedure, public :: parse    => cubesyntax_keyval_dble_comm_parse
  end type keyval_dble_comm_t
  !
  type keyval_dble_user_t
     logical               :: do = .false.
     character(len=argu_l) :: val = strg_star
   contains
     procedure, public :: toprog => cubesyntax_keyval_dble_user_toprog
     procedure, public :: list   => cubesyntax_keyval_dble_user_list
  end type keyval_dble_user_t
  !
  type keyval_dble_prog_t
   contains
     procedure, public :: list   => cubesyntax_keyval_dble_prog_list
  end type keyval_dble_prog_t
  !
contains
  !
  subroutine cubesyntax_keyval_dble_comm_register(comm,&
       keyname,keyabstract,keyhelp,valdefault,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keyval_dble_comm_t), intent(inout) :: comm
    character(len=*),          intent(in)    :: keyname
    character(len=*),          intent(in)    :: keyabstract
    character(len=*),          intent(in)    :: keyhelp
    real(kind=dble_k),         intent(in)    :: valdefault
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>DBLE>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         keyname,&
         'value',&
         keyabstract,&
         keyhelp,&
         comm%key,&
         error)
    if (error) return
    call comm%value%register(&
         keyname,&
         valdefault,&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubesyntax_keyval_dble_comm_register
  !
  subroutine cubesyntax_keyval_dble_comm_parse(comm,line,user,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! /KEY value
    !----------------------------------------------------------------------
    class(keyval_dble_comm_t), intent(in)    :: comm
    character(len=*),          intent(in)    :: line
    type(keyval_dble_user_t),  intent(out)   :: user ! => Initialized!
    logical,                   intent(inout) :: error
    !
    integer(kind=argu_k), parameter :: ival=1
    character(len=*), parameter :: rname='KEYVAL>DBLE>COMM>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,comm%key,ival,user%val,mandatory,error)
       if (error) return
    endif
  end subroutine cubesyntax_keyval_dble_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_keyval_dble_user_toprog(user,comm,prog,error)
    use cubetools_unit
    use cubetools_user2prog
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keyval_dble_user_t), intent(in)    :: user
    type(keyval_dble_comm_t),  intent(in)    :: comm
    real(kind=dble_k),         intent(inout) :: prog
    logical,                   intent(inout) :: error
    !
    type(unit_user_t) :: nounit
    character(len=*), parameter :: rname='KEYVAL>DBLE>USER>TOPROG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! *** JP This syntax seems very strange to me because we transfer a
    ! *** JP constant object named nounit!
    call nounit%get_from_code(code_unit_unk,error)
    if (error) return
    call cubetools_user2prog_resolve_star(user%val,nounit,comm%value%default,prog,error)
    if (error) return
  end subroutine cubesyntax_keyval_dble_user_toprog
  !
  subroutine cubesyntax_keyval_dble_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging purpose
    !----------------------------------------------------------------------
    class(keyval_dble_user_t), intent(in)    :: user 
    logical,                       intent(inout) :: error
    !
!    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='KEYVAL>DBLE>USER>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
  end subroutine cubesyntax_keyval_dble_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_keyval_dble_prog_list(prog,comm,value,error)
    use cubesyntax_keyval_list_tool
    !-------------------------------------------------------------------
    ! List the information in a user friendly way
    !-------------------------------------------------------------------
    class(keyval_dble_prog_t), intent(in)    :: prog
    type(keyval_dble_comm_t),  intent(in)    :: comm
    real(kind=dble_k),         intent(in)    :: value
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>DBLE>PROG>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call keyval%list(comm%key%name,value,error)
    if (error) return
  end subroutine cubesyntax_keyval_dble_prog_list
end module cubesyntax_keyval_dble_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
! The use of UV buffers in Mapping
!
! Mapping has three virtual UV buffers, named
! "UVI" (Initial), "UVS" (Sorted) and "UVR" (Resampled).
! UVR and UVS are used indifferently, depending on which one is
! available, rather than using UVS only for sorting and UVR only
! for Resampling. Only one of those two is allocated at any time
! (except temporarily when using one as input and the other as output).
!
! UVR and UVS may point to UVI, as sorting is not always needed.
!
! Command READ uses UVI, and nullifies or deallocate UVR and UVS.
!
! Commands UV_MAP, UV_CONT, UV_TIME, UV_RESIDUAL, UV_COMPRESS
! and UV_RESAMPLE use the UVR and UVS buffers.
!   A little tricky logic allows to select UVS or UVR
! for the output, depending on which one is busy as input,
! allocating on demand as needed.
!
! Through the use of a pointer, "UV" (actually a header
! HUV and a pointer to the data DUV), the so-called "current UV data"
! points towards one of them, depending on the last issued commands.
!
! Other commands like UV_BASELINE, UV_FILTER, UV_REWEIGHT or UV_FLAG
! work on the "current UV data". UV_FLAG is partially reversible.
!
! Finally, UV_SORT does not affect the "current UV data", but produces
! a transposed copy of it (which thus cannot be written by WRITE UV),
! called UVT.
!
! The whole thing is a little complex and perhaps should be changed.
!
! In addition to the buffer use, the code must account for the
! weight computation optimization.
!
! NOTE: In an earlier version, commands UV_COMPRESS and UV_RESAMPLE 
! only worked with UVI as input. This makes little sense, as a 
! combination of UV_TIME - UV_COMPRESS did not give the same as 
! UV_COMPRESS - UV_TIME for example. The only "nice" feature of 
! this behaviour was to allow the spectral resampling to start 
! from the full resolution data.
!
! The original data can always be recovered through a READ, which
! is optimized by proper caching if no modification has been done
! to the data.
!-----------------------------------------------------------------------
!
module uv_buffers
  use gbl_message
  use image_def
  use mapping_types
  use file_buffers
  use uvmap_buffers, only: do_weig
  !
  public :: uv_select_buffer,uv_reset_buffer,uv_free_buffers
  public :: uv_find_buffers,uv_clean_buffers,uv_discard_buffers
  public :: uv_dump_buffers
  !
  public :: uvi,uvtb,uvm
  public :: huv,duv
  public :: duvr,duvs
  !
  public :: uv_buffer
  public :: uv_plotted
  public :: do_weig     ! Debug ***JP: What does it mean?
  !
  private
  !
  type(gildas), save, target :: huv        ! Current UV data
  type(mapping_2d_t), save, target :: uvi  ! Initial UV data
  type(mapping_2d_t), save, target :: uvtb ! Time-Baseline sorted UV data, for UV_FLAG
  type(mapping_2d_t), save, target :: uvm  ! Model UV data
  !
  real, pointer :: duv(:,:)   ! Current UV data
  real, pointer :: duvr(:,:)  ! Resampled UV data
  real, pointer :: duvs(:,:)  ! Sorted UV data
  !
  logical, save :: uv_plotted
  !
  type uv_buffer_user_t
   contains
     procedure, public :: init   => uv_buffer_user_init
     procedure, public :: sicdef => uv_buffer_user_sicdef
  end type uv_buffer_user_t
  type(uv_buffer_user_t) :: uv_buffer
  !
contains
  !
  subroutine uv_buffer_user_init(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(uv_buffer_user_t), intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    nullify(duvr)
    nullify(duvs)
    call gildas_null(huv, type='UVT')
    call gildas_null(uvi%head,type='UVT')
    call gildas_null(uvtb%head,type='UVT')
    call gildas_null(uvm%head,type='UVT')
  end subroutine uv_buffer_user_init
  !
  subroutine uv_buffer_user_sicdef(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(uv_buffer_user_t), intent(inout) :: user
    logical,                 intent(inout) :: error
    !
    integer(kind=index_length) :: dim(4) = 0
    !
    dim(1) = 2
    !***JP: Is the pre-processing for tests?
#if defined(INDEX4) || !defined(BITS64)
    call sic_def_inte('UV_DIM',huv%gil%dim,1,dim,.false.,error)
    if (error) return
    call sic_def_inte('UVS_DIM',uvtb%head%gil%dim,1,dim,.false.,error)
    if (error) return
#else
    call sic_def_long('UV_DIM',huv%gil%dim,1,dim,.false.,error)
    if (error) return
    call sic_def_long('UVS_DIM',uvtb%head%gil%dim,1,dim,.false.,error)
    if (error) return
#endif
    call sic_def_inte('UV_NCHAN',huv%gil%nchan,0,0,.false.,error)
    if (error) return
    !
    !***JP: primary definition of do_weig is in the uvmap_buffers module
    !***JP: unclear whether do_weig related things should happen here or there
    call sic_def_logi('DO_WEIG',do_weig,.false.,error)
    if (error) return
  end subroutine uv_buffer_user_sicdef
  !
  subroutine uv_select_buffer(rname,nu,nv,error)
    !---------------------------------------------------------------------
    ! Select the next available UV buffer (UVR or UVS) for
    ! commands using them.
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    integer,          intent(in)    :: nu    ! Visibility size
    integer,          intent(in)    :: nv    ! Number of visibilities
    logical,          intent(inout) :: error
    !
    integer :: ier
    !
    if (associated(duvr)) then
       allocate (duvs(nu,nv),stat=ier)
       if (ier.ne.0) then
          error = .true.
          call map_message(seve%f,rname,'Memory allocation failure on UVS')
          return
       endif
       if (associated(duvr,uvi%data)) then
          nullify(duvr)
       else if (associated(duvr)) then
          deallocate (duvr)     ! Free the old one
       endif
       duv => duvs             ! Point to new one
    else
       allocate (duvr(nu,nv),stat=ier)
       if (ier.ne.0) then
          error = .true.
          call map_message(seve%f,rname,'Memory allocation failure on UVR')
          return
       endif
       if (associated(duvs,uvi%data)) then
          nullify(duvs)
       else if (associated(duvs)) then
          deallocate (duvs)      ! Free the old one
       endif
       duv => duvr               ! Point to new one
    endif
    optimize(code_save_uv)%change = optimize(code_save_uv)%change+1
    error = .false.
  end subroutine uv_select_buffer
  !
  subroutine uv_reset_buffer(rname)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Reset pointers to UV datasets (back to UVI). Deallocate
    ! UVR or UVS if needed, as well as the "transposed" buffer UVT
    !---------------------------------------------------------------------
    character(len=*) :: rname
    !
    logical :: error
    !
    ! What happens no compressed data is defined ?
    ! well we have to set the same pointers DUV and DUVR as in READ...
    !
    if (allocated(uvtb%data)) deallocate (uvtb%data)        ! UV data not plotted
    uv_plotted = .false.
    !
    if (.not.allocated(uvi%data)) then
       call map_message(seve%w,rname,'No UV data (DUVI not allocated)')
       return
    endif
    !
    ! Find out which one DUVI is pointing about
    if (associated(duvr,uvi%data)) then
       !!print *,'DUVR was pointing towards UVI%DATA'
       nullify(duvr)
    else if (associated(duvr)) then
       !!print *,'DUVR was allocated '
       deallocate (duvr)     ! Free the old one
    else
       !!print *,'DUVR not allocated '
    endif
    if (associated(duvs,uvi%data)) then
       !!print *,'DUVS was pointing towards UVI%DATA'
       nullify(duvs)
    else if (associated(duvs)) then
       !!print *,'DUVS was allocated '
       deallocate (duvs)     ! Free the old one
    else
       !!print *,'DUVS not allocated '
    endif
    !
    call gdf_copy_header(uvi%head,huv,error)
    !
    duvr => uvi%data     ! As in READ
    !
    ! This means we were already pointing to the previous UV data set
    if (associated(duv,uvi%data)) return
    !
    ! Here we point back...
    if (optimize(code_save_uv)%change.gt.1) then
       optimize(code_save_uv)%change = optimize(code_save_uv)%change - 1
       call map_message(seve%i,rname,'Returning to previous UV data set')
    else
       optimize(code_save_uv)%change = 0
       call map_message(seve%i,rname,'Returning to original UV data set')
    endif
    duv => uvi%data
    do_weig = .true. ! Recompute weight
    call sic_delvariable ('UV',.false.,error)
    call sic_delvariable ('UVS',.false.,error)
  end subroutine uv_reset_buffer
  !
  subroutine uv_dump_buffers(rname)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Dump the allocation status of the UV buffers. (Debugging only)
    !---------------------------------------------------------------------
    character(len=*), intent(in) :: rname
    !
    integer(kind=index_length) :: udim(2)
    logical :: error
    !
    if (associated(duvr)) then
       if (associated(duvr,uvi%data)) then
          call map_message(seve%w,rname,'DUVR associated to UVI%DATA')
       else
          call map_message(seve%w,rname,'DUVR allocated')
       endif
       !
       ! Redefine SIC variables
       udim(1) = ubound(duvr,1)
       udim(2) = ubound(duvr,2)
       call sic_delvariable ('UVR',.false.,error)
       call sic_def_real ('UVR',duvr,2,udim,.false.,error)
    else
       call map_message(seve%w,rname,'no DUVR ...')
    endif
    !
    if (associated(duvs)) then
       if (associated(duvs,uvi%data)) then
          call map_message(seve%w,rname,'DUVS associated to UVI%DATA')
       else
          call map_message(seve%w,rname,'DUVS allocated')
       endif
       ! Redefine SIC variables
       udim(1) = ubound(duvs,1)
       udim(2) = ubound(duvs,2)
       call sic_delvariable ('UVS',.false.,error)
       call sic_def_real ('UVS',duvs,2,udim,.false.,error)
    else
       call map_message(seve%w,rname,'no DUVS ...')
    endif
    !
    if (allocated(uvtb%data)) call map_message(seve%w,rname,'Transposed buffer allocated.')
    !
    if (associated(duv,uvi%data)) then
       call map_message(seve%w,rname,'DUV associated to UVI%DATA')
    else if (associated(duv,duvr)) then
       call map_message(seve%w,rname,'DUV associated to DUVR')
    else if (associated(duv,duvs)) then
       call map_message(seve%w,rname,'DUV associated to DUVS')
    else if (associated(duv)) then
       call map_message(seve%w,rname,'DUV is not associated to ???')
    else
       call map_message(seve%w,rname,'DUV is undefined')
    endif
  end subroutine uv_dump_buffers
  !
  subroutine uv_free_buffers
    !---------------------------------------------------------------------
    ! Deallocate all UV buffers.
    !---------------------------------------------------------------------
    !
    integer :: ier
    !
    ! Free the previous zone
    !!print *,'Into free_uvdata '
    if (associated(duvr)) then
       if (associated(duvr,uvi%data)) then
          nullify(duvr)
          !!print *,'Nullify duvr'
       else
          !!print *,'Deallocate duvr'
          deallocate(duvr,stat=ier)
       endif
    endif
    if (associated(duvs)) then
       if (associated(duvs,uvi%data)) then
          !!print *,'Nullify duvs'
          nullify(duvs)
       else
          !!print *,'Deallocate duvs'
          deallocate(duvs,stat=ier)
       endif
    endif
    if (allocated(uvi%data))  deallocate(uvi%data,stat=ier)
    if (allocated(uvtb%data)) deallocate(uvtb%data,stat=ier)
    !!print *,'Done free_uvdata'
  end subroutine uv_free_buffers
  !
  subroutine uv_find_buffers(rname,nu,nv,duv_previous,duv_next,error)
    !---------------------------------------------------------------------
    ! Find the next available UV buffer (UVR or UVS).
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    integer,          intent(in)    :: nu   ! Size of a visiblity
    integer,          intent(in)    :: nv   ! Number of visibilities
    real, pointer,    intent(out)   :: duv_previous(:,:)
    real, pointer,    intent(out)   :: duv_next(:,:)
    logical,          intent(inout) :: error
    !
    integer :: ier
    !
    if (associated(duvr)) then
       allocate (duvs(nu,nv),stat=ier)
       if (ier.ne.0) then
          error = .true.
          call map_message(seve%f,rname,'UV_FIND_BUFFERS: Memory allocation failure on UVS')
          return
       endif
       call map_message(seve%d,rname,'Storing in DUVS')
       duv_previous => duvr
       duv_next => duvs
    else
       allocate (duvr(nu,nv),stat=ier)
       if (ier.ne.0) then
          error = .true.
          call map_message(seve%f,rname,'UV_FIND_BUFFERS: Memory allocation failure on UVR')
          return
       endif
       call map_message(seve%d,rname,'Storing in DUVR')
       duv_previous => duvs
       duv_next => duvr
    endif
    error = .false.
  end subroutine uv_find_buffers
  !
  subroutine uv_clean_buffers(duv_previous,duv_next,error)
    !---------------------------------------------------------------------
    ! Take care of freeing the unused UV buffer, and set UV to point to the
    ! new one.
    !---------------------------------------------------------------------
    real, pointer, intent(inout) :: duv_previous(:,:)
    real, pointer, intent(inout) :: duv_next(:,:)
    logical,       intent(inout) :: error
    !
    if (associated(duv_previous,duvr)) then
       if (error) then
          deallocate(duvs)
          nullify (duv_previous, duv_next)
          return
       endif
       !
       if (associated(duvr,uvi%data)) then
          nullify(duvr)
       else
          deallocate (duvr)      ! Free the old one
       endif
       duv => duvs              ! Point to new one
    else if (associated(duv_previous,duvs)) then
       if (error) then
          deallocate(duvr)
          nullify (duv_previous, duv_next)
          return
       endif
       !
       if (associated(duvs,uvi%data)) then
          nullify(duvs)
       else
          deallocate (duvs)     ! Free the old one
       endif
       duv => duvr             ! Point to new one
    endif
  end subroutine uv_clean_buffers
  
  subroutine uv_discard_buffers(duv_previous,duv_next,error)
    !---------------------------------------------------------------------
    ! Take care of freeing the last used UV buffer, and reset UV to point
    ! to the previous one.
    !---------------------------------------------------------------------
    real, pointer, intent(inout) :: duv_previous(:,:)
    real, pointer, intent(inout) :: duv_next(:,:)
    logical,       intent(inout) :: error
    !
    if (associated(duv_next,duvr)) then
       if (error) then
          deallocate(duvr)
          nullify (duv_previous, duv_next)
          return
       endif
       !
       if (associated(duvr,uvi%data)) then
          nullify(duvr)
       else
          deallocate (duvr)      ! Free it 
       endif
       duv => duvs               ! Point to new one
    else if (associated(duv_next,duvs)) then
       if (error) then
          deallocate(duvs)
          nullify (duv_previous, duv_next)
          return
       endif
       !
       if (associated(duvs,uvi%data)) then
          nullify(duvs)
       else
          deallocate (duvs)     ! Free it
       endif
       duv => duvr              ! Point to new one
    endif
  end subroutine uv_discard_buffers
end module uv_buffers
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine greg_axis(line,error)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_axis
  use greg_axes
  use greg_kernel
  use greg_pen
  use greg_types
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routines for commands
  !   AXIS  XLow|XUp|YLeft|YRight [A1 A2]
  ! 1       /TICK ICLOCK SMALL BIG
  ! 2       /LABEL POSITION [FORMAT]
  ! 3       /LOCATION   X Y LENGTH
  ! 4-5     /[NO]LOGARITHM
  ! 6       /ABSOLUTE
  ! 7       /UNIT Angle
  ! 8-9     /[NO]BRIEF
  ! --- to be implemented ---
  !                       /WINDOW AMIN AMAX
  !   TICKSPACE  [X SMALL BIG]  [Y SMALL BIG]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_pi.inc'
  ! Local
  character(len=*), parameter :: rname='AXIS'
  logical :: notick
  real(kind=8) :: a1,a2,a,small,big
  type(axis_t) :: axis
  real(kind=4) :: ax,ay,alen
  integer(kind=4) :: inum
  character(len=1) :: clock,clabel
  character(len=80) :: chain
  character(len=2) :: arg1
  character(len=12) :: argum,name,angu(4)
  integer(kind=4) :: c_angle,n,nc
  ! Data
  data angu/'SECOND','MINUTE','DEGREE','RADIAN'/
  !
  call sic_ke (line,0,1,arg1,nc,.true.,error)
  if (error) return
  !
  ! Default is: decimal notation
  axis%label%format = format_decimal
  !
  if (arg1.eq.'XL') then
    !
    ! No projection, No System : Nothing
    if (gproj%type.eq.p_none .and. i_system.eq.type_un .and. sic_present(6,0)) then
      call greg_message(seve%w,rname,'/ABSOLUTE coordinates ignored when '//  &
      'no projection')
      a1 = gux1
      a2 = gux2
      !
    elseif (sic_present(6,0)) then
      ! Absolute labelling
      if (abs(gux2-gux1).gt.0.2 .and. gproj%type.ne.p_none) then
        ! See remark in subroutine greg_box
        call greg_message(seve%e,rname,'Field of view is too large for '//  &
        'absolute labelling')
        goto 10
      endif
      if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
        a1 = (axrem1+axrem2)*0.5d0/pi*3.6d3*1.2d1
        a2 = (axrem5+axrem6)*0.5d0/pi*3.6d3*1.2d1
        axis%label%format = format_sexage_hour
        axis%label%format_nd = ndecimx
      else
        if (xsixty.eq.format_decimal) then
          a1 = (axrem1+axrem2)*0.5d0/pi*1.8d2
          a2 = (axrem5+axrem6)*0.5d0/pi*1.8d2
          axis%label%format = format_decimal
        else
          a1 = (axrem1+axrem2)*0.5d0/pi*1.8d2*3.6d3
          a2 = (axrem5+axrem6)*0.5d0/pi*1.8d2*3.6d3
          axis%label%format = format_sexage_none
          if (i_system.eq.type_ga) axis%label%format = format_sexage_degree
          ! The %format_nd field was not defined before...
          axis%label%format_nd = ndecimx
        endif
      endif
      if (gux1.lt.gux2) then
        a = a1
        a1 = a2
        a2 = a
      endif
    else
      !
      ! Relative labelling in current angle unit
      c_angle = u_angle
      if (sic_present(7,0)) then
        call sic_ke (line,7,1,name,nc,.true.,error)
        if (error) goto 10
        call sic_ambigs(rname,name,argum,n,angu,4,error)
        if (error) goto 10
        c_angle = n
      endif
      if (c_angle.eq.u_second) then
        a1 = gux1/pi*3.6d3*1.8d2
        a2 = gux2/pi*3.6d3*1.8d2
      elseif (c_angle.eq.u_minute) then
        a1 = gux1/pi*6.0d1*1.8d2
        a2 = gux2/pi*6.0d1*1.8d2
      elseif (c_angle.eq.u_degree) then
        a1 = gux1/pi*1.8d2
        a2 = gux2/pi*1.8d2
      else
        a1 = gux1
        a2 = gux2
      endif
    endif
    axis%angle = tangle*pi/180.d0
    small  = smallx
    big    = bigx
    axis%loga = axis_xlog
    ax     = gx1
    ay     = gy1
    alen   = gx2-gx1
    inum   = 1
    axis%doline  = .true.
    axis%dolabel = .true.
    axis%label%justif = 1
    if (axis%label%format.eq.format_decimal) then
      axis%label%brief = axis_xdecim_brief
    else
      axis%label%brief = axis_xsexag_brief
    endif
    axis%label%expo = axis_xexpo
    !
  elseif (arg1.eq.'XU') then
    !
    ! No projection
    if (gproj%type.eq.p_none .and. i_system.eq.type_un .and. sic_present(6,0)) then
      call greg_message(seve%w,rname,'/ABSOLUTE coordinates ignored when '//  &
      'no projection')
      a1 = gux1
      a2 = gux2
      !
      ! Absolute labelling
    elseif (sic_present(6,0)) then
      if (abs(gux2-gux1).gt.0.2 .and. gproj%type.ne.p_none) then
        ! See remark in subroutine greg_box
        call greg_message(seve%e,rname,'Field of view is too large for '//  &
        'absolute labelling')
        goto 10
      endif
      if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
        a1 = (axrem1+axrem2)*0.5d0/pi*3.6d3*1.2d1
        a2 = (axrem5+axrem6)*0.5d0/pi*3.6d3*1.2d1
        axis%label%format = format_sexage_hour
        axis%label%format_nd = ndecimx
      else
        if (xsixty.eq.format_decimal) then
          a1 = (axrem1+axrem2)*0.5d0/pi*1.8d2
          a2 = (axrem5+axrem6)*0.5d0/pi*1.8d2
          axis%label%format = format_decimal
        else
          a1 = (axrem1+axrem2)*0.5d0/pi*1.8d2*3.6d3
          a2 = (axrem5+axrem6)*0.5d0/pi*1.8d2*3.6d3
          axis%label%format = format_sexage_none
          if (i_system.eq.type_ga) axis%label%format = format_sexage_degree
          ! The %format_nd field was not defined before...
          axis%label%format_nd = ndecimx
        endif
      endif
      if (gux1.lt.gux2) then
        a = a1
        a1 = a2
        a2 = a
      endif
    else
      !
      ! Relative labelling in current angle unit
      c_angle = u_angle
      if (sic_present(7,0)) then
        call sic_ke (line,7,1,name,nc,.true.,error)
        if (error) goto 10
        call sic_ambigs(rname,name,argum,n,angu,4,error)
        if (error) goto 10
        c_angle = n
      endif
      if (c_angle.eq.u_second) then
        a1 = gux1/pi*3.6d3*1.8d2
        a2 = gux2/pi*3.6d3*1.8d2
      elseif (c_angle.eq.u_minute) then
        a1 = gux1/pi*6.0d1*1.8d2
        a2 = gux2/pi*6.0d1*1.8d2
      elseif (c_angle.eq.u_degree) then
        a1 = gux1/pi*1.8d2
        a2 = gux2/pi*1.8d2
      else
        a1 = gux1
        a2 = gux2
      endif
    endif
    axis%angle = tangle*pi/180.d0
    small  = smallx
    big    = bigx
    axis%loga = axis_xlog
    ax     = gx1
    ay     = gy2
    alen   = gx2-gx1
    inum   = 3
    axis%doline  = .true.
    axis%dolabel = .false.
    axis%label%justif = 1
    if (axis%label%format.eq.format_decimal) then
      axis%label%brief = axis_xdecim_brief
    else
      axis%label%brief = axis_xsexag_brief
    endif
    axis%label%expo = axis_xexpo
    !
  elseif (arg1.eq.'YL') then
    !
    ! No projection
    if (gproj%type.eq.p_none .and. i_system.eq.type_un .and. sic_present(6,0)) then
      call greg_message(seve%w,rname,'/ABSOLUTE coordinates ignored when '//  &
      'no projection')
      a1 = guy1
      a2 = guy2
      !
      ! Absolute labelling
    elseif (sic_present(6,0)) then
      if (abs(guy2-guy1).gt.0.2 .and. gproj%type.ne.p_none) then
        ! See remark in subroutine greg_box
        call greg_message(seve%e,rname,'Field of view is too large for '//  &
        'absolute labelling')
        goto 10
      endif
      if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
        a1 = (ayrem1+ayrem5)*0.5d0/pi*3.6d3*1.8d2
        a2 = (ayrem2+ayrem6)*0.5d0/pi*3.6d3*1.8d2
        axis%label%format = format_sexage_degree
        axis%label%format_nd = ndecimy
      else
        if (ysixty.eq.format_decimal) then
          a1 = (ayrem1+ayrem5)*0.5d0/pi*1.8d2
          a2 = (ayrem2+ayrem6)*0.5d0/pi*1.8d2
          axis%label%format = format_decimal
        else
          a1 = (ayrem1+ayrem5)*0.5d0/pi*1.8d2*3.6d3
          a2 = (ayrem2+ayrem6)*0.5d0/pi*1.8d2*3.6d3
          axis%label%format = format_sexage_none
          if (i_system.eq.type_ga) axis%label%format = format_sexage_degree
          ! The %format_nd field was not defined before...
          axis%label%format_nd = ndecimy
        endif
      endif
      if (guy1.gt.guy2) then
        a = a1
        a1 = a2
        a2 = a
      endif
    else
      !
      ! Relative labelling in current angle unit
      c_angle = u_angle
      if (sic_present(7,0)) then
        call sic_ke (line,7,1,name,nc,.true.,error)
        if (error) goto 10
        call sic_ambigs(rname,name,argum,n,angu,4,error)
        if (error) goto 10
        c_angle = n
      endif
      if (c_angle.eq.u_second) then
        a1 = guy1/pi*3.6d3*1.8d2
        a2 = guy2/pi*3.6d3*1.8d2
      elseif (c_angle.eq.u_minute) then
        a1 = guy1/pi*6.0d1*1.8d2
        a2 = guy2/pi*6.0d1*1.8d2
      elseif (c_angle.eq.u_degree) then
        a1 = guy1/pi*1.8d2
        a2 = guy2/pi*1.8d2
      else
        a1 = guy1
        a2 = guy2
      endif
    endif
    axis%angle = (tangle+90.d0)*pi/180.d0
    small  = smally
    big    = bigy
    axis%loga = axis_ylog
    ax     = gx1
    ay     = gy1
    alen   = gy2-gy1
    inum   = 5
    axis%doline  = .true.
    axis%dolabel = .true.
    axis%label%justif = just(5)
    if (axis%label%format.eq.format_decimal) then
      axis%label%brief = axis_ydecim_brief
    else
      axis%label%brief = axis_ysexag_brief
    endif
    axis%label%expo = axis_yexpo
    !
  elseif (arg1.eq.'YR') then
    !
    ! No projection
    if (gproj%type.eq.p_none .and. i_system.eq.type_un .and. sic_present(6,0)) then
      call greg_message(seve%w,rname,'/ABSOLUTE coordinates ignored when '//  &
      'no projection')
      a1 = guy1
      a2 = guy2
      !
      ! Absolute labelling
    elseif (sic_present(6,0)) then
      if (abs(guy2-guy1).gt.0.2 .and. gproj%type.ne.p_none) then
        ! See remark in subroutine greg_box
        call greg_message(seve%e,rname,'Field of view is too large for '//  &
        'absolute labelling')
        goto 10
      endif
      if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
        a1 = (ayrem1+ayrem5)*0.5d0/pi*3.6d3*1.8d2
        a2 = (ayrem2+ayrem6)*0.5d0/pi*3.6d3*1.8d2
        axis%label%format = format_sexage_degree
        axis%label%format_nd = ndecimy
      else
        if (ysixty.eq.format_decimal) then
          a1 = (ayrem1+ayrem5)*0.5d0/pi*1.8d2
          a2 = (ayrem2+ayrem6)*0.5d0/pi*1.8d2
          axis%label%format = format_decimal
        else
          a1 = (ayrem1+ayrem5)*0.5d0/pi*1.8d2*3.6d3
          a2 = (ayrem2+ayrem6)*0.5d0/pi*1.8d2*3.6d3
          axis%label%format = format_sexage_none
          if (i_system.eq.type_ga) axis%label%format = format_sexage_degree
          ! The %format_nd field was not defined before...
          axis%label%format_nd = ndecimy
        endif
      endif
      if (guy1.gt.guy2) then
        a = a1
        a1 = a2
        a2 = a
      endif
    else
      !
      ! Relative labelling in current angle unit
      c_angle = u_angle
      if (sic_present(7,0)) then
        call sic_ke (line,7,1,name,nc,.true.,error)
        if (error) goto 10
        call sic_ambigs(rname,name,argum,n,angu,4,error)
        if (error) goto 10
        c_angle = n
      endif
      if (c_angle.eq.u_second) then
        a1 = guy1/pi*3.6d3*1.8d2
        a2 = guy2/pi*3.6d3*1.8d2
      elseif (c_angle.eq.u_minute) then
        a1 = guy1/pi*6.0d1*1.8d2
        a2 = guy2/pi*6.0d1*1.8d2
      elseif (c_angle.eq.u_degree) then
        a1 = guy1/pi*1.8d2
        a2 = guy2/pi*1.8d2
      else
        a1 = guy1
        a2 = guy2
      endif
    endif
    axis%angle = (tangle+90.d0)*pi/180.d0
    small  = smally
    big    = bigy
    ax     = gx2
    ay     = gy1
    alen   = gy2-gy1
    axis%loga = axis_ylog
    inum   = 7
    axis%doline  = .true.
    axis%dolabel = .false.
    axis%label%justif = just(7)
    if (axis%label%format.eq.format_decimal) then
      axis%label%brief = axis_ydecim_brief
    else
      axis%label%brief = axis_ysexag_brief
    endif
    axis%label%expo = axis_yexpo
    !
  else
    chain = 'Invalid argument '//arg1
    call greg_message(seve%e,rname,chain)
    goto 10
  endif
  axis%label%offset = 1.
  call sic_r8 (line,0,2,a1,.false.,error)
  if (error) goto 10
  call sic_r8 (line,0,3,a2,.false.,error)
  if (error) goto 10
  !
  ! /TICK [In/Out/None] [SMALL] [BIG]
  notick = .false.
  if (sic_present(1,0)) then
    call sic_ke (line,1,1,clock,nc,.false.,error)
    if (error) goto 10
    if (clock.eq.'O') then
      inum = inum+1
      axis%label%offset = -2.
    elseif (clock.eq.'N') then
      notick = .true.
    elseif (clock.ne.'I') then
      call greg_message(seve%e,rname,'Invalid parameter for /TICK option')
      goto 10
    endif
    call sic_r8 (line,1,2,small,.false.,error)
    if (error) goto 10
    call sic_r8 (line,1,3,big,.false.,error)
    if (error) goto 10
  endif
  !
  ! /LABEL
  if (sic_present(2,0)) then
    call sic_ke (line,2,1,clabel,nc,.false.,error)
    if (error) goto 10
    if (clabel.eq.'N') then      ! No labels
      axis%dolabel = .false.
    elseif (clabel.eq.'P') then  ! Parallel
      axis%dolabel = .true.
      axis%label%justif = 1
    elseif (clabel.eq.'O') then  ! Orthogonal
      axis%dolabel = .true.
      axis%label%justif = just(inum)
    else
      chain = 'Invalid argument '//clabel
      call greg_message(seve%e,rname,chain)
      goto 10
    endif
    if (notick .and. clabel.ne.'N') then
      call greg_message(seve%e,rname,  &
        'Conflicting options : /TICKS None and /LABEL')
    endif
    !
    clabel = ' '
    call sic_ke (line,2,2,clabel,nc,.false.,error)
    if (error) goto 10
    if (clabel.eq.'O')  axis%doline = .false.
  endif
  !
  ! /LOCATION
  if (sic_present(3,0)) then
    call sic_r4 (line,3,1,ax,.false.,error)
    if (error) goto 10
    call sic_r4 (line,3,2,ay,.false.,error)
    if (error) goto 10
    call sic_r4 (line,3,3,alen,.false.,error)
    if (error) goto 10
  endif
  !
  ! /LOGARITHM
  if (sic_present(4,0)) axis%loga = .true.
  !
  ! /NOLOG
  if (sic_present(5,0)) then
    if (sic_present(4,0)) then
      call greg_message(seve%e,rname,'Conflicting options /LOG and /NOLOG')
      goto 10
    endif
    axis%loga = .false.
  endif
  !
  ! /[NO]BRIEF
  if (sic_present(8,0)) then
    if (sic_present(9,0)) then
      call greg_message(seve%e,rname,'Conflicting options /BRIEF and /NOBRIEF')
      goto 10
    endif
    axis%label%brief = .true.
  elseif (sic_present(9,0)) then
    axis%label%brief = .false.
  endif
  !
  axis%tdirect = jclock(inum)
  call setdas(1)
  if (notick) then
    call grelocate(ax,ay)
    ax = ax+alen*cos(axis%angle)
    ay = ay+alen*sin(axis%angle)
    call gdraw(ax,ay)
  else
    call plot_axis(a1,a2,small,big,ax,ay,alen,axis,error)
  endif
  return
  !
10 continue
  error = .true.
end subroutine greg_axis
!
subroutine greg_rule(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_rule
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support for command RULE
  !  RULE [X] [Y] [/MAJOR] [/MINOR]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='RULE'
  character(len=4) :: chain
  integer(kind=4) :: ixy,nc
  logical :: lx,ly,lmajor,lminor
  !
  ! Rule X and/or Y ticks. Default is ticking both X and Y ticks.
  lx = .false.
  ly = .false.
  if (sic_present(0,1)) then
    call sic_ke (line,0,1,chain,nc,.false.,error)
    if (error) goto 10
    if (chain.eq.'X') then
      lx = .true.
    elseif (chain.eq.'Y') then
      ly = .true.
    else
      goto 10
    endif
  endif
  if (sic_present(0,2)) then
    call sic_ke (line,0,2,chain,nc,.false.,error)
    if (error) goto 10
    if (chain.eq.'X') then
      lx = .true.
    elseif (chain.eq.'Y') then
      ly = .true.
    else
      goto 10
    endif
  endif
  if (lx.and.ly) then
    ixy = 3
  elseif (lx) then
    ixy = 1
  elseif (ly) then
    ixy = 2
  else
    ixy = 3
  endif
  !
  ! Rule Major or Minor ticks ? Default is Major only.
  lmajor = sic_present(1,0)
  lminor = sic_present(2,0)
  if (.not.lmajor .and. .not.lminor) lmajor = .true.
  !
  if (lmajor) call rulexy (.true.,ixy,error)
  if (lminor) call rulexy (.false.,ixy,error)
  return
  !
10 continue
  call greg_message(seve%e,rname,  &
    'Invalid Arguments. Valid arguments are X or Y.')
  error = .true.
end subroutine greg_rule
!
subroutine rulexy(major,ixy,error)
  use phys_const
  use greg_interfaces, except_this=>rulexy
  use greg_axes
  use greg_kernel
  use greg_types
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command
  !  RULE [X] [Y] [/MAJOR] [/MINOR]
  ! Arguments :
  !  IXY    For ruling X or Y ticks
  !    1 Rule X ticks
  !    2 Rule Y ticks
  !    3 Rule both X and Y ticks
  !---------------------------------------------------------------------
  logical,         intent(in)    :: major  ! T for lines at labelled ticks, F for all ticks
  integer(kind=4), intent(in)    :: ixy    ! For ruling X or Y ticks (1:X, 2:Y, 3:both)
  logical,         intent(inout) :: error  ! Logical flag
  ! Local
  type(axis_t) :: axis  ! Axis description
  !
  if (ixy.eq.1 .or. ixy.eq.3) then
    axis%angle = 0.d0
    axis%loga = axis_xlog
    axis%glength = gy2 - gy1
    axis%gmajor = major
    axis%ghoriz = .false.
    ! Label format has influence on major tick position. Duplicate.
    if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
      axis%label%format = format_sexage_hour
    else
      if (xsixty.eq.format_decimal) then
        axis%label%format = format_decimal
      else
        axis%label%format = format_sexage_none
        if (i_system.eq.type_ga) axis%label%format = format_sexage_degree
      endif
    endif
    axis%label%justif = 1
    axis%label%brief = .false.
    !
    call plot_at_tick(gux1,gux2,smallx,bigx,gx1,gy1,gx2-gx1,axis,plot_rulexy,error)
    if (error)  return
  endif
  !
  if (ixy.eq.2 .or. ixy.eq.3) then
    axis%angle = pi/2.d0
    axis%loga = axis_ylog
    axis%glength = gx2 - gx1
    axis%gmajor = major
    axis%ghoriz = .true.
    ! Label format has influence on major tick position. Duplicate.
    if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
      axis%label%format = format_sexage_hour
    else
      if (ysixty.eq.format_decimal) then
        axis%label%format = format_decimal
      else
        axis%label%format = format_sexage_none
        if (i_system.eq.type_ga) axis%label%format = format_sexage_degree
      endif
    endif
    axis%label%justif = just(5)
    axis%label%brief = .false.
    !
    call plot_at_tick(guy1,guy2,smally,bigy,gx1,gy1,gy2-gy1,axis,plot_rulexy,error)
    if (error)  return
  endif
  !
end subroutine rulexy
!
subroutine plot_axis(a1,a2,small,big,ax,ay,alen,axis,error)
  use greg_interfaces, except_this=>plot_axis
  use greg_kernel
  use greg_types
  !---------------------------------------------------------------------
  ! @ private
  !  Plot an axis: line+ticks and/or tick labels
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: a1     ! User coordinate value at start point of axis
  real(kind=8), intent(in)    :: a2     ! User coordinate value at end point of axis
  real(kind=8), intent(in)    :: small  ! Minor tick space
  real(kind=8), intent(in)    :: big    ! Major (labelled) tick space
  real(kind=4), intent(in)    :: ax     ! Page coordinates of start point of axis
  real(kind=4), intent(in)    :: ay     ! Page coordinates of start point of axis
  real(kind=4), intent(in)    :: alen   ! Length of axis
  type(axis_t), intent(inout) :: axis   ! Parameters for labels and ticks
  logical,      intent(inout) :: error  ! Error flag
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real(kind=4) :: ax2,ay2
  !
  ax2 = alen*cos(axis%angle) + ax
  ay2 = alen*sin(axis%angle) + ay
  !
  if (axis%doline) then
    !
    ! Plot axis
    call grline(ax2,ay2,ax,ay)
    !
    ! Plot ticks
    call plot_at_tick(a1,a2,small,big,ax,ay,alen,axis,plot_tickmark,error)
    if (error) return
  endif
  !
  if (axis%dolabel) then
    ! Write labels
    call plot_at_tick(a1,a2,small,big,ax,ay,alen,axis,plot_ticklabel,error)
  endif
  !
end subroutine plot_axis
!
subroutine plot_at_tick(a1,a2,small,big,ax,ay,alen,axis,func,error)
  use gbl_message
  use greg_interfaces, except_this=>plot_at_tick
  use greg_kernel
  use greg_types
  !---------------------------------------------------------------------
  ! @ private
  !  Execute the input function at each tick position
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: a1     ! User coordinate value at start point of axis
  real(kind=8), intent(in)    :: a2     ! User coordinate value at end point of axis
  real(kind=8), intent(in)    :: small  ! Minor tick space
  real(kind=8), intent(in)    :: big    ! Major (labelled) tick space
  real(kind=4), intent(in)    :: ax     ! Page X coordinates of start point of axis
  real(kind=4), intent(in)    :: ay     ! Page Y coordinates of start point of axis
  real(kind=4), intent(in)    :: alen   ! Length of axis
  type(axis_t), intent(inout) :: axis   ! Parameters for labels and ticks
  external                    :: func   ! Tick drawing function
  logical,      intent(inout) :: error  ! Logical flag
  ! Global
  include 'gbl_pi.inc'
  ! Local
  character(len=*), parameter :: rname='AXIS'
  real(kind=4) :: rsmall
  real(kind=8) :: val(6),ax1,ax2,tickpos,off,step,adiff,diff,dx
  real(kind=4) :: sine,cosine,amant
  real(kind=4) :: xlen
  logical :: first,lbrief
  integer(kind=4) :: nch,nlabel,nsmall
  integer(kind=4) :: iexp,num,i,j,n1,n2,smstep
  logical :: dolog
  type(tick_t) :: tick
  ! Data
  ! Tick locations for a logarithmic axis with two decades between major ticks.
  data val /1.d0,2.d0,5.d0,1.d1,2.d1,5.d1/
  !
  ! Logarithmic axis
  if (axis%loga) then
    if (a1.le.0.d0 .or. a2.le.0.d0) then
      call greg_message(seve%e,rname,'Negative limit on logarithmic axis')
      error = .true.
      return
    endif
    ax1 = dlog10(a1)
    ax2 = dlog10(a2)
    nch = 5  ! Was 9 before, but this is more appropriate
    ! Evaluate number of label intervals that can fit on the axis.
    if (axis%label%justif.eq.1) then
      nlabel = int(alen/(nch*cwidth*cdef*expand))
    else
      nlabel = int(alen/(5.*cheight*cdef*expand))
    endif
    ! Compute distance between major ticks in (user) decades
    if (nlabel.gt.0) then
      ! step = 1.d0 * int((ax2-ax1)/nlabel)
      n1 = int(ax1)
      if (ax1.lt.0) n1 = n1-1
      n2 = int(ax2)
      if (ax2.lt.0) n2 = n2-1
      step = 1.d0 * int(abs(n2-n1)/(nlabel+1))
    else
      call greg_message(seve%e,rname,'Character size too big')
      error = .true.
      return
    endif
    ! Number of small ticks depends on (user) distance between big ticks
    ! One decade: minor ticks at every integer
    dolog = .true.  ! Do effective log spacing for ticks
    if (step.le.1.d0) then
      ! Beware that AX2 can be smaller than AX1
      if (int(abs(ax2-ax1)).lt.1d0) then   !
        ! Less than 1 Decade, we have an issue: fall back on "standard" label
        step = 0d0
        dolog = .false.
      else
        step = 1.d0
        nsmall = 10
      endif
      ! Two decades: minor ticks at 2 5 10 20 50 100
    elseif (step.eq.2.d0) then
      nsmall = 6
      ! More than two decades: minor ticks every decade up to 10 decades,
      ! every second up to 20 and so
    else
      smstep = int((step-1)/10)+1
      step = smstep*int(step/smstep)
      nsmall = int(step/smstep)
    endif
  else
    dolog = .false.  ! Don't forget to initialize it...
  endif
  !
  if (dolog) then
    continue                   ! Log axis done...
    ! Linear axis
  elseif (big.gt.0.and.small.gt.0) then
    ax1 = a1
    ax2 = a2
    step = big
    rsmall = abs(step/small)
    if (rsmall.lt.2e2) then
      nsmall = int(rsmall)
    else
      call greg_message(seve%e,rname,'Too many small ticks')
      error = .true.
      return
    endif
    !
    ! Linear axis
  elseif (big.eq.0) then
    ax1 = a1
    ax2 = a2
    nsmall = 5
    nch = 9
    if (axis%label%justif.eq.1) then
      nlabel = int(alen/(nch*cwidth*cdef*expand))
    else
      nlabel = int(alen/(5.*cheight*cdef*expand))
    endif
    !
    ! Sexagesimal label
    if (axis%label%format.ne.format_decimal) then
      if (nlabel.lt.3) nlabel = 3
      adiff = abs(a2-a1)
      if (adiff.lt.10*nlabel) then
        diff  = log10(adiff/nlabel)
        iexp  = diff
        if (diff.lt.0.) iexp = iexp-1
        amant = diff - iexp
        if (amant.eq.0.) then
          num = 1
        elseif (amant.lt..302) then
          num = 2
          nsmall = 4
        elseif (amant.lt..700) then
          num = 5
        else
          num = 1
          iexp = iexp+1
        endif
        axis%label%format_nd = -iexp
        step = num * 1.d1**iexp
      else
        !
        ! IEXP nombre de multiple de 60 -1,0 Secondes 1 Minutes 2 Degres
        ! AMANT mantisse
        diff  = log10(adiff/nlabel)/log10(60.0)
        iexp  = diff
        if (diff.lt.0.) iexp = iexp-1
        amant = diff - iexp
        if (amant.eq.0.) then
          num = 1
          nsmall = 6
        elseif (amant.le.0.171) then   ! log10(2)/log10(60)
          num = 2
          nsmall = 4
        elseif (amant.le.0.395) then   ! log10(5)/log10(60)
          num = 5
          nsmall = 5
        elseif (amant.le.0.564) then   ! log10(10)/log10(60)
          num = 10
          nsmall = 5
        elseif (amant.le.0.832) then   ! log10(30)/log10(60)
          num = 30
          nsmall = 3
        else
          num = 60
          nsmall = 6
        endif
        step = num * 6.d1**iexp
        axis%label%format_nd = 0
      endif
    else
      ! Normal decimal label
      if (nlabel.le.4) nlabel = 5
      adiff = abs(a2-a1)
      diff  = log10(adiff/nlabel)
      iexp  = diff
      if (diff.lt.0.) iexp = iexp-1
      amant = diff - iexp
      if (amant.eq.0.) then
        num = 1
      elseif (amant.lt..302) then
        num = 2
        nsmall = 4
      elseif (amant.lt..700) then
        num = 5
      else
        num = 10
      endif
      step = num * 1.d1**iexp
    endif
    if (small.gt.0) then
      rsmall = abs(step/small)
      if (rsmall.lt.2e2) then
        nsmall = int(rsmall)
      else
        call greg_message(seve%e,rname,'Too many small ticks')
        error = .true.
        return
      endif
    endif
  else
    call greg_message(seve%e,rname,'Invalid tick space')
    error = .true.
    return
  endif
  !
  if (ax2.lt.ax1) step = -step
  off = dint(ax1/step)
  if (ax1/step.lt.0.d0) off = off-1.d0
  tickpos = step*off
  dx = ax2-ax1
  cosine = cos(axis%angle)
  sine = sin(axis%angle)
  !
  first = .true.
  if (axis%loga .or. .not.axis%label%brief) then
    lbrief = .false.
    tick%loffval = 0.d0
  else
    call tick_offset(axis%label%format.ne.format_decimal,a1,a2,lbrief,tick%loffval)
  endif
  tick%lbrief = .false.  ! First major tick is not abbreviated
  !
  ! Place Major Tick every "Step" value, starting from "Tick" value
  do j=1,100
    do i=1,nsmall
      !
      if (dolog) then
        if (abs(step).eq.1.d0) then
          tick%value = i*1.d1**tickpos
        elseif (abs(step).eq.2.d0) then
          tick%value = val(i)*1.d1**tickpos
        else
          ! tick%value = 1.d1**(tickpos+(i-1))
          tick%value = 1.d1**(tickpos+dble(i-1)*smstep)
        endif
        xlen  = alen*(dlog10(tick%value)-ax1)/dx
      else
        tick%value = tickpos + step*dble(i-1)/dble(nsmall)
        if (axis%loga) then
          xlen = alen * (log10(tick%value)-log10(ax1)) / (log10(ax2)-log10(ax1))
        else
          if (abs(tick%value).lt.abs(step*1.d-12)) tick%value = 0.d0
          xlen  = alen*(tick%value-ax1)/dx
        endif
      endif
      !
      ! Allow for roundoff errors
      if (xlen.gt.alen*(1d0+1.d-5)) return
      if (xlen.le.-1.d-5)  cycle
      !
      tick%x = xlen*cosine + ax
      tick%y = xlen*sine + ay
      if (i.eq.1) then
        ! A major tick
        tick%major = .true.
        call func(tick,axis)
        !
        if (first) then
          ! Next major ticks abbreviated or not?
          tick%lbrief = lbrief
          first = .false.
        endif
      else
        ! A minor tick
        tick%major = .false.
        call func(tick,axis)
      endif
      !
    enddo
    tickpos = tickpos+step
  enddo
end subroutine plot_at_tick
!
subroutine plot_tickmark(tick,axis)
  use greg_interfaces, except_this=>plot_tickmark
  use greg_kernel
  use greg_types
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Plot one tick mark
  !---------------------------------------------------------------------
  type(tick_t), intent(in) :: tick    ! Tick description
  type(axis_t), intent(in) :: axis     ! Axis description
  ! Local
  real(kind=4) :: big,xtick,ytick
  real(kind=4) :: small,orient
  real(kind=8) :: sine,cosine
  !
  if (axis%tdirect) then
    orient = 1.
  else
    orient = -1.
  endif
  big = ctick*expand*orient
  small = cmtick*expand*orient
  cosine = cos(axis%angle)
  sine = sin(axis%angle)
  if (tick%major) then
    xtick = -big*sine+tick%x
    ytick =  big*cosine+tick%y
  else
    xtick = -small*sine+tick%x
    ytick =  small*cosine+tick%y
  endif
  call grline(tick%x,tick%y,xtick,ytick)
end subroutine plot_tickmark
!
subroutine plot_ticklabel(tick,axis)
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>plot_ticklabel
  use greg_kernel
  use greg_types
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Plot one tick label
  !---------------------------------------------------------------------
  type(tick_t), intent(in) :: tick  ! Tick description
  type(axis_t), intent(in) :: axis  ! Axis description
  ! Local
  real(kind=8) :: value,range,angle,sine,cosine
  real(kind=4) :: big,tiny,dx,slength,t,xs,ys,xlabl,ylabl
  integer(kind=4) :: iform,oform,nchar
  character(len=30) :: string
  ! Data
  data range/0.d0/
  !
  if (.not.tick%major) return
  !
  if (axis%tdirect) then
    big = cheight*cdef*expand
  else
    big = -cheight*cdef*expand
  endif
  tiny = big*0.5
  !
  if (tick%lbrief .and. tick%loffval.ne.0.d0) then
    ! Remove offset value from value
    value = tick%value-tick%loffval
    !   At this stage there may be roundoff problems in 'value', because we
    ! may have substracted two huge values (remember this is the exact purpose
    ! of the 'brief' flag!). As a solution, we round the value to 6
    ! significant digits (not decimal but significant). 6 should be fine
    ! because, again, this is the purpose of the 'brief' flag: keeping only a
    ! few significant digits!
    !   Note that rounding is not done with integer rounding because
    ! nint(kind=8) is limited to ~9.E18:
    !     fact = 10.d0**(floor(log10(value))-6)
    !     value = dble(nint(value/fact,kind=8)*fact)
    ! Rely on compiler instead
    write(string,'(E20.6)') value
    read(string,*) value
  else
    value = tick%value
  endif
  !
  if (axis%label%format.ne.format_decimal) then
    call gag_cflabh (string,value,nchar,  &
      axis%label%format_nd,axis%label%format,tick%lbrief)
  else
    if (axis%label%expo) then
      iform = -1  ! Request floating point format
    else
      iform = 0  ! Request integer format
    endif
    call sic_spanum(string,value,iform,oform,nchar,range,15,5) ! was 3) before, and too long
    ! print *,'iform, oform = ',iform,oform,nchar,string(1:nchar)
    if (oform.eq.-1) then
      ! String has been returned with floating point format. Need to convert
      ! it to something Greg can understand
      call spanum_to_greg(string,nchar,axis%label%expo)
    endif
  endif
  call gstrlen (nchar,string,slength)
  dx = - axis%label%justif*0.5*slength
  cosine = cos(axis%angle)
  sine = sin(axis%angle)
  if (axis%label%justif.eq.1) then
    t = axis%label%offset*big
    xlabl = t*sine+tick%x
    ylabl =-t*cosine+tick%y
    xs = dx*cosine + xlabl
    ys = dx*sine + ylabl
    call grelocate (xs,ys)
    call gstring(nchar,string,axis%angle,.false.)
  else
    t = (4*axis%label%offset-1)/3.*tiny
    xlabl =  t*sine+tick%x
    ylabl = -t*cosine+tick%y
    xs = dx*sine + xlabl
    ys = -dx*cosine + ylabl
    call grelocate (xs,ys)
    angle = axis%angle-pi/2.d0
    call gstring(nchar,string,angle,.false.)
  endif
end subroutine plot_ticklabel
!
subroutine plot_rulexy(tick,axis)
  use greg_interfaces, except_this=>plot_rulexy
  use greg_types
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Used by command RULE for gridding the plot page
  !---------------------------------------------------------------------
  type(tick_t), intent(in) :: tick  ! Tick description
  type(axis_t), intent(in) :: axis  ! Axis description
  ! Local
  real(kind=4) :: xb,yb
  !
  if (tick%major.neqv.axis%gmajor) return
  !
  if (axis%ghoriz) then
    xb = tick%x + axis%glength
    yb = tick%y
  else
    xb = tick%x
    yb = tick%y + axis%glength
  endif
  call grline(tick%x,tick%y,xb,yb)
end subroutine plot_rulexy
!
subroutine greg_tickspace(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_tickspace
  use greg_axes
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GREG  Support routine for command
  !  TICKSPACE SMALLX BIGX SMALLY BIGY
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  !
  if (sic_narg(0).ne.4) then
    call greg_message(seve%e,'TICKSPACE','4 arguments required')
    error = .true.
    return
  endif
  !
  call sic_r8 (line,0,1,smallx,.false.,error)
  if (error) return
  call sic_r8 (line,0,2,bigx,.false.,error)
  if (error) return
  call sic_r8 (line,0,3,smally,.false.,error)
  if (error) return
  call sic_r8 (line,0,4,bigy,.false.,error)
end subroutine greg_tickspace
!
subroutine tick_offset(sexage,v1,v2,brief,o)
  use greg_interfaces, except_this=>tick_offset
  use gbl_message
  use greg_kernel
  use greg_types
  !---------------------------------------------------------------------
  ! @ private
  ! Custom rounding function. Takes 2 floats as input and return
  ! the most common value.
  ! - Example 1: d1=111259. and d2=111335.
  !    We want to return 111000. There is trap here: dx<100 but we have
  !    to round to the 1000s.
  ! - Example 2: d1=123456. and d2=3.
  !    We want to return 0.
  ! - Example 3: d1=123456. and d2=-120000.
  !    We want to return 0.
  ! - Example 4: d1=123456.789 and d2=d1
  !    We want to return d1
  !---------------------------------------------------------------------
  logical,      intent(in)  :: sexage  ! Sexagesimal notation?
  real(kind=8), intent(in)  :: v1,v2   !
  logical,      intent(out) :: brief   !
  real(kind=8), intent(out) :: o       !
  ! Local
  character(len=*), parameter :: rname='AXIS'
  integer(kind=4), parameter :: strlen=24
  character(len=strlen) :: c1,c2,c3
  integer(kind=4) :: e,d,d1,d2,m1,m2,ier
  real(kind=8) :: s
  !
  brief = .false.
  o = 0.d0
  !
  ! No common digits if numbers do not have the same sign
  if (v1*v2.lt.0.)  return
  !
  if (sexage) then
    d1 = floor(abs(v1)/3.6d3)
    d2 = floor(abs(v2)/3.6d3)
    if (d1.ne.d2)  return
    !
    s = sign(1.d0,v1)
    m1 = floor(abs(v1)/60.d0)-d1*60
    m2 = floor(abs(v2)/60.d0)-d2*60
    if (m1.ne.m2) then
      o = s*real(d1,kind=8)*3.6d3
    else
      o = s*(real(d1,kind=8)*3.6d3+real(m1,kind=8)*60d0)
    endif
    !
  else
    ! For double precision floats, use 15 significant digits
    write(c1,'(D24.15)')  v1
    write(c2,'(D24.15)')  v2
    !
    ! No common digits if numbers do not share the same highest power of 10
    ! NB: this test is also valid for numbers lower than 1.
    e = index(c1,'D')  ! Exponent position
    if (c1(e:).ne.c2(e:))  return
    !
    d = index(c1,'0')+2  ! First significant digit position
    do while (c1(1:d).eq.c2(1:d))
      d = d+1
    enddo
    c3 = c1(1:d-1)//c1(e:)
    read(c3,*,iostat=ier) o
    if (ier.ne.0) then
      call greg_message(seve%e,rname,'Error while reading '//c3)
      o = 0.d0
      return
    endif
  endif
  !
  brief = .true.
  !
end subroutine tick_offset

!-----------------------------------------------------------------------
! Support file for the User Section.
!-----------------------------------------------------------------------
subroutine class_user_exists(obs,iuser)
  use classcore_interfaces, except_this=>class_user_exists
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  !  Search the User subsection matching the current hooks known by
  ! Class. Return index 0 if no such subsection exists.
  !---------------------------------------------------------------------
  type(observation), intent(in)  :: obs
  integer(kind=4),   intent(out) :: iuser
  !
  if (obs%head%presec(class_sec_user_id)) then
    do iuser=1,obs%user%n
      if (user_sec_match(obs%user%sub(iuser)))  return
    enddo
  endif
  !
  ! We have not returned from the loop: no such subsection
  iuser = 0
  !
end subroutine class_user_exists
!
function user_sec_match(subsection)
  use class_user
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the input User Subsection matches the hooks
  ! known by Class
  !---------------------------------------------------------------------
  logical :: user_sec_match  ! Function value on return
  type(class_user_sub_t), intent(in) :: subsection  !
  !
  user_sec_match = cuserhooks.ne.0                                 .and.  &
                   subsection%owner.eq.userhooks(cuserhooks)%owner .and.  &
                   subsection%title.eq.userhooks(cuserhooks)%title
  !
end function user_sec_match
!
subroutine user_sec_owner(subsection,iowner,error)
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !  Loop in the list of known hooks to find the one matching the input
  ! User Subsection
  !---------------------------------------------------------------------
  type(class_user_sub_t), intent(in)    :: subsection  !
  integer(kind=4),        intent(out)   :: iowner      !
  logical,                intent(inout) :: error       !
  ! Local
  integer(kind=4) :: io
  !
  iowner = 0
  do io=1,muserhooks
    if (subsection%owner.eq.userhooks(io)%owner .and.  &
        subsection%title.eq.userhooks(io)%title) then
      iowner = io
    endif
  enddo
  !
end subroutine user_sec_owner
!
subroutine classcore_user_add(obs,sversion,sdata,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>classcore_user_add
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !   Add a User Section to the input observation. The caller has no
  ! control on the number of this new user section
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs       ! Observation
  integer(kind=4),   intent(in)    :: sversion  ! Version value
  integer(kind=4),   intent(in)    :: sdata     ! The user data (do not use "as is")
  logical,           intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLASS_USER_ADD'
  integer :: ier,nuser,iuser
  !
  if (cuserhooks.eq.0) then
    call class_message(seve%e,rname,'User Section hooks are not defined')
    error = .true.
    return
  endif
  if (userhooks(cuserhooks)%owner.eq.'') then
    call class_message(seve%e,rname,'User Section owner is not defined')
    error = .true.
    return
  endif
  if (userhooks(cuserhooks)%title.eq.'') then
    call class_message(seve%e,rname,'User Section title is not defined')
    error = .true.
    return
  endif
  !
  ! First check if such a section already exist
  call class_user_exists(obs,iuser)
  if (iuser.ne.0) then
    call class_message(seve%e,rname,  &
      'Observation already contains a user section '//  &
      trim(userhooks(cuserhooks)%owner)//' '//userhooks(cuserhooks)%title)
    error = .true.
    return
  endif
  !
  nuser = obs%user%n+1
  call reallocate_user(obs%user,nuser,.true.,error)
  if (error)  return
  obs%user%n = nuser
  !
  obs%head%presec(class_sec_user_id) = .true.
  !
  obs%user%sub(nuser)%owner   = userhooks(cuserhooks)%owner
  obs%user%sub(nuser)%title   = userhooks(cuserhooks)%title
  obs%user%sub(nuser)%version = sversion
  !
  ! Transfer and align the user data into uwork
  unext = 1
  call userhooks(cuserhooks)%toclass(sdata,sversion,error)
  if (error) return
  if (unext.le.1) then
    call class_message(seve%e,rname,'User section length is null')
    error = .true.
    return
  endif
  !
  ! Save uwork in our structure
  obs%user%sub(nuser)%ndata = unext-1
  allocate(obs%user%sub(nuser)%data(unext-1),stat=ier)
  if (failed_allocate(rname,'OBS%SUB(NUSER)%DATA',ier,error))  return
  obs%user%sub(nuser)%data(1:unext-1) = uwork(1:unext-1)
  !
end subroutine classcore_user_add
!
subroutine reallocate_user(user,nuser,keep,error)
  use classcore_dependencies_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Allocates or reallocates the section user depending on the
  ! 'nuser' value. In case of reallocation, previous data is preserved.
  !---------------------------------------------------------------------
  type(class_user_t), intent(inout) :: user   !
  integer(kind=4),    intent(in)    :: nuser  ! Number of User Subsections needed
  logical,            intent(in)    :: keep   ! Keep the previous data when enlarging?
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='REALLOCATE_USER'
  integer :: ier,iuser
  type(class_user_sub_t), allocatable :: sub(:)
  !
  if (nuser.le.0)  return
  !
  if (.not.allocated(user%sub)) then
    allocate(user%sub(nuser),stat=ier)
    if (failed_allocate(rname,'USER%SUB',ier,error))  return
    do iuser=1,nuser
      user%sub(iuser)%data => null()
    enddo
    !
  elseif (nuser.gt.size(user%sub)) then
    if (keep) then
      allocate(sub(user%n),stat=ier)
      if (failed_allocate(rname,'SUB',ier,error))  return
      ! Make a copy
      do iuser=1,user%n
        sub(iuser)%owner   =  user%sub(iuser)%owner
        sub(iuser)%title   =  user%sub(iuser)%title
        sub(iuser)%version =  user%sub(iuser)%version
        sub(iuser)%ndata   =  user%sub(iuser)%ndata
        sub(iuser)%data    => user%sub(iuser)%data
      enddo
      ! Free the extra ones (if any)
      do iuser=user%n+1,size(user%sub)
        if (associated(user%sub(iuser)%data))  &
          deallocate(user%sub(iuser)%data)
      enddo
    else
      ! Free all
      do iuser=1,size(user%sub)
        if (associated(user%sub(iuser)%data))  &
          deallocate(user%sub(iuser)%data)
      enddo
    endif
    !
    ! Free
    deallocate(user%sub)
    ! Enlarge
    allocate(user%sub(nuser),stat=ier)
    if (failed_allocate(rname,'USER%SUB',ier,error))  return
    ! Initialize
    do iuser=1,nuser
      user%sub(iuser)%data => null()
    enddo
    !
    if (keep) then
      ! Copy back the values
      do iuser=1,user%n
        user%sub(iuser)%owner   =  sub(iuser)%owner
        user%sub(iuser)%title   =  sub(iuser)%title
        user%sub(iuser)%version =  sub(iuser)%version
        user%sub(iuser)%ndata   =  sub(iuser)%ndata
        user%sub(iuser)%data    => sub(iuser)%data
      enddo
      deallocate(sub)
    endif
  endif
  !
end subroutine reallocate_user
!
subroutine reallocate_user_sub(sub,error)
  use classcore_dependencies_interfaces
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Reallocate sub%data according to sub%ndata
  !---------------------------------------------------------------------
  type(class_user_sub_t), intent(inout) :: sub
  logical,                intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>USER>SUB'
  logical :: realloc
  integer(kind=4) :: ier
  !
  if (associated(sub%data)) then
    realloc = sub%ndata.gt.size(sub%data)
    if (realloc)  deallocate(sub%data)
  else
    realloc = .true.
  endif
  !
  if (realloc) then
    allocate(sub%data(sub%ndata),stat=ier)
    if (failed_allocate(rname,'SUB%DATA',ier,error))  return
  endif
  !
end subroutine reallocate_user_sub
!
subroutine newdat_user(set,obs,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>newdat_user
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Recompute the User Section related data, typically when a new
  ! observation is loaded.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(in)    :: obs
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: iuser
  logical :: done_ruser
  ! Data
  data done_ruser /.false./
  !
  if (.not.obs%is_R)  return
  !
  if (done_ruser) then
    ! Delete the previous instance
    call sic_delvariable('R%USER',.false.,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    done_ruser = .false.  ! R%USER deleted
  endif
  !
  if (set%varpresec(class_sec_user_id).eq.setvar_off)  return  ! SET VAR USER OFF
  if (obs%user%n.eq.0)                                 return  ! No user section!
  if (cuserhooks.eq.0)                                 return  ! No current hooks defined!
  if (.not.associated(userhooks(cuserhooks)%setvar))   return  ! No SET VAR hook
  !
  ! Find which user subsection
  call class_user_exists(obs,iuser)
  if (iuser.eq.0)  return
  !
  ! Create the new instance
  call sic_defstructure('R%USER',.true.,error)
  call sic_defstructure('R%USER%'//userhooks(cuserhooks)%owner,.true.,error)
  if (error)  return
  !
  usub = iuser  ! The User Subsection number
  unext = 1     ! The offset in the 'r%user%sub(iuser)%data' array,
                ! for each variable
  call userhooks(cuserhooks)%setvar(obs%user%sub(iuser)%version,error)
  !
  done_ruser = .true.  ! R%USER created
  !
end subroutine newdat_user
!
subroutine rzero_user(obs)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Reset the User Section to default value
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs  !
  !
  obs%user%n = 0
  !
  !  Do not deallocate obs%user%sub nor obs%user%sub(:)%data: we keep
  ! them allocated for later reuse.
  !
end subroutine rzero_user
!
subroutine copy_user(inuser,outuser,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>copy_user
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Copy the User Section from the input observation to the output one.
  ! User Section is enlarged if needed.
  !---------------------------------------------------------------------
  type(class_user_t), intent(in)    :: inuser   ! Input user section
  type(class_user_t), intent(inout) :: outuser  ! Output user section
  logical,            intent(inout) :: error    ! Logical error flag
  ! Local
  integer :: iuser,l,ier
  logical :: realloc
  !
  ! First allocate or enlarge the section (only if needed)
  call reallocate_user(outuser,inuser%n,.false.,error)
  if (error)  return
  !
  ! Then, copy the section
  outuser%n = inuser%n
  do iuser=1,inuser%n
    outuser%sub(iuser)%owner   = inuser%sub(iuser)%owner
    outuser%sub(iuser)%title   = inuser%sub(iuser)%title
    outuser%sub(iuser)%version = inuser%sub(iuser)%version
    outuser%sub(iuser)%ndata   = inuser%sub(iuser)%ndata
    !
    ! Then, the allocatable block of data
    l = outuser%sub(iuser)%ndata
    if (associated(outuser%sub(iuser)%data)) then
      realloc = size(outuser%sub(iuser)%data).lt.size(inuser%sub(iuser)%data)
      if (realloc) then
        deallocate(outuser%sub(iuser)%data,stat=ier)
        if (failed_allocate('COPY_USER','DATA (1)',ier,error))  return
      endif
    else
      realloc = .true.
    endif
    if (realloc) then
      allocate(outuser%sub(iuser)%data(l),stat=ier)
      if (failed_allocate('COPY_USER','DATA (2)',ier,error))  return
    endif
    !
    outuser%sub(iuser)%data(1:l) = inuser%sub(iuser)%data(1:l)
  enddo
  !
end subroutine copy_user
!
subroutine classcore_user_update(obs,sversion,sdata,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>classcore_user_update
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ public  (for libclass only)
  !  Update the User Section in the input observation. The caller has no
  ! control on the number of this new user section
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs       ! Observation
  integer(kind=4),   intent(in)    :: sversion  ! Version value
  integer(kind=4),   intent(in)    :: sdata     ! The user data (do not use "as is")
  logical,           intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLASS_USER_UPDATE'
  integer :: ier,snum
  !
  if (cuserhooks.eq.0) then
    call class_message(seve%e,rname,'User Section hooks are not defined')
    error = .true.
    return
  endif
  if (userhooks(cuserhooks)%owner.eq.'') then
    call class_message(seve%e,rname,'User Section owner is not defined')
    error = .true.
    return
  endif
  if (userhooks(cuserhooks)%title.eq.'') then
    call class_message(seve%e,rname,'User Section title is not defined')
    error = .true.
    return
  endif
  !
  ! First check if such a section already exist
  call class_user_exists(obs,snum)
  if (snum.eq.0) then
    call class_message(seve%e,rname,  &
      'Observation has no such section '//  &
      trim(userhooks(cuserhooks)%owner)//' '//userhooks(cuserhooks)%title)
    error = .true.
    return
  endif
  !
  ! obs%user%sub(snum)%owner   = userhooks(cuserhooks)%owner  ! No need
  ! obs%user%sub(snum)%title   = userhooks(cuserhooks)%title  ! No need
  obs%user%sub(snum)%version = sversion
  !
  ! Transfer and align the user data into uwork
  unext = 1
  call userhooks(cuserhooks)%toclass(sdata,sversion,error)
  if (error)  return
  if (unext.le.1) then
    call class_message(seve%e,rname,'User section length is null')
    error = .true.
    return
  endif
  !
  ! Save uwork in our structure
  if (obs%user%sub(snum)%ndata.ne.unext-1) then
    deallocate(obs%user%sub(snum)%data)
    obs%user%sub(snum)%ndata = unext-1
    allocate(obs%user%sub(snum)%data(unext-1),stat=ier)
    if (failed_allocate(rname,'OBS%SUB(SNUM)%DATA',ier,error))  return
  endif
  obs%user%sub(snum)%data(1:unext-1) = uwork(1:unext-1)
  !
end subroutine classcore_user_update
!
subroutine user_sec_dump(obs,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>user_sec_dump
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !   Dump all the User Sections from the input observation. Data is
  ! not displayed if there is no hook provided by the user.
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs    ! Observation
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='USER_SEC_DUMP'
  integer(kind=4) :: iuser,iowner
  character(len=message_length) :: mess
  !
  if (obs%user%n.eq.0) then
    call class_message(seve%w,rname,'Observation has no User Section defined')
    return
    !
  else
    !
    write(mess,'(2X,A,1X,I0)') 'Number of subsections:',obs%user%n
    call class_message(seve%r,rname,mess)
    !
    do iuser=1,obs%user%n
      write(mess,'(2X,A,T20,I0)') 'User Section #',iuser
      call class_message(seve%r,rname,mess)
      write(mess,'(4X,A,T20,A)')   'Owner:',obs%user%sub(iuser)%owner
      call class_message(seve%r,rname,mess)
      write(mess,'(4X,A,T20,A)')   'Title:',obs%user%sub(iuser)%title
      call class_message(seve%r,rname,mess)
      write(mess,'(4X,A,T20,I0)')  'Version:',obs%user%sub(iuser)%version
      call class_message(seve%r,rname,mess)
      write(mess,'(4X,A,T20,I0)')  'Data length:',obs%user%sub(iuser)%ndata
      call class_message(seve%r,rname,mess)
      ! Now, the data:
      write(mess,'(4X,A)')         'Data:'
      call class_message(seve%r,rname,mess)
      !
      ! Find the correct owner and use it:
      call user_sec_owner(obs%user%sub(iuser),iowner,error)
      if (iowner.ne.0 .and.  &
          associated(userhooks(iowner)%dump)) then
        ! Transfer the data to uwork
        unext = 1
        uwork(1:obs%user%sub(iuser)%ndata) = obs%user%sub(iuser)%data
        ! Call the user hook, which will read uwork by itself
        call userhooks(iowner)%dump(obs%user%sub(iuser)%version,error)
      else
        call class_message(seve%r,rname,'      (can not list)')
      endif
    enddo
    !
  endif
  !
end subroutine user_sec_dump
!
subroutine user_sec_setvar(set,obs,delete,error)
  use gbl_message
  use classcore_interfaces, except_this=>user_sec_setvar
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !  Support subroutine for
  !   SET VARIABLE USER
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set     !
  type(observation),   intent(in)    :: obs     ! Observation
  logical,             intent(in)    :: delete  ! Delete structure only?
  logical,             intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='USER_SEC_SETVAR'
  !
  if (obs%user%n.eq.0)  return  ! No user section!
  if (cuserhooks.eq.0)  return  ! No current hooks defined!
  if (.not.associated(userhooks(cuserhooks)%setvar)) then
    call class_message(seve%e,rname,'No user function set for SET VAR USER')
    error = .true.
    return
  endif
  !
  call newdat_user(set,obs,error)
  !
end subroutine user_sec_setvar
!
subroutine user_sec_fix(obs,found,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>user_sec_fix
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !   Select or not the input observation according to its user section
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs    ! Observation
  logical,           intent(out)   :: found  !
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='USER_SEC_FIX'
  integer :: iuser
  !
  found = .false.
  !
  if (obs%user%n.eq.0)  return  ! No user section!
  if (cuserhooks.eq.0)  return  ! No current hooks defined!
  if (.not.associated(userhooks(cuserhooks)%fix))  return  ! No user function!
  !
  call class_user_exists(obs,iuser)
  if (iuser.eq.0)  return
  !
  ! Transfer the data to uwork
  unext = 1
  uwork(1:obs%user%sub(iuser)%ndata) = obs%user%sub(iuser)%data
  ! Call the user hook, which will read uwork by itself
  call userhooks(cuserhooks)%fix(obs%user%sub(iuser)%version,found,error)
  if (error)  return
  !
end subroutine user_sec_fix
!
subroutine user_sec_find(line,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>user_sec_find
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !  Command line parsing for option FIND /USER
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='USER_SEC_FIND'
  integer(kind=4), parameter :: optuser=16
  integer(kind=4), parameter :: muarg=10
  integer(kind=4) :: iarg,nuarg,nc
  character(len=32) :: uarg(muarg)
  !
  nuarg = sic_narg(optuser)
  if (nuarg.gt.muarg) then
    call class_message(seve%e,rname,'Too many arguments for option /USER')
    error = .true.
    return
  endif
  !
  ! Parse the command line and store arguments as strings
  do iarg=1,nuarg
    call sic_ch(line,16,iarg,uarg(iarg),nc,.true.,error)
    if (error)  return
  enddo
  !
  if (cuserhooks.eq.0 .or.  & ! No current hooks defined!
      .not.associated(userhooks(cuserhooks)%find)) then
    call class_message(seve%e,rname,'No user function for FIND /USER')
    error = .true.
    return
  endif
  !
  ! Send the string list to the user hook
  call userhooks(cuserhooks)%find(uarg,nuarg,error)
  if (error)  return
  !
end subroutine user_sec_find
!
subroutine user_sec_varidx_fill(obs,ient,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>user_sec_varidx_fill
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the VARIABLE /INDEX support array(s) for user section
  !---------------------------------------------------------------------
  type(observation),          intent(in)    :: obs    ! Observation
  integer(kind=entry_length), intent(in)    :: ient   ! Entry number in index
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='USER_SEC_VARIDX_FILL'
  integer(kind=4) :: iuser
  !
  if (obs%user%n.eq.0)  return  ! No user section!
  if (cuserhooks.eq.0)  return  ! No current hooks defined!
  if (.not.associated(userhooks(cuserhooks)%varidx_fill))  return  ! No user function!
  !
  call class_user_exists(obs,iuser)
  if (iuser.eq.0)  return
  !
  ! Transfer the data to uwork
  unext = 1
  uwork(1:obs%user%sub(iuser)%ndata) = obs%user%sub(iuser)%data
  ! Call the user hook, which will read uwork by itself
  call userhooks(cuserhooks)%varidx_fill(obs%user%sub(iuser)%version,ient,error)
  if (error)  return
  !
end subroutine user_sec_varidx_fill
!
subroutine user_sec_varidx_defvar(error)
  use gildas_def
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>user_sec_varidx_defvar
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !  Define the VARIABLE /INDEX sic arrays for user section
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  character(len=64) :: name
  !
  if (cuserhooks.eq.0)  error = .true.  ! No current hooks defined!
  if (.not.associated(userhooks(cuserhooks)%varidx_defvar))  error = .true.  ! No user function!
  if (error) then
    call class_message(seve%e,rname,'No user hook defined')
    return
  endif
  !
  name = 'IDX%USER'
  call sic_defstructure(name,.true.,error)
  if (error)  return
  !
  name = trim(name)//'%'//userhooks(cuserhooks)%owner
  call sic_defstructure(name,.true.,error)
  if (error)  return
  !
  name = trim(name)//'%'//userhooks(cuserhooks)%title
  call sic_defstructure(name,.true.,error)
  if (error)  return
  !
  ! Call the user hook
  call userhooks(cuserhooks)%varidx_defvar(error)
  if (error)  return
  !
end subroutine user_sec_varidx_defvar
!
subroutine user_sec_varidx_realloc(nent,error)
  use gildas_def
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>user_sec_varidx_realloc
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !  Re/Deallocate the VARIABLE /INDEX support arrays for user section
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)    :: nent   ! Size of arrays
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  !
  if (cuserhooks.eq.0)  return  ! No current hooks defined!
  if (.not.associated(userhooks(cuserhooks)%varidx_realloc))  return  ! No user function!
  !
  ! Call the user hook
  call userhooks(cuserhooks)%varidx_realloc(nent,error)
  if (error)  return
  !
end subroutine user_sec_varidx_realloc
!
subroutine classcore_user_owner(sowner,stitle)
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%owner character variable
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: sowner  ! Section owner
  character(len=*), intent(in) :: stitle  ! Section title
  ! Local
  integer(kind=4) :: ihook
  !
  cuserhooks = 0
  do ihook=1,nuserhooks
    if (userhooks(ihook)%owner.eq.sowner .and.  &
        userhooks(ihook)%title.eq.stitle) then
      ! Update old hooks
      cuserhooks = ihook
      exit
    endif
  enddo
  !
  if (cuserhooks.eq.0) then
    ! Define new hooks
    nuserhooks = nuserhooks+1
    cuserhooks = nuserhooks
    userhooks(cuserhooks)%owner = sowner
    userhooks(cuserhooks)%title = stitle
  endif
  !
end subroutine classcore_user_owner
!
subroutine classcore_user_toclass(usertoclass)
  use classcore_dependencies_interfaces
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%toclass procedure to the input procedure
  !---------------------------------------------------------------------
  external usertoclass
  !
  userhooks(cuserhooks)%toclass => usertoclass
  !
end subroutine classcore_user_toclass
!
subroutine classcore_user_dump(userdump)
  use classcore_dependencies_interfaces
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%dump procedure to the input procedure
  !---------------------------------------------------------------------
  external userdump
  !
  userhooks(cuserhooks)%dump => userdump
  !
end subroutine classcore_user_dump
!
subroutine classcore_user_setvar(set,usersetvar)
  use classcore_dependencies_interfaces
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%setvar procedure to the input procedure
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  external                        :: usersetvar
  ! Local
  logical :: error
  !
  if (set%varpresec(class_sec_user_id).ne.setvar_off) then
    error = .false.
    call sic_delvariable('R%USER',.false.,error)
  endif
  !
  userhooks(cuserhooks)%setvar => usersetvar
  !
end subroutine classcore_user_setvar
!
subroutine classcore_user_fix(userfix)
  use classcore_dependencies_interfaces
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%fix procedure to the input procedure
  !---------------------------------------------------------------------
  external userfix
  !
  userhooks(cuserhooks)%fix => userfix
  !
end subroutine classcore_user_fix
!
subroutine classcore_user_find(userfind)
  use classcore_dependencies_interfaces
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%find procedure to the input procedure
  !---------------------------------------------------------------------
  external userfind
  !
  userhooks(cuserhooks)%find => userfind
  !
end subroutine classcore_user_find
!
subroutine classcore_user_varidx_fill(uservaridx_fill)
  use classcore_dependencies_interfaces
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%varidx_fill procedure to the input
  ! procedure
  !---------------------------------------------------------------------
  external uservaridx_fill
  !
  userhooks(cuserhooks)%varidx_fill => uservaridx_fill
  !
end subroutine classcore_user_varidx_fill
!
subroutine classcore_user_varidx_defvar(uservaridx_defvar)
  use classcore_dependencies_interfaces
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%varidx_defvar procedure to the input
  ! procedure
  !---------------------------------------------------------------------
  external uservaridx_defvar
  !
  userhooks(cuserhooks)%varidx_defvar => uservaridx_defvar
  !
end subroutine classcore_user_varidx_defvar
!
subroutine classcore_user_varidx_realloc(uservaridx_realloc)
  use classcore_dependencies_interfaces
  use class_user
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Set the userhooks(cuserhooks)%varidx_realloc procedure to the input
  ! procedure
  !---------------------------------------------------------------------
  external uservaridx_realloc
  !
  userhooks(cuserhooks)%varidx_realloc => uservaridx_realloc
  !
end subroutine classcore_user_varidx_realloc
!
subroutine class_user_reset(set)
  use classcore_dependencies_interfaces
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ private
  !  Reset the User Subsection hooks, i.e. forget how to handle a
  ! specific User Subsection
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  ! Local
  logical :: error
  !
  userhooks(cuserhooks)%owner = ''
  userhooks(cuserhooks)%title = ''
  userhooks(cuserhooks)%toclass        => null()
  userhooks(cuserhooks)%dump           => null()
  userhooks(cuserhooks)%setvar         => null()
  userhooks(cuserhooks)%find           => null()
  userhooks(cuserhooks)%fix            => null()
  userhooks(cuserhooks)%varidx_fill    => null()
  userhooks(cuserhooks)%varidx_defvar  => null()
  userhooks(cuserhooks)%varidx_realloc => null()
  !
  if (set%varpresec(class_sec_user_id).ne.setvar_off) then
    error = .false.
    call sic_delvariable('R%USER',.false.,error)
  endif
  !
end subroutine class_user_reset
!
subroutine classcore_user_def_inte(set,obs,suffix,ndim,dims,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ public
  !  Define the Sic integer variable R%USER%OWNER%SUFFIX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set      !
  type(observation),   intent(in)    :: obs      !
  character(len=*),    intent(in)    :: suffix   ! Component name
  integer(kind=4),     intent(in)    :: ndim     ! Number of dimensions (0=scalar)
  integer(kind=4),     intent(in)    :: dims(4)  ! Dimensions (if needed)
  logical,             intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=32) :: name
  integer(kind=index_length) :: mydims(4)
  !
  name = 'R%USER%'//trim(userhooks(cuserhooks)%owner)//'%'//suffix
  mydims(:) = dims(:)
  call sic_def_inte_addr (name,obs%user%sub(usub)%data(unext),ndim,mydims,  &
    set%varpresec(class_sec_user_id).ne.setvar_write,error)
  unext = unext+product(dims(1:ndim))  ! If ndim==0, product is 1
  !
end subroutine classcore_user_def_inte
!
subroutine classcore_user_def_real(set,obs,suffix,ndim,dims,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ public
  !  Define the Sic real variable R%USER%OWNER%SUFFIX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set      !
  type(observation),   intent(in)    :: obs      !
  character(len=*),    intent(in)    :: suffix   ! Component name
  integer(kind=4),     intent(in)    :: ndim     ! Number of dimensions (0=scalar)
  integer(kind=4),     intent(in)    :: dims(4)  ! Dimensions (if needed)
  logical,             intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=32) :: name
  integer(kind=index_length) :: mydims(4)
  !
  name = 'R%USER%'//trim(userhooks(cuserhooks)%owner)//'%'//suffix
  mydims(:) = dims(:)
  call sic_def_real_addr (name,obs%user%sub(usub)%data(unext),ndim,mydims,  &
    set%varpresec(class_sec_user_id).ne.setvar_write,error)
  unext = unext+product(dims(1:ndim))  ! If ndim==0, product is 1
  !
end subroutine classcore_user_def_real
!
subroutine classcore_user_def_dble(set,obs,suffix,ndim,dims,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ public
  !  Define the Sic double variable R%USER%OWNER%SUFFIX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set      !
  type(observation),   intent(in)    :: obs      !
  character(len=*),    intent(in)    :: suffix   ! Component name
  integer(kind=4),     intent(in)    :: ndim     ! Number of dimensions (0=scalar)
  integer(kind=4),     intent(in)    :: dims(4)  ! Dimensions (if needed)
  logical,             intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=32) :: name
  integer(kind=index_length) :: mydims(4)
  !
  name = 'R%USER%'//trim(userhooks(cuserhooks)%owner)//'%'//suffix
  mydims(:) = dims(:)
  call sic_def_dble_addr (name,obs%user%sub(usub)%data(unext),ndim,mydims,  &
    set%varpresec(class_sec_user_id).ne.setvar_write,error)
  unext = unext+2*product(dims(1:ndim))  ! If ndim==0, product is 1
  !
end subroutine classcore_user_def_dble
!
subroutine classcore_user_def_char(set,obs,suffix,lchain,error)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_types
  use class_user
  !---------------------------------------------------------------------
  ! @ public
  !  Define the Sic character variable R%USER%OWNER%SUFFIX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set      !
  type(observation),   intent(in)    :: obs      !
  character(len=*),    intent(in)    :: suffix   ! Component name
  integer(kind=4),     intent(in)    :: lchain   ! String length in the 'data' buffer
  logical,             intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=32) :: name
  !
  name = 'R%USER%'//trim(userhooks(cuserhooks)%owner)//'%'//suffix
  call sic_def_strn (name,obs%user%sub(usub)%data(unext),lchain,  &
    set%varpresec(class_sec_user_id).ne.setvar_write,error)
  unext = unext+lchain/4
  !
end subroutine classcore_user_def_char
!
subroutine class_user_varidx_def_inte_1d(suffix,array,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_index
  use class_user
  !---------------------------------------------------------------------
  ! @ public-generic class_user_varidx_def_inte
  !  Define the Sic integer array IDX%USER%OWNER%TITLE%SUFFIX[:]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: suffix    ! Component name
  integer(kind=4),  intent(in)    :: array(:)  ! Target 1D array
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=64) :: name
  integer(kind=4) :: ndim
  integer(kind=index_length) :: dims(4)
  !
  name = 'IDX%USER%'//                             &
         trim(userhooks(cuserhooks)%owner)//'%'//  &
         trim(userhooks(cuserhooks)%title)//'%'//  &
         suffix
  !
  ndim = 1
  dims(1) = cx%next-1  ! Last dimension: limit to CX size (because
                       ! reallocation routines do not shrink arrays)
  call sic_def_inte(name,array,ndim,dims,.true.,error)
  if (error)  return
  !
end subroutine class_user_varidx_def_inte_1d
!
subroutine class_user_varidx_def_inte_2d(suffix,array,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_index
  use class_user
  !---------------------------------------------------------------------
  ! @ public-generic class_user_varidx_def_inte
  !  Define the Sic integer array IDX%USER%OWNER%TITLE%SUFFIX[:,:]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: suffix      ! Component name
  integer(kind=4),  intent(in)    :: array(:,:)  ! Target 2D array
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=64) :: name
  integer(kind=4) :: ndim
  integer(kind=index_length) :: dims(4)
  !
  name = 'IDX%USER%'//                             &
         trim(userhooks(cuserhooks)%owner)//'%'//  &
         trim(userhooks(cuserhooks)%title)//'%'//  &
         suffix
  !
  ndim = 2
  dims(1) = ubound(array,1)
  dims(2) = cx%next-1  ! Last dimension: limit to CX size (because
                       ! reallocation routines do not shrink arrays)
  call sic_def_inte(name,array,ndim,dims,.true.,error)
  if (error)  return
  !
end subroutine class_user_varidx_def_inte_2d
!
subroutine class_user_varidx_def_real_1d(suffix,array,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_index
  use class_user
  !---------------------------------------------------------------------
  ! @ public-generic class_user_varidx_def_real
  !  Define the Sic real array IDX%USER%OWNER%TITLE%SUFFIX[:]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: suffix    ! Component name
  real(kind=4),     intent(in)    :: array(:)  ! Target 1D array
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=64) :: name
  integer(kind=4) :: ndim
  integer(kind=index_length) :: dims(4)
  !
  name = 'IDX%USER%'//                             &
         trim(userhooks(cuserhooks)%owner)//'%'//  &
         trim(userhooks(cuserhooks)%title)//'%'//  &
         suffix
  !
  ndim = 1
  dims(1) = cx%next-1  ! Last dimension: limit to CX size (because
                       ! reallocation routines do not shrink arrays)
  call sic_def_real(name,array,ndim,dims,.true.,error)
  if (error)  return
  !
end subroutine class_user_varidx_def_real_1d
!
subroutine class_user_varidx_def_real_2d(suffix,array,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_index
  use class_user
  !---------------------------------------------------------------------
  ! @ public-generic class_user_varidx_def_real
  !  Define the Sic real array IDX%USER%OWNER%TITLE%SUFFIX[:,:]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: suffix      ! Component name
  real(kind=4),     intent(in)    :: array(:,:)  ! Target 2D array
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=64) :: name
  integer(kind=4) :: ndim
  integer(kind=index_length) :: dims(4)
  !
  name = 'IDX%USER%'//                             &
         trim(userhooks(cuserhooks)%owner)//'%'//  &
         trim(userhooks(cuserhooks)%title)//'%'//  &
         suffix
  !
  ndim = 2
  dims(1) = ubound(array,1)
  dims(2) = cx%next-1  ! Last dimension: limit to CX size (because
                       ! reallocation routines do not shrink arrays)
  call sic_def_real(name,array,ndim,dims,.true.,error)
  if (error)  return
  !
end subroutine class_user_varidx_def_real_2d
!
subroutine class_user_varidx_def_dble_1d(suffix,array,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_index
  use class_user
  !---------------------------------------------------------------------
  ! @ public-generic class_user_varidx_def_dble
  !  Define the Sic double array IDX%USER%OWNER%TITLE%SUFFIX[:]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: suffix    ! Component name
  real(kind=8),     intent(in)    :: array(:)  ! Target 1D array
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=64) :: name
  integer(kind=4) :: ndim
  integer(kind=index_length) :: dims(4)
  !
  name = 'IDX%USER%'//                             &
         trim(userhooks(cuserhooks)%owner)//'%'//  &
         trim(userhooks(cuserhooks)%title)//'%'//  &
         suffix
  !
  ndim = 1
  dims(1) = cx%next-1  ! Last dimension: limit to CX size (because
                       ! reallocation routines do not shrink arrays)
  call sic_def_dble(name,array,ndim,dims,.true.,error)
  if (error)  return
  !
end subroutine class_user_varidx_def_dble_1d
!
subroutine class_user_varidx_def_dble_2d(suffix,array,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_index
  use class_user
  !---------------------------------------------------------------------
  ! @ public-generic class_user_varidx_def_dble
  !  Define the Sic double array IDX%USER%OWNER%TITLE%SUFFIX[:,:]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: suffix      ! Component name
  real(kind=8),     intent(in)    :: array(:,:)  ! Target 2D array
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=64) :: name
  integer(kind=4) :: ndim
  integer(kind=index_length) :: dims(4)
  !
  name = 'IDX%USER%'//                             &
         trim(userhooks(cuserhooks)%owner)//'%'//  &
         trim(userhooks(cuserhooks)%title)//'%'//  &
         suffix
  !
  ndim = 2
  dims(1) = ubound(array,1)
  dims(2) = cx%next-1  ! Last dimension: limit to CX size (because
                       ! reallocation routines do not shrink arrays)
  call sic_def_dble(name,array,ndim,dims,.true.,error)
  if (error)  return
  !
end subroutine class_user_varidx_def_dble_2d
!
subroutine class_user_varidx_def_charn_1d(suffix,array,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_index
  use class_user
  !---------------------------------------------------------------------
  ! @ public-generic class_user_varidx_def_charn
  !  Define the Sic character array IDX%USER%OWNER%TITLE%SUFFIX[:]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: suffix    ! Component name
  character(len=*), intent(in)    :: array(:)  ! Target 1D array
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=64) :: name
  integer(kind=4) :: ndim
  integer(kind=index_length) :: dims(4)
  !
  name = 'IDX%USER%'//                             &
         trim(userhooks(cuserhooks)%owner)//'%'//  &
         trim(userhooks(cuserhooks)%title)//'%'//  &
         suffix
  !
  ndim = 1
  dims(1) = cx%next-1  ! Last dimension: limit to CX size (because
                       ! reallocation routines do not shrink arrays)
  call sic_def_charn(name,array,ndim,dims,.true.,error)
  if (error)  return
  !
end subroutine class_user_varidx_def_charn_1d
!
subroutine class_user_varidx_def_charn_2d(suffix,array,error)
  use gildas_def
  use classcore_dependencies_interfaces
  use class_index
  use class_user
  !---------------------------------------------------------------------
  ! @ public-generic class_user_varidx_def_charn
  !  Define the Sic character array IDX%USER%OWNER%TITLE%SUFFIX[:,:]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: suffix      ! Component name
  character(len=*), intent(in)    :: array(:,:)  ! Target 2D array
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=64) :: name
  integer(kind=4) :: ndim
  integer(kind=index_length) :: dims(4)
  !
  name = 'IDX%USER%'//                             &
         trim(userhooks(cuserhooks)%owner)//'%'//  &
         trim(userhooks(cuserhooks)%title)//'%'//  &
         suffix
  !
  ndim = 2
  dims(1) = ubound(array,1)
  dims(2) = cx%next-1  ! Last dimension: limit to CX size (because
                       ! reallocation routines do not shrink arrays)
  call sic_def_charn(name,array,ndim,dims,.true.,error)
  if (error)  return
  !
end subroutine class_user_varidx_def_charn_2d
!
subroutine classtoi4_0d(i4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write scalar integer*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  integer(kind=4), intent(out) :: i4
  call filein%conv%read%i4(uwork(unext),i4,1)
  unext = unext+1
end subroutine classtoi4_0d
!
subroutine classtor4_0d(r4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write scalar real*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=4), intent(out) :: r4
  call filein%conv%read%r4(uwork(unext),r4,1)
  unext = unext+1
end subroutine classtor4_0d
!
subroutine classtor8_0d(r8)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write scalar real*8 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=8), intent(out) :: r8
  call filein%conv%read%r8(uwork(unext),r8,1)
  unext = unext+2
end subroutine classtor8_0d
!
subroutine classtocc_0d(cc)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write scalar character(len=*) at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: cc
  ! Local
  integer(kind=4) :: cclen
  cclen = len(cc)/4  ! ZZZ Check if a multiple of 4? Round to upper 4-bytes?
  call filein%conv%read%cc(uwork(unext),cc,cclen)
  unext = unext+cclen
end subroutine classtocc_0d
!
subroutine classtoi4_1d(i4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write 1D array integer*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  integer(kind=4), intent(out) :: i4(:)
  ! Local
  integer(kind=4) :: l
  l = size(i4)
  call filein%conv%read%i4(uwork(unext),i4,l)
  unext = unext+l
end subroutine classtoi4_1d
!
subroutine classtor4_1d(r4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write 1D array real*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=4), intent(out) :: r4(:)
  ! Local
  integer(kind=4) :: l
  l = size(r4)
  call filein%conv%read%r4(uwork(unext),r4,l)
  unext = unext+l
end subroutine classtor4_1d
!
subroutine classtor8_1d(r8)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write 1D array real*8 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=8), intent(out) :: r8(:)
  ! Local
  integer(kind=4) :: l
  l = size(r8)
  call filein%conv%read%r8(uwork(unext),r8,l)
  unext = unext+2*l
end subroutine classtor8_1d
!
subroutine classtocc_1d(cc)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write 1D array character(len=*) at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: cc(:)
  ! Local
  integer(kind=4) :: cclen
  integer(kind=4) :: l
  l = size(cc)
  cclen = l*(len(cc(1))/4)  ! ZZZ Check if a multiple of 4? Round to upper 4-bytes?
  call filein%conv%read%cc(uwork(unext),cc,cclen)
  unext = unext+cclen
end subroutine classtocc_1d
!
subroutine classtoi4_2d(i4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write 2D array integer*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  integer(kind=4), intent(out) :: i4(:,:)
  ! Local
  integer(kind=4) :: l
  l = size(i4)
  call filein%conv%read%i4(uwork(unext),i4,l)
  unext = unext+l
end subroutine classtoi4_2d
!
subroutine classtor4_2d(r4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write 2D array real*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=4), intent(out) :: r4(:,:)
  ! Local
  integer(kind=4) :: l
  l = size(r4)
  call filein%conv%read%r4(uwork(unext),r4,l)
  unext = unext+l
end subroutine classtor4_2d
!
subroutine classtor8_2d(r8)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write 2D array real*8 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=8), intent(out) :: r8(:,:)
  ! Local
  integer(kind=4) :: l
  l = size(r8)
  call filein%conv%read%r8(uwork(unext),r8,l)
  unext = unext+2*l
end subroutine classtor8_2d
!
subroutine classtocc_2d(cc)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_classtodata
  ! Write 2D array character(len=*) at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: cc(:,:)
  ! Local
  integer(kind=4) :: cclen
  integer(kind=4) :: l
  l = size(cc)
  cclen = l*(len(cc(1,1))/4)  ! ZZZ Check if a multiple of 4? Round to upper 4-bytes?
  call filein%conv%read%cc(uwork(unext),cc,cclen)
  unext = unext+cclen
end subroutine classtocc_2d
!
subroutine i4toclass_0d(i4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write scalar integer*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: i4
  ! Local
  logical :: error
  !
  error = .false.
  call reallocate_uwork(unext,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%i4(i4,uwork(unext),1)
  unext = unext+1
end subroutine i4toclass_0d
!
subroutine r4toclass_0d(r4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write scalar real*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: r4
  ! Local
  logical :: error
  !
  error = .false.
  call reallocate_uwork(unext,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%r4(r4,uwork(unext),1)
  unext = unext+1
end subroutine r4toclass_0d
!
subroutine r8toclass_0d(r8)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write scalar real*8 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: r8
  ! Local
  logical :: error
  !
  error = .false.
  call reallocate_uwork(unext+1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%r8(r8,uwork(unext),1)
  unext = unext+2
end subroutine r8toclass_0d
!
subroutine cctoclass_0d(cc)
  use gbl_message
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write scalar character(len=*) at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cc
  ! Local
  integer(kind=4) :: cclen
  character(len=message_length) :: mess
  logical :: error
  !
  cclen = len(cc)/4  ! Truncate
  error = .false.
  call reallocate_uwork(unext+cclen-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%cc(cc,uwork(unext),cclen)
  unext = unext+cclen
  !
  if (cclen*4.ne.len(cc)) then
    write(mess,'(A,I0,A)')  &
      'String variable truncated to ',cclen*4,' characters'
    call class_message(seve%w,'USER',mess)
  endif
end subroutine cctoclass_0d
!
subroutine i4toclass_1d(i4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write 1D array integer*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: i4(:)
  ! Local
  integer(kind=4) :: l
  logical :: error
  !
  l = size(i4)
  error = .false.
  call reallocate_uwork(unext+l-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%i4(i4,uwork(unext),l)
  unext = unext+l
end subroutine i4toclass_1d
!
subroutine r4toclass_1d(r4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write 1D array real*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: r4(:)
  ! Local
  integer(kind=4) :: l
  logical :: error
  !
  l = size(r4)
  error = .false.
  call reallocate_uwork(unext+l-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%r4(r4,uwork(unext),l)
  unext = unext+l
end subroutine r4toclass_1d
!
subroutine r8toclass_1d(r8)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write 1D array real*8 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: r8(:)
  ! Local
  integer(kind=4) :: l
  logical :: error
  !
  l = size(r8)
  error = .false.
  call reallocate_uwork(unext+2*l-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%r8(r8,uwork(unext),l)
  unext = unext+2*l
end subroutine r8toclass_1d
!
subroutine cctoclass_1d(cc)
  use gbl_message
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write 1D array character(len=*) at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cc(:)
  ! Local
  integer(kind=4) :: cclen
  character(len=message_length) :: mess
  integer(kind=4) :: l
  logical :: error
  !
  l = size(cc)
  cclen = l*(len(cc(1))/4)  ! Truncate
  error = .false.
  call reallocate_uwork(unext+cclen-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%cc(cc,uwork(unext),cclen)
  unext = unext+cclen
  !
  if (cclen*4.ne.len(cc)) then
    write(mess,'(A,I0,A)')  &
      'String variable truncated to ',cclen*4,' characters'
    call class_message(seve%w,'USER',mess)
  endif
end subroutine cctoclass_1d
!
subroutine i4toclass_2d(i4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write 2D array integer*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: i4(:,:)
  ! Local
  integer(kind=4) :: l
  logical :: error
  !
  l = size(i4)
  error = .false.
  call reallocate_uwork(unext+l-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%i4(i4,uwork(unext),l)
  unext = unext+l
end subroutine i4toclass_2d
!
subroutine r4toclass_2d(r4)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write 2D array real*4 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: r4(:,:)
  ! Local
  integer(kind=4) :: l
  logical :: error
  !
  l = size(r4)
  error = .false.
  call reallocate_uwork(unext+l-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%r4(r4,uwork(unext),l)
  unext = unext+l
end subroutine r4toclass_2d
!
subroutine r8toclass_2d(r8)
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write 2D array real*8 at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: r8(:,:)
  ! Local
  integer(kind=4) :: l
  logical :: error
  !
  l = size(r8)
  error = .false.
  call reallocate_uwork(unext+2*l-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%r8(r8,uwork(unext),l)
  unext = unext+2*l
end subroutine r8toclass_2d
!
subroutine cctoclass_2d(cc)
  use gbl_message
  use classcore_dependencies_interfaces
  use class_buffer
  use class_common
  !---------------------------------------------------------------------
  ! @ public-generic class_user_datatoclass
  ! Write 2D array character(len=*) at next position in buffer 'uwork'
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cc(:,:)
  ! Local
  integer(kind=4) :: cclen
  character(len=message_length) :: mess
  integer(kind=4) :: l
  logical :: error
  !
  l = size(cc)
  cclen = l*(len(cc(1,1))/4)  ! Truncate
  error = .false.
  call reallocate_uwork(unext+cclen-1,.true.,error)
  if (error)  return
  !
  call fileout%conv%writ%cc(cc,uwork(unext),cclen)
  unext = unext+cclen
  !
  if (cclen*4.ne.len(cc)) then
    write(mess,'(A,I0,A)')  &
      'String variable truncated to ',cclen*4,' characters'
    call class_message(seve%w,'USER',mess)
  endif
end subroutine cctoclass_2d
!
subroutine reallocate_uwork(newlen,twice,error)
  use classcore_dependencies_interfaces
  use class_buffer
  !---------------------------------------------------------------------
  ! @ private
  !  Reallocate the 'uwork' working buffer
  !---------------------------------------------------------------------
  integer(kind=data_length), intent(in)    :: newlen  !
  logical,                   intent(in)    :: twice   ! Strict reallocation or twice more?
  logical,                   intent(inout) :: error   !
  ! Local
  logical :: dokeep
  integer(kind=data_length) :: oldlen,dolen
  integer(kind=4), allocatable :: tmp(:)
  integer(kind=4) :: ier
  !
  if (allocated(uwork)) then
    oldlen = size(uwork)
    if (oldlen.ge.newlen) then
      ! Already enough size, nothing to do
      return
    else
      allocate(tmp(oldlen),stat=ier)
      if (failed_allocate('REALLOCATE>USER','tmp buffer',ier,error))  return
      tmp(:) = uwork(:)
      deallocate(uwork)
      dokeep = .true.
      if (twice) then
        dolen = max(oldlen*2,newlen)
      else
        dolen = newlen
      endif
    endif
  else
    dokeep = .false.
    dolen = newlen
  endif
  !
  allocate(uwork(dolen),stat=ier)
  if (failed_allocate('REALLOCATE>USER','uwork buffer',ier,error))  return
  !
  if (dokeep) then
    uwork(1:oldlen) = tmp(1:oldlen)
    deallocate(tmp)
  endif
  !
end subroutine reallocate_uwork

program uv_getinterval
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='UV_GETINTERVAL'
  type(gildas) :: tab
  character(len=filename_length) :: filename
  logical :: error
  !
  error = .false.
  !
  call gildas_open
  call gildas_char('UVTABLE$',filename)
  call gildas_close
  !
  if (len_trim(filename).le.0) goto 99
  !
  ! Read all input file
  call gildas_null(tab,type='UVT')
  call gdf_read_gildas(tab,filename,'.uvt',error,data=.true.)
  if (gildas_error(tab,rname,error)) then
    write(6,*) 'F-UV_GETINTERVAL,  Cannot read input UV table'
    goto 99
  endif
  !
  call compute_eclass(tab,error)
  if (error)  goto 99
  !
  call gdf_close_image(tab,error)
  if (gildas_error(tab,rname,error))  goto 99
  !
  call gagout('S-UV_GETINTERVAL,  Successful completion')
  call sysexi(1)
  !
99 call sysexi(fatale)
  !
end program uv_getinterval
!
subroutine compute_eclass(tab,error)
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: tab
  logical,      intent(inout) :: error
  ! Global
  logical, external :: eclass_time_eq
  ! Local
  character(len=*), parameter :: rname='UV_GETINTERVAL'
  real(kind=8), allocatable :: datetime(:)
  real(kind=8) :: prevdatetime
  integer(kind=4), allocatable :: idx(:),work(:)
  integer(kind=4) :: ier,nvisi,ivisi,iequ,nuniq
  type(eclass_dble_t) :: eclass
  real(kind=8), parameter :: tol=1.d0  ! [sec]
  !
  ! Read/compute date-time for all visibilities
  nvisi = tab%gil%nvisi
  allocate(datetime(nvisi),idx(tab%gil%nvisi),stat=ier)
  if (failed_allocate(rname,'date-time arrays',ier,error))  return
  ! ZZZ This is valid only for UV tables (not TUV)
  datetime(:) = tab%r2d(code_uvt_date,:)*86400.d0 + tab%r2d(code_uvt_time,:)
  !
  ! Sort date-times
  call gr8_trie(datetime,idx,nvisi,error)
  !
  ! Compress datetime list by removing duplicates (most likely when
  ! considering several baselines of the same datetime dump)
  nuniq = 1
  prevdatetime = datetime(1)
  do ivisi=2,nvisi
    if (abs(prevdatetime-datetime(ivisi)).gt.tol) then
      nuniq = nuniq+1
      prevdatetime = datetime(ivisi)
      datetime(nuniq) = prevdatetime
    endif
  enddo
  !
  ! Compute equivalence classes with some tolerance
  call reallocate_eclass_dble(eclass,nuniq-1,error)
  if (error)  return
  do ivisi=1,nuniq-1
    eclass%val(ivisi) = datetime(ivisi+1) - datetime(ivisi)
    eclass%cnt(ivisi) = 1
  enddo
  call eclass_dble(eclass_time_eq,eclass)
  !
  ! Sort by increasing values (NB: this breaks the 'bak' pointer, use it
  ! as the index array)
  call gr8_trie(eclass%val,eclass%bak,eclass%nequ,error)
  if (error)  return
  allocate(work(eclass%nequ))
  call gi4_sort(eclass%cnt,work,eclass%bak,eclass%nequ)
  !
  write(*,'(4(A,I0))') "Found ",eclass%nequ," different time intervals among ",  &
    nuniq," date-times for ",nvisi," visibilities:"
  do iequ=1,eclass%nequ
    write (*,'(I3,A,F20.10,A,I5,A)')  &
      iequ," : ",eclass%val(iequ),' seconds (',eclass%cnt(iequ),' occurences)'
  enddo
  !
  call free_eclass_dble(eclass,error)
  if (error)  return
  !
end subroutine compute_eclass
!
function eclass_time_eq(x1,x2)
  !---------------------------------------------------------------------
  ! Equality routine between two time intervals (real*8) with a
  ! tolerance of 1 second
  !---------------------------------------------------------------------
  logical :: eclass_time_eq
  real(kind=8), intent(in) :: x1,x2  ! [sec]
  real(kind=8), parameter :: tol=1.d0  ! [sec]
  !
  eclass_time_eq = abs(x1-x2).le.tol
  !
end function eclass_time_eq

module sofia_types
  !
  type sofia_kalibrate_t
    ! Atmospheric model information
    character(len=12)   :: atmodel
    character(len=36)   :: atmid
    integer(kind=4)     :: atmarg
    ! Environment information
    real(kind=4)        :: tamb_sofi
    real(kind=4)        :: tempri1
    real(kind=4)        :: tempsec1
    ! Flight information
    real(kind=4)        :: gndspeed
    real(kind=4)        :: heading
    ! Instrument information
    character(len=16)   :: instrume
    character(len=32)   :: instcfg
    character(len=16)   :: frontend
    character(len=16)   :: backend
    ! Chopper information
    real(kind=4)        :: schpfrq
    real(kind=4)        :: chpamp1
    real(kind=8)        :: chpangle
    ! Mission management
    character(len=32)   :: datasrc
    character(len=32)   :: observer
    character(len=32)   :: operater ! operator is a keyword even in Fortran
    character(len=32)   :: planid
    character(len=32)   :: mission_id
    character(len=32)   :: obs_id
    ! Atmospheric calibration parameters
    real(kind=4)        :: pwv_mm
    real(kind=4)        :: err_pwv_mm
    integer(kind=4)     :: fit_pwv_mm
    real(kind=8)        :: ratio_f_th
    real(kind=4)        :: dry_atm
    real(kind=4)        :: err_dry_atm
    integer(kind=4)     :: fit_dry_atm
    real(kind=4)        :: dry_ratio
    real(kind=4)        :: err_dry_ratio
    integer(kind=4)     :: fit_dry_ratio
    real(kind=4)        :: tcold_scale
    real(kind=4)        :: err_tcold_scale
    integer(kind=4)     :: fit_tcold_scale
    real(kind=4)        :: tcold_ratio
    real(kind=4)        :: err_tcold_ratio
    integer(kind=4)     :: fit_tcold_ratio
    real(kind=4)        :: chisq
    real(kind=4)        :: pwv_ratio
    real(kind=4)        :: err_pwv_ratio
    integer(kind=4)     :: fit_pwv_ratio
    real(kind=4)        :: dry_off
    real(kind=4)        :: err_dry_off
    integer(kind=4)     :: fit_dry_off
    real(kind=4)        :: dry_off_ratio
    real(kind=4)        :: err_dry_off_ratio
    integer(kind=4)     :: fit_dry_off_ratio
    integer(kind=4)     :: last_load
    real(kind=8)        :: freq_off
    ! Beam rotator related angles
    real(kind=8)        :: posangle
    real(kind=8)        :: beamangle
    real(kind=8)        :: anglediff
    real(kind=8)        :: rxdx
    real(kind=8)        :: rxdy
    real(kind=8)        :: refrxdx
    real(kind=8)        :: refrxdy
    integer(kind=4)     :: signrxdx
    integer(kind=4)     :: signrxdy
    real(kind=8)        :: focallength
    ! Atmospheric model
    integer(kind=4)     :: atm_model_dim(2)
    real(kind=4), allocatable :: atm_model_data(:,:)
    character(len=12), allocatable :: atm_model_param(:)
    ! Runtime setup of kalibrate
    character(len=256)  :: kalibraterc
    character(len=256)  :: kalibrate_args
    character(len=256)  :: processing_steps
    character(len=256)  :: backend_grouping
    ! Observation setup
    character(len=32)   :: aor_id
    integer(kind=4)     :: aot_id_len
    character(len=4), allocatable :: aot_id(:)
    real(kind=4)        :: main_beam_eff
    integer(kind=4)     :: pi_name_len
    character(len=4), allocatable :: pi_name(:)
  end type sofia_kalibrate_t
  !
end module sofia_types
!
subroutine sofia_fromclass1(skdata,version)
  use sofia_types
  use class_api
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  type(sofia_kalibrate_t), intent(out) :: skdata   ! The data to be filled with the Class buffer
  integer(kind=4),         intent(in)  :: version  ! The version of the data
  !
  ! print *,'>>> Entering sofia_fromclass1'
  !
  call class_user_classtodata(skdata%atmodel)
  call class_user_classtodata(skdata%atmid)
  call class_user_classtodata(skdata%atmarg)

  if (version .lt. 2) then
    return
  end if

  call class_user_classtodata(skdata%tamb_sofi)
  call class_user_classtodata(skdata%tempri1)
  call class_user_classtodata(skdata%tempsec1)

  call class_user_classtodata(skdata%gndspeed)
  call class_user_classtodata(skdata%heading)

  call class_user_classtodata(skdata%instrume)
  call class_user_classtodata(skdata%instcfg)
  call class_user_classtodata(skdata%frontend)
  call class_user_classtodata(skdata%backend)

  call class_user_classtodata(skdata%schpfrq)
  call class_user_classtodata(skdata%chpamp1)
  call class_user_classtodata(skdata%chpangle)

  if (version .lt. 3) then
    return
  end if

  call class_user_classtodata(skdata%datasrc)
  call class_user_classtodata(skdata%observer)
  call class_user_classtodata(skdata%operater)
  call class_user_classtodata(skdata%planid)
  call class_user_classtodata(skdata%mission_id)
  call class_user_classtodata(skdata%obs_id)

  if (version .lt. 4) then
    return
  end if

  call class_user_classtodata(skdata%pwv_mm)
  call class_user_classtodata(skdata%err_pwv_mm)
  call class_user_classtodata(skdata%fit_pwv_mm)

  call class_user_classtodata(skdata%ratio_f_th)

  call class_user_classtodata(skdata%dry_atm)
  call class_user_classtodata(skdata%err_dry_atm)
  call class_user_classtodata(skdata%fit_dry_atm)

  call class_user_classtodata(skdata%dry_ratio)
  call class_user_classtodata(skdata%err_dry_ratio)
  call class_user_classtodata(skdata%fit_dry_ratio)

  call class_user_classtodata(skdata%tcold_scale)
  call class_user_classtodata(skdata%err_tcold_scale)
  call class_user_classtodata(skdata%fit_tcold_scale)

  call class_user_classtodata(skdata%tcold_ratio)
  call class_user_classtodata(skdata%err_tcold_ratio)
  call class_user_classtodata(skdata%fit_tcold_ratio)

  if (version .lt. 5) then
    return
  end if

  call class_user_classtodata(skdata%chisq)

  if (version .lt. 6) then
    return
  end if

  call class_user_classtodata(skdata%pwv_ratio)
  call class_user_classtodata(skdata%err_pwv_ratio)
  call class_user_classtodata(skdata%fit_pwv_ratio)

  if (version .lt. 7) then
    return
  end if

  call class_user_classtodata(skdata%dry_off)
  call class_user_classtodata(skdata%err_dry_off)
  call class_user_classtodata(skdata%fit_dry_off)

  call class_user_classtodata(skdata%dry_off_ratio)
  call class_user_classtodata(skdata%err_dry_off_ratio)
  call class_user_classtodata(skdata%fit_dry_off_ratio)

  if (version .lt. 8) then
    return
  end if

  call class_user_classtodata(skdata%last_load)

  if (version .lt. 9) then
    return
  end if

  call class_user_classtodata(skdata%freq_off)

  if (version .lt. 10) then
    return
  end if

  call class_user_classtodata(skdata%posangle)
  call class_user_classtodata(skdata%beamangle)
  call class_user_classtodata(skdata%anglediff)

  if (version .lt. 11) then
    return
  end if

  call class_user_classtodata(skdata%rxdx)
  call class_user_classtodata(skdata%rxdy)
  call class_user_classtodata(skdata%refrxdx)
  call class_user_classtodata(skdata%refrxdy)
  call class_user_classtodata(skdata%signrxdx)
  call class_user_classtodata(skdata%signrxdy)
  call class_user_classtodata(skdata%focallength)

  if (version .lt. 12) then
    return
  end if

  call class_user_classtodata(skdata%atm_model_dim)
  if (allocated(skdata%atm_model_data)) then
    deallocate(skdata%atm_model_data)
  end if
  allocate(skdata%atm_model_data(skdata%atm_model_dim(1),skdata%atm_model_dim(2)))
  call class_user_classtodata(skdata%atm_model_data)

  if (version .lt. 13) then
    return
  end if

  if (allocated(skdata%atm_model_param)) then
    deallocate(skdata%atm_model_param)
  end if
  allocate(skdata%atm_model_param(skdata%atm_model_dim(1)))
  call class_user_classtodata(skdata%atm_model_param)

  if (version .lt. 14) then
    return
  end if
  call class_user_classtodata(skdata%kalibraterc)
  call class_user_classtodata(skdata%kalibrate_args)
  call class_user_classtodata(skdata%processing_steps)
  call class_user_classtodata(skdata%backend_grouping)

  if (version .lt. 15) then
     return
  end if
  call class_user_classtodata(skdata%aor_id)
  call class_user_classtodata(skdata%aot_id_len)
  if (allocated(skdata%aot_id)) then
     deallocate(skdata%aot_id)
  end if
  allocate(skdata%aot_id(skdata%aot_id_len/4))
  call class_user_classtodata(skdata%aot_id)
  if (version .lt. 16) then
     return
  end if
  call class_user_classtodata(skdata%main_beam_eff)

  call class_user_classtodata(skdata%pi_name_len)
  if (allocated(skdata%pi_name)) then
     deallocate(skdata%pi_name)
  end if
  allocate(skdata%pi_name(skdata%pi_name_len/4))
  call class_user_classtodata(skdata%pi_name)
  return
  !
end subroutine sofia_fromclass1
!
subroutine sofia_dump1(version,error)
  use sofia_types
  !---------------------------------------------------------------------
  ! Hook for command LAS\DUMP
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: version  ! The version of the data
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  type(sofia_kalibrate_t) :: skdata   ! The data to be listed
  !
  ! print *,'>>> Entering sofia_dump1 for version ',version
  !
  call sofia_fromclass1(skdata,version)
  !
  print *,' atmodel            = ',skdata%atmodel
  print *,' atmid              = ',skdata%atmid
  print *,' atmarg             = ',skdata%atmarg

  if (version .lt. 2) then
    return
  end if

  print *,' tamb_sofi          = ',skdata%tamb_sofi
  print *,' tempri1            = ',skdata%tempri1
  print *,' tempsec1           = ',skdata%tempsec1

  print *,' gndspeed           = ',skdata%gndspeed
  print *,' heading            = ',skdata%heading

  print *,' instrume           = ',skdata%instrume
  print *,' instcfg            = ',skdata%instcfg
  print *,' frontend           = ',skdata%frontend
  print *,' backend            = ',skdata%backend

  print *,' schpfrq            = ',skdata%schpfrq
  print *,' chpamp1            = ',skdata%chpamp1
  print *,' chpangle           = ',skdata%chpangle

  if (version .lt. 3) then
    return
  end if

  print *,' datasrc            = ',skdata%datasrc
  print *,' observer           = ',skdata%observer
  print *,' operator           = ',skdata%operater
  print *,' planid             = ',skdata%planid
  print *,' mission_id         = ',skdata%mission_id
  print *,' obs_id             = ',skdata%obs_id

  if (version .lt. 4) then
    return
  end if

  print *,' pwv_mm             = ',skdata%pwv_mm
  print *,' err_pwv_mm         = ',skdata%err_pwv_mm
  print *,' fit_pwv_mm         = ',skdata%fit_pwv_mm

  print *,' ratio_f_th         = ',skdata%ratio_f_th

  print *,' dry_atm            = ',skdata%dry_atm
  print *,' err_dry_atm        = ',skdata%err_dry_atm
  print *,' fit_dry_atm        = ',skdata%fit_dry_atm

  print *,' dry_ratio          = ',skdata%dry_ratio
  print *,' err_dry_ratio      = ',skdata%err_dry_ratio
  print *,' fit_dry_ratio      = ',skdata%fit_dry_ratio

!  print *,' tcold_scale        = ',skdata%tcold_scale
!  print *,' err_tcold_scale    = ',skdata%err_tcold_scale
!  print *,' fit_tcold_scale    = ',skdata%fit_tcold_scale

!  print *,' tcold_ratio        = ',skdata%tcold_ratio
!  print *,' err_tcold_ratio    = ',skdata%err_tcold_ratio
!  print *,' fit_tcold_ratio    = ',skdata%fit_tcold_ratio

  if (version .lt. 5) then
    return
  end if

  print *,' chisq              = ',skdata%chisq

  if (version .lt. 6) then
    return
  end if

  print *,' pwv_ratio          = ',skdata%pwv_ratio
  print *,' err_pwv_ratio      = ',skdata%err_pwv_ratio
  print *,' fit_pwv_ratio      = ',skdata%fit_pwv_ratio

  if (version .lt. 7) then
    return
  end if

  print *,' dry_off            = ',skdata%dry_off
  print *,' err_dry_off        = ',skdata%err_dry_off
  print *,' fit_dry_off        = ',skdata%fit_dry_off

  print *,' dry_off_ratio      = ',skdata%dry_off_ratio
  print *,' err_dry_off_ratio  = ',skdata%err_dry_off_ratio
  print *,' fit_dry_off_ratio  = ',skdata%fit_dry_off_ratio

  if (version .lt. 8) then
    return
  end if

  print *,' last_load          = ',skdata%last_load

  if (version .lt. 9) then
    return
  end if

  print *,' freq_off           = ',skdata%freq_off

  if (version .lt. 10) then
    return
  end if

  print *,' posangle           = ',skdata%posangle
  print *,' beamangle          = ',skdata%beamangle
  print *,' anglediff          = ',skdata%anglediff

  if (version .lt. 11) then
    return
  end if

  print *,' rxdx               = ',skdata%rxdx
  print *,' rxdy               = ',skdata%rxdy
  print *,' refrxdx            = ',skdata%refrxdx
  print *,' refrxdy            = ',skdata%refrxdy
  print *,' signrxdx           = ',skdata%signrxdx
  print *,' signrxdy           = ',skdata%signrxdy
  print *,' focallength        = ',skdata%focallength

  if (version .lt. 12) then
    return
  end if

  print *,' atm_model_dim      = ',skdata%atm_model_dim
  print *,' atm_model_data     = (2-D array)'

  if (version .lt. 13) then
    return
  end if

  print *,' atm_model_param    = (string array)'

  if (version .lt. 14) then
    return
  end if

  print *,' kalibraterc        = ',trim(skdata%kalibraterc)
  print *,' kalibrate_args     = ',trim(skdata%kalibrate_args)
  print *,' processing_steps   = ',trim(skdata%processing_steps)
  print *,' backend_grouping   = ',trim(skdata%backend_grouping)

  if (version .lt. 15) then
     return
  end if

  print *,' aor_id             = ',skdata%aor_id
  print *,' aot_id_len         = ',skdata%aot_id_len
  print *,' aot_id             =  (character array)'

  if (version .lt. 16) then
     return
  end if

  print *,' main_beam_eff      = ',skdata%main_beam_eff
  print *,' pi_name_len        = ',skdata%pi_name_len
  print *,' pi_name            =  (character array)'

  return
  !
end subroutine sofia_dump1
!
subroutine sofia_setvar1(version,error)
  use gbl_message
  use class_api
  use sofia_types
  !---------------------------------------------------------------------
  ! Hook for command LAS\SET VARIABLE USER
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: version  ! The version of the data
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: ndim,dims(4)
  character(len=*), parameter :: rname='SOFIA_SETVAR1'
  !
  ! print *,'>>> Entering sofia_setvar1 for version ',version
  !
  error = .false.
  ndim = 0
  call class_user_def_char('ATMODEL',12,error)
  call class_user_def_char('ATMID',36,error)
  call class_user_def_inte('ATMARG',ndim,dims,error)

  if (version .lt. 2) then
    return
  end if

  call class_user_def_real('TAMB_SOFI',ndim,dims,error)
  call class_user_def_real('TEMPRI1',ndim,dims,error)
  call class_user_def_real('TEMPSEC1',ndim,dims,error)

  call class_user_def_real('GNDSPEED',ndim,dims,error)
  call class_user_def_real('HEADING',ndim,dims,error)

  call class_user_def_char('INSTRUME',16,error)
  call class_user_def_char('INSTCFG',32,error)
  call class_user_def_char('FRONTEND',16,error)
  call class_user_def_char('BACKEND',16,error)

  call class_user_def_real('SCHPFRQ',ndim,dims,error)
  call class_user_def_real('CHPAMP1',ndim,dims,error)
  call class_user_def_dble('CHPANGLE',ndim,dims,error)

  if (version .lt. 3) then
    return
  end if

  call class_user_def_char('DATASRC',32,error)
  call class_user_def_char('OBSERVER',32,error)
  call class_user_def_char('OPERATOR',32,error)
  call class_user_def_char('PLANID',32,error)
  call class_user_def_char('MISSION_ID',32,error)
  call class_user_def_char('OBS_ID',32,error)

  if (version .lt. 4) then
    return
  end if

  call class_user_def_real('PWV_MM',ndim,dims,error)
  call class_user_def_real('ERR_PWV_MM',ndim,dims,error)
  call class_user_def_inte('FIT_PWV_MM',ndim,dims,error)

  call class_user_def_dble('RATIO_F_TH',ndim,dims,error)

  call class_user_def_real('DRY_ATM',ndim,dims,error)
  call class_user_def_real('ERR_DRY_ATM',ndim,dims,error)
  call class_user_def_inte('FIT_DRY_ATM',ndim,dims,error)

  call class_user_def_real('DRY_RATIO',ndim,dims,error)
  call class_user_def_real('ERR_DRY_RATIO',ndim,dims,error)
  call class_user_def_inte('FIT_DRY_RATIO',ndim,dims,error)

  call class_user_def_real('TCOLD_SCALE',ndim,dims,error)
  call class_user_def_real('ERR_TCOLD_SCALE',ndim,dims,error)
  call class_user_def_inte('FIT_TCOLD_SCALE',ndim,dims,error)

  call class_user_def_real('TCOLD_RATIO',ndim,dims,error)
  call class_user_def_real('ERR_TCOLD_RATIO',ndim,dims,error)
  call class_user_def_inte('FIT_TCOLD_RATIO',ndim,dims,error)

  if (version .lt. 5) then
    return
  end if

  call class_user_def_real('CHISQ',ndim,dims,error)

  if (version .lt. 6) then
    return
  end if

  call class_user_def_real('PWV_RATIO',ndim,dims,error)
  call class_user_def_real('ERR_PWV_RATIO',ndim,dims,error)
  call class_user_def_inte('FIT_PWV_RATIO',ndim,dims,error)

  if (version .lt. 7) then
    return
  end if

  call class_user_def_real('DRY_OFF',ndim,dims,error)
  call class_user_def_real('ERR_DRY_OFF',ndim,dims,error)
  call class_user_def_inte('FIT_DRY_OFF',ndim,dims,error)

  call class_user_def_real('DRY_OFF_RATIO',ndim,dims,error)
  call class_user_def_real('ERR_DRY_OFF_RATIO',ndim,dims,error)
  call class_user_def_inte('FIT_DRY_OFF_RATIO',ndim,dims,error)

  if (version .lt. 8) then
    return
  end if

  call class_user_def_inte('LAST_LOAD',ndim,dims,error)

  if (version .lt. 9) then
    return
  end if

  call class_user_def_dble('FREQ_OFF',ndim,dims,error)

  if (version .lt. 10) then
    return
  end if

  call class_user_def_dble('POSANGLE',ndim,dims,error)
  call class_user_def_dble('BEAMANGLE',ndim,dims,error)
  call class_user_def_dble('ANGLEDIFF',ndim,dims,error)

  if (version .lt. 11) then
    return
  end if

  call class_user_def_dble('RXDX',ndim,dims,error)
  call class_user_def_dble('RXDY',ndim,dims,error)
  call class_user_def_dble('REFRXDX',ndim,dims,error)
  call class_user_def_dble('REFRXDY',ndim,dims,error)
  call class_user_def_inte('SIGNRXDX',ndim,dims,error)
  call class_user_def_inte('SIGNRXDY',ndim,dims,error)
  call class_user_def_dble('FOCALLENGTH',ndim,dims,error)

  if (version .lt. 12) then
    return
  end if

  ndim = 1
  dims(1) = 2
  call class_user_def_inte('ATM_MODEL_DIM',ndim,dims,error)
  call sic_get_inte('R%USER%SOFIA%ATM_MODEL_DIM[1]',dims(1),error)
  if (error) then
    call class_message(seve%e, rname, 'Cannot get R%USER%SOFIA%ATM_MODEL_DIM[1]')
    return
  end if
  call sic_get_inte('R%USER%SOFIA%ATM_MODEL_DIM[2]',dims(2),error)
  if (error) then
    call class_message(seve%e, rname, 'Cannot get R%USER%SOFIA%ATM_MODEL_DIM[2]')
    return
  end if
  if (dims(1)*dims(2) .gt. 0) then
    ndim = 2
    call class_user_def_real('ATM_MODEL_DATA',ndim,dims,error)
  end if
  ndim = 0

  if (version .lt. 13) then
    return
  end if

  if (dims(1) .gt. 0) then
    call class_user_def_char('ATM_MODEL_PARAM',12*dims(1),error)
  end if

  if (version .lt. 14) then
    return
  end if

  call class_user_def_char('KALIBRATERC',256,error)
  call class_user_def_char('KALIBRATE_ARGS',256,error)
  call class_user_def_char('PROCESSING_STEPS',256,error)
  call class_user_def_char('BACKEND_GROUPING',256,error)

  if (version .lt. 15) then
     return
  end if

  call class_user_def_char('AOR_ID',32,error)
  call class_user_def_inte('AOT_ID_LEN',ndim,dims,error)
  call sic_get_inte('R%USER%SOFIA%AOT_ID_LEN',dims(1),error)
  if (error) then
     call class_message(seve%e, rname, 'Cannot get AOT_ID_LEN')
     return
  end if
  call class_user_def_char('AOT_ID',dims(1),error)

  if (version .lt. 16) then
     return
  end if
  call class_user_def_real('MAIN_BEAM_EFF',ndim,dims,error)
  call class_user_def_inte('PI_NAME_LEN',ndim,dims,error)
  call sic_get_inte('R%USER%SOFIA%PI_NAME_LEN',dims(1),error)
  if (error) then
     call class_message(seve%e, rname, 'Cannot get PI_NAME_LEN')
     return
  end if
  call class_user_def_char('PI_NAME',dims(1),error)

  return
  !
end subroutine sofia_setvar1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_units_option
  use cubetools_parameters
  use cubetools_structure
  use cubetools_unit_arg
  use cubetools_unit
  use cubeset_messaging
  !
  public :: units_opt_option_t,units_opt_user_t
  private
  !
  type :: units_opt_option_t
    type(option_t),   pointer :: opt
    type(unit_arg_t), pointer :: arg
  contains
    procedure, public :: register => cubeset_units_opt_register
    procedure, public :: parse    => cubeset_units_opt_parse
  end type units_opt_option_t
  !
  type :: units_opt_user_t
    logical               :: present = .false.
    character(len=unit_l) :: name = strg_unk
  end type units_opt_user_t
  !
contains
  !
  subroutine cubeset_units_opt_register(option,kind,error)
    use cubetools_unit_setup
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(units_opt_option_t), intent(inout) :: option
    integer(kind=code_k),      intent(in)    :: kind
    logical,                   intent(inout) :: error
    !
    type(unit_arg_t)  :: unitarg
    character(len=*), parameter :: rname='UNITS>OPTION>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         unitkinds(kind),'name',&
         'Set current '//trim(unitkinds(kind))//' unit',&
         strg_emp,&
         option%opt,error)
    if (error) return
    call unitarg%register(&
         'name',&
         'New current unit name',&
         strg_emp,&
         code_arg_mandatory,&
         kind,&
         option%arg,&
         error)
    if (error) return
  end subroutine cubeset_units_opt_register
  !
  subroutine cubeset_units_opt_parse(option,line,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(units_opt_option_t), intent(inout) :: option
    character(len=*),          intent(in)    :: line
    type(units_opt_user_t),    intent(out)   :: user
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='UNITS>OPTION>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call option%opt%present(line,user%present,error)
    if (error) return
    if (user%present) then
       call cubetools_getarg(line,option%opt,1,user%name,mandatory,error)
       if (error) return
    endif
  end subroutine cubeset_units_opt_parse
end module cubeset_units_option
!
module cubeset_units
  use cubetools_structure
  use cubetools_unit_setup
  use cubetools_unit
  use cubeset_units_option
  use cubeset_messaging
  !
  public :: units
  private
  !
  type :: units_comm_t
     type(option_t), pointer  :: comm
     type(units_opt_option_t) :: kind(nunitkinds)
     type(option_t), pointer  :: def
   contains
     procedure, public  :: register => cubeset_units_register
     procedure, private :: parse    => cubeset_units_parse
     procedure, private :: main     => cubeset_units_main
  end type units_comm_t
  type(units_comm_t) :: units
  !
  type :: units_user_t
    type(units_opt_user_t) :: kind(nunitkinds)
    logical                :: dodef
  end type units_user_t
  !
contains
  !
  subroutine cubeset_units_command(line,error)
    !---------------------------------------------------------------------
    ! Support routine for command
    ! UNITS
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(units_user_t) :: user
    character(len=*), parameter :: rname='UNIT>COMMAND'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call units%parse(line,user,error)
    if (error) return
    call units%main(user,error)
    if (error) return
  end subroutine cubeset_units_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeset_units_register(units,error)
    use cubetools_parameters
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(units_comm_t), intent(inout) :: units
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='UNIT>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'UNITS','',&
         'Set current user units',&
         'Current units are used to display information to the user and to&
         & interpret user input. If called without options, UNITS lists&
         & current units and their conversion factors to internal units.&
         & Use /DEFAULT to restore default unit settings. When /DEFAULT&
         & is combined with other unit keys on the same command line,&
         & reset is applied first.',&
         cubeset_units_command,&
         units%comm,error)
    if (error) return
    !
    call units%kind(code_unit_uv)%register(code_unit_uv,error)
    if (error) return
    call units%kind(code_unit_fov)%register(code_unit_fov,error)
    if (error) return
    call units%kind(code_unit_pang)%register(code_unit_pang,error)
    if (error) return
    call units%kind(code_unit_beam)%register(code_unit_beam,error)
    if (error) return
    call units%kind(code_unit_freq)%register(code_unit_freq,error)
    if (error) return
    call units%kind(code_unit_velo)%register(code_unit_velo,error)
    if (error) return
    call units%kind(code_unit_wave)%register(code_unit_wave,error)
    if (error) return
    call units%kind(code_unit_chan)%register(code_unit_chan,error)
    if (error) return
    call units%kind(code_unit_pixe)%register(code_unit_pixe,error)
    if (error) return
    call units%kind(code_unit_dist)%register(code_unit_dist,error)
    if (error) return
    call units%kind(code_unit_unk)%register(code_unit_unk,error)
    if (error) return
    !
    call cubetools_register_option(&
         'DEFAULT','',&
         'Reset unit settings',&
         'Reset unit settings before applying other unit keys from the&
         & same command line.',&
         units%def,error)
    if (error) return
  end subroutine cubeset_units_register
  !
  subroutine cubeset_units_parse(units,line,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(units_comm_t), intent(inout) :: units
    character(len=*),    intent(in)    :: line
    type(units_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    integer(kind=4) :: ikind
    character(len=*), parameter :: rname='UNIT>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call units%def%present(line,user%dodef,error)
    if (error) return
    !
    do ikind=1,nunitkinds
       call units%kind(ikind)%parse(line,user%kind(ikind),error)
       if (error) return
    enddo
  end subroutine cubeset_units_parse
  !
  subroutine cubeset_units_main(units,user,error)
    use cubetools_unit_setup
    use cubetools_unit
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(units_comm_t), intent(in)    :: units
    type(units_user_t),  intent(in)    :: user
    logical,             intent(inout) :: error
    !
    integer(kind=4) :: ikind
    character(len=*), parameter :: rname='UNIT>MAIN'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (user%dodef) then
       call unitbuffer%defaults(error)
       if (error) return
    endif
    !
    do ikind=1,nunitkinds
       if (user%kind(ikind)%present) then
          call cubetools_unit_set(user%kind(ikind)%name,ikind,error)
          if (error) return
       endif
    enddo
    !
    if (cubetools_nopt().eq.0) then
       call unitbuffer%list(error)
       if (error) return
    endif
  end subroutine cubeset_units_main
end module cubeset_units
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine greg_write(line,error)
  use gbl_format
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_write
  use greg_kernel
  use greg_poly
  use greg_rg
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Support routine for command
  !
  !   WRITE
  !     COLUMN Filename [NEW [Format]] /TABLE X Nx Y Ny z Nz
  !     IMAGE
  !     RGDATA Filename "Comment X" "Comment Y"
  !     POLYGON
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='WRITE'
  integer(kind=4) :: nkey,nc
  character(len=filename_length) :: fname,ffile
  character(len=12) :: argum,keywor
  integer(kind=4), parameter :: mvoc=4
  character(len=7), parameter :: vocab(mvoc)=(/'COLUMN ','RGDATA ','POLYGON','IMAGE  '/)
  !
  ! Argument
  call sic_ke(line,0,1,argum,nc,.true.,error)
  if (error) return
  call sic_ambigs(rname,argum,keywor,nkey,vocab,mvoc,error)
  if (error) return
  !
  ! File name
  call sic_ch (line,0,2,fname,nc,.true.,error)
  if (error) return
  !
  ! Option /TABLE
  if (nkey.ne.1 .and. sic_present(1,0)) then
    call greg_message(seve%e,rname,'Option /TABLE valid only with COLUMN argument')
    error = .true.
    return
  endif
  !
  select case (keywor)
  case ('COLUMN')
    if (nxy.le.0) then
      call greg_message(seve%e,rname,'No column loaded')
      error = .true.
      return
    endif
    if (sic_present(1,0)) then ! WRITE COLUMN /TABLE (binary table)
      call greg_write_column(line,fname,error)
      if (error)  return
    else                       ! WRITE COLUMN (formatted table)
      call sic_parsef(fname,ffile,' ','.dat')
      open(unit=jtmp,file=ffile,status='NEW',err=98)
      call greg_message(seve%i,rname,'Creating '//ffile)
      if (.not.associated(column_z)) then
        call wrcol2(jtmp,nxy,column_x,column_y)
      else
        call wrcol3(jtmp,nxy,column_x,column_y,column_z)
      endif
      close(unit=jtmp)
    endif
    !
  case ('RGDATA')
    if (rg%status.eq.code_pointer_null) then
      call greg_message(seve%e,rname,'No map loaded')
      error=.true.
      return
    endif
    call sic_parsef(fname,ffile,' ','.dat')
    open(unit=jtmp,file=ffile,status='NEW',err=98)
    call greg_message(seve%i,rname,'Creating '//ffile)
    call greg_write_rgdata(line,jtmp,rg%data,rg%nx*rg%ny,error)
    close(unit=jtmp)
    !
  case ('POLYGON')
    call greg_poly_write(rname,gpoly,fname,error)
    if (error) return
    !
  case ('IMAGE')
    if (rg%status.eq.code_pointer_null) then
      call greg_message(seve%e,rname,'No map loaded')
      error=.true.
      return
    endif
    call sic_parsef(fname,ffile,' ','.gdf')
    call greg_message(seve%i,rname,'Creating '//ffile)
    call greg_write_image(ffile,rg%data,error)
    !
  end select
  return
  !
  ! Error opening file
98 continue
  call greg_message(seve%e,rname,'Cannot open file '//ffile)
  error = .true.
end subroutine greg_write
!
subroutine greg_write_column(line,fname,error)
  use image_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_write_column
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   WRITE COLUMN Filename [NEW [Format]] /TABLE X Nx Y Ny z Nz
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  character(len=*), intent(in)    :: fname
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='WRITE>COLUMN'
  integer(kind=4) :: ncx,ncy,ncz,iarg,nc
  integer(kind=index_length) :: ncn,odim2
  character(len=2) :: code  ! len=2 so that we trap syntax error with 2 letters
  type(gildas) :: t
  character(len=16) :: argum,keywor
  integer(kind=4), parameter :: matype=2  ! Access type
  character(len=3), parameter :: atype(matype) = (/'OLD','NEW'/)
  integer(kind=4), parameter :: mforms=3  ! Formats
  character(len=7), parameter :: forms(mforms) = (/'REAL   ','DOUBLE ','INTEGER'/)
  !
  ncx = 0
  ncy = 0
  ncz = 0
  !
  do iarg=1,max(1,sic_narg(1)),2  ! At least 1 argument is needed!
    ! X, Y, or Z
    call sic_ke(line,1,iarg,code,nc,.true.,error)
    if (error) return
    if (code.eq.'X') then
      call sic_i4(line,1,iarg+1,ncx,.true.,error)
    elseif (code.eq.'Y') then
      call sic_i4(line,1,iarg+1,ncy,.true.,error)
    elseif (code.eq.'Z') then
      call sic_i4(line,1,iarg+1,ncz,.true.,error)
    else
      call greg_message(seve%e,rname,'Unknown column code '//code)
      error = .true.
    endif
    if (error) return
  enddo
  !
  ! New or old table?
  argum = 'OLD'
  call sic_ke(line,0,3,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,argum,keywor,nc,atype,matype,error)
  if (error) return
  !
  call gildas_null(t, type='TABLE')
  if (keywor.eq.'NEW') then
    ! Create new file
    call sic_parse_file(fname,' ','.gdf',t%file)
    call greg_message(seve%i,rname,'Creating '//t%file)
    !
    ! Table format?
    argum = 'REAL'
    call sic_ke (line,0,4,argum,nc,.false.,error)
    if (error) return
    call sic_ambigs(rname,argum,keywor,nc,forms,mforms,error)
    if (error) return
    !
    t%gil%dim(1) = nxy
    t%gil%dim(2)  = max(ncx,ncy,ncz)
    if (keywor.eq.forms(1)) t%gil%form=fmt_r4
    if (keywor.eq.forms(2)) t%gil%form=fmt_r8
    if (keywor.eq.forms(3)) t%gil%form=fmt_i4
    call gdf_create_image (t, error)
    call gdf_allocate (t, error)
    !
  else
    ! Fill an existing file
    t%gil%form = 0  ! i.e. accept any format
    call gdf_read_gildas(t,fname,'.gdf',error,data=.false.)
    if (error) then
      call greg_message(seve%e,rname,'Error reading table')
      error = .true.
      return
    endif
    if (t%gil%dim(1).ne.nxy) then
      call greg_message(seve%e,rname,  &
        'Output table has incompatible number of lines')
      call gdf_close_image(t,error)
      error = .true.
      return
    endif
    if (t%gil%dim(2).lt.max(ncx,ncy,ncz)) then
      odim2 = t%gil%dim(2)
      call gdf_close_image (t, error)
      call greg_message(seve%w,rname,'Extending number of columns')
      ncn = max(ncx,ncy,ncz)
      call gdf_extend_image(t,ncn,error)
      if (error) return
    endif
    call gdf_allocate(t,error)  ! Allocate to new dimensions
    if (error) return
    ! Read only the old dimensions from disk
    t%blc(:) = 0
    t%blc(2) = 1
    t%trc(:) = 0
    t%trc(2) = odim2
    ! Damn why do I have to say where I want to read the data!?
    if (t%gil%form.eq.fmt_r4) then
      call gdf_read_data(t,t%r2d,error)
    elseif (t%gil%form.eq.fmt_r8) then
      call gdf_read_data(t,t%d2d,error)
    elseif (t%gil%form.eq.fmt_i4) then
      call gdf_read_data(t,t%i2d,error)
    endif
    t%blc(:) = 0
    t%trc(:) = 0
    if (error) then
      call my_close_image(t,error)
      return
    endif
  endif
  !
  ! OK now fill the requested columns
  if (t%gil%form.eq.fmt_r4) then
    !!Print *,'Real*4 ',t%gil%form,ncx,ncy,ncz
    if (ncx.ne.0)                             call r8tor4(column_x,t%r2d(1,ncx),nxy)
    if (ncy.ne.0)                             call r8tor4(column_y,t%r2d(1,ncy),nxy)
    if (ncz.ne.0 .and. associated(column_z))  call r8tor4(column_z,t%r2d(1,ncz),nxy)
    call gdf_write_data(t,t%r2d,error)
    !
  elseif (t%gil%form.eq.fmt_r8) then
    if (ncx.ne.0)                             call r8tor8(column_x,t%d2d(1,ncx),nxy)
    if (ncy.ne.0)                             call r8tor8(column_y,t%d2d(1,ncy),nxy)
    if (ncz.ne.0 .and. associated(column_z))  call r8tor8(column_z,t%d2d(1,ncz),nxy)
    call gdf_write_data(t,t%d2d,error)
    !
  elseif (t%gil%form.eq.fmt_i4) then
    if (ncx.ne.0)                             call r8toi4_fini(column_x,t%i2d(1,ncx),nxy,error)
    if (ncy.ne.0)                             call r8toi4_fini(column_y,t%i2d(1,ncy),nxy,error)
    if (ncz.ne.0 .and. associated(column_z))  call r8toi4_fini(column_z,t%i2d(1,ncz),nxy,error)
    if (.not.error)  &
      call gdf_write_data(t,t%i2d,error)
  else
    call greg_message(seve%e,rname,'Table format not supported')
    error = .true.
  endif
  call my_close_image(t,error)
  !
contains
  subroutine my_close_image(t,error)
    use image_def
    !-------------------------------------------------------------------
    ! Close the image and deallocate the data buffer. This subroutine
    ! is because we do not want to loose the error in case of error 
    ! recovery (status is reset by gdf_close_image...)
    !-------------------------------------------------------------------
    type(gildas), intent(inout) :: t
    logical,      intent(inout) :: error
    ! 
    logical :: err
    !
    err = .false.
    call gdf_close_image(t,err)
    if (associated(t%r2d)) deallocate(t%r2d)
    if (associated(t%d2d)) deallocate(t%d2d)
    if (associated(t%i2d)) deallocate(t%i2d)
    error = error.or.err  ! Propagate previous error
  end subroutine my_close_image
  !
end subroutine greg_write_column
!
subroutine greg_write_rgdata(line,jtmp,regmap,mreg,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_write_rgdata
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Writes a RGDATA like file from the Regular_Grid array
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line          ! Input command line
  integer(kind=4),  intent(in)    :: jtmp          ! Logical unit number
  integer(kind=4),  intent(in)    :: mreg          ! Size of array
  real(kind=4),     intent(in)    :: regmap(mreg)  ! Array to write
  logical,          intent(inout) :: error         ! Logical error flag
  ! Local
  character(len=80) :: fname
  integer(kind=4) :: nc
  !
  write (jtmp,*) rg%nx,rg%xref,rg%xval,rg%xinc
  if (sic_present(0,3)) then
    call sic_ch (line,0,3,fname,nc,.false.,error)
    write (jtmp,'(A)') fname
  else
    write (jtmp,'(A)') ' '
  endif
  write (jtmp,*) rg%ny,rg%yref,rg%yval,rg%yinc
  if (sic_present(0,4)) then
    call sic_ch (line,0,4,fname,nc,.false.,error)
    write (jtmp,'(A)') fname
  else
    write (jtmp,'(A)') ' '
  endif
  !
  ! Write the map
  write (jtmp,'(10Z8.8)') regmap
end subroutine greg_write_rgdata
!
subroutine greg_poly_write(rname,poly,fname,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_write
  use greg_kernel  ! For jtmp
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !  Write the given polygon into the output file
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  type(polygon_t),  intent(in)    :: poly
  character(len=*), intent(in)    :: fname
  logical,          intent(inout) :: error
  ! Local
  character(len=filename_length) :: ffile
  integer(kind=4) :: ier
  !
  if (poly%ngon.le.2) then
    call greg_message(seve%e,rname,'No polygon defined')
    error = .true.
    return
  endif
  !
  call sic_parse_file(fname,' ','.pol',ffile)
  ier = sic_open(jtmp,ffile,'NEW',.false.)
  if (ier.ne.0) then
    call putios('E-'//trim(rname)//',  ',ier)
    error = .true.
    return
  endif
  call greg_message(seve%i,rname,'Creating '//ffile)
  call wrcol2(jtmp,poly%ngon,poly%xgon,poly%ygon)
  ier = sic_close(jtmp)
  !
end subroutine greg_poly_write
!
subroutine wrcol2(jun,n,x,y)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: jun   !
  integer(kind=4), intent(in) :: n     !
  real(kind=8),    intent(in) :: x(*)  !
  real(kind=8),    intent(in) :: y(*)  !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    write(jun,*) x(i),y(i)
  enddo
end subroutine wrcol2
!
subroutine wrcol3(jun,n,x,y,z)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: jun   !
  integer(kind=4), intent(in) :: n     !
  real(kind=8),    intent(in) :: x(*)  !
  real(kind=8),    intent(in) :: y(*)  !
  real(kind=8),    intent(in) :: z(*)  !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    write(jun,*) x(i),y(i),z(i)
  enddo
end subroutine wrcol3
!
subroutine greg_write_image(name,array,error)
  use gildas_def
  use gbl_message
  use gbl_format
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_write_image
  use greg_wcs
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name      ! File name
  real(kind=4),     intent(in)    :: array(*)  ! Data array
  logical,          intent(inout) :: error     ! Error flag
  !
  call gildas_null(rg%imag)
  !
  ! Same assumption as BOX: X is 1 and Y is 2
  rg%imag%gil%ndim = 2
  rg%imag%gil%dim(1) = rg%nx
  rg%imag%gil%dim(2) = rg%ny
  rg%imag%gil%dim(3) = 1
  rg%imag%gil%dim(4) = 1
  rg%imag%gil%convert(:,1) = (/rg%xref,rg%xval,rg%xinc/)
  rg%imag%gil%convert(:,2) = (/rg%yref,rg%yval,rg%yinc/)
  !
  ! Blanking
  rg%imag%gil%blan_words = 2
  rg%imag%gil%bval = cblank
  rg%imag%gil%eval = eblank
  !
  ! Extrema
  if (rg%minmax) then
    rg%imag%gil%rmin = rg%zmin
    rg%imag%gil%rmax = rg%zmax
    rg%imag%gil%minloc(:) = 0
    rg%imag%gil%minloc(1) = nint((rg%zxmin-rg%xval)/rg%xinc+rg%xref)
    rg%imag%gil%minloc(2) = nint((rg%zymin-rg%yval)/rg%yinc+rg%yref)
    rg%imag%gil%maxloc(:) = 0
    rg%imag%gil%maxloc(1) = nint((rg%zxmax-rg%xval)/rg%xinc+rg%xref)
    rg%imag%gil%maxloc(2) = nint((rg%zymax-rg%yval)/rg%yinc+rg%yref)
    rg%imag%gil%extr_words = 6
  else
    rg%imag%gil%extr_words = 0
  endif
  !
  ! Section 4 DESCRIPTION
  rg%imag%char%unit = 'UNKNOWN'
  rg%imag%gil%posi_words = 12
  if (i_system.eq.type_ic) then
    call greg_message(seve%w,'WRITE',  &
      'Computing galactic coordinates of source from ICRS coordinates is not implemented')
    rg%imag%gil%lii = 0.d0
    rg%imag%gil%bii = 0.d0
    rg%imag%gil%ra = gproj%a0
    rg%imag%gil%dec = gproj%d0
    rg%imag%char%syst = 'ICRS'
    rg%imag%gil%epoc = equinox_null
    rg%imag%char%code(1) = 'RA'   ! Same assumption as BOX /ABS: X is RA
    rg%imag%char%code(2) = 'DEC'  ! Same assumption as BOX /ABS: Y is DEC
  elseif (i_system.eq.type_eq) then
    ! Compute alternate coordinates in galactic system
    if (i_equinox.eq.equinox_null) then
      call greg_message(seve%w,'WRITE',  &
        'Unknown equinox, could not compute galactic coordinates of source')
      rg%imag%gil%lii = 0.
      rg%imag%gil%bii = 0.
    else
      call equ_gal(gproj%a0,gproj%d0,i_equinox,rg%imag%gil%lii,rg%imag%gil%bii,error)
      if (error)  return
    endif
    rg%imag%gil%ra = gproj%a0
    rg%imag%gil%dec = gproj%d0
    rg%imag%char%syst = 'EQUATORIAL'
    rg%imag%gil%epoc = i_equinox
    rg%imag%char%code(1) = 'RA'   ! Same assumption as BOX /ABS: X is RA
    rg%imag%char%code(2) = 'DEC'  ! Same assumption as BOX /ABS: Y is DEC
  elseif (i_system.eq.type_ga) then
    ! Compute alternate coordinates in equatorial system, use an arbitrary
    ! equinox
    call gal_equ(gproj%a0,gproj%d0,rg%imag%gil%ra,rg%imag%gil%dec,i_equinox_def,error)
    if (error)  return
    rg%imag%gil%lii = gproj%a0
    rg%imag%gil%bii = gproj%d0
    rg%imag%char%syst = 'GALACTIC'
    rg%imag%gil%epoc = i_equinox_def
    rg%imag%char%code(1) = 'LII'  ! Same assumption as BOX /ABS: X is LII
    rg%imag%char%code(2) = 'BII'  ! Same assumption as BOX /ABS: Y is BII
  else
    rg%imag%gil%posi_words = 0
    rg%imag%char%syst = 'UNKNOWN'
  endif
  rg%imag%gil%desc_words = 18
  !
  ! Section 5 POSITION
  !
  ! Section 6 PROJECTION
  if (gproj%type.ne.p_none) then
    rg%imag%gil%ptyp = gproj%type
    rg%imag%gil%a0 = gproj%a0
    rg%imag%gil%d0 = gproj%d0
    rg%imag%gil%xaxi = 1
    rg%imag%gil%yaxi = 2
    rg%imag%gil%pang = gproj%angle
    rg%imag%gil%proj_words = 9
    if (u_angle.eq.u_second) then
      rg%imag%gil%convert(2:3,1:2)  = pi/3600d0/180d0 * rg%imag%gil%convert(2:3,1:2)
    elseif (u_angle.eq.u_minute) then
      rg%imag%gil%convert(2:3,1:2)  = pi/60d0/180d0 * rg%imag%gil%convert(2:3,1:2)
    elseif (u_angle.eq.u_degree) then
      rg%imag%gil%convert(2:3,1:2)  = pi/180d0 * rg%imag%gil%convert(2:3,1:2)
    endif
  endif
  !
  ! Now write the image, using the new interface
  rg%imag%file = name
  call gdf_write_image(rg%imag,array,error)
  !
end subroutine greg_write_image

subroutine gio_exis (is,gtype,name,form,size,error)
  use gbl_format
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_exis
  use gio_convert
  use gio_image
  !---------------------------------------------------------------------
  ! @ public
  ! GDF EXtend Image Slot
  !     Extend a Greg Data Frame, and return size and address to caller
  !     Used by SIC only
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: is     ! Image slot
  character(len=*),          intent(out)   :: gtype  ! Image type (GILDAS_vwxyz)
  character(len=*),          intent(in)    :: name   ! File name
  integer(kind=4),           intent(out)   :: form   ! Data format
  integer(kind=size_length), intent(inout) :: size   ! Data size
  logical,                   intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=record_length) :: old_nvb,new_nvb,js
  character(len=*), parameter :: rname='EXIS'
  integer(kind=4) :: ier,old_isbig
  integer :: zero(128) = 0
  logical :: allocate_last
  character(len=message_length) :: mess
  !
  ! Check frame is OK
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    error = .true.
    return
  elseif (islot(is).ne.code_gio_full) then
    call gio_message(seve%e,rname,'Image slot is already mapped')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Check header
  ier = sic_getlun (iunit(is))
  if (ier.ne.1) then
    error = .true.
    return
  endif
  open(unit=iunit(is),file=name,status='OLD',form='UNFORMATTED',  &
       action='READWRITE',recl=lenbuf*facunf,access='DIRECT',iostat=ier)
  if (ier.ne.0) then
    call putios(seve%e,'EXIS(Open)',ier)
    goto 99
  endif
  !
  ! Read old header
  read (unit=iunit(is),rec=1,iostat=ier) gdfbuf
  if (ier.ne.0) then
    call putios(seve%e,'EXIS(Read)',ier)
    goto 99
  endif
  ier = gio_eih (is,gtype,form,old_nvb)
  if (ier.ne.1) then
    call gio_message(seve%e,rname,'File is not a GILDAS Data Frame')
    goto 99
  endif
  !
  ! Compute allocation quantity, and extend if required
  new_nvb = gio_block(form,size)   ! New size
  !
  if (istbl(is).eq.1) then
    ! Output file is GDF version 1
    if (new_nvb.gt.ndb_64bit) then
      write (mess,'(A,I0,A,I0,A)')  &
        'Can not extend GDF V1 file: limit reached (',new_nvb,' > ',ndb_64bit,' blocks)'
      call gio_message(seve%e,rname,mess)
      goto 99
    endif
  endif
  !
  ! Perform pre-allocation if needed
  allocate_last = pre_allocate
  !
  old_isbig = isbig(is)
  ! Compute new blocking for efficiency reasons (gio_blocking with argument
  ! .true. to ensure rounding of the Blocking Factor). The logic of
  !       imblock(is) (End of file block)
  !       irblock(is) (last block read)
  !  and  iwblock(is) (last block written)
  ! ensures the end of file is handled properly in all cases
  ! (reading the last big block before completing it if needed).
  isbig(is) = gio_blocking(new_nvb,istbl(is),.true.)
  !
  ! Perform pre-allocation if blocking factor changed
  ! This is no longer needed, given the comment above
  !! if (old_isbig.ne.isbig(is)) allocate_last = .true.
  !
  if (allocate_last) then
    ! Write the last block to make sure all pointers are set
    ! If the extension is not too big, the possible file high-water
    ! marking will not harm too much
    if (new_nvb.gt.old_nvb) then
      js = new_nvb+istbl(is)
      write (unit=iunit(is),rec=js,iostat=ier) zero
      if (ier.ne.0) then
        call putios(seve%e,'EXIS(Extend)',ier)
        goto 99
      endif
      imblock(is) = js 
    endif
  endif
  !
  ! Update Header
  ier = gio_wih (is,gtype,iform(is),new_nvb)
  if (ier.eq.0) goto 99
  !
  do js=1,istbl(is)
    write(unit=iunit(is),rec=js) gdfbig(:,js)
  enddo
  !
  call gio_idim (is,size)
  ichan(is) = iunit(is)
  cname(is) = name             ! Remember name
  close(unit=iunit(is))        ! Close the file
  !
  islot(is) = code_gio_write
  return
  !
99 call gdf_deis(is,error)
  error = .true.
end subroutine gio_exis
!
subroutine gdf_extend_image (x,newdim,error)
  use image_def
  use gbl_format
  use gio_interfaces, except_this=>gdf_extend_image
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API routine
  !     Extend an existing image by increasing its LAST dimension
  !---------------------------------------------------------------------
  type(gildas),               intent(inout) :: x       ! Gildas Image
  integer(kind=index_length)                :: newdim  ! New value of last dimension
  logical,                    intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=12) :: gtype
  integer :: is,form,idime
  integer(kind=size_length) :: osize,nsize
  !
  call gio_geis (is,error)
  if (error) return
  call gio_wris (is,gtype,x%file,form,osize,error)
  if (error) return
  call gio_read_header(x,is,error)
  if (error) return
  !
  ! Now extend it if needed
  if (x%gil%ndim.lt.1) then
    x%gil%ndim = 1
    x%gil%dim(1) = 1
    x%gil%convert = 1.d0
  endif
  !
  if (newdim.gt.x%gil%dim(x%gil%ndim)) then
    x%gil%dim(x%gil%ndim) = newdim
    call gio_write_header(x,is,error)
    if (error) return
    call gio_clis (is,error)     ! Close image slot
    !
    nsize = 1
    do idime=1,x%gil%ndim
      nsize = nsize*x%gil%dim(idime)
    enddo
    call gio_exis (is,gtype,x%file,form,nsize,error)
    if (error) return
  endif
  !
  ! Set the image slot
  x%status = 0
  x%loca%islo = is
end subroutine gdf_extend_image

subroutine gtv_clear_alpha(output)
  use gtv_interfaces, except_this=>gtv_clear_alpha
  use gtv_types
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !  The purpose of this routine is to show the graphic display at best.
  ! To do that it
  !  - Clears the "Alphanumeric" plane of the input device
  !    is the graphic device.
  !  - Pop the graphic window on window systems
  !  - Does nothing in other cases.
  !---------------------------------------------------------------------
  type(gt_display) :: output         ! Output instance
  !
  ! Should add here protocol dependent code, such as "pop in front"
  if (output%dev%protocol.eq.p_x)  &
    call x_clal(output%x%graph_env)  ! Raise Window
  !
end subroutine gtv_clear_alpha
!
subroutine gtclal
  use gtv_interfaces, except_this=>gtclal
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public obsolescent 22-sep-2009
  ! Obsolete entry point to 'gtv_clear_alpha'. To be removed from
  ! official documentation before.
  !---------------------------------------------------------------------
  call gtv_clear_alpha(cw_output)
end subroutine gtclal
!
subroutine gtv_clear_graphic(output)
  use gtv_interfaces, except_this=>gtv_clear_graphic
  use gtv_types
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !  The purpose of this routine is to show the ALPHA display at best.
  ! To do that it
  !  - Lower the graphic window on window systems
  !  - Does nothing in other cases.
  !---------------------------------------------------------------------
  type(gt_display) :: output         ! Output instance
  !
  if (output%dev%protocol.eq.p_x)  &
    call x_clpl(output%x%graph_env)       ! Lower Window
  !
end subroutine gtv_clear_graphic

module cubetools_cubeid_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_flag_types
  !---------------------------------------------------------------------
  ! Support module for CubeID strings, i.e. family:flag1,flag2,...
  !---------------------------------------------------------------------
  !
  public :: cubeid_separ
  public :: cubetools_cubeid_string2familyflags
  public :: cubetools_cubeid_familyflags2string
  private
  !
  character(len=1), parameter :: cubeid_separ=':'  ! Family/flags separator
  !
  ! As of today there is no specific type defined for CubeID
  !
contains
  !
  subroutine cubetools_cubeid_string2familyflags(string,family,flags,error)
    !-------------------------------------------------------------------
    ! Transform a string into family name + list of flag_t
    !-------------------------------------------------------------------
    character(len=*),          intent(in)    :: string
    character(len=*),          intent(out)   :: family
    type(flag_t), allocatable, intent(out)   :: flags(:)
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: sep
    character(len=argu_l) :: stflags
    character(len=*), parameter :: rname='CUBEID>STRING2FAMILYFLAGS'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    sep = index(string,cubeid_separ)
    if (sep.eq.0) sep = len_trim(string)+1  ! No flags
    if (sep.eq.1) then
      call cubeheader_message(seve%e,rname,'Family name is empty')
      error =.true.
      return
    endif
    !
    family  = string(1:sep-1)
    stflags = string(sep+1:)
    !
    call cubetools_string_toflaglist(stflags,.false.,flags,error)
    if (error) return
  end subroutine cubetools_cubeid_string2familyflags
  !
  subroutine cubetools_cubeid_familyflags2string(family,flags,string,error)
    !-------------------------------------------------------------------
    ! From family name and flag codes, build the CubeID string
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: family
    type(flag_t),     intent(in)    :: flags(:)
    character(len=*), intent(out)   :: string
    logical,          intent(inout) :: error
    !
    call cubetools_flaglist_tostr(flags,size(flags,kind=flag_k),strflag=string,error=error)
    if (error) return
    string = trim(family)//cubeid_separ//string
  end subroutine cubetools_cubeid_familyflags2string
end module cubetools_cubeid_types

program uv_track
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Task to create a UV table from Station Coordinates and Observation
  ! parameters.
  !
  ! Does not include proper noise estimate for the time being
  !---------------------------------------------------------------------
  ! Global
  real :: a_lever
  include 'gbl_pi.inc'
  ! Local
  type(gildas) :: xima
  integer :: mstat, nstat, muv, ier, nc
  parameter (mstat=100, muv=10000)
  real, allocatable :: zch(:), zsh(:)
  real :: x(mstat), xx, yy, zz, sd, cd, sp, cp, h, sh, ch, phn(mstat)
  real :: y(mstat), z(mstat), extr, hlim(2)
  real :: hmin, hmax, array, uk, vk, horizon, phase, ph
  real :: uvmin, uvmin2, uv_spacing, diameter
  real*8 :: decs,freq,latitud,amat(9),bvec(3),az,el,avec(3),bandwidth
  integer :: i, j, k, kh, nh, lun, count, nvis, nshadow, nfill, ip, ff
  character(len=132) :: chain, file, fstation
  logical :: error,new,complete(mstat),ok
  real :: integ_time, frac, test, date, time, bandw
  real :: trec, tsys, tau, jpk, weight, total
  real :: step_time
  parameter (step_time=180.0)
  logical :: first
  integer :: next
  !------------------------------------------------------------------------
  nshadow = 0
  trec = 50.0
  tau = 0.1
  first = .true.
  total = 0.0
  ! Code:
  call gildas_open
  call gildas_dble('DECLINATION$',decs,1)
  call gildas_dble('FREQUENCY$',freq,1)
  call gildas_logi('NEW$',new,1)
  call gildas_char('UV_TABLE$',file)
  call gildas_char('STATION_FILE$',fstation)
  call gildas_real('UV_SPACING$',uv_spacing,1)
  call gildas_real('DIAMETER$',diameter,1)
  call gildas_real('HORIZON$',horizon,1)
  call gildas_dble('LATITUDE$',latitud,1)
  call gildas_real('HOUR$',hlim,2)
  call gildas_real('INTEGRATION$',integ_time,1)
  call gildas_real('BANDWIDTH$',bandw,1)
  !
  call gildas_real('TREC$',trec,1)
  call gildas_real('TAU$',tau,1)
  call gildas_real('PHASE$',phase,1)
  call gildas_close
  !
  decs = decs*pi/180.0
  !
  chain = file
  nc = lenc(chain)
  call sic_parsef(chain,file,' ','.uvt')
  call gagout('W-UV_TRACK,  Table name '   &
     &    //file(1:lenc(file)))
  !
  ! Use all stations in station file
  chain = fstation
  ier = sic_getlog(chain)
  call sic_parsef (chain,fstation,' ','.dat')
  !
  ! Antenna Diameter and Min UV spacing
  if (diameter.eq.0) then
    call gagout ('W-UV_TRACKS,  Antenna size unknown. '//   &
     &      'No shadowing warnings will be given.')
    jpk = 1.0
  else
    !
    ! Jy/K for 70 % Aperture efficiency
    jpk = 2.0*1.38e3*4.0/(pi*diameter**2)/0.70
    print *,'Using ',jpk,' Jansky/K'
  endif
  !
  ! Hour angle coverage
  horizon = max(3.0,min(horizon,90.0))
  !
  ! Observatory coordinates
  call amset(latitud,amat)     ! Hour-Dec to Az-El matrix
  !
  hmin = a_lever(sngl(decs),sngl(latitud),horizon)
  if (hmin.ge.0) then
    write(6,*) 'Dec. ',decs
    write(6,*) 'Latitude ',latitud
    write(6,*) 'E-UV_TRACK,  Source is not visible'
    call sysexi(fatale)
  endif
  sd = sin(decs)
  cd = cos(decs)
  !
  ! Hour angle range
  hmax = -hmin
  if (hlim(1).ne.0.0) then
    if (hlim(1).lt.hmin) then
      write(6,*) 'W-UV_TRACK,  Source rises only at ',hmin
    else
      hmin = hlim(1)
    endif
  endif
  if (hlim(2).ne.0.0) then
    if (hlim(2).gt.hmax) then
      write(6,*) 'W-UV_TRACK,  Source already sets at ',hmax
    else
      hmax = hlim(2)
    endif
  endif
  !
  ! Open Station Main List; Get best coverage from First Line
  ier = sic_getlun (lun)
  open (unit=lun,file=fstation(1:lenc(fstation)),status='OLD',   &
     &    iostat=ier,err=998)
  read (lun,'(A)',iostat=ier,end=998,err=998) chain
  !
  ! Handle various formats.
  array = 0.0
  ok = chain(1:1).eq.'!'
  if (ok) then
    do while(ok)
      read(lun,'(A)',iostat=ier) chain
      ok = chain(1:1).eq.'!'
    enddo
  else
    read(lun,'(A)',iostat=ier) chain
  endif
  array = array**2
  !
  ! Read X,Y,Z coordinates from station file
  nstat = 0
  xx = 0.
  yy = 0.
  zz = 0.
  ok = .true.
  do while (ok)
    nstat = nstat+1
    i = 1
    do while(chain(i:i).eq.' ')
      i = i+1
    enddo
    ip = index(chain(i:),' ')+i
    read(chain(ip:),*,iostat=ier) x(nstat),y(nstat),z(nstat)
    xx = xx+x(nstat)
    yy = yy+y(nstat)
    zz = zz+z(nstat)
    read(lun,'(A)',iostat=ier) chain
    ok = ier.eq.0
  enddo
  close(unit=lun)
  call sic_frelun(lun)
  xx = xx/nstat
  yy = yy/nstat
  zz = zz/nstat
  array = 0.0
  do i=1,nstat
    array = max(array,(x(i)-xx)**2+   &
     &      (y(i)-yy)**2+(z(i)-zz)**2)
  enddo
  array = 2.0*sqrt(array)
  write(6,*) 'I-UV_TRACKS, Array size is ',array
  !
  ! Get integration time in seconds
  ! FG 05.01.01 : force use of INTEG_TIME if given
  !
  if (integ_time.eq.0) then
    integ_time = 24.*3600.*uv_spacing/(4.*pi*array)
  endif
  integ_time = nint(integ_time)
  if (integ_time.gt.step_time) integ_time = step_time
  write(6,*) 'I-UV_TRACKS, Integration time ',integ_time,' sec.'
  frac = integ_time/3600.
  !
  ! Convert the phase noise into radian
  phase = pi*phase/180.0
  !
  ! Precompute the coordinates
  nh = nint((hmax-hmin)/frac)+2
  write(6,*) 'Number of time dump ',nh
  allocate (zch(nh),zsh(nh),stat=ier)
  nh = 0
  h = pi*hmin/12.0
  do while (h.lt.(pi*hmax/12.0))
    ch = cos(h)
    sh = sin(h)
    nh = nh + 1
    zch(nh) = ch
    zsh(nh) = sh
    h = h+pi*frac/12.0
  enddo
  write(6,*) 'Number of time dump ',nh
  !
  ! Bandwidth (in MHz)
  bandwidth = bandw            ! single -> double precision
  if (bandwidth.eq.0) then
    bandwidth = 8000.
  endif
  !
  ! Create or open table
  nvis = nh*nstat*(nstat-1)/2
  write(6,*) 'Number of visibilities ',nvis
  if (new) then
    xima%gil%inc(2) = integ_time
    call init_table (xima,file,nvis,decs,freq,bandwidth,error)
  else
    call extend_table (xima,file,nvis,decs,freq,bandwidth,error)
  endif
  if (error) then
    write(6,*) 'W-UV_TRACK,  Cannot open output Table'
    call sysexi(fatale)
  endif
  if (new) then
    allocate (xima%r2d(xima%gil%dim(1), xima%gil%dim(2)), stat=ier)
  else
    allocate (xima%r2d(xima%gil%dim(1), xima%trc(2)-xima%blc(2)+1), stat=ier)
  endif
  if (error) then
    write(6,*) 'W-UV_TRACK,  Cannot allocate output Table'
    call sysexi(fatale)
  endif
  count = 1
  !
  ! Shadowing
  uvmin2 = diameter**2
  h = pi*hmin/12.0
  next = 0
  nfill = 0
  !
  do k = 1,nh
    !
    ! Reset shadowing
    do i=1,nstat
      complete(i) = .true.
    enddo
    !
    ! Check for shadowing
    do i=1,nstat-1
      if (complete(i)) then
        do j=i+1,nstat
          if (complete(j)) then
            xx = x(i)-x(j)
            yy = y(i)-y(j)
            zz = z(i)-z(j)
            uk = zsh(k)*xx + zch(k)*yy
            vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
            if ((uk**2+vk**2).le.uvmin2) then
              test = (xx*zch(k) - yy*zsh(k))*cd + zz*sd
              if (test.gt.0.0) then
                complete(j) = .false.
                ff = j
              else
                complete(i) = .false.
                ff = i
              endif
              !!                        PRINT *,'U2+V2',UK**2+VK**2,UK,VK,UVMIN2,I,J,FF
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Fill the table now
    date = float(count)        ! In days
    time = k*frac*3600.0       ! In seconds
    !
    ! Compute source elevation
    avec(1) = zch(k)*cd
    avec(2) = zsh(k)*cd
    avec(3) = sd
    call matmul(amat,avec,bvec,1)
    call dangle(az,el,bvec)
    ! Compute Tsys
    call atmos(trec,tsys,tau,el)
    if (first) then
      print *,'Tsys ',tsys
      first = .false.
    endif
    ! Compute Weight
    weight= 2*bandwidth*integ_time/(jpk*tsys)**2
    total = total+weight
    !
    ! Generate phase noise
    call phase_sinus (phase,phn,nstat,h)
    !
    do i=1,nstat-1
      do j=i+1,nstat
        ph = phn(i)-phn(j)
        xx = x(i)-x(j)
        yy = y(i)-y(j)
        zz = z(i)-z(j)
        uk = zsh(k)*xx + zch(k)*yy
        vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
        next = next+1
        if (complete(i).and.complete(j)) then
          call fill_table (uk,vk,date,time,   &
     &            weight,i,j,xima%r2d(1,next),el,   &
     &            integ_time,ph)
          total = total+weight
          nfill = nfill+1
        else
          call fill_table (uk,vk,date,time,   &
     &            0.0,i,j,xima%r2d(1,next),el,   &
     &            integ_time,ph)
          nshadow = nshadow+1
        endif
      enddo
    enddo
    h = h+pi*frac/12.0
  enddo
  write(6,*) 'Wrote ',nfill,' Visibilities (',nshadow,' shadowed)'
  call gdf_write_data(xima,xima%r2d,error)
  call cut_table(xima,file,0,error)
  !
  ! Write estimate noise
  total = 1e-3/sqrt(total)
  write(6,*) 'I-UV_TRACK,  Expected noise ',total,' Jy/beam'
  stop
  !
  998   write(6,*) 'E-UV_TRACK,  Trouble with ASTRO_STATIONS'
  print *,fstation(1:lenc(fstation))
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
end program uv_track
!
!!subroutine newuvt_init (xima,name,nvis,error)
subroutine init_table (xima,name,nvis,dec,freq,bandwidth,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Creates the output table header in X (the significant header parameters
  ! have already been defned in clic_table)
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(out) :: error         ! Error flag
  real(8), intent(in) :: dec                         !
  real(8), intent(in) :: freq                        !
  real(8), intent(in) :: bandwidth                   !
  ! Local
  integer :: i, last
  !
  ! Do not nullify X header here: it has already been partly computed before.
  !
  error = .false.
  !
  xima%file = name
  xima%gil%blan_words = def_blan_words
  xima%gil%extr_words = def_extr_words
  xima%gil%desc_words = def_desc_words
  xima%gil%posi_words = def_posi_words
  xima%gil%proj_words = def_proj_words
  xima%gil%spec_words = def_spec_words
  xima%gil%reso_words = def_reso_words
  xima%gil%uvda_words = 2 ! Not Zero is enough
  !
  xima%gil%eval = 0.
  xima%gil%dim(2) = nvis              ! +1 ! = add the dummy uv = 7.5 m point
  xima%gil%ref(2) = 0.
  xima%gil%inc(2) = 1.                  ! needed to avoid crash in GRAPHIC
  xima%gil%val(2) = 0.
  xima%gil%ndim = 2
  xima%char%unit = 'Jy'
  xima%char%syst = 'EQUATORIAL'
  xima%gil%ptyp = p_azimuthal
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%gil%faxi = 1
  !
  xima%gil%dec = dec
  xima%gil%epoc = 2000.0
  xima%gil%a0 = xima%gil%ra
  xima%gil%d0 = xima%gil%dec
  xima%char%line = ' '
  xima%gil%fres = bandwidth
  if (freq.ne.0d0) then
    xima%gil%fima = (freq+12.0)*1d3
    xima%gil%freq = freq*1d3
  else
    xima%gil%fima = 102d3
    xima%gil%freq = 90d3
  endif
  xima%gil%val(1) = xima%gil%freq
  !
  ! Here define the order in which you want the extra "columns"
  xima%gil%column_pointer = 0
  xima%gil%column_size = 0
  xima%gil%column_pointer(code_uvt_u) = 1
  xima%gil%column_pointer(code_uvt_v) = 2
  xima%gil%column_pointer(code_uvt_w) = 3
  xima%gil%column_pointer(code_uvt_date) = 4
  xima%gil%column_pointer(code_uvt_time) = 5
  xima%gil%column_pointer(code_uvt_anti) = 6
  xima%gil%column_pointer(code_uvt_antj) = 7
  xima%gil%natom = 3
  xima%gil%nstokes = 1
  ! Extra columns
  xima%gil%fcol = 8
  last = xima%gil%fcol+xima%gil%natom * xima%gil%nchan
  xima%gil%column_pointer(code_uvt_el) = last
  last = last+1
  xima%gil%column_pointer(code_uvt_int) = last
!  if (scan) then
!    xima%gil%column_pointer(code_uvt_scan) = last
!    last = last+1
!  endif
!
!  if (positions) then
!    xima%gil%column_pointer(code_uvt_loff) = last
!    xima%gil%column_pointer(code_uvt_moff) = last
!    last = last+2
!  endif
  do i=1,code_uvt_last
    if (xima%gil%column_pointer(i).ne.0) xima%gil%column_size(i) = 1
  enddo
  !
  xima%gil%nvisi = nvis
  xima%gil%type_gdf = code_gdf_uvt
  call gdf_setuv (xima,error)
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2)
  print *, 'Into newuvt_init ',xima%gil%nvisi, xima%gil%nchan, xima%gil%dim(1:2)
  print *, 'Into newuvt_init UVDA_WORDS', xima%gil%uvda_words
  call gdf_create_image (xima,error)
  print *, 'Done newuvt_init '
end subroutine init_table
!<FF>
!!subroutine newuvt_extend (xima,name,nvis,nn,ndobs,ndscan,error,lc)
subroutine extend_table (xima,name,nvis,dec,freq,bandwidth,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Open a Table to extend it.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(out) :: error         ! Error flag
  real(8), intent(in) :: dec                         !
  real(8), intent(in) :: freq                        !
  real(8), intent(in) :: bandwidth                   !
!  integer, intent(in) :: nn             !
!  integer, intent(in) :: ndobs(nn)      !
!  integer, intent(in) :: ndscan(nn)     !
!  logical, intent(in) :: lc             ! Check table before
  ! Local
  integer(kind=size_length) :: mvis
  integer :: ier
  character(len=60) :: chain
  !-----------------------------------------------------------------------
  !
  call gdf_read_gildas(xima, name, '.uvt', error, data=.false.)
  if (.not.error) then
    if (abs(xima%gil%dec-dec).gt.1d-6) then
      write(6,*) 'W-ASTRO_UV,  Different declinations'
      error = .true.
    endif
    if (freq.ne.0.0 .and. (abs(freq-xima%gil%freq*1d-3).gt.1d-6)) then
      write(6,*) 'W-ASTRO_UV,  Different frequencies'
      error = .true.
    endif
    if (abs(bandwidth-xima%gil%fres).gt.1d-6) then
      write(6,*) 'W-ASTRO_UV, Different bandwidth'
      error = .true.
    endif
  endif
  if (error) return
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) xima%gil%dim(2),nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call gagout('I-EXTEND_TABLE,  '//chain)
  !
  mvis = xima%gil%dim(2)+nvis
  !
  print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  call gdf_extend_image (xima,mvis,error)
  print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  if (error) then
    call gagout('I-EXTEND_TABLE,  Table extension failed')
    return
  endif
  !
  ! Map only new region
  xima%blc(1) = 1
  xima%blc(2) = xima%gil%dim(2)+1-nvis
  xima%trc(1) = xima%gil%dim(1)
  xima%trc(2) = xima%gil%dim(2)
  print *, 'Done newuvt_extend '
end subroutine extend_table
!
subroutine cut_table (xima,name,ncut,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Update the number of visibilities
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: xima !
  character(len=*) :: name          !
  integer, intent(in) :: ncut         ! Number of missing visibilities
  logical :: error                    !
  !
  ! Local
  character(len=80) :: chain
  !----------------------------------------------------------------------
  !
  xima%gil%nvisi = xima%gil%dim(2) - ncut
  write(chain,1001) xima%gil%dim(2), xima%gil%nvisi
  xima%gil%dim(2) = xima%gil%nvisi
  call gagout('I-CUT_TABLE,  '//chain)
  call gdf_update_header(xima,error)
  print *, 'Done newuvt_cut ',xima%gil%nchan
  !
1001 format('Old size ',i8,' New ',i8)
end subroutine cut_table
!<FF>
subroutine fill_table (u,v,d,t,w,ideb,ifin,visi,e,dt,ph)
  !---------------------------------------------------------------------
  ! 7 Parametres :
  ! U, V, W=0, Date, Temps, Ant1, Ant2
  ! 3 values
  ! Reel, Imag, Poids
  ! 1.0,  0.0, 1.0
  !---------------------------------------------------------------------
  real :: u                         !
  real :: v                         !
  real :: d                         !
  real :: t                         !
  real :: w                         !
  integer :: ideb                   !
  integer :: ifin                   !
  real :: visi(*)                   !
  real :: e                         !
  real :: dt                        !
  real :: ph                        !
  !
  visi(1) = u
  visi(2) = v
  visi(3) = 0.0
  visi(4) = d
  visi(5) = t
  visi(6) = ideb
  visi(7) = ifin
  visi(8) = cos(ph)
  visi(9) = sin(ph)
  visi(10) = w
  visi(11) = e
  visi(12) = dt
end
!<FF>
function a_lever(d,d0,el)
  !---------------------------------------------------------------------
  ! Lever d'une etoile de declinaison D a latitude D0
  ! Ce code est different de "lever" de GreG, donc je l'appelle A_LEVER
  ! (sinon big problemes,...GD, 8-10-1992)
  ! D Declination in radians
  ! D0  Latitude in degrees
  !   EL  elevation limit in degrees
  ! LEVER Hour angle in Hours
  !
  ! PI/2-D0+EL < D  Circumpolaire
  ! D0-PI/2+EL < D < PI/2-D0+EL H = ACOS (TAN(D)/TAN(D0-PI/2))
  ! D < D0-PI/2+EL  Toujours couchee...
  !
  ! Formule applicable a la partie visible du ciel en projection
  ! sur un plan
  !---------------------------------------------------------------------
  real :: a_lever                   !
  real :: d                         !
  real :: d0                        !
  real :: el                        !
  ! Local
  real :: dd,d1,d2,ee
  real*8 :: pi
  parameter (pi=3.14159265358979323846d0)
  !
  if (d0.lt.0.) then
    d2 = -d
    d1 = -d0*pi/180.0
  else
    d2 = d
    d1 = d0*pi/180.0
  endif
  dd = d1-pi*0.5d0
  ee = el*pi/180.
  a_lever = (-sin(ee)+sin(d2)*cos(dd))/(cos(d2)*sin(dd))
  if (a_lever.le.-1.0) then
    a_lever = -12.0            ! Circumpolar
  elseif (a_lever.ge.1.0) then
    a_lever = 0.0              ! Not visible
  else
    a_lever = -12.0/pi* acos(a_lever)
  endif
end
!<FF>
subroutine amset(obslat,amat)
  !---------------------------------------------------------------------
  !   subroutine to provide transformation matrix from hour angle - dec
  !       into azimuth - elevation.
  !---------------------------------------------------------------------
  real*8 ::  obslat                 ! in degrees
  real*8 ::  amat(9)                !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::  x1,y1,z1
  !
  x1=pi/180d0*obslat
  y1=dsin(x1)
  z1=dcos(x1)
  amat(1)=-y1
  amat(2)=0.d0
  amat(3)=z1
  amat(4)=0.d0
  amat(5)=-1.d0
  amat(6)=0.d0
  amat(7)=z1
  amat(8)=0.d0
  amat(9)=y1
end
!<FF>
subroutine dangle(along,alat,a)
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine recovers the longitude and latitude angles, along
  ! (0 - 360) and alat ( +.- 180) in deg_to_radrees, which correspond to the
  ! vector a.
  !---------------------------------------------------------------------
  real*8 ::   along                 !
  real*8 ::   alat                  !
  real*8 ::   a(3)                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::   aa
  !
  aa     = a(1)*a(1)+a(2)*a(2)
  aa     = dsqrt(aa)
  alat   = pi/2d0
  if (aa.ge.0.000001d0) then
    aa = a(3)/aa
    alat = datan(aa)           ! latitude in Radian
  endif
  !
  if (a(2).ne.0.d0 .or. a(1).ne.0.d0) then
    along=datan2(a(2),a(1))    ! longitude in Radian
  else
    along = 0.d0
  endif
end
!<FF>
subroutine dcosin(along,alat,a)    ! direction cosinus
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine computes the vector a for the angles, along and alat,
  ! which should be specified in deg_to_radrees.
  !---------------------------------------------------------------------
  real*8 ::   along                 !
  real*8 ::   alat                  !
  real*8 ::   a(3)                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::   x,y,z
  !
  x    = along                 ! x in radians
  y    = alat                  ! y in radians
  z    = dcos(y)
  a(1) = dcos(x)*z
  a(2) = dsin(x)*z
  a(3) = dsin(y)
end
!<FF>
subroutine matmul(mat,a,b,n)
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.  G.Haslam
  ! version 2.0  iram
  !
  ! this routine provides the transformation of vector a to vector b
  ! using the n dimensional direction cosine array, mat.
  !---------------------------------------------------------------------
  real*8 ::    mat(3,3)             !
  real*8 ::    a(1)                 !
  real*8 ::    b(1)                 !
  integer ::   n                    !
  ! Local
  integer ::   i,j
  !
  if (n.gt.0) then
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(i,j)*a(j)
      enddo
    enddo
  else
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(j,i)*a(j)
      enddo
    enddo
  endif
end
!<FF>
subroutine atmos(trec,tsys,tau0,el)
  real :: trec                      !
  real :: tsys                      !
  real :: tau0                      !
  real*8 :: el                      !
  ! Local
  real :: tau,tatm,feff,tcab
  feff = 0.93
  tatm = 240.0
  tcab = 300.0
  !
  tau = tau0/sin(el)
  tsys = feff*(1.-exp(-tau))*tatm + (1.0-feff)*tcab + trec
  tsys = exp(tau)/feff*tsys
end
!<FF>
subroutine phase_sinus(phase,phn,n,h)
  real :: phase                     !
  integer :: n                      !
  real :: phn(n)                    !
  real :: h                         !
  ! Local
  integer :: i
  real :: rangau
  !
  ! A simple sinusoid variation
  do i = 1,n
    phn(i) = phase * sin(i*h)
  enddo
  ! Print *,'Phases ',phn
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module azimuth_average_head
  !
  interface
     subroutine azimuthal_averaging(image,averaged,summed,nxy,first,last,error)
       use image_def
       type (gildas), intent(in)  :: image
       type (gildas), intent(inout) :: averaged, summed
       logical,               intent(out) :: error
       integer,               intent(in)  :: first,last
       integer, dimension(2), intent(in)  :: nxy
     end subroutine azimuthal_averaging
  end interface
  !
end module azimuth_average_head
!
program azimuth_average
  use image_def
  use azimuth_average_head, only : azimuthal_averaging
  use gkernel_interfaces
  type (gildas) :: image_head,averaged_head,summed_head
  character(len=*), parameter :: rname = 'AZIMUTH_AVERAGE'
  logical :: error
  integer               :: nradius,nplane,iplane,first,last
  integer, dimension(2) :: nxy
  real, dimension(:,:),   allocatable, save, target :: averaged_data,summed_data
  real, dimension(:,:,:), allocatable, save, target :: image_data
  !
  ! Initialize gildas header
  call gildas_null(image_head)
  call gildas_null(summed_head)
  call gildas_null(averaged_head)
  !
  ! Get input parameters and verifies them
  call gildas_open
  call gildas_char('IMAGE$',image_head%file)
  call gildas_char('SUMMED$',summed_head%file)
  call gildas_char('AVERAGED$',averaged_head%file)
  call gildas_inte('NPLANE$',iplane,1)
  call gildas_close
  !
  ! Read IMAGE header, allocates memory space and reads data
  call gdf_read_header(image_head,error)
  if (gildas_error(image_head,rname,error)) call sysexi(fatale)
  nxy = image_head%gil%dim(1:2)
  !
  allocate(image_data(image_head%gil%dim(1),&
       image_head%gil%dim(2),&
       image_head%gil%dim(3)),&
       stat = image_head%status)
  if (gildas_error(image_head,rname,error)) call sysexi(fatale)
  image_head%r3d => image_data
  !
  call gdf_read_data(image_head,image_data,error)
  if (gildas_error(image_head,rname,error)) call sysexi(fatale)
  !
  ! Sanity checks
  if (iplane.eq.0) then
     first = 1
     last = image_head%gil%dim(3)
  else if (iplane.gt.image_head%gil%dim(3)) then
     call gagout('F-'//rname//',  iplane is greater than the 3rd image dimension')
     call sysexi(fatale)
  else if (iplane.lt.0) then
     call gagout('F-'//rname//',  iplane is negative or zero valued')
     call sysexi(fatale)
  else
     first = iplane
     last = iplane
  endif
  if ((image_head%gil%inc(1).eq.0.0).or.(image_head%gil%inc(2).eq.0.0)) then
     call gagout('F-'//rname//',  pixel size is zero valued')
     call sysexi(fatale)
  endif
  !
  ! Allocate memory space for the output results
  nradius = minval(nxy)
  nplane  = image_head%gil%dim(3)
  allocate(averaged_data(nradius,nplane),stat=averaged_head%status)
  if (gildas_error(averaged_head,rname,error)) call sysexi(fatale)
  averaged_head%r2d => averaged_data
  !
  allocate(summed_data(nradius,nplane),stat=summed_head%status)
  if (gildas_error(summed_head,rname,error)) call sysexi(fatale)
  summed_head%r2d => summed_data
  !
  ! Compute azimuthal average and sum
  call azimuthal_averaging(image_head,averaged_head,summed_head,nxy,first,last,error)
  if (error) call sysexi(fatale)
  !
  ! Write results on disk
  call gdf_write_image(averaged_head,averaged_data,error)
  if (gildas_error(averaged_head,rname,error)) call sysexi(fatale)
  !
  call gdf_write_image(summed_head,summed_data,error)
  if (gildas_error(summed_head,rname,error)) call sysexi(fatale)
  !
  ! Free memory space and return
  deallocate(image_data,stat=image_head%status)
  if (gildas_error(image_head,rname,error)) call sysexi(fatale)
  !
  deallocate(summed_data,stat=summed_head%status)
  if (gildas_error(summed_head,rname,error)) call sysexi(fatale)
  !
  deallocate(summed_data,stat=summed_head%status)
  if (gildas_error(averaged_head,rname,error)) call sysexi(fatale)
  !
end program azimuth_average
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine azimuthal_averaging(image,averaged,summed,nxy,first,last,error)
  use image_def
  use gkernel_interfaces
  type (gildas), intent(in)  :: image
  type (gildas), intent(inout) :: averaged,summed
  logical,               intent(out) :: error
  integer,               intent(in)  :: first,last
  integer, dimension(2), intent(in)  :: nxy
  !
  ! Local variables
  integer, dimension(min(nxy(1),nxy(2))) :: indices
  integer :: i,iplane,jplane,jradius,nrad
  real    :: r_pix,x_pix,y_pix
  real, dimension(nxy(1)) :: x
  real, dimension(nxy(2)) :: y
  real, dimension(nxy(1),nxy(2)) :: xy
  !
  error = .false.
  !
  x_pix = abs(image%gil%inc(1))
  y_pix = abs(image%gil%inc(2))
  !
  r_pix = sqrt(x_pix*y_pix)
  nrad  = min(nxy(1)*x_pix,nxy(2)*y_pix)/r_pix
  !
  x = (/ (real(i), i = 1, nxy(1)) /)
  y = (/ (real(i), i = 1, nxy(2)) /)
  !
  x = image%gil%val(1)+(x-image%gil%ref(1))*image%gil%inc(1)
  y = image%gil%val(2)+(y-image%gil%ref(2))*image%gil%inc(2)
  !
  summed%r2d = 0.0
  averaged%r2d = 0.0
  !
  do jradius = 1, nxy(2)
     xy(:,jradius) = sqrt(x**2+y(jradius)**2)
     indices = int(xy(:,jradius)/r_pix)+1
     do iplane=first,last
        jplane=iplane-first+1
        where(indices.le.nrad)
           summed%r2d(indices,jplane) = summed%r2d(indices,jplane) + image%r3d(:,jradius,iplane)
           averaged%r2d(indices,jplane) = averaged%r2d(indices,jplane) + 1.0
        endwhere
     enddo
  enddo
  !
  where(averaged%r2d /= 0.0)
     averaged%r2d = summed%r2d/averaged%r2d
  endwhere
  !
  ! Update headers
  summed%char = image%char
  summed%gil = image%gil
  summed%gil%dim(1) = nrad
  summed%gil%ref(1) = 1
  summed%gil%val(1) = 0.0
  summed%gil%inc(1) = r_pix
  summed%gil%xaxi = 1
  summed%gil%yaxi = 0
  if (last-first.eq.0) then
     summed%char%code(1) = 'AZM. SUM'
     summed%gil%ndim = 1
     summed%gil%dim(2) = 0
     summed%gil%ref(2) = 0
     summed%gil%val(2) = 0
     summed%gil%inc(2) = 0
     summed%gil%faxi = 0
  else
     summed%char%code(2) = image%char%code(3)
     summed%gil%ndim   = 2
     summed%gil%dim(2) = last-first+1
     summed%gil%ref(2) = image%gil%ref(3)
     summed%gil%val(2) = image%gil%val(3)
     summed%gil%inc(2) = image%gil%inc(3)
     summed%gil%faxi = 2
  endif
  summed%char%code(3:4) = 'UNKNOWN'
  summed%gil%dim(3:4) = 0
  summed%gil%convert(:,3:) =  0
  !
  averaged%gil  = summed%gil
  averaged%char = summed%char
  averaged%char%code(1) = 'AZM. AVE.'
  !
end subroutine azimuthal_averaging
!
!!!!!!!!!!!!!!!!!!!!! azimuth_average.f90 ends here !!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE GET_GRADVEL(TIME,ICOMP,REFCODE,VEL,B,ERROR)
C----------------------------------------------------------------------------
* Returns the radial velocity of one specified component at requested time
* and its gradient relative to the various orbital elements.
* This is basically a long 'case' statement that branches to the apropriate
* specific routines for each component. No actual calculation is done here.
*
** FIXME: Should be consolidated with GET_VELOCITY
C------------------------------------------------------------------------------
      REAL*8 TIME
      INTEGER ICOMP, REFCODE
      REAL*4 VEL, B(*)
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
*
      REAL PHASE
*
      CALL SET_TIME(1,IORB0,TIME,PHASE) ! Always needed...
      IF (ICOMP.EQ.1) THEN
         CALL GRAD_V1(REFCODE,VEL,B)
      ELSEIF (ICOMP.EQ.2) THEN
         CALL GRAD_V2(REFCODE,VEL,B)
      ELSEIF (ICOMP.EQ.11.OR.ICOMP.EQ.12) THEN
         CALL SET_TIME(1,IORB1,TIME,PHASE)
         IF (ICOMP.EQ.11) THEN
            CALL GRAD_V11(REFCODE,VEL,B)
         ELSEIF (ICOMP.EQ.12) THEN
            CALL GRAD_V12(REFCODE,VEL,B)
         ENDIF
      ELSEIF (ICOMP.EQ.21.OR.ICOMP.EQ.22) THEN
         CALL SET_TIME(1,IORB2,TIME,PHASE)
         IF (ICOMP.EQ.21) THEN
            CALL GRAD_V21(REFCODE,VEL,B)
         ELSEIF (ICOMP.EQ.22) THEN
            CALL GRAD_V22(REFCODE,VEL,B)
         ENDIF
      ELSE
         WRITE(6,*) 'E-VISU,  Unknown component ',ICOMP
         GOTO 99
      ENDIF
      IF (VEL.NE.VEL) THEN ! Check for NaNs
         WRITE(6,101) 'E-VELOCITY, Error evaluating velocity for ',
     +        'component ',ICOMP
         WRITE(6,101) 'E-VELOCITY, Velocity is Not a Number '
 101     FORMAT(1X,A,A,I2)
         GOTO 99  
      ENDIF
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END
*
      SUBROUTINE GET_VELOCITY(TIME,ICOMP,REFCODE,VEL,ERROR)
* Returns the radial velocity of one specified component at requested time.
* This is basically a long 'case' statement that branches to the apropriate
* specific routines for each component. No actual calculation is done here.
      REAL*8 TIME
      INTEGER ICOMP,REFCODE
      REAL*4 VEL
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
*
      REAL V1,V2,PHASE,B(MA)
*
      CALL SET_TIME(1,IORB0,TIME,PHASE)
      IF (ICOMP.EQ.1.OR.ICOMP.EQ.2) THEN
         CALL VALUE_V1_V2(REFCODE,V1,V2)
         IF (ICOMP.EQ.1) THEN
            VEL = V1
         ELSEIF (ICOMP.EQ.2) THEN
            VEL = V2
         ENDIF
      ELSEIF (ICOMP.EQ.11.OR.ICOMP.EQ.12) THEN
         CALL SET_TIME(1,IORB1,TIME,PHASE)
         IF (ICOMP.EQ.11) THEN
            CALL GRAD_V11(REFCODE,VEL,B)
         ELSEIF (ICOMP.EQ.12) THEN
            CALL GRAD_V12(REFCODE,VEL,B)
         ENDIF
      ELSEIF (ICOMP.EQ.21.OR.ICOMP.EQ.22) THEN
         CALL SET_TIME(1,IORB2,TIME,PHASE)
         IF (ICOMP.EQ.21) THEN
            CALL GRAD_V21(REFCODE,VEL,B)
         ELSEIF (ICOMP.EQ.22) THEN
            CALL GRAD_V22(REFCODE,VEL,B)
         ENDIF
      ELSE
         WRITE(6,*) 'E-VISU,  Unknown component ',ICOMP
         GOTO 99
      ENDIF
      IF (VEL.NE.VEL) THEN ! Check for NaNs
         WRITE(6,101) 'E-VELOCITY, Error evaluating velocity for ',
     +        'component ',ICOMP
         WRITE(6,101) 'E-VELOCITY, Velocity is Not a Number '
 101     FORMAT(1X,A,A,I2)
         GOTO 99  
      ENDIF
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END
*
      SUBROUTINE VALUE_V1_V2(CODE,V1,V2)
* Returns radial velocity values for the outer orbit
      REAL V1,V2
      INTEGER CODE
*
      INCLUDE 'constant.inc'
      INCLUDE 'kepler.inc'
      REAL DELTA
* Call basic keplerian orbit routine for the outer orbit.
      CALL KEPLER_RV(IORB0,V1,V2)
* Add the systemic velocity
      V1=V0+V1
      V2=V0+V2
* Add apropriate instrumental zero point correction when needed
      IF (CODE.LT.1.OR.CODE.GT.MVREF) write(6,*) 'ERROR, CODE:',code
      IF (CODE.GT.1) THEN
         DELTA = DV(CODE-1)
         V1=V1+DELTA
         V2=V2+DELTA
      ENDIF
* Add the gravitational+convective velocity shift for each component.
      V1=V1+DELTV(1,IORB0)
      V2=V2+DELTV(2,IORB0)
      RETURN
      END
*
*
      SUBROUTINE GRAD_V1(CODE,V1,B)
C B(j)=dV1/dEL(j), RES1=V1
      INTEGER CODE
      REAL V1,B(*)
*
      INCLUDE 'constant.inc'
      INCLUDE 'kepler.inc'
*
      INTEGER I
      REAL DELTA
*
      DO I=1,MA
         B(I)=0
      ENDDO
*
* Call keplerian radial velocity gradient routine for the outer orbit 
      CALL GRAD_VA(IORB0,V1,B)
* Add systemic velocity, and set the corresponding gradient element to +1
      V1   = V0+V1
      B(I_V0)= +1.
* Add grav+conv velocity shift, and set the corresponding gradient element 
* to +1
      V1 = V1 + DELTV(1,IORB0)
      B(I_DELTV1+ELINDX(IORB0)) = +1
* Add radial velocity zero point, and the set corresponding gradient element
* to +1
      IF (CODE.LT.1.OR.CODE.GT.MVREF) write(6,*) 
     +     'INTERNAL ERROR, CODE:',code
      IF (CODE.GT.1) THEN
         DELTA = DV(CODE-1)
         V1 = V1+DELTA
         B(MELEM+CODE-1) = +1.
      ENDIF
*
      RETURN
      END
*
      SUBROUTINE GRAD_V2(CODE,V2,B)
C B(j)=dV2/dEL(j), RES2=V2
      INTEGER CODE
      REAL V2,B(*)
*
      INCLUDE 'constant.inc'
      INCLUDE 'kepler.inc'
*
      INTEGER I
      REAL DELTA
*
      DO I=1,MA
         B(I)=0
      ENDDO
*
* Call keplerian radial velocity gradient routine for the outer orbit 
      CALL GRAD_VB(IORB0,V2,B)
* Add systemic velocity, and set the corresponding gradient element to +1
      V2   = V0+V2
      B(I_V0)= +1.
* Add grav+conv velocity shift, and set the corresponding gradient element 
* to +1
      V2 = V2 + DELTV(2,IORB0)
      B(I_DELTV2+ELINDX(IORB0)) = +1
* Add radial velocity zero point, and the set corresponding gradient element
* to +1
      IF (CODE.LT.1.OR.CODE.GT.MVREF) write(6,*) 'ERROR, CODE:',code
      IF (CODE.GT.1) THEN
         DELTA = DV(CODE-1)
         V2 = V2+DELTA
         B(MELEM+CODE-1) = +1.
      ENDIF
*
      RETURN
      END
C<FF>
      SUBROUTINE GRAD_V11(CODE,V11,B)
C B(j)=dV11/dEL(j), RES1=V11
      INTEGER CODE
      REAL V11,B(*)
*
      INCLUDE 'constant.inc'
      INCLUDE 'kepler.inc'
      REAL V1
*
* Call full gradient routine of the outer orbit
      CALL GRAD_V1(CODE,V1,B)
*
* Call keplerian gradient routine for the inner orbit 
      CALL GRAD_VA(IORB1,V11,B) ! B(ELINDX(IORB1)))

* Add the two components of V11: V11(Hel) = V1(Hel)+V11(1)
* As there is no overlap of orbital elements, there is no need
* for an explicit sum on the gradient, the two parts are just
* evaluated in place. CAUTION: this would not longer be true
* for a sel of physical+geometric elements.
      V11 = V11+V1
* Add grav+conv velocity shift, and set the corresponding gradient element 
* to +1. 
      V11 = V11 + DELTV(1,IORB1)
      B(I_DELTV1+ELINDX(IORB1)) = +1
*
      RETURN
      END
C<FF>
      SUBROUTINE GRAD_V12(CODE,V12,B)
C B(j)=dV12/dEL(j), RES1=V12
      INTEGER CODE
      REAL V12,B(*)
*
      INCLUDE 'constant.inc'
      INCLUDE 'kepler.inc'
      REAL V1
*
* Call full gradient routine of the outer orbit
      CALL GRAD_V1(CODE,V1,B)
*
* Call keplerian gradient routine for the inner orbit 
      CALL GRAD_VB(IORB1,V12,B) ! B(ELINDX(IORB1)))
* Add the two components of V12: V12(Hel) = V1(Hel)+V12(1)
* As there is no overlap of orbital elements, there is no need
* for an explicit sum on the gradient, the two parts are just
* evaluated in place.
      V12 = V12+V1
* Add grav+conv velocity shift, and set the corresponding gradient element 
* to +1. 
      V12 = V12 + DELTV(2,IORB1)
      B(I_DELTV2+ELINDX(IORB1)) = +1
*
      RETURN
      END
C<FF>
      SUBROUTINE GRAD_V21(CODE,V21,B)
C B(j)=dV21/dEL(j), RES1=V21
      INTEGER CODE
      REAL V21,B(*)
*
      INCLUDE 'constant.inc'
      INCLUDE 'kepler.inc'
      REAL V2
*
* Call full gradient routine of the outer orbit
      CALL GRAD_V2(CODE,V2,B)
*
* Call keplerian gradient routine for the inner orbit 
      CALL GRAD_VA(IORB2,V21,B) ! B(ELINDX(IORB2)))

* Add the two components of V21: V21(Hel) = V2(Hel)+V21(1)
* As there is no overlap of orbital elements, there is no need
* for an explicit sum on the gradient, the two parts are just
* evaluated in place.
      V21 = V21+V2
* Add grav+conv velocity shift, and set the corresponding gradient element 
* to +1. 
      V21 = V21 + DELTV(1,IORB2)
      B(I_DELTV1+ELINDX(IORB2)) = +1
*
      RETURN
      END
C<FF>
      SUBROUTINE GRAD_V22(CODE,V22,B)
C B(j)=dV22/dEL(j), RES1=V22
      INTEGER CODE
      REAL V22,B(*)
*
      INCLUDE 'constant.inc'
      INCLUDE 'kepler.inc'
      REAL V2
*
* Call full gradient routine of the outer orbit
      CALL GRAD_V2(CODE,V2,B)
*
* Call keplerian gradient routine for the inner orbit 
      CALL GRAD_VB(IORB2,V22,B) ! B(ELINDX(IORB2)))
* Add the two components of V22: V22(Hel) = V2(Hel)+V22(1)
* As there is no overlap of orbital elements, there is no need
* for an explicit sum on the gradient, the two parts are just
* evaluated in place.
      V22 = V22+V2
* Add grav+conv velocity shift, and set the corresponding gradient element 
* to +1. 
      V22 = V22 + DELTV(2,IORB2)
      B(I_DELTV2+ELINDX(IORB2)) = +1
*
*
      RETURN
      END

subroutine astro_catalog(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_catalog
  use ast_horizon
  use ast_astro
  use plot_molecules_globals
  !---------------------------------------------------------------------
  ! @ private
  ! ASTRO CATALOG name
  !	Defines the name of the source and molecular line catalog
  !---------------------------------------------------------------------
  character(len=*), intent(inout):: line           !
  logical, intent(inout) :: error                  !
  ! Local
  character(len=128) :: name,fbasename
  character(len=32) :: ext
  character(len=filename_length) :: file,file2,fdir,fsou,flin
  integer(kind=4) :: icat,l1,iext
  character(len=*), parameter :: rname='CATALOG'
  integer(kind=4), parameter :: optveleta=1
  integer(kind=4), parameter :: optalter=2
  integer(kind=4), parameter :: optline=3
  integer(kind=4), parameter :: optsource=4
  logical :: dosource
  !
  ! No arg = displays current catalogs
  if (.not.sic_present(0,1)) then
    l1 = lenc(catalog_name(1))
    if (l1.ne.0) then
      call astro_message(seve%i,rname,'Current source catalog is '//catalog_name(1))
    else
      call astro_message(seve%i,rname,'No Current source catalog opened')
    endif
    l1 = lenc(catalog_name(2))
    if (l1.ne.0) then
      call astro_message(seve%i,rname,'Alternate source catalog is '//catalog_name(2))
    else
      call astro_message(seve%i,rname,'No Alternate source catalog opened')
    endif
    l1 = lenc(molecules%catalog)
    if (l1.ne.0) then
      call astro_message(seve%i,rname,'Current line catalog is '//molecules%catalog)
    else
      call astro_message(seve%i,rname,'No Current line catalog opened')
    endif
    return
  endif 
  !
  call sic_ch (line,0,1,name,l1,.true.,error)
  if (error) return
  !
  !Resolve input file name
  call sic_parse_file(name,' ','',file)
  !Split file name to extract extension
  call sic_parse_name(file,fbasename,ext,fdir)
  !
  ! /VELETA Option
  if (sic_present(optveleta,0)) then
    if (sic_present(optline,0)) then
      call astro_message(seve%e,rname,'Options /VELETA and /LINE are exclusive from each other')
      error=.true.
      return
    endif
    if (ext.eq.'cat') then
      call astro_message(seve%w,rname,'/VELETA requires the file name without extension .CAT')
      file=file(1:iext-1)
    else if (len_trim(ext).ne.0) then
      call astro_message(seve%e,rname,'/VELETA requires a file name without extension')
      error=.true.
      return
    endif
    call format_catalog(line,error)
    if (error) return
    dosource=.true.
  endif
  !
  if (sic_present(optsource,0)) then !Option source
    dosource=.true.
  else if (sic_present(optline,0)) then !Option line
    dosource=.false.
  else if (ext.eq.'lin') then !Mode deduced from extension
    dosource=.false.
  else if (ext.eq.'sou') then !!Mode deduced from extension
    dosource=.true.
  else if (ext.eq.'') then
    write (fsou,'(a,a)') trim(file),'.sou'
    write (flin,'(a,a)') trim(file),'.lin'
    if (gag_inquire(fsou,len_trim(fsou)).eq.0) then !No extension and file.sou found
      dosource=.true.
    else if (gag_inquire(flin,len_trim(flin)).eq.0) then !!No extension and file.lin found
      dosource=.false.
    else
      call astro_message(seve%e,rname,'Could not find any catalog file')
      error=.true.
      return
    endif
  else !Extension given but neither .sou nor .lin
    dosource=.true.
  endif
  !
  if (dosource) then
    ext='.sou'
    if (sic_present(optalter,0)) then
      icat = 2
    else
      icat = 1
    endif  
    call get_catalog_name(file,file2,ext,error)
    if (error) return
    catalog_name(icat) = file2
    next_source(icat) = 1
    if (icat.eq.1) then
      call astro_message(seve%i,rname,'New source catalog is '//catalog_name(icat))
    else
      call astro_message(seve%i,rname,'New alternate source catalog is '//catalog_name(icat))
    endif
  else 
    ext='.lin'
    call get_catalog_name(file,file2,ext,error)
    if (error) return
    molecules%catalog = file2
    call astro_message(seve%i,rname,'New line catalog is '//molecules%catalog)
  endif
  !
end subroutine astro_catalog
!
subroutine get_catalog_name(file,file2,ext,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>get_catalog_name
  !---------------------------------------------------------------------
  ! @ private
  ! Decode the new catalog name
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: file    !
  character(len=*), intent(inout) :: file2   !
  character(len=*), intent(inout) :: ext     !
  logical,          intent(inout) :: error   !
  ! LOCal
  character(len=*), parameter :: rname='CATALOG'
  !
  call sic_parse_file(file,' ',ext,file2)
  if (gag_inquire(file2,len_trim(file2)).ne.0) then
    call astro_message(seve%e,rname,'Error opening '//trim(file2))
    error = .true.
    return
  endif
  !
end subroutine get_catalog_name

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_keyval_keyword_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_value_keywordlist_types
  use cubesyntax_messaging
  !
  public :: keyval_keyword_comm_t,keyval_keyword_user_t,keyval_keyword_prog_t
  private
  !
  type keyval_keyword_comm_t
     type(option_t), pointer        :: key
     type(value_keywordlist_comm_t) :: value
   contains
     procedure, public :: register => cubesyntax_keyval_keyword_comm_register
     procedure, public :: parse    => cubesyntax_keyval_keyword_comm_parse
  end type keyval_keyword_comm_t
  !
  type keyval_keyword_user_t
     logical               :: do = .false.
     character(len=argu_l) :: val = strg_star
   contains
     procedure, public :: toprog => cubesyntax_keyval_keyword_user_toprog
     procedure, public :: list   => cubesyntax_keyval_keyword_user_list
  end type keyval_keyword_user_t
  !
  type keyval_keyword_prog_t
     logical           :: do = .false. !
     character(len=32) :: keyword      ! Resolved keyword
     integer(kind=4)   :: ikeyword     ! Resolved position in value_keywordlist_comm_t
   contains
     procedure, public :: list   => cubesyntax_keyval_keyword_prog_list
  end type keyval_keyword_prog_t
  !
contains
  !
  subroutine cubesyntax_keyval_keyword_comm_register(comm,&
       keyname,keyabstract,keyhelp,valdefault,list,flexibl,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keyval_keyword_comm_t), intent(inout) :: comm
    character(len=*),             intent(in)    :: keyname
    character(len=*),             intent(in)    :: keyabstract
    character(len=*),             intent(in)    :: keyhelp
    character(len=*),             intent(in)    :: valdefault
    character(len=*),             intent(in)    :: list(:)
    logical,                      intent(in)    :: flexibl
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>KEYWORD>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         keyname,&
         'value',&
         keyabstract,&
         keyhelp,&
         comm%key,&
         error)
    if (error) return
    call comm%value%register(&
         keyname,&
         valdefault,&
         list,&
         flexibl,&
         error)
    if (error) return
  end subroutine cubesyntax_keyval_keyword_comm_register
  !
  subroutine cubesyntax_keyval_keyword_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! /KEY value
    !----------------------------------------------------------------------
    class(keyval_keyword_comm_t), intent(in)    :: comm
    character(len=*),             intent(in)    :: line
    type(keyval_keyword_user_t),  intent(out)   :: user ! => Initialized!
    logical,                      intent(inout) :: error
    !
    integer(kind=argu_k), parameter :: ival=1
    character(len=*), parameter :: rname='KEYVAL>KEYWORD>COMM>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,comm%key,ival,user%val,mandatory,error)
       if (error) return
    endif
  end subroutine cubesyntax_keyval_keyword_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_keyval_keyword_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keyval_keyword_user_t), intent(in)    :: user
    type(keyval_keyword_comm_t),  intent(in)    :: comm
    class(keyval_keyword_prog_t), intent(inout) :: prog
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>KEYWORD>USER>TOPROG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    prog%do = user%do
    if (user%do) then
      call cubetools_keywordlist_user2prog(comm%value%value,user%val, &
        prog%ikeyword,prog%keyword,error)
      if (error)  return
    else
      prog%keyword = comm%value%default
      prog%ikeyword = code_null
    endif
  end subroutine cubesyntax_keyval_keyword_user_toprog
  !
  subroutine cubesyntax_keyval_keyword_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging purpose
    !----------------------------------------------------------------------
    class(keyval_keyword_user_t), intent(in)    :: user
    logical,                      intent(inout) :: error
    !
!    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='KEYVAL>KEYWORD>USER>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
  end subroutine cubesyntax_keyval_keyword_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_keyval_keyword_prog_list(prog,comm,value,error)
    use cubesyntax_keyvalunit_list_tool
    !-------------------------------------------------------------------
    ! List the information in a user friendly way
    !-------------------------------------------------------------------
    class(keyval_keyword_prog_t), intent(in)    :: prog
    type(keyval_keyword_comm_t),  intent(in)    :: comm
    character(len=*),             intent(in)    :: value
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>KEYWORD>PROG>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call keyvalunit%list(comm%key%name,value,error)
    if (error) return
  end subroutine cubesyntax_keyval_keyword_prog_list
end module cubesyntax_keyval_keyword_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gag_fromdate(date,idate,error)
  use gsys_interfaces, except_this=>gag_fromdate
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !  Converts the date '01-JAN-1984' in internal code
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: date   ! String date
  integer(kind=4),  intent(out)   :: idate  ! Internal coded date value
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DATE'
  character(len=3) :: cm(12),m
  integer(kind=4) :: id,iy,im,ier
  character(len=1) :: d1,d2
  ! Data
  data cm /'JAN','FEB','MAR','APR','MAY','JUN',  &
           'JUL','AUG','SEP','OCT','NOV','DEC'/
  !
  error=.false.
  if (date.eq.'*') return
  read(date,'(I2,A1,A3,A1,I4)',iostat=ier) id,d1,m,d2,iy
  if (ier.ne.0 .or. d1.ne.'-' .or. d2.ne.'-') then
    call gsys_message(seve%e,rname,'Date conversion error')
    error=.true.
    return
  endif
  !
  call sic_upper(m)
  do im=1,12
    if (cm(im).eq.m) then
      call gag_datj(id,im,iy,idate)
      return
    endif
  enddo
  !
  call gsys_message(seve%e,rname,'Date conversion error')
  error=.true.
  return
  !
end subroutine gag_fromdate
!
subroutine gag_todate(idate,date,error)
  use gsys_interfaces, except_this=>gag_todate
  !---------------------------------------------------------------------
  ! @ public
  ! Converts the internal code to formatted date
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: idate  ! Internal coded date value
  character(len=*), intent(out)   :: date   ! String date
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=3) :: cm(12)
  integer(kind=4) :: id,iy,im,ier
  ! Data
  data cm /'JAN','FEB','MAR','APR','MAY','JUN',  &
           'JUL','AUG','SEP','OCT','NOV','DEC'/
  !
  call gag_jdat(idate,id,im,iy)
  write(date,1000,iostat=ier) id,cm(im),iy
1000 format(i2.2,'-',a,'-',i4.4)
end subroutine gag_todate
!
subroutine gag_fromyyyymmdd(string,dobs,error)
  use gsys_interfaces, except_this=>gag_fromyyyymmdd
  !---------------------------------------------------------------------
  ! @ public
  ! Decode a string date in the format "YYYYMMDD" into a gag date
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: string  !
  integer(kind=4),  intent(out)   :: dobs    !
  logical,          intent(inout) :: error   !
  ! Local
  integer(kind=4) :: iy,im,id,ier
  !
  read(string(1:4),'(I4)',iostat=ier)  iy
  if (ier.ne.0) then
    error = .true.
    return
  endif
  read(string(5:6),'(I2)',iostat=ier)  im
  if (ier.ne.0) then
    error = .true.
    return
  endif
  read(string(7:8),'(I2)',iostat=ier)  id
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  call gag_datj(id,im,iy,dobs)
  !
end subroutine gag_fromyyyymmdd
!
subroutine gag_toyyyymmdd(dobs,string,error)
  use gsys_interfaces, except_this=>gag_toyyyymmdd
  !---------------------------------------------------------------------
  ! @ public
  ! Encode a gag date to a string date in the format "YYYYMMDD"
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: dobs    !
  character(len=*), intent(out)   :: string  !
  logical,          intent(inout) :: error   !
  ! Local
  integer(kind=4) :: iy,im,id,ier
  !
  call gag_jdat(dobs,id,im,iy)
  !
  string = ''  ! First fill the whole string with blanks
  !
  write(string(1:4),'(I4.4)',iostat=ier)  iy
  if (ier.ne.0) then
    error = .true.
    return
  endif
  write(string(5:6),'(I2.2)',iostat=ier)  im
  if (ier.ne.0) then
    error = .true.
    return
  endif
  write(string(7:8),'(I2.2)',iostat=ier)  id
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
end subroutine gag_toyyyymmdd
!
subroutine gag_isodate(date,idate,error)
  use gsys_interfaces, except_this=>gag_isodate
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Converts the ISO #8601 date '1996-10-14T10:34:55.345' in internal
  ! code.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: date   ! String date
  integer(kind=4),  intent(out)   :: idate  ! Internal coded date value
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DATE'
  integer(kind=4) :: id,iy,im,ier
  !
  if (date.eq.'*') return
  ! This reads only the date digits, not the time digit (short form of
  ! ISO/IAU#8601 date format
  read(date,'(I4,1X,I2,1X,I2)',iostat=ier) iy,im,id
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Wrong ISO Date format, conversion error')
    error=.true.
    return
  endif
  !
  call gag_datj(id,im,iy,idate)
  return
  !
  call gsys_message(seve%e,rname,'Date conversion error')
  error=.true.
  return
  !
end subroutine gag_isodate
!
subroutine gag_toisodate(idate,date,error)
  use gsys_interfaces, except_this=>gag_toisodate
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Converts the internal code to ISO formatted date
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: idate  ! Internal coded date value
  character(len=*), intent(out)   :: date   ! String date
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DATE'
  integer(kind=4) :: id,iy,im,ier
  !
  error=.false.
  call gag_jdat(idate,id,im,iy)
  write(date,1000,iostat=ier) iy,im,id
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Unable to write ISO Date format')
    error=.true.
    return
  endif
  !
1000 format(i4.4,'-',i2.2,'-',i2.2)
end subroutine gag_toisodate
!
subroutine isodate_to_gagdate(date,error)
  use gsys_interfaces, except_this=>isodate_to_gagdate
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Converts an ISO date representation to a GAG (DD-Monthname-YY) date
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: date   ! String date
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DATE'
  integer(kind=4) :: id,iy,im,ier
  !
  error=.false.
  read(date,'(I4,1X,I2,1X,I2)',iostat=ier) iy,im,id
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Wrong ISO Date format, conversion error')
    error=.true.
    return
  endif
  write(date,1000,iostat=ier) iy,im,id
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Unable to write ISO Date format')
    error=.true.
    return
  endif
  !
1000 format(i4.4,'-',i2.2,'-',i2.2)
end subroutine isodate_to_gagdate
!
subroutine gagdate_to_isodate(date,error)
  use gsys_interfaces, except_this=>gagdate_to_isodate
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Converts an ISO date representation to a GAG (DD-Monthname-YY) date
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: date   ! String date
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DATE'
  character(len=3) :: cm(12),m
  integer(kind=4) :: id,iy,im,ier
  ! Data
  data cm /'JAN','FEB','MAR','APR','MAY','JUN',  &
           'JUL','AUG','SEP','OCT','NOV','DEC'/
  !
  error=.false.
  read(date,'(I2,1X,A,1X,I4)',iostat=ier) id,m,iy
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Wrong Date format, ISO conversion error')
    error=.true.
    return
  endif
  call sic_upper(m)
  do im=1,12
    if (cm(im).eq.m) then
      write(date,1000,iostat=ier) iy,im,id
      if (ier.ne.0) then
        call gsys_message(seve%e,rname,'Unable to write ISO Date format')
        error=.true.
        return
      endif
      return
    endif
  enddo
  call gsys_message(seve%e,rname,'Wrong Date format, ISO conversion error')
  error=.true.
  return
1000 format(i4.4,'-',i2.2,'-',i2.2)
end subroutine gagdate_to_isodate
!
subroutine gag_datj(id,im,iy,jour)
  use gsys_interfaces, except_this=>gag_datj
  !---------------------------------------------------------------------
  ! @ public
  !   Convert a date (id/im/iy) in number of days till the 01/01/1984
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: id    ! Day number
  integer(kind=4), intent(in)  :: im    ! Month number
  integer(kind=4), intent(in)  :: iy    ! Year number
  integer(kind=4), intent(out) :: jour  ! Elapsed day count
  ! Local
  integer(kind=4) :: id1,im1
  integer(kind=4) :: ideb(13),ibiss,jour4
  integer(kind=4), parameter :: izero=2025
  ! Data
  data ideb/0,31,59,90,120,151,181,212,243,273,304,334,365/
  !
  im1 = max(1,im)
  im1 = min(12,im1)
  ibiss=gag_julda(iy+1)-gag_julda(iy)-365
  id1 = max(1,id)
  if (im1.ne.2) id1 = min(id1,(ideb(im1+1)-ideb(im1)))
  if (im1.eq.2) id1 = min(id1,(ideb(im1+1)+ibiss-ideb(im1)))
  jour4=id1+ideb(im1)
  if (im1.ge.3) jour4=jour4+ibiss
  jour4=jour4+gag_julda(iy)
  jour=jour4
  !
end subroutine gag_datj
!
subroutine gag_jdat(jour,id,im,iy)
  use gsys_interfaces, except_this=>gag_jdat
  !---------------------------------------------------------------------
  ! @ public
  ! Reverse conversion
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: jour  ! Elapsed day count
  integer(kind=4), intent(out) :: id    ! Day number
  integer(kind=4), intent(out) :: im    ! Month number
  integer(kind=4), intent(out) :: iy    ! Year number
  ! Local
  integer(kind=4) :: ideb(13),ibiss,j,m
  integer(kind=4), parameter :: izero=2025
  ! Data
  data ideb/0,31,59,90,120,151,181,212,243,273,304,334,365/
  !
  iy=izero+jour/365
1 j=jour-gag_julda(iy)
  if (j.le.0) then
    iy=iy-1
    goto 1
  elseif (j.gt.365) then
    ! Special case for 31 december of leap years...
    if (j.eq.366) then
      ibiss=gag_julda(iy+1)-gag_julda(iy)-365
      if (ibiss.eq.0) then
        iy=iy+1
        goto 1
      endif
    else
      iy=iy+1
      goto 1
    endif
  endif
  ibiss=gag_julda(iy+1)-gag_julda(iy)-365
  do m=12,1,-1
    id=j-ideb(m)
    if (m.ge.3) id=id-ibiss
    if (id.gt.0) exit
  enddo
  im=m
end subroutine gag_jdat
!
function gag_julda(nyr)
  !---------------------------------------------------------------------
  ! @ private
  !  Returns Julian date of 1 day of Year
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_julda  ! Date returned
  integer(kind=4), intent(in) :: nyr  !
  ! Local
  integer(kind=4) :: nyrm1,ic,nadd
  integer(kind=4), parameter :: izero=2025
  !
  nyrm1=nyr-1
  ic=nyrm1/100
  nadd=nyrm1/4-ic+ic/4
  gag_julda=365.*(nyrm1-izero)+nadd
end function gag_julda
!
subroutine gag_isodate2mjd(timestring,mjd,error)
  use gbl_message
  use gsys_interfaces, except_this=>gag_isodate2mjd
  !---------------------------------------------------------------------
  ! @ public
  ! Convert an ISO #8601 date string of the form:
  !   2015-01-09T08:58:19.230000
  ! into a Modified Julian Date value.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: timestring
  real(kind=8),     intent(out)   :: mjd
  logical,          intent(inout) :: error
  ! local
  integer(kind=4) :: intyear,intmonth,intday,inthours,intminutes,ier
  real(kind=8) :: seconds
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='ISODATE2MJD'
  !
  read(timestring( 1: 4),'(i4)',iostat=ier) intyear
  if (ier.ne.0)  goto 10
  read(timestring( 6: 7),'(i2)',iostat=ier) intmonth
  if (ier.ne.0)  goto 10
  read(timestring( 9:10),'(i2)',iostat=ier) intday
  if (ier.ne.0)  goto 10
  call gag_gregorian2mjd(intyear,intmonth,intday,mjd,ier)
  if (ier.ne.0)  goto 10
  read(timestring(12:13),'(i2)',iostat=ier) inthours
  if (ier.ne.0)  goto 10
  read(timestring(15:16),'(i2)',iostat=ier) intminutes
  if (ier.ne.0)  goto 10
  read(timestring(18:23),*,     iostat=ier) seconds
  if (ier.ne.0)  goto 10
  mjd = mjd+(inthours+(intminutes+seconds/60d0)/60d0)/24d0
  return
  !
  ! Read error
10 continue
  write(mess,'(3a)') 'Can not translate string ''',trim(timestring),''''
  call gsys_message(seve%e,rname,mess)
  error = .true.
  return
end subroutine gag_isodate2mjd
!
subroutine gag_gregorian2mjd(iy,im,id,djm,ier)
  use gsys_interfaces, except_this=>gag_gregorian2mjd
  !---------------------------------------------------------------------
  ! @ private
  ! Gregorian Calendar to Modified Julian Date
  ! MJD is not computed when ier.ne.0
  !
  ! The year must be -4699 (i.e. 4700BC) or later.
  !
  ! The algorithm is derived from that of Hatcher 1984
  ! (QJRAS 25, 53-55).
  !
  ! Derived from P.T.Wallace   Starlink   11 March 1998
  ! Copyright (C) 1998 Rutherford Appleton Laboratory
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: iy  ! year in Gregorian calendar
  integer(kind=4), intent(in)  :: im  ! month in Gregorian calendar
  integer(kind=4), intent(in)  :: id  ! day in Gregorian calendar
  real(kind=8),    intent(out) :: djm ! Modified Julian Date (JD-2400000.5) for 0 hrs
  integer(kind=4), intent(out) :: ier ! Status  (0 = OK, 1 = bad year, 2 = bad month, 3 = bad day)
  ! local
  integer :: mtab(12) !  Month lengths in days
  data mtab / 31,28,31,30,31,30,31,31,30,31,30,31 /
  !
  ! Preset status
  ier=0
  ! Validate year
  if (iy.lt.-4699) then
     ier=1
  else
     ! Validate month
     if (im.ge.1.and.im.le.12) then
        ! Allow for leap year
        if (mod(iy,4).eq.0) then
           mtab(2)=29
        else
           mtab(2)=28
        endif
        if (mod(iy,100).eq.0.and.mod(iy,400).ne.0) mtab(2)=28
        ! Validate day
        if (id.lt.1.or.id.gt.mtab(im)) ier=3
        ! Modified Julian Date
        djm=dble((1461*(iy-(12-im)/10+4712))/4   &
             +(306*mod(im+9,12)+5)/10   &
             -(3*((iy-(12-im)/10+4900)/100))/4   &
             +id-2399904)
     else
        ! Bad month
        ier=2
     endif
  endif
end subroutine gag_gregorian2mjd
!
subroutine gag_mjd2isodate(mjd,timestring,error)
  use phys_const
  use gbl_message
  use gsys_interfaces, except_this=>gag_mjd2isodate
  !---------------------------------------------------------------------
  ! @ public
  ! Convert a Modified Julian Date value to an ISO #8601 date string
  ! of the form:
  !   2015-01-09T08:58:19.230000
  !   123456789 123456789 123456
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)    :: mjd
  character(len=*), intent(out)   :: timestring
  logical,          intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='MJD2ISODATE'
  integer(kind=4) :: iye,imo,ida
  real(kind=8) :: se
  character(len=30) :: isodate  ! Larger than 26 for safety
  !
  call gag_mjd2gregorian(mjd,iye,imo,ida,error)
  if (error)  return
  !
  ! Use an intermediate string of appropriate length
  write(isodate,100) iye,imo,ida
  !
  se = (mjd-floor(mjd))*2.d0*pi  ! Remainder in radians
  call rad2sexa(se,24,isodate(12:),left=.true.)
  !
  ! Copy (may be truncate) the intermediate string to the output string
  timestring = isodate
  !
100 format(I4,'-',I2.2,'-',I2.2,'T')
  !
end subroutine gag_mjd2isodate
!
subroutine gag_mjd2gregorian(mjd,iy,im,id,error)
  use phys_const
  use gsys_interfaces, except_this=>gag_mjd2gregorian
  !---------------------------------------------------------------------
  ! @ private
  ! Modified Julian Date to Gregorian Calendar
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: mjd    ! Modified Julian Date (JD-2400000.5) for 0 hrs
  integer(kind=4), intent(out)   :: iy     ! Year in Gregorian calendar
  integer(kind=4), intent(out)   :: im     ! Month in Gregorian calendar
  integer(kind=4), intent(out)   :: id     ! Day in Gregorian calendar
  logical(kind=4), intent(inout) :: error  ! Logical error flag
  ! Local
  real(kind=8) :: jd,jdf
  integer(kind=4) :: jdi,l,n
  !
  jd = mjdzero_in_jd + floor(mjd)  ! Julian day
  jdi = floor(jd,kind=4)           ! Integer Julian day
  jdf = jd-real(jdi,kind=8)+0.5d0  ! Fractional part of day
  !
  ! Next calendar day?
  if (jdf.ge.1.d0) then
    jdf = jdf-1.d0
    jdi = jdi+1
  endif
  !
  l = jdi + 68569
  n = floor(4*l/146097.d0,kind=4)
  !
  l = l-floor((146097*n+3)/4.d0,kind=4)
  iy = floor(4000*(l+1)/1461001.d0,kind=4)
  !
  l = l-floor(1461*iy/4.d0,kind=4)+31
  im = floor(80*l/2447.d0,kind=4)
  !
  id = l-floor(2447*im/80.d0,kind=4)
  !
  l = floor(im/11.d0,kind=4)
  !
  im = im+2-12*l
  iy = 100*(n-49)+iy+l
  !
end subroutine gag_mjd2gregorian
!
subroutine gag_gagut2mjd(date,ut,mjd,error)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  !  Convert a GAG_DATE + UT into a MJD date
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: date   ! [gag]
  real(kind=8),    intent(in)    :: ut     ! [rad] Day starts at 0 radians
  real(kind=8),    intent(out)   :: mjd    !
  logical,         intent(inout) :: error  !
  !
  mjd = gagzero_in_mjd+date+ut/2d0/pi
  !
end subroutine gag_gagut2mjd
!
subroutine gag_mjd2gagut(mjd,date,ut,error)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  !  Convert a MJD date into GAG_DATE + UT
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: mjd
  integer(kind=4), intent(out)   :: date
  real(kind=8),    intent(out)   :: ut
  logical,         intent(inout) :: error
  !
  date = floor(mjd)
  ut = 2d0*pi*(mjd-real(date,kind=8))
  date = date-gagzero_in_mjd
  !
end subroutine gag_mjd2gagut
!
subroutine sic_date(datetime)
  use gsys_interfaces, except_this=>sic_date
  !---------------------------------------------------------------------
  ! @ public
  !  Return the current date-time in Gildas format
  !     DD-MMM-YYYY hh:mm:ss.ss
  !     123456789 123456789 123
  ! Use 23 character strings for full date-time, or shorter strings
  ! for truncated values.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: datetime
  ! Local
  character(len=23) :: good_chain
  !
  call sic_c_datetime(good_chain)
  datetime = good_chain
  call sic_upper(datetime)
end subroutine sic_date
!
subroutine sic_isodate(datetime)
  use gsys_interfaces, except_this=>sic_isodate
  !---------------------------------------------------------------------
  ! @ public
  !  Return the current date-time in ISO #8601:
  !     1996-10-14T10:34:55.345
  !     123456789 123456789 123
  ! Use 23 character strings for full date-time, or shorter strings
  ! for truncated values.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: datetime
  ! Local
  character(len=23) :: good_chain
  !
  call sic_c_isodatetime(good_chain)
  datetime = good_chain
end subroutine sic_isodate
!
subroutine sic_gagdate(gagdate)
  use gsys_interfaces, except_this=>sic_gagdate
  !---------------------------------------------------------------------
  ! @ public
  !  Return the current UTC date in GAG_DATE format
  !---------------------------------------------------------------------
  integer(kind=4), intent(out) :: gagdate
  ! Local
  integer(kind=4) :: values(6)
  real(kind=4) :: frac
  !
  call sic_c_idatetime(values,frac)
  !
  call gag_datj(values(3),values(2),values(1),gagdate)
  !
end subroutine sic_gagdate

module orbit_interfaces_none
  interface
    subroutine orbit_pack_set(pack)
      use gpack_def
      !
      type(gpack_info_t), intent(out) :: pack
    end subroutine orbit_pack_set
  end interface
  !
  interface
    subroutine orbit_pack_init(gpack_id,error)
      !----------------------------------------------------------------------
      ! 
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine orbit_pack_init
  end interface
  !
  interface
    subroutine orbit_pack_clean(error)
      !----------------------------------------------------------------------
      ! Called at end of session. Might clean here for example global buffers
      ! allocated during the session
      !----------------------------------------------------------------------
      logical :: error
    end subroutine orbit_pack_clean
  end interface
  !
end module orbit_interfaces_none

module ram_sizes
  integer(kind=8), parameter :: bytes_per_real = 4
  integer(kind=8), parameter :: kB = 1024
  integer(kind=8), parameter :: MB = 1024**2
  integer(kind=8), parameter :: GB = 1024**3
end module ram_sizes
!
module imbfits_parameters
  !
  real(kind=4), parameter :: bad=-1000.e0
  real(kind=8), parameter :: bad8=-1000.d0
  !
  integer(kind=4), parameter :: code_imbfits_init = 0
  integer(kind=4), parameter :: code_imbfits_started = 1
  integer(kind=4), parameter :: code_imbfits_done = 2
  real(kind=4), parameter :: imbfits_version_min=1.1999  ! Min supported (included)
  real(kind=4), parameter :: imbfits_version_max=3.      ! Max supported (excluded)
  !
  integer(kind=4), parameter :: mhdukinds=8
  integer(kind=4), parameter :: hdu_scan=1           ! HDU Scan identifier
  integer(kind=4), parameter :: hdu_frontend=2       ! HDU Frontend identifier
  integer(kind=4), parameter :: hdu_backend=3        ! HDU Backend identifier
  integer(kind=4), parameter :: hdu_backdata=4       ! HDU BackEndXXX identifier
  integer(kind=4), parameter :: hdu_antslow=5        ! HDU AntennaSlow identifier
  integer(kind=4), parameter :: hdu_antfast=6        ! HDU AntennaFast identifier
  integer(kind=4), parameter :: hdu_subreflector=7   ! HDU Subreflector identifier
  integer(kind=4), parameter :: hdu_derot=8          ! HDU Derotator identifier
  !
  ! Known telescopes
  integer(kind=4), parameter :: telescope_length=12
  integer(kind=4), parameter :: ntelescopes=1
  ! Ad vitam aeternam codes:
  integer(kind=4), parameter :: telescope_unknown=0
  integer(kind=4), parameter :: telescope_iram30m=1
  ! Order must match telescope codes:
  character(len=telescope_length), parameter :: telescopes(0:ntelescopes) =  &
    (/ 'unknown     ','IRAM 30m    ' /)
  !
  ! Known backends
  integer(kind=4), parameter :: backname_length=9
  integer(kind=4), parameter :: nbackends_imbfits=10
  integer(kind=4), parameter :: nbackends_mrtcal=9
  ! Ad vitam aeternam codes:
  integer(kind=4), parameter :: backend_unknown  =0
  integer(kind=4), parameter :: backend_nbc      =1
  integer(kind=4), parameter :: backend_bbc      =2
  integer(kind=4), parameter :: backend_4mhz     =3
  integer(kind=4), parameter :: backend_vespa    =4
  integer(kind=4), parameter :: backend_wilma    =5
  integer(kind=4), parameter :: backend_fts      =6
  integer(kind=4), parameter :: backend_nika1mm  =7
  integer(kind=4), parameter :: backend_nika2mm  =8
  integer(kind=4), parameter :: backend_holo     =9
  ! Used by IMBFITS, do not use for MRTCAL (this code can be modified)
  integer(kind=4), parameter :: backend_continuum=10
  ! Order must match backend codes:
  ! 1) As found in IMBFITS files
  character(len=backname_length), parameter :: backends_imbfits(nbackends_imbfits) =  &
    (/             'NBC      ','BBC      ','4MHZ     ','VESPA    ',  &
       'WILMA    ','FTS      ','NIKA1MM  ','NIKA2MM  ','HOLO     ',  &
       'CONTINUUM'/)
  ! 2) As displayed by MRTCAL
  character(len=backname_length), parameter :: backends_mrtcal(0:nbackends_mrtcal) =  &
    (/ 'UNKNOWN  ','NBC      ','BBC      ','4MHZ     ','VESPA    ',  &
       'WILMA    ','FTS      ','NIKA1MM  ','NIKA2MM  ','HOLO     ' /)
  !
end module imbfits_parameters

module gwcs_projnam
  use gbl_constant
  !---------------------------------------------------------------------
  ! DO NOT USE out of this file! The following array can not be made
  ! public because of problems of data sharing under various
  ! platforms.
  !---------------------------------------------------------------------
  !
  character(len=13), parameter :: projections(0:mproj) = (/  &
      'NONE         ',  &
      'GNOMONIC     ',  &
      'ORTHOGRAPHIC ',  &
      'AZIMUTHAL    ',  &
      'STEREOGRAPHIC',  &
      'LAMBERT      ',  &
      'AITOFF       ',  &
      'RADIO        ',  &
      'SFL          ',  &
      'MOLLWEIDE    ',  &
      'NCP          ',  &
      'CARTESIAN    '   /)
  !
end module gwcs_projnam
!
function projnam(iproj)
  use gwcs_projnam
  use gbl_message
  use gwcs_interfaces, except_this=>projnam
  !---------------------------------------------------------------------
  ! @ public
  ! Return the projection name as a character string
  ! ---
  !  The purpose of this function is to avoid declaring a static
  ! character string array containing the projection names: there are
  ! difficulties to share such kind of data between libraries under
  ! several systems (MSWIN, MINGW, ...)
  !---------------------------------------------------------------------
  character(len=13) :: projnam  ! Function value on return
  integer(kind=4), intent(in) :: iproj  ! The projection number
  ! Local
  character(len=*), parameter :: rname='PROJNAM'
  character(len=message_length) :: mess
  !
  if (iproj.lt.0 .or. iproj.gt.mproj) then
    write(mess,*) 'Unrecognized projection number ',iproj
    call gwcs_message(seve%e,rname,mess)
    projnam = 'UNKNOWN'
  else
    projnam = projections(iproj)
  endif
  !
end function projnam
!
subroutine projnam_list(list)
  use gbl_constant
  use gwcs_projnam
  use gwcs_interfaces, except_this=>projnam_list
  !---------------------------------------------------------------------
  ! @ public
  ! Return the list of projections in a string array
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: list(0:mproj)  !
  !
  list(0:mproj) = projections(0:mproj)
  !
end subroutine projnam_list

*DECK DP1VLU
      SUBROUTINE DP1VLU (L, NDER, X, YFIT, YP, A)
C***BEGIN PROLOGUE  DP1VLU
C***PURPOSE  Use the coefficients generated by DPOLFT to evaluate the
C            polynomial fit of degree L, along with the first NDER of
C            its derivatives, at a specified point.
C***LIBRARY   SLATEC
C***CATEGORY  K6
C***TYPE      DOUBLE PRECISION (PVALUE-S, DP1VLU-D)
C***KEYWORDS  CURVE FITTING, LEAST SQUARES, POLYNOMIAL APPROXIMATION
C***AUTHOR  Shampine, L. F., (SNLA)
C           Davenport, S. M., (SNLA)
C***DESCRIPTION
C
C     Abstract
C
C     The subroutine  DP1VLU  uses the coefficients generated by  DPOLFT
C     to evaluate the polynomial fit of degree  L , along with the first
C     NDER  of its derivatives, at a specified point.  Computationally
C     stable recurrence relations are used to perform this task.
C
C     The parameters for  DP1VLU  are
C
C     Input -- ALL TYPE REAL variables are DOUBLE PRECISION
C         L -      the degree of polynomial to be evaluated.  L  may be
C                  any non-negative integer which is less than or equal
C                  to  NDEG , the highest degree polynomial provided
C                  by  DPOLFT .
C         NDER -   the number of derivatives to be evaluated.  NDER
C                  may be 0 or any positive value.  If NDER is less
C                  than 0, it will be treated as 0.
C         X -      the argument at which the polynomial and its
C                  derivatives are to be evaluated.
C         A -      work and output array containing values from last
C                  call to  DPOLFT .
C
C     Output -- ALL TYPE REAL variables are DOUBLE PRECISION
C         YFIT -   value of the fitting polynomial of degree  L  at  X
C         YP -     array containing the first through  NDER  derivatives
C                  of the polynomial of degree  L .  YP  must be
C                  dimensioned at least  NDER  in the calling program.
C
C***REFERENCES  L. F. Shampine, S. M. Davenport and R. E. Huddleston,
C                 Curve fitting by polynomials in one variable, Report
C                 SLA-74-0270, Sandia Laboratories, June 1974.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   740601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891006  Cosmetic changes to prologue.  (WRB)
C   891006  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DP1VLU
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER I,IC,ILO,IN,INP1,IUP,K1,K1I,K2,K3,K3P1,K3PN,K4,K4P1,K4PN,
     * KC,L,LM1,LP1,MAXORD,N,NDER,NDO,NDP1,NORD
      DOUBLE PRECISION A(*),CC,DIF,VAL,X,YFIT,YP(*)
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  DP1VLU
      IF (L .LT. 0) GO TO 12
      NDO = MAX(NDER,0)
      NDO = MIN(NDO,L)
      MAXORD = A(1) + 0.5D0
      K1 = MAXORD + 1
      K2 = K1 + MAXORD
      K3 = K2 + MAXORD + 2
      NORD = A(K3) + 0.5D0
      IF (L .GT. NORD) GO TO 11
      K4 = K3 + L + 1
      IF (NDER .LT. 1) GO TO 2
      DO 1 I = 1,NDER
 1      YP(I) = 0.0D0
 2    IF (L .GE. 2) GO TO 4
      IF (L .EQ. 1) GO TO 3
C
C L IS 0
C
      VAL = A(K2+1)
      GO TO 10
C
C L IS 1
C
 3    CC = A(K2+2)
      VAL = A(K2+1) + (X-A(2))*CC
      IF (NDER .GE. 1) YP(1) = CC
      GO TO 10
C
C L IS GREATER THAN 1
C
 4    NDP1 = NDO + 1
      K3P1 = K3 + 1
      K4P1 = K4 + 1
      LP1 = L + 1
      LM1 = L - 1
      ILO = K3 + 3
      IUP = K4 + NDP1
      DO 5 I = ILO,IUP
 5      A(I) = 0.0D0
      DIF = X - A(LP1)
      KC = K2 + LP1
      A(K4P1) = A(KC)
      A(K3P1) = A(KC-1) + DIF*A(K4P1)
      A(K3+2) = A(K4P1)
C
C EVALUATE RECURRENCE RELATIONS FOR FUNCTION VALUE AND DERIVATIVES
C
      DO 9 I = 1,LM1
        IN = L - I
        INP1 = IN + 1
        K1I = K1 + INP1
        IC = K2 + IN
        DIF = X - A(INP1)
        VAL = A(IC) + DIF*A(K3P1) - A(K1I)*A(K4P1)
        IF (NDO .LE. 0) GO TO 8
        DO 6 N = 1,NDO
          K3PN = K3P1 + N
          K4PN = K4P1 + N
 6        YP(N) = DIF*A(K3PN) + N*A(K3PN-1) - A(K1I)*A(K4PN)
C
C SAVE VALUES NEEDED FOR NEXT EVALUATION OF RECURRENCE RELATIONS
C
        DO 7 N = 1,NDO
          K3PN = K3P1 + N
          K4PN = K4P1 + N
          A(K4PN) = A(K3PN)
 7        A(K3PN) = YP(N)
 8      A(K4P1) = A(K3P1)
 9      A(K3P1) = VAL
C
C NORMAL RETURN OR ABORT DUE TO ERROR
C
 10   YFIT = VAL
      RETURN
C
   11 WRITE (XERN1, '(I8)') L
      WRITE (XERN2, '(I8)') NORD
      CALL XERMSG ('SLATEC', 'DP1VLU',
     *   'THE ORDER OF POLYNOMIAL EVALUATION, L = ' // XERN1 //
     *   ' REQUESTED EXCEEDS THE HIGHEST ORDER FIT, NORD = ' // XERN2 //
     *   ', COMPUTED BY DPOLFT -- EXECUTION TERMINATED.', 8, 2)
      RETURN
C
   12 CALL XERMSG ('SLATEC', 'DP1VLU',
     +   'INVALID INPUT PARAMETER.  ORDER OF POLYNOMIAL EVALUATION ' //
     +   'REQUESTED IS NEGATIVE.', 2, 2)
      RETURN
      END

module clean_arrays
  use image_def
  use uvmap_types
  use clean_types
  use cct_types
  !
  ! Static variables first, allocatable next.
  !
  type (uvmap_par), save :: themap
  type (clean_par), target :: method, user_method
  type (gildas), save, target :: hbeam, hdirty, hclean, hresid
  type (gildas), save, target :: hprim, huvi, huv, huvt, hfields
  type (gildas), save, target :: hcct, hmask, hsky
  type (gildas), save :: huvm
  !
  ! Support variable for the SIC variable 'W':
  type (gildas), save :: w_plot
  type (gildas), save :: b_plot
  !
  ! These are UV data
  real, pointer :: duv(:,:)
  logical, save :: uv_plotted
  ! For the Multi-Primary beams Mosaic deconvolution
  ! C_ stands for "Compact Array"
  type (clean_par), target :: c_method, cuse_method
  type (gildas), save :: c_hbeam, c_hdirty, c_hresid, c_hclean
  type (gildas), save :: c_hprim
  !
  real, allocatable, save :: g_weight(:)  ! UV weights
  real, allocatable, save :: g_v(:)       ! V values
  logical, save :: do_weig                ! Optimization of weight computing
  !
  ! Imaging and deconvolution arrays
  real, allocatable, target, save :: dbeam(:,:,:,:) ! 4-D
  real, allocatable, target, save :: ddirty(:,:,:)  ! Dirty 3-D 
  real, allocatable, target, save :: dclean(:,:,:)  ! Clean 3-D
  real, allocatable, target, save :: dresid(:,:,:)  ! Residual 3-D
  real, allocatable, target, save :: dprim(:,:,:,:) ! Primary beam 4-D
  real, allocatable, target, save :: weight(:,:,:)  ! Mosaic weights 3-D
  real, allocatable, target, save :: dsky(:,:,:)      ! Primary beam corrected 3-D
  real, allocatable, target, save :: dfields(:,:,:,:) ! Mosaic fields 4-D
  !
  ! Deconvolution arrays
  real, allocatable, target, save :: dmask(:,:,:)   ! Input 3-D 0, #0 mask
  integer, allocatable, target, save :: d_list(:)   ! List of selected pixels
  logical, allocatable, target, save :: d_mask(:,:) ! Logical mask for pixel selection
  real, allocatable, target, save :: dcct(:,:,:)    ! Clean component values
  type (cct_par), allocatable, save :: tcc(:)       ! Clean component list
  !
  ! These are UV data
  real, allocatable, target, save :: duvi(:,:)  ! Original UV data
  real, pointer :: duvr(:,:)                    ! Resampled UV data
  real, pointer :: duvs(:,:)                    ! Sorted UV data
  real, allocatable, target, save :: duvt(:,:)  ! Time-Baseline sorted UV data, for UV_FLAG
  real, allocatable, target, save :: duvm(:,:)  ! Model UV data
  !
  ! For the Multi-Primary beams Mosaic deconvolution
  ! C_ stands for "Compact Array"
  real, allocatable, target, save :: c_dbeam(:,:,:)
  real, allocatable, target, save :: c_ddirty(:,:,:)
  real, allocatable, target, save :: c_dclean(:,:,:)
  real, allocatable, target, save :: c_dresid(:,:,:)
  real, allocatable, target, save :: c_dprim(:,:,:)
  logical, allocatable, target, save :: c_mask(:,:)
  integer, allocatable, target, save :: c_list(:)
  real, allocatable, target, save :: c_weight(:,:,:)  ! 3-D
  !
  integer :: niter_listsize=0
  integer, allocatable :: niter_list(:)
  integer :: ares_listsize=0
  real, allocatable :: ares_list(:)
  ! List of selected fields in UV_MAP (used for UV_RESTORE and
  ! also for SHOW FIELDS)
  integer :: selected_fieldsize=0
  integer, allocatable :: selected_fields(:)
end module clean_arrays
!
module buffer_types
  use gkernel_types
  integer(kind=4), parameter :: mtype=13
  integer(kind=4), parameter :: mtype_read=11  ! Command READ can not read FIELDS nor COVERAGE
  character(len=12) :: vtype(1:mtype) = (/ &
  &  'UV          ',  &
  &  'BEAM        ',  &
  &  'DIRTY       ',  &
  &  'CLEAN       ',  &
  &  'PRIMARY     ',  &
  &  'RESIDUAL    ',  &
  &  'MASK        ',  &
  &  'SUPPORT     ',  &
  &  'CCT         ',  &
  &  'MODEL       ',  &
  &  'SKY         ',  &
  &  'FIELDS      ',  &
  &  'COVERAGE    ' /)   ! Support keyword for SHOW COVERAGE (no associated buffer)
  !
  character(len=12) :: etype(1:mtype) = (/ &
  & '.uvt        ',  &
  & '.beam       ',  &
  & '.lmv        ',  &
  & '.lmv-clean  ',  &
  & '.lobe       ',  &
  & '.lmv-res    ',  &
  & '.msk        ',  &
  & '.pol        ',  &
  & '.cct        ',  &
  & '.uvt        ',  &
  & '.lmv-sky    ',  &
  & '.fields     ',  &
  & '.uvt        ' /)   ! Irrelevant for COVERAGE
  !
  character(len=12) ctype
  !
  integer, parameter :: code_save_uv=1
  integer, parameter :: code_save_beam=2
  integer, parameter :: code_save_dirty=3
  integer, parameter :: code_save_clean=4
  integer, parameter :: code_save_primary=5
  integer, parameter :: code_save_resid=6
  integer, parameter :: code_save_mask=7
  integer, parameter :: code_save_support=8
  integer, parameter :: code_save_cct=9
  integer, parameter :: code_save_model=10
  integer, parameter :: code_save_sky=11
  integer, parameter :: code_save_fields=12
  logical :: save_data(mtype)
  !
  ! Read / Write optimization
  type readop_t
    type(mfile_t) :: modif
    integer :: lastnc(2) = 0
    integer :: change = 0
  end type
  !
  type (readop_t), save :: optimize(mtype)
  !
  integer :: rw_optimize
end module buffer_types

program mask_3d
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Task
  !   Apply a 3-D real mask to an input data cube
  !   Ouput = Input where Mask is non zero
  !
  !   The Mask does not need to share the same sampling as the
  !   data cube.
  !---------------------------------------------------------------------
  character(len=filename_length) :: cmask
  character(len=filename_length) :: cinp
  character(len=filename_length) :: cout 
  logical :: error
  !
  call gildas_open
  call gildas_char('MASK$',cmask)
  call gildas_char('INPUT$',cinp)
  call gildas_char('OUTPUT$',cout)
  call gildas_close
  !
  call sub_mask3d(cmask,cinp,cout,error)
  if (error) call sysexi(fatale)
  call gagout('S-MASK_3D, successful completion')
  contains
!
subroutine sub_mask3d(cmask,cinp,cout,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  ! @ private
  character(len=*), intent(inout) :: cmask
  character(len=*), intent(inout) :: cinp
  character(len=*), intent(inout) :: cout
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname = 'MASK_3D'
  ! Local
  type(gildas) :: gmask, ginp, gout
  real, allocatable :: rmask(:,:), data(:,:,:)
  integer :: nblock, iloop, j, ier, iplane, imask
  !
  ! Code
  call gildas_null (ginp) 
  call gdf_read_gildas (ginp, cinp, '.gdf', error, data=.false.)
  !
  ! Make it a 3-D data set even if only one plane
  call gildas_null (gmask) 
  call gdf_read_gildas (gmask, cmask, '.msk', error, rank=3, data=.true.)
  !
  call gildas_null (gout) 
  call gdf_copy_header(ginp,gout,error)
  if (error) return
  !
  if (gmask%gil%dim(3).gt.1) then
    if (ginp%gil%faxi.ne.3 .or. gmask%gil%faxi.ne.3) then
      call gag_message(seve%e,rname,'Mask and Cube must have FREQUENCY / VELOCITY axis as 3rd one')
      error = .true.
      return
    endif
    if (ginp%char%code(3).ne.gmask%char%code(3)) then
      call gag_message(seve%e,rname,'3rd axis must be of same type')
      error = .true.
      return
    endif
  endif
  !
  call sic_parsef(cout,gout%file,' ','.gdf')
  call gdf_create_image(gout,error)
  if (error) return
  !
  call gdf_nitems('SPACE_GILDAS',nblock,ginp%gil%dim(1)*ginp%gil%dim(2)) 
  nblock = min(nblock,ginp%gil%dim(3))
  allocate(rmask(ginp%gil%dim(1),ginp%gil%dim(2)), &
    & data(ginp%gil%dim(1),ginp%gil%dim(2),nblock),stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Initialize
  imask = 0
  ! Loop over blocks
  do iloop = 1,ginp%gil%dim(3),nblock
    ginp%blc(3) = iloop
    ginp%trc(3) = min(iloop+nblock-1,ginp%gil%dim(3))
    gout%blc(3) = iloop
    gout%trc(3) = ginp%trc(3)
    call gdf_read_data (ginp,data,error)
    if (error) return
    !
    ! Mask it
    do j=1,ginp%trc(3)-ginp%blc(3)+1
      iplane = j+ginp%blc(3)-1
      call get_realmask(imask,iplane,gmask,ginp,rmask)
      data(:,:,j) = rmask*data(:,:,j)
    enddo
    call gdf_write_data (gout, data, error)
    if (error) return
  enddo
  call gdf_close_image(gout,error)
  call gdf_close_image(ginp,error)
  call gdf_close_image(gmask,error)
end subroutine sub_mask3d
!
subroutine get_realmask(imask,iplane,hmask,hmap,rmask)
  use image_def
  !----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Define beam plane and check if fit is required
  !----------------------------------------------------------------
  integer, intent(inout) :: imask
  integer, intent(inout) :: iplane
  type (gildas), intent(in) :: hmask
  type (gildas), intent(in) :: hmap   ! Used to figure out which plane
  real, intent(inout) :: rmask(:,:)
  !
  integer :: i, j, nx, ny, ier
  real(8) :: i_freq, r
  integer, allocatable :: im(:), jm(:)
  !
  if (hmask%gil%dim(3).le.1) then
    iplane = 1
 else
    i_freq = (iplane-hmap%gil%ref(3))*hmap%gil%inc(3) + hmap%gil%val(3)
    iplane = nint((i_freq-hmask%gil%val(3))/hmask%gil%inc(3) + hmask%gil%ref(3))
    iplane = min(max(1,iplane),hmask%gil%dim(3)) ! Just  in case
  endif
  !
  if (imask.ne.iplane) then
    !
    ! Should also work in OMP mode...
    nx = hmap%gil%dim(1)
    ny = hmap%gil%dim(2)
    !
    allocate(im(nx),jm(ny),stat=ier)
    !
    do i=1,nx
      r = (i-hmap%gil%ref(1))*hmap%gil%inc(1) + hmap%gil%val(1)
      im(i) = (r-hmask%gil%val(1))/hmask%gil%inc(1) + hmask%gil%ref(1)
      im(i) = max(1,im(i))
      im(i) = min(hmask%gil%dim(1),im(i))
    enddo
    !
    do i=1,ny
      r = (i-hmap%gil%ref(2))*hmap%gil%inc(2) + hmap%gil%val(2)
      jm(i) = (r-hmask%gil%val(2))/hmask%gil%inc(2) + hmask%gil%ref(2)
      jm(i) = max(1,jm(i))
      jm(i) = min(hmask%gil%dim(2),jm(i))
    enddo
    !
    do j=1,ny
      do i=1,nx
        if (hmask%r3d(im(i),jm(j),iplane).ne.0) then
          rmask(i,j) = 1.0
        else
          rmask(i,j) = 0.0
        endif
      enddo
    enddo
    deallocate(im,jm)
    imask = iplane
  endif
end subroutine get_realmask
!
end program

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_chunkset_check(set,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_check
  !---------------------------------------------------------------------
  ! @ private
  ! Check the integrity of a set of chunks
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: set
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>CHECK'
  integer(kind=4) :: ichunk,id
  character(len=12) :: line
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  id = set%chunks(1)%id
  line = set%chunks(1)%spe%line
  do ichunk=2,set%n
     if (set%chunks(ichunk)%id.ne.id) then
        call mrtcal_message(seve%e,rname,'Inconsistant identifiers in set of chunks')
        error = .true.
        return
     endif
     if (set%chunks(ichunk)%spe%line.ne.line) then
        call mrtcal_message(seve%e,rname,'Inconsistant line names in set of chunks')
        error = .true.
        return
     endif
  enddo
  !
end subroutine mrtcal_chunkset_check
!
subroutine mrtcal_chunkset_show(chunkset)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_show
  !---------------------------------------------------------------------
  ! @ private
  ! Display a set of chunks. For debugging purpose.
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in) :: chunkset
  ! Local
  integer(kind=4) :: ichunk
  character(len=*), parameter :: rname='CHUNKSET>SHOW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do ichunk=1,chunkset%n
     write(*,'(A,I0)') 'Chunk #',ichunk
     call mrtcal_chunk_show(chunkset%chunks(ichunk))
  enddo
  !
end subroutine mrtcal_chunkset_show
!
subroutine mrtcal_chunkset_accumulate_setweight(diff,tscale,dowei,error)
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_accumulate_setweight
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! ZZZ
  ! Quick and dirty subroutine to enforce chunks dataw to something
  ! non-zero (needed by simple_waverage). Currently set to 1.0 i.e.
  ! equal weights. Should probably come early and cleverly e.g.
  ! weight equal, tsys, time, maybe in mrtcal_on_minus_off.
  !---------------------------------------------------------------------
  type(chunkset_t), intent(inout) :: diff
  type(chunkset_t), intent(in)    :: tscale
  logical,          intent(in)    :: dowei   ! Compute real weights or dummy?
  logical,          intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ichunk,ichan
  real(kind=4) :: fact
  !
  if (dowei) then
    !
    do ichunk=1,diff%n
      fact = diff%chunks(ichunk)%gen%time * abs(diff%chunks(ichunk)%spe%fres)
      do ichan=1,diff%chunks(ichunk)%ndata
        diff%chunks(ichunk)%dataw(ichan) =  &
          fact / tscale%chunks(ichunk)%data1(ichan)**2
      enddo
    enddo ! ichunk
    !
  else
    !
    do ichunk=1,diff%n
      diff%chunks(ichunk)%dataw(:) = 1.0
    enddo ! ichunk
    !
  endif
  !
end subroutine mrtcal_chunkset_accumulate_setweight
!
subroutine mrtcal_chunkset_accumulate_do(inchunkset,ouchunkset,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_accumulate_do
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Accumulate the input chunkset into the running output chunkset
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: inchunkset
  type(chunkset_t), intent(inout) :: ouchunkset
  logical,          intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ichunk
  logical, parameter :: contaminate=.true.  ! Input bad channels contaminate the output sum
  real(kind=8) :: iinteg,ointeg,sinteg
  !
  do ichunk=1,inchunkset%n
    call simple_waverage(                   &
      inchunkset%chunks(ichunk)%data1,      &
      inchunkset%chunks(ichunk)%dataw,bad,  &
      ouchunkset%chunks(ichunk)%data1,      &
      ouchunkset%chunks(ichunk)%dataw,bad,  &
      1,inchunkset%chunks(ichunk)%ndata,    &
      contaminate,.true.)
    ! The following lines assume that the whole spectrum is
    ! not bad
    iinteg = inchunkset%chunks(ichunk)%gen%time
    ointeg = ouchunkset%chunks(ichunk)%gen%time
    sinteg = iinteg+ointeg  ! Total integration time
    ! Compute mean MJD = DOBS + UT
    ouchunkset%chunks(ichunk)%mjd =  &
            (ouchunkset%chunks(ichunk)%mjd*ointeg +  &
            inchunkset%chunks(ichunk)%mjd*iinteg)/sinteg
    call mrtindex_mjd2gagut(ouchunkset%chunks(ichunk)%scandate,  &
                            ouchunkset%chunks(ichunk)%mjd,       &
                            ouchunkset%chunks(ichunk)%gen%dobs,  &
                            ouchunkset%chunks(ichunk)%gen%ut,    &
                            error)
    ! Compute mean AZ EL, rederive parallactic angle
    ouchunkset%chunks(ichunk)%gen%az =  &
           (ouchunkset%chunks(ichunk)%gen%az*ointeg +  &
            inchunkset%chunks(ichunk)%gen%az*iinteg)/sinteg
    ouchunkset%chunks(ichunk)%gen%el =  &
           (ouchunkset%chunks(ichunk)%gen%el*ointeg +  &
            inchunkset%chunks(ichunk)%gen%el*iinteg)/sinteg
    call mrtcal_chunk_parang_from_gen(ouchunkset%chunks(ichunk)%gen,error)
    ! Same for continuum drift offsets
    ouchunkset%chunks(ichunk)%offset(1:2) =  &
           (ouchunkset%chunks(ichunk)%offset(1:2)*ointeg +  &
            inchunkset%chunks(ichunk)%offset(1:2)*iinteg)/sinteg
    ! Set total integration time
    ouchunkset%chunks(ichunk)%gen%time = sinteg
    ! *** JP Normally OTF PSW never explore this subroutine.
    ! *** JP But if it would, the OFF time would be wrongly added...
    ouchunkset%chunks(ichunk)%swi%duree   =  &
      ouchunkset%chunks(ichunk)%swi%duree +  &
      inchunkset%chunks(ichunk)%swi%duree
  enddo ! ichunk
  !
end subroutine mrtcal_chunkset_accumulate_do
!
subroutine mrtcal_chunkset_copy(in,ofirst,ou,error)
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_copy
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Copy the chunkset to the output structure (from ofirst chunk),
  ! taking care of reallocating chunkds if needed. Copy is done with
  ! allocations, not associations.
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: in
  integer(kind=4),  intent(in)    :: ofirst
  type(chunkset_t), intent(inout) :: ou
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: ichunk,ochunk
  !
  ochunk = ofirst-1
  do ichunk=1,in%n
    ochunk = ofirst-1+ichunk
    call ou%chunks(ochunk)%reallocate(in%chunks(ichunk)%ndata,error)
    if (error) return
    call ou%chunks(ochunk)%copy_header(in%chunks(ichunk),error)
    if (error) return
    call ou%chunks(ochunk)%copy_data(in%chunks(ichunk),error)
    if (error) return
  enddo
  ou%n = ochunk
end subroutine mrtcal_chunkset_copy
!
subroutine mrtcal_chunkset_append_do(in,ou,error)
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_append_do
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Append the input chunkset into the running output chunkset
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: in
  type(chunkset_t), intent(inout) :: ou
  logical,          intent(inout) :: error
  ! Local
  type(chunkset_t) :: tmp
  integer(kind=4) :: newsize
  !
  if (size(ou%chunks).lt.ou%n+in%n) then
    ! ZZZ reallocate_chunkset should have a "keep" mode
    newsize = max(ou%n+in%n,2*ou%n)
    ! Allocate a temporary copy
    call tmp%reallocate(ou%n,error)
    if (error)  return
    ! Duplicate the output chunkset
    call mrtcal_chunkset_copy(ou,1,tmp,error)
    if (error)  return
    ! Enlarge the original
    call ou%reallocate(newsize,error)
    if (error)  return
    ! Copy back from tmp to original
    call mrtcal_chunkset_copy(tmp,1,ou,error)
    if (error)  return
    ! Free the temporary
    call tmp%free(error)
    if (error)  return
  endif
  !
  ! Insert the new ones!
  call mrtcal_chunkset_copy(in,ou%n+1,ou,error)
  if (error)  return
end subroutine mrtcal_chunkset_append_do

program help
  !------------------------------------------------------------------------
  ! This program produces a Runoff or Tex file from a standard
  ! "GILDAS" help file (similar to VMS help input text file extracted
  ! from a library).
  !------------------------------------------------------------------------
  ! Local variables:
  character in*80, out*100, w1*40, w2*40, accept*1, name*40, new*40
  integer n, l1, l2, level, lw, lenc
  integer iunit, ounit, iback
  logical verb, latex, option
  !------------------------------------------------------------------------
  ! Code:
  option = .false.
  verb = .false.
  name = 'LATEX'
  if (name.eq.'LATEX') then
    latex =.true.
    accept = char(92)          ! This is the Backslash
  else
    latex = .false.
    accept = '_'
  endif
  iunit = 5
  ounit = 6
  level = 0
  l1 = 1
  !
  10    read (iunit,'(a)',end=100) in
  if (.not.verb .and. in.eq.' ') goto 10
  !
  ! n is the Level of information (1 to 3, but 3 is actually
  ! never used)
  n = ichar(in(1:1)) - ichar('0')
  if (n.ge.1 .and. n.le.3) then
    !
    ! End of file
    if (in.eq.'1 ENDOFHELP') goto 100
    !
    ! Help entry line
    call clean(in(2:), out, accept)
    lw = 40
    call sic_blanc(out, lw)
    iback = index(out,'$#$')
    if (iback.ne.0) then
      new = out(1:iback)//char(92)//'backslash'//out(iback+2:)
      out = new
      lw = lenc(out)
    endif
    if (n.eq.1) then
      if (out(1:lw).eq.'LANGUAGE') then
        level = 3
      elseif (latex) then
        level = 1
        w1 = out(1:lw)
        l1 = lw
        if (verb) write(ounit,1000) '\end{verbatim}'
        write(ounit,1000) '\subsection{'//w1(1:l1)//'}'
        write(ounit,1000) '\index{'//w1(1:l1)//'}'
        write(ounit,1000) '\begin{verbatim}'
        verb = .true.
      else
        level = 1
        w1 = out(1:lw)
        l1 = lw
        if (verb) write(ounit,1000) '.END LITERAL'
        write(ounit,1000) '.HL 2 '//w1(1:l1)
        write(ounit,1000) '.INDEX '//w1(1:l1)
        write(ounit,1000) '.LITERAL'
        verb = .true.
      endif
      option = .true.
    elseif (n.eq.2) then
      if (level.eq.3) then
        continue
      elseif (latex) then
        level = 2
        w2 = out(1:lw)
        l2 = lw
        if (verb) write(ounit,1000) '\end{verbatim}'
        if (option) then
          write(ounit,1000) '\subsubsection{'//w1(1:l1)//   &
       &          ' '//w2(1:l2)//'}'
        else
          write(ounit,1000) '\subsubsection{'//w2(1:l2)//'}'
        endif
        write(ounit,1000) '\index{'//w1(1:l1)//   &
     &          '!'//w2(1:l2)//'}'
        write(ounit,1000) '\begin{verbatim}'
        verb = .true.
        if (out(lw:lw).eq.':') option = .false.
      else
        level = 2
        w2 = out(1:lw)
        l2 = lw
        if (verb) write(ounit,1000) '.END LITERAL'
        write(ounit,1000) '.HL 3 '//w2(1:l2)
        write(ounit,1000) '.index '//w1(1:l1)//'>'//w2(1:l2)
        write(ounit,1000) '.LITERAL'
        verb = .true.
      endif
    endif
  elseif (level.ne.3) then
    write(ounit,1000) in(1:lenc(in))
  endif
  goto 10
  !
  ! End of File
  100   continue
  if (verb) then
    if (latex) then
      write(ounit,1000) '\end{verbatim}'
    else
      write(ounit,1000) '.end literal'
    endif
  endif
  stop
  1000  format(a)
end program help
!<FF>
subroutine clean(in,out,accept)
  !------------------------------------------------------------------------
  !------------------------------------------------------------------------
  ! Dummy variables:
  character*(*) in, out, accept
  ! Local variables:
  integer i, k
  !------------------------------------------------------------------------
  ! Code:
  k = 0
  do i=1, len(in)
    if (in(i:i).eq.' ') then
      if (k.ne.0) return
    else
      if (in(i:i).eq.'$'.or.in(i:i).eq.'_'.or.in(i:i).eq.'%') then
        k = k+1
        out(k:) = accept
      endif
      k = k + 1
      if (in(i:i).eq.char(92)) then
        out(k:) = '$#$'
        k = k+2
      else
        out(k:) = in(i:i)
      endif
    endif
  enddo
end
!<FF>
function lenc(c)
  !----------------------------------------------------------------------
  ! SIC	External routine : Integer function
  !
  !	Returns the location of the last SIGNIFICANT character in a
  !       string. Control characters and spaces are non significant...
  ! Arguments :
  !	C	C*(*)	Character string			Input
  !----------------------------------------------------------------------
  character*(*) c
  integer lenc
  integer i,lc
  !
  lc = len(c)
  do i=lc,1,-1
    if (c(i:i).gt.' ') then
      lenc = i
      return
    endif
  enddo
  lenc = 0
end
!<FF>
subroutine sic_blanc(c,n)
  !----------------------------------------------------------------------
  ! SIC	External routine
  !
  ! 	Reduce the character string C to the standard SIC internal syntax.
  !	Suppress all unecessary separators.
  !	Character strings "abcd... " are not modified.
  !	Convert to upper case all characters.
  !	Ignores and destroys comments.
  ! Arguments :
  !	C	C*(*)	Character string to be formatted	Input/Output
  !	N	I	Length of C				Input/Output
  !----------------------------------------------------------------------
  character*(*) c
  integer n
  ! character*1024 tempo
  !
  integer i,nl,nc
  logical lo,li,chaine,some
  integer tab
  parameter (tab=9)
  !
  if (n.eq.0) return
  !
  li = .false.
  lo = .true.
  chaine = .false.
  some = .false.
  nl = n
  nc = len(c)
  n = 0
  i = 1
  !
  do while (i.le.nl)
    !
    ! Skip character strings
    if (c(i:i).eq.'"') then
      ! IF (I.LT.NC) THEN      ! Protect against empty strings
      !    IF (C(I+1:I+1).EQ.'"') THEN
      !       TEMPO = ' '//C(I+1:)
      !       C(I+1:) = TEMPO
      !       NL = MIN(NL+1,NC)
      !    ENDIF
      ! ENDIF
      chaine=.not.chaine
    endif
    if (chaine) goto 30
    !
    ! Suppress redondant separators
    li=.false.
    if (c(i:i).ne.' ' .and. c(i:i).ne.char(tab)) goto 20
    ! Space separator
    li=.true.
    ! Not the first one
    if (lo)  goto 100
    ! First one
    c(i:i)=' '
    goto 30
    !
    ! Skip comment area
    20       continue
    if (c(i:i).eq.'!') then
      some=.true.
      goto 200
    endif
    !
    ! Reset input character string
    30       n=n+1
    if (i.ne.n) c(n:n)=c(i:i)
    if (i.gt.n) c(i:i)=' '
    100      lo=li
    !
    ! End of loop
    i = i+1
  enddo
  !
  ! Remove trailing separators if any
  200   continue
  if (n.ne.0) then
    if (c(n:n).eq.' ') n=n-1
  endif
  ! Clean up end of line
  if( n.lt.nl) c(n+1:) = ' '
  if (some) n=max(n,1)
end

function fchisq(x,n,nfree,xfit,good)
  !---------------------------------------------------------------------
  !	calcul de la dispersion quadratique moyenne
  !---------------------------------------------------------------------
  real*8 :: fchisq                  !
  real*8 :: x(1)                    !
  integer :: n                      !
  integer :: nfree                  !
  real*8 :: xfit(1)                 !
  logical :: good(1)                !
  ! Local
  real*8 :: res
  integer :: j,kp
  !
  fchisq=0.
  kp = 0
  do j=1,n
    if (good(j)) then
      res = x(j)-xfit(j)
      fchisq=fchisq+res**2
      kp = kp+1
    endif
  enddo
  fchisq = fchisq/(kp-nfree)
end

subroutine mrtcal_index_comm(line,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_index_comm
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !   INDEX BUILD|UPDATE|OPEN|APPEND|WATCH|OUTPUT [DirName]
  ! 1       [/FILE IndexFile]
  ! 2       [/RECURSIVE]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line  ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX'
  !
  if (sic_present(1,0) .and. sic_present(2,0)) then
    call mrtcal_message(seve%e,rname,'Exclusive options /FILE and /RECURSIVE')
    error = .true.
    return
  endif
  !
  ! All these commands modify the input index: reset the current index
  mfound = 0
  !
  call mrtindex_index_comm(line,ix,cx,error)
  if (error)  return
  !
end subroutine mrtcal_index_comm

function s_gaussian1d(x,xcent,fwhm)
  !---------------------------------------------------------------------
  ! @ public
  ! Compute gaussian value at X, peaks at 1 (single precision)
  !---------------------------------------------------------------------
  real(kind=4) :: s_gaussian1d
  real(kind=4), intent(in) :: x
  real(kind=4), intent(in) :: xcent
  real(kind=4), intent(in) :: fwhm
  ! Local
  real(kind=4) :: sigma
  !
  sigma = fwhm/(2.0*sqrt(2.0*log(2.0)))
  !
  s_gaussian1d = exp(-(x-xcent)**2/(2.0*sigma*sigma))
  !
end function s_gaussian1d
!
function d_gaussian1d(x,xcent,fwhm)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  ! Compute gaussian value at X, peaks at 1 (double precision)
  !---------------------------------------------------------------------
  real(kind=8) :: d_gaussian1d
  real(kind=8), intent(in) :: x
  real(kind=8), intent(in) :: xcent
  real(kind=8), intent(in) :: fwhm
  ! Local
  real(kind=8) :: sigma
  !
  sigma = fwhm/(2.d0*sqrt(2.d0*log(2.d0)))
  !
  d_gaussian1d = exp(-(x-xcent)**2/(2.d0*sigma*sigma))
  !
end function d_gaussian1d
!
function s_normal1d(x,xcent,sigma)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  ! Compute normal distribution value at X, area is 1 (single precision)
  !---------------------------------------------------------------------
  real(kind=4) :: s_normal1d
  real(kind=4), intent(in) :: x
  real(kind=4), intent(in) :: xcent
  real(kind=4), intent(in) :: sigma
  !
  s_normal1d = exp(-(x-xcent)**2/(2.d0*sigma*sigma)) / (sigma*sqrt(2*pi))
  !
end function s_normal1d
!
function d_normal1d(x,xcent,sigma)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  ! Compute normal distribution value at X, area is 1 (double precision)
  !---------------------------------------------------------------------
  real(kind=8) :: d_normal1d
  real(kind=8), intent(in) :: x
  real(kind=8), intent(in) :: xcent
  real(kind=8), intent(in) :: sigma
  !
  d_normal1d = exp(-(x-xcent)**2/(2.d0*sigma*sigma)) / (sigma*sqrt(2*pi))
  !
end function d_normal1d
!
subroutine gauss2d_convolution(a1,b1,t1,a2,b2,t2,a3,b3,t3,error)
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the parameters of the 2D gaussian resulting from the
  ! convolution of 2 2D gaussians:
  !   1 * 2 => 3
  ! Knowing 1 and 2 find 3.
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: a1    ! [same] First gaussian major axis
  real(kind=4), intent(in)    :: b1    ! [same] First gaussian minor axis
  real(kind=4), intent(in)    :: t1    ! [rad]  First gaussian position angle
  real(kind=4), intent(in)    :: a2    ! [same] Second gaussian major axis
  real(kind=4), intent(in)    :: b2    ! [same] Second gaussian minor axis
  real(kind=4), intent(in)    :: t2    ! [rad]  Second gaussian position angle
  real(kind=4), intent(out)   :: a3    ! [same] Result major axis
  real(kind=4), intent(out)   :: b3    ! [same] Result minor axis
  real(kind=4), intent(out)   :: t3    ! [rad]  Result position angle
  logical,      intent(inout) :: error ! Logical error flag
  ! Local
  real(kind=4) :: c1,s1,c2,s2
  real(kind=4) :: alpha,beta,gamma,s,t,u
  !
  c1 = cos(t1)
  s1 = sin(t1)
  c2 = cos(t2)
  s2 = sin(t2)
  !
  alpha = (a1*c1)**2 + (b1*s1)**2 + (a2*c2)**2 + (b2*s2)**2
  beta  = (a1*s1)**2 + (b1*c1)**2 + (a2*s2)**2 + (b2*c2)**2
  gamma = 2.0*( (a1**2-b1**2)*s1*c1 +  (a2**2-b2**2)*s2*c2 )
  !
  s = alpha+beta
  u = alpha-beta
  t = sqrt(u**2+gamma**2)
  !
  ! New values updated in place
  a3 = sqrt(0.5*(s+t))
  b3 = sqrt(0.5*(s-t))
  t3 = 0.5 * atan2(gamma,u)  ! No issue here, except the very extreme case where
                             ! we convolve a Dirac by a Dirac
  !
end subroutine gauss2d_convolution
!
subroutine gauss2d_deconvolution(a1,b1,t1,a3,b3,t3,a2,b2,t2,error)
  use gmath_interfaces, except_this=>gauss2d_deconvolution
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the parameters of the 2D gaussian resulting from the
  ! deconvolution of 2 2D gaussians:
  !   1 * 2 => 3
  ! Knowing 1 and 3 find 2.
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: a1    ! [same] First gaussian major axis
  real(kind=4), intent(in)    :: b1    ! [same] First gaussian minor axis
  real(kind=4), intent(in)    :: t1    ! [rad]  First gaussian position angle
  real(kind=4), intent(in)    :: a3    ! [same] Result major axis
  real(kind=4), intent(in)    :: b3    ! [same] Result minor axis
  real(kind=4), intent(in)    :: t3    ! [rad]  Result position angle
  real(kind=4), intent(out)   :: a2    ! [same] Second gaussian major axis
  real(kind=4), intent(out)   :: b2    ! [same] Second gaussian minor axis
  real(kind=4), intent(out)   :: t2    ! [rad]  Second gaussian position angle
  logical,      intent(inout) :: error ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GAUSS2D'
  real(kind=4) :: c1,s1,c3,s3
  real(kind=4) :: alpha,beta,gamma,s,t,u
  !
  c1 = cos(t1)
  s1 = sin(t1)
  c3 = cos(t3)
  s3 = sin(t3)
  !
  alpha = (a3*c3)**2 + (b3*s3)**2 - (a1*c1)**2 - (b1*s1)**2
  beta  = (a3*s3)**2 + (b3*c3)**2 - (a1*s1)**2 - (b1*c1)**2
  gamma = 2.0*( (a3**2-b3**2)*s3*c3 - (a1**2-b1**2)*s1*c1 )
  !
  s = alpha+beta
  u = alpha-beta
  t = sqrt(u**2+gamma**2)
  !
  ! Sanity check
  if (t.gt.s) then
    call gmath_message(seve%e,rname,'Final resolution is not reachable from input resolution')
    error = .true.
    return
  endif
  !
  ! New values updated in place
  a2 = sqrt(0.5*(s+t))
  b2 = sqrt(0.5*(s-t))
  t2 = 0.5 * atan2(gamma,u)
  !
end subroutine gauss2d_deconvolution

program uv_merge
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! TASK  Merge two UV tables;
  !
  ! with calibration factor and weight factor and resampling of
  ! the first one, the second one being used as the reference
  !
  ! Input :
  !   two UV tables
  ! Output :
  !   one new UV table
  !---------------------------------------------------------------------
  ! Local
  integer, parameter :: mw=9  ! Maximum number of files to be merged
  character(len=filename_length) :: table_in(mw), table_ref, table_out
  real :: weight(mw), factor(mw)
  integer :: mode
  real    :: alpha
  logical :: error
  !------------------------------------------------------------------------
  ! Code:
  call gildas_open
  call gildas_char( 'TABLE_IN$', table_in(1))
  call gildas_real( 'WEIGHT$', weight, 1)
  call gildas_real( 'FACTOR$', factor, 1)
  call gildas_char( 'TABLE_REF$', table_ref)
  call gildas_char( 'TABLE_OUT$', table_out)
  call gildas_inte( 'MODE$',mode,1)
  call gildas_real( 'ALPHA$', alpha, 1)
  call gildas_close
  !
  call sub_uv_merge_block(1, table_in, table_ref, table_out, &
    weight, factor, mode, alpha, error)
  if (error) call sysexi(fatale)
!
contains
!
subroutine uvmergel (nv,ncx,x,ncz,z,weight,factor,iwork,rwork &
  & ,xref,xval,xinc,zref,zval,zinc)
  use gildas_def
  use gbl_message
  integer(kind=size_length), intent(in) :: nv   ! Number of visibilities
  integer, intent(in) :: ncx                    ! Number of channels
  real, intent(inout) :: x(:,:)                 ! Merged UV table
  integer, intent(in) :: ncz                    ! Number of channels
  real, intent(in) :: z(:,:)                    ! Input UV table
  real, intent(in) :: weight                    ! Weight scale factor
  real, intent(in) :: factor                    ! Intensity scale factor
  integer, intent(inout) :: iwork(2,*)          ! Work array
  real, intent(inout) :: rwork(4,*)             ! Work array
  real(8), intent(in) :: xref,xval,xinc         ! Input velocity sampling
  real(8), intent(in) :: zref,zval,zinc         ! Output velocity sampling
  !
  real(kind=8),parameter      :: ctol = 0.1     ! Spectral tolerance over all spectrum
  character(len=*), parameter :: rname='UV_MERGE'
  !
  ! Local
  integer :: i, j, k, iv
  real :: poids
  logical :: resample
  !
  ! iwork = imin,imax
  ! rwork = rmin_1, rmin, rmax, rmax_1
  !
  integer imax,imin, ix,iy, jxmin, jymin, jxmax, jymax
  integer :: mcx, mcz, lcx, lcz, mtrail
  real(8) minpix, maxpix, pix, val, expand
  real rmin_1, rmin, rmax_1, rmax, smin, smax
  real scale
  !------------------------------------------------------------------------
  ! Code:
  !
  resample = shouldresample(ncx,xref,xval,xinc,ncz,zref,zval,zinc,ctol)
  !
  if (.not.resample) then
     call map_message(seve%i,rname,'Spectral Sampling of the UV tables is consistent')
     call map_message(seve%i,rname,'Merged table is a simple concatenation')
     do iv=1,nv   
        x(:,iv) = z(:,iv)
     end do
  else
     call map_message(seve%w,rname,'Spectral Sampling of the UV tables is not consistent')
     call map_message(seve%w,rname,'Resampling UV table 1 on the spectral axis of UV table 2')
     !
     ! Interpolate first (Z) Table on X grid
     !
     mcx = ubound(x,1)
     mcz = ubound(z,1)
     lcx = 3*ncx+7
     lcz = 3*ncz+7
     mtrail = mcx-lcx
     ! Setup interpolation scheme
     !
     expand = abs(xinc/zinc)
     scale  = factor/expand
     !
     ! Initialize workspace
     iwork(:,1:ncx) = 0
     rwork(:,1:ncx) = 0.0
     do i = 1, ncx
        !
        ! Compute interval
        val = xval + (i-xref)*xinc
        pix = (val-zval)/zinc + zref
        maxpix = pix + 0.5d0*expand
        minpix = pix - 0.5d0*expand
        imin = int(minpix+1.0d0)
        imax = int(maxpix)
        iwork(1,i) = imin
        iwork(2,i) = imax
        if (imax.eq.imin .and. expand.eq.1.0) then
           ! Shifted grid or not actually
           rwork(1,i) = (imin-pix)
           rwork(2,i) = 1.0-rwork(1,i)
        else if (imax.ge.imin) then
           ! Lower end
           if (imin.gt.1) then
              !
              ! ZMIN = Z(IMIN-1)*(IMIN-MINPIX)+Z(IMIN)*(MINPIX-IMIN+1)
              !     and
              ! X(I) = X(I) + 0.5 * ( (IMIN-MINPIX)*(ZMIN+Z(IMIN)) )
              !
              !     RMIN_1 = 0.5 * (IMIN-MINPIX)*(IMIN-MINPIX)     ! Coefficient de IMIN-1
              !     RMIN   = 0.5 * (MINPIX-IMIN+2)*(IMIN-MINPIX)   ! Coefficient de IMIN
              !
              smin = imin-minpix
              rwork(1,i) = 0.5*smin*smin
              rwork(2,i) = smin-rwork(1,i)
           else
              !     RMIN   = (IMIN-MINPIX)                          ! Coefficient de IMIN
              !     RMIN_1 = 0                                      ! Coefficient de IMIN-1
              rwork(1,i) = 0.0
              rwork(2,i) = imin-minpix
           endif
           ! Upper end
           if (imax.lt.ncz) then
              smax = maxpix-imax
              rwork(4,i) = 0.5*smax*smax
              rwork(3,i) = smax-rwork(4,i)
           else
              rwork(3,i) = maxpix-imax
              rwork(4,i) = 0.0
           endif
           if (imax.eq.imin) then
              ! 3 Point Case
              rwork(2,i) = rwork(2,i)+rwork(3,i)
              rwork(3,i) = 0.0
           else
              ! General Case: Add 1/2 of IMIN & IMAX + 1 of all intermediate channels
              rwork(2,i) = rwork(2,i)+0.5
              rwork(3,i) = rwork(3,i)+0.5
           endif
        else
           if (imin.gt.1) then
              rwork(1,i) = (imin-pix)
              rwork(2,i) = 1.0-rwork(1,i)
           else
              rwork(1,i) = 0.0
              rwork(2,i) = 1.0
           endif
        endif
     enddo
     !
     ! OK, now do it for all visibilities
     do iv=1,nv
        !
        ! Coordinates
        do j=1, 7
           x(j,iv) = z(j,iv)
        enddo
        !
        ! Channels
        do i=1,ncx
           imin = iwork(1,i)
           imax = iwork(2,i)
           jxmin = 5+3*imin
           jymin = jxmin+1
           jxmax = 5+3*imax
           jymax = jxmax+1
           rmin_1 = rwork(1,i)
           rmin   = rwork(2,i)
           rmax   = rwork(3,i)
           rmax_1 = rwork(4,i)
           ix = 5+3*i
           iy = ix+1
           !
           if (imax.ge.imin) then
              ! General Trapezium integration
              if (imin.gt.1) then
                 x(ix,iv) = z(jxmin-3,iv)*rmin_1+z(jxmin,iv)*rmin
                 x(iy,iv) = z(jymin-3,iv)*rmin_1+z(jymin,iv)*rmin
              else
                 x(ix,iv) = z(jxmin,iv)*rmin
                 x(iy,iv) = z(jymin,iv)*rmin
              endif
              if (imax.gt.imin) then
                 do k = 5+3*(imin+1),5+3*(imax-1),3
                    x(ix,iv) = x(ix,iv) + z(k,iv)
                    x(iy,iv) = x(iy,iv) + z(k+1,iv)
                 enddo
              endif
              x(ix,iv) = x(ix,iv) + z(jxmax,iv)*rmax
              x(iy,iv) = x(iy,iv) + z(jymax,iv)*rmax
              if (imax.lt.ncz) then
                 x(ix,iv) = x(ix,iv) + z(jxmax+3,iv)*rmax_1
                 x(iy,iv) = x(iy,iv) + z(jymax+3,iv)*rmax_1
              endif
              x(ix,iv) = x(ix,iv)*scale
              x(iy,iv) = x(iy,iv)*scale
           else
              !
              ! Interpolation
              if (imin.gt.1) then
                 x(ix,iv) = z(jxmin-3,iv)*rmin_1+z(jxmin,iv)*rmin
                 x(iy,iv) = z(jymin-3,iv)*rmin_1+z(jymin,iv)*rmin
              else
                 x(ix,iv) = z(jxmin,iv)
                 x(iy,iv) = z(jymin,iv)
              endif
              x(ix,iv) = x(ix,iv)*factor
              x(iy,iv) = x(iy,iv)*factor
           endif
        enddo
        !
        ! Weight
        ! Same weight for all channels...
        !
        poids = z(10+3*(ncz/2),iv)*weight
        if (poids.eq.0) then  ! May happen with Widex spectra
           poids = z(10+3*(ncz/3),iv)*weight
        endif
        do j=10, 3*ncx+7, 3
           x(j,iv) = poids
        enddo
        !
        ! Trailing columns if any
        do j=1,mtrail
           x(lcx+j,iv) = z(lcz+j,iv)
        enddo
     enddo
  endif
end subroutine uvmergel
!
function shouldresample(xnc,xref,xval,xinc,znc,zref,zval,zinc,ctol)
  integer(kind=4),intent(in) :: xnc
  real(kind=8),   intent(in) :: xref
  real(kind=8),   intent(in) :: xval
  real(kind=8),   intent(in) :: xinc
  integer(kind=4),intent(in) :: znc
  real(kind=8),   intent(in) :: zref
  real(kind=8),   intent(in) :: zval
  real(kind=8),   intent(in) :: zinc
  real(kind=8),   intent(in) :: ctol
  logical :: shouldresample
  !
  real(kind=8) :: xleft,xright,zleft,zright,vtol
  !
  vtol = abs(zinc*ctol)
  !
  if (xnc.ne.znc) then
     shouldresample = .true.
     return
  else if (xinc*zinc.lt.0.d0) then
     shouldresample = .true.
     return
  else
    xleft  = (0.5-xref)*xinc+xval    
    xright = (xnc+0.5-xref)*xinc+xval 
    zleft  = (0.5-zref)*zinc+zval    
    zright = (znc+0.5-zref)*zinc+zval
    !
    if (abs(xleft-zleft).gt.vtol) then
       shouldresample = .true.
       return
    else if (abs(xright-zright).gt.vtol) then
       shouldresample = .true.
       return
    else
       shouldresample = .false.
       return
    endif
  endif
  !
end function shouldresample
!
subroutine uvmergec (nv,ndx,x,ndz,z,weight,factor,scaleuv,alpha)
  use gildas_def
  !
  ! Merge two Continuum Data Set
  !
  integer(kind=size_length), intent(in) :: nv                     ! Number of visibilities
  integer(kind=size_length), intent(in) :: ndx                    !
  real, intent(inout) :: x(ndx,nv)              ! Merged UV table
  integer(kind=size_length), intent(in) :: ndz                    !
  real, intent(in) :: z(ndz,nv)                 ! Input UV table
  real, intent(in) :: weight                    ! Weight scale factor
  real, intent(in) :: factor                    ! Intensity scale factor
  real, intent(in) :: scaleuv                   ! Baseline length scale
  real, intent(in) :: alpha                     ! Spectral index
  ! Local
  integer :: j, iv, n
  real(kind=4) :: scale_flux, scale_w           ! flux and weigh scales in case of a spectral index
  !------------------------------------------------------------------------
  ! Code:
  scale_flux = scaleuv**(-alpha)
  scale_w = scaleuv**(2*alpha)
  n = min(ndx,ndz)
  !
  ! OK, now do it for all visibilities
  do iv=1,nv
    !
    ! Coordinates
    x(1,iv) = scaleuv*z(1,iv)
    x(2,iv) = scaleuv*z(2,iv)
    do j=3, 7
      x(j,iv) = z(j,iv)
    enddo
    !
    ! Visibilities
    x(8,iv) = z(8,iv)*factor*scale_flux
    x(9,iv) = z(9,iv)*factor*scale_flux
    ! Weight
    x(10,iv) = z(10,iv)*weight*scale_w
    ! Other (if any)
    do j=11,n
      x(j,iv) = z(j,iv)
    enddo
  enddo
end subroutine uvmergec
!
subroutine uvmergef (nv,ndx,x,ndz,z,weight,factor,w1,w2)
  use gildas_def
  !
  ! Merge two Continuum Data Set: Average visibilities
  !
  integer(kind=size_length), intent(in) :: nv   ! Number of visibilities
  integer(kind=size_length), intent(in) :: ndx  !
  real, intent(inout) :: x(ndx,nv)              ! Merged UV table
  integer(kind=size_length), intent(in) :: ndz  !
  real, intent(in) :: z(ndz,nv)                 ! Input UV table
  real, intent(in) :: weight                    ! Weight scale factor
  real, intent(in) :: factor                    ! Intensity scale factor
  real(8), intent(out) :: w1,w2                 ! Relative weights
  ! Local
  integer :: iv, n, j
  real :: ww
  !------------------------------------------------------------------------
  ! Code:
  n = min(ndx,ndz)
  w1 = 0.d0
  w2 = 0.d0
  ! OK, now do it for all visibilities
  do iv=1,nv
    !
    ! U and V Coordinates
    if (x(1,iv).ne.z(1,iv)) then
      print *,'U iv ',iv,x(1,iv),z(1,iv), x(10,iv), z(10,iv)
      print *,'Out ',z(1:10,iv)
      goto 99
    endif
    if (x(2,iv).ne.z(2,iv)) then
      print *,'V iv ',iv,x(2,iv),z(2,iv), x(10,iv), z(10,iv)
      goto 99
    endif
    !
    ! Visibilities
    ww = x(10,iv)
    if (x(10,iv).gt.0) w1 = w1+x(10,iv)
    !
    if (z(10,iv).gt.0) then
      w2 = w2+z(10,iv)
      if (x(10,iv).gt.0) then
        ww = x(10,iv)+weight*z(10,iv)
        x(8,iv) = (x(8,iv)*x(10,iv) + z(8,iv)*z(10,iv)*weight*factor ) / ww
        x(9,iv) = (x(9,iv)*x(10,iv) + z(9,iv)*z(10,iv)*weight*factor ) / ww
      else
        ww = weight*z(10,iv)
        x(8,iv) = z(8,iv)*factor
        x(9,iv) = z(9,iv)*factor
      endif
    endif
    ! Weight
    x(10,iv) = ww
    ! Trailing columns if any
    do j=11,n
      x(j,iv) = z(j,iv)
    enddo
  enddo
  return
99  call gagout('E-UV_MERGE,  Continuum tables do not match')
end subroutine uvmergef

!
subroutine sub_uv_merge_block(n_in, table_in, table_ref, table_out, &
     weight, factor, mode, alpha, error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! TASK  Merge two UV tables;
  !
  ! with calibration factor and weight factor and resampling of
  ! the first one, the second one being used as the reference
  !
  ! Input :
  ! two UV tables
  ! Output :
  ! one new UV table
  !---------------------------------------------------------------------
  integer, intent(in) :: n_in ! Number of input tables
  character(len=*), intent(in) :: table_in(*), table_ref, table_out
  real, intent(in)  :: weight(*)
  real, intent(in)  :: factor(*)
  integer, intent(in)  :: mode
  real, intent(in)     :: alpha
  logical, intent(out) :: error
  ! Local
  character(len=*), parameter :: rname='UV_MERGE'
  type(gildas) :: in,inref,out
  integer, allocatable :: iwork(:,:)
  real(4), allocatable :: rwork(:,:)
  real :: scale_uv
  real(8) :: w1,w2
  integer :: nblock, i, ier, im
  character(len=80) :: mess
  integer :: code
  integer(kind=size_length) :: in_gil_dim1,in_gil_dim2, nvisi
  integer, parameter :: code_cont=1
  integer, parameter :: code_merge=0
  integer, parameter :: code_stack=2
  !------------------------------------------------------------------------
  ! Code:
  !
  if (n_in.eq.0) goto 999
  if (len_trim(table_ref).eq.0) goto 999
  if (len_trim(table_out).eq.0) goto 999
  !
  ! Input file TABLE_REF  (INREF) is the reference one
  call gildas_null(inref, type = 'UVT')
  call gdf_read_gildas (inref, table_ref, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table #2 (Reference)')
    return
  endif
  !
  ! Prepare output table: compute number of visibilities
  call gildas_null(out, type = 'UVT')
  call gdf_copy_header (inref, out, error)
  call sic_parse_file(table_out,' ','.uvt',out%file)
  !
  ! Loop over tables to be merged
  call gildas_null(in, type = 'UVT')
  in_gil_dim1 = 0
  in_gil_dim2 = 0
  !
  do im=1,n_in
    call gdf_read_gildas (in, table_in(im), '.uvt', error, data=.false.)
    if (error) then
      write(mess,*) 'Cannot read input UV table #',im
      call map_message(seve%e,rname,mess)
      return
    endif
    !
    if (mode.eq.code_cont) then
      if (in%gil%dim(2).ne.inref%gil%dim(2) .or. &
        in%gil%nchan.ne.1 .or. inref%gil%nchan.ne.1) then
        call map_message(seve%e,rname,'Mode = 1 only valid for matching continuum UV tables ')
        error = .true.
        return
      endif
    else
      out%gil%dim(2) = in%gil%nvisi + out%gil%nvisi
      out%gil%nvisi = out%gil%dim(2)  ! Set the number of visibilities
    endif
    in_gil_dim1 = max(in_gil_dim1,in%gil%dim(1))
    in_gil_dim2 = max(in_gil_dim2,in%gil%dim(2))
    !
    ! Verify if trailing columns do match
    call gdf_uvmatch_codes(inref,in,code)
    if (code.eq.3) then
      ! Column # 3 has a mismatch - Make sure the Ref is now SCAN
      inref%gil%column_pointer(code_uvt_w) = 0
      inref%gil%column_size(code_uvt_w) = 0
      inref%gil%column_pointer(code_uvt_scan) = 3
      inref%gil%column_size(code_uvt_scan) = 1
     else if (code.lt.0) then
      error = .true. 
      call map_message(seve%e,rname,'Leading or Trailing columns do not match')
      return
    endif
    !
    call gdf_close_image(in,error)
  enddo
  !
  ! Finished preparatory work, and create the OUT table
  call map_message(seve%i,rname,'Creating UV table '//trim(out%file))
  call gdf_create_image(out, error)
  if (error) then
    call map_message(seve%e,rname,'Cannot create output UV table')
    return
  endif
  !
  ! Define blocking factor,
  call gdf_nitems('SPACE_GILDAS',nblock,inref%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,inref%gil%nvisi)
  allocate (out%r2d(out%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',inref%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! First pass is to read INREF directly in OUT
  !
  ! Loop over line table
  inref%blc = 0
  inref%trc = 0
  out%blc = 0
  out%trc = 0
  do i=1,inref%gil%nvisi,nblock
    write(mess,*) i,' / ',inref%gil%nvisi,nblock
    call map_message(seve%d,rname,mess)
    inref%blc(2) = i
    inref%trc(2) = min(inref%gil%nvisi,i-1+nblock)
    out%blc(2) = inref%blc(2)
    out%trc(2) = inref%trc(2)
    call gdf_read_data(inref,out%r2d,error)
    if (error) return
    call gdf_write_data(out,out%r2d,error)
    if (error) return
  enddo
  deallocate(out%r2d)
  call gdf_close_image(inref,error)
  !
  ! Define blocking factor
  call gdf_nitems('SPACE_GILDAS',nblock,in_gil_dim1) ! Visibilities at once
  nblock = min(nblock,in_gil_dim2)
  allocate (out%r2d(out%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error OUT ',out%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
    call map_message(seve%i,rname,'Merging two continuum tables')
  else
    allocate (iwork(2,out%gil%nchan), rwork(4,out%gil%nchan), stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error WORK ',6,out%gil%nchan
      call map_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    if (in%gil%freq.ne.out%gil%freq) then
       call map_message(seve%w,rname,'Merging two line tables with different rest frequencies')
    else   
       call map_message(seve%i,rname,'Merging line tables')
    endif
  endif
  !
  ! Append INs to OUT with resampling and rescaling
  do im = 1,n_in
    call gdf_read_gildas (in, table_in(im), '.uvt', error, data=.false.)
    if (error) then
      write(mess,*) 'Cannot read input UV table #',im
      call map_message(seve%e,rname,mess)
      return
    endif
    !
    allocate (in%r2d(in%gil%dim(1),nblock), stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error IN ',in%gil%dim(1), nblock
      call map_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
      scale_uv = in%gil%freq / inref%gil%freq
      if (mode.eq.code_cont) then
        out%blc(2) = 1
      else
        out%blc(2) = out%trc(2)+1
      endif
    else
      if (mode.eq.code_stack) then
        !   In Stacking Mode, Lambda/D is conserved, so the UV length
        ! must be scaled by FreqIn/ FreqRef
        scale_uv = in%gil%freq / inref%gil%freq
      else
        scale_uv = 1.0
      endif
      out%blc(2) = out%trc(2)+1
    endif
    !
    in%blc = 0
    in%trc = 0
    !
    ! Block loop on current input file
    do i=1,in%gil%nvisi,nblock
      write(mess,*) i,' / ',in%gil%nvisi,nblock
      call map_message(seve%d,rname,mess)
      in%blc(2) = i
      in%trc(2) = min(in%gil%nvisi,i-1+nblock)
      nvisi = in%trc(2)-in%blc(2)+1
      out%trc(2) = out%blc(2)+nvisi-1
      call gdf_read_data(in,in%r2d,error)
      !
      if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
        if (mode.eq.0) then
          print *,'    with uvmergeC ',im,' weight ',weight(im)
          call uvmergec (nvisi, out%gil%dim(1), out%r2d,  &
       &       in%gil%dim(1),in%r2d,weight(im),factor(im),      &
       &       scale_uv,alpha)
        else
          call gdf_read_data(out,out%r2d,error)
          print *,'    with uvmergeF ',im,' weight ',weight(im)
          call uvmergef (nvisi, out%gil%dim(1), out%r2d,  &
       &       in%gil%dim(1),in%r2d,weight(im),factor(im),      &
       &       w1,w2)
          out%gil%freq = (w1*in%gil%freq + w2*inref%gil%freq) / (w1+w2)
        endif
      else
        call uvmergel (nvisi, out%gil%nchan, out%r2d,    &
       &       in%gil%nchan,in%r2d,weight(im),factor(im),      &
       &       iwork, rwork, &
       &       out%gil%ref(1), dble(out%gil%voff), dble(out%gil%vres), &
       &       in%gil%ref(1), dble(in%gil%voff), dble(in%gil%vres) )
      endif
      call gdf_write_data(out,out%r2d,error)
      if (error) return
      out%blc(2) = out%trc(2)+1
    enddo
    !
    call gdf_close_image(in,error)
    deallocate (in%r2d,stat=ier)
  enddo
  !
  call gdf_close_image(out,error)
  deallocate(out%r2d)
  call map_message(seve%i,rname,'Successful completion')
  return
  !
  999   error = .true.
end subroutine sub_uv_merge_block
!
subroutine gdf_uvmatch_codes(a,b,code)
  use image_def
  ! use gio_interfaces, only : gdf_uvcolumn_codes
  !---------------------------------------------------------------------
  ! @ public
  !
  ! GIO     Compare layout of UV tables for description columns
  ! Code = 0    Same layout
  ! Code = -1   Different layout
  ! Code = 3    Similar layout, except that Col.3 is SCAN in one,
  !             and W in the other.
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: a       ! Input Header
  type(gildas), intent(in) :: b       ! Input Header
  integer, intent(out)     :: code    ! Returned code
  !
  integer :: k, nlt, ier
  integer, allocatable :: a_codes(:,:), b_codes(:,:)
  !
  ! If # number of trailing : no match
  code = -1
  if (a%gil%ntrail.ne.b%gil%ntrail) return
  ! If # number of leading : no match
  if (a%gil%nlead.ne.b%gil%nlead) return
  !
  ! Else, compare columns, but make a specific provision
  ! for SCAN and W (both of which may happen in Col 3)
  !
  nlt = a%gil%nlead + a%gil%ntrail
  allocate(a_codes(2,nlt),b_codes(2,nlt),stat=ier)
  call gdf_uvcolumn_codes(a,a_codes)
  call gdf_uvcolumn_codes(b,b_codes)  
  !
  code = 0
  do k = 1,nlt
    if (a_codes(1,k).ne.b_codes(1,k)) then
      if (code.eq.0 .and. k.eq.3) then
        code = 3
        if (a_codes(1,k).eq.code_uvt_scan .and. b_codes(1,k).eq.code_uvt_w) cycle 
        if (b_codes(1,k).eq.code_uvt_scan .and. a_codes(1,k).eq.code_uvt_w) cycle
      endif
      code = -1
    else if (a_codes(2,k).ne.b_codes(2,k)) then
      print *,'Code length mismatch at Col. ',k
    endif
  enddo
end subroutine gdf_uvmatch_codes
!
subroutine gdf_uvcolumn_codes(h,column_codes)
  use image_def
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! GIO     Return the column codes and sizes of the Leading and Trailing
  !         columns
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: h                ! Input header
  integer, intent(inout) :: column_codes(:,:)   ! Column codes
  !
  integer :: nlt, i, j, itrail
  !
  nlt = h%gil%nlead + h%gil%ntrail
  !
  do j = 1,nlt
    do i = 1, code_uvt_last
      if (h%gil%column_pointer(i).lt.h%gil%fcol) then
        if (h%gil%column_pointer(i).eq.j) then
          column_codes(1,j) = i
          column_codes(2,j) = h%gil%column_size(i)
          exit
        endif
      else if (h%gil%column_pointer(i).gt.h%gil%lcol) then
         ! A little more vicious if > nlead
        itrail = h%gil%column_pointer(i)-h%gil%lcol+h%gil%nlead
        !! print *,'Trail ',j,i,itrail
        if (itrail.eq.j) then
          column_codes(1,j) = i
          column_codes(2,j) = h%gil%column_size(i)
          exit
        endif
      else
        print *,'Inconsistent Column Pointer #',i,' = ', h%gil%column_pointer(i), &
        &   ' in data range',h%gil%fcol,h%gil%lcol
      endif
    enddo
  enddo
end subroutine gdf_uvcolumn_codes

end program uv_merge

program uv_table
  use gildas_def
  use image_def
  use gkernel_interfaces, no_interface=>fourt
  !---------------------------------------------------------------------
  ! GILDAS
  !	Compute the UV data set corresponding to an image
  !	Input : an image.
  !	Output: the UV table, where the visibilities have been computed.
  ! This tasks differs from UV_MODEL by using an FFT, and generating UV
  ! data on a fully sampled grid (up to a maximum radius) rather than along
  ! user specified tracks.
  !---------------------------------------------------------------------
  ! Local
  type(gildas) :: x,y
  complex, allocatable :: tf(:,:), work(:)
  integer :: nf,nx,ny,n, if, nn(2), ier,ydim1
  character(len=filename_length) :: image,name,uvmodel
  character(len=132) :: mess
  real :: freq
  logical :: error
  !
  ! Code:
  call gildas_open
  call gildas_char('IMAGE$',image)
  call gildas_char('UVMODEL$',uvmodel)
  call gildas_close
  !
  ! Image
  n = len_trim(image)
  if (n.le.0) goto 999
  name = image(1:n)
  call gildas_null(y, type = 'IMAGE')
  call gdf_read_gildas(y, name, '.vlm', error, rank=3, data=.true.)
  if (error) then
    call gagout('E-UV_MODEL,  Could not read input image')
    goto 999
  endif
  if (y%char%code(1).eq.'FREQUENCY' .or.  &
      y%char%code(1).eq.'VELOCITY'  .or.  &
      y%char%code(1).eq.'UNKNOWN') then
    nf = y%gil%dim(1)
  else
    call gagout('E-UV_MODEL,  First axis unit not FREQUENCY')
    goto 999
  endif
  nx = y%gil%dim(2)
  ny = y%gil%dim(3)
  mess = 'I-UV_TABLE,  '//trim(y%file)//' succesfully opened'
  call gagout(mess)
  ! Define mean observing frequency
  freq = y%gil%freq+y%gil%fres*(nf*0.5-y%gil%ref(1))
  if (freq.lt.0.1) then        ! 100 kHz threshold for warning
    call gagout ('W-UV_MODEL,  VERY low frequency. Please check!')
    write(6,*) 'Value is ',freq,' MHz'
    goto 999
  endif
  !
  ! Get Virtual Memory to perform the FFT
  allocate (tf(nx,ny), work(max(nx,ny)), stat=ier)
!  ip = gag_pointer(addr,memory)    ! Complex copy of the image
!  ipw = gag_pointer(addr,memory)   ! FOURT internal work space
  if (ier.ne.0) then
    mess = 'E-UV_TABLE,  Error allocating virtual memory'
    call gagout (mess)
    goto 999
  endif
  ! Create output table
  call gildas_null(x, type = 'UVT')
  ! Transfer the cube (vlm) header to the UV table header.
  ! Problem: in such a mixed case, gdf_copy_header does not behave properly.
  ! If the input VLM has only 1 channel (dim1 = 1), the UV table will also
  ! have dim1 = 1; as a consequence gdf_setuv will discard all but 1 leading
  ! column, leading to later program error ("suspicious Nlead"). Fixed by
  ! temporarily setting dim1 to the desired size, copy it, and reset it back
  ! to the original value.
  ydim1 = y%gil%dim(1)
  y%gil%dim(1) = x%gil%nlead+x%gil%natom * nf
  call gdf_copy_header (y,x, error)
  y%gil%dim(1) = ydim1  ! Unpatch
  n = len_trim(uvmodel)
  if (n.le.0) then
    mess = 'E-UV_TABLE,  Output file name is empty.'
    call gagout (mess)
    goto 999
  endif
  name = uvmodel(1:n)
  call sic_parsef(name,x%file,' ','.uvt')
  x%gil%nchan = nf
  x%gil%dim(1) = x%gil%nlead+x%gil%natom * nf 
  x%gil%dim(2) = y%gil%dim(2)*(y%gil%dim(3)/2+1)   ! Use hermiticity for a factor of two
  x%gil%dim(3) = 1                 ! space saving
  x%gil%dim(4) = 1
  x%gil%ndim = 2
  x%gil%ref(1)  = y%gil%ref(1)
  x%gil%val(1)  = y%gil%freq
  x%gil%inc(1)  = y%gil%fres
  x%char%code(1) = 'UV-DATA'
  x%char%code(2) = 'RANDOM'
  x%char%code(3) = ' '
  x%char%code(4) = ' '
  x%gil%faxi = 1
  call gdf_create_image (x, error)
  !
  if (error) then
    mess = 'E-UV_MODEL,  Cannot create output UV model '//x%file
    call gagout (mess)
    goto 999
  endif
  call gdf_allocate (x, error)
  if (error) then
    mess = 'E-UV_MODEL,  Cannot obtain memory slot for UV model '
    call gagout (mess)
    goto 999
  endif
  !
  mess = 'I-UV_TABLE,  Output table '//trim(x%file)//' succesfully opened'
  call gagout(mess)
  !
  call uv_pos (error,x%gil%dim(1),x%gil%dim(2),x%r2d,nx,ny,  &
               y%gil%convert(1,2),y%gil%convert(1,3),freq)
  if (error) then
    mess = 'E-UV_TABLE,  Error in UV_POS'
    call gagout(mess)
    goto 999
  endif
  !
  ! OK, compute the model for each channel. Working on an LMV cube would avoid
  ! the (inefficiently programmed) transposition, but would not be consistent
  ! with UV_MODEL. Let's accept the inefficiency for the time being...
  nn(1:2) = y%gil%dim(2:3)
  do if=1,nf
    tf = cmplx ( y%r3d(if,:,:), 0.0)
    call fourt(tf,nn,2,-1,1,work)
    call recent(nx,ny,tf)
    call uv_fill (x%gil%dim(1),x%gil%dim(2),if,x%r2d,nx,ny,tf)
  enddo
  call gdf_write_data (x, x%r2d, error)
  if (error) then
    mess = 'E-UV_TABLE,  Error while updating images'
    call gagout(mess)
    goto 999
  endif
  call gagout('S-UV_TABLE,  Successful completion')
  call sysexi(1)
  !
999 call sysexi(fatale)
end program uv_table
!
subroutine uv_pos(errorfl,nco,nv,visi,nx,ny,xconvert,yconvert,freq)
  use gildas_def
  !---------------------------------------------------------------------
  ! Fill the UV coordinates of the grid points
  !---------------------------------------------------------------------
  logical :: errorfl                             !
  integer(kind=index_length), intent(in) :: nco  !
  integer(kind=index_length), intent(in) :: nv   !
  real :: visi(nco,nv)                           !
  integer :: nx                                  !
  integer :: ny                                  !
  real*8 :: xconvert(3)                          !
  real*8 :: yconvert(3)                          !
  real :: freq                                   !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 :: clight
  parameter (clight = 299792458)
  real*8 :: lambda
  integer :: i,j,i0,j0,k,iv
  real :: u,v,stepx,stepy
  !
  if (mod(nx,2).ne.0.or.mod(ny,2).ne.0) then
    call gagout('E-UV_TABLE,  Odd image dimensions are not supported yet')
    errorfl = .true.
    return
  elseif (nv.lt.nx*(ny/2+1)) then  ! Internal logic must be wrong!
    call gagout('F-UV_TABLE, Output dimension is too small')
    errorfl = .true.
    return
  endif
  !
  i0 = nx/2+1
  j0 = ny/2+1
  lambda = clight/(freq*1e6)
  stepx = 1./(nx*xconvert(3))*lambda
  stepy = 1./(ny*yconvert(3))*lambda
  !
  iv = 0
  do j=1,j0-1
    v = (j-j0)*stepy
    do i=1,nx
      iv = iv+1
      u = (i-i0)*stepx
      visi(1,iv) = u           ! U
      visi(2,iv) = v           ! V
      visi(3,iv) = 0           ! W
      do k=8,nco,3
        visi(k,iv)   = 0
        visi(k+1,iv) = 0
        visi(k+2,iv) = 1.
      enddo
    enddo
  enddo
  ! Special handling of U axis to avoid storing conjugate data
  do j=j0,j0
    v = (j-j0)*stepy
    do i=1,i0
      iv = iv+1
      u = (i-i0)*stepx
      visi(1,iv) = u           ! U
      visi(2,iv) = v           ! V
      visi(3,iv) = 0           ! W
      do k=8,nco,3
        visi(k,iv)   = 0
        visi(k+1,iv) = 0
        visi(k+2,iv) = 1.
      enddo
    enddo
  enddo
end subroutine uv_pos
!
subroutine uv_fill (nco,nv,if,visi,nx,ny,fft)
  use gildas_def
  !---------------------------------------------------------------------
  ! Fill the visibilities for one frequency channel
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nco  !
  integer(kind=index_length), intent(in) :: nv   !
  integer :: if                                  !
  real :: visi(nco,nv)                           !
  integer :: nx                                  !
  integer :: ny                                  !
  real :: fft(2,nx,ny)                           !
  ! Local
  integer :: i,j,iv,i0,j0
  !
  i0 = nx/2+1
  j0 = ny/2+1
  !
  iv = 0
  do j=1,j0-1
    do i=1,nx
      iv = iv+1
      visi(5+3*if,iv) =  +(-1)**(i+j)*fft(1,i,j)
      visi(6+3*if,iv) =  -(-1)**(i+j)*fft(2,i,j)
    enddo
  enddo
  do j=j0,j0
    do i=1,i0
      iv = iv+1
      visi(5+3*if,iv) =  +(-1)**(i+j)*fft(1,i,j)
      visi(6+3*if,iv) =  -(-1)**(i+j)*fft(2,i,j)
    enddo
  enddo
end subroutine uv_fill
!
subroutine recent(nx,ny,z)
  !---------------------------------------------------------------------
  ! Recenters the Fourier Transform, for easier display. The present version
  ! will only work for even dimensions.
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  complex :: z(nx,ny)               !
  ! Local
  integer :: i, j
  complex :: tmp
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i+nx/2,j+ny/2)
      z(i+nx/2,j+ny/2) = z(i,j)
      z(i,j) = tmp
    enddo
  enddo
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i,j+ny/2)
      z(i,j+ny/2) = z(i+nx/2,j)
      z(i+nx/2,j) = tmp
    enddo
  enddo
end subroutine recent

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the GREG package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine greg_pack_set(pack)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_pack_set
  use gpack_def
  !----------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Public package definition routine.
  ! It defines package methods and dependencies to other packages.
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack ! Package info structure
  !
  pack%name='greg'
  pack%ext='.greg'
  pack%depend(1:1) = (/ locwrd(sic_pack_set) /)
  pack%init=locwrd(greg_pack_init)
  pack%clean=locwrd(greg_pack_clean)
  pack%authors="S.Bardeau, J.Pety"
  !
end subroutine greg_pack_set
!
subroutine greg_pack_init(gpack_id,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_pack_init
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Private routine to set the GREG environment.
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Set libraries id's
  call gchar_message_set_id(gpack_id)
  call gcont_message_set_id(gpack_id)
  call gtv_message_set_id(gpack_id)
  call gtv_c_message_set_id(gpack_id)
  call greg_message_set_id(gpack_id)
  call gcore_c_message_set_id(gpack_id)
#ifdef GAG_USE_GTK
  call gui_c_message_set_id(gpack_id)
#endif
  !
  ! Local language
  call load_greg('INTERACTIVE')
  call load_greg('INTERACTIVE GREG3')
  !
  if (.not.gmaster_hide_gui()) then
     call gr_exec('DEVICE IMAGE WHITE')
     error = gr_error()
     if (error) return
  endif
  !
end subroutine greg_pack_init
!
subroutine greg_pack_clean(error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_pack_clean
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Private routine to clean the GREG environment
  ! (e.g. Remove temporary buffers, unregister languages...)
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  call exit_greg(error)
  ! if (error)  continue
  !
  ! Clear the graphic screen
  call exit_clear
  !
end subroutine greg_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
! Split ADJ_VALUE into ADJ_PROG (internal) and ADJ_USER (external)
! Suppress adj_prog accordingly (it will be ADJ_PROG)
!
! Make conversion when appropriate
!   - begin  USER --> PROG
!   - run  PROG --> USER
!   - finish  PROG --> USER
!
! Also correct error bars accordingly
!
subroutine all_from_internal
  use sic_interfaces, except_this=>all_from_internal
  use sic_adjust
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: ivar
  do ivar=1,adj_n
     call from_internal(ivar,adj_prog(ivar),adj_user(ivar))
  enddo
end subroutine all_from_internal
!
subroutine from_internal(ivar,xint,xext)
  use sic_interfaces, except_this=>from_internal
  use sic_adjust
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer, intent(in) :: ivar       ! Variable number
  real(8), intent(in) :: xint       ! Internal value
  real(8), intent(out) :: xext      ! Outside value
  !
  if (adj_bound(ivar).eq.0) then
    ! Unbounded parameter
    xext = xint
  else if (adj_bound(ivar).eq.3) then
    ! Bounded parameter
    xext = adj_lower(ivar) + 0.5d0*(dsin(xint)+1d0)*(adj_upper(ivar)-adj_lower(ivar))
  else
    call sic_message(seve%e,'ADJUST','One bound unsupported')
  endif
end subroutine from_internal
!
subroutine all_to_adjust
  use sic_interfaces, except_this=>all_to_adjust
  use sic_adjust
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: ivar
  !
  do ivar=1,adj_n
    call to_adjust(ivar,adj_prog(ivar),adj_user(ivar))
  enddo
end subroutine all_to_adjust
!
subroutine to_adjust(ivar,xint,xext)
  use sic_interfaces, except_this=>to_adjust
  use sic_adjust
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer, intent(in) :: ivar       ! Variable number
  real(8), intent(out) :: xint      ! Internal value
  real(8), intent(inout) :: xext    ! Outside value
  ! Local
  real(kind=8) :: big=1.570796326794897d0
  real(kind=8) :: small=-1.570796326794897d0
  real(8) :: lower,upper,yy
  !
  if (adj_bound(ivar).eq.0) then
    xint = xext
  else if (adj_bound(ivar).eq.3) then
    !
    ! Others mean some limits
    lower = adj_lower(ivar)
    upper = adj_upper(ivar)
    if (xext.lt.lower) then
      xint = small
      xext = lower
    elseif  (xext.eq.lower) then
      xint = small
      return
    elseif  (xext.gt.upper) then
      xint = big
      xext = upper
    elseif  (xext.eq.upper) then
      xint = big
      return
    else
      yy=2.0d0*(xext-lower)/(upper-lower) - 1.0d0
      xint = datan(yy/dsqrt(1.d0- yy**2) )
      return
    endif
    ! Optional message
  endif
end subroutine to_adjust
!
subroutine run_adjust(line,comm,error)
  use sic_interfaces, except_this=>run_adjust
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support the ADJUST Language
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  character(len=*), intent(in)    :: comm   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='ADJUST'
  !
  call sic_message(seve%c,rname,line)
  !
  if (comm.eq.'ADJUST') then
    call fit_expression('ADJUST',line,error)
#if defined(GAG_USE_PYTHON)
  else if (comm.eq.'EMCEE') then
    call adjust_mcmc (comm,line,error)
  else if (comm.eq.'ESHOW') then
    call adjust_display (comm,line,error)
#endif
  else
    call sic_message(seve%e,rname,'Unsupported command')
    error = .true.
  endif
end subroutine run_adjust
!
!
subroutine init_adjust
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>init_adjust
  use sic_adjust
  !---------------------------------------------------------------------
  ! @ public
  ! Initialize the ADJUST Language
  !---------------------------------------------------------------------
  ! Local
  integer(kind=address_length), save :: addr_exec
  integer, parameter :: mfit=11+3+9
  character(len=12) :: vfit(mfit)
  logical, save :: load_adjust=.true.
  !
  data vfit /' ADJUST','/START','/STEP','/WEIGHTS','/EPSILON','/METHOD',  &
    '/ITERATIONS','/QUIET','/BOUNDS','/ROOT_NAME','/PARAMETERS', &
    ' ESHOW', '/BURN', '/SPLIT', &
    ' EMCEE', '/BEGIN', '/BOUNDS', '/LENGTH', '/PARAMETERS', '/ROOT_NAME', &
    '/START', '/STEP',  '/WALKERS'/
  !
  if (load_adjust) then
    call sic_begin('ADJUST','GAG_HELP_ADJUST',mfit,vfit,  &
    '2.1    30-Sep-2016',run_adjust,err_vector)
    load_adjust = .false.
  endif
  !
  addr_exec = locwrd(exec_adjust)
  adj_exec = bytpnt(addr_exec,membyt)
end subroutine init_adjust
!
subroutine init_mfit
  use sic_dependencies_interfaces
  use sic_adjust
  !---------------------------------------------------------------------
  ! @ private
  ! Initialize the MFIT driver routine address
  !---------------------------------------------------------------------
  external :: sic_libr
  ! Local
  integer(kind=address_length) :: addr_exec
  !
  addr_exec = locwrd(sic_libr)
  fun_exec = bytpnt(addr_exec,membyt)
end subroutine init_mfit
!
subroutine fit_expression (comm,line,error)
  use gildas_def
  use gbl_format
  use sic_adjust
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fit_expression
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !     Support for commands
  !
  !     ADJUST Data Command [/START A1 B1 C1 ...] [/STEP A2 B2 C2 ...]
  !     [/EPSILON e] [/WEIGHTS w] [/METHOD Powell|Robust|Simplex|Slatec|Anneal]
  !     [/ITER Niter] [/QUIET]  /Bounds Par Low Up [...] /Parameters Va Vb Vc ...
  !     [/ROOT]
  !
  ! and
  !     MFIT Y=f(X) [/START A1,B1,C1,...] [/STEP A2,B2,C2,...]
  !     [/EPSILON e] [/WEIGHTS w] [/METHOD Powell|Robust|Simplex|Slatec|Anneal]
  !     [/ITER Niter] [/QUIET] /Bounds &Par Low Up
  !
  ! Allows fitting arbitrary data with arbitrary number of parameters
  !
  ! POWELL and SIMPLEX methods use the library routines from Press et al.,
  ! Numerical Recipes modified to allow easy error recovery.
  !
  ! SLATEC method uses the Slatec library, modified Levenberg-Marquardt
  ! routine DNLS1E, and also computes the error bars on the parameters.
  ! Much faster, but sensitive to starting values...
  !
  ! ROBUST uses a combination of SIMPLEX to get started and SLATEC to finish with
  !
  ! ANNEAL uses a simulated annealing. Very robust, but slow... It finishes
  ! with a SLATEC method to compute the errors.
  !---------------------------------------------------------------------
  character(len=*)                :: comm   !
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='ADJUST'
  !
  integer, parameter :: O_START = 1
  integer, parameter :: O_STEP = 2
  integer, parameter :: O_WEIGHT = 3
  integer, parameter :: O_EPS = 4
  integer, parameter :: O_METHOD = 5
  integer, parameter :: O_ITER = 6
  integer, parameter :: O_QUIET = 7
  integer, parameter :: O_BOUND = 8
  integer, parameter :: O_ROOT = 9
  integer, parameter :: O_PAR = 10
  !
  character(len=256) :: cstart,cstep,cweight
  character(len=formula_length) :: chain,formula
  character(len=commandline_length) :: fitexpr
  character(len=varname_length) :: avar,cvar
  character(len=64) :: work
  logical :: found
  integer :: lstart,lstep,lweight
  integer :: i,narg,ivar
  real(4) :: xstart(adj_m),xstep(adj_m),xdef(adj_m)
  real(8) :: epsilon
  type(sic_descriptor_t) :: ddesc,wdesc,default
  integer :: iter,nc,pdim
  !
  integer, parameter :: mtools=5
  character(len=12) :: argum,method,tools(mtools)
  integer :: la,nm,lk
  data tools /'ANNEALING','POWELL','SIMPLEX','SLATEC','ROBUST'/
  logical :: do_anneal
  logical :: do_simplex
  logical :: do_powell
  logical :: do_slatec
  logical :: do_errorbars
  logical :: is_general
  logical :: quiet
  !
  integer :: m1,m2,m3,lc,ier,ilun,j,k
  character(len=filename_length) :: fname
  character(len=message_length) :: mess
  !
  is_general = comm.ne.'MFIT'
  !
  ! Delete the (previous) generic structure name to be as clean as possible
  call sic_delvariable(adj_root(1:adj_lroot),.false.,error)
  error = .false.
  !
  ! Option /ROOT : Root name
  if (sic_present(O_ROOT,1)) then
    call sic_ch(line,O_ROOT,1,adj_root,adj_lroot,.true.,error)
    if (error) return
  else if (comm.eq.'MFIT') then
    adj_root = 'MFIT'
    adj_lroot = 4     
  endif
  !
  ! Delete the (new) generic structure name, in case it exists
  call sic_delvariable(adj_root(1:adj_lroot),.false.,error)
  error = .false.
  !
  if (is_general) then
    cur_exec = adj_exec
    pdim = sic_narg(O_PAR)
    if (pdim.le.0) then
      call sic_message(seve%e,rname,'No variable specified')
      error = .true.
      return
    endif
  else
    cur_exec = fun_exec
    if (sic_narg(0).eq.0) then
      call sic_message(seve%e,rname,'No Formula...')
      error = .true.
      return
    endif
  endif
  !
  ! Option /METHOD 
  if (sic_present(O_METHOD,0)) then
    call sic_ke (line,O_METHOD,1,argum,la, .true.,error)
    if (error) return
    call sic_ambigs('style',argum,method,nm,tools,mtools,error)
    if (error) return
  else
    method = 'ROBUST'
  endif
  do_anneal = .false.
  do_simplex = .false.
  do_powell = .false.
  do_slatec = .false.
  do_errorbars = .false.
  select case (method)
  case ('POWELL')
    iter = 200
    epsilon = 2d-6
    do_powell = .true.
    do_errorbars = .true.
  case ('SIMPLEX') 
    iter = 500
    epsilon = 2d-6
    do_simplex = .true.
  case  ('ANNEALING') 
    epsilon = 0.0
    iter = 2000
    do_anneal = .true.
    do_slatec = .true.
  case ('SLATEC') 
    do_slatec = .true.
    epsilon = 0.0
    do_errorbars = .true.
  case ('ROBUST') 
    do_simplex = .true.
    do_slatec = .true.
    do_errorbars = .true.
    epsilon = 0.
    iter = 200                 ! for robust, just to initialize
  case default  
    call sic_message(seve%e,rname,'No such method '//method)
    error = .true.
    return
  end select
  !
  ! Option /EPSILON  : Epsilon value. Note it must be after /METHOD
  ! to inherit the proper default
  call sic_r8 (line,O_EPS,1,epsilon,.false.,error)
  if (error) return
  !
  ! Option /ITERATIONS : Iterations
  call sic_i4 (line,O_ITER,1,iter,.false.,error)
  if (error) return
  !
  ! Option /QUIET 
  quiet = sic_present(O_QUIET,0)
  !
  call sic_defstructure(adj_root(1:adj_lroot),.true.,error)
  if (error) return
  !
  ! Main arguments; must be the last ones, because
  ! of use of M_VARCOP in one case
  if (is_general) then
    !
    default%type = fmt_r8
    default%readonly = .false.
    default%addr = 0
    default%ndim = 0
    default%dims(:) = 0
    default%size = 0
    default%status = 0
    call sic_desc (line,0,1,ddesc,default,.true.,error)
    if (error) return
    !
    call sic_ch(line,0,2,diff_expression,nc,.true.,error)
    if (error) return
  else
    !
    ! Non standard, but to remain compatible with MFIT
    m1=sic_narg(0)
    m2=sic_start(0,1)
    m3=sic_end(0,m1)
    chain = line(m2:m3)
    ! Here the formula is without blanks.
    lc = m3-m2+1
    call sic_black(chain,lc)
    !
    ! Look if it might be a filename:
    found = index (chain(1:lc),'=').ne.0
    !
    ! No "=" sign in formula: this might be a file. Default extension is .grf
    ! (like GRemlin Fit, GReg Fit, GRaphic Fit) instead of simply .fit to avoid
    ! possible collisions with MIDAS *.FIT files.
    !
    if (.not. found) then
      error = .true.
      call sic_parse_file (chain,' ','.grf',fname)
      ier = sic_getlun(ilun)
      open(ilun,file=fname,form='FORMATTED',status='OLD',iostat=ier)
      if (ier.ne.0) then
        call sic_frelun(ilun)
        call putios('E-ADJUST,  ',ier)
        error = .true.
        return
      endif
      !
      k = 1
      formula = ' '
      !
      ! Formula file reading loop:
      do
        read(ilun,'(A)',iostat=ier) chain
        if (ier.ne.0)  exit
        !
        ! Overread comment lines
        if (chain(1:1).eq.'!')  cycle
        !
        do j = 1, len_trim(chain)
          if (chain(j:j) .ne. ' ') then
            formula(k:k) = chain(j:j)
            k = k+1
            if (k .gt. len(formula)) then
              call sic_message(seve%e,rname,'Formula too long')
              close(unit=ilun)
              call sic_frelun(ilun)
              return
            endif
          endif
        enddo
      enddo
      !
      close (unit=ilun)
      call sic_frelun(ilun)
    else
      ! Commandline formula:
      formula = chain
    endif
    call sic_upper (formula)
    error = .false.
    call get_formula(formula,fitexpr,ddesc,pdim,quiet,error)
    if (error) return
  endif
  !
  ! Option /PARAMETER : parameter names, must be parsed before /BOUND
  ! /START and /STEP options
  !
  if (is_general) then
    pdim = sic_narg(O_PAR)
    do i=1,pdim
      call sic_ke(line,O_PAR,i,work,nc,.true.,error)
      if (error) return
      if (.not.sic_varexist(work(1:nc))) then
        call sic_message(seve%e,rname,'Parameter'//work(1:nc)//' does not exist')
        error = .true.
        return
      endif
      adj_names(i) = work
    enddo
  else
    do i=1,pdim
      write(adj_names(i),'(A,A,I2.2,A)') adj_root(1:adj_lroot),'%PAR[',i,']'
    enddo
  endif
  !
  ! Option /BOUNDS : Allowed range for parameter values
  adj_bound = 0 ! Reset to Unbound
  narg = max(sic_narg(O_BOUND),0)  ! -1 if not present
  if (mod(narg,3).ne.0) then
    call sic_message(seve%e,rname,'/BOUND requires N times 3 arguments')
    error = .true.
    return
  endif
  do i=1,narg,3
    call sic_ke (line,O_BOUND,i,avar,lk,.false.,error)
    if (is_general) then
      ! Parameter names have been defined
      call sic_ambigs('/BOUNDS',avar,cvar,ivar,adj_names,pdim,error)
      if (error) return
    else
      ! Parameters are &A .. &N
      ivar = ichar(avar(2:2)) - ichar('A') +1
    endif
    call sic_ke (line,O_BOUND,i+1,argum,lk,.false.,error)
    if (argum.eq.'*') then
      call sic_message(seve%e,rname,'Free Lower bound not yet supported')
      error = .true.
      return
    else
      call sic_r8 (line,O_BOUND,i+1,adj_lower(ivar),.false.,error)
    endif
    call sic_ke (line,O_BOUND,i+2,argum,lk,.false.,error)
    if (argum.eq.'*') then
      call sic_message(seve%e,rname,'Free Upper bound not yet supported')
      error = .true.
      return
    else
      call sic_r8 (line,O_BOUND,i+2,adj_upper(ivar),.false.,error)
    endif
    adj_bound(ivar) = 3
    write (mess,*) 'Bound ',ivar,adj_lower(ivar),adj_upper(ivar)
    call sic_message(seve%i,rname,mess)
  enddo
  !
  ! Option /START: Starting values (again after everything, to have PDIM defined)
  narg = min(sic_narg(O_START),pdim)
  cstart = ' '
  call sic_ch (line,O_START,1,cstart,lstart,.false.,error)
  if (error) return
  xstart = 0.0
  !
  if (index(cstart,',').ne.0) then
    !
    ! This stupid code below is to support the old MFIT syntax
    call sic_upper(cstart)
    xdef = 1.0 ! 0.5*(adj_lower+adj_upper)
    call txt_array(cstart,pdim,xstart,xdef)
    ! The 'mess' string below may be too small if pdim (number of
    ! variables to be fitted) is large
    write (mess,*) 'XSTART ',trim(cstart),xstart(1:pdim)
    call sic_message(seve%d,rname,mess)
    !
    ! Set the variable to their starting values
    do i=1,pdim
      adj_user(i) = xstart(i)
      call sic_let_auto(adj_names(i),adj_user(i),error)
    enddo
  else
    !
    ! More generic and standard syntax - one argument per value.
    !
    ! Get the default
    if (is_general) then
      do i=1,pdim
        call sic_get_real(adj_names(i),xstart(i),error)
        error = .false.
      enddo
    else
      xstart = 1.0
    endif
    !
    ! Override by user specified values
    do i=1,narg
      call sic_r4 (line,O_START,i,xstart(i),.false.,error)
      if (error) return
      !
      ! Set the variable to its starting value ...
      adj_user(i) = xstart(i)
      if (is_general) then
        call sic_let_auto(adj_names(i),adj_user(i),error)
      endif
    enddo
  endif
  !
  ! Option O_STEP: Steps
  cstep = ' '
  narg = min(sic_narg(O_STEP),pdim) 
  call sic_ch (line,O_STEP,1,cstep,lstep,.false.,error)
  if (error) return
  xstep = 0.0
  if (index(cstep,',').ne.0) then
    call sic_upper(cstep)
    xdef = 0.1*xstart
    call txt_array(cstep(1:lstep),pdim,xstep,xdef)
    write (mess,*) "XSTEP",xstep(1:pdim)
    call sic_message(seve%d,rname,mess)
  else
    xstep = 0.25 * xstart
    where (xstep.eq.0) xstep = 0.25
    do i=1,narg
      call sic_r4 (line,O_STEP,i,xstep(i),.false.,error)
      if (error) return
    enddo
  endif
  !
  ! Option /WEIGHT: Weight. Put it last because of variable incarnation
  cweight = ' '
  call sic_ke (line,O_WEIGHT,1,cweight,lweight,.false.,error)
  if (error) return
  if (lweight.gt.0) then
    default%type = fmt_r8
    default%readonly = .false.
    default%addr = 0
    default%ndim = 0
    default%dims(:) = 0
    default%size = 0
    default%status = 0
    call sic_inca (line,O_WEIGHT,1,wdesc,default,.true.,error)
    if (error) return
  else
    wdesc%type = 0
    wdesc%readonly = .false.
    wdesc%addr = 0
    wdesc%ndim = 0
    wdesc%dims(:) = 0
    wdesc%size = 0
    wdesc%status = 0
  endif
  !
  ! Make the minimization
  error = .false.
  call minimize_all (pdim,ddesc,xstart,xstep,wdesc,epsilon,do_anneal,  &
  do_simplex,do_powell,do_slatec,do_errorbars,error,iter,quiet)
  !
  if (.not.error) then
    !
    ! Set the output variables or the residual
    if (is_general) then
      do i=1,adj_n
        call from_internal(i,adj_prog(i),adj_user(i))
        call sic_let_auto(adj_names(i),adj_user(i),error)
      enddo
    else
      call sic_libr(diff_expression,error)
      call sic_libr(fitexpr,error)
    endif
  endif
  !
  ! Cleanup incarnations
  call sic_volatile(wdesc)
end subroutine fit_expression
!
subroutine minimize_all (np,darray,xstart,xstep,weight,epsilon,do_anneal,  &
  do_simplex,do_powell,do_slatec,do_errorbars,error,iter,quiet)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_adjust
  use sic_types
  use sic_interfaces, except_this=>minimize_all
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Adjust parameters in the least-square sense for a general problem.
  !
  ! Uses a set of minimization routines
  ! - Simplex
  ! - Gradient (Powell method)
  ! - Simulated annealing
  ! - Levenberg Marquardt (from SLATEC)
  ! and error bars through the Jacobian
  !---------------------------------------------------------------------
  integer(kind=4),        intent(in)    :: np            ! Number of parameters to be adjusted
  type(sic_descriptor_t), intent(in)    :: darray        ! Descriptor of Data array
! character(len=*)                      :: cstart        ! Starting values
! character(len=*)                      :: cstep         ! Increments to compute derivatives
  real(kind=4),           intent(in)    :: xstart(np)    ! Starting values
  real(kind=4),           intent(in)    :: xstep(np)     ! Increments to compute derivatives
  type(sic_descriptor_t), intent(in)    :: weight        ! Descriptor of Weight array
  real(kind=8),           intent(inout) :: epsilon       ! Precision to decided convergence
  logical,                intent(in)    :: do_anneal     !
  logical,                intent(in)    :: do_simplex    !
  logical,                intent(in)    :: do_powell     !
  logical,                intent(in)    :: do_slatec     !
  logical,                intent(inout) :: do_errorbars  !
  logical,                intent(inout) :: error         ! Error return flag
  integer(kind=4),        intent(in)    :: iter          !
  logical,                intent(in)    :: quiet         !
  ! Local
  integer :: i,j,ni,signum
  !
  real(8), allocatable :: fvec(:)
  integer(kind=address_length) :: ip
  integer :: memory(1)
  real(8), allocatable :: wa(:)
  integer, allocatable :: iw(:)
  real(8), allocatable :: wa1(:),wa2(:),wa3(:),wa4(:),r(:,:)
  integer :: ier
  integer :: nprint,info,lwa,iopt
  real(8) :: chi2,tmp,guess_i
  !
  ! Simulated Annealing
  real(8) :: lbounds(adj_m),ubounds(adj_m),step(adj_m),guess(adj_m),saved(adj_m)
  real(8), allocatable :: fstar(:),xp(:)
  real(8) :: temp_factor,eps,temperature,fopt
  integer :: ncycles,niter,neps,iseed1,iseed2,iprint,nacc,nfcnev,nobds,maxevl
  integer, allocatable :: nacp(:)
  !
  ! Powell and Simplex
  !  real pstart(np), e_v(np,np), y(np), point(np)
  real, allocatable :: pstart(:),e_v(:,:),y(:),point(:)
  real fret,p(adj_m+1,adj_m),epsi
  !
  ! Errors with bounds
  real(8) :: dx,al,bl,du1,du2
  !
  integer, parameter :: mp=26 ! Alphabet ...
  integer, parameter :: mform=26  ! Number of characters in a * format for Real(8)
  integer :: lp
  character(len=mp*mform+16) :: mess
  character(len=6) :: rname = 'ADJUST'
  !
  if (np.le.mp) then
    lp = np
  else
    call sic_message(seve%w,rname,'Maximum number of parameters exceeded in debug messages, truncated') 
    lp = mp
  endif
  write (mess,*) "START ",xstart(1:lp)
  call sic_message(seve%d,rname,mess)
  write (mess,*) "STEP ",xstep(1:lp)
  call sic_message(seve%d,rname,mess)
  !
  call xsetf(0)
  !
  adj_ncall = 0
  press_pdim = np
  !
  ! Error detection:
  call sic_def_logi (adj_root(1:adj_lroot)//'%STATUS',press_error,.false.,error)
  press_error = .false.
  !
  ! Make a "local" copy to hold the "difference" array.
  ! Note that SIC does not care about non-conformant array provided they have
  ! the same size, so do it simply...
  ndata = desc_nelem(darray)
  if (allocated(dvec)) deallocate(dvec)
  allocate(dvec(ndata),stat=ier)
  ip = gag_pointer(darray%addr,memory)
  call r8tor8(memory(ip),dvec,ndata)
  !
  ! Do the same for the weights
  if (weight%type.ne.0) then
    if (weight%size.ne.2*ndata) then
      call sic_message(seve%e,rname,'Weight array size mismatch')
      error = .true.
      return
    endif
    allocate(wvec(ndata),stat=ier)
    ip = gag_pointer(weight%addr,memory)
    call r8tor8(memory(ip),wvec,ndata)
    wvec = sqrt(wvec)
  else
    allocate(wvec(ndata),stat=ier)
    wvec = 1.d0
  endif
  !
  ! Create the Parameter variables
  call sic_def_inte(adj_root(1:adj_lroot)//'%N',adj_n,0,0,.false.,error)
  call sic_def_dble(adj_root(1:adj_lroot)//'%PAR',adj_user,1,np,.false.,error)
  call sic_def_charn(adj_root(1:adj_lroot)//'%NAME',adj_names,1,np,.false.,error)
  !
  adj_guess(1:np) = xstart
  adj_user = adj_guess
  adj_step(1:np) = xstep
  do i=1,np
    if (adj_bound(i).eq.0) then
      if (xstep(i).eq.0) then
        adj_step(i) = 0.1
      else
        adj_step(i) = xstep(i)
      endif
    else if (adj_bound(i).eq.3) then
      if (xstep(i).eq.0) then
        adj_step(i) = 0.5d0*(adj_upper(i) - adj_lower(i))
      else
        guess_i = adj_guess(i)
        call to_adjust(i,dx,guess_i)
        guess_i = adj_guess(i)+xstep(i)
        call to_adjust(i,al,guess_i)
        guess_i = adj_guess(i)-xstep(i)
        call to_adjust(i,bl,guess_i)
        adj_step(i) = 0.5d0 * (dabs(al-dx)+dabs(bl-dx))
      endif
    endif
  enddo
  write(mess,*) 'Adjust Steps ',adj_step(1:lp)
  call sic_message(seve%d,rname,mess)
  adj_n = np
  !
  ! Make the minimization...
  allocate (fvec(ndata),stat=ier)
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  call sic_def_dble(adj_root(1:adj_lroot)//'%RES',dvec,1,ndata,.false.,error)
  call exec_subprogram (membyt(cur_exec),diff_expression,error)
  !
  ! Now minimize
  !
  if (do_simplex) then
    allocate(pstart(np),y(np+1),point(np),stat=ier)
    call all_to_adjust !! adj_prog(1:adj_n) = adj_user(1:adj_n)
    press_itmax = iter
    epsi = epsilon
    if (do_slatec.or.epsi.eq.0) epsi = 2e-6
    !
    ! Calculate the Simplex points:
    !
    do j = 1, np+1
      do i = 1, np
        signum = 1
        if (i .ge. j) signum = -1
        ! This does not work for Bounded values !!BOUND
        point(i) = adj_prog(i) + signum * adj_step(i)
      enddo
      y(j) = press_func (point)
      do i = 1, np
        p(j,i) = point(i)
      enddo
    enddo
    !
    ! Simplex Amoeba minimum detection (Numerical Recipes, Press et al.)
    !
    if (.not.quiet) then
      call sic_message(seve%i,rname,'Using method SIMPLEX')
    endif
    call press_amoeba(p,y,adj_m+1,adj_m,np,epsi,press_func,ni)
    do i = 1, np
      pstart(i) = p(np+1,i)
    enddo
    fret = y(np+1)
    adj_prog(1:np) = pstart(1:np)
    call all_from_internal
    deallocate(pstart,y,point,stat=ier)
  endif
  !
  if (do_powell) then
    call all_to_adjust !! adj_prog(1:adj_n) = adj_user(1:adj_n)
    allocate(pstart(np),e_v(np,np),stat=ier)
    press_itmax = 100
    epsi = epsilon
    if (do_slatec.or.epsi.eq.0) epsi = 2e-6
    !
    e_v = 0.0
    do i=1,np
      e_v(i,i) = adj_step(i)
      pstart(i) = adj_prog(i)
    enddo
    !
    ! Powell minimum detection (Numerical Recipes, Press et al.)
    !
    if (.not.quiet) then
      call sic_message(seve%i,rname,'Using method POWELL')
    endif
    call press_powell(pstart,e_v,np,np,epsi,ni,fret,press_func,press_f1dim)
    !
    adj_prog(1:np) = pstart(1:np)
    call all_from_internal
    deallocate(pstart,e_v,stat=ier)
  endif
  !
  if (do_anneal) then
    call all_to_adjust !! adj_prog(1:adj_n) = adj_user(1:adj_n)
    ! Need also to convert the Guesses
    do i=1,adj_n
      call to_adjust(i,guess(i),adj_guess(i))
    enddo
    neps = 4
    allocate (fstar(neps),xp(adj_n),nacp(adj_n))
    temp_factor = 0.85d0
    call sic_get_dble('ANNEAL%RT',temp_factor,error)
    eps = epsilon
    if (eps.eq.0d0) then
      eps  = 4.d0              ! A few sigma make sense
    endif
    ncycles = 20
    call sic_get_inte('ANNEAL%CYCLE',ncycles,error)
    niter = max(20,5*adj_n)
    call sic_get_inte('ANNEAL%NT',niter,error)
    step(1:adj_n) = 2.0
    iseed1 = 10000
    iseed2 = 20000
    lbounds = -1d30
    ubounds = 1d30
    temperature = 5.0
    call sic_get_dble('ANNEAL%T',temperature,error)
    iprint = 0                 ! 1,2,3
    if (quiet.or.do_slatec) iprint = -1
    maxevl = iter
    if (iter.eq.0) then
      maxevl = 5000
    endif
    call sic_get_inte('ANNEAL%MAX',maxevl,error)
    !!Print *,'Annealing ',eps,niter,temperature,' eps,niter,temperature'
    call simann (  &
       adj_n,       &  ! N - Number of variables in the function to be optimized. (INT)
       guess,       &  ! X - The starting values for the variables of the function to be optimized. (DP(N))
       .false.,     &  !    MAX - the function should be maximized or minimized.
       temp_factor, &  !    RT - The temperature reduction factor. 0.85 in practice
       eps,         &  !    EPS - Error tolerance for termination.
       ncycles,     &  !    NS - Number of cycles.
       niter,       &  !    NT - Number of iterations before temperature reduction
       neps,        &  !    NEPS - Number of final function values used to decide upon termination.
       maxevl,      &  !    MAXEVL - The maximum number of function call. If exceeded, IER = 1. (INT)
       lbounds,     &  !    LB - The lower bound for the allowable solution variables. (DP(N))
       ubounds,     &  !    UB - The upper bound for the allowable solution variables. (DP(N))
       step,        &  !    C - Vector that controls the step length adjustment. (DP(N))
       iprint,      &  !    IPRINT - controls printing inside SA. (INT) (0 nothing  - 3 too many)
       iseed1,      &  !    ISEED1 - The first seed   0 .LE. ISEED1 .LE. 31328. (INT)
       iseed2,      &  !    ISEED2 - The second seed  0 .LE. ISEED2 .LE. 30081. (INT)
       temperature, &  !   Annealing Temperature (initial and final)  (DP)
       adj_step,    &  !    VM - The step length vector.  (DP(N))
       adj_prog,    &  !    XOPT - The variables that optimize the function. (DP(N))
       fopt,        &  !    FOPT - The optimal value of the function. (DP)
       nacc,        &  !    NACC - The number of accepted function evaluations. (INT)
       nfcnev,      &  !    NFCNEV - The total number of function evaluations.
       nobds,       &  !    NOBDS - The total number of evaluations that would have been out of bounds.
       ier,         &  !    IER - The error return number. (INT) (0 - 3)
       fstar,       &  !    Work arrays (DP(NEPS)
       xp,          &  !    Work array DP(N)
       nacp,        &  !    Work array I(N)
       mini_siman)     !    FCN - Function to be optimized.
    deallocate (fstar,xp,nacp)
    call all_from_internal         !      adj_user = adj_prog
  endif
  !
  if (epsilon.eq.0d0) then
    epsilon  = max(0.7d0/ndata,1d-12)
  endif
  !
  if (do_slatec) then
    if (.not.quiet) then
      call sic_message(seve%i,rname,'Using method SLATEC')
    endif
    call all_to_adjust !! adj_prog(1:adj_n) = adj_user(1:adj_n)
    !
    lwa = adj_n*(ndata+5)+ndata
    allocate (wa(lwa),stat=ier)
    allocate (iw(ndata),stat=ier)
    !
    nprint = 2               ! 00               ! Just for debug
    if (quiet) nprint = 100000
    info = 0
    iopt = 2
    call dnls1e( &
       mini_dnls, &  ! Function to be minimized
       iopt,      &  ! 1=No, 2=Full Jacobian provided, 3=Single Derivative
       ndata,     &  ! Number of data points
       adj_n,     &  ! Number of variable fitted parameters
       adj_prog,  &  ! Values of variable fitted parameters
       fvec,      &  !
       epsilon,   &  ! Tolerance
       nprint,    &  ! Print control every NPRINT iterations (IFLAG = 0 in FCN)
       info,      &  ! Information on result quality
       iw,        &  ! integer work array of length NPAR
       wa,        &  !
       lwa )
     !
    if (info.eq.0) then
      write(mess,*) 'Improper input parameters, info= ',info
      call sic_message(seve%e,'DNLS1E',mess)
      error = .true.
    elseif (info.eq.6 .or. info.eq.7) then
      write(mess,*) 'TOL too small, info= ',info
      call sic_message(seve%e,'DNLS1E',mess)
      error = .true.
    elseif (info.eq.5) then
      write(mess,*) 'Not converging, info= ',info
      call sic_message(seve%e,'DNLS1E',mess)
      error = .true.
    elseif (info.eq.4) then
      write(mess,*) 'Singular Jacobian, info= ',info
      call sic_message(seve%e,'DNLS1E',mess)
      error = .true.
    elseif (info.eq.1 .or. info.eq.2 .or.info.eq.3) then
      if (.not.quiet) then
        write(mess,*) 'Algorithm reaches convergence, info= ',info
        call sic_message(seve%i,'DNLS1E',mess)
        if (info.eq.1 .or. info.eq.3) then
          write(mess,*) 'Relative error on CHI2 less than ',epsilon
          call sic_message(seve%i,'DNLS1E',mess)
        endif
        if (info.eq.2 .or. info.eq.3) then
          write(mess,*) 'Relative error on solution less than ',epsilon
          call sic_message(seve%i,'DNLS1E',mess)
        endif
      endif
      error = .false.
    elseif (info.eq.-1) then
      write(mess,*) 'Aborted by user, info= ',info
      call sic_message(seve%e,'DNLS1E',mess)
      error = .true.
    else
      write(mess,*) 'Unknown info code, info= ',info
      call sic_message(seve%e,'DNLS1E',mess)
      error = .true.
    endif
    if (error) then
      write (mess,*) 'Epsilon ',epsilon
      call sic_message(seve%i,'DNLS1E',mess)
      write (mess,*) 'Adj_n ',adj_n
      call sic_message(seve%i,'DNLS1E',mess)
      write (mess,*) 'Ndata ',ndata
      call sic_message(seve%i,'DNLS1E',mess)
      write (mess,*) 'Iopt ',iopt
      call sic_message(seve%i,'DNLS1E',mess)
    endif
    !
    deallocate (iw,wa)
    if (error) do_errorbars = .false.
    call all_from_internal         !      adj_user = adj_prog
  endif
  !
  ! Find errors: do we use the Bounds ?
  if (do_errorbars) then
    call all_to_adjust !! adj_prog(1:adj_n) = adj_user(1:adj_n)
    allocate(wa(ndata),r(ndata,adj_n),stat=ier)
    saved = adj_prog
    wa(:) = dvec
    !
    r = 0
    allocate(wa1(adj_n),wa2(adj_n),wa3(adj_n),wa4(ndata),stat=ier)
    !
    info = 0
    call dcov(     &
       mini_dnls,   &
       iopt,        &
       ndata,       &
       adj_n,       &
       adj_prog,    &
       fvec,        &
       r,           &
       ndata,       &
       info,        &     ! Result condition
       wa1,wa2,wa3, &
       wa4)
    !
    adj_prog = saved  ! DCOV disturbs the values...
    dvec(:) = wa      ! and the residuals
    call all_from_internal         !      adj_user = adj_prog
    error = .true.
    if (info.eq.0) then
      write(mess,*) 'Improper input parameters, info= ',info
      call sic_message(seve%e,'DCOV',mess)
    elseif (info.eq.2) then
      write(mess,*) 'Singular Jacobian, info= ',info
      call sic_message(seve%e,'DCOV',mess)
      error = .false.
    else
      error = .false.
      ! To be corrected if bounded
      do i=1,adj_n
        dx = sqrt(abs(r(i,i)))  !!BOUND
        if (adj_bound(i).eq.3) then
          al = adj_lower(i)
          bl = adj_upper(i) - al
          du1 = al + 0.5d0 *(sin(adj_prog(i)+dx) +1.0d0) * bl - adj_user(i)
          du2 = al + 0.5d0 *(sin(adj_prog(i)-dx) +1.0d0) * bl - adj_user(i)
          if (dx .gt. 1.0d0)  du1 = bl
          dx = 0.5d0 * (abs(du1) + abs(du2))
        endif
        adj_errors(i) = dx
      enddo
    endif
    deallocate (wa,r,wa1,wa2,wa3,wa4)
  endif
  !
  if (error) then
    deallocate(fvec,wvec)
    return
  endif
  if (do_errorbars) then
    call sic_def_dble(adj_root(1:adj_lroot)//'%ERRORS',adj_errors,1,np,.false.,error)
  endif
  if (error.or.quiet) then
    deallocate(fvec,wvec)
    return
  endif
  !
  ! Compute Chi^2
  chi2 = 0
  do i=1,ndata
    tmp = dvec(i) * wvec(i)
    chi2 = chi2 + tmp*tmp
  enddo
  deallocate(fvec,wvec)
  !
  ! Print out Results
  write(mess,'(I6,A,1PG20.10,1X,1PG20.10)') adj_ncall,  &
  ' Function calls, Chi2: ',chi2,sqrt(chi2/ndata)
  call sic_message(seve%i,rname,mess)
  if (do_errorbars) then
    call sic_message(seve%i,rname,'Parameters and Errors:')
    do i=1,adj_n
      write(mess,*) trim(adj_names(i)),adj_user(i),adj_errors(i)
      call sic_message(seve%i,rname,mess)
    enddo
  else
    call sic_message(seve%i,rname,'Parameters')
    do i=1,adj_n
      write(mess,*) trim(adj_names(i)),adj_user(i)
      call sic_message(seve%i,rname,mess)
    enddo
  endif
  call sic_message(seve%i,rname,'Residuals in '//adj_root(1:adj_lroot)//'%RES')
  !
end subroutine minimize_all
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mini_dnls(iflag,mdat,npar,x,fvec,fjac,ldfjac)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>mini_dnls
  use sic_adjust
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Driver routine for the Levenberq-Marquardt
  !---------------------------------------------------------------------
  integer, intent(inout)  :: iflag        ! Operation Flag
  integer, intent(in)  :: mdat            ! Number of data points
  integer, intent(in)  :: npar            ! Number of variable fitted parameters
  real(8), intent(in)  :: x(npar)         ! Variable fitted parameters
  real(8), intent(inout) :: fvec(mdat)    ! Difference between value and data
  integer, intent(in)  :: ldfjac          ! First dimension of fjac
  real(8), intent(out) :: fjac(ldfjac,*)  ! Jacobian
  ! Local
  real(8) :: chi2, y,newx
  real(8), allocatable :: svec(:)
  integer :: i,k,ier
  logical :: error
  character(len=message_length) :: mess
  !
  error = .false.
  if (iflag.eq.0) return  ! We want to be quiet here...
  !
  ! From x to association module
  do i=1,adj_n
    call from_internal(i,x(i),y)
    call sic_let_auto(adj_names(i),y,error)
  enddo
  !
  if (iflag.eq.0) then         ! Print current values
    chi2 = 0.
    do i=1,mdat
      y = fvec(i)
      chi2 = chi2 + y*y
    enddo
    write (mess,*) 'Val  ',(x(i),i=1,adj_n)
    call sic_message(seve%i,'MINI_DNLS',mess)
    write (mess,'(1x,A,F12.2)') 'Chi2 ',chi2
    call sic_message(seve%i,'MINI_DNLS',mess)
  elseif  (iflag.eq.1) then    ! Compute the difference vector (fvec)
    adj_ncall = adj_ncall+1
    call exec_subprogram (membyt(cur_exec),diff_expression,error)
    if (error) then
      iflag = -1
      return
    endif
    fvec = dvec*wvec
  elseif  (iflag.eq.2) then
    !
    ! fvec must *NOT* be altered here (See dnsl1e documentation).
    !
    call exec_subprogram (membyt(cur_exec),diff_expression,error)
    if (error) then
      iflag = -1
      return
    endif
    !
    allocate(svec(ndata),stat=ier)
    svec(:) = dvec
    !
    adj_ncall = adj_ncall+adj_n
    do i=1,adj_n
      newx = x(i) + adj_step(i)
      call from_internal(i,newx,y)
      call sic_let_auto(adj_names(i),y,error)
      call exec_subprogram (membyt(cur_exec),diff_expression,error)
      do k=1,ndata
         fjac(k,i) = (dvec(k)-svec(k))/adj_step(i) * wvec(k)
      enddo
      call from_internal(i,x(i),y)
      call sic_let_auto(adj_names(i),y,error)
    enddo
    deallocate (svec)
  else
    write(mess,*) 'Do not know IFLAG ',iflag
    call sic_message(seve%u,'MINI_DNLS',mess)
  endif
  if (sic_ctrlc()) iflag=-1
end subroutine mini_dnls
!
subroutine mini_siman(npar,x,value,ier)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>mini_siman
  use sic_adjust
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Driver routine for the Simulated Annealing
  !---------------------------------------------------------------------
  integer, intent(in) :: npar          ! Number of parameters
  real(kind=8), intent(in) :: x(npar)  ! Parameter values
  real(kind=8), intent(out) :: value   ! Resulting Chi2
  integer, intent(inout) :: ier        ! Error code
  ! Local
  real(8) :: y
  integer :: i
  logical :: error
  !
  ! From x to association module
  error = .false.
  do i=1,adj_n
    call from_internal(i,x(i),y)   !!BOUND : not obvious, the method is different here
    call sic_let_auto(adj_names(i),y,error)
  enddo
  !
  adj_ncall = adj_ncall+1
  call exec_subprogram (membyt(cur_exec),diff_expression,error)
  value = 0.d0
  do i = 1,ndata
    y = dvec(i)*wvec(i)
    value = value + y*y
  enddo
  if (sic_ctrlc()) ier = -1
end subroutine mini_siman
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine exec_subprogram (passed_function,command,error)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  external                        :: passed_function  !
  character(len=*)                :: command          !
  logical,          intent(inout) :: error            !
  !
  !! print *,command(1:len_trim(command))
  call passed_function(command,error)
  !! print *,'Error ',error
end subroutine exec_subprogram
!
subroutine get_formula(formula,fitexpr,darray,pdim,quiet,error)
  use gildas_def
  use sic_interfaces, except_this=>get_formula
  use sic_adjust
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Fit a given formula to a set of data points using the
  ! DNLS1E method form SLATEC (Modified Levenberg-Marquardt routine)
  !---------------------------------------------------------------------
  character(len=*) :: formula                ! Formula used for minimisation
  character(len=*) :: fitexpr                ! Formula used for minimisation
  type(sic_descriptor_t) :: darray           !
  integer :: pdim                            !
  logical :: quiet                           !
  logical :: error                           !
  ! Local
  character(len=*), parameter :: rname='ADJUST'
  integer, parameter :: mp=27,np=26
  character(len=formula_length) :: text,work
  character(len=32) :: cnum
  character(len=26), parameter :: alphab='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
  integer :: i,k,l,lw,nr
  !
  character(len=formula_length) :: funtext
  !
  ! Edit the formula string: from y=f(x) to y-(f(x)) ,
  ! and replace the placeholder &A ...&Z by the mfit array:
  !
  l = len_trim(formula)
  !
  funtext = formula
  pdim = 0
  !
  do i = 1, np
    write (cnum,'(A,A,I2.2,A1)') adj_root(1:adj_lroot),'%PAR[', pdim+1, ']'
    call replace_string(funtext(1:l),'&'//alphab(i:i),cnum,work,l,2,adj_lroot+8,k)
    funtext = work
    l = len_trim(funtext)
    if (k .ne. 0) pdim = pdim+1
  enddo
  if (pdim.eq.0) then
    call sic_message(seve%e,rname,'No fit parameter (&A ... &Z) found in formula.')
    error = .true.
    return
  endif
  !
  k = index(funtext,'=')
  if (k.ne.0) then
    k = k+1
    if (.not.quiet) then
      call sic_message(seve%i,rname,'Formula is :')
      call sic_message(seve%i,rname,funtext(k:l))
    endif
  else
    call sic_message(seve%e,rname,'No = sign found in formula.')
    error = .true.
    return
  endif
  !
  math_expression = funtext(k:l)
  lw = l-k+1
  call sic_def_char(adj_root(1:adj_lroot)//'%MATH',math_expression(1:lw),.true.,error)
  !
  ! Error detection:
  press_error = .false.
  !
  ! Create a variable to hold the fit solution, and the text to execute
  ! the command to calculate it. Return the 'Y' variable descriptor, too
  !
  call create_fitvar (funtext(1:k-2),adj_root(1:adj_lroot)//'%FIT',darray,error)
  fitexpr = 'LET '//adj_root(1:adj_lroot)//'%FIT = ' // funtext(k:l)
  !
  ! Edit the formula into the Difference form.
  !
  call replace_string(funtext, '=', '-(', text, l,1,2,nr)
  if (nr .ne. 1) then
    call  sic_message(seve%e,rname,'Error in syntax.')
    error = .true.
    return
  endif
  diff_expression = 'LET '//adj_root(1:adj_lroot)//'%RES = '//text(1:l+1) // ')'
end subroutine get_formula
!
subroutine txt_array(chain,ndim,values,default)
  use sic_interfaces, except_this=>txt_array
  !---------------------------------------------------------------------
  ! @ private
  ! Read a real array from a comma separated text string.
  ! Return the default in case of error.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: chain  ! Input chain (modified)
  integer, intent(in) :: ndim               ! Number of values
  real(4), intent(out) :: values(ndim)      ! Output values
  real(4), intent(in) :: default(ndim)      ! Default values
  ! Local
  integer :: lc
  integer :: i,k,n,j,l
  !
  lc = len_trim(chain)
  values = default
  !
  if (lc .gt. 0) then
    k = 0
    j = 1
    n = 1
    do i = 1, lc
      if (chain(i:i).eq.'"') chain(i:i) = ' '
      if (chain(i:i).eq.',') then
        l = i-j
        if (l.gt.0) values(n) = txt_real(chain(j:i-1), default(n))
        n = n + 1
        if (n.gt.ndim) return
        j = i + 1
      endif
    enddo
    l = lc-j
    if (l.ge.0) values(n) = txt_real(chain(j:lc), default(n))
  endif
end subroutine txt_array
!
function txt_real (text, default)
  !---------------------------------------------------------------------
  ! @ private
  ! Read a real variable from a text string. Return the default
  ! in case of error.
  !---------------------------------------------------------------------
  real :: txt_real                      !  Output value
  character(len=*), intent(in) :: text  !  Input string
  real(4), intent(in) :: default        !  Default value
  ! Local
  real(8) :: value
  integer :: ier, nt
  !
  nt=len_trim(text)
  !
  read (text(1:nt),*,iostat=ier) value
  if (ier.eq.0) then
    txt_real = value
  else
    txt_real = default
  endif
end function txt_real
!
subroutine create_fitvar (in,out,y_array,err)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>create_fitvar
  use sic_types
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Copy a SIC variable into R(8) array
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: in                 ! Input SIC variable name
  character(len=*), intent(in) :: out                ! Output DOUBLE variable
  type(sic_descriptor_t), intent(out) :: y_array     ! Output variable descriptor
  logical, intent(out) :: err                        ! Error flag
  ! Local
  character(len=*), parameter :: rname='MFIT'
  integer :: i,ier,ndata,memory(1)
  logical :: found
  type(sic_descriptor_t) :: d_array
  integer(kind=address_length) :: ip
  real(8), allocatable, save :: hvec(:)
  !
  err = .false.
  !
  ! Delete output variable, if it exists
  call sic_descriptor (out,d_array,found)
  if (found) then
    call sic_delvariable(out,.false.,err)    ! This is a Program request
    if (err) then
      call sic_message(seve%e,rname,'Protected target variable exists.')
      err = .true.
      return
    endif
  endif
  !
  found = .true.
  call sic_materialize(in,y_array,found)   ! Checked, allow transposition
  if (.not. found) then
    call sic_message(seve%e,rname,'Input Variable does not exist.')
    err = .true.
    return
  endif
  d_array = y_array
  d_array%readonly = .false.
  !
  ! Make a double-precision copy to hold the array. Do not forget to
  ! free the sic_materialization before leaving (see below).
  ! Note that SIC does not care about non-conformant array provided they have
  ! the same size, so do it simply...
  ndata = desc_nelem(d_array)
  if (allocated(hvec)) deallocate(hvec)
  allocate(hvec(ndata),stat=ier)
  !
  ! Get data type:
  ip = gag_pointer(d_array%addr,memory)
  if (d_array%type.eq.fmt_r4) then
    call r4tor8(memory(ip),hvec,ndata)
  else if (d_array%type.eq.fmt_r8) then
    call r8tor8(memory(ip),hvec,ndata)
  else
    call sic_message(seve%e,rname,'Variable type invalid in this context')
    err = .true.
  endif
  if (err) return
  !
  call sic_volatile(y_array)  ! Free the materialization (if relevant) now that
                              ! we have a copy
  !
  ! Now define variable
  call sic_def_dble(out,hvec,1,ndata,.false.,err)
  ! Now reset Y_ARRAY
  call sic_descriptor (out,y_array,found)
end subroutine create_fitvar
!
subroutine m_varcop (in,out,out_array,global,err)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_interfaces, except_this=>m_varcop
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Create a copy of a SIC variable
  !---------------------------------------------------------------------
  character(len=*) :: in                        ! Input variable name
  character(len=*) :: out                       ! Output variable name
  type(sic_descriptor_t) :: out_array           ! Output variable descriptor
  logical :: global                             ! Global status
  logical :: err                                ! Error flag
  ! Local
  character(len=*), parameter :: rname='MFIT'
  character(len=80) :: text
  character(len=6) :: wort
  integer :: ibyte,k
  logical :: found
  type(sic_descriptor_t) :: d_array
  !
  err = .false.
  !
  found = .true.
  call sic_materialize(in,d_array,found)   ! Checked, allow transposition
  if (.not. found) then
    call sic_message(seve%e,rname,'Variable to be copied does not exist.')
    err = .true.
    return
  endif
  d_array%readonly = .false.
  call sic_volatile(d_array)  ! Free descriptor
  !
  found = .true.
  call sic_descriptor (out,out_array,found)
  if (found) then
    call sic_delvariable(out,.false.,err)    ! This is a Program request
    if (err) then
      call sic_message(seve%e,rname,'Protected target variable exists.')
      return
    endif
  endif
  !
  ! Get data type:
  !
  if (d_array%type.gt.0) then
    write (wort,'(I6.6)') d_array%type
    text = 'DEFINE CHARACTER '//trim(out)//'*'//wort
    ibyte = 1
  else
    ibyte = 4
    if (d_array%type.eq.fmt_l )  text = 'DEFINE LOGICAL ' // out
    if (d_array%type.eq.fmt_i4)  text = 'DEFINE INTEGER ' // out
    if (d_array%type.eq.fmt_r4)  text = 'DEFINE REAL ' // out
    if (d_array%type.eq.fmt_r8) then
      text = 'DEFINE DOUBLE ' // out
      ibyte = 8
    endif
  endif
  !
  ! Get dimensions, and create the variables:
  !
  k = len_trim(text)+1
  if (global) then
    text(k:) = ' /GLOBAL /LIKE '//in
  else
    text(k:) = ' /LIKE '//in
  endif
  call sic_libr (text,err)
  if (err) return
  !
  ! Initialize it
  text = 'LET '//trim(out)//' = '//in
  call sic_libr (text,err)
  found = .true.
  call sic_descriptor (out,out_array,found)    ! Checked
end subroutine m_varcop
!
subroutine sic_libr(buffer,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_libr
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Execute a restricted set of SIC commands in "library" mode
  !   No commands with level change allowed here
  !---------------------------------------------------------------------
  character(len=*)                :: buffer  ! Command line
  logical,          intent(inout) :: error   ! Error flag
  ! Local
  character(len=commandline_length) :: line
  character(len=16) :: comm
  character(len=1), parameter :: backslash=char(92)
  integer :: nline
  !
  line = 'SIC'//backslash//buffer
  nline = len(line)
  call sic_blanc(line,nline)
  call sic_find(comm,line,nline,error)
  if (error)  return
  !
  if (comm.eq.'DEFINE') then
    call sic_define (line,nline,error)
  elseif (comm.eq.'LET') then
    call let_variable (line,nline,error)
  elseif (comm.eq.'EXAMINE') then
    call examine_variable(line,error)
  elseif (comm.eq.'COMPUTE') then
    call sic_compute (line,nline,error)
  else
    call sic_message(seve%e,'SIC',  &
       'Command '''//trim(comm)//''' not supported in this context')
    error = .true.
  endif
end subroutine sic_libr
!
subroutine replace_string (in,old,new,out,l1,l2,l3,nr)
  use sic_interfaces, except_this=>replace_string
  !---------------------------------------------------------------------
  ! @ private
  ! Replace occurrence of string OLD in IN by NEW and store the new string in
  ! OUT. String lengths for the input strings have to be provided.
  ! Number of replacements is returned in integer NR.
  !---------------------------------------------------------------------
  character(len=*) :: in            !
  character(len=*) :: old           !
  character(len=*) :: new           !
  character(len=*) :: out           !
  integer :: l1                     !
  integer :: l2                     !
  integer :: l3                     !
  integer :: nr                     !
  ! Local
  integer :: i,k
  !
  out = ' '
  nr  = 0
  if (l2 .gt. l1) then
    out(1:l1) = in(1:l1)
    return
  else
    k = 1
    i = 1
10  continue
    if (in(i:i+l2-1).eq.old(1:l2)) then
      out(k:k+l3-1) = new(1:l3)
      i  = i + l2
      k  = k + l3
      nr = nr + 1
    else
      out(k:k) = in(i:i)
      i = i + 1
      k = k + 1
    endif
    if (i .le. l1-l2+1) goto 10
    out(k:k+l2-2)=in(i:l1)
  endif
  !
end subroutine replace_string

subroutine solve_monitor(line,error)
  use gildas_def
  use gkernel_interfaces
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: m_mon
  integer(kind=address_length) :: ipx,ipy,ipw,ips,ipmon,data_mon
  !------------------------------------------------------------------------
  ! Code:
  ipx = gag_pointer(data_x,memory)
  ipy = gag_pointer(data_y,memory)
  ipw = gag_pointer(data_w,memory)
  ips = gag_pointer(data_s,memory)
  !
  ! just in case m_data has changed
  call get_first(.true.,error)
  !
  m_mon = m_data*8
  error = sic_getvm(m_mon,data_mon).ne.1
  if (error) goto 999
  ipmon = gag_pointer(data_mon,memory)
  call sub_solve_mon(m_data,m_boxes,memory(ipx),   &
    memory(ipy),memory(ipw),   &
    memory(ips), memory(ipmon+6*m_data),   &
    memory(ipmon),   &
    memory(ipmon+2*m_data), memory(ipmon+4*m_data),   &
    line,error)
  call free_vm(m_mon,data_mon)
  return
  !
999 error = .true.
  return
end subroutine solve_monitor
!
subroutine sub_solve_mon(md,mb,x_data,y_data,w_data,   &
    ind,wk1,xxx,yyy,www,line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  integer :: ind(md)                !
  real*8 :: wk1(3*md)               !
  real*8 :: xxx(md)                 !
  real*8 :: yyy(md)                 !
  real*8 :: www(md)                 !
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  logical :: gr8_random
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: nk, iy, iba, ib, i, l, l1, nn, nd
  integer :: n_br, k_br(10), ikn, nkn, j, ia
  real*8 :: cs(m_spl+4), ks(m_spl+8), rss, ss, sss
  real*8 :: xx(10*m_spl), yy(10*m_spl), xx1
  real*8 :: wk2(4*(m_spl+8)), wk3(2*m_pol)
  real*8 :: w0, xold, xnew
  real*8 :: apol(m_pol,m_pol), spol(m_pol), aa(m_pol)
  real :: x4, x2, y2, x3, y3, t_br(10), tkn(40), step
  logical :: plot, reset, poly, weight
  character(len=132) :: chain
  integer :: ipol, nt, old_pen
  real :: rms_err(mbox)
  real :: ymean, wmean
  save rms_err
  !------------------------------------------------------------------------
  ! Code:
  t_splmon = t_step
  old_pen = -1
  if (i_base(1).gt.mnbas) then
    call message(8,4,'SOLVE_PASS','Triangle mode not supported')
    error = .true.
  endif
  !
  poly = sic_present(9,0)
  ipol = 0
  if (poly) then
    call sic_i4(line,9,1,ipol,.false.,error)
    if (error) goto 999
    ipol = max(min(ipol+1,m_pol),1)    ! degree+1
  endif
  reset = sic_present(4,0)
  if (reset) then
    call reset_time
  endif
  !
  n_br = 0
  if (sic_present(8,0)) then
    i = 0
    do while (i.lt.sic_narg(8))
      n_br = n_br+1
      call sic_i4(line,8,i+1,k_br(n_br),.true.,error)
      if (error) goto 999
      k_br(n_br) = min(max(k_br(n_br),0),3)
      call sic_r4(line,8,i+2,t_br(n_br),.true.,error)
      if (error) goto 999
      i = i + 2
    enddo
  endif
  !
  call show_general('X',.false.,line,error)
  call show_general('Y',.false.,line,error)
  if (change_display) then
    ! plot all scans in index, sorted, plot buffer re-initialized.
    call read_data('ALL',.true.,.true., error)
    plotted = .false.
    if (error) goto 999
    change_display = .false.
  else
    plotted = .true.
  endif
  plot = sic_present(1,0)
  weight = sic_present(2,0)
  if (plot) then
    clear = .true.
    if (.not. plotted) call sub_plot('A',.false.,.false.,0,error)
    if (error) goto 999
    plotted = .true.
    old_pen = gr_spen (1)
    call gr_segm('FIT',error)
  endif
  !
  ! Loop on boxes
  do ib = 1, n_boxes
    iy = i_y(k_y(ib))
    iba = i_base(k_base(ib))
    ia = -iba
    if (n_data(ib).eq.0) then
      call message(4,3,'SOLVE_MONITOR','No data in that box')
      goto 200
    elseif (i_x(k_x(ib)).ne. xy_time) then
      call message(4,2,'SOLVE_MONITOR','X axis should be Time')
      goto 200
    elseif (iy.ne.xy_atm_pow) then
      call message(4,2,'SOLVE_MONITOR',   &
        'Y axis should be Atmospheric Power')
      goto 200
    elseif (iba.gt.0) then
      call message(4,2,'SOLVE_MONITOR',   &
        'Use an antenna plot (SET ANTENNA)')
      goto 200
    endif
    nkn = 0
    if (n_br.gt.0) then
      do i=1, n_br
        do j=1,4-k_br(i)
          nkn = nkn + 1
          tkn(nkn) = t_br(i)
        enddo
      enddo
    endif
    w0 = 0
    !
    ! Load arrays for fitting, ignoring blanked values.
    nd = 0
    ymean = 0
    wmean = 0
    do i=1, n_data(ib)
      if (y_data(i,ib) .ne. blank4 .and.   &
        w_data(i,ib).gt.0) then
        nd = nd+1
        xxx(nd) = x_data(i,ib)
        yyy(nd) = y_data(i,ib)
        ! The MTH_FITPOL routine requires 1/sigma values
        if (w0.eq.0) w0 = sqrt(w_data(i,ib))
        if (weight) then
          www(nd) = sqrt(w_data(i,ib))
        else
          www(nd) = w0
        endif
        ymean = ymean+yyy(nd)+www(nd)
        wmean = wmean+www(nd)
      endif
    enddo
    if (nd.eq.0) goto 200
    if (wmean.gt.0) ymean = ymean / wmean
    !
    if (.not.poly .and. nd.eq.3) then
      y2 = yyy(2)-yyy(1)
      y3 = yyy(3)-yyy(1)
      x2 = xxx(2)-xxx(1)
      x3 = xxx(3)-xxx(1)
      xxx(4) = (xxx(3)+xxx(2))/2
      x4 = xxx(4)-xxx(1)
      yyy(4) = yyy(1) + x4**2*(y2/x2-y3/x3)/(x2-x3)   &
        + x4*(y3*x2/x3-y2*x3/x2)/(x2-x3)
      www(4) = (www(3)+www(2))/2
      nd = 4
    elseif (.not. poly .and. nd.eq.2) then
      y2 = yyy(2)-yyy(1)
      x2 = xxx(2)-xxx(1)
      xxx(3) = xxx(2)-x2/3
      xxx(4) = xxx(1)+x2/3
      yyy(3) = yyy(2)-y2/3
      yyy(4) = yyy(1)+y2/3
      www(3) = www(2)
      www(4) = www(1)
      nd = 4
    elseif (nd.eq.1) then
      xxx(2) = xxx(1)+0.01
      xxx(3) = xxx(1)+0.02
      xxx(4) = xxx(1)-0.01
      yyy(2) = yyy(1)
      yyy(3) = yyy(1)
      yyy(4) = yyy(1)
      www(2) = www(1)
      www(3) = www(1)
      www(4) = www(1)
      nd = 4
    endif
    sss = 0
    do i=1, nd
      sss = sss + www(i)**2
    enddo
    ! Sort if required
    if (gr8_random(xxx,nd)) then
      call gr8_trie(xxx,ind,nd,error)
      if (error) goto 999
      call gr8_sort(yyy,wk1,ind,nd)
      call gr8_sort(www,wk1,ind,nd)
    endif
    ! Set knots
    if (.not. poly) then
      xold = xxx(1)
      ikn = 0
      nk = 0
      do while (xold.lt.xxx(nd))
        if (ikn.eq.nkn) then
          xnew = xxx(nd)
        elseif (nk.lt.m_spl) then
          ikn = ikn + 1
          xnew = tkn(ikn)
          nk = nk+1
          ks(nk+4) = tkn(ikn)
        else
          call message(8,3,'SOLVE_MONITOR',   &
            'Too many knots for this spline')
          error = .true.
          return
        endif
        nt = (xnew-xold)/t_splmon
        nt = min(nt, m_spl-nk, nd-4)
        if (nt.gt.0) then
          step = (xnew-xold)/(nt+1)
          if (nk+nt.gt.m_spl) then
            call message(8,3,'SOLVE_MONITOR',   &
              'Too many knots for this spline')
            error = .true.
            return
          endif
          do i=1, nt
            ks(nk+i+4) = xold + i*step
          enddo
          nk = nk + nt
        endif
        xold = xnew
      enddo
      if (nk.gt.0) call gr8_trie(ks(5:),ind,nk,error)
      if (error) goto 999
      !		write(*,*) 'knots ',nk
      !		if (nk.gt.0) write(*,*) (ks(i),i=5,nk+4)
      call mth_fitspl ('SOLVE_MONITOR', nd, nk+8, xxx,   &
        yyy, www, ks, wk1, wk2, cs, ss, error)
      if (error) goto 999
      rss = sqrt(ss/sss)/ymean
    else
      ipol = min(ipol,nd)
      call mth_fitpol('SOLVE_MONITOR',nd,ipol,m_pol,   &
        xxx,yyy,www,wk1,wk3,apol,spol,error)
      if (error) goto 999
      rss = sqrt(sss/nd)       ! rms obtenu
      rss = spol(ipol)/rss/ymean
    endif
    ! display results
l = min(lenc(y_label(ib)),5)
    l1 = lenc(header_1(ib))
    rms_err(ib) = rss
    write(chain,1000) y_label(ib)(1:3), header_1(ib)(1:l1),rss
1000 format(a,'. ',a,' rms: ',1pg10.3)
    call message(6,1,'SOLVE_MONITOR',chain(1:lenc(chain)))
    if (plot) then
      nn = 10.*m_spl
      step = (gb2_x(ib)-gb1_x(ib)) / (nn-1)
      if (step.eq.0) step = 0.1
      if (poly) then
        do i=1, ipol
          aa(i) = apol(ipol,i)
        enddo
      endif
      do i=1, nn
        xx(i) = gb1_x(ib) + (i-1) * step
        if (.not.poly) then
          xx1 = min(xx(i),ks(nk+5))
          xx1  = max(xx1,ks(4))
          call mth_getspl('SOLVE_MONITOR',   &
            nk+8, ks, cs, xx1, yy(i), error)
          if (error) goto 999
        else
          xx1 = min(max(xx(i),xxx(1)),xxx(nd))
          xx1 = ((xx1-xxx(1))-(xxx(nd)-xx1))   &
            /(xxx(nd)-xxx(1))
          call mth_getpol('SOLVE_MONITOR',   &
            ipol,aa,xx1,yy(i),error)
          if (error) goto 999
        endif
      enddo
      write(chain,'(I4.4)') ib
      call gr_execl('CHANGE DIRECTORY BOX'//chain)
      error = gr_error()
      if (error) goto 999
      call gr8_connect (nn,xx,yy,0.0d0,-1.0d0)
      call gr_execl('CHANGE DIRECTORY')
    endif
    !
    ! Save results
    if (.not.poly) then
      n_splmon(ia) = nk
      do i=1, nk+8
        k_splmon(i,ia) = ks(i) ! in hours
      enddo
      do i=1, nk+4
        c_splmon(i,ia) = cs(i)
      enddo
      rms_splmon(ia) = rss
      f_splmon(ia) = 1
      f_polmon(ia) = 0
    else
      n_polmon(ia) = ipol
      do i=1, ipol
        c_polmon(i,ia) = apol(ipol,i)
      enddo
      t_polmon(1,ia) = xxx(1)
      t_polmon(2,ia) = xxx(nd)
      rms_polmon(ia) = rss
      f_polmon(ia) = 1
      f_splmon(ia) = 0
    endif
    !
200 continue
  enddo
  call sic_delvariable ('RMS_ATM',.false.,error)
  error = .false.
  call sic_def_real ('RMS_ATM',rms_err,1,n_boxes,.false.,error)
  error = .false.
998 continue
  if (old_pen.ne.-1)  then
    call gr_segm_close(error)
    i = gr_spen(old_pen)
  endif
  return
  !
999 error = .true.
  goto 998
end subroutine sub_solve_mon

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_noise_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_consistency_types
  use cubetools_structure
  !
  public :: noise_t,noise_user_t,noise_cons_t,noise_opt_t
  public :: cubetools_array_noise2userstruct
  !
  public :: cubetools_noise_init,cubetools_noise_get_and_derive
  public :: cubetools_noise_final,cubetools_noise_put
  public :: cubetools_noise_list,cubetools_noise_sicdef,cubetools_noise_copy
  public :: cubetools_noise_consistency_init,cubetools_noise_consistency_final
  public :: cubetools_noise_consistency_check,cubetools_noise_consistency_list
  private
  !
  type noise_t
     real(kind=sign_k) :: sigma = 0.0
     real(kind=sign_k) :: rms  = 0.0
  end type noise_t
  !
  type noise_opt_t
     type(option_t), pointer :: opt
   contains
     procedure :: register  => cubetools_noise_register
     procedure :: parse     => cubetools_noise_parse
     procedure :: user2prog => cubetools_noise_user2prog
  end type noise_opt_t
  !
  type noise_user_t
     character(len=argu_l) :: sigma = strg_unk ! [ ] Theoretical noise
     character(len=argu_l) :: rms   = strg_unk ! [ ] Measured noise
     logical               :: do    = .false.  ! Option was present
  end type noise_user_t
  !
  type noise_cons_t
     logical                  :: check=.true.    ! Check the section
     logical                  :: prob =.false.   ! Is there a problem
     logical                  :: mess =.true.    ! Output message for this section?
     type(consistency_desc_t) :: sigma
     type(consistency_desc_t) :: rms
  end type noise_cons_t
contains
  !
  subroutine cubetools_noise_init(noise,error)
    !-------------------------------------------------------------------
    ! Just initialize the type
    !-------------------------------------------------------------------
    type(noise_t), intent(out)   :: noise
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_noise_init
  !
  subroutine cubetools_noise_get_and_derive(sigma,rms,noi,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    real(kind=sign_k), intent(in)    :: sigma
    real(kind=sign_k), intent(in)    :: rms
    type(noise_t),     intent(inout) :: noi
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='GENERAL>GET>AND>DERIVE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    noi%sigma = sigma
    noi%rms   = rms
  end subroutine cubetools_noise_get_and_derive
  !
  subroutine cubetools_noise_put(noi,sigma,rms,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(noise_t),     intent(in)    :: noi
    real(kind=sign_k), intent(out)   :: sigma
    real(kind=sign_k), intent(out)   :: rms
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>PUT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    sigma = noi%sigma
    rms   = noi%rms
  end subroutine cubetools_noise_put
  !
  subroutine cubetools_noise_final(noise,error)
    !-------------------------------------------------------------------
    !  Just reinitialize the type
    !-------------------------------------------------------------------
    type(noise_t), intent(out)   :: noise
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_noise_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_noise_register(noise,abstract,error)
    !----------------------------------------------------------------------
    ! Register a /NOISE option under a given name and abstract
    !----------------------------------------------------------------------
    class(noise_opt_t), intent(out)   :: noise
    character(len=*),   intent(in)    :: abstract
    logical,            intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    !
    character(len=*), parameter :: rname='NOISE>REGISTER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'NOISE','sigma rms',&
         abstract,&
         strg_emp, &
         noise%opt,error)
    if (error) return
    call stdarg%register( &
         'SIGMA',  &
         'Theoretical noise', &
         '"*" or "=" mean previous value is kept',&
         code_arg_mandatory, &
         error)
    if (error) return
    call stdarg%register( &
         'RMS',  &
         'Measured noise', &
         '"*" or "=" mean previous value is kept',&
         code_arg_mandatory, &
         error)
    if (error) return
  end subroutine cubetools_noise_register
  !
  subroutine cubetools_noise_parse(noise,line,user,error)
    !----------------------------------------------------------------------
    ! Parse noise
    ! /NOISE major [minor [pang [pangunit]]]
    ! ----------------------------------------------------------------------
    class(noise_opt_t), intent(in)    :: noise
    character(len=*),   intent(in)    :: line
    type(noise_user_t), intent(inout) :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>PARSE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    user%sigma = strg_star
    user%rms   = strg_star
    !
    call noise%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,noise%opt,1,user%sigma,mandatory,error)
       if (error) return
       call cubetools_getarg(line,noise%opt,2,user%rms,mandatory,error)
       if (error) return
    endif
  end subroutine cubetools_noise_parse
  !
  subroutine cubetools_noise_user2prog(noise,user,prog,error)
    use cubetools_unit
    use cubetools_user2prog
    !----------------------------------------------------------------------
    ! Resolves a noise description based on a previous one according to
    ! user inputs.
    !----------------------------------------------------------------------
    class(noise_opt_t), intent(in)    :: noise
    type(noise_user_t), intent(in)    :: user
    type(noise_t),      intent(inout) :: prog
    logical,            intent(inout) :: error
    !
    type(unit_user_t) :: userunit
    real(kind=sign_k) :: default,previous
    character(len=*), parameter :: rname='NOISE>USER2PROG'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (user%do) then
       call userunit%get_from_code(code_unit_unk,error)
       if (error) return
       !
       default = prog%sigma
       previous = prog%sigma
       call cubetools_user2prog_resolve_all(user%sigma,userunit,default,previous,prog%sigma,error)
       if (error) return
       if (prog%sigma.lt.0.) then
          call cubeheader_message(seve%e,rname,'Theoretical noise can not be negative')
          error = .true.
          return
       endif
       default = prog%rms
       previous = prog%rms
       call cubetools_user2prog_resolve_all(user%rms,userunit,default,previous,prog%rms,error)
       if (error) return
       if (prog%rms.lt.0.) then
          call cubeheader_message(seve%e,rname,'Measured noise can not be negative')
          error = .true.
          return
       endif
    else ! .not.user%do
       continue
    endif
  end subroutine cubetools_noise_user2prog
  !
  subroutine cubetools_noise_prog2user(prog,user,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(noise_t),      intent(in)    :: prog
    type(noise_user_t), intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>PROG2USER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    write(user%sigma,'(1pg14.7)') prog%sigma
    write(user%rms,  '(1pg14.7)') prog%rms
  end subroutine cubetools_noise_prog2user
  !
  subroutine cubetools_array_noise2userstruct(prog,userstruct,error)
    use cubetools_userspace
    use cubetools_userstruct
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(noise_t),      intent(in)    :: prog
    type(userstruct_t), intent(inout) :: userstruct
    logical,            intent(inout) :: error
    !
    type(noise_user_t) :: user
    character(len=*), parameter :: rname='ARRAY>NOISE2USERSTRUCT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_noise_prog2user(prog,user,error)
    if (error) return
    call userstruct%def(error)
    if (error) return
    call userstruct%set_member('sigma',user%sigma,error)
    if (error) return
    call userstruct%set_member('rms',user%rms,error)
    if (error) return
  end subroutine cubetools_array_noise2userstruct
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_noise_list(noise,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(noise_t), intent(in)    :: noise
    logical,       intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='NOISE>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    mess = cubetools_format_stdkey_boldval('Sigma',noise%sigma,'f15.8',22)
    mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('RMS',noise%rms,'f15.8',22)
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_noise_list
  !
  subroutine cubetools_noise_sicdef(name,noise,readonly,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    type(noise_t),    intent(in)    :: noise
    logical,          intent(in)    :: readonly
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>SICDEF'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call sic_defstructure(name,global,error)
    if (error) return
    call sic_def_real(trim(name)//'%sigma',noise%sigma,0,0,readonly,error)
    if (error) return
    call sic_def_real(trim(name)//'%rms',noise%rms,0,0,readonly,error)
    if (error) return
  end subroutine cubetools_noise_sicdef
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_noise_copy(in,ou,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(noise_t), intent(in)    :: in
    type(noise_t), intent(out)   :: ou
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>COPY'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    ou = in
  end subroutine cubetools_noise_copy
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_noise_consistency_init(cons,error)
    !-------------------------------------------------------------------
    ! Init the consistency between noise sections
    !-------------------------------------------------------------------
    type(noise_cons_t), intent(out)   :: cons
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>NOISE>CONSISTENCY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_init(strict,check,mess,cons%sigma,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%rms,error)
    if (error) return
    !
  end subroutine cubetools_noise_consistency_init
  !
  subroutine cubetools_noise_consistency_check(cons,noise1,noise2,error)
    !-------------------------------------------------------------------
    ! Check the consistency between noise sections
    !-------------------------------------------------------------------
    type(noise_cons_t), intent(inout) :: cons
    type(noise_t),      intent(in)    :: noise1
    type(noise_t),      intent(in)    :: noise2
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>NOISE>CONSISTENCY>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = .false.
    call cubetools_consistency_real_check(cons%sigma,noise1%sigma,noise2%sigma,error)
    if (error) return
    call cubetools_consistency_real_check(cons%rms,noise1%rms,noise2%rms,error)
    if (error) return
    !
    cons%prob = cons%sigma%prob.or.cons%rms%prob
  end subroutine cubetools_noise_consistency_check
  !
  subroutine cubetools_noise_consistency_list(unit1,unit2,cons,noise1,noise2,error)
    !-------------------------------------------------------------------
    ! List the consistency between noise sections
    !-------------------------------------------------------------------
    character(len=*),   intent(in)    :: unit1
    character(len=*),   intent(in)    :: unit2
    type(noise_cons_t), intent(in)    :: cons
    type(noise_t),      intent(in)    :: noise1
    type(noise_t),      intent(in)    :: noise2
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>NOISE>CONSISTENCY>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess.or..not.cons%prob) return
    !
    if (.not.cons%mess) return
    !
    call cubetools_consistency_title('noises',3,cons%check,cons%prob,error)
    if (error) return
    if (cons%check.and.cons%prob) then
       call cubetools_consistency_real_print('Sigmas',unit1,unit2,cons%sigma,noise1%sigma,noise2%sigma,error)
       if (error) return
       call cubetools_consistency_real_print('RMS',unit1,unit2,cons%rms,noise1%rms,noise2%rms,error)
       if (error) return
    endif
    call cubeheader_message(seve%r,rname,'')
  end subroutine cubetools_noise_consistency_list
  !
  subroutine cubetools_noise_consistency_final(cons,error)
    !-------------------------------------------------------------------
    ! Final the consistency between noise sections
    !-------------------------------------------------------------------
    type(noise_cons_t), intent(out)   :: cons
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>NOISE>CONSISTENCY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_final(cons%sigma,error)
    if (error) return
    call cubetools_consistency_final(cons%rms,error)
    if (error) return
    !
  end subroutine cubetools_noise_consistency_final
end module cubetools_noise_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine decode_header (iw)
  use gkernel_interfaces
  use phys_const
  use classic_api  
  use clic_file
  use clic_title
  integer :: iw(*)                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'clic_proc_par.inc'
  ! Local
  integer :: k, j, l, m, natfac, temp_dim, ia, ib, ii, mask
  integer :: saflag(mnant),sbflag(mnbas),dummy
  character(len=12) :: ch
  logical :: error
  real :: dellin(m_pol_rec,mnant,2), delay(m_pol_rec,mnant)
  logical, save :: warned = .false.
  !------------------------------------------------------------------------
  ! CODE:
  !      print *, '========================decode header ! r_kind ', r_kind
  call r4tor4 (iw,dh_dump,3)
  k = 4
  !
  !      call r8tor8 (iw(k),dh_utc,4)
  ! Use an R4TOR4 call to avoid mis-aligned problems
  call r4tor4 (iw(k),dh_utc,8)
  k = k + 8
  if (de%version.le.2) then
    call r4tor4 (iw(k),dh_test0,10)
    k = k + 10
  else
    call r4tor4 (iw(k),dh_test0,20)
    k = k + 20
  endif
  call r4tor4 (iw(k),dh_aflag,r_nant)
  k = k + r_nant
  !     RL: first ngrx data had r_npol_rec=2, but only 1 totalpower.
  if (de%version.le.3) then
    if (new_receivers) then
      if (r_dobs.lt.(-6406)) then    ! changed the 13/02/2007
        temp_dim = r_npol_rec + r_nband_widex
      else
        temp_dim = 2 + r_nband_widex
      endif
      do ia=1, r_nant
        call r4tor4 (iw(k),dh_total(1,ia),temp_dim)
        k = k + temp_dim
      enddo
    else
      do ia=1, r_nant
        call r4tor4 (iw(k),dh_total(1,ia),1)
        call r4tor4 (iw(k),dh_total(2,ia),1)
        k = k + 1
      enddo
    endif
  else
    do ia=1, r_nant
      call r4tor4 (iw(k),dh_total(1,ia),r_nbb)
      k = k + r_nbb 
    enddo
  endif
  !      print *, 'crall : dh_total ',dh_total
  !
  !     RL: first ngrx data had only 1 dh_atfac, with no sub-band
  !     dependence; make sure this work with the subbands.
  if (de%version.le.3) then
    if (new_receivers) then
      natfac = max(r_npol_rec, r_lband)
    else
      natfac = 1
    endif
    do ia=1, r_nant
      do j=1, 2
        call r4tor4 (iw(k),dh_atfac(1,j,ia),natfac)
        ! this is needed for old data (RL 2007-03-19)
        if (natfac.eq.1 .and. r_lband.gt.1) then
          do l=2, r_lband
            dh_atfac(l,j,ia) = dh_atfac(1,j,ia)
          enddo
        endif
        k = k + natfac
      enddo
    enddo
  else
    do ia=1, r_nant
      do j=1, 2
        call r4tor4(iw(k),dh_atfac(1,j,ia),r_nbb)
        k = k + r_nbb
      enddo
    enddo
  endif
  call r4tor4 (iw(k),dh_rmspe,2*r_nant)
  k = k + 2*r_nant
  if (de%version.le.2) then
    call r4tor4 (iw(k),dh_delcon,r_nant)
    k = k + r_nant
  endif
  !     RL: first ngrx data had r_npol_rec=2, but only 1 dh_dellin.
  if (de%version.le.3) then
    !
    ! Was coded as (m_pol_rec,mnant,2)
    if (r_nband_widex.ne.0) then
      temp_dim = 2
    else
      temp_dim = 1
    endif
    do ia=1, r_nant
      do j = 1, temp_dim
         call r4tor4 (iw(k),dellin(1,ia,j),r_npol_rec)
         k = k + r_npol_rec
      enddo
    enddo
    ! 
    ! Convert it in v4
    do ia=1, r_nant
      do j=1, r_nbb
        ii = r_mapbb(j)
        l  = r_mappol(ia,j)
        !
        ! BB 1 and 2 connected to first correlator, 3 to 6 to second correlator
        if (ii.le.2) then        
          dh_dellin(ii,ia) = dellin(l,ia,1)
        else
          dh_dellin(ii,ia) = dellin(l,ia,2)
        endif
      enddo
    enddo    
  else 
    do ia=1, r_nant
      call r4tor4(iw(k),dh_dellin(1,ia),r_nbb)
      k = k + r_nbb
    enddo
  endif
  call r4tor4 (iw(k),dh_delayc,r_nant)
  k = k + r_nant
  !     RL: first ngrx data had r_npol_rec=2, but only 1 dh_delay.
  if (de%version.le.3) then
    if (new_receivers) then
      do ia=1, r_nant
        call r4tor4 (iw(k),delay(1,ia),r_npol_rec)
        k = k + r_npol_rec
      enddo
    else
      do ia=1, r_nant
        call r4tor4 (iw(k),delay(1,ia),1)
        call r4tor4 (iw(k),delay(2,ia),1)
        k = k + 1
      enddo
    endif
    ! 
    ! Convert it in v4
    do ia=1, r_nant
      do j=1, r_nbb
        ii = r_mapbb(j)
        l  = r_mappol(ia,j)
        dh_delay(ii,ia) = delay(l,ia)
      enddo
    enddo 
  else
    do ia=1, r_nant
      call r4tor4(iw(k),dh_delay(1,ia),r_nbb)
      k = k + r_nbb
    enddo
  endif
  call r4tor4 (iw(k),dh_phasec,r_nant)
  k = k + r_nant
  call r4tor4 (iw(k),dh_phase,r_nant)
  k = k + r_nant
  call r4tor4 (iw(k),dh_ratec,r_nant)
  k = k + r_nant
  call r4tor4 (iw(k),dh_cable,r_nant)
  k = k + r_nant
  if (de%version.le.2) then
    call r4tor4 (iw(k),dh_gamme,r_nant)
    k = k + r_nant
  endif
  if (de%version.le.2) then
    do ia=1, r_nant
      call r4tor4 (iw(k),dh_test1(1,ia),5)
      k = k + 5
    enddo
  else
    call r4tor4 (iw(k),dh_test1,20*r_nant)
    k = k + 20*r_nant
  endif
  ! RL: first ngrx data had r_npol_rec=2, but only 1 dh_rmsamp/pha.
  if (new_receivers) then
    do ia=1, r_nbas
      do j=1, 2
        call r4tor4 (iw(k),dh_rmsamp(1,j,ia),r_npol_rec)
        k = k + r_npol_rec
      enddo
    enddo
    do ib=1, r_nbas
      do j=1, 2
        call r4tor4 (iw(k),dh_rmspha(1,j,ib),r_npol_rec)
        k = k + r_npol_rec
      enddo
    enddo
  else
    call r4tor4 (iw(k),dh_rmsamp,2*r_nbas)
    k = k + 2*r_nbas
    call r4tor4 (iw(k),dh_rmspha,2*r_nbas)
    k = k + 2*r_nbas
  endif
  call r4tor4 (iw(k),dh_offfoc,r_nant)
  k = k + r_nant
  call r4tor4 (iw(k),dh_offlam,r_nant)
  k = k + r_nant
  call r4tor4 (iw(k),dh_offbet,r_nant)
  k = k + r_nant
  !
  ! Patch for mosaics observed:
  ! - between 01-jun-2018 and 18-jun-2018
  ! - on 18-sep-2018
  ! - between 05-may-2019 and 21-may-2019
  ! - between 18-sep-2020 and 04-oct-2020
  ! - between 03-may-2021 and 30-jun-2021
  ! - on 03-feb-2022
  ! - between 05-aug-2022 and 21-aug-2022
  ! - between 16-oct-2023 and 24-oct-2023
  if (((r_proc.eq.p_source).and.                       &
       (title%off1.ne.0).or.(title%off2.ne.0))  .and. &
      (((r_dobs.ge.-2279).and.(r_dobs.le.-2266)).or.  & 
       ((r_dobs.eq.-2170))                      .or.  & 
       ((r_dobs.ge.-2279).and.(r_dobs.le.-2266)).or.  & 
       ((r_dobs.ge.-1941).and.(r_dobs.le.-1925)).or.  & 
       ((r_dobs.ge.-1439).and.(r_dobs.le.-1423)).or.  & 
       ((r_dobs.gt.-1212).and.(r_dobs.lt.-1154)).or.  & 
       ((r_dobs.eq.-936))                       .or.  & 
       ((r_dobs.ge.-753).and.(r_dobs.le.-737))  .or.  &
       ((r_dobs.ge.-316).and.(r_dobs.le.-309)))) then   
     if (.not.warned) then
       call message(8,1,'RRECORD',&
         'Patching mosaic data for a known acquisition problem')
       warned = .true.
     endif
     do ia=1,r_nant
       dh_offlam(ia) = title%off1*sec_per_rad
       dh_offbet(ia) = title%off2*sec_per_rad
     enddo
  endif
  call r4tor4 (iw(k),dh_bflag,r_nbas)
  k = k + r_nbas
  call r4tor4 (iw(k),dh_uvm,2*r_nbas)
  k = k + 2*r_nbas
  if (de%version.le.2) then
    call r4tor4 (iw(k),dh_infac,4*r_nbas)
    k = k + 4*r_nbas
  endif
  call r4tor4 (iw(k),dh_wvr,mwvrch*r_nant)
  k = k + mwvrch*r_nant
  call r4tor4 (iw(k),dh_wvrstat,r_nant)
  k = k + r_nant
  if (new_receivers) then
    if (de%version.le.3) then
      do ii = 1, r_lband
        do j = 1, r_nant
          call r4tor4 (iw(k),dh_actp(1,j,ii),r_npol_rec)
          k = k + r_npol_rec
        enddo
      enddo
    endif
    do j=1, r_nant
      call r4tor4 (iw(k),dh_anttp(1,j),r_nif)
      k = k + r_nif
    enddo
  endif
  if (de%version.le.3) then
    if (r_nband_widex.ne.0) then
        call w4tow4 (iw(k),saflag,r_nant)
        k = k + r_nant
        call w4tow4 (iw(k),sbflag,r_nbas)
        k = k + r_nbas
    else
        ! Copy spectral flags to dh_saflag and clear corresponding bits
        do ia = 1, r_nant
           saflag(ia) = 0
           do ii=1, 10
              mask = 0 
              mask = iand(dh_aflag(ia),ior(mask,ishft(1,ii-1)))
              if (mask.ne.0) then
                saflag(ia) = ibset(saflag(ia),ii-1) 
                dh_aflag(ia) = ibclr(dh_aflag(ia),ii-1)
              endif
           enddo
           do ii=1,8
              mask = 0
              mask = iand(dh_aflag(ia),ior(mask,ishft(1,ii+9)))
              if (mask.ne.0) then
                saflag(ia) = ibset(saflag(ia),ii+mbands-1) 
                dh_aflag(ia) = ibclr(dh_aflag(ia),ii+9) 
              endif
           enddo
        enddo
        do ib = 1, r_nbas
           sbflag(ib) = 0
           do ii=1, 10
              mask = 0
              mask = iand(dh_bflag(ib),ior(mask,ishft(1,ii-1)))
              if (mask.ne.0) then
                sbflag(ib) = ibset(sbflag(ib),ii-1)
                dh_bflag(ib) = ibclr(dh_bflag(ib),ii-1)
              endif
           enddo
           do ii=1,8
              mask = 0
              mask = iand(dh_bflag(ib),ior(mask,ishft(1,ii+9)))
              if (mask.ne.0) then
                sbflag(ib) = ibset(sbflag(ib),ii+mbands-1)
                dh_bflag(ib) = ibclr(dh_bflag(ib),ii+9)
              endif
           enddo
        enddo
    endif
    !
    ! With version le 3, spectral flags on one word
    dh_saflag = .false.
    do ia = 1, r_nant
      is_saflag(ia) =.false.
      do ii = 1, 16
         if (btest(saflag(ia),ii-1)) then
           dh_saflag(ii,ia) = .true.
           is_saflag(ia) = .true.
         endif
         if (btest(saflag(ia),ii+15)) then
           dh_saflag(ii+mbands,ia) = .true.
           is_saflag(ia) = .true.
         endif
      enddo
    enddo
    dh_sbflag = .false.
    do ib = 1, r_nbas
      is_sbflag(ib) =.false.
      do ii = 1, 16
         if (btest(sbflag(ib),ii-1)) then
           dh_sbflag(ii,ib) = .true.
           is_sbflag(ib) =.true.
         endif
         if (btest(sbflag(ib),ii+15)) then
           dh_sbflag(ii+mbands,ib) = .true.
           is_sbflag(ib) =.true.
         endif
      enddo
    enddo
  else
    dh_saflag = .false.
    do ia=1, r_nant
      l = 0
      do j=1, r_nword
        call i4toi4(iw(k),dummy,1)
        k = k+1
        do m=1, 32
          l = l+1
          if (btest(dummy,m-1).and.l.le.r_lband) then
            dh_saflag(l,ia) = .true.
            is_saflag(ia) = .true.
          endif
        enddo
      enddo 
    enddo
    do ia=1, r_nant
      l = 0
      do j=1, r_nword
        call i4toi4(iw(k),dummy,1)
        k = k+1
        do m=1, 32
          l = l+1
          if (btest(dummy,m-1).and.l.le.r_lband) then
            dh_saflag(l+mbands,ia) = .true.
            is_saflag(ia) = .true.
          endif
        enddo
      enddo 
    enddo
    dh_sbflag = .false.
    do ib=1, r_nbas
      l = 0
      do j=1, r_nword
        call i4toi4(iw(k),dummy,1)
        k = k+1
        do m=1, 32
          l = l+1
          if (btest(dummy,m-1).and.l.le.r_lband) then
            dh_sbflag(l,ib) = .true.
            is_sbflag(ib) = .true.
          endif
        enddo
      enddo 
    enddo
    do ib=1, r_nbas
      l = 0
      do j=1, r_nword
        call i4toi4(iw(k),dummy,1)
        k = k+1
        do m=1, 32
          l = l+1
          if (btest(dummy,m-1).and.l.le.r_lband) then
            dh_sbflag(l+mbands,ib) = .true.
            is_sbflag(ib) = .true.
          endif
        enddo
      enddo 
    enddo
  endif
  if (de%version.ge.3) then
    call r4tor4(iw(k),dh_cable_alternate,r_nant)
    k = k + r_nant
    call r4tor4(iw(k),dh_ntime,1)
    k = k + 1 
    if (dh_ntime.gt.0) then
      call r4tor4(iw(k),dh_time_monitoring,dh_ntime)
      k = k + dh_ntime
    endif
    do j = 1, 2
      call r4tor4(iw(k),dh_incli(1,j),r_nant)
      k = k + r_nant
    enddo
    call r4tor4(iw(k),dh_incli_temp,r_nant)
    k = k + r_nant
    do j = 1, 3
      call r4tor4(iw(k),dh_tilfoc(1,j),r_nant)
      k = k + r_nant
    enddo
    do j = 1, 2
      call r4tor4(iw(k),dh_offfoc_xy(1,j),r_nant)
      k = k + r_nant
    enddo    
  else
    do j=1, r_nant
      call r4tor4(dh_test1(3,j),dh_cable_alternate(j),1)
    enddo
    dh_ntime = 4
    call r4tor4(dh_test0,dh_time_monitoring,dh_ntime)
  endif
  if (de%version.ge.6) then
    if (r_nant_vlbi.gt.0) then
      call r4tor4(iw(k),dh_vlbi_phaseff,r_nbb)
      k = k + r_nbb
      do j=1, r_nbb
        call r4tor4(iw(k),dh_vlbi_phase_tot(1,j),r_nant)
        k = k + r_nant
      enddo
      do j=1, r_nbb
        call r4tor4(iw(k),dh_vlbi_phase_inc(1,j),r_nant)
        k = k + r_nant
      enddo
    else
      dh_vlbi_phaseff = 0
      dh_vlbi_phase_inc = 0
      dh_vlbi_phase_tot = 0
    endif
  else
    dh_vlbi_phaseff = 0
    dh_vlbi_phase_inc = 0
    dh_vlbi_phase_tot = 0
  endif
!        print *, '=========== end decode_header  k= ',k
  !
  call datec(dh_obs,dh_date,error)
  call sexag(ch,dh_utc*pi/43200.,24)
  dh_time = ch(1:12)
end subroutine decode_header
!
subroutine encode_header(iw)
  use classic_api  
  use clic_file
  integer :: iw(*)                  !
  ! Global
  include 'clic_parameter.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: ii, j, k, l, natfac, temp_dim, ia, ib
  integer :: saflag(mnant),sbflag(mnbas),dummy,nword
  real :: dellin(m_pol_rec,mnant,2),delay(m_pol_rec,mnant)
  logical :: to_new_receivers
  !------------------------------------------------------------------------
  ! CODE:
  ! We want do use this for format conversion ...
  to_new_receivers = (r_kind.ge.5)
!        print *,'============encode header to_new ',to_new_receivers, &
!            r_kind
  k = 1
  call r4tor4 (dh_dump,iw(k),3)
  k = k + 3
  !
  !      call r8tor8 (dh_utc,iw(k),4)
  ! Use an R4TOR4 call to avoid mis-aligned problems
  call r4tor4 (dh_utc,iw(k),8)
  k = k + 8
  if (de%version.le.2) then
    call r4tor4 (dh_test0,iw(k),10)
    k = k + 10
  else
    call r4tor4 (dh_test0,iw(k),20)
    k = k + 20
  endif
  call r4tor4 (dh_aflag,iw(k),r_nant)
  k = k + r_nant
  if (de%version.le.3) then
    if (to_new_receivers) then
      if (r_dobs.lt.(-6406)) then    ! changed the 13/02/2007
        temp_dim = r_npol_rec + r_nband_widex
      else
        temp_dim = 2 + r_nband_widex
      endif
      do ia=1, r_nant
        call r4tor4 (dh_total(1,ia),iw(k),temp_dim)
        k = k + temp_dim
      enddo
    else
      do ia=1, r_nant
        call r4tor4 (dh_total(1,ia),iw(k),1)
        call r4tor4 (dh_total(2,ia),iw(k),1)
        k = k + 1
      enddo
    endif
  else
    do ia=1, r_nant
      call r4tor4(dh_total(1,ia),iw(k),r_nbb)
      k = k + r_nbb
    enddo
  endif
  ! atfac
  if (de%version.le.3) then
    natfac = max(r_npol_rec, r_lband)
    if (to_new_receivers) then
      natfac = max(r_npol_rec, r_lband)
    else
      natfac = 1
    endif
    do ia=1, r_nant
      do j=1, 2
        call r4tor4 (dh_atfac(1,j,ia),iw(k),natfac)
        k = k + natfac
      enddo
    enddo
  else
    do ia=1, r_nant
      do j=1, 2
        call r4tor4 (dh_atfac(1,j,ia),iw(k),r_nbb)
        k = k + r_nbb
      enddo
    enddo
  endif
  call r4tor4 (dh_rmspe,iw(k),2*r_nant)
  k = k + 2*r_nant
  if (de%version.le.2) then
    call r4tor4 (dh_delcon,iw(k),r_nant)
    k = k + r_nant
  endif
  if (de%version.le.3) then
    do ia=1, r_nant
      do j=1, r_nbb
        l = r_mappol(ia,j)
        if (j.le.2) then
           dellin(l,ia,1) = dh_dellin(j,ia)
        else
           dellin(l,ia,2) = dh_dellin(j,ia)
        endif
      enddo
    enddo
    if (r_nband_widex.ne.0) then
      temp_dim = 2
    else
      temp_dim = 1
    endif
    do ia=1, r_nant
      do j = 1, temp_dim
         call r4tor4 (dellin(1,ia,j),iw(k),r_npol_rec)
         k = k + r_npol_rec
      enddo
    enddo
  else
    do ia=1, r_nant
      call r4tor4 (dh_dellin(1,ia),iw(k),r_nbb)
      k = k + r_nbb
    enddo
  endif 
  call r4tor4 (dh_delayc,iw(k),r_nant)
  k = k + r_nant
  !
  if (de%version.le.3) then
    do ia=1, r_nant
      do j=1, r_nbb
        l = r_mappol(ia,j)
        delay(l,ia) = dh_delay(j,ia)
      enddo
      call r4tor4 (dh_delay(1,ia),iw(k),r_npol_rec)
      k = k + r_npol_rec
    enddo
  else
    do ia=1, r_nant
      call r4tor4 (dh_delay(1,ia),iw(k),r_nbb)
      k = k + r_nbb
    enddo
  endif
  !      CALL R4TOR4 (DH_DELAY,IW(K),R_NPOL_REC*R_NANT)
  !      K = K + R_NPOL_REC*R_NANT
  call r4tor4 (dh_phasec,iw(k),r_nant)
  k = k + r_nant
  call r4tor4 (dh_phase,iw(k),r_nant)
  k = k + r_nant
  call r4tor4 (dh_ratec,iw(k),r_nant)
  k = k + r_nant
  call r4tor4 (dh_cable,iw(k),r_nant)
  k = k + r_nant
  if (de%version.le.2) then
    call r4tor4 (dh_gamme,iw(k),r_nant)
    k = k + r_nant
  endif
  if (de%version.le.2) then
    do ia=1, r_nant
      call r4tor4 (dh_test1(1,ia),iw(k),5)
      k = k + 5
    enddo
  else
    call r4tor4 (dh_test1,iw(k),20*r_nant)
    k = k + 20*r_nant
  endif
  !
  if (to_new_receivers) then
    do ib=1, r_nbas
      do j=1, 2
        call r4tor4 (dh_rmsamp(1,j,ib),iw(k),r_npol_rec)
        k = k + r_npol_rec
      enddo
    enddo
    do ib=1, r_nbas
      do j=1, 2
        call r4tor4 (dh_rmspha(1,j,ib),iw(k),r_npol_rec)
        k = k + r_npol_rec
      enddo
    enddo
  else
    call r4tor4 (dh_rmsamp,iw(k),2*r_nbas)
    k = k + 2*r_nbas
    call r4tor4 (dh_rmspha,iw(k),2*r_nbas)
    k = k + 2*r_nbas
  endif
  !
  call r4tor4 (dh_offfoc,iw(k),2*r_nant)
  k = k + r_nant
  call r4tor4 (dh_offlam,iw(k),r_nant)
  k = k + r_nant
  call r4tor4 (dh_offbet,iw(k),r_nant)
  k = k + r_nant
  call r4tor4 (dh_bflag,iw(k),r_nbas)
  k = k + r_nbas
  call r4tor4 (dh_uvm,iw(k),2*r_nbas)
  k = k + 2*r_nbas
  if (de%version.le.2) then
    call r4tor4 (dh_infac,iw(k),4*r_nbas)
    k = k + 4*r_nbas
  endif
  call r4tor4 (dh_wvr,iw(k),mwvrch*r_nant)
  k = k + mwvrch*r_nant
  call r4tor4 (dh_wvrstat,iw(k),r_nant)
  k = k + r_nant
  if (to_new_receivers) then
    if (de%version.le.3) then
      do ii = 1, r_lband
        do j = 1, r_nant
          call r4tor4 (dh_actp(1,j,ii),iw(k),r_npol_rec)
          k = k + r_npol_rec
        enddo
      enddo
    endif
    do j=1, r_nant
      call r4tor4 (dh_anttp(1,j),iw(k),r_nif)
      k = k + r_nif
    enddo
  endif
  if (de%version.le.3) then
    saflag = 0
    do ia = 1, r_nant
      do ii = 1, 16
         if (dh_saflag(ii,ia))  saflag(ia)= ibset(saflag(ia),ii-1)
         if (dh_saflag(ii+mbands,ia))  saflag(ia)= ibset(saflag(ia),ii+15)
      enddo
    enddo
    sbflag = 0
    do ib = 1, r_nbas
      do ii = 1, 16
         if (dh_sbflag(ii,ib)) sbflag(ib)= ibset(sbflag(ib),ii-1)
         if (dh_sbflag(ii+mbands,ib)) sbflag(ib)= ibset(sbflag(ib),ii+15)
      enddo
    enddo
    if (r_nband_widex.ne.0) then
      call w4tow4 (saflag,iw(k),r_nant)
      k = k + r_nant
      call w4tow4 (sbflag,iw(k),r_nbas)
      k = k + r_nbas
    endif
  else
    nword = int(r_lband/32)+1
    do ia=1, r_nant
      l = 0
      do j=1, nword
        dummy = 0
        do ii= 1, 32
          l=l+1
          if (l.le.r_lband) then
            if (dh_saflag(l,ia)) dummy = ibset(dummy,ii-1)
          endif
        enddo
        call i4toi4(dummy,iw(k),1)
        k = k + 1
      enddo
    enddo
    do ia=1, r_nant
      l = 0
      do j=1, nword
        dummy = 0
        do ii= 1, 32
          l=l+1
          if (l.le.r_lband) then
            if (dh_saflag(l+mbands,ia)) dummy = ibset(dummy,ii-1)
          endif
        enddo
        call i4toi4(dummy,iw(k),1)
        k = k + 1
      enddo
    enddo
    do ib=1, r_nbas
      l = 0
      do j=1, nword
        dummy = 0
        do ii= 1, 32
          l=l+1
          if (l.le.r_lband) then
            if (dh_sbflag(l,ib)) dummy = ibset(dummy,ii-1)
          endif
        enddo
        call i4toi4(dummy,iw(k),1)
        k = k + 1
      enddo
    enddo
    do ib=1, r_nbas
      l = 0
      do j=1, nword
        dummy = 0
        do ii= 1, 32
          l=l+1
          if (l.le.r_lband) then
            if (dh_sbflag(l+mbands,ib)) dummy = ibset(dummy,ii-1)
          endif
        enddo
        call i4toi4(dummy,iw(k),1)
        k = k + 1
      enddo
    enddo
  endif
  if (de%version.ge.3) then
    call r4tor4(dh_cable_alternate,iw(k),r_nant)
    k = k + r_nant
    call r4tor4(dh_ntime,iw(k),1)
    k = k + 1
    if (dh_ntime.gt.0) then
      call r4tor4(dh_time_monitoring,iw(k),dh_ntime)
      k = k + dh_ntime
    endif
    do j = 1, 2
      call r4tor4(dh_incli(1,j),iw(k),r_nant)
      k = k + r_nant
    enddo
    call r4tor4(dh_incli_temp,iw(k),r_nant)
    k = k + r_nant
    do j = 1, 3
      call r4tor4(dh_tilfoc(1,j),iw(k),r_nant)
      k = k + r_nant
    enddo
    do j = 1, 2
      call r4tor4(dh_offfoc_xy(1,j),iw(k),r_nant)
      k = k + r_nant
    enddo    
  endif
  if (de%version.ge.6) then
    if (r_nant_vlbi.gt.0) then
      call r4tor4(dh_vlbi_phaseff,iw(k),r_nbb)
      k = k + r_nbb
      do j=1, r_nbb
        call r4tor4(dh_vlbi_phase_tot(1,j),iw(k),r_nant)
        k = k + r_nant
      enddo
      do j=1, r_nbb
        call r4tor4(dh_vlbi_phase_inc(1,j),iw(k),r_nant)
        k = k + r_nant
      enddo
   endif
   endif
!      print *, '=========== end encode_header  k= ',k
end subroutine encode_header

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the WIFISYN package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_pack_set
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack
  !
  pack%name='wifisyn'
  pack%ext='.wifi'
  pack%depend(1:1) = (/ locwrd(greg_pack_set) /)
  pack%init=locwrd(wifisyn_pack_init)
  pack%on_exit=locwrd(wifisyn_pack_on_exit)
  pack%authors="J.Pety"
  !
end subroutine wifisyn_pack_set
!
subroutine wifisyn_pack_init(gpack_id,error)
  use sic_def
  use wifisyn_interfaces, except_this=>wifisyn_pack_init
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Init WIFISYN package
  error = .false.
  call wifisyn_init(error)
  if (error) return
  !
  ! Local language
  call wifisyn_load
  !
  ! One time initialization
  call wifisyn_message_set_id(gpack_id)  ! Set library id
  !
  ! Language priorities
  call exec_program('SIC'//backslash//'SIC PRIORITY 1 WIFISYN')
  !
  ! Specific initializations
  !
end subroutine wifisyn_pack_init
!
subroutine wifisyn_pack_on_exit(error)
  use wifisyn_interfaces, except_this=>wifisyn_pack_on_exit
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical :: error
  !
  call wifisyn_exit(error)
  if (error) return
  !
end subroutine wifisyn_pack_on_exit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_CorrelatorMode(error)
  !---------------------------------------------------------------------
  ! Write the CorrelatorMode SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_CorrelatorMode
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (CorrelatorModeKey) :: cmKey
  type (CorrelatorModeRow) :: cmRow
  character sdmTable*20
  parameter (sdmTable='CorrelatorMode')
  integer ier, i
  integer, parameter :: maxAxes=10, maxunit=8
  integer :: burebasebandNames(maxunit)
  data burebasebandNames/ BasebandName_BB_1, BasebandName_BB_2, &
       BasebandName_BB_3, BasebandName_BB_4, BasebandName_BB_5, BasebandName_BB_6, &
       BasebandName_BB_7, BasebandName_BB_8 /
  !---------------------------------------------------------------------
  ier = 0
  call sdmMessage(1,1,sdmTable ,'starting...')
  cmRow%numBaseband = v_lband
  cmRow%numAxes = 6
  call  allocCorrelatorModeRow(cmRow, error)
  if (error) return
  cmRow%axesOrderArray = (/ AxisName_BAL, AxisName_BAB, AxisName_SPW, AxisName_APC,&
       AxisName_SPP, AxisName_POL /)
  cmRow%basebandConfig = 0
  do i=1, cmRow%numBaseband
    cmRow%basebandNames(i) = burebasebandNames(r_iunit(i))
    ! there is no specific configuration number (?)
    cmRow%basebandConfig(i) = 0
  enddo
  cmRow%correlatorName = CorrelatorName_IRAM_PDB 
  cmRow%accumMode = 0
  cmRow%binMode = 0
  cmRow%filterMode = 0
  call addCorrelatorModeRow(cmKey, cmRow, error)
  if (error) return
  !
  ! was not changed...
  CorrelatorMode_Id = cmKey%correlatorModeId
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_CorrelatorMode
!---------------------------------------------------------------------
subroutine get_sdm_CorrelatorMode(error)
  !---------------------------------------------------------------------
  ! Get the CorrelatorMode SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_CorrelatorMode
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (CorrelatorModeKey) :: cmKey
  type (CorrelatorModeRow) :: cmRow
  integer ier, ia, ic
  integer, parameter :: maxBaseband = 8, maxAxes=10
  character  :: sdmTable*20
  parameter (sdmTable='CorrelatorMode')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! very much *TBD* at this stage. Think of better filling this in...
  !$$$      print *, 'CorrelatorMode_Id ', CorrelatorMode_Id
  call  allocCorrelatorModeRow(cmRow, maxBaseband, maxAxes, error   &
    )
  if (error) return
  cmKey%CorrelatorModeId  = CorrelatorMode_Id
  call getCorrelatorModeRow(cmKey, cmRow, error)
  if (error) return
  if (cmRow%numBaseband.gt.mrlband) then
    call sdmMessageI(8,3,sdmTable   &
      ,'Wrong numBaseband',cmRow%numBaseband)
    goto 99
  endif
  !
  ! ### Note: with current PDB-NG  format, if there are two polarization products (Polarization.numCorr = 2)
  ! we have to double  double the subbands. SO we should also read the POlarization table.
  ! keep num_Baseband as a global item?
  v_lband = cmRow%numBaseband
  !
  !     baseband index ???
  !
  !     ignore accumMode, binMode, quantization, windowFunction,
  !     axesOrderArray for the time being
  !
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_CorrelatorMode
!---------------------------------------------------------------------
!!! subroutine allocCorrelatorModeRow(row, numBaseband, numAxes, error   &
!!!     )
!!!   !---------------------------------------------------------------------
!!!   !$$$    integer, allocatable :: basebandNames(:)
!!!   !$$$    integer, allocatable :: basebandConfig(:)
!!!   !$$$    logical*1, allocatable :: quantization(:)
!!!   !$$$    integer, allocatable :: windowFunction(:)
!!!   !$$$    integer, allocatable :: axesOrderArray(:)
!!!   !$$$    logical*1, allocatable :: oversampling(:)
!!!   !$$$    integer, allocatable :: correlationBit(:)
!!!   !$$$    integer, allocatable :: filterMode(:)
!!!   !C <<< A ETENDRE AUX NOUVEAUX ITEMS>>>
!!!   !---------------------------------------------------------------------
!!!   use sdm_CorrelatorMode
!!!   type(CorrelatorModeRow) :: row
!!!   integer :: numBaseband, numAxes, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*8 = 'calReduction'
!!!   !
!!!   ! BasebandNames
!!!   if (allocated(row%BasebandNames)) then
!!!     deallocate(row%BasebandNames, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%BasebandNames(numBaseband), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! basebandConfig
!!!   if (allocated(row%basebandConfig)) then
!!!     deallocate(row%basebandConfig, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%basebandConfig(numBaseband), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! quantization
!!!   !$$$      if (allocated(row%quantization)) then
!!!   !$$$         deallocate(row%quantization, stat=ier)
!!!   !$$$         if (ier.ne.0) goto 98
!!!   !$$$      endif
!!!   !$$$      allocate(row%quantization(numBaseband), stat=ier)
!!!   !$$$      if (ier.ne.0) goto 99
!!!   !
!!!   ! windowFunction
!!!   !$$$      if (allocated(row%windowFunction)) then
!!!   !$$$         deallocate(row%windowFunction, stat=ier)
!!!   !$$$         if (ier.ne.0) goto 98
!!!   !$$$      endif
!!!   !$$$      allocate(row%windowFunction(numBaseband), stat=ier)
!!!   !$$$      if (ier.ne.0) goto 99
!!!   !
!!!   ! oversampling
!!!   !$$$      if (allocated(row%oversampling)) then
!!!   !$$$         deallocate(row%oversampling, stat=ier)
!!!   !$$$         if (ier.ne.0) goto 98
!!!   !$$$      endif
!!!   !$$$      allocate(row%oversampling(numBaseband), stat=ier)
!!!   !$$$      if (ier.ne.0) goto 99
!!!   !
!!!   ! correlationBit
!!!   !$$$      if (allocated(row%correlationBit)) then
!!!   !$$$         deallocate(row%correlationBit, stat=ier)
!!!   !$$$         if (ier.ne.0) goto 98
!!!   !$$$      endif
!!!   !$$$      allocate(row%correlationBit(numBaseband), stat=ier)
!!!   !$$$      if (ier.ne.0) goto 99
!!!   !
!!!   ! filterMode
!!!   if (allocated(row%filterMode)) then
!!!     deallocate(row%filterMode, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%filterMode(numBaseband), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! axesOrderArray (dimension: numAxes)
!!!   if (allocated(row%axesOrderArray)) then
!!!     deallocate(row%axesOrderArray, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%axesOrderArray(numAxes), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end

!
!----------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoCalibrate">
!   <VERSION>
!                Id: modulePakoCalibrate.f90,v 1.2.3 2014-10-24 Hans Ungerechts
!                Id: modulePakoCalibrate.f90,v 1.2.3 2014-02-03 Hans Ungerechts
!                                              1.2.2 2013-01-17 Hans Ungerechts
!                                              1.2.1 2012-08-16 Hans Ungerechts
!                based on
!                Id: modulePakoCalibrate.f90,v 1.1.0 2009-03-31 Hans Ungerechts
!   </VERSION>
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>
!                Calibrate
!                Focus
!                OnOff
!                OtfMap
!                Pointing
!                Tip
!                Track
!                VLBI
!   </SIBLINGS>        
!
!   Pako module for command: CALIBRATE
!
! </DOCUMENTATION> <!-- name="modulePakoCalibrate" -->
!
!----------------------------------------------------------------------
!
Module modulePakoCalibrate
  !
  Use modulePakoMessages
  Use modulePakoTypes
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
  !!? TBD 2.0:   Use modulePakoSwBeam
  !!? TBD 2.0:   Use modulePakoSwFrequency
  !!? TBD 2.0:   Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  Public :: calibrate, displayCalibrate, saveCalibrate, startCalibrate
  !     
  ! *** Variables for Calibrate ***
  Include 'inc/variables/variablesCalibrate.inc'
!!!   
!!!   
Contains
!!!
!!!
  Subroutine CALIBRATE(programName,line,command,error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    ! *** special working variables:   ***
    Integer    ::   nSubscans
    Logical    ::   isConnected
    !
    Character (len=lenCh) :: bolometerName
    !
    Include 'inc/ranges/rangesCalibrate.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Calibrate, v 1.2.3 2014-02-03 ---> SR: Calibrate ")         ! trace execution
    Call pako_message(seve%t,programName,                                        &
         &  " module Calibrate, v 1.2.3 test in GILDAS feb17 ")                  ! trace execution
    !
    ! *** initialize:   ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars   (iIn) = vars   (iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    Call checkNofParameters(command,                                             &
         &     0, 0,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    ! *** check for alternative Options   ***
!!OLD      If (.Not. ERROR) Then
!!OLD         Include 'inc/options/alternative.inc'
!!OLD      End If
    !
    ! *** read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/options/readOptionsCalibrate.inc'
    End If
    !
    ! *** set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)                
       If (setDefaults) Then
          Include 'inc/variables/setDefaults.inc'
       Endif
    Endif
    !
    ! *** Read Parameters, Options (again, after defaults!)   ***
    ! *** and check for validity and ranges                   ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/options/readOptionsCalibrate.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.ERROR) Then
       !
       errorInconsistent = .False.
       !
       Include 'inc/options/checkConsistentCalibrate.inc'
       !
       If (.Not. errorInconsistent) Then
          vars   (iTemp) = vars   (iIn)
       End If
       !
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** evaluate consequences  / rules
    !
    If (.Not. ERROR) Then
       !
       If (vars(iTemp)%doGainImage) Then
          vars(iTemp)%doAmbient    = .True.
          vars(iTemp)%doCold       = .True.
          vars(iTemp)%doSky        = .False.
          vars(iTemp)%doGrid       = .False.
          messageText = "implies specific subscans!"
          Call PakoMessage(priorityI,severityI,                                  &
               &           "calibrate"//" /gainImage ",messageText)              !
       End If
       !
       If (vars(iTemp)%doGrid) Then
          vars(iTemp)%doAmbient    = .True.
          vars(iTemp)%doCold       = .True.
          !
          OPTION = 'SKY'
          Call indexCommmandOption                                               &
               &     (command,option,commandFull,optionFull,                     &
               &      commandIndex,optionIndex,iCommand,iOption,                 &
               &      errorNotFound,errorNotUnique)                              !
          If (.Not.SIC_PRESENT(iOption,0)) Then
             vars(iTemp)%doSky        = .True.
          End If
          vars(iTemp)%doGainImage  = .False.
          messageText = "implies specific subscans!"
          Call PakoMessage(priorityI,severityI,                                  &
               &           "calibrate"//" /grid ",messageText)                   !
          If (.Not.vars(iTemp)%doSky) Then
             messageText = "should normally be done with /SKY!"
             Call PakoMessage(priorityW,severityW,                               &
                  &           "calibrate"//" /grid ",messageText)                !
          End If
       End If
       !
    End If
    !
    ! *** conclude alternative options   ***
!!OLD      If (.Not.error) Then
!!OLD         Include 'inc/options/alternativeEnd.inc'
!!OLD      End If
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars   (iValue) = vars   (iTemp)
    End If
    !
    !D    Write (6,*) '   --> moduleCalibrate: SR calibrate before Call displayCalibrate '
    !
    ! *** display values ***
    If (.Not.ERROR) Then
       Call displayCalibrate
    End If
    !
    ! *** set "selected" observing mode & plot ***
    If (.Not.error) Then
       GV%observingMode     = OM%Cal
       GV%observingModePako = OMpako%Cal
       GV%omSystemName      = vars(iValue)%systemName 
       GV%notReadySWafterOM = .False.
       GV%notReadySecondaryRafterOM = .False.
       calibrateCommand     = line(1:lenc(line))
       Call analyzeCalibrate (errorA)
       !! TBD 2.0:        Call listSegmentList (errorA)
       !!aws this crashes, but activated
       Call plotCalibrate (errorP)
    End If
    !
    Return
  End Subroutine CALIBRATE
!!!
!!!
  Subroutine displayCalibrate
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module Calibrate, v 1.2.1  --> SR: displayCalibrate ")             ! trace execution
    !
    Include 'inc/display/commandDisplayCalibrate.inc'
    !
  End Subroutine displayCalibrate
!!!
!!!
  Subroutine analyzeCalibrate (errorA)

    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character (len=12)   :: aUnit, sUnit
    !
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module Calibrate, v 1.2.1  --> SR: analyzeCalibrate ")             ! trace execution
    !
    aUnit     = GV%angleUnitC
    sUnit     = GV%speedUnitC
    !
    errorA = .False.
    !
    segList(:) = segDefault
    !
    Call countSubscans(value=0)
    Call countSegments(value=0)
    !
    If (vars(iValue)%doGainImage) Then
       !
       Call countSubscans(ii)
       Call countSegments(jj)
       segList(ii)%newSubscan = .True.
       segList(ii)%ssNumber   =  ii
       segList(ii)%segNumber  =  jj
       segList(ii)%ssType     =  ss%ca
       segList(ii)%segType    =  seg%track
       segList(ii)%angleUnit  =  aUnit
       segList(ii)%speedUnit  =  sUnit
       segList(ii)%flagOn     =  .True.
       segList(ii)%flagRef    =  .False.
       segList(ii)%pStart%x   =  vars(iValue)%xOffsetRC
       segList(ii)%pStart%y   =  vars(iValue)%yOffsetRC
       segList(ii)%systemName =  vars(iValue)%systemName
       segList(ii)%tSegment   =  vars(iValue)%tCalibrate
       segList(ii)%tRecord    =  1.0
       segList(ii)%sideBand   =  sb%lsb
       !
       Call countSubscans(ii)
       Call countSegments(jj)
       segList(ii)%newSubscan = .True.
       segList(ii)%ssNumber   =  ii
       segList(ii)%segNumber  =  jj
       segList(ii)%ssType     =  ss%cc
       segList(ii)%segType    =  seg%track
       segList(ii)%angleUnit  =  aUnit
       segList(ii)%speedUnit  =  sUnit
       segList(ii)%flagOn     =  .True.
       segList(ii)%flagRef    =  .False.
       segList(ii)%pStart%x   =  vars(iValue)%xOffsetRC
       segList(ii)%pStart%y   =  vars(iValue)%yOffsetRC
       segList(ii)%systemName =  vars(iValue)%systemName
       segList(ii)%tSegment   =  vars(iValue)%tCalibrate
       segList(ii)%tRecord    =  1.0
       segList(ii)%sideBand   =  sb%lsb
       !
       Call countSubscans(ii)
       Call countSegments(jj)
       segList(ii)%newSubscan = .True.
       segList(ii)%ssNumber   =  ii
       segList(ii)%segNumber  =  jj
       segList(ii)%ssType     =  ss%ca
       segList(ii)%segType    =  seg%track
       segList(ii)%angleUnit  =  aUnit
       segList(ii)%speedUnit  =  sUnit
       segList(ii)%flagOn     =  .True.
       segList(ii)%flagRef    =  .False.
       segList(ii)%pStart%x   =  vars(iValue)%xOffsetRC
       segList(ii)%pStart%y   =  vars(iValue)%yOffsetRC
       segList(ii)%systemName =  vars(iValue)%systemName
       segList(ii)%tSegment   =  vars(iValue)%tCalibrate
       segList(ii)%tRecord    =  1.0
       segList(ii)%sideBand   =  sb%usb
       !
       Call countSubscans(ii)
       Call countSegments(jj)
       segList(ii)%newSubscan = .True.
       segList(ii)%ssNumber   =  ii
       segList(ii)%segNumber  =  jj
       segList(ii)%ssType     =  ss%cc
       segList(ii)%segType    =  seg%track
       segList(ii)%angleUnit  =  aUnit
       segList(ii)%speedUnit  =  sUnit
       segList(ii)%flagOn     =  .True.
       segList(ii)%flagRef    =  .False.
       segList(ii)%pStart%x   =  vars(iValue)%xOffsetRC
       segList(ii)%pStart%y   =  vars(iValue)%yOffsetRC
       segList(ii)%systemName =  vars(iValue)%systemName
       segList(ii)%tSegment   =  vars(iValue)%tCalibrate
       segList(ii)%tRecord    =  1.0
       segList(ii)%sideBand   =  sb%usb
       !
    Else
       !
       If (vars(iValue)%doSky) Then
          !
          Call countSubscans(ii)
          Call countSegments(jj)
          segList(ii)%newSubscan = .True.
          segList(ii)%ssNumber   =  ii
          segList(ii)%segNumber  =  jj
          segList(ii)%ssType     =  ss%cs
          segList(ii)%segType    =  seg%track
          segList(ii)%angleUnit  =  aUnit
          segList(ii)%speedUnit  =  sUnit
          segList(ii)%flagOn     =  .True.
          segList(ii)%flagRef    =  .False.
          segList(ii)%pStart%x   =  vars(iValue)%xOffsetRC
          segList(ii)%pStart%y   =  vars(iValue)%yOffsetRC
          segList(ii)%systemName =  vars(iValue)%systemName
          segList(ii)%tSegment   =  vars(iValue)%tCalibrate
          segList(ii)%tRecord    =  1.0
          !
          If (vars(iValue)%systemName.Eq.offs%pro) Then
             segList(ii)%updateDoppler = .True.
             segList(ii)%pDoppler      = segList(ii)%pStart
          Else
             segList(ii)%updateDoppler = .True.
             segList(ii)%pDoppler      = xyPointType(0.0,0.0)
          End If
          !
       End If
       !
       If (vars(iValue)%doAmbient) Then
          !
          Call countSubscans(ii)
          Call countSegments(jj)
          segList(ii)%newSubscan = .True.
          segList(ii)%ssNumber   =  ii
          segList(ii)%segNumber  =  jj
          segList(ii)%ssType     =  ss%ca
          segList(ii)%segType    =  seg%track
          segList(ii)%angleUnit  =  aUnit
          segList(ii)%speedUnit  =  sUnit
          segList(ii)%flagOn     =  .True.
          segList(ii)%flagRef    =  .False.
          segList(ii)%pStart%x   =  vars(iValue)%xOffsetRC
          segList(ii)%pStart%y   =  vars(iValue)%yOffsetRC
          segList(ii)%systemName =  vars(iValue)%systemName
          segList(ii)%tSegment   =  vars(iValue)%tCalibrate
          segList(ii)%tRecord    =  1.0
          !
       End If
       !
       If (vars(iValue)%doCold) Then
          !
          Call countSubscans(ii)
          Call countSegments(jj)
          segList(ii)%newSubscan = .True.
          segList(ii)%ssNumber   =  ii
          segList(ii)%segNumber  =  jj
          segList(ii)%ssType     =  ss%cc
          segList(ii)%segType    =  seg%track
          segList(ii)%angleUnit  =  aUnit
          segList(ii)%speedUnit  =  sUnit
          segList(ii)%flagOn     =  .True.
          segList(ii)%flagRef    =  .False.
          segList(ii)%pStart%x   =  vars(iValue)%xOffsetRC
          segList(ii)%pStart%y   =  vars(iValue)%yOffsetRC
          segList(ii)%systemName =  vars(iValue)%systemName
          segList(ii)%tSegment   =  vars(iValue)%tCalibrate
          segList(ii)%tRecord    =  1.0
          !
       End If
       !
       If (vars(iValue)%doGrid) Then                                      ! for polarization
          !
          Call countSubscans(ii)
          Call countSegments(jj)
          segList(ii)%newSubscan = .True.
          segList(ii)%ssNumber   =  ii
          segList(ii)%segNumber  =  jj
          segList(ii)%ssType     =  ss%cg
          segList(ii)%segType    =  seg%track
          segList(ii)%angleUnit  =  aUnit
          segList(ii)%speedUnit  =  sUnit
          segList(ii)%flagOn     =  .True.
          segList(ii)%flagRef    =  .False.
          segList(ii)%pStart%x   =  vars(iValue)%xOffsetRC
          segList(ii)%pStart%y   =  vars(iValue)%yOffsetRC
          segList(ii)%systemName =  vars(iValue)%systemName
          segList(ii)%tSegment   =  vars(iValue)%tCalibrate
          segList(ii)%tRecord    =  1.0
          !
       End If
       !
    End If
    !
    Call getCountSegments(nSegments)
    !
    Return 
    !
  End Subroutine analyzeCalibrate
!!!
!!!
  Subroutine plotCalibrate (errorP)
    !
    !**   Variables  for Plots   ***
    Include 'inc/variables/headerForPlotMethods.inc'
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    errorP = .False.
    !
    Call configurePlots
    !
    Call plotCalSky(vars(iValue)%xOffsetRC, vars(iValue)%yOffsetRC,errorP)
    !
    Return
  End Subroutine plotCalibrate
!!!
!!!
  Subroutine saveCalibrate(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module Calibrate, v 1.2.1  --> SR: saveCalibrate ")                ! trace execution
    !
    contC = contNN
    !
    ERROR = .False.
    !
    Include 'inc/commands/saveCommand.inc'
    !
    contC = contCC
    !
    Include 'inc/options/saveAmbient.inc'
    Include 'inc/options/saveCold.inc'
    !
    ! **  EMIR, HERA: no /gainIamge
!!OLD    Include 'inc/options/saveGainImage.inc'
    Include 'inc/options/saveGrid.inc'
!!OLD        include 'inc/options/saveFast.inc'
!!OLD        include 'inc/options/saveNull.inc'
    Include 'inc/options/saveSky.inc'
    Include 'inc/options/saveSystem.inc'
    !
    contC = contCN
    !
    Include 'inc/options/saveTcalibrate.inc'
!!OLD        include 'inc/options/saveTest.inc'
!!OLD        include 'inc/options/saveVariable.inc'
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveCalibrate
!!!
!!!
  Subroutine startCalibrate(programName,LINE,commandToSave,iUnit, ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: messageText
    Logical                 :: errorL, errorXML
    ! 
    Call pako_message(seve%t,"PAKO",                                              &
         &  " module Calibrate, v 1.2.1  --> SR: startCalibrate ")                ! trace execution
    !
    ERROR = .False.
    !
    Call pakoXMLsetOutputUnit(iunit=iunit)
    Call pakoXMLsetIndent(iIndent=2)
!!OLD   Call pakoXMLsetLevel(1)
    !
    Include 'inc/startXML/generalHead.inc'
    !
    Call writeXMLset(programName,LINE,commandToSave,                             &
         &           iUnit, ERROR)                                               !
    !
    Call pakoXMLwriteStartElement("RESOURCE","pakoScript",                       &
         &                         comment="save from pako",                     &
         &                         error=errorXML)                               !
    Call pakoXMLwriteStartElement("DESCRIPTION",                                 &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/savePakoScriptFirst.inc'
    !
    Call saveCalibrate    (programName,LINE,commandToSave, iUnit, errorL)
    !
    Call pakoXMLwriteEndElement("DESCRIPTION",                                   &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    Call pakoXMLwriteEndElement  ("RESOURCE","pakoScript",                       &
         &                         space="after",                                &
         &                         error=errorXML)                               !
    !
    Call writeXMLantenna(programName,LINE,commandToSave,                         &
         &         iUnit, ERROR)                                                 !
    !
    Call writeXMLreceiver(programName,LINE,commandToSave,                        &
         &         iUnit, ERROR)                                                 !
    !
    Call writeXMLbackend(programName,LINE,commandToSave,                         &
         &         iUnit, ERROR)                                                 !
    !
    Call writeXMLswTotalPower(programName,LINE,commandToSave,                    &
         &        iUnit, ERROR)                                                  !
    !
    Call writeXMLsource(programName,LINE,commandToSave,                          &
         &         iUnit, ERROR)                                                 !
    !
    Include 'inc/startXML/generalScanHead.inc'
    !
    !TBD: implement the same scheme for other observing modes
    !
    ! **  Observing Mode to XML
    If (gv%doXMLobservingMode) Then
       messageText = "writing observing mode in XML format"
       Call PakoMessage(priorityI,severityI,                                     &
               &           commandToSave,messageText)                            !
       Call writeXMLcalibrate(programName,LINE,commandToSave,                    &
         &         iUnit, ERROR)                                                 !
    End If
    !
    !!? TBD 2.0: 
!!$    !! NOTE: gain calibration not supported with current receivers (2012-06-21)
!!$    If (vars(iValue)%doGainImage) Then
!!$       Call writeXMLcalibrate(programName,LINE,commandToSave,                    &
!!$         &         iUnit, ERROR)
!!$    End If
    !
    ! **  subscan list to XML
    Call writeXMLsubscanList(programName,LINE,commandToSave,                     &
         &         iUnit, ERROR)                                                 !
    !   
    Include 'inc/startXML/generalTail.inc'
    !
    Return
  End Subroutine startCalibrate
!!!
!!!
  Subroutine writeXMLcalibrate(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: iMatch, nMatch, len1, len2
    Character (len=lenCh)   :: valueC, errorCode
    Character (len=lenLine) :: valueComment
    Logical                 :: errorM, errorXML
    !
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module Calibrate, v 1.2.3  --> SR: writeXMLCalibrate 2014-10-24")  ! trace execution
    !
    ERROR = .False.
    !
    Call pakoXMLwriteStartElement("RESOURCE","observingMode",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    valueC = GV%observingMode
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/optionAmbientXML.inc'
    Include 'inc/startXML/optionColdXML.inc'
    Include 'inc/startXML/optionSkyXML.inc'
    Include 'inc/startXML/optionSystemXML.inc'
    Include 'inc/startXML/optionTcalibrateXML.inc'
    Include 'inc/startXML/optionGainImageXML.inc'
    Include 'inc/startXML/optionGridXML.inc'
    !
    Include 'inc/startXML/annotationsXML.inc'
    !
    Call pakoXMLwriteEndElement("RESOURCE","observingMode",                      &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLcalibrate
!!!
!!!
End Module modulePakoCalibrate

subroutine gio_gems (ms, is, blc, trc, addr, form, error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_gems
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! GIO
  !     GEt Memory Slot
  !     Generalized version to also obtain non-contiguous subsets
  !---------------------------------------------------------------------
  integer, intent(out) :: ms                         ! Memory slot
  integer, intent(in)  :: is                         ! Image slot
  integer(kind=index_length), intent(in)  :: blc(:)  ! Bottom left corner
  integer(kind=index_length), intent(in)  :: trc(:)  ! Top right corner
  integer(kind=address_length), intent(out) :: addr  ! Returned address
  integer, intent(in)  :: form                       ! Image format
  logical, intent(out) :: error                      ! Flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='GIO_GEMS'
  integer(kind=address_length) :: ipi, ipo, addr_tmp
  integer :: ms_tmp, ier, ndim
  integer(kind=index_length) :: jblc(gdf_maxdims), jtrc(gdf_maxdims), dimin(gdf_maxdims), dimou(gdf_maxdims), &
       & iblc(gdf_maxdims), itrc(gdf_maxdims)
  integer(kind=size_length) :: isize,ioffs, ileng, i, j
  logical :: icont
  !
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    error = .true.
    return
  elseif (islot(is).eq.code_gio_full) then
    call gio_message(seve%e,rname,'Image is not mapped')
    error = .true.
    return
  endif
  error = .false.
  !
  call gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
  if (isize.le.0) then
    call gio_message(seve%e,rname,'Requesting a zero length memory slot')
  endif
  !
  ! Do not allow to open in Read/Write old UV data files
  if (islot(is).ne.code_gio_reado) then
    if (abs(ivers(is)).eq.code_gdf_uvold) then
      call gio_message(seve%e,rname,'Old UV data files cannot be written')
      error = .true.
      return
    endif
  endif
  !
  ! Try to allocate a memory frame big enough
  if (icont) then
    call gio_gemsco (ms, is, blc, trc, addr, form, error)
    dimou(:) = itrc(:)-iblc(:)+1
  else
    if (islot(is).ne.code_gio_reado) then
      call gio_message(seve%e,rname,'Subset option not supported for '//  &
      'Write access')
      error = .true.
      return
    endif
    !
    ! Define smallest contiguous containing subset
    jblc(:) = iblc(:)
    jtrc(:) = itrc(:)
    do i=ndim,1,-1
      if (iblc(i).ne.itrc(i)) then
        do j=1,i-1
          jblc(j) = 1
          jtrc(j) = idims(j,is)
        enddo
      endif
    enddo
    dimin(:) = jtrc(:)-jblc(:)+1
    dimou(:) = itrc(:)-iblc(:)+1
    !
    ! Get virtual memory for the subset
    ioffs = 0
    do i=ndim,1,-1
      ioffs = ioffs*idims(i,is)+iblc(i)-1
    enddo
    ileng = isize
    if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
      ileng = 2*isize
    elseif (form.eq.fmt_by) then
      ileng = (isize+3)/4
    else
      ileng = isize
    endif
    ileng = -ileng
    call gio_gmslot (ioffs,ileng,form,ms,isbig(is),istbl(is),error)
    if (error) return
    mslot(ms) = is
    ier = sic_getvm (isize,addr)
    if (ier.ne.1) goto 99
    maddr(1,ms) = addr
    maddr(2,ms) = addr+4*(isize-1)
    mleng(ms) = ileng
    !
    ! Get the continuous subset
    call gio_gemsco (ms_tmp, is, jblc, jtrc, addr_tmp, form, error)
    !
    ! Extract the subset
    ipo = gag_pointer(addr,memory)
    ipi = gag_pointer(addr_tmp,memory)
    !
    ! Good code...
    do i=1,ndim
      if (dimin(i).eq.dimou(i)) iblc(i) = 1
    enddo
    !
    if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
      call gdf_sub8(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    elseif (form.eq.fmt_by) then
      call gdf_sub1(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    else
      call gdf_sub4(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    endif
    !
    ! Free the temporary subset.
    ! Note that ISLOT(IS) = READO in this case
    call gio_frms (ms_tmp, error)
  endif
  ! Define memory slot format
  mform(ms) = form
  !
  ! Patch old UV data files
  if (abs(ivers(is)).eq.code_gdf_uvold) then
    call gio_message(seve%i,rname,'Patching old UV data weights')
    !
    ! If the array has been re-shaped for transposition, re-re-shape it
    if (dimou(1).eq.1 .and. dimou(3).ne.1) then
      dimou(1) = dimou(2)
      dimou(2) = dimou(3)
      dimou(3) = dimou(4)
      dimou(4) = 1
    endif
    ipo = gag_pointer(addr,memory)
    call patch_weight(ivers(is),memory(ipo),dimou(1),dimou(2),dimou(3),dimou(4))
  endif
  return
  !
99 call gio_message(seve%e,rname,'Memory allocation failure')
  mslot(ms) = code_gio_empty
  error = .true.
end subroutine gio_gems
!
subroutine gio_gemsco (ms, is, blc, trc, addr, form, error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_gemsco
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF
  !     GEt Memory Slot COntiguous
  !     Restricted version for contiguous subsets
  !---------------------------------------------------------------------
  integer, intent(out) :: ms                         ! Memory slot
  integer, intent(in)  :: is                         ! Image slot
  integer(kind=index_length), intent(in)  :: blc(gdf_maxdims)    ! Bottom left corner
  integer(kind=index_length), intent(in)  :: trc(gdf_maxdims)    ! Top right corner
  integer(kind=address_length), intent(out) :: addr  ! Returned address
  integer, intent(in)  :: form                       ! Image format
  logical, intent(out) :: error                      ! Flag
  ! Local
  character(len=*), parameter :: rname='GIO_GEMSCO'
  integer :: ier, ndim
  integer(kind=index_length) :: iblc(gdf_maxdims), itrc(gdf_maxdims)
  integer(kind=size_length) :: isize, ioffs, ileng, i
  logical :: icont
  !
  !!Print *,'FORM gio_gemsco ',form
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    error = .true.
    return
  elseif (islot(is).eq.code_gio_full) then
    call gio_message(seve%e,rname,'Image is not mapped')
    error = .true.
    return
  endif
  error = .false.
  !
  call gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
  if (isize.le.0) then
    call gio_message(seve%e,rname,'Requesting a zero length memory slot')
  endif
  !
  ! Try to allocate a memory frame big enough
  if (icont) then
    ioffs = 0
    do i=ndim,1,-1
      ioffs = ioffs*idims(i,is)+iblc(i)-1
    enddo
    ileng = isize
    !
    ! Disk file
    if (ichan(is).ne.0) then
      call gio_gmslot (ioffs,ileng,form,ms,isbig(is),istbl(is),error)
      if (error) return
      mslot(ms) = is
      !
      if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
        ileng = 2*isize
      elseif (form.eq.fmt_by) then
        ileng = (isize+3)/4
      else
        ileng = isize
      endif
      !
      call gio_mmslot (ioffs,ileng,form,ms,addr,error)
      if (error)  return
      !
      ! Virtual memory
    else
      ileng = -ileng
      call gio_gmslot (ioffs,ileng,form,ms,isbig(is),istbl(is),error)
      if (error) return
      mslot(ms) = is
      !
      ! Allocate what is needed, no less, no more (to 4 byte rouding)
      if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
        ileng = 2*isize
      elseif (form.eq.fmt_by) then
        ileng = (isize+3)/4
      else
        ileng = isize
      endif
      ier = sic_getvm (ileng,addr)
      if (ier.ne.1) goto 99
      maddr(1,ms) = addr
      maddr(2,ms) = addr+4*(ileng-1)
      ! Negative value means "Virtual Memory"
      mleng(ms) = -ileng
    endif
    if (error) then
      mslot(ms) = code_gio_empty
      return
    else
      mblc(:,ms) = blc(:)
      mtrc(:,ms) = trc(:)
      msize(ms) = isize
      mcont(ms) = icont
    endif
  else
    call gio_message(seve%e,rname,'Subset option not yet supported')
    error = .true.
  endif
  ! Define memory slot format
  mform(ms) = form
  return
  !
99 call gio_message(seve%e,rname,'Memory allocation failure')
  mslot(ms) = code_gio_empty
  error = .true.
end subroutine gio_gemsco
!
subroutine gdf_sub1 (blc, n1,n2,n3,n4,in, m1,m2,m3,m4,out)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (type mismatch)
  !---------------------------------------------------------------------
  integer(kind=index_length) :: blc(4)                    !
  integer(kind=index_length) :: n1                        !
  integer(kind=index_length) :: n2                        !
  integer(kind=index_length) :: n3                        !
  integer(kind=index_length) :: n4                        !
  integer(kind=1) :: in(n1,n2,n3,n4)   !
  integer(kind=index_length) :: m1                        !
  integer(kind=index_length) :: m2                        !
  integer(kind=index_length) :: m3                        !
  integer(kind=index_length) :: m4                        !
  integer(kind=1) :: out(m1,m2,m3,m4)  !
  ! Local
  integer(kind=index_length) :: i1,i2,i3,i4
  integer(kind=index_length) :: j1,j2,j3,j4
  !
  i4 = blc(4)
  do j4=1,m4
    i3 = blc(3)
    do j3=1,m3
      i2 = blc(2)
      do j2=1,m2
        i1 = blc(1)
        do j1=1,m1
          out(j1,j2,j3,j4) = in(i1,i2,i3,i4)
          i1 = i1+1
        enddo
        i2 = i2
      enddo
      i3  = i3+1
    enddo
    i4 = i4+1
  enddo
end subroutine gdf_sub1
!
subroutine gdf_sub8 (blc, n1,n2,n3,n4,in, m1,m2,m3,m4,out)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (type mismatch)
  !---------------------------------------------------------------------
  integer(kind=index_length) :: blc(4)                 !
  integer(kind=index_length) :: n1                     !
  integer(kind=index_length) :: n2                     !
  integer(kind=index_length) :: n3                     !
  integer(kind=index_length) :: n4                     !
  real(8) :: in(n1,n2,n3,n4)        !
  integer(kind=index_length) :: m1                     !
  integer(kind=index_length) :: m2                     !
  integer(kind=index_length) :: m3                     !
  integer(kind=index_length) :: m4                     !
  real(8) :: out(m1,m2,m3,m4)       !
  ! Local
  integer(kind=index_length) :: i1,i2,i3,i4
  integer(kind=index_length) :: j1,j2,j3,j4
  !
  i4 = blc(4)
  do j4=1,m4
    i3 = blc(3)
    do j3=1,m3
      i2 = blc(2)
      do j2=1,m2
        i1 = blc(1)
        do j1=1,m1
          out(j1,j2,j3,j4) = in(i1,i2,i3,i4)
          i1 = i1+1
        enddo
        i2 = i2
      enddo
      i3  = i3+1
    enddo
    i4 = i4+1
  enddo
end subroutine gdf_sub8
!
subroutine gdf_sub4 (blc, n1,n2,n3,n4,in, m1,m2,m3,m4,out)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=index_length) :: blc(4)                 !
  integer(kind=index_length) :: n1                     !
  integer(kind=index_length) :: n2                     !
  integer(kind=index_length) :: n3                     !
  integer(kind=index_length) :: n4                     !
  integer(4) :: in(n1,n2,n3,n4)     !
  integer(kind=index_length) :: m1                     !
  integer(kind=index_length) :: m2                     !
  integer(kind=index_length) :: m3                     !
  integer(kind=index_length) :: m4                     !
  integer(4) :: out(m1,m2,m3,m4)    !
  ! Local 
  integer(kind=index_length) :: i1,i2,i3,i4
  integer(kind=index_length) :: j1,j2,j3,j4
  !
  i4 = blc(4)
  do j4=1,m4
    i3 = blc(3)
    do j3=1,m3
      i2 = blc(2)
      do j2=1,m2
        i1 = blc(1)
        do j1=1,m1
          out(j1,j2,j3,j4) = in(i1,i2,i3,i4)
          i1 = i1+1
        enddo
        i2 = i2+1
      enddo
      i3  = i3+1
    enddo
    i4 = i4+1
  enddo
end subroutine gdf_sub4
!
subroutine gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
  use gio_interfaces, except_this=>gio_cont
  use gio_image
  !---------------------------------------------------------------------
  ! @ private
  ! GDF / GIO
  !     Determine if a slot is contiguous in memory
  !---------------------------------------------------------------------
  integer, intent(in)  :: is                         ! Image slot
  integer, intent(out) :: ndim                       ! Number of dimensions
  integer(kind=index_length), intent(in)  :: blc(:)  ! Bottom left corner
  integer(kind=index_length), intent(in)  :: trc(:)  ! Top right corner
  integer(kind=index_length), intent(out) :: iblc(:) ! Bottom left corner
  integer(kind=index_length), intent(out) :: itrc(:) ! Top right corner
  integer(kind=size_length), intent(out) :: isize    ! Size of memory region
  logical, intent(out) :: icont                      ! Contiguous flag
  ! Local
  integer(kind=index_length) :: i, j
  !
  isize = 1
  icont = .true.
  ndim = indim(is)
  do i=1,ndim
    if (blc(i).le.0) then
      iblc(i) = 1
    else
      iblc(i) = min(blc(i),idims(i,is))
    endif
    if (trc(i).le.0) then
      itrc(i) = idims(i,is)
    else
      itrc(i) = min(trc(i),idims(i,is))
      itrc(i) = max(iblc(i),itrc(i))
    endif
    isize = isize*(itrc(i)-iblc(i)+1)
  enddo
  do i=1,ndim-1
    if (iblc(i).ne.1 .or. itrc(i).ne.idims(i,is)) then
      do j=i+1,ndim
        if (iblc(j).ne.itrc(j)) then
          icont = .false.      ! Not contiguous
        endif
      enddo
    endif
  enddo
  do i=ndim+1,gdf_maxdims
    iblc(i) = 1
    itrc(i) = 1
  enddo
end subroutine gio_cont
!
subroutine gio_gmslot (offs, size, form, ms, big, stablo, error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=> gio_gmslot
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private 
  ! GDF   Get a free memory slot.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: offs          ! Offset from start of image, in "pixel"
  integer(kind=size_length), intent(inout)  :: size       ! Required size (in pixels), and allocated size (in WOrds)
  integer, intent(in)  :: form          ! Type of image
  integer, intent(out) :: ms            ! Memory slot number
  integer, intent(in)  :: big           ! Are big blocks being used ?
  integer, intent(in)  :: stablo        ! Number of Starting Blocks
  logical, intent(out) :: error         ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GIO_GMSLOT'
  integer :: i, freems, sizbuf
  integer(kind=record_length) :: ikbfi,ikbla
  integer(kind=size_length) :: ioffs, isize
  !
  !!Print *,'FORM gdf_gmslot ',form
  !
  if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
    isize = 8*size
    ioffs = 8*offs
  elseif (form.eq.fmt_by) then
    isize = size
    ioffs = offs
  else
    isize = 4*size
    ioffs = 4*offs
  endif
  !
  ! Compute length, taking into account header, offset and block size
  if (size.gt.0) then
    size = isize/4 ! In words...
    call gio_buffs_vm(big,ioffs,size,ikbfi,ikbla,sizbuf,stablo)
  endif
  !
  ! OK, now get a free frame-ID and virtual memory
  freems = 0
  ms = 0
  do i=1,mms
    if (mslot(i).eq.code_gio_empty) then
      ! Enough space in a previously freed frame
      if (size.gt.0) then
        if (mleng(i).ge.size) then
          if (ms.ne.0) then
            if (mleng(ms).gt.mleng(i)) ms = i
          else
            ms = i
          endif
        else
          if (freems.eq.0) freems = i
        endif
      else
        if (freems.eq.0) freems = i
      endif
    endif
  enddo
  if (ms.ne.0) return
  !
  ! No free frame large enough, or virtual memory
  if (freems.eq.0) then
    call gio_message(seve%e,rname,'Too many memory frames')
    error = .true.
  else
    ms = freems
    maddr(1,ms) = 0
    maddr(2,ms) = 0
    mleng(ms) = 0
  endif
end subroutine gio_gmslot
!
subroutine gio_mmslot (offs,leng,form,ms,addr,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_mmslot
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF / GIO
  !             Map Memory SLOT
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: offs     ! Offset from start of image, in "pixel"
  integer(kind=size_length), intent(in)  :: leng     ! Required size (in Words)
  integer, intent(in)  :: form                       ! Type of image
  integer, intent(in)  :: ms                         ! Memory slot number
  integer(kind=address_length), intent(out) :: addr  ! Returned address
  logical, intent(out) :: error                      ! Logical error flag
  ! Global
  integer(kind=4) :: gdf_conv
  include 'gbl_memory.inc'
  character(len=*), parameter :: rname='GIO_MMSLOT'
  ! Local
  integer(kind=address_length) :: ip
  integer(kind=record_length) :: i,ikbfi,ikbla,lastbl
  integer(kind=size_length) :: ioffs,size
  integer :: ier, is
  integer(kind=4) :: buffer(lenbig), sizbuf
  character(len=message_length) :: mess
  !
  error = .true.
  if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
    ioffs = 8*offs
  elseif (form.eq.fmt_by) then
    ioffs = offs
  else
    ioffs = 4*offs
  endif
  !
  is = mslot(ms)
  size = leng
  call gio_buffs_vm(isbig(is),ioffs,size,ikbfi,ikbla,sizbuf,istbl(is))
  !
  ! Get some virtual memory
  ier = sic_getvm (size,addr)
  if (ier.ne.1) goto 99
  !
  open(unit=iunit(is),file=cname(is),status='OLD',form='UNFORMATTED',  &
       access='DIRECT',recl=sizbuf*facunf,iostat=ier)
  !
  ! Do not read beyond written parts
  lastbl = imblock(is)/isbig(is) 
  ikbfi = max(1,min(ikbfi,lastbl)) 
  ikbla = min(ikbla,lastbl) 
  !
  maddr(1,ms) = addr
  maddr(2,ms) = addr+4*size
  mleng(ms) = size
  moffs(ms) = ioffs
  !
  ! The new offset from the first read block is
  !       MOFFS(MS) = (IKBFI-1)*4*SIZBUF
  !
  ! Read file
  ip = gag_pointer(addr,memory)
  if (iform(is).eq.form) then
    !
    ! Here, we could do a true memory mapping instead of reading
    do i=ikbfi,ikbla
      ier = gio_riox (iunit(mslot(ms)),i,memory(ip),sizbuf)
      if (ier.ne.0) then
        write(mess,*) 'READ error #1 on slot ', mslot(ms),' Block ',i
        call gio_message(seve%e,rname,mess)
        call putios(seve%e,rname,ier)
        write(mess,*) ' Range ',ikbfi,ikbla,'  End ',imblock(is),' Sizbuf ',sizbuf
        call gio_message(seve%e,rname,mess)
        return
      endif
      ip = ip+sizbuf
    enddo
  else
    !
    ! Here we must convert the data, so a read is required...
    do i=ikbfi,ikbla
      ier = gio_riox (iunit(mslot(ms)),i,buffer,sizbuf)
      if (ier.ne.0) then
        write(mess,*) 'READ error #2 on slot ', mslot(ms),' Block ',i
        call gio_message(seve%e,rname,mess)
        call putios(seve%e,rname,ier)
        write(mess,*) ' Range ',ikbfi,ikbla,'  End ',imblock(is),' Sizbuf ',sizbuf
        call gio_message(seve%e,rname,mess)
        return
      endif
      if (i.eq.1) then ! First big buffer may contain header ....
        call r4tor4 (buffer,memory(ip),istbl(is)*lenbuf)
        ier = gdf_conv(buffer(1+istbl(is)*lenbuf),memory(ip+istbl(is)*lenbuf), &
        &    sizbuf-istbl(is)*lenbuf,form,iform(is))
      else
        ier = gdf_conv (buffer,memory(ip),sizbuf,form,iform(is))
      endif
      if (ier.ne.1) goto 98
      ip = ip+sizbuf
    enddo
  endif
  close (unit=iunit(is))
  !
  ! Compute address
  ioffs = mod(ioffs,4*sizbuf)
  addr = addr+ioffs
  error = .false.
  return
  !
98 continue 
  write(mess,*) 'Unsupported conversion from ',iform(is),' to ',form
  call gio_message(seve%e,rname,mess)
  call free_vm (size,addr)
  close (unit=iunit(is))
  return
99 call gio_message(seve%e,rname,'Memory allocation failure')
  mslot(ms) = code_gio_empty
  error = .true.
end subroutine gio_mmslot
!
subroutine gio_frms (ms,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_frms
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF   FRee Memory Slot
  !
  ! In case of success, error flag (T/F) is preserved on return. Code is
  ! insensitive to error=T on input.
  !---------------------------------------------------------------------
  integer, intent(in)    :: ms     ! Memory slot
  logical, intent(inout) :: error  ! error flag
  ! Local
  character(len=*), parameter :: rname='GIO_FRMS'
  integer :: is
  !
  is = mslot(ms)
  if (is.eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Memory slot is empty')
    error = .true.
    return
  endif
  !
  ! Contiguous slot
  if (mcont(ms)) then
    !
    ! If virtual memory, free it
    if (mleng(ms).lt.0) then
      !!            Print *,'FREE_VM Virtual memory slot'
      call free_vm(-mleng(ms),maddr(1,ms))
    else
      !!            Print *,'Disk memory slot'
      !
      ! Write disk file
      call gio_wmslot (ms,iunit(is),error)
    endif
    !
  else
    ! Not contiguous Read-Only: just free memory if needed
    if (islot(is).lt.code_gio_write) then
      !!            Print *,'FREE_VM Read-Only  memory slot ',
      !!     $           islot(is),write
      call free_vm (mleng(ms),maddr(1,ms))
    else if (islot(is).ne.code_gio_reade) then
      ! Not contiguous, DUMPI or DUMPE : update line by line
      call gio_message(seve%e,rname,'Inconsistent state of GDF library')
      call gio_message(seve%e,rname,'Non-contiguous WRITE slot')
      error = .true.
    endif
  endif
  !
  ! In all cases, set the memory slot to empty state...
  maddr(1,ms) = 0
  maddr(2,ms) = 0
  mleng(ms) = 0
  mslot(ms) = code_gio_empty
end subroutine gio_frms
!
subroutine gio_wmslot (ms,lun,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_wmslot
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! Write Memory SLOT.
  ! Direct access solution, contiguous data only.
  !
  ! In case of success, error flag (T/F) is preserved on return. Code is
  ! insensitive to error=T on input.
  !---------------------------------------------------------------------
  integer, intent(in)    :: ms     ! Memory slot number
  integer, intent(in)    :: lun    ! Logical Unit Number
  logical, intent(inout) :: error  ! Logical error flag
  ! Global
  integer(kind=4) :: gdf_conv
  include 'gbl_memory.inc'
  character(len=*), parameter :: rname='GIO_WMSLOT'
  ! Local
  integer(kind=4) :: ier, is, buffer(lenbig), sizbuf, lasbuf, form
  integer(kind=record_length) :: i,ikbfi,ikbla
  integer(kind=size_length) :: ioffs, ileft 
  integer(kind=4) :: koffs
  integer(kind=address_length) :: ip
  !
  is = mslot(ms)
  !
  ! Do nothing for READE (External Memory, Read-Only
  if (islot(is).eq.code_gio_reade) return
  !
  ! Only Free Virtual Memory for Read-Only and Full slots
  if (islot(is).lt.code_gio_write) then
    call free_vm (mleng(ms),maddr(1,ms))
    return
  endif
  !
  form = mform(ms)
  !
  ! This should be redone in a different way, like in GDF_RMSLO, by
  !  - keeping MOFFS(MS) as the offset in Byte from the data start
  !  - Reading the header blocks
  !  - Copying the end part of the first block to the beginning of the data      (READ)
  !    or
  !    copying the beginning of the data to the end part of the first block,
  !    and writing the first block     (WRITE)
  !  - Reading the intermediate areas (READ) or Writing them (WRITE)
  !  - Reading the last block
  !  - Copying the beginning of the last block to the end of the data      (READ)
  !      or
  !    copying the end of the data to the first part of the last block,
  !    and writing the last block                                         (WRITE)
  !
  ! Let us do it only for DUMPE to debug...
  if (islot(is).eq.code_gio_dumpe) then
    !
    ! DUMPE State, i.e. a slot which is associated to a user-handled
    ! memory area. There is safeguard around...
    !
    ioffs = moffs(ms)/4+istbl(is)*lenbuf ! Offset in Word in file
    sizbuf = isbig(is) * lenbuf
    koffs = mod(ioffs,sizbuf)  ! Offset in Word from first buffer!
    ikbfi = ioffs/sizbuf + 1
    ikbla = (ioffs+mleng(ms)+sizbuf-1)/sizbuf  ! Last buffer address
    !
    open(unit=lun,file=cname(is),status='OLD',form='UNFORMATTED',  &
         access='DIRECT',recl=sizbuf*facunf,iostat=ier)
    if (ier.ne.0) then
      Print *,'Opened in DUMPE ',ier,sizbuf,lenbuf,isbig(is)
      Print *,'DUMPE -- WMSLOT Iform ',iform(is), ' MFORM ',mform(ms)
      goto 90
    endif
    ip = gag_pointer(maddr(1,ms),memory)
    !
    ! Write file
    ! Native format
    if (iform(is).eq.mform(ms)) then
      ileft = mleng(ms)
      do i=ikbfi,ikbla-1
        if (i.eq.ikbfi) then
        ! Could be simplified by if (i.eq.ikbfi .and. koffs.gt.0) then
          if (koffs.gt.0) then 
            ier = gio_riox (lun,i,buffer,sizbuf)
            if (ier.ne.0) then
              Print *,'DUMPE -- NATIVE Buffer ',i,ikbfi,ikbla,' Read IER ',ier
              goto 90
            endif
          endif
          call r4tor4 (memory(ip),buffer(1+koffs),sizbuf-koffs)
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) then
            Print *,'DUMPE -- NATIVE Buffer ',i,ikbfi,ikbla,' Write IER ',ier,sizbuf
            goto 90
          endif
          ip = ip+sizbuf-koffs
          ileft = ileft-sizbuf+koffs
        else
          ier = gio_wiox (lun,i,memory(ip),sizbuf)
          if (ier.ne.0) then 
            Print *,'DUMPE -- Direct write ',i,ikbfi,ikbla,' Write IER ',ier
            goto 90
          endif
          ip = ip+sizbuf
          ileft = ileft-sizbuf
        endif
        iwblock(is) = i*isbig(is)
        imblock(is) = max(iwblock(is),imblock(is))
      enddo
      !
      ! Last buffer may be incomplete
      if (ikbla.le.imblock(is)/isbig(is)) then
        ier = gio_riox(lun,ikbla,buffer,sizbuf)
        if (ier.ne.0) then
          Print *,'DUMPE - NATIVE Buffer ',i,ikbfi,ikbla,' Read IER ',ier,sizbuf
          Print *,'IMBLOCk ',imblock(is),' StartBlock ',istbl(is)
          goto 90
        endif
      endif
      if (ikbla.eq.ikbfi) then
        call r4tor4(memory(ip),buffer(koffs+1),ileft)
      else
        call r4tor4(memory(ip),buffer,ileft)
      endif
      ier = gio_wiox(lun,ikbla,buffer,sizbuf)
      if (ier.ne.0) then
        Print *,'DUMPE -- Last Buffer IKBLA ',ikbla,' Write IER ',ier
        goto 90
      endif
      iwblock(is) = i*isbig(is)
      imblock(is) = max(iwblock(is),imblock(is))
    else
      ! As above, but with format Conversion
      !!Print *,'CONVERT ',iform(is), form
      ileft = mleng(ms)
      do i=ikbfi,ikbla-1
        if (i.eq.ikbfi) then
          ier = gio_riox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ier = gdf_conv(memory(ip),buffer(1+koffs),sizbuf-koffs,form,iform(is))
          if (ier.ne.1) goto 80
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf-koffs
          ileft = ileft-sizbuf+koffs
        else
          ier = gdf_conv(memory(ip),buffer,sizbuf,form,iform(is))
          if (ier.ne.1) goto 80
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
          ileft = ileft-sizbuf
        endif
      enddo
      ier = gio_riox(lun,ikbla,buffer,sizbuf)
      if (ikbla.eq.ikbfi) then
        ier = gdf_conv(memory(ip),buffer(koffs+1),ileft,form,iform(is))
      else
        ier = gdf_conv(memory(ip),buffer,ileft,form,iform(is))
      endif
      ier = gio_wiox(lun,ikbla,buffer,sizbuf)
      if (ier.ne.0) goto 90
    endif
  else !! if (islot(is).eq.code_gio_dumpi) then
    !
    ! WRITE, DUMPI state: Write the file
    !
    ! Here, the MOFFS(MS) pointer and MLENG(MS) size take into account the
    ! rounding to an integer number of blocks.
    !
    ! So we use a different system to read and write.
    !
    sizbuf = isbig(is) * lenbuf
    if (isbig(is).ne.1) then
      ikbfi = moffs(ms)/4/sizbuf + 1
      !!          Print *,'Big ',4*LENBIG*(IKBFI-1)+512, moffs(ms)
      ikbla = ikbfi + (mleng(ms)-1)/sizbuf ! Last buffer address
    else
      ikbfi = moffs(ms)/4/sizbuf + 1 + istbl(is)   ! First buffer address
      !!          Print *,'Small ',4*LENBUF*(IKBFI-1), moffs(ms)
      ikbla = ikbfi + (mleng(ms)-1)/sizbuf ! Last buffer address
    endif
    !
    open(unit=iunit(is),file=cname(is),status='OLD',form='UNFORMATTED',  &
         access='DIRECT',recl=sizbuf*facunf,iostat=ier)
    if (ier.ne.0) then
      Print *,'Opened in DUMPI ',islot(is),code_gio_dumpi
      goto 90
    endif
    !
    ip = gag_pointer(maddr(1,ms),memory)
    !
    ! Write file (Version OK for WRITE and DUMPI)
    ! Code should now be correct even for DUMPE
    !
    ! Well, now the test differs whether it is a "big" or "small" block...
    !!Print *,'DUMPI -- WMSLOT Iform ',iform(is), ' MFORM ',mform(ms)
    !!Print *,'DUMPI -- MLENG ',mleng(ms), ' IKB ',ikbfi,ikbla
    if (iform(is).eq.mform(ms)) then
      !!Print *,'NATIVE '
      if (isbig(is).ne.1) then
        do i=ikbfi,ikbla-1
          ! Here we read the Header Buffers...
          if (i.eq.1) then
            ier = gio_riox (lun,i,buffer,lenbuf*istbl(is))  ! Just read the header blocks
            if (ier.ne.0) goto 90
            call r4tor4 (buffer,memory(ip),lenbuf*istbl(is))
          endif
          ! and write the "big" buffer
          ier = gio_wiox (lun,i,memory(ip),sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
        enddo
        !
        ! Last buffer is special
        lasbuf = mod(mleng(ms),sizbuf)
        if (lasbuf.eq.0) lasbuf = sizbuf
        if (ikbla.eq.1) then
          ier = gio_riox (lun,ikbla,buffer,lenbuf*istbl(is))
          if (ier.ne.0) goto 90
          call r4tor4 (buffer,memory(ip),lenbuf*istbl(is))
        endif
        ier = gio_wiox (lun,ikbla,memory(ip),lasbuf)
!!        Print *,'Last buffer ',ier,lasbuf
!!        call r4tor4(memory(ip),buffer,lasbuf)
!!        Print *,'Last buffer ',buffer(1:lasbuf)
        if (ier.ne.0) goto 90
      else
        !
        ! Header blocks cannot be present here
        do i=ikbfi,ikbla-1
          if (ikbfi.le.istbl(is)) then
            print *,'Major programming error IKBFI ',ikbfi,  &
            & ' < istbl(is) ',istbl(is)
            STOP
          endif
          ! Write the "small" buffer
          ier = gio_wiox (lun,i,memory(ip),sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
        enddo
        !
        ! Last buffer is special
        lasbuf = mod(mleng(ms),sizbuf)
        if (lasbuf.eq.0) lasbuf = sizbuf
        ier = gio_wiox (lun,ikbla,memory(ip),lasbuf)
        if (ier.ne.0) goto 90
      endif
      !
    else
      ! With conversion
      Print *,'CONVERT ',iform(is), mform(ms), isbig(is)
      if (isbig(is).ne.1) then
        do i=ikbfi,ikbla-1
          ! Here we read the Header Buffer...
          if (i.eq.1) then
            ier = gio_riox (lun,i,buffer,lenbuf*istbl(is))
            if (ier.ne.0) goto 90
            ier = gdf_conv(memory(ip+lenbuf*istbl(is)), &
          &     buffer(1+lenbuf*istbl(is)),sizbuf-lenbuf*istbl(is),  &
                iform(is),mform(ms))
          else
            ier = gdf_conv(memory(ip),buffer,sizbuf,iform(is),mform(ms))
          endif
          if (ier.ne.1) goto 80
          ! and write the "big" buffer
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
        enddo
        !
        ! Last buffer is special: length may be shorter
        lasbuf = mod(mleng(ms),sizbuf)
        if (lasbuf.eq.0) lasbuf = sizbuf
        if (ikbla.eq.1) then
          ier = gio_riox (lun,ikbla,buffer,lenbuf*istbl(is))
          if (ier.ne.0) goto 90
          ier = gdf_conv(memory(ip+lenbuf*istbl(is)), &
          &     buffer(1+lenbuf*istbl(is)),lasbuf-lenbuf*istbl(is),  &
                iform(is),mform(ms))
        else
          ier = gdf_conv(memory(ip),buffer,lasbuf,iform(is),mform(ms))
        endif
        if (ier.ne.1) goto 80
        ier = gio_wiox (lun,ikbla,buffer,lasbuf)
        if (ier.ne.0) goto 90
      else
        !
        ! Header blocks cannot be present here
        do i=ikbfi,ikbla-1
          if (ikbfi.le.istbl(is)) then
            print *,'Major programming error IKBFI ',ikbfi,  &
            & ' < istbl(is) ',istbl(is)
            STOP
          endif
          ier = gdf_conv(memory(ip),buffer,sizbuf,iform(is),mform(ms))
          if (ier.ne.1) goto 80
          ! Write the "small" buffer
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
        enddo
        !
        ! Last buffer is special: length may be shorter
        lasbuf = mod(mleng(ms),sizbuf)
        if (lasbuf.eq.0) lasbuf = sizbuf
        ier = gdf_conv(memory(ip),buffer,lasbuf,iform(is),mform(ms))
        if (ier.ne.1) goto 80
        ier = gio_wiox (lun,ikbla,buffer,lasbuf)
        if (ier.ne.0) goto 90
      endif
    endif
  endif                        !
  goto 100
  !
  ! Free virtual memory
80 call gio_message(seve%e,rname,'Output conversion error in data')
  Print *,iform(is),mform(ms),ier
  error = .true.
  goto 100
  !
90 call gio_message(seve%e,rname,'Write error in data')
  call putios(seve%e,rname,ier)
  Print *,'Blocks ',irblock(is),iwblock(is),imblock(is)
  Print *,'OFFSETS ',koffs,ileft
  error = .true.
  goto 100
  !
100 continue
  close (unit=iunit(is))
  !
  ! Free Virtual memory if allocated by the Image Library
  !
  !!      Print *,'Slot Status ',islot(is),write,dumpi
  if (islot(is).eq.code_gio_write) then
    !!         Print *,'FREE_VM Freeing memory '
    call free_vm (mleng(ms),maddr(1,ms))
  endif
end subroutine gio_wmslot
!
subroutine gio_buffs_vm(big,ioffs,size,ikbfi,ikbla,sizbuf,stablo)
  use gio_interfaces, except_this=>gio_buffs_vm
  use gildas_def
  use gio_image
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: big ! Blocking factor
  integer(kind=size_length),   intent(inout) :: ioffs   ! Memory offset
  integer(kind=size_length),   intent(inout) :: size    ! Effective size in words
  integer(kind=record_length), intent(out)   :: ikbfi   ! First block
  integer(kind=record_length), intent(out)   :: ikbla   ! Last block
  integer(kind=4),             intent(out)   :: sizbuf  ! Buffer Size in words (output)
  integer(kind=4),             intent(in)    :: stablo  ! Number of Starting Blocks
  !
  if (big.ne.1) then
    ! Note that first BIG block is read
    ioffs = ioffs+4*stablo*lenbuf ! Add header small buffers
    sizbuf = lenbuf*big
    ikbfi = ioffs/4/sizbuf + 1             ! First BIG block
    ikbla = (ioffs/4+size-1)/sizbuf + 1    ! Last BIG block
    size = sizbuf*(ikbla-ikbfi+1)          ! In words
  else
    ! Note that the Header Blocks are skipped
    ikbfi = ioffs/4/lenbuf + 1 + stablo              ! First buffer address
    ikbla = (ioffs/4+size-1)/lenbuf + 1 + stablo     ! Last buffer address
    size = (ikbla-ikbfi+1)*lenbuf
    sizbuf = lenbuf
  endif
end subroutine gio_buffs_vm
!
subroutine gio_umps (ms,error)
  use gio_interfaces, except_this=>gio_umps
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF   UPdate Memory Slot
  !             Write it to file if needed
  !
  ! THIS ROUTINE IS NOW OBSOLETE (Apr 2014)
  ! and the code code_gdf_dumpi  also
  !---------------------------------------------------------------------
  integer, intent(in)  :: ms                     ! Memory slot
  logical, intent(out) :: error                  ! Error flag
  !
  character(len=*), parameter :: rname='GIO_UPMS'
  ! Local
  integer :: is,jslot
  !
  is = mslot(ms)
  if (is.eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Memory slot is empty')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Contiguous slot
  if (mcont(ms)) then
    !
    ! If virtual memory, free it
    if (mleng(ms).lt.0) then
      call gio_message(seve%e,rname,'Virtual Memory slot cannot be '//  &
      'updated')
      error = .true.
      return
    else
      if (mapped(is)) then
        return
      else
        !
        ! Write disk file
        jslot = islot(is)
        islot(is) = code_gio_dumpi
        call gio_wmslot (ms,iunit(is),error)
        maddr(1,ms) = 0
        maddr(2,ms) = 0
        mleng(ms) = 0
        mslot(ms) = code_gio_empty
        ! Restore slot status
        islot(is) = jslot
      endif
    endif
    !
  else
    error = .true.
    ! Not contiguous Read-Only:
    if (islot(is).lt.code_gio_write) then
      call gio_message(seve%e,rname,'Read-0nly Memory slot cannot be '//  &
      'updated')
    else
      ! Not contiguous : update line by line
      call gio_message(seve%e,rname,'Inconsistent state of GDF library')
      call gio_message(seve%e,rname,'Non-contiguous WRITE slot')
    endif
  endif
end subroutine gio_umps
!
subroutine gio_zams (ms,error)
  use gio_interfaces, except_this=>gio_zams
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF   ZAp Memory Slot
  !                     Just delete it, don't do anything else
  !---------------------------------------------------------------------
  integer, intent(in)  :: ms                     ! Memory slot
  logical, intent(out) :: error                  ! Error flag
  character(len=*), parameter :: rname='GIO_ZAMS'
  ! Local
  integer :: is
  !
  is = mslot(ms)
  if (is.eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Memory slot is empty')
    error = .true.
    return
  endif
  !
  maddr(1,ms) = 0
  maddr(2,ms) = 0
  mleng(ms) = 0
  mslot(ms) = code_gio_empty
end subroutine gio_zams
!
subroutine patch_weight(icode,uv,nx,ny,nz,nt)
  use gio_interfaces
  use gio_params
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Patch UV data weights for old data
  !---------------------------------------------------------------------
  integer, intent(in) :: icode      ! Data code > 0 means UVT order, < 0 means TUV order
  integer(kind=index_length), intent(in) :: nx                     !
  integer(kind=index_length), intent(in) :: ny                     !
  integer(kind=index_length), intent(in) :: nz                     !
  integer(kind=index_length), intent(in) :: nt                     !
  real, intent(inout) :: uv(nx,ny,nz,nt)        !
  ! Local
  integer(kind=index_length) :: i,j,k,l
  !
  !!      PRINT *,'icode ',ICODE
  !!      READ(5,*) ICODE
  if (icode.gt.0) then
    do l=1,nt
      do k=1,nz
        do j=1,ny
          do i=10,nx,3
            uv(i,j,k,l) = 2.0*uv(i,j,k,l)
          enddo
        enddo
      enddo
    enddo
  elseif  (icode.lt.0) then
    do l=1,nt
      do k=1,nz
        do j=10,ny,3
          do i=1,nx
            uv(i,j,k,l) = 2.0*uv(i,j,k,l)
          enddo
        enddo
      enddo
    enddo
  endif
end subroutine patch_weight

module mrtindex_list_colnames
  !
  integer(kind=4), parameter :: ncolumns=31
  character(len=11) :: columns(ncolumns) = (/  &
    'NUMBER     ','ENTRY      ','DIRECTORY  ','FITSFILE   ','MRTFILE    ',  &  !  1- 5
    'RECORD     ','WORD       ','VERSION    ','TELESCOPE  ','PROJID     ',  &  !  6-10
    'SOURCE     ','OBSERVED   ','UT         ','LST        ','AZIMUTH    ',  &  ! 11-15
    'ELEVATION  ','POSITION   ','FRONTEND   ','SCAN       ','BACKEND    ',  &  ! 16-20
    'OBSTYPE    ','SWITCHMODE ','POLARIMETRY','COMPLETE   ','CALIBRATED ',  &  ! 21-25
    'SOLVED     ','ITIME      ','ISLAST     ','WITH       ','RESULTS    ',  &  ! 26-30
    'DEFAULT    ' /)                                                           ! 31
  !
  integer(kind=4), parameter :: col_none        = 0  ! Nullifier
  integer(kind=4), parameter :: col_number      = 1
  integer(kind=4), parameter :: col_entry       = 2
  integer(kind=4), parameter :: col_directory   = 3
  integer(kind=4), parameter :: col_fitsfile    = 4
  integer(kind=4), parameter :: col_mrtfile     = 5
  integer(kind=4), parameter :: col_record      = 6
  integer(kind=4), parameter :: col_word        = 7
  integer(kind=4), parameter :: col_version     = 8
  integer(kind=4), parameter :: col_telescope   = 9
  integer(kind=4), parameter :: col_projid      = 10
  integer(kind=4), parameter :: col_source      = 11
  integer(kind=4), parameter :: col_observed    = 12
  integer(kind=4), parameter :: col_ut          = 13
  integer(kind=4), parameter :: col_lst         = 14
  integer(kind=4), parameter :: col_azimuth     = 15
  integer(kind=4), parameter :: col_elevation   = 16
  integer(kind=4), parameter :: col_position    = 17
  integer(kind=4), parameter :: col_frontend    = 18
  integer(kind=4), parameter :: col_scan        = 19
  integer(kind=4), parameter :: col_backend     = 20
  integer(kind=4), parameter :: col_obstype     = 21
  integer(kind=4), parameter :: col_switchmode  = 22
  integer(kind=4), parameter :: col_polarimetry = 23
  integer(kind=4), parameter :: col_complete    = 24
  integer(kind=4), parameter :: col_calibrated  = 25
  integer(kind=4), parameter :: col_solved      = 26
  integer(kind=4), parameter :: col_itime       = 27
  integer(kind=4), parameter :: col_islast      = 28
  integer(kind=4), parameter :: col_with        = 29
  integer(kind=4), parameter :: col_results     = 30
  ! Aliases
  integer(kind=4), parameter :: col_default     = 31
  !
  ! Aliases translation
  integer(kind=4), parameter :: col_default_list(12) =  &
    [col_number,col_version,col_projid,col_source,col_observed,  &
     col_ut,col_scan,col_backend,col_obstype,col_switchmode,  &
     col_calibrated,col_solved]
  !
end module mrtindex_list_colnames
!
module mrtindex_toc_parameters
  !---------------------------------------------------------------------
  ! Support module for Table-Of-Contents
  !---------------------------------------------------------------------
  !
  ! Key codes
  integer(kind=4), parameter :: mrtindex_toc_key_number    = 1
  integer(kind=4), parameter :: mrtindex_toc_key_version   = 2
  integer(kind=4), parameter :: mrtindex_toc_key_telescope = 3
  integer(kind=4), parameter :: mrtindex_toc_key_projid    = 4
  integer(kind=4), parameter :: mrtindex_toc_key_source    = 5
  integer(kind=4), parameter :: mrtindex_toc_key_observed  = 6
  integer(kind=4), parameter :: mrtindex_toc_key_frontend  = 7
  integer(kind=4), parameter :: mrtindex_toc_key_scan      = 8
  integer(kind=4), parameter :: mrtindex_toc_key_backend   = 9
  integer(kind=4), parameter :: mrtindex_toc_key_obstype   = 10
  integer(kind=4), parameter :: mrtindex_toc_key_switch    = 11
  integer(kind=4), parameter :: mrtindex_toc_key_polar     = 12
  integer(kind=4), parameter :: mrtindex_toc_key_calstatus = 13
  integer(kind=4), parameter :: mrtindex_toc_key_directory = 14
  !
  ! Mrtcal types, i.e. for fields which needs special decoding (e.g. gag_date:
  ! we won't display the I*4 value, but its translation as a string)
  integer(kind=4), parameter :: mrtindex_ptype_null=0
  integer(kind=4), parameter :: mrtindex_ptype_teles=1
  integer(kind=4), parameter :: mrtindex_ptype_gagdate=2
  integer(kind=4), parameter :: mrtindex_ptype_backend=3
  integer(kind=4), parameter :: mrtindex_ptype_obstype=4
  integer(kind=4), parameter :: mrtindex_ptype_switchmode=5
  integer(kind=4), parameter :: mrtindex_ptype_polarimetry=6
  integer(kind=4), parameter :: mrtindex_ptype_calstatus=7
  integer(kind=4), parameter :: mrtindex_ptype_directory=8
  integer(kind=4), parameter :: mrtindex_ptype_frontend=9
end module mrtindex_toc_parameters
!
module mrtindex_sort_var
  use toc_types
  !---------------------------------------------------------------------
  ! Support module for Table-Of-Contents
  !---------------------------------------------------------------------
  !
  type(toc_t), target :: mtoc
  !
end module mrtindex_sort_var
!
subroutine mrtindex_list_columns(line,custom,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_list_columns
  use mrtindex_list_colnames
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command:
  !   MLIST /COLUMNS Key1 ... KeyN
  ! Get the custom list of columns identifiers
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       !
  integer(kind=4),  intent(out)   :: custom(:)  !
  logical,          intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='MLIST'
  integer(kind=4) :: iarg,nc
  integer(kind=4) :: ukeys(size(custom))
  character(len=12) :: argum,key
  !
  custom(:) = col_none
  ukeys(:) = col_none
  !
  do iarg=1,sic_narg(3)
    if (iarg.gt.size(ukeys)) then
      call mrtindex_message(seve%w,rname,'/COLUMNS list too long, truncated')
      return
    endif
    !
    call sic_ke(line,3,iarg,argum,nc,.true.,error)
    if (error)  return
    call sic_ambigs(rname,argum,key,ukeys(iarg),columns,ncolumns,error)
    if (error)  return
  enddo
  !
  call mrtindex_list_columns_set(ukeys,size(ukeys),custom,size(custom),error)
  if (error)  return
  !
end subroutine mrtindex_list_columns
!
subroutine mrtindex_list_columns_set(ukeys,nukeys,ckeys,nckeys,error)
  use gbl_message
  use mrtindex_list_colnames
  !---------------------------------------------------------------------
  ! @ private
  ! Translate user keys to column keys.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: nukeys     !
  integer(kind=4), intent(in)    :: nckeys     !
  integer(kind=4), intent(in)    :: ukeys(nukeys)  !
  integer(kind=4), intent(out)   :: ckeys(nckeys)  !
  logical,         intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='MLIST'
  integer(kind=4) :: ikey,iout,nnew
  integer(kind=4) :: new(size(col_default_list))
  !
  ckeys(:) = col_none
  iout = 0
  !
  do ikey=1,nukeys
    if (ukeys(ikey).eq.col_none)  exit
    !
    select case (ukeys(ikey))
    case (col_default)
      nnew = size(col_default_list)
      new(1:nnew) = col_default_list
    case default
      nnew = 1
      new(1) = ukeys(ikey)
    end select
    !
    if (iout+nnew.gt.nckeys) then
      call mrtindex_message(seve%w,rname,'/COLUMNS list too long, truncated')
      return
    endif
    ckeys(iout+1:iout+nnew) = new(1:nnew)
    iout = iout+nnew
  enddo
  !
end subroutine mrtindex_list_columns_set
!
subroutine mrtindex_list(optx,name,custom,olun,page,error)
  use gbl_message
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_interfaces, except_this=>mrtindex_list
  use mrtindex_types
  use mrtindex_list_colnames
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: optx       !
  character(len=*),          intent(in)    :: name       !
  integer(kind=4),           intent(in)    :: custom(:)  ! Columns to be listed
  integer(kind=4),           intent(in)    :: olun       ! Output logical unit
  logical,                   intent(in)    :: page       ! Page or Scroll mode?
  logical,                   intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='MLIST'
  logical, parameter :: rawdebug=.false.
  integer(kind=entry_length) :: ient,jent
  integer(kind=4) :: tt_lines
  logical :: defaul
  character(len=message_length) :: mess
  !
  if (optx%next.le.1) then
    call mrtindex_message(seve%w,rname,'No entry in '//trim(name)//' index')
    return
  endif
  !
  defaul = custom(1).eq.col_none
  tt_lines = sic_ttynlin()-2
  !
  ! Print header
  ient = 0  ! <=> Header
  if (rawdebug) then
    call mrtindex_list_one_raw(optx,ient,mess,error)
  elseif (defaul) then
    call mrtindex_list_one_default(optx,ient,mess,error)
  else
    call mrtindex_list_one_custom(optx,ient,custom,mess,error)
  endif
  call mrtindex_list_one_print(mess,olun)
  !
  do ient=1,optx%next-1
    jent = optx%sort(ient)
    !
    if (olun.eq.6 .and. page) then
      if (mod(ient,tt_lines).eq.0) then
        if (hlp_more().ne.0)  return
      endif
    endif
    !
    if (rawdebug) then
      call mrtindex_list_one_raw(optx,jent,mess,error)
    elseif (defaul) then
      call mrtindex_list_one_default(optx,jent,mess,error)
    else
      call mrtindex_list_one_custom(optx,jent,custom,mess,error)
    endif
    if (error)  return
    call mrtindex_list_one_print(mess,olun)
    !
  enddo
  !
end subroutine mrtindex_list
!
subroutine mrtindex_list_one_raw(optx,ient,mess,error)
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_list_one_raw
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   MLIST [IN|OUT] [/FILE OutputFile]
  ! Print 1 line for 1 entry (debugging output => raw values)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  character(len=*),           intent(out)   :: mess   !
  logical,                    intent(inout) :: error  !
  !
  if (ient.eq.0) then
    ! Print header and quit
    write(mess,100)
  else
    write(mess,101)            &
      optx%mnum(ient),         &
      optx%num(ient),          &
      optx%version(ient),      &
      optx%filename(ient),     &
      optx%fnum(ient),         &
      optx%bloc(ient),         &
      optx%word(ient),         &
      optx%telescope(ient),    &
      optx%projid(ient),       &
      optx%source(ient),       &
      optx%dobs(ient)
      !
    write(mess,102)            &
      trim(mess),              &
      optx%ut(ient),           &
      optx%lst(ient),          &
      optx%az(ient),           &
      optx%el(ient),           &
      optx%lon(ient),          &
      optx%lat(ient),          &
      optx%system(ient),       &
      optx%equinox(ient)
      !
    write(mess,103)            &
      trim(mess),              &
      optx%frontend(1,ient),   &
      optx%frontend(2,ient),   &
      optx%frontend(3,ient),   &
      optx%frontend(4,ient)
      !
    write(mess,104)            &
      trim(mess),              &
      optx%scan(ient),         &
      optx%backend(ient),      &
      optx%obstype(ient),      &
      optx%switchmode(ient),   &
      optx%polstatus(ient),    &
      optx%filstatus(ient),    &
      optx%calstatus(ient),    &
      optx%solstatus(ient),    &
      optx%itime(ient),        &
      optx%idir(ient),         &
      optx%islast(ient)
  endif
  !
100 format(                                                                                &
  '# N.V File                                    Ent Blo Wor Tel Pro Source      Date  ',  &
  'UT         LST       Az        El             Frontend                         ',       &
  'Sca Bac Typ Swi Pol Com Cal Sol Time              Dir Last')
  !
  !         #    Num   Ver   File   Ent   Blo   Wor   Tel   Pro    Sour  Dobs
101 format(I0,1X,I0,1X,I0,1X,A40,1X,I0,1X,I0,1X,I0,1X,I0,1X,A8,1X,A12,1X,I5)
  !        Mess UT      LST     Az      El      Lon-Lat    Syst  Equinox
102 format(A,1X,F0.8,1X,F0.8,1X,F0.8,1X,F0.8,1X,2(F0.5,1X),I0,1X,F0.2)
  !        Mess Frontend
103 format(A,1X,4(A8,1X))
  !        Mess Sca   Bac   Typ   Swi   Pol   Com   Cal   Sol   Tim   Dir   Last
104 format(A,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,L1)
end subroutine mrtindex_list_one_raw
!
subroutine mrtindex_list_one_default(optx,ient,mess,error)
  use phys_const
  use classic_api
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_list_one_default
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command
  !   MLIST [IN|OUT]
  ! Print 1 line for 1 entry (default output)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  character(len=*),           intent(out)   :: mess   !
  logical,                    intent(inout) :: error  !
  ! Local
  real(kind=8), parameter :: rad_per_tsec=pi/4.32d4  ! Radians per seconds (time)
  character(len=11) :: date,num
  character(len=13) :: ut
  integer(kind=4) :: n2,nl
  !
  if (ient.eq.0) then
    ! Print header and quit
    write(mess,100)
    return
    !
  else
    if (optx%num(ient).lt.1000) then
      write(num(1:3),'(I3)')  optx%num(ient)
      n2 = 3
    else
      write(num,'(I0)') optx%num(ient)
      n2 = len_trim(num)
    endif
    call gag_todate(optx%dobs(ient),date,error)
    if (error)  return
    if (optx%ut(ient).ne.optx%ut(ient)) then  ! NaN
      ut = ' unknown'
    else
      call sexag(ut,optx%ut(ient),24)
    endif
    !
    write(mess,101)                               &
      num(1:n2),                                  &
      optx%version(ient),                         &
      optx%projid(ient),                          &
      optx%source(ient),                          &
      date,                                       &
      ut,                                         &
      optx%scan(ient),                            &
      backends_mrtcal(optx%backend(ient)),        &
      obstypes_mrtcal(optx%obstype(ient)),        &
      switchmodes_mrtcal(optx%switchmode(ient)),  &
      mrtindex_list_calstatus(optx%calstatus(ient)),  &
      mrtindex_list_solstatus(optx%solstatus(ient)),  &
      mrtindex_list_results(optx,ient)
    !
    nl = len_trim(mess)
    if (optx%filstatus(ient).ne.complete_full) then
      mess(nl+2:) = completenesses(optx%filstatus(ient))
    endif
  endif
  !
  !        'NNN.V PPPPPPPP SSSSSSSSSSSS DDDDDDDDDDD UUUUUUUUUUU SSS BBBBB OOOOOOOOOOO SSS CCCCCC SSSSSS RRRR...
100 format('  N.V ProjId    Source         Date          UT     Scn Backe  ObsType    Swi Calibr Solved Results')
  !        N    V     proj  sourc  date   ut     scan  back  obst   swit  cali
101 format(A,'.',I0,1X,A8,1X,A12,1X,A11,1X,A11,1X,I3,1X,A5,1X,A11,1X,A3,1X,A6,1X,A6,1X,A)
end subroutine mrtindex_list_one_default
!
subroutine mrtindex_list_one_custom(optx,ient,custom,mess,error)
  use gbl_constant
  use phys_const
  use classic_api
  use imbfits_parameters
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_list_one_custom
  use mrtindex_types
  use mrtindex_list_colnames
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   MLIST [IN|OUT]
  ! Print 1 line for 1 entry (custom output)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: optx       !
  integer(kind=entry_length), intent(in)    :: ient       !
  integer(kind=4),            intent(in)    :: custom(:)  !
  character(len=*),           intent(out)   :: mess       !
  logical,                    intent(inout) :: error      !
  ! Local
  integer(kind=4) :: icol,nc,nc2
  real(kind=8), parameter :: rad_per_tsec=pi/4.32d4  ! Radians per seconds (time)
  character(len=11) :: date
  character(len=13) :: str13
  character(len=128) :: results
  type(mrtindex_entry_t) :: entry
  !
  mess = ''
  nc = 0
  if (ient.eq.0) then
    ! Print header only
    do icol=1,size(custom)
      select case (custom(icol))
      case (col_number)
        write(mess(nc+1:),'(A6)')   'NUMBER'
        nc = nc+7
      case (col_entry)
        write(mess(nc+1:),'(A6)')   'ENTRY'
        nc = nc+7
      case (col_directory)
        write(mess(nc+1:),'(A20)')  '-----DIRECTORY------'
        nc = nc+21
      case (col_fitsfile)
        write(mess(nc+1:),'(A40)')  '----------------FITSFILE----------------'
        nc = nc+fitsname_length+1
      case (col_mrtfile)
        write(mess(nc+1:),'(A20)')  '------MRTFILE-------'
        nc = nc+21
      case (col_record)
        write(mess(nc+1:),'(A4)')   'RECO'
        nc = nc+5
      case (col_word)
        write(mess(nc+1:),'(A4)')   'WORD'
        nc = nc+5
      case (col_version)
        write(mess(nc+1:),'(A3)')   'VER'
        nc = nc+4
      case (col_telescope)
        write(mess(nc+1:),'(A8)')   'TELESCOP'
        nc = nc+9
      case (col_projid)
        write(mess(nc+1:),'(A8)')   '-PROJID-'
        nc = nc+9
      case (col_source)
        write(mess(nc+1:),'(A12)')  '---SOURCE---'
        nc = nc+13
      case (col_observed)
        write(mess(nc+1:),'(A11)')  '-OBSERVED--'
        nc = nc+12
      case (col_ut)
        write(mess(nc+1:),'(A11)')  '----UT-----'
        nc = nc+12
      case (col_lst)
        write(mess(nc+1:),'(A11)')  '----LST----'
        nc = nc+12
      case (col_azimuth)
        write(mess(nc+1:),'(A11)')  '--AZIMUTH--'
        nc = nc+12
      case (col_elevation)
        write(mess(nc+1:),'(A11)')  '-ELEVATION-'
        nc = nc+12
      case (col_position)
        write(mess(nc+1:),'(A36)')  '--------------POSITION--------------'
        nc = nc+37
      case (col_frontend)
        write(mess(nc+1:),'(A19)')  '------FRONTEND-----'
        nc = nc+20
      case (col_scan)
        write(mess(nc+1:),'(A3)')   'SCA'
        nc = nc+4
      case (col_backend)
        write(mess(nc+1:),'(A5)')   'BACKE'
        nc = nc+6
      case (col_obstype)
        write(mess(nc+1:),'(A11)')  '--OBSTYPE--'
        nc = nc+12
      case (col_switchmode)
        write(mess(nc+1:),'(A3)')   'SWI'
        nc = nc+4
      case (col_polarimetry)
        write(mess(nc+1:),'(A3)')   'POL'
        nc = nc+4
      case (col_complete)
        write(mess(nc+1:),'(A10)')  '-COMPLETE-'
        nc = nc+11
      case (col_calibrated)
        write(mess(nc+1:),'(A6)')   'CALIBR'
        nc = nc+7
      case (col_solved)
        write(mess(nc+1:),'(A6)')   'SOLVED'
        nc = nc+7
      case (col_itime)
        write(mess(nc+1:),'(A19)')  '-------ITIME-------'
        nc = nc+20
      case (col_islast)
        write(mess(nc+1:),'(A3)')   'LAS'
        nc = nc+4
      case (col_with)
        write(mess(nc+1:),'(A28)')  '---WITH (OBS SCA BAC VER)---'
        nc = nc+29
      case (col_results)
        write(mess(nc+1:),'(A7)')  'RESULTS'
        nc = nc+8
      case default
        exit
      end select
    enddo
    !
  else
    !
    do icol=1,size(custom)
      select case (custom(icol))
      case (col_number)
        write(mess(nc+1:),'(I6)')   optx%num(ient)
        nc = nc+7
      case (col_entry)
        write(mess(nc+1:),'(I6)')   optx%fnum(ient)
        nc = nc+7
      case (col_directory)
        write(mess(nc+1:),'(A20)')  ix_dirs(optx%idir(ient))
        nc = nc+21
      case (col_fitsfile)
        write(mess(nc+1:),'(A40)')  optx%filename(ient)
        nc = nc+fitsname_length+1
      case (col_mrtfile)
        write(mess(nc+1:),'(A20)')  ix_files(optx%idir(ient))%spec
        nc = nc+21
      case (col_record)
        write(mess(nc+1:),'(I4)')   optx%bloc(ient)
        nc = nc+5
      case (col_word)
        write(mess(nc+1:),'(I4)')   optx%word(ient)
        nc = nc+5
      case (col_version)
        write(mess(nc+1:),'(I3)')   optx%version(ient)
        nc = nc+4
      case (col_telescope)
        write(mess(nc+1:),'(A8)')   telescopes(optx%telescope(ient))
        nc = nc+9
      case (col_projid)
        write(mess(nc+1:),'(A8)')   optx%projid(ient)
        nc = nc+9
      case (col_source)
        write(mess(nc+1:),'(A12)')  optx%source(ient)
        nc = nc+13
      case (col_observed)
        call gag_todate(optx%dobs(ient),date,error)
        if (error)  return
        write(mess(nc+1:),'(A11)')  date
        nc = nc+12
      case (col_ut)
        if (optx%ut(ient).ne.optx%ut(ient)) then  ! NaN
          str13 = ' unknown'
        else
          call sexag(str13,optx%ut(ient),24)
        endif
        write(mess(nc+1:),'(A11)')  str13
        nc = nc+12
      case (col_lst)
        if (optx%lst(ient).ne.optx%lst(ient)) then  ! NaN
          str13 = ' unknown'
        else
          call sexag(str13,optx%lst(ient)*rad_per_tsec,24)
        endif
        write(mess(nc+1:),'(A11)')  str13
        nc = nc+12
      case (col_azimuth)
        if (optx%az(ient).ne.optx%az(ient)) then  ! NaN
          str13 = ' unknown'
        else
          write(str13,'(F0.8)') optx%az(ient)*deg_per_rad
        endif
        write(mess(nc+1:),'(A11)')  str13
        nc = nc+12
      case (col_elevation)
        if (optx%el(ient).ne.optx%el(ient)) then  ! NaN
          str13 = ' unknown'
        else
          write(str13,'(F0.8)') optx%el(ient)*deg_per_rad
        endif
        write(mess(nc+1:),'(A11)')  str13
        nc = nc+12
      case (col_position)
        if (optx%lon(ient).ne.optx%lon(ient)) then  ! NaN
          mess(nc+1:nc+12) = ' --:--:--.--'
        elseif (optx%system(ient).eq.type_eq) then
          call rad2sexa(optx%lon(ient), 24,mess(nc+1:nc+12))
        else
          call rad2sexa(optx%lon(ient),360,mess(nc+1:nc+12))
        endif
        nc = nc+13
        if (optx%lat(ient).ne.optx%lat(ient)) then  ! NaN
          mess(nc+1:nc+12) = ' ---:--:--.-'
        else
          call rad2sexa(optx%lat(ient),360,mess(nc+1:nc+12))
        endif
        nc = nc+13
        if (optx%system(ient).eq.type_eq) then
          write(mess(nc+1:),'(A3,1X,F0.1)')  'Eq.',optx%equinox(ient)
        elseif (optx%system(ient).eq.type_ga) then
          mess(nc+1:nc+3) = 'Ga.'
        else
          mess(nc+1:nc+2) = '??'
        endif
        nc = nc+11
      case (col_frontend)
        write(mess(nc+1:),'(A19)')  mrtindex_list_frontend(optx%frontend(:,ient))
        nc = nc+20
      case (col_scan)
        write(mess(nc+1:),'(I3)')   optx%scan(ient)
        nc = nc+4
      case (col_backend)
        write(mess(nc+1:),'(A5)')   backends_mrtcal(optx%backend(ient))
        nc = nc+6
      case (col_obstype)
        write(mess(nc+1:),'(A11)')  obstypes_mrtcal(optx%obstype(ient))
        nc = nc+12
      case (col_switchmode)
        write(mess(nc+1:),'(A3)')   switchmodes_mrtcal(optx%switchmode(ient))
        nc = nc+4
      case (col_polarimetry)
        write(mess(nc+1:),'(A3)')   polstatus(optx%polstatus(ient))
        nc = nc+4
      case (col_complete)
        write(mess(nc+1:),'(A10)')  completenesses(optx%filstatus(ient))
        nc = nc+11
      case (col_calibrated)
        write(mess(nc+1:),'(A6)')   calstatus(optx%calstatus(ient))
        nc = nc+7
      case (col_solved)
        write(mess(nc+1:),'(A6)')   solstatus(optx%solstatus(ient))
        nc = nc+7
      case (col_itime)
        write(mess(nc+1:),'(I19)')  optx%itime(ient)
        nc = nc+20
      case (col_islast)
        write(mess(nc+1:),'(L3)')   optx%islast(ient)
        nc = nc+4
      case (col_with)
        call mrtindex_optimize_to_entry(optx,ient,entry,error)
        if (error)  return
        call mrtindex_entry_lscience(entry%head,mess(nc+1:),nc2,error)
        if (error)  return
        nc = nc+nc2+1
      case (col_results)
        results = mrtindex_list_results(optx,ient)
        write(mess(nc+1:),'(A)')  trim(results)
        nc = nc+len_trim(results)+1
      case default
        exit
      end select
    enddo
    !
  endif
  !
  call mrtindex_entry_free(entry,error)
  if (error)  return
  !
end subroutine mrtindex_list_one_custom
!
function mrtindex_list_frontend(frontend) result(ostring)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the frontend string to be displayed by the MLIST command.
  ! Note the syntax must match the one understood by MFIND /FRONTEND
  !---------------------------------------------------------------------
  character(len=19) :: ostring ! 4 receivers * 4 chars + 3 ampersands
  character(len=*), intent(in) :: frontend(:)
  !
  integer(kind=4) :: ifront,nc,nc2
  !
  nc = 0
  do ifront=1,mrtcal_indx_mfrontend
    nc2 = len_trim(frontend(ifront))
    if (nc2.le.0)  exit
    write(ostring(nc+1:),'(A,A1)') frontend(ifront)(1:nc2),'&'
    nc = nc+nc2+1
  enddo
  if (nc.gt.0)  ostring(nc:nc) = ' '  ! Drop the last '&'
end function mrtindex_list_frontend
!
function mrtindex_list_calstatus(status)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Return the calibration status string to be displayed by the LIST
  ! command
  !---------------------------------------------------------------------
  character(len=calstatus_length) :: mrtindex_list_calstatus
  integer(kind=4), intent(in) :: status
  !
  select case (status)
  case (calstatus_none)
    mrtindex_list_calstatus = '--'
  case (calstatus_done,calstatus_failed,calstatus_empty,calstatus_skipped)
    mrtindex_list_calstatus = calstatus(status)
  case default
    mrtindex_list_calstatus = '???'
  end select
end function mrtindex_list_calstatus
!
function mrtindex_list_solstatus(status)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Return the solve status string to be displayed by the LIST command
  !---------------------------------------------------------------------
  character(len=solstatus_length) :: mrtindex_list_solstatus
  integer(kind=4), intent(in) :: status
  !
  select case (status)
  case (solstatus_none)
    mrtindex_list_solstatus = '--'
  case (solstatus_done,solstatus_failed)
    mrtindex_list_solstatus = solstatus(status)
  case default
    mrtindex_list_solstatus = '???'
  end select
end function mrtindex_list_solstatus
!
function mrtindex_list_results(optx,ient) result(string)
  use mrtindex_interfaces, except_this=>mrtindex_list_results
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! List the scan results (Tsys, pointing, etc).
  ! No error returned on purpose (LIST should not stop)
  !---------------------------------------------------------------------
  character(len=128) :: string
  type(mrtindex_optimize_t),  intent(in) :: optx
  integer(kind=entry_length), intent(in) :: ient
  ! Local
  type(mrtindex_entry_t) :: entry
  logical :: error
  !
  error = .false.
  !
  call mrtindex_optimize_to_entry(optx,ient,entry,error)
  if (error)  goto 10
  !
  if (entry%head%presec(sec_calib_id)) then
    call mrtindex_entry_lcalib(entry%head,string,error)
    if (error)  goto 10
  elseif (entry%head%presec(sec_pointing_id)) then
    call mrtindex_entry_lpointing(entry%head,string,error)
    if (error)  goto 10
  else
    string = ''
  endif
  !
  call mrtindex_entry_free(entry,error)
  if (error)  goto 10
  !
  return
10 continue
  string = '<error>'
end function mrtindex_list_results
!
subroutine mrtindex_list_one_print(message,olun)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_list_one_print
  !---------------------------------------------------------------------
  ! @ private
  !  Send the message to the given Logical Unit. Quite generic, could
  ! be used in other contexts.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: message
  integer(kind=4),  intent(in) :: olun
  ! Local
  character(len=*), parameter :: rname='MLIST'
  !
  if (olun.eq.6) then
    call mrtindex_message(seve%r,rname,message)
  else
    write(olun,'(A)') trim(message)
  endif
  !
end subroutine mrtindex_list_one_print
!
!=======================================================================
!
subroutine mrtindex_list_pointing(optx,name,olun,error)
  use gbl_message
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_list_pointing
  use mrtindex_types
  use mrtindex_table
  !---------------------------------------------------------------------
  ! @ public
  ! MRTCAL support routine for command
  !   MLIST [IN|CURRENT] /POINTING [/FILE Output]
  ! List the current with specific 'pointing' format (listing the
  ! pointing results)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: optx   !
  character(len=*),          intent(in)    :: name   ! Index name
  integer(kind=4),           intent(in)    :: olun   !
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MLIST>POINTING'
  integer(kind=entry_length) :: ient,jent
  type(mrtindex_entry_t) :: entry
  type(table_t) :: tab
  type(line_t) :: line
  !
  if (optx%next.le.1) then
    call mrtindex_message(seve%w,rname,'No entry in '//trim(name)//' index')
    return
  endif
  !
  ! Register columns
  call tab%register_column('Date','[gag]',6,'(i6)',error)
  if (error)  return
  call tab%register_column('Scan','',3,'(i3)',error)
  if (error)  return
  call tab%register_column('idBe','',5,'(a5)',error)
  if (error)  return
  call entry%head%poi%list_register_columns(tab,error)
  if (error)  return
  !
  ! List header
  call tab%header(olun,error)
  if (error)  return
  !
  ! List lines
  do ient=1,optx%next-1
    jent = optx%sort(ient)
    !
    call mrtindex_optimize_to_entry(optx,jent,entry,error)
    if (error)  return
    if (.not.entry%head%presec(sec_pointing_id))  cycle
    !
    call line%new_value(tab,entry%head%key%dobs,error)
    if (error)  return
    call line%new_value(tab,entry%head%key%scan,error)
    if (error)  return
    call line%new_value(tab,backends_mrtcal(entry%head%key%backend),error)
    if (error)  return
    call entry%head%poi%list(tab,line,entry%head%key%backend,olun,error)
    if (error)  return
    !
    call line%reset(error)
    if (error)  return
  enddo
  !
end subroutine mrtindex_list_pointing
!
!=======================================================================
!
subroutine mrtindex_list_toc_comm(optx,line,olun,error)
  use gildas_def
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_list_toc_comm
  use mrtindex_sort_var
  use mrtindex_toc_parameters
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  ! MRTCAL support routine for command
  !   MLIST [IN|CURRENT] /TOC [Key1] ... [KeyN]  [/VARIABLE VarName]
  ! Main entry point
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: optx   !
  character(len=*),          intent(in)    :: line   ! Input command line
  integer(kind=4),           intent(in)    :: olun   !
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4), parameter :: opttoc=1  ! /TOC
  integer(kind=4), parameter :: optvar=5  ! /VARIABLE
  integer(kind=4) :: toc_keys(13)  ! Arbitrary number of args accepted in option /TOC
  character(len=varname_length) :: tocname
  integer(kind=4) :: nc
  !
  call mrtindex_toc_init(mtoc,error)
  if (error)  return
  !
  ! Default (unchanged in no arguments)
  toc_keys(:) = toc_key_null
  toc_keys(1) = mrtindex_toc_key_observed
  toc_keys(2) = mrtindex_toc_key_scan
  call toc_getkeys(line,opttoc,mtoc,toc_keys,error)
  if (error)  return
  !
  tocname = 'MTOC'  ! Default structure name
  call sic_ch(line,optvar,1,tocname,nc,.false.,error)
  if (error)  return
  !
  call mrtindex_list_toc(optx,toc_keys,tocname,olun,error)
  if (error)  return
  !
end subroutine mrtindex_list_toc_comm
!
subroutine mrtindex_toc_init(toc,error)
  use gkernel_interfaces
  use toc_types
  use classic_api
  use mrtindex_toc_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! MRTCAL Support routine for command MLIST /TOC
  ! Initialization routine
  !---------------------------------------------------------------------
  type(toc_t), intent(inout) :: toc    !
  logical,     intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='TOC/INIT'
  integer(kind=4) :: ier
  !
  if (toc%initialized)  return
  !
  toc%nkey = 14
  allocate(toc%keys(toc%nkey),stat=ier)
  if (failed_allocate(rname,'keys array',ier,error)) return
  !
  toc%keys(1)%id            = mrtindex_toc_key_number
  toc%keys(1)%keyword       = 'NUM'
  toc%keys(1)%sic_var_name  = 'num'
  toc%keys(1)%human_name    = 'NUMBER'
  toc%keys(1)%message       = 'Number of numbers......'
  toc%keys(1)%ftype         = toc_ftype_i8_1d
  toc%keys(1)%ptype         = mrtindex_ptype_null
  !
  toc%keys(2)%id            = mrtindex_toc_key_version
  toc%keys(2)%keyword       = 'VER'
  toc%keys(2)%sic_var_name  = 'ver'
  toc%keys(2)%human_name    = 'VERSION'
  toc%keys(2)%message       = 'Number of versions.....'
  toc%keys(2)%ftype         = toc_ftype_i4_1d
  toc%keys(2)%ptype         = mrtindex_ptype_null
  !
  toc%keys(3)%id            = mrtindex_toc_key_telescope
  toc%keys(3)%keyword       = 'TELE'
  toc%keys(3)%sic_var_name  = 'tele'
  toc%keys(3)%human_name    = 'TELESCOPE'
  toc%keys(3)%message       = 'Number of telescopes...'
  toc%keys(3)%ftype         = toc_ftype_i4_1d
  toc%keys(3)%ptype         = mrtindex_ptype_teles
  !
  toc%keys(4)%id            = mrtindex_toc_key_projid
  toc%keys(4)%keyword       = 'ID'
  toc%keys(4)%sic_var_name  = 'id'
  toc%keys(4)%human_name    = 'ID'
  toc%keys(4)%message       = 'Number of projects.....'
  toc%keys(4)%ftype         = toc_ftype_c8_1d
  toc%keys(4)%ptype         = mrtindex_ptype_null
  !
  toc%keys(5)%id            = mrtindex_toc_key_source
  toc%keys(5)%keyword       = 'SOUR'
  toc%keys(5)%sic_var_name  = 'sour'
  toc%keys(5)%human_name    = 'SOURCE'
  toc%keys(5)%message       = 'Number of sources......'
  toc%keys(5)%ftype         = toc_ftype_c12_1d
  toc%keys(5)%ptype         = mrtindex_ptype_null
  !
  toc%keys(6)%id            = mrtindex_toc_key_observed
  toc%keys(6)%keyword       = 'OBS'
  toc%keys(6)%sic_var_name  = 'obs'
  toc%keys(6)%human_name    = 'OBSERVED' ! Observed date
  toc%keys(6)%message       = 'Number of observation dates'
  toc%keys(6)%ftype         = toc_ftype_i4_1d
  toc%keys(6)%ptype         = mrtindex_ptype_gagdate
  !
  toc%keys(7)%id            = mrtindex_toc_key_frontend
  toc%keys(7)%keyword       = 'FRONTEND'
  toc%keys(7)%sic_var_name  = 'frontend'
  toc%keys(7)%human_name    = 'FRONTEND'
  toc%keys(7)%message       = 'Number of frontends.....'
  toc%keys(7)%ftype         = toc_ftype_c8_2d
  toc%keys(7)%ptype         = mrtindex_ptype_frontend
  !
  toc%keys(8)%id            = mrtindex_toc_key_scan
  toc%keys(8)%keyword       = 'SCAN'
  toc%keys(8)%sic_var_name  = 'scan'
  toc%keys(8)%human_name    = 'SCAN'
  toc%keys(8)%message       = 'Number of scans........'
  toc%keys(8)%ftype         = toc_ftype_i4_1d
  toc%keys(8)%ptype         = mrtindex_ptype_null
  !
  toc%keys(9)%id            = mrtindex_toc_key_backend
  toc%keys(9)%keyword       = 'BACK'
  toc%keys(9)%sic_var_name  = 'back'
  toc%keys(9)%human_name    = 'BACKEND'
  toc%keys(9)%message       = 'Number of backends.....'
  toc%keys(9)%ftype         = toc_ftype_i4_1d
  toc%keys(9)%ptype         = mrtindex_ptype_backend
  !
  toc%keys(10)%id           = mrtindex_toc_key_obstype
  toc%keys(10)%keyword      = 'TYPE'
  toc%keys(10)%sic_var_name = 'type'
  toc%keys(10)%human_name   = 'OBSTYPE'
  toc%keys(10)%message      = 'Number of obs. types...'
  toc%keys(10)%ftype        = toc_ftype_i4_1d
  toc%keys(10)%ptype        = mrtindex_ptype_obstype
  !
  toc%keys(11)%id           = mrtindex_toc_key_switch
  toc%keys(11)%keyword      = 'SWITCH'
  toc%keys(11)%sic_var_name = 'switch'
  toc%keys(11)%human_name   = 'SWITCHMODE'
  toc%keys(11)%message      = 'Number of switch modes.'
  toc%keys(11)%ftype        = toc_ftype_i4_1d
  toc%keys(11)%ptype        = mrtindex_ptype_switchmode
  !
  toc%keys(12)%id           = mrtindex_toc_key_polar
  toc%keys(12)%keyword      = 'POLAR'
  toc%keys(12)%sic_var_name = 'polarimetry'
  toc%keys(12)%human_name   = 'POLARIMETRY'
  toc%keys(12)%message      = 'Number of polar. files.'
  toc%keys(12)%ftype        = toc_ftype_i4_1d
  toc%keys(12)%ptype        = mrtindex_ptype_polarimetry
  !
  toc%keys(13)%id           = mrtindex_toc_key_calstatus
  toc%keys(13)%keyword      = 'CALIB'
  toc%keys(13)%sic_var_name = 'calibrated'
  toc%keys(13)%human_name   = 'CALIBRATED'
  toc%keys(13)%message      = 'Number of calib status.'
  toc%keys(13)%ftype        = toc_ftype_i4_1d
  toc%keys(13)%ptype        = mrtindex_ptype_calstatus
  !
  toc%keys(14)%id           = mrtindex_toc_key_directory
  toc%keys(14)%keyword      = 'DIR'
  toc%keys(14)%sic_var_name = 'directory'
  toc%keys(14)%human_name   = 'DIRECTORY'
  toc%keys(14)%message      = 'Number of directories.'
  toc%keys(14)%ftype        = toc_ftype_i4_1d
  toc%keys(14)%ptype        = mrtindex_ptype_directory
  !
  call toc_init_pointers(toc,error)
  if (error)  return
  !
  toc%initialized = .true.
  !
end subroutine mrtindex_toc_init
!
subroutine mrtindex_toc_clean(error)
  use classic_api
  use mrtindex_sort_var
  !---------------------------------------------------------------------
  ! @ private
  ! MRTCAL Support routine for command MLIST /TOC
  ! Clean the global variable holding the TOC
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  !
  call toc_clean(mtoc,error)
  ! if (error)  continue
  !
end subroutine mrtindex_toc_clean
!
subroutine mrtindex_list_toc(optx,keywords,tocname,olun,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_list_toc
  use mrtindex_types
  use mrtindex_sort_var
  !---------------------------------------------------------------------
  ! @ private
  ! MRTCAL Support routine for command
  !   MLIST /TOC
  ! Processing routine
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: optx         ! The optx whose TOC is desired
  integer(kind=4),           intent(in)    :: keywords(:)  ! Key identifiers
  character(len=*),          intent(in)    :: tocname      ! Structure name
  integer(kind=4),           intent(in)    :: olun         !
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MLIST/TOC'
  !
  call mrtindex_toc_datasetup(mtoc,optx)
  !
  call toc_main(rname,mtoc,optx%next-1,keywords,tocname,olun,mrtindex_toc_format,error)
  if (error)  return
  !
end subroutine mrtindex_list_toc
!
subroutine mrtindex_toc_datasetup(toc,idx)
  use toc_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! MRTCAL support routine for command
  !   MLIST /TOC
  ! Associate the TOC data pointers to the index whose TOC is desired
  !---------------------------------------------------------------------
  type(toc_t),               intent(inout) :: toc
  type(mrtindex_optimize_t), intent(in)    :: idx  ! The idx whose TOC is desired
  !
  toc%keys( 1)%ptr%i8%data1  => idx%num
  toc%keys( 2)%ptr%i4%data1  => idx%version
  toc%keys( 3)%ptr%i4%data1  => idx%telescope
  toc%keys( 4)%ptr%c8%data1  => idx%projid
  toc%keys( 5)%ptr%c12%data1 => idx%source
  toc%keys( 6)%ptr%i4%data1  => idx%dobs
  toc%keys( 7)%ptr%c8%data2  => idx%frontend
  toc%keys( 8)%ptr%i4%data1  => idx%scan
  toc%keys( 9)%ptr%i4%data1  => idx%backend
  toc%keys(10)%ptr%i4%data1  => idx%obstype
  toc%keys(11)%ptr%i4%data1  => idx%switchmode
  toc%keys(12)%ptr%i4%data1  => idx%polstatus
  toc%keys(13)%ptr%i4%data1  => idx%calstatus
  toc%keys(14)%ptr%i4%data1  => idx%idir
  !
end subroutine mrtindex_toc_datasetup
!
subroutine mrtindex_toc_format(key,ival,output)
  use toc_types
  use imbfits_parameters
  use mrtindex_parameters
  use mrtindex_vars
  use mrtindex_toc_parameters
  use mrtindex_interfaces, except_this=>mrtindex_toc_format
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! MRTCAL support routine for command
  !   MLIST /TOC
  ! Custom display routine (because there are custom types)
  !---------------------------------------------------------------------
  type(toc_descriptor_t),     intent(in)  :: key     !
  integer(kind=entry_length), intent(in)  :: ival    !
  character(len=*),           intent(out) :: output  !
  ! Local
  integer(kind=4) :: nc,i
  logical :: error
  !
  select case(key%ftype)
  case(toc_ftype_i4_1d) ! integer*4
    if (key%ptype.eq.mrtindex_ptype_teles) then
      output = telescopes(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_gagdate) then
      call gag_todate(key%ptr%i4%data1(ival),output,error)
    elseif (key%ptype.eq.mrtindex_ptype_backend) then
      output = backends_mrtcal(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_obstype) then
      output = obstypes_mrtcal(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_switchmode) then
      output = switchmodes_mrtcal(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_polarimetry) then
      output = polstatus(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_calstatus) then
      output = calstatus(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_directory) then
      output = ix_dirs(key%ptr%i4%data1(ival))
    else
      write(output,'(i12)') key%ptr%i4%data1(ival)
    endif
    !
  case(toc_ftype_i8_1d)  ! integer*8
    write(output,'(i12)') key%ptr%i8%data1(ival)
    !
  case(toc_ftype_r4_1d)  ! real*4
    write(output,'(f8.3)') key%ptr%r4%data1(ival)
    !
  case(toc_ftype_c8_1d)  ! string*8
    output = key%ptr%c8%data1(ival)
    !
  case(toc_ftype_c12_1d) ! string*12
    output = key%ptr%c12%data1(ival)
    !
  case(toc_ftype_c8_2d)  ! string*8 (2D)
    if (key%ptype.eq.mrtindex_ptype_frontend) then
      output = mrtindex_list_frontend(key%ptr%c8%data2(:,ival))
    else  ! Generic formatting (unclear)
      nc = 1
      do i=1,ubound(key%ptr%c8%data2,1)
        output(nc:) = key%ptr%c8%data2(i,ival)
        nc = len_trim(output)+2  ! Compact the names
      enddo
    endif
  end select
  !
end subroutine mrtindex_toc_format

subroutine telcal_setup(line,error)
  use telcal_interfaces, except_this=>telcal_setup
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! TELCAL
  ! Support routine for command
  !   SET ATM
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='TELCAL_SET'
  character(len=*), parameter :: echain='E-'//rname//',  '
  integer, parameter :: mkeys=1
  integer :: nkey,nc
  character(len=12) :: arg,key,keys(mkeys)
  ! Data
  data keys /'ATM'/
  !
  call sic_ke(line,0,1,arg,nc,.true.,error)
  if (error) return
  call sic_ambigs('SET',arg,key,nkey,keys,mkeys,error)
  if (error) return
  !
  select case(key)
  !
  ! ATM model
  case ('ATM')
    call sic_ch(line,0,2,arg,nc,.true.,error)
    if (error) return
    call sic_upper(arg)  ! 'OLD', 'NEW', '1985', ...
    call atm_setup(arg,error)
  !
  case default
    call gagout(echain//trim(key)//' not yet implemented')
    error = .true.
  end select
  !
end subroutine telcal_setup

!  Support file for Class index. The Index provides a short summary of a
! given observation.
!
subroutine index_frombuf_v1(data,indl,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use classcore_interfaces, except_this=>index_frombuf_v1
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transfer the data(*) buffer from V1 to the last version of the
  ! index
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: data(*)  !
  type(indx_t),             intent(out)   :: indl     !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  type(indx_v1_t) :: ind1
  !
  ! Read in the indx sequence of length 'lenbi' integers
  if (conv%code.eq.0) then
    ! Native, copy the whole block (NB: might be a problem with the strings)
    call r4tor4(data(1),ind1%bloc,lind_v1)
  else
    ! Non native, conversion needed
    call conv%read%i4(data(1), ind1%bloc,   3)
    call conv%read%cc(data(4), ind1%csour,  3)
    call conv%read%cc(data(7), ind1%cline,  3)
    call conv%read%cc(data(10),ind1%ctele,  3)
    call conv%read%i4(data(13),ind1%dobs,   2)
    call conv%read%r4(data(15),ind1%off1,   2)
    call conv%read%i4(data(17),ind1%type,   4)
    call conv%read%r4(data(21),ind1%posa,   1)
    call conv%read%i4(data(22),ind1%subscan,1)
  endif
  !
  if (ind1%scan.eq.0) ind1%scan = ind1%num
  !
  ! Upper case conversion
  call sic_upper(ind1%csour)
  call sic_upper(ind1%cline)
  call sic_upper(ind1%ctele)
  !
  call index_v1tovl(ind1,indl,error)
  !
end subroutine index_frombuf_v1
!
subroutine index_v1tovl(ind1,indl,error)
  use classcore_interfaces, except_this=>index_v1tovl
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transform the index V1 into an index last version
  !---------------------------------------------------------------------
  type(indx_v1_t), intent(in)    :: ind1   !
  type(indx_t),    intent(out)   :: indl   !
  logical,         intent(inout) :: error  !
  !
  indl%bloc    = ind1%bloc  ! Record number where observation starts
  indl%word    = 1          ! In this record, the word where the observation starts
  indl%num     = ind1%num
  indl%ver     = ind1%ver
  indl%csour   = ind1%csour
  indl%cline   = ind1%cline
  indl%ctele   = ind1%ctele
  indl%dobs    = ind1%dobs
  indl%dred    = ind1%dred
  indl%off1    = ind1%off1
  indl%off2    = ind1%off2
  indl%type    = ind1%type
  indl%kind    = ind1%kind
  indl%qual    = ind1%qual
  indl%scan    = ind1%scan
  indl%posa    = ind1%posa
  indl%subscan = ind1%subscan
  indl%ut      = ut_null
  !
end subroutine index_v1tovl
!
subroutine index_frombuf_v2orv3(data,isv3,indl,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use classcore_interfaces, except_this=>index_frombuf_v2orv3
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transfer the data(*) buffer from V2 or V3 to the last version of
  ! the index
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: data(*)  !
  logical,                  intent(in)    :: isv3     !
  type(indx_t),             intent(out)   :: indl     !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  !
  ! Read in the indx. Since the index in memory is not correctly
  ! aligned (memory padding, no SEQUENCE), we MUST read the elements
  ! one by one.
  call conv%read%i8(data(1), indl%bloc,   1)  ! bloc
  call conv%read%i4(data(3), indl%word,   1)  ! word
  call conv%read%i8(data(4), indl%num,    1)  ! num
  call conv%read%i4(data(6), indl%ver,    1)  ! ver
  call conv%read%cc(data(7), indl%csour,  3)  ! csour
  call conv%read%cc(data(10),indl%cline,  3)  ! cline
  call conv%read%cc(data(13),indl%ctele,  3)  ! ctele
  call conv%read%i4(data(16),indl%dobs,   1)  ! dobs
  call conv%read%i4(data(17),indl%dred,   1)  ! dred
  call conv%read%r4(data(18),indl%off1,   1)  ! off1
  call conv%read%r4(data(19),indl%off2,   1)  ! off2
  call conv%read%i4(data(20),indl%type,   1)  ! type
  call conv%read%i4(data(21),indl%kind,   1)  ! kind
  call conv%read%i4(data(22),indl%qual,   1)  ! qual
  call conv%read%r4(data(23),indl%posa,   1)  ! posa
  call conv%read%i8(data(24),indl%scan,   1)  ! scan
  call conv%read%i4(data(26),indl%subscan,1)  ! subscan
  if (isv3) then
    call conv%read%r8(data(27),indl%ut,   1)  ! ut
  else
    indl%ut = ut_null
  endif
  !
  if (indl%scan.eq.0) indl%scan = indl%num
  !
  ! Upper case conversion
  call sic_upper(indl%csour)
  call sic_upper(indl%cline)
  call sic_upper(indl%ctele)
  !
end subroutine index_frombuf_v2orv3
!
subroutine index_tobuf_v1(indl,data,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use classcore_interfaces, except_this=>index_tobuf_v1
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transfer last version of the index to the data(*) buffer V1
  !---------------------------------------------------------------------
  type(indx_t),             intent(in)    :: indl     !
  integer(kind=4),          intent(out)   :: data(*)  !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  type(indx_v1_t) :: ind1
  !
  call index_vltov1(indl,ind1,error)
  !
  if (conv%code.eq.0) then
    ! Native, copy the whole block (NB: might be a problem with the strings)
    call r4tor4(ind1%bloc,data(1),lind_v1)
  else
    ! Non native, conversion needed
    call conv%writ%i4(ind1%bloc,   data(1), 3)
    call conv%writ%cc(ind1%csour,  data(4), 3)
    call conv%writ%cc(ind1%cline,  data(7), 3)
    call conv%writ%cc(ind1%ctele,  data(10),3)
    call conv%writ%i4(ind1%dobs,   data(13),2)
    call conv%writ%r4(ind1%off1,   data(15),2)
    call conv%writ%i4(ind1%type,   data(17),4)
    call conv%writ%r4(ind1%posa,   data(21),1)
    call conv%writ%i4(ind1%subscan,data(22),1)
  endif
  !
end subroutine index_tobuf_v1
!
subroutine index_vltov1(indl,ind1,error)
  use gbl_message
  use classcore_interfaces, except_this=>index_vltov1
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transform the index last version into an index V1
  !---------------------------------------------------------------------
  type(indx_t),    intent(in)    :: indl   !
  type(indx_v1_t), intent(out)   :: ind1   !
  logical,         intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='INDEX'
  !
  call i8toi4_fini(indl%bloc,ind1%bloc,1,error)
  if (error)  return
  if (indl%word.ne.1) then
    call class_message(seve%e,rname,  &
      'Internal error: Observation must start at the beginning of record for V1 file')
    error = .true.
    return
  endif
  call i8toi4_fini(indl%num,ind1%num,1,error)
  if (error)  return
  ind1%ver     = indl%ver
  ind1%csour   = indl%csour
  ind1%cline   = indl%cline
  ind1%ctele   = indl%ctele
  ind1%dobs    = indl%dobs
  ind1%dred    = indl%dred
  ind1%off1    = indl%off1
  ind1%off2    = indl%off2
  ind1%type    = indl%type
  ind1%kind    = indl%kind
  ind1%qual    = indl%qual
  call i8toi4_fini(indl%scan,ind1%scan,1,error)
  if (error)  return
  ind1%posa    = indl%posa
  ind1%subscan = indl%subscan
  !            = indl%ut  ! Not available in V1
  !
end subroutine index_vltov1
!
subroutine index_tobuf_v2orv3(indl,isv3,data,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use classcore_interfaces, except_this=>index_tobuf_v2orv3
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transfer last version of the index to the data(*) buffer V2 or V3
  !---------------------------------------------------------------------
  type(indx_t),             intent(in)    :: indl     !
  logical,                  intent(in)    :: isv3     !
  integer(kind=4),          intent(out)   :: data(*)  !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  !
  ! Write in the indx. Since the index in memory is not correctly
  ! aligned (memory padding, no SEQUENCE), we MUST write the elements
  ! one by one.
  call conv%writ%i8(indl%bloc,   data(1), 1)  ! bloc
  call conv%writ%i4(indl%word,   data(3), 1)  ! word
  call conv%writ%i8(indl%num,    data(4), 1)  ! num
  call conv%writ%i4(indl%ver,    data(6), 1)  ! ver
  call conv%writ%cc(indl%csour,  data(7), 3)  ! csour
  call conv%writ%cc(indl%cline,  data(10),3)  ! cline
  call conv%writ%cc(indl%ctele,  data(13),3)  ! ctele
  call conv%writ%i4(indl%dobs,   data(16),1)  ! dobs
  call conv%writ%i4(indl%dred,   data(17),1)  ! dred
  call conv%writ%r4(indl%off1,   data(18),1)  ! off1
  call conv%writ%r4(indl%off2,   data(19),1)  ! off2
  call conv%writ%i4(indl%type,   data(20),1)  ! type
  call conv%writ%i4(indl%kind,   data(21),1)  ! kind
  call conv%writ%i4(indl%qual,   data(22),1)  ! qual
  call conv%writ%r4(indl%posa,   data(23),1)  ! posa
  call conv%writ%i8(indl%scan,   data(24),1)  ! scan
  call conv%writ%i4(indl%subscan,data(26),1)  ! subscan
  if (isv3) then
    call conv%writ%r8(indl%ut,   data(27),1)  ! ut
  endif
  !
end subroutine index_tobuf_v2orv3
!
subroutine index_fromobs(head,ind,error)
  use gbl_constant
  use classcore_interfaces, except_this=>index_fromobs
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Set the output Index from the input Observation Header
  !---------------------------------------------------------------------
  type(header), intent(in)    :: head   ! Observation header
  type(indx_t), intent(out)   :: ind    ! Computed Index
  logical,      intent(inout) :: error  !
  !
  ind%num     = head%gen%num
  ind%ver     = head%gen%ver
  if (head%gen%kind.eq.kind_sky) then
    ind%csour = 'SKYDIP'
    ind%cline = head%sky%line
  else
    ind%csour = head%pos%sourc
    ind%cline = head%spe%line
  endif
  ind%ctele   = head%gen%teles
  ind%dobs    = head%gen%dobs
  ind%dred    = head%gen%dred
  ind%off1    = head%pos%lamof
  ind%off2    = head%pos%betof
  ind%type    = head%pos%system
  ind%kind    = head%gen%kind
  ind%qual    = head%gen%qual
  ind%scan    = head%gen%scan
  ind%posa    = head%dri%apos
  ind%subscan = head%gen%subscan
  ind%ut      = head%gen%ut
  !
end subroutine index_fromobs
!
subroutine index_toobs(ind,head,error)
  use gbl_constant
  use classcore_interfaces, except_this=>index_toobs
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Copy the Index to the in/out Observation Header
  !---------------------------------------------------------------------
  type(indx_t), intent(in)    :: ind    ! Computed Index
  type(header), intent(inout) :: head   ! Observation header
  logical,      intent(inout) :: error  !
  !
  head%gen%num     = ind%num
  head%gen%ver     = ind%ver
  head%pos%sourc   = ind%csour
  if (head%gen%kind.eq.kind_sky) then
    head%sky%line = ind%cline
  else
    head%spe%line = ind%cline
  endif
  head%gen%teles   = ind%ctele
  head%gen%dobs    = ind%dobs
  call gag_todate(ind%dobs,head%gen%cdobs,error)
  head%gen%dred    = ind%dred
  call gag_todate(ind%dred,head%gen%cdred,error)
  head%pos%lamof   = ind%off1
  head%pos%betof   = ind%off2
  head%pos%system  = ind%type
  head%gen%kind    = ind%kind
  head%gen%qual    = ind%qual
  head%gen%scan    = ind%scan
  head%dri%apos    = ind%posa
  head%gen%subscan = ind%subscan
  head%gen%ut      = ind%ut
  !
end subroutine index_toobs
!
subroutine index_tooptimize(ind,iind,long,iopt,optx,error)
  use classic_api
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Copy the input Index to the input 'optimize' object (collection
  ! of all the Indexes of the Observations in the file). The code
  ! assumes that the arrays are correctly allocated (enough space).
  ! This is done with reallocate_optimize.
  !  'long' index: all arrays are allocated
  !  'short' index: only ind(:), bloc(:), num(:), ver(:)
  !---------------------------------------------------------------------
  type(indx_t),               intent(in)    :: ind    ! Index
  integer(kind=entry_length), intent(in)    :: iind   ! Index number
  logical,                    intent(in)    :: long   ! Long index?
  integer(kind=entry_length), intent(in)    :: iopt   ! Position in optimized index
  type(optimize),             intent(inout) :: optx   ! Optimized index of file
  logical,                    intent(inout) :: error  !
  !
  optx%ind(iopt)     = iind
  optx%bloc(iopt)    = ind%bloc
  optx%word(iopt)    = ind%word
  optx%num(iopt)     = ind%num
  optx%ver(iopt)     = ind%ver
  optx%dobs(iopt)    = ind%dobs
  optx%ut(iopt)      = ind%ut
  optx%ctele(iopt)   = ind%ctele
  optx%scan(iopt)    = ind%scan
  optx%subscan(iopt) = ind%subscan
  !
  if (long) then
    optx%csour(iopt)   = ind%csour
    optx%cline(iopt)   = ind%cline
    !                  = ind%dred ?
    optx%off1(iopt)    = ind%off1
    optx%off2(iopt)    = ind%off2
    !                  = ind%type?
    optx%kind(iopt)    = ind%kind
    optx%qual(iopt)    = ind%qual
    optx%posa(iopt)    = ind%posa
    !
  else
    ! optx%sort%number(iopt) = ???
    ! optx%sort%entry(iopt) = ???
  endif
  !
end subroutine index_tooptimize
!
subroutine index_fromoptimize(optx,i,ind,error)
  use classic_api
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Fill the given Index from the input 'optimize' object
  ! (collection of Indexes)
  !---------------------------------------------------------------------
  type(optimize),             intent(in)    :: optx   ! Optimized index of file
  integer(kind=entry_length), intent(in)    :: i      ! Index number
  type(indx_t),               intent(out)   :: ind    ! Current spectrum index
  logical,                    intent(inout) :: error  !
  !
  ind%bloc    = optx%bloc(i)
  ind%word    = optx%word(i)
  ind%num     = optx%num(i)
  ind%ver     = optx%ver(i)
  ind%csour   = optx%csour(i)
  ind%cline   = optx%cline(i)
  ind%ctele   = optx%ctele(i)
  ind%dobs    = optx%dobs(i)
  ! ind%dred  = ?
  ind%off1    = optx%off1(i)
  ind%off2    = optx%off2(i)
  ! ind%type  = ?
  ind%kind    = optx%kind(i)
  ind%qual    = optx%qual(i)
  ind%scan    = optx%scan(i)
  ind%posa    = optx%posa(i)
  ind%subscan = optx%subscan(i)
  ind%ut      = optx%ut(i)
  !
end subroutine index_fromoptimize
!
subroutine optimize_tooptimize(in,i,ou,o,long,error)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Copy 1 element of optimize'd index IN into OU
  !---------------------------------------------------------------------
  type(optimize),             intent(in)    :: in     ! Input index
  integer(kind=entry_length), intent(in)    :: i      ! Element to be copied
  type(optimize),             intent(inout) :: ou     ! Output index
  integer(kind=entry_length), intent(in)    :: o      ! Destination
  logical,                    intent(in)    :: long   ! Long index?
  logical,                    intent(inout) :: error  ! Logical error flag
  !
  ou%ind(o)     = in%ind(i)
  ou%bloc(o)    = in%bloc(i)
  ou%word(o)    = in%word(i)
  ou%num(o)     = in%num(i)
  ou%ver(o)     = in%ver(i)
  ou%ut(o)      = in%ut(i)
  ou%ctele(o)   = in%ctele(i)
  ou%scan(o)    = in%scan(i)
  ou%subscan(o) = in%subscan(i)
  !
  if (long) then
    ou%csour(o)   = in%csour(i)
    ou%cline(o)   = in%cline(i)
    ou%dobs(o)    = in%dobs(i)
    ou%off1(o)    = in%off1(i)
    ou%off2(o)    = in%off2(i)
    ou%kind(o)    = in%kind(i)
    ou%qual(o)    = in%qual(i)
    ou%posa(o)    = in%posa(i)
  else
    ! ou%number(o) = ???
    ! ou%entry(o) = ???
  endif
  !
end subroutine optimize_tooptimize
!
subroutine optimize_old_format(optx,name,error)
  use gbl_message
  use classcore_interfaces, except_this=>optimize_old_format
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check whether the index contains old format observations, and act
  ! accordingly.
  !---------------------------------------------------------------------
  type(optimize),   intent(inout) :: optx   !
  character(len=*), intent(in)    :: name   ! Index name
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=entry_length) :: ient
  !
  optx%has_old_fmt = .false.
  do ient=1,optx%next-1
    ! Old data format can be detected in the index as entries with a
    ! null subcan number (since this information was not written in
    ! the index at that time -- it is read as 0 from file --), and an
    ! observing date before 01-JAN-2006 (the new format was
    ! implemented at the telescope in 2005).
    if (optx%subscan(ient).eq.0 .and. optx%dobs(ient).lt.dobs_v1_old) then
      ! Old format in index has 2 minor consequences:
      ! 1) raises a warning to user
      ! 2) raise the associated flag (visible in SIC variable IDX%OLDFMT in
      !    case of CX)
      call class_message(seve%w,rname,name//' index contains old format data')
      optx%has_old_fmt = .true.
      return
    endif
  enddo
end subroutine optimize_old_format
!
subroutine rix_to_ix(entry_num,error)
  use classic_api
  use classcore_interfaces, except_this=>rix_to_ix
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  !  Read the Entry Index for given entry in FILE IN, and store it into
  ! IX. Assume IX has already been (re)allocated to a sufficient size!
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)    :: entry_num  !
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  type(indx_t) :: ind
  !
  call rix(entry_num,ind,error)
  if (error)  return
  !
  call index_tooptimize(ind,entry_num,.true.,entry_num,ix,error)
  if (error)  return
  !
end subroutine rix_to_ix
!
subroutine rox_to_ox(entry_num,error)
  use classic_api
  use classcore_interfaces, except_this=>rox_to_ox
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  !  Read the Entry Index for given entry in FILE OUT, and store it into
  ! OX. Assume OX has already been (re)allocated to a sufficient size!
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)    :: entry_num  !
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  type(indx_t) :: ind
  !
  call rox(entry_num,ind,error)
  if (error)  return
  !
  call index_tooptimize(ind,entry_num,.false.,entry_num,ox,error)
  if (error)  return
  !
end subroutine rox_to_ox
!
subroutine ix_update(error)
  use gbl_message
  use gbl_format
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>ix_update
  use class_common
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Check if input file has new entries, and save them in IX if yes
  !---------------------------------------------------------------------
  logical, intent(out) :: error  ! Error status
  ! Local
  character(len=*), parameter :: rname='UDPATE'
  integer(kind=entry_length) :: i
  !
  if (filein_isvlm) then
    call class_message(seve%w,rname,  &
      'Index update is not relevant for FILE IN VLM. Ignored.')
    return
  endif
  !
  ! Re-read the File Descriptor and check if file has new observations.
  call classic_file_fflush(filein,error)  ! Flush for reading
  if (error) then  ! e.g. file has disappearead
    call class_message(seve%e,rname,'Read error file '//filein%spec)
    return
  endif
  call classic_filedesc_read(filein,error)
  if (error) then
    call class_message(seve%e,rname,'Read error file '//filein%spec)
    return
  endif
  !
  if (ix%next.ge.filein%desc%xnext)  return  ! Nothing new
  !
  ! Resize The Input File Index to the new size
  call reallocate_optimize(ix,filein%desc%xnext-1,.true.,.true.,error)
  if (error)  return
  !
  ! Nullify the Entry Index buffer: it may contain a record which has
  ! been updated on disk. This forces re-reading.
  call classic_recordbuf_nullify(ibufbi)
  !
  ! Nullify the Observation buffer: in V2 files, there can be several
  ! (pieces of) observations sharing the same record. This forces
  ! re-reading from disk when GET will be done later.
  call classic_recordbuf_nullify(ibufobs)
  !
  ! And finally store the new entries
  do i=ix%next,filein%desc%xnext-1
    call rix_to_ix(i,error)  ! Append the IX% structure
    if (error)  return
    ix%next = ix%next+1
  enddo
  !
end subroutine ix_update

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! *** JP: module name is a bit ambiguous with cube_types defined in
! *** JP: tuple/type-cube.f90
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_cube_types
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubeedit_messaging
  !
  public :: cube_opt_t,cube_user_t,cube_prog_t
  private
  !
  type cube_opt_t
     type(option_t), pointer :: opt
   contains
     procedure :: register => cubeedit_cube_register
     procedure :: parse    => cubeedit_cube_parse
  end type cube_opt_t
  !
  type cube_user_t
     logical :: do = .false.  ! Option was present
   contains
     procedure :: init   => cubeedit_cube_user_init
     procedure :: toprog => cubeedit_cube_user_toprog
  end type cube_user_t
  !
  type cube_prog_t
  end type cube_prog_t
  !
contains
  !
  subroutine cubeedit_cube_register(option,name,abstract,error)
    use cubetools_unit
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(cube_opt_t), intent(out)   :: option
    character(len=*),  intent(in)    :: name
    character(len=*),  intent(in)    :: abstract
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBE>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'',&
         abstract,&
         'Load the whole cube in the named variable. If the cube is &
         &an image set, its first plane and its spatial coordinates &
         &are also loaded in the RG buffer.',&
         option%opt,error)
    if (error) return
  end subroutine cubeedit_cube_register
  !
  subroutine cubeedit_cube_parse(option,line,user,error)
    !----------------------------------------------------------------------
    ! /CUBE (no argument)
    !----------------------------------------------------------------------
    class(cube_opt_t), intent(in)    :: option
    character(len=*),  intent(in)    :: line
    type(cube_user_t), intent(out)   :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBE>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call option%opt%present(line,user%do,error)
    if (error) return
  end subroutine cubeedit_cube_parse
  !
  subroutine cubeedit_cube_user_init(user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cube_user_t), intent(in)    :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBE>USER>INIT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
  end subroutine cubeedit_cube_user_init
  !
  subroutine cubeedit_cube_user_toprog(user,option,cube,prog,error)
    use cube_types
    use cubetools_user2prog
    use cubetools_unit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cube_user_t), intent(in)    :: user
    type(cube_opt_t),   intent(in)    :: option
    type(cube_t),       intent(in)    :: cube
    type(cube_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBE>USER>TOPROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
  end subroutine cubeedit_cube_user_toprog
end module cubeedit_cube_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clic_atmos(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! Command ATMOS [DETECTOR|CORRELATOR]
  ! This command  quasi real time amplitude and IF passband calibration.
  ! It processes CAL, AUTO, IFPB and CWVR scans as they are encountered.
  ! Option 1 /COMPRESS time uvmax
  ! Option 2 /RESET {CAL|IFPB:AUTO:ALL}
  ! Option 3 /NOWRITE
  ! Option 4 /NOMONITOR
  ! Option 5 /CMODE  wvrmode wvrcpol
  !
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: end, do_write, monitor
  integer :: i, ir, ia, ip, ic
  integer(kind=address_length) :: data_in, ip_data
  integer(kind=data_length) :: ndata, ldata_in
  integer :: isb, isub, nch
  character(len=7) :: done
  character(len=12) :: arg1, arg
  character(len=80) :: chain
  character(len=4) :: cproc,procname
  real :: scale(mnant,mnbb)
  integer :: mvoc1, mvoc2, mvoc3
  parameter (mvoc1=2, mvoc2=5, mvoc3=5)
  character(len=12) :: voc1(mvoc1), voc2(mvoc2), voc3(mvoc3)
  data voc1/'DETECTOR','CORRELATOR'/
  data voc2/'CAL','IFPB','AUTO','ALL','CWVR'/
  data voc3/'TR_GE','TR_GL','TRL_GC','TR_GC','NOCAL'/
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  do_write = .not.sic_present(3,0)
  if (do_write) then
    call check_output_file(error)
    if (write_mode.eq.'UPDA') call check_equal_file(error)
    if (error) return
  endif
  arg1 = 'DETECTOR'
  call clic_kw(line,0,1,arg1,nch,voc1,mvoc1,.false.,error,.true.)
  if (error) return
  !
  ! Reset CAL, AUTO, ALL, and/or IFPB  : Option 2
  if (sic_present(2,0)) then
    do i=1, max(1,sic_narg(2))
      arg = 'ALL'
      call clic_kw(line,2,i,arg,nch,voc2,mvoc2,.true.,error,.true.)
      if (error) return
      if (arg.eq.'ALL') then
        do ia=1,mnant
          do ir=1,mnrec
            do ic=1, mnbb
              do ip=1, m_pol_rec
                integ(ia,ir,ic,ip,chop) = 0
                integ(ia,ir,ic,ip,cold) = 0
                integ(ia,ir,ic,ip,sky) = 0
              enddo
            enddo
          enddo
        enddo
        mon_scan = 0
      elseif (arg.eq.'AUTO') then
        do ia=1,mnant
          do ir=1,mnrec
            do ic=1, mnbb
              do ip=1, m_pol_rec
                integ(ia,ir,ic,ip,sky) = 0
              enddo
            enddo
          enddo
        enddo
      elseif (arg.eq.'CAL') then
        do ia=1,mnant
          do ir=1,mnrec
            do ic=1, mnbb
              do ip=1, m_pol_rec
                integ(ia,ir,ic,ip,chop) = 0
                integ(ia,ir,ic,ip,cold) = 0
              enddo
            enddo
          enddo
        enddo
      endif
    enddo
  endif
  !
  ! /NOMONITOR
  monitor = .not.sic_present(4,0)
  !
  ! Loop on current index
  call get_first(.true.,error)
  if (error) return
  end = .false.
  do while (.not.end)
    if (r_ndump.eq.0) goto 200
    r_nrec = max(1,r_nrec)
    do isb = 1, r_nsb
      if (c_line(isb).ne.'*') then
        r_crfoff(isb) = c_freq(isb)
        r_cnam(isb) = c_line(isb)
      elseif (r_restf.gt.0) then
        r_crfoff(isb) = r_restf
        r_cnam(isb) = r_line
      else
        r_crfoff(isb) = 100000.
        r_cnam(isb) = 'DUMMY'
      endif
      do isub=1, r_lband
        if (l_line(isub,isb).ne.'*') then
          r_lrfoff(isb,isub) = l_freq(isub,isb)
          r_lnam(isb,isub) = l_line(isub,isb)
        elseif (r_restf.gt.0) then
          r_lrfoff(isb,isub) = r_restf
          r_lnam(isb,isub) = r_line
        else
          r_lrfoff(isb,isub) = 100000.
          r_lnam(isb,isub) = 'DUMMY'
        endif
      enddo
    enddo
    !
    ! Get storage and data
    call get_data (ldata_in,data_in,error)
    if (error) goto 200
    ndata = ldata_in
    !
    ! Process (with atmospheric monitor)
    ip_data = gag_pointer(data_in,memory)
    call sub_atmos (ndata,memory(ip_data),arg1,monitor,error,   &
      scale)
    !         CALL SUB_ATMOS (LDATA_IN,MEMORY(IP_DATA),ARG1,WVRMODE,WVRCPOL,
    !     $   MONITOR,ERROR)
    if (error) goto 200
    !         CALL CHECK_FLUX(LDATA_IN, MEMORY(IP_DATA), FLUXOUT, ERRFLUX,
    !     &   PHCOROK, LOWFAC, ERROR)
    error = .false.
    !
    ! Write
    call loose_data
    if (do_write) then
      call ipb_write(write_mode,.true.,error)
      if (error) goto 200
      if (write_mode.eq.'UPDA') then
        call wgen(error)       ! section generale
        if (error) return
        call wpos(error)       ! position
        if (error) return
        call winterc(error)
        if (r_presec(rfset_sec)) then
          call wrfset(error)
          if (error) return
        endif
        if (r_presec(contset_sec)) then
          call wcontset(error)
          if (error) return
        endif
        if (r_presec(lineset_sec)) then
          call wlineset(error)
          if (error) return
        endif
        if (r_presec(atparm_sec)) then
          call watparm(error)
          if (error) return
        endif
        if (r_presec(wvr_sec)) then
          call wwvr(error)
          if (error) return
        endif
      endif
      call update_header       ! Missing in this circumstances
      ndata = ldata_in
      call wdata (ndata,memory(ip_data),.false.,error)
      if (error) goto 200
      call ipb_close(error)
      if (error) goto 200
      cproc = procname(r_proc)
      write(chain,'(A4,1X,I6,A,I6,A)') cproc ,r_num,   &
        ' '//done(write_mode)//' (',r_ndump,' records)'
      call message(4,1,'CLIC_ATMOS',chain(1:50))
    endif
    !
    ! Next observation
200 if (sic_ctrlc()) then
      error = .true.
      return
    endif
    error = .false.
    call get_next(end, error)
    if (error) return
  enddo
  return
end subroutine clic_atmos
!
subroutine load_atmos
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !	Load Atmospheric Parameters
  !---------------------------------------------------------------------
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  real :: airmas, current_el
  real*8 :: air_mass
  integer :: ia, ip
  !
  ! Setup atmospheric monitor section:
  !      CALL R4TOR4(H_MON(1,R_NREC),R_NREC_MON,MATMON)
  !
  ! Setup calibration parameters section:
  current_el = r_el
  ! just in case ...
  airmas = sngl(air_mass(current_el)-air_mass(r_el))
  do ia =1, r_nant
    do ip = 1, mnbb
      r_tsyss(ip,ia) = r_tsyss(ip,ia)*exp(r_taus(ip,ia)   &
        *airmas)
      r_tsysi(ip,ia) = r_tsysi(ip,ia)*exp(r_taui(ip,ia)   &
        *airmas)
    enddo
  enddo
end subroutine load_atmos
!
subroutine cal_levels(arg,mes)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     Show total power levels
  ! Input
  !	ARG C*(*)	'Detector' or 'Correlator'
  !---------------------------------------------------------------------
  character(len=*) :: arg           !
  integer :: mes                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  ! Local
  real :: wk, tp(mnant)
  integer :: ia, ic, jc,  ip, ical
  character(len=200) :: chain
  logical :: error
  integer :: cold_scan(mnrec)
  character(len=2) :: ch(3)
  data ch/'Ch','Co','Sk'/
  save cold_scan
  data cold_scan/0,0,0,0/
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Use "Temporal" data if correlator to be used
  ! Not necessarily the best thing (narrow band on some occasions ?)
  ! Get saved values from previous measurements in same scan
  !
  if (r_nbb.eq.0) then
      print *,"CAL_LEVELS, No unit connected to any IF"
      error = .true.
      return
  endif
  !
  ! New calibration scan : reset cold measurements to zero.
  !
  if (r_scan.ne.cold_scan(r_nrec) .and. mes.ne.cold) then
    do ia=1, r_nant
      do ic = 1, mnbb
         do ip = 1, m_pol_rec
           c_lev(ia,r_nrec,ic,ip,cold) = 0
         enddo
      enddo
    enddo
  endif
  if (mes.eq.cold) then
    cold_scan(r_nrec) = r_scan
  endif
  !
  do ia = 1, r_nant
    if (new_receivers) then
      !
      ! new receivers: use Tot power as it comes from correlator anyway.
      !
      ! Sky used to actually calibrate spectra, fill only what measured
      if (mes.eq.sky) then
        do ical = 1, r_nbb
          ic = r_mapbb(ical)
          ip = r_mappol(ia,ical)
          c_lev(ia,r_nrec,ic,ip,mes) = dh_total(ic, ia)
        enddo
      else
        !
        ! Temporary: fill both pol buffers since not measured in pol case.
        do ical = 1, r_nbb
          ic = r_mapbb(ical)
          ip = r_mappol(ia,ical)
            c_lev(ia,r_nrec,ic,ip,mes) = dh_total(ic, ia)
        enddo
      endif
    else
      !
      ! old receivers: use either Correl or Detector
      if (arg.eq.'C') then
        tp(ia) = 0
        wk = 0
        do jc = 1, l_subb(k_subb(1))
          ic = max(1,min(r_nband,i_subb(jc,k_subb(1))))
          ip = r_lpolentry(ia,ic)
          if (iand(dh_aflag(ia),ishft(1,ic-1)).eq.0) then
            wk = wk + r_cfwid(ic)
            tp(ia) = tp(ia)   &
              + c_c(ic,ia,r_nrec,ip,mes)*r_cfwid(ic)
          endif
        enddo
        if (wk.ne.0) then
          tp(ia) = tp(ia) / wk
        else
          write (chain,'(A,I0)')   &
            'No calibration data for Antenna ',ia
          call message(8,4,'CAL_LEVELS',chain(1:lenc(chain)))

!! TBA          integ(ia,r_nrec,1,ip,mes) = 0    ! may be one could use the other
          return               ! antennas ... ###
        endif
      elseif (arg.eq.'D') then
        !
        !     use the dh_total...
        tp(ia) = dh_total(1, ia)
        c_lev(ia,r_nrec,1,1,mes) = tp(ia)        !!! TBA
        c_lev(ia,2,1,1,mes) = dh_test1(2,ia)     !!! TBA
      endif
    endif
  enddo
  if (new_receivers) then
    do ical = 1,  r_nbb
      ic = r_mapbb(ical)
      write(chain,1001) arg, ch(mes), ic, (r_kant(ia), c_lev(ia,  &
        r_nrec,ic,r_mappol(ia,ical),mes), ia=1,r_nant)
      call message(1,1,'CAL_LEVELS',chain(1:lenc(chain)))
    enddo
1001 format(a1,1x,a2,' Cal.Unit',i0,12(' A',i0,':',f6.3))
  else
    write(chain,1000) arg,ch(mes),r_nrec, (r_kant(ia),tp(ia),ia=1   &
      ,r_nant)
1000 format(a1,1x,a2,' Rec',i0,12(' A',i0,':',f6.1))
    call message(1,1,'CAL_LEVELS',chain(1:lenc(chain)))
  endif
  return
end subroutine cal_levels
!
subroutine check_atmos (error)
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! Check that spectrum to be reduced is compatible with available
  ! calibration buffers.
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  logical :: wrong
  integer :: i, ia, ip, ic, ical
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Check configuration compatibility
  wrong = .false.
  call compare_sec(r_nant,h_inter(1,r_nrec),2,wrong)
  call compare_sec(r_lband,h_line(1,r_nrec),3+5*mrlband,wrong)
  !*
  ! Check Atmospheric calibration presence
  if (new_receivers) then
    do ia=1, r_nant
      do ical = 1, r_nbb
        ic = r_mapbb(ical)
        ip = r_mappol(ia,ical)
        if (integ(ia,r_nrec,ic,ip,chop).le.0 .or. wrong) then
            tcal_u(ia,ic) = 1.
            tcal_l(ia,ic) = 1.
          call message(6,2,'CHECK_ATMOS',   &
            'No Amplitude Calibration')
          sky_flags(ia,ic) = 0
          r_qual = min(r_qual,8)
          error = .true.
        else
          return
        endif
      enddo
    enddo
  else
    if (integ(1,r_nrec,1,1,chop).le.0 .or. wrong) then !! TBA
      do ia=1, r_nant
        tcal_u(ia,r_nrec) = 1.  !!! TBA
        tcal_l(ia,r_nrec) = 1.  !!! TBA
      enddo
      call message(6,2,'CHECK_ATMOS','No Amplitude Calibration')
      do i = 1, r_nant
        sky_flags(i,r_nrec) = 0
      enddo
      r_qual = min(r_qual,8)
      error = .true.
    else
      return
    endif
  endif
end subroutine check_atmos
!
subroutine real_to_complex(rel,cmpl,n)
  !---------------------------------------------------------------------
  ! Reverse storage order from:
  !	N real parts, N imaginary parts
  ! 	to:
  !	N complex numbers
  !---------------------------------------------------------------------
  integer :: n                      !
  real*4 :: rel(n,2)                !
  complex :: cmpl(n)                !
  ! Local
  integer :: i
  !------------------------------------------------------------------------
  ! Code:
  do i=1,n
    cmpl(i) = cmplx( rel(i,1), rel(i,2) )
  enddo
end subroutine real_to_complex
!
subroutine vel_scale
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Updates frequencies in header according to last
  !     'SET FREQUENCY' command
  !---------------------------------------------------------------------
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! Local
  integer :: isb, sky(2), isub
  real*8 :: x,y,c
  parameter (c=299792.458d0)
  data sky/+1,-1/              ! Usb, Lsb
  !------------------------------------------------------------------------
  ! Code:
  ! Loop on sidebands
  do isb = 1, 2
    !
    ! Continuum
    x = r_flo1_ref - sky(isb)*r_isb*r_fif1   &
      - sky(isb)*(r_crfoff(isb)-r_restf)*(1.+r_doppl)
    r_crch(isb) = 5.5+ (x-350.)/50.  ! reference channel
    r_crfres(isb) = -sky(isb)*50.    ! channel width
    r_cvoff(isb) = r_veloc   ! source velocity
    r_cvres(isb) = -r_crfres(isb)/r_crfoff(isb)*c
    !
    ! Line
    do isub=1, r_lband
      x = r_fif1 + r_isb *   &             ! New reference freq (I_F)
        (r_lrfoff(isb,isub) - r_restf)*(1.+r_doppl)
      y = r_flo2(isub) +r_band2(isub)* (r_flo2bis(isub) & ! Band reference freq (I_F)
        + r_band2bis(isub) * r_lfcen(isub))
      r_lrch(isb,isub) = (r_isb * x -  sky(isb) * y)   & 
        * sky(isb) * r_band2(isub) * r_band2bis(isub) / r_lfres(isub)   &
        + r_lcench(isub)
      r_lrfres(isb,isub) = sky(isb)*r_lfres(isub)   &
        *r_band2(isub) * r_band2bis(isub)
      r_lvoff(isb,isub) = r_veloc
      r_lvres(isb,isub) = -r_lrfres(isb,isub)   &
        /r_lrfoff(isb,isub)*c
    enddo
  enddo
end subroutine vel_scale
!
function prec_water(tamb,humidity)
  !---------------------------------------------------------------------
  ! CLIC
  !	Compute the precipitable water content
  !	Assumes scale height 2km
  ! Input
  !     TAMB       REAL	Ambiant Temperature in Kelvin
  !     HUMIDITY   REAL   Humidity in %
  ! Output
  !     PREC_WATER REAL   Water vapor in mm
  !---------------------------------------------------------------------
  real :: prec_water                !
  real :: tamb                      !
  real :: humidity                  !
  !------------------------------------------------------------------------
  ! Code:
  prec_water = 26.46*humidity/tamb   &
    * exp(25.22*(tamb-273)/tamb-5.31*alog(tamb/273.))
  return
end function prec_water
!
subroutine compare_sec(n1,n2,nn,ok)
  !---------------------------------------------------------------------
  ! CLIC: compare two memory areas
  !---------------------------------------------------------------------
  integer :: nn                     !
  integer :: n1(nn)                 !
  integer :: n2(nn)                 !
  logical :: ok                     !
  ! Local
  integer :: i
  !------------------------------------------------------------------------
  do i=1,nn
    ok = ok.and.(n1(i).eq.n2(i))
  enddo
  return
end subroutine compare_sec
!
subroutine check_flux(ndata, data, fluxout, errflux, phcorok,   &
    lowfac, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! Check the flux on a phase calibrator.
  ! Assume the efficiencies in r_jykel are correct.
  ! The best of corrected and uncorrected data is used.
  !
  ! Arguments
  !     LDATA_IN      Integer Length of data array
  !     DATA(*)       (*)     Data array
  !     Fluxout       R       Measured flux if procedure is flux measurement
  !     Errflux       R       Error on flux "  "             "      "
  !     phcorOK       L(mnant) true if flux with phcor is best
  !     floss         R(mnant) degradation factor for each ant. (0 to 1)
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  integer(kind=data_length) :: ndata                  !
  real :: data(ndata)               !
  real :: fluxout                   !
  real :: errflux                   !
  logical :: phcorok(mnant)         !
  real :: lowfac(mnant)             !
  logical :: error                  !
  ! Global
  real :: effmax
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'clic_sba.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: data_in
  real :: effm, fr, fu(mnant), fc(mnant), wfu(mnant),ec(mnant)
  real :: eu(mnant), efc, efu, ft(mnant), wfc(mnant), afc, afu, wafc
  real :: wafu, fopt
  integer :: ib, isb, kh, ia, if,if1, i
  integer :: ind(mnant), nbest 
  character(len=132) :: chain
  complex :: z(mnbas), zant(mnant)
  real :: w(mnbas), want(mnant), frtol
  parameter (frtol=1e3)
  ! use the two best antennas for flux determination
  parameter (nbest = 2)
  logical :: save_atm(mnant), zero
  integer(kind=address_length) :: kin, ipkh
  integer(kind=data_length) :: h_offset
  !------------------------------------------------------------------------
  data_in = locwrd(data)
  kin = gag_pointer(data_in,memory)
  error = .false.
  if (r_itype.eq.1 .and. r_proc.ne.p_flux) then
    return
  endif
  if (r_proc.ne.p_source .and. r_proc.ne.p_flux) then
    return
  endif
  fr = r_flo1+r_isb*r_fif1
  effm = effmax(fr)
  do ib=1, r_nant
    fu(ib) = 0.
    fc(ib) = 0.
  enddo
  isb = 1+(1-r_isb)/2          !              (1 usb, 2 lsb)
  !
  ! Save atm phase status
  do i=1, mnant
    save_atm(i) = do_phase_atm(i)
  enddo
  !
  if (do_spidx) then
    call set_spidx(r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, spidc, spidl, r_spidx, error)
  endif  
  !
  ! Get average record (uncorrected) in zsba(isb,ib) (weights in wsba)
  if (r_ndatl.ne.1) then
    do i=1, mnant
      do_phase_atm(i) = .false.
    enddo
    kh = 1 + h_offset(r_ndump+1)
    !         KC = 1 + C_OFFSET(R_NDUMP+1)
    ipkh = kin+h_offset(r_ndump+1)
    call decode_header (memory(ipkh))
    call set_scaling(error)
    if (error) return
    zero = .true.
    !
    ! NGRX : Not sure if this is handling both polarizations, ...
    ! may be do each one at a time ?
    if (k_average.eq.1) then
      call line_average (r_lntch,r_nbas,r_lnsb,data_in,   &
        spidl,zero,error)
    else
      call cont_average (r_nband,r_nbas,data_in,   &
       spidc,zero,error)
    endif 
    if (error) return
    do ib = 1, r_nbas
      if (wsba(isb,ib).gt.0) then
        z(ib) = zsba(isb,ib)/wsba(isb,ib)
      else
        z(ib) = 0
      endif
      w(ib) = wsba(isb,ib)
    enddo
    call antgain (z,w,zant,want)
    do ia = 1, r_nant
      fu(ia) = 0
      wfu(ia) = 0
      if (want(ia).gt.0) then
        !               do ip = i, r_npol_rec
        !                  if (r_npol_rec.eq.1) then
        !                     ipol = r_lpolentry(1,1) ! To be patched when mixed unit
        !                  else
        !                     ipol = ip
        !                  endif
        fu(ia) = fu(ia) + abs(zant(ia)) * r_jykel(1,ia)
        if (r_jykel(1,ia).ne.0) then
          wfu(ia) = wfu(ia) + want(ia) / r_jykel(1,ia)**2
        else
          print *,"R_JYKEL ",1,ia," is ZERO"
        endif
        !              enddo
        !               if (r_npol_rec.ne.0) then
        !                  fu(ia) = fu(ia)/r_npol_rec
        !                  wfu(ia) = wfu(ia)/r_npol_rec
        !               else
        !                  print *,"R_NPOL_REC is ZERO"
        !               endif
        if (wfu(ia).ne.0) then
          eu(ia) = 1e-3 / sqrt(wfu(ia))
        else
          print *,"WFU ",ia," is ZERO"
        endif
      else
        fu(ia) = 0
        wfu(ia) = 0
        eu(ia) = -10.
      endif
    enddo
  endif
  !
  ! Get average record (corrected) in zsba(isb,ib) (weights in wsba)
  if (r_ndatl.ge.1) then
    do i=1, mnant
      do_phase_atm(i) = .true.
    enddo
    call spectral_dump(kh,0,0)
    ipkh = kin+h_offset(r_ndump+1)
    call decode_header (memory(ipkh))
    call set_scaling(error)
    if (error) return
    zero = .true.
    if (k_average.eq.1) then
      call line_average (r_lntch,r_nbas,r_lnsb,data_in,   &
        spidl,zero,error)
    else
      call cont_average (r_nband,r_nbas,data_in,   &
       spidc,zero,error)
    endif 
    if (error) return
    do ib = 1, r_nbas
      if (wsba(isb,ib).gt.0) then
        z(ib) = zsba(isb,ib)/wsba(isb,ib)
      else
        z(ib) = 0
      endif
      w(ib) = wsba(isb,ib)
    enddo
    call antgain (z,w,zant,want)
    do ia = 1, r_nant
      if (want(ia).gt.0) then
        !               do ip = i, r_npol_rec
        !                  if (r_npol_rec.eq.1) then
        !                     ipol = r_lpolentry(1,1) ! To be patched when mixed unit
        !                  else
        !                     ipol = ip
        !                  endif
        if (r_jykel(1,ia).ne.0) then
          fc(ia) = fc(ia) + abs(zant(ia)) * r_jykel(1,ia)
          wfc(ia) = wfc(ia) + want(ia) / r_jykel(1,ia)**2
        else
          print *,"R_JYKEL ",1,ia," is ZERO"
        endif
        !               enddo
        !               if (r_npol_rec.ne.0) then
        !                  fc(ia) = fc(ia)/r_npol_rec
        !                  wfc(ia) = wfc(ia)/r_npol_rec
        !               else
        !                  print *,"R_NPOL_REC is ZERO"
        !               endif
        if (wfc(ia).ne.0) then
          ec(ia) = 1e-3 / sqrt(wfc(ia))
        else
          print *,"WFC ",ia," is ZERO"
        endif
      else
        fc(ia) = 0
        wfc(ia) = 0
        ec(ia) = -10.
      endif
    enddo
  endif
  !
  ! Restore atm phase status
  do i=1, mnant
    do_phase_atm(i) = save_atm(i)
  enddo
  !
  ! Compute FLUX
  if (r_proc.ne.p_flux) then
    ! search for flux in the table
    if = 0
    do i = 1, n_flux
      if (c_flux(i).eq.r_sourc   &
        .and. abs(freq_flux(i)-r_restf).lt.1d3   &
        .and. abs(r_dobs-date_flux(i)).lt.3) then
        if = i
      endif
    enddo
    if (if.ne.0) then
      r_flux = abs(flux(if))
      fluxout = r_flux
      write (chain,'(a,f5.1,a,f6.3,a)')   &
        'Current flux of '//r_sourc//' at ',   &
        r_restf/1d3,' GHz is ', fluxout, ' Jy'
      call message(6,1,'CHECK_FLUX',chain(1:lenc(chain)))
    else
      fluxout = r_flux
      if (r_flux.eq.0) fluxout = 1.0
      write (chain,'(a,f5.1,a,f6.3,a)')   &
        'Default flux of '//r_sourc//' at ',   &
        r_restf/1d3,' GHz is ', fluxout, ' Jy'
      call message(4,2,'CHECK_FLUX',chain(1:lenc(chain)))
    endif
  else
    ! Use only the two best antennas.
    !
    !     NGRX: for the time being we average polarizations (assume
    !     unpolarized source)
    !     corrected
    afc = 0
    wafc = 0
    efc  = 0
    if (r_ndatl.ge.1) then
      call r4tor4(fc,ft,r_nant)
      call gr4_trie(ft,ind,r_nant,error)
      do ia= r_nant, r_nant-nbest+1, -1
        i = ind(ia)
        afc = afc + ft(ia)*wfc(i)
        wafc = wafc + wfc(i)
      enddo
      if (wafc.gt.0) then
        afc = afc / wafc
        efc = 1e-3 / sqrt(wafc)
      endif
    endif
    !     uncorrected
    afu = 0
    wafu = 0
    efu = 0
    if (r_ndatl.ne.1) then
      call r4tor4(fu,ft,r_nant)
      call gr4_trie(ft,ind,r_nant,error)
      do ia= r_nant, r_nant-nbest+1, -1
        i = ind(ia)
        afu = afu + ft(ia)*wfu(i)
        wafu = wafu + wfu(i)
      enddo
      if (wafu.gt.0) then
        afu = afu / wafu
        efu = 1e-3 / sqrt(wafu)
      endif
    endif
    if (afc.ge.afu) then
      fluxout = afc
      errflux = efc
    else
      fluxout = afu
      errflux = efu
    endif
    if (abs(fluxout).gt.1e6 .or. abs(fluxout).lt.1e-6) then
      write (chain,'(a,1pg12.5)')   &
        'Unlikely flux for '//r_sourc//' : ',fluxout
      call message (8,3,'CHECK_FLUX',chain(1:lenc(chain)))
    else
      write (chain,'(a,f5.1,a,f6.3,a,f5.3,a)')   &
        'Estimated flux of '//r_sourc//' at ',   &
        r_restf/1d3,' GHz is ',   &
        fluxout, ' Jy (',errflux,')'
      call message(6,1,'CHECK_FLUX',chain(1:lenc(chain)))
      r_flux= fluxout
      !
      ! put in our source list
      if1 = 0
      if (n_flux.ge.1) then
        do if =1, n_flux
          if (r_sourc.eq.c_flux(if)   &
            .and. abs(r_restf-freq_flux(if)).lt.frtol) then
            flux(if) = r_flux
            freq_flux(if) = r_restf
            date_flux(if) = r_dobs
            f_flux(if) = .false.
            if1 = if
          endif
        enddo
      endif
      if (if1.le.0 .and. n_flux.lt.m_flux) then
        n_flux = n_flux+1
        f_flux(n_flux) = .false.
        flux(n_flux) = r_flux
        c_flux(n_flux) = r_sourc
        date_flux(n_flux) = r_dobs
        freq_flux(n_flux) = r_restf
      endif
    !
    endif
  endif
  !
  ! Messages
  error = .false.
  do ia = 1, r_nant
    ! optimistic flux is measured+3sigma
    phcorok(ia) = fc(ia).ge.fu(ia)
    if (phcorok(ia)) then
      fopt = fc(ia)+ec(ia)
    else
      fopt = fu(ia)+eu(ia)
    endif
    if (fluxout.gt.0 .and. fopt.gt.0) then
      lowfac(ia) = fopt / fluxout
      if (fopt.lt.0.9*fluxout) then
        if (r_ndatl.eq.0) then
          write (chain,1002) 'Low flux on Ant ',r_kant(ia),   &
            ' Rec ',r_nrec,' : ', fu(ia), 'Jy (Unc.)'
        elseif (r_ndatl.eq.1) then
          write (chain,1002) 'Low flux on Ant ',r_kant(ia),   &
            ' Rec ',r_nrec,' : ', fc(ia), 'Jy (Cor.)'
        elseif (r_ndatl.eq.2) then
          write (chain,1002) 'Low flux on Ant ',r_kant(ia),   &
            ' Rec ',r_nrec,' : ', fu(ia), 'Jy (Unc.) ',   &
            fc(ia),'Jy (Cor.)'
        endif
        call message(4,2,'CHECK_FLUX',chain(1:lenc(chain)))
        error = .true.
      endif
    endif
  enddo
  return
1002 format(a,i1,a,i1,a,2(f6.3,a))
end subroutine check_flux
!
real function effmax(f)
  real :: f                         !
  effmax = 60.
  if (f.lt.120000.) then
    effmax = 30.
  endif
  return
end function effmax

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_progstruct_types
  use cubetools_parameters
  use cubesyntax_messaging
  !
  public :: progstruct_t
  private
  !
  type progstruct_t
     character(len=varn_l) :: name = strg_unk
   contains
     procedure, public :: init     => cubetools_progstruct_init
     procedure, public :: reinit   => cubetools_progstruct_reinit
     procedure, public :: recreate => cubetools_progstruct_recreate
  end type progstruct_t
  !
contains
  !
  subroutine cubetools_progstruct_init(struct,name,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(progstruct_t), intent(inout) :: struct
    character(len=*),    intent(in)    :: name
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBETOOLS>PROGSTRUCT>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_defstructure(cubetools_progstruct_remove_trailing(name),global,error)
    if (error) return
    struct%name = cubetools_progstruct_remove_trailing(name)//'%'
  end subroutine cubetools_progstruct_init
  !
  subroutine cubetools_progstruct_reinit(struct,name,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(progstruct_t), intent(inout) :: struct
    character(len=*),    intent(in)    :: name
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBETOOLS>PROGSTRUCT>REINIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (sic_varexist(name)) then
       call cubesyntax_message(syntaxseve%others,rname,&
            name//' prog structure already exists => Remove it')
       call sic_delvariable(name,.false.,error)
       if (error) return
    endif
    call struct%init(name,error)
    if (error) return
  end subroutine cubetools_progstruct_reinit
  !
  subroutine cubetools_progstruct_recreate(struct,subname,substruct,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Check if the "struct" SIC structure exists. If it doesn't, return.
    ! Else check if "name" SIC structure dependant on "struct" exists.
    ! If it does, erase it, and then recreate it.
    !-------------------------------------------------------------------
    class(progstruct_t), intent(in)    :: struct
    character(len=*),    intent(in)    :: subname
    type(progstruct_t),  intent(inout) :: substruct
    logical,             intent(inout) :: error
    !
    character(len=varn_l) :: name
    character(len=*), parameter :: rname='CUBETOOLS>PROGSTRUCT>RECREATE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (.not.sic_varexist(cubetools_progstruct_remove_trailing(struct%name))) then
       call cubesyntax_message(seve%e,rname,&
            cubetools_progstruct_remove_trailing(struct%name)//' prog structure does not exist yet')
       error = .true.
       return
    endif
    name = trim(struct%name)//cubetools_progstruct_remove_trailing(subname)
    if (sic_varexist(name)) then
       call cubesyntax_message(syntaxseve%others,rname,&
            name//' prog structure already exists => Remove it')
       call sic_delvariable(name,.false.,error)
       if (error) return
    endif
    call substruct%init(name,error)
    if (error) return
  end subroutine cubetools_progstruct_recreate
  !
  function cubetools_progstruct_remove_trailing(name) result(trimname)
    !-------------------------------------------------------------------
    ! Check if name ends in a %. If it does, remove it .
    !-------------------------------------------------------------------
    character(len=*), intent(in)   :: name
    character(len=:), allocatable  :: trimname
    !
    integer(kind=4) :: length
    character(len=*), parameter :: rname='CUBETOOLS>PROGSTRUCT>REMOVE>TRAILING'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! *** JP Shouldn't we allocate the string trimname?
    length = len_trim(name)
    if (name(length:length).eq.'%') then
       trimname = name(1:length-1)
    else
       trimname = trim(name)
    endif
  end function cubetools_progstruct_remove_trailing
end module cubetools_progstruct_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the SIC package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine sic_pack_set(pack)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_pack_set
  use gpack_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack
  !
  pack%name='sic'
  pack%ext='.sic'
  pack%authors="S.Bardeau, J.Pety"
  pack%init=locwrd(sic_pack_init)
  pack%clean=locwrd(sic_pack_clean)
  pack%exec_on_child=locwrd(sic_pack_exec_on_child)
  !
end subroutine sic_pack_set
!
subroutine sic_pack_init(gpack_id,error)
  use gmath_messaging
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_pack_init
  use sic_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer, intent(in) :: gpack_id  !
  logical, intent(inout) :: error  ! Error flag
  !
  ! Set libraries id's
  call gsys_message_set_id(gpack_id)
  call gsys_c_message_set_id(gpack_id)
  call gmath_message_set_id(gpack_id)
  call gwcs_message_set_id(gpack_id)
  call gfits_message_set_id(gpack_id)
  call gio_message_set_id(gpack_id)
  call sic_message_set_id(gpack_id)
  call sic_c_message_set_id(gpack_id)
  !
  call sic_build()
  !
  ! Set default procedure extension
  call exec_program('sic'//backslash//'sic extension .pro')
  !
end subroutine sic_pack_init
!
subroutine sic_pack_exec_on_child(building_pack,error)
  use gpack_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_pack_exec_on_child
  use sic_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Load package and user procedure initializations.
  !---------------------------------------------------------------------
  type(gpack_info_t), intent(inout) :: building_pack  ! Package properties
  logical,            intent(inout) :: error          ! Error flag
  ! Local
  character(len=filename_length) :: file
  !
  ! Call initialization procedures
  if (building_pack%ext.eq.'') return
  !
  call exec_program('sic'//backslash//'sic extension '//building_pack%ext)
  !
  ! Execute default initialization macro
  if (sic_query_file('define'//trim(building_pack%pro_suffix)//building_pack%ext,'macro#dir:',building_pack%ext,file)) then
     call exec_program('@ "'//trim(file)//'"')
  endif
  !
  ! Execute user initialization macro
  if (sic_query_file('init','gag_init:',building_pack%ext,file)) then
     call exec_program('@ "'//trim(file)//'"')
  endif
  !
end subroutine sic_pack_exec_on_child
!
subroutine sic_pack_clean(error)
  use gbl_message
  use sic_interfaces, except_this=>sic_pack_clean
  use sic_dependencies_interfaces
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=4) :: i,nmacro2,ier
  character(len=filename_length) :: file
  !
  ! Close the procedures at each execution level
  nmacro2 = nmacro
  do i=1,nmacro2
    call endmac
  enddo
  !
  ! Delete all image variables to ensure updating
  call del_ima_var
  !
  ! Delete temporary directories (unique per session)
  call end_procedure  ! GAG_PROC: support files for procedures (begin/end procedure blocks)
  file = 'GAG_SCRATCH:'
  ier = sic_getlog(file)
  ier = gag_rmdir(file)
  if (ier.ne.0)  call sic_message(seve%w,'SIC','Error removing directory '//file)
  !
#ifndef CYGWIN
  ! Kill sub-process if any
  call end_dialog
#endif
  !
  ! Deallocate the SIC variables arrays
  call sic_free_variable
  !
  call sic_freesymbol(error)
  ! if (error)  continue
  !
  call sic_free_languages(error)
  ! if (error)  continue
  !
  call sic_lunmac_exit(error)
  ! if (error)  continue
  !
  call sic_output_close(error)
  ! if (error)  continue
  !
  call exit_task(error)
  ! if (error)  continue
  !
end subroutine sic_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE FORMAT_DATE(JDATE,CDATE,ERROR)
C----------------------------------------------------------------------
C ORBIT	
C	Convert a julian day to a human readable character string
C Arguments :
C	JDATE	R*8	Julian date
C       CDATE   C*(*)   Human readable string
C	ERROR   L       Error flag
C----------------------------------------------------------------------
      REAL*8 JDATE
      CHARACTER*(*) CDATE
      LOGICAL ERROR
*
      INTEGER ID,HH,MM
      CHARACTER NAME*11
      REAL*8 TT
      INTEGER LL
*
      ERROR = .FALSE.
      TT = JDATE-60549.5       ! Convert to "radio julian days": 
      ID = INT(TT)             !-2^15 is Karl Jansky's first radio observation
      IF (ID.GT.TT) THEN       ! Work around the stupid fortran INT definition
         ID=ID-1               ! for negative numbers
      ENDIF
      CALL DATEC(ID,NAME,ERROR)! Format to day of year
      IF (ERROR) THEN
         WRITE(6,*) 'E-LIST,  Error in date conversion ',ID
         RETURN
      ENDIF
      TT = (TT-ID)*24.D0
      HH = INT(TT)
      TT = (TT-HH)*60.D0
      MM = INT(TT)
      TT = (TT-MM)*60.D0 
*
      CDATE = NAME
      LL = 11
      IF (LEN(CDATE).LT.LL+3) RETURN  ! No space for hours
      WRITE (CDATE(LL+1:),100) HH
      LL = LL+3
      IF (LEN(CDATE).LT.LL+3) RETURN  ! No space for minutes
      WRITE (CDATE(LL+1:),101) MM
      LL = LL+3
      IF (LEN(CDATE).LT.LL+3) RETURN  ! No space for seconds
      IF (LEN(CDATE).LT.LL+5) THEN
         WRITE (CDATE(LL+1:),101) INT(TT)
         LL = LL+3
      ELSE
         WRITE (CDATE(LL+1:),102) TT
         LL = LL+5
      ENDIF
*         
      RETURN
 100  FORMAT (1X,I2.2)
 101  FORMAT (':',I2.2)
 102  FORMAT (':',F4.1)
      END

      SUBROUTINE CDATE(DATE,IDATE,ERROR)
C----------------------------------------------------------------------
C ASTRO Utility routine
C	Converts the date '01-JAN-1984' in internal code
C Arguments
C	DATE 	C*(*)	String date			Input
C	IDATE 	I	Internal coded date value	Output
C	ERROR 	L	Logical error flag		Output
C Subroutines :
C	(SIC)
C	DATJ,JDAT
C No commons
C----------------------------------------------------------------------
      CHARACTER*(*) DATE
      INTEGER IDATE
      LOGICAL ERROR
*
      CHARACTER*3 CM(12),M
      INTEGER ID, IY, IM
*
      DATA CM/'JAN','FEB','MAR','APR','MAY','JUN',
     $'JUL','AUG','SEP','OCT','NOV','DEC'/
*
      IF (DATE.EQ.'*') RETURN
      READ(DATE,'(I2,1X,A,1X,I4)',ERR=900) ID,M,IY
      CALL SIC_UPPER(M)
      DO 10 IM=1,12
         IF (CM(IM).EQ.M) THEN
            CALL DATJ(ID,IM,IY,IDATE)
            RETURN
         ENDIF
10    CONTINUE
*
* Wrong date
900   WRITE(6,'(A)') 'E-DATE,  Date conversion error'
      ERROR=.TRUE.
      RETURN
      END
*
      SUBROUTINE DATEC(IDATE,DATE,ERROR)
      CHARACTER*(*) DATE
      INTEGER IDATE
*
      LOGICAL ERROR
      CHARACTER*3 CM(12)
      INTEGER ID, IY, IM
*
      DATA CM/'JAN','FEB','MAR','APR','MAY','JUN',
     $'JUL','AUG','SEP','OCT','NOV','DEC'/

C-------
C	Converts the internal code to formatted date
C-------
      CALL JDAT(IDATE,ID,IM,IY)
      WRITE(DATE,1000,ERR=900) ID,CM(IM),IY
1000  FORMAT(I2.2,'-',A3,'-',I4)
      RETURN
 900  ERROR = .TRUE.
      END
*<FF>
      SUBROUTINE DATJ(ID,IM,IY,JOUR)
C----------------------------------------------------------------------
C ASTRO	Utility routine
C	Convert a date (id/im/iy) in number of days till the
C	01/01/1984
C Arguments :
C	ID	I	Day number		Input
C	IM	I	Month number		Input
C	IY	I	Year number		Input
C	JOUR	I	Elapsed day count	Output
C Subroutine
C	JULDA
C----------------------------------------------------------------------
      INTEGER ID, IM, IY
      INTEGER JOUR
      INTEGER IDEB(13), IBISS, JULDA, J, M, JOUR4
      INTEGER IZERO
      PARAMETER (IZERO=2025)
*
      DATA IDEB/0,31,59,90,120,151,181,212,243,273,304,334,365/
*
      JOUR4=ID+IDEB(IM)
      IBISS=JULDA(IY+1)-JULDA(IY)-365
      IF (MOD(IY,100).EQ.0.AND.MOD(IY,400).NE.0) IBISS=0
      IF (IM.GE.3) JOUR4=JOUR4+IBISS
      JOUR4=JOUR4+JULDA(IY)
      JOUR=JOUR4
      RETURN
*
      ENTRY JDAT(JOUR,ID,IM,IY)
C-------
C 	Reverse conversion
C-------
      IY=IZERO+JOUR/365
1     J=JOUR-JULDA(IY)
      IF (J.LE.0) THEN
         IY=IY-1
         GO TO 1
      ELSEIF (J.GT.365) THEN
* Special case for 31 december of leap years...
         IF (J.EQ.366) THEN
            IBISS=JULDA(IY+1)-JULDA(IY)-365
            IF (MOD(IY,100).EQ.0.AND.MOD(IY,400).NE.0) 
     +           IBISS=0
            IF (IBISS.EQ.0) THEN
               IY=IY+1
               GO TO 1
            ENDIF
         ELSE
            IY=IY+1
            GO TO 1
         ENDIF
      ENDIF
      IBISS=JULDA(IY+1)-JULDA(IY)-365
      IF (MOD(IY,100).EQ.0.AND.MOD(IY,400).NE.0) IBISS=0
      DO 2 M=12,1,-1
         ID=J-IDEB(M)
         IF (M.GE.3) ID=ID-IBISS
         IF (ID.GT.0) GO TO 3
2     CONTINUE
3     IM=M
      END
*<FF>
      FUNCTION JULDA(NYR)
C----------------------------------------------------------------------
C ASTRO	Utility routine
C	Returns Julian date of 1 day of Year
C Arguments
C	NYR	I	Year				Input
C	JULDA	I	Date returned			Output
C----------------------------------------------------------------------
      INTEGER NYR, NYRM1, IC, NADD, JULDA
      INTEGER IZERO
      PARAMETER (IZERO=2025)
      NYRM1=NYR-1
      IC=NYRM1/100
      NADD=NYRM1/4-IC+IC/4
      JULDA=365.*(NYRM1-IZERO)+NADD
      END
*<FF>
      SUBROUTINE ADATE(CHAIN,ID,IM,IY,ERROR)
      CHARACTER*(*) CHAIN
      INTEGER ID,IM,IY
      LOGICAL ERROR
*
      INTEGER I,IER
      CHARACTER*3 CM(12),M
      DATA CM/'JAN','FEB','MAR','APR','MAY','JUN',
     $'JUL','AUG','SEP','OCT','NOV','DEC'/
*
      ERROR = .TRUE.
      READ(CHAIN(1:11),'(I2,1X,A,1X,I4)',IOSTAT=IER) ID,M,IY
      IF (IER.NE.0) THEN
         WRITE(6,*) 'E-DATE, Error decoding formatted date'
         ID = 0
         IM = 0
         IY = 0
         RETURN
      ENDIF
      CALL SIC_UPPER(M)
      DO I=1,12
         IF (CM(I).EQ.M) THEN
            IM = I
            ERROR = .FALSE.
            RETURN
         ENDIF
      ENDDO
      END

module cubedag_history_types
  use gkernel_interfaces
  use cubelist_types
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_link_type
  use cubedag_links_type
  use cubedag_dag_buffer
  !---------------------------------------------------------------------
  ! Support module for the history type
  !---------------------------------------------------------------------
  !
  public :: cubedag_history_t,cubedag_history_ptr
  public :: cubedag_history_list_t
  private
  !
  integer(kind=4), parameter :: command_length=16  ! ZZZ Duplicated from SIC
  !
  ! DAG data format
  character(len=*), parameter :: form_i8='(A,T13,I20)'
  character(len=*), parameter :: form_a='(A,T13,A)'  ! Scalar string
  !
  type, extends(list_object_t) :: cubedag_history_t
    integer(kind=iden_l)              :: id = 0
    character(len=command_length)     :: command = strg_unk
    character(len=commandline_length) :: line = strg_unk
    type(cubedag_hlinks_t)            :: links
  contains
    procedure, public  :: init       => cubedag_history_init
    procedure, public  :: read       => cubedag_history_read
    procedure, private :: read_head  => cubedag_history_read_head
    procedure, public  :: write      => cubedag_history_write
    procedure, private :: write_head => cubedag_history_write_head
    procedure, public  :: final      => cubedag_history_final
  end type cubedag_history_t
  !
  type, extends(list_t) :: cubedag_history_list_t
    integer(kind=4), private :: lun
  contains
    procedure, public  :: entrynum => cubedag_history_entrynum
    procedure, public  :: add      => cubedag_history_add_fromargs
    procedure, public  :: liste    => cubedag_history_list
    procedure, public  :: init     => cubedag_history_list_init
    procedure, private :: open     => cubedag_history_list_open
    procedure, public  :: read     => cubedag_history_list_read
    procedure, public  :: write    => cubedag_history_list_write
    procedure, private :: close    => cubedag_history_list_close
  end type cubedag_history_list_t
contains

  function cubedag_history_ptr(lot,error)
    !-------------------------------------------------------------------
    ! Check if the input type is a 'cubedag_history_t', and return a
    ! pointer to it if relevant.
    !-------------------------------------------------------------------
    type(cubedag_history_t), pointer :: cubedag_history_ptr  ! Function value on return
    class(list_object_t), pointer       :: lot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPENED>PTR'
    !
    select type(lot)
    type is (cubedag_history_t)
      cubedag_history_ptr => lot
    class default
      cubedag_history_ptr => null()
      call cubedag_message(seve%e,rname,'Internal error: object is not a cubedag_history_t')
      error = .true.
      return
    end select
  end function cubedag_history_ptr

  subroutine cubedag_history_init(hist,error)
    !-------------------------------------------------------------------
    ! Initialize the i-th component in the index
    !-------------------------------------------------------------------
    class(cubedag_history_t), intent(out)   :: hist
    logical,                  intent(inout) :: error
    !
    ! Done with intent(out)
  end subroutine cubedag_history_init
  !
  subroutine cubedag_history_read(hobj,lun,nshift,hshift,nomore,error)
    !-------------------------------------------------------------------
    ! Read the next history object from the DAG file (if any)
    !-------------------------------------------------------------------
    class(cubedag_history_t), intent(inout) :: hobj
    integer(kind=4),          intent(in)    :: lun
    integer(kind=iden_l),     intent(in)    :: nshift  ! Node ID shift
    integer(kind=iden_l),     intent(in)    :: hshift  ! History ID shift
    logical,                  intent(inout) :: nomore
    logical,                  intent(inout) :: error
    !
    call hobj%read_head(lun,hshift,nomore,error)
    if (error)  return
    if (nomore)  return
    call hobj%links%read(lun,nshift,error)
    if (error)  return
  end subroutine cubedag_history_read
  !
  subroutine cubedag_history_read_head(hobj,lun,hshift,nomore,error)
    class(cubedag_history_t), intent(inout) :: hobj
    integer(kind=4),          intent(in)    :: lun
    integer(kind=iden_l),     intent(in)    :: hshift  ! History ID shift
    logical,                  intent(inout) :: nomore
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='HREPOSITORY>READ'
    character(len=12) :: key
    integer(kind=iden_l) :: hid
    integer(kind=4) :: ier
    !
    read(lun,form_i8,iostat=ier) key,hid
    if (ier.lt.0) then
      ! EOF
      nomore = .true.
      return
    endif
    if (ier.gt.0) then
      call putios('E-HREPOSITORY,  ',ier)
      error = .true.
      return
    endif
    if (key.ne.'ID') then
      call cubedag_message(seve%e,rname,'Malformatted file: got '//trim(key))
      error = .true.
      return
    endif
    !
    hobj%id = hid+hshift
    read(lun,form_a) key,hobj%command
    read(lun,form_a) key,hobj%line
  end subroutine cubedag_history_read_head
  !
  subroutine cubedag_history_write(hobj,lun,error)
    !-------------------------------------------------------------------
    ! Write the next history object to the DAG file
    !-------------------------------------------------------------------
    class(cubedag_history_t), intent(in)    :: hobj
    integer(kind=4),          intent(in)    :: lun
    logical,                  intent(inout) :: error
    !
    call hobj%write_head(lun,error)
    if (error)  return
    call hobj%links%write(lun,error)
    if (error)  return
  end subroutine cubedag_history_write
  !
  subroutine cubedag_history_write_head(hobj,lun,error)
    class(cubedag_history_t), intent(in)    :: hobj
    integer(kind=4),          intent(in)    :: lun
    logical,                  intent(inout) :: error
    !
    write(lun,form_i8) 'ID',hobj%id
    write(lun,form_a)  'COMMAND',trim(hobj%command)
    write(lun,form_a)  'LINE',trim(hobj%line)
  end subroutine cubedag_history_write_head
  !
  subroutine cubedag_history_final(obj,error)
    !-------------------------------------------------------------------
    ! No implicit final because of
    ! https://gcc.gnu.org/bugzilla/show_bug.cgi?id=112459
    !-------------------------------------------------------------------
    class(cubedag_history_t), intent(inout) :: obj
    logical,                  intent(inout) :: error
    !
    ! Clean
    call obj%links%final(error)
    if (error)  continue
    !
    ! Reinitialize (after cleaning)
    call obj%init(error)
    if (error)  continue
  end subroutine cubedag_history_final

  function cubedag_history_entrynum(hx,id,error)
    !-------------------------------------------------------------------
    ! Resolve the entry number corresponding to the given ID.
    ! - If ID>0, the entry is resolved by searching in all the history
    ! index. This resolution is based on two strong assumptions:
    !  1) the identifier is UNIQUE,
    !  2) the identifier list is SORTED
    ! - If ID<=0, the ID is assumed to be a position from the end
    ! (0=last, same as CubeID).
    !-------------------------------------------------------------------
    integer(kind=entr_k) :: cubedag_history_entrynum
    class(cubedag_history_list_t), intent(in)    :: hx
    integer(kind=iden_l),          intent(in)    :: id
    logical,                       intent(inout) :: error
    !
    integer(kind=entr_k) :: inf,mid,sup
    character(len=mess_l) :: mess
    type(cubedag_history_t), pointer :: hist
    character(len=*), parameter :: rname='HISTORY>ENTRYNUM'
    !
    if (id.le.0) then
      ! Search by position from the end
      if (-id.gt.hx%n-1) then
        write(mess,'(A,I0,A)')  'No such identifier ',id,' in command history index'
        call cubedag_message(seve%e,rname,mess)
        cubedag_history_entrynum = 0
        error = .true.
        return
      endif
      cubedag_history_entrynum = hx%n+id
      return
    endif
    !
    ! Dichotomic search
    hist => cubedag_history_ptr(hx%list(1)%p,error)
    if (error)  return
    if (hist%id.eq.id) then
      cubedag_history_entrynum = 1
      return
    endif
    !
    inf = 1
    sup = hx%n
    do while (sup.gt.inf+1)
      mid = (inf+sup)/2  ! Integer division
      hist => cubedag_history_ptr(hx%list(mid)%p,error)
      if (error)  return
      if (hist%id.lt.id) then
        inf = mid
      else
        sup = mid
      endif
    enddo
    !
    hist => cubedag_history_ptr(hx%list(sup)%p,error)
    if (error)  return
    if (hist%id.eq.id) then
      cubedag_history_entrynum = sup
    else
      write(mess,'(A,I0,A)')  'No such identifier ',id,' in command history index'
      call cubedag_message(seve%e,rname,mess)
      cubedag_history_entrynum = 0
      error = .true.
      return
    endif
  end function cubedag_history_entrynum
  !
  subroutine cubedag_history_add_fromargs(hoptx,command,line,inputs,outputs,&
    hid,error)
    !-------------------------------------------------------------------
    ! Add a new command in the HISTORY index
    !-------------------------------------------------------------------
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: command
    character(len=*),              intent(in)    :: line
    type(cubedag_link_t),          intent(in)    :: inputs
    type(cubedag_link_t),          intent(in)    :: outputs
    integer(kind=list_k),          intent(out)   :: hid
    logical,                       intent(inout) :: error
    !
    type(cubedag_history_t) :: model
    class(list_object_t), pointer :: lot
    type(cubedag_history_t), pointer :: hobj
    !
    ! Add
    call hoptx%allocate(model,lot,error)
    if (error)  return
    hobj => cubedag_history_ptr(lot,error)
    if (error)  return
    !
    ! Fill the object
    hid = hoptx%n
    hobj%id = hid
    hobj%command = command
    hobj%line = line
    call inputs%copy(hobj%links%inputs,error)
    if (error)  return
    call outputs%copy(hobj%links%outputs,error)
    if (error)  return
  end subroutine cubedag_history_add_fromargs

  subroutine cubedag_history_list(hoptx,error)
    !-------------------------------------------------------------------
    ! List the history index
    !-------------------------------------------------------------------
    class(cubedag_history_list_t), intent(in)    :: hoptx
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='HISTORY>LIST'
    type(cubedag_history_t), pointer :: obj
    integer(kind=entr_k) :: ient
    character(len=10) :: tmpi,tmpo
    integer(kind=4) :: nd
    character(len=16) :: forma
    integer(kind=iden_l) :: maxid
    !
    if (hoptx%n.le.0) then
      call cubedag_message(seve%w,rname,'History index is empty')
      return
    endif
    !
    maxid = 0
    do ient=1,hoptx%n
      obj => cubedag_history_ptr(hoptx%list(ient)%p,error)
      if (error)  return
      maxid = max(maxid,obj%id)
    enddo
    nd = ceiling(log10(real(maxid+1,kind=8)))
    write(forma,'(A,I0,A)') '(I',nd,',4(2X,A))'
    !
    do ient=1,hoptx%n
      obj => cubedag_history_ptr(hoptx%list(ient)%p,error)
      if (error)  return
      call obj%links%inputs%repr('i=',tmpi)
      call obj%links%outputs%repr('o=',tmpo)
      write(*,forma)  obj%id,obj%command,tmpi,tmpo,trim(obj%line)
    enddo
  end subroutine cubedag_history_list
  !
  subroutine cubedag_history_list_init(hoptx,path,error)
    !-------------------------------------------------------------------
    ! Initialize a new repository
    !-------------------------------------------------------------------
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: path
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='HISTORY>LIST>INIT'
    !
    ! Create and init new one on disk
    ! ZZZ Not yet implemented
    !
  end subroutine cubedag_history_list_init
  !
  subroutine cubedag_history_list_open(hoptx,name,read,error)
    use cubetools_system_tool
    !-------------------------------------------------------------------
    ! Open the repository file for reading or writing.
    !-------------------------------------------------------------------
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: name
    logical,                       intent(in)    :: read
    logical,                       intent(inout) :: error
    !
    character(len=3) :: mode
    integer(kind=4) :: ier
    logical :: readonly
    character(len=*), parameter :: rname='HISTORY>LIST>OPEN'
    !
    if (read) then
      mode = 'OLD'
      readonly = .true.
    else
      call cubedag_message(seve%i,rname,'Creating history repository in file '//name)
      readonly = .false.
      mode = 'NEW'
      call cubetools_directory_create_for_file(name,error)
      if (error) return
    endif
    !
    ier = sic_getlun(hoptx%lun)
    if (mod(ier,2).eq.0) then
      error = .true.
      return
    endif
    ier = sic_open(hoptx%lun,name,mode,readonly)
    if (ier.ne.0) then
      call cubedag_message(seve%e,rname,'Error opening file '//name)
      call putios('E-SIC, ',ier)
      error = .true.
      return
    endif
  end subroutine cubedag_history_list_open
  !
  subroutine cubedag_history_list_close(hoptx,error)
    class(cubedag_history_list_t), intent(inout) :: hoptx
    logical,                       intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    ier = sic_close(hoptx%lun)
    call sic_frelun(hoptx%lun)
  end subroutine cubedag_history_list_close
  !
  subroutine cubedag_history_list_write(hoptx,reponame,error)
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: reponame
    logical,                       intent(inout) :: error
    !
    integer(kind=entr_k) :: ient
    character(len=mess_l) :: mess
    type(cubedag_history_t), pointer :: hobj
    character(len=*), parameter :: rname='HISTORY>LIST>WRITE'
    !
    call hoptx%open(reponame,.false.,error)
    if (error)  return
    !
    do ient=1,hoptx%n
      hobj => cubedag_history_ptr(hoptx%list(ient)%p,error)
      if (error)  return
      call hobj%write(hoptx%lun,error)
      if (error) then
        write(mess,'(2(A,I0))')  'Error writing history entry #',ient,'/',hoptx%n
        call cubedag_message(seve%e,rname,mess)
        return
      endif
    enddo
    !
    call hoptx%close(error)
    if (error)  return
  end subroutine cubedag_history_list_write

  subroutine cubedag_history_list_read(hoptx,reponame,nshift,hshift,error)
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: reponame
    integer(kind=iden_l),          intent(in)    :: nshift  ! Node ID shift
    integer(kind=iden_l),          intent(in)    :: hshift  ! History ID shift
    logical,                       intent(inout) :: error
    !
    character(len=mess_l) :: mess
    logical :: nomore
    integer(kind=entr_k) :: ient
    type(cubedag_history_t) :: model
    type(cubedag_history_t), pointer :: hobj
    class(list_object_t), pointer :: lot
    character(len=*), parameter :: rname='HISTORY>LIST>READ'
    !
    call hoptx%open(reponame,.true.,error)
    if (error)  return
    !
    nomore = .false.
    do
      ! Allocate a new object
      call hoptx%allocate(model,lot,error)
      if (error)  return
      hobj => cubedag_history_ptr(lot,error)
      if (error)  return
      call hobj%read(hoptx%lun,nshift,hshift,nomore,error)
      if (error)  return
      if (nomore) then
        ! The last allocated object was useless: remove
        call hoptx%pop(hoptx%n,error)
        if (error)  return
        exit
      endif
    enddo
    !
    ! Post-read: resolve all the links (from IDs to pointers) AFTER the
    ! whole DAG (IX) is reconstructed
    do ient=1,hoptx%n
      hobj => cubedag_history_ptr(hoptx%list(ient)%p,error)
      if (error)  return
      call hobj%links%resolve(ix,error)
      if (error)  return
    enddo
    !
    ! Feedback
    write(mess,'(A,I0,A)')  'Loaded an history index of ',hoptx%n,' commands'
    call cubedag_message(seve%i,rname,mess)
    !
    call hoptx%close(error)
    if (error)  return
  end subroutine cubedag_history_list_read

end module cubedag_history_types

subroutine w4tow4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of 'untyped' 4-bytes words. In practice, use integer*4
  ! type because any bit pattern is valid in this representation
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine w4tow4
!
subroutine r4tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of real*4. In practice, use integer*4 type because any
  ! bit pattern is valid in this representation. Some compilers and/or
  ! architectures may change the real*4 bit pattern during the copy,
  ! especially if value is a NaN
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4tor4
!
subroutine r8tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of real*8. In practice, use integer*8 type because any
  ! bit pattern is valid in this representation. Some compilers and/or
  ! architectures may change the real*8 bit pattern during the copy,
  ! especially if value is a NaN.
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r8tor8
!
subroutine r8tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r8tor4
!
subroutine r4tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  real(kind=8),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4tor8
!
subroutine i4tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  real(kind=8),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4tor8
!
subroutine i4tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4tor4
!
subroutine r4toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r4toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -2147483648
    elseif  (in(i).le.iplus) then
      out(i) = nint(in(i),kind=4)
    else
      out(i) = 2147483647
    endif
  enddo
end subroutine r4toi4
!
subroutine r8toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -2147483648
    elseif  (in(i).le.iplus) then
      out(i) = nint(in(i),kind=4)
    else
      out(i) = 2147483647
    endif
  enddo
end subroutine r8toi4
!
subroutine i8tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8tor4
!
subroutine r4toi8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r4toi8_fini instead.
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -9223372036854775808_8
    elseif (in(i).le.iplus) then
      out(i) = nint(in(i),kind=8)
    else
      out(i) = 9223372036854775807_8
    endif
  enddo
end subroutine r4toi8
!
subroutine l4tol4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of logical*4. Be conservative: use integer*4 type
  ! because any bit pattern is valid in this representation. Not sure of
  ! what happens in case of invalid logical value.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine l4tol4
!
subroutine i4toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4toi4
!
subroutine i8toi8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8toi8
!
subroutine i4toi8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4toi8
!
subroutine i8toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  integer(kind=8), parameter :: iplus = 2147483647_8 ! 2**31-1
  integer(kind=8), parameter :: imoins = -2147483648_8 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = imoins
    elseif (in(i).gt.iplus) then
      out(i) = iplus
    else
      out(i) = in(i)
    endif
  enddo
end subroutine i8toi4
!
subroutine i8tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  real(kind=8),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8tor8
!
subroutine r8toi8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi8_fini instead.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -9223372036854775808_8
    elseif (in(i).le.iplus) then
      out(i) = nint(in(i),kind=8)
    else
      out(i) =  9223372036854775807_8
    endif
  enddo
end subroutine r8toi8
!
subroutine c4toc4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  complex(kind=4), intent(in)  :: in(*)   !
  complex(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine c4toc4
!
subroutine c4tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  complex,         intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine c4tor4
!
subroutine r4toc4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  complex(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine r4toc4
!
subroutine c8tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  double complex,  intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine c8tor4
!
subroutine r4toc8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  double complex,  intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4toc8
!
subroutine i2toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=2), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = in(i)
  enddo
end subroutine i2toi4
!
subroutine adtoad(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)  :: in(*)   !
  integer(kind=address_length), intent(out) :: out(*)  !
  integer(kind=4),              intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = in(i)
  enddo
end subroutine adtoad
!
subroutine i2tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=2), intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = in(i)
  enddo
end subroutine i2tor4
!
subroutine i2tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=2), intent(in)  :: in(*)   !
  real(kind=8),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = in(i)
  enddo
end subroutine i2tor8
!
subroutine bytoby(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=1), intent(in)  :: in(*)   !
  integer(kind=1), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine bytoby
!
subroutine bytoch(in,ch,n)
  use gildas_def
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Copy a Byte array into a Fortran character String
  !---------------------------------------------------------------------
  integer(kind=1),  intent(in)    :: in(*)  !
  character(len=*), intent(inout) :: ch     ! Ifort complains if intent(out)
  integer(kind=4),  intent(in)    :: n      ! [bytes]
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ich
  integer(kind=4) :: i, m
  !
  ich = bytpnt(locstr(ch),membyt)
  m = min(n,len(ch))
  do i=1,m
    membyt(ich+i-1) = in(i)
  enddo
end subroutine bytoch
!
subroutine chtoby(ch,out,n)
  use gildas_def
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Copy a Fortran character String into a Byte array
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: ch      !
  integer(kind=1),  intent(out) :: out(*)  !
  integer(kind=4),  intent(in)  :: n       ! [bytes]
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ich
  integer(kind=4) :: i, m
  !
  ich = bytpnt(locstr(ch),membyt)
  m = min(n,len(ch))
  do i=1,m
    out(i) = membyt(ich+i-1)
  enddo
end subroutine chtoby
!
subroutine w4toch(in,ch,n)
  use gildas_def
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Same as bytoch except number of elements is in words (not bytes).
  ! Suited for arrays multiple of 4-bytes.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: in(*)  !
  character(len=*), intent(inout) :: ch     !
  integer(kind=4),  intent(in)    :: n      ! [words]
  !
  call bytoch(in,ch,n*4)
  !
end subroutine w4toch
!
subroutine chtow4(ch,out,n)
  use gildas_def
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Same as chtoby except number of elements is in words (not bytes).
  ! Suited for arrays multiple of 4-bytes.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: ch      !
  integer(kind=4),  intent(out) :: out(*)  !
  integer(kind=4),  intent(in)  :: n       ! [words]
  !
  call chtoby(ch,out,n*4)
  !
end subroutine chtow4
!
! Below duplicate of the subroutines, but which accept number of elements
! to be copied as integers of kind=size_length.
!
subroutine w4tow4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of 'untyped' 4-bytes words. In practice, use integer*4
  ! type because any bit pattern is valid in this representation
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine w4tow4_sl
!
subroutine w8tow8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of 'untyped' 8-bytes words. In practice, use integer*8
  ! type because any bit pattern is valid in this representation
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine w8tow8_sl
!
subroutine r4tor4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of real*4. In practice, use integer*4 type because any
  ! bit pattern is valid in this representation. Some compilers and/or
  ! architectures may change the real*4 bit pattern during the copy,
  ! especially if value is a NaN
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4tor4_sl
!
subroutine r8tor8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of real*8. In practice, use integer*8 type because any
  ! bit pattern is valid in this representation. Some compilers and/or
  ! architectures may change the real*8 bit pattern during the copy,
  ! especially if value is a NaN.
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r8tor8_sl
!
subroutine r8tor4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  real(kind=4),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r8tor4_sl
!
subroutine r4tor8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: in(*)   !
  real(kind=8),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4tor8_sl
!
subroutine l4tol4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of logical*4. Be conservative: use integer*4 type
  ! because any bit pattern is valid in this representation. Not sure of
  ! what happens in case of invalid logical value.
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine l4tol4_sl
!
subroutine i4tor8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  real(kind=8),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4tor8_sl
!
subroutine i4tor4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  real(kind=4),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4tor4_sl
!
subroutine r4toi4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r4toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -2147483648
    elseif  (in(i).le.iplus) then
      out(i) = nint(in(i),kind=4)
    else
      out(i) = 2147483647
    endif
  enddo
end subroutine r4toi4_sl
!
subroutine r8toi4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -2147483648
    elseif  (in(i).le.iplus) then
      out(i) = nint(in(i),kind=4)
    else
      out(i) = 2147483647
    endif
  enddo
end subroutine r8toi4_sl
!
subroutine i8tor4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  real(kind=4),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8tor4_sl
!
subroutine r4toi8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -9223372036854775808_8
    elseif (in(i).le.iplus) then
      out(i) = nint(in(i),kind=8)
    else
      out(i) = 9223372036854775807_8
    endif
  enddo
end subroutine r4toi8_sl
!
subroutine i4toi8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4toi8_sl
!
subroutine i8toi4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  integer(kind=8), parameter :: iplus = 2147483647_8 ! 2**31-1
  integer(kind=8), parameter :: imoins = -2147483648_8 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = imoins
    elseif (in(i).gt.iplus) then
      out(i) = iplus
    else
      out(i) = in(i)
    endif
  enddo
end subroutine i8toi4_sl
!
subroutine i8tor8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  real(kind=8),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8tor8_sl
!
subroutine r8toi8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi8_fini instead.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -9223372036854775808_8
    elseif (in(i).le.iplus) then
      out(i) = nint(in(i),kind=8)
    else
      out(i) =  9223372036854775807_8
    endif
  enddo
end subroutine r8toi8_sl
!
subroutine c4toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  complex(kind=4),           intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine c4toc4_sl
!
subroutine r4toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine r4toc4_sl
!
subroutine r8toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine r8toc4_sl
!
subroutine i4toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine i4toc4_sl
!
subroutine i8toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine i8toc4_sl
!
subroutine r4toi4_fini(in,out,n,error)
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: in(*)   !
  integer(kind=4), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (.not.sic_fini4(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*4')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=4)
    endif
  enddo
end subroutine r4toi4_fini
!
subroutine r4toi8_fini(in,out,n,error)
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: in(*)   !
  integer(kind=8), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (.not.sic_fini4(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*8')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=8)
    endif
  enddo
end subroutine r4toi8_fini
!
subroutine r8toi4_fini(in,out,n,error)
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: in(*)   !
  integer(kind=4), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (.not.sic_fini8(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*4')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=4)
    endif
  enddo
end subroutine r8toi4_fini
!
subroutine r8toi8_fini(in,out,n,error)
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: in(*)   !
  integer(kind=8), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (.not.sic_fini8(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*8')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=8)
    endif
  enddo
end subroutine r8toi8_fini
!
subroutine i8toi4_fini(in,out,n,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: in(*)   !
  integer(kind=4), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  integer(kind=8), parameter :: iplus = 2147483647_8 ! 2**31-1
  integer(kind=8), parameter :: imoins = -2147483648_8 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'INTEGER*8 value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'INTEGER*8 value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = in(i)
    endif
  enddo
end subroutine i8toi4_fini
!
subroutine r4toi4_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)    :: in(*)   !
  integer(kind=4),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (.not.sic_fini4(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*4')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=4)
    endif
  enddo
end subroutine r4toi4_fini_sl
!
subroutine r4toi8_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)    :: in(*)   !
  integer(kind=8),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (.not.sic_fini4(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*8')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=8)
    endif
  enddo
end subroutine r4toi8_fini_sl
!
subroutine r8toi4_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)    :: in(*)   !
  integer(kind=4),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (.not.sic_fini8(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*4')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=4)
    endif
  enddo
end subroutine r8toi4_fini_sl
!
subroutine r8toi8_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)    :: in(*)   !
  integer(kind=8),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (.not.sic_fini8(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*8')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=8)
    endif
  enddo
end subroutine r8toi8_fini_sl
!
subroutine i8toi4_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)    :: in(*)   !
  integer(kind=4),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  integer(kind=8), parameter :: iplus = 2147483647_8 ! 2**31-1
  integer(kind=8), parameter :: imoins = -2147483648_8 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'INTEGER*8 value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'INTEGER*8 value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = in(i)
    endif
  enddo
end subroutine i8toi4_fini_sl
!
subroutine bytoby_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=1),           intent(in)  :: in(*)   !
  integer(kind=1),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine bytoby_sl

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_fullcube2fullcube
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetemplate_factor_types
  use cubetopology_cuberegion_types
  use cubetemplate_messaging
  !
  public :: fullcube2fullcube
  private
  !
  type :: fullcube2fullcube_comm_t
     type(option_t), pointer :: comm  
     type(factor_comm_t)     :: factor
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube
  contains
     procedure, public  :: register => cubetemplate_fullcube2fullcube_comm_register
     procedure, private :: parse    => cubetemplate_fullcube2fullcube_comm_parse
     procedure, private :: main     => cubetemplate_fullcube2fullcube_comm_main
  end type fullcube2fullcube_comm_t
  type(fullcube2fullcube_comm_t) :: fullcube2fullcube
  !
  type fullcube2fullcube_user_t
     type(cubeid_user_t)     :: cubeids
     type(factor_user_t)     :: factor
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubetemplate_fullcube2fullcube_user_toprog
  end type fullcube2fullcube_user_t
  !
  type fullcube2fullcube_prog_t
     type(cuberegion_prog_t) :: region
     type(factor_prog_t)     :: factor
     type(cube_t), pointer   :: incube
     type(cube_t), pointer   :: oucube
   contains
     procedure, private :: header => cubetemplate_fullcube2fullcube_prog_header
     procedure, private :: data   => cubetemplate_fullcube2fullcube_prog_data
     procedure, private :: loop   => cubetemplate_fullcube2fullcube_prog_loop
     procedure, private :: act    => cubetemplate_fullcube2fullcube_prog_act
  end type fullcube2fullcube_prog_t
  !
contains
  !
  subroutine cubetemplate_fullcube2fullcube_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(fullcube2fullcube_user_t) :: user
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call fullcube2fullcube%parse(line,user,error)
    if (error) return
    call fullcube2fullcube%main(user,error)
    if (error) continue
  end subroutine cubetemplate_fullcube2fullcube_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_fullcube2fullcube_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_comm_t), intent(inout) :: comm
    logical,                         intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
!         'FULLCUBE2FULLCUBE','[cubeid]',& ! *** JP: SIC limitation?
         'FULCUBE2FULCUBE','[cubeid]',&
         'Template command for per-fullcube input and output access',&
         'Input cubes must be real and output cubes will be real.',&
         cubetemplate_fullcube2fullcube_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'INPUT',&
         'Signal cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_fullset,&
         comm%incube,&
         error)
    if (error) return
    call comm%factor%register(error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'OUTPUT',&
         'Output cube',&
         strg_emp,&
         [flag_template],&
         comm%oucube,&
         error)
    if (error)  return
  end subroutine cubetemplate_fullcube2fullcube_comm_register
  !
  subroutine cubetemplate_fullcube2fullcube_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! fulcube2fulcube cubeid
    !----------------------------------------------------------------------
    class(fullcube2fullcube_comm_t), intent(in)    :: comm
    character(len=*),                intent(in)    :: line
    type(fullcube2fullcube_user_t),  intent(out)   :: user
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
    call comm%factor%parse(line,user%factor,error)
    if (error) return
  end subroutine cubetemplate_fullcube2fullcube_comm_parse
  !
  subroutine cubetemplate_fullcube2fullcube_comm_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_comm_t), intent(in)    :: comm
    type(fullcube2fullcube_user_t),  intent(inout) :: user
    logical,                         intent(inout) :: error
    !
    type(fullcube2fullcube_prog_t) :: prog
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>COMM>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_fullcube2fullcube_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_fullcube2fullcube_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_user_t), intent(in)    :: user
    type(fullcube2fullcube_comm_t),  intent(in)    :: comm
    type(fullcube2fullcube_prog_t),  intent(out)   :: prog
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call user%factor%toprog(prog%factor,error)
    if (error) return
    call user%region%toprog(prog%incube,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%factor%list(error)
    if (error) return
    call prog%region%list(error)
    if (error) return
  end subroutine cubetemplate_fullcube2fullcube_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_fullcube2fullcube_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_prog_t), intent(inout) :: prog
    type(fullcube2fullcube_comm_t),  intent(in)    :: comm
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%oucube,prog%incube,prog%oucube,error)
    if (error) return
    call prog%factor%header(prog%oucube,error)
    if (error) return
    call prog%region%header(prog%oucube,error)
    if (error) return
  end subroutine cubetemplate_fullcube2fullcube_prog_header
  !
  subroutine cubetemplate_fullcube2fullcube_prog_data(prog,error)
    use cubeadm_opened
    use cubeadm_taskloop
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! Structure is simplified compared to other cases because only one task
    ! can work on a full cube at a time by construction!
    !----------------------------------------------------------------------
    class(fullcube2fullcube_prog_t), intent(inout) :: prog
    logical,                         intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    type(fullcube_t) :: infull,oufull
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>PROG>DATA'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! 1. Open in and out cubes
    ! 2. Prepare parallel tasking (here only one task i.e. no parallelization)
    ! 2. Define iterator of entries (here only one fullcube)
    ! 3. Command feedback
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !
    ! Note on full cubes association/allocation: in the current command
    ! we know there is only 1 iteration of the tasks (cubeadm_dataiterate_all)
    ! and 1 iteration of the entries (iterate_entry), so this can be done
    ! at any level without troubles. For symmetry with the others entry types,
    ! we should do it in cubetemplate_fullcube2fullcube_prog_loop. However,
    ! when using mixed accesses like in SLICE command (iterate the input cube
    ! as images, into a full cube as output), there are several iterations, so
    ! we DO want to factorize the association/allocation of the full cubes out
    ! of the loops, just here:
    ! Prepare the input cube for getting data
    call infull%associate('infull',prog%incube,error)
    if (error) return
    ! Prepare the output cube for putting data
    call oufull%allocate('oufull',prog%oucube,error)
    if (error) return
    !
    ! Loop on task => Only one task, (i.e. one iteration) => no parallelization statements
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       if (.not.error) &
         call prog%loop(iter,infull,oufull,error)
    enddo ! itask
  end subroutine cubetemplate_fullcube2fullcube_prog_data
  !
  subroutine cubetemplate_fullcube2fullcube_prog_loop(prog,iter,infull,oufull,error)
    use cubeadm_taskloop
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),        intent(inout) :: iter
    type(fullcube_t),                intent(inout) :: infull
    type(fullcube_t),                intent(inout) :: oufull
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>PROG>LOOP'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    do while (iter%iterate_entry(error))  ! Only 1 iteration in this case
      ! Get the input full cube
      call infull%get(error)
      if (error) return
      ! Do the computation
      call prog%act(infull,oufull,error)
      if (error) return
      ! Put the output full cube
      call oufull%put(error)
      if (error) return
    enddo  ! ientry
  end subroutine cubetemplate_fullcube2fullcube_prog_loop
  !
  subroutine cubetemplate_fullcube2fullcube_prog_act(prog,infull,oufull,error)
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_prog_t), intent(inout) :: prog
    type(fullcube_t),                intent(inout) :: infull
    type(fullcube_t),                intent(inout) :: oufull
    logical,                         intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>PROG>ACT'
    !
    do iz=1,infull%nz
       do iy=1,infull%ny
          do ix=1,infull%nx
             oufull%val(ix,iy,iz) = prog%factor%val*infull%val(ix,iy,iz)
          enddo ! ix
       enddo ! iy
    enddo ! iz
  end subroutine cubetemplate_fullcube2fullcube_prog_act
end module cubetemplate_fullcube2fullcube
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_language
  use cubetools_parameters
  use cubetools_structure
  use cubeset_messaging
  use cubeset_axset
  use cubeset_blanking
  use cubeset_buffering
  use cubeset_colors
  use cubeset_index
  use cubeset_output
  use cubeset_panel
  use cubeset_scaling
  use cubeset_spatial
  use cubeset_spectral
  use cubeset_timing
  use cubeset_units
  !
  public :: cubeset_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubeset_register_language(error)
    !----------------------------------------------------------------------
    ! Register the SET\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'SET',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Commands that set global behaviors of the program',&
         'SET configures session-wide defaults used by other CUBE commands.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- INDEX selects the default cube index used for command lookup.'//strg_cr//&
         '- SPATIAL, SPECTRAL, and SCALING define default coordinate and view settings.'//strg_cr//&
         '- PANEL and COLORS tune interactive display layout and palette.'//strg_cr//&
         '- UNITS defines default user units for command inputs and outputs.'//strg_cr//&
         '- OUTPUT, BUFFERING, BLANKING, and TIMING control runtime behavior.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> SET\INDEX DAG'//strg_cr//&
         'CUBE> SET\SPATIAL /SIZE 120 120'//strg_cr//&
         'CUBE> SET\SPECTRAL /RANGE * *'//strg_cr//&
         'CUBE> GO\VIEW'//strg_bl//&
         'Note:'//strg_cr//&
         'SET values remain active for the current session until changed.',&
         'gag_doc:hlp/cube-help-set.hlp',&
         cubeset_execute_command,&
         langid,&
         error)
    if (error) return
    !
    call axset%register(error)
    if (error) return
    call blanking%register(error)
    if (error) return
    !
    ! These two commands are registered with name+comm because of
    ! buffers used by these commands that would raise name conflicts
    call bufferingcomm%register(error)
    if (error) return
    call colorcomm%register(error)
    if (error) return
    call index%register(error)
    if (error) return
    call output%register(error)
    if (error) return
    call panel%register(error)
    if (error) return
    call scaling%register(error)
    if (error) return
    call spatial%register(error)
    if (error) return
    call spectral%register(error)
    if (error) return
    call timing%register(error)
    if (error) return
    call units%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubeset_register_language
  !
  subroutine cubeset_execute_command(line,comm,error)
    !----------------------------------------------------------------------
    ! Execute a command of the SET\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'SET?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubetools_execute_command(line,langid,comm,error)
       if (error) return
       ! There should be no call to cubeadm_finish_all here
    endif
  end subroutine cubeset_execute_command
end module cubeset_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine keepfi(set,obs,error)
  use gildas_def
  use gbl_message
  use classfit_dependencies_interfaces
  use classfit_interfaces, except_this=>keepfi
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! CLASS support routine for command KEEP
  ! Save profile fit results in the output file.
  ! (Modifies an observation in R onto the output file)
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(observation),   intent(inout) :: obs    !
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='KEEP'
  character(len=message_length) :: mess
  !
  if (.not.filein_is_fileout()) then
     call class_message(seve%e,rname,'Input file must equal output file')
     error = .true.
     return
  endif
  !
  call mobs(obs,error)   ! Open an obs. of output file to modify it
  if(error) return
  !
  call wgaus(set,obs,error)  ! Save Gaussian fit parameters
  if (error) return
  !
  call class_write_close(set,obs,error)
  if (error) return
  !
  write(mess,'(A,I0,A,I0,A)')  &
    'Observation #',obs%head%gen%num,';',obs%head%gen%ver,' successfully updated'
  call class_message(seve%i,rname,mess)
  !
end subroutine keepfi

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_calibration(mrtset,filebuf,backcal,error)
  use mrtcal_buffer_types
  use mrtcal_messaging
  use mrtcal_setup_types
  use imbfits_interfaces_public
  use mrtcal_interfaces, except_this => mrtcal_calib_calibration
  !---------------------------------------------------------------------
  ! @ private
  !
  !  1. Check the polarimetry status of the calibration scan.
  !  2. Read the calambient, calcold subscan in the order they
  !     appear in the IMBFITS and compute the mean counts over the channels.
  !  3. Read the calsky when it exists (it probably needs to rewind a bit
  !     the file before reading it) or mock it.
  !  4. Fill the chopper structure, compute the Tamt, Trec, Tsys, and Tcal,
  !     and fill the chunkset structure with these results.
  !  5. Calibrate the grid subscan when it is available.
  !  6. List results on screen and write results in the output CLASS file.
  !
  !  When the calsky is the only missing subscan, we can still compute an
  !  approximated receiver temperature (i.e., assuming 100% coupling to the
  !  hot and cold loads). To do this, we create a blanked calsky so that we
  !  can use exactly the same steps/pieces of code. It's only in the
  !  chopper code that we'll catch the fact we can only compute the Trec.  
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),   intent(in)    :: mrtset
  type(imbfits_buffer_t), intent(inout) :: filebuf
  type(calib_backend_t),  intent(inout) :: backcal
  logical,                intent(inout) :: error
  !
  logical :: calgridpresent
  logical :: poldatapresent
  character(len=*), parameter :: rname='CALIB>CALIBRATION'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Check polarimetry status of the calibration scan. Check whether
  ! 1. the scan contains a calgrid subscan,
  ! 2. the data contains polarimetry chunks. 
  calgridpresent = imbfits_subscan_exists(filebuf%imbf,'calgrid')
  poldatapresent = filebuf%imbf%back%polchunks
  if (calgridpresent.and..not.poldatapresent) then
     ! This one is just a warning
     call mrtcal_message(seve%w,rname,'The CALGRID subscan does not contain polarimetry data!')
  endif
  if (.not.calgridpresent.and.poldatapresent) then
     ! This one implies that the observer will not be able to use
     ! the next science scan to do polarimetry => Clear feedback
     ! is needed now => That's an error.
     call mrtcal_message(seve%e,rname,'No CALGRID subscan!')
     error = .true.
     return
  endif
  backcal%polar = calgridpresent.and.poldatapresent
  !
  ! Average the ambient, cold load.
  call mrtcal_calibrate_average_load(mrtset,'calambient',filebuf%imbf,filebuf%subscanbuf,backcal%hot,error)
  if (failed_calibrate(rname,'calambient',error)) return
  call mrtcal_calibrate_average_load(mrtset,'calcold',filebuf%imbf,filebuf%subscanbuf,backcal%cold,error)
  if (failed_calibrate(rname,'calcold',error)) return
  ! The sky subscan may not be present
  if (imbfits_subscan_exists(filebuf%imbf,'calsky')) then
     ! Present => average it.
     call mrtcal_calibrate_average_load(mrtset,'calsky',filebuf%imbf,filebuf%subscanbuf,backcal%sky,error)
     if (failed_calibrate(rname,'calsky',error)) return
  else
     ! Absent => Create it.
     ! At this point, calambient and calcold were successfully read.
     ! Let's use one of them to create a blanked calsky.
     call mrtcal_chunkset_2d_blank(backcal%hot,backcal%sky,error)
     if (error) return
     ! Force the source name 
     call mrtcal_chunkset_2d_modify_source('calnosky',backcal%sky,error)
     if (error)  return
  endif
  !
  ! First, calibrate the receiver and system temperature
  call mrtcal_calibrate_chunkset2chopperset(backcal,mrtset,error)
  if (error) return
  call mrtcal_calibrate_compute_chopperset(backcal,error)
  if (error) return
  call mrtcal_calibrate_chopperset2chunkset(backcal,mrtset,error)
  if (error) return
  ! Second, calibrate the grid subscan
  if (backcal%polar) then
     call mrtcal_calibrate_grid(mrtset,filebuf%imbf,filebuf%subscanbuf,backcal,error)
     if (failed_calibrate(rname,'calgrid',error)) return
  endif
  !
  !***JP: Are the following tables different in the case of polarimetry data?
  !
  ! Feedback:
  ! - Terminal and ASCII table
  call mrtcal_calibrate_user_feedback(backcal,mrtset%out,error)
  if (error) return
  ! - VO XML
  if (mrtset%out%voxml) then
    call calibration_to_VO(filebuf%imbf,backcal,error)
    if (error)  return
  endif
  ! - Class file
  call mrtcal_calibrate_toclass(mrtset,backcal,error)
  if (error) return
end subroutine mrtcal_calib_calibration
!
subroutine mrtcal_calibrate_toclass(mrtset,backcal,error)
  use chopper_definitions
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_calibrate_toclass
  use mrtcal_calib_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),  intent(in)    :: mrtset
  type(calib_backend_t), intent(inout) :: backcal
  logical,               intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIBRATE>TOCLASS'
  type(chunkset_3d_t) :: allinone
  type(mrtcal_setup_output_t) :: out
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  backcal%nspec = 0
  !
  select case (mrtset%out%calib)
  case (outputcalib_none)
    ! Nothing to write. Just invoke once mrtcal_write_toclass with toclass=.false.
    ! so that backcal%nspec is correctly set.
    out = mrtset%out
    out%toclass = .false.
    call mrtcal_write_toclass(backcal%sky,out,backcal%nspec,error)
    if (error) return
    !
  case (outputcalib_spec)
    call mrtcal_write_toclass(backcal%sky,mrtset%out,backcal%nspec,error)
    if (error) return
    call mrtcal_write_toclass(backcal%hot,mrtset%out,backcal%nspec,error)
    if (error) return
    call mrtcal_write_toclass(backcal%cold,mrtset%out,backcal%nspec,error)
    if (error) return
    call mrtcal_write_toclass(backcal%trec,mrtset%out,backcal%nspec,error)
    if (error) return
    call mrtcal_write_toclass(backcal%tcal,mrtset%out,backcal%nspec,error)
    if (error) return
    call mrtcal_write_toclass(backcal%tsys,mrtset%out,backcal%nspec,error)
    if (error) return
    call mrtcal_write_toclass(backcal%water,mrtset%out,backcal%nspec,error)
    if (error) return
    call mrtcal_write_toclass(backcal%ztau,mrtset%out,backcal%nspec,error)
    if (error) return
    call mrtcal_write_toclass(backcal%flag,mrtset%out,backcal%nspec,error)
    if (error) return
    !
  case (outputcalib_asso)
    ! Set 'allinone' as kind calibration, i.e. 3rd dimension is special,
    ! with associated arrays.
    allinone%kind = ckind_calib
    !
    call allinone%reallocate(backcal%sky%nset,backcal%sky%npix,9,error)
    if (error)  return
    !
    call allinone%reassociate(1,backcal%sky,error)
    if (error)  goto 10
    call allinone%reassociate(2,backcal%hot,error)
    if (error)  goto 10
    call allinone%reassociate(3,backcal%cold,error)
    if (error)  goto 10
    call allinone%reassociate(4,backcal%trec,error)
    if (error)  goto 10
    call allinone%reassociate(5,backcal%tcal,error)
    if (error)  goto 10
    call allinone%reassociate(6,backcal%tsys,error)
    if (error)  goto 10
    call allinone%reassociate(7,backcal%water,error)
    if (error)  goto 10
    call allinone%reassociate(8,backcal%ztau,error)
    if (error)  goto 10
    call allinone%reassociate(9,backcal%flag,error)
    if (error)  goto 10
    !
    call mrtcal_write_toclass(allinone,mrtset%out,backcal%nspec,error)
    if (error)  goto 10
    !
    if (backcal%polar) then
      ! Also write the cross-polarimetric products as a spectrum
      ! + associated arrays
      call mrtcal_calibrate_toclass_assoc_polar(backcal,allinone,error)
      if (error)  goto 10
    endif
    !
10 continue
    call allinone%free(error)
    if (error)  return
    !
  case default
    call mrtcal_message(seve%e,rname,'MSET OUTPUT CALIBRATION mode not implemented')
    error = .true.
    return
  end select
  !
contains
  !
  subroutine mrtcal_calibrate_toclass_assoc_polar(backcal,allinone,error)
    !-------------------------------------------------------------------
    ! Ad-hoc subroutine which builds a chunkset 3D to be written in
    ! Class as 1 spectrum with 5 Associated Arrays. In the context of
    ! polarimetry data, we have 3 chunkset 2D which contains
    ! alternatively:
    !   #1  HH VV REAL IMAG HH VV REAL IMAG
    !   #2  AMP  PHA  AMP  PHA
    !   #3  COS  SIN  COS  SIN
    ! We want to write 2 spectra with
    !   #1  HH VV REAL IMAG AMP PHA COS SIN
    !   #2  HH VV REAL IMAG AMP PHA COS SIN
    ! This means that the various chunkset have to be reordered in the
    ! dummy chunkset 3D before using the generic tools for transfering
    ! data to class.
    !-------------------------------------------------------------------
    type(calib_backend_t), intent(in)    :: backcal
    type(chunkset_3d_t),   intent(inout) :: allinone
    logical,               intent(inout) :: error
    ! Local
    type(stokesset_book_t) :: book
    integer(kind=4) :: istokesset,nstokesset
    integer(kind=4) :: ipix,dummy
    !
    call imbfits_count_polar_stokesset(backcal%chunksetlist,nstokesset,error)
    if (error)  return
    call allinone%reallocate(nstokesset,backcal%grid%npix,8,error)
    if (error)  return
    !
    istokesset = 0
    do ipix=1,backcal%grid%npix
       call imbfits_init_stokesloop(book,error)
       if (error) return
       do
          call imbfits_get_next_stokesset(backcal%chunksetlist,book,error)
          if (error) return
          if (.not.book%found) exit
          if (book%nstokes.ne.4) cycle
          istokesset = istokesset+1
          call allinone%chunkset(istokesset,ipix,1)%reassociate(&
               backcal%grid%chunkset(book%iset(code_h),ipix),error)
          if (error) return
          call allinone%chunkset(istokesset,ipix,2)%reassociate(&
               backcal%grid%chunkset(book%iset(code_v),ipix),error)
          if (error) return
          call allinone%chunkset(istokesset,ipix,3)%reassociate(&
               backcal%grid%chunkset(book%iset(code_r),ipix),error)
          if (error) return
          call allinone%chunkset(istokesset,ipix,4)%reassociate(&
               backcal%grid%chunkset(book%iset(code_i),ipix),error)
          if (error) return
          call allinone%chunkset(istokesset,ipix,5)%reassociate(&
               backcal%amppha%chunkset(book%iset(code_r),ipix),error)
          if (error) return
          call allinone%chunkset(istokesset,ipix,6)%reassociate(&
               backcal%amppha%chunkset(book%iset(code_i),ipix),error)
          if (error) return
          call allinone%chunkset(istokesset,ipix,7)%reassociate(&
               backcal%sincos%chunkset(book%iset(code_r),ipix),error)
          if (error)  return
          call allinone%chunkset(istokesset,ipix,8)%reassociate(&
               backcal%sincos%chunkset(book%iset(code_i),ipix),error)
          if (error)  return
       enddo ! istokesset
    enddo ! ipix
    !
    dummy = 0
    call mrtcal_write_toclass(allinone,mrtset%out,dummy,error)
    if (error) return
    !
  end subroutine mrtcal_calibrate_toclass_assoc_polar
end subroutine mrtcal_calibrate_toclass
!
subroutine mrtcal_calibrate_user_feedback(backcal,setout,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_calibrate_user_feedback
  use mrtcal_buffers
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_user_feedback_tool
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(calib_backend_t), target, intent(in)    :: backcal
  type(mrtcal_setup_output_t),   intent(in)    :: setout
  logical,                       intent(inout) :: error
  !
  integer(kind=4), parameter :: iperpixel = 1
  integer(kind=4), parameter :: iperset   = 2
  integer(kind=4), parameter :: iperchunk = 3
  integer(kind=4) :: ipix,iset,ncal
  type(user_feedback_t) :: user
  character(len=*), parameter :: rname='CALIBRATE>USER>FEEDBACK'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_calibrate_user_feedback_head(error)
  if (error) return
  !
  ncal = 0
  if (rsetup%cal%feedback.eq.iperpixel) then
    ! Less verbose (1 per pixel)
    ncal = backcal%sky%npix
  elseif (rsetup%cal%feedback.eq.iperset) then
    ! More verbose (1 per chunkset)
    ncal = backcal%sky%npix*backcal%sky%nset
  elseif (rsetup%cal%feedback.eq.iperchunk) then
    ! Most verbose (1 per chunk)
    do ipix=1,backcal%sky%npix
      do iset=1,backcal%sky%nset
        ncal = ncal+backcal%chopper%set(iset,ipix)%n
      enddo ! iset
    enddo ! ipix
  endif
  !
  call user%allocate_and_init(ncal,error)
  if (error) return
  !
  if (rsetup%cal%feedback.eq.iperpixel) then
    call calibrate_user_feedback_perpixel(mrtcal_gr8_median)
  elseif (rsetup%cal%feedback.eq.iperset) then
    call calibrate_user_feedback_perset(mrtcal_gr8_median)
  elseif (rsetup%cal%feedback.eq.iperchunk) then
    call calibrate_user_feedback_perchunk
  endif
  !
  call user%sort_by_freq_idfe(error)
  if (error) return
  call user%list(error)
  if (error) return
  if (setout%restable) then
     ! Also display in a file
     call user%tofile(backcal%head,error)
     if (error) return
  endif
  !
contains
  !
  subroutine mrtcal_calibrate_user_feedback_head(error)
    use mrtcal_messaging
    logical, intent(inout) :: error
    ! Local
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='CALIBRATE>USER>FEEDBACK>HEAD'
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    call mrtcal_separator(seve%r,rname,1,error)
    if (error) return
    write(mess,'(t1,a4,t7,a4,t13,a8,t22,a9,t32,a4,t38,a3,t43,a7,t51,a7,t59,a7,t67,a9,t77,a3)') &
         'idFe','freq','THotLoad','TColdLoad','idBe','Pix','recTemp','sysTemp','calTemp','tauZenith','pwv'
    call mrtcal_message(seve%r,rname,mess)
    write(mess,'(t7,a5,t13,a18,t43,a23,t68,a7,t77,a4)') &
         '[GHz]','---- [Kelvin] ----','------ [Kelvin] -------','[Neper]','[mm]'
    call mrtcal_message(seve%r,rname,mess)
    write(mess,'(t1,a80)') &
         '--------------------------------------------------------------------------------'
    call mrtcal_message(seve%r,rname,mess)
    !
  end subroutine mrtcal_calibrate_user_feedback_head
  !
  subroutine calibrate_user_feedback_perpixel(gr8_compute)
    external :: gr8_compute  ! Computation routine, same calling sequence
                             ! as gr8_median
    integer(kind=4) :: ical
    real(kind=8) :: mfreq,mthot,mtcold,mtrec,mtsys,mtcal,mtau,mh2o
    character(len=8) :: mfrontend
    character(len=message_length) :: result
    !
    ical = 0
    do ipix=1,backcal%sky%npix
      call calibrate_user_feedback_compute_perpixel(gr8_compute,  &
           backcal,ipix,                                          &
           mfrontend,mfreq,mthot,mtcold,mtrec,mtsys,mtcal,mtau,mh2o,error)
      if (error)  return
      !
      ical = ical+1
      call calibrate_user_feedback_oneline(  &
        mfrontend,                 &
        mfreq,                     &
        mthot,                     &
        mtcold,                    &
        backcal%head%key%backend,  &
        ipix,                      &
        mtrec,                     &
        mtsys,                     &
        mtcal,                     &
        mtau,                      &
        mh2o,                      &
        result)
      call user%fill(ical,mfrontend,mfreq,result,code_color_default)
    enddo ! ipix
  end subroutine calibrate_user_feedback_perpixel
  !
  subroutine calibrate_user_feedback_compute_perpixel(gr8_compute,backcal,ipix,  &
    frontend,freq,thot,tcold,trec,tsys,tcal,tau,h2omm,error)
    !-------------------------------------------------------------------
    ! Make the computations for the input chunkset
    !-------------------------------------------------------------------
    external                             :: gr8_compute
    type(calib_backend_t), intent(in)    :: backcal
    integer(kind=4),       intent(in)    :: ipix
    character(len=8),      intent(out)   :: frontend
    real(kind=8),          intent(out)   :: freq
    real(kind=8),          intent(out)   :: thot
    real(kind=8),          intent(out)   :: tcold
    real(kind=8),          intent(out)   :: trec
    real(kind=8),          intent(out)   :: tsys
    real(kind=8),          intent(out)   :: tcal
    real(kind=8),          intent(out)   :: tau
    real(kind=8),          intent(out)   :: h2omm
    logical,               intent(inout) :: error
    ! Local
    integer(kind=4) :: iset,ic,nc
    character(len=8) :: myfrontend
    integer(kind=size_length) :: nelem
    real(kind=8), allocatable :: r8data(:)
    !
    ! Compute an 'average' frontend name
    frontend = backcal%sky%chunkset(1,ipix)%chunks(1)%frontend
    do iset=2,backcal%sky%nset
      myfrontend = backcal%sky%chunkset(iset,ipix)%chunks(1)%frontend
      do ic=1,8
        if (frontend(ic:ic).ne.myfrontend(ic:ic))  frontend(ic:ic) = '-'
      enddo
    enddo
    !
    ! Need to fill a temporary data array for gr8_compute. First get its size
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      nelem = nelem+nc
    enddo
    !
    allocate(r8data(nelem))
    !
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      r8data(nelem+1:nelem+nc) = backcal%chopper%set(iset,ipix)%freqs(1:nc)%s
      nelem = nelem+nc
    enddo
    call gr8_compute(r8data,nelem,backcal%chopper%set(1,1)%bad,0.d0,freq,error)
    if (error)  return
    !
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      r8data(nelem+1:nelem+nc) = backcal%chopper%set(iset,ipix)%loads(1:nc)%hot%temp
      nelem = nelem+nc
    enddo
    call gr8_compute(r8data,nelem,backcal%chopper%set(1,1)%bad,0.d0,thot,error)
    if (error)  return
    !
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      r8data(nelem+1:nelem+nc) = backcal%chopper%set(iset,ipix)%loads(1:nc)%cold%temp
      nelem = nelem+nc
    enddo
    call gr8_compute(r8data,nelem,backcal%chopper%set(1,1)%bad,0.d0,tcold,error)
    if (error)  return
    !
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      r8data(nelem+1:nelem+nc) = backcal%chopper%set(iset,ipix)%recs(1:nc)%temp
      nelem = nelem+nc
    enddo
    call gr8_compute(r8data,nelem,backcal%chopper%set(1,1)%bad,0.d0,trec,error)
    if (error)  return
    !
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      r8data(nelem+1:nelem+nc) = backcal%chopper%set(iset,ipix)%tsyss(1:nc)%s
      nelem = nelem+nc
    enddo
    call gr8_compute(r8data,nelem,backcal%chopper%set(1,1)%bad,0.d0,tsys,error)
    if (error)  return
    !
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      r8data(nelem+1:nelem+nc) = backcal%chopper%set(iset,ipix)%tcals(1:nc)%s
      nelem = nelem+nc
    enddo
    call gr8_compute(r8data,nelem,backcal%chopper%set(1,1)%bad,0.d0,tcal,error)
    if (error)  return
    !
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      r8data(nelem+1:nelem+nc) = backcal%chopper%set(iset,ipix)%atms(1:nc)%taus%tot
      nelem = nelem+nc
    enddo
    call gr8_compute(r8data,nelem,backcal%chopper%set(1,1)%bad,0.d0,tau,error)
    if (error)  return
    !
    nelem = 0
    do iset=1,backcal%sky%nset
      nc = backcal%chopper%set(iset,ipix)%n
      r8data(nelem+1:nelem+nc) = backcal%chopper%set(iset,ipix)%atms(1:nc)%h2omm
      nelem = nelem+nc
    enddo
    call gr8_compute(r8data,nelem,backcal%chopper%set(1,1)%bad,0.d0,h2omm,error)
    if (error)  return
    !
    deallocate(r8data)
  end subroutine calibrate_user_feedback_compute_perpixel
  !
  subroutine calibrate_user_feedback_perset(gr8_compute)
    external :: gr8_compute  ! Computation routine, same calling sequence
                             ! as gr8_median
    integer(kind=4) :: ical,jpix
    real(kind=8) :: mfreq,mthot,mtcold,mtrec,mtsys,mtcal,mtau,mh2o
    character(len=8) :: mfrontend
    character(len=message_length) :: result
    !
    ical = 0
    do ipix=1,backcal%sky%npix
      do iset=1,backcal%sky%nset
          call calibrate_user_feedback_compute_perset(gr8_compute,  &
               backcal%chopper%set(iset,ipix),                       &
               mfreq,mthot,mtcold,mtrec,mtsys,mtcal,mtau,mh2o,error)
          if (error)  return
          !
          if (ipix.eq.1) then
            ! Either single-pixel data, or multi-pixel data read with
            ! flat pixel*chunkset dimension. See MRTCAL prog documentation
            ! for details.
            jpix = backcal%chunksetlist%eclass%val2(iset)
          else
            ! Multi-pixel data with pixel dimension properly separated from
            ! the chunkset dimension.
            jpix = ipix
          endif
          !
          ical = ical+1
          ! Assume consistent telescope name per chunksets, use first one
          mfrontend = backcal%sky%chunkset(iset,ipix)%chunks(1)%frontend
          call calibrate_user_feedback_oneline(  &
            mfrontend,                 &
            mfreq,                     &
            mthot,                     &
            mtcold,                    &
            backcal%head%key%backend,  &
            jpix,                      &
            mtrec,                     &
            mtsys,                     &
            mtcal,                     &
            mtau,                      &
            mh2o,                      &
            result)
          call user%fill(ical,mfrontend,mfreq,result,code_color_default)
      enddo ! iset
    enddo ! ipix
  end subroutine calibrate_user_feedback_perset
  !
  subroutine calibrate_user_feedback_compute_perset(gr8_compute,chopperset,freq,  &
    thot,tcold,trec,tsys,tcal,tau,h2omm,error)
    !-------------------------------------------------------------------
    ! Make the computations for the input chunkset
    !-------------------------------------------------------------------
    external                       :: gr8_compute
    type(chopper_t), intent(in)    :: chopperset
    real(kind=8),    intent(out)   :: freq
    real(kind=8),    intent(out)   :: thot
    real(kind=8),    intent(out)   :: tcold
    real(kind=8),    intent(out)   :: trec
    real(kind=8),    intent(out)   :: tsys
    real(kind=8),    intent(out)   :: tcal
    real(kind=8),    intent(out)   :: tau
    real(kind=8),    intent(out)   :: h2omm
    logical,         intent(inout) :: error
    ! Local
    integer(kind=size_length) :: nc
    real(kind=8), allocatable :: r8buf(:)
    !
    nc = chopperset%n
    allocate(r8buf(nc))
    !
    r8buf(:) = chopperset%freqs(1:nc)%s
    call gr8_compute(r8buf,nc,chopperset%bad,0.d0,freq,error)
    if (error)  return
    !
    r8buf(:) = chopperset%loads(1:nc)%hot%temp
    call gr8_compute(r8buf,nc,chopperset%bad,0.d0,thot,error)
    if (error)  return
    !
    r8buf(:) = chopperset%loads(1:nc)%cold%temp
    call gr8_compute(r8buf,nc,chopperset%bad,0.d0,tcold,error)
    if (error)  return
    !
    r8buf(:) = chopperset%recs(1:nc)%temp
    call gr8_compute(r8buf,nc,chopperset%bad,0.d0,trec,error)
    if (error)  return
    !
    r8buf(:) = chopperset%tsyss(1:nc)%s
    call gr8_compute(r8buf,nc,chopperset%bad,0.d0,tsys,error)
    if (error)  return
    !
    r8buf(:) = chopperset%tcals(1:nc)%s
    call gr8_compute(r8buf,nc,chopperset%bad,0.d0,tcal,error)
    if (error)  return
    !
    r8buf(:) = chopperset%atms(1:nc)%taus%tot
    call gr8_compute(r8buf,nc,chopperset%bad,0.d0,tau,error)
    if (error)  return
    !
    r8buf(:) = chopperset%atms(1:nc)%h2omm
    call gr8_compute(r8buf,nc,chopperset%bad,0.d0,h2omm,error)
    if (error)  return
  end subroutine calibrate_user_feedback_compute_perset
  !
  subroutine calibrate_user_feedback_perchunk
    ! Local
    type(chopper_t), pointer :: chopperset
    integer(kind=4) :: ical,ichunk
    real(kind=8) :: mfreq
    character(len=8) :: mfrontend
    character(len=message_length) :: result
    !
    ical = 0
    do ipix=1,backcal%sky%npix
      do iset=1,backcal%sky%nset
          chopperset => backcal%chopper%set(iset,ipix)
          !
          do ichunk=1,chopperset%n
            ical = ical+1
            mfrontend = backcal%sky%chunkset(iset,ipix)%chunks(ichunk)%frontend
            mfreq = chopperset%freqs(ichunk)%s
            call calibrate_user_feedback_oneline(  &
              mfrontend,                           &
              mfreq,                               &
              chopperset%loads(ichunk)%hot%temp,   &
              chopperset%loads(ichunk)%cold%temp,  &
              backcal%head%key%backend,            &
              ipix,                                &
              chopperset%recs(ichunk)%temp,        &
              chopperset%tsyss(ichunk)%s,          &
              chopperset%tcals(ichunk)%s,          &
              chopperset%atms(ichunk)%taus%tot,    &
              chopperset%atms(ichunk)%h2omm,       &
              result)
            call user%fill(ical,mfrontend,mfreq,result,code_color_default)
         enddo ! ichunk
      enddo ! iset
    enddo ! ipix
  end subroutine calibrate_user_feedback_perchunk
  !
  subroutine calibrate_user_feedback_oneline(frontend,freq,thot,tcold,  &
    backend,ipix,trec,tsys,tcal,tau,h2omm,oneline)
    character(len=*),  intent(in)  :: frontend
    real(kind=8),      intent(in)  :: freq
    real(kind=8),      intent(in)  :: thot
    real(kind=8),      intent(in)  :: tcold
    integer(kind=4),   intent(in)  :: backend
    integer(kind=4),   intent(in)  :: ipix
    real(kind=8),      intent(in)  :: trec
    real(kind=8),      intent(in)  :: tsys
    real(kind=8),      intent(in)  :: tcal
    real(kind=8),      intent(in)  :: tau
    real(kind=8),      intent(in)  :: h2omm
    character(len=*),  intent(out) :: oneline
    !
    real(kind=8) :: bad
    !
    bad = backcal%chopper%set(1,1)%bad
    write(oneline,100)  frontend,&
                        user_feedback_format_onedouble(5,'f5.1',freq,bad),&
                        user_feedback_format_onedouble(8,'f8.3',thot,bad),&
                        user_feedback_format_onedouble(9,'f9.3',tcold,bad),&
                        mrtindex_backend(backend),&
                        ipix,&
                        user_feedback_format_onedouble(7,'f7.2',trec,bad),&
                        user_feedback_format_onedouble(7,'f7.2',tsys,bad),&
                        user_feedback_format_onedouble(7,'f7.2',tcal,bad),&
                        user_feedback_format_onedouble(5,'f5.2',tau,bad),&
                        user_feedback_format_onedouble(4,'f4.1',h2omm,bad)
    !
100 format(t1,a5,t7,a5,t13,a8,t20,a9,t32,a5,t37,i3,t43,a7,t51,a7,t59,a7,t69,a5,t77,a4)
  end subroutine calibrate_user_feedback_oneline
end subroutine mrtcal_calibrate_user_feedback
!
subroutine mrtcal_calibrate_compute_chopperset(backcal,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_calibrate_compute_chopperset
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(calib_backend_t), intent(inout) :: backcal
  logical,               intent(inout) :: error
  ! Local
  type(stokesset_book_t) :: book
  integer(kind=size_length) :: ipix,istokes
  character(len=*), parameter :: rname='CALIBRATE>COMPUTE>CHOPPERSET'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do ipix=1,backcal%sky%npix
     call imbfits_init_stokesloop(book,error)
     if (error) return
     do while (.true.)
        call imbfits_get_next_stokesset(backcal%chunksetlist,book,error)
        if (error) return
        if (.not.book%found) exit
        do istokes=1,book%nstokes
           if (istokes.le.2) then
              call telcal_chopper(backcal%chopper%set(book%iset(istokes),ipix),error)
              if (error)  return
           endif
        enddo ! istokes
     enddo ! istokesset
  enddo ! ipix
end subroutine mrtcal_calibrate_compute_chopperset
!
subroutine mrtcal_calibrate_chunkset2chopperset(backcal,mrtset,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_calibrate_chunkset2chopperset
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_chopperset_tools
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(calib_backend_t), intent(inout), target :: backcal
  type(mrtcal_setup_t),  intent(in)            :: mrtset
  logical,               intent(inout)         :: error
  ! Local
  integer(kind=size_length) :: ipix,iset
  character(len=*), parameter :: rname='CALIBRATE>CHUNKSET2CHOPPERSET'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Check consistency of sky, hot, and cold
  call backcal%sky%consistency(rname,backcal%hot,error)
  if (error)  return
  call backcal%sky%consistency(rname,backcal%cold,error)
  if (error)  return
  !
  call backcal%chopper%reallocate(backcal%sky,error)
  if (error) return
  ! Save size of chopperset (re)allocation:
  backcal%nset = backcal%sky%nset
  backcal%npix = backcal%sky%npix
  !
  do ipix=1,backcal%npix
    do iset=1,backcal%nset
      call mrtcal_calibrate_chunkset2chopper(  &
           mrtset,                             &
           backcal%sky%chunkset(iset,ipix),    &
           backcal%hot%chunkset(iset,ipix),    &
           backcal%cold%chunkset(iset,ipix),   &
           backcal%chopper%set(iset,ipix),     &
           backcal%chopper%book(iset,ipix),    &
           error)
      if (error)  return
    enddo
  enddo
end subroutine mrtcal_calibrate_chunkset2chopperset
!
subroutine mrtcal_calibrate_chopperset2chunkset(backcal,mrtset,error)
  use mrtcal_messaging
  use chopper_definitions
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_calibrate_chopperset2chunkset
  use mrtcal_chopperset_tools
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(calib_backend_t), target, intent(inout) :: backcal
  type(mrtcal_setup_t),          intent(in)    :: mrtset
  logical,                       intent(inout) :: error
  ! Local
  type(stokesset_book_t) :: book
  type(chopper_t), pointer :: hh,vv,hv,vh
  integer(kind=size_length) :: ipix,iset
  character(len=*), parameter :: rname='CALIBRATE>CHOPPERSET2CHUNKSET'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Cross-correlation calibration products are deduced from previously
  ! compute auto-correlation calibration products
  do ipix=1,backcal%sky%npix
     call imbfits_init_stokesloop(book,error)
     if (error) return
     do while (.true.)
        call imbfits_get_next_stokesset(backcal%chunksetlist,book,error)
        if (error) return
        if (.not.book%found) exit
        if (book%nstokes.ne.4) cycle
        hh => backcal%chopper%set(book%iset(code_h),ipix) ! input
        vv => backcal%chopper%set(book%iset(code_v),ipix) ! input
        hv => backcal%chopper%set(book%iset(code_r),ipix) ! output
        vh => backcal%chopper%set(book%iset(code_i),ipix) ! output
        call mrtcal_calibrate_chopperset_cross(hh,vv,hv,vh,error)
        if (error) return
     enddo ! istokesset
  enddo ! ipix
  !
  call backcal%trec%clone(backcal%sky,.false.,error)
  if (error) return
  call backcal%tcal%clone(backcal%sky,.false.,error)
  if (error) return
  call backcal%atsys%clone(backcal%sky,.false.,error)
  if (error) return
  call backcal%tsys%clone(backcal%sky,.false.,error)
  if (error) return
  call backcal%water%clone(backcal%sky,.false.,error)
  if (error) return
  call backcal%ztau%clone(backcal%sky,.false.,error)
  if (error) return
  call backcal%flag%clone(backcal%sky,.false.,error)
  if (error) return
  do ipix=1,backcal%sky%npix
     do iset=1,backcal%sky%nset
        ! Fill chunk headers from the chopperset structure
        call mrtcal_calibrate_chopperset2loadheader(&
             backcal%chopper%set(iset,ipix),&
             backcal%chopper%book(iset,ipix),&
             backcal%sky%chunkset(iset,ipix),&
             error)
        call mrtcal_calibrate_chopperset2loadheader(&
             backcal%chopper%set(iset,ipix),&
             backcal%chopper%book(iset,ipix),&
             backcal%hot%chunkset(iset,ipix),&
             error)
        call mrtcal_calibrate_chopperset2loadheader(&
             backcal%chopper%set(iset,ipix),&
             backcal%chopper%book(iset,ipix),&
             backcal%cold%chunkset(iset,ipix),&
             error)
        ! Interpolate calibration results in frequency
        call mrtcal_calibrate_chopperset2calarray(&
             mrtset,&
             backcal%chopper%set(iset,ipix),&
             backcal%chopper%book(iset,ipix),&
             backcal%sky%chunkset(iset,ipix),&  ! Used as reference (not modified)
             backcal%trec%chunkset(iset,ipix),&
             backcal%tcal%chunkset(iset,ipix),&
             backcal%atsys%chunkset(iset,ipix),&
             backcal%tsys%chunkset(iset,ipix),&
             backcal%water%chunkset(iset,ipix),&
             backcal%ztau%chunkset(iset,ipix),&
             backcal%flag%chunkset(iset,ipix),&
             error)
         ! Ad-hoc patch: backcal%atsys must provide the attenuated Tsys,
         ! not Tsys itself which was inherited when duplicating the
         ! backcal%sky headers in mrtcal_calibrate_chopperset2calarray
         call mrtcal_calibrate_patch_atsysheader(&
             backcal%chopper%set(iset,ipix),&
             backcal%chopper%book(iset,ipix),&
             backcal%atsys%chunkset(iset,ipix),&
             error)
     enddo ! iset
  enddo ! ipix
end subroutine mrtcal_calibrate_chopperset2chunkset
!
subroutine mrtcal_calibrate_average_load(mrtset,name,imbf,subscanbuf,load,error)
  use mrtcal_messaging
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calibrate_average_load
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),   intent(in)    :: mrtset
  character(len=*),       intent(in)    :: name
  type(imbfits_t),        intent(in)    :: imbf
  type(subscan_buffer_t), intent(inout) :: subscanbuf
  type(chunkset_2d_t),    intent(inout) :: load
  logical,                intent(inout) :: error
  ! Local
  logical, parameter :: iscal = .true.
  integer(kind=4), parameter :: first = 1
  character(len=*), parameter :: rname='CALIBRATE>AVERAGE>LOAD'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_average_times(mrtset,iscal,first,name,imbf,subscanbuf,load,error)
  if (error) return
  call mrtcal_chunkset_2d_modify_source(name,load,error)
  if (error) return
  call mrtcal_average_channels(load,error)
  if (error) return
end subroutine mrtcal_calibrate_average_load
!
subroutine mrtcal_calibrate_grid(mrtset,imbf,subscanbuf,backcal,error)
  use mrtcal_messaging
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calibrate_grid
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),   intent(in)    :: mrtset
  type(imbfits_t),        intent(in)    :: imbf
  type(subscan_buffer_t), intent(inout) :: subscanbuf
  type(calib_backend_t),  intent(inout) :: backcal
  logical,                intent(inout) :: error
  ! Local
  logical, parameter :: iscal = .true.
  integer(kind=4), parameter :: first = 1
  character(len=*), parameter :: rname='CALIBRATE>GRID'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_average_times(mrtset,iscal,first,'calgrid',imbf,subscanbuf,backcal%grid,error)
  if (error) return
  call mrtcal_chunkset_2d_calgrid(backcal%chunksetlist,backcal%grid,backcal%amppha,backcal%sincos,error)
  if (error) return
  call mrtcal_chunkset_2d_cross(backcal%chunksetlist,mrtcal_chunk_cross,backcal%atsys,error)
  if (error) return
  call mrtcal_chunkset_2d_cross(backcal%chunksetlist,mrtcal_chunk_cross,backcal%tsys,error)
  if (error) return
  call mrtcal_chunkset_2d_cross(backcal%chunksetlist,mrtcal_chunk_cross,backcal%tcal,error)
  if (error) return
  call mrtcal_chunkset_2d_cross(backcal%chunksetlist,mrtcal_chunk_cross,backcal%trec,error)
  if (error) return
  call mrtcal_chunkset_2d_cross(backcal%chunksetlist,mrtcal_chunk_mean,backcal%water,error)
  if (error) return
  call mrtcal_chunkset_2d_cross(backcal%chunksetlist,mrtcal_chunk_mean,backcal%ztau,error)
  if (error) return
  call mrtcal_chunkset_2d_cross(backcal%chunksetlist,mrtcal_chunk_flag,backcal%flag,error)
  if (error) return
end subroutine mrtcal_calibrate_grid
!
subroutine mrtcal_chunkset_2d_calgrid(chunksetlist,grid_2d,amppha_2d,sincos_2d,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_calgrid
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_back_chunks_t), intent(in)    :: chunksetlist
  type(chunkset_2d_t), target, intent(in)    :: grid_2d
  type(chunkset_2d_t), target, intent(inout) :: amppha_2d
  type(chunkset_2d_t), target, intent(inout) :: sincos_2d
  logical,                     intent(inout) :: error
  ! Local
  type(stokesset_book_t) :: book
  type(chunkset_t), pointer :: hh,vv,real,imag,amp,pha,cos,sin
  integer(kind=size_length) :: ipix,ichunk
  character(len=*), parameter :: rname='CHUNKSET2D>CALGRID'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call amppha_2d%clone(grid_2d,.true.,error)
  if (error) return
  call sincos_2d%clone(grid_2d,.true.,error)
  if (error) return
  !
  do ipix=1,grid_2d%npix
     call imbfits_init_stokesloop(book,error)
     if (error) return
     do while (.true.)
        call imbfits_get_next_stokesset(chunksetlist,book,error)
        if (error) return
        if (.not.book%found) exit
        if (book%nstokes.ne.4) cycle
        hh   =>   grid_2d%chunkset(book%iset(code_h),ipix)
        vv   =>   grid_2d%chunkset(book%iset(code_v),ipix)
        real =>   grid_2d%chunkset(book%iset(code_r),ipix)
        imag =>   grid_2d%chunkset(book%iset(code_i),ipix)
        amp  => amppha_2d%chunkset(book%iset(code_r),ipix)
        pha  => amppha_2d%chunkset(book%iset(code_i),ipix)
        cos  => sincos_2d%chunkset(book%iset(code_r),ipix)
        sin  => sincos_2d%chunkset(book%iset(code_i),ipix)
        do ichunk=1,real%n
           call mrtcal_chunk_calgrid(&
                hh%chunks(ichunk),&
                vv%chunks(ichunk),&
                real%chunks(ichunk),&
                imag%chunks(ichunk),&
                amp%chunks(ichunk),&
                pha%chunks(ichunk),&
                cos%chunks(ichunk),&
                sin%chunks(ichunk),&
                error)
           if (error) return
        enddo ! ichunk
     enddo ! istokesset
  enddo ! ipix
end subroutine mrtcal_chunkset_2d_calgrid
!
subroutine mrtcal_chunkset_2d_cross(chunksetlist,operation,chunkset_2d,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_cross
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_back_chunks_t), intent(in)    :: chunksetlist
  type(chunkset_2d_t), target, intent(inout) :: chunkset_2d
  logical,                     intent(inout) :: error
  external :: operation
  ! Local
  type(stokesset_book_t) :: book
  type(chunkset_t), pointer :: hh,vv,hv,vh
  integer(kind=size_length) :: ipix,ichunk
  character(len=*), parameter :: rname='CHUNKSET2D>CROSS'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do ipix=1,chunkset_2d%npix
     call imbfits_init_stokesloop(book,error)
     if (error) return
     do while (.true.)
        call imbfits_get_next_stokesset(chunksetlist,book,error)
        if (error) return
        if (.not.book%found) exit
        if (book%nstokes.eq.1) cycle
        hh => chunkset_2d%chunkset(book%iset(code_h),ipix)
        vv => chunkset_2d%chunkset(book%iset(code_v),ipix)
        hv => chunkset_2d%chunkset(book%iset(code_r),ipix)
        vh => chunkset_2d%chunkset(book%iset(code_i),ipix) 
        do ichunk=1,hh%n
           call operation(&
                hh%chunks(ichunk),&
                vv%chunks(ichunk),&
                hv%chunks(ichunk),&
                vh%chunks(ichunk),&
                error)
           if (error) return
        enddo ! ichunk
     enddo ! istokesset
  enddo ! ipix
end subroutine mrtcal_chunkset_2d_cross
!
subroutine mrtcal_chunkset_2d_modify_source(source,chunkset_2d,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => mrtcal_chunkset_2d_modify_source
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: source
  type(chunkset_2d_t), intent(inout) :: chunkset_2d
  logical,             intent(inout) :: error
  ! Local
  character(len=12) :: mysource
  type(chunkset_t), pointer :: chunkset
  integer(kind=size_length) :: ipix,iset,ichunk
  character(len=*), parameter :: rname='CHUNKSET2D>MODIFY>SOURCE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  mysource = source  ! 12 characters
  call sic_upper(mysource)
  !
  do ipix=1,chunkset_2d%npix
     do iset=1,chunkset_2d%nset
        chunkset => chunkset_2d%chunkset(iset,ipix)
        do ichunk=1,chunkset%n
           chunkset%chunks(ichunk)%pos%sourc = mysource
        enddo ! ichunk
     enddo ! iset
  enddo ! ipix
end subroutine mrtcal_chunkset_2d_modify_source
!
subroutine mrtcal_gr8_median(data,ndata,bval,eval,median,error)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! *** JP Trick because gr8_median does not return the blanking
  ! *** JP value when there is no valid data
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ndata        ! Array size
  real(kind=8),              intent(in)    :: data(ndata)  ! Data
  real(kind=8),              intent(in)    :: bval         ! Blanking value
  real(kind=8),              intent(in)    :: eval         ! Tolerance
  real(kind=8),              intent(inout) :: median       ! Median of input array
  logical,                   intent(inout) :: error        ! Logical error flag
  !
  median = bval
  call gr8_median(data,ndata,bval,eval,median,error)
  if (error) return
end subroutine mrtcal_gr8_median
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

* DECK ddisna.f
      SUBROUTINE DDISNA( JOB, M, N, D, SEP, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOB
      INTEGER            INFO, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), SEP( * )
*     ..
*
*  Purpose
*  =======
*
*  DDISNA computes the reciprocal condition numbers for the eigenvectors
*  of a real symmetric or complex Hermitian matrix or for the left or
*  right singular vectors of a general m-by-n matrix. The reciprocal
*  condition number is the 'gap' between the corresponding eigenvalue or
*  singular value and the nearest other one.
*
*  The bound on the error, measured by angle in radians, in the I-th
*  computed vector is given by
*
*         DLAMCH( 'E' ) * ( ANORM / SEP( I ) )
*
*  where ANORM = 2-norm(A) = max( abs( D(j) ) ).  SEP(I) is not allowed
*  to be smaller than DLAMCH( 'E' )*ANORM in order to limit the size of
*  the error bound.
*
*  DDISNA may also be used to compute error bounds for eigenvectors of
*  the generalized symmetric definite eigenproblem.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies for which problem the reciprocal condition numbers
*          should be computed:
*          = 'E':  the eigenvectors of a symmetric/Hermitian matrix;
*          = 'L':  the left singular vectors of a general matrix;
*          = 'R':  the right singular vectors of a general matrix.
*
*  M       (input) INTEGER
*          The number of rows of the matrix. M >= 0.
*
*  N       (input) INTEGER
*          If JOB = 'L' or 'R', the number of columns of the matrix,
*          in which case N >= 0. Ignored if JOB = 'E'.
*
*  D       (input) DOUBLE PRECISION array, dimension (M) if JOB = 'E'
*                              dimension (min(M,N)) if JOB = 'L' or 'R'
*          The eigenvalues (if JOB = 'E') or singular values (if JOB =
*          'L' or 'R') of the matrix, in either increasing or decreasing
*          order. If singular values, they must be non-negative.
*
*  SEP     (output) DOUBLE PRECISION array, dimension (M) if JOB = 'E'
*                               dimension (min(M,N)) if JOB = 'L' or 'R'
*          The reciprocal condition numbers of the vectors.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            DECR, EIGEN, INCR, LEFT, RIGHT, SING
      INTEGER            I, K
      DOUBLE PRECISION   ANORM, EPS, NEWGAP, OLDGAP, SAFMIN, THRESH
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      EIGEN = LSAME( JOB, 'E' )
      LEFT = LSAME( JOB, 'L' )
      RIGHT = LSAME( JOB, 'R' )
      SING = LEFT .OR. RIGHT
      IF( EIGEN ) THEN
         K = M
      ELSE IF( SING ) THEN
         K = MIN( M, N )
      END IF
      IF( .NOT.EIGEN .AND. .NOT.SING ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( K.LT.0 ) THEN
         INFO = -3
      ELSE
         INCR = .TRUE.
         DECR = .TRUE.
         DO 10 I = 1, K - 1
            IF( INCR )
     $         INCR = INCR .AND. D( I ).LE.D( I+1 )
            IF( DECR )
     $         DECR = DECR .AND. D( I ).GE.D( I+1 )
   10    CONTINUE
         IF( SING .AND. K.GT.0 ) THEN
            IF( INCR )
     $         INCR = INCR .AND. ZERO.LE.D( 1 )
            IF( DECR )
     $         DECR = DECR .AND. D( K ).GE.ZERO
         END IF
         IF( .NOT.( INCR .OR. DECR ) )
     $      INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DDISNA', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( K.EQ.0 )
     $   RETURN
*
*     Compute reciprocal condition numbers
*
      IF( K.EQ.1 ) THEN
         SEP( 1 ) = DLAMCH( 'O' )
      ELSE
         OLDGAP = ABS( D( 2 )-D( 1 ) )
         SEP( 1 ) = OLDGAP
         DO 20 I = 2, K - 1
            NEWGAP = ABS( D( I+1 )-D( I ) )
            SEP( I ) = MIN( OLDGAP, NEWGAP )
            OLDGAP = NEWGAP
   20    CONTINUE
         SEP( K ) = OLDGAP
      END IF
      IF( SING ) THEN
         IF( ( LEFT .AND. M.GT.N ) .OR. ( RIGHT .AND. M.LT.N ) ) THEN
            IF( INCR )
     $         SEP( 1 ) = MIN( SEP( 1 ), D( 1 ) )
            IF( DECR )
     $         SEP( K ) = MIN( SEP( K ), D( K ) )
         END IF
      END IF
*
*     Ensure that reciprocal condition numbers are not less than
*     threshold, in order to limit the size of the error bound
*
      EPS = DLAMCH( 'E' )
      SAFMIN = DLAMCH( 'S' )
      ANORM = MAX( ABS( D( 1 ) ), ABS( D( K ) ) )
      IF( ANORM.EQ.ZERO ) THEN
         THRESH = EPS
      ELSE
         THRESH = MAX( EPS*ANORM, SAFMIN )
      END IF
      DO 30 I = 1, K
         SEP( I ) = MAX( SEP( I ), THRESH )
   30 CONTINUE
*
      RETURN
*
*     End of DDISNA
*
      END

subroutine gtwindow(output,ax,bx,ay,by)
  use gtv_interfaces, except_this=>gtwindow
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Defines the clipping area and redraw the plot.
  !---------------------------------------------------------------------
  type(gt_display)   :: output      ! Output instance
  real*4, intent(in) :: ax,bx       ! Clipping area coordinates
  real*4, intent(in) :: ay,by       !
  ! Local
  logical :: error
  error = .false.
  call sub_gtwindow(output,ax,bx,ay,by,.true.,error)
end subroutine gtwindow
!
subroutine sp_gtwindow(output,ax,bx,ay,by)
  use gtv_interfaces, except_this=>sp_gtwindow
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Defines the clipping area but does not redraw the plot.
  !---------------------------------------------------------------------
  type(gt_display)   :: output      ! Output instance
  real*4, intent(in) :: ax,bx       ! Clipping area coordinates
  real*4, intent(in) :: ay,by       !
  ! Local
  logical :: error
  error = .false.
  call sub_gtwindow(output,ax,bx,ay,by,.false.,error)
end subroutine sp_gtwindow
!
subroutine sub_gtwindow(output,ax,bx,ay,by,redraw,error)
  use gtv_interfaces, except_this=>sub_gtwindow
  use gtv_types
  use gtv_graphic
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Defines the clipping area and optionally redraw the plot. Works on
  ! the current working directory.
  !---------------------------------------------------------------------
  type(gt_display)       :: output  ! Output instance
  real*4,  intent(in)    :: ax,bx   ! Clipping area coordinates
  real*4,  intent(in)    :: ay,by   !
  logical, intent(in)    :: redraw  !
  logical, intent(inout) :: error   ! Logical error flag
  !
  if (.not.awake .or. error_condition) return
  !
  output%gx1 = min(ax,bx)
  output%gx2 = max(ax,bx)
  output%gy1 = min(ay,by)
  output%gy2 = max(ay,by)
  !
  ! Clip with the physical paper size
  ! This clipping is disabled because it is not desirable. Especially when
  ! zooming completely out of the paper area, we do not want to raise an
  ! error.
  ! output%gx1 = max(output%gx1,0.)
  ! output%gx2 = min(output%gx2,cw_directory%phys_size(1))
  ! output%gy1 = max(output%gy1,0.)
  ! output%gy2 = min(output%gy2,cw_directory%phys_size(2))
  !
  if (output%gx1.ge.output%gx2 .or. output%gy1.ge.output%gy2) then
    call gtv_message(seve%e,'GTWINDOW','Invalid clipping window')
    call gtx_err
    return
  endif
  !
  ! Make it visible.
  if (redraw) then
    if (output%dev%protocol.eq.p_x)  call gti_xforceupdate(output)
    call gtview_sub(output,'R',error)  ! Rewind
  endif
  !
end subroutine sub_gtwindow
!
subroutine on_resize(graph_env,error)
  use gildas_def
  use gtv_interfaces, except_this=>on_resize
  use gtv_types
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! Document me!
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)    :: graph_env
  logical,                      intent(inout) :: error
  ! Local
  logical :: found
  type(gt_display), pointer :: output
  !
  ! Get the output instance associated to the input graph_env
  call get_slot_output_by_genv(graph_env,output,.true.,found,error)
  if (error)  return
  !
  if (graph_env.gt.0)  &
    call get_win_pixel_info(graph_env,output%px1,output%py1,output%px2,output%py2)
  !
  ! Clear needed for gtk but this code doesn't do anything
  ! if (graph_env.ne.0) call x_clear(graph_env)
  !
end subroutine on_resize

subroutine write_fits_datapar (unit, nsubant, subant,   &
    ldata, data , holodata, switch, simpolar, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  use gbl_constant
  !---------------------------------------------------------------------
  ! Write the DATAPAR fits table.
  ! assumes NO_POL=1, NO_FEED=1
  ! switch forces the writing of 2 switch phases for each record
  !     ISWITCH is ON and OFF
  !     WSWITCH is +1., -1.
  !---------------------------------------------------------------------
  integer :: unit                   !
  integer :: nsubant                !
  integer :: subant(nsubant)        ! selected antennas in table
  integer :: ldata                  !
  integer :: data(1)                !
  logical :: holodata               !
  logical :: switch                 !
  logical :: simpolar               !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'clic_proc_par.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: k, mf, status, nrows, tfields, varidat, ir, h_offset
  integer :: i, j, naxis, naxes(4), r_npol, r_nfeed, r_nside, mdigit2, mdigit1
  integer :: ncorr, nauto, nholo, isub, felem, jr, nswitch, isw
  logical :: datanum(5), corr, holo, auto
  real :: rrlamof, rrbetof, t(2), dlam, dtot, ntot, beamsize, dtt
  real :: dist2
  parameter(r_npol = 1, r_nside=2, mdigit2=13,   &
    mdigit1=8)
  real*8 :: uvw(3), sind, cosd, sinh, cosh
  parameter (mf = 23)
  character(len=16) :: ttype(mf),tform(mf),tunit(mf), extname
  character(len=8) :: vcode(0:4), scode(0:3)
  ! switch simulation
  real :: wsw(2)
  data wsw/+1.,-1./
  real :: l0, b0, f0              ! pointing and focus errors
  data l0/-4.5/, b0/8.5/, f0/0.45/
  data beamsize /40./          ! 40 arc sec.
  data dtot, ntot / 12., 0.25/
  !
  data ttype/   &
    'INTEGNUM', 'INTEGTIM',  'MJD',      &  ! 1  2  3
    'UUVVWW',   'AZELERR',   'SOURDIR',  &  ! 4 5  6
    'DELAYGEO', 'DELAYOFF',              &  ! 7 8
    'PHASEGEO', 'PHASEOFF',              &  ! 9 10
    'RATEGEO',  'RATEOFF',               &  ! 11 12
    'FOCUSOFF', 'LONGOFF',   'LATOFF',   &  ! 13 14 15
    'TOTPOWER',  'WINDSPEE', 'WINDDIRE', 'FLAG',  &  ! 16 17 18 19
    'RDPOWER',  'CORR',                  &  ! 20 21
    'ISWITCH', 'WSWITCH'/                   ! 22 23
  data tform/   &
    '1J',       '1E',      '1D',   &
    '*D',       '*D',      '*D',   &
    '*D',       '*D',   &
    '*D',       '*D',   &
    '*D',       '*D',   &
    '*E',       '*E',      '*E',   &
    '*E',       '1E',      '1E',       '*J',   &
    '*E',       '2L',   &
    '1J',       '1E'/
  data tunit/   &
    ' ',        's',       'day',   &
    's',        'deg',     ' ',   &
    's',        's',   &
    'rad',      'rad',   &
    'rad/s',    'rad/s',   &
    'm',        'deg',     'deg',   &
    'adu',        'm/s',      'deg',      ' ',   &
    'adu',      ' ',   &
    ' ',        ' '/
  !
  data vcode/'VELO-UNK','VELO-LSR','VELO-HEL','VELO-OBS','VELO-EAR'/
  data scode/ '?...','OBJ','PHAS','?...'/
  !      DATA SYSTEXT /'Un','Un','Eq','Ga','Ho','Pl','Ea'/
  !      DATA VELTEXT /'Unkn.','LSR  ','Hel. ','Obs. ','Null '/
  !      DATA CHARTYPE /'*','O','P','R'/
  !---------------------------------------------------------------------
  if (simpolar) then
    r_nfeed = 2
  else
    r_nfeed = 1
  endif
  !
  !  Append/create a new empty HDU onto the end of the file and move to it.
  status = 0
  call ftcrhd(unit,status)
  !
  !  Define parameters for the binary table (see the above data statements)
  nswitch = 1
  tfields = mf-2
  if (holodata) then
    nrows = r_ndump
  ! nutator switch simulation (switch = .true.)
  elseif (switch) then
    nswitch = 2
    nrows = nswitch*r_ndump+1
    tfields = mf
  else
    nrows = r_ndump+1
  endif
  extname = 'DATAPAR-ALMATI'
  varidat = 0
  !
  ! number of data tables of various kinds.
  nholo = 0
  nauto = 0
  ncorr = 0
  if(r_project.eq.'HOLO' .and. r_lmode.eq.1) then
    holo = .true.
    auto = .false.
    corr = .false.
    nholo = 1
    ttype(21) = 'HOLO'
    call f_tform(tform(21),1,'L')  ! HOLO
  elseif (r_lmode.eq.1) then
    holo = .false.
    auto = .false.
    corr = .true.
    ncorr = 3
    ttype(21) = 'CORR'
    call f_tform(tform(21),3,'L')  ! CORR
  elseif (r_lmode.eq.2) then
    holo = .false.
    auto = .true.
    corr = .false.
    nauto = 3
    ttype(21) = 'AUTO'
    call f_tform(tform(21),3,'L')  ! AUTO
  endif
  ! columns in datapar
  ! changed to use nsubant instead or r_nant
  call f_tform(tform(4),3*nsubant,'D') ! UUVVWW
  call f_tform(tform(5),2*nsubant,'E') ! AZELERR
  call f_tform(tform(6),3*nsubant,'D') ! SOURDIR
  call f_tform(tform(7),nsubant,'D')   ! DELAYGEO
  call f_tform(tform(8),r_lband*nsubant,'D')   ! DELAYOFF
  call f_tform(tform(9),nsubant,'D')   ! PHASEGEO
  call f_tform(tform(10),r_lband*nsubant,'D')  ! PHASEOFF
  call f_tform(tform(11),nsubant,'D')  ! RATEGEO
  call f_tform(tform(12),r_lband*nsubant,'D')  ! RATEOFF
  call f_tform(tform(13),nsubant,'E')  ! FOCUSOFF
  call f_tform(tform(14),nsubant,'E')  ! LATOFF
  call f_tform(tform(15),nsubant,'E')  ! LONGOFF
  ! rl 2004-08-24 Revert to original (wrong) configuration used for aips++test
  call f_tform(tform(16),r_lband*nsubant,'E')  ! TOTPOWER * rl 2004-08-24
  ! rl 2004-08-24       CALL F_TFORM(TFORM(16),R_nfeed*NSUBANT,'E')    ! TOTPOWER
  call f_tform(tform(19),1*r_lband*nsubant,'J')    ! FLAG
  call f_tform(tform(20),nsubant,'E')  ! RDPOWER
  call ftphbn(unit,nrows,tfields,ttype,tform,tunit,   &
    extname,varidat,status)
  naxis = 2
  naxes(1) = 3
  naxes(2) = nsubant
  call ftptdm(unit, 4, naxis, naxes, status)
  call ftptdm(unit, 6, naxis, naxes, status)
  naxis = 2
  naxes(1) = 2
  naxes(2) = nsubant
  call ftptdm(unit, 5, naxis, naxes, status)
  naxis = 2
  naxes(1) = r_lband
  naxes(2) = nsubant
  call ftptdm(unit, 8, naxis, naxes, status)
  call ftptdm(unit, 10, naxis, naxes, status)
  call ftptdm(unit, 12, naxis, naxes, status)
  ! rl 2004-08-24 revert ot original config (aips++ test)
  call ftptdm(unit, 16, naxis, naxes, status)  ! TOTPOWER
  ! rl 2004-08-24       naxis = 2
  ! rl 2004-08-24       naxes(1) = r_nfeed
  ! rl 2004-08-24       naxes(2) = nsubant
  ! rl 2004-08-24       call ftptdm(unit, 16, naxis, naxes, status) ! TOTPOWER
  naxis = 3
  naxes(1) = 1
  naxes(2) = r_lband
  naxes(3) = nsubant
  call ftptdm(unit, 19, naxis, naxes, status)
  ! Other header keywords
  call ftpkys(unit,'TABLEREV','v1.0 2001-07-03',   &
    extname//' release',status)
  call ftpkys(unit,'TELESCOP',r_teles,   &
    'Telescope name',status)
  call write_fits_dobs(unit,error)
  if (error) return
  !      CALL FTPKYJ(UNIT,'SCAN-NUM',R_SCAN,'Scan number',STATUS)
  !      CALL FTPKYJ(UNIT,'OBS-NUM',R_NUM,'Observation number',STATUS)
  !?
  !      CALL JJDATE (R_DOBS+2460549.5D0+R_UT/PI/2,DATE)
  !      CALL FTTM2S(DATE(1),DATE(2),DATE(3),DATE(4),DATE(5),
  !     $DATE(6)+DATE(7)*0.001D0,
  !     $3,CHAIN,STATUS)
  !      CALL FTPKYS(UNIT,'DATE-OBS',CHAIN,'Date',STATUS)
  !      call ftpkyd(unit,'DATE-OBS',r_dobs+2460549.5d0,mdigit2,'Date',
  !     &     status)
  !      call ftpkyd(unit,'UT',r_ut*43200/pi,mdigit2,
  !     &     'Universal time (start)', status)
  call ftpkys(unit,'TIMESYS','UTC','Time system',status)
  call ftpkyd(unit,'LST',r_st*43200/pi,mdigit2,   &
    'Apparent sidereal time (start)',  status)
  !
  ! r_cproc will be  put into FITS OBSMODE keyword:
  ! CALIBRATION
  if (r_cproc.eq.'CALI') then
    if (r_scaty.eq.5) then
      r_cproc = 'CSKY'
    elseif (r_scaty.eq.7) then
      r_cproc = 'COLD'
    elseif (r_scaty.eq.4) then
      r_cproc = 'CALI'
    endif
  ! SKYDIP
  elseif (r_cproc.eq.'SKYD') then
    if (r_scaty.eq.5) then
      r_cproc = 'SKYD'
    elseif (r_scaty.eq.4) then
      r_cproc = 'SKYC'
    endif
  ! FOCUS
  elseif (r_cproc.eq.'FOCU') then
    if (r_scaty.eq.1) then
      r_cproc = 'FOCU'
    elseif (r_scaty.eq.11) then
      r_cproc = 'FOCX'
    elseif (r_scaty.eq.12) then
      r_cproc = 'FOCY'
    endif
  ! (POINTING)
  endif
  !
  call ftpkys(unit,'OBSMODE',r_cproc,'Scan type',status)
  call ftpkys(unit,'PROJID',r_project,'Project ID',status)
  call ftpkyd(unit,'AZIMUTH',r_az*180d0/pi,mdigit2,   &
    'Azimuth (degrees)',status)
  call ftpkyd(unit,'ELEVATIO',r_el*180d0/pi,mdigit2,   &
    'Elevation (degrees)',status)
  !
  ! Offset system
  if (r_typof.eq.type_eq) then
    call ftpkys(unit,'LATSYS','RA---SIN',   &
      'type of latitude-like offsets',status)
    call ftpkys(unit,'LONGSYS','DEC--SIN',   &
      'type of longitude-like offsets',status)
  elseif (r_typof.eq.type_ho) then
    call ftpkys(unit,'LATSYS','AZIM-SIN',   &
      'type of latitude-like offsets',status)
    call ftpkys(unit,'LONGSYS','ELEV-SIN',   &
      'type of longitude-like offsets',status)
  elseif (r_typof.eq.type_ga) then
    call ftpkys(unit,'LATSYS','GLON-SIN',   &
      'type of latitude-like offsets',status)
    call ftpkys(unit,'LONGSYS','GLAT-SIN',   &
      'type of longitude-like offsets',status)
  else
    call ftpkys(unit,'LATSYS','ELON-SIN',   &
      'type of latitude-like offsets',status)
    call ftpkys(unit,'LONGSYS','ELAT-SIN',   &
      'type of longitude-like offsets',status)
  endif
  call ftpkye(unit,'EXPOSURE',r_ndump*1.,mdigit1,   &
    'Total integration time (s)',status)
  call ftpkyj(unit,'NO_ANT',nsubant,'Number of antennas',status)
  call ftpkyj(unit,'NO_BAND',r_lband,'Number of basebands',status)
  call ftpkyj(unit,'NO_CHAN',r_lntch,'Total number of channels',   &
    status)
  call ftpkyj(unit,'NO_POL',r_npol,'Number of pols.',status)
  call ftpkyj(unit,'NO_FEED',r_nfeed,'Number of feeds.',status)
  call ftpkyj(unit,'NO_SIDE',r_nside,'Number of side bands',status)
  call ftpkyd(unit,'VFRAME',r_doppl*299792458d0,mdigit2,   &
    'radial vel. corr. (m/s)',status)
  call ftpkyj(unit,'NO_PHCOR',r_ndatl,'Number of phase corr. data',   &
    status)
  call ftpkyj(unit,'NO_CORR',ncorr ,   &
    'Number of CORRDATA Tables per baseband',status)
  call ftpkyj(unit,'NO_AUTO',nauto,   &
    'Number of AUTODATA Tables per baseband',status)
  call ftpkyj(unit,'NO_HOLO',nholo,   &
    'Number of HOLODATA Tables per baseband',status)
  if (switch) then
    call ftpkyj(unit,'NO_SWITC',nswitch,   &
      'Number of switch states in a switch cycle',status)
  endif
  call ftpkyj(unit,'FRONTEND',r_nrec,   &
    'number ID of front end used',status)
  !
  ! 05:54:28.500  44:38:02.000    Alt. :      2.560
  call ftpkyd(unit,'OBS-LAT',44.63389d0,mdigit2,   &
    'Observatory Latitude (degrees)',status)
  !?
  call ftpkyd(unit,'OBS-LONG',5.9079167d0,mdigit2,   &
    'Observatory Latitude (degrees)',status)
  call ftpkye(unit,'OBS-ELEV',2560.,mdigit1,   &
    'Observatory Elevation (m)',   &
    status)
  !
  ! Source information
  call ftpkys(unit,'SOURCE',r_sourc,'Source Name',status)
  call ftpkys(unit,'CALCODE',scode(r_itype),'Calibrator code',   &
    status)
  ! coordinate system
  if (r_typec.eq.type_eq) then
    if (r_epoch.eq.2000.) then
      call ftpkys(unit,'RADESYS','FK5',   &
        'Equatorial Coordinate system', status)
    elseif (r_epoch.eq.1950.) then
      call ftpkys(unit,'RADESYS','FK4',   &
        'Equatorial Coordinate system', status)
    endif
    call ftpkyd(unit,'RA',r_lam*180d0/pi,mdigit2,   &
      'Right Ascension (ICRF)',status)
    call ftpkyd(unit,'DEC',r_bet*180d0/pi,mdigit2,   &
      'Declination (ICRF)',status)
    call ftpkyd(unit,'PMRA',0d0,mdigit2,   &
      'RA Pr.Motion  (deg./Jul.y.) [dRA*cos(Dec)/dt]',status)
    call ftpkyd(unit,'PMDEC',0d0,mdigit2,   &
      'DEC Pr.Motion  (deg./Jul.y.)',status)
    call ftpkye(unit,'EQUINOX',r_epoch,mdigit1,'Equinox',   &
      status)
  elseif (r_typec.eq.type_ga) then
    call ftpkyd(unit,'GLON',r_lam*180d0/pi,mdigit2,   &
      'Galactic Longitude (deg.)',status)
    call ftpkyd(unit,'GLAT',r_bet*180d0/pi,mdigit2,   &
      'Galactic Latitude (deg.)',status)
  elseif (r_typec.eq.type_ho) then
    call ftpkyd(unit,'AZIM-FIX',r_lam*180d0/pi,mdigit2,   &
      'Fixed Azimuth (deg.)',status)
    call ftpkyd(unit,'ELEV-FIX',r_bet*180d0/pi,mdigit2,   &
      'Fixed Elevation (deg.)',status)
  else
    call ftpkyd(unit,'ELON',r_lam*180d0/pi,mdigit2,   &
      ' Longitude (deg.)',status)
    call ftpkyd(unit,'ELAT',r_bet*180d0/pi,mdigit2,   &
      'Latitude (deg.)',status)
  endif
  call ftpkys(unit,'VELTYP',vcode(r_typev),'Velocity type',status)
  !
  ! Default frequency information
  call ftpkyd(unit,'FREQLO1',r_flo1*1d6,mdigit2,   &
    'LO1 frequency (Hz)',status)
  call ftpkyj(unit,'SIDEBLO1',r_isb,'LO1 side band',status)
  call ftpkyd(unit,'FREQLO2',r_flo1_ref*1d6,mdigit2,   &
    'LO2 frequency (Hz)',status)
  call ftpkyj(unit,'SIDEBLO2',-1,'LO2 side band',status)
  call ftpkyd(unit,'INTERFRE',350d6,mdigit2,   &
    '2nd IF frequency (Hz)',status)
  call ftpkyd(unit,'FREQRES',600d6,mdigit2,   &
    'Total power bandwidth (Hz)',status)
  !
  ! Astrometry ...
  ! Note these are not real values, as we do not keep track of them in CLIC
  !
  call ftpkyd(unit,'UT1UTC',0.380901d0,mdigit2,'UT1-UTC', status)
  call ftpkyd(unit,'TAIUTC',32.d0,mdigit2,'TAI-UTC', status)
  call ftpkyd(unit,'POLARX',0.000103d0,mdigit2,   &
    'x coordinate of North Pole', status)
  call ftpkyd(unit,'POLARY',0.000107d0,mdigit2,   &
    'x coordinate of North Pole', status)
  !
  if (status .gt. 0) goto 99
  do ir=1, nrows
    if (switch) then
      jr = (ir+1)/2
      isw = ir+2-2*jr
      ! add 120" in lambda for OFF state (in degrees)
      if (isw.eq.2) then
        dlam = 240./3600.
      else
        dlam = 0.
      endif
      dtot = 10.
    else
      jr = ir
      isw = 0
      dlam = 0.
      dtot = 0.
    endif
    k = 1+ h_offset(jr)
    call decode_header (data(k))
    !
    ! Fill in the columns.
    ! INTEGNUM
    if (switch) then
      call ftpclj(unit,1,ir,1,1,ir,status)
    else
      call ftpclj(unit,1,ir,1,1,dh_dump,status)
    endif
    if (status .gt. 0) goto 99
    ! INTEGTIM
    if (switch) then
      call ftpcle(unit,2,ir,1,1,dh_integ/2.,status)
    else
      call ftpcle(unit,2,ir,1,1,dh_integ,status)
    endif
    if (status.gt.0) then
      call fio_printerror('WRITE_FITS_DATAPAR','FTPCLE',   &
        status,error)
      return
    endif
    ! MJD
    ! MJD = JD - 2400000.5
    call ftpcld(unit,3,ir,1,1,   &
      dh_obs+60549.0d0+dh_utc/86400d0,status)
    if (status .gt. 0) goto 99
    ! UUVVWW
    sind = dh_svec(3)
    cosd = sqrt(1.d0-sind**2)
    if (cosd.ne.0.d0) then
      sinh = -dh_svec(2) / cosd
      cosh = dh_svec(1) / cosd
    endif
    ! recompute by antenna (in CLIC only by baseline).
    felem = 1
    do isub = 1, nsubant
      i = subant(isub)
      uvw(1) = (r_ant(1,i)*sinh + r_ant(2,i)*cosh)
      uvw(2) = (-r_ant(1,i)*cosh + r_ant(2,i)*sinh)*sind   &
        + r_ant(3,i)*cosd
      uvw(3) = (r_ant(1,i)*cosh - r_ant(2,i)*sinh)*cosd   &
        + r_ant(3,i)*sind
      call ftpcld(unit,4,ir,felem,3,uvw,status)
      felem = felem+3
      if (status .gt. 0) then
        goto 99
      endif
    enddo
    ! AZELERR
    do isub = 1, nsubant
      i = subant(isub)
      do k=1, 2
        t(k) = dh_rmspe(k,i)/3600.
      enddo
      call ftpcle(unit,5,ir,1+2*(isub-1),2,t,status)
      if (status .gt. 0) goto 99
    enddo
    ! SOURDIR
    do isub = 1, nsubant
      i = subant(isub)
      call ftpcld(unit,6,ir,1+3*(isub-1),3,dh_svec,status)
      if (status .gt. 0) goto 99
    enddo
    ! DELAYGEO ...
    do isub = 1, nsubant
      i = subant(isub)
      call ftpcld(unit,7,ir,isub,1,dh_delayc(i)*1d-9,status)
    enddo
    if (status .gt. 0) goto 99
    ! DELAYOFF ...
    do isub = 1, nsubant
      i = subant(isub)
      do j=1, r_lband
        call ftpcld(unit,8,ir,(isub-1)*r_lband+j,1,   &
          dh_delay(1,i)*1d-9,status)
      enddo
    enddo
    if (status .gt. 0) goto 99
    ! PHASEGEO ...
    do isub = 1, nsubant
      i = subant(isub)
      call ftpcld(unit,9,ir,isub,1,2d0*pi*dh_phasec(i),status)
      if (status .gt. 0) goto 99
    enddo
    ! PHASEOFF ...
    do isub = 1, nsubant
      i = subant(isub)
      do j=1, r_lband
        call ftpcld(unit,10,ir,(isub-1)*r_lband+j,1,   &
          2d0*pi*dh_phase(i),status)
      enddo
    enddo
    if (status .gt. 0) goto 99
    ! RATEGEO ...
    do isub = 1, nsubant
      i = subant(isub)
      call ftpcld(unit,11,ir,isub,1,1d0*dh_ratec(i),status)
      if (status .gt. 0) goto 99
    enddo
    ! RATEOFF ...
    do isub = 1, nsubant
      i = subant(isub)
      do j=1, r_lband
        call ftpcld(unit,12,ir,(isub-1)*r_lband+j,1,   &
          0d0,status)
      enddo
    enddo
    if (status .gt. 0) goto 99
    ! FOCUSOFF
    do isub = 1, nsubant
      i = subant(isub)
      call ftpcle(unit,13,ir,isub,1,dh_offfoc(i),status)
      if (status .gt. 0) goto 99
    enddo
    ! LONGOFF
    if (r_proc.ne.p_point) then
      rrlamof = r_lamof/pi*180.
    else
      rrlamof = 0
    endif
    do isub = 1, nsubant
      i = subant(isub)
      call ftpcle(unit,14,ir,isub,1,   &
        rrlamof+dh_offlam(i)/3600.+dlam, status)
    enddo
    if (status .gt. 0) goto 99
    ! LATOFF
    if (r_proc.ne.p_point) then
      rrbetof = r_betof/pi*180.
    else
      rrbetof = 0
    endif
    do isub = 1, nsubant
      i = subant(isub)
      call ftpcle(unit,15,ir,isub,1,rrbetof+dh_offbet(i)/3600.,   &
        status)
    enddo
    if (status .gt. 0) goto 99
    ! TOTPOWER
    do isub = 1, nsubant
      i = subant(isub)
      !     cread only the first polar for the time being...
      dtt = dh_total(1,i)
      if (isw.ne.0) then
        dist2 =   &
          (rrlamof+dh_offlam(i)/3600.+dlam-l0/3600.)**2 +   &
          (rrbetof+dh_offbet(i)/3600.-b0/3600.)**2
        dtt = dtt   &
          + dtot*exp(-dist2/((beamsize/3600./2.))**2*alog(2.))   &
          *exp(-((dh_offfoc(i)-f0)/2.)**2) + rangau(ntot)
      endif
      ! 2004-08-24
      do j=1, r_lband
        call ftpcle(unit,16,ir,(isub-1)+j, 1,   &
          dtt, status)
      enddo
    ! 2004-08-24            CALL FTPCLE(UNIT,16,IR,(ISUB-1)*R_nfeed+1,1,
    ! 2004-08-24     &           dtt,STATUS)
    ! simulate 2nd feed ...
    ! 2004-08-24            if (r_nfeed.gt.1) then
    ! 2004-08-24               CALL FTPCLE(UNIT,16,IR,(ISUB-1)*R_nfeed+2,1,
    ! 2004-08-24     &              dtt*1.23, STATUS)
    ! 2004-08-24            endif
    enddo
    if (status .gt. 0) goto 99
    ! WINDSPEE
    call ftpcle(unit,17,ir,1,1,r_avwind,status)
    if (status .gt. 0) goto 99
    ! WINDDIRE
    call ftpcle(unit,18,ir,1,1,r_avwindir,status)
    if (status .gt. 0) goto 99
    ! FLAG
    do isub = 1, nsubant
      i = subant(isub)
      ! flag is repeated for each subband as described in the format.
      do j=1, r_lband
        call ftpclj(unit,19,ir,(isub-1)*r_lband+j,1,   &
          dh_aflag(i),status)
      enddo
      !cc   CALL FTPCLJ(UNIT,19,IR,ISUB,1,DH_AFLAG(I),STATUS)
      if (status .gt. 0) goto 99
    enddo
    ! RDPOWER
    !         DO I=1, R_NANT
    do isub = 1, nsubant
      i = subant(isub)
      call ftpcle(unit,20,ir,isub,1,dh_test1(2,i),status)
    enddo
    if (status .gt. 0) goto 99
    ! CORR / AUTO /HOLO
    ! The Bure standard: continuum for all records,
    !                    continuum and line for the average record
    ! [only one column]
    if (holo) then
      datanum(1) = holo
      call ftpcll(unit,21,ir,1,1,datanum,status)
    else
      if (ir.le.r_ndump*nswitch) then
        datanum(1) = .true.
        datanum(2) = .false.
        datanum(3) = .false.
      else
        datanum(1) = .false.
        datanum(2) = .true.
        datanum(3) = .true.
      endif
      call ftpcll(unit,21,ir,1,3,datanum,status)
    endif
    if (status .gt. 0) goto 99
    ! SWITCH columns
    if (switch) then
      call ftpclj(unit,22,ir,1,1,isw,status)
      if (status.gt.0) then
        call fio_printerror('GET_FITS_DATAPAR','FTPCLJ',   &
          status,error)
        return
      endif
      call ftpcle(unit,23,ir,1,1,wsw(isw),status)
      if (status.gt.0) then
        call fio_printerror('GET_FITS_DATAPAR','FTPCLE',   &
          status,error)
        return
      endif
    endif
  enddo
  return
  ! error return
99 error = .true.
  call printerror('WRITE_FITS_DATAPAR',status)
end subroutine write_fits_datapar

module gcore_interfaces_public_c
  !---------------------------------------------------------------------
  ! Fortran interfaces to C public subroutines (hand made)
  !---------------------------------------------------------------------
  !
  interface
    subroutine hsv_to_rgb(h,s,v,r,g,b)
      real(kind=4), intent(in)  :: h  !
      real(kind=4), intent(in)  :: s  !
      real(kind=4), intent(in)  :: v  !
      real(kind=4), intent(out) :: r  !
      real(kind=4), intent(out) :: g  !
      real(kind=4), intent(out) :: b  !
    end subroutine hsv_to_rgb
  end interface
  !
  interface
    subroutine rgb_to_hsv(r,g,b,h,s,v)
      real(kind=4), intent(in)  :: r  !
      real(kind=4), intent(in)  :: g  !
      real(kind=4), intent(in)  :: b  !
      real(kind=4), intent(out) :: h  !
      real(kind=4), intent(out) :: s  !
      real(kind=4), intent(out) :: v  !
    end subroutine rgb_to_hsv
  end interface
  !
end module gcore_interfaces_public_c

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_two2one_template
  !----------------------------------------------------------------------
  ! Commands that take two input cubes and produce one output cube
  !
  ! Syntax: "COMMAND cubeid1 cubeid2"
  !----------------------------------------------------------------------
  use cubetools_structure
  use cube_types
  use cubetools_flag_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetemplate_messaging
  !
  public :: two2one_comm_t,two2one_user_t,two2one_prog_t
  private
  !
  type :: two2one_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: incube1
     type(cubeid_arg_t), pointer :: incube2
     type(cube_prod_t),  pointer :: oucube
   contains
     procedure, public  :: parse   => cubetemplate_two2one_parse
     procedure, public  :: command => cubetemplate_two2one_command
     procedure, private :: main    => cubetemplate_two2one_main
  end type two2one_comm_t
  !
  type two2one_user_t
     type(cubeid_user_t) :: cubeids
   contains
     procedure, public :: toprog => cubetemplate_two2one_user_toprog
  end type two2one_user_t
  !
  type two2one_prog_t
     type(cube_t), pointer :: incube1
     type(cube_t), pointer :: incube2
     type(cube_t), pointer :: oucube
   contains
     procedure, public  :: header => cubetemplate_two2one_prog_header
     procedure, private :: data   => cubetemplate_two2one_prog_data
     procedure, private :: loop   => cubetemplate_two2one_prog_loop
  end type two2one_prog_t
  !
contains
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_two2one_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! COMMAND cubeid
    !----------------------------------------------------------------------
    class(two2one_comm_t), intent(in)    :: comm
    character(len=*),      intent(in)    :: line
    class(two2one_user_t), intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='TWO2ONE>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubetemplate_two2one_parse
  !
  subroutine cubetemplate_two2one_command(comm,line,user,prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(two2one_comm_t), intent(in)    :: comm
    character(len=*),      intent(in)    :: line
    class(two2one_user_t), intent(inout) :: user
    class(two2one_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='TWO2ONE>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call comm%parse(line,user,error)
    if (error) return
    call comm%main(user,prog,error)
    if (error) continue
  end subroutine cubetemplate_two2one_command
  !
  subroutine cubetemplate_two2one_main(comm,user,prog,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(two2one_comm_t), intent(in)    :: comm
    class(two2one_user_t), intent(in)    :: user
    class(two2one_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='TWO2ONE>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_two2one_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_two2one_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(two2one_user_t), intent(in)    :: user
    class(two2one_comm_t), intent(in)    :: comm
    class(two2one_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='TWO2ONE>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube1,user%cubeids,prog%incube1,error)
    if (error) return
    call cubeadm_get_header(comm%incube2,user%cubeids,prog%incube2,error)
    if (error) return
  end subroutine cubetemplate_two2one_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_two2one_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(two2one_prog_t), intent(inout) :: prog
    class(two2one_comm_t), intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='TWO2ONE>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%oucube,prog%incube1,prog%oucube,error)
    if (error) return
  end subroutine cubetemplate_two2one_prog_header
  !
  subroutine cubetemplate_two2one_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(two2one_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='TWO2ONE>PROG>DATA'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubetemplate_two2one_prog_data
  !
  subroutine cubetemplate_two2one_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(two2one_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='TWO2ONE>PROG>LOOP'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
  end subroutine cubetemplate_two2one_prog_loop
end module cubetemplate_two2one_template
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine class_draw(set,line,r,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_draw
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command
  !   DRAW [Args] [/PEN Ipen]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(inout) :: line   ! Command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Flag
  ! Local
  integer(kind=4), parameter :: optpen=1
  logical :: dopen
  integer(kind=4) :: oldpen,newpen
  !
  dopen = sic_present(optpen,0)
  if (dopen) then
    call sic_i4(line,optpen,1,newpen,.true.,error)
    if (error) return
    oldpen = gr_spen(newpen)
  endif
  !
  call class_draw_sub(set,line,r,error)
  if (error)  continue  ! Reset pen before leaving
  !
  if (dopen)  newpen = gr_spen(oldpen)
  !
end subroutine class_draw
!
subroutine class_draw_sub(set,line,r,error)
  use gildas_def
  use gbl_constant
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_draw_sub
  use class_setup_new
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   DRAW [FILL     Ichan]
  !   DRAW [KILL     Ichan]
  !   DRAW [LOWER    Xpos String [Angle]]
  !   DRAW [UPPER    Xpos String [Angle]]
  !   DRAW [MASK     [Ylev]]
  !   DRAW [TEXT     Xpos Ypos Text [Centering]]
  !   DRAW [WINDOW   [Yup] [Ylow]]
  !   DRAW MOLECULE  Xpos "Texte" [Angle]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(inout) :: line   ! Command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Flag
  ! Local
  character(len=*), parameter :: rname='DRAW'
  logical :: interactive,kill
  integer, parameter :: narg=9
  character(len=8) :: chain,argum,action(narg)
  character(len=1) :: ch,backslash
  character(len=160) :: text
  character(len=255) :: mess
  integer(kind=4) :: ic,nc,ltext,n,ichan,nl,lire,ier,iarg
  real(kind=4) :: xxp,yyp,xc,xv,xf,xi,xl,ya,n2
  real(kind=8) :: xf0,xi0,ux1,ux2
  data action/'FILL','KILL','LOWER','MASK','MOLECULE','TEXT','UPPER',  &
              'WINDOW','EXIT'/
  !
  call get_box(gx1,gx2,gy1,gy2)
  text = ' '
  backslash=char(92)
  kill = .false.
  lire = sic_lire()
  !
  if (sic_present(0,1)) then
     ! Parse DRAW kind from command line, the associated parameters
     ! will be read after
     call sic_ke (line,0,1,chain,nc,.true.,error)
     if (error) return
     call sic_ambigs(rname,chain,argum,iarg,action,narg,error)
     if (error)  return
     ch = argum(1:1)
     interactive = .false.
     !
     if (argum.eq.'MOLECULE') then
        call class_draw_molecule(line,r,error)
        ch = "E" ! DRAW MOLECULE never uses the cursor loop
     else
        ! Not MOLECULE
        if (sic_present(0,2)) then   ! Read arguments
           call sic_r4 (line,0,2,xc,.true.,error)
           if (error) return
           if (r%head%gen%kind.eq.kind_spec) then
              call abscissa_chan2velo(r%head,xc,xv)
              call abscissa_chan2sigoff(r%head,xc,xf)
              call abscissa_chan2sigabs(r%head,dble(xc),xf0)
              call abscissa_chan2imaabs(r%head,dble(xc),xi0)
           else
              call abscissa_chan2angl(r%head,xc,xv)
              call abscissa_chan2time(r%head,xc,xf)
           endif
        endif
     endif
     !
  else
     ! Get arguments from cursor
     if (.not. gtg_curs()) then
        call class_message(seve%e,rname,'No cursor available')
        error = .true.
        return
     endif
     call getcur(xc,xv,xf,xi,ya,xxp,yyp,ch)
     nl = index(line,' ')+1
     if (set%fft) then                           ! Fourier space
        n2  = r%head%spe%nchan/2+1.
        ux1 = 0.
        ux2 = 0.5/abs(r%head%spe%fres)
        xc  = 1.+(n2-1.)*(xxp-gx1)/(gx2-gx1)
        xf  = ux1+(ux2-ux1)/(gx2-gx1)*(xxp-gx1)
        xv  = clight_kms/xf/r%head%spe%restf
        xl  = clight_kms*xf*1d-3                     ! wavelength   [m]
        ch = ' '
     else
        if (ch.eq."Q") ch="E"
        xf0 = r%head%spe%restf+xf
        if (r%head%spe%image.eq.image_null) then
          xi0 = image_null
        else
          xi0 = r%head%spe%image-xf
        endif
     endif
     interactive = .true.
  endif
  !
  ! Handle cursor loop
  do while (.true.)
     if (set%fft) then
        select case (ch)
        case ('E')
          exit
        case ('F','K','L','U','M','T','W')
          call class_message(seve%w,rname,'Action '//ch//' ignored on FFT plot')
        case default
          if (r%head%gen%kind.eq.kind_spec) then
            write(6,1002) xc,xv,xf,xl
          elseif (r%head%gen%kind.eq.kind_cont) then
            call class_message(seve%w,rname,'Not implemented for continuum drifts')
            exit
          endif
          if (interactive)  line(nl:) = ' '  ! Last action was "none" => no argument after DRAW
        end select
     else
        select case(ch)
        case("F") ! FILL
           if (.not.interactive) then
              call sic_i4 (line,0,2,ichan,.true.,error)
              if (error) return
           else
              ichan = nint(xc)
           endif
           if (ichan.lt.1 .or. ichan.gt.r%cnchan) then
              call class_message(seve%w,'DRAW FILL','Channel outside spectrum')
           elseif (r%spectre(ichan).ne.r%cbad) then
              call class_message(seve%w,'DRAW FILL','Channel is not blanked')
           else
              r%spectre(ichan) = obs_good(r,ichan)
              if (interactive)  write(line(nl:),103) 'FILL',ichan
           endif
           !
           !
        case("K") ! KILL
           if (.not.interactive) then
              call sic_i4 (line,0,2,ichan,.true.,error)
              if (error) return
           else
              ichan = nint(xc)
           endif
           if (ichan.lt.1 .or. ichan.gt.r%cnchan) then
              call class_message(seve%w,rname,'Channel outside spectrum')
           else
              r%spectre(ichan) = r%cbad
              kill = .true.
              if (interactive) then
                ! Echo on screen
                write(mess,'(A,I0)')  'Killed channel number ',ichan
                call class_message(seve%i,rname,mess)
                ! Save in command line
                write(line(nl:),103) 'KILL',ichan
              endif
           endif
           !
           !
        case("L") ! DRAW LOWER Xpos "String"
           call class_draw_uplow(set,line,r,interactive,1,xxp,xf0,xi0,xc,xv,error)
           if (error)  return
           !
           !
        case("U") ! DRAW Upper Xpos "String"
           call class_draw_uplow(set,line,r,interactive,2,xxp,xf0,xi0,xc,xv,error)
           if (error)  return
           !
           !
        case("M") ! MASK
           call class_draw_mask(set,line,error)
           if (error)  return
           !
           !
        case("T") ! DRAW TEXT Xpos Ypos "Texte" Centering
           if (.not.interactive) then
              call sic_r4 (line,0,2,xxp,.true.,error)
              if (error) return
              call sic_r4 (line,0,3,yyp,.true.,error)
              if (error) return
              call sic_ch (line,0,4,text,ltext,.true.,error)
              if (error) return
              ic = 6
              call sic_i4 (line,0,5,ic,.false.,error)
              if (error) return
           else
              call sic_wprn('Text : ',text,ltext)
              call sic_wprn('Centering option [1-9] :',argum,n)
              read (argum(1:n),'(I1)',iostat=ier) ic
              if (ier.ne.0) then
                 ic = 0
              elseif (ic.ge.1 .and. ic.le.9) then
                 write (line(nl:),100) 'TEXT',xxp,yyp,text(1:ltext),ic
              endif
           endif
           if (ic.lt.1 .or. ic.gt.9) then
              call class_message(seve%e,rname,'Invalid Centering')
              error = .true.
              return
           endif
           call grelocate(xxp,yyp)
           write(mess,'(A,1X,F8.2,A,i1)')'LABEL "'//text(1:ltext)//'"',0.0,' /CENTER ',ic
           call gr_exec(mess)
           !
           !
        case ("W") ! WINDOW
           call class_draw_window(set,line,r,error)
           if (error)  return
           !
           !
        case("E") ! Exit the loop from cursor
           exit
           !
        case default
           if (r%head%gen%kind.eq.kind_spec) then
             if (xi0.eq.image_null) then
               write(6,999) xc,xv,xf0,xf,ya
             else
               write(6,1000) xc,xv,xf0,xi0,xf,ya
             endif
           elseif (r%head%gen%kind.eq.kind_cont) then
              write(6,1001) xc,  &
                            xv*class_setup_get_fangle(),class_setup_get_angle(),  &
                            xf*86400.d0/twopi,  &
                            ya
           endif
           line(nl:) = ' '  ! Last action was "none" => no argument after DRAW
        end select
     endif
     nl = lenc(line)
     !
     ! Compatibility SIC versions patch
     if (line(8:8).ne.backslash) then
        mess = 'ANALYSE'//backslash//line(1:nl)
        call sic_log (mess,nl+8,lire)
        if (lire.eq.0) call sic_insert(mess)
     else
        call sic_log (line,nl+8,lire)
        if (lire.eq.0) call sic_insert (line(1:nl))
     endif
     !
     if (.not.interactive) exit
     !
     call getcur(xc,xv,xf,xi,ya,xxp,yyp,ch)
     if (set%fft) then
        ! Fourier space
        ux1 = 0.
        ux2 = 0.5/abs(r%head%spe%fres)
        xc = 1.+(n2-1.)*(xxp-gx1)/(gx2-gx1)
        xf = ux1+(ux2-ux1)/(gx2-gx1)*(xxp-gx1)
        if (xf.ne.0.d0) then
           xv = clight_kms/xf/r%head%spe%restf
        else
           xv = 0.d0
        endif
        xl = clight_kms*xf*1d-3 ! wavelength   [m]
     else
        if (ch.eq."Q") ch = "E"
        xf0 = r%head%spe%restf+xf
        if (r%head%spe%image.eq.image_null) then
          xi0 = image_null
        else
          xi0 = r%head%spe%image-xf
        endif
        nl = index(line,' ')+1
     endif
  enddo
  !
  ! Normal end
  if (kill) then
     call newlimy(set,r,error)
     if (error) return
  endif
  !
  !
100 format(a,1x,1pg11.4,1x,1pg11.4,' "',a,'" ',i1)
103 format(a,1x,i6)
999 format(&
       t5, 'Channel number', t25,': ',f0.2,/,   &
       t5, 'Velocity', t25,': ',1pg12.5,' km/s',/,   &
       t5, 'Rest Frequency', t25,': ',1pg19.12,' MHz',/,   &
       t5, 'Image Frequency', t25,': N/A',/,   &
       t5, 'Offset Frequency', t25,': ',1pg12.5,' MHz',/,   &
       t5, 'Antenna Temperature', t25,': ',1pg12.5,' K')
1000 format(&
       t5, 'Channel number', t25,': ',f0.2,/,   &
       t5, 'Velocity', t25,': ',1pg12.5,' km/s',/,   &
       t5, 'Rest Frequency', t25,': ',1pg19.12,' MHz',/,   &
       t5, 'Image Frequency', t25,': ',1pg19.12,' MHz',/,   &
       t5, 'Offset Frequency', t25,': ',1pg12.5,' MHz',/,   &
       t5, 'Antenna Temperature', t25,': ',1pg12.5,' K')
1001 format(&
       t5, 'Channel number', t25,': ',f0.2,/,   &
       t5, 'Angle ', t25,': ',1pg12.5,a,/,   &
       t5, 'Time ', t25,': ',1pg12.5,' sec',/,   &
       t5, 'Antenna Temperature', t25,': ',1pg12.5,' K')
1002 format(&
       t5, 'Channel number', t25,': ',f0.2,/,   &
       t5, 'Velocity', t25,': ',1pg15.5,'     km/s',/,   &
       t5, 'Inverse Frequency', t25,': ',1pg19.12,' MHz-1',/,   &
       t5, 'Wavelength', t25,': ',1pg19.12,' m')
end subroutine class_draw_sub
!
subroutine class_draw_molecule(line,r,error)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_draw_molecule
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  DRAW MOLECULE Frequency Name [Angle]
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: line   ! Input command line
  type(observation), intent(in)    :: r      !
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=160) :: text
  real(kind=8) :: x1
  integer :: ltext,ic
  real(kind=4) :: ang,si,xxp,y1,cdef,slength,yp1,yp2
  character(len=commandline_length) :: cline
  !
  ! Parse the arguments
  call sic_r8 (line,0,2,x1,.true.,error)
  if (error) return
  !
  text = ' '
  call sic_ch (line,0,3,text,ltext,.false.,error)
  if (error) return
  !
  ang = 90.0
  call sic_r4 (line,0,4,ang,.false.,error)
  if (error) return
  ang = mod(ang,360.)
  si = sin(pi*ang/180.0)
  !
  call sic_get_real('CHARACTER_SIZE',cdef,error)
  if (error)  return
  !
  ! Is the frequency in the signal frequency range?
  xxp = gx1 + gfx * (x1 - (gfxo+gfx1))
  if (xxp.gt.gx1 .and. xxp.lt.gx2) then
    call gr_segm('MOLECULE',error)
    ic = nint(gcx1 + (xxp-gx1)/gcx)
    ic = max(r%cimin,min(r%cimax,ic))
    y1 = r%spectre(ic)
    call gtg_charlen(ltext,text,cdef,slength,0)
    slength = slength+2*cdef
    yp2 = gy1 + slength*si
    yp1 = gy1 + guy*(y1-guy1)
    if (yp2.gt.yp1) then
      call gplot(xxp,yp1,3)
      call gplot(xxp,yp2,2)
    endif
    call gr_segm_close(error)
    if (error)  return
    !
    ! Open a new segment to plot the text (with solid line style)
    call grelocate(xxp,gy1)
    write(cline,'(A,1X,F8.2,A)') 'LABEL "'//text(1:ltext)//'"',ang,' /CENTER 6'
    call gr_exec(cline)
  endif
  !
  ! Is the frequency in the image frequency range?
  xxp = gx1 + gix * (x1-(gixo+gix1))
  if (xxp.gt.gx1 .and. xxp.lt.gx2) then
    call gr_segm('MOLECULE',error)
    ic = nint(gcx1 + (xxp-gx1)/gcx)
    ic = max(r%cimin,min(r%cimax,ic))
    y1 = r%spectre(ic)
    call gtg_charlen(ltext,text,cdef,slength,0)
    slength = slength+2*cdef
    yp2 = gy2 - slength*si
    yp1 = gy1 + guy*(y1-guy1)
    if (yp2.gt.yp1) then
      call gplot(xxp,yp1,3)
      call gplot(xxp,yp2,2)
    endif
    call gr_segm_close(error)
    if (error)  return
    !
    ! Open a new segment to plot the text (with solid line style)
    call grelocate(xxp,gy2)
    write(cline,'(A,1X,F8.2,A)') 'LABEL "'//text(1:ltext)//'"',ang,' /CENTER 6'
    call gr_exec(cline)
  endif
  !
end subroutine class_draw_molecule
!
subroutine class_draw_uplow(set,line,r,interactive,axis,xxp,xf0,xi0,xc,xv,error)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_draw_uplow
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   ANA\DRAW UPPER|LOWER Xpos String
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set          !
  character(len=*),    intent(inout) :: line         ! Command line
  type(observation),   intent(in)    :: r            !
  logical,             intent(in)    :: interactive  ! Command line or cursor?
  integer(kind=4),     intent(in)    :: axis         ! 1 = lower, 2 = upper
  real(kind=4),        intent(inout) :: xxp          ! X position from cursor (Paper)
  real(kind=8),        intent(in)    :: xf0          ! X position from cursor (Signal)
  real(kind=8),        intent(in)    :: xi0          ! X position from cursor (Image)
  real(kind=4),        intent(in)    :: xc           ! X position from cursor (Channel)
  real(kind=4),        intent(in)    :: xv           ! X position from cursor (Velocity)
  logical,             intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=160) :: text
  real(kind=8) :: x1
  real(kind=4) :: ang,cdef,y1,yp1,yp2,si,slength
  integer(kind=4) :: ic,ltext,nl,align
  character(len=commandline_length) :: cline
  character(len=5) :: skind
  !
  if (.not.interactive) then
    call sic_r8 (line,0,2,x1,.true.,error)
    if (error) return
    if (set%unitx(axis).eq.'F') then
      xxp = gx1 + gfx * (x1 - (gfxo+gfx1))
    elseif (set%unitx(axis).eq.'I') then
      xxp = gx1 + gix * (x1 - (gixo+gix1))
    elseif (set%unitx(axis).eq.'C') then
      xxp = gx1 + gcx * (x1 - gcx1)
    elseif (set%unitx(axis).eq.'V') then
      xxp = gx1 + gvx * (x1 - gvx1)
    endif
    text = ' '
    call sic_ch (line,0,3,text,ltext,.false.,error)
    if (error) return
    ang = 90.0
    call sic_r4 (line,0,4,ang,.false.,error)
    ang = mod(ang,360.)
    if (error) return
  else
    nl = index(line,' ')+1
    if (axis.eq.1) then
      skind = 'LOWER'
    else
      skind = 'UPPER'
    endif
    call sic_wprn('Text : ',text,ltext)
    !
    if (set%unitx(axis).eq.'F') then
      write (line(nl:),101) skind,xf0,text(1:ltext)
    elseif (set%unitx(axis).eq.'I') then
      write (line(nl:),101) skind,xi0,text(1:ltext)
    elseif (set%unitx(axis).eq.'C') then
      write (line(nl:),102) skind,xc,text(1:ltext)
    elseif (set%unitx(axis).eq.'V') then
      write (line(nl:),102) skind,xv,text(1:ltext)
    endif
    ang = 90.0
  endif
  !
  si = sin(pi*ang/180.0)
  if (xxp.gt.gx1 .and. xxp.lt.gx2) then
    ic = nint(gcx1 + (xxp-gx1)/gcx)
    ic = max(r%cimin,min(r%cimax,ic))
    y1 = r%spectre(ic)
    !
    call sic_get_real('CHARACTER_SIZE',cdef,error)
    if (error)  return
    call gtg_charlen(ltext,text,cdef,slength,0)
    slength = slength+2*cdef
    !
    if (axis.eq.1) then
      yp2 = gy1 + slength*si
    else
      yp2 = gy2 - slength*si
    endif
    yp1 = gy1 + guy*(y1-guy1)
    if (axis.eq.1 .and. yp1.gt.yp2 .or.  &
        axis.eq.2 .and. yp2.gt.yp1) then
      call gr_segm ('DRAW',error)
      call gplot(xxp,yp1,3)
      call gplot(xxp,yp2,2)
      call gr_segm_close(error)
      if (error)  return
    endif
    !
    ! Open a new segment to plot the text (with solid line style)
    if (axis.eq.1) then
      call grelocate(xxp,gy1+cdef)  ! 1 character away from bottom axis
      align = 6
    else
      call grelocate(xxp,gy2-cdef)  ! 1 character away from top axis
      align = 4
    endif
    write(cline,'(A,1X,F8.2,A,I0)')  &
      'LABEL "'//text(1:ltext)//'"',ang,' /CENTER ',align
    call gr_exec(cline)
  endif
  !
101 format(a,1x,1pg15.8,' "',a,'"')
102 format(a,1x,1pg11.4,' "',a,'"')
end subroutine class_draw_uplow
!
subroutine class_draw_mask(set,line,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_draw_mask
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    DRAW MASK [Ylev]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: i
  real(kind=4) :: ylev
  !
  ylev = guy1*0.5
  call sic_r4(line,0,2,ylev,.false.,error)
  if (error) return
  !
  call gr_segm('DRAW',error)
  if (error)  return
  !
  do i=1,set%nmask
    call uplot(set%mask1(i),0.0,3)
    call uplot(set%mask1(i),ylev,2)
    call uplot(set%mask2(i),ylev,2)
    call uplot(set%mask2(i),0.0,2)
  enddo
  !
  call gr_segm_close(error)
  if (error)  return
  !
end subroutine class_draw_mask
!
subroutine class_draw_window(set,line,r,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_draw_window
  use class_types
  use class_index
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    DRAW WINDOW [Ymin [Ymax]]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  type(observation),   intent(in)    :: r      !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DRAW'
  integer(kind=4) :: i,nwind
  real(kind=8) :: xw1,xw2,yw1,yw2
  real(kind=4) :: w1(mwind),w2(mwind)
  character(len=commandline_length) :: comm
  type(class_assoc_sub_t) :: array
  !
  if (set%nwind.eq.setnwind_auto) then
    ! Take from data
    if (r%head%bas%nwind.eq.basnwind_assoc) then
      nwind = setnwind_assoc
    else
      nwind = r%head%bas%nwind
      w1(:) = r%head%bas%w1(:)
      w2(:) = r%head%bas%w2(:)
    endif
  else
    ! Take from SET WINDOW
    nwind = set%nwind
    w1(:) = set%wind1(:)
    w2(:) = set%wind2(:)
  endif
  !
  ! Sanity checks
  select case (nwind)
  case (setnwind_default)
    call class_message(seve%w,rname,'SET WINDOW is not defined')
    return
  case (setnwind_assoc)
    if (.not.class_assoc_exists(r,'LINE',array)) then
      call class_message(seve%w,rname,  &
        'No LINE Associated Array while SET WINDOW /ASSOCIATED is set')
      return
    endif
  case (0)
    call class_message(seve%w,rname,'0 windows defined')
    return
  end select
  !
  yw1 = guy1
  call sic_r8 (line,0,2,yw1,.false.,error)
  if (error)  return
  yw2 = 0.9*guy1+0.1*guy2
  call sic_r8 (line,0,3,yw2,.false.,error)
  if (error) return
  !
  call gr_segm ('DRAW',error)
  if (error)  return
  !
  if (nwind.eq.setnwind_polygon) then
    ! Draw the window(s) from polygon(s) for the current spectrum
    do i=1,nint(set%window_polygon(knext,1))
      xw1 = set%window_polygon(knext,2*i)
      xw2 = set%window_polygon(knext,2*i+1)
      call relocate(xw1,yw1)
      call draw(xw1,yw2)
      call draw(xw2,yw2)
      call draw(xw2,yw1)
    enddo
    !
  elseif (nwind.eq.setnwind_assoc) then
    ! LINE is an array of 0 and 1. We want 0 at level yw1, and 1 at level yw2
    write(comm,'(A,4(1X,G14.7))') 'LIMITS',gux1,gux2,(guy1-yw1)/(yw2-yw1),(guy2-yw1)/(yw2-yw1)
    call gr_exec(comm)
    error = gr_error()
    call spectr1d_draw(set,r,array%i4(:,1),array%badi4,error)
    if (error)  continue
    ! Revert to normal limits
    write(comm,'(A,4(1X,G14.7))') 'LIMITS',gux1,gux2,guy1,guy2
    call gr_exec(comm)
    error = gr_error()
    !
  else
    do i=1,nwind
      xw1 = w1(i)
      xw2 = w2(i)
      call relocate(xw1,yw1)
      call draw(xw1,yw2)
      call draw(xw2,yw2)
      call draw(xw2,yw1)
    enddo
  endif
  !
  call gr_segm_close(error)
  if (error)  return
  !
end subroutine class_draw_window

module classmap_interfaces_public
  interface
    subroutine load_map(error)
      use xymap_def
      !---------------------------------------------------------------------
      ! @ public (for libclass only)
      ! MAP initialization routine:
      ! MAP language is loaded.
      !---------------------------------------------------------------------
      logical, intent(out) :: error     ! Error status
    end subroutine load_map
  end interface
  !
end module classmap_interfaces_public

module cubeadm_opened
  use cubelist_types
  use cubedag_parameters
  use cubetools_flag_types
  use cubedag_link_type
  use cubedag_node_class
  use cubetuple_format_class
  use cubetopology_cuberegion_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubeadm_taskloop
  use cubeadm_opened_types
  use cubeadm_messaging
  !---------------------------------------------------------------------
  ! Support module for registering and keep track of cubes opened by
  ! current command, up to the moment they are closed with
  ! 'cubeadm_finish_all'
  !---------------------------------------------------------------------
  !
  ! Keep a list of the parents and children currently 'opened'.
  ! At some point they are all 'flushed' in the DAG, with the proper
  ! cross-references.
  type(cubeadm_opened_list_t) :: all
  type(cubeadm_opened_list_t) :: pa
  type(cubeadm_opened_list_t) :: ch
  !
  integer(kind=code_k), parameter :: code_parent_noarg=1
  integer(kind=code_k), parameter :: code_parent=2
  integer(kind=code_k), parameter :: code_child=3
  integer(kind=code_k), parameter :: code_child_noprod=4
  !
  interface cubeadm_parents_add
    module procedure cubeadm_parents_add_noarg
    module procedure cubeadm_parents_add_witharg
  end interface cubeadm_parents_add
  !
  interface cubeadm_children_add
    module procedure cubeadm_children_add_noprod
    module procedure cubeadm_children_add_withprod
  end interface cubeadm_children_add
  !
  interface cubeadm_datainit_all
    module procedure cubeadm_datainit_allcubes_full
    module procedure cubeadm_datainit_allcubes_region
  end interface cubeadm_datainit_all
  !
  public :: cubeadm_parents_add,cubeadm_children_add
  public :: cubeadm_datainit_all,cubeadm_dataiterate_all
  public :: cubeadm_finish_all
  public :: cubeadm_iterator_t  ! For convenience to users
  public :: cubeadm_parents_children_pop
  private
  !
contains
  !
  subroutine cubeadm_parents_add_noarg(dno,action)
    !-------------------------------------------------------------------
    ! Add a parent cube as command input
    ! ---
    ! This version does not provide a cubeid_arg_t nor a
    ! cubeid_user_cube_t
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: action
    !
    type(cubeadm_opened_t), pointer :: obj  ! Pointer to the actual object
    logical :: error,skip
    !
    error = .false.
    call cubeadm_add_opened_node(code_parent_noarg,  &
                                 action,  &
                                 ' ',     &  ! User input => unknown with this API
                                 dno,     &
                                 null(),  &  ! Argument/product => unknown with this API
                                 obj,skip,error)
    if (error)  return
    if (skip)   return
    !
    call pa%associate(obj,error)
    if (error)  return
  end subroutine cubeadm_parents_add_noarg
  !
  subroutine cubeadm_parents_add_witharg(arg,user,dno,action)
    !-------------------------------------------------------------------
    ! Add a parent cube as command input
    ! ---
    ! This version provides a cubeid_arg_t (for input cube expectations)
    ! and a cubeid_user_cube_t (for actual user inputs)
    !-------------------------------------------------------------------
    type(cubeid_arg_t), target,   intent(in) :: arg
    type(cubeid_user_cube_t),     intent(in) :: user
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: action
    !
    type(cubeadm_opened_t), pointer :: obj  ! Pointer to the actual object
    class(list_object_t), pointer :: arg_or_prod
    logical :: error,skip
    !
    error = .false.
    arg_or_prod => arg
    call cubeadm_add_opened_node(code_parent,  &
                                 action,       &
                                 user%id,      &  ! User input => keep only the non-parsed string
                                 dno,          &
                                 arg_or_prod,  &
                                 obj,skip,error)
    if (error)  return
    if (skip)   return
    !
    call pa%associate(obj,error)
    if (error)  return
  end subroutine cubeadm_parents_add_witharg
  !
  subroutine cubeadm_children_add_noprod(dno,action)
    !-------------------------------------------------------------------
    ! Add a child cube as command output
    ! ---
    ! This version does not provide a cube_prod_t
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: action
    !
    type(cubeadm_opened_t), pointer :: obj  ! Pointer to the actual object
    logical :: error,skip
    !
    error = .false.
    call cubeadm_add_opened_node(code_child_noprod,  &
                                 action,  &
                                 ' ',     &  ! User input => unknown with this API
                                 dno,     &
                                 null(),  &  ! Argument/product => unknown with this API
                                 obj,skip,error)
    if (error)  return
    if (skip)   return
    !
    call ch%associate(obj,error)
    if (error)  return
  end subroutine cubeadm_children_add_noprod
  !
  subroutine cubeadm_children_add_withprod(prod,dno,action)
    !-------------------------------------------------------------------
    ! Add a child cube as command output
    ! ---
    ! This version does not provide a cube_prod_t
    !-------------------------------------------------------------------
    type(cube_prod_t), target,    intent(in) :: prod
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: action
    !
    type(cubeadm_opened_t), pointer :: obj  ! Pointer to the actual object
    class(list_object_t), pointer :: arg_or_prod
    logical :: error,skip
    !
    error = .false.
    arg_or_prod => prod
    call cubeadm_add_opened_node(code_child,   &
                                 action,       &
                                 ' ',          &  ! User input => irrelevant
                                 dno,          &
                                 arg_or_prod,  &
                                 obj,skip,error)
    if (error)  return
    if (skip)   return
    !
    call ch%associate(obj,error)
    if (error)  return
  end subroutine cubeadm_children_add_withprod
  !
  subroutine cubeadm_add_opened_node(status,action,userid,dno,arg_or_prod,  &
    obj,skip,error)
    !-------------------------------------------------------------------
    ! Insert a new opened node in the 'all' list. Skip if already
    ! referenced.
    !-------------------------------------------------------------------
    integer(kind=code_k),         intent(in)    :: status
    integer(kind=code_k),         intent(in)    :: action
    character(len=*),             intent(in)    :: userid
    class(cubedag_node_object_t), pointer       :: dno
    class(list_object_t),         pointer       :: arg_or_prod
    type(cubeadm_opened_t),       pointer       :: obj
    logical,                      intent(out)   :: skip
    logical,                      intent(inout) :: error
    !
    integer(kind=list_k) :: iall
    class(list_object_t), pointer :: lot
    type(cubeadm_opened_t) :: model  ! Dummy model (template) for the Fortran allocation
    !
    ! Avoid double insertions. This can happen if a cube is re-accessed
    ! (cubeadm_access_header) during the command execution
    do iall=1,all%n
      obj => cubeadm_opened_ptr(all%list(iall)%p,error)
      if (error)  return
      if (associated(obj%dno,dno)) then
        skip = .true.
        return
      endif
    enddo
    skip = .false.
    !
    ! Allocate a new 'opened_t' object
    call all%allocate(model,lot,error)
    if (error)  return
    obj => cubeadm_opened_ptr(lot,error)
    if (error)  return
    !
    ! Fill the object
    obj%status = status
    obj%action = action
    obj%userid = userid
    obj%dno => dno
    obj%arg_or_prod => arg_or_prod
  end subroutine cubeadm_add_opened_node
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeadm_parents_children_pop(dno,error)
    !-------------------------------------------------------------------
    ! Pop out the given node from the parents/children lists
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer       :: dno
    logical,                      intent(inout) :: error
    !
    call pa%unlink(dno,error)
    call ch%unlink(dno,error)
    call all%unlink(dno,error)
  end subroutine cubeadm_parents_children_pop
  !
  subroutine cubeadm_parents_children_reset()
    logical :: error
    error = .false.
    call pa%final(error)
    call ch%final(error)
    call all%final(error)
  end subroutine cubeadm_parents_children_reset
  !
  subroutine cubeadm_list_opened(error)
    use cubelist_list
    use cubedag_list_columns
    logical, intent(inout) :: error
    ! Local
    integer(kind=4) :: larg,lflag,luser,nc,icol
    character(len=mess_l) :: mess
    integer(kind=entr_k) :: icub
    type(cubeadm_opened_t), pointer :: opened
    type(cubedag_link_t) :: link
    type(cubeid_arg_t), pointer :: arg
    type(cube_prod_t), pointer :: prod
    character(len=*), parameter :: colnames(7) = &
         ['IDENTIFIER ','TYPE       ','CUBEID     ','OBSERVATORY',  &
          'SOURCE     ','LINE       ','DATASIZE   ']
    type(list_column_list_t) :: cols
    character(len=*), parameter :: rname='LIST>OPENED'
    !
    ! Set up columns
    do icol=1,7
      call cubedag_list_columns_fetch(colnames(icol),cols,error)
      if (error)  return
    enddo
    call all%to_link(link,error)
    if (error)  return
    call cols%widths(link,error)
    if (error)  return
    call link%final(error)
    if (error)  return
    !
    ! Automatic widths for leading columns
    larg = 1   ! Argument name width
    lflag = 1  ! Flag list width
    luser = 1  ! User input width
    do icub=1,all%n
      opened => cubeadm_opened_ptr(all%list(icub)%p,error)
      if (error)  return
      select case (opened%status)
      case (code_parent_noarg)  ! A parent with no associated cubeid_arg_t nor cubeid_user_cube_t
        ! Argument name size unchanged
        ! Flag column size unchanged
        ! User input column size unchanged
      case (code_parent)
        arg => cubedag_cubeid_arg_ptr(opened%arg_or_prod,error)
        if (error)  return
        ! Argument name size from command's cubeid_arg_t
        larg = max(larg,len_trim(arg%name))
        ! Flag column size from command's cubeid_arg_t
        call cubetools_flaglist_tostr(arg%flag,arg%nflag,lstrflag=nc,error=error)
        if (error) return
        lflag = max(lflag,nc)
        ! User input column size from user input
        luser = max(1,len_trim(opened%userid))
      case (code_child_noprod)
        ! Argument name size unchanged
        ! Flag column size from child cube itself
        call opened%dno%node%flag%repr(lstrflag=nc,error=error)
        if (error) return
        lflag = max(lflag,nc)
        ! User input column size not changed (irrelevant)
      case (code_child)
        prod => cubeadm_cubeprod_ptr(opened%arg_or_prod,error)
        if (error)  return
        ! Product name size from command's cube_prod_t
        larg = max(larg,len_trim(prod%name))
        ! Flag column size from command's cube_prod_t
        call cubetools_flaglist_tostr(prod%flag,prod%nflag,lstrflag=nc,error=error)
        if (error) return
        lflag = max(lflag,nc)
        ! User input column size not changed (irrelevant)
      case default
        call cubeadm_message(seve%w,rname,'Cube is neither parent nor child')
      end select
    enddo
    !
    ! Actual print
    do icub=1,all%n
      nc = 1
      opened => cubeadm_opened_ptr(all%list(icub)%p,error)
      if (error)  return
      select case (opened%status)
      case (code_parent_noarg)  ! A parent with no associated cubeid_arg_t nor cubeid_user_cube_t
        mess(nc:) = 'I'
        nc = nc+2
        mess(nc:) = ' '  ! No argument name
        nc = nc+larg+1
        mess(nc:) = ' '  ! No argument flags
        nc = nc+lflag+1
        mess(nc:) = ' '  ! No user input
        nc = nc+luser
      case (code_parent)
        arg => cubedag_cubeid_arg_ptr(opened%arg_or_prod,error)
        if (error)  return
        mess(nc:) = 'I'
        nc = nc+2
        mess(nc:) = arg%name
        nc = nc+larg+1
        call cubetools_flaglist_tostr(arg%flag,arg%nflag,strflag=mess(nc:),error=error)
        if (error) return
        nc = nc+lflag+1
        mess(nc:) = opened%userid
        nc = nc+luser
      case (code_child_noprod)
        mess(nc:) = 'O'
        nc = nc+2
        mess(nc:) = ' '  ! No argument name
        nc = nc+larg+1
        call opened%dno%node%flag%repr(strflag=mess(nc:),error=error)
        if (error) return
        nc = nc+lflag+1
        mess(nc:) = opened%userid
        nc = nc+luser
      case (code_child)
        prod => cubeadm_cubeprod_ptr(opened%arg_or_prod,error)
        if (error)  return
        mess(nc:) = 'O'
        nc = nc+2
        mess(nc:) = prod%name
        nc = nc+larg+1
        call cubetools_flaglist_tostr(prod%flag,prod%nflag,strflag=mess(nc:),error=error)
        if (error) return
        nc = nc+lflag+1
        mess(nc:) = opened%userid
        nc = nc+luser
      end select
      mess(nc:) = ' => '
      nc = nc+4
      call cols%line(opened%dno,mess(nc:),error)
      if (error) return
      call cubeadm_message(seve%r,rname,mess)
    enddo
    !
    call cols%final(error)
    if (error) return
  end subroutine cubeadm_list_opened
  !
  subroutine cubeadm_datainit_allcubes_full(iter,error,align)
    use cubetuple_iterator
    !-------------------------------------------------------------------
    ! Prepare the data IO for all the registered cubes
    !-------------------------------------------------------------------
    type(cubeadm_iterator_t),       intent(out)   :: iter
    logical,                        intent(inout) :: error
    integer(kind=code_k), optional, intent(in)    :: align
    ! Local
    character(len=*), parameter :: rname='DATAINIT>ALLCUBES>FULLSET'
    type(cuberegion_prog_t), pointer :: region
    integer(kind=code_k) :: lalign
    !
    if (present(align)) then
      lalign = align
    else
      lalign = code_align_auto
    endif
    region => null()
    call cubeadm_datainit_allcubes_do(iter,lalign,region,error)
    if (error) return
    !
  end subroutine cubeadm_datainit_allcubes_full
  !
  subroutine cubeadm_datainit_allcubes_region(iter,region,error)
    use cubetuple_iterator
    !-------------------------------------------------------------------
    ! Prepare the data IO for all the registered cubes
    !-------------------------------------------------------------------
    type(cubeadm_iterator_t),        intent(out)   :: iter
    type(cuberegion_prog_t), target, intent(in)    :: region
    logical,                         intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='DATAINIT>ALLCUBES>REGION'
    type(cuberegion_prog_t), pointer :: pregion
    !
    pregion => region
    call cubeadm_datainit_allcubes_do(iter,code_align_auto,pregion,error)
    if (error) return
  end subroutine cubeadm_datainit_allcubes_region
  !
  subroutine cubeadm_datainit_allcubes_do(iter,align,region,error)
    use cubetools_access_types
    use cubeadm_entryloop
    !-------------------------------------------------------------------
    ! Prepare the data IO for all the registered cubes
    !-------------------------------------------------------------------
    type(cubeadm_iterator_t), intent(inout) :: iter
    integer(kind=code_k),     intent(in)    :: align
    type(cuberegion_prog_t),  pointer       :: region
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='DATAINIT>ALLCUBES>DO'
    type(cubeadm_opened_t), pointer :: opened
    class(format_t), pointer :: incube,oucube
    integer(kind=entr_k) :: icube,refnum
    integer(kind=code_k) ::refaccess,reforder
    character(len=mess_l) :: mess
    type(cubedag_link_t) :: plink,clink
    !
    ! Loop on all the input cubes to check their consistency
    refnum = 0
    do icube=1,pa%n
      opened => cubeadm_opened_ptr(pa%list(icube)%p,error)
      if (error)  return
      if (opened%action.eq.code_read_head)  cycle  ! No need for data consistency check
      incube => cubetuple_format_ptr(opened%dno,error)
      if (error) return
      if (refnum.eq.0) then
        refnum = icube
        refaccess = incube%access()
        reforder = incube%order()
      else
        if (incube%order().ne.reforder .or. &
            incube%access().ne.refaccess) then
          call cubeadm_message(seve%e,rname,'Inconsistent cube accesses or orders:')
          write(mess,'(A,I0,4A)')  '  Cube #',refnum,  &
                                   ': access ',trim(cubetools_accessname(refaccess)),  &
                                   ', order ',cubetools_ordername(reforder)
          call cubeadm_message(seve%e,rname,mess)
          write(mess,'(A,I0,4A)')  '  Cube #',icube,  &
                                   ': access ',trim(cubetools_accessname(incube%access())),  &
                                   ', order ',cubetools_ordername(incube%order())
          call cubeadm_message(seve%e,rname,mess)
          error = .true.
          return
        endif
      endif
      call incube%tuple%elapsed_init(error)
      if (error)  return
    enddo
    !
    ! Loop on all the output cubes to prepare them for data access
    do icube=1,ch%n
      opened => cubeadm_opened_ptr(ch%list(icube)%p,error)
      if (error)  return
      oucube => cubetuple_format_ptr(opened%dno,error)
      if (error) return
      call cubeadm_datainit_one(oucube,error)
      if (error) return
      ! After the IO desc is available:
      call oucube%default_iorder(error)
      if (error)  return
    enddo
    !
    ! Taskloop iterator is set by taking all the input and output cubes
    ! into account
    call pa%to_link(plink,error)
    if (error)  return
    call ch%to_link(clink,error)
    if (error)  return
    call cubeadm_taskloop_init(plink,clink,align,region,iter,error)
    if (error) return
    call plink%final(error)
    if (error) return
    call clink%final(error)
    if (error) return
    ! Entryloop iterator
    call cubeadm_entryloop_init(iter%ne,error)
    if (error) return
    !
    ! Initialize processing
    do icube=1,ch%n
      opened => cubeadm_opened_ptr(ch%list(icube)%p,error)
      if (error)  return
      oucube => cubetuple_format_ptr(opened%dno,error)
      if (error) return
      call cubeadm_processinginit_one(oucube,iter%nt,error)
      if (error) return
      call oucube%tuple%elapsed_init(error)
      if (error)  return
    enddo
    !
    ! User feedback (after the output cubes have been prepared)
    call cubeadm_list_opened(error)
    if (error) return
  end subroutine cubeadm_datainit_allcubes_do
  !
  subroutine cubeadm_datainit_one(oucube,error)
    use cubeio_highlevel
    !-------------------------------------------------------------------
    ! Prepare the data IO for one cube
    !-------------------------------------------------------------------
    class(format_t), intent(inout) :: oucube
    logical,         intent(inout) :: error
    !
    ! Prepare HGDF and the descriptor (the later is needed between now
    ! and first data access)
    call cubeio_clone_header(oucube%user,oucube%prog,oucube,oucube%tuple%current,error)
    if (error) return
  end subroutine cubeadm_datainit_one
  !
  subroutine cubeadm_processinginit_one(oucube,ntasks,error)
    use cubetools_header_methods
    !-------------------------------------------------------------------
    ! Prepare the processing for one cube
    !-------------------------------------------------------------------
    class(format_t),      intent(inout) :: oucube
    integer(kind=entr_k), intent(in)    :: ntasks
    logical,              intent(inout) :: error
    !
    ! Re-initialize the extrema since they are about to be recomputed
    ! in the upcoming processing loop (OBSOLESCENT)
    ! BEWARE: ndat is also computed below
    call cubetools_header_extrema_init(oucube%head,error)
    if (error) return
    !
    ! Extrema are not recomputed if disabled or if complex. Leave them
    ! reinitialized on purpose.
    if (.not.oucube%user%output%extrema .or. oucube%iscplx())  return
    !
    ! Re-initialize the per-task extrema since they are about to be
    ! recomputed in the upcoming processing loop
    call oucube%proc%allocate_extrema(oucube%head,ntasks,error)
    if (error)  return
  end subroutine cubeadm_processinginit_one
  !
  function cubeadm_dataiterate_all(iter,error)
    !-------------------------------------------------------------------
    ! Iterate the iterator until all data is processed, and ensure all
    ! the registered cubes are ready to access their first to last
    ! entries.
    !-------------------------------------------------------------------
    logical :: cubeadm_dataiterate_all
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    ! Local
    type(cubeadm_opened_t), pointer :: opened
    integer(kind=entr_k) :: icube
    !
    ! Iteration
    cubeadm_dataiterate_all = cubeadm_taskloop_iterate(iter,error)
    if (error) return
    if (.not.cubeadm_dataiterate_all)   return  ! All done
    !
    ! Parents
    do icube=1,pa%n
      opened => cubeadm_opened_ptr(pa%list(icube)%p,error)
      if (error)  return
      if (opened%action.eq.code_read .or.  &
          opened%action.eq.code_update) then  ! Skip parent which is code_read_head
        call cubeadm_dataiterate_one(opened%dno,iter%prange,error)
        if (error) return
      endif
    enddo
    !
    ! Children
    do icube=1,ch%n
      opened => cubeadm_opened_ptr(ch%list(icube)%p,error)
      if (error)  return
      call cubeadm_dataiterate_one(opened%dno,iter%prange,error)
      if (error) return
    enddo
    !
  end function cubeadm_dataiterate_all
  !
  subroutine cubeadm_dataiterate_one(dno,refrange,error)
    use cubeadm_ioloop
    !-------------------------------------------------------------------
    ! Ensure the identified cube is ready to access its iter%first to
    ! iter%last entries.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer       :: dno
    integer(kind=indx_k),         intent(in)    :: refrange(2)
    logical,                      intent(inout) :: error
    ! Local
    class(format_t), pointer :: cube
    integer(kind=coor_k) :: thisrange(2)
    logical, parameter :: truncate=.true.
    character(len=*), parameter :: rname='DATAITERATE>ONE'
    !
    cube => cubetuple_format_ptr(dno,error)
    if (error)  return
    if (cube%access().eq.code_access_fullset) then
      call cube%iter%fullrange(thisrange,error)
      if (error)  return
    else
      call cube%iter%range(refrange,truncate,thisrange,error)
      if (error)  return
    endif
    call cubeadm_io_iterate_planes(thisrange(1),thisrange(2),cube,error)
    if (error) return
  end subroutine cubeadm_dataiterate_one
  !
  subroutine cubeadm_finish_all(comm,line,error)
    use cubedag_dag_buffer
    use cubedag_history_buffer
    use cubedag_links_tool
    use cubedag_remove_tool
    !---------------------------------------------------------------------
    ! Finish all cubes currently opened in index.
    ! ---
    ! Beware this subroutine can be called in an error recovery context,
    ! i.e. with error = .true. on input
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: comm
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FINISH>ALL'
    integer(kind=entr_k) :: ient,hid
    logical :: lerror
    type(cubeadm_opened_t), pointer :: opened
    type(cubedag_link_t) :: plink,clink
    !
    lerror = .false.  ! Local error
    !
    call pa%to_link(plink,lerror)
    if (lerror)  continue
    call ch%to_link(clink,lerror)
    if (lerror)  continue
    !
    ! Insert in history
    if (.not.error) then
      ! If you plan to put failed commands in the HISTORY list,
      ! you can not reference output cubes ('ch' list) which are
      ! not inserted in DAG but destroyed instead.
      call cubedag_history_add_tohx(comm,line,plink,clink,hid,lerror)
      if (lerror) continue
    endif
    !
    if (.not.error) then
      ! Update the links between parents and children, according to their read/write
      ! status. This is to be done before the cubes are freed (finalized)
      call nodeln%all_links(plink,clink,hid,lerror)
      if (lerror) continue
    endif
    !
    call plink%final(lerror)
    if (lerror)  continue
    call clink%final(lerror)
    if (lerror)  continue
    !
    ! Deal with the input cubes (including cubes opened in UPDATE mode, needing
    ! to be written on disk).
    do ient=1,pa%n
      opened => cubeadm_opened_ptr(pa%list(ient)%p,lerror)
      if (lerror) exit
      call opened%dno%finish(lerror)
      if (lerror) exit
    enddo
    !
    ! Deal with the output cubes
    do ient=1,ch%n
      opened => cubeadm_opened_ptr(ch%list(ient)%p,lerror)
      if (lerror) exit
      call opened%dno%finish(lerror)
      if (lerror) exit
      if (error) then
        call noderm%destroy(opened%dno,lerror)
        if (lerror) exit
      else
        call cubedag_dag_attach(opened%dno,lerror)
        if (lerror) exit
      endif
    enddo
    !
    ! Reset parents and children list
    call cubeadm_parents_children_reset()
    !
    ! Ensure the ID counter is up-to-date (in particular if an error
    ! occured, i.e. the output cubes were discarded)
    call cubedag_dag_updatecounter(lerror)
    if (lerror) continue
    !
    if (lerror) error = .true.
    !
  end subroutine cubeadm_finish_all
end module cubeadm_opened

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_getdata
  use cubetools_parameters
  use cubelist_types
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetools_userspace
  use cubetools_uservar
  use cube_types
  use cubetopology_spapos_types
  use cubetopology_spechannel_types
  use cubeedit_cube_types
  use cubeedit_entry
  use cubeedit_which_data
  use cubeedit_messaging
  !  
  public :: getdata_comm_t,getdata_user_t
  public :: access_is_fixed,access_not_fixed,entr_unk
  private
  !
  integer(kind=4), parameter :: izero=1
  integer(kind=4), parameter :: ifirst=2
  integer(kind=4), parameter :: ilast=3
  integer(kind=4), parameter :: inext=4
  integer(kind=4), parameter :: iprevious=5
  integer(kind=4), parameter :: iafter=6
  integer(kind=4), parameter :: icurrent=7
  integer(kind=4), parameter :: nwhich = icurrent
  !
  character(len=*), parameter :: options(nwhich) = &
       ['ZERO     ','FIRST    ','LAST     ','NEXT     ','PREVIOUS ','AFTERLAST','CURRENT  ']
  !
  logical, parameter :: access_is_fixed  = .true.
  logical, parameter :: access_not_fixed = .false.
  logical, parameter :: active = .true.
  integer(kind=entr_k), parameter :: entr_unk = -1000
  !
  type :: getdata_comm_t
     type(which_comm_t)             :: which(1:nwhich)
     type(entry_opt_t)              :: entry
     type(spapos_comm_t)            :: pixel    
     type(spechannel_opt_t)         :: channel
     type(cube_opt_t)               :: cube
     type(userspace_opt_t), pointer :: into
     logical                        :: fixed
   contains
     procedure :: register => cubeedit_getdata_register
     procedure :: parse    => cubeedit_getdata_parse_and_check
     procedure :: get      => cubeedit_getdata_command
     procedure :: list     => cubeedit_getdata_list_buffers
  end type getdata_comm_t
  !
  type getdata_user_t
     type(userspace_user_t), pointer :: uservar
     type(which_user_t)              :: which(1:nwhich)
     type(entry_user_t)              :: entry
     type(spapos_user_t)             :: pixel
     type(spechannel_user_t)         :: channel
     type(cube_user_t)               :: cube
     logical                         :: show
     logical                         :: do
  end type getdata_user_t
  !
  type getdata_prog_t
     type(cube_t), pointer          :: cube
     integer(kind=entr_k)           :: ie
     integer(kind=4)                :: ibuffer
     integer(kind=code_k), private  :: doaccess
     logical                        :: get
     type(uservar_t)                :: uservar
  end type getdata_prog_t
  !
  integer(kind=code_k), parameter :: code_not_used = -1
  integer(kind=code_k), parameter :: code_defined  = 2
  !
  type, extends(userspace_t) :: getdata_buffer_t
     integer(kind=4)      :: id
     integer(kind=entr_k) :: ie   = 0
     integer(kind=code_k) :: status = code_not_used
  end type getdata_buffer_t
  !
  type(list_t) :: imaglist,speclist,cubelist
  !
contains
  !
  subroutine cubeedit_getdata_register(comm,into,fixed,iterator,error)
    !-------------------------------------------------------------------
    ! Register for EDIT\GET and  GO\LOAD (data part)
    !-------------------------------------------------------------------
    class(getdata_comm_t), intent(out)   :: comm
    type(userspace_opt_t), target        :: into
    logical,               intent(in)    :: fixed
    logical,               intent(in)    :: iterator
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iwhich
    logical :: listactive(nwhich)
    character(len=*), parameter :: rname='GETDATA>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    comm%into  => into
    comm%fixed =  fixed
    if (iterator) then
       listactive(:) = active
    else
       listactive(:) = .not.active
       listactive(ifirst)     = active
       listactive(ilast)      = active
    endif
    !
    do iwhich=1, nwhich
       call comm%which(iwhich)%register(options(iwhich), &
            'Get the '//trim(options(iwhich))//' entry from the cube',&
            fixed,listactive(iwhich),error)
       if (error) return
    enddo
    !
    ! /ENTRY
    call comm%entry%register(&
         'Get the i-th entry from the cube',fixed,error)
    if (error) return
    !
    ! /PIXEL
    call comm%pixel%register("PIXEL",&
         'Define the position of the pixel to be gotten',&
         error)
    if (error) return
    !
    ! /CHANNEL
    call comm%channel%register('CHANNEL',&
         'Get a channel from the cube',&
         error)
    if (error) return
    !
    ! /CUBE
    call comm%cube%register('CUBE',&
         'Get the full cube',&
         error)
    if (error) return
  end subroutine cubeedit_getdata_register
  !
  subroutine cubeedit_getdata_parse_and_check(comm,line,userspace,user,error)
    !-------------------------------------------------------------------
    ! Parse for the data options, and return flag indicating if
    ! something relevant here is to be done
    !-------------------------------------------------------------------
    class(getdata_comm_t),  intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(userspace_user_t), target        :: userspace
    type(getdata_user_t),   intent(out)   :: user
    logical,                intent(inout) :: error
    !
    call cubetools_userspace_array_update(imaglist,error)
    if (error) return
    call cubetools_userspace_array_update(speclist,error)
    if (error) return
    call cubetools_userspace_array_update(cubelist,error)
    if (error) return
    call cubeedit_getdata_parse(comm,line,user,error)
    if (error) return
    user%do = .not.user%show
    user%uservar => userspace
  end subroutine cubeedit_getdata_parse_and_check
  !
  subroutine cubeedit_getdata_parse(comm,line,user,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(getdata_comm_t),  intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(getdata_user_t),   intent(out)   :: user
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nopt,iwhich
    character(len=*), parameter :: rname='GETDATA>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    nopt = 0
    do iwhich=1, nwhich
       call comm%which(iwhich)%parse(line,user%which(iwhich),error)
       if (error) return
       if (user%which(iwhich)%do) nopt = nopt+1 
    enddo
    ! /ENTRY
    call comm%entry%parse(line,user%entry,error)
    if (error) return
    if (user%entry%do) nopt = nopt+1 
    ! /PIXEL
    call comm%pixel%parse(line,user%pixel,error)
    if (error) return
    if (user%pixel%present) nopt = nopt+1 
    ! /CHANNEL
    call comm%channel%parse(line,user%channel,error)
    if (error) return
    if (user%channel%do) nopt = nopt+1
    ! /CUBE
    call comm%cube%parse(line,user%cube,error)
    if (error) return
    if (user%cube%do) nopt = nopt+1 
    !
    if (nopt.eq.0) then
       user%show = .true.
       return
    else if (nopt.ge.2) then
       call cubeedit_message(seve%e,rname,'Data related options are mutually exclusive')
       error = .true.
       return
    else
      user%show = .false.
    endif
  end subroutine cubeedit_getdata_parse
  !
  subroutine cubeedit_getdata_command(comm,user,cube,defname,dohead,ie,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(getdata_comm_t),  intent(in)    :: comm
    type(getdata_user_t),   intent(in)    :: user
    type(cube_t),target,    intent(in)    :: cube
    character(len=*),       intent(in)    :: defname
    logical,                intent(in)    :: dohead
    integer(kind=entr_k),   intent(inout) :: ie
    logical,                intent(inout) :: error
    !
    type(getdata_prog_t) :: prog
    character(len=*), parameter :: rname='GETDATA>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    prog%cube => cube
    call cubeedit_getdata_user2prog(comm,user,defname,dohead,ie,prog,error)
    if (error) return
    call cubeedit_getdata_act(prog,error)
    if (error) return
  end subroutine cubeedit_getdata_command
  !
  subroutine cubeedit_getdata_user2prog(comm,user,defname,dohead,ie,prog,error)
    use cubeadm_get
    use cubetools_userstruct
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(getdata_comm_t),  intent(in)    :: comm
    type(getdata_user_t),   intent(in)    :: user
    character(len=*),       intent(in)    :: defname
    logical,                intent(in)    :: dohead
    integer(kind=entr_k),   intent(inout) :: ie
    type(getdata_prog_t),   intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: iwhich
    character(len=varn_l) :: varname
    type(spapos_prog_t) :: pixel
    type(spechannel_prog_t) :: channel
    type(userstruct_t) :: parent
    logical, parameter :: local=.false., overwrite = .true.
    character(len=*), parameter :: rname='GETDATA>USER2PROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    ! 1) Guess the access mode
    if (comm%fixed) then
       prog%doaccess = prog%cube%order()
       if (user%pixel%present .and. prog%doaccess.eq.code_access_imaset) then
          call cubeedit_message(seve%e,rname,'Cannot get a pixel from a cube that is accessed by images')
          error = .true.
          return
       endif
       if (user%channel%do .and. prog%doaccess.eq.code_access_speset) then
          call cubeedit_message(seve%e,rname,'Cannot get a channel from a cube that is accessed by spectra')
          error = .true.
          return
       endif
    else
       if (user%entry%do) then
          call comm%entry%user2prog(user%entry,prog%doaccess,error)
          if (error) return
       else if (user%channel%do) then
          prog%doaccess = code_access_imaset
       else if (user%pixel%present) then
          prog%doaccess = code_access_speset
       else if (user%cube%do) then
          prog%doaccess = code_access_fullset
       else
          do iwhich=1,nwhich
             if (.not.user%which(iwhich)%do)  cycle
             call comm%which(iwhich)%user2prog(user%which(iwhich),prog%doaccess,error)
             if (error) return
          enddo
       endif
    endif
    !
    ! 2) Re-access cube with the proper access. Do not insert it in the parents list,
    !    otherwise this would "finish" the cube buffer which is currently opened (by
    !    OPEN).
    call cubeadm_access_header(prog%cube,prog%doaccess,code_read,error,opened=.false.)
    if (error) return
    !
    ! 3) Get/Set the output variable
    select case (prog%doaccess)
    case (code_access_imaset)
       varname = 'image'
    case (code_access_speset)
       varname = 'spectrum'
    case (code_access_fullset)
       varname = 'cube'
    end select
    if (dohead) then ! If also doing header, always a sub structure
       if (user%uservar%do) then
          call cubetools_userspace_get(user%uservar%name,parent,error)
          if (error) return
       else
          call cubetools_userspace_get(defname,parent,error)
          if (error) return
       endif
       call parent%create_member(varname,prog%uservar,error)
       if (error) return
    else
       if (user%uservar%do) then
          call comm%into%user2prog(user%uservar,prog%uservar,error)
          if (error) return
       else
          call parent%create(defname,local,overwrite_user,error)
          if (error) return
          call parent%create_member(varname,prog%uservar,error)
          if (error) return
       endif
    endif
    !
    ! 4) Get a/the buffer associated to the cube
    call cubeedit_getdata_buffer(prog,error)
    if (error) return
    !
    ! 5) Compute which entry is to be fetched
    if (user%entry%do) then
       prog%ie = user%entry%ientry
    else if (user%channel%do) then
       call user%channel%toprog(comm%channel,prog%cube,channel,error)
       if (error) return
       prog%ie = channel%ic
    else if (user%pixel%present) then
       call user%pixel%toprog(prog%cube,pixel,error)
       if (error) return
       prog%ie = pixel%nearest_entry()
    else if (user%cube%do) then
       prog%ie = 1
    else
       do iwhich=1,nwhich
          if (.not.user%which(iwhich)%do)  cycle
          select case (iwhich)
          case (izero)
             prog%ie = 0
          case (ifirst)
             prog%ie = 1
          case (ilast)
             prog%ie = prog%cube%nentry()
          case (inext)
             if (ie.eq.entr_unk) then
                prog%ie = prog%ie+1
             else
                prog%ie = ie+1
             endif
          case (iprevious)
             if (ie.eq.entr_unk) then
                prog%ie = prog%ie-1
             else
                prog%ie = ie-1
             endif
          case (iafter)
             prog%ie = prog%cube%nentry()+1
          case (icurrent)
             if (ie.eq.entr_unk) then
                prog%ie = prog%ie
             else
                prog%ie = ie
             endif
          end select
       enddo
    endif
    !
    if (prog%ie.lt.1 .or. prog%ie.gt.prog%cube%nentry()) then
      ! Not an error: we might want to iterate beyond limits, and
      ! return empty data. Should we raise a warning or not is unclear.
      ! write(mess,'(3(A,I0))')  'Trying to fetch entry #',prog%ie,  &
      !  ' while entry range is ',1,'-',prog%cube%nentry()
      ! call cubeedit_message(seve%w,rname,mess)
      prog%get = .false.
    else
      prog%get = .true.
    endif
    ie = prog%ie
  end subroutine cubeedit_getdata_user2prog
  !
  subroutine cubeedit_getdata_act(prog,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(getdata_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='GETDATA>ACT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    select case (prog%doaccess)
    case (code_access_imaset)
       if (prog%cube%iscplx()) then
          call cubeedit_getdata_act_image_cplx(prog,error)
          if (error) return
       else
          call cubeedit_getdata_act_image_real(prog,error)
          if (error) return
       endif
    case (code_access_speset)
       if (prog%cube%iscplx()) then
          call cubeedit_message(seve%e,rname,'Getting complex spectra is unsupported')
          error = .true.
          return
!!$          call cubeedit_getdata_act_spectrum_cplx(prog,error)
!!$          if (error) return
       else
          call cubeedit_getdata_act_spectrum_real(prog,error)
          if (error) return
       endif
    case (code_access_fullset)
       if (prog%cube%iscplx()) then
          call cubeedit_message(seve%e,rname,'Getting complex cubes is not implemented')
          error = .true.
          return
       else
          call cubeedit_getdata_act_cube_real(prog,error)
          if (error) return
       endif
    end select
  end subroutine cubeedit_getdata_act
  !
  subroutine cubeedit_getdata_act_image_real(prog,error)
    use cubetools_nan
    use cubeadm_ioloop
    use cubeadm_image_types
    use cubeadm_taskloop
    use cubeset_plot_tool
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(getdata_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(image_t) :: locima
    type(getdata_buffer_t), pointer :: buffer
    character(len=*), parameter :: rname='GETDATA>ACT>IMAGE>REAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%get) then
       call locima%associate('real locima',prog%cube,error)
       if (error) return
       call cubeadm_io_iterate(prog%ie,prog%ie,prog%cube,error)
       if (error) return
       call locima%get(prog%ie,error)
       if (error) return
    else
       call locima%allocate('real locima',prog%cube,error)
       if (error) return
       call locima%set(gr4nan,error)
       if (error) return
    endif
    call plot%put_image_into_rg(prog%cube%head,locima%val,error)
    if (error) return
    call prog%uservar%set(locima%val,error)
    if (error) return
    !
    buffer => getdata_buffer_ptr(imaglist%list(prog%ibuffer)%p,error)
    if (error)  return
    buffer%ie          = prog%ie
    buffer%status      = code_defined
    buffer%id          = prog%cube%node%id
    buffer%userspace_t = prog%uservar%userspace_t
  end subroutine cubeedit_getdata_act_image_real
  !
  subroutine cubeedit_getdata_act_image_cplx(prog,error)
    use gkernel_interfaces
    use cubetools_nan
    use cubeadm_ioloop
    use cubeadm_visi_types
    use cubeadm_taskloop
    use cubeset_plot_tool
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(getdata_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(visi_t) :: locima
    integer(kind=4) :: ier
    real(kind=sign_k),allocatable :: modulus(:,:)
    type(getdata_buffer_t), pointer :: buffer
    character(len=*), parameter :: rname='GETDATA>ACT>IMAGE>CPLX'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%get) then
       call locima%associate('cplx locima',prog%cube,error)
       if (error) return
       call cubeadm_io_iterate(prog%ie,prog%ie,prog%cube,error)
       if (error) return
       call locima%get(prog%ie,error)
       if (error) return
    else
       call locima%allocate('cplx locima',prog%cube,error)
       if (error) return
       call locima%set(gc4nan,error)
       if (error) return
    endif
    allocate(modulus(locima%nx,locima%ny),stat=ier)
    if (failed_allocate(rname,'modulus',ier,error)) return
    modulus(:,:) = sqrt(real(locima%val(:,:))**2+aimag(locima%val(:,:))**2)
    call plot%put_image_into_rg(prog%cube%head,modulus,error)
    if (error) return
    call prog%uservar%set(locima%val,error)
    if (error) return
    !
    buffer => getdata_buffer_ptr(imaglist%list(prog%ibuffer)%p,error)
    if (error)  return
    buffer%ie          = prog%ie
    buffer%status      = code_defined
    buffer%id          = prog%cube%node%id
    buffer%userspace_t = prog%uservar%userspace_t
  end subroutine cubeedit_getdata_act_image_cplx
  !
  subroutine cubeedit_getdata_act_spectrum_real(prog,error)
    use cubetools_nan
    use cubeadm_ioloop
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    use cubeset_plot_tool
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(getdata_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(spectrum_t) :: spe
    type(getdata_buffer_t), pointer :: buffer
    character(len=*), parameter :: rname='GETDATA>ACT>SPECTRUM>REAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%get) then
       call spe%associate('spe',prog%cube,error)
       if (error) return
       call cubeadm_io_iterate(prog%ie,prog%ie,prog%cube,error)
       if (error) return
       call spe%get(prog%ie,error)
       if (error) return
    else
       call spe%allocate('spe',prog%cube,error)
       if (error) return
       call spe%y%set(gr4nan,error)
       if (error) return
    endif
    call plot%put_spectrum_into_xy(prog%cube%head,spe%y%val,error)
    if (error) return
    call prog%uservar%set(spe%y%val,error)
    if (error) return
    !
    buffer => getdata_buffer_ptr(speclist%list(prog%ibuffer)%p,error)
    if (error)  return
    buffer%ie          = prog%ie
    buffer%status      = code_defined
    buffer%id          = prog%cube%node%id
    buffer%userspace_t = prog%uservar%userspace_t
  end subroutine cubeedit_getdata_act_spectrum_real
  !
!!$  subroutine cubeedit_getdata_act_spectrum_cplx(prog,error)
!!$    use gkernel_interfaces
!!$    use cubeadm_ioloop
!!$    use cubemain_spectrum_cplx
!!$    !------------------------------------------------------------------------
!!$    !
!!$    !------------------------------------------------------------------------
!!$    type(getdata_prog_t), intent(inout) :: prog
!!$    logical,              intent(inout) :: error
!!$    !
!!$    type(spectrum_cplx_t) :: locspe
!!$    integer(kind=4) :: ier
!!$    real(kind=4), allocatable :: modulus(:)
!!$    type(getdata_buffer_t), pointer :: buffer
!!$    character(len=*), parameter :: rname='GETDATA>ACT>SPECTRUM>CPLX'
!!$    !
!!$    call cubeedit_message(edseve%trace,rname,'Welcome')
!!$    !
!!$    if (prog%get) then
!!$       call locspe%reassociate_and_init(prog%cube,error)
!!$       if (error) return
!!$       call cubeadm_io_iterate(prog%ie,prog%ie,prog%cube,error)
!!$       if (error) return
!!$       call locspe%get(prog%cube,prog%ie,error)
!!$       if (error) return
!!$    else
!!$       call locspe%reallocate_and_init(prog%cube,error)
!!$       if (error) return
!!$    endif
!!$    allocate(modulus(locspe%m),stat=ier)
!!$    if (failed_allocate(rname,'modulus',ier,error)) return
!!$    modulus(:) = sqrt(real(locspe%t(:))**2+aimag(locspe%t(:))**2)
!!$    call plot%put_spectrum_into_xy(prog%cube%head,modulus,error)
!!$    if (error) return
!!$    call prog%uservar%set(locspe%t,error)
!!$    if (error) return
!!$    !
!!$    buffer => getdata_buffer_ptr(speclist%list(prog%ibuffer)%p,error)
!!$    if (error)  return
!!$    buffer%ie          = prog%ie
!!$    buffer%status      = code_defined
!!$    buffer%id          = prog%cube%node%id
!!$    buffer%userspace_t = prog%uservar%userspace_t
!!$  end subroutine cubeedit_getdata_act_spectrum_cplx
  !
  subroutine cubeedit_getdata_act_cube_real(prog,error)
    use cubeadm_opened
    use cubeadm_subcube_types
    use cubeadm_image_types
    use cubeset_plot_tool
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(getdata_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(subcube_t) :: subcube
    type(cubeadm_iterator_t) :: iter
    logical :: ier
    type(getdata_buffer_t), pointer :: buffer
    character(len=*), parameter :: rname='GETDATA>ACT>CUBE>REAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%get) then
       ! Prepare an iterator to iterate everything at once, as prog%cube was opened
       ! with code_access_fullset. Note that this mode enforces the load of the
       ! full cube in memory, independently of the SET\BUFFERING /INPUT mode.
       call cubeadm_datainit_all(iter,error)
       if (error)  return
       ! This should have set up a unique iteration, and a unique subcube entry
       ! in this iteration.
       ! Iterate the iterator to its unique iteration (in particular, ensure that
       ! the whole cube is loaded in memory).
       ier = cubeadm_dataiterate_all(iter,error)
       if (error)  return
       ! Iterate the unique subcube entry in this unique iteration, so that we
       ! can get it hereafter.
       ier = iter%iterate_entry(error)
       if (error)  return
       ! The subcube is prepared to point to the full cube (associate mode).
       ! This avoids duplicating the data, and this is possible because of
       ! the forced memory mode above.
       call subcube%associate('real subcube',prog%cube,iter,error)
       if (error) return
       call subcube%get(error)
       if (error) return
       ! Also load the 1st plane into the RG buffer (for at least the
       ! WCS description).
       if (prog%cube%order().eq.code_cube_imaset) then
         ! This only makes sense if the cube is image-ordered
         call plot%put_image_into_rg(prog%cube%head,subcube%val(:,:,1),error)
         if (error) return
       endif
    else
       call cubeedit_message(seve%e,rname,'Not implemented')
       error = .true.
       return
    endif
    ! Create the /INTO variable. Note that this duplicates the data, on purpose,
    ! as the original data can be destroyed at any time (in this case, the full
    ! cube might be destroyed or garbage-collected from memory).
    call prog%uservar%set(subcube%val,error)
    if (error) return
    !
    buffer => getdata_buffer_ptr(cubelist%list(prog%ibuffer)%p,error)
    if (error)  return
    buffer%ie          = 0  ! No sense for full cubes
    buffer%status      = code_defined
    buffer%id          = prog%cube%node%id
    buffer%userspace_t = prog%uservar%userspace_t
  end subroutine cubeedit_getdata_act_cube_real
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_getdata_list_buffers(comm,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(getdata_comm_t), intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='GETDATA>LIST>BUFFERS'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    write(mess,'(a,i0)') 'Loaded Image buffers: ',imaglist%n
    call cubeedit_message(seve%r,rname,mess)
    call cubeedit_getdata_list_buffer(imaglist)
    !
    write(mess,'(a,i0)') 'Loaded Spectrum buffers: ',speclist%n
    call cubeedit_message(seve%r,rname,mess)
    call cubeedit_getdata_list_buffer(speclist)
    !
    write(mess,'(a,i0)') 'Loaded Cube buffers: ',cubelist%n
    call cubeedit_message(seve%r,rname,mess)
    call cubeedit_getdata_list_buffer(cubelist)
  end subroutine cubeedit_getdata_list_buffers
  !
  subroutine cubeedit_getdata_list_buffer(arr)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(list_t), intent(in) :: arr
    !
    integer(kind=4) :: ibuffer
    class(list_object_t), pointer :: buffer
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='GETDATA>LIST>BUFFER'
    !
    do ibuffer=1,arr%n
      buffer => arr%list(ibuffer)%p
      select type (buffer)
      type is (getdata_buffer_t)
        write(mess,1001) ibuffer,' => CUBE id: ',buffer%id,  &
            ', entry: ',buffer%ie, &
            ', SIC variable: ',trim(buffer%name)
      class is (userspace_t)
        write(mess,1002) ibuffer,' => CUBE id: ','TBD',  &
            ', entry: ','TBD', &
            ', SIC variable: ',trim(buffer%name)
      class default
        write(mess,1002) ibuffer,' => CUBE id: ','TBD',  &
            ', entry: ','TBD', &
            ', SIC variable: ','TBD'
      end select
      call cubeedit_message(seve%r,rname,mess)
    enddo
    call cubeedit_message(seve%r,rname,'')
    !
1001 format(2x,i2,a,i4,a,i7,2a)
1002 format(2x,i2,a,a4,a,a7,2a)
  end subroutine cubeedit_getdata_list_buffer
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_getdata_buffer(prog,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(getdata_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    select case (prog%doaccess)
    case (code_access_imaset)
      call cubeedit_getdata_buffer_from(prog,imaglist,error)
      if (error) return
    case (code_access_speset)
      call cubeedit_getdata_buffer_from(prog,speclist,error)
      if (error) return
    case (code_access_fullset)
      call cubeedit_getdata_buffer_from(prog,cubelist,error)
      if (error) return
    end select
  end subroutine cubeedit_getdata_buffer
  !
  subroutine cubeedit_getdata_buffer_from(prog,array,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(getdata_prog_t), intent(inout) :: prog
    type(list_t),         intent(inout) :: array
    logical,              intent(inout) :: error
    !
    type(getdata_buffer_t), pointer :: buffer
    type(getdata_buffer_t) :: template
    class(list_object_t), pointer :: lot
    logical :: samevar, samecube
    integer(kind=list_k) :: ibuffer
    character(len=*), parameter :: rname='GETDATA>BUFFER>FROM'
    !
    ! Find if refering to a previously defined buffer
    do ibuffer=1,array%n
      buffer => getdata_buffer_ptr(array%list(ibuffer)%p,error)
      if (error)  return
      samecube = prog%cube%node%id.eq.buffer%id
      samevar  = prog%uservar%name.eq.buffer%name
      if (samecube.and.samevar) then
        prog%ibuffer = ibuffer
        prog%ie      = buffer%ie
        return
      endif
    enddo
    !
    ! No previous buffer found, insert new one
    call array%allocate(template,lot,error)
    if (error)  return
    buffer => getdata_buffer_ptr(lot,error)
    if (error)  return
    buffer%ie = 0  ! GET NEXT gets FIRST
    ! buffer%... => other elements updated later
    ! Save instance in prog structure
    prog%ibuffer = array%n
    prog%ie      = 0
  end subroutine cubeedit_getdata_buffer_from
  !
  function getdata_buffer_ptr(buffer,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(getdata_buffer_t), and return
    ! a pointer to it if yes.
    !-------------------------------------------------------------------
    type(getdata_buffer_t), pointer :: getdata_buffer_ptr  ! Function value on return
    class(list_object_t),   pointer       :: buffer
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GETDATA>BUFFER>PTR'
    !
    select type(buffer)
    type is (getdata_buffer_t)
      getdata_buffer_ptr => buffer
    class default
      getdata_buffer_ptr => null()
      call cubeedit_message(seve%e,rname,  &
        'Internal error: object is not a getdata_buffer_t type')
      error = .true.
      return
    end select
  end function getdata_buffer_ptr
end module cubeedit_getdata
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mrtcal_setup_types
  use phys_const
  use ram_sizes
  use chopper_definitions
  !
  integer(kind=4), parameter :: mdatamodes=3
  integer(kind=4), parameter :: datamode_none=1
  integer(kind=4), parameter :: datamode_ontrack=2
  integer(kind=4), parameter :: datamode_all=3
  character(len=8) :: datamodes(mdatamodes) =  &
    (/ 'NONE    ','ONTRACK ','ALL     ' /)
  !
  integer(kind=4), parameter :: minterpmodes=3
  integer(kind=4), parameter :: interp_nearest=1
  integer(kind=4), parameter :: interp_linear=2
  integer(kind=4), parameter :: interp_spline=3
  character(len=11), parameter :: interpmodes(minterpmodes) =  &
       (/ 'NEAREST    ','LINEAR     ','SPLINE     ' /)
  !
  integer(kind=4), parameter :: maccmodes=4
  integer(kind=4), parameter :: accmode_unkn=0
  integer(kind=4), parameter :: accmode_defa=1  ! Default (best depending on context)
  integer(kind=4), parameter :: accmode_cycl=2  ! Phase cycle or subscan cycle (depending on context)
  integer(kind=4), parameter :: accmode_subs=3
  integer(kind=4), parameter :: accmode_scan=4
  character(len=8), parameter :: accmodes(maccmodes) = &
       (/ '*       ','CYCLE   ','SUBSCAN ','SCAN    ' /)
  !
  integer(kind=4), parameter :: mfeedbacks=3
  integer(kind=4), parameter :: feedback_pix=1
  integer(kind=4), parameter :: feedback_set=2
  integer(kind=4), parameter :: feedback_elt=3
  character(len=12), parameter :: feedbacks(mfeedbacks) = &
       (/ 'PIXEL       ','SET         ','ELEMENT     ' /)
  !
  integer(kind=4), parameter :: mmixmode_pointing=6
  integer(kind=4), parameter :: mixmode_entry=1
  integer(kind=4), parameter :: mixmode_drift=2
  integer(kind=4), parameter :: mixmode_fesbdrift=3
  integer(kind=4), parameter :: mixmode_fesbdirec=4
  integer(kind=4), parameter :: mixmode_fedrift=5
  integer(kind=4), parameter :: mixmode_fedirec=6
  character(len=12), parameter :: mixmodes(mmixmode_pointing) = &
       (/ 'ENTRY    ','DRIFT    ','FESBDRIFT',  &
          'FESBDIREC','FEDRIFT  ','FEDIREC  ' /)
  !
  integer(kind=4), parameter :: moutputcalib=3
  integer(kind=4), parameter :: outputcalib_none=1
  integer(kind=4), parameter :: outputcalib_spec=2
  integer(kind=4), parameter :: outputcalib_asso=3
  character(len=12), parameter :: outputcalibs(moutputcalib) = &
    (/ 'NONE        ','SPECTRA     ','ASSOCIATED  ' /)
  !
  type mrtcal_setup_input_t
    logical         :: bad = .true.             ! [----] Read or not the bad dumps from the backendXXX tables?
    integer(kind=4) :: data = datamode_ontrack  ! [code] Read on-track part of the DATA column?
    logical         :: mjdinter = .false.       ! [----] Intersect or not the DATE-OBS and DATE-END with the MJD colums
    logical         :: tochunk = .true.         ! [----] Map the DATA to chunks at read time
  end type mrtcal_setup_input_t
  type mrtcal_setup_calib_t
    logical         :: bad = .false.                ! [----] Read or not the bad dumps from the backendXXX tables?
    real(kind=4)    :: bandwidth = 20.0             ! [ MHz] Desired calibration bandwidth
    logical         :: chopperstrict = .true.       ! [----] Shall telcal_chopper work in strict or tolerant mode?
    integer(kind=4) :: feedback = feedback_set      ! [code] Feedback level for calibration results
    real(kind=4)    :: winterval = 20.0             ! [ min] Time interval for searching nearest calibration scan (warning)
    real(kind=4)    :: einterval = 30.0             ! [ min] Time interval for searching nearest calibration scan (error)
    integer(kind=4) :: interpscan = interp_nearest  ! [code] Shall MRTCAL interpolate the surrounding calibration scans?
    integer(kind=4) :: interpoff = interp_linear    ! [code] Shall MRTCAL interpolate the calibration Tsys with time between two calibrations? *** JP This default should depend on the observing mode
    real(kind=8)    :: antslowmjdshift = 0.d0       ! [sec ] Shift the antenna slow traces?
    logical         :: mjdinter = .false.           ! [----] Intersect or not the DATE-OBS and DATE-END with the MJD colums
    integer(kind=4) :: interpprod = interp_linear   ! [code] Trec, Tcal, Tsys, Ztau frequency interpolation mode
    real(kind=4)    :: match=4e-2*rad_per_sec       ! [ rad] Matching tolerance for subscan position
    integer(kind=4) :: watermode=chopper_water_elem ! [code] Chopper mode for searching water
    real(kind=4)    :: watervalue=0.                ! [  mm] PWV if water mode is fixed
  end type mrtcal_setup_calib_t
  type mrtcal_setup_solve_t
    integer(kind=4) :: poimix = mixmode_fesbdirec  ! [code] How pointings are mixed before solving?
  end type mrtcal_setup_solve_t
  type mrtcal_setup_output_t
    integer(kind=4) :: accmode = accmode_defa      ! [code] On which periodicity MRTCAL shall accumulate data?
    integer(kind=4) :: calib   = outputcalib_asso  ! [code] How calibration products are written
    logical         :: bychunk    = .false.        ! [----] Shall MRTCAL stitched chunks before writing them as CLASS observations?
    logical         :: fold       = .true.         ! [----] Shall MRTCAL fold the FSW spectra?
    logical         :: restable   = .false.        ! [----] Create an ASCII table of results in current dir?
    logical         :: toclass    = .true.         ! [----] Shall MRTCAL write CLASS observations?
    logical         :: vdirection = .false.        ! [----] Apply MODIFY VDIRECTION before writing to Class?
    logical         :: voxml      = .false.        ! [----] Write VO XML calibration results?
    character(len=256) :: vodir   = '.'            ! [----] VO XML output directory
    logical         :: weight     = .false.        ! [----] Write the W Associated Array together with RY?
    logical         :: user       = .false.        ! [----] Shall MRTCAL write the User section in CLASS observations?
  end type mrtcal_setup_output_t
  type :: mrtcal_setup_t
    type(mrtcal_setup_input_t)  :: inp           ! READ tunings
    type(mrtcal_setup_calib_t)  :: cal           ! CALIBRATE or PIPELINE tunings
    type(mrtcal_setup_solve_t)  :: sol           ! SOLVE tunings
    type(mrtcal_setup_output_t) :: out           ! OUTPUT tunings
    integer(kind=8) :: bufsize   = 512*MB        ! [Byte]
    logical         :: pipeline  = .true.        ! [----] Shall the CALIBRATE command stop or not if an error occur?
  end type mrtcal_setup_t
end module mrtcal_setup_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! *** JP: These types are obsolescent. Please use the one in
! *** JP: adm/type-spectral-range.f90 when possible.
!
! window_scalar_t and window_array_t are the user types corresponding to
! the range_scalar_t and range_array_t prog types in the
! main/type-spectral-range-obsolescent.f90 file.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_windowing_types
  use cubetools_parameters
  use cubetools_header_types
  use cubeadm_messaging
  !
  public :: window_scalar_t,window_array_t
  private
  !
  type window_scalar_t
     integer(kind=chan_k) :: nc   = 1   ! [none] Number of channels inside window
     integer(kind=chan_k) :: o(2) = 1   ! [none] Channels sorted by increasing value
     integer(kind=chan_k) :: p(2) = 1   ! [none] Channels unsorted
     type(cube_header_t), pointer :: head => null()
   contains
     procedure :: list => cubeadm_window_scalar_list
     procedure :: chan2velo => cubeadm_window_scalar_chan2velo
     procedure :: chan2freq => cubeadm_window_scalar_chan2freq
  end type window_scalar_t
  type window_array_t
     integer(kind=wind_k) :: n = 0
     type(window_scalar_t), pointer :: val(:) => null()
   contains
     procedure :: allocate => cubeadm_allocate_window_array
     final     :: cubeadm_free_window_array
  end type window_array_t
  !
contains
  !
  subroutine cubeadm_allocate_window_array(wind,nw,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(window_array_t), intent(inout) :: wind
    integer(kind=wind_k),  intent(in)    :: nw
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='ALLOCATE>WINDOW>ARRAY'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (nw.le.0) then
       call cubeadm_message(seve%e,rname,'Negative or zero number of windows')
       error = .true.
       return
    endif
    ! Allocate
    allocate(wind%val(nw),stat=ier)
    if (failed_allocate(rname,'window',ier,error)) return
    ! Allocation success => wind%n may be updated
    wind%n = nw
  end subroutine cubeadm_allocate_window_array
  !
  subroutine cubeadm_free_window_array(wind)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(window_array_t), intent(inout) :: wind
    !
    character(len=*), parameter :: rname='FREE>WINDOW>ARRAY'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    wind%n = 0
    if (associated(wind%val)) deallocate(wind%val)
  end subroutine cubeadm_free_window_array
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeadm_window_scalar_chan2velo(wind,velo,error)
    use cubetools_axis_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(window_scalar_t), intent(in)    :: wind
    real(kind=coor_k),      intent(out)   :: velo(2)
    logical,                intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    character(len=*), parameter :: rname='WINDOW>SCALAR>CHAN2VELO'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    if (.not.associated(wind%head)) then
       call cubeadm_message(seve%e,rname,'The window has no associated header')
       error = .true.
       return
    endif
    do iw=1,2
       call cubetools_axis_pixel2offset(&
            wind%head%spe%v,wind%p(iw),velo(iw),error)
       if (error) return
    enddo ! iw
  end subroutine cubeadm_window_scalar_chan2velo
  !
  subroutine cubeadm_window_scalar_chan2freq(wind,freq,error)
    use cubetools_axis_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(window_scalar_t), intent(in)    :: wind
    real(kind=coor_k),      intent(out)   :: freq(2)
    logical,                intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    character(len=*), parameter :: rname='WINDOW>SCALAR>CHAN2FREQ'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    if (.not.associated(wind%head)) then
       call cubeadm_message(seve%e,rname,'The window has no associated header')
       error = .true.
       return
    endif
    do iw=1,2
       call cubetools_axis_pixel2offset(&
            wind%head%spe%f,wind%p(iw),freq(iw),error)
       if (error) return
    enddo ! iw
  end subroutine cubeadm_window_scalar_chan2freq
  !
  subroutine cubeadm_window_scalar_list(wind,error)
    use cubetools_unit
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(window_scalar_t), intent(in)    :: wind
    logical,                intent(inout) :: error
    !
    type(unit_user_t) :: unit
    real(kind=coor_k) :: values(2)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='WINDOW>SCALAR>LIST'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    values = wind%p
    call cubetools_format_range('SPECTRAL',values,1.d0,'channel',mess,error)
    if (error) return
    call cubeadm_message(seve%r,rname,mess)
    !
    call unit%get_from_code(code_unit_velo,error)
    if (error) return
    call wind%chan2velo(values,error)
    if (error) return
    values = values*unit%user_per_prog    
    call cubetools_format_range('SPECTRAL',values,1.d0,unit%name,mess,error)
    if (error) return
    call cubeadm_message(seve%r,rname,mess)
    !
    call unit%get_from_code(code_unit_freq,error)
    if (error) return
    call wind%chan2freq(values,error)
    if (error) return
    values = values*unit%user_per_prog    
    call cubetools_format_range('SPECTRAL',values,1.d0,unit%name,mess,error)
    if (error) return
    call cubeadm_message(seve%r,rname,mess)
  end subroutine cubeadm_window_scalar_list
end module cubeadm_windowing_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_history(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Write the History  table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_History
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (HistoryRow) :: hRow
  type (HistoryKey) :: hKey
  character :: sdmTable*12, uname*80
  integer :: l, count
  data count/ 0/
  save count
  parameter (sdmTable='History')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !     (no array to allocate)
  !
  !     very much *TBD*
  !
  hKey%time = time_interval(1)
  hKey%execBlockId = execBlock_Id
  call user_info(uname)
  l = lenc(uname)
  hRow%message = uname(1:l)
  call sdmMessage(1,1,sdmTable , 'Message: '//hRow%message(1:l))
  hRow%priority = '-'
  hRow%origin = '-'
  hRow%application = 'CLIC'
  hRow%cliCommand = 'WRITE '
  hRow%appParms = '-'
  hRow%objectId = 'whateverObjectId...'
  if (count.ne.r_scan) then
    count = r_scan
    call addHistoryRow(hKey, hRow, error)
    if (error) return
  endif
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
!
end subroutine write_sdm_history
!---------------------------------------------------------------------
subroutine get_sdm_history(error)
  !---------------------------------------------------------------------
  ! Read the History table
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_History
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (HistoryRow) :: hRow
  type (HistoryKey), allocatable :: hKeyList(:)
  integer :: historySize, lenz, i, l, ier
  character*12 , parameter :: sdmTable='History'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  call getHistoryTableSize(historySize, error)
  if (error) return
  !
  if (historySize.gt.0) then
    if (allocated(hKeyList)) then
      deallocate (hKeyList, stat = ier)
      if (ier.ne.0) then
        call sdmMessageI(8,4,sdmTable, 'Deallocate error: ',ier)
        error = .true.
        return
      endif
    endif
    allocate (hKeyList(historySize), stat = ier)
    if (ier.ne.0) then
      call sdmMessageI(8,4,sdmTable, 'Allocate error: ',ier)
      error = .true.
      return
    endif
    call  getHistoryKeys(historySize, hKeyList, error)
    !
    do i=1, historySize
      if (hKeyList(i)%time.ge.time_interval(1) .and. hKeyList(i   &
        )%time.le.time_interval(1)+time_interval(2)) then
        call getHistoryRow(hKeyList(i), hRow, error)
        if (error) return
        l = lenz(hRow%Message)
        call sdmMessage(1,1,sdmTable, 'History: '//hRow%Message(1:l))
      endif
    enddo
  endif
  call sdmMessage(1,1,sdmTable ,'Read.')
!
end subroutine get_sdm_history
!---------------------------------------------------------------------

module deconv_dsb_commons
  use gildas_def
  use class_types
  !-------------------------------------------------------------------
  !
  ! Common block definitions used in XCLASS
  ! for the Maximum Entropy Method deconvolution algorithm.
  !
  ! hogm stands for High Order Gain Modification: done by PH while
  ! visiting Bonn 05/2009
  !
  !-------------------------------------------------------------------
  !
  ! Related to DSB spectra.
  type(header)    :: dsb_head      ! Header of one DSB spectra
  integer(kind=4) :: dsb_system    ! Coordinate system - DSB header - CC 4.7.2013
  real(kind=8)    :: dsb_time      ! Integration time from first DSB scan - CC 4.7.2013
  integer(kind=4) :: dsb_counter   ! Effective number of DSB spectra
  integer(kind=4) :: dsb_size      ! Logical size of DSB array, in channels
  real(kind=8)    :: sigma_weight  !
  integer(kind=4), allocatable, dimension(:) :: single_size ! Logical size of single DSB spectra
  real(kind=8),    allocatable, dimension(:) :: dsb_weight  ! Weight for each spectrum (time/tsys^2)
  integer(kind=4), allocatable, dimension(:) :: dsb_pointer ! Array pointing to index of spectrum for each channel
  logical         :: hifi          !
  !
  !
  ! To each DSB channel i correspond two original SSB frequencies:
  ! dsb_signal(i) (for the upper side band) and dsb_image(i) (for the
  ! lower side band).
  real(kind=4), allocatable, dimension(:) :: dsb_signal   ! Linear array of ALL DSB spectra; rest freq information
  real(kind=4), allocatable, dimension(:) :: dsb_image    ! Linear array of ALL DSB spectra; image freq information
  real(kind=4), allocatable, dimension(:) :: dsb_spectrum ! Linear array of ALL DSB spectra; power information
  real(kind=8), allocatable, dimension(:) :: ddsb_spectrum! Double precision array
  !
  ! Related to final SSB spectrum
  integer(kind=4)            :: ssb_size       ! Size of SSB array, in channels.
  real(kind=4)               :: ssb_voff       ! [km/s] Velocity at reference channel
  integer(kind=4), parameter :: max_og=100     ! Maximum order of the gain
  integer(kind=4)            :: o_gain         ! Effective order of the gain
  logical                    :: variable_gain  ! 2 options: variable gain through the IF / piecewise constant gain
  ! assumption is zeroth order signal gain, zeroth order image gain, first order signal gain,....
  real(kind=4), allocatable, dimension(:) :: gain ! Vector containing Signal (USB) and Image (LSB) gains
  ! Need to store these quantities to calculate the position in the IF
  real(kind=4),    allocatable, dimension(:) :: dsb_Rrestf
  real(kind=4),    allocatable, dimension(:) :: dsb_Rimage
  integer(kind=4), allocatable, dimension(:) :: dsb_Rrchan
  integer(kind=4), allocatable, dimension(:) :: dsb_Cnchan
  !
  ! Standing waves before mixing for SSB.
  ! one_out_of_f : Used with psw_bm in order to have a parameter close to 1
  !                during the deconvolution. The derivative of
  !                the chisquare in regard with the pulsation causes the SSB
  !                frequency to get out of the sin(). Because the SSB
  !                frequencies are relatively high (something like 10^6),
  !                this contribution to the derivative is too high and
  !                the algorithm fails. In order to have something close to
  !                1 getting out of the sin(), we choosed to introduce a
  !                constant which will get out the sin() in the same time
  !                that SSB frequency and which has a value compensating
  !                the SSB frequency : 1 / mean(SSB frequency).
  !                So, instead of having d(sin(wf))/dw = f.sin(wf),
  !                we'll have d(sin(w0fF))/dw0 = fF.sin(w0fF), and fF is
  !                close to 1 because F = 1/mean(f).
  !                You can see that w0 = w / F. It is that w0 we call
  !                psw_bm.
  real(kind=4) :: one_out_of_f
  real(kind=4), allocatable, dimension(:,:) :: asw_bm  ! amplitude.
  real(kind=4), allocatable, dimension(:,:) :: psw_bm  ! pulsation / one_out_of_f.
  real(kind=4), allocatable, dimension(:,:) :: phsw_bm ! phase.
  !
  ! Theoretically, ssb_freq(i) = ssb_first+(i-1)*ssb_width.
  real(kind=4) :: ssb_first  ! Frequency of first channel for SSB array.
  real(kind=4) :: ssb_width  ! Frequency width of SSB array - should be equal to dsb_width.
  !
  integer(kind=4), parameter :: max_model_lines=3000
  ! Assumption is zeroth order signal gain, zeroth order image gain, first order signal gain,....
  real(kind=4)                            :: sum_model      ! Sum of ssb_model(i)
  character(len=filename_length)          :: ssb_model_file !
  real(kind=4)                            :: cont_offset    ! Continuum offset needed for model, to prevent argument < 0 in the entropy calculation
  real(kind=4), allocatable, dimension(:) :: gain_model
  real(kind=4), allocatable, dimension(:) :: gain_model_input
  real(kind=8), allocatable, dimension(:) :: norm_gain_model
  real(kind=4), allocatable, dimension(:) :: ssb_spectrum   ! final ssb spectrum, spectral power information.
  real(kind=4), allocatable, dimension(:) :: ssb_freq       ! SSB frequency scale (for checks).
  real(kind=4), allocatable, dimension(:) :: ssb_model      ! Model of SSB_DAT, also first guess
  real(kind=8), allocatable, dimension(:) :: norm_ssb_model ! ssb_model / sum_model
  !
  ! Standing waves before mixing.
  logical :: no_bmswA,no_bmswP,no_bmswPh
  integer(kind=4) :: n_sw_bm                  ! Effective number of standing waves.
  integer(kind=4), parameter :: n_sw_bm_max=8 ! Maximum number of standing waves.
  integer(kind=4), parameter :: maxchi=3
  real(kind=4), allocatable, dimension(:,:)  :: asw_bm_model       ! model's swbm amplitude.
  real(kind=4), allocatable, dimension(:,:)  :: psw_bm_model       ! model's swbm pulsation.
  real(kind=4), allocatable, dimension(:,:)  :: phsw_bm_model      ! model's swbm phase.
  real(kind=8), allocatable, dimension(:,:)  :: norm_asw_bm_model  !
  real(kind=8), allocatable, dimension(:,:)  :: norm_psw_bm_model  !
  real(kind=8), allocatable, dimension(:,:)  :: norm_phsw_bm_model !
  !
  ! Frequency switch.
  logical :: freq_switch
  integer(kind=4), allocatable, dimension(:,:) :: chan_throw  ! modified to accomodate variable frequency throw (HIFI) - CC Jul2011
  real(kind=4),    allocatable, dimension(:,:) :: freq_throw  ! modified to accomodate variable frequency throw (HIFI) - CC Jul2011
  real(kind=4),    allocatable, dimension(:,:) :: throw_poids ! modified to accomodate variable "poids" (HIFI), needed?? - CC Jul2011
  !
  ! Related to the function to minimize
  ! Minimize Chi^2 - lambda1 * entrop_ssb
  !                - lambda2 * entrop_gain
  !                - lambda3 * entrop_sw
  real(kind=8) :: lambda1  ! SSB entropy weight in the function to minimize
  real(kind=8) :: lambda2  ! Gain entropy weight in the function to minimize
  real(kind=8) :: lambda3  ! Standing waves entropy weight in the function to minimize
  !
  ! Related to deconvolution behaviour.
  logical :: no_channels ! Do not try to fit channels during deconvolution
! logical :: no_gain     ! Do not try to fit sideband gains during deconvolution
  logical :: fit_gains   ! Fit sideband gains during deconvolution           !! CC 19.6.2013 no_gain is now default
                                                                             !! removed /NOGAIN option
                                                                             !! replaced with /GAIN [firstGuess]
  logical :: use_deriv   ! Use derivatives in the linear minimization
  logical :: debug=.false.
  !
  ! Miscealeneous.
  integer(kind=4) :: n_lws
  real(kind=4)    :: lws_resolution
  real(kind=4)    :: big_F
  real(kind=4)    :: small_f
  real(kind=4)    :: delta_angle
  real(kind=4)    :: airy_width
  real(kind=4)    :: gap
  real(kind=4)    :: lambda0
  real(kind=4)    :: lambda
  !
end module deconv_dsb_commons
!
!
module f1_commons
  integer(kind=4) :: mem_ncom
  real(kind=8), allocatable, dimension(:) :: mem_pcom
  real(kind=8), allocatable, dimension(:) :: mem_xicom
end module f1_commons
!
!
!
subroutine deconv_allocate(key,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>deconv_allocate
  use deconv_dsb_commons
  use f1_commons
  !-------------------------------------------------------------------
  ! @ private
  ! Check memory allocation for SSB, DSB, ALL arrays
  ! * Allocate non-allocated arrays
  ! * Check size of allocated arrays
  !-------------------------------------------------------------------
  character(len=*), intent(in)  :: key   ! SSB, DSB or ALL
  logical,          intent(out) :: error ! Output flag
  ! Local
  character(len=*), parameter :: rname='deconv_allocate'
  integer(kind=4) :: ier
  logical :: noalloc,ssb,dsb
  !
  error = .false.
  ssb   = key.eq.'SSB'
  dsb   = key.eq.'DSB'
  !
  ! Check if SSB or DSB arrays are already allocated
  if (ssb) then
     noalloc = .not.(allocated(ssb_spectrum))
  else if (dsb) then
     noalloc = .not.(&
          allocated(single_size).and.&
          allocated(dsb_pointer).and.&
          allocated(asw_bm))
  else ! key='ALL' : check if all arrays are allocated. If not, exit.
     error = .not.(&
          allocated(ssb_spectrum).and.&
          allocated(mem_pcom).and.&
          allocated(single_size).and.&
          allocated(dsb_pointer))
     if (error) then
        call class_message(seve%e,rname,'Arrays are not allocated. See INITIALIZE.')
        return
     endif
!!$     write(*,*) allocated(ssb_spectrum),size(ssb_spectrum)
!!$     write(*,*) allocated(dsb_spectrum),size(dsb_spectrum)
     noalloc = .false.
  endif
  !
  !
  ! Allocate memory if needed
  if (noalloc) then
     if (ssb) then
        if (ssb_size.le.0) goto 100
        allocate(&
             ssb_spectrum(ssb_size),&
             ssb_freq(ssb_size),&
             ssb_model(ssb_size),&
             norm_ssb_model(ssb_size),&
             stat=ier)
        if (failed_allocate(rname,'Global SSB arrays',ier,error)) return
     else
        if (dsb_counter.le.0.or.dsb_size.le.0) goto 100
        allocate(&
             single_size(dsb_counter),&
             dsb_weight(dsb_counter),&
             gain(2*dsb_counter*max_og),&
             gain_model(2*dsb_counter*max_og),&
             gain_model_input(2*dsb_counter*max_og),&
             norm_gain_model(2*dsb_counter*max_og),&
             chan_throw(dsb_counter,2),freq_throw(dsb_counter,2),throw_poids(dsb_counter,2),&
             dsb_pointer(dsb_size),dsb_signal(dsb_size),dsb_image(dsb_size),&
             dsb_spectrum(dsb_size),ddsb_spectrum(dsb_size),&
             dsb_rrestf(dsb_counter),dsb_rimage(dsb_counter),&
             dsb_rrchan(dsb_counter),dsb_cnchan(dsb_counter),&
             stat=ier)
        if (failed_allocate(rname,"Global DSB arrays",ier,error)) return
     endif
     call class_message(seve%i,rname,'Memory allocation successful for '//key)
  else
     ! Already allocated: check sizes
     ! If already allocated, check if of the correct size
     if (ssb.and.size(ssb_spectrum).ne.ssb_size) then
        call class_message(seve%e,rname,'New initialization needed for '//key)
        error = .true.
        return
     endif
     if (dsb.and.size(single_size).ne.dsb_counter) then
        call class_message(seve%e,rname,'New initialization needed for '//key)
        error = .true.
        return
     endif
     call class_message(seve%i,rname,'Arrays already allocated.')
  endif
  return
  !
100 call class_message(seve%e,rname,'Can not allocate negative size arrays')
  error = .true.
  return
end subroutine deconv_allocate
!
!
!
subroutine deconv_dealloc(error)
  use classcore_interfaces, except_this=>deconv_dealloc
  use deconv_dsb_commons
  use gbl_message
  use f1_commons
  !-------------------------------------------------------------------
  ! @ private
  ! Free allocated memory
  !-------------------------------------------------------------------
  logical, intent(out) :: error ! Output flag
  ! Local
  character(len=*), parameter :: rname='DECONV_DEALLOC'
  integer(kind=4) :: ier
  !
  ier = 0
  ! Spectra arrays
  if (allocated(single_size)) then
     deallocate(single_size,dsb_weight,&
          gain,gain_model,gain_model_input,norm_gain_model,&
          chan_throw,freq_throw,throw_poids,&
          stat=ier)
  endif
  if (allocated(dsb_pointer)) then
     deallocate(dsb_pointer,dsb_signal,dsb_image,dsb_spectrum,ddsb_spectrum,stat=ier)
     deallocate(dsb_rrestf,dsb_rimage,dsb_rrchan,dsb_cnchan,stat=ier)
  endif
  ! Standing wave arrays
  if (allocated(asw_bm)) then
     deallocate(asw_bm,psw_bm,phsw_bm,stat=ier)
     deallocate(asw_bm_model,psw_bm_model,phsw_bm_model,stat=ier)
     deallocate(norm_asw_bm_model,norm_psw_bm_model,norm_phsw_bm_model,stat=ier)
  endif
  ! SSB arrays
  if (allocated(ssb_spectrum)) then
     deallocate(ssb_spectrum,ssb_freq,ssb_model,norm_ssb_model,stat=ier)
  endif
  ! Minimization arrays
  if (allocated(mem_pcom)) then
     deallocate(mem_pcom,mem_xicom,stat=ier)
  endif
  !
  if (ier.ne.0) then
     call class_message(seve%e,rname,'Problem during deallocation of DECONV arrays.')
     error = .true.
  endif
end subroutine deconv_dealloc
!
!
!
!
!
subroutine deconv_init(set,line,r,error,user_function)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>deconv_init
  use class_index
  use class_types
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ public
  ! Support routine for command
  !
  ! INITIALIZE [cont_offset]
  ! 1          [/MODEL file]
  ! 2          [/SIMULATE file noise]
  ! 3          [/WEIGHT weight]
  ! 4          [/BMSW n [a p ph [...]]
  !
  ! Initializes the deconvolution process.
  !
  ! - read the DSB scans from the opened input CLASS file.
  ! - contatenate all these DSB scan into a single vector called
  !   dsb_spectrum
  ! - determine information about the output SSB from information
  !   about the DSB : number of channels,frequency resolution,min and
  !   max frequencies...
  ! - It sets up a flat null model.
  ! - Allocate global arrays
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Input command line
  type(observation),   intent(inout) :: r              !
  logical,             intent(out)   :: error          ! Error flag
  logical,             external      :: user_function  ! External function, intent(in)
  ! Local
  character(len=*), parameter :: rname='DECONV_INIT'
  type (observation) :: obs
  logical :: use_weight,use_model,use_simulate,use_bmsw
  integer(kind=4) :: i,ii,j,scan,blanked,ier,nc
  integer(kind=entry_length) :: entry_num
  real(kind=4) :: decal,weight
  real(kind=4) :: ssb_last
  real(kind=4) :: dsb_width                 ! [ MHz] maximum DSB frequency resolution
  !?????? PH: problem with this when channel width is not an integer
  !  integer :: image_first,image_last,signal_first,signal_last ! In MHz.
  real(kind=4) :: image_first,image_last    ! [ MHz]
  real(kind=4) :: signal_first,signal_last  ! [ MHz]
  real(kind=8) :: x_signal,x_image          ! [ MHz]
  real(kind=4) :: mean_freq                 ! [ MHz]
  real(kind=4), parameter :: fres_tol=0.01  ! [    ] Relative tolerance on DSB channel width
  character(len=25) :: check
  character(len=80) :: mess    ! Error or debug or info messages.
  !
  check = ">>>>>>>>>>>>>>"//rname
  !
  ! Decode input line arguments
  use_model    = sic_present(1,0)
  use_simulate = sic_present(2,0)
  use_weight   = sic_present(3,0)
  use_bmsw     = sic_present(4,0)
  !
  !
  cont_offset = 1.e-3  ! 0.0 causes failure of MEM deconvolution
  call sic_r4(line,0,1,cont_offset,.false.,error)
  if (error) return
  write(mess,'(a,g12.4)') "Continuum offset: ",cont_offset
  call class_message(seve%i,rname,mess)
  if (use_weight) then
     call sic_r4(line,3,1,sigma_weight,.true.,error)
     if (error) return
  endif
  !
  !>> hogm 3bis
  ! Distinguish between spacially (within the IF) varying gain or
  ! piecewise constant gain (within the IF) take care this MUST be
  ! defined in deconv_init because of the gain initialisation
  variable_gain=.false.
  print*,check,'variable gain ',variable_gain
  !<< hogm 3bis
  if (use_model) then
     write(mess,*) "/MODEL Not yet implemented"
     call class_message(seve%i,rname,mess)
     return
  endif
  if (use_simulate) then
     write(mess,*) "/SIMULATE Not yet implemented"
     call class_message(seve%i,rname,mess)
     return
  endif
  !
  ! Sanity checks
  !
  ! Verify if any input file
  if (.not.filein_opened(rname,error))  return
  if (cx%next.le.1) then
     call class_message(seve%e,rname,'Index is empty')
     error = .true.
     return
  endif
  !
  ! Free memory if any already allocated
  call deconv_dealloc(error)
  if (error) return
  !
  ! Read the first observation into OBS
  knext= 1
  call init_obs(obs)
  call get_first(set,obs,user_function,error)
  if (error) return
  dsb_counter = cx%next-1
  dsb_size    = 0 ! dsb_spectrum is empty at the beginning.
  blanked     = 0 ! Number of blanked channels. Not used,but could be
  !
  ! Read the first guesses for these standing waves.
  n_sw_bm = 0
  if (use_bmsw) then
     call sic_i4(line,4,1,n_sw_bm,.true.,error)
     allocate( asw_bm(dsb_counter,n_sw_bm),stat=ier)
     allocate( psw_bm(dsb_counter,n_sw_bm),stat=ier)
     allocate(phsw_bm(dsb_counter,n_sw_bm),stat=ier)
     allocate(asw_bm_model(dsb_counter,n_sw_bm),stat=ier)       ! model's swbm amplitude.
     allocate(psw_bm_model(dsb_counter,n_sw_bm),stat=ier)       ! model's swbm pulsation.
     allocate(phsw_bm_model(dsb_counter,n_sw_bm),stat=ier)      ! model's swbm phase.
     allocate(norm_asw_bm_model(dsb_counter,n_sw_bm),stat=ier)  !
     allocate(norm_psw_bm_model(dsb_counter,n_sw_bm),stat=ier)  !
     allocate(norm_phsw_bm_model(dsb_counter,n_sw_bm),stat=ier) !
     if (failed_allocate(rname,'Standing wave arrays',ier,error))  goto 100
     asw_bm  = 0.0
     psw_bm  = 0.0
     phsw_bm = 0.0
     do i = 1,n_sw_bm
        call sic_r4(line,4,3*i-1,asw_bm(1,i) ,.true.,error)
        if (error) goto 100
        call sic_r4(line,4,3*i  ,psw_bm(1,i) ,.true.,error)
        if (error) goto 100
        call sic_r4(line,4,3*i+1,phsw_bm(1,i),.true.,error)
        if (error) goto 100
        write(mess,'(a,i2,3g12.4)') 'BMSW: ',i,asw_bm(1,i),psw_bm(1,i),phsw_bm(1,i)
        call class_message(seve%i,rname,mess)
        do j=2,dsb_counter
           asw_bm(j,i)  =  asw_bm(1,i)
           psw_bm(j,i)  =  psw_bm(1,i)
           phsw_bm(j,i) =  phsw_bm(1,i)
        enddo
     enddo
  endif
  !
  ! Go through the index to compute dsb_size
  dsb_size = 0
  do scan=1,dsb_counter
     entry_num = cx%ind(scan) ! Take the observation number of the scan^th observation in the index.
     call get_it(set,obs,entry_num,user_function,error)
     if (error) goto 100
     nc = count(obs%spectre(1:obs%cnchan).ne.obs%head%spe%bad)
     dsb_size = dsb_size+nc
  enddo
  !
  ! Memory allocation of DSB arrays
  ! Zero-size array are legitimate objects
  call deconv_allocate('DSB',error)
  if (error) goto 100
  !
  ! Initialization from 1st DBS observation
  ! Store 1st DBS observation header to be copied into the SSB header
  call get_it(set,obs,cx%ind(1),user_function,error)
  if (error) goto 100
  dsb_head = obs%head
  dsb_width = abs(obs%head%spe%fres)
  ssb_voff  = obs%head%spe%voff
  write (mess,'(A,F9.6)') 'Frequency resolution (MHz) = ',dsb_width
  call class_message(seve%i,rname,mess)
  write (mess,'(A,F9.6)') 'Velocity at ref. chan (km/s) = ',ssb_voff
  call class_message(seve%i,rname,mess)
  !
  ! Check telescope (needed to assess usage of sideband gain correction later)
  call sic_upper(obs%head%gen%teles)
  hifi = index(obs%head%gen%teles,'HIF-').ne.0
  ! Store variables from GENERAL section of header
  dsb_system = obs%head%pos%system
  dsb_time = obs%head%gen%time
  !
  ! Read the DSB scans from the CLASS index.
  dsb_size = 0
  ii = 0
  do scan=1,dsb_counter
     single_size(scan) = 0
     entry_num = cx%ind(scan) ! Take the observation number of the scan^th observation in the index.
     call get_it(set,obs,entry_num,user_function,error)
     if (error) goto 100
!!$     if (scan.eq.1) then
!!$        dsb_width = abs(obs%head%spe%fres)
!!$        ssb_voff  = obs%head%spe%voff
!!$        dsb_telescope = obs%head%gen%teles
!!$        dsb_source = obs%head%pos%sourc
!!$        write (mess,'(A,F9.6)') 'Frequency resolution (MHz) = ',dsb_width
!!$        call class_message(seve%i,rname,mess)
!!$        write (mess,'(A,F9.6)') 'Velocity at ref. chan (km/s) = ',ssb_voff
!!$        call class_message(seve%i,rname,mess)
!!$     else if (abs(abs(obs%head%spe%fres)-dsb_width).gt.epsilon) then
!!$        write(mess,'(a,f12.4,1x,f12.4)') 'Changing channel widths: ',dsb_width,abs(obs%head%spe%fres)
!!$        call class_message(seve%i,rname,mess)
!!$     endif
     if (abs(obs%head%spe%fres/dsb_width-1.d0).gt.fres_tol) then
        dsb_width = abs(obs%head%spe%fres)
        write(mess,'(a,f12.4,1x,f12.4)') 'Changing channel widths: ',dsb_width,abs(obs%head%spe%fres)
        call class_message(seve%i,rname,mess)
     endif
     ! Frequency Switch: obs%head%swi%swmod.eq.mod_freq is not a
     ! sufficient test because FSWITCH mode has mod_freq=0 and any
     ! value initialized to 0 would match the criterium.
     freq_switch = r%head%presec(class_sec_swi_id).and.&
          obs%head%swi%swmod.eq.mod_freq.and.    &
          r%head%swi%nphas.gt.1
     if (freq_switch) then
        do i=1,2
           freq_throw(scan,i) = obs%head%swi%decal(i)
           decal              = freq_throw(scan,i)/obs%head%spe%fres
!!$           chan_throw(scan,i) = int(freq_throw(scan,i)/obs%head%spe%fres)
           if (decal.ge.0) then
              chan_throw(scan,i) = int(decal)
           else
              chan_throw(scan,i) = int(decal)-1
           endif
           ! Why is the weight rounded to the nearest integer ???? PHB
           throw_poids(scan,i) = anint(obs%head%swi%poids(i))
           print *,check,'scan,i,chan_throw(scan,i):',scan,i,chan_throw(scan,i),freq_throw(scan,i),throw_poids(scan,i)
        enddo
     else
        do i=1,2
           freq_throw(scan,i) = 0.
           chan_throw(scan,i) = 0.
        enddo
     endif
     ! ?????????????????? should be modified
     !
     ! Copy the DSB spectrum from CLASS to XCLASS.
     !>> hogm 5
     ! Store these quantities to calculate the position of the channels
     dsb_rrestf(scan) = obs%head%spe%restf
     dsb_rimage(scan) = obs%head%spe%image
     dsb_rrchan(scan) = obs%head%spe%rchan
     dsb_cnchan(scan) = obs%cnchan
     !<< hogm 5
     !
     !
     !Store gain information for signal sideband  CC 19.6.2013
     if (obs%head%cal%gaini.eq.0.000) then
        gain_model_input(scan) = 1.0
     else
        if (hifi) then
           gain_model_input(scan) = obs%head%cal%gaini/0.5 ! HIFI works with relative gains
        else
           gain_model_input(scan) = obs%head%cal%gaini
        endif
     endif
     ! Loop over current observation channels
     do i=1,obs%cnchan
        if (obs%spectre(i).eq.obs%head%spe%bad) then
           blanked = blanked+1
        else
           single_size(scan) = single_size(scan)+1
           dsb_size          = dsb_size+1
           if (debug.and.i.eq.1)  print*,check,i,obs%cnchan,&
                obs%head%spe%rchan,obs%head%spe%fres,obs%head%spe%restf,obs%head%spe%image
           dsb_signal(dsb_size) =  (i-obs%head%spe%rchan)*dsb_width+obs%head%spe%restf
           dsb_image (dsb_size) = -(i-obs%head%spe%rchan)*dsb_width+obs%head%spe%image
!!$           dsb_signal(dsb_size) =  (i-obs%head%spe%rchan)*obs%head%spe%fres+obs%head%spe%restf
!!$           dsb_image (dsb_size) = -(i-obs%head%spe%rchan)*obs%head%spe%fres+obs%head%spe%image
           dsb_pointer(dsb_size) = scan
!           dsb_spectrum(dsb_size) = obs%spectre(i) ! Fill in DSB spectrum
           if (hifi) then  !CC 19.6.2013
              dsb_spectrum(dsb_size) = obs%spectre(i)*gain_model_input(scan) ! remove HIFI gain correction
                                                                             ! before deconvolving
           else  ! how other observatories use GAINIMAG must still be verified. In the meantime: do nothing
              dsb_spectrum(dsb_size) = obs%spectre(i)
           endif
           if (debug.and.mod(ii,100).eq.0.) then
              ii = dsb_size
              x_signal = (dsb_signal(ii)-dsb_rrestf(dsb_pointer(ii)))/dsb_width
              x_signal = (x_signal+dsb_rrchan(dsb_pointer(ii))-dsb_cnchan(dsb_pointer(ii))/2.)/dsb_cnchan(dsb_pointer(ii))
              x_image  = (dsb_image(ii)-dsb_rimage(dsb_pointer(ii)))/dsb_width
              x_image  = (-x_image+dsb_rrchan(dsb_pointer(ii))-dsb_cnchan(dsb_pointer(ii))/2.)/dsb_cnchan(dsb_pointer(ii))
              print*,check,i, ii, x_signal, x_image,dsb_width,obs%head%spe%fres
           endif
        endif
     enddo
     !
     ! Now, dsb_size has its definitive value. It really represents
     ! the number of channels in dsb_spectrum, the sum of all
     ! single_size.
     if (use_weight) then
        dsb_weight(scan) = sigma_weight
     else
        call obs_weight_time(rname,obs,weight,error)
        if (error)  goto 100
        ! Why weight is used as a divider?
        dsb_weight(scan) = obs%head%cal%beeff**2 / (weight*1e6)
     endif
     dsb_weight(scan) = 1.d0 ! ???????????????? PH
  enddo
  ! Fill in gain_model_input information for image sideband:
  !   gLSB + gUSB = 2
  do i = dsb_counter+1, 2*dsb_counter
     gain_model_input(i) = 2.-gain_model_input(i-dsb_counter)
  enddo
  !
  ! SSB and model X axis (channels,frequencies...).
  ! Frequency resolution.
  ssb_width = dsb_width
  ! Find first and last frequencies of the SSB frequency scale.
  signal_first = dsb_signal(1) ! Signal freq of the first channel.
  signal_last  = dsb_signal(1) ! Signal freq of the last  channel.
  image_first  = dsb_image(1)  ! Image  freq of the first channel.
  image_last   = dsb_image(1)  ! Image  freq of the last  channel.
  do i=1,dsb_size
     if (dsb_signal(i).lt.signal_first) signal_first = dsb_signal(i)
     if (dsb_signal(i).gt.signal_last ) signal_last  = dsb_signal(i)
     if (dsb_image(i) .lt.image_first ) image_first  = dsb_image(i)
     if (dsb_image(i) .gt.image_last  ) image_last   = dsb_image(i)
  enddo
  ssb_first = min(signal_first,image_first)
  ssb_last  = max(signal_last, image_last )
  !
  ! Determine the number of channels for that SSB.
  ssb_size = (ssb_last-ssb_first)/ssb_width+1
  !
  ! Ensure the number of channel is an integer.
  if (((ssb_last-ssb_first)/(1.*ssb_width)+1).ne.(1.*ssb_size)) then
     write(mess,'(a,f12.4,1x,i12,f12.4,f12.4)') 'Non-integer number of channels: ',&
          (ssb_last-ssb_first)/ssb_width+1.0,ssb_size
!!$     write(*,'(a,f12.4,1x,i12,f12.4,f12.4)') 'Non-integer number of channels: ',&
!!$          (ssb_last-ssb_first)/ssb_width+1.0,ssb_size,ssb_last,ssb_first
     call class_message(seve%w,rname,mess)
     ! Shrink the spectrum so that the number of channels of the final SSB is an integer.
     ! PHB ???????????????
     ssb_last = ssb_first+(ssb_size-1)*ssb_width
     write(mess,'(a,f12.4,1x,i12,f12.4,f12.4)') 'Set to integer number of channels: ',&
          (ssb_last-ssb_first)/ssb_width+1.0,ssb_size
     call class_message(seve%i,rname,mess)
!!$     ssb_size=ssb_size+1
     !ph removes this line while working with CC 13/05/09
     !phb put back this line 25/08/2009
!!$     error = .true. !Stop here ???? PHB 24/03/09
!!$     goto 100
  endif
  !
  ! Memory allocation of SSB arrays
  call deconv_allocate('SSB',error)
  if (error) goto 100
  !
  ! Creates the frequency axis of the SSB.
  call class_message(seve%i,rname,'Creates frequency axis of the ssb')

  !  do i = 1,ssb_size
  !     ssb_freq(i)  = ssb_first + ssb_width * (i - 1)
  !  enddo
  ! If no model is wanted, use a flat one.
  !========================================
  ! The only places where the model is used is entropy calculations and
  ! SSB initialization.
  ! So,we can make here some processing on the model in order to
  ! spare CPU later.
  ! 1: For entropy calculation,it is not the model that is reqired,but
  !    the model divided by its sum. We call this "normalized model".
  ! 2: In order to avoid negative parameters into log,an offset is added
  !    the the vector used for entropy calculation. Because the model
  !    won't change during all the deconvolution,we can add this offset
  !    here,instead of adding it every time a entropy is calculated.
  ! 3: There are two expression for the entropy equation. One with model
  !    and one without model. When we look closer,we realize that the
  !    expression of the entropy without model is a particular case
  !    of the expression of the entropy with model: the case where the
  !    normalized model equals 1.
  ! 4: Only the normalized model is used for entropy calculations,but
  !    some people might want to have a look at the non normalized model.
  !    So,we give it a value here. You can get it from XCLASS to CLASS
  !    using the XCLASS command MAKEMODEL on SIC command line.
  !    Plus,the non-normalized model is used to initialize the SSB. It
  !    worths keeping.
  do i = 1,ssb_size
     ssb_model(i)      = cont_offset
     norm_ssb_model(i) = 1.0
     ssb_freq(i)       = ssb_first+ssb_width*(i-1)
  enddo
  !
  ! sum_model is set to 0 but it has no meaning: it won't be used.
  sum_model = 0.0 ! sum_model : mem.inc,/mem_data/
  !
  ! SSB model gains
  do i=1,2*dsb_counter
     gain_model(i)   = 1.0 ! 1 everywhere : no sideband imbalances.
     ! hogm : this has to be modified to take into account the high order gain fitting
     norm_gain_model(i) = 1.0/dsb_counter ! PHB ???????
  enddo
  !>> hogm 6
  ! set to zero the high order gain coefficient
  if (variable_gain) then
     do i=2*dsb_counter+1,max_og*2*dsb_counter
        gain_model(i)   = 0. ! 1 everywhere : no sideband imbalances.
     enddo
  else
     do i=2*dsb_counter+1,max_og*2*dsb_counter
        gain_model(i)   = 1. ! 1 everywhere : no sideband imbalances.
     enddo
  endif
  !<< hogm 6
  !
  ! SSB model standing waves.
  ! Everything is given the value 1.0. When these values can be read from
  ! a file, we will have to give the value 1.0 only when use_model=.FALSE..
  ! The value 1.0 is required by the entropy() function in chisquare.f.
  do i = 1,n_sw_bm
     do j = 1,dsb_counter
        norm_asw_bm_model(j,i) = 1.d0
        norm_psw_bm_model(j,i) = 1.d0
        ! This initialization of the normalized model of the phase has no
        ! real meaning. It won't be used.
     enddo
  enddo
  !
  ! Before-mixing standing waves.
  ! one_out_of_f : Used with psw_bm in order to have a parameter close
  ! to 1 during the deconvolution. The derivative of the chisquare
  ! with respect to the pulsation causes the SSB frequency to get out
  ! of the sin(). Because the SSB frequencies are relatively high
  ! (something like 10^6), this contribution to the derivative is too
  ! high and the algorithm fails. In order to have something close to
  ! 1 getting out of the sin(),we choosed to introduce a constant
  ! which will get out the sin() in the same time that SSB frequency
  ! and which has a value compensating the SSB frequency : 1 /
  ! mean(SSB frequency).  So,instead of having d(sin(wf))/dw =
  ! f.cos(wf), we'll have d(sin(w0fF))/dw0 = fF.cos(w0fF),and fF is
  ! close to 1 because F = 1/mean(f).  You can see that w0 = w / F. It
  ! is that w0 we call psw_bm.
  mean_freq    = (ssb_first+ssb_last)/2.0 ! Mean (SSB frequencies).
  one_out_of_f = 1.0/mean_freq
  do i=1,n_sw_bm
     do j=1,dsb_counter
        psw_bm(j,i) = psw_bm(j,i)/one_out_of_f
     enddo
  enddo
  !
  ! Initialize the SSB.
  do i=1,ssb_size    ! usemodel=.FALSE.,ssb_model(i) = cont_offset.
     ssb_spectrum(i) = cont_offset    ! See at the end of model creation.
  enddo
  !
  ! Gains
  do i=1,2*dsb_counter
     gain(i) = gain_model(i)
  enddo
  !
  !>> hogm 7
  ! for high order gain coefficient
  do i=2*dsb_counter+1,max_og*2*dsb_counter
     gain(i) = gain_model(i)
  enddo
  !<< hogm 7
  !
  ! Free memory
  call free_obs(obs)
  return
100 call free_obs(obs)
  call deconv_dealloc(error)
end subroutine deconv_init
!
!
!
!
!
subroutine deconv(set,line,r,error,user_function)
  use gildas_def
  use gbl_message
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>deconv
  use class_types
  use deconv_dsb_commons
  use f1_commons
  !-------------------------------------------------------------------
  ! @ public
  ! Support routine for command
  !
  ! DECONVOLVE tolerance itmax [lambda1 [lambda2 [lambda3]]]
  ! 1          [/GAIN [first_guess]]      !!CC 19.6.2013
  ! 2          [/DERIV]
  ! 3          [/BMSW n [NOA] [NOP] [NOPH]]
  ! 4          [/NOCHANNELS]
  ! 5          [/KEEP]
  !
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  character(len=*),    intent(in)    :: line
  type(observation),   intent(inout) :: r
  logical,             intent(out)   :: error
  logical,             external      :: user_function
  ! Local
  character(len=*), parameter :: rname='DECONV'
  logical :: use_bmsw,keep
  integer(kind=4) :: nkey,itmax,i,vect_size,ier,larg
  integer(kind=4) :: gain_first_guess
  real(kind=8) :: ftol
  integer(kind=4), parameter :: mvocab=3               ! Size of set vocabulary
  character(len=20)  :: arg,chain
  character(len=256) :: mess
  character(len=20), dimension(mvocab) :: vocab
  data vocab /'NOAMPLITUDE','NOPULSATION','NOPHASE'/
  character(len=25) :: check
  !
  check = ">>>>>>>>>>>"//rname
  !
  ! Decode input line arguments
  ftol        = 1.e-4 ! Default value
  itmax       = 1000  ! Default value
  error=.false.
  call sic_r8(line,0,1,ftol,   .true. ,error)
  if (error) goto 100
  call sic_i4(line,0,2,itmax,  .true. ,error)
  if (error) goto 100
  call sic_r8(line,0,3,lambda1,.false.,error)
  if (error) goto 100
  call sic_r8(line,0,4,lambda2,.false.,error)
  if (error) goto 100
  call sic_r8(line,0,5,lambda3,.false.,error)
  if (error) goto 100
  fit_gains   = sic_present(1,0)   !! CC 19.6.2013
  gain_first_guess = 1  ! Default: do not use GAINIMAG information as first guess for gain fitting
  call sic_i4(line,1,1,gain_first_guess,.false.,error)
  if (error) goto 100
  if (gain_first_guess.eq.0) then   !use gain input as first guess for gain fitting
     do i=1,2*dsb_counter
        gain(i) = gain_model_input(i)
     enddo
  endif
  use_deriv   = sic_present(2,0)
  use_bmsw    = sic_present(3,0)
  no_channels = sic_present(4,0)
  keep        = sic_present(5,0)
  no_bmswa    = .false.
  no_bmswp    = .false.
  no_bmswph   = .false.
  !
  !>> hogm 4
  ! set by hand the gain order
  ! this should be changed and read from the class script
  if (.not.fit_gains) then     !! CC 19.6.2013
     print*,'Not fitting the gains'
     o_gain = 1
     print*,'o_gain ',o_gain
  else
     print*,'Fitting the gains'
     o_gain = 1
     print*,'o_gain ',o_gain
  endif
  print*,check,'variable gain ',variable_gain
  !<< hogm 4
  !
  ! Finish memory allocation
  ! Depends on o_gain: if o_gain always 1, then do it in deconv_init ???????????? PHB
  vect_size = ssb_size+2*dsb_counter*o_gain+3*dsb_counter*n_sw_bm
  if (allocated(mem_pcom)) then
     deallocate(mem_pcom,mem_xicom,stat=ier)
     if (ier.ne.0) then
        call class_message(seve%e,rname,'Could not deallocate minimization arrays.')
        error = .true.
        return
     endif
  endif
  allocate(mem_pcom(vect_size),mem_xicom(vect_size),stat=ier)
  if (failed_allocate(rname,"Global minimization arrays",ier,error)) return
  !
  ! Sanity check
  ! Check for allocated arrays
  call deconv_allocate('ALL',error)
  if (error) return
  !
  ! Before-mixing standing waves first guesses.
  if (use_bmsw) then
     ! read the number of standing waves.
     if (sic_present(4,1)) then
        call sic_i4(line,4,1,i,.true.,error)
        if (error) goto 100
        if (i.gt.n_sw_bm) then
           write(mess,*) "Required number of standing waves larger than supplied."
           error = .true.
           goto 100
        endif
        ! Read "NOA","NOP" and "NOPH" to block them in delta_chi().
        do i=2,4
           if (.not.sic_present(4,i)) exit
           call sic_ke(line,4,i,arg,larg,.false.,error)
           call sic_ambigs(rname,arg,chain,nkey,vocab,mvocab,error)
           if (error) goto 100
           select case(chain)
           case('NOAMPLITUDE')
              no_bmswA  = .true.
           case('NOPULSATION')
              no_bmswP  = .true.
           case('NOPHASE')
              no_bmswPh = .true.
           end select
        enddo
     endif
  endif
  !
  !
  ! Write deconvolution parameters on screen.
  write (mess,*) 'Tolerance : ',ftol
  call class_message(seve%i,rname,mess)
  write (mess,*) 'Maximum number of iterations : ',itmax
  call class_message(seve%i,rname,mess)
  write (mess,*) 'Lambda1 = ',lambda1,'  Lambda2 = ',lambda2,'  Lambda3 = ',lambda3
  call class_message(seve%i,rname,mess)
  !
  write(mess,*) 'Sideband imbalances: ',fit_gains   !! CC 19.6.2013
  call class_message(seve%i,rname,mess)
  write(mess,*) 'Derivatives: ',use_deriv
  call class_message(seve%i,rname,mess)
  write(mess,*) 'Before-mixing standing waves: ',use_bmsw
  call class_message(seve%i,rname,mess)
  if (use_bmsw) then
     write (mess,*) 'Number of standing waves: ',n_sw_bm
     call class_message(seve%i,rname,mess)
     write(mess,*) 'BMSW Amplitude locked:',no_bmswa
     call class_message(seve%i,rname,mess)
     write(mess,*) 'BMSW Pulsation locked:',no_bmswp
     call class_message(seve%i,rname,mess)
     write(mess,*) 'BMSW Phase     locked:',no_bmswph
     call class_message(seve%i,rname,mess)
  endif
  !
  ! Do the job
  call deconvolve(ftol,itmax,error)
  if (error) goto 100
  call deconv_makessb(set,r,error,user_function)
  if (error) goto 100
  !
  ! Free allocated memory
  if (.not.keep) then
     call deconv_dealloc(error)
  endif
  return
100 call deconv_dealloc(error)
end subroutine deconv
!
!
!
!
!
subroutine deconvolve(ftol,itmax,error)
  use gildas_def
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>deconvolve
  use f1_commons
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ private
  ! This subroutine prepares the deconvolution process by initializing variables.
  ! deconvolve() gives frprmn() the parameters it needs to really calculate the
  ! deconvolution. frprmn() is supposed to return a SSB spectrum which minimizes
  ! the chisquare() function.
  !
  ! Convergence criterium: If the chisquare() evolution between two iterations of
  ! frprmn() is lower than ftol,frprmn() considers it has
  ! achieved convergence. If iter > IT_MAX (as defined in frprmn()),
  ! it means that frprmn() had not finised its convergence.
  !
  ! The information printed on screen at the end is not fundamental,but can be
  ! of any interest. It prints:
  ! - the value found for chisquare() (named min_chi);
  ! - the number of iteration frprmn() required to achieve it (named iter);
  ! - the LSB and USB gains found for each of the dsb_counter DSB scans (gain).
  ! After the deconvolution performed by frprmn(), ssb_spectrum stays in memory
  ! and can be transfered into CLASS.
  !-------------------------------------------------------------------
  real(kind=8),    intent(in)  :: ftol  ! Tolerance on chisqare evolution
  integer(kind=4), intent(in)  :: itmax ! Maximum iteration for frprmn
  logical,         intent(out) :: error ! Error flag
  ! Local
  character(len=*), parameter :: rname='DECONVOLVE'
  character(len=80) :: mess
  ! These vectors contain a copy of ssb_spectrum gain and SW, but in double precision.
  real(kind=8) :: dssb_spectrum(ssb_size)
  !<< hogm 9
  !  real(kind=8) :: dgain(2 * dsb_counter)
  ! the size of the gain array should be modified
  real(kind=8) :: dgain(2*o_gain*dsb_counter)
  !>> hogm 9
  !
  real(kind=8) :: dasw_bm (dsb_counter,n_sw_bm)
  real(kind=8) :: dpsw_bm (dsb_counter,n_sw_bm)
  real(kind=8) :: dphsw_bm(dsb_counter,n_sw_bm)
  ! This vector is used to transport dssb_spectrum and dgain in a single vector.
  !<< hogm 8
  ! PH changed this. There was a bug there.
  ! real(kind=8)  :: vect(ssb_size+2*dsb_counter+3*dsb_counter*n_sw_bm_max)
  ! replace this line by
  real(kind=8), allocatable, dimension(:) :: vect
  ! to take the high order gain extension
  !>> hogm 8
  integer(kind=4) :: vect_size ! Logical nb of elements of vect: ssb_size + 2 * dsb_counter.
  real(kind=8) :: min_chi      ! chisquare() value of the SSB which minimizes chisquare().
  integer(kind=4) :: iter      ! Number of iterations made by frprmn() to achieve
  integer(kind=4) :: i,j,ier
  !
  ! Initialization
  min_chi   = 1.
  iter      = 0
  error     = .false.
  !<< hogm 8bis
  !  vect_size = ssb_size+2*dsb_counter+3*dsb_counter*n_sw_bm_max ! size of the array vect
!!$  vect_size = ssb_size+2*dsb_counter*o_gain+3*dsb_counter*n_sw_bm_max ! size of the array vect
  !>> hogm 8bis
  !
  ! Memory allocation
  vect_size = ssb_size+2*dsb_counter*o_gain+3*dsb_counter*n_sw_bm
  allocate(vect(vect_size),stat=ier)
  if (failed_allocate(rname,'Concatenated array',ier,error)) return
  !
  ! Double-ization of vectors.
  do i=1,dsb_size
     ddsb_spectrum(i) = dble(dsb_spectrum(i))
  enddo
  do i=1,ssb_size
     dssb_spectrum(i) = dble(ssb_spectrum(i))
  enddo
  do i=1,2*dsb_counter
     dgain(i) = dble(gain(i))
     do j=1,n_sw_bm
        dasw_bm (i,j) = dble(asw_bm (i,j))
        dpsw_bm (i,j) = dble(psw_bm (i,j))
        dphsw_bm(i,j) = dble(phsw_bm(i,j))
     enddo
  enddo
  !hogm 9
  !convert the high order gain coefficient in double precision
  do i=2*dsb_counter+1,2*dsb_counter*o_gain
     dgain(i) = dble(gain(i))
  enddo
  !hogm 9
  do i=1,vect_size
     vect(i) = 0.
  enddo
  !
  call class_message(seve%i,rname,'Start deconvolution')
  !
  ! Concatenation of SSB vectors.
  call vect_contract(vect,dssb_spectrum,dgain,dAsw_bm,dpsw_bm,dphsw_bm)
  !
  ! Do the real job: minimization of X2 - l1*F_ssb - l2*F_gain - l3*F_sw.
  ! It returns vect,iter and min_chi.
  !      print*,'enter in delta_chi'
  !      call delta_chi(vect, xi, vect_size)
  !      print*,'enter in chi from deconv'
  !      fp = chisquare(vect, vect_size)
  !      print*,'delta_chi ok'
  call frprmn(vect,vect_size,ftol,itmax,iter,min_chi,error)
  if (error) return
  !
  ! Expansion of SSB vectors.
  call vect_expand(vect,dssb_spectrum,dgain,dAsw_bm,dpsw_bm,dphsw_bm,vect_size)
  !
  ! Constraints phase between -pi and pi
  do i=1,dsb_counter
     do j=1,n_sw_bm
        do while (dphsw_bm(i,j).gt.pi)
           dphsw_bm(i,j) = dphsw_bm(i,j)-pi*2
        enddo
        do while (dphsw_bm(i,j).le.-pi)
           dphsw_bm(i,j) = dphsw_bm(i,j)+pi*2
        enddo
     enddo
  enddo
  !
  ! Single-ization of vectors.
  do i = 1,ssb_size
     ssb_spectrum(i) = sngl(dssb_spectrum(i))
     ! Set blanked channels to BAD, not to cont_offset
     if (abs(ssb_spectrum(i)).eq.cont_offset) then
        ssb_spectrum(i) = dsb_head%spe%bad
     endif
  enddo
  do i = 1,2*dsb_counter
     gain(i) = sngl(dgain(i))
     do j = 1,n_sw_bm
        asw_bm (i,j) = sngl(dasw_bm (i,j))
        psw_bm (i,j) = sngl(dpsw_bm (i,j))
        phsw_bm(i,j) = sngl(dphsw_bm(i,j))
     enddo
  enddo
  !
  ! Print results.
  write (mess,'(a,g10.4,a,i5)') 'Min Chisquare = ',min_chi,' iterations=',iter
  call class_message(seve%i,rname,mess)
  call class_message(seve%i,rname,'    DSB   Input_gain(sig)   Input_gain(im)   Output_gain(sig)    Output_gain(im) ')
  do i=2*dsb_counter+1,2*o_gain*dsb_counter
     gain(i) = sngl(dgain(i))
  enddo
  !hogm 9bis
  !hogm 10
  do j=1,o_gain
     do i=1,dsb_counter
        write(mess,'(2i3,4g17.3)') i,j,gain_model_input(i+(j-1)*2*dsb_counter), &    ! CC 19.6.2013 writes out initial guess gains and fitted gains
             gain_model_input(i+dsb_counter+(j-1)*2*dsb_counter), &
             gain(i+(j-1)*2*dsb_counter),gain(i+dsb_counter+(j-1)*2*dsb_counter)
        call class_message(seve%i,rname,mess)
     enddo
  enddo
  !hogm 10
  !
  deallocate(vect)
  call class_message(seve%i,rname,'Deconvolution done')
end subroutine deconvolve
!
!
!
!
!
subroutine deconv_makessb(set,r,error,user_function)
  use gildas_def
  use phys_const
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>deconv_makessb
  use class_types
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ private
  ! This subroutine copies the deconvolved SSB spectrum ssb_spectrum
  ! into the CLASS R-memory.
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  type(observation),   intent(inout) :: r              !
  logical,             intent(inout) :: error          ! Error flag
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname="MAKE_SSB"
  !
  ! Initialize R header
  call rzero(r,'NULL',user_function)
  !
  ! Compute X axis
  r%cnchan         = ssb_size
  r%head%spe%nchan = r%cnchan
  r%head%spe%rchan = 1                                            ! [    ] Reference channel
  r%head%spe%restf = ssb_first                                    ! [ MHz] Rest frequency
  r%head%spe%fres  = ssb_width                                    ! [ MHz] Frequency resolution
  r%head%spe%vres  = -clight_kms*r%head%spe%fres/r%head%spe%restf ! [km/s] Velocity resolution
  r%head%spe%voff  = ssb_voff                                     ! [km/s] Velocity offset
  if (r%head%spe%restf.eq.0) r%head%spe%restf  =  3.0d5
  if (r%head%spe%fres.eq.0)  r%head%spe%fres   = -1.0
  if (r%head%spe%vres.eq.0)  r%head%spe%vres   = -clight_kms*r%head%spe%fres/r%head%spe%restf
  if (r%head%spe%bad.eq.0)   r%head%spe%bad    = -1000.0
  r%cbad = r%head%spe%bad
  r%head%spe%line = 'DECONV-SSB'
  r%head%gen%teles = dsb_head%gen%teles
  r%head%pos%sourc = dsb_head%pos%sourc
  r%head%gen%kind = kind_spec
  r%head%presec(class_sec_xcoo_id) = .false.    ! Regularly sampled X-axis
  !
  call reallocate_obs(r,r%cnchan,error)
  if (error) return
  call abscissa(set,r,error)
  if (error) return
  !
  ! Copy the XCLASS vector ssb_spectrum into the CLASS R-memory.
  call r4tor4(ssb_spectrum,r%data1,r%head%spe%nchan)
  !
  ! Fill in header
  call sic_gagdate(r%head%gen%dobs)
  !
  !Fill in source information ! CC 4.7.2013
  r%head%pos%system = dsb_head%pos%system
  r%head%pos%equinox = dsb_head%pos%equinox
  r%head%pos%lam = dsb_head%pos%lam
  r%head%pos%bet = dsb_head%pos%bet
  !
  ! Fill in GENERAL section ! CC 4.7.2013
  r%head%gen%dobs    = dsb_head%gen%dobs
  r%head%gen%qual    = qual_unknown
  r%head%gen%tsys    = 1
  r%head%gen%time    = dsb_head%gen%time
  r%head%presec(class_sec_gen_id) = .true.     ! if .false., spectrum can't be written out CC 4.7.2013
  r%head%presec(class_sec_pos_id) = .true.     ! if .false., spectrum can't be written out CC 4.7.2013
  r%head%presec(class_sec_spe_id) = .true.    ! if .false., spectrum can't be written out cc 4.7.2013
!
  r%head%presec(class_sec_desc_id) = .false.     ! Not an OTF spectrum
  r%head%des%ndump=1
  r%head%xnum  = -1                      ! Modeled observation will be in memory but was not red from a file
  !
  ! Finish
  call newdat(set,r,error)
  call class_message(seve%i,rname,'Deconvolved SSB array in R buffer')
end subroutine deconv_makessb
!
!
!
!
subroutine vect_expand(pvect,pssb,pgain,pAsw_bm,ppsw_bm,pphsw_bm,psize)
  use gildas_def
  use gbl_message
  use classcore_interfaces
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ no-interface (because of dummy dimension using parameters)
  ! The variables given to vect_expand() have a "p" as first letter,
  ! meaning they are Parameters of the subroutine. So, they won't
  ! be confused with other variables in common blocs which could have
  ! a similar name (ssb, gain, ...).
  !-------------------------------------------------------------------
  integer(kind=4), intent(in)  :: psize
  real(kind=8),    intent(in)  :: pvect(psize)
  real(kind=8),    intent(out) :: pssb(ssb_size)                ! contains the spectral power information of the SSB
  real(kind=8),    intent(out) :: pgain(2*dsb_counter*o_gain)   ! contains the lower and upper side band gains
  real(kind=8),    intent(out) :: pasw_bm (dsb_counter,n_sw_bm) ! amplitude of SW before mixing
  real(kind=8),    intent(out) :: ppsw_bm (dsb_counter,n_sw_bm) ! pulsation of SW before mixing
  real(kind=8),    intent(out) :: pphsw_bm(dsb_counter,n_sw_bm) ! phase     of SW before mixing
  ! Local
  character(len=*), parameter :: rname='VECT_EXPAND'
  integer(kind=4) :: j,i,i_offset_A,i_offset_p,i_offset_ph,debug_index
  !
  debug_index = 0
  ! Copy the spectral power, gain, and SW informations
  do i = 1, ssb_size
     pssb(i) = pvect(i)
  enddo
  do i=1,2*o_gain*dsb_counter
     pgain(i) = pvect(ssb_size+i)
  enddo
  i_offset_A  = ssb_size+2*o_gain*dsb_counter+1
  i_offset_p  = i_offset_A+n_sw_bm*dsb_counter
  i_offset_ph = i_offset_p+n_sw_bm*dsb_counter
  do j=1,n_sw_bm
     do i=1,dsb_counter
        pAsw_bm (i,j) = pvect(i_offset_A )
        ppsw_bm (i,j) = pvect(i_offset_p )
        pphsw_bm(i,j) = pvect(i_offset_ph)
        i_offset_A    = i_offset_A+1
        i_offset_p    = i_offset_p+1
        i_offset_ph   = i_offset_ph+1
        debug_index   = debug_index+1
     enddo
  enddo
end  subroutine vect_expand
!
!
!
!
!
subroutine vect_contract(pvect,pssb,pgain,pAsw_bm,ppsw_bm,pphsw_bm)
  use gildas_def
  use gbl_message
  use classcore_interfaces
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ no-interface (because of dummy dimension using parameters)
  ! The variables given to vect_contract() have a "p" as first letter,
  ! meaning they are Parameters of the subroutine. So, they won't
  ! be confused with other variables in common blocs which could have
  ! a similar name (ssb, gain, ...).
  !-------------------------------------------------------------------
  real(kind=8), intent(out) :: pvect(ssb_size+2*dsb_counter*o_gain+3*dsb_counter*n_sw_bm)
  real(kind=8), intent(in)  :: pssb(ssb_size)                ! contains the spectral power information of the SSB
  real(kind=8), intent(in)  :: pgain(2*dsb_counter*o_gain)   ! contains the lower and upper side band gains
  real(kind=8), intent(in)  :: pasw_bm (dsb_counter,n_sw_bm) ! amplitude of SW before mixing
  real(kind=8), intent(in)  :: ppsw_bm (dsb_counter,n_sw_bm) ! pulsation of SW before mixing
  real(kind=8), intent(in)  :: pphsw_bm(dsb_counter,n_sw_bm) ! phase     of SW before mixing
  ! Local
  character(len=*), parameter :: rname='VECT_CONTRACT'
  integer(kind=4) :: j,i,i_offset_A,i_offset_p,i_offset_ph
  !
  !  call class_message(seve%i,rname,'Starting vector concatenation')
  ! Copy the spectral power, gain and SW informations
  do i=1,ssb_size
     pvect(i) = pssb(i)
  enddo
  do i=1,2*o_gain*dsb_counter
     pvect(ssb_size+i) = pgain(i)
  enddo
  i_offset_A  = ssb_size+2*o_gain*dsb_counter+1
  i_offset_p  = i_offset_A+n_sw_bm*dsb_counter
  i_offset_ph = i_offset_p+n_sw_bm*dsb_counter
  do j=1,n_sw_bm
     do i=1,dsb_counter
        pvect(i_offset_A ) = pAsw_bm (i,j)
        pvect(i_offset_p ) = ppsw_bm (i,j)
        pvect(i_offset_ph) = pphsw_bm(i,j)
        i_offset_A  = i_offset_A +1
        i_offset_p  = i_offset_p +1
        i_offset_ph = i_offset_ph+1
     enddo
  enddo
end subroutine vect_contract
!
!
!
!
!
subroutine frprmn(p,n,ftol,itmax,iter,fret,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>frprmn
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ private
  ! Fletcher-Reeves-Polak-Ribiere minimization (Numerical Recipes)
  ! Requires the calculation of derivatives for the function.
  !-------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n     ! Size of p
  real(kind=8),    intent(in)    :: ftol  ! Tolerance on MEM deconvolution
  integer(kind=4), intent(in)    :: itmax ! Maximal number of iteration before returing
  integer(kind=4), intent(out)   :: iter  ! Iterations counter
  real(kind=8),    intent(out)   :: fret  ! X^2 - lambda1 * Sspectrum - lambda2 * Sgain
  logical,         intent(out)   :: error ! Logical error flag
  real(kind=8),    intent(inout) :: p(n)  ! Vector to deconvolve
  ! Local
  character(len=*), parameter :: rname='FRPRMN'
  real(kind=8), parameter :: eps=1.d-20
  integer(kind=4)           :: its,j
  real(kind=8)            :: dgg,fp,gam,gg
  real(kind=8)            :: g(n),h(n),xi(n)
  character(len=80) :: mess
  !
  ! Initializations.
  error = .false.
  fp = chisquare(p,n)
  !
  call delta_chi(p,xi,n)
  do j=1,n
     g(j)  = -xi(j)
     h(j)  =   g(j)
     xi(j) =   h(j)
  enddo
  !
  ! Loop over iterations.
  do its=1,itmax
     write (mess,'(a,i3,a,es15.6)') 'Iter = ', its,' ; Chisquare = ',fp
     call class_message(seve%i,rname,mess)
     iter = its
     if (debug) then
        print*,'p(1:2) ',p(1:2)
        print*,'p(ssb_size-1:ssb_size) ',p(ssb_size-1:ssb_size)
        print*,'p(ssb_size+1:ssb_size+2) ',p(ssb_size+1:ssb_size+2)
        print*,'p(ssb_size+2*dsb_counter-1:ssb_size+2*dsb_counter) ', p(ssb_size+2*dsb_counter-1:ssb_size+2*dsb_counter)
        if (o_gain .gt. 1) then
           print*,'p(ssb_size+2*dsb_counter+1:ssb_size+2*dsb_counter+2) ',p(ssb_size+1+2*dsb_counter:ssb_size+2+2*dsb_counter)
           print*,'p(ssb_size+2*dsb_counter-1:ssb_size+2*dsb_counter) ', p(ssb_size+4*dsb_counter-1:ssb_size+4*dsb_counter)
        endif
        print*,'xi(1:2) ',xi(1:2)
        print*,'xi(ssb_size-1:ssb_size) ',xi(ssb_size-1:ssb_size)
        print*,'xi(ssb_size+1:ssb_size+2) ',xi(ssb_size+1:ssb_size+2)
        print*,'xi(ssb_size+2*dsb_counter-1:ssb_size+2*dsb_counter) ', xi(ssb_size+2*dsb_counter-1:ssb_size+2*dsb_counter)
        if (o_gain .gt. 1) then
           print*,'xi(ssb_size+2*dsb_counter+1:ssb_size+2*dsb_counter+2) ',xi(ssb_size+2*dsb_counter+1:ssb_size+2*dsb_counter+2)
           print*,'xi(ssb_size+4*dsb_counter-1:ssb_size+4*dsb_counter) ', xi(ssb_size+4*dsb_counter-1:ssb_size+4*dsb_counter)
        endif
     endif
     !
     call mem_linmin(p,xi,n,fret,use_deriv,error)
     if (error) return
     ! Next statement is the normal return :
     if (2.d0*abs(fret-fp).le.ftol*(abs(fret)+abs(fp)+eps)) then
        ! fret-fp : chisquare variation between last iter (fp) and new (fret).
        ! (fp+fret)/2 is almost equal to fp. And Epsilon is just here to
        ! avoid a zero on the right.
        write(mess,'(a,es12.3,es12.3)') 'Chi^2 variation smaller than ftol: ',fp,fret
        call class_message(seve%e,rname,mess)
        return
     endif
     fp = chisquare(p,n)
     call delta_chi(p,xi,n)
     gg  = 0.d0
     dgg = 0.d0
     do j = 1,n
        gg  = gg+g(j)**2
        !         dgg = dgg + xi(j)         **2 ! This statement for Fletcher-Reeves.
        dgg = dgg+(xi(j)+g(j))*xi(j) ! This one for Polak-Ribiere.
     enddo
     if (gg.eq.0.d0) return ! If gradient is exactly zero then we are already done.
     gam = dgg/gg
     do j=1,n
        g(j)  = -xi(j)
        h(j)  =   g(j)+gam*h(j)
        xi(j) =   h(j)
     enddo
     if (sic_ctrlc()) then
        call class_message(seve%e,rname,'Aborted by ^C')
        error = .true.
        return
     endif
  enddo
  call class_message(seve%e,rname,'Maximum iterations exceeded.')
end subroutine frprmn
!
!
!
!
!
subroutine mem_linmin(xp,xi,n,fret,use_deriv,error)
  use classcore_interfaces, except_this=>mem_linmin
  use f1_commons
  !-------------------------------------------------------------------
  ! @ private
  ! Finds the minimum of a N-dimensional function along vector xi from
  ! a specific point P, both defined in N-space. 'linmin' does the
  ! bookkeeping required to treat the function as a function of
  ! position along this line, and minimizes the function with
  ! conventional 1-D minimization routine.
  !-------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         ! Size of p and xi.
  real(kind=8),    intent(out)   :: fret      !
  real(kind=8),    intent(inout) :: xp(n)     !
  real(kind=8),    intent(inout) :: xi(n)     !
  logical,         intent(in)    :: use_deriv !
  logical,         intent(out)   :: error     ! Logical error flag
  ! Local
  real(kind=8), parameter :: tol=1.d-4
  integer(kind=4) :: j
  real(kind=8) :: ax,bx,fa,fb,fx,mem_xmin,xx
  !
  mem_ncom=n
  do j=1,n
     mem_pcom(j)  = xp(j)
     mem_xicom(j) = xi(j)
  enddo
  ax = 0.d0
  xx = 1.d0
  bx = 2.d0
  !
  call mem_mnbrak(ax,xx,bx,fa,fx,fb,mem_f1dim,error)
  !
  ! Choose between brent and dbrent:
  if (use_deriv) then
     fret = mem_dbrent(ax,xx,bx,mem_f1dim,mem_df1dim,tol,mem_xmin)
  else
     fret = mem_brent(ax,xx,bx,mem_f1dim,tol,mem_xmin)
  endif
  do j=1,n
     xi(j) = mem_xmin*xi(j)
     xp(j) = xp(j)+xi(j)
  enddo
end subroutine mem_linmin
!
!
!
!
!
subroutine mem_mnbrak(ax,bx,cx,fa,fb,fc,func,error)
  use gbl_message
  use classcore_interfaces, except_this=>mem_mnbrak
  !-------------------------------------------------------------------
  ! @ private
  ! Search a given function for a minimum. Given two values 'ax' and
  ! 'bx' of abscissa, searches in the downward direction until it can
  ! find 3 new valies 'ax', 'bx,' and 'cx' that bracket a
  ! minimum. 'fa', 'fb', 'fc' are the values of the function at these
  ! points.
  !-------------------------------------------------------------------
  real(kind=8), intent(inout) :: ax
  real(kind=8), intent(inout) :: bx
  real(kind=8), intent(out)   :: cx
  real(kind=8), intent(out)   :: fa
  real(kind=8), intent(out)   :: fb
  real(kind=8), intent(out)   :: fc
  real(kind=8), external      :: func
  logical,      intent(out)   :: error
  ! Local
  character(len=*), parameter :: rname='MEM_MNBRAK'
  real(kind=8), parameter :: gold=1.618034d0 ! Gold number.
  real(kind=8), parameter :: glimit=100.d0   !
  real(kind=8), parameter :: tiny=1.d-20     ! Used to avoid divisions by zero.
  real(kind=8) :: fac
  integer(kind=4) :: iter1,iter2
  real(kind=8) :: dum
  real(kind=8) :: qq,rr
  real(kind=8) :: uu,ulim,fu
  !
  ! Initializations.
  error = .false.
  iter1 = 0
  iter2 = 0
  fac   = 1.d0
  fa    = func(ax)
  fb    = func(bx)
  !
  ! Switch role of A and B so that we can go downhill in the direction from A to B.
  if (fb.gt.fa) then
     dum = ax
     ax  = bx
     bx  = dum
     dum = fb
     fb  = fa
     fa  = dum
  endif
  cx = bx+gold*(bx-ax) ! First guess for C.
  fc = func(cx)
  !
  ! "do while": keep returning here until we bracket.
  ! Either fb <  fc: found a minimum between b and c,
  !        fb >= fc: continue to go downhill until find a cx for which fb < fc.
  do iter1=1,100
     iter2 = iter2+1
     if (iter2.ge.10) then
        fac   = fac/2.d0
        iter2 = 0
     endif
     !
     if (fb.ge.fc) then ! we have to go downhill:
        ! Compute U by parabolic interpolation from A, B and C.
        ! U is at the minimum of this parabole.
        rr   = (bx-ax)*(fb-fc)
        qq   = (bx-cx)*(fb-fa)
        uu   = bx-((bx-cx)*qq-(bx-ax)*rr)/(2.d0*sign(max(abs(qq-rr),tiny),qq-rr))
        ulim = bx+glimit*fac*(cx-bx)  ! We won't go further than ulim.
        ! Now, test various possibilities.
        ! U is between B and C.
        if ((bx-uu)*(uu-cx).gt.0.d0) then
           fu = func(uu)
           if (fu.lt.fc) then ! we have a minimum between B and C:
              ! Zoom bracketting. Present (B, U, C) => future (A, B, C).
              ax = bx
              fa = fb
              bx = uu
              fb = fu
!!$              return
              exit
           else if (fu.gt.fb) then ! we have a min between B and U:
              ! Zoom bracketting. Present (A, B, U) => future (A, B, C).
              cx = uu
              fc = fu
!!$              return
              exit
           endif
           ! Parabolic fit was no use, use default magnification.
           uu = cx+gold*(cx-bx)
           fu = func(uu)
           ! U between C and its limit.
        else if ((cx-uu)*(uu-ulim).gt.0.d0) then
           fu = func(uu)
           if (fu.lt.fc) then
              bx = cx
              cx = uu
              uu = cx+gold*(cx-bx)
              fb = fc
              fc = fu
              fu = func(uu)
           endif
           ! U beyond its limit value.
        else if ((uu-ulim)*(ulim-cx).ge.0.d0) then
           uu = ulim
           fu = func(uu)
           ! Reject parabolic U, use default magnification.
        else
           uu = cx+gold*(cx-bx)
           fu = func(uu)
        endif
        ! Eliminate oldest points and continue.
        ax = bx
        bx = cx
        cx = uu
        fa = fb
        fb = fc
        fc = fu
     endif
  enddo
end subroutine mem_mnbrak
!
!
!
!
!
function mem_brent(ax,bx,cx,func,tol,xmin)
  use gbl_message
  use classcore_interfaces, except_this=>mem_brent
  !-------------------------------------------------------------------
  ! @ private
  !
  !-------------------------------------------------------------------
  real(kind=8) :: mem_brent  ! Function value on return
  real(kind=8), intent(in) :: ax
  real(kind=8), intent(in) :: bx
  real(kind=8), intent(in) :: cx
  real(kind=8), external   :: func
  real(kind=8), intent(in) :: tol
! real(kind=8), intent(in) :: xmin
  real(kind=8)             :: xmin
  ! Local
  character(len=*), parameter :: rname='BRENT'
  integer(kind=4), parameter :: itmax=100        ! Maximal allowed number of iterations
  real(kind=8), parameter :: cgold=.3819660d0 ! Golden ratio
  real(kind=8), parameter :: zeps=1.d-10      ! a small number which protects against trying to achieve
  ! fractional accuracy for a minimum that happens to be exactly zero
  integer(kind=4) :: iter
  real(kind=8) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2
  real(kind=8) :: u,v,w,x,xm
  !
  !     A and B sorting (must be in ascending order, though the input abscissas need not)
  a = min(ax,cx)
  b = max(ax,cx)
  !     Initializations.
  v = bx
  w = v
  x = v
  !     E will be the distance moved on the step before last.
  e = 0.d0
  fx = func(x)
  fv = fx
  fw = fx
  !     Main program loop.
  do iter = 1,itmax
     xm = 0.5d0*(a+b)
     tol1 = tol*abs(x)+zeps
     tol2 = 2.d0*tol1
     if (abs(x-xm).le.(tol2-.5d0*(b-a))) goto 3
     if (abs(e).gt.tol1) then
        !         Construct a trial parabolic fit.
        r = (x-w)*(fx-fv)
        q = (x-v)*(fx-fw)
        p = (x-v)*q-(x-w)*r
        q = 2.d0*(q-r)
        if (q.gt.0.d0) p=-p
        q = abs(q)
        etemp = e
        e = d
        !         This condition determines the acceptability of the parabolic fit:
        if (abs(p).ge.abs(.5*q*etemp).or.p.le.q*(a-x).or.p.ge.q*(b-x)) goto 1
        !         Here, it is OK: Take the parabolic step.
        d = p / q
        u = x + d
        !         Skip over the golden section step?
        if((u-a).lt.tol2.or.(b-u).lt.tol2)  d=sign(tol1,xm-x)
        goto 2
     endif
     !       We arrive here for a golden section step, which we take into the larger of the two segments.
1    if (x.ge.xm) then
        e = a-x
     else
        e = b-x
     endif
     !       Take the golden section step.
     d = CGOLD * e
     !       Arrive here with D computed either from parabolic fit, or else from golden section.
2    if (abs(d).ge.tol1) then
        u = x + d
     else
        u = x + sign(tol1,d)
     endif
     !       This is the one function evaluation per iteration.
     !       And we have to decide what to do with our function evaluation.
     !       Housekeeping follows:
     fu = func(u)
     if (fu.le.fx) then
        if (u.ge.x) then
           a = x
        else
           b = x
        endif
        v  = w
        fv = fw
        w  = x
        fw = fx
        x  = u
        fx = fu
     else
        if(u.lt.x) then
           a = u
        else
           b = u
        endif
        if(fu.le.fw .or. w.eq.x) then
           v  = w
           fv = fw
           w  = u
           fw = fu
        else if(fu.le.fv .or. v.eq.x .or. v.eq.w) then
           v  = u
           fv = fu
        endif
     endif
     !       Done with housekeeping. Back for another iteration.
  enddo
  call class_message(seve%e,rname,'mem_brent exceeded maximum iterations')
  !     Arrive here ready to exit with best values.
3 xmin = x ! ?????? PHB
  mem_brent = fx
  return
end function mem_brent
!
!
!
!
!
function mem_dbrent(ax,bx,cx,func,df,tol,xmin)
  use gbl_message
  use classcore_interfaces, except_this=>mem_dbrent
  !-------------------------------------------------------------------
  ! @ private
  ! --> Uses first derivative
  ! From Numerical Recipes
  !
  !-------------------------------------------------------------------
  real(kind=8) :: mem_dbrent  ! Function value on return
  real(kind=8), intent(in) :: ax    !
  real(kind=8), intent(in) :: bx    !
  real(kind=8), intent(in) :: cx    !
  real(kind=8), external   :: func  !
  real(kind=8), external   :: df    !
  real(kind=8), intent(in) :: tol   !
! real(kind=8), intent(in) :: xmin  !
  real(kind=8)             :: xmin  !
  ! Local
  character(len=*), parameter :: rname='DBRENT'
  integer(kind=4), parameter :: itmax=100
  real(kind=8),  parameter :: zeps=1.0d-10
  logical :: ok1,ok2 ! flags for wether proposed steps are acceptable or not.
  real(kind=8)  :: a,b,olde,e,x,u,v,w,fx,fu,fv,fw,dx,dv,dw
  real(kind=8)  :: xm,d,du,d1,d2,tol1,tol2,u1,u2
  integer(kind=4) :: iter
  !
  !
  a  = min(ax,cx)
  b  = max(ax,cx)
  v  = bx
  w  = v
  x  = v
  e  = 0.d0
  fx = func(x)
  fv = fx
  fw = fx

  dx = df(x)
  dv = dx
  dw = dx

  do iter = 1,itmax
     xm = 0.5 * (a + b)
     tol1 = tol * abs(x) + zeps
     tol2 = 2 * tol1
     if (abs(x - xm).le.(tol2 - .5 * (b-a))) goto 3
     if (abs(e).gt.tol1) then
        d1 = 2. * (b - a)
        d2 = d1
        ! Secant method.
        if (dw.ne.dx) d1 = (w - x) * dx / (dx - dw)
        ! Secant method with the other stored point.
        if (dv.ne.dx) d2 = (v - x) * dx / (dx - dv)
        ! Which of these two estimates of D shall we take?
        ! We will insist that they be within the bracket, and on the side
        ! pointed to by the derivative at X:
        u1  = x + d1
        u2  = x + d2
        ok1 = (((a - u1) * (u1 - b)).gt.0).and.((dx * d1).le.0)
        ok2 = (((a - u2) * (u2 - b)).gt.0).and.((dx * d2).le.0)
        ! Movement on the step before last.
        olde = e
        e    = d
        ! Take only an acceptable D: if both are acceptable, then take the smallest one.
        if (.not.(ok1.or.ok2)) then
           goto 1
        else if (ok1.and.ok2) then
           if (abs(d1).lt.abs(d2)) then
              d = d1
           else
              d = d2
           endif
        else if (ok1) then
           d = d1
        else
           d = d2
        endif
        if (abs(d).gt.abs(0.5 * olde))  goto 1
        u = x + d
        if (((u - a).lt.tol2) .or. ((b - u).lt.tol2))  d = sign(tol1,xm - x)
        goto 2
     endif
     ! Decide which segment by the sign of the derivative.
1    if (dx.ge.0) then
        e = a - x
     else
        e = b - x
     endif
     ! Bissect, not golden section.
     d = 0.5 * e
2    if (abs(d).ge.tol1) then
        u  = x + d
        fu = func(u)
     else
        u = x + sign(tol1,d)
        fu = func(u)
        ! If the minimum step in the downhill direction takes us uphill, then we are done.
        if (fu.gt.fx)  goto 3
     endif
     ! Now, all the housekeeping.
     du = df(u)
     if (fu.le.fx) then
        if (u.ge.x) then
           a = x
        else
           b = x
        endif
        v  = w
        fv = fw
        dv = dw
        w  = x
        fw = fx
        dw = dx
        x  = u
        fx = fu
        dx = du
     else
        if (u.lt.x) then
           a = u
        else
           b = u
        endif
        if ((fu.le.fw) .or. (w.eq.x)) then
           v  = w
           fv = fw
           dv = dw
           w  = u
           fw = fu
           dw = du
        else if ((fu.le.fv).or.(v.eq.x).or.(v.eq.w)) then
           v  = u
           fv = fu
           dv = du
        endif
     endif
  enddo
  call class_message(seve%e,rname,'DBRENT exceeded maximum iterations.')
3 xmin = x  ! ?????? PHB
  mem_dbrent = fx
end function mem_dbrent
!
!
!
!
!
function mem_f1dim(xx)
  use f1_commons
  use classcore_interfaces, except_this=>mem_f1dim
  !-------------------------------------------------------------------
  ! @ private
  ! Make the N-dimensional function effectively a 1-D function along a
  ! given line in N-space.
  !-------------------------------------------------------------------
  real(kind=8) :: mem_f1dim  ! Function value on return
  real(kind=8), intent(in) :: xx
  ! Local
  real(kind=8), dimension(mem_ncom) :: xt ! ???????? ph changed this
  integer(kind=4) :: j
  !
  do j=1,mem_ncom
     xt(j) = mem_pcom(j)+xx*mem_xicom(j)
  enddo
  mem_f1dim = chisquare(xt,mem_ncom)
end function mem_f1dim
!
!
!
!
!
function mem_df1dim(xx)
  use f1_commons
  use classcore_interfaces, except_this=>mem_df1dim
  !-------------------------------------------------------------------
  ! @ private
  ! Make the N-dimensional function effectively a 1-D function along a
  ! given line in N-space.
  !-------------------------------------------------------------------
  real(kind=8) :: mem_df1dim  ! Function value on return
  real(kind=8), intent(in) :: xx
  ! Local
  integer(kind=4) :: j
  real(kind=8), dimension(mem_ncom) :: xt,df      ! ???????? ph changed this
  !
  do j=1,mem_ncom
     xt(j) = mem_pcom(j)+xx*mem_xicom(j)
  enddo
  call delta_chi(xt,df,mem_ncom)
  mem_df1dim = 0.d0
  do j=1,mem_ncom
     mem_df1dim = mem_df1dim+df(j)*mem_xicom(j)
  enddo
end function mem_df1dim
!
!
!
!
!
! Parameter variables.
!======================
!
! vect      IO : A vector in which are concatenated the SSB spectrum
!                temperatures and the signal and image gains of the DSB spectra.
! vect_size I- : Number of elements in vector vect.
!
!
!
! Read from common block:
!-------------------------
! dsb_counter   I- : Number of DSB scans.
! ssb_size      I- : Number of channels of our SSB spectrum lssb.
! dsb_size      I- : Number of channels in our DSB spectra.
! ddsb_spectrum I- : DSB spectrum measured from the sky (concatenation of
!                    the dsb_counter DSB scans).
! dsb_weight    I- : Kind of quality quantifier for DSB scans.
!                    dsb_weight = IntegrationTime / SystemTemperature.
!                    The higher dsb_weight, the lower the noise in the scan.
! one_out_of_f  I- : Related to standing waves modulation. This factor is used
!                    to bring the variable we want to fit into a range close to
!                    1. Otherwise, the variable has very high values which
!                    unbalances the algorithm. Instead of fitting F, you fit
!                    f, and you know that F = one_out_of_f * f.
!
!
! As its name does not say, chisquare() does not calculate the X2 (Chi square)
! of the spectrum given in the parameter vect. It calculates the value we want
! to minimize as a criterium for a good deconvolution. For us, a good
! deconvolution must have a small X2 for sure, but should have an entropy
! high enough (the higher the entropy, the less structure in the spectrum,
! it avoids us to fit the noise as if it was important). The balance between
! X2 and entropy weights in chisquare() is set by the lambda1 and lambda2
! values : chisquare = X2 - lambda1 * entropy_ssb - lambda2 * entropy_gain.
! If lambda1 = lambda2 = 0 then chisquare = X2
! With a high lambda1, chisquare will decrease faster with an entropy_ssb
! variation than with a X2 variation, and the deconvolution algorithm will
! naturally converge in that direction, a direction in which spectra have a
! high entropy.
!
! This function calculates four things :
!   1 : X2 of the SSB spectrum given in parameter (through vect) ;
!   2 : entropy of the SSB spectrum ;
!   3 : entropy of the gain vector ;
!   4 : the sum of 1, 2 and 3, weighted by lambda1 and lambda2.
!
! The entropy calculations does not require a lot of information. You just
! have to give one vector, and the entropy function gives you its entropy (the
! higher the entropy, the flatter the spectrum).
!
! X2 calculation is a bit more subtle: it requires two vectors. Indeed, a X2
! is a measure representing the amount of differences between two vectors. One
! of these vectors could be the SSB spectrum given to deconvolve() through vect.
! But where can we find another SSB spectrum to which the first one could be
! compared ? Ideally, that second SSB spectrum is the spectrum of the signal
! we get from the sky, but if we had it, deconvolution would be useless! We
! don't have this ideal SSB spectrum. But we have the DSB spectrum measured
! from the sky. This DSB spectrum results from the mixing of the sky signal
! and a local oscilator signal. The Lower side band (image band) and the
! upper side band (signal band) of the sky are convolved to give the DSB
! spectrum. Convolving is an easy operation. So we won't calculate the X2
! between two SSB spectra, but between two DSB spectra : the one measured
! from the sky, and the other convolved here from the SSB given in vect.

function chisquare(vect,vect_size)
  use gildas_def
  use classcore_interfaces, except_this=>chisquare
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ private
  ! Calculates the value we want to minimize as a criterium for
  ! a good deconvolution
  ! vect: ssb(ssb_size)+gain(2*dsb_counter)
  !-------------------------------------------------------------------
  real(kind=8) :: chisquare  ! Function value on return
  integer(kind=4), intent(in)    :: vect_size        ! The logical size of vect
  real(kind=8),    intent(inout) :: vect(vect_size)  ! The vector you want to compute the chisquare
  ! Local
  integer(kind=4)                                  :: i,j,maxthrow,i1,i2,s1,s2
  logical                                          :: signal_in,image_in
  integer(kind=4)                                  :: index_weight              ! Index in weight vector.
  integer(kind=4)                                  :: index_signal,index_image  ! Index for lssb.
  integer(kind=4)                                  :: signal_gain,image_gain    ! Indices for lgain.
  real(kind=8), dimension(ssb_size)                :: lssb                      ! Local SSB spectrum vector.
  real(kind=8), dimension(ssb_size)                :: ssb_int                   ! Contains the product of lssb by lgain.
  real(kind=8), dimension(ssb_size)                :: ssb_interm                ! Intermediate vector - TEST
  real(kind=8)                                     :: entrop_ssb                ! Entropy of lssb.
  real(kind=8), dimension(2*o_gain*dsb_counter)    :: lgain                     ! Image and signal gains of the scans.
  real(kind=8)                                     :: entrop_gain               ! Entropy of lgain.
  real(kind=8), dimension(dsb_counter,n_sw_bm_max) :: lAsw_bm                   ! Amplitude.
  real(kind=8), dimension(dsb_counter,n_sw_bm_max) :: lpsw_bm                   ! Pulsation (2 * pi * freq).
  real(kind=8), dimension(dsb_counter,n_sw_bm_max) :: lphsw_bm                  ! Phase.
  real(kind=8), dimension(dsb_counter)             :: sw_int,mod_int
  real(kind=8)                                     :: entrop_sw
  real(kind=8), dimension(dsb_size)                :: dsb_int                   ! Contains the mixed lssb leading to a DSB.
  real(kind=8)                                     :: x_signal,x_image
  real(kind=8)                                     :: val_gain_signal,val_gain_image !value of the gains
  integer(kind=4)                                  :: l,ind_gain_sig,ind_gain_ima
  !
  ! Initialization
  chisquare = 0.d0
  !
  ! Extract ssb's spectrum, gain and sw bm from vect.
  call vect_expand(vect,lssb,lgain,lasw_bm,lpsw_bm,lphsw_bm,vect_size)
  !
  ! PART 1: Chi-square calculation.
  ! Start the loop on all the DSB channels.
  ! Main actions are :
  ! - convolution of SSB into a DSB;
  !   - modulation by before-mixing standing waves;
  !   - gain multiplication;
  !   - mixing;
  ! - X^2 (chi-square) calculation.
  do i=1,ssb_size
     ssb_interm(i) = lssb(i)
  enddo
  !
  ! Convolution of SSB into a DSB.
  do i=1,dsb_size
     ! Find SSB channels corresponding to the DSB channel i.
     index_signal = (dsb_signal(i)-ssb_first)/ssb_width+1
     index_image  = (dsb_image(i)-ssb_first)/ssb_width+1
     signal_gain  = dsb_pointer(i)                        ! Signal gain index for vector lgain.
     image_gain   = signal_gain + dsb_counter             ! Image gain index
     index_weight = dsb_pointer(i)                        ! Observation number associated to this channel.
     ssb_int(index_signal) = lssb(index_signal)
     ssb_int(index_image ) = lssb(index_image )
     !
     ! Determine the position of the channel in the IF. The value is between -0.5 and 0.5
     x_signal = dble( (dsb_signal(i) - dsb_Rrestf(dsb_pointer(i)))/ssb_width)
     x_signal = dble((x_signal + dsb_Rrchan(dsb_pointer(i)) - dsb_Cnchan(dsb_pointer(i))/2.) / dsb_Cnchan(dsb_pointer(i)) )
     x_image = dble( (dsb_image(i) - dsb_Rimage(dsb_pointer(i)))/ssb_width)
     x_image = dble((-x_image + dsb_Rrchan(dsb_pointer(i)) - dsb_Cnchan(dsb_pointer(i))/2.) / dsb_Cnchan(dsb_pointer(i)) )
     !
     ! 1st step : Modulation by before-mixing standing waves.
     ! Formula is taken from "HIFI Standing Waves and their Impact on
     ! Sideband Deconvolution, A First Report" by Steve Lord.
!!! Careful !!!!!
!!! is there not a bug here when n_sw_bm gt 1 ?????
     do j=1,n_sw_bm ! Loop over all before-mixing SW.
        ssb_int(index_signal) = ssb_int(index_signal) * &
             (1.d0+lasw_bm(index_weight,j)*             &
             sin(ssb_freq(index_signal)*one_out_of_f*lpsw_bm(index_weight,j)+lphsw_bm(index_weight,j)))
        ssb_int(index_image ) = ssb_int(index_image ) * &
             (1.d0+lasw_bm(index_weight,j)*             &
             sin(ssb_freq(index_image) *one_out_of_f*lpsw_bm(index_weight,j)+lphsw_bm(index_weight,j)))
     enddo
     ! 2nd step : multiply lssb by the gain.
     if (freq_switch) then
        maxthrow  = maxval(abs(chan_throw(index_weight,:)))
        signal_in = (index_signal-maxthrow).ge.1.and.(index_signal+maxthrow).le.ssb_size
        image_in  = (index_image-maxthrow).ge.1.and.(index_image+maxthrow).le.ssb_size
        if (signal_in.and.image_in) then
!!$        if ((index_signal-chan_throw(index_weight,1)).ge.1               &
!!$             .and.(index_signal-chan_throw(index_weight,2)).ge.1         &
!!$             .and.(index_signal-chan_throw(index_weight,1)).le.ssb_size  &
!!$             .and.(index_signal-chan_throw(index_weight,2)).le.ssb_size  &
!!$             .and.(index_image-chan_throw(index_weight,1)).ge.1           &
!!$             .and.(index_image-chan_throw(index_weight,2)).ge.1          &
!!$             .and.(index_image-chan_throw(index_weight,1)).le.ssb_size   &
!!$             .and.(index_image-chan_throw(index_weight,2)).le.ssb_size) then
!!$           ssb_int(index_signal) = (throw_poids(index_weight,1)*ssb_interm(index_signal-chan_throw(index_weight,1)) &
!!$                + throw_poids(index_weight,2)*ssb_interm(index_signal-chan_throw(index_weight,2)))                  &
!!$                * lgain(signal_gain)
!!$           ssb_int(index_image ) = (throw_poids(index_weight,1)*ssb_interm(index_image-chan_throw(index_weight,1)) &
!!$                + throw_poids(index_weight,2)*ssb_interm(index_image-chan_throw(index_weight,2)))               &
!!$                * lgain(image_gain)
           s1 = index_signal-chan_throw(index_weight,1)
           s2 = index_signal-chan_throw(index_weight,2)
           i1 = index_image-chan_throw(index_weight,1)
           i2 = index_image-chan_throw(index_weight,2)
           ssb_int(index_signal) = (throw_poids(index_weight,1)*ssb_interm(s1) &
                + throw_poids(index_weight,2)*ssb_interm(s2))* lgain(signal_gain)
           ssb_int(index_image ) = (throw_poids(index_weight,1)*ssb_interm(i1) &
                + throw_poids(index_weight,2)*ssb_interm(i2))               &
                * lgain(image_gain)
        endif
     else
        if (variable_gain) then
           val_gain_signal= 0.d0
           val_gain_image = 0.d0
           do l=1,o_gain
              val_gain_signal = val_gain_signal+lgain(signal_gain+(l-1)*2*dsb_counter)*(x_signal)**(l-1)
              val_gain_image  = val_gain_image +lgain( image_gain+(l-1)*2*dsb_counter)*(x_image )**(l-1)
           enddo
        else
           ind_gain_sig  = 2*dsb_counter*int(o_gain*(x_signal+0.5D0-1.d-4))+signal_gain
           ind_gain_ima = ind_gain_sig + dsb_counter
           val_gain_signal = lgain(ind_gain_sig)
           val_gain_image =  lgain(ind_gain_ima)
        endif
        ssb_int(index_signal) = ssb_int(index_signal)*val_gain_signal
        ssb_int(index_image ) = ssb_int(index_image )*val_gain_image
     endif
     ! 3rd step : do the mixing.
     dsb_int(i) = ssb_int(index_signal)+ssb_int(index_image)
     ! Post-mixing standing wave will have to go here.
     !
     ! Calculate chisquare contribution:
     ! chi^2= 1/v Sum_{i=1,v} [ (yi0 - yi)^2 / si^2]
     ! v   : Number of channels in y and y* (dsb_size).
     ! y0  : DSB spectrum measured from the sky (ddsb_spectrum).
     ! y   : DSB spectrum convolved from lssb (dsb_int).
     ! si^2: Variance. Channels can vary with time, it is a kind of noise
     !       measurement.
     chisquare = chisquare + &
          (ddsb_spectrum(i)-dsb_int(i))**2/(dsb_weight(index_weight)*abs(dsb_size-ssb_size-2*dsb_counter))
  enddo
  !
  ! PART 2: Beginning of the entropy calculation.
  ! lssb entropy.
  if (lambda1.ne.0.) then
     entrop_ssb  = entropythreshold(lssb,norm_ssb_model,ssb_size)
  else
     entrop_ssb = 0.d0
  endif
  ! Gain entropy.
  if ((fit_gains).and.(lambda2.gt.0.d0)) then      !! CC 19.6.2013
     !hogm this should be modified                 !! must look into this, never used it so far CC 20.11.2013
     if (o_gain.lt.1) then
        print*,'entropy with high order gain is not considered yet'
        stop
     endif
     entrop_gain = entropythreshold(lgain,norm_gain_model,2*dsb_counter)
  else
     entrop_gain = 0.d0
  endif
  ! Standing waves before mixing entropy.
  entrop_sw  = 0.d0
  if (lambda3.gt.0.d0) then
     ! Loop over all before-mixing standing waves.
     do i = 1, n_sw_bm
        ! Contribution of Amplitude to the entropy.
        do j = 1, dsb_counter
           sw_int(j)  = lasw_bm(j,i)
           mod_int(j) = norm_asw_bm_model(j,i)
        enddo
        entrop_sw = entrop_sw + entropy(sw_int,mod_int,dsb_counter)
        ! Contribution of pulsation to the entropy.
        do j = 1, dsb_counter
           sw_int(j)  = lpsw_bm(j,i)*one_out_of_f
           mod_int(j) = norm_psw_bm_model(j,i)
        enddo
        entrop_sw = entrop_sw+entropy(sw_int,mod_int,dsb_counter)
        ! Contribution of the phase to the entropy.
        ! None because no model can be provided:
        ! The phase jumps 'randomly' from one scan to another, because each
        ! scan is taken at a different time.
     enddo
  endif
  ! Finally add the different contributions.
  chisquare = chisquare-lambda1*entrop_ssb-lambda2*entrop_gain-lambda3*entrop_sw
  ! Propagation of modifications introduced by entropythreshold().
  call vect_contract(vect,lssb,lgain,lasw_bm,lpsw_bm,lphsw_bm)
end function chisquare
!
!
!
!
!
function entropy(x,M,n)
  use gildas_def
  use classcore_interfaces, except_this=>entropy
  use deconv_dsb_commons
  use gbl_message
  !-------------------------------------------------------------------
  ! @ private
  ! Calculate the entropy of a set of data and model of size n.
  ! The formula is:
  ! entropy = - Sum_{i=1,n} (xi/xtot) * log(xi/xtot/Mi)
  ! where xtot = sum(x). It is therefore assumed that Mi = mi / mtot.
  ! If no model is used then Mi = 1. (See init_mem.f.)
  !
  ! Add a continuum offset to x to avoid a negative argument in the
  ! log. Since the offset is the same during all the deconvolution
  ! process, we still can try to maximize the entropy. The model m
  ! must be shifted up by the same cont_offset. It is taken into
  ! account when M is calculated in init_mem():
  ! Mi = (mi+cont_offset) / sum(mi + cont_offset).
  ! -------------------------------------------------------------------
  real(kind=8) :: entropy  ! Function value on return
  integer(kind=4), intent(in)    :: n    ! The number of elements of x and M
  real(kind=8),    intent(in)    :: M(n) ! A normalized model (M = m / sum(m))
  real(kind=8),    intent(inout) :: x(n) ! The vector we want to compute the entropy
  !
  ! Local variables.
  integer(kind=4) :: i,j
  real(kind=8)  :: xtot       ! sum(x)
  real(kind=8)  :: x_xtot(n)  ! x / xtot
  real(kind=4)  :: f_array    ! Entropy terms. F = -sum(f_array).
  !
  ! Initialization
  xtot    = 0.d0
  entropy = 0.d0
  do i=1,n
     ! x(i) and M(i) must be positive.
     if (x(i)+cont_offset.le.0.d0.or.m(i).le.0.d0) then
        call class_message(seve%e,'ENTROPY','vect or model is 0 or negative.')
        do j=i-10,i+10
           if (j.ge.1.and.j.le.n) then
              print *, '  j, vect, model ', j, x(j), M(j)
           endif
        enddo
        stop
     endif
     xtot = xtot+x(i)+cont_offset
  enddo
  ! Calculate the entropy.
  do i=1,n
     x_xtot(i) = (x(i)+cont_offset)/xtot
     f_array   = x_xtot(i)*log(x_xtot(i)/M(i))
     entropy   = entropy-f_array
  enddo
end function entropy
!
!
!
!
!
function entropythreshold(x,M,n)
  use gildas_def
  use classcore_interfaces, except_this=>entropythreshold
  use deconv_dsb_commons
  use gbl_message
  !-------------------------------------------------------------------
  ! @ private
  ! Calculate the entropy of a set of data and model of size n.
  ! The formula is: entropy = -sum ( (xi/xtot) * log( (xi/xtot) / Mi),
  ! where xtot = sum(x). It is therefore assumed that Mi = mi / mtot.
  ! If no model is used then Mi = 1. (See init_mem.f.)
  ! Same as entropy(), but if a channel of vect is lower than epsilon, it is set
  ! to epsilon.
  !
  ! Add a continuum offset to x to avoid a negative argument in the
  ! log. Since the offset is the same during all the deconvolution
  ! process, we still can try to maximize the entropy. The model m
  ! must be shifted up by the same cont_offset. It is taken into
  ! account when M is calculated in init_mem():
  ! Mi = (mi+cont_offset) / sum(mi+cont_offset).
  !-------------------------------------------------------------------
  real(kind=8) :: entropythreshold  ! Function value on return
  integer(kind=4), intent(in)    :: n ! The number of elements of x and M
  real(kind=8),    intent(in)    :: M(n) ! A normalized model (M = m / sum(m))
  real(kind=8),    intent(inout) :: x(n) ! The vector we want to compute the entropy
  ! Local
  integer(kind=4)              :: i,j
  real(kind=8), parameter    :: epsilon=1.d-10
  real(kind=8)               :: xtot       ! Sum(x)
  real(kind=8)               :: x_xtot(n)  ! x / xtot
  real(kind=4)               :: f_array    ! Entropy terms. F = -sum(f_array).
  !
  !
  ! Initialization
  xtot = 0.d0
  entropythreshold = 0.d0
  !
  do i=1,n
     ! make x(i) greater than 0.
     if (x(i)+cont_offset.lt.epsilon) x(i)=epsilon-cont_offset
     ! model must be positive.
     if (m(i).le.0.) then
        call class_message(seve%f,'entropythreshold','model is 0 or negative.')
        do j=max(1,i-10),min(i+10,n)
           print *, '  j, model ', j, m(j)
        enddo
        stop
     endif
     xtot = xtot+x(i)+cont_offset
  enddo
  ! calculate the entropy.
  do i=1,n
     x_xtot(i) = (x(i)+cont_offset)/xtot
     f_array   = x_xtot(i)*log(x_xtot(i)/m(i))
     entropythreshold = entropythreshold-f_array
  enddo
end function entropythreshold
!
!
!
!
!
subroutine delta_chi(vect,delta_chisquare,vect_size)
  use gildas_def
  use phys_const
  use classcore_interfaces, except_this=>delta_chi
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ private
  ! vect contains (in this order) :
  ! - lssb    : Single side band spectrum only:                        size = ssb_size.
  ! - lgain   : Contains the signal band gain and the image band gain: size = 2 * dsb_counter.
  ! - lAsw_bm : Amplitude of the standing waves before mixing:         size = (dsb_counter, n_sw_bm).
  ! - lpsw_bm : Pulsation of the standing waves before mixing:         size = (dsb_counter, n_sw_bm).
  ! - lphsw_bm: Phase of the standing waves before mixing:             size = (dsb_counter, n_sw_bm).
  !-------------------------------------------------------------------
  integer(kind=4), intent(in)    :: vect_size        ! size of vect
  real(kind=8),    intent(inout) :: vect(vect_size)  ! The vector you want to compute the chisquare
  real(kind=8),    intent(out)   :: delta_chisquare(vect_size)
  ! Local
  real(kind=8), dimension(ssb_size) :: lssb
  real(kind=8), dimension(2*o_gain*dsb_counter) :: lgain       ! Image and signal gains of the scans.
  real(kind=8)                      :: modula_signal_prod,modula_image_prod
  real(kind=8)                      :: dchi
  real(kind=8), dimension(ssb_size) :: dchi_ssb
  real(kind=8), dimension(n_sw_bm)  :: modula_signal
  real(kind=8), dimension(n_sw_bm)  :: modula_image
  real(kind=8), dimension(dsb_counter,n_sw_bm) :: lasw_bm,lpsw_bm,lphsw_bm  ! amplitude, pulsation (2*pi*freq), phase.
  real(kind=8), dimension(2*o_gain*dsb_counter) :: dchi_gain
  real(kind=8), dimension(dsb_counter,n_sw_bm) :: dchi_asw_bm,dchi_psw_bm,dchi_phsw_bm  ! amplitude, pulsation (2*pi*freq), phase.
  real(kind=8), dimension(ssb_size)      :: dent_ssb
  !hogm should be modified at some stage
  real(kind=8), dimension(2*dsb_counter) :: dent_gain
  real(kind=8), dimension(2*dsb_counter) :: dgain
  real(kind=8), dimension(dsb_counter)   :: dent_sw
  real(kind=8), dimension(dsb_counter)   :: sw_int
  real(kind=8), dimension(dsb_counter)   :: mod_int
  real(kind=8), dimension(dsb_size)      :: dsb_int      ! mixed lssb leading to a dsb and its product by postmixing sw.
  real(kind=8), dimension(ssb_size)      :: ssb_int      ! product of lssb by the sw and the gain.
  real(kind=8), dimension(ssb_size)      :: ssb_interm   ! intermediate vector - test
  real(kind=8)                           :: x_signal     ! coordinate of the channel in the IF
  real(kind=8)                           :: x_image      ! coordinate of the channel in the IF
  real(kind=8)                           :: phase,sin_phase,amp_cos_phase,dchi_sw
  real(kind=8)                           :: val_gain_signal, val_gain_image
  integer(kind=4)                        :: l,ind_gain_sig,ind_gain_ima
  integer(kind=4)                        :: i,j,k
  integer(kind=4)                        :: index_signal,index_image,num_scan
  integer(kind=4)                        :: signal_gain,image_gain
  integer(kind=4)                        :: maxthrow,i1,i2,s1,s2
  logical                                :: signal_in,image_in
  !
  ! Initialize the variables.
  call vect_expand(vect,lssb,lgain,lasw_bm,lpsw_bm,lphsw_bm,vect_size)
  ! constraints phase between -pi and pi.
  do j=1,n_sw_bm
     do i=1,dsb_counter
        do while (lphsw_bm(i,j).gt.pi)
           lphsw_bm(i,j) = lphsw_bm(i,j)-pi*2
        enddo
        do while (lphsw_bm(i,j).lt.-pi)
           lphsw_bm(i,j) = lphsw_bm(i,j)+pi*2
        enddo
     enddo
  enddo
  ! Zero derivative spectrum, gain and standing waves before mixing.
  do i=1,ssb_size
     dchi_ssb(i) = 0.d0
  enddo
  do i=1,2*o_gain*dsb_counter
     dchi_gain(i) = 0.d0
  enddo
  do j=1,n_sw_bm
     do i=1,dsb_counter
        dchi_Asw_bm(i, j)  = 0.d0 ! SW BM amplitude.
        dchi_psw_bm(i, j)  = 0.d0 ! SW BM pulsation.
        dchi_phsw_bm(i, j) = 0.d0 ! SW BM phase.
     enddo
  enddo
  do i=1,ssb_size
     ssb_interm(i) = lssb(i)
  enddo
  ! PART 1: Derivative of chi calculation.
  ! Start the loop on all the channels.
  ! Main calculations are derivative of chi with respect to:
  ! - ssb
  ! - gain
  ! - amplitude, pulsation and phase of SW
  do i=1,dsb_size
     index_signal = (dsb_signal(i)-ssb_first)/ssb_width+1
     index_image  = (dsb_image(i)-ssb_first)/ssb_width+1
     !hogm 23
     !calculate the position of the channel in the IF. The value is between -0.5 and 0.5
     num_scan     = dsb_pointer(i)
     x_signal     = dble((dsb_signal(i)-dsb_rrestf(num_scan))/ssb_width)
     x_signal     = dble((x_signal+dsb_rrchan(num_scan)-dsb_cnchan(num_scan)/2.d0)/dsb_cnchan(num_scan))
     x_image      = dble((dsb_signal(i)-dsb_rimage(num_scan))/ssb_width)
     x_image      = dble((-x_image+dsb_rrchan(num_scan)-dsb_cnchan(num_scan)/2.d0)/dsb_cnchan(num_scan))
     signal_gain  = num_scan
     image_gain   = signal_gain+dsb_counter
     ssb_int(index_signal) = lssb(index_signal)
     ssb_int(index_image ) = lssb(index_image )
     !
     ! FIRST STEP : Convolve lssb by the premixing SW.
     ! Formula is taken from HIFI Standing Waves and their Impact on
     ! Sideband Deconvolution, A First Report by Steve Lord.
     modula_signal_prod = 1.d0
     modula_image_prod  = 1.d0
     do j = 1, n_sw_bm  !loops over all premixing SW
        modula_signal(j)      = 1.d0+lAsw_bm(num_scan,j)*&
             sin(ssb_freq(index_signal)*one_out_of_f*lpsw_bm(num_scan,j)+lphsw_bm(num_scan,j))
        modula_signal_prod    = modula_signal_prod * modula_signal(j)
        ssb_int(index_signal) = ssb_int(index_signal)*modula_signal(j)
        modula_image(j)       = 1.d0+lasw_bm(num_scan,j)*&
             sin(ssb_freq(index_image)*one_out_of_f*lpsw_bm(num_scan,j)+lphsw_bm(num_scan,j))
        modula_image_prod     = modula_image_prod * modula_image(j)
        ssb_int(index_image ) = ssb_int(index_image )*modula_image(j)
     enddo
     !
     ! SECOND STEP : multiply lssb by the gain.
     if (freq_switch) then
        maxthrow  = maxval(abs(chan_throw(num_scan,:)))
        signal_in = (index_signal-maxthrow).ge.1.and.(index_signal+maxthrow).le.ssb_size
        image_in  = (index_image-maxthrow).ge.1.and.(index_image+maxthrow).le.ssb_size
        if (signal_in.and.image_in) then
!!$        if ((index_signal-chan_throw(num_scan,1)).ge.1               &  ! modified to accomodate HIFI throw - CC Jul2011
!!$             .and.(index_signal-chan_throw(num_scan,2)).ge.1         &
!!$             .and.(index_signal-chan_throw(num_scan,1)).le.ssb_size  &
!!$             .and.(index_signal-chan_throw(num_scan,2)).le.ssb_size  &
!!$             .and.(index_image-chan_throw(num_scan,1)).ge.1           &
!!$             .and.(index_image-chan_throw(num_scan,2)).ge.1          &
!!$             .and.(index_image-chan_throw(num_scan,1)).le.ssb_size   &
!!$             .and.(index_image-chan_throw(num_scan,2)).le.ssb_size) then
           ! modified to accomodate HIFI throw - CC Jul2011
           s1 = index_signal-chan_throw(num_scan,1)
           s2 = index_signal-chan_throw(num_scan,2)
           i1 = index_image-chan_throw(num_scan,1)
           i2 = index_image-chan_throw(num_scan,2)
           ssb_int(index_signal) = (throw_poids(num_scan,1)*ssb_interm(s1) &
                + throw_poids(num_scan,2)*ssb_interm(s2))                  &
                * lgain(signal_gain)
           ssb_int(index_image ) = (throw_poids(num_scan,1)*ssb_interm(i1) &
                + throw_poids(num_scan,2)*ssb_interm(i2))                  &
                * lgain(image_gain)
        endif
     else
        if (variable_gain) then
           val_gain_signal= 0.d0
           val_gain_image = 0.d0
           do l=1,o_gain
              val_gain_signal = val_gain_signal+lgain(signal_gain+(l-1)*2*dsb_counter)*(x_signal)**(l-1)
              val_gain_image  = val_gain_image +lgain( image_gain+(l-1)*2*dsb_counter)*(x_image )**(l-1)
           enddo
        else
           ind_gain_sig  = 2*dsb_counter*int(o_gain*(x_signal+0.5D0-1.d-4))+signal_gain
           ind_gain_ima = ind_gain_sig+dsb_counter
           val_gain_signal = lgain(ind_gain_sig)
           val_gain_image  = lgain(ind_gain_ima)
        endif
        ssb_int(index_signal) = ssb_int(index_signal)*val_gain_signal
        ssb_int(index_image ) = ssb_int(index_image )*val_gain_image
     endif
     !
     ! THIRD STEP : do the mixing.
     dsb_int(i) = ssb_int(index_signal) + ssb_int(index_image)
     if ((index_signal.lt.1).or.(index_signal.gt.ssb_size).or.(index_image.lt.1).or.(index_image .gt.ssb_size)) then
        print *,'DELTA_CHI: index out of limits: ', i
        print *,'index_signal, index_image <1 or >ssb_size',index_signal, index_image, ssb_size
        print *, 'ssb_first, ssb_width = ', ssb_first, ssb_width
        print *, 'dsb_sig, dsb_img = ', dsb_signal(i), dsb_image(i)
        ! What to do in this case ???????? PHB
     endif
     ! Calculate dchi.
     dchi = -2.d0*(ddsb_spectrum(i)-dsb_int(i))/(dsb_weight(num_scan)*abs(dsb_size-ssb_size-2*dsb_counter*o_gain))
     ! Derivative of chi with respect to SSB.
     if (no_channels) then
        print *,'NO_CHANNELS'
        dchi_ssb(index_signal) = 0.d0
        dchi_ssb(index_image ) = 0.d0
     else
        if (freq_switch) then
           ! Test was already done above in FREQ_SWITCH case
           ! Shifted SIGNAL and IMAGE channels (s1, s2, i1, i2) are also kept from above
           if (signal_in.and.image_in) then
!!$           if ((index_signal-chan_throw(num_scan,1)).ge.1               &  ! modified according to ssb_int above - CC Jul2011
!!$             .and.(index_signal-chan_throw(num_scan,2)).ge.1         &
!!$             .and.(index_signal-chan_throw(num_scan,1)).le.ssb_size  &
!!$             .and.(index_signal-chan_throw(num_scan,2)).le.ssb_size  &
!!$             .and.(index_image-chan_throw(num_scan,1)).ge.1           &
!!$             .and.(index_image-chan_throw(num_scan,2)).ge.1          &
!!$             .and.(index_image-chan_throw(num_scan,1)).le.ssb_size   &
!!$             .and.(index_image-chan_throw(num_scan,2)).le.ssb_size) then
              dchi_ssb(s1) = dchi_ssb(s1)+throw_poids(num_scan,1)*modula_signal_prod*lgain(signal_gain)*dchi
              dchi_ssb(s2) = dchi_ssb(s2)+throw_poids(num_scan,2)*modula_signal_prod*lgain(signal_gain)*dchi
              dchi_ssb(i1) = dchi_ssb(i1)+throw_poids(num_scan,1)*modula_signal_prod*lgain(image_gain)*dchi
              dchi_ssb(i2) = dchi_ssb(i2)+throw_poids(num_scan,2)*modula_signal_prod*lgain(image_gain)*dchi
!!$                 dchi_ssb(index_signal-chan_throw(num_scan,1)) =       &
!!$                      dchi_ssb(index_signal-chan_throw(num_scan,1)) +  &
!!$                      throw_poids(num_scan,1)*modula_signal_prod * lgain(signal_gain) * dchi
!!$                 dchi_ssb(index_signal-chan_throw(num_scan,2)) =       &
!!$                      dchi_ssb(index_signal-chan_throw(num_scan,2)) +  &
!!$                      throw_poids(num_scan,2)*modula_signal_prod * lgain(signal_gain) * dchi
!!$                 dchi_ssb(index_image-chan_throw(num_scan,1)) =        &
!!$                      dchi_ssb(index_image-chan_throw(num_scan,1)) +   &
!!$                      throw_poids(num_scan,1)*modula_signal_prod * lgain(image_gain) * dchi
!!$                 dchi_ssb(index_image-chan_throw(num_scan,2)) =        &
!!$                      dchi_ssb(index_image-chan_throw(num_scan,2)) +   &
!!$                      throw_poids(num_scan,2)*modula_signal_prod * lgain(image_gain) * dchi
           endif
        else
           if (variable_gain) then
              val_gain_signal= 0.d0
              val_gain_image = 0.d0
              do l=1, o_gain
                 val_gain_signal = val_gain_signal+lgain(signal_gain+(l-1)*2*dsb_counter)*(x_signal)**(l-1)
                 val_gain_image  = val_gain_image +lgain( image_gain+(l-1)*2*dsb_counter)*(x_image )**(l-1)
              enddo
           else
              ind_gain_sig    = 2*dsb_counter*int(o_gain*(x_signal+0.5D0-1.d-4))+signal_gain
              ind_gain_ima    = ind_gain_sig + dsb_counter
              val_gain_signal = lgain(ind_gain_sig)
              val_gain_image  = lgain(ind_gain_ima)
           endif
           val_gain_signal = val_gain_signal*modula_signal_prod*dchi
           val_gain_image  = val_gain_image*modula_image_prod*dchi
           dchi_ssb(index_signal) = dchi_ssb(index_signal)+val_gain_signal
           dchi_ssb(index_image ) = dchi_ssb(index_image )+val_gain_image
        endif
     endif
     ! Derivative of chi with respect to gain parameters.
     if (.not.fit_gains) then     !! CC 19.6.2013
        !hogm it assumed that if no_gain then o_gain = 1
        dchi_gain(signal_gain) = 0.d0
        dchi_gain(image_gain ) = 0.d0
     else
        if (freq_switch) then
           if (signal_in.and.image_in) then
!!$           if ((index_signal-chan_throw(num_scan,1)).ge.1               &  ! modified according to ssb_int above - CC Jul2011
!!$             .and.(index_signal-chan_throw(num_scan,2)).ge.1         &
!!$             .and.(index_signal-chan_throw(num_scan,1)).le.ssb_size  &
!!$             .and.(index_signal-chan_throw(num_scan,2)).le.ssb_size  &
!!$             .and.(index_image-chan_throw(num_scan,1)).ge.1           &
!!$             .and.(index_image-chan_throw(num_scan,2)).ge.1          &
!!$             .and.(index_image-chan_throw(num_scan,1)).le.ssb_size   &
!!$             .and.(index_image-chan_throw(num_scan,2)).le.ssb_size) then
!!$              dchi_gain(signal_gain) = dchi_gain(signal_gain) +      &
!!$                   (throw_poids(num_scan,1)*ssb_interm(index_signal-chan_throw(num_scan,1)) +  &
!!$                   throw_poids(num_scan,2) *ssb_interm(index_signal-chan_throw(num_scan,2)))*   &
!!$                   modula_signal_prod * dchi
!!$              dchi_gain(image_gain ) = dchi_gain(image_gain ) +      &
!!$                   (throw_poids(num_scan,1)*ssb_interm(index_image-chan_throw(num_scan,1)) +    &
!!$                   throw_poids(num_scan,2)*ssb_interm(index_image-chan_throw(num_scan,2)))*  &
!!$                   modula_image_prod * dchi
              dchi_gain(signal_gain) = dchi_gain(signal_gain) + &
                   (throw_poids(num_scan,1)*ssb_interm(s1) +  &
                   throw_poids(num_scan,2) *ssb_interm(s2))*   &
                   modula_signal_prod * dchi
              dchi_gain(image_gain ) = dchi_gain(image_gain ) +      &
                   (throw_poids(num_scan,1)*ssb_interm(i1) +    &
                   throw_poids(num_scan,2)*ssb_interm(i2))*  &
                   modula_image_prod * dchi
           endif
        else
           if( variable_gain ) then
              do l=  1,o_gain
                 dchi_gain(signal_gain+(l-1)*2*dsb_counter) = dchi_gain(signal_gain+(l-1)*2*dsb_counter) +&
                      lssb(index_signal)*((x_signal)**(l-1))*modula_signal_prod*dchi
                 dchi_gain(image_gain +(l-1)*2*dsb_counter) = dchi_gain(image_gain +(l-1)*2*dsb_counter) +&
                      lssb(index_image )*((x_image )**(l-1))*modula_image_prod *dchi
              enddo
           else
              ind_gain_sig  = 2*dsb_counter*int(o_gain*(x_signal+0.5D0-1.d-4))+signal_gain
              ind_gain_ima = ind_gain_sig + dsb_counter
              dchi_gain(ind_gain_sig) = dchi_gain(ind_gain_sig) + lssb(index_signal)*modula_signal_prod*dchi
              dchi_gain(ind_gain_ima) = dchi_gain(ind_gain_ima) + lssb(index_image )*modula_image_prod *dchi
           endif
        endif
     endif
     !
     ! Derivative of chi with respect to SW parameters.
     ! The formulae should be coherent with what has been used in chisquare().
     !
     ! hogm take care not compatible with o_gain larger than 1 since
     ! it is rather unclear whether SW should be corrected here not
     ! clear that this should be done
     !
     do j=1,n_sw_bm  !loops over all premixing SW
        ! Contribution of the signal (upper side) band.
        ! Define some intermediate variables to spare CPU.
        phase = ssb_freq(index_signal)*one_out_of_f*lpsw_bm(num_scan,j)+lphsw_bm(num_scan,j)
        sin_phase = sin(phase)
        amp_cos_phase = lAsw_bm(num_scan, j) * cos(phase)
        dchi_sw = dchi * lssb(index_signal) * lgain(signal_gain)
        do k=1,n_sw_bm
           if (k.ne.j) then
              dchi_sw = dchi_sw*modula_signal(k)
           endif
        enddo
        ! derivation : amplitude.
        if (no_bmswa) then
           dchi_asw_bm(num_scan,j) = 0.d0
        else
           dchi_asw_bm(num_scan,j) = dchi_asw_bm(num_scan,j)+sin_phase*dchi_sw
        endif
        ! Derivation : Pulsation.
        if (no_bmswP) then
           dchi_Psw_bm(num_scan,j) = 0.d0
        else
           dchi_Psw_bm(num_scan,j) = dchi_Psw_bm(num_scan, j) +   &
                ssb_freq(index_signal)*one_out_of_f*amp_cos_phase*dchi_sw
        endif
        ! Derivation : Phase.
        if (no_bmswPh) then
           dchi_Phsw_bm(num_scan,j) = 0.d0
        else
           dchi_Phsw_bm(num_scan,j) = dchi_Phsw_bm(num_scan,j)+amp_cos_phase*dchi_sw
        endif
        ! Contribution of the image (lower side) band.
        ! Define some intermediate variables to spare CPU.
        phase         = ssb_freq(index_image)*one_out_of_f*lpsw_bm(num_scan,j)+lphsw_bm(num_scan,j)
        sin_phase     = sin(phase)
        amp_cos_phase = lAsw_bm(num_scan,j)*cos(phase)
        dchi_sw       = dchi*lssb(index_image)*lgain(image_gain)
        do k = 1, n_sw_bm
           if (k.ne.j) then
              dchi_sw = dchi_sw * modula_image(k)
           endif
        enddo
        ! Derivation : Amplitude.
        if (no_bmswA) then
           dchi_Asw_bm(num_scan,j) = 0.d0
        else
           dchi_Asw_bm(num_scan,j) = dchi_Asw_bm(num_scan, j)+sin_phase*dchi_sw
        endif
        ! Derivation : Pulsation.
        if (no_bmswP) then
           dchi_Psw_bm(num_scan, j) = 0.d0
        else
           dchi_psw_bm(num_scan, j) = dchi_psw_bm(num_scan, j)+     &
                ssb_freq(index_image )*one_out_of_f*amp_cos_phase*dchi_sw
        endif
        ! Derivation : Phase.
        if (no_bmswPh) then
           dchi_Phsw_bm(num_scan, j) = 0.d0
        else
           dchi_phsw_bm(num_scan,j) = dchi_phsw_bm(num_scan,j)+amp_cos_phase*dchi_sw
        endif
     enddo ! do j = 1, n_sw_bm  !loops over all premixing SW
  enddo ! do i = 1, dsb_size
  ! PART 2: Derivative of the entropy.
  ! SSB.
  if (lambda1.ne.0.d0) then
     call derentrop(lssb,norm_ssb_model,ssb_size,dent_ssb)
     do i=1,ssb_size
        dchi_ssb(i) = dchi_ssb(i)-lambda1*dent_ssb(i)
     enddo
  endif
  ! Gain.
  if ((fit_gains).and.(lambda2.gt.0.d0)) then     !! CC 19.6.2013
     !hogm this should be modified to take into account high order gain fitting with entropy
     print*,'calculate the entropy for the gain, not compatible with high order gain fitting'
     dgain(:) = gain(:) ! *** PATCH SB 11-jan-2012
     call derentrop(dgain,norm_gain_model,2*dsb_counter,dent_gain)
     do i=1,2*dsb_counter
        dchi_ssb(i) = dchi_ssb(i)-lambda2*dent_gain(i)
     enddo
  endif
  ! Standing waves before mixing.
  if (lambda3.gt.0.d0) then
     do i = 1, n_sw_bm
        ! Amplitude.
        do j = 1, dsb_counter
           sw_int(j) = lAsw_bm(j,i)
           mod_int(j) = norm_Asw_bm_model(j,i)
        enddo
        call derentrop(sw_int,mod_int,dsb_counter,dent_sw)
        do j = 1,dsb_counter
           dchi_Asw_bm(j,i) = dchi_Asw_bm(j,i)-lambda3*dent_sw(j)
        enddo
        ! Pulsation.
        do j = 1,dsb_counter
           sw_int(j) = lpsw_bm(j,i)
           mod_int(j) = norm_psw_bm_model(j,i)
        enddo
        call derentrop(sw_int,mod_int,dsb_counter,dent_sw)
        do j = 1,dsb_counter
           dchi_psw_bm(j,i) = dchi_psw_bm(j,i)-lambda3*dent_sw(j)
        enddo
        ! Phase.
        ! Entropy is not defined for phase,because no model can be provided.
        do j = 1,dsb_counter
           dchi_phsw_bm(j,i) = dchi_phsw_bm(j,i)-lambda3*dent_sw(j)
        enddo
     enddo
  endif ! Standing waves.
  ! Finally put everything in delta_chisquare.
  call vect_contract(delta_chisquare,dchi_ssb,dchi_gain,dchi_Asw_bm,dchi_psw_bm,dchi_phsw_bm)
  call vect_contract(vect,lssb,lgain,lAsw_bm,lpsw_bm,lphsw_bm)
end subroutine delta_chi
!
!
!
!
!
subroutine derentrop(px,pm,pn,pds)
  use classcore_interfaces, except_this=>derentrop
  use deconv_dsb_commons
  !-------------------------------------------------------------------
  ! @ private
  ! Calculate the entropy derivative of a set of data x and model m of size n.
  ! The formula is: entropy = S = sum ((xi/X) * log((xi/X) / Mi)).
  ! Where X = sum(xi). It is therefore assumed that Mi = mi / M. M = sum(mi).
  ! If no model is used then Mi = 1. (see init_mem()).
  ! The derivative of the entropy is:
  ! dS_dvect(i) = 1. / X * (log(xi / X / Mi) - S)
  !
  ! ??????????????? PHB: is it definitive ?
  ! Presently (10/02/05), wherever the model is used, its values are
  ! divided by sum(ssb_model). In order to spare CPU, we (PH and BD)
  ! have decided to divide it once for all. The sum must be kept in
  ! memory because makemodel() should be able to restore ssb_model's
  ! original value. The division is made in put_model() or init_mem()
  ! and need not to be done once again just before calling derentrop().
  !-------------------------------------------------------------------
  integer(kind=4), intent(in)    :: pn      ! logical size of px and pm.
  real(kind=8),    intent(inout) :: px(pn)  ! x
  real(kind=8),    intent(in)    :: pm(pn)  ! m
  real(kind=8),    intent(out)   :: pds(pn)
  ! Local
  integer(kind=4) :: i,j
  real(kind=8), parameter :: epsilon=1.d-10
  real(kind=8), dimension(pn) :: log_xi_x_mi
  real(kind=8)  :: sumx,xi_x,xs ! Sum of px, px(i)/x, entropy.
  !
  ! Sum of px.
  sumx = 0.d0
  do i=1,pn
     if (px(i).le.epsilon) px(i)=epsilon
     if ((px(i).le.0.d0).or.(pm(i).le.0.d0)) then
        print*, 'Error DERENTROP: model is 0 or negative.'
        do j = i - 15, i + 15
           if (j.ge.1 .and. j.le.pn) then
              print*, 'i, data, model ', i, px(i), pm(i)
           endif
        enddo
        STOP
     endif
     sumx = sumx+px(i)
  enddo
  ! Entropy.
  xs = 0.d0
  do i=1,pn
     xi_x           = px(i)/sumx
     log_xi_x_mi(i) = log(xi_x/pm(i))
     xs             = xs+xi_x*log_xi_x_mi(i)
  enddo
  ! Derivative.
  do i=1,pn
     pds(i) = (log_xi_x_mi(i)-xs)/sumx
  enddo
end subroutine derentrop

module gauss_2d_data
  use image_def
  type(gildas), save :: xima
  !
  ! Former 'ellipse.inc':
  real(kind=4) :: spar(10),kpar(10),sigbas,sigrai,par(10),err(10)
  real, allocatable :: array(:,:)
  integer(kind=index_length) :: t_dim(2)
  real(kind=8) :: t_ref1, t_ref2
  !
end module gauss_2d_data
!
program gauss_2d
  use gildas_def
  use image_def
  use gkernel_interfaces
  use fit_minuit
  use gauss_2d_data
  !---------------------------------------------------------------------
  ! Make a 2-D gaussfit to a part of an image
  !---------------------------------------------------------------------
  ! Global
  external :: min2d
  ! Local
  type(fit_minuit_t) :: fit
  character(len=filename_length) :: in_name,out_name,name,res_name
  logical :: error, do_res
  real :: upar(20),s
  integer :: i,i3, i4, blc(4), trc(4), lun, ier
  type(gildas) :: y
  !
  ! Read commands
  call gildas_open
  call gildas_char('IN$',in_name)
  call gildas_char('OUT$',out_name)
  call gildas_logi('DO_RES$',do_res,1)
  if (do_res) then
    call gildas_char('RES$',res_name)
  endif
  call gildas_real('MAX_INT$',upar(1:2),2)
  call gildas_real('X_POS$',upar(3:4),2)
  call gildas_real('Y_POS$',upar(5:6),2)
  call gildas_real('MAJOR$',upar(7:8),2)
  call gildas_real('MINOR$',upar(9:10),2)
  call gildas_real('POSANG$',upar(11:12),2)
  call gildas_inte('BLC$',blc,4)
  call gildas_inte('TRC$',trc,4)
  call gildas_real('SIGMA$',s,1)
  call gildas_close
  fit%verbose=.false.
  !
  ! Read input map
  call gildas_null(xima, type = 'IMAGE')
  call gdf_read_gildas(xima, in_name, '.gdf', error, rank=4)
  !
  ! Create map  of residuals  (Y common)
  if (do_res) then
    call gildas_null (y, type = 'IMAGE')
    call gdf_copy_header(xima,y,error)
    call sic_parsef(res_name,y%file,' ','.gauss-res')
    call gagout('I-GAUSS_2D,  Creating residuals image '//y%file)
    call gdf_create_image (y, error)
    if (error) then
      call gagout('F-GAUSS_2D,  Cannot create residuals table')
      goto 99
    endif
    y%gil%ndim = 4
    call gdf_allocate(y,error)
  endif
  !
  ! Open listing file
  call sic_parsef(out_name,name,' ','.gauss')
  lun = 1
  ier = sic_open(lun,name,'NEW',.false.)
  !
  do i=1,4
    if (blc(i).eq.0) then
      blc(i) = 1
    else
      blc(i) = max(1,min(xima%gil%dim(i),blc(i)))
    endif
  enddo
  do i=1,4
    if (trc(i).eq.0) then
      trc(i) = xima%gil%dim(i)
    else
      trc(i) = max(blc(i),min(xima%gil%dim(i),trc(i)))
    endif
  enddo
  !
  t_dim(1) = trc(1)-blc(1)+1
  t_dim(2) = trc(2)-blc(2)+1
  t_ref1 = xima%gil%ref(1)-blc(1)+1
  t_ref2 = xima%gil%ref(2)-blc(2)+1
  allocate (array(t_dim(1),t_dim(2)),stat=ier)
  if (ier.ne.0) goto 99
  !
  do i4 = blc(4), trc(4)
    do i3 = blc(3), trc(3)
      write (6,*) 'Plane ',i3,i4,' starting'
      do i=1,6
        spar(i) = upar(2*i-1)
        kpar(i) = upar(2*i)
      enddo
      sigbas = s
      sigrai = s
      ! Extract one plane
      call ext2d(xima%r4d(:,:,i3,i4),xima%gil%dim(1),xima%gil%dim(2),  &
                 array,              t_dim(1),       t_dim(2),         &
                 blc,trc)
      ! Fit the gaussian
      call fit2d(fit,min2d,.false.,error)
      ! Get residuals
      if (do_res) then
        call res2d(xima%r4d(:,:,i3,i4),xima%gil%dim(1),xima%gil%dim(2),  &
                y%r4d(:,:,i3,i4),                                        &
                xima%gil%ref(1),xima%gil%val(1),xima%gil%inc(1),         &
                xima%gil%ref(2),xima%gil%val(2),xima%gil%inc(2),         &
                xima%gil%bval,xima%gil%eval)
      endif
      ! Write the results to listing file
      call wri2d (lun,i3,i4)
    enddo
  enddo
  if (do_res) then
    call gdf_write_data(y, y%r4d, error)
    call gdf_close_image (y, error)
  endif
  call gdf_close_image (xima,error)
  stop 'S-GAUSS_2D,  Successful completion'
  !
99 call sysexi (fatale)
end program gauss_2d
!
subroutine ext2d(x,nx1,nx2,y,ny1,ny2,blc,trc)
  use gildas_def
  !---------------------------------------------------------------------
  ! Extract the relevant part of one plane in the image
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nx1         !
  integer(kind=index_length), intent(in) :: nx2         !
  real(kind=4),               intent(in) :: x(nx1,nx2)  !
  integer(kind=index_length), intent(in) :: ny1         !
  integer(kind=index_length), intent(in) :: ny2         !
  real(kind=4)                           :: y(ny1,ny2)  !
  integer(kind=4),            intent(in) :: blc(4)      !
  integer(kind=4),            intent(in) :: trc(4)      !
  ! Local
  integer(kind=4) :: j,l
  l = 1
  do j=blc(2),trc(2)
    call r4tor4 (x(blc(1),j),y(1,l),trc(1)-blc(1)+1)
    l = l+1
  enddo
end subroutine ext2d
!
subroutine wri2d (lun, i, j)
  use gildas_def
  use gauss_2d_data
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  integer :: lun                    !
  integer :: i                      ! I, J = plane number
  integer :: j                      !
  ! Local
  real aa
  !
  if (par(4).lt.par(5)) then
    par(6) = par(6)+90.
    aa = par(4)
    par(4) = par(5)
    par(5) = aa
  endif
  par(6) = -90.+mod(par(6)+3690.,180.)
  ! Writing result in arc second is 1) in contradistinction with the doc
  ! and 2) incompatible with GILDAS philosophy for Xinc, Yinc.
  write (lun,100) par(1),err(1),par(2),err(2)   &
     &    ,par(3),err(3),par(4),err(4)   &
     &    ,par(5),err(5),par(6),err(6), i, j
100 format(12(1x,g10.4),2(1x,i4))
end subroutine wri2d
!
subroutine res2d (map,nx,ny,res,xref,xval,xinc,yref,yval,yinc,bad,tol)
  use gildas_def
  use gauss_2d_data
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nx  !
  integer(kind=index_length), intent(in) :: ny  !
  real :: map(nx,ny)                !
  real :: res(nx,ny)                !
  real*8 :: xref                    !
  real*8 :: xval                    !
  real*8 :: xinc                    !
  real*8 :: yref                    !
  real*8 :: yval                    !
  real*8 :: yinc                    !
  real :: bad                       !
  real :: tol                       !
  ! Local
  real :: far,sfar
  parameter (far=24.0, sfar=5.0)
  integer :: i,j
  real :: x,y
  real :: i0, x0,y0,a,b,alpha
  real :: t1,t2, gint, gg, ca, sa
  real :: zz
  real*8 :: pi
  parameter (pi=3.141592653589793d0)
  !
  i0 = par(1)
  x0 = par(2)
  y0 = par(3)
  a = par(4)/2.0/sqrt(log(2.0))
  b = par(5)/2.0/sqrt(log(2.0))
  alpha = (par(6)-90)*pi/180.
  ca = cos(alpha)
  sa = sin(alpha)
  do j = 1,ny
    y = (j-yref)*yinc+yval
    do i = 1,nx
      zz = map(i,j)
      if (abs(zz-bad).gt.tol) then
        x = (i-xref)*xinc+xval
        t1 = ca * (x - x0) + sa * (y - y0)
        t2 = sa * (x - x0) - ca * (y - y0)
        gint = (t1/a)**2 + (t2/b)**2
        if (gint.ge.far) then
          res(i,j)= zz
        else
          gg = exp(-gint)
          res(i,j) = zz-i0*gg
        endif
      else
        res(i,j)= zz
      endif
    enddo
  enddo
end subroutine res2d
!
subroutine fit2d(fit,fcn,liter,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use fit_minuit
  use gauss_2d_data
  !---------------------------------------------------------------------
  ! SAS	Internal routine
  !	Setup and starts a GAUSS fit minimisation using MINUIT
  !---------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit    !
  external                          :: fcn    ! Function to be mininized
  logical,            intent(in)    :: liter  ! Logical of iterate fit
  logical                           :: error  ! Logical error flag Output
  ! Local
  real*8, parameter :: pi=3.141592653589793d0
  integer :: i,k,l,ifatal,ier
  real*8 :: dx,al,ba,du1,du2
  real :: sec
  character(len=message_length) :: mess
  !
  error = .false.
  fit%isyswr=6
  fit%maxext=ntot
  fit%maxint=nvar
  !
  ! Initialise values
  call mid2d(fit,ifatal,liter)
  if (ifatal.ne.0) then
    error = .true.
    return
  endif
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  write(fit%isyswr,*) 'Sigmas 1:',sigbas,sigrai
  fit%up = sigbas**2
  fit%nfcnmx = 5000
  fit%epsi   = 0.1d0 * fit%up
  fit%newmin = 0
  fit%itaur  = 0
  fit%isw(1) = 0
  fit%isw(3) = 1
  fit%nfcn   = 1
  fit%vtest  = 0.04
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,1)
  !
  ! Simplex Minimization
  if (.not.liter) then
    call simplx(fit,fcn,ier)
    ! Error Patch in Case of bad behaved Function
    if (ier.ne.0) then
      error=.true.
      return
    endif
    do k=1,fit%nu
      par(k) = fit%u(k)
    enddo
  endif
  !
  ! Gradient Minimization
  fit%nfcnmx = 5000
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  write(fit%isyswr,*) 'Sigmas 2:',sigbas,sigrai
  fit%up = sigbas**2
  fit%epsi  = 0.1d0 * fit%up
  fit%apsi  = fit%epsi
  call hesse(fit,fcn)
  call migrad(fit,fcn,ier)
  ! CALL HESSE fait par FITGAU si IER = 1
  if (ier.eq.1) then
    ier=0
    error=.false.
    call hesse(fit,fcn)
  endif
  !
  ! Print Results
  do k=1,fit%nu
    par(k)  = fit%u(k)
  enddo
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  write(fit%isyswr,*) 'Sigmas 3:',sigbas,sigrai
  fit%up  = sigbas**2
  !
  ! Calculate External Errors
  do i=1,fit%nu
    l  = fit%lcorsp(i)
    if (l .eq. 0)  then
      fit%werr(i)=0.
    else
      if (fit%isw(2) .ge. 1)  then
        dx = dsqrt(dabs(fit%v(l,l)*fit%up))
        if (fit%lcode(i) .gt. 1) then
          al = fit%alim(i)
          ba = fit%blim(i) - al
          du1 = al + 0.5d0 *(dsin(fit%x(l)+dx) +1.0d0) * ba - fit%u(i)
          du2 = al + 0.5d0 *(dsin(fit%x(l)-dx) +1.0d0) * ba - fit%u(i)
          if (dx .gt. 1.0d0)  du1 = ba
          dx = 0.5d0 * (dabs(du1) + dabs(du2))
        endif
        fit%werr(i) = dx
      endif
    endif
  enddo
  !
  if (sigbas.lt.sigrai/1.5 .or. sigbas.gt.1.5*sigrai) then
    write(fit%isyswr,*) 'I-GAUSS,  Bad fit'
  else
    write(fit%isyswr,*) 'I-GAUSS,  Good fit'
  endif
  !
  ! Setup results
  sec = 3600*180/pi
  par(1) = fit%u(1)
  err(1) = fit%werr(1)
  write(mess,*) 'Peak Intensity ',par(1),err(1)
  call gagout(mess)
  !
  par(2) = fit%u(2)
  err(2) = fit%werr(2)
  write(mess,*) 'X Position ',par(2),err(2),par(2)*sec,err(2)*sec
  call gagout(mess)
  !
  par(3) = fit%u(3)
  err(3) = fit%werr(3)
  write(mess,*) 'Y Position ',par(3),err(3),par(3)*sec,err(3)*sec
  call gagout(mess)
  !
  par(4) = 2.0*sqrt(log(2.0))*fit%u(4)
  err(4) = 2.0*sqrt(log(2.0))*fit%werr(4)
  write(mess,*) 'Major axis ',par(4),err(4),par(4)*sec,err(4)*sec
  call gagout(mess)
  !
  par(5) = 2.0*sqrt(log(2.0))*fit%u(5)
  err(5) = 2.0*sqrt(log(2.0))*fit%werr(5)
  write(mess,*) 'Minor axis ',par(5),err(5),par(5)*sec,err(5)*sec
  call gagout(mess)
  !
  par(6) = fit%u(6)*180.0/pi+90.0
  err(6) = fit%werr(6)*180.0/pi
  write(mess,*) 'Position Angle',par(6),err(6)
  call gagout(mess)
  !
end subroutine fit2d
!
subroutine mid2d(fit,ifatal,liter)
  use gkernel_interfaces
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use fit_minuit
  use gauss_2d_data
  !---------------------------------------------------------------------
  ! ANALYSE	Internal routine
  !	Start a gaussian fit by building the PAR array and internal
  !	variable used by Minuit
  !---------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit     !
  integer,            intent(out)   :: ifatal  ! Number of fatal errors
  logical,            intent(in)    :: liter   ! Iterate a fit
  ! Local
  real*8, parameter :: pi=3.141592653589793d0
  integer :: i, nint, k
  real*8 :: sav, sav2, vplu, vminu
  real :: sln2
  character(len=message_length) :: mess
  !
  sln2 = 2.0*sqrt(log(2.0))
  !
  do i= 1, 7
    fit%isw(i) = 0
  enddo
  fit%sigma = 0.d0
  fit%npfix = 0
  nint = 0
  fit%nu = 0
  fit%npar = 0
  ifatal = 0
  do i= 1, fit%maxext
    fit%u(i) = 0.0d0
    fit%lcode(i) = 0
    fit%lcorsp (i) = 0
  enddo
  fit%isw(5) = 1
  !
  ! Starting values
  par(1) = spar(1)             ! Intensite
  fit%u(1) = par(1)
  if (kpar(1).eq.1) then
    fit%werr(1)=0.
  else
    fit%werr(1) = abs(0.1*fit%u(1))
    ! if (liter) fit%werr(1) = err(1)
    if (fit%u(1).lt.0) then
      fit%alim(1) = 100.*fit%u(1)
      fit%blim(1) = 0.01*fit%u(1)
    else
      fit%blim(1) = 100.*fit%u(1)
      fit%alim(1) = 0.01*fit%u(1)
    endif
  endif
  !
  par(2) = spar(2)             ! X Position
  fit%u(2) = par(2)
  if (kpar(2).eq.1) then
    fit%werr(2)=0.
  else
    fit%werr(2) = abs(3.0*xima%gil%inc(1))
    ! if (liter) fit%werr(2) = err(2)
    fit%alim(2) = fit%u(2) - 40.*fit%werr(2)
    fit%blim(2) = fit%u(2) + 40.*fit%werr(2)
  endif
  !
  par(3) = spar(3)             ! Y Position
  fit%u(3) = par(3)
  if (kpar(3).eq.1) then
    fit%werr(3)=0.
  else
    fit%werr(3) = abs(3.0*xima%gil%inc(2))
    ! if (liter) fit%werr(3) = err(3)
    fit%alim(3) = fit%u(3) - 40.*fit%werr(3)
    fit%blim(3) = fit%u(3) + 40.*fit%werr(3)
  endif
  !
  par(4) = spar(4) / sln2      ! Major axis
  fit%u(4) = par(4)
  if (kpar(4).eq.1) then
    fit%werr(4)=0.
  else
    fit%werr(4) = 3.0*sqrt(abs(xima%gil%inc(2)*xima%gil%inc(1))) / sln2
    ! if (liter) fit%werr(4) = err(4) / sln2
    fit%alim(4) = fit%werr(4)/9.0
    fit%blim(4) = max(abs(xima%gil%dim(1)*xima%gil%inc(1)),abs(xima%gil%dim(2)*xima%gil%inc(2)))*3.0/ sln2
  endif
  !
  par(5) = spar(5) / sln2      ! Minor axis
  fit%u(5) = par(5)
  if (kpar(5).eq.1) then
    fit%werr(5)=0.
  else
    fit%werr(5) = fit%werr(4)
    ! if (liter) fit%werr(5) = err(5) / sln2
    fit%alim(5) = fit%alim(4)
    fit%blim(5) = fit%blim(4)
  endif
  !
  par(6) = spar(6)*pi/180.0    ! Position Angle
  fit%u(6) = par(6)
  if (kpar(6).eq.1) then
    fit%werr(6)=0.
  else
    fit%werr(6) = pi/8.0
    ! if (liter) fit%werr(6)=err(6)*180.0/pi
    fit%alim(6) = fit%u(6)-pi/4.0
    fit%blim(6) = fit%u(6)+pi/4.0
  endif
  !
  fit%nu = 6
  !
  ! Various checks
  do k=1,fit%nu
    if (k .le. fit%maxext)  go to 115
    ifatal = ifatal + 1
    go to 160
115 if (fit%werr(k) .gt. 0.0d0)  go to 122
    ! Fixed parameter
    fit%lcode(k) = 0
    write(mess,1010) k,' is fixed'
    call gagout('W-MID2D,  '//mess)
    go to 160
    ! Variable parameter
122 nint = nint + 1
    if (fit%lcode(k).eq.1) go to 160
    fit%lcode(k) = 4
    if ((fit%blim(k)-fit%u(k))*(fit%u(k)-fit%alim(k)))  153,155,160
153 ifatal = ifatal + 1
    write (fit%isyswr,1011) k,fit%alim(k),fit%blim(k)
    go to 160
155 if (k.gt.3) then
      write(mess,1010) k,' is at limit'
      call gagout('W-MID2D,  '//mess)
    endif
160 continue
  enddo
  !
  ! End parameter cards
  ! Stop if fatal error
  if (nint .gt. fit%maxint)  then
    write (fit%isyswr,1008)  nint,fit%maxint
    ifatal = ifatal + 1
  endif
  if (nint .eq. 0) then
    write (fit%isyswr,1009)
    ifatal = ifatal + 1
  endif
  if (ifatal .gt. 0)  then
    write (fit%isyswr,1013)  ifatal
    return
  endif
  !
  ! O.K. Start
  ! Calculate step sizes DIRIN
  fit%npar = 0
  do k= 1, fit%nu
    if (fit%lcode(k) .gt. 0)  then
      fit%npar = fit%npar + 1
      fit%lcorsp(k) = fit%npar
      sav = fit%u(k)
      fit%x(fit%npar) = pintf(fit,sav,k)
      fit%xt(fit%npar) = fit%x(fit%npar)
      sav2 = sav + fit%werr(k)
      vplu = pintf(fit,sav2,k) - fit%x(fit%npar)
      sav2 = sav - fit%werr(k)
      vminu = pintf(fit,sav2,k) - fit%x(fit%npar)
      fit%dirin(fit%npar) = 0.5d0 * (dabs(vplu) +dabs(vminu))
    endif
  enddo
  return
  !
1008 format (' Too many variable parameters.  You request ',i5/,  &
               ' This version of MINUIT is only dimensioned for ',i4)
1009 format (' All input parameters are fixed')
1010 format (' Warning - Parameter ',i2,' ',a)
1011 format (' Error - Parameter ',i2,' outside limits ',1pg11.4,1x,1pg11.4)
1013 format (1x,i3,' Errors on input parameters. ABORT.')
end subroutine mid2d
!
subroutine min2d (npar,g,f,var,iflag)
  use gkernel_interfaces
  use gildas_def
  use gauss_2d_data
  integer :: npar                   !
  real*8 :: g(npar)                 !
  real*8 :: f                       !
  real*8 :: var(npar)               !
  integer :: iflag                  !
  ! Local
  real :: xref,xval,xinc, yref,yval,yinc
  !
  xref = t_ref1
  xval = xima%gil%val(1)
  xinc = xima%gil%inc(1)
  yref = t_ref2
  yval = xima%gil%val(2)
  yinc = xima%gil%inc(2)
  call mn2d(npar,g,f,var,iflag,array,t_dim(1),t_dim(2),xref,xval,xinc,  &
  yref,yval,yinc,xima%gil%bval,xima%gil%eval,sigbas,sigrai)
end subroutine min2d
!
subroutine mn2d(npar,g,f,var,iflag,map,nx,ny,xref,xval,xinc,yref,yval,yinc,  &
  bad,tol,sigbas,sigrai)
  use gildas_def
  !---------------------------------------------------------------------
  ! Let
  !	t1 : (x-x0) Cos[alpha] + (y-y0) Sin[alpha]
  !	t2 : (x-x0) Sin[alpha] - (y-y0) Cos[alpha]
  ! Then
  ! 	dt&NAME : D[t&,NAME]
  ! Let
  !	g : i0 Exp[-t1^2/(a^2) - t2^2/(b^2)]
  ! Then
  !	dgNAME : D[g,NAME]/g
  !---------------------------------------------------------------------
  integer(kind=4)            :: npar
  real(kind=8)               :: g(npar)
  real(kind=8)               :: f
  real(kind=8)               :: var(npar)
  integer(kind=4)            :: iflag
  integer(kind=index_length) :: nx
  integer(kind=index_length) :: ny
  real(kind=4)               :: map(nx,ny)
  real(kind=4)               :: xref
  real(kind=4)               :: xval
  real(kind=4)               :: xinc
  real(kind=4)               :: yref
  real(kind=4)               :: yval
  real(kind=4)               :: yinc
  real(kind=4)               :: bad
  real(kind=4)               :: tol
  real(kind=4)               :: sigbas
  real(kind=4)               :: sigrai
  ! Local
  real(kind=4), parameter :: far=24.0
  real(kind=4), parameter :: sfar=5.0
  logical :: dograd,dosig
  integer(kind=index_length) :: i,j
  integer(kind=4) :: nrai,nbas
  real(kind=4) :: x,y
  real(kind=4) :: i0, x0,y0,a,b,alpha
  real(kind=4) :: dfx0,dfy0,dfa,dfb,dfalp
  real(kind=4) :: dgx0,dgy0,dga,dgb,dgalp
  real(kind=4) :: dt1x0,dt1y0,dt1alp
  real(kind=4) :: dt2x0,dt2y0,dt2alp
  real(kind=4) :: dgt1,dgt2
  real(kind=4) :: t1,t2, gint, gsxy, gd,gg, ca, sa
  real(kind=4) :: zz, frai, fbas
  !
  if (iflag.eq.3) then
    dosig = .true.
    nbas = 0
    nrai = 0
  endif
  dograd = iflag.eq.2
  !
  ! Setup
  i0 = var(1)
  x0 = var(2)
  y0 = var(3)
  a = var(4)
  b = var(5)
  alpha = var(6)
  dfx0 = 0.0
  dfy0 = 0.0
  dfa = 0.0
  dfb = 0.0
  dfalp = 0.0
  !
  ! Constants
  ca = cos(alpha)
  sa = sin(alpha)
  !
  ! Constant intermediate values for derivatives
  if (dograd) then
    dt1y0 = - sa
    dt1x0 = - ca
    dt2x0 = - sa
    dt2y0 = ca
  endif
  !
  ! Preliminaries
  fbas = 0.0
  frai = 0.0
  gsxy = 0.0
  do j=1,ny
    y = (j-yref)*yinc+yval
    if (abs(y-y0).gt.sfar*a) then
      do i=1,nx
        zz = map(i,j)
        if (abs(zz-bad).gt.tol) then
          fbas = fbas + zz*zz
          if (dosig) nbas = nbas+1
        endif
      enddo
      cycle                    ! J
    endif
    do i=1,nx
      zz = map(i,j)
      if (abs(zz-bad).le.tol) cycle    ! I
      x = (i-xref)*xinc+xval
      t1 = ca * (x - x0) + sa * (y - y0)
      t2 = sa * (x - x0) - ca * (y - y0)
      gint = (t1/a)**2 + (t2/b)**2
      !
      ! Skip zero values
      if (gint.ge.far) then
        fbas = fbas + zz*zz
        if (dosig) nbas = nbas+1
        cycle                  ! I
      endif
      !
      ! Function
      gg = exp(-gint)
      gd = i0*gg-zz
      frai = frai + gd*gd      ! sum of squares
      !
      if (dograd) then
        dt1alp = - t2
        dt2alp = t1
        dgt1 = - 2*t1/a/a
        dgt2 = - 2*t2/b/b
        dga = -t1*dgt1/a
        dgb = -t2*dgt2/b
        dgx0 = dgt1 * dt1x0 + dgt2 * dt2x0
        dgy0 = dgt1 * dt1y0 + dgt2 * dt2y0
        dgalp = dgt1 * dt1alp + dgt2 * dt2alp
        !
        gg = 2*gd*gg
        gsxy = gsxy + gg
        gg = i0*gg
        !
        dfx0 = dfx0 + dgx0*gg
        dfy0 = dfy0 + dgy0*gg
        dfalp = dfalp + dgalp*gg
        dfa = dfa + dga*gg
        dfb = dfb + dgb*gg
      endif
      if (dosig) nrai = nrai+1
    enddo                      ! I
  enddo                        ! J
  !
  if (dosig) then
    if (nbas.ne.0) then
      sigbas = sqrt (fbas/nbas)
      if (nrai.ne.0) then
        sigrai = sqrt (frai/nrai)
      else
        sigrai = sigbas
      endif
    else
      if (nrai.ne.0) sigrai = sqrt (frai/nrai)
      sigbas = sigrai
    endif
  endif
  f = fbas+frai
  if (.not.dograd) return
  !
  g(1) = gsxy/i0
  g(2) = dfx0
  g(3) = dfy0
  g(4) = dfa
  g(5) = dfb
  g(6) = dfalp
  !
end subroutine mn2d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBE IO messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeio_messaging
  use gpack_def
  use gbl_message
  use gkernel_interfaces
  use cubetools_parameters
  !
  public :: ioseve,seve,mess_l
  public :: cubeio_message_set_id,cubeio_message
  public :: cubeio_message_set_alloc,cubeio_message_get_alloc
  public :: cubeio_message_set_trans,cubeio_message_get_trans
  public :: cubeio_message_set_trace,cubeio_message_get_trace
  public :: cubeio_message_set_others,cubeio_message_get_others
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubeio_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubeio_messaging_debug_t
     integer(kind=code_k) :: alloc = seve%d
     integer(kind=code_k) :: trans = seve%d
     integer(kind=code_k) :: trace = seve%t
     integer(kind=code_k) :: others = seve%d
  end type cubeio_messaging_debug_t
  !
  type(cubeio_messaging_debug_t) :: ioseve
  !
contains
  !
  subroutine cubeio_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubeio_message_id = id
    write (mess,'(A,I0)') 'Now use id #',cubeio_message_id
    call cubeio_message(seve%d,rname,mess)
  end subroutine cubeio_message_set_id
  !
  subroutine cubeio_message(mkind,procname,message)
    !$ use omp_lib
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! @ private
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    ! Local
    integer(kind=4) :: nc
    logical :: parallel
    integer(kind=4), parameter :: mc=32
    character(len=mc) :: myprocname
    !
    parallel = .false.
    !$ parallel = OMP_IN_PARALLEL()
    if (parallel) then
      nc = len_trim(procname)
      if (nc.gt.mc-8)  nc = mc-8  ! Leave room for "IO>" (3 leading chars) and
                                  ! "(999)" (5 trailing chars)
      !$ write (myprocname,'(A3,A,A1,I0,A1)')  &
      !$   'IO>',procname(1:nc),'(',OMP_GET_THREAD_NUM(),')'
    else
      myprocname = 'IO>'//procname  ! Implicit truncation
    endif
    call cubetools_cmessage(cubeio_message_id,mkind,myprocname,message)
  end subroutine cubeio_message
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeio_message_set_alloc(on)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    logical, intent(in) :: on
    if (on) then
       ioseve%alloc = seve%i
    else
       ioseve%alloc = seve%d
    endif
  end subroutine cubeio_message_set_alloc
  !
  subroutine cubeio_message_set_trans(on)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    logical, intent(in) :: on
    if (on) then
       ioseve%trans = seve%i
    else
       ioseve%trans = seve%d
    endif
  end subroutine cubeio_message_set_trans
  !
  subroutine cubeio_message_set_trace(on)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    logical, intent(in) :: on
    if (on) then
       ioseve%trace = seve%i
    else
       ioseve%trace = seve%t
    endif
  end subroutine cubeio_message_set_trace
  !
  subroutine cubeio_message_set_others(on)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    logical, intent(in) :: on
    if (on) then
       ioseve%others = seve%i
    else
       ioseve%others = seve%d
    endif
  end subroutine cubeio_message_set_others
  !
  !---------------------------------------------------------------------
  !
  function cubeio_message_get_alloc()
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    logical :: cubeio_message_get_alloc
    cubeio_message_get_alloc = ioseve%alloc.eq.seve%i
  end function cubeio_message_get_alloc
  !
  function cubeio_message_get_trans()
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    logical :: cubeio_message_get_trans
    cubeio_message_get_trans = ioseve%trans.eq.seve%i
  end function cubeio_message_get_trans
  !
  function cubeio_message_get_trace()
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    logical :: cubeio_message_get_trace
    cubeio_message_get_trace = ioseve%trace.eq.seve%i
  end function cubeio_message_get_trace
  !
  function cubeio_message_get_others()
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    logical :: cubeio_message_get_others
    cubeio_message_get_others = ioseve%others.eq.seve%i
  end function cubeio_message_get_others
  !
end module cubeio_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeio_block
  !---------------------------------------------------------------------
  ! Define a "monoblock" type which reflects the way the data is stored
  ! in file
  !---------------------------------------------------------------------
  use cubetools_parameters
  use cubetools_setup_types
  use cubeio_messaging

  type cubeio_block_t
    integer(kind=4)            :: order = code_null ! UVT or TUV order?
    logical                    :: iscplx = .false.  ! R*4 or C*4?
    real(kind=sign_k),    allocatable :: r4(:,:,:)  ! [nx,ny,nc] (LMV) or [nc,nx,ny] (VLM) R*4 cube slice
    complex(kind=sign_k), allocatable :: c4(:,:,:)  ! [nx,ny,nc] (LMV) or [nc,nx,ny] (VLM) C*4 cube slice
    integer(kind=index_length) :: dim1              ! First dimension (size of alloc), strict
    integer(kind=index_length) :: dim2              ! Second dimension (size of alloc), strict
    integer(kind=index_length) :: dim3              ! Third dimension (size of alloc), maximum available
    integer(kind=index_length) :: first             ! First element of last dimension mapped by the block
    integer(kind=index_length) :: last              ! Last element of last dimension mapped by the block
    logical                    :: readwrite         ! Is this block opened read-only or read-write?
  contains
    procedure, public :: reallocate123 => cubeio_block_reallocate_123
    procedure, public :: reallocatexyc => cubeio_block_reallocate_xyc
    procedure, public :: free          => cubeio_block_free
    procedure, public :: memsize       => cubeio_block_memsize
  end type cubeio_block_t

  public :: cubeio_block_t
  private

contains

  subroutine cubeio_block_reallocate_xyc(block,iscplx,nx,ny,nc,order,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate a cubeio_block_t
    ! Do nothing when the array sizes do not need to change.
    ! ---
    ! This version with nx ny nc as argument
    !-------------------------------------------------------------------
    class(cubeio_block_t), intent(inout) :: block
    logical,               intent(in)    :: iscplx
    integer(kind=pixe_k),  intent(in)    :: nx
    integer(kind=pixe_k),  intent(in)    :: ny
    integer(kind=chan_k),  intent(in)    :: nc
    integer(kind=code_k),  intent(in)    :: order
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='BLOCK>REALLOCATE>XYC'
    integer(kind=data_k) :: dim1,dim2,dim3
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    ! Sanity checks
    if (nx.lt.0) then
      call cubeio_message(seve%e,rname,'Number of X pixels is null or negative')
      error = .true.
    endif
    if (ny.lt.0) then
      call cubeio_message(seve%e,rname,'Number of Y pixels is null or negative')
      error = .true.
    endif
    if (nc.lt.0) then
      call cubeio_message(seve%e,rname,'Number of channels is null or negative')
      error = .true.
    endif
    if (error)  return
    !
    select case (order)
    case (code_cube_imaset)
      dim1 = max(1,nx)
      dim2 = max(1,ny)
      dim3 = max(1,nc)
    case (code_cube_speset)
      dim1 = max(1,nc)
      dim2 = max(1,nx)
      dim3 = max(1,ny)
    case default
      call cubeio_message(seve%e,rname,'Unsupported data order')
      error = .true.
      return
    end select
    !
    call cubeio_block_reallocate_123(block,iscplx,dim1,dim2,dim3,order,error)
    if (error)  return
    !
  end subroutine cubeio_block_reallocate_xyc

  subroutine cubeio_block_reallocate_123(block,iscplx,dim1,dim2,dim3,order,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate a cubeio_block_t
    ! Do nothing when the array sizes do not need to change.
    ! ---
    ! This version with dim1 dim2 dim3 as argument
    !-------------------------------------------------------------------
    class(cubeio_block_t), intent(inout) :: block
    logical,               intent(in)    :: iscplx
    integer(kind=data_k),  intent(in)    :: dim1
    integer(kind=data_k),  intent(in)    :: dim2
    integer(kind=data_k),  intent(in)    :: dim3
    integer(kind=code_k),  intent(in)    :: order
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='BLOCK>REALLOCATE>123'
    integer(kind=4) :: ier
    logical :: calloc
    !
    ! Allocation or reallocation?
    if (block%iscplx) then
      calloc = allocated(block%c4)
    else
      calloc = allocated(block%r4)
    endif
    if (calloc) then
      ! Reallocation?
      if ((block%iscplx.eqv.iscplx) .and. block%dim1.eq.dim1 .and.  &
          block%dim2.eq.dim2 .and. block%dim3.eq.dim3) then
        ! Same type and same size => Nothing to be done!
        call cubeio_message(ioseve%alloc,rname,'Block array already allocated with correct size')
        goto 100
      else  ! Different type or different size => reallocation
        call cubeio_message(ioseve%alloc,rname,'Reallocating block array')
        call block%free(error)
        if (error)  return
      endif
    else
      ! Allocation
      call cubeio_message(ioseve%alloc,rname,'Creating block array')
    endif
    !
    ! Reallocate memory of the right size
    if (iscplx) then
      allocate(block%c4(dim1,dim2,dim3),stat=ier)
    else
      allocate(block%r4(dim1,dim2,dim3),stat=ier)
    endif
    if (failed_allocate(rname,'Block array',ier,error)) return
    !
  100 continue
    ! Operation success
    block%order  = order
    block%iscplx = iscplx
    block%dim1   = dim1
    block%dim2   = dim2
    block%dim3   = dim3
    block%first  = 0
    block%last   = 0
    block%readwrite = .false.
  end subroutine cubeio_block_reallocate_123

  subroutine cubeio_block_free(block,error)
    !---------------------------------------------------------------------
    ! Free a 'cubeio_block_t' instance
    !---------------------------------------------------------------------
    class(cubeio_block_t), intent(inout) :: block
    logical,               intent(inout) :: error
    !
    block%order     = 0
    block%iscplx    = .false.
    if (allocated(block%c4))  deallocate(block%c4)
    if (allocated(block%r4))  deallocate(block%r4)
    block%dim1      = 0
    block%dim2      = 0
    block%dim3      = 0
    block%first     = 0
    block%last      = 0
    block%readwrite = .false.
  end subroutine cubeio_block_free

  function cubeio_block_memsize(block)
    !-------------------------------------------------------------------
    ! Return the memory footprint in bytes
    !-------------------------------------------------------------------
    integer(kind=size_length) :: cubeio_block_memsize
    class(cubeio_block_t), intent(in) :: block
    !
    cubeio_block_memsize = 0
    !
    if (allocated(block%r4)) &
      cubeio_block_memsize = cubeio_block_memsize + size(block%r4,kind=size_length)*4
    !
    if (allocated(block%c4)) &
      cubeio_block_memsize = cubeio_block_memsize + size(block%c4,kind=size_length)*8
    !
  end function cubeio_block_memsize

end module cubeio_block

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_opened_types
  use cubetools_parameters
  use cubelist_types
  use cube_types
  use cubeedit_messaging
  !
  public :: undetermined_dim
  public :: opened
  private
  !
  integer(kind=list_k), parameter :: not_found = -1
  integer(kind=entr_k), parameter :: undetermined_dim = -2
  integer(kind=4),      parameter :: root_id = 0
  !
  type, extends(list_object_t) :: opened_object_t
     integer(kind=4),       private :: inputid        ! Numeric id of input cube
     character(len=varn_l), private :: editedid       ! Cube id during editing
     type(cube_t), pointer, private :: cube => null() ! The edited cube
     integer(kind=code_k),  private :: access         ! Access order
     integer(kind=entr_k),  private :: ie             ! Current cube entry
     logical,               private :: new            ! Is the cube created from scratch?
   contains
     ! Command actions
     procedure, private :: open    => cubeedit_opened_object_open
     procedure, private :: close   => cubeedit_opened_object_close
     procedure, private :: abort   => cubeedit_opened_object_abort
     procedure, private :: glimpse => cubeedit_opened_object_glimpse
     ! Internal actions
     procedure, private :: create    => cubeedit_opened_object_create
     procedure, private :: resize    => cubeedit_opened_object_resize
     procedure, private :: init_data => cubeedit_opened_object_init_data
     procedure, private :: list      => cubeedit_opened_object_list
     procedure, public  :: final     => cubeedit_opened_object_final
  end type opened_object_t
  !
  type, extends(list_t) :: opened_list_t
   contains
     ! Command actions
     procedure, public  :: listing => cubeedit_opened_list_list
     procedure, public  :: open    => cubeedit_opened_list_open
     procedure, public  :: close   => cubeedit_opened_list_close
     procedure, public  :: abort   => cubeedit_opened_list_abort
     procedure, public  :: glimpse => cubeedit_opened_list_glimpse
     ! Internal actions
     procedure, public  :: create           => cubeedit_opened_list_create
     procedure, public  :: get_editedid     => cubeedit_opened_list_get_editedid
     procedure, public  :: get_cube_pointer => cubeedit_opened_list_get_cube_pointer
     procedure, public  :: get_cube_entry   => cubeedit_opened_list_get_cube_entry
     procedure, public  :: set_cube_entry   => cubeedit_opened_list_set_cube_entry
     procedure, private :: find             => cubeedit_opened_list_find
     generic,   private :: get_ptr          => get_ptr_byname,get_ptr_bynum
     procedure, private :: get_ptr_byname   => cubeedit_opened_object_ptr_byname
     procedure, private :: get_ptr_bynum    => cubeedit_opened_object_ptr_bynum
  end type opened_list_t
  type(opened_list_t) :: opened
  !
contains
  !
  subroutine cubeedit_opened_object_final(obj,error)
    !----------------------------------------------------------------------
    ! Finalize a buffer
    !----------------------------------------------------------------------
    class(opened_object_t), intent(inout) :: obj
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUBE>BUFFER>FINAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    obj%cube => null()
    obj%editedid = ''
  end subroutine cubeedit_opened_object_final
  !
  subroutine cubeedit_opened_object_open(buffer,buffprod,likearg,likeid,access,  &
    dims,doinit,initval,name,error)
    use cubetools_structure
    use cubedag_node_class
    use cubedag_dag_buffer
    use cubeadm_cubeid_types
    use cubeadm_cubeprod_types
    use cubeadm_clone
    use cubeadm_get
    use cubeadm_opened
    use cubeadm_copy_tool
    !----------------------------------------------------------------------
    ! Open a cube in a buffer, resize it and initialize it if need be
    !----------------------------------------------------------------------
    class(opened_object_t), intent(out)   :: buffer
    type(cube_prod_t),      intent(in)    :: buffprod
    type(cubeid_arg_t),     intent(in)    :: likearg
    type(cubeid_user_t),    intent(in)    :: likeid
    integer(kind=code_k),   intent(in)    :: access
    integer(kind=entr_k),   intent(in)    :: dims(3)
    logical,                intent(in)    :: doinit
    real(kind=sign_k),      intent(in)    :: initval
    character(len=*),       intent(in)    :: name
    logical,                intent(inout) :: error
    !
    type(cube_t), pointer :: ref
    logical :: modified_dims
    class(cubedag_node_object_t), pointer :: dno
    character(len=*), parameter :: rname='CUBE>BUFFER>OPEN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    buffer%access = access
    buffer%editedid = name
    modified_dims = any(dims.ne.undetermined_dim)
    buffer%ie = 0
    buffer%new = .false.
    !
    if (modified_dims) then
       call cubeadm_get_header(likearg,likeid,ref,error,  &
         access=buffer%access,action=code_read_head)
       if (error) return
       call cubeadm_clone_header(buffprod,ref,buffer%cube,error)
       if (error) return
       call cubedag_dag_nullid(buffer%cube%node%id)
       call buffer%resize(dims,error)
       if (error) return
       call buffer%init_data(initval,error)
       if (error) return
    else
       if (doinit) then
          call cubeadm_get_header(likearg,likeid,ref,error,  &
            access=buffer%access,action=code_read_head)
          if (error) return
          call cubeadm_clone_header(buffprod,ref,buffer%cube,error)
          if (error) return
          call cubedag_dag_nullid(buffer%cube%node%id)
          call buffer%init_data(initval,error)
          if (error) return
       else
          ! Header part:
          ! Here cubeadm_get_header prepares the transposition if relevant.
          ! The cube to be used in the tuple is set to the imaset or speset
          ! at this stage, but in case of transposition its data is not yet
          ! ready.
          call cubeadm_get_header(likearg,likeid,ref,error,  &
            access=buffer%access,action=code_read)
          if (error) return
          call cubeadm_clone_header(buffprod,ref,buffer%cube,error)
          if (error) return
          call cubedag_dag_nullid(buffer%cube%node%id)
          ! Data part
          ! First apply transposition on the input cube if needed
          call ref%autotranspose(error)
          if (error) return
          ! Now switch the input cube to subset access
          call cubeadm_access_header(ref,code_access_subset,code_read,error)
          if (error) return
          ! And copy its data in subset access
          call cubeadm_copy_data(ref,buffer%cube,error)
          if (error) return
       endif
    endif
    ! All or part copied from likearg => inherit as child
    buffer%inputid = ref%node%id
    !
    ! Prepare extrema processing. Assume no parallel put involved (1 pseudo-task)
    ! ZZZ Should this be merged at clone_header time, knowing that most of all
    !     the other commands will reallocate with the proper number of tasks?
    call buffer%cube%proc%allocate_extrema(buffer%cube%head,1,error)
    if (error) return
    !
    ! Unreference the output cube from the 'opened' ones, so that it is left
    ! "opened" in memory and not yet inserted in DAG. See symetric action
    ! in cubeedit_opened_object_close. The cube will be properly finalized and
    ! inserted at that moment.
    dno => buffer%cube
    call cubeadm_parents_children_pop(dno,error)
    if (error) return
  end subroutine cubeedit_opened_object_open
  !
  subroutine cubeedit_opened_object_create(buffer,access,dims,initval,name,error)
    use cubedag_allflags
    use cubedag_node_class
    use cubedag_dag_buffer
    use cubeadm_create
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! Create a cube buffer from scratch and initialize it
    !----------------------------------------------------------------------
    class(opened_object_t), intent(out)   :: buffer
    integer(kind=code_k),   intent(in)    :: access
    integer(kind=entr_k),   intent(in)    :: dims(3) ! *** JP it should be of type integer(kind=data_k)
    real(kind=sign_k),      intent(in)    :: initval
    character(len=*),       intent(in)    :: name
    logical,                intent(inout) :: error
    !
    integer(kind=ndim_k) :: ndim
    integer(kind=data_k) :: mydims(maxdim)
    class(cubedag_node_object_t), pointer :: dno
    character(len=*), parameter :: rname='CUBE>BUFFER>OPEN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    buffer%access = access
    buffer%editedid = name
    buffer%ie = 0
    buffer%inputid = root_id
    buffer%new = .true.
    !
    ndim = 3
    mydims(1:3)      = dims
    mydims(4:maxdim) = 0
    call cubeadm_create_header([flag_edit,flag_cube],access,ndim,mydims,buffer%cube,error)
    if (error) return
    ! *** JP: Does the order matters after this point?
    call cubedag_dag_nullid(buffer%cube%node%id)
    call buffer%init_data(initval,error)
    if (error) return
    !
    ! Prepare extrema processing. Assume no parallel put involved (1 pseudo-task)
    ! ZZZ Should this be merged at create_header time, knowing that most of all
    !     the other commands will reallocate with the proper number of tasks?
    call buffer%cube%proc%allocate_extrema(buffer%cube%head,1,error)
    if (error) return
    !
    ! Unreference the output cube from the 'opened' ones, so that it is left
    ! "opened" in memory and not yet inserted in DAG. See symetric action
    ! in cubeedit_opened_object_close. The cube will be properly finalized and
    ! inserted at that moment.
    dno => buffer%cube
    call cubeadm_parents_children_pop(dno,error)
    if (error) return
  end subroutine cubeedit_opened_object_create
  !
  subroutine cubeedit_opened_object_glimpse(buffer,error)
    use cubetools_header_types
    !----------------------------------------------------------------------
    ! Glimpse the edited cube header
    !----------------------------------------------------------------------
    class(opened_object_t), intent(in)    :: buffer
    logical,                intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='CUBE>BUFFER>GLIMPSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubeedit_message(seve%r,rname,'')
    write(mess,'(a,24x,a,4x,a,x,a)') 'Editing Id','Access','Orig Id','Entry'
    call cubeedit_message(seve%r,rname,mess)
    call buffer%list(mess,error)
    if (error) return
    call cubeedit_message(seve%r,rname,mess)
    call cubeedit_message(seve%r,rname,'')
    call buffer%cube%head%list(error)
    if (error) return
  end subroutine cubeedit_opened_object_glimpse
  !
  subroutine cubeedit_opened_object_abort(buffer,error)
    use cubedag_node_class
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! Abort buffer edition
    !----------------------------------------------------------------------
    class(opened_object_t), intent(inout) :: buffer
    logical,                intent(inout) :: error
    !
    class(cubedag_node_object_t), pointer :: dno
    logical :: lerror
    character(len=*), parameter :: rname='CUBE>BUFFER>ABORT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    ! call cubeadm_parents_add(root,code_read)
    dno => buffer%cube
    call cubeadm_children_add(dno,code_write)
    !
    ! Explicit call of cubeadm_finish_all with error=.true. will ensure
    ! the cube is destroyed instead of attached in DAG
    lerror = .true.
    call cubeadm_finish_all('ABORT','ABORT',lerror)
  end subroutine cubeedit_opened_object_abort
  !
  subroutine cubeedit_opened_object_close(buffer,newname,error)
    use gkernel_interfaces
    use cubedag_node_class
    use cubedag_dag_buffer
    use cubetools_flag_types
    use cubeadm_opened
    use cubetools_cubeid_types
    !----------------------------------------------------------------------
    ! Close buffer edition
    !----------------------------------------------------------------------
    class(opened_object_t), intent(inout) :: buffer
    character(len=*),       intent(in)    :: newname
    logical,                intent(inout) :: error
    !
    class(cubedag_node_object_t), pointer :: dno
    character(len=file_l) :: family
    type(flag_t), allocatable :: flags(:)
    character(len=*), parameter :: rname='CUBE>BUFFER>CLOSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubedag_dag_newid(buffer%cube%node%id)
    !
    ! Family + flags
    call cubetools_cubeid_string2familyflags(newname,family,flags,error)
    if (error) return
    call buffer%cube%set_value('FAMILY',family,error)
    if (error) return
    if (allocated(flags)) then
      ! Apply the user-defined flags
      call buffer%cube%set_flags(flags,error)
      if (error) return
    else
      ! Let flags as they were created at clone/create time
    endif
    !
    call buffer%cube%set_header(buffer%cube%head,error)
    if (error) return
    !
    ! Add parent
    call cubedag_dag_get_object(buffer%inputid,dno,error)
    if (error) return
    call cubeadm_parents_add(dno,code_read)
    ! Add child
    dno => buffer%cube
    call cubeadm_children_add(dno,code_write)
  end subroutine cubeedit_opened_object_close
  !
  subroutine cubeedit_opened_object_list(buffer,mess,error)
    !----------------------------------------------------------------------
    ! Return a message containing a summary of the buffer
    !----------------------------------------------------------------------
    class(opened_object_t), intent(in)    :: buffer
    character(len=mess_l),  intent(out)   :: mess
    logical,                intent(inout) :: error
    !
    character(len=8) :: access,cubeid
    character(len=*), parameter :: rname='CUBE>BUFFER>LIST'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (buffer%access.eq.code_access_speset) then
       access = 'Spectrum'
    else if (buffer%access.eq.code_access_imaset) then
       access = 'Image'
    else
       access = strg_unk
    endif
    if (buffer%inputid.eq.root_id) then
       cubeid = 'New'
    else
       write(cubeid,'(i0)') buffer%inputid
    endif
    write(mess,'(a32,2(a10),i0)') buffer%editedid,access,cubeid,buffer%ie
  end subroutine cubeedit_opened_object_list
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_opened_object_resize(buffer,dims,error)
    use cubetools_axis_types
    use cubetools_header_methods
    use cubetools_unit
    !----------------------------------------------------------------------
    ! Resize a cube buffer to dims. Ensure that the reference value
    ! keeps the same place on axis when the dimensions are identical
    ! to handle the /LIKE case. Else puts it at the axis center
    !----------------------------------------------------------------------
    class(opened_object_t), intent(inout) :: buffer
    integer(kind=entr_k),   intent(in)    :: dims(3)
    logical,                intent(inout) :: error
    !
    type(axis_t) :: laxis,maxis,caxis
    character(len=*), parameter :: rname='CUBE>BUFFER>RESIZE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_axis_head_l(buffer%cube%head,laxis,error)
    if (error) return
    call cubetools_header_get_axis_head_m(buffer%cube%head,maxis,error)
    if (error) return
    call cubetools_header_get_axis_head_c(buffer%cube%head,caxis,error)
    if (error) return
    if (laxis%n.ne.dims(1)) laxis%ref = laxis%n/2.+1
    if (maxis%n.ne.dims(2)) maxis%ref = maxis%n/2.+1
    if (caxis%n.ne.dims(3)) caxis%ref = caxis%n/2.+1
    laxis%n = dims(1)
    maxis%n = dims(2)
    caxis%n = dims(3)
    call cubetools_header_update_axset_l(laxis,buffer%cube%head,error)
    if (error) return
    call cubetools_header_update_axset_m(maxis,buffer%cube%head,error)
    if (error) return
    if (caxis%kind.eq.code_unit_freq) then
       call cubetools_header_update_frequency_from_axis(caxis,buffer%cube%head,error)
       if (error) return
    else if (caxis%kind.eq.code_unit_velo) then
       call cubetools_header_update_velocity_from_axis(caxis,buffer%cube%head,error)
       if (error) return
    else
       call cubetools_header_update_axset_c(caxis,buffer%cube%head,error)
       if (error) return
       call cubeedit_message(seve%w,rname,'Unknown kind of Spectral axis')
    endif
  end subroutine cubeedit_opened_object_resize
  !
  subroutine cubeedit_opened_object_init_data(buffer,initval,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! Initialize a cube buffer to a value
    !
    ! *** JP: This kind of operation should always be done per subcube.
    !
    !----------------------------------------------------------------------
    class(opened_object_t), intent(inout) :: buffer
    real(kind=sign_k),      intent(in)    :: initval
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    integer(kind=code_k) :: order
    character(len=*), parameter :: rname='CUBE>BUFFER>INIT>DATA'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    order = buffer%cube%order()
    !$OMP PARALLEL DEFAULT(none) SHARED(order,buffer,initval,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(order,buffer,initval,error) FIRSTPRIVATE(iter)
       if (.not.error) then
          select case (order)
          case (code_cube_imaset)
             call cubeedit_opened_object_data_init_imag(buffer%cube,initval,iter,error)
          case (code_cube_speset)
             call cubeedit_opened_object_data_init_spec(buffer%cube,initval,iter,error)
          end select
       endif
       !$OMP END TASK
    enddo ! ie
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubeedit_opened_object_init_data
  !
  subroutine cubeedit_opened_object_data_init_spec(cube,initval,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! Initialize a speset cube buffer to a value
    !----------------------------------------------------------------------
    type(cube_t),             pointer       :: cube
    real(kind=sign_k),        intent(in)    :: initval
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: spe
    character(len=*), parameter :: rname='CUBE>BUFFER>DATA>INIT>SPEC'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call spe%allocate('spectral buffer',cube,iter,error)
    if (error) return
    call spe%y%set(initval,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call spe%put(iter%ie,error)
      if (error) return
    enddo ! ie
  end subroutine cubeedit_opened_object_data_init_spec
  !
  subroutine cubeedit_opened_object_data_init_imag(cube,initval,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! Initialize a speset cube buffer to a value
    !----------------------------------------------------------------------
    type(cube_t),             pointer       :: cube
    real(kind=sign_k),        intent(in)    :: initval
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: ima
    character(len=*), parameter :: rname='CUBE>BUFFER>DATA>INIT>IMAG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call ima%allocate('image buffer',cube,iter,error)
    if (error) return
    call ima%set(initval,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call ima%put(iter%ie,error)
      if (error) return
    enddo ! ie
  end subroutine cubeedit_opened_object_data_init_imag
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_opened_list_find(list,name,found,error)
    !----------------------------------------------------------------------
    ! Loop through the list to look for a opened cube with name 
    !----------------------------------------------------------------------
    class(opened_list_t), intent(in)    :: list
    character(len=*),     intent(in)    :: name 
    integer(kind=list_k), intent(out)   :: found
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: ibuff
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>FIND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (name.eq.strg_star) then
       if (list%n.gt.0) then
         found = list%n
       else
         found = not_found
       endif
    else
       found = not_found
       do ibuff=1, list%n
          buffer => list%get_ptr(ibuff,error)
          if (error) return
          if (buffer%editedid.eq.name) then
             found = ibuff
             return
          endif
       enddo
    endif
  end subroutine cubeedit_opened_list_find
  !
  subroutine cubeedit_opened_list_open(list,name,buffprod,likearg,likeid,access,  &
    dims,doinit,init,error)
    use cubetools_structure
    use cubeadm_cubeid_types
    use cubeadm_cubeprod_types
    !----------------------------------------------------------------------
    ! Open a new buffer in buffer list
    !----------------------------------------------------------------------
    class(opened_list_t), intent(inout) :: list
    character(len=*),     intent(in)    :: name
    type(cube_prod_t),    intent(in)    :: buffprod
    type(cubeid_arg_t),   intent(in)    :: likearg
    type(cubeid_user_t),  intent(in)    :: likeid
    integer(kind=code_k), intent(in)    :: access
    integer(kind=entr_k), intent(in)    :: dims(3)
    logical,              intent(in)    :: doinit
    real(kind=sign_k),    intent(in)    :: init
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: found
    type(opened_object_t), pointer :: buffer
    type(opened_object_t) :: template
    class(list_object_t), pointer :: lot
    character(len=*), parameter :: rname='OPENED>LIST>OPEN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call list%find(name,found,error)
    if (error) return
    !
    if (found.ne.not_found) then
       call cubeedit_message(seve%e,rname,'There is already an opened cube&
            & with identifier '//name)
       error = .true.
       return
    endif
    !
    call list%allocate(template,lot,error)
    if (error) return
    buffer => list%get_ptr(list%n,error)
    if (error) return
    call buffer%open(buffprod,likearg,likeid,access,dims,doinit,init,name,error)
    if (error) return
  end subroutine cubeedit_opened_list_open
  !
  subroutine cubeedit_opened_list_create(list,name,access,dims,init,error)
    !----------------------------------------------------------------------
    ! Create a new buffer in buffer list
    !----------------------------------------------------------------------
    class(opened_list_t), intent(inout) :: list
    character(len=*),     intent(in)    :: name
    integer(kind=code_k), intent(in)    :: access
    integer(kind=entr_k), intent(in)    :: dims(3)
    real(kind=sign_k),    intent(in)    :: init
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: found
    type(opened_object_t), pointer :: buffer
    type(opened_object_t) :: template
    class(list_object_t), pointer :: lot
    character(len=*), parameter :: rname='OPENED>LIST>CREATE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call list%find(name,found,error)
    if (error) return
    !
    if (found.ne.not_found) then
       call cubeedit_message(seve%e,rname,'There is already an opened cube&
            & with identifier '//name)
       error = .true.
       return
    endif
    !
    call list%allocate(template,lot,error)
    if (error) return
    buffer => list%get_ptr(list%n,error)
    if (error) return
    call buffer%create(access,dims,init,name,error)
    if (error) return
  end subroutine cubeedit_opened_list_create
  !
  subroutine cubeedit_opened_list_glimpse(list,name,error)
    !----------------------------------------------------------------------
    ! Glimpse the header of a cube being edited if found
    !----------------------------------------------------------------------
    class(opened_list_t), intent(inout) :: list
    character(len=*),     intent(in)    :: name 
    logical,              intent(inout) :: error
    !
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>GLIMPSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    buffer => list%get_ptr(name,error)
    if (error) return
    call buffer%glimpse(error)
    if (error) return
  end subroutine cubeedit_opened_list_glimpse
  !
  subroutine cubeedit_opened_list_abort(list,name,error)
    !----------------------------------------------------------------------
    ! Abort the edition of a cube if found
    !----------------------------------------------------------------------
    class(opened_list_t), intent(inout) :: list
    character(len=*),     intent(in)    :: name 
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: found
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>ABORT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call list%find(name,found,error)
    if (error) return
    !
    if (found.eq.not_found) then
       call cubeedit_message(seve%e,rname,trim(name)//' is not currently open')
       error = .true.
       return
    endif
    !
    buffer => list%get_ptr(found,error)
    if (error) return
    call buffer%abort(error)
    if (error) return
    call list%pop(found,error)
    if (error) return
  end subroutine cubeedit_opened_list_abort
  !
  subroutine cubeedit_opened_list_close(list,name,newname,error)
    !----------------------------------------------------------------------
    ! Close the edition of a cube if found
    !----------------------------------------------------------------------
    class(opened_list_t), intent(inout) :: list
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: newname
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: found
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>CLOSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call list%find(name,found,error)
    if (error) return
    !
    if (found.eq.not_found) then
       call cubeedit_message(seve%e,rname,trim(name)//' is not currently open')
       error = .true.
       return
    endif
    !
    buffer => list%get_ptr(found,error)
    if (error) return
    call buffer%close(newname,error)
    if (error) return
    call list%pop(found,error)
    if (error) return
  end subroutine cubeedit_opened_list_close
  !
  subroutine cubeedit_opened_list_list(list,error)
    !----------------------------------------------------------------------
    ! List the currently open buffers
    !----------------------------------------------------------------------
    class(opened_list_t), intent(in)    :: list
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess,bmess
    integer(kind=list_k) :: ibuff
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>LIST'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    write(mess,'(a,i0)') 'Currently Opened cubes for edition: ',list%n
    call cubeedit_message(seve%r,rname,mess)
    if (list%n.gt.0) then
       write(mess,'(3x,a,x,a,24x,a,4x,a,x,a)') '#','Editing Id','Access','Orig Id','Entry'
       call cubeedit_message(seve%r,rname,mess)
       !
       do ibuff=1, list%n
          buffer => list%get_ptr(ibuff,error)
          if (error) return
          call buffer%list(bmess,error)
          if (error) return
          write(mess,'(i4)') ibuff
          mess = trim(mess)//' '//bmess
          call cubeedit_message(seve%r,rname,mess)
       enddo
    endif
  end subroutine cubeedit_opened_list_list
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_opened_list_get_editedid(list,inid,ouid,error)
    !----------------------------------------------------------------------
    ! Return the editedid if the cube is found in the opened list
    !----------------------------------------------------------------------
    class(opened_list_t),  intent(in)    :: list
    character(len=*),      intent(in)    :: inid
    character(len=*),      intent(out)   :: ouid
    logical,               intent(inout) :: error
    !
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>GET>EDITEDID'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    buffer => list%get_ptr(inid,error)
    if (error) return
    ouid = buffer%editedid
  end subroutine cubeedit_opened_list_get_editedid
  !
  subroutine cubeedit_opened_list_get_cube_pointer(list,idname,cube,error)
    !----------------------------------------------------------------------
    ! Return a pointer to the buffer cube if the cube is found in the opened list
    !----------------------------------------------------------------------
    class(opened_list_t),  intent(in)    :: list
    character(len=*),      intent(in)    :: idname
    type(cube_t), pointer, intent(out)   :: cube
    logical,               intent(inout) :: error
    !
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>GET>CUBE>POINTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    buffer => list%get_ptr(idname,error)
    if (error) return
    cube => buffer%cube
  end subroutine cubeedit_opened_list_get_cube_pointer
  !
  subroutine cubeedit_opened_list_get_cube_entry(list,idname,ie,error)
    !----------------------------------------------------------------------
    ! Return the last touched entry for idname
    !----------------------------------------------------------------------
    class(opened_list_t),  intent(in)    :: list
    character(len=*),      intent(in)    :: idname
    integer(kind=entr_k),  intent(out)   :: ie
    logical,               intent(inout) :: error
    !
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>GET>CUBE>ENTRY'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    buffer => list%get_ptr(idname,error)
    if (error) return
    ie = buffer%ie
  end subroutine cubeedit_opened_list_get_cube_entry
  !
  subroutine cubeedit_opened_list_set_cube_entry(list,idname,ie,error)
    !----------------------------------------------------------------------
    ! Set the last touched entry for idname
    !----------------------------------------------------------------------
    class(opened_list_t),  intent(in)    :: list
    character(len=*),      intent(in)    :: idname
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    type(opened_object_t), pointer :: buffer
    character(len=*), parameter :: rname='OPENED>LIST>SET>CUBE>ENTRY'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    buffer => list%get_ptr(idname,error)
    if (error) return
    buffer%ie = ie
  end subroutine cubeedit_opened_list_set_cube_entry
  !
  function cubeedit_opened_object_ptr_byname(list,idname,error) result(ptr)
    !-------------------------------------------------------------------
    ! Given its name, return a pointer to the named buffer currently
    ! opened.
    !-------------------------------------------------------------------
    class(opened_list_t),  intent(in)    :: list
    type(opened_object_t), pointer       :: ptr
    character(len=*),      intent(in)    :: idname
    logical,               intent(inout) :: error
    !
    integer(kind=list_k) :: found
    character(len=*), parameter :: rname='CUBE>BUFFER>PTR'
    !
    ptr => null()
    !
    call list%find(idname,found,error)
    if (error) return
    if (found.eq.not_found) then
       call cubeedit_message(seve%e,rname,trim(idname)//' is not currently opened')
       error = .true.
       return
    endif
    !
    ptr => list%get_ptr_bynum(found,error)
    if (error) return
  end function cubeedit_opened_object_ptr_byname
  !
  function cubeedit_opened_object_ptr_bynum(list,ibuffer,error) result(ptr)
    !-------------------------------------------------------------------
    ! Given its number, return a pointer to the named buffer currently
    ! opened.
    !-------------------------------------------------------------------
    class(opened_list_t),  intent(in)    :: list
    type(opened_object_t), pointer       :: ptr
    integer(kind=list_k),  intent(in)    :: ibuffer
    logical,               intent(inout) :: error
    !
    class(list_object_t), pointer :: object
    character(len=*), parameter :: rname='CUBE>BUFFER>PTR'
    !
    ptr => null()
    !
    if (ibuffer.le.0 .or. ibuffer.gt.ubound(list%list,1)) then
      call cubeedit_message(seve%e,rname,'Internal error: invalid buffer number')
      error = .true.
      return
    endif
    !
    object => list%list(ibuffer)%p
    select type (object)
    type is (opened_object_t)
       ptr => object
    class default
       call cubeedit_message(seve%e,rname,'Internal error: object has wrong type')
       error = .true.
       return
    end select
  end function cubeedit_opened_object_ptr_bynum
end module cubeedit_opened_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine greg_extrema(line,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_extrema
  use greg_kernel
  use greg_pen
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  [GREG2\]EXTREMA
  !  1       [/BLANKING Bval Eval]
  !  2       [/PLOT]
  !  3       [/COMPUTE]
  !  4       [/LOCAL PLOT|TERMINAL|FileName]
  ! Find the extrema of regular grid array loaded
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  real(kind=4) :: zmin,zmax,bval,eval
  logical :: forced,dolocal,toplot,toterm
  integer(kind=4) :: icode,nc,tolun,iarg,ier
  character(len=filename_length) :: argum,filename
  character(len=*), parameter :: plot='PLOT'
  character(len=*), parameter :: terminal='TERMINAL'
  !
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%w,'EXTREMA','No map loaded')
    error = .true.
    return
  endif
  !
  ! EXTREMA /BLANK
  bval = cblank
  call sic_r4 (line,1,1,bval,.false.,error)
  if (error) return
  eval = eblank
  call sic_r4 (line,1,2,eval,.false.,error)
  if (error) return
  !
  ! EXTREMA /COMPUTE
  forced = sic_present(3,0)
  !
  ! EXTREMA /PLOT
  ! EXTREMA /LOCAL
  dolocal = .false.
  toplot = .false.
  toterm = .false.
  tolun = 0
  if (sic_present(2,0)) then  ! /PLOT
    ! Obsolescent since 10-jul-2013 (SB)
    ! call greg_message(seve%w,rname,  &
    !   'Option /PLOT is obsolescent. Use /LOCAL PLOT instead')
    dolocal = .true.
    toplot = .true.
  elseif (sic_present(4,0)) then  ! /LOCAL PLOT|TERMINAL|FileName
    dolocal = sic_narg(4).gt.0
    do iarg=1,sic_narg(4)
      call sic_ke(line,4,iarg,argum,nc,.true.,error)
      if (error)  return
      !
      if (argum(1:nc).eq.plot(1:min(nc,4))) then
        toplot = .true.
      elseif (argum(1:nc).eq.terminal(1:min(nc,8))) then
        toterm = .true.
      elseif (tolun.eq.0) then  ! Assume a filename
        call sic_ch(line,4,iarg,argum,nc,.true.,error)
        if (error)  return
        call sic_parse_file(argum,'','.dat',filename)
        ier = sic_getlun(tolun)
        if (ier.ne.1) then
          error = .true.
          return
        endif
        ier = sic_open(tolun,filename,'NEW',.false.)
        if (ier.ne.0) then
          error = .true.
          return
        endif
      else
        call greg_message(seve%w,rname,  &
          'Ignoring argument '''//trim(argum)//''' (not understood)')
      endif
    enddo
  endif
  !
  if (dolocal) then
    if (toplot)  call gtsegm('EXTREMA',error)
    if (penupd)  call setpen(cpen)
    call rgextr_local(rg%data,toplot,toterm,tolun,error)  ! Calls SETDAS in PUTLABEL
    if (toplot)  call gtsegm_close(error)
    if (tolun.ne.0) then
      ier = sic_close(tolun)
      call sic_frelun(tolun)
    endif
    !
  else
    if (sic_present(0,1)) then
      icode = 0
    else
      icode = 1
    endif
    call rgextr(icode,zmin,zmax,rg%data,bval,eval,forced)
  endif
  !
end subroutine greg_extrema
!
subroutine rgextr(itype,zmin,zmax,z,bval,eval,forced)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>rgextr
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Finds the maxima and minima for Regular Grid array and writes on
  ! screen the values and corresponding position if ITYPE = 1
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: itype   ! Type values on screen
  real(kind=4)                :: zmin    ! Minimum map value (output)
  real(kind=4)                :: zmax    ! Maximum map value (output)
  real(kind=4),    intent(in) :: z(*)    ! RG map array
  real(kind=4),    intent(in) :: bval    ! Blanking value
  real(kind=4),    intent(in) :: eval    ! Tolerance on blanking
  logical,         intent(in) :: forced  ! Force computation
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  real(kind=4) :: tmin,tmax,oldbval,oldeval
  integer(kind=size_length) :: kmin,kmax
  integer(kind=4):: i,j
  integer(kind=4) :: imin,imax,jmin,jmax
  logical :: compute
  character(len=80) :: chain
  integer(kind=size_length) :: nelem
  !
  save oldbval,oldeval
  ! Data
  data oldeval/1e18/, oldbval/0/
  !
  if (forced) then
    compute = .true.
  elseif (.not.rg%minmax) then
    compute = .true.
  elseif (eval.lt.0 .and. oldeval.lt.0) then
    compute = .false.
  elseif (oldeval.ne.eval .or. abs(bval-oldbval).gt.eval) then
    compute = .true.
  else
    compute = .false.  ! Do not recompute if already done
  endif
  !
  if (compute) then
    nelem = rg%nx*rg%ny
    call gr4_minmax (nelem,z,bval,eval,tmin,tmax,kmin,kmax)
    rg%minmax = .true.
    oldbval = bval
    oldeval = eval
    !
    ! Compute coordinates corresponding to KZ1
    i = mod(kmin,rg%nx)
    if (i.eq.0) i = rg%nx
    j = (kmin-i)/rg%nx + 1
    rg%zxmin = rg%xval + (i-rg%xref)*rg%xinc
    rg%zymin = rg%yval + (j-rg%yref)*rg%yinc
    rg%zmin = tmin
    !
    ! Compute coordinates corresponding to KZ2
    i = mod(kmax,rg%nx)
    if (i.eq.0) i = rg%nx
    j = (kmax-i)/rg%nx + 1
    rg%zxmax = rg%xval + (i-rg%xref)*rg%xinc
    rg%zymax = rg%yval + (j-rg%yref)*rg%yinc
    rg%zmax = tmax
  endif
  zmax = rg%zmax
  zmin = rg%zmin
  !
  ! Output results
  if (itype .ne. 0) then
    write(chain,100) 'Xmin = ',rg%xval+(1-rg%xref)*rg%xinc,  &
                   '  Xmax = ',rg%xval+(rg%nx-rg%xref)*rg%xinc
    call greg_message(seve%r,rname,chain)
    !
    write(chain,100) 'Ymin = ',rg%yval+(1-rg%yref)*rg%yinc,  &
                   '  Ymax = ',rg%yval+(rg%ny-rg%yref)*rg%yinc
    call greg_message(seve%r,rname,chain)
    !
    write(chain,100) 'Zmin = ',zmin,'  at X = ',rg%zxmin,'  Y = ',rg%zymin
    call greg_message(seve%r,rname,chain)
    !
    write(chain,100) 'Zmax = ',zmax,'  at X = ',rg%zxmax,'  Y = ',rg%zymax
    call greg_message(seve%r,rname,chain)
  endif
100 format(a,1pg12.5,a,1pg12.5,a,1pg12.5)
  return
  !
entry gr4_egive(zmin,zmax,imin,jmin,imax,jmax,bval,eval)
  !----------------------------------------------------------------------
  ! @ private
  !	Give extremas of the Regular Grid array and their positions
  !----------------------------------------------------------------------
  !
  rg%minmax = .true.
  oldbval = bval
  oldeval = eval
  rg%zxmin = rg%xval + (imin-rg%xref)*rg%xinc
  rg%zymin = rg%yval + (jmin-rg%yref)*rg%yinc
  rg%zmin = zmin
  rg%zxmax = rg%xval + (imax-rg%xref)*rg%xinc
  rg%zymax = rg%yval + (jmax-rg%yref)*rg%yinc
  rg%zmax = zmax
end subroutine rgextr
!
subroutine rgextr_local(z,toplot,toterm,tolun,error)
  use greg_interfaces, except_this=>rgextr_local
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Finds local extrema of the Regular Grid array
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: z(rg%nx,rg%ny)  ! Regular grid array
  logical,         intent(in)    :: toplot          ! Display on plot
  logical,         intent(in)    :: toterm          ! Display on terminal
  integer(kind=4), intent(in)    :: tolun           ! Output lun, if defined
  logical,         intent(inout) :: error           ! Logical error flag
  ! Local
  integer(kind=4) :: i,ist,ied,imin,imax,irg
  integer(kind=4) :: j,jst,jed,jmin,jmax,jrg
  real(kind=4) :: cur,val
  real(kind=8) :: x,y,x1,x2,y1,y2
  !
  if (toterm)      write(6,    '(A)')  '!   Value           Xoffset          Yoffset'
  if (tolun.ne.0)  write(tolun,'(A)')  '!   Value           Xoffset          Yoffset'
  !
  x1 = min(gux1,gux2)
  x2 = max(gux1,gux2)
  y1 = min(guy1,guy2)
  y2 = max(guy1,guy2)
  if (rg%xinc.gt.0.) then
    imin = max (1,    int((x1-rg%xval)/rg%xinc+rg%xref) )
    imax = min (rg%nx,int((x2-rg%xval)/rg%xinc+rg%xref)+1 )
  else
    imin = max (1,    int((x2-rg%xval)/rg%xinc+rg%xref) )
    imax = min (rg%nx,int((x1-rg%xval)/rg%xinc+rg%xref)+1 )
  endif
  if (rg%yinc.gt.0.) then
    jmin = max (1,    int((y1-rg%yval)/rg%yinc+rg%yref) )
    jmax = min (rg%ny,int((y2-rg%yval)/rg%yinc+rg%yref)+1 )
  else
    jmin = max (1,    int((y2-rg%yval)/rg%yinc+rg%yref) )
    jmax = min (rg%ny,int((y1-rg%yval)/rg%yinc+rg%yref)+1 )
  endif
  !
  irg = min(15,max(3,int(float(rg%nx)/8.0)))
  jrg = min(15,max(3,int(float(rg%ny)/8.0)))
  !
  do j=jmin,jmax
    do i=imin,imax
      val = z(i,j)
      !
      if (i.eq.imin) then
        if (val.ge.z(i+1,j))  goto 130
        if (val.ge.z(i+2,j))  goto 130
      elseif (i.eq.imax) then
        if (val.ge.z(i-1,j))  goto 140
        if (val.ge.z(i-2,j))  goto 140
      else
        if (val.ge.z(i-1,j))  goto 150
        if (val.ge.z(i+1,j))  goto 150
      endif
      !
      ! Candidate for a minimum, look in neighbourhood in
      ! range [i-irg:i+irg,j-jrg:j+jrg]
      jst = max(jmin,j-jrg)
      jed = min(jmax,j+jrg)
70    ist = max(imin,i-irg)
      ied = min(imax,i+irg)
      !
100   cur = z(ist,jst)
      if (val.lt.cur)  goto 110  ! Found a higher value in neighbourhood: continue
      if (val.gt.cur)  cycle     ! Found a lower value in neighbourhood: not a minimum
      if (i.eq.ist .and. j.eq.jst) goto 110  ! Looking at same pixel: continue
      cycle                      ! Found an equal value: not a lower minimum
      !
110   ist = ist+1                ! Iterate on next pixel in neighbourhood
      if (ist.le.ied) goto 100
      jst = jst+1                ! Iterate on next pixel in neighbourhood
      if (jst.le.jed) goto 70
      !
      ! Finished iterating in neighbourhood: val is a local minimum
      x = (i-rg%xref)*rg%xinc+rg%xval
      y = (j-rg%yref)*rg%yinc+rg%yval
      call uwrite(val,x,y)
      cycle
      !
      ! Maximum
      !
130   if (val.le.z(i+1,j))  cycle
      if (val.le.z(i+2,j))  cycle
      goto 160
      !
140   if (val.le.z(i-1,j))  cycle
      if (val.le.z(i-2,j))  cycle
      goto 160
      !
150   if (val.le.z(i+1,j))  cycle
      if (val.le.z(i-1,j))  cycle
      !
      ! Candidate for a maximum, look in neighbourhood in
      ! range [i-irg:i+irg,j-jrg:j+jrg]
160   jst = max(jmin,j-jrg)
      jed = min(jmax,j+jrg)
170   ist = max(imin,i-irg)
      ied = min(imax,i+irg)
      !
200   cur = z(ist,jst)
      if (val.gt.cur)  goto 210  ! Found a lower value in neighbourhood: continue
      if (val.lt.cur)  cycle     ! Found a higher value in neighbourhood: not a maximum
      if (i.eq.ist .and. j.eq.jst) goto 210  ! Looking at same pixel: continue
      cycle                      ! Found an equal value: not a higher maximum
      !
210   ist = ist+1                ! Iterate on next pixel in neighbourhood
      if (ist.le.ied) goto 200
      jst = jst+1                ! Iterate on next pixel in neighbourhood
      if (jst.le.jed) goto 170
      !
      ! Finished iterating in neighbourhood: val is a local maximum
      x = (i-rg%xref)*rg%xinc+rg%xval
      y = (j-rg%yref)*rg%yinc+rg%yval
      call uwrite(val,x,y)
      !
    enddo
  enddo
  !
contains
  subroutine uwrite(val,x,y)
    use greg_kernel
    !---------------------------------------------------------------------
    !  This subroutine writes the value VAL at location X,Y in User
    ! Coordinates. VAL is encoded in shortest format.
    !---------------------------------------------------------------------
    real(kind=4), intent(in) :: val   ! Value to be encoded
    real(kind=8), intent(in) :: x     ! X coordinate
    real(kind=8), intent(in) :: y     ! Y coordinate
    ! Local
    real(kind=4) :: expand0
    character(len=24) :: chain
    character(len=20) :: string
    integer(kind=4) :: nchar
    character(len=1), parameter :: backslash=char(92)
    !
    if (toplot) then
      expand0 = expand
      expand = 0.6*expand
      call conecd (val,string,nchar)
      call relocate(x,y)
      chain = backslash//backslash//'1'//string
      call putlabel(nchar+3,chain,5,tangle,.false.)
      expand = expand0
    endif
    if (toterm)      write(6,    '(1PG14.6,2(1X,1PG16.8))')  val,x,y
    if (tolun.ne.0)  write(tolun,'(1PG14.6,2(1X,1PG16.8))')  val,x,y
  end subroutine uwrite
end subroutine rgextr_local

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_tuple_trans
  use gkernel_interfaces
  use cubetools_parameters
  use cubedag_messaging
  !
  public :: cubedag_trans_t
  private
  !
  ! Type describing each object in a tuple. It can lie in memory and/or disk
  type :: cubedag_trans_t
    character(len=maxdim) :: iorder = ''         ! Intrinsic order (empty: unused)
    integer(kind=code_k)  :: morder = code_null  ! Mapped order (null: unused)
    integer(kind=8)       :: mtstamp = 0         ! Memory time stamp (0: unused)
    integer(kind=8)       :: dtstamp = 0         ! Disk time stamp (0: unused)
    character(len=file_l) :: file = ''           ! File on disk
    integer(kind=4)       :: hdu = 0             ! HDU in file on disk
  contains
    procedure, public :: list       => cubedag_trans_list
    procedure, public :: read       => cubedag_trans_read
    procedure, public :: write      => cubedag_trans_write
    procedure, public :: upsert     => cubedag_trans_upsert
    procedure, public :: diskupdate => cubedag_trans_diskupdate
    procedure, public :: access     => cubedag_trans_access
    procedure, public :: filename   => cubedag_trans_filename
    procedure, public :: location   => cubedag_trans_location
    procedure, public :: disksize   => cubedag_trans_disksize
  end type cubedag_trans_t
  !
  character(len=*), parameter :: form_tup='(A,T26,A,1X,I11,I20,1X,A,1X,I0)'  ! For version 0.5
  !
contains
  subroutine cubedag_trans_list(trans,error)
    use cubetools_format
    !---------------------------------------------------------------------
    ! Read tuple from disk for latest versions
    !---------------------------------------------------------------------
    class(cubedag_trans_t), intent(in)   :: trans
    logical,                intent(inout) :: error
    !
    character(len=6) :: set
    character(len=mess_l) :: mess
    character(len=50) :: shortname
    character(len=*), parameter :: rname='TRANS>LIST'
    !
    select case (trans%morder)
    case (code_cube_imaset)
      set = 'ImaSet'
    case (code_cube_speset)
      set = 'SpeSet'
    case default
      set = 'UnkSet'
    end select
    !
    ! Memory
    if (trans%mtstamp.gt.0) then
      mess = cubetools_format_stdkey_boldval(set,'none',60)
      mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Status','---',18)
      call cubedag_message(seve%r,rname,mess)
    endif
    !
    ! Disk
    if (trans%dtstamp.gt.0) then
      call trans%location(code_buffer_disk,shortname)
      mess = cubetools_format_stdkey_boldval(set,shortname,60)
      mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Status','---',18)
      call cubedag_message(seve%r,rname,mess)
    endif
  end subroutine cubedag_trans_list
  !
  subroutine cubedag_trans_read(trans,lun,dagdir,curdir,error)
    use cubetools_realpath
    !---------------------------------------------------------------------
    ! Read tuple from disk for latest versions
    !---------------------------------------------------------------------
    class(cubedag_trans_t),     intent(out)   :: trans
    integer(kind=4),            intent(in)    :: lun
    character(len=*),           intent(in)    :: dagdir
    type(cubetools_realpath_t), intent(inout) :: curdir
    logical,                    intent(inout) :: error
    !
    integer(kind=4) :: ier,hdu
    character(len=12) :: key
    character(len=maxdim) :: iorder
    integer(kind=code_k) :: morder
    integer(kind=8) :: tstamp
    character(len=file_l) :: file
    type(cubetools_realpath_t) :: path
    !
    ! List-directed read allows for flexible file length
    read(lun,*,iostat=ier)  key,iorder,morder,tstamp,file,hdu
    if (ier.lt.0) return  ! EOF
    if (ier.gt.0) then
      call putios('E-TUPLE>READ,  ',ier)
      error = .true.
      return
    endif
    trans%iorder  = iorder
    trans%morder  = morder
    trans%dtstamp = tstamp
    trans%hdu     = hdu
    !
    if (file.ne.'') then
      ! File path was saved absolute, or relative to the directory of
      ! the DAG file
      call path%absolutefrom(file,dagdir)
      ! And now resolve file path relative to current directory
      trans%file = path%relativeto(curdir)
    endif
  end subroutine cubedag_trans_read
  !
  subroutine cubedag_trans_write(trans,lun,dagpath,error)
    use cubetools_realpath
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(cubedag_trans_t),     intent(in)    :: trans
    integer(kind=4),            intent(in)    :: lun
    type(cubetools_realpath_t), intent(inout) :: dagpath
    logical,                    intent(inout) :: error
    !
    character(len=file_l) :: relpath
    type(cubetools_realpath_t) :: path
    character(len=*), parameter :: rname='TRANS>WRITE'
    !
    if (trans%dtstamp.le.0) then
      ! Error... or skip?
      call cubedag_message(seve%e,rname,  &
        'Internal error: can not snapshot a cube with no disk information')
      error = .true.
      return
    endif
    !
    ! Compute path relative to the DAG file (cube.dag)
    call path%resolve(trans%file)
    relpath = path%relativeto(dagpath)
    !
    write(lun,form_tup)  'TUPLE',  &
                         trans%iorder,  &
                         trans%morder,  &
                         trans%dtstamp,  &
                         '"'//trim(relpath)//'"', &  ! Quotes to support partially or fully blank strings
                         trans%hdu
  end subroutine cubedag_trans_write
  !
  subroutine cubedag_trans_upsert(trans,iorder,morder,location,onefile,hdu,  &
    updated,error)
    !---------------------------------------------------------------------
    ! Upsert one entry
    !---------------------------------------------------------------------
    class(cubedag_trans_t), intent(inout) :: trans
    character(len=*),       intent(in)    :: iorder
    integer(kind=code_k),   intent(in)    :: morder    ! imaset, speset, unkset
    integer(kind=code_k),   intent(in)    :: location  ! Memory/disk
    character(len=*),       intent(in)    :: onefile
    integer(kind=4),        intent(in)    :: hdu
    logical,                intent(inout) :: updated
    logical,                intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    integer(kind=8) :: mtime
    logical :: update
    !
    if (location.eq.code_buffer_disk) then
      if (gag_inquire(onefile,len_trim(onefile)).eq.0) then
        ! File exists or it disappeared
        ier = gag_mtime(onefile,mtime)
        ! ZZZ should trap error
        update = mtime.gt.trans%dtstamp
      else
        mtime = 0
        update = .true.
      endif
    else
      mtime = 1
      update = .true.
    endif
    !
    if (update) then
      ! ZZZ Should we complain if file name has changed?
      trans%iorder = iorder
      trans%morder = morder
      if (location.eq.code_buffer_disk) then
        trans%dtstamp = mtime
        trans%file = onefile
        trans%hdu = hdu
      else
        trans%mtstamp = mtime
      endif
      updated = .true.
    endif
  end subroutine cubedag_trans_upsert
  !
  subroutine cubedag_trans_diskupdate(trans,updated,error)
    !-------------------------------------------------------------------
    ! Update the timestamp of one file ONLY IF IT HAS CHANGED.
    !-------------------------------------------------------------------
    class(cubedag_trans_t), intent(inout) :: trans
    logical,                intent(inout) :: updated
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='TUPLE>DISKUPDATE>ONE'
    !
    if (trans%dtstamp.eq.0)  return  ! Disk time stamp unused: nothing to update
    !
    if (gag_inquire(trans%file,len_trim(trans%file)).ne.0) then
      ! File is referenced but it disappeared: discard it
      call cubedag_message(seve%w,rname,  &
        'File '//trim(trans%file)//' does not exist anymore')
      trans%dtstamp = 0
      trans%file = ''
      trans%hdu = 0
      ! For safety also disable the consistency flag: NOT REIMPLEMENTED
      ! pos_cons = cubedag_tuple_position(code_null,code_null)
      ! tup%tstamp(pos_cons) = 0
      ! tup%file(pos_cons) = ''
      ! tup%hdu(pos_cons) = 0
      ! updated = .true.
      return
    endif
    !
    ! File exists: update if needed
    call trans%upsert(trans%iorder,trans%morder,code_buffer_disk,trans%file,  &
      trans%hdu,updated,error)
    if (error)  return
  end subroutine cubedag_trans_diskupdate
  !
  function cubedag_trans_access(trans)
    !-------------------------------------------------------------------
    ! Return the access code (mapped order)
    !-------------------------------------------------------------------
    integer(kind=code_k) :: cubedag_trans_access
    class(cubedag_trans_t), intent(in) :: trans
    !
    cubedag_trans_access = trans%morder
  end function cubedag_trans_access
  !
  function cubedag_trans_filename(trans,location)
    !-------------------------------------------------------------------
    ! Return the file name for access+location cube
    !-------------------------------------------------------------------
    character(len=file_l) :: cubedag_trans_filename
    class(cubedag_trans_t), intent(in) :: trans
    integer(kind=code_k),   intent(in) :: location
    !
    if (location.eq.code_buffer_memory) then
      if (trans%mtstamp.le.0) then
        cubedag_trans_filename = '<not-yet-defined>'
      else
        cubedag_trans_filename = '<memory>'
      endif
    else
      if (trans%dtstamp.le.0) then
        cubedag_trans_filename = '<not-yet-defined>'
      else
        cubedag_trans_filename = trans%file
      endif
    endif
  end function cubedag_trans_filename
  !
  subroutine cubedag_trans_location(trans,location,shortloc)
    !-------------------------------------------------------------------
    ! Return the location (path) of the cube referenced by the tuple,
    ! in a string suited for LIST (i.e. properly truncating it)
    !-------------------------------------------------------------------
    class(cubedag_trans_t), intent(in)  :: trans
    integer(kind=code_k),   intent(in)  :: location  ! Memory/Disk
    character(len=*),       intent(out) :: shortloc
    ! Local
    character(len=file_l) :: cubename
    integer(kind=4) :: nc,lmax
    !
    cubename = trans%filename(location)
    nc = len_trim(cubename)
    !
    ! Append HDU number if relevant
    if (location.eq.code_buffer_disk .and. trans%hdu.gt.1) then
      write(cubename(nc+1:),'(a1,i0,a1)') '[',trans%hdu,']'
      nc = len_trim(cubename)
    endif
    !
    ! Truncate if needed
    lmax = len(shortloc)
    if (nc.gt.lmax) then
      shortloc = '...'//cubename(nc-(lmax-4):nc)
    else
      shortloc = cubename(1:nc)
    endif
  end subroutine cubedag_trans_location
  !
  function cubedag_trans_disksize(trans,location)
    !-------------------------------------------------------------------
    ! Return the disk footprint of one file (one order) in the tuple, if
    ! relevant
    !-------------------------------------------------------------------
    integer(kind=size_length) :: cubedag_trans_disksize  ! [bytes]
    class(cubedag_trans_t), intent(in) :: trans
    integer(kind=code_k),   intent(in) :: location
    ! Local
    integer(kind=4) :: ier,nc
    integer(kind=8) :: onesize
    !
    cubedag_trans_disksize = 0
    if (location.eq.code_buffer_memory)  return  ! Memory has no disk footprint
    !
    if (trans%dtstamp.le.0)  return  ! No file on disk referenced
    !
    nc = len_trim(trans%file)
    if (gag_inquire(trans%file,nc).ne.0)  return
    !
    ! This is not what we want in case of several HDUs:
    ier = gag_filsize(trans%file(1:nc),onesize)
    if (ier.ne.0)  return
    !
    cubedag_trans_disksize = onesize
  end function cubedag_trans_disksize
  !
end module cubedag_tuple_trans
!
module cubedag_tuple
  use gkernel_interfaces
  use cubetools_parameters
  use cubedag_messaging
  use cubedag_tuple_trans
  !
  public :: cubedag_tuple_t
  public :: cubedag_tuple_upsert,cubedag_tuple_setconsistent,  &
            cubedag_tuple_hasuptodatefile,cubedag_tuple_reset,  &
            cubedag_tuple_diskupdate,cubedag_tuple_rmmemo,cubedag_tuple_rmfiles
  private
  !
  ! The tuple is a collection of transpositions of the same data object
  integer(kind=4), parameter :: tuple_mtrans=4  ! Static allocation (should be made dynamic)
  type :: cubedag_tuple_t
   !consistency description: not reimplemented
    integer(kind=4),       private :: n = 0                ! Number of transpositions currently in use
    type(cubedag_trans_t), private :: trans(tuple_mtrans)  ! Transpositions
    integer(kind=4),       private :: itrans = 0           ! Iterator running index
  contains
    procedure, private :: position  => cubedag_tuple_position
    procedure          :: list      => cubedag_tuple_list
    procedure          :: hascube   => cubedag_tuple_hascube
    procedure, public  :: access    => cubedag_tuple_access
    procedure          :: filename  => cubedag_tuple_filename
    procedure          :: location  => cubedag_tuple_location
   !procedure          :: debug     => cubedag_tuple_debug
    procedure          :: disksizes => cubedag_tuple_disksizes
    procedure          :: disksize  => cubedag_tuple_disksize
    procedure          :: contains  => cubedag_tuple_contains
    procedure, public  :: write     => cubedag_tuple_write
    procedure, public  :: read02    => cubedag_tuple_read02
    procedure, public  :: read03    => cubedag_tuple_read03
    procedure, public  :: read04    => cubedag_tuple_read04
    procedure, public  :: read      => cubedag_tuple_read
    procedure, public  :: to_struct => cubedag_tuple_to_struct
    ! Iterator
    procedure, public :: iterate_init => cubedag_tuple_iterate_init
    procedure, public :: iterate      => cubedag_tuple_iterate
  end type cubedag_tuple_t
  !
  ! Formats in DAG file
  integer(kind=4),  parameter :: tuple_mdisk=4                            ! For version 0.4 and below
  character(len=*), parameter :: form_i4   ='(A,T26,I11,20(I11))'         ! Scalar or array I*4
  character(len=*), parameter :: form_tup02='(A,T26,I11,I20,3X,A)'        ! For version 0.2 and below
  character(len=*), parameter :: form_tup  ='(A,T26,I11,I20,1X,A,1X,I0)'  ! For version 0.3 and 0.4
  !
contains
  !
  subroutine cubedag_tuple_reset(tuple)
    !---------------------------------------------------------------------
    ! Fully reset a tuple
    !---------------------------------------------------------------------
    type(cubedag_tuple_t), intent(out) :: tuple
    return
  end subroutine cubedag_tuple_reset
  !
  subroutine cubedag_tuple_read02(tup,lun,error)
    !---------------------------------------------------------------------
    ! Read tuple from disk for version 0.2 and earlier
    !---------------------------------------------------------------------
    class(cubedag_tuple_t), intent(out)   :: tup
    integer(kind=4),        intent(in)    :: lun
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>READ02'
    integer(kind=4) :: ier,access,i
    integer(kind=8) :: tstamp
    character(len=file_l) :: file
    character(len=12) :: key
    !
    tup%n = 0
    do i=1,tuple_mdisk
      read(lun,form_tup02,iostat=ier)  key,access,tstamp,file
      if (ier.lt.0)                exit  ! EOF
      if (ier.gt.0) then
        call putios('E-TUPLE>READ,  ',ier)
        error = .true.
        return
      endif
      if (tstamp.le.0)  cycle  ! No information available => nothing to store in latest format
      if (i.eq.1)       cycle  ! Consistency flag not reimplemented
      !
      tup%n = tup%n+1
      if (access.eq.code_cube_speset) then
        tup%trans(tup%n)%iorder = 'CAB'
      else
        tup%trans(tup%n)%iorder = 'ABC'
      endif
      tup%trans(tup%n)%morder = access
      tup%trans(tup%n)%mtstamp = 0
      tup%trans(tup%n)%dtstamp = tstamp
      tup%trans(tup%n)%file = file
      tup%trans(tup%n)%hdu = 1  ! Default in version 0.2
    enddo
  end subroutine cubedag_tuple_read02
  !
  subroutine cubedag_tuple_read03(tup,lun,error)
    !---------------------------------------------------------------------
    ! Read tuple version 0.3
    ! In this version, file paths are relative to current working
    ! directory
    !---------------------------------------------------------------------
    class(cubedag_tuple_t), intent(out)   :: tup
    integer(kind=4),        intent(in)    :: lun
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>READ'
    integer(kind=4) :: ier,access,i,hdu
    integer(kind=8) :: tstamp
    character(len=file_l) :: file
    character(len=12) :: key
    !
    tup%n = 0
    do i=1,tuple_mdisk
      ! List-directed read allows for flexible file length
      read(lun,*,iostat=ier)  key,access,tstamp,file,hdu
      if (ier.lt.0)                exit  ! EOF
      if (ier.gt.0) then
        call putios('E-TUPLE>READ,  ',ier)
        error = .true.
        return
      endif
      if (tstamp.le.0)  cycle  ! No information available => nothing to store in latest format
      if (i.eq.1)       cycle  ! Consistency flag not reimplemented
      !
      tup%n = tup%n+1
      if (access.eq.code_cube_speset) then
        tup%trans(tup%n)%iorder = 'CAB'
      else
        tup%trans(tup%n)%iorder = 'ABC'
      endif
      tup%trans(tup%n)%morder = access
      tup%trans(tup%n)%mtstamp = 0
      tup%trans(tup%n)%dtstamp = tstamp
      tup%trans(tup%n)%file = file
      tup%trans(tup%n)%hdu = hdu
    enddo
  end subroutine cubedag_tuple_read03
  !
  subroutine cubedag_tuple_read04(tup,lun,dagdir,curdir,error)
    use cubetools_realpath
    !---------------------------------------------------------------------
    ! Read tuple version 0.4
    ! In this version, there is no intrinsic order
    !---------------------------------------------------------------------
    class(cubedag_tuple_t),     intent(out)   :: tup
    integer(kind=4),            intent(in)    :: lun
    character(len=*),           intent(in)    :: dagdir
    type(cubetools_realpath_t), intent(inout) :: curdir
    logical,                    intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>READ04'
    integer(kind=4) :: ier,access,i,hdu
    integer(kind=8) :: tstamp
    character(len=file_l) :: file
    character(len=12) :: key
    type(cubetools_realpath_t) :: path
    !
    tup%n = 0
    do i=1,tuple_mdisk
      ! List-directed read allows for flexible file length
      read(lun,*,iostat=ier)  key,access,tstamp,file,hdu
      if (ier.lt.0)                exit  ! EOF
      if (ier.gt.0) then
        call putios('E-TUPLE>READ,  ',ier)
        error = .true.
        return
      endif
      if (tstamp.le.0)  cycle  ! No information available => nothing to store in latest format
      if (i.eq.1)       cycle  ! Consistency flag not reimplemented
      !
      tup%n = tup%n+1
      if (access.eq.code_cube_speset) then
        tup%trans(tup%n)%iorder = 'CAB'
      else
        tup%trans(tup%n)%iorder = 'ABC'
      endif
      tup%trans(tup%n)%morder = access
      tup%trans(tup%n)%mtstamp = 0
      tup%trans(tup%n)%dtstamp = tstamp
      tup%trans(tup%n)%hdu = hdu
      !
      if (file.ne.'') then
        ! File path was saved absolute, or relative to the directory of
        ! the DAG file
        call path%absolutefrom(file,dagdir)
        ! And now resolve file path relative to current directory
        tup%trans(tup%n)%file = path%relativeto(curdir)
      endif
    enddo
  end subroutine cubedag_tuple_read04
  !
  subroutine cubedag_tuple_read(tup,lun,dagdir,curdir,error)
    use cubetools_realpath
    !---------------------------------------------------------------------
    ! Read tuple from disk for latest versions
    !---------------------------------------------------------------------
    class(cubedag_tuple_t),     intent(out)   :: tup
    integer(kind=4),            intent(in)    :: lun
    character(len=*),           intent(in)    :: dagdir
    type(cubetools_realpath_t), intent(inout) :: curdir
    logical,                    intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>READ'
    integer(kind=4) :: ier,i
    character(len=12) :: key
    !
    read(lun,form_i4,iostat=ier) key,tup%n
    if (ier.gt.0) then
      call putios('E-TUPLE>READ,  ',ier)
      error = .true.
      return
    endif
    if (key.ne.'TUPLE_N') then
      call cubedag_message(seve%e,rname,'Expected key TUPLE_N, got '//key)
      error = .true.
      return
    endif
    !
    do i=1,tup%n
      call tup%trans(i)%read(lun,dagdir,curdir,error)
      if (error)  return
    enddo
  end subroutine cubedag_tuple_read
  !
  subroutine cubedag_tuple_write(tup,lun,dagpath,error)
    use cubetools_realpath
    !---------------------------------------------------------------------
    ! Write tuple to disk
    !---------------------------------------------------------------------
    class(cubedag_tuple_t),     intent(in)    :: tup
    integer(kind=4),            intent(in)    :: lun
    type(cubetools_realpath_t), intent(inout) :: dagpath
    logical,                    intent(inout) :: error
    !
    integer(kind=4) :: i,n
    character(len=*), parameter :: rname='TUPLE>WRITE'
    !
    ! Snapshot only the transpositions with a disk file. Need to count them.
    n = 0
    do i=1,tup%n
      if (tup%trans(i)%dtstamp.gt.0)  n = n+1
    enddo
    !
    write(lun,form_i4)  'TUPLE_N',n
    !
    do i=1,tup%n
      if (tup%trans(i)%dtstamp.gt.0) then
        call tup%trans(i)%write(lun,dagpath,error)
        if (error)  return
      endif
    enddo
  end subroutine cubedag_tuple_write
  !
  subroutine cubedag_tuple_upsert(tup,iorder,morder,location,onefile,hdu,error)
    !---------------------------------------------------------------------
    ! Insert (if the file is new) or update (if the file has changed) one
    ! file in the tuple file. Nothing done if file is already up-to-date.
    ! If file does not exist, its timestamp is set to 0.
    !---------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    character(len=*),      intent(in)    :: iorder
    integer(kind=code_k),  intent(in)    :: morder
    integer(kind=code_k),  intent(in)    :: location
    character(len=*),      intent(in)    :: onefile
    integer(kind=4),       intent(in)    :: hdu
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: pos
    logical :: updated
    character(len=*), parameter :: rname='TUPLE>UPSERT'
    !
    if (iorder.eq.'') then
      call cubedag_message(seve%e,rname,'Intrinsic order is not set')
      error = .true.
      return
    endif
    !
    pos = tup%position(iorder)
    if (pos.eq.0) then
      ! Allocate a new slot
      if (tup%n.ge.tuple_mtrans) then
        ! We should go for dynamic reallocation of the tuple
        call cubedag_message(seve%e,rname,'Not implemented: too many transpositions')
        error = .true.
        return
      endif
      tup%n = tup%n+1
      pos = tup%n
    endif
    !
    updated = .false.
    call tup%trans(pos)%upsert(iorder,morder,location,onefile,hdu,updated,error)
    if (error)  return
  end subroutine cubedag_tuple_upsert
  !
  subroutine cubedag_tuple_diskupdate(tup,error)
    !-------------------------------------------------------------------
    ! Update the disk file timestamps of all the files ONLY IF THEY HAVE
    ! CHANGED. The consistency timestamp is left unchanged on purpose.
    !-------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    logical,               intent(inout) :: error
    !
    logical :: updated
    integer(kind=4) :: iorder
    !
    updated = .false.
    do iorder=1,tup%n
      call tup%trans(iorder)%diskupdate(updated,error)
      if (error)  return
    enddo
  end subroutine cubedag_tuple_diskupdate
  !
  subroutine cubedag_tuple_setconsistent(tup,error)
    !---------------------------------------------------------------------
    ! Insert or update the consistency flag. It is the responsibility of
    ! the caller to ensure the files are consistent at the time this
    ! subroutine is called.
    !---------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>SETCONSISTENCY'
    !integer(kind=4) :: ier,pos
    !integer(kind=8) :: time
    !
    !call cubedag_message(seve%e,rname,'Consistency flag is not reimplemented')
    !error = .true.
    !return
    !
    !if (tup%tstamp(cubedag_tuple_position(code_cube_imaset,code_buffer_disk)).le.0 .or.  &
    !    tup%tstamp(cubedag_tuple_position(code_cube_speset,code_buffer_disk)).le.0) then
    !  call cubedag_message(seve%e,rname,  &
    !    'Can not set consistency while the 2 cubes are not present in tuple')
    !  error = .true.
    !  return
    !endif
    !
    !ier = gag_time(time)
    !pos = cubedag_tuple_position(code_null,code_null)
    !tup%code(pos) = code_null
    !tup%tstamp(pos) = time
    !tup%file(pos) = 'consistency'
    !tup%hdu(pos) = 0
  end subroutine cubedag_tuple_setconsistent
  !
  function cubedag_tuple_hasuptodatefile(tup,morder,location,iorder,onefile,hdu)
    use cubetools_access_types
    !---------------------------------------------------------------------
    ! Get the file for the given mapped order. The file is assumed "found"
    ! if:
    ! 1) it is present in the tuple and
    ! 2) the tuple is consistent, or the tuple is inconsistent but the
    !    requested file is the newest.
    !---------------------------------------------------------------------
    logical :: cubedag_tuple_hasuptodatefile
    type(cubedag_tuple_t), intent(in)  :: tup
    integer(kind=code_k),  intent(in)  :: morder    ! imaset, speset
    integer(kind=code_k),  intent(in)  :: location  ! Could be memory or disk
    character(len=*),      intent(out) :: iorder    ! Returned intrinsic order
    character(len=*),      intent(out) :: onefile   ! Returned file name
    integer(kind=4),       intent(out) :: hdu       ! Returned HDU in file
    !
    integer(kind=4) :: jorder
    !
    cubedag_tuple_hasuptodatefile = .false.
    iorder = ''
    onefile = ''
    hdu = 0
    !
    do jorder=1,tup%n
      if (tup%trans(jorder)%morder.ne.morder)  cycle
      if (location.eq.code_buffer_memory .and. tup%trans(jorder)%mtstamp.gt.0) then
        cubedag_tuple_hasuptodatefile = .true.
        iorder = tup%trans(jorder)%iorder
        return
      endif
      if (location.eq.code_buffer_disk .and. tup%trans(jorder)%dtstamp.gt.0) then
        cubedag_tuple_hasuptodatefile = .true.
        iorder  = tup%trans(jorder)%iorder
        onefile = tup%trans(jorder)%file
        hdu     = tup%trans(jorder)%hdu
        return
      endif
    enddo
    !
    ! CONSISTENCY checks not reimplemented
    !
    !if (access.eq.code_cube_unkset) then
    !  ! Consistency has no much meaning
    !  cubedag_tuple_hasuptodatefile = tstamp.gt.0
    !else
    !  ! Check for consistent file between image set and spectrum set
    !  ttstamp = tup%tstamp(cubedag_tuple_position(cubetools_transpose_access(access),location))
    !  ctstamp = tup%tstamp(cubedag_tuple_position(code_null,code_null))
    !  if (tstamp.le.0) then
    !    ! File does not exist
    !    cubedag_tuple_hasuptodatefile = .false.
    !  elseif (ttstamp.le.0) then
    !    ! Transposed file does not exist: no consistency issue
    !    cubedag_tuple_hasuptodatefile = .true.
    !  elseif (tstamp.le.ctstamp .and. ttstamp.le.ctstamp) then
    !    ! Files are consistent
    !    cubedag_tuple_hasuptodatefile = .true.
    !  elseif (ttstamp.le.tstamp) then
    !    ! Files are not consistent, and the requested one is the newest
    !    cubedag_tuple_hasuptodatefile = .true.
    !  else
    !    ! Files are not consistent, and the transposed one is the newest
    !    cubedag_tuple_hasuptodatefile = .false.
    !  endif
    !endif
  end function cubedag_tuple_hasuptodatefile
  !
  subroutine cubedag_tuple_list(tup,id,family,flag,error)
    use cubetools_format
    use cubedag_parameters
    use cubetools_flag_types
    !---------------------------------------------------------------------
    ! List the tuple contents
    !---------------------------------------------------------------------
    class(cubedag_tuple_t), intent(inout) :: tup
    integer(kind=iden_l),   intent(in)    :: id
    character(len=*),       intent(in)    :: family
    type(flag_list_t),      intent(in)    :: flag
    logical,                intent(inout) :: error
    ! Local
    logical :: consistent
    ! integer(kind=4) :: cpos,ipos,spos
    integer(kind=4) :: lstrflag,iorder
    character(len=128) :: strflag
    !integer(kind=8) :: ctstamp,itstamp,ststamp
    character(len=file_l) :: name
    character(len=32) :: status
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='TUPLE>LIST'
    !
    ! *** JP Why a listing needs to update the content of the tuple? To be
    ! *** sure JP sur to be uptodate? If yes, this should be stated in the
    ! *** header of the subroutine.
    call cubedag_tuple_diskupdate(tup,error)
    if (error)  return
    !
    ! CONSISTENCY NOT REIMPLEMENTED
    !cpos = cubedag_tuple_position(code_null,code_null)
    !spos = cubedag_tuple_position(code_cube_speset,code_buffer_disk)
    !ipos = cubedag_tuple_position(code_cube_imaset,code_buffer_disk)
    !ctstamp = tup%tstamp(cpos)
    !ststamp = tup%tstamp(spos)
    !itstamp = tup%tstamp(ipos)
    !
    ! Consistency
    !consistent = .false.
    !if (ststamp.le.0 .or. itstamp.le.0) then
    !  status = 'INCOMPLETE'
    !elseif (ststamp.le.ctstamp .and. itstamp.le.ctstamp) then
    !  status = 'CONSISTENT'
    !  consistent = .true.
    !else
    !  status = 'INCONSISTENT'
    !endif
    status = 'CONSISTENT'
    consistent = .true.
    !
    call flag%repr(strflag=strflag,lstrflag=lstrflag,error=error)
    if (error)  return
    write(name,'(i0,2x,3a)') id,trim(family),":",strflag(1:lstrflag)
    !
    mess = cubetools_format_stdkey_boldval('Identifier',name,60)
    mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Status',status,18)
    call cubedag_message(seve%r,rname,mess)
    !
    do iorder=1,tup%n
      call tup%trans(iorder)%list(error)
      if (error) return ! ?
    enddo
    !
    call cubedag_message(seve%r,rname,'')
  end subroutine cubedag_tuple_list
  !
  function cubedag_tuple_position(tup,iorder)
    !-------------------------------------------------------------------
    ! Find in the tuple the named transposition according to its order.
    !-------------------------------------------------------------------
    integer(kind=4) :: cubedag_tuple_position  ! Function value on return
    class(cubedag_tuple_t), intent(in) :: tup
    character(len=maxdim),  intent(in) :: iorder
    !
    integer(kind=4) :: jorder
    character(len=*), parameter :: rname='TUPLE>POSITION'
    !
    cubedag_tuple_position = 0
    do jorder=1,tup%n  ! This loop is unefficient, but 99% of the time we
                       ! have only 1 or 2 transpositions in the tuple!
      if (tup%trans(jorder)%iorder.eq.iorder) then
        cubedag_tuple_position = jorder
        return
      endif
    enddo
  end function cubedag_tuple_position
  !
  function cubedag_tuple_hascube(tup,order,location)
    !-------------------------------------------------------------------
    ! Return true if the tuple provides the order+location cube
    !-------------------------------------------------------------------
    logical :: cubedag_tuple_hascube
    class(cubedag_tuple_t), intent(in) :: tup
    character(len=*),       intent(in) :: order
    integer(kind=code_k),   intent(in) :: location
    !
    integer(kind=4) :: pos
    !
    cubedag_tuple_hascube = .false.
    !
    pos = tup%position(order)
    if (pos.eq.0)  return
    !
    if (location.eq.code_buffer_memory) then
      cubedag_tuple_hascube = tup%trans(pos)%mtstamp.gt.0
    else
      cubedag_tuple_hascube = tup%trans(pos)%dtstamp.gt.0
    endif
  end function cubedag_tuple_hascube
  !
  function cubedag_tuple_access(tup,order)
    !-------------------------------------------------------------------
    ! Return the access code of the cube referenced by the tuple
    !-------------------------------------------------------------------
    integer(kind=code_k) :: cubedag_tuple_access
    class(cubedag_tuple_t), intent(in)  :: tup
    character(len=*),       intent(in)  :: order
    !
    integer(kind=4) :: pos
    !
    pos = tup%position(order)
    if (pos.eq.0) then
      cubedag_tuple_access = code_cube_unkset
    else
      cubedag_tuple_access = tup%trans(pos)%access()
    endif
  end function cubedag_tuple_access
  !
  function cubedag_tuple_filename(tup,order,location)
    !-------------------------------------------------------------------
    ! Return the file name for access+location cube
    !-------------------------------------------------------------------
    character(len=file_l) :: cubedag_tuple_filename
    class(cubedag_tuple_t), intent(in) :: tup
    character(len=*),       intent(in) :: order
    integer(kind=code_k),   intent(in) :: location
    !
    integer(kind=4) :: pos
    !
    pos = tup%position(order)
    if (pos.eq.0) then
      cubedag_tuple_filename = '<not-yet-defined>'
    else
      cubedag_tuple_filename = tup%trans(pos)%filename(location)
    endif
  end function cubedag_tuple_filename
  !
  subroutine cubedag_tuple_location(tup,order,location,shortloc)
    !-------------------------------------------------------------------
    ! Return the location of the cube referenced by the tuple,
    ! in a string suited for LIST (i.e. properly truncating it)
    !-------------------------------------------------------------------
    class(cubedag_tuple_t), intent(in)  :: tup
    character(len=*),       intent(in)  :: order
    integer(kind=code_k),   intent(in)  :: location
    character(len=*),       intent(out) :: shortloc
    !
    integer(kind=4) :: pos
    !
    pos = tup%position(order)
    if (pos.eq.0) then
      shortloc = 'none'
    else
      call tup%trans(pos)%location(location,shortloc)
    endif
  end subroutine cubedag_tuple_location

  function cubedag_tuple_disksize(tup,order,location)
    !-------------------------------------------------------------------
    ! Return the file name for access+location cube
    !-------------------------------------------------------------------
    integer(kind=size_length) :: cubedag_tuple_disksize
    class(cubedag_tuple_t), intent(in) :: tup
    character(len=*),       intent(in) :: order
    integer(kind=code_k),   intent(in) :: location
    !
    integer(kind=4) :: pos
    !
    pos = tup%position(order)
    if (pos.eq.0) then
      cubedag_tuple_disksize = 0
    else
      cubedag_tuple_disksize = tup%trans(pos)%disksize(location)
    endif
  end function cubedag_tuple_disksize

  subroutine cubedag_tuple_rmmemo(tup,error)
    !-------------------------------------------------------------------
    ! Unreference the memory buffers for all orders
    !-------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iorder
    !
    do iorder=1,tup%n
      if (tup%trans(iorder)%mtstamp.le.0)  cycle  ! Not used
      !
      tup%trans(iorder)%mtstamp = 0
    enddo
  end subroutine cubedag_tuple_rmmemo

  subroutine cubedag_tuple_rmfiles(tup,error)
    !-------------------------------------------------------------------
    ! Remove all files on disk for the given tuple
    !-------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iorder
    !
    do iorder=1,tup%n
      if (tup%trans(iorder)%dtstamp.le.0)  cycle  ! Not used
      !
      call gag_filrm(tup%trans(iorder)%file)
      tup%trans(iorder)%dtstamp = 0
      tup%trans(iorder)%file    = ''
      tup%trans(iorder)%hdu     = 0
    enddo
  end subroutine cubedag_tuple_rmfiles
  !
!   subroutine cubedag_tuple_debug(tup)
!     class(cubedag_tuple_t), intent(in) :: tup
!     ! Local
!     integer(kind=4) :: i
!     do i=1,tuple_mmemo
!       write(stdout,form_tup)  'TUPLE',tup%code(i),tup%tstamp(i),trim(tup%file(i)),tup%hdu(i)
!     enddo
!   end subroutine cubedag_tuple_debug
  !
  function cubedag_tuple_disksizes(tup)
    !-------------------------------------------------------------------
    ! Return the disk footprint of ALL the files referenced by the tuple
    !-------------------------------------------------------------------
    integer(kind=size_length) :: cubedag_tuple_disksizes  ! [bytes]
    class(cubedag_tuple_t), intent(in) :: tup
    !
    integer(kind=4) :: iorder
    !
    cubedag_tuple_disksizes = 0
    do iorder=1,tup%n
      cubedag_tuple_disksizes = cubedag_tuple_disksizes + &
        tup%trans(iorder)%disksize(code_buffer_disk)
    enddo
  end function cubedag_tuple_disksizes

  function cubedag_tuple_contains(tup,file,hdu)
    !-------------------------------------------------------------------
    ! Return .true. is the tuple references the named file and hdu
    !-------------------------------------------------------------------
    logical :: cubedag_tuple_contains
    class(cubedag_tuple_t), intent(in) :: tup
    character(len=*),       intent(in) :: file
    integer(kind=4),        intent(in) :: hdu
    !
    integer(kind=4) :: iorder
    logical :: samefile,samehdu
    !
    cubedag_tuple_contains = .false.
    do iorder=1,tup%n
      if (tup%trans(iorder)%dtstamp.le.0)  cycle
      !
      samefile = gag_filsame(tup%trans(iorder)%file,file)
      samehdu  = tup%trans(iorder)%hdu.eq.hdu
      if (samefile.and.samehdu) then
        cubedag_tuple_contains = .true.
        return
      endif
    enddo
  end function cubedag_tuple_contains

  subroutine cubedag_tuple_to_struct(tup,userspace,error)
    use cubetools_userspace
    use cubetools_userstruct
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(cubedag_tuple_t), intent(in)    :: tup
    class(userspace_t),     intent(inout) :: userspace
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: jorder
    logical :: imamemo,spememo
    character(len=file_l) :: imafile,spefile
    integer(kind=4) :: imahdu,spehdu
    type(userstruct_t), pointer :: struct
    type(userstruct_t) :: imastruct,spestruct
    character(len=*), parameter :: rname='TUPLE>TOSTRUCT'
    !
    call cubedag_message(seve%t,rname,'Welcome')
    !
    ! Search for imaset and speset values
    imamemo = .false.
    imafile = ''
    imahdu = 0
    spememo = .false.
    spefile = ''
    spehdu = 0
    do jorder=1,tup%n
      if (tup%trans(jorder)%morder.eq.code_cube_imaset) then
        if (tup%trans(jorder)%mtstamp.gt.0) then
          imamemo = .true.
        endif
        if (tup%trans(jorder)%dtstamp.gt.0) then
          imafile = tup%trans(jorder)%file
          imahdu = tup%trans(jorder)%hdu
        endif
      endif
      if (tup%trans(jorder)%morder.eq.code_cube_speset) then
        if (tup%trans(jorder)%mtstamp.gt.0) then
          spememo = .true.
        endif
        if (tup%trans(jorder)%dtstamp.gt.0) then
          spefile = tup%trans(jorder)%file
          spehdu = tup%trans(jorder)%hdu
        endif
      endif
    enddo
    !
    ! Main structure
    struct => cubetools_userstruct_ptr(userspace,error)
    if (error)  return
    call struct%def(error)
    if (error) return
    !
    ! Image set
    call struct%def_substruct('imaset',imastruct,error)
    if (error) return
    call imastruct%set_member('memory',imamemo,error)
    if (error) return
    call imastruct%set_member('file',imafile,error)
    if (error) return
    call imastruct%set_member('hdu',imahdu,error)
    if (error) return
    !
    ! Spectrum set
    call struct%def_substruct('speset',spestruct,error)
    if (error) return
    call spestruct%set_member('memory',spememo,error)
    if (error) return
    call spestruct%set_member('file',spefile,error)
    if (error) return
    call spestruct%set_member('hdu',spehdu,error)
    if (error) return
  end subroutine cubedag_tuple_to_struct

  subroutine cubedag_tuple_iterate_init(tup)
    !-------------------------------------------------------------------
    ! (Re)initialize the tuple iterator
    !-------------------------------------------------------------------
    class(cubedag_tuple_t), intent(inout) :: tup
    !
    tup%itrans = 0
  end subroutine cubedag_tuple_iterate_init
  !
  function cubedag_tuple_iterate(tup,iorder)
    !-------------------------------------------------------------------
    ! Iterate the tuple iterator
    !-------------------------------------------------------------------
    logical :: cubedag_tuple_iterate
    class(cubedag_tuple_t), intent(inout) :: tup
    character(len=*),       intent(out)   :: iorder
    !
    if (tup%itrans.ge.tup%n) then
      cubedag_tuple_iterate = .false.
      iorder = ''
    else
      cubedag_tuple_iterate = .true.
      tup%itrans = tup%itrans+1
      iorder = tup%trans(tup%itrans)%iorder
    endif
  end function cubedag_tuple_iterate
end module cubedag_tuple
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubelist_list
  use cubetools_parameters
  use cubelist_messaging
  use cubelist_object_class
  use cubelist_object_advanced_class
  use cubelist_list_types
  !---------------------------------------------------------------------
  ! Support module for generic list of list_t contents
  !---------------------------------------------------------------------
  !
  public :: list_column_t
  public :: cubelist_column_ptr
  public :: list_column_list_t
  private
  !
  integer(kind=4), parameter :: col_width_auto=0
  !
  ! Support for 1 column
  type, abstract, extends(list_object_t) :: list_column_t
    character(len=16), public  :: name    ! Column name (identifier)
    character(len=16), public  :: header  ! Column name in header (might be truncated)
    integer(kind=4),   private :: width = col_width_auto  ! Static or dynamic column width
  contains
    procedure(get_lrepr_interface), deferred :: get_lrepr  ! [private]
    procedure(get_repr_interface),  deferred :: get_repr   ! [private]
    procedure,                      private  :: width_auto => cubelist_column_width_auto
    procedure,                      public   :: copy       => cubelist_column_copy
  end type list_column_t
  !
  ! The collection of columns to be listed
  type, extends(list_t) :: list_column_list_t
    logical,                       public  :: doheader = .true.
    integer(kind=4),               public  :: olun = stdout
    logical,                       public  :: dopage = .false.
    character(len=:), allocatable, private :: one(:)  ! One column buffer (for 1 object)
    character(len=:), allocatable, private :: all(:)  ! All columns buffer (for 1 object)
  contains
    procedure, public  :: register  => cubelist_list_register_column
    procedure, public  :: get       => cubelist_list_get_column
    procedure, public  :: widths    => cubelist_list_widths
    generic,   public  :: line      => oneline,manylines
    procedure, private :: oneline   => cubelist_list_one_line
    procedure, private :: manylines => cubelist_list_many_lines
    procedure, public  :: act       => cubelist_list_act
  end type list_column_list_t
  !
contains
  !
  function cubelist_column_ptr(obj,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(list_column_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(list_column_t), pointer :: cubelist_column_ptr
    class(list_object_t), pointer       :: obj
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='COLUMN>PTR'
    !
    select type(obj)
    class is (list_column_t)
      cubelist_column_ptr => obj
    class default
      cubelist_column_ptr => null()
      call cubelist_message(seve%e,rname,  &
        'Internal error: object is not a list_column_t type')
      error = .true.
      return
    end select
  end function cubelist_column_ptr
  !
  subroutine get_lrepr_interface(col,obj,lrepr,error)
    class(list_column_t),          intent(in)    :: col
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=4),               intent(out)   :: lrepr
    logical,                       intent(inout) :: error
  end subroutine get_lrepr_interface
  !
  subroutine get_repr_interface(col,obj,lrepr,repr,nline,error)
    class(list_column_t),          intent(inout) :: col
    class(list_object_advanced_t), intent(inout) :: obj
    integer(kind=4),               intent(in)    :: lrepr
    character(len=*),              intent(out)   :: repr(:)
    integer(kind=4),               intent(out)   :: nline
    logical,                       intent(inout) :: error
  end subroutine get_repr_interface
  !
  subroutine cubelist_column_width_auto(col,list,error)
    !-------------------------------------------------------------------
    ! Compute the best width for one column supporting adaptative width,
    ! based on the index to be listed.
    !-------------------------------------------------------------------
    class(list_column_t), intent(inout) :: col   ! One column to be listed
    class(list_t),        intent(in)    :: list  ! The collection of objects (index) to be listed
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: lrepr
    integer(kind=list_k) :: iobj
    class(list_object_advanced_t), pointer :: obj
    !
    col%width = 1
    do iobj=1,list%n
      obj => cubelist_object_advanced_ptr(list%list(iobj)%p,error)
      if (error)  return
      if (obj%hidden)  cycle
      call col%get_lrepr(obj,lrepr,error)
      if (error)  return
      col%width = max(col%width,lrepr)
    enddo
  end subroutine cubelist_column_width_auto
  !
  subroutine cubelist_column_copy(in,out,error)
    !-------------------------------------------------------------------
    ! Copy the known attributes of the abstract type. Nothing done on
    ! the unknown extended attributes,
    !-------------------------------------------------------------------
    class(list_column_t), intent(in)    :: in
    class(list_column_t), intent(inout) :: out
    logical,              intent(inout) :: error
    out%name = in%name
    out%header = in%header
  end subroutine cubelist_column_copy
  !
  !------------------------------------------------------------------------
  !
  subroutine cubelist_list_register_column(cols,col,name,header,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Register a column in the global column list
    !----------------------------------------------------------------------
    class(list_column_list_t), intent(inout) :: cols
    class(list_column_t),      intent(inout) :: col
    character(len=*),          intent(in)    :: name
    character(len=*),          intent(in)    :: header
    logical,                   intent(inout) :: error
    !
    ! Attributes
    col%name = name
    col%header = header
    !
    ! Insert in global column list
    call cols%associate(col,error)
    if (error)  return
  end subroutine cubelist_list_register_column
  !
  subroutine cubelist_list_get_column(cols,name,col,error)
    !-------------------------------------------------------------------
    ! Return a pointer to the named column
    !-------------------------------------------------------------------
    class(list_column_list_t), intent(in)    :: cols
    character(len=*),          intent(in)    :: name
    class(list_column_t),      pointer       :: col
    logical,                   intent(inout) :: error
    !
    integer(kind=list_k) :: icol
    character(len=*), parameter :: rname='COLUMN>GET'
    !
    ! ZZZ Implement dichotomic search in sorted list!
    col => null()
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      if (col%name.eq.name)  return
    enddo
    call cubelist_message(seve%e,rname,'Column not found: '//trim(name))
    error = .true.
  end subroutine cubelist_list_get_column
  !
  subroutine cubelist_list_act(cols,list,name,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(list_column_list_t), intent(inout) :: cols
    class(list_t),             intent(in)    :: list
    character(len=*),          intent(in)    :: name  ! Index name
    logical,                   intent(inout) :: error
    !
    integer(kind=list_k) :: ient
    integer(kind=4) :: tt_lines,iline
    character(len=mess_l) :: mess
    class(list_object_advanced_t), pointer :: obj
    character(len=*), parameter :: rname='LIST'
    !
    if (list%n.le.0) then
      call cubelist_message(seve%w,rname,'No entry in '//trim(name)//' index')
      return
    endif
    if (cols%n.le.0) then
      call cubelist_message(seve%e,rname,'Internal error: list of colums is empty')
      error = .true.
      return
    endif
    !
    ! Pre-compute columns widths (for those which are dynamic)
    call cols%widths(list,error)
    if (error)  return
    !
    tt_lines = sic_ttynlin()-1
    iline = 0
    !
    if (cols%doheader) then
      ! Print header
      call cubelist_list_header(cols,mess,error)
      if (error)  return
      call cubelist_list_print(mess,cols%olun,iline)
    endif
    !
    do ient=1,list%n
      ! Repeat header if relevant
      if (cols%doheader) then
        if (cols%olun.eq.stdout .and. cols%dopage) then
          if (mod(iline,tt_lines).eq.0) then
            if (hlp_more().ne.0)  return  ! Exit list by user request
            call cubelist_list_header(cols,mess,error)
            if (error)  return
            call cubelist_list_print(mess,cols%olun,iline)
          endif
        endif
      endif
      ! Show line for this object
      obj => cubelist_object_advanced_ptr(list%list(ient)%p,error)
      if (error)  return
      if (obj%hidden)  cycle
      call cubelist_list_object(cols,obj,iline,error)
      if (error)  return
    enddo
    !
    if (cols%doheader) then
      if (iline.gt.tt_lines .and. .not.cols%dopage) then
        ! Long list in non-page mode: repeat header at last line
        call cubelist_list_header(cols,mess,error)
        if (error)  return
        call cubelist_list_print(mess,cols%olun,iline)
      endif
    endif
  end subroutine cubelist_list_act
  !
  subroutine cubelist_list_widths(cols,list,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Compute the best width for columns supporting adaptative width,
    ! based on the index to be listed.
    !-------------------------------------------------------------------
    class(list_column_list_t), intent(inout) :: cols  ! The collection of columns to be listed
    class(list_t),             intent(in)    :: list  ! The collection of objects (index) to be listed
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: maxwidth,totwidth,ier
    integer(kind=list_k) :: icol
    class(list_column_t), pointer :: col
    integer(kind=4), parameter :: mline=10
    character(len=*), parameter :: rname='LIST>WIDTHS'
    !
    maxwidth = 0
    totwidth = 0
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      if (col%width.eq.col_width_auto) then
        call col%width_auto(list,error)
        if (error)  return
      endif
      maxwidth = max(maxwidth,col%width)
      totwidth = totwidth+col%width+1
    enddo
    !
    if (allocated(cols%one))  deallocate(cols%one)
    allocate(character(maxwidth)::cols%one(mline),stat=ier)
    if (failed_allocate(rname,'char buffer (1)',ier,error)) return
    if (allocated(cols%all))  deallocate(cols%all)
    allocate(character(totwidth)::cols%all(mline),stat=ier)
    if (failed_allocate(rname,'char buffer (2)',ier,error)) return
  end subroutine cubelist_list_widths
  !
  subroutine cubelist_list_header(cols,mess,error)
    !-------------------------------------------------------------------
    ! Build the header line
    !-------------------------------------------------------------------
    class(list_column_list_t), intent(inout) :: cols  ! The collection of columns to be listed
    character(len=*),          intent(out)   :: mess
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: nc
    integer(kind=list_k) :: icol
    class(list_column_t), pointer :: col
    !
    mess = ''
    nc = 0
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      mess(nc+1:nc+col%width) = col%header
      nc = nc+1+col%width
    enddo
  end subroutine cubelist_list_header
  !
  subroutine cubelist_list_object(cols,obj,cntline,error)
    !-------------------------------------------------------------------
    ! Build and print the line for object 'obj' with the desired columns
    ! 'cols'.
    ! Note that some columns may spawn over several lines.
    !-------------------------------------------------------------------
    class(list_column_list_t),     intent(inout) :: cols  ! The collection of columns to be listed
    class(list_object_advanced_t), intent(inout) :: obj
    integer(kind=4),               intent(inout) :: cntline
    logical,                       intent(inout) :: error
    !
    integer(kind=4) :: mline,iline
    !
    cols%all(:) = ''
    call cols%line(obj,cols%all,mline,error)
    if (error)  return
    do iline=1,mline
      call cubelist_list_print(cols%all(iline),cols%olun,cntline)
    enddo
  end subroutine cubelist_list_object
  !
  subroutine cubelist_list_one_line(cols,obj,repr,error)
    !-------------------------------------------------------------------
    ! Build the line for object 'obj' with the desired columns 'cols'.
    ! Support only one line (see cubelist_list_many_lines)
    !-------------------------------------------------------------------
    class(list_column_list_t),     intent(inout) :: cols  ! The collection of columns to be listed
    class(list_object_advanced_t), intent(inout) :: obj
    character(len=*),              intent(inout) :: repr
    logical,                       intent(inout) :: error
    !
    integer(kind=4) :: nc,icol,nline
    class(list_column_t), pointer :: col
    character(len=*), parameter :: rname='LIST>ONE>LINE'
    !
    nc = 0
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      cols%one(:) = ''
      call col%get_repr(obj,col%width,cols%one,nline,error)
      if (error)  return
      if (nline.gt.1) then
        call cubelist_message(seve%w,rname,  &
          'Column '//trim(col%name)//' requires more than one line')
      endif
      repr(nc+1:nc+col%width) = cols%one(1)
      nc = nc+1+col%width
    enddo
  end subroutine cubelist_list_one_line
  !
  subroutine cubelist_list_many_lines(cols,obj,repr,mline,error)
    !-------------------------------------------------------------------
    ! Build the line for object 'obj' with the desired columns 'cols'.
    ! Note that some columns may spawn over several lines.
    !-------------------------------------------------------------------
    class(list_column_list_t),     intent(inout) :: cols  ! The collection of columns to be listed
    class(list_object_advanced_t), intent(inout) :: obj
    character(len=*),              intent(inout) :: repr(:)
    integer(kind=4),               intent(out)   :: mline  ! Number of lines actually filled
    logical,                       intent(inout) :: error
    !
    integer(kind=4) :: nc,icol,nline,iline
    class(list_column_t), pointer :: col
    !
    nc = 0
    mline = 1
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      cols%one(:) = ''
      call col%get_repr(obj,col%width,cols%one,nline,error)
      if (error)  return
      do iline=1,nline
        repr(iline)(nc+1:nc+col%width) = cols%one(iline)
      enddo
      nc = nc+1+col%width
      mline = max(nline,mline)
    enddo
  end subroutine cubelist_list_many_lines
  !
  subroutine cubelist_list_print(message,olun,iline)
    !---------------------------------------------------------------------
    !  Send the message to the given Logical Unit. Quite generic, could
    ! be used in other contexts.
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: message
    integer(kind=4),  intent(in)    :: olun
    integer(kind=4),  intent(inout) :: iline  ! Current line number
    !
    character(len=*), parameter :: rname='LIST'
    !
    iline = iline+1
    if (olun.eq.stdout) then
      call cubelist_message(seve%r,rname,message)
    else
      write(olun,'(A)') trim(message)
    endif
  end subroutine cubelist_list_print
  !
end module cubelist_list

      SUBROUTINE DEFINE(LINE,ERROR)
      USE GKERNEL_INTERFACES
      CHARACTER LINE*(*)
      logical error
*      
      INCLUDE 'constant.inc'
      INCLUDE 'elements.inc'
*
      INTEGER MVOCAB
      PARAMETER (MVOCAB=1)
      CHARACTER*12 VOCAB(MVOCAB),ARGUM,KEYWOR
      INTEGER MVOCAB_METH
      PARAMETER (MVOCAB_METH=2)
      CHARACTER*12 VOCAB_METH(MVOCAB_METH)
      CHARACTER*12 METHOD
      INTEGER NKEY
      INTEGER I,J,NC
* Data
      DATA VOCAB /'METHOD'/
      DATA VOCAB_METH /'GAUSS-JORDAN','DIAGONALISE'/
*
      CALL SIC_CH (LINE,0,1,ARGUM,NC,.TRUE.,ERROR)
      IF (ERROR) RETURN
      CALL SIC_AMBIGS('DEFINE',ARGUM,KEYWOR,NKEY,
     +     VOCAB,MVOCAB,ERROR)
      IF (ERROR) RETURN
      IF (KEYWOR.EQ.'METHOD') THEN
         CALL SIC_CH (LINE,0,2,ARGUM,NC,.TRUE.,ERROR)
         IF (ERROR) RETURN
         CALL SIC_AMBIGS('DEFINE METHOD',ARGUM,METHOD,NKEY,
     +        VOCAB_METH,MVOCAB_METH,ERROR)
         IF (ERROR) RETURN
      ELSE
         ERROR = .TRUE.
      ENDIF
      RETURN
*
      END

subroutine conloc (ndp,xd,yd,ntr,ipt,nli,ipl,xii,yii,iti,iwk,wk)
  use gcont_contour
  !---------------------------------------------------------------------
  ! @ public
  !	This subroutine locates a point, i.e., determines to what
  !	triangle a given point (xii,yii) belongs.  When the given
  !	point does not lie inside the data area, this subroutine
  !	determines the border line segment when the point lies in
  !	an outside rectangular area, and two border line segments
  !	when the point lies in an outside triangular area.
  ! Arguments :
  !	NDP	I	number of data points			Input
  !	XD	R*4 (*)	Arrays of dimension NDP containing the
  !			X coordinates of the data points	Input
  !	YD	R*4 (*) Array of Y coordinates			Input
  !	NTR	I	Number of triangles			Input
  !	IPT	I (*)	Array of dimension 3*NTR containing the
  !			point numbers of the vertexes of the
  !			triangles				Input
  !	NLI	I	Number of border line segments		Input
  !	IPL	I (*)	Array of dimension 3*NLI containing the
  !			point numbers of the end points of the
  !			border line segments and their respective
  !			triangle numbers			Input
  !	XII	R*4	X coordinate of point to locate		Input
  !	YII 	R*4	Y coordinate of point to locate		Input
  !	ITI 	I	Triangle number, when the point is
  !			inside the data area, or two border
  !			line segment numbers, IL1 and IL2,
  !			coded to IL1*(NTR+NLI)+IL2, when the
  !			point is outside the data area.		Output
  !	IWK 	I (*)	Array of dimension 18*NDP used
  !			internally as a work area
  !	WK  	R*4 (*)	Array of dimension 8*NDP used internally
  !			as a work area.
  !---------------------------------------------------------------------
  integer :: ndp                    !
  real :: xd(*)                     !
  real :: yd(*)                     !
  integer :: ntr                    !
  integer :: ipt(*)                 !
  integer :: nli                    !
  integer :: ipl(*)                 !
  real :: xii                       !
  real :: yii                       !
  integer :: iti                    !
  integer :: iwk(*)                 !
  real :: wk(*)                     !
  ! Local
  integer :: ntsc(9), idsc(9)
  !      REAL SIDE,U1,U2,V1,V2,U3,V3,SPDT
  integer :: nt0, nl0, idp, isc, it0t3, it0, i1, i2, i3
  integer :: jiwk, ip1, ip2, ip3, il1, il2, il1t3
  integer :: ntsci, itsc, ntl, jwk
  real :: x0, y0, xmn, xmx, ymn, ymx
  real :: xi, yi, xs1, ys1, xs2, ys2
  real :: x1, y1, x2, y2, x3, y3
  !
  ! Needed for at least NTSC, XS1, XS2, YS1, YS2
  save ntsc, xi, yi, xs1, ys1, xs2, ys2
  !
  ! Statement functions
  !
  !      SIDE(U1,V1,U2,V2,U3,V3) = (U1-U3)*(V2-V3)-(V1-V3)*(U2-U3)
  !      SPDT(U1,V1,U2,V2,U3,V3) = (U1-U2)*(U3-U2)+(V1-V2)*(V3-V2)
  !
  ! Preliminary processing
  !
  nt0 = ntr
  nl0 = nli
  ntl = nt0+nl0
  x0 = xii
  y0 = yii
  !
  ! Processing for a new set of data points
  !
  if (nit .ne. 0) go to  170
  nit = 1
  !
  ! Divides the X-Y plane into nine rectangular sections.
  !
  xmn = xd(1)
  xmx = xmn
  ymn = yd(1)
  ymx = ymn
  do idp=2,ndp
    xi = xd(idp)
    yi = yd(idp)
    xmn = amin1(xi,xmn)
    xmx = amax1(xi,xmx)
    ymn = amin1(yi,ymn)
    ymx = amax1(yi,ymx)
  enddo
  xs1 = (xmn+xmn+xmx)/3.0
  xs2 = (xmn+xmx+xmx)/3.0
  ys1 = (ymn+ymn+ymx)/3.0
  ys2 = (ymn+ymx+ymx)/3.0
  !
  ! Determines and stores in the IWK array triangle numbers of
  ! the triangles associated with each of the nine sections.
  !
  do isc=1,9
    ntsc(isc) = 0
    idsc(isc) = 0
  enddo
  it0t3 = 0
  jwk = 0
  do it0=1,nt0
    it0t3 = it0t3+3
    i1 = ipt(it0t3-2)
    i2 = ipt(it0t3-1)
    i3 = ipt(it0t3)
    xmn = amin1(xd(i1),xd(i2),xd(i3))
    xmx = amax1(xd(i1),xd(i2),xd(i3))
    ymn = amin1(yd(i1),yd(i2),yd(i3))
    ymx = amax1(yd(i1),yd(i2),yd(i3))
    if (ymn .gt. ys1) go to  120
    if (xmn .le. xs1) idsc(1) = 1
    if (xmx.ge.xs1 .and. xmn.le.xs2) idsc(2) = 1
    if (xmx .ge. xs2) idsc(3) = 1
120 if (ymx.lt.ys1 .or. ymn.gt.ys2) go to  130
    if (xmn .le. xs1) idsc(4) = 1
    if (xmx.ge.xs1 .and. xmn.le.xs2) idsc(5) = 1
    if (xmx .ge. xs2) idsc(6) = 1
130 if (ymx .lt. ys2) go to  140
    if (xmn .le. xs1) idsc(7) = 1
    if (xmx.ge.xs1 .and. xmn.le.xs2) idsc(8) = 1
    if (xmx .ge. xs2) idsc(9) = 1
140 do isc=1,9
      if (idsc(isc).eq.0) cycle    ! ISC
      jiwk = 9*ntsc(isc)+isc
      iwk(jiwk) = it0
      ntsc(isc) = ntsc(isc)+1
      idsc(isc) = 0
    enddo                      ! ISC
    !
    ! Stores in the WK array the minimum and maximum of the X and
    ! Y coordinate values for each of the triangle.
    !
    jwk = jwk+4
    wk(jwk-3) = xmn
    wk(jwk-2) = xmx
    wk(jwk-1) = ymn
    wk(jwk) = ymx
  enddo                        ! IT0
  go to  200
  !
  ! Checks if in the same triangle as previous.
  !
170 it0 = itipv
  if (it0 .gt. nt0) go to  180
  it0t3 = it0*3
  ip1 = ipt(it0t3-2)
  x1 = xd(ip1)
  y1 = yd(ip1)
  ip2 = ipt(it0t3-1)
  x2 = xd(ip2)
  y2 = yd(ip2)
  if (side(x1,y1,x2,y2,x0,y0) .lt. 0.0) go to  200
  ip3 = ipt(it0t3)
  x3 = xd(ip3)
  y3 = yd(ip3)
  if (side(x2,y2,x3,y3,x0,y0) .lt. 0.0) go to  200
  if (side(x3,y3,x1,y1,x0,y0) .lt. 0.0) go to  200
  go to  260
  !
  ! Checks if on the same border line segment.
  !
180 il1 = it0/ntl
  il2 = it0-il1*ntl
  il1t3 = il1*3
  ip1 = ipl(il1t3-2)
  x1 = xd(ip1)
  y1 = yd(ip1)
  ip2 = ipl(il1t3-1)
  x2 = xd(ip2)
  y2 = yd(ip2)
  if (il2 .ne. il1) go to  190
  if (spdt(x1,y1,x2,y2,x0,y0) .lt. 0.0) go to  200
  if (spdt(x2,y2,x1,y1,x0,y0) .lt. 0.0) go to  200
  if (side(x1,y1,x2,y2,x0,y0) .gt. 0.0) go to  200
  go to  260
  !
  ! Checks if between the same two border line segments.
  !
190 if (spdt(x1,y1,x2,y2,x0,y0) .gt. 0.0) go to  200
  ip3 = ipl(3*il2-1)
  x3 = xd(ip3)
  y3 = yd(ip3)
  if (spdt(x3,y3,x2,y2,x0,y0) .le. 0.0) go to  260
  !
  ! Locates inside the data area.
  ! Determines the section in which the point in question lies.
  !
200 isc = 1
  if (x0 .ge. xs1) isc = isc+1
  if (x0 .ge. xs2) isc = isc+1
  if (y0 .ge. ys1) isc = isc+3
  if (y0 .ge. ys2) isc = isc+3
  !
  ! Searches through the triangles associated with the section.
  !
  ntsci = ntsc(isc)
  if (ntsci .le. 0) go to  220
  jiwk = -9+isc
  do itsc=1,ntsci
    jiwk = jiwk+9
    it0 = iwk(jiwk)
    jwk = it0*4
    if (x0 .lt. wk(jwk-3)) cycle
    if (x0 .gt. wk(jwk-2)) cycle
    if (y0 .lt. wk(jwk-1)) cycle
    if (y0 .gt. wk(jwk))   cycle
    it0t3 = it0*3
    ip1 = ipt(it0t3-2)
    x1 = xd(ip1)
    y1 = yd(ip1)
    ip2 = ipt(it0t3-1)
    x2 = xd(ip2)
    y2 = yd(ip2)
    if (side(x1,y1,x2,y2,x0,y0) .lt. 0.0) cycle
    ip3 = ipt(it0t3)
    x3 = xd(ip3)
    y3 = yd(ip3)
    if (side(x2,y2,x3,y3,x0,y0) .lt. 0.0) cycle
    if (side(x3,y3,x1,y1,x0,y0) .lt. 0.0) cycle
    go to  260
  enddo                        ! ITSC
  !
  ! Locates outside the data area.
  !
220 do il1=1,nl0
    il1t3 = il1*3
    ip1 = ipl(il1t3-2)
    x1 = xd(ip1)
    y1 = yd(ip1)
    ip2 = ipl(il1t3-1)
    x2 = xd(ip2)
    y2 = yd(ip2)
    if (spdt(x2,y2,x1,y1,x0,y0) .lt. 0.0) cycle
    if (spdt(x1,y1,x2,y2,x0,y0) .lt. 0.0) go to  230
    if (side(x1,y1,x2,y2,x0,y0) .gt. 0.0) cycle
    il2 = il1
    go to  250
230 il2 = mod(il1,nl0)+1
    ip3 = ipl(3*il2-1)
    x3 = xd(ip3)
    y3 = yd(ip3)
    if (spdt(x3,y3,x2,y2,x0,y0) .le. 0.0) go to  250
  enddo                        ! IL1
  it0 = 1
  go to  260
250 it0 = il1*ntl+il2
  !
  ! Normal exit
  !
260 iti = it0
  itipv = it0
  return
  !
contains
  !
  ! Statement functions
  real function side(u1,v1,u2,v2,u3,v3)
    real :: u1                      !
    real :: v1                      !
    real :: u2                      !
    real :: v2                      !
    real :: u3                      !
    real :: v3                      !
    side = (u1-u3)*(v2-v3)-(v1-v3)*(u2-u3)
  end function side
  !
  real function spdt(u1,v1,u2,v2,u3,v3)
    real :: u1                      !
    real :: v1                      !
    real :: u2                      !
    real :: v2                      !
    real :: u3                      !
    real :: v3                      !
    spdt = (u1-u2)*(u3-u2)+(v1-v2)*(v3-v2)
  end function spdt
  !
end subroutine conloc

module class_addons
  use gildas_def
  integer(kind=1), save :: mem_user(8)
  integer(kind=address_length), save :: addr_user
  integer(kind=address_length), save :: ip_user
end module class_addons
!
subroutine class_languages(user_function)
  use class_dependencies_interfaces
  use class_interfaces, except_this=>class_languages
  use class_addons
  !---------------------------------------------------------------------
  ! @ private
  ! LAS initialization routine
  ! SIC is loaded with LAS and ANALYSE languages, plot library is
  ! initialized, and SIC variables are defined.
  !---------------------------------------------------------------------
  logical, external :: user_function
  ! Local
  integer, parameter :: mlas=117  ! LAS          language
  integer, parameter :: mana=62   ! ANALYSE      language
  integer, parameter :: mfit=17   ! FIT          language
  integer, parameter :: mdec=11   ! DECONV       language
  integer, parameter :: mexp=22   ! EXPERIMENTAL language
  character(len=12) :: vocab_las(mlas)
  character(len=12) :: vocab_ana(mana)
  character(len=12) :: vocab_fit(mfit)
  character(len=12) :: vocab_dec(mdec)
  character(len=12) :: vocab_exp(mexp)
  character(len=20) :: version
  logical :: error
  ! Data
  data vocab_las /  &
       ' ACCUMULATE', '/RESAMPLE','/NOCHECK','/WEIGHT',                      &
       ' ASSOCIATE', '/BAD','/UNIT','/DELETE',                               &
       ' AVERAGE', '/NOMATCH','/RESAMPLE','/NOCHECK','/WEIGHT',              &
       ' BASE', '/PLOT','/CONTINUUM','/INDEX','/OBS',                        &
       ' BOX', '/INDEX','/OBS','/UNIT',                                      &
       ' CATALOG', '/STATUS','/SORT',                                        &
       ' CONSISTENCY', '/NOCHECK',                                           &
       ' COPY', '/SORTED',                                                   &
       ' DROP',                                                              &
       ' DUMP', '/SECTION',                                                  &
       ' EXTRACT', '/INDEX',                                                 &
       ' FILE', '/OVERWRITE',                                                &
       ' FIND', '/ALL','/LINE','/NUMBER','/SCAN','/OFFSET','/SOURCE',        &
                '/RANGE','/QUALITY','/TELESCOPE', '/SUBSCAN','/ENTRY',       &
                '/OBSERVED','/REDUCED','/FREQUENCY','/SECTION','/USER',      &
                '/MASK','/POSITION','/SWITCHMODE','/DRIFT','/DIRECTION',     &
       ' FITS', '/BITS','/STYLE','/XTENSION','/MODE','/CHECK',               &
       ' FOLD', '/BOUNDARIES',                                               &
       ' GET',                                                               &
       ' HEADER',                                                            &
       ' IGNORE', '/SCAN',                                                   &
       ' LIST', '/BRIEF','/LONG','/SCAN','/OUTPUT','/TOC','/VARIABLE',       &
       ' LOAD', '/NOCHECK',                                                  &
       ' MERGE',                                                             &
       ' MODIFY', '/RUZE',                                                   &
       ' MULTIPLY',                                                          &
       ' NEW_DATA',                                                          &
       ' PLOT', '/INDEX','/OBS',                                             &
       ' SAVE',                                                              &
       ' SET', '/NOCURSOR','/DEFAULT','/POLYGON','/VARIABLE','/ASSOCIATED',  &
       ' SHOW',                                                              &
       ' SPECTRUM', '/INDEX','/OBS','/PEN',                                  &
       ' STITCH', '/NOMATCH','/RESAMPLE','/IMAGE','/LINE','/TELESCOPE',      &
                  '/NOCHECK','/WEIGHT',                                      &
       ' SWAP',                                                              &
       ' TAG',                                                               &
       ' TITLE', '/INDEX','/OBS','/BRIEF','/LONG','/FULL',                   &
       ' UPDATE',                                                            &
       ' WRITE' /
  data vocab_ana /  &
       ' COMMENT',                                                           &
       ' DIVIDE',                                                            &
       ' DRAW', '/PEN',                                                      &
       ' FFT', '/REMOVE','/KILL','/INDEX','/OBS','/NOCURS','/CURS',          &
       ' FILL', '/INTER','/NOISE','/BLANK',                                  &
       ' GREG', '/FORMATTED','/READ',                                        &
       ' LMV', '/SCAN','/STEP','/LINE','/FORCE',                             &
       ' MAP', '/CELL','/GRID','/NOLABEL','/NUMBER','/BASE',                 &
       ' MEMORIZE', '/DELETE',                                               &
       ' MODEL', '/BLANK','/REGULAR','/FREQUENCY','/XAXIS',                  &
       ' NOISE',                                                             &
       ' POPUP',                                                             &
       ' PRINT', '/OUTPUT','/TABLE',                                         &
       ' REDUCE',                                                            &
       ' RESAMPLE', '/FFT','/NOFFT','/LIKE',                                 &
       ' RETRIEVE',                                                          &
       ' SMOOTH',                                                            &
       ' STAMP', '/LABEL',                                                   &
       ' STRIP',                                                             &
       ' TABLE', '/MATH','/RANGE','/RESAMPLE','/FFT','/FREQUENCY',           &
                 '/NOCHECK','/SIGMA','/WEIGHT','/LIKE','/NASMYTH'  /
  data vocab_fit /  &
       ' DISPLAY', '/NOPLOT','/METHOD',                                      &
       ' ITERATE', '/NOCHECK',                                               &
       ' KEEP',                                                              &
       ' LINES', '/NOCURSOR','/INPUT','/SHOW',                               &
       ' METHOD',                                                            &
       ' MINIMIZE', '/NOCHECK',                                              &
       ' RESIDUAL',                                                          &
       ' RESULT',                                                            &
       ' VISUALIZE', '/PEN'/
  data vocab_dec /  &
       ' INITIALIZE', '/MODEL','/SIMULATE','/WEIGHT','/BMSW',                &
       ' DECONVOLVE', '/GAIN','/DERIV','/BMSW','/NOCHANNELS','/KEEP'/
  data vocab_exp /  &
       ' DIFF',                                                              &
       ' FILTER', '/STORE',                                                  &
       ' MEDIAN',                                                            &
       ' RMS', '/NOCHECK','/RESAMPLE','/WEIGHT',                             &
       ' SUBTRACT',                                                          &
       ' UNBLANK', '/MODE',                                                  &
       ' UV_ZERO', '/VERBOSE','/NEW','/NOCHECK','/LIKE',                     &
       ' VARIABLE', '/MODE','/INDEX',                                        &
       ' WAVELET', '/BASE','/PLOT'/
  !
  error = .false.
  !
  ! Code
  version = '6.0 15-JUN-2005'
  call sic_begin('LAS','GAG_HELP_LAS',mlas,vocab_las,   &
                 version//'  PHB - SG - JP - RL', run_sas, class_error)
  call sic_begin('ANALYSE','GAG_HELP_ANALYSE',mana,vocab_ana,   &
                 version//'  PHB - SG - JP - RL', run_ana, class_error)
  call sic_begin('FIT','GAG_HELP_FIT',mfit,vocab_fit,   &
                 version//'  PHB - SG - JP - RL', run_fit, class_error)
  call sic_begin('DSB2SSB','GAG_HELP_DSB2SSB',mdec,vocab_dec,   &
                 version//'  PHB - SG - JP - RL', run_dec, class_error)
  call sic_begin('EXPERIMENTAL','GAG_HELP_EXPERIMENTAL',mexp,vocab_exp,  &
                 version//'  JP - SB - PG', run_exp, class_error)
  !
  addr_user = locwrd(user_function)
  ip_user = bytpnt(addr_user,mem_user)
end subroutine class_languages
!
function class_error()
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for the error status of the library. Does nothing
  ! here.
  !---------------------------------------------------------------------
  logical :: class_error  ! Function value on return
  !
  class_error = .false.
  !
end function class_error
!
!-----------------------------------------------------------------------
!
subroutine run_sas(line,comm,error)
  use class_addons
  use class_rt
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Support routine for LAS\ language
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  character(len=*), intent(in)  :: comm   ! Command name
  logical,          intent(out) :: error  ! Error status
  !
  call sub_sas(line,comm,error,mem_user(ip_user))
end subroutine run_sas
!
subroutine run_ana(line,comm,error)
  use class_addons
  use class_rt
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Support routine for ANALYSE\ language
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Command line
  character(len=*), intent(in)    :: comm   ! Command name
  logical,          intent(out)   :: error  ! Error status
  !
  call sub_ana(line,comm,error,mem_user(ip_user))
end subroutine run_ana
!
subroutine run_fit(line,comm,error)
  use class_addons
  use class_rt
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Support routine for FIT\ language
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  character(len=*), intent(in)  :: comm   ! Command name
  logical,          intent(out) :: error  ! Error status
  !
  call sub_fit(line,comm,error,mem_user(ip_user))
end subroutine run_fit
!
subroutine run_dec(line,comm,error)
  use class_addons
  use class_rt
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Support routine for DSB2SSB\ language
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  character(len=*), intent(in)  :: comm   ! Command name
  logical,          intent(out) :: error  ! Error status
  !
  call sub_dec(line,comm,error,mem_user(ip_user))
end subroutine run_dec
!
subroutine run_exp(line,comm,error)
  use class_addons
  use class_rt
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Support routine for EXPERIMENTAL\ language
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  character(len=*), intent(in)  :: comm   ! Command name
  logical,          intent(out) :: error  ! Error status
  !
  call sub_exp(line,comm,error,mem_user(ip_user))
end subroutine run_exp
!
!-----------------------------------------------------------------------
subroutine sub_sas(line,comm,error,user_function)
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces
  use class_setup
  use class_rt
  !----------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! CLASS Main routine for language LAS\
  ! Call appropriate subroutine according to COMM
  !----------------------------------------------------------------------
  character(len=*),  intent(in)    :: line           ! Command line
  character(len=*),  intent(in)    :: comm           ! Command name
  logical,           intent(out)   :: error          ! Error status
  logical,           external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='LAS'
  integer(kind=4) :: i
  integer(kind=4), save :: icall=0
  !
  if (icall.ne.0) then
     Print *,'Re-entrant call to RUN_LAS ',comm,', type a number to continue'
     read(5,*) i
  endif
  icall = icall+1
  !
  call class_message(seve%c,rname,line)
  !
  error = .false.
  if (r%is_otf) then
    select case (comm)
    case ('COPY')
      call class_copy(set,line,error,user_function)
    case ('FILE')
      call class_file(set,line,error)
    case ('FIND')
      call find(set,line,error)
    case ('GET')
      call get(set,line,r,error,user_function)
    case ('LIST')
      call class_list(set,line,error)
    case ('SET')
      call class_set_command(set,line,r,error)
    case ('SHOW')
      call class_show_comm(set,line,r,error)
    case ('WRITE')
      call class_write_comm(set,line,r,error,user_function)
    case default
      call class_message(seve%e,rname,'Command forbidden on OTF data')
      call class_message(seve%e,rname,'Use WRITE to convert this data into spectra')
      error = .true.
    end select
    icall = icall-1
    return
  endif
  !
  select case (comm)
  case ('ACCUMULATE')
    call class_accumulate(set,line,r,t,error)
  case ('ASSOCIATE')
    call class_associate(set,line,r,error)
  case ('AVERAGE')
    call copyrt(user_function,'FREE')
    call class_average(set,line,r,error,user_function)
  case ('BASE')
    call copyrt(user_function,'KEEP')
    call baseline(set,line,r,error,user_function)
  case ('BOX')
    call class_box(set,line,r,error)
  case ('CATALOG')
    call class_catalog(line,error)
  case ('CONSISTENCY')
    call index_consistency_check(set,line,error,user_function)
  case ('COPY')
    call class_copy(set,line,error,user_function)
  case ('DROP')
    call class_drop(line,r,error)
  case ('DUMP')
    call class_dump(line,r,t,error)
  case ('EXTRACT')
    call copyrt(user_function,'FREE')
    call extract(set,line,r,error,user_function)
  case ('FILE')
    call class_file(set,line,error)
  case ('FIND')
    call find(set,line,error)
  case ('FITS')
    call copyrt(user_function,'FREE')
    call fits_class(set,line,r,error,user_function)
  case ('FOLD')
    call copyrt(user_function,'KEEP')
    call class_fold(set,line,r,error,user_function)
  case ('GET')
    call copyrt(user_function,'FREE')
    call get(set,line,r,error,user_function)
  case ('HEADER')
    call class_header(set,r,error)
  case ('IGNORE')
    call ignore(line,error)
  case ('LIST')
    call class_list(set,line,error)
  case ('LOAD')
    call load_2d(set,line,error,user_function)
  case ('MERGE')
    call copyrt(user_function,'FREE')
    call merge(set,r,error,user_function)
  case ('MODIFY')
    call modify(set,line,r,error)
  case ('MULTIPLY')
    call multi(set,line,r,error)
  case ('NEW_DATA')
    call new_data(line,error)
  case ('PLOT')
    call class_plot(set,line,r,error)
  case ('SAVE')
    call class_save(set,line,error)
  case ('SET')
    call class_set_command(set,line,r,error)
  case ('SHOW')
    call class_show_comm(set,line,r,error)
  case ('SPECTRUM')
    call class_spectrum(set,line,r,error)
  case ('STITCH')
    call copyrt(user_function,'FREE')
    call class_stitch(set,line,r,error,user_function)
  case ('SWAP')
    call class_swap(line,error,user_function)
  case ('TAG')
    call tagout(line,r,error)
  case ('TITLE')
    call class_title(set,line,r,error)
  case ('UPDATE')
    ! Do not try to write it in case of error !...
    call class_update_comm(set,r,error,user_function)
  case ('WRITE')
    call class_write_comm(set,line,r,error,user_function)
  case default
    call class_message(seve%e,rname,'You are using an undocumented, unsupported feature')
    call class_message(seve%e,rname,trim(comm)//' not yet implemented')
    call class_message(seve%e,rname,'Command line: '//line)
    error = .true.
  end select
  icall = icall-1
end subroutine sub_sas
!
subroutine sub_ana(line,comm,error,user_function)
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces
  use class_rt
  use class_setup
  !----------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! CLASS Main routine for language ANALYSE\
  ! Call appropriate subroutine according to COMM
  !----------------------------------------------------------------------
  character(len=*),  intent(inout) :: line           ! Command line (inout because of command DRAW)
  character(len=*),  intent(in)    :: comm           ! Command name
  logical,           intent(out)   :: error          ! Error status
  logical,           external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='ANALYSE'
  character(len=message_length) :: mess
  integer(kind=4) :: i
  integer(kind=4), save :: icall=0
  !
  if (icall.ne.0) then
     Print *,'Re-entrant call to RUN_ANA ',comm,', type a number to continue'
     read(5,*) i
  endif
  !
  call class_message(seve%c,rname,line)
  !
  if (r%is_otf) then
     call class_message(seve%e,rname,'Command forbidden on OTF data')
     call class_message(seve%e,rname,'Use WRITE to convert this data into spectra')
     error = .true.
     return
  endif
  icall = icall+1
  !
  select case (comm)
  case ('COMMENT')
    call class_comment(line,r,error)
  case ('DIVIDE')
    call class_divide(set,line,r,t,error)
  case ('DRAW')
    call class_draw(set,line,r,error)
  case ('FILL')
    call copyrt(user_function,'KEEP')
    call class_fill(set,line,r,error,user_function)
  case ('FFT')
    call copyrt(user_function,'KEEP')
    call class_fft(set,line,r,error,user_function)
  case ('GREG')
    call copyrt(user_function,'FREE')
    call class_greg(set,line,r,error,user_function)
  case ('LMV')
    call class_lmv(set,line,error,user_function)
  case ('MAP')
    call class_cells(set,line,error,user_function)
  case ('MEMORIZE')
    call memorize(line,r,error)
  case ('MODEL')
    call copyrt(user_function,'FREE')
    call model (set,line,r,t,error,user_function)
  case ('NOISE')
    call copyrt(user_function,'FREE')
    call class_noise(set,line,r,error,user_function)
  case ('POPUP')
    call popup(set,line,error,user_function)
  case ('PRINT')
    call class_print(set,line,error)
  case ('RESAMPLE')
    call copyrt(user_function,'FREE')
    call class_resample(set,line,r,error)
    if (error)  call swaprt(comm,error,user_function)
  case ('RETRIEVE')
    call copyrt(user_function,'KEEP')
    call retrieve(set,line,r,error,user_function)
    if (error)  call swaprt(comm,error,user_function)
  case ('SMOOTH')
    call copyrt(user_function,'FREE')
    call smooth(set,line,r,t,error,user_function)
  case ('STAMP')
    call stamp(set,line,error,user_function)
  case ('STRIP')
    call class_strip(set,line,error,user_function)
  case ('TABLE')
    call copyrt(user_function,'FREE')
    call class_table(set,line,r,error,user_function)
    call swaprt(comm,error,user_function)  ! R buffer may have been modified (/MATH mode)
  case ('REDUCE')
    call class_message(seve%e,rname,'REDUCE not yet implemented')
    error = .true.
    ! if (r%head%gen%kind.eq.kind_sky) then
    !   call redsky(line,r,error)
    ! else
    !   call class_message(seve%w,'REDUCE','Only valid for skydips')
    ! endif
  case default
    mess = 'ANALYSE'//char(92)//comm//' not yet implemented'
    call class_message(seve%i,rname,mess)
    error = .true.
  end select
  icall = icall-1
end subroutine sub_ana
!
subroutine sub_fit(line,comm,error,user_function)
  use gbl_constant
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces
  use class_rt
  use class_setup
  !----------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! CLASS Main routine for language FIT\
  !   Call appropriate subroutine according to COMM
  !----------------------------------------------------------------------
  character(len=*),  intent(in)    :: line           ! Command line
  character(len=*),  intent(in)    :: comm           ! Command name
  logical,           intent(out)   :: error          ! Error status
  logical,           external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='FIT'
  character(len=message_length) :: mess
  integer(kind=4) :: i
  integer(kind=4), save :: icall=0
  !
  if (icall.ne.0) then
     Print *,'Re-entrant call to RUN_FIT ',comm,', type a number to continue'
     read(5,*) i
  endif
  !
  call class_message(seve%c,rname,line)
  !
  if (r%is_otf) then
     call class_message(seve%e,rname,'Command forbidden on OTF data')
     call class_message(seve%e,rname,'Use WRITE to convert this data into spectra')
     error = .true.
     return
  endif
  icall = icall+1
  !
  select case (comm)
  case ('DISPLAY')
    call display(set,line,r,error)
  case ('ITERATE')
    call iterate_fit(set,line,r,error)
  case ('KEEP')
    call keepfi(set,r,error)
  case ('LINES')
    call fitlines(set,line,r,error)
  case ('METHOD')
    call class_method(set,line,error)
  case ('MINIMIZE')
    call minimize(set,line,r,error)
  case ('RESIDUAL')
    call copyrt(user_function,'KEEP')
    call residu_comm(set,line,r,user_function,error)
  case ('RESULT')
    call copyrt(user_function,'KEEP')
    call result_comm(set,line,r,user_function,error)
  case ('VISUALIZE')
    call plotfit(set,line,r,error)
  case default
    mess = 'FIT'//char(92)//comm//' not yet implemented'
    call class_message(seve%i,rname,mess)
    error = .true.
  end select
  icall = icall-1
end subroutine sub_fit
!
subroutine sub_dec(line,comm,error,user_function)
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces
  use class_rt
  use class_setup
  !----------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! CLASS Main routine for language DSB2SSB\
  !  Call appropriate subroutine according to COMM
  !----------------------------------------------------------------------
  character(len=*),  intent(in)    :: line           ! Command line
  character(len=*),  intent(in)    :: comm           ! Command name
  logical,           intent(out)   :: error          ! Error status
  logical,           external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='DSB2SSB'
  character(len=message_length) :: mess
  integer(kind=4) :: i
  integer(kind=4), save :: icall=0
  !
  if (icall.ne.0) then
     Print *,'Re-entrant call to RUN_DECONV ',comm,', type a number to continue'
     read(5,*) i
  endif
  !
  call class_message(seve%c,rname,line)
  !
  if (r%is_otf) then
     call class_message(seve%e,rname,'Command forbidden on OTF data')
     call class_message(seve%e,rname,'Use WRITE to convert this data into spectra')
     error = .true.
     return
  endif
  icall = icall+1
  !
  select case (comm)
  case ('DECONVOLVE')
    call copyrt(user_function,'FREE')
    call deconv(set,line,r,error,user_function)
  case ('INITIALIZE')
    call deconv_init(set,line,r,error,user_function)
  case default
    mess = rname//char(92)//comm//' not yet implemented'
    call class_message(seve%i,rname,mess)
    error = .true.
  end select
  icall = icall-1
end subroutine sub_dec
!
subroutine sub_exp(line,comm,error,user_function)
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces
  use class_rt
  use class_setup
  !----------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! CLASS Main routine for language EXPERIMENTAL\
  !  Call appropriate subroutine according to COMM
  !----------------------------------------------------------------------
  character(len=*),  intent(in)    :: line           ! Command line
  character(len=*),  intent(in)    :: comm           ! Command name
  logical,           intent(out)   :: error          ! Error status
  logical,           external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='EXPERIMENTAL'
  character(len=message_length) :: mess
  integer(kind=4) :: i
  integer(kind=4), save :: icall=0
  !
  if (icall.ne.0) then
     Print *,'Re-entrant call to RUN_EXPERIMENTAL ',comm,', type a number to continue'
     read(5,*) i
  endif
  !
  call class_message(seve%c,rname,line)
  !
  if (r%is_otf) then
     call class_message(seve%e,rname,'Command forbidden on OTF data')
     call class_message(seve%e,rname,'Use WRITE to convert this data into spectra')
     error = .true.
     return
  endif
  icall = icall+1
  !
  select case (comm)
  case ('DIFF')
    call class_diff(set,line,r,t,error,user_function)
  case ('FILTER')
    call class_filter(line,r,error)
  case ('MEDIAN')
    call class_median(set,line,r,error)
  case ('RMS')
    call copyrt(user_function,'FREE')
    call class_rms(set,line,r,error,user_function)
  case ('SUBTRACT')
    call class_subtract_comm(set,line,r,t,error)
  case ('UNBLANK')
    call class_unblank(line,error)
  case ('UV_ZERO')
    call class_uvt(set,line,r,error,user_function)
  case ('VARIABLE')
    call class_variable(set,line,error,user_function)
  case ('WAVELET')
    call copyrt(user_function,'FREE')
    call class_wavelet(line,r,error,user_function)
  case default
    mess = rname//char(92)//comm//' not yet implemented'
    call class_message(seve%i,rname,mess)
    error = .true.
  end select
  icall = icall-1
end subroutine sub_exp

program uv_circle
  use gkernel_interfaces
  use image_def
  !---------------------------------------------------------------------
  ! Updated by R.Neri 09/09/93
  !       - Compute maximum uv_radius when QMAX = 0
  !       - Skip over empty regions
  !---------------------------------------------------------------------
  ! Global
  type (gildas) :: huvd
  type (gildas) :: huvo
  !
  ! Local
  character(len=80) :: name, resu
  integer :: n, i, eff_dim, ier, mq, nq
  integer :: nvs, nvi, kvi
  integer, allocatable :: array(:),flag(:)
  real, allocatable :: q(:), meter(:)
  logical :: error
  real :: qstep, qmax, qmin
  !
  call gildas_open
  call gildas_char('UVTABLE$',name)
  call gildas_char('OUTABLE$',resu)
  call gildas_real('QMIN$',qmin,1)
  call gildas_real('QMAX$',qmax,1)
  call gildas_real('QSTEP$',qstep,1)
  call gildas_close
  !
  print *,'UV_CIRCLE Fortran 90 version'
  n = len_trim(name)
  if (n.eq.0) goto 999
  n = len_trim(resu)
  if (n.eq.0) goto 999
  !
  ! Input file
  call gildas_null(huvd, type = 'UVT')
  error = .false.
  call gdf_read_gildas(huvd,name,'.uvt', error)
  if (error) then
    call gagout ('F-UV_CIRCLE,  Cannot read input table')
    goto 999
  endif
  !
  ! Create New Table   (Y common)
  call gildas_null(huvo, type = 'UVT')
  call gdf_copy_header(huvd,huvo,error)
  call sic_parsef(resu,huvo%file,' ','.uvt')
  call gagout('I-UV_CIRCLE,  Creating  UV table '//   &
     &    trim(huvo%file))
  nvs = huvd%gil%dim(1)
  nvi = huvd%gil%dim(2)
  !
  if (qmax.eq.0) qmax = uv_max (huvd%r2d,nvs,nvi)
  huvo%gil%dim(2) = (qmax-qmin)/qstep
  kvi = huvo%gil%dim(2)
  mq = huvo%gil%dim(2)+1
  allocate (q(mq), meter(mq), flag(mq), array(mq), stat=ier)
  !
  do i=1, mq 
    q(i) = qmin+(i-1)*qstep
  enddo
  write(6,*) mq,q(1:mq)  
  !
  ! Find actual size
  call uv_steps (huvd%r2d,nvs,nvi, &
     &    q,kvi,eff_dim, array,meter,flag,mq)
  huvo%gil%ndim = 2
  huvo%gil%dim(2) = eff_dim
  huvo%gil%dim(3) = 1
  huvo%gil%dim(4) = 1
  allocate (huvo%r2d(huvo%gil%dim(1),huvo%gil%dim(2)),stat=ier)
  !
  nq = int((qmax-qmin)/qstep)
  call circle (nvs,nvi,huvd%gil%nchan,huvd%r2d,   &
     &    nq,huvo%r2d,q,eff_dim,   &
     &    array,meter,mq)
  !
  ! Cleaning
  deallocate(q,meter,flag,array)
  !
  ! Don't forget to reset the number of visibilities
  huvo%gil%nvisi = huvo%gil%dim(2)
  call gdf_create_image(huvo,error)
  call gdf_write_uvall(huvo,huvo%r2d,error)
  !
  call gagout('S-UV_CIRCLE,  Successful completion')
  call sysexi(1)
  !
  999   call sysexi(fatale)
  !
  contains
!<FF>
function uv_max(visx, n1, nvx)
  real :: uv_max                    ! Output result
  integer, intent(in) :: n1         ! Size of a visibility
  integer, intent(in) :: nvx        ! Number of visibilities
  real, intent(in) :: visx(n1,nvx)  ! Visibilities
  ! Local
  integer :: i
  !
  uv_max = 0.0
  do i=1, nvx
    uv_max = max (uv_max,visx(1,i)**2+visx(2,i)**2)
  enddo
  uv_max = sqrt(uv_max)
end function uv_max
!
subroutine uv_steps(visx, n1, nvx, q, nq, eff_dim,   &
     &    array,meter,flag,nsize)
  integer, intent(in) :: n1              ! Size of a visibility
  integer, intent(in) :: nvx             ! Number of a visibilities
  real, intent(in) :: visx(n1,nvx)       ! Visibilities
  integer, intent(in) :: nq              ! Number of radii
  real, intent(in) :: q(nq+1)            ! Radii
  integer, intent(out) :: eff_dim        ! Actual size of radial array
  integer, intent(in) :: nsize           ! Size of radial array
  integer, intent(out) :: array(nsize)   ! Cell value
  real, intent(inout) :: meter(nsize)    ! Cell position
  integer, intent(out) :: flag(nsize)    ! Is there any data ?

  ! Local
  integer :: iq, iv, i
  real :: qq
  !
  flag = 0
  !
  do iv=1, nvx
    qq = sqrt(visx(1,iv)**2+visx(2,iv)**2)
    iq = int( (qq-q(1))/(q(2)-q(1))+1. )
    if (iq.gt.0 .and. iq.le.nq+1) then
      flag(iq) = 1
    endif
  enddo
  !
  eff_dim = 0
  do i=1,nsize
    if (flag(i).ne.0) then
      eff_dim = eff_dim+1
      meter(eff_dim) = (3*q(1)-q(2))/2+(q(2)-q(1))*i
    endif
    array(i) = eff_dim
  enddo
end subroutine uv_steps
!
subroutine circle(n1, nvx, nc, visx, nq, visy, q, eff_dim,   &
     &    array, meter, nsize)
  integer, intent(in) :: n1              ! Size of a visibility
  integer, intent(in) :: nvx             ! Number of a visibilities
  integer, intent(in) :: nc              ! Number of channels 
  real, intent(in) :: visx(n1,nvx)       ! Visibilities
  integer, intent(in) :: nq              ! Number of radii
  real, intent(in) :: q(nq+1)            ! Radii
  integer, intent(in) :: eff_dim         ! Actual size of radial array
  real, intent(out) :: visy(n1, eff_dim) ! Output visibilities        !
  integer, intent(in) :: nsize           ! Size of radial array
  integer, intent(in) :: array(nsize)    ! Cell value
  real, intent(inout) :: meter(nsize)       ! Cell position
  ! Local
  integer :: iq, iv, ic, i, ip, ier
  real :: w, qq
  real, allocatable :: true(:)
  !
  visy = 0.0
  allocate (true(nsize),stat=ier)
  if (ier.ne.0) stop
  !
  true = 0
  ic = (nc+1)/2
  !
  do iv=1, nvx
    qq = sqrt(visx(1,iv)**2+visx(2,iv)**2)
    iq = int( (qq-q(1))/(q(2)-q(1))+1. )
    if (iq.gt.0 .and. iq.le.nq+1) then
      ip = array(iq)
      w = visx(3*ic+7,iv)
      ! Compute true uv distance for the bin (weighted average, using the weight of the central channel)
      if (w.gt.0) then
        true(ip) = true(ip)+w*qq
      endif
      do i=1, nc
        w = visx(3*i+7,iv)
        if (w.gt.0) then
          visy(3*i+5,ip)=visy(3*i+5,ip)+visx(3*i+5,iv)*w
          visy(3*i+6,ip)=visy(3*i+6,ip)+visx(3*i+6,iv)*w
          visy(3*i+7,ip)=visy(3*i+7,ip)+w
        endif 
      enddo
    endif
  enddo
  !
  do iq=1, eff_dim
    w = visy(3*ic+7,iq) ! sum of non flagged weights
    if (w.ne.0) then
      ! at least one non flagged visibility, use true averaged uv distance
      visy(1,iq) = true(iq)/w
    else
      ! no valid visibility in the bin, use nominal uv distance
      visy(1,iq) = meter(iq)
    endif
    do i=1, nc
      w = visy(3*i+7,iq)
      if (w.gt.0) then
        visy(3*i+5,iq)=visy(3*i+5,iq)/w
        visy(3*i+6,iq)=visy(3*i+6,iq)/w
      endif
    enddo
  enddo
  deallocate (true)
end subroutine circle
!
end program uv_circle

module cubefit_function_spectral_absorption
  use fit_minuit
  !
  use cubefit_messaging
  use cubefit_spectral_parameters
  use cubefit_spectral_obs
  !
  real(kind=para_k), parameter ::  absorption_tau_min = 0.1
  real(kind=para_k), parameter ::  absorption_tau_max = 100.0
  !
  integer(kind=npar_k),parameter :: npara = 3
  integer(kind=npar_k),parameter :: icont   = 1
  integer(kind=npar_k),parameter :: itau    = 2
  integer(kind=npar_k),parameter :: ivelo   = 3
  integer(kind=npar_k),parameter :: ifwhm   = 4
  !
  public cubefit_function_spectral_absorption_init, cubefit_function_spectral_absorption_minimize
  public cubefit_function_spectral_absorption_extract, cubefit_function_spectral_absorption_residuals
  public cubefit_function_spectral_absorption_npar, cubefit_function_spectral_absorption_user2par
  public cubefit_function_spectral_absorption_par2spec, cubefit_function_spectral_absorption_spec2par
  public cubefit_function_spectral_absorption_iterate,cubefit_function_spectral_absorption_wind2par
  public cubefit_function_spectral_absorption_flags, cubefit_function_spectral_absorption_doprofile
  public cubefit_function_spectral_absorption_units
  private
  !
contains
    !
  subroutine cubefit_function_spectral_absorption_init(par,obs,minuit,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(spectral_pars_t), intent(inout) :: par
    type(spectral_obs_t),  intent(in)    :: obs
    type(fit_minuit_t),    intent(inout) :: minuit
    logical,               intent(inout) :: error
    !
    real(kind=coor_k) :: vsup,vinf
    real(kind=sign_k) :: val,area,ymin,ymax,cont
    character(len=mess_l) :: mess
    integer(kind=4) :: ipara,ifunc
    integer(kind=chan_k) :: ichan
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>INIT'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')    
    !
    if (.not.obs%hfs%loaded) then
       call cubefit_message(seve%e,rname,'No HFS structure loaded')
       error = .true.
       return
    endif
    !
    ! Starting values
    if (par%nfunc.eq.0) then
       par%leaders(:) = 0
       par%flag(:,:) = 0
       par%errs(:) = 0
       ymax=0.
       ymin=0.
       area=0.
       vinf=minval(obs%spec%v)
       vsup=maxval(obs%spec%v)
       cont = 0.5*(obs%spec%t(obs%ifirst)+obs%spec%t(obs%ilast))
       do ichan=obs%ifirst+1,obs%ilast-1
          if (obs%wfit(ichan).ne.0) then
             val = ( obs%spec%t(ichan) + &
                  obs%wfit(ichan-1)*obs%spec%t(ichan-1) +   &
                  obs%wfit(ichan+1)*obs%spec%t(ichan+1) )   &
                  / (1+obs%wfit(ichan-1)+obs%wfit(ichan+1))
             val = val - cont
             if (val.ge.ymax) then
                ymax = val
                vsup = obs%spec%v(ichan)
             endif
             if (val.le.ymin) then
                ymin = val
                vinf = obs%spec%v(ichan)
             endif
             area=area+val*abs((obs%spec%v(ichan+1)-obs%spec%v(ichan-1)))
          endif
       enddo
       area = area*0.5
       if (abs(ymin).lt.abs(ymax)) then
          par%pars(ivelo)=vsup
          par%pars(itau)=ymax
       else
          par%pars(ivelo)=vinf
          par%pars(itau)=ymin
       endif
       par%pars(ifwhm) = abs(area/par%pars(itau)/1.064467)/2.    ! Take care of satellites
       par%pars(icont) = cont
       if (par%pars(ifwhm).lt.2*obs%deltav) par%pars(ifwhm) = 2*obs%deltav
       minuit%nu=cubefit_function_spectral_absorption_npar(1)
    else
       minuit%nu=cubefit_function_spectral_absorption_npar(par%nfunc)
    endif
    !
    ipara=0
    write(mess,'(a)') 'Input Parameters           Tau      Position         Width'
    call cubefit_message(fitseve%others,rname,mess)
    do ifunc=1,max(par%nfunc,1)
       write (mess,1002) par%pars(ipara+itau),par%pars(ipara+ivelo),par%pars(ipara+ifwhm)
       call cubefit_message(fitseve%others,rname,mess)
       ipara=ipara+npara
    enddo
    !
    ! Set Up Parameters
    minuit%u(icont) = par%pars(icont)
    minuit%alim(icont) = absorption_tau_min*par%pars(icont)
    minuit%blim(icont) = absorption_tau_max*par%pars(icont)
    minuit%werr(icont) = obs%sigbase
    ipara=2
    do ifunc=1,max(par%nfunc,1)
       !
       ! Optical depth
       minuit%u(ipara)=par%pars(ipara)
       minuit%werr(ipara)=obs%sigbase
       if ( mod(par%flag(ifunc,itau),2).ne.0 .and. par%nfunc.ne.0) minuit%werr(ipara)=0.
       if (minuit%u(ipara).ne.0.) then
          minuit%alim(ipara)=min(0.d0,8.d0*minuit%u(ipara))
          minuit%blim(ipara)=max(0.d0,8.d0*minuit%u(ipara))
       else
          minuit%lcode(ipara)=1
       endif
       ipara=ipara+1
       !
       ! Velocity
       minuit%u(ipara)=par%pars(ipara)
       minuit%werr(ipara)=obs%deltav
       if ( mod(par%flag(ifunc,ivelo),2).ne.0 .and. par%nfunc.ne.0) minuit%werr(ipara)=0.
       minuit%alim(ipara)=minuit%u(ipara)-0.15*obs%spec%n*obs%deltav
       minuit%blim(ipara)=minuit%u(ipara)+0.15*obs%spec%n*obs%deltav
       ipara=ipara+1
       !
       ! Line Width
       minuit%u(ipara)=abs(par%pars(ipara))/1.665109
       minuit%werr(ipara)=2*obs%deltav
       if ( mod(par%flag(ifunc,ifwhm),2).ne.0 .and. par%nfunc.ne.0 ) minuit%werr(ipara)=0.
       minuit%alim(ipara)=0.2*obs%deltav
       minuit%blim(ipara)=0.5*obs%spec%n*obs%deltav
       ipara=ipara+1
    enddo
    !
1002 format((3(f14.3)))
  end subroutine cubefit_function_spectral_absorption_init
  !
  subroutine cubefit_function_spectral_absorption_minimize(npar,grad,chi2,pars,iflag,obs)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=npar_k),   intent(in)    :: npar        ! Number of parameters
    real(kind=grad_k),      intent(out)   :: grad(npar)  ! Gradientes
    real(kind=chi2_k),      intent(out)   :: chi2        ! chi squared
    real(kind=para_k),      intent(in)    :: pars(npar)  ! Parameter values
    integer(kind=4),        intent(in)    :: iflag       ! Code operation
    type(spectral_obs_t),   intent(inout) :: obs         ! Observation
    !
    integer(kind=chan_k) :: ichan
    real(kind=coor_k) :: xvel
    real(kind=sign_k) :: pred
    real(kind=grad_k), allocatable :: parsgrad(:)
    real(kind=8) :: arg,aux
    real(kind=chi2_k) :: chi2loc
    real(kind=para_k) :: tau,velo,fwhm,acoeff,bcoeff,ccoeff
    integer(kind=func_k) :: ifunc,ihfs
    integer(kind=npar_k) :: ipara,it,iv,id,ntot
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>MINIMIZE'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    if (iflag.eq.code_minuit_rms) then
       call obs%sigma(cubefit_function_spectral_absorption_profile,.false.)
       return
    endif
    !
    grad(:) = 0.
    chi2 = 0.
    ntot = cubefit_function_spectral_absorption_npar(max(obs%par%nfunc,1))
    !
    allocate(parsgrad(ntot))
    do ichan=obs%ifirst,obs%ilast
       !
       ! Skip over masked area or bad channels
       if (obs%wfit(ichan).gt.0) then
          xvel = obs%spec%v(ichan)
          pred = 0
          do ifunc = 1, max(obs%par%nfunc,1)
             acoeff = 0
             bcoeff = 0
             ccoeff = 0
             it = (ifunc-1)*3+2
             iv = it+1
             id = iv+1
             tau  = pars(it)
             velo = pars(iv)
             fwhm = pars(id)
             do ihfs=1, obs%hfs%n
                arg = (xvel-obs%hfs%vel(ihfs)-velo)/fwhm
                if (abs(arg).lt.4.) then
                   aux = obs%hfs%rel(ihfs)*exp(-arg**2)
                   acoeff = acoeff + aux
                   aux = aux*2.*arg/fwhm
                   bcoeff = bcoeff + aux
                   ccoeff = ccoeff + aux*arg
                endif
             enddo
             pred = pred+acoeff*tau
             parsgrad(it) = acoeff
             parsgrad(iv) = bcoeff*tau
             parsgrad(id) = ccoeff*tau
          enddo
          pred = exp(-pred)
          chi2loc = obs%spec%t(ichan) - pred*pars(icont)
          chi2 = chi2 + chi2loc**2
          pred = 2*pred*chi2loc
          grad(icont) = grad(icont) - pred
          do ipara =2, ntot
             grad(ipara) = grad(ipara)+pred*parsgrad(ipara)
          enddo
       endif
    enddo
  end subroutine cubefit_function_spectral_absorption_minimize
  !
  subroutine cubefit_function_spectral_absorption_extract(minuit,obs,par,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(fit_minuit_t),    intent(inout) :: minuit
    type(spectral_obs_t),  intent(inout) :: obs
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
    !
    integer(kind=func_k) :: ifunc
    integer(kind=npar_k) :: ipara
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>EXTRACT'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    ! Update Parameters
    par%pars(icont) = minuit%u(icont)
    par%errs(icont) = minuit%werr(icont)
    ipara=0
    do ifunc=1,max(par%nfunc,1)
       par%pars(ipara+itau)  = minuit%u(ipara+itau)
       par%pars(ipara+ivelo) = minuit%u(ipara+ivelo)
       par%pars(ipara+ifwhm) = minuit%u(ipara+ifwhm)*1.665109
       par%errs(ipara+itau)  = minuit%werr(ipara+itau)
       par%errs(ipara+ivelo) = minuit%werr(ipara+ivelo)
       par%errs(ipara+ifwhm) = minuit%werr(ipara+ifwhm)*1.665109
       ipara=ipara+npara
    enddo
  end subroutine cubefit_function_spectral_absorption_extract
  !
  subroutine cubefit_function_spectral_absorption_residuals(obs,spec,error)
    use cubemain_spectrum_real
    !------------------------------------------------------------------------
    ! Compute the residuals of a absorption fit
    !------------------------------------------------------------------------
    type(spectral_obs_t), intent(inout) :: obs          
    type(spectrum_t),     intent(inout) :: spec         
    logical,              intent(inout) :: error
    !
    integer(kind=chan_k) :: ichan
    real(kind=coor_k) :: xvel
    real(kind=sign_k) :: pred
    character(len=*), parameter :: rname="SPECTRAL>ABSORPTION>RESIDUALS"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    do ichan=1, spec%n
       xvel = obs%spec%v(ichan)
       pred = cubefit_function_spectral_absorption_profile(obs,xvel,0)
       spec%t(ichan) = obs%spec%t(ichan) - pred
    enddo
  end subroutine cubefit_function_spectral_absorption_residuals
  !
  subroutine cubefit_function_spectral_absorption_doprofile(ifunc,obs,spec,error)
    use cubemain_spectrum_real
    !------------------------------------------------------------------------
    ! Compute the doprofile of a absorption fit
    !------------------------------------------------------------------------
    integer(kind=func_k), intent(in)    :: ifunc
    type(spectral_obs_t), intent(inout) :: obs          
    type(spectrum_t),     intent(inout) :: spec         
    logical,              intent(inout) :: error
    !
    integer(kind=chan_k) :: ichan
    real(kind=coor_k) :: xvel
    real(kind=sign_k) :: pred
    character(len=*), parameter :: rname="SPECTRAL>ABSORPTION>DOPROFILE"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    do ichan=1, spec%n
       xvel = obs%spec%v(ichan)
       pred = cubefit_function_spectral_absorption_profile(obs,xvel,ifunc)
       spec%t(ichan) = pred
    enddo
  end subroutine cubefit_function_spectral_absorption_doprofile
  !
  subroutine cubefit_function_spectral_absorption_user2par(flag,pars,par,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=flag_k),  intent(in)    :: flag(:)
    real(kind=para_k),     intent(in)    :: pars(:)
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
    !
    integer(kind=npar_k) :: ipara,jpara
    integer(kind=func_k) :: ifunc
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>USER2PAR'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    par%leaders(:) = 0
    par%flag(:,:)  = 0
    par%errs(:)    = 0.
    !
    par%flag(1,icont) = flag(icont)
    par%pars(icont)   = pars(icont)
    jpara = 2
    do ifunc=1,par%nfunc
       do ipara=2,npara+1
          par%flag(ifunc,ipara) = flag(jpara)
          par%pars(jpara)       = pars(jpara)
          jpara=jpara+1
       enddo ! ipara
    enddo ! ifunc
    !
    call par%check_line(itau,error)
    if (error) return
    call par%check_line(ivelo,error)
    if (error) return
    call par%check_line(ifwhm,error)
    if (error) return
  end subroutine cubefit_function_spectral_absorption_user2par
  !
  subroutine cubefit_function_spectral_absorption_par2spec(par,spec,error)
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spectral_pars_t), intent(in)    :: par
    type(spectrum_t),      intent(inout) :: spec
    logical,               intent(inout) :: error
    !
    integer(kind=func_k) :: ifunc
    integer(kind=chan_k) :: ichan
    integer(kind=npar_k) :: ipara
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>PAR2SPEC'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    ichan = ndaps+1
    spec%t(ichan) = par%flag(1,icont)
    ichan = ichan+1
    spec%t(ichan) = par%pars(icont)
    ichan = ichan+1
    spec%t(ichan) = par%errs(icont)
    ipara = 0
    do ifunc=1,max(par%nfunc,1)
       ichan = ichan+1
       spec%t(ichan) = par%flag(ifunc,itau)
       ichan = ichan+1
       spec%t(ichan) = par%pars(ipara+itau)
       ichan = ichan+1
       spec%t(ichan) = par%errs(ipara+itau)
       ichan = ichan+1
       spec%t(ichan) = par%flag(ifunc,ivelo)
       ichan = ichan+1
       spec%t(ichan) = par%pars(ipara+ivelo)
       ichan = ichan+1
       spec%t(ichan) = par%errs(ipara+ivelo)
       ichan = ichan+1
       spec%t(ichan) = par%flag(ifunc,ifwhm)
       ichan = ichan+1
       spec%t(ichan) = par%pars(ipara+ifwhm)
       ichan = ichan+1
       spec%t(ichan) = par%errs(ipara+ifwhm)
       ipara = ipara + npara
    enddo
  end subroutine cubefit_function_spectral_absorption_par2spec
  !
  subroutine cubefit_function_spectral_absorption_spec2par(spec,par,error)
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spectrum_t),      intent(in)    :: spec
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
    !
    integer(kind=npar_k) :: ipara
    integer(kind=func_k) :: ifunc
    integer(kind=chan_k) :: ichan
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>SPEC2PAR'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    ichan = ndaps+1
    par%flag(1,icont) = spec%t(ichan)  
    ichan = ichan+1
    par%pars(icont)   = spec%t(ichan)  
    ichan = ichan+1
    par%errs(icont)   = spec%t(ichan) 
    ipara = 0
    do ifunc=1,max(par%nfunc,1)
       ichan = ichan+1
       par%flag(ifunc,itau)  = spec%t(ichan)
       ichan = ichan+1
       par%pars(ipara+itau)   = spec%t(ichan)
       ichan = ichan+1
       par%errs(ipara+itau)   = spec%t(ichan)
       ichan = ichan+1
       par%flag(ifunc,ivelo) = spec%t(ichan)
       ichan = ichan+1
       par%pars(ipara+ivelo)  = spec%t(ichan)
       ichan = ichan+1
       par%errs(ipara+ivelo)  = spec%t(ichan)
       ichan = ichan+1
       par%flag(ifunc,ifwhm) = spec%t(ichan)
       ichan = ichan+1
       par%pars(ipara+ifwhm)  = spec%t(ichan)
       ichan = ichan+1
       par%errs(ipara+ifwhm)  = spec%t(ichan)
       ipara = ipara + npara
    enddo
  end subroutine cubefit_function_spectral_absorption_spec2par
  !
  subroutine cubefit_function_spectral_absorption_iterate(par,error)
    !----------------------------------------------------------------------
    ! This routine is empty as no transformation is needed when we are
    ! iterating an ABSORPTION fit
    !----------------------------------------------------------------------
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>ITERATE'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
  end subroutine cubefit_function_spectral_absorption_iterate
  !
  subroutine cubefit_function_spectral_absorption_wind2par(obs,wind,par,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spectral_obs_t),  intent(in)    :: obs
    integer(kind=chan_k),  intent(in)    :: wind(:)
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
    !
    integer(kind=chan_k) :: first,last
    integer(kind=func_k) :: ifunc
    integer(kind=npar_k) :: ipara
    real(kind=para_k) :: area,velo,fwhm
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>WIND2PAR'
    !
    par%errs(:) = 0
    par%leaders(:)  = 0
    par%pars(icont) = 1.0
    !
    ipara = 0
    do ifunc=1,par%nfunc
       first = wind(2*ifunc-1)
       last  = wind(2*ifunc)
       par%flag(ifunc,:)   = 0
       !
       call obs%est_gauss(first,last,area,velo,fwhm,error)
       if (error) return
       if (fwhm.lt.obs%deltav) fwhm = obs%deltav
       if (fwhm.gt.obs%deltav*obs%spec%n*0.5) fwhm = obs%deltav*obs%spec%n*0.5
       par%pars(ipara+itau)  = area 
       par%pars(ipara+ivelo) = velo 
       par%pars(ipara+ifwhm) = fwhm
       ipara = ipara + npara
    enddo
  end subroutine cubefit_function_spectral_absorption_wind2par
  !
  !----------------------------------------------------------------------
  !
  function cubefit_function_spectral_absorption_profile(obs,xvel,ifunc) result(absorption)
    !----------------------------------------------------------------------
    ! Compute the value of a hyperfine line or a sum of hyperfine
    ! lines at xvel
    !----------------------------------------------------------------------
    type(spectral_obs_t),   intent(in)    :: obs         ! Observation
    real(kind=coor_k),      intent(in)    :: xvel        ! Coordinate to compute value
    integer(kind=func_k),   intent(in)    :: ifunc       ! Which absorption is to be computed
    !
    real(kind=sign_k) :: absorption
    !
    integer(kind=func_k) :: jfunc
    !
    absorption=0.
    if (ifunc.eq.0) then
       do jfunc=1,max(obs%par%nfunc,1)
          absorption = absorption+absorption_single(jfunc)
       enddo
       absorption = exp(-absorption)
    else
       absorption = exp(-absorption_single(ifunc))
    endif
    ! multiply by continuum level
    absorption = absorption*obs%par%pars(icont)
  contains
    function absorption_single(iwhich)
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      integer(kind=func_k),   intent(in)    :: iwhich   ! Which absorption is to be computed
      real(kind=sign_k) :: absorption_single  
      !
      real(kind=para_k) :: tau, velo, fwhm, arg
      integer(kind=func_k) :: ihfs
      !
      tau =obs%par%pars((iwhich-1)*npara+itau)
      velo=obs%par%pars((iwhich-1)*npara+ivelo)
      fwhm=obs%par%pars((iwhich-1)*npara+ifwhm)/1.665109
      absorption_single = 0.
      if (tau.ne.0 .and. fwhm.ne.0) then
         do ihfs=1,obs%hfs%n
            arg = abs ((xvel-obs%hfs%vel(ihfs)-velo)/fwhm)
            if (arg.lt.4.) then
               absorption_single = absorption_single + obs%hfs%rel(ihfs)*exp(-(arg**2))
            endif
         enddo
      endif
      absorption_single = absorption_single*tau
    end function absorption_single
  end function cubefit_function_spectral_absorption_profile
  !
  subroutine cubefit_function_spectral_absorption_flags(ipara,funcflag,paraflag,error)
    use cubedag_allflags
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=npar_k), intent(in)    :: ipara
    type(flag_t),         intent(out)   :: funcflag
    type(flag_t),         intent(out)   :: paraflag
    logical,              intent(inout) :: error
    !
    integer(kind=func_k) :: ifunc
    integer(kind=npar_k) :: mypar
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>FLAGS'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    if (ipara.eq.1) then
       paraflag = flag_continuum
       funcflag = flag_one
       return
    else
       mypar = ipara-1
       ifunc  = mypar/npara+1
       select case(mod(mypar,npara))
       case(1)
          paraflag = flag_tau
       case(2)
          paraflag = flag_velocity
       case(0)
          paraflag = flag_fwhm
          ifunc  = ifunc-1
       end select
       call cubefit_func2flag(ifunc,funcflag,error)
       if (error) return
    endif
  end subroutine cubefit_function_spectral_absorption_flags
  !
  subroutine cubefit_function_spectral_absorption_units(ipara,unit,error)
    use cubetools_unit_setup
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=npar_k), intent(in)    :: ipara
    character(len=*),     intent(out)   :: unit
    logical,              intent(inout) :: error
    !
    integer(kind=func_k) :: ifunc
    integer(kind=npar_k) :: mypar
    character(len=*), parameter :: rname='SPECTRAL>ABSORPTION>UNITS'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    if (ipara.eq.1) then
       unit = strg_id
    else
       mypar = ipara-1
       ifunc  = mypar/npara+1
       select case(mod(mypar,npara))
       case(1)
          unit = '---' ! no unit for opacity
       case(2)
          unit = unit_velo%prog_name()
       case(0)
          unit = unit_velo%prog_name()
       end select
    endif
  end subroutine cubefit_function_spectral_absorption_units
  !
  function cubefit_function_spectral_absorption_npar(nfunc) result(npar)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=func_k), intent(in) :: nfunc
    !
    integer(kind=npar_k) :: npar
    !
    npar = npara*nfunc+1
  end function cubefit_function_spectral_absorption_npar
end module cubefit_function_spectral_absorption

module back_conversion
  real, save :: cvi(6),cvo(6)
end module back_conversion
!
program background_main
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  use back_conversion
  !---------------------------------------------------------------------
  ! Compute a large scale background
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey
  character(len=4) :: method
  integer :: mode
  logical :: error,slow,fourier
  integer :: n, scale, nw, nt
  integer :: nhisto,nback,ier
  real :: pmin,pmax,pinc,x1,x2
  real(4), allocatable :: x(:), y(:), z(:), w(:), histo(:)
  real(4), allocatable :: iw(:)
  integer :: nx,ny,nz
  integer :: mx,my
  type(gildas) :: xima,yima
  !
  slow=.false.
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('X_MIN$',x1,1)
  call gildas_real('X_MAX$',x2,1)
  call gildas_inte('NBINS$',nhisto,1)
  call gildas_inte('WIDTH$',nw,1)
  call gildas_inte('SCALE$',scale,1)
  call gildas_inte('N_MIN$',nt,1)
  call gildas_char('METHOD$',method)
  call gildas_close
  !
  n = len_trim(namey)
  call gildas_null(yima)
  call gdf_read_gildas(yima,namey,'.gdf',error, rank=3) 
  if (error) then
    write(6,*) 'F-BACKGROUND,  Cannot read input file'
    goto 100
  endif
  !
  call gildas_null(xima)
  call gdf_copy_header(yima,xima,error)
  !
  nx=xima%gil%dim(1)
  ny=xima%gil%dim(2)
  pmin = min(x1,x2)
  pmax = max(x1,x2)
  pinc = (pmax-pmin)/nhisto
  !
  ! Consistency checks.
  nt = max(nt,3*nhisto)
  nt = min(nt,3*nw**2/4)       ! PI*D^2/4
  mode=1
  slow=.false.
  fourier=.false.
  if (method.eq.'ZERO') then
    mode=0
  elseif (method.eq.'FAST') then
    mode=1
  elseif (method.eq.'LINE') then
    mode=1
  elseif (method.eq.'PARA') then
    mode=2
  elseif (method.eq.'GAUS') then
    mode=3
  elseif (method.eq.'FOUR') then
    fourier = .true.
    mode=-1
  elseif (method.eq.'SLOW') then
    slow=.true.
    mode=0
  endif
  !
  ! Get some work space
  allocate (histo(nhisto), stat=ier)
  if (ier.ne.0) goto 99
  mx=int(float(nx-nw)/float(scale))+1
  my=int(float(ny-nw)/float(scale))+1
  cvi(:) = 1.0
  cvo(1)=1.0
  cvo(2)=float(nw+1)*0.5
  cvo(3)=float(scale)
  cvo(4)=1.0
  cvo(5)=float(nw+1)*0.5
  cvo(6)=float(scale)
  nback = mx*my
  if (slow) then
    write(6,*) 'Using slow method...'
	allocate (x(nback), y(nback), z(nback), iw(35*nback), w(13*nback), stat=ier)
  elseif (fourier) then
    xima%gil%dim(1)=mx
    xima%gil%dim(2)=my
    xima%loca%size = xima%gil%dim(1)*xima%gil%dim(2)*xima%gil%dim(3)*xima%gil%dim(4)
  else
	allocate (x(3*nback), stat=ier)
  endif
  n = len_trim(namex)
  call sic_parsef(namex(1:n),xima%file,' ','.gdf')
  call gdf_create_image(xima,error)  
  if (error) then
    write(6,*) 'F-BACKGROUND,  Cannot create output image'
    goto 100
  endif
  !
  ! Allocate the data 
  allocate(xima%r3d(xima%gil%dim(1), xima%gil%dim(2), xima%gil%dim(3) ) , stat=ier) 
  if (ier.ne.0) goto 100
  !
  ! Do the real work
  nz = xima%gil%dim(3)
  if (slow) then
    call zodi011 (yima%r3d,   & !Input image
     &      nx,ny,nz,         & !Size
     &      nt,   &            !Minimum number of data points
     &      scale,   &         !Scale
     &      nw,   &            !Width
     &      xima%gil%bval,    &        !Blanking value
     &      xima%gil%eval,    &
     &      pmin,pmax,pinc,   &
     &      histo,   &
     &      x, y, z, w, iw,   &
  	 &      xima%r3d )
  else
    ! Define the background map
    if (xima%gil%blan_words.eq.0) then
      xima%gil%bval = pmin-1.0
      xima%gil%eval = 0.9
      xima%gil%blan_words = 2
    endif
!!    if (fourier) x = ipx
    call zodi001 (yima%r3d,   & !Input image
     &      nx,ny,nz,         & !Size
     &      nt,   &            !Minimum number of data points
     &      scale,   &         !Scale
     &      nw,   &            !Width
     &      xima%gil%bval,   &        !Blanking value
     &      xima%gil%eval,   &
     &      pmin,pmax,pinc,   &
     &      histo,   &
     &      x,   &
     &      xima%r3d,   &
     &      mode)
  endif
  ! Update disk files and free memory
  call gdf_write_data(xima, xima%r3d, error)
  if (error) goto 100
  !
  stop 'S-BACKGROUND,  Successful completion'
  !
99 write(6,*) 'F-BACKGROUND,  Memory allocation failure'
100 call sysexi (fatale)
end program background_main
!
subroutine zodi001(a,nx,ny,nz,nt,scale,nw,bval,eval,   &
     &    pmin,pmax,pinc,histo,inter,b,mode)
  !---------------------------------------------------------------------
  ! Compute a large scale background, FAST VERSION
  !
  ! Arguments:
  !	A	R*4	Input data cube				Input
  !	NX	I	First dimension of A			Input
  !	NY	I	Second dimension of A			Input
  !	NZ	I	Third dimension of A			Input
  !	NT	I	Minimum valid number of points 		Input
  !	SCALE	I	Scale factor for intermediate grid	Input
  !	NW	I	Diameter of smoothing circle		Input
  !	BVAL	R*4	Blanking value				Input
  !	EVAL	R*4	Tolerance on blanking value		Input
  !	PMIN	R*4	Minimum accepted value			Input
  !	PMAX	R*4	Maximum accepted value			Input
  !	PINC	R*4	Histogram step				Input
  !	HISTO	R*4	Histogram array				Scratch
  !	INTER	R*4	Intermediate image			Scratch
  !	B	R*4	Output background image			Output
  !       MODE    I       0=nointerpol, 1 or 2 interpol same orderInput
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  integer :: nz                     !
  real(4) :: a(nx,ny,nz)             !
  integer :: nt                     !
  integer :: scale                  !
  integer :: nw                     !
  real(4) :: bval                    !
  real(4) :: eval                    !
  real(4) :: pmin                    !
  real(4) :: pmax                    !
  real(4) :: pinc                    !
  real(4) :: histo(*)                !
  real(4) :: inter(*)                !
  real(4) :: b(nx,ny,nz)             !
  integer :: mode                   !
  ! Local
  integer :: mx,my
  !
  integer nh,i
  !
  mx=int(float(nx-nw)/float(scale))+1
  my=int(float(ny-nw)/float(scale))+1
  ! Define the Histogram
  nh = nint((pmax-pmin)/pinc)
  !
  ! Compute the background image
  do i=1,nz                    ! Loop on planes
    call zodi002(a(1,1,i),nx,ny,scale,nw,pmin,   &
     &      pmax,pinc,histo,nh,nt,inter,mx,my,bval)
    !
    ! Resample the image to the full Grid
    if (mode.ne.-1) call zodi003(inter,mx,my,   &
     &      b(1,1,i),nx,ny,bval,eval,   &
     &      scale,nw,mode)
    !
    ! Subtract the background from the image
    !         CALL ZODI004 (A,B,NX,NY,BVAL,EVAL)
  enddo
end subroutine zodi001
!
subroutine zodi002(a,nx,ny,ns,nw,pmin,pmax,pinc,h,nh,nt,   &
     &    inter,mx,my,bval)
  use back_conversion
  !---------------------------------------------------------------------
  ! Estimate large scale background on reduced grid, FAST VERSION
  ! Arguments:
  !	A	R*4	Input data cube				Input
  !	NX	I	First dimension of A			Input
  !	NY	I	Second dimension of A			Input
  !	NS	I	Scale factor for intermediate grid	Input
  !	NW	I	Diameter of smoothing circle		Input
  !	PMIN	R*4	Minimum accepted value			Input
  !	PMAX	R*4	Maximum accepted value			Input
  !	PINC	R*4	Histogram step				Input
  !	H	R*4	Histogram array				Scratch
  !	NH	I	Size of histogram			Input
  !	NT	I	Minimum valid number of points 		Input
  !     INTER	R*4	Intermediate image		        Output
  !	MX	I	First dimension of INTER		Input
  !	MY	I	Second dimension of INTER		Input
  !	BVAL	R*4	Blanking value				Input
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real(4) :: a(nx,ny)                !
  integer :: ns                     !
  integer :: nw                     !
  real(4) :: pmin                    !
  real(4) :: pmax                    !
  real(4) :: pinc                    !
  integer :: nh                     !
  real(4) :: h(nh)                   !
  integer :: nt                     !
  integer :: mx                     !
  integer :: my                     !
  real(4) :: inter(mx,my,3)          !
  real(4) :: bval                    !
  ! Local
  integer :: m
  real(4) :: ja,ia
  !
  real r,grav(2)
  integer i,j,nf,k,ier
  !
  write(6,*) 'Size of intermediate background grid: ',mx,my
  k = 0
  do j = 1,my
    ja = (j-cvo(4))*cvo(6)+cvo(5)
    do i = 1,mx
      ia = (i-cvo(1))*cvo(3)+cvo(2)
      call zodi102(a,nx,ny,ia,ja,pmin,pmax,pinc,   &
     &        h,nh,nw,nf)
      if (nf.ge.nt) then
        call zodi122(h,nh,r,pmin,pinc)
        call zodi123(a,nx,ny,ia,ja,nw,pinc,r,grav,ier)
        if (ier.eq.0) then
          k    = k+1
          inter(i,j,1) = r
          inter(i,j,2) = grav(1)
          inter(i,j,3) = grav(2)
        endif
      endif
    enddo
  enddo
  m = k
  write(6,*) m,' valid background values found'
end subroutine zodi002
!
subroutine zodi003(a,mx,my,b,nx,ny,bval,eval,ns,nw,mode)
  use back_conversion
  !---------------------------------------------------------------------
  !	Regrid the intermediate background map on the same scale as
  !       the original map, zero,1 or 2-order linear interpolation
  ! Arguments
  !       A	R*4(*)	Input map                               Input
  !	MX	I	First dimension of A			Input
  !	MY	I	Second dimension of A			Input
  !	B	R*4(*)	Output map                              Output
  !	NX	I	First dimension of B			Input
  !	NY	I	Second dimension of B			Input
  !	BVAL	R*4	Blanking value                          Input
  !	EVAL	R*4	Tolerance on blanking value		Input
  !	NS	I	Scale factor for intermediate grid	Input
  !	NW	I	Diameter of smoothing circle		Input
  !       MODE    I       0=nointerpol, 1 or 2 interpol same orderInput
  !---------------------------------------------------------------------
  integer :: mx                     !
  integer :: my                     !
  real(4) :: a(mx,my,3)              !
  integer :: nx                     !
  integer :: ny                     !
  real(4) :: b(nx,ny)                !
  real(4) :: bval                    !
  real(4) :: eval                    !
  integer :: ns                     !
  integer :: nw                     !
  integer :: mode                   !
  ! Local
  integer :: ib,jb,i,j,imin,imax,jmin,jmax
  real :: xa,ya,xr,yr,aplus,azero,amoin
  integer :: ia,ja
  !
  real x,y,z,x0,y0,dx,dy,tmp,delta,dist
  real*8 value,weight
  integer ibb,jbb,isup
  integer count
  integer nexp,mexp
  parameter (mexp=100)
  real myexp(mexp)
  !
  ! Interpolate,Take Blanking into account, version #1
  ! Loop over Output data points
  ! blank output map
  do jb=1,ny
    do ib=1,nx
      b(ib,jb) = bval
    enddo
  enddo
  !
  ! Gauss mode
  if (mode.eq.3) then
    ! Pre-compute the gaussian weights just once
    delta=float(nw)*float(nw)/(4*alog(2.0))
    write(6,*) 'Gaussian weights: '
    do i=1,100
      x=(i-1)*0.03*float(nw)
      x=x*x
      myexp(i)=exp(-1.0*x/delta)
      write (6,*) (i-1)*0.03,myexp(i)
    enddo
    isup=int(float(nw)/cvo(3))
    !
    count=0
    do jb=1,ny
      count = count+nx
      if (count.ge.32*1024) then   ! Say something, every 32 kpixels
        write(6,*) 'Interpolating background for row ',jb
        count = 0
      endif
      y0=float(jb)
      tmp  = (jb-cvo(5))/cvo(6)+cvo(4)
      j  = nint(tmp)
      jmin = max(1,j-isup)     !support de la fonction Gauss dans A
      jmax = min(my,j+isup)
      do ib=1,nx
        x0=float(ib)
        tmp  = (ib-cvo(2))/cvo(3)+cvo(1)
        i  = nint(tmp)
        imin = max(1,i-isup)
        imax = min(mx,i+isup)
        value=0.0
        weight=0.0
        do jbb=jmin,jmax
          do ibb=imin,imax
            z=a(ibb,jbb,1)
            if (z.ne.bval) then
              x=a(ibb,jbb,2)
              y=a(ibb,jbb,3)
              dx=(x-x0)/float(nw)
              dy=(y-y0)/float(nw)
              dist=dx*dx+dy*dy
              nexp= nint(100.0*dist)+1
              if (nexp.le.mexp) then
                tmp=myexp(nexp)
                value=value+z*tmp
                weight=weight+tmp
              endif
            endif
          enddo
        enddo
        if (weight.gt.0.0) then
          b(ib,jb)=value/weight
        else
          b(ib,jb)=bval
        endif
      enddo
    enddo
  elseif (mode.eq.0) then
    tmp  = (1-cvo(1))*cvo(3)+cvo(2)
    imin = nint(tmp)
    tmp  = (mx-cvo(1))*cvo(3)+cvo(2)
    imax = nint(tmp)
    tmp  = (1-cvo(4))*cvo(6)+cvo(5)
    jmin = nint(tmp)
    tmp  = (my-cvo(4))*cvo(6)+cvo(5)
    jmax = nint(tmp)
    do jb = jmin,jmax
      do ib = imin,imax
        tmp  = (ib-cvo(2))/cvo(3)+cvo(1)
        i  = nint(tmp)
        tmp  = (jb-cvo(5))/cvo(6)+cvo(4)
        j  = nint(tmp)
        b(ib,jb) = a(i,j,1)
      enddo
    enddo
  elseif (mode.eq.1) then
    tmp  = (1-cvo(1))*cvo(3)+cvo(2)
    imin = nint(tmp)
    tmp  = (mx-1-cvo(1))*cvo(3)+cvo(2)
    imax = nint(tmp)
    tmp  = (1-cvo(4))*cvo(6)+cvo(5)
    jmin = nint(tmp)
    tmp  = (my-1-cvo(4))*cvo(6)+cvo(5)
    jmax = nint(tmp)
    do jb = jmin,jmax
      do ib = imin,imax
        tmp  = (ib-cvo(2))/cvo(3)+cvo(1)
        i  = nint(tmp)
        tmp  = (jb-cvo(5))/cvo(6)+cvo(4)
        j  = nint(tmp)
        xa = (i-cvo(1))*cvo(3)+cvo(2)
        ya = (j-cvo(4))*cvo(6)+cvo(5)
        ia = nint(xa)
        ja = nint(ya)
        xr = (float(ib)-float(ia))/cvo(3)+0.5
        yr = (float(jb)-float(ja))/cvo(6)+0.5
        if (a(i,j,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i+1,j,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i,j+1,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i+1,j+1,1).eq.bval) then
          b(ib,jb) = bval
        else
          b(ib,jb) = (1-xr)*(1-yr)*a(i,j,1)+   &
     &            xr*(1-yr)*a(i+1,j,1)+   &
     &            xr*yr*a(i+1,j+1,1)+   &
     &            (1-xr)*yr*a(i,j+1,1)
        endif
      enddo
    enddo
  elseif (mode.eq.2) then
    tmp  = (2-cvo(1))*cvo(3)+cvo(2)
    imin = nint(tmp)
    tmp  = (mx-1-cvo(1))*cvo(3)+cvo(2)
    imax = nint(tmp)
    tmp  = (2-cvo(4))*cvo(6)+cvo(5)
    jmin = nint(tmp)
    tmp  = (my-1-cvo(4))*cvo(6)+cvo(5)
    jmax = nint(tmp)
    do jb = jmin,jmax
      do ib = imin,imax
        tmp  = (ib-cvo(2))/cvo(3)+cvo(1)
        i  = nint(tmp)
        tmp  = (jb-cvo(5))/cvo(6)+cvo(4)
        j  = nint(tmp)
        xa = (i-cvo(1))*cvo(3)+cvo(2)
        ya = (j-cvo(4))*cvo(6)+cvo(5)
        ia = nint(xa)
        ja = nint(ya)
        xr = (float(ib)-float(ia))/cvo(3)+0.5
        yr = (float(jb)-float(ja))/cvo(6)+0.5
        if (a(i-1,j-1,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i,j-1,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i+1,j-1,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i-1,j,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i,j,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i+1,j,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i-1,j+1,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i,j+1,1).eq.bval) then
          b(ib,jb) = bval
        elseif (a(i+1,j+1,1).eq.bval) then
          b(ib,jb) = bval
        else
          !
          ! Interpolate (XR or YR first, does not matter in this case)
          aplus = xr*(xr-1)*a(i-1,j+1,1)*0.5+   &
     &            xr*(xr+1)*a(i+1,j+1,1)*0.5-   &
     &            (xr+1)*(xr-1)*a(i,j+1,1)
          azero = xr*(xr-1)*a(i-1,j,1)*0.5+   &
     &            xr*(xr+1)*a(i+1,j,1)*0.5-   &
     &            (xr+1)*(xr-1)*a(i,j,1)
          amoin = xr*(xr-1)*a(i-1,j-1,1)*0.5+   &
     &            xr*(xr+1)*a(i+1,j-1,1)*0.5-   &
     &            (xr+1)*(xr-1)*a(i,j-1,1)
          !     Then YR (or XR)
          b(ib,jb) = yr*(yr-1)*amoin*0.5+   &
     &            yr*(yr+1)*aplus*0.5-   &
     &            (yr+1)*(yr-1)*azero
        endif
      enddo
    enddo
  endif
end subroutine zodi003
!
subroutine zodi011(a,nx,ny,nz,nt,scale,nw,bval,eval,   &
     &    pmin,pmax,pinc,histo,x,y,z,w,iw,b)
  !---------------------------------------------------------------------
  ! Compute a large scale background, SLOW METHOD
  !
  ! Arguments:
  !	A	R*4	Input data cube				Input
  !	NX	I	First dimension of A			Input
  !	NY	I	Second dimension of A			Input
  !	NZ	I	Third dimension of A			Input
  !	NT	I	Minimum valid number of points 		Input
  !	SCALE	I	Scale factor for intermediate grid	Input
  !	NW	I	Diameter of smoothing circle		Input
  !	BVAL	R*4	Blanking value				Input
  !	EVAL	R*4	Tolerance on blanking value		Input
  !	PMIN	R*4	Minimum accepted value			Input
  !	PMAX	R*4	Maximum accepted value			Input
  !	PINC	R*4	Histogram step				Input
  !	HISTO	R*4	Histogram array				Scratch
  !	X	R*4	Work space				Scratch
  !	Y	R*4	Work space				Scratch
  !	Z	R*4	Work space				Scratch
  !	W	R*4	Work space				Scratch
  !	IW	R*4	Work space				Scratch
  !	B	R*4	Output background image			Output
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  integer :: nz                     !
  real(4) :: a(nx,ny,nz)             !
  integer :: nt                     !
  integer :: scale                  !
  integer :: nw                     !
  real(4) :: bval                    !
  real(4) :: eval                    !
  real(4) :: pmin                    !
  real(4) :: pmax                    !
  real(4) :: pinc                    !
  real(4) :: histo(*)                !
  real(4) :: x(*)                    !
  real(4) :: y(*)                    !
  real(4) :: z(*)                    !
  real(4) :: w(*)                    !
  real(4) :: iw(*)                   !
  real(4) :: b(nx,ny,nz)             !
  ! Local
  integer :: ier
  !
  integer mx,my,m,nh,i
  !
  ! Define the background map
  mx=int(float(nx-nw)/float(scale))+1
  my=int(float(ny-nw)/float(scale))+1
  nh = nint((pmax-pmin)/pinc)
  !
  ! Compute the background image
  m = mx*my
  do i=1,nz                    ! Loop on planes
    call zodi012(a(1,1,i),nx,ny,scale,nw,pmin,   &
     &      pmax,pinc,histo,nh,nt,   &
     &      x,y,z,mx,my,m)
    !
    ! Resample the image to the full Grid
    call zodi013(m,x,y,z,w,iw,b(1,1,i),nx,ny,bval,ier)
    if (ier.ne.0) return
    !
    ! Subtract the background from the image
    !         CALL ZODI004 (A,B,NX,NY,BVAL,EVAL)
  enddo
end subroutine zodi011
!
subroutine zodi012(a,nx,ny,ns,nw,pmin,pmax,pinc,h,nh,nt,   &
     &    x,y,z,mx,my,m)
  use back_conversion
  !---------------------------------------------------------------------
  ! Estimate large scale background on reduced grid
  !
  ! Arguments:
  !	A	R*4	Input data cube				Input
  !	NX	I	First dimension of A			Input
  !	NY	I	Second dimension of A			Input
  !	NS	I	Scale factor for intermediate grid	Input
  !	NW	I	Diameter of smoothing circle		Input
  !	PMIN	R*4	Minimum accepted value			Input
  !	PMAX	R*4	Maximum accepted value			Input
  !	PINC	R*4	Histogram step				Input
  !	H	R*4	Histogram array				Scratch
  !	NH	I	Size of histogram			Input
  !	NT	I	Minimum valid number of points 		Input
  !	BVAL	R*4	Blanking value				Input
  !	EVAL	R*4	Tolerance on blanking value		Input
  !	X	R*4	X coordinate for reduced grid		Output
  !	Y	R*4	Y coordinate for reduced grid		Output
  !	Z	R*4	Background value on reduced grid	Output
  !	MX	I	First dimension of submap		Input
  !	MY	I	Second dimension of submap		Input
  !	M	I	Number of valid points in reduced grid	Output
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real(4) :: a(nx,ny)                !
  integer :: ns                     !
  integer :: nw                     !
  real(4) :: pmin                    !
  real(4) :: pmax                    !
  real(4) :: pinc                    !
  integer :: nh                     !
  real(4) :: h(nh)                   !
  integer :: nt                     !
  real(4) :: x(*)                    !
  real(4) :: y(*)                    !
  real(4) :: z(*)                    !
  integer :: mx                     !
  integer :: my                     !
  integer :: m                      !
  ! Local
  real(4) :: ja,ia
  !
  real r,grav(2)
  integer i,j,nf,k,ier
  !
  k = 0
  do j = 1,my
    ja = (j-cvo(4))*cvo(6)+cvo(5)
    do i = 1,mx
      ia = (i-cvo(1))*cvo(3)+cvo(2)
      call zodi102(a,nx,ny,ia,ja,pmin,pmax,pinc,   &
     &        h,nh,nw,nf)
      if (nf.gt.nt) then
        call zodi122(h,nh,r,pmin,pinc)
        call zodi123(a,nx,ny,ia,ja,nw,pinc,r,grav,ier)
        if (ier.eq.0) then
          k    = k+1
          z(k) = r
          x(k) = grav(1)
          y(k) = grav(2)
        endif
      endif
    enddo
  enddo
  write(6,*) k,' intermediate background values found'
  if (k.gt.0) call zodi124(k,x,y,z)
  m = k
  write(6,*) m,' unredondant (valid) background values found'
  do j=1,m
    write(1,*) x(j),y(j),1.0,z(j)
  enddo
end subroutine zodi012
!
subroutine zodi124(n,x,y,z)
  !---------------------------------------------------------------------
  !     ensures no two entries have the same coordinates (arises when
  !     background is estimated on areas greater than the mesh width)
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: x(*)                      !
  real :: y(*)                      !
  real :: z(*)                      !
  ! Local
  integer :: i,k,good
  !
  good=1
  do i=2,n
    do k=1,good
      if (x(i).eq.x(k).and.y(i).eq.y(k)) goto 1
    enddo
    good=good+1
    x(good)=x(i)
    y(good)=y(i)
    z(good)=z(i)
1   continue
  enddo
  n=good
  return
end subroutine zodi124
!
subroutine zodi102 (a,nx,ny,ia,ja,pmin,pmax,pinc,h,nh,nw,nf)
  use back_conversion
  !---------------------------------------------------------------------
  ! Determine an histogram for map values in a disk around the
  ! specified point.
  !
  ! Arguments:
  !	A	R*4	Input data cube				Input
  !	NX	I	First dimension of A			Input
  !	NY	I	Second dimension of A			Input
  !	IA	R*4	First coordinate of specified point	Input
  !	JA	R*4	Second coordinate of specified point	Input
  !	PMIN	R*4	Minimum accepted value			Input
  !	PMAX	R*4	Maximum accepted value			Input
  !	PINC	R*4	Histogram step				Input
  !	H	R*4	Histogram array				Output
  !	NH	I	Size of histogram			Input
  !	NW	I	Diameter of smoothing circle		Input
  !	NF	I	Number of valid data points		Output
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real(4) :: a(nx,ny)                !
  real(4) :: ia                      !
  real(4) :: ja                      !
  real(4) :: pmin                    !
  real(4) :: pmax                    !
  real(4) :: pinc                    !
  integer :: nh                     !
  real(4) :: h(nh)                   !
  integer :: nw                     !
  integer :: nf                     !
  ! Local
  integer :: i,j,k,imin,imax,jmin,jmax
  real :: r
  !
  ! Zero Histogram
  do i = 1,nh
    h(i) = 0.0
  enddo
  nf = 0
  !
  ! Build it
  jmin = max(1,int(ja-0.5*nw)+1)
  jmax = min(ny,int(ja+0.5*nw)-1)
  imin = max(1,int(ia-0.5*nw)+1)
  imax = min(nx,int(ia+0.5*nw)-1)
  do j = jmin,jmax
    do i = imin,imax
      r = a(i,j)
      if (r.ge.pmin .and. r.lt.pmax) then
        k = int((r-pmin)/pinc)+1
        h(k) = h(k)+1.0
        nf = nf+1
      endif
    enddo
  enddo
end subroutine zodi102
!
subroutine zodi122 (h,nh,r,pmin,pinc)
  !---------------------------------------------------------------------
  ! Determine maximum in an histogram.
  !
  ! Arguments:
  !	H	R*4	Histogram array				Input
  !	NH	I	Size of histogram			Input
  !	R	R*4	Coordinate of histogram maximum		Output
  !	PMIN	R*4	Minimum accepted value			Input
  !	PMAX	R*4	Maximum accepted value			Input
  !	PINC	R*4	Histogram step				Input
  !	NW	I	Radius of smoothing circle		Input
  !---------------------------------------------------------------------
  integer :: nh                     !
  real :: h(nh)                     !
  real :: r                         !
  real :: pmin                      !
  real :: pinc                      !
  ! Local
  integer :: i,n
  real :: t
  !
  t = h(1)
  n = 1
  do i=2,nh
    if (h(i).gt.t) then
      n = i
      t = h(i)
    endif
  enddo
  r = pmin+(n-0.5)*pinc
end subroutine zodi122
!
subroutine zodi123(a,nx,ny,ia,ja,nw,pinc,r,grav,ier)
  use back_conversion
  !---------------------------------------------------------------------
  ! Determine the center of gravity of pixels belonging to the histogram
  ! bin of value R (width PINC) in map A, inside circle of diameter
  ! NW centered at IA JA
  !
  ! Arguments:
  !	A	R*4	Input data cube				Input
  !	NX	I	First dimension of A			Input
  !	NY	I	Second dimension of A			Input
  !	IA	R*4	First coordinate of specified point	Input
  !	JA	R*4	Second coordinate of specified point	Input
  !	NW	I	Diameter of smoothing circle		Input
  !	PINC	R*4	Histogram step				Input
  !	R	R*4	Coordinate of histogram maximum		Output
  !	GRAV(2)	R*4	gravity center coordinates		Output
  !	IER	I	Logical error flag			Output
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real(4) :: a(nx,ny)                !
  real(4) :: ia                      !
  real(4) :: ja                      !
  integer :: nw                     !
  real(4) :: pinc                    !
  real(4) :: r                       !
  real(4) :: grav(2)                 !
  integer :: ier                    !
  ! Local
  integer :: i,j,imin,imax,jmin,jmax,ngrav
  real(4) :: rmin,rmax
  !
  ! Zero
  grav(1)=0
  grav(2)=0
  ngrav=0
  ! Build it
  jmin = max(1,int(ja-0.5*nw)+1)
  jmax = min(ny,int(ja+0.5*nw)-1)
  imin = max(1,int(ia-0.5*nw)+1)
  imax = min(nx,int(ia+0.5*nw)-1)
  rmin=r-pinc*0.5
  rmax=rmin+pinc
  do j = jmin,jmax
    do i = imin,imax
      if (a(i,j).ge.rmin .and. a(i,j).le.rmax) then
        grav(1)=grav(1)+float(i)
        grav(2)=grav(2)+float(j)
        ngrav=ngrav+1
      endif
    enddo
  enddo
  if (ngrav.gt.0) then
    grav(1)=grav(1)/ngrav
    grav(2)=grav(2)/ngrav
    ier=0
    return
  endif
  ier=1
end subroutine zodi123
!
subroutine zodi013(m,x,y,z,w,iw,b,nx,ny,bval,ier)
  integer :: m                      !
  real :: x(*)                      !
  real :: y(*)                      !
  real :: z(*)                      !
  real :: w(*)                      !
  real :: iw(*)                     !
  integer :: nx                     !
  integer :: ny                     !
  real :: b(nx,ny)                  !
  real :: bval                      !
  integer :: ier                    !
  ! Local
  integer :: ncp
  logical :: logran(7), error
  external :: dumf
  data logran /7*.false./, ncp/4/
  !
  call gridini(nx,1.d0,1.d0,1.d0, ny,1.d0,1.d0,1.d0)
  call gridset(ncp,bval,logran)
  call gridran(x,y,z,m,w,iw,b,dumf,dumf,dumf,error)
  if (error) ier = 10
end subroutine zodi013
!
subroutine dumf
end subroutine dumf
!
subroutine zodi004 (a,b,nx,ny,bval,eval)
  integer :: nx                     !
  integer :: ny                     !
  real :: a(nx,ny)                  !
  real :: b(nx,ny)                  !
  real :: bval                      !
  real :: eval                      !
  ! Local
  integer :: i,j
  !
  do j=1,ny
    do i=1,nx
      if (abs(a(i,j)-bval).gt.eval .and.   &
     &        abs(b(i,j)-bval).gt.eval) then
        b(i,j) = a(i,j) - b(i,j)
      else
        b(i,j) = bval
      endif
    enddo
  enddo
end subroutine zodi004

module cubetuple_iterate
  use cubetools_parameters
  use cubetuple_format_class

  public :: cubetuple_iterate_chan,cubetuple_iterate_pix,cubetuple_iterate_subcube
  private

contains

  subroutine cubetuple_iterate_chan(fchan,lchan,cub,error)
    use cubeio_chan
    !---------------------------------------------------------------------
    ! Prepare buffers for working (at least) on the requested channel
    ! range
    !---------------------------------------------------------------------
    integer(kind=chan_k), intent(in)    :: fchan
    integer(kind=chan_k), intent(in)    :: lchan
    class(format_t),      intent(inout) :: cub
    logical,              intent(inout) :: error
    !
    call cub%autotranspose(error)
    if (error)  return
    call cubeio_iterate_chan(cub%user,cub%prog,cub,cub%tuple%current,fchan,lchan,error)
    if (error)  return
  end subroutine cubetuple_iterate_chan

  subroutine cubetuple_iterate_pix(fypix,lypix,cub,error)
    use cubeio_pix
    !---------------------------------------------------------------------
    ! Prepare buffers for working (at least) on the requested Y pixel row
    ! range
    !---------------------------------------------------------------------
    integer(kind=pixe_k), intent(in)    :: fypix
    integer(kind=pixe_k), intent(in)    :: lypix
    class(format_t),      intent(inout) :: cub
    logical,              intent(inout) :: error
    !
    call cub%autotranspose(error)
    if (error)  return
    call cubeio_iterate_pix(cub%user,cub%prog,cub,cub%tuple%current,fypix,lypix,error)
    if (error)  return
  end subroutine cubetuple_iterate_pix

  subroutine cubetuple_iterate_subcube(first,last,cub,error)
    use cubeio_subcube
    !---------------------------------------------------------------------
    ! Prepare buffers for working (at least) on the requested plane
    ! range
    !---------------------------------------------------------------------
    integer(kind=data_k), intent(in)    :: first
    integer(kind=data_k), intent(in)    :: last
    class(format_t),      intent(inout) :: cub
    logical,              intent(inout) :: error
    !
    call cub%autotranspose(error)
    if (error)  return
    call cubeio_iterate_subcube(cub%user,cub%prog,cub,cub%tuple%current,first,last,error)
    if (error)  return
  end subroutine cubetuple_iterate_subcube

end module cubetuple_iterate

subroutine store_monitor(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_rdata
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  include 'clic_xy_code.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: end, do_it
  integer(kind=address_length) :: kh, data_in, kin
  integer(kind=data_length)    :: ldata_in, h_offset
  integer :: oscan, spline(mnant), pol(mnant)
  integer :: nc1, ia, kr
  real :: xx, yy
  character(len=80) :: ch2,ch1
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  call get_first(.false.,error)    ! to initialise ...
  if (error) goto 999
  call check_output_file(error)
  if (error) goto 999
  call check_equal_file(error)
  if (error) goto 999
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) goto 999
  !
  ! Check for presence of calibration curve
  do_it = .false.
  ch1 = 'No Atm.Monitor calibration for '
  nc1 = lenc(ch1)+1
  do ia = 1, r_nant
    ch2 = ', Antenna '//char(ia+ichar('0'))
    if (f_splmon(ia).gt.0) then
      spline(ia) = 1
      pol (ia) = 0
      do_it = .true.
    elseif (f_polmon(ia).gt.0) then
      pol (ia) = 1
      spline(ia) = 0
      do_it = .true.
    else
      pol (ia) = 0
      spline(ia) = 0
      call message(4,2,'STORE_MON',ch1(1:nc1)//ch2 )
    endif
  enddo
  if (.not.do_it) then
    call message (8,4,'STORE_MON','No atm.mon. curve to store')
    goto 999
  endif
  !
  ! Loop on current index
  end = .false.
  oscan = 0
  do while (.not.end)
    !
    ! Store calibration curves
    call get_data (ldata_in,data_in,error)
    if (error) goto 999
    !
    ! Average record only
    kin = gag_pointer(data_in,memory)
    call spectral_dump(kr,0,0)
    kh = kin + h_offset(kr)
    call decode_header (memory(kh))
    if (error) return
    xx = dh_utc/3600.   &
      + (mod(dh_obs+32768,65536)-mod(dobs_0+32768,65536))*24.
    !
    do ia = 1, r_nant
      call get_mon(ia,spline(ia),   &
        pol(ia),xx,yy,oscan,error)
      if (error) return
      r_csky_mon(ia) = yy
    enddo
    !         WRITE(6,*) R_CSKY_MON
    !
    ! Update or copy scan
    call write_scan (.false.,error)
    if (error) goto 999
    !
    ! Next observation
    if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) goto 999
  enddo
  return
  !
999 error = .true.
  return
end subroutine store_monitor
!
subroutine get_mon(ia,ispline,ipol,x,y,oscan,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Returns in Y the value and derivatives of the calibration curve
  ! at time X,
  ! for baseline IB, side band ISB.
  !---------------------------------------------------------------------
  integer :: ia                     !
  integer :: ispline                !
  integer :: ipol                   !
  real :: x                         !
  real :: y                         !
  integer :: oscan                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  ! Local
  real*8 :: xx, yy(4), aa(m_pol)
  integer :: ifail, nk, i
  character(len=80) :: ch
  !------------------------------------------------------------------------
  ! Code:
  xx = x
  error = .false.
  !
  ! Splines
  if (ispline.ne.0) then
    ifail = 1
    nk = n_splmon(ia)
    if (xx.lt.k_splmon(4,ia)) then
      if (k_splmon(4,ia)-xx .gt. 0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' below limit (',   &
            k_splmon(4,ia),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = k_splmon(4,ia)
    elseif (xx.gt.k_splmon(nk+5,ia)) then
      if (xx-k_splmon(nk+5,ia).gt.0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' above limit (',   &
            k_splmon(nk+5,ia),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = k_splmon(nk+5,ia)
    endif
    !
    ! Get spline and derivatives
    call mth_getspd('GET_CAL',nk+8, k_splmon(1,ia),   &
      c_splmon(1,ia), xx, 0, yy, error)
    if (error) return
  !
  ! Polynomials
  elseif (ipol.ne.0) then
    ifail = 1
    if (xx.lt.t_polmon(1,ia)) then
      if (t_polmon(1,ia)-xx .gt. 0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' below limit (',   &
            t_polmon(1,ia),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = t_polmon(1,ia)
    elseif (xx.gt.t_polmon(2,ia)) then
      if (xx-t_polmon(2,ia).gt.0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' above limit (',   &
            t_polmon(2,ia),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = t_polmon(2,ia)
    endif
    do i=1, n_polmon(ia)
      aa(i) = c_polmon(i,ia)
    enddo
    xx = ((xx-t_polmon(1,ia))-(t_polmon(2,ia)-xx))   &
      /(t_polmon(2,ia)-t_polmon(1,ia))
    xx = max(xx,-1d0)
    xx = min(xx,1d0)
    call mth_getpol ('GET_CAL',n_polmon(ia),aa,xx,yy,error)
    if (error) return
  else
    yy(1) = 0.
  endif
  y = yy(1)
end subroutine get_mon

program make_mosaic
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  !----------------------------------------------------------------------
  !   Make a mosaic cube from a set of original images.
  !
  ! The original images are assumed to have the same phase tracking center
  ! and hence the same map characterictics (pixel, size, coordinates)
  ! This program compute several images (rather n-D data sets) :
  !
  ! Ouput
  !   NX NY are the image sizes
  !   NC is the number of channels
  !   NF is the number of different frequencies
  !   NP is the number of pointing centers
  !
  ! 'NAME'.LMV  a 3-d cube containing the uniform noise
  !     combined mosaic, i.e. the sum of the product
  !     of the fields by the primary beam. (NX,NY,NC)
  ! 'NAME'.LOBE the primary beams pseudo-cube (NP,NX,NY,NB)
  ! 'NAME'.WEIGHT the sum of the square of the primary beams (NX,NY,NB)
  ! 'NAME'.BEAM a 4-d cube where each cube contains the synthesised
  !     beam for one field (NX,NY,NP,NB)
  !
  ! All images have the same X,Y sizes
  !
  ! It is assumed that the names of the original field images follow
  ! the simple sequence 'NAME'-'I'.LMV
  !----------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: version = 'Version 3.0 23-July-2015'
  character(len=*), parameter :: pname = 'MAKE_MOSAIC'
  integer :: np
  real :: bsize,bmin
  character(len=80) :: generic
  logical :: error
  !
  call gag_message(seve%i,pname,version)
  !
  call gildas_open
  call gildas_inte('FIELDS$',np,1)
  call gildas_char('NAME$',generic)
  call gildas_real('BEAM$',bsize,1)
  call gildas_real('BMIN$',bmin,1)
  call gildas_close
  !
  ! Do all the work in a subroutine...
  call sub_mosaic (trim(generic),np,bsize,bmin,error)
  if (error) call sysexi(fatale)
  call gag_message(seve%i,pname,'Successful completion')
  !
end program make_mosaic
!
subroutine sub_mosaic(generic,np,bsize_rest,bmin,error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use mapping_primary
  !
  ! Build a Mosaic from an ensemble of NF initial Images
  ! with a name following the convention name-'i' i=1,nf
  !
  character(len=*), intent(in) :: generic  ! Generic name
  integer, intent(in) :: np                ! Number of pointings
  real, intent(in) :: bsize_rest           ! Primary beam size (Radian)
  real, intent(in) :: bmin                 ! Truncation level
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname = 'MAKE_MOSAIC'
  type(gildas) :: field
  type(gildas) :: beam
  type(gildas) :: lobe
  type(gildas) :: mosaic
  type(gildas) :: tmp
  type(gildas) :: weight
  !
  real, allocatable :: dbeam(:,:,:,:) ! Dirty and Primary beam arrays
  real, allocatable :: dmosaic(:,:,:) ! Mosaic
  real, allocatable :: dprim(:,:)     ! Current primary beam
  real, allocatable :: dtmp(:,:)      ! Temporary work space
  real, allocatable :: dweight(:,:,:) ! Final weight image
  !
  character(len=filename_length) :: name
  integer :: nx,ny,nc,nb,nn,ier
  integer :: ip,ib,ic, fc,lc
  real :: thre, rmin, rmax, bsize
  real(8) :: beam_freq
  integer(kind=size_length) :: nelem, imin, imax
  character(len=64) :: chain
  !
  call gildas_null(field)
  call gildas_null(beam)
  call gildas_null(lobe)
  call gildas_null(mosaic)
  call gildas_null(weight)
  call gildas_null(tmp)
  !
  error = .false.
  nn = len_trim(generic)
  !
  name = generic
  name(nn+1:) = '-1'
  call sic_parsef (name,field%file,' ','.lmv')
  call gdf_read_header(field,error)
  if (error) then
    call gag_message(seve%e,rname,'Cannot open '//trim(field%file))
    return
  endif
  nx = field%gil%dim(1)
  ny = field%gil%dim(2)
  nc = field%gil%dim(3)
  !
  ! Test the dirty beam properties
  name = generic
  name(nn+1:) = '-1'
  call sic_parsef (name,beam%file,' ','.beam')
  call gdf_read_header(beam,error)
  if (error) then
    call gag_message(seve%e,rname,'Cannot open '//trim(beam%file))
    return
  endif
  if (nx.ne.beam%gil%dim(1) .or. ny.ne.beam%gil%dim(2)) then
    write(6,*) 'F-'//rname//',  Beam and Dirty do not match'
    return
  endif
  nb = beam%gil%dim(3)    ! Number of different beams per field
  !
  ! First pass: Produce the .BEAM Dirty Beam 4-D data set
  name = generic
  call sic_parsef (name,beam%file,' ','.beam')
  beam%gil%ndim = 4
  ! Push frequency dimension
  beam%char%code(4) = beam%char%code(3)
  beam%gil%dim(4) = nb
  beam%gil%convert(:,4) = beam%gil%convert(:,3)
  beam%gil%faxi = 4
  !
  ! Fill projection information from fields
  beam%gil%proj_words = def_proj_words
  beam%char%code(1) = 'RA'
  beam%char%code(2) = 'DEC'
  beam%gil%ptyp = field%gil%ptyp
  beam%gil%pang = field%gil%pang ! Defined in table.
  beam%gil%a0 = field%gil%a0
  beam%gil%d0 = field%gil%d0
  !
  ! Fill Field dimension
  beam%char%code(3) = 'FIELD-ID'
  beam%gil%dim(3) = np
  beam%gil%convert(:,3) = 1.d0
  beam%gil%extr_words = 0
  !
  allocate (dbeam(nx,ny,np,nb),dtmp(nx,ny),stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Memory allocation error DBEAM')
    error = .true.
    return
  endif
  !
  ! Loop over individual synthesized beams
  call gdf_copy_header(field,tmp,error)
  do ip=1,np
    name = generic
    call append_number(name,ip)
    call sic_parsef (name,tmp%file,' ','.beam')
    call gdf_read_header (tmp,error)
    if (error) then
      call gag_message(seve%f,rname,'Cannot open '//trim(tmp%file))
      return
    endif
    if (tmp%gil%dim(1).ne.nx .or. tmp%gil%dim(2).ne.ny) then
      write(chain,'(A,I4,I6,I6)') 'Inconsistent size, field  ',ip,tmp%gil%dim(1:2)
      call gag_message(seve%f,rname,chain)
      error = .true.
      return
    endif
    do ib=1,nb
      tmp%blc(3) = ib
      tmp%trc(3) = ib
      call gdf_read_data(tmp,dtmp,error)
      dbeam(:,:,ip,ib) = dtmp(:,:)
    enddo
    call gdf_close_image(tmp,error) ! Free image after use
  enddo
  call gdf_write_image(beam,dbeam,error)
  deallocate(dbeam,stat=ier) ! Need a different shape later, so just free it
  if (error) then
    call gag_message(seve%f,rname,'Cannot open '//trim(beam%file))
    return
  endif
  !
  ! Create the primary beams  -- This is a transposed cube (NP,NX,NY,NB)
  call gdf_transpose_header(beam,lobe,'3124',error)
  if (error)  return
  name = generic
  call sic_parsef (name,lobe%file,' ','.lobe')
  !
  lobe%gil%inc(1) = bmin                ! Valeur conventionnelle
  lobe%gil%inc(5) = bsize               ! necessaire pour MRC_MOSAIC.
  allocate (dbeam(np,nx,ny,nb),dmosaic(nx,ny,nc),dprim(nx,ny), &
    & dweight(nx,ny,nb),stat=ier)  !
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Memory allocation error DMOSAIC & DBEAM')
    error = .true.
    return
  endif
  !
  ! Create the .LMV cube
  call gdf_copy_header(field,mosaic,error)
  !
  ! loop over the various fields.
  name = generic(1:nn)
  call sic_parsef (name,mosaic%file,' ','.lmv')
  mosaic%gil%ra = mosaic%gil%a0
  mosaic%gil%dec  = mosaic%gil%d0
  !
  dmosaic = 0
  !
  do ip=1,np
    name = generic
    call append_number(name,ip)
    call sic_parsef (name,field%file,' ','.lmv')
    call gdf_read_header (field,error)
    if (error) then
      call gag_message(seve%f,rname,'Cannot open '//trim(field%file))
      return
    endif
    !
    ! Here, loop over the NB beams at different frequencies
    do ib=1,nb
      !
      ! Figure out the frequency and corresponding Primary Beam size
      beam_freq = (ib-beam%gil%ref(4))*beam%gil%fres + beam%gil%freq
      bsize = bsize_rest * beam%gil%freq / beam_freq
      !
      ! Figure out the first and last channels in the data array
      if (nb.eq.1) then
        fc = 1
        lc = nc
      else if (beam%gil%freq.gt.0) then
        !
        if (field%gil%fres.gt.0) then
          fc = int((beam_freq-beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) + 1d0)
          lc = int((beam_freq+beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) )
          if (ib.eq.1) fc = 1
          if (ib.eq.nb) lc = nc
        else
          fc = int((beam_freq+beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) + 1d0)
          lc = int((beam_freq-beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) )
          if (ib.eq.1) lc = nc
          if (ib.eq.nb) fc = 1
        endif
      else
        !
        if (field%gil%fres.gt.0) then
          fc = int((beam_freq+beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) + 1d0)
          lc = int((beam_freq-beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) )
          if (ib.eq.nb) fc = 1
          if (ib.eq.1) lc = nc
        else
          fc = int((beam_freq-beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) + 1d0)
          lc = int((beam_freq+beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) )
          if (ib.eq.1) fc = 1
          if (ib.eq.nb) lc = nc
        endif
      endif
      !
      ! Compute the non truncated primary beam
      call mos_primary (field,dprim,bsize)
      dbeam(ip,:,:,ib) = dprim  ! Fill the primary beam array
      !
      ! But a truncated primary beam is used
      where (dprim.lt.bmin) dprim = 0
      !
      ! Make it Plane by Plane to save Memory
      ! A more efficient implementation would use a Blocking Factor
      do ic=fc,lc
        field%blc(3) = ic
        field%trc(3) = ic
        call gdf_read_data (field, dtmp, error)
        dmosaic(:,:,ic) = dmosaic(:,:,ic) + dtmp*dprim  ! Apply the primary beam
      enddo
    enddo
    !
    call gdf_close_image (field,error) ! Free field image after use
  enddo
  !
  ! Write the primary beams
  call gdf_write_image (lobe,dbeam,error)
  if (error) then
    call gag_message(seve%f,rname,'Cannot create '//trim(lobe%file))
    return
  endif
  !
  ! Compute the extrema of the Mosaic and write it
  nelem = nx*ny*nc
  call gr4_extrema (nelem,dmosaic,mosaic%gil%bval,mosaic%gil%eval,   &
                    rmin,rmax,imin,imax)
  call t_setextrema(mosaic,rmin,imin,rmax,imax)
  call gdf_write_image(mosaic,dmosaic,error)
  if (error) then
    call gag_message(seve%f,rname,'Cannot open '//trim(mosaic%file))
    return
  endif
  !
  ! Now the .WEIGHT file
  call gdf_copy_header(mosaic,weight,error)
  weight%gil%ndim = 3
  weight%gil%dim(3) = beam%gil%dim(4)
  weight%gil%convert(:,3) = beam%gil%convert(:,4)
  weight%gil%fres = beam%gil%fres
  weight%gil%freq = beam%gil%freq
  !
  name = generic(1:nn)
  call sic_parsef(name,weight%file,' ','.weight')
  !
  ! Use DTMP as temporary space
  thre = bmin**2
  do ib=1,nb
    dtmp = 0.0
    do ip=1,np
      dtmp(:,:) = dtmp + dbeam(ip,:,:,ib)**2
    enddo
    where (dtmp.ge.thre)
      dweight(:,:,ib) = 1.0/dtmp
    else where
      dweight(:,:,ib) = 0.0
    end where
  enddo
  !
  nelem = nx*ny*nb
  call gr4_extrema (nelem,dweight,weight%gil%bval,weight%gil%eval,   &
                    rmin,rmax,imin,imax)
  weight%gil%bval = 0
  weight%gil%eval = 0
  call t_setextrema(weight,rmin,imin,rmax,imax)
  call gdf_write_image(weight,dweight,error)
  !
  if (error) then
    call gag_message(seve%f,rname,'Cannot create '//trim(weight%file))
    return
  endif
end subroutine sub_mosaic

subroutine append_number(name,if)
  character(len=*), intent(inout) :: name
  integer, intent(in) :: if
  !
  character(len=12) :: rchain, lchain
  integer :: nn
  !
  nn = len_trim(name)
  !
  write(rchain,'(I12)') if
  lchain = adjustl(rchain)
  !
  name(nn+1:) = '-'//lchain
end subroutine append_number

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBE messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_messaging
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: fitseve,seve,mess_l
  public :: cubefit_message_set_id,cubefit_message
  public :: cubefit_message_set_alloc,cubefit_message_get_alloc
  public :: cubefit_message_set_trace,cubefit_message_get_trace
  public :: cubefit_message_set_others,cubefit_message_get_others
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubefit_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubefit_messaging_debug_t
     integer(kind=code_k) :: alloc = seve%d
     integer(kind=code_k) :: trace = seve%t
     integer(kind=code_k) :: others = seve%d
  end type cubefit_messaging_debug_t
  !
  type(cubefit_messaging_debug_t) :: fitseve
  !
contains
  !
  subroutine cubefit_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubefit_message_id = id
    write (mess,'(A,I0)') 'Now use id #',cubefit_message_id
    call cubefit_message(seve%d,rname,mess)
  end subroutine cubefit_message_set_id
  !
  subroutine cubefit_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubefit_message_id,mkind,'FIT>'//procname,message)
  end subroutine cubefit_message
  !
  subroutine cubefit_message_set_alloc(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitseve%alloc = seve%i
    else
       fitseve%alloc = seve%d
    endif
  end subroutine cubefit_message_set_alloc
  !
  subroutine cubefit_message_set_trace(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitseve%trace = seve%i
    else
       fitseve%trace = seve%t
    endif
  end subroutine cubefit_message_set_trace
  !
  subroutine cubefit_message_set_others(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitseve%others = seve%i
    else
       fitseve%others = seve%d
    endif
  end subroutine cubefit_message_set_others
  !
  function cubefit_message_get_alloc()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefit_message_get_alloc
    !
    cubefit_message_get_alloc = fitseve%alloc.eq.seve%i
    !
  end function cubefit_message_get_alloc
  !
  function cubefit_message_get_trace()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefit_message_get_trace
    !
    cubefit_message_get_trace = fitseve%trace.eq.seve%i
    !
  end function cubefit_message_get_trace
  !
  function cubefit_message_get_others()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefit_message_get_others
    !
    cubefit_message_get_others = fitseve%others.eq.seve%i
    !
  end function cubefit_message_get_others
end module cubefit_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clic_print(line,error)
  use gkernel_interfaces
  use gildas_def
  use clic_file
  use clic_title
  use clic_index
  !---------------------------------------------------------------------
  ! Command PRINT [ BASELINE | DELAY | FLUX ]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_stations.inc'
  include 'clic_display.inc'
  ! Local
  character(len=11) :: ch1
  character(len=80) :: name,file
  character(len=12) :: arg,ateles
  character(len=1) :: arm(4)
  integer :: j, k, iarm, jarm, k_ant, lun, ier, iarm1
  integer :: iarm2, jarm1, jarm2, nch, idf, mvoc1, narg
  parameter (mvoc1=3)
  logical :: f_ant(mnant), more, antenna
  real*8 :: pos(3,mnant)
  character(len=12) :: voc1(mvoc1)
  !
  data arm/'N','W','E','E'/
  data voc1/'BASELINE','FLUX','DELAY'/
  !------------------------------------------------------------------------
  ! Code:
  arg = '*'
  call clic_kw(line,0,1,arg,nch,voc1,mvoc1,.true.,error,.true.)
  if (error) return
  !
  ! Baseline
  if (arg.eq.'BASELINE') then
    !
    ! output
    call datec(title%dobs,ch1,error)
    ! May be datec should produce lower case ?
    call sic_lower(ch1)
    ier = sic_getlun(lun)
    if (ier.ne.1) then
      call gagout('W-CLIC_PRINT,  Error getting logical unit')
      call show_luns
      error = .true.
      return
    endif
    if (sic_present(1,0)) then
       call sic_ch (line,1,1,file,narg,.true.,error)
       if (error) return
    else
      name = ch1(1:11)//'-base'
      file = name
      call sic_parsef (name,file,'INTER_OBS:','.obs')
    endif
    ier = sic_open (lun,file,'NEW',.false.)
    if (ier.ne.0) then
      call message(8,4, 'CLIC_PRINT',   &
        'Open error file '//file(1:lenc(file)))
      call messios(8,4, 'CLIC_INPUT',ier)
      goto 999
    endif
    rewind(lun)
    !
    call user_info(name)
    write (lun,1002) '! '//name(1:78)
    write (lun,1002) '! Results of baseline fit:'
    call rix(cx_ind(1),error)
    call bytoch(title%teles,ateles,12)
    write(lun,1003) ateles, title%scan, ch1(1:11)
    call rix(cx_ind(cxnext-1),error)
    call datec(title%dobs,ch1,error)
    write(lun,1004) title%scan, ch1(1:11)
    write(lun,1002) '!'
    !
    antenna = .false.
    do k=1, r_nant
      antenna = antenna .or. f_afit(k)
      f_ant(k) = .false.
    enddo
    if (.not.antenna) then
      do k=1, mnbas
        if (f_bfit(k)) then
          iarm1 = r_istat(r_iant(k))/100
          jarm1 = r_istat(r_iant(k))-iarm1*100+(r_istat(r_iant(k))/400)*100
          iarm2 = r_istat(r_jant(k))/100
          jarm2 = r_istat(r_jant(k))-iarm2*100+(r_istat(r_jant(k))/400)*100
          write(lun,1010) cbas(k),   &
            arm(iarm1), jarm1, arm(iarm2), jarm2, b_rms(k)
          write(lun,1011,err=999)   &
            (b_fit(j,k), b_err(j,k)/1000., j=1,3)
          write(lun,1002) '!'
        endif
      enddo
      k_ant = 0
      more = .true.
      do while (more)
        more = .false.
        do k=1, mnbas
          if (f_bfit(k)) then
            if (k_ant.eq.0) then
              do j=1,3
                pos(j,r_iant(k)) = 0
              enddo
              k_ant = k_ant+1
              f_ant(r_iant(k)) = .true.
              more = .true.
            endif
            if (f_ant(r_iant(k))   &
              .and. .not. f_ant(r_jant(k))) then
              do j=1,3
                pos(j,r_jant(k)) =   &
                  b_fit(j,k)+pos(j,r_iant(k))   &
                  - stat25(j,r_istat(r_jant(k)))   &
                  + stat25(j,r_istat(r_iant(k)))
              enddo
              k_ant = k_ant+1
              f_ant(r_jant(k)) = .true.
              more = .true.
            elseif (f_ant(r_jant(k))   &
              .and. .not.f_ant(r_iant(k))) then
              do j=1,3
                pos(j,r_iant(k)) =   &
                  - b_fit(j,k)+ pos(j,r_jant(k))   &
                  + stat25(j,r_istat(r_jant(k)))   &
                  - stat25(j,r_istat(r_iant(k)))
              enddo
              k_ant = k_ant+1
              f_ant(r_iant(k)) = .true.
              more = .true.
            endif
          endif
        enddo
      enddo
    elseif (antenna) then
      do k=1, r_nant
        if (f_afit(k)) then
          f_ant(k) = .true.
          do j = 1, 3
            pos(j,k) = a_fit(j,k)-stat25(j,r_istat(k))
          enddo
          iarm = r_istat(k)/100
          jarm = r_istat(k)-iarm*100+(r_istat(k)/400)*100
          write(lun,1012) k, arm(iarm), jarm, a_rms(k)
          write(lun,1011,err=999)   &
            (a_fit(j,k), a_err(j,k)/1000., j=1,3)
          write(lun,1002) '!'
        else
          do j = 1, 3
            pos(j,k) = 0
          enddo
        endif
      enddo
    endif
    !
    write (lun,1002) '!'
    write (lun,1002) '! OBS procedure for updating '   &
      //'antenna positions offsets'
    write (lun,1002) '!'
    do k=1, r_nant
      iarm = r_istat(k)/100
      jarm = r_istat(k)-iarm*100+(r_istat(k)/400)*100
      if (f_ant(k)) then
        write(lun,1000) char(92),   &
          (pos(j,k)-pos(j,1),j=1,3),r_kant(k),   &
          arm(iarm), jarm
      else
        write(lun,1001) r_kant(k),arm(iarm), jarm
      endif
    enddo
    !
    write(lun,1002) '!'
    write(lun,1002) '! CLIC command for updating antenna positions'
    write(lun,1002) '!'
    write(lun,1002) '! MODIFY ANTENNA -'
    do k=1,r_nant
      write(lun,1008) k,(pos(j,k)-pos(j,1),j=1,3)
    enddo
    write(lun,1002) '! /OFFSET 25'
    inquire (unit=lun, name=name)
    close (unit=lun)
    call sic_frelun (lun)
    call message(6,1,'CLIC_PRINT','Created '//name(1:lenc(name)))
  !
  ! Flux ------------------------------------------------------------------
  elseif (arg.eq.'FLUX') then
    if (n_flux.le.0) then
      call gagout('E-PRINT,  No list of fluxes')
    else
      ier = sic_getlun (lun)
      if (ier.ne.1) then
        call gagout('W-CLIC_PRINT,  Error getting logical unit')
        call show_luns
        error = .true.
        return
      endif
      name = 'clic-fluxes.clic'
      ier = sic_open(lun,name,'NEW',.false.)
      if (ier.ne.0) then
        call message(8,4, 'CLIC_PRINT',   &
          'Open error file CLIC-FLUXES.CLIC')
        call messios(8,4, 'CLIC_PRINT',ier)
        goto 999
      endif
      !
      call user_info(name)
      write (lun,1002) '! '//name(1:78)
      write (lun,1002)   &
        '! CLIC procedure for updating source fluxes'
      call rix(cx_ind(1),error)
      call datec(title%dobs,ch1,error)
      call bytoch(title%teles,ateles,12)
      write(lun,1003) ateles, title%scan, ch1(1:11)
      call rix(cx_ind(cxnext-1),error)
      call datec(title%dobs,ch1,error)
      write(lun,1004) title%scan, ch1(1:11)
      do k=1, n_flux
        idf = date_flux(k)
        if (idf.le.99999) then
          call datec(idf,ch1,error)
        else
          ch1 = ' '
        endif
        if (f_flux(k)) then
          write(lun,1005) ' SET FLUX', c_flux(k),   &
            flux(k), '! Jy FIXED '
        else
          write(lun,1005) '!SET FLUX',c_flux(k),   &
            flux(k), '! Jy FREE  '//ch1(1:11)//' ',   &
            freq_flux(k)/1d3,' GHz'
        endif
      enddo
      inquire (unit=lun, name=name)
      close (unit=lun)
      call sic_frelun (lun)
      call message(6,1,'CLIC_PRINT','Created '   &
        //name(1:lenc(name)))
    endif
  !
  ! DELAY --------------------------------------------------------
  !
  elseif (arg.eq.'DELAY') then
    call print_delay (.true.,error)
  endif
  return
  !
  ! Error case
999 error = .true.
  call sic_frelun(lun)
  return
  !
1000 format('SET',a,'XYZ ',3(f10.6,1x),'/ANTENNA ',i0,   &
    '  ! on ',a1,i3.3)
1001 format('! (no data for antenna ',i0,' on ',a1,i3.3,')')
1002 format(a)
1003 format('! ',a,' from scan ',i5,' (',a,')')
1004 format('! ',12x,'   to scan ',i5,' (',a,')')
1005 format(a9,2x,a12,2x,f10.4,2x,a,f5.1,a)
1008 format('! ',i2,3(1x,f11.6),' -')
1010 format('! Baseline ',a5,' ',a1,i3.3,'-',a1,i3.3,   &
    '   rms = ',1pg11.4)
1012 format('! Antenna  ',i3,' on ',a1,i3.3,'   rms = ',1pg11.4)
1011 format('! X= ',f11.6,' +/- ',f8.6,/   &
    '! Y= ',f11.6,' +/- ',f8.6,/   &
    '! Z= ',f11.6,' +/- ',f8.6)
end subroutine clic_print
!
subroutine show_luns
  use gkernel_interfaces
  ! Local
  integer :: i,ier
  character(len=80) :: name
  character(len=1) :: pol(2)
  data pol/'H','V'/
  !------------------------------------------------------------------------
  ! Code:
  do i=100,119
    inquire (unit=i, name=name, iostat=ier)
    if (ier.ne.0) then
      write(6,*) 'Unit ',i,':'
      call messios(8,4, 'clic_print',ier)
    else
      write(6,*) 'Unit ',i,'   File ',name(1:lenc(name))
    endif
  enddo
  return
end subroutine show_luns
!
subroutine print_delay (date,error)
  use gildas_def
  use gkernel_interfaces
  use clic_file,except=>i
  use clic_title
  use clic_index
  logical :: date                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_stations.inc'
  ! Local
  character(len=11) :: ch1
  character(len=1) :: arm(4),pol(2)
  character(len=200) :: name,file,ch
  integer :: ier, lun, i, k, l, iarm, jarm, iif, ibb, ndelay(mnbb), jbb
  character(len=12) :: ateles
  real :: ref_delay(mnbb)
  !
  data arm/'N','W','E','E'/
  data pol/'H','V'/
  !
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    call gagout('W-CLIC_PRINT,  Error getting logical unit')
    call show_luns
    error = .true.
    return
  endif
  if (date) then
    call datec(title%dobs,ch1,error)
    name = ch1(1:11)//'-delay'
  else
    name = 'delay'
    ch1 = ' '
  endif
  file = name
  call sic_parsef (name,file,'INTER_OBS:','.obs')
  ier = sic_open (lun,file,'NEW',.false.)
  if (ier.ne.0) then
    call message(8,4, 'CLIC_PRINT',   &
      'Open error file '//file(1:lenc(file)))
    call messios(8,4, 'CLIC_INPUT',ier)
    call sic_frelun (lun)
    error = .true.
    return
  endif
  rewind(lun)
  !
  call check_scan(lun,r_scan,'Delay')
  call user_info(name)
  write (lun,1002) '! '//name(1:78)
  write (lun,1002) '! Results of Delay fit:'
  call rix(cx_ind(1),error)
  call bytoch(title%teles,ateles,12)
  write(lun,1003) ateles, title%scan, ch1(1:11)
  call rix(cx_ind(cxnext-1),error)
  call datec(title%dobs,ch1,error)
  write(lun,1004) title%scan, ch1(1:11)
  write(lun,1002) '!'
  !
  ref_delay = 0
  ndelay = 0
  do k=1, r_nant
    do ibb=1,mnbb
      if (f_bbdelayfit(k,ibb)) then
        iarm = r_istat(k)/100
        jarm = r_istat(k)-iarm*100+(r_istat(k)/400)*100
        write(lun,1013) k, r_kant(k), ibb,arm(iarm), jarm,   &
          bbdelayoff(r_kant(k),ibb),bbdelayrms(k,ibb)
1013    format('! Ant. ',i0,' (a',i0,') bb.',i0,' on ',a1,i3.3,' delay = ',   &
          1pg13.6, '   rms = ',1pg13.6)
        write(lun,1002) '!'
      endif
    enddo
    do iif=1,mnif
      if (f_ifdelayfit(k,iif)) then
        iarm = r_istat(k)/100
        jarm = r_istat(k)-iarm*100+(r_istat(k)/400)*100
        write(lun,1014) k, r_kant(k), iif,arm(iarm), jarm,   &
          ifdelayoff(r_kant(k),iif),ifdelayrms(k,iif)
1014    format('! Ant. ',i0,' (a',i0,') if.',i0,' on ',a1,i3.3,' delay = ',   &
          1pg13.6, '   rms = ',1pg13.6)
        write(lun,1002) '!'
      endif
    enddo
  enddo
  !
  write (lun,1002) '!'
  write (lun,1002) '! OBS procedure for updating delays'
  write (lun,1002) '!'
  do i=1, r_nant
    k = r_kant(i)
    do ibb=1,mnbb
      if (f_bbdelayoff(k,ibb)) then
        iarm = r_istat(i)/100
        jarm = r_istat(i)-iarm*100+(r_istat(k)/400)*100
        if (f_crossed) then
          write(lun,1009) char(92), bbdelayoff(k,ibb), k, r_nrec,   &
            r_bbname(ibb),arm(iarm), jarm
        elseif (.not.f_reference) then
          if (new_receivers) then
            write(lun,1007) char(92), bbdelayoff(k,ibb), k, r_nrec,   &
              r_bbname(ibb),arm(iarm), jarm
          else
            write(lun,1006) char(92), bbdelayoff(k,1), k, r_nrec,   & !! CHECK
              arm(iarm), jarm
          endif
        elseif (.not.f_delaybase) then          
          ref_delay(ibb) = ref_delay(ibb)+bbdelayoff(k,ibb)
          ndelay(ibb) = ndelay(ibb)+1
        else
          jbb = ibb
        endif
      endif
1006  format('SET',a,'DELAY ',f10.4,' /ANTENNA ',i0,' /RECEIVER ',   &
        i1,' ! on ',a1,i2.2)
1007  format('SET',a,'DELAY ',f10.4,' /ANTENNA ',i0,' /RECEIVER ',   &
        i1,' /BASEBAND ',a,' ! on ',a1,i2.2)
1009  format('SET',a,'DELAY ',f10.4,' /ANTENNA ',i0,' /RECEIVER ',   &
        i1,' /BASEBAND ',a,'/CROSSED   ! on ',a1,i2.2)
1010  format('SET',a,'DELAY ',f10.4,' /RECEIVER ',   &
        i1,' /BASEBAND ',a,'/REFERENCE ')
    enddo
    do iif=1,mnif
      if (f_ifdelayoff(k,iif)) then
        iarm = r_istat(i)/100
        jarm = r_istat(i)-iarm*100+(r_istat(k)/400)*100
        if (new_receivers) then
          write(lun,1008) char(92), ifdelayoff(k,iif), k, r_nrec,   &
            r_ifname(iif),arm(iarm), jarm
        else
          write(lun,1006) char(92), ifdelayoff(k,1), k, r_nrec,   & !! CHECK
            arm(iarm), jarm
        endif
      endif
1008  format('SET',a,'DELAY ',f10.4,' /ANTENNA ',i0,' /RECEIVER ',   &
        i1,' /IF ',a,' ! on ',a1,i2.2)
    enddo

  enddo
  if (f_reference.and.f_delaybase) then
    do i=1, r_nbas
      ref_delay(jbb) = ref_delay(jbb)+bbdelayfitbase(i,jbb)
      ndelay(jbb) = ndelay(jbb)+1
    enddo
  endif
  do ibb=1,mnbb
    if (ndelay(ibb).gt.0) then
      ref_delay(ibb) = ref_delay(ibb)/ndelay(ibb)
      write(lun,1010) char(92), ref_delay(ibb), r_nrec,   &
          r_bbname(ibb)
    endif
  enddo
  !
  write(lun,1002) '!'
  write(lun,1002) '! CLIC command for updating delays'
  write(lun,1002) '!'
  do ibb=1, mnbb
    ch = '! MODIFY DELAY '
    l = lenc(ch)
    do k=1,r_nant
      if (.not.f_reference) then
        if (k.gt.1 .and. f_bbdelayfit(k,ibb)) then
          write(ch(l+1:),'(1x,i2,1x,f10.4)') k,bbdelayoff(r_kant(k),ibb)
          l = lenc(ch)
        endif
      else
        if (ndelay(ibb).gt.0) then
          write(ch(l+1:),'(1x,i2,1x,f10.4)') k,ref_delay(ibb)
          l = lenc(ch)
        endif 
      endif
    enddo
    ch(l+1:) = ' /BBAND '//char(ibb+ichar('0'))
    l = lenc(ch)
    ch(l+1:) = ' /OFF'
    l = lenc(ch)
    if (f_crossed.or.f_reference) then
      ch(l+1:) = ' /SWITCH CROSSED'
      l = lenc(ch)
    else
      ! Generic case is direct
      ch(l+1:) = ' /SWITCH DIRECT'
      l = lenc(ch)
    endif
    if (l.gt.44)  write(lun,1002) ch(1:l)
  enddo
  do iif=1, mnif
    ch = '! MODIFY DELAY '
    l = lenc(ch)
    do k=1,r_nant
      if (k.gt.1 .and. f_ifdelayfit(k,iif)) then
        write(ch(l+1:),'(1x,i2,1x,f10.4)') k,ifdelayoff(r_kant(k),iif)
        l = lenc(ch)
      endif
    enddo      
    ch(l+1:) = ' /IF '//char(iif+ichar('0'))
    l = lenc(ch)
    ch(l+1:) = ' /OFF'
    l = lenc(ch)
    if (l.gt.25)  write(lun,1002) ch(1:l)
  enddo
  inquire (unit=lun, name=name)
  close (unit=lun)
  call sic_frelun (lun)
  call message(6,1,'CLIC_PRINT','Created '//name(1:lenc(name)))
  return
  !
1002 format(a)
1003 format('! ',a,' from scan ',i5,' (',a,')')
1004 format('! ',12x,'   to scan ',i5,' (',a,')')
end subroutine print_delay

!
subroutine getfits(filename,tmpbackend,stepcompress,   &
     cryoextension,derotextension,trackingcutoff,   &
     currentindex,firstifb,ncf,nfb,subscanRange,nosky,error)
!
! Reads the imbfits file (version < 2.0) into MIRA's data structures (define in
! mira_use.f90). Called by subroutine getmira. See "MIRA\help get" for possible options.
!
   !
   use mira
   use gbl_constant
   use cfitsio_status
   use telcal_interfaces
   use fit_definitions
   use pcross_definitions
   use focus_definitions
   !
   implicit none
   !
   integer            :: firstifb, ncf, nfb
   character(len=200) :: filename
   logical            :: error, keep
   integer            :: blocksize, currentindex, hdutype, i,           &
                         ibd, icol, idcol, idump, idump1, idump2,       &
                         idump3, idump4, ier, ifb, iobs, istart,        &
                         iend, j, jfb, j1, j2, k, l, lastifb,           &
                         mxchan, nbd, nchan, nxchan, ndump,             &
                         ndumpantenna, ndumpantennanew,                 &
                         ndumpantennafast, ndumpantennafastnew,         &
                         ndumpcryo, ndumpderot, nhdu, noffset, nrecords,&
                         nrecnew, ndumpfrontend, ndumpsubref, nphases,  &
                         npix, readwrite=0, status=0, tracerate, unit
   integer            :: idcol_mjd, idcol_integtim, idcol_iswitch,      &
                         idcol_data
   integer, dimension(2) :: subscanRange
   !
   real               :: nullval
   real*4             :: aux, median
   real*8             :: dumptime,stepcompress,trackingcutoff
   !
   !
   character(len=1)   :: nullstr
   character(len=6)   :: subscanstring, string
   character(len=8)   :: keystring, offsetstring
   character(len=8)   :: backend, focustranslationdirection, specsys
   character(len=20)  :: backendextension, tmpformat, dataformat,   &
                         frontend, swtchmod
   character(len=23)  :: tmpbackend
   character(len=20)  :: tmpscantype, tmpswitchmode
   character(len=23)  :: subscantime
   character(len=80)  :: comment
   logical            :: anynull, readonly
   !
   !
   integer, dimension(:), allocatable         :: intdata
   real, dimension(:), allocatable            :: realdata
   real*8, dimension(:), allocatable          :: doubledata
   integer, dimension(:), allocatable         :: subscantrace,   &
                                                 traceflag,   &
                                                 tmptraceflag
   real*8                                     :: fmax,fmin,   &
                                                 focusoffset,f1,f2,   &
                                                 substime,velosys,   &
                                                 posanghera
   logical, dimension(1)                      :: flagscalar
   logical, dimension(:), allocatable         :: flagvals,   &
                                                 traceflagdefined
   !
   type myslowdap
      integer :: subscan
      integer :: traceflag
      real*8  :: mjd
      real*8  :: lst
      real*8  :: longoff
      real*8  :: latoff
      real*8  :: baslong
      real*8  :: baslat
      real*8  :: parangle
   end type myslowdap
   !
   type myfastdap
      integer :: subscanfast
      real*8, dimension(3) :: encoder_az_el
      real*8, dimension(2) :: tracking_az_el
   end type myfastdap
   !
   type(myslowdap), dimension(:), allocatable :: slowdap
   type(myfastdap), dimension(:), allocatable :: fastdap
   !
   type(arraydata_data)                                      :: artmp
   !
   integer                                      :: allchannels,   &
                                                   nrowbackendtable
   integer                                      :: ipix,ichan,iph,   &
                                                   irow, i1, i2, i3,   &
                                                   i4, i5, i6, m,   &
                                                   nbin, ncfe,pswitch
   integer                                      :: idxantenna,   &
                                                   idxstart,   &
                                                   idxsubref,   &
                                                   idxcryo,   &
                                                   idxderot,   &
                                                   idxbackend, next
   integer, dimension(:), allocatable           :: refchan, chans,   &
                                                   dropped, used,   &
                                                   band, baseband,   &
                                                   pixel, tmpsubscan
   logical                                      :: cryoextension,   &
                                                   derotextension,   &
                                                   nosky
   logical, dimension(:), allocatable           :: bandmask,   &
                                                   compressmask,   &
                                                   foundfebe
   integer, dimension(:,:), allocatable         :: iddump
   real                                         :: imbftsve
   real*8                                       :: pmjd, pintegtim
   real, dimension(:), allocatable              :: reffreq, spacing
   character(len=12), dimension(:), allocatable :: rec1, rec2
   character(len=20), dimension(:), allocatable :: sysoff
   !
   integer                                      :: bandsave, k1, k2
   integer                                      :: nrowfrontendtable
   integer, dimension(:), allocatable           :: indx, nfeeds,   &
                                                   part, irank
   real, dimension(:), allocatable              :: beameff,etafss,   &
                                                   gainimag,tcold,   &
                                                   ifcenter,   &
                                                   frqoff1,frqoff2,   &
                                                   frqthrow
   real*8, dimension(:), allocatable            :: fx,restfreq,   &
                                                   sbsep,tcoldmon,   &
                                                   tmpfocus
   real*8                                       :: pcoldimage,   &
                                                   pcoldsignal,   &
                                                   photimage,   &
                                                   photsignal,   &
                                                   pcoldimagenew,   &
                                                   pcoldsignalnew,   &
                                                   photimagenew,   &
                                                   photsignalnew
   real*8                                       :: tmpcalib
   real*8                                       :: trec, gainimage,   &
                                                   pcoldimagemean,   &
                                                   photimagemean
   character(len=3), dimension(:), allocatable  :: sideband
   character(len=6), dimension(:), allocatable  :: widenar
   character(len=20)                            :: tmpfrontend
   character(len=20), dimension(:), allocatable :: recname, linename
   character(len=32)                            :: message
   !
   ! local variables related to polarimetry
   !
   integer                                              :: nspec
   integer, dimension(:), allocatable                   :: ifbold
   real*8                                               :: ccimag
   real*8                                               :: ccreal
   character(len=1), dimension(4), parameter            :: stokes =   &
                                                           (/'H','V','R','I'/)
   character(len=4), dimension(:), allocatable          :: polar
   character(len=10), dimension(:),allocatable          :: poltype
   character(len=12), dimension(:), allocatable         :: rec3
   logical                                              :: polmode
   logical, dimension(:,:), allocatable                 :: mask
   logical, dimension(:), allocatable                   :: calmask
   type(flag), dimension(:), allocatable                :: reducetmp
   type(febepar), dimension(:), pointer                 :: febetmp   &
                                                           => null()
   type(arraydata), dimension(:), pointer               :: arraytmp   &
                                                           => null()
   type(datapar), dimension(:), pointer                 :: datatmp   &
                                                           => null()
   type(monitor), dimension(:), pointer                 :: montmp   &
                                                           => null()
   type(calibration), dimension(:), pointer             :: gainstmp   &
                                                           => null()
   type(imbfitsantenna), dimension(:), allocatable      :: antennatmp
   type(imbfitsbackend), dimension(:), allocatable      :: backendtmp
   type(imbfitssubreflector), dimension(:), allocatable :: subreftmp
   !
   !
   error = .false.
   !
   if (firstifb.eq.1) then
      !
      if (associated(scan)) call freescan(scan%data,error)
      if (associated(sc%data%longoff)) call freescan(sc%data,error)
      !
      if (allocated(fb)) then
         do ifb = 1, size(fb)
            call freefebe(fb(ifb)%data,error)
         enddo
         deallocate(fb, stat = ier)
      endif
      !
      if (allocated(databuf)) then
         do ifb = 1, size(databuf)
            call freedata(databuf(ifb)%data,error)
         enddo
         deallocate(databuf,stat=ier)
      endif
      !
      if (allocated(arraybuf)) then
         do ifb = 1, size(array)
            do ibd = 1, size(arraybuf(ifb)%header)
               call freearray(arraybuf(ifb)%data(ibd),error)
            enddo
            deallocate(arraybuf(ifb)%header,   &
              arraybuf(ifb)%data,stat =ier)
         enddo
         deallocate(arraybuf,stat=ier)
      endif
      !
      if (allocated(monbuf)) then
         do ifb = 1, size(monbuf)
            call freemon(monbuf(ifb)%data,error)
         enddo
         deallocate(monbuf,stat=ier)
      endif
      !
      if (allocated(reduce)) deallocate(reduce,stat = ier)
      if (associated(cryo))    call freecryo(cryo,error)
      if (associated(crx%mjd)) call freecryo(crx, error)
      if (associated(derot))   call freederot(derot,error)
      if (associated(drt%mjd)) call freederot(drt,error)
      !
      if (allocated(raw)) then
         do i = 1, size(raw)
            call freeraw(raw(i), error)
         enddo
         deallocate(raw, stat = ier)
      endif
      !
      if (allocated(antdata%encoder_az_el))   &
        deallocate(antdata%encoder_az_el,stat=ier)
      if (allocated(antdata%tracking_az_el))   &
        deallocate(antdata%tracking_az_el,stat=ier)
      if (allocated(antdata%slowtrace))   &
        deallocate(antdata%slowtrace,stat=ier)
   !
   endif
   !
   call ftgiou(unit,status)
   call ftopen(unit,filename,readwrite,blocksize,status)
   !
   if (status.ne.0) then
      call gagout('E-GET: Open fits file error.')
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   !
   !
   call ftmahd(unit,1,hdutype,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkys(unit,'IMBFTSVE',pr%header%mbftsver,comment,status)
   read(pr%header%mbftsver,'(f3.1)') imbftsve
   if (imbftsve.ge.2.0) then
      call ftclos(unit,status)
      call ftfiou(-1,status)
!      call gagout('E-GET: wrong IMBFITS format.')
      status = 0
      error = .true.
      return
   endif
   call ftgkyj(unit,'NAXIS   ',pr%header%naxis,comment,status)
   call ftgkyl(unit,'SIMPLE  ',pr%header%simple,comment,status)
   call ftgkyj(unit,'BITPIX  ',pr%header%bitpix,comment,status)
   call ftgkyl(unit,'EXTEND  ',pr%header%extend,comment,status)
   call ftgkys(unit,'TELESCOP',pr%header%telescop,comment,status)
   sc%header%telescop = pr%header%telescop
   call ftgkys(unit,'ORIGIN  ',pr%header%origin,comment,status)
   call ftgkys(unit,'CREATOR ',pr%header%creator,comment,status)
   call ftgkys(unit,'DATE-OBS',sc%header%date_obs,comment,status)
   call ftgkyj(unit,'N_OBSP  ',sc%header%nobs,comment,status)
   !
   if (imbftsve.ge.1.2) then
      idxstart = 4
   else
      idxstart = 3
   endif
   !
   hdutype = 2
   call ftmnhd(unit,hdutype,'IMBF-scan',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   !
   call ftgkyd(unit,'SITELONG',sc%header%sitelong,comment,status)
   call ftgkyd(unit,'SITELAT ',sc%header%sitelat,comment,status)
   call ftgkye(unit,'SITEELEV',sc%header%siteelev,comment,status)
   call ftgkys(unit,'OBSID   ',sc%header%obsid,comment,status)
   call ftgkys(unit,'PROJID  ',sc%header%projid,comment,status)
   call ftgkyj(unit,'SCANNUM ',sc%header%scannum,comment,status)
   call ftgkys(unit,'OBJECT  ',sc%header%object,comment,status)
   call ftgkyd(unit,'MJD     ',sc%header%mjd,comment,status)
   call ftgkyd(unit,'LST     ',sc%header%lst,comment,status)
!  call ftgkyj(unit,'N_OBS   ',sc%header%nobs,comment,status)
!  commented out by H.W.
   call ftgkyj(unit,'NFEBE   ',sc%header%nfebe,comment,status)
   sc%header%nfebe = ncf
   sc%header%taiutc = 32d0     ! will change in future due to leap seconds
   call ftgkyd(unit,'ETUTC   ',sc%header%etutc,comment,status)
   ! sc%header%scanlen, sc%header%scanskew still to be checked in
   sc%header%scanline = sc%header%nobs
   !
   if (subscanRange(1).eq.0.and.subscanRange(2).eq.0) then
     nsubscan = sc%header%nobs
     subscanRange(1) = 1
     subscanRange(2) = nsubscan
   else if (subscanRange(2).lt.subscanRange(1).or. &
 &          subscanRange(1).le.0.or.subscanRange(2).le.0.or. &
 &          subscanRange(2).gt.sc%header%nobs) then
     call gagout('W-GET: invalid subscan range. Reading all subscans.')
     nsubscan = sc%header%nobs
     subscanRange(1) = 1
     subscanRange(2) = nsubscan
   else
     nsubscan = subscanRange(2)-subscanRange(1)+1
   endif
   !
   call ftthdu(unit,nhdu,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   if ((nhdu-idxstart)/nsubscan.lt.3) then
      call gagout('E-GET: input file ')
      call gagout('       '//trim(filename))
      call gagout('       is incomplete.')
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   !
   !
   if (firstifb.eq.1) then
      allocate(raw(nsubscan),stat=ier)
      do i = 1, nsubscan
         allocate(   &
           raw(i)%antenna(nfb),   &
           raw(i)%backend(nfb),   &
           raw(i)%subref(nfb),   &
           stat=ier)
      enddo
   endif
   !
   call ftgkys(unit,'CTYPE1  ',sc%header%ctype1,comment,status)
   call ftgkys(unit,'CTYPE2  ',sc%header%ctype2,comment,status)
   call ftgkys(unit,'RADESYS ',sc%header%radecsys,comment,status)
   call ftgkye(unit,'EQUINOX ',sc%header%equinox,comment,status)
!! nochmals
!!   sc%header%ctype1 = 'RA-SFL'
!!   sc%header%ctype2 = 'DEC-SFL'
   call ftgkyd(unit,'CRVAL1  ',sc%header%crval1,comment,status)
   call ftgkyd(unit,'CRVAL2  ',sc%header%crval2,comment,status)
   call ftgkyd(unit,'LONPOLE ',sc%header%lonpole,comment,status)
   call ftgkyd(unit,'LATPOLE ',sc%header%latpole,comment,status)
   call ftgkyd(unit,'LONGOBJ ',sc%header%longobj,comment,status)
   call ftgkyd(unit,'LATOBJ  ',sc%header%latobj,comment,status)
   !
   noffset = 0
   status = 0
   if (imbftsve.ge.1.2) then
      call ftgkyj(unit,'NOSWITCH',nphases,comment,status)
      call ftgkys(unit,'SWTCHMOD',swtchmod,comment,status)
      call ftgkyj(unit,'NAXIS2',noffset,comment,status)
      if (noffset.ne.0) then
         if (allocated(flagvals)) deallocate(flagvals)
         allocate(flagvals(noffset),stat=ier)
         allocate(sc%data%longoff(noffset),stat=ier)
         allocate(sc%data%latoff(noffset),stat=ier)
         allocate(sysoff(noffset),stat=ier)
         call ftgcno(unit,.false.,'SYSOFF',idcol,status)
         call ftgcvs(unit,idcol,1,1,noffset,nullstr,sysoff,anynull,   &
           status)
         call ftgcno(unit,.false.,'XOFFSET',idcol,status)
         call ftgcfd(unit,idcol,1,1,noffset,sc%data%longoff,flagvals,   &
           anynull,status)
         call ftgcno(unit,.false.,'YOFFSET',idcol,status)
         call ftgcfd(unit,idcol,1,1,noffset,sc%data%latoff,flagvals,   &
           anynull,status)
         sc%data%longoff = sc%data%longoff*rad2deg
         sc%data%latoff = sc%data%latoff*rad2deg
         deallocate(flagvals)
      endif
   else
      do i = 1, nmxoff
         write(offsetstring,'(A7,I1)') 'XOFFSET', i
         call ftgkey(unit,trim(offsetstring),keystring,comment,   &
           status)
         if (len_trim(keystring).ne.1.and.status.eq.0) then
            noffset = noffset+1
         else
            status = 0
         endif
      enddo
      if (noffset.ne.0) then
         allocate(sc%data%longoff(noffset),stat=ier)
         allocate(sc%data%latoff(noffset),stat=ier)
         allocate(sysoff(noffset),stat=ier)
         do i = 1, noffset
            write(offsetstring,'(A7,I1)') 'XOFFSET', i
            call ftgkyd(unit,trim(offsetstring),sc%data%longoff(i),   &
              comment,status)
            offsetstring(1:1) = 'Y'
            call ftgkyd(unit,trim(offsetstring),sc%data%latoff(i),   &
              comment,status)
            write(offsetstring,'(A6,I1)') 'SYSOFF', i
            call ftgkys(unit,trim(offsetstring),sysoff(i),comment,   &
              status)
            call sic_upper(sysoff(i))
         enddo
         sc%data%longoff = sc%data%longoff*rad2deg
         sc%data%latoff = sc%data%latoff*rad2deg
      endif
   endif
   status = 0
   !
   !      call ftgkyl(unit,'MOVEFRAM',sc%header%movefram,comment,status)
   !      call ftgkyl(unit,'WOBUSED ',sc%header%wobused,comment,status)
   call ftgkyd(unit,'WOBTHROW',sc%header%wobthrow,comment,status)
   call ftgkye(unit,'WOBCYCLE',sc%header%wobcycle,comment,status)
   call ftgkys(unit,'WOBDIR  ',sc%header%wobdir,comment,status)
   call ftgkye(unit,'P1      ',sc%header%ia,comment,status)
   call ftgkye(unit,'P2      ',sc%header%ca,comment,status)
   call ftgkye(unit,'P7      ',sc%header%ie,comment,status)
   if (firstifb.eq.1) then
      allocate(mnt(nfb),stat=ier)
   endif
   call ftgkyd(unit,'P1COR   ',   &
     mnt(firstifb)%header%iaobs_caobs_ieobs(1),comment,status)
   call ftgkyd(unit,'P2COR   ',   &
     mnt(firstifb)%header%iaobs_caobs_ieobs(2),comment,status)
   call ftgkyd(unit,'P7COR   ',   &
     mnt(firstifb)%header%iaobs_caobs_ieobs(3),comment,status)
   mnt(firstifb)%header%iaobs_caobs_ieobs(1:3)   &
     = mnt(firstifb)%header%iaobs_caobs_ieobs(1:3)*rad2deg
   call ftgkyd(unit,'FOCUSX  ',mnt(firstifb)%header%focobs_x_y_z(1),   &
     comment,status)
   call ftgkyd(unit,'FOCUSY  ',mnt(firstifb)%header%focobs_x_y_z(2),   &
     comment,status)
   call ftgkyd(unit,'FOCUSZ  ',mnt(firstifb)%header%focobs_x_y_z(3),   &
     comment,status)
   !
   ! need here sc%header%ia, sc%header%ca, sc%header%npae, sc%header%aw,
   ! sc%header%an, sc%header%ie, sc%header%ecec, sc%header%zflx,
   ! sc%header%scandir
   !
   !
   if (firstifb.eq.1) then
      allocate(sc%data%febe(nfb),stat=ier)
      allocate(fb(nfb),stat=ier)
      allocate(ar(nfb),stat=ier)
      allocate(dt(nfb),stat=ier)
      allocate(reduce(nfb),stat=ier)
   endif
   !
   lastifb = firstifb+sc%header%nfebe-1
   if (lastifb.eq.nfb) sc%header%nfebe = nfb
   !
   if (imbftsve.ge.1.2) then
      call ftmnhd(unit,hdutype,'IMBF-backend',0,status)
   else
      call ftmnhd(unit,hdutype,'IMBF-scan',0,status)
   endif
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkyj(unit,'NAXIS2',nrowbackendtable,comment,status)
   if (nrowbackendtable.eq.0.and.tmpbackend.ne."ABBA") then
      call gagout('E-GET: imbFits scan table is empty.')
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   else if (tmpbackend.eq."ABBA") then
      goto 11
   endif
   allocate(   &
     refchan(nrowbackendtable),chans(nrowbackendtable),   &
     dropped(nrowbackendtable),used(nrowbackendtable),   &
     band(nrowbackendtable),baseband(nrowbackendtable),   &
     pixel(nrowbackendtable),   &
     rec1(nrowbackendtable),rec2(nrowbackendtable),   &
     rec3(nrowbackendtable),   &
     polar(nrowbackendtable),reffreq(nrowbackendtable),   &
     spacing(nrowbackendtable),bandmask(nrowbackendtable),   &
     stat=ier   &
     )
   do i = 1, nrowbackendtable
      rec1(i) = '            '
      rec2(i) = '            '
      rec3(i) = '            '
   enddo
   call ftgcno(unit,.false.,'REFCHAN',idcol,status)
   if (allocated(flagvals)) deallocate(flagvals)
   allocate(flagvals(nrowbackendtable),stat=ier)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,refchan,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'CHANS',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,chans,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'DROPPED',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,dropped,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'USED',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,used,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'BAND',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,band,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'PIXEL',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,pixel,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'REC1',idcol,status)
   call ftgcvs(unit,idcol,1,1,nrowbackendtable,nullstr,rec1,anynull,   &
     status)
   call ftgcno(unit,.false.,'REC2',idcol,status)
   call ftgcvs(unit,idcol,1,1,nrowbackendtable,nullstr,rec2,anynull,   &
     status)
   polmode = count(rec1.ne.rec2).ne.0   &
     .and.index(tmpbackend,'VESPA').ne.0
   if (polmode) then
      do i = 1, nrowbackendtable
         if (index(rec1(i),'A').ne.0.and.index(rec2(i),'B').ne.0)   &
           then
            rec3(i) = rec1(i)//rec2(i)
         else if (index(rec2(i),'A').ne.0.and.index(rec1(i),'B')   &
           .ne.0) then
            rec3(i) = rec2(i)//rec1(i)
         else if (index(rec1(i),'C').ne.0.and.index(rec2(i),'D')   &
           .ne.0) then
            rec3(i) = rec1(i)//rec2(i)
         else if (index(rec2(i),'C').ne.0.and.index(rec1(i),'D')   &
           .ne.0) then
            rec3(i) = rec2(i)//rec1(i)
         else if (rec1(i).eq.rec2(i)) then
            rec3(i) = rec1(i)//rec2(i)
         endif
      enddo
   endif
   call ftgcno(unit,.false.,'POLAR',idcol,status)
   call ftgcvs(unit,idcol,1,1,nrowbackendtable,nullstr,polar,anynull,   &
     status)
   call ftgcno(unit,.false.,'REFFREQ',idcol,status)
   call ftgcfe(unit,idcol,1,1,nrowbackendtable,reffreq,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'SPACING',idcol,status)
   call ftgcfe(unit,idcol,1,1,nrowbackendtable,spacing,flagvals,   &
     anynull,status)
   !
   if (polmode) then
      do i = 2, nrowbackendtable
         do k = 1, i-1
            if (band(i).eq.band(k).and.(rec3(i).ne.rec3(k).or.   &
              polar(i).ne.polar(k))) then
               bandsave = band(i)
               band(i) = maxval(band)+1
               do j = i+1, nrowbackendtable
                  if (rec3(j).eq.rec3(i).and.polar(j).eq.polar(i)   &
                    .and.band(j).eq.bandsave)   &
                    band(j) = band(i)
               enddo
            endif
         enddo
      enddo
   else
      do i = 2, nrowbackendtable
         do k = 1, i-1
            if (band(i).eq.band(k).and.rec1(i).ne.rec1(k)) then
               bandsave = band(i)
               band(i) = maxval(band)+1
               do j = i+1, nrowbackendtable
                  if (rec1(j).eq.rec1(i).and.band(j).eq.bandsave)   &
                    band(j) = band(i)
               enddo
            endif
         enddo
      enddo
   endif
   !
   ncfe = maxval(band)
   k1 = ncfe
   do k = 1, ncfe
      if (count(band.eq.k).eq.0) k1 = k1-1
   enddo
   do k = 1, ncfe
      if (count(band.eq.k).eq.0) then
         do j = 1, nrowbackendtable
            if (band(j).gt.k) band(j) = band(j)-1
         enddo
      endif
   enddo
   ncfe = k1
   !
   k1 = minval(band)
   if (k1.ne.1) then
      do k = 1, nrowbackendtable
         band(k) = band(k)-k1+1
      enddo
   endif
   !
   allocate(part(ncfe),indx(ncfe),irank(ncfe),stat=ier)
   !
   do i = 1, ncfe
      backend = list(currentindex)%backend(i)
      k1 = index(backend,'/')+1
      if (k1.ne.1) then
         k2 = len_trim(backend)
         read(backend(k1:k2),'(i3)') part(i)
      else
         part(i) = i
      endif
   enddo
   call indexx(ncfe,dble(part),indx)
   call rank(ncfe,indx,irank)
   !
   where (pixel(1:nrowbackendtable).eq.0)   &
     pixel(1:nrowbackendtable) = 1
   do i = 1, ncfe
      bandmask = band(1:nrowbackendtable).eq.i.and.   &
        pixel(1:nrowbackendtable).eq.1
      ifb = firstifb+irank(i)-1
      fb(ifb)%header%febeband = count(bandmask)
      do l = 1, maxval(pixel)
         k = 0
         do j = 1, nrowbackendtable
            if (band(j).eq.i.and.pixel(j).eq.l) then
               k = k+1
               baseband(j) = k
            endif
         enddo
      enddo
   enddo
   !
11 continue
   if (tmpbackend.eq."ABBA") then
      ncfe = 1
      allocate(   &
        refchan(1),chans(1),   &
        dropped(1),used(1),   &
        band(1),baseband(1),   &
        pixel(1),   &
        rec1(1),rec2(1),   &
        rec3(1),   &
        polar(1),reffreq(1),   &
        spacing(1),bandmask(1),stat=ier   &
        )
   endif
   !
   hdutype = 2
   nullstr = ' '
   call ftmnhd(unit,hdutype,'IMBF-frontend',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkyj(unit,'SCANNUM ',fb(firstifb)%header%scannum,comment,   &
     status)
   if (imbftsve.lt.1.2) then
      call ftgkyj(unit,'NOSWITCH',fb(firstifb)%header%nphases,   &
        comment,status)
      call ftgkys(unit,'SWTCHMOD',fb(firstifb)%header%swtchmod,   &
        comment,status)
   else
      fb(firstifb)%header%nphases = nphases
      fb(firstifb)%header%swtchmod = swtchmod
   endif
   call ftgkys(unit,'DATE-OBS',fb(firstifb)%header%date_obs,comment,   &
     status)
   call ftgkys(unit,'DEWRTMOD',fb(firstifb)%header%dewrtmod,comment,   &
     status)
   call ftgkye(unit,'DEWANG  ',fb(firstifb)%header%dewang,comment,   &
     status)
   call ftgkys(unit,'VELOCONV',fb(firstifb)%header%veloconv,comment,   &
     status)
   if (status.ne.0) then
      fb(firstifb)%header%veloconv = 'optical'
      status = 0
   endif
   fb(firstifb+1:lastifb)%header%scannum   &
     = fb(firstifb)%header%scannum
   fb(firstifb+1:lastifb)%header%nphases   &
     = fb(firstifb)%header%nphases
   fb(firstifb+1:lastifb)%header%date_obs   &
     = fb(firstifb)%header%date_obs
   fb(firstifb+1:lastifb)%header%swtchmod   &
     = fb(firstifb)%header%swtchmod
   call sic_upper(fb(firstifb)%header%veloconv)
   fb(firstifb+1:lastifb)%header%veloconv   &
     = fb(firstifb)%header%veloconv
   call sic_upper(fb(firstifb)%header%dewrtmod)
   if (index(fb(firstifb)%header%dewrtmod,'C').eq.1.or.   &
       index(fb(firstifb)%header%dewrtmod,'F').eq.1) then
      fb(firstifb)%header%dewrtmod = 'CABIN'
   else if (index(fb(firstifb)%header%dewrtmod,'S').eq.1) then
      fb(firstifb)%header%dewrtmod = 'EQUA'
   else if (index(fb(firstifb)%header%dewrtmod,'H').eq.1) then
      fb(firstifb)%header%dewrtmod = 'HORIZ'
   else
      fb(firstifb)%header%dewrtmod = 'UNDEF'
   endif
   fb(firstifb+1:lastifb)%header%dewrtmod   &
     = fb(firstifb)%header%dewrtmod
   fb(firstifb+1:lastifb)%header%dewang   &
     = fb(firstifb)%header%dewang
   !
   if (index(sc%header%telescop,'30m').ne.0) then
      fb(firstifb:lastifb)%header%dewcabin = 'NASMYTH_A'
   else
      fb(firstifb:lastifb)%header%dewcabin = 'UNDEFINED'
   endif
   !
   call ftgkyj(unit,'NAXIS2',nrowfrontendtable,comment,status)
   allocate(nfeeds(nrowfrontendtable),sideband(nrowfrontendtable),   &
     beameff(nrowfrontendtable), etafss(nrowfrontendtable),   &
     gainimag(nrowfrontendtable), tcold(nrowfrontendtable),   &
     restfreq(nrowfrontendtable),sbsep(nrowfrontendtable),   &
     widenar(nrowfrontendtable),recname(nrowfrontendtable),   &
     linename(nrowfrontendtable),poltype(nrowfrontendtable),   &
     ifcenter(nrowfrontendtable),frqoff1(nrowfrontendtable),   &
     frqoff2(nrowfrontendtable),frqthrow(nrowfrontendtable),   &
     stat=ier)
   !
   if (tmpbackend.ne."ABBA") then
      call ftgkyd(unit,'VELOSYS',velosys,comment,status)
      call ftgkys(unit,'SPECSYS',specsys,comment,status)
      call ftgcno(unit,.false.,'LINENAME',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,linename,   &
        anynull, status)
      call ftgcno(unit,.false.,'BEAMEFF',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,beameff,   &
        anynull,status)
      call ftgcno(unit,.false.,'ETAFSS',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,etafss,   &
        anynull,status)
      call ftgcno(unit,.false.,'GAINIMAG',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,gainimag,   &
        anynull,status)
      call ftgcno(unit,.false.,'SIDEBAND',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,   &
        sideband,anynull,status)
      call ftgcno(unit,.false.,'SBSEP',idcol,status)
      call ftgcvd(unit,idcol,1,1,nrowfrontendtable,nullval,sbsep,   &
        anynull,status)
      call ftgcno(unit,.false.,'WIDENAR',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,widenar,   &
        anynull,status)
      call ftgcno(unit,.false.,'TCOLD',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,tcold,   &
        anynull,status)
      call ftgcno(unit,.false.,'NOFEEDS',idcol,status)
      call ftgcvj(unit,idcol,1,1,nrowfrontendtable,nullval,nfeeds,   &
        anynull,status)
      call ftgcno(unit,.false.,'POLA',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,poltype,   &
        anynull,status)
      call ftgcno(unit,.false.,'IFCENTER',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,ifcenter,   &
        anynull,status)
      call ftgcno(unit,.false.,'FRQTHROW',idcol,status)
      if (idcol.ne.0) call ftgcve(unit,idcol,1,1,nrowfrontendtable,   &
        nullval,frqthrow,anynull,status)
      call ftgcno(unit,.false.,'FRQOFF1',idcol,status)
      if (idcol.ne.0) call ftgcve(unit,idcol,1,1,nrowfrontendtable,   &
        nullval,frqoff1,anynull,status)
      call ftgcno(unit,.false.,'FRQOFF2',idcol,status)
      if (idcol.ne.0) call ftgcve(unit,idcol,1,1,nrowfrontendtable,   &
        nullval,frqoff2,anynull,status)
      call ftgcno(unit,.false.,'RECNAME',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,recname,   &
        anynull, status)
   else
      call ftgcno(unit,.false.,'RECNAME',idcol,status)
      if (idcol.ne.0) call ftgcvs(unit,idcol,1,1,nrowfrontendtable,   &
        nullstr,rec1,anynull,status)
      call ftgkyj(unit,'NUSEFEED',nfeeds,comment,status)
      chans(1) = 1
      spacing(1) = 0.
      used(1) = 1
      dropped(1) = 0
      recname(1) = rec1(1)
      frqoff1(1) = 0.
      frqoff2(1) = 0.
      beameff(1) = 1.0
      etafss(1) = 1.0
      fb(1)%header%febeband = 1
      linename(1) = ' '
   endif
   call ftgcno(unit,.false.,'RESTFREQ',idcol,status)
   call ftgcvd(unit,idcol,1,1,nrowfrontendtable,nullval,restfreq,   &
     anynull,status)
   !
   do ifb = firstifb, lastifb
      nbd = fb(ifb)%header%febeband
      allocate(ar(ifb)%header(nbd),ar(ifb)%data(nbd),stat=ier)
   enddo
   !
   if (allocated(foundfebe)) deallocate(foundfebe,stat=ier)
   allocate(foundfebe(nfb),stat=ier)
   foundfebe(1:nfb) = .false.
   !
   if (allocated(tcoldmon)) deallocate(tcoldmon,stat=ier)
   allocate(tcoldmon(nfb),stat=ier)
   !
   do i = 1, nrowbackendtable
      if (tmpbackend.ne."ABBA") then
         k = band(i)
         ifb = firstifb+irank(k)-1
      else
         band(1) = 1
         ifb = 1
         foundfebe(1) = .false.
         fb(ifb)%header%ifcenter = 0.
      endif
      if (foundfebe(ifb)) cycle
      nbd = fb(ifb)%header%febeband
      do j = 1, nrowfrontendtable
         if (index(recname(j),rec1(i)).ne.0) then
            !
            tmpfrontend = recname(j)
            if (polmode) then
               if (index(polar(i),'REAL').ne.0) then
                  tmpfrontend(1:1) = 'R'
               else if (index(polar(i),'IMAG').ne.0) then
                  tmpfrontend(1:1) = 'I'
               else if (index(polar(i),'AXIS').ne.0) then
                  if (index(rec1(i),'A').ne.0.or.   &
                      index(rec1(i),'C').ne.0) then
                     tmpfrontend(1:1) = 'V'
                  else if (index(rec1(i),'B').ne.0.or.   &
                           index(rec1(i),'D').ne.0) then
                     tmpfrontend(1:1) = 'H'
                  endif
               endif
            endif
            !
            npix = nfeeds(j)
            if (npix.le.0) npix = 1
            allocate(fb(ifb)%data%usefeed(npix),   &
                     fb(ifb)%data%feedtype(npix),   &
                     fb(ifb)%data%feedoffx(npix),   &
                     fb(ifb)%data%feedoffy(npix),   &
                     fb(ifb)%data%polty(npix),   &
                     fb(ifb)%data%pola(npix),   &
                     fb(ifb)%data%apereff(npix,nbd),   &
                     fb(ifb)%data%bolcalfc(npix),   &
                     fb(ifb)%data%flatfiel(npix,nbd),   &
                     fb(ifb)%data%gainimag(npix,nbd),   &
                     fb(ifb)%data%beameff(npix,nbd),   &
                     fb(ifb)%data%etafss(npix,nbd),   &
                     fb(ifb)%data%hpbw(npix,nbd),   &
                     fb(ifb)%data%antgain(npix,nbd),   &
                     fb(ifb)%data%gainele1(nbd),   &
                     fb(ifb)%data%gainele2(nbd),   &
              stat=ier)
            fb(ifb)%header%febefeed = npix
            fb(ifb)%header%nusefeed = npix
            fb(ifb)%header%ifcenter = ifcenter(j)*1.d9
            fb(ifb)%header%frqoff1 = frqoff1(j)*1.e9
            fb(ifb)%header%frqoff2 = frqoff2(j)*1.e9
            fb(ifb)%header%frqthrow = frqthrow(j)*1.e9
            if (index(poltype(j),'vertical').ne.0) then
               fb(ifb)%data%polty(1:npix) = 'Y'
            else if (index(poltype(j),'horizontal').ne.0) then
               fb(ifb)%data%polty(1:npix) = 'X'
            else
               fb(ifb)%data%polty(1:npix) = 'U'
            endif
            backend = list(currentindex)%backend(band(i))
            tmpbackend = backend
            call sic_upper(tmpbackend)
            sc%data%febe(ifb) = trim(tmpfrontend)//' '//trim(backend)
            fb(ifb)%header%febe = sc%data%febe(ifb)
            ar(ifb)%header(1:nbd)%febe = sc%data%febe(ifb)
            ar(ifb)%header(1:nbd)%transiti = linename(j)
            ar(ifb)%header(1:nbd)%molecule = linename(j)
            do ibd = 1, nbd
               ar(ifb)%header(ibd)%restfreq = restfreq(j)*1.d9
               ar(ifb)%header(ibd)%restfreqO = restfreq(j)*1.d9
               ar(ifb)%header(ibd)%sbsep = sbsep(j)
            enddo
            fb(ifb)%data%beameff(1,1) = beameff(j)
            fb(ifb)%data%beameff(1:npix,1:nbd)   &
              = fb(ifb)%data%beameff(1,1)
            fb(ifb)%data%etafss(1,1) = etafss(j)
            fb(ifb)%data%etafss(1:npix,1:nbd)   &
              = fb(ifb)%data%etafss(1,1)
            fb(ifb)%data%gainimag(1,1) = gainimag(j)
            fb(ifb)%data%gainimag(1:npix,1:nbd)   &
              = fb(ifb)%data%gainimag(1,1)
            ar(ifb)%header(1:nbd)%sideband = sideband(j)
            fb(ifb)%header%widenar = widenar(j)
            if (index(sc%header%telescop,'30m').ne.0) then
               fb(ifb)%data%hpbw(1:npix,1:nbd)   &
                 = 2460.d9/ar(ifb)%header(1)%restfreq/3600.
            else
               fb(ifb)%data%hpbw(1:npix,1:nbd) = -1000.
            endif
            fb(ifb)%data%antgain(1:npix,1:nbd) = 0. ! not yet done
            tcoldmon(ifb) = dble(tcold(j))
            !
            exit
         endif
      enddo
      foundfebe(ifb) = .true.
   enddo
   !
   !
   hdutype = 2
   call ftmnhd(unit,hdutype,'IMBF-antenna',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkys(unit,'OBSTYPE ',sc%header%scantype,comment,status)
   call ftgkyd(unit,'SESPES01',sc%header%scanxvel,comment,status)
   sc%header%scanxvel = sc%header%scanxvel*rad2asec
   tmpscantype = sc%header%scantype
   call sic_upper(tmpscantype)
   !
   ! check completeness of subscans
   !
   if (index(tmpscantype,'FOCUS').ne.0.or.index(tmpscantype,'TIP').ne.0) then
      if (sc%header%nobs.lt.6) then
         call gagout('E-GET: '//tmpscantype//' needs at least 6 subscans.')
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
   endif
   !
   if (polmode.and.nsubscan.gt.3.and.index(tmpscantype,'CAL').ne.0)   &
     then
      sc%header%scantype = 'calibGrid'
      tmpscantype = 'CALIBGRID'
   endif
   tmpswitchmode = fb(1)%header%swtchmod
   call sic_upper(tmpswitchmode)
   if (index(tmpscantype,'CAL').ne.0.and.firstifb.eq.1) then
      if (allocated(gn)) then
         do ifb = 1, size(gn)
            call freegains(gn(ifb),error)
         enddo
         deallocate(gn)
      endif
      if (index(tmpswitchmode,'FREQ').ne.0) then
         allocate(gn(2*nfb),stat=ier)
      else
         allocate(gn(nfb),stat=ier)
      endif
   endif
   !
   !
   ndumpantenna = 0
   ndumpantennafast = 0
   ndumpantennanew = 0
   ndumpantennafastnew = 0
   !
   cryoextension = .false.
   derotextension = .false.
   call ftmnhd(unit,hdutype,'IMBF-hera-cryot',0,status)
   if (status.eq.0) then
      cryoextension = .true.
   else
      status = 0
   endif
   call ftmnhd(unit,hdutype,'IMBF-hera-derot',0,status)
   if (status.eq.0) then
      derotextension = .true.
   else
      status = 0
   endif
   !
   if (.not.cryoextension.and..not.derotextension) then
      next       = 3
      idxantenna = 1
      idxsubref  = 2
      idxbackend = 3
   else if (.not.derotextension) then
      next       = 4
      idxantenna = 1
      idxsubref  = 2
      idxcryo    = 3
      idxbackend = 4
   else
      next       = 5
      idxantenna = 1
      idxsubref  = 2
      idxcryo    = 3
      idxderot   = 4
      idxbackend = 5
   endif
   !
   if (allocated(subscantrace)) deallocate(subscantrace,stat=ier)
   allocate(subscantrace(nsubscan),stat=ier)
   !
   ndumpcryo = 0
   ndumpderot = 0
   subscanloop1: do i = subscanRange(1), subscanRange(2)
      j = idxstart+idxantenna+(i-1)*next
      i1 = i-subscanRange(1)+1 
      call ftmahd(unit,j,hdutype,status)
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      call ftgkyj(unit,'TRACERAT',tracerate,comment,status)
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      !
      if (allocated(traceflagdefined))   &
        deallocate(traceflagdefined,stat=ier)
      if (allocated(tmptraceflag))   &
        deallocate(tmptraceflag,stat=ier)
      if (allocated(flagvals)) deallocate(flagvals,stat=ier)
      allocate(flagvals(idump),traceflagdefined(idump),   &
        tmptraceflag(idump),stat=ier)
      !
      ndumpantenna = ndumpantenna+idump
      ndumpantennafast = ndumpantennafast+idump*tracerate
      call ftgkys(unit,'DATE-OBS',subscantime,comment,status)
      call dateobstomjd(subscantime,   &
                        raw(i1)%antenna(firstifb)%subscanstart,   &
                        status)
      call ftgkys(unit,'DATE-END',subscantime,comment,status)
      if (status.ne.0) then
         status = 0
         call ftgkyd(unit,'SUBSTIME',substime,comment,status)
         raw(i1)%antenna(firstifb)%subscanend   &
           = raw(i1)%antenna(firstifb)%subscanstart+substime*sec2day
      else
         call dateobstomjd(subscantime,   &
           raw(i1)%antenna(firstifb)%subscanend,status)
      endif
      call ftgkys(unit,'SYSTEMOF',raw(i1)%antenna(firstifb)%systemoff,   &
        comment,status)
      call ftgkyd(unit,'SUBSXOFF',   &
        raw(i1)%antenna(firstifb)%subscanxoff,comment,   &
        status)
      call ftgkyd(unit,'SUBSYOFF',   &
        raw(i1)%antenna(firstifb)%subscanyoff,comment,   &
        status)
      call ftgkyd(unit,'SEXSTA01',   &
        raw(i1)%antenna(firstifb)%segmentxstart,comment,   &
        status)
      call ftgkyd(unit,'SEYSTA01',   &
        raw(i1)%antenna(firstifb)%segmentystart,comment,   &
        status)
      call ftgkyd(unit,'SEXEND01',   &
        raw(i1)%antenna(firstifb)%segmentxend,comment,   &
        status)
      call ftgkyd(unit,'SEYEND01',   &
        raw(i1)%antenna(firstifb)%segmentyend,comment,   &
        status)
      call ftgkyd(unit,'DOPPLERC',   &
        raw(i1)%antenna(firstifb)%dopplercorr,comment,   &
        status)
      call ftgkyd(unit,'OBSVELRF',raw(i1)%antenna(firstifb)%obsvelrf,   &
        comment,status)
      if (status.ne.0.and.tmpbackend.ne."ABBA") then
         call gagout('W-GET: Doppler correction factor set to 1.')
         raw(i1)%antenna(firstifb)%dopplercorr = 1.0d0
         status = 0
      endif
      call ftgkys(unit,'SBCALREC',   &
        raw(i1)%antenna(firstifb)%sbcalrec,comment,   &
        status)
      if (status.ne.0) then
         raw(i1)%antenna(firstifb)%sbcalrec = 'UNKNOWN'
         status = 0
      else
         call sic_upper(raw(i1)%antenna(firstifb)%sbcalrec)
      endif
      raw(i1)%antenna(firstifb)%trackingerror = trackingcutoff
      raw(i1)%antenna(firstifb+1:lastifb) = raw(i1)%antenna(firstifb)
      call ftgcno(unit,.false.,'TRACEFLAG',idcol,status)
      call ftgcfj(unit,idcol,1,1,idump,tmptraceflag,flagvals,anynull,   &
        status)
      !
      if (idump.ne.0) then
         call medianinteger(tmptraceflag,idump,median)
         subscantrace(i) = int(median)
      else
         write(subscanstring,'(I3)') i
         call gagout('W-GET: subscan '//trim(subscanstring)//   &
                     ' contains no valid antenna data point.')
         subscantrace(i) = 2
      endif
      traceflagdefined = (tmptraceflag.ne.2.and.   &
                          subscantrace(i).eq.tmptraceflag)   &
                          .or.   &
                          index(tmpscantype,'CAL').ne.0
      if (count(traceflagdefined).eq.0) then
         write(subscanstring,'(I3)') i
         call gagout('W-GET: subscan '//trim(subscanstring)//   &
                     ' contains no valid antenna data point.')
      endif
      ndumpantennanew = ndumpantennanew+count(traceflagdefined)
      ndumpantennafastnew = ndumpantennafastnew   &
        +tracerate*count(traceflagdefined)
      !
      j = idxstart+idxsubref+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkys(unit,'DATE-OBS',subscantime,comment,status)
      call dateobstomjd(subscantime,   &
        raw(i1)%subref(firstifb)%subscanstart,status)
      call ftgkys(unit,'DATE-END',subscantime,comment,status)
      if (status.ne.0) then
         status = 0
         call ftgkyd(unit,'SUBSTIME',substime,comment,status)
         raw(i1)%subref(firstifb)%subscanend   &
           = raw(i1)%subref(firstifb)%subscanstart+substime*sec2day
      else
         call dateobstomjd(subscantime,   &
           raw(i1)%subref(firstifb)%subscanend,status)
      endif
      call ftgkyd(unit,'SEXSTA01',   &
        raw(i1)%subref(firstifb)%segmentxstart,comment,   &
        status)
      call ftgkyd(unit,'SEYSTA01',   &
        raw(i1)%subref(firstifb)%segmentystart,comment,   &
        status)
      call ftgkyd(unit,'SEXEND01',   &
        raw(i1)%subref(firstifb)%segmentxend,comment,status)
      call ftgkyd(unit,'SEYEND01',   &
        raw(i1)%subref(firstifb)%segmentyend,comment,status)
      !
      raw(i1)%subref(firstifb+1:lastifb) = raw(i1)%subref(firstifb)
      !
      if (cryoextension) then
         j = idxstart+idxcryo+(i-1)*next
         call ftmahd(unit,j,hdutype,status)
         call ftgkyj(unit,'NAXIS2',idump,comment,status)
         ndumpcryo = ndumpcryo+idump
      endif
      !
      if (derotextension) then
         j = idxstart+idxderot+(i-1)*next
         call ftmahd(unit,j,hdutype,status)
         call ftgkyj(unit,'NAXIS2',idump,comment,status)
         ndumpderot = ndumpderot+idump
      endif
      !
      j = idxstart+idxbackend+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkys(unit,'DATE-OBS',subscantime,comment,status)
      do ifb = firstifb, lastifb
         do ibd = 1, nbd
            ar(ifb)%header(1)%date_obs = subscantime
            ar(ifb)%header(1)%scannum = fb(firstifb)%header%scannum
         enddo
      enddo
      !
      call dateobstomjd(subscantime,   &
        raw(i1)%backend(firstifb)%subscanstart,status)
      call ftgkys(unit,'DATE-END',subscantime,comment,status)
      if (status.ne.0) then
         status = 0
         raw(i1)%backend(firstifb)%subscanend   &
           = raw(i1)%backend(firstifb)%subscanstart
      else
         call dateobstomjd(subscantime,   &
           raw(i1)%backend(firstifb)%subscanend,status)
      endif
      raw(i1)%backend(firstifb+1:lastifb) = raw(i1)%backend(firstifb)
   !
   enddo subscanloop1
   !
   if (.not.timingCheck) then
      ndumpAntennaNew     = ndumpAntenna
      ndumpAntennaFastNew = ndumpAntennaFast
   endif
   !
   if (cryoextension.and.ndumpcryo.ge.1) then
      ! In case of empty tables allocate at least 1 (otherwise ifort crash)
      allocate(crx%mjd(ndumpcryo), crx%cr4k1(ndumpcryo),   &
               crx%cr4k2(ndumpcryo),stat=ier)
   elseif (cryoextension.and.ndumpcryo.lt.1) then
      allocate(crx%mjd(1), crx%cr4k1(1),   &
               crx%cr4k2(1),stat=ier)
      print*,'No data in cryo table'
   endif
   !
   !
   if (derotextension.and.ndumpderot.ge.1) then
      ! In case of empty tables allocate at least 1 (otherwise ifort crash)
      allocate(drt%mjd(ndumpderot), drt%actframe(ndumpderot),   &
        stat=ier)
   elseif (derotextension.and.ndumpderot.lt.1) then
      allocate(drt%mjd(1), drt%actframe(1),   &
        stat=ier)
      print*,'No data in derot table'  
   endif
   !
   !
   ndumpfrontend = 1
   !
   !
   i2 = 0
   i4 = 0
   ndumpsubref = 0
   subscanloop2: do i = subscanRange(1), subscanRange(2)
      j = idxstart+idxsubref+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      ndumpsubref = ndumpsubref+idump
      !
      if (cryoextension) then
         j = idxstart+idxcryo+(i-1)*next
         call ftmahd(unit,j,hdutype,status)
         call ftgkyj(unit,'NAXIS2',idump,comment,status)
         if (allocated(flagvals)) deallocate(flagvals,stat=ier)
         allocate(flagvals(idump),stat=ier)
         i1 = i2+1
         i2 = i2+idump
         call ftgcno(unit,.false.,'MJD',idcol,status)
         call ftgcfd(unit,idcol,1,1,idump,crx%mjd(i1:i2),flagvals,   &
           anynull,status)
         call ftgcno(unit,.false.,'cr4K',idcol,status)
         call ftgcfe(unit,idcol,1,1,idump,crx%cr4k1(i1:i2),flagvals,   &
           anynull,status)
         call ftgcno(unit,.false.,'cr4K2',idcol,status)
         call ftgcfe(unit,idcol,1,1,idump,crx%cr4k2(i1:i2),flagvals,   &
           anynull,status)
      endif
      !
      if (derotextension) then
         j = idxstart+idxderot+(i-1)*next
         call ftmahd(unit,j,hdutype,status)
         call ftgkyj(unit,'NAXIS2',idump,comment,status)
         if (allocated(flagvals)) deallocate(flagvals,stat=ier)
         allocate(flagvals(idump),stat=ier)
         i3 = i4+1
         i4 = i4+idump
         call ftgcno(unit,.false.,'MJD',idcol,status)
         call ftgcfd(unit,idcol,1,1,idump,drt%mjd(i3:i4),flagvals,   &
           anynull,status)
         call ftgcno(unit,.false.,'fAct',idcol,status)
         call ftgcfe(unit,idcol,1,1,idump,drt%actframe(i3:i4),   &
           flagvals,anynull,status)
      endif
   !
   enddo subscanloop2
   !
   !
   if (firstifb.eq.1)   &
     allocate(antdata%encoder_az_el(ndumpantennafast,3),   &
              antdata%tracking_az_el(ndumpantennafast,2),  &
              antdata%slowtrace(ndumpantenna,3),           &
              stat=ier)
   do ifb = firstifb, lastifb
      allocate(mnt(ifb)%data%subscan(ndumpantennanew),   &
               mnt(ifb)%data%subscanfast(ndumpantennafastnew),   &
               mnt(ifb)%data%subscansubref(ndumpsubref),   &
               mnt(ifb)%data%mjd(ndumpantennanew),   &
               mnt(ifb)%data%lst(ndumpantennanew),   &
               mnt(ifb)%data%encoder_az_el(ndumpantennafastnew,3),   &
               mnt(ifb)%data%tracking_az_el(ndumpantennafastnew,2),   &
               mnt(ifb)%data%longoff(ndumpantennanew),   &
               mnt(ifb)%data%latoff(ndumpantennanew),   &
               mnt(ifb)%data%baslong(ndumpantennanew),   &
               mnt(ifb)%data%baslat(ndumpantennanew),   &
               mnt(ifb)%data%parangle(ndumpantennanew),   &
               mnt(ifb)%data%antenna_az_el(2),   &
               mnt(ifb)%data%tamb_p_humid(ndumpfrontend,3),   &
               mnt(ifb)%data%wind_dir_vavg_vmax(ndumpfrontend,3),   &
               mnt(ifb)%data%thotcold(ndumpfrontend,2),   &
               mnt(ifb)%data%refractio(ndumpfrontend),   &
               mnt(ifb)%data%focus_x_y_z(ndumpsubref,4),   &
               mnt(ifb)%data%dfocus_x_y_z(ndumpsubref,3),   &
               mnt(ifb)%data%dphi_x_y_z(ndumpsubref,3),   &
               mnt(ifb)%data%phi_x_y_z(ndumpsubref,3),   &
               stat = ier)
   enddo
   if (allocated(traceflag)) deallocate(traceflag,stat=ier)
   allocate(traceflag(ndumpantennanew),stat=ier)
   !
   hdutype = 2
   idump2 = 0
   subscanloop3: do i = subscanRange(1), subscanRange(2)
      i1 = i-subscanRange(1)+1
      j = idxstart+idxsubref+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      call ftgkys(unit,'SUBSTYPE',   &
        raw(i1)%subref(firstifb)%subscantype,comment,status)
      raw(i1)%subref(firstifb+1:lastifb) = raw(i1)%subref(firstifb)
      idump1 = idump2+1
      idump2 = idump2+idump
      if (allocated(flagvals)) deallocate(flagvals)
      allocate(flagvals(idump),stat=ier)
      if (allocated(tmpfocus)) deallocate(tmpfocus)
      allocate(tmpfocus(idump),stat=ier)
      call ftgkys(unit,'FOTRANSL',focustranslationdirection,comment,   &
        status)
      call sic_upper(focustranslationdirection)
      raw(i1)%subref(firstifb:lastifb)%focustransl   &
        = focustranslationdirection
      call ftgkyd(unit,'FOOFFSET',focusoffset,comment,status)
      do ifb = firstifb, lastifb
         mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,1)   &
           = mnt(firstifb)%header%focobs_x_y_z(1)
         mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,2)   &
           = mnt(firstifb)%header%focobs_x_y_z(2)
         mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,3)   &
           = mnt(firstifb)%header%focobs_x_y_z(3)
         if (index(focustranslationdirection,'X').ne.0) then
            mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,1) =   &
              mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,1)+focusoffset
         else if (index(focustranslationdirection,'Y').ne.0) then
            mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,2) =   &
              mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,2)+focusoffset
         else if (index(focustranslationdirection,'Z').ne.0) then
            mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,3) =   &
              mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,3)+focusoffset
         endif
      enddo

      call ftgcno(unit,.false.,'FOCUS_X',idcol,status)
      do icol = idcol, idcol+2
         call ftgcfd(unit,icol,1,1,idump,tmpfocus,flagvals,anynull,   &
           status)
         do ifb = firstifb, lastifb
            mnt(ifb)%data%focus_x_y_z(idump1:idump2,icol-idcol+1)   &
              = tmpfocus(:)
         enddo
      enddo
      call ftgcno(unit,.false.,'PHI_X',idcol,status)
      do icol = idcol, idcol+2
         call ftgcfd(unit,icol,1,1,idump,tmpfocus,flagvals,anynull,   &
           status)
         do ifb = firstifb, lastifb
            mnt(ifb)%data%phi_x_y_z(idump1:idump2,icol-idcol+1)   &
              = tmpfocus(:)
         enddo
      enddo
      call ftgcno(unit,.false.,'MJD',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,tmpfocus,flagvals,anynull,   &
        status)
      do ifb = firstifb, lastifb
         mnt(ifb)%data%focus_x_y_z(idump1:idump2,4) = tmpfocus(:)
         mnt(ifb)%data%subscansubref(idump1:idump2) = i
      enddo
      raw(i1)%subref(firstifb)%subscanstart =   &
        max(   &
            raw(i1)%subref(firstifb)%subscanstart,   &
            mnt(firstifb)%data%focus_x_y_z(idump1,4)   &
           )
      raw(i1)%subref(firstifb)%subscanend =   &
        min(   &
            raw(i1)%subref(firstifb)%subscanend,   &
            mnt(firstifb)%data%focus_x_y_z(idump2,4)   &
           )
      raw(i1)%subref(firstifb+1:lastifb) = raw(i1)%subref(firstifb)
   !
   enddo subscanloop3
   !
   idump2 = 0
   idump4 = 0
   if (allocated(fastdap)) deallocate(fastdap,stat=ier)
   if (allocated(slowdap)) deallocate(slowdap,stat=ier)
   !
   allocate(fastdap(ndumpantennafast),slowdap(ndumpantenna),   &
     stat=ier)
   !
   subscanloop4: do i = subscanRange(1), subscanRange(2)
      i1 = i-subscanRange(1)+1
      j = idxstart+idxantenna+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      call ftgkys(unit,'SUBSTYPE',   &
        raw(i1)%antenna(firstifb)%subscantype,comment,   &
        status)
      idump1 = idump2+1
      idump2 = idump2+idump
      idump3 = idump4+1
      idump4 = idump4+idump*tracerate
      if (allocated(flagvals)) deallocate(flagvals)
      allocate(flagvals(idump),stat=ier)
      call ftgcno(unit,.false.,'MJD',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%mjd,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'LST',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%lst,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'LONGOFF',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%longoff,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'LATOFF',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%latoff,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'BASLONG',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%baslong,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'BASLAT',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%baslat,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'PARANGLE',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%parangle,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'TRACEFLAG',idcol,status)
      call ftgcfj(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%traceflag,flagvals,anynull,   &
        status)
      slowdap(idump1:idump2)%subscan = i
      !
      if (allocated(flagvals)) deallocate(flagvals)
      allocate(flagvals(idump*tracerate),stat=ier)
      call ftgcno(unit,.false.,'MJDFAST',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%encoder_az_el(3),   &
        flagvals,anynull,status)
      call ftgcno(unit,.false.,'AZIMUTH',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%encoder_az_el(1),   &
        flagvals,anynull,status)
      call ftgcno(unit,.false.,'TRACKING_AZ',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%tracking_az_el(1),   &
        flagvals,anynull,status)
      call ftgcno(unit,.false.,'ELEVATION',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%encoder_az_el(2),   &
        flagvals,anynull,status)
      call ftgcno(unit,.false.,'TRACKING_EL',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%tracking_az_el(2),   &
        flagvals,anynull,status)
      fastdap(idump3:idump4)%subscanfast = i
   !
   enddo subscanloop4
   !
   if (firstifb.eq.1) then
      do m = 1, 3
         antdata%encoder_az_el(1:ndumpantennafast,m) &
 &       = fastdap(1:ndumpantennafast)%encoder_az_el(m)
      enddo
      antdata%encoder_az_el(1:ndumpantennafast,1:2) &
 &    = antdata%encoder_az_el(1:ndumpantennafast,1:2)*rad2deg
      do m = 1, 2
         antdata%tracking_az_el(1:ndumpantennafast,m) &
 &       = fastdap(1:ndumpantennafast)%tracking_az_el(m)*rad2deg
      enddo
      antdata%slowtrace(1:ndumpantenna,1)  &
 &    = slowdap(1:ndumpantenna)%longoff*rad2deg
      antdata%slowtrace(1:ndumpantenna,2)  &
 &    = slowdap(1:ndumpantenna)%latoff*rad2deg
      antdata%slowtrace(1:ndumpantenna,3) = slowdap(1:ndumpantenna)%mjd
   endif

   !
   j = 0
   i2 = 0
   i4 = 0
   do i = 1, ndumpantenna
      i1 = i2+1
      i2 = i2+tracerate
      if((slowdap(i)%traceflag.ne.2.and.                             &
          slowdap(i)%traceflag.eq.subscantrace(slowdap(i)%subscan))  &
         .or.index(tmpscantype,'CAL').ne.0.or..not.timingCheck) then
         j = j+1
         i3 = i4+1
         i4 = i4+tracerate
         do ifb = firstifb, lastifb
            mnt(ifb)%data%mjd(j) = slowdap(i)%mjd
            mnt(ifb)%data%lst(j) = slowdap(i)%lst
            mnt(ifb)%data%longoff(j) = slowdap(i)%longoff
            mnt(ifb)%data%latoff(j) = slowdap(i)%latoff
            mnt(ifb)%data%baslong(j) = slowdap(i)%baslong
            mnt(ifb)%data%baslat(j) = slowdap(i)%baslat
            mnt(ifb)%data%parangle(j) = slowdap(i)%parangle
            traceflag(j) = slowdap(i)%traceflag
            mnt(ifb)%data%subscan(j) = slowdap(i)%subscan
            do m = 1, 3
               mnt(ifb)%data%encoder_az_el(i3:i4,m)   &
                 = fastdap(i1:i2)%encoder_az_el(m)
            enddo
            do m = 1, 2
               mnt(ifb)%data%tracking_az_el(i3:i4,m)   &
                 = fastdap(i1:i2)%tracking_az_el(m)
            enddo
            mnt(ifb)%data%subscanfast(i3:i4)   &
              = fastdap(i1:i2)%subscanfast
         enddo
      endif
   enddo
   !
   ndumpantenna = ndumpantennanew
   ndumpantennafast = ndumpantennafastnew
   !
   do i = 1, nsubscan
      raw(i)%antenna(firstifb+1:lastifb) = raw(i)%antenna(firstifb)
   enddo
   !
   antennaTimingCheck: if (timingCheck) then
      do i = subscanRange(1), subscanRange(2)
         i1 = i-subscanRange(1)+1
         do j = 1, ndumpantenna
            if (mnt(firstifb)%data%subscan(j).eq.i) exit
         enddo
         raw(i1)%antenna(firstifb)%subscanstart   &
           = max(raw(i1)%antenna(firstifb)%subscanstart,   &
           mnt(firstifb)%data%mjd(j))
         do j = ndumpantenna, 1, -1
            if (mnt(firstifb)%data%subscan(j).eq.i) exit
         enddo
         raw(i1)%antenna(firstifb)%subscanend   &
           = min(raw(i1)%antenna(firstifb)%subscanend,   &
           mnt(firstifb)%data%mjd(j))
      enddo
      !
      do i = subscanRange(1), subscanRange(2)
         i1 = i-subscanRange(1)+1
         do j = 1, ndumpantennafast
            if (mnt(firstifb)%data%subscanfast(j).eq.i) exit
         enddo
         raw(i1)%antenna(firstifb)%subscanstart   &
           = max(raw(i1)%antenna(firstifb)%subscanstart,   &
           mnt(firstifb)%data%encoder_az_el(j,3))
         do j = ndumpantennafast, 1, -1
            if (mnt(firstifb)%data%subscanfast(j).eq.i) exit
         enddo
         raw(i1)%antenna(firstifb)%subscanend   &
           = min(raw(i1)%antenna(firstifb)%subscanend,   &
           mnt(firstifb)%data%encoder_az_el(j,3))
         raw(i1)%antenna(firstifb+1:lastifb) = raw(i1)%antenna(firstifb)
      enddo
      !
   endif antennaTimingCheck
   !
   !
   febe_loop1: do ifb = firstifb, lastifb
      !
      mnt(ifb)%data%longoff  = rad2deg*mnt(ifb)%data%longoff
      mnt(ifb)%data%latoff   = rad2deg*mnt(ifb)%data%latoff
      mnt(ifb)%data%baslong  = rad2deg*mnt(ifb)%data%baslong
      mnt(ifb)%data%baslat   = rad2deg*mnt(ifb)%data%baslat
      mnt(ifb)%data%parangle = rad2deg*mnt(ifb)%data%parangle
      mnt(ifb)%data%encoder_az_el(1:ndumpantennafast,1:2)   &
        = mnt(ifb)%data%encoder_az_el(1:ndumpantennafast,1:2)*rad2deg
      mnt(ifb)%data%tracking_az_el   &
        = mnt(ifb)%data%tracking_az_el*rad2deg
      mnt(ifb)%data%antenna_az_el(:)   &
        = mnt(ifb)%data%encoder_az_el(1,:)
      !
      !
      !
      fb(ifb)%data%usefeed(1) = 1
      fb(ifb)%data%reffeed = 1
      if (index(fb(ifb)%header%febe,'HER') /= 0 ) then
         fb(ifb)%data%reffeed = 5
         do i = 1, npix
            fb(ifb)%data%usefeed(1) = i
         enddo
         if (index(tmpfrontend,'VERTICAL').ne.0) then
            fb(ifb)%data%pola(1:npix) = 0.
         else if (index(tmpfrontend,'HORIZONTAL').ne.0) then
            fb(ifb)%data%pola(1:npix) = 90.
         endif
         !
         posanghera = fb(ifb)%header%dewang/rad2deg
         if (index(fb(ifb)%header%dewrtmod,'CABIN').ne.0) then
            fb(ifb)%data%feedoffx   &
              =  xhera(:)*cos(posanghera)-yhera(:)*sin(posanghera)
            fb(ifb)%data%feedoffy   &
              =  xhera(:)*sin(posanghera)+yhera(:)*cos(posanghera)
         else if (index(fb(ifb)%header%dewrtmod,'HORIZ').ne.0) then
            fb(ifb)%data%feedoffx   &
              =  xhera(:)*cos(posanghera)-yhera(:)*sin(posanghera)
            fb(ifb)%data%feedoffy   &
              =  xhera(:)*sin(posanghera)+yhera(:)*cos(posanghera)
         else if (index(fb(ifb)%header%dewrtmod,'EQUA').ne.0) then
            fb(ifb)%data%feedoffx   &
              = -xhera(:)*cos(posanghera)+yhera(:)*sin(posanghera)
            fb(ifb)%data%feedoffy   &
              =  xhera(:)*sin(posanghera)+yhera(:)*cos(posanghera)
         else
            fb(ifb)%data%feedoffx = 0.
            fb(ifb)%data%feedoffy = 0.
         endif
         fb(ifb)%data%feedoffx = fb(ifb)%data%feedoffx(:)/3.6d+3
         fb(ifb)%data%feedoffy = fb(ifb)%data%feedoffy(:)/3.6d+3
      !
      else
         if (index(tmpfrontend,'H').eq.1) then
            fb(ifb)%data%pola(1) = 90.
         else if (index(tmpfrontend,'V').eq.1) then
            fb(ifb)%data%pola(1) = 0.
         endif
         fb(ifb)%data%feedoffx(1) = 0.
         fb(ifb)%data%feedoffy(1) = 0.
      endif
   !
   enddo febe_loop1
   !
   hdutype = 2
   call ftmnhd(unit,hdutype,'IMBF-scan',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkyd(unit,'THOT',tmpcalib,comment,status)
   do ifb = firstifb, lastifb
      mnt(ifb)%data%thotcold(1,1) = tmpcalib
   enddo
   call ftgkyd(unit,'REFRACTI',tmpcalib,comment,status)
   do ifb = firstifb, lastifb
      mnt(ifb)%data%refractio(1) = tmpcalib
   enddo
   call ftgkyd(unit,'TEMPERAT',tmpcalib,comment,status)
   if (status.ne.0) then
      status = 0
      call ftgkyd(unit,'TAMBIENT',tmpcalib,comment,status)
   endif
   do ifb = firstifb, lastifb
      mnt(ifb)%data%tamb_p_humid(1,1) = tmpcalib
   enddo
   call ftgkyd(unit,'PRESSURE',tmpcalib,comment,status)
   do ifb = firstifb, lastifb
      mnt(ifb)%data%tamb_p_humid(1,2) = tmpcalib
   enddo
   call ftgkyd(unit,'HUMIDITY',tmpcalib,comment,status)
   do ifb = firstifb, lastifb
      mnt(ifb)%data%tamb_p_humid(1,3) = tmpcalib
   enddo
   !
   !
   call ftgkyd(unit,'WINDDIR',tmpcalib,comment,status)
   if (status /= 0) then
      status = 0
      do ifb = firstifb, lastifb
         mnt(ifb)%data%wind_dir_vavg_vmax(1,1:3) = 0.0
      enddo
   else
      do ifb = firstifb, lastifb
         mnt(ifb)%data%wind_dir_vavg_vmax(1,1) = tmpcalib
      enddo
      call ftgkyd(unit,'WINDVEL',tmpcalib,comment,status)
      do ifb = firstifb, lastifb
         mnt(ifb)%data%wind_dir_vavg_vmax(1,2) = tmpcalib
      enddo
      call ftgkyd(unit,'WINDVELM',tmpcalib,comment,status)
      do ifb = firstifb, lastifb
         mnt(ifb)%data%wind_dir_vavg_vmax(1,3) = tmpcalib
      enddo
   endif
   !
   !
   hdutype = 2
   call ftmnhd(unit,hdutype,'IMBF-antenna',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkyj(unit,'SCANNUM',mnt(firstifb)%header%scannum,comment,   &
     status)
   call ftgkys(unit,'DATE-OBS',mnt(firstifb)%header%date_obs,comment,   &
     status)
   mnt(firstifb)%header%obsnum = currentindex
   !
   do ifb = firstifb+1, lastifb
      mnt(ifb)%header = mnt(firstifb)%header
   enddo
   do ifb = firstifb, lastifb
      mnt(ifb)%data%thotcold(1,2) = tcoldmon(ifb)
   enddo
   !
   nrecords = 0
   hdutype = 2
   do i = subscanRange(1), subscanRange(2) 
      j = idxstart+idxbackend+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      if (i.eq.1) then
         !
         call ftgkys(unit,'TFORM3',dataformat,comment,status)
         call sic_upper(dataformat)
         !
         call ftgkyj(unit,'CHANNELS',allchannels,comment,status)
         if (allocated(iddump)) deallocate(iddump,stat=ier)
         allocate(iddump(allchannels,5),stat=ier)
         if (allocated(flagvals)) deallocate(flagvals,stat=ier)
         allocate(flagvals(allchannels),stat=ier)
         if (allocated(intdata)) deallocate(intdata,stat=ier)
         if (allocated(realdata)) deallocate(realdata,stat=ier)
         if (allocated(doubledata)) deallocate(doubledata,stat=ier)
         if (index(dataformat,'J').ne.0) then
            allocate(intdata(allchannels),stat=ier)
         else if (index(dataformat,'E').ne.0) then
            allocate(realdata(allchannels),stat=ier)
         else if (index(dataformat,'D').ne.0) then
            allocate(doubledata(allchannels),stat=ier)
         endif
      endif
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      !
      if (idump.eq.0) then
         write(subscanstring,'(I3)') i
         j = index(fb(firstIfb)%header%febe,' ')
         tmpbackend(1:5) = fb(firstIfb)%header%febe(j+1:j+5)
         call gagout('W-GET: no '//tmpbackend(1:5)//          &
                     ' data in subscan '//subscanstring(1:3)//'.')
      endif
      !
      if (imbftsve.lt.1.2)   &
        call ftgkyj(unit,'NPHASES',nphases,comment,status)
      nrecords = nrecords+int(idump/nphases)
   !
   enddo
   !
   if (nrecords.eq.0) then
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      j = index(fb(firstIfb)%header%febe,' ')
      tmpbackend(1:5) = fb(firstIfb)%header%febe(j+1:j+5)
      call gagout('W-GET: no '//tmpbackend(1:5)//' data in this scan.')
      call sic_upper(tmpbackend)
      if (index(tmpbackend(1:5),'VESPA').ne.0.or.index(tmpbackend(1:5),'WILMA').ne.0) &
 &       error = .true.
      return
   endif
   !
   if (index(tmpbackend,'ABBA').eq.0) then
      !
      do i = 1, nrowbackendtable
         !
         ifb = firstifb+irank(band(i))-1
         if (index(tmpbackend,'CONT').ne.0) then
            iddump(i,1) = ifb
            iddump(i,2) = baseband(i)
            iddump(i,3) = pixel(i)
            iddump(i,4) = 1
         else if (index(tmpbackend,'BBC').ne.0) then
            iddump(i,1) = ifb
            iddump(i,2) = baseband(i)
            iddump(i,3) = pixel(i)
            iddump(i,4) = 1
         else if (index(tmpbackend,'NBC').ne.0) then
            iddump(i,1) = ifb
            iddump(i,2) = baseband(i)
            iddump(i,3) = pixel(i)
            iddump(i,4) = 1
         else
            do j = refchan(i), refchan(i)+chans(i)-1
               iddump(j,1) = ifb
               iddump(j,2) = baseband(i)
               iddump(j,3) = pixel(i)
               iddump(j,4) = j-refchan(i)+1
               if (polmode) then
                  if (index(polar(i),'IMAG').ne.0.and.   &
                      index(rec1(i),'A').ne.0.and.index(rec2(i),'B')   &
                      .ne.0) then
                     iddump(j,5) = -1
                  else if (index(polar(i),'IMAG').ne.0.and.   &
                           index(rec1(i),'C').ne.0.and.index(rec2(i),'D')   &
                           .ne.0) then
                     iddump(j,5) = -1
                  else
                     iddump(j,5) = 1
                  endif
               endif
            enddo
         endif
      !
      enddo
   !
   else if (index(tmpbackend,'ABBA').ne.0) then
      !
      iddump(1:allchannels,1) = 1
      iddump(1:allchannels,2) = 1
      do m = 1, allchannels
         iddump(m,3) = m
      enddo
      iddump(1:allchannels,4) = 1
      iddump(1:allchannels,5) = 1
   !
   endif
   !
   !
   !
   do jfb = 1, lastifb-firstifb+1
      !
      if (index(tmpbackend,'ABBA').ne.0) then
         ifb = jfb
      else
         ifb = firstifb+irank(jfb)-1
      endif
      !
      fmin = 1.d12
      fmax = 0.d0
      !
      nbd = fb(ifb)%header%febeband
      npix = fb(ifb)%header%febefeed
      nphases = fb(ifb)%header%nphases
      do ibd = 1, nbd
         do i = 1, nrowbackendtable
            if (index(tmpbackend,'CONT').ne.0.or.   &
                index(tmpbackend,'BBC').ne.0.or.   &
                index(tmpbackend,'NBC').ne.0.or.   &
                index(tmpbackend,'ABBA').ne.0) then
               j = i
            else
               j = refchan(i)
            endif
            if (iddump(j,1).eq.ifb.and.iddump(j,2).eq.ibd) exit
         enddo
         ar(ifb)%header(ibd)%channels = chans(i)
         ar(ifb)%header(ibd)%usedchan = used(i)
         ar(ifb)%header(ibd)%dropchan = dropped(i)
         ar(ifb)%header(ibd)%baseband = ibd
         ar(ifb)%header(ibd)%crvl4f_2   &
           = reffreq(i)*1.d6   &
            +ar(ifb)%header(ibd)%restfreq   &
            -fb(ifb)%header%ifcenter
         aux = spacing(i)*1.e6
         ar(ifb)%header(ibd)%cd4f_21 = aux
         ar(ifb)%header(ibd)%bandwid = abs(used(i)*aux)
         !
         if (index(tmpbackend,'4MHZ').ne.0.or.   &
             index(tmpbackend,'1MHZ').ne.0.or.   &
             index(tmpbackend,'100K').ne.0.or.   &
             index(tmpbackend,'BBC').ne.0.or.   &
             index(tmpbackend,'NBC').ne.0.or.   &
             index(tmpbackend,'CONT').ne.0) then
            ar(ifb)%header(ibd)%freqres = ar(ifb)%header(ibd)%cd4f_21
         else               ! for parabolic apodization (Welch window)
            ar(ifb)%header(ibd)%freqres   &
              = 1.59*ar(ifb)%header(ibd)%cd4f_21
         endif
         ar(ifb)%header(ibd)%cd4r_21   &
           = -ar(ifb)%header(ibd)%cd4f_21*clight   &
           /ar(ifb)%header(ibd)%restfreq
         ar(ifb)%header(ibd)%cuni4f_2 = 'Hz'
         ar(ifb)%header(ibd)%cuni4r_2 = 'km/s'
         !
         ar(ifb)%header(ibd)%vsou4r_2 = velosys
         ar(ifb)%header(ibd)%spec4r_2 = specsys
         !
         ar(ifb)%header(ibd)%crvl4r_2   &
           = -(reffreq(i)*1.d6-fb(ifb)%header%ifcenter)   &
              /ar(ifb)%header(ibd)%restfreq*clight+velosys
         ar(ifb)%header(ibd)%crpx4f_2 = 1
         ar(ifb)%header(ibd)%crpx4r_2 = 1
         !
         if (ar(ifb)%header(ibd)%cd4f_21.gt.0) then
            f1 = ar(ifb)%header(ibd)%crvl4f_2   &
                +(1+ar(ifb)%header(ibd)%dropchan   &
                   -ar(ifb)%header(ibd)%crpx4f_2)   &
                *ar(ifb)%header(ibd)%cd4f_21
            f2 = ar(ifb)%header(ibd)%crvl4f_2   &
                +(ar(ifb)%header(ibd)%dropchan+used(i)   &
                 -ar(ifb)%header(ibd)%crpx4f_2)   &
                 *ar(ifb)%header(ibd)%cd4f_21
         else
            f2 = ar(ifb)%header(ibd)%crvl4f_2   &
                +(1+ar(ifb)%header(ibd)%dropchan   &
                   -ar(ifb)%header(ibd)%crpx4f_2)   &
                 *ar(ifb)%header(ibd)%cd4f_21
            f1 = ar(ifb)%header(ibd)%crvl4f_2   &
                 +(ar(ifb)%header(ibd)%dropchan   &
                   +used(i)-ar(ifb)%header(ibd)%crpx4f_2)   &
                 *ar(ifb)%header(ibd)%cd4f_21
         endif
         fmin = min(fmin,f1)
         fmax = max(fmax,f2)
         !
         nchan = ar(ifb)%header(ibd)%channels
         allocate(   &
           ar(ifb)%data(ibd)%mjd(nrecords*nphases),   &
           ar(ifb)%data(ibd)%integtim(nrecords*nphases),   &
           ar(ifb)%data(ibd)%iswitch(nrecords,nphases),   &
           ar(ifb)%data(ibd)%data(npix,nchan,nrecords,nphases),   &
           stat=ier)
      !
      enddo
      !
      if (index(tmpbackend,'100K').ne.0) then
         if (ar(ifb)%header(1)%channels.eq.256) then
            dt(ifb)%header%channels = 253
         else
            dt(ifb)%header%channels = ar(ifb)%header(1)%channels
         endif
      else if (index(tmpbackend,'ABBA').ne.0) then
         dt(ifb)%header%channels = 1
      else
         dt(ifb)%header%channels   &
           = (fmax-fmin)/abs(ar(ifb)%header(1)%cd4f_21)+1
      endif
      !
      if (index(tmpscantype,'CAL') /= 0 ) then
         gn(ifb)%febe = fb(ifb)%header%febe
         mxchan = 0
         do ibd = 1, nbd
            nchan = ar(ifb)%header(ibd)%channels
            mxchan = max(mxchan,nchan)
         enddo

         call sic_get_logi('calByChannel',calbychannel,error)
         if (calbychannel) then
            call sic_get_inte('ncalchan',ncalchan,error)
            nxchan = ceiling(mxchan/float(ncalchan))
         else
            nxchan = 1
         endif

         allocate(gn(ifb)%crvl4f_2(nbd),                    &
                  gn(ifb)%channels(nbd),                    &
                  gn(ifb)%cd4f_21(nbd),                     &
                  stat=ier)
         allocate(gn(ifb)%tauzen(nbd,npix,nxchan),          &
                  gn(ifb)%tauzenimage(nbd,npix,nxchan),     &
                  gn(ifb)%tauzendry(nbd,npix,nxchan),       &
                  gn(ifb)%tauzenimagedry(nbd,npix,nxchan),  &
                  gn(ifb)%tauzenwet(nbd,npix,nxchan),       &
                  gn(ifb)%tauzenimagewet(nbd,npix,nxchan),  &
                  gn(ifb)%tatms(nbd,npix,nxchan),           &
                  gn(ifb)%tatmi(nbd,npix,nxchan),           &
                  gn(ifb)%temis(nbd,npix,nxchan),           &
                  gn(ifb)%temii(nbd,npix,nxchan),           &
                  gn(ifb)%tcal(nbd,npix,nxchan),            &
                  gn(ifb)%trx(nbd,npix,nxchan),             &
                  gn(ifb)%tsys(nbd,npix,nxchan),            &
                  gn(ifb)%h2omm(nbd,npix,nxchan),           &
                  stat=ier)
         allocate(gn(ifb)%gainarray(nbd,npix,mxchan),       &
                  gn(ifb)%gainimage(nbd,npix,mxchan),       &
                  gn(ifb)%psky(nbd,npix,mxchan),            &
                  gn(ifb)%phot(nbd,npix,mxchan),            &
                  gn(ifb)%pcold(nbd,npix,mxchan),           &
                  gn(ifb)%phasearray(nbd,npix,mxchan),      &
                  gn(ifb)%pgrid(nbd,npix,mxchan),           &
                  stat=ier)
         gn(ifb)%tsys = -1.
         gn(ifb)%trx  = -1.
         gn(ifb)%tcal = -1.
         gn(ifb)%gainimage(:,:,:)  = 0.0d0
         gn(ifb)%phasearray(:,:,:) = 0.0d0
         if (index(tmpswitchmode,'FREQ').ne.0) then
            allocate(gn(ifb+nfb)%crvl4f_2(nbd),                   &
                     gn(ifb+nfb)%channels(nbd),                   &
                     gn(ifb+nfb)%cd4f_21(nbd),                    &
                     stat=ier)
            allocate(gn(ifb+nfb)%tauzen(nbd,npix,nxchan),         &
                     gn(ifb+nfb)%tauzenimage(nbd,npix,nxchan),    &
                     gn(ifb+nfb)%tauzendry(nbd,npix,nxchan),      &
                     gn(ifb+nfb)%tauzenimagedry(nbd,npix,nxchan), &
                     gn(ifb+nfb)%tauzenwet(nbd,npix,nxchan),      &
                     gn(ifb+nfb)%tauzenimagewet(nbd,npix,nxchan), &
                     gn(ifb+nfb)%tatms(nbd,npix,nxchan),          &
                     gn(ifb+nfb)%tatmi(nbd,npix,nxchan),          &
                     gn(ifb+nfb)%temis(nbd,npix,nxchan),          &
                     gn(ifb+nfb)%temii(nbd,npix,nxchan),          &
                     gn(ifb+nfb)%tcal(nbd,npix,nxchan),           &
                     gn(ifb+nfb)%trx(nbd,npix,nxchan),            &
                     gn(ifb+nfb)%tsys(nbd,npix,nxchan),           &
                     gn(ifb+nfb)%h2omm(nbd,npix,nxchan),          &
                     stat=ier)
            allocate(gn(ifb+nfb)%gainarray(nbd,npix,mxchan),      &
                     gn(ifb+nfb)%gainimage(nbd,npix,mxchan),      &
                     gn(ifb+nfb)%psky(nbd,npix,mxchan),           &
                     gn(ifb+nfb)%phot(nbd,npix,mxchan),           &
                     gn(ifb+nfb)%pcold(nbd,npix,mxchan),          &
                     gn(ifb+nfb)%phasearray(nbd,npix,mxchan),     &
                     gn(ifb+nfb)%pgrid(nbd,npix,mxchan),          &
                     stat=ier)
            gn(ifb+nfb)%tsys = -1.
            gn(ifb+nfb)%trx  = -1.
            gn(ifb+nfb)%tcal = -1.
            gn(ifb+nfb)%gainimage(:,:,:)  = 0.0d0
            gn(ifb+nfb)%phasearray(:,:,:) = 0.0d0
         endif
         !
         !
         do ibd = 1, fb(ifb)%header%febeband
            gn(ifb)%crvl4f_2(ibd) = ar(ifb)%header(ibd)%crvl4f_2
            gn(ifb)%channels(ibd) = ar(ifb)%header(ibd)%channels
            gn(ifb)%cd4f_21(ibd) = ar(ifb)%header(ibd)%cd4f_21
            if (index(tmpswitchmode,'FREQ').ne.0) then
               gn(ifb+nfb)%crvl4f_2(ibd) = ar(ifb)%header(ibd)%crvl4f_2
               gn(ifb+nfb)%channels(ibd) = ar(ifb)%header(ibd)%channels
               gn(ifb+nfb)%cd4f_21(ibd) = ar(ifb)%header(ibd)%cd4f_21
            endif
         enddo
      !
      endif
      dt(ifb)%header%scannum = sc%header%scannum
      dt(ifb)%header%obsnum = currentindex
      dt(ifb)%header%date_obs = fb(ifb)%header%date_obs
      dt(ifb)%header%lst = sc%header%lst
      !
      allocate(dt(ifb)%data%integnum(nrecords),   &
               dt(ifb)%data%subscan(nrecords),   &
               stat=ier)
   !
   enddo
   !
   !
   i1 = 0
   i2 = 0
   subscanloop: do i = subscanRange(1), subscanRange(2) 
      j = idxstart+idxbackend+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      call ftgcno(unit,.false.,'MJD',idcol_mjd,status)
      if (index(tmpbackend,'ABBA').eq.0)   &
        call ftgcno(unit,.false.,'INTEGTIM',idcol_integtim,status)
      call ftgcno(unit,.false.,'ISWITCH',idcol_iswitch,status)
      call ftgcno(unit,.false.,'DATA',idcol_data,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      call ftgkyj(unit,'NPHASES',nphases,comment,status)
      fb(firstifb:lastifb)%header%nphases = nphases
      ndump = nphases*int(idump/nphases)
      dumploop: do k = 1, ndump, nphases
         i1 = i1+1
         do ifb = firstifb, lastifb
            dt(ifb)%data%integnum(i1) = i1
            dt(ifb)%data%subscan(i1) = i
         enddo
         phaseloop: do l = 1, nphases
            irow = k+l-1
            i2 = i2+1
            call ftgcfd(unit,idcol_mjd,irow,1,1,pmjd,   &
              flagscalar,anynull,status)
            !
            if (index(tmpbackend,'ABBA').eq.0)   &
              call ftgcfd(unit,idcol_integtim,irow,1,1,pintegtim,   &
                          flagscalar,anynull,status)
            call ftgcfj(unit,idcol_iswitch,irow,1,1,pswitch,   &
                        flagscalar,anynull,status)
            if (index(dataformat,'J').ne.0) then
               call ftgcfj(unit,idcol_data,irow,1,allchannels,   &
                 intdata,flagvals,anynull,status)
            else if (index(dataformat,'E').ne.0) then
               call ftgcfe(unit,idcol_data,irow,1,allchannels,   &
                 realdata,flagvals,anynull,status)
            else if (index(dataformat,'D').ne.0) then
               call ftgcfd(unit,idcol_data,irow,1,allchannels,   &
                 doubledata,flagvals,anynull,status)
            endif
            do m = 1, allchannels
               ifb = iddump(m,1)
               ibd = iddump(m,2)
               ipix = iddump(m,3)
               ichan = iddump(m,4)
               if (index(dataformat,'J').ne.0) then
                  if (polmode) then
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = intdata(m)*iddump(m,5)
                  else
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = intdata(m)
                  endif
               else if (index(dataformat,'E').ne.0) then
                  if (polmode) then
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = realdata(m)*iddump(m,5)
                  else
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = realdata(m)
                  endif
               else if (index(dataformat,'D').ne.0) then
                  if (polmode) then
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = doubledata(m)*iddump(m,5)
                  else
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = doubledata(m)
                  endif
               endif
            enddo
            do ifb = firstifb, lastifb
               do ibd = 1, fb(ifb)%header%febeband
                  ar(ifb)%data(ibd)%mjd(i2) = pmjd
                  ar(ifb)%data(ibd)%integtim(i2) = pintegtim
               enddo
            enddo
            if ((subscantrace(i).eq.1.and.nphases.gt.1)   &
              .or.   &
              index(tmpscantype,'POINT').ne.0   &
              .or.   &
              index(tmpscantype,'FOCUS').ne.0   &
              ) then
               if (index(fb(firstifb)%header%swtchmod,'beam')   &
                 .ne.0) then
                  if (pswitch.eq.1.or.pswitch.eq.3) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'SKY '
                  else if (pswitch.eq.2.or.pswitch.eq.4) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'LOAD'
                  endif
               else if (index(fb(firstifb)%header%swtchmod,'wob')   &
                 .ne.0) then
                  if (pswitch.eq.1.or.pswitch.eq.3) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'ON  '
                  else if (pswitch.eq.2.or.pswitch.eq.4) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'OFF '
                  endif
               endif
            else if (subscantrace(i).eq.0.and.nphases.gt.1) then
               if (index(fb(firstifb)%header%swtchmod,'beam')   &
                 .ne.0) then
                  if (pswitch.eq.1.or.pswitch.eq.3) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'SKY '
                  else if (pswitch.eq.2.or.pswitch.eq.4) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'LOAD'
                  endif
               else if (index(fb(firstifb)%header%swtchmod,'wob')   &
                 .ne.0) then
                  if (pswitch.eq.1.or.pswitch.eq.3) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'OFF '
                  else if (pswitch.eq.2.or.pswitch.eq.4) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'ON  '
                  endif
               endif
            endif
            if (index(fb(firstifb)%header%swtchmod,'freq').ne.0) then
               if (pswitch.eq.1) then
                  ar(firstifb)%data(1)%iswitch(i1,l) = 'FLO'
               else if (pswitch.eq.2) then
                  ar(firstifb)%data(1)%iswitch(i1,l) = 'FHI'
               endif
            endif
            do ifb = firstifb, lastifb
               do ibd = 1, fb(ifb)%header%febeband
                  ar(ifb)%data(ibd)%iswitch(i1,l)   &
                    = ar(firstifb)%data(1)%iswitch(i1,l)
               enddo
            enddo
         enddo phaseloop
      enddo dumploop
   enddo subscanloop
   !
   if (stepcompress.ne.0) then
      dumptime   &
        = sum(ar(firstifb)%data(1)%integtim(:))/(nrecords*nphases)
      nbin = int(stepcompress/dumptime)
      dumptime = dumptime*nbin
      write(string,'(f6.3)') dumptime
      if (nbin.eq.0) then
         call gagout('I-GET: compression timestep too short,'   &
                   //' nothing changed.')
         nbin = 1
      endif
      if (abs(dumptime-stepcompress).gt.0.01)   &
        call gagout('I-GET: dump time rounded to '   &
                   //string//' s.')
      nrecnew = int(nrecords/nbin)
      allocate(   &
        tmpsubscan(nrecnew),   &
        artmp%mjd(nrecnew*nphases),   &
        artmp%integtim(nrecnew*nphases),   &
        artmp%iswitch(nrecnew,nphases),   &
        artmp%data(npix,nchan,nrecnew,nphases),   &
        stat=ier   &
        )
      allocate(compressmask(nbin),stat=ier)
      fbloop: do ifb = firstifb, lastifb
         bdloop: do ibd = 1, fb(ifb)%header%febeband
            i2 = 0
            i4 = 0
            i6 = 0
            recloop: do j = 1, nrecnew
               i1 = i2+1
               i2 = i2+nbin
               if (ibd.eq.1) tmpsubscan(j) = dt(ifb)%data%subscan(i1)
               i3 = i4+1
               i4 = i4+nbin*nphases
               i5 = i6+1
               i6 = i6+nphases
               do ipix = 1, npix
                  do ichan = 1, nchan
                     do iph = 1, nphases
                        compressmask   &
                          =ar(ifb)%data(ibd)%data(ipix,ichan,i1:i2,iph)   &
                          .ne.blankingraw
                        artmp%data(ipix,ichan,j,iph)   &
                          = sum(   &
                          ar(ifb)%data(ibd)%data(ipix,ichan,i1:i2,iph),   &
                          compressmask)/count(compressmask)
                     enddo
                  enddo
               enddo
               if (ifb.eq.firstifb.and.ibd.eq.1) then
                  do k = 1, nphases
                     artmp%mjd(i5+k-1)   &
                       = ar(ifb)%data(ibd)%mjd(i4+1-k)
                     artmp%integtim(i5+k-1)   &
                       = sum(ar(ifb)%data(ibd)%integtim(i3:i4))
                  enddo
                  artmp%iswitch(j,:)= ar(ifb)%data(ibd)%iswitch(i1,:)
               endif
            enddo recloop
            deallocate(ar(ifb)%data(ibd)%mjd,   &
                       ar(ifb)%data(ibd)%integtim,   &
                       ar(ifb)%data(ibd)%iswitch,   &
                       ar(ifb)%data(ibd)%data,   &
                       stat=ier)
            allocate(   &
              ar(ifb)%data(ibd)%mjd(nrecnew*nphases),   &
              ar(ifb)%data(ibd)%integtim(nrecnew*nphases),   &
              ar(ifb)%data(ibd)%iswitch(nrecnew,nphases),   &
              ar(ifb)%data(ibd)%data(npix,nchan,nrecnew,nphases),   &
              stat=ier)
            ar(ifb)%data(ibd)%mjd = artmp%mjd(:)
            ar(ifb)%data(ibd)%integtim = artmp%integtim(:)
            ar(ifb)%data(ibd)%iswitch = artmp%iswitch(:,:)
            ar(ifb)%data(ibd)%data = artmp%data(:,:,:,:)
         enddo bdloop
         deallocate(dt(ifb)%data%integnum,dt(ifb)%data%subscan,   &
           stat=ier)
         allocate(dt(ifb)%data%integnum(nrecnew),   &
                  dt(ifb)%data%subscan(nrecnew),   &
                  stat=ier)
         dt(ifb)%data%subscan = tmpsubscan(:)
         do j = 1, nrecnew
            dt(ifb)%data%integnum(j) = j
         enddo
      enddo fbloop
      deallocate(tmpsubscan,stat=ier)
      deallocate(artmp%data,artmp%iswitch,artmp%integtim,   &
                 artmp%mjd,stat=ier)
      deallocate(compressmask,stat=ier)
      nrecords = nrecnew
   endif
   !
   do i = subscanRange(1), subscanRange(2)
      i1 = i-subscanRange(1)+1
      if (raw(i1)%backend(firstifb)%subscanend   &
        .eq.raw(i1)%backend(firstifb)%subscanstart) then
         nphases = fb(firstifb)%header%nphases
         j = maxval(dt(firstifb)%data%integnum,   &
           dt(firstifb)%data%subscan.eq.i)
         raw(i1)%backend(firstifb)%subscanend   &
           = ar(firstifb)%data(1)%mjd(j*nphases)
      endif
   enddo
   !
   do ifb = firstifb, lastifb
      !
      allocate(dt(ifb)%data%nints(nrecords),   &
               dt(ifb)%data%lst(nrecords),   &
               dt(ifb)%data%longoff(nrecords),   &
               dt(ifb)%data%latoff(nrecords),   &
               dt(ifb)%data%azimuth(nrecords),   &
               dt(ifb)%data%elevatio(nrecords),   &
               dt(ifb)%data%cbaslong(nrecords),   &
               dt(ifb)%data%cbaslat(nrecords),   &
               dt(ifb)%data%baslong(nrecords),   &
               dt(ifb)%data%baslat(nrecords),   &
               dt(ifb)%data%parangle(nrecords),   &
               dt(ifb)%data%pc_11(nrecords),   &
               dt(ifb)%data%pc_12(nrecords),   &
               dt(ifb)%data%pc_21(nrecords),   &
               dt(ifb)%data%pc_22(nrecords),   &
               dt(ifb)%data%cr4k1(nrecords),   &
               dt(ifb)%data%cr4k2(nrecords),   &
               dt(ifb)%data%mcrval1(nrecords),   &
               dt(ifb)%data%mcrval2(nrecords),   &
               dt(ifb)%data%mlonpole(nrecords),   &
               dt(ifb)%data%mlatpole(nrecords),   &
               dt(ifb)%data%mjd(nrecords),   &
               dt(ifb)%data%midtime(nrecords),   &
               dt(ifb)%data%integtim(nrecords),   &
               dt(ifb)%data%dfocus_x_y_z(nrecords,3),   &
               dt(ifb)%data%focus_x_y_z(nrecords,3),   &
               dt(ifb)%data%dphi_x_y_z(nrecords,3),   &
               dt(ifb)%data%phi_x_y_z(nrecords,3),   &
               stat=ier)
      !
      nchan = dt(ifb)%header%channels
      npix = fb(ifb)%header%febefeed
      allocate(dt(ifb)%data%otfdata(npix,nchan,nrecords),   &
               dt(ifb)%data%rdata(npix,nchan),   &
               stat=ier)
      !
      dt(ifb)%data%longoff(1:nrecords) = 0
      dt(ifb)%data%latoff(1:nrecords) = 0
      dt(ifb)%data%nints(1:nrecords) = tracerate
      dt(ifb)%header%febe = fb(ifb)%header%febe
   enddo
   !
   !
   do ifb = firstifb, lastifb
      nphases = fb(ifb)%header%nphases
      do i = 1, nrecords
         dt(ifb)%data%mjd(i)   &
           = ar(ifb)%data(1)%mjd(i*nphases)
         dt(ifb)%data%midtime(i)   &
           = 0.5*(   &
                  dt(ifb)%data%mjd(i)   &
                  +ar(ifb)%data(1)%mjd((i-1)*nphases+1)   &
                  -sec2day*ar(ifb)%data(1)%integtim((i-1)*nphases+1)   &
                 )
         dt(ifb)%data%integtim(i)   &
           = sum(   &
                 ar(ifb)%data(1)%integtim((i-1)*nphases+1:i*nphases)   &
                )
      enddo
   enddo
   !
   !
   do ifb = firstifb, lastifb
      nbd = fb(ifb)%header%febeband
      if (stepcompress.ne.0) then
         nphases = fb(ifb)%header%nphases
         dt(ifb)%data%integtim = dt(ifb)%data%integtim(:)/nphases
         do ibd = 1, nbd
            ar(ifb)%data(ibd)%integtim   &
              = ar(ifb)%data(ibd)%integtim(:)/nphases
         enddo
      endif
      if (fb(ifb)%header%nphases.eq.1.and.   &
        index(tmpscantype,'CAL').eq.0) then
         do iobs = subscanRange(1), subscanRange(2)
            i1 = iobs-subscanRange(1)+1
            do i = 1, nbd
               do j = 1, nrecords
                  if (dt(ifb)%data%subscan(j).eq.iobs.and.   &
                    subscantrace(i1).eq.0) then
                     ar(ifb)%data(i)%iswitch(j,1) = 'ON  '
                  else if (dt(ifb)%data%subscan(j).eq.iobs.and.   &
                    subscantrace(i1).eq.1) then
                     ar(ifb)%data(i)%iswitch(j,1) = 'OFF '
                  else if (dt(ifb)%data%subscan(j).eq.iobs.and.   &
                    subscantrace(i1).eq.2) then
                     ar(ifb)%data(i)%iswitch(j,1) = 'NONE'
                  endif
               enddo
            enddo
         enddo
      endif
   enddo
   !
   !
   if (index(tmpscantype,'CAL') /= 0) then
      !
      do ifb = firstifb, lastifb
         nbd = fb(ifb)%header%febeband
         do iobs = subscanRange(1), subscanRange(2)
            !
            i1 = iobs-subscanRange(1)+1
            if (index(raw(i1)%antenna(ifb)%subscantype,'Sky').ne.0)   &
              then
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'S'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'S'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'SKY '
                        endif
                     endif
                  enddo
               enddo
            else if (index(raw(i1)%antenna(ifb)%subscantype,   &
              'Ambient').ne.0) then
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'H'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'H'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'HOT '
                        endif
                     endif
                  enddo
               enddo
            else if (index(raw(i1)%antenna(ifb)%subscantype,'Cold')   &
              .ne.0) then
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'C'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'C'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'COLD'
                        endif
                     endif
                  enddo
               enddo
            else if (index(raw(i1)%antenna(ifb)%subscantype,'Grid')   &
              .ne.0) then
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'G'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'G'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'GRID'
                        endif
                     endif
                  enddo
               enddo
            else
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'N'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'N'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'NONE'
                        endif
                     endif
                  enddo
               enddo
            endif
         enddo
      !
      enddo
   !
   endif
   !
   !
   if (lastifb.eq.nfb) then
      !
      ! check completeness of subscans
      !
      if (fb(nfb)%header%nphases.eq.1.and.                        &
          count(ar(nfb)%data(1)%iswitch(:,1).eq.'OFF ').eq.0.and. &
          index(tmpscantype,'CAL').eq.0)                          &
         call gagout('W-GET: total power data without sky reference')
      !
      prim  => pr
      scan  => sc
      febe  => fb
      if (cryoextension) then
         cryo  => crx
      else
         cryo => null()
      endif
      if (derotextension) then
         derot => drt
      else
         derot => null()
      endif
   endif
   !
   call ftclos(unit,status)
   call ftfiou(-1,status)
   !
   !
   tmpscantype = sc%header%scantype
   call sic_upper(tmpscantype)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      return
   else if (lastifb.eq.nfb) then
      if (allocated(newpar)) then 
         if (overrideFlag(1).or.overrideFlag(2)) then
            do ifb = 1, nfb
               if (size(mnt(ifb)%data%thotcold).eq.   &
                   size(newpar(ifb)%thotcold)) then
                  mnt(ifb)%data%thotcold = newpar(ifb)%thotcold
               else
                  call gagout('W-GET: shapes of THOTCOLD do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
         if (overrideflag(6).or.overrideflag(7)) then
            do ifb = 1, nfb
               if (size(mnt(ifb)%data%tamb_p_humid).eq.   &
                   size(newpar(ifb)%tamb_p_humid)) then
                  mnt(ifb)%data%tamb_p_humid = newpar(ifb)%tamb_p_humid
               else
                  call gagout('W-GET: shapes of TAMB_P_HUMID do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
         if (overrideflag(3)) then
            do ifb = 1, nfb
               if (size(fb(ifb)%data%etafss).eq.   &
                   size(newpar(ifb)%etafss)) then
                  fb(ifb)%data%etafss = newpar(ifb)%etafss
               else
                  call gagout('W-GET: shapes of ETAFSS do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
         if (overrideflag(4)) then
            do ifb = 1, nfb
               if (size(fb(ifb)%data%beameff).eq.   &
                   size(newpar(ifb)%beameff)) then
                  fb(ifb)%data%beameff = newpar(ifb)%beameff
               else
                  call gagout('W-GET: shapes of BEAMEFF do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
         if (overrideflag(5)) then
            do ifb = 1, nfb
               if (size(fb(ifb)%data%gainimag).eq.   &
                   size(newpar(ifb)%gainimag)) then
                  fb(ifb)%data%gainimag = newpar(ifb)%gainimag
               else
                  call gagout('W-GET: shapes of GAINIMAG do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
      endif 
      call sic_get_logi('timingCheck',timingcheck,error)
      call sic_get_logi('traceExtrapolation',traceExtrapolation,error)
      if (timingCheck) then
         do ifb = 1, nfb
            call syncData(ifb,nfb,subscanRange,error)
         enddo
      else
         do ifb = 1, nfb
            call syncDataNew(ifb,nfb,subscanRange,error)
         enddo
      endif
      !
      data => databuf
      array => arraybuf
      mon => monbuf
      !
      if (index(tmpscantype,'CAL') /= 0 ) gains => gn
      !
      do i = 1, size(dt)
         call freedata(dt(i)%data,error)
      enddo
      deallocate(dt,stat=ier)
      !
      do i = 1, size(ar)
         do j = 1, size(ar(i)%header)
            call freearray(ar(i)%data(j),error)
         enddo
         deallocate(ar(i)%header, ar(i)%data,stat =ier)
      enddo
      deallocate(ar,stat=ier)
      !
      do i = 1, size(mnt)
         call freemon(mnt(i)%data,error)
      enddo
      deallocate(mnt,stat=ier)
      !
      nosky = .false.
      nrecords = size(array(1)%data(1)%iswitch,1)
      call computeoffset(nfb,noffset,nrecords,sysoff,tmpscantype,   &
        tmpswitchmode,nosky,error)
      if (error) return
      !
      ! check completeness of calibration scans
      !
      if (index(tmpscantype,'CAL').ne.0) then
         if (nsubscan.eq.1.or.  &
             (nsubscan.eq.2.and..not.nosky)) then
            call gagout('E-GET: incomplete calibration')
            error = .true.
            return
         endif
      endif
      !
      !
      if (nosky.and.index(tmpscantype,'CAL').ne.0.and.   &
        .not.polmode.and.maxval(data(1)%data%subscan).eq.4) then
         scan%header%scantype = 'calibImage'
         tmpscantype = 'CALIBIMAGE'
         if (.not.allocated(igains)) then
            allocate(igains(nfb),stat=ier)
            do ifb=1, nfb
               mxchan=0
               igains(ifb)%febe = febe(ifb)%header%febe
               nbd = febe(ifb)%header%febeband
               npix = febe(ifb)%header%febefeed
               do ibd = 1, nbd
                  nchan = array(ifb)%header(ibd)%channels
                  mxchan = max(nchan,mxchan)
               enddo
               allocate(igains(ifb)%gainimage(nbd,npix,mxchan),   &
                 stat=ier)
               igains(ifb)%gainimage = 0.d0
            enddo
         endif
         if (index(raw(1)%antenna(firstifb)%sbcalrec,'UNKNOWN').ne.0)   &
           then
            call gagout('W-GET: receiver for image gain calibration '   &
                      //'unknown.')
         else
            call gagout('I-GET: image gain calibration for '//   &
                        trim(raw(1)%antenna(firstifb)%sbcalrec)//'.')
         endif
         call gagout(' ')
         call gagout('Fe/Be          Pixel    gainImage')
         do ifb = 1, nfb
            tmpfrontend = febe(ifb)%header%febe
            call sic_upper(tmpfrontend)
            if (index(tmpfrontend,trim(raw(1)%antenna(ifb)%sbcalrec))   &
              .eq.0.and.   &
              index(raw(1)%antenna(ifb)%sbcalrec,'UNKNOWN')   &
              .eq.0) cycle
            nbd = febe(ifb)%header%febeband
            npix = febe(ifb)%header%febefeed
            do ipix = 1, npix
               gainimage = 0.
               photimagemean = 0.
               pcoldimagemean = 0.
               do ibd = 1, nbd
                  pcoldimage = 0.
                  pcoldsignal = 0.
                  photimage = 0.
                  photsignal = 0.
                  do ichan = array(ifb)%header(ibd)%dropchan+1,   &
                       array(ifb)%header(ibd)%dropchan   &
                       +array(ifb)%header(ibd)%usedchan
                     !
                     pcoldsignalnew = sum(   &
                       array(ifb)%data(ibd)%data(ipix,ichan,:,1),   &
                       data(ifb)%data%subscan(:).le.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'COLD')   &
                       /count(data(ifb)%data%subscan(:).le.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'COLD')
                     pcoldimagenew = sum(   &
                       array(ifb)%data(ibd)%data(ipix,ichan,:,1),   &
                       data(ifb)%data%subscan(:).gt.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'COLD')   &
                       /count(data(ifb)%data%subscan(:).gt.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'COLD')
                     photsignalnew = sum(   &
                       array(ifb)%data(ibd)%data(ipix,ichan,:,1),   &
                       data(ifb)%data%subscan(:).le.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'HOT')   &
                       /count(data(ifb)%data%subscan(:).le.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'HOT')
                     photimagenew = sum(   &
                       array(ifb)%data(ibd)%data(ipix,ichan,:,1),   &
                       data(ifb)%data%subscan(:).gt.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'HOT')   &
                       /count(data(ifb)%data%subscan(:).gt.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'HOT')
                     igains(ifb)%gainimage(ibd,ipix,ichan)   &
                       = (photimagenew-pcoldimagenew)   &
                       /(photsignalnew-pcoldsignalnew)
                     !
                     ! comment the following two lines in for new backends
                     !                         if (gains(ifb)%gainimage(ibd,ipix,ichan).ne.0)
                     !     &                   calByChannel = .true.
                     photimage   = photimage+photimagenew
                     pcoldimage  = pcoldimage+pcoldimagenew
                     photsignal  = photsignal+photsignalnew
                     pcoldsignal = pcoldsignal+pcoldsignalnew
                  enddo
                  photimagemean = photimagemean+photimage   &
                    /array(ifb)%header(ibd)%usedchan
                  pcoldimagemean = pcoldimagemean+pcoldimage   &
                    /array(ifb)%header(ibd)%usedchan
                  gainimage = gainimage+(photimage-pcoldimage)   &
                    /(photsignal-pcoldsignal)   &
                    /array(ifb)%header(ibd)%usedchan
               enddo
               gainimage = gainimage/nbd
               photimagemean  = photimagemean/nbd
               pcoldimagemean = pcoldimagemean/nbd
               if (photimagemean.le.pcoldimagemean) then
                  gainimage = 0.
                  call gagout('W-GET: image/signal ratio is too '   &
                            //'small to measure and set to zero.')
               endif
               write(message,'(T1,A13,T18,I1,T24,f9.4)')   &
                 febe(ifb)%header%febe(1:13), ipix, gainimage
               call gagout(message)
               write(message,'(T1,A26)') '                          '
               call gagout(message)
               write(message,'(T1,A8,T10,A4,T15,A5,T21,F9.4)')   &
                 'RECEIVER',febe(ifb)%header%febe(1:4),'/GAIN',   &
                 gainimage
               call gagout(message)
            enddo
         enddo
         do ifb = 1, nfb
            gains(ifb)%gainimage = igains(ifb)%gainimage
         enddo
      else if (nosky.and.index(tmpscantype,'CAL').ne.0) then
         call gagout(' ')
         call gagout('Fe/Be       Pixel   Trec [K]')
         do ifb = 1 ,nfb
            nbd = febe(ifb)%header%febeband
            npix = febe(ifb)%header%febefeed
            do ipix = 1, npix
               trec = 0
               do ibd = 1, nbd
                  nchan = array(ifb)%header(ibd)%usedchan
                  i1 = array(ifb)%header(ibd)%dropchan+1
                  i2 = array(ifb)%header(ibd)%dropchan   &
                      +array(ifb)%header(ibd)%usedchan
                  if (allocated(calmask)) deallocate(calmask)
                  allocate(calmask(i2-i1+1))
                  if (calbychannel) then
                     calmask   &
                       =gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw   &
                       .and.   &
                       gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
                     do ichan = i1, i2
                        if (calmask(ichan)) then
                           photsignal   &
                             = gains(ifb)%phot(ibd,ipix,ichan)
                           pcoldsignal   &
                             = gains(ifb)%pcold(ibd,ipix,ichan)
                           gains(ifb)%trx(ibd,ipix,ichan)   &
                             =(photsignal*mon(ifb)%data%thotcold(1,2)   &
                             -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                             /(pcoldsignal-photsignal)
                           trec = trec+gains(ifb)%trx(ibd,ipix,ichan)   &
                             /count(calmask)
                        endif
                     enddo
                  else
                     calmask   &
                       =gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw
                     photsignal   &
                       = sum(gains(ifb)%phot(ibd,ipix,i1:i2),calmask)   &
                       /count(calmask)
                     calmask   &
                       =gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
                     pcoldsignal   &
                       = sum(gains(ifb)%pcold(ibd,ipix,i1:i2),calmask)   &
                       /count(calmask)
                     gains(ifb)%trx(ibd,ipix,1)   &
                       = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                       -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                       /(pcoldsignal-photsignal)
                     trec = trec+gains(ifb)%trx(ibd,ipix,1)
                  endif
               enddo
               trec = trec/nbd
               j = index(febe(ifb)%header%febe,' ')
               tmpbackend = febe(ifb)%header%febe(j+1:j+8)
               write(message,'(T1,A5,T7,A5,T15,i1,T21,f7.2)')   &
                 febe(ifb)%header%febe(1:5), tmpbackend(1:5), ipix,   &
                 trec
               call gagout(message)
            enddo
         enddo
         return
      else if (index(tmpscantype,'CAL').ne.0) then
         do ifb = 1 ,nfb
            nbd = febe(ifb)%header%febeband
            npix = febe(ifb)%header%febefeed
            do ipix = 1, npix
               do ibd = 1, nbd
                  nchan = array(ifb)%header(ibd)%usedchan
                  i1 = array(ifb)%header(ibd)%dropchan+1
                  i2 = array(ifb)%header(ibd)%dropchan   &
                      +array(ifb)%header(ibd)%usedchan
                  if (allocated(calmask)) deallocate(calmask)
                  allocate(calmask(i2-i1+1))
                  if (calbychannel) then
                     calmask   &
                       =gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw   &
                       .and.   &
                       gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
                     do ichan =  i1, i2
                        if (calmask(ichan)) then
                           photsignal   &
                             = gains(ifb)%phot(ibd,ipix,ichan)
                           pcoldsignal   &
                             = gains(ifb)%pcold(ibd,ipix,ichan)
                           gains(ifb)%trx(ibd,ipix,ichan)   &
                             = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                             -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                             /(pcoldsignal-photsignal)
                        else
                           gains(ifb)%trx(ibd,ipix,ichan) = -1.
                        endif
                     enddo
                  else
                     calmask   &
                       = gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw
                     photsignal   &
                       = sum(gains(ifb)%phot(ibd,ipix,i1:i2),calmask)   &
                       /count(calmask)
                     calmask   &
                       =gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
                     pcoldsignal   &
                       = sum(gains(ifb)%pcold(ibd,ipix,i1:i2),calmask)   &
                       /count(calmask)
                     gains(ifb)%trx(ibd,ipix,1)   &
                       = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                       -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                       /(pcoldsignal-photsignal)
                  endif
                  if (index(tmpswitchmode,'FREQ').ne.0) then
                     calmask = gains(ifb+nfb)%phot(ibd,ipix,i1:i2)   &
                       .ne.blankingraw
                     photsignal = sum(   &
                       gains(ifb+nfb)%phot(ibd,ipix,i1:i2),calmask   &
                       )/count(calmask)
                     calmask = gains(ifb+nfb)%pcold(ibd,ipix,i1:i2)   &
                       .ne.blankingraw
                     pcoldsignal = sum(   &
                       gains(ifb+nfb)%pcold(ibd,ipix,i1:i2),calmask   &
                       )/count(calmask)
                     gains(ifb+nfb)%trx(ibd,ipix,1)   &
                       = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                       -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                       /(pcoldsignal-photsignal)
                  endif
               enddo
            enddo
         enddo
      endif
   endif
   !
   if (index(tmpscantype,'CAL').ne.0.and.tmpscantype.ne.'CALIBIMAGE'   &
     .and.lastifb.eq.nfb.and.allocated(igains)) then
      do ifb = 1, nfb
         do jfb = 1, size(igains)
            if (gains(ifb)%febe.eq.igains(jfb)%febe)   &
              gains(ifb)%gainimage = igains(jfb)%gainimage
         enddo
      enddo
   endif
   !
   if (.not.associated(zfocus%sol(1)%x)) then
      do i = firstifb, lastifb
         reduce(i)%focus_done = .false.
      enddo
   else
      do i = firstifb, lastifb
         reduce(i)%focus_done = .true.
      enddo
   endif
   !
   if (.not.associated(pcross(1)%sol%x)) then
      do i = firstifb, lastifb
         reduce(i)%pointing_done = .false.
      enddo
   else
      do i = firstifb, lastifb
         reduce(i)%pointing_done = .true.
      enddo
   endif
   !
   if (index(tmpscantype,'POINT').ne.0) then
      do i = firstifb, lastifb
         reduce(i)%pointing_done = .false.
      enddo
   else if (index(tmpscantype,'FOCUS').ne.0) then
      do i = firstifb, lastifb
         reduce(i)%focus_done = .false.
      enddo
   endif
   !
   do i = firstifb, lastifb
      reduce(i)%calibration_done(1:5) = .false.
      reduce(i)%base_done        = .false.
      reduce(i)%despike_done     = .false.
   enddo
   !
   ! bring polarimetry data into order H,V,R,I
   !
   if (polmode) then
      allocate(febetmp(nfb),arraytmp(nfb),datatmp(nfb),gainstmp(nfb),   &
               antennatmp(nfb),backendtmp(nfb),montmp(nfb),   &
               subreftmp(nfb),reducetmp(nfb),   &
               ifbold(nfb),stat=ier)
      nspec = (lastifb-firstifb+1)/4
      j = 0
      do i = firstifb, lastifb, 4
         i1 = index(febe(i)%header%febe,' ')
         i2 = len_trim(febe(i)%header%febe)
         j = j+1
         febetmp(j)%header%febe = febe(i)%header%febe(i1:i2)
      enddo
      do i = 1, nspec
         do j = 1, 4
            k = (i-1)*4+j
            do ifb = firstifb, lastifb
               if (febe(ifb)%header%febe(1:1).eq.stokes(j).and.   &
                   febe(ifb)%header%febe(i1:i2)   &
                   .eq.febetmp(i)%header%febe   &
                 ) then
                  ifbold(k) = ifb
                  exit
               endif
            enddo
         enddo
      enddo
      datatmp(1:nfb) = data(1:nfb)
      data(1:nfb) = datatmp(ifbold(1:nfb))
      montmp(1:nfb) = mon(1:nfb)
      mon(1:nfb) = montmp(ifbold(1:nfb))
      febetmp(1:nfb) = febe(1:nfb)
      febe(1:nfb) = febetmp(ifbold(1:nfb))
      arraytmp(1:nfb) = array(1:nfb)
      array(1:nfb) = arraytmp(ifbold(1:nfb))
      reducetmp(1:nfb) = reduce(1:nfb)
      reduce(1:nfb) = reducetmp(ifbold(1:nfb))
      do ifb = firstifb, lastifb
         scan%data%febe(ifb) = febe(ifb)%header%febe
      enddo
      if (index(tmpscantype,'GRID').ne.0) then
         gainstmp(1:nfb) = gains(1:nfb)
         gains(1:nfb) = gainstmp(ifbold(1:nfb))
         do i = 1, nspec
            i1 = 4*i
            where (gains(i1-3)%gainarray.ne.blankingraw.and.   &
                   gains(i1-2)%gainarray.ne.blankingraw)
               gains(i1)%gainarray   &
                 = sqrt(gains(i1-3)%gainarray*gains(i1-2)%gainarray)
            elsewhere
               gains(i1)%gainarray = blankingraw
            endwhere
            gains(i1-1)%gainarray = gains(i1)%gainarray
         enddo
      endif
      do i = 1, nsubscan
         antennatmp = raw(i)%antenna(:)
         raw(i)%antenna = antennatmp(ifbold(1:nfb))
         backendtmp = raw(i)%backend(:)
         raw(i)%backend = backendtmp(ifbold(1:nfb))
         subreftmp = raw(i)%subref(:)
         raw(i)%subref = subreftmp(ifbold(1:nfb))
      enddo
      deallocate(febetmp,arraytmp,datatmp,montmp,gainstmp)
      deallocate(antennatmp,backendtmp,subreftmp,reducetmp,   &
                 ifbold,stat=ier)
   endif
   !
   !
   !
10 format(t4,a51)
20 format(t4,a1,t20,i1,t29,a17,t54,a1)
   !
   return
!
end subroutine getfits
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_uvsort_command(line,error)
  use wifisyn_interfaces, except_this=>wifisyn_uvsort_command
  use wifisyn_sort_types
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !	UVSORT [U|V|X|Y]
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  !
  integer :: args(m_tot_key)
  !
  call wifisyn_sort_getargs(line,args,error)
  if (error) return
  !
!!$  call wifisyn_sort_uvrt(args,error)
!!$  if (error) return
  !
end subroutine wifisyn_uvsort_command
!
subroutine wifisyn_sort_getargs(line,args,error)
  use gbl_message
  use gio_params
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_sort_getargs
  use wifisyn_gridding_types
  use wifisyn_sort_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer,          intent(out)   :: args(m_tot_key)
  logical,          intent(inout) :: error
  !
  integer :: narg,iarg,larg,num
  character(len=6) :: key,arg
  character(len=*), parameter :: rname = 'SORT'
  !
  ! Sanity check
  narg = sic_narg(0)
  if (narg.gt.m_tot_key) then
     call wifisyn_message(seve%e,rname,'Too many arguments for command SORT')
     error = .true.
     return
  endif
  !
  ! Nullify
  args = code_null
  !
  ! Get them
  if (narg.eq.0) then
     ! Default
     args(1) = code_axis_u
     args(2) = code_axis_v
     args(3) = code_axis_x
     args(4) = code_axis_y
  else
     ! User defined
     do iarg=1,narg
        call sic_ke(line,0,iarg,arg,larg,.true.,error)
        if (error) return
        call sic_ambigs(rname,arg,key,num,known_keys,m_tot_key,error)
        if (error) return
        args(iarg) = num
     enddo
  endif
  !
end subroutine wifisyn_sort_getargs
!
!!$subroutine wifisyn_sort_uvrt(args,error)
!!$  use gbl_message
!!$  use wifisyn_uv_buffer
!!$  use wifisyn_sort_types
!!$  !---------------------------------------------------------------------
!!$  ! @ private
!!$  !---------------------------------------------------------------------
!!$  integer,    intent(in)  :: args(m_tot_key) !
!!$  logical,    intent(out) :: error ! Error status
!!$  !
!!$  integer :: idata
!!$  character(len=80) :: mess
!!$  character(len=*), parameter :: rname = 'SORT/RT'
!!$  !
!!$  ! Sanity check
!!$  if (no_data(rname,uvr%head,error)) return
!!$  !
!!$  ! Swap UVR into UVT buffer
!!$  call wifisyn_uvrt_swap(error)
!!$  if (error) return
!!$  !
!!$  call wifisyn_allocate_inte_1d('idx',uvr%head%type%ndata,sort%idx,error)
!!$  if (error) return
!!$  call wifisyn_allocate_inte_1d('iu',uvr%head%type%ndata,sort%iu,error)
!!$  if (error) return
!!$  call wifisyn_allocate_inte_1d('iv',uvr%head%type%ndata,sort%iv,error)
!!$  if (error) return
!!$  !
!!$  !
!!$  ! Loop on observed data point
!!$  do idata=1,sort%iu%n ! should check iv%n and idx%n
!!$     sort%iu%val(idata) = nint(uref+(htab%u(idata)-uval)/uinc)
!!$     sort%iv%val(idata) = nint(vref+(htab%v(idata)-vval)/vinc)
!!$  enddo
!!$  !
!!$  call wifisyn_sort_index(args,sort,error)
!!$  if (error) return
!!$  !
!!$  ! Sort UVT buffer into UVR buffer using the previously computed INDEX
!!$  call wifisyn_sort_head(sort,uvt,uvr,error)
!!$  if (error) return
!!$  call wifisyn_sort_data(sort,uvt,uvr,error)
!!$  if (error) return
!!$  !
!!$  ! Clean
!!$  call wifisyn_free_inte_1d(sort%idx,error)
!!$  call wifisyn_free_inte_1d(sort%iu,error)
!!$  call wifisyn_free_inte_1d(sort%iv,error)
!!$  !
!!$end subroutine wifisyn_sort_uvrt
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_set_index(ndata,sort,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_set_index
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,      intent(in)    :: ndata
  type(sort_t), intent(out)   :: sort
  logical,      intent(inout) :: error ! Error status
  !
  integer :: idata
  character(len=*), parameter :: rname='SET/INDEX'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_allocate_inte_1d('idx',ndata,sort%idx,error)
  if (error) return
  !
  do idata=1,ndata
     sort%idx%val(idata) = idata
  enddo
  !
end subroutine wifisyn_set_index
!
subroutine wifisyn_sort_index(args,sort,error)
  use gbl_message
  use gio_params
  use wifisyn_interfaces, except_this=>wifisyn_sort_index
  use wifisyn_gridding_types
  use wifisyn_sort_buffer
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,              intent(in)    :: args(m_tot_key)
  type(sort_t), target, intent(inout) :: sort
  logical,              intent(inout) :: error
  !
  integer :: idata,iselect,iarg
  character(len=*), parameter :: rname='SORT/INDEX'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Sanity check (not generic yet *** JP)
  if (inconsistent_size(rname,'iu',sort%iu%n,'idx',sort%idx%n,error)) return
  if (inconsistent_size(rname,'iv',sort%iv%n,'idx',sort%idx%n,error)) return
  !
  keys(code_axis_u)%ipointer%type => sort%iu%val
  keys(code_axis_v)%ipointer%type => sort%iv%val
  keys(code_axis_x)%ipointer%type => sort%ix%val
  keys(code_axis_y)%ipointer%type => sort%iy%val
  !
  n_inte_key = 0
  do iarg=1,m_tot_key
     iselect = args(iarg)
     if (iselect.eq.code_null) then
        exit
     endif
     n_inte_key = n_inte_key+1
     inte_keys(n_inte_key)%type => keys(iselect)%ipointer%type
  enddo
  !
  do idata=1,sort%idx%n
     sort%idx%val(idata) = idata
  enddo
  !
  call gi4_quicksort_index_with_user_gtge(sort%idx,wifisyn_gt,wifisyn_ge,error)
  if (error) return
  !
end subroutine wifisyn_sort_index
!
function wifisyn_eq(m,l)
  use wifisyn_sort_buffer
  !---------------------------------------------------------------------
  ! @ private
  ! This routine is optimized because it is called many times
  ! Do not modify
  !---------------------------------------------------------------------
  logical             :: wifisyn_eq
  integer, intent(in) :: m ! Data #m
  integer, intent(in) :: l ! Data #l
  !
  integer :: ikey
  !
  wifisyn_eq = .true.
  do ikey=1,n_inte_key
     if (inte_keys(ikey)%type(m).ne.inte_keys(ikey)%type(l)) then
        wifisyn_eq = .false.
        return
     endif
  enddo
  !
end function wifisyn_eq
!
function wifisyn_ge(m,l)
  use wifisyn_sort_buffer
  !---------------------------------------------------------------------
  ! @ private
  ! This routine is optimized because it is called many times
  ! Do not modify
  !---------------------------------------------------------------------
  logical             :: wifisyn_ge
  integer, intent(in) :: m ! Data #m
  integer, intent(in) :: l ! Data #l
  !
  integer :: ikey
  !
  wifisyn_ge = .true.
  do ikey=1,n_inte_key
     if (inte_keys(ikey)%type(m).gt.inte_keys(ikey)%type(l)) then
        return
     else if (inte_keys(ikey)%type(m).lt.inte_keys(ikey)%type(l)) then
        wifisyn_ge = .false.
        return
     endif
  enddo
  !
end function wifisyn_ge
!
function wifisyn_gt(m,l)
  use wifisyn_sort_buffer
  !---------------------------------------------------------------------
  ! @ private
  ! This routine is optimized because it is called many times
  ! Do not modify
  !---------------------------------------------------------------------
  logical             :: wifisyn_gt
  integer, intent(in) :: m ! Data #m
  integer, intent(in) :: l ! Data #l
  !
  integer :: ikey
  !
  wifisyn_gt = .false.
  do ikey=1,n_inte_key
     if (inte_keys(ikey)%type(m).gt.inte_keys(ikey)%type(l)) then
        wifisyn_gt = .true.
        return
     else if (inte_keys(ikey)%type(m).lt.inte_keys(ikey)%type(l)) then
        return
     endif
  enddo
  !
end function wifisyn_gt
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_sort_head(sort,table,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_sort_head
  use wifisyn_gridding_types
  use wifisyn_uv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(sort_t), intent(in)    :: sort
  type(uv_t),   intent(inout) :: table
  logical,      intent(inout) :: error
  !
  type(uv_t) :: temp
  integer :: idata,ndata
  character(len=*), parameter :: rname='SORT/HEAD'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Sanity check
  ndata = table%head%type%ndata
  if (inconsistent_size(rname,'table',ndata,'index',sort%idx%n,error)) return
  !
  call wifisyn_reallocate_uv_header(temp,ndata,error)
  if (error) return
  !
  do idata=1,ndata
     temp%buff%uvp1(idata,:) = table%buff%uvp1(idata,:)
     temp%buff%uvp2(idata,:) = table%buff%uvp2(idata,:)
  enddo
  do idata=1,ndata
     table%buff%uvp1(idata,:) = temp%buff%uvp1(sort%idx%val(idata),:)
     table%buff%uvp2(idata,:) = temp%buff%uvp2(sort%idx%val(idata),:)
  enddo
  !
  call wifisyn_free_uv(temp,error)
  if (error) return
  !
end subroutine wifisyn_sort_head
!
subroutine wifisyn_sort_data(sort,tabin,tabout,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_sort_data
  use wifisyn_gridding_types
  use wifisyn_uv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(sort_t), intent(in)    :: sort
  type(uv_t),   intent(in)    :: tabin
  type(uv_t),   intent(inout) :: tabout
  logical,      intent(inout) :: error
  !
  integer :: ndata,idata
  character(len=*), parameter :: rname='SORT/DATA'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Sanity check
  ndata = tabin%head%type%ndata
  if (inconsistent_size(rname,'tabin',ndata,'index',sort%idx%n,error)) return
  if (inconsistent_size(rname,'tabout',ndata,'index',sort%idx%n,error)) return
  !
  ! Table data only
  do idata=1,ndata
     tabout%buff%uvp3(idata,:,:) = tabin%buff%uvp3(sort%idx%val(idata),:,:)
  enddo
  !
end subroutine wifisyn_sort_data
!
!!$subroutine wifisyn_sort_check(nent,index,leq)
!!$  use gbl_message
!!$  use wifisyn_uv_types
!!$  !---------------------------------------------------------------------
!!$  ! @ private
!!$  ! Check if visibilities are negative and increasing
!!$  !---------------------------------------------------------------------
!!$  integer, intent(in)    :: nent  !
!!$  integer, intent(in)    :: index(nent)
!!$  !
!!$  integer :: ient
!!$  !
!!$  do ient = 2,nent
!!$     if (leq(ient-1,ient)) then
!!$        sorted = .false.
!!$        return
!!$     endif
!!$  enddo
!!$  sorted = .true.
!!$  !
!!$end subroutine wifisyn_sort_check
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage IMBFITS messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module imbfits_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: imbfits_message_id = gpack_global_id  ! Default value for startup message
  !
end module imbfits_message_private
!
subroutine imbfits_message_set_id(id)
  use imbfits_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  imbfits_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',imbfits_message_id
  call imbfits_message(seve%d,'imbfits_message_set_id',mess)
  !
end subroutine imbfits_message_set_id
!
subroutine imbfits_message(mkind,procname,message)
  use imbfits_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(imbfits_message_id,mkind,procname,message)
  !
end subroutine imbfits_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_message_debug(doalloc,alloc,doother,other,error)
  use imbfits_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Alter the imbfits specific severities. You can switch them to
  ! seve%d and seve%i only!
  !---------------------------------------------------------------------
  logical,         intent(in)    :: doalloc  !
  integer(kind=4), intent(in)    :: alloc    ! For iseve%alloc
  logical,         intent(in)    :: doother  !
  integer(kind=4), intent(in)    :: other    ! For iseve%other
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='IMBFITS>MESSAGE>DEBUG'
  !
  if (doalloc) then
    if (alloc.ne.seve%i .and. alloc.ne.seve%d) then
      call imbfits_message(seve%e,rname,  &
        'You can switch the ALLOCATION messages to Info or Debug only')
      error = .true.
      return
    endif
    iseve%alloc = alloc
  endif
  !
  if (doother) then
    if (other.ne.seve%i .and. other.ne.seve%d) then
      call imbfits_message(seve%e,rname,  &
        'You can switch the OTHER messages to Info or Debug only')
      error = .true.
      return
    endif
    iseve%other = other
  endif
  !
end subroutine imbfits_message_debug
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gchar_variables
  !--------------------------------------------------------------------
  ! Definition of gchar global variables
  !--------------------------------------------------------------------
  ! Only 26826 used up to now
  integer, parameter :: nkbyte=28000
  integer, parameter :: nkchar=600
  integer, parameter :: nksize=4+(3*2+4)*nkchar+nkbyte  ! Number of bytes needed by the common
  integer, parameter :: nkpage=(nksize+511)/512         ! Number block of 512 bytes = 128 words
  integer, parameter :: nkempt=(512*nkpage-nksize)/4    ! Padding for the last block
  !
  logical :: vstrsh1                  ! First word in common
  integer(2) :: nstrok(nkchar)        !
  integer(2) :: ladj(nkchar)          !
  integer(2) :: radj(nkchar)          !
  integer    :: pointe(nkchar)        !
  integer(kind=1) :: font(0:nkbyte-1) !
  integer :: lastad(nkempt)           ! Padding array
  !
  ! The following common is required, because all these variables
  ! must be aligned in memory.
  common /vstrsh/ vstrsh1,nstrok,ladj,radj,pointe,font,lastad
end module gchar_variables
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE COMPUTE_MAG(EL,NEL,MAG,SIG_MAG,DELTA_MAG,SIG_DMAG,
     +              COMPUTE_ERRORS,MAG_A,sMAG_A,MAG_B,sMAG_B,ERROR)
* Compute absolute magnitudes from apparent magnitudes and orbital elements
      INTEGER NEL
      REAL*8 EL(NEL)
      REAL MAG,SIG_MAG         ! Apparent magnitude of the pair
      REAL DELTA_MAG,SIG_DMAG  ! Magnitude difference
      REAL MAG_A,sMAG_A,MAG_B,sMAG_B ! Absolute magnitudes and probable errors
      LOGICAL COMPUTE_ERRORS,ERROR
*
      INCLUDE 'constant.inc'
*
      REAL B(MA)
      REAL Orb_Par,dOrb_Par       ! Orbital parallax and probable error
      REAL APPARENT(2),SIG2_APP(2) ! Apparent magnitudes of individual stars
      INCLUDE 'pi.inc'
      INCLUDE 'physical_constants.inc'
*
* Compute apparent magnitude of each of the two stars from their magnitude 
* difference and the apparent magnitude of the pair
*  m(A) = m +2.5 log10(1+10^(-delta_m/2.5))
*  m(B) = m +2.5 log10(1+10^(+delta_m/2.5))
*  dm(A) = dm - 2.5/Log(10)*10^(-delta_m/2.5))/[1+10^(-delta_m/2.5))] *ddelta_m
*  dm(B) = dm + 2.5/Log(10)*10^(+delta_m/2.5))/[1+10^(+delta_m/2.5))] *ddelta_m
      APPARENT(1) = MAG+2.5*LOG10(1+10**(-DELTA_MAG/2.5))
      APPARENT(2) = MAG+2.5*LOG10(1+10**(+DELTA_MAG/2.5))
!         write(6,*) (10**(-DELTA_MAG/2.5))/(1+10**(-DELTA_MAG/2.5)),
!     +        (10**(+DELTA_MAG/2.5))/(1+10**(+DELTA_MAG/2.5))
      SIG2_APP(1) = SIG_MAG**2 +
     +     (2.5/LOG(10.)*(10**(-DELTA_MAG/2.5))
     +     /(1+10**(-DELTA_MAG/2.5)))**2
     +     * (SIG_DMAG)**2
      SIG2_APP(2) = SIG_MAG**2 +
     +     (2.5/LOG(10.)*(10**(+DELTA_MAG/2.5))
     +     /(1+10**(+DELTA_MAG/2.5)))**2
     +     * (SIG_DMAG)**2
!      write(6,'(2(F6.3,F5.3))') mag,sig_mag, delta_mag, sig_dmag
!      Write(6,'(2(F6.3,F5.3))') apparent(1),sqrt(SIG2_APP(1)),
!     +     apparent(2),sqrt(SIG2_APP(2))
* SB2 with known non zero inclination: compute orbital parallax and convert 
* from apparent magnitudes to absolute ones
      IF((EL(ELINDX(IORB0)+I_K1)*EL(ELINDX(IORB0)+I_K2)).NE.0
     +     .AND.SIN(EL(ELINDX(IORB0)+I_i)/GR).NE.0) THEN  
         CALL GRAD_PARALLAX(Orb_Par,B)
         MAG_A = APPARENT(1)+5*LOG10(Orb_Par/0.1)
         MAG_B = APPARENT(2)+5*LOG10(Orb_Par/0.1)
         IF (COMPUTE_ERRORS) THEN
            CALL EVAL_ERROR(dOrb_Par,B)
* dM = dm + 5/LOG(10) dPi/Pi
            sMAG_A = SIG2_APP(1)+(5./LOG(10.)*dOrb_Par/Orb_Par)**2
            sMAG_A = SQRT(sMAG_A)
            sMAG_B = SIG2_APP(2)+(5./LOG(10.)*dOrb_Par/Orb_Par)**2
            sMAG_B = SQRT(sMAG_B)
         ENDIF
      ENDIF

      RETURN
*
! 99   ERROR = .TRUE.
      RETURN
      END

      SUBROUTINE GRAD_MAGNITUDE(EL,PAR,B)
*---------------------------------------------------------------------------
* Orbit:
* Compute an orbital parallax and its gradient relative to the 
* elements
* CAUTION: the gradient routines must NEVER contain the element common, they
* are called with trial elements.
*---------------------------------------------------------------------------
      INCLUDE 'constant.inc'
      REAL*8 EL(MA)
      REAL PAR,B(MA)
*
      INCLUDE 'pi.inc'
      INCLUDE 'physical_constants.inc'
*
      INTEGER I
      REAL SI,CI,CF
*
* Compute sqrt(1-e**2) and trigonometric functions of inclination, which 
* are needed everywhere
      SI=SIN(EL(I_i+ELINDX(IORB0))/GR)
      CI=COS(EL(I_i+ELINDX(IORB0))/GR)
      IF (ABS(EL(I_Ecc+ELINDX(IORB0))).GT.1) THEN
         CF = 0.
      ELSE
         CF=SQRT(1.-EL(I_Ecc+ELINDX(IORB0))**2)
      ENDIF
*
      DO I=1,MA
         B(I)=0
      ENDDO
*
* Return zero rather than NaNs or Inf whenever parameters are undefined
      IF ((EL(I_K1+ELINDX(IORB0))+EL(I_K2+ELINDX(IORB0))).EQ.0
     +     .OR.EL(I_PERIOD+ELINDX(IORB0)).EQ.0
     +     .OR.EL(I_as+ELINDX(IORB0)).EQ.0
     +     .OR.CF.EQ.0
     +     .OR.SI.EQ.0) THEN
         PAR = 0
      ELSE
* First, evaluate the logarithmic gradient
         B(I_PERIOD+ELINDX(IORB0)) = -1/EL(I_PERIOD+ELINDX(IORB0))
         B(I_Ecc+ELINDX(IORB0)) = +EL(I_Ecc+ELINDX(IORB0))/CF**2
         B(I_as+ELINDX(IORB0)) = +1/EL(I_as+ELINDX(IORB0))
         B(I_i+ELINDX(IORB0)) = CI/SI
         B(I_K1+ELINDX(IORB0)) = -1/(EL(I_K1+ELINDX(IORB0))
     +        +El(I_K2+ELINDX(IORB0)))
         B(I_K2+ELINDX(IORB0)) = -1/(EL(I_K1+ELINDX(IORB0))
     +        +El(I_K2+ELINDX(IORB0)))
* Then compute parallax value, and scale the gradient
         PAR=AU*2*PI*SI*EL(I_as+ELINDX(IORB0))
     +        /(((EL(I_K1+ELINDX(IORB0))
     +        +EL(I_K2+ELINDX(IORB0)))*KM_S)*CF*
     +        EL(I_PERIOD+ELINDX(IORB0))*DAY)
         DO I=1,MA
            B(I)=B(I)*PAR
         ENDDO
      ENDIF
      END

subroutine write_sdm_totalPower(holodata, nd, rdata,   &
    error)
  !---------------------------------------------------------------------
  !     Write the totalPower SDM table.
  ! Many *TBD* items...
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_TotalPower
  use sdm_Enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical :: error, holodata
  integer :: nd
  real*4 :: rdata(nd)
  ! Local
  type (TotalPowerRow) :: tpmRow
  type (TotalPowerKey) :: tpmKey
  type (TotalPowerOpt) :: tpmOpt
  integer :: ia, i, ib, numBaseBand, ic, ip
  character, parameter :: sdmTable*20 = 'TotalPower'
  !c      integer, parameter :: numchannel = 1
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable,'Starting...')
  numBaseBand = r_lband
  !
  ! Force numCorr to 6 products in holodata mode, and numBaseBand to 1
  if (holodata) then
    num_Corr = 6
    numBaseBand = 1
  else
    num_Corr = r_npol_rec
    numBaseBand = r_lband
  endif
  !! this is the old fashioned way...
  call allocTotalPowerRow(tpmRow, r_nant, num_Corr,   &
    numBaseBand, error)
  !      print *, r_nant, num_Corr, numBaseBand, error
  if (error) return
  !
  !     *TBD* THe dimensions of the floatData are unclear in documentation
  !
  !     For ALMA I would say:
  !
  !     - Nant, Nreceptors(2), Nbb for the baseband detectors (2GHz Bw)
  !
  !     - Nant, Nreceptors(2), Nsidebands(<2) for the downConverter
  !     detectors (2GHz Bw)
  !
  !     In all cases we need to define a spectral window and a configId
  !     for the continuum detectors.
  !
  !     The Key:
  !     The time interval midpoint
  tpmKey%time = time_Interval(1) + time_Interval(2)/2.
  if (.not. holodata) then
    tpmKey%configDescriptionId = TotPowConfigDescription_Id
  else
    tpmKey%configDescriptionId = ConfigDescription_Id
  endif
  !
  tpmKey%fieldId = Field_Id
  tpmRow%interval = time_Interval(2)
  tpmRow%execBlockId = execBlock_Id
  tpmRow%scanNumber = Scan_Number
  tpmRow%subScanNumber = subScan_Number
  tpmRow%exposure = time_interval(2)
  tpmRow%timeCentroid = time_Interval(1) + time_Interval(2)/2.
  !
  !     State_Id could depend on antenna, but doesn't.  exposures could
  !     too (for average record). We do not keep proper tracking at Bure
  !     for averaging....
  do i=1, r_nant
    tpmRow%stateId(i) = State_Id
  enddo
  !
  ! In e.g. holography each integration will be a dump in CLIC. (no spectral data).
  if (holodata) then
    tpmRow%integrationNumber = dh_dump
  else
    tpmRow%integrationNumber = 1
  endif
  !
  tpmRow%uvw = 0
  if (r_nbas.gt.0) then
    do ib = 1, r_nbas
      if (r_iant(ib).eq.1) then
        tpmRow%uvw(1,r_jant(ib)) = dh_uvm(1,ib)
        tpmRow%uvw(2,r_jant(ib)) = dh_uvm(2,ib)
      endif
    enddo
  endif
  !     ...     put dh_total in FloatData
  !
  !     *TBD* The dimensions of floatData are nant, nc, nf for total power
  !     I guess nc is always 1; should it not be numReceptors?  in fact nc
  !     is defined in polarization table, there shoudl be there en entry
  !     for the total powers. this is the number of corr products which
  !     can be 1 or 2.
  !     nc is num_Corr ...
  !
  if (.not.holodata) then
    !
    !     The order is : (pol. product, baseband, antenna). Bure has a single
    !     number of all basebands at this point.
    !
    do ic = 1, r_lband
      do ip = 1, r_npol_rec
        do ia = 1, r_nant
          tpmRow%FloatData(ip,ic,ia) = dh_total(ip,ia)
          if (r_totscale(ip,ia).ne.0) then
            tpmRow%FloatData(ip,ic,ia) = tpmRow%FloatData(ip   &
              ,ic,ia) * r_totscale(ip,ia)
          endif
        enddo
      enddo
    enddo
  else
    do ia = 1, r_nant
      do ic = 1, mCorrHolo
        if (holo_type(ic).eq.HolographyChannelType_S2) then
          tpmRow%FloatData(ic,1,ia) = dh_test0(2)
        elseif (holo_type(ic).eq.HolographyChannelType_R2) then
          tpmRow%FloatData(ic,1,ia) = dh_test0(1)
        elseif (holo_type(ic).eq.HolographyChannelType_Q2) then
          tpmRow%FloatData(ic,1,ia) = dh_test0(3)
        elseif (holo_type(ic).eq.HolographyChannelType_RS) then
          tpmRow%FloatData(ic,1,ia) = rdata(1)*dh_test0(1)
        elseif (holo_type(ic).eq.HolographyChannelType_QS) then
          tpmRow%FloatData(ic,1,ia) = dh_test0(4)
        elseif (holo_type(ic).eq.HolographyChannelType_QR) then
          tpmRow%FloatData(ic,1,ia) = rdata(2)*dh_test0(1)
        endif
      enddo
    enddo
  !
  endif
  !
  ! *TBD* The order of dimensions for floatData in TotalPower
  ! *TBD*  is not precised in ASDM documentation...
  !
  !     ...     put dh_aflag in flagAnt
  tpmRow%flagAnt = 0
  tpmRow%flagRow = .false.
  tpmRow%flagPol = 0
  ! *TBD* The order of dimensions for flagPol in TotalPower
  ! *TBD*  is not precised in ASDM documentation...
  !
  call addtotalPowerRow(tpmKey, tpmRow, error)
  if (error) return
  !
  ! Add subintegration number if this is is a subintegration:
  if (dh_integ.le.1.0 .and. .not.holodata) then
    tpmOpt%subintegrationNumber = dh_dump
    call addtotalPowerSubintegrationNumber(tpmKey, tpmOpt   &
      ,error)
    if (error) return
  endif
  call sdmMessage(1,1,sdmTable,'Written.')
  return
99 error = .true.
end subroutine write_sdm_totalPower
!---------------------------------------------------------------------
subroutine get_sdm_totalPower(holodata, tpmSize,   &
    tpmKeyList, error)
  !---------------------------------------------------------------------
  !     Read the totalPower SDM table.
  !     Specific holography data mode allowed
  ! Many *TBD* items...
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_TotalPower
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  integer :: tpmSize
  logical :: holodata, error, present
  type (TotalPowerKey) :: tpmKeyList(tpmSize)
  ! Local
  type (TotalPowerRow) :: tpmRow
  type (TotalPowerKey) :: tpmKey
  type (TotalPowerOpt) :: tpmOpt
  integer :: ia, i, ib, itpm, ic, ip, numCorr, numBaseBand
  character, parameter :: sdmTable*20 = 'TotalPower'
  !      integer, parameter :: numchannel = 1
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable,'Starting...')
  !
  ! need to find the relevant totalpower row; assume only one ...
  error = .true.
  do itpm = 1, tpmSize
    if ((tpmKeyList(itpm)%fieldId.eq.field_Id) .and.   &
      (tpmKeyList(itpm)%time.ge.time_interval(1) -   &
      time_interval(2)/2) .and. (tpmKeyList(itpm)%time.le.   &
      (time_interval(1) + time_interval(2)/2))) then
      tpmKey = tpmKeyList(itpm)
      error = .false.
    endif
  enddo
  if (error) then
    call sdmMessage(6,3,sdmTable,'No relevant Row')
    return
  endif
  !
  TotPowConfigDescription_Id = tpmKey%configDescriptionId
  !
  !     Get numCorr (and numBaseBand) for this (should find them in
  !
  !     ConfigDescription -> DataDescription -> Polarization and Processor...
  !
  !     I assume here that numCorr is equal to numReceptors (=r_npol_rec),
  !     which is not necessary for ALMA.
  !
  numCorr = r_npol_rec
  numBaseBand = 1
  !
  call allocTotalPowerRow(tpmRow, mnant, numCorr, numBaseBand, error   &
    )
  if (error) return
  !
  !     *TBD* THe dimensions of the floatData are (ncorr, nbaseband, nant)
  !
  call getTotalPowerRow(tpmKey, tpmRow, error)
  if (error) return
  if (.not.holodata) then
    ! these could be checked...
    if (Scan_Number.ne.tpmRow%scanNumber .or. tpmRow%subScanNumber   &
      .ne.subScan_Number .or. tpmRow%execBlockId.ne.execBlock_Id   &
      .or.tpmRow%subScanNumber.ne.subScan_Number) then
    !$$$            print *, 'execBlock_Id, Scan_Number, subScan_Number'
    !$$$            print *, execBlock_Id, Scan_Number, subScan_Number
    !$$$            print *, 'tpmRow%execBlockId, tpmRow%scanNumber, ',
    !$$$     &           'tpmRow%subScanNumber'
    !$$$            print *, tpmRow%execBlockId, tpmRow%scanNumber,
    !$$$     &           tpmRow%subScanNumber
    endif
    !
    !     State_Id could depend on antenna, but doesn't.  exposures could
    !     too (for average record). We do not keep proper tracking at Bure
    !     for averaging....
    !     ...     put dh_total in FloatData
    !
    !
    do ip=1, numCorr
      do ia = 1, r_nant
        dh_total(ip, ia) = tpmRow%FloatData(ip, 1, ia)
      enddo
    enddo
    !
    !
    !     Get the subintegration number:
    call getTotalPowerSubintegrationNumber(tpmKey, tpmOpt   &
      ,present, error)
    if (error) return
    !     We have a problem if this does not match the one from Main!!
    if (present) then
      if (dh_dump.ne.tpmOpt%subintegrationNumber) then
        call sdmMessageI(6,2,sdmTable   &
          ,'Unexpected SubintegrationNumber'   &
          ,tpmOpt%subintegrationNumber)
        call sdmMessageI(6,2,sdmTable ,'I expected: ' ,dh_dump)
      endif
    endif
  else
    !
    ! holography is different
    !... put the floatdata where it should be put .....#############
    !
    !$$$         print *, 'execBlock_Id, Scan_Number, subScan_Number'
    !$$$         print *, execBlock_Id, Scan_Number, subScan_Number
    !$$$         print *, 'tpmRow%execBlockId, tpmRow%scanNumber, ',
    !$$$     &        'tpmRow%subScanNumber'
    !$$$         print *, tpmRow%execBlockId, tpmRow%scanNumber,
    !$$$     &        tpmRow%subScanNumber
    ExecBlock_Id = tpmRow%ExecBlockId
    Scan_Number = tpmRow%scanNumber
    subScan_Number = tpmRow%subScanNumber
    !$$$         print *, 'tpmRow%stateId'
    !$$$         print *, tpmRow%stateId
    state_Id = tpmRow%stateId(1)
    do ia = 1, r_nant
      if(state_Id.ne.tpmRow%stateId(ia)) then
        error = .true.
        call sdmmessageI(8,4,sdmTable ,'Unexpected State_Id '   &
          ,tpmRow%stateId(ia))
        return
      endif
    enddo
  !$$$         print *, 'state_Id ',state_Id
  endif
  call sdmMessage(1,1,sdmTable,'Read.')
  return
99 error = .true.
end subroutine get_sdm_totalPower
!---------------------------------------------------------------------
subroutine get_sdm_totalPowerHoloData(tpm, tpRow,   &
    dataArray, error)
  !---------------------------------------------------------------------
  !     Read the totalPower SDM holography data, for the
  !     relevant row.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_TotalPower
  use sdm_Enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  type (TotalPower) :: tpm
  integer :: tpRow
  logical :: error, no_number
  real :: dataArray(4)
  ! Local
  integer :: ia, i, ib, itpm, k, ic
  character, parameter :: sdmTable*20 = 'TotalPower'
  real :: holoss, holoqq, holorr, holosq, holosr, holoqr
  real :: testArray(4)
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable,'Starting...')
  !      num_Corr = 6
  !
  !...  put the floatdata where it should be put .....
  !
  ia = 1
  ! apparently the product number goes first...
  !'QQ', 'QR', 'QS', 'RR', 'RS', 'SS'/)
  do ic = 1, mCorrHolo
    if (no_number(tpm%FloatData(ic,1,ia,tpRow))) then
      tpm%FloatData(ic,1,ia,tpRow) = 0
      dh_bflag(1) = 2**30
      dh_aflag(1) = 2**30
    endif
    if (holo_type(ic).eq.HolographyChannelType_S2) then
      holoss = tpm%FloatData(ic,1,ia,tpRow)/1e5
    elseif (holo_type(ic).eq.HolographyChannelType_R2) then
      holorr = tpm%FloatData(ic,1,ia,tpRow)/1e5
    elseif (holo_type(ic).eq.HolographyChannelType_Q2) then
      holoqq = tpm%FloatData(ic,1,ia,tpRow)/1e5
    elseif (holo_type(ic).eq.HolographyChannelType_RS) then
      holosr = tpm%FloatData(ic,1,ia,tpRow)/1e5
    elseif (holo_type(ic).eq.HolographyChannelType_QS) then
      holosq = tpm%FloatData(ic,1,ia,tpRow)/1e5
    elseif (holo_type(ic).eq.HolographyChannelType_QR) then
      holoqr = tpm%FloatData(ic,1,ia,tpRow)/1e5
    endif
  enddo
  dh_test0(1) = holorr         ! true rr
  dh_test0(2) = holoss         ! true ss
  dh_test0(3) = holoqq         ! true qq
  dh_test0(4) = holosr         ! true sq
  dh_test0(5) = holoqr         ! true sq
  dh_test0(6) = holosq         ! true sq
  dh_test0(7) = 1d-9*(tpm%time(tpRow) - tpm%time(1))
  !      print *, tpRow, tpm%time(tpRow), dh_test0(7)
  ! holography has a single polarization:
  dh_total(1, 1) = holoss
  dh_total(2, 1) = holoss
  r_totscale(1,1) = 1.0
  r_totscale(2,1) = 1.0
  !
  !     1 subband, 2 side band ,1 baseline (2 side bands for
  !     compatibility) as clic poorly handles data with one sideband only
  !     .  LSB is used to hold data with phases reversed.  More precise
  !     formula is TBD
  dataarray(3) = holorr        ! reference beam in LSB
  dataarray(4) = 0             ! with zero phase ... uncalibrated in LSB
  if (holorr.ne.0) then
    holosr = holosr/holorr
    holoqr = holoqr/holorr
    dataarray(1) = holosr      ! true SR in USB (real)
    dataarray(2) = holoqr/0.99834  ! true QR in USB (imag)
    !         dataarray(3) = dataarray(1)    ! true SR in LSB (real)
    !         dataarray(4) = dataarray(2)    ! true QR in LSB (imag)
    dh_aflag = 0
    dh_bflag = 0
  else
    holosr = 0.0
    holoqr = 0.0
    dataarray(1) = holosr      ! true SR in USB (real)
    dataarray(2) = holoqr/0.99834  ! true QR in USB (imag)
    !         dataarray(3) = dataarray(1)    ! true SR in LSB (real)
    !         dataarray(4) = dataarray(2)    ! true QR in LSB (imag)
    dh_aflag(1) = -1
    dh_bflag(1) = -1
    print *, '== r_xnum, tpRow ',r_xnum, tpRow ,   &
      ' data flagged (holorr = 0) '
  endif
  if (tpm%flagrow(tpRow) .or. tpm%flagAnt(1,tpRow).ne.0 .or.   &
    tpm%flagpol(1,1,tpRow).ne.0) then
    dh_aflag(1) = -1
    dh_bflag(1) = dh_aflag(1)
    print *, '== r_xnum, tpRow ',r_xnum, tpRow , ' data flagged'
    print *, 'tpm%flagrow(tpRow) ', tpm%flagrow(tpRow)
    print *, 'tpm%flagAnt(1,tpRow) ', tpm%flagAnt(1,tpRow)
    print *, 'tpm%flagpol(1,1,tpRow) ', tpm%flagpol(1,1,tpRow)
  endif
  !
  call sdmMessage(1,1,sdmTable,'Read.')
  return
99 error = .true.
end subroutine get_sdm_totalPowerHoloData
!---------------------------------------------------------------------
subroutine allocTotalPowerRow(row, numAntenna,   &
    numCorr, numBaseBand, error)
  !---------------------------------------------------------------------
  !     integer, allocatable :: stateId(:)
  !     real*8, allocatable :: uvw(:,:)
  !     integer*8, allocatable :: exposure(:,:)
  !     integer*8, allocatable :: timeCentroid(:,:)
  !     real, allocatable :: floatData(:,:,:)
  !     integer, allocatable :: flagAnt(:)
  !     integer, allocatable :: flagPol(:,:)
  !---------------------------------------------------------------------
  use sdm_TotalPower
  type(TotalPowerRow) :: row
  integer :: numAntenna, numCorr, numBaseBand, ier
  logical :: error
  character, parameter :: sdmTable*20 = 'TotalPower'
  !---------------------------------------------------------------------
  !
  ! stateId (numAntenna)
  if (allocated(row%stateId)) then
    deallocate(row%stateId, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%stateId(numAntenna), stat=ier)
  if (ier.ne.0) goto 99
  !
  ! uvw (3, numAntenna)
  if (allocated(row%uvw)) then
    deallocate(row%uvw, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%uvw(3, numAntenna), stat=ier)
  if (ier.ne.0) goto 99
  !
  ! exposure (numBaseband, numAntenna)
  if (allocated(row%exposure)) then
    deallocate(row%exposure, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%exposure(numBaseband, numAntenna), stat=ier)
  if (ier.ne.0) goto 99
  !
  ! timeCentroid (numBaseband, numAntenna)
  if (allocated(row%timeCentroid)) then
    deallocate(row%timeCentroid, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%timeCentroid(numBaseband, numAntenna), stat=ier)
  if (ier.ne.0) goto 99
  !
  ! floatData (numChannel, numCorr, numAntenna)
  if (allocated(row%floatData)) then
    deallocate(row%floatData, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%floatData(numCorr, numBaseband, numAntenna), stat   &
    =ier)
  if (ier.ne.0) goto 99
  !
  ! flagAnt (numAntenna)
  if (allocated(row%flagAnt)) then
    deallocate(row%flagAnt, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%flagAnt(numAntenna), stat=ier)
  if (ier.ne.0) goto 99
  !
  ! flagPol (numCorr, numAntenna)
  if (allocated(row%flagPol)) then
    deallocate(row%flagPol, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%flagPol(numCorr, numAntenna), stat=ier)
  if (ier.ne.0) goto 99
  !
  return
  !
98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
  error = .true.
  return
  !
99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
  error = .true.
  return
end subroutine allocTotalPowerRow
!!! !---------------------------------------------------------------------

subroutine read_all(fits,error,eot)
  use gildas_def
  use gbl_format
  use gbl_message
  use image_def
  use gsys_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>read_all
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! Read all the input FITS image
  !
  ! Should be re-written by using a block mode operation, with say a
  ! few Mbyte buffer, or even less...
  ! Slot re-shaping can be used for this
  ! Extrema should be carried on through, not in a separate pass...
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: fits   !
  logical,      intent(out)   :: error  ! Error flag
  logical,      intent(inout) :: eot    ! End of Tape flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=size_length) :: nfill
  integer :: i
  integer(kind=address_length) :: ip
  type(time_t) :: time
  integer(kind=index_length) :: large_dim, block_num, ibl, old_dims(gdf_maxdims)
  integer(kind=size_length) :: imin, imax, jmin, jmax, data_size, nblank
  real(4) :: rmin, rmax, amin, amax
  integer :: old_ndim, ier, block_factor
  real, allocatable :: mydata(:)
  ! This will be removed at some point, once debugging is fool-proof
  logical, save :: mode_all=.false.
  integer(kind=8) :: ilong
  character(len=message_length) :: mess
  character(len=*), parameter :: rname= 'FITS_GILDAS'
  !
  error = .false.
  !
  ! Write the sections
  !
  ! Read the data
  if (fits%loca%islo.ne.0) then
    call gio_fris (fits%loca%islo,error)
    fits%loca%islo = 0
  endif
  fits%loca%size = 1
  do i=1,gdf_maxdims
    if (fits%gil%dim(i).le.0) fits%gil%dim(i)=1
    fits%loca%size = fits%loca%size*fits%gil%dim(i)
  enddo
  !
  ! Only Real*4 images supported
  call gio_geis (fits%loca%islo,error)
  fits%gil%blan_words = 2
  fits%gil%extr_words = 0  ! Set in close_gdf
  call gio_write_header(fits,fits%loca%islo,error)
  fits%char%type = 'GILDAS_IMAGE'
  fits%gil%form = fmt_r4
  if (.not.error)  then
    call gio_cris(fits%loca%islo,fits%char%type, &
    &   fits%file,fits%gil%form,fits%loca%size,error)
  endif
  if (error) then
    call gio_message(seve%e,rname,'Image '//trim(fits%file)//' not created')
    return
  endif
  !
  ! Make sure the FITS file is at the right position
  nfill = 0
  call gfits_flush_data(error)
  if (error) return
  !
  fits%blc = 0
  fits%trc = 0
  !
  if (mode_all) then
    !
    ! Old way, all at once, memory hungry...
    call gio_gems (fits%loca%mslo,fits%loca%islo,fits%blc,fits%trc,fits%loca%addr,fits%gil%form,error)
    if (error) return
    !
    ip = gag_pointer(fits%loca%addr,memory)
    call read_allmap(fd,memory(ip),fits%loca%size,nfill,fits%gil%bval,error)
    if (nfill.lt.fits%loca%size) then
      call gio_message(seve%w,rname,'FITS data file is incomplete')
    endif
    !
    call close_gdf(fd,fits,memory(ip),error)
  else
    !
    ! Read by block, extrema not set, but memory saving...
    old_ndim = fits%gil%ndim
    old_dims = fits%gil%dim
    !
    ! Decompose in large blocks
    fits%gil%ndim = 2
    fits%gil%dim(2) = fits%loca%size / fits%gil%dim(1)
    large_dim = max(fits%gil%dim(1),fits%gil%dim(2))
    block_num = fits%loca%size / large_dim 
    fits%gil%dim = 1
    fits%gil%dim(1) = large_dim
    fits%gil%dim(2) = block_num
    fits%blc(1) = 1
    fits%trc(1) = fits%gil%dim(1)     
    !
    block_factor = max((256*256)/large_dim,1)
    allocate (mydata(large_dim*block_factor),stat=ier)
    !
    fd%nb = 2881  ! Initialize FITS byte counter
    !
    call gtime_init(time,block_num/block_factor,error)
    if (error)  goto 100
    !
    rmin = huge(1.0)
    rmax = -huge(1.0)
    nblank = 0
    !
    do ibl = 1, block_num, block_factor
      call gtime_current(time)
      !
      fits%blc(2) = ibl
      fits%trc(2) = min(ibl+block_factor-1,fits%gil%dim(2))
      data_size = (fits%trc(2)-fits%blc(2)+1)*large_dim
      mydata = 0.0
      call gfits_getreal(fd,data_size, mydata, fd%bscal, fd%bzero, error)
      if (error) goto 100 
      !
      ! Patch NaN or bval
      call fitscube2gdf_patch_bval(fd,fits,mydata,data_size,nblank,error)
      if (error)  goto 100
      !
      ! Extrema
      call gr4_extrema (data_size,mydata,     &
                       fits%gil%bval, fits%gil%eval,  &
                       amin, amax, imin, imax)
      if (amin.lt.rmin) then
        rmin = amin
        jmin = (ibl-1)*fits%gil%dim(1) + imin
      endif
      if (amax.gt.rmax) then
        rmax = amax
        jmax = (ibl-1)*fits%gil%dim(1) + imax
      endif
      !
      ! Write the current section
      call gdf_write_data(fits,mydata,error)
      if (error) goto 100
      !
    enddo
    !
    if (nblank.eq.0) then
      fits%gil%eval = -1.0
      call gio_message(seve%d,rname,'No blank data in FITS file')
    else
      write(mess,'(A,I0,A)') 'Patched ',nblank,' blank data'
      call gio_message(seve%d,rname,mess)
    endif
    !
    fits%gil%dim = old_dims
    fits%gil%ndim = old_ndim
    !
    ! Update extrema here if needed
    fits%gil%rmin = rmin
    fits%gil%rmax = rmax
    ilong = jmin
    call gdf_index_to_where(ilong,fits%gil%ndim,fits%gil%dim,fits%gil%minloc)
    ilong = jmax
    call gdf_index_to_where(ilong,fits%gil%ndim,fits%gil%dim,fits%gil%maxloc)
    fits%gil%extr_words = def_extr_words
    !
    call gdf_update_header(fits,error)
    !
    ! Close image
    call gdf_close_image(fits,error)
    !
    ! Restore shape of array
100 continue
    fits%gil%ndim = old_ndim
    fits%gil%dim = old_dims
    deallocate (mydata)
  endif  
  !
end subroutine read_all
!
subroutine close_gdf(fd,fits,z,error)
  use gbl_message
  use image_def
  use gfits_types
  use gio_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Flush the GILDAS image.
  !---------------------------------------------------------------------
  type(gfits_hdesc_t), intent(in)    :: fd     !
  type(gildas),        intent(inout) :: fits   !
  real(kind=4),        intent(inout) :: z(*)   !
  logical,             intent(inout) :: error  !
  ! Local
  logical :: err,update
  integer(kind=size_length) :: nblank
  !
  err = .false.
  nblank = 0
  call fitscube2gdf_patch_bval(fd,fits,z,fits%loca%size,nblank,err)
  if (err)  error = .true.
  !
  update = .false.
  if (fits%gil%blan_words.ne.0 .and. nblank.eq.0) then
    fits%gil%eval = -1.0
    update = .true.
  endif
  if (fits%gil%extr_words.eq.0) then
    call gio_message(seve%i,'FITS','Computing extrema...')
    call gdf_get_extrema(fits,err)
    update = .true.
  endif
  if (update)  call gdf_update_header(fits,err)
  !
  call gdf_close_image(fits,err)
  if (err) error = .true.
  !
end subroutine close_gdf
!
subroutine read_sub(fits,error,eot,blc,trc)
  use gildas_def
  use gbl_format
  use gbl_message
  use image_def
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>read_sub
  use gio_params
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! FITS  Support routine for command
  !
  !       READ [/BLC Nx1 Nx2 Nx3 Nx4] [/TRC Ny1 Ny2 Ny3 Ny4]
  ! Arguments :
  !       ERROR   L       Logical error flag      Output
  !---------------------------------------------------------------------
  type(gildas),          intent(inout) :: fits    !
  logical,               intent(out)   :: error   ! Error flag
  logical,               intent(inout) :: eot     ! End of Tape flag
  integer(index_length), intent(in)    :: blc(:)  !
  integer(index_length), intent(in)    :: trc(:)  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='READ'
  integer :: i
  integer(kind=index_length) :: gdim(gdf_maxdims),gblc(gdf_maxdims),gtrc(gdf_maxdims)
  integer(kind=address_length) :: ip
  character(len=message_length) :: mess
  !
  ! Clip within the map
  gblc = blc
  gtrc = trc
  do i=1,gdf_maxdims
    if (gblc(i).le.0) then
      if (gblc(i).lt.0) then
        write(mess,101) i
        call gio_message(seve%w,rname,mess)
      endif
      gblc(i) = 1
    elseif (gblc(i).gt.fits%gil%dim(i)) then
      write(mess,102) i,fits%gil%dim(i)
      call gio_message(seve%w,rname,mess)
      gblc(i) = fits%gil%dim(i)
    endif
    if (gtrc(i).eq.0) then
      gtrc(i) = fits%gil%dim(i)
    elseif (gtrc(i).lt.gblc(i)) then
      write(mess,103) i,i
      call gio_message(seve%e,rname,mess)
      error = .true.
      return
    elseif (gtrc(i).gt.fits%gil%dim(i)) then
      write(mess,104) i,fits%gil%dim(i)
      call gio_message(seve%w,rname,mess)
      gtrc(i) = fits%gil%dim(i)
    endif
  enddo
  !
  ! Change the header by the appropriate pixel displacements
  fits%gil%convert(1,1:gdf_maxdims) = fits%gil%convert(1,1:gdf_maxdims)-gblc(1:gdf_maxdims) 
  ! Change the size
  do i=1,gdf_maxdims
    gdim(i) = fits%gil%dim(i)
    fits%gil%dim(i) = gtrc(i)-gblc(i)+1
  enddo
  !
  ! Read the data
  error = .false.
  if (fits%loca%islo.ne.0) then
    call gio_fris (fits%loca%islo,error)
    fits%loca%islo = 0
  endif
  fits%loca%size = 1
  do i=1,gdf_maxdims
    if (fits%gil%dim(i).le.0) fits%gil%dim(i)=1
    fits%loca%size = fits%loca%size*fits%gil%dim(i)
  enddo
  call gio_geis (fits%loca%islo,error)
  call gio_write_header(fits,fits%loca%islo,error)
  fits%char%type = 'GILDAS_IMAGE'
  fits%gil%form = fmt_r4
  if (.not.error)  then
    call gio_cris (fits%loca%islo,fits%char%type, &
    & fits%file,fits%gil%form,fits%loca%size,error)
  endif
  if (error) then
    call gio_message(seve%e,rname,'Image not created')
    return
  endif
  call gio_gems (fits%loca%mslo,fits%loca%islo,fits%blc,fits%trc,fits%loca%addr,fits%gil%form,error)
  if (error) return
  !
  ! Make sure the FITS file is at the right position
  call gfits_flush_data(error)
  if (error) return
  !
  ! Load map into virtual memory
  ip = gag_pointer(fits%loca%addr,memory)
  call read_subset(fd,memory(ip),fits%loca%size,gdim,gblc,gtrc,error,fits%gil%bval)
  !
  call close_gdf(fd,fits,memory(ip),error)
  !
101 format('BLC(',i1,') is negative, 1 used instead')
102 format('BLC(',i1,') is greater than image dimension ',i6,' truncated')
103 format('TRC(',i1,') is smaller than BLC(',i1,')')
104 format('TRC(',i1,') is greater than image dimension ',i6,' truncated')
end subroutine read_sub

program histo_double
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Main program for making a Histogram from two maps
  !
  ! Subroutines	HISTO003
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey,namez
  logical :: error
  real :: hmin,hmax,hstep
  integer, parameter :: mdim=4
  integer :: n, pmin(mdim), pmax(mdim), nh, ier
  type(gildas) :: x,y,z
  !
  call gildas_open
  call gildas_char('Z_NAME$',namez)
  call gildas_char('Y_NAME$',namey)
  call gildas_inte('Y_BLC$',pmin,mdim)
  call gildas_inte('Y_TRC$',pmax,mdim)
  call gildas_inte('X_BINS$',nh,1)
  call gildas_real('X_MIN$',hmin,1)
  call gildas_real('X_MAX$',hmax,1)
  call gildas_char('X_NAME$',namex)
  call gildas_close
  !
  call gildas_null(z)
  z%blc(1:mdim) = pmin
  z%trc(1:mdim) = pmax
  call gdf_read_gildas(z,namez,'.gdf',error,rank=0)
  if (error) goto 100
  !
  ! y%gil%form = fmt_r4 ! This is the default
  call gildas_null(y)
  y%blc(1:mdim) = pmin
  y%trc(1:mdim) = pmax
  call gdf_read_gildas(y,namey,'.gdf',error,rank=0)
  if (error) goto 100
  !
  ! Define output histogram
  n = len_trim(namex)
  if (n.eq.0) goto 100
  call gildas_null(x, type= 'TABLE') 
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  x%gil%ndim = 2
  x%gil%dim(1) = nh
  x%gil%dim(2) = 4
  x%loca%size = x%gil%dim(1)*x%gil%dim(2)
  hstep = (hmax-hmin)/(nh+1)
  allocate(x%r2d(nh,4), stat=ier)
  !
  call histo003(z%r1d,y%r1d,y%loca%size,y%gil%bval,y%gil%eval,   &
     &    x%r2d,x%gil%dim(1),hmin,hstep)
  call gdf_write_image (x,x%r2d,error)
  !
  call gagout('S-HISTO_DOUBLE,  Successful completion')
  call sysexi (1)
  !
100 call sysexi(fatale)
end program histo_double
!
subroutine histo003(z,y,n, bval,eval, x,nh,hmin,hstep)
  use gildas_def
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Computes the histogram of part of an Y image, as a
  !	function of another Z. The output histogram X contains
  !	(1)	Mean value of Y image
  !	(2)	Standard deviation
  !	(3)	Number of pixels
  !	(4)	Value of input Z image
  !
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: n                     !
  real, intent(in) :: z(n)           ! Array of histogram definition
  real, intent(in) :: y(n)           ! Array of values
  real, intent(in) :: bval                      ! Blanking
  real, intent(in) :: eval                      ! and tolerance
  integer(index_length), intent(in) :: nh       ! Size of histogram
  real, intent(out) :: x(nh,4)                  ! Histogram
  real, intent(in) :: hmin                      ! Minimum
  real, intent(in) :: hstep                     ! Step
  ! Local
  integer(kind=size_length) :: i, ntot,nin,nout,nblank
  integer :: nval, j
  !
  nin = 0
  nout = 0
  nblank = 0
  x = 0.0
  !
  do i=1,n
    if (abs(z(i)-bval).gt.eval) then
      nval = 1+int((z(i)-hmin)/hstep)
      if (nval.ge.1 .and. nval.le.nh) then
        if (abs(y(i)-bval).gt.eval) then
          x(nval,1) = x(nval,1)+y(i)
          x(nval,2) = x(nval,2)+y(i)**2
          x(nval,3) = x(nval,3)+1.
          nin = nin+1
        else
          nblank = nblank+1
        endif
      else
        nout= nout+1
      endif
    else
      nblank = nblank+1
    endif
  enddo
  !
  ! Now fill the histogram definition
  do j=1,nh
    x(j,4) = hmin + (n+0.5)*hstep
    if (x(j,3).ne.0.) then
      x(j,1) = x(j,1)/x(j,3)
      x(j,2) = sqrt(x(j,2)/x(j,3)-x(j,1)**2)
    endif
  enddo
  ntot = nin+nout+nblank
  write(6,100) nin,float(nin)/float(ntot)*1.e2,   &
     &    nout,float(nout)/float(ntot)*1.e2,   &
     &    nblank,float(nblank)/float(ntot)*1.e2,   &
     &    ntot
100 format(1x,'Number of points in histogram ',i8,4x,f5.1,' Z',   &
     &    /,'   "    "    "    out of  "    ',i8,4x,f5.1,' %',   &
     &    /,'   "    "    "    blanked      ',i8,4x,f5.1,' %',   &
     &    /,'                  Total      = ',i8)
end subroutine histo003

module astro_types
  use gildas_def
  use ast_params
  use ast_constant
  use astro_pfx_types
  !
  !side band handling
  integer(kind=4), parameter :: m_sideband=2
  integer(kind=4), parameter :: usb_code=1
  integer(kind=4), parameter :: lsb_code=2
  integer(kind=4), parameter :: sb_sign(m_sideband) =  (/ 1, -1/) ! +1 USB/-1 LSB used for tuning
  character(len=16), parameter :: sb_col(m_sideband) =  (/ 'BLUE', 'RED '/) ! USB in blue/ LSB in red
  character(len=3), parameter  :: sideband(m_sideband) = (/ 'USB', 'LSB'/)
  !
  ! Polarisation
  integer(kind=4), parameter :: m_polars=10     !max number of polarizations for a receiver
  integer(kind=4), parameter :: hpol_code=1
  integer(kind=4), parameter :: vpol_code=2
  ! basebands Inner Outer
  integer(kind=4), parameter :: outer_code=1
  integer(kind=4), parameter :: inner_code=2
  !
  ! Maximum numbers
  integer(kind=4), parameter :: m_boxes=20      !max number of frequency boxes in a plot page
  integer(kind=4), parameter :: m_tunings=10    !max number of tunings
  integer(kind=4), parameter :: m_rbands=10     !max number of receiver bands in a receiver
  integer(kind=4), parameter :: m_bbands=10     !max number of basebandsbands in a sideband
  integer(kind=4), parameter :: m_ifcables=16   !max number of if transport cable (PICO/EMIR)
  integer(kind=4), parameter :: m_backends=10   !max number of backends for a receiver
  integer(kind=4), parameter :: m_spw=256       !max number of spectral windows
  integer(kind=4), parameter :: m_res=3         !max number of spectral resolution in a setup
  integer(kind=4), parameter :: m_backunits=32  !max number of backend units
  integer(kind=4), parameter :: m_b2b=16  !max number of parasites affectig a FEBE
  !
  ! Frequency related
  real(kind=8), parameter :: undef_freq=-1d0
  real(kind=8), parameter :: khzpermhz=1d3
  real(kind=8), parameter :: mhzperkhz=1d0/1d3
  real(kind=8), parameter :: mhzperghz=1d3
  real(kind=8), parameter :: ghzpermhz=1d0/1d3
  real(kind=8), parameter :: toldoppler=1d-10
  !
  ! Plot Configuration
  ! Global colors
  integer(kind=4), parameter  :: idefcol=0
  integer(kind=4), parameter  :: iconfliccol=1
  character(len=16), parameter :: adefcol='BLACK' !
  character(len=16), parameter :: azcol='DARK_RED' !
  character(len=16), parameter :: apolcol='GREEN' !
  character(len=16),parameter :: amolcol='BLACK'
  character(len=16),parameter :: asweepfcol='WEB_PURPLE' ! spec sweep frequency coverage
  ! Info for polygon hatching
  real(kind=4), parameter :: hatch_info=45
  real(kind=4), parameter :: hatch_warning=-45
  !
  ! Plot modes (NOEMA)
  integer(kind=4), parameter :: m_pm=6
  integer(kind=4), parameter :: pm_receiver=1 ! RECEIVER mode (1 box = H/V IF)
  integer(kind=4), parameter :: pm_basebands=2 ! BASEBAND mode (1 box = H/V basebands)
  integer(kind=4), parameter :: pm_proposal=3 ! PROPOSAL mode (1 box with all)
  integer(kind=4), parameter :: pm_allbands=4 ! All bands mode 
  integer(kind=4), parameter :: pm_tunedbands=5 ! Tuned bands mode 
  integer(kind=4), parameter :: pm_zoom=6 ! Zoom mode 
  character(len=*), parameter  :: pm_names(m_pm) =  (/ 'RECEIVER  ','BASEBAND  ','PROPOSAL  ', &
                                                       'ALLBANDS  ','TUNEDBANDS','ZOOM      '/)
  !
  !Frequency axis choices
  integer(kind=4), parameter :: m_freqax=10
  integer(kind=4), parameter :: freqax_rest=1 ! REST
  integer(kind=4), parameter :: freqax_rf=2 ! RF
  integer(kind=4), parameter :: freqax_lsr=3 ! LSR
  integer(kind=4), parameter :: freqax_if1=4 ! IF1
  integer(kind=4), parameter :: freqax_if2=5 ! IF2
  integer(kind=4), parameter :: freqax_chunks=6 ! CHUNKS
  integer(kind=4), parameter :: freqax_imrest=7 ! IMREST
  integer(kind=4), parameter :: freqax_imrf=8 ! IMRF
  integer(kind=4), parameter :: freqax_imlsr=9 ! IMLSR
  integer(kind=4), parameter :: freqax_null=10 ! NULL
  character(len=12), parameter  :: freqax_names(m_freqax) = (/ 'REST  ','RF    ','LSR   ','IF1   ','IF2   ' &
                                                              ,'CHUNKS','IMREST','IMRF  ','IMLSR ','NULL  '/)
  !
  !Conflict/warnings
  character(len=16), parameter  :: aconflictcol='ORANGE' ! fill area + text
  character(len=16), parameter  :: aconflictcolh='CHOCOLATE' ! hatched area
  character(len=16), parameter  :: aconflictcolplot='WEB_GREY' ! hatched area
  character(len=16), parameter  :: aconfucol='GREY'
  !Color at receiver level
  character(len=16), parameter :: aoutcol='BLACK' ! out of rec band
  character(len=16), parameter :: aavailcol='DARK_GREY' ! available, not tuned
  character(len=16), parameter :: atunedcol='WHITE' ! tuned
  character(len=16), parameter :: anotselcol='LIGHT_GREY' !
  character(len=16), parameter :: abbifproccol='WEB_PURPLE' !
  character(len=16), parameter :: altunecol='MAGENTA' ! tuned freq
  character(len=16), parameter :: afrepcol='ROYAL_BLUE' ! representative freq
  ! Other global parameters
  real(kind=4), parameter :: ltuneheight=3./4. ! hight of the tuning line indicator
  real(kind=4), parameter :: frepheight=9./16. ! hight of the tuning line indicator
  !
  !Backend
  integer(kind=4), parameter :: icol_fill=1
  integer(kind=4), parameter :: icol_hatch=2
  integer(kind=4), parameter :: icol_border=3
  character(len=16), parameter  :: ahighrescol='PALE_GREEN'
  character(len=16), parameter  :: ahighrescolh='DARK_GREEN'
  character(len=16), parameter  :: ahighrescolr='LIME_GREEN'
  character(len=16), parameter  :: alowrescol='PAPAYA_WHIP'
  character(len=16), parameter  :: alowrescolh='SANDY_BROWN'
  character(len=16), parameter  :: alowrescolr='SANDY_BROWN'
  character(len=16), parameter  :: a250col='LIGHT_STEEL_BLUE'
  character(len=16), parameter  :: a250colh='STEEL_BLUE'
  character(len=16), parameter  :: a250colr='STEEL_BLUE'
  character(len=16), parameter  :: achunkcol='WEB_GREY'
  character(len=16), parameter  :: aoverlapcol='SEA_GREEN'
  !
  ! Types
  type :: receiver_desc_t
    ! describe an heterodyne receiver
    character(len=20) :: name                ! name of the receiver
    logical           :: defined=.false.
    real(kind=8)      :: iflim(2)              ! IF limits
    real(kind=8)      :: ifband                 ! IF bandwidth
    integer(kind=4)   :: n_rbands               ! number of receiver bands
    character(len=20) :: bandname(m_rbands)     ! name of the Bands
    ! Limits of the receiver bands
    real(kind=8)      :: rflim(2,m_rbands)      !  RF (sky) band edge TRUE HARDWARE
    real(kind=8)      :: rfcall(2,m_rbands)     ! RF (sky) band edge CALL for PROP
    real(kind=8)      :: rfcallreq(2,m_rbands)     ! RF (sky) limits for the reqested rf freq, CALL for PROP (mostly used for EMIR)
    real(kind=8)      :: restlim(2,m_rbands)     ! limits of the receiver bands TRUE --> taking into account current source doppler
    real(kind=8)      :: restcall(2,m_rbands)     ! limits of the receiver bands CALL FOR PROP --> taking into account current source doppler
    real(kind=8)      :: lolim(2,m_rbands)     ! limits of the LO for all the bands (used to check freq)
    real(kind=8)      :: lohard(2,m_rbands)     ! limits of the LO for all the bands ("true" hard limits)
    real(kind=8)      :: locall(2,m_rbands)     ! limits of the LO for all the bands (call for proposal limits)
    real(kind=8)      :: lotol                 ! tolerance beyond the call value
    real(kind=8)      :: rejection(m_rbands)    ! image side band rejection (dB)
    integer(kind=4)   :: n_sbands               ! number of sidebands in output of the receiver
    integer(kind=4)   :: n_polar                ! number of polar in output of the receiver
    integer(kind=4)   :: n_bbands                ! number of basebands in output of the receiver
    real(kind=8)      :: flo2                  ! LO frequency used to downconvert the basebands
    real(kind=8)      :: if1conf(2)           ! confusion zone (in IF1 because not the same in upper and lower)
    real(kind=8)      :: bblim(2,m_bbands)      ! limit of the basebands
    character(len=20) :: bbname(m_bbands)       ! name of the basebands
    real(kind=8)      :: bbref(m_bbands)       ! ref in the basebands
    character(len=20) :: polname(m_polars)       ! name of the polars
    integer(kind=4)   :: n_backends                   !number of associated Backends
    logical           :: tuninggrid             ! use a tuning grid
    real(kind=8)      :: gridbin                ! bins of the tuning grid (in LO) MHz
    real(kind=8)      :: gridtol                ! tolerance around the grid nodes MHz
    logical           :: redshift               ! .true. to take into account source redshift, .false. to ignore it
  end type receiver_desc_t
  !
  type :: receiver_source_t
    integer(kind=4)   :: sourcetype ! source kind to define the source handling
    logical           :: defined=.false.
    character(len=3)    :: invtype ! kind of velocity used to define the source
    character(len=sourcename_length) :: name
    real(kind=8)      :: jutc ! Time for which the source doppler was computed
    character(len=2)   :: coord ! coordinate frame
    real(kind=4)       :: eq ! equinox (in case of ra dec)
    character(len=16)  :: lambda
    character(len=16)  :: beta
    real(kind=8)       :: vdop !doppler + source LSR velocity 
    real(kind=8)       :: vdopmin !doppler + source LSR velocity  min over 1 year
    real(kind=8)       :: vdopmax !doppler + source LSR velocity  max over 1 year
    real(kind=8)       :: vlsr ! source LSR velocity
    logical            :: lsrdefined ! true if LSR actually set
    real(kind=8)       :: z      ! redshift
    real(kind=8)       :: zshift ! freq shift due to redshift
    real(kind=8)       :: dopshift ! freq shift dure to doppler + [source LSR velocity or redshift]
    real(kind=8)       :: dopmin ! min doppler shift
    real(kind=8)       :: dopmax ! max doppler shift
    real(kind=8)       :: lsrshift ! freq shift due source [LSR velocity OR redshift] only (no earth motion)
  end type receiver_source_t
  !
  type :: receiver_comm_t
    ! describe user input of receiver command
    character(len=20)  :: rec_name           ! rec name
    character(len=100) :: name           ! line name
    real(kind=8)       :: frest          ! line rest frequency GHz
    character(len=3)   :: sideband        ! USB/LSB
    real(kind=8)       :: fcent          ! IF frequency where RF Frest is tuned
  end type receiver_comm_t
  !
  type receiver_tune_t
    ! tuning dependent parameters of a receiver
    character(len=40) :: name=''           ! line name
    integer(kind=4)   :: iband          ! Used frequency band
    real(kind=8)      :: flo1=0d0           ! LO1 frequency (including doppler tracking)
    real(kind=8)      :: flo1dmin=0d0           ! LO1 frequency (including min doppler)
    real(kind=8)      :: flo1dmax=0d0          ! LO1 frequency (including max doppler)
    real(kind=8)      :: flotune        ! LO1 frequency (used for tuning on a grid)
    real(kind=8)      :: frest          ! reference rest frequency MHz
    real(kind=8)      :: frf           ! RF (sky) frequency MHz
    real(kind=8)      :: flsr           ! frequency corrected for lsr (no doppler) MHz
    real(kind=8)      :: fcent          ! IF center frequency (where frest is tuned)
    character(len=200) :: label         ! Summary of tuning parameters
    logical           :: outlo          ! to warn when between the call and the wide values
    logical           :: ongrid          ! to indicate whether the current tuning respects the optimized tuning grid
    !sideband related
    integer(kind=4)    :: sb_code       !
  end type receiver_tune_t
  !
  type receiver_t
    integer(kind=4)       :: n_tunings
    type(receiver_desc_t) :: desc
    type(receiver_source_t) :: source
    type(receiver_comm_t) :: comm(m_tunings)
    type(receiver_tune_t) :: tune(m_tunings)
  end type receiver_t
  !
  type backend_unit_t
  !describe a correlator unit
    integer(kind=4)     :: n_chunks             ! number of chunks
    real(kind=8)        :: ifmin
    real(kind=8)        :: ifmax
    real(kind=8)        :: ifcenter
    real(kind=8)        :: width
    integer(kind=4)     :: iband    ! receiver processed by unit
    integer(kind=4)     :: sb_code   ! sideband processed by unit
    integer(kind=4)     :: bb_code   ! baseband processed by unit
    integer(kind=4)     :: pol_code  ! polar processed by unit
    character(len=5)    :: label        !
  end type backend_unit_t
  !
  type backend_mode_t
    !describe backend mode
    character(len=50)   :: backname             !backend name
    character(len=50)   :: modename             ! mode name
    integer(kind=4)     :: n_backunits          ! number of units (processes 1 baseband)
    real(kind=8)        :: iflim(2,m_bbands)    ! iflim as a function of baseband - order should be the same as taken in rec%desc
    integer(kind=4)     :: m_chunks
    type(backend_unit_t) :: unit(m_backunits)
  end type backend_mode_t
  !
  type backend_t
    character(len=50) :: name
    integer(kind=4) :: n_backmodes
    integer(kind=4) :: imode
    type(backend_mode_t) :: mode(m_backmodes)
  end type backend_t
  !
  type emir_comm_t
    !emir command parameters
    integer(kind=4)     :: n_tunings
    real(kind=8)        :: frest(m_tunings) ! GHz
    character(len=argument_length)    :: code(m_tunings)
    character(len=50)     :: zoommode 
    real(kind=8)        :: fz1,fz2
    logical             :: fixed_scale
  end type emir_comm_t
  !
  type emir_setup_t
    !emir setup
    character(len=3):: sb_mode ! sideband connected to backend 2SB or SSB
    integer(kind=4):: sb_code(m_tunings) !
    character(len=10) :: polmode          ! polar connected to backend: DUAL/SINGLE/USER
    character(len=3) :: polar(m_tunings)  ! in single polar, the 2 tunings have different polar
    integer(kind=4)    :: pol_code(m_tunings) ! 1=H or 2=V
  end type emir_setup_t
  !
  type if_cable_t
    character(len=5)    :: label
    integer(kind=4)     :: iband
    integer(kind=4)     :: sb_code
    integer(kind=4)     :: bb_code
    integer(kind=4)     :: pol_code
  end type if_cable_t
  !
  type correlator_input_t
    character(len=20)   :: mode              ! switchbox command mode : AUTO/SINGLE/LIST
    logical             :: defined           ! to know whether it has been configured
    integer(kind=4)     :: m_usercables      ! number of cables defined by the user !for emir
    integer(kind=4)     :: n_ifcables        ! number of if cables
    type(if_cable_t)    :: ifc(m_ifcables)   ! individual if cable descritpion
  end type correlator_input_t
  !
  type emir_t
    type(emir_comm_t) :: comm
    type(emir_setup_t) :: setup
    type(receiver_t)    :: rec            ! receiver stuff
    type(correlator_input_t) :: switch
    type(backend_t)       :: be(m_backends) ! backends
  end type emir_t
  !
  type if_selection_t
    ! define a subset of if_cables on which the following SPW commands will work
    integer(kind=4)     :: n_ifsel              ! number of if ranges in the present SPW session
    character(len=4)    :: polmode              ! H,V,B to make the difference between single and dual polar cases
    integer(kind=4)      :: usel(m_backunits)    ! index of the selected pfx units
  end type if_selection_t
  !
  type noema_tuning_comm_t
    !recnoema command parameters
    logical             :: dotune ! no when only info, no tuning
    character(len=12)   :: name
    real(kind=8)        :: frest ! GHz
    real(kind=8)        :: fcent ! MHz
    character(len=3)    :: sideband ! LSB or USB
    character(len=50)   :: zoommode
    real(kind=8)        :: fz1,fz2
    logical             :: fixed_scale
    logical             :: fixedfreq
  end type noema_tuning_comm_t
  !
  type noema_if_t
!    type(noema_comm_t) :: comm
    type(correlator_input_t) :: ifproc
    type(if_selection_t) :: selunit
  end type noema_if_t
  !
  type spw_comm_t
    real(kind=4)    :: resol ! in kHz
    integer(kind=4) :: itype
    integer(kind=8) :: time=-1 ! time when the command was typed (to have chronology)
    logical     :: allowconflict ! if true then it is authorized to go on when a conflict occurs 
    real(kind=8) :: fmin
    real(kind=8) :: fmax
    character(len=32) :: user_label=''
  end type spw_comm_t
  !
  type spw_unit_t
    integer(kind=4)     :: iband     ! receiver processed by unit
    integer(kind=4)     :: sb_code   ! sideband processed by unit
    integer(kind=4)     :: bb_code   ! baseband processed by unit
    integer(kind=4)     :: pol_code  ! polar processed by unit
    character(len=5)    :: label        !
    integer(kind=4)     :: itype        ! Correl mode/type used for the SPW
    real(kind=8)  :: restmin       !rest freq
    real(kind=8)  :: restmax       !rest freq
    integer(kind=4) :: ich1
    integer(kind=4) :: ich2
    real(kind=4) :: resol              !kHz
    character(len=32)    :: user_label=''        !
    logical             :: flexible     ! true = tunable, false = fixed
    logical             :: conflict     ! true if 1 of the chunks is used by several spw
    logical             :: overload     ! true if correl unit uses more resource than possible
    logical             :: chunk1     ! true if highres chunk 1 is used
    integer(kind=8)     :: ctime        ! creation time
  end type spw_unit_t
  !
  type spw_output_t
    integer(kind=4) :: n_spw
    type(spw_unit_t) :: win(m_spw)
  end type spw_output_t
  !
  type spw_t
    type(spw_comm_t)      :: comm
    type(spw_output_t)    :: out
  end type spw_t
  !
  type febe_userinfo_t
    real(kind=8) :: user_frep=astro_nullr8 !MHz
    real(kind=8) :: user_resol=astro_nullr8  !MHz
    character(len=256) :: user_res_unit=astro_nulla
    character(len=256) :: user_exp=astro_nulla
    character(len=256) :: user_expcont=astro_nulla    
  end type febe_userinfo_t
  !
  type febe_b2b_crosstalks_t
    ! Information about parasites affecting a FEBE
    logical :: defined=.false.
    integer(kind=4) :: n_b2b=0
    real(kind=8), allocatable :: freq(:)
  end type febe_b2b_crosstalks_t
  !
  type noema_febe_t
    ! Set of frontend backend parameters
    ! Some descriptors
    integer(kind=4) :: id=0
    character(len=32) :: name
    logical :: defined=.false.
    logical :: loaded=.false.
    ! Actual structures
    type(receiver_comm_t)          :: reccomm            ! receiver tuning input
    type(receiver_tune_t)          :: rectune            ! receiver tuning result
    type(noema_tuning_comm_t) :: tune           ! noema tuning command
    type(noema_if_t)          :: i_f            ! if processor and selection
    type(pfx_t)               :: pfx            ! polyfix backend
    type(spw_t)               :: spw            ! spw collection (defined by polyfix settings)
    type(febe_userinfo_t)      :: uinfo          ! Information to/from PMS
    type(febe_b2b_crosstalks_t) :: b2b ! Information about parasites affecting a FEBE
    !
  end type noema_febe_t
  !
  type noema_febe_selection_t
    ! Describe the selection of FEBE as done in /FEBE option (PROPOSAL or SETUP command)
    integer(kind=4) :: nsel=0
    integer(kind=4) :: nbands
    integer(kind=4), allocatable :: selnum(:) ! number in the saved FEBE
    integer(kind=4), allocatable :: selidx(:) ! index of the selected FEBE in the register
    integer(kind=4), allocatable :: iband(:) ! band of each FEBE
    integer(kind=4), allocatable :: bandsel(:) ! band selection (size nsel) for the selected FEBE
    integer(kind=4), allocatable :: tuning_count(:) ! number of tuning per band (size n_rband)
  end type noema_febe_selection_t
  !
  type info_pms_t
    ! put together all info to be provided to PMS (plot /proposal)
    ! Related to tuning
    integer(kind=4)     :: tuning_band
    real(kind=8)        :: tuning_freq
    real(kind=8)        :: tuning_flo1
    real(kind=8)        :: tuning_maxrf ! highest rf freq
    real(kind=8)        :: tuning_minrf ! lowest rf freq
    logical             :: tuning_ongrid
    logical             :: tuning_outlo ! true means out of Call for prop limits
    logical             :: redshift
    real(kind=8)        :: lsrlim(m_sideband,2)  ! lsb min, lsb max, usb min, usb max limits in LSR (for Tsys comparison)
    ! Related to backend
    ! - LSR/Redshift range
    real(kind=8)        :: lsrrange
    real(kind=8)        :: zrange
    ! Usage
    integer(kind=4)     :: mflex ! total number of flexible chunks available (all units merged)
    integer(kind=4)     :: nflex ! total number of flexible chunks used (all units merged)
    logical             :: chunk1 ! chunk 1 raise a warning
    ! - Representative frequency
    real(kind=8)        :: frep                 !rest frame
    real(kind=8)        :: freplsr               ! representative freq in LSR frame (for Tsys and sensitivity)
    real(kind=8)        :: resrep                ! user input spectral resolution
    integer(kind=4)     :: npolrep                ! nb of polar with user input spectral resolution
    integer(kind=4)     :: nspw
    integer(kind=4)     :: nresol              ! number of different spectral resolution covering the repr. freq
    real(kind=8)        :: resol(m_chtypes)     ! resolutions covering the repr. freq
    integer(kind=4)     :: npol(m_chtypes)      ! numb of polarization covering the repr. freq (in each resolution)
    ! Continuum Part
    real(kind=8)        :: fcont                ! representative frequency for continuum (REST FRAME)
    real(kind=8)        :: fcontlsr             ! representative frequency for continuum (LSR frame)
    real(kind=8)        :: fcontw20             ! representative frequency for continuum (LSR frame) - special semester W20
    real(kind=8)        :: dfcont               ! total bandwidth covered
    real(kind=8)        :: rescont              ! Channel spacing (lowest resolution for information only in PMS)
    integer(kind=4)     :: npolcont             ! number of polarization in continuum mode
    !Tracksharing case
    logical             :: tracksharing 
    real(kind=8)        :: tsdf(2)              ! offset in frequency for Sources with values Vmin and Vmax
    logical             :: ts_freqout           ! true if 1 of the frequency gets out of range
    ! User information
    character(len=256)  :: user_res_unit
    character(len=256)  :: user_fline
    character(len=256)  :: user_fcont
    ! B2B cross talk in dual band
    integer(kind=4)     :: n_b2b
    real(kind=8) :: b2b_freq(m_b2b)
  end type info_pms_t
  !
  type draw_axis_t
    character(len=3)    :: pos          ! UP or LOW
    character(len=4)    :: tick='IN'     ! I O N
    character(len=1)    :: label='P'    !  P O N
    character(len=16)   :: aboxcol='BLACK'
    character(len=16)   :: alabcol='BLACK'
  end type draw_axis_t
  !
  type frequency_box_phys_t
    ! Physical description of a box
    real(kind=8)        :: xmin          ! x left position
    real(kind=8)        :: xmax          ! x right position
    real(kind=8)        :: ymin          ! y lower position
    real(kind=8)        :: ymax          ! y upper position
    real(kind=8)        :: sx           ! x size
    real(kind=8)        :: sy           ! y size
  end type frequency_box_phys_t
  !
  type frequency_box_user_t
    ! user defined parameters of a box
    real(kind=8)        :: xmin          ! x left limit
    real(kind=8)        :: xmax          ! x right limit
    real(kind=8)        :: ymin=0        ! y lower limit
    real(kind=8)        :: ymax=5        ! y upper limit
    character(len=50)   :: name=''       ! name of the Axis
    character(len=3)   :: unit='MHz'     ! unit
    logical :: defined=.false.           ! to check before drawing
  end type frequency_box_user_t
  !
  type frequency_box_t
    !global structure that characterize a box : physical coordinates + all frequency axis
    integer(kind=4)                  :: bb_code
    integer(kind=4)                  :: sb_code
    integer(kind=4)                  :: iband
    type(frequency_box_phys_t)       :: phys
    type(frequency_box_user_t)       :: rest            ! freq in the frame of the source
    type(frequency_box_user_t)       :: lsr             ! freq corrected for LSR or Redshift (no earth)
    type(frequency_box_user_t)       :: rf             ! freq corrected for LSR or Redshift + earth
    type(frequency_box_user_t)       :: imrest
    type(frequency_box_user_t)       :: imrf
    type(frequency_box_user_t)       :: imlsr
    type(frequency_box_user_t)       :: if1
    type(frequency_box_user_t)       :: if2
    type(frequency_box_user_t)       :: chunks
  end type frequency_box_t
  !
  type current_boxes_desc_t
    integer(kind=4)   :: plotmode  ! according to plotmodes defined above
    real(kind=4)      :: hugechar   
    real(kind=4)      :: defchar   
    real(kind=4)      :: smallchar
    real(kind=4)      :: molchar
  end type  current_boxes_desc_t
  !
  type current_boxes_t
    ! current state of the plot pages - nbox boxes described by frequency_box_t(nbox)
    integer(kind=4) :: nbox=0
    type(current_boxes_desc_t) :: desc
    type(frequency_box_t) :: box(m_boxes)
  end type current_boxes_t
  !
  type draw_mark_t
    !parameters needed to draw a line
    real(kind=8)        :: x    ! x positions
    real(kind=8)        :: y    ! y positions
    character(len=16)   :: ref       ! reference for coordinates (USER,PHYSICAl,BOX,CHARACTER)
    integer(kind=4)   :: iref       ! iref (for box and character)
    integer(kind=4)     :: nside=0        ! number of sides of the marker
    integer(kind=4)     :: style=0        ! follows g\set mark
    real(kind=4)     :: s=0.5            ! size in physical units
    character(len=16)   :: col='BLACK'  ! pen color
    logical             :: clip=.false.
  end type draw_mark_t
  !
  type draw_line_t
    !parameters needed to draw a line
    real(kind=8)        :: xmin,xmax    ! x positions
    real(kind=8)        :: ymin,ymax    ! y positions
    character(len=16)   :: col='BLACK'  ! pen color
    integer(kind=4)     :: dash=1       ! pen dash
  end type draw_line_t
  !
  type draw_interbox_line_t
    !parameters needed to draw a line between 2 boxes
    integer(kind=4)     :: ibox(2)      ! boxes
    real(kind=8)        :: xpos(2)      ! x position
    real(kind=8)        :: ypos(2)      ! y positions
    character(len=16)   :: frame(2)     ! frame for values
    character(len=16)   :: col='BLACK'  ! pen color
    integer(kind=4)     :: dash=1       ! pen dash
  end type draw_interbox_line_t
  !
  type draw_rect_t
    !parameters needed to draw a rectangle
    real(kind=8)        :: xmin,xmax    ! x positions
    real(kind=8)        :: ymin,ymax    ! y positions
    real(kind=4)        :: hang=45      ! angle for hatching (if hacthing is chosen)
    character(len=16)     :: col='BLACK'   ! pen color
    integer(kind=4)     :: dash=1          ! pen dash
  end type draw_rect_t
  !
  type draw_gauss_t
    !parameters needed to draw a guassian
    real(kind=8)        :: xcent    ! x position
    real(kind=8)        :: fwhm    ! fwhm
    real(kind=8)        :: ymin,ymax    ! y positions
    character(len=16)   :: col='BLACK'          ! pen color
    integer(kind=4)     :: dash=1          ! pen dash
  end type draw_gauss_t
  !
  type plot_molecules_t
    ! Describes the global behavior for plotting molecular lines
    character(len=filename_length) :: catalog='' ! Name of the catalog. Default is GILDAS one.
    logical            :: doplot=.False.          ! Plot the lines ?
    character(len=12)  :: profile="BOXCAR"        ! Profile of the lines to plot
    real(kind=8)       :: width=0d0               ! Width of the lines to plot [MHz]
  end type plot_molecules_t
  !
  type frequency_axis_t
    ! Describes the global frequency axis used (for NOEMA and EMIR frequency coverages)
    character(len=16)  :: main='REST'        ! lower axis of plots + commands
    character(len=16)  :: second='NULL'        ! upper axis of plots
  end type frequency_axis_t
  !
  type astro_noemareceiver_t
    ! plot pfx configuration from outside ASTRO (CLIC/OBS)
    ! receiver/source part
    real(kind=8) :: flo1 ! frequency of the tuning
    real(kind=8) :: fcent ! MHZ IF1
    integer(kind=4) :: sbcode ! USB or LSB
    character(len=12) :: tuningname ! tuning name
    character(len=12) :: sourcename ! sourcename
    real(kind=8) :: obsdoppler ! current doppler
  end type astro_noemareceiver_t
  !
  type astro_noemaspw_t
    ! plot pfx configuration from outside ASTRO (CLIC/OBS)
    ! spw part
    integer(kind=4) :: n_spw=0 ! number of defined spw
    integer(kind=4) :: chunkmin(m_spw) ! first chunk of spw
    integer(kind=4) :: chunkmax(m_spw) ! last chunk of spw
    real(kind=8) :: resol(m_spw) ! spectral resolution
    character(len=5) :: label(m_spw) ! format: B1HUO,B2HUI,...
    character(len=32) :: user_label(m_spw) ! spw name as stated by user
    integer(kind=4) :: corrmode(m_spw) ! correlator mode
  end type astro_noemaspw_t
  !
  type astro_noemasetup_t
    ! plot pfx configuration from outside ASTRO (CLIC/OBS)
!     character(len=4)  :: mode ! CLIC or OBS ! could set defaults for computations/visualization ?
    type(astro_noemareceiver_t) :: rec
    type(astro_noemaspw_t) :: spw
  end type astro_noemasetup_t
  !
end module astro_types
!
module string_parser_types
  !
  ! Support module for "string parser". See string-parser.f90 for details.
  !
  integer(kind=4), parameter :: substring_parser_mval=4
  integer(kind=4), parameter :: substring_parser_mchar=2
  type :: substring_parser_t
    integer(kind=4) :: nval
    character(len=substring_parser_mchar) :: val(substring_parser_mval)
  end type substring_parser_t
  !
  integer(kind=4), parameter :: string_parser_msub=4
  type :: string_parser_t
    logical :: active(string_parser_msub) = .false.
    type(substring_parser_t) :: substring(string_parser_msub)
  end type string_parser_t
  !
end module string_parser_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 
module cubeadm_ancillary_cube_types
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_messaging
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  !
  public :: ancillary_cube_comm_t,ancillary_cube_user_t,ancillary_cube_prog_t
  private
  !
  type ancillary_cube_comm_t
     type(option_t), pointer :: key
     type(cubeid_arg_t), pointer :: cube
   contains
     procedure, public :: fully_register => cubeadm_ancillary_cube_comm_fully_register
     procedure, public :: parse          => cubeadm_ancillary_cube_comm_parse
  end type ancillary_cube_comm_t
  !
  type ancillary_cube_user_t
     logical             :: present = .false.
     type(cubeid_user_t) :: id
   contains
     procedure, public :: toprog => cubeadm_ancillary_cube_user_toprog
     procedure, public :: list   => cubeadm_ancillary_cube_user_list
  end type ancillary_cube_user_t
  !
  type ancillary_cube_prog_t
     character(len=80), private :: abstract = strg_unk ! ***JP: abst_l=80 is defined in structure-argument.f90!
     logical               :: do = .false.
     type(cube_t), pointer :: cube
   contains
    procedure, public :: list => cubeadm_ancillary_cube_prog_list
  end type ancillary_cube_prog_t
  !
contains
  !
  subroutine cubeadm_ancillary_cube_comm_fully_register(comm,&
       keyname,keysyntax,keyabstract,keyhelp,&
       cubename,cubeabstract,cubeflags,&
       cubemandatory,cubestatus,cubeaccess,error,cubehelp)
    use cubetools_flag_types
    !----------------------------------------------------------------------
    ! Register a "/KEYNAME [cubeid]" key
    !----------------------------------------------------------------------
    class(ancillary_cube_comm_t), intent(inout) :: comm
    character(len=*),             intent(in)    :: keyname
    character(len=*),             intent(in)    :: keysyntax
    character(len=*),             intent(in)    :: keyabstract
    character(len=*),             intent(in)    :: keyhelp
    character(len=*),             intent(in)    :: cubename
    character(len=*),             intent(in)    :: cubeabstract
    type(flag_t),                 intent(in)    :: cubeflags(:)
    integer(kind=code_k),         intent(in)    :: cubemandatory
    integer(kind=code_k),         intent(in)    :: cubestatus
    integer(kind=code_k),         intent(in)    :: cubeaccess
    logical,                      intent(inout) :: error
    character(len=*),             intent(in), optional :: cubehelp
    !
    type(cubeid_arg_t) :: incube
    character(len=:), allocatable :: my_cubehelp
    character(len=*), parameter :: rname='ANCILLARY>CUBE>COMM>FULLY>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         keyname,&
         keysyntax,&
         keyabstract,&
         keyhelp,&
         comm%key,&
         error)
    if (error) return
    if (present(cubehelp)) then
       my_cubehelp = cubehelp
    else
       my_cubehelp = strg_emp
    endif
    call incube%register(&
         cubename,&
         cubeabstract,&
         my_cubehelp,&
         cubemandatory,&
         cubeflags,&
         cubestatus,&
         cubeaccess,&
         comm%cube,&
         error)
    if (error) return
  end subroutine cubeadm_ancillary_cube_comm_fully_register
  !
  subroutine cubeadm_ancillary_cube_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! /KEYNAME [cubeid]
    !----------------------------------------------------------------------
    class(ancillary_cube_comm_t),  intent(in)    :: comm
    character(len=*),              intent(in)    :: line
    class(ancillary_cube_user_t),  intent(inout) :: user
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='ANCILLARY>CUBE>COMM>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%present,error)
    if (error) return
    if (user%present) then
       call cubeadm_cubeid_parse(line,comm%key,user%id,error)
       if (error) return
    endif
  end subroutine cubeadm_ancillary_cube_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeadm_ancillary_cube_user_init(user,error)
    !----------------------------------------------------------------------
    ! Initialize by setting the intent of ancillary_cube_user_t to out
    !----------------------------------------------------------------------
    class(ancillary_cube_user_t), intent(out)   :: user
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='ANCILLARY>CUBE>USER>INIT'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
  end subroutine cubeadm_ancillary_cube_user_init
  !
  subroutine cubeadm_ancillary_cube_user_toprog(user,comm,prog,error,access)
    use cubeadm_get
    !----------------------------------------------------------------------
    ! Resolve cubeid into a cube
    !----------------------------------------------------------------------
    class(ancillary_cube_user_t),   intent(in)    :: user
    class(ancillary_cube_comm_t),   intent(in)    :: comm
    class(ancillary_cube_prog_t),   intent(inout) :: prog
    logical,                        intent(inout) :: error
    integer(kind=code_k), optional, intent(in)    :: access
    !
    character(len=*), parameter :: rname='ANCILLARY>CUBE>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    prog%do = user%present
    prog%abstract = comm%key%abstract
    if (prog%do) then
       call cubeadm_get_header(comm%cube,user%id,prog%cube,error,access)
       if (error) return
    endif
  end subroutine cubeadm_ancillary_cube_user_toprog
  !
  subroutine cubeadm_ancillary_cube_user_list(user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ancillary_cube_user_t), intent(in)    :: user
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='ANCILLARY>CUBE>USER>LIST'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! ***JP: to be written
  end subroutine cubeadm_ancillary_cube_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeadm_ancillary_cube_prog_list(prog,key,error)
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ancillary_cube_prog_t), intent(in)    :: prog
    character(len=*),             intent(in)    :: key
    logical,                      intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='ANCILLARY>CUBE>PROG>LIST'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_message(seve%r,rname,'')
    mess = cubetools_format_stdkey_boldval(key,'Cube Mask',40)
    call cubeadm_message(seve%r,rname,mess)
    ! ***JP: And then I should have something like:
    !I MASK mask                * =>  2 3D ch3oh21-s1-fts mask      30M HORSEHEAD ch3oh21 3.75 kiB    
  end subroutine cubeadm_ancillary_cube_prog_list
end module cubeadm_ancillary_cube_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine flux_read (line,error)
  !---------------------------------------------------------------------
  !     Command
  !     FLUX\READ Antenna Frequency
  !     with frequency in GHz
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'flux.inc'
  !
  call sic_i4 (line,0,1,nantenna,.true.,error)
  if (error) return
  call sic_r8 (line,0,2,frequency,.true.,error)
end subroutine flux_read
!
subroutine read_flux(file,antenna,freqobs,date,n_source,   &
     &    source,sarea,sdarea,flux,gainis,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! ASTRO This subroutine -reads the input file from CLASS or CLIC (print FLUX)
  !			-reads the selected antenna and frequency
  !			-corrects from pointing errors
  !			-corrects frequency from gains USB/LSB measurements
  !			-calculates the flux from planets (call to subroutine
  !	flux_planet at the corrected frequency)
  !
  ! Arguments:
  !   Input: character *(80) FILE	name of file from Class or Clic
  !   Input: integer ANTENNA	Antenna number
  !   Input: R*8 FREQOBS		Frequence selected to compute
  !                               fluxes (generaly 86 or 110 GHz).
  !   Output: Character*12 DATE 	Observing date
  !   Output: integer N_SOURCE 	Number of sources
  !                               (corrected from U/L gain).
  !   Output: character*12 SOURCE(N_SOURCE)	Name of source
  !   Output: real SAREA(N_SOURCE)		Mean area corrected
  !                                               from pointing (Sarea/Warea)
  !   Output: real SDAREA(N_SOURCE)		Errors on Area
  !   Output: real FLUX(N_SOURCE)		Flux from planets only
  !   Output: real GAINIS  		Gain I/S
  !   Input/Output: logical ERROR
  !---------------------------------------------------------------------
  character(len=*) :: file          !
  integer :: antenna                !
  real*8 :: freqobs                 !
  character(len=*) :: date          !
  integer :: n_source               !
  character(len=*) :: source(*)     !
  real*8 :: sarea(*)                !
  real*8 :: sdarea(*)               !
  real*8 :: flux(*)                 !
  real*4 :: gainis                  !
  logical :: error                  !
  ! Local
  integer :: m_source
  parameter (m_source=100)
  character(len=12) :: sour,sdat
  integer :: i,ier
  real*8 :: area,darea, warea(m_source), nu(m_source)
  real :: gaini,snui,inui
  real :: gainj,snuj,inuj
  real :: az,el,time,daz,ddaz,waz,dwaz,areaj,daj
  real :: del,ddel,wel,dwel,areai,dai
  integer :: jnum,jscan,jcode,jant
  integer :: inum,iscan,icode,iant
  integer :: nf
  logical :: found, existe
  real*8 :: freqeq, dnui
  !
  ! Programme
  error = .false.
  !
  ier = 0
  nf = lenc(file)
  ier = sic_open (1,file(1:nf),'OLD',.true.)
  if (ier.ne.0) then
    call gagout('E-READ_FLUX,  Cannot open input file')
    call putios('E-READ_FLUX,  ',ier)
    error = .true.
    return
  endif
  read (1,100)
  read (1,100)
  read (1,100)
  read (1,100)
  !
  n_source = 0
  !
  existe = .true.
  dnui = 10.0
  iant = 0
  !
  date = ' '
  do while (.true.)
    ! Test sur la frequence et l'antenne:
    do while (antenna.ne.iant .or. abs(dnui).gt.1.0)
      read(1,*,end=10) inum,iscan,icode,az,el,time,daz,ddaz,iant,   &
     &        waz,dwaz,areai,dai,gaini,snui,inui,sour,sdat
      if (antenna.eq.iant) dnui = freqobs-snui
    enddo
    existe = .false.
    jant = 0
    jscan = 0
    if (date.ne.sdat) then
      call gagout('W-READ_FLUX,  Date changed, now '//sdat)
      date = sdat
    endif
    !
    ! Do NOT Assume consecutive Az & El data, but start with Az (or El)
    ! and now Search the associated El (resp Az) Scan
    do while (iant.ne.jant .or. iscan.ne.jscan)
      read(1,*,end=10) jnum,jscan,jcode,az,el,time,del,ddel,   &
     &        jant,wel,dwel,areaj,daj,gainj,snuj,inuj,sour
    enddo
    !
    ! Correct for pointing
    waz = waz/(2.*sqrt(log(2.)))   ! FWHM_TO_1/E
    wel = wel/(2.*sqrt(log(2.)))   ! FWHM_TO_1/E
    area = areai*exp((del/wel)**2)+areaj*exp((daz/waz)**2)
    area = 0.5*area
    darea =  (dai*exp((del/wel)**2))**2 +   &
     &      (daj*exp((daz/waz)**2))**2
    darea = 0.5*sqrt(darea)
    inui = (snui+gaini*inui)/(1+gaini)
    !
    found = .false.
    i = 1
    do while (.not.found .and. i.le.n_source)
      if (sour.eq.source(i)) then
        sarea(i) = sarea(i)+area
        sdarea(i) = sdarea(i)+darea**2
        warea(i) = warea(i)+1.0
        nu(i) = inui
        found = .true.
      endif
      i = i+1
    enddo
    if (.not.found) then
      n_source = n_source+1
      source(n_source) = sour
      sdarea(n_source) = darea**2  ! /SIGMA**2
      sarea(n_source) = area   ! /SIGMA**2
      warea(n_source) = 1      ! /SIGMA**2
      nu(n_source) = inui
    endif
    gainis = gaini
    ! Next data
    dnui = 10.0
    iant = 0
  enddo
  !
  ! Moyenne de l'aire + CAS DES PLANETES:
  10    continue
  close(unit=1)
  !
  if (existe) then
    error=.true.
    write(6,*) 'E-FLUX,  Wrong antenna ',antenna,   &
     &      ' or frequency ',freqobs
    goto 999
  endif
  !
  write(6,*) 'W-FLUX Sources in the file:'
  do i=1, n_source
    freqeq = nu(i)
    if (source(i).eq.'MERCURY' .or. source(i).eq.'VENUS'   .or.  &
        source(i).eq.'MARS'    .or. source(i).eq.'JUPITER' .or.  &
        source(i).eq.'SATURN'  .or. source(i).eq.'URANUS'  .or.  &
        source(i).eq.'NEPTUNE') then
      call planet_flux(source(i),date,freqeq,flux(i),error)
      if (error) goto 999
    else
      flux(i) = 0.0
    endif
    flux(i) = -flux(i)
    sarea(i) = sarea(i)/warea(i)
    sdarea(i) = sqrt(sdarea(i)/warea(i))
    write(6,110) source(i), 'weight:', warea(i)
  enddo
  !
  !True frequency of observation (gain corrected):
  freqobs = freqeq
  !
  100   format(a)
  110   format(5x,a,2x,a,1x,f2.0)
  !
  return
  999   error=.true.
end subroutine read_flux

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_mx
  use gbl_message
  !
  public :: old_mx_comm
  public :: domima
  private
  !
contains
  !
  subroutine old_mx_comm(line,error)
    use phys_const, only: pi
    use gkernel_interfaces
    use uv_continuum, only: map_beams,map_parameters
    use uv_shift, only: map_get_radecang
    use uv_rotate_shift_and_sort_tool, only: uv_sort_main
    use uvmap_tool, only: map_prepare,new_dirty_beam
    use uvmosaic_tool, only: many_beams_para
    use clean_tool, only: check_area,cct_prepare,clean_data
    use clean_support_tool, only: check_mask
    use clean_flux_tool, only: init_plot,init_flux,close_flux
    use clean_types, only: beam_unit_conversion
    use map_buffers
    use file_buffers
    use uv_buffers
    use uvmap_buffers
    use clean_buffers
    !------------------------------------------------------------------------
    ! Compute a map from a CLIC UV Sorted Table by Gridding and Fast
    ! Fourier Transform, using adequate scratch space for
    ! optimisation. Will work for up to 128x128x128 cube data size, may be
    ! more...
    !
    ! Input :
    !     a precessed UV table
    ! Output :
    !     a precessed, rotated, shifted UV table, sorted in V,
    !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    !     a beam image or cube
    !     a LMV cube
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
    !
    real, allocatable :: w_mapu(:), w_mapv(:), w_grid(:,:)
    real, allocatable :: res_uv(:,:)
    real(8) new(3)
    logical :: found(3)
    real(4) rmega,uvmax,uvmin,uvma
    integer wcol,mcol(2),nfft,sblock
    integer ier
    logical one, sorted, shift
    character(len=message_length) :: chain
    real cpu0, cpu1
    real(8) :: freq
    real, allocatable :: fft(:)
    integer nx,ny,nu,nv,nc,np,nb
    !
    logical limits
    real ylimn,ylimp
    integer ipen
    !
    integer, save :: saved_mcol(2)=[0,0]
    character(len=*), parameter :: rname='MX'
    !
    if (uvmap_prog%nfields.ne.0) then
       call map_message(seve%e,rname,'UV data is a Mosaic, not supported')
       error = .true.
       return
    endif
    !
    call map_prepare(rname,uvmap_prog,error)
    if (error) return
    !
    if (rname.eq.'MX') then
       if (uvmap_prog%beam.ne.0) then
          call map_message(seve%e,rname,'Only works of 1 beam in total (so far)')
          error = .true.
          return
       endif
    endif
    !
    one = .true.
    call sic_get_inte('WCOL',wcol,error)
    call sic_get_inte('MCOL[1]',mcol(1),error)
    call sic_get_inte('MCOL[2]',mcol(2),error)
    !
    call sic_get_logi('UV_SHIFT',shift,error)
    if (shift) then
       ! Read MAP_RA, MAP_DEC, MAP_ANGLE
       call map_get_radecang(rname,found,new,error)
       if (error)  return
       if (.not.all(found)) then
          call map_message(seve%e,rname,'MAP_RA and MAP_DEC must be defined')
          error = .true.
          return
       endif
    else
       new(:) = 0.d0
    endif
    !
    ! First sort the input UV Table, leaving UV Table in UV_*
    call gag_cpu(cpu0)
    call uv_sort_main(error,sorted,shift,new,uvmax,uvmin)
    if (error) return
    if (.not.sorted) then
       ! Redefine SIC variables (mandatory)
       call sic_delvariable ('UV',.false.,error)
       call sic_mapgildas('UV',huv,error,duv)
    endif
    call gag_cpu(cpu1)
    write(chain,102) 'Finished sorting ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    call map_parameters(rname,uvmap_prog,freq,uvmax,uvmin,error) ! huv%gil%majo)
    if (error) return
    uvma = uvmax/(freq*f_to_k)
    !
    uvmap_prog%xycell = uvmap_prog%xycell*pi/180.0/3600.0
    !
    ! Get work space, ideally before mapping first image, for
    ! memory contiguity reasons.
    !
    nx = uvmap_prog%size(1)
    ny = uvmap_prog%size(2)
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    !
    ! Define the number of output channels
    nc = huv%gil%nchan
    if (mcol(1).eq.0) then
       mcol(1) = 1
    else
       mcol(1) = max(1,min(mcol(1),nc))
    endif
    if (mcol(2).eq.0) then
       mcol(2) = nc
    else
       mcol(2) = max(1,min(mcol(2),nc))
    endif
    nc = mcol(2)-mcol(1)+1
    !
    ! Check if Weights have changed by MCOL choice
    if (any(saved_mcol.ne.mcol)) do_weig = .true.
    saved_mcol = mcol
    !
    if (clean_prog%method.eq.'MX') do_weig = .true. ! Test
    if (do_weig) then
       call map_message(seve%i,rname,'Computing weights ')
       if (allocated(g_weight)) deallocate(g_weight)
       if (allocated(g_v)) deallocate(g_v)
       allocate(g_weight(nv),g_v(nv),stat=ier)
       if (ier.ne.0) goto 98
    else
       call map_message(seve%d,rname,'Re-using weight space')
    endif
    !
    rmega = 8.0
    ier = sic_ramlog('SPACE_MAPPING',rmega)
    sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
    !
    ! New Beam place
    if (allocated(dbeam)) then
       call sic_delvariable ('BEAM',.false.,error)
       deallocate(dbeam)
    endif
    call gildas_null(hbeam)
    !
    ! New dirty image
    if (allocated(dirty%data)) then
       call sic_delvariable ('DIRTY',.false.,error)
       deallocate(dirty%data)
    endif
    allocate(dirty%data(nx,ny,nc),stat=ier)
    !
    call gildas_null(dirty%head)
    dirty%head%gil%ndim = 3
    dirty%head%gil%dim(1:3) = (/nx,ny,nc/)
    call sic_mapgildas('DIRTY',dirty%head,error,dirty%data)
    !
    dirty%head%r3d => dirty%data
    !
    ! Find out how many beams are required
    call map_beams(rname,uvmap_prog%beam,huv,nx,ny,nb,nc)
    !
    ! Process sorted UV Table according to the number of beams produced
    if (map_buffer%version.eq.-1 .or. rname.eq.'MX') then
       ! The MX patch is temporary
       !
       ! Use old code only when explicitely requested
       hbeam%gil%ndim = 2
       hbeam%gil%dim(1:2)=(/nx,ny/)
       allocate(dbeam(nx,ny,1,1),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error on DBEAM')
          error =.true.
          return
       endif
       call sic_mapgildas('BEAM',hbeam,error,dbeam)
       hbeam%r3d => dbeam(:,:,:,1)
       !
       nfft = 2*max(nx,ny)
       allocate(w_mapu(nx),w_mapv(ny),w_grid(nx,ny),fft(nfft),stat=ier)
       if (ier.ne.0) goto 98
       call one_beam (rname,uvmap_prog,   &
            &    huv, hbeam, dirty%head,   &
            &    nx,ny,nu,nv, duv,   &
            &    w_mapu, w_mapv, w_grid, &
            &    g_weight, g_v, do_weig,  &
            &    wcol,mcol,fft,   &
            &    sblock,cpu0,error,uvma)
    else
       ! The MX part still needs debugging
       !
       hbeam%gil%ndim = 3
       hbeam%gil%dim(1:4)=[nx,ny,nb,1]
       if (nb.gt.1) then
          allocate(hbeam%r3d(nx,ny,nb),dbeam(nx,ny,1,nb),stat=ier)
       else
          allocate(dbeam(nx,ny,1,1),stat=ier)
          hbeam%r3d => dbeam(:,:,:,1)
       endif
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error on DBEAM')
          error =.true.
          return
       endif
       !
       call many_beams_para (rname,uvmap_prog,   &
            &    huv, hbeam, dirty%head,   &
            &    nx,ny,nu,nv, duv,   &
            &    g_weight, g_v, do_weig,  &
            &    wcol,mcol,sblock,cpu0,error,uvma,0)
       !
       ! Re-shape the beam, and reset the 4-D pointer, but show it as a 3-D array
       ! in SIC
       if (nb.gt.1) then
          dbeam(:,:,:,:) = reshape(hbeam%r3d,[nx,ny,1,nb])
          deallocate(hbeam%r3d)
       endif
       call sic_mapgildas('BEAM',hbeam,error,dbeam)
       !
       hbeam%r4d => dbeam
       hbeam%gil%dim(1:4)=[nx,ny,1,nb]
       hbeam%gil%ndim = 4
       !
       ! Transpose the header appropriately
       hbeam%gil%convert(:,4) = hbeam%gil%convert(:,3)
       hbeam%gil%faxi = 4
       hbeam%char%code(4) = 'VELOCITY' ! Frequency would be better...
       hbeam%gil%convert(:,3) = 1.d0
       hbeam%char%code(3) = 'FIELD'    ! Pseudo-mosaic
       hbeam%gil%ndim = 4
       !
    endif
    if (.not.error) call map_message(seve%i,rname,'Successful completion')
    save_data(code_save_beam) = .true.
    save_data(code_save_dirty) = .true.
    !
    call new_dirty_beam(error)
    if (error) return
    !
    ! Define Min Max
    d_max = dirty%head%gil%rmax
    if (dirty%head%gil%rmin.eq.0) then
       d_min = -0.03*dirty%head%gil%rmax
    else
       d_min = dirty%head%gil%rmin
    endif
    !
    if (rname.ne.'MX') goto 99
    !
    !---------------------------------------------------
    !
    ! Prepare MX part
    limits = sic_present(1,1)
    if (limits) then
       call sic_r4 (line,1,1,ylimn,.true.,error)
       if (error) return
       call sic_r4 (line,1,2,ylimp,.true.,error)
       if (error) return
    else
       ylimp = sqrt (float(clean_prog%m_iter+200) *   &
            &      log(float(clean_prog%m_iter+1)) ) * clean_prog%gain
       if (-dirty%head%gil%rmin.gt.1.3*dirty%head%gil%rmax) then
          ylimn = ylimp*dirty%head%gil%rmin
          ylimp = 0.0
       elseif (-1.3*dirty%head%gil%rmin.gt.dirty%head%gil%rmax) then
          ylimn = 0.0
          ylimp = ylimp*dirty%head%gil%rmax
       else
          ylimn = ylimp*dirty%head%gil%rmin
          ylimp = ylimp*dirty%head%gil%rmax
       endif
    endif
    np = max(1,primbeam%head%gil%dim(1))
    !
    ! Data checkup
    call clean_data (error)
    if (error) return
    !
    ! Copy the UV Data (eh eh)
    allocate (res_uv(nu,nv),stat=ier)
    res_uv(:,:) = duv
    !
    ! Get the right pointers before starting...
    clean%head%r3d => clean%data
    resid%head%r3d => resid%data
    resid%data(:,:,:) = dirty%data
    hbeam%r4d => dbeam ! Also required for MX
    !
    ! Parameter Definitions
    call beam_unit_conversion(clean_user)
    call clean_user%copyto(clean_prog)
    clean_prog%method = 'MX'
    clean_prog%pflux = sic_present(1,0)
    clean_prog%pcycle = sic_present(2,0)
    clean_prog%qcycle = sic_present(3,0)
    clean_prog%pclean = .false.
    clean_prog%pmrc = .false.
    !
    call sic_get_inte('FIRST',clean_prog%first,error)
    call sic_get_inte('LAST',clean_prog%last,error)
    if (clean_prog%first.eq.0) clean_prog%first = 1
    if (clean_prog%last.eq.0) clean_prog%last = dirty%head%gil%dim(3)
    clean_prog%first = max(1,min(clean_prog%first,dirty%head%gil%dim(3)))
    clean_prog%last = max(clean_prog%first,min(clean_prog%last,dirty%head%gil%dim(3)))
    !
    ! Other parameters
    if (clean_user%patch(1).ne.0) then
       clean_prog%patch(1) = min(clean_user%patch(1),nx)
    else
       clean_prog%patch(1) = min(nx,max(32,nx/4))
    endif
    if (clean_user%patch(2).ne.0) then
       clean_prog%patch(2) = min(clean_user%patch(2),nx)
    else
       clean_prog%patch(2) = min(nx,max(32,nx/4))
    endif
    clean_prog%bzone = (/1,1,nx,ny/)
    !
    call check_area(clean_prog,dirty%head,.false.)
    call check_mask(clean_prog,dirty%head)
    clean_user%do_mask = clean_prog%do_mask
    !
    ! Clean Component Structure (once it is defined, i.e. after check)
    allocate(tcc(clean_prog%m_iter),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error on MX CCT')
       error = .true.
       return
    endif
    !
    ! Prepare the CCT data
    call cct_prepare(line,nv,clean_prog,rname,error)
    if (error) return
    !
    if (clean_prog%pflux) call init_flux(clean_prog,dirty%head,ylimn,ylimp,ipen)
    if (clean_prog%pcycle) call init_plot(clean_prog,dirty%head,resid%data)
    !
    ! Perform the cleaning
    call mx_clean (uvmap_prog,huv,res_uv,g_weight,g_v,       &
         &    clean_prog,dirty%head,hbeam,clean%head,resid%head,primbeam%head,   &
         &    w_grid,w_mapu,w_mapv,tcc,cct%data,d_mask,d_list,      &
         &    sblock, cpu0, uvma)
    !
    if (clean_prog%pflux) then
       call close_flux(ipen,error)
    else
       call gr_execl('CHANGE DIRECTORY <GREG')
    endif
    !
    ! Reset extrema
    resid%head%gil%extr_words = 0
    clean%head%gil%extr_words = 0
    !
    ! Specify clean beam parameters
    clean%head%gil%reso_words = 3
    clean%head%gil%majo = clean_prog%major
    clean%head%gil%mino = clean_prog%minor
    clean%head%gil%posa = pi*clean_prog%angle/180.0
    save_data(code_save_clean) = .true.
    clean_user%nlist = clean_prog%nlist
    ! Cleanup
    deallocate(tcc)
    error = .false.
    !
99  continue
    if (allocated(w_mapu)) deallocate(w_mapu)
    if (allocated(w_mapv)) deallocate(w_mapv)
    if (allocated(w_grid)) deallocate(w_grid)
    if (allocated(fft)) deallocate(fft)
    return
    !
98  call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
    !
102 format(a,f9.2)
  end subroutine old_mx_comm
  !
  subroutine one_beam(rname,map,huv,hbeam,hdirty,&
       nx,ny,nu,nv,uvdata,&
       w_mapu,w_mapv,w_grid,w_weight,w_v,do_weig,&
       wcol,mcol,wfft,sblock,cpu0,error,uvmax)
    use gkernel_interfaces
    use image_def
    use omp_buffers
    use uvmap_types
    !------------------------------------------------------------------------
    ! Compute a map from a CLIC UV Sorted Table
    ! by Gridding and Fast Fourier Transform, with
    ! one single beam for all channels.
    !
    ! Input:
    !    a precessed UV table, sorted in V, ordered in
    !    (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    ! Output:
    !    a beam image
    !    a VLM cube
    ! Workspace:
    !    a  VLM complex Fourier cube (first V value is for beam)
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type (uvmap_par), intent(inout) :: map            ! Mapping parameters
    type (gildas),    intent(inout) :: huv            ! UV data set
    type (gildas),    intent(inout) :: hbeam          ! Dirty beam data set
    type (gildas),    intent(inout) :: hdirty         ! Dirty image data set
    integer,          intent(in)    :: nx             ! X size
    integer,          intent(in)    :: ny             ! Y size
    integer,          intent(in)    :: nu             ! Size of a visibilities
    integer,          intent(in)    :: nv             ! Number of visibilities
    real,             intent(inout) :: uvdata(nu,nv)
    real,             intent(inout) :: w_mapu(nx)     ! U grid coordinates
    real,             intent(inout) :: w_mapv(ny)     ! V grid coordinates
    real,             intent(inout) :: w_grid(nx,ny)  ! Gridding space
    real,             intent(inout) :: w_weight(nv)   ! Weight of visibilities
    real,             intent(inout) :: w_v(nv)        ! V values
    logical,          intent(inout) :: do_weig
    !
    real,             intent(inout) :: wfft(*)        ! Work space
    real,             intent(inout) :: cpu0           ! CPU
    real,             intent(inout) :: uvmax          ! Maximum baseline
    integer,          intent(inout) :: sblock         ! Blocking factor
    integer,          intent(inout) :: wcol           ! Weight channel
    integer,          intent(inout) :: mcol(2)        ! First and last channel
    logical,          intent(inout) :: error
    !
    if (omp%single_beam.eq.0) then
       print *,'Calling SERIAL one_beam'
       call one_beam_serial(rname,map,huv,hbeam,hdirty,&
            nx,ny,nu,nv,uvdata,&
            w_mapu, w_mapv, w_grid, w_weight, w_v, do_weig, &
            wcol,mcol,wfft,sblock,cpu0,error,uvmax)
    else
       print *,'Calling PARALLEL one_beam'
       call one_beam_para(rname,map,huv,hbeam,hdirty,&
            nx,ny,nu,nv,uvdata,&
            w_mapu, w_mapv, w_grid, w_weight, w_v, do_weig, &
            wcol,mcol,wfft,sblock,cpu0,error,uvmax)
    endif
  end subroutine one_beam
  !
  ! Sblock is the Blocking factor
  ! Experience shows that the efficiency does not
  ! increase with large blocking factors. Values of order
  ! 16 are often sufficient and even optimal.
  !   Huge values (e.g. 1024) yield a penalty.
  ! This drives from the fact that gridding is essentially
  ! memory access limited, so page fault dominate.
  ! In the presence of Multi-Threading, a good policy is
  ! be to have the number of blocks being a multiple of
  ! the number of threads.
  !
  subroutine one_beam_para(rname,map,huv,hbeam,hdirty,&
       nx,ny,nu,nv,uvdata,&
       w_mapu,w_mapv,w_grid,w_weight,w_v,do_weig,&
       wcol,mcol,wfft,sblock,cpu0,error,uvmax)
    use image_def
    use gkernel_interfaces
    use mapping_interfaces
    use uvmap_types
    use uvstat_tool, only: prnoise
    !$ use omp_lib
    !------------------------------------------------------------------------
    ! Compute a map from a CLIC UV Sorted Table
    ! by Gridding and Fast Fourier Transform, with
    ! one single beam for all channels.
    !
    ! Input:
    !    a precessed UV table, sorted in V, ordered in
    !    (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    ! Output:
    !    a beam image
    !    a VLM cube
    ! Workspace:
    !    a VLM complex Fourier cube (first V value is for beam)
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type (uvmap_par), intent(inout) :: map            ! Mapping parameters
    type (gildas),    intent(inout) :: huv            ! UV data set
    type (gildas),    intent(inout) :: hbeam          ! Dirty beam data set
    type (gildas),    intent(inout) :: hdirty         ! Dirty image data set
    integer,          intent(in)    :: nx             ! X size
    integer,          intent(in)    :: ny             ! Y size
    integer,          intent(in)    :: nu             ! Size of a visibilities
    integer,          intent(in)    :: nv             ! Number of visibilities
    real,             intent(inout) :: uvdata(nu,nv)
    real,             intent(inout) :: w_mapu(nx)     ! U grid coordinates
    real,             intent(inout) :: w_mapv(ny)     ! V grid coordinates
    real,             intent(inout) :: w_grid(nx,ny)  ! Gridding space
    real,             intent(inout) :: w_weight(nv)   ! Weight of visibilities
    real,             intent(inout) :: w_v(nv)        ! V values
    logical,          intent(inout) :: do_weig
    !
    real,             intent(inout) :: wfft(*)        ! Work space
    real,             intent(inout) :: cpu0           ! CPU
    real,             intent(inout) :: uvmax          ! Maximum baseline
    integer,          intent(inout) :: sblock         ! Blocking factor
    integer,          intent(inout) :: wcol           ! Weight channel
    integer,          intent(inout) :: mcol(2)        ! First and last channel
    logical,          intent(inout) :: error
    !
    real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
    !
    real ubias,vbias,ubuff(4096),vbuff(4096)
    common /conv/ ubias,vbias,ubuff,vbuff ! To be saved
    !
    integer :: nc   ! Number of channels
    integer :: nd   ! Size of data
    integer :: ier
    integer :: ctypx,ctypy
    integer :: icol,lcol,fcol,imi,ima,iv
    integer :: ndim, nn(2), i, lx, ly
    integer :: istart,iblock,nblock,kz,iz,kkz
    integer :: blc(4),trc(4)
    integer(kind=8) :: ilong
    real :: rmi,rma,wall,cpu1
    real :: xparm(10),yparm(10)
    real :: vref,voff,vinc
    real :: rms,null_taper(4)
    real(kind=4) :: loff,boff
    real(kind=8) :: freq
    real :: local_wfft(2*max(nx,ny))
    real, allocatable :: w_xgrid(:),w_ygrid(:),w_w(:)
    complex, allocatable :: ftbeam(:,:)
    complex, allocatable :: tfgrid(:,:,:)
    character(len=message_length) :: chain
    !
    !
    !$ integer(kind = OMP_lock_kind) :: lck
    integer :: ithread,nthread
    real(8) :: elapsed_s,elapsed_e,elapsed
    data blc/4*0/, trc/4*0/
    !
    nd = nx*ny
    nc = huv%gil%nchan
    !
    ! Reset the parameters
    xparm = 0.0
    yparm = 0.0
    !
    vref = huv%gil%ref(1)
    voff = huv%gil%voff
    vinc = huv%gil%vres
    if (mcol(1).eq.0) then
       mcol(1) = 1
    else
       mcol(1) = max(1,min(mcol(1),nc))
    endif
    if (mcol(2).eq.0) then
       mcol(2) = nc
    else
       mcol(2) = max(1,min(mcol(2),nc))
    endif
    fcol = min(mcol(1),mcol(2))
    lcol = max(mcol(1),mcol(2))
    if (wcol.eq.0) then
       wcol = (fcol+lcol)/3
    endif
    wcol = max(1,wcol)
    wcol = min(wcol,nc)
    nc = lcol-fcol+1
    !
    ! Compute observing sky frequency for U,V cell size
    freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
    !
    ! Compute gridding function
    ctypx = map%ctype
    ctypy = map%ctype
    call grdflt (ctypx, ctypy, xparm, yparm)
    call convfn (ctypx, xparm, ubuff, ubias)
    call convfn (ctypy, yparm, vbuff, vbias)
    map%uvcell = clight/freq/(map%xycell*map%size)
    map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
    map%support(2) = yparm(1)*map%uvcell(2)
    !
    ! Load V values and original Weights
    icol = 3*wcol + 7
    allocate(w_w(nv),stat=ier)
    call dovisi (nu,nv,uvdata,w_v,w_w,icol)
    !
    ! Compute weights
    !
    if (do_weig) then
       call doweig (nu,nv,   &
            &    uvdata,   &          ! Visibilities
            &    1,2,   &             ! U, V pointers
            &    wcol,   &            ! Weight channel
            &    map%uniform(1),   &  ! Uniform UV cell size
            &    w_weight,   &        ! Weight array
            &    map%uniform(2),   &  ! Fraction of weight
            &    w_v,              &  ! V values
            &    error)
       if (error)  return
       !
       ! Should also plug the TAPER here, rather than in DOFFT later  !
       call dotape (nu,nv,   &
            &    uvdata,   &          ! Visibilities
            &    1,2,   &             ! U, V pointers
            &    map%taper,  &        ! Taper
            &    w_weight)            ! Weight array
       do_weig = .false.
    else
       call map_message(seve%i,rname,'Reusing weights')
    endif
    null_taper = 0
    ! For test
    !  else
    !    null_taper = map%taper
    !  endif
    !
    call gag_cpu(cpu1)
    write(chain,102) 'Finished weighting CPU ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    wall = 0
    do iv=1,nv
       if (w_w(iv).gt.0) then
          wall = wall + w_w(iv)
       endif
    enddo
    if (wall.eq.0.0) then
       write(chain,101) 'Plane ',wcol,' has Zero weight'
       call map_message(seve%e,rname,chain)
       error = .true.
       return
    else
       !
       ! Noise definition
       wall = 1e-3/sqrt(wall)
       call prnoise(rname,'Natural',wall,rms)
       !
       ! Re-normalize the weights and re-count the noise
       call scawei (nv,w_weight,w_w,wall)
       wall = 1e-3/sqrt(wall)
       call prnoise(rname,'Expected',wall,rms)
    endif
    deallocate(w_w)
    !
    lx = (uvmax+map%support(1))/map%uvcell(1) + 2
    ly = (uvmax+map%support(2))/map%uvcell(2) + 2
    lx = 2*lx
    ly = 2*ly
    if (ly.gt.ny) then
       write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
            &      ' Undersampling ratio ',float(ly)/float(ny)
       call map_message(seve%e,rname,chain)
       ly = min(ly,ny)
       lx = min(lx,nx)
    endif
    call docoor (lx,-map%uvcell(1),w_mapu)
    call docoor (ly,map%uvcell(2),w_mapv)
    !
    ! Optimize SBLOCK now, allowing some additional memory if NBLOCK small
    if (sblock.gt.0) then
       nblock = (nc+sblock-1)/sblock
       kz = mod(nc,sblock)
       if (kz.ne.0 .and. kz.lt.(sblock/(nblock+1))) then
          if (nblock.ne.1) nblock = nblock-1
       endif
       sblock = (nc+nblock-1)/nblock
       kz = min(sblock,nc)
    else
       kz = nc
       nblock = 1
    endif
    !
    ! Get FFT's work space
    write(chain,101) 'Using a blocking factor of ',sblock,' planes'
    call map_message(seve%i,rname,chain)
    allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),stat=ier)
    ndim = 2
    nn(1) = nx
    nn(2) = ny
    call fourt_plan(ftbeam,nn,ndim,-1,1)
    !
    ! Prepare grid correction,
    !
    allocate(w_xgrid(nx),w_ygrid(ny),stat=ier)
    call grdtab (ny, vbuff, vbias, w_ygrid)
    call grdtab (nx, ubuff, ubias, w_xgrid)
    !
    ! Make beam, not normalized
    call gdf_copy_header(huv,hbeam,error)
    hbeam%gil%dopp = 0    ! Nullify the Doppler factor
    !
    hbeam%gil%ndim = 2
    hbeam%gil%dim(1) = nx
    hbeam%gil%dim(2) = ny
    hbeam%gil%dim(3) = 1
    hbeam%gil%dim(4) = 1
    hbeam%gil%convert(1,1) = nx/2+1
    hbeam%gil%convert(1,2) = ny/2+1
    hbeam%gil%convert(2,1) = 0
    hbeam%gil%convert(2,2) = 0
    hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
    hbeam%gil%convert(3,2) = map%xycell(2)
    hbeam%gil%proj_words = 0
    hbeam%gil%extr_words = 0
    hbeam%gil%reso_words = 0
    hbeam%gil%uvda_words = 0
    hbeam%gil%type_gdf = code_gdf_image
    !
    hbeam%char%code(1) = 'ANGLE'
    hbeam%char%code(2) = 'ANGLE'
    hbeam%gil%majo = 0.0
    hbeam%loca%size = nx*ny
    hbeam%char%type = 'GILDAS_IMAGE'
    !
    ! Prepare the dirty map header
    call gdf_copy_header(hbeam,hdirty,error)
    hdirty%gil%ndim = 3
    hdirty%gil%dim(1) = nx
    hdirty%gil%dim(2) = ny
    hdirty%gil%dim(3) = nc
    hdirty%gil%dim(4) = 1
    hdirty%gil%convert(1,3) = vref-fcol+1
    hdirty%gil%convert(2,3) = voff
    hdirty%gil%convert(3,3) = vinc
    hdirty%gil%proj_words = def_proj_words
    hdirty%gil%uvda_words = 0
    hdirty%gil%type_gdf = code_gdf_image
    hdirty%char%code(1) = 'RA'
    hdirty%char%code(2) = 'DEC'
    hdirty%char%code(3) = 'VELOCITY'
    call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,&
         hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
    if (huv%gil%ptyp.eq.p_none) then
       hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
       hdirty%gil%pang = 0.d0     ! Defined in table.
       hdirty%gil%a0 = hdirty%gil%ra
       hdirty%gil%d0 = hdirty%gil%dec
    else
       hdirty%gil%ptyp = p_azimuthal
       hdirty%gil%pang = huv%gil%pang ! Defined in table.
       hdirty%gil%a0 = huv%gil%a0
       hdirty%gil%d0 = huv%gil%d0
    endif
    hdirty%char%syst = 'EQUATORIAL'
    hdirty%gil%xaxi = 1
    hdirty%gil%yaxi = 2
    hdirty%gil%faxi = 3
    hdirty%gil%extr_words = 0          ! extrema not computed
    hdirty%gil%reso_words = 0          ! no beam defined
    hdirty%gil%nois_words = 2
    hdirty%gil%majo = 0
    hdirty%gil%noise = wall
    hdirty%char%unit = 'Jy/beam'
    hdirty%char%type = 'GILDAS_IMAGE'
    hdirty%loca%size = nx*ny*nc
    !
    ! Loop over blocks
    !$ call omp_init_lock(lck)
    !
    kkz = kz
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP PRIVATE(iblock,istart,kz,blc,trc)  &
    !$OMP PRIVATE(tfgrid,ftbeam) &  ! Big arrays
    !$OMP SHARED(nblock, sblock, kkz, nu,nv,nx,ny,nc,nd,fcol,lx,ly, lck,nthread) &
    !$OMP SHARED(w_mapu,w_mapv,map,null_taper) &
    !$OMP SHARED(ubias,vbias,ubuff,vbuff) &
    !$OMP SHARED(nn,ndim,hbeam,hdirty,rname) &
    !$OMP SHARED(w_grid,w_xgrid,w_ygrid,w_v,w_weight,uvdata, wfft) &
    !$OMP PRIVATE(rmi,rma,imi,ima,ilong,chain) &
    !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread)
    !
    !$OMP MASTER
    nthread = 1
    !$  nthread = omp_get_num_threads()
    if (nblock.lt.nthread) then
       nblock = min(nthread,nc)
       sblock = (nc+nblock-1)/nblock
       write(chain,'(A,I6,A,I8,A)') 'Reset ',nblock,' blocks of ',&
            & sblock,' channels for Threading'
       call map_message(seve%w,rname,chain)
       kkz = sblock
    endif
    !$OMP END MASTER
    !$OMP BARRIER
    !
    !$OMP DO
    do iblock = 1,nblock
       !$ elapsed_s = omp_get_wtime()
       !$ ithread = omp_get_thread_num()
       !$ if (iblock.eq.1) call omp_set_lock(lck)
       !
       istart = fcol+(iblock-1)*sblock
       blc(3) = (iblock-1)*kkz+1
       kz = min (sblock,nc-sblock*(iblock-1))
       trc(3) = blc(3)-1+kz
       !
       ! This is the power-hungry routine...
       call dofft (nu,nv,   &   ! Size of visibility array
            &        uvdata,   &      ! Visibilities
            &        1,2,   &         ! U, V pointers
            &        istart,   &      ! First channel to map
            &        kz,lx,ly,   &    ! Cube size
            &        tfgrid,   &      ! FFT cube
            &        w_mapu,w_mapv,   &   ! U and V grid coordinates
            &        map%support,map%uvcell,null_taper,   &    ! Gridding parameters
            &        w_weight,w_v,   &    ! Weight array
            &        ubias,vbias,ubuff,vbuff,map%ctype)
       !
       ! Should one beam per block be created, this test can be
       ! easily modified
       if (iblock.eq.1) then
          call map_message(seve%i,rname,'Creating beam ')
          !
          call extracs(kz+1,nx,ny,kz+1,tfgrid,ftbeam,lx,ly)
          call fourt  (ftbeam,nn,ndim,-1,1,wfft)
          call cmtore (ftbeam,hbeam%r3d(:,:,1),nx,ny)
          !
          ! Compute Grid correction and Free the Grid lock
          ! Normalization factor is applied to grid correction,
          ! for further use on beam and channel maps.
          call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,hbeam%r3d(:,:,1))
          !$ call omp_unset_lock(lck)
          !
          ! Normalize and Free beam
          call docorr (hbeam%r3d(:,:,1),w_grid,nd)
          rma = -1e38
          rmi = 1e38
          call domima (hbeam%r3d(:,:,1),rmi,rma,imi,ima,nd)
          hbeam%gil%extr_words = def_extr_words          ! extrema computed
          hbeam%gil%rmax = rma
          hbeam%gil%rmin = rmi
          ilong = imi
          call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%minloc)
          ilong = ima
          call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%maxloc)
          !
          !$ elapsed_e = omp_get_wtime()
          elapsed = elapsed_e - elapsed_s
          write(chain,102) 'Finished Beam, Elapsed ',elapsed
          call map_message(seve%i,rname,chain)
          call map_message(seve%i,rname,'Creating map file ')
       endif
       !
       ! Wait for gridding correction to be computed
       !$  call omp_set_lock(lck)
       ! but free lock immediately, as no further waiting is needed.
       !$  call omp_unset_lock(lck)
       ! In general, the time spent here is negligible,
       ! so Parallel Nesting is not needed,
       ! but this is not always the case...
       !$OMP PARALLEL DEFAULT(none) &
       !$OMP & PRIVATE(i,iz,ftbeam,local_wfft) &
       !$OMP & SHARED(lck,nx,ny,nd,nn,ndim,lx,ly,iblock,kz,kkz) &
       !$OMP & SHARED(hdirty,w_grid,tfgrid)
       !$OMP DO
       do i=1,kz
          iz = i+(iblock-1)*kkz
          call extracs(kz+1,nx,ny,i,tfgrid,ftbeam,lx,ly)
          call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
          call cmtore (ftbeam,hdirty%r3d(:,:,iz),nx,ny)
          call docorr (hdirty%r3d(:,:,iz),w_grid,nd)
       enddo
       !$OMP END DO
       !$OMP END PARALLEL
       !$  elapsed_e = omp_get_wtime()
       elapsed = elapsed_e - elapsed_s
       write(chain,103) 'End planes ',blc(3),trc(3),' Time ',elapsed &
            & ,' Block ',iblock,' Thread ',ithread
       call map_message(seve%i,rname,chain)
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !$  call omp_destroy_lock(lck)
    !
    call gag_cpu(cpu1)
    write(chain,102) 'Finished maps ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    hdirty%gil%extr_words = def_extr_words  ! extrema computed
    hdirty%gil%minloc = 1
    hdirty%gil%maxloc = 1
    hdirty%gil%minloc(1:3) = minloc(hdirty%r3d)
    hdirty%gil%maxloc(1:3) = maxloc(hdirty%r3d)
    rma = hdirty%r3d(hdirty%gil%maxloc(1),hdirty%gil%maxloc(2),hdirty%gil%maxloc(3))
    rmi = hdirty%r3d(hdirty%gil%minloc(1),hdirty%gil%minloc(2),hdirty%gil%minloc(3))
    hdirty%gil%rmax = rma
    hdirty%gil%rmin = rmi
    !
    ! Delete scratch space
    error = .false.
    if (allocated(tfgrid)) deallocate(tfgrid)
    if (allocated(ftbeam)) deallocate(ftbeam)
    if (allocated(w_xgrid)) deallocate(w_xgrid)
    if (allocated(w_ygrid)) deallocate(w_ygrid)
    return
    !
101 format(a,i6,a)
102 format(a,f9.2)
103 format(a,i5,' to ',i5,a,f9.2,a,i2,a,i2)
  end subroutine one_beam_para
  !
  subroutine one_beam_serial(rname,map,huv,hbeam,hdirty,&
       nx,ny,nu,nv,uvdata,&
       w_mapu,w_mapv,w_grid,w_weight,w_v,do_weig,&
       wcol,mcol,wfft,sblock,cpu0,error,uvmax)
    use image_def
    use gkernel_interfaces
    use mapping_interfaces
    use uvmap_types
    use uvstat_tool, only: prnoise
    !------------------------------------------------------------------------
    ! Compute a map from a CLIC UV Sorted Table
    ! by Gridding and Fast Fourier Transform, with
    ! one single beam for all channels.
    !
    ! Input:
    !    a precessed UV table, sorted in V, ordered in
    !    (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    ! Output:
    !    a beam image
    !    a VLM cube
    ! Workspace:
    !    a VLM complex Fourier cube (first V value is for beam)
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type (uvmap_par), intent(inout) :: map            ! Mapping parameters
    type (gildas),    intent(inout) :: huv            ! UV data set
    type (gildas),    intent(inout) :: hbeam          ! Dirty beam data set
    type (gildas),    intent(inout) :: hdirty         ! Dirty image data set
    integer,          intent(in)    :: nx             ! X size
    integer,          intent(in)    :: ny             ! Y size
    integer,          intent(in)    :: nu             ! Size of a visibilities
    integer,          intent(in)    :: nv             ! Number of visibilities
    real,             intent(inout) :: uvdata(nu,nv)
    real,             intent(inout) :: w_mapu(nx)     ! U grid coordinates
    real,             intent(inout) :: w_mapv(ny)     ! V grid coordinates
    real,             intent(inout) :: w_grid(nx,ny)  ! Gridding space
    real,             intent(inout) :: w_weight(nv)   ! Weight of visibilities
    real,             intent(inout) :: w_v(nv)        ! V values
    logical,          intent(inout) :: do_weig
    !
    real,             intent(inout) :: wfft(*)        ! Work space
    real,             intent(inout) :: cpu0           ! CPU
    real,             intent(inout) :: uvmax          ! Maximum baseline
    integer,          intent(inout) :: sblock         ! Blocking factor
    integer,          intent(inout) :: wcol           ! Weight channel
    integer,          intent(inout) :: mcol(2)        ! First and last channel
    logical,          intent(inout) :: error
    !
    real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
    !
    real ubias,vbias,ubuff(4096),vbuff(4096)
    common /conv/ ubias,vbias,ubuff,vbuff ! To be saved
    !
    integer :: nc   ! Number of channels
    integer :: nd   ! Size of data
    integer :: ier
    integer :: ctypx,ctypy
    integer :: icol,lcol,fcol,imi,ima,iv
    integer :: ndim, nn(2), i, lx, ly
    integer :: istart,iblock,nblock,kz,iz,kkz
    integer :: blc(4),trc(4)
    integer(kind=8) :: ilong
    real :: rmi,rma,wall,cpu1
    real :: xparm(10),yparm(10)
    real :: vref,voff,vinc
    real :: rms,null_taper(4)
    real(kind=4) :: loff,boff
    real(kind=8) :: freq
    !
    real :: local_wfft(2*max(nx,ny))
    real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:)
    complex, allocatable :: ftbeam(:,:)
    complex, allocatable :: tfgrid(:,:,:)
    character(len=message_length) :: chain
    data blc/4*0/, trc/4*0/
    !
    nd = nx*ny
    nc = huv%gil%nchan
    !
    ! Reset the parameters
    xparm = 0.0
    yparm = 0.0
    !
    vref = huv%gil%ref(1)
    voff = huv%gil%voff
    vinc = huv%gil%vres
    if (mcol(1).eq.0) then
       mcol(1) = 1
    else
       mcol(1) = max(1,min(mcol(1),nc))
    endif
    if (mcol(2).eq.0) then
       mcol(2) = nc
    else
       mcol(2) = max(1,min(mcol(2),nc))
    endif
    fcol = min(mcol(1),mcol(2))
    lcol = max(mcol(1),mcol(2))
    if (wcol.eq.0) then
       wcol = (fcol+lcol)/3
    endif
    wcol = max(1,wcol)
    wcol = min(wcol,nc)
    nc = lcol-fcol+1
    !
    ! Compute observing sky frequency for U,V cell size
    freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
    !
    ! Compute gridding function
    ctypx = map%ctype
    ctypy = map%ctype
    call grdflt (ctypx, ctypy, xparm, yparm)
    call convfn (ctypx, xparm, ubuff, ubias)
    call convfn (ctypy, yparm, vbuff, vbias)
    map%uvcell = clight/freq/(map%xycell*map%size)
    map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
    map%support(2) = yparm(1)*map%uvcell(2)
    !
    ! Load V values and original Weights
    icol = 3*wcol + 7
    allocate(w_w(nv),stat=ier)
    call dovisi (nu,nv,uvdata,w_v,w_w,icol)
    !
    ! Compute weights
    !
    if (do_weig) then
       call doweig (nu,nv,   &
            &    uvdata,   &          ! Visibilities
            &    1,2,   &             ! U, V pointers
            &    wcol,   &            ! Weight channel
            &    map%uniform(1),   &  ! Uniform UV cell size
            &    w_weight,   &        ! Weight array
            &    map%uniform(2),   &  ! Fraction of weight
            &    w_v,              &  ! V values
            &    error)
       if (error)  return
       !
       ! Should also plug the TAPER here, rather than in DOFFT later  !
       call dotape (nu,nv,   &
            &    uvdata,   &          ! Visibilities
            &    1,2,   &             ! U, V pointers
            &    map%taper,  &        ! Taper
            &    w_weight)            ! Weight array
       do_weig = .false.
    else
       call map_message(seve%i,rname,'Reusing weights')
    endif
    null_taper = 0
    ! For test
    !  else
    !    null_taper = map%taper
    !  endif
    !
    call gag_cpu(cpu1)
    write(chain,102) 'Finished weighting CPU ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    wall = 0
    do iv=1,nv
       if (w_w(iv).gt.0) then
          wall = wall + w_w(iv)
       endif
    enddo
    if (wall.eq.0.0) then
       write(chain,101) 'Plane ',wcol,' has Zero weight'
       call map_message(seve%e,rname,chain)
       error = .true.
       return
    else
       !
       ! Noise definition
       wall = 1e-3/sqrt(wall)
       call prnoise(rname,'Natural',wall,rms)
       !
       ! Re-normalize the weights and re-count the noise
       call scawei (nv,w_weight,w_w,wall)
       wall = 1e-3/sqrt(wall)
       call prnoise(rname,'Expected',wall,rms)
    endif
    deallocate(w_w)
    !
    lx = (uvmax+map%support(1))/map%uvcell(1) + 2
    ly = (uvmax+map%support(2))/map%uvcell(2) + 2
    lx = 2*lx
    ly = 2*ly
    if (ly.gt.ny) then
       write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
            &      ' Undersampling ratio ',float(ly)/float(ny)
       call map_message(seve%e,rname,chain)
       ly = min(ly,ny)
       lx = min(lx,nx)
    endif
    call docoor (lx,-map%uvcell(1),w_mapu)
    call docoor (ly,map%uvcell(2),w_mapv)
    !
    ! Optimize SBLOCK now, allowing some additional memory if NBLOCK small
    if (sblock.gt.0) then
       nblock = (nc+sblock-1)/sblock
       kz = mod(nc,sblock)
       if (kz.ne.0 .and. kz.lt.(sblock/(nblock+1))) then
          if (nblock.ne.1) nblock = nblock-1
       endif
       sblock = (nc+nblock-1)/nblock
       kz = min(sblock,nc)
    else
       kz = nc
       nblock = 1
    endif
    !
    ! Get FFT's work space
    write(chain,101) 'Using a blocking factor of ',sblock,' planes'
    call map_message(seve%i,rname,chain)
    allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),stat=ier)
    ndim = 2
    nn(1) = nx
    nn(2) = ny
    call fourt_plan(ftbeam,nn,ndim,-1,1)
    !
    ! Compute FFT's
    call dofft (nu,nv,   &       ! Size of visibility array
         &    uvdata,   &          ! Visibilities
         &    1,2,   &             ! U, V pointers
         &    fcol,   &            ! First channel to map
         &    kz,lx,ly,   &        ! Cube size
         &    tfgrid,   &          ! FFT cube
         &    w_mapu,w_mapv,   &   ! U and V grid coordinates
         &    map%support,map%uvcell,null_taper,   &    ! Gridding parameters
         &    w_weight,w_v,   &    ! Weight array + V Visibilities
         &    ubias,vbias,ubuff,vbuff,map%ctype)
    call gag_cpu(cpu1)
    write(chain,102) 'Finished gridding CPU ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    ! Make beam, not normalized
    call gdf_copy_header(huv,hbeam,error)
    hbeam%gil%dopp = 0    ! Nullify the Doppler factor
    !
    hbeam%gil%ndim = 2
    hbeam%gil%dim(1) = nx
    hbeam%gil%dim(2) = ny
    hbeam%gil%dim(3) = 1
    hbeam%gil%dim(4) = 1
    hbeam%gil%convert(1,1) = nx/2+1
    hbeam%gil%convert(1,2) = ny/2+1
    hbeam%gil%convert(2,1) = 0
    hbeam%gil%convert(2,2) = 0
    hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
    hbeam%gil%convert(3,2) = map%xycell(2)
    hbeam%gil%proj_words = 0
    hbeam%gil%extr_words = 0
    hbeam%gil%reso_words = 0
    hbeam%gil%uvda_words = 0
    hbeam%gil%type_gdf = code_gdf_image
    !
    hbeam%char%code(1) = 'ANGLE'
    hbeam%char%code(2) = 'ANGLE'
    hbeam%gil%majo = 0.0
    hbeam%loca%size = nx*ny
    hbeam%char%type = 'GILDAS_IMAGE'
    call map_message(seve%i,rname,'Creating beam ')
    !
    call extracs(kz+1,nx,ny,kz+1,tfgrid,ftbeam,lx,ly)
    !
    ! For debugging
    !      call sic_descriptor('ffta',desc,found)
    !      if (found) then
    !         jpd = pointer(desc%addr,memory)
    !         call r4tor4 (memory(ipf),memory(jpd),2*nx*ny)
    !      endif
    !
    call fourt  (ftbeam,nn,ndim,-1,1,wfft)
    call cmtore (ftbeam,hbeam%r3d(:,:,1),nx,ny)
    !
    ! Compute grid correction,
    ! Normalization factor is applied to grid correction, for further
    ! use on channel maps.
    !
    allocate(w_xgrid(nx),w_ygrid(ny),stat=ier)
    call grdtab (ny, vbuff, vbias, w_ygrid)
    call grdtab (nx, ubuff, ubias, w_xgrid)
    call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,   &
         &    hbeam%r3d(:,:,1))
    !
    ! Normalize and Free beam
    call docorr (hbeam%r3d(:,:,1),w_grid,nd)
    rma = -1e38
    rmi = 1e38
    call domima (hbeam%r3d(:,:,1),rmi,rma,imi,ima,nd)
    hbeam%gil%extr_words = def_extr_words          ! extrema computed
    hbeam%gil%rmax = rma
    hbeam%gil%rmin = rmi
    ilong = imi
    call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%minloc)
    ilong = ima
    call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%maxloc)
    !
    ! For debugging
    !      call sic_descriptor('fftb',desc,found)
    !      if (found) then
    !         jpd = pointer(desc%addr,memory)
    !         call r4toc4 (memory(ipy),memory(jpd),nx*ny)
    !         call fourt (memory(jpd),nn,ndim,1,0,wfft)
    !      endif
    !
    call gag_cpu(cpu1)
    write(chain,102) 'Finished beam CPU ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    ! Create image (in order l m v )
    call map_message(seve%i,rname,'Creating map file ')
    call gdf_copy_header(hbeam,hdirty,error)
    hdirty%gil%ndim = 3
    hdirty%gil%dim(1) = nx
    hdirty%gil%dim(2) = ny
    hdirty%gil%dim(3) = nc
    hdirty%gil%dim(4) = 1
    hdirty%gil%convert(1,3) = vref-fcol+1
    hdirty%gil%convert(2,3) = voff
    hdirty%gil%convert(3,3) = vinc
    hdirty%gil%proj_words = def_proj_words
    hdirty%gil%uvda_words = 0
    hdirty%gil%type_gdf = code_gdf_image
    hdirty%char%code(1) = 'RA'
    hdirty%char%code(2) = 'DEC'
    hdirty%char%code(3) = 'VELOCITY'
    call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
         hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
    if (huv%gil%ptyp.eq.p_none) then
       hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
       hdirty%gil%pang = 0.d0     ! Defined in table.
       hdirty%gil%a0 = hdirty%gil%ra
       hdirty%gil%d0 = hdirty%gil%dec
    else
       hdirty%gil%ptyp = p_azimuthal
       hdirty%gil%pang = huv%gil%pang ! Defined in table.
       hdirty%gil%a0 = huv%gil%a0
       hdirty%gil%d0 = huv%gil%d0
    endif
    hdirty%char%syst = 'EQUATORIAL'
    hdirty%gil%xaxi = 1
    hdirty%gil%yaxi = 2
    hdirty%gil%faxi = 3
    hdirty%gil%extr_words = 0          ! extrema not computed
    hdirty%gil%reso_words = 0          ! no beam defined
    hdirty%gil%nois_words = 2
    hdirty%gil%majo = 0
    hdirty%gil%noise = wall
    hdirty%char%unit = 'Jy/beam'
    hdirty%char%type = 'GILDAS_IMAGE'
    hdirty%loca%size = nx*ny*nc
    !
    ! Make maps with grid correction
    rmi = 1e38
    rma = -1e38
    blc(3) = 1
    trc(3) = kz
    iz = 0
    !
    do i=1,kz
       iz = i
       call extracs(kz+1,nx,ny,i,tfgrid,ftbeam,lx,ly)
       call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
       call cmtore (ftbeam,hdirty%r3d(:,:,iz),nx,ny)
       call docorr (hdirty%r3d(:,:,iz),w_grid,nd)
    enddo
    call gag_cpu(cpu1)
    write(chain,103) 'Finished planes ',blc(3),trc(3),' CPU ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    ! Proceed with further planes
    if (kz.lt.nc) then
       kkz = kz
       do iblock = 2,nblock
          istart = fcol+(iblock-1)*sblock
          blc(3) = blc(3)+kz
          kz = min (sblock,nc-sblock*(iblock-1))
          trc(3) = blc(3)-1+kz
          call dofft (nu,nv,   &   ! Size of visibility array
               &        uvdata,   &      ! Visibilities
               &        1,2,   &         ! U, V pointers
               &        istart,   &      ! First channel to map
               &        kz,lx,ly,   &    ! Cube size
               &        tfgrid,   &      ! FFT cube
               &        w_mapu,w_mapv,   &   ! U and V grid coordinates
               &        map%support,map%uvcell,null_taper,   &    ! Gridding parameters
               &        w_weight,w_v,   &    ! Weight array
               &        ubias,vbias,ubuff,vbuff,map%ctype)
          do i=1,kz
             iz = i+(iblock-1)*kkz
             call extracs(kz+1,nx,ny,i,tfgrid,ftbeam,lx,ly)
             call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
             call cmtore (ftbeam,hdirty%r3d(:,:,iz),nx,ny)
             call docorr (hdirty%r3d(:,:,iz),w_grid,nd)
          enddo
          call gag_cpu(cpu1)
          write(chain,103) 'Finished planes ',blc(3),trc(3),   &
               &        ' CPU ',cpu1-cpu0
          call map_message(seve%i,rname,chain)
       enddo
    endif
    call gag_cpu(cpu1)
    write(chain,102) 'Finished maps ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    hdirty%gil%extr_words = def_extr_words  ! extrema computed
    hdirty%gil%minloc = 1
    hdirty%gil%maxloc = 1
    hdirty%gil%minloc(1:3) = minloc(hdirty%r3d)
    hdirty%gil%maxloc(1:3) = maxloc(hdirty%r3d)
    rma = hdirty%r3d(hdirty%gil%maxloc(1),hdirty%gil%maxloc(2),hdirty%gil%maxloc(3))
    rmi = hdirty%r3d(hdirty%gil%minloc(1),hdirty%gil%minloc(2),hdirty%gil%minloc(3))
    hdirty%gil%rmax = rma
    hdirty%gil%rmin = rmi
    !
    ! Delete scratch space
    error = .false.
    if (allocated(tfgrid)) deallocate(tfgrid)
    if (allocated(ftbeam)) deallocate(ftbeam)
    if (allocated(w_xgrid)) deallocate(w_xgrid)
    if (allocated(w_ygrid)) deallocate(w_ygrid)
    return
    !
101 format(a,i6,a)
102 format(a,f9.2)
103 format(a,i5,' to ',i5,a,f9.2)
  end subroutine one_beam_serial
  !
  subroutine domima(a,rmi,rma,imi,ima,n)
    !----------------------------------------------------------
    ! Compute minmax and location
    !----------------------------------------------------------
    integer, intent(in)    :: n
    integer, intent(out)   :: ima,imi
    real,    intent(in)    ::  a(n)
    real,    intent(inout) :: rmi,rma
    !
    integer :: i
    !
    ima = 0
    imi = 0
    if (a(1).gt.rma) then
       rma = a(1)
       ima = 1
    endif
    if (a(1).lt.rmi) then
       rmi = a(1)
       imi = 1
    endif
    do i=2,n
       if (a(i).gt.rma) then
          rma = a(i)
          ima = i
       elseif (a(i).lt.rmi) then
          rmi = a(i)
          imi = i
       endif
    enddo
  end subroutine domima
  !
  subroutine mx_clean (map,huv,uvdata,uvp,uvv,&
       method,hdirty,hbeam,hclean,hresid,hprim,&
       w_grid,w_mapu,w_mapv,p_cct,dcct,smask,slist,&
       sblock,cpu0,uvmax)
    use image_def
    use uvmap_types
    use cct_types
    use clean_types
    use clean_beam_tool, only: get_beam,beam_plane
    !----------------------------------------------------------------------
    ! Implementation of MX CLEAN deconvolution algorithm.
    !----------------------------------------------------------------------
    type(clean_par), intent(inout) :: method
    type(uvmap_par), intent(inout) :: map
    type(gildas),    intent(inout) :: huv
    type(gildas),    intent(inout) :: hdirty
    type(gildas),    intent(inout) :: hbeam
    type(gildas),    intent(inout) :: hclean
    type(gildas),    intent(inout) :: hresid
    type(gildas),    intent(inout) :: hprim
    real,            intent(inout) :: dcct(3,hclean%gil%dim(3),*)
    logical,         intent(inout) :: smask(:,:)
    integer,         intent(in)    :: slist(*)
    integer,         intent(in)    :: sblock
    real,            intent(inout) :: uvdata(huv%gil%dim(1),huv%gil%dim(2))
    real,            intent(in)    :: uvp(*)
    real,            intent(in)    :: uvv(*)
    real,            intent(inout) :: w_grid(*)
    real,            intent(inout) :: w_mapu(*)
    real,            intent(inout) :: w_mapv(*)
    real,            intent(in)    :: cpu0
    real,            intent(inout) :: uvmax
    type(cct_par),   intent(out)   :: p_cct(method%m_iter)
    !
    logical :: error
    integer :: ier,iplane
    integer :: nx,ny,nz,nf,mc,nclean,i,nu,nv
    real :: fhat
    !
    real, pointer :: p_resid(:,:)
    real, pointer :: p_clean(:,:)
    real, pointer :: p_beam(:,:,:)
    real, pointer :: p_prim(:,:,:)          ! Primary beam
    real, pointer :: p_weight(:,:,:)        ! Mosaic weight
    real, target :: dummy3d(1,1,1)
    !
    integer, allocatable :: p_niter(:)
    real, allocatable :: mapx(:),mapy(:)
    real, allocatable :: p_tfbeam(:,:,:)
    real, allocatable :: w_fft(:)
    complex, allocatable :: p_work(:,:)
    type(cct_par), allocatable :: p_comp(:) ! Clean values
    !
    character(len=message_length) :: chain
    character(len=*), parameter :: rname='MX>CLEAN'
    !
    nx = hdirty%gil%dim(1)
    ny = hdirty%gil%dim(2)
    mc = method%m_iter
    !
    ! Get some memory
    allocate (p_work(nx,ny),p_tfbeam(nx,ny,1),stat=ier)
    nclean = nx*ny
    allocate (p_comp(nclean),stat=ier)
    allocate (mapx(nx),mapy(ny),stat=ier)
    allocate (w_fft(max(nx,ny)),stat=ier)
    !
    call loadxy(method,huv,hdirty,mapx,nx,mapy,ny)
    !
    ! Prepare beam parameters
    method%ibeam = 1             ! Test
    method%iplane = 1            ! Test
    error = .false.
    call method%fit_beam(hbeam,hbeam%r3d,error)
    if (error) return
    call get_beam(method,hbeam,hresid,hprim,p_tfbeam,p_work,w_fft,fhat,error)
    if (error) return
    !
    ! Find components in all planes...
    nz = max(hdirty%gil%dim(3),1)
    allocate (p_niter(nz),stat=ier)
    nf = max(1,hprim%gil%dim(1))
    p_beam  => hbeam%r3d(:,:,1:1)
    if (method%mosaic) then
       p_prim => hprim%r3d
       p_weight=> method%weight
    else
       p_prim => dummy3d
       p_weight=> dummy3d
    endif
    !
    ! Loop here if needed
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    do iplane = method%first,method%last
       method%iplane = iplane
       call beam_plane(method,hbeam,hdirty)
       write(chain,'(A,I6,I6)') 'Image & Beam planes ',method%iplane,method%ibeam
       !omp!$ chain = trim(chain)//cthread
       call map_message(seve%i,rname,chain)
       !
       method%iplane = iplane
       p_resid => hresid%r3d(:,:,iplane)
       p_clean => hclean%r3d(:,:,iplane)
       p_beam  => hbeam%r3d(:,:,method%ibeam:method%ibeam)
       !
       call method%fit_beam(hbeam,p_beam,error)
       if (error) return
       !
       call mx_major_cycle(map,uvdata,   &
            nu,nv,uvp,uvv,   &
            method,hdirty,   &
            p_clean,p_beam,p_resid,   &
            nx,ny,1,         &
            p_comp,nclean,   &
            p_cct, p_niter(iplane),   &
            slist, method%nlist,   &
            nf, p_prim, p_weight,   &
            w_grid, w_mapu, w_mapv, mapx, mapy,   &
            p_tfbeam, cpu0, uvmax)
       !
       ! Add clean components to clean map
       write(chain,1001) 'Restoring plane ',iplane
       call map_message(seve%i,'CLARK',chain)
       ! Could be replaced by CLEAN_MAKE... to be checked...
       if (p_niter(iplane).ne.0) then
          print *,'adding residual '
          call clean_make(method,hclean,p_clean,p_cct)
          p_clean = p_clean+p_resid
       else
          p_clean = p_resid
       endif
       !
       do i=1,method%n_iter
          dcct(1,iplane,i) = (dble(p_cct(i)%ix) -   &
               hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
               hclean%gil%convert(2,1)
          dcct(2,iplane,i) = (dble(p_cct(i)%iy) -   &
               hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
               hclean%gil%convert(2,2)
          dcct(3,iplane,i) = p_cct(i)%value
       enddo
    enddo
    !
    ! Clean-up
    if (allocated(p_work)) deallocate(p_work)
    if (allocated(p_tfbeam)) deallocate(p_tfbeam)
    if (allocated(p_comp)) deallocate(p_comp)
    if (allocated(mapx)) deallocate(mapx)
    if (allocated(mapy)) deallocate(mapy)
    if (allocated(w_fft)) deallocate(w_fft)
    if (allocated(p_niter)) deallocate(p_niter)
    return
    !
1001 format(a,i5,i5)
  end subroutine mx_clean
  !
  subroutine loadxy(method,huv,head,mapx,nx,mapy,ny)
    use phys_const, only: pi
    use image_def
    use clean_types
    !--------------------------------------------------
    ! Load x,y coordinates
    !--------------------------------------------------
    type(clean_par), intent(in)  :: method
    type(gildas),    intent(in)  :: huv,head
    integer,         intent(in)  :: nx
    integer,         intent(in)  :: ny
    real,            intent(out) :: mapx(nx)
    real,            intent(out) :: mapy(ny)
    !
    real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
    !
    integer :: i
    real :: pidsur ! 2*pi*D/Lambda
    real(8) :: freq
    !
    freq = huv%gil%convert(2,1)+huv%gil%fres*   &
         ((method%first+method%last)*0.5-huv%gil%convert(1,1))
    pidsur = f_to_k * freq
    !
    do i=1,nx
       mapx(i) = pidsur*((i-head%gil%convert(1,1))*head%gil%convert(3,1)   &
            +head%gil%convert(2,1))
    enddo
    do i=1,ny
       mapy(i) = pidsur*((i-head%gil%convert(1,2))*head%gil%convert(3,2)   &
            +head%gil%convert(2,2))
    enddo
  end subroutine loadxy
  !
  !------------------------------------------------------------------------
  !
  subroutine mx_major_cycle(map,uvdata,nu,nv,&
       w_weight,w_v,&
       method,head,&
       clean,beam,resid,nx,ny,nb,&
       wcl,mcl,tcc,ncct,&
       list,nl,nf,primary,weight,&
       grid,mapu,mapv,mapx,mapy,&
       wfft,cpu0,uvmax)
    use image_def
    use gkernel_interfaces
    use mapping_interfaces
    use uvmap_types
    use clean_types
    use cct_types
    use minmax_tool, only: maxlst
    use clean_flux_tool, only: next_flux,major_plot
    use clean_cycle_tool, only: minor_cycle
    !----------------------------------------------------------------------
    ! Major cycle loop according to B.Clark idea
    ! Treat only one "plane/channel" at a time
    ! Plane is specified by method%iplane
    !----------------------------------------------------------------------
    type(clean_par), intent(inout) :: method
    type(uvmap_par), intent(in)    :: map
    type(gildas),    intent(inout) :: head
    integer,         intent(in)    :: nu                 ! Visibility size
    integer,         intent(in)    :: nv                 ! Number of visibilities
    integer,         intent(in)    :: nb                 ! Number of beams
    real,            intent(inout) :: uvdata(nu,nv)      ! Visibilities (iterated residuals)
    real,            intent(in)    :: w_weight(nv)       ! Weight array
    real,            intent(in)    :: w_v(nv)            ! V values
    real,            intent(in)    :: uvmax              ! Max baseline
    integer,         intent(in)    :: nx,ny              ! X,Y size
    real,            intent(in)    :: mapx(nx),mapy(ny)  ! X,Y coordinates
    real,            intent(out)   :: mapu(*),mapv(*)    ! U,V coordinates
    real,            intent(in)    :: grid(nx,ny)        ! Grid correction
    real,            intent(inout) :: clean(nx,ny)       ! Clean image
    real,            intent(inout) :: resid(nx,ny)       ! Residuals
    real,            intent(in)    :: beam(nx,ny,nb)     ! Synthesized beams
    integer,         intent(in)    :: nl                 ! Search list size
    integer,         intent(in)    :: mcl                ! Maximum number of clean components
    integer,         intent(out)   :: ncct               ! Number of clean components / plane
    real,            intent(inout) :: wfft(*)            ! Work space for FFT
    type (cct_par),  intent(out)   :: tcc(method%m_iter) ! Clean components array
    integer,         intent(in)    :: list(nx*ny)        ! List of valid pixels
    integer,         intent(in)    :: nf                 ! Number of fields
    real,            intent(inout) :: primary(nf,nx,ny)  ! Primary beams
    real,            intent(inout) :: weight (nx,ny)     ! Flat field
    type(cct_par),   intent(inout) :: wcl(mcl)           ! Work array for Clean Components
    !
    logical :: fini                ! critere d'arret
    logical :: converge            ! Indique la conv par acc de flux
    integer :: lx,ly
    integer :: nn(2),ndim,kz,ier
    integer :: k,kcl
    integer :: ncl                 ! nb de pts reellement retenus
    integer :: imax,jmax,imin,jmin ! leurs coordonnees
    real :: maxc,minc,maxabs       ! max et min de la carte, absolute
    real :: borne                  ! fraction de la carte initiale
    real :: limite                 ! intensite minimum des pts retenus
    real :: clarkl                 ! Clark worry limit
    real :: flux                   ! Total clean flux density
    real :: cpu1,cpu0
    real,    allocatable :: my_resid(:,:)
    complex, allocatable :: tfgrid(:,:,:)
    complex, allocatable :: ftbeam(:,:)
    character(len=message_length) :: chain
    !
    character(len=*), parameter :: rname='MX>MAJOR>CYCLE'
    !
    real ubias,vbias,ubuff(4096),vbuff(4096)
    common /conv/ ubias,vbias,ubuff,vbuff
    !
    print *,'Number of fields ',nf
    print *,'Number of Beams ',nb
    !
    lx = (uvmax+map%support(1))/map%uvcell(1) + 2
    ly = (uvmax+map%support(2))/map%uvcell(2) + 2
    lx = 2*lx
    ly = 2*ly
    if (ly.gt.ny) then
       write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
            ' Undersampling ratio ',   &
            float(ly)/float(ny)
       call map_message(seve%w,'UVMAP',chain)
       write(chain,*) 'UVMAX ',uvmax,map%support, map%uvcell
       call map_message(seve%w,'UVMAP',chain)
    endif
    ly = min(ly,ny)
    lx = min(lx,nx)
    call docoor (lx,-map%uvcell(1),mapu)
    call docoor (ly,map%uvcell(2),mapv)
    !
    kz = 1
    allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),my_resid(nx,ny),stat=ier)
    !
    nn(1) = nx
    nn(2) = ny
    ndim = 2
    call fourt_plan(ftbeam,nn,ndim,-1,1)
    call gag_cpu(cpu0)
    !
    ! Find maximum residual
    call maxlst(resid,nx,ny,list,nl,maxc,imax,jmax,minc,imin,jmin)
    if (method%n_iter.lt.method%p_iter) then
       maxabs=abs(maxc)
    elseif ( abs(maxc).lt.abs(minc) ) then
       maxabs=abs(minc)
    else
       maxabs=abs(maxc)
    endif
    borne= max(method%fres*maxabs,method%ares)
    fini = maxabs.lt.borne
    method%n_iter= 0
    !
    print *,'Weight ',w_weight(1:100)
    !  print *,'V ',w_v
    !
    ! Major cycle
    k = 0
    flux = 0.0
    do while (.not.fini)
       !
       ! Define minor cycle limit
       k = k+1
       write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
       call map_message(seve%i,rname,chain)
       limite = max(maxabs*method%bgain,0.8*borne)
       clarkl = maxabs*method%bgain
       !
       kcl = mcl
       !
       ! Select points of maximum strength and load them in
       call choice (      &
            resid,     &      ! Current residuals
            nx,ny,     &      ! image size
            list, nl,  &      ! Search list
            limite,    &      ! Detection threshold
            kcl,       &      ! Maximum number of candidates
            wcl,       &      ! Selected candidate components
            ncl,       &      ! Selected Number of components
            maxabs, method%ngoal)
       !
       if (ncl.gt.0) then
          write(chain,100) 'Selected ',ncl,' points above ',limite
          call map_message(seve%i,'CLARK',chain)
          !
          ! Make minor cycles
          call minor_cycle (method,   &
               wcl,    &     ! Selected candidate components
               ncl,   &         ! Number of candidates
               beam,nx,ny,   &  ! Dirty beams and Size
               method%beam0(1),method%beam0(2),   & ! Beam center
               method%patch(1),method%patch(2),   & ! Beam patch
               clarkl,limite,   &
               converge,   &    !
               tcc,   &         ! Cumulated components
               nf, primary, weight, method%trunca,   &
               flux,   &        ! Total Flux
               method%pflux, next_flux)
          !
          ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
          !
          call mx_uvsub (nx,ny,mapx,mapy,   &
               wcl, ncl,   &
               nu,nv,uvdata,method%iplane)
          write (chain,101)  'Cleaned ',flux,' Jy with ',   &
               method%n_iter,' clean components'
          call map_message(seve%i,rname,chain)
          !
          ! Compute FFT's and loop again
          call gag_cpu(cpu1)
          write(chain,101) 'Start FFT back at ',cpu1-cpu0
          call map_message(seve%i,rname,chain)
          call dofft (nu,nv,   &   ! Size of visibility array
               uvdata,   &      ! Visibilities
               1,2,   &         ! U, V pointers
               method%iplane,   &   ! First channel to map
               1,lx,ly,   &     ! Cube size
               tfgrid,   &      ! FFT cube
               mapu,mapv,   &   ! U and V grid coordinates
               map%support,   &
               map%uvcell,map%taper,   &    ! Gridding parameters
               w_weight,w_v,   &    ! Weight & Visi arrays
               ubias,vbias,ubuff,vbuff,map%ctype)
          !
          ! Make maps with grid correction
          call extracs (1+1,nx,ny,1,tfgrid,ftbeam,lx,ly)
          call fourt  (ftbeam,nn,ndim,-1,1,wfft)
          call cmtore (ftbeam,my_resid,nx,ny)
          !! print *,'RESID 1',my_resid(:,ny/2)
          call docorr (my_resid,grid,nx*ny)
          !! print *,'RESID 2',my_resid(:,ny/2)
          call gag_cpu(cpu1)
          write(chain,101) 'Finished gridding again ',cpu1-cpu0
          call map_message(seve%i,rname,chain)
          resid = my_resid
          !
          ! Find new extrema
          call maxlst(resid,nx,ny,list,nl,maxc,imax,jmax,minc,imin,jmin)
          if (method%n_iter.lt.method%p_iter) then
             maxabs=abs(maxc)
          elseif ( abs(maxc).lt.abs(minc) ) then
             maxabs=abs(minc)
          else
             maxabs=abs(maxc)
          endif
          !
          ! Check if converge
          fini = (maxabs.le.borne)   &
               .or. (method%m_iter.le.method%n_iter)   &
               .or. converge
       else
          ! No component found: finish...
          write(chain,101) 'No points selected above ',limite
          call map_message(seve%i,rname,chain)
          fini = .true.
       endif
       !
       converge = fini
       !
       ! Unclear here ...
       call major_plot (method,head,   &
            converge,method%n_iter,nx,ny,nf,   &
            tcc,clean,resid,weight)
       fini = converge
       !
       ! Get new list
!!!    if (.not.fini) then
!!!      call re_mask (method,head,nl,error)
!!!      nl = method%nlist
!!!      list = method%list
!!!    endif
    enddo
    ncct = method%n_iter
    !
    ! End
    if (maxabs.le.borne) then
       call map_message(seve%i,rname,'Reached minimum flux density')
    elseif (method%m_iter.le.method%n_iter) then
       call map_message(seve%i,rname,'Reached maximum number of components')
    elseif (method%n_major.le.k) then
       call map_message(seve%i,rname,'Reached maximum number of cycles')
    elseif (converge) then
       call map_message(seve%i,rname,'Reached minor cycle convergence')
    else
       call map_message(seve%i,rname,'End of transcendental causes')
    endif
    write(chain,'(a,1pg10.3,a,i5,a)')  'CLEAN found ',flux,' Jy in ',   &
         method%n_iter,' clean components'
    call map_message(seve%i,'CLEAN',chain)
    !
    if (allocated(tfgrid)) deallocate(tfgrid)
    if (allocated(ftbeam)) deallocate(ftbeam)
    !
100 format (a,i6,a,1pg10.3,a)
101 format (a,1pg10.3,a,i5,a)
  end subroutine mx_major_cycle
  !
  subroutine mx_uvsub(nx,ny,mapx,mapy,wcl,ncl,nu,nv,visi,ip)
    use cct_types
    !----------------------------------------------------------------------
    ! Subtract last major cycle components from UV table.
    ! Treats only one channel.
    !----------------------------------------------------------------------
    integer,       intent(in)    :: nx,ny             ! X,Y size
    real,          intent(in)    :: mapx(nx),mapy(ny) ! X,Y coordinates
    integer,       intent(in)    :: ncl               ! Number of clean components
    type(cct_par), intent(inout) :: wcl(ncl)          ! Clean comp. value
    integer,       intent(in)    :: nu                ! Visibility size
    integer,       intent(in)    :: nv                ! Number of visibilities
    real,          intent(inout) :: visi(nu,nv)       ! Visibilities
    integer,       intent(in)    :: ip                ! Current "plane/channel"
    !
    integer :: ncomp
    integer :: ic,iv,ir,ii
    real :: x,y,phase,rvis,ivis
    !
    ir = 5+3*ip  ! Real part
    ii = ir+1    ! Imaginary part
    !
    ! Compress clean component list
    ncomp = 0
    do ic=1,ncl
       if (wcl(ic)%value.ne.0.0) then
          ncomp = ncomp+1
          wcl(ncomp) = wcl(ic)
       endif
    enddo
    !
    ! Remove clean component from UV data set
    do iv = 1,nv
       do ic = 1,ncomp
          x = mapx(wcl(ic)%ix)
          y = mapy(wcl(ic)%iy)
          phase = visi(1,iv)*x+visi(2,iv)*y
          rvis = wcl(ic)%value*cos(phase)
          ivis = wcl(ic)%value*sin(phase)
          visi(ir,iv) = visi(ir,iv) - rvis
          visi(ii,iv) = visi(ii,iv) - ivis
       enddo
    enddo
  end subroutine mx_uvsub
end module clean_mx
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!*********************************************************************
! REAL*4 Generic External three argument function on vectors
!
subroutine do_real_loop3 (func,n,result,m1,oper1,m2,oper2,m3,oper3,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),              external      :: func       !
  integer(kind=size_length)                :: n          !
  real(kind=4)                             :: result(n)  !
  integer(kind=size_length)                :: m1         !
  real(kind=4)                             :: oper1(m1)  !
  integer(kind=size_length)                :: m2         !
  real(kind=4)                             :: oper2(m2)  !
  integer(kind=size_length)                :: m3         !
  real(kind=4)                             :: oper3(m3)  !
  logical,                   intent(inout) :: error      !
  ! Local
  real(kind=4) :: r,a,b,c
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1 .and. m2.eq.1 .and. m3.eq.1) then
    r = func(oper1(1),oper2(1),oper3(1))
    do i=1,n
      result(i) = r
    enddo
  elseif (m1.eq.n .and. m2.eq.1 .and. m3.eq.1) then
    b = oper2(1)
    c = oper3(1)
    do i=1,n
      result(i) = func(oper1(i),b,c)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n .and. m3.eq.1) then
    a = oper1(1)
    c = oper3(1)
    do i=1,n
      result(i) = func(a,oper2(i),c)
    enddo
  elseif (m1.eq.n .and. m2.eq.n .and. m3.eq.1) then
    c = oper3(1)
    do i=1,n
      result(i) = func(oper1(i),oper2(i),c)
    enddo
  elseif (m1.eq.1 .and. m2.eq.1 .and. m3.eq.n) then
    a = oper1(1)
    b = oper2(1)
    do i=1,n
      result(i) = func(a,b,oper3(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.1 .and. m3.eq.n) then
    b = oper2(1)
    do i=1,n
      result(i) = func(oper1(i),b,oper3(i))
    enddo
  elseif (m1.eq.1 .and. m2.eq.n .and. m3.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = func(a,oper2(i),oper3(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n .and. m3.eq.n) then
    do i=1,n
      result(i) = func(oper1(i),oper2(i),oper3(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2,m3
    call sic_message(seve%e,'S_FUNC',mess)
    error = .true.
  endif
end subroutine do_real_loop3
!
!*********************************************************************
! REAL*4 Generic External two argument function on vectors
!
subroutine do_real_loop2 (func,n,result,m1,oper1,m2,oper2,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),              external      :: func       !
  integer(kind=size_length)                :: n          !
  real(kind=4)                             :: result(n)  !
  integer(kind=size_length)                :: m1         !
  real(kind=4)                             :: oper1(m1)  !
  integer(kind=size_length)                :: m2         !
  real(kind=4)                             :: oper2(m2)  !
  logical,                   intent(inout) :: error      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1 .and. m2.eq.1) then
    a = func(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = func(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = func(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = func(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_FUNC',mess)
    error = .true.
  endif
end subroutine do_real_loop2
!
!----------------------------------------------------------------------
! REAL*4 Two operands arithmetic operations on vectors
!
function lsic_s_bplus (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bplus         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_bplus = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)+oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)+a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a+oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)+oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BPLUS',mess)
    lsic_s_bplus = 1
  endif
end function lsic_s_bplus
!
function lsic_s_bminus (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bminus        !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_bminus = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)-oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)-a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a-oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)-oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BMINUS',mess)
    lsic_s_bminus = 1
  endif
end function lsic_s_bminus
!
function lsic_s_mul (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_mul           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_mul = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)*oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)*a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a*oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)*oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_MUL',mess)
    lsic_s_mul = 1
  endif
end function lsic_s_mul
!
function lsic_s_div (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_div           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Global
  include 'gbl_nan.inc'
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_div = 0
  if (m1.eq.1 .and. m2.eq.1) then
    if (oper2(1).ne.0) then
      a =  oper1(1)/oper2(1)
    elseif  (oper1(1).gt.0) then
      a = s_pinf
    elseif  (oper1(1).lt.0) then
      a = s_minf
    else
      a = s_nan
    endif
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      if (a.ne.0) then
        result(i) = oper1(i)/a
      elseif  (oper1(i).gt.0) then
        result(i) = s_pinf
      elseif  (oper1(i).lt.0) then
        result(i) = s_minf
      else
        result(i) = s_nan
      endif
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      if (oper2(i).ne.0) then
        result(i) = a/oper2(i)
      elseif  (a.gt.0) then
        result(i) = s_pinf
      elseif  (a.lt.0) then
        result(i) = s_minf
      else
        result(i) = s_nan
      endif
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      if (oper2(i).ne.0) then
        result(i) = oper1(i)/oper2(i)
      elseif  (oper1(i).gt.0) then
        result(i) = s_pinf
      elseif  (oper1(i).lt.0) then
        result(i) = s_minf
      else
        result(i) = s_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_DIV',mess)
    lsic_s_div = 1
  endif
end function lsic_s_div
!
function lsic_s_power (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_power         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  integer :: p
  character(len=message_length) :: mess
  !
  lsic_s_power = 0
  if (m1.eq.1 .and. m2.eq.1) then
    p = nint(oper2(1))
    if (abs(float(p)-oper2(1)).le.1.0e-7*abs(float(p))) then
      a = oper1(1)**p
    else
      a = oper1(1)**oper2(1)
    endif
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    p = nint(a)
    if (abs(float(p)-a).le.1.0e-7*abs(float(p))) then
      if (p.eq.2) then
        do i=1,n
          result(i) = oper1(i)*oper1(i)
        enddo
      else
        do i=1,n
          result(i) = oper1(i)**p
        enddo
      endif
    else
      do i=1,n
        result(i) = oper1(i)**a
      enddo
    endif
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      p = nint(oper2(i))
      if (abs(float(p)-oper2(i)).le.1.0e-7*abs(float(p))) then
        result(i) = a**p
      else
        result(i) = a**oper2(i)
      endif
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      p = nint(oper2(i))
      if (abs(float(p)-oper2(i)).le.1.0e-7*abs(float(p))) then
        result(i) = oper1(i)**p
      else
        result(i) = oper1(i)**oper2(i)
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_POWER',mess)
    lsic_s_power = 1
  endif
end function lsic_s_power
!
!----------------------------------------------------------------------
! REAL*4 Two argument functions on vectors
!
function lsic_s_min (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_min           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_min = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = min(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = min(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = min(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = min(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_MIN',mess)
    lsic_s_min = 1
  endif
end function lsic_s_min
!
function lsic_s_max (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_max           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_max = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = max(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = max(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = max(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = max(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_MAX',mess)
    lsic_s_max = 1
  endif
end function lsic_s_max
!
function lsic_s_atan2 (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_atan2         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_atan2 = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = atan2(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = atan2(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = atan2(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = atan2(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_ATAN2',mess)
    lsic_s_atan2 = 1
  endif
end function lsic_s_atan2
!
function lsic_s_dim (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_dim           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_dim = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = dim(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = dim(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = dim(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = dim(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_DIM',mess)
    lsic_s_dim = 1
  endif
end function lsic_s_dim
!
function lsic_s_sign (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_sign          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_sign = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = sign(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = sign(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = sign(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = sign(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_SIGN',mess)
    lsic_s_sign = 1
  endif
end function lsic_s_sign
!
function lsic_s_mod (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_mod           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_mod = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = mod(oper1(1),oper2(1))
    if (a.lt.0.0) a = a+oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = mod(oper1(i),a)
      if (result(i).lt.0.0) result(i) = result(i)+a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = mod(a,oper2(i))
      if (result(i).lt.0.0) result(i) = result(i)+oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = mod(oper1(i),oper2(i))
      if (result(i).lt.0.0) result(i) = result(i)+oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_MOD',mess)
    lsic_s_mod = 1
  endif
end function lsic_s_mod
!
!----------------------------------------------------------------------
! REAL*4 Generic External single argument function on vector
!
subroutine do_real_loop1(func,n,result,m1,oper1,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4) ,             external      :: func       !
  integer(kind=size_length)                :: n          !
  real(kind=4)                             :: result(n)  !
  integer(kind=size_length)                :: m1         !
  real(kind=4)                             :: oper1(m1)  !
  logical,                   intent(inout) :: error      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1) then
    a = func(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = func(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_FUNC',mess)
    error = .true.
  endif
end subroutine do_real_loop1
!
!----------------------------------------------------------------------
! REAL*4 Single argument functions on vectors
!
function lsic_s_abs (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_abs           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_abs = 0
  if (m1.eq.1) then
    a = abs(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = abs(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ABS',mess)
    lsic_s_abs = 1
  endif
end function lsic_s_abs
!
function lsic_s_acos (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_acos          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Global
  include 'gbl_nan.inc'
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_acos = 0
  if (m1.eq.1) then
    a = acos(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      if (oper1(i).ge.-1.0 .and. oper1(i).le.1.0) then
        result(i) = acos(oper1(i))
      else
        result(i) = s_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ACOS',mess)
    lsic_s_acos = 1
  endif
end function lsic_s_acos
!
function lsic_s_asin (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_asin          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Global
  include 'gbl_nan.inc'
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_asin = 0
  if (m1.eq.1) then
    a = asin(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      if (oper1(i).ge.-1.0 .and. oper1(i).le.1.0) then
        result(i) = asin(oper1(i))
      else
        result(i) = s_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ASIN',mess)
    lsic_s_asin = 1
  endif
end function lsic_s_asin
!
function lsic_s_atan (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_atan          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_atan = 0
  if (m1.eq.1) then
    a = atan(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = atan(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ATAN',mess)
    lsic_s_atan = 1
  endif
end function lsic_s_atan
!
function lsic_s_cos (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_cos           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_cos = 0
  if (m1.eq.1) then
    a = cos(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = cos(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_COS',mess)
    lsic_s_cos = 1
  endif
end function lsic_s_cos
!
function lsic_s_atanh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_atanh         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_atanh = 0
  if (m1.eq.1) then
    a = atanh(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = atanh(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ATANH',mess)
    lsic_s_atanh = 1
  endif
end function lsic_s_atanh
!
function lsic_s_cosh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_cosh          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_cosh = 0
  if (m1.eq.1) then
    a = cosh(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = cosh(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_COSH',mess)
    lsic_s_cosh = 1
  endif
end function lsic_s_cosh
!
function lsic_s_exp (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_exp           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_exp = 0
  if (m1.eq.1) then
    a = exp(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = exp(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_EXP',mess)
    lsic_s_exp = 1
  endif
end function lsic_s_exp
!
function lsic_s_int (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_int           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_int = 0
  if (m1.eq.1) then
    a = aint(oper1(1))
    if (a.gt.oper1(1)) a = a-1.0
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = aint(oper1(i))
      if (result(i).gt.oper1(i)) result(i) = result(i)-1.0
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_INT',mess)
    lsic_s_int = 1
  endif
end function lsic_s_int
!
function lsic_s_log (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_log           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_log = 0
  if (m1.eq.1) then
    a = log(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = log(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_LOG',mess)
    lsic_s_log = 1
  endif
end function lsic_s_log
!
function lsic_s_log10 (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_log10         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_log10 = 0
  if (m1.eq.1) then
    a = log10(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = log10(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_LOG10',mess)
    lsic_s_log10 = 1
  endif
end function lsic_s_log10
!
function lsic_s_nint (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_nint          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_nint = 0
  if (m1.eq.1) then
    a = anint(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = anint(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_NINT',mess)
    lsic_s_nint = 1
  endif
end function lsic_s_nint
!
function lsic_s_sin (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_sin           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4)  :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_sin = 0
  if (m1.eq.1) then
    a = sin(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = sin(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_SIN',mess)
    lsic_s_sin = 1
  endif
end function lsic_s_sin
!
function lsic_s_sinh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_sinh          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_sinh = 0
  if (m1.eq.1) then
    a = sinh(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = sinh(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_SINH',mess)
    lsic_s_sinh = 1
  endif
end function lsic_s_sinh
!
function lsic_s_sqrt (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_sqrt          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Global
  include 'gbl_nan.inc'
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_sqrt = 0
  if (m1.eq.1) then
    a = sqrt(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      if (oper1(i).ge.0.0) then
        result(i) = sqrt(oper1(i))
      else
        result(i) = s_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_SQRT',mess)
    lsic_s_sqrt = 1
  endif
end function lsic_s_sqrt
!
function lsic_s_tan (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_tan           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_tan = 0
  if (m1.eq.1) then
    a = tan(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = tan(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_TAN',mess)
    lsic_s_tan = 1
  endif
end function lsic_s_tan
!
function lsic_s_tanh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_tanh          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4)  :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_tanh = 0
  if (m1.eq.1) then
    a = tanh(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = tanh(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_TANH',mess)
    lsic_s_tanh = 1
  endif
end function lsic_s_tanh
!
function lsic_s_floor (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_floor         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4)  :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_floor = 0
  if (m1.eq.1) then
    a = real(floor(oper1(1)),kind=4)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = real(floor(oper1(i)),kind=4)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_FLOOR',mess)
    lsic_s_floor = 1
  endif
end function lsic_s_floor
!
function lsic_s_ceiling (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_ceiling       !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4)  :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_ceiling = 0
  if (m1.eq.1) then
    a = real(ceiling(oper1(1)),kind=4)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = real(ceiling(oper1(i)),kind=4)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_CEILING',mess)
    lsic_s_ceiling = 1
  endif
end function lsic_s_ceiling
!
function lsic_s_uminus (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_uminus        !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_uminus = 0
  if (m1.eq.1) then
    a = -oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = -oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_UMINUS',mess)
    lsic_s_uminus = 1
  endif
end function lsic_s_uminus
!
function lsic_s_uplus (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_uplus         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_uplus = 0
  if (m1.eq.1) then
    a = oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_PLUS',mess)
    lsic_s_uplus = 1
  endif
end function lsic_s_uplus
!
function lsic_s_pyfunc (noper,nelem,nwords,n,result)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>lsic_s_pyfunc
  !---------------------------------------------------------------------
  ! @ private
  ! REAL*4 Generic PYTHON function with variable number of arguments
  !        Called by DO_VECTOR
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_pyfunc  ! Function value on return
  integer(kind=4),              intent(in)  :: noper          ! Number of operands
  integer(kind=size_length),    intent(in)  :: nelem(noper)   ! # of elements for each operand
  integer(kind=address_length), intent(in)  :: nwords(noper)  ! Memory location for each operand
  integer(kind=size_length),    intent(in)  :: n              ! Size of result
  real(kind=4),                 intent(out) :: result(n)      ! Result
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: j
  integer(kind=size_length) :: m
  ! Note on 'ielem': it should be 'size_length', but C functions have no such
  ! equivalent: use 'address_length' (Fortran) == 'size_t' (C), with the limit
  ! that under 32 bits architectures, 'size_length' can be 8 but
  ! 'address_length' 4.
  integer(kind=address_length) :: ielem
  integer(kind=4) :: strides(noper)
  real(kind=4) :: value
  logical :: hasarray
  !
  ! Check dimensions and construct strides
  lsic_s_pyfunc = 1
#if defined(GAG_USE_PYTHON)
  hasarray = .false.
  do j=1,noper
    m = nelem(j)
    if (m.eq.1) then
      strides(j) = 0
    elseif (m.eq.n) then
      strides(j) = 1
      hasarray=.true.
    else
      call sic_message(seve%e,'S_PYFUNC','Inconsistent dimensions')
      lsic_s_pyfunc = 1
      return
    endif
  enddo
  !
  if (.not.hasarray) then
    ielem = 1
    lsic_s_pyfunc = gpy_callfuncs(noper,ielem,strides,nwords,memory,value)
    if (lsic_s_pyfunc.ne.0) return
    do ielem=1,n
      result(ielem) = value
    enddo
  else
    do ielem=1,n
      lsic_s_pyfunc = gpy_callfuncs(noper,ielem,strides,nwords,memory,value)
      if (lsic_s_pyfunc.ne.0) return
      result(ielem) = value
    enddo
  endif
#else
  call sic_message(seve%e,'PYFUNC','Python not available')
#endif
end function lsic_s_pyfunc
!
function lsic_s_erf(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_erf           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_erf = 0
  if (m1.eq.1) then
    a = erf(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = erf(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ERF',mess)
    lsic_s_erf = 1
  endif
end function lsic_s_erf
!
function lsic_s_erfc(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_erfc          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_erfc = 0
  if (m1.eq.1) then
    a = erfc(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = erfc(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ERFC',mess)
    lsic_s_erfc = 1
  endif
end function lsic_s_erfc
!
function lsic_s_erfinv(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_erfinv        !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=8):: x
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_erfinv = 0
  if (m1.eq.1) then
    x = real(oper1(1),kind=8)
    a = gag_erfinv(x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      x = real(oper1(i),kind=8)
      result(i) = gag_erfinv(x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ERFINV',mess)
    lsic_s_erfinv = 1
  endif
end function lsic_s_erfinv
!
function lsic_s_erfcinv(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_erfcinv       !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=8) :: x
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_erfcinv = 0
  if (m1.eq.1) then
    x = real(oper1(1),kind=8)
    a = gag_erfcinv(x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      x = real(oper1(i),kind=8)
      result(i) = gag_erfcinv(x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ERFCINV',mess)
    lsic_s_erfcinv = 1
  endif
end function lsic_s_erfcinv
!
function lsic_s_bessel_i0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_i0     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  real(kind=8) :: x
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_bessel_i0 = 0
  if (m1.eq.1) then
    x = oper1(1)
    a = gag_bessel_i0(x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      x = oper1(i)
      result(i) = gag_bessel_i0(x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_I0',mess)
    lsic_s_bessel_i0 = 1
  endif
end function lsic_s_bessel_i0
!
function lsic_s_bessel_i1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_i1     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  real(kind=8) :: x
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_bessel_i1 = 0
  if (m1.eq.1) then
    x = oper1(1)
    a = gag_bessel_i1(x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      x = oper1(i)
      result(i) = gag_bessel_i1(x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_I1',mess)
    lsic_s_bessel_i1 = 1
  endif
end function lsic_s_bessel_i1
!
function lsic_s_bessel_in(n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_in     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  real(kind=8) :: x
  integer(kind=size_length) :: i
  integer(kind=4) :: o
  character(len=message_length) :: mess
  !
  lsic_s_bessel_in = 0
  if (m1.eq.1 .and. m2.eq.1) then
    o = nint(oper1(1))
    x = dble(oper2(1))
    a = gag_bessel_in(o,x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    x = oper2(1)
    do i=1,n
      o = nint(oper1(i))
      result(i) = gag_bessel_in(o,x)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    o = nint(oper1(1))
    do i=1,n
      x = oper2(i)
      result(i) = gag_bessel_in(o,x)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      o = nint(oper1(i))
      x = oper2(i)
      result(i) = gag_bessel_in(o,x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BESSEL_IN',mess)
    lsic_s_bessel_in = 1
  endif
end function lsic_s_bessel_in
!
function lsic_s_bessel_j0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_j0     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_j0 = 0
  if (m1.eq.1) then
    a = bessel_j0(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = bessel_j0(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_J0',mess)
    lsic_s_bessel_j0 = 1
  endif
#endif
end function lsic_s_bessel_j0
!
function lsic_s_bessel_j1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_j1     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_j1 = 0
  if (m1.eq.1) then
    a = bessel_j1(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = bessel_j1(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_J1',mess)
    lsic_s_bessel_j1 = 1
  endif
#endif
end function lsic_s_bessel_j1
!
function lsic_s_bessel_jn(n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_jn     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  integer(kind=4) :: o
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_jn = 0
  if (m1.eq.1 .and. m2.eq.1) then
    o = nint(oper1(1))
    a = bessel_jn(o,oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      o = nint(oper1(i))
      result(i) = bessel_jn(o,a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    o = nint(oper1(1))
    do i=1,n
      result(i) = bessel_jn(o,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      o = nint(oper1(i))
      result(i) = bessel_jn(o,oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BESSEL_JN',mess)
    lsic_s_bessel_jn = 1
  endif
#endif
end function lsic_s_bessel_jn
!
function lsic_s_bessel_y0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_y0     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_y0 = 0
  if (m1.eq.1) then
    a = bessel_y0(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = bessel_y0(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_Y0',mess)
    lsic_s_bessel_y0 = 1
  endif
#endif
end function lsic_s_bessel_y0
!
function lsic_s_bessel_y1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_y1     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_y1 = 0
  if (m1.eq.1) then
    a = bessel_y1(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = bessel_y1(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_Y1',mess)
    lsic_s_bessel_y1 = 1
  endif
#endif
end function lsic_s_bessel_y1
!
function lsic_s_bessel_yn(n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_yn     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  integer(kind=4) :: o
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_yn = 0
  if (m1.eq.1 .and. m2.eq.1) then
    o = nint(oper1(1))
    a = bessel_yn(o,oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      o = nint(oper1(i))
      result(i) = bessel_yn(o,a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    o = nint(oper1(1))
    do i=1,n
      result(i) = bessel_yn(o,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      o = nint(oper1(i))
      result(i) = bessel_yn(o,oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BESSEL_YN',mess)
    lsic_s_bessel_yn = 1
  endif
#endif
end function lsic_s_bessel_yn

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_consistency
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cube_types
  use cubeadm_cubeid_types
  use cubeadm_index
  use cubemain_messaging
  !
  public :: consistency
  private
  !
  integer(kind=4), parameter :: nsection = 4
  integer(kind=4), parameter :: sect_l = 12
  character(len=sect_l), parameter :: sections(nsection) = [&
       'SPATIAL    ',&
       'SPECTRAL   ',&
       'ARRAY      ',&
       'OBSERVATORY']
  integer(kind=4), parameter :: ispa = 1
  integer(kind=4), parameter :: ispe = 2
  integer(kind=4), parameter :: iarr = 3
  integer(kind=4), parameter :: iobs = 4
  !
  integer(kind=4), parameter :: ntol = 3
  character(len=*), parameter :: tole(ntol) = [&
       'SPATIAL ',&
       'SPECTRAL',&
       'BEAM    ']
  integer(kind=4), parameter :: itolspa = 1
  integer(kind=4), parameter :: itolspe = 2
  integer(kind=4), parameter :: itolbea = 3
  !
  type :: cons_comm_t
     type(option_t),      pointer :: comm
     type(option_t),      pointer :: nocheck
     type(keywordlist_comm_t), pointer :: nocheck_arg
     type(option_t),      pointer :: tolerance
     type(keywordlist_comm_t), pointer :: tole_arg
     type(option_t),      pointer :: index
   contains
     procedure, public  :: register        => cubemain_consistency_register
     procedure, private :: parse           => cubemain_consistency_parse
     procedure, private :: parse_names     => cubemain_consistency_parse_names
     procedure, private :: parse_nocheck   => cubemain_consistency_parse_nocheck
     procedure, private :: parse_tolerance => cubemain_consistency_parse_tolerance
     procedure, private :: main            => cubemain_consistency_main
  end type cons_comm_t
  type(cons_comm_t) :: consistency
  !
  type cons_user_t
     type(cubeid_user_t)   :: cubeids
     logical               :: check(nsection) = .true.
     character(len=argu_l) :: tol(ntol) = strg_unk     ! Tolerances
     logical               :: doindex
   contains
     procedure, private :: toprog => cubemain_consistency_user_toprog
  end type cons_user_t
  type cons_prog_t
     type(index_t)                     :: index            ! Index of cubes to be compared
     real(kind=8)                      :: tol(ntol) = 1d-1 ! Default tolerance
     logical                           :: check(nsection) = .true.
   contains
     procedure, private :: do => cubemain_consistency_prog_do
  end type cons_prog_t
  !
contains
  !
  subroutine cubemain_consistency_command(line,error) 
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(cons_user_t) :: user
    character(len=*), parameter :: rname='CONSISTENCY'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call consistency%parse(line,user,error)
    if (error) return
    call consistency%main(user,error)
    if (error) return
  end subroutine cubemain_consistency_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_consistency_register(consistency,error)
    use cubedag_allflags
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(cons_comm_t), intent(inout) :: consistency
    logical,            intent(inout) :: error
    !
    !
    type(cubeid_arg_t)   :: cubearg
    type(cubeid_arg_t), pointer :: dummy
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: rname='CONSISTENCY>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'CONSISTENCY','[cubeid1 cubeid2]',&
         'Check the consistency between two cube headers',&
         'CONSISTENCY checks header consistency either between two cubes or&
         & across the current index.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Without /INDEX, CONSISTENCY compares two cube headers (explicit&
         & cube arguments or index fallback).'//strg_cr//&
         '- With /INDEX, CONSISTENCY checks cubes from the current index.'//strg_cr//&
         '- Available sections are SPATIAL, SPECTRAL, ARRAY, and OBSERVATORY;&
         & /NOCHECK disables selected sections.'//strg_cr//&
         '- /TOLERANCE customizes percent thresholds for SPECTRAL, SPATIAL,&
         & and BEAM checks. Default tolerance is 10%. '//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> CONSISTENCY cubeA cubeB'//strg_cr//&
         'CUBE> CONSISTENCY cubeA cubeB /NOCHECK ARRAY'//strg_cr//&
         'CUBE> CONSISTENCY /INDEX /TOLERANCE SPATIAL 5 SPECTRAL 5',&
         cubemain_consistency_command,&
         consistency%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID1',&
         'Identifier of cube #1',&
         'If omitted, use the last matching cube (any family/flags) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read_head,&
         code_access_imaset_or_speset,&
         dummy,&! Pointer not saved, will use consistency%comm%arg%list(:)
         error)
    if (error) return
    call cubearg%register(&
         'CUBEID2',&
         'Identifier of cube #2',&
         'If omitted, use the last matching cube (any family/flags) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read_head,&
         code_access_imaset_or_speset,&
         dummy,&! Pointer not saved, will use consistency%comm%arg%list(:)
         error)
    if (error) return
    ! 
    call cubetools_register_option(&
         'NOCHECK','section',&
         'Select consistency section(s) to skip',&
         'Disable selected consistency sections.'//strg_cr//&
         'Accepted sections are SPATIAL, SPECTRAL, ARRAY, and OBSERVATORY.',&
         consistency%nocheck,&
         error)
    if (error) return
    call keyarg%register(&
         'SECTION',&
         'Section(s) to skip in consistency check',&
         'Accepted values: SPATIAL, SPECTRAL, ARRAY, OBSERVATORY.',&
         code_arg_unlimited,&
         sections,&
         .not.flexible,&
         consistency%nocheck_arg,&
         error)
    if (error) return
    ! 
    call cubetools_register_option(&
         'TOLERANCE','[SPECTRAL Tol] [SPATIAL Tol] [BEAM Tol]',&
         'Customize the tolerance on parameters consistency',&
         'Set custom tolerances in percent for SPECTRAL, SPATIAL, and BEAM&
         & consistency checks.'//strg_cr//&
         'Default is 10% for all tolerance-enabled sections.',&
         consistency%tolerance,&
         error) 
    if (error) return
    call keyarg%register(&
         'SECTION',&
         'Section(s) that will have a modified tolerance',&
         'Accepted values: SPECTRAL, SPATIAL, BEAM.',&
         code_arg_unlimited,&
         tole,&
         .not.flexible,&
         consistency%tole_arg,&
         error)
    if (error) return
    call stdarg%register(&
         'TOL',&
         'New tolerance for a given section, in percent',&
         'Default is 10%.',&
         code_arg_unlimited,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'INDEX','',&
         'Check consistency between cubes in the current index',&
         'Run consistency checks on cubes from the current index instead of an&
         & explicit two-cube comparison.',&
         consistency%index,&
         error)
    if (error) return
  end subroutine cubemain_consistency_register
  !
  subroutine cubemain_consistency_parse(consistency,line,user,error) 
    !---------------------------------------------------------------------
    ! CONSISTENCY [cube1 cube2]
    ! /INDEX
    ! /NOCHECK [SPATIAL|SPECTRAL|ARRAY|OBSERVATORY]
    ! /TOLERANCE [SPECTRAL Tol] [SPATIAL Tol] [BEAM Tol]
    !---------------------------------------------------------------------
    class(cons_comm_t), intent(in)    :: consistency
    character(len=*),   intent(in)    :: line
    type(cons_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call consistency%parse_nocheck(line,user,error)
    if (error) return
    call consistency%parse_tolerance(line,user,error)
    if (error) return
    call consistency%index%present(line,user%doindex,error)
    if (error) return
    if (.not.user%doindex) then
       call consistency%parse_names(line,user,error)
       if (error) return
    endif
  end subroutine cubemain_consistency_parse
  !
  subroutine cubemain_consistency_parse_names(consistency,line,user,error)
    !---------------------------------------------------------------------
    ! CONSISTENCY cub1 cub2
    !---------------------------------------------------------------------
    class(cons_comm_t), intent(in)    :: consistency
    character(len=*),   intent(in)    :: line
    type(cons_user_t),  intent(inout) :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>PARSE>NAMES'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,consistency%comm,user%cubeids,error)
    if (error) return
  end subroutine cubemain_consistency_parse_names
  !
  subroutine cubemain_consistency_parse_nocheck(consistency,line,user,error)
    !---------------------------------------------------------------------
    ! /NOCHECK [SPATIAL|SPECTRAL|ARRAY|OBSERVATORY]
    !---------------------------------------------------------------------
    class(cons_comm_t), intent(in)    :: consistency
    character(len=*),   intent(in)    :: line
    type(cons_user_t),  intent(inout) :: user
    logical,            intent(inout) :: error
    !
    integer(kind=4) :: narg, iarg,ikey
    character(len=argu_l) :: arg,key
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='CONSISTENCY>PARSE>NOCHECK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    narg = consistency%nocheck%getnarg()
    if (narg.gt.nsection) then
       write(mess,'(a,i0,a)') 'Only ',nsection,' sections available'
       call cubemain_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    do iarg = 1, narg
       call cubetools_getarg(line,consistency%nocheck,iarg,arg,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(consistency%nocheck_arg,arg,ikey,key,error)
       if (error) return
       user%check(ikey) = .false.
    enddo
  end subroutine cubemain_consistency_parse_nocheck
  !
  subroutine cubemain_consistency_parse_tolerance(consistency,line,user,error)
    !---------------------------------------------------------------------
    ! /TOLERANCE [SPECTRAL Tol] [SPATIAL Tol] [BEAM Tol]
    !---------------------------------------------------------------------
    class(cons_comm_t), intent(in)    :: consistency
    character(len=*),   intent(in)    :: line
    type(cons_user_t),  intent(inout) :: user
    logical,            intent(inout) :: error
    !
    integer(kind=4) :: narg, iarg,ikey
    character(len=argu_l) :: arg,key
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='CONSISTENCY>PARSE>TOLERANCE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    narg = consistency%tolerance%getnarg()
    if (narg.gt.2*ntol) then
       write(mess,'(a,i0,a)') 'Only ',ntol,' sections available'
       call cubemain_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    user%tol(:) = strg_star
    do iarg = 1,narg,2
       call cubetools_getarg(line,consistency%tolerance,iarg,arg,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(consistency%tole_arg,arg,ikey,key,error)
       if (error) return
       call cubetools_getarg(line,consistency%tolerance,iarg+1,user%tol(ikey),mandatory,error)
       if (error) return
    enddo
  end subroutine cubemain_consistency_parse_tolerance
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_consistency_main(consistency,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(cons_comm_t), intent(in)    :: consistency
    type(cons_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(cons_prog_t) :: prog
    character(len=*), parameter :: rname='CONSISTENCY>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubemain_consistency_main
  !
  subroutine cubemain_consistency_user_toprog(user,prog,error)
    use gkernel_interfaces
    use cubetools_consistency_types
    use cubetools_user2prog
    use cubetools_unit
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(cons_user_t), intent(in)    :: user
    type(cons_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    integer(kind=4) :: itol
    type(unit_user_t) :: nounit
    real(kind=8), parameter :: deftol = 2*tenper
    character(len=*), parameter :: rname='CONSISTENCY>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (user%doindex) then
       call prog%index%get_from_current(code_access_imaset_or_speset,code_read_head,error)
       if (error) return
    else
       call prog%index%get_from_cubeid(consistency%comm,user%cubeids,error)
       if (error) return
    endif
    !
    ! What sections are to be checked
    prog%check(:) = user%check(:)
    !
    call nounit%get_from_code(code_unit_unk,error)
    if (error) return
    do itol=1,ntol
       call cubetools_user2prog_resolve_star(user%tol(itol),nounit,deftol,prog%tol(itol),error)
       if (error) return
       ! Convert from percentage to deviation from mean
       prog%tol(itol) = prog%tol(itol)/2d2
    enddo
  end subroutine cubemain_consistency_user_toprog
  !
  subroutine cubemain_consistency_prog_do(prog,error)
    use cubeadm_consistency
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(cons_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    type(consistency_t) :: cons
    character(len=*), parameter :: rname='CONSISTENCY>PROG>DO'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cons%init(prog%index,error)
    if (error) return
    call cons%set_sections(prog%check(ispa),prog%check(ispe),prog%check(iarr),prog%check(iobs),error)
    if (error) return
    call cons%set_tolerance(prog%tol(itolspa),prog%tol(itolbea),prog%tol(itolspe),error)
    if (error) return
    !
    call cons%check(error)
    if (error) return
    !
  end subroutine cubemain_consistency_prog_do
end module cubemain_consistency
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

* DECK xerbla.f
      SUBROUTINE XERBLA( SRNAME, INFO )
*
*  -- LAPACK auxiliary routine (preliminary version) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER*6        SRNAME
      INTEGER            INFO
*     ..
*
*  Purpose
*  =======
*
*  XERBLA  is an error handler for the LAPACK routines.
*  It is called by an LAPACK routine if an input parameter has an
*  invalid value.  A message is printed and execution stops.
*
*  Installers may consider modifying the STOP statement in order to
*  call system-specific exception-handling facilities.
*
*  Arguments
*  =========
*
*  SRNAME  (input) CHARACTER*6
*          The name of the routine which called XERBLA.
*
*  INFO    (input) INTEGER
*          The position of the invalid parameter in the parameter list
*          of the calling routine.
*
*
      WRITE( *, FMT = 9999 )SRNAME, INFO
*
      STOP
*
 9999 FORMAT( ' ** On entry to ', A6, ' parameter number ', I2, ' had ',
     $      'an illegal value' )
*
*     End of XERBLA
*
      END

subroutine sic_add_expr (line,nl,output,no,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_add_expr
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Replace a function by its translation in command line
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: nl                     !
  character(len=*) :: output        !
  integer :: no                     !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='FUNCTION'
  integer :: iput,iout,inxt,ipre,in,ip
  integer :: ifun,iarg,ioper,ipoi,ilas,ifir
  integer :: ista(mfunarg),iend(mfunarg)
  !
  iput = 1
  iout = 1
  inxt = 1                     ! Next character in.
  do while (iput.le.nl)
    !
    ! A parenthesis : may be a function appears before
    if (line(iput:iput).eq.'(') then
      do ifun=1,nfun
        ipre = iput-lonc(ifun)
        if (ipre.lt.1) cycle   ! IFUN
        !
        ! With New SIC, Functions are in UPPER Case, so make the comparison
        ! meaningfull
        if (.not.sic_eqchain(line(ipre:iput-1),fonc(ifun)(1:lonc(ifun))))  &
          cycle   ! IFUN
        if (ipre.gt.1 .and. .not.expr_anoper(line(ipre-1:ipre-1)))  &
          cycle    ! IFUN
        ! This function
        ! Put pending characters
        if (ipre.gt.inxt) then
          output(iout:) = line(inxt:ipre-1)
          iout = iout+ipre-inxt
        endif
        output(iout:) = '('
        iout = iout+1
        in = iput+1
        iarg = 1
        do while (iarg.le.nfunarg(ifun))
          ista(iarg) = in
          ioper = expr_oper2 (line,ip,in,nl)
          if (ioper.eq.1) then
            call sic_message(seve%e,rname,'Wrong syntax')
            error = .true.
            return
          endif
          iend(iarg) = ip
          iarg = iarg+1
        enddo
        !
        ! Last operator must be a closing parenthesis
        if (ioper.ne.-1) then
          call sic_message(seve%e,rname,'Wrong number of arguments')
          error = .true.
          return
        endif
        !
        ! All arguments have been identified. Replace
        do ipoi = 1,lptr(ifun)
          !
          ! Preceding section
          ilas = ila(ipoi,ifun)
          ifir = ifi(ipoi,ifun)
          if (ilas.ge.ifir) then
            output(iout:) = defi(ifun)(ifir:ilas)
            iout = iout+ilas-ifir+1
          endif
          !
          ! Argument if any
          iarg = iva(ipoi,ifun)
          if (iarg.ne.0) then
            output(iout:iout) = '('
            iout = iout+1
            output(iout:) = line(ista(iarg):iend(iarg))
            iout = iout+iend(iarg)-ista(iarg)+1
            output(iout:iout) = ')'
            iout = iout+1
          endif
        enddo
        iput = ip
        inxt = ip+1
        !
      enddo                    ! IFUN
    endif
    iput = iput+1
  enddo
  !
  if (inxt.le.nl) output(iout:) = line(inxt:nl)
  no = len_trim(output)
  ! Add for new SIC
  call sic_upcase(output,no)
end subroutine sic_add_expr
!
function sic_get_expr(func,nf)
  use sic_expressions
  !---------------------------------------------------------------------
  ! @ private
  !  Translate a function name to its identifier. Return 0 if no such
  ! function (not an error, up to the caller to decide)
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_get_expr  ! Function value on return
  character(len=*), intent(in) :: func  !
  integer(kind=4),  intent(in) :: nf    !
  ! Local
  integer(kind=4) :: i
  !
  do i=1,nfun
    if (func(1:nf).eq.fonc(i)(1:lonc(i))) then  ! Case-sensitive
      ! Found
      sic_get_expr = i
      return
    endif
  enddo
  !
  ! Not found
  sic_get_expr = 0
  !
end function sic_get_expr
!
subroutine sic_list_expr (func,nf,error)
  use sic_interfaces, except_this=>sic_list_expr
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  List 1 or all user-defined functions
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: func   !
  integer(kind=4),  intent(in)    :: nf     !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FUNCTION'
  integer(kind=4) :: i
  !
  if (nf.eq.0) then
    ! List all functions
    if (nfun.eq.0) return
    call sic_message(seve%i,'FUNCTION','User defined functions are:')
    do i=1,nfun
      write (*,'(2A)') fonc(i),defi(i)
    enddo
  else
    ! List one function
    i = sic_get_expr(func,nf)
    if (i.eq.0) then
      call sic_message(seve%e,rname,'No such function '//func(1:nf))
      error = .true.
      return
    endif
    call sic_message(seve%i,'FUNCTION',func(1:nf)//' is a user-defined function:')
    write (*,'(2A)') fonc(i),defi(i)
  endif
  !
end subroutine sic_list_expr
!
subroutine sic_del_expr(func,nf,error)
  use sic_interfaces, except_this=>sic_del_expr
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Delete a user function
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: func   ! Function name
  integer(kind=4),  intent(in)    :: nf     ! Length of func
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FUNCTION'
  integer(kind=4) :: i,j,jj,k
  !
  i = sic_get_expr(func,nf)
  if (i.eq.0) then
    call sic_message(seve%e,rname,'No such function '//func(1:nf))
    error = .true.
    return
  endif
  !
  do j=i+1,nfun
    jj = j-1
    nfunarg(jj) = nfunarg(j)
    lonc(jj) = lonc(j)
    lptr(jj) = lptr(j)
    do k=1,lptr(j)
      ifi(k,jj) = ifi(k,j)
      ila(k,jj) = ila(k,j)
      iva(k,jj) = iva(k,j)
    enddo
    fonc(jj) = fonc(j)
    defi(jj) = defi(j)
  enddo
  nfun = nfun-1
  !
end subroutine sic_del_expr
!
subroutine sic_def_expr (func,nf,line,nl,error)
  use sic_interfaces, except_this=>sic_def_expr
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Define a user function (DEFINE FUNCTION)
  !---------------------------------------------------------------------
  character(len=*) :: func          !
  integer :: nf                     !
  character(len=*) :: line          !
  integer :: nl                     !
  logical :: error                  !
  ! Local
  character(len=12) :: farg(mfunarg)
  integer :: iarg,i,if,ip,in,jp,ioper,ipt,ifun
  !
  if (nfun.eq.mfun) then
    call sic_message(seve%e,'FUNCTION','Too many functions')
    error = .true.
    return
  elseif (nf.gt.len(fonc(1))) then
    call sic_message(seve%e,'FUNCTION','Function name is too long')
    error = .true.
    return
  elseif (nl.gt.len(defi(1))) then
    call sic_message(seve%e,'FUNCTION','Definition is too long')
    error = .true.
    return
  endif
  !
  ! Analyse input function FUNC(Var1,Var2,VarN)
  ifun = nfun+1
  iarg = 0
  if = 0
  do i=1,nf
    if (func(i:i).eq.'(') then
      if (if.ne.0) goto 99
      fonc(ifun) = func
      lonc(ifun) = i-1
      iarg = 1
      if = i+1
    elseif (func(i:i).eq.',') then
      if (iarg.eq.mfunarg) then
        call sic_message(seve%e,'DEFINE','Too many arguments')
        error =.true.
        return
      endif
      if (if.eq.0) goto 99
      farg(iarg) = func(if:i-1)
      iarg = iarg+1
      if = i+1
    elseif (func(i:i).eq.')') then
      if (if.eq.0) goto 99
      if (i.ne.nf) goto 99
      farg(iarg) = func(if:i-1)
    endif
  enddo
  !
  ! Check if it exists
  i = sic_get_expr(fonc(ifun),lonc(ifun))  ! NB: ifun = nfun+1
  if (i.ne.0) then
    call sic_message(seve%e,'FUNCTION',  &
      'Function '//fonc(ifun)(1:lonc(ifun))//' already defined')
    error = .true.
    return
  endif
  nfunarg(ifun) = iarg
  !
  ! Analyse definition
  ip = 1
  in = 1
  jp = 1
  ipt = 1
  ifi(ipt,ifun) = 1
  iva(ipt,ifun) = 0
  do while (in.le.nl)
    !
    ! Find next operator : IP pointer towards end of previous
    ! operand, IN towards beginning of next operand.
    ! Operator is LINE(IP+1:IN-1).
    !
    ioper = expr_oper1(line,ip,in,nl)
    if (ioper.eq.0 .and. ip.ge.jp) then
      do i=1,iarg
        if (farg(i).eq.line(jp:ip)) then
          if (ipt.eq.mpoi) then
            call sic_message(seve%e,'FUNCTION','Definition is too complex')
            error = .true.
            return
          endif
          ila(ipt,ifun) = jp-1
          iva(ipt,ifun) = i
          ipt = ipt+1
          ifi(ipt,ifun) = ip+1
          iva(ipt,ifun) = 0
        endif
      enddo
    elseif (ioper.eq.-1) then
      error = .true.
      return
    endif
    jp = in
  enddo
  ila(ipt,ifun) = nl
  lptr(ifun) = ipt
  defi(ifun) = line(1:nl)
  nfun = ifun
  error = .false.
  return
  !
99 call sic_message(seve%e,'DEFINE','Syntax error')
  error = .true.
end subroutine sic_def_expr
!
function expr_oper1 (line,ip,in,nl)
  use sic_interfaces, except_this=>expr_oper1
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !       Returns index of first character in line which could be part of
  !       an operator field.
  ! Arguments :
  !       LINE    B(N)    Character string to be formatted        Input
  !       IP      I       Index of character before operator	Output
  !	IN	I	Index of character after operator	Input/Output
  !       NL      I       Length of C                             Input
  !---------------------------------------------------------------------
  integer :: expr_oper1             !
  character(len=*) :: line          !
  integer :: ip                     !
  integer :: in                     !
  integer :: nl                     !
  ! Local
  character(len=*), parameter :: rname='MATH'
  integer :: i
  logical :: array,separ,chain
  !
  expr_oper1 = 1
  array = .false.
  separ = .false.
  chain = .false.
  do i = in,nl
    if (chain) then
      if (line(i:i).eq.'"') then
        chain = .false.
        separ = .true.
      endif
    elseif (array) then
      if (line(i:i).eq.']') then
        array = .false.
        separ = .true.
      endif
    elseif (line(i:i).eq.'[') then
      array = .true.
    elseif (line(i:i).eq.']') then
      call sic_message(seve%e,rname,'Unmatch Closing bracket')
      expr_oper1 = -1
      return
    elseif (line(i:i).eq.'"') then
      chain = .true.
      !
      ! * could also be ** : check next character
    elseif (line(i:i).eq.'*') then
      ip = i-1
      if (line(i+1:i+1).eq.'*') then
        in = i+2
      else
        in = i+1
      endif
      expr_oper1 = 0
      return
      !
      ! Should be changed on a non-ASCII machine.
      ! '(', ')', '*', '+', ',', '-', '.', or '/' are contiguous in ASCII
    elseif ( (line(i:i).ge.'('.and.line(i:i).le.'/') .or.  &
             (line(i:i).eq.'|') .or. (line(i:i).eq.'^') ) then
      ip = i-1
      in = i+1
      expr_oper1 = 0
      return
    elseif (separ) then
      call sic_message(seve%e,rname,'Missing operator after string or '//  &
      'closing bracket')
      expr_oper1 = -1
      return
    endif
  enddo
  if (chain.or.array) return
  expr_oper1 = 0
  ip = nl
  in = nl+1
end function expr_oper1
!
function expr_oper2 (line,ip,in,nl)
  !---------------------------------------------------------------------
  ! @ private
  !       Returns index of first character in line which is a
  !	matching comma or closing parentheses
  ! Arguments :
  !       LINE    B(N)    Character string to be formatted        Input
  !       IP      I       Index of character before operator	Output
  !	IN	I	Index of character after operator	Input/Output
  !       NL      I       Length of C                             Input
  !---------------------------------------------------------------------
  integer :: expr_oper2             !
  character(len=*) :: line          !
  integer :: ip                     !
  integer :: in                     !
  integer :: nl                     !
  ! Local
  integer :: i,level
  logical :: array,chain
  !
  expr_oper2 = 1
  array = .false.
  chain = .false.
  level = 0
  do i = in,nl
    if (chain) then
      if (line(i:i).eq.'"') chain = .false.
    elseif (array) then
      if (line(i:i).eq.']') array = .false.
    elseif (line(i:i).eq.'[') then
      array = .true.
    elseif (line(i:i).eq.'"') then
      chain = .true.
    elseif (line(i:i).eq.'(') then
      level = level+1
    elseif (line(i:i).eq.')') then
      if (level.eq.0) then
        ip = i-1
        in = i+1
        expr_oper2 = -1
        return
      endif
      level = level-1
    elseif (line(i:i).eq.',') then
      if (level.eq.0) then
        ip = i-1
        in = i+1
        expr_oper2 = 0
        return
      endif
    endif
  enddo
  ip = nl+1
end function expr_oper2
!
function expr_anoper (line)
  !---------------------------------------------------------------------
  ! @ private
  !       Returns index of first character in line which could be part of
  !       an operator field.
  ! Arguments :
  !       LINE    C*1     Character string to be formatted        Input
  !---------------------------------------------------------------------
  logical :: expr_anoper            !
  character(len=1) :: line          !
  ! Should be changed on a non-ASCII machine.
  ! '(', ')', '*', '+', ',', '-', '.', or '/' are contiguous in ASCII
  if ( (line.ge.'('.and.line.le.'/') .or.  &
       (line.eq.'|') .or. (line.eq.'^') ) then
    expr_anoper = .true.
  else
    expr_anoper = .false.
  endif
end function expr_anoper

!-----------------------------------------------------------------------
! Support file for skydips fit (minimization routines).
!
! In this file, equations can be found from:
!   Memo I: "Amplitude Calibration, IRAM PdBI", S.Guilloteau, v1.0
!   Memo II: "Calibration of spectral line data at the IRAM 30m
!             radiotelescope", C.Kramer, 24-jan-1997, v2.1
!-----------------------------------------------------------------------
module skydip_data
  use chopper_definitions
  !
  ! Atmosphere definition
  real*4 :: tamb,pamb,alti
  !
  integer, parameter :: mmeas=10  ! Maximum number of measurement sets to reduce simultaneously
  integer :: nmeas                ! Number of effective measurement set requested by user
  !
  ! Input receiver(s)
  type(mixer), save :: rec(mmeas)  ! rec%feff & rec%temp: one is in, one is out, depending on mode
  !
  ! Input skydip measurements
  type(skydip_meas), save :: skydip(mmeas)
  !
  ! FITSKY (minimization routine) variables
  real*8 :: sky(msky,mmeas)   ! Unknown (???) (Trec mode)
  real*8 :: temi(msky,mmeas)  ! Temi (Feff mode)
  logical :: trec_mode        ! Fit Trec or Feff
  real*8  :: par(mmeas+2)     ! mmeas*Feff + H2Omm + Tloss
                              ! Feff/Trec are the 1 to nmeas parameters
  integer :: ph2o             ! H2Ommm is the ph2o-th parameter
  logical :: tloss_mode       ! Fit or not one global Tloss
  integer :: ptloss           ! Tloss is the ptloss-th parameter
  integer :: plast            ! Last parameter is the plast-th one
  real*8 :: chi2tot           ! One global chi2 for all fitted measurement set
  real*8 :: rmstot            ! One global RMS for all fitted measurement set
  !
  ! Calibration variables
  type(atm_prop), save :: atm(mmeas)  ! Each measurement set (with its own frequencies)
                                 ! has its own atm% values
  real :: tcal,chot_mean
  !
end module skydip_data
!
subroutine solve_skydip(tamb_in,pamb_in,alti_in,     &
                        nmeas_in,rec_in,skydip_in,   &
                        fit_mode_in,  &
                        params_out,   &
                        error)
  use telcal_interfaces, except_this=>solve_skydip
  use skydip_data
  use chopper_definitions
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  ! SKYDIP Internal routine
  !   Main entrance routine to reduce a skydip.
  !   1) Copy input data into the real variables used for the reduction.
  !      These are shared through subroutines thanks to a module.
  !   2) Call the real work routine
  !----------------------------------------------------------------------
  real*4,             intent(in)    :: tamb_in         ! [K]
  real*4,             intent(in)    :: pamb_in         ! [mbar/hPa]
  real*4,             intent(in)    :: alti_in         ! [m]
  integer,            intent(in)    :: nmeas_in        !
  type (mixer),       intent(in)    :: rec_in(nmeas_in)     !
  type (skydip_meas), intent(in)    :: skydip_in(nmeas_in)  !
  logical,            intent(in)    :: fit_mode_in(2)  ! Which values to fit
  real*8,             intent(out)   :: params_out(*)   ! Output fitted parameters
  logical,            intent(inout) :: error           ! Error flag
  !
  ! 1) Copy values into shared variables
  tamb = tamb_in
  pamb = pamb_in
  alti = alti_in
  nmeas = nmeas_in
  rec(1:nmeas) = rec_in
  skydip(1:nmeas) = skydip_in
  trec_mode = fit_mode_in(1)
  tloss_mode = fit_mode_in(2)
  !
  ! 2) Deduce some fitting parameters
  ph2o = nmeas+1
  if (tloss_mode) then
    ptloss = nmeas+2
    plast = ptloss
  else
    plast = ph2o
  endif
  !
  ! 2) Call the reduction routines
  call solve_skydip_sub(error)
  if (error) return
  !
  ! 3) Return fitted parameters
  params_out(1:plast) = par(1:plast)
  !
end subroutine solve_skydip
!
subroutine solve_skydip_sub(error)
  use telcal_interfaces, except_this=>solve_skydip_sub
  use skydip_data
  !----------------------------------------------------------------------
  ! @ private
  ! SKYDIP Internal routine
  !   Reduce a skydip. Compute the starting atmospheric model.
  !----------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='SKYDIP'
  character(len=*), parameter :: wchain='W-'//rname//',  '
  integer :: ier,imeas
  !
  ! Set the atmosphere
  call atm_atmosp(tamb,  &    ! [K]
                  pamb,  &    ! [mbar]
                  alti*1e-3)  ! [km]
  !
  ! Prepare environment for each skydip to be reduced
  do imeas=1,nmeas
    call solve_skydip_set(imeas,error)
    if (error) return
  enddo
  !
  ! Minimize
  ! ZZZ to be checked in Trec mode
  chot_mean = skydip(1)%hot(1)%count  ! sum(skydip%hot(1:skydip%nhot)%count)/skydip%nhot
  call fitsky(minsky,.false.,ier)
  if (ier.ne.0)  &
     call gagout(wchain//'Solution not converged')
  !
  ! Fitted (and derived) values
  do imeas=1,nmeas
    ! Fitted H2O
    atm(imeas)%h2omm = par(ph2o)  ! Same for all
    atm(imeas)%taus%tot = atm(imeas)%taus%oth + atm(imeas)%h2omm * atm(imeas)%taus%wat
    atm(imeas)%taui%tot = atm(imeas)%taui%oth + atm(imeas)%h2omm * atm(imeas)%taui%wat
    !
    ! Fitted Trec/Feff
    if (trec_mode) then
      rec(imeas)%temp = par(imeas)
    else
      rec(imeas)%feff = par(imeas)
    endif
  enddo
  !
  ! Display results
  call skydip_display()
  !
end subroutine solve_skydip_sub
!
subroutine solve_skydip_set(inmeas,error)
  use atm_interfaces_public
  use telcal_interfaces, except_this=>solve_skydip_set
  use skydip_data
  !---------------------------------------------------------------------
  ! @ private
  ! Prepare the environment (atmosphere...) and calibration variables
  ! for the inmeas-th skydip.
  !---------------------------------------------------------------------
  integer, intent(in)    :: inmeas  ! Skydip number
  logical, intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SKYDIP'
  character(len=*), parameter :: echain='E-'//rname//',  '
  real*4 :: t_emi,freqsig_ghz,freqima_ghz
  real*4 :: tau_dry_s,tau_wet_s,tau_tot_s,t_atm_s
  real*4 :: tau_dry_i,tau_wet_i,tau_tot_i,t_atm_i
  integer :: i,ier
  character(len=*), parameter :: emess(3) = (/  &
                'Zero atmospheric opacity',     &
                'No oxygen in atmosphere ' ,    &
                'No water in atmosphere  '  /)
  !
  ! Set opacities (signal and image)
  freqsig_ghz = 1e-3*skydip(inmeas)%freq%s
  call atm_transm(1.,1.,freqsig_ghz,  &
                  t_emi,t_atm_s,tau_dry_s,tau_wet_s,tau_tot_s,ier)
  if (ier.ne.0)  &
    call gagout(echain//'Stupid calibration: '//emess(ier))
  atm(inmeas)%taus%oth = tau_dry_s  ! R*8 <- R*4
  atm(inmeas)%taus%wat = tau_wet_s
  atm(inmeas)%temp%s   = t_atm_s
  !
  freqima_ghz = 1e-3*skydip(inmeas)%freq%i
  call atm_transm(1.,1.,freqima_ghz,  &
                  t_emi,t_atm_i,tau_dry_i,tau_wet_i,tau_tot_i,ier)
  if (ier.ne.0)  &
    call gagout(echain//'Stupid calibration: '//emess(ier))
  atm(inmeas)%taui%oth = tau_dry_i  ! R*8 <- R*4
  atm(inmeas)%taui%wat = tau_wet_i
  atm(inmeas)%temp%i   = t_atm_i
  !
  if (trec_mode) then
    do i=1,skydip(inmeas)%nsky
      sky(i,inmeas) =  &
        skydip(inmeas)%emiss(i)%count - skydip(inmeas)%hot(i)%count
    enddo
  else
    do i=1,skydip(inmeas)%nsky
      ! Eq.7 Memo I:
      ! Temi = ((Tload+Trec)*Cemi)/Cload - Trec
      temi(i,inmeas) =  &
        (skydip(inmeas)%hot(i)%temp + rec(inmeas)%temp) *  &
        skydip(inmeas)%emiss(i)%count /            &
        skydip(inmeas)%hot(i)%count                &
        - rec(inmeas)%temp
    enddo
  endif
  !
end subroutine solve_skydip_set
!
subroutine skydip_display()
  use telcal_interfaces, except_this=>skydip_display
  use skydip_data
  !---------------------------------------------------------------------
  ! @ private
  ! SKYDIP Internal routine
  !   Display the input and fitted values
  !---------------------------------------------------------------------
  ! Local
  integer :: imeas
  !
  ! Print common parameters
  write(6,'(A)') '=== Summary ====='
  write(6,100) tamb,pamb,alti
  !
  ! Print skydip-per-skydip values
  do imeas=1,nmeas
    write(6,'(A,I2,A)') '--- ',imeas,' -----'
    ! Input
    write(6,101) rec(imeas)%temp,skydip(imeas)%hot(1)%temp,skydip(imeas)%cold(1)%temp
    !
    ! Output
    write(6,'(t20,a,t30,a,t40,a,t50,a,t60,a)')  &
      'Freq','Tau','TauDry','TauWet','Tatm'
    write(6,102)  'Signal band: ',  &
      1d-3*skydip(imeas)%freq%s,atm(imeas)%taus%tot,atm(imeas)%taus%oth,  &
        atm(imeas)%taus%wat*atm(imeas)%h2omm,atm(imeas)%temp%s
    write(6,102)  'Image  band: ',  &
      1d-3*skydip(imeas)%freq%i,atm(imeas)%taui%tot,atm(imeas)%taui%oth,  &
        atm(imeas)%taui%wat*atm(imeas)%h2omm,atm(imeas)%temp%i
    !
    write(6,103)  rec(imeas)%feff
  enddo
  !
  ! Print fitted values shared by all skydips
  write(6,'(A)') '--- Total -----'
  if (tloss_mode) then
    write(6,104) atm(1)%h2omm,par(ptloss)
  else
    write(6,105) atm(1)%h2omm
  endif
  write(6,106) chi2tot,rmstot
  !
100 format(t3,'Tamb:',f8.2,t20,'Pamb:',f8.2,t37,'Alti:',f8.0)
101 format(t3,'Trec:',f8.2,t20,'Thot:',f8.2,t37,'Tcold:',f8.2)
102 format(t3,a,t15,5f10.3)
103 format(t3,'Feff:', f8.3)
104 format(t3,'Water:',f8.3,t20,'Tloss (K):',f8.2)
105 format(t3,'Water:',f8.3)
106 format(t3,'Chi2:',f8.4,t20,'Rms (K):',f8.4)
  !
end subroutine skydip_display
!
subroutine fitsky(fcn,liter,ier)
  use telcal_interfaces, except_this=>fitsky
  use skydip_data
  use gkernel_interfaces
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ private
  ! SKYDIP Internal routine
  !   Setup and starts a SKYDIP fit minimisation using MINUIT
  !----------------------------------------------------------------------
  external             :: fcn      ! Function to be mininized
  logical, intent(in)  :: liter    ! Logical of iterate fit
  integer, intent(out) :: ier      ! Error flag
  ! Local
  type(fit_minuit_t) :: fit
  integer :: npoints,imeas
  real :: tau,a1,ap
  logical :: error
  !
  error = .false.
  ier = 0
  !
  fit%owner = gpack_get_id('telcal',.true.,error)
  if (error)  return
  fit%maxext=ntot
  fit%maxint=nvar
  npoints = sum(skydip(1:nmeas)%nsky)
  !
  write(6,'(A)') 'SKYDIP Fit:'
  !
  ! Initialise values.
  do imeas=1,nmeas
    ! Airmasses: approx but harmless for an initial guess
    a1 = 1./sin(skydip(imeas)%elev(1))
    ap = 1./sin(skydip(imeas)%elev(skydip(imeas)%nsky))
    !
    if (trec_mode) then
      ! ZZZ to be checked in Trec mode
      par(imeas) = skydip(imeas)%hot(1)%count /  &
                   (0.9*rec(imeas)%temp + skydip(imeas)%hot(1)%temp)
      write(6,'(A,I2,A,F8.3)')  &
        ' Starting value of Trec[',imeas,'] (K): ',par(imeas)
      tau = (sky(skydip(imeas)%nsky,imeas)-sky(1,imeas)) /  &
            par(imeas)/(ap-a1)/atm(imeas)%temp%s/rec(imeas)%feff
    else
      par(imeas) = 1. -  &
                  (a1*temi(skydip(imeas)%nsky,imeas) - ap*temi(1,imeas)) /  &
                  tamb/(a1-ap)
      par(imeas) = min(1.,max(0.,par(imeas)))
      write(6,'(A,I2,A,F8.3)')  &
        ' Starting value of Feff[',imeas,']    : ',par(imeas)
      tau = (temi(skydip(imeas)%nsky,imeas)-temi(1,imeas)) /  &
            par(imeas)/(ap-a1)/atm(imeas)%temp%s
    endif
  enddo
  !
  ! Starting value of global H2Omm. Rely on the last measurement set for
  ! initial guess.
  ! tau_tot = tau_dry + Wh2O*tau_wet
  par(ph2o) = (tau-atm(nmeas)%taus%oth)/atm(nmeas)%taus%wat *  &
              (1.0+rec(nmeas)%sbgr) ! ZZZ ! Extra factor?
  par(ph2o) = min(20.,max(0.,par(ph2o)))
  write(6,'(A,F8.3)') ' Starting value of PWV (mm)    :',par(ph2o)
  !
  ! Starting value for global Tloss (if fitted)
  if (tloss_mode) then
    ! Tloss = alpha*Tcab+(1-alpha)*Tamb
    par(ptloss) = tamb  ! Approximation for initial guess
    write(6,'(A,F8.2)') ' Starting value of Tloss (K)   :',par(ptloss)
  endif
  !
  ! Init
  call midsky(fit,ier,liter)
  if (ier.ne.0) return
  call intoex(fit,fit%x)
  fit%nfcnmx = 1000
  fit%newmin = 0
  fit%itaur  = 0
  fit%isw(1) = 0
  fit%isw(3) = 1
  fit%nfcn = 1
  fit%vtest = 0.04
  call fcn(fit%npar,fit%g,fit%amin,fit%u,1)
  chi2tot = fit%amin
  rmstot = sqrt(fit%amin/npoints)  ! RMS with initial values
  fit%up = rmstot**2
  fit%epsi = 0.1d0 * fit%up
  !
  ! Simplex Minimization
  call simplx(fit,fcn,ier)
  if (ier.ne.0) return
  call intoex(fit,fit%x)
  ! Store back results
  par(1:plast) = fit%u(1:plast)
  ! Compute rms
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  chi2tot = fit%amin
  rmstot = sqrt(fit%amin/npoints)
  fit%up = rmstot**2
  write(6,'(A)') '1st step: Simplex minimization'
  call fitsky_print(fit)
  ! Prepare next minimization
  fit%epsi = 0.1d0 * fit%up
  fit%apsi = fit%epsi
  !
  ! Gradient Minimization
  call hesse(fit,fcn)
  call migrad(fit,fcn,ier)
  call intoex(fit,fit%x)
  ! Store back results
  par(1:plast) = fit%u(1:plast)
  ! Compute rms
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  chi2tot = fit%amin
  rmstot = sqrt(fit%amin/npoints)
  fit%up = rmstot**2
  write(6,'(A)') '2nd step: Gradient minimization'
  call fitsky_print(fit)
  ! Prepare next minimization
  fit%epsi = 0.1d0 * fit%up
  fit%apsi = fit%epsi
  ier = 0
  call migrad(fit,fcn,ier)
  !
  ! Iterate once again if not converged
  if (ier.eq.3) then
    ier = 0
    call migrad(fit,fcn,ier)
  endif
  ! Compute covariance matrix if bad
  if (ier.eq.1) then
    call hesse(fit,fcn)
    ier = 0
  endif
  call intoex(fit,fit%x)
  ! Store back results
  par(1:plast) = fit%u(1:plast)
  ! Compute rms
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  chi2tot = fit%amin
  rmstot = sqrt(fit%amin/npoints)
  fit%up = rmstot**2
  write(6,'(A)') '3rd step: Final minimization'
  call fitsky_print(fit)
  !
end subroutine fitsky
!
subroutine fitsky_print(fit)
  use telcal_interfaces, except_this=>fitsky_print
  use skydip_data
  use gkernel_interfaces
  use fit_minuit
  !---------------------------------------------------------------------
  ! @ private
  ! SKYDIP Internal routine
  !  Display fitted values and RMS
  !---------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit  ! Fitting variables
  ! Local
  integer :: i,l,imeas
  real*8 :: dx,al,ba,du1,du2
  !
  ! External Errors
  do i=1,fit%nu
    l = fit%lcorsp(i)
    if (l.eq.0)  then
      fit%werr(i)=0.
    else
      if (fit%isw(2).ge.1)  then
        dx = dsqrt(dabs(fit%v(l,l)*fit%up))
        if (fit%lcode(i).gt.1) then
          al = fit%alim(i)
          ba = fit%blim(i) - al
          du1 = al + 0.5d0 *(dsin(fit%x(l)+dx) +1.0d0) * ba - fit%u(i)
          du2 = al + 0.5d0 *(dsin(fit%x(l)-dx) +1.0d0) * ba - fit%u(i)
          if (dx.gt.1.0d0)  du1 = ba
          dx = 0.5d0 * (dabs(du1) + dabs(du2))
        endif
        fit%werr(i) = dx
      endif
    endif
  enddo
  !
  do imeas=1,nmeas
    if (trec_mode) then
      fit%werr(imeas) = fit%werr(imeas)/par(imeas)**2*chot_mean
      ! ZZZ to be checked in Trec mode
      par(imeas) = chot_mean/par(imeas) - skydip(imeas)%hot(1)%temp
      write(6,'(A,I2,A,F8.2,A,F7.2,A)')  &
        ' Trec[',imeas,'] (K): ',par(imeas),' (',fit%werr(imeas),')'
    else
      write(6,'(A,I2,A,F8.3,A,F7.3,A)')  &
        ' Feff[',imeas,']    : ',par(imeas),' (',fit%werr(imeas),')'
    endif
  enddo
  !
  ! Fitted water vapor
  write(6,'(A,F8.3,A,F7.3,A)')  &
    ' PWV (mm)    : ',par(ph2o),' (',fit%werr(ph2o),')'
  !
  ! Fitted Tloss
  if (tloss_mode) then
    write(6,'(A,F8.2,A,F7.2,A)')  &
      ' Tloss (K)   : ',par(ptloss),' (',fit%werr(ptloss),')'
  endif
  !
  ! RMS of residuals
  write(6,'(A,F8.5)') ' RMS of Residuals: ',rmstot
  !
  write(6,*)
  !
end subroutine fitsky_print
!
subroutine midsky(fit,ier,liter)
  use telcal_interfaces, except_this=>midsky
  use skydip_data
  use gkernel_interfaces
  use fit_minuit
  !----------------------------------------------------------------------
  ! @ private
  ! SKYDIP Internal routine
  !   Start a SKYDIP fit by building the PAR array and internal
  !    variable used by Minuit.
  !   Parameters are
  !    PAR(1:NMEAS) = FEFF Forward efficiencies
  !     or            TREC Receivers temperature (K)
  !    PAR(PH2O)    = H2OMM Water vapor amount (mm)
  !    PAR(PTLOSS)  = TLOSS (K)   (if fitted)
  !----------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit    !
  integer,            intent(out)   :: ier    ! Error code
  logical,            intent(in)    :: liter  ! Iterate a fit
  ! Local
  integer :: ifatal
  integer :: ninte,k,imeas
  real(8) :: sav,sav2,vplu,vminu,value
  !
  ! Init the values
  ier = 0
  fit%isw = 0
  fit%npfix = 0
  ninte = 0
  fit%npar = 0
  ifatal = 0
  fit%u = 0.0d0
  fit%lcode = 0
  fit%lcorsp = 0
  fit%isw(5) = 1
  !
  ! Set up Parameters
  fit%nu=plast
  !
  ! Trec / Forward Efficiencies
  do imeas=1,nmeas
    fit%u(imeas) = par(imeas)
    if (trec_mode) then
      fit%werr(imeas) = abs(0.2*par(imeas))
      fit%lcode(imeas) = 1
    else
      fit%werr(imeas) = 0.01
      fit%alim(imeas) = 0.30  ! Lower limit
      fit%blim(imeas) = 1.00  ! Upper limit
      fit%lcode(imeas) = 0    ! ZZZ Check this
    endif
  enddo
  !
  ! Water Vapor
  fit%u(ph2o) = par(ph2o)
  fit%werr(ph2o) = max(0.2,0.1*par(ph2o))
  fit%alim(ph2o) = 0.0   ! Lower limit (no water)
  fit%blim(ph2o) = 20.0  ! Upper limit
  !
  ! Tloss (if fitted)
  if (tloss_mode) then
    fit%u(ptloss) = par(ptloss)
    fit%werr(ptloss) = 0.1    ! ZZZ Check
    fit%alim(ptloss) = 0.0    ! Lower limit
    fit%blim(ptloss) = 500.0  ! Upper limit
  endif
  !
  ! Various checks
  do k=1,fit%nu
    if (k.gt.fit%maxext)  then
      ifatal = ifatal + 1
      cycle ! k
    endif
    ! Fixed parameter
    if (fit%werr(k) .le. 0.0d0)  then
      fit%lcode(k) = 0
      write(6,1010) k,' is fixed'
      cycle ! k
    endif
    ! Variable parameter
    ninte = ninte + 1
    if (fit%lcode(k).eq.1)  cycle ! k
    fit%lcode(k) = 4
    value = (fit%blim(k)-fit%u(k))*(fit%u(k)-fit%alim(k))
    if (value.lt.0.0d0) then
      ifatal = ifatal+1
      write (fit%isyswr,1011) k
    elseif (value.eq.0.0d0) then
      write(6,1010) k,' is at limit'
    endif
  enddo
  !
  ! End parameter cards
  ! Stop if fatal error
  if (ninte .gt. fit%maxint)  then
    write (fit%isyswr,1008)  ninte,fit%maxint
    ifatal = ifatal + 1
  endif
  if (ninte .eq. 0) then
    write (fit%isyswr,'(A)') ' All input parameters are fixed'
    ifatal = ifatal + 1
  endif
  if (ifatal .gt. 0)  then
    write (fit%isyswr,1013)  ifatal
    ier = 2
    return
  endif
  !
  ! O.K. Start
  ! Calculate step sizes DIRIN
  fit%npar = 0
  do k= 1, fit%nu
    if (fit%lcode(k) .gt. 0)  then
      fit%npar = fit%npar + 1
      fit%lcorsp(k) = fit%npar
      sav = fit%u(k)
      fit%x(fit%npar) = pintf(fit,sav,k)
      fit%xt(fit%npar) = fit%x(fit%npar)
      sav2 = sav + fit%werr(k)
      vplu = pintf(fit,sav2,k) - fit%x(fit%npar)
      sav2 = sav - fit%werr(k)
      vminu = pintf(fit,sav2,k) - fit%x(fit%npar)
      fit%dirin(fit%npar) = 0.5d0 * (dabs(vplu) +dabs(vminu))
    endif
  enddo
  return
  !
1008 format(' Too many variable parameters.  You request ',i5/,  &
            ' This version of MINUIT is only dimensioned for ',i4)
1010 format(' Warning - Parameter ',i2,' ',a)
1011 format(' Error - Parameter ',i2,' outside limits')
1013 format(1x,i3,' Errors on input parameters. ABORT.')
end subroutine midsky
!
subroutine minsky(npar,grad,chi2,params,iflag)
  use telcal_interfaces, except_this=>minsky
  use skydip_data
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! SKYDIP Internal routine
  !   Function to be minimized in the SKYDIP.
  !----------------------------------------------------------------------
  integer, intent(in)  :: npar          ! Number of parameters
  real(8), intent(out) :: grad(npar)    ! Array of derivatives
  real(8), intent(out) :: chi2          ! Chi**2
  real(8), intent(in)  :: params(npar)  ! Parameter values
  integer, intent(in)  :: iflag         ! Code operation
  ! Local
  real*8 :: airmas
  real*8 :: yy,dist
  real*8, allocatable :: dy(:),dy_sqsum(:)
  logical :: dograd
  integer :: ier,imeas,ipoint,ipar
  !
  chi2 = 0.0d0
  dograd = iflag.eq.2
  allocate(dy(npar),dy_sqsum(npar),stat=ier)
  if (ier.ne.0) then
    call gagout('E-MINSKY, Error allocating dy / dy_sqsum')
    return
  endif
  dy_sqsum = 0.d0
  !
  ! Compute function and derivative
  do imeas=1,nmeas
    do ipoint=1,skydip(imeas)%nsky
      !
      call fsky(imeas,skydip(imeas)%elev(ipoint),params,dograd,airmas,yy,dy)
      !
      ! Compute chi**2
      if (trec_mode) then
        dist = yy - sky(ipoint,imeas)
      else
        dist = yy - temi(ipoint,imeas)
      endif
      chi2 = chi2 + dist**2
      !
      if (.not.dograd) cycle  ! ipoint
      !
      ! Compute Gradients
      do ipar=1,npar
        dy_sqsum(ipar) = dy_sqsum(ipar) + 2.0*dist*dy(ipar)
      enddo
      !
    enddo  ! ipoint
    !
  enddo  ! imeas
  !
  ! Setup values and return
  do ipar=1,npar
    grad(ipar) = dy_sqsum(ipar)
  enddo
  !
  deallocate(dy,dy_sqsum)
  !
end subroutine minsky
!
subroutine fsky(inmeas,eleva,params,dograd,airmas,yy,dy)
  use phys_const
  use skydip_data
  !----------------------------------------------------------------------
  ! @ no-interface (because of argument rank mismatch)
  ! SKYDIP Internal routine
  !   Compute sky emission
  !  params(1:nmeas) : Trec
  !       or           Feff (depending on mode, one for each skydips set)
  !  params(ph2o)    : H2O [mm]
  !  params(ptloss)  : Tloss [K]  (if fitted)
  ! Computations are made with double precision floats because of very low
  ! angles (airmass) and sensible exponents (tsky) in this problem.
  !----------------------------------------------------------------------
  integer, intent(in)  :: inmeas     ! Skydip number in use
  real(8), intent(in)  :: eleva      ! Elevation in degrees
  real(8), intent(in)  :: params(*)  ! Values of parameters
  logical, intent(in)  :: dograd     ! Compute the gradient
  real(8), intent(out) :: airmas     ! Number of airmasses
  real(8), intent(out) :: yy         ! Emissivity (Kelvins)
  real(8), intent(out) :: dy(*)      ! Derivate value according to each parameter
  ! Local
  real(8) :: eps,gamma,hz
  real(8), parameter :: h0=5.5d0     ! Atmospheric scale height
  real(8), parameter :: r0=6370.0d0  ! Earth radius
  real(8) :: tsky,           dw_tsky
  real(8) :: tsky_s,e_tsky_s,dw_tsky_s,taus_tot
  real(8) :: tsky_i,e_tsky_i,dw_tsky_i,taui_tot
  real(8) :: zz,tloss
  integer :: imeas
  !
  ! Curved atmosphere, equivalent height 5.5 KM
  eps = asin(r0/(r0+h0)*cos(eleva))
  gamma = 0.5*pi-eleva-eps
  hz = r0*r0 + (r0+h0)**2 - 2.*r0*(r0+h0)*cos(gamma)
  hz = sqrt(max(hz,h0**2))     ! Avoid floating point errors
  airmas = hz/h0
  !
  ! Tsky (signal frequency component)
  taus_tot = params(ph2o) * atm(inmeas)%taus%wat + atm(inmeas)%taus%oth
  e_tsky_s = exp(-airmas * taus_tot)
  tsky_s = atm(inmeas)%temp%s * (1. - e_tsky_s)
  !
  ! Tsky (image frequency component)
  taui_tot = params(ph2o) * atm(inmeas)%taui%wat + atm(inmeas)%taui%oth
  e_tsky_i = exp(-airmas * taui_tot)
  tsky_i = atm(inmeas)%temp%i * (1. - e_tsky_i)
  !
  ! Tsky (total) from paragraph 3.5, Memo II
  tsky  = (tsky_s + tsky_i*rec(inmeas)%sbgr) / (1. + rec(inmeas)%sbgr)
  !
  if (trec_mode) then
    ! ZZZ to be checked in Trec mode
    zz = tamb-skydip(1)%hot(1)%temp + rec(inmeas)%feff*(tsky-tamb)
    yy = params(inmeas) * zz
  else
    if (tloss_mode) then
      tloss = params(ptloss)
    else
      ! Tloss = alpha*Tcab + (1-alpha)*Tamb
      tloss = tamb  ! Approx
    endif
    ! Temi = Feff*Tsky + (1-Feff)*Tloss
    yy = params(inmeas)*tsky + (1.-params(inmeas))*tloss
  endif
  !
  if (.not.dograd) return
  !
  dw_tsky_s = atm(inmeas)%temp%s * atm(inmeas)%taus%wat * e_tsky_s * airmas
  dw_tsky_i = atm(inmeas)%temp%i * atm(inmeas)%taui%wat * e_tsky_i * airmas
  dw_tsky = (dw_tsky_s + dw_tsky_i*rec(inmeas)%sbgr) / (1.+rec(inmeas)%sbgr)
  !
  ! Partial derivate on other params (Trec's/Feff's)
  do imeas=1,nmeas
    if (imeas.ne.inmeas) then
      dy(imeas) = 0.d0  ! No cross-dependency of the different Trec's/Feff's !
    elseif (trec_mode) then
      ! ZZZ to be checked in Trec mode
      dy(imeas) = zz
    else
      dy(imeas) = tsky - tamb
    endif
  enddo
  !
  ! Partial derivate on H2Omm
  if (trec_mode) then
    dy(ph2o) = params(inmeas)*rec(inmeas)%feff*dw_tsky
  else
    dy(ph2o) = params(inmeas)*dw_tsky
  endif
  !
  ! Partial derivate on Tloss (if fitted)
  if (tloss_mode) then
    ! dy/dtloss = 1-Feff
    dy(ptloss) = 1-params(inmeas)
  endif
  !
end subroutine fsky

subroutine write_sdm_polarization(error)
  !---------------------------------------------------------------------
  ! Write the polarization SDM table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_polarization
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (PolarizationRow) :: pRow
  type (PolarizationKey) :: pKey
  character sdmTable*12
  parameter (sdmTable='Polarization')
  integer :: ier, ic, jc, ia
  integer, parameter :: minalloc=2
  logical :: single(mrlband)
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !     simple version for current status of CLIC: one product only; for
  !     completeness we enter also an entry for the total powers, which
  !     will be also there when we have more correlation products...
  !
  !     Also we have at this time at Bure only one polarization
  !     description, in the future it will be per correlator unit
  !     (baseband).
  !
  !
  !     Now for Bure data the numCorr is either 1 or 2 (not yet 4).  some
  !     units are H, some are V. If two units are at linked to the same
  !     spectral window, one in H and the other in V, then they are a
  !     couple, with numCorr 2.
  !
  !     search for couples
  !c      numCorr is at most 2...
  do ic = 1, r_lband
    single(ic) = .true.
  enddo
  v_lband = 0
  do ic = 1, r_lband
    if (r_lpolentry(1,ic).le.0) then
      do ia=1, r_nant
        r_lpolentry(ia,ic) = 1
      enddo
    endif
    if (ic.lt.r_lband) then
      do jc = ic+1, r_lband
        if (spectralWindow_Id(1,ic,1).eq.spectralWindow_Id(1,jc,1   &
          )) then
          pRow%numCorr = 2
          call allocPolarizationRow(pRow, pRow%numCorr,  error)
          if (error) return
          pRow%corrType = (/StokesParameter_XX,   &
            StokesParameter_YY/)
          pRow%corrProduct(1,1) = PolarizationType_X
          pRow%corrProduct(2,1) = PolarizationType_X
          pRow%corrProduct(1,2) = PolarizationType_Y
          pRow%corrProduct(2,2) = PolarizationType_Y
          call addPolarizationRow(pKey, pRow, error)
          if (error) return
          polarization_Id(ic) = pKey%polarizationId
          polarization_Id(jc) = pKey%polarizationId
          single(ic) = .false.
          single(jc) = .false.
          v_lband = v_lband+1
          !print *, 'D v_lband, polarization_Id(v_lband), ic, jc ', &
          !     v_lband, polarization_Id(v_lband), ic, jc
          !     I know, this is wrong. It can be reversed depending on the status
          !     of the quarters...  for test data it does not matter.
          !            print *, ' r_lpolentry(1,ic) ', r_lpolentry(1,ic)
          !            print *, ' r_lpolentry(1,jc) ', r_lpolentry(1,jc)
          v_bands(v_lband, r_lpolentry(1,ic)) = ic
          v_bands(v_lband, r_lpolentry(1,jc)) = jc
          v_ncorr(v_lband) = 2
        endif
      enddo
    endif
    if (single(ic)) then
      pRow%numCorr = 1
      call allocPolarizationRow(pRow, pRow%numCorr,  error)
      if (error) return
      if (r_lpolentry(1,ic).eq.1) then
        pRow%corrType = StokesParameter_XX
        pRow%corrProduct(1,1) = PolarizationType_X
        pRow%corrProduct(2,1) = PolarizationType_X
      elseif (r_lpolentry(1,ic).eq.2) then
        pRow%corrType = StokesParameter_YY
        pRow%corrProduct(1,1) = PolarizationType_Y
        pRow%corrProduct(2,1) = PolarizationType_Y
      endif
      call addPolarizationRow(pKey, pRow, error)
      if (error) return
      v_lband = v_lband+1
      polarization_Id(v_lband) = pKey%polarizationId
      !            print *, 'S v_lband, polarization_Id(v_lband), ic:  '
       !           print *, v_lband, polarization_Id(v_lband), ic
      !     I know, this is wrong. It can be reversed depending on the status
      !     of the quarters...  for test data it does not matter.
      !            print *, ' r_lpolentry(1,ic) ', r_lpolentry(1,ic)
      !!v_bands(v_lband, r_lpolentry(1,ic)) = ic
      v_bands(v_lband, 1) = ic
      v_ncorr(v_lband) = 1
    endif
  enddo
  !$$$      print *, v_ncorr
  !
  ! now for the total powers
  num_CorrTotPow = r_npol_rec
  pRow%numCorr = num_CorrTotPow
  call allocPolarizationRow(pRow, num_CorrTotPow,  error)
  if (error) return
  ! (no need to reallocate)
  if (num_CorrTotPow.eq.2) then
    pRow%corrType = (/StokesParameter_XX,   &
      StokesParameter_YY/)
    pRow%corrProduct(1,1) = PolarizationType_X
    pRow%corrProduct(2,1) = PolarizationType_X
    pRow%corrProduct(1,2) = PolarizationType_Y
    pRow%corrProduct(2,2) = PolarizationType_Y
  else
    pRow%corrType = StokesParameter_XX
    pRow%corrProduct(1,1) = PolarizationType_X
    pRow%corrProduct(2,1) = PolarizationType_X
  endif
  !
  call addPolarizationRow(pKey, pRow, error)
  if (error) return
  totPowPolarization_Id = pKey%polarizationId
  !$$$      print *, 'totPowPolarization_Id ', totPowPolarization_Id
  call sdmMessage(1,1,sdmTable ,'Written.')
!
end subroutine write_sdm_polarization
!---------------------------------------------------------------------
subroutine get_sdm_polarization(error)
  !---------------------------------------------------------------------
  ! Write the polarization SDM table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_polarization
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (PolarizationRow) :: pRow
  type (PolarizationKey) :: pKey
  integer :: ier, ipp, ivc, ia, ic
  integer, parameter :: mcorrp = 4
  character sdmTable*12
  parameter (sdmTable='Polarization')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !     simple version for current status of CLIC: one product only; for
  !     completeness we enter also an entry for the total powers, which
  !     will be also there when we have more correlation products...
  !
  !     Also we have at this time at Bure only one polarization
  !     description, in the future it will be per correlator unit
  !     (baseband).
  !
  !     *TBD* may corrType is  1 for 1mm receiver (or the reverse)...
  !
  !     most of this information cannot be put in Bure data format at this
  !     time (2006-01-27)
  pRow%numCorr = mcorrp
  call allocPolarizationRow(pRow, error)
  if (error) return
  pKey%PolarizationId = polarization_Id(1)
  call getPolarizationRow(pKey, pRow, error)
  r_npol_rec = 1
  if (pRow%numCorr.gt.1) then
    !call sdmMessageI(6,2,sdmTable   &
    !  ,'Too many correlation products: ', pRow%numCorr)
    !error =.true.
    !return
    !call sdmMessage(6,2,sdmTable,'Only first product will be used')
    r_npol_rec = 2
  endif
  num_Corr = pRow%numCorr
  

  ! move this to get polarization. define the r_lvand here
  r_lband = num_Corr *  v_lband
  r_nband = r_lband
  r_lpolmode = 1 !!! num_corr
  ic = 1
  do ivc=1, v_lband
    v_ncorr(ivc) = num_Corr
    do ipp = 1, num_corr
      if (pRow%corrType(ipp) .eq. StokesParameter_XX) then
        do ia=1, r_nant
          r_lpolentry(ia,ic) = 1 
        enddo
        v_bands(ivc, 1) = ic
      elseif (pRow%corrType(ipp) .eq. StokesParameter_YY) then
        do ia=1, r_nant
          r_lpolentry(ia,ic) = 2 
        enddo
        v_bands(ivc, 2) = ic
      endif
      ic = ic + 1
    enddo
  enddo
  !
  ! for the total powers: use another routine if needed...
  call sdmMessage(1,1,sdmTable ,'Read.')
!
end subroutine get_sdm_polarization

subroutine fcheb  (xx,a,np1)
  !---------------------------------------------------------------------
  ! Fitting routine for a Chebychev polynomial of degree NP-1.
  ! Compute all coefficients of the polynomials, from the usual recurrence
  ! Beware of first point for "true" Chebychev polynomials
  !---------------------------------------------------------------------
  real*8 :: xx                      !
  integer :: np1                    !
  real*8 :: a(np1)                  !
  ! Local
  integer :: j
  real*8 :: z
  !
  a(1) = 1.d0
  a(2) = xx
  do j=3,np1
    z = a(j-1)*xx
    a(j)= z+z-a(j-2)
  enddo
  ! Note that this one is special
  a(1) = 0.5d0
end subroutine fcheb
!
subroutine svdput(f,np,a,nrows)
  !---------------------------------------------------------------------
  ! Move solution of least-square fit of Chebychev polynomial
  ! found by Singular Value Decomposition or Linear Fit into
  ! appropriate place for compatibility with NAG.
  !
  ! A bit crazy, but...
  !---------------------------------------------------------------------
  integer :: np                     !
  real*8 :: f(np)                   !
  integer :: nrows                  !
  real*8 :: a(nrows,np)             !
  ! Local
  integer :: j
  !
  ! Storage is incredible, but documented...
  do j=1,np
    a(np,j) = f(j)
  enddo
end subroutine svdput
!
subroutine svdfit(x,y,weight,ndata,a,ma,u,v,w,mp,np,chisq,   &
    funcs,b,afunc,error)
  !---------------------------------------------------------------------
  ! Singular value decomposition
  ! Given a set of NDATA points X(I), Y(I) with individual weights
  ! WEIGHT(I), use Chi2 minimization to determine the MA coefficients A of the
  ! fitting function. Here we solve the fitting
  ! equations using singular value decomposition of the NDATA by MA matrix.
  ! Arrays U,V,W provide workspace on input. On output they define the singular
  ! value decomposition and can be used to obtain the covariance matrix. MP, NP
  ! are the physical dimensions of the matrices U, V, W, as indicated below. It
  ! is necessary that MP>=NDATA, NP>=MA. The programs returns values for the MA
  ! fit parameters and Chi2, CHISQ. The user supplies a subroutine
  ! FUNCS(X,AFUNC,MA) that returns the MA basis functions evaluated at x=X in the
  ! array AFUNC.
  !
  ! As compared to the basic algorithm in "Numerical recipes",
  !     work arrays AFUNC and B are passed as argument. This suppress
  !     the need for size dependent storage.
  ! WEIGHT is the inverse of the sigma.
  !     Written by T.Forveille sometime ago
  !     Modifications by S.Guilloteau 28-feb-1995
  !---------------------------------------------------------------------
  integer :: ndata                  !
  real*8 :: x(ndata)                !
  real*8 :: y(ndata)                !
  real*8 :: weight(ndata)           !
  integer :: ma                     !
  real*8 :: a(ma)                   !
  integer :: mp                     !
  integer :: np                     !
  real*8 :: u(mp,np)                !
  real*8 :: v(np,np)                !
  real*8 :: w(np)                   !
  real*8 :: chisq                   !
  external :: funcs                 !
  real*8 :: b(ndata)                !
  real*8 :: afunc(ma)               !
  logical :: error                  !
  ! Local
  real*8 :: tol
  parameter (tol=1d-5)
  !
  integer :: i,j
  real*8 :: wmax,thresh,sum
  !
  error = .false.
  do i=1,ndata
    call funcs(x(i),afunc,ma)
    do j=1,ma
      u(i,j) = afunc(j)*weight(i)
    enddo
    b(i) = y(i)*weight(i)
  enddo
  call svdcmp(u,ndata,ma,mp,np,w,v,error)
  if (error) return
  ! Edit out the (nearly) singular values
  wmax = 0.
  do j=1,ma
    if (w(j).gt.wmax) wmax=w(j)
  enddo
  thresh = tol*wmax
  do j=1,ma
    if (w(j).lt.thresh) w(j) = 0
  enddo
  ! Solve the equations
  call svbksb(u,w,v,ndata,ma,mp,np,b,a,error)
  if (error) return
  ! Evaluate chi-square
  chisq = 0.d0
  do i=1,ndata
    call funcs(x(i),afunc,ma)
    sum=0.
    do j=1,ma
      sum = sum+a(j)*afunc(j)
    enddo
    chisq = chisq+((y(i)-sum)*weight(i))**2
  enddo
end subroutine svdfit
!
subroutine svdcmp(a,m,n,mp,np,w,v,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Singular value decomposition
  ! Given a matrix A with logical dimensions M by N and physical dimensions MP
  ! by NP, this routine computes its singular value decomposition
  !	A = U.W.Vt
  ! The matrix U replaces A on output. The diagonal matrix of singular values W
  ! is a output as a vector W. The matrix V (not the transpose Vt) is output as
  ! V. M must be greater or equal to N. If it is smaller, then A should be filled
  ! up to square with zero rows.
  ! Typed from "numerical recipes".  TF
  !---------------------------------------------------------------------
  integer :: mp                     !
  integer :: np                     !
  real*8 :: a(mp,np)                !
  integer :: m                      !
  integer :: n                      !
  real*8 :: w(np)                   !
  real*8 :: v(np,np)                !
  logical :: error                  !
  ! Local
  integer :: nmax
  parameter (nmax=100)         ! Maximum anticipated value of N
  real*8 :: rv1(nmax)
  integer :: i,j,k,l,nm,its,jj
  real*8 :: scale,anorm,c,s,x,y,z
  real*8 :: f,g,h
  !
  if (n.gt.nmax) then
    call gagout('E-SVDCMP,  NMAX dimension too small. '//   &
      'Will need to recompile.')
    error = .true.
    return
  elseif (m.lt.n) then
    call gagout('E-SVDCMP,  You must augment A with extra '//   &
      'zero rows.')
    error = .true.
    return
  endif
  ! Householder reduction to diagonal form
  g = 0.0
  scale = 0.0
  anorm = 0.0
  do i=1,n
    l=i+1
    rv1(i) = scale*g
    g = 0.0
    s = 0.0
    scale = 0.0
    if (i.le.m) then
      do k=i,m
        scale = scale+abs(a(k,i))
      enddo
      if (scale.ne.0.0) then
        do k=i,m
          a(k,i) = a(k,i)/scale
          s = s+a(k,i)*a(k,i)
        enddo
        f = a(i,i)
        g = -sign(sqrt(s),f)
        h = f*g-s
        a(i,i) = f-g
        if(i.ne.n) then
          do j=l,n
            s=0.0
            do k=i,m
              s = s+a(k,i)*a(k,j)
            enddo
            f = s/h
            do k=i,m
              a(k,j) = a(k,j)+f*a(k,i)
            enddo
          enddo
        endif
        do k=i,m
          a(k,i) = scale*a(k,i)
        enddo
      endif
    endif
    w(i) = scale*g
    g = 0.0
    s = 0.0
    scale = 0.0
    if ((i.le.m).and.(i.ne.n)) then
      do k=l,n
        scale = scale+abs(a(i,k))
      enddo
      if (scale.ne.0) then
        do k=l,n
          a(i,k)=a(i,k)/scale
          s=s+a(i,k)*a(i,k)
        enddo
        f=a(i,l)
        g=-sign(sqrt(s),f)
        h=f*g-s
        a(i,l)=f-g
        do k=l,n
          rv1(k)=a(i,k)/h
        enddo
        if (i.ne.m) then
          do j=l,m
            s=0.0
            do k=l,n
              s=s+a(j,k)*a(i,k)
            enddo
            do k=l,n
              a(j,k)=a(j,k)+s*rv1(k)
            enddo
          enddo
        endif
        do k=l,n
          a(i,k)=scale*a(i,k)
        enddo
      endif
    endif
    anorm = max(anorm,(abs(w(i))+abs(rv1(i))))
  enddo
  ! Accumulation of right hand transformation
  do i=n,1,-1
    if (i.lt.n) then
      if (g.ne.0.0) then
        do j=l,n               ! Double division avoids possible underflow
          v(j,i) = (a(i,j)/a(i,l))/g
        enddo
        do j=l,n
          s=0.0
          do k=l,n
            s=s+a(i,k)*v(k,j)
          enddo
          do k=l,n
            v(k,j)=v(k,j)+s*v(k,i)
          enddo
        enddo
      endif
      do j=l,n
        v(i,j) = 0.0
        v(j,i) = 0.0
      enddo
    endif
    v(i,i) = 1.0
    g = rv1(i)
    l = i
  enddo
  ! Accumulation of left hand transformations.
  do i=n,1,-1
    l = i+1
    g = w(i)
    if (i.lt.n) then
      do j=l,n
        a(i,j) = 0.0
      enddo
    endif
    if (g.ne.0.0) then
      g = 1.0/g
      if (i.ne.n) then
        do j=l,n
          s = 0.0
          do k=l,m
            s = s+a(k,i)*a(k,j)
          enddo
          f = (s/a(i,i))*g
          do k=i,m
            a(k,j)=a(k,j)+f*a(k,i)
          enddo
        enddo
      endif
      do j=i,m
        a(j,i) = a(j,i)*g
      enddo
    else
      do j=i,m
        a(j,i) = 0.0
      enddo
    endif
    a(i,i) = a(i,i)+1.0
  enddo
  ! Diagonalization of the bidiagonal form
  do k=n,1,-1                  ! Loop over singular values
    do its=1,30                ! Loop over allowed iterations
      do l=k,1,-1              ! Test for splitting:
        nm=l-1                 ! Note that RV1(1) is always zero
        if ((abs(rv1(l))+anorm).eq.anorm) goto 2
        if ((abs(w(nm))+anorm).eq.anorm) goto 1
      enddo
1     c=0.0        ! Cancellation of RV1(L), if L>1
      s=1.0
      do i=l,k
        f=s*rv1(i)
        if ((abs(f)+anorm).ne.anorm) then
          g = w(i)
          h = sqrt(f*f+g*g)
          w(i) = h
          h = 1.0/h
          c = (g*h)
          s = -f*h
          do j=1,m
            y = a(j,nm)
            z = a(j,i)
            a(j,nm)=(y*c)+(z*s)
            a(j,i)=-(y*s)+(z*c)
          enddo
        endif
      enddo
2     z=w(k)
      if (l.eq.k) then         ! Convergence
        if (z.lt.0.0) then     ! Singular value is made non negative
          w(k)=-z
          do j=1,n
            v(j,k)=-v(j,k)
          enddo
        endif
        goto 3
      endif
      if (its.eq.30) then
        call gagout('E-SVDCMP,  '//   &
          'No convergence in 30 iterations.')
        error = .true.
        return
      endif
      x=w(l)                   ! Shift from bottom 2-by-2 minor
      nm = k-1
      y = w(nm)
      g = rv1(nm)
      h = rv1(k)
      f = ((y-z)*(y+z)+(g-h)*(g+h))/(2.0*h*y)
      g = sqrt(f*f+1.0)
      f = ((x-z)*(x+z)+h*((y/(f+sign(g,f)))-h))/x
      ! Next QR transformation
      c=1.0
      s=1.0
      do j=l,nm
        i=j+1
        g=rv1(i)
        y=w(i)
        h=s*g
        g=c*g
        z=sqrt(f*f+h*h)
        rv1(j) = z
        c=f/z
        s=h/z
        f= (x*c)+(g*s)
        g=-(x*s)+(g*c)
        h=y*s
        y=y*c
        do jj=1,n
          x=v(jj,j)
          z=v(jj,i)
          v(jj,j)= (x*c)+(z*s)
          v(jj,i)=-(x*s)+(z*c)
        enddo
        z=sqrt(f*f+h*h)
        w(j) = z
        if (z.ne.0) then       ! Rotation can be arbitrary if Z=0
          z=1.0/z
          c=f*z
          s=h*z
        endif
        f= (c*g)+(s*y)
        x=-(s*g)+(c*y)
        do jj=1,m
          y=a(jj,j)
          z=a(jj,i)
          a(jj,j) = (y*c)+(z*s)
          a(jj,i) =-(y*s)+(z*c)
        enddo
      enddo
      rv1(l)=0.0
      rv1(k)=f
      w(k)=x
    enddo
3   continue
  enddo
  return
end subroutine svdcmp
!
subroutine svbksb(u,w,v,m,n,mp,np,b,x,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Singular value decomposition
  ! Solves A.X = B for a vector X, where A is specified by the arrays U,W,V as
  ! returned by SVDCMP. M and N are the logical dimensions of A, and will be
  ! equal for square matrices. MP and NP are the physical dimensions of A. B
  ! is the input right hand side. X is the output soolution vector. No input
  ! quantities are destroyed, so the routine may be called sequentially with
  ! different B's.
  ! Typed from "numerical recipes".  TF
  !---------------------------------------------------------------------
  integer :: mp                     !
  integer :: np                     !
  real*8 :: u(mp,np)                !
  real*8 :: w(np)                   !
  real*8 :: v(np,np)                !
  integer :: m                      !
  integer :: n                      !
  real*8 :: b(mp)                   !
  real*8 :: x(np)                   !
  logical :: error                  !
  ! Local
  integer :: nmax
  parameter (nmax=100)
  real*8 :: tmp(nmax),s
  integer :: i,j,jj
  !
  if (n.gt.nmax) then
    call gagout('E-SVDCMP,  NMAX dimension too small. '//   &
      'Will need to recompile.')
    error = .true.
    return
  endif
  ! Calculate UtB
  do j=1,n
    s = 0.
    if (w(j).ne.0.) then
      do i=1,m
        s=s+u(i,j)*b(i)
      enddo
      s = s/w(j)
    endif
    tmp(j) = s
  enddo
  ! Matrix multiply by V to get answer
  do j=1,n
    s = 0.0
    do jj=1,n
      s = s+v(j,jj)*tmp(jj)
    enddo
    x(j) = s
  enddo
end subroutine svbksb
!
subroutine fpoly(x,p,np)
  !---------------------------------------------------------------------
  ! Fitting routine for a polynomial of degree NP-1.
  !---------------------------------------------------------------------
  real*8 :: x                       !
  integer :: np                     !
  real*8 :: p(np)                   !
  ! Local
  integer :: j
  !
  p(1) = 1.d0
  do j=2,np
    p(j)=p(j-1)*x
  enddo
end subroutine fpoly
!
subroutine lfit(x,y,weight,ndata,a,ma,covar,ncvm,chisq,   &
    funcs,error)
  !---------------------------------------------------------------------
  ! Given a set of NDATA points X(I),Y(I) with individual weights WEIGHT(I),
  ! use Chi2 minimization to determine the MA coefficients A of a function
  ! that depends linearly on A.
  !
  ! WEIGHT is the inverse of the Sigmas.
  !---------------------------------------------------------------------
  integer :: ndata                  !
  real*8 :: x(ndata)                !
  real*8 :: y(ndata)                !
  real*8 :: weight(ndata)           !
  integer :: ma                     !
  real*8 :: a(ma)                   !
  integer :: ncvm                   !
  real*8 :: covar(ncvm,ncvm)        !
  real*8 :: chisq                   !
  external :: funcs                 !
  logical :: error                  !
  ! Local
  integer :: mmax
  parameter (mmax=50)
  real*8 :: beta(mmax),afunc(mmax),sig2i,sum,ym,wt
  integer :: i,j,k
  !
  if (ma.gt.mmax) then
    call message(8,4,'LFIT','Incoherent array dimensions')
    error = .true.
    return
  endif
  !
  do j=1,ma
    do k=1,ma
      covar(j,k)=0.d0
    enddo
    beta(j)=0.d0
  enddo
  do i=1,ndata
    call funcs(x(i),afunc,ma)
    ym=y(i)
    sig2i=weight(i)**2
    do j=1,ma
      wt=afunc(j)*sig2i
      do k=1,j
        covar(j,k)=covar(j,k)+wt*afunc(k)
      enddo
      beta(j)=beta(j)+ym*wt
    enddo
  enddo
  if (ma.gt.1) then
    do j=2,ma
      do k=1,j-1
        covar(k,j)=covar(j,k)
      enddo
    enddo
  endif
  call gaussj(covar,ma,ncvm,beta,1,1)
  do j=1,ma
    a(j)=beta(j)
  enddo
  chisq=0.d0
  do i=1,ndata
    call funcs(x(i),afunc,ma)
    sum=0.d0
    do j=1,ma
      sum=sum+a(j)*afunc(j)
    enddo
    chisq=chisq+((y(i)-sum)*weight(i))**2
  enddo
end subroutine lfit
!
subroutine gaussj(a,n,np,b,m,mp)
  use gkernel_interfaces
  integer :: np                     !
  real*8 :: a(np,np)                !
  integer :: n                      !
  integer :: mp                     !
  real*8 :: b(np,mp)                !
  integer :: m                      !
  ! Local
  integer :: nmax
  !
  real*8 :: big,dum,pivinv
  parameter (nmax=50)
  integer :: ipiv(nmax),indxr(nmax),indxc(nmax)
  integer :: i,j,k,l,ll,irow,icol
  !
  do j=1,n
    ipiv(j)=0
  enddo
  !
  do i=1,n
    big=0.d0
    do j=1,n
      if (ipiv(j).ne.1) then
        do k=1,n
          if (ipiv(k).eq.0) then
            if (abs(a(j,k)).ge.big) then
              big=abs(a(j,k))
              irow=j
              icol=k
            endif
          elseif (ipiv(k).gt.1) then
            call gagout('F-GAUSSJ,  Singular matrix')
            return
          endif
        enddo
      endif
    enddo
    ipiv(icol)=ipiv(icol)+1
    if (irow.ne.icol) then
      do l=1,n
        dum=a(irow,l)
        a(irow,l)=a(icol,l)
        a(icol,l)=dum
      enddo
      do l=1,m
        dum=b(irow,l)
        b(irow,l)=b(icol,l)
        b(icol,l)=dum
      enddo
    endif
    indxr(i)=irow
    indxc(i)=icol
    if (a(icol,icol).eq.0.d0) then
      call gagout('F-GAUSSJ,  Singular matrix')
      return
    endif
    pivinv=1.d0/a(icol,icol)
    a(icol,icol)=1.d0
    do l=1,n
      a(icol,l)=a(icol,l)*pivinv
    enddo
    do l=1,m
      b(icol,l)=b(icol,l)*pivinv
    enddo
    do ll=1,n
      if (ll.ne.icol) then
        dum=a(ll,icol)
        a(ll,icol)=0.d0
        do l=1,n
          a(ll,l)=a(ll,l)-a(icol,l)*dum
        enddo
        do l=1,m
          b(ll,l)=b(ll,l)-b(icol,l)*dum
        enddo
      endif
    enddo
  enddo
  !
  do l=n,1,-1
    if (indxr(l).ne.indxc(l)) then
      do k=1,n
        dum=a(k,indxr(l))
        a(k,indxr(l))=a(k,indxc(l))
        a(k,indxc(l))=dum
      enddo
    endif
  enddo
end subroutine gaussj
!
subroutine mindeg(a,n)
  integer :: n                      !
  real*8 :: a(n)                    !
  ! Local
  integer :: i,imin
  character(len=32) :: chain
  !
  ! Crude criterium, shout on first minimum
  imin = n
  do i=n-1,1,-1
    if (a(i).le.a(imin)) imin = i
  enddo
  if (imin.lt.n) then
    write(chain,'(A,I2,A)') 'Degree ',imin-1,   &
      ' would be even better'
    call message(6,2,'POLYNO',chain)
    print *,(a(i),i=1,n)
  endif
end subroutine mindeg
!
subroutine svdvar(v,ma,np,w,cvm,ncvm,wti,sigma)
  !---------------------------------------------------------------------
  ! Compute covariance matrix
  ! Note NP > MA
  !---------------------------------------------------------------------
  integer :: np                     ! Dimension of V matrix
  real*8 :: v(np,np)                !
  integer :: ma                     ! Number of variables
  real*8 :: w(np)                   !
  integer :: ncvm                   ! Dimension of covariance matrix
  real*8 :: cvm(ncvm,ncvm)          !
  real*8 :: wti(ma)                 !
  real*8 :: sigma                   !
  ! Local
  real*8 :: sum
  integer :: i,j,k
  !
  do i=1,ma
    wti(i)=0.
    if (w(i).ne.0.d0) wti(i)=(sigma/w(i))**2
  enddo
  do i=1,ma
    do j=1,i
      sum=0.d0
      do k=1,ma
        sum=sum+v(i,k)*v(j,k)*wti(k)
      enddo
      cvm(i,j)=sum
      cvm(j,i)=sum
    enddo
  enddo
end subroutine svdvar

subroutine astro_line(line,error)
  use gbl_message
  use gkernel_interfaces
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! ASTRO 	Internal routine
  !	support for command
  !	LINE name Freq SB [Lock [Center [Harm]]]
  !	/MOLECULES FileName [Mol1 Mol2 ... Moln]        (1)
  !	/SPECTRAL Bandwidth LO3 Center [LO3 Center]     (2)
  !       /WIDTH  line_width                              (3)
  !       /IF_LIMITS ifmin ifmax                          (4)
  !       /BEST best                                      (5)
  !       /AUTO                                           (6)
  !       /VLBI                                           (7)
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !
  logical, intent(inout) :: error          !
  ! Local
  character(len=12) :: name,par
  character(len=256) :: msg,chain,molfile
  integer(kind=4) :: lname, nlu, npar, lpar, kmol
  character(len=4) :: band, lock
  real(kind=8) :: fcent, eps, fsky, best, f1, lo1, lo2, vsys
  integer(kind=4) :: harm, mult, lck, nc, irec, k, pdbi, ier
  parameter (eps=(100.25d0))   ! MHz
  logical :: vlbi
  character(len=9) :: rname
  character(len=message_length) :: mess
  ! Data
  data rname /'PDBI_LINE'/
  !! REAL*8 FLO1(2), FLO2(2)
  ! Code -----------------------------------------------------------------------
  !
  ! Find IF limits to be used depending on receiver used
  ! PDBI is a flag = -1 if ALMA, SMA
  !                = 1  if <2006 system
  !                = 2  if NGRx  --- CODE IS THERE BUT NOT USED
  !
  iflim(1) = 100               ! Default IF2
  if (obs_year.eq.1995) then
    iflim(2) = 600             ! Default IF2
  elseif (obs_year.eq.2000) then
    iflim(2) = 680             ! Default IF2
  endif
  pdbi = 1                     ! Default
  if (obsname.eq.'ALMA') then
    !
    ! ALMA -- VERY OLD CODE !!
    !
    iflim(1) = 4000            ! IF1
    iflim(2) = 8000            ! IF1
    pdbi =-1
  endif
  !
  userlim = iflim
  if (sic_present(4,0)) then
    call sic_r4(line,4,1,userlim(1),.false.,error)
    call sic_r4(line,4,2,userlim(2),.false.,error)
    if (error) return
    if (userlim(1).ge.userlim(2)) then
      call astro_message(seve%e,rname,'Wrong IF limits')
      error = .true.
      return
    endif
    if (userlim(1).lt.iflim(1)) then
      userlim(1) = iflim(1)
    endif
    if (userlim(2).gt.iflim(2)) then
      userlim(2) = iflim(2)
    endif
  endif
  !
  ! /SPECTRAL
  !
  if (sic_present(2,0) .and. .not.sic_present(0,1)) then
    call plot_correlator(line, iflim, userlim, error)
    return
  endif
  !
  ! /MOLECULE filename [molecules]
  !
  if (sic_present(1,1)) then
    call sic_ch (line,1,1,msg,nc,.false.,error)
    if (error) return
    molfile = msg
    call sic_parsef (msg,molfile,' ','.DAT')
  else
    msg = ''
    ier = sic_getlog('GAG_MOLECULES',msg)
    call sic_parsef (msg,molfile,' ','.DAT')
  endif
  kmol = sic_narg(1)
  call read_lines(line,kmol,molfile)
  !
  ! /WIDTH linewidth
  !
  width = 0
  call sic_r4(line,3,1,width,.false.,error)
  if (error) return
  width = abs(width)
  !
  ! PdBI specific options
  !
  if (pdbi.eq.1) then
    !
    ! /VLBI
    !
    vlbi = sic_present(7,0)
    !
    ! /BEST 1860. or 1875.
    !
    best = 0
    call sic_r8(line,5,1,best,.false.,error)
    if (error) return
  endif
  !
  ! Decode line parameters
  ! LINE linename freq lsb|usb [low|high] [if] [harm]
  !
  ! Line name
  !
  lname = 12
  call sic_ch (line,0,1,name,lname,.true.,error)
  if (error) return
  !
  ! Prepare for reading the next parameters
  !
  if (sic_present(0,2)) then
    if (.not.sic_present (0,3)) then
      call astro_message(seve%e,rname,'Missing Sidebands')
      error = .true.
      return
    endif
    msg = line(11:)            ! Skip language and commands
    if (index(msg,'/').ne.0) then
      msg = msg(1:index(msg,'/')-1)
    endif
    nlu = lenc(msg)
    call sic_blanc(msg,nlu)
    npar = 1
    lpar = 12
    call sic_next(msg(1:),par,lpar,npar)   ! Skip line name
  endif
  !
  ! Decode frequency
  !
  if (fshift.eq.0.0d0) fshift = 1.0d0
  lpar = 12
  call sic_next(msg(npar:),par,lpar,npar)
  if (lpar.eq.0) then
    call astro_message(seve%e,rname,'Missing rest frequency')
    goto 99
  endif
  call sic_math_dble(par,lpar,freq,error)
  if (error) goto 930
  fsky = freq*1d3*fshift       ! In MHz
  !
  ! Decode sideband
  !
  lpar = 1
  call sic_next (msg(npar:),par,lpar,npar)
  if (lpar.eq.0) then
    call astro_message(seve%e,rname,'Missing sideband')
    goto 99
  endif
  call sic_upper(par(1:lpar))
  if (par(1:1).eq. 'L') then
    band = 'LSB '
    sky = -1
  elseif (par(1:1).eq. 'U') then
    band = 'USB '
    sky = +1
  else
    goto 930
  endif
  !
  ! Decode further parameters (only for Bure)
  !
  if (pdbi.gt.0) then
    !
    ! Default values for harmonic, lock, and central IF
    !
    harm = 0
    lock = 'LOW'
    lck = -1
    if (obs_year.eq.1995) then
      fcent = 350.d0
    elseif (obs_year.eq.2000) then
      fcent = 390.d0
    endif
    !
    ! Decode lock
    !
    lpar = 4
    call sic_next (msg(npar:),par,lpar,npar)
    if (lpar.eq.0) goto 300
    call sic_upper(par(1:lpar))
    if (par(1:1).eq.'L') then
      lock = 'LOW '
      lck = -1
    elseif (par(1:1).eq.'H') then
      lock = 'HIGH'
      lck = +1
    else
      goto 930
    endif
    !
    ! Decode center IF. Force it to 390 if *
    !
    lpar = 12
    call sic_next (msg(npar:),par,lpar,npar)
    if (lpar.eq.0) goto 300
    if (par(1:1).eq.'*') then
      call astro_message(seve%i,rname,'Using default center freq.')
    else
      call sic_math_dble(par,lpar,fcent,error)
      if (error) goto 930
      if (fcent.lt.110.d0 .or. fcent.gt.590.d0) then
        call astro_message(seve%e,rname,'Invalid center frequency')
        goto 930
      endif
    endif
    !
    ! Decode harmonic number
    !
    lpar = 12
    call sic_next (msg(npar:),par,lpar,npar)
    if (lpar.eq.0) goto 300
    if (par(1:1).eq.'*') then
      harm = 0
    else
      read (par(1:lpar),*,err=930) harm
      if (harm.lt.32 .or. harm.gt.70) then
        call astro_message(seve%e,rname,'Invalid harmonic number')
        goto 930
      endif
    endif
  endif
  !
  300  continue
  !
  ! Now compute and check LO frequencies
  !
  ! (1) PdBI Rx1 and Rx2 (<2006)
  !
  if (pdbi.eq.1) then
    !
    if (fsky.gt.80e3 .and. fsky.lt.120e3) then
      mult = +1
      irec = 1
      if (best.eq.0) best = 1860
    elseif (fsky.gt.200e3 .and. fsky.lt.260e3) then
      mult = 3                 ! Tripler
      irec = 2
      if (best.eq.0) best = 1875
    else
      call astro_message(seve%e,rname,'Frequency not accessible with PdBI '//  &
      'receivers')
      goto 99
    endif
    !
    ! Define harmonic number
    !
    if (harm.eq.0) then
      f1 = ( (fsky + lck*eps*mult + sky*fcent) / best - sky) / dble(mult)
      harm = nint(f1)
    endif
    !
    ! Check FLO2
    !
    lo2 = (fsky + sky*fcent + lck*mult*eps) / (mult*harm+sky)
    if (lo2.lt.1835 .or. lo2.gt.1910) then
      write(chain,'(A,1PG10.3)') 'Invalid LO2 frequency',lo2
      call astro_message(seve%e,rname,chain)
      goto 99
    elseif  (lo2.lt.1845 .or. lo2.gt.1880) then
      write(chain,'(A,1PG10.3,A)') 'LO2 frequency ',lo2,' near limits'
      call astro_message(seve%w,rname,chain)
    endif
    !
    ! Check VLBI case (FLO2 must be a multiple of 0.125)
    !
    if (vlbi) then
      lo2 = (fsky + sky*fcent + lck*mult*eps) / (mult*harm+sky)
      k = nint(lo2/0.125d0)
      if (lo2.ne.k*0.125d0) then
        lo2 = k*0.125d0
        fcent = (lo2*(mult*harm+sky) - fsky - lck*mult*eps)/sky
        write(chain,'(A,1PG12.5,A)') 'Center frequency shifted to ', fcent,  &
        ' for VLBI requirements'
        call astro_message(seve%w,rname,chain)
      endif
    endif
    !
    ! Compute FLO1 and FLO2
    !
    lo2 = (fsky + sky*fcent + lck*mult*eps) / (mult*harm+sky)
    lo1 = mult*(harm*lo2 - lck*eps)
    !! FLO2(IREC) = LO2 ! SIC variable
    !! FLO1(IREC) = LO1 ! SIC variable
    vsys = (1.d0-fshift)*299792.458
    write(mess,'(A,I2)') ' Setup valid for receiver ', irec
    call astro_message(seve%r,rname,mess)
    if (vsys.ne.0) then
      write(mess,*) 'Source velocity = ', vsys,' km/s'
      call astro_message(seve%r,rname,mess)
    endif
    write(mess,*) 'FSKY  = ',fsky/1d3,' GHz'
    call astro_message(seve%r,rname,mess)
    write(mess,*) 'FLO1  = ',lo1,' MHz'
    call astro_message(seve%r,rname,mess)
    write(mess,*) 'FLO2  = ',lo2,' MHz'
    call astro_message(seve%r,rname,mess)
    write(mess,*) 'FSYN  = ',lo2+0.5d0,' MHz'
    call astro_message(seve%r,rname,mess)
    if ((abs(mod(lo1+sky*lo2+0.5d0,1d0)-0.5d0).gt. 0.0000001).or.  &
        nint(8*lo2).ne.8*lo2) then
      write(mess,*) '** Setup invalid for VLBI **'
      call astro_message(seve%r,rname,mess)
    endif
    !
    ! Plot label
    !
    write(label,1030) name(1:lenc(name)), fsky*1d-3/fshift, band, lock,  &
    fcent, harm, '  /RECEIVER',irec,'   [V= ',vsys,' km/s]'
    ! &  'Image ' (FLO1(IREC)-SKY*(FLO2(IREC)-350.))*1D-3/FSHIFT
    call astro_message(seve%r,rname,label)
    !
    ! (2) PdBI NGRx  -- CODE NOT USED, REPLACED BY pdbi_line.f
    !
  elseif (pdbi.eq.2) then
    !
    if (fsky.lt.120e3) then
      irec = 1
    elseif (fsky.lt.200e3) then
      irec = 2
    elseif (fsky.lt.260e3) then
      irec = 3
    else
      irec = 4
    endif
    !
    ! Compute FLO1 and FLO2
    !
    lo2 = 8000
    if (sky.eq.1) then
      lo1 = fsky-6000
    else
      lo1 = fsky+6000
    endif
    !
    vsys = (1.d0-fshift)*299792.458
    write(mess,*) '** Support of NGRX still preliminary **'
    call astro_message(seve%r,rname,mess)
    if (vsys.ne.0) then
      write(mess,*) 'Source velocity = ', vsys,' km/s'
      call astro_message(seve%r,rname,mess)
    endif
    write(mess,*) 'FSKY  = ',fsky/1d3,' GHz'
    call astro_message(seve%r,rname,mess)
    write(mess,*) 'FLO1  = ',lo1,' MHz'
    call astro_message(seve%r,rname,mess)
    write(mess,*) 'FLO2  = ',lo2,' MHz'
    call astro_message(seve%r,rname,mess)
    lo2 = 0                    ! to have plot in IF1
    !
    ! Plot label
    !
    write(label,1040) name(1:lenc(name)), fsky*1d-3/fshift, band,   &
    '   *** PdBI NGRX *** '
    call astro_message(seve%r,rname,label)
    !
    ! (3) ALMA
    !
  else
    !
    ! Compute FLO1 and FLO2
    !
    lo2 = 8000
    if (sky.eq.1) then
      lo1 = fsky-6000
    else
      lo1 = fsky+6000
    endif
    !
    vsys = (1.d0-fshift)*299792.458
    write(mess,*) '** Support of ALMA still preliminary **'
    call astro_message(seve%r,rname,mess)
    if (vsys.ne.0) then
      write(mess,*) 'Source velocity = ', vsys,' km/s'
      call astro_message(seve%r,rname,mess)
    endif
    write(mess,*) 'FSKY  = ',fsky/1d3,' GHz'
    call astro_message(seve%r,rname,mess)
    write(mess,*) 'FLO1  = ',lo1,' MHz'
    call astro_message(seve%r,rname,mess)
    write(mess,*) 'FLO2  = ',lo2,' MHz'
    call astro_message(seve%r,rname,mess)
    lo2 = 0                    ! to have plot in IF1
    !
    ! Plot label
    !
    write(label,1040) name(1:lenc(name)), fsky*1d-3/fshift, band,   &
    '   *** ALMA *** '
    call astro_message(seve%r,rname,label)
  endif
  !
  ! Do the plot
  !
  call plot_line(iflim, userlim, lo1, lo2, pdbi, fshift, sky, label, nmol,  &
  molname, molfreq, width)
  call plot_correlator(line, iflim, userlim, error)
  !
  return
  !
  ! Errors
  !
  930   call astro_message(seve%e,rname,'Error decoding '//par(1:lpar))
  99    error = .true.
  !
  1030  format('LINE ',a,1x,f11.6,1x,a,1x,a,1x,f6.2,1x,i3,a,i2,a,f6.1,a)
  1040  format('LINE ',a,1x,f11.6,1x,a,1x,a,1x,a)
end subroutine astro_line
!
subroutine plot_line(iflim, userlim, flo1, flo2, pdbi, fshift, sky, label,  &
  nmol, name, freq, width)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=4) :: iflim(2)          !
  real(kind=4) :: userlim(2)        !
  real(kind=8) :: flo1              !
  real(kind=8) :: flo2              !
  logical :: pdbi                   !
  real(kind=8) :: fshift            !
  integer(kind=4) :: sky            !
  character(len=130) :: label       !
  integer(kind=4) :: nmol           !
  character(len=20) :: name(nmol)   !
  real(kind=8) :: freq(nmol)        !
  real(kind=4) :: width             !
  ! Global
  integer(kind=4) :: lenc
  logical :: gr_error
  ! Local
  real(kind=4) :: bandwidth, fw, center
  integer(kind=4) :: i
  real(kind=8) :: f1, f2
  character(len=3) :: tmp
  character(len=132) :: chain, limi
  character(len=20) :: aname
  real(kind=4) :: afreq
  logical :: error
  !------------------------------------------------------------------------
  ! Code:
  !
  call gr_exec('CLEAR DIRECTORY')
  !
  ! IF bandwidth
  !
  bandwidth = abs(userlim(2)-userlim(1))/1000.
  center = userlim(1)+(userlim(2)-userlim(1))/2.
  write(limi,1040) userlim(1), userlim(2)
  !
  ! IF1 or IF2?
  !
  if (flo2.eq.0) then
    tmp = 'IF1'
  else
    tmp = 'IF2'
  endif
  !
  ! USB plot ----------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('SET BOX 3 29 13 18')
  if (gr_error()) return
  !
  ! IF axis
  !
  call gr_exec1(limi)
  call gr_exec1('AXIS XL')
  chain = 'DRAW TEXT 0 -1 "Intermediate frequency '//tmp//' (MHz)" /BOX 2'
  call gr_exec1(chain)
  !
  ! Y axis (dash on user limits, then continuous on hard limits)
  !
  call gr_exec1('PEN /DASH 3')
  write (chain,1050) userlim(1)
  call gr_exec1(chain)
  write (chain,1060) userlim(1)
  call gr_exec1(chain)
  write (chain,1050) userlim(2)
  call gr_exec1(chain)
  write (chain,1060) userlim(2)
  call gr_exec1(chain)
  call gr_exec1('PEN /DASH 1')
  write (chain,1050) iflim(1)
  call gr_exec1(chain)
  write (chain,1060) iflim(1)
  call gr_exec1(chain)
  write (chain,1050) iflim(2)
  call gr_exec1(chain)
  write (chain,1060) iflim(2)
  call gr_exec1(chain)
  !
  ! RF axis
  !
  if (flo2.eq.0) then
    !
    ! Plot in IF1
    !
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
  else
    !
    ! Plot in IF2
    !
    f1 = (flo1+flo2-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
  endif
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec('PEN /DASH 1')
  if (sky.eq.1) then
    call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz)        - Signal" /BOX 8')
  else
    call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz)        - Image" /BOX 8')
  endif
  call gr_exec1('PEN /WEIGHT 3')
  call gr_exec1('DRAW TEXT 0 1 "                        USB         " /BOX 8')
  call gr_exec1('PEN /WEIGHT 1')
  !
  ! Lines
  !
  if (nmol.ge.1) then
    fw=min(f1,f2)              ! If plot in IF1, F1<F2
    f1=max(f1,f2)              ! If plot in IF2, F1>F2
    f2=fw                      ! Need here IF2 convention
    call gr_exec1 ('SET ORIEN 50')
    aname = ' '
    afreq = 0.0
    do i=1, nmol
      if (freq(i).le.f1 .and. freq(i).ge.f2) then
        if (name(i).ne.aname .or. abs(afreq-freq(i)).gt.40e-3) then
          write(chain,1000) 'DRAW TEXT ',freq(i),' 4. "'//  &
          name(i)(1:lenc(name(i)))//'" 5 /USER'
          aname = name(i)
          afreq = freq(i)
          call gr_exec1(chain(1:lenc(chain)))
        endif
        call gr_segm('LINE',error)
        if (width.eq.0) then
          call relocate (freq(i),3.d0)
          call draw (freq(i),2.0d0)
        else
          fw = width*freq(i)/299792.458
          call relocate (freq(i)-fw/2.,2.d0)
          call draw(freq(i),3.d0)
          call draw(freq(i)+fw/2.,2.d0)
        endif
        call gr_segm_close(error)
      endif
    enddo
  endif
  !
  ! LSB plot ----------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('SET BOX 3 29 3 8')
  if (gr_error()) return
  !
  ! IF axis
  !
  call gr_exec1(limi)
  ! IF (ERROR) RETURN
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  chain = 'DRAW TEXT 0 1 "Intermediate frequency '//tmp//' (MHz)" /BOX 8'
  call gr_exec1(chain)
  !
  ! Y axis (dash on user limits, then continuous on hard limits)
  !
  call gr_exec1('PEN /DASH 3')
  write (chain,1050) userlim(1)
  call gr_exec1(chain)
  write (chain,1060) userlim(1)
  call gr_exec1(chain)
  write (chain,1050) userlim(2)
  call gr_exec1(chain)
  write (chain,1060) userlim(2)
  call gr_exec1(chain)
  call gr_exec1('PEN /DASH 1')
  write (chain,1050) iflim(1)
  call gr_exec1(chain)
  write (chain,1060) iflim(1)
  call gr_exec1(chain)
  write (chain,1050) iflim(2)
  call gr_exec1(chain)
  write (chain,1060) iflim(2)
  call gr_exec1(chain)
  !
  ! RF axis
  !
  if (flo2.eq.0) then
    !
    ! Plot in IF1
    !
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    tmp = 'IF1'
  else
    !
    ! Plot in IF2
    !
    f1 = (flo1-flo2+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    tmp = 'IF2'
  endif
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  if (sky.eq.-1) then
    call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)        - Signal" /BOX 2')
  else
    call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)        - Image" /BOX 2')
  endif
  call gr_exec1('PEN /WEIGHT 3')
  call gr_exec1('DRAW TEXT 0 -1 "                        LSB        " /BOX 2')
  call gr_exec1('PEN /WEIGHT 1')
  !
  ! Lines
  !
  if (nmol.ge.1) then
    fw=min(f1,f2)              ! If plot in IF1, F2>F2
    f2=max(f1,f2)              ! If plot in IF2, F1<F2
    f1=fw                      ! Need here IF2 convention
    call gr_exec1 ('SET ORIEN 50')
    aname = ' '
    afreq = 0.0
    do i=1, nmol
      if (freq(i).le.f2 .and. freq(i).ge.f1) then
        if (name(i).ne.aname .or. abs(afreq-freq(i)).gt.40e-3) then
          write(chain,1000) 'DRAW TEXT ',freq(i),' 4. "'//  &
          name(i)(1:lenc(name(i)))//'" 5 /USER'
          aname = name(i)
          afreq = freq(i)
          call gr_exec1(chain(1:lenc(chain)))
        endif
        call gr_segm('LINE',error)
        if (width.eq.0) then
          call relocate (freq(i),3.d0)
          call draw (freq(i),2.0d0)
        else
          fw = width*freq(i)/299792.458
          call relocate (freq(i)-fw/2.,2.d0)
          call draw(freq(i),3.d0)
          call draw(freq(i)+fw/2.,2.d0)
        endif
        call gr_segm_close(error)
      endif
    enddo
  endif
  !
  ! Label ----------------------------------
  !
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1('DRAW TEXT 0 3.1 "'//label(1:lenc(label)) //'" 5 /BOX 8')
  !
  1000 format(a,g14.7,a)
  1030 format(a,1x,f11.6,1x,a,1x,a,1x,f6.2,1x,i4,a,f6.2,a,f11.6)
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1050 format('DRAW RELOCATE ',f10.2,' 0 /USER')
  1060 format('DRAW LINE ',f10.2,' 5 /USER')
end subroutine plot_line
!
subroutine plot_correlator(line, iflim, userlim, error)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: line           !
  real(kind=4) :: iflim(2)          !
  real(kind=4) :: userlim(2)        !
  logical :: error                  !
  ! Global
  integer(kind=4) :: lenc
  logical :: gr_error
  ! Local
  character(len=256) :: berk, limi
  integer(kind=4) :: n
  !
  ! Initialization label
  !
  berk = ''
  !
  ! IF limits
  !
  write(limi,1040) userlim(1), userlim(2)
  call gr_exec1(limi)
  !
  ! USB plot
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('SET BOX 3 29 13 18')
  if (gr_error()) return
  call berkeley (line, iflim, berk, error)
  !
  ! LSB plot
  !
  call gr_exec1('SET BOX 3 29 3 8')
  if (gr_error()) return
  call berkeley (line, iflim, berk, error)
  !
  ! Label
  !
  n = lenc(berk)
  if (n.gt.0) then
    call gr_exec1('SET EXPAND 0.80')
    call gr_exec1('DRAW TEXT -1.5 2.2 "'//berk(1:n) //'" 6 /BOX 7')
    call gr_exec1('SET EXPAND 1.0')
  endif
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
end subroutine plot_correlator
!
subroutine old_berkeley (line,error,berk)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  character(len=*):: berk           !
  ! Global
  integer(kind=4) :: lenc,sic_narg
  ! Local
  integer(kind=4) :: nband,iband,i,j,icent,nline,llo3(2),nc
  character(len=12) :: comm
  character(len=1) :: cband
  character(len=4) :: lband(2)
  real(kind=4) :: x(7),y(7)
  character(len=13) :: rname
  ! Data
  data y/0.0,2.0,2.0,0.0,2.0,2.0,0.0/
  data rname /'LINE/SPECTRAL'/
  !
  nline = lenc(line)
  call sic_analyse (comm,line,nline,error)
  if (error) return
  nband = sic_narg(2)
  if (nband.ge.0) then
    if (nband.eq.5) then
      nband = 2
    elseif (nband.eq.3) then
      nband = 1
    else
      call astro_message(seve%e,rname,'Invalid syntax, see HELP')
      error = .true.
      return
    endif
    call sic_i4 (line,2,1,iband,.true.,error)
    if (iband.ne.10 .and. iband.ne.20 .and. iband.ne.40 .and. iband.ne.80  &
        .and. iband.ne.5) then
      call astro_message(seve%e,rname,'Invalid bandwidth ')
      error = .true.
      return
    endif
    !
    do j=1,nband
      call sic_i4 (line,2,2*j,icent,.true.,error)
      if (icent.ne.150 .and. icent.ne.250 .and. icent .ne. 350 .and.  &
          icent.ne.450 .and. icent.ne.550) then
        call astro_message(seve%e,rname,'Invalid LO3 ')
        error = .true.
        return
      endif
      call sic_ke (line,2,2*j+1,cband,nc,.true.,error)
      if (error) return
      if (iband.ne.80) then
        if (cband.eq.'U') then
          x(1) = icent+iband+0.5
          x(2) = icent+iband-0.5
          x(3) = icent+0.5
          x(4) = icent
          call gr4_connect(4,x,y,0.0,-1.0)
          lband(j) = 'USB'
        elseif (cband.eq.'L') then
          x(1) = icent-iband-0.5
          x(2) = icent-iband+0.5
          x(3) = icent-0.5
          x(4) = icent
          call gr4_connect(4,x,y,0.0,-1.0)
          lband(j) = 'LSB'
        else
          call astro_message(seve%e,rname,'Invalid sideband '//cband)
          error = .true.
          return
        endif
      elseif (cband.eq.'D') then
        x(1) = icent-40.5
        x(2) = icent-39.5
        x(3) = icent-0.5
        x(4) = icent
        x(5) = icent+0.5
        x(6) = icent+39.5
        x(7) = icent+40.5
        call gr4_connect(7,x,y,0.0,-1.0)
        lband(j) = 'DSB'
      else
        call astro_message(seve%e,rname,'Invalid sideband '//cband)
        error = .true.
        return
      endif
      llo3(j) = icent
    enddo
    if (berk.eq.' ') then
      if (nband.eq.1) then
        write(berk,1000) iband,llo3(1),lband(1)
      else
        write(berk,1000) iband,llo3(1),lband(1),llo3(2),lband(2)
      endif
    endif
  else
    do i=150,550,100
      x(1) = i-40.5
      x(2) = i-39.5
      x(3) = i-0.5
      x(4) = i
      x(5) = i+0.5
      x(6) = i+39.5
      x(7) = i+40.5
      call gr4_connect(7,x,y,0.0,-1.0)
    enddo
  endif
  error = .false.
  1000  format('SPECTRAL ',i2,2(1x,i3,1x,a))
end subroutine old_berkeley
!
subroutine berkeley (line, iflim, berk, error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: line           !
  real(kind=4) :: iflim(2)          !
  character(len=128) :: berk        !
  logical :: error                  !
  ! Global
  integer(kind=4) :: lenc
  logical :: sic_present
  ! Local
  logical :: err
  integer(kind=4) :: iband,nline,iunit,i
  character(len=12) :: comm
  real(kind=4) :: x(8),y(8),flo3,z(8), edge
  character(len=13) :: rname
  ! Data
  data z/0.0,2.0,2.0,0.0,2.5,2.0,2.0,0.0/
  data rname /'LINE/SPECTRAL'/
  !
  nline = lenc(line)
  error = .false.
  call sic_analyse (comm,line,nline,error)
  if (nline.eq.0) return
  if (error) return
  if (.not.sic_present(2,1)) return
  !
  ! Unit
  !
  call sic_i4 (line,2,1,iunit,.true.,error)
  if (error) return
  if (iunit.lt.1 .or. iunit.gt.8) then
    call astro_message(seve%w,rname,'Invalid correlator unit number ')
    error = .true.
    return
  endif
  do i=1,8
    y(i) = (1.0+0.05*(iunit-1))*z(i)
  enddo
  !
  ! Bandwidth
  !
  call sic_i4  (line,2,2,iband,.true.,error)
  if (error) return
  if (iband.ne.20 .and. iband.ne.40 .and. iband.ne.80 .and. iband.ne.160  &
      .and. iband.ne.320) then
    call astro_message(seve%e,rname,'Invalid bandwidth ')
    error = .true.
    return
  endif
  !
  ! Center LO3 frequency
  !
  call sic_r4 (line,2,3,flo3,.true.,error)
  if (error) return
  if (flo3.lt.iflim(1) .or. flo3.gt.iflim(2)) then
    call astro_message(seve%e,rname,'Invalid LO3 ')
    error = .true.
    return
  endif
  flo3 = 0.625*nint(flo3/0.625)
  call gr_segm('SPECTRAL',err)
  !
  ! Consider a 5% loss at the filter's edge
  !
  edge = iband*0.05
  if (iband.ne.20) then
    x(1) = flo3+0.5*iband
    x(2) = flo3+0.5*iband-1.0*edge
    x(3) = flo3
    x(4) = flo3
    x(5) = flo3
    x(6) = flo3
    x(7) = flo3-0.5*iband+1.0*edge
    x(8) = flo3-0.5*iband
    call gr4_connect(8,x,y,0.0,-1.0)
  else
    x(1) = flo3+0.5*iband
    x(2) = flo3+0.5*iband-1.0*edge
    x(3) = flo3-0.5*iband+1.0*edge
    x(4) = flo3-0.5*iband
    call gr4_connect(4,x,y,0.0,-1.0)
  endif
  call gr_segm_close(error)
  !
  ! Label
  !
  berk = 'SPECTRAL '
  do i = 1, 8
    nline = 15*(i-1)+10
    if (i.eq.iunit) then
      write(berk(nline:),'(I1,I4,F7.2,A)') i,iband,flo3,';'
    else
      ! WRITE(BERK(NLINE:),'(I2)') I
      ! WRITE(BERK(NLINE+13:),'(A)') ';'
    endif
  enddo
  !
  error = .false.
end subroutine berkeley
!
subroutine astro_line_alma(line,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  integer(kind=4) :: nmol,kmol,mmol
  integer(kind=4) :: i, ier, nc, lun
  parameter (mmol=1000)
  real(kind=8) :: f1, f2, freqs(mmol), afreq
  real(kind=4) :: new_width
  character(len=20) :: name(mmol), aname
  character(len=64) :: limi,fname
  character(len=256) :: chain
  character(len=256) :: molfile
  logical :: new
  !
  real(kind=4) :: sky, width, fw, fsky, tole
  character(len=4) :: band
  character(len=12) :: lname
  character(len=4) :: rname='LINE'
  !------------------------------------------------------------------------
  !
  width = 0.0                  ! No line width
  new = sic_present(4,0)       ! Wide band option
  ! Line name
  call sic_ch(line,0,1,fname,nc,.true.,error)
  ! Frequency
  call sic_r4(line,0,2,fsky,.true.,error)
  ! USB / LSB indicator
  call sic_ke(line,0,3,aname,nc,.true.,error)
  if (aname.eq.'USB') then
    sky = 1
  elseif  (aname.eq.'LSB') then
    sky = -1
  else
    ! je pense qu'il s'agit d'une erreur -- RL
    ! CALL GAGOUT('E-LINE, Invalid sideband '//NAME)
    call astro_message(seve%e,rname,'Invalid sideband '//aname)
    error = .true.
    return
  endif
  !
  ! Redshift
  if (fshift.eq.0) fshift = 1.d0
  !
  ! Molecule list
  kmol = sic_narg(1)
  if (kmol.gt.1) then
    kmol = kmol-1
    do i=1,kmol
      call sic_ch (line,1,i+1,name(mmol-i+1),nc,.false.,error)
      if (error) return
    enddo
  else
    kmol = 0
  endif
  !
  chain = 'GAG_MOLECULES'
  call sic_ch(line,1,1,chain,nc,.false.,error)
  molfile = chain
  call sic_parsef (chain,molfile,' ','.dat')
  !
  nmol = 0
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    call astro_message(seve%e,rname,'Cannot allocate LUN')
    call putios('E-LINE,  ',ier)
    return
  endif
  open(unit=lun,file=molfile(1:lenc(molfile)), status='OLD',iostat=ier)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Cannot open file: ')
    call astro_message(seve%e,rname,molfile)
    call putios('E-LINE,  ',ier)
    goto 9
  endif
  !
  5     read(lun,'(A)',iostat=ier,end=9) chain
  if (ier.ne.0 .or. lenc(chain).eq.0) goto 5
  if (chain(1:1).ne.'!') then
    read(chain,*,err=5) afreq, aname
    if (kmol.eq.0) then
      nmol = nmol + 1
      freqs(nmol) = afreq
      name(nmol) = aname
      if (nmol.le.mmol) goto 5
    else
      do i=mmol-kmol+1,mmol
        if (name(i).eq.aname) then
          nmol = nmol+1
          name(nmol) = aname
          freqs(nmol) = afreq
        endif
      enddo
      if (nmol.le.mmol-kmol) goto 5
    endif
  else
    goto 5
  endif
  9     close(unit=lun)
  call sic_frelun(lun)
  !
  call gr_exec('CLEAR DIRECTORY')
  tole = 0.1                   ! max(0.1,WIDTH)
  !
  ! Note: WIDTH existait deja et servait bien a quelque chose ... (RL)
  if (new) then
    !
    ! RN, Thu Nov 23, 2000... leaving it at 680 for the time being
    ! NEW_WIDTH = 1.0
    ! LIMI = 'LIMITS 100 1100 0 5'
    new_width = 8.0
    limi = 'LIMITS 4000 12000 0 5'
  else
    new_width = 4.0
    limi = 'LIMITS 4000 8000 0 5'
  endif
  !
  ! USB plot
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('SET BOX 3 29 13 18')
  if (gr_error()) return
  call gr_exec1(limi)
  ! CALL BERKELEY (LINE,ERROR,BERK)
  ! IF (ERROR) RETURN
  call gr_exec1('AXIS XL')
  call gr_exec1('DRAW TEXT 0 -1 "IF" /BOX 2')
  !
  if (sky.eq.1) then
    f1 = fsky/fshift - new_width/2.0
  else
    f1 = fsky/fshift + new_width/2.0 + 8.0
  endif
  f2 = f1 + new_width
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS YR /TICK NONE /LABEL NONE')
  call gr_exec1('AXIS YL /TICK NONE /LABEL NONE')
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  if (sky.eq.1) then
    call gr_exec1('DRAW TEXT 0 1 "USB - Signal" /BOX 8')
  else
    call gr_exec1('DRAW TEXT 0 1 "USB - Image " /BOX 8')
  endif
  if (nmol.ge.1) then
    call gr_exec1 ('SET ORIEN 50')
    aname = ' '
    afreq = 0.0
    do i=1, nmol
      if (freqs(i).le.f2 .and. freqs(i).ge.f1) then
        if (name(i).ne.aname .or. abs(afreq-freqs(i)).gt.tole) then
          write(chain,1000) 'DRAW TEXT ',freqs(i),' 4. "'//  &
          name(i)(1:lenc(name(i))+1)//'" 5 /USER'
          aname = name(i)
          afreq = freqs(i)
          call gr_exec1(chain(1:lenc(chain)))
        endif
        call gr_segm('LINE',error)
        if (width.eq.0) then
          call relocate (freqs(i),3.d0)
          call draw (freqs(i),2.0d0)
        else
          fw = width*freqs(i)/299792.458
          call relocate (freqs(i)-fw/2.,2.d0)
          call draw(freqs(i),3.d0)
          call draw(freqs(i)+fw/2.,2.d0)
        endif
        call gr_segm_close(error)
      endif
    enddo
  endif
  !
  ! LSB plot
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('SET BOX 3 29 3 8')
  if (gr_error()) return
  call gr_exec1(limi)
  !      CALL BERKELEY (LINE,ERROR,BERK)
  !      IF (ERROR) RETURN
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('DRAW TEXT 0 1 "IF" /BOX 8')
  if (sky.eq.1) then
    f1 = fsky/fshift - new_width/2.0 - 8.0
  else
    f1 = fsky/fshift + new_width/2.0
  endif
  f2 = f1 - new_width
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS YR /TICK NONE /LABEL NONE')
  call gr_exec1('AXIS YL /TICK NONE /LABEL NONE')
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  if (sky.eq.-1) then
    call gr_exec1('DRAW TEXT 0 -1 "LSB - Signal" /BOX 2')
  else
    call gr_exec1('DRAW TEXT 0 -1 "LSB - Image " /BOX 2')
  endif
  if (nmol.ge.1) then
    call gr_exec1 ('SET ORIEN 50')
    aname = ' '
    afreq = 0.0
    do i=1, nmol
      if (freqs(i).le.f1 .and. freqs(i).ge.f2) then
        if (name(i).ne.aname .or. abs(afreq-freqs(i)).gt.tole) then
          write(chain,1000) 'DRAW TEXT ',freqs(i),' 4. "'//  &
          name(i)(1:lenc(name(i)))//'" 5 /USER'
          aname = name(i)
          afreq = freqs(i)
          call gr_exec1(chain(1:lenc(chain)))
        endif
        call gr_segm('LINE',error)
        if (width.eq.0) then
          call relocate (freqs(i),3.d0)
          call draw (freqs(i),2.0d0)
        else
          fw = width*freqs(i)/299792.458
          call relocate (freqs(i)-fw/2.,2.d0)
          call draw(freqs(i),3.d0)
          call draw(freqs(i)+fw/2.,2.d0)
        endif
        call gr_segm_close(error)
      endif
    enddo
  endif
  call gr_exec1 ('SET ORIEN 0')
  !
  ! Label
  if (sky.eq.1) then
    band = 'USB'
  else
    band = 'LSB'
  endif
  ! IF (LCK.EQ.-1) THEN
  !   LOCK = 'LOW'
  ! ELSE
  !   LOCK = 'HIGH'
  ! ENDIF
  write(chain,1030) lname(1:lenc(lname)), fsky/fshift,band
  call astro_message(seve%r,rname,chain)
  call gr_exec1('DRAW TEXT 0 3.1 "'//chain(1:lenc(chain))//'" 5 /BOX 8')
  !
  ! SPECTRAL command
  ! N = LENC(BERK)
  ! IF (N.GT.0) THEN
  !   CALL GR_EXEC1('SET EXPAND 0.85')
  !   CALL GR_EXEC1('DRAW TEXT 0 2.2 "'//BERK(1:N)//'" 6 /BOX 7')
  !   CALL GR_EXEC1('SET EXPAND 1.0')
  ! ENDIF
  !
  1000  format(a,g14.7,a)
  1010  format(a,i3,a)
  1020  format(1x,a,f12.6)
  1030  format(a,1x,f11.6,1x,a,1x,a,1x,f6.2,1x,i4,a,f6.2,a,f11.6)
  1040  format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
end subroutine astro_line_alma
!
subroutine astro_line_sma(line,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Support for the SMA frequency setup.
  !     This is simple enough (en principle):
  !     The IF is at 5+/-1 GHz
  !     The correlator covers the 2 GHz IF with ? channels
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  integer(kind=4) :: nmol,kmol,mmol
  integer(kind=4) :: i, ier, nc, lun
  parameter (mmol=1000)
  real(kind=8) :: f1, f2, freqs(mmol), afreq
  real(kind=4) :: new_width
  character(len=20) :: name(mmol), aname, quant(mmol), aquant
  character(len=64) :: limi,fname
  character(len=256) :: chain
  character(len=256) :: molfile
  !
  real(kind=4) :: sky, width, fw, fsky, tole
  character(len=4) :: band
  character(len=12) :: lname
  character(len=4) :: rname
  data rname /'LINE'/
  !------------------------------------------------------------------------
  !
  width = 0.0                  ! No line width
  ! NEW = SIC_PRESENT(4,0)     ! Wide band option
  ! Line name
  call sic_ch(line,0,1,fname,nc,.true.,error)
  ! Frequency
  call sic_r4(line,0,2,fsky,.true.,error)
  ! USB / LSB indicator
  call sic_ke(line,0,3,aname,nc,.true.,error)
  if (aname.eq.'USB') then
    sky = 1
  elseif  (aname.eq.'LSB') then
    sky = -1
  else
    call astro_message(seve%e,rname,'Invalid sideband '//aname)
    error = .true.
    return
  endif
  !
  ! Redshift
  if (fshift.eq.0) fshift = 1.d0
  !
  ! Molecule list
  kmol = sic_narg(1)
  if (kmol.gt.1) then
    kmol = kmol-1
    do i=1,kmol
      call sic_ch (line,1,i+1,name(mmol-i+1),nc,.false.,error)
      if (error) return
    enddo
  else
    kmol = 0
  endif
  !
  chain = 'GAG_MOLECULES'
  call sic_ch(line,1,1,chain,nc,.false.,error)
  molfile = chain
  call sic_parsef (chain,molfile,' ','.dat')
  !
  nmol = 0
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    call astro_message(seve%e,rname,'Cannot allocate LUN')
    call putios('E-LINE,  ',ier)
    return
  endif
  open(unit=lun,file=molfile(1:lenc(molfile)), status='OLD',iostat=ier)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Cannot open file: ')
    call astro_message(seve%e,rname,molfile)
    call putios('E-LINE,  ',ier)
    goto 9
  endif
  !
  5     read(lun,'(A)',iostat=ier,end=9) chain
  if (ier.ne.0 .or. lenc(chain).eq.0) goto 5
  if (chain(1:1).ne.'!') then
    aquant = ' '
    read(chain,*,iostat=ier) afreq, aname, aquant
    if (kmol.eq.0) then
      nmol = nmol + 1
      freqs(nmol) = afreq
      name(nmol) = aname
      quant(nmol) = aquant
      if (nmol.le.mmol) goto 5
    else
      do i=mmol-kmol+1,mmol
        if (name(i).eq.aname) then
          nmol = nmol+1
          name(nmol) = aname
          freqs(nmol) = afreq
          quant(nmol) = aquant
        endif
      enddo
      if (nmol.le.mmol-kmol) goto 5
    endif
  else
    goto 5
  endif
  9     close(unit=lun)
  call sic_frelun(lun)
  !
  call gr_exec('CLEAR DIRECTORY')
  tole = 0.1                   ! max(0.1,WIDTH)
  !
  new_width = 2.0
  limi = 'LIMITS 4000 6000 0 5'
  !
  ! USB plot
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('SET BOX 3 29 13 18')
  if (gr_error()) return
  call gr_exec1(limi)
  call gr_exec1('AXIS XL')
  call gr_exec1('DRAW TEXT 0 -1 "IF" /BOX 2')
  !
  if (sky.eq.1) then
    f1 = fsky/fshift - new_width/2.0
  else
    f1 = fsky/fshift + new_width/2.0 + 8.0
  endif
  f2 = f1 + new_width
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS YR /TICK NONE /LABEL NONE')
  call gr_exec1('AXIS YL /TICK NONE /LABEL NONE')
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  if (sky.eq.1) then
    call gr_exec1('DRAW TEXT 0 1 "USB - Signal" /BOX 8')
  else
    call gr_exec1('DRAW TEXT 0 1 "USB - Image " /BOX 8')
  endif
  if (nmol.ge.1) then
    call gr_exec1 ('SET ORIEN 50')
    aname = ' '
    afreq = 0.0
    do i=1, nmol
      if (freqs(i).le.f2 .and. freqs(i).ge.f1) then
        if (name(i).ne.aname .or. abs(afreq-freqs(i)).gt.tole) then
          write(chain,1000) 'DRAW TEXT ',freqs(i),' 4. "'//  &
          name(i)(1:lenc(name(i))+1) //quant(i)(1:lenc(quant(i))+1)//'" 5 /USER'
          aname = name(i)
          afreq = freqs(i)
          call gr_exec1(chain(1:lenc(chain)))
        endif
        call gr_segm('LINE',error)
        if (width.eq.0) then
          call relocate (freqs(i),3.d0)
          call draw (freqs(i),2.0d0)
        else
          fw = width*freqs(i)/299792.458
          call relocate (freqs(i)-fw/2.,2.d0)
          call draw(freqs(i),3.d0)
          call draw(freqs(i)+fw/2.,2.d0)
        endif
        call gr_segm_close(error)
      endif
    enddo
  endif
  !
  ! LSB plot
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('SET BOX 3 29 3 8')
  if (gr_error()) return
  call gr_exec1(limi)
  ! CALL BERKELEY (LINE,ERROR,BERK)
  ! IF (ERROR) RETURN
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('DRAW TEXT 0 1 "IF" /BOX 8')
  if (sky.eq.1) then
    f1 = fsky/fshift - new_width/2.0 - 8.0
  else
    f1 = fsky/fshift + new_width/2.0
  endif
  f2 = f1 - new_width
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS YR /TICK NONE /LABEL NONE')
  call gr_exec1('AXIS YL /TICK NONE /LABEL NONE')
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  if (sky.eq.-1) then
    call gr_exec1('DRAW TEXT 0 -1 "LSB - Signal" /BOX 2')
  else
    call gr_exec1('DRAW TEXT 0 -1 "LSB - Image " /BOX 2')
  endif
  if (nmol.ge.1) then
    call gr_exec1 ('SET ORIEN 50')
    aname = ' '
    afreq = 0.0
    do i=1, nmol
      if (freqs(i).le.f1 .and. freqs(i).ge.f2) then
        if (name(i).ne.aname .or. abs(afreq-freqs(i)).gt.tole) then
          write(chain,1000) 'DRAW TEXT ',freqs(i),' 4. "'//  &
          name(i)(1:lenc(name(i)))//'" 5 /USER'
          aname = name(i)
          afreq = freqs(i)
          call gr_exec1(chain(1:lenc(chain)))
        endif
        call gr_segm('LINE',error)
        if (width.eq.0) then
          call relocate (freqs(i),3.d0)
          call draw (freqs(i),2.0d0)
        else
          fw = width*freqs(i)/299792.458
          call relocate (freqs(i)-fw/2.,2.d0)
          call draw(freqs(i),3.d0)
          call draw(freqs(i)+fw/2.,2.d0)
        endif
        call gr_segm_close(error)
      endif
    enddo
  endif
  call gr_exec1 ('SET ORIEN 0')
  !
  ! Label
  if (sky.eq.1) then
    band = 'USB'
  else
    band = 'LSB'
  endif
  write(chain,1030) lname(1:lenc(lname)), fsky/fshift,band
  call astro_message(seve%r,rname,chain)
  call gr_exec1('DRAW TEXT 0 3.1 "'//chain(1:lenc(chain)) //'" 5 /BOX 8')
  !
  ! SPECTRAL command
  ! N = LENC(BERK)
  ! IF (N.GT.0) THEN
  !   CALL GR_EXEC1('SET EXPAND 0.85')
  !   CALL GR_EXEC1('DRAW TEXT 0 2.2 "'//BERK(1:N)//'" 6 /BOX 7')
  !   CALL GR_EXEC1('SET EXPAND 1.0')
  ! ENDIF
  !
  1000  format(a,g14.7,a)
  1010  format(a,i3,a)
  1020  format(1x,a,f12.6)
  1030  format(a,1x,f11.6,1x,a,1x,a,1x,f6.2,1x,i4,a,f6.2,a,f11.6)
  1040  format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
end subroutine astro_line_sma

module cubeio_transpose
  use cubetools_parameters
  use cubetools_setup_types
  use cubedag_node_class
  use cubeio_messaging
  use cubeio_cube_define
  use cubeio_cube
  use cubeio_desc
  use cubeio_desc_setup
  use cubeio_chan
  use cubeio_pix
  use cubeio_subcube
  use cubeio_highlevel

  public :: cubeio_transpose_cube_desc
  public :: cubeio_transpose_memory,cubeio_transpose_disk
  private

contains

  subroutine cubeio_transpose_cube_desc(cubset,cubdef,in,out,error)
    !---------------------------------------------------------------------
    ! Memory-to-memory transposition of the input 'cubeio_cube_t' into the
    ! output one
    !---------------------------------------------------------------------
    type(cube_setup_t),   intent(in)    :: cubset
    type(cube_define_t),  intent(in)    :: cubdef
    type(cubeio_cube_t),  intent(in)    :: in
    type(cubeio_cube_t),  intent(inout) :: out
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TRANSPOSE>CUBE>DESC'
    !
    if (.not.cubdef%dotransname) then
      call cubeio_message(seve%e,rname,'Transposed cube name is not set')
      error = .true.
      return
    endif
    call cubeio_desc_transpose(in%desc,out%desc,cubdef%access,error)
    if (error) return
    out%file%name = cubdef%transname
    call cubeio_set_descriptor_external(cubset,cubdef,.true.,out,error)
    if (error)  return
  end subroutine cubeio_transpose_cube_desc
  !
  subroutine cubeio_transpose_memory(cubset,cubdef,  &
    dno,cubin,cubout,error)
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    ! Perform the transposition from input cube in memory to output cube
    ! in memory.
    !-------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cubin
    type(cubeio_cube_t),          intent(inout) :: cubout
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TRANSPOSE>MEMORY'
    !
    call cubeio_message(ioseve%trans,rname,terminal%dash_strg())
    call cubeio_message(ioseve%trans,rname,'Automatic transposition in memory')
    !
    ! NB: input and output file names are useless (no meaning) for
    ! memory transposition
    call cubeio_transpose_engine(cubset,cubdef,code_buffer_memory,  &
      '',0,'',dno,cubin,cubout,error)
    if (error)  return
    !
    call cubeio_message(ioseve%trans,rname,terminal%dash_strg())
  end subroutine cubeio_transpose_memory
  !
  subroutine cubeio_transpose_disk(cubset,cubdef,directname,directhdu,  &
    transname,dno,cubin,cubout,error)
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    ! Perform the transposition from input cube on disk to output cube
    ! on disk.
    !-------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    character(len=*),             intent(in)    :: directname
    integer(kind=4),              intent(in)    :: directhdu
    character(len=*),             intent(in)    :: transname
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cubin
    type(cubeio_cube_t),          intent(inout) :: cubout
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TRANSPOSE>DISK'
    !
    call cubeio_message(ioseve%trans,rname,terminal%dash_strg())
    call cubeio_message(ioseve%trans,rname,'Automatic transposition from '//  &
      trim(directname)//' to '//transname)
    !
    call cubeio_transpose_engine(cubset,cubdef,code_buffer_disk,  &
      directname,directhdu,transname,dno,cubin,cubout,error)
    if (error)  return
    !
    call cubeio_message(ioseve%trans,rname,terminal%dash_strg())
  end subroutine cubeio_transpose_disk
  !
  subroutine cubeio_transpose_engine(cubset,cubdef,buffering,  &
    directname,directhdu,transname,dno,cubin,cubout,error)
    use cubeio_dataformat_types
    use cubetools_format
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    integer(kind=code_k),         intent(in)    :: buffering
    character(len=*),             intent(in)    :: directname
    integer(kind=4),              intent(in)    :: directhdu
    character(len=*),             intent(in)    :: transname
    class(cubedag_node_object_t), intent(inout) :: dno   ! Header reloaded...
    type(cubeio_cube_t),          intent(inout) :: cubin
    type(cubeio_cube_t),          intent(inout) :: cubout
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TRANSPOSE'
    integer(kind=chan_k) :: fchan,lchan,stepnchan
    type(cube_define_t) :: cubindef,cuboutdef
    integer(kind=pixe_k) :: fypix,lypix,stepypix
    type(cubeio_subcube_t) :: subcube
    character(len=mess_l) :: mess
    character(len=6) :: where
    !
    ! Input description
    call cubdef%copy(cubindef)
    call cubindef%set_buffering(buffering,error)
    if (error)  return
    call cubindef%set_action(code_read,error)
    if (error)  return
    if (buffering.eq.code_buffer_disk) then
      where = 'disk'
      call cubindef%set_filename(directname,directhdu,error)
      if (error)  return
      call cubeio_get_header(cubset,cubindef,dno,cubin,error)
      if (error)  return
    else
      ! In memory mode, do not reload the header (as this can be a
      ! memory-only cube!). Just reset the descriptor access.
      where = 'memory'
      call cubeio_set_descriptor_external(cubset,cubindef,.true.,cubin,error)
      if (error)  return
    endif
    !
    ! Output description
    call cubdef%copy(cuboutdef)  ! Copy all except the next ones:
    cuboutdef%dofilename  = .false.
    cuboutdef%dofilekind  = .false.
    cuboutdef%dobuffering = .false.
    cuboutdef%doaction    = .false.
    call cuboutdef%set_filename(transname,1,error)
    if (error)  return
    call cuboutdef%set_filekind(code_dataformat_gdf,error)
    if (error)  return
    call cuboutdef%set_buffering(buffering,error)
    if (error)  return
    call cuboutdef%set_action(code_write,error)
    if (error)  return
    call cubeio_clone_header(cubset,cuboutdef,dno,cubout,error)
    if (error)  return
    !
    select case (cubout%desc%order)
    case (code_cube_imaset)
      ! Guess the internal buffer size
      ! ZZZ This should be automatic i.e cubeio_iterate_chan("as much as you can")
      if (buffering.eq.code_buffer_memory) then
        stepnchan = cubin%desc%nc
      else
        call cubin%chan_per_block(cubset%buff%block,'SET\BUFFER /BLOCK',stepnchan,error)
        if (error)  return
      endif
      write(mess,'(A,I0,3A)') 'Output file will be iterated by blocks of ',stepnchan,  &
        ' channels (',cubetools_format_memsize(stepnchan*cubout%chansize()),') in 3rd dimension'
      call cubeio_message(ioseve%trans,rname,mess)
      write(mess,'(A,I0,2A)')  'This means the input file will be traversed ', &
        (cubin%desc%nc-1)/stepnchan+1,' times from ',where
      call cubeio_message(ioseve%trans,rname,mess)
      lchan = 0
      do while (lchan.lt.cubin%desc%nc)
        fchan = lchan+1
        lchan = min(lchan+stepnchan,cubin%desc%nc)
        ! Load from buffer to subcube
        call cubeio_iterate_chan(cubset,cubindef,dno,cubin,fchan,lchan,error)
        if (error)  return
        call subcube%get(cubset,cubindef,dno,cubin,fchan,lchan,code_cube_imaset,error)
        if (error)  return
        ! Copy the subcube to the output data
        call cubeio_iterate_chan(cubset,cuboutdef,dno,cubout,fchan,lchan,error)
        if (error)  return
        call subcube%put(cubset,cuboutdef,dno,cubout,fchan,lchan,error)
        if (error)  return
      enddo
      call subcube%free(error)
      if (error)  return
      !
    case (code_cube_speset)
      ! Guess the internal buffer size
      ! ZZZ This should be automatic i.e cubeio_iterate_pix("as much as you can")
      if (buffering.eq.code_buffer_memory) then
        stepypix = cubin%desc%ny
      else
        call cubin%y_per_block(cubset%buff%block,'SET\BUFFER /BLOCK',stepypix,error)
        if (error)  return
      endif
      write(mess,'(A,I0,3A)') 'Output file will be iterated by blocks of ',stepypix,  &
        ' Y rows (',cubetools_format_memsize(stepypix*cubout%ysize()),') in 3rd dimension'
      call cubeio_message(ioseve%trans,rname,mess)
      write(mess,'(A,I0,2A)')  'This means the input file will be traversed ', &
        (cubin%desc%ny-1)/stepypix+1,' times from ',where
      call cubeio_message(ioseve%trans,rname,mess)
      lypix = 0
      do while (lypix.lt.cubin%desc%ny)
        fypix = lypix+1
        lypix = min(lypix+stepypix,cubin%desc%ny)
        ! Load from buffer to subcube
        call cubeio_iterate_pix(cubset,cubindef,dno,cubin,fypix,lypix,error)
        if (error)  return
        call subcube%get(cubset,cubindef,dno,cubin,fypix,lypix,code_cube_speset,error)
        if (error)  return
        ! Copy the subcube to the output data
        call cubeio_iterate_pix(cubset,cuboutdef,dno,cubout,fypix,lypix,error)
        if (error)  return
        call subcube%put(cubset,cuboutdef,dno,cubout,fypix,lypix,error)
        if (error)  return
      enddo
      call subcube%free(error)
      if (error)  return
      !
    case default
      call cubeio_message(seve%e,rname,'Unsupported order')
      error = .true.
      return
    end select
    !
    ! Input cube: free block buffer
    call cubeio_cube_finish(cubset,dno,cubin,error)
    if (error)  return
    ! Output cube: flush & free block buffer, finish checksum, ...
    call cubeio_cube_finish(cubset,dno,cubout,error)
    if (error)  return
    !
    ! The input and output descriptors need to be reverted as much as
    ! possible to the original 'cubdef'.
    ! 1) The original cube: reapply as is
    call cubeio_set_descriptor_external(cubset,cubdef,.true.,cubin,error)
    if (error)  return
    ! 2) Transposed cube:
    !  i) the action must be reverted from code_write to desired action
    !     in cubdef%action (usually code_read) => OK
    !  ii) the buffering must mode match the one it was created with
    call cubdef%copy(cuboutdef)
    call cuboutdef%set_buffering(buffering,error)
    if (error)  return
    call cubeio_set_descriptor_external(cubset,cuboutdef,.true.,cubout,error)
    if (error)  return
  end subroutine cubeio_transpose_engine

end module cubeio_transpose

subroutine clic_popup (line,error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! CLIC
  !     Pop-up the box pointed out by the cursor, and
  !     then call the cursor again to get "local" user coordinates.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  ! Local
  character(len=1) :: code
  integer :: i, ib, l, jb
  real*4 :: gx1(mbox), gx2(mbox), gy1(mbox), gy2(mbox)
  real*4 :: x4, y4
  real*8 :: xu, yu
  !
  ! Get box corners
  do i=1, n_boxes
    l = lenc(c_setbox(i))
    call gr_exec  (c_setbox(i)(1:l))
    call sic_get_real ('BOX_XMIN',gx1(i),error)
    call sic_get_real ('BOX_XMAX',gx2(i),error)
    call sic_get_real ('BOX_YMIN',gy1(i),error)
    call sic_get_real ('BOX_YMAX',gy2(i),error)
  enddo
  !
  call gr_execl('CHANGE DIRECTORY')
  do while (.true.)
    error = .false.
    call gr_curs (xu, yu, x4, y4, code)
    if (code.eq.'E' .or. code.eq.'e') then
      call resetvar(error)
      return
    endif
    ib = 0
    jb = 0
    do while (ib.eq.0)
      jb = jb+1
      if (jb.gt.n_boxes) then
        ib = -1
      else
        if ((x4-gx1(jb))*(x4-gx2(jb)) .le. 0) then
          if ((y4-gy1(jb))*(y4-gy2(jb)) .le. 0) then
            ib = jb
          endif
        endif
      endif
    enddo
    !
    if (ib.lt.0) then
      write(6,*) ' Cursor (',x4,',',y4,') is not in any box'
    else
      call sub_popup(ib)
    endif
  enddo
end subroutine clic_popup
!
subroutine sub_popup(ib)
  integer :: ib                     !
  ! Local
  character(len=4) :: chain
  !
  write(chain,'(I4.4)') ib
  call gr_execl('CHANGE DIRECTORY BOX'//chain)
  call gr_execl('CREATE WINDOW')
  call gr_exec1('DRAW')
  call gr_execl('DESTROY WINDOW')
  call gr_execl('CHANGE DIRECTORY')
end subroutine sub_popup

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uvmap_tool
  use gbl_message
  !
  public :: uvmap_main
  public :: map_prepare
  public :: uv_squeeze_clean,uv_removef_clean,uv_removes_clean,uv_clean_sizes
  public :: new_dirty_beam,plunge_real,recent
  private
  !
contains
  !
  subroutine map_prepare(rname,map,error)
    use gkernel_interfaces
    use map_buffers
    use uvmap_types
    use uvmap_buffers
    !-----------------------------------------------------------------------
    !
    !-----------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type(uvmap_par),  intent(inout) :: map
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: obsol='obsolescent'
    !
    ! Check version
    if (map_buffer%version.lt.-1 .or. map_buffer%version.gt.1) then
       call map_message(seve%e,rname,'Invalid MAP_VERSION, should be -1,0 or 1')
       error = .true.
       return
    endif
    !
    ! Check old syntax
    if (uvmap_old%uniform(1).ne.uvmap_saved%uniform(1)) then
       call map_message(seve%w,rname,'UV_CELL is '//obsol//', use MAP_UVCELL instead')
       uvmap_default%uniform(1) = uvmap_old%uniform(1)
    endif
    if (uvmap_old%uniform(2).ne.uvmap_saved%uniform(2)) then
       call map_message(seve%w,rname,'UV_CELL is '//obsol//', use MAP_ROBUST instead')
       uvmap_default%uniform(2) = uvmap_old%uniform(2)
    endif
    if (uvmap_old%taper(4).ne.uvmap_saved%taper(4)) then
       call map_message(seve%w,rname,'TAPER_EXPO is '//obsol//', use MAP_TAPER_EXPO instead')
       uvmap_saved%taper(4) = uvmap_old%taper(4)
       uvmap_default%taper(4) = uvmap_old%taper(4)
    endif
    if (any(uvmap_old%taper.ne.uvmap_saved%taper)) then
       call map_message(seve%w,rname,'UV_TAPER is '//obsol//', use MAP_UVTAPER instead')
       uvmap_default%taper = uvmap_old%taper
    endif
    if (uvmap_old%ctype.ne.uvmap_saved%ctype) then
       call map_message(seve%w,rname,'CONVOLUTION is '//obsol//', use MAP_CONVOLUTION instead')
       uvmap_default%ctype = uvmap_old%ctype
    endif
    if (uvmap_old%mode.ne.uvmap_saved%mode) then
       call map_message(seve%w,rname,'WEIGHT_MODE is '//obsol//', use MAP_WEIGHT instead')
       uvmap_default%mode = uvmap_old%mode
    endif
    if (uvmap_old%shift.neqv.uvmap_saved%shift) then
       call map_message(seve%w,rname,'UV_SHIFT is '//obsol//', use MAP_SHIFT instead')
       uvmap_default%shift = uvmap_old%shift
    endif
    !
    ! Copy the current default to the actual structure
    call uvmap_default%copyto(map)
    !
    ! Weighting scheme
    call uvmap_user_weight_mode_toprog(rname,map,error)
    if (error) return
    uvmap_default%mode = map%mode ! Solve ambiguities
    !
    if (map%mode.eq.'NATU') map%uniform(1) = 0.0
    if (map%uniform(2).le.0.0) map%uniform(2) =  1.0
    !
    error = .false.
    !
    ! Here, we do not care about the fields issue
    uvmap_old = uvmap_default
    uvmap_saved = uvmap_default
  end subroutine map_prepare
  !
  subroutine uvmap_main(rname,line,error)
    use phys_const, only: pi
    use gkernel_interfaces
    use mapping_types, only: map_minmax
    use uv_continuum, only: map_beams,map_parameters
    use uv_shift, only: map_get_radecang
    use uv_rotate_shift_and_sort_tool, only: uv_sort_main
    use clean_types
    use file_buffers
    use uv_buffers
    use uvmap_buffers
    use clean_buffers
    !------------------------------------------------------------------------
    ! Support for commands
    !    UV_RESTORE
    !    UV_MAP
    !    MX (eventually, not coded yet)
    !
    ! Compute a map from a CLIC UV Sorted Table  by Gridding and Fast Fourier
    ! Transform, using adequate virtual memory space for optimisation. Also
    ! allows removal of Clean Components in the UV data and restoration of
    ! the clean image.
    !
    ! Input :
    !     a precessed UV table
    !     a list of Clean components
    ! Output :
    !     a precessed, rotated, shifted UV table, sorted in V,
    !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    !     a beam image or cube
    !     a LMV cube  (dirty or clean)
    !
    ! To be implemented
    !     Optionally, a Residual UV table
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname ! Caller (MX or UV_MAP or UV_RESTORE)
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    logical :: do_cct,do_slow,do_copy
    logical :: one,sorted,shift,found(3)
    integer :: ier
    integer, save :: saved_mcol(2)=[0,0]
    integer, save :: saved_wcol=0
    integer, parameter :: o_slow = 2
    integer, parameter :: o_copy = 1
    integer :: nx,ny,nu,nv,nc,nb,mx,my
    integer :: wcol,mcol(2),rcol,sblock
    real :: cpu0,cpu1
    real, allocatable :: w_mapu(:),w_mapv(:),w_grid(:,:)
    real(4) :: rmega,uvmax,uvmin,uvma
    real(8) :: new(3),freq
    real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
    character(len=message_length) :: chain
    !
    ! print *,'DO_WEIG at start ',do_weig
    !
    uvmap_prog%beam = 0
    call sic_get_inte('MAP_BEAM_STEP',uvmap_prog%beam,error)
    !
    do_cct = rname.eq.'UV_RESTORE'
    !
    do_slow = sic_present(o_slow,0)
    do_copy = sic_present(o_copy,0)
    !
    error = .false.
    !
    if (do_cct) then
       ! Subtract all Clean Components
       if (.not.associated(duv)) then
          call map_message(seve%e,rname,'No UV data loaded')
          error = .true.
       endif
       if (.not.allocated(cct%data)) then
          call map_message(seve%e,rname,'No CCT data available')
          error = .true.
       endif
       if (error) return
    endif
    !
    call map_prepare(rname,uvmap_prog,error)
    if (error) return
    !
    one = .true.
    call sic_get_inte('WCOL',wcol,error)
    call sic_get_inte('MCOL[1]',mcol(1),error)
    call sic_get_inte('MCOL[2]',mcol(2),error)
    !
    call sic_get_logi('UV_SHIFT',shift,error)
    if (shift) then
       ! Read MAP_RA, MAP_DEC, MAP_ANGLE
       call map_get_radecang(rname,found,new,error)
       if (error)  return
       if (.not.all(found)) then
          call map_message(seve%e,rname,'MAP_RA and MAP_DEC must be defined')
          error = .true.
          return
       endif
    else
       new(:) = 0.d0
    endif
    !
    ! First sort the input UV Table, leaving UV Table in UV_*
    call gag_cpu(cpu0)
    call uv_sort_main(error,sorted,shift,new,uvmax,uvmin)
    if (error) return
    if (.not.sorted) then
       ! Redefine SIC variables (mandatory)
       call sic_delvariable ('UV',.false.,error)
       call sic_mapgildas ('UV',huv,error,duv)
    endif
    call gag_cpu(cpu1)
    write(chain,102) 'Finished sorting ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    call map_parameters(rname,uvmap_prog,freq,uvmax,uvmin,error)
    if (error) return
    uvma = uvmax/(freq*f_to_k)
    !
    uvmap_prog%xycell = uvmap_prog%xycell*pi/180.0/3600.0
    !
    ! Get work space, ideally before mapping first image, for
    ! memory contiguity reasons.
    !
    nx = uvmap_prog%size(1)
    ny = uvmap_prog%size(2)
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    !
    ! Define the number of output channels
    nc = huv%gil%nchan
    if (do_cct .and. nc.ne.cct%head%gil%dim(2)) then
       print *,'Mismatch number of channels between HUV ',nc,' and CCT ',cct%head%gil%dim(2)
    endif
    if (mcol(1).eq.0) then
       mcol(1) = 1
    else
       mcol(1) = max(1,min(mcol(1),nc))
    endif
    if (mcol(2).eq.0) then
       mcol(2) = nc
    else
       mcol(2) = max(1,min(mcol(2),nc))
    endif
    nc = mcol(2)-mcol(1)+1
    !
    ! Find out how many beams are required
    call map_beams(rname,uvmap_prog%beam,huv,nx,ny,nb,nc)
    !
    ! Check if Weights have changed by MCOL choice
    !!PRINT *,'DO_WEIG before ',do_weig
    if (any(saved_mcol.ne.mcol) .or. nb.gt.1) do_weig = .true.
    if (saved_wcol.ne.wcol) do_weig = .true.
    !!PRINT *,'DO_WEIG just after ',do_weig,' nb ',nb
    saved_mcol = mcol
    saved_wcol = wcol
    !
    if (clean_prog%method.eq.'MX') do_weig = .true. ! Test
    if (do_weig) then
       call map_message(seve%i,rname,'Computing weights ')
       if (allocated(g_weight)) deallocate(g_weight)
       if (allocated(g_v)) deallocate(g_v)
       allocate(g_weight(nv),g_v(nv),stat=ier)
       if (ier.ne.0) goto 98
    else
       call map_message(seve%i,rname,'Re-using weight space')
    endif
    !
    rmega = 512.0
    ier = sic_ramlog('SPACE_MAPPING',rmega)
    !
    ! In fast mode, an intermediate Large FFT is used
    ! The maximum number of threads should also play a role here,
    ! but we assume the user has accounted for this in its definition
    ! of SPACE_MAPPING
    !
    if (do_cct.and..not.do_slow) then
       mx = max(nx,min(4*nx,4096))
       my = max(ny,min(4*ny,4096))
       sblock = max(int(256.0*rmega*1024.0)/mx/my,1)
    else
       sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
    endif
    !
    ! New Beam place
    if (allocated(dbeam)) then
       call sic_delvariable ('BEAM',.false.,error)
       deallocate(dbeam)
    endif
    call gildas_null(hbeam)
    !
    ! Process sorted UV Table according to the number of beams produced
    !
    hbeam%gil%ndim = 3
    hbeam%gil%dim(1:4)=[nx,ny,nb,1]
    if (nb.gt.1) then
       allocate(hbeam%r3d(nx,ny,nb),dbeam(nx,ny,1,nb),stat=ier)
       rcol = 0
    else
       allocate(dbeam(nx,ny,1,1),stat=ier)
       hbeam%r3d => dbeam(:,:,:,1)
       rcol = (mcol(2)+mcol(1))/2
    endif
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error on DBEAM')
       error =.true.
       return
    endif
    !
    if (do_cct) then
       cct%head%r3d => cct%data
       !
       ! New residual image
       if (allocated(resid%data)) then
          call sic_delvariable ('RESIDUAL',.false.,error)
          deallocate(resid%data)
       endif
       allocate(resid%data(nx,ny,nc),stat=ier)
       !
       call gildas_null(resid%head)
       resid%head%gil%ndim = 3
       resid%head%gil%dim(1:3) = (/nx,ny,nc/)
       resid%head%r3d => resid%data
       !
       if (allocated(clean%data)) then
          call sic_delvariable ('CLEAN',.false.,error)
          deallocate(clean%data)
       endif
       allocate(clean%data(nx,ny,nc),stat=ier)
       clean%head%r3d => clean%data
       !
       call uvmap_and_restore(&
            rname,uvmap_prog, &
            huv,hbeam,resid%head, &
            nx,ny,nu,nv,duv, &
            g_weight,g_v,do_weig, &
            rcol,wcol,mcol,sblock,cpu0,error,uvma, &
            clean_prog,do_cct,cct%head,clean%head,do_slow,do_copy)
       !!PRINT *,'DO_WEIG after ',do_weig
       !
       ! Specify clean beam parameters
       clean%head%gil%reso_words = 3
       clean%head%gil%majo = clean_prog%major
       clean%head%gil%mino = clean_prog%minor
       clean%head%gil%posa = pi*clean_prog%angle/180.0
       !
       ! Get extrema
       call map_minmax(clean%head)
       !
       clean%head%loca%size = nx*ny*nc
       clean%head%gil%ndim = 3
       clean%head%gil%dim(1:3) = (/nx,ny,nc/)
       call sic_mapgildas ('CLEAN',clean%head,error,clean%data)
       call sic_mapgildas ('RESIDUAL',resid%head,error,resid%data)
       !
       save_data(code_save_clean) = .true.
       save_data(code_save_resid) = .true.
    else
       ! New dirty image
       if (allocated(dirty%data)) then
          call sic_delvariable ('DIRTY',.false.,error)
          deallocate(dirty%data)
       endif
       allocate(dirty%data(nx,ny,nc),stat=ier)
       !
       call gildas_null(dirty%head)
       dirty%head%gil%ndim = 3
       dirty%head%gil%dim(1:3) = (/nx,ny,nc/)
       dirty%head%r3d => dirty%data
       call sic_mapgildas('DIRTY',dirty%head,error,dirty%data)
       !
       call uvmap_and_restore (rname,uvmap_prog,   &
            &    huv, hbeam, dirty%head,   &
            &    nx,ny,nu,nv, duv,   &
            &    g_weight, g_v, do_weig,  &
            &    rcol,wcol,mcol,sblock,cpu0,error,uvma, &
            &    clean_prog, do_cct, cct%head, clean%head, do_slow, do_copy)
       !!PRINT *,'DO_WEIG after ',do_weig
       !
       save_data(code_save_beam) = .true.
       save_data(code_save_dirty) = .true.
       !
       call new_dirty_beam(error)
       if (error) return
       !
       ! Define Min Max
       call map_minmax(dirty%head)
       !
       d_max = dirty%head%gil%rmax
       if (dirty%head%gil%rmin.eq.0) then
          d_min = -0.03*dirty%head%gil%rmax
       else
          d_min = dirty%head%gil%rmin
       endif
    endif
    !
    ! Re-shape the beam, and reset the 4-D pointer,
    ! but show it as a 3-D array in SIC
    if (nb.gt.1) then
       dbeam(:,:,:,:) = reshape(hbeam%r3d,[nx,ny,1,nb])
       deallocate(hbeam%r3d)
    endif
    !
    hbeam%r4d => dbeam
    hbeam%gil%dim(1:4)=[nx,ny,1,nb]
    hbeam%gil%ndim = 4
    !
    ! Transpose the header appropriately
    hbeam%gil%convert(:,4) = hbeam%gil%convert(:,3)
    hbeam%gil%faxi = 4
    hbeam%char%code(4) = 'VELOCITY' ! Frequency would be better...
    hbeam%gil%convert(:,3) = 1.d0
    hbeam%char%code(3) = 'FIELD'    ! Pseudo-mosaic
    hbeam%gil%ndim = 4
    !
    call sic_mapgildas('BEAM',hbeam,error,dbeam)
    !
    if (.not.error) call map_message(seve%i,rname,'Successful completion')
    !
    if (rname.ne.'MX') goto 99
    !
99  continue
    if (allocated(w_mapu)) deallocate(w_mapu)
    if (allocated(w_mapv)) deallocate(w_mapv)
    if (allocated(w_grid)) deallocate(w_grid)
    !!PRINT *,'DO_WEIG at end ',do_weig
    return
    !
98  call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
    !
102 format(a,f9.2)
  end subroutine uvmap_main
  !
  subroutine uvmap_and_restore(rname,map,huv,hbeam,hdirty, &
       nx,ny,nu,nv,uvdata,r_weight,w_v,do_weig, &
       rcol,wcol,mcol,sblock,cpu0,error,uvmax, &
       method,do_cct,hcct,hclean,do_slow,do_copy)
    use gkernel_interfaces
    use image_def
    use mapping_interfaces, only: grdflt,convfn,convfn,docoor,grdtab,doweig,dotape,dofft,scawei
    use mapping_interfaces, only: sump,extracs,cmtore,chkfft
    use mapping_types, only: map_minmax
    use minmax_tool, only: maxmap
    use uvstat_tool, only: prnoise
    use gridding_types
    use uvmap_types
    use cct_types
    use clean_types
    use fit_beam_tool
    use omp_buffers
    !$ use omp_lib
    ! ------------------------------------------------------------------------
    ! Compute a map from a CLIC UV Sorted Table by Gridding and Fast
    ! Fourier Transform, with a different beam per channel.
    !
    ! Input :
    ! a precessed UV table, sorted in V, ordered in
    ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    !
    ! (optionally) a list of Clean components
    !
    ! Output :
    ! a beam image
    ! a DIRTY or RESIDUAL and CLEAN cube
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type (uvmap_par), intent(inout) :: map  ! Mapping parameters
    type (gildas),    intent(inout) :: huv     ! UV data set
    type (gildas),    intent(inout) :: hbeam   ! Dirty beam data set
    type (gildas),    intent(inout) :: hdirty  ! Dirty image data set
    integer,          intent(in)    :: nx   ! X size
    integer,          intent(in)    :: ny   ! Y size
    integer,          intent(in)    :: nu   ! Size of a visibilities
    integer,          intent(in)    :: nv   ! Number of visibilities
    real,             intent(inout) :: uvdata(nu,nv)
    real, target,     intent(inout) :: r_weight(nv)    ! Weight of visibilities
    real,             intent(inout) :: w_v(nv)         ! V values
    logical,          intent(inout) :: do_weig
    !
    real,             intent(inout) :: cpu0     ! CPU
    real,             intent(inout) :: uvmax    ! Maximum baseline
    integer,          intent(inout) :: sblock   ! Blocking factor
    integer,          intent(inout) :: rcol     ! Reference frequency channel
    integer,          intent(inout) :: wcol     ! Weight channel
    integer,          intent(inout) :: mcol(2)  ! First and last channel
    logical,          intent(inout) :: error
    logical,          intent(in)    :: do_cct
    type (clean_par), intent(inout) :: method
    type (gildas),    intent(inout) :: hcct
    type (gildas),    intent(inout) :: hclean
    logical,          intent(in)    :: do_slow
    logical,          intent(in)    :: do_copy
    !
    real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
    real(8), parameter :: pi=3.14159265358979323846d0
    !
    type (gridding) :: conv
    character(len=32) :: cname
    !
    integer :: nchan    ! Number of channels
    integer :: ndata    ! Size of data
    integer :: nbeam    ! Number of beams
    integer :: schunk   ! Number of channels per chunk
    integer :: nblock   ! Number of blocks/chunks ( = nbeam if nbeam.gt.1)
    integer :: ier, icmax
    real(kind=8) :: freq
    integer ctypx,ctypy
    integer lcol,fcol
    real wall,cpu1
    real xparm(10),yparm(10)
    real(8) :: vref,voff,vinc
    real(kind=4) :: loff,boff
    integer ndim, nn(2), lx, ly, kz1
    integer kz,iz,ic,kc,kb,jc,lc
    character(len=message_length) :: chain
    !
    real :: rms, null_taper(4), wold
    complex, allocatable :: ftbeam(:,:)
    complex, allocatable :: tfgrid(:,:,:)
    real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:),  w_grid(:,:), walls(:)
    real, allocatable :: w_weight(:)
    real, allocatable :: beam(:,:)
    real, allocatable :: w_mapu(:), w_mapv(:)
    real, allocatable :: local_wfft(:)
    real uvcell(2)
    real support(2)
    real(8) local_freq
    !
    integer :: ithread,othread,nthread
    real(8) :: elapsed_s, elapsed_e, elapsed
    !
    logical :: local_error
    logical :: compute_weight
    !
    integer :: maxic, icc, no, niter
    integer, allocatable :: mic(:)    ! Number of clean components per channel
    real, allocatable :: ouv(:,:)     ! Residual Visibilities
    real, allocatable :: ccou(:,:,:)  ! Transpose, compressed Clean Component List
    type (cct_par), allocatable :: p_cct(:)
    type(clean_par) :: my_method
    real :: my_major, my_minor, my_angle
    integer :: ix_min,ix_max,iy_min,iy_max
    real :: bmin,bmax
    character(len=12) :: fname
    integer :: grid_code
    integer(kind=4) :: lastchanblock,firstchanblock
    !$ integer(kind = OMP_lock_kind) :: lck_weight, lck_grid
    !
    grid_code = 0
    call sic_get_inte('MAP_GRID_CODE',grid_code,error)
    !
    elapsed_s = 0
    elapsed_e = 0
    error = .false.
    ndata = nx*ny
    nchan = huv%gil%nchan
    nbeam = hbeam%gil%dim(3)
    !
    schunk = map%beam
    null_taper = 0
    !
    if (schunk.ne.1 .and. nbeam.gt.1) then
       write(chain,'(a,i6,a)') 'Processing ',schunk,' channels per beam'
       call map_message(seve%w,rname,chain)
    endif
    if (nbeam.eq.1) then
       !
       ! Optimize SBLOCK now, allowing some additional memory if NBLOCK small
       if (sblock.gt.0) then
          nblock = (nchan+sblock-1)/sblock
          kz = mod(nchan,sblock)
          if (kz.ne.0 .and. kz.lt.(sblock/(nblock+1))) then
             if (nblock.ne.1) nblock = nblock-1
          endif
          sblock = (nchan+nblock-1)/nblock
          schunk = min(sblock,nchan)
       else
          schunk = nchan
          nblock = 1
       endif
       !$ nthread = omp_get_max_threads()
       if (nblock.lt.nthread) then
          nblock = min(nthread,nchan)
          sblock = (nchan+nblock-1)/nblock
          write(chain,'(A,I6,A,I8,A)') 'Reset ',nblock,' blocks of ',&
               & sblock,' channels for Threading'
          call map_message(seve%w,rname,chain)
          schunk = sblock
       endif
       write(chain,'(A,I6,A,I8,A)') 'Using ',nblock,' blocks of ',&
            & schunk
       call map_message(seve%w,rname,chain)
    else
       nblock = nbeam  ! For the Nesting of OMP parallel codes
    endif
    !
    ! Reset the parameters
    xparm = 0.0
    yparm = 0.0
    !
    vref = huv%gil%ref(1)
    voff = huv%gil%voff
    vinc = huv%gil%vres
    if (mcol(1).eq.0) then
       mcol(1) = 1
    else
       mcol(1) = max(1,min(mcol(1),nchan))
    endif
    if (mcol(2).eq.0) then
       mcol(2) = nchan
    else
       mcol(2) = max(1,min(mcol(2),nchan))
    endif
    fcol = min(mcol(1),mcol(2))
    lcol = max(mcol(1),mcol(2))
    if (wcol.eq.0) then
       wcol = (fcol+lcol)/3
    endif
    wcol = max(1,wcol)
    wcol = min(wcol,nchan)
    nchan = lcol-fcol+1
    !
    ! Compute observing sky frequency for U,V cell size
    if (rcol.eq.0) then
       freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
    else
       freq = gdf_uv_frequency(huv, dble(rcol) )
    endif
    !
    ! Compute gridding function
    ctypx = map%ctype
    ctypy = map%ctype
    call grdflt (ctypx, ctypy, xparm, yparm)
    call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
    call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
    map%uvcell = clight/freq/(map%xycell*map%size)
    map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
    map%support(2) = yparm(1)*map%uvcell(2)
    !
    ! Process sorted UV Table according to the type of beam produced
    !
    allocate (w_w(nv),w_weight(nv),walls(nbeam),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Cannot allocate Weight arrays')
       error = .true.
       return
    endif
    w_v(:) = uvdata(2,1:nv)
    !
    !
    lx = (uvmax+map%support(1))/map%uvcell(1) + 2
    ly = (uvmax+map%support(2))/map%uvcell(2) + 2
    lx = 2*lx
    ly = 2*ly
    if (ly.gt.ny) then
       write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
            &      ' Undersampling ratio ',float(ly)/float(ny)
       call map_message(seve%e,rname,chain)
       ly = min(ly,ny)
       lx = min(lx,nx)
    endif
    !
    ! Get FFT's and beam work spaces
    allocate (tfgrid(schunk+1,lx,ly),ftbeam(nx,ny),beam(nx,ny),&
         & w_mapu(lx),w_mapv(ly),local_wfft(2*max(nx,ny)), &
         & w_xgrid(nx),w_ygrid(ny),w_grid(nx,ny),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Cannot allocate TF arrays')
       error = .true.
       return
    endif
    !
    call docoor (lx,-map%uvcell(1),w_mapu)
    call docoor (ly,map%uvcell(2),w_mapv)
    !
    ndim = 2
    nn(1) = nx
    nn(2) = ny
    call fourt_plan(ftbeam,nn,ndim,-1,1)
    !
    ! Prepare grid correction,
    call grdtab (ny, conv%vbuff, conv%vbias, w_ygrid)
    call grdtab (nx, conv%ubuff, conv%ubias, w_xgrid)
    !
    ! Make beam, not normalized
    call gdf_copy_header(huv,hbeam,error)
    hbeam%gil%dopp = 0.0  ! Nullify the Doppler factor
    !
    hbeam%gil%ndim = 3
    hbeam%gil%dim(1) = nx
    hbeam%gil%dim(2) = ny
    hbeam%gil%dim(3) = nbeam
    hbeam%gil%dim(4) = 1
    hbeam%gil%convert(1,1) = nx/2+1
    hbeam%gil%convert(1,2) = ny/2+1
    hbeam%gil%convert(2,1) = 0
    hbeam%gil%convert(2,2) = 0
    hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
    hbeam%gil%convert(3,2) = map%xycell(2)
    !    hbeam%gil%convert(1,3) = vref-fcol+1     ! for 1 per channel
    ! From UV_COMPRESS
    !    uvout%gil%inc(1) = uvout%gil%inc(1)*nc
    !    uvout%gil%ref(1) = (2.0*uvout%gil%ref(1)+nc-1.0)/2/nc
    !    uvout%gil%vres = nc*uvout%gil%vres
    !    uvout%gil%fres = nc*uvout%gil%fres
    !
    ! Strictly speaking, this is true only if there is more than one beam
    ! but the information is only used in this case anyway
    hbeam%gil%convert(1,3) = (2.d0*(vref-fcol)+schunk+1.d0)/2/schunk ! Correct
    hbeam%gil%convert(2,3) = voff
    hbeam%gil%proj_words = 0
    hbeam%gil%extr_words = 0
    hbeam%gil%reso_words = 0
    hbeam%gil%uvda_words = 0
    hbeam%gil%type_gdf = code_gdf_image
    !
    hbeam%char%code(1) = 'ANGLE'
    hbeam%char%code(2) = 'ANGLE'
    hbeam%char%code(3) = 'VELOCITY'
    hbeam%gil%xaxi = 1
    hbeam%gil%yaxi = 2
    hbeam%gil%faxi = 3
    hbeam%gil%majo = 0.0
    hbeam%loca%size = nx*ny*nbeam
    !
    ! Prepare the dirty map header
    call gdf_copy_header(hbeam,hdirty,error)
    hdirty%gil%ndim = 3
    hdirty%gil%dim(1) = nx
    hdirty%gil%dim(2) = ny
    hdirty%gil%dim(3) = nchan
    hdirty%gil%dim(4) = 1
    hdirty%gil%convert(1,3) = vref-fcol+1
    hdirty%gil%convert(2,3) = voff
    hdirty%gil%convert(3,3) = vinc
    hdirty%gil%proj_words = def_proj_words
    hdirty%gil%uvda_words = 0
    hdirty%gil%type_gdf = code_gdf_image
    hdirty%char%code(1) = 'RA'
    hdirty%char%code(2) = 'DEC'
    hdirty%char%code(3) = 'VELOCITY'
    call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
         hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
    if (huv%gil%ptyp.eq.p_none) then
       hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
       hdirty%gil%pang = 0.d0     ! Defined in table.
       hdirty%gil%a0 = hdirty%gil%ra
       hdirty%gil%d0 = hdirty%gil%dec
    else
       hdirty%gil%ptyp = p_azimuthal
       hdirty%gil%pang = huv%gil%pang ! Defined in table.
       hdirty%gil%a0 = huv%gil%a0
       hdirty%gil%d0 = huv%gil%d0
    endif
    hdirty%char%syst = 'EQUATORIAL'
    hdirty%gil%xaxi = 1
    hdirty%gil%yaxi = 2
    hdirty%gil%faxi = 3
    hdirty%gil%extr_words = 0          ! extrema not computed
    hdirty%gil%reso_words = 0          ! no beam defined
    hdirty%gil%nois_words = 2
    hdirty%gil%majo = 0
    hdirty%char%unit = 'Jy/beam'
    hdirty%loca%size = nx*ny*nchan
    !
    ! Smooth the beam
    hbeam%gil%convert(3,3) = vinc*schunk
    hbeam%gil%vres = schunk*vinc
    hbeam%gil%fres = schunk*hbeam%gil%fres
    !
    if (do_cct) then
       call gdf_copy_header(hdirty,hclean,error)
       maxic = hcct%gil%dim(3)
       no = 7+3*schunk
       allocate (ouv(no,huv%gil%dim(2)), &
            &   ccou(3,maxic,schunk), mic(schunk), p_cct(maxic), stat=ier)
    else
       no = 7+3*schunk
       allocate (ouv(no,huv%gil%dim(2)), stat=ier)
       maxic = 0
    endif
    if (ier.ne.0) then
       call map_message(seve%e,rname,'UV data allocation error')
       error = .true.
       return
    endif
    !
    cname = rname
    !
    error = .false.
    if (nbeam.gt.1) then
       !$ othread = omp_get_max_threads()
       !$ nthread = min(othread,nbeam)
       !$ call omp_set_num_threads(nthread)
    else
       ! Set a lock if Nbeam is One
       if (omp%uvmap_lock) then
          !$ call omp_init_lock(lck_weight)
          !$ call omp_init_lock(lck_grid)
       endif
    endif
    !$ elapsed_s = omp_get_wtime()
    !
    ! print *,'WCOL ',wcol,' RCOL ',rcol,' FREQ '
    !
    ! Loop over blocks
    !
    !$OMP PARALLEL if (nblock.gt.1) DEFAULT(none) &      ! For UV_MAP first
    !$OMP PRIVATE(tfgrid,ftbeam,beam,w_weight,w_w) &
    !$OMP PRIVATE(w_mapu,w_mapv,w_grid) &
    !$OMP PRIVATE(local_wfft,chain,firstchanblock,lastchanblock) &
    !$OMP PRIVATE(local_freq,support,wall,rms,uvcell,local_error) &
    !$OMP PRIVATE(kz,kb,kc,iz,ic, kz1,jc,lc, cname) &
    !$OMP SHARED(walls,schunk,nbeam) &
    !$OMP SHARED(nu,nv,nx,ny,nchan,ndata,fcol,lcol,lx,ly, nthread) &
    !$OMP SHARED(map,null_taper,error) &
    !$OMP SHARED(conv,freq,do_weig, r_weight) &
    !$OMP SHARED(nn,ndim,huv,hbeam,hdirty,rname) &
    !$OMP SHARED(w_xgrid,w_ygrid,w_v,uvdata) &
    !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread) &
    !$OMP SHARED(maxic,hcct,hclean,no,do_cct,do_slow,method,do_copy) & ! For RESTORE
    !$OMP PRIVATE(mic,niter,ccou,ouv,p_cct) &
    !$OMP PRIVATE(ix_min,ix_max,iy_min,iy_max,bmin,bmax,icmax) &
    !$OMP PRIVATE(my_method,fname,compute_weight) SHARED(my_major, my_minor, my_angle) &
    !$OMP SHARED(lck_weight, lck_grid, omp) & ! Lock mechanism for grid & weight
    !$OMP SHARED(rcol, wold, wcol, grid_code)
    kz = 1 ! test for bug below
    !
    ! print *,'KZ ',kz,' NChan ',nchan,' ndata ',ndata
    my_method = method
    my_method%method = 'RESTORE'
    !
    ! Loop over blocks
    !$OMP DO SCHEDULE(STATIC)
    do ic = fcol,lcol,schunk                !
       ! Set a Lock
       lc = min(lcol,ic+schunk-1) ! Last channel in the block (in input unit)
       kz = lc-ic+1 ! Width of the chunk, may be different from schunk in last block
       ! First and last channels in block in output unit
       firstchanblock = ic-fcol+1 
       lastchanblock = lc-fcol+1
       !
       ithread = 1
       !$ ithread = omp_get_thread_num()+1
       !$ elapsed_s = omp_get_wtime()
       !$ write(cname,'(A,A,I0,A)') trim(rname),'(',ic,')' 
       !
       jc = min(lcol,ic+schunk/2)            ! The default weight channel here...
       if (nbeam.eq.1) jc = wcol             ! Reset the default weight channel
       !!print *,'JC ',jc,' Wcol ',wcol, ic, lcol,schunk
       compute_weight = do_weig
       !$ if (nbeam.eq.1 .and. omp%uvmap_lock) then
       ! One will get the lock, the others will not compute the weights
       !$   if (do_weig .and. (ic.le.wcol .and. ic+schunk.gt.wcol) ) then
       !$     call omp_set_lock(lck_weight)
       !$     print *,'Thread ',ithread,' got WEIGHT lock ',do_weig,' WCOL ',ic,' < ',wcol &
       !$       ,' < ',ic+schunk
       !$   else
       !$     compute_weight = .false.
       !$   endif
       !$ endif
       !print *,'Thread ',ithread,' IC ',ic,', KZ ',kz,', Schunk ',schunk
       !
       kb = (ic-fcol)/schunk+1
       if (kb.gt.nbeam .or. kb.lt.1) then
          !
          ! *** Actually, this is perfectly acceptable in the One Beam, Many Chunks case
          if (nbeam.gt.1) print *,'Programming error, expected 0 < ',kb,' < ',nbeam+1
          kb = nbeam
       endif
       !
       w_w(:) = uvdata(7+3*jc,:)
       wold = sump(nv,w_w)
       !
       ! Search for a non empty weight channel
       if (wold.eq.0) then
          do kc=ic,lc 
             if (kc.ne.jc) then
                w_w(:) = uvdata(7+3*kc,:)
                wold = sump(nv,w_w)
                if (wold.ne.0) then
                   jc = kc
                   exit
                endif
             endif
          enddo
       endif
       !
       if (wold.eq.0) then
          write(chain,'(A,I6,A)') 'Channel ',jc, ' has zero weight'
          hbeam%r3d(:,:,kb) = 0
          do kc=firstchanblock,lastchanblock
             hdirty%r3d(:,:,kc) = 0
          end do
          walls(kb) = 0.0
          if (nbeam.eq.1) then
             call map_message(seve%e,rname,chain)
             error = .true.
          else
             call map_message(seve%w,rname,chain)
          endif
          !
          ! One should release the Lock if only one beam is needed...
          cycle
       else
          wall = 1e-3/sqrt(wold)
          !!write(chain,'(a,i6,a)') 'Plane ',ic,' Natural '
          !!call prnoise('UV_MAP',trim(chain),wall,rms)
          walls(kb) = wall
       endif
       !
       ! Compute the weights from this
       !
       if (compute_weight) then
          local_error = .false.
          call doweig (nu,nv,   &
               &    uvdata,   &          ! Visibilities
               &    1,2,    &            ! U, V pointers
               &    jc,     &            ! Weight channel
               &    map%uniform(1),   &  ! Uniform UV cell size
               &    w_weight,   &        ! Weight array
               &    map%uniform(2),   &  ! Fraction of weight
               &    w_v,              &  ! V values
               &    local_error,      &
               &    grid_code)           ! Gridding method (for tests)
          if (local_error)  then
             error = .true.
             ! One should release the Lock if only one beam is needed...
             cycle
          endif
          !
          ! Should also plug the TAPER here, rather than in DOFFT later  !
          call dotape (nu,nv,   &
               &    uvdata,   &          ! Visibilities
               &    1,2,   &             ! U, V pointers
               &    map%taper,  &        ! Taper
               &    w_weight)            ! Weight array
          !
          ! Re-normalize the weights and re-count the noise
          wall = sump(nv,w_weight)
          if (wall.ne.wold) call scawei (nv,w_weight,w_w,wall)
          !
          ! Declare the weight ready
          if (nbeam.eq.1) then
             if (do_weig) r_weight = w_weight
             !$ if (omp%uvmap_lock) then
             !$ print *,'Thread ',ithread,' Unsetting LCK Weight ',do_weig, compute_weight
             !$ call omp_unset_lock(lck_weight)  ! Release the lock
             !$ endif
          endif
       else
          !$  if (nbeam.eq.1 .and. omp%uvmap_lock) then
          !$    if (omp%debug) print *,'Thread ',ithread,' waiting for lck_weight ',do_weig
          !$    call omp_set_lock(lck_weight)    ! Wait for the Lock to be grasped
          !$    if (omp%debug) print *,'Thread ',ithread,' got lck_weight ',do_weig
          !$    call omp_unset_lock(lck_weight)  ! and free it immediately
          !$  endif
          chain = 'Reusing weights'
          !$ write(chain(20:),'(a,i4)') ' - Thread ',ithread
          call map_message(seve%i,cname,chain)
          w_weight = r_weight
          !
          wall = sump(nv,w_weight)
          if (wall.ne.wold) call scawei (nv,w_weight,w_w,wall)
       endif
       !
       wall = 1e-3/sqrt(wall)
       write(chain,'(a,i6,a)') 'Plane ',ic,' Expected '
       call prnoise(cname,trim(chain),wall,rms)
       walls(kb) = wall
       !
       ! Then compute the Dirty Beam
       if (rcol.eq.0) then
          local_freq = gdf_uv_frequency(huv, dble(ic))
       else
          local_freq = freq
       endif
       uvcell = map%uvcell * (freq / local_freq)
       support = map%support * (freq / local_freq)
       !
       call docoor (lx,-uvcell(1),w_mapu)
       call docoor (ly,uvcell(2),w_mapv)
       !
       ! Optionally remove the Clean components
       icmax = 0
       !
       if (maxic.ne.0) then
          ! Compact the Clean components first
          call uv_clean_sizes(hcct,hcct%r3d,mic,ic,lc)
          icmax = maxval(mic)
          if (icmax.ne.0) then
             call uv_squeeze_clean(nchan,hcct%r3d,ccou, mic,ic,lc)
             freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
             if (do_slow) then
                call uv_removes_clean(huv,uvdata,ouv,kz,mic,ccou,freq,ic,lc)
                !!print *,'Done remove clean SLOW'
             else
                call uv_removef_clean(hdirty,uvdata,ouv,kz,mic,ccou,freq,ic,lc)
                !!print *,'Done remove clean FAST'
             endif
          else
             if (do_copy) call uv_extract_clean(uvdata,ouv,kz,ic,lc)
             call map_message(seve%w,cname,'No valid Clean Component')
          endif
          !$  elapsed_e = omp_get_wtime()
          !$  elapsed = elapsed_e - elapsed_s
          !$  write(chain,'(a,f9.2,a)') 'Finished Subtract Clean ',elapsed
          !$  call map_message(seve%i,cname,chain)
       else if (do_copy) then
          call uv_extract_clean(uvdata,ouv,kz,ic,lc)
       endif
       !
       if (.not.do_copy .and. icmax.eq.0) then
          !$ if (omp%debug) print *,'No copy '
          !
          ! Compute FFT's
          call dofft (nu,nv,          &   ! Size of visibility array
               &    uvdata,           &   ! Visibilities
               &    1,2,              &   ! U, V pointers
               &    ic,               &   ! First channel to map
               &    kz,lx,ly,         &   ! Cube size
               &    tfgrid,           &   ! FFT cube
               &    w_mapu,w_mapv,    &   ! U and V grid coordinates
               &    support,uvcell,null_taper, &  ! Gridding parameters
               &    w_weight,w_v,     &    ! Weight array + V Visibilities
               &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
       else
          !$ if (omp%debug) print *,'With copy '
          call dofft (no,nv,          &   ! Size of visibility array
               &    ouv,              &   ! Visibilities
               &    1,2,              &   ! U, V pointers
               &    1,                &   ! First channel to map
               &    kz,lx,ly,         &   ! Cube size
               &    tfgrid,           &   ! FFT cube
               &    w_mapu,w_mapv,    &   ! U and V grid coordinates
               &    support,uvcell,null_taper, &  ! Gridding parameters
               &    w_weight,w_v,     &    ! Weight array + V Visibilities
               &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
       endif
       !
       ! *** Compute the beam only if needed ***
       ! **** Put a LOCK around this in case of only One Beam but multi-thread ****
       !
       kz1 = kz+1
       call extracs(kz1,nx,ny,kz1,tfgrid,ftbeam,lx,ly)
       call fourt  (ftbeam, nn,ndim,-1,1,local_wfft)
       beam = 0.0
       call cmtore (ftbeam, beam ,nx,ny)
       call chkfft (beam, nx,ny, error)
       !!print *,'NU,NV ',nu,nv
       !!print *,'IC ',ic
       !!print *,'KZ,LX,LY ',kz,lx,ly
       !!print *,'support ',support,' uvcell ',uvcell, ' null_taper ',null_taper
       !!print *,'conv%ubias,conv%vbias,map%ctype ',conv%ubias,conv%vbias,map%ctype
       !!print *, ' '
       if (error) then
          print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1),' NO ',no
          print *,'Local freq ',local_freq
          print *,'KZ, LX, LY ', kz,lx,ly, ' nx,ny ',nx,ny, ' Schunk ',schunk
          call map_message(seve%e,rname,'Inconsistent pixel size')
          cycle
       endif
       !
       ! Compute grid correction,
       ! Normalization factor is applied to grid correction, for further
       ! use on channel maps.
       !
       !
       ! Make beam, not normalized
       call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,beam)  ! grid correction
       !
       ! Normalize and Free beam
       call docorr (beam,w_grid,nx*ny)
       !
       ! Fit beam if needed
       if (do_cct) then
          my_method%bzone=[1,1,nx,ny]
          call maxmap(beam,nx,ny,my_method%bzone,   &
               &      bmax,ix_max,iy_max,   &
               &      bmin,ix_min,iy_min)
          my_method%beam0 = [ix_max,iy_max]
          my_method%ibeam = kb
          !$OMP CRITICAL
          if (ic.eq.fcol) then
             fname = rname  ! print beam
          else
             fname = ' '    ! Do not print beam
          endif
          call fibeam (fname,beam,nx,ny,   &
               &    my_method%patch(1),my_method%patch(2),my_method%thresh,   &
               &    my_method%major,my_method%minor,my_method%angle,   &
               &    hbeam%gil%convert,error)
          !
          my_major = my_method%major
          my_minor = my_method%minor
          my_angle = my_method%angle
          ! print *,'fit results ',my_method%major, my_method%minor, my_method%angle
          !$OMP END CRITICAL
       endif
       !
       !
       ! *** End of LOCK in case of One Beam ***
       ! Wait for gridding correction to be computed
       !    if (nbeam.eq.1) then
       !      !$   if (ic.eq.fcol) then
       !      !$     print *,'Thread ',ithread,' freeing lck_grid'
       !      !$     call omp_unset_lock(lck_grid)  ! Release the lock
       !      !$   else
       !      !$     print *,'Thread ',ithread,' waiting for lck_grid'
       !      !$     call omp_set_lock(lck_grid)    ! Wait for the Lock to be grasped
       !      !$     print *,'Thread ',ithread,' got lck_grid'
       !      !$     call omp_unset_lock(lck_grid)  ! and free it immediately
       !      !$   endif
       !    endif
       ! *** End of One Beam region ***
       !
       ! Write beam
       hbeam%r3d(:,:,kb) = beam
       !
       ! Now extracts the Image planes...
       do iz=1,kz
          call extracs(kz+1,nx,ny,iz,tfgrid,ftbeam,lx,ly)
          call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
          call cmtore (ftbeam,beam,nx,ny)
          call docorr (beam,w_grid,ndata)
          ! Write the subset
          kc = ic-fcol+iz
          hdirty%r3d(:,:,kc) = beam
          !
          if (do_cct) then
             ! And add the Clean Components
             ! Recover the component list in pixels
             niter = mic(iz)
             do icc = 1,mic(iz)
                ! The NINT is required because of rounding errors
                p_cct(icc)%ix = nint( (ccou(1,icc,iz)-hdirty%gil%convert(2,1)) /  &
                     &        hdirty%gil%convert(3,1) + hdirty%gil%convert(1,1))
                p_cct(icc)%iy = nint( (ccou(2,icc,iz)-hdirty%gil%convert(2,2)) /  &
                     &        hdirty%gil%convert(3,2) + hdirty%gil%convert(1,2))
                p_cct(icc)%value = ccou(3,icc,iz)
             enddo
             !
             ! Compute Clean image and add back residual
             if (niter.gt.0) then
                my_method%n_iter = niter
                call clean_make(my_method,hclean,hclean%r3d(:,:,kc),p_cct)
                hclean%r3d(:,:,kc) = hclean%r3d(:,:,kc) + hdirty%r3d(:,:,kc)
             else
                hclean%r3d(:,:,kc) = hdirty%r3d(:,:,kc)
             endif
             ! Make sure the next Clean Component is empty 
             if (niter.lt.maxic) p_cct(niter+1)%value = 0 ! Required
          endif
       enddo
       !
       !$  elapsed_e = omp_get_wtime()
       elapsed = elapsed_e - elapsed_s
       write(chain,103) 'End plane ',kc,' Time ',elapsed &
            & ,' Thread ',ithread
       call map_message(seve%d,cname,chain)
       !
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !$ if (nbeam.gt.1) call omp_set_num_threads(othread)
    if (error) return
    !
    if (nbeam.eq.1) do_weig = .false.
    !
    method%major = my_major
    method%minor = my_minor
    method%angle = my_angle
    !
    call gag_cpu(cpu1)
    !$  elapsed_e = omp_get_wtime()
    !$  elapsed = elapsed_e - elapsed_s
    if (elapsed.eq.0) then
       write(chain,102) 'Finished maps CPU ',cpu1-cpu0
    else
       write(chain,102) 'Finished maps Elapsed ',elapsed,'; CPU ',cpu1-cpu0
    endif
    call map_message(seve%i,rname,chain)
    !
    call map_minmax(hdirty)
    !
    wall = maxval(walls(1:nbeam))
    call prnoise(rname,'Expected',wall,rms)
    hdirty%gil%noise = wall
    hclean%gil%noise = wall ! Also for the Restored clean map
    !  !
    ! Delete scratch space
    error = .false.
    if (nbeam.ne.1)  deallocate(w_grid)
    if (allocated(tfgrid)) deallocate(tfgrid)
    if (allocated(ftbeam)) deallocate(ftbeam)
    if (allocated(w_xgrid)) deallocate(w_xgrid)
    if (allocated(w_ygrid)) deallocate(w_ygrid)
    return
    !
102 format(a,f9.2,a,f9.2)
103 format(a,i5,a,f9.2,a,i2,a,i2)
  end subroutine uvmap_and_restore
  !
  subroutine uv_removes_clean(huv,duv,ouv,nc,mic,dcct,freq,first,last,beams)
    use image_def
    use gbl_message
    !$ use omp_lib
    !-----------------------------------------------------------------
    ! MAPPING   Support for UV_RESTORE
    !     Compute visibilities for a UV data set according to a
    !     set of Clean Components , and remove them from the original
    !     UV table.
    !     Semi-Slow version using interpolation from pre-tabulated
    !     Sin/Cos, which could still be optimized
    !-----------------------------------------------------------------
    type(gildas),   intent(in)  :: huv   ! header of UV data set
    real,           intent(in)  :: duv(:,:)      ! UV data set
    integer,        intent(in)  :: nc         ! Number of channels
    integer,        intent(in)  :: mic(:)     ! Number of Clean Components
    real,           intent(out) :: ouv(:,:)     ! Extracted UV data set
    real,           intent(in)  :: dcct(:,:,:)   ! Clean component
    real(8),        intent(in)  :: freq       ! Apparent observing frequency
    integer,        intent(in)  :: first      ! First channel
    integer,        intent(in)  :: last       ! Last channel
    real, optional, intent(in)  :: beams(3) ! Mosaic primary beam (0 = single)
    !
    real(8) :: pidsur            ! 2*pi*D/Lambda
    real(8), parameter :: pi=3.14159265358979323846d0
    real(8), parameter :: f_to_k=2.d0*pi/299792458.d-6
    real(8) :: phase,cp,sp
    real(4) :: rvis,ivis,b2,dxy,value
    integer :: ii, ir, iw
    integer :: oi, or, ow
    integer :: ic,iv,jc,kc
    !
    integer :: nv    ! Number of visibilities
    integer :: no, icmax
    !
    pidsur = f_to_k * freq
    !
    nv = huv%gil%dim(2)  ! Number of Visibilities
    no = ubound(mic,1)
    if (no.lt.last-first+1 .or. no.gt.ubound(dcct,3)) then
       print *,'Remove Clean Slow dimension error ',no,last-first+1,ubound(dcct,3)
    endif
    icmax = maxval(mic)
    if (icmax.gt.ubound(dcct,2))  then
       print *,'Remove Clean Slow -- too many Clean Comp.',icmax,ubound(dcct,2)
    endif
    ! Mosaic : Get 1/e width from FWHM
    b2 = 0.
    if (present(beams)) then
       if (beams(1).ne.0.) b2 = 4.d0*log(2.d0)/beams(1)**2
    endif
    !
    ! Remove clean component from UV data set
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP    & SHARED(duv,ouv,dcct)  SHARED(pidsur,nv,first,last,mic) &
    !$OMP    & PRIVATE(iv,jc,ic,kc,ir,ii,iw,or,oi,ow,phase,rvis,ivis,cp,sp) &
    !$OMP    & PRIVATE(dxy,value) SHARED(b2,beams)
    !
    !$OMP DO SCHEDULE(DYNAMIC,1)
    do iv=1,nv
       ouv(1:7,iv) = duv(1:7,iv)
       do jc = first,last  ! Channels
          ir = 5+3*jc
          ii = 6+3*jc
          iw = 7+3*jc
          kc = jc-first+1
          or = 5+3*kc
          oi = 6+3*kc
          ow = 7+3*kc
          ouv(or,iv) = duv(ir,iv)
          ouv(oi,iv) = duv(ii,iv)
          do ic = 1,mic(kc)  ! Clean components
             if (dcct(3,ic,kc).ne.0) then
                if (b2.ne.0) then
                   ! In case of Mosaics, multiply by beam value
                   dxy = ((dcct(1,ic,kc)-beams(2))**2+(dcct(2,ic,kc)-beams(3))**2)*b2
                   if (dxy.gt.16.0) cycle ! Too faint anyway ...
                   value = dcct(3,ic,kc)*exp(-dxy)
                else
                   value = dcct(3,ic,kc)
                endif
                phase = (ouv(1,iv)*dcct(1,ic,kc) + ouv(2,iv)*dcct(2,ic,kc))*pidsur
                call cossin(phase,cp,sp)
                rvis = value*cp
                ivis = value*sp
                ouv(or,iv) = ouv(or,iv) - rvis   ! Subtract
                ouv(oi,iv) = ouv(oi,iv) - ivis
             else
                print *,'Premature end of work for channel ',jc
                exit ! End of work, jump to next channel
             endif
          enddo  ! Clean components
          ouv(ow,iv) = duv(iw,iv)
       enddo  ! Channels
    enddo ! Visibilities
    !$OMP END DO
    !$OMP END PARALLEL
  end subroutine uv_removes_clean
  !
  subroutine uv_squeeze_clean(nc,ccin,ccou,mic,first,last)
    use image_def
    !-----------------------------------------------------------------
    ! MAPPING   Support for UV_RESTORE
    !   Compact the component list by summing up all values at the
    !   same position in a range of channels.
    !   The output list has a transposed order
    !-----------------------------------------------------------------
    integer, intent(in)    :: nc          ! Number of channels
    real,    intent(in)    :: ccin(:,:,:) ! Initial Clean Component List
    real,    intent(out)   :: ccou(:,:,:) ! Resulting list
    integer, intent(inout) :: mic(:)      ! Number of Clean component per channel
    integer, intent(in)    :: first       ! First channel
    integer, intent(in)    :: last        ! Last channel
    !
    integer :: ii,jj,ic,jc
    integer :: ki    ! Number of different components per channel
    logical doit
    !
    ccou = 0
    !
    do ic=first,last
       jc = ic-first+1
       ki = 0
       do ii=1,mic(jc)
          if (ccin(3,ic,ii).eq.0) then
             exit
          else
             doit = .true.
             do jj=1,ki
                if (ccou(1,jj,jc).eq.ccin(1,ic,ii)) then
                   if (ccou(2,jj,jc).eq.ccin(2,ic,ii)) then
                      doit = .false.
                      ccou(3,jj,jc) = ccou(3,jj,jc) + ccin(3,ic,ii)
                      exit
                   endif
                endif
             enddo
             if (doit) then
                ki = ki+1
                ccou(1:3,ki,jc) = ccin(1:3,ic,ii)
             endif
          endif
       enddo
       mic(jc) = ki
    enddo
  end subroutine uv_squeeze_clean
  !
  subroutine uv_removef_clean(hdirty,duv,ouv,nc,mic,dcct,freq,first,last,beams)
    use image_def
    !$ use omp_lib
    !-----------------------------------------------------------------
    ! MAPPING   Support for UV_RESTORE
    !     Compute visibilities for a UV data set according to a
    !     set of Clean Components , and remove them from the original
    !     UV table
    !   This version is for tranpose CCT data (3,ncomp,nchannels)
    !   and uses an intermediate FFT for speed
    !-----------------------------------------------------------------
    type(gildas),   intent(in)  :: hdirty       ! header of Dirty image
    integer,        intent(in)  :: nc           ! Number of channels
    integer,        intent(in)  :: mic(:)       ! Number of Clean Components
    real,           intent(in)  :: duv(:,:)     ! Input visibilities
    real,           intent(out) :: ouv(:,:)     ! Output visibilities
    real,           intent(in)  :: dcct(:,:,:)  ! Clean components
    real(8),        intent(in)  :: freq         ! Apparent observing frequency
    integer,        intent(in)  :: first        ! First
    integer,        intent(in)  :: last         ! and last channel
    real, optional, intent(in)  :: beams(3)     ! Mosaic primary beam (in radians)
    !
    integer :: nv    ! Number of visibilities
    integer :: mv    ! Size of a visibility
    integer :: nx,ny
    integer :: mx,my
    integer :: kx,ky
    real :: rx,ry,b2,dxy
    real :: value
    complex, allocatable :: cfft(:,:,:)
    real, allocatable :: comp(:,:), work(:)
    integer :: iplane,ic,ix,iy,iv,ier, dim(2)
    logical :: error
    real(8) :: xinc, yinc, xref, yref, xval, yval
    real(8), parameter :: pi=3.14159265358979323846d0
    !
    nv = ubound(duv,2)    ! Number of Visibilities
    mv = 7+3*nc
    mx = hdirty%gil%dim(1)
    my = hdirty%gil%dim(2)
    !
    ! Define the image size
    rx = log(float(mx))/log(2.0)
    kx = nint(rx)
    if (kx.lt.rx) kx = kx+1
    nx = 2**kx
    ry = log(float(my))/log(2.0)
    ky = nint(ry)
    if (ky.lt.ry) ky = ky+1
    ny = 2**ky
    kx = max(nx,ny)
    kx = min(4*kx,4096)
    !
    ! If the image is already fine enough, use it "as is"
    !    even if it is not a power of two...
    nx = max(kx,mx)  ! max(kx,nx) for power of two
    ny = max(kx,my)  ! max(kx,ny) for power of two
    !
    ! Get Virtual Memory & compute the FFT
    allocate(comp(mx,my),cfft(nx,ny,nc),work(2*max(nx,ny)),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,'UV_RESTORE','uv_removef_clean -- allocation error')
       error = .true.
       return
    endif
    !
    xref = hdirty%gil%convert(1,1)
    yref = hdirty%gil%convert(1,2)
    xval = hdirty%gil%convert(2,1)
    yval = hdirty%gil%convert(2,2)
    xinc = hdirty%gil%convert(3,1)
    yinc = hdirty%gil%convert(3,2)
    dim = [nx,ny]
    !
    b2 = 0.
    if (present(beams)) then
       if (beams(1).ne.0.) b2 = 4.d0*log(2.d0)/beams(1)**2
    endif
    !  call fourt_plan(ftbeam,dim,2,1,1)
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(dcct,cfft) &
    !$OMP    & SHARED(nc,mic,nx,ny,mx,my,dim,xinc,yinc,xref,yref,xval,yval) &
    !$OMP    & PRIVATE(iplane,ic,ix,iy,value) PRIVATE(comp,work) &
    !$OMP    & PRIVATE(dxy) SHARED(b2,beams)
    !
    !$OMP DO
    do iplane=1,nc
       comp = 0.
       do ic=1,mic(iplane)
          if (dcct(3,ic,iplane).eq.0) exit
          !
          if (b2.ne.0) then
             ! In case of Mosaics, multiply by beam value
             dxy = ((dcct(1,ic,iplane)-beams(2))**2+(dcct(2,ic,iplane)-beams(3))**2)*b2
             if (dxy.gt.16.0) cycle ! Too faint anyway ...
             value = dcct(3,ic,iplane)*exp(-dxy)
          else
             value = dcct(3,ic,iplane)
          endif
          ! The NINT is required because of rounding errors
          ix = nint( (dcct(1,ic,iplane)-xval) / xinc + xref )
          iy = nint( (dcct(2,ic,iplane)-yval) / yinc + yref )
          comp(ix,iy) = comp(ix,iy) + value
       enddo
       !
       call plunge_real (comp,mx,my,cfft(:,:,iplane),nx,ny)
       ! FOURT is now Thread-safe for the non-FFTW version.
       call fourt(cfft(:,:,iplane),dim,2,1,1,work)
       call recent(nx,ny,cfft(:,:,iplane))
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !
    ! Extract the visibility subset
    do iv = 1,nv
       ouv(1:7,iv) = duv(1:7,iv)
       ouv(8:mv,iv) = duv(5+3*first:7+3*last,iv)
    enddo
    !
    ! Interpolate and subtract the model visibilities
    call do_smodel(ouv,mv,nv,cfft,nx,ny,nc,freq,xinc,yinc,1.0)
    !
    deallocate(comp,cfft)
  end subroutine uv_removef_clean
  !
  subroutine cossin(phase,rcos,rsin)
    !-------------------------------------------------------
    ! Semi-Fast,  Semi-accurate Sin/Cos pair computation
    ! using (not yet clever) interpolation from a precise
    ! loop-up table
    !
    ! A solution using Taylor expansion and symmetries
    ! would be faster and more accurate
    !-------------------------------------------------------
    real(8), intent(inout) :: phase
    real(8), intent(out)   :: rcos
    real(8), intent(out)   :: rsin
    !
    !!  integer, intent(inout) :: ier
    !!  real(8), intent(in) :: maxerr
    !!  real(8), intent(inout) :: themax
    !
    real(8), parameter :: pi=3.14159265358979323846d0
    integer, parameter :: mcos=2048
    integer, save :: ncos = 0
    real(8), save :: cosine(mcos)
    real(8), save :: sine(mcos)
    real(8), save :: rstep
    real(8) :: rdeg
    integer :: i
    logical :: minus
    !
    rcos = cos(phase)
    rsin = sin(phase)
    return
    !
    if (ncos.eq.0) then
       ncos = mcos
       rstep = 2.01d0*pi/mcos
       do i=1,ncos
          rdeg = (i-1)*rstep
          cosine(i) = cos(rdeg)
          sine(i) = sin(rdeg)
       enddo
    endif
    !
    if (phase.ge.0) then
       minus =.false.
       rdeg = modulo(phase,2.0d0*pi)+0.5d0*rstep
    else
       minus = .true.
       rdeg = modulo(-phase,2.0d0*pi)+0.5d0*rstep
    endif
    rdeg = rdeg/rstep
    i = int(rdeg)
    rdeg = rdeg - i
    i = i+1
    rcos = (1.0-rdeg)*cosine(i) + rdeg*cosine(i+1)
    rsin = (1.0-rdeg)*sine(i) + rdeg*sine(i+1)
    if (minus) rsin = -rsin
  end subroutine cossin
  !
  subroutine uv_extract_clean(duv,ouv,nc,first,last)
    !-----------------------------------------------------------------
    ! MAPPING   Support for UV_MAP  &  UV_RESTORE
    !     Extract a subset of visibilities
    !-----------------------------------------------------------------
    integer, intent(in)  :: nc       ! Number of channels
    real,    intent(in)  :: duv(:,:) ! Input visbilities
    real,    intent(out) :: ouv(:,:) ! Output visibilities
    integer, intent(in)  :: first    ! First channel
    integer, intent(in)  :: last     ! Last channel
    !
    integer :: iv, nv
    !
    nv = ubound(duv,2)                ! Number of Visibilities
    !
    do iv=1,nv
       ouv(1:7,iv) = duv(1:7,iv)
       ouv(8:,iv) = duv(5+3*first:7+3*last,iv)
    enddo
  end subroutine uv_extract_clean
  !
  subroutine uv_clean_sizes(hcct,ccin, mic, first, last)
    use image_def
    !-----------------------------------------------------------------
    ! MAPPING   Support for UV_RESTORE
    !   Compute the actual number of components
    !-----------------------------------------------------------------
    type(gildas), intent(in)  :: hcct        ! header of CCT data set
    real,         intent(in)  :: ccin(:,:,:) ! Clean component table
    integer,      intent(out) :: mic(:)      ! Number of iterations per channel
    integer,      intent(in)  :: first       ! First
    integer,      intent(in)  :: last        ! and last channel
    !
    integer :: nc
    integer :: ni, ki
    integer :: i,ic,jc
    !
    nc = hcct%gil%dim(2)
    ni = hcct%gil%dim(3)
    !
    mic(:) = ni ! Up to the last one
    do ic=first,last
       jc = ic-first+1
       ki = 0
       do i=1,ni
          if (ccin(3,ic,i).eq.0) then
             mic(jc) = i-1
             exit
          endif
       enddo
    enddo
  end subroutine uv_clean_sizes
  !
  subroutine do_smodel(visi,nc,nv,a,nx,ny,nf,freq,xinc,yinc,factor)
    !-----------------------------------------------------------------
    ! MAPPING   Support for UV_RESTORE
    !     Remove model visibilities from UV data set.
    !     Interpolate from a grid of values obtained by FFT before.
    !-----------------------------------------------------------------
    integer, intent(in)    :: nc ! Visibility size
    integer, intent(in)    :: nv ! Number of visibilities
    integer, intent(in)    :: nx ! X size
    integer, intent(in)    :: ny ! Y size
    integer, intent(in)    :: nf ! Number of frequencies
    real,    intent(inout) :: visi(:,:)  ! Computed visibilities
    real(8), intent(in)    :: freq       ! Effective frequency
    real,    intent(in)    :: factor     ! Flux factor
    complex, intent(in)    ::  a(:,:,:)  ! FFT
    real(8), intent(in)    :: xinc,yinc  ! Pixel sizes
    !
    integer :: i,if,ia,ja
    real(8), parameter :: clight=299792458d0
    real(8) :: kwx,kwy,stepx,stepy,lambda,xr,yr
    complex(8) :: aplus,amoin,azero,afin
    !
    lambda = clight/(freq*1d6)
    stepx = 1.d0/(nx*xinc)*lambda
    stepy = 1.d0/(ny*yinc)*lambda
    !
    ! Loop on visibility
    do i = 1, nv
       kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
       ia = int(kwx)
       if (ia.le.1) cycle
       if (ia.ge.nx) cycle
       kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
       ja = int(kwy)
       if (ja.le.1) cycle
       if (ja.ge.ny) cycle
       !
       xr = kwx - ia
       yr = kwy - ja
       do if=1,nf
          !
          ! Interpolate (X or Y first, does not matter in this case)
          aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
               &          - 2.d0*a(ia,ja+1,if) )*xr   &
               &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
               &          + a(ia,ja+1,if)
          azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
               &          - 2.d0*a(ia,ja,if) )*xr   &
               &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
               &          + a(ia,ja,if)
          amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
               &          - 2.d0*a(ia,ja-1,if) )*xr   &
               &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
               &          + a(ia,ja-1,if)
          ! Then Y (or X)
          afin = ( (aplus+amoin-2.d0*azero)   &
               &          *yr + aplus-amoin )*yr*0.5d0 + azero
          !
          visi(5+3*if,i) =  visi(5+3*if,i) - real(afin)*factor
          visi(6+3*if,i) =  visi(6+3*if,i) - imag(afin)*factor
       enddo
    enddo
  end subroutine do_smodel
  !
  !------------------------------------------------------------------------------
  !
  subroutine new_dirty_beam(error)
    use gkernel_interfaces
    use clean_types
    use uv_buffers
    use uvmap_buffers
    use clean_buffers
    use primary_buffers
    !---------------------------------------------------------------------------
    ! Needed when a new dirty map is computed by command uv_map
    !---------------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    if (allocated(clean%data)) deallocate(clean%data)
    call sic_delvariable('CLEAN',.false.,error)
    if (error) return
    clean%head%loca%size = 0
    !
    if (allocated(resid%data)) deallocate(resid%data)
    call sic_delvariable('RESIDUAL',.false.,error)
    if (error) return
    resid%head%loca%size = 0
    !
    if (allocated(cct%data)) deallocate(cct%data)
    call sic_delvariable('CCT',.false.,error)
    if (error) return
    cct%head%loca%size = 0
    !
    if (allocated(sky%data)) deallocate(sky%data)
    call sic_delvariable('SKY',.false.,error)
    if (error) return
    sky%head%loca%size = 0
  end subroutine new_dirty_beam
  !
  subroutine plunge_real(r,nx,ny,c,mx,my)
    !------------------------------------------------------------------------------
    ! Plunge a Real array into a Complex array
    !-----------------------------------------------------------------
    integer, intent(in)  :: nx,ny    ! Size of input array
    real,    intent(in)  :: r(nx,ny) ! Input real array
    integer, intent(in)  :: mx,my    ! Size of output array
    complex, intent(out) :: c(mx,my) ! Output complex array
    !
    integer :: i,j
    integer :: kx,ky,lx,ly
    !
    kx = nx/2+1
    lx = mx/2+1
    ky = ny/2+1
    ly = my/2+1
    !
    c = 0.0
    do j=1,ny
       do i=1,nx
          c(i-kx+lx,j-ky+ly) = cmplx(r(i,j),0.0)
       enddo
    enddo
  end subroutine plunge_real
  !
  subroutine recent(nx,ny,z)
    !------------------------------------------------------------------------------
    ! Recenters the Fourier Transform, for easier display. The present version
    ! will only work for even dimensions.
    !------------------------------------------------------------------------------
    integer, intent(in)    :: nx
    integer, intent(in)    :: ny
    complex, intent(inout) :: z(nx,ny)
    !
    integer :: i,j
    complex :: tmp
    !
    do j=1,ny/2
       do i=1,nx/2
          tmp = z(i+nx/2,j+ny/2)
          z(i+nx/2,j+ny/2) = z(i,j)
          z(i,j) = tmp
       enddo
    enddo
    !
    do j=1,ny/2
       do i=1,nx/2
          tmp = z(i,j+ny/2)
          z(i,j+ny/2) = z(i+nx/2,j)
          z(i+nx/2,j) = tmp
       enddo
    enddo
    !
    do j=1,ny
       do i=1,nx
          if (mod(i+j,2).ne.0) then
             z(i,j) = -z(i,j)
          endif
       enddo
    enddo
  end subroutine recent  
end module uvmap_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

subroutine directory(line,error)
!
! Defines the directory containing the imbfits raw data.
! Checks whether the directory exists and whether there are
! data in it.
!
! Called by: load_mira (in load.f90, MIRA command "file in")
! Input: command line from Mira (see "help file")
! Output: error flag.
!
!
   use mira
   use gildas_def
   use gkernel_types
   use gkernel_interfaces
   !
   implicit none
   !
   integer                           :: ier, lc, nc
   type(sic_descriptor_t)            :: desc
   character(len = *)                :: line
   character                         :: ch*256,file*256,out*256
   character(len = 256), allocatable :: tmpstr(:)
   character(len = 256)              :: comm
   logical                           :: case_both, case_in,   &
                                        case_new, case_out,   &
                                        error, ex
   integer(kind=8)                   :: class_idx_size
   !
   !
   if (.not.sic_present(0,1).and.sic_present(3,0)) then
      file = 'INPUT_FILE:'
      call sic_parsef(file,ch,' ',' ')
      if (trim(ch).eq.'INPUT_FILE:') then
         call gagout('No input file opened.')
      else
         call gagout('Input file: '//trim(ch))
      endif
      file = 'OUTPUT_FILE:'
      call sic_parsef(file,ch,' ',' ')
      if (trim(ch).eq.'OUTPUT_FILE:') then
         call gagout('No output file opened.')
      else
         call gagout('Output file: '//trim(ch))
      endif
      error = .false.
      return
   endif
   call sic_ch (line,0,1,ch,nc,.true.,error)
   case_in   = .false.
   case_out  = .false.
   case_both = .false.
   case_in   = (index(ch,'IN').ne.0.or.index(ch,'in').ne.0)
   case_out  = (index(ch,'OUT').ne.0.or.index(ch,'out').ne.0)
   case_both = (index(ch,'BOTH').ne.0.or.index(ch,'both').ne.0)
   if (.not.case_in.and..not.case_out.and..not.case_both) then
      call gagout ('E-FILE, IN, OUT or BOTH, please.')
      error = .true.
      return
   endif
   if (.not.sic_present(0,2)) then
      call gagout ('E-FILE, no default provided for directory')
      error = .true.
      return
   endif
   if (error) return
   if (case_in) then
      call sic_ch (line,0,2,ch,nc,.false.,error)
      ier = sic_getlog(ch)
      ier = sic_setlog('INPUT_FILE:',ch)
      call gag_directory(char(0),ch,tmpstr,nc,error)
      if (nc.le.0) then
         call gagout('E-FILE, input file does not exist or is empty.')
         error = .true.
         return
      endif
   else if (case_out) then
      if (sic_present(0,3)) then
         call sic_ch (line,0,3,ch,nc,.true.,error)
         call sic_upper(ch)
         case_new = index(ch,'NEW').ne.0
      else
         case_new = .false.
      endif
      call sic_ch (line,0,2,ch,nc,.true.,error)
      ier = sic_getlog(ch)
      if (sic_present(2,0)) then
         classoption = .false.
         comm = 'sic find '//ch
         call sic_descriptor('DIR',desc,ex)
         if (ex) call sic_delvariable('DIR',.false.,error)
         call exec_program(comm)
         call sic_get_inte('DIR%NFILE',nc,error)
         if (nc.lt.0) then
            ex = .false.
         else
            ex = .true.
         endif
      else
         classoption = .true.
         if (index(ch,'.').eq.0) ch = trim(ch)//'.30m'
         inquire(file=ch,exist=ex)
      endif
      ier = sic_setlog('OUTPUT_FILE:',ch)
      if (case_new) then
         if (ex) then
            call gagout('E-FILE, file already exists.')
            error = .true.
            return
         endif
      else if (.not.ex) then
         call gagout('E-FILE, file does not exist, use:')
         call gagout('       FILE OUT myFile NEW')
         error = .true.
         return
      endif
      out = 'OUTPUT_FILE:'
      ier = sic_getlog(out)
      lc = lenc(out)
      out = out(1:lc-1)//char(0)
      if (classoption) then
         obsnumber = 1
         ier = sic_getlog('CLASS_IDX_SIZE',class_idx_size)
         if (ier.eq.0) then
            call class_fileout_open(out,case_new,.false.,class_idx_size,.true.,error)
         else
            error = .true.
         endif
      else
         call writembfits(error)
      endif
      if (error) return
   else if (case_both) then
      ier = sic_getlog(ch)
      ier = sic_setlog('INPUT_FILE:',ch)
      ier = sic_setlog('OUTPUT_FILE:',ch)
   endif
   if (error) return
end subroutine directory

subroutine greg_grid(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_grid
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  GRID Step [/LABEL] [/ALTERNATE]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4), parameter :: optalter=1  ! /ALTERNATE
  !
  if (sic_present(optalter,0)) then
    call galac(line,error)
  else
    call gridmp(line,error)
  endif
  !
end subroutine greg_grid
!
subroutine gridmp(line,error)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gridmp
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  GRID Step [/LABEL]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  external :: gdraw
  ! Local
  character(len=*), parameter :: rname='GRID'
  real(kind=8), parameter :: precision=1.0d-10
  character(len=20) :: ch,steps
  character(len=80) :: chain
  real(kind=8) :: step,ra,dec,stepd
  integer(kind=4) :: i,nstep,imax,imin,nc,nra,ndec,raused,decused,ier
  real(kind=8), allocatable :: ralist(:),declist(:)
  integer(kind=4), parameter :: optlabel=2
  !
  nra = 0
  ndec = 0
  !
  steps = '15'  ! Default 15 deg
  call sic_ch(line,0,1,steps,nc,.false.,error)
  if (error)  return
  call sic_sexa(steps,nc,stepd,error)
  if (error)  return
  step = stepd*pi/180.d0
  if (step.eq.0.d0)  goto 20
  !
  ! Search for RA grid
  if (ramin.lt.0.d0) then
    imin = -int(-ramin/step)-1
  else
    imin = int(ramin/step)
  endif
  if (ramax.lt.0.d0) then
    imax = -int(-ramax/step)
  else
    imax = int(ramax/step)+1
  endif
  allocate(ralist(imax-imin+1),stat=ier)
  if (failed_allocate(rname,'RA list',ier,error))  return
  do i=imin,imax
    ra = dble(i)*step
    if (ra.le.ramin-precision .or. ra.ge.ramax+precision)  cycle
    !
    ra = max(ramin,min(ra,ramax))
    if (abs(ra-ramax).lt.precision) then
      if ((ramax-ramin-2.d0*pi).lt.precision) then
        if (gproj%type.eq.p_gnomonic .or. gproj%type.eq.p_ortho)  exit
      endif
    endif
    !
    nra = nra+1
    ralist(nra) = ra
  enddo
  !
  call gr_segm('MERIDIAN',error)
  do i=1,nra
    ra = ralist(i)
    call meridien(ra,grelocate,gdraw,error)
    if (error) then
      if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
        call sexag(ch,ra,24)
        chain = 'RA '//ch
      elseif (i_system.eq.type_un) then
        write(chain,100) 'absolute X',ra*180.d0/pi
      elseif (i_system.eq.type_ga) then
        write(chain,100) 'Lii',ra*180.d0/pi
      else
        write(chain,'(A)') 'System not supported'
      endif
      call greg_message(seve%w,'GRID',chain)
      error = .false.
    endif
  enddo
  call gtsegm_close(error)
  !
20 continue
  if (sic_present(0,2)) then
    call sic_ch(line,0,2,steps,nc,.false.,error)
    if (error)  return
    call sic_sexa(steps,nc,stepd,error)
    if (error)  return
    step = stepd*pi/180.d0
  endif  ! Else step unchanged
  if (step.eq.0.d0)  return
  !
  ! Search for DEC grid
  nstep = int(pi/step)/2
  allocate(declist(2*nstep+1))
  if (failed_allocate(rname,'DEC list',ier,error))  return
  do i=-nstep,nstep
    dec = dble(i)*step
    if (dec.le.decmin-precision .or. dec.ge.decmax+precision)  cycle
    !
    dec = max(decmin,min(dec,decmax))
    !
    ndec = ndec+1
    declist(ndec) = dec
  enddo
  !
  call gr_segm('PARALLEL',error)
  do i=1,ndec
    dec = declist(i)
    call parallele(dec,grelocate,gdraw,error)
    if (error) then
      if (i_system.eq.type_un) then
        write(chain,100) 'absolute Y',dec*180.d0/pi
      elseif (i_system.eq.type_eq .or. i_system.eq.type_ic) then
        call sexag(ch,dec,360)
        chain = 'Dec '//ch
      elseif (i_system.eq.type_ga) then
        write(chain,100) 'Bii',dec*180.d0/pi
      else
        write(chain,'(A)') 'System not supported'
      endif
      call greg_message(seve%w,'GRID',chain)
      error = .false.
    endif
    !
  enddo
  call gtsegm_close(error)
  !
  if (sic_present(optlabel,0)) then
    ! Labels
    decused = min(2,ndec)  ! Put RA labels on the 2nd parallel
    do i=1,nra
      call grid_label(gproj,ralist(i),declist(decused),.true.,error)
      if (error)  return
    enddo
    raused = max(nra-1,1)  ! Put DEC labels on the before last meridian
    do i=1,ndec
      if (i.eq.decused)  cycle  ! Avoid overlapping labels
      call grid_label(gproj,ralist(raused),declist(i),.false.,error)
      if (error)  return
    enddo
  endif
  !
100 format('Spline failed at ',a,1x,f12.6)
end subroutine gridmp
!
subroutine galac(line,error)
  use gbl_message
  use phys_const
  use gwcs_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>galac
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command GRID
  !  Plot a Lii/Bii grid onto a RA-DEC plot or Vice-Versa
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='GRID'
  real(kind=8), parameter :: precision=1.0d-10
  real(kind=8) :: angal,xpole,ypole,gxpole,gypole,dpole
  real(kind=8) :: a1,d1
  logical :: north_up
  type(projection_t) :: oldproj
  !
  ! Check if I know what to do
  if (i_system.eq.type_un) then
    call greg_message(seve%e,rname,'System is UNKNOWN')
    error = .true.
    return
  endif
  !
  ! Check if I know how to do it
  if (gproj%type.ne.p_gnomonic  .and. gproj%type.ne.p_ortho .and.  &
      gproj%type.ne.p_azimuthal .and. gproj%type.ne.p_stereo) then
    call greg_message(seve%w,rname,'Galactic-Equatorial not supported in '//  &
    'this projection')
    return
  endif
  !
  ! Change the projection center to appropriate one in alternate system
  if (i_system.eq.type_ic) then
    call greg_message(seve%w,rname,'Can not convert to ICRS')
    return
  elseif (i_system.eq.type_eq) then
    if (i_equinox.eq.equinox_null) then
      call greg_message(seve%w,rname,  &
        'Can not convert to Equatorial system with unset equinox')
      return
    endif
    ! Galactic coordinates of projection center
    call equ_gal(gproj%a0,gproj%d0,i_equinox,a1,d1,error)
    if (error)  return
    ! Find which pole is up
    if (gproj%type.eq.p_gnomonic .or. gproj%type.eq.p_ortho) then
      north_up = lever(pi*0.5d0,d1).gt.0.d0
    else
      north_up = .true.
    endif
    ! Equatorial coordinates of Galactic pole
    if (north_up) then
      call gal_equ(0.d0,pi*0.5d0,gxpole,gypole,i_equinox,error)
    else
      call gal_equ(0.d0,-pi*0.5d0,gxpole,gypole,i_equinox,error)
    endif
    if (error)  return
  elseif (i_system.eq.type_ga) then
    ! Equatorial coordinates of projection center. Use arbitrary equinox.
    call gal_equ(gproj%a0,gproj%d0,a1,d1,i_equinox_def,error)
    if (error)  return
    ! Find which pole is up
    if (gproj%type.eq.p_gnomonic .or. gproj%type.eq.p_ortho) then
      north_up = lever(pi*0.5d0,d1).gt.0.d0
    else
      north_up = .true.
    endif
    ! Galactic coordinates of pole
    if (north_up) then
      call equ_gal(0.d0,pi*0.5d0,i_equinox_def,gxpole,gypole,error)
    else
      call equ_gal(0.d0,-pi*0.5d0,i_equinox_def,gxpole,gypole,error)
    endif
    if (error)  return
  endif
  !
  ! Relative coordinates of alternate pole
  call abs_to_rel(gproj,gxpole,gypole,xpole,ypole,1)
  dpole = sqrt(xpole**2+ypole**2)
  if (dpole.ge.precision) then
    angal = atan2(xpole,ypole)
    if (.not.north_up) angal = pi+angal
  else
    angal = 0.d0
  endif
  !
  ! Change the projection to the alternate system
  oldproj = gproj
  i_system = 5-i_system
  call gwcs_projec(a1,d1,angal,gproj%type,gproj,error)
  call setrem
  call gridmp(line,error)
  !
  ! Change back the projection to the normal system
  i_system = 5-i_system
  gproj = oldproj
  call setrem
  !
end subroutine galac
!
subroutine meridien(ra,myrelocate,mydraw,error)
  use gildas_def
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>meridien
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  Plot the meridian at a given RA
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: ra          ! Right ascension of meridian
  external                    :: myrelocate  !
  external                    :: mydraw      !
  logical,      intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MERIDIAN'
  integer(kind=size_length), parameter :: nstep=21
  real(kind=8), parameter :: precision=1.0d-10
  real(kind=8) :: x(nstep),y(nstep),z,d(nstep),a(nstep),delta1
  real(kind=8) :: y1,y2,slope,ypole,sp,tp,cp
  integer(kind=4) :: i
  !
  select case (gproj%type)
  case (p_none)
    ! No projection. Straight line from (RA,DECMIN) to (RA,DECMAX)
    call relocate(ra,guy1)
    call draw(ra,guy2)
    !
  case (p_cartesian)
    ! Meridians are straight lines from South Pole to North pole
    call abs_to_rel(gproj,ra,-pi/2.d0,x(1),y(1),1)
    call abs_to_rel(gproj,ra, pi/2.d0,x(2),y(2),1)
    call relocate(x(1),y(1))
    call draw(x(2),y(2))
    !
  case (p_gnomonic)
    ! Gnomonic : Straight line from (RA,0) to Pole
    ypole = min(gproj%spole,gproj%npole)
    if (abs(gproj%angle).le.precision) then
      if (abs(ra-gproj%a0).lt.precision) then
        call relocate(0.d0,guy1)
        call draw(0.d0,guy2)
      elseif (abs(gproj%d0)-pi*0.5d0 .ge. -precision) then
        call abs_to_rel(gproj,ra,1.d0,x(1),y(1),1)
        slope = (y(1)-ypole) / x(1)
        y1 = (gux1-x(1))*slope + y(1)
        y2 = gux2*slope + ypole
        call relocate(gux1,y1)
        call draw(gux2,y2)
      elseif (abs(gproj%d0).gt.precision) then
        call abs_to_rel(gproj,ra,0.d0,x(1),y(1),1)
        slope = (y(1)-ypole) / x(1)
        y1 = (gux1-x(1))*slope + y(1)
        y2 = gux2*slope + ypole
        call relocate(gux1,y1)
        call draw(gux2,y2)
      else
        call abs_to_rel(gproj,ra,0.d0,x(1),y(1),1)
        call relocate(x(1),guy1)
        call draw(x(1),guy2)
      endif
    else
      call abs_to_rel(gproj,ra,pi*0.25d0,x(1),y(1),1)
      call abs_to_rel(gproj,ra,pi*0.45d0,x(2),y(2),1)
      if (x(2).ne.x(1)) then
        slope = (y(2)-y(1))/(x(2)-x(1))
        y1 = (gux1-x(1))*slope + y(1)
        y2 = (gux2-x(1))*slope + y(1)
        call relocate(gux1,y1)
        call draw(gux2,y2)
      else
        call relocate(x(1),guy1)
        call draw(x(1),guy2)
      endif
    endif
    !
  case (p_ortho)
    ! Orthographic : In general these are conics
    if (abs(ra-gproj%a0).le.precision) then
      sp = sin(gproj%angle)
      cp = cos(gproj%angle)
      if (gproj%d0.ge.0.d0) then
        call relocate(-sp,-cp)
        call draw(gproj%npole*sp,gproj%npole*cp)
      else
        call relocate(-sp,-cp)
        call draw(gproj%spole*sp,gproj%spole*cp)
      endif
    elseif (abs(abs(ra-gproj%a0)-pi).le.precision) then
      sp = sin(gproj%angle)
      cp = cos(gproj%angle)
      if (gproj%d0.ge.0.d0) then
        call relocate(sp,cp)
        call draw(gproj%npole*sp,gproj%npole*cp)
      else
        call relocate(sp,cp)
        call draw(gproj%spole*sp,gproj%spole*cp)
      endif
    else
      goto 1000
    endif
    !
  case (p_azimuthal)
    ! Azimuthal (Schmidt)
    if (abs(ra-gproj%a0).le.precision) then
      sp = pi*sin(gproj%angle)
      cp = pi*cos(gproj%angle)
      call relocate(-sp,-cp)
      call draw(sp,cp)
    else
      do i=1,nstep
        d(i) = (2*i-nstep-1)*(pi*0.5d0-precision)/(nstep-1)
        a(i) = ra
      enddo
      call abs_to_rel(gproj,a,d,x,y,nstep)
      call plcurv(nstep,x,y,z,accurd,'CUBIC_SPLINE','POLYGONAL_LENGTH',.false.,  &
        myrelocate,mydraw,error)
    endif
    !
  case (p_stereo)
    ! Stereo
    if (abs(ra-gproj%a0).le.precision) then
      tp = tan(gproj%angle)
      call relocate(guy1*tp,guy1)
      call draw(guy2*tp,guy2)
    elseif (pi-abs(ra-gproj%a0).le.precision) then
      continue
    elseif (abs(0.5*pi-abs(gproj%d0)).ge.precision) then
      do i=1,nstep
        d(i) = (2*i-nstep-1)*(pi*0.5d0-precision)/(nstep-1)
        a(i) = ra
      enddo
      call abs_to_rel(gproj,a,d,x,y,nstep)
      call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','NUMBERING',.false.,  &
      myrelocate,mydraw,error)
    else
      tp = 2*max(abs(gux1),abs(gux2),abs(guy1),abs(guy2))
      cp = tp*cos(gproj%angle+ra-gproj%a0)
      sp = tp*sin(gproj%angle+ra-gproj%a0)
      call relocate(0.0d0,0.0d0)
      call draw(sp,cp)
    endif
    !
  case (p_lambert)
    ! Lambert
    if (abs(ra-gproj%a0).le.precision) then
      sp = 2.0*sin(gproj%angle)
      cp = 2.0*cos(gproj%angle)
      call relocate(-sp,-cp)
      call draw(sp,cp)
    else
      do i=1,nstep
        d(i) = (2*i-nstep-1)*(pi*0.5d0-precision)/(nstep-1)
        a(i) = ra
      enddo
      call abs_to_rel(gproj,a,d,x,y,nstep)
      call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','POLYGONAL_LENGTH',  &
      .false.,myrelocate,mydraw,error)
    endif
    !
  case (p_aitoff,p_radio)
    ! Aitoff equal area : all sky is visible
    ! Stupid radio projection : in principle also...
    if (abs(ra-gproj%a0).lt.precision) then
      sp = sin(gproj%angle)
      cp = cos(gproj%angle)
      call relocate(gproj%spole*sp,gproj%spole*cp)
      call draw(gproj%npole*sp,gproj%npole*cp)
    else
      do i=1,nstep
        d(i) = (pi*0.5d0-precision)/(nstep-1)*(2*i-nstep-1)
        a(i) = ra
      enddo
      call abs_to_rel(gproj,a,d,x,y,nstep)
      call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','NUMBERING',.false.,  &
      myrelocate,mydraw,error)
    endif
    !
  case (p_mollweide)
    ! Meridians are arcs of ellipse
    do i=1,nstep
      d(i) = (pi*0.5d0)/(nstep-1)*(2*i-nstep-1)
      a(i) = ra
    enddo
    call abs_to_rel(gproj,a,d,x,y,nstep)
    call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','POLYGONAL_LENGTH',.false.,  &
      myrelocate,mydraw,error)
    !
  case (p_ncp)
    ! Meridians are straight lines from Equator to North pole
    call abs_to_rel(gproj,ra,   0.d0,x(1),y(1),1)
    call abs_to_rel(gproj,ra,pi/2.d0,x(2),y(2),1)
    call relocate(x(1),y(1))
    call draw(x(2),y(2))
    !
  case default
    call greg_message(seve%e,rname,'Kind of projection not supported')
    error = .true.
    return
    !
  end select
  return
  !
  ! Else go from Delta1 to PI/2 or from PI/2 to -Delta1, depending
  ! on whether the North or South poles are visible.
  !
1000 continue
  if (gproj%d0.ge.0.d0) then
    delta1 = atan (cos(ra-gproj%a0)*tan(gproj%d0-pi*0.5d0))
    do i=1,nstep
      d(i) = delta1 + (pi*0.5-delta1)/(nstep-1)*(i-1)
      a(i) = ra
    enddo
    call abs_to_rel(gproj,a,d,x,y,nstep)
    call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','NUMBERING',.false.,  &
     myrelocate,mydraw,error)
  else
    delta1 = atan (cos(ra-gproj%a0)*tan(pi*0.5d0+gproj%d0))
    do i=1,nstep
      d(i) = delta1 - (pi*0.5+delta1)/(nstep-1)*(i-1)
      a(i) = ra
    enddo
    call abs_to_rel(gproj,a,d,x,y,nstep)
    call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','NUMBERING',.false.,  &
     myrelocate,mydraw,error)
  endif
  !
end subroutine meridien
!
subroutine parallele(dec,myrelocate,mydraw,error)
  use gildas_def
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>parallele
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  Draw a parallel
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: dec         ! Declination
  external                    :: myrelocate  !
  external                    :: mydraw      !
  logical,      intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PARALLEL'
  integer(kind=size_length), parameter :: nstep=21
  real(kind=8), parameter :: precision=1.0d-10
  real(kind=8) :: x(nstep),y(nstep),z,d(nstep),a(nstep)
  real(kind=8) :: h,sp,cp
  integer(kind=4) :: i
  character(len=20) :: variable
  !
  select case (gproj%type)
  case (p_none)
    ! No projection: straight lines
    call relocate(gux1,dec)
    call draw(gux2,dec)
    !
  case (p_gnomonic)
    ! Gnomonic
    variable = 'POLYGONAL_LENGTH'
    goto 1000
    !
  case (p_ortho)
    ! Orthographic
    variable = 'NUMBERING'
    goto 1000
    !
  case (p_azimuthal,p_lambert)
    ! Azimuthal and Lambert
    if (dec.eq.pi*0.5d0) then
      sp = sin(gproj%angle)*gproj%npole
      cp = cos(gproj%angle)*gproj%npole
      call relocate(sp,cp)
      call draw(sp,cp)
    elseif (dec.eq.-pi*0.5d0) then
      sp = sin(gproj%angle)*gproj%spole
      cp = cos(gproj%angle)*gproj%spole
      call relocate(sp,cp)
      call draw(sp,cp)
    else
      variable = 'POLYGONAL_LENGTH'
      if (abs(dec+gproj%d0).le.precision) then
        h = min(max((gproj%a0-ramin),(ramax-gproj%a0)),pi-1.d1*precision)
      else
        h = min(max((gproj%a0-ramin),(ramax-gproj%a0)),pi)
      endif
      if (h.ne.pi) then
        do i=1,nstep
          a(i) = gproj%a0 + (2*i-nstep-1)*h/(nstep-1)
          d(i) = dec
        enddo
        call abs_to_rel(gproj,a,d,x,y,nstep)
        call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE',variable,.false.,  &
        myrelocate,mydraw,error)
      else
        do i=1,nstep-1
          a(i) = gproj%a0 + (2*i-nstep-1)*h/(nstep-1)
          d(i) = dec
        enddo
        call abs_to_rel(gproj,a,d,x,y,nstep-1)
        x(nstep) = x(1)
        y(nstep) = y(1)
        call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','POLYGONAL_LENGTH',  &
        .true.,myrelocate,mydraw,error)
      endif
    endif
    !
  case (p_stereo)
    ! Stereographic
    if (dec.eq.pi*0.5d0) then
      sp = sin(gproj%angle)*gproj%npole
      cp = cos(gproj%angle)*gproj%npole
      call relocate(sp,cp)
      call draw(sp,cp)
    elseif (dec.eq.-pi*0.5d0) then
      sp = sin(gproj%angle)*gproj%spole
      cp = cos(gproj%angle)*gproj%spole
      call relocate(sp,cp)
      call draw(sp,cp)
    else
      variable = 'POLYGONAL_LENGTH'
      if (abs(dec+gproj%d0).le.precision) then
        h = min(max((gproj%a0-ramin),(ramax-gproj%a0)),pi-0.01d0)
        variable = 'NUMBERING'
      else
        h = min(max((gproj%a0-ramin),(ramax-gproj%a0)),pi)
      endif
      if (h.ne.pi) then
        do i=1,nstep
          a(i) = gproj%a0 + (2*i-nstep-1)*h/(nstep-1)
          d(i) = dec
        enddo
        call abs_to_rel(gproj,a,d,x,y,nstep)
        call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE',variable,.false.,  &
        myrelocate,mydraw,error)
      else
        do i=1,nstep-1
          a(i) = gproj%a0 + (2*i-nstep-1)*h/(nstep-1)
          d(i) = dec
        enddo
        call abs_to_rel(gproj,a,d,x,y,nstep-1)
        x(nstep) = x(1)
        y(nstep) = y(1)
        call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','POLYGONAL_LENGTH',  &
        .true.,myrelocate,mydraw,error)
      endif
    endif
    !
  case (p_aitoff)
    variable = 'NUMBERING'
    h = min(max((gproj%a0-ramin),(ramax-gproj%a0)),pi)
    do i=1,nstep
      a(i) = gproj%a0 + (2*i-nstep-1)*h/(nstep-1)
      d(i) = dec
    enddo
    call abs_to_rel(gproj,a,d,x,y,nstep)
    call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE',variable,.false.,myrelocate,  &
    mydraw,error)
    !
  case (p_radio)
    call abs_to_rel(gproj,gproj%a0,dec,x(1),y(1),1)
    h = pi*cos(dec)
    call relocate(x(1)-h,y(1))
    call draw(x(1)+h,y(1))
    !
  case (p_mollweide,p_cartesian)
    ! Parallels are straight lines
    call abs_to_rel(gproj,gproj%a0-pi,dec,x(1),y(1),1)
    call abs_to_rel(gproj,gproj%a0+pi,dec,x(2),y(2),1)
    call relocate(x(1),y(1))
    call draw(x(2),y(2))
    !
  case (p_ncp)
    ! Parallels are ellipsoids centered on North pole
    do i=1,nstep
      a(i) = gproj%a0 + (2*i-nstep-1)*pi/(nstep-1)
      d(i) = dec
    enddo
    call abs_to_rel(gproj,a,d,x,y,nstep)
    call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE','NUMBERING',.false.,myrelocate,  &
      mydraw,error)
    !
  case default
    call greg_message(seve%e,rname,'Kind of projection not supported')
    error = .true.
    return
    !
  end select
  return
  !
  ! Determine up time
1000 continue
  if (abs(dec).gt.0.5*pi) return
  if (0.5*pi-abs(dec).lt.precision) then
    h = lever(dec,gproj%d0)
    if (h.lt.0.d0) return
    call abs_to_rel(gproj,gproj%a0,dec,x(1),y(1),1)
    call relocate(x(1),y(1))
    call draw(x(1),y(1))
    return
  endif
  h = lever(dec,gproj%d0)
  if (h.lt.0.d0) then
    return
  elseif (h.lt.precision) then
    call abs_to_rel(gproj,gproj%a0,dec,x(1),y(1),1)
    call relocate(x(1),y(1))
    call draw(x(1),y(1))
  elseif (h.gt.pi+precision .and. ipole.ne.0) then
    do i=1,nstep-1
      a(i) = gproj%a0 + (2*i-nstep-1)*pi/(nstep-1)
      d(i) = dec
    enddo
    call abs_to_rel(gproj,a,d,x,y,nstep-1)
    x(nstep)=x(1)
    y(nstep)=y(1)
    call plcurv (nstep,x,y,z,accurd,'CUBIC_SPLINE',variable,.true.,myrelocate,  &
     mydraw,error)
  elseif (gproj%type.eq.p_gnomonic) then
    h = min(max((gproj%a0-ramin),(ramax-gproj%a0)),0.8d0*h)
    do i=1,nstep
      a(i) = gproj%a0 + (2*i-nstep-1)*h/(nstep-1)
      d(i) = dec
    enddo
    call abs_to_rel(gproj,a,d,x,y,nstep)
    call plcurv(nstep,x,y,z,accurd,'CUBIC_SPLINE',variable,.false.,myrelocate,  &
     mydraw,error)
  else
    h = min(max((gproj%a0-ramin),(ramax-gproj%a0)),h)
    do i=1,nstep
      a(i) = gproj%a0 + (2*i-nstep-1)*h/(nstep-1)
      d(i) = dec
    enddo
    call abs_to_rel(gproj,a,d,x,y,nstep)
    call plcurv(nstep,x,y,z,accurd,'CUBIC_SPLINE',variable,.false.,myrelocate,  &
     mydraw,error)
  endif
  !
end subroutine parallele
!
subroutine grid_label(proj,ra,dec,dora,error)
  use gildas_def
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>grid_label
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(projection_t), intent(in)    :: proj    ! Projection description
  real(kind=8),       intent(in)    :: ra,dec  ! [rad]
  logical,            intent(in)    :: dora    ! Do RA or DEC?
  logical,            intent(inout) :: error   !
  ! Local
  real(kind=8) :: x,y,x1,x2,y1,y2,off,orien,shift,incsquare,lang
  character(len=commandline_length) :: comm
  character(len=64) :: text
  integer(kind=4) :: nc,oform
  !
  off = rad_per_sec/10.d0  ! +-0.1 arcsec to compute the tangent
  incsquare = gux*guy
  shift = 0.8d0*cdef/sqrt(abs(incsquare))  ! The label is furthered from the line by 0.8 char
  !
  if (dora) then
    ! Compute position of 2 near values along RA so that we can define
    ! the tangent
    call abs_to_rel(proj,ra,dec-off,x1,y1,1)
    call abs_to_rel(proj,ra,dec+off,x2,y2,1)
    !
    if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
      call gag_cflabh(text,ra*hang_per_rad*3600d0,nc,0,format_sexage_hour,.false.)
    else  ! type_ga, type_un
      call sic_spanum(text,ra*deg_per_rad,0,oform,nc,0.d0,15,5)
    endif
    !
  else
    ! Compute position of 2 near values along DEC so that we can define
    ! the tangent
    call abs_to_rel(proj,ra-off,dec,x1,y1,1)
    call abs_to_rel(proj,ra+off,dec,x2,y2,1)
    !
    if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
      call gag_cflabh(text,dec*sec_per_rad,nc,0,format_sexage_degree,.false.)
    else
      call sic_spanum(text,dec*deg_per_rad,0,oform,nc,0.d0,15,5)
    endif
    !
    !
  endif
  !
  orien = text_angle(x1,x2,y1,y2)
  if (incsquare.lt.0.d0) orien = -orien  ! Indirect trigonometric direction
  !
  ! Compute the position of the text, a bit away from its line
  call abs_to_rel(proj,ra,dec,x,y,1)
  lang = line_angle(x1,x2,y1,y2)
  x = x + shift*cos(lang)
  y = y + shift*sin(lang)
  !
  write(comm,'(A,F0.6,1X,F0.6,1X,3A,F0.4,A)')  &
    'DRAW TEXT ',x,y,'"',text(1:nc),'" 5 ',orien,' /USER RADIAN /CLIP'
  call gr_exec(comm)
  !
contains
  function line_angle(x1,x2,y1,y2)
    ! Return the angle of the line [x1,y1] to [x2,y2]
    real(kind=8) :: line_angle  ! [rad]
    real(kind=8), intent(in) :: x1,x2,y1,y2
    line_angle = modulo(atan2(y2-y1,x2-x1),pi)    ! Modulo in the range [0:pi[
    if (guy.gt.0.d0)  line_angle = line_angle-pi  ! Range [-pi:0[
  end function line_angle
  function text_angle(x1,x2,y1,y2)
    ! Return the angle so that text is perpendicular to the line
    ! [x1,y1] to [x2,y2]
    real(kind=8) :: text_angle  ! [deg]
    real(kind=8), intent(in) :: x1,x2,y1,y2
    real(kind=8) :: ang
    ang = atan2(y2-y1,x2-x1)*deg_per_rad-90.d0
    ! Modulo in the range [-90:+90[
    text_angle = modulo(ang+90.d0,180.d0)-90.d0
  end function text_angle
end subroutine grid_label

module imbfits_types
  use gildas_def
  use cfitsio_api
  use gkernel_types
  use eclass_types
  use imbfits_parameters
  use imbfits_file_type
  use imbfits_header_type
  use imbfits_backdata_type
  !
  ! HDUs description
  type imbfits_hdus_t
     integer(kind=4) :: n = 0  ! Number of HDUs in file (unused)
     integer(kind=4) :: nlead = 0  ! Position of first HDU of first subscan
     integer(kind=4) :: npersubscan = 0   ! Number of HDUs per subscan
     integer(kind=4) :: pos(mhdukinds)    ! Positions (abs or rel) of HDUs (per kind)
  end type imbfits_hdus_t
  !
  ! Primary
  type imbfits_primary_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_logi_0d_t) :: simple
     type(fits_inte_0d_t) :: bitpix
     type(fits_inte_0d_t) :: naxis
     type(fits_logi_0d_t) :: extend
     type(fits_char_0d_t) :: telescop
     type(fits_char_0d_t) :: origin
     type(fits_char_0d_t) :: creator
     type(fits_dble_0d_t) :: imbftsve
     type(fits_char_0d_t) :: instrume
     type(fits_char_0d_t) :: object
     type(fits_dble_0d_t) :: longobj
     type(fits_dble_0d_t) :: latobj
     type(fits_char_0d_t) :: timesys
     type(fits_dble_0d_t) :: mjd_obs
     type(fits_char_0d_t) :: date_obs
     type(fits_dble_0d_t) :: lst
     type(fits_char_0d_t) :: projid
     type(fits_char_0d_t) :: queue
     type(fits_dble_0d_t) :: exptime
     type(fits_inte_0d_t) :: n_obs
     type(fits_inte_0d_t) :: n_obsp
     type(fits_char_0d_t) :: obstype
     type(fits_inte_0d_t) :: nusefeed
     type(fits_inte_0d_t) :: totant
     type(fits_inte_0d_t) :: totsubr
     type(fits_inte_0d_t) :: totback
  end type imbfits_primary_t
  ! Scan header and table
  type imbfits_scan_header_t
     type(imbfits_header_t) :: desc
     ! Telescope and site
     type(fits_char_0d_t) :: telescop
     type(fits_dble_0d_t) :: telsize
     type(fits_dble_0d_t) :: sitelong
     type(fits_dble_0d_t) :: sitelat
     type(fits_dble_0d_t) :: siteelev
     ! Project
     type(fits_char_0d_t) :: projid
     type(fits_char_0d_t) :: obsid
     type(fits_char_0d_t) :: operator
     ! Scan
     type(fits_inte_0d_t) :: scannum
     type(fits_inte_0d_t) :: scandate  ! [GAG] Date associated to the scan (might differ from date_obs after midnight)
     ! Date and time
     type(fits_char_0d_t) :: date_obs
     type(fits_char_0d_t) :: date
     type(fits_dble_0d_t) :: mjd
     type(fits_dble_0d_t) :: lst
     type(fits_inte_0d_t) :: n_obs
     type(fits_inte_0d_t) :: exptime
     type(fits_char_0d_t) :: timesys
     type(fits_dble_0d_t) :: ut1utc
     type(fits_dble_0d_t) :: taiutc
     type(fits_dble_0d_t) :: etutc
     type(fits_dble_0d_t) :: gpstai
     ! Fixed source parameters
     type(fits_dble_0d_t) :: polex
     type(fits_dble_0d_t) :: poley
     type(fits_char_0d_t) :: object
     !type(fits_unkn_0d_t) :: sbas
     !type(fits_unkn_0d_t) :: sbasflag
     type(fits_char_0d_t) :: ctype1
     type(fits_char_0d_t) :: ctype2
     type(fits_char_0d_t) :: radesys
     type(fits_dble_0d_t) :: equinox
     type(fits_dble_0d_t) :: crval1
     type(fits_dble_0d_t) :: crval2
     type(fits_dble_0d_t) :: lonpole
     type(fits_dble_0d_t) :: latpole
     type(fits_dble_0d_t) :: longobj
     type(fits_dble_0d_t) :: latobj
     !type(fits_unkn_0d_t) :: calcode
     ! Moving source parameters
     type(fits_logi_0d_t) :: movefram
     type(fits_dble_0d_t) :: peridate
     type(fits_dble_0d_t) :: peridist
     type(fits_dble_0d_t) :: longasc
     type(fits_dble_0d_t) :: omega
     type(fits_dble_0d_t) :: inclinat
     type(fits_dble_0d_t) :: eccentr
     type(fits_dble_0d_t) :: orbepoch
     type(fits_dble_0d_t) :: orbeqnox
     type(fits_dble_0d_t) :: distance
     ! Switch mode
     type(fits_char_0d_t) :: swtchmod
     type(fits_inte_0d_t) :: noswitch
     type(fits_dble_0d_t) :: phasetim
     type(fits_dble_0d_t) :: wobthrow
     type(fits_inte_0d_t) :: wobdir ! ???
     type(fits_dble_0d_t) :: wobcycle
     type(fits_char_0d_t) :: wobmode
     !
     type(fits_inte_0d_t) :: nfebe
     ! Pointing and focus
     type(fits_dble_0d_t) :: p1
     type(fits_dble_0d_t) :: p2
     type(fits_dble_0d_t) :: p3
     type(fits_dble_0d_t) :: p4
     type(fits_dble_0d_t) :: p5
     type(fits_dble_0d_t) :: p7
     type(fits_dble_0d_t) :: p8
     type(fits_dble_0d_t) :: p9
     type(fits_dble_0d_t) :: rxhori
     type(fits_dble_0d_t) :: rxvert
     type(fits_dble_0d_t) :: third_re
     type(fits_dble_0d_t) :: zero_pol
     type(fits_dble_0d_t) :: phi_pol
     type(fits_dble_0d_t) :: eps_pol
     type(fits_dble_0d_t) :: col_sin
     type(fits_dble_0d_t) :: col_cos
     type(fits_char_0d_t) :: date_poi
     type(fits_dble_0d_t) :: p1cor
     type(fits_dble_0d_t) :: p2cor
     type(fits_dble_0d_t) :: p3cor
     type(fits_dble_0d_t) :: p4cor
     type(fits_dble_0d_t) :: p5cor
     type(fits_dble_0d_t) :: p7cor
     type(fits_dble_0d_t) :: p8cor
     type(fits_dble_0d_t) :: p9cor
     type(fits_dble_0d_t) :: rxhorico
     type(fits_dble_0d_t) :: rxvertco
     type(fits_dble_0d_t) :: focusx
     type(fits_dble_0d_t) :: focusy
     type(fits_dble_0d_t) :: focusz
     type(fits_dble_0d_t) :: p4corinc
     type(fits_dble_0d_t) :: p5corinc
     type(fits_char_0d_t) :: date_inc
     ! Weather and calibration
     type(fits_dble_0d_t) :: pressure
     type(fits_dble_0d_t) :: tambient
     type(fits_dble_0d_t) :: humidity
     type(fits_dble_0d_t) :: winddir
     type(fits_dble_0d_t) :: windvel
     type(fits_dble_0d_t) :: windvelm
     type(fits_char_0d_t) :: date_wea
     type(fits_dble_0d_t) :: refracti ! ???
     type(fits_dble_0d_t) :: thot
     type(fits_char_0d_t) :: date_hot
     type(fits_dble_0d_t) :: tiptauz
     type(fits_dble_0d_t) :: tiptaue
     type(fits_dble_0d_t) :: tiptauc
     type(fits_char_0d_t) :: date_tip
     ! ???
     type(fits_inte_0d_t) :: recon
     type(fits_inte_0d_t) :: reccntrl
  end type imbfits_scan_header_t
  type imbfits_scan_table_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_char_1d_t) :: sysoff
     type(fits_real_1d_t) :: xoffset
     type(fits_real_1d_t) :: yoffset
  end type imbfits_scan_table_t
  type imbfits_scan_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_scan_header_t) :: head
     type(imbfits_scan_table_t) :: table
  end type imbfits_scan_t
  ! Frontend header and scan
  type imbfits_front_header_t
     type(imbfits_header_t) :: desc
     !
     type(fits_inte_0d_t) :: scannum
     type(fits_char_0d_t) :: date_obs
     type(fits_char_0d_t) :: dewrtmod
     type(fits_dble_0d_t) :: dewang
     type(fits_inte_0d_t) :: febeband
     type(fits_inte_0d_t) :: febefeed
     type(fits_inte_0d_t) :: nusefeed
     type(fits_dble_0d_t) :: velosys
     type(fits_char_0d_t) :: specsys
     type(fits_char_0d_t) :: veloconv
     type(fits_char_0d_t) :: emirbeam
  end type imbfits_front_header_t
  type imbfits_front_table_t
     integer(kind=4) :: status = code_imbfits_init
     ! Frequency axis
     type(fits_char_1d_t) :: recname
     type(fits_char_1d_t) :: linename
     type(fits_dble_1d_t) :: restfreq
     ! Calibration
     type(fits_real_1d_t) :: beameff
     type(fits_real_1d_t) :: etafss
     type(fits_real_1d_t) :: gainimag
     type(fits_char_1d_t) :: sideband
     type(fits_dble_1d_t) :: sbsep
     type(fits_char_1d_t) :: widenar
     type(fits_real_1d_t) :: tcold
     type(fits_real_1d_t) :: thot
     ! Pixel description
     type(fits_inte_1d_t) :: ifeed
     type(fits_inte_1d_t) :: nofeeds
     type(fits_char_1d_t) :: pola
     ! Frequency axis
     type(fits_char_1d_t) :: doppler
     type(fits_real_1d_t) :: ifcenter
     type(fits_real_1d_t) :: bandwid
     type(fits_logi_1d_t) :: ifflipps ! ???
     type(fits_logi_1d_t) :: speclo   ! ???
     ! Brightness axis
     type(fits_char_1d_t) :: tscale
     ! Frequency switching
     type(fits_real_1d_t) :: frqthrow
     type(fits_real_1d_t) :: frqoff1
     type(fits_real_1d_t) :: frqoff2
  end type imbfits_front_table_t
  type imbfits_front_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_front_header_t) :: head
     type(imbfits_front_table_t) :: table
  end type imbfits_front_t
  ! Backend header and scan
  type imbfits_back_header_t
     type(imbfits_header_t) :: desc
     !
     type(fits_inte_0d_t) :: scannum
     type(fits_char_0d_t) :: date_obs
     type(fits_inte_0d_t) :: febeband
     type(fits_inte_0d_t) :: febefeed
     type(fits_inte_0d_t) :: nusefeed
     !type(fits_inte_0d_t) :: if1freqs ! ???
  end type imbfits_back_header_t
  type imbfits_back_table_t
     integer(kind=4) :: status = code_imbfits_init
     ! Channel information
     type(fits_inte_1d_t) :: part
     type(fits_inte_1d_t) :: refchan
     type(fits_inte_1d_t) :: chans
     type(fits_inte_1d_t) :: dropped
     type(fits_inte_1d_t) :: used
     ! Receiver information
     type(fits_inte_1d_t) :: pixel
     type(fits_char_1d_t) :: receiver
     type(fits_char_1d_t) :: band
     type(fits_char_1d_t) :: frontend  ! Frontend name to be used in telescope name (memory only)
     type(fits_char_1d_t) :: polar
     type(fits_logi_1d_t) :: dataflip  ! Data needs sign flip? (memory only)
     type(fits_inte_1d_t) :: ifront    ! Backpointer to frontend table (memory only)
     ! Frequency information
     type(fits_real_1d_t) :: reffreq
     type(fits_real_1d_t) :: spacing
     type(fits_char_1d_t) :: linename
  end type imbfits_back_table_t
  type imbfits_back_chunks_t
     ! Description of the chunks in the BACKEND table
     type(eclass_2inte2char_t)    :: eclass   ! Chunk equivalence classes
     integer(kind=4), allocatable :: used(:)  ! (Size Nchunks) Chunks used for those classes
     integer(kind=4), allocatable :: kind(:)  ! (Size Nset) See codes in stokesset_book_t
  end type imbfits_back_chunks_t
  type imbfits_back_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_back_header_t) :: head
     type(imbfits_back_table_t) :: table
     ! Derived data:
     logical :: polchunks  ! The table provides or not polarimetric chunks
     type(imbfits_back_chunks_t) :: chunks  ! NONE, AXIS, REAL, IMAG chunks description
  end type imbfits_back_t
  !
  ! Antenna slow traces
  type imbfits_antslow_header_t
     ! NB: this type for both antslow and antfast
     type(imbfits_header_t) :: desc
     !
     type(fits_inte_0d_t) :: scannum
     type(fits_inte_0d_t) :: obsnum
     type(fits_char_0d_t) :: date_obs
     type(fits_dble_0d_t) :: mjd_beg  ! [MJD] Duplicate of 'date_obs' (memory only)
     type(fits_char_0d_t) :: date_end
     type(fits_dble_0d_t) :: mjd_end  ! [MJD] Duplicate of 'date_end' (memory only)
     type(fits_char_0d_t) :: obstype
     type(fits_char_0d_t) :: substype
     type(fits_dble_0d_t) :: substime
     type(fits_char_0d_t) :: systemof
     type(fits_dble_0d_t) :: subsxoff
     type(fits_dble_0d_t) :: subsyoff
     ! Segment
     type(fits_char_0d_t) :: setype01
     type(fits_dble_0d_t) :: setime01
     type(fits_dble_0d_t) :: sexoff01
     type(fits_dble_0d_t) :: seyoff01
     type(fits_dble_0d_t) :: sexsta01
     type(fits_dble_0d_t) :: seysta01
     type(fits_dble_0d_t) :: sexend01
     type(fits_dble_0d_t) :: seyend01
     type(fits_dble_0d_t) :: sespes01
     type(fits_dble_0d_t) :: sespee01
     ! Doppler
     type(fits_dble_0d_t) :: dopplerc
     type(fits_dble_0d_t) :: obsvelrf
     ! Fast traces
     type(fits_inte_0d_t) :: tracerat
  end type imbfits_antslow_header_t
  type imbfits_antslow_table_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_dble_1d_t) :: mjd
     type(fits_dble_1d_t) :: lst
     type(fits_dble_1d_t) :: longoff
     type(fits_dble_1d_t) :: latoff
     type(fits_dble_1d_t) :: cazimuth
     type(fits_dble_1d_t) :: celevatio
     type(fits_inte_1d_t) :: traceflag
  end type imbfits_antslow_table_t
  ! Antenna fast traces
  type imbfits_antfast_table_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_dble_1d_t) :: mjd
     type(fits_dble_1d_t) :: azimuth
     type(fits_dble_1d_t) :: elevation
     type(fits_dble_1d_t) :: tracking_az
     type(fits_dble_1d_t) :: tracking_el
  end type imbfits_antfast_table_t
  !
  type imbfits_antslow_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_antslow_header_t) :: head
     type(imbfits_antslow_table_t)  :: table
  end type imbfits_antslow_t
  !
  type imbfits_antfast_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_antslow_header_t) :: head ! There is not yet an antfast header
     type(imbfits_antfast_table_t)  :: table
  end type imbfits_antfast_t
  !
  ! Derotator
  type imbfits_derot_header_t
     ! NB: this type for both antslow and antfast
     type(imbfits_header_t) :: desc
     !
     type(fits_inte_0d_t) :: scannum
     type(fits_inte_0d_t) :: obsnum
     type(fits_char_0d_t) :: date_obs
     type(fits_dble_0d_t) :: mjd_beg  ! [MJD] Duplicate of 'date_obs' (memory only)
     type(fits_char_0d_t) :: date_end
     type(fits_dble_0d_t) :: mjd_end  ! [MJD] Duplicate of 'date_end' (memory only)
     type(fits_dble_0d_t) :: substime
  end type imbfits_derot_header_t
  type imbfits_derot_table_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_dble_1d_t) :: mjd
     type(fits_char_1d_t) :: system
     type(fits_real_1d_t) :: fwant
     type(fits_real_1d_t) :: hwant
     type(fits_real_1d_t) :: swant
     type(fits_real_1d_t) :: fact
     type(fits_real_1d_t) :: hact
     type(fits_real_1d_t) :: sact
  end type imbfits_derot_table_t
  type imbfits_derot_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_derot_header_t) :: head
     type(imbfits_derot_table_t) :: table
  end type imbfits_derot_t
  !
  type imbfits_t
     type(imbfits_file_t)    :: file
     type(imbfits_hdus_t)    :: hdus
     type(imbfits_primary_t) :: primary
     type(imbfits_scan_t)    :: scan
     type(imbfits_front_t)   :: front
     type(imbfits_back_t)    :: back
     type(imbfits_derot_t)   :: derot    ! Derotator
     type(eclass_char_t)     :: seclass  ! Subscans equiv class
  end type imbfits_t
  !
  ! Type specific for the DATA column. Note that this is the only
  ! column we do not read entirely
  type imbfits_data_t
     integer(kind=4) :: ntime = 0  ! Number of 'time' rows read
     integer(kind=4) :: npix  = 0  !
     integer(kind=4) :: nchan = 0  ! Number of channels in first dimension of 'VAL'
     real(kind=4), pointer :: val(:,:,:) => null()  ! [nchan x npix x ntimes] The DATA block
     real(kind=4), pointer :: wei(:)     => null()  ! [nchan] The WEIGHT array (use the same for all channels and pixels)
  end type imbfits_data_t
  !
  type imbfits_subscan_t
     integer(kind=4) :: isub = 0           ! Subscan number
     logical         :: onsky = .false.    ! Was the subscan looking at sky?
     integer(kind=4) :: calkind = 0        ! 0: not a cal, 1: sky/hot/cold, 2: grid  ZZZ useless?
     type(imbfits_backdata_t) :: backdata  !
     type(imbfits_antslow_t)  :: antslow   ! slow traces
     type(imbfits_antfast_t)  :: antfast   ! fast traces
  end type imbfits_subscan_t
  !
  integer(kind=4), parameter :: mstokes=4
  integer(kind=4), parameter :: code_n=0
  integer(kind=4), parameter :: code_h=1
  integer(kind=4), parameter :: code_v=2
  integer(kind=4), parameter :: code_r=3
  integer(kind=4), parameter :: code_i=4
  type stokesset_book_t
    integer(kind=4) :: nstokes        ! Number of chunksets per stokeset
    integer(kind=4) :: kind(mstokes)  ! Kind of each chunkset
    integer(kind=4) :: iset(mstokes)  ! Number of each chunkset
    logical         :: found          ! Found a stokesset?
    integer(kind=4) :: next           ! Next chunkset after the stokeset
  end type stokesset_book_t
  !
end module imbfits_types
!
module imbfits_messaging
  use gbl_message
  !---------------------------------------------------------------------
  ! This module provides:
  !  - the usual seve%? severities from the Gildas kernel (no need
  !    to USE GBL_MESSAGE)
  !  - the imbfits specific severities which can be dynamically changed
  !    thanks to the appropriate command
  !---------------------------------------------------------------------
  !
  type :: imbfits_debug_message_t
    integer(kind=4) :: alloc
    integer(kind=4) :: other
  end type imbfits_debug_message_t
  !
  ! Set the default at startup:
  !  iseve%alloc = seve%d
  !  iseve%other = seve%d
  type(imbfits_debug_message_t) :: iseve = imbfits_debug_message_t(seve%d,seve%d)
  !
end module imbfits_messaging

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_uvmap_command(line,error)
  use wifisyn_interfaces, except_this=>wifisyn_uvmap_command
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  call wifisyn_uvmap_inter(error)
  if (error) return
!  call wifisyn_uvmap_pipe(error)
!  if (error) return
  !
end subroutine wifisyn_uvmap_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_uvmap_inter(error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvmap_inter
  use wifisyn_uv_buffer
  use wifisyn_cube_buffer
  use wifisyn_sic_buffer
  use wifisyn_transform_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  type(uv_t) :: uvtmp
  type(window_t) :: win
  character(len=*), parameter :: rname='UVMAP/INTER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  call wifisyn_message(seve%i,rname,'Interactive mode')
  !
  call wifisyn_setup_main(usermap,uvr,progmap,uvtmp,error)
  if (error) return
  win = progmap%win%cur(1)
  call wifisyn_uvgrid_main(code_shift,win,uvr,uvtmp,progmap,wifi,error)
  if (error) return
  call wifisyn_fft_wifi(code_inverse,code_space_uv,win,wifi,error)
  if (error) return
  call wifisyn_apodize_wifi_uv(code_inverse,progmap,wifi,error)
  if (error) return
  call wifisyn_fft_wifi(code_direct,code_space_uv,win,wifi,error)
  if (error) return
  call wifisyn_shift_wifi_uv(code_direct,progmap,wifi,error)
  if (error) return
  call wifisyn_fft_wifi(code_direct,code_space_xy,win,wifi,error)
  if (error) return
!!$  call wifisyn_apodize_wifi_xy(code_inverse,progmap,wifi,error)
!!$  if (error) return
  call wifisyn_wifi2visi_main(progmap,wifi,visi,error)
  if (error) return
  call wifisyn_fft_visi(code_inverse,win,visi,error)
  if (error) return
  call wifisyn_free_uv(uvtmp,error)
  if (error) return
  !
end subroutine wifisyn_uvmap_inter
!
subroutine wifisyn_uvmap_pipe(error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_uvmap_pipe
  use wifisyn_uv_buffer
  use wifisyn_cube_buffer
  use wifisyn_sic_buffer
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='UVMAP/PIPE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  call wifisyn_message(seve%i,rname,'Pipeline mode')
  !
  !
end subroutine wifisyn_uvmap_pipe
!
subroutine wifisyn_uvmap_cube_header(map,huv,itype,cube,error)
  use gbl_message
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_uvmap_cube_header
  use wifisyn_buffer_parameters
  use wifisyn_uv_types
  use wifisyn_gridding_types
  !-----------------------------------------------------
  ! @ private
  ! Set beam or dirty header
  ! Note: Contrary to MAPPING, we here copy the projection information also
  !       in the beam header.
  !-----------------------------------------------------
  type(map_t),     intent(in)    :: map
  type(uv_head_t), intent(in)    :: huv
  integer,         intent(in)    :: itype ! cube type (beam or dirty)
  type (gildas),   intent(inout) :: cube
  logical,         intent(inout) :: error
  !
  character(len=80) :: mess
  character(len=*), parameter :: rname='UVMAP/CUBE/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call gdf_copy_header(huv%file,cube,error)
  if (error)  return
  !
  if (itype.eq.code_buffer_beam) then
     ! 3rd axis
     cube%char%code(3) = ''
     cube%gil%faxi = 0
     cube%gil%ndim = 2
     cube%gil%dim(3) = 1
     cube%gil%ref(3) = 0
     cube%gil%val(3) = 0
     cube%gil%inc(3) = 0
     ! Noise section
     cube%gil%nois_words = 0
     ! Cube unit
     cube%char%unit = 'none'
  else if (itype.eq.code_buffer_dirty) then
     ! 3rd axis
     cube%char%code(3) = 'VELOCITY'
     cube%gil%faxi = 3
     cube%gil%ndim = 3
     cube%gil%dim(3) = map%win%cur(map%win%n)%last-map%win%cur(1)%first+1
     ! The input table is a tuv one
     cube%gil%ref(3) = huv%file%gil%ref(2) - map%win%cur(1)%first +1
     cube%gil%val(3) = huv%file%gil%voff
     cube%gil%inc(3) = huv%file%gil%vres
     ! Noise section
     cube%gil%nois_words = 2
     cube%gil%noise = map%noise%mod ! not fully clear *** JP
     ! Cube unit
     cube%char%unit = 'Jy/beam'
  else
     write(mess,'(a,i0)') 'Data type should be dirty or beam: ',itype
     call wifisyn_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  ! 1st axis
  cube%char%code(1) = 'RA'
  cube%gil%xaxi = 1
  cube%gil%dim(1) = map%axes(1)%a%sky%n
  cube%gil%ref(1) = map%axes(1)%a%sky%ref
  cube%gil%val(1) = map%axes(1)%a%sky%val
  cube%gil%inc(1) = map%axes(1)%a%sky%inc
  ! 2nd axis
  cube%char%code(2) = 'DEC'
  cube%gil%yaxi = 2
  cube%gil%dim(2) = map%axes(2)%a%sky%n
  cube%gil%ref(2) = map%axes(2)%a%sky%ref
  cube%gil%val(2) = map%axes(2)%a%sky%val
  cube%gil%inc(2) = map%axes(2)%a%sky%inc
  ! 4th axis
  cube%char%code(4) = ''
  cube%gil%dim(4) = 1
  cube%gil%ref(4) = 0
  cube%gil%val(4) = 0
  cube%gil%inc(4) = 0
  ! Projection information (assume equatorial system)
  cube%gil%proj_words = 9
  cube%gil%ra  = huv%file%gil%ra
  cube%gil%dec = huv%file%gil%dec
  cube%gil%lii = huv%file%gil%lii
  cube%gil%bii = huv%file%gil%bii
  cube%gil%ptyp = p_azimuthal ! Azimuthal (Sin)
  cube%gil%pang = map%shift%pang
  cube%gil%a0 = map%shift%a0
  cube%gil%d0 = map%shift%d0
  cube%char%syst = 'EQUATORIAL'
  ! Initialized extrema section
  cube%gil%extr_words = 10
  cube%gil%rmin = +1e38
  cube%gil%rmax = -1e38
  ! No beam yet
  cube%gil%reso_words = 0
  ! Others
  cube%char%type = 'GILDAS_IMAGE'
  cube%loca%size = cube%gil%dim(1)*cube%gil%dim(2)*cube%gil%dim(3)*cube%gil%dim(4)
  !
end subroutine wifisyn_uvmap_cube_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_library
  use cubedag_directory_type
  use cubeadm_setup
  use cubedag_snapshot
  use cubeadm_timing
  !
  public :: cubeadm_library_init,cubeadm_library_exit
  private
  !
contains
  !
  subroutine cubeadm_library_init(error)
    use gkernel_interfaces
    use cubedag_library
    use cubeformats_engine_types
    !---------------------------------------------------------------------
    ! Initialize the ADM library
    !---------------------------------------------------------------------
    logical, intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    logical :: autoreimport
    logical, parameter :: merge=.false.
    !
    ! Initialization of Directories list buffer
    call dir%init(error)
    if (error) return
    call dir%sicdef(error)
    if (error) return
    !
    call cubedag_library_init(error)
    if (error) return
    call cubeformats_types_register(cubset,error)
    if (error) return
    !
    ! Implicit import of the previous snapshot, if any
    autoreimport = .true.
    ier = sic_getlog('CUBE_REIMPORT_AUTO',autoreimport)
    if (autoreimport) then
      call cubedag_snapshot_reimport(cubedag_snapshot_dagname(),  &
                                    cubedag_snapshot_histname(),  &
                                    merge,                        &
                                    .true.,error)
      if (error) then
        ! We should not stop the program initialization...
        error = .false.
      endif
    endif
    !
    call cubeadm_timing_variables(error)
    if (error) return
    !
  end subroutine cubeadm_library_init
  !
  subroutine cubeadm_library_exit(error)
    use cubedag_library
    !---------------------------------------------------------------------
    ! Exit the ADM library
    !---------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubedag_library_exit(error)
    if (error) continue
  end subroutine cubeadm_library_exit

end module cubeadm_library
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--- Present sections --------------------------------------------------
!
subroutine pyclassfiller_set_presec(code,error)
  use class_api
  use pyclassfiller_data
  integer(kind=4), intent(in)    :: code
  logical,         intent(inout) :: error
  ! Local
  character(len=128) :: mess
  !
  if (code.lt.-mx_sec .or. code.gt.0) then
    write(mess,'(A,I0,A)')  'E-FILLER,  Invalid section code (got ',code,')'
    call gagout(mess)
    error = .true.
    return
  endif
  obs%head%presec(code) = .true.
end subroutine pyclassfiller_set_presec
!
!--- General -----------------------------------------------------------
!
subroutine pyclassfiller_set_gen_num(num,error)
  use pyclassfiller_data
  integer(kind=obsnum_length), intent(in) :: num
  logical, intent(inout) :: error
  obs%head%gen%num = num
end subroutine pyclassfiller_set_gen_num
!
subroutine pyclassfiller_set_gen_ver(ver,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: ver
  logical, intent(inout) :: error
  obs%head%gen%ver = ver
end subroutine pyclassfiller_set_gen_ver
!
subroutine pyclassfiller_set_gen_teles(teles,error)
  use pyclassfiller_data
  character(len=*), intent(in) :: teles
  logical, intent(inout) :: error
  obs%head%gen%teles = teles
end subroutine pyclassfiller_set_gen_teles
!
subroutine pyclassfiller_set_gen_dobs(dobs,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: dobs
  logical, intent(inout) :: error
  obs%head%gen%dobs = dobs
end subroutine pyclassfiller_set_gen_dobs
!
subroutine pyclassfiller_set_gen_dred(dred,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: dred
  logical, intent(inout) :: error
  obs%head%gen%dred = dred
end subroutine pyclassfiller_set_gen_dred
!
subroutine pyclassfiller_set_gen_kind(kind,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: kind
  logical, intent(inout) :: error
  obs%head%gen%kind = kind
end subroutine pyclassfiller_set_gen_kind
!
subroutine pyclassfiller_set_gen_qual(qual,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: qual
  logical, intent(inout) :: error
  obs%head%gen%qual = qual
end subroutine pyclassfiller_set_gen_qual
!
subroutine pyclassfiller_set_gen_scan(scan,error)
  use pyclassfiller_data
  integer(kind=obsnum_length), intent(in) :: scan
  logical, intent(inout) :: error
  obs%head%gen%scan = scan
end subroutine pyclassfiller_set_gen_scan
!
subroutine pyclassfiller_set_gen_subscan(subscan,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: subscan
  logical, intent(inout) :: error
  obs%head%gen%subscan = subscan
end subroutine pyclassfiller_set_gen_subscan
!
subroutine pyclassfiller_set_gen_ut(ut,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: ut
  logical, intent(inout) :: error
  obs%head%gen%ut = ut
end subroutine pyclassfiller_set_gen_ut
!
subroutine pyclassfiller_set_gen_st(st,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: st
  logical, intent(inout) :: error
  obs%head%gen%st = st
end subroutine pyclassfiller_set_gen_st
!
subroutine pyclassfiller_set_gen_az(az,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: az
  logical, intent(inout) :: error
  obs%head%gen%az = az
end subroutine pyclassfiller_set_gen_az
!
subroutine pyclassfiller_set_gen_el(el,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: el
  logical, intent(inout) :: error
  obs%head%gen%el = el
end subroutine pyclassfiller_set_gen_el
!
subroutine pyclassfiller_set_gen_tau(tau,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tau
  logical, intent(inout) :: error
  obs%head%gen%tau = tau
end subroutine pyclassfiller_set_gen_tau
!
subroutine pyclassfiller_set_gen_tsys(tsys,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tsys
  logical, intent(inout) :: error
  obs%head%gen%tsys = tsys
end subroutine pyclassfiller_set_gen_tsys
!
subroutine pyclassfiller_set_gen_time(time,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: time
  logical, intent(inout) :: error
  obs%head%gen%time = time
end subroutine pyclassfiller_set_gen_time
!
subroutine pyclassfiller_set_gen_xunit(xunit,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: xunit
  logical, intent(inout) :: error
  obs%head%gen%xunit = xunit
end subroutine pyclassfiller_set_gen_xunit
!
!--- Position ----------------------------------------------------------
!
subroutine pyclassfiller_set_pos_sourc(sourc,error)
  use pyclassfiller_data
  character(len=*), intent(in) :: sourc
  logical, intent(inout) :: error
  obs%head%pos%sourc = sourc
end subroutine pyclassfiller_set_pos_sourc
!
subroutine pyclassfiller_set_pos_system(system,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: system
  logical, intent(inout) :: error
  obs%head%pos%system = system
end subroutine pyclassfiller_set_pos_system
!
subroutine pyclassfiller_set_pos_equinox(equinox,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: equinox
  logical, intent(inout) :: error
  obs%head%pos%equinox = equinox
end subroutine pyclassfiller_set_pos_equinox
!
subroutine pyclassfiller_set_pos_proj(proj,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: proj
  logical, intent(inout) :: error
  obs%head%pos%proj = proj
end subroutine pyclassfiller_set_pos_proj
!
subroutine pyclassfiller_set_pos_lam(lam,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: lam
  logical, intent(inout) :: error
  obs%head%pos%lam = lam
end subroutine pyclassfiller_set_pos_lam
!
subroutine pyclassfiller_set_pos_bet(bet,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: bet
  logical, intent(inout) :: error
  obs%head%pos%bet = bet
end subroutine pyclassfiller_set_pos_bet
!
subroutine pyclassfiller_set_pos_projang(projang,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: projang
  logical, intent(inout) :: error
  obs%head%pos%projang = projang
end subroutine pyclassfiller_set_pos_projang
!
subroutine pyclassfiller_set_pos_lamof(lamof,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: lamof
  logical, intent(inout) :: error
  obs%head%pos%lamof = lamof
end subroutine pyclassfiller_set_pos_lamof
!
subroutine pyclassfiller_set_pos_betof(betof,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: betof
  logical, intent(inout) :: error
  obs%head%pos%betof = betof
end subroutine pyclassfiller_set_pos_betof
!
!--- Spectroscopy ------------------------------------------------------
!
subroutine pyclassfiller_set_spe_line(line,error)
  use pyclassfiller_data
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  obs%head%spe%line = line
end subroutine pyclassfiller_set_spe_line
!
subroutine pyclassfiller_set_spe_nchan(nchan,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: nchan
  logical, intent(inout) :: error
  obs%head%spe%nchan = nchan
end subroutine pyclassfiller_set_spe_nchan
!
subroutine pyclassfiller_set_spe_restf(restf,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: restf
  logical, intent(inout) :: error
  obs%head%spe%restf = restf
end subroutine pyclassfiller_set_spe_restf
!
subroutine pyclassfiller_set_spe_image(image,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: image
  logical, intent(inout) :: error
  obs%head%spe%image = image
end subroutine pyclassfiller_set_spe_image
!
subroutine pyclassfiller_set_spe_doppler(doppler,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: doppler
  logical, intent(inout) :: error
  obs%head%spe%doppler = doppler
end subroutine pyclassfiller_set_spe_doppler
!
subroutine pyclassfiller_set_spe_rchan(rchan,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: rchan
  logical, intent(inout) :: error
  obs%head%spe%rchan = rchan
end subroutine pyclassfiller_set_spe_rchan
!
subroutine pyclassfiller_set_spe_fres(fres,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: fres
  logical, intent(inout) :: error
  obs%head%spe%fres = fres
end subroutine pyclassfiller_set_spe_fres
!
subroutine pyclassfiller_set_spe_vres(vres,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: vres
  logical, intent(inout) :: error
  obs%head%spe%vres = vres
end subroutine pyclassfiller_set_spe_vres
!
subroutine pyclassfiller_set_spe_voff(voff,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: voff
  logical, intent(inout) :: error
  obs%head%spe%voff = voff
end subroutine pyclassfiller_set_spe_voff
!
subroutine pyclassfiller_set_spe_bad(bad,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: bad
  logical, intent(inout) :: error
  obs%head%spe%bad = bad
end subroutine pyclassfiller_set_spe_bad
!
subroutine pyclassfiller_set_spe_vtype(vtype,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: vtype
  logical, intent(inout) :: error
  obs%head%spe%vtype = vtype
end subroutine pyclassfiller_set_spe_vtype
!
subroutine pyclassfiller_set_spe_vconv(vconv,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: vconv
  logical, intent(inout) :: error
  obs%head%spe%vconv = vconv
end subroutine pyclassfiller_set_spe_vconv
!
!--- Switching ---------------------------------------------------------
!
subroutine pyclassfiller_set_swi_nphas(nphas,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: nphas
  logical, intent(inout) :: error
  obs%head%swi%nphas = nphas
end subroutine pyclassfiller_set_swi_nphas
!
subroutine pyclassfiller_set_swi_decal(decal,nelem,error)
  use class_api
  use pyclassfiller_data
  integer(kind=4), intent(in) :: nelem
  real(kind=8), intent(in) :: decal(nelem)
  logical, intent(inout) :: error
  ! Local
  character(len=128) :: mess
  !
  if (nelem.gt.mxphas) then
    write(mess,'(A,I0,A,I0,A)')  &
      'E-FILLER,  SWI%DECAL must have at most ',mxphas,' values (got ',nelem,')'
    call gagout(mess)
    error = .true.
    return
  endif
  obs%head%swi%decal(:) = 0
  obs%head%swi%decal(1:nelem) = decal(1:nelem)
end subroutine pyclassfiller_set_swi_decal
!
subroutine pyclassfiller_set_swi_duree(duree,nelem,error)
  use class_api
  use pyclassfiller_data
  integer(kind=4), intent(in) :: nelem
  real(kind=4), intent(in) :: duree(nelem)
  logical, intent(inout) :: error
  ! Local
  character(len=128) :: mess
  !
  if (nelem.gt.mxphas) then
    write(mess,'(A,I0,A,I0,A)')  &
      'E-FILLER,  SWI%DUREE must have at most ',mxphas,' values (got ',nelem,')'
    call gagout(mess)
    error = .true.
    return
  endif
  obs%head%swi%duree(:) = 0
  obs%head%swi%duree(1:nelem) = duree(1:nelem)
end subroutine pyclassfiller_set_swi_duree
!
subroutine pyclassfiller_set_swi_poids(poids,nelem,error)
  use class_api
  use pyclassfiller_data
  integer(kind=4), intent(in) :: nelem
  real(kind=4), intent(in) :: poids(nelem)
  logical, intent(inout) :: error
  ! Local
  character(len=128) :: mess
  !
  if (nelem.gt.mxphas) then
    write(mess,'(A,I0,A,I0,A)')  &
      'E-FILLER,  SWI%POIDS must have at most ',mxphas,' values (got ',nelem,')'
    call gagout(mess)
    error = .true.
    return
  endif
  obs%head%swi%poids(:) = 0
  obs%head%swi%poids(1:nelem) = poids(1:nelem)
end subroutine pyclassfiller_set_swi_poids
!
subroutine pyclassfiller_set_swi_swmod(swmod,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: swmod
  logical, intent(inout) :: error
  obs%head%swi%swmod = swmod
end subroutine pyclassfiller_set_swi_swmod
!
subroutine pyclassfiller_set_swi_ldecal(ldecal,nelem,error)
  use class_api
  use pyclassfiller_data
  integer(kind=4), intent(in) :: nelem
  real(kind=4), intent(in) :: ldecal(nelem)
  logical, intent(inout) :: error
  ! Local
  character(len=128) :: mess
  !
  if (nelem.gt.mxphas) then
    write(mess,'(A,I0,A,I0,A)')  &
      'E-FILLER,  SWI%LDECAL must have at most ',mxphas,' values (got ',nelem,')'
    call gagout(mess)
    error = .true.
    return
  endif
  obs%head%swi%ldecal(:) = 0
  obs%head%swi%ldecal(1:nelem) = ldecal(1:nelem)
end subroutine pyclassfiller_set_swi_ldecal
!
subroutine pyclassfiller_set_swi_bdecal(bdecal,nelem,error)
  use class_api
  use pyclassfiller_data
  integer(kind=4), intent(in) :: nelem
  real(kind=4), intent(in) :: bdecal(nelem)
  logical, intent(inout) :: error
  ! Local
  character(len=128) :: mess
  !
  if (nelem.gt.mxphas) then
    write(mess,'(A,I0,A,I0,A)')  &
      'E-FILLER,  SWI%BDECAL must have at most ',mxphas,' values (got ',nelem,')'
    call gagout(mess)
    error = .true.
    return
  endif
  obs%head%swi%bdecal(:) = 0
  obs%head%swi%bdecal(1:nelem) = bdecal(1:nelem)
end subroutine pyclassfiller_set_swi_bdecal
!
!--- Calibration -------------------------------------------------------
!
subroutine pyclassfiller_set_cal_beeff(beeff,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: beeff
  logical, intent(inout) :: error
  obs%head%cal%beeff = beeff
end subroutine pyclassfiller_set_cal_beeff
!
subroutine pyclassfiller_set_cal_foeff(foeff,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: foeff
  logical, intent(inout) :: error
  obs%head%cal%foeff = foeff
end subroutine pyclassfiller_set_cal_foeff
!
subroutine pyclassfiller_set_cal_gaini(gaini,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: gaini
  logical, intent(inout) :: error
  obs%head%cal%gaini = gaini
end subroutine pyclassfiller_set_cal_gaini
!
subroutine pyclassfiller_set_cal_h2omm(h2omm,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: h2omm
  logical, intent(inout) :: error
  obs%head%cal%h2omm = h2omm
end subroutine pyclassfiller_set_cal_h2omm
!
subroutine pyclassfiller_set_cal_pamb(pamb,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: pamb
  logical, intent(inout) :: error
  obs%head%cal%pamb = pamb
end subroutine pyclassfiller_set_cal_pamb
!
subroutine pyclassfiller_set_cal_tamb(tamb,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tamb
  logical, intent(inout) :: error
  obs%head%cal%tamb = tamb
end subroutine pyclassfiller_set_cal_tamb
!
subroutine pyclassfiller_set_cal_tatms(tatms,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tatms
  logical, intent(inout) :: error
  obs%head%cal%tatms = tatms
end subroutine pyclassfiller_set_cal_tatms
!
subroutine pyclassfiller_set_cal_tchop(tchop,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tchop
  logical, intent(inout) :: error
  obs%head%cal%tchop = tchop
end subroutine pyclassfiller_set_cal_tchop
!
subroutine pyclassfiller_set_cal_tcold(tcold,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tcold
  logical, intent(inout) :: error
  obs%head%cal%tcold = tcold
end subroutine pyclassfiller_set_cal_tcold
!
subroutine pyclassfiller_set_cal_taus(taus,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: taus
  logical, intent(inout) :: error
  obs%head%cal%taus = taus
end subroutine pyclassfiller_set_cal_taus
!
subroutine pyclassfiller_set_cal_taui(taui,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: taui
  logical, intent(inout) :: error
  obs%head%cal%taui = taui
end subroutine pyclassfiller_set_cal_taui
!
subroutine pyclassfiller_set_cal_tatmi(tatmi,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tatmi
  logical, intent(inout) :: error
  obs%head%cal%tatmi = tatmi
end subroutine pyclassfiller_set_cal_tatmi
!
subroutine pyclassfiller_set_cal_trec(trec,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: trec
  logical, intent(inout) :: error
  obs%head%cal%trec = trec
end subroutine pyclassfiller_set_cal_trec
!
subroutine pyclassfiller_set_cal_cmode(cmode,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: cmode
  logical, intent(inout) :: error
  obs%head%cal%cmode = cmode
end subroutine pyclassfiller_set_cal_cmode
!
subroutine pyclassfiller_set_cal_atfac(atfac,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: atfac
  logical, intent(inout) :: error
  obs%head%cal%atfac = atfac
end subroutine pyclassfiller_set_cal_atfac
!
subroutine pyclassfiller_set_cal_alti(alti,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: alti
  logical, intent(inout) :: error
  obs%head%cal%alti = alti
end subroutine pyclassfiller_set_cal_alti
!
subroutine pyclassfiller_set_cal_count(count,nelem,error)
  use class_api
  use pyclassfiller_data
  integer(kind=4), intent(in) :: nelem
  real(kind=4), intent(in) :: count(nelem)
  logical, intent(inout) :: error
  ! Local
  character(len=128) :: mess
  !
  if (nelem.ne.3) then
    write(mess,'(A,I0,A,I0,A)')  &
      'E-FILLER,  CAL%COUNT must have exactly ',3,' values (got ',nelem,')'
    call gagout(mess)
    error = .true.
    return
  endif
  obs%head%cal%count(:) = 0
  obs%head%cal%count(1:nelem) = count(1:nelem)
end subroutine pyclassfiller_set_cal_count
!
subroutine pyclassfiller_set_cal_lcalof(lcalof,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: lcalof
  logical, intent(inout) :: error
  obs%head%cal%lcalof = lcalof
end subroutine pyclassfiller_set_cal_lcalof
!
subroutine pyclassfiller_set_cal_bcalof(bcalof,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: bcalof
  logical, intent(inout) :: error
  obs%head%cal%bcalof = bcalof
end subroutine pyclassfiller_set_cal_bcalof
!
subroutine pyclassfiller_set_cal_geolong(geolong,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: geolong
  logical, intent(inout) :: error
  obs%head%cal%geolong = geolong
end subroutine pyclassfiller_set_cal_geolong
!
subroutine pyclassfiller_set_cal_geolat(geolat,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: geolat
  logical, intent(inout) :: error
  obs%head%cal%geolat = geolat
end subroutine pyclassfiller_set_cal_geolat
!
!--- Continuum Drift ---------------------------------------------------
!
subroutine pyclassfiller_set_dri_freq(freq,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: freq
  logical, intent(inout) :: error
  obs%head%dri%freq = freq
end subroutine pyclassfiller_set_dri_freq
!
subroutine pyclassfiller_set_dri_width(width,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: width
  logical, intent(inout) :: error
  obs%head%dri%width = width
end subroutine pyclassfiller_set_dri_width
!
subroutine pyclassfiller_set_dri_npoin(npoin,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: npoin
  logical, intent(inout) :: error
  obs%head%dri%npoin = npoin
end subroutine pyclassfiller_set_dri_npoin
!
subroutine pyclassfiller_set_dri_rpoin(rpoin,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: rpoin
  logical, intent(inout) :: error
  obs%head%dri%rpoin = rpoin
end subroutine pyclassfiller_set_dri_rpoin
!
subroutine pyclassfiller_set_dri_tref(tref,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tref
  logical, intent(inout) :: error
  obs%head%dri%tref = tref
end subroutine pyclassfiller_set_dri_tref
!
subroutine pyclassfiller_set_dri_aref(aref,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: aref
  logical, intent(inout) :: error
  obs%head%dri%aref = aref
end subroutine pyclassfiller_set_dri_aref
!
subroutine pyclassfiller_set_dri_apos(apos,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: apos
  logical, intent(inout) :: error
  obs%head%dri%apos = apos
end subroutine pyclassfiller_set_dri_apos
!
subroutine pyclassfiller_set_dri_tres(tres,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: tres
  logical, intent(inout) :: error
  obs%head%dri%tres = tres
end subroutine pyclassfiller_set_dri_tres
!
subroutine pyclassfiller_set_dri_ares(ares,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: ares
  logical, intent(inout) :: error
  obs%head%dri%ares = ares
end subroutine pyclassfiller_set_dri_ares
!
subroutine pyclassfiller_set_dri_bad(bad,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: bad
  logical, intent(inout) :: error
  obs%head%dri%bad = bad
end subroutine pyclassfiller_set_dri_bad
!
subroutine pyclassfiller_set_dri_ctype(ctype,error)
  use pyclassfiller_data
  integer(kind=4), intent(in) :: ctype
  logical, intent(inout) :: error
  obs%head%dri%ctype = ctype
end subroutine pyclassfiller_set_dri_ctype
!
subroutine pyclassfiller_set_dri_cimag(cimag,error)
  use pyclassfiller_data
  real(kind=8), intent(in) :: cimag
  logical, intent(inout) :: error
  obs%head%dri%cimag = cimag
end subroutine pyclassfiller_set_dri_cimag
!
subroutine pyclassfiller_set_dri_colla(colla,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: colla
  logical, intent(inout) :: error
  obs%head%dri%colla = colla
end subroutine pyclassfiller_set_dri_colla
!
subroutine pyclassfiller_set_dri_colle(colle,error)
  use pyclassfiller_data
  real(kind=4), intent(in) :: colle
  logical, intent(inout) :: error
  obs%head%dri%colle = colle
end subroutine pyclassfiller_set_dri_colle
!
!--- Data --------------------------------------------------------------
!
subroutine pyclassfiller_set_datay(datay,n,error)
  use pyclassfiller_data
  integer(kind=4), intent(in)    :: n
  real(kind=4),    intent(in)    :: datay(n)
  logical,         intent(inout) :: error
  !
  call reallocate_obs(obs,n,error)
  if (error)  return
  !
  obs%data1(1:n) = datay(1:n)
  !
end subroutine pyclassfiller_set_datay

subroutine gtclos(error)
  use gtv_interfaces, except_this=>gtclos
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   AWAKE flag is not reset by GTCLOS, as GTINIT is required only
  ! once even for multiple GTOPEN calls. Similarly, IUNIT is closed,
  ! but not freeed.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTCLOS'
  !
  if (.not.awake) then
    call gtv_message(seve%w,rname,'Library is not awake')
    return
  endif
  if (error_condition) then
    call gtv_message(seve%e,rname,'Library is in error condition')
    call gtx_err
    return
  endif
  !
  if (cw_device%protocol.eq.p_x) then
    ! Cleanly detach all the windows in the metacode.
    call gtv_open_segments_for_writing_from_main()
    call win_destroy_all_recursive(root,error)
    call gtv_close_segments_for_writing_from_main()
    if (error)  return
    !
    ! Clean the X ressources
    call x_close
    !
  elseif (cw_device%protocol.eq.p_svg) then
    call svg_close
    !
  endif
    !
  if (cw_output%dev%linit2.gt.0) then
    call cwrite(cw_output,cw_output%dev%init2,cw_output%dev%linit2)
    !
    call gtv_message(seve%i,rname,'Device closed')
  endif
    !
  if (cw_output%opened) then
    ! Close File
    call gtz_close(cw_output)
    call gtv_message(seve%i,rname,'Device closed')
  endif
  !
  ! Reset flags
  call gtx_reset
  !
end subroutine gtclos
!
subroutine gtx_reset
  use gtv_interfaces, except_this=>gtx_reset
  use gtv_graphic
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !  Resets flags.
  !----------------------------------------------------------------------
  !
  ! Reset flags
  cw_output%opened=.false.
  !
  ! Switch to the NONE device?
  ! Reset the hardware character parameters
  !
  ! To define it for DEVICE NONE
  cw_device%hardw_cursor = .false.
  !
end subroutine gtx_reset
!
subroutine gtnone
  use gtv_interfaces, except_this=>gtnone
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! Define the null device as current device.
  !---------------------------------------------------------------------
  logical :: error
  !
  ! Setup the NONE device
  error = .false.
  call gtx_setup('NONE',cw_device,error)
  if (error)  continue  ! ?
  gtv_device = device_list(cw_device%ident)
  !
  ! Setup a null output
  call gt_output_reset(null_output)
  null_output%dev => cw_device
  cw_output => null_output
  !
end subroutine gtnone

module cubeio_read
  use cubetools_setup_types
  use cubeio_messaging
  use cubeio_cube_define
  use cubeio_block
  use cubeio_range
  use cubeio_cube
  use cubeio_interface
  use cubeio_readwrite_iterator

  public :: cubeio_read_cube_data
  public :: cubeio_read_chan_block
  public :: cubeio_read_y_block
  public :: cubeio_read_any_block
  private

contains
  !
  subroutine cubeio_read_cube_data(cubset,cubdef,cub,error)
    !----------------------------------------------------------------------
    ! Read or prepare the data of a cube
    !----------------------------------------------------------------------
    type(cube_setup_t),  intent(in)    :: cubset
    type(cube_define_t), intent(in)    :: cubdef
    type(cubeio_cube_t), intent(inout) :: cub
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='READ>CUBE>DATA'
    !
    if (cub%ready())  return
    !
    ! Sanity
    if (cub%desc%iorder.eq.'') then
      call cubeio_message(seve%e,rname,  &
        'Attempt to get cube data while header is not loaded')
      error = .true.
      return
    endif
    ! if (cub%io%trans%do) then
    !   call cubeio_message(seve%e,rname,'Internal error: a transposition is pending')
    !   error = .true.
    !   return
    ! endif
    !
    if (cub%desc%buffered.eq.code_buffer_none)  return  ! Data is not to be read nor transposed
    !
    select case (cub%desc%buffered)
    case (code_buffer_none)
      return
    case (code_buffer_memory)
      call cubeio_message(ioseve%others,rname,'File is buffered in memory')
      call cubeio_read_all_memory(cubset,cub,error)
      if (error)  return
    case (code_buffer_disk)
      call cubeio_message(ioseve%others,rname,'File is not buffered in memory, using disk')
      call cub%memo%free(error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
    !
    cub%memo%ready = cub%desc%buffered
    !
  end subroutine cubeio_read_cube_data
  !
  subroutine cubeio_read_all_memory(cubset,cub,error)
    !-------------------------------------------------------------------
    ! Read all the cube (any order) from disk to memory.
    ! The reading process is done by blocks, with the possibility to
    ! interrupt (CTRL-C) with error.
    !-------------------------------------------------------------------
    type(cube_setup_t),  intent(in)    :: cubset
    type(cubeio_cube_t), intent(inout) :: cub
    logical,             intent(inout) :: error
    !
    type(readwrite_iterator_t) :: iter
    character(len=*), parameter :: rname='READ>ALL>MEMORY'
    !
    call cub%memo%reallocate(cub%desc%iscplx,  &
      cub%desc%nx,cub%desc%ny,cub%desc%nc,cub%desc%order,error)
    if (error) return
    !
    call iter%init(cubset,cub,'Read',error)
    if (error)  return
    !
    do while (iter%iterate(cub,error))
      if (cub%desc%iscplx) then
        call cubeio_cube_read_data(cub,iter%range, &
                                   cub%memo%c4(:,:,iter%first:iter%last),error)
      else
        call cubeio_cube_read_data(cub,iter%range, &
                                   cub%memo%r4(:,:,iter%first:iter%last),error)
      endif
      if (error)  return
    enddo
  end subroutine cubeio_read_all_memory
  !
  subroutine cubeio_read_chan_block(cubset,cub,lmvblock,error)
    !---------------------------------------------------------------------
    ! Read a LMV block of channels from LMV or VLM file on disk
    !---------------------------------------------------------------------
    type(cube_setup_t),   intent(in)    :: cubset
    type(cubeio_cube_t),  intent(inout) :: cub
    type(cubeio_block_t), intent(inout) :: lmvblock
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='READ>CHAN>BLOCK'
    type(cubeio_block_t) :: vlmblock
    integer(kind=pixe_k) :: iy,lmvy,vlmy,nyperblock
    integer(kind=chan_k) :: nchan,lmvchan,vlmchan
    character(len=message_length) :: mess
    type(cubeio_range_t) :: range
    integer(kind=4), parameter :: downfactor=10
    !
    ! Sanity
    if (lmvblock%order.ne.code_cube_imaset) then
      call cubeio_message(seve%e,rname,'Internal error: block is not LMV')
      error = .true.
      return
    endif
    if (cub%desc%iscplx.neqv.lmvblock%iscplx) then
      call cubeio_message(seve%e,rname,'Channel block and output cube mismatch type (R*4/C*4)')
      error = .true.
      return
    endif
    if (lmvblock%first.lt.1 .or. lmvblock%last.gt.cub%desc%nc) then
      call cubeio_message(seve%e,rname,'Internal error: invalid range')
      error = .true.
      return
    endif
    nchan = lmvblock%last-lmvblock%first+1  ! Useful size of the block
    !
    select case (cub%desc%order)
    case (code_cube_imaset)
      ! Easy: just a contiguous piece to be extracted
      range%blc(:) = 0
      range%trc(:) = 0
      range%blc(cub%desc%i3) = lmvblock%first
      range%trc(cub%desc%i3) = lmvblock%last
      if (lmvblock%iscplx) then
        call cubeio_cube_read_data(cub,range,lmvblock%c4,error)
      else
        call cubeio_cube_read_data(cub,range,lmvblock%r4,error)
      endif
      if (error)  return
      !
    case (code_cube_speset)
      ! Transposition needed: this means traversing the whole file with
      ! an intermediate buffer to collect the elements
      write(mess,'(4(A,I0))')  'Collecting LMV block ',lmvblock%first,' to ',  &
        lmvblock%last,' (over ',cub%desc%nc,') from VLM file'
      call cubeio_message(ioseve%trans,rname,mess)
      !
      call cub%y_per_block(cubset%buff%block/downfactor,'SET\BUFFER /BLOCK',nyperblock,error)
      if (error)  return
      call vlmblock%reallocatexyc(cub%desc%iscplx,cub%desc%nx,&
          nyperblock,cub%desc%nc,code_cube_speset,error)
      if (error)  return
      vlmblock%readwrite = .false.
      vlmblock%last = 0
      do iy=1,cub%desc%ny  ! For ALL Y pixel rows in VLM file
        if (iy.gt.vlmblock%last) then
          vlmblock%first = iy
          vlmblock%last = min(iy+nyperblock-1,cub%desc%ny)
          ! Note 1: we read here ALL Y pixel rows but a SUBSET of channels
          write(mess,'(2(A,I0))')  'Reading Y pixels block from ',vlmblock%first,' to ',vlmblock%last
          call cubeio_message(ioseve%trans,rname,mess)
          call cubeio_read_y_block(cubset,cub,vlmblock,error)
          if (error)  return
        endif
        ! Note 2: we write here a SUBSET of channels for current Y pixel row
        lmvy =  iy                    ! Position of first pixel of this Y row in lmvblock
        vlmy = (iy-vlmblock%first+1)  ! Position of first pixel of this Y row in vlmblock
        if (lmvblock%iscplx) then
          do lmvchan=1,nchan  ! For the desired SUBSET of channels
            vlmchan = lmvchan+lmvblock%first-1
            lmvblock%c4(:,lmvy,lmvchan) = vlmblock%c4(vlmchan,:,vlmy)
          enddo
        else
          do lmvchan=1,nchan  ! For the desired SUBSET of channels
            vlmchan = lmvchan+lmvblock%first-1
            lmvblock%r4(:,lmvy,lmvchan) = vlmblock%r4(vlmchan,:,vlmy)
          enddo
        endif
      enddo
      !
      call vlmblock%free(error)
      !
    case default
      call cubeio_message(seve%e,rname,'Unsupported cube order')
      error = .true.
      return
    end select
  end subroutine cubeio_read_chan_block
  !
  subroutine cubeio_read_y_block(cubset,cub,vlmblock,error)
    !---------------------------------------------------------------------
    ! Read a VLM block of channels from VLM or LMV file on disk
    !---------------------------------------------------------------------
    type(cube_setup_t),   intent(in)    :: cubset
    type(cubeio_cube_t),  intent(inout) :: cub
    type(cubeio_block_t), intent(inout) :: vlmblock
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='READ>Y>BLOCK'
    type(cubeio_block_t) :: lmvblock
    integer(kind=chan_k) :: ichan,lmvchan,vlmchan,nchanperblock
    integer(kind=pixe_k) :: ny,lmvy,vlmy
    character(len=message_length) :: mess
    type(cubeio_range_t) :: range
    integer(kind=4), parameter :: downfactor=10
    !
    ! Sanity
    if (vlmblock%order.ne.code_cube_speset) then
      call cubeio_message(seve%e,rname,'Internal error: block is LMV')
      error = .true.
      return
    endif
    if (cub%desc%iscplx.neqv.vlmblock%iscplx) then
      call cubeio_message(seve%e,rname,'Y rows block and output cube mismatch type (R*4/C*4)')
      error = .true.
      return
    endif
    if (vlmblock%first.lt.1 .or. vlmblock%last.gt.cub%desc%ny) then
      call cubeio_message(seve%e,rname,'Internal error: invalid range')
      error = .true.
      return
    endif
    ny = vlmblock%last-vlmblock%first+1  ! Useful size of the block
    !
    select case (cub%desc%order)
    case (code_cube_speset)
      ! Easy: just a contiguous piece to be extracted
      range%blc(:) = 0
      range%trc(:) = 0
      range%blc(cub%desc%i3) = vlmblock%first
      range%trc(cub%desc%i3) = vlmblock%last
      if (lmvblock%iscplx) then
        call cubeio_cube_read_data(cub,range,vlmblock%c4,error)
      else
        call cubeio_cube_read_data(cub,range,vlmblock%r4,error)
      endif
      if (error)  return
      !
    case (code_cube_imaset)
      ! Transposition needed: this means traversing the whole file with
      ! an intermediate buffer to collect the elements
      write(mess,'(4(A,I0))')  'Collecting VLM block ',vlmblock%first,' to ',  &
        vlmblock%last,' (over ',cub%desc%ny,') from LMV file'
      call cubeio_message(ioseve%trans,rname,mess)
      !
      call cub%chan_per_block(cubset%buff%block/downfactor,'SET\BUFFER /BLOCK',nchanperblock,error)
      if (error)  return
      call lmvblock%reallocatexyc(cub%desc%iscplx,&
          cub%desc%nx,cub%desc%ny,nchanperblock,code_cube_imaset,error)
      if (error)  return
      lmvblock%readwrite = .false.
      lmvblock%last = 0
      do ichan=1,cub%desc%nc  ! For ALL channels in LMV file
        if (ichan.gt.lmvblock%last) then
          lmvblock%first = ichan
          lmvblock%last = min(ichan+nchanperblock-1,cub%desc%nc)
          ! Note 1: we read here ALL channels but a SUBSET of Y rows
          write(mess,'(2(A,I0))')  'Reading channel block from ',lmvblock%first,' to ',lmvblock%last
          call cubeio_message(ioseve%trans,rname,mess)
          call cubeio_read_chan_block(cubset,cub,lmvblock,error)
          if (error)  return
        endif
        ! Note 2: we write here a SUBSET of Y rows for current channel
        vlmchan =  ichan                    ! Position of first pixel of this channel in vlmblock
        lmvchan = (ichan-lmvblock%first+1)  ! Position of first pixel of this channel in lmvblock
        if (vlmblock%iscplx) then
          do vlmy=1,ny  ! For the desired SUBSET of Y rows
            lmvy = vlmy+vlmblock%first-1
            vlmblock%c4(vlmchan,:,vlmy) = lmvblock%c4(:,lmvy,lmvchan)
          enddo
        else
          do vlmy=1,ny  ! For the desired SUBSET of Y rows
            lmvy = vlmy+vlmblock%first-1
            vlmblock%r4(vlmchan,:,vlmy) = lmvblock%r4(:,lmvy,lmvchan)
          enddo
        endif
      enddo
      !
      call lmvblock%free(error)
      !
    case default
      call cubeio_message(seve%e,rname,'Unsupported cube order')
      error = .true.
      return
    end select
  end subroutine cubeio_read_y_block
  !
  subroutine cubeio_read_any_block(cubset,cub,anyblock,error)
    !---------------------------------------------------------------------
    ! Read a block of planes from file on disk
    !---------------------------------------------------------------------
    type(cube_setup_t),   intent(in)    :: cubset
    type(cubeio_cube_t),  intent(inout) :: cub
    type(cubeio_block_t), intent(inout) :: anyblock
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='READ>ANY>BLOCK'
    integer(kind=data_k) :: n3
    type(cubeio_range_t) :: range
    !
    ! Sanity
    if (anyblock%order.ne.code_cube_unkset) then  ! ZZZ Is this test relevant?
      call cubeio_message(seve%e,rname,'Internal error: block has not ANY order')
      error = .true.
      return
    endif
    if (cub%desc%iscplx.neqv.anyblock%iscplx) then
      call cubeio_message(seve%e,rname,'Block and output cube mismatch type (R*4/C*4)')
      error = .true.
      return
    endif
    if (anyblock%first.lt.1 .or. anyblock%last.gt.cub%desc%n3) then
      call cubeio_message(seve%e,rname,'Internal error: invalid range')
      error = .true.
      return
    endif
    n3 = anyblock%last-anyblock%first+1  ! Useful size of the block
    !
    select case (cub%desc%order)
    case (code_cube_imaset,code_cube_speset)
      ! Easy: just a contiguous piece to be extracted
      range%blc(:) = 0
      range%trc(:) = 0
      range%blc(cub%desc%i3) = anyblock%first
      range%trc(cub%desc%i3) = anyblock%last
      if (anyblock%iscplx) then
        call cubeio_cube_read_data(cub,range,anyblock%c4,error)
      else
        call cubeio_cube_read_data(cub,range,anyblock%r4,error)
      endif
      if (error)  return
      !
    case default
      call cubeio_message(seve%e,rname,'Unsupported cube order')
      error = .true.
      return
    end select
  end subroutine cubeio_read_any_block

end module cubeio_read

module gtv_interfaces_private_c
  !---------------------------------------------------------------------
  ! @ private
  ! Private interfaces to C routines (hand made)
  !---------------------------------------------------------------------
  !
  logical, external :: x_refresh_genv  ! No-interface (argument type mismatch)
  !
  interface
    function c_get_win_genv(genv_array,iwin)
    use gildas_def
    integer(kind=address_length) :: c_get_win_genv  ! Function value on return
    integer(kind=address_length), intent(in) :: genv_array  !
    integer(kind=4),              intent(in) :: iwin        ! Window C number
    end function c_get_win_genv
    !
    function c_new_genv_array(mwindows)
    use gildas_def
    integer(kind=address_length) :: c_new_genv_array
    integer(kind=4), intent(in) :: mwindows
    end function c_new_genv_array
    !
    function open_x(cross)
    integer(kind=4) :: open_x
    integer(kind=4), intent(in) :: cross
    end function open_x
    !
    function xcolormap_create(r,g,b,siz,defaul)
    use gildas_def
    integer(kind=address_length) :: xcolormap_create
    integer(kind=4), intent(in) :: siz
    real(kind=4),    intent(in) :: r(siz)
    real(kind=4),    intent(in) :: g(siz)
    real(kind=4),    intent(in) :: b(siz)
    logical,         intent(in) :: defaul
    end function xcolormap_create
    !
    function gpng_zopen(filename,lf,npixx,npixy,nchan)
    integer(kind=4) :: gpng_zopen
    character(len=*), intent(in) :: filename
    integer(kind=4),  intent(in) :: lf
    integer(kind=4),  intent(in) :: npixx
    integer(kind=4),  intent(in) :: npixy
    integer(kind=4),  intent(in) :: nchan
    end function gpng_zopen
    !
    subroutine gpng_copy_data(row,r,g,b,a)
    integer(kind=4), intent(in) :: row
    integer(kind=1), intent(in) :: r,g,b,a
    end subroutine gpng_copy_data
    !
    subroutine gpng_finish()
    end subroutine gpng_finish
    !
    subroutine gpng_cleanup()
    end subroutine gpng_cleanup
    !
    subroutine gpng_getbuf(nwords32,addr)
    use gildas_def
    integer(kind=4),              intent(out) :: nwords32
    integer(kind=address_length), intent(out) :: addr
    end subroutine gpng_getbuf
    !
    function si4_to_ui1(si4)
    integer(kind=1) :: si4_to_ui1
    integer(kind=4), intent(in) :: si4
    end function si4_to_ui1
  end interface
  !
end module gtv_interfaces_private_c
!
module gtv_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GTV interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use gtv_interfaces_private
  use gtv_interfaces_private_c
  use gtv_interfaces_public
  !
end module gtv_interfaces
!
module gtv_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GTV dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  use gmath_interfaces_public
  use sic_interfaces_public
  use gcore_interfaces_public_c
  use gchar_interfaces_public
end module gtv_dependencies_interfaces

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_ancillary_init_types
  use cubemain_messaging
  use cubeadm_ancillary_cube_types
  !
  public :: ancillary_init_comm_t,ancillary_init_user_t,ancillary_init_prog_t
  private
  !
  type, extends(ancillary_cube_comm_t) :: ancillary_init_comm_t
   contains
     procedure, public :: register => cubemain_ancillary_init_comm_register
  end type ancillary_init_comm_t
  !
  type, extends(ancillary_cube_user_t) :: ancillary_init_user_t
     ! Empty for the moment
  end type ancillary_init_user_t
  !
  type, extends(ancillary_cube_prog_t) :: ancillary_init_prog_t
     ! Empty for the moment
  end type ancillary_init_prog_t
  !
contains
  !
  subroutine cubemain_ancillary_init_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! Register an optional "/INIT [initid]" key
    !----------------------------------------------------------------------
    class(ancillary_init_comm_t), intent(inout) :: comm
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='ANCILLARY>INIT>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call comm%fully_register(&
         'PARAMETERS','[parameterid]',&
         'Reuse a fit-results cube as initial guesses',&
         'Use /PARAMETERS to reuse the fit-results cube produced by&
         & FIT\MINIMIZE as initial guesses. The ancillary cube must follow&
         & the FIT\MINIMIZE output layout.',&
         'PARAMETERS',&
         'Fit-results cube identifier',&
         [flag_minimize],&
         code_arg_optional,&
         code_read,&
         code_access_speset,&
         error)
    if (error) return
  end subroutine cubemain_ancillary_init_comm_register
end module cubemain_ancillary_init_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine flux_set(line,error)
  !---------------------------------------------------------------------
  ! FLUX   Support for command
  !     ASTRO\SET FLUX Quasar [Flux|*]
  !        (only one value by SET command)
  !
  !  Quasar   CHARACTER*12	Quasar name
  !  Flux     REAL   		Flux (of the source)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'flux.inc'
  ! Local
  character(len=12) :: name,argum2
  real*8 :: flux
  integer :: i,j,nc
  !------------------------------------------------------------------------
  ! Code:
  !
  call sic_ch (line,0,2,name,nc,.true.,error)
  argum2 = '*'
  call sic_ch (line,0,3,argum2,nc,.false.,error)
  !
  ! Set the flux for the speficied quasar
  if (argum2.ne.'*') then
    call sic_r8 (line,0,3,flux,.false.,error)
    do i=1,n_qua
      if (qsource(i).eq.name) then
        qflux(i) = flux
        return
      endif
    enddo
    n_qua = n_qua+1
    qsource(n_qua) = name
    qflux(n_qua) = flux
  else
    !
    ! If flux is *, remove quasar from list
    do i=1,n_qua
      if (qsource(i).eq.name) then
        do j=i+1,n_qua
          qsource(j-1) = qsource(j)
          qflux(j-1) = qflux(j)
        enddo
        n_qua = n_qua-1
        return
      endif
    enddo
  endif
end subroutine flux_set

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehistogram_ppv2xyv
  use cube_types 
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_ancillary_weight_types
  use cubetopology_cuberegion_types
  use cubehistogram_messaging
  !
  public :: ppv2xyv
  private
  !
  type :: ppv2xyv_comm_t
     type(option_t), pointer :: comm
!     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: fromto
     type(cubeid_arg_t), pointer :: histo2d
     type(ancillary_weight_comm_t) :: ppvwei
     type(cubeid_arg_t), pointer :: ppvsig
     type(cube_prod_t),  pointer :: xyvsig
   contains
     procedure, public  :: register => cubehistogram_ppv2xyv_comm_register
     procedure, private :: parse    => cubehistogram_ppv2xyv_comm_parse
     procedure, private :: main     => cubehistogram_ppv2xyv_comm_main
  end type ppv2xyv_comm_t
  type(ppv2xyv_comm_t) :: ppv2xyv  
  !
  type ppv2xyv_user_t
     type(cubeid_user_t)           :: cubeids
     type(ancillary_weight_user_t) :: ppvwei
!     type(cuberegion_user_t)      :: region
   contains
     procedure, private :: toprog => cubehistogram_ppv2xyv_user_toprog
  end type ppv2xyv_user_t
  !
  type ppv2xyv_prog_t
!     type(cuberegion_prog_t) :: region
     type(cube_t), pointer         :: fromto
     type(cube_t), pointer         :: histo2d
     type(ancillary_weight_prog_t) :: ppvwei
     type(cube_t), pointer :: ppvsig
     type(cube_t), pointer :: xyvsig
     procedure(cubehistogram_ppv2xyv_prog_loop_with_weight), pointer :: loop => null()
   contains
     procedure, private :: header             => cubehistogram_ppv2xyv_prog_header
     procedure, private :: data               => cubehistogram_ppv2xyv_prog_data
     procedure, private :: act_without_weight => cubehistogram_ppv2xyv_prog_act_without_weight
     procedure, private :: act_with_weight    => cubehistogram_ppv2xyv_prog_act_with_weight
  end type ppv2xyv_prog_t
  !
contains
  !
  subroutine cubehistogram_ppv2xyv_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(ppv2xyv_user_t) :: user
    character(len=*), parameter :: rname='PPV2XYV>COMMAND'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call ppv2xyv%parse(line,user,error)
    if (error) return
    call ppv2xyv%main(user,error)
    if (error) continue
  end subroutine cubehistogram_ppv2xyv_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(inout) :: comm
    logical,                 intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='PPV2XYV>COMM>REGISTER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'PPV2XYV','[ppvid fromtoid histo2did]',&
         'Build one stacked spectrum per 2D histogram bin',&
         'Group together the spectra of all pixels that fall in the&
         & same 2D histogram bin. The result is one stacked spectrum&
         & for each bin of the histogram.'//strg_bl//&
         'Behavior:'//strg_cr//&
         'Use PPV as the input Position-Position-Velocity cube, FROMTO&
         & as the pointer product from HISTO2D, and HISTO2D as the&
         & reference histogram layout. For each channel map, CUBE&
         & accumulates the PPV pixels that point to the same XY bin and&
         & writes their mean value into XYV.'//strg_cr//&
         'Use /WEIGHT to switch from plain to weighted averaging. The&
         & XYV spatial geometry follows HISTO2D.'//strg_bl//&
         'Notes:'//strg_cr//&
         'You may omit ppvid, fromtoid, and histo2did when the intended&
         & inputs are unambiguous. Query PPVID ?, FROMTOID ?, or&
         & HISTO2DID ? for the fallback used by each argument.'//&
         strg_cr//&
         'If FROMTO contains indices outside the HISTO2D layout, the&
         & command prints raw diagnostics and continues.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'Build the 2D histogram and keep its Pointer product, then&
         & stack the PPV cube in histogram space.'//strg_cr//&
         'CUBE> HISTOGRAM\HISTO2D xcube ycube'//strg_cr//&
         'CUBE> HISTOGRAM\PPV2XYV ppv Pointer histo2d [/WEIGHT weight]'//strg_cr//&
         'CUBE> HISTOGRAM\XY2PP ppin Pointer xyv.',&
         cubehistogram_ppv2xyv_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'PPVID',&
         'Position-Position-Velocity cube identifier',&
         'Input PPV cube to stack in XY histogram space.'//strg_cr//&
         'If ppvid is omitted, CUBE uses the standard CubeID fallback&
         & in the default index (DAG by default; see SET\INDEX) and&
         & keeps the last matching product.'//strg_cr//&
         'This fallback is intentionally broad, so give ppvid&
         & explicitly unless the input cube is obvious.',&
         code_arg_optional,&
         !         [flag_ppv,flag_cube],&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%ppvsig,&
         error)
    if (error) return
    call incube%register(&
         'FROMTOID',&
         'From PP to XY cube identifier',&
         'Index image explaining how to go from a PP image to a bin of&
         & XY HISTO2D values.'//strg_cr//&
         'If fromtoid is omitted, CUBE uses the last matching HISTO2D&
         & Pointer product in the default index (DAG by default; see&
         & SET\INDEX).',&
         code_arg_optional,&
         [flag_histo2d,flag_pointer],&
         code_read,&
         code_access_imaset,&
         comm%fromto,&
         error)
    if (error) return
    call incube%register(&
         'HISTO2DID',&
         '2D histogram identifier',&
         'Reference HISTO2D product that defines the XY layout of the&
         & output cube.'//strg_cr//&
         'If histo2did is omitted, CUBE uses the last matching HISTO2D&
         & product in the default index (DAG by default; see&
         & SET\INDEX).',&
         code_arg_optional,&
         [flag_histo2d],&
         code_read_head,&
         code_access_imaset,&
         comm%histo2d,&
         error)
    if (error) return
    call comm%ppvwei%register(&
         'Weight the XY-bin averages',&
         code_access_imaset,&
         error)
    if (error) return
!    call comm%region%register(error)
!    if (error) return
    !
    ! Products
    call oucube%register(&
         'XYV',&
         'X-Y-Velocity cube',&
         strg_emp,&
         [flag_xyv,flag_cube],&
         comm%xyvsig,&
         error)
    if (error)  return
  end subroutine cubehistogram_ppv2xyv_comm_register
  !
  subroutine cubehistogram_ppv2xyv_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! PPV2XYV ppvid fromtoid histo2did
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(in)    :: comm
    character(len=*),      intent(in)    :: line
    type(ppv2xyv_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>COMM>PARSE'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%ppvwei%parse(line,user%ppvwei,error)
    if (error) return
!!$    call comm%region%parse(line,user%region,error)
!!$    if (error) return
  end subroutine cubehistogram_ppv2xyv_comm_parse
  !
  subroutine cubehistogram_ppv2xyv_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(in)    :: comm
    type(ppv2xyv_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(ppv2xyv_prog_t) :: prog
    character(len=*), parameter :: rname='PPV2XYV>MAIN'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubehistogram_ppv2xyv_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_user_t), intent(in)    :: user
    type(ppv2xyv_comm_t),  intent(in)    :: comm
    type(ppv2xyv_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>USER>TOPROG'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%ppvsig,user%cubeids,prog%ppvsig,error)
    if (error) return
    call user%ppvwei%toprog(comm%ppvwei,prog%ppvwei,error)
    if (error) return
    call prog%ppvwei%check_consistency(prog%ppvsig,error)
    if (error) return
    call cubeadm_get_header(comm%fromto,user%cubeids,prog%fromto,error)
    if (error) return
    call cubeadm_get_header(comm%histo2d,user%cubeids,prog%histo2d,error)
    if (error) return
    if (prog%ppvwei%do) then
       prog%loop => cubehistogram_ppv2xyv_prog_loop_with_weight
    else
       prog%loop => cubehistogram_ppv2xyv_prog_loop_without_weight
    endif
!!$    call user%region%toprog(prog%fromto,prog%region,error)
!!$    if (error) return
    !
    ! User feedback about the interpretation of his command line
!!$    call prog%region%list(error)
!!$    if (error) return    
  end subroutine cubehistogram_ppv2xyv_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    type(ppv2xyv_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>PROG>HEADER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%xyvsig,prog%ppvsig,prog%xyvsig,error)
    if (error) return
    call cubetools_header_spatial_like(prog%histo2d%head,prog%xyvsig%head,error)
    if (error) return
!!$    call prog%region%header(prog%xyvsig,error)
!!$    if (error) return
  end subroutine cubehistogram_ppv2xyv_prog_header
  !
  subroutine cubehistogram_ppv2xyv_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='PPV2XYV>PROG>DATA'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubehistogram_ppv2xyv_prog_data
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_prog_loop_without_weight(prog,iter,error)
    use cubeadm_taskloop
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: fromto
    type(image_t) :: ppsig,xysig
    type(dble_2d_t) :: xysum
    type(long_2d_t) :: xywei
    character(len=*), parameter :: rname='PPV2XYV>PROG>LOOP>WITHOUT>WEIGHT'
    !
    call fromto%associate('fromto',prog%fromto,iter,error)
    if (error) return
    call ppsig%associate('ppsig',prog%ppvsig,iter,error)
    if (error) return
    call xysig%allocate('xysig',prog%xyvsig,iter,error)
    if (error) return
    call xysum%reallocate('xysum',xysig%nx,xysig%ny,error)
    if (error) return
    call xywei%reallocate('xywei',xysig%nx,xysig%ny,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act_without_weight(iter%ie,fromto,ppsig,xysig,xysum,xywei,error)
      if (error) return
    enddo ! ie
  end subroutine cubehistogram_ppv2xyv_prog_loop_without_weight
  !
  subroutine cubehistogram_ppv2xyv_prog_act_without_weight(&
       prog,ie,fromto,ppsig,xysig,xysum,xywei,error)
    use cubetools_nan
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t),         intent(inout) :: fromto
    type(image_t),         intent(inout) :: ppsig
    type(image_t),         intent(inout) :: xysig
    type(dble_2d_t),       intent(inout) :: xysum
    type(long_2d_t),       intent(inout) :: xywei
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    integer(kind=pixe_k) :: jx,jy
    integer(kind=indx_k) :: index
    integer(kind=long_k), parameter :: zero=0
    character(len=*), parameter :: rname='PPV2XYV>PROG>ACT>WITHOUT>WEIGHT'
    !
    call fromto%get(ie,error)
    if (error) return
    call ppsig%get(ie,error)
    if (error) return
    ! Initialize
    call xywei%set(zero,error)
    if (error) return
    call xysum%set(0d0,error)
    if (error) return
    ! Sum the input pixels using the fromto mask
    do iy=1,fromto%ny
       do ix=1,fromto%nx
          if (ieee_is_nan(fromto%val(ix,iy))) cycle
          index = fromto%val(ix,iy)
          if (index.eq.0) cycle
          jx = 1+mod(index-1,xysig%nx)
          jy = 1+(index-jx)/xysig%nx
          ! The user can provide an inconsistent set of fromto and histo2d images!
          if ((1.le.jx).and.(jx.le.xywei%nx).and.(1.le.jy).and.(jy.le.xywei%ny)) then
             xywei%val(jx,jy) = xywei%val(jx,jy) + 1
             xysum%val(jx,jy) = xysum%val(jx,jy) + ppsig%val(ix,iy)
          else
             ! ***JP: Some shorter feedback to user? For instance counting
             ! ***JP: the number of points outside and stating it at the end?
             print *,jx,jy,xywei%nx,xywei%ny
          endif
       enddo ! ix
    enddo ! iy
    ! Compute xy
    do iy=1,xysig%ny
       do ix=1,xysig%nx
          if (xywei%val(ix,iy).ne.zero) then
             xysig%val(ix,iy) = xysum%val(ix,iy)/xywei%val(ix,iy)
          else
             xysig%val(ix,iy) = gr4nan
          endif
       enddo ! ix
    enddo ! iy
    call xysig%put(ie,error)
    if (error) return
  end subroutine cubehistogram_ppv2xyv_prog_act_without_weight
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_prog_loop_with_weight(prog,iter,error)
    use cubeadm_taskloop
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: fromto
    type(image_t) :: ppsig,ppwei,xysig
    type(dble_2d_t) :: xysum,xywei
    character(len=*), parameter :: rname='PPV2XYV>PROG>LOOP>WITH>WEIGHT'
    !
    call fromto%associate('fromto',prog%fromto,iter,error)
    if (error) return
    call ppsig%associate('ppsig',prog%ppvsig,iter,error)
    if (error) return
    call ppwei%associate('ppwei',prog%ppvwei%cube,iter,error)
    if (error) return
    call xysig%allocate('xysig',prog%xyvsig,iter,error)
    if (error) return
    call xysum%reallocate('xysum',xysig%nx,xysig%ny,error)
    if (error) return
    call xywei%reallocate('xywei',xysig%nx,xysig%ny,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act_with_weight(iter%ie,fromto,ppsig,ppwei,xysig,xysum,xywei,error)
      if (error) return
    enddo ! ie
  end subroutine cubehistogram_ppv2xyv_prog_loop_with_weight
  !
  subroutine cubehistogram_ppv2xyv_prog_act_with_weight(&
       prog,ie,fromto,ppsig,ppwei,xysig,xysum,xywei,error)
    use cubetools_nan
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t),         intent(inout) :: fromto
    type(image_t),         intent(inout) :: ppsig
    type(image_t),         intent(inout) :: ppwei
    type(image_t),         intent(inout) :: xysig
    type(dble_2d_t),       intent(inout) :: xysum
    type(dble_2d_t),       intent(inout) :: xywei
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    integer(kind=pixe_k) :: jx,jy
    integer(kind=indx_k) :: index
    real(kind=dble_k), parameter :: zero=0d0
    character(len=*), parameter :: rname='PPV2XYV>PROG>ACT>WITH>WEIGHT'
    !
    call fromto%get(ie,error)
    if (error) return
    call ppsig%get(ie,error)
    if (error) return
    call ppwei%get(ie,error)
    if (error) return
    ! Initialize
    call xywei%set(zero,error)
    if (error) return
    call xysum%set(zero,error)
    if (error) return
    ! Sum the input pixels using the fromto mask
    do iy=1,fromto%ny
       do ix=1,fromto%nx
          if (ieee_is_nan(fromto%val(ix,iy))) cycle
          if (ieee_is_nan(ppsig%val(ix,iy)))  cycle
          if (ieee_is_nan(ppwei%val(ix,iy)))  cycle
          index = fromto%val(ix,iy)
          if (index.eq.0) cycle
          jx = 1+mod(index-1,xysig%nx)
          jy = 1+(index-jx)/xysig%nx
          ! The user can provide an inconsistent set of fromto and histo2d images!
          if ((1.le.jx).and.(jx.le.xywei%nx).and.(1.le.jy).and.(jy.le.xywei%ny)) then
             xywei%val(jx,jy) = xywei%val(jx,jy) + ppwei%val(ix,iy)
             xysum%val(jx,jy) = xysum%val(jx,jy) + ppwei%val(ix,iy)*ppsig%val(ix,iy)
          else
             ! ***JP: Some shorter feedback to user? For instance counting
             ! ***JP: the number of points outside and stating it at the end?
             print *,jx,jy,xywei%nx,xywei%ny
          endif
       enddo ! ix
    enddo ! iy
    ! Compute xy
    do iy=1,xysig%ny
       do ix=1,xysig%nx
          if (xywei%val(ix,iy).ne.zero) then
             xysig%val(ix,iy) = xysum%val(ix,iy)/xywei%val(ix,iy)
          else
             xysig%val(ix,iy) = gr4nan
          endif
       enddo ! ix
    enddo ! iy
    call xysig%put(ie,error)
    if (error) return
  end subroutine cubehistogram_ppv2xyv_prog_act_with_weight
end module cubehistogram_ppv2xyv
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubemain_pang
  use cubetools_parameters
  use cubemain_messaging
  !
  type pang_user_t
     character(len=argu_l) :: val = strg_unk
     character(len=argu_l) :: unit = strg_unk
  end type pang_user_t
  !
  type pang_t
     real(kind=coor_k) :: val = 0d0
  end type pang_t
  !
contains
  !
  subroutine cubemain_pang_register(name,abstract,option,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! Register a /PANG option according to a name and abstract
    ! provided by the command
    ! ----------------------------------------------------------------------
    character(len=*),        intent(in)    :: name
    character(len=*),        intent(in)    :: abstract
    type(option_t), pointer, intent(out)   :: option
    logical,                 intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    !
    character(len=*), parameter :: rname='PANG>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'angle [unit]',&
         abstract,&
         strg_emp,&
         option,error)
    if (error) return
    call stdarg%register( &
         'angle',&
         'Rotation angle', &
         '"*" or "=" mean previous value is kept',&
         code_arg_mandatory, &
         error)
    if (error) return
    call stdarg%register( &
         'unit',  &
         'Position unit if relative', &
         '"*" or "=" mean previous value is kept',&
         code_arg_optional, &
         error)
    if (error) return
  end subroutine cubemain_pang_register
  !
  subroutine cubemain_pang_parse(line,opt,user,dopang,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),        intent(in)    :: line   ! Input user line
    type(option_t),          intent(in)    :: opt    ! Command option
    type(pang_user_t),       intent(out)   :: user   ! Parsed user input
    logical,                 intent(out)   :: dopang ! Option was present
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PANG>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    user%val  = strg_star
    user%unit = strg_star
    !
    call opt%present(line,dopang,error)
    if (error) return
    if (dopang) then
       call cubetools_getarg(line,opt,1,user%val,mandatory,error)
       if (error) return
       call cubetools_getarg(line,opt,2,user%unit,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_pang_parse
  !
  subroutine cubemain_pang_user2prog(cube,user,prog,error)
    use cubetools_unit
    use cube_types
    use cubetools_user2prog
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t),      intent(in)    :: cube
    type(pang_user_t), intent(in)    :: user
    type(pang_t),      intent(out)   :: prog
    logical,           intent(inout) :: error
    !
    type(unit_user_t) :: unit
    character(len=*), parameter :: rname='PANG>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call unit%get_from_name_for_code(user%unit,code_unit_pang,error)
    if (error) return
    !
    call cubetools_user2prog_resolve_star(user%val,unit,cube%head%spa%pro%pa,prog%val,error)
    if (error) return
  end subroutine cubemain_pang_user2prog
end module cubemain_pang

subroutine include (line,comm,error)
  use gkernel_interfaces
  use point_interfaces, except_this=>include
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  character(len=*)                :: comm   !
  logical,          intent(inout) :: error  !
  ! Global
  include 'setup.inc'
  ! Local
  character(len=*), parameter :: rname='INCLUDE'
  character(len=12) :: argum
  real(kind=4) :: tmin,tmax
  integer(kind=4) :: na
  !
  if (sic_present(1,0)) then  ! /SCAN
    call sic_ch (line,1,1,argum,na,.false.,error)
    if (error) return
    if (argum.eq.'*') then
      call get_all(npt)
      fitted = .false.
    else
      call do_list (rname,line,1,error,get_scans)
      fitted = .false.
    endif
  endif
  !
  if (sic_present(2,0)) then  ! /SOURCE
    call sic_ch (line,2,1,argum,na,.false.,error)
    if (error) return
    if (argum.eq.'*') then
      call get_all(npt)
      fitted = .false.
    else
      call do_list (rname,line,2,error,get_sources)
      fitted = .false.
    endif
  endif
  !
  if (sic_present(3,0)) then  ! /TIME
    call sic_r4 (line,3,2,tmax,.true.,error)
    if (error) return
    call sic_r4 (line,3,1,tmin,.true.,error)
    if (error) return
    call get_ti (npt,tmin,tmax)
    fitted = .false.
  endif
  !
end subroutine include
!
subroutine ignore (line,comm,error)
  use gkernel_interfaces
  use point_interfaces, except_this=>ignore
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  character(len=*)                :: comm   !
  logical,          intent(inout) :: error  !
  ! Global
  include 'setup.inc'
  ! Local
  character(len=*), parameter :: rname='IGNORE'
  real(kind=4) :: tmin,tmax
  !
  if (sic_present(1,0)) then  ! /SCAN
    call do_list (rname,line,1,error,flag_scans)
    fitted = .false.
  endif
  !
  if (sic_present(2,0)) then  ! /SOURCE
    call do_list (rname,line,2,error,flag_sources)
    fitted = .false.
  endif
  !
  if (sic_present(3,0)) then  ! /TIME
    call sic_r4 (line,3,2,tmax,.true.,error)
    if (error) return
    call sic_r4 (line,3,1,tmin,.true.,error)
    if (error) return
    call flag_ti (npt,tmin,tmax)
    fitted = .false.
  endif
  !
end subroutine ignore
!
subroutine reject (line,comm,error)
  use gkernel_interfaces
  use point_interfaces, except_this=>reject
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  character(len=*)                :: comm   !
  logical,          intent(inout) :: error  !
  ! Global
  include 'setup.inc'
  ! Local
  real(kind=4) :: rmserr
  !
  call sic_r4 (line,0,1,rmserr,.true.,error)
  if (error) return
  fitted = .false.
  call flag_re (ndata,rmserr)
end subroutine reject
!
subroutine do_list (rname,line,iopt,error,func)
  use gkernel_interfaces
  use gkernel_types
  use point_interfaces, except_this=>do_list
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname  !
  character(len=*), intent(in)  :: line   !
  integer(kind=4),  intent(in)  :: iopt   !
  logical,          intent(out) :: error  !
  external                      :: func   !
  ! Local
  integer(kind=4) :: narg,first,last
  integer(kind=4), parameter :: mloop=1
  type(sic_listi4_t) :: list
  integer(kind=4) :: loop(3)
  !
  error = .false.
  narg = sic_narg(iopt)
  if (narg.eq.0)  return
  !
  first = sic_start(iopt,1)
  last = sic_end(iopt,narg)
  call sic_parse_listi4(rname,line(first:last),list,mloop,error)
  if (error)  return
  !
  loop(1) = list%i1(1)
  loop(2) = list%i2(1)
  loop(3) = list%i3(1)
  call func(loop)
  !
end subroutine do_list
!
subroutine get_scans (loop)
  use point_interfaces, except_this=>get_scans
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: loop(3)  !
  ! Global
  include 'setup.inc'
  ! Local
  integer(kind=4) :: i
  !
  do i=loop(1),loop(2),loop(3)
    call get_scan (npt,i)
  enddo
end subroutine get_scans
!
subroutine get_sources (loop)
  use point_interfaces, except_this=>get_sources
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: loop(3)  !
  ! Global
  include 'setup.inc'
  ! Local
  integer(kind=4) :: i
  !
  do i=loop(1),loop(2),loop(3)
    call get_source (npt,i)
  enddo
end subroutine get_sources
!
subroutine flag_scans (loop)
  use point_interfaces, except_this=>flag_scans
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: loop(3)  !
  ! Global
  include 'setup.inc'
  ! Local
  integer(kind=4) :: i
  !
  do i=loop(1),loop(2),loop(3)
    call flag_scan (npt,i)
  enddo
end subroutine flag_scans
!
subroutine flag_sources (loop)
  use point_interfaces, except_this=>flag_sources
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: loop(3)  !
  ! Global
  include 'setup.inc'
  ! Local
  integer(kind=4) :: i
  !
  do i=loop(1),loop(2),loop(3)
    call flag_source (npt,i)
  enddo
end subroutine flag_sources

  !
subroutine mx_get_parameters(nx,ny)
  use gildas_def
  use gkernel_interfaces
  use mx_parameters
  use clean_tool, only: check_box
  !---------------------------------------------------------------------
  ! GILDAS:	MX Internal routine
  !	Retrieves input parameters for MX Uvmap & Clean
  !---------------------------------------------------------------------
  integer, intent(out) :: nx,ny
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  character(len=4) :: weight_mode
  logical :: error
  !
  call gildas_open
  call gildas_char('UV_TABLE$',uv_table)
  call gildas_char('MAP_NAME$',map_name)
  !
  ! UVMAP part
  call gildas_real('UV_TAPER$',uv_taper,4)
  uv_taper(3) = 0.0
  call gildas_char('WEIGHT_MODE$',weight_mode)
  call gildas_inte('MAP_SIZE$',map_size,2)
  call gildas_real('MAP_CELL$',map_cell,2)
  call gildas_real('UV_CELL$',uniform,2)
  call gildas_inte('WCOL$',wcol,1)
  call gildas_inte('MCOL$',mcol,2)
  call gildas_inte('CONVOLUTION$',ctype,1)
  call gildas_logi('UV_SHIFT$',shift,1)
  if (shift) then
    call gildas_char('RA_CENTER$',ra_c)
    call gildas_char('DEC_CENTER$',dec_c)
    call gildas_dble('ANGLE$',new(3),1)
  endif
  !
  ! Clark Clean Part
  call gildas_real('GAIN$',gain_loop,1)
  call gildas_inte('NITER$',max_iter,1)
  call gildas_real('FRES$',frac_res,1)
  call gildas_real('ARES$',abs_res,1)
  call gildas_inte('BLC$',c_blc,4)
  call gildas_inte('TRC$',c_trc,4)
  call gildas_logi('KEEP$',keep_cleaning,1)
  call gildas_real('MAJOR$',major_axis,1)
  call gildas_real('MINOR$',minor_axis,1)
  call gildas_real('PA$',pos_angle,1)
  call gildas_inte('BEAM_PATCH$',ix_patch,2)
  !
  call gildas_close
  call get_weightmode('MX',weight_mode,error)
  if (error) goto 99
  !
  ! Redefine some parameters
  if (power_of_two(map_size(1)).le.0 .or. power_of_two(map_size(2)).le.0) then
    call gagout('E-MX,  Only powers of two allowed')
    goto 99
  endif
  if (any(map_cell.eq.0)) then
    call gagout('E-MX,  Specify map cell')
    goto 99
  endif  
  !
  if (shift) then
    call sic_decode(ra_c,new(1),24,error)
    if (error) goto 98
    call sic_decode(dec_c,new(2),360,error)
    if (error) goto 98
    new(3) = new(3)*pi/180.0d0
  endif
  !
  if (weight_mode.eq.'NATU') uniform(1) = -1.0
  map_cell(1) = map_cell(1)*pi/180.0/3600.0   ! In radians
  map_cell(2) = map_cell(2)*pi/180.0/3600.0   ! In radians
  !
  if (ctype.eq.0) ctype = 5
  !
  ! Check cleaning box
  call check_box(map_size(1),map_size(2),c_blc,c_trc)
  call gagout('I-MX,  Parameters read successfully')
  nx = map_size(1)
  ny = map_size(2)
  return
  98    call gagout('E-MX,  Input conversion error on phase center')
  99    call sysexi(fatale)
end subroutine mx_get_parameters
!
subroutine mx_open_clean(hd,hc,hcct,rms,error)
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  use mx_parameters
  !---------------------------------------------------------------------
  ! GILDAS:	MX routine
  !	Open missing input maps
  !	Dirty beam has been copied into B area
  !	Clean Component Table created in C area, after creation in Z.
  !	Residual map is in Y, originally loaded with dirty map
  !	Cleaned map in Z, originally undefined
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hd
  type(gildas), intent(inout) :: hc,hcct
  real, intent(in) :: rms
  logical, intent(out) :: error
  ! Global
  real(8), parameter :: pi=3.141592653589793d0 
  ! Local
  integer :: ier
  character(len=filename_length) :: name
  !
  error = .false.
  !
  call gildas_null (hcct)
  call gdf_copy_header (hd, hcct, error)
  ! Create Clean Component Table 
  hcct%gil%dim(1) = 3
  hcct%gil%dim(2) = max_iter
  !	hcct%gil%dim(3) and hcct%gil%dim(4) as before
  name = map_name
  call sic_parsef(name,hcct%file,' ','.cct')
  hcct%char%code(1) = 'IJV'
  hcct%char%code(2) = 'COMPONENT'
  hcct%gil%convert(:,1) = (/1d0,0d0,1d0/)
  hcct%gil%convert(:,2) = (/1d0,0d0,1d0/)
  hcct%gil%extr_words = 0
  call gdf_create_image(hcct, error)
  if (error) then
    call gagout ('F-MX_CLEAN,  Cannot create clean component table')
    return
  endif
  !
!!  call gdf_allocate (hcct, error)
  allocate (hcct%r3d(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3)), stat=ier)
  error = ier.ne.0
  if (error) then
    call gagout('F-MX_CLEAN,  Cannot allocate Clean Component Table')
    return
  endif
  !
  ! Create clean map 
  call gildas_null(hc)
  call gdf_copy_header (hd, hc, error)
  name = map_name
  call sic_parsef(name,hc%file,' ','.lmv-mx')
  !
  ! Undefine Extrema section
  hc%gil%extr_words = 0
  ! Define resolution
  hc%gil%reso_words = 3
  hc%gil%majo = major_axis
  hc%gil%mino = minor_axis
  hc%gil%posa = pi*pos_angle/180.0
  ! Create noise section
  hc%gil%nois_words = 2
  hc%gil%noise = rms
  !
  call gdf_create_image (hc, error)
  if (error) then
    call gagout('F-MX_CLEAN,  Cannot create clean image')
    return
  endif
  !
  ! Define Clean Image 
!!  call gdf_allocate (hc, error)
  allocate (hc%r3d(hc%gil%dim(1),hc%gil%dim(2),hc%gil%dim(3)), stat=ier)
  error = ier.ne.0
  if (error) then
    call gagout('F-MX_CLEAN,  Cannot allocate clean image')
    return
  endif
end subroutine mx_open_clean
!
subroutine mx_fit_beam(hb,error)
  use image_def
  use mx_parameters
  use fit_beam_tool
  type(gildas), intent(inout) :: hb
  logical, intent(out) :: error
  !
  real :: thre
  !
  if (ix_patch.eq.0) ix_patch = min(map_size(1)/2,128)
  if (iy_patch.eq.0) iy_patch = min(map_size(2)/2,128)
  ix_patch = min(ix_patch,map_size(1)/2)
  iy_patch = min(iy_patch,map_size(2)/2)
  thre = 0.30
  call fibeam ('MX',hb%r2d,map_size(1),map_size(2),   &
     &    ix_patch,iy_patch,thre,major_axis,minor_axis,pos_angle,   &
     &    hb%gil%convert,error)
end subroutine mx_fit_beam

program classic_demo_read
  use classic_api
  implicit none
  !---------------------------------------------------------------------
  !  Demonstration program which reads a Classic file version 2, with a
  ! few entries, and 1 Entry Index, 1 section, and 1 data array per
  ! entry. The input file 'foo.bin' should have created first with the
  ! writing demonstration program.
  !
  !  * Entry Index:
  !     - Entry starting record  (I*8)
  !     - Entry starting word    (I*4)
  !     - Dummy 'foo' value      (I*4)
  !  * Section:
  !     - One R*4 value
  !     - One R*8 value
  !     - One I*4 value
  !     - One I*8 value
  !     - One C*8 value
  !  * Data:
  !     - Array of 10 R*4 values
  !---------------------------------------------------------------------
  type(classic_recordbuf_t) :: rbufind,rbufobs
  integer(kind=entry_length) :: ientry
  logical :: error
  ! File
  type(classic_file_t) :: file
  integer(kind=4), parameter :: file_lun=50  ! Arbitrary value
  character(len=*), parameter :: file_name='foo.bin'
  logical, parameter :: file_readwrite=.false.  ! Open the file read-only
  ! File Descriptor
  integer(kind=4), parameter :: fdesc_kind=classic_kind_demo
  ! Entry Index
  integer(kind=4), parameter :: ind_version=123  ! Index version (arbitrary value)
  integer(kind=4), parameter :: ind_length=4  ! 1 I*8, 2 I*4
  integer(kind=8) :: ind_rstart
  integer(kind=4) :: ind_wstart
  integer(kind=4) :: ind_foo
  integer(kind=4) :: bufind(ind_length)  ! Buffer for byte-swapping one index
  ! Entry Descriptor
  type(classic_entrydesc_t) :: edesc
  integer(kind=4), parameter :: edesc_version=456  ! Observation version (arbitrary value)
  ! Section
  integer(kind=4), parameter :: sec_id=789  ! Identifier (arbitrary value)
  integer(kind=data_length), parameter :: sec_length_max=8  ! Max section length
  integer(kind=data_length) :: sec_length                   ! Actual section length
  real(kind=4) :: sec_r4
  real(kind=8) :: sec_r8
  integer(kind=4) :: sec_i4
  integer(kind=8) :: sec_i8
  character(len=8) :: sec_c8
  integer(kind=4) :: bufsec(sec_length_max)  ! Buffer for byte-swapping one section
  ! Data
  integer(kind=data_length), parameter :: dat_length_max=10  ! Max data length
  integer(kind=data_length) :: dat_length                    ! Actual data length
  real(kind=4) :: data(dat_length_max)
  real(kind=4) :: bufdat(dat_length_max)  ! Buffer for byte-swapping one data block
  !
  write(*,'(A)')  '--- Welcome to the Classic demonstration reading program ---'
  !
  error = .false.
  !
  ! Initialize the Classic library
  call classic_init(error)
  if (error)  stop
  !
  file%lun = file_lun
  file%spec = file_name
  file%nspec = len_trim(file%spec)
  file%update = .false.
  call classic_file_open(file,file_readwrite,error)
  if (error)  stop
  !
  call classic_filedesc_open(file,error)
  if (error)  stop
  write(*,*) ''
  write(*,'(A)')  'File Descriptor:'
  call classic_filedesc_dump(file%desc,'r')
  !
  if (file%desc%kind.ne.fdesc_kind) then
    write(*,*) 'Error: unexpected file kind'
    stop
  elseif (file%desc%vind.ne.ind_version) then
    write(*,*) 'Error: unsupported index version'
    stop
  endif
  !
  call reallocate_recordbuf(rbufind,file%desc%reclen,error)
  if (error)  stop
  call reallocate_recordbuf(rbufobs,file%desc%reclen,error)
  if (error)  stop
  !
  do ientry=1,file%desc%xnext-1  ! Read all entries
    write(*,*) ''
    write(*,'(A,I0)') 'Reading entry #',ientry
    !
    ! Read the Entry Index
    call classic_entryindex_read(file,ientry,bufind,rbufind,error)
    if (error)  stop
    ! Entry Index can be anything => byte swapping is application specific
    call classic_demo_buf2ind(bufind,ind_rstart,ind_wstart,ind_foo,file%conv)
    if (error)  stop
    write(*,'(A,I0,1X,I0,1X,I0)')  &
      '  INDEX: ',ind_rstart,ind_wstart,ind_foo
    !
    ! Set the working buffer
    call classic_recordbuf_open(file,ind_rstart,ind_wstart,rbufobs,error)
    if (error)  stop
    !
    ! Read the Entry Descriptor
    call classic_entrydesc_read(file,rbufobs,edesc,error)
    if (error)  stop
    write(*,'(A,I0,1X,I0,1X,I0,1X,I0)')  &
      '  DESCRIPTOR: ',edesc%nsec,edesc%nword,edesc%adata,edesc%ldata
    if (edesc%version.ne.edesc_version) then
      write(*,*) 'Error: unsupported observation version'
      stop
    endif
    !
    ! Read section by identifier
    sec_length = sec_length_max  ! Updated in return
    call classic_entry_section_read(sec_id,sec_length,bufsec,edesc,rbufobs,  &
      error)
    if (error)  stop
    ! Section can be anything => byte swapping is application specific
    call classic_demo_buf2sec(bufsec,sec_r4,sec_r8,sec_i4,sec_i8,sec_c8,  &
      file%conv)
    write(*,'(A,F0.2,1X,F0.4,1X,I0,1X,I0,1X,A)')   &
      '  SECTION: ',sec_r4,sec_r8,sec_i4,sec_i8,sec_c8
    !
    ! Data
    dat_length = dat_length_max  ! Updated in return
    call classic_entry_data_read(bufdat,dat_length,edesc,rbufobs,error)
    if (error)  stop
    call classic_demo_buf2dat(int(dat_length,kind=4),bufdat,data,file%conv)
    write(*,'(A,I0,A,10(1X,F0.2))')  &
      '  DATA (',dat_length,' values): ',data(1:dat_length)
    !
  enddo
  !
  call classic_file_close(file,error)
  if (error)  stop
  !
  call deallocate_recordbuf(rbufobs,error)
  if (error)  stop
  call deallocate_recordbuf(rbufind,error)
  if (error)  stop
  !
  write(*,*) ''
  write(*,'(A,A,A)') 'File ',trim(file%spec),' successfully read'
  !
contains
  !
  subroutine classic_demo_buf2ind(buf,rec,word,foo,conv)
    use gildas_def
    use gkernel_interfaces
    use classic_api
    !---------------------------------------------------------------------
    ! Copy the Entry Index into the given buffer, swap bytes if needed
    !---------------------------------------------------------------------
    integer(kind=4),          intent(in)  :: buf(*)
    integer(kind=8),          intent(out) :: rec
    integer(kind=4),          intent(out) :: word
    integer(kind=4),          intent(out) :: foo
    type(classic_fileconv_t), intent(in)  :: conv
    !
    call conv%read%i8(buf(1),rec, 1)  ! 1-2: record
    call conv%read%i4(buf(3),word,1)  !   3: word
    call conv%read%i4(buf(4),foo, 1)  !   4: foo
    !
  end subroutine classic_demo_buf2ind
  !
  subroutine classic_demo_buf2sec(buf,r4,r8,i4,i8,c8,conv)
    use gildas_def
    use gkernel_interfaces
    use classic_api
    !---------------------------------------------------------------------
    ! Copy the section values into the given buffer, swap bytes if needed
    !---------------------------------------------------------------------
    integer(kind=4),          intent(in)  :: buf(*)
    real(kind=4),             intent(out) :: r4
    real(kind=8),             intent(out) :: r8
    integer(kind=4),          intent(out) :: i4
    integer(kind=8),          intent(out) :: i8
    character(len=*),         intent(out) :: c8
    type(classic_fileconv_t), intent(in)  :: conv
    !
    call conv%read%r4(buf(1),r4,1)  !   1: R*4
    call conv%read%r8(buf(2),r8,1)  ! 2-3: R*8
    call conv%read%i4(buf(4),i4,1)  !   4: I*4
    call conv%read%i8(buf(5),i8,1)  ! 5-6: I*8
    call conv%read%cc(buf(7),c8,2)  ! 7-8: C*8
    !
  end subroutine classic_demo_buf2sec
  !
  subroutine classic_demo_buf2dat(ldata,buf,data,conv)
    use gildas_def
    use gkernel_interfaces
    use classic_api
    !---------------------------------------------------------------------
    ! Copy the Data array into the given buffer, swap bytes if needed
    !---------------------------------------------------------------------
    integer(kind=4),          intent(in)  :: ldata
    real(kind=4),             intent(in)  :: buf(ldata)
    real(kind=4),             intent(out) :: data(ldata)
    type(classic_fileconv_t), intent(in)  :: conv
    !
    call conv%read%r4(buf,data,ldata)
    !
  end subroutine classic_demo_buf2dat
  !
end program classic_demo_read

subroutine gr4_extrema (nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Find extrema of a (Real*4) array.
  ! +/- Infinity are considered as valid extrema is this routine
  ! See GR4_MINMAX for a version which ignores Infinity
  !
  !     Ignore NaNs and all "blanked" values.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy     ! Number of values
  real(kind=4),              intent(in)    :: z(nxy)  ! Values
  real(kind=4),              intent(in)    :: bval    ! Blanking
  real(kind=4),              intent(in)    :: eval    ! Tolerance
  real(kind=4),              intent(inout) :: zmin    ! Unchanged if no valid value
  real(kind=4),              intent(inout) :: zmax    ! Unchanged if no valid value
  integer(kind=size_length), intent(out)   :: nmin    ! Set to 0 if no valid value
  integer(kind=size_length), intent(out)   :: nmax    ! Set to 0 if no valid value
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  integer(kind=size_length) :: i,j
  !
  j = nxy+1
  nmin = 0
  nmax = 0
  if (eval.lt.0.0) then
    do i=1,nxy
      if (z(i).eq.z(i)) then
        zmin = z(i)
        zmax = z(i)
        nmin = i
        nmax = i
        j = i
        exit
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      endif
    enddo
  else
    do i=1,nxy
      if (z(i).eq.z(i)) then
        !
        !     Tests are not equivalent if BVAL is a NaN!
        !     IF (ABS(Z(I)-BVAL).GT.EVAL) THEN
        if (.not.(abs(z(i)-bval).le.eval)) then
          zmin = z(i)
          zmax = z(i)
          nmin = i
          nmax = i
          j = i
          exit
        endif
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (.not.(abs(z(i)-bval).le.eval)) then
          if (z(i).lt.zmin) then
            zmin = z(i)
            nmin = i
          elseif (z(i).gt.zmax) then
            zmax = z(i)
            nmax = i
          endif
        endif
      endif
    enddo
  endif
end subroutine gr4_extrema
!
subroutine gr8_extrema (nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Find extrema of a (Real*8) array
  ! +/- Infinity are considered as valid extrema is this routine
  ! See GR8_MINMAX for a version which ignores Infinity
  !!
  !     Ignore NaNs and all "blanked" values.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy     ! Number of values
  real(kind=8),              intent(in)    :: z(nxy)  ! Values
  real(kind=4),              intent(in)    :: bval    ! Blanking
  real(kind=4),              intent(in)    :: eval    ! Tolerance
  real(kind=4),              intent(inout) :: zmin    ! Unchanged if no valid value
  real(kind=4),              intent(inout) :: zmax    ! Unchanged if no valid value
  integer(kind=size_length), intent(out)   :: nmin    ! Set to 0 if no valid value
  integer(kind=size_length), intent(out)   :: nmax    ! Set to 0 if no valid value
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  integer(kind=size_length) :: i,j
  !
  j = nxy+1
  nmin = 0
  nmax = 0
  if (eval.lt.0.0) then
    do i=1,nxy
      if (z(i).eq.z(i)) then
        zmin = z(i)
        zmax = z(i)
        nmin = i
        nmax = i
        j = i
        exit
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      endif
    enddo
  else
    do i=1,nxy
      if (z(i).eq.z(i)) then
        !
        !     Tests are not equivalent if BVAL is a NaN!
        !     IF (ABS(Z(I)-BVAL).GT.EVAL) THEN
        if (.not.(abs(z(i)-bval).le.eval)) then
          zmin = z(i)
          zmax = z(i)
          nmin = i
          nmax = i
          j = i
          exit
        endif
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (.not.(abs(z(i)-bval).le.eval)) then
          if (z(i).lt.zmin) then
            zmin = z(i)
            nmin = i
          elseif (z(i).gt.zmax) then
            zmax = z(i)
            nmax = i
          endif
        endif
      endif
    enddo
  endif
end subroutine gr8_extrema
!
subroutine gr4_minmax(nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_minmax
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Protect against NaN and INFs even without blanking
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nxy     !
  real(kind=4),              intent(in)  :: z(nxy)  !
  real(kind=4),              intent(in)  :: bval    !
  real(kind=4),              intent(in)  :: eval    !
  real(kind=4),              intent(out) :: zmin    !
  real(kind=4),              intent(out) :: zmax    !
  integer(kind=size_length), intent(out) :: nmin    !
  integer(kind=size_length), intent(out) :: nmax    !
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=size_length) :: i,j,cnt_nan,cnt_inf,cnt_bla
  character(len=message_length) :: chain
  !
  ! Default values if no valid data found
  zmin = bval
  zmax = bval
  nmin = 1
  nmax = 1
  !
  cnt_nan=0
  cnt_inf=0
  cnt_bla=0
  do j=1,nxy
    if (sic_fini4(z(j)))then
      if(abs(z(j)-bval).gt.eval) then
        zmin = z(j)
        zmax = z(j)
        nmin = j
        nmax = j
        goto 10
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(j).eq.z(j))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  !
10 continue
  do i=j+1,nxy
    if (sic_fini4(z(i)))then
      if (abs(z(i)-bval).gt.eval) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(i).eq.z(i))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  if (cnt_nan+cnt_inf+cnt_bla.eq.0) return
  !
  ! Debug (these messages are too much verbose for a daily use)
  if (cnt_nan.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_nan,' NaNs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_inf.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_inf,' INFs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_bla.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_bla,' blanks'
    call gmath_message(seve%d,rname,chain)
  endif
  !
  if (cnt_nan+cnt_inf+cnt_bla.eq.nxy)  &
    call gmath_message(seve%w,rname,'No valid data found')
  !
end subroutine gr4_minmax
!
subroutine gr8_minmax(nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_minmax
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Protect against NaN and INFs even without blanking
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nxy     !
  real(kind=8),              intent(in)  :: z(nxy)  !
  real(kind=8),              intent(in)  :: bval    !
  real(kind=8),              intent(in)  :: eval    !
  real(kind=8),              intent(out) :: zmin    !
  real(kind=8),              intent(out) :: zmax    !
  integer(kind=size_length), intent(out) :: nmin    !
  integer(kind=size_length), intent(out) :: nmax    !
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=size_length) :: i,j,cnt_nan,cnt_inf,cnt_bla
  character(len=message_length) :: chain
  !
  ! Default values if no valid data found
  zmin = bval
  zmax = bval
  nmin = 1
  nmax = 1
  !
  cnt_nan=0
  cnt_inf=0
  cnt_bla=0
  do j=1,nxy
    if (sic_fini8(z(j)))then
      if (abs(z(j)-bval).gt.eval) then
        zmin = z(j)
        zmax = z(j)
        nmin = j
        nmax = j
        goto 10
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(j).eq.z(j))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  !
10 continue
  do i=j,nxy
    if (sic_fini8(z(i)))then
      if (abs(z(i)-bval).gt.eval) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(i).eq.z(i))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  if (cnt_nan+cnt_inf+cnt_bla.eq.0) return
  !
  ! Debug (these messages are too much verbose for a daily use)
  if (cnt_nan.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_nan,' NaNs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_inf.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_inf,' INFs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_bla.gt.0) then
    ! Debug (message is too much verbose for a daily use)
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_bla,' blanks'
    call gmath_message(seve%d,rname,chain)
  endif
  !
  if (cnt_nan+cnt_inf+cnt_bla.eq.nxy)  &
    call gmath_message(seve%w,rname,'No valid data found')
  !
end subroutine gr8_minmax
!
subroutine gr4_load(in,out,n,bval,eval,m)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Copy input array into output array, but remove blanked values if
  ! any. Return the number of elements kept accordingly. Real*4 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n       ! Number of elements to copy
  real(kind=4),              intent(in)  :: in(n)   ! Input array
  real(kind=4),              intent(out) :: out(n)  ! Output array
  real(kind=4),              intent(in)  :: bval    ! Blanking value
  real(kind=4),              intent(in)  :: eval    ! Error value for blanking
  integer(kind=size_length), intent(out) :: m       ! Number elements kept
  ! Local
  integer(kind=size_length) :: i
  !
  if (eval.lt.0.) then
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      m = m+1
      out(m) = in(i)
    enddo
  else
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      if (abs(in(i)-bval).le.eval) cycle
      m = m+1
      out(m) = in(i)
    enddo
  endif
end subroutine gr4_load
!
subroutine gr8_load(in,out,n,bval,eval,m)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Copy input array into output array, but remove blanked values if
  ! any. Return the number of elements kept accordingly. Real*8 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n       !
  real(kind=8),              intent(in)  :: in(n)   !
  real(kind=8),              intent(out) :: out(n)  !
  real(kind=8),              intent(in)  :: bval    !
  real(kind=8),              intent(in)  :: eval    !
  integer(kind=size_length), intent(out) :: m       !
  ! Local
  integer(kind=size_length) :: i
  !
  if (eval.lt.0.d0) then
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      m = m+1
      out(m) = in(i)
    enddo
  else
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      if (abs(in(i)-bval).le.eval) cycle
      m = m+1
      out(m) = in(i)
    enddo
  endif
end subroutine gr8_load
!
subroutine gr4_median(data,ndata,bval,eval,median,error)
  use gildas_def
  use gmath_interfaces, except_this=>gr4_median
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ndata        ! Array size
  real(kind=4),              intent(in)    :: data(ndata)  ! Data
  real(kind=4),              intent(in)    :: bval         ! Blanking value
  real(kind=4),              intent(in)    :: eval         ! Tolerance
  real(kind=4),              intent(inout) :: median       ! Median of input array
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MEDIAN'
  integer(kind=4) :: ier
  integer(kind=size_length) :: nwork
  real(kind=4), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  !
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr4_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr4_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output median value unmodified on return
    goto 10
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  call gr4_trie(work,indices,int(nwork,kind=4),error)
  if (error) goto 10
  !
  if (mod(nwork,2).eq.0) then
    median = (work(nwork/2)+work((nwork/2)+1))/2.0
  else
    median = work((nwork+1)/2)
  endif
  !
10 continue
  if (allocated(work)) deallocate(work)
  if (allocated(indices)) deallocate(indices)
  !
end subroutine gr4_median
!
subroutine gr8_median(data,ndata,bval,eval,median,error)
  use gildas_def
  use gmath_interfaces, except_this=>gr8_median
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ndata        ! Array size
  real(kind=8),              intent(in)    :: data(ndata)  ! Data
  real(kind=8),              intent(in)    :: bval         ! Blanking value
  real(kind=8),              intent(in)    :: eval         ! Tolerance
  real(kind=8),              intent(inout) :: median       ! Median of input array
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MEDIAN'
  integer(kind=4) :: ier
  integer(kind=size_length) :: nwork
  real(kind=8), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  !
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr8_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr8_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output median value unmodified on return
    goto 10
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  call gr8_trie(work,indices,int(nwork,kind=4),error)
  if (error) goto 10
  !
  if (mod(nwork,2).eq.0) then
    median = (work(nwork/2)+work((nwork/2)+1))/2.d0
  else
    median = work((nwork+1)/2)
  endif
  !
10 continue
  if (allocated(work)) deallocate(work)
  if (allocated(indices)) deallocate(indices)
  !
end subroutine gr8_median
!
subroutine gr4_dicho(np,x,xval,ival)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: np     ! Number of input points
  real(kind=4),              intent(in)  :: x(np)  ! Input ordered Values
  real(kind=4),              intent(in)  :: xval   ! The value we search for
  integer(kind=size_length), intent(out) :: ival   ! Position in the array
  ! Local
  integer(kind=size_length) :: iinf,isup,imid
  !
  if (x(1).gt.xval) then
    ival = 0
    return
  elseif (x(1).eq.xval) then
    ival = 1
    return
  elseif (x(np).lt.xval) then
    ival = np
    return
  endif
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)
    imid = (isup + iinf)/2
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ival = isup
  !
end subroutine gr4_dicho
!
subroutine gr8_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  real(kind=8),              intent(in)    :: x(np)  ! Input ordered Values
  real(kind=8),              intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,F0.8,A,F0.8,A,F0.8,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
  ! If no exact match, the requested value is in between. Returned value
  ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gr8_dicho
!
subroutine gi4_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  integer(kind=4),           intent(in)    :: x(np)  ! Input ordered Values
  integer(kind=4),           intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,I0,A,I0,A,I0,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
    ! If no exact match, the requested value is in between. Returned value
    ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gi4_dicho
!
subroutine gi8_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  integer(kind=8),           intent(in)    :: x(np)  ! Input ordered Values
  integer(kind=8),           intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,I0,A,I0,A,I0,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
  ! If no exact match, the requested value is in between. Returned value
  ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gi8_dicho
!
subroutine gi4_dicho_with_user_ltgt(np,ceil,ival,ult,ugt,error)
  use gildas_def
  use gmath_interfaces, except_this=>gi4_dicho_with_user_ltgt
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gi0_dicho_with_user_ltgt
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: np     ! Number of elements in array
  logical,         intent(in)    :: ceil   ! Ceiling mode?
  integer(kind=4), intent(out)   :: ival   ! Deduced position in the array
  logical,         external      :: ult    ! User lower than
  logical,         external      :: ugt    ! User greater than
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=4) :: iinf,isup,imid
  !
  if (ugt(1) .or. ult(np)) then
    call gmath_message(seve%e,rname,'Input value is out of range')
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (ult(imid)) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  if (ult(iinf).and.ugt(isup)) then
    ! We are in between (boundaries excluded), output depends on ceiling or
    ! floor mode
    if (ceil) then
      ival = isup
    else
      ival = iinf
    endif
    !
  else
    ! Not in between: we match one of the 2 boundaries
    if (ult(iinf)) then
      ival = isup
    else
      ival = iinf
    endif
  endif
  !
end subroutine gi4_dicho_with_user_ltgt
!
subroutine gi8_dicho_with_user_ltgt(np,ceil,ival,ult,ugt,error)
  use gildas_def
  use gmath_interfaces, except_this=>gi8_dicho_with_user_ltgt
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gi0_dicho_with_user_ltgt
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: np     ! Number of elements in array
  logical,         intent(in)    :: ceil   ! Ceiling mode?
  integer(kind=8), intent(out)   :: ival   ! Deduced position in the array
  logical,         external      :: ult    ! User lower than
  logical,         external      :: ugt    ! User greater than
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=8) :: iinf,isup,imid
  !
  if (ugt(1_8) .or. ult(np)) then
    call gmath_message(seve%e,rname,'Input value is out of range')
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (ult(imid)) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  if (ult(iinf).and.ugt(isup)) then
    ! We are in between (boundaries excluded), output depends on ceiling or
    ! floor mode
    if (ceil) then
      ival = isup
    else
      ival = iinf
    endif
    !
  else
    ! Not in between: we match one of the 2 boundaries
    if (ult(iinf)) then
      ival = isup
    else
      ival = iinf
    endif
  endif
  !
end subroutine gi8_dicho_with_user_ltgt
!
subroutine gr4_mean(x,nelem,bval,eval,out)
  !$ use omp_lib
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_mean
  !---------------------------------------------------------------------
  ! @ public
  !   Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !   R*4 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nelem     ! Number of data values
  real(kind=4),              intent(in)  :: x(nelem)  ! Data values to compute
  real(kind=4),              intent(in)  :: bval      ! Blanking value
  real(kind=4),              intent(in)  :: eval      ! Blanking tolerance
  real(kind=4),              intent(out) :: out       ! Output scalar value
  ! Local
  integer(kind=size_length) :: ielem,nvalid
  real(kind=4) :: nan,lastchanceretval
  ! We need an intermediate real*8 array to avoid precision loss
  ! in case of a very large number of values...
  real(kind=8) :: dout
  !
  if (eval.ge.0.) then
    lastchanceretval = bval
  else
    call gag_notanum(nan)
    lastchanceretval = nan
  endif
  out = lastchanceretval
  if (nelem.lt.1) return
  !
  ! Now we can compute
  dout = 0.
  nvalid = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(nelem,x,bval,eval,nvalid,dout) &
  !$OMP PRIVATE(ielem)
  !$OMP DO REDUCTION(+:dout,nvalid)
  do ielem=1,nelem
    if (x(ielem).eq.x(ielem)) then
      if (eval.lt.0.) then
        dout = dout + x(ielem)
        nvalid = nvalid+1
      else
        if (abs(x(ielem)-bval).gt.eval) then
          dout = dout + x(ielem)
          nvalid = nvalid+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (nvalid.gt.0) then
    out = dout/real(nvalid)
  else
    out = lastchanceretval
  endif
  !
end subroutine gr4_mean
!
subroutine gr8_mean(x,nelem,bval,eval,out)
  !$ use omp_lib
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_mean
  !---------------------------------------------------------------------
  ! @ public
  !   Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !   R*8 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nelem     ! Number of data values
  real(kind=8),              intent(in)  :: x(nelem)  ! Data values to compute
  real(kind=8),              intent(in)  :: bval      ! Blanking value
  real(kind=8),              intent(in)  :: eval      ! Blanking tolerance
  real(kind=8),              intent(out) :: out       ! Output scalar value
  ! Local
  integer(kind=size_length) :: ielem,nvalid
  real(kind=8) :: nan,lastchanceretval
  !
  if (eval.ge.0.d0) then
    lastchanceretval = bval
  else
    call gag_notanum(nan)
    lastchanceretval = nan
  endif
  out = lastchanceretval
  if (nelem.lt.1) return
  !
  ! Now we can compute
  out = 0.d0
  nvalid = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(nelem,x,bval,eval,nvalid,out) &
  !$OMP PRIVATE(ielem)
  !$OMP DO REDUCTION(+:out,nvalid)
  do ielem=1,nelem
    if (x(ielem).eq.x(ielem)) then
      if (eval.lt.0.d0) then
        out = out + x(ielem)
        nvalid = nvalid+1
      else
        if (abs(x(ielem)-bval).gt.eval) then
          out = out + x(ielem)
          nvalid = nvalid+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  if (nvalid.gt.0) then
    out = out/nvalid
  else
    out = lastchanceretval
  endif
  !
end subroutine gr8_mean
!
subroutine gr4_quantile(data,ndata,bval,eval,quant,nquant,error)
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_quantile
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the k-quantiles (i.e. the k-1 values which split the data in
  ! k subsets of equal or almost-equal sizes) of the input data array in
  ! quant(nquant).
  ! For convenience the 0-th (minimum value) and the k-th (maximum
  ! value) quantiles of the data are also returned. Which means:
  ! - the median (2-quantile) needs nquant=3
  ! - quartiles               need  nquant=5
  ! and so on.
  ! - nquant = 2 will return only the min-max values
  ! - nquant = 1 will return only the min value
  !---------------------------------------------------------------------
  integer(kind=size_length),  intent(in)    :: ndata          ! Array size
  real(kind=4),               intent(in)    :: data(ndata)    ! Data
  real(kind=4),               intent(in)    :: bval           ! Blanking value
  real(kind=4),               intent(in)    :: eval           ! Tolerance
  integer(kind=index_length), intent(in)    :: nquant         ! Number of quantiles
  real(kind=4),               intent(inout) :: quant(nquant)  ! Quantiles of input array
  logical,                    intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='QUANTILE'
  integer(kind=4) :: ier,iquant
  integer(kind=size_length) :: nwork,fwork,cwork
  real(kind=4), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  real(kind=8) :: rwork
  !
  ! Sanity check
  if (nquant.le.0) then
    call gmath_message(seve%e,rname,'Null or negative quantile count')
    error = .true.
    return
  endif
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (failed_allocate(rname,'work',ier,error))  return
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr4_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr4_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output quantile values unmodified on return
    return
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (failed_allocate(rname,'indices',ier,error))  return
  !
  call gr4_trie(work,indices,int(nwork,kind=4),error)
  if (error)  return
  !
  ! Fill the quantile. Be careful for the stupid cases where nquant>=ndata.
  ! Also works for boundaries:
  !   quant(1) = work(1)
  !   quant(nquant) = work(nwork)
  if (nquant.eq.1) then
    quant(1) = work(1)
  else
    do iquant=1,nquant
      rwork = 1+(nwork-1)*real(iquant-1,kind=8)/real(nquant-1,kind=8)
      fwork = floor(rwork,kind=size_length)
      cwork = ceiling(rwork,kind=size_length)
      if (fwork.eq.cwork) then
        quant(iquant) = work(fwork)
      else
        quant(iquant) = work(fwork)*(cwork-rwork) + &
                        work(cwork)*(rwork-fwork)
      endif
    enddo
  endif
end subroutine gr4_quantile
!
subroutine gr8_quantile(data,ndata,bval,eval,quant,nquant,error)
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_quantile
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the k-quantiles (i.e. the k-1 values which split the data in
  ! k subsets of equal or almost-equal sizes) of the input data array in
  ! quant(nquant).
  ! For convenience the 0-th (minimum value) and the k-th (maximum
  ! value) quantiles of the data are also returned. Which means:
  ! - the median (2-quantile) needs nquant=3
  ! - quartiles               need  nquant=5
  ! and so on.
  ! - nquant = 2 will return only the min-max values
  ! - nquant = 1 will return only the min value
  !---------------------------------------------------------------------
  integer(kind=size_length),  intent(in)    :: ndata          ! Array size
  real(kind=8),               intent(in)    :: data(ndata)    ! Data
  real(kind=8),               intent(in)    :: bval           ! Blanking value
  real(kind=8),               intent(in)    :: eval           ! Tolerance
  integer(kind=index_length), intent(in)    :: nquant         ! Number of quantiles
  real(kind=8),               intent(inout) :: quant(nquant)  ! Quantiles of input array
  logical,                    intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='QUANTILE'
  integer(kind=4) :: ier,iquant
  integer(kind=size_length) :: nwork,fwork,cwork
  real(kind=8), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  real(kind=8) :: rwork
  !
  ! Sanity check
  if (nquant.le.0) then
    call gmath_message(seve%e,rname,'Null or negative quantile count')
    error = .true.
    return
  endif
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (failed_allocate(rname,'work',ier,error))  return
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr8_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr8_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output quantile values unmodified on return
    return
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (failed_allocate(rname,'indices',ier,error))  return
  !
  call gr8_trie(work,indices,int(nwork,kind=4),error)
  if (error)  return
  !
  ! Fill the quantile. Be careful for the stupid cases where nquant>=ndata.
  ! Also works for boundaries:
  !   quant(1) = work(1)
  !   quant(nquant) = work(nwork)
  if (nquant.eq.1) then
    quant(1) = work(1)
  else
    do iquant=1,nquant
      rwork = 1+(nwork-1)*real(iquant-1,kind=8)/real(nquant-1,kind=8)
      fwork = floor(rwork,kind=size_length)
      cwork = ceiling(rwork,kind=size_length)
      if (fwork.eq.cwork) then
        quant(iquant) = work(fwork)
      else
        quant(iquant) = work(fwork)*(cwork-rwork) + &
                        work(cwork)*(rwork-fwork)
      endif
    enddo
  endif
end subroutine gr8_quantile

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_access_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  !***JP: The module is called cubetools_accessorder_types but the types are called order_*_t!
  !***JP: For me, it's unclear whether the /KEY IMAGE|SPECTRUM always refer to the access order.
  !***JP: It could also means produce an IMAGE or a SPECTRUM with crossed access
  !
  public :: order_comm_t,order_user_t,order_prog_t
  !
  public :: cubetools_accessname,cubetools_ordername
  public :: cubetools_order2ext,cubetools_access2ext,cubetools_access2order,cubetools_order2access
  public :: cubetools_transpose_order,cubetools_transpose_access,cubetools_transpose_operator
  private
  !
  integer(kind=4), parameter :: norders=2
  character(len=*), parameter :: orders(norders) = (/ 'IMAGE   ','SPECTRUM' /)
  !
  ! Support for /KEY IMAGE|SPECTRUM
  type :: order_comm_t
    type(option_t),      pointer :: opt
    type(keywordlist_comm_t), pointer :: arg
  contains
    procedure, public :: register => cubetools_order_comm_register
    procedure, public :: parse    => cubetools_order_comm_parse
  end type order_comm_t
  type :: order_user_t
    logical               :: do
    character(len=argu_l) :: arg
  contains
    procedure, public :: toprog => cubetools_order_user_toprog
  end type order_user_t
  type :: order_prog_t
    integer(kind=code_k) :: code
  end type order_prog_t
  !
contains
  !
  subroutine cubetools_order_comm_register(order,name,abstract,help,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(order_comm_t), intent(inout) :: order
    character(len=*),    intent(in)    :: name      ! Command name
    character(len=*),    intent(in)    :: abstract  ! Command abstract
    character(len=*),    intent(in)    :: help      ! Command help
    logical,             intent(inout) :: error
    !
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='ORDER>COMM>REGISTER'
    !
    call cubetools_register_option(&
         name,'Order',&
         abstract,&
         help,&
         order%opt,error)
    if (error) return
    call keyarg%register( &
         'Order', &
         'Order name',  &
         strg_emp,&
         code_arg_mandatory,  &
         orders, &
         .not.flexible,&
         order%arg,&
         error)
    if (error) return
  end subroutine cubetools_order_comm_register
  !
  subroutine cubetools_order_comm_parse(order,line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(order_comm_t), intent(in)    :: order
    character(len=*),    intent(in)    :: line
    type(order_user_t),  intent(inout) :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='ORDER>COMM>PARSE'
    !
    call order%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
      call cubetools_getarg(line,order%opt,1,user%arg,mandatory,error)
      if (error) return
    endif
  end subroutine cubetools_order_comm_parse
  !
  subroutine cubetools_order_user_toprog(user,order,default,prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(order_user_t),  intent(in)    :: user
    type(order_comm_t),   intent(in)    :: order
    integer(kind=code_k), intent(in)    :: default
    type(order_prog_t),   intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=12) :: key
    integer(kind=4) :: iorder
    character(len=*), parameter :: rname='ORDER>USER>TOPROG'
    !
    if (user%do) then
      call cubetools_keywordlist_user2prog(order%arg,user%arg,iorder,key,error)
      if (error) return
      select case (key)
      case ('IMAGE')
        prog%code = code_access_imaset
      case ('SPECTRUM')
        prog%code = code_access_speset
      case default
        call cubesyntax_message(seve%e,rname,'Unknown access')
        error = .true.
        return
      end select
    else
      prog%code = default
    endif
  end subroutine cubetools_order_user_toprog
  !
  !---------------------------------------------------------------------
  !
  function cubetools_accessname(access)
    !---------------------------------------------------------------------
    ! Return the name of the access given its code
    !---------------------------------------------------------------------
    character(len=7) :: cubetools_accessname
    integer(kind=code_k), intent(in) :: access
    !
    select case (access)
    case (code_access_imaset)
      cubetools_accessname = 'ImaSet'
    case (code_access_speset)
      cubetools_accessname = 'SpeSet'
    case (code_access_subset)
      cubetools_accessname = 'SubSet'
    case (code_access_blobset)
      cubetools_accessname = 'BlobSet'
    case (code_access_fullset)
      cubetools_accessname = 'FullSet'
    case default
      cubetools_accessname = '???'
    end select
  end function cubetools_accessname
  !
  function cubetools_ordername(order)
    !---------------------------------------------------------------------
    ! Return the name of the order given its code
    !---------------------------------------------------------------------
    character(len=6) :: cubetools_ordername
    integer(kind=code_k), intent(in) :: order
    !
    select case (order)
    case (code_cube_unkset)
      cubetools_ordername = 'UnkSet'
    case (code_cube_speset)
      cubetools_ordername = 'SpeSet'
    case (code_cube_imaset)
      cubetools_ordername = 'ImaSet'
    case default
      cubetools_ordername = '???'
    end select
  end function cubetools_ordername
  !
  function cubetools_order2ext(order)
    !---------------------------------------------------------------------
    ! Return the default extension suited for the input order mode.
    !---------------------------------------------------------------------
    character(len=exte_l) :: cubetools_order2ext
    integer(kind=code_k), intent(in) :: order
    !
    select case (order)
    case (code_cube_imaset)
       cubetools_order2ext = '.lmv'
    case (code_cube_speset)
       cubetools_order2ext = '.vlm'
    case default
       cubetools_order2ext = '.unk'
    end select
  end function cubetools_order2ext
  !
  function cubetools_access2ext(access)
    !---------------------------------------------------------------------
    ! Return the default extension suited for the input access mode.
    !---------------------------------------------------------------------
    character(len=exte_l) :: cubetools_access2ext
    integer(kind=4), intent(in) :: access
    !
    select case (access)
    case (code_access_imaset)
       cubetools_access2ext = '.lmv'
    case (code_access_speset)
       cubetools_access2ext = '.vlm'
    case default
       cubetools_access2ext = '.unk'
    end select
  end function cubetools_access2ext
  !
  function cubetools_access2order(access)
    !--------------------------------------------------------------------- 
    ! Return the order suited for the input access mode.
    !---------------------------------------------------------------------
    integer(kind=4) :: cubetools_access2order
    integer(kind=4), intent(in) :: access  ! code_access_*
    !
    select case (access)
    case (code_access_imaset)
       cubetools_access2order = code_cube_imaset
    case (code_access_speset)
       cubetools_access2order = code_cube_speset
    case default
       cubetools_access2order = code_null
    end select
  end function cubetools_access2order
  !
  function cubetools_order2access(order)
    use cubetools_parameters
    !---------------------------------------------------------------------
    ! Return the access mode suited for the input order.
    !---------------------------------------------------------------------
    integer(kind=4) :: cubetools_order2access  ! code_cube_*
    integer(kind=4), intent(in) :: order
    !
    select case (order)
    case (code_cube_imaset)
       cubetools_order2access = code_access_imaset
    case (code_cube_speset)
       cubetools_order2access = code_access_speset
    case (code_cube_unkset)
       cubetools_order2access = code_access_any
    case default
       cubetools_order2access = code_null
    end select
  end function cubetools_order2access
  !
  !------------------------------------------------------------------------
  !
  function cubetools_transpose_order(code_order)
    !----------------------------------------------------------------------
    ! Transpose the data order:  LMV <-> VLM
    !----------------------------------------------------------------------
    integer(kind=4)             :: cubetools_transpose_order
    integer(kind=4), intent(in) :: code_order
    !
    select case (code_order)
    case (code_cube_imaset)
      cubetools_transpose_order = code_cube_speset
    case (code_cube_speset)
      cubetools_transpose_order = code_cube_imaset
    case default
      cubetools_transpose_order = code_null
    end select
    !
  end function cubetools_transpose_order
  !
  function cubetools_transpose_access(code_access)
    !----------------------------------------------------------------------
    ! Transpose the data access mode: spectrum <-> image
    !----------------------------------------------------------------------
    integer(kind=4)             :: cubetools_transpose_access  ! code_access_*
    integer(kind=4), intent(in) :: code_access                 ! code_access_*
    !
    select case (code_access)
    case (code_access_imaset)
      cubetools_transpose_access = code_access_speset
    case (code_access_speset)
      cubetools_transpose_access = code_access_imaset
    case default
      cubetools_transpose_access = code_null
    end select
    !
  end function cubetools_transpose_access
  !
  subroutine cubetools_transpose_operator(inorder,ouorder,operator,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    integer(kind=4),         intent(in)    :: inorder
    integer(kind=4),         intent(in)    :: ouorder
    character(len=trop_l),   intent(out)   :: operator
    logical,                 intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter  :: rname='TRANSPOSE>OPERATOR'
    !
    if (inorder.eq.code_cube_imaset .and.  &
        ouorder.eq.code_cube_speset) then
       operator = '312'
    elseif (inorder.eq.code_cube_speset .and.  &
            ouorder.eq.code_cube_imaset) then
       operator = '231'
    else
       write(mess,'(2(a,i0))')  &
         'Do not know how to transpose from code ',inorder,' to code ',ouorder
       call cubesyntax_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !  
  end subroutine cubetools_transpose_operator
end module cubetools_access_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine rheader(set,obs,entry_num,user_function,error,readsec_in)
  use gbl_message
  use gbl_constant
  use classcore_interfaces, except_this=>rheader
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  !  Reset the observation and read all present header sections by
  ! default, or read a subset if optional argument is present.
  !----------------------------------------------------------------------
  type(class_setup_t),        intent(in)    :: set                    !
  type(observation),          intent(inout) :: obs                    !
  integer(kind=entry_length), intent(in)    :: entry_num              !
  logical,                    intent(out)   :: error                  !
  logical,                    external      :: user_function          !
  logical, optional,          intent(in)    :: readsec_in(-mx_sec:0)  !
  ! Local
  logical :: notok
  logical :: readsec(-mx_sec:0)  ! Which section are to be read
  !
  error = .false.
  !
  ! Reset the input observation header
  call rzero(obs,'KEEP',user_function)
  !
  ! Read its descriptor, index, and presec array. Note that part of the
  ! header is filled here.
  call robs(obs,entry_num,error)
  if (error)  return
  !
  if (present(readsec_in)) then
    readsec(:) = readsec_in(:)
  else
    ! Read all the (available) sections
    readsec(:) = .true.
  endif
  call rheader_sub(set,obs,readsec,error)
  if (error)  return
  !
  ! Now, read user section if any
  notok = user_function('GET')
  if (notok) then
     call class_message(seve%w,'GET','Error reading user sections')
  endif
  !
end subroutine rheader
!
subroutine rheader_sub(set,obs,readsec_in,error)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>rheader_sub
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  !  Read only the requested sections (if they exist)
  ! FixMe:
  !   - rename this subroutine!
  !   - use a specific type instead of "readsec_in(-mx_sec:0)"
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set                    !
  type(observation),   intent(inout) :: obs                    !
  logical,             intent(in)    :: readsec_in(-mx_sec:0)  !
  logical,             intent(inout) :: error                  ! Logical error flag
  ! Local
  logical :: readsec(-mx_sec:0)  ! Which section are effectively to be read
  logical :: err
  !
  ! 1) Get the general informations (always)
  err = .false.
  call rgen(set,obs,err)
  error = error.or.err
  err = .false.
  !
  ! 2) Setup the sections to be read
  readsec(:) = .false.  ! Default no for any section
  readsec(class_sec_pos_id) = readsec_in(class_sec_pos_id)
  !
  ! Optional, not type-specific sections
  readsec(class_sec_user_id)  = obs%head%presec(class_sec_user_id) .and.readsec_in(class_sec_user_id)
  readsec(class_sec_res_id)   = obs%head%presec(class_sec_res_id)  .and.readsec_in(class_sec_res_id)
  readsec(class_sec_bas_id)   = obs%head%presec(class_sec_bas_id)  .and.readsec_in(class_sec_bas_id)
  readsec(class_sec_plo_id)   = obs%head%presec(class_sec_plo_id)  .and.readsec_in(class_sec_plo_id)
  readsec(class_sec_his_id)   = obs%head%presec(class_sec_his_id)  .and.readsec_in(class_sec_his_id)
  readsec(class_sec_swi_id)   = obs%head%presec(class_sec_swi_id)  .and.readsec_in(class_sec_swi_id)
  readsec(class_sec_gau_id)   = obs%head%presec(class_sec_gau_id)  .and.readsec_in(class_sec_gau_id)
  readsec(class_sec_cal_id)   = obs%head%presec(class_sec_cal_id)  .and.readsec_in(class_sec_cal_id)
  readsec(class_sec_bea_id)   = obs%head%presec(class_sec_bea_id)  .and.readsec_in(class_sec_bea_id)
  readsec(class_sec_sky_id)   = obs%head%presec(class_sec_sky_id)  .and.readsec_in(class_sec_sky_id)
  readsec(class_sec_her_id)   = obs%head%presec(class_sec_her_id)  .and.readsec_in(class_sec_her_id)
  readsec(class_sec_com_id)   = obs%head%presec(class_sec_com_id)  .and.readsec_in(class_sec_com_id)
  readsec(class_sec_assoc_id) = obs%head%presec(class_sec_assoc_id).and.readsec_in(class_sec_assoc_id)
  readsec(class_sec_desc_id)  = obs%head%presec(class_sec_desc_id) .and.readsec_in(class_sec_desc_id)  ! the OTF section if any
  !
  ! Type-specific sections
  if (obs%head%gen%kind.eq.kind_spec) then
    readsec(class_sec_spe_id) = readsec_in(class_sec_spe_id)
    ! Recover fits results (NH3/HFS, ABS, SHELL), if any
    readsec(class_sec_hfs_id) = obs%head%presec(class_sec_hfs_id).and.readsec_in(class_sec_hfs_id)
    readsec(class_sec_abs_id) = obs%head%presec(class_sec_abs_id).and.readsec_in(class_sec_abs_id)
    readsec(class_sec_she_id) = obs%head%presec(class_sec_she_id).and.readsec_in(class_sec_she_id)
    !
  elseif (obs%head%gen%kind.eq.kind_cont .or. &
          obs%head%gen%kind.eq.kind_onoff) then
    readsec(class_sec_dri_id) = readsec_in(class_sec_dri_id)
    ! Recover continuum fit parameters, if any
    readsec(class_sec_poi_id) = obs%head%presec(class_sec_poi_id).and.readsec_in(class_sec_poi_id)
    !
  elseif (obs%head%gen%kind.eq.kind_sky) then
    readsec(class_sec_cal_id) = readsec_in(class_sec_cal_id)
    readsec(class_sec_sky_id) = readsec_in(class_sec_sky_id)
  endif
  !
  ! 3) Effectively read the selected sections
  if (readsec(class_sec_pos_id)) then
    call rpos(set,obs,err)
    error = error.or.err
    err = .false.
    call convert_pos(set,obs%head,error)
  endif
  if (readsec(class_sec_spe_id)) then
     call rspec(set,obs,err)
     error = error.or.err
     err = .false.
     call convert_vtype(set,obs%head,error)
  endif
  if (readsec(class_sec_res_id)) then
     call rres(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_hfs_id)) then
    call rnh3(set,obs,err)
    error = error.or.err
    err = .false.
  endif
  if (readsec(class_sec_abs_id)) then
    call rabs(set,obs,err)
    error = error.or.err
    err = .false.
  endif
  if (readsec(class_sec_she_id)) then
    call rshel(set,obs,err)
    error = error.or.err
    err = .false.
  endif
  if (readsec(class_sec_swi_id)) then
    call rswi(set,obs,err)
    error = error.or.err
    err = .false.
  else
    obs%head%swi%nphas = 0
    obs%head%swi%swmod = mod_pos
  endif
  if (readsec(class_sec_dri_id)) then
     call rcont(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_poi_id)) then
    call rpoint(set,obs,err)
    error = error.or.err
    err = .false.
  endif
  if (readsec(class_sec_bas_id)) then
     call rbase(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_plo_id)) then
     call rplot(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_his_id)) then
     call rorig(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_gau_id)) then
     call rgaus(set,obs,err)
     error = error.or.err
     err = .false.
  else
     obs%head%gau%sigba = 0.0
  endif
  if (readsec(class_sec_cal_id)) then
     call rcal(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_bea_id)) then
     call rbeam(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_sky_id)) then
     call rsky(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_her_id)) then
     call rherschel(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_com_id)) then
     call rcom(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_desc_id))  then
     call rdescr(set,obs,err)
     call class_message(seve%i,'GET','OTF Section')
     obs%is_otf = .true.
     error = error.or.err
     err = .false.
  else
     obs%head%des%ldump = 0  ! Not old OTF format - needed to avoid pb
     obs%head%des%ndump = 1  ! Not old OTF format - needed to avoid pb
     obs%is_otf = .false.
  endif
  if (readsec(class_sec_assoc_id)) then
     call rassoc(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  if (readsec(class_sec_user_id)) then
     if (set%verbose)  call class_message(seve%i,'GET','User Section')
     call ruser(set,obs,err)
     error = error.or.err
     err = .false.
  endif
  !
end subroutine rheader_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_axis_offset2pixel(axis,doff,ioff,error)
  use gbl_message
  use wifisyn_primitive_types
  use wifisyn_interfaces, except_this=>wifisyn_axis_offset2pixel
  !----------------------------------------------------------------------
  ! @ public
  ! Convert an offset into the corresponding pixel number.
  ! Make sure that the returned pixel number is inside the axis range.
  !----------------------------------------------------------------------
  type(axis_1d_t), intent(in)    :: axis
  real(kind=8),    intent(in)    :: doff
  integer,         intent(out)   :: ioff
  logical,         intent(inout) :: error
  !
  character(len=*), parameter :: rname='AXIS/OFFSET2PIXEL'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (axis%inc.ne.0.0) then
     ioff = nint(axis%ref+(doff-axis%val)/axis%inc)
     ioff = min(axis%n,max(1,ioff))
  else
     call wifisyn_message(seve%e,rname,'Increment is zero valued')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_axis_offset2pixel
!
subroutine wifisyn_axis_pixel2offset(axis,ioff,doff,error)
  use gbl_message
  use wifisyn_primitive_types
  use wifisyn_interfaces, except_this=>wifisyn_axis_pixel2offset
  !----------------------------------------------------------------------
  ! @ public
  !----------------------------------------------------------------------
  type(axis_1d_t), intent(in)    :: axis
  integer,         intent(in)    :: ioff
  real(kind=8),    intent(out)   :: doff
  logical,         intent(inout) :: error
  !
  character(len=*), parameter :: rname='AXIS/PIXEL2OFFSET'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  doff = (ioff-axis%ref)*axis%inc+axis%val
  !
end subroutine wifisyn_axis_pixel2offset
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_axis_ddx2idx(axis,ddx,idx,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_axis_ddx2idx
  use wifisyn_primitive_types
  !----------------------------------------------------------------------
  ! @ public
  !----------------------------------------------------------------------
  type(axis_1d_t), intent(in)    :: axis
  real(kind=8),    intent(in)    :: ddx
  integer,         intent(out)   :: idx
  logical,         intent(inout) :: error
  !
  character(len=*), parameter :: rname='WIFISYN/AXIS/DDX2IDX'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (axis%inc.ne.0.0) then
     idx = nint(ddx/axis%inc)
  else
     call wifisyn_message(seve%e,rname,'Increment is zero valued')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_axis_ddx2idx
!
subroutine wifisyn_axis_idx2ddx(axis,idx,ddx,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_axis_idx2ddx
  use wifisyn_primitive_types
  !----------------------------------------------------------------------
  ! @ public
  !----------------------------------------------------------------------
  type(axis_1d_t), intent(in)    :: axis
  integer,         intent(in)    :: idx
  real(kind=8),    intent(out)   :: ddx
  logical,         intent(inout) :: error
  !
  character(len=*), parameter :: rname='WIFISYN/AXIS/IDX2DDX'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ddx = idx*axis%inc
  !
end subroutine wifisyn_axis_idx2ddx
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program histo_simple
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GDF	Main program for making a Histogram from a map
  ! Subroutines
  !	HISTO002
  !
  ! To be re-written for more efficiency: just extract the relevant
  ! part of the image first.
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  real :: hmin,hmax,hstep
  integer, parameter :: mdim=4
  integer :: n, pmin(mdim), pmax(mdim), nh, ier
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_inte('Y_BLC$',pmin,mdim)
  call gildas_inte('Y_TRC$',pmax,mdim)
  call gildas_inte('X_BINS$',nh,1)
  call gildas_real('X_MIN$',hmin,1)
  call gildas_real('X_MAX$',hmax,1)
  call gildas_close
  !
  call gildas_null(y)
  y%blc(1:mdim) = pmin
  y%trc(1:mdim) = pmax
  !
  ! y%gil%form = fmt_r4 ! This is the default
  call gdf_read_gildas(y,namey,'.gdf',error,rank=0)
  if (error) goto 100
  if (y%gil%blan_words.eq.0) then
    y%gil%eval = -1.0
    y%gil%bval = 0.0
  endif
  !
  call gildas_null(x, type = 'TABLE' )
  n = lenc(namex)
  if (n.eq.0) goto 100
  call sic_parsef(namex(1:n),x%file,' ','.tab')
  x%gil%dim(1) = nh
  x%gil%dim(2) = 2
  hstep = (hmax-hmin)/(nh-1)
  !
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)), stat=ier)
  call histo002(y%r1d,y%loca%size,y%gil%bval,y%gil%eval,   &
     &    x%r2d,x%gil%dim(1),hmin,hstep)
  call gdf_write_image (x,x%r2d,error)
  call gagout('S-HISTO_SIMPLE,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program histo_simple
!
subroutine histo002(y,ydim,bval,eval, x,nh,hmin,hstep)
  use gildas_def
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Computes the histogram of part of an image
  !---------------------------------------------------------------------
  integer(kind=size_length),  intent(in)    :: ydim     ! Input array size
  real(kind=4),               intent(in)    :: y(ydim)  ! Input array
  real(kind=4),               intent(in)    :: bval     ! Blanking
  real(kind=4),               intent(in)    :: eval     ! Tolerance
  integer(kind=index_length), intent(in)    :: nh       ! Histogram size
  real(kind=4),               intent(inout) :: x(nh,2)  ! Histogram values
  real(kind=4),               intent(in)    :: hmin     ! Min val
  real(kind=4),               intent(in)    :: hstep    ! Step
  ! Local
  integer(kind=size_length) :: i,n,ntot,nin,nout,nblank
  !
  nin = 0
  nout = 0
  nblank = 0
  x(:,1) = 0.0
  !
  if (eval.ge.0.0) then
    do i=1,ydim
      if (abs(y(i)-bval).gt.eval) then
        n = nint((y(i)-hmin)/hstep + 1.0)
        if (n.ge.1 .and. n.le.nh) then
          x(n,1) = x(n,1)+1.
          nin = nin+1
        else
          nout= nout+1
        endif
      else
        nblank = nblank+1
      endif
    enddo
  else
    do i=1,ydim
      n = nint((y(i)-hmin)/hstep + 1.0)
      if (n.ge.1 .and. n.le.nh) then
        x(n,1) = x(n,1)+1.
        nin = nin+1
      else
        nout= nout+1
      endif
    enddo
  endif  
  !
  ! Now fill the histogram definition
  do n=1,nh
    x(n,2) = hmin - hstep + n*hstep
  enddo
  ntot = nin+nout+nblank
  write(6,100) nin,float(nin)/float(ntot)*1.e2,   &
     &    nout,float(nout)/float(ntot)*1.e2,   &
     &    nblank,float(nblank)/float(ntot)*1.e2,   &
     &    ntot
100 format(1x,'Number of points in histogram ',i12,4x,f4.1,' %',   &
     &    /,'   "    "    "    out of  "    ',i12,4x,f4.1,' %',   &
     &    /,'   "    "    "    blanked      ',i12,4x,f4.1,' %',   &
     &    /,'                  Total      = ',i12)
end subroutine histo002

subroutine gtl_destroy(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_destroy
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command CLEAR
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DESTROY'
  integer, parameter :: nvocab=3
  character(len=12) :: vocab(nvocab),to_check,comm
  integer :: nc,ncom
  ! Data
  data vocab / 'ALL','DIRECTORY','WINDOW' /
  !
  ! Get the argument
  call sic_ke (line,0,1,to_check,nc,.true.,error)
  if (error) return
  call sic_ambigs(rname,to_check,comm,ncom,vocab,nvocab,error)
  if (error)  return
  !
  select case (comm)
  case ('ALL')
    call gtv_destroy_all(error)
    !
  case ('DIRECTORY')
    call gtl_destroy_directory(line,error)
    if (error)  return
    call gtview('Update')
    !
  case ('WINDOW')
    call gtl_destroy_window(line,error)
    !
  case default
    call gtv_message(seve%e,rname,''''//trim(comm)//''' not yet implemented.')
    error = .true.
    return
  end select
  !
end subroutine gtl_destroy
!
subroutine gtl_destroy_directory(line,error)
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_destroy_directory
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command DESTROY DIRECTORY [Name]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DESTROY'
  character(len=gtvpath_length) :: dirname
  integer :: nc
  !
  ! Get directory name. No name means last subdirectory
  dirname = ''
  call sic_ch(line,0,2,dirname,nc,.false.,error)
  if (error) return
  !
  call gtv_destroy_directory(dirname,error)
  if (error)  return
  !
end subroutine gtl_destroy_directory
!
subroutine gtv_destroy_directory(name,error)
  use gbl_message
  use gtv_interfaces, except_this=>gtv_destroy_directory
  use gtv_buffers
  use gtv_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support for DESTROY DIRECTORY, using a name as input argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='DESTROY'
  character(len=gtvpath_length) :: dirname
  logical :: isdir,found
  type(gt_directory), pointer :: workdir,otherdir,newdir
  type(gt_segment), pointer :: segm
  !
  if (name.eq.'') then
    ! Delete the last subdirectory (for symetry with CLEAR SEGMENT)
    ! of the current directory
    if (.not.associated(cw_directory%son_last)) then
      call gtv_message(seve%e,rname,'No subdirectory to destroy here')
      error = .true.
      return
    endif
    !
    workdir => cw_directory%son_last
    !
  else
    dirname = name
    call sic_upper(dirname)
    !
    ! Get the directory
    call decode_chemin(dirname,cw_directory,workdir,isdir,segm,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,'No such directory '//dirname)
      error = .true.
      return
    endif
    if (.not.isdir) then
      call gtv_message(seve%e,rname,  &
        'Input segment is not a directory, use CLEAR SEGMENT [Name] instead')
      error = .true.
      return
    endif
  endif
  !
  ! Protect root
  if (associated(workdir,root)) then
    call gtv_message(seve%e,rname,'Can not delete root directory <')
    error = .true.
    return
  endif
  !
  ! Protect Current Working Directory
  otherdir => cw_directory
  do while (associated(otherdir))
    if (associated(otherdir,workdir)) then
      ! One of the fathers is the directory to be destroyed. Switch to its
      ! parent.
      newdir => workdir%father
      if (associated(newdir,root)) then
        call gtv_message(seve%e,rname,  &
          'You are in a tree to be destroyed, move somewhere else before')
        error = .true.
        return
      else
        call gtv_open_segments_for_writing_from_main()
        call cd_by_adr(newdir,newdir%x%curwin,error)
        call gtv_close_segments_for_writing_from_main()
        if (error)  return
        exit
      endif
    endif
    otherdir => otherdir%father
  enddo
  !
  call destroy_directory(workdir,error)  ! Thread-safe
  if (error)  return
  !
end subroutine gtv_destroy_directory
!
subroutine destroy_directory(dir,error)
  use gtv_interfaces, except_this=>destroy_directory
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Cleanly destroy the input directory, taking care of the surrounding
  ! pointers and chain in the GTV tree.
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  type(gt_directory), pointer       :: dir    ! Directory to destroy
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_directory), pointer :: father,otherdir,previous,next
  !
  if (.not.associated(dir))  return
  !
  ! 1) Look for the surrounding elements
  ! Parent
  father => dir%father
  ! Previous
  otherdir => father%son_first
  previous => null()
  do while (.not.associated(otherdir,dir))
    previous => otherdir
    otherdir => otherdir%brother
  enddo
  ! Next
  next => dir%brother
  !
  call gtv_open_segments_for_writing_from_main()
  !
  ! 2) Update the pointers and chain in the tree (parent or brother)
  if (.not.associated(previous)) then
    ! We are destroying the first son of the parent directory
    father%son_first => next  ! ... which can be null()
  else
    previous%brother => next  ! ... which can be null()
  endif
  if (.not.associated(next)) then
    ! We are destroying the last son of the parent directory
    father%son_last => previous  ! ... which can be null()
  endif
  !
  ! 3) Update the limits of the parent directory
  call gtv_limits(father,error)
  !
  ! 4) Destroy all the windows attached to the directory and
  ! subdirectories
  call win_destroy_all_recursive(dir,error)
  ! if (error) ?
  !
  call gtv_close_segments_for_writing_from_main()
  !
  ! 5) Effectively destroy the directory. This can be done out of
  ! the threads protection since its existence is know hidden to
  ! the rest of the world.
  dir%brother => null()  ! Only destroy 'dir', not the whole list.
  ! if (associated(dir)) then => tested above
    call x_destroy_directory(dir)  ! will call gtv_deldirectories(dir)
  !
end subroutine destroy_directory
!
subroutine gtv_destroy_all(error)
  use gildas_def
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>gtv_destroy_all
  use gtv_protocol
  use gtv_plot
  use gtv_segatt
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Destroy all the trees and windows.
  !   Since it is forbidden to user to be in root (<) and to create
  ! segments in it, he would have first to create a new top-directory
  ! and go in it. So we do it implicitely for him.
  !   In practice, destroy all the trees and windows EXCEPT the first
  ! window of the first child under root (normally, <GREG). This avoids
  ! to destroy and recreate a new window which could be moved to another
  ! place by the window manager.
  ! ---
  !  Thread status: safe to call from main thread.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DESTROY ALL'
  integer(kind=address_length) :: genv_saved
  logical :: found
  type(greg_values) :: dummy_tab
  type(gt_directory), pointer :: ancestor,brother
  !
  if (.not.awake .or. error_condition) return
  !
  ! First clear the windows
  if (cw_device%protocol.eq.p_x) then
    ! Get first child of the root, should be <GREG
    ancestor => root%son_first
    !
    call gtv_open_segments_for_writing_from_main()
    !
    ! Clear <GREG (first child) tree, keep one window
    call win_destroy_almost_recursive(ancestor,genv_saved,error)
    !
    ! Clear all other ancestors, delete all windows
    brother => ancestor%brother
    do while (associated(brother) .and. .not.error)
      call win_destroy_all_recursive(brother,error)
      !
      brother => brother%brother
    enddo
    !
    call gtv_close_segments_for_writing_from_main()
    !
  endif
  !
  ! Clear all the directories (and the allocated data in each: polylines,
  ! images, etc). In other words: throw away the current GTV tree and
  ! create a new one. Put it in the stack to ensure that all the remaining
  ! drawing instructions have been performed.
  if (associated(root))  &
    call x_destroy_directory(root)  ! will call gtv_deldirectories(root)
  !
  ! And now recreate a basic tree (i.e. < and <GREG)...
  call gtx_segm_0(error)
  if (error)  return
  !
  ! ... and attach a window.
  if (cw_device%protocol.ne.p_x) then
    call gti_clear(cw_output)
    !
  else
    !
    if (genv_saved.eq.0) then
      ! A new window will be attached to the output instances list:
      call get_free_slot_output(cw_output,error)
      if (error)  return
      cw_output%dev => cw_device  ! Point on the shared X-protocol instance
      call x_display_reset(cw_output%x)  ! Default values
      cw_output%color = .true.
      cw_output%background = cw_output%dev%background  ! Device default color is used
      call create_window(cw_output,.true.,cw_directory,.true.,.true.,error)
    else
      call gtv_open_segments_for_writing_from_main()
      call get_slot_output_by_genv(genv_saved,cw_output,.true.,found,error)
      if (error)  return
      call use_fen(cw_directory,genv_saved,error,' ')
      call gtv_close_segments_for_writing_from_main()
    endif
    !
    if (error) then
      call gtv_message(seve%e,rname,'Cannot create or reuse window')
      return
    endif
    !
    ! By default the physical area the window sees is the full physical area
    ! of the brand new directory. Must come after the 'cw_output' definition.
    cw_output%gx1 = 0.
    cw_output%gx2 = phys_sizex_def
    cw_output%gy1 = 0.
    cw_output%gy2 = phys_sizey_def
    !
  endif
  !
  cdepth = 1
  vdepth(1) = .true.
  vdepth(2:max_depth) = .false.
  !
  if (flag_greg)  &
    call reset_greg_val(dummy_tab)  ! 'dummy_tab' values unused during reset
  !
end subroutine gtv_destroy_all
!
subroutine gtclear
  use gtv_interfaces, except_this=>gtclear
  !---------------------------------------------------------------------
  ! @ public obsolete
  ! Obsolete entry point to 'gtv_destroy_all'. To be removed from
  ! some packages and official documentation before.
  ! SB, 22-09-2009
  !---------------------------------------------------------------------
  logical :: error
  error = .false.
  call gtv_destroy_all(error)
end subroutine gtclear
!
subroutine use_fen(dir,genv,error,nam)
  use gildas_def
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>use_fen
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Re-use a pre-existing window...
  !  Utilise UNIQUEMENT par gtv_destroy_all, apres un appel a DESTROY_MOST
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing.
  !---------------------------------------------------------------------
  type(gt_directory)              :: dir      ! Pointer to directory
  integer(kind=address_length)    :: genv     !
  logical,          intent(inout) :: error    ! Logical error flag
  character(len=*), intent(in)    :: nam      ! Optional window name
  ! Local
  integer :: nb_env
  character(len=64) :: dirname
  integer*4 :: nl,width,height
  !
  if (cw_output%dev%protocol.eq.p_null)  then
    ! No device, nothing to do
    return
    !
  elseif (cw_device%protocol.ne.p_x) then
    error = .true.
    call gtv_message(seve%e,'USE_FEN','Not implemented')
    return
  endif
  !
  ! Recuperation du nom du repertoire. The name of the x window is the directory
  ! name and the window number, unless otherwise specified in the calling
  ! arguments
  nb_env = 0
  nl = len_trim(nam)
  if (nl.eq.0) then
    call cree_chemin_dir(dir,dirname,nl)
    dirname(nl+1:) = ' 0'
  else
    dirname = nam(1:nl)
  endif
  !
  ! This will be a new window in a directory with no windows.
  ! Create a new table for the addresses of the graphical environments,
  ! put the address of the table in the directory descriptor
  dir%x%genv_array = c_new_genv_array(mwindows)
  !
  ! Put the address of the graphical environment in the directory descriptor
  dir%x%genv = genv
  !
  ! Put the address of the graphical environment in the table of addresses for
  ! all the windows in the directory (the table is ordered by window number)
  call c_set_win_genv(dir%x%genv_array,nb_env,genv)
  !
  ! Put the number of the current window and the total number of windows in the
  ! directory descriptor
  dir%x%curwin = nb_env
  dir%x%nbwin = nb_env+1
  !
  ! Update global values
  call get_win_pixel_info(genv,cw_output%px1,cw_output%py1,  &
                               cw_output%px2,cw_output%py2)
  cw_device%hardw_cursor = .true.
  !
  ! Use a Character String (DIRNAME): not portable...
  call reusewindow(genv,dirname,width,height,dir,len_trim(dirname))
  !
end subroutine use_fen
!
subroutine gtl_destroy_window(line,error)
  use gbl_message
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_destroy_window
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  DESTROY WINDOW [Dirname [WinNum|ZOOM]]
  ! Destroys all the windows of the input directory
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DESTROY WINDOW'
  character(len=gtvpath_length) :: dirname
  integer :: nc,cnum
  logical :: isdir,found
  type(gt_segment), pointer :: segm
  type(gt_directory), pointer :: workdir
  !
  if (sic_present(0,2)) then
    ! Get directory name
    call sic_ch(line,0,2,dirname,nc,.true.,error)
    if (error) return
    call sic_upper(dirname)
    !
    ! Get the directory
    call decode_chemin(dirname,cw_directory,workdir,isdir,segm,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,'No such directory '//dirname)
      error = .true.
      return
    endif
    if (.not.isdir) then
      call gtv_message(seve%e,rname,'Input segment is not a directory')
      error = .true.
      return
    endif
    !
  else
    workdir => cw_directory
  endif
  !
  call gtv_open_segments_for_writing_from_main()
  !
  if (sic_present(0,3)) then
    ! Destroy given window
    cnum = get_window_cnum_byname(workdir,rname,line,0,3,error)
    if (error .or. cnum.lt.0) then
      call gtv_message(seve%w,rname,'No such window, nothing done')
      return
    endif
    call win_destroy_one(workdir,cnum,error)
  else
    ! Destroy all windows
    call win_destroy_all(workdir,error)
  endif
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gtl_destroy_window
!
subroutine win_destroy_one_genv(dir,num_to_delete,error)
  use gildas_def
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>win_destroy_one_genv
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Elemental routine which detaches the pointer to the input window
  ! from the input directory: the directory descriptor is updated
  ! accordingly. The code here assumes that c_delete_win_genv
  ! removes and shifts the window to be deleted from the genv_array
  ! list.
  !   Can be called by the window which is destroying itself (e.g.
  ! user has closed it manually).
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing.
  !---------------------------------------------------------------------
  type(gt_directory)             :: dir            ! Directory where the window is attached
  integer(kind=4), intent(in)    :: num_to_delete  ! Window number to be deleted
  logical,         intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WIN_DESTROY_ONE_GENV'
  integer(kind=address_length) :: genv
  character(len=message_length) :: mess
  !
  if (dir%x%genv_array.eq.0) then
    call gtv_message(seve%e,rname,'No graphical environment attached')
    error = .true.
    return
  endif
  !
  ! Get the current window index and total number of windows attached
  if (dir%x%nbwin.eq.0) then
    call gtv_message(seve%e,rname,'No window attached')
    error = .true.
    return
  endif
  if (num_to_delete.ge.dir%x%nbwin) then
    write (mess,'(A,I0,A,I0,A)') 'Invalid window number #',num_to_delete,  &
      ' (directory has only ',dir%x%nbwin,' window(s))'
    call gtv_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  genv = c_get_win_genv(dir%x%genv_array,num_to_delete)
  !
  ! Decrease the number of windows attached, ...
  dir%x%nbwin = dir%x%nbwin-1
  ! compress the genv array, ...
  call c_delete_win_genv(dir%x%genv_array,num_to_delete)
  !
  ! Does any window remain attached?
  if (dir%x%nbwin.eq.0) then
    ! Delete the genv_array
    call c_delete_genv_array(dir%x%genv_array)
    dir%x%genv_array = 0
    !
    dir%x%curwin = 0  ! Dummy value
    !
    dir%x%genv = 0
    !
  elseif (dir%x%curwin.eq.num_to_delete) then
    ! Modify the active window number (arbitrarily take the first of the list
    ! of windows). Call cd_by_win which does all the job correctly.
    call cd_by_win(dir,0,error)
    !
  elseif (dir%x%curwin.gt.num_to_delete) then
    ! c_delete_win_genv should have decreased the window number for the C side.
    ! All is ok except the new number of the active window which has changed.
    dir%x%curwin = dir%x%curwin-1
    !
  endif
  !
  ! Free the window instance
  call free_slot_output_by_genv(genv,error)
  if (error)  return
  !
end subroutine win_destroy_one_genv
!
subroutine win_destroy_one(dir,num_to_delete,error)
  use gildas_def
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>win_destroy_one
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Elemental routine which detaches the input window from the input
  ! directory: the window is destroyed and the directory descriptor is
  ! updated accordingly.
  !   Can be called by the user from the command line e.g. CLEAR
  ! WINDOW num.
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing.
  !---------------------------------------------------------------------
  type(gt_directory)             :: dir            ! Directory where the window is attached
  integer(kind=4), intent(in)    :: num_to_delete  ! Window number to be deleted
  logical,         intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WIN_DESTROY_ONE'
  integer(kind=address_length) :: genv
  !
  if (error)  return
  !
  if (dir%x%genv_array.eq.0) then
    call gtv_message(seve%e,rname,'No graphical environment attached')
    error = .true.
    return
  endif
  !
  ! Get the current window index and total number of windows attached
  genv = c_get_win_genv(dir%x%genv_array,num_to_delete)
  if (genv.eq.0) then
    call gtv_message(seve%e,rname,'Invalid window number')
    error = .true.
    return
  endif
  !
  ! Destroy the X window
  call x_destroy_window(dir%x%genv_array,genv)
  !
  ! Suppress the window cleanly in the GTV tree
  call win_destroy_one_genv(dir,num_to_delete,error)
  !
  ! NB: 'win_destroy_one_genv' is called when the destruction order
  ! comes from Fortran (i.e. the 2 above routine calls). When the
  ! order does not come from Fortran (i.e. user closed it manually),
  ! the window must call it by itself.
  !  This scheme MUST be preserved in a multi-thread context: the
  ! window should not call 'win_destroy_one_genv' in all cases, since
  ! this can imply an asynchroneous call, when the parent directory
  ! is already destroyed. Which would mean: troubles...
  !
end subroutine win_destroy_one
!
subroutine win_destroy_all(dir,error)
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>win_destroy_all
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Detach all the windows attached to the input directory, and
  ! update the directory descriptor accordingly.
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing.
  !---------------------------------------------------------------------
  type(gt_directory)     :: dir    ! Directory where the window is attached
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WIN_DESTROY_ALL'
  integer*4 :: iwin
  !
  do iwin=dir%x%nbwin-1,0,-1
    ! Detach from last to first window (this order mandatory).
    call win_destroy_one(dir,iwin,error)
    if (error)  return
  enddo
  !
end subroutine win_destroy_all
!
recursive subroutine win_destroy_all_recursive(dir,error)
  use gtv_interfaces, except_this=>win_destroy_all_recursive
  use gtv_buffers
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Detach all the windows starting from input directory and
  ! recursively in its sub-directories.
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing.
  !---------------------------------------------------------------------
  type(gt_directory)     :: dir    ! Directory to start from
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_directory), pointer :: son
  !
  ! 1) Destroy the windows of the input directory
  call win_destroy_all(dir,error)
  if (error)  return
  !
  ! 2) Loop on its subdirectories and destroy their windows too
  son => dir%son_first
  do while (associated(son))
    call win_destroy_all_recursive(son,error)
    if (error)  return
    !
    son => son%brother
  enddo
  !
end subroutine win_destroy_all_recursive
!
subroutine win_destroy_almost(dir,genv,error)
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>win_destroy_almost
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Detach almost all the windows attached to the input directory, and
  ! update the directory descriptor accordingly. Keep only the first
  ! window of the input directory, and return its genv.
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing.
  !---------------------------------------------------------------------
  type(gt_directory)                          :: dir    ! Directory where the window is attached
  integer(kind=address_length), intent(out)   :: genv   ! Saved Genv
  logical,                      intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WIN_DESTROY_ALMOST'
  integer*4 :: iwin
  !
  genv = 0  ! No window found for the time being
  !
  if (dir%x%genv_array.eq.0) then
    ! No graphical environment attached: which means, no window to save.
    ! Not an error.
    return
  endif
  !
  do iwin=dir%x%nbwin-1,1,-1
    ! Detach from last to 2nd (#1) window (this order mandatory).
    call win_destroy_one(dir,iwin,error)
    if (error)  return
  enddo
  !
  ! And return 1st window Genv
  genv = c_get_win_genv(dir%x%genv_array,0)
  ! Should not be 0 (== error) on return, since the genv_array exists.
  !
  ! ZZZ Do we really want this?
  ! Destroy the genv_array: a new one will be created after and the
  ! genv saved will restored in it.
  call c_delete_genv_array(dir%x%genv_array)
  !
end subroutine win_destroy_almost
!
subroutine win_destroy_almost_recursive(dir,genv,error)
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>win_destroy_almost_recursive
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Detach almost all the windows starting from input directory and
  ! recursively in its sub-directories. Keep only the first window
  ! of the input directory, and return its genv.
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing.
  !---------------------------------------------------------------------
  type(gt_directory)                          :: dir    ! Directory to start from
  integer(kind=address_length), intent(out)   :: genv   ! Saved Genv
  logical,                      intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_directory), pointer :: son
  !
  call win_destroy_almost(dir,genv,error)
  if (error)  return
  !
  son => dir%son_first
  do while (associated(son))
    call win_destroy_all_recursive(son,error)
    if (error)  return
    !
    son => son%brother
  enddo
  !
end subroutine win_destroy_almost_recursive

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage GILDAS LIST messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubelist_messaging
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: seve,mess_l
  public :: cubelist_message_set_id,cubelist_message
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubelist_message_id = gpack_global_id  ! Default value for startup message
  !
contains
  !
  subroutine cubelist_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubelist_message_id = id
    write (mess,'(A,I0)') 'Now use id #',cubelist_message_id
    call cubelist_message(seve%d,rname,mess)
  end subroutine cubelist_message_set_id
  !
  subroutine cubelist_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubelist_message_id,mkind,'LIST>'//procname,message)
  end subroutine cubelist_message
  !
end module cubelist_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cursor_position
  real(kind=4), save :: xcurs,ycurs
end module cursor_position
!
subroutine getcur(xc,xv,xf,xi,ya,xo,yo,ch)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>getcur
  use cursor_position
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  !  Sends back cursor position in all user units
  !---------------------------------------------------------------------
  real(kind=4),     intent(out) :: xc  ! Channel number
  real(kind=4),     intent(out) :: xv  ! Velocity
  real(kind=4),     intent(out) :: xf  ! Frequency offset
  real(kind=4),     intent(out) :: xi  ! Image offset
  real(kind=4),     intent(out) :: ya  ! Intensity
  real(kind=4),     intent(out) :: xo  ! Cursor X-offset
  real(kind=4),     intent(out) :: yo  ! Cursor Y-offset
  character(len=*), intent(out) :: ch  ! Character struck
  ! Local
  logical :: error
  !
  call get_box(gx1,gx2,gy1,gy2)
  error = .false.
  call gtcurs(xcurs,ycurs,ch,error)
  if (error) return
  !
  xc = gcx1 + (xcurs-gx1)/gcx
  xv = gvx1 + (xcurs-gx1)/gvx  ! For RADIO definition
  xf = gfx1 + (xcurs-gx1)/gfx
  xi = gix1 + (xcurs-gx1)/gix
  ya = guy1 + (ycurs-gy1)/guy
  xo = xcurs
  yo = ycurs
  call sic_upper(ch)
end subroutine getcur
!
subroutine setcur(xa,ya,unit)
  use classcore_interfaces, except_this=>setcur
  use cursor_position
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  !  Set cursor at (XA,YA) in UNIT coordinate system
  !---------------------------------------------------------------------
  real(kind=4),     intent(in) ::  xa   ! X position
  real(kind=4),     intent(in) ::  ya   ! Intensity
  character(len=*), intent(in) :: unit  ! X unit
  !
  call get_box(gx1,gx2,gy1,gy2)
  if (unit.eq.'C') then
     xcurs = gx1 + (xa-gcx1)*gcx
  elseif (unit.eq.'V') then
     xcurs = gx1 + (xa-gvx1)*gvx    ! For RADIO definition
  elseif (unit.eq.'F') then
     xcurs = gx1 + (xa-gfx1)*gfx
  elseif (unit.eq.'I') then
     xcurs = gx1 + (xa-gix1)*gix
  endif
  ycurs = gy1 + (ya-guy1)*guy
end subroutine setcur
!
subroutine cursor(r,par,jcode,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>cursor
  use class_types
  use cursor_position
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! Compute initial values for gauss fit using cursor
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: r       !
  real(kind=4),      intent(out)   :: par(3)  ! Parameters array
  integer(kind=4),   intent(in)    :: jcode   ! Code to tell what to compute
  logical,           intent(inout) :: error   ! Error flag
  ! Local
  real(kind=4) :: ymax,ymin,aire,vinf,vsup,y,s0,s1,s2
  character(len=1) :: ch
  integer(kind=4) :: i1,i2,i
  !
  call get_box(gx1,gx2,gy1,gy2)
  call gtcurs(xcurs,ycurs,ch,error)
  if (error) return
  if (ch.eq.'/') return
  i1 = gcx1 + (xcurs-gx1)/gcx
  call gtcurs(xcurs,ycurs,ch,error)
  if (error) return
  i2 = gcx1 + (xcurs-gx1)/gcx
  error = .true.
  !
  ! Compute intensity, maximum and width
  if (jcode.eq.0) then
     ymax=0.
     ymin=0.
     aire=0.
     do i=min(i1,i2)+1,max(i1,i2)-1
        y = r%spectre(i)
        if (y.ne.r%cbad) then
           if (y.ge.ymax) then
              ymax = y
              vsup = r%datax(i)
           elseif (y.le.ymin) then
              ymin = y
              vinf = r%datax(i)
           endif
           aire = aire+y*abs(r%datax(i+1)-r%datax(i-1))
        endif
     enddo
     aire = aire*0.5
     if (aire.lt.0.) then
        par(3) = abs(aire/ymin)
        par(2) = vinf
        par(1) = ymin
     elseif (aire.gt.0) then
        par(3) = abs(aire/ymax)
        par(2) = vsup
        par(1) = ymax
     endif
     error = .false.
     !
     ! Compute area, position and width
  elseif (jcode.eq.1) then
     !
     s0=0.
     s1=0.
     s2=0.
     do i=min(i1,i2)+1,max(i1,i2)-1
        y = r%spectre(i)
        if (y.ne.r%cbad) then
           s0 = s0 + y
           s1 = s1 + y * r%datax(i)
           s2 = s2 + y * r%datax(i)**2
        endif
     enddo
     if (s0.ne.0) then
        s1 = s1 / s0
        s2 = s2 / s0
        y  = abs ((r%datax(i1)-r%datax(i2)) / (i1-i2))
        par(3) = y * sqrt (abs(s2-s1**2)*8.*alog(2.))
        par(2) = s1
        par(1) = s0 * y
        error = .false.
     else
        call class_message(seve%e,'LINES','Null area found, use manual mode')
        error = .true.
     endif
  endif
end subroutine cursor

subroutine load_gtvl
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>load_gtvl
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  ! Local
  integer, parameter :: mcom=34
  character(len=12) :: vocab(mcom)
  !
  data vocab /                                     &
    ' CHANGE',                                     &
    ' CLEAR',                                      &
    ' COMPRESS',                                   &
    ' CREATE', '/PLOT_PAGE','/PIXEL','/GEOMETRY','/POSITION','/SIZE',  &
    ' DESTROY',                                    &
    '$DEVICE', '/OUTPUT',                          &
    ' DISPLAY',                                    &
    ' FLUSH',                                      &
    ' GTV',                                        &
    ' HARDCOPY', '/PRINT','/DEVICE','/OVERWRITE','/DIRECTORY',  &
                 '/GEOMETRY','/EXACT','/FITPAGE',  &
    ' LENS',                                       &
    ' LUT', '/PEN','/EDIT','/REVERSE','/BLANK',    &
    ' METACODE', '/PATH',                          &
    ' REFRESH',                                    &
    ' REPLICATE',                                  &
    ' ZOOM' /
  !
  call sic_begin('GTVL','GAG_HELP_GTVL',mcom,vocab,  &
    '4.0    S.Bardeau,E.Reynier,J.Pety',run_gtvl,gterrtst)
  !
end subroutine load_gtvl
!
subroutine gtv_delseg(name,is_dir,error)
  use gtv_buffers
  use gtv_interfaces, except_this=>gtv_delseg
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !     Delete (i.e. make it invisible) a named segment or a directory
  !---------------------------------------------------------------------
  character(len=*)                :: name    !
  logical                         :: is_dir  !
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  logical :: isdir,found
  type(gt_segment), pointer :: segm
  type(gt_directory), pointer :: dir
  !
  ! Le segment donne en parametre existe t il ?
  call decode_chemin(name,cw_directory,dir,isdir,segm,found)
  if (.not.found) then
    call gtv_message(seve%e,rname,'No such segment '//name)
    error = .true.
  elseif (is_dir.and..not.isdir) then
    call gtv_message(seve%e,rname,'This is NOT a directory ')
    error = .true.
  elseif (isdir.and..not.is_dir) then
    call gtv_message(seve%e,rname,'This is a directory')
    error = .true.
  elseif (isdir) then
    call gtv_open_segments_for_writing_from_main()
    call change_attr_dir(dir,att_vis,-1)
    call gtv_close_segments_for_writing_from_main()
  else
    call gtv_open_segments_for_writing_from_main()
    call change_attr_seg(segm,att_vis,-1)
    call gtv_close_segments_for_writing_from_main()
  endif
end subroutine gtv_delseg
!
subroutine gtl_replicate(line,error)
  use gtv_interfaces, except_this=>gtl_replicate
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call gtv_message(seve%e,'REPLICATE','Not yet implemented')
  error = .true.
  !
end subroutine gtl_replicate
!
subroutine gtl_corner(error)
  use gtv_interfaces, except_this=>gtl_corner
  use gtv_buffers
  !---------------------------------------------------------------------
  ! @ public
  ! GTVIRT support routine for command
  !   CORNERS
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  real(kind=4) :: sizex,sizey
  !
  ! Get physical paper size of current active directory
  sizex = cw_directory%phys_size(1)
  sizey = cw_directory%phys_size(2)
  !
  call gtreloc(0.0,      0.1*sizey)
  call gtdraw (0.0,      0.0      )
  call gtdraw (0.1*sizex,0.0      )
  call gtreloc(0.9*sizex,0.0      )
  call gtdraw (    sizex,0.0      )
  call gtdraw (    sizex,0.1*sizey)
  call gtreloc(    sizex,0.9*sizey)
  call gtdraw (    sizex,    sizey)
  call gtdraw (0.9*sizex,    sizey)
  call gtreloc(0.1*sizex,    sizey)
  call gtdraw (0.0,          sizey)
  call gtdraw (0.0,      0.9*sizey)
  !
end subroutine gtl_corner
!
subroutine run_gtvl(line,comm,error)
  use gtv_interfaces, except_this=>run_gtvl
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (public but should not) (mandatory because
  ! symbol is used elsewhere)
  !---------------------------------------------------------------------
  character(len=*)              :: line   !
  character(len=*)              :: comm   !
  logical,          intent(out) :: error  !
  ! Local
  character(len=*), parameter :: rname = 'GTVL'
  character(len=60) :: chain
  integer, save :: icall=0
  !
  if (icall.ne.0)  &
    call gtv_message(seve%d,rname,'Reentrant call to RUN_GTVL '//comm)
  !
  icall = icall+1
  !
  call gtv_message(seve%c,rname,line)
  !
  error = .false.
  select case (comm)
  case('CLEAR')
    call gtl_clear(line,error)
  case('CREATE')
    call gtl_create(line,error)
  case('REPLICATE')
    call gtl_replicate(line,error)
  case('CHANGE')
    call gtl_change(line,error)
  case('COMPRESS')
    call gtl_compress(line,error)
  case('METACODE')
    call gtl_metacode(line,error)
  case('DISPLAY')
    call gtl_display(line,error)
  case('DESTROY')
    call gtl_destroy(line,error)
  case('DEVICE')
    call gtl_device(line,error)
  case('GTV')
    call gtl_gtv(line,error)
  case('HARDCOPY')
    call gtl_hardcopy(line,error)
  case('ZOOM')
    call gtl_zoom(line,error)
  case('LENS')
    call gtl_lens(line,error)
  case('LUT')
    call gtl_lutpen(line,error)
  case('FLUSH')
    ! Flush the stack (it can contain directories destruction, so call
    ! it whatever the device is).
    call x_flush(0)
  case('REFRESH')
    call gtl_refresh(line,error)
  case default
    chain = 'No code to execute for '//comm
    call gtv_message(seve%e,rname,chain)
    error = .true.
  end select
  !
  icall = icall-1
end subroutine run_gtvl

module cubelist_list_types
  use cubetools_parameters
  use cubelist_messaging
  use cubelist_object_class
  use cubelist_object_pointer_types
  !---------------------------------------------------------------------
  ! Support module to support generic list of objects, including methods
  ! to reallocate them, preserving previous values.
  ! The base type is an empty shell (class). Users have to create
  ! extended types from this class.
  !---------------------------------------------------------------------
  !
  private
  public :: list_k
  public :: list_t
  !
  integer(kind=4), parameter :: list_k=8
  !
  type :: list_t
    integer(kind=list_k), private :: first = 1  ! Array index starting point (as allocated)
    integer(kind=list_k), private :: last  = 0  ! Array index end point (as allocated)
    integer(kind=list_k), public  :: n = 0      ! Useful part of the array (upper bound)
    type(list_object_p_t), allocatable, public :: list(:)
  contains
    ! Actions on the whole list
    procedure, public  :: lbound     => cubelist_set_lbound
    procedure, private :: reallocate_byubound4 => cubelist_reallocate_byubound4
    procedure, private :: reallocate_byubound8 => cubelist_reallocate_byubound8
    generic,   public  :: reallocate => reallocate_byubound4,reallocate_byubound8
    procedure, public  :: copy       => cubelist_copy
    procedure, public  :: enlarge    => cubelist_enlarge
    procedure, public  :: final      => cubelist_final  ! NB: no implicit FINAL: Fortran requires
                                                        ! the exact type as argument (does not work for extended types)
    ! Actions on 1 object in list
    procedure, public  :: allocate   => cubelist_allocate
    procedure, public  :: associate  => cubelist_associate
    procedure, public  :: pop        => cubelist_pop
    procedure, public  :: dissociate => cubelist_dissociate
  end type list_t
  !
contains
  !
  subroutine cubelist_set_lbound(arr,first,error)
    !-------------------------------------------------------------------
    ! Modify the lower-bound index of the array. Future allocations will
    ! use this value as lower-bound.
    !-------------------------------------------------------------------
    class(list_t),        intent(inout) :: arr
    integer(kind=list_k), intent(in)    :: first
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SET>LBOUND'
    !
    if (allocated(arr%list)) then
      call cubelist_message(seve%e,rname,  &
        'Can not modify list lower-bound as list is already allocated')
      error = .true.
      return
    endif
    arr%first = first
  end subroutine cubelist_set_lbound
  !
  recursive subroutine cubelist_reallocate_byubound4(arr,n,error)
    !-------------------------------------------------------------------
    ! (Re)allocate to given size.
    ! Previous values are preserved if a reallocation is actually
    ! performed.
    ! ---
    ! This version without the index of the first component (i.e.
    ! indices run from 1 to n).
    !-------------------------------------------------------------------
    class(list_t),   intent(inout) :: arr
    integer(kind=4), intent(in)    :: n
    logical,         intent(inout) :: error
    !
    call cubelist_reallocate_byrange8(arr,arr%first,int(n,kind=8),error)
    if (error) return
  end subroutine cubelist_reallocate_byubound4
  !
  recursive subroutine cubelist_reallocate_byubound8(arr,n,error)
    !-------------------------------------------------------------------
    ! (Re)allocate to given size.
    ! Previous values are preserved if a reallocation is actually
    ! performed.
    ! ---
    ! This version without the index of the first component (i.e.
    ! indices run from 1 to n).
    !-------------------------------------------------------------------
    class(list_t),   intent(inout) :: arr
    integer(kind=8), intent(in)    :: n
    logical,         intent(inout) :: error
    !
    call cubelist_reallocate_byrange8(arr,arr%first,n,error)
    if (error) return
  end subroutine cubelist_reallocate_byubound8
  !
  recursive subroutine cubelist_reallocate_byrange8(arr,first,last,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate to given size.
    ! Previous values are preserved if a reallocation is actually
    ! performed.
    ! ---
    ! This version with a range of indices to allocate.
    !-------------------------------------------------------------------
    class(list_t),   intent(inout) :: arr
    integer(kind=8), intent(in)    :: first,last
    logical,         intent(inout) :: error
    !
    integer(kind=list_k), parameter :: array_minalloc=10
    integer(kind=list_k) :: ofirst,olast,nfirst,nlast
    integer(kind=4) :: ier
    type(list_t) :: tmp
    character(len=*), parameter :: rname='LIST>REALLOCATE'
    !
    if (allocated(arr%list)) then
      ofirst = lbound(arr%list,1)
      olast  = ubound(arr%list,1)
      if (ofirst.eq.first .and. olast.ge.last) then
        arr%first = ofirst  ! Should not be needed
        arr%last  = olast   ! Should not be needed
        return
      else
        call cubelist_transfer(arr,tmp,error)
        if (error) return
      endif
    else
      olast = 0
    endif
    !
    nfirst = first
    nlast = max(last,2*olast)
    nlast = max(nlast,array_minalloc)
    !
    allocate(arr%list(nfirst:nlast),stat=ier)
    if (failed_allocate(rname,'list',ier,error)) return
    arr%first = nfirst
    arr%last = nlast
    arr%n = nfirst-1
    !
    if (tmp%n.gt.0) then
      call cubelist_transfer(tmp,arr,error)
      if (error) return
    endif
  end subroutine cubelist_reallocate_byrange8
  !
  subroutine cubelist_enlarge(arr,nnew,start,error)
    !-------------------------------------------------------------------
    ! Enlarge a list_t by inserting 'nnew' elements at the
    ! desired position. Old elements are moved consistently if needed,
    ! new elements are left unallocated.
    !-------------------------------------------------------------------
    class(list_t),        intent(inout) :: arr
    integer(kind=list_k), intent(in)    :: nnew
    integer(kind=list_k), intent(in)    :: start
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: ntot,ielem,jelem
    !
    ! First enlarge to its full size
    ntot = arr%n+nnew
    call cubelist_reallocate_byrange8(arr,arr%first,ntot,error)
    if (error)  return
    !
    ! Move the old elements to the right, if any
    do ielem=arr%n,start,-1  ! Old position
      jelem = ielem+nnew  ! New position
      arr%list(jelem)%p            => arr%list(ielem)%p
      arr%list(jelem)%code_pointer =  arr%list(ielem)%code_pointer
      ! Keep old element as a pointer. Probably not much sense but this
      ! leaves the array in proper shape (the caller will probably do
      ! other things with this element).
      arr%list(ielem)%code_pointer = code_pointer_associated
    enddo
    !
    ! arr%n is not updated, as sometimes we kept valid pointers, but
    ! sometimes (when enlarging to the right) the pointers are just null
    ! (thus unusable). It is the reponsibility of the caller to update
    ! arr%n when relevant.
  end subroutine cubelist_enlarge
  !
  subroutine cubelist_final(arr,error)
    !-------------------------------------------------------------------
    ! Free the targets referenced by the list (if relevant) AND
    ! free the list itself.
    ! This properly works if the targets have declared a FINAL method.
    !-------------------------------------------------------------------
    class(list_t), intent(inout) :: arr
    logical,       intent(inout) :: error
    !
    integer(kind=list_k) :: iobj
    !
    ! Free the targets
    if (allocated(arr%list)) then
      do iobj=arr%first,arr%last
        call arr%list(iobj)%final(error)
        if (error)  return
      enddo
    endif
    !
    ! Free the list
    if (allocated(arr%list))  deallocate(arr%list)
    arr%first = 1
    arr%last = 0
    arr%n = 0
  end subroutine cubelist_final
  !
  subroutine cubelist_copy(arr1,arr2,error)
    !-------------------------------------------------------------------
    ! Copy one list to another, including implicit reallocation of the
    ! output instance.
    ! The target objects are saved under the association status, i.e.
    ! they do not own the allocation.
    !-------------------------------------------------------------------
    class(list_t), intent(in)    :: arr1
    class(list_t), intent(inout) :: arr2
    logical,       intent(inout) :: error
    !
    integer(kind=list_k) :: i,last
    !
    if (.not.allocated(arr1%list)) then
      call arr2%final(error)
      return
    endif
    !
    last = arr1%n  ! Transfer only the useful part
    call cubelist_reallocate_byrange8(arr2,arr1%first,last,error)
    if (error) return
    !
    do i=arr1%first,last
      arr2%list(i)%p => arr1%list(i)%p
      arr2%list(i)%code_pointer = code_pointer_associated
    enddo
    arr2%n = arr1%n
  end subroutine cubelist_copy
  !
  subroutine cubelist_transfer(arr1,arr2,error)
    !-------------------------------------------------------------------
    ! Transfer one list to another, including allocation property if
    ! relevant. Includes implicit reallocation of the output instance.
    ! The input object is freed in return.
    !-------------------------------------------------------------------
    type(list_t), intent(inout) :: arr1
    type(list_t), intent(inout) :: arr2
    logical,      intent(inout) :: error
    !
    integer(kind=list_k) :: i,last
    !
    last = arr1%n  ! Transfer only the useful part
    call cubelist_reallocate_byrange8(arr2,arr1%first,last,error)
    if (error) return
    !
    do i=arr1%first,last
      ! Steal the object
      arr2%list(i)%p => arr1%list(i)%p
      arr2%list(i)%code_pointer = arr1%list(i)%code_pointer
      ! Just keep as a pointer
      arr1%list(i)%code_pointer = code_pointer_associated
    enddo
    arr2%n = arr1%n
    !
    call arr1%final(error)
    if (error) return
  end subroutine cubelist_transfer
  !
  !---------------------------------------------------------------------
  !
  subroutine cubelist_allocate(arr,template,lot,error)
    !----------------------------------------------------------------------
    ! Allocate an extended 'list_object_t' in memory, appended at last
    ! position in the list, of type taken from the given template. Return
    ! a pointer to this object in return.
    !----------------------------------------------------------------------
    class(list_t),        intent(inout) :: arr
    class(list_object_t), intent(in)    :: template
    class(list_object_t), pointer       :: lot
    logical,              intent(inout) :: error
    !
    call arr%reallocate(arr%n+1,error)
    if (error) return
    call arr%list(arr%n+1)%allocate(template,error)
    if (error) return
    ! Success
    arr%n = arr%n+1
    lot => arr%list(arr%n)%p
  end subroutine cubelist_allocate
  !
  subroutine cubelist_associate(arr,lot,error)
    !----------------------------------------------------------------------
    ! Associate an extended 'list_object_t' in memory, appended at last
    ! position in the list.
    !----------------------------------------------------------------------
    class(list_t),        intent(inout)      :: arr
    class(list_object_t), intent(in), target :: lot
    logical,              intent(inout)      :: error
    !
    call arr%reallocate(arr%n+1,error)
    if (error) return
    call arr%list(arr%n+1)%associate(lot,error)
    if (error) return
    ! Success
    arr%n = arr%n+1
  end subroutine cubelist_associate
  !
  subroutine cubelist_pop(full,ipop,error)
    !-------------------------------------------------------------------
    ! Free the ith element and pop it out from the list (list compressed
    ! in return)
    !-------------------------------------------------------------------
    class(list_t),        intent(inout) :: full
    integer(kind=list_k), intent(in)    :: ipop
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: iobj
    !
    call full%list(ipop)%final(error)
    if (error)  return
    !
    do iobj=ipop+1,full%n
      full%list(iobj-1)%p            => full%list(iobj)%p
      full%list(iobj-1)%code_pointer =  full%list(iobj)%code_pointer
    enddo
    !
    ! Last element is now unused
    full%list(full%n)%p            => null()
    full%list(full%n)%code_pointer =  code_pointer_null
    !
    ! Update array size
    full%n = full%n-1
    !
    if (full%n.lt.full%first) then
      call full%final(error)
      if (error) return
    endif
  end subroutine cubelist_pop
  !
  subroutine cubelist_dissociate(full,object,error)
    !-------------------------------------------------------------------
    ! Dissociate (dereference) the given 'object' from the list (assume
    ! there can be one or more occurrences). The object itself is freed
    ! or not according to its code_pointer status.
    !
    ! The list is compressed in return.
    !-------------------------------------------------------------------
    class(list_t),        intent(inout) :: full
    class(list_object_t), pointer       :: object
    logical,              intent(inout) :: error
    !
    integer(kind=entr_k) :: ient,shift
    logical :: found
    !
    found = .false.
    shift = 0
    do ient=full%first,full%n
      if (associated(full%list(ient)%p,object)) then
        found = .true.
        shift = shift+1
        call full%list(ient)%final(error)
        if (error)  return
        cycle
      endif
      if (found) then
        full%list(ient-shift)%p => full%list(ient)%p
        full%list(ient-shift)%code_pointer = full%list(ient)%code_pointer
      endif
    enddo
    full%n = full%n-shift
    !
    if (full%n.lt.full%first) then
      call full%final(error)
      if (error) return
    endif
  end subroutine cubelist_dissociate
  !
end module cubelist_list_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mapping_support
  use gbl_message
  !
  public :: support_comm
  private
  !
contains
  !
  subroutine support_comm(line,error)
    use gkernel_interfaces
    use gildas_def
    use clean_support_tool
    use uvmap_buffers
    use clean_buffers
    !----------------------------------------------------------------------
    ! MAPPING Support routine for command
    !	  SUPPORT
    ! 1         [/PLOT]
    ! 2         [/CURSOR]
    ! 3         [/RESET]
    ! 4         [/MASK]
    ! 5         [/VARIABLE]
    ! 6         [/THRESHOLD  Raw Smooth [SmoothingLength]
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    logical :: fromfile, do_plot
    integer(kind=4) :: ier
    real(kind=4), allocatable, target :: imask(:,:)
    real :: raw,smo,length,noise,margin
    character(len=filename_length) :: file
    !
    integer(kind=4), parameter :: optname=0
    integer(kind=4), parameter :: optcurs=1
    integer(kind=4), parameter :: optmask=2
    integer(kind=4), parameter :: optplot=3
    integer(kind=4), parameter :: optrese=4
    integer(kind=4), parameter :: optthre=5
    integer(kind=4), parameter :: optvari=6
    character(len=*), parameter :: rname='SUPPORT'
    !
    do_plot = sic_present(optplot,0)
    !
    if (sic_present(optcurs,0)) then
       call map_message(seve%i,rname,'Use cursor to define polygon')
       clean_user%do_mask = .true.
       file = ''
       fromfile = .false.
       call sic_delvariable('MASK',.false.,error)
       mask%head%loca%size = 0
    else if (sic_present(optrese,0)) then
       if (allocated(mask%data)) then
          deallocate(mask%data,stat=ier)
       endif
       call greg_poly_reset(supportpol,supportvar,error)
       if (error)  return
       clean_user%do_mask = .true.  ! The mask HAS changed...
       call sic_delvariable('MASK',.false.,error)
       support_type = support_none
       mask%head%loca%size = 0
       return
    else if (sic_present(optmask,0)) then
       if (allocated(mask%data)) then
          call sic_delvariable('MASK',.false.,error)
          call sic_def_real ('MASK',mask%data,mask%head%gil%ndim,   &
               &        mask%head%gil%dim,.true.,error)
          clean_user%do_mask = .true.
          support_type = 1 ! First plane will be used by default
          !
          ! Show it if asked for by /PLOT option
          if (do_plot) then
             allocate (imask(mask%head%gil%dim(1),mask%head%gil%dim(2)),stat=ier)
             imask = 0.0
             where (mask%data(:,:,1).ne.0) imask = 1.0
             call sic_def_real ('BITMAP_MASK',imask,mask%head%gil%ndim,   &
                  &        mask%head%gil%dim,.true.,error)
             call gr_exec2('PLOT BITMAP_MASK /SCALING LIN -0.5 1.5')
             error = gr_error()
             call sic_delvariable('BITMAP_MASK',.false.,error)
             deallocate (imask,stat=ier)
          endif
       else
          call map_message(seve%e,rname,'No mask defined')
          error  = .true.
       endif
       return
    else if (sic_present(optthre,0)) then
       ! SUPPORT /THRESHOLD Raw Smooth [Length]
       !
       !  Raw      Thresholding (in Sigma) of the Clean image
       !  Smooth   Thresholding (in Sigma) after smoothing
       !  Length   Smoothing length: default is Clean beam major axis
       !
       if (clean%head%loca%size.eq.0) then
          call map_message(seve%e,rname,'No CLEAN image')
          error = .true.
          return
       endif
       raw = 5.0
       smo = 2.0
       length = clean%head%gil%majo
       !
       call sic_r4(line,optthre,1,raw,.false.,error)
       if (error) return
       call sic_r4(line,optthre,2,smo,.false.,error)
       if (error) return
       call sic_r4(line,optthre,3,length,.false.,error)
       if (error) return
       if (length.eq.0)  length = clean%head%gil%majo
       margin = 0.18
       call sic_r4(line,optthre,4,margin,.false.,error)
       if (margin.lt.0 .or. margin.gt.0.5) then
          call map_message(seve%e,rname,'Margin must be >0 and <0.5')
          error = .true.
          return
       endif
       !
       noise = max(dirty%head%gil%noise,clean%head%gil%noise,clean%head%gil%rms)
       !
       call sic_delvariable('MASK',.false.,error)
       if (allocated(mask%data)) deallocate(mask%data)    
       call gdf_copy_header(clean%head,mask%head,error)
       allocate(mask%data(mask%head%gil%dim(1),mask%head%gil%dim(2),mask%head%gil%dim(3)),   &
            &        stat=ier)
       !
       call mask_clean(mask%head,mask%data,clean%data,raw*noise,smo*noise,length,margin,error)
       if (error) return
       !
       call sic_def_real ('MASK',mask%data,mask%head%gil%ndim,   &
            &        mask%head%gil%dim,.true.,error)
       clean_user%do_mask = .true.
       support_type = 1 ! First plane will be used by default 
       return   
    else if (do_plot.and.sic_narg(optname).eq.0) then
       ! Just plot
       if (support_type.eq.support_poly) then
          call greg_poly_plot(supportpol,error)
       else if (support_type.ne.support_none) then
          allocate (imask(mask%head%gil%dim(1),mask%head%gil%dim(2)),stat=ier)
          imask = 0.0
          where (mask%data(:,:,1).ne.0) imask = 1.0
          call sic_def_real ('BITMAP_MASK',imask,mask%head%gil%ndim,   &
               &        mask%head%gil%dim,.true.,error)
          call gr_exec2('PLOT BITMAP_MASK /SCALING LIN -0.5 1.5')
          error = gr_error()
          call sic_delvariable('BITMAP_MASK',.false.,error)
          deallocate (imask,stat=ier)
          support_type = 1
       else
          call map_message(seve%w,rname,'No support defined')
          error  = .true.      
       endif
       return
    else
       ! This also re-instate the Polygon as the Clean support
       clean_user%do_mask = .true.
       if (sic_narg(optname).ge.1) then
          call greg_poly_parsename(line,optname,optvari,fromfile,file,error)
          if (error) return
       else  if (do_plot) then  ! /PLOT
          call greg_poly_plot(supportpol,error)
          return
       else
          fromfile = .false.
          file = ''  ! Not from file, not from var, i.e. from cursor
       endif
    endif
    !
    ! Define the polygon from file or cursor
    mask%head%loca%size = 0
    call greg_poly_define(rname,file,fromfile,supportpol,supportvar,error)
    if (error)  return
    support_type = support_poly
    !
    if (do_plot) then
       call greg_poly_plot(supportpol,error)
       if (error)  return
    endif
  end subroutine support_comm
end module mapping_support
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine lfit(x,y,weight,ndata,a,ma,covar,ncvm,chisq,funcs,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  ! Given a set of NDATA points X(I),Y(I) with individual weights WEIGHT(I),
  ! use Chi2 minimization to determine the MA coefficients A
  ! of a function that depends linearly on A.
  !---------------------------------------------------------------------
  integer,                    intent(in)  :: ndata   ! Size of data arrays
  real, dimension(ndata),     intent(in)  :: x       ! Abscissa of input values
  real, dimension(ndata),     intent(in)  :: y       ! Ordinates of input values
  real, dimension(ndata),     intent(in)  :: weight  ! Weights
  integer,                    intent(in)  :: ma      ! Approx. polynom number
  real, dimension(ma),        intent(out) :: a       ! Output coefficients
  integer,                    intent(in)  :: ncvm    ! Size of covariance matrix
  real, dimension(ncvm,ncvm), intent(out) :: covar   ! Covariance matrix (pivot)
  real,                       intent(out) :: chisq   ! Chi2 value
  external                                :: funcs   ! Approx. function
  logical,                    intent(out) :: error   ! Error flag
  ! Local
  integer, parameter :: mmax=50
  real :: beta(mmax),afunc(mmax)
  integer :: i,j,k
  real :: sig2i,sum,ym,wt
  !
  if (ma.gt.mmax) then
     call class_message(seve%f,'LFIT','Incoherent array dimensions')
     error = .true.
     return
  endif
  !
  do j=1,ma
     do k=1,ma
        covar(j,k)=0.
     enddo
     beta(j)=0.
  enddo
  do i=1,ndata
     call funcs(x(i),afunc,ma)
     ym=y(i)
     sig2i=weight(i)
     do j=1,ma
        wt=afunc(j)*sig2i
        do k=1,j
           covar(j,k)=covar(j,k)+wt*afunc(k)
        enddo
        beta(j)=beta(j)+ym*wt
     enddo
  enddo
  if (ma.gt.1) then
     do j=2,ma
        do k=1,j-1
           covar(k,j)=covar(j,k)
        enddo
     enddo
  endif
  call gaussj(covar,ma,ncvm,beta,1,1)
  do j=1,ma
     a(j)=beta(j)
  enddo
  chisq=0.
  do i=1,ndata
     call funcs(x(i),afunc,ma)
     sum=0.
     do j=1,ma
        sum=sum+a(j)*afunc(j)
     enddo
     chisq=chisq+((y(i)-sum)*weight(i))**2
  enddo
  return
end subroutine lfit
!
subroutine gaussj(a,n,np,b,m,mp)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  ! Gauss Jordan elimination with full pivoting
  ! Solve A.X = B by computing inv(A) : X = inv(A).B
  !---------------------------------------------------------------------
  integer, intent(in)    ::  np        ! Size
  real,    intent(inout) ::  a(np,np)  ! On input A ; on output inv(A)
  integer, intent(in)    ::  n         ! Size of X vectors
  integer, intent(in)    ::  mp        ! Size
  real,    intent(inout) ::  b(np,mp)  ! On input, RHS ; on output, X vectors
  integer, intent(in)    ::  m         ! Number of X vectors
  ! Local
  character(len=*), parameter :: rname='GAUSSJ'
  integer, parameter :: nmax=50
  real :: big,dum,pivinv
  integer, dimension(nmax) :: ipiv,indxr,indxc
  integer :: i,j,k,l,ll,irow,icol
  !
  do j=1,n
     ipiv(j)=0
  enddo
  do i=1,n
     big=0.
     do j=1,n
        if(ipiv(j).ne.1)then
           do k=1,n
              if (ipiv(k).eq.0) then
                 if (abs(a(j,k)).ge.big)then
                    big=abs(a(j,k))
                    irow=j
                    icol=k
                 endif
              elseif  (ipiv(k).gt.1) then
                 call class_message(seve%r,rname,'Singular matrix')
                 return
              endif
           enddo
        endif
     enddo
     ipiv(icol)=ipiv(icol)+1
     if (irow.ne.icol) then
        do l=1,n
           dum=a(irow,l)
           a(irow,l)=a(icol,l)
           a(icol,l)=dum
        enddo
        do l=1,m
           dum=b(irow,l)
           b(irow,l)=b(icol,l)
           b(icol,l)=dum
        enddo
     endif
     indxr(i)=irow
     indxc(i)=icol
     if (a(icol,icol).eq.0.) then
        call class_message(seve%r,rname,'Singular matrix')
        return
     endif
     pivinv=1./a(icol,icol)
     a(icol,icol)=1.
     do l=1,n
        a(icol,l)=a(icol,l)*pivinv
     enddo
     do l=1,m
        b(icol,l)=b(icol,l)*pivinv
     enddo
     do ll=1,n
        if(ll.ne.icol)then
           dum=a(ll,icol)
           a(ll,icol)=0.
           do l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
           enddo
           do  l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
           enddo
        endif
     enddo
  enddo
  do l=n,1,-1
     if(indxr(l).ne.indxc(l))then
        do k=1,n
           dum=a(k,indxr(l))
           a(k,indxr(l))=a(k,indxc(l))
           a(k,indxc(l))=dum
        enddo
     endif
  enddo
  return
end subroutine gaussj

!---------------------------------------------------------------------
!
! plait.f90:
! Elaborated on original ideas from Ch. Nieten and
! the NOD2 package.
!
! P. Hily-Blant feb-2005
!
!---------------------------------------------------------------------
!
module plait_common
  integer(kind=4), parameter :: sp=4
  integer(kind=4), parameter :: dp=8
  character(len=*), parameter :: rname = 'PLAIT'
  real(kind=sp), parameter :: wfunc_thres = 1.e-3_sp
end module plait_common
!
module  plait_interface
  interface
     subroutine plait_check(next,prev,error)
       use plait_common
       use image_def
       type(gildas), intent(in) :: prev , next
       logical, intent(out) :: error
     end subroutine plait_check
     !
     function plait_wfunc(r,width)
       use plait_common
       use phys_const
       real(kind=sp) :: plait_wfunc
       real(kind=sp), intent(in) :: r, width
     end function plait_wfunc
     !
     subroutine plait_cutoff(a,lower,upper,bval)
       use plait_common
       real(kind=sp), intent(in) :: lower , upper , bval
       real(kind=sp), intent(inout) :: a(:,:,:)
     end subroutine plait_cutoff
     !
     subroutine plait_replace(a,b,bval,eval)
       use plait_common
       real(kind=4), intent(in)    :: b(:,:,:)
       real(kind=4), intent(inout) :: a(:,:,:)
       real(kind=sp), intent(in) :: bval,eval
     end subroutine plait_replace
     !
     subroutine plait_add(aa,ww,head,a1,a2)
       use plait_common
       use image_def
       type(gildas), intent(in) :: head
       real(kind=4), intent(in)  :: a1(:,:,:),a2(:,:,:)
       real(kind=4), intent(out) :: aa(:,:,:)
       integer(kind=4), intent(inout) :: ww(:,:,:)
     end subroutine plait_add
     !
     subroutine plait_mean(w,a,bval,eval)
       use plait_common
       real(kind=sp), intent(in) :: bval , eval
       real(kind=sp), intent(inout) :: a(:,:,:)
       integer(kind=4), intent(in) :: w(:,:,:)
     end subroutine plait_mean
     !
     subroutine plait_weight(w,theta,scale,head)
       use plait_common
       use image_def
       use phys_const
!       use plait_interface, only : plait_wfunc
       type(gildas), intent(in) :: head
       real(kind=sp), intent(in) :: theta , scale
       real(kind=4), intent(inout) :: w(:,:)
     end subroutine plait_weight
     !
     subroutine plait_norm(a,w,bval,eval)
       use plait_common
       complex(kind=4), intent(inout) :: a(:,:,:)
       real(kind=sp), intent(in) :: w(:,:)
       real(kind=4), intent(in) :: bval, eval
     end subroutine plait_norm
  end interface
end module plait_interface
!
subroutine plait_check(next,prev,error)
  use plait_common
  use image_def
  !---------------------------------------------------------------------
  ! CHECK INPUT CUBES HAVE IDENTICAL DIMENSIONS
  !---------------------------------------------------------------------
  type(gildas), intent(in)  :: prev,next
  logical,      intent(out) :: error
  !
  error = .false.
  if (next%gil%ndim.ne.prev%gil%ndim) then
     error = .true.
     return
  endif
  if (.not.all(next%gil%dim.eq.prev%gil%dim)) then
     error = .true.
  endif
end subroutine plait_check
!
function plait_wfunc(r,width)
  use plait_common
  use phys_const
  !---------------------------------------------------------------------
  ! WEIGHTING FUNCTION
  !---------------------------------------------------------------------
  real(kind=sp) :: plait_wfunc
  real(kind=sp), intent(in) :: r , width
  ! Local
  real(kind=sp) :: zsc
  !
  plait_wfunc = 1.0_sp
  if (width.eq.0.0) return
  zsc = r*width
  if (abs(zsc).ge.1.0_sp) return
  zsc = zsc*pi*0.5_sp
  plait_wfunc = max(wfunc_thres,(sin(zsc))**2)
end function plait_wfunc
!
subroutine plait_weight(w,theta,scale,head)
  use plait_common
  use image_def
  use phys_const
  use plait_interface, only : plait_wfunc
  !---------------------------------------------------------------------
  ! COMPUTES WEIGHTING IMAGE
  !---------------------------------------------------------------------
  real(kind=4),  intent(inout) :: w(:,:)
  real(kind=sp), intent(in)    :: theta,scale
  type(gildas),  intent(in)    :: head
  ! Local
  integer(kind=4) :: i,j,m,n
  real(kind=sp) :: phi,cphi,sphi
  real(kind=sp) :: x(head%gil%dim(1)),y(head%gil%dim(2))
  real(kind=sp) :: d
  real(kind=sp) :: dx,dy,xinc,yinc
  !
  n = head%gil%dim(1)
  m = head%gil%dim(2)
  xinc = head%gil%convert(3,1)
  yinc = head%gil%convert(3,2)
  ! orientation of weighting in FT space
  phi  = theta * pi / 180._sp
  cphi = cos(phi)
  sphi = sin(phi)
  ! discretization of axes in FT space
  ! X and Y arrays are filled in with FORALL
  dx   = 1.0_sp / (xinc*(n-1))
  dy   = 1.0_sp / (yinc*(m-1))
  forall(i=1:n)
     x(i) = (i-1-(i/(n/2+1))*(n-1))
  end forall
  forall(j=1:m)
     y(j) = (j-1-(j/(m/2+1))*(m-1))
  end forall
  x    = x * dx * cphi
  y    = y * dy * sphi
  ! DX and DY are redefined in the loops
  do i=1,n
     dx = x(i)
     do j=1,m
        dy = y(j)
        d  = dx + dy
        w(i,j) = plait_wfunc(d,scale)
     enddo
  enddo
end subroutine plait_weight
!
subroutine plait_cutoff(a,lower,upper,bval)
  use plait_common
  !---------------------------------------------------------------------
  ! BLANK PIXELS OUTSIDE [LOWER:UPPER] INTERVAL
  !---------------------------------------------------------------------
  real(kind=sp), intent(in)    :: lower,upper,bval
  real(kind=sp), intent(inout) :: a(:,:,:)
  !
  if ((lower.eq.0._sp).and.(upper.eq.0._sp)) return
  where (a.lt.lower.or.a.gt.upper) a = bval
  !
end subroutine plait_cutoff
!
subroutine plait_replace(a,b,bval,eval)
  use plait_common
  !---------------------------------------------------------------------
  ! WHERE A IS BLANKED REPLACE WITH CORRESPONDING B VALUE
  !---------------------------------------------------------------------
  real(kind=4),  intent(in)    :: b(:,:,:)
  real(kind=4),  intent(inout) :: a(:,:,:)
  real(kind=sp), intent(in)    :: bval,eval
  !
!!$  integer :: I
  ! Check efficiency of either methods
!!$  do i=1,size(a,3)
!!$     where (abs(a(:,:,i)-bval).ge.eval) a(:,:,i) = b(:,:,i)
!!$  enddo
  !
  where (abs(a-bval).le.eval) a = b
  !
end subroutine plait_replace
!
subroutine plait_norm(a,w,bval,eval)
  use plait_common
  !---------------------------------------------------------------------
  ! NORMALIZE THE OUTPUT OF PLAITED FFTs
  !---------------------------------------------------------------------
  complex(kind=4), intent(inout) :: a(:,:,:)
  real(kind=sp),   intent(in)    :: w(:,:)
  real(kind=4),    intent(in)    :: bval,eval
  ! Local
  integer(kind=4) :: i,dim3
  !
  dim3 = size(a,3)
  do i=1,dim3
     where (w.ne.0._sp.and.abs(a(:,:,i)-bval).gt.eval)&
          a(:,:,i) = a(:,:,i) / w
  enddo
end subroutine plait_norm
!
subroutine plait_add(aa,ww,head,a1,a2)
  use plait_common
  use image_def
  !---------------------------------------------------------------------
  ! ADD TWO DATA CUBES TAKING INTO ACCOUNT BLANKING VALUE
  !---------------------------------------------------------------------
  real(kind=4),    intent(inout) :: aa(:,:,:)
  integer(kind=4), intent(inout) :: ww(:,:,:)
  type(gildas),    intent(in)    :: head
  real(kind=4),    intent(in)    :: a1(:,:,:),a2(:,:,:)
  ! Local
  integer(kind=4) :: mask(head%gil%dim(1),head%gil%dim(2))
  real(kind=sp) :: bval , eval
  integer(kind=4) :: i

  bval = head%gil%bval
  eval = head%gil%eval
  do i=1,head%gil%dim(3)
     !
     mask = 0
     where (abs(a1(:,:,i)-bval).gt.eval) mask = 1
     ww(:,:,i) = ww(:,:,i) + mask
     aa(:,:,i) = aa(:,:,i) + a1(:,:,i) * mask
     !
     mask = 0
     where (abs(a2(:,:,i)-bval).gt.eval) mask = 1
     ww(:,:,i) = ww(:,:,i) + mask
     aa(:,:,i) = aa(:,:,i) + a2(:,:,i) * mask
     !
  enddo
  !
end subroutine plait_add
!
subroutine plait_mean(w,a,bval,eval)
  use gkernel_interfaces
  use plait_common
  !---------------------------------------------------------------------
  ! COMPUTES THE MEAN OF INPUT CUBES
  ! IF THE MEAN CONTAINS BLANKED PIXEL(S) RETURN
  !---------------------------------------------------------------------
  real(kind=sp),   intent(in)    :: bval,eval
  real(kind=sp),   intent(inout) :: a(:,:,:)
  integer(kind=4), intent(in)    :: w(:,:,:)
  !
  ! First, check if any zero in weights
  if (minval(w).eq.0) then
     call gagout('F-'//rname//',  BLANKED PIXEL(S) IN SUM OF IMAGES')
     return
  endif
  ! No zero in w : computes the MEAN
  where (abs(a-bval).gt.eval) a = a / w
  !
end subroutine plait_mean
!
program plait_program
  use image_def
  use gkernel_interfaces
  use plait_common
  use plait_interface
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: nmap=5
  integer(kind=4) :: nfile,i,j,ier
  integer(kind=4) :: dim(3),maxdim
  character(len=256) :: message
  type(gildas) :: cin(nmap)
  type(gildas) :: cout , prev
  complex(kind=4), allocatable :: b(:,:,:),res(:,:,:)
  real(kind=4),    allocatable :: a(:,:,:),som(:,:,:)
  integer(kind=4), allocatable :: w3d(:,:,:)
  real(kind=sp),   allocatable :: w2d(:,:),norm(:,:)
  real(kind=4),    allocatable :: wfft(:)
  real(kind=sp) :: theta(nmap) , length(nmap)
  real(kind=sp) :: thres(2),blan(2)
  logical :: error
  !
  error = .false.
  do i=1,nmap
     call gildas_null(cin(i))
  enddo
  call gildas_null(cout)
  call gildas_null(prev)
  !
!!$  write(*,*) "READING INPUT PARAMETERS"
  call gildas_open
  call gildas_char('NAME_1$',cin(1)%file)
  call gildas_char('NAME_2$',cin(2)%file)
  call gildas_char('NAME_3$',cin(3)%file)
  call gildas_char('NAME_4$',cin(4)%file)
  call gildas_char('NAME_5$',cin(5)%file)
  call gildas_char('O_NAME$',cout%file)
  call gildas_inte('NFILE$',nfile,1)
  call gildas_real('THETA$',theta,nmap)
  call gildas_real('LENGTH$',length,nmap)
  call gildas_real('CUTOFF$',thres,2)
  call gildas_real('BLANK$',blan,2)
  call gildas_close
!!$  write(*,*) "PARAMETERS RED",nfile
  !
  ! Check that input files exist
  !
  do i=1,nfile
     ier = gag_inquire(cin(i)%file,lenc(cin(i)%file))
     if (ier.ne.0) then
        message = 'Input cube '//char(48+i)//' ' &
                  //cin(i)%file(1:len_trim(cin(i)%file))//' not found'
        call gagout('F-'//rname//',  '//message)
        call sysexi(fatale)
     endif
  enddo
  !
  ! Check that input cubes match
  !
  i = 1
  call gdf_read_header(cin(i),error)
!!$  write(*,*) "HEADER RED",i,cin(i)%file
  if (gildas_error(cin(i),rname,error)) call sysexi(fatale)
  prev = cin(i)
  do i=2,nfile
     call gdf_read_header(cin(i),error)
     if (gildas_error(cin(i),rname,error)) call sysexi(fatale)
     call plait_check(cin(i),prev,error)
     if (error) then
        call gagout('F-'//rname//',  Input cubes dimensions do not match')
        call sysexi(fatale)
     endif
     prev = cin(i)
  enddo
  dim(1:3) = cin(1)%gil%dim(1:3)
  maxdim = 2*maxval(dim)
  !
  ! Allocating memory
  !
  allocate(&
       w2d (dim(1),dim(2)),&
       norm(dim(1),dim(2)),&
       w3d (dim(1),dim(2),dim(3)),&
       a   (dim(1),dim(2),dim(3)), &
       b   (dim(1),dim(2),dim(3)), &
       res (dim(1),dim(2),dim(3)),&
       som (dim(1),dim(2),dim(3)),&
       wfft(maxdim),&
       stat=ier)
  if (failed_allocate(rname,'plait buffers',ier,error))  call sysexi(fatale)
  !
  ! Initialize SOM with first input cube
  !
  i = 1
  call gdf_read_data(cin(i),som,error)
  if (gildas_error(cin(i),rname,error)) call sysexi(fatale)
  !
  ! Compute the mean of input cubes
  !
  w3d = 0.
  som = 0.
  do i=1,nfile
     call gdf_read_data(cin(i),a,error)
     if (gildas_error(cin(i),rname,error)) call sysexi(fatale)
     call plait_cutoff(a,thres(1),thres(2),blan(1))
     call plait_add(som,w3d,cin(i),a,som)
  enddo
  call plait_mean(w3d,som,blan(1),blan(2))
  !
  ! Perform the plait algorithm
  !
  res  = cmplx(0.,0.,kind(0.))
  do i=1,nfile
     wfft = cmplx(0.,kind(0.))
     a    = 0.
     call gdf_read_data(cin(i),a,error)
     if (gildas_error(cin(i),rname,error)) call sysexi(fatale)
     call plait_cutoff(a,thres(1),thres(2),blan(1))
     call plait_replace(a,som,blan(1),blan(2))
     b(:,:,:) = cmplx(a,0.,kind(a))
     call plait_weight(w2d,theta(i),length(i),cin(i))
     do j=1,dim(3)
        call fourt(b(:,:,j),dim(1:2),2,1,1,wfft)
     enddo
     !-!$$     call fourt(b,dim(1:2),cin(1)%gil%ndim,1,0,wfft)
     forall(j=1:dim(3)) res(:,:,j) = res(:,:,j) + b(:,:,j)*w2d
     norm(:,:) = norm + w2d
  enddo
  call plait_norm(res,norm,blan(1),blan(2))
  wfft = cmplx(0.,kind(0.))
  do j=1,dim(3)
     call fourt(res(:,:,j),dim(1:2),2,-1,1,wfft)
  enddo
  a(:,:,:) = real(res)
  where (abs(a-blan(1)).gt.blan(2)) 
     a = a/real(dim(1)*dim(2))
  end where
  !
!-!$$  a = aimag(res)/real(dim(1)*dim(2))
!-!!$  call gildas_null(gsom)
!-!!$  gsom%file = "mean.lmv"
!-!!$  call gdf_copy_header(cin(1),gsom)
!-!!$  call gdf_write_image(gsom,som,error)
  !
  ! Write result in output image
  !
  call gdf_copy_header(cin(1),cout,error)
  call gdf_write_image(cout,a,error)
  if (gildas_error(cout,rname,error)) call sysexi(fatale)
  deallocate(w2d,norm,w3d,a,b,res,som,wfft,stat=ier)
  if (ier.ne.0) then
     call gagout('F-'//rname//',  Deallocation error')
     call sysexi(fatale)
  endif
end program plait_program

module maptasks_interfaces_private
  interface
    subroutine absmax (x,n,num,rabs)
      use cct_types
      !-------------------------------------------------------------------
      ! @ private
      !
      ! GILDAS:	Utility routine
      ! 	Compute position and values of Min and Max of array X
      !-------------------------------------------------------------------
      integer, intent(in) :: n                    !
      type(cct_par), intent(in) :: x(n)            !
      integer, intent(out) :: num                  !
      real, intent(out) :: rabs                    !
    end subroutine absmax
  end interface
  !
  interface
    subroutine choice_box (r,nx,ny,box,limite,   &
         &    nclean,wclean,nbpoin,rmax,select)
      use cct_types
      !---------------------------------------------------------------------
      ! @ private
      !
      ! MAP TASKS 	Internal routine
      !	  Select possible clean components in residual map.
      !	  Components are returned ordered in increasing I and J.
      !   Uses a BOX instead of a LIST
      !   Differs from one in map/lib by using a Box 
      !   and a slightly different test to rebuild the histogram.
      !---------------------------------------------------------------------
      integer, intent(in) :: nx          ! X size
      integer, intent(in) :: ny          ! Y size
      integer, intent(in) :: nclean      ! Maximum number of components
      integer, intent(out) :: nbpoin     ! Number of components found
      real, intent(in) :: r(nx,ny)       ! Input array
      integer :: box(4)                  !
      type(cct_par), intent(inout) :: wclean(nclean)            !
      real, intent(inout) ::  limite     ! selection threshold
      real, intent(in) :: rmax           ! Maximum value
      logical, intent(in) :: select                 !
    end subroutine choice_box
  end interface
  !
  interface
    subroutine histos_box (r,nx,ny, box, hx,nh,hmin,hstep)
      !---------------------------------------------------------------------
      ! @ private
      !
      ! MAP TASKS
      !	  Computes the histogram of part of an image
      !   Differs from one in map/lib: uses a box instead
      !   of a list of pixels.
      !---------------------------------------------------------------------
      integer, intent(in) :: nx        ! X size
      integer, intent(in) :: ny        ! Y size
      real, intent(in)  :: r(nx,ny)    ! Input array 
      integer, intent(in)  :: box(4)   ! Search box
      integer, intent(in) :: nh        ! Histogram size
      integer, intent(out) :: hx(nh)   ! Histogram
      real, intent(in) :: hmin         ! Min bin
      real, intent(in) :: hstep        ! Bin size
    end subroutine histos_box
  end interface
  !
end module maptasks_interfaces_private

module cubeedit_abort
  use cubetools_parameters
  use cubetools_structure
  use cubeedit_messaging
  !
  public :: abort
  private
  !
  type :: abort_comm_t
     type(option_t), pointer :: comm
   contains
     procedure, public  :: register => cubeedit_abort_register
     procedure, private :: parse    => cubeedit_abort_parse
     procedure, private :: main     => cubeedit_abort_main
  end type abort_comm_t
  type(abort_comm_t) :: abort
  !
  type abort_user_t
     character(len=varn_l) :: edid
  end type abort_user_t
  !
contains
  !
  subroutine cubeedit_abort_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command ABORT
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(abort_user_t) :: user
    character(len=*), parameter :: rname='ABORT>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call abort%parse(line,user,error)
    if (error) return
    call abort%main(user,error)
    if (error) return
  end subroutine cubeedit_abort_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_abort_register(abort,error)
    !-------------------------------------------------------------------
    ! Register EDIT\ABORT and its options
    !-------------------------------------------------------------------
    class(abort_comm_t), intent(inout) :: abort
    logical,             intent(inout) :: error
    !
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='ABORT>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'ABORT','[bufferid]',&
         'Abort the editing of an opened buffer',&
         'Abort an opened edited buffer and discard its pending&
         & edits.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- The selected edited buffer is destroyed and not registered in&
         & the DAG. Any previous editing work on that buffer will be lost.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- The edited buffer is registered in the DAG only after CLOSE.'&
         //strg_cr//&
         '- Use CLOSE to register updates in the DAG instead of&
         & discarding them.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> ABORT'//strg_cr//&
         'CUBE> ABORT work'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> OPEN work /LIKE refcube'//strg_cr//&
         'CUBE> PUT work ...'//strg_cr//&
         'CUBE> ABORT work'//strg_bl//&
         'After ABORT, the edited buffer no longer exists.',&
         cubeedit_abort_command,&
         abort%comm,&
         error)
    if (error) return
    call stdarg%register(&
         'BUFFERID',&
         'Edited buffer identifier',&
         'ABORT resolves bufferid. If omitted, it targets the most&
         & recently opened edited buffer.',&
         code_arg_optional,&
         error)
    if (error) return
    !
  end subroutine cubeedit_abort_register
  !
  subroutine cubeedit_abort_parse(abort,line,user,error)
    !-------------------------------------------------------------------
    ! Parse routine for command ABORT
    !-------------------------------------------------------------------
    class(abort_comm_t), intent(in)    :: abort
    character(len=*),    intent(in)    :: line
    type(abort_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='ABORT>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    user%edid = strg_star
    call cubetools_getarg(line,abort%comm,1,user%edid,.not.mandatory,error)
    if (error) return
    !
  end subroutine cubeedit_abort_parse
  !
  subroutine cubeedit_abort_main(abort,user,error)
    use cubeedit_opened_types
    !-------------------------------------------------------------------
    ! Main routine for command ABORT
    !-------------------------------------------------------------------
    class(abort_comm_t), intent(in)    :: abort
    type(abort_user_t),  intent(in)    :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='ABORT>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%abort(user%edid,error)
    if (error) return
  end subroutine cubeedit_abort_main
end module cubeedit_abort

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_spectrum_operations
  use cubetools_parameters
  use cubeobsolete_messaging
  use cubemain_spectrum_real
  !
  public :: cubemain_spectrum_base_noise
  public :: cubemain_spectrum_extract
  public :: cubemain_spectrum_smooth
  public :: cubemain_spectrum_average
  public :: cubemain_spectrum_sort
  public :: cubemain_spectrum_wind
  private
  !
contains
  !
  subroutine cubemain_spectrum_base_noise(base,error)
    use cubetools_nan
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(spectrum_t), intent(inout) :: base
    logical,          intent(inout) :: error
    !
    integer(kind=chan_k) :: idat
    real(kind=8) :: mean,var
    character(len=*), parameter :: rname='SPECTRUM>BASE>NOISE'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    ! 0. Sanity check
    if (base%n.lt.5) then
       ! At least five points needed to compute an rms...
       base%noi = gr4nan
       return
    endif
    ! 1. Mean computation
    mean = 0
    do idat=1,base%n
       ! VVV this does not take into account the presence of NaNs or blanks...
       mean = mean+base%t(idat)
    enddo
    mean = mean/dble(base%n)
    ! 2. Variance computation
    var = 0
    do idat=1,base%n
       ! VVV this does not take into account the presence of NaNs or blanks...
       var = var+(base%t(idat)-mean)**2
    enddo
    var = var/dble(base%n)
    ! 3. RMS computation
    base%noi = sqrt(var)
  end subroutine cubemain_spectrum_base_noise
  !
  subroutine cubemain_spectrum_extract(ifirst,ilast,specin,specout,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    integer(kind=chan_k), intent(in)    :: ifirst
    integer(kind=chan_k), intent(in)    :: ilast
    type(spectrum_t),     intent(in)    :: specin
    type(spectrum_t),     intent(inout) :: specout
    logical,              intent(inout) :: error
    !
    integer(kind=chan_k) :: nchan,ochan,ichan
    character(len=*), parameter :: rname='SPECTRUM>EXTRACT'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    nchan = ilast-ifirst+1
    ! VVV This routine does not do any check, hence it may segfault,
    ! should it be left this way for the sake of efficiency?
    do ochan=1,nchan
       ichan = ochan+ifirst-1
       specout%c(ochan) = specin%c(ichan)
       specout%v(ochan) = specin%v(ichan)
       specout%f(ochan) = specin%f(ichan)
       specout%w(ochan) = specin%w(ichan)
       specout%t(ochan) = specin%t(ichan)
    enddo
    specout%n = nchan
  end subroutine cubemain_spectrum_extract
  !
  subroutine cubemain_spectrum_smooth(specin,specout,error)
    use cubetools_nan
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(spectrum_t), intent(in)    :: specin
    type(spectrum_t), intent(inout) :: specout
    logical,          intent(inout) :: error
    !
    integer(kind=chan_k) :: nc,ic,icmin,icmax,idc
    integer(kind=chan_k) :: jc,ldc
    real(kind=8) :: sum
    character(len=*), parameter :: rname='SPECTRUM>SMOOTH'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    specout%n = specin%n
    specout%c = specin%c
    specout%v = specin%v
    specout%f = specin%f
    !
    idc = 5 ! should be user defined *** JP
    ldc = 2*idc+1
    nc = specin%n
    if ((ldc).gt.nc) then
       idc = (nc-1)/2
       ldc = 2*idc+1
    endif
    do ic=1,nc
       icmin = max(ic-idc,1)
       icmax = min(ic+idc,nc)
       if (icmin.eq.1) then
          icmax = icmin+ldc-1
       else if (icmax.eq.nc) then
          icmin = icmax-ldc+1
       endif
       sum = 0.
       ! VVV Here we should decide wether we want the nans to contamine
       ! or not, the old code does not take care of this.
       ! Maybe it assumes blank2zero has been called beforehand?
       do jc=icmin,icmax
          sum = sum+specin%t(jc)
       enddo ! jc
       specout%t(ic) = sum/dble(ldc)
    enddo ! ic
    if (ieee_is_nan(specin%noi)) then
       specout%noi = gr4nan
    else
       specout%noi = sqrt(real(ldc))*specin%noi
    endif
  end subroutine cubemain_spectrum_smooth
  !
  subroutine cubemain_spectrum_average(spec1,spec2,nois1,nois2,aver,error)
    use cubetools_nan
    !----------------------------------------------------------------------
    ! The consistency of the different spectrum is assumed to have been
    ! done outside this routine
    !----------------------------------------------------------------------
    type(spectrum_t), intent(in)    :: spec1
    type(spectrum_t), intent(in)    :: spec2
    type(spectrum_t), intent(in)    :: nois1
    type(spectrum_t), intent(in)    :: nois2
    type(spectrum_t), intent(inout) :: aver
    logical,          intent(inout) :: error
    !
    integer(kind=chan_k) :: nc,ic
    real(kind=sign_k) :: wei1,wei2
    character(len=*), parameter :: rname='SPECTRUM>AVERAGE'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    nc = aver%n
    do ic=1,nc
       ! VVV Previous Behaviour is contamination hence there is no
       ! longer a test on blanking values
       if ((nois1%t(ic).ne.0).and.(nois2%t(ic).ne.0)) then
          wei1 = 1.0/nois1%t(ic)**2
          wei2 = 1.0/nois2%t(ic)**2
          aver%t(ic) = (wei1*spec1%t(ic)+wei2*spec2%t(ic)) / (wei1+wei2)
       else
          aver%t(ic) = gr4nan
       endif
    enddo ! ic
  end subroutine cubemain_spectrum_average
  !
  subroutine cubemain_spectrum_sort(ipeak,specin,specout,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    integer(kind=chan_k),   intent(in)    :: ipeak
    type(spectrum_t),       intent(in)    :: specin
    type(spectrum_t),       intent(inout) :: specout
    logical,                intent(inout) :: error
    !
    integer(kind=chan_k) :: ileft,iright
    integer(kind=chan_k) :: jchan,nchan
    character(len=*), parameter :: rname='SPECTRUM>SORT'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (ipeak.eq.code_null) then
       call cubeobsolete_message(seve%e,rname,'Inexistent peak channel')
       error = .true.
       return
    endif
    if (specin%n.lt.1) then
       call cubeobsolete_message(seve%e,rname,'Zero channel')
       error = .true.
       return
    endif
    specout%n = specin%n
    specout%noi = specin%noi
    ! Order data
    specout%c(1) = specin%c(ipeak)
    specout%v(1) = specin%v(ipeak)
    specout%f(1) = specin%f(ipeak)
    specout%w(1) = specin%w(ipeak)
    specout%t(1) = specin%t(ipeak)
    nchan = specin%n
    jchan = 2
    ileft = ipeak-1
    iright = ipeak+1
    do while (jchan.le.nchan)
       if (ileft.eq.0) then
          specout%c(jchan) = specin%c(iright)
          specout%v(jchan) = specin%v(iright)
          specout%f(jchan) = specin%f(iright)
          specout%w(jchan) = specin%w(iright)
          specout%t(jchan) = specin%t(iright)
          iright = iright+1
       else if (iright.eq.(nchan+1)) then
          specout%c(jchan) = specin%c(ileft)
          specout%v(jchan) = specin%v(ileft)
          specout%f(jchan) = specin%f(ileft)
          specout%w(jchan) = specin%w(ileft)
          specout%t(jchan) = specin%t(ileft)
          ileft = ileft-1
       else if (specin%t(ileft).gt.specin%t(iright)) then
          specout%c(jchan) = specin%c(ileft)
          specout%v(jchan) = specin%v(ileft)
          specout%f(jchan) = specin%f(ileft)
          specout%w(jchan) = specin%w(ileft)
          specout%t(jchan) = specin%t(ileft)
          ileft = ileft-1
       else
          specout%c(jchan) = specin%c(iright)
          specout%v(jchan) = specin%v(iright)
          specout%f(jchan) = specin%f(iright)
          specout%w(jchan) = specin%w(iright)
          specout%t(jchan) = specin%t(iright)
          iright = iright+1
       endif
       jchan = jchan+1
    enddo
  end subroutine cubemain_spectrum_sort
  !
  subroutine cubemain_spectrum_wind(sorted,wfound,error)
    use cube_types
    use cubemain_windowing
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(spectrum_t),      intent(in)    :: sorted
    type(window_scalar_t), intent(out)   :: wfound
    logical,               intent(inout) :: error
    !
    integer(kind=chan_k) :: ichan,imin,imax,cmin,cmax
    character(len=*), parameter :: rname='SPECTRUM>WIND'
    !
    call cubeobsolete_message(obsoleteseve%trace,rname,'Welcome')
    !
    imin = 1
    imax = 1
    cmin = sorted%c(1)
    cmax = sorted%c(1)
    do ichan=2,sorted%n
       if (cmin.gt.sorted%c(ichan)) then
          cmin = sorted%c(ichan)
          imin = ichan
       endif
       if (cmax.lt.sorted%c(ichan)) then
          cmax = sorted%c(ichan)
          imax = ichan
       endif
       if (sorted%t(ichan).le.0.0) then
          exit
       endif
    enddo ! ichan
    ! Transfer result in original spectrum channels
    wfound%nc = imax-imin+1
    wfound%o = (/ imin,imax /)
    wfound%p = (/ imin,imax /)
  end subroutine cubemain_spectrum_wind
end module cubemain_spectrum_operations
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_conjugate
  use cubecompute_one2one_template
  use cubecompute_messaging
  !
  public :: cubecompute_conjugate_register
  private
  !
  type(one2one_comm_t) :: conjugate
  !
contains
  !
  subroutine cubecompute_conjugate_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONJUGATE>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call conjugate%register_syntax(&
         'CONJUGATE','input',&
         'Compute the complex conjugate of a visibility cube',&
         strg_emp,&
         code_access_imaset,[flag_conjugate],cubecompute_conjugate_command,&
         error)
    if (error) return
    call conjugate%act%register_vis2vis(cubecompute_conjugate_prog_act,error)
    if (error) return
  end subroutine cubecompute_conjugate_register
  !
  subroutine cubecompute_conjugate_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(one2one_user_t) :: user
    character(len=*), parameter :: rname='CONJUGATE>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call conjugate%parse(line,user,error)
    if (error) return
    call conjugate%main(user,error)
    if (error) continue
  end subroutine cubecompute_conjugate_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_conjugate_prog_act(ie,input,conjugate,error)
    use cubetools_parameters
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(visi_t),         intent(inout) :: input
    type(visi_t),         intent(inout) :: conjugate
    logical,              intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    character(len=*), parameter :: rname='CONJUGATE>PROG>ACT'
    !
    call input%get(ie,error)
    if (error) return
    do iy=1,conjugate%ny
       do ix=1,conjugate%nx
          conjugate%val(ix,iy) = conjg(input%val(ix,iy))
       enddo ! ix
    enddo ! iy
    call conjugate%put(ie,error)
    if (error) return
  end subroutine cubecompute_conjugate_prog_act
end module cubecompute_conjugate
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! From uv_buffers, we use
!   huv, duv for the UV data set (by READ UV)
!   uvm for the ModelUV data set (by READ MODEL)
!
! From flux_variables
!   n_dates      ! number of dates
!   class(:)     ! List of Class dates
!   chain*70(:)  ! Text string per date
!   vscale(:)    ! Flux scale factors
!   dscale(:)    ! Errors on scale factors
!
! Operation
!  
!  READ UV DataSet
!      Read the UV data set
!  READ MODEL DataSet
!      Read the Model data set
!  FLUX FIND 
!      Define n_dates
!      load Class(n_dates)
!      compute Flux(n_dates)
!      define the associate SIC variable Flux[] and D_Flux
!  FLUX APPLY MyVariable
!      Compute  Fij*ModelUV
!      put it in a SIC variable called MyVariable
!
! Then
!  begin procedure my_proc
!    FLUX APPLY MyVariable
!    let adj%res UV-MyVariable
!  end procedure my_proc
!  adjust UV "@ my_proc" /start /par flux[i] .. flux[j] /root adj
!  exa adj%fit
!  exa adj%err
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mapping_flux_scale
  use gbl_message
  !
  public :: flux_scale_comm
  private
  !
  integer :: date_interval=1 
  integer :: n_dates=0                       ! number of dates
  integer, allocatable :: class(:)           ! List of Class dates
  real, allocatable ::  fscale(:)            ! Flux scale factors
  real, allocatable ::  dscale(:)            ! Errors on scale factors
  character(len=70), allocatable :: chain(:) ! Text string per date
  character(len=16) myvar
  real, allocatable :: myuv(:,:)
  !
contains
  !
  subroutine flux_scale_comm(line,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Dispatching routine for command
    !  FLUX FIND DateInterval
    !  FLUX APPLY OutputVariable
    !  FLUX CALIBRATE
    !  FLUX LIST
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: iarg
    integer, parameter :: mpar=4
    character(len=12) :: arg,argument
    character(12) :: cpar(mpar)
    data cpar /'FIND','APPLY','LIST','CALIBRATE'/ 
    !
    call sic_ke(line,0,1,arg,iarg,.true.,error)
    call sic_ambigs('FLUX',arg,argument,iarg,cpar,mpar,error)
    select case (argument)
    case ('FIND')
       call flux_scale_find(line,error)
    case ('APPLY')
       call flux_scale_apply(line,error)
    case ('LIST') 
       call flux_scale_list(line,error)
    case ('CALIBRATE') 
       call flux_scale_calib(line,error)
    case default
       call gagout(argument//' Not yet implemented')
       error = .true.
    end select
  end subroutine flux_scale_comm
  !   
  subroutine flux_scale_apply(line,error)
    use gkernel_interfaces
    use gildas_def
    use uv_buffers
    !-----------------------------------------------------------
    ! FLUX_SCALE APPLY OutputVariable
    !-----------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: ier
    integer :: nc,nv,iv,ic,ir,ii,iw,id,ie,ti
    real :: weight_fact, flux_fact
    !
    if (n_dates.eq.0) then
       print *,'Dates not defined, use command FLUX FIND before'
       error = .true.
       return
    endif
    !
    call sic_ch(line,0,2,myvar,ier,.true.,error)
    if (error) return
    call sic_delvariable(myvar,.false.,error)
    if (error) return
    !
    if (allocated(myuv)) deallocate(myuv)
    allocate (myuv(huv%gil%dim(1),huv%gil%dim(2)),stat=ier)
    nv = huv%gil%dim(2)
    nc = huv%gil%nchan 
    id = 1
    !
    do iv=1,nv
       ! Get the date
       ti = int(duv(4,iv)+duv(5,iv)/86400.0d0)     
       if (ti.eq.0 .and. duv(6,iv).eq.0) cycle  ! Dummy
       if (abs(ti-class(id)).ge.date_interval) then
          do ie=1,n_dates 
             if (abs(ti-class(ie)).lt.date_interval) then
                id = ie
                exit
             endif
          enddo
       endif
       flux_fact =  fscale(id) 
       weight_fact = 1./flux_fact**2
       myuv(:,iv) = uvm%data(:,iv)
       do ic=1,nc
          ir = 5+3*ic
          ii = ir+1
          iw = ii+1
          !
          myuv(ir,iv) = myuv (ir,iv) * flux_fact 
          myuv(ii,iv) = myuv (ii,iv) * flux_fact 
          myuv(iw,iv) = myuv (iw,iv) * weight_fact 
       enddo
    enddo
    call sic_def_real(myvar,myuv,2,huv%gil%dim,.true.,error)
  end subroutine flux_scale_apply
  !
  subroutine flux_scale_calib(line,error)
    use gildas_def
    use uv_buffers
    !-----------------------------------------------------------
    ! FLUX_SCALE CALIBRATE 
    !
    ! Apply the factors to the UV data set.
    !-----------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: ier
    integer :: nc,nv,iv,ic,ir,ii,iw,id,ie,ti
    real :: weight_fact, flux_fact
    !
    if (n_dates.eq.0) then
       print *,'Dates not defined, use command FLUX FIND before'
       error = .true.
       return
    endif
    !
    allocate (myuv(huv%gil%dim(1),huv%gil%dim(2)),stat=ier)
    nv = huv%gil%dim(2)
    nc = huv%gil%nchan 
    id = 1
    !
    do iv=1,nv
       ! Get the date
       ti = int(duv(4,iv)+duv(5,iv)/86400.0d0)     
       if (ti.eq.0 .and. duv(6,iv).eq.0) cycle  ! Dummy
       if (abs(ti-class(id)).ge.date_interval) then
          do ie=1,n_dates 
             if (abs(ti-class(ie)).lt.date_interval) then
                id = ie
                exit
             endif
          enddo
       endif
       flux_fact =  1./fscale(id) 
       weight_fact = flux_fact**2
       do ic=1,nc
          ir = 5+3*ic
          ii = ir+1
          iw = ii+1
          !
          duv(ir,iv) = duv (ir,iv) * flux_fact 
          duv(ii,iv) = duv (ii,iv) * flux_fact 
          duv(iw,iv) = duv (iw,iv) * weight_fact 
       enddo
    enddo
  end subroutine flux_scale_calib
  !
  subroutine flux_scale_find(line,error)
    use gkernel_interfaces
    use gildas_def
    use uv_buffers
    !-----------------------------------------------------------
    ! FLUX FIND DateInterval
    !
    !  Scan the current UV table (obtained by READ UV) to determine
    !  how many independent dates exist
    !
    !  Compare it date by date with the model UV table (obtained by 
    !  READ MODEL) and compute, through linear regression, the best scaling
    !  factors to match the two tables
    !
    !  Return these flux factors as variables
    !  FLUX and D_FLUX
    !-----------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    logical :: equal
    integer :: ier
    !
    call sic_i4 (line,0,2,date_interval,.true.,error)
    if (error) return
    date_interval = max(1,date_interval) 
    !
    call gdf_compare_shape(huv,uvm%head,equal)
    if (.not.equal) then
       print *,'Data  ',huv%gil%dim
       print *,'Model ',uvm%head%gil%dim 
       call gagout('E-FLUX,   Data and Model are not comparable')
       error = .true.
       return
    endif
    if (n_dates.ne.0) then
       deallocate(class,fscale,dscale,chain,stat=ier)
       n_dates = 0
       call sic_delvariable('FLUX',.false.,error)
       call sic_delvariable('D_FLUX',.false.,error)
    endif
    call flux_scale_factor(huv,duv,uvm%head,uvm%data,date_interval)
    !
    call sic_def_real('FLUX',fscale,1,n_dates,.false.,error)
    call sic_def_real('D_FLUX',dscale,1,n_dates,.false.,error)
  end subroutine flux_scale_find
  !
  subroutine flux_scale_list(line,error)
    !-----------------------------------------------------------
    ! @ private
    !
    ! MAPPING
    ! Support routine for command
    !  FLUX LIST 
    !
    !  printout the latest results from FLUX FIND
    !-----------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: id
    !
    if (n_dates.eq.0) then
       print *,'Dates not defined, use command FLUX FIND before'
       error = .true.
       return
    endif
    print *,'Summary of observations' 
    print *,'                             Baselines (kLambda)          '
    print *,' Dates      Visibilities       Min   &  Max           Scale'
    do id=1,n_dates
       write(chain(id)(49:),'(F8.3,a,F6.3)') fscale(id),' +/-',dscale(id)
       print *,chain(id)
    enddo
  end subroutine flux_scale_list
  !
  subroutine flux_scale_factor(hduv,duv,hcuv,cuv,date_spacing)
    use image_def
    !-----------------------------------------------------------
    ! Find the flux scale factors for the Observations
    !
    ! The observations are defined by  Obs = Factor * Model + noise
    ! so the calibration factor to apply is the inverse of this solution
    !-----------------------------------------------------------
    integer,       intent(in) :: date_spacing
    type (gildas), intent(in) :: hduv
    type (gildas), intent(in) :: hcuv
    real(kind=4),  intent(in) :: duv(hduv%gil%dim(1),hduv%gil%dim(2))
    real(kind=4),  intent(in) :: cuv(hcuv%gil%dim(1),hcuv%gil%dim(2))
    !
    real(kind=8), allocatable :: xy(:), xx(:), yy(:)
    integer :: nm,nv,nc,nd
    integer :: id,ie,iv,ic,ti,ier
    integer :: ii,ir,iw
    !
    ! 3) Build list of dates
    nm = hduv%gil%dim(1)
    nv = hduv%gil%dim(2)
    nc = (nm-7)/3
    !
    call find_date(nm,nv,duv,date_spacing,nd) 
    allocate(class(nd),fscale(nd),dscale(nd),chain(nd),stat=ier)
    !
    call list_date(nm,nv,duv,nd,class,date_spacing,chain) 
    !
    ! 4) Linear fit of flux scale factor
    !
    ! A = Sum (X Y / sigma^2) / Sum (X^2/Sigma^2)
    ! A = Sum (X Y W) / Sum (X X W)
    !
    allocate (xy(nd),xx(nd),yy(nd),stat=ier)
    xx = 0
    xy = 0
    yy = 0
    id = 1
    !
    do iv=1,nv
       ! Get the date
       ti = int(duv(4,iv)+duv(5,iv)/86400.0d0)     
       if (ti.eq.0 .and.duv(6,iv).eq.0) cycle !! Dummy
       if (abs(ti-class(id)).ge.date_spacing) then
          do ie=1,nd 
             if (abs(ti-class(ie)).lt.date_spacing) then
                id = ie
                exit
             endif
          enddo
       endif
       !
       do ic=1,nc
          ir = 5+3*ic
          ii = ir+1
          iw = ii+1
          !
          xx(id) = xx(id) + (cuv(ir,iv)**2 + cuv(ii,iv)**2) * cuv(iw,iv)
          xy(id) = xy(id) + (duv(ir,iv)*cuv(ir,iv) + duv(ii,iv)*cuv(ii,iv)) * cuv(iw,iv)
          yy(id) = yy(id) + (duv(ir,iv)**2 + duv(ii,iv)**2) * duv(iw,iv)
       enddo
    enddo
    !
    !! factors = xy/yy  ! Not these ones
    fscale(:) = xy/xx
    dscale = 0.01  
    n_dates = nd
    !
  contains
    !
    subroutine find_date(nc,nv,visi,itol,nt) 
      !-----------------------------------------------------------
      ! Find how many dates
      !-----------------------------------------------------------
      integer, intent(in)  :: nc          ! Visibility size 
      integer, intent(in)  :: nv          ! Number of visibilities
      integer, intent(out) :: nt          ! Number of time stamps
      integer, intent(in)  :: itol        ! Tolerance to check dates 
      real,    intent(in)  :: visi(nc,nv) ! Visibilities
      !
      integer iv
      integer ti,jt,j
      integer tf(nv)
      !
      nt = 0
      do iv=1,nv
         ti = int(visi(4,iv)+visi(5,iv)/86400.0d0)
         if (ti.eq.0 .and.visi(6,iv).eq.0) cycle !! Dummy
         jt = 0
         do j=1,nt
            if (abs(ti-tf(j)).lt.itol) then
               jt = j
               exit
            endif
         enddo
         if (jt.eq.0) then
            nt = nt+1
            tf(nt) = ti
         endif
      enddo
    end subroutine find_date
    !
    subroutine list_date(nc,nv,visi,nt,tf,itol,chain) 
      use gkernel_interfaces
      !-----------------------------------------------------------
      ! List the different dates 
      !-----------------------------------------------------------
      integer,          intent(in)  :: nc          ! Visibility size 
      integer,          intent(in)  :: nv          ! Number of visibilities
      real,             intent(in)  :: visi(nc,nv) ! Visibilities
      integer,          intent(in)  :: nt          ! Number of time stamps
      integer,          intent(out) :: tf(nt)      ! Time stamp values
      integer,          intent(in)  :: itol        ! Tolerance to check dates 
      character(len=*), intent(out) :: chain(nt)   ! Associated message
      !
      character(len=14) :: ch
      integer :: jt,ti,co,iv,i,j,k
      integer :: it
      integer :: count(nt)
      real :: bmin(nt),bmax(nt),bm,bp,base
      !
      logical error
      !
      it = 0
      tf = 0
      bmin = 1E20
      bmax = 0
      !
      print *,'Date Tolerance ',itol
      !
      do iv=1,nv
         ti = int(visi(4,iv)+visi(5,iv)/86400.0d0)
         if (ti.eq.0 .and.visi(6,iv).eq.0) cycle !! Dummy
         jt = 0
         do j=1,nt
            if (abs(ti-tf(j)).lt.itol) then
               jt = j
               exit
            endif
         enddo
         if (jt.eq.0) then
            if (it.gt.nt) then
               print *,'E-DATES,  more than ',nt,' dates'
               return
            endif
            it = it+1
            tf(it) = ti
            count(it) = 1
            jt = it
         else
            count(jt) = count(jt)+1
         endif
         !
         base = visi(1,iv)**2+visi(2,iv)**2
         if (base.ne.0) then
            bmin(jt) = min(base,bmin(jt))
            bmax(jt) = max(base,bmax(jt))
         endif
      enddo
      !
      ! Go to true baseline length
      bmin = sqrt(bmin)
      bmax = sqrt(bmax)
      !
      ! A simple sort
      do j = nt-1,1,-1
         k = j
         do i = j+1,nt
            if (tf(j).le.tf(i)) exit 
            k = i
         enddo
         if (k.ne.j) then
            ti = tf(j)
            co = count(j)
            bp = bmax(j)
            bm = bmin(j)     
            do i = j+1,k
               tf(i-1) = tf(i)
               count(i-1) = count(i)
               bmax(i-1) = bmax(i)
               bmin(i-1) = bmin(i)
            enddo
            tf(k) = ti
            count(k) = co
            bmax(k) = bp
            bmin(k) = bm
         endif
      enddo
      !
      do i=1,nt
         call gag_todate(tf(i),ch,error)
         write(chain(i),100) ch,count(i),bmin(i),bmax(i)
      enddo
100   format (A,I8,3X,F9.1,1X,F9.1) 
    end subroutine list_date
  end subroutine flux_scale_factor
end module mapping_flux_scale
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cfitsio_bintable
  use cfitsio_interfaces
  use cfitsio_messaging
  use cfitsio_status
  !---------------------------------------------------------------------
  ! Routines to provide enhanced API for CFITSIO binary tables
  !---------------------------------------------------------------------
  !
  public :: cfitsio_bintable_read_column_r4
  private
  !
contains
  !
  subroutine cfitsio_bintable_read_column_r4(caller,iunit,colnum,frow,felem,nelem,array,error)
    use, intrinsic :: iso_c_binding, only : c_float,c_int,c_long_long,c_ptr
    !-------------------------------------------------------------------
    ! Custom overlay to CFITSIO routine fits_read_col_flt (ffgcve)
    ! with I*8 arguments.
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: caller    ! Name of calling procedure
    integer(kind=4),  intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4),  intent(in)    :: colnum    ! Number of the column to read
    integer(kind=8),  intent(in)    :: frow      ! First row to read
    integer(kind=8),  intent(in)    :: felem     ! First element within the row to read
    integer(kind=8),  intent(in)    :: nelem     ! Number of elements to read
    real(kind=4),     intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,          intent(inout) :: error     ! Logical error flag
    ! Local
    type(c_ptr) :: fptr
    integer(c_int) :: colnum_c,anynul_c,status_c
    integer(c_long_long) :: felem_c,frow_c,nelem_c
    real(c_float) :: nulval_c
    character(len=message_length) :: mess
    !
    call cfitsio_file_cptr(iunit,fptr,error)
    if (error)  return
    !
    colnum_c = int(colnum,kind=c_int)
    frow_c = int(frow,kind=c_long_long)
    felem_c = int(felem,kind=c_long_long)
    nelem_c = int(nelem,kind=c_long_long)
    nulval_c = -1.0_c_float
    anynul_c = 0_c_int
    status_c = int(0_c_int)
    !
    status_c = fits_read_col_flt(fptr,colnum_c,frow_c,felem_c,nelem_c,nulval_c,  &
                                 array,anynul_c,status_c)
    !
    if (anynul_c.ne.0_c_int .or. status_c.gt.0) then
      call cfitsio_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,I0)')  &
        'Error while reading column #',colnum,', row #',frow
      call cfitsio_message(seve%e,caller,mess)
      if (anynul_c.ne.0_c_int) then
        call cfitsio_message(seve%e,caller,'Some null values found')
      else
        call cfitsio_errormsg(status_c)
        call ftrprt('STDOUT',status_c)  ! Much verbose for debugging
      endif
      error = .true.
      return
    endif
  end subroutine cfitsio_bintable_read_column_r4
end module cfitsio_bintable

subroutine class_save(set,line,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_save
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! CLASS Support routine for command
  !
  ! SAVE  [Filename]
  !
  ! Save all current default on a CLASS procedure
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: proc='SAVE'
  character(len=64) :: argum
  character(len=filename_length) :: file_save,mess
  integer :: nc,ier,lun
  !
  argum='SAVED'
  call sic_ch (line,0,1,argum,nc,.false.,error)
  if (error) return
  call sic_parse_file(argum,' ','.class',file_save)
  ier = sic_getlun(lun)
  if (ier.ne.1) then
     mess = 'Cannot open file '//file_save
     call class_message(seve%e,proc,mess)
     call class_message(seve%e,proc,'No logical unit left')
     error = .true.
     return
  endif
  !
  ier = sic_open(lun,file_save,'NEW',.false.)
  if (ier.ne.0) then
     mess = 'Cannot open file '//file_save
     call class_message(seve%e,proc,mess)
     call putios('         ',ier)
     error = .true.
  else
     call sas_save(set,lun,error)
     close(unit=lun)
     mess = 'Parameters saved on '//file_save
     call class_message(seve%e,proc,mess)
  endif
  call sic_frelun(lun)
end subroutine class_save
!
subroutine sas_save(set,lun,error)
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>sas_save
  use class_setup_new
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !    SAVE
  ! Save the current CLASS parameters on a file opend on a Logical Unit
  ! Number
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  integer(kind=4),     intent(in)    :: lun    ! Fortran Logical Unit Number to use
  logical,             intent(inout) :: error  !
  ! Local
  integer(kind=4) :: i,nc
  character(len=12) :: arg,argum1,argum2,argum3,argum4
  character(len=256) :: chaine
  character(len=80) :: messa,mess
  character(len=1), parameter :: backslash=char(92)
  integer(kind=8), parameter :: maxi8=9223372036854775807_8
  !
  ! Setup parameters
  write(lun,1009) '!'
  write(lun,1009) '!  Saved CLASS parameters'
  write(lun,1009) '!'
  !
  ! angle
  mess = 'LAS'//backslash//'SET ANGLE'
  write(lun,1000) mess(1:lenc(mess)),class_setup_get_angle(),'! Angle unit'
  !
  ! align
  mess = 'LAS'//backslash//'SET ALIGN'
  messa = set%align//' '//set%alig2
  write(lun,1000) mess(1:lenc(mess)),messa(1:lenc(messa)),'! Align type for adding spectra'
  !
  ! bad
  mess = 'LAS'//backslash//'SET BAD'
  write(lun,1000) mess(1:lenc(mess)),set%bad,'! Bad channel checking mode'
  !
  ! base
  if (set%base.eq.-1) then
     mess = 'LAS'//backslash//'SET BASELINE'
     write(lun,1000) mess(1:lenc(mess)),'SINUS','! Sinusoidal baseline'
  else
     mess = 'LAS'//backslash//'SET BASELINE'
     write(lun,1001) mess(1:lenc(mess)),set%base,'! degree of polynomial'
  endif
  !
  ! coord
  if (set%coord.eq.0) then
     mess = 'LAS'//backslash//'SET SYSTEM'
     write(lun,1000) mess(1:lenc(mess)),'AUTO','! Coordinate system '
  elseif (set%coord.eq.type_eq) then
     mess = 'LAS'//backslash//'SET SYSTEM EQUATORIAL '
     write(lun,1005) mess(1:lenc(mess)),set%equinox,'! Coordinate system '
  else
     mess = 'LAS'//backslash//'SET SYSTEM'
     write(lun,1000) mess(1:lenc(mess)),'GALACTIC','! Coordinate system '
  endif
  !
  ! format
  mess = 'LAS'//backslash//'SET FORMAT'
  write(lun,1000) mess(1:lenc(mess)),set%heade,'! Default header format'
  !
  ! line
  mess = 'LAS'//backslash//'SET LINE'
  write(lun,1013) mess(1:lenc(mess)),set%line,'! Molecular transition'
  ! fit mask
  if (set%nmask.eq.0) then
     mess = 'LAS'//backslash//'SET MASK'
     write(lun,1000) mess(1:lenc(mess)),'NONE','! no fit mask'
  else
     if (set%kind.eq.kind_spec) then
        mess = 'LAS'//backslash//'SET MASK'
        write(chaine,1010) &
             mess(1:lenc(mess)),(set%mask1(i),set%mask2(i),i=1,set%nmask)
     elseif (set%kind.eq.kind_cont) then
        mess = 'LAS'//backslash//'SET MASK'
        write(chaine,1010)  mess(1:lenc(mess)),  &
          (set%mask1(i)*class_setup_get_fangle(),  &
           set%mask2(i)*class_setup_get_fangle(),i=1,set%nmask)
     endif
     call sic_noir(chaine,nc)
     write(lun,1009) chaine(1:nc)
  endif
  !
  ! match
  if (set%match) then
     call offsec(set,set%tole,arg)
     mess = 'LAS'//backslash//'SET MATCH'
     write(lun,1000) mess(1:lenc(mess)),arg(1:lenc(arg)),'! Position match tested.'
  else
     mess = 'LAS'//backslash//'SET NOMATCH'
     write(lun,1000) mess(1:lenc(mess)),' ','! Position match not tested.'
  endif
  !
  ! MODE X
  if (set%modex.eq.'T') then
     mess = 'LAS'//backslash//'SET MODE X'
     write(lun,1000) mess(1:lenc(mess)),   &
          &      'TOTAL','! Whole spectrum displayed'
  elseif  (set%modex.eq.'A') then
     mess = 'LAS'//backslash//'SET MODE X'
     write(lun,1000) mess(1:lenc(mess)),   &
          &      'AUTO','! Pre-determined scale for X'
  else
     mess = 'LAS'//backslash//'SET MODE X'
     write(lun,1002) mess(1:lenc(mess)),gux1,   &
          &      gux2,'! Fixed mode for X'
  endif
  !
  ! MODE Y
  if (set%modey.eq.'T') then
     mess = 'LAS'//backslash//'SET MODE Y'
     write(lun,1000) mess(1:lenc(mess)),   &
          &      'TOTAL','! Whole spectrum displayed'
  elseif  (set%modey.eq.'A') then
     mess = 'LAS'//backslash//'SET MODE Y'
     write(lun,1000) mess(1:lenc(mess)),   &
          &      'AUTO','! Pre-determined scale for Y'
  else
     mess = 'LAS'//backslash//'SET MODE Y'
     write(lun,1002) mess(1:lenc(mess)),   &
          &      guy1,guy2,'! Fixed mode for Y'
  endif
  !
  ! Number
  if (set%nume2.lt.maxi8) then
     mess = 'LAS'//backslash//'SET NUMBER'
     write(lun,1003) trim(mess),set%nume1,set%nume2,'! Scan number range.'
  else
     mess = 'LAS'//backslash//'SET NUMBER'
     write(lun,1012) trim(mess),set%nume1,' *','! Scan number range.'
  endif
  !
  ! Observed date
  call gag_todate(set%obse1,argum1,error)
  call gag_todate(set%obse2,argum2,error)
  mess = 'LAS'//backslash//'SET OBSERVED '   &
       &    //argum1(1:lenc(argum1))//' '//argum2(1:lenc(argum2))
  write(lun,1004) mess(1:lenc(mess)),'! Range of observ. dates.'
  !
  ! Offset-range
  call offsec(set,set%offs1,argum1)
  call offsec(set,set%offl1,argum2)
  call offsec(set,set%offs2,argum3)
  call offsec(set,set%offl2,argum4)
  mess = 'LAS'//backslash//'SET RANGE '//argum1(1:lenc(argum1))   &
       &    //' '//argum2(1:lenc(argum2))//' '//argum3(1:lenc(argum3))   &
       &    //' '//argum4(1:lenc(argum4))
  write(lun,1004) mess(1:lenc(mess)),'! Offset range.'
  !
  ! Plot
  mess = 'LAS'//backslash//'SET PLOT'
  write(lun,1000) mess(1:lenc(mess)),set%plot,'! plot type.'
  !
  ! Reduction date
  call gag_todate(set%redu1,argum1,error)
  call gag_todate(set%redu2,argum2,error)
  mess = 'LAS'//backslash//'SET REDUCED '//argum1(1:lenc(argum1))   &
       &    //' '//argum2(1:lenc(argum2))
  write(lun,1004) mess(1:lenc(mess)),'! Range of reduc. dates.'
  !
  ! Source
  mess = 'LAS'//backslash//'SET SOURCE'
  write(lun,1013) mess(1:lenc(mess)),set%sourc,'! Source name'
  !
  ! Telescope
  mess = 'LAS'//backslash//'SET TELESCOPE'
  write(lun,1013) mess(1:lenc(mess)),set%teles,'! Telescope name'
  !
  ! Type of data
  if (set%kind.eq.kind_spec) then
     mess = 'LAS'//backslash//'SET TYPE SPECTROSCOPY'
     write(lun,1004) mess(1:lenc(mess)),'! Data type'
  elseif (set%kind.eq.kind_cont) then
     mess = 'LAS'//backslash//'SET TYPE CONTINUUM'
     write(lun,1004) mess(1:lenc(mess)),'! Data type'
  elseif (set%kind.eq.kind_sky) then
     mess = 'LAS'//backslash//'SET TYPE SKYDIP'
     write(lun,1004) mess(1:lenc(mess)),'! Data type'
  elseif (set%kind.eq.kind_onoff) then
     mess = 'LAS'//backslash//'SET TYPE ONOFF'
     write(lun,1004) mess(1:lenc(mess)),'! Data type'
  else
     write(lun,1009) '! Unsupported kind of data'
  endif
  !
  ! unit of X axis
  mess = 'LAS'//backslash//'SET UNIT'
  write(lun,1000) mess(1:lenc(mess)),set%unitx(1),   &
       &    '! Unit of x axis (vel. freq. or chan.)'
  !
  ! weight
  mess = 'LAS'//backslash//'SET WEIGHT'
  write(lun,1000) mess(1:lenc(mess)),   &
       &    set%weigh,'! Weight type for summations.'
  !
  ! window
  if (set%nwind.eq.0) then
     mess = 'LAS'//backslash//'SET WINDOW'
     write(lun,1000) mess(1:lenc(mess)),'NONE',   &
          &      '! no line window.'
  else
     if (set%kind.eq.kind_spec) then
        mess = 'LAS'//backslash//'SET WINDOW'
        write(chaine,1010) mess(1:lenc(mess)),   &
             &        (set%wind1(i),set%wind2(i),   &
             &        i=1,set%nwind)
     elseif (set%kind.eq.kind_cont) then
        mess = 'LAS'//backslash//'SET WINDOW'
        write(chaine,1010) mess(1:lenc(mess)),   &
             &        (set%wind1(i)*class_setup_get_fangle(),   &
             &        set%wind2(i)*class_setup_get_fangle(),i=1,set%nwind)
     endif
     call sic_noir(chaine,nc)
     write(lun,1009) chaine(1:nc)
  endif
  !
1000 format(a,1x,a,t50,a)
1001 format(a,1x,i2,t50,a)
1002 format(a,2x,2(1pg11.4),t50,a)
1003 format(a,2(2x,i0),t50,a)
1004 format(a,t50,a)
1005 format(a,1x,1pg11.4,t50,a)
1009 format(a)
1010 format(a,10(1pg10.3))
1012 format(a,i0,a,t50,a)
1013 format(a,' "',a,'"',t50,a)
end subroutine sas_save

function sic_ctrlc()
  use gsys_variables
  !---------------------------------------------------------------------
  ! @ public
  ! Return .TRUE. if ^C has been pressed, and restore CONTROLC flag to
  ! .FALSE.
  !---------------------------------------------------------------------
  logical :: sic_ctrlc  ! Function value on return
  !
  sic_ctrlc = controlc
  controlc = .false.
end function sic_ctrlc
!
function sic_ctrlc_status()
  use gsys_variables
  !---------------------------------------------------------------------
  ! @ public
  ! Return .TRUE. if ^C has been pressed but do *not* restore CONTROLC
  ! flag to .FALSE.
  !---------------------------------------------------------------------
  logical :: sic_ctrlc_status  ! Function value on return
  !
  sic_ctrlc_status = controlc
end function sic_ctrlc_status
!
subroutine set_ctrlc
  use gsys_variables
  !---------------------------------------------------------------------
  ! @ private
  ! Set CONTROLC flag to .TRUE.
  ! Re-initiate the ^C trapping by calling TRAP_CTRLC
  !---------------------------------------------------------------------
  controlc = .true.
  call trap_ctrlc
end subroutine set_ctrlc

subroutine attach_greg_values(dir,tab_greg,error)
  use gtv_buffers
  use gtv_interfaces, except_this=>attach_greg_values
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Update the input Greg values and save them in the input directory
  ! descriptor.
  !---------------------------------------------------------------------
  type(gt_directory), intent(inout) :: dir       ! Directory
  type(greg_values),  intent(inout) :: tab_greg  ! Greg values
  logical,            intent(inout) :: error     ! Logical error flag
  !
  tab_greg%lx1 = 0.0
  tab_greg%lx2 = dir%phys_size(1)
  tab_greg%ly1 = 0.0
  tab_greg%ly2 = dir%phys_size(2)
  !
  dir%val_greg = tab_greg
  !
end subroutine attach_greg_values
!
subroutine get_greg_values(tab_greg)
  use gtv_dependencies_interfaces
  use gtv_interfaces
  use gildas_def
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ no-interface
  !---------------------------------------------------------------------
  integer(kind=4) :: tab_greg(*)  ! Whole block of Greg values
  !
  ! Get values from GreG values in TAB_GREG
  call gt_greg_user(1,tab_greg)
  !
end subroutine get_greg_values
!
subroutine send_greg_values(tab_greg)
  use gtv_dependencies_interfaces
  use gtv_interfaces
  use gildas_def
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ no-interface
  !---------------------------------------------------------------------
  integer(kind=4) :: tab_greg(*)  ! Whole block of Greg values
  !
  ! Transmit values in TAB_GREG to GreG
  call gt_greg_user(-1,tab_greg)
  !
end subroutine send_greg_values
!
subroutine reset_greg_val(tab_greg)
  use gtv_dependencies_interfaces
  use gtv_interfaces
  use gildas_def
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ no-interface
  !---------------------------------------------------------------------
  integer(kind=4) :: tab_greg(*)  ! Whole block of Greg values
  !
  ! Reset current position & pen in GreG
  call gt_greg_user(0,tab_greg)
  !
end subroutine reset_greg_val

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtcal_chunkset_types
  use gildas_def
  use gkernel_interfaces
  use mrtcal_chunk_types
  use mrtcal_messaging
  !
  private
  public :: chunkset_t
  !
  type chunkset_t
    integer(kind=4)        :: n   ! Number of chunks in this set
    type(chunk_t), pointer :: chunks(:) => null() ! [ n ] The chunks
    integer(kind=4)        :: allocated=code_pointer_null ! Allocated or just associated?
  contains
    procedure, public :: reallocate  => reallocate_chunkset
    procedure, public :: reassociate => reassociate_chunkset
    procedure, public :: free        => free_chunkset
    procedure, public :: nullify     => nullify_chunkset
    procedure, public :: clone       => clone_chunkset
    procedure, public :: init_data   => chunkset_init_data
    procedure, public :: consistency => chunkset_consistency
  end type chunkset_t
  !
contains
  !
  subroutine reallocate_chunkset(chunkset,n,error)
    !-------------------------------------------------------------------
    ! (Re)allocate a chunkset so that it can store n chunks.
    !
    ! Nothing is done for the chunks in the chunkset. The caller is free
    ! to allocate them or associate them depending on its need.
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: chunkset
    integer(kind=4),   intent(in)    :: n
    logical,           intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='REALLOCATE>CHUNKSET'
    logical :: alloc
    character(len=message_length) :: mess
    integer(kind=4) :: ier
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    if (n.le.0) then
      write(mess,'(A,I0,A)')  'Array size can not be zero nor negative (got ',n,')'
      call mrtcal_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    alloc = .true.
    if (chunkset%allocated.eq.code_pointer_associated) then
      call mrtcal_message(seve%e,rname,  &
        'Internal error: attempt to allocate an associated pointer')
      error = .true.
      return
    elseif (chunkset%allocated.eq.code_pointer_allocated) then
       if (.not.associated(chunkset%chunks)) then
         ! How come!?!? chunkset has code 'allocated' but its pointer is
         ! not associated? Something wrong, need fix.
         call mrtcal_message(seve%e,rname,  &
           'Internal error: CHUNKSET is expected to be associated but is not')
         error = .true.
         return
       endif
       if (chunkset%n.eq.n) then
          write(mess,'(a,i0)')  &
            'CHUNKSET already associated at the right size: ',n
          call mrtcal_message(seve%d,rname,mess)
          alloc = .false.
       else
          call mrtcal_message(seve%d,rname,  &
            'CHUNKSET pointer already associated but with a different size => Freeing it first')
          call chunkset%free(error)
          if (error)  return
       endif
    endif
    !
    if (alloc) then
       allocate(chunkset%chunks(n),stat=ier)
       if (failed_allocate(rname,'CHUNKSET',ier,error)) then
          call chunkset%free(error)
          return
       endif
       chunkset%allocated = code_pointer_allocated
       write(mess,'(a,i0)') 'Allocated CHUNKSET of size: ',n
       call mrtcal_message(seve%d,rname,mess)
    endif
    !
    ! Allocation success => Initialize
    chunkset%n = n
  end subroutine reallocate_chunkset
  !
  subroutine reassociate_chunkset(ou,in,error,ichunk)
    !---------------------------------------------------------------------
    !  Associate a chunkset onto another one.
    !  If 'ichunk' is present, associate only onto this single element
    !  (pointer to subset).
    !---------------------------------------------------------------------
    class(chunkset_t),         intent(inout) :: ou
    type(chunkset_t),          intent(in)    :: in
    logical,                   intent(inout) :: error
    integer(kind=4), optional, intent(in)    :: ichunk
    ! Local
    character(len=*), parameter :: rname='REASSOCIATE>CHUNKSET'
    integer(kind=4) :: first,last
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    if (present(ichunk)) then
      if (ichunk.lt.1 .or. ichunk.gt.in%n) then
        call mrtcal_message(seve%e,rname,'Invalid chunk number')
        error = .true.
        return
      endif
      first = ichunk
      last = first
    else
      first = 1
      last = in%n
    endif
    !
    if (ou%allocated.eq.code_pointer_allocated) then
      call ou%free(error)
      if (error)  return
    endif
    !
    ou%n = last-first+1
    ou%chunks => in%chunks(first:last)
    ou%allocated = code_pointer_associated
  end subroutine reassociate_chunkset
  !
  subroutine free_chunkset(chunkset,error)
    !-------------------------------------------------------------------
    ! Free a chunkset
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: chunkset
    logical,           intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FREE>CHUNKSET'
    integer(kind=4) :: ichunk
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    if (chunkset%allocated.eq.code_pointer_associated) then
      call chunkset%nullify(error)
      if (error)  return
      !
    elseif (chunkset%allocated.eq.code_pointer_allocated) then
      do ichunk=1,ubound(chunkset%chunks,1)
        call chunkset%chunks(ichunk)%free(error)
        ! if (error) continue
      enddo ! ichunk
      chunkset%n = 0
      if (associated(chunkset%chunks))  deallocate(chunkset%chunks)
      chunkset%allocated = code_pointer_null
    endif
  end subroutine free_chunkset
  !
  subroutine nullify_chunkset(chunkset,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: chunkset
    logical,           intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='NULLIFY>CHUNKSET'
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    if (chunkset%allocated.eq.code_pointer_associated) then
      chunkset%n = 0
      chunkset%chunks => null()
      chunkset%allocated = code_pointer_null
      !
    elseif (chunkset%allocated.eq.code_pointer_allocated) then
      call mrtcal_message(seve%e,rname,'Attempt to nullify an allocated pointer')
      error = .true.
      return
    endif
  end subroutine nullify_chunkset
  !
  subroutine chunkset_consistency(c1,caller,c2,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(chunkset_t), intent(in)    :: c1
    character(len=*),  intent(in)    :: caller  ! Calling routine name
    type(chunkset_t),  intent(in)    :: c2
    logical,           intent(inout) :: error
    ! Local
    integer(kind=4) :: ichunk
    character(len=message_length) :: mess
    !
    if (c1%n.ne.c2%n) then
      write(mess,'(A,I0,1X,I0)')  &
        'Inconsistent number of chunks per set: ',c1%n,c2%n
      call mrtcal_message(seve%e,caller,mess)
      error = .true.
      return
    endif
    !
    do ichunk=1,c1%n
      if (c1%chunks(ichunk)%ndata.ne.c2%chunks(ichunk)%ndata) then
        write(mess,'(A,I0,1X,I0)')  'Inconsistent number of channels: ', &
          c1%chunks(ichunk)%ndata,c2%chunks(ichunk)%ndata
        call mrtcal_message(seve%e,caller,mess)
        error = .true.
        return
      endif
    enddo
    !
  end subroutine chunkset_consistency
  !
  subroutine chunkset_init_data(chunkset,v,w,c,error)
    !-------------------------------------------------------------------
    ! Initialize the chunk data from the input values
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: chunkset
    real(kind=4),      intent(in)    :: v      ! Data value (duplicated to all channels)
    real(kind=4),      intent(in)    :: w      ! Weight (duplicated to all channels)
    real(kind=4),      intent(in)    :: c      ! Continuum value
    logical,           intent(inout) :: error
    ! Local
    integer(kind=4) :: ichunk
    character(len=*), parameter :: rname='CHUNKSET>INIT>DATA'
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    do ichunk=1,chunkset%n
      call chunkset%chunks(ichunk)%init_data(v,w,c,error)
      if (error) return
    enddo ! ichunk
  end subroutine chunkset_init_data
  !
  subroutine clone_chunkset(ou,in,doheader,error)
    !-------------------------------------------------------------------
    !  Clone a chunkset structure.
    !
    !  The chunks in the chunkset are ALLOCATED so that the full structure
    ! clones exactly the input one.
    !  Nothing is done for the data and headers (not copied, not
    ! initialized e.g. to 0).
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: ou        !
    type(chunkset_t),  intent(in)    :: in        !
    logical,           intent(in)    :: doheader  ! Also clone the headers?
    logical,           intent(inout) :: error     !
    ! Local
    integer(kind=4) :: ichunk
    !
    call ou%reallocate(in%n,error)
    if (error) return
    !
    do ichunk=1,in%n
      call ou%chunks(ichunk)%clone(in%chunks(ichunk),doheader,error)
      if (error) return
    enddo
  end subroutine clone_chunkset
end module mrtcal_chunkset_types
!

module ast_horizon
! Old horizon.inc
      integer(kind=4), parameter :: m_horiz=9
      integer(kind=4), parameter :: m_source=1000
!
      real(kind=8) :: horiz(m_horiz), rise(m_source, m_horiz)
      real(kind=8) :: set (m_source, m_horiz), transit(m_source)
      real(kind=8) :: declin(m_source), righta(m_source),dsun(m_source)
      real(kind=8) :: sunriz(4),sunset(4),moonphse, moonmag
      integer(kind=4) :: n_horiz, next_source(2), n_rise
      logical :: airmass, night_mark
!
      character(len=36) :: c_rise(m_source)
      integer(kind=4) :: min_elev(m_source)
!
! Old projec.inc
      character(len=4) :: c_proj(m_source)
      character(len=8) :: c_freq(m_source)
      character(len=4) :: c_weig(m_source)
end module ast_horizon
!
module ast_line
! PDBI/ALMA/PICO receiver/correlator setup
      integer(kind=4) :: obs_year
      integer(kind=4) :: alma_cycle
! NOEMA mode (ONLINE or OFFLINE)
      character(len=8) :: noema_mode
!
! spurious lines
      real(kind=8) :: flo1ref
      logical :: do_spurious
!
! correlator setup
      logical :: narrow_def
      integer(kind=4) :: narrow_input(2)
      integer(kind=4), parameter :: nunit=8
      logical :: unit_def(nunit)
      integer(kind=4) :: unit_band(nunit)
      real(kind=4) :: unit_cent(nunit)
      integer(kind=4) :: unit_wind(nunit)
      integer(kind=4) :: unit_bmode(nunit)
!
! ALMA correlator setup
      logical :: bb_def(4)
      real(kind=4) :: bb_cfreq(4)
      integer(kind=4) :: bb_sideband(4)
      integer(kind=4) :: bb_nspw(4)
      real(kind=4) :: tolerance_freq
!
      integer(kind=4) :: maxsp
      parameter(maxsp=40)
      real spw_width(4,maxsp)
      real spw_cfreq(4,maxsp)
      integer spw_polar(4,maxsp)
      real spw_use(4,maxsp)
      integer spw_sideband(4,maxsp)
!---------------------------------------------
!
! Molecules
      integer nmol
    integer, parameter :: mmol=1000
      character(len=20) molname(mmol)
      real(8) molfreq(mmol)
      real(4) width
!------------------------------------
!
! plot
      real(8) flo1
      integer plot_mode
      real(4) iflim(2), userlim(2)
      integer sky
      character(len=132) label
!
! for plot /atmosphere
      logical do_atmplot
      real plotwater
!
! for print command
      character(len=80) linecomm
      integer recband
end module ast_line

module ast_constant
    real(kind=8),  parameter :: pi=3.141592653589793d0
    real(kind=8),  parameter ::  halfpi=pi/2d0
    real(kind=8),  parameter :: twopi = pi*2d0
    real(kind=8),  parameter :: j2000 = 2451545.0d0
    real(kind=8),  parameter :: light = 299792.458d0   ! km/s
    real(kind=8),  parameter :: radius=6367.435d0      ! earth radius in kilometers
    real(kind=8), parameter :: au_m=149597870700d0 !astronomical unit in m
    real(kind=8), parameter :: au_km=149597870.700d0 !astronomical unit in m
    real(kind=8), parameter :: astro_nullr8=-1.2345d36
    real(kind=4), parameter :: astro_nullr4=-1.2345e36
    real(kind=8), parameter :: astro_nulli8=-12345678
    real(kind=4), parameter :: astro_nulli4=-12345678
    character(len=4), parameter :: astro_nulla='NULL'
end module ast_constant
!
module ast_params
  integer(kind=8), parameter :: sourcename_length=128
  !
end module ast_params
!
module ast_planets
  use gildas_def
  use ast_ephem
  !
  integer(kind=4), parameter :: m_body = 9
  character(len=12), parameter :: body(m_body+1)=(/ 'MOON        ', 'SUN         ', &
                    'MERCURY     ', 'VENUS       ', 'MARS        ', 'JUPITER     ', &
                    'SATURN      ', 'URANUS      ', 'NEPTUNE     ', 'ALL         '/)
  ! Body id
  !-----------
  integer(kind=4), parameter :: ibody_moo=1
  integer(kind=4), parameter :: ibody_sun=2
  integer(kind=4), parameter :: ibody_mer=3
  integer(kind=4), parameter :: ibody_ven=4
  integer(kind=4), parameter :: ibody_mar=5
  integer(kind=4), parameter :: ibody_jup=6
  integer(kind=4), parameter :: ibody_sat=7
  integer(kind=4), parameter :: ibody_ura=8
  integer(kind=4), parameter :: ibody_nep=9
  integer(kind=4), parameter :: ibody_all=10
  ! Plot Symbol 
  !-------------
  character(len=1), parameter :: c_symbol(m_body)=(/':', '0', '1', '2', '4', '5', '6', '7', '8'/)
  ! Body properties
  !------------------
  ! Planet Radius from Astronomical Almanac 2015 (page E6):
  real(kind=8), parameter :: plrad(m_body) = (/1737.4d0,0.d0,2439.7d0,6051.8d0,&
                                 3396.2d0,71492.d0,60268.d0,25559.d0,24764.d0/)    ! in km
  ! Aspect ratio = oblateness=flatening from Ast. Almanac 2015 (page E6):
  ! aratio=(Feq-Fpol)/Feq)
  real(kind=8), parameter :: aratio(m_body) = (/0d0,0d0,0d0,0d0, 0.005886d0, &
                                    0.064874d0,0.097962d0,0.022927d0,0.017081d0/) 
  ! Pole coordinates from Astronomical Almanac 2015 (page E5):
  real(kind=8), parameter :: rap(m_body) = (/0.d0, 0.d0, 281.00d0, 272.76d0, 317.67d0, &
                                              268.06d0, 40.58d0,257.31d0, 299.43d0/)
  real(kind=8), parameter :: decp(m_body) = (/0.d0, 0.d0, 61.41d0, 67.16d0, 52.88d0, &
                                            64.50d0,83.54d0,-15.18d0, 42.95d0/)
  ! origin of time                                          
  real(kind=8), parameter :: jzero=2449352.4993381481d0 ! 1994 January 0, 0h tdt.
  !Argument of prime meridian (Ast. Almanac 1994 (page E87)) -
  ! Go along with jzero defined above
  real(kind=8), parameter :: w0(m_body) = (/0d0, 0d0, 191.04d0, 168.12d0, 166.20d0, &
                                            354.77d0,53.27d0,277.31d0, 147.30d0/)
                                            
  real(kind=8), parameter :: wp(m_body) = (/0d0, 0d0, 6.1385025d0, -1.4813675d0, 350.8919830d0, &
                                          870.536d0,810.7939024d0, -501.1600928d0, 536.3128492d0/)
  !Variable for britghness temperature
  ! Comparison of results of the 2 methods decribed in IRAM report 2024-01
  integer(kind=4), parameter :: itmode_spidx=1 ! computation legacy method
  integer(kind=4), parameter :: itmode_file=2  ! tabulated model values
  character(len=5), parameter ::tmode_name(2) = (/'SPIDX','MODEL'/)
  integer(kind=4), parameter :: tmode_default(m_body) = (/itmode_spidx,itmode_spidx,itmode_spidx,itmode_spidx,itmode_spidx, &
                                                itmode_file,itmode_file,itmode_file,itmode_file/)
  integer(kind=4) :: tmode_variable(m_body)=tmode_default
  !Brightness temperatures @ 100GHz (3mm) - legacy method
  real(kind=8), parameter :: temp(m_body) = (/200.d0,5700.d0,450.d0,350.d0, &
                                          207.d0,170.d0,150.d0,132.d0,125.d0/) ! Avant Marten
                                    ! 207.D0,170.D0,150.D0,118.D0,119.D0/       ! D'apres A.Marten
  ! spectral index for T - legacy method
  real(kind=8), parameter :: etemp(m_body) = (/0.d0,0.d0,0.d0,-0.35d0, &
                                          0.d0,0.d0,0.d0,-0.35d0,-0.35d0/)  ! Avant Marten
  !                                       0.D0,0.D0,0.D0,-0.22D0,-0.20D0/        ! D'apres A.Marte
  ! Model files
  ! Files provided in 2017 by R. MORENO (LESIA - OBS PARIS)
  character(len=filename_length), parameter :: tmodel_file(m_body)=(/'NONE               ','NONE               ',   &
                                                                     'NONE               ','NONE               ',  &
                                                                     'NONE               ', &            
                                                         'jup_esa2_2_i_1000  ','sat_esa2_2_i_1000  ', &
                                                         'ura_esa2_2_i_h_1000','nep_esa5_2_i_1000  '/)
  ! Number of lines max in the model (can be adpated later)
  integer(kind=8), parameter :: tmodel_mlines = 1024
  !vector (to compute positions, vsop, etc)
  integer(kind=4), parameter :: vector(m_body)=(/ ivect_moon, ivect_sun, ivect_pla, ivect_pla, &
                                         ivect_pla, ivect_pla, ivect_pla, ivect_pla, ivect_pla/)
  ! Variables
  type :: planet_spec_t
    ! planet spectra read from files
    logical :: reading_done=.false.
    integer(kind=8) :: n_freq
    real(kind=8), allocatable :: freq(:)
    real(kind=8), allocatable :: tb(:)
  end type planet_spec_t
  !
  type(planet_spec_t) :: planet_model(m_body)
  !
end module ast_planets
!
module ast_astro
      use gildas_def
      use ast_params
      !
      logical :: library_mode  ! Astro loaded in Library or Interactive mode?
      !
! astro.inc
      real(kind=8) :: jnow_utc              ! date julienne utc
      real(kind=8) :: jnow_ut1              ! date julienne ut1
      real(kind=8) :: jnow_tdt              ! date julienne tdt
      real(kind=8) :: d_ut1                 ! ut1 - utc (seconds)
      real(kind=8) :: d_tdt                 ! tdt - utc (seconds)
      real(kind=8) :: lst                   ! local "true" sidereal time
      real(kind=8) :: lonlat(2)             ! e-longitude, latitude in degrees
      real(kind=8) :: altitude              ! altitude in kilometers
      real(kind=8) :: xsun_0(3)             ! earth_sun vector, in r0 , in km
      real(kind=8) :: xsun_2(3)             ! sun az-el at current time
      real(kind=8) :: xg_0(3)               ! earth_g vector, in r0 , in km
      real(kind=8) :: vg_0(3)               ! earth_g vector derivative, in r0 , in km/s
      real(kind=8) :: trfm_30(9)            ! matrix r0 to r3
      real(kind=8) :: trfm_20(9)            ! matrix r0 to r2
      real(kind=8) :: trfm_23(9)            ! matrix r3 to r2
      real(kind=8) :: trfm_43(9)            ! matrix r3 to r4
      real(kind=8) :: trfm_05(9)            ! matrix r5 (day ecliptic) to r0 (j2000 ecliptic)
      real(kind=8) :: s_1(2)                ! source reference coords.
      real(kind=8) :: azimuth, elevation    ! horizontal coords
      real(kind=8) :: ra, dec               ! present_day equatorial coords
      real(kind=8) :: parallactic_angle     ! parallactic angle
      real(kind=8) :: azimuth_old, elevation_old  ! horizontal coords
      real(kind=8) :: ra_old, dec_old       ! present_day equatorial coords
      real(kind=8) :: slimit                ! sun avoidance radius
      real(kind=8) :: fshift                ! frequency ratio due to doppler effect
      real(kind=8) :: freq                  ! frequency (rest) in ghz
      real(kind=8) :: primbeam              ! telescope primary beam width in radian (value used in computations)
      real(kind=4) :: z_axis
      logical :: projection
      integer(kind=4) :: name_out
      character(len=sourcename_length) :: source_name
      ! Possible values for sourcetype
      integer(kind=4), parameter :: msoukind=4
      integer(kind=4), parameter :: soukind_none=1      ! no source defined
      integer(kind=4), parameter :: soukind_full=2      ! source defined, full computations
      integer(kind=4), parameter :: soukind_vlsr=3      ! use only LSR
      integer(kind=4), parameter :: soukind_red=4      ! use only Redshift
      character(len=12), parameter ::soukinds(msoukind)= (/ 'NO SOURCE   ','ASTRO SOURCE', &
                                                            'LSR         ','REDSHIFT    ' /)
      integer(kind=4) :: soukind=soukind_none
!
! Support for ASTRO%SOURCE% variable
      character(len=60) :: source_alpha, source_delta
      real(kind=8):: source_az, source_el, source_ha
      real(kind=8):: source_ra, source_dec, source_sun_dist
      real(kind=8) :: source_jutc
      character(len=sourcename_length) :: astro_source_name, source_date_chain
      real(kind=8) :: source_vlsr, source_dop, source_vshift, source_lsr
      real(kind=8) :: source_redshift
      real(kind=4) :: source_flux(2)
! Support for ASTRO%SOURCE%IN variable
      character(len=2)  :: source_incoord
      character(len=2)  :: source_invtype
      character(len=14) :: source_inbetasexa,source_inlambdasexa
      real(kind=4)      :: source_ineq
      real(kind=8)      :: source_invelocity,source_inredshift     
! To save the current astro source      
      type :: astro_source_mem
        integer(kind=4)   :: soukind
        character(len=sourcename_length) :: name
        character(len=2)  :: coord
        real(kind=4)   :: equinox
        real(kind=8)      :: lambda  ! radians
        real(kind=8)      :: beta  ! radians
        character(len=2)  :: vtype
        real(kind=8) :: velocity
        real(kind=8) :: redshift
        real(kind=4) :: flux
        real(kind=4) :: spindex
      end type astro_source_mem

!       Planet stuff
      real(kind=4) :: planet_tmb            ! planet main beam brightness
      real(kind=4) :: planet_flux           ! planet flux
      real(kind=4) :: planet_size(3)        ! planet size
!
      character(len=2) :: z_axis_type
      character(len=12) :: frame           ! 'horizontal','equatorial' display
      character(len=filename_length) :: catalog_name(2) ! for sources
      character(len=1) :: azref
!       character(len=2) :: vtype           ! velocity system ('ls', 'ea', 'he','re')
      character(len=16) :: obsname         ! observatory name
!
! For OMS interaction
      character(len=16) :: oms_caller="NULL"  ! oms or pms or sms or dms...
      logical :: oms_bugw20=.false.   ! to let ASTRO know we are dealing with the special semester w20
! For plots
      integer(kind=4) :: msplot, nsplot
      parameter (msplot=2000)
      real(kind=8) :: xsplot(msplot), ysplot(msplot), zsplot(msplot)
      character(len=sourcename_length) :: splot(msplot)
      character(len=filename_length) :: ccplot(msplot)
      ! For UV tracks
      integer(kind=4), parameter :: msize=20  ! max number of differnt sizes for an observatory
      integer(kind=4), parameter :: msta=300  ! max number of selected stations
      !
      type :: uv_track_in_t
        ! Describe input of uvtrack command
        logical :: three_digit_name_compatible
        logical :: do_frame,do_hour,do_table,do_ho,do_int,do_stations,do_size,do_offset,do_weight
        logical :: do_all
        real(kind=4) :: in_h1,in_h2 !  /HOUR_ANGLE option user input
        real(kind=4) :: h1,h2 ! /HOUR_ANGLE option actually used value
        real(kind=4) :: horizon !  /HOUR_ANGLE option
        real(kind=4) :: integ_time ! /INT option
        real(kind=4) :: user_array ! if argument of /FRAME option
        ! For / WEight
        integer(kind=4) :: wkey
        ! For /SIZE
        integer(kind=4) :: nsize
        real(kind=4) :: sizes(msize)      ! size
        integer(kind=4) :: nant_size(msize)  ! number of antennas of this size
        real(kind=4) :: offset            ! option /OFFSET (delay line)
        ! For the stations
      end type uv_track_in_t
      !
      type:: uv_track_station_t
        character(len=12) :: name
        real(kind=4) :: x,y,z ! station coordinates
        real(kind=4) :: t ! alma case
        real(kind=4) :: asize ! antenna size
        logical :: found
      end type uv_track_station_t
      !
      type :: uv_track_angles_t
        real(kind=4) :: sd ! sine of declination
        real(kind=4) :: cd ! cosine of dec
        real(kind=4) :: sp ! sine of lat
        real(kind=4) :: cp ! cosine of lat
        real(kind=4) :: zsh ! depends on h
        real(kind=4) :: zch ! depends on h
      end type uv_track_angles_t
      !
      type :: uv_track_t
        type(uv_track_in_t) :: in
        type(uv_track_angles_t) :: ang
        integer(kind=4)   :: n_stations
        type(uv_track_station_t) :: stations(msta)
      end type uv_track_t
      !
  !
end module ast_astro
!
module atm_params
  !---------------------------------------------------------------------
  ! ATM input and output parameters.
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !---------------------------------------------------------------------
  real(kind=4), save :: t0,p0,p1,h0,water,airmass
  real(kind=4), save :: freqs,freqi,feff,trec,gim,tsys,tant
  real(kind=4), save :: tauox,tauw,taut,temis,temii,paths,pathi,tatms,tatmi
  logical, save :: atm_initdone=.false.
  !
  ! Noise information
  real(kind=4) :: bandwidth
  real(kind=4) :: jy_per_k
  real(kind=4) :: inttime
  real(kind=4) :: uvweight
end module atm_params

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeheader_edit_tool
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubeheader_messaging
  use cubetools_header_array_types
  use cubetools_spatial_types
  use cubetools_spectral_prog_types
  use cubetools_spectral_frame_types
  use cubetools_spectral_line_types
  use cubetools_spectral_f_or_w_types
  use cubetools_spectral_v_or_z_types
  use cubetools_axset_types
  use cubetools_noise_types
  use cubetools_observatory_types
  !
  public :: edit_comm_t,edit_user_t
  private
  !
  type :: edit_comm_t
     type(spatial_source_opt_t)     :: source        
     type(spafra_opt_t)             :: spafra  
     type(spapro_type_opt_t)        :: ptype
     type(spapro_center_opt_t)      :: pcenter
     type(spapro_angle_opt_t)       :: pangle
     type(beam_opt_t)               :: beam          
     type(option_t),      pointer   :: unit          
     type(noise_opt_t)              :: noise
     type(option_t),      pointer   :: axis
     type(keywordlist_comm_t), pointer :: ax_kind
     type(observatory_opt_t)        :: obs
     type(spectral_line_comm_t)     :: line
     type(spectral_f_or_w_comm_t)   :: f_or_w
     type(spectral_v_or_z_comm_t)   :: v_or_z
     type(spectral_frame_comm_t)    :: spefra
     type(option_t),      pointer   :: axnames
   contains
     procedure, public :: register => cubeheader_edit_register
     procedure, public :: parse    => cubeheader_edit_parse
     procedure, public :: main     => cubeheader_edit_main
  end type edit_comm_t
  !
  type edit_user_t
     type(spatial_source_user_t)    :: source
     type(spafra_user_t)            :: spafra
     type(spapro_type_user_t)       :: ptype
     type(spapro_center_user_t)     :: pcenter
     type(spapro_angle_user_t)      :: pangle
     type(beam_user_t)              :: beam
     type(axset_axis_user_t)        :: axis
     type(array_unit_user_t)        :: unit
     type(noise_user_t)             :: noise
     type(axset_axnames_user_t)     :: axnames
     type(observatory_user_t)       :: obs
     type(spectral_line_user_t)     :: line
     type(spectral_f_or_w_user_t)   :: f_or_w
     type(spectral_v_or_z_user_t)   :: v_or_z
     type(spectral_frame_user_t)    :: spefra
  end type edit_user_t
  !
contains
  !
  subroutine cubeheader_edit_register(comm,error)
    !----------------------------------------------------------------------
    ! Register keys related to header edition
    !----------------------------------------------------------------------
    class(edit_comm_t), intent(inout) :: comm
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='PUT>HEADER>REGISTER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call comm%source%register(&
         'Put a new source name',&
         error)
    if (error) return
    !
    call comm%spafra%register(&
         'Put new Spatial frame information',&
         error)
    if (error) return
    !
    call comm%ptype%register(&
         'PTYPE',&
         'Put a new projection type',&
         error)
    if (error) return
    call comm%pcenter%register(&
         'PCENTER',&
         'Put a new projection center',&
         error)
    if (error) return
    call comm%pangle%register(&
         'PANGLE',&
         'Put a new projection angle',&
         error)
    if (error) return
    !
    call comm%beam%register(&
         'Put a new beam',&
         error)
    if (error) return
    !
    !----------------------------------------------------------------------
    !
    call cubetools_array_unit_register(&
         'UNIT',&
         'Put a new unit for the cube',&
         comm%unit,error)
    if (error) return
    !
    call comm%noise%register(&
         'Put new noise values',&
         error)
    if (error) return
    !
    call cubetools_axset_axis_register(&
         'AXIS',&
         'Put a new axis description for one of the current axes',&
         comm%axis,comm%ax_kind,error)
    if (error) return
    !
    call cubetools_axset_axnames_register(&
         'AXNAMES',&
         'Put new names on cube''s axes',&
         comm%axnames,error)
    if (error) return
    !
    !----------------------------------------------------------------------
    !
    call comm%obs%register(&
         'Put new observatory information',&
         error)
    if (error) return
    !
    !----------------------------------------------------------------------
    !
    call comm%line%register(&
         'Put a new line name',&
         error)
    if (error) return
    !
    call comm%f_or_w%register(error)
    if (error) return
    call comm%v_or_z%register(error)
    if (error) return
    !
    call comm%spefra%register(&
         'Put new spectral frame information',&
         error)
    if (error) return
  end subroutine cubeheader_edit_register
  !
  subroutine cubeheader_edit_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    ! Parse routine for header part of command PUT
    !-------------------------------------------------------------------
    class(edit_comm_t), intent(in)    :: comm
    character(len=*),   intent(in)    :: line
    type(edit_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='PUT>HEADER>PARSE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call comm%source%parse(line,user%source,error)
    if (error) return
    call comm%spafra%parse(line,user%spafra,error)
    if (error) return
    call comm%ptype%parse(line,user%ptype,error)
    if (error) return
    call comm%pcenter%parse(line,user%pcenter,error)
    if (error) return
    call comm%pangle%parse(line,user%pangle,error)
    if (error) return
    call comm%beam%parse(line,user%beam,error)
    if (error) return
    !
    call cubetools_array_unit_parse(line,comm%unit,user%unit,error)
    if (error) return
    call comm%noise%parse(line,user%noise,error)
    if (error) return
    call cubetools_axset_axis_parse(line,comm%axis,user%axis,error)
    if (error) return
    call cubetools_axset_axnames_parse(line,comm%axnames,user%axnames,error)
    if (error) return
    !
    call comm%obs%parse(line,user%obs,error)
    if (error) return
    !
    call comm%line%parse(line,user%line,error)
    if (error) return
    call comm%f_or_w%parse(line,user%f_or_w,error)
    if (error) return
    call comm%v_or_z%parse(line,user%v_or_z,error)
    if (error) return
    call comm%spefra%parse(line,user%spefra,error)
    if (error) return
  end subroutine cubeheader_edit_parse
  !
  subroutine cubeheader_edit_main(comm,user,head,error)
    use cubetools_header_interface !***JP: Ugly patch. Do not reuse elsewhere!
    use cubetools_header_types     !***JP: Ugly patch. Do not reuse elsewhere!
    !-------------------------------------------------------------------
    ! Main routine for header part of command PUT
    !-------------------------------------------------------------------
    class(edit_comm_t),  intent(in)    :: comm
    type(edit_user_t),   intent(in)    :: user
    type(cube_header_t), intent(inout) :: head
    logical,             intent(inout) :: error
    !
    type(cube_header_interface_t) :: headinter
    character(len=*), parameter :: rname='PUT>HEADER>MAIN'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call comm%source%user2prog(user%source,head%spa%source,error)
    if (error) return
    call comm%spafra%user2prog(user%spafra,head%spa%fra,error)
    if (error) return
    call comm%ptype%user2prog(user%ptype,head%spa%pro,error)
    if (error) return
    call comm%pcenter%user2prog(head%spa%fra,user%pcenter,head%spa%pro,error)
    if (error) return
    call comm%pangle%user2prog(user%pangle,head%spa%pro,error)
    if (error) return
    call comm%beam%user2prog(user%beam,head%spa%bea,error)
    if (error) return
    !
    call cubetools_array_unit_user2prog(user%unit,head%arr%unit,error)
    if (error) return
    call comm%noise%user2prog(user%noise,head%arr%noi,error)
    if (error) return
    call cubetools_axset_axis_user2prog(user%axis,head%set,error)
    if (error) return
    call cubetools_axset_axnames_user2prog(user%axnames,head%set,error)
    if (error) return
    !
    call comm%obs%user2prog(user%obs,head%obs,error)
    if (error) return
    !
    call user%line%toprog(head%spe,error)
    if (error) return
    !***JP: Ugly patch. Do not reuse elsewhere!
    call cubetools_header_export(head,headinter,error)
    if (error) return
    call user%f_or_w%toprog(headinter,error)
    if (error) return
    call user%v_or_z%toprog(comm%v_or_z,headinter,error)
    if (error) return
    call cubetools_header_import_and_derive(headinter,head,error)
    if (error) return
    !***JP: Ugly patch. Do not reuse elsewhere!
    call user%spefra%toprog(comm%spefra,head%spe,error)
    if (error) return
  end subroutine cubeheader_edit_main
end module cubeheader_edit_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine fits_get_header_card_i4(fits,iname,i4,found,error,target)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_get_header_card_i4
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_card
  !  Translate a card to its associated value
  ! ---
  !  I*4 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  integer(kind=4),            intent(inout) :: i4      ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=80) :: string
  integer(kind=4) :: ier
  !
  call fits_get_header_key2val(fits%head,iname,string,found)
  !
  if (present(target)) then
    call fits_warn_missing_i4(fits%warn,'Card',iname,target,i4,found,error)
    if (error)  return
  endif
  !
  if (.not.found)  return
  !
  read(string,'(I20)',iostat=ier)  i4
  if (ier.ne.0) then
    call class_message(seve%e,rname,  &
      'Error decoding meta keyword '//trim(iname)//' = "'//trim(string)//'"')
    call putios('E-FITS,  ',ier)
    error = .true.
  endif
  !
end subroutine fits_get_header_card_i4
!
subroutine fits_get_header_card_i8(fits,iname,i8,found,error,target)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_get_header_card_i8
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_card
  !  Translate a card to its associated value
  ! ---
  !  I*8 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  integer(kind=8),            intent(inout) :: i8      ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=80) :: string
  integer(kind=4) :: ier
  !
  call fits_get_header_key2val(fits%head,iname,string,found)
  !
  if (present(target)) then
    call fits_warn_missing_i8(fits%warn,'Card',iname,target,i8,found,error)
    if (error)  return
  endif
  !
  if (.not.found)  return
  !
  read(string,'(I20)',iostat=ier)  i8
  if (ier.ne.0) then
    call class_message(seve%e,rname,  &
      'Error decoding meta keyword '//trim(iname)//' = "'//trim(string)//'"')
    call putios('E-FITS,  ',ier)
    error = .true.
  endif
  !
end subroutine fits_get_header_card_i8
!
subroutine fits_get_header_card_r4(fits,iname,r4,found,error,target)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_get_header_card_r4
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_card
  !  Translate a card to its associated value
  ! ---
  !  R*4 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  real(kind=4),               intent(inout) :: r4      ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=80) :: string
  integer(kind=4) :: ier
  !
  call fits_get_header_key2val(fits%head,iname,string,found)
  !
  if (present(target)) then
    call fits_warn_missing_r4(fits%warn,'Card',iname,target,r4,found,error)
    if (error)  return
  endif
  !
  if (.not.found)  return
  !
  read(string,*,iostat=ier)  r4
  if (ier.ne.0) then
    call class_message(seve%e,rname,  &
      'Error decoding meta keyword '//trim(iname)//' = "'//trim(string)//'"')
    call putios('E-FITS,  ',ier)
    error = .true.
  endif
  !
end subroutine fits_get_header_card_r4
!
subroutine fits_get_header_card_r8(fits,iname,r8,found,error,target)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_get_header_card_r8
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_card
  !  Translate a card to its associated value
  ! ---
  !  R*8 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  real(kind=8),               intent(inout) :: r8      ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=80) :: string
  integer(kind=4) :: ier
  !
  call fits_get_header_key2val(fits%head,iname,string,found)
  !
  if (present(target)) then
    call fits_warn_missing_r8(fits%warn,'Card',iname,target,r8,found,error)
    if (error)  return
  endif
  !
  if (.not.found)  return
  !
  read(string,*,iostat=ier)  r8
  if (ier.ne.0) then
    call class_message(seve%e,rname,  &
      'Error decoding meta keyword '//trim(iname)//' = "'//trim(string)//'"')
    call putios('E-FITS,  ',ier)
    error = .true.
  endif
  !
end subroutine fits_get_header_card_r8
!
subroutine fits_get_header_card_l(fits,iname,l,found,error,target)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_get_header_card_l
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_card
  !  Translate a card to its associated value
  ! ---
  !  Logical version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  logical,                    intent(inout) :: l       ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=80) :: string
  integer(kind=4) :: ier
  !
  call fits_get_header_key2val(fits%head,iname,string,found)
  if (.not.found)  return
  !
  read(string,*,iostat=ier)  l
  if (ier.ne.0) then
    call class_message(seve%e,rname,  &
      'Error decoding meta keyword '//trim(iname)//' = "'//trim(string)//'"')
    call putios('E-FITS,  ',ier)
    error = .true.
  endif
  !
end subroutine fits_get_header_card_l
!
subroutine fits_get_header_card_cc(fits,iname,value,found,error,target)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fits_get_header_card_cc
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_card
  !  Translate a card to its associated value
  ! ---
  !  Character*(*) version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  character(len=*),           intent(inout) :: value   ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=80) :: string
  !
  call fits_get_header_key2val(fits%head,iname,string,found)
  !
  if (present(target)) then
    call fits_warn_missing_cc(fits%warn,'Card',iname,target,value,found,error)
    if (error)  return
  endif
  !
  if (.not.found)  return
  !
  value = gfits_unquote(string)
  !
end subroutine fits_get_header_card_cc
!
!-----------------------------------------------------------------------
!
subroutine fits_get_header_metacard_i4(fits,iname,i4,found,error,target)
  use classcore_interfaces, except_this=>fits_get_header_metacard_i4
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_metacard
  !  Translate meta-cards to their associated value, i.e. follow the
  ! indirection due to hierarch cards. For example:
  !  HIERARCH  key.META_20='bbtype'
  !  META_20 =                 6031 / [] Building Block Type
  ! The parsing here is probably very HIFI-specific
  ! ---
  !  I*4 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  integer(kind=4),            intent(inout) :: i4      ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=8) :: key
  !
  call fits_get_header_val2key(fits%head,iname,key,found)
  !
  if (found) &
    call fits_get_header_card_i4(fits,key,i4,found,error)
  !
  if (present(target)) then
    call fits_warn_missing_i4(fits%warn,'Metacard',iname,target,i4,found,error)
    if (error)  return
  endif
  !
end subroutine fits_get_header_metacard_i4
!
subroutine fits_get_header_metacard_i8(fits,iname,i8,found,error,target)
  use classcore_interfaces, except_this=>fits_get_header_metacard_i8
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_metacard
  !  Translate meta-cards to their associated value, i.e. follow the
  ! indirection due to hierarch cards. For example:
  !  HIERARCH  key.META_20='bbtype'
  !  META_20 =                 6031 / [] Building Block Type
  ! The parsing here is probably very HIFI-specific
  ! ---
  !  I*8 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  integer(kind=8),            intent(inout) :: i8      ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=8) :: key
  !
  call fits_get_header_val2key(fits%head,iname,key,found)
  !
  if (found) &
    call fits_get_header_card_i8(fits,key,i8,found,error)
  !
  if (present(target)) then
    call fits_warn_missing_i8(fits%warn,'Metacard',iname,target,i8,found,error)
    if (error)  return
  endif
  !
end subroutine fits_get_header_metacard_i8
!
subroutine fits_get_header_metacard_r4(fits,iname,r4,found,error,target)
  use classcore_interfaces, except_this=>fits_get_header_metacard_r4
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_metacard
  !  Translate meta-cards to their associated value, i.e. follow the
  ! indirection due to hierarch cards. For example:
  !  HIERARCH  key.META_20='bbtype'
  !  META_20 =                 6031 / [] Building Block Type
  ! The parsing here is probably very HIFI-specific
  ! ---
  !  R*4 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  real(kind=4),               intent(inout) :: r4      ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=8) :: key
  !
  call fits_get_header_val2key(fits%head,iname,key,found)
  !
  if (found) &
    call fits_get_header_card_r4(fits,key,r4,found,error)
  !
  if (present(target)) then
    call fits_warn_missing_r4(fits%warn,'Metacard',iname,target,r4,found,error)
    if (error)  return
  endif
  !
end subroutine fits_get_header_metacard_r4
!
subroutine fits_get_header_metacard_r8(fits,iname,r8,found,error,target)
  use classcore_interfaces, except_this=>fits_get_header_metacard_r8
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_metacard
  !  Translate meta-cards to their associated value, i.e. follow the
  ! indirection due to hierarch cards. For example:
  !  HIERARCH  key.META_20='bbtype'
  !  META_20 =                 6031 / [] Building Block Type
  ! The parsing here is probably very HIFI-specific
  ! ---
  !  R*8 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  real(kind=8),               intent(inout) :: r8      ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=8) :: key
  !
  call fits_get_header_val2key(fits%head,iname,key,found)
  !
  if (found) &
    call fits_get_header_card_r8(fits,key,r8,found,error)
  !
  if (present(target)) then
    call fits_warn_missing_r8(fits%warn,'Metacard',iname,target,r8,found,error)
    if (error)  return
  endif
  !
end subroutine fits_get_header_metacard_r8
!
subroutine fits_get_header_metacard_l(fits,iname,l,found,error,target)
  use classcore_interfaces, except_this=>fits_get_header_metacard_l
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_metacard
  !  Translate meta-cards to their associated value, i.e. follow the
  ! indirection due to hierarch cards. For example:
  !  HIERARCH  key.META_20='bbtype'
  !  META_20 =                 6031 / [] Building Block Type
  ! The parsing here is probably very HIFI-specific
  ! ---
  !  Logical version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  logical,                    intent(inout) :: l       ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=8) :: key
  !
  call fits_get_header_val2key(fits%head,iname,key,found)
  !
  if (found) &
    call fits_get_header_card_l(fits,key,l,found,error)
  !
end subroutine fits_get_header_metacard_l
!
subroutine fits_get_header_metacard_cc(fits,iname,value,found,error,target)
  use classcore_interfaces, except_this=>fits_get_header_metacard_cc
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_header_metacard
  !  Translate meta-cards to their associated value, i.e. follow the
  ! indirection due to hierarch cards. For example:
  !  HIERARCH  key.META_20='bbtype'
  !  META_20 =                 6031 / [] Building Block Type
  ! The parsing here is probably very HIFI-specific
  ! ---
  !  Character*(*) version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits    !
  character(len=*),           intent(in)    :: iname   ! Card name
  character(len=*),           intent(inout) :: value   ! inout: if not found, input is preserved
  logical,                    intent(out)   :: found   !
  logical,                    intent(inout) :: error   ! Logical error flag
  character(len=*), optional, intent(in)    :: target  ! Target name
  ! Local
  character(len=8) :: key
  !
  call fits_get_header_val2key(fits%head,iname,key,found)
  !
  if (found) &
    call fits_get_header_card_cc(fits,key,value,found,error)
  !
  if (present(target)) then
    call fits_warn_missing_cc(fits%warn,'Metacard',iname,target,value,found,error)
    if (error)  return
  endif
  !
end subroutine fits_get_header_metacard_cc
!
subroutine fits_get_header_val2key(head,val,key,found)
  use classcore_dependencies_interfaces
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find the key corresponding to input value. Key must start with
  ! "key." to avoid false positives. This prefix is stripped off on
  ! return. Search is case sensitive. For example
  !    HIERARCH  key.META_20='bbtype'
  ! returns "META_20".
  !---------------------------------------------------------------------
  type(classfits_header_t), intent(in)  :: head   ! Unit header
  character(len=*),         intent(in)  :: val    ! Desired value name
  character(len=*),         intent(out) :: key    ! Corresponding key name
  logical,                  intent(out) :: found  !
  ! Local
  integer(kind=4) :: icard
  !
  found = .false.
  key = ''
  !
  do icard=1,head%dict%ncard
    if (val.eq.gfits_unquote(head%dict%card(icard)%val)) then
      if (head%dict%card(icard)%key(1:4).eq.'key.') then
        key = head%dict%card(icard)%key(5:)
        found = .true.
        return
      endif
    endif
  enddo
  !
end subroutine fits_get_header_val2key
!
subroutine fits_get_header_key2val(head,key,val,found)
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find the (string) value corresponding to input key
  !---------------------------------------------------------------------
  type(classfits_header_t), intent(in)  :: head   ! Unit header
  character(len=*),         intent(in)  :: key    ! Key name
  character(len=*),         intent(out) :: val    ! Value found
  logical,                  intent(out) :: found  !
  ! Local
  integer(kind=4) :: icard
  !
  found = .false.
  val = ''
  !
  do icard=1,head%dict%ncard
    if (key.eq.head%dict%card(icard)%key) then
      val = head%dict%card(icard)%val
      found = .true.
      return
    endif
  enddo
  !
end subroutine fits_get_header_key2val
!
subroutine fits_get_bintable_key2column(cols,key,icol,found)
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private
  ! Find the column number whose TTYPE is 'key'
  ! Case-sensitive search
  !---------------------------------------------------------------------
  type(classfits_columns_t), intent(in)  :: cols   ! Columns description
  character(len=*),          intent(in)  :: key    ! Key name
  integer(kind=4),           intent(out) :: icol   ! Column number, if found
  logical,                   intent(out) :: found  !
  ! Local
  integer(kind=4) :: jcol
  !
  found = .false.
  icol = 0
  !
  do jcol=1,cols%desc%ncols
    if (cols%desc%ttype(jcol).eq.key) then
      icol = jcol
      found = .true.
      return
    endif
  enddo
  !
end subroutine fits_get_bintable_key2column
!
!-----------------------------------------------------------------------
!
subroutine fits_get_metacard_or_column_i4(fits,buffer,name,i4,found,error,target)
  use gbl_format
  use classcore_interfaces, except_this=>fits_get_metacard_or_column_i4
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_metacard_or_column
  !  If buffer(:) is zero-sized, read the metacard 'name' from the
  ! FITS header
  !  If not, read the single-valued column 'name' from the bintable
  !  NB: zero-sized arrays are legitimate objects in Fortran
  ! ---
  !  I*4 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits       !
  integer(kind=1),            intent(in)    :: buffer(:)  !
  character(len=*),           intent(in)    :: name       ! Element name (case-sensitive)
  integer(kind=4),            intent(inout) :: i4         ! Previous value preserved if not found
  logical,                    intent(out)   :: found      !
  logical,                    intent(inout) :: error      !
  character(len=*), optional, intent(in)    :: target     ! Target name
  ! Local
  character(len=8) :: ftype
  integer(kind=4) :: icol
  !
  if (size(buffer).eq.0) then
    ! Get a metacard value
    ftype = 'Metacard'
    call fits_get_header_metacard(fits,name,i4,found,error)
    if (error)  return
  else
    ! Get a column single value
    ftype = 'Column'
    call fits_get_bintable_key2column(fits%cols,name,icol,found)
    if (found) then
      call get_item(i4,1,fmt_i4,buffer(fits%cols%desc%addr(icol)),  &
          fits%cols%desc%fmt(icol),error)
      if (error)  return
    endif
  endif
  !
  if (present(target)) then
    call fits_warn_missing_i4(fits%warn,ftype,name,target,i4,found,error)
    if (error)  return
  endif
  !
end subroutine fits_get_metacard_or_column_i4
!
subroutine fits_get_metacard_or_column_r4(fits,buffer,name,r4,found,error,target)
  use gbl_format
  use classcore_interfaces, except_this=>fits_get_metacard_or_column_r4
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_metacard_or_column
  !  If buffer(:) is zero-sized, read the metacard 'name' from the
  ! FITS header
  !  If not, read the single-valued column 'name' from the bintable
  !  NB: zero-sized arrays are legitimate objects in Fortran
  ! ---
  !  R*4 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits       !
  integer(kind=1),            intent(in)    :: buffer(:)  !
  character(len=*),           intent(in)    :: name       ! Element name (case-sensitive)
  real(kind=4),               intent(inout) :: r4         ! Target value (preserved if not found)
  logical,                    intent(out)   :: found      !
  logical,                    intent(inout) :: error      !
  character(len=*), optional, intent(in)    :: target     ! Target name
  ! Local
  character(len=8) :: ftype
  integer(kind=4) :: icol
  !
  if (size(buffer).eq.0) then
    ! Get a metacard value
    ftype = 'Metacard'
    call fits_get_header_metacard(fits,name,r4,found,error)
    if (error)  return
  else
    ! Get a column single value
    ftype = 'Column'
    call fits_get_bintable_key2column(fits%cols,name,icol,found)
    if (found) then
      call get_item(r4,1,fmt_r4,buffer(fits%cols%desc%addr(icol)),  &
          fits%cols%desc%fmt(icol),error)
      if (error)  return
    endif
  endif
  !
  if (present(target)) then
    call fits_warn_missing_r4(fits%warn,ftype,name,target,r4,found,error)
    if (error)  return
  endif
  !
end subroutine fits_get_metacard_or_column_r4
!
subroutine fits_get_metacard_or_column_r8(fits,buffer,name,r8,found,error,target)
  use gbl_format
  use classcore_interfaces, except_this=>fits_get_metacard_or_column_r8
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_get_metacard_or_column
  !  If buffer(:) is zero-sized, read the metacard 'name' from the
  ! FITS header
  !  If not, read the single-valued column 'name' from the bintable
  !  NB: zero-sized arrays are legitimate objects in Fortran
  ! ---
  !  Scalar R*8 version
  !---------------------------------------------------------------------
  type(classfits_t),          intent(inout) :: fits       !
  integer(kind=1),            intent(in)    :: buffer(:)  !
  character(len=*),           intent(in)    :: name       ! Element name (case-sensitive)
  real(kind=8),               intent(inout) :: r8         ! Previous value preserved if not found
  logical,                    intent(out)   :: found      !
  logical,                    intent(inout) :: error      !
  character(len=*), optional, intent(in)    :: target     ! Target name
  ! Local
  character(len=8) :: ftype
  integer(kind=4) :: icol
  !
  if (size(buffer).eq.0) then
    ! Get a metacard value
    ftype = 'Metacard'
    call fits_get_header_metacard(fits,name,r8,found,error)
    if (error)  return
  else
    ! Get a column single value
    ftype = 'Column'
    call fits_get_bintable_key2column(fits%cols,name,icol,found)
    if (found) then
      call get_item(r8,1,fmt_r8,buffer(fits%cols%desc%addr(icol)),  &
          fits%cols%desc%fmt(icol),error)
      if (error)  return
    endif
  endif
  !
  if (present(target)) then
    call fits_warn_missing_r8(fits%warn,ftype,name,target,r8,found,error)
    if (error)  return
  endif
  !
end subroutine fits_get_metacard_or_column_r8
!
!-----------------------------------------------------------------------
!
subroutine fits_warn_missing_i4(warn,ftype,fname,tname,tvalue,found,error)
  use gbl_message
  use classcore_interfaces, except_this=>fits_warn_missing_i4
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_warn_missing
  !  If not found, add a warning to the warning list
  ! ---
  !  I*4 version
  !---------------------------------------------------------------------
  type(classfits_warnings_t), intent(inout) :: warn    !
  character(len=*),           intent(in)    :: ftype   ! FITS element type
  character(len=*),           intent(in)    :: fname   ! FITS element name
  character(len=*),           intent(in)    :: tname   ! Target name
  integer(kind=4),            intent(in)    :: tvalue  ! Target value
  logical,                    intent(in)    :: found   ! Was it found or not?
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=message_length) :: mess
  !
  if (found)  return
  !
  write(mess,'(A,1X,4A,I0)')  trim(ftype),trim(fname),' not found, ',  &
    trim(tname),' defaults to ',tvalue
  !
  call fits_warning_add(warn,mess,error)
  if (error)  return
  !
end subroutine fits_warn_missing_i4
!
subroutine fits_warn_missing_i8(warn,ftype,fname,tname,tvalue,found,error)
  use gbl_message
  use classcore_interfaces, except_this=>fits_warn_missing_i8
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_warn_missing
  !  If not found, add a warning to the warning list
  ! ---
  !  I*8 version
  !---------------------------------------------------------------------
  type(classfits_warnings_t), intent(inout) :: warn    !
  character(len=*),           intent(in)    :: ftype   ! FITS element type
  character(len=*),           intent(in)    :: fname   ! FITS element name
  character(len=*),           intent(in)    :: tname   ! Target name
  integer(kind=8),            intent(in)    :: tvalue  ! Target value
  logical,                    intent(in)    :: found   ! Was it found or not?
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=message_length) :: mess
  !
  if (found)  return
  !
  write(mess,'(A,1X,4A,I0)')  trim(ftype),trim(fname),' not found, ',  &
    trim(tname),' defaults to ',tvalue
  !
  call fits_warning_add(warn,mess,error)
  if (error)  return
  !
end subroutine fits_warn_missing_i8
!
subroutine fits_warn_missing_r4(warn,ftype,fname,tname,tvalue,found,error)
  use gbl_message
  use classcore_interfaces, except_this=>fits_warn_missing_r4
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_warn_missing
  !  If not found, add a warning to the warning list
  ! ---
  !  R*4 version
  !---------------------------------------------------------------------
  type(classfits_warnings_t), intent(inout) :: warn    !
  character(len=*),           intent(in)    :: ftype   ! FITS element type
  character(len=*),           intent(in)    :: fname   ! FITS element name
  character(len=*),           intent(in)    :: tname   ! Target name
  real(kind=4),               intent(in)    :: tvalue  ! Target value
  logical,                    intent(in)    :: found   ! Was it found or not?
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=message_length) :: mess
  !
  if (found)  return
  !
  write(mess,'(A,1X,4A,F0.1)')  trim(ftype),trim(fname),' not found, ',  &
    trim(tname),' defaults to ',tvalue
  !
  call fits_warning_add(warn,mess,error)
  if (error)  return
  !
end subroutine fits_warn_missing_r4
!
subroutine fits_warn_missing_r8(warn,ftype,fname,tname,tvalue,found,error)
  use gbl_message
  use classcore_interfaces, except_this=>fits_warn_missing_r8
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_warn_missing
  !  If not found, add a warning to the warning list
  ! ---
  !  R*8 version
  !---------------------------------------------------------------------
  type(classfits_warnings_t), intent(inout) :: warn    !
  character(len=*),           intent(in)    :: ftype   ! FITS element type
  character(len=*),           intent(in)    :: fname   ! FITS element name
  character(len=*),           intent(in)    :: tname   ! Target name
  real(kind=8),               intent(in)    :: tvalue  ! Target value
  logical,                    intent(in)    :: found   ! Was it found or not?
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=message_length) :: mess
  !
  if (found)  return
  !
  write(mess,'(A,1X,4A,F0.1)')  trim(ftype),trim(fname),' not found, ',  &
    trim(tname),' defaults to ',tvalue
  !
  call fits_warning_add(warn,mess,error)
  if (error)  return
  !
end subroutine fits_warn_missing_r8
!
subroutine fits_warn_missing_cc(warn,ftype,fname,tname,tvalue,found,error)
  use gbl_message
  use classcore_interfaces, except_this=>fits_warn_missing_cc
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private-generic fits_warn_missing
  !  If not found, add a warning to the warning list
  ! ---
  !  C*(*) version
  !---------------------------------------------------------------------
  type(classfits_warnings_t), intent(inout) :: warn    !
  character(len=*),           intent(in)    :: ftype   ! FITS element type
  character(len=*),           intent(in)    :: fname   ! FITS element name
  character(len=*),           intent(in)    :: tname   ! Target name
  character(len=*),           intent(in)    :: tvalue  ! Target value
  logical,                    intent(in)    :: found   ! Was it found or not?
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=message_length) :: mess
  !
  if (found)  return
  !
  if (tvalue.eq.'') then
    write(mess,'(A,1X,4A)')  trim(ftype),trim(fname),' not found, ',  &
      trim(tname),' defaults to blank string'
  else
    write(mess,'(A,1X,5A)')  trim(ftype),trim(fname),' not found, ',  &
      trim(tname),' defaults to ',tvalue
  endif
  !
  call fits_warning_add(warn,mess,error)
  if (error)  return
  !
end subroutine fits_warn_missing_cc
!
!-----------------------------------------------------------------------
!
subroutine fits_warning_add(warn,mess,error)
  use gbl_message
  use classcore_interfaces, except_this=>fits_warning_add
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Add a new warning to the warning list. Duplicates are not added
  !---------------------------------------------------------------------
  type(classfits_warnings_t), intent(inout) :: warn
  character(len=*),           intent(in)    :: mess
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FITS>WARNING'
  integer(kind=4) :: imess
  !
  ! Check if already present
  do imess=1,warn%n
    if (mess.eq.warn%mess(imess))  return
  enddo
  !
  ! A new one: check if we have room
  if (warn%n.ge.mwarning) then
    call class_message(seve%w,rname,'Warning buffer exhausted, message lost:')
    call class_message(seve%w,rname,mess)
    return
  endif
  !
  ! Add it
  warn%n = warn%n+1
  warn%mess(warn%n) = mess
  !
end subroutine fits_warning_add
!
subroutine fits_warning_dump(warn,error)
  use gbl_message
  use classcore_interfaces, except_this=>fits_warning_dump
  use classfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Displays the warnings in the structure input structure.
  !---------------------------------------------------------------------
  type(classfits_warnings_t), intent(inout) :: warn
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: imess
  !
  if (warn%n.le.0)  return
  !
  call class_message(seve%r,rname,'')  ! Blank line
  call class_message(seve%w,rname,'--- Warning summary (all extensions) ---')
  do imess=1,warn%n
    call class_message(seve%w,rname,warn%mess(imess))
  enddo
  !
end subroutine fits_warning_dump

program uv_template
  use gildas_def
  use gkernel_interfaces
  character(len=filename_length) :: cuvin, cuvou 
  integer :: nc(2)
  logical error
  !
  ! Code:
  call gildas_open
  call gildas_char('UV_INPUT$',cuvin)
  call gildas_char('UV_OUTPUT$',cuvou)
  !
  ! Other parameters
  ! call gildas_inte('NC$',nc,2)   ! Desired channel range for example
  call gildas_close
  !
  call sub_uv_template_whole (cuvin,cuvou,nc,error)
  if (error) call sysexi(fatale)
end program uv_template
!
subroutine sub_uv_template_block (cuvin, cuvou, nc, error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  !	A template for handling UV tables, with an Input and Output one
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cuvin 
  character(len=*), intent(in) :: cuvou 
  integer, intent(in) :: nc(2)
  logical, intent(out) :: error
  !
  ! Local variables
  character(len=*), parameter :: rname='UV_TEMPLATE'
  character(len=80)  :: mess
  type (gildas) :: uvin
  type (gildas) :: uvou
  integer :: ier, nblock, ib, nvisi
  !
  ! Simple checks 
  error = len_trim(cuvin).eq.0
  if (error) then
    call map_message(seve%e,rname,'No input UV table name')
    return
  endif
  !
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, cuvin, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  !
  ! Here modify the header of the output UV table according
  ! to the desired goal
  !
  call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_copy_header(uvin,uvou,error)
  call sic_parse_file(cuvou,' ','.uvt',uvou%file)
  !
  ! create the image
  call gdf_create_image(uvou,error)
  if (error) return
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...  
  call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvin%gil%dim(2))
  ! Allocate respective space for each file
  allocate (uvin%r2d(uvin%gil%dim(1),nblock), uvou%r2d(uvou%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',uvin%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Loop over line table - The example assumes the same
  ! number of visibilities in Input and Output, which may not
  ! be true...
  uvou%blc = 0
  uvou%trc = 0
  uvin%blc = 0
  uvin%trc = 0
  do ib = 1,uvou%gil%dim(2),nblock
    write(mess,*) ib,' / ',uvou%gil%dim(2),nblock
    call map_message(seve%d,rname,mess) 
    uvin%blc(2) = ib
    uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock) 
    uvou%blc(2) = ib
    uvou%trc(2) = uvin%trc(2)
    call gdf_read_data(uvin,uvin%r2d,error)
    nvisi = uvin%trc(2)-uvin%blc(2)+1
    !
    ! Here do the job
    !
    ! call myjob (uvou, uvou%r2d, uvin, uvin%r2d, nvisi) 
    !
    call gdf_write_data (uvou,uvou%r2d,error)
    if (error) return
  enddo
  !
  ! Finalize the image
  call gdf_close_image(uvin,error)
  call gdf_close_image(uvou,error)
  if (error) return
  !
  call map_message(seve%i,rname,'Successful completion')
  return
end subroutine sub_uv_template_block
!
! 
subroutine sub_uv_template_whole (cuvin, cuvou, nc, error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  !	A template for handling UV tables, with an Input and Output one
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cuvin 
  character(len=*), intent(in) :: cuvou 
  integer, intent(in) :: nc(2)
  logical, intent(out) :: error
  !
  ! Local variables
  character(len=*), parameter :: rname='UV_TEMPLATE'
  type (gildas) :: uvin
  type (gildas) :: uvou
  type (gildas) :: huv
  integer :: ier
  integer :: mv,nv,ncin,nadd, my_nc(2)
  !
  !
  ! Simple checks 
  error = len_trim(cuvin).eq.0
  if (error) then
    call map_message(seve%e,rname,'No input UV table name')
    return
  endif
  !
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, cuvin, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  !
  ! huv can be used as intermediate step to select a subset of all channels
  ! and specify the desired layout
  call gildas_null (huv, type = 'UVT') 
  call gdf_copy_header(uvin,huv,error)
  if (error) return
  !
  ! my_nc = nc
  my_nc = [1,uvin%gil%nchan]
  !
  ! Define number of visibilities and channels
  mv = huv%gil%dim(1)              ! Visibility size
  nv = huv%gil%nvisi               ! Number of visibilities
  ncin = huv%gil%nchan             ! Number of channels
  ! Number of additional columns, with default layout
  nadd = huv%gil%dim(1)-(huv%gil%nlead+huv%gil%natom*ncin) 
  !
  call gdf_copy_header(huv,uvou,error)
  !
  ! Here modify the header of the output UV table according
  ! to the desired goal
  !
  ! call my_header (uvou)
  !
  call sic_parse_file(cuvou,' ','.uvt',uvou%file)
  !
  allocate(huv%r2d(huv%gil%dim(1),huv%gil%dim(2)), &
       uvou%r2d(uvou%gil%dim(1),uvou%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error') 
    error = .true.
    return
  endif
  !
  ! read the Input UV data
  ! nc(2) are the first and last channels to read. 
  ! 0,0 means nothing at all, only ancillary information ?
  !
  call gdf_read_uvdataset(uvin,huv,nc,huv%r2d,error)
  if (error) return
  !
  ! Here do the job
  !
  ! call myjob (uvou, uvou%r2d, huv, huv%r2d) 
  !
  ! Write the output UV table, header & data at once
  call gdf_write_image(uvou,huv%r2d,error)
  if (error) return
  !
  call map_message(seve%i,rname,'Successful completion')
  return
end subroutine sub_uv_template_whole

module class_interfaces_public
  interface
    subroutine class_pack_set(pack)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      type(gpack_info_t), intent(out) :: pack
    end subroutine class_pack_set
  end interface
  !
  interface
    subroutine class_write_init(error)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !   Public procedure suited for programs linked basically to the
      ! libclass, i.e. with no Gildas specific features like interpreter or
      ! initializations or so. See demo program classdemo-telwrite.f90
      !   Perform the basic initializations of the libclass needed for
      ! the writing process (e.g. stand-alone program at the telescope).
      !   Should be done once at program startup.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine class_write_init
  end interface
  !
  interface
    subroutine class_write_clean(error)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !   Public procedure suited for programs linked basically to the
      ! libclass, i.e. with no Gildas specific features like interpreter or
      ! initializations or so. See demo program classdemo-telwrite.f90
      !   Perform the basic cleaning of the libclass needed after the
      ! writing process (e.g. stand-alone program at the telescope).
      !  Should be done once before leaving the program
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine class_write_clean
  end interface
  !
  interface
    subroutine class_fileout_open(spec,lnew,lover,lsize,lsingle,error)
      use classic_api
      use class_setup
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Public entry point to open a new or reopen an old output file.
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: spec     ! File name including extension
      logical,                    intent(in)    :: lnew     ! Should it be a new file or an old?
      logical,                    intent(in)    :: lover    ! If new, overwrite existing file or raise an error?
      integer(kind=entry_length), intent(in)    :: lsize    ! If new, maximum number of observations allowed
      logical,                    intent(in)    :: lsingle  ! If new, should spectra be unique?
      logical,                    intent(inout) :: error    ! Logical error flag
    end subroutine class_fileout_open
  end interface
  !
  interface
    subroutine class_fileout_close(error)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Close the output file without closing the input file if they are
      ! the same
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Error status
    end subroutine class_fileout_close
  end interface
  !
  interface
    subroutine class_obs_write(obs,error)
      use class_setup
      use class_types
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Write the observation to the currently opened output file
      !  See demo program classdemo-telwrite.f90
      !---------------------------------------------------------------------
      type(observation), intent(inout) :: obs    !
      logical,           intent(inout) :: error  ! Logical error flag
    end subroutine class_obs_write
  end interface
  !
  interface
    subroutine class_fold_obs(obs,keepblank,error)
      use class_setup
      use class_types
      !----------------------------------------------------------------------
      ! @ public (available to external programs)
      !   Fold an unfolded frequency switched observation.
      !  Each phase is assumed to be given a weight and a frequency change.
      !  The frequency change need not be an integer number of channels.
      !  The number of phases is not limited.
      !-----------------------------------------------------------------------
      type(observation), intent(inout) :: obs
      logical,           intent(in)    :: keepblank  ! Keep blank channels at boundaries?
      logical,           intent(inout) :: error
    end subroutine class_fold_obs
  end interface
  !
  interface
    subroutine class_modify_vdirection(head,error)
      use class_setup
      use class_types
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      ! Support routine for command:
      !  MODIFY VDIRECTION
      !---------------------------------------------------------------------
      type(header), intent(inout) :: head   !
      logical,      intent(inout) :: error  !
    end subroutine class_modify_vdirection
  end interface
  !
  interface
    subroutine class_resample_obs(obs,axis,dofft,error)
      use class_setup
      use class_types
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      ! Resample the observation
      !---------------------------------------------------------------------
      type(observation),   intent(inout) :: obs    ! Observation before and after resampling
      type(resampling),    intent(in)    :: axis   ! New definition of X-axis sampling
      logical,             intent(in)    :: dofft  ! In frequency or time domain (the default)
      logical,             intent(inout) :: error  ! Error flag
    end subroutine class_resample_obs
  end interface
  !
  interface
    subroutine class_user_owner(sowner,stitle)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%owner character variable
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: sowner  ! Section owner
      character(len=*), intent(in) :: stitle  ! Section title
    end subroutine class_user_owner
  end interface
  !
  interface
    subroutine class_user_toclass(usertoclass)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%toclass procedure to the input procedure
      !---------------------------------------------------------------------
      external usertoclass
    end subroutine class_user_toclass
  end interface
  !
  interface
    subroutine class_user_dump(userdump)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%dump procedure to the input procedure
      !---------------------------------------------------------------------
      external userdump
    end subroutine class_user_dump
  end interface
  !
  interface
    subroutine class_user_fix(userfix)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%fix procedure to the input procedure
      !---------------------------------------------------------------------
      external userfix
    end subroutine class_user_fix
  end interface
  !
  interface
    subroutine class_user_find(userfind)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%find procedure to the input procedure
      !---------------------------------------------------------------------
      external userfind
    end subroutine class_user_find
  end interface
  !
  interface
    subroutine class_user_setvar(usersetvar)
      use class_setup
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%setvar procedure to the input procedure
      !---------------------------------------------------------------------
      external usersetvar
    end subroutine class_user_setvar
  end interface
  !
  interface
    subroutine class_user_varidx_fill(uservaridx_fill)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%varidx_fill procedure to the input
      ! procedure
      !---------------------------------------------------------------------
      external uservaridx_fill
    end subroutine class_user_varidx_fill
  end interface
  !
  interface
    subroutine class_user_varidx_defvar(uservaridx_defvar)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%varidx_defvar procedure to the input
      ! procedure
      !---------------------------------------------------------------------
      external uservaridx_defvar
    end subroutine class_user_varidx_defvar
  end interface
  !
  interface
    subroutine class_user_varidx_realloc(uservaridx_realloc)
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Set the userhooks(cuserhooks)%varidx_realloc procedure to the input
      ! procedure
      !---------------------------------------------------------------------
      external uservaridx_realloc
    end subroutine class_user_varidx_realloc
  end interface
  !
  interface
    subroutine class_user_def_inte(suffix,ndim,dims,error)
      use class_rt
      use class_setup
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Define the Sic integer variable R%USER%OWNER%SUFFIX
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: suffix   ! Component name
      integer(kind=4),  intent(in)    :: ndim     ! Number of dimensions (0=scalar)
      integer(kind=4),  intent(in)    :: dims(4)  ! Dimensions (if needed)
      logical,          intent(inout) :: error    ! Logical error flag
    end subroutine class_user_def_inte
  end interface
  !
  interface
    subroutine class_user_def_real(suffix,ndim,dims,error)
      use class_rt
      use class_setup
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Define the Sic real variable R%USER%OWNER%SUFFIX
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: suffix   ! Component name
      integer(kind=4),  intent(in)    :: ndim     ! Number of dimensions (0=scalar)
      integer(kind=4),  intent(in)    :: dims(4)  ! Dimensions (if needed)
      logical,          intent(inout) :: error    ! Logical error flag
    end subroutine class_user_def_real
  end interface
  !
  interface
    subroutine class_user_def_dble(suffix,ndim,dims,error)
      use class_rt
      use class_setup
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Define the Sic double variable R%USER%OWNER%SUFFIX
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: suffix   ! Component name
      integer(kind=4),  intent(in)    :: ndim     ! Number of dimensions (0=scalar)
      integer(kind=4),  intent(in)    :: dims(4)  ! Dimensions (if needed)
      logical,          intent(inout) :: error    ! Logical error flag
    end subroutine class_user_def_dble
  end interface
  !
  interface
    subroutine class_user_def_char(suffix,lchain,error)
      use class_rt
      use class_setup
      !---------------------------------------------------------------------
      ! @ public (available to external programs)
      !  Define the Sic character variable R%USER%OWNER%SUFFIX
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: suffix   ! Component name
      integer(kind=4),  intent(in)    :: lchain   ! String length in the 'data' buffer
      logical,          intent(inout) :: error    ! Logical error flag
    end subroutine class_user_def_char
  end interface
  !
end module class_interfaces_public

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_key_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: key_comm_t,key_user_t,key_prog_t
  private
  !
  type :: key_comm_t
     type(option_t), pointer :: key
   contains
     procedure, public :: register => key_comm_register
     procedure, public :: parse    => key_comm_parse
  end type key_comm_t
  !
  type :: key_user_t
     logical :: present = .false.
   contains
     procedure, public :: toprog => key_user_toprog
  end type key_user_t
  !
  type :: key_prog_t
     logical :: act = .false.
  end type key_prog_t
  !
contains
  !
  subroutine key_comm_register(comm,name,abstract,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(key_comm_t), intent(inout) :: comm
    character(len=*),  intent(in)    :: name
    character(len=*),  intent(in)    :: abstract
    character(len=*),  intent(in)    :: help
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEY>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'',&
         abstract,help,&
         comm%key,error)
    if (error) return
  end subroutine key_comm_register
  !
  subroutine key_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(key_comm_t), intent(in)    :: comm
    character(len=*),  intent(in)    :: line
    type(key_user_t),  intent(inout) :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEY>COMM>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%present,error)
    if (error) return
  end subroutine key_comm_parse
  !
  !---------------------------------------------------------------------
  !
  subroutine key_user_toprog(user,comm,prog,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(key_user_t), intent(in)    :: user
    type(key_comm_t),  intent(in)    :: comm
    type(key_prog_t),  intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEY>USER>TOPROG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    prog%act = user%present
  end subroutine key_user_toprog
end module cubesyntax_key_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! TELCAL routines related to focus
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine fit_xy_polynomial(line,error)
  use telcal_interfaces, except_this=>fit_xy_polynomial
  use fit_definitions
  use gildas_def
  use gkernel_interfaces
  use gbl_format
  use gkernel_types
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for command:
  !     POLYNOM Degree Xvar Yvar Wvar
  ! Purpose: Computes the weighted least-square polynomial fit of a given
  !          degree
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Error flag
  ! Local
  type(simple_1d) :: dat
  type(fit_fun) :: fun
  type(sic_descriptor_t) :: xinca,yinca
  integer(kind=address_length) :: ipx,ipy
  integer memory(1)
  integer nc,ndeg,ixy,inx,iny,ier,i
  logical found
  character(16) :: string,var
  character(80) :: chain
  !
  ! 0. Initialization
  !
  error = .false.
  !
  ! 1. Data vector setup
  !
  ! Degree(mandatory)
  call sic_i4(line,0,1,ndeg,.true.,error)
  if(error) return
  ! Xvar(mandatory)
  call sic_ch(line,0,2,var,nc,.true.,error)
  if(error) return
  call sic_descriptor(var,xinca,found)
  if(.not.found) then
     chain = 'E-POLYNOM,  Unknown variable '//var
     call gagout(chain)
     error = .true.
     return
  endif
  if (xinca%type.eq.fmt_r8) then
     inx = xinca%size/2
  elseif (xinca%type.eq.fmt_r4) then
     inx = xinca%size
  endif
  !
  ! Yvar(mandatory)
  call sic_ch(line,0,3,var,nc,.true.,error)
  if(error) return
  call sic_descriptor(var,yinca,found)
  if(.not.found) then
     chain = 'E-POLYNOM,  Unknown variable '//var
     call gagout(chain)
     error = .true.
     return
  endif
  if (yinca%type.eq.fmt_r8) then
     iny = yinca%size/2
  elseif (yinca%type.eq.fmt_r4) then
     iny = yinca%size
  endif
  if(iny.ne.inx) then
     call gagout('E-POLYNOM, Arrays do not match')
     error = .true.
     return
  endif
  ixy = inx
  !
  dat%n = ixy
  allocate(dat%x(dat%n),dat%y(dat%n),stat=ier)
  if(ier.ne.0) then
     error = .true.
     return
  endif
  !
  ipx = gag_pointer(xinca%addr,memory)
  ipy = gag_pointer(yinca%addr,memory)
  if (xinca%type.eq.fmt_r8) then
     call r8tor8(memory(ipx), dat%x, ixy)
  else
     call r4tor8(memory(ipx), dat%x, ixy)
  endif
  if (yinca%type.eq.fmt_r8) then
     call r8tor8(memory(ipy), dat%y, ixy)
  else
     call r4tor8(memory(ipy), dat%y, ixy)
  endif
  !
  ! Wvar(optional)
  allocate(dat%w(dat%n),stat=ier)
  if(ier.ne.0) then
     error = .true.
     return
  endif
  if(sic_present(0,4)) then
     print *,'Using input weights'
     call sic_ch(line,0,4,var,nc,.true.,error)
     if(error) return
     call sic_descriptor(var,yinca,found)
     if(.not.found) then
        chain = 'E-POLYNOM,  Unknown variable '//var
        call gagout(chain)
        error = .true.
        return
     endif
     if (yinca%type.eq.fmt_r8) then
        iny = yinca%size/2
     elseif (yinca%type.eq.fmt_r4) then
        iny = yinca%size
     endif
     if(iny.ne.inx) then
        call gagout('E-POLYNOM, Arrays do not match')
        error = .true.
        return
     endif
     ipy = gag_pointer(yinca%addr,memory)
     if(yinca%type.eq.fmt_r8) then
        call r8tor8(memory(ipy), dat%w, ixy)
     else
        call r4tor8(memory(ipy), dat%w, ixy)
     endif
  else
     print *,'Setting equal weights'
     dat%w = 1.0
  endif
  !
  ! 2. Fitting function setup
  !
  nullify(fun%par)
  call null_function(fun)
  fun%name   = 'POLYNOMIAL'
  fun%method = 'SLATEC'
  fun%npar   = ndeg+1
  allocate(fun%par(fun%npar),stat=ier)
  if(ier.ne.0) then
     error = .true.
     return
  endif
  ! Names
  do i =1, fun%npar
     call null_parameter(fun%par(i))
     write(string,'(a12,i2)') 'Coefficient ', i-1
     fun%par(i)%name = string
  enddo
  !
  ! 3. Fitting
  !
  call fit_polynomial(dat,fun)
  !
  ! 4. Freeing memory
  !
  deallocate(dat%x,dat%y,dat%w,fun%par)
  !
end subroutine fit_xy_polynomial
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine solve_focus(line,error)
  use telcal_interfaces, except_this=>solve_focus
  use fit_definitions
  use focus_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine for command
  !    FOCUS [Polynomial|Lorentzian|Gaussian]
  !----------------------------------------------------------------------
  character(*), intent(in)  :: line  ! Command line
  logical,      intent(out) :: error ! Error flag
  !
  ! Local variables
  character(1) :: method
  integer :: idir,ndir,i,n
  real :: min,max
  !
  method = zfocus%fun(1)%name
  call sic_ke(line,0,1,method,n,.false.,error)
  if(error) return
  !
  ndir = 2
  !
  do idir=1,ndir
    if(method.eq.'L') then
      zfocus%fun(idir)%name   = 'LORENTZIAN'
      zfocus%fun(idir)%par(1)%guess = 1.0
      zfocus%fun(idir)%par(2)%guess = 0.0
      zfocus%fun(idir)%par(3)%guess = 3.0
    else if(method.eq.'G') then
      zfocus%fun(idir)%name   = 'GAUSSIAN'
      zfocus%fun(idir)%par(1)%guess = 1.0
      zfocus%fun(idir)%par(2)%guess = 0.0
      zfocus%fun(idir)%par(3)%guess = 3.0
    else ! if(method.eq.'P') then
      zfocus%fun(idir)%name   = 'POLYNOMIAL'
    endif
     if(zfocus%fun(idir)%flag.ne.-1000) then
        call fit_1d(zfocus%dat(idir),zfocus%fun(idir),.true.)
        min = zfocus%dat(idir)%x(1)
        max = zfocus%dat(idir)%x(zfocus%dat(idir)%n)
        do i=1,zfocus%sol(idir)%n
           zfocus%sol(idir)%x(i) = min+(max-min)*(i-1)/(zfocus%sol(idir)%n-1)
        enddo
        call get_profile(zfocus%fun(idir),zfocus%sol(idir))
     endif
  enddo
  call exec_program('sic\@ plot-focus.telcal')
  !
end subroutine solve_focus
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine init_focus(ndat)
  use telcal_interfaces, except_this=>init_focus
  use focus_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine for focus
  ! Purpose:
  !----------------------------------------------------------------------
  integer, intent(in) :: ndat ! Number of data points
  !
  ! Local variables
  integer   :: ndir,npar,nsol,i,idir,ier
  character :: string*16
  !
  ndir = 2
  npar = 3   ! Parabola, Lorentzian or Gaussian fitting
  nsol = 100 ! Arbitrary value
  !
  zfocus%sys = 0
  zfocus%dir(1) = '+FCZ'
  zfocus%dir(2) = '-FCZ'
  !
  do idir=1,ndir
     !
     call null_simple_1d(zfocus%dat(idir))
     zfocus%dat(idir)%n = ndat
     allocate(zfocus%dat(idir)%x(ndat),zfocus%dat(idir)%y(ndat),zfocus%dat(idir)%w(ndat),stat=ier)
     zfocus%dat(idir)%x = 0.
     zfocus%dat(idir)%y = 0.
     zfocus%dat(idir)%w = 1.
     !
     call null_simple_1d(zfocus%sol(idir))
     zfocus%sol(idir)%n = nsol
     allocate(zfocus%sol(idir)%x(nsol),zfocus%sol(idir)%y(nsol),zfocus%sol(idir)%w(nsol),stat=ier)
     zfocus%sol(idir)%x = 0.
     zfocus%sol(idir)%y = 0.
     zfocus%sol(idir)%w = 1.
     !
     call null_function(zfocus%fun(idir))
     zfocus%fun(idir)%name   = 'LORENTZIAN'  ! or 'POLYNOMIAL', or 'GAUSSIAN'
     zfocus%fun(idir)%method = 'SLATEC'
     zfocus%fun(idir)%npar = npar
     allocate(zfocus%fun(idir)%par(npar),stat=ier)
     do i=1,npar
        call null_parameter(zfocus%fun(idir)%par(i))
        write(string,'(a12,i2)') 'COEFFICIENT ', i-1
        zfocus%fun(idir)%par(i)%name = string
     enddo
     !
  enddo
  !
end subroutine init_focus
!
subroutine free_focus
  use telcal_interfaces, except_this=>free_focus
  use focus_definitions
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for focus
  ! Purpose:
  !----------------------------------------------------------------------
  !
  ! Local variables
  integer   :: ndir,idir
  !
  ndir = 2
  !
  do idir=1,ndir
     call null_simple_1d(zfocus%dat(idir))
     call null_simple_1d(zfocus%sol(idir))
     call null_function(zfocus%fun(idir))
  enddo
  !
end subroutine free_focus
!
subroutine define_sic_focus
  use telcal_interfaces, except_this=>define_sic_focus
  use focus_definitions
  use gildas_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for focus
  ! Purpose:
  !----------------------------------------------------------------------
  !
  ! Local variables
  integer :: idir,ipar,ndat,nsol,ndir,npar
  character(1) :: cdir,cpar
  logical :: error
  !
  ndir = 2
  !
  if (.not.sic_varexist('zfocus')) then
     call sic_defstructure('zfocus%',.true.,error)
     call sic_def_inte('zfocus%sys',zfocus%sys,0,0,.false.,error)
     call sic_def_charn('zfocus%dir',zfocus%dir,1,2,.false.,error)
     do idir=1,ndir
        write(cdir,1000) idir
        call sic_defstructure('zfocus%dat'//cdir,.true.,error)
        call sic_defstructure('zfocus%sol'//cdir,.true.,error)
        call sic_defstructure('zfocus%fun'//cdir,.true.,error)
        !
        ndat = zfocus%dat(idir)%n
        call sic_def_inte('zfocus%dat'//cdir//'%n',zfocus%dat(idir)%n,0,0,.false.,error)
        call sic_def_dble('zfocus%dat'//cdir//'%x',zfocus%dat(idir)%x,1,ndat,.false.,error)
        call sic_def_dble('zfocus%dat'//cdir//'%y',zfocus%dat(idir)%y,1,ndat,.false.,error)
        call sic_def_dble('zfocus%dat'//cdir//'%w',zfocus%dat(idir)%w,1,ndat,.false.,error)
        !
        nsol = zfocus%sol(idir)%n
        call sic_def_inte('zfocus%sol'//cdir//'%n',zfocus%sol(idir)%n,0,0,.false.,error)
        call sic_def_dble('zfocus%sol'//cdir//'%x',zfocus%sol(idir)%x,1,nsol,.false.,error)
        call sic_def_dble('zfocus%sol'//cdir//'%y',zfocus%sol(idir)%y,1,nsol,.false.,error)
        call sic_def_dble('zfocus%sol'//cdir//'%w',zfocus%sol(idir)%w,1,nsol,.false.,error)
        !
        npar = zfocus%fun(idir)%npar
        call sic_def_char('zfocus%fun'//cdir//'%name',  zfocus%fun(idir)%name,.true.,error)
        call sic_def_char('zfocus%fun'//cdir//'%method',zfocus%fun(idir)%method,.true.,error)
        call sic_def_real('zfocus%fun'//cdir//'%chi2',  zfocus%fun(idir)%chi2,0,0,.false.,error)
        call sic_def_real('zfocus%fun'//cdir//'%rms',   zfocus%fun(idir)%rms,0,0,.false.,error)
        call sic_def_inte('zfocus%fun'//cdir//'%flag',  zfocus%fun(idir)%flag,0,0,.false.,error)
        call sic_def_inte('zfocus%fun'//cdir//'%ncall', zfocus%fun(idir)%ncall,0,0,.false.,error)
        call sic_def_inte('zfocus%fun'//cdir//'%npar',  zfocus%fun(idir)%npar,0,0,.true.,error)
        do ipar=1,npar
           write(cpar,1000) ipar
           call sic_def_char('zfocus%fun'//cdir//'%par'//cpar//'%name', zfocus%fun(idir)%par(ipar)%name,.true.,error)
           call sic_def_dble('zfocus%fun'//cdir//'%par'//cpar//'%value',zfocus%fun(idir)%par(ipar)%value,0,0,.false.,error)
           call sic_def_dble('zfocus%fun'//cdir//'%par'//cpar//'%error',zfocus%fun(idir)%par(ipar)%error,0,0,.false.,error)
           call sic_def_dble('zfocus%fun'//cdir//'%par'//cpar//'%mini', zfocus%fun(idir)%par(ipar)%mini,0,0,.false.,error)
           call sic_def_dble('zfocus%fun'//cdir//'%par'//cpar//'%maxi', zfocus%fun(idir)%par(ipar)%maxi,0,0,.false.,error)
           call sic_def_logi('zfocus%fun'//cdir//'%par'//cpar//'%fixed',zfocus%fun(idir)%par(ipar)%fixed,.false.,error)
        enddo
     enddo
  endif
  !
1000 format(i1)
end subroutine define_sic_focus
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine format_catalog(line,error)
  use gbl_message
  use astro_interfaces, except_this=>format_catalog
  !---------------------------------------------------------------------
  ! @ private
  !	ASTRO Command CATALOG  name /VELETA
  !---------------------------------------------------------------------
  character(len=*), intent(inout):: line           !
  logical, intent(inout) :: error                  !
  ! Global
  integer(kind=4) :: lenc,sic_getlun,sic_open
  ! Local
  character(len=80) :: c_sbas,c_seqn,c_slam,c_sbet,c_vhel,c_vlsr,c_snam
  character(len=80) :: c_flux
  integer(kind=4) :: l_sbas,l_seqn,l_slam,l_sbet,l_vhel,l_vlsr,l_snam,l_flux
  logical :: i_sbas,i_seqn,i_slam,i_sbet,i_vhel,i_vlsr,i_flux
  common /source_infc/ c_sbas,c_seqn,c_slam,c_sbet,c_vhel,c_vlsr,c_snam,c_flux
  common /source_infi/ l_sbas,l_seqn,l_slam,l_sbet,l_vhel,l_vlsr,l_snam,  &
                l_flux,i_sbas,i_seqn,i_slam,i_sbet,i_vhel,i_vlsr,i_flux
  character(len=132) :: c_line
  character(len=80) :: name, file, c_snam_t
  integer(kind=4) :: nlu, olun, lun, icom, l_snam_t, ier, nc
  character(len=7) :: rname
  data rname /'CATALOG'/
  ! Code ------------------------------------------------------------------
  !
  ! Open input catalog
  call sic_ch (line,0,1,name,nc,.true.,error)
  if (error) return
  error = .true.
  call sic_parsef(name,file,' ','.cat')
  ier = sic_getlun(lun)
  ier = sic_open(lun,file,'OLD',.true.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening '//file)
    goto 998
  endif
  !
  ! Open output catalog
  call sic_parsef(name,file,' ','.sou')
  ier = sic_getlun (olun)
  ier = sic_open(olun,file,'NEW',.false.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening '//file)
    goto 997
  endif
  l_snam = 0
  l_sbas = 0
  l_seqn = 0
  l_slam = 0
  l_sbet = 0
  l_vlsr = 0
  l_vhel = 0
  l_flux = 0
  i_sbas = .false.
  i_seqn = .false.
  i_slam = .false.
  i_sbet = .false.
  i_vlsr = .false.
  i_vhel = .false.
  i_flux = .false.
  error = .false.
  !
  ! Start reading
  100   read(lun,'(A)',end=997) c_line
  nlu = lenc(c_line)
  if (nlu.eq.0) goto 100
  icom = index(c_line(1:nlu),'!')-1
  if (icom.eq.-1) icom = nlu   ! no comment
  if (icom.gt.0) icom = lenc(c_line(1:icom))
  if (icom.eq.0) then
    write(olun,'(A)') c_line(1:nlu)
    goto 100
  elseif (c_line(1:1).eq.'*') then
    write(olun,'(A)') '!'//c_line(2:nlu)
    goto 100
  elseif (index(c_line(1:icom),'STOP') .ne. 0) then
    if (l_snam .ne. 0 .and. l_slam.ne.0 .and. l_sbet.ne.0) then
      call output_line(olun,error)
      if(error) goto 98
    endif
    goto 997
  elseif (index(c_line(1:icom),'COMMON:') .ne. 0) then
    call sic_upper(c_line(1:icom))
    if (l_snam .ne. 0 .and. l_slam.ne.0 .and. l_sbet.ne.0) then
      call output_line(olun,error)
      if(error) goto 98
      l_snam = 0
    endif
    call getpar(c_line(1:icom),'SBAS',c_sbas,l_sbas)
    call getpar(c_line(1:icom),'SEQN',c_seqn,l_seqn)
    call getpar(c_line(1:icom),'SLAM',c_slam,l_slam)
    call getpar(c_line(1:icom),'SBET',c_sbet,l_sbet)
    call getpar(c_line(1:icom),'VHEL',c_vhel,l_vhel)
    call getpar(c_line(1:icom),'VLSR',c_vlsr,l_vlsr)
    goto 100
  elseif (index(c_line(1:icom),'INDIVIDUAL:') .ne. 0) then
    call sic_upper(c_line(1:icom))
    if (l_snam .ne. 0 .and. l_slam.ne.0 .and. l_sbet.ne.0) then
      !	if (l_snam .ne. 0) then
      call output_line(olun,error)
      if(error) goto 98
      l_snam = 0
    endif
    if(error) return
    i_sbas = index(c_line(1:icom),'SBAS').ne.0
    i_seqn = index(c_line(1:icom),'SEQN').ne.0
    i_slam = index(c_line(1:icom),'SLAM').ne.0
    i_sbet = index(c_line(1:icom),'SBET').ne.0
    i_vhel = index(c_line(1:icom),'VHEL').ne.0
    i_vlsr = index(c_line(1:icom),'VLSR').ne.0
    i_flux = index(c_line(1:icom),'FLUX').ne.0
    goto 100
  else
    call sic_upper(c_line(1:icom))
    call getpar(c_line(1:icom),'SNAM',c_snam_t,l_snam_t)
    !
    !  New source is defined
    if (l_snam_t .ne.0) then
      ! if (l_snam .ne. 0) then
      if (l_snam .ne. 0 .and. l_slam.ne.0 .and. l_sbet.ne.0) then
        call output_line(olun,error)
        if(error) goto 98
      endif
      l_snam = l_snam_t
      c_snam(1:l_snam) = c_snam_t(1:l_snam_t)
    endif
    if (i_sbas) call getpar(c_line(1:icom),'SBAS',c_sbas,l_sbas)
    if (i_seqn) call getpar(c_line(1:icom),'SEQN',c_seqn,l_seqn)
    if (i_slam) call getpar(c_line(1:icom),'SLAM',c_slam,l_slam)
    if (i_sbet) call getpar(c_line(1:icom),'SBET',c_sbet,l_sbet)
    if (i_vhel) call getpar(c_line(1:icom),'VHEL',c_vhel,l_vhel)
    if (i_vlsr) call getpar(c_line(1:icom),'VLSR',c_vlsr,l_vlsr)
    if (i_flux) call getpar(c_line(1:icom),'FLUX',c_flux,l_flux)
    goto 100
  endif
  !
98 call astro_message(seve%r,rname,'Input: '//c_line(1:nlu))
  !
997 close (unit=olun)
    call sic_frelun (olun)
  !
998 close (unit=lun)
    call sic_frelun (lun)
  !
end subroutine format_catalog
!
subroutine getpar(line,code,par,lpar)
  !---------------------------------------------------------------------
  ! @ private
  ! Find parameter par for code word CODE
  !---------------------------------------------------------------------
  character(len=*):: line           !
  character(len=*):: code           !
  character(len=*):: par            !
  integer(kind=4) :: lpar           !
  ! Global
  integer(kind=4) :: lenc
  ! Local
  integer(kind=4) :: i, j, j1, j2, ll
  ! Code ------------------------------------------------------------------
  lpar = 0
  par = ' '
  ll = lenc(line)
  i = index(line,code)
  if (i.eq.0) return
  i = i+len(code)
  if (i.gt.ll) goto 100
  j1 = index(line(i:),'=')
  j2 = index(line(i:),':')
  if (j1.ne.0) then
    i = i+j1
  elseif (j2.ne.0) then
    i = i+j2
  endif
  if (i.gt.ll) goto 100
  j = index(line(i:),';')-1
  if (j.eq.-1) j = lenc(line(i:))
  lpar = j
  if (lpar.ne.0) par(1:lpar) = line(i:i+lpar-1)
  return
  !
  100   lpar = 0
  return
end subroutine getpar
!
subroutine nblank(par,lpar)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: par            !
  integer(kind=4) :: lpar           !
  ! Local
  character(len=1) :: tab
  integer(kind=4) :: i, j
  tab = char(9)
  !
  call sic_blanc(par,lpar)
  j = 0
  do i=1, lpar
    if (par(i:i).ne.' ' .and. par(i:i).ne.tab) then
      j = j + 1
      par(j:j) = par(i:i)
    endif
  enddo
  lpar = j
  return
end subroutine nblank
!
subroutine transform(in,out,u,error)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: in             !
  character(len=*):: out            !
  character(len=1) :: u             !
  logical :: error                  !
  ! Local
  integer(kind=4) :: iret, iang, iangin, lin
  real(kind=8) :: dang
  character(len=9) :: rname
  data rname /'TRANSFORM'/
  ! Code ------------------------------------------------------------------------
  lin = lenc(in)
  if (lin.le.0) then
    call astro_message(seve%e,rname,'null chain')
    error = .true.
    return
  endif
  call sic_blanc(in,lin)
  iret = iangin(in(1:lin),u,dang,iang)
  error = iret.ne.1
  if (error) then
    call astro_message(seve%e,rname,'error in IANGIN')
    return
  endif
  if (u.eq.'S') then
    call rad2sexa(dang,24,out,4,left=.true.)
  else
    call rad2sexa(dang,360,out,3,left=.true.)
  endif
end subroutine transform
!
subroutine output_line(olun,error)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: olun           !
  logical :: error                  !
  ! Local
  character(len=80) :: c_sbas,c_seqn,c_slam,c_sbet,c_vhel,c_vlsr,c_snam
  character(len=80) :: c_flux
  integer(kind=4) :: l_sbas,l_seqn,l_slam,l_sbet,l_vhel,l_vlsr,l_snam,l_flux
  logical :: i_sbas,i_seqn,i_slam,i_sbet,i_vhel,i_vlsr,i_flux
  common /source_infc/ c_sbas,c_seqn,c_slam,c_sbet,c_vhel,c_vlsr,c_snam,c_flux
  common /source_infi/ l_sbas,l_seqn,l_slam,l_sbet,l_vhel,l_vlsr,l_snam,  &
                l_flux,i_sbas,i_seqn,i_slam,i_sbet,i_vhel,i_vlsr,i_flux
  character(len=132) :: o_line
  integer(kind=4) :: ko, sbas, lpar, npar
  character(len=12) :: par
  ! Code ------------------------------------------------------------------
  call sic_blanc(c_snam,l_snam)
  npar = 1
  lpar = 12
  ko = 1
  call sic_next(c_snam(1:l_snam),par,lpar,npar)
  lpar = min(12,lpar)
  o_line(ko:) = par(1:lpar)
  ko = ko + lpar
  if (ko.lt.7) then
    call sic_next(c_snam(npar:),par,lpar,npar)
    if (lpar.le.6 .and. lpar.gt.0) then
      o_line(ko:) = par(1:lpar)
      ko = ko + lpar
    endif
  endif
  ko = 15
  !
  ! Coordinate system
  if (l_sbas.gt.0) then
    call nblank(c_sbas,l_sbas)
    read(c_sbas(1:l_sbas),*,err=98) sbas
  else
    sbas = 1
  endif
  call nblank(c_seqn,l_seqn)
  if (sbas.eq.-1) then
    o_line (ko:) = 'EQ 2000'
    ko = ko + 7
  elseif (sbas.eq.0) then
    o_line(ko:) = 'GA'
    ko = ko + 2
  elseif (sbas.eq.1) then
    o_line(ko:) = ' '          ! EQ 1950 default
  elseif (sbas.eq.2) then
    if (l_seqn.eq.0) goto 98
    o_line(ko:) = 'EQ '//c_seqn
    ko = ko + 2 + l_seqn
  elseif (sbas.eq.3) then
    o_line(ko:) = 'DA'
    ko = ko + 2
  elseif (sbas.eq.6) then
    o_line (ko:) = 'EC 1950'
    ko = ko + 7
  elseif (sbas.eq.7) then
    if (l_seqn.eq.0) goto 98
    o_line(ko:) = 'EC '//c_seqn
    ko = ko + l_seqn
  elseif (sbas.eq.10) then
    o_line(ko:) = 'HO'
    ko = ko + 2
  else
    write (6,*) 'sbas = ',sbas
    goto 98
  endif
  ko = max(ko+1, 25)
  !
  ! Lambda, Beta
  if (sbas.eq.0 .or. sbas.eq.10) then
    call transform(c_slam,o_line(ko:),'"',error)
  else
    call transform(c_slam,o_line(ko:),'S',error)
  endif
  ko = ko + 15
  if (error) goto 98
  call transform(c_sbet,o_line(ko:),'"',error)
  ko = ko + 15
  if (error) goto 98
  !
  ! Velocity
  if (l_vlsr.ne.0) then
    call nblank(c_vlsr,l_vlsr)
    o_line(ko:) = 'LS '//c_vlsr(1:l_vlsr)
    ko = ko + 3 + l_vlsr
  elseif (l_vhel.ne.0) then
    call nblank(c_vhel,l_vhel)
    o_line(ko:) = 'HE '//c_vhel(1:l_vhel)
    ko = ko + 3 + l_vhel
  else
    o_line(ko:) = 'HE 0'
    ko = ko + 4
  endif
  !
  ! Flux
  if (l_flux .ne. 0) then
    call nblank(c_flux,l_flux)
    o_line(ko:) = ' FL '//c_flux(1:l_flux)
    ko = ko + 4 + l_flux
  endif
  !
  write(olun,'(A)') o_line(1:ko-1)
  if (i_sbas) l_sbas = 0
  if (i_seqn) l_seqn = 0
  if (i_slam) l_slam = 0
  if (i_sbet) l_sbet = 0
  if (i_flux) l_flux = 0
  l_flux = 0
  if (i_vlsr) l_vlsr = 0
  if (i_vhel) l_vhel = 0
  return
  !
  98 call astro_message(seve%e,'FORMAT','Conversion error or unsupported '//  &
     'option')
  error = .true.
  return
end subroutine output_line

subroutine dpoinl(xv,a,deriv)
  !---------------------------------------------------------------------
  ! POINT
  !	Compute the derivatives of the pointing function
  !	Dimensionned for MVAR or KVAR
  ! V2.0
  !	Changed sign of excentricity corrections
  !---------------------------------------------------------------------
  ! Global
  include 'size.inc'
  !
  real*8 :: xv(3)                   !
  real*8 :: a(mvar)                 !
  real*8 :: deriv(mvar)             !
  ! Local
  real*8 :: az,el,cosel,sinel,cosaz,sinaz
  !
  az=xv(1)
  el=xv(2)
  cosel=cos(el)
  sinel=sin(el)
  cosaz=cos(az)
  sinaz=sin(az)
  if (xv(3).eq.0) then
    deriv( 1)=-cosel
    deriv( 2)= 0
    deriv( 3)=-1.0/sqrt(max(1d-37,1.0d0-(a(3)/cosel)**2))
    deriv( 4)= -cosaz*sinel
    deriv( 5)= sinaz*sinel
    deriv( 6)= sinel
    deriv( 7)= 0
    deriv( 8)= 0
    deriv( 9)= 0
    deriv(10)= 0
    deriv(11)= -sinaz*cosel
    deriv(12)= -cosaz*cosel
    if (kvar.le.12) return
    deriv(13)= sin(2.d0*az)*cosel
    deriv(14)= cos(2.d0*az)*cosel
    deriv(15)= 0
    deriv(16)= 0
  else
    deriv( 1)= 0
    deriv( 2)=-1
    deriv( 3)= -sinel*a(3)/   &
     &      sqrt(max(1d-30,1.0d0-sinel**2/(1.0d0-a(3)**2)))/   &
     &      sqrt(max(1d-30,(1.0d0-a(3)**2)**3))
    deriv( 4)=sinaz
    deriv( 5)=+cosaz
    deriv( 6)= 0
    deriv( 7)= 1.d0/tan(el)
    deriv( 8)= deriv(7)**3
    deriv( 9)= -sinel
    deriv(10)= -cosel
    deriv(11)= 0
    deriv(12)= 0
    if (kvar.le.12) return
    deriv(13)= 0
    deriv(14)= 0
    deriv(15)= sin(2.d0*el)
    deriv(16)= cos(2.d0*el)
  endif
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_sdi
  use gbl_message
  !
  public :: sdi_comm
  private
  !
contains
  !
  subroutine sdi_comm(line,error)
    use gkernel_interfaces
    use mapping_interfaces
    use clean_tool, only: sub_clean,clean_data
    use clean_types, only: beam_unit_conversion
    use uvmap_buffers
    use clean_buffers, only: clean_user,clean_prog
    !----------------------------------------------------------------------
    ! Implementation of Steer Dewdney Ito Clean
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: iv,na,m_iter
    character(len=8) :: name,argum,voc1(2)
    data voc1/'CLEAN','RESIDUAL'/
    !
    ! Save default number of components
    m_iter = clean_user%m_iter
    clean_user%m_iter = dirty%head%gil%dim(1) * dirty%head%gil%dim(2)
    !
    ! Data checkup: method must be defined first ?
    clean_user%method = 'SDI'
    call clean_data (error)
    if (error) return
    !
    ! Parameter Definitions
    call beam_unit_conversion(clean_user)
    call clean_user%copyto(clean_prog)
    clean_prog%pflux = .false.
    clean_prog%pcycle = sic_present(2,0)
    clean_prog%qcycle = sic_present(3,0)
    if (clean_prog%pcycle) then
       argum = 'RESIDUAL'
       call sic_ke (line,2,1,argum,na,.false.,error)
       if (error) return
       call sic_ambigs ('PLOT',argum,name,iv,voc1,2,error)
       if (error) return
       clean_prog%pclean = iv.eq.1
    else
       clean_prog%pclean = .false.
    endif
    call sub_clean(line,error)
    ! Restore default number of components
    clean_user%m_iter = m_iter
  end subroutine sdi_comm
end module clean_sdi
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine rgen(set,obs,error)
  use classcore_interfaces, except_this=>rgen
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -2 General
  !  Caution: part of the GEN section is actually copied from the
  ! index, and not read here
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_gen_id,error)
end subroutine rgen
!
subroutine rpos(set,obs,error)
  use classcore_interfaces, except_this=>rpos
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -3 Position
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_pos_id,error)
end subroutine rpos
!
subroutine rspec(set,obs,error)
  use classcore_interfaces, except_this=>rspec
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -4 Spectroscopy
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_spe_id,error)
  !
  ! Factorize here some duplicates of the spectroscopic section. It
  ! is unclear where this action should be factorized. Here is good
  ! for spectra from disk, subroutine 'abscissa' is good for a memory
  ! only spectrum, but 'abscissa' is not suited when the other data
  ! arrays are not needed (waste of time)...
  obs%cbad = obs%head%spe%bad
  obs%cnchan = obs%head%spe%nchan
  !
end subroutine rspec
!
subroutine rres(set,obs,error)
  use classcore_interfaces, except_this=>rres
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -21 Resolution description
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_res_id,error)
end subroutine rres
!
subroutine rbase(set,obs,error)
  use classcore_interfaces, except_this=>rbase
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -5 Baseline
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_bas_id,error)
end subroutine rbase
!
subroutine rorig(set,obs,error)
  use classcore_interfaces, except_this=>rorig
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -6 Origin
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_his_id,error)
end subroutine rorig
!
subroutine rplot(set,obs,error)
  use classcore_interfaces, except_this=>rplot
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -7 Plotting parameters
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_plo_id,error)
end subroutine rplot
!
subroutine rswi(set,obs,error)
  use classcore_interfaces, except_this=>rswi
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -8 Switching description
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_swi_id,error)
end subroutine rswi
!
subroutine rgaus(set,obs,error)
  use classcore_interfaces, except_this=>rgaus
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -9 Gauss fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_gau_id,error)
end subroutine rgaus
!
subroutine rcont(set,obs,error)
  use classcore_interfaces, except_this=>rcont
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -10 Drift continuum
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_dri_id,error)
  !
  obs%cnchan = obs%head%dri%npoin
  obs%cbad = obs%head%dri%bad
end subroutine rcont
!
subroutine rbeam(set,obs,error)
  use classcore_interfaces, except_this=>rbeam
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -11 Beam Switch
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_bea_id,error)
end subroutine rbeam
!
subroutine rshel(set,obs,error)
  use classcore_interfaces, except_this=>rshel
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -12 SHELL fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_she_id,error)
end subroutine rshel
!
subroutine rnh3(set,obs,error)
  use classcore_interfaces, except_this=>rnh3
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -13 NH3 fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_hfs_id,error)
end subroutine rnh3
!
subroutine rabs(set,obs,error)
  use classcore_interfaces, except_this=>rabs
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -18 ABS fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_abs_id,error)
end subroutine rabs
!
subroutine rcal(set,obs,error)
  use classcore_interfaces, except_this=>rcal
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -14 Calibration
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_cal_id,error)
end subroutine rcal
!
subroutine rpoint(set,obs,error)
  use classcore_interfaces, except_this=>rpoint
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -15 Pointing fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_poi_id,error)
end subroutine rpoint
!
subroutine rsky(set,obs,error)
  use classcore_interfaces, except_this=>rsky
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -16 Skydip
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_sky_id,error)
end subroutine rsky
!
subroutine rxcoo(set,obs,error)
  use classcore_interfaces, except_this=>rxcoo
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -17 X coordinates (irregularly spaced data).
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec_xcoo(set,obs,error)
end subroutine rxcoo
!
subroutine rdescr(set,obs,error)
  use classcore_interfaces, except_this=>rdescr
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -30 Data Section descriptor
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_desc_id,error)
end subroutine rdescr
!
subroutine rcom(set,obs,error)
  use classcore_interfaces, except_this=>rcom
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -1  Comment section
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_com_id,error)
end subroutine rcom
!
subroutine ruser(set,obs,error)
  use classcore_interfaces, except_this=>ruser
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Write the USER defined section description
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_user_id,error)
end subroutine ruser
!
subroutine rassoc(set,obs,error)
  use classcore_interfaces, except_this=>rassoc
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! -19 ASSOCiated arrays section
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_assoc_id,error)
end subroutine rassoc
!
subroutine rherschel(set,obs,error)
  use classcore_interfaces, except_this=>rherschel
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! HERSCHEL section
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_her_id,error)
end subroutine rherschel
!
subroutine rdata(set,obs,nv4,values,error)
  use gildas_def
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>rdata
  use class_types
  use class_common
  !----------------------------------------------------------------------
  ! @ private
  ! Read the whole data section
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set          !
  type(observation),   intent(in)    :: obs          ! Observation
  integer(kind=4),     intent(inout) :: nv4          ! Number of data words
  real(kind=4),        intent(out)   :: values(nv4)  ! Data array
  logical,             intent(inout) :: error        !
  ! Local
  integer(kind=4) :: l1,i,k
  integer(kind=data_length) :: first,last,nv8
  !
  error = .false.
  !
  if (obs%head%presec(class_sec_desc_id) ) then
     ! OTF data (presumably)
     nv4 = min(nv4,obs%desc%ldata)
     nv8 = nv4
     call classic_entry_data_read(values,nv8,obs%desc,ibufobs,error)
     if (error)  return
     nv4 = nv8
     if (obs%head%des%ldump.gt.nv4 .or. obs%head%des%ndump*obs%head%des%ldump.gt.nv4) then
        call class_message(seve%f,'RDATA','Inconsistent data section')
        write(6,*) 'r_ndump, r_ldump, r_ldpar, nv'
        write(6,*)  obs%head%des%ndump, obs%head%des%ldump, obs%head%des%ldpar, nv4
        error = .true.
        return
     endif
     l1 = obs%head%des%ldump-obs%head%des%ldpar
     k = 1
     do i=1,obs%head%des%ndump
        call convert_dh (values(k),obs%head%des%ldpar,filein%conv)
        k = k+obs%head%des%ldpar
        call filein%conv%read%r4(values(k),values(k),l1)
        k = k+l1
     enddo
     !
  else
    ! Normal data
    first = 1_8
    last = nv4
    nv8 = nv4
    call rdata_sub(set,obs,first,last,nv8,values,error)
    nv4 = nv8
    if (error)  return
  endif
  !
end subroutine rdata
!
subroutine rdata_sub(set,obs,first,last,nv,values,error)
  use classic_api
  use classcore_interfaces, except_this=>rdata_sub
  use class_common
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Read a subset of the data section.
  ! No support for OTF data
  !----------------------------------------------------------------------
  type(class_setup_t),       intent(in)    :: set         !
  type(observation),         intent(in)    :: obs         ! Observation
  integer(kind=data_length), intent(in)    :: first       ! First data word to read
  integer(kind=data_length), intent(in)    :: last        ! Last data word to read
  integer(kind=data_length), intent(inout) :: nv          ! Input and actual number of values read
  real(kind=4),              intent(out)   :: values(nv)  ! Data array
  logical,                   intent(inout) :: error       ! Logical error flag
  !
  error = .false.
  !
  if (filein_isvlm) then
    call rdata_sub_vlm(obs%desc%xnum,first,last,nv,values,error)
  else
    call rdata_sub_classic(obs,first,last,nv,values,error)
  endif
  if (error)  return
  !
  ! Chase NaN
  if (set%chase_nan)  &
    call modify_blanking(values,nv,obs_bad(obs%head),obs_bad(obs%head))
  !
end subroutine rdata_sub
!
subroutine rdata_sub_classic(obs,first,last,nv,values,error)
  use gildas_def
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>rdata_sub_classic
  use class_common
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Read a (subset of) the data array from an entry of a Classic file
  !---------------------------------------------------------------------
  type(observation),         intent(in)      :: obs         ! Observation
  integer(kind=data_length), intent(in)      :: first       ! First data word to read
  integer(kind=data_length), intent(in)      :: last        ! Last data word to read
  integer(kind=data_length), intent(inout)   :: nv          ! Input and actual number of values read
  real(kind=4),              intent(out)     :: values(nv)  ! Data array
  logical,                   intent(inout)   :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RDATA'
  integer(kind=4) :: nv4
  !
  if (obs%head%presec(class_sec_desc_id)) then
    ! OTF data (presumably)
    call class_message(seve%e,rname,'Can not read subset of old OTF data section')
    error = .true.
    return
  endif
  !
  ! Read 'data' block
  call classic_entry_data_readsub(values,nv,first,last,obs%desc,ibufobs,error)
  if (error)  return
  nv4 = nv
  !
  if (filein%conv%code.ne.0) then
    ! Non-native, conversion needed.
    call filein%conv%read%r4(values,values,nv4)
  endif
  !
end subroutine rdata_sub_classic
!
subroutine convert_dh (iwin,nw,conv)
  use gbl_convert
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! @ private
  !  Convert data header IWIN using conversion code CONVE, assuming NW
  ! is the length of the data header.
  !---------------------------------------------------------------------
  real(kind=4),             intent(inout) :: iwin(*)  ! Array containing data header to be converted
  integer(kind=4),          intent(in)    :: nw       ! Size of IWIN
  type(classic_fileconv_t), intent(in)    :: conv     ! Conversion structure
  ! Local
  !
  if (conv%code.eq.0) return
  !
  ! Non native, conversion needed. NB: inplace modification is not
  ! Fortran standard and might not work! Should use a temporary buffer.
  ! As for now, everything is in R4 format.
  call conv%read%r4(iwin(1),iwin(1),nw)
  !
end subroutine convert_dh

subroutine clic_mark(line,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! CLIC	Command CLIC\MARK f1 f2 ... [/ANTENNA] [/BASELINE] [/RESET]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_flags.inc'
  ! Local
  integer :: i, j, ak(mnant), bk(mnbas)
  logical :: sa(2*mbands,mnant), sb(2*mbands,mnbas)
  logical :: reset
  character(len=1024) :: out
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  if (sic_narg(0).eq.0) then
    call list_flags(mnant,mnbas,ant_kill,bas_kill,san_kill,sba_kill,out)
    call message(6,1,'CLIC_MARK','Marked '//out(1:lenc(out)))
    return
  endif
  call get_flags(line,1,1,2,3,-1,-1,ak,bk,sa,sb,reset,error)
  if (error) return
  do i=1, mnant
    if (ak(i).ne.0) then
      if (reset) then
        ant_kill(i) = iand(ant_kill(i),not(ak(i)))
      else
        ant_kill(i) = ior(ant_kill(i),ak(i))
      endif
    endif
    do j=1, 2*mbands
      if (sa(j,i)) then
        if (reset) then
          san_kill(j,i) = .false.
        else
          san_kill(j,i) = .true.
        endif
      endif
    enddo
  enddo
  do i=1, mnbas
    if (bk(i).ne.0) then
      if (reset) then
        bas_kill(i) = iand(bas_kill(i),not(bk(i)))
      else
        bas_kill(i) = ior(bas_kill(i),bk(i))
      endif
    endif
    do j=1, 2*mbands
      if (sb(j,i)) then
        if (reset) then
          sba_kill(j,i) = .true.
        else
          sba_kill(j,i) = .false.
        endif
      endif
    enddo
  enddo
  call list_flags(mnant,mnbas,ant_kill,bas_kill,san_kill,sba_kill,out)
  call message(6,1,'CLIC_MARK','Marked '//out(1:lenc(out)))
  return
end subroutine clic_mark
!
subroutine list_flags(nant,nbas,afl,bfl,saf,sbf,out)
  use gkernel_interfaces
  use gildas_def
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_flags.inc'
  integer :: nant                   !
  integer :: nbas                   !
  integer :: afl(nant)              !
  integer :: bfl(nbas)              !
  logical :: saf(2*mbands,nant)              !
  logical :: sbf(2*mbands,nbas)              !
  character(len=*) :: out           !
  ! Local
  integer :: k, n, i, j, l, nout, lout
  logical :: done
  !------------------------------------------------------------------------
  ! Code:
  lout = len(out)
  nout = 0
  out = ' '
  do i=1, nant
    if (afl(i).ne.0) then
      if (nout.gt.0) then
        if (nout+2.gt.lout) goto 99
        out(nout+1:) = ', '
        nout = nout+2
      endif
      if (nout+6.gt.lout) goto 99
      write (out(nout+1:),'(a,i0,a)') 'Ant ',i,':'
      nout = nout + 6
      do k=1, maf
        n = ishft(1,k-1)
        if (iand(afl(i),n).eq.n) then
           l = lenc(af(k))
           if (nout+l+1.gt.lout) goto 99
           out(nout+1:) = ' '//af(k)(1:l)
           nout = nout + l+1
        endif
      enddo
    endif
    done = .false.
    do j=1, 2*mbands
      if (saf(j,i)) then
        if (.not.done) then
          if (nout.gt.0) then
            if (nout+2.gt.lout) goto 99
            out(nout+1:) = ', '
            nout = nout+2
          endif
          if (nout+6.gt.lout) goto 99
          write (out(nout+1:),'(a,i0,a)') 'Ant ',i,':'
          nout = nout + 6
          done = .true.
        endif
        l = lenc(sf(j))
        if (nout+l+1.gt.lout) goto 99
        out(nout+1:) = ' '//sf(j)(1:l)
        nout = nout + l+1
      endif
    enddo
  enddo
  do i=1, nbas
    if (bfl(i).ne.0) then
      if (nout.gt.0) then
        if (nout+2.gt.lout) goto 99
        out(nout+1:) = ', '
        nout = nout+2
      endif
      if (nout+10.gt.lout) goto 99
      out(nout+1:) = 'Bas '//cbas(i)//':'
      nout = nout + 10
      do k=1, mbf
        n = ishft(1,k-1)
        if (iand(bfl(i),n).eq.n) then
          l = lenc(bf(k))
          if (nout+l+1.gt.lout) goto 99
          out(nout+1:) = ' '//bf(k)(1:l)
          nout = nout + l+1
        endif
      enddo
      if (nout+1.gt.lout) goto 99
      out(nout+1:) = ' '
      nout = nout+1
    endif
    done = .false.
    do j=1, 2*mbands
      if (sbf(j,i)) then
        if (.not.done) then
          if (nout.gt.0) then
            if (nout+2.gt.lout) goto 99
            out(nout+1:) = ', '
            nout = nout+2
          endif
          if (nout+10.gt.lout) goto 99
          out(nout+1:) = 'Bas '//cbas(i)//':'
          nout = nout + 10
          done = .true.
        endif
        l = lenc(sf(j))
        if (nout+l+1.gt.lout) goto 99
        out(nout+1:) = ' '//sf(j)(1:l)
        nout = nout + l+1
        if (nout+1.gt.lout) goto 99
        out(nout+1:) = ' '
        nout = nout+1
      endif
    enddo
  enddo
  if (nout.eq.0) out = 'no flags'
  return
99 out(lout-3:lout) = '...'
  return
end subroutine list_flags

module lines
  !
  ! Variables for current command line
  character(len=256) :: code,comm,chain
  integer :: lcode,lcomm
  !
  ! Variables for previous command line
  character(len=256) :: code_last,comm_last
  integer :: lcode_last = 0
  integer :: lcomm_last = 0
  !
  ! Buffer for consecutive comment lines
  integer, parameter :: mbuffer = 20
  integer :: ibuffer = 0
  character(len=256) :: comm_buffer(mbuffer)
  !
  character(len=256), parameter :: empty = ' '
  integer :: ispace
  !
end module lines
!
module stdio
  !
  integer, parameter :: stdout = 6
  integer, parameter :: stderr = 0
  integer, parameter :: stdin  = 5
  !
end module stdio
!
module processor_variables
  logical :: do_declar        ! Convert non standard declarations
  logical :: do_byte          ! Convert BYTE declarations
  integer(kind=4) :: ngood
  integer(kind=4) :: lpinc,lbyte,laddr
  integer(kind=4) :: w_comm  ! Write out comments a position W_COMM
  ! -1 : Other line, 0 Do not write; <72 at least a W_COMM; >73 In column 73
  !
  integer(kind=4), parameter :: mgood=10
  integer(kind=4) :: lgsys(mgood)
  character(len=1) :: csuite
  character(len=6) :: goodsys(mgood)
  character(len=80) :: pinc,byte,address
end module processor_variables
!
program processor
  use lines
  use stdio
  use processor_variables
  !---------------------------------------------------------------------
  ! PROCESSOR Main program
  !    Pre-Process a Fortran file. Makes the program "nice", by
  !    appropriate indentation of the source code.
  ! Use
  !    Uses standard input (FOR005), standard output (FOR006) and
  !    standard error for error messages (to be defined for Unix
  !    systems, SYS$ERROR for VMS), so that it can be used on a pipe.
  ! Restrictions
  !    Program must execute where the include files are.
  !---------------------------------------------------------------------
  ! Global
  integer :: lenc,lsign
  ! Local
  character(len=3) :: arg
  character(len=40) :: date
  character(len=20) :: processed,customize
  character(len=8192) :: fortran
  character(len=1) :: tab
  integer :: iarg,lc,lf,ic,i,level,step,iline,fcode
  logical :: asuite,keepcase,keepblank
  integer :: void,ier
  !
  ! --- Customize here ---
  step = 2                     ! Smaller than for Fortran-77
  keepcase = .true.            ! Should case be kept?
  keepblank = .true.           ! Should blank lines be kept?
  ! ----------------------
  !
  ! Command line option parsing
  do iarg=1,command_argument_count()
    call get_command_argument(iarg,arg)
    if (arg.eq.'-l')  keepcase = .false.   ! -l lowercase
    if (arg.eq.'-u')  keepblank = .false.  ! -u unblank
  enddo
  !
  ! Initializations
  void = 0
  call load_processor
  level = 0
  tab = char(9)
  date = ' '
  fortran = ' '
  lf = 1                       ! To get started
  ispace = 0                   ! Itou
  !
  ! lc = len(date)
  ! call sic_c_datetime(date,lc)
  ! lc = lenc(date)
  ! date(lc-2:)=':00 '
  ! print *,'Date ',date
  ! To make differences between 2 consecutive versions, I prefer
  ! to skip the seconds (procedure cdiff).  Agree ?
  processed = '! Last processed by '
  ! Don't write it anymore
  ! write(stdout,'(a)') processed//'indent on '//date(1:lc)
  customize = '! Customized for : '
  lc = 1
  do i=1,ngood
    chain(lc:) = goodsys(i)
    lc = lenc(chain)
    lc=lc+1
    chain(lc:)=', '
    lc=lc+2
  enddo
  if (lc.gt.3) lc = lc-3
  ! write(stdout,'(a)') customize//chain(1:lc)
  iline = 0
  !
  ! Loop on lines
  do while (.true.)
    read(stdin,'(A)',end=10,iostat=ier) chain
    if (void.gt.100) goto 10
    ! print *,'Chain ',iline,ier,chain
    iline = iline+1
    if (iline.eq.1) then
      if (chain(2:20).eq.processed(2:)) cycle  ! Loop
    elseif (iline.eq.2) then
      if (chain(2:20).eq.customize(2:)) cycle  ! Loop
    endif
    lc = lenc(chain)
    if (lc.eq.0) then
      if (chain(1:1).eq.char(12)) then
        write(stdout,'(A)') '!<FF>'    ! A Pseudo Form-Feed
      endif
      void = void+1
      if (.not.keepblank)  cycle  ! Loop
    endif
    void = 0
    !
    ! Format Here...
    lcode = lc
    call nice(chain,code,lcode,comm,lcomm,fortran,lf,asuite)
    !
    ! Compiler or cpp directives must not be indented:
    if (lcode.eq.-1) then
      call purge_all()
      write(stdout,'(A)') trim(chain)
    !
    ! Line is a comment
    elseif (lcode.eq.0) then
      if (lcode_last.gt.0) then
        ! There is a code line pending (>0), and we have currently a
        ! comment: we do not print code line yet, since this line
        ! might be continued. Store comment line in buffer:
        ibuffer = ibuffer+1
        comm_buffer(ibuffer) = comm(1:lcomm)
        !
        if (ibuffer.ge.mbuffer) then
          ! Ok, comment buffer is full. Let's purge it, hoping that pending
          ! code line need not to be continued. If yes, an error will be
          ! raised later on.
          !
          call purge_all()  ! Purge pending lines, reset comm_buffer
          !
        endif
      else
        ! No code line pending, write current comment line now
        write(stdout,'(A)') trim(empty(1:ispace)//comm(1:lcomm))
      endif
    !
    ! Normal lines
    else
      !
      ! Obsolete: call translate (code,lcode)
      !
      ! Compute indentations
      call indent(code,lcode,level,step,fortran,lf,asuite,ispace)
      if (level.lt.0) then
        write(stderr,*) 'Internal error: negative level (',level,')'
        call crash
      endif
      !
      if (.not.keepcase) then
        lcode = lenc(chain)
        call sic_white(chain,lcode)  ! Convert to lower case
      endif
      !
      chain = empty(1:ispace)//chain
      lcode = lenc(chain)
      !
      ! Check continuation mark...
      fcode = lsign(chain,lcode)
      if (chain(fcode:fcode).eq.'&' .or.asuite) then
        ic = abs(lcode_last)
        if (code_last(ic:ic).ne.'&') then
          !
          ! Add a Fortran-95 continuation mark on previous line
          if (lcode_last.gt.0) then
            ic = ic+1
            code_last(ic:ic+3) = '   &'
            lcode_last = ic+3
          else
            write (stderr,*) 'Inconsistent continuation line...'
            call crash
          endif
        endif
      endif
      !
      ! Write previous line
      if (lcode_last.gt.0) then
        ic = lcode_last
        asuite = code_last(ic:ic).eq.'&'
        !
        call purge_all()
      else
        asuite = .false.
      endif
      !
      ! Move to buffer
      code_last = chain
      lcode_last = lcode
      comm_last  = comm
      lcomm_last = lcomm
      !
      ! Recompute ispace such as next comment lines are correctly aligned in
      ! blocks
      ispace = step*level
      !
    endif
    !
  enddo
  !
  10 continue
  call purge_all()
  !
end program processor
!
subroutine print_last
  use lines
  use stdio
  !---------------------------------------------------------------------
  ! Print last code line pending
  !---------------------------------------------------------------------
  ! Local
  character(len=256) :: chain_last
  integer :: icomm
  !
  if (lcode_last.lt.0)  return  ! Nothing to print
  !
  chain_last = code_last
  !
  ! Add last chain comment if any before printing it
  if (lcomm_last.ne.0) then
    icomm = max(32,4*((lcode_last+5)/4))
    chain_last(icomm:) = comm_last(1:lcomm_last)
  endif
  !
  ! Print it
  write(stdout,'(A)') trim(chain_last)
  lcode_last = -lcode_last  ! < 0 means that line has already been printed
  !
end subroutine print_last
!
subroutine purge_all
  use lines
  use stdio
  !---------------------------------------------------------------------
  ! Purge last pending code line and intermediate comment lines
  !---------------------------------------------------------------------
  ! Local
  integer :: i
  !
  ! Print last code line
  call print_last()
  !
  ! Print pending comments
  do i=1,ibuffer
    write(stdout,'(A)') trim(empty(1:ispace)//comm_buffer(i))
  enddo
  ibuffer = 0
  !
end subroutine purge_all
!
subroutine crash
  write(6,'(A)') '%PRE-F-ABORT,  Syntax error in input file'
  stop 1
end
!
subroutine nice(cin,cout,lc,comm,lcomm,fortran,lf,asuite)
  ! use stdio
  !---------------------------------------------------------------------
  ! - 'cin' is the input chain. It can be modified (suppression of
  !   leading spaces, change of continuation markers) but its case is
  !   kept.
  ! - 'cout' is 'cin' converted into uppercase, such as it can be used
  !   to recognize commands.
  ! - 'comm' is the comment found (if any) on line, such as 'cin' is
  !   split 'cout' and 'comm'
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: cin      ! Chain-in (but can be modified)
  character(len=*), intent(out)   :: cout     ! Chain-out
  integer,          intent(inout) :: lc       ! Length of cin/cout
  character(len=*), intent(out)   :: comm     ! Comment found
  integer,          intent(out)   :: lcomm    ! Length of 'comm'
  character(len=*), intent(inout) :: fortran  ! Previous line(s), used to detect continuations
  integer,          intent(inout) :: lf       ! Length of 'fortran'
  logical,          intent(out)   :: asuite   ! Input line is a continuation
  ! Local
  logical :: start, string
  character(len=1) :: tab,space,delimiter
  integer :: in,out,i,is,lsign
  character(len=256) :: chain  ! Local copy of 'cin', computed during the processing
  ! Data
  data space/' '/, string/.false./
  save string, delimiter
  !
  lcomm = 0
  asuite = .false.
  !
  if (lc.le.0)  return
  !
  ! Pseudo-Standard comment
  if (cin(1:1).eq.'*' .or. cin(1:1).eq.'D' .or. cin(1:1).eq.'d' .or.  &
      cin(1:1).eq.'C' .or. cin(1:1).eq.'c' .or. cin(1:1).eq.'$') then
    comm = cin
    comm(1:1) = '!'
    lcomm = lc
  elseif (cin(1:1).eq.'!') then
    comm = cin
    lcomm = lc
  endif
  !
  if (lcomm.ne.0) then
    ! Found a comment, nothing more to do
    lc = 0
    return
  endif
  !
  ! Check for fixed-form continuation lines
  is = lsign(cin,lc)
  !
  ! Old continuation marks at beginning of line, column 6
  if (is.eq.6 .and. cin(is:is).ne.' ' .and. cin(is:is).ne.'0') then
    cin(is:is) = '&'
    in = is+1
  elseif (cin(1:1).eq.'$') then  ! $something:  assume compiler directive
    comm = cin
    lcomm = lc
    lc = -1
    return
  elseif (cin(1:1).eq.'#') then  ! #something:  assume cpp directive
    comm = cin
    lcomm = lc
    lc = -1
    return
  else
    in = is
  endif
  !
  ! Case for Fortran-90 continuation
  if (fortran(lf:lf).eq.'&') then
    ! write(stderr,*) 'Found a continuation ',fortran(1:lf)
    lf = lf-1
    asuite = .true.
  elseif (cin(is:is).ne.'&') then
    fortran = ' '
    lf = 1
    string = .false.
    asuite = .false.
  else
    ! write(stderr,*) 'Found a F77 continuation ',CIN
    ! write(stderr,*) Fortran(1:lf)
    asuite = .true.
  endif
  !
  start = .true.
  tab = char(9)
  cout  = ' '
  chain = ' '
  out = 1
  do i=in,lc
    if (string) then
      cout(out:out) = cin(i:i)
      chain(out:out) = cin(i:i)
      out = out+1
    elseif (cin(i:i).eq.space .or. cin(i:i).eq.tab) then
      if (.not.start) then
        cout(out:out) = space
        chain(out:out) = space
        out = out+1
      endif
    else
      if (cin(i:i).eq.'!') then
        comm = cin(i:lc)
        lcomm = lc-i+1
        goto 20
      endif
      start = .false.
      ! Upcase 'cin'
      if (cin(i:i).ge.'a' .and. cin(i:i).le.'z') then
        cout(out:out) = char(ichar(cin(i:i)) + ichar('A')-ichar('a'))
      else
        cout(out:out) = cin(i:i)
      endif
      ! Keep case for 'chain'
      chain(out:out) = cin(i:i)
      out = out+1
    endif
    ! if (cin(i:i).eq.'''') string = .not.string
    if (string) then
      if (cin(i:i).eq.delimiter) string = .false.
    elseif  (cin(i:i).eq.'''') then
      string = .true.
      delimiter = ''''
    elseif  (cin(i:i).eq.'"') then
      string = .true.
      delimiter = '"'
    endif
  enddo
  !
  20 continue
  lc = len_trim(cout)
  cin = chain  ! On return 'cin' is stripped of comments and surrounding blanks
  !
  ! Horrible but useful patch:
  ! i = index(cout,'END IF')
  ! if (i.ne.0) cout(i:i+5) = 'ENDIF '
  ! i = index(cout,'END DO')
  ! if (i.ne.0) cout(i:i+5) = 'ENDDO '
  ! i = index(cout,'ELSEIF ')
  ! if (i.ne.0) cout(i:i+6) = 'ELSEIF '
  !
  if (lc.ge.1) then
    ! Append code in 'fortran' variable
    fortran(lf:) = cout(1:lc)
    lf = lf+lc-1
  else
    ! Nothing on this line, add a comment mark
    comm(1:1) = '!'
  endif
end
!
subroutine indent (cin,lc,level,step,merged,lm,asuite,ispace)
  character(len=*), intent(in)    :: cin     ! Chain-in
  integer,          intent(in)    :: lc      ! Length of 'cin'
  integer,          intent(inout) :: level   ! Indentation level
  integer,          intent(in)    :: step    ! Indentation per level
  character(len=*), intent(in)    :: merged  ! Merged lines in case of continuations
  integer,          intent(in)    :: lm      ! Length of 'merged'
  logical                         :: asuite  !
  integer,          intent(out)   :: ispace  ! Spaces to use for current line
  ! Local
  logical :: akey
  integer :: posi,start,is
  !
  ! 1/ Compute the spaces to add at the beginning of input line
  if (.not.asuite) then
  ! if (cin(6:6).ne.' ') then
  !   posi = 7+step*level
  !   asuite = .true.
  ! else
    !
    ! a) Single instructions indented to the left. They do not change the
    !    current general indentation.
    if (cin.eq.'ELSE') then
      posi = 1+step*(level-1)
    elseif (cin(:4).eq.'CASE') then
      posi = 1+step*(level-1)
    elseif (cin.eq.'ELSEWHERE') then
      posi = 1+step*(level-1)
    !
    ! b) Instructions which terminate blocks and indent all to the left
    else
      if (cin.eq.'ENDDO' .or. cin.eq.'ENDIF') then
        level = level-1
      elseif (cin(:3).eq.'END') then
        call isakey(merged,lm,'END',akey)
        if (akey) level = level-1
      elseif (cin(:6).eq.'ELSEIF') then
        call isakey(merged,lm,'ELSEIF',akey)
        if (akey) level = level-1
      elseif (cin(:7).eq.'ELSE IF') then
        level = level-1
      elseif (ichar(cin(1:1)).ge.ichar('0') .and.   &
              ichar(cin(1:1)).le.ichar('9')) then
        is = index(cin,' ')-1           ! Support of labeled DO loops:
        call islabel(cin(1:is),akey)    ! "100 CONTINUE". Must indent to the
        do while (akey)                 ! left. Several might end on the same
          level = level-1               ! labeled instruction
          call islabel(cin(1:is),akey)
        enddo
      endif
      posi = 1+step*level
    endif
  else
    posi = 3+step*level  ! For a continued line
  endif
  !
  ! Where is it written...
  ispace = posi-1
  !
  ! 2/ Change level?
  ! First check if instruction started by a label
  start = 1
  if (ichar(merged(start:start)).ge.ichar('0') .and.  &
      ichar(merged(start:start)).le.ichar('9')) then
    start = index(merged,' ')
    do while (merged(start:start).eq.' ')
      start = start+1
    enddo
  endif
  !
  ! Then analyse line
  if (merged(start:start+1).eq.'DO' .and. .not.asuite) then
    call isakey(merged,lm,'DO',akey)
    if (akey) level = level+1
  elseif (lc.ge.4.and.cin(lc-3:lc).eq.'THEN') then
    if (merged(start:start+1).eq.'IF') then
      call isakey(merged,lm,'IF',akey)
    elseif (merged(start:start+5).eq.'ELSEIF') then
      call isakey(merged,lm,'ELSEIF',akey)
    elseif (merged(start:start+6).eq.'ELSE IF') then
      akey = .true.
    else
      akey = .false.
    endif
    if (akey) level = level+1
  elseif (cin(:11).eq.'SUBROUTINE ') then
    level = level+1
  elseif (cin(:21).eq.'RECURSIVE SUBROUTINE ') then
    level = level+1
  elseif (cin(:9).eq.'FUNCTION ') then
    level = level+1
  elseif (cin(:9).eq.'INTERFACE') then
    level = level+1
  elseif (cin(:7).eq.'MODULE ') then
    level = level+1
  elseif (cin(:8).eq.'PROGRAM ') then
    level = level+1
  elseif (cin(:7).eq.'SELECT ') then
    level = level+1
  elseif (cin(:6).eq.'WHERE ') then
    level = level+1
  elseif (cin(:5).eq.'TYPE ') then
    call isakey(merged,lm,'TYPE',akey)
    if (akey) level = level+1
  elseif (cin(:5).eq.'BLOCK') then
    call isakey(merged,lm,'BLOCK',akey)
    if (akey) level = level+1
  elseif (cin(:17).eq.'INTEGER FUNCTION ') then
    level = level+1
  elseif (cin(:19).eq.'INTEGER*8 FUNCTION ') then
    level = level+1
  elseif (cin(:14).eq.'REAL FUNCTION ') then
    level = level+1
  elseif (cin(:17).eq.'LOGICAL FUNCTION ') then
    level = level+1
  elseif (cin(:16).eq.'REAL*8 FUNCTION ') then
    level = level+1
  elseif (cin(:16).eq.'REAL*4 FUNCTION ') then
    level = level+1
  endif
  !
end
!
subroutine isakey (line,nl,key,akey)
  use stdio
  !-----------------------------------------------------------------------
  !  Detect if KEY is a Fortran statement (keyword) or a simple
  !  variable.
  !-----------------------------------------------------------------------
  character(len=*)     :: line  !
  integer              :: nl    !
  character(len=*)     :: key   !
  logical, intent(out) :: akey  !
  ! Global
  logical :: lexpr
  integer :: lenc
  ! Local
  integer :: ni,i,level,nk,ik
  character(len=12) :: label
  !
  akey = .false.
  nk = lenc(key)
  !
  ik = index(line,key)
  level = 0
  !
  ! BYTE declaration
  if (key.eq.'BYTE') then
    do i=ik+4,nl
      if (line(i:i).eq.'=') return
    enddo
  !
  ! IF or ELSEIF Statement
  elseif (key.eq.'ELSEIF') then
    akey = lexpr(line(ik+6:nl),nl-ik-1)
  elseif (key.eq.'IF') then
    akey = lexpr(line(ik+2:nl),nl-ik-1)
  !
  ! DO Statement
  elseif (key.eq.'DO') then
    ni = 0
    do i=ik+2,nl
      if (line(i:i).eq.'=') then
        ni = i
        goto 20
        ! Check this is a DO WHILE  (Expression), and not DOWHILE(I) = 3
      elseif (line(i:i).eq.'(') then
        if (index(line(1:i),'WHILE').ne.0) then
          akey = lexpr(line(i:nl),nl-i+1)
        endif
        return
        ! Assume loop index is not a structure element...
      elseif (line(i:i).eq.'.') then
        return
      endif
    enddo
    !
    20 continue
    if (ni.eq.0) return        ! Must be DOUBLE PRECISION Something...
    !
    ! Now count parenthesis level, and search for comma at zero level
    ! if one is found, this is a DO statement.
    i = ni+1
    do while (i.le.nl)
      if (line(i:i).eq.'(') then
        level = level+1
      elseif (line(i:i).eq.')') then
        level = level-1
      elseif (level.eq.0) then
        if (line(i:i).eq.',') then
          akey = .true.
          goto 30
        endif
      endif
      i = i+1
    enddo
    !
    30 continue
    if (akey) then
      ! Search for possible label, to locate Label CONTINUE for indentation
      ! later
      do i=ik+2,ni-1
        if (line(i:i).ne.' ' .and. line(i:i).lt.'0' .or. line(i:i).gt.'9') then
          if (i.eq.ik+2) return
          label = line(ik+2:i-1)
          if (lenc(label).ne.0) call set_label(label)
          return
        endif
      enddo
    endif
    return
  !
  ! END* statements
  elseif (key.eq.'END' .or. key.eq.'ENDDO' .or. key.eq.'ENDIF') then
    if (index (line,'=').ne.0) then
      akey = .false.
    else
      akey = .true.
    endif
  !
  ! OPEN statement
  elseif (key.eq.'OPEN') then
    ni = 0
    do i=ik+4,nl
      if (line(i:i).eq.'(') then
        ni = i
        goto 10
      elseif (line(i:i).eq.'=') then
        ! OPEN = something
        return
      elseif (line(i:i).eq.'.') then
        ! OPEN.field.subfield
        return
      endif
    enddo
    10 continue
    if (ni.eq.0) then
      write(stderr,*) 'Syntax error in statement'
      write(stderr,*) line(1:nl)
      return
    endif
    if (line(ik:ni-1).ne.'OPEN') then
      return
    endif
    !
    ! May be OPEN(I,J) = something
    level = 1
    ik = ni+1
    !
    ! Find closing parentheses
    do while (level.ne.0)
      if (ik.gt.nl) then
        write(stderr,*) 'OPEN : Unbalanced parentheses'
        write(stderr,*) line(1:nl)
        return
      endif
      if (line(ik:ik).eq.'(') then
        level = level+1
      elseif (line(ik:ik).eq.')') then
        level = level-1
      endif
      ik = ik+1
    enddo
    !
    ! Search for a possible = sign after it
    do i=ik,nl
      if (line(i:i).eq.'=') return
    enddo
    akey = .true.
    return
  !
  ! TYPE declaration
  elseif (key.eq.'TYPE') then
    akey = .false.
    do i=ik+4,nl
      if (line(i:i).eq.'*') return
      if (ichar(line(i:i)).ge.0 .and. ichar(line(i:i)).le.9) return
      if (line(i:i).eq.'(') return
      if (line(i:i).eq.'=') return
      if (line(i:i).ne.' ') then
        akey = .true.
        return
      endif
    enddo
  !
  ! BLOCK DATA routine
  elseif (key.eq.'BLOCK') then
    akey = .false.
    i = index(line,'DATA')
    if (i.eq.0) return
    if (line(ik+5:i-1).ne.' ') return
    !
    ik = i+4
    do i=ik,nl
      if (ichar(line(i:i)).ge.0 .and. ichar(line(i:i)).le.9) return
      if (line(i:i).eq.'(') return
      if (line(i:i).eq.'=') return
      if (line(i:i).ne.' ') then
        akey = .true.
        return
      endif
    enddo
  endif
end
!
function lexpr(line,nl)
  logical string,lexpr,begin
  integer nl,i
  character*(*) line
  character*1 quote, lp,ln
  data quote /''''/
  !
  string = .false.
  begin = .true.
  do i=1,nl
    if (begin) then
      if (line(i:i).eq.'(') then
        begin = .false.
      elseif (line(i:i).ne.' ') then
        lexpr = .false.
        return
      endif
    else
      if (string) then
        if (line(i:i).eq.quote) string = .false.
      elseif (line(i:i).eq.'=') then
        lp = line(i-1:i-1)
        ln = line(i+1:i+1)
        if (lp.ne.'<' .and. lp.ne.'/' .and. lp.ne.'=' .and.  &
            lp.ne.'>' .and. ln.ne.'=') then
          lexpr = .false.
          return
        endif
      elseif (line(i:i).eq.quote) then
        string = .true.
      endif
    endif
  enddo
  lexpr = .true.
end
!
subroutine load_processor
  use processor_variables
  !
  csuite = '&'
  w_comm = 42
  pinc = 'gbl_'
  lpinc = 4
  !
  ngood = 5
  goodsys(1) = 'IEEE'
  goodsys(2) = 'LINUX'
  goodsys(3) = 'UNIX'
  goodsys(4) = 'F77'
  goodsys(5) = 'MOTIF'
  lgsys(1) = 4
  lgsys(2) = 6
  lgsys(3) = 4
  lgsys(4) = 3
  lgsys(5) = 5
end
!
subroutine set_label (label)
  character*(*) label
  logical akey
  integer mdo
  parameter (mdo=100)
  integer ilabel,alabel(mdo),jlabel,i,k,ier
  save ilabel,alabel
  ! Data
  data ilabel/0/
  ! Code
  ilabel = ilabel+1
  read(label,*) alabel(ilabel)
  return
  !
  entry islabel(label,akey)
  read(label,*,iostat=ier) jlabel  !
  akey = .false.               !
  if (ier.ne.0) return         !
  do i=1,ilabel
    if (alabel(i).eq.jlabel) then
      akey = .true.
      do k=i+1,ilabel
        alabel(k-1) = alabel(k)
      enddo
      ilabel = ilabel-1
      return
    endif
  enddo
  akey = .false.
end
!
subroutine translate (code,lcode)
  use processor_variables
  character*(*) code
  integer lcode
  !
  character*1 quote
  character*80 chain
  integer i,j,l,lenc
  data quote /''''/
  !
  ! Check for commands that need special processing:
  ! DO ENDDO
  ! INTEGER*4, REAL*8, BYTE
  i = 1
  ! INCLUDE: expand file name
  if (code(i:i+6).eq.'INCLUDE') then
    ! Opening quote:
    i = i+index(code(i:),quote)-1
    ! Handle INC:
    l = index(code(i+1:),':')
    if (l.eq.0) then
      l = index(code(i+1:),'gbl_')
      if (l.ne.0) l = l+3
    endif
    if (l.ne.0) i=i+l
    ! Closing quote:
    j = index(code(i+1:),quote)
    if (j.eq.0) j = lcode+1
    j = i+j-1
    !
    ! Force lower case for include file name. Not necessarily a good idea in
    ! the long term, but usefull for conversion of old VMS code.
    call sic_lower (code(i+1:j))
    if (l.ne.0) then
      chain = pinc(1:lpinc)//code(i+1:j)
    else
      chain = code(i+1:j)
    endif
    if (index(chain,'$').ne.0) then
      ! write(stderr,*) 'Warning, system Include file '
      ! write(stderr,*) chain(1:lenc(chain))
    endif
    code = 'INCLUDE '//quote//chain(1:lenc(chain))//quote
    lcode = lenc(code)
    !
    ! ADDRESS Tag
  elseif (code(i:i+14).eq.'INTEGER(KIND=4)') then
    if (laddr.ne.0) then
      chain = '      '//address(1:laddr)//code(i+15:lcode)
      lcode = lcode+laddr-15
      code = chain(1:lcode)
    endif
    !
    ! ADDRESS Tag
  elseif (code(i:i+10).eq.'INTEGER*(4)') then
    if (laddr.ne.0) then
      chain = '      '//address(1:laddr)//code(i+11:lcode)
      lcode = lcode+laddr-11
      code = chain(1:lcode)
    endif
    !
    ! BYTE declarations
  elseif (do_byte) then
    if (code(i:i+3).eq.'BYTE') then
      chain = '      '//byte(1:lbyte)//code(i+4:lcode)
      lcode = lcode+lbyte-4
      code = chain(1:lcode)
    endif
  elseif (do_declar) then
    ! Non standard
    if (code(i:i+9).eq.'INTEGER*4 ') then
      chain = '      INTEGER '//code(i+10:lcode)
      lcode = lcode-2
      code = chain(1:lcode)
    elseif (code(i:i+6).eq.'REAL*4 ') then
      chain = '      REAL '//code(i+7:lcode)
      lcode = lcode-2
      code = chain(1:lcode)
    elseif (code(i:i+6).eq.'REAL*8 ') then
      chain = '      DOUBLEPRECISION '//code(i+7:lcode)
      lcode = lcode+9
      code = chain(1:lcode)
    endif
  endif
end
!
function lenc(c)
  !----------------------------------------------------------------------
  ! SIC	External routine : Integer function
  !
  !	Returns the location of the last SIGNIFICANT character in a
  !       string. Control characters and spaces are non significant...
  ! Arguments :
  !	C	C*(*)	Character string			Input
  !----------------------------------------------------------------------
  character*(*) c
  integer lenc
  integer i,lc
  !
  lc = len(c)
  do i=lc,1,-1
    if (c(i:i).gt.' ') then
      lenc = i
      return
    endif
  enddo
  lenc = 0
end
!
subroutine sic_upper(c)
  !----------------------------------------------------------------------
  ! SIC	External routine.
  !
  !	Converts a character string to uppercase.
  !	Slow if called frequently to convert a single character.
  ! Arguments :
  !	C	C*(*)	Character string			Input/Output
  !----------------------------------------------------------------------
  character *(*) c
  integer i,ic,lc
  !
  lc = len(c)
  do i=1,lc
    if (c(i:i).ge.'a' .and. c(i:i).le.'z') then
      ic=ichar(c(i:i))+ichar('A')-ichar('a')
      c(i:i)=char(ic)
    endif
  enddo
end
!
subroutine sic_lower(c)
  !----------------------------------------------------------------------
  ! SIC	External routine.
  !
  !	Converts a character string to LOWER CASE.
  !	Slow if called frequently to convert a single character.
  ! Arguments :
  !	C	C*(*)	Character string		Input/Output
  !----------------------------------------------------------------------
  character *(*) c
  integer i,ic,lc
  !
  lc = len(c)
  do i=1,lc
    if (c(i:i).ge.'A' .and. c(i:i).le.'Z') then
      ic=ichar(c(i:i))+ichar('a')-ichar('A')
      c(i:i)=char(ic)
    endif
  enddo
end
!
subroutine sic_white(c,n)
  !----------------------------------------------------------------------
  ! SIC	External routine
  !
  !	Character strings "abcd... " are not modified.
  !	Convert to upper case all characters.
  ! Arguments :
  !	C	C*(*)	Character string to be formatted	Input/Output
  !	N	I	Length of C				Input/Output
  !----------------------------------------------------------------------
  character*(*) c
  integer n
  !
  integer i,ic
  logical chaine
  character string*1
  save chaine, string
  data chaine/.false./
  data string/' '/
  !
  if (n.eq.0) return
  !
  do i=1,n
    !
    ! Skip character strings
    if (.not.chaine) then
      if (c(i:i).eq.'"') then
        chaine = .true.
        string = '"'
      elseif  (c(i:i).eq.'''') then
        chaine = .true.
        string = ''''
      else
        !
        ! Convert to lower case
        if (c(i:i).ge.'A' .and. c(i:i).le.'Z') then
          ic=ichar(c(i:i))+ichar('a')-ichar('A')
          c(i:i)=char(ic)
        endif
      endif
    else
      if (c(i:i).eq.string) chaine=.false.
    endif
  enddo
end
!
function lsign(chain,length)
  integer lsign, length
  character*(*) chain
  integer i
  !
  lsign = 0
  do i=1,length
    if (chain(i:i).ne.' ') then
      lsign = i
      return
    endif
  enddo
end

module gwcs_interfaces_private
  interface
    subroutine gwcs_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gwcs_message
  end interface
  !
  interface
    subroutine chgref(matrix, oldref, newref)
      !---------------------------------------------------------------------
      ! @ private
      ! Computes the coordinates of the reference direction in the new system
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: matrix(3,3)  ! Rotation matrix
      real(kind=8), intent(in)  :: oldref(2)    ! Old coordinates (radians)
      real(kind=8), intent(out) :: newref(2)    ! New coordinates (radians)
    end subroutine chgref
  end interface
  !
  interface
    subroutine chgoff(matrix,oldref,oldoff,newref,newoff)
      !---------------------------------------------------------------------
      ! @ private
      ! Compute offsets in the new system
      !------------------------------------------------------------------------
      real(kind=8), intent(in)  :: matrix(3,3)  ! Rotation matrix
      real(kind=8), intent(in)  :: oldref(2)    ! Old coordinates (radians)
      real(kind=4), intent(in)  :: oldoff(2)    ! Old offsets (radians)
      real(kind=8), intent(in)  :: newref(2)    ! New coordinates (radians)
      real(kind=4), intent(out) :: newoff(2)    ! New offsets (radians)
    end subroutine chgoff
  end interface
  !
  interface
    subroutine full_b1950_to_j2000(obs_epoch,lambda,beta,mu_alph,mu_delt,  &
      parallax,radvel)
      !---------------------------------------------------------------------
      ! @ private
      ! Convert Besselian coordinates to J2000.
      ! Implementation of the general formulas given in Aoki et al AA 128,
      ! 263 (1983), modified (not totally sure the modification is totally
      ! consistent, but the potentially remaining inconsistencies should be
      ! small for practical cases) to handle the case of a non-B1950 observing
      ! epoch.
      !
      ! NOT YET FINISHED, STILL RESTRICTED TO NO PM, NO PARALLAX, NO RV,
      ! BUT WORKS AS BEFORE IN THIS RESTRICTED CASE
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: obs_epoch  !
      real(kind=8), intent(inout) :: lambda     !
      real(kind=8), intent(inout) :: beta       !
      real(kind=8), intent(in)    :: mu_alph    !
      real(kind=8), intent(in)    :: mu_delt    !
      real(kind=8), intent(in)    :: parallax   !
      real(kind=8), intent(in)    :: radvel     !
    end subroutine full_b1950_to_j2000
  end interface
  !
  interface
    subroutine rel_to_abs_sfl(proj,x,y,a,d,n)
      use phys_const
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ private
      ! SFL: see Calabretta and Greisen 2002
      !
      ! Their general idea, as described in section 2, is that
      ! 1) you convert from (x,y) projected coordinates to the "native"
      !    absolute spherical coordinate: (x,y) are converted to
      !    (phi,theta).
      ! 2) you rotate the absolute native coordinates (phi,theta) to
      !    absolute celestial coordinates (alpha,delta) (Euler rotation of
      !    the native sphere).
      ! => those 2 steps are grouped in Eq. 2, 8, 9, 10.
      !
      ! In the context of SFL, these equations can be simplified. As per
      ! section 5.3, SFL projection is a pseudo-spherical projection with
      ! coordinates of the reference point (phi_0,theta_0) = (0,0). Also,
      ! (phi,theta) are defined in Eq. 92, 93 for SFL projection.
      !---------------------------------------------------------------------
      type(projection_t), intent(in)  :: proj  ! Description of projection
      real(kind=8),       intent(in)  :: x(*)  ! Array of offsets in X
      real(kind=8),       intent(in)  :: y(*)  ! Array of offsets in Y
      real(kind=8),       intent(out) :: a(*)  ! Array of R.A. (radians)
      real(kind=8),       intent(out) :: d(*)  ! Array of declinations
      integer(kind=8),    intent(in)  :: n     ! Size of arrays
    end subroutine rel_to_abs_sfl
  end interface
  !
  interface
    subroutine abs_to_rel_sfl(proj,a,d,x,y,n)
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ private
      ! SFL: see Calabretta and Greisen 2002
      !
      ! See comments in rel_to_abs_sfl
      !---------------------------------------------------------------------
      type(projection_t), intent(in)  :: proj  ! Description of projection
      real(kind=8),       intent(in)  :: a(*)  ! Array of R.A. (radians)
      real(kind=8),       intent(in)  :: d(*)  ! Array of declinations
      real(kind=8),       intent(out) :: x(*)  ! Array of offsets in X
      real(kind=8),       intent(out) :: y(*)  ! Array of offsets in Y
      integer(kind=8),    intent(in)  :: n     ! Size of arrays
    end subroutine abs_to_rel_sfl
  end interface
  !
  interface
    function arcsin (x)
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real(kind=8) :: arcsin         !
      real(kind=8), intent(in) :: x  !
    end function arcsin
  end interface
  !
  interface
    function arccos (x)
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real(kind=8) :: arccos         !
      real(kind=8), intent(in) :: x  !
    end function arccos
  end interface
  !
  interface
    subroutine gwcs_observatory_internal(arg,lonlat,altitude,slimit,diam,found)
      !---------------------------------------------------------------------
      ! @ private
      !  Internal subroutine, do not call directly! Use generic API
      ! 'gwcs_observatory' to retrieve a known observatory parameters, or
      ! use 'gwcs_observatory_exists' to check if it is known here.
      ! ---
      !  Return the observatory parameters given its name, with a flag
      ! 'found' if it was found or not.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: arg        ! Telescope name
      real(kind=8),     intent(inout) :: lonlat(2)  !
      real(kind=8),     intent(inout) :: altitude   !
      real(kind=8),     intent(inout) :: slimit     !
      real(kind=4),     intent(inout) :: diam       !
      logical,          intent(out)   :: found      !
    end subroutine gwcs_observatory_internal
  end interface
  !
end module gwcs_interfaces_private

subroutine rstrip(line,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>rstrip
  use greg_kernel
  use greg_rg
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  !  Make a strip across the regular grid array
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Command line, updated in return
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='STRIP'
  character(len=1) :: code
  real(kind=8) :: x1,x2,y1,y2
  !
  ! Check if map is here
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%e,rname,'No map loaded')
    error = .true.
    return
    !
    ! Fill in arguments from command line
  elseif (sic_present(0,4)) then
    call sic_r8 (line,0,1,x1,.true.,error)
    if (error) return
    call sic_r8 (line,0,2,y1,.true.,error)
    if (error) return
    call sic_r8 (line,0,3,x2,.true.,error)
    if (error) return
    call sic_r8 (line,0,4,y2,.true.,error)
    if (error) return
  elseif (gtg_curs()) then
    !
    ! Insufficient arguments, call the cursor
    call greg_message(seve%i,rname,'Using the cursor.')
    call greg_message(seve%i,rname,'Type Q to abort, any other key to set '//  &
    'strip points')
    error = .true.
    call gr_curs(x1,y1,xcurse,ycurse,code)
    if (code.eq.'Q') return
    call gr_curs(x2,y2,xcurse,ycurse,code)
    if (code.eq.'Q') return
    error = .false.
  else
    !
    ! No cursor either
    call greg_message(seve%e,rname,'No cursor available')
    error = .true.
    return
  endif
  !
  call delete_xyz (.true.,error)
  if (error) return
  call more_xyz (max(rg%nx,rg%ny),error)
  if (error)  return
  call sloppy(x1,x2,y1,y2,rg%data,column_x,column_y,nxy,error)
  if (error) return
  call create_xyz(error)
  if (error)  return
  !
  write(line,100) x1,y1,x2,y2
  return
  !
100 format('STRIP',4(1x,1pg13.6))
end subroutine rstrip
!
subroutine sloppy(x1,x2,y1,y2,r,sample,value,nxy,error)
  use gbl_message
  use greg_interfaces, except_this=>sloppy
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Make a diagonal strip across the regular grid array
  !  The number of pixels is NX or NY, according to wether the slope is
  ! greater than NX/NY and interpolation in the non-sampled direction is
  ! made using a parabola fitting the 3 nearby points.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: x1,y1      ! Coordinates of one point on line
  real(kind=8),    intent(in)  :: x2,y2      ! Coordinates of another point on line
  real(kind=4),    intent(in)  :: r(*)       ! Array of map value
  real(kind=8),    intent(out) :: sample(*)  ! Array of coordinates to be filled
  real(kind=8),    intent(out) :: value(*)   ! Array of values to be filled
  integer(kind=4), intent(out) :: nxy        ! Number of samples filled
  logical,         intent(out) :: error      ! Logical error flag
  ! Local
  real(kind=8) :: dx,xx,tmp
  integer(kind=4) :: i,j,k,n,is
  real(kind=4) :: vx,vy1,vy2,vy3,a,b,x,y,xi1,xi2,yi1,yi2
  !
  ! Take care of strip along X axis
  error = .false.
  if (y2.eq.y1) then
    tmp = (y1-rg%yval)/rg%yinc + rg%yref
    n = idnint(tmp)
    if (n.gt.rg%ny .or. n.lt.1) goto 99
    dx = rg%xinc
    sample(1) = rg%xval + (1.d0-rg%xref)*rg%xinc
    k = (n-1)*rg%nx+1
    value(1) = r(k)
    do i=2,rg%nx
      k = k+1
      value(i) = r(k)
      sample(i) = sample(i-1) + dx
    enddo
    nxy = rg%nx
    return
    !
    ! Take care of strip along Y axis
  elseif (x2.eq.x1) then
    tmp = (x1-rg%xval)/rg%xinc + rg%xref
    n = idnint(tmp)
    if (n.gt.rg%nx .or. n.lt.1) goto 99
    dx = rg%yinc
    sample(1) = rg%yval + (1.d0-rg%yref)*rg%yinc
    k = n
    value(1) = r(k)
    do i=2,rg%ny
      k = k+rg%nx
      value(i) = r(k)
      sample(i) = sample(i-1) + dx
    enddo
    nxy = rg%ny
    return
  endif
  !
  ! Get the line equation in map pixels
  yi1 = (y1-rg%yval)/rg%yinc+rg%yref
  yi2 = (y2-rg%yval)/rg%yinc+rg%yref
  xi1 = (x1-rg%xval)/rg%xinc+rg%xref
  xi2 = (x2-rg%xval)/rg%xinc+rg%xref
  a = (yi2-yi1)/(xi2-xi1)
  !
  if (abs(a).lt.1.0) then
    ! If slope is less than (NY-1)/(NX-1), use I pixels from 1 to NX
    ! with line equation Y = A*X+B
    b = yi1 - a*xi1
    dx = rg%xinc
    xx = -rg%xref*rg%xinc+rg%xval
    is = 0
    !
    do i=1,rg%nx
      y = a*i+b
      xx = xx+dx
      if (y.lt.1 .or. y.gt.rg%ny) cycle   ! I
      !
      ! Set the user coordinate
      is = is+1
      sample(is) = xx
      !
      ! Find nearest pixel J and interpolate between J-1, J and J+1
      j = nint(y)
      if (j.eq.1) then
        value(i) = r(i) + (r(rg%nx+i)-r(i))*(y-1)
      elseif (j.eq.rg%ny) then
        value(i) = r((rg%ny-1)*rg%nx+i) + (r((rg%ny-1)*rg%nx+i)-r((rg%ny-2)*rg%nx+i)) * (rg%ny-y)
      else
        k = (j-2)*rg%nx+i
        vy1 = r(k)
        k = k+rg%nx
        vy2 = r(k)
        k = k+rg%nx
        vy3 = r(k)
        vx = y-j
        value(is) = ( (vy1+vy3-2*vy2)*vx + vy3-vy1 )/2.*vx + vy2
      endif
    enddo
    !
  else
    ! If slope greater than (NY-1)/(NX-1), use J pixels from 1 to NY
    ! with line equation X = A*Y + B
    !
    a = 1./a
    b = xi1 - a*yi1
    dx = rg%yinc
    xx = -rg%yref*rg%yinc+rg%yval
    is = 0
    !
    do j=1,rg%ny
      xx = xx+dx
      x = a*j+b
      if (x.lt.1 .or. x.gt.rg%nx) cycle   ! J
      !
      ! Set the user coordinate
      is = is+1
      sample(is) = xx
      !
      ! Find nearest pixel I and interpolate between I-1, I and I+1
      i = nint(x)
      k = (j-1)*rg%nx+i
      if (i.eq.1) then
        value(j) = r(k) + (r(k+1)-r(k))*(x-1.)
      elseif (i.eq.rg%nx) then
        value(j) = r(k) + (r(k)-r(k-1)) * (float(rg%nx)-x)
      else
        vy1 = r(k-1)
        vy2 = r(k)
        vy3 = r(k+1)
        vx = x-i
        value(is) = ( (vy1+vy3-2*vy2)*vx + vy3-vy1 )/2.*vx + vy2
      endif
    enddo  ! J
  endif
  !
  if (is.ne.0) then
    nxy = is
    return
  endif
  !
99 call greg_message(seve%e,'STRIP','Outside map boundaries')
  error = .true.
end subroutine sloppy

subroutine alma_baseband(line,error)
  use gkernel_interfaces
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! PDBI internal routine, support for command
  !	BASEBAND i freq sideband
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  integer(kind=4) :: iband,n,nkey,nc,mkeys, firstbase, lastbase
  real(kind=4) :: cfreq, x4, y4, tmp, rffromif
  real(kind=8) :: xu, yu
  character(len=1) :: code
  character(len=3) :: qq
  character(len=13) :: rname
  !
  parameter(mkeys=2)
  character(len=3) :: key, keys(mkeys)
  character(len=128) :: chain
  ! Data
  data keys/'LSB','USB'/
  data rname /'ALMA_BASEBAND'/
  ! ---------------------------------------------------------------------------
  !
  n = sic_narg(0)
  if (n.gt.3) then
     call astro_message(seve%e,rname,'Wrong number of arguments')
     error = .true.
     return
  endif
  !
  if (n.eq.0) then
     !
     ! Command BASE alone means a loop on all four basebands
     !
     firstbase = 1
     lastbase = 4
     bb_def(:) = .false.  ! reset all basebands
  else
     !
     ! First argument is the baseband number
     !
     call sic_i4(line,0,1,iband,.false.,error)
     if ((iband.lt.1).or.(iband.gt.4)) then
        call astro_message(seve%e,rname,'Only four basebands')
        error =.true.
        return
     endif
     firstbase = iband
     lastbase = iband
     !
     ! Possibly switch to "plot baseband iband"
     !
     if (plot_mode.gt.10 .and. plot_mode.lt.15) then
        plot_mode = 10+iband
     endif
  endif
  !
  ! Loop on basebands
  !
  do iband = firstbase, lastbase
     !
     ! CURSOR option
     !
     if (n.le.1) then
        !
        ! plot_mode must be 10
        !
        if (plot_mode.ne.10) then
           plot_mode = 10
           call alma_plot_def(error)
           if (error) return
           call alma_plot_line
        endif
        !
        call gr_curs (xu, yu, x4, y4, code)
        if ((yu.ge.0).and.(yu.le.5)) then
           bb_sideband(iband) = 1
           key = 'USB'
        elseif ((yu.ge.7.75).and.(yu.le.12.75)) then
           bb_sideband(iband) = -1
           key = 'LSB'
        else
           call astro_message(seve%e,rname,'Please select LSB or USB')
           error =.true.
           return
        endif
        !
        if (bb_sideband(iband).eq.-1) then
           xu = iflim(2)-(xu-iflim(1)) ! LSB: IF limits are flipped on the plot
        endif
        if (xu.lt.(iflim(1)+1000)) then
           call astro_message(seve%w,rname,'Baseband must fit into IF band')
           xu = iflim(1)+1000
        elseif (xu.gt.(iflim(2)-1000)) then
           call astro_message(seve%w,rname,'Baseband must fit into IF band')
           xu = iflim(2)-1000
        endif
        bb_cfreq(iband) = xu
     else
        !
        ! No CURSOR (in that case the loop firstband/lastband is useless)
        !
        ! Central frequency
        !
        call sic_r4(line,0,2,cfreq,.false.,error)
        !
        if (cfreq.lt.1000) then
           !
           ! Defined in RF instead of IF?
           !
           cfreq = cfreq*1000.  ! in MHz
           call decoderf(cfreq, tmp, bb_sideband(iband))
           if ((tmp.lt.(iflim(1)+1000)).or.(tmp.gt.(iflim(2)-1000))) then
              call astro_message(seve%e,rname,'Baseband must fit into IF band')
!**!              error =.true.
!**!              return
           endif
           bb_cfreq(iband) = tmp
           key = "LSB"
           if (bb_sideband(iband).eq.1) key = "USB"
        else
           !
           ! Defined as IF, BAND
           if ((cfreq.lt.(iflim(1)+1000)).or.(cfreq.gt.(iflim(2)-1000))) then
              call astro_message(seve%e,rname,'Baseband must fit into IF band')
              error =.true.
              return
           endif
           bb_cfreq(iband) = cfreq
           !
           ! Sideband
           !
           call sic_ke(line,0,3,qq,nc,.false.,error)
           call sic_upper(qq)
           call sic_ambigs(rname,qq,key,nkey,keys,mkeys,error)
           if (error) return
           if (key.eq.'LSB') then
              bb_sideband(iband) = -1
           elseif (key.eq.'USB') then
              bb_sideband(iband) = 1
           endif
        endif
     endif
     !
     ! Check if this is possible
     !
     call check_basebands(iband, error)
     if (error) return
     bb_def(iband) = .true.
     !
     ! Reset spectral windows associated to that baseband
     ! NO - dont do it
     !  bb_nspw(iband) = 0
     !
     ! Output message
     !
     tmp = rffromif(bb_cfreq(iband),bb_sideband(iband))/1000.
     write(chain,1000) iband, bb_cfreq(iband), key
     call astro_message(seve%i,rname,chain)
     write(chain,1010) iband, tmp
     call astro_message(seve%i,rname,chain)
     !
     ! Now update the current plot
     !
     call alma_plot_line
     !
     ! End of loop on basebands
     !
  enddo
  !
  1000 format('BASEBAND ',i1,' is centered at IF1 = ',f8.2,' MHz (',a3,')')
  1010 format('BASEBAND ',i1,' is centered at RF = ',f10.5,' GHz')
end subroutine alma_baseband
!
subroutine check_basebands(iband, error)
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: iband  !
  logical, intent(out) :: error         !
  ! Local
  integer(kind=4) :: i, usb_count, lsb_count
  !
  error = .false.
  usb_count = 0
  lsb_count = 0
  do i = 1,4 ! Loop on basebands
    if (bb_def(i).or.(i.eq.iband)) then  ! bb_def(iband) not yet updated
        if (bb_sideband(i).eq.1) then
          usb_count = usb_count+1
        else
          lsb_count = lsb_count+1
        endif
    endif
  enddo
  if ((recband.ne.9).and.   &
      ((usb_count.eq.3 .and. lsb_count.eq.1)  &
      .or. (usb_count.eq.1 .and. lsb_count.eq.3) )) then
    call astro_message(seve%e,'ALMA_BASEBAND','Cannot have 3+1 basebands combination')
    error = .true.
  endif
end subroutine check_basebands

module astro_noema_type
  use astro_register_type ! register and all types from there
  !
  public
  !
  type noema_t
    ! Some global things
    type(receiver_source_t) :: source
    type(receiver_desc_t) :: recdesc
    ! Current FEBE configuration
    type(noema_febe_t) :: cfebe
    ! Register of saved febes
    type(noema_febe_register_t) :: register
    !
  end type noema_t
end module astro_noema_type

subroutine write_sdm_pointing(ndata, data, error)
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  !     Write the Pointing SDM table.
  ! now a single row per subscan.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_pointing
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  include 'gbl_pi.inc'
  INCLUDE 'clic_constant.inc'
  ! Dummy
  logical :: error
  integer(kind=data_length) :: ndata, h_offset
  integer :: data(ndata)
  ! Local
  type (PointingRow) :: pRow
  type (PointingKey) :: pKey
  type (PointingOpt) :: pOpt
  integer :: ia, ir, isw, k
  real*8 lat, trfm_24(3,3), x_2(3), ho(2)
  real*8 ::  x_6(3), s_2(2), s_6(2), trfm_62(3,3), psi, the,   &
       phi, radpersec
  character, parameter :: sdmTable*8 = 'Pointing'
  integer*8 :: pointingTime
  logical first
  data first/.true./
  save first
  save pointingTime
  data pointingTime /-1/

  !---------------------------------------------------------------------
  radpersec = pi/180d0/3600d0
  !
  ! ensure a minimal granularity of 48ms
  k = 1+ h_offset(r_ndump+1)
  call decode_header (data(k))
  !print *, dh_obs, dh_integ, dh_utc
  call get_time_interval
  !print *, 'pointing time_Interval ', time_Interval
!  if (time_Interval(1).ge.pointinTime+48000000) then
!    pKey%timeInterval = ArrayTimeInterval(time_Interval(1), -1)
!    pointingTime = time_Interval(1)
!  else
!    return
!  endif
  pKey%timeInterval = ArrayTimeInterval(time_Interval(1),time_Interval(2))
  !print *, 'pKey%timeInterval ', pKey%timeInterval
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! we do not use polynomials
  ! one sample is one PdB dump.cp  /diskb/ALMA_ACS8/ASDMImpl/ICD/HLA/
  pRow%numSample = r_ndump
  pRow%numTerm = r_ndump
  ! pRow%numPoly = 0
  !!   call allocPointingRow(pRow, pRow%numPoly, error)
  call allocPointingRow(pRow, error)
  if (error) return
  call allocPointingOpt(pRow, pOpt, error)
  if (error) return
  pRow%numTerm = 1

  
  !
  do ia = 1, r_nant
    ! OPTIONAL IN SS2 ...         pRow%name = r_sourc
    pRow%timeOrigin = time_Interval(1)
    ! loop on the dumps
    do ir=1, r_ndump
      k = 1+ h_offset(ir)
      call decode_header (data(k))
      if (error) return
      ! print *, dh_utc
      ! get the time interval from CLIC data_header.
      call get_time_interval
      pOpt%sampledTimeInterval(ir) = ArrayTimeInterval(time_Interval(1), &
           time_interval(2))

      if (r_nswitch.gt.0) then
        isw = dh_test0(1)
        dh_offlam = dh_offlam - r_pswitch(1,isw)
        dh_offlam = dh_offlam - r_pswitch(2,isw)
      endif

      !
      !     pRow%target is the source direction as seen from antenna
      !
      !     equatorial coordinates system
      !
      if (r_typec.eq.type_eq) then
        !     get it from dh_svec:
        !     dh_svec is the source vector in hour-angle, dec coordinates (4)
        !     n_4 is the normal to the source meridian plane
        !     TRFM_24 goes from (4) to (2)
        !     x_2 is the source vector in in horiz coords(2).
        !     lat is the latitude of antenna...
        lat = atan2(r_antgeo(3,ia), sqrt(r_antgeo(1,ia)**2   &
             +(r_antgeo(2,ia)**2)))
        psi = pi/2               ! 90 degrees
        the = pi/2-lat           ! 90 degrees minus latitude
        phi = -pi/2              ! -90 degrees
        call eulmat (psi, the, phi,trfm_24)
        call matvec (dh_svec, trfm_24, x_2)
        call spher(x_2, ho)
        ho(1) = mod(-ho(1)+3d0*pi,2d0*pi)
        ho(2) = mod(ho(2)+3d0*pi,2d0*pi)-pi
        !
        ! horizontal coordinates system
        !
      elseif (r_typec.eq.type_ho) then
        ho(1) = r_az
        ho(2) = r_el
        ho(1) = mod(ho(1)+3d0*pi,2d0*pi)
        ho(2) = mod(ho(2)+3d0*pi,2d0*pi)-pi
      elseif (r_typec.eq.type_un) then
        ! this must be old holo data from ATF, with reference to North?
        ho(1) = r_az
        ho(2) = r_el
        ho(1) = mod(ho(1)+3d0*pi,2d0*pi)-pi
        ho(2) = mod(ho(2)+3d0*pi,2d0*pi)-pi
      endif
      !print *, r_typec, type_eq, type_ho, type_un, ho
      ! use az reference to North...
      pRow%target(1,ir) = ho(1)
      pRow%target(2,ir) = ho(2)
      !
      ! Euler angles from  descriptive system to AzEl system:
      psi = pi/2.
      the = pRow%target(2,ir)
      phi = -pi/2 -pRow%target(1,ir)
      s_6(1) = dh_offlam(ia) * radpersec
      s_6(2) = dh_offbet(ia) * radpersec
      call rect(s_6, x_6)
      call eulmat (psi, the, phi, trfm_62)
      call matvec (x_6, trfm_62, x_2)
      call spher(x_2, s_2)
      pRow%pointingDirection(1,ir) = s_2(1)
      pRow%pointingDirection(2,ir) = s_2(2)

      pRow%offset(1,ir) = s_6(1)
      pRow%offset(2,ir) = s_6(2)
      !14712
      !     This is antenna measured pointing direction (add the errors back in)
      !
      pRow%encoder(1,ir) = pRow%pointingDirection(1,ir) + dh_rmspe(1,ia)   &
           * radpersec
      pRow%encoder(2,ir) = pRow%pointingDirection(2,ir) + dh_rmspe(2,ia)   &
           * radpersec
    enddo
    pRow%pointingTracking = .true.
    ! OPTIONAL IN SS2 ...            pRow%phaseTracking = .true.
    pKey%antennaId = antenna_Id(ia)
    !         pKey%timeInterval = ArrayTimeInterval(time_Interval(1), -1)
    pRow%pointingModelId = pointingModel_Id(ia)
    !print *, ' pKey%timeInterval ', pKey%timeInterval
    !print *, ' pKey%antennaId ', pKey%antennaId
    call addPointingRow(pKey, pRow, error)
    if (error) return
    if (first) then
      call addPointingSampledTimeInterval(pKey, pOpt, error)
      if (error) return
    endif
    first = .not.first
    
  enddo
  call sdmMessage(1,1,sdmTable,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_pointing
!---------------------------------------------------------------------
!!! subroutine get_sdm_pointing(first, error)
!!!   !---------------------------------------------------------------------
!!!   !     Read  the Pointing SDM table.
!!!   !
!!!   !---------------------------------------------------------------------
!!!   use gildas_def
!!!   use sdm_pointing
!!!   ! Global variables:
!!!   include 'clic_parameter.inc'
!!!   include 'clic_par.inc'
!!!   include 'clic_dheader.inc'
!!!   include 'sdm_identifiers.inc'
!!!   include 'gbl_pi.inc'
!!!   ! Dummy
!!!   logical error, first
!!!   ! Local
!!!   type (PointingRow) :: pRow
!!!   type (PointingKey) :: pKey
!!!   integer :: ia
!!!   integer, parameter :: mpoly = 10
!!!   real*8 ::  x_2(3), x_6(3), s_2(2), s_6(2), trfm_26(3,3), psi, the,   &
!!!     phi, radpersec, rad, slat, clat
!!!   character, parameter :: sdmTable*8 = 'Pointing'
!!!   !---------------------------------------------------------------------
!!!   call sdmMessage(1,1,sdmTable ,'starting...')
!!!  call allocPointingRow(pRow, mPoly, error)14961
!!!   pRow%numTerm = 1
!!!   call allocPointingRow(pRow, error)
!!!   if (error) return
!!!   radpersec = pi/180d0/3600d0
!!!   !
!!!   !      pKey%timeInterval = ArrayTimeInterval(time_Interval(1),-1)
!!!   pKey%timeInterval = ArrayTimeInterval(time_interval(1)+1   &
!!!     ,time_interval(2)-1)
!!!   do ia = 1, r_nant
!!!     pKey%antennaId = antenna_Id(ia)
!!!     !!print *, 'pKey%antennaId, pKey%timeInterval ', pKey%antennaId, pKey%timeInterval
!!!     call getPointingRow(pKey, pRow, error)
!!!     if (error) return
!!!     ! print *, pKey%timeInterval, pRow%numSample
!!!     ! OPTIONAL in SS2 ...          r_sourc = pRow%name
!!!     !
!!!     !     This is the source direction as seen from antenna
!!!     !     this is in the CLIC header, check only of first point.
!!!     r_az = pRow%target(1,1)
!!!     r_el = pRow%target(2,1)
!!!     ! print *, r_az, r_el
!!!     !
!!!     !     Compute offsets i.e. coordinates in the system of origin p%target.
!!!     !
!!!     psi = pi/2 + pRow%target(1,1)
!!!     the = - pRow%target(2,1)
!!!     phi = -pi/2.
!!!     s_2 = pRow%encoder(:,1)
!!!     call rect(s_2, x_2)
!!!     call eulmat (psi, the, phi, trfm_26)
!!!     call matvec (x_2, trfm_26, x_6)
!!!     call spher(x_6, s_6)
!!! !    dh_offlam(ia) = s_6(1) / radpersec
!!! !    dh_offbet(ia) = s_6(2) / radpersec
!!! ! not exactly ...
!!!     dh_offlam(ia) = pRow%offset(1,1) / radpersec
!!!     dh_offbet(ia) = pRow%offset(2,1) / radpersec
!!!     ! print *, dh_offlam, dh_offbet
!!!     !
!!!     !     These are the antenna tracking errors:
!!!    dh_rmspe(1,ia) = (pRow%encoder(1)-pRow%pointingDirection(1,1))   &
!!!      / radpersec
!!!    dh_rmspe(2,ia) = (pRow%encoder(2)-pRow%pointingDirection(2,1))   &
!!!      / radpersec
!!!     dh_rmspe(1,ia) = (pRow%encoder(1,1)-pRow%pointingDirection(1,1))   &
!!!       / radpersec
!!!     dh_rmspe(2,ia) = (pRow%encoder(2,1)-pRow%pointingDirection(2,1))   &
!!!       / radpersec
!!!     dh_offlam(ia) = dh_offlam(ia)+dh_rmspe(1,ia)
!!!     dh_offbet(ia) = dh_offbet(ia)+dh_rmspe(2,ia)
!!!     pointingModel_Id(ia) = pRow%pointingModelId
!!!     ! calculate source direction vector:
!!!     ! in horizontal:
!!!     dh_svec(1) = cos(pRow%target(1,1)) * cos(pRow%target(2,1))
!!!     dh_svec(2) = -sin(pRow%target(1,1)) * cos(pRow%target(2,1)) ! az backwards
!!!     dh_svec(3) = sin(pRow%target(2,1))
!!!     !in Bure hour-angle system : rotate pi around z:
!!!     dh_svec(1) = -dh_svec(1)
!!!     dh_svec(2) = -dh_svec(2)
!!!     ! print *, dh_svec
!!!     ! then lat around y
!!!     rad = sqrt(r_antgeo(1,ia)**2+r_antgeo(2,ia)**2+r_antgeo(3,ia)**2)
!!!     slat = asin(r_antgeo(3,ia)/rad)
!!!     clat = sqrt(1-slat**2)
!!!     dh_svec(1) =  slat * dh_svec(1) + clat * dh_svec(3)
!!!     dh_svec(3) = -slat * dh_svec(1) + slat * dh_svec(3)
!!!     ! print *, dh_svec
!!!   enddo
!!!   call sdmMessage(1,1,sdmTable ,'Read.')
!!!   return
!!!   !
!!! 99 error = .true.
!!! end
!---------------------------------------------------------------------
!---------------------------------------------------------------------
subroutine get_sdm_pointing(ndata, data, timeIntervalSubscan, &
     timeIntervalRecord, error)
  use gildas_def
  use gkernel_interfaces
  use sdm_pointing
  use sdm_types
  !---------------------------------------------------------------------
  !     Read data needed from the SDM table. 
  !     pRow is the row for the subscan...
  !---------------------------------------------------------------------
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  include 'gbl_pi.inc'
  ! Dummy
  logical :: error, isOutside
  integer :: ndata, data(ndata)
  type(ArrayTimeInterval) :: timeIntervalSubscan, splitTimeInterval
  type(ArrayTimeInterval) :: timeIntervalRecord(r_ndump)
  ! Local
  type(ArrayTimeInterval) :: tsplit 
  type (PointingRow) :: pRow
  type (PointingKey) :: pKey
  integer :: ia, ip, k, np, ip1, ip2, j, next, pSize, ir, ic, h_offset, ipm, i
  integer*8 :: t, tj, dt, adt, it
  character, parameter :: sdmTable*8 = 'Pointing'
  real*8 ::  x_2(3), x_6(3), s_2(2), s_6(2), trfm_26(3,3), psi, the,   &
    phi, radpersec, spdir(2), senc(2), soff(2), w, sw, minlam, maxlam, minbet, maxbet
  real*8::  target_Hack(2)
  logical:: first
  data first/.true./
  save target_Hack, first
  integer, parameter :: scan_lamb = 2, scan_beta = 3
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  pRow%numTerm = timeIntervalSubscan%interval / 48000000
  pRow%numSample = pRow%numTerm
  call allocPointingRow(pRow, error)
  if (error) return
  radpersec = pi/180d0/3600d0

  pKey%timeInterval = timeIntervalSubscan
  
  do ia = 1, r_nant
    pKey%antennaId = antenna_Id(ia)
    call getPointingRow(pKey, pRow, error)
    if (error) return
    ip = 1
    np = pRow%numSample
    minlam = 1e20
    minbet = 1e20
    maxlam = -1e20
    maxbet = -1e20
    do ir = 1, r_ndump
      k = 1 + h_offset(ir)
      call decode_header(data(k))
      r_mobil(ia) = .false.
      ip = mod(ip-1, np) + 1 
      ic = 1
      t = timeIntervalRecord(ir)%time
      do while (isOutside(t, splitTimeInterval(pKey%timeInterval, np, ip)) &
           .and. ic.le.np+1)
        ip = mod(ip, np) + 1
        ic = ic+1
      enddo
      ipm = 1
      if (ic.le.np+1) then
        if ( pKey%antennaId .eq. antenna_Id(ia)) then
          ipm = ip
        endif
      else
        
        call message(8,2,'Read_sdm','Times do not match')
      endif
      !
      ! interpolate with time neighbours
      !
      ip = ipm
      spdir = 0
      senc = 0
      soff = 0
      dt = pKey%timeInterval%interval/np
      !
      ! first try with nearest points
      next = 1
      do while (next.le.np .and. next.gt.0)
        sw = 0
        ip1 = max(1, ip-next)
        ip2 = min(ip+next, np)
        do j= ip1, ip2
          tsplit = splitTimeInterval(pKey%timeInterval, np, j)
          tj = tsplit%time
          adt = abs(t-tj)
          w = 0
          if (pRow%encoder(1,j).ne.0 .or. pRow%encoder(2,j).ne.0) then
            w = max(0,next*dt-adt)
            spdir(1) = spdir(1)+ pRow%pointingDirection(1,j)*w
            spdir(2) = spdir(2)+ pRow%pointingDirection(2,j)*w
            senc(1) = senc(1)+ pRow%encoder(1,j)*w
            senc(2) = senc(2)+ pRow%encoder(2,j)*w
            soff(1) = soff(1)+ pRow%offset(1,j)*w
            soff(2) = soff(2)+ pRow%offset(2,j)*w
          endif
          sw = sw+ w
        enddo
        if (sw.gt.0) then
          spdir(1) = spdir(1)/ sw
          spdir(2) = spdir(2)/ sw
          senc(1) = senc(1)/ sw
          senc(2) = senc(2)/ sw
          soff(1) = soff(1)/ sw
          soff(2) = soff(2)/ sw
          next = -1              ! done
        else
          next=next*2
        endif
        
      enddo
      it = (ip-1) * dt !
      ! T10 time in seconds in subscan
      dh_test1(1,ia) = 1d-9*it
      ! T11, T12: encoders (radians)
      dh_test1(2,ia) =pRow%encoder(1,ip)
      dh_test1(3,ia) =pRow%encoder(2,ip)
      ! T13, T14 : trackinf errors in arc seconds
      dh_test1(4,ia) =(pRow%encoder(1,ip)-pRow%pointingDirection(1,ip))   &
           /pi*180.*3600.
      dh_test1(5,ia) =(pRow%encoder(2,ip)-pRow%pointingDirection(2,ip))   &
           /pi*180.*3600.
      !
      !     This is the source direction as seen from antenna
      !     Keep for the CLIC Header
      r_az = pRow%target(1,1)
      r_el = pRow%target(2,1)
      !
      !     Compute offsets i.e. in the system of origin p%target.
      !
      psi = pi/2 + pRow%target(1,ip)
      the = - pRow%target(2,ip)
      phi = -pi/2.
      s_2 = senc
      call rect(s_2, x_2)
      call eulmat (psi, the, phi, trfm_26)
      call matvec (x_2, trfm_26, x_6)
      call spher(x_6, s_6)
      !dh_offlam(ia) = s_6(1)/ radpersec
      !dh_offbet(ia) = s_6(2)/ radpersec
      ! use the offset column 
      dh_offlam(ia) = soff(1)/ radpersec
      dh_offbet(ia) = soff(2)/ radpersec
      !
      !     These are the antenna tracking errors:
      do k=1, 2
        dh_rmspe(k,ia) = (senc(k)-spdir(k)) / radpersec
      enddo
      ! Do not read the pointingModelId for now.
      !         pointingModel_Id(ia) = p%pointingModelId
      !
      ! scanning stuff
!!!       minlam = min(minlam,dh_offlam(ia)*pi/180./3600.)
!!!       maxlam = max(maxlam,dh_offlam(ia)*pi/180./3600.)
!!!       minbet = min(minbet,dh_offbet(ia)*pi/180./3600.)
!!!       maxbet = max(maxbet,dh_offbet(ia)*pi/180./3600.)
      k = 1 + h_offset(ir)
      call encode_header(data(k))
    enddo

!    if (maxlam-minlam.gt.0.1*pi/180./3600.) then
!      r_mobil(ia) = .true.
!      if (r_scaty.le.3) r_scaty = scan_lamb
!    endif
!    if (maxbet-minbet.gt.0.1*pi/180./3600.) then
!      r_mobil(ia) = .true.
!      if (r_scaty.le.3) r_scaty = scan_beta
!    endif
    
  enddo
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_pointing
!---------------------------------------------------------------------
subroutine get_sdm_pointingHoloData(ndata, data, timeIntervalSubscan, timeIntervalRecord, error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     Read data needed from the SDM table. 
  !     pRow is the row for the subscan...
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_pointing
  use sdm_types 
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  include 'gbl_pi.inc'
  ! Dummy
  logical :: error, isOutside
  integer :: ndata, data(ndata)
  type(ArrayTimeInterval) :: timeIntervalSubscan, splitTimeInterval
  type(ArrayTimeInterval) :: timeIntervalRecord(r_ndump)
  ! Local
  type(ArrayTimeInterval) :: tsplit 
  type (PointingRow) :: pRow
  type (PointingKey) :: pKey
  integer :: ia, ip, k, np, ip1, ip2, j, next, pSize, ir, ic, h_offset, ipm, i
  integer*8 :: t, tj, dt, adt, it
  character, parameter :: sdmTable*8 = 'Pointing'
  real*8 ::  x_2(3), x_6(3), s_2(2), s_6(2), trfm_26(3,3), psi, the,   &
    phi, radpersec, spdir(2), senc(2), soff(2), w, sw, minlam, maxlam, minbet, maxbet
  real*8::  target_Hack(2)
  logical:: first
  data first/.true./
  save target_Hack, first
  integer, parameter :: scan_lamb = 2, scan_beta = 3
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  pRow%numTerm = timeIntervalSubscan%interval / 48000000
  pRow%numSample = pRow%numTerm
  !print *, 'pRow%numTerm ', pRow%numTerm
  call allocPointingRow(pRow, error)
  if (error) return
  radpersec = pi/180d0/3600d0

  !np = size(p%target,3)
  !t = time_interval(1)
  !      print *, 'np ',np
  pKey%timeInterval = timeIntervalSubscan
  
  do ia = 1, r_nant
    pKey%antennaId = antenna_Id(ia)
    !print *, 'pKey%antennaId, pKey%timeInterval ', pKey%antennaId, pKey%timeInterval
    ! TEMPORARY HOLO PATCH 
    !! REMOVE !! pKey%timeInterval%time = pKey%timeInterval%time+6000000
    !print *, 'pKey%antennaId, pKey%timeInterval ', pKey%antennaId, pKey%timeInterval
    call getPointingRow(pKey, pRow, error)
    if (error) return

    if (first) then
      target_Hack(1) = pRow%target(1,1)
      target_Hack(2) = pRow%target(2,1)
      first = .false.
    endif

    !! print *, 'pKey%antennaId, pKey%timeInterval ', pKey%antennaId, pKey%timeInterval
    ip = 1
    np = pRow%numSample
    !!print *, ' pRow%numSample ', pRow%numSample

!! REMOVE HACK !! 
!!    do  i =1, np
!!      pRow%target(1,i)=target_Hack(1)
!!      pRow%target(2,i)=target_Hack(2)
!!    enddo
!! REMOVE HACK !! 
      !!print *, '=== ', pRow%target

    minlam = 1e20
    minbet = 1e20
    maxlam = -1e20
    maxbet = -1e20
    do ir = 1, r_ndump
      k = 1 + h_offset(ir)
      call decode_header(data(k))
      r_mobil(ia) = .false.
      ip = mod(ip-1, np) + 1 
      ic = 1
      t = timeIntervalRecord(ir)%time
      !do while (isOutside(time, pRow%timeInterval(ip)) .and.   &
      !print *, 'ir, t, pKey%timeInterval%time'
      !print *, ir, t, pKey%timeInterval%time
      do while (isOutside(t, splitTimeInterval(pKey%timeInterval, np, ip)) .and.   &
           ic.le.np+1)
        ip = mod(ip, np) + 1
        ic = ic+1
      enddo
      ipm = 1
      if (ic.le.np+1) then
        if ( pKey%antennaId .eq. antenna_Id(ia)) then
          ipm = ip
          !print *, 'ir, time, split, ipm ', ir, time,  splitTimeInterval(pKey%timeInterval, np, ipm), ipm
        endif
      else
        !print *, 'ir, t, np, ip, ic'
        !print *, ir, t, np, ip, ic
        
        call message(8,2,'Read_sdm','Times do not match')
!!!       print *, ip, p%timeInterval(1)%time, p%timeInterval(np   &
!!!         )%time, p%timeInterval(1)%time + p%timeInterval(np   &
!!!         )%interval
      endif
      !
      ! interpolate with time neighbours
      !
      !print *, 'ir, ipm ',ir, ipm
      ip = ipm
      spdir = 0
      senc = 0
      soff = 0
      !dt = pRow%timeInterval(1)%interval
      dt = pKey%timeInterval%interval/np
      !if (ip.le.10) print *, '= ip, ip1, ip2, dt ', ip, ip1, ip2, dt
      !if (ip.le.30) print *, '= ip, encoder, pointingDir, target ', ip, pRow%encoder(1,ip), pRow%pointingDirection(1,ip), &
      !     pRow%target(1,ip)
      !if (ip.le.30) print *, '= ip, encoder, pointingDir, target ', ip, pRow%encoder(2,ip), pRow%pointingDirection(2,ip), &
      !     pRow%target(2,ip)
      
      ! first try with nearest points
      next = 1
      do while (next.le.np .and. next.gt.0)
        sw = 0
        ip1 = max(1, ip-next)
        ip2 = min(ip+next, np)
        do j= ip1, ip2
          !tj = pRow%timeInterval(j)%time
          tsplit = splitTimeInterval(pKey%timeInterval, np, j)
          tj = tsplit%time
          adt = abs(t-tj)
          w = 0
          if (pRow%encoder(1,j).ne.0 .or. pRow%encoder(2,j).ne.0) then
            w = max(0,next*dt-adt)
            spdir(1) = spdir(1)+ pRow%pointingDirection(1,j)*w
            spdir(2) = spdir(2)+ pRow%pointingDirection(2,j)*w
            senc(1) = senc(1)+ pRow%encoder(1,j)*w
            senc(2) = senc(2)+ pRow%encoder(2,j)*w
            soff(1) = soff(1)+ pRow%offset(1,j)*w
            soff(2) = soff(2)+ pRow%offset(2,j)*w
          endif
          sw = sw+ w
          !if (ip.le.10) print *, '==  j, adt, w ', j, adt, w
        enddo
        if (sw.gt.0) then
          spdir(1) = spdir(1)/ sw
          spdir(2) = spdir(2)/ sw
          senc(1) = senc(1)/ sw
          senc(2) = senc(2)/ sw
          soff(1) = soff(1)/ sw
          soff(2) = soff(2)/ sw
          next = -1              ! done
        else
          !c               next = next+1
          next=next*2
          ! if (ip.le.10) print *, 'ip, next ', ip, next
        endif
        
      enddo
      it = (ip-1) * dt ! pKey%timeInterval(ip)%time-pKey%timeInterval(1)%time
      ! T10 time in seconds in subscan
      dh_test1(1,ia) = 1d-9*it
      ! T11, T12: encoders (radians)
      dh_test1(2,ia) =pRow%encoder(1,ip)
      dh_test1(3,ia) =pRow%encoder(2,ip)
      !print *, dh_test1(1,ia), dh_test1(2,ia), dh_test1(3,ia)
      !print *, ip, pRow%encoder(1,ip), pRow%encoder(2,ip)
      ! T13, T14 : trackinf errors in arc seconds
      dh_test1(4,ia) =(pRow%encoder(1,ip)-pRow%pointingDirection(1,ip))   &
           /pi*180.*3600.
      dh_test1(5,ia) =(pRow%encoder(2,ip)-pRow%pointingDirection(2,ip))   &
           /pi*180.*3600.
      !
      ! print *, ip, pRow%target(1,ip), pRow%target(2,ip)
      ! + PATCH
      ! take the target to be the first PointingDirection !!!
      !pRow%target(1,1) = pRow%pointingDirection(1,1)
      !pRow%target(2,1) = pRow%pointingDirection(2,1)
      ! take  the first point assumed to be the reference position
      !pRow%target(1,ip) = pRow%target(1,1)
      !pRow%target(2,ip) = pRow%target(2,1)
      ! - PATCH
      !
      !     This is the source direction as seen from antenna
      !     Keep for the CLIC Header
      r_az = pRow%target(1,1)
      r_el = pRow%target(2,1)
      !if (ip.le.10) print *, ir, senc, spdir, r_az, r_el 
      !
      !     Compute offsets i.e. in the system of origin p%target.
      !
      psi = pi/2 + pRow%target(1,ip)
      the = - pRow%target(2,ip)
      phi = -pi/2.
      !         s_2 = (/ p%encoder(1,ip), p%encoder(2,ip)/)
      s_2 = senc
      call rect(s_2, x_2)
      call eulmat (psi, the, phi, trfm_26)
      call matvec (x_2, trfm_26, x_6)
      call spher(x_6, s_6)
      dh_offlam(ia) = s_6(1)/ radpersec
      dh_offbet(ia) = s_6(2)/ radpersec
      !! if (ip.le.10) print *, ir, dh_offlam(ia), dh_offbet(ia)
      ! use the offset column 
      !!dh_offlam(ia) = soff(1)/ radpersec
      !!dh_offbet(ia) = soff(2)/ radpersec
      !if (ip.le.10) print *, ir, senc, spdir, soff, dh_offlam(ia), dh_offbet(ia)
      !
      !     These are the antenna tracking errors:
      !$$$         dh_rmspe(1,ia) = (p%encoder(1,ip)-p%pointingDirection(1,1,ip))
      !$$$     &        / radpersec
      !$$$         dh_rmspe(2,ia) = (p%encoder(2,ip)-p%pointingDirection(2,1,ip))
      !$$$     &        / radpersec
      do k=1, 2
        dh_rmspe(k,ia) = (senc(k)-spdir(k)) / radpersec
      enddo
      ! Do not read the pointingModelId for now.
      !         pointingModel_Id(ia) = p%pointingModelId
      !
      ! scanning stuff
      minlam = min(minlam,dh_offlam(ia)*pi/180./3600.)
      maxlam = max(maxlam,dh_offlam(ia)*pi/180./3600.)
      minbet = min(minbet,dh_offbet(ia)*pi/180./3600.)
      maxbet = max(maxbet,dh_offbet(ia)*pi/180./3600.)
      k = 1 + h_offset(ir)
      call encode_header(data(k))
    enddo

    if (maxlam-minlam.gt.0.1*pi/180./3600.) then
      r_mobil(ia) = .true.
      if (r_scaty.le.3) r_scaty = scan_lamb
    endif
    if (maxbet-minbet.gt.0.1*pi/180./3600.) then
      r_mobil(ia) = .true.
      if (r_scaty.le.3) r_scaty = scan_beta
    endif
    
  enddo
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_pointingHoloData
!--------------------------------------------------------------------
logical function isOutside(time, timeInterval)
  use sdm_types
  integer*8 :: time, t2
  type(ArrayTimeInterval) :: timeInterval
  !
  isOutside = .false.
  if (time.lt.timeInterval%time) then
    isOutside = .true.
    return
  !
  ! makes sure this work for the last interval (may be not always...)
  elseif (time.ge.timeInterval%time) then
    t2 = time - timeInterval%time
    !$$$         if (timeInterval%interval.gt.24000000) print *, t2,
    !$$$     &        timeInterval%interval
    if (t2.gt.timeInterval%interval) then
      isOutside = .true.
      return
    endif
  endif
end function isOutside
!
function splitTimeInterval(timeInterval, n, i)
  use sdm_types
  integer :: n, i
  type(ArrayTimeInterval) :: timeInterval, splitTimeInterval
  integer*8 :: time, interval
  !
  interval = timeInterval%interval / n
  time = timeInterval%time + (i-1)*interval 
  splitTimeInterval = ArrayTimeInterval(time, interval)
end function splitTimeInterval

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_remove_tool
  use gkernel_interfaces
  use cubedag_messaging
  use cubedag_parameters
  use cubedag_node_class
  use cubedag_tuple
  use cubedag_type_type
  !
  public :: noderm
  private
  !
  type :: cubedag_remove_tool_t
  contains
    procedure, nopass, public :: destroy => cubedag_node_destroy
    procedure, nopass, public :: remove  => cubedag_node_remove
  end type cubedag_remove_tool_t
  type(cubedag_remove_tool_t) :: noderm
  !
contains
  !
  subroutine cubedag_node_destroy(object,error)
    !-------------------------------------------------------------------
    ! Brute force destruction of a node object. Do not worry about
    ! family links between nodes.
    ! The object is a pointer which is expected to be deallocated and
    ! nullified in return.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer       :: object
    logical,                      intent(inout) :: error
    !
    integer(kind=4) :: ivar
    character(len=*), parameter :: rname='NODE>DESTROY'
    !
    do ivar=1,object%node%nuservar
      ! As of today, on the command OLDLOAD creates user variables
      ! pointing to the actual cube data. This is likely to disappear
      ! when OLDLOAD is rewritten.
      call cubedag_message(seve%w,rname,'Removing variable '//  &
        trim(object%node%uservar(ivar))//' pointing to destroyed node')
      call sic_delvariable(object%node%uservar(ivar),.false.,error)
      if (error)  error = .false.
    enddo
    !
    ! Clean the object contents (common part). The polymorphic part
    ! must be cleaned by the specific deallocation subroutine invoked
    ! below
    call object%final(error)
    if (error)  continue
    !
    ! Deallocate the object in memory
    call nodetype%deallocate(object,error)
    if (error)  return
  end subroutine cubedag_node_destroy
  !
  subroutine cubedag_node_remove(object,error)
    use cubelist_types
    !-------------------------------------------------------------------
    ! Proper removal of a node object, taking care of the family links
    ! between the other nodes
    ! The object is a pointer which is expected to be deallocated and
    ! nullified in return.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer       :: object
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='REMOVE'
    integer(kind=entr_k) :: irel
    class(cubedag_node_object_t), pointer :: relative
    class(list_object_t), pointer :: tot
    !
    if (object%node%links%children%n.gt.0) then
      call cubedag_message(seve%e,rname,'Node has one or more children')
      error = .true.
      return
    endif
    !
    ! Clean twins
    do irel=1,object%node%links%twins%n
      relative => cubedag_node_ptr(object%node%links%twins%list(irel)%p,error)
      if (error)  return
      tot => object
      call relative%node%links%twins%dissociate(tot,error)
      if (error)  return
    enddo
    ! Clean parents
    do irel=1,object%node%links%parents%n
      relative => cubedag_node_ptr(object%node%links%parents%list(irel)%p,error)
      if (error)  return
      tot => object
      call relative%node%links%children%dissociate(tot,error)
      if (error)  return
    enddo
    !
    ! Clean files on disk, only for non-raw cubes!
    if (object%node%origin.ne.code_origin_imported) then
      call cubedag_tuple_rmfiles(object%node%tuple,error)
      if (error)  return
    endif
    !
    ! Now destroy it
    call noderm%destroy(object,error)
    if (error)  return
  end subroutine cubedag_node_remove
  !
end module cubedag_remove_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_rms
  use gbl_message
  !
  public :: uv_rms_comm
  private
  !
contains
  !
  subroutine uv_rms_comm(line,error)
    use gkernel_interfaces
    use image_def
    use file_buffers
    use uv_buffers
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(gildas) :: ouuvh
    real, pointer :: inuvd(:,:),ouuvd(:,:)
    integer(kind=4), parameter :: one=1
    character(len=*), parameter :: rname='UV>RMS>COMM'
    !
    ! Get information on input uv table
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data loaded')
      error = .true.
      return
    endif
    !
    ! Update the header of the output uv table
    call gildas_null(ouuvh,type='UVT')
    call gdf_copy_header(huv,ouuvh,error)
    ouuvh%gil%dim(2) = one
    ouuvh%gil%nvisi  = one
    !
    ! User feedback
    call map_message(seve%i,rname,'Computing visibility RMS spectrum')
    !
    ! Prepare appropriate array
    nullify(inuvd,ouuvd)
    call uv_find_buffers(rname,int(ouuvh%gil%dim(1),kind=4),int(ouuvh%gil%dim(2),kind=4),inuvd,ouuvd,error)
    if (error) return
    !
    ! Actually rms
    call uv_rms_data(huv,inuvd,ouuvh,ouuvd,error)
    if (error) return
    !
    ! Everything went fine => copy output header in global buffer that contains input header up to now
    call gdf_copy_header(ouuvh,huv,error)
    ! Set global UV pointer to the output data and free the input data
    call uv_clean_buffers(inuvd,ouuvd,error)
    if (error) return
    ! UV data not plotted
    if (allocated(uvtb%data)) deallocate(uvtb%data)
    uv_plotted = .false.
    ! Indicate optimization and save status
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
    ! Recompute weight
    do_weig = .true.
    !
    ! Redefine SIC variables 
    call sic_delvariable('UV',.false.,error)
    call sic_mapgildas('UV',huv,error,duv) 
  end subroutine uv_rms_comm
  !
  subroutine uv_rms_data(inuvh,inuvd,ouuvh,ouuvd,error)
    use gkernel_interfaces
    use gbl_message
    use image_def
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(gildas),         intent(in)    :: inuvh
    real(kind=4), target, intent(in)    :: inuvd(:,:)
    type(gildas),         intent(in)    :: ouuvh
    real(kind=4), target, intent(inout) :: ouuvd(:,:)
    logical,              intent(inout) :: error
    !
    real(kind=4), allocatable :: mean(:,:)
    integer(kind=4) :: ier
    integer(kind=4) :: ic,nc,ncol
    integer(kind=4) :: iv,nv
    integer(kind=4), parameter :: one=1
    character(len=*), parameter :: rname='UV>RMS>DATA'
    !
    call map_message(seve%t,rname,'Welcome')
    !
    ncol = inuvh%gil%dim(1)
    nv = inuvh%gil%dim(2)
    nc = inuvh%gil%nchan
    !
    if (nv.gt.1) then
       allocate(mean(ncol,one),stat=ier)
       if (failed_allocate(rname,'mean visibility',ier,error)) return
       !
       ! Sum visilibities
       mean(:,one) = 0.0
       do iv=1,nv
          do ic=1,nc
             ! Real part
             mean(5+3*ic,one) = mean(5+3*ic,one) + inuvd(5+3*ic,iv)
             ! Imaginary part
             mean(6+3*ic,one) = mean(6+3*ic,one) + inuvd(6+3*ic,iv)
             ! Weight
             mean(7+3*ic,one) = mean(7+3*ic,one) + inuvd(7+3*ic,iv)
          enddo ! ic
       enddo ! iv
       ! Normalize the result
       do ic=1,nc
          mean(5+3*ic,one) = mean(5+3*ic,one)/nv
          mean(6+3*ic,one) = mean(6+3*ic,one)/nv
       enddo ! ic
       !
       ouuvd(:,one) = 0.0
       do iv=1,nv
          do ic=1,nc
             ! Real part
             ouuvd(5+3*ic,one) = ouuvd(5+3*ic,one) + (inuvd(5+3*ic,iv)-mean(5+3*ic,one))**2
             ! Imaginary part
             ouuvd(6+3*ic,one) = ouuvd(6+3*ic,one) + (inuvd(6+3*ic,iv)-mean(6+3*ic,one))**2
             ! Weight
             ouuvd(7+3*ic,one) = ouuvd(7+3*ic,one) + (inuvd(7+3*ic,iv)-mean(7+3*ic,one))**2
          enddo ! ic
       enddo ! iv
       ! Normalize the result
       do ic=1,nc
          ouuvd(5+3*ic,one) = sqrt(ouuvd(5+3*ic,one))/(nv-1)
          ouuvd(6+3*ic,one) = sqrt(ouuvd(6+3*ic,one))/(nv-1)
          ouuvd(7+3*ic,one) = sqrt(ouuvd(7+3*ic,one))/(nv-1)
       enddo ! ic
    else
       call map_message(seve%w,rname,'Only one visibility => RMS set to 0!')
       ouuvd(:,one) = 0
    endif
  end subroutine uv_rms_data
end module uv_rms
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module hershey_symb
  !
  integer :: nc1,nc2
  !
  integer, parameter :: maxbuf=27000
  integer :: buffer(maxbuf)
  !
  integer, parameter :: maxind=3000
  integer :: index(maxind)
  !
end module hershey_symb
!
subroutine hershey2gag(file)
  use gchar_dependencies_interfaces
  use gchar_interfaces, except_this=>hershey2gag
  use gchar_variables
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Build of the GREG character set from the HERSHEY one
  !
  ! Organisation :
  !	2 Quality of characters
  !		1 FAST		2 DUPLEX
  !	3 Set of characters per quality
  !		1 ROMAN		2 GREEK		3 SCRIPT
  ! 	95 Characters per set
  !
  ! Addressing is based on the ASCII code of the character:
  ! INDEX = ICHAR(caractere) - ICHAR(' ') + 1 + 100*(NJEU-1) + 300*(NQUAL-1)
  !---------------------------------------------------------------------
  character(len=*) :: file          !
  ! Local
  character(len=*), parameter :: rname='HERSHEY'
  integer(kind=1) :: xy(400)
  integer :: n,j,k,l,nchar
  logical :: unused
  integer :: i(nkchar)
  character(len=4) :: sycode
  character(len=message_length) :: mess
  !
  ! Delete file if it already exists
  if (gag_inquire(file,lenc(file)).eq.0) call gag_delete(file)
  !
  ! Load the correspondance table
  call coresp(i)
  !
  ! Load HERSHEY font
  call bldfil
  !
  nchar = 0
  do j=1,nkchar
    call gsymxd(i(j),xy,n,unused)
    if (unused) then
      write(mess,*) j,i(j),' is not used'
      call gchar_message(seve%u,rname,mess)
      ladj(j) = 0
      radj(j) = 0
      pointe(j) = 0
      nstrok(j) = 0
    else
      ladj(j) = xy(4)
      radj(j) = xy(5)
      pointe(j) = nchar
      k = 0
      l = 6
      do while (xy(l+1).ne.-64)
        font(nchar+l-6) = xy(l)
        font(nchar+l-5) = xy(l+1)
        l = l+2
        k = k+1
      enddo
      nstrok(j) = k
      nchar = nchar + 2*k
    endif
  enddo
  !
  write (mess,*) nchar,' bytes used'
  call gchar_message(seve%d,rname,mess)
  !
  ! Write binary stuff
  call gdf_getcod(sycode)
  call chtoby(sycode,vstrsh1,4)
  call suwrit(file,vstrsh1,nkpage)
  !
end subroutine hershey2gag
!
subroutine gsymxd(number,xygrid,nstrok,unused)
  use gchar_interfaces, except_this=>gsymxd
  use hershey_symb
  !---------------------------------------------------------------------
  ! @ private
  ! GRPCKG (internal routine):
  !	Return the digitization coordinates of a character. Each
  !	character is built up on a grid with X and Y coordinates
  !	in the range (-49,49), with the origin (0,0) at the center
  !	of the character.  The coordinate system is right-handed,
  !	with X positive to the right, and Y positive upward.
  !	Characters are drawn with their tops upward, towards
  !	positive Y values.
  !
  ! Arguments:
  ! 	NUMBER 	I	symbol number in range (1..3000).	Input
  ! 	XYGRID 	L*1(*)	Height range, width range, and pairs	Output
  !			of (X,Y) coordinates returned.
  !			Height range = (XYGRID(1),XYGRID(3)).
  !			Width range = (XYGRID(4),XYGRID(5)).
  !			(X,Y) = (XYGRID(K),XYGRID(K+1)) (K=6,8,...).
  !	NSTROK	I	Number of strokes			Output
  ! 	UNUSED	L	Set to .TRUE. if NUMBER is an unused 	Output
  !			symbol number. A character of normal
  !			height and zero width is returned.
  !			Set to .FALSE. if NUMBER is a valid
  !			symbol number.
  !
  !	The height range consists of 3 values: (minimum Y, baseline
  !	Y, maximum Y).  The first is reached by descenders on
  !	lower-case g, p, q, and y.  The second is the bottom of
  !	upper-case letters.  The third is the top of upper-case
  !	letters.  A coordinate pair (-64,0) requests a pen raise,
  !	and a pair (-64,-64) terminates the coordinate list.  It is
  !	assumed that movement to the first coordinate position will
  !	be done with the pen raised - no raise command is
  !	explicitly included to do this.
  !
  ! (7-Mar-1983)
  !---------------------------------------------------------------------
  integer :: number                 !
  integer(kind=1) :: xygrid(400)    !
  integer :: nstrok                 !
  logical :: unused                 !
  ! Local
  integer :: ix,iy,k,l,locbuf
  !
  ! Extract digitization.
  !
  if (number.lt.nc1 .or. number.gt.nc2) goto 3000
  l = number - nc1 + 1
  locbuf = index(l)
  if (locbuf .eq. 0) goto 3000
  xygrid(1) = buffer(locbuf)
  locbuf = locbuf + 1
  k = 2
  iy = -1
  !
10 continue
  ix = buffer(locbuf)/128
  iy = buffer(locbuf) - 128*ix - 64
  xygrid(k) = ix - 64
  xygrid(k+1) = iy
  k = k + 2
  locbuf = locbuf + 1
  if (iy.ne.-64) goto 10
  !
  unused = .false.
  nstrok = (k-6)/2
  return
  !
  !		Unimplemented character.
  !
3000 xygrid(1) = -16
  xygrid(2) =  -9
  xygrid(3) = +12
  xygrid(4) =   0
  xygrid(5) =   0
  xygrid(6) = -64
  xygrid(7) = -64
  nstrok = 0
  unused = .true.
  return
end subroutine gsymxd
!
subroutine bldfil
  use gchar_interfaces, except_this=>bldfil
  use hershey_symb
  !---------------------------------------------------------------------
  ! @ private
  !  (build HERSHEY font file)
  !  This program converts the character digitizations on the
  !  distribution HERSHEY font file to a series of records on a
  !  fortran unformatted (binary) file in which coordinate pairs
  !  have been packed into single integers to reduce the space
  !  requirements.  The font file contains the character
  !  digitizations in record groups, as follows:
  !
  !  first: NC,LENGTH,(XYGRID(I),I=1,5)
  !  remaining: (XYGRID(I),I=6,LENGTH)
  !
  !  the format for each record is (7(2X,2I4)).  NC is the
  !  HERSHEY character number, which at present consists of one of
  !  1611 integers in the range (1..NCLAST), with NCLAST = 4000.
  !  these character numbers must never be altered, since
  !  the entire set of routines which handle the hershey fonts
  !  use them. The first five entries in XYGRID(*) are the
  !  character extents:
  !
  !  XYGRID(1) = minimum Y value.
  !  XYGRID(2) = baseline Y value.
  !  XYGRID(3) = maximum Y value.
  !  XYGRID(4) = minimum X value.
  !  XYGRID(5) = maximum X value.
  !
  !  the minimum and maximum values do not necessarily
  !  correspond to the actual (X,Y) coordinates in the remainder
  !  of XYGRID(*), but specify the box in which characters are
  !  drawn.  The center of each character grid is at (0,0), and
  !  actual coordinates lie in the range (-49..+49).  a
  !  coordinate pair (-64,0) is a request to raise the pen
  !  before moving to the next point, and a pair (-64,-64)
  !  signals end-of-data for the current character.
  !
  !  By biasing each coordinate by +64, the coordinate range
  !  becomes (0..113), which can be represented by 7 bits.  Thus
  !  an (x,y) pair can be packed into 14 data bits.  The
  !  distribution version of <PLOT79> packs only one pair per
  !  integer word, so that the system can be installed without
  !  change on any machine with 16 or more bits/integer.  Later
  !  on, it may be desirable to increase the number of
  !  coordinate pairs stored in a single word.  On machines
  !  which permit this, it may be most convenient to define the
  !  data arrays as integer*2 or integer*3, rather than to
  !  revise the packing algorithm.
  !
  !  The entire set of fonts contains at present 105,557
  !  individual coordinate values, to which space for pointers
  !  to individual characters must be added.  If the coordinates
  !  are packed as (X,Y) pairs in 16-bit integers, then about
  !  57,000 16-bit integers are required for the coordinates and
  !  pointers. Since this is an excessive amount of storage on
  !  many machines, the character data is subdivided into
  !  smaller sections and stored as fortran unformatted (binary)
  !  records. Each such record contains the data list
  !
  !  NC1,NC2,NC3,INDEX,BUFFER
  !
  !  the data items in the record are
  !
  !  NC1......... starting character number in buffer.
  !  NC2......... last character number in buffer.
  !  NC3......... starting character number in next buffer, if there
  !               would be one.
  !  INDEX(*).... index array, locating the start of data
  !               for character K (assumed in range NC1..NC2) at
  !               BUFFER(INDEX(K+1-NC1)).
  !  BUFFER(*)... array for packed coordinates.
  !
  !  The actual size of BUFFER(*) and INDEX(*) may be adjusted
  !  to an installation's requirements, and the code in
  !  subroutine SYMXD must be appropriately modified to reflect
  !  any change in the size of these arrays.
  !
  !  This version of BLDFIL omits the indexical, triplex, and
  !  gothic fonts (Hershey numbers 1000-1999, 3000-3999). A
  !  buffer size of 27000 words and an index size of 3000 are
  !  adequate.
  !
  ! (09-aug-80)
  !---------------------------------------------------------------------
  integer :: i,           l
  integer :: length,      locbuf
  integer :: nc,          nclast
  integer :: need,        numbuf
  integer :: nused,       prtfil
  integer :: xygrid(400)
  integer :: input
  !
  prtfil = 6
  input = 1
  open (unit=input,status='OLD',file='hershey-font.dat')
  !-----------------------------------------------------------------------
  nclast = 3000                ! Last character considered in this version
  !
  !---- Procedure (initialize)
  numbuf = 0
  nc = 0
  nc1 = 0
  locbuf = 1
  rewind input
  !
10 continue
  !---- Procedure (retrieve next character digitization)
  read (input,1000) nc,length,(xygrid(i),i=1,5)
  read (input,1000) (xygrid(i),i=6,length)
  !
  if (nc.gt.nclast) goto 20
  !
  !---- Skip these ones
  if ((nc.gt.999.and.nc.lt.2000).or.(nc.gt.2999)) goto 10
  !
  need = (length + 1)/2
  !---- If no space left, flush current buffer
  if ( (locbuf+need-1).gt.maxbuf .or. (nc-nc1+1.gt.maxind) ) then
    numbuf = numbuf + 1
    nused = locbuf - 1
    write (prtfil,2000) numbuf,nc1,nc2,nc,nused
    nc1 = 0
  endif
  !---- Initialize new buffer if needed
  if (nc1.eq.0) then
    do i=1,maxind
      index(i) = 0
    enddo
    nc1 = nc
    nc2 = nc
    locbuf = 1
  endif
  !
  ! Add character to current buffer
  l = nc - nc1 + 1
  index(l) = locbuf
  nc2 = nc
  buffer(locbuf) = xygrid(1)
  locbuf = locbuf + 1
  do i=2,length,2
    buffer(locbuf) = 128*(xygrid(i)+64) + xygrid(i+1) + 64
    locbuf = locbuf + 1
  enddo
  !
  ! Loop for next character
  if (nc.lt.nclast) goto 10
  !
  ! Flush last buffer
20 continue
  close (unit=input)
  numbuf = numbuf + 1
  nused = locbuf - 1
  write (prtfil,2000) numbuf,nc1,nc2,nc,nused
  !
1000 format (7(2x,2i4))
2000 format (1x,'RECORD =',i4,5x,'CHARACTER RANGE =',3i5,5x,  &
       'BUFFER WORDS USED =',i5)
end subroutine bldfil
!
subroutine suwrit (filename,array,n)
  use gchar_dependencies_interfaces
  use gchar_interfaces
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because 'vstrsh1' is used as 1st word of a common block)
  ! SUWRIT
  !       Writes the GREG character set to file.
  !
  ! Arguments :
  !       FILENAME        C*(*)     Name of output file          Input
  !       ARRAY           I(128,N)  Character set                Input
  !       N               I                                      Input
  !---------------------------------------------------------------------
  character(len=*) :: filename      !
  integer :: n                      !
  integer :: array(128,n)           !
  ! Local
  integer :: i,ier
  !
  open(unit=1,status='NEW',file=filename,form='UNFORMATTED',access='DIRECT',  &
       recl=128*facunf,iostat=ier)
  if (ier.ne.0) then
    call gchar_message(seve%e,'HERSHEY','An error occured while creating '//  &
    'file '//filename)
    call sysexi(ier)
  endif
  !
  do i=1,n
    call wwrite(1,array(1,i),i)
  enddo
  close(unit=1)
end subroutine suwrit
!
subroutine wwrite(iunit,array,block)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: iunit                  !
  integer :: array(128)             !
  integer :: block                  !
  write (unit=iunit,rec=block) array
end subroutine wwrite
!
subroutine coresp(i)
  use gchar_interfaces, except_this=>coresp
  use gchar_variables
  !---------------------------------------------------------------------
  ! @ private
  ! CHAR
  !	Create the correspondance table between Hershey and Greg fonts
  !---------------------------------------------------------------------
  integer :: i(nkchar)              !
  ! Local
  integer :: j
  !
  ! Load SIMPLEX quality font
  !
  ! Roman alphabet
  !	Number	  Hershey number	! Caractere	ASCII
  !
  i(  1) = 699
  !			 Space 	32
  i(  2) = 714
  !			 !		33
  i(  3) = 619
  !			 "		34 Unused
  i(  4) = 2275
  !			 #		35
  i(  5) = 719
  !			 $		36
  i(  6) = 2271
  !			 %		37
  i(  7) = 734
  !			 &		38
  i(  8) = 716
  !			 '		39
  i(  9) = 721
  !			 (		40
  i( 10) = 722
  !			 )		41
  i( 11) = 728
  !			 *		42
  i( 12) = 725
  !			 +		43
  i( 13) = 711
  !			 ,		44
  i( 14) = 724
  !			 -		45
  i( 15) = 710
  !			 .		46
  i( 16) = 720
  !			 /		47
  !
  do j=0,9
    i( 17+j) = 700+j
    !			 0-9 numerals	48-57
  enddo
  !
  i( 27) = 712
  !			 :		58
  i( 28) = 713
  !			 ;		59
  i( 29) = 2241
  !			 <		60
  i( 30) = 726
  !			 =		61
  i( 31) = 2242
  !			 >		62
  i( 32) = 715
  !			 ?		63
  i( 33) = 2273
  !			 @		64
  !
  do j=1,26
    i( 33+j) = 500+j
    !			 A-Z 		65-90
  enddo
  !
  i( 60) = 2223
  !			 [		91
  i( 61) = 2199
  !			 \		92
  i( 62) = 2224
  !			 ]		93
  i( 63) = 2218
  !			 ^ = Degree	94
  i( 64) = 2199
  !			 *95
  !			 _		95
  i( 65) =  717
  !			 ` = "		96
  !
  do j=1,26
    i( 65+j) = 600+j
    !			 a-z		97-122
  enddo
  !
  i( 92) = 2225
  !			 {		123
  i( 93) = 723
  !			 |		124
  i( 94) = 2226
  !			 }		125
  i( 95) = 2246
  !			 ~		126
  !
  do j=96,100
    i( j) = 2199
    !			 Space		unused
  enddo
  !
  ! Greek font
  !
  i(101) = 699
  !			 Space 	32
  i(102) = 2301
  !
  !			 Aries	33
  i(103) = 699
  !			 " Taurus	34 Unused used `
  i(104) = 2303
  !			 # Gemini	35
  i(105) = 2304
  !			 $ Cancer	36
  i(106) = 2305
  !			 % Leo		37
  i(107) = 2306
  !			 & Virgo	38
  i(108) = 2307
  !			 ' Libra	39
  i(109) = 2308
  !			 ( Scorpius	40
  i(110) = 2309
  !			 ) Sagittarius	41
  i(111) = 2310
  !			 * Capricornus	42
  i(112) = 2311
  !			 + Aquarius	43
  i(113) = 2312
  !			 , Pisces	44
  i(114) = 2199
  !			*
  !			 - Conjunction	45
  i(115) =  254
  !			 . Quadrature	46
  i(116) = 2199
  !			*
  !			 / Opposition	47
  !
  i(117) = 2281
  !			 0 Sun
  i(118) = 2282
  !			 1 Mercure
  i(119) = 2283
  !			 2 Venus
  i(120) = 2284
  !			 3 Terre
  i(121) = 2285
  !			 4 Mars
  i(122) = 2286
  !			 5 Jupiter
  i(123) = 2287
  !			 6 Saturne
  i(124) = 2288
  !			 7 Uranus
  i(125) = 2289
  !			 8 Neptune
  i(126) = 2290
  !			 9 Pluton
  i(127) = 2291
  !			 : Lune	58
  i(128) = 2292
  !			 ; Comete	59
  i(129) = 2293
  !			 < Etoile	60
  i(130) = 2294
  !			 = Neud ascendant	61
  i(131) = 2295
  !			 > Neud descendant	62
  i(132) = 2199
  !			*90
  !			 ? h barre		63
  i(133) = 2199
  !			*
  !			 @ lambda barre	64
  !
  i(134) =  527
  !			 A Alpha
  i(135) =  528
  !			 B Beta
  i(136) =  548
  !			 C Chi
  i(137) =  530
  !			 D Delta
  i(138) =  531
  !			 E Epsilon
  i(139) =  547
  !			 F Phi
  i(140) =  529
  !			 G Gamma
  i(141) =  533
  !			 H Eta
  i(142) =  535
  !			 I Iota
  i(143) =  583
  !			 J   Nabla
  i(144) =  536
  !			 K Kappa
  i(145) =  537
  !			 L Lambda
  i(146) =  538
  !			 M Mu
  i(147) =  539
  !			 N Nu
  i(148) =  541
  !			 O Omicron
  i(149) =  542
  !			 P Pi
  i(150) =  534
  !			 Q Theta
  i(151) =  543
  !			 R Rho
  i(152) =  544
  !			 S Sigma
  i(153) =  545
  !			 T Tau
  i(154) =  546
  !			 U Upsilon
  i(155) = 2199
  !			*86
  !			 V   Angstrom
  i(156) =  550
  !			 W Omega
  i(157) =  540
  !			 X Xi
  i(158) =  549
  !			 Y Psi
  i(159) =  532
  !			 Z Zeta
  !
  i(160) = 2277
  !			 [ Cross
  i(161) = 2199
  !			 "\"
  i(162) = 2278
  !			 ] Double Cross
  i(163) = 2276
  !			 ^ Paragraph
  i(164) =  276
  !			 _ ...
  i(165) = 2302
  !			 ` Taurus
  !
  i(166) =  627
  !			 A Alpha
  i(167) =  628
  !			 B Beta
  i(168) =  648
  !			 C Chi
  i(169) =  630
  !			 D Delta
  i(170) =  631
  !			 E Epsilon
  i(171) =  686
  !			 F Phi		variante
  i(172) =  629
  !			 G Gamma
  i(173) =  633
  !			 H Eta
  i(174) =  635
  !			 I Iota
  i(175) =  683
  !			 J   d ronde
  i(176) =  636
  !			 K Kappa
  i(177) =  637
  !			 L Lambda
  i(178) =  638
  !			 M Mu
  i(179) =  639
  !			 N Nu
  i(180) =  641
  !			 O Omicron
  i(181) =  642
  !			 P Pi
  i(182) =  685
  !			 Q Theta	variante
  i(183) =  643
  !			 R Rho
  i(184) =  644
  !			 S Sigma
  i(185) =  645
  !			 T Tau
  i(186) =  646
  !			 U Upsilon
  i(187) = 2270
  !			 V   Infini
  i(188) =  650
  !			 W Omega
  i(189) =  640
  !			 X Xi
  i(190) =  649
  !			 Y Psi
  i(191) =  632
  !			 Z Zeta
  !
  i(192) = 2407
  !			 { Grand format
  i(193) = 2412
  !			 | Integrale
  i(194) = 2408
  !			 } Grand format
  i(195) = 2411
  !			 ~ Racine
  !
  do j=196,200
    i(j) =  699
    !			 Space		unused
  enddo
  !
  ! Script font
  !
  i(201) =  699
  !			   Space 	32
  i(202) = 2279
  !
  !			 Il existe	33
  i(203) = 2199
  !			 " 		34 Unused
  i(204) = 2256
  !			 # Inclusion	35
  i(205) = 2257
  !			 $ Union	36
  i(206) = 2258
  !			 % Contient	37
  i(207) = 2259
  !			 & Intersection
  i(208) = 2260
  !			 ' Appartient	39
  i(209) = 2268
  !			 ( Integrale	40
  i(210) = 2269
  !			 ) Integrale circulaire
  i(211) = 2235
  !			 * x		42
  i(212) = 2233
  !			 + Plus moins	43
  i(213) = 2237
  !			 , ./. droit	44
  i(214) = 2234
  !			 - Moins plus	45
  i(215) = 2236
  !			 . .		46
  i(216) = 2267
  !			 / Racine	47
  !
  do j=0,9
    i(217+j) = 700+j
    !			 0-9 numerals	48-57
  enddo
  !
  i(227) = 2199
  !			*
  !			 : Quelque soit
  i(228) =  738
  !			 ; Orthogonal	59
  i(229) = 2243
  !			 < ou egal	60
  i(230) = 2240
  !			 = Equivalent	61
  i(231) = 2244
  !			 > ou egal	62
  i(232) = 2239
  !			 ? Different	63
  i(233) = 2245
  !			 @ Proportionnel
  !
  do j=1,26
    i(233+j) =  550+j
    !			 A-Z 		65-90
  enddo
  !
  i(260) = 248
  !			 [ A peu pres egal
  i(261) = 2199
  !			 "\"
  i(262) = 250
  !			 ] A peu pres egal
  i(263) = 252
  !			 ^ Equilibre chimique
  i(264) = 278
  !			 _ Fleches horizontales
  i(265) = 279
  !			 ` Fleches verticales
  !
  do j=1,26
    i(265+j) =  650+j
    !			 a-z		97-122
  enddo
  !
  i(292) = 2262
  !			 { Fleche en haut
  i(293) = 2261
  !			 | Fleche a droite
  i(294) = 2264
  !			 } Fleche en bas
  i(295) = 2263
  !			 ~ Fleche a gauche
  !
  do j=296,300
    i(j) = 699
    !			 Space		unused
  enddo
  !
  ! Load DUPLEX quality font
  !
  ! Roman alphabet
  !	Number	  Hershey number
  !			 Caractere	ASCII
  i(301) = 2199
  !			 Space 	32
  i(302) = 2214
  !
  !					33
  i(303) = 2199
  !			 "		34 Unused
  i(304) = 2275
  !			 #		35
  i(305) = 2274
  !			 $		36
  i(306) = 2271
  !			 %		37
  i(307) = 2272
  !			 &		38
  i(308) = 2216
  !			 '		39
  i(309) = 2221
  !			 (		40
  i(310) = 2222
  !			 )		41
  i(311) = 2219
  !			 *		42
  i(312) = 2232
  !			 +		43
  i(313) = 2211
  !			 ,		44
  i(314) = 2231
  !			 -		45
  i(315) = 2210
  !			 .		46
  i(316) = 2220
  !			 /		47
  !
  do j=0,9
    i(317+j) = 2200+j
    !			 0-9 numerals	48-57
  enddo
  !
  i(327) = 2212
  !			 :		58
  i(328) = 2213
  !			 ;		59
  i(329) = 2241
  !			 <		60
  i(330) = 2238
  !			 =		61
  i(331) = 2242
  !			 >		62
  i(332) = 2215
  !			 ?		63
  i(333) = 2273
  !			 @		64
  !
  do j=1,26
    i(333+j) = 2000+j
    !			 A-Z 		65-90
  enddo
  !
  i(360) = 2223
  !			 [		91
  i(361) = 2199
  !			 \		92
  i(362) = 2224
  !			 ]		93
  i(363) = 2218
  !			 ^ = Degree	94
  i(364) = 2199
  !			 *95
  !			 _		95
  i(365) = 2217
  !			 ` = "		96
  !
  do j=1,26
    i(365+j) = 2100+j
    !			 a-z		97-122
  enddo
  !
  i(392) = 2225
  !			 {		123
  i(393) = 2229
  !			 |		124
  i(394) = 2226
  !			 }		125
  i(395) = 2246
  !			 ~		126
  !
  do j=396,400
    i( j) = 2199
    !			 Space		unused
  enddo
  !
  ! Greek font
  !
  i(401) = 2199
  !			 Space 	32
  i(402) = 2301
  !
  !			 Aries	33
  i(403) = 2199
  !			 " Taurus	34 Unused use `
  i(404) = 2303
  !			 # Gemini	35
  i(405) = 2304
  !			 $ Cancer	36
  i(406) = 2305
  !			 % Leo		37
  i(407) = 2306
  !			 & Virgo	38
  i(408) = 2307
  !			 ' Libra	39
  i(409) = 2308
  !			 ( Scorpius	40
  i(410) = 2309
  !			 ) Sagittarius	41
  i(411) = 2310
  !			 * Capricornus	42
  i(412) = 2311
  !			 + Aquarius	43
  i(413) = 2312
  !			 , Pisces	44
  i(414) = 2199
  !			*
  !			 - Conjunction	45
  i(415) = 254
  !			 . Quadrature	46
  i(416) = 2199
  !			*
  !			 / Opposition	47
  !
  i(417) = 2281
  !			 0 Sun
  i(418) = 2282
  !			 1 Mercure
  i(419) = 2283
  !			 2 Venus
  i(420) = 2284
  !			 3 Terre
  i(421) = 2285
  !			 4 Mars
  i(422) = 2286
  !			 5 Jupiter
  i(423) = 2287
  !			 6 Saturne
  i(424) = 2288
  !			 7 Uranus
  i(425) = 2289
  !			 8 Neptune
  i(426) = 2290
  !			 9 Pluton
  i(427) = 2291
  !			 : Lune	58
  i(428) = 2292
  !			 ; Comete	59
  i(429) = 2293
  !			 < Etoile	60
  i(430) = 2294
  !			 = Neud ascendant	61
  i(431) = 2295
  !			 > Neud descendant	62
  i(432) = 2199
  !			*90
  !			 ? h barre		63
  i(433) = 2199
  !			*
  !			 @ lambda barre	64
  !
  i(434) = 2027
  !			 A Alpha
  i(435) = 2028
  !			 B Beta
  i(436) = 2048
  !			 C Chi
  i(437) = 2030
  !			 D Delta
  i(438) = 2031
  !			 E Epsilon
  i(439) = 2047
  !			 F Phi
  i(440) = 2029
  !			 G Gamma
  i(441) = 2033
  !			 H Eta
  i(442) = 2035
  !			 I Iota
  i(443) = 2266
  !			 J   Nabla
  i(444) = 2036
  !			 K Kappa
  i(445) = 2037
  !			 L Lambda
  i(446) = 2038
  !			 M Mu
  i(447) = 2039
  !			 N Nu
  i(448) = 2041
  !			 O Omicron
  i(449) = 2042
  !			 P Pi
  i(450) = 2034
  !			 Q Theta
  i(451) = 2043
  !			 R Rho
  i(452) = 2044
  !			 S Sigma
  i(453) = 2045
  !			 T Tau
  i(454) = 2046
  !			 U Upsilon
  i(455) = 2199
  !			*86
  !			 V   Angstrom
  i(456) = 2050
  !			 W Omega
  i(457) = 2040
  !			 X Xi
  i(458) = 2049
  !			 Y Psi
  i(459) = 2032
  !			 Z Zeta
  !
  i(460) = 2277
  !			 [ Cross
  i(461) = 2199
  !			 "\"
  i(462) = 2278
  !			 ] Double Cross
  i(463) = 2276
  !			 ^ Paragraph
  i(464) = 276
  !			 _ ...
  i(465) = 2302
  !			 ` Taurus
  !
  i(466) = 2127
  !			 A Alpha
  i(467) = 2128
  !			 B Beta
  i(468) = 2148
  !			 C Chi
  i(469) = 2130
  !			 D Delta
  i(470) = 2131
  !			 E Epsilon
  i(471) = 2186
  !			 F Phi		variante
  i(472) = 2129
  !			 G Gamma
  i(473) = 2133
  !			 H Eta
  i(474) = 2135
  !			 I Iota
  i(475) = 2265
  !			 J   d ronde
  i(476) = 2136
  !			 K Kappa
  i(477) = 2137
  !			 L Lambda
  i(478) = 2138
  !			 M Mu
  i(479) = 2139
  !			 N Nu
  i(480) = 2141
  !			 O Omicron
  i(481) = 2142
  !			 P Pi
  i(482) = 2185
  !			 Q Theta	variante
  i(483) = 2143
  !			 R Rho
  i(484) = 2144
  !			 S Sigma
  i(485) = 2145
  !			 T Tau
  i(486) = 2146
  !			 U Upsilon
  i(487) = 2270
  !			 V   Infini
  i(488) = 2150
  !			 W Omega
  i(489) = 2140
  !			 X Xi
  i(490) = 2149
  !			 Y Psi
  i(491) = 2132
  !			 Z Zeta
  !
  i(492) = 2407
  !			 { Grand format
  i(493) = 2412
  !			 | Integrale
  i(494) = 2408
  !			 } Grand format
  i(495) = 2411
  !			 ~ Racine
  !
  do j=496,500
    i(j) = 2199
    !			 Space		unused
  enddo
  !
  ! Script font
  !
  i(501) = 2199
  !			   Space 	32
  i(502) = 2279
  !
  !			 Il existe	33
  i(503) = 2199
  !			 " 		34 Unused
  i(504) = 2256
  !			 # Inclusion	35
  i(505) = 2257
  !			 $ Union	36
  i(506) = 2258
  !			 % Contient	37
  i(507) = 2259
  !			 & Intersection
  i(508) = 2260
  !			 ' Appartient	39
  i(509) = 2268
  !			 ( Integrale	40
  i(510) = 2269
  !			 ) Integrale circulaire
  i(511) = 2235
  !			 * x		42
  i(512) = 2233
  !			 + Plus moins	43
  i(513) = 2237
  !			 , ./. droit	44
  i(514) = 2234
  !			 - Moins plus	45
  i(515) = 2236
  !			 . .		46
  i(516) = 2267
  !			 / Racine	47
  !
  do j=0,9
    i(517+j) = 2200+j
    !			 0-9 numerals	48-57
  enddo
  !
  i(527) = 2199
  !			*
  !			 : Quelque soit
  i(528) =  738
  !			 ; Orthogonal	59
  i(529) = 2243
  !			 < ou egal	60
  i(530) = 2240
  !			 = Equivalent	61
  i(531) = 2244
  !			 > ou egal	62
  i(532) = 2239
  !			 ? Different	63
  i(533) = 2245
  !			 @ Proportionnel
  !
  do j=1,26
    i(533+j) = 2550+j
    !			 A-Z 		65-90
  enddo
  !
  i(560) = 248
  !			 [ A peu pres egal
  i(561) = 2199
  !			 "\"
  i(562) = 250
  !			 ] A peu pres egal
  i(563) = 252
  !			 ^ Equilibre chimique
  i(564) = 278
  !			 _ Fleches horizontales
  i(565) = 279
  !			 ` Fleches verticales
  !
  do j=1,26
    i(565+j) = 2650+j
    !			 a-z		97-122
  enddo
  !
  i(592) = 2262
  !			 { Fleche en haut
  i(593) = 2261
  !			 | Fleche a droite
  i(594) = 2264
  !			 } Fleche en bas
  i(595) = 2263
  !			 ~ Fleche a gauche
  !
  do j=596,nkchar
    i(j) = 2199
    !			 Space		unused
  enddo
end subroutine coresp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_parse(line,ientuser,icaluser,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_interfaces, except_this => mrtcal_calib_or_solve_parse
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  ! CALIBRATE | SOLVE ient
  ! 1. /WITH ical
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: line
  integer(kind=entry_length), intent(out)   :: ientuser
  integer(kind=entry_length), intent(out)   :: icaluser
  logical,                    intent(inout) :: error
  !
  integer(kind=4), parameter :: icomm = 0
  integer(kind=4), parameter :: iwith = 1
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>PARSE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_parse_numver(rname,line,icomm,1,ix,ientuser,error)
  if (error)  return
  if (sic_present(iwith,0)) then
     call mrtcal_parse_numver(rname,line,iwith,1,ix,icaluser,error)
     if (error)  return
  else
     ! Null value that will be interpreted as search for the best 
     ! associated calibration in the ix index
     icaluser = 0
  endif
end subroutine mrtcal_calib_or_solve_parse
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_ix_entry(commcode,mrtset,ix,ientuser,icaluser,filebuf,  &
     calib,science,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_ix_entry
  use mrtcal_parameters
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: commcode
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(inout) :: ientuser
  integer(kind=entry_length), intent(inout) :: icaluser
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_t),              intent(inout) :: calib
  type(science_t),            intent(inout) :: science
  logical,                    intent(inout) :: error
  ! Local
  logical :: myerror
  integer(kind=4) :: scibackid,calbackid
  integer(kind=entry_length) :: isciprog,icalprog
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>IX>ENTRY'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (ix%obstype(ientuser).eq.obstype_calibrate) then
     ! Calibration scan: easy
     select case(commcode)
     case (code_command_calib,code_command_pipe)
        if (icaluser.ne.0) then
           call mrtcal_message(seve%e,rname,  &
                'Can not calibrate a calibration scan /WITH another scan')
           error = .true.
           return
        endif
        call mrtcal_calib_or_solve_ix_entry_calib(mrtset,ix,ientuser,filebuf,calib,error)
        if (error) return
     case (code_command_solve)
        call mrtcal_message(seve%e,rname,'Can not solve a calibration scan')
        error = .true.
        return
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select
  else
     ! Science scan: less easy
     if (icaluser.eq.0) then
        ! Search for the best associated calibration in the ix index
        myerror = error
        call mrtcal_calib_or_solve_autofind_done_cal(mrtset,ix,ientuser,icalprog,&
             filebuf,calib,myerror)
        if (myerror) then
           ! Previous matching calibration not found 
           ! => Need to set the calibration status of the current entry to
           !    FAILED
           call mrtcal_calib_or_solve_init_science(ix,ientuser,isciprog,error)
           if (error) return
           error = .true.
           return
        endif
        call mrtcal_calib_or_solve_feedback(ix,ientuser,icalprog,  &
             warnlim=mrtset%cal%winterval,error=error)
        if (error) return
     else
        ! Use user-defined calibration scan => Some additional sanity
        ! checks are required
        icalprog = icaluser
        call mrtcal_calib_or_solve_feedback(ix,ientuser,icalprog,error=error)
        if (error) return
     endif
     ! 1) Ensure 'icalprog' is the one currently buffered (reprocess if necessary)
     call mrtcal_calib_or_solve_reload(mrtset,ix,icalprog,filebuf,calib,error)
     if (error)  return
     ! 2) Initialize science scan (after calibration reprocess)
     call mrtcal_calib_or_solve_init_science(ix,ientuser,isciprog,error)
     if (error) return
     ! 3) Check calibration scan is sane for use
     call mrtcal_calib_or_solve_check_consistency(ix,ientuser,icalprog,error)
     if (error) return
     call mrtcal_calib_or_solve_check_obstype_is_cal(ix,icalprog,error)
     if (error) return
     call mrtcal_calib_or_solve_check_calstatus(ix,icalprog,error)
     if (error) return
     ! 4) Now calibrate
     call mrtcal_calib_or_solve_get_backid(ix,isciprog,scibackid,error)
     if (error) return
     call mrtcal_calib_or_solve_get_backid(ix,icalprog,calbackid,error)
     if (error) return
     call mrtcal_calib_or_solve_onebackend_science(commcode,&
          mrtset,calib%scan%val(calbackid)%last,&
          ix,isciprog,filebuf,&
          science%scan%val(scibackid),&
          error)
     if (error) return
     call mrtcal_calib_or_solve_exit_science(science%scan%val(scibackid),ix,isciprog,icalprog,error)
     if (error) return
  endif
end subroutine mrtcal_calib_or_solve_ix_entry
!
subroutine mrtcal_calib_or_solve_ix_entry_calib(mrtset,ix,icaluser,filebuf,  &
     calib,error)
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_ix_entry_calib
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  ! Calibrate the 'icaluser' entry (calibration scan) in IX
  ! Return the new (calibrated) entry number in 'icaluser'.
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(inout) :: icaluser
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_t),              intent(inout) :: calib
  logical,                    intent(inout) :: error
  ! Local
  integer(kind=entry_length) :: icalprog
  integer(kind=4) :: calbackid
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>IX>ENTRY>CALIB'
  !
  call mrtcal_calib_or_solve_feedback(ix,icaluser,error=error)
  if (error) return
  call mrtcal_calib_or_solve_init_calib(ix,icaluser,icalprog,error)
  if (error) return
  call mrtcal_calib_or_solve_get_backid(ix,icalprog,calbackid,error)
  if (error) return
  call mrtcal_calib_or_solve_onebackend_calibration(&
       mrtset,ix,icalprog,filebuf,&
       calib%scan%val(calbackid)%work,error)
  if (error)  return
  call mrtcal_calib_or_solve_exit_calib(calib%scan%val(calbackid),ix,icalprog,error)
  if (error) return
  ! Success: update icaluser to store the calibrated entry number.
  icaluser = icalprog
end subroutine mrtcal_calib_or_solve_ix_entry_calib
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_get_backid(idx,ient,backid,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_get_backid
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the backend identifier for the i-th entry in the input index
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(in)    :: ient
  integer(kind=4),            intent(out)   :: backid
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>GET>BACKEND'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  backid = idx%backend(ient)
  if (backid.eq.backend_unknown) then
     call mrtcal_message(seve%e,rname,'Unknown backend')
     error = .true.
     return
  endif
end subroutine mrtcal_calib_or_solve_get_backid
!
subroutine mrtcal_calib_or_solve_autofind_matching_cal(idx,backward,mtole,ientuser,  &
  istart,jcalprog,error)
  use phys_const
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_autofind_matching_cal
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !   Automatic search of the previous or next matching calibration in
  ! the input index, starting from the istart entry.
  !   The returned scan will be:
  !    - a calibration (obstype)
  !    - with calibration status none or done (reject failed or empty)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  logical,                    intent(in)    :: backward  ! Backward or forward search?
  real(kind=4),               intent(in)    :: mtole     ! [min] Tolerance
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(inout) :: istart
  integer(kind=entry_length), intent(out)   :: jcalprog
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>AUTOFIND>MATCHING>CAL'
  logical :: duplicated
  integer(kind=4), parameter :: newest = 0
  integer(kind=entry_length) :: ient,jent,first,last,step
  character(len=message_length) :: mess
  real(kind=8) :: sdobsut,cdobsut,dtole
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_separator(mseve%calib%book,rname,2,error)
  if (error) return
  call mrtindex_list_one_default(idx,ientuser,mess,error)
  call mrtcal_message(mseve%calib%book,rname,'Matching '//mess)
  !
  if (backward) then
    first = istart-1
    last = 1
    step = -1
  else
    first = istart+1
    last = idx%next-1
    step = +1
  endif
  sdobsut = idx%dobs(ientuser)+idx%ut(ientuser)/2.d0/pi
  dtole = mtole/60.d0/24.d0  ! Convert minutes to days
  jcalprog = 0
  do ient=first,last,step
     ! Finding the most recent version of the previous entry in the ix index
     ! *** JP I am not sure but there should be a shortcut as we already 
     ! *** JP known ient, i.e. why searching it from idx%num(ient) again?
     call mrtindex_numver2ent(rname,idx,idx%num(ient),newest,jent,duplicated,error)
     if (error) return
     call mrtindex_list_one_default(idx,jent,mess,error)
     call mrtcal_message(mseve%calib%book,rname,'Trying   '//mess)
     ! Search for a successful calibration of the same project and same backend
     if (idx%obstype(jent).ne.obstype_calibrate) cycle
     if (idx%calstatus(jent).eq.calstatus_failed) cycle
     if (idx%calstatus(jent).eq.calstatus_empty) cycle
     if (idx%calstatus(jent).eq.calstatus_skipped) cycle
     if (idx%projid(jent).ne.idx%projid(ientuser)) cycle
     if (idx%backend(jent).ne.idx%backend(ientuser)) cycle
     cdobsut = idx%dobs(jent)+idx%ut(jent)/2.d0/pi
     if (abs(cdobsut-sdobsut).gt.dtole)  cycle  ! Or exit?
     !
     ! OK, found a matching candidate
     ! *** JP That's not enough. Tuned frequency and channel width should also match...
     jcalprog = jent
     istart = ient  ! Also reset starting point so that we start from here
                    ! if we need to resume the loop
     exit
  enddo ! ient
end subroutine mrtcal_calib_or_solve_autofind_matching_cal
!
subroutine mrtcal_calib_or_solve_autofind_done_cal(mrtset,ix,ientuser,jcalprog,filebuf,calib,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_autofind_done_cal
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Automatic search of the nearest matching calibration in the input index.
  ! Calibrate it when needed
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(out)   :: jcalprog
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_t),              intent(inout) :: calib
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>AUTOFIND>DONE>CAL'
  logical :: myerror,way(2)
  integer(kind=4) :: iway
  integer(kind=entry_length) :: istart
  character(len=message_length) :: mess
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  way(1) = .true.   ! Backward search first
  way(2) = .false.  ! Then forward search
  !
  do iway=1,2
    istart = ientuser
    do while (.true.)
      call mrtcal_calib_or_solve_autofind_matching_cal(ix,way(iway),mrtset%cal%einterval,  &
        ientuser,istart,jcalprog,error)
      if (error) return
      if (jcalprog.eq.0)  exit  ! Nothing found, try next way
      if (ix%calstatus(jcalprog).eq.calstatus_done)  return  ! Found a calibrated one => done!
      !
      ! Found one, but it is not calibrated. Try to calibrate it:
      myerror = .false.
      call mrtcal_calib_or_solve_ix_entry_calib(mrtset,ix,jcalprog,filebuf,calib,myerror)
      if (myerror) then
        ! Calibration failure: its calibration status is marked failed in the
        ! index but it is not an error for the current subroutine. Continue
        ! to search for a valid calibration.
      else
        ! Calibration success: jcalprog is now the calibrated entry.
        return
      endif
    enddo
  enddo  ! iway
  !
  ! At this point we tried both ways but we have not return'ed from the loop
  ! => no matching calibration found
  !
  ! Give also some feedback, so that the error does not come alone and we see
  ! clearly which scan fails. The line "Calibrating ..." is also needed by the
  ! pipeline-report script.
  call mrtcal_calib_or_solve_feedback(ix,ientuser,error=error)
  if (error)  continue
  !
  ! This is an error. If you plan to relax this, think twice because having a
  ! reasonable upper limit avoids Mrtcal to pair a science scan with a
  ! calibration scan observed 2 days ago before a storm...
  write(mess,'(A,F0.1,A)')   &
    'No matching calibration in the surrounding ',mrtset%cal%einterval,' minutes'
  call mrtcal_message(seve%e,rname,mess)
  error = .true.
  return
end subroutine mrtcal_calib_or_solve_autofind_done_cal
!
subroutine mrtcal_calib_or_solve_check_consistency(idx,ient,ical,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_check_consistency
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(in)    :: ient
  integer(kind=entry_length), intent(inout) :: ical
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>CHECK>CONSISTENCY'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (idx%backend(ient).ne.idx%backend(ical)) then
     call mrtcal_message(seve%e,rname,'Calibration and science backends do not match')
     error = .true.
     return
  endif
end subroutine mrtcal_calib_or_solve_check_consistency
!
subroutine mrtcal_calib_or_solve_check_obstype_is_cal(idx,ical,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_check_obstype_is_cal
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(inout) :: ical
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>CHECK>OBSTYPE>IS>CAL'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (idx%obstype(ical).ne.obstype_calibrate) then
     call mrtcal_message(seve%e,rname,'Entry ### is not a calibration in input index')
     error = .true.
     return
  endif
end subroutine mrtcal_calib_or_solve_check_obstype_is_cal
!
subroutine mrtcal_calib_or_solve_check_calstatus(idx,ical,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_check_calstatus
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(in)    :: ical
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>CHECK>CALSTATUS'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  select case(idx%calstatus(ical))
  case (calstatus_done)
    return
  case (calstatus_none)
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with an UNCALIBRATED status')
    error = .true.
  case (calstatus_failed)
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with a FAILED status')
    error = .true.
  case (calstatus_empty)
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with an EMPTY status')
    error = .true.
  case (calstatus_skipped)
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with an SKIPPED status')
    error = .true.
  case default
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with an UNKNOWN status')
    error = .true.
  end select
end subroutine mrtcal_calib_or_solve_check_calstatus
!
subroutine mrtcal_calib_or_solve_check_current(idx,ical,backcal,warn,same,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_check_current
  use mrtcal_calib_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Check if the calibration scan given as argument is the ical-th
  ! entry in the index. Issue warning messages if needed.
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(in)    :: ical
  type(calib_backend_t),      intent(in)    :: backcal
  logical,                    intent(in)    :: warn
  logical,                    intent(out)   :: same
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>CHECK>CURRENT'
  character(len=message_length) :: mess
  character(len=11) :: date1,date2
  !
  same = .true.
  !
  if (idx%dobs(ical).ne.backcal%head%key%dobs) then
    same = .false.
    if (warn) then
      call gag_todate(idx%dobs(ical),date1,error)
      if (error)  return
      call gag_todate(backcal%head%key%dobs,date2,error)
      if (error)  return
      write(mess,'(3(A,1X))') 'Inconsistent observing dates:',date1,date2
      call mrtcal_message(seve%w,rname,mess)
    endif
  endif
  !
  if (idx%scan(ical).ne.backcal%head%key%scan) then
    same = .false.
    if (warn) then
      write(mess,'(A,1X,I0,1X,I0)') 'Inconsistent scan numbers:',idx%scan(ical),backcal%head%key%scan
      call mrtcal_message(seve%w,rname,mess)
    endif
  endif
  !
  if (idx%backend(ical).ne.backcal%head%key%backend) then
    same = .false.
    if (warn) then
      write(mess,'(3(A,1X))') 'Inconsistent backends:',  &
        mrtindex_backend(idx%backend(ical)),mrtindex_backend(backcal%head%key%backend)
      call mrtcal_message(seve%w,rname,mess)
    endif
  endif
end subroutine mrtcal_calib_or_solve_check_current
!
subroutine mrtcal_calib_or_solve_reload(mrtset,idx,ient,filebuf,calib,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_reload
  use mrtcal_buffer_types
  use mrtcal_calib_types
  use mrtindex_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(inout) :: idx
  integer(kind=entry_length), intent(inout) :: ient
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_t),              intent(inout) :: calib
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>RELOAD'
  logical :: same
  integer(kind=4) :: backid
  !
  call mrtcal_calib_or_solve_get_backid(idx,ient,backid,error)
  if (error) return
  call mrtcal_calib_or_solve_check_current(idx,ient,calib%scan%val(backid)%last,.true.,same,error)
  if (error)  return
  !
  if (same) then
    call mrtcal_message(seve%d,rname,'Calibration in memory is the desired one: nothing to do')
  else
    ! Recalibrate the calibration scan and load it in memory
    call mrtcal_message(seve%w,rname,  &
      'The calibration scan currently in memory is not the desired one: reprocess')
    call mrtcal_calib_or_solve_ix_entry_calib(mrtset,idx,ient,filebuf,calib,error)
    if (error)  return
    call mrtcal_message(seve%w,rname,'Calibration scan reprocessing done, resuming science scan')
    call mrtcal_separator(seve%r,rname,2,error)
    if (error) return
  endif
end subroutine mrtcal_calib_or_solve_reload
!
subroutine mrtcal_calib_or_solve_feedback(idx,ient,ical,warnlim,error)
  use phys_const
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_calib_or_solve_feedback
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)           :: idx
  integer(kind=entry_length), intent(in)           :: ient
  integer(kind=entry_length), intent(in), optional :: ical
  real(kind=4),               intent(in), optional :: warnlim
  logical,                    intent(inout)        :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>FEEDBACK'
  character(len=message_length) :: mess
  real(kind=4) :: diff,fact
  integer(kind=4) :: sev
  character(len=8) :: befaft,tunit
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_separator(seve%r,rname,2,error)
  if (error) return
  call mrtindex_list_one_default(idx,ient,mess,error)
  if (error) return
  call mrtcal_message(seve%r,rname,'Calibrating '//mess)
  if (.not.present(ical))  return
  !
  call mrtindex_list_one_default(idx,ical,mess,error)
  if (error) return
  call mrtcal_message(seve%r,rname,'With        '//mess)
  if (.not.present(warnlim))  return
  !
  diff = (idx%dobs(ient)+idx%ut(ient)/2.d0/pi) -  &
         (idx%dobs(ical)+idx%ut(ical)/2.d0/pi)
  diff = diff*24.d0*60.d0  ! Convert day to min
  if (diff.gt.0.) then
    befaft = ' before'
  else
    befaft = ' after'
    diff = -diff
  endif
  if (diff.lt.1.) then
    fact = 60.
    tunit = ' seconds'
  else
    fact = 1.
    tunit = ' minutes'
  endif
  write(mess,'(A,F0.1,2A)')  'Calibration observed ',diff*fact,tunit,befaft
  if (abs(diff).gt.warnlim) then
    call sic_upper(mess)
    sev = seve%w
  else
    sev = seve%i
  endif
  call mrtcal_message(sev,rname,mess)
end subroutine mrtcal_calib_or_solve_feedback
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_init_calib(ix,ientuser,ientprog,error)
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_init_calib
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Prepare a new entry for a calibration scan
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(out)   :: ientprog
  logical,                    intent(inout) :: error
  !
  call mrtcal_calib_or_solve_init(ix,.true.,ientuser,ientprog,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_init_calib
!
subroutine mrtcal_calib_or_solve_init_science(ix,ientuser,ientprog,error)
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_init_science
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Prepare a new entry for a science scan
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(out)   :: ientprog
  logical,                    intent(inout) :: error
  !
  call mrtcal_calib_or_solve_init(ix,.false.,ientuser,ientprog,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_init_science
!
subroutine mrtcal_calib_or_solve_init(ix,iscalib,ientuser,ientprog,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_init
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Do not call directly! Call mrtcal_calib_or_solve_init_calib or
  ! mrtcal_calib_or_solve_init_science instead.
  ! ---
  ! Copy the ient entry of the input index into a new entry. Then set 
  ! in place its calstatus to calstatus_failed. This status will
  ! be replaced in place by calstatus_done in mrtcal_calib_or_solve_exit_*
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(in)    :: iscalib
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(out)   :: ientprog
  logical,                    intent(inout) :: error
  ! Local
  type(mrtindex_entry_t) :: entry
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! *** JP We should first try to see whether the data was already
  ! *** JP already calibrated. If yes, we should return without error,
  ! *** JP but send a warning. Of course, the user could force the
  ! *** JP calibration through /FORCE option. In this case, we should
  ! *** JP upgrade the version number to last number + 1...
  !
  ! Set the new entry. Everything identical to 'ientuser'...
  call mrtindex_optimize_to_entry(ix,ientuser,entry,error)
  if (error) return
  ! ... except those:
  entry%indx%calstatus = calstatus_failed  ! Until calibration is not successful
  ! entry%indx%version = set by mrtindex_append_entry
  !
  ! --- Sections depending on obstype ----------------------------------
  ! The section pre-allocations are needed because it may happen that
  ! mrtcal_calib_or_solve_reload adds another entry after the current
  ! one, so we can not extend it anymore.
  !
  ! --- Calibration section ---
  if (iscalib) then
    ! This is calibration scan. Forget possible previous calibration results
    ! (we will overwrite it with possible new tunings)
    entry%head%presec(sec_calib_id) = .false.
  endif
  !
  ! --- Science section ---
  if (iscalib) then
    ! This is calibration scan. No Science section
    entry%head%presec(sec_science_id) = .false.
  else
    ! This is a "science" scan (in large sense, i.e. everything which
    ! is calibrated thanks to a calibration scan). Prepare room for the
    ! Science section, it will be updated (with the actual values) by
    ! mrtcal_calib_or_solve_exit_science.
    call mrtindex_entry_zscience(entry%head%sci,error)
    if (error)  return
    entry%head%presec(sec_science_id) = .true.
  endif
  !
  ! --- Pointing section ---
  ! No solution and section disabled as long as no result to be written in index.mrt
  entry%head%presec(sec_pointing_id) = .false.  ! As long as no result
  entry%indx%solstatus = solstatus_none
  if (entry%indx%obstype.eq.obstype_pointing) then
    call entry%head%poi%zero(error)
    if (error)  return
  endif
  !
  ! --- End of sections ------------------------------------------------
  !
  call mrtindex_append_entry(entry,ientuser,ientprog,ix,error)
  if (error) return
  !
  call mrtindex_entry_free(entry,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_init
!
subroutine mrtcal_calib_or_solve_exit_calib(cal,ix,ientprog,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_exit_calib
  use mrtindex_types
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(calib_backend_work_t), intent(inout) :: cal
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: ientprog
  logical,                    intent(inout) :: error
  ! Local
  type(mrtindex_entry_t) :: entry
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>EXIT>CALIB'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtindex_optimize_to_entry(ix,ientprog,entry,error)
  if (error) return
  !
  if (cal%work%nspec.eq.0) then
    ! 0-sized calibration: done, but not useable later on
    ! No purpose saving an empty calibration section.
    entry%indx%calstatus = calstatus_empty
  else
    ! This is a successful calibration: the 'work' calibration
    ! becomes the 'last' useable
    call cal%swap(error)
    if (error)  return
    !
    ! *** JP: For the moment use this one. But in fact, the work on presec
    !         should also be done inside this one
    !
    ! Fill and enable the calibration section
    call mrtcal_entry_chopperset2calsec(cal%last,entry%head%cal,error)
    if (error) return
    entry%head%presec(sec_calib_id) = .true.
    !
    entry%indx%calstatus = calstatus_done
  endif
  !
  call mrtindex_extend_entry(entry,ientprog,ix,error)
  if (error) return
  call mrtindex_entry_free(entry,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_exit_calib
!
subroutine mrtcal_calib_or_solve_exit_science(sci,ix,isciprog,icalprog,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_exit_science
  use mrtcal_calib_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(science_backend_t),    intent(in)    :: sci
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: isciprog
  integer(kind=entry_length), intent(in)    :: icalprog
  logical,                    intent(inout) :: error
  ! Local
  type(mrtindex_entry_t) :: entry
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>EXIT>SCIENCE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtindex_optimize_to_entry(ix,isciprog,entry,error)
  if (error) return
  !
  if (sci%nobs.eq.0) then
    entry%indx%calstatus = calstatus_empty
  else
    entry%indx%calstatus = calstatus_done
    !
    ! Fill and enable the science section
    entry%head%sci%caldobs = ix%dobs(icalprog)
    entry%head%sci%calscan = ix%scan(icalprog)
    entry%head%sci%calback = ix%backend(icalprog)
    entry%head%sci%calvers = ix%version(icalprog)
    entry%head%presec(sec_science_id) = .true.
    !
    ! Enable the pointing section if relevant
    if (entry%indx%obstype.eq.obstype_pointing) then
      call mrtcal_entry_sdrifts2poisec(sci,entry%head%poi,error)
      if (error) return
      entry%head%presec(sec_pointing_id) = .true.
      entry%indx%solstatus = solstatus_done
    endif
    !
  endif
  !
  call mrtindex_extend_entry(entry,isciprog,ix,error)
  if (error) return
  call mrtindex_entry_free(entry,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_exit_science
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_onebackend_calibration(mrtset,scanidx,ient,filebuf,&
     backcal,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_onebackend_calibration
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(in)    :: scanidx
  integer(kind=entry_length), intent(in)    :: ient
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_backend_t),      intent(inout) :: backcal
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>ONEBACKEND>CALIBRATION'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_calib_or_solve_read_backend_header(scanidx,ient,filebuf,backcal%head,error)
  if (error) return
  !
  ! Keep memory of the chunks description
  call imbfits_copy_back_chunks(filebuf%imbf%back%chunks,backcal%chunksetlist,error)
  if (error)  return
  !
  call mrtcal_calib_calibration(mrtset,filebuf,backcal,error)
  if (error) return
end subroutine mrtcal_calib_or_solve_onebackend_calibration
!
subroutine mrtcal_calib_or_solve_onebackend_science(commcode,doset,backcal,&
     scanidx,ient,filebuf, backsci,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_onebackend_science
  use mrtcal_parameters
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: commcode
  type(mrtcal_setup_t),       intent(in)    :: doset    ! Setup (user choices)
  type(calib_backend_t),      intent(in)    :: backcal
  type(mrtindex_optimize_t),  intent(in)    :: scanidx
  integer(kind=entry_length), intent(in)    :: ient
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(science_backend_t),    intent(inout) :: backsci
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>ONEBACKEND>SCIENCE'
  type(mrtcal_setup_t) :: doneset  ! Setup (resolved choices)
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_calib_or_solve_read_backend_header(scanidx,ient,filebuf,backsci%head,error)
  if (error) return
  !
  ! Keep memory of the chunks description
  call imbfits_copy_back_chunks(filebuf%imbf%back%chunks,backsci%chunksetlist,error)
  if (error)  return
  !
  ! Translate user choices for this scan
  call mrtcal_setup_do2done(backsci%head%key%obstype,  &
    backsci%head%key%switchmode,doset,doneset,error)
  if (error)  return
  !
  ! Build and print subscan list
  call mrtcal_init_scan_cal(backsci,filebuf%imbf,error)
  if (error) return
  !
  if (all(backsci%list%empty)) then
    call mrtcal_message(seve%w,rname,  &
      'All subscan data tables are zero-sized: scan marked as EMPTY')
    ! backsci%nspec was initialized and left to 0. mrtcal_calib_or_solve_exit_science
    ! will then mark the scan as empty.
    return
  endif
  !
  select case(backsci%head%key%obstype)
  case (obstype_tracked)
     select case(commcode)
     case (code_command_calib,code_command_pipe)
        select case(backsci%head%key%switchmode)
        case (switchmode_pos)
           call mrtcal_calib_tracked_psw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case (switchmode_wob)
           call mrtcal_calib_tracked_wsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case (switchmode_fre)
           call mrtcal_calib_tracked_fsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case (code_command_solve)
        call mrtcal_message(seve%e,rname,'Unsupported observing type when solving')
        error = .true.
        return
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select ! commcode
  case (obstype_otf)
     select case(commcode)
     case (code_command_calib,code_command_pipe)
        select case(backsci%head%key%switchmode)
        case (switchmode_pos)
           call mrtcal_calib_otf_psw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case (switchmode_fre)
           call mrtcal_calib_otf_fsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case (code_command_solve)
        call mrtcal_message(seve%e,rname,'Unsupported observing type when solving')
        error = .true.
        return
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select ! commcode
  case (obstype_pointing)   
     select case(commcode)
     case (code_command_calib)
        select case(backsci%head%key%switchmode)
!!$        case (switchmode_pos)
!!$           call mrtcal_calib_pointing_psw(doneset,backcal,backsci,filebuf,error)
!!$           if (error) return
        case (switchmode_bea)
           call mrtcal_calib_pointing_bsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select  ! backsci%head%key%switchmode
     case (code_command_solve,code_command_pipe)
        select case(backsci%head%key%switchmode)
!!$        case (switchmode_pos)
!!$           call mrtcal_solve_pointing_psw(doneset,backcal,backsci,filebuf,error)
!!$           if (error) return
        case (switchmode_bea)
           call mrtcal_solve_pointing_bsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select ! commcode
  case (obstype_focus)
     select case(commcode)
     case (code_command_calib)
        select case(backsci%head%key%switchmode)
        case (switchmode_bea)
           call mrtcal_calib_focus_bsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case (code_command_solve,code_command_pipe)
        select case(backsci%head%key%switchmode)
        case (switchmode_bea)
           call mrtcal_solve_focus_bsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select ! commcode
  case default
     call mrtcal_message(seve%e,rname,'Unsupported observing type '// &
          mrtindex_obstype(backsci%head%key%obstype))
     error = .true.
     return
  end select ! backsci%head%key%obstype
end subroutine mrtcal_calib_or_solve_onebackend_science
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! *** JP Not sure where the following code should go: in calib-utils.f90?
!
subroutine mrtcal_calib_or_solve_read_backend_header(scanidx,ient,filebuf,head,error)
  use mrtcal_messaging
  use classic_api
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_read_backend_header
  use mrtcal_buffer_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: scanidx
  integer(kind=entry_length), intent(in)    :: ient
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(mrtindex_header_t),    intent(inout) :: head
  logical,                    intent(inout) :: error
  ! Local
  character(len=filename_length) :: filename
  type(classic_entrydesc_t) :: edesc
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>READ>BACKEND>HEADER'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtindex_entry_rheader(scanidx,ient,edesc,head,error)
  if (error) return
  call mrtindex_optimize_to_filename(scanidx,ient,filename,error)
  if (error) return
  call imbfits_read_header(filename,filebuf%imbf,error)
  if (error) return
end subroutine mrtcal_calib_or_solve_read_backend_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_hyperview
  use cubetools_parameters
  use cubetools_structure
  use cubetools_switch_types
  use cubeadm_cubeid_types
  use cubego_index_iterator_types
  use cubego_messaging
  !
  public :: hyperview
  private
  !
  type :: view_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(index_iterator_comm_t) :: which
     type(switch_comm_t)         :: interactive
   contains
     procedure, public  :: register => cubego_view_comm_register
     procedure, private :: parse    => cubego_view_comm_parse
     procedure, private :: main     => cubego_view_comm_main
  end type view_comm_t
  type(view_comm_t) :: hyperview
  !
  type :: view_user_t
     type(cubeid_user_t)         :: cubeids
     type(index_iterator_user_t) :: which
     type(switch_user_t)         :: interactive
   contains
     procedure, private :: toprog => cubego_view_user_toprog
  end type view_user_t
  !
  type view_prog_t
     type(switch_prog_t) :: interactive
   contains
     procedure, private :: act => cubego_view_prog_act
  end type view_prog_t
  !
contains
  !
  subroutine cubego_hyperview_command(line,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(view_user_t) :: user
    character(len=*), parameter :: rname='VIEW>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call hyperview%parse(line,user,error)
    if (error) return
    call hyperview%main(user,error)
    if (error) return
    ! Force insertion in SIC stack ! *** JP Why?
    if (sic_lire().eq.0) call sic_insert(line)
  end subroutine cubego_hyperview_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_view_comm_register(comm,error)
    use cubedag_allflags
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(view_comm_t), intent(inout) :: comm
    logical,            intent(inout) :: error
    !
    type(cubeid_arg_t) :: in
    character(len=*), parameter :: rname='VIEW>COMM>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'HYPERVIEW','[cubeid]',&
         'Interactive view of a cube',&
         'This is a tentative reimplementation of the BIT command.'//strg_bl//&
         'Open the new cube viewer for a cube. This command remembers&
         & the last cube opened, and you can use different iterators to&
         & display the neighboring cubes in the current DAG index.&
         & Set /INTERACTIVE OFF to run once without the control loop.',&
         cubego_hyperview_command,&
         comm%comm,&
         error)
    if (error) return
    call in%register(&
         'CUBEID',&
         'Identity of the cube to be viewed',&
         'If omitted and no iterator key is set, use the last matching&
         & cube (any family/flags) in the default index (DAG by default;&
         & see SET\INDEX). If an iterator key is set, selection follows&
         & that iterator on the DAG index.',&
         code_arg_optional,&
         [flag_any],&
         code_read,&                    ! Indicative: data access done by procedure
         code_access_imaset_or_speset,& ! Indicative: data access done by procedure
         comm%cube,&
         error)
    if (error) return
    call comm%which%register('VIEW','current',error)
    if (error) return
    call comm%interactive%register(&
         'INTERACTIVE',&
         'the interactive mode',&
         'ON',&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubego_view_comm_register
  !
  subroutine cubego_view_comm_parse(comm,line,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(view_comm_t), intent(inout) :: comm
    character(len=*),   intent(in)    :: line
    type(view_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='VIEW>COMM>PARSE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%which%parse(line,user%which,error)
    if (error) return
    call comm%interactive%parse(line,user%interactive,error)
    if (error) return
  end subroutine cubego_view_comm_parse
  !
  subroutine cubego_view_comm_main(comm,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(view_comm_t), intent(in)    :: comm
    type(view_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(view_prog_t) :: prog
    character(len=*), parameter :: rname='VIEW>COMM>MAIN'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubego_view_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_view_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    use cubego_buffer
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(view_user_t), intent(in)    :: user
    type(view_comm_t),  intent(in)    :: comm
    type(view_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='VIEW>USER>TOPROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_user2prog(comm%comm,user%cubeids,cubes,error,user%which%code)
    if (error) return
    call cubes%defstruct(cubego,error)
    if (error) return
    call prog%interactive%init(comm%interactive,error)
    if (error) return
    call user%interactive%toprog(comm%interactive,prog%interactive,error)
    if (error) return
  end subroutine cubego_view_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_view_prog_act(prog,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(view_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='VIEW>PROG>ACT'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call exec_program('@ q-view.cube')
    if (prog%interactive%enabled) then
       call exec_program('@ l-ctrl-master-loop')
    else
       call exec_program('@ l-ctrl-master-exit')
    endif
  end subroutine cubego_view_prog_act
end module cubego_hyperview
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine small_circle(a1,d1,r,error)
  use gkernel_interfaces
  use gkernel_types
  use ast_astro
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=8) :: a1                !
  real(kind=8) :: d1                !
  real(kind=8) :: r                 !
  logical :: error                  !
  ! Local
  integer(kind=4) :: mstep
  parameter (mstep=50)
  real(kind=8) :: s1(2), u(3), v(3), s(2), w(3), vv(3)
  real(kind=8) :: xin(mstep), yin(mstep), zin(mstep)
  real(kind=8) :: xmin, xmax, ymin, ymax, x1, cs, ss, t, cp, sp, x, y, g
  integer(kind=4) :: i, j, nin
  logical :: in, last_in
  type(projection_t) :: gregproj
  !------------------------------------------------------------------------
  s1(1) = a1
  s1(2) = d1
  call sic_get_dble('USER_XMIN',xmin,error)
  call sic_get_dble('USER_XMAX',xmax,error)
  call sic_get_dble('USER_YMIN',ymin,error)
  call sic_get_dble('USER_YMAX',ymax,error)
  if (xmax.lt.xmin) then
    x1 = xmin
    xmin = xmax
    xmax = x1
  endif
  if (ymax.lt.ymin) then
    x1 = ymin
    ymin = ymax
    ymax = x1
  endif
  error = .false.
  !
  call rect(s1,w)
  v (3) = 0
  g = sqrt(1 - w(3)**2)
  u (3) = - g
  if (g.ne.0) then
    u (1) = w(1) * w(3) / g
    u (2) = w(2) * w(3) / g
    v (1) = w(2) / g
    v (2) = - w(1) / g
  else
    u (1) = 1
    u (2) = 0
    v (1) = 0
    v (2) = 1
  endif
  cs = cos(r)
  ss = sin(r)
  in = .false.
  last_in = .false.
  nin = 0
  do j=1, mstep
    t = 2*pi * (j-1) / (mstep-1)
    cp = cos(t)
    sp = sin(t)
    do i= 1, 3
      vv(i) = ss * (cp * u(i) + sp * v(i)) + cs * w(i)
    enddo
    call spher(vv,s)
    if (projection) then
      call greg_projec_get(gregproj)  ! Get current Greg projection
      call abs_to_rel(gregproj,s(1),s(2),x,y,1)
    else
      x = s(1)
      if (frame.eq.'EQUATORIAL' .and. x.lt.0) x = x + 2d0*pi
      if (frame.eq.'HORIZONTAL' .and. azref.eq.'N' .and. x.lt.0) x = x + 2d0*pi
      y = s(2)
    endif
    in = x.ge.xmin .and. x.le.xmax .and. y.ge.ymin .and. y.le.ymax
    if (frame.eq.'HORIZONTAL') in = in .and. (s(2).ge.0d0)
    if (in) then
      nin = nin + 1
      xin (nin) = x
      yin (nin) = y
      zin (nin) = t
      if (nin.ge.2) then
        if (.not.projection .and. abs(xin(nin)-xin(nin-1)).gt.pi) then
          xin(nin) = xin(nin)-sign(2*pi,xin(nin)-xin(nin-1))
          call gr8_curve(nin,xin,yin,zin,'Z',.false.,0d0,-1d0,error)
          nin = 1
          xin (1) = x
          yin (1) = y
          zin (1) = t
        endif
      endif
    elseif (.not.last_in) then
      nin = 1
      xin (1) = x
      yin (1) = y
      zin (1) = t
    elseif (last_in) then
      nin = nin + 1
      xin (nin) = x
      yin (nin) = y
      zin (nin) = t
      call gr8_curve (nin,xin,yin,zin,'Z',.false.,0d0,-1d0,error)
      nin = 1
    endif
    last_in = in
  enddo
  if (nin.ge.2) then
    call gr8_curve (nin,xin,yin,zin,'Z',.false.,0d0,-1d0,error)
  endif
end subroutine small_circle

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_keyvalunit_list_tool
  use cubetools_parameters
  use cubetools_unit_types
  use cubetools_format
  use cubesyntax_messaging
  !
  public :: keyvalunit_list_t
  public :: keyvalunit
  private
  !
  type keyvalunit_list_t
   contains
     procedure, private :: list_inte => cubesyntax_keyvalunit_list_inte
!!$     procedure, private :: list_long => cubesyntax_keyvalunit_list_long
     procedure, private :: list_real => cubesyntax_keyvalunit_list_real
     procedure, private :: list_dble => cubesyntax_keyvalunit_list_dble
     procedure, private :: list_strg => cubesyntax_keyvalunit_list_strg
     generic,   public  :: list => list_inte,list_real,list_dble,list_strg
  end type keyvalunit_list_t
  type(keyvalunit_list_t) :: keyvalunit
  !
  integer(kind=4) :: list_l = 40
  !
  type(unit_user_t) :: unit
  character(len=mess_l) :: mess
  !
contains
  !
  subroutine cubesyntax_keyvalunit_list_inte(prog,name,value,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(keyvalunit_list_t), intent(in)    :: prog
    character(len=*),         intent(in)    :: name
    integer(kind=inte_k),     intent(in)    :: value
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVALUNIT>LIST>INTE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  '//cubetools_format_stdkey_boldval(name,value,'i0',list_l)
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubesyntax_keyvalunit_list_inte
  !
  subroutine cubesyntax_keyvalunit_list_real(prog,name,value,code,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(keyvalunit_list_t), intent(in)    :: prog
    character(len=*),         intent(in)    :: name
    real(kind=real_k),        intent(in)    :: value
    integer(kind=code_k),     intent(in)    :: code
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVALUNIT>LIST>REAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call unit%get_from_code(code,error)
    if (error) return
    mess = '  '//cubetools_format_stdkey_boldval(&
         name,value*unit%user_per_prog,fsimple,list_l)
    mess = trim(mess)//'  '//trim(unit%name)
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubesyntax_keyvalunit_list_real
  !
  subroutine cubesyntax_keyvalunit_list_dble(prog,name,value,code,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(keyvalunit_list_t), intent(in)    :: prog
    character(len=*),         intent(in)    :: name
    real(kind=dble_k),        intent(in)    :: value
    integer(kind=code_k),     intent(in)    :: code
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVALUNIT>LIST>DBLE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call unit%get_from_code(code,error)
    if (error) return
    mess = '  '//cubetools_format_stdkey_boldval(&
         name,value*unit%user_per_prog,fdouble,list_l)
    mess = trim(mess)//'  '//trim(unit%name)
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubesyntax_keyvalunit_list_dble
  !
  subroutine cubesyntax_keyvalunit_list_strg(prog,name,value,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(keyvalunit_list_t), intent(in)    :: prog
    character(len=*),         intent(in)    :: name
    character(len=*),         intent(in)    :: value
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVALUNIT>LIST>STRG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  '//cubetools_format_stdkey_boldval(name,value,list_l)
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubesyntax_keyvalunit_list_strg
end module cubesyntax_keyvalunit_list_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gvalue (qsb, qband, qant, qntch,   &
    gainc, gainl, wgainc, wgainl,   &
    iant, iband, isub, jw1, jw2, jw3, w, zz, aa, ww, ny,error)
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Get an antenna gain-like value
  !     QSB     INTEGER   Number of sidebands (2)
  !     QBAND   INTEGER   Number of temporal data
  !     QANT    INTEGER   Number of antennas
  !     QNTCH   INTEGER   Number of channels (in total per baseline)
  !     GAINC(QBAND,QSB,QANT)   COMPLEX  Antenna gains (temporal data)
  !     GAINL(QNTCH,QSB,QBAND)  COMPLEX  Antenna gains (spectral data)
  !     WGAINC(QBAND,QSB,QANT)  REAL  Weight of antenna gain
  !     WGAINL(QNTCH,QSB,QBAND) REAL  Weight of antenna gain
  !     IANT    INTEGER   Antenna number
  !     IBAND   INTEGER   Subband number
  !     ISUB    INTEGER   Sideband number
  !     NY      INTEGER   Number of Y values (output)
  !     JW1,JW2 INTEGER   Lowest and Highest channel in window subband
  !     W       REAL      Signed integration time
  !     AA(*)   REAL      Positive weights
  !     WW(*)   REAL      Total weights
  !     ZZ(*)   COMPLEX   Complex output
  ! Call Tree
  !	...	SUB_READ_SPEC
  !---------------------------------------------------------------------
  integer :: qsb                     !
  integer :: qband                   !
  integer :: qant                    !
  integer :: qntch                   !
  complex :: gainc(qband,qsb,qant)   !
  complex :: gainl(qntch,qsb,qband)  !
  real :: wgainc(qband,qsb,qant)     !
  real :: wgainl(qntch,qsb,qband)    !
  integer :: iant                    !
  integer :: iband                   !
  integer :: isub                    !
  integer :: jw1                     !
  integer :: jw2                     !
  integer :: jw3                     !
  real*4 :: w                        !
  complex :: zz(*)                   !
  real*4 :: aa(*)                    !
  real*4 :: ww(*)                    !
  integer :: ny                      !
  logical :: error
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! INCLUDE 'clic_sba.inc'
  ! Local
  integer :: ig, im, is, ii, ii1, ii2, k, i, jok(mch)
  complex :: zzz(2), z, av(2)
  real :: www(2), fw
  !------------------------------------------------------------------------
  !
  ! Correlation scan
  if (r_isb.eq.1) then
    ig = 1
    im = 2
  else
    ig = 2
    im = 1
  endif
  do i=1, 2
    av(i) = 1.
  enddo
  !
  if (qsb.eq.1) then ! Check available sideband
    if (isub.le.mbands) then
      is = isub
    else
      is = isub-mbands
    endif
    if (r_lsband(1,is).ne.iband) then
      call message(6,3,'GVALUE','Sideband unavailable')
      error = .true.
      return
    endif
  endif
  do i=1, 2
    av(i) = 1.0
  enddo
  ! normally one should take here the antenna based side band averages
  ! to be computed in SET_PASS
  ! Use side band averages just determined in CONT_AVERAGE.
  !      DO I=1, 2
  !         IF  (WSBA(I,-IANT).NE.0) THEN
  !            AV(I) = ABS(ZSBA(I,-IANT))/ZSBA(I,-IANT)
  !         ENDIF
  !      ENDDO
  !
  if (iband.le.2) then
    ii1 = iband
    ii2 = iband
  else
    ii1 = 1
    ii2 = 2
  endif
  if (isub.le.mbands) then
    ny = 1
    is = isub
    do ii = ii1, ii2
      zzz(ii) = gainc(is,ii,iant)
      www(ii) = wgainc(is,ii,iant)
    enddo
    !c         CALL MIXBAND(IBAND,IG,IM,ZZZ,WWW,AV,Z,FW)
    call mixband(iband,r_sb(is),zzz,www,av,z,fw)
    zz(1) = zz(1) + fw * z
    if (j_average.ne.1) then
      aa(1) = aa(1) + fw * abs(z)
    endif
    if (fw.gt.0) ww(1) = ww(1) + fw
  else
    is = isub-mbands
    ny = r_lnch(is)
    k = r_lich(is)
    call jlimits(r_lnch(is),jw1,jw2,jw3,jok)
    call jmask(r_lnch(is),nmask(is,iant),cmask(:,:,is,iant),jok)
    do i = 1, ny
      k = k + 1
      do ii = ii1, ii2
        zzz(ii) = gainl(k,ii,iant)
        www(ii) = wgainl(k,ii,iant)
      enddo
      !cc            CALL MIXBAND(IBAND,IG,IM,ZZZ,WWW,AV,Z,FW)
      call mixband(iband,r_sb(is),zzz,www,av,z,fw)
      fw = fw * jok(i)
      zz(i) = zz(i) + fw * z
      if (j_average.ne.1) then
        aa(i) = aa(i) + fw * abs(z)
      endif
      if (fw.gt.0) ww(i) = ww(i) + fw
    enddo
  endif
  return
end subroutine gvalue
!
subroutine mixband(iband,isb,z,w,av,zm,wm)
  use classic_api
  !---------------------------------------------------------------------
  !     IBAND    INTEGER   Sideband code (u/l/aver/diff/ratio)
  !     Z(2)     COMPLEX   Complex antenna gain for both sidebands
  !     W(2)     REAL      Weight
  !     AV(2)    COMPLEX   Complex sideband ratio
  !     ZM       COMPLEX   Output complex gain
  !     WM       REAL      Output weight
  !---------------------------------------------------------------------
  integer :: iband                  !
  integer :: isb                    !
  complex :: z(2)                   !
  real :: w(2)                      !
  complex :: av(2)                  !
  complex :: zm                     !
  real :: wm                        !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: ig, im
  !------------------------------------------------------------------------
  ! Code:
  ig = (3-isb)/2
  im = (3+isb)/2
  !
  if (iband.le.2) then
    zm = z(iband)
    wm = w(iband)
  elseif (iband.eq.3) then
    zm = av(ig)*z(ig)*w(ig) + av(im)*z(im)*w(im)
    wm = w(ig) + w(im)
    if (wm.ne.0) zm = zm / wm
  elseif (iband.eq.5) then
    zm = av(ig)*z(ig) - av(im)*z(im)
    wm = w(ig) + w(im)
  elseif (iband.eq.4) then
    if (z(im).ne.0.and.z(ig).ne.0   &
      .and.w(ig).ne.0.and.w(im).ne.0) then
      zm = av(im)*z(im) / (av(ig)*z(ig))
      wm = 1/w(ig)/abs(z(ig))**2 + 1/w(im)/abs(z(im))**2
      wm = 1/wm/abs(zm)**2
    else
      zm = 0
      wm = 0.
    endif
  endif
  return
end subroutine mixband
!
subroutine gain_cont (qsb,qband,qbas,qant,   &
    data_in, passc,gainc,wgainc,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Compute the antenna gains from temporal data
  ! Arguments
  !     QSB     INTEGER   Number of sidebands (2)
  !     QBAND   INTEGER   Number of temporal data
  !     QANT    INTEGER   Number of antennas
  !     QBAS    INTEGER   Number of baselines
  !     DATC(QBAND,QSB,QBAS)   COMPLEX  Temporal data
  !     PASSC(QBAND,QSB,QBAS)  COMPLEX  PassBand of temporal data
  !     GAINC(QBAND,QSB,QANT)  COMPLEX  Antenna gains (temporal data)
  !     WGAINC(QBAND,QSB,QANT) REAL  Weight of antenna gain
  ! Call Tree
  !	...	SUB_READ_SPEC
  !---------------------------------------------------------------------
  integer :: qsb                           !
  integer :: qband                         !
  integer :: qbas                          !
  integer :: qant                          !
  integer(kind=address_length) :: data_in  !
  complex :: passc(qband,qsb,qbas)         !
  complex :: gainc(qband,qsb,qant)         !
  real :: wgainc(qband,qsb,qant)           !
  logical :: error                         !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: isb, ib, ic, iant, kr, c_offset, isb1, isb2, ibnd, ibdata
  logical :: down_channel, down_baseline
  real :: tsys_b, w(mnbas), want(mnant), afac
  complex :: z(mnbas), zant(mnant)
  integer(kind=address_length) :: ipkc, kin
  !------------------------------------------------------------------------
  ! Code:
  kin = gag_pointer(data_in,memory)
  !
  !
  do ic = 1, r_nband
    ! Number of sidebands.
    if (r_lnsb.eq.1) then
      isb1 = r_lsband(1,ic)
      isb2 = isb1
      ibnd = 1
    else 
      isb1 = 1
      isb2 = 2
      ibnd = 0
    endif
    do ib = 1, r_nbas
      do isb=isb1, isb2
        if (down_baseline(ib) .or.   &
          down_channel(ib,ic)) then
          z(ib) = 0
          w(ib) = 0
        else
          if (ibnd.ne.0) then
            ibdata = ibnd
          else
            ibdata = isb
          endif
          call spectral_dump(kr,0,ib)
          ipkc = kin + c_offset(kr)
          afac = 1
          call retrieve_datac(qband,qsb,qbas,   &
            memory(ipkc),ic,ibdata,ib,z(ib))
          if (do_pass.or.do_spidx) then
            z(ib) = z(ib)*passc(ic,isb,ib)
          endif
          call scaling (ic,isb,ib,z(ib),afac,error)
          if (.not.error) then
            w(ib) = 2*dh_integ*r_cfwid(ic)/tsys_b(ic,isb,ib)   &
              /afac**2
          else
            w(ib) = 0
          endif
        endif
      enddo
      call antgain (z,w,zant,want)
      do iant = 1, r_nant
        gainc(ic,isb,iant) = zant(iant)
        wgainc(ic,isb,iant) = want(iant)
      enddo
    enddo
  enddo
  return
end subroutine gain_cont
!
subroutine gain_line (qntch,qsb,qbas,qant,   &
    data_in,passl,gainl,wgainl,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Compute the antenna gains from temporal data
  ! Arguments
  !     QSB     INTEGER   Number of sidebands (2)
  !     QNTCH   INTEGER   Number of spectral channels
  !     QANT    INTEGER   Number of antennas
  !     QBAS    INTEGER   Number of baselines
  !     DATL(QNTCH,QSB,QBAS)   COMPLEX  Spectral data
  !     PASSL(QNTCH,QSB,QBAS)  COMPLEX  PassBand of spectral data
  !     GAINL(QNTCH,QSB,QANT)  COMPLEX  Antenna gains (spectral data)
  !     WGAINL(QNTCH,QSB,QANT) REAL     Weight of antenna gain
  ! Call Tree
  !	...	SUB_READ_SPEC
  !---------------------------------------------------------------------
  integer :: qntch                         !
  integer :: qsb                           !
  integer :: qbas                          !
  integer :: qant                          !
  integer(kind=address_length) :: data_in  !
  complex :: passl(qntch,qsb,qbas)         !
  complex :: gainl(qntch,qsb,qant)         !
  real :: wgainl(qntch,qsb,qant)           !
  logical :: error                         !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: isb, ib, ic, ny, k, i, iant, jok(mch), l_offset, kr
  integer :: jokant(mch,mnant)
  integer :: ia, ja
  integer :: isb1, isb2, ibnd, ibdata
  logical :: down_channel, down_baseline
  real :: tsys_b, w(mnbas), want(mnant), afac
  complex :: z(mnbas), zant(mnant)
  integer(kind=address_length) :: ipkl, kin
  !------------------------------------------------------------------------
  ! Code:
  kin = gag_pointer(data_in,memory)
  !
  !
  !
  do ic=1, r_lband
    ! Number of sidebands.
    if (r_lnsb.eq.1) then
      isb1 = r_lsband(1,ic)
      isb2 = isb1
      ibnd = 1
    else 
      isb1 = 1
      isb2 = 2
      ibnd = 0
    endif
    do isb=isb1, isb2
      ny = r_lnch(ic)
      call jlimits(ny,0,0,ngibbs,jok)
      do iant = 1, mnant
        do i = 1, ny
          jokant(i,iant) = jok(i)
        enddo
        call jmask(ny,nmask(ic,iant),cmask(:,:,ic,iant),jokant(1,iant))
      enddo
      !$OMP PARALLEL &
      !$OMP & SHARED(gainl,wgainl,ny,r_lich,ic,r_nbas,ibnd,isb,kin) &
      !$OMP & SHARED(qntch,qsb,qbas,memory,do_pass,do_spidx,passl) &
      !$OMP & SHARED(dh_integ,r_lfres,r_nant,jokant,jok,r_iant,r_jant) &
      !$OMP & PRIVATE(i,k,ib,ibdata,ipkl,kr,afac,z,w,iant,error,zant,want,ia,ja) & 
      !$OMP & DEFAULT(none)
      !
      !$OMP DO
      do i = 1, ny
        error = .false.
        k = r_lich(ic)+i
        do ib = 1, r_nbas
          if (ib.le.mnbas) then
            ia = r_iant(ib)
            ja = r_jant(ib)
          else
            ia = 1
            ja = ia
          endif
          if (down_baseline(ib) .or.   &
            down_channel(ib,ic+mbands) .or.   &
            jokant(i,ia).eq.0 .or. jokant(i,ja).eq.0) then
            z(ib) = 0
            w(ib) = 0
          else
            if (ibnd.ne.0) then
              ibdata = ibnd
            else
              ibdata = isb
            endif
            call spectral_dump(kr,0,ib)
            ipkl = kin + l_offset(kr)
            afac = 1
            call retrieve_datal(qntch,qsb,qbas,   &
              memory(ipkl),k,ibdata,ib,z(ib))
            if (do_pass.or.do_spidx) then
              z(ib) = z(ib)*passl(k,isb,ib)
            endif
            call scaling (ic,isb,ib,z(ib),afac,error)
            if (.not.error)  then
              w(ib) = 2*dh_integ*abs(r_lfres(ic))/tsys_b(ic   &
                ,isb,ib)/afac**2
            else
              w(ib) = 0
            endif
          endif
        enddo
        if (jok(i).ne.0) then
          call antgain (z,w,zant,want)
          do iant = 1, r_nant
            gainl(k,isb,iant) = zant(iant)
            wgainl(k,isb,iant) = want(iant)
          enddo
        else
          do iant = 1, r_nant
            gainl(k,isb,iant) = 0
            wgainl(k,isb,iant) = 0
          enddo
        endif
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
    enddo
  enddo
  return
end subroutine gain_line
!
!
subroutine antgain(z,w,zant,want)
  use gildas_def
  !---------------------------------------------------------------------
  ! CLIC
  !     Derive antenna "gains" from baseline visibilities
  ! Arguments:
  !     Z(MNBAS)    COMPLEX   Visibility
  !     W(MNBAS)    REAL      Weight
  !     ZANT(MNANT) COMPLEX   Complex antenna gain
  !     WANT(MNANT) REAL      Weight
  ! Call Tree
  !	...	GAIN_CONT
  !	...	GAIN_LINE
  !	...	ARECORD
  !	...	CONT_AVERAGE
  !	...	SUB_SOLVE_PASS
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  complex :: z(mnbas)               !
  real*4 :: w(mnbas)                !
  complex :: zant(mnant)            !
  real*4 :: want(mnant)             !
  include 'clic_clic.inc'
  ! Code
  if (new_ant_gain) then
    call new_antgain(z,w,zant,want)
  else
    call old_antgain(z,w,zant,want)
  endif
end subroutine antgain
!
!
subroutine new_antgain (z,w,zant,want)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !     Derive antenna "gains" from baseline visibilities
  ! Arguments:
  !     Z(MNBAS)    COMPLEX   Visibility
  !     W(MNBAS)    REAL      Weight
  !     ZANT(MNANT) COMPLEX   Complex antenna gain
  !     WANT(MNANT) REAL      Weight
  ! Call Tree
  !	...	GAIN_CONT
  !	...	GAIN_LINE
  !	...	ARECORD
  !	...	CONT_AVERAGE
  !	...	SUB_SOLVE_PASS
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  complex :: z(mnbas)               !
  real*4 :: w(mnbas)                !
  complex :: zant(mnant)            !
  real*4 :: want(mnant)             !
  ! Global
  include 'gbl_pi.inc'
  include 'clic_constant.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  ! Local
  real*4 :: aa, faz, wl(mnbas)
  complex :: zl(mnbas)
  integer :: ib, ia, base, iref, itry, i, nant2, nant, repl, ia1
  integer :: irepl(r_nant),nbas,nrem
  parameter (nant2=mnant**2)
  logical :: refok, error
  real*8 :: yy(mnbas), wy(mnbas), ss(mnbas)
  real*8 :: wk2(nant2), wk3(mnant)
  real*8 :: amp(mnant), wamp(mnant), pha(mnant), wpha(mnant)
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Solve for phases, using retroprojection algorithm:
  !
  nant = r_nant
  nbas = r_nbas
  repl = 0
  !
  ! Copy baseline based values into local variables
  do ib = 1, mnbas
    wl(ib) = w(ib)
    zl(ib) = z(ib)
  enddo
  !
  ! Find if there are flagged antennas
  do ia = 1, r_nant
    want(ia) = 0
    do ia1 = 1, r_nant
      if (ia1.ne.ia) then
        ib = base(ia,ia1)
        want(ia) = want(ia) + wl(ib)
      endif
    enddo
    if (want(ia).eq.0) then
      repl = repl + 1
      irepl(repl) = ia
    endif
  enddo
  !
  ! Reduce arrays accordingly
  ! Iterate on flagged antennas in decreasing logical order
  if (repl.ne.0) then
    nrem = 0
    do i = repl, 1, -1
      !
      ! If the flagged antenna I is the last, do nothing
      ! else first remove all baselines IJ with J>I
      if(irepl(i).ne.nant) then
        do ia = nant,irepl(i)+1,-1
          do ib = (ia-2)*(ia-1)/2+irepl(i),nbas
            wl(ib) = wl(ib+1)
            zl(ib) = zl(ib+1)
          enddo
          nrem = nrem + 1
        enddo
        !
        ! Then remove all baseline IJ with J<I
        ib = 1+(irepl(i)-2)*(irepl(i)-1)/2
        do ia = ib,nbas
          zl(ia) = zl(ia+irepl(i)-1)
          wl(ia) = wl(ia+irepl(i)-1)
        enddo
      endif
      !
      ! Reduce array and modify reference antenna if needed
      nant = nant - 1
      nbas = nant * (nant - 1) / 2
      if (iref.gt.irepl(i)) then
        iref =  iref - 1
      endif
    enddo
  endif
  !
  ! No baseline survived for this channel after flagging/masking.
  ! In that case there is no antenna-based solve to perform.
  if (nant.le.1 .or. nbas.le.0) then
    do ia = 1, r_nant
      zant(ia) = 1.
      want(ia) = 0.
    enddo
    return
  endif
  !
  ! Find reference antenna for phase
  refok = .false.
  error = .false.
  iref = ref_ant
  itry = 1
  do while (.not.refok .and. itry.le.r_nant)
    do ia=1, nant
      if (ia.lt.iref) then
        ib = base(ia,iref)
        refok = refok .or. wl(ib).gt.0
      elseif (ia.gt.iref) then
        ib = base(iref,ia)
        refok = refok .or. wl(ib).gt.0
      endif
    enddo
    if (.not.refok) then
      itry = itry+1
      iref = mod(iref,r_nant)+1
    endif
  enddo
  !
  ! Phases
  do ib = 1, nbas
    yy(ib) = faz(zl(ib))
    wy(ib) = wl(ib)
  enddo
  !
  ! Phases
  call gain_ant(2, nbas, r_iant, r_jant, iref,   &
    nant, yy, wy, wk2, wk3, ss, pha, wpha, error)
  !
  ! Amplitudes
  do ib = 1, nbas
    aa = abs(zl(ib))
    yy(ib) = log(aa)
    wy(ib) = wl(ib)*aa**2
  enddo
  call gain_ant(1, nbas, r_iant, r_jant, iref,   &
    nant, yy, wy, wk2, wk3, ss, amp, wamp, error)
  !
  do ia=1, r_nant
    aa = exp(2*amp(ia))
    zant(ia) = aa * exp(cmplx(0.,pha(ia)))
    want(ia) = wamp(ia)/aa**2
  enddo
  !
  ! Special case: less than 3 antennas
  if (nant.lt.3) then
    do ia = 1, nant
      do ib=1, nbas
        if (wl(ib).gt.0) then
          amp(ia) = abs(zl(ib))
          pha(ia) = faz(zl(ib))
          want(ia) = wl(ib)
        endif
      enddo
      zant(ia) = amp(ia) * exp(cmplx(0.,pha(ia)))
    enddo
  endif
  !
  ! Subsitute back flagged value
  if (repl.ne.0) then
    do i = 1,repl ,1
      do ia = nant,max(1,nant-(r_nant-irepl(i))+1),-1
        zant(ia+1) = zant(ia)
        want(ia+1) = want(ia)
      enddo
      nant = nant + 1
      zant(irepl(i))=1
      want(irepl(i))=0
    enddo
  endif
  !
  return
end subroutine new_antgain
!
!
subroutine old_antgain (z,w,zant,want)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !     Derive antenna "gains" from baseline visibilities
  ! Arguments:
  !     Z(MNBAS)    COMPLEX   Visibility
  !     W(MNBAS)    REAL      Weight
  !     ZANT(MNANT) COMPLEX   Complex antenna gain
  !     WANT(MNANT) REAL      Weight
  ! Call Tree
  !	...	GAIN_CONT
  !	...	GAIN_LINE
  !	...	ARECORD
  !	...	CONT_AVERAGE
  !	...	SUB_SOLVE_PASS
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  complex :: z(mnbas)               !
  real*4 :: w(mnbas)                !
  complex :: zant(mnant)            !
  real*4 :: want(mnant)             !
  ! Global
  include 'gbl_pi.inc'
  include 'clic_constant.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  ! Local
  real*4 :: pha(mnant), amp(mnant), aa, faz, wa, add, aji, aki, ajk
  real*4 :: pha0(mnant)
  integer :: ib, ia, j_i, k_i, j_k, ja, ka, base, iref, itry, i
  logical :: retro, refok
  parameter (retro=.false.)
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Solve for phases, using retroprojection algorithm:
  !
  refok = .false.
  iref = ref_ant
  itry = 1
  do while (.not.refok .and. itry.le.r_nant)
    do ia=1, r_nant
      if (ia.lt.iref) then
        ib = base(ia,iref)
        refok = refok .or. w(ib).gt.0
      elseif (ia.gt.iref) then
        ib = base(iref,ia)
        refok = refok .or. w(ib).gt.0
      endif
    enddo
    if (.not.refok) then
      itry = itry+1
      iref = mod(iref,r_nant)+1
    endif
  enddo
  if (.not.refok) then
    do i=1, r_nant
      pha(i) = 0
    enddo
  else
    !
    pha0(iref) = 0.
    do ia=1, r_nant
      if (ia.lt.iref) then
        ib = base(ia,iref)
        if (w(ib).gt.0) pha0(ia) = -faz(z(ib))
      elseif (ia.gt.iref) then
        ib = base(iref,ia)
        if (w(ib).gt.0) pha0(ia) = faz(z(ib))
      endif
    enddo
    do ia = 1, r_nant
      add = 0
      do ja = 1, r_nant
        if (ja.lt.ia) then
          ib = base(ja,ia)
          if (w(ib).gt.0) then
            add = add + faz(z(ib)) - pha0(ia) + pha0(ja)
          endif
        elseif (ja.gt.ia) then
          ib = base(ia,ja)
          if (w(ib).gt.0) then
            add = add - faz(z(ib)) - pha0(ia) + pha0(ja)
          endif
        endif
      enddo
      add = mod(add+31d0*pi,2d0*pi)-pi
      pha(ia) = pha0(ia)+add/r_nant
    enddo
  endif
  !
  ! solve for amplitudes, using retroprojection algorithm:
  ! (to be checked again)
  ! note:
  ! to compute this way the weights must be provided by antenna,
  ! not by baseline. (RL 2002-02-27)
  if (retro) then
    do ia = 1, r_nant
      want(ia) = 0
      amp(ia) = 0
      do ib=1, r_nbas
        if (w(ib).gt.0) then
          if (r_iant(ib).eq.ia .or. r_jant(ib).eq.ia) then
            amp(ia) = amp(ia)+log(abs(z(ib)))*wa
            want(ia) = want(ia)+wa
          else
            amp(ia) = amp(ia)-log(abs(z(ib)))*wa/(r_nant-2)
            want(ia) = want(ia)-wa/(r_nant-2)
          endif
        endif
      enddo
      if (want(ia).gt.0) then
        amp(ia) = amp(ia)/want(ia)
      else
        amp(ia) = 0.
      endif
      if (r_nant.gt.1) then
        amp(ia) = amp(ia)/(r_nant-1)
        want(ia) = want(ia)/(r_nant-1)
      endif
      zant(ia) = exp(cmplx(amp(ia),pha(ia)))
    !            if (want(ia).gt.0) WANT(IA) = EXP(WANT(IA))
    enddo
  else
    !
    ! Solve for amplitudes
    do ia = 1, r_nant
      want(ia) = 0
      amp(ia) = 0
      if (r_nant.gt.2) then
        do ja = 1, r_nant
          if (ja.ne.ia .and. ja.lt.r_nant) then
            do  ka = ja+1, r_nant
              if (ka.ne.ia) then
                j_i = base(min(ja,ia),max(ja,ia))
                k_i = base(min(ka,ia),max(ka,ia))
                j_k = base(ja,ka)
                if (z(j_k).ne.0 .and. z(j_i).ne.0 .and.   &
                  z(k_i).ne.0 .and. w(j_k).ne.0 .and.   &
                  w(j_i).ne.0 .and. w(k_i).ne.0) then
                  aji = abs(z(j_i))
                  aki = abs(z(k_i))
                  ajk = abs(z(j_k))
                  if (aji.lt.1e15 .and. aki.lt.1e15   &
                    .and. ajk.lt.1e15) then
                    aa = aji*aki/ajk
                    wa = 1./w(j_i)/abs(z(j_i))**2   &
                      +1./w(k_i)/abs(z(k_i))**2   &
                      +1./w(j_k)/abs(z(j_k))**2
                    wa = 1/aa**2/wa
                    amp(ia) = amp(ia) + aa*wa
                    want(ia) = want(ia) + wa
                  endif
                endif
              endif
            enddo
          endif
        enddo
        if (want(ia).ne.0) amp(ia) = amp(ia) / want(ia)
      endif
      !
      ! if previous algorithm did not work, take first valid baseline
      ! containing IA. This will work if there is only one operational baseline ...
      if (want(ia).le.0) then
        do ib=1, r_nbas
          if (w(ib).gt.0) then
            amp(ia) = abs(z(ib))
            want(ia) = w(ib)
          endif
        enddo
      endif
      zant(ia) = amp(ia) * exp(cmplx(0.,pha(ia)))
    !
    !            ZANT(IA) =CMPL2(AMP(IA), PHA(IA))
    !            if (amp(ia).GT.BLANK4-D_BLANK4) want(ia) = 0
    enddo
  endif
  return
end subroutine old_antgain
!
subroutine gain_ant(iy, nbas, iant, jant, iref,   &
    nant, y, w, wk2, wk3, ss, c, wc, error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     gain_ant computes a weighted least-squares approximation
  !     to the antenna amplitudes or phases
  !     for an arbitrary set of baseline data points.
  ! parameters:
  !     iy             I   Input    1 for log(amplitude), 2 for phase
  !     nbas           I   Input    the number of baselines
  !     iant(nbas)     I   Input    start antenna for each baseline
  !     jant(nbas)     I   Input    end  antenna for each baseline
  !     iref           i   Input    Reference antenna for phases
  !     nant           I   Input    the number of antennas
  !     y(m,nbas)      R8  Input    the data values
  !     w(m,nbas)      R8  Input    weights
  !     wk2(nant**2)   R8  Output   work space
  !     wk3(nant)      R8  Output   work space
  !     ss(nbas)       R8  Output   rms of fit for each baseline
  !     c(nant)        R8  Output   the gains
  !     wc(nant)        R8  Output   the output weights
  !---------------------------------------------------------------------
  integer :: iy                     !
  integer :: nbas                   !
  integer :: iant(nbas)             !
  integer :: jant(nbas)             !
  integer :: iref                   !
  integer :: nant                   !
  real*8 :: y(nbas)                 !
  real*8 :: w(nbas)                 !
  real*8 :: wk2(nant,nant)          !
  real*8 :: wk3(nant)               !
  real*8 :: ss(nbas)                !
  real*8 :: c(nant)                 !
  real*8 :: wc(nant)                !
  logical :: error                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 :: norm, tol
  parameter (tol=1d-14)
  integer :: zant, i, ia, ib, nantm1, ja, l, iter
  real*8 ::  wi, ww, yi
  !------------------------------------------------------------------------
  ! Code
  !
  ! Check that the weights are positive.
  !
  do ib = 1, nbas
    if (w(ib).lt.0.0d0) then
      call gagout('E-GAIN_ANT, Weights not positive')
      error = .true.
      return
    endif
  enddo
  !
  ! Amplitude case is simple...
  !
  if (iy.eq.1) then
    do i=1,nant
      do l=1,nant
        wk2(l,i) = 0.0d0
      enddo
      wk3(i) = 0.0d0
    enddo
    !
    ! store the upper-triangular part of the normal equations in wk2
    ! and the right-hand side in wk3.
    do ib=1,nbas
      wi = w(ib)
      if (wi.gt.0) then
        ia = iant(ib)
        ja = jant(ib)
        wk2(ia,ia) = wk2(ia,ia)+wi
        wk2(ia,ja) = wk2(ia,ja)+wi
        wk2(ja,ia) = wk2(ja,ia)+wi
        wk2(ja,ja) = wk2(ja,ja)+wi
      endif
    enddo
    do ib=1, nbas
      ia = iant(ib)
      ja = jant(ib)
      wi = w(ib)*y(ib)
      wk3(ia) = wk3(ia) + wi
      wk3(ja) = wk3(ja) + wi
    enddo
    !
    ! Solve the system of normal equations by first computing the Cholesky
    ! factorization
    call mth_dpotrf ('GAIN_ANT','U',nant,wk2,nant,error)
    if (error) goto 999
    call mth_dpotrs ('GAIN_ANT','U',nant,1,wk2,nant,wk3,nant,error)
    if (error) goto 999
    do i=1,nant
      wc(i) = wk2(i,i)**2
      c(i) = wk3(i)
    enddo
  !
  ! Phase is more complicated ...
  elseif (iy.eq.2) then
    nantm1 = nant-1
    do i=1,nant
      c(i) = 0.0d0
      wc(i) = 0.0d0
    enddo
    !
    ! start iterating
    norm = 1e10
    iter = 0
    do while (norm.gt.tol .and. iter.lt.100)
      iter = iter + 1
      do i=1,nantm1
        do l=1,nantm1
          wk2(l,i) = 0.0d0
        enddo
        wk3(i) = 0.0d0
      enddo
      do ib=1,nbas
        wi = w(ib)
        if (wi.gt.0) then
          ia = zant(iant(ib),iref)
          ja = zant(jant(ib),iref)
          if (ia.ne.0) then
            wk2(ia,ia) = wk2(ia,ia)+wi
          endif
          if (ja.ne.0) then
            wk2(ja,ja) = wk2(ja,ja)+wi
          endif
          if (ia.ne.0 .and. ja.ne.0) then
            wk2(ja,ia) = wk2(ja,ia)-wi
            wk2(ia,ja) = wk2(ia,ja)-wi
          endif
        endif
      enddo
      do ib=1, nbas
        if (w(ib).gt.0) then
          yi = y(ib)
          ia = iant(ib)
          ja = jant(ib)
          yi = yi+(c(ia)-c(ja))
        else
          yi = 0
        endif
        yi = sin(yi)
        ia = zant(iant(ib),iref)
        ja = zant(jant(ib),iref)
        wi = w(ib)*yi
        if (ia.ne.0) then
          wk3(ia) = wk3(ia) - wi
        endif
        if (ja.ne.0) then
          wk3(ja) = wk3(ja) + wi
        endif
      enddo
      !
      ! Solve the system of normal equations by first computing the Cholesky
      ! factorization
      call mth_dpotrf('GAIN_ANT','U',nantm1,wk2,nant,error)
      if (error) goto 999
      call mth_dpotrs ('GAIN_ANT','U',nantm1,1,wk2,nant,   &
        wk3,nantm1,error)
      if (error) goto 999
      !  Add the result to c:
      norm = 0
      do ia=1,nant
        i = zant(ia,iref)
        if (i.ne.0) then
          ww = wk3(i)
          c(ia) = c(ia)+ww
          wc(ia) = wk2(i,i)**2
          norm = norm+ww**2
        endif
      enddo
    enddo
  endif
  return
  !
999 error = .true.
  return
end subroutine gain_ant
!
function cmpl2(amp, pha)
  !---------------------------------------------------------------------
  ! Returns a complex of given amplitude and phase
  ! Test blanking value BLANK4
  !---------------------------------------------------------------------
  complex :: cmpl2                  !
  real :: amp                       !
  real :: pha                       !
  ! Global
  include 'clic_parameter.inc'
  !-----------------------------------------------------------------------
  if ((pha.gt.blank4-d_blank4   &
    .and. pha.le.blank4+d_blank4)   &
    .or. (amp.gt.blank4-d_blank4   &
    .and. amp.le.blank4+d_blank4)) then
    cmpl2 = cmplx(blank4,blank4)
    return
  endif
  cmpl2 = amp * exp(cmplx(0,pha))
  return
end function cmpl2
!
subroutine retrieve_datac(qband,qsb,qbas,datac,ic,isb,ib,z)
  integer :: qband                  !
  integer :: qsb                    !
  integer :: qbas                   !
  complex :: datac(qband,qsb,qbas)  !
  integer :: ic                     !
  integer :: isb                    !
  integer :: ib                     !
  complex :: z                      !
  !-----------------------------------------------------------------------
  z = datac(ic,isb,ib)
  return
end subroutine retrieve_datac
!
subroutine retrieve_datal(qntch,qsb,qbas,datal,k,isb,ib,z)
  integer :: qntch                  !
  integer :: qsb                    !
  integer :: qbas                   !
  complex :: datal(qntch,qsb,qbas)  !
  integer :: k                      !
  integer :: isb                    !
  integer :: ib                     !
  complex :: z                      !
  !-----------------------------------------------------------------------
  z = datal(k,isb,ib)
  return
end subroutine retrieve_datal

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_pointing_create(backsci,drifts,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_create
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(science_backend_t), intent(in)    :: backsci  !
  type(obs_list_t),        intent(inout) :: drifts   ! Output collection of drifts
  logical,                 intent(inout) :: error    !
  ! Local
  integer(kind=4) :: ipix,iset
  character(len=*), parameter :: rname='POINTING>CREATE'
  !
  ! Sanity
  if (backsci%cumulinit) then
    ! No data accumulated, or remnants from a previous accumulation
    ! which should be ignored. Can happen if tables are zero-sized
    ! (no data or no good data), but should be trapped earlier.
    call mrtcal_message(seve%e,rname,'No data accumulated to be written')
    error = .true.
    return
  endif
  if (backsci%cumul%kind.ne.ckind_onoff) then
    call mrtcal_message(seve%e,rname,'Unexpected chunkset kind')
    error = .true.
    return
  endif
  if (backsci%cumul%ntime.ne.1) then
    call mrtcal_message(seve%e,rname,'Unexpected time dimension')
    error = .true.
    return
  endif
  !
  do ipix=1,backsci%cumul%npix
    do iset=1,backsci%cumul%nset
      call mrtcal_pointing_create_from_chunkset(  &
        backsci%cumul%chunkset(iset,ipix,1),drifts,error)
      if (error)  return
    enddo
  enddo
  !
end subroutine mrtcal_pointing_create
!
subroutine mrtcal_pointing_create_from_chunkset(chunkset,drifts,error)
  use class_types
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_create_from_chunkset
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: chunkset  !
  type(obs_list_t), intent(inout) :: drifts    ! Output collection of drifts
  logical,          intent(inout) :: error     !
  ! Local
  type(drift_book_t), pointer :: book  ! Unused
  type(observation), pointer :: obs
  !
  call drifts%new(book,obs,error)
  if (error)  return
  call mrtcal_chunkset_to_obs_ry(chunkset,obs,error)
  if (error)  return
end subroutine mrtcal_pointing_create_from_chunkset
!
subroutine mrtcal_solve_and_write_obslist(drifts,out,ndrift,error)
  use class_types
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_solve_and_write_obslist
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(obs_list_t),            intent(inout) :: drifts  ! Collection of drifts
  type(mrtcal_setup_output_t), intent(in)    :: out     ! Output configuration
  integer(kind=4),             intent(inout) :: ndrift  ! Cumulative sum of drifts written
  logical,                     intent(inout) :: error   !
  !
  integer(kind=list_k) :: idrift
  type(observation), pointer :: obs
  !
  do idrift=1,drifts%n
    call drifts%get(idrift,obs,error)
    if (error)  return
    call mrtcal_solve_pointing_observation(obs,error)
    if (error)  return
    call mrtcal_pointing_associate_array(obs,error)
    if (error)  return
    if (out%toclass) then
      call mrtcal_obs_to_class(obs,error)
      if (error)  return
    endif
    ndrift = ndrift+1
  enddo
end subroutine mrtcal_solve_and_write_obslist
!
subroutine mrtcal_solve_pointing_observation(obs,error)
  use phys_const
  use point_definitions
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_observation
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  !
  type(pointing_t) :: point
  type(point_guess_t) :: guess
  logical, parameter :: quiet = .false.
  integer(kind=4) :: ndat
  character(len=16) :: str
  character(len=*), parameter :: rname='SOLVE>POINTING>OBSERVATION'
  !
  ndat = obs%head%dri%npoin
  call init_pointing(ndat,      &  ! Number of data points
                     ndat,      &  ! Number of solution points
                     0,         &  ! ??? Pointing coordinate system
                     ' ',       &  ! ??? Pointing direction in above system
                     'SINGLE',  &  ! i.e. GAUSSIAN+BASE
                     point,error)
  if (error)  goto 100
  !
  point%dat%x(:) = obs%datav(1:ndat)*sec_per_rad  !
  point%dat%y(:) = obs%data1(1:ndat)              ! R4 to R8
  point%dat%w(:) = obs%dataw(1:ndat)
  !
  call default_pointing_guess(guess)
  ! Override the gaussian width with the telescope beam. Note the width
  ! is also used by solve_pointing to sample the gaussian position on
  ! the X axis.
  guess%width%value = iram_30m_beam(obs%head%dri%freq/1.d3)
  !
  ! All parameters are free
  guess%area%fixed     = .false.
  guess%position%fixed = .false.
  guess%width%fixed    = .false.
  guess%offset%fixed   = .false.
  guess%slope%fixed    = .false.
  !
  point%fun%flag = 2  ! Needed so that 'solve_pointing' actually works
  call solve_pointing(point,guess,quiet,error)
  if (error)  goto 100
  !
  ! Transfer to observation
  call mrtcal_fit_to_obs_poi(point%fun,obs,error)
  if (error)  goto 100
  !
  call mrtcal_solve_pointing_debug()
  !
100 continue
  call free_pointing(point)
  !
contains
  !
  subroutine mrtcal_solve_pointing_debug()
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=4) :: debug,ier
    character(len=message_length) :: mess
    real(kind=4) :: vpeak,epeak
    real(kind=8) :: xmin,xmax,ymin,ymax,bval,eval,y1,y2
    integer(kind=size_length) :: ndat8,imin,imax
    logical :: altplot
    !
    debug = 0  ! Default (0=no, 1=histo, 2=points)
    ier = sic_getlog('MRTCAL_SOLVE_POINTING_DEBUG',debug)
    if (debug.le.0)  return
    !
    ! Feedback
    print *,"Values:   Area   Position    FWHM    Offset    Slope    Peak"  ! Order in fun%par(:)
    write(mess,'(a,5(1pg10.3))')  "Guesses: ",guess%area%value,      &
                                              guess%position%value,  &
                                              guess%width%value,     &
                                              guess%offset%value,    &
                                              guess%slope%value
    print *,trim(mess)
    call mrtcal_pointing_peak(obs%head%poi,vpeak,epeak,error)
    if (error)  return
    write(mess,'(a,6(1pg10.3))')  "Results: ",point%fun%par(1:5)%value,vpeak
    print *,trim(mess)
    write(mess,'(a,6(1pg10.3))')  "Errors:  ",point%fun%par(1:5)%error,epeak
    print *,trim(mess)
    write(mess,'(a,1(1pg10.3))')  "RMS:  ",point%fun%rms
    print *,trim(mess)
    !
    ! Plot
    call gr_execl('CLEAR')
    call gr_exec1('SET PLOT LANDSCAPE')
    !
    ! Limits (suited for the drift)
    ndat8 = ndat
    bval = 0.d0
    eval = -1.d0
    call gr8_minmax(ndat8,point%dat%x,bval,eval,xmin,xmax,imin,imax)
    ! Y
    bval = obs%head%dri%bad
    eval = 0.d0
    call gr8_minmax(ndat8,point%dat%y,bval,eval,ymin,ymax,imin,imax)
    !
    call mrtcal_solve_pointing_plot(debug,xmin,xmax,ymin,ymax,vpeak)
    !
    ! Limits (suited for the drift and the gaussian)
    altplot = .false.
    ! X: ensure we see the gaussian and its wings if outside the data range
    if      (point%fun%par(2)%value-2*point%fun%par(3)%value.lt.xmin) then
      xmin = point%fun%par(2)%value-2*point%fun%par(3)%value
      altplot = .true.
    endif
    if  (point%fun%par(2)%value+2*point%fun%par(3)%value.gt.xmax) then
      xmax = point%fun%par(2)%value+2*point%fun%par(3)%value
      altplot = .true.
    endif
    ! Y: ensure we see the baseline at both edges
    y1 = point%fun%par(4)%value+xmin*point%fun%par(5)%value
    y2 = point%fun%par(4)%value+xmax*point%fun%par(5)%value
    if (ymin.gt.min(y1,y2)) then
      ymin = min(y1,y2)
      altplot = .true.
    endif
    if (ymax.lt.max(y1,y2)) then
      ymax = max(y1,y2)
      altplot = .true.
    endif
    ! Y: Ensure we see the gaussian peak
    if (vpeak.gt.ymax) then
      ymax = vpeak
      altplot = .true.
    endif
    if (altplot) then
      if (.not.gtexist('<GAUSSFIT'))  &
        call gr_execl('CREATE DIRECTORY <GAUSSFIT')
      call gr_execl('CHANGE DIRECTORY <GAUSSFIT')
      call mrtcal_solve_pointing_plot(debug,xmin,xmax,ymin,ymax,vpeak)
      call gr_execl('CHANGE DIRECTORY <GREG')
    endif
    !
    call sic_wpr('Type C to continue ',str)
  end subroutine mrtcal_solve_pointing_debug
  !
  subroutine mrtcal_solve_pointing_plot(debug,xmin,xmax,ymin,ymax,vpeak)
    !-------------------------------------------------------------------
    ! Plot the drift and its fitted model in the currently selected
    ! window, with the given limits
    !-------------------------------------------------------------------
    integer(kind=4), intent(in) :: debug
    real(kind=8),    intent(in) :: xmin,xmax
    real(kind=8),    intent(in) :: ymin,ymax
    real(kind=4),    intent(in) :: vpeak
    !
    type(simple_1d) :: mysol
    integer(kind=4) :: isol
    character(len=message_length) :: mess
    real(kind=8) :: x1,x2,y1,y2
    !
    ! Apply
    write(mess,'(4(a,1pg15.7),a)') 'LIMITS ',xmin,' ',xmax,' ',ymin,' ',ymax,' /MARGIN'
    call gr_exec1(mess)
    call sic_get_dble('USER_XMIN',xmin,error)
    if (error)  return
    call sic_get_dble('USER_XMAX',xmax,error)
    if (error)  return
    call sic_get_dble('USER_YMIN',ymin,error)
    if (error)  return
    call sic_get_dble('USER_YMAX',ymax,error)
    if (error)  return
    call gr_exec1('BOX')
    !
    ! Data
    write(mess,'(a,f0.3,a)') 'SET BLANKING ',obs%head%dri%bad,' 0.0'
    call gr_exec1(mess)
    call gr8_give('X',ndat,point%dat%x)
    call gr8_give('Y',ndat,point%dat%y)
    if (debug.eq.1) then
      call gr_exec1('HISTOGRAM')
    elseif (debug.eq.2) then
      call gr_exec1('SET MARKER 4 1 0.2 45')
      call gr_exec1('POINTS')
    endif
    !
    ! Gaussian+baseline fit
    call gr_exec1('PEN /COL WEB_GREEN')
    if (.false.) then
      call gr8_give('X',point%sol%n,point%sol%x)
      call gr8_give('Y',point%sol%n,point%sol%y)
    else
      mysol%n = 512
      allocate(mysol%x(mysol%n),mysol%y(mysol%n))
      do isol=1,mysol%n
        mysol%x(isol) = xmin + (isol-1.)/(mysol%n-1)*(xmax-xmin)
      enddo
      call get_profile(point%fun,mysol)
      call gr8_give('X',mysol%n,mysol%x)
      call gr8_give('Y',mysol%n,mysol%y)
    endif
    call gr_exec1('CONNECT')
    !
    ! Some typical gaussian points
    mysol%n = 3
    mysol%x(1) = point%fun%par(2)%value-point%fun%par(3)%value/2  ! Half-maximum (left)
    mysol%x(2) = point%fun%par(2)%value                           ! Center
    mysol%x(3) = point%fun%par(2)%value+point%fun%par(3)%value/2  ! Half-maximum (right)
    call get_profile(point%fun,mysol)
    !
    ! Gaussian position (from baseline to peak)
    x1 = mysol%x(2)
    y1 = point%fun%par(4)%value+x1*point%fun%par(5)%value
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW RELOCATE ',x1,' ',y1,' /USER'
    call gr_exec1(mess)
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW LINE ',x1,' ',mysol%y(2),' /USER /CLIP'
    call gr_exec1(mess)
    !
    ! Gaussian FWHM
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW RELOCATE ',mysol%x(1),' ',mysol%y(1),' /USER'
    call gr_exec1(mess)
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW LINE ',mysol%x(3),' ',mysol%y(3),' /USER /CLIP'
    call gr_exec1(mess)
    !
    ! Baseline fit only
    call gr_exec1('PEN /COL BLUE')
    x1 = xmin
    y1 = point%fun%par(4)%value+x1*point%fun%par(5)%value
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW RELOCATE ',x1,' ',y1,' /USER'
    call gr_exec1(mess)
    x2 = xmax
    y2 = point%fun%par(4)%value+x2*point%fun%par(5)%value
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW LINE ',x2,' ',y2,' /USER /CLIP'
    call gr_exec1(mess)
    !
    ! Sanity check
    call gr_exec1('PEN /COL RED')
    if (point%fun%par(2)%value.lt.min(x1,x2).or.point%fun%par(2)%value.gt.max(x1,x2)) then
      write(mess,'(a,1pg0.3,a)') 'DRAW TEXT 0 3 "WARNING: Gaussian peak @ ',point%fun%par(2)%value,'" 5 /BOX 2'
      call gr_exec1(mess)
      write(mess,'(a,1pg0.3,a)') 'DRAW TEXT 0 2 "(the minimization used the edge of the gaussian)" 5 /BOX 2'
      call gr_exec1(mess)
    endif
    if ((y1.gt.ymax.and.y2.gt.ymax).or.(y1.lt.ymin.and.y2.lt.ymin)) then
      write(mess,'(a,1pg0.3,a)') 'DRAW TEXT 0 1 "WARNING: baseline out of plot (',point%fun%par(4)%value,' @ x=0)" 5 /BOX 2'
      call gr_exec1(mess)
    endif
    !
    ! Legend
    call gr_exec1('PEN /COL WEB_GREEN')
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -1 "Area: ',point%fun%par(1)%value,' [K.sec]" 6 /CHAR 7'
    call gr_exec1(mess)
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -2 "Position: ',point%fun%par(2)%value,' [sec]" 6 /CHAR 7'
    call gr_exec1(mess)
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -3 "FWHM: ',point%fun%par(3)%value,' [sec]" 6 /CHAR 7'
    call gr_exec1(mess)
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -4 "Peak: ',vpeak,' [K]" 6 /CHAR 7'
    call gr_exec1(mess)
    call gr_exec1('PEN /COL BLUE')
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -5 "Offset: ',point%fun%par(4)%value,' [K]" 6 /CHAR 7'
    call gr_exec1(mess)
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -6 "Slope: ',point%fun%par(5)%value,' [K/sec]" 6 /CHAR 7'
    call gr_exec1(mess)
    call gr_exec1('PEN /COL FOREGROUND')
    write(mess,'(3a)') 'DRAW TEXT 0 0.5 ',trim(obs%head%gen%teles),' /BOX 8'
    call gr_exec1(mess)
    !
    call null_simple_1d(mysol)
  end subroutine mrtcal_solve_pointing_plot
end subroutine mrtcal_solve_pointing_observation
!
subroutine mrtcal_pointing_peak(poi,vpeak,epeak,error)
  use phys_const
  use class_types
  use mrtindex_sec_pointing
  !---------------------------------------------------------------------
  ! @ private
  ! From a CLASS pointing section, return the peak value and its error.
  ! This information is redundant with the (area,position,fwhm) stored
  ! in the section.
  !---------------------------------------------------------------------
  type(class_pointing_t), intent(in)    :: poi
  real(kind=4),           intent(out)   :: vpeak  ! Peak value
  real(kind=4),           intent(out)   :: epeak  ! Peak error
  logical,                intent(inout) :: error
  !
  real(kind=4) :: fac
  real(kind=4) :: voffs,vslop,varea,vposi,vfwhm
  real(kind=4) :: eoffs,eslop,earea,eposi,efwhm
  !
  fac = 2*sqrt(log(2.)/pis)
  !
  voffs = poi%nfit(pointing_fit_offset)
  vslop = poi%nfit(pointing_fit_slope)
  varea = poi%nfit(pointing_fit_area1)
  vposi = poi%nfit(pointing_fit_posi1)
  vfwhm = poi%nfit(pointing_fit_fwhm1)
  vpeak = voffs+vslop*vposi + fac*varea/vfwhm
  !
  eoffs = poi%nerr(pointing_fit_offset)
  eslop = poi%nerr(pointing_fit_slope)
  earea = poi%nerr(pointing_fit_area1)
  eposi = poi%nerr(pointing_fit_posi1)
  efwhm = poi%nerr(pointing_fit_fwhm1)
  epeak = fac/vfwhm * sqrt(earea**2  + (varea*efwhm/vfwhm)**2)  ! ZZZ Missing the eoffs and eslope contribution
end subroutine mrtcal_pointing_peak
!
subroutine mrtcal_pointing_associate_array(obs,error)
  use class_types
  use mrtindex_sec_pointing
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_pointing_associate_array
  !---------------------------------------------------------------------
  ! @ private
  ! If the observation provides a pointing drift fit, it is modified so
  ! that:
  ! 1) RY provides the baselined pointing drift,
  ! 2) an associated array named XX provides the (original)
  !    non-baselined pointing drifts
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  !
  real(kind=4), pointer :: data1(:)
  integer(kind=4) :: ichan
  real(kind=4) :: y
  !
  if (.not.obs%head%presec(class_sec_poi_id))  return
  !
  ! Declare the reserved associated array and fetch a pointer to its
  ! data
  call class_assoc_add(obs,'POINTING',data1,error)
  if (error)  return
  data1(:) = obs%data1(:)
  !
  ! Replace original RY with its baselined version
  do ichan=1,obs%head%dri%npoin
    if (obs%data1(ichan).ne.obs%head%dri%bad) then
      y = obs%head%poi%nfit(pointing_fit_offset) +  &
          obs%head%poi%nfit(pointing_fit_slope) * obs%datav(ichan)
      obs%data1(ichan) = obs%data1(ichan) - y
    endif
  enddo
end subroutine mrtcal_pointing_associate_array
!
subroutine mrtcal_pointing_classify(mrtset,idrifts,sdrifts,error)
  use phys_const
  use mrtcal_messaging
  use toc_types
  use class_toc_parameters
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_classify
  !---------------------------------------------------------------------
  ! @ private
  ! Gtaher drifts by equivalence class and solve each class.
  !---------------------------------------------------------------------
  type(mrtcal_setup_t), intent(in)    :: mrtset   !
  type(obs_list_t),     intent(in)    :: idrifts  ! Collection of individual drifts
  type(obs_list_t),     intent(inout) :: sdrifts  ! Collection of averaged and solved drifts
  logical,              intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>AVERAGE'
  integer(kind=4) :: toc_keys(2)
  type(toc_selection_t) :: select
  integer(kind=entry_length) :: iequ
  type(drift_book_t), pointer :: book
  type(observation), pointer :: obs
  integer(kind=4) :: nkeys,ikey
  !
  select case (mrtset%sol%poimix)
  case (mixmode_entry)     ! Unique entry
                           ! i.e. no mixing
    nkeys = 1
    toc_keys(1) = class_toc_key_entry
  case (mixmode_drift)     ! Unique telescope and unique drift
                           ! i.e. mixed directions (e.g. 0+180)
    nkeys = 2
    toc_keys(1) = class_toc_key_telescope
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fesbdrift) ! Unique frontend, unique sideband and unique drift
                           ! i.e. mixed polarizations and mixed directions
    nkeys = 2
    toc_keys(1) = class_toc_key_fesb
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fesbdirec) ! Unique frontend, unique sideband and unique direction
                           ! i.e. mixed polarizations
    nkeys = 2
    toc_keys(1) = class_toc_key_fesb
    toc_keys(2) = class_toc_key_direction
  case (mixmode_fedrift)   ! Unique frontend and unique drift
                           ! i.e. mixed polarizations, sidebands, and directions
    nkeys = 2
    toc_keys(1) = class_toc_key_frontend
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fedirec)   ! Unique frontend and unique direction
                           ! i.e. mixed polarizations and sidebands
    nkeys = 2
    toc_keys(1) = class_toc_key_frontend
    toc_keys(2) = class_toc_key_direction
  case default
    call mrtcal_message(seve%e,rname,'MSET SOLVE POINTING mode not implemented')
    error = .true.
    return
  end select
  !
  call idrifts%to_selection(toc_keys(1:nkeys),select,error)
  if (error)  return
  !
  call sdrifts%final(error)
  if (error)  return
  !
  ! Fill pseudo observations (only the relevant parts needed by
  ! mrtcal_solve_pointing_observation) and perform the minimizations
  do iequ=1,select%nequ
    ! Fetch a new observation from list
    call sdrifts%new(book,obs,error)
    if (error)  return
    ! Bookkeeping for this class
    book%nkey = nkeys
    book%nobs = select%cnt(iequ)
    do ikey=1,nkeys
      book%keys(ikey)   = select%ids(ikey)
      book%values(ikey) = select%nam(iequ,ikey)
    enddo
    ! Gather this class in a single observation
    call mrtcal_solve_pointing_oneclass(idrifts,iequ,select%cnt(iequ),select%bak,obs,error)
    if (error)  return
  enddo
end subroutine mrtcal_pointing_classify
!
subroutine mrtcal_solve_pointing_oneclass(drifts,iequ,cnt,bak,obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_oneclass
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Produce the drift for one equivalence class
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts  ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: iequ    ! Eq. class identifier
  integer(kind=entry_length), intent(in)    :: cnt     ! Number of elements in this eq. class
  integer(kind=entry_length), intent(in)    :: bak(:)  ! Back pointer to original elements
  type(observation),          intent(inout) :: obs     !
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>ONECLASS'
  integer(kind=entry_length) :: idrift,ilist,list(cnt)  ! Automatic array
  type(observation), pointer :: drift
  !
  ! Get the drift numbers which go in this eq. class
  ilist = 0
  do idrift=1,drifts%n
    if (bak(idrift).eq.iequ) then
      ilist = ilist+1
      list(ilist) = idrift
    endif
  enddo
  !
  if (cnt.eq.1) then
    ! Direct export (as is), i.e. leave it irregular
    call drifts%get(list(1),drift,error)
    if (error)  return
    call copy_obs(drift,obs,error)
    if (error)  return
  else
    ! Resample and average in a single regular drift
    call mrtcal_solve_pointing_gather(drifts,list,obs,error)
    if (error)  return
  endif
  !
end subroutine mrtcal_solve_pointing_oneclass
!
subroutine mrtcal_solve_pointing_gather(drifts,list,obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Gather the drifts indentfies in the list and produce a single drift
  ! observation
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER'
  logical, parameter :: doregular=.true.
  !
  if (doregular) then
    ! Resample and average the drifts
    call mrtcal_solve_pointing_gather_regular(drifts,list,obs,error)
    if (error)  return
  else
    ! Concatenate and sort the data points
    call mrtcal_solve_pointing_gather_irregular(drifts,list,obs,error)
    if (error)  return
  endif
end subroutine mrtcal_solve_pointing_gather
!
subroutine mrtcal_solve_pointing_gather_regular(drifts,list,obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather_regular
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Resample each irregular drift to a common axis and average them.
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER>REGULAR'
  integer(kind=entry_length) :: ilist
  integer(kind=list_k) :: iref,idrift
  type(observation), pointer :: ref,drift
  type(resampling) :: axis
  type(observation) :: tmp
  real(kind=4) :: cbad,weight
  logical :: stele_c(12)
  logical, parameter :: contaminate=.true.
  logical, parameter :: weight_update=.true.
  !
  ! Use the first drift as reference. All drifts have a regular axis
  ! declared which is a good approximation of the irregular axis.
  iref = list(1)
  call drifts%get(iref,ref,error)
  if (error)  return
  cbad = ref%head%dri%bad
  axis%nchan = ref%head%dri%npoin
  axis%ref   = ref%head%dri%rpoin
  axis%val   = ref%head%dri%aref
  axis%inc   = ref%head%dri%ares
  axis%unit  = 'A'
  axis%shape = ''   ! Only for FFT resampling
  axis%width = 1.0  ! Only for FFT resampling
  !
  ! Initialize output sum
  ! - Minimalist header (more to be done for a real drift in CLASS)
  call copy_header(ref%head,obs%head)
  obs%head%presec(class_sec_xcoo_id) = .false.
  stele_c(:) = .true.
  ! obs%head%dri%apos  = ref%head%dri%apos   ZZZ need specific mixing function i.e. 0,180 give 0
  ! - Data area
  call reallocate_obs(obs,axis%nchan,error)  ! Is this useful?
  if (error)  return
  obs%spectre(:) = 0.
  obs%dataw(:) = 0.
  !
  ! Initialize temporary observation
  call class_obs_init(tmp,error)
  if (error)  return
  !
  do ilist=1,size(list)
    idrift = list(ilist)
    call drifts%get(idrift,drift,error)
    if (error)  return
    ! --- Header update ---
    if (drift%head%gen%subscan.ne.obs%head%gen%subscan)  &
      obs%head%gen%subscan = 0
    call sumlin_header_telescope(drift%head%gen%teles,stele_c,obs%head%gen%teles)
    ! --- Data update ---
    call copy_obs(drift,tmp,error)
    if (error)  exit
    call obs_weight_time(rname,tmp,weight,error,verbose=.true.)
    if (error)  exit
    ! From irregular axis to regular: use CLASS RESAMPLE
    tmp%cbad = cbad
    tmp%datax = tmp%datav
    call class_resample_obs(tmp,axis,.false.,error)
    if (error)  exit
    ! Average in running sum
    tmp%dataw(:) = weight
    call simple_waverage(tmp%spectre,tmp%dataw,cbad,  &
                         obs%spectre,obs%dataw,cbad,  &
                         1,axis%nchan,contaminate,weight_update)
  enddo
  ! Recompute regularized X axis in DATAV (used for minimization)
  call abscissa_angl_r8(obs%head,obs%datav,1,obs%head%dri%npoin)
  !
  call class_obs_clean(tmp,error)
  if (error)  return
end subroutine mrtcal_solve_pointing_gather_regular
!
subroutine mrtcal_solve_pointing_gather_irregular(drifts,list,obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather_irregular
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Gather the drifts identifies in the list and produce a single drift
  ! observation. Just concatenate and sort the (X,Y) data point, leave
  ! the observation irregular.
  ! This solution is well suited for minimization of the point cloud,
  ! but can not be extensively used in CLASS. In particular, such an
  ! irregular axis does not behave well with the RESAMPLE command.
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER'
  integer(kind=entry_length) :: ilist
  type(observation), pointer :: ref,drift
  integer(kind=list_k) :: iref,idrift
  integer(kind=4) :: ndata,first,last,npoin,ier
  real(kind=4), allocatable :: buf(:)
  integer(kind=4), allocatable :: key(:)
  !
  iref = list(1)  ! Select 1st obs in its class as reference
  call drifts%get(iref,ref,error)
  if (error)  return
  !
  ! Precompute the number of points for this class
  ndata = 0
  do ilist=1,size(list)
    idrift = list(ilist)
    call drifts%get(idrift,drift,error)
    if (error)  return
    ndata = ndata+drift%head%dri%npoin
  enddo
  call reallocate_obs(obs,ndata,error)
  if (error)  return
  !
  ! Minimalist header (more to be done for a real drift in CLASS)
  call copy_header(ref%head,obs%head)
  ! obs%head%gen%teles = ref%head%gen%teles  ZZZ need specific mixing function
  ! obs%head%dri%apos  = ref%head%dri%apos   ZZZ need specific mixing function i.e. 0,180 give 0
  !
  ! Collect points
  first = 1
  do ilist=1,size(list)
    idrift = list(ilist)
    call drifts%get(idrift,drift,error)
    if (error)  return
    npoin = drift%head%dri%npoin
    last = first+npoin-1
    obs%datav(first:last) = drift%datav(1:npoin)
    obs%data1(first:last) = drift%data1(1:npoin)
    obs%dataw(first:last) = drift%dataw(1:npoin)
    first = last+1
  enddo
  obs%head%dri%npoin = ndata  ! = last
  !
  ! Sort the points
  allocate(buf(ndata),key(ndata),stat=ier)
  if (failed_allocate(rname,"sorting buffers",ier,error))  return
  call gr8_trie(obs%datav,key,ndata,error)
  if (error)  return
  call gr4_sort(obs%data1,buf,key,ndata)
  if (error)  return
  call gr4_sort(obs%dataw,buf,key,ndata)
  if (error)  return
end subroutine mrtcal_solve_pointing_gather_irregular
!
!--------------------------------------------------------------------------
!
subroutine mrtcal_solve_pointing_user_feedback(backsci,setout,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_solve_pointing_user_feedback
  use mrtcal_buffers
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_user_feedback_tool
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(science_backend_t),     intent(in)    :: backsci
  type(mrtcal_setup_output_t), intent(in)    :: setout
  logical,                     intent(inout) :: error
  !
  type(user_feedback_t) :: user
  character(len=*), parameter :: rname='SOLVE>POINTING>USER>FEEDBACK'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call user_feedback_head(error)
  if (error) return
  call user%allocate_and_init(backsci%head%poi%nsol,error)
  if (error) return
  call user_feedback_perobs(backsci%head,error)
  if (error) return
  call user%sort_by_freq_direction_idfe(error)
  if (error) return
  call user%list(error)
  if (error) return
  if (setout%restable) then
     call user%tofile(backsci%head,error)
     if (error) return
  endif
  !
contains
  !
  subroutine user_feedback_perobs(head,error)
    use phys_const
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    type(mrtindex_header_t), intent(in)    :: head
    logical,                 intent(inout) :: error
    ! Local
    integer(kind=4) :: iobs,color
    real(kind=8) :: bad
    real(kind=8) :: mfreq,mangle,mhpbw
    real(kind=8) :: varea,vposi,vfwhm,voffs,vslop,vcorr ! Values
    real(kind=8) :: earea,eposi,efwhm,eoffs,eslop,ecorr ! Errors
    character(len=8) :: mfrontend,mbackend
    character(len=message_length) :: result
    !
    do iobs=1,head%poi%nsol
!!$      call calibrate_user_feedback_compute_perpixel(gr8_compute,  &
!!$           backcal,ipix,                                          &
!!$           mfrontend,mfreq,mthot,mtcold,mtrec,mtsys,mtcal,mtau,mh2o,error)
!!$      if (error) return
       !
       bad = head%poi%sol(iobs)%dri%bad
       !
       mfrontend = head%poi%sol(iobs)%gen%teles(4:)
       mbackend = backends_mrtcal(head%key%backend)
       mfreq = head%poi%sol(iobs)%dri%freq/1d3
       mangle = head%poi%sol(iobs)%dri%apos*deg_per_rad
       mhpbw = iram_30m_beam(mfreq)
       !
       voffs = head%poi%sol(iobs)%poi%nfit(pointing_fit_offset)*1d3            ! [mK]
       vslop = head%poi%sol(iobs)%poi%nfit(pointing_fit_slope)/sec_per_rad*1d3 ! [mK/arcsec]
       varea = head%poi%sol(iobs)%poi%nfit(pointing_fit_area1)*sec_per_rad     ! [K.arcsec]
       vposi = head%poi%sol(iobs)%poi%nfit(pointing_fit_posi1)*sec_per_rad     ! [arcsec]
       vfwhm = head%poi%sol(iobs)%poi%nfit(pointing_fit_fwhm1)*sec_per_rad     ! [arcsec]
       vcorr = pointing_collimation(head%poi%sol(iobs)%dri)                    ! [rad]
       if (vcorr.ne.bad)  vcorr = vcorr*sec_per_rad+vposi                      ! [arcsec]
       !
       eoffs = head%poi%sol(iobs)%poi%nerr(pointing_fit_offset)*1d3            ! [mK]
       eslop = head%poi%sol(iobs)%poi%nerr(pointing_fit_slope)/sec_per_rad*1d3 ! [mK/arcsec]
       earea = head%poi%sol(iobs)%poi%nerr(pointing_fit_area1)*sec_per_rad     ! [K.arcsec]
       eposi = head%poi%sol(iobs)%poi%nerr(pointing_fit_posi1)*sec_per_rad     ! [arcsec]
       efwhm = head%poi%sol(iobs)%poi%nerr(pointing_fit_fwhm1)*sec_per_rad     ! [arcsec]
       ecorr = eposi                                                           ! [arcsec]
       !
       vfwhm = vfwhm/mhpbw
       efwhm = efwhm/mhpbw
       call user_feedback_oneline(&
            mfrontend,&
            mbackend,&
            mfreq,&
            mangle,&
            vcorr,ecorr,&
            varea,earea,&
            vposi,eposi,&
            vfwhm,efwhm,&
            voffs,eoffs,&
            vslop,eslop,&
            bad,&
            result,color)
       call user%fill(iobs,mfrontend,mfreq,mangle,result,color)
    enddo ! iobs
  end subroutine user_feedback_perobs
  !
  subroutine user_feedback_oneline(frontend,backend,freq,angle,  &
       vcorr,ecorr,varea,earea, &
       vposi,eposi,vfwhm,efwhm, &
       voffs,eoffs,vslop,eslop,bad,oneline,color)
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    character(len=*), intent(in)  :: frontend
    character(len=*), intent(in)  :: backend
    real(kind=8),     intent(in)  :: freq
    real(kind=8),     intent(in)  :: angle
    real(kind=8),     intent(in)  :: vcorr,ecorr
    real(kind=8),     intent(in)  :: varea,earea
    real(kind=8),     intent(in)  :: vposi,eposi
    real(kind=8),     intent(in)  :: vfwhm,efwhm
    real(kind=8),     intent(in)  :: voffs,eoffs
    real(kind=8),     intent(in)  :: vslop,eslop
    real(kind=8),     intent(in)  :: bad
    character(len=*), intent(out) :: oneline
    integer(kind=4),  intent(out) :: color        ! Colorization code
    !
    real(kind=8) :: snr
    !
    snr = abs(varea/earea)
    write(oneline,100)  frontend,&
                        user_feedback_format_onedouble(5,'f5.1',freq,bad),&
                        backend,&
                        user_feedback_format_onedouble(6,'f6.1',angle,bad),&
                        user_feedback_format_onedouble(6,'f6.1',vcorr,bad),&
                        user_feedback_format_onedouble(6,'f6.1',vposi,bad),&
                        user_feedback_format_onedouble(6,'f6.1',eposi,bad),&
                        user_feedback_format_onedouble(6,'f6.2',vfwhm,bad),&
                        user_feedback_format_onedouble(6,'f6.2',efwhm,bad),&
                        nint(snr),&
                        user_feedback_format_onedouble(6,'f6.1',varea,bad),&
                        user_feedback_format_onedouble(6,'f6.1',earea,bad),&
                        nint(voffs),&
                        nint(eoffs),&
                        user_feedback_format_onedouble(6,'f6.1',vslop,bad),&
                        user_feedback_format_onedouble(6,'f6.1',eslop,bad)
    !
    if (snr.lt.10) then
       color = code_color_red
    else if (snr.lt.20) then
       color = code_color_orange
    else
       color = code_color_green
    endif
    !
100 format(t1,a5,   &  ! Frontend
           t7,a5,   &  ! Freq
           t13,a3,  &  ! Backend
           t18,a6,  &  ! Angle
           t25,a6,  &  ! Correction
           t32,a6,  &  ! Position
           t38,a6,  &  ! Position error
           t46,a6,  &  ! FWHM
           t52,a6,  &  ! FWHM error
           t60,i4,  &  ! Area SNR
           t65,a6,  &  ! Area (+1 leading blank)
           t72,a6,  &  ! Area error (+1 leading blank)
           t80,i6,  &  ! Offset
           t87,i6,  &  ! Offset error (+1 leading blank)
           t95,a6,  &  ! Slope
           t102,a6)    ! Slope error (+1 leading blank)
  end subroutine user_feedback_oneline
  !
  subroutine user_feedback_head(error)
    use mrtcal_messaging
    logical, intent(inout) :: error
    !
    character(len=message_length) :: mess
    !
    call mrtcal_separator(seve%r,rname,1,error)
    if (error) return
    write(mess,'(t1,a4,t7,a4,t13,a4,t18,a6,t25,a6,t32,a12,t46,a12,t60,a18,t80,a12,t95,a13)') &
         'idFe','freq','idBe','Angle','Correc','  Position  ', '    FWHM    ','       Area       ','   Offset    ','    Slope    '
    call mrtcal_message(seve%r,rname,mess)
    write(mess,'(t7,a5,t19,a5,t25,a6,t32,a12,t46,a12,t60,a18,t80,a13,t95,a13)') &
         '[GHz]','[deg]','[arcs]','--[arcsec]--','-[fraction]-','-[SNR]-[K.arcsec]-','----[mK]-----','-[mK/arcsec]-'
    call mrtcal_message(seve%r,rname,mess)
    mess = repeat('-',107)
    call mrtcal_message(seve%r,rname,mess)
  end subroutine user_feedback_head
end subroutine mrtcal_solve_pointing_user_feedback
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine astro_uv(line,error)
  use gildas_def
  use image_def
  use gkernel_interfaces, no_interface=>gr4_marker
  use gkernel_types
  use gbl_message
  use ast_astro
  use ast_constant
  use atm_params
  use astro_interfaces, except_this=>astro_uv
  !---------------------------------------------------------------------
  ! @ private
  ! ASTRO Support for command
  ! UV_TRACKS Station1_ .. StationN
  !       [/FRAME Max_U] #1
  !       [/HOUR Hmin Hmax] #2
  !       [/TABLE Name] #3
  !       [/HORIZON Elv] #4
  !       [/INTEGRATION T] #5
  !       [/STATIONS ALL|list] #6
  !       [/SIZE size1 nsize1 size2 nsize2 ...] #7
  !       [/OFFSET offset] #8
  !       [/WEIGHT mode [Jy_per_K Bandwidth]] #9
  !------------------------------------------------------------------------
  ! Notes:
  ! - RL 09-nov-1998 /SIZE must be given to antenna size.
  ! - OFFSET is the position of the fixed delay line which corresponds to the
  ! the first station. It is then necessary to insure that in the following
  ! the tables X(MSTAT) reflect the order in which the stations were entered
  ! in the command line.
  !
  ! Note about XX YY ZZ TT, the positions written in the station's file:
  ! TT is (or should be) the total length (in m) from the center of
  ! the aperture to a reference plane common to all beams (preferably the
  ! entrance plane of delay lines). For XX, YY and ZZ, these are the 3
  ! components of the vector going from the earth centre to the location of
  ! the station on the surface of the earth (local equatorial coordinates),
  ! with XX along this direction, YY in the W-E direction
  ! (positive towards EAST) and ZZ in the N direction. Given local horizontal
  ! (on earth surface) coordinates x,y,z of the station,
  ! x towards Local east, y toward N and z toward Zenith,
  ! the transformation matrix is :
  !
  ! XX      / 0,-sin(lat),  cos(lat) \   x
  ! YY =    | 1,        0,         0 | * y
  ! ZZ      \ 0, cos(lat),  sin(lat) /   z
  !
  ! Where lat is the latitude of the interferometer center
  ! Note about u,v,w:
  ! the transformation from the equatorial coordinates Bx,By,Bz
  ! of a Baseline B to u,v,w is given by the matrix:
  ! u       / sin(H)       , cos(H)       ,      0 \   Bx
  ! v  =    |-sin(D)*cos(H), sin(D)*sin(H), cos(D) | * By
  ! w       \ cos(D)*cos(H),-cos(D)*sin(H), sin(D) /   Bz
  ! where H is the hour angle and D the declination of the source
  !
  ! which give ellipses of centre (0, (B/lambda)*sin(d)*cos(D)), with semi-major
  ! axis (B/lambda)*cos(d) and semi-minor axis (B/lambda)*cos(d)*sin(D)
  !
  ! Taking into account a maximum throw for delay lines may be useful for
  ! RadioInterferometers too (some may have cable length limitations) but
  ! is not desirable by default for them. However, the geometrical delay between
  ! apertures ('aerials'? 'telescopes'?) is used deep in the program. To avoid
  ! problems, I suggest to define the throw of fake 'delay lines' for radio
  ! interferometers to 2 a.u = 3.0E11 m ,with OFFSET to 1 a.u.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UV_TRACK'
  !
  integer(kind=4), parameter :: iopt_frame=1
  integer(kind=4), parameter :: iopt_hour=2
  integer(kind=4), parameter :: iopt_table=3
  integer(kind=4), parameter :: iopt_ho=4
  integer(kind=4), parameter :: iopt_int=5
  integer(kind=4), parameter :: iopt_stations=6
  integer(kind=4), parameter :: iopt_size=7
  integer(kind=4), parameter :: iopt_offset=8
  integer(kind=4), parameter :: iopt_weight=9
  !
  integer(kind=4), parameter :: mstat=300,mlist=20
  integer(kind=4), parameter :: visi_size=10 ! number of column of output table
  integer(kind=4), parameter :: hori_min=3 ! minimum elevation in degrees
  real(kind=4), parameter :: def_integ_time=15 ! default integration time
  !
  !
  type(uv_track_t) :: uvt
  !
  integer(kind=4) :: nstat_in, ier, nc, ii, i1, i2,iline,muv
  integer(kind=4) :: istation(mstat), nlu, nn,nskip,nces,nsize,nfilled
  type(sic_listi4_t) :: list
  character(len=12) :: name, statn,stations_in(mstat)
  character(len=132) :: clu, oldlis, stalis, delay_mess
  real(kind=4) ::  tt
  integer(kind=4) :: flag
  real(kind=4) ::  xx, yy, zz,  h, sh, ch
  real(kind=4) :: hmin, hmax, array,hh1,hh2,poff(4)
  real(kind=4) :: uk, vk, wk,  hori, uvmin,psize,throw, latitud
  real(kind=8) :: decs, az, el,avec(3), bvec(3), amat(9)
  integer(kind=4) :: i, j, k, l, ns, nh, lun, nvis
  character(len=256) :: chain
  character(len=message_length) :: mess
  character(len=132) :: fstation
  logical :: take, found(mstat), table_ok,delay_ok
  logical :: complete(mstat)
  real(kind=4) ::  frac
  integer(kind=4) ::  iused, nused, ntake,check_nsize
  integer(kind=4), parameter :: mw=3
  character(len=8) :: weight(mw)
  real(kind=4), allocatable :: myvisi(:,:),zch(:), zsh(:)
  integer(kind=4) :: ivisi
  integer :: date(7)
  character(len=16) :: d_chain
  integer :: idate
  ! Saved variables
  type(gildas), save :: xtab  ! Probably needs to be SAVE'd
  integer(kind=4), save :: count=0 ! when several succesive calls
  logical, save :: first_call = .true.
  real(kind=4), save :: extr=300.0  ! Array size in meters
  real(kind=4) :: px !page_x from sic
  character(len=filename_length), save :: file = ' ' ! output table name 
  ! Data
  data weight /'UNIFORM','AIRMASS','FULL'/
  !
  ! Check that station files is found
  if (.not.sic_query_file('astro_stations','data#dir:','.dat',fstation)) then
    ier = sic_getlog('astro_stations',fstation)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,  &
        'Failure in translation of astro_stations logical')
      error = .true.
      return
    else
      write (mess,'(a,1x,a,1x,a)') 'Station file',trim(fstation),'not found'
      call astro_message(seve%f,rname,mess)
      error = .true.
      return
    endif
  endif
  !
  ! backward compatibility to understand 3digit station names (E68 instead o E068)
  uvt%in%three_digit_name_compatible = .true.   
  !
  uvt%in%do_frame = sic_present(iopt_frame,0)
  uvt%in%do_hour=sic_present(iopt_hour,0)
  uvt%in%do_table=sic_present(iopt_table,0)
  uvt%in%do_ho=sic_present(iopt_ho,0)
  uvt%in%do_int=sic_present(iopt_int,0)
  uvt%in%do_stations=sic_present(iopt_stations,0)
  uvt%in%do_size=sic_present(iopt_size,0)
  uvt%in%do_offset=sic_present(iopt_offset,0)
  uvt%in%do_weight=sic_present(iopt_weight,0)
  !
  ! Option /FRAME
  uvt%in%user_array=0.
  if (uvt%in%do_frame) then
    call sic_r4 (line,iopt_frame,1,uvt%in%user_array,.false.,error)
    if (error) return
  endif
  !
  if (first_call) then
    ! do the frame whatever the option upon fist call
    uvt%in%do_frame = .true.
    first_call = .false.
  endif
  !
  ! The logic of /TABLE is VERY restrictive.
  !          /TABLE Name     should only be used with /FRAME
  !          /TABLE          without /FRAME can only be used
  !                          if a previous /FRAME /TABLE Name
  !                          has been given in the session.
  ! This means it is impossible to add some UV coverage to an
  ! existing UV Table...  It should be changed at some time.
  if (uvt%in%do_table) then
    if (uvt%in%do_frame) then
      ! 1st plot with /FRAME
      call sic_ch (line,iopt_table,1,chain,nc,.true.,error)
      if (error) return
      call sic_parsef(chain,file,' ','.uvt')
    elseif (sic_present(iopt_table,1)) then
      ! later call to inand
      if (len_trim(file).eq.0) then
        call astro_message(seve%e,rname,'No previous Table')
        error = .true.
        return
      endif
      call astro_message(seve%w,rname,'Table name ignored, using '//file)
    endif
  endif
  !
  uvt%in%do_all=.false.
  
  ! /STATIONS
  if (uvt%in%do_stations) then
    ! stations given through option /STATION
    if (sic_present(0,1)) then
      call astro_message(seve%e,rname,'With option /STATIONS UV_TRACKS should not have any argument ')
      error=.true.
      return
    endif
    call sic_ke(line,iopt_stations,1,stalis,nc,.true.,error)
    if (error) return
    if (stalis.eq.'ALL') then
      uvt%in%do_all = .true.
      nstat_in = -1
      if (sic_present(iopt_stations,2)) then
        call astro_message(seve%e,rname,'Argument ALL should be alone')
        error=.true.
        return
      endif
    else
      i1 = sic_start(iopt_stations,1)
      i2 = sic_end(iopt_stations,sic_narg(iopt_stations))
      stalis = line(i1:i2)
      call sic_parse_listi4('UV_TRACKS',stalis,list,mlist,error)
      if (error) return
      nstat_in = 0
      do i=1,list%nlist
        do ii=list%i1(i),list%i2(i),list%i3(i)
          if (nstat_in.ge.mstat) then
            call astro_message(seve%e,rname,'Too many stations')
            error=.true.
            return
          else
            nstat_in = nstat_in+1
            istation(nstat_in) = ii
            stations_in(nstat_in) = ''
          endif
        enddo
      enddo
    endif
  else
    ! Stations given through command arguments
    ! Stations. Check validity of names passed as 'character variables'.
    stalis = ' '
    nc = 0
    ns = 0
    if (sic_narg(0).gt.mstat) then
      call astro_message(seve%e,rname,'Too many stations entered')
      error=.true.
      return
    endif
    if (sic_narg(0).eq.0) then
      call astro_message(seve%e,rname,'No stations')
      error = .true.
      return
    endif
    if (sic_narg(0).eq.1) then
      call sic_ke (line,0,1,statn,l,.true.,error)
      if (statn(1:3).eq.'ALL') then
        call astro_message(seve%i,rname,'Using all stations from input file')
        uvt%in%do_all =.true.
        nstat_in = -1
      else
        call astro_message(seve%e,rname,'Only one station - no uv coverage')
        error = .true.
        return
      endif
    else
      do i=1, sic_narg(0)
        call sic_ke (line,0,i,statn,l,.true.,error)
        if (error) return
        if(lenc(statn).gt.0)then
          ns=ns+1
          call sic_blanc(statn,l)
          stations_in(ns)=statn(1:l)
          istation(ns) = -1
        endif
      enddo
      nstat_in = ns
      if (nstat_in.eq.0) then
        call astro_message(seve%e,rname,'No stations')
        error = .true.
        return
      endif
    endif
  endif
  !
  ! /SIZES size1 nsize1 size2 nsize2 ...
  ! Compute minimum valid UV spacing from dish sizes. For inhomogeneous arrays
  ! (i.e. for the VLT) this should be done for each baseline.
  uvt%in%nsize=1
  uvt%in%nant_size(1) = mstat
  uvt%in%sizes(1) = 0.   ! default set to no size
  ! Part related to limit in delay line
  throw = 2.0*au_m               ! essentially, ignore delay (radio interferometers)
  uvt%in%offset= au_m                   ! so the dl max is +- 1 au
  ! Note that OFFSET and THROW are updated
  !
  ! Defaults for some observatories we know of. Note that there is no external
  ! definition of THROW, nor different THROWS for pairs of telescopes.
  if (obsname(1:4).eq.'BURE'.or.obsname(1:4).eq.'NOEM'.or.obsname(1:4).eq.'PDBI') then
    uvt%in%sizes(1) = 15.0
  elseif (obsname(1:4).eq.'ALMA') then
    uvt%in%sizes(1) = 12.0
  elseif (obsname(1:4).eq.'ACA ') then
    uvt%in%sizes(1) = 7.0
  elseif (obsname(1:4).eq.'VLA ') then
    uvt%in%sizes(1) = 25.0
  elseif (obsname(1:3).eq.'SMA ') then
    uvt%in%sizes(1) = 6.0
  elseif (obsname(1:4).eq.'PARA'.or.obsname(1:4).eq.'VLT ') then
    ! Assume Main UT telescopes for the time being...
    uvt%in%nsize = 2
    uvt%in%nant_size(1) = 4
    uvt%in%sizes(1) = 8.0
    uvt%in%nant_size(2) = 2
    uvt%in%sizes(2) = 1.5
    throw   = 127
    uvt%in%offset = 0.0
  elseif  (obsname(1:4).eq.'PTI ') then
    uvt%in%sizes(1) = 0.40
    throw = 76.0               ! 2 delay lines
    uvt%in%offset = 0.0
  elseif  (obsname(1:4).eq.'GI2T') then
    uvt%in%sizes(1) = 1.50
    throw = 6.0                ! 2 delay lines
    uvt%in%offset = 0.0
  elseif  (obsname(1:4).eq.'IOTA') then
    uvt%in%sizes(1) = 0.45
    throw = 3.9                ! new iota small delay ?
    uvt%in%offset = 0.0
  endif
  ! Here one can update the default OFFSET:
  ! option /OFFSET
  ! Load the value of the fixed delay line
  if (uvt%in%do_offset) then
    call sic_r4 (line,iopt_offset,1,uvt%in%offset,.true.,error)
    if (error) then
      call astro_message(seve%e,rname,'No valid offset given')
      return
    endif
  endif
  !
  ! Size of the antennas (mostly for shadowing)
  if (uvt%in%do_size) then
    if (sic_narg(iopt_size).eq.1) then
      ! 1 size for all the antennas
      call sic_r4(line,iopt_size,1,uvt%in%sizes(1),.true.,error)
      if (error) return
      uvt%in%nant_size(1) = mstat
      nsize = 1
    else if (floor(sic_narg(iopt_size)/2.).ne.sic_narg(iopt_size)/2.) then
      call astro_message(seve%e,rname,'Option /SIZE requires an even number arguments')
      call astro_message(seve%e,rname,'/SIZE size1 number1 [size2 number2 ...]')
      error=.true.
      return
    else
      nsize = 0
      i = 1
      do while(uvt%in%nsize.lt.msize .and. i.lt.sic_narg(iopt_size))
        ! /SIZE argument SIZE and number of antennas of this size
        nsize = nsize+1
        ! Read first argument of pair: size
        call sic_r4(line,iopt_size,i,uvt%in%sizes(nsize),.true.,error)
        if (error) return
        i = i+1
        ! Read 2nd argument of pair: number of antennas with this part
        call sic_i4(line,iopt_size,i,uvt%in%nant_size(nsize),.true.,error)
        if (error) return
        i = i+1
      enddo
    endif
    check_nsize=0
    do i=1,nsize
      check_nsize=check_nsize+uvt%in%nant_size(i)
    enddo
    if (check_nsize.lt.nstat_in) then
      call astro_message(seve%e,rname,'The number of defineds sizes does not match the number of used antennas')
      return
    endif
    uvt%in%nsize=nsize
  endif
  if (uvt%in%sizes(1).eq.0) then
    call astro_message(seve%w,rname,'Antenna size unknown. No shadowing '//  &
    'warnings will be given.')
  endif
  !
  ! HORIZON option input  
  uvt%in%horizon = hori_min
  if (uvt%in%do_ho) then
    if (sic_narg(iopt_ho).gt.1) then
      call astro_message(seve%e,rname,'Too many arguments for /HORIZON option')
      error=.true.
      return
    endif
    call sic_r4  (line,iopt_ho,1,hori,.true.,error)
    if (error) return
    if (hori.gt.90) then
      call astro_message(seve%e,rname,'Sourve elevation cannot be higher than 90 degrees')
      error=.true.
      return
    endif
    if (hori.lt.hori_min) then
      uvt%in%horizon=hori_min 
      write (mess,'(a,1x,i2.0,1x,a)') 'Minimum elevation set to',hori_min,'degrees'
      call astro_message(seve%w,rname,mess)
    else
      uvt%in%horizon=hori
    endif
  endif
  !
  ! option /HOUR_ANGLE
  if (uvt%in%do_hour) then
    call sic_r4 (line,iopt_hour,1,hh1,.true.,error)
    if (error) return
    hh2=-hh1
    ! default is symetric wrt transit
    call sic_r4 (line,iopt_hour,2,hh2,.false.,error)
    if (error) return
    uvt%in%in_h1=min(hh1,hh2)
    uvt%in%in_h2=max(hh1,hh2)    
  endif
  !
  ! /INTEGRATION Option
  uvt%in%integ_time = def_integ_time
  if (uvt%in%do_int) then
    call sic_r4 (line,iopt_int,1,uvt%in%integ_time,.true.,error)
    if (error) return
    if (uvt%in%integ_time.le.0) then
      call astro_message(seve%e,rname,'integration time should be longer than 0')
      error=.true.
      return
    endif
  endif
  write(mess,'(A,1PG10.3,A)') 'Integration time ',uvt%in%integ_time,' min'
  call astro_message(seve%i,rname,mess)
  !
  ! /WEIGHT option
  uvt%in%wkey = 1
  if (uvt%in%do_weight) then
    call sic_ke (line,iopt_weight,1,chain,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,chain,name,uvt%in%wkey,weight,mw,error)
    if (error) return
    call astro_message(seve%i,rname,'Weighting mode is '//name)
    if (name.eq.'FULL') then
      call sic_r4 (line,iopt_weight,3,bandwidth,.true.,error)
      if (error) return
      call sic_r4 (line,iopt_weight,2,jy_per_k,.true.,error)
      if (error) return       
      ! Make sure the Frequencies are set properly by default
      if (freq.ne.freqs) then
        freqs = freq
        freqi = freq
        gim   = 0.0
      endif
    else
      if (sic_present(iopt_weight,2)) then
        call astro_message(seve%e,rname,'Too many arguments for option /WEIGHT')
        error=.true.
        return
      endif
    endif
  else
    bandwidth = 1.0
  endif
  !
  ! END OF COMMAND PARSING
  !
  ! START OF WORK
  !
  ! 1. Check that source goes above the elevation limit and that there is no problem with hour angle limits
  ! Need current source today Declination
  call sic_get_dble('DEC',decs,error)
  if (error) return
  latitud = lonlat(2)
  hmin = a_lever(sngl(decs),latitud,uvt%in%horizon)
  if (hmin.ge.0) then
    call astro_message(seve%e,rname,'Source is not visible')
    error = .true.
    return
  endif
  hmax = -hmin
  ! Default range is rise to set
  uvt%in%h1=hmin
  uvt%in%h2=hmax
  ! Limit the range if requested
  if (uvt%in%do_hour) then
    if (uvt%in%in_h1.lt.hmin) then
      write(mess,'(A,1PG10.3)') 'Source rises only at ',hmin
      call astro_message(seve%w,rname,mess)      
    endif
    uvt%in%h1=max(uvt%in%in_h1,hmin)
    if (uvt%in%in_h2.gt.hmax) then
      write(mess,'(A,1PG10.3)') 'Source sets at ',hmax
      call astro_message(seve%w,rname,mess)
    endif
    uvt%in%h2=min(uvt%in%in_h2,hmax)
  endif
  !
  !2. Compute Hour angle range (one data point every 15mn; just OK for Bure but
  ! a shorter interval is needed for long VLA configurations or the VLT).
  ! to allow any integration time
  frac = uvt%in%integ_time/60. ! in hour
  inttime = uvt%in%integ_time*60. ! needed for atm computation in /weight, full mode
  !
  ! Conservative guess size of table with hours for which we will compute the uv
  muv = ceiling((uvt%in%h2-uvt%in%h1)/frac)+2 ! +2 to avoid issues with rounding 
  allocate(zch(muv),zsh(muv),stat=ier)
  if (failed_allocate(rname,'elevation table',ier,error))  return  
  nh = 0
  h = pi*uvt%in%h1/12.0
  do while (h.le.pi*uvt%in%h2/12.0)
    ch = cos(h)
    sh = sin(h)
    nh = nh + 1
    zch(nh) = ch
    zsh(nh) = sh
    h = h+pi*frac/12.0
  enddo
  !
  !Get best coverage from header Line of station file
  call uv_get_arraysize(rname,fstation,array,nskip,poff,error)
  if (error) return
  !
  if (uvt%in%do_frame) then
  ! Frame : Reset coverage and station list
    call uv_reset_plot(rname,uvt%in,array,extr,freq,error)
    if (error) return
    count = 0
    oldlis = ' '
  else
    oldlis = stalis
  endif
  !
  ! Get and plot stations
  call sic_get_real('page_x',px,error)
  if (px.gt.21) then
     call gr_exec('SET BOX 20 30 9 19')
  else
     call gr_exec('SET BOX 3 12 18 28')
  endif
  if (gr_error()) then
    error=.true.
    return
  endif
  !
  if (uvt%in%do_frame) then
    write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-array+poff(1),array+poff(2),-array+poff(3),array+poff(4)
    ! poff depends on observatory station file format
    !
    call gr_exec1(chain)
    if (gr_error()) then
      error=.true.
      return
    endif
  endif
  ! Init found variable
  do i=1,mstat
    found(i) =.false.
  enddo
  ! Useful values for conversion/plots
  uvt%ang%sd = sin(decs)
  uvt%ang%cd = cos(decs)
  uvt%ang%sp = sin(pi*(lonlat(2))/180.0d0)
  uvt%ang%cp = cos(pi*(lonlat(2))/180.0d0)
  !
  call gr_segm('ARRAY',error)
  !
  ! Init the reading of the station file
  iline= 0
  nn = 0
  iused = 1
  nused = 0
  ier = sic_getlun (lun)
  ier = sic_open(lun,fstation,'OLD',.true.)
  if (ier.ne.0) then
    write (mess,'(a,1x,a)') 'Troubles opening station file:',fstation
    call astro_message(seve%e,rname,trim(mess))
    goto 998
  endif
  nfilled=0
  do while (.true.)
    read(lun,'(a)',iostat=ier) clu
    if (ier.lt.0)  exit      ! EOF
    if (ier.ne.0)  then
      call astro_message(seve%e,rname,'Troubles reading station coordinates')
      goto 998  ! Error reading line
    endif
    iline = iline+1
    if (iline.le.nskip) cycle ! ignore first line - number depends on file format
    if (clu(1:1).eq.'!')  cycle  ! ignore comments
    nlu = lenc(clu)
    if (nlu.eq.0)  cycle     ! ignore empty lines
    !
    if (obsname.eq.'BURE'.or.obsname.eq.'NOEMA'.or.obsname.eq.'SMA') then
      ! BURE format: 4 columns
      read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz
      tt = 0.0
    else
      ! ALMA format: at least 5 columns (antenna size in column 5)
      read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz,tt
    endif
    if (ier.ne.0) then
      call astro_message(seve%w,rname,'Could not decode line: '//clu)
      cycle
    endif
    !
    take = .false.
    nn = nn+1
    if (uvt%in%do_all) then
      ntake = nn
      take = .true.
    else
      do i=1, nstat_in
        if (uvt%in%do_stations.and.nn.eq.istation(i)) then
          ! station entered by index and option station
          take=.true.
          ntake=i
          exit
        endif
        if (.not.uvt%in%do_stations) then
          ! station entered by name as command argument
          call uv_match_station(rname,uvt%in,name,stations_in(i),take,error)
          if (error) return
          if (take) then
            ntake=i
            exit
          endif
        endif
      enddo
    endif
    if (take) then
      ! Get the station coordinates
      nfilled=nfilled+1
      uvt%stations(ntake)%name = name
      uvt%stations(ntake)%x = xx
      uvt%stations(ntake)%y = yy
      uvt%stations(ntake)%z = zz
      uvt%stations(ntake)%t = tt
      uvt%stations(ntake)%found = .true.
      ! 
      ! Check size of the current antenna
      if (nused.ge.uvt%in%nant_size(iused)) then
        iused = iused+1
        nused = 0
      endif
      nused = nused+1
      uvt%stations(ntake)%asize = uvt%in%sizes(iused)
      ! Plot the station position
      call gr_set_marker (4,3,.3)
      if (uvt%in%do_size) then
        ! Compute marker size to try represent the respective size of the dish
        ! vs the size of the array:
        psize = uvt%stations(ntake)%asize*10/(2*array)  ! box is 10 cm...
        if (psize.gt.0.1) then
          call gr_set_marker (20,3,psize)
        endif
      endif
      ! Draw the marker
      call gr4_marker(1,yy,zz*uvt%ang%cp-xx*uvt%ang%sp,0.,-1.0)
    elseif (uvt%in%do_frame) then     
      ! station not selected : only a square to mark the position
      call gr_set_marker(4,0,.1)
      call gr4_marker(1,yy,zz*uvt%ang%cp-xx*uvt%ang%sp,0.,-1.0)
    endif
  enddo  ! end of loop on station file lines
  !
  close(unit=lun)
  call sic_frelun (lun)
  call gr_segm_close(error)
  !
  if (uvt%in%do_all) then
    stalis='ALL STATIONS'
    uvt%n_stations=nfilled
  else
    if (nstat_in.eq.nfilled) then
      uvt%n_stations=nstat_in
    else
      write (mess,'(a)') 'Problems with input station list'
      do i=1,nstat_in-1
        do j=i+1,nstat_in
          if (stations_in(i).eq.stations_in(j)) then
            write (mess,'(a,a,a)') 'Station ',trim(stations_in(i)),' requested several times'   
          endif
        enddo
      enddo
      call astro_message(seve%e,rname,mess)
      error=.true.
      return
    endif
  ! Build the line with all stations that were entered AND which are found in station file
    k = 0
    do i=1, uvt%n_stations
      if (uvt%stations(i)%found) then
        stalis(k+1:) = uvt%stations(i)%name//'-'
        call sic_black(stalis,k)
        if (i.eq.floor(uvt%n_stations/2.)) then
          ! get index of half antenna list place
          nces=k
        endif
      else
        call astro_message(seve%f,rname,'Station not found: '//uvt%stations(i)%name)
        error=.true.   ! for GTVIEW and other problems...
        return 
      endif
    enddo
    nc = k-1
  endif
!   endif
  !
  if (uvt%in%do_offset.and.uvt%in%offset.gt.0.0.and.uvt%in%offset.lt.au_m) then
    write (delay_mess,102) uvt%in%offset
    call sic_noir(delay_mess,nc)
  else
    delay_mess=''
  endif
  !
  !draw legend:  stations used, source declination and frequency
  call astro_uv_legend(rname,freq,decs,stalis,oldlis,delay_mess,uvt%n_stations, count,nc,nces,error)
  if (error) return
  !
  ! Plot coverage
  ! Consider setting marker size to equivalent dish size?
  ! size is a ratio
  call gr_exec('SET BOX 4 19 3 18')
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-extr,extr,-extr,extr
  call gr_exec1(chain)
  if (gr_error()) then
    error=.true.
    return
  endif
  call gr_segm('UVTRACK',error)
  !
  !
  uvt%stations(1)%t=uvt%stations(1)%t+uvt%in%offset
  nvis = 0
  table_ok=uvt%in%do_table
  if (uvt%in%do_table) then
    ! Size of Output Table. Must be computed exactly, since we
    ! do not want null entries at the end. we must take into account here
    ! rejected samples due to shadowing and/or delay line THROW.
    ! First loops just to get the number of visilities
    do k = 1,nh
      ! need update for each h
      uvt%ang%zsh=zsh(k)
      uvt%ang%zch=zch(k)
      !
      ! Reset complete variable at each h
      do i=1,uvt%n_stations-1
        complete(i) = uvt%stations(i)%found
        do j=i+1,uvt%n_stations
          complete(j) = uvt%stations(j)%found
        enddo
      enddo
      !
      ! Check for shadowing
      do i=1,uvt%n_stations-1
        if (complete(i)) then
          do j=i+1,uvt%n_stations
            if (complete(j)) then
              call uv_check_shadow(rname,uvt%ang,uvt%stations(i),uvt%stations(j),complete(i),complete(j),error)
              ! complete = false means that antenna is shadowed at the present h
              if (error) return
            endif
          enddo
        endif
      enddo
      !
      ! Now, Take in account max delay of Delay lines
      do i=1,uvt%n_stations-1
        if (complete(i)) then
          do j=i+1,uvt%n_stations
            if (complete(j)) then
              delay_ok=.false.
              call uv_check_delay(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uvt%stations(1),throw,delay_ok,error)
              if (error) return
              if (delay_ok) then
                nvis=nvis+1
              endif
            endif
          enddo
        endif
      enddo
    enddo
    !
    if (uvt%in%do_frame) then
      ! /FRAME means we restart from scratch the visibility table
      write(mess,'(A,A,A,I0,A)')  &
        'Initialising ',trim(file),' with ',nvis,' (u,v) points'
      call astro_message(seve%i,rname,mess)
      call astro_init_table(xtab,file,nvis,decs,freq,bandwidth,obsname,error)
    else
      ! No /FRAME, add visi to existig file
      write(mess,'(A,I0,A,A)')  &
        'Adding ',nvis,' (u,v) points to table ',trim(file)
      call astro_message(seve%i,rname,mess)
      call astro_extend_table(xtab,file,nvis,decs,freq,error)
    endif
    if (error) then
      call astro_message(seve%w,rname,'Cannot open output Table')
      call astro_close_table(xtab)
      table_ok = .false.
      error = .false.
    else
      allocate(myvisi(visi_size,nvis),stat=ier)
      if (ier.ne.0) then
         call astro_message(seve%w,rname,'Memory allocation failure for Table')
         call astro_close_table(xtab)
         table_ok = .false.
         error = .false.
      else
        table_ok=.true.
      endif
    endif
  endif
  !
  call jjdate(jnow_utc, date)
  call ndatec(date, d_chain, error)
  call gag_fromdate(d_chain,idate,error)
  idate = idate+count
  !
  ! OK, redo for good now!
  ivisi = 0
  do k = 1,nh
    uvt%ang%zsh=zsh(k)
    uvt%ang%zch=zch(k)
    !
    ! Check for stations
    do i=1,uvt%n_stations-1
      complete(i) = uvt%stations(i)%found
      do j=i+1,uvt%n_stations
        complete(j) = uvt%stations(j)%found
      enddo
    enddo
    !
    ! Source elevation
    !
    call amset(lonlat(2),amat)
    avec(1) = zch(k)*uvt%ang%cd
    avec(2) = zsh(k)*uvt%ang%cd
    avec(3) = uvt%ang%sd
    call matmul(amat,avec,bvec,1)
    call dangle(az,el,bvec)
    !
    if (uvt%in%wkey.eq.3) then
      ! Full mode for wight: atm computation
      call astro_setuv_weight(el)
    endif
    !
    ! Check for shadowing
    do i=1,uvt%n_stations-1
      if (complete(i)) then
        do j=i+1,uvt%n_stations
          if (complete(j)) then
            call uv_check_shadow(rname,uvt%ang,uvt%stations(i),uvt%stations(j),complete(i),complete(j),error)
            ! complete = false means that antenna is shadowed at the present h
            if (error) return
            if (.not.(complete(i))) then
              write(mess,'(A,I0,A,I0)') 'Antenna ',i,' is shadowed by ',j
              call astro_message(seve%i,rname,mess)
            else if  (.not.(complete(j))) then
              write(mess,'(A,I0,A,I0)') 'Antenna ',j,' is shadowed by ',i
              call astro_message(seve%i,rname,mess)
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Fill the table now and Plot, Take in account max delay of Delay lines
    do i=1,uvt%n_stations-1
      if (complete(i)) then
        do j=i+1,uvt%n_stations
          if (complete(j)) then
            delay_ok=.false.
            call uv_check_delay(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uvt%stations(1),throw,delay_ok,error)
            if (error) return
            psize = sqrt(uvt%stations(i)%asize*uvt%stations(j)%asize)*15/(2*extr)
            ! Plot 'bad' points (throw unable to follow delay) only if DO_SIZE
            call uv_do_baseline(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uk,vk,wk,error)
            if (error) return
            ! Plot Considerations
            if (.not.delay_ok) then
              if (uvt%in%do_size) then
                ! Plot the excluded points in case of do_size
                call gr_set_marker (4,1,0.05)
                flag=0
              else
                flag=1         ! do not plot
              endif
            else
              flag=0
              if (psize.lt.0.0001 .or. .not.uvt%in%do_size) then
                call gr_set_marker (4,0,0.05)
              else
                call gr_set_marker (20,0,psize)
              endif
            endif
            !            
            uvmin = uvt%stations(i)%asize/2.+uvt%stations(j)%asize/2.
            if ((uk**2+vk**2).le.uvmin**2) then
              call astro_message(seve%d,rname,'---- Y A UN PROBLEME ----')
            else
              if (table_ok.and.delay_ok) then
                ivisi = ivisi+1
                call fill_table (uk,vk,wk,float(idate),(uvt%in%integ_time*60*k),i,j,  &
                myvisi(1,ivisi),el,uvt%in%wkey)
              endif
              if (flag.eq.0) then
                call gr4_marker(1,uk,vk,0.0,-1.0)
                uk = -uk
                vk = -vk
                wk = -wk
                call gr4_marker(1,uk,vk,0.0,-1.0)
              endif
              flag=0
            endif
          endif
        enddo
      endif
    enddo
    !
  enddo
  call gr_segm_close(error)
  !
  if (table_ok) then
    call gdf_write_data(xtab,myvisi,error)
    call astro_close_table (xtab)
    deallocate (myvisi, stat=ier)
  endif
  return
  !
  998   continue
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
  return
  102   format (', DL set @ ',f12.5,' m')
end subroutine astro_uv
!
subroutine uv_do_baseline(rname,uvang,uvsta_i,uvsta_j,uk,vk,wk,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_do_baseline
  !---------------------------------------------------------------------
  ! @ private
  !
  ! compute baseline coordinates
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_angles_t), intent(in) :: uvang ! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j ! current stations
  real(kind=4), intent(inout) :: uk,vk,wk
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: xx,yy,zz
  !
  xx = uvsta_j%x-uvsta_i%x
  yy = uvsta_j%y-uvsta_i%y
  zz = uvsta_j%z-uvsta_i%z
  uk = uvang%zsh*xx + uvang%zch*yy
  vk = uvang%sd*(-uvang%zch*xx+uvang%zsh*yy)+uvang%cd*zz
  wk = uvang%cd*(-uvang%zch*yy+xx*uvang%zch)+zz*uvang%sd
  !
end subroutine uv_do_baseline
!
subroutine uv_check_shadow(rname,uvang,uvsta_i,uvsta_j,ok_i,ok_j,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_check_shadow
  !---------------------------------------------------------------------
  ! @ private
  !
  ! check whether the 2 antennas on stations i,j have shadowing
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_angles_t), intent(in) :: uvang ! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j ! current stations
  logical, intent(inout) :: ok_i,ok_j
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: xx,yy,zz,uk,vk,uvmin,test
  !
  uvmin = uvsta_i%asize/2.+uvsta_j%asize/2.
  xx = uvsta_j%x-uvsta_i%x
  yy = uvsta_j%y-uvsta_i%y
  zz = uvsta_j%z-uvsta_i%z
  uk = uvang%zsh*xx + uvang%zch*yy
  vk = uvang%sd*(-uvang%zch*xx+uvang%zsh*yy)+uvang%cd*zz
  if ((uk**2+vk**2).le.uvmin**2) then
    ! shadowing happends, check who shadows who
    test = (xx*uvang%zch - yy*uvang%zsh)*uvang%cd + zz*uvang%sd
    if (test.gt.0.0) then
      ok_i = .false. 
    else
      ok_j = .false.
    endif
  endif
end subroutine uv_check_shadow
!
subroutine uv_check_delay(rname,uvang,uvsta_i,uvsta_j,uvsta_ref,throw,delay_ok,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_check_delay
  !---------------------------------------------------------------------
  ! @ private
  !
  ! check whether the delay is not bigger than the limit (for observatories using fixed delay lines)
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_angles_t), intent(in) :: uvang ! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j,uvsta_ref ! current stations
  real(kind=4), intent(in) :: throw
  logical, intent(inout) :: delay_ok
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: xx,yy,zz,wkj,wki
  !
  xx = uvsta_j%x-uvsta_ref%x
  yy = uvsta_j%y-uvsta_ref%y
  zz = uvsta_j%z-uvsta_ref%z
  wkj = uvang%cd*(-uvang%zsh*yy+uvang%zch*xx)+uvang%sd*zz+uvsta_ref%t-uvsta_j%t
  !
  xx = uvsta_i%x-uvsta_ref%x
  yy = uvsta_i%y-uvsta_ref%y
  zz = uvsta_i%z-uvsta_ref%z
  wki = uvang%cd*(-uvang%zsh*yy+uvang%zch*xx)+uvang%sd*zz+uvsta_ref%t-uvsta_i%t
  !
  ! Count only visibility doable wrt delay lines
  if ((wkj.ge.0).and.(wkj.le.throw).and. (wki.ge.0).and.(wki.le.throw))  delay_ok=.true.
  ! 
end subroutine uv_check_delay
!
subroutine uv_match_station(rname,uvin,fname,istation,match,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_match_station
  !---------------------------------------------------------------------
  ! @ private
  !
  ! check if station of the current line in the file matches the requested station
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_in_t), intent(in) :: uvin
  character(len=*) :: fname ! station name as in station file
  character(len=*) :: istation ! station name as user input
  logical, intent(inout) :: match 
  logical, intent(inout) :: error 
  ! Local
  character(len=256) :: chain
  character(len=3) :: sname
  !
  if (fname.eq.istation) then
    match=.true.
  else if ((obsname.eq.'BURE'.or.obsname.eq.'NOEMA').and.uvin%three_digit_name_compatible) then
    ! 01-jul-2022. Mnemonic station names changed from [E,W,N]+2 digits to [E,W,N]+3 digits in station files
    ! The following trick has been written to ensure backward compatibility reasons
    ! Will be removed after a period of ~ 1--2 yr
    if (len_trim(fname).eq.4.and.len_trim(istation).eq.3.and.fname(2:2).eq.'0') then
      sname(1:1)=fname(1:1)
      sname(2:3)=fname(3:4)
      if (sname.eq.istation) then
        call astro_message(seve%w,rname,'The 3 characters format for NOEMA stations is obsolescent')
        write (chain,'(a,1x,a,1x,a,1x,a)') 'Station',trim(istation),'is now called',trim(fname)
        call astro_message(seve%w,rname,chain)
        match=.true.
      endif
    endif
  endif
  !
end subroutine uv_match_station
!
subroutine uv_reset_plot(rname,uvin,arr,lextr,ff,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_reset_plot
  !---------------------------------------------------------------------
  ! @ private
  !
  ! reset the plot upon /frame option
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_in_t), intent(in) :: uvin
  real(kind=4), intent(in) :: arr
  real(kind=4), intent(inout) :: lextr
  real(kind=8), intent(inout) :: ff        !
  logical, intent(inout) :: error 
  ! Local
  character(len=256) :: chain
  !
  lextr = arr
  if (uvin%user_array.gt.0) then
    ! use user value
    lextr=uvin%user_array
  endif  
  call gr_exec ('CLEAR DIRECTORY')
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-lextr,lextr,-lextr,lextr
  call gr_exec1(chain)
  if (gr_error()) then
    error=.true.
    return
  endif
  call gr_exec1('SET BOX 4 19 3 18')
  if (gr_error()) then
    error=.true.
    return
  endif
  call gr_exec1('TICKS 0 0 0 0 ')
  if (error .or. freq.eq.0.0) then
    error = .false.
    freq = 0.0
    call gr_exec1('BOX')
  else
    call uvbox (lextr,freq)
  endif
  !
end subroutine uv_reset_plot
!
subroutine uv_get_arraysize(rname,fsta,arr,nign,off,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_get_arraysize
  !---------------------------------------------------------------------
  ! @ private
  !
  ! extract useful info from station file
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  character(len=*), intent(in) :: fsta   ! station file name
  real(kind=4), intent(inout) :: arr        !
  integer(kind=4), intent(inout) :: nign
  real(kind=4), intent(inout) :: off(4) ! offset wrt to origin to plot positions of stations
  logical, intent(inout) :: error 
  ! Local
  integer(kind=4) :: ier,lun,iequal,i
  character(len=256) :: mess,clu
  !
  ier = sic_getlun (lun)
  ier = sic_open(lun,fsta,'OLD',.true.)
  if (ier.ne.0) then
    write (mess,'(a,1x,a)') 'Troubles opening station file:',fsta
    call astro_message(seve%e,rname,trim(mess))
    goto 998
  endif
  if (obsname.eq.'BURE'.or.obsname.eq.'NOEMA'.or.obsname.eq.'SMA') then
    read (lun,*,iostat=ier) arr
    nign=1
    off(1) = 0
    off(2) = 0
    off(3) = 0
    off(4) = 0
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline in',fsta
      call astro_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call astro_message(seve%e,rname,mess)
      goto 998
    endif
  else if (obsname.eq.'ALMA'.or.obsname.eq.'ACA') then
    ! Patch for ALMA configuration files
    ! Skip first 7 lines:
    do i=1,7
      read(lun,*,iostat=ier)
      if (ier.ne.0)  then
        write (mess,'(a,1x,a)') 'Troubles reading header part of',fsta
        call astro_message(seve%e,rname,mess)
        write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
        call astro_message(seve%e,rname,mess)
        goto 998
      endif
    enddo
    read(lun,'(a)',iostat=ier) clu
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline line in',fsta
      call astro_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call astro_message(seve%e,rname,mess)
      goto 998
    endif
    iequal = index(clu,'=')
    read(clu(iequal+1:),*,iostat=ier)  arr
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline in',fsta
      call astro_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call astro_message(seve%e,rname,mess)
      goto 998
    endif
    arr = arr*1.2
    nign=9
    if (obsname.eq.'ALMA') then
      off(1) = 0
      off(2) = 0
      off(3) = -660
      off(4) = -660
    else if (obsname.eq.'ACA') then
      off(1) = -52
      off(2) = -52
      off(3) = -570
      off(4) = -570
    endif
  endif
  close(unit=lun)
  call sic_frelun (lun)
  return
  998   continue
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
  return
  !
end subroutine uv_get_arraysize
!
subroutine astro_uv_legend(rname,lfreq,decs,stalis,oldlis,del_mess,nused, count, nc,nces,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>astro_uv_legend
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  ! draw the legend (stations used, declination, frequency)
  ! at the right place according to the plot_page orientation
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  real(kind=8), intent(in) :: lfreq         ! Frequency
  real(kind=8), intent(in) :: decs         ! Declination [radian]
  character(len=*), intent(in) :: stalis   !list of used stations
  integer(kind=4), intent(in) :: nces     !positions to split the displayed line if needed
  character(len=*), intent(in) :: oldlis   !previous list of used stations
  character(len=*), intent(in) :: del_mess   !message about delay if present
  integer(kind=4), intent(in) :: nused     ! number of used stations
  integer(kind=4), intent(inout) :: count  !
  integer(kind=4), intent(in) :: nc        !
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: px
  real(kind=8) :: ddec,dy,mjd
  logical :: err
  character(len=200) :: chain,stafile
  integer(kind=4) :: ier,lb,iy,im,id
  !
  call sic_get_real('page_x',px,err)
  if (px.ge.30) then !landscape
     call gr_exec('SET BOX 20 30 3 9')
  else ! portrait
     call gr_exec('SET BOX 12 20 20 26')
  endif
  call gr_exec('limits 0 10 0 10')
  if (lfreq.gt.1e3) then
     write(chain,102) clight/lfreq/1d3
  else
     write(chain,100) lfreq
  endif
  call gr_exec('set char 0.5')
  call gr_exec1(chain)
  if (source_incoord.eq."EQ") then
    lb=len(source_inbetasexa)
    call sic_sexa(source_inbetasexa,lb,ddec,error)
    write(chain,101) source_ineq,ddec !write in degrees
  else
    mjd=source_jutc-2400000.5
    call gag_mjd2gregorian(mjd,iy,im,id,error)
    dy=iy+im/12.
    write(chain,101)  dy,sngl(decs*180d0/pi) !write in degrees
  endif
  call gr_exec1(chain)
  if (len_trim(del_mess).gt.0) then
    write(chain,103) trim(del_mess)
    call gr_exec1(chain)
  endif
  call gr_exec('set char /def')
100   format ('DRAW TEXT 1 1 "Frequency ',f5.1,' GHz" 6 /user')
102   format ('DRAW TEXT 1 1 "Wavelength ',f6.3,' microns" /user')
101   format ('DRAW TEXT 1 0 "Dec EQ ',f7.1,' ',f5.1,' ^" 6 /user ')
103   format ('DRAW TEXT 1 2 "',a,' ^" 6 /user ')

  !
  ! Plot on two lines when more than 6 stations (and less than 13)
  call gr_exec('set char 0.4')
  if (oldlis.ne.stalis) then
    if (nused.gt.12.or.stalis.eq."ALL STATIONS") then !ALMA or other observatory?
      count = count+2
      if (stalis.eq."ALL STATIONS") then
        chain = 'DRAW TEXT 1 1234 "'//stalis//'"   6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
      else
        chain = 'DRAW TEXT 1 1234 "More than 12 antennas"   6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
      endif
      count = count+1
      ier = sic_getlog('ASTRO_STATIONS',stafile)
      if (ier.ne.0) then
        call astro_message(seve%e,rname,  &
             'Failure in translation of ASTRO_STATIONS logical')
        error = .true.
        return
      endif
      chain = 'DRAW TEXT 1 1234 "'//trim(stafile)//'"   6 /user'
      write(chain(13:16),'(I4)') count
      call gr_exec1 (chain)
    else if (nused.le.6) then !PDB = 1 line
      count = count+4
      chain = 'DRAW TEXT 1 1234 "'//stalis(1:nc) //'" 6 /user'
      write(chain(13:16),'(I4)') count
      call gr_exec1 (chain)
    else if (nused.le.12) then !NOEMA = 2 lines
      count = count+2
      chain = 'DRAW TEXT 1 1234 -"'//stalis(nces+1:nc) //'" 6 /user'
      write(chain(13:16),'(I4)') count
      call gr_exec1 (chain)
      count = count+1
      chain = 'DRAW TEXT 1 1234 "'//stalis(1:nces) //'" 6 /user'
      write(chain(13:16),'(I4)') count
      call gr_exec1 (chain)
    endif
  endif
  call gr_exec('set char /def')
  !
end subroutine astro_uv_legend
!
subroutine uvbox(base,freq)
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: base  ! Baseline length
  real(kind=8), intent(in) :: freq  ! Frequency
  ! Global
  logical, external :: gr_error
  ! Local
  real(kind=4) :: x
  character(len=80) :: chain
  !
  call gr_exec1('SET BOX 4 19 3 18')
  if (gr_error()) return
  x = base*freq*1d6/clight
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-x,x,-x,x
  call gr_exec1(chain)
  chain = 'DRAW TEXT 0 2.5 "U (k'//char(92)//'gl)" 5 /CHARACTER 8'
  call gr_exec1(chain)
  call gr_exec1('SET ORIENT 90.0')
  chain = 'DRAW TEXT 2.0 0 "V (k'//char(92)//'gl)" 5 /CHARACTER 6'
  call gr_exec1(chain)
  call gr_exec1('SET ORIENT 0')
  call gr_exec1('AXIS XU /LABEL P')
  call gr_exec1('AXIS YR /LABEL O')
  x = base
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-x,x,-x,x
  call gr_exec1(chain)
  call gr_exec1('AXIS XL')
  call gr_exec1('AXIS YL')
  call gr_exec1('LABEL "U (meters)" /X')
  call gr_exec1('SET ORIENT 90.0')
  call gr_exec1('DRAW TEXT -2.0 0 "V (meters)" 5 /CHARACTER 4')
  call gr_exec1('SET ORIENT 0')
end subroutine uvbox
!
subroutine astro_close_table(x)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! To be re-written using
  !    gdf_write_image(header,array,error)
  ! AND may be also
  !    gdf_close_image(header,error)
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x  !
  ! Local
  logical :: error
  !
  error = .false.
  call gdf_close_image(x,error)
end subroutine astro_close_table
!
subroutine astro_extend_table(x,name,nvis,dec,freq,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Re-written for new Imgage I/O interface
  !---------------------------------------------------------------------
  type(gildas),     intent(inout) :: x      ! Image structure
  character(len=*), intent(in)    :: name   ! File name
  integer(kind=4),  intent(in)    :: nvis   ! Number of visibilities to add
  real(kind=8),     intent(in)    :: dec    ! Declination
  real(kind=8),     intent(in)    :: freq   ! Frequency
  logical,          intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ASTRO_UV'
  character(len=80) :: chain
  integer(kind=index_length) :: mvis
  !
  call gildas_null(x, type='UVT')
  x%file = name
  x%loca%read = .false.
  !
  call gdf_read_gildas(x,name,'.uvt',error, data=.false.)
  if (error) return
  !! call gio_lsis(error)
  !! read(5,*) i
  call gdf_close_image(x,error)
  !
  ! Couple of checks
  if (abs(x%gil%dec-dec).gt.1d-6) then
    call astro_message(seve%e,rname,'Different declinations')
    error = .true.
  endif
  if (freq.ne.0.0 .and. (abs(freq-x%gil%freq*1d-3).gt.1d-6)) then
    call astro_message(seve%e,rname,'Different frequencies')
    error = .true.
  endif
  if (error) goto 100
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) x%gil%dim(2),nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call astro_message(seve%i,rname,chain)
  !
  mvis = x%gil%dim(2)+nvis
  !
  call gdf_extend_image (x,mvis,error)
  if (error) goto 100
  !
  x%gil%nvisi = mvis  ! Update number of visibilities
  call gdf_update_header(x,error)
  !
  ! Map only new region
  x%blc(1) = 1
  x%blc(2) = x%gil%dim(2)+1-nvis
  x%trc(1) = x%gil%dim(1)
  x%trc(2) = x%gil%dim(2)
  return
  !
  100   call astro_message(seve%e,rname,'Table extension failed')
end subroutine astro_extend_table
!
subroutine astro_init_table(x,name,nvis,dec,freq,band,obs,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gildas),     intent(inout) :: x      ! Image structure
  character(len=*), intent(in)    :: name   ! File name
  integer(kind=4),  intent(in)    :: nvis   ! Number of visibilities to write
  real(kind=8),     intent(in)    :: dec    ! Declination
  real(kind=8),     intent(in)    :: freq   ! Frequency
  real(kind=4),     intent(in)    :: band   ! Frequency resolution
  character(len=*), intent(in)    :: obs    ! Current observatory
  logical,          intent(out)   :: error  ! Logical error flag
  ! Local
  real(kind=8) :: dummy(3)
  !
  error = .false.
  !
  ! Create new file
  call gildas_null(x, type = 'UVT')
  x%file = name
  x%gil%convert(1,1) = 1.0
  x%gil%convert(3,1) = 1.0
  x%gil%blan_words = 2
  x%gil%extr_words = 0
  x%gil%bval = -1.0
  x%gil%eval = 0.
  x%gil%dim(2) = nvis
  x%gil%dim(1) = 10  ! 7 daps + (real, imag, weight)*nchannels
  !
  x%gil%ndim = 2
  x%char%unit = 'Jy'
  x%char%syst = 'EQUATORIAL'
  x%char%name = ' '
  x%gil%ra = 0.0
  x%gil%dec = dec
  x%gil%epoc = 2000.0
  x%char%line = ' '
  x%gil%fres = band
  if (freq.ne.0d0) then
    x%gil%fima = 0.0
    x%gil%freq = freq*1d3
  else
    x%gil%fima = 102d3
    x%gil%freq = 90d3
  endif
  x%gil%convert(2,1) = x%gil%freq
  x%gil%vres = -299792.458*x%gil%fres/x%gil%freq
  x%gil%voff = 0.0
  x%gil%faxi = 1
  x%loca%size = x%gil%dim(1) * x%gil%dim(2)
  x%gil%nvisi = x%gil%dim(2)
  x%gil%nchan = 1
  !
  call gdf_addteles(x,'TELE',obs,dummy,error)
  if (error)  return
  !
  call gdf_create_image(x,error)
  x%blc = 0
  x%trc = 0
end subroutine astro_init_table
!
subroutine fill_table (u,v,w,d,t,ideb,ifin,visi,el,wkey)
  use atm_params
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: u         ! U coordinate
  real(kind=4),    intent(in)  :: v         ! V
  real(kind=4),    intent(in)  :: w         ! W
  real(kind=4),    intent(in)  :: d         ! Date
  real(kind=4),    intent(in)  :: t         ! Time
  integer(kind=4), intent(in)  :: ideb      ! Start Antenna
  integer(kind=4), intent(in)  :: ifin      ! End Antenna
  real(kind=4),    intent(out) :: visi(10)  ! Visibility
  real(kind=8),    intent(in)  :: el        ! Elevation
  integer(kind=4), intent(in)  :: wkey      ! Code for Weights
  !
  ! 7 parameters:
  !  U, V, W, Date, Time, Ant1, Ant2
  ! 3 values:
  !  Real, Imag, Weight
  !  1.0, 0.0, 1.0
  !
  visi(1) = u
  visi(2) = v
  visi(3) = w
  visi(4) = d
  visi(5) = t
  visi(6) = ideb
  visi(7) = ifin
  visi(8) = 1.0
  visi(9) = 0.0
  if (wkey.eq.1) then
     visi(10) = 1.0
  elseif (wkey.eq.2) then
     visi(10) = sin(el)**2
  elseif (wkey.eq.3) then
     visi(10) = uvweight
  endif
end subroutine fill_table
!
subroutine matmul(mat,a,b,n)
  !---------------------------------------------------------------------
  ! @ private
  ! version 1.0  mpifr cyber edition  22 may 1977.  G.Haslam
  ! version 2.0  iram
  !
  ! this routine provides the transformation of vector a to vector b
  ! using the n dimensional direction cosine array, mat.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: mat(3,3)  !
  real(kind=8),    intent(in)  :: a(3)      !
  real(kind=8),    intent(out) :: b(3)      !
  integer(kind=4), intent(in)  :: n         !
  ! Local
  integer(kind=4) :: i,j
  !
  if (n.gt.0) then
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(i,j)*a(j)
      enddo
    enddo
  else
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(j,i)*a(j)
      enddo
    enddo
  endif
end subroutine matmul
!
subroutine amset(obslat,amat)
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !   subroutine to provide transformation matrix from hour angle - dec
  !       into azimuth - elevation.
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: obslat   ! in degrees
  real(kind=8), intent(out) :: amat(9)  !
  ! Local
  real(kind=8) :: x1,y1,z1
  !
  x1=pi/180d0*obslat
  y1=dsin(x1)
  z1=dcos(x1)
  amat(1)=-y1
  amat(2)=0.d0
  amat(3)=z1
  amat(4)=0.d0
  amat(5)=-1.d0
  amat(6)=0.d0
  amat(7)=z1
  amat(8)=0.d0
  amat(9)=y1
end subroutine amset
!
subroutine dangle(along,alat,a)
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine recovers the longitude and latitude angles, along
  ! (0 - 360) and alat ( +.- 180) in deg_to_radrees, which correspond to the
  ! vector a.
  !---------------------------------------------------------------------
  real(kind=8), intent(out) :: along  !
  real(kind=8), intent(out) :: alat   !
  real(kind=8), intent(in)  :: a(3)   !
  ! Local
  real(kind=8) :: aa
  !
  aa     = a(1)*a(1)+a(2)*a(2)
  aa     = dsqrt(aa)
  alat   = pi/2d0
  if (aa.ge.0.000001d0) then
    aa = a(3)/aa
    alat = datan(aa)           ! latitude in Radian
  endif
  !
  if (a(2).ne.0.d0 .or. a(1).ne.0.d0) then
    along = datan2(a(2),a(1))    ! longitude in Radian
  else
    along = 0.d0
  endif
end subroutine dangle
!
subroutine astro_setuv_weight(el)
  use gildas_def
  use gkernel_interfaces
  use atm_params
  use atm_interfaces_public
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! ATM - using global astro variables
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: el
  !
  real(4) :: w
  real(4) :: frequ
  integer :: ier
  !
  airmass = 1./sin(el)
  h0 = altitude
  !
  p1 = p0*2.0**(-h0/5.5)     ! Pressure at altitude H0
  call atm_atmosp(t0,p1,h0)
  !
  if (gim.ne.0) then
    frequ = freqi
    call atm_transm(water,airmass,frequ,temii,tatmi,tauox,tauw,taut,ier)
    frequ = freqs
    call atm_transm(water,airmass,frequ,temis,tatms,tauox,tauw,taut,ier)
    !
    tant = (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
           (feff*temis+(1.0-feff)*t0 + trec) ) / (1.0+gim)
    tsys = exp(taut*airmass) * (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
           (feff*temis+(1.0-feff)*t0 + trec) ) / feff
  else
    frequ = freqs
    call atm_transm(water,airmass,frequ,temis,tatms,tauox,tauw,taut,ier)
    !
    tant = feff*temis+(1.0-feff)*t0 + trec
    tsys = exp(taut*airmass) * (feff*temis+(1.0-feff)*t0 + trec) / feff
  endif
  !
  ! Need  Integration time
  ! Need  Bandwidth
  ! Need  Antenna Jy/K conversion factor
  w = jy_per_k*tsys/sqrt(bandwidth * inttime)
  uvweight = 1./w**2
end subroutine astro_setuv_weight
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! This file contains the outimage_tool module before implementing the
! PARAMETERS command.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_outimage_tool
  use cube_types
  use cubedag_allflags
  use cubeadm_cubeprod_types
  use cubefit_messaging
  use cubefit_parameters
  !
  public :: nsig,nvari
  public :: jcol_flag,jcol_signal,jcol_noise,jcol_snr
  public :: jcol_rmsbase,jcol_rmsspec,jcol_rmsline
  public :: jcol_method,jcol_nfunc
  public :: outimage_t
  private
  !
  integer(kind=4), parameter :: nsig  = 2
  integer(kind=4), parameter :: nvari = 4
  integer(kind=4), parameter :: jcol_flag    = 1
  integer(kind=4), parameter :: jcol_signal  = 2
  integer(kind=4), parameter :: jcol_noise   = 3
  integer(kind=4), parameter :: jcol_snr     = 4
  integer(kind=4), parameter :: jcol_rmsline = +1
  integer(kind=4), parameter :: jcol_rmsbase = +2
  integer(kind=4), parameter :: jcol_rmsspec = -1 ! Fit RMS
  integer(kind=4), parameter :: jcol_method  = -2 ! Fit Method
  integer(kind=4), parameter :: jcol_nfunc   = -3 ! Fit number of components
  !
  type outimage_t
     type(cube_t), pointer :: cube
     type(cube_prod_t)     :: prod
     character(len=unit_l) :: unit
   contains
     procedure, public :: init  => cubefit_parameters_outimage_init
     procedure, public :: clone => cubefit_parameters_outimage_clone
  end type outimage_t
  !
contains
  !
  subroutine cubefit_parameters_outimage_init(out,imeth,ifunc,jcol,iout,prod,error)
    use gkernel_interfaces
    use cubefit_spectral_fit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(outimage_t), intent(inout) :: out
    integer(kind=4),   intent(in)    :: imeth
    integer(kind=4),   intent(in)    :: ifunc
    integer(kind=4),   intent(in)    :: jcol
    integer(kind=4),   intent(in)    :: iout
    type(cube_prod_t), intent(in)    :: prod  ! Output cube description (reference)
    logical,           intent(inout) :: error
    !
    type(flag_t) :: signoiflag(nvari),sigmaflags(nsig),flags(3)
    character(len=*), parameter :: rname='PARAMETERS>OUTIMAGE>INIT'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    signoiflag(:) = [flag_flag,flag_signal,flag_noise,flag_snr]
    sigmaflags(:) = [flag_base,flag_line]
    !
    call prod%copy(out%prod,error)
    if (error)  return
    !
    select case(jcol)
    case(jcol_rmsspec)
      ! Pre-defined flags are fit,parameters,*,noise,*
       call cubefit_parameters_flags(imeth,1,flags(1),flags(2),flags(3),error)
       if (error) return
       call out%prod%flag_to_flag(flag_any,flags(1),error)  ! Replace 1st *
       if (error)  return
       call out%prod%flag_to_flag(flag_any,sigmaflags(iout),error)  ! Replace 2nd *
       if (error)  return
       out%unit = strg_id ! Sigma has the same unit as the original cube 
    case(jcol_nfunc)
       ! Pre-defined flags are fit,parameters,nlines (no change needed)
       out%unit = '---' ! No unit for number of lines
    case(jcol_method)
       ! Pre-defined flags are fit,parameters,method (no change needed)
       out%unit = '---' ! No unit for method
    case default
       ! Pre-defined flags are fit,parameters,*,*,*,*
       call cubefit_parameters_flags(imeth,jcol,flags(1),flags(2),flags(3),error)
       if (error) return
       if (ifunc.ne.0) then
          call cubefit_func2flag(ifunc,flags(3),error)
          if (error) return
       endif
       call out%prod%flag_to_flag(flag_any,flags(1),error)  ! Replace 1st *
       if (error)  return
       call out%prod%flag_to_flag(flag_any,flags(2),error)  ! Replace 2nd *
       if (error)  return
       call out%prod%flag_to_flag(flag_any,flags(3),error)  ! Replace 3rd *
       if (error)  return
       call out%prod%flag_to_flag(flag_any,signoiflag(iout),error)  ! Replace 4th *
       if (error)  return
       if (iout.eq.2.or.iout.eq.3) then
          ! Signal and noise have the same unit as the data
          call cubefit_parameters_units(imeth,jcol,out%unit,error)
          if (error) return
       else
          ! Flag and snr have no unit
          out%unit = '---'
       endif
    end select
  end subroutine cubefit_parameters_outimage_init
  !
  subroutine cubefit_parameters_outimage_clone(ou,incube,error)
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(outimage_t),     intent(inout) :: ou
    type(cube_t), pointer, intent(in)    :: incube
    logical,               intent(inout) :: error
    !
    character(len=unit_l) :: unit
    character(len=*), parameter :: rname='PARAMETERS>OUTIMAGE>CLONE'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(ou%prod,incube,ou%cube,error)
    if (error) return
    call cubetools_header_nullify_axset_c(ou%cube%head,error)
    if (error) return
    if (ou%unit.ne.strg_id) then
       if (ou%unit(1:1).eq.strg_add) then
          call cubetools_header_get_array_unit(ou%cube%head,unit,error)
          if (error) return
          unit = trim(unit)//'.'//ou%unit(2:)
          call cubetools_header_put_array_unit(unit,ou%cube%head,error)
          if (error) return
       else
          call cubetools_header_put_array_unit(ou%unit,ou%cube%head,error)
          if (error) return
       endif
    endif
  end subroutine cubefit_parameters_outimage_clone
end module cubefit_outimage_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_command_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubefit_messaging
  use cubefit_parameters
  use cubefit_selection
  use cubefit_outimage_tool
  !
  public :: parameters
  private
  !
  integer(kind=chan_k), parameter :: one   = 1
  !
  type :: parameters_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: incube
     type(selection_opt_t)       :: select
     type(cube_prod_t),  pointer :: method
     type(cube_prod_t),  pointer :: nfuncs
     type(cube_prod_t),  pointer :: sigmas  ! One for all, adapted at run time
     type(cube_prod_t),  pointer :: output  ! One for all, adapted at run time
   contains
     procedure, public  :: register => cubefit_parameters_register
     procedure, private :: parse    => cubefit_parameters_parse
     procedure, private :: main     => cubefit_parameters_main
  end type parameters_comm_t
  type(parameters_comm_t) :: parameters
  !
  type parameters_user_t
     type(cubeid_user_t)    :: cubeids
     type(selection_user_t) :: sele
   contains
     procedure, private :: toprog => cubefit_parameters_user_toprog
  end type parameters_user_t
  !
  type parameters_prog_t
     type(cube_t),      pointer     :: incube
     type(selection_prog_t)         :: sele
     integer(kind=4)                :: nmeth
     integer(kind=4)                :: methhash(nmeth)
     integer(kind=npar_k)           :: npara(nmeth)
     integer(kind=4),   allocatable :: parahash(:,:)
     type(outimage_t),  allocatable :: output(:,:,:)
     logical,           allocatable :: ispos(:,:)
     real(kind=coor_k), allocatable :: reso(:)
     type(outimage_t),  allocatable :: sigmas(:,:)
     type(outimage_t)               :: method
     type(outimage_t)               :: nfuncs
   contains
      procedure, private :: header  => cubefit_parameters_prog_header
      procedure, private :: data    => cubefit_parameters_prog_data
      procedure, private :: loop    => cubefit_parameters_prog_loop
      procedure, private :: act     => cubefit_parameters_prog_act
  end type parameters_prog_t
  !
contains
  !
  subroutine cubefit_parameters_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(parameters_user_t) :: user
    character(len=*), parameter :: rname='PARAMETERS>COMMAND'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call parameters%parse(line,user,error)
    if (error) return
    call parameters%main(user,error)
    if (error) return
  end subroutine cubefit_parameters_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_parameters_register(parameters,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_comm_t), intent(inout) :: parameters
    logical,                  intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='PARAMETERS>REGISTER'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'PARAMETERS','[fitid]',&
         'Extract maps of fitted quantities from a fit-results cube',&
         'Turn the fit-results cube produced by FIT\MINIMIZE into maps of&
         & fitted quantities.&
         & PARAMETERS reads, for each spectrum, the stored fit family,&
         & number of components, noise estimates, and fitted parameters,&
         & then writes summary maps and parameter products that can be&
         & inspected like ordinary CUBE data.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- The exact parameter maps depend on the fit family stored in the&
         & input fit-results cube. They can represent quantities such as area,&
         & velocity, linewidth, opacity, or shell parameters.'//strg_cr//&
         '- /SELECT can keep all fitted methods and components or isolate&
         & one method and optional component. Outputs that do not match the&
         & selection are written as NaN.'//strg_cr//&
         '- SNR maps use value divided by fit error for most parameters. For&
         & frequency and velocity parameters, SNR uses spectral resolution&
         & divided by fit error.'//strg_bl//&
         'Additional output(s):'//strg_cr//&
         '- METHOD: code of the fitted profile family in each spectrum.'&
         //strg_cr//&
         '- NLINES: number of fitted components in each spectrum.'//strg_cr//&
         '- NOISE: RMS maps for the baseline or fitted-line channels of the&
         & selected family.'//strg_cr//&
         '- PARAMETER: per-method maps of flag, fitted value, formal error,&
         & and SNR for each decoded parameter.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> PARAMETERS fit'//strg_cr//&
         'CUBE> PARAMETERS fit /SELECT GAUSSIAN 1'//strg_cr//&
         'These examples reuse the same fit-results cube with different&
         & /SELECT filters.',&
         cubefit_parameters_command,&
         parameters%comm,error)
    if (error) return
    call cubearg%register(&
         'FITID',&
         'Identifier for the fit-results cube',&
         'If omitted, use the last matching cube (fit,minimize flags) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_fit,flag_minimize],&
         code_read,&
         ! %toprog() needs to first access the data in imaset;
         ! %data() will change it for speset iteration afterwards.
         code_access_imaset,&
         parameters%incube,&
         error)
    if (error) return
    call parameters%select%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'METHOD',&
         'The fitting method code',&
         strg_emp,&
         [flag_fit,flag_parameters,flag_method],&
         parameters%method,&
         error)
    if (error) return
    call oucube%register(&
         'NLINES',&
         'The number of fitted lines',&
         strg_emp,&
         [flag_fit,flag_parameters,flag_nlines],&
         parameters%nfuncs,&
         error)
    if (error) return
    call oucube%register(&
         'NOISE',&
         'The base or line noise image',&
         strg_emp,&
         [flag_fit,flag_parameters,flag_any,flag_noise,flag_any],&
         parameters%sigmas,&
         error)
    if (error) return
    call oucube%register(&
         'PARAMETER',&
         'The fitted parameters (as many as needed)',&
         strg_emp,&
         [flag_fit,flag_parameters,flag_any,flag_any,flag_any,flag_any],&
         parameters%output,&
         error)
    if (error) return
  end subroutine cubefit_parameters_register
  !
  subroutine cubefit_parameters_parse(parameters,line,user,error)
    !----------------------------------------------------------------------
    ! PARAMETERS cubname
    !----------------------------------------------------------------------
    class(parameters_comm_t), intent(in)    :: parameters
    character(len=*),         intent(in)    :: line
    type(parameters_user_t),  intent(out)   :: user
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='PARAMETERS>PARSE'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,parameters%comm,user%cubeids,error)
    if (error) return
    call parameters%select%parse(line,user%sele,error)
    if (error) return
  end subroutine cubefit_parameters_parse
  !
  subroutine cubefit_parameters_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_comm_t), intent(in)    :: comm
    type(parameters_user_t),  intent(in)    :: user
    logical,                  intent(inout) :: error
    !
    type(parameters_prog_t) :: prog
    character(len=*), parameter :: rname='PARAMETERS>MAIN'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(error)
    if (error) return    
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubefit_parameters_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_parameters_user_toprog(user,comm,prog,error)
    use gkernel_interfaces
    use cubetools_nan
    use cubetools_shape_types
    use cubetools_header_methods
    use cubedag_allflags
    use cubeadm_taskloop
    use cubeadm_opened
    use cubeadm_get
    use cubeadm_image_types
    use cubefit_spectral_fit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_user_t), intent(in)    :: user
    type(parameters_comm_t),  intent(in)    :: comm
    type(parameters_prog_t),  intent(out)   :: prog
    logical,                  intent(inout) :: error
    !
    type(shape_t) :: n
    type(flag_t) :: methflag,funcflag,paraflag
    type(image_t) :: method,imnfuncs,status
    type(cubeadm_iterator_t) :: iter
    logical :: loop,found,meth_prob,nfunc_prob,round_prob
    integer(kind=4) :: nfuncs(nmeth),nfunc,imeth,maxpar,ier,iout,icol,jcol,ifunc,stat
    integer(kind=chan_k) :: nout,nmax
    integer(kind=pixe_k) :: ix,iy
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PARAMETERS>USER>TOPROG'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call comm%select%user2prog(user%sele,prog%sele,error)
    if (error) return
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    call method%associate('method',prog%incube,iter,error)
    if (error) return
    call imnfuncs%associate('imnfuncs',prog%incube,iter,error)
    if (error) return
    call status%associate('status',prog%incube,iter,error)
    if (error) return
    !
    loop = cubeadm_dataiterate_all(iter,error)  ! ZZZ we should ensure we get
      ! planes icol_method, icol_nfunc, icol_status. Probably by iterating
      ! until they are all iterated.
    if (error)  return
    ! call cubeadm_io_iterate(icol_status,icol_nfunc,prog%incube,error)
    ! if (error) return
    call method%get(icol_method,error)
    if (error) return
    call imnfuncs%get(icol_nfunc,error)
    if (error) return
    call status%get(icol_status,error)
    if (error) return
    !
    meth_prob  = .false.
    nfunc_prob = .false.
    round_prob = .false.
    nfuncs(:) = 0
    do iy=1,method%ny
       do ix=1,method%nx
          if (ieee_is_nan(status%val(ix,iy))) cycle
          stat  = nint(status%val(ix,iy))
          if (stat.eq.code_status_diverged) cycle
          imeth = nint(method%val(ix,iy))
          nfunc = nint(imnfuncs%val(ix,iy))
          round_prob = round_prob .or.(abs(nfunc-imnfuncs%val(ix,iy)).gt.1e-6)
          round_prob = round_prob .or.(abs(imeth-method%val(ix,iy)).gt.1e-6)
          meth_prob  = meth_prob  .or. (imeth.le.0.or.imeth.gt.nmeth)
          nfunc_prob = nfunc_prob .or. (nfunc.le.0.or.nfunc.gt.mfunc)
          if (nfunc.gt.nfuncs(imeth)) then
             nfuncs(imeth) = nfunc
          endif
       enddo ! ix
    enddo ! iy
    !
    if (meth_prob) then
       call cubefit_message(seve%e,rname,'Method description contains unrecognized methods')
       error = .true.
    endif
    if (nfunc_prob) then
       call cubefit_message(seve%e,rname,'Number of lines description goes beyond bounds')
       write(mess,'(a,i0,a)') 'Number of lines goes greater than ',mfunc,' and/or less than 0'
       call cubefit_message(seve%e,rname,mess)
       error = .true.
    endif
    if (round_prob) then
       call cubefit_message(seve%e,rname,'Cube does not contain a proper description of a fit')
       error = .true.
    endif
    if (error) return
    !
    if (prog%sele%ifunc.gt.maxval(imnfuncs%val)) then
       write (mess,'(2(a,i0))') 'Line ',prog%sele%ifunc,' Goes beyond the maximum of lines found: ',&
            nint(maxval(imnfuncs%val))
       call cubefit_message(seve%w,rname,mess)
    endif
    !
    nmax = 0
    if (prog%sele%imeth.eq.code_method_all) then
       ! All Methods are to be used
       prog%nmeth     = 0
       prog%methhash(:) = 0
       prog%npara(:)     = 0 
       do imeth=1,nmeth
          if (nfuncs(imeth).gt.0) then
             prog%nmeth = prog%nmeth+1
             prog%methhash(imeth) = prog%nmeth
             call cubefit_parameters_npars_nout(imeth,nfuncs(imeth),prog%npara(imeth),nout,error)
             if (error) return
             if (nout.gt.nmax) nmax = nout
          endif
       enddo
    else
       ! A single method is to be used
       prog%nmeth = 1
       prog%methhash(:) = 0
       prog%npara(:)      = 0
       found = .false.
       do iy=1,method%ny
          do ix=1,method%nx
             if (method%val(ix,iy).eq.prog%sele%imeth) found = .true.
          enddo ! ix
       enddo ! iy
       if (.not.found) call cubefit_message(seve%w,rname,'Method '//trim(prog%sele%meth)&
            //' Not found in fit')
       prog%methhash(prog%sele%imeth) = 1
       call cubefit_parameters_npars_nout(prog%sele%imeth,nfuncs(imeth),prog%npara(prog%sele%imeth),nout,error)
       if (error) return
       if (nout.gt.nmax) nmax = nout
    endif
    maxpar = maxval(prog%npara)
    !
    call cubetools_header_get_array_shape(prog%incube%head,n,error)
    if (error) return
    if (nmax.gt.n%c) then
       call cubefit_message(&
            fitseve%trace,rname,&
            'Number of channels in cube is inferior to what is expected')
       error = .true.
       return
    endif
    !
    allocate(prog%output(prog%nmeth,maxpar,nvari),prog%sigmas(prog%nmeth,nvari),&
         prog%parahash(nmeth,maxpar),prog%ispos(prog%nmeth,maxpar),prog%reso(prog%nmeth),stat=ier)
    if (failed_allocate(rname,'Parameters cubes',ier,error)) return
    !
    prog%parahash(:,:) = 0
    do imeth=1,nmeth
       if (prog%methhash(imeth).eq.0) cycle
       do iout=1,nsig
          call prog%sigmas(prog%methhash(imeth),iout)%init&
               (imeth,prog%sele%ifunc,jcol_rmsspec,iout,comm%sigmas,error)
          if (error) return
       enddo
       jcol = 0
       do icol=1,prog%npara(imeth)
          call cubefit_parameters_flags(imeth,icol,methflag,funcflag,paraflag,error)
          if (error) return
          if (prog%sele%ifunc.ne.0) then
             call cubefit_flag2func(funcflag,ifunc,error)
             if (error) return
             if (ifunc.eq.prog%sele%ifunc) then
                jcol = jcol+1
                prog%parahash(imeth,icol) = jcol
             endif
          else
             prog%parahash(imeth,icol) = icol
          endif
          prog%ispos(prog%methhash(imeth),prog%parahash(imeth,icol)) = &
            (paraflag.eq.flag_velocity) .or. (paraflag.eq.flag_frequency)
       enddo
       if (imeth.eq.code_method_shell) then
          prog%reso(prog%methhash(imeth)) = prog%incube%head%spe%inc%f
       else
          prog%reso(prog%methhash(imeth)) = prog%incube%head%spe%inc%v
       endif
       if (imeth.eq.code_method_absorption.and.prog%sele%ifunc.gt.1) then
          prog%parahash(imeth,1) = 1
          do icol=2,size(prog%parahash(imeth,:))
             if (prog%parahash(imeth,icol).gt.0) prog%parahash(imeth,icol) = prog%parahash(imeth,icol)+1
          enddo
       endif
       do icol=1,prog%npara(imeth)
          jcol = prog%parahash(imeth,icol)
          if (jcol.gt.0) then
             do iout=1,nvari
                call prog%output(prog%methhash(imeth),jcol,iout)%init&
                     (imeth,prog%sele%ifunc,icol,iout,comm%output,error)
                if (error) return
             enddo
          endif
       enddo
    enddo
    call prog%nfuncs%init(0,0,jcol_nfunc,0,comm%nfuncs,error)
    if (error) return
    call prog%method%init(0,0,jcol_method,0,comm%method,error)
    if (error) return
    !
    call cubeadm_access_header(prog%incube,code_access_speset,code_read,error)
    if (error) return
  end subroutine cubefit_parameters_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_parameters_prog_header(prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_prog_t), intent(inout) :: prog
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: imeth,iout,icol
    character(len=*), parameter :: rname='PARAMETERS>PROG>HEADER'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    do imeth=1,nmeth
       if (prog%methhash(imeth).eq.0) cycle
       do iout=1,nsig
          call prog%sigmas(prog%methhash(imeth),iout)%clone(prog%incube,error)
          if (error) return
       enddo ! iout
       do icol=1,prog%npara(imeth)
          if (prog%parahash(imeth,icol).gt.0) then
             do iout=1,nvari
                call prog%output(prog%methhash(imeth),prog%parahash(imeth,icol),iout)%clone(prog%incube,error)
                if (error) return
             enddo ! iout
          endif
       enddo ! icol
    enddo
    call prog%nfuncs%clone(prog%incube,error)
    if (error) return
    call prog%method%clone(prog%incube,error)
    if (error) return
  end subroutine cubefit_parameters_prog_header
  !
  subroutine cubefit_parameters_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(parameters_prog_t), intent(inout) :: prog
    logical,                  intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='PARAMETERS>PROG>DATA'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubefit_parameters_prog_data
  !
  subroutine cubefit_parameters_prog_loop(prog,iter,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    integer(kind=chan_k),parameter :: one = 1
    type(spectrum_t) :: inspec,oupoint,nanpoint,sigbas,siglin
    character(len=*), parameter :: rname='PARAMETERS>PROG>LOOP'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call inspec%reassociate_and_init(prog%incube,iter,error)
    if (error) return
    call oupoint%reallocate('oupoint',one,iter,error)
    if (error) return
    call nanpoint%reallocate('nanpoint',one,iter,error)
    if (error) return
    call sigbas%reallocate('sigbas',one,iter,error)
    if (error) return
    call siglin%reallocate('siglin',one,iter,error)
    if (error) return
    !
    nanpoint%t(one) = gr4nan
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,inspec,oupoint,nanpoint,sigbas,siglin,error)
      if (error) return
    enddo ! ie
  end subroutine cubefit_parameters_prog_loop
  !
  subroutine cubefit_parameters_prog_act(prog,ie,inspec,oupoint,nanpoint,sigbas,siglin,error)
    use cubetools_nan
    use cubetools_shape_types
    use cubetools_header_methods
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_prog_t), intent(inout) :: prog
    integer(kind=entr_k),     intent(in)    :: ie
    type(spectrum_t),         intent(inout) :: inspec
    type(spectrum_t),         intent(inout) :: oupoint
    type(spectrum_t),         intent(in)    :: nanpoint
    type(spectrum_t),         intent(inout) :: sigbas
    type(spectrum_t),         intent(inout) :: siglin
    logical,                  intent(inout) :: error
    !
    type(shape_t) :: n
    integer(kind=4) :: imeth,icol,iout,jmeth,jcol
    integer(kind=chan_k) :: ic
    real(kind=sign_K) :: outdata(nvari)
    character(len=*), parameter :: rname='PARAMETERS>PROG>ACT'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call inspec%get(prog%incube,ie,error)
    if (error) return
    !
    icol = 0
    iout = 0
    ! Store method image
    oupoint%t(one) = inspec%t(icol_method)
    call oupoint%put(prog%method%cube,ie,error)
    if (error) return
    ! Store Nlines image
    oupoint%t(one) = inspec%t(icol_nfunc)
    call oupoint%put(prog%nfuncs%cube,ie,error)
    if (error) return    
    sigbas%t(one) = inspec%t(icol_rmsbase)
    siglin%t(one) = inspec%t(icol_rmsline)
    do imeth=1,nmeth
       if (prog%methhash(imeth).eq.0) cycle
       jmeth = prog%methhash(imeth)
       if (nint(inspec%t(icol_method)).eq.imeth) then
          call siglin%put(prog%sigmas(jmeth,jcol_rmsline)%cube,ie,error)
          if (error) return
          call sigbas%put(prog%sigmas(jmeth,jcol_rmsbase)%cube,ie,error)
          if (error) return          
       else
          call nanpoint%put(prog%sigmas(jmeth,jcol_rmsline)%cube,ie,error)
          if (error) return
          call nanpoint%put(prog%sigmas(jmeth,jcol_rmsbase)%cube,ie,error)
          if (error) return   
       endif
    enddo ! imeth
    call cubetools_header_get_array_shape(prog%incube%head,n,error)
    if (error) return
    do ic=ndaps+1,n%c
       select case(mod(ic-ndaps,3))
       case(1)
          ! Flags and we have reached a new parameter
          icol = icol+1
          outdata(jcol_flag) = inspec%t(ic)
       case(2)
          ! Results
          outdata(jcol_signal) = inspec%t(ic)
       case(0)
          ! Errors and then export
          outdata(jcol_noise) = inspec%t(ic)
          do imeth=1,nmeth
             jmeth = prog%methhash(imeth)
             jcol  = prog%parahash(imeth,icol)
             if (jcol.eq.0.or.jmeth.eq.0) cycle
             if (outdata(jcol_noise).eq.0) then
                outdata(jcol_snr) = gr4nan
             else
                if (prog%ispos(jmeth,jcol)) then
                   outdata(jcol_snr) = prog%reso(jmeth)/outdata(jcol_noise)
                else
                   outdata(jcol_snr) = outdata(jcol_signal)/outdata(jcol_noise)
                endif
             endif
             if (nint(inspec%t(icol_method)).eq.imeth) then
                do iout=1,nvari
                   oupoint%t(one) = outdata(iout)
                   call oupoint%put(prog%output(jmeth,jcol,iout)%cube,ie,error)
                   if (error) return
                enddo ! iout
             else
                do iout=1,nvari
                   call nanpoint%put(prog%output(jmeth,jcol,iout)%cube,ie,error)
                   if (error) return
                enddo ! iout
             endif
          enddo ! imeth
       end select
    enddo ! ic
  end subroutine cubefit_parameters_prog_act
end module cubefit_command_parameters
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gmath_quicksort_types
  use gmath_messaging
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  public :: gi4_quicksort_t,gi8_quicksort_t
  private
  !
  type, abstract :: gi4_quicksort_t
  contains
    procedure(gi4_compare_interface), public, deferred :: compare
    procedure,                        public           :: sort => gi4_quicksort_index_with_user_type
  end type gi4_quicksort_t
  !
  type, abstract :: gi8_quicksort_t
  contains
    procedure(gi8_compare_interface), public, deferred :: compare
    procedure,                        public           :: sort => gi8_quicksort_index_with_user_type
  end type gi8_quicksort_t
  !
  abstract interface
    function gi4_compare_interface(self,m,l)
      import :: gi4_quicksort_t
      !-----------------------------------------------------------------
      ! Return -1, 0, or +1 if the m-th value is lower, equal, or
      ! greater than the l-th one.
      !-----------------------------------------------------------------
      integer(kind=4) :: gi4_compare_interface
      class(gi4_quicksort_t), intent(in) :: self
      integer(kind=4),        intent(in) :: m,l
    end function gi4_compare_interface
  end interface
  !
  abstract interface
    function gi8_compare_interface(self,m,l)
      import :: gi8_quicksort_t
      !-----------------------------------------------------------------
      ! Return -1, 0, or +1 if the m-th value is lower, equal, or
      ! greater than the l-th one.
      !-----------------------------------------------------------------
      integer(kind=4) :: gi8_compare_interface
      class(gi8_quicksort_t), intent(in) :: self
      integer(kind=8),        intent(in) :: m,l
    end function gi8_compare_interface
  end interface
  !
contains
  !
  subroutine gi4_quicksort_index_with_user_type(self,x,n,error)
    !---------------------------------------------------------------------
    ! Sort an integer*4 index array according to an external comparison
    ! criteria. The index array can then be used by gi4_quicksort_array
    ! to sort an associated array.
    !---------------------------------------------------------------------
    class(gi4_quicksort_t), intent(in)    :: self   !
    integer(kind=4),        intent(in)    :: n      ! Length of index array
    integer(kind=4),        intent(inout) :: x(n)   ! Index array to be sorted
    logical,                intent(out)   :: error  ! Error status
    ! Local
    integer(kind=4), parameter :: maxstack=1000, nstop=15
    integer(kind=4) :: temp,key
    integer(kind=4) :: i,j,k,l,r,m
    integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
    !
    include 'quicksort-index-with-user-type.inc'
   end subroutine gi4_quicksort_index_with_user_type
  !
  subroutine gi8_quicksort_index_with_user_type(self,x,n,error)
    !---------------------------------------------------------------------
    ! Sort an integer*8 index array according to an external comparison
    ! criteria. The index array can then be used by gi8_quicksort_array
    ! to sort an associated array.
    !---------------------------------------------------------------------
    class(gi8_quicksort_t), intent(in)    :: self   !
    integer(kind=8),        intent(in)    :: n      ! Length of index array
    integer(kind=8),        intent(inout) :: x(n)   ! Index array to be sorted
    logical,                intent(out)   :: error  ! Error status
    ! Local
    integer(kind=4), parameter :: maxstack=1000, nstop=15
    integer(kind=8) :: temp,key
    integer(kind=8) :: i,j,k,l,r,m
    integer(kind=8) :: lstack(maxstack),rstack(maxstack),sp
    !
    include 'quicksort-index-with-user-type.inc'
   end subroutine gi8_quicksort_index_with_user_type
end module gmath_quicksort_types

module gildas_tasks_io
  !---------------------------------------------------------------------
  ! Module private to this file
  !---------------------------------------------------------------------
  integer(kind=4) :: ilun,olun
  logical :: inter_state
end module gildas_tasks_io
!
subroutine gildas_open
  use gio_dependencies_interfaces
  use gildas_tasks_io
  use gio_headers
  use gio_interfaces, only : gdf_stbl
  !---------------------------------------------------------------------
  ! @ public
  ! GILDAS
  !       I/O routines for GILDAS tasks.
  !---------------------------------------------------------------------
  ! Local
  integer :: stbl,ier
  logical :: error
  character(len=16) :: chain
  !
  ! Standard FORTRAN unit number, but possible sharing problems
  ilun = 5
  olun = 6
  inter_state = .false.
  !
  if (code_version_gdf_current.lt.code_version_gdf_v20) then
    stbl = 1
  else
    stbl = 2
  endif
  ier = sic_getlog('GILDAS_HEADERS',stbl)
  error = .false.
  call gdf_stbl(stbl,error)
  chain = ' '
  ier = sic_getlog('UVT_VERSION',chain)
  if (chain.ne.' ') call gdf_set_uvt_version(chain)
end subroutine gildas_open
!
subroutine gildas_char (name,chain)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  character(len=*), intent(out) :: chain
  ! Local
  character(len=16) :: key
  integer :: ier
  !
  if (inter_state) then
    write(olun,101) name
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,100,iostat=ier) chain
  if (ier.ne.0) then
    call putios ('E-GILDAS_CHAR, '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
101 format(1x,'Character ',a)
end subroutine gildas_char
!
subroutine gildas_charn (name,string,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  character(len=*), intent(out) :: string(n)
  ! Local
  character(len=16) :: key
  integer :: ier,i
  !
  if (inter_state) then
    write(olun,101) name
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  do i=1,n
    read (ilun,100,iostat=ier) string(i)
    if (ier.ne.0) then
      call putios('E-GILDAS_CHAR,  '//key,ier)
      call sysexi (fatale)
    endif
  enddo
100 format(a)
101 format(1x,'Character ',a)
end subroutine gildas_charn
!
subroutine gildas_real_0d (name,areal,n)
  use gildas_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_real_0d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_real
  ! ---
  ! This version for scalar argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  real(kind=4),     intent(out) :: areal
  ! Local
  character(len=message_length) :: mess
  real(kind=4) :: tmp(1)
  !
  if (n.ne.1) then
    write(mess,'(3A)')  'Internal error: argument ',trim(name),  &
      ' should be array, not scalar'
    call gio_message(seve%e,'GILDAS_REAL',mess)
    call sysexi (fatale)
  endif
  !
  call gildas_real_1d (name,tmp,1)
  areal = tmp(1)
  !
end subroutine gildas_real_0d
!
subroutine gildas_real_1d (name,areal,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_real_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_real
  ! ---
  ! This version for 1D array as argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  real(kind=4),     intent(out) :: areal(n)
  ! Local
  character(len=16) :: key
  integer :: ier
  !
  if (inter_state) then
    write(olun,102) 'Real',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) areal
  if (ier.ne.0) then
    call putios('E-GILDAS_REAL,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_real_1d
!
subroutine gildas_inte4_0d(name,ainte,n)
  use gildas_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_inte4_0d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_inte
  ! ---
  ! This version for scalar I*4 argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  integer(kind=4),  intent(out) :: ainte
  ! Local
  character(len=message_length) :: mess
  integer(kind=4) :: tmp(1)
  !
  if (n.ne.1) then
    write(mess,'(3A)')  'Internal error: argument ',trim(name),  &
      ' should be array, not scalar'
    call gio_message(seve%e,'GILDAS_INTE',mess)
    call sysexi (fatale)
  endif
  !
  call gildas_inte4_1d(name,tmp,1)
  ainte = tmp(1)
  !
end subroutine gildas_inte4_0d
!
subroutine gildas_inte4_1d(name,ainte,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_inte4_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_inte
  ! ---
  ! This version for a 1D I*4 variable
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  integer(kind=4),  intent(out) :: ainte(n)
  ! Local
  character(len=16) :: key
  integer(kind=4) :: ier
  !
  if (inter_state) then
    write(olun,102) 'Integer ',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) ainte
  if (ier.ne.0) then
    call putios('E-GILDAS_INTE,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_inte4_1d
!
subroutine gildas_inte8_1d(name,along,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_inte8_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_inte
  ! ---
  ! This version for a 1D I*8 variable
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  integer(kind=8),  intent(out) :: along(n)
  ! Local
  character(len=16) :: key
  integer(kind=4) :: ier
  !
  if (inter_state) then
    write(olun,102) 'Long ',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) along
  if (ier.ne.0) then
    call putios('E-GILDAS_INTE,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_inte8_1d
!
subroutine gildas_logi_0d (name,alogi,n)
  use gildas_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_logi_0d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_logi
  ! ---
  ! This version for scalar argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  logical,          intent(out) :: alogi
  ! Local
  character(len=message_length) :: mess
  logical :: tmp(1)
  !
  if (n.ne.1) then
    write(mess,'(3A)')  'Internal error: argument ',trim(name),  &
      ' should be array, not scalar'
    call gio_message(seve%e,'GILDAS_LOGI',mess)
    call sysexi (fatale)
  endif
  !
  call gildas_logi_1d (name,tmp,1)
  alogi = tmp(1)
  !
end subroutine gildas_logi_0d
!
subroutine gildas_logi_1d (name,alogi,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_logi_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_logi
  ! ---
  ! This version for 1D array as argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  logical,          intent(out) :: alogi(n)
  ! Local
  character(len=16) :: key
  integer :: ier
  !
  if (inter_state) then
    write(olun,102) 'Logical',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) alogi
  if (ier.ne.0) then
    call putios('E-GILDAS_LOGI,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_logi_1d
!
subroutine gildas_dble_0d (name,adble,n)
  use gildas_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_dble_0d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_dble
  ! ---
  ! This version for scalar argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  real(kind=8),     intent(out) :: adble
  ! Local
  character(len=message_length) :: mess
  real(kind=8) :: tmp(1)
  !
  if (n.ne.1) then
    write(mess,'(3A)')  'Internal error: argument ',trim(name),  &
      ' should be array, not scalar'
    call gio_message(seve%e,'GILDAS_DBLE',mess)
    call sysexi (fatale)
  endif
  !
  call gildas_dble_1d(name,tmp,1)
  adble = tmp(1)
  !
end subroutine gildas_dble_0d
!
subroutine gildas_dble_1d (name,adble,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_dble_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_dble
  ! ---
  ! This version for 1D array as argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  real(kind=8),     intent(out) :: adble(n)
  ! Local
  character(len=16) :: key
  integer :: ier
  !
  if (inter_state) then
    write(olun,102) 'Double',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) adble
  if (ier.ne.0) then
    call putios('E-GILDAS_DBLE,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_dble_1d
!
subroutine gildas_close
  use gio_dependencies_interfaces
  use gildas_tasks_io
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  if (ilun.eq.5) return
  close (unit=ilun)
  call sic_frelun (olun)
end subroutine gildas_close
!
subroutine gildas_fatale(name)
  use gio_dependencies_interfaces
  use gildas_def
  use gio_interfaces, only : gio_message
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name
  !
  call gio_message(seve%f,'GILDAS_OPEN','Missing parameter '//name)
  call sysexi (fatale)
end subroutine gildas_fatale

subroutine astro_j2000(line,error)
  use gkernel_interfaces
  use gbl_message
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !	ASTRO Command :
  !	CONVERT out_catalog_name /J2000 obs_equinox ! change ref frame to J2000
  !	/PRECESS new_equinox		! precess to equinox
  !     /FLUX fmin                ! select sources larger than fmin Jy
  !     /NAME ncname iname        ! reserve ncname chars for names;
  !                               ! Put `IAU' standard name in iname^th position
  !     /INPUT POS filename pos
  !     /INPUT FLUX filename
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  integer(kind=4), parameter :: iopt_alt=1 !
  integer(kind=4), parameter :: iopt_j2000=2 !
  integer(kind=4), parameter :: iopt_prec=3 !
  integer(kind=4), parameter :: iopt_gal=4!
  integer(kind=4), parameter :: iopt_flux=5 !
  integer(kind=4), parameter :: iopt_name=6 !
  integer(kind=4), parameter :: iopt_input=7 !
  !
  character(len=2) :: coord, fcoord    ! coordinate system ('EQ','GA','HO'...)
  character(len=2) :: vtyp             ! velocity system ('LS', 'EA', 'HE')
  real(kind=4) :: equinox, new_equinox, fequinox   ! Equinox
  real(kind=8) :: velo,redsh                       ! Velocity (km/s)
  real(kind=8) :: lambda, beta, flambda, fbeta  ! coords (rad)
  character(len=40) :: name,file
  character(len=80) :: par
  logical :: to_j2000, precess, to_galactic, do_flux, do_alt
  logical :: do_name, input, found
  integer(kind=4) :: nlu, npar, lpar, nc, lun, olun, i, icat, ier
  integer(kind=4) :: iname, nkey, ncname
  character(len=2) :: ftype
  real(kind=4) :: flux, spindex, mag(9), obs_equinox, fmin, fflux, fspindex
  real(kind=4) :: poserr, posmin
  character(len=256) :: c_line, comment, ctext
  character(len=30) :: fcomment, ftext
  real(kind=8) :: s(2), x_0(3), x_1(3), matrix(9)
  integer(kind=4) :: mvfile
  parameter(mvfile=3)
  character(len=12) :: vfile(mvfile), key, arg, aname
  character(len=7) :: rname
  ! Data
  data vfile/'ALIAS','FLUX', 'POSITION'/
  data rname /'CONVERT'/
  ! Code -------------------------------------------------------------------
  !
  if (sic_nopt().le.0) then
    call astro_message(seve%i,rname,"Command requires at least one option")
    call astro_message(seve%i,rname,"Nothing done")
    return
  endif
  !
  do_alt = sic_present(iopt_alt,0)
  do_name = sic_present(iopt_name,0)
  do_flux = sic_present(iopt_flux,0)
  to_j2000 = sic_present(iopt_j2000,0)
  precess = sic_present(iopt_prec,0)
  to_galactic = sic_present(iopt_gal,0)
  input = sic_present(iopt_input,0)
  !
  ! Some options are exclusive
  if ((to_j2000.and.precess).or.(to_j2000.and.to_galactic).or.(to_galactic.and.precess)) then
    call astro_message(seve%e,rname,"/J2000, /PRECESS, /GALACTIC options cannot be combined")
    error=.true.
    return
  endif
  !
  ! Select right catalog
  if (do_alt) then
    icat = 2
  else
    icat = 1
  endif
  if (lenc(catalog_name(icat)).eq.0) then
    call astro_message(seve%f,rname,'No catalog')
    error = .true.
    return
  endif
  !
  ! Find output file name
  if (sic_present(0,1)) then
    ! Output File given in arg
    call sic_ch (line,0,1,name,nc,.true.,error)
    if (error) return
    call sic_parsef(name,file,' ','.sou')
  else
    ! Output file automatic
    name = catalog_name(icat)
    call sic_parsef(name,file,' ','.sou')
    nc = lenc(name)
    if (to_j2000) then
      name = name(1:nc)//'-J2000'
    elseif (precess) then
      name = name(1:nc)//'-prec'
    elseif (to_galactic) then
      name = name(1:nc)//'-gal'
    endif
    if (do_flux) then
      nc = lenc(name)
      name = name(1:nc)//'-flux'
    endif
    if (do_name) then
      nc = lenc(name)
      name = name(1:nc)//'-name'
    endif
    if (input) then
      nc = lenc(name)
      name = name(1:nc)//'-new'
    endif
    call sic_parsef(name,file,' ','.sou')
  endif
  !
  ! Input file for edition
  iname = 0
  if (input) then
    ! Read argument
    call sic_ke(line,iopt_input,1,arg,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,arg,key,nkey,vfile,mvfile,error)
    if (error) return
    ! Read file name
    call sic_ch(line,iopt_input,2,name,nc,.true.,error)
    if (error) return
    call sic_parsef(name,file,' ','.dat')
    if (key.eq.'POSITION') then
      posmin = 0.0001
      call sic_r4(line,iopt_input,3,posmin,.false.,error)
      if (error) return
    elseif (key.eq.'ALIAS') then
      iname = -1
    endif
    call get_input(key,file,error)
    if (error) return
  endif
  !
  ! /NAME ncname iname
  ncname = 48
  if (do_name) then
    call sic_i4(line,iopt_name,1,ncname,.true.,error)
    if (error) return
    call sic_i4(line,iopt_name,2,iname,.false.,error)
    if (error) return
  endif
  !
  ! Case of FLUX option
  fmin = -1.
  if (do_flux) then
    call sic_r4(line,iopt_flux,1,fmin,.true.,error)
    if (error) return
  endif
  !
  !
  ! Observation equinox:
  obs_equinox = 1950.
  if (to_j2000) then
    call sic_r4 (line,iopt_j2000,1,obs_equinox,.false.,error)
    if (error) return
  endif
  ! New equinox:
  new_equinox = 2000.
  if (precess) then
    call sic_r4 (line,iopt_prec,1,new_equinox,.false.,error)
    if (error) return
  endif
  !
  ! Open input catalog
  ier = sic_getlun (lun)
  ier = sic_open(lun,catalog_name(icat),'OLD',.true.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening '// catalog_name(icat))
    call putios('E-CONVERT,  ',ier)
    error = .true.
    call sic_frelun(lun)
    return
  endif
  !
  ! Open output catalog
  ier = sic_getlun(olun)
  ier = sic_open(olun,file,'NEW',.false.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening file:')
    call astro_message(seve%e,rname,file)
    call putios('E-CONVERT,  ',ier)
    error = .true.
    goto 210
  endif
  vtyp = 'LS'
  !
  do while (.true.)
    ! Start to read the catalog
    100      read(lun,1000,end=210,iostat=ier) c_line
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Error reading catalog')
      error = .true.
      goto 210
    endif
    nlu = lenc(c_line)
    if (nlu.eq.0) then
      ! Empty line in input
      write(olun,1000) '!'
      goto 100
    elseif (c_line(1:1).eq.'!') then    
      ! commented line in input
      write(olun,1000) c_line(1:nlu)
      goto 100
    endif
    ! Look for comment
    i = index(c_line(1:nlu),'!')
    if (i.ne.0) then
      comment = c_line(i+1:nlu)
      nc = lenc(comment)
      call sic_blanc(comment,nc)
    else
      comment = ' '
    endif
    ! Process the meaningful part of the line
    call sic_blanc(c_line,nlu)
    npar = 1
    lpar = 50
    call sic_next(c_line(1:nlu),par,lpar,npar)
    if (lpar.eq.0) goto 100
    par = par(1:lpar)
    lpar = min(lpar,48)
    ctext = par(1:lpar)
    ! Decode the line (coordinate, velocity, fluxes,...)
    call decode_line (c_line, npar, coord, equinox, lambda, beta, vtyp, velo, redsh, &
    ftype, flux, spindex, mag, error)
    ! Do the requested conversion
    if (to_j2000) then
      if (coord.eq.'EQ' .and. equinox.eq.1950. ) then
        call b1950_to_j2000(obs_equinox,lambda,beta)
        equinox = 2000.0
      else
        call astro_message(seve%r,rname,par(1:lpar)//' not converted to J2000')
      endif
    endif
    if (precess) then
      if (coord.eq.'EQ') then
        call do_precess(equinox,new_equinox,lambda,beta)
      elseif (coord.eq.'GA') then
        s(1) = lambda
        s(2) = beta
        call rect (s, x_0)
        call chgcoo ('GA','EQ',1950.0,new_equinox,matrix)
        call matvec (x_0, matrix, x_1)
        call spher (x_1, s)
        lambda = s(1)
        beta = s(2)
        coord = 'EQ'
      else
        call astro_message(seve%r,rname,par(1:lpar)//' not precessed')
      endif
    endif
    if (to_galactic) then
      if (coord.eq.'EQ') then
        s(1) = lambda
        s(2) = beta
        call rect (s, x_0)
        call chgcoo ('EQ','GA',equinox,1950.0,matrix)
        call matvec (x_0, matrix, x_1)
        call spher (x_1, s)
        lambda = s(1)
        beta = s(2)
        coord = 'GA'
      else
        call astro_message(seve%r,rname,par(1:lpar)//' not converted')
      endif
    endif
    ! /INPUT option: add info to the line
    if (input) then
      call find_input(ctext, key, ftext, fcoord, fequinox, flambda, fbeta,  &
      fflux, fspindex, fcomment, found)
      aname = ' '
      if (found) then
        if (key.eq.'FLUX') then
          if (fflux.gt.0) then
            flux = fflux
            if (fspindex.ne.0) spindex=fspindex
            comment = comment(1:lenc(comment))//' +' //fcomment
            print 1012, ftext, flux
            1012                 format('*** ',a12,' Flux ',f8.3,'Jy')
          endif
        elseif (key.eq.'POSITION') then
          if (coord.eq.fcoord .and. equinox.eq.fequinox) then
            poserr = sqrt((lambda-flambda)**2+(beta-fbeta)**2)   &
                     *180*3600/3.1415929d0
            if (poserr.gt.posmin) then
              print 1011, ftext, poserr
              1011 format('*** ',a12,' Position Error ',f8.3,'"')
              lambda = flambda
              beta = fbeta
            endif
            comment = comment(1:lenc(comment))//' +' //fcomment
          endif
        elseif (key.eq.'ALIAS') then
          aname  = fcomment
        endif
      endif
    endif
    if (flux.ge.fmin) then
      ! Build the output line
      call encode_line (olun, par, lpar, coord, equinox, lambda, beta, vtyp,  &
      velo, ftype, flux, spindex, comment, iname, ncname, aname, error)
    endif
  enddo
  !
  ! End
  210   close (unit=lun)
  call sic_frelun (lun)
  close (unit=olun)
  call sic_frelun (olun)
  return
  !
  1000  format(a)
end subroutine astro_j2000
!
subroutine encode_line (olun, par, lpar, coord, equinox, lambda, beta, vtypx,  &
  velo, ftype, flux, spindex, comment, iname, ncname, aname, error)
  use gkernel_interfaces
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  integer(kind=4) :: olun           !
  character(len=*):: par            !
  integer(kind=4) :: lpar           !
  character(len=2) :: coord         !
  real(kind=4) :: equinox           !
  real(kind=8) :: lambda            !
  real(kind=8) :: beta              !
  character(len=2) :: vtypx         !
  real(kind=4) :: velo              !
  character(len=2) :: ftype         !
  real(kind=4) :: flux              !
  real(kind=4) :: spindex           !
  character(len=*):: comment        !
  integer(kind=4) :: iname          !
  integer(kind=4) :: ncname         !
  character(len=12) :: aname        !
  logical :: error                  !
  ! Local
  character(len=256) :: line
  character(len=80) :: cpar, ctest
  integer(kind=4) :: nc, j, k1, k2, lca
  character(len=16) :: lcoo, bcoo
  real(kind=4) :: ss
  !------------------------------------------------------------------------
  ! Code:
  ! iname = -1: insert comment as first name (in first position)
  ! iname gt 0 : insert a standard name in position iname
  ! note: this conforms to IAU standards, I guess (RL)
  ! (leave out EC or GA for the time being)
  lca = lenc(aname)
  if (iname.gt.0) then
    if (coord.eq.'EQ') then
      if (equinox.eq.2000.) then
        line(1:1) = 'J'
      elseif (equinox.eq.1950.0) then
        line(1:1) = 'B'
      endif
      call rad2sexa(lambda,24,lcoo,4,left=.true.)
      line(2:5) = lcoo(1:2)//lcoo(4:5)
      read(lcoo(7:11),'(f5.2)') ss
      write(line(6:6),'(i1.1)') int(ss/6.0)
      call rad2sexa(beta,360,bcoo,3,left=.true.)
      if (bcoo(1:1).ne.'-') then
        bcoo = '+'//bcoo(1:15)
      endif
      line(7:11) = bcoo(1:3)//bcoo(5:6)
      nc = 12
      ! strip out standard name if already there:
      k1 = index(par(1:lpar),line(1:5))
      if (k1.ne.0 .and.(k1.eq.1.or.par(k1-1:k1-1).eq.'|')) then
        k2 = index(par(k1:lpar),'|')
        if (k2.ne.0 .and. k1.gt.1) then
          par = par(1:k1-1)//par(k2+1:lpar)
          lpar = k1-1 + lpar-k2
        elseif (k2.ne.0 .and. k1.eq.1) then
          par = par(k2+1:lpar)
          lpar = lpar-k2
        else
          if (k1.gt.1) par = par(1:k1-1)
          lpar = k1-1
        endif
      endif
      !
      ! put standard name in inameth position
      j = 1
      k1 = 1
      do while (j.lt.iname .and. k1.lt.lpar)
        k1 = index(par(k1:lpar),'|')
        if (k1.gt.0) then
          k1 = k1+1
          j = j+1
        else
          k1 = lpar+1
        endif
      enddo
      if (j.lt.iname) then
        par = par(1:lpar)//'|'//line(1:11)
      elseif (j.eq.1 .and. lpar.gt.0) then
        par = line(1:11)//'|'//par(1:lpar)
      elseif (lpar.gt.0) then
        par = par(1:k1-1)//line(1:11)//'|'//par(k1:lpar)
      else
        par = line(1:11)
        lpar = -1
      endif
      lpar = lpar+12
    endif
    ! Alias operation:
  elseif (iname.eq.-1) then
    ! (no alias provided : shortcut.
    if (lca.le.0) then
      if (coord.eq.'EQ') then
        if (equinox.eq.2000.) then
          aname(1:1) = 'J'
        elseif (equinox.eq.1950.0) then
          aname(1:1) = 'B'
        endif
        call rad2sexa(lambda,24,lcoo,4,left=.true.)
        aname(2:5) = lcoo(1:2)//lcoo(4:5)
        call rad2sexa(beta,360,bcoo,3,left=.true.)
        if (bcoo(1:1).ne.'-') then
          bcoo = '+'//bcoo(1:15)
        endif
        aname(6:8) = bcoo(1:3)
        read(bcoo(5:6),'(f2.0)') ss
        write(aname(9:9),'(i1.1)') int(ss/6.0)
        lca = 9
      endif
    endif
    cpar(1:1)  = '|'
    cpar(2:lpar+1) = par(1:lpar)
    ctest(1:1)  = '|'
    ctest(2:lca+1) = par(1:lca)
    ! K1 = INDEX('|'//PAR(1:LPAR),'|'//ANAME(1:LCA))
    k1 = index(cpar(1:lpar+1),ctest(1:lca+1))
    if (k1.ne.0 .and.(k1.eq.1.or.par(k1-1:k1-1).eq.'|')) then
      k2 = index(par(k1:lpar),'|')
      if (k2.ne.0 .and. k1.gt.1) then
        par = par(1:k1-1)//par(k2+k1:lpar)
        lpar = lpar-k2
      elseif (k2.ne.0 .and. k1.eq.1) then
        par = par(k2+1:lpar)
        lpar = lpar-k2
      else
        if (k1.gt.2) par = par(1:k1-2)
        lpar = k1-2
      endif
    endif
    if (lpar.gt.11) then
      par= aname(1:lca)//'|'//par(13:lpar)
      lpar = lca+lpar-11
    else
      par= aname(1:lca)
      lpar = lca
    endif
  endif
  !
  ! shorten to ncname, but do not truncate an alias name:
  if (lpar.gt.ncname) then
    lpar = 0
    do while (lpar.lt.ncname)
      k1 = index(par(lpar+2:ncname+1),'|')
      if (k1.gt.0) then
        lpar = lpar + k1
      else
        if (lpar.gt.0) par(lpar+1:ncname) = ' '
        lpar = ncname
      endif
    enddo
  endif
  line = par(1:lpar)//' '
  nc = ncname+2
  !
  ! finished with names, now coords.
  line(nc:) = coord//' '
  nc = nc+3
  if (coord.eq.'EQ') then
    if (equinox.eq.2000.0) then
      line(nc+1:) = '2000 '
      nc = nc+5
    else
      write(line(nc+1:),'(F8.3,1X)') equinox
      nc = nc + 9
    endif
  endif
  if (coord.eq.'EQ') then
    call rad2sexa(lambda,24,line(nc+1:),4,left=.true.)
    line(nc+16:) = ' '
    nc = nc+16
  else
    write(line(nc+1:nc+12),'(f11.6,1x)') mod(lambda*180d0/pi+360d0,360d0)
    nc=nc+12
  endif
  if (coord.eq.'EQ') then
    if (beta.gt.0) then
      line(nc+1:) = '+'
      nc = nc+1
      call rad2sexa(beta,360,line(nc+1:),3,left=.true.)
      nc = nc+15
    else
      call rad2sexa(beta,360,line(nc+1:),3,left=.true.)
      nc = nc+16
    endif
  else
    write(line(nc+1:nc+12),'(f11.6,1x)') beta*180d0/pi
    nc=nc+12
  endif
  line(nc+1:) = ' '//vtypx//' '
  nc = nc + 4
  if (vtypx.ne.'NU') then
    write(line(nc+1:),'(F8.3,1X)') velo
    nc = nc + 9
  endif
  line(nc+1:) = ' '//ftype//' '
  nc = nc+4
  write(line(nc+1:),'(F8.3,1X)') flux
  nc = nc + 9
  write(line(nc+1:),'(F8.3,1X)') spindex
  nc = nc + 9
  write(olun,'(A,a,a)',err=99) line(1:nc),' ! ', comment(1:lenc(comment))
  return
  !
  99    error = .true.
end subroutine encode_line
!
subroutine get_input(key,file,error)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*):: key            !
  character(len=*):: file           !
  logical :: error                  !
  ! Local
  character(len=*):: fkey, ctext, fcomment, fcoord, ftext
  logical :: found
  !
  integer(kind=4) :: ier, lun, nlu, i, npar, lpar, ndata, mdata, k, idata
  integer(kind=4) :: ltext, l, nc, l1
  parameter (mdata=3500)
  character(len=2) :: coodata(mdata)
  character(len=12) :: comdata(mdata),cdata(mdata)
  real(kind=4) :: fdata(mdata), sdata(mdata),equdata(mdata)
  real(kind=4) :: equinox, velo, flux, spindex, mag(9), fequinox, fflux, fspindex
  real(kind=8) :: flambda, fbeta
  real(kind=8) :: lambda, beta, lamdata(mdata), betdata(mdata)
  character(len=32) :: comment
  character(len=256) :: c_line,par
  character(len=2) :: coord,vtyp,ftype
  character(len=7) :: rname
  ! Data
  data rname /'CONVERT'/
  !
  save
  !--------------------------------------------------------------------
  !
  ! Open data file
  ier = sic_getlun (lun)
  ier = sic_open (lun,file,'OLD',.true.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening file:')
    call astro_message(seve%e,rname,file)
    call putios('E-CONVERT,  ',ier)
    error = .true.
    call sic_frelun(lun)
    return
  endif
  !     read data
  ndata = 0
  do while (.true.)
    50       read(lun,1000,end=70,iostat=ier) c_line
    1000     format(a)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Error reading file:')
      call astro_message(seve%e,rname,file)
      error = .true.
      goto 70
    endif
    nlu = lenc(c_line)
    if (nlu.eq.0) then
      goto 50
    elseif (c_line(1:1).eq.'!') then
      goto 50
    endif
    i = index(c_line(1:nlu),'!')
    if (i.ne.0) then
      comment = c_line(i+1:nlu)
      nc = lenc(comment)
      call sic_blanc(comment,nc)
    else
      comment = ' '
    endif
    call sic_blanc(c_line,nlu)
    npar = 1
    lpar = 40
    call sic_next(c_line(1:nlu),par,lpar,npar)
    if (lpar.eq.0) goto 50
    l = index(par(1:lpar), '|')
    if (ndata.ge.mdata) then
      call astro_message(seve%e,rname,'File is too big:')
      call astro_message(seve%e,rname,file)
      goto 70
    endif
    if (key.eq.'ALIAS') then
      if (l.gt.0 .and. l.lt.lpar) then
        ndata=ndata+1
        cdata(ndata) = par(1:lpar)
        l1 = index(par(l+1:lpar), '|')
        if (l1.eq.0) l1=lpar-l+1
        comdata(ndata) = par(l+1:l+l1-1)
      endif
    else
      if (l.gt.0 .and. l.le.lpar) lpar = l-1
      par = par(1:lpar)
      call decode_line (c_line, npar, coord, equinox, lambda, beta, vtyp, velo,  &
      ftype, flux, spindex, mag, error)
      if (key.eq.'FLUX') then
        if (flux.gt.0) then
          ndata=ndata+1
          cdata(ndata) = par(1:lpar)
          fdata(ndata) = flux
          sdata(ndata) = spindex
          comdata(ndata) = comment(1:lenc(comment))
        endif
      elseif (key.eq.'POSITION') then
        ndata=ndata+1
        cdata(ndata) = par(1:lpar)
        lamdata(ndata)= lambda
        betdata(ndata)= beta
        equdata(ndata)= equinox
        coodata(ndata)= coord
        comdata(ndata) = comment(1:lenc(comment))
      endif
    endif
  enddo
  70    close(unit=lun)
  call sic_frelun(lun)
  idata = 0
  return
  !
  entry find_input(ctext, fkey, ftext, fcoord, fequinox, flambda, fbeta, fflux,  &
  fspindex, fcomment, found)
  ltext = lenc(ctext)
  do k=1, ndata
    idata = mod(idata, ndata)+1
    l = lenc(cdata(idata))
    if (index(ctext(1:ltext),cdata(idata)(1:l)) .ne. 0) then
      if (fkey.eq.'FLUX') then
        fflux = fdata(idata)
        fspindex = sdata(idata)
        fcomment = comdata(idata)
      elseif (fkey.eq.'POSITION') then
        flambda = lamdata(idata)
        fbeta = betdata(idata)
        fequinox = equdata(idata)
        fcoord = coodata(idata)
        fcomment = comdata(idata)
      elseif (fkey.eq.'ALIAS') then
        fcomment = comdata(idata)
      endif
      ftext = cdata(idata)(1:l)
      found = .true.
      return
    endif
  enddo
  found = .false.
  return
end subroutine get_input

module telcal_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! TELCAL interfaces, all kinds (private or public). Do not use
  ! directly out of the library.
  !---------------------------------------------------------------------
  !
  use telcal_interfaces_public
  use telcal_interfaces_private
  !
end module telcal_interfaces

subroutine flimit
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>flimit
  use greg_image
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !
  !	This subroutine computes the limits of the Regular Grid array.
  !	It tries to handle "Astronomical Maps" as best as possible (!).
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='RGDATA'
  real*8 :: tmp,xmin,xmax,ymin,ymax
  character(len=80) :: chain
  !
  if (rg%xval.ne.0.d0 .and. xunit.ne.'UNKNOWN') then
    if (dabs(rg%xinc/rg%xval).lt.1.d-3) then
      tmp = rg%xval/15.d0
      if (xunit.eq.'(DEGREES)') tmp = 3600.d0*tmp
      if (xunit.eq.'(ARC MIN.)') tmp = 60.d0*tmp
      call deg2sexa(tmp/3600.d0,360,coffx,2,left=.true.)
      call greg_message(seve%i,rname,'Offset in X '//coffx)
      rg%xval = 0.d0
    endif
  endif
  !
  if (rg%yval.ne.0.d0 .and. yunit.ne.'UNKNOWN') then
    if (dabs(rg%yinc/rg%yval).lt.1.d-3) then
      tmp = rg%yval
      if (yunit.eq.'(DEGREES)') tmp = 3600.*tmp
      if (yunit.eq.'(ARC MIN.)') tmp = 60.*tmp
      call deg2sexa(tmp/3600.d0,360,coffy,1,left=.true.)
      call greg_message(seve%i,rname,'Offset in Y '//coffy)
      rg%yval = 0.d0
    endif
  endif
  !
  xmin = (1.d0-rg%xref)*rg%xinc + rg%xval
  xmax = (dble(rg%nx)-rg%xref)*rg%xinc + rg%xval
  ymin = (1.d0-rg%yref)*rg%yinc + rg%yval
  ymax = (dble(rg%ny)-rg%yref)*rg%yinc + rg%yval
  !
  ! Signal the limits to the user
  write(chain,'(A,4(1X,1PG12.5))') 'Limits ',xmin,xmax,ymin,ymax
  call greg_message(seve%i,rname,chain)
end subroutine flimit

!
!
! Id: modulePakoBackend.f90,v 1.3.0  2017-09-06 Hans Ungerechts
!                                    pulsar sampling
! Id: modulePakoBackend.f90,v 1.2.3  2014-10-23 Hans Ungerechts
! Id: modulePakoBackend.f90,v 1.2.3  2014-04-29 Hans Ungerechts
!                                    holography
!
! Id: modulePakoBackend.f90,v 1.2.3  2013-08-27, 28 Hans Ungerechts
!                                    upgrade of E150 to H&V 2SB LO LI UI UO
!
! Id: modulePakoBackend.f90,v 1.2.3  2013-03-01 Hans Ungerechts
!     review against pako            2012-11-20
!     modulePakoBackend.f90,v 1.1.12 2012-02-20 Hans Ungerechts
!
!     modulePakoBackend.f90,v 1.2.2  2012-08-22 Hans Ungerechts
!     modulePakoBackend.f90,v 1.2.1  2012-06-13 Hans Ungerechts
!     based on:
!     modulePakoBackend.f90,v 1.1.12 2012-02-20 Hans Ungerechts
!     
! <DOCUMENTATION name="modulePakoBackend">
!   <PROGRAM>
!                Pako
!   <\PROGRAM>
!   <FAMILY>
!                Backend
!   </FAMILY>
!   <SIBLINGS>
!
!   </SIBLINGS>        
!
!   Pako module for command: Backend
!
! </DOCUMENTATION> <!-- name="modulePakoBackend" -->
!
Module modulePakoBackend
  !
  Use modulePakoMessages
  Use modulePakoGlobalParameters
  Use modulePakoGlobalVariables
  Use modulePakoLimits
  Use modulePakoDisplayText
  Use modulePakoUtilities
  Use modulePakoReceiver,                                                        &
       &  Only: queryReceiver,                                                   &
       &        listRX, varReceiver,                                             &
       &        nEsbIF, EMIRsbType, EMIRsubBands,                                &
       &        nEMIRsbCoax, esbCoax                                             !
  Use modulePakoXML
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  Public :: backend, displayBackend, saveBackend, writeXMLbackend
  !     
  ! *** Variables for backend ***
  Include 'inc/variables/variablesBackend.inc'
!!!   
!!!   
Contains
!!!   
!!!
  Subroutine Backend(programName,line,command,ERROR)
    !
    ! *** arguments: ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer               :: iOption2, iOption3
    Integer               :: countBE
    Logical               :: errorBE
    !
    Logical               :: doCCD              !  do clear, connect, or disconnect
    Logical               :: doClear
    Logical               :: doConnect          !  do connect based on /CONNECT or implicitly
    Logical               :: doConnectExplicit  !  explicit option /CONNECT .True.
    Logical               :: doDisconnect
    Logical               :: doDefaults         !  option /DEFAULTS is present
    Logical               :: fineFTS            !  option /FINEFTS is present
    Logical               :: doLineName         !  option /LINENAMAE is present
    Logical               :: doMode             !  option /MODE is present
    Logical               :: doPercentage       !  option /PERCENTAGE is present
    Logical               :: doReceiver         !  option /RECEIVER is present
    Logical               :: shortSyntax
    !
    Logical               :: hasOptions
    !
    Logical               :: doImplicitConnect
    !
    Real(Kind=kindSingle) ::      percentUsed
    Real(Kind=kindSingle) :: VESPApercentUsed
    !
    Logical               :: isConnectedRX      !  when checking if receiver is connected
    !
    Real(Kind=kindSingle) :: fShiftForced
    !
    Logical               :: receiverIsEMIR
    Logical               :: receiverIsHERA
    !
    Integer               :: length
    !
    Include 'inc/ranges/rangesBackend.inc'
    !
    ERROR       = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &          " module Backend v1.3.0 2017-09-13 ---> SR: Backend ")       ! this allows to trace execution
    !
    doCCD         = .False.
    doClear       = .False.
    doConnect     = .False.
    doDisconnect  = .False.
    doDefaults    = .False.
    fineFTS       = .False.
    doLineName    = .False.
    doMode        = .False.
    doPercentage  = .False.
    doReceiver    = .False.
    shortSyntax   = .False.
    !
    hasOptions    = .False.
    !
    doImplicitConnect   = .False. 
    !
    !D     Write (6,*) " BBC    samples ", vars(iValue,iBBC)%nSamples,   vars(iValue,iBBC)%samplesIsSet 
    !D     Write (6,*) " VESPA  samples ", vars(iValue,iVESPA)%nSamples, vars(iValue,iVESPA)%samplesIsSet 
    !D     Write (6,*) " WILMA  samples ", vars(iValue,iWILMA)%nSamples, vars(iValue,iWILMA)%samplesIsSet 
    !D     Write (6,*) "                                 "
    !D     Write (6,*) " GV%pulsarMode: ", GV%pulsarMode
    !D     Write (6,*) "                                 "
    !
    Call queryReceiver("EMIR", receiverIsEMIR)
    Call queryReceiver("HERA", receiverIsHERA)
    !D     Write (6,*) "      receiverIsEMIR: ", receiverIsEMIR
    !
!!$!!OLD    Write (6,*) "     backendChoices: ", backendChoices
!!$!!OLD    Write (6,*) "     bac%Continuum:  ", bac%Continuum
!!$!!OLD    Write (6,*) "     bac%FB4MHz      ", bac%FB4MHz  
!!$!!OLD    Write (6,*) "     bac%FB1MHz      ", bac%FB1MHz  
!!$!!OLD    Write (6,*) "     bac%FB100kHz    ", bac%FB100kHz
!!$!!OLD    Write (6,*) "     bac%FTS         ", bac%FTS     
!!$!!OLD    Write (6,*) "     bac%WILMA       ", bac%WILMA   
!!$!!OLD    Write (6,*) "     bac%VESPA       ", bac%VESPA   
!!$!!OLD    Write (6,*) "     bac%ABBA        ", bac%ABBA    
!!$!!OLD    Write (6,*) "     bac%USB         ", bac%USB     
!!$
    ! *** Initialize:   ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/backendSetDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values   ***
    If (.Not.ERROR) Then
       vars(iIn,:) = vars(iValue,:)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    ! *** read Parameters, Options (to detect errors)         ***
    ! *** and check for validity and ranges                   ***
    Call checkNofParameters(command,                                             &
         &     0, 8,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !    
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/parameters/parametersBackend.inc'                            
       Include 'inc/options/readOptionsBackend.inc'          
    End If
    !
!!$    !D     Write (6,*) "         after 1st parametersBackend.inc readOptionsBackend.inc "
!!$    !D     Write (6,*) "         vars(iIn,iBack): ", vars(iIn,iBack)
    !
    ! *** set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          If (receiverIsEMIR) Then
             Include 'inc/variables/backendSetDefaults.inc'
          Else
             error = .True.
             messageText = " /defaults only works with receiver EMIR"
             Call pakoMessage(priorityE,severityE,command,messageText)
          End If
       End If
    End If
    !
    If (GV%doDebugMessages) Then
       Write (6,*)    "     ---> SR Backend after backendSetDefaults.inc"
       Do jj = 1,8,1 
          Write (6,*) "     listBE(iBBC,jj): ", listBE(iBBC,jj)
       End Do
!!$       Do jj = 1,4,1 
!!$          Write (6,*) "     listBE(iNBC,jj): ", listBE(iNBC,jj)
!!$       End Do
       Do jj = 1,4,1 
          Write (6,*) "     listBE(iContinuum,jj): ", listBE(iContinuum,jj)
       End Do
    End If
    !
    ! *** read Parameters, Options (again, after defaults!)   ***
    ! *** and check for validity and ranges                   ***
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/parameters/parametersBackend.inc'
       Include 'inc/options/readOptionsBackend.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** check consistency and                           ***                    
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.ERROR) Then
       errorInconsistent = .False.
       Include 'inc/parameters/checkConsistentBackend.inc'
       If (.Not. errorInconsistent) Then
          vars(iTemp,iBack) = vars(iIn,iBack)
       End If
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    If (.Not.ERROR) Then         !!    enforce special and fixed values
       !
       ! *** special default settings for VESPA * * 640 * * : 
       !     percentage = 82, if not specified explicitly
       !
       If (               iBack.Eq.iVESPA                                        &   
            & .And. .Not. doPercentage                                           &
            &    ) Then                                                          !
          If (vars(iTemp,iBack)%bandWidth.Ge.512.) Then                          
               vars(iTemp,iBack)%percentage = 82.0
          Else If (vars(iTemp,iBack)%percentage .Eq. 82.0) Then
               !  ** set back to "normal default"
               vars(iTemp,iBack)%percentage = vars(iDefault,iBack)%percentage
          End If
       End If   !!   VESPA * * 640 * *
       !
       ! **  EMIR: enforce formally correct fOffset (relative to VESPA)
       !           if it is fixed by hardware and user requests 0.0 ("no shift")
       !
       If     (     receiverIsEMIR                                               &
            & .And. (     iBack.Eq.iWILMA                                        &
            &        .Or. iBack.Eq.iContinuum                                    &
            &        .Or. iBack.Eq.iFB4MHz                                       &
            &        .Or. ( iBack.Eq.iFTS                                        &
            &          .And. Abs(vars(iTemp,iBack)%bandWidth-FTSbw%wide).Lt.0.1) &    !!  FTS   wide
            &        .Or. ( iBack.Eq.iFB1MHz                                     &
            &              .And. Abs(vars(iTemp,iBack)%bandWidth-1024.0).Lt.0.1) &
            &       ) ) Then                                                     !
          !
          If (Abs(vars(iTemp,iBack)%fShift-0.0) .Lt. 0.1) Then
             !
             If ( vars(iTemp,iBack)%subBand .Eq. esb%lo ) Then
                fShiftForced = fRangeSky(iBack,iLO,iCenter)                      &
                     &       - fRangeSky(iVESPA,iLO,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%li ) Then
                fShiftForced = fRangeSky(iBack,iLI,iCenter)                      &
                     &       - fRangeSky(iVESPA,iLI,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%ui ) Then
                fShiftForced = fRangeSky(iBack,iUI,iCenter)                      &
                     &       - fRangeSky(iVESPA,iUI,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%uo ) Then
                fShiftForced = fRangeSky(iBack,iUO,iCenter)                      &
                     &       - fRangeSky(iVESPA,iUO,iCenter)                     !
             End If
             !
             vars(iTemp,iBack)%fShift = fShiftForced
             !
             Write (messageText,'(a)')                                           &
                  &   " paKo OVERRULES USER parameter fShift to hardware value:" !
             Call pakoMessage(priorityI,severityI,command,messageText)
             Write (messageText,'(a,f7.1,a,a,a,a)')                              &
                  &   " set fShift to fixed value ", fShiftForced,               &
                  &   " for ",      backendChoices(iBack),                       &
                  &   " on EMIR ",  vars(iTemp,iBack)%subBand                    !
             Call pakoMessage(priorityW,severityW,command,messageText)
             !
          End If
          !
       End If   !!   EMIR  &  FTS wide
       !
       If     (     receiverIsEMIR                                               &
            & .And.(( iBack.Eq.iFTS                                              &
            &        .And. Abs(vars(iTemp,iBack)%resolution-FTSres%fine).Lt.0.01 &  !!  FTS   /fine
            &        .And. Abs(vars(iTemp,iBack)%bandWidth-FTSbw%fine).Lt.0.1)   &
            &      )) Then                                                       !
          !
          If (Abs(vars(iTemp,iBack)%fShift-0.0) .Lt. 0.1) Then
             !
             If ( vars(iTemp,iBack)%subBand .Eq. esb%lo ) Then
                fShiftForced = fRangeSkyFTSfine(iLO,iCenter)                     &
                     &       - fRangeSky(iVESPA,iLO,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%li ) Then
                fShiftForced = fRangeSkyFTSfine(iLI,iCenter)                     &
                     &       - fRangeSky(iVESPA,iLI,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%ui ) Then
                fShiftForced = fRangeSkyFTSfine(iUI,iCenter)                     &
                     &       - fRangeSky(iVESPA,iUI,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%uo ) Then
                fShiftForced = fRangeSkyFTSfine(iUO,iCenter)                     &
                     &       - fRangeSky(iVESPA,iUO,iCenter)                     !
             End If
             !
             vars(iTemp,iBack)%fShift = fShiftForced
             !
             Write (messageText,'(a)')                                           &
                  &   " paKo OVERRULES USER parameter fShift to hardware value:" !
             Call pakoMessage(priorityI,severityI,command,messageText)
             Write (messageText,'(a,f7.1,a,a,a,a)')                              &
                  &   " set fShift to fixed value ", fShiftForced,               &
                  &   " for ",      backendChoices(iBack),                       &
                  &   " on EMIR ",  vars(iTemp,iBack)%subBand                    !
             Call pakoMessage(priorityW,severityW,command,messageText)
             !
          End If
          !
       End If   !!   EMIR &  FTS /fine
       !
       If     (     receiverIsEMIR                                               &
            & .And. (     iBack.Eq.iBBC                                          &
            &       ) ) Then                                                     !
          !
          If (Abs(vars(iTemp,iBack)%fShift-0.0) .Lt. 0.1) Then
             !
             If ( vars(iTemp,iBack)%subBand .Eq. esb%lo ) Then
                fShiftForced = fRangeSky(iContinuum,iLO,iCenter)                 &
                     &       - fRangeSky(iVESPA,iLO,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%li ) Then
                fShiftForced = fRangeSky(iContinuum,iLI,iCenter)                 &
                     &       - fRangeSky(iVESPA,iLI,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%ui ) Then
                fShiftForced = fRangeSky(iContinuum,iUI,iCenter)                 &
                     &       - fRangeSky(iVESPA,iUI,iCenter)                     !
             Else If ( vars(iTemp,iBack)%subBand .Eq. esb%uo ) Then
                fShiftForced = fRangeSky(iContinuum,iUO,iCenter)                 &
                     &       - fRangeSky(iVESPA,iUO,iCenter)                     !
             End If
             !
             vars(iTemp,iBack)%fShift = fShiftForced
             !
             Write (messageText,'(a)')                                           &
                  &   " paKo OVERRULES USER parameter fShift to hardware value:" !
             Call pakoMessage(priorityI,severityI,command,messageText)
             Write (messageText,'(a,f7.1,a,a,a,a)')                              &
                  &   " set fShift to fixed value ", fShiftForced,               &
                  &   " for ",      backendChoices(iBack),                       &
                  &   " on EMIR ",  vars(iTemp,iBack)%subBand                    !
             Call pakoMessage(priorityW,severityW,command,messageText)
             !
          End If
          !
       End If   !!   EMIR BBC
       !
       ! **  FTS: enforce formally correct resolution (channel separation)
       !
       If (         (    gv%privilege.EQ.setPrivilege%staff                      &  !! allow to avoid rules
            &       .Or. gv%privilege.EQ.setPrivilege%ncsTeam )                  &
            & .And.      GV%limitCheck.Eq.setLimitCheck%loose )                  &
            & Then                                                               !
          !
       Else
          !
          If      ( iBack.Eq.iFTS                                                &
               &   .And. .Not.(      setDefaults                                 &
               &                .Or. doConnect                                   &
               &                .Or. doDisconnect                                &
               &                .Or. shortSyntax )                               &
               &  ) Then                                                         !
             !
             If (      Abs(vars(iTemp,iBack)%resolution-FTSres%wide)             &
                  &       .Le. 0.1*FTSres%wide) Then                             !
                !
                If (Abs(vars(iTemp,iBack)%resolution-FTSres%wide).Ge.0.001) Then
                   !
                   Write (messageText,'(a)')                                     &
                        &   " paKo OVERRULES USER resolution to hardware value:" !
                   Call pakoMessage(priorityI,severityI,command,messageText)
                   Write (messageText,'(a,f7.3,a,a,a,a)')                        &
                        &   " set resolution to exact value ",                   &
                        &     FTSres%wide,                                       &
                        &   " for ",      backendChoices(iBack),                 &
                        &   " on EMIR ",  vars(iTemp,iBack)%subBand              !
                   Call pakoMessage(priorityW,severityW,command,messageText)
                   !
                End If
                !
                vars(iTemp,iBack)%resolution = FTSres%wide
                !
             Else If ( Abs(vars(iTemp,iBack)%resolution-FTSres%fine)             &
                  &       .Le. 0.1*FTSres%fine) Then                             !
                !
                If (Abs(vars(iTemp,iBack)%resolution-FTSres%fine).Ge.0.001) Then
                   !
                   Write (messageText,'(a)')                                     &
                        &   " paKo OVERRULES USER resolution to hardware value:" !
                   Call pakoMessage(priorityI,severityI,command,messageText)
                   Write (messageText,'(a,f7.3,a,a,a,a)')                        &
                        &   " set resolution to exact value ",                   &
                        &     FTSres%fine,                                       &
                        &   " for ",      backendChoices(iBack),                 &
                        &   " on EMIR ",  vars(iTemp,iBack)%subBand              !
                   Call pakoMessage(priorityW,severityW,command,messageText)
                   !
                End If
                !
                vars(iTemp,iBack)%resolution = FTSres%fine
                !
             Else
                !
                ERROR = .True.
                !
                Write (messageText,'(a,f7.3,a,a,a,f7.3,f7.3)')                   &
                     &   " resolution ", vars(iTemp,iBack)%resolution,           &
                     &   " for ",      backendChoices(iBack),                    &
                     &   " wrong. valid choices: ",                              &
                     &   FTSres%fine, FTSres%wide                                !
                Call pakoMessage(priorityE,severityE,command,messageText)
                !
             End If
             !
          End If                 !!    FTS
          !
       End If                                                                      !! allow to avoid rules
       !      
    End If                       !!    enforce special and fixed values
    !
    !D     Write (6,*)    "          ---> SR Backend after overrule "
    !D     Do jj = 1,8,1 
    !D        Write (6,*) "          listBE(iFTS,jj)E: ", listBE(iFTS,jj)
    !D     End Do
    !
    ! *** store from Temp into persistent variables   ***                        
    !
    !! If (.Not.ERROR .And. .Not.setDefaults) Then
    If ( .Not.ERROR ) Then
       vars(iValue,iBack) = vars(iTemp,iBack)
       iPart = vars(iValue,iBack)%nPart
       print *,iPart,iBack,"  iPart,iBack" 
       If (.Not. doCCD) Then
          listBe(iBack,iPart) = vars(iValue,iBack)
       End If
    End If
    !
    !D     Write (6,*)    "          ---> SR Backend after store from Temp into persistent"
    !D     !
    !D     Write (6,*)    "               vars(:,iBBC)%samplesIsSet:   ",               &
    !D          &                         vars(:,iBBC)%samplesIsSet                     !
    !D     Write (6,*)    "               vars(:,iVESPA)%samplesIsSet:  ",              &
    !D          &                         vars(:,iVESPA)%samplesIsSet                   !
    !D     Write (6,*)    "               vars(:,iWILMA)%samplesIsSet:  ",              &
    !D          &                         vars(:,iWILMA)%samplesIsSet                   !
    !
    GV%pulsarMode =      vars(iValue,iBBC)%samplesIsSet                          &
         &          .Or. vars(iValue,iVESPA)%samplesIsSet                        &
         &          .Or. vars(iValue,iWILMA)%samplesIsSet                        !
    !D     Write (6,*)    "               GV%pulsarMode:     ", GV%pulsarMode
    !
    !D     Do jj = 1,8,1 
    !D        Write (6,*) "          listBE(iFTS,jj)E: ", listBE(iFTS,jj)
    !D     End Do
    !
    !     NOTE: 
    !           Character(len=lenVar)   ::  errorCode = GPnone in standardWorkingVariables.inc
    !           Integer, Parameter      ::  lenVar = 128       in sizes.inc
    !           Character(len=lenLine)  ::  messageText        in standardWorkingVariables.inc
    !           Integer, Parameter      ::  lenLine = 256      in sizes.inc
    !
    Call  checkContinuum (listRX,                                                &
         &  listBe(iContinuum,:),                                                &
         &  errorBE, errorCode, percentUsed)                                     !
    Write (messageText,'(a,f5.1)')                                               &
         &             bac%continuum//" total hardware used [%]: ", percentUsed  !
    Call pakoMessage(priorityI,severityI,command,messageText)
    If (errorBE) Then
       If (Len_trim(errorCode) .Ge. 1) Then
          messageText = bac%continuum//" error. "                                &
               &        //errorCode(1:Len_trim(errorCode))                       !
       Else
          messageText = bac%continuum//" error. "
       End If
       Call pakoMessage(priorityE,severityE,command,messageText)
    End If
    errorInconsistent = errorInconsistent .Or. errorBE
    !
    Call  checkBBC (listRX,                                                      &
         &  listBe(iBBC,:),                                                      &
         &  errorBE, errorCode, percentUsed)                                     !
    Write (messageText,'(a,f5.1)')                                               &
         &             bac%BBC//" total hardware used [%]: ", percentUsed        !
    Call pakoMessage(priorityI,severityI,command,messageText)
    If (errorBE) Then
       If (Len_trim(errorCode) .Ge. 1) Then
          messageText = bac%BBC//" error. "//errorCode(1:Len_trim(errorCode))
       Else
          messageText = bac%BBC//" error. "
       End If
       Call pakoMessage(priorityE,severityE,command,messageText)
    End If
    errorInconsistent = errorInconsistent .Or. errorBE
    !
!!$    Call  checkFB100kHz (listRX,                                                 &   !!   OBSOLETE
!!$         &  listBe(iFB100kHz,:),                                                 &
!!$         &  errorBE, errorCode, percentUsed)
!!$    Write (messageText,'(a,f5.1)')                                               &
!!$         &             " 100kHz total hardware used [%]: ", percentUsed
!!$    Call pakoMessage(priorityI,severityI,command,messageText)
!!$    If (errorBE) Then
!!$       If (Len_trim(errorCode) .Ge. 1) Then
!!$          messageText = " 100kHz error. "//errorCode(1:Len_trim(errorCode))
!!$       Else
!!$          messageText = " 100kHz error. "
!!$       End If
!!$       Call pakoMessage(priorityE,severityE,command,messageText)
!!$    End If
!!$    errorInconsistent = errorInconsistent .Or. errorBE
!!$    !
!!$    Call  checkFB1MHz (listRX,                                                   &   !!   OBSOLETE
!!$         &  listBe(iFB1MHz,:),                                                   &
!!$         &  errorBE, errorCode, percentUsed)
!!$    Write (messageText,'(a,f5.1)')                                               &
!!$         &             " 1MHz total hardware used [%]: ", percentUsed
!!$    Call pakoMessage(priorityI,severityI,command,messageText)
!!$    If (errorBE) Then
!!$       If (Len_trim(errorCode) .Ge. 1) Then
!!$          messageText = " 1MHz error. "//errorCode(1:Len_trim(errorCode))
!!$       Else
!!$          messageText = " 1MHz error. "
!!$       End If
!!$       Call pakoMessage(priorityE,severityE,command,messageText)
!!$    End If
!!$    errorInconsistent = errorInconsistent .Or. errorBE
    !
    Call  checkFB4MHz (listRX,                                                   &
         &  listBe(iFB4MHz,:),                                                   &
         &  errorBE, errorCode, percentUsed)                                     !
    Write (messageText,'(a,f5.1)')                                               &
         &             " 4MHz total hardware used [%]: ", percentUsed            !
    Call pakoMessage(priorityI,severityI,command,messageText)
    If (errorBE) Then
       If (Len_trim(errorCode) .Ge. 1) Then
          messageText = " 4MHz error. "//errorCode(1:Len_trim(errorCode))
       Else
          messageText = " 4MHz error. "
       End If
       Call pakoMessage(priorityE,severityE,command,messageText)
    End If
    errorInconsistent = errorInconsistent .Or. errorBE
    !                                                                            
    If (         (    gv%privilege.EQ.setPrivilege%staff                         &  !! allow to avoid rules
         &       .Or. gv%privilege.EQ.setPrivilege%ncsTeam )                     &
         & .And.      GV%limitCheck.Eq.setLimitCheck%loose )                     &
         & Then                                                                  !
       !
    Else
       !
       Call  checkFTS (listRX,                                                   &
            &  listBe(iFTS,:),                                                   &
            &  errorBE, errorCode, percentUsed)                                  !
       !
       Write (messageText,'(a,f5.1)')                                            &
            &             " FTS total hardware used [%]: ", percentUsed          !
       Call pakoMessage(priorityI,severityI,command,messageText)
       If (errorBE) Then
          length  = Len_trim(errorCode)
          If (Len_trim(errorCode) .Ge. 1) Then
             messageText = "FTS error. "//errorCode(1:length)
          Else
             messageText = "FTS error. "
          End If
          Call pakoMessage(priorityE,severityE,command,messageText)
       End If
       errorInconsistent = errorInconsistent .Or. errorBE
       !
    End If                                                                          !! allow to avoid rules
    !
    Call  checkUsb (listRX,                                                      &
         &  listBe(iUSBack,:),                                                   &
         &  errorBE, errorCode, percentUsed)                                     !
    Write (messageText,'(a,f5.1)')                                               &
         &             " USB total hardware used [%]: ", percentUsed             !
    Call pakoMessage(priorityI,severityI,command,messageText)
    If (errorBE) Then
       If (Len_trim(errorCode) .Ge. 1) Then
          messageText = " USB error. "//errorCode(1:Len_trim(errorCode))
       Else
          messageText = " USB error. "
       End If
       Call pakoMessage(priorityE,severityE,command,messageText)
    End If
    errorInconsistent = errorInconsistent .Or. errorBE
    !
    Call  checkWILMA (listRX,                                                    &
         &  listBe(iWILMA,:),                                                    &
         &  errorBE, errorCode, percentUsed)                                     !
    Write (messageText,'(a,f5.1)') " WILMA total hardware requested [%]: ",      &
         &                         percentUsed                                   !
    If (percentUsed.Le.100.001) Then
       Call pakoMessage(priorityI,severityI,command,messageText)
    Else
       Call pakoMessage(priorityE,severityE,command,messageText)
    End If
    If (errorBE) Then
       If (Len_trim(errorCode) .Ge. 1) Then
          messageText = " WILMA error. "//errorCode(1:Len_trim(errorCode))
       Else
          messageText = " WILMA error. "
       End If
       Call pakoMessage(priorityE,severityE,command,messageText)
    End If
    errorInconsistent = errorInconsistent .Or. errorBE
    !
    errorBE   = .False.
    errorCode = ""
    !
    Call  checkVespaEMIR (listRX,                                                &
         &  listBe(iVESPA,:),                                                    &
         &  errorBE, errorCode, VESPApercentUsed)                                !
    If (errorBE) Then
       If (Len_trim(errorCode) .Ge. 1) Then
          messageText = " VESPA error. "//errorCode(1:Len_trim(errorCode))
       Else
          messageText = " VESPA error. "
       End If
       Call pakoMessage(priorityE,severityE,command,messageText)
    End If
    errorInconsistent = errorInconsistent .Or. errorBE
    !
    Call  checkVespa (listRX,                                                    &
         &  listBe(iVESPA,:),                                                    &
         &  errorBE, errorCode, VESPApercentUsed)                                !
    Write (messageText,'(a,f9.3)')                                               &
         &             " VESPA total hardware used [%]: ", VESPApercentUsed      !
    Call pakoMessage(priorityI,severityI,command,messageText)
    If (errorBE) Then
       If (Len_trim(errorCode) .Ge. 1) Then
          messageText = " VESPA error. "//errorCode(1:Len_trim(errorCode))
       Else
          messageText = " VESPA error. "
       End If
       Call pakoMessage(priorityE,severityE,command,messageText)
    End If
    errorInconsistent = errorInconsistent .Or. errorBE
    !
    If (errorInconsistent) Then
       ERROR = .True.
       listBe(iBack,iPart) = beReset
    End If
    !
    ! *** display values ***
    !     (Note: this is done independantly of the Error status)
    Call queryReceiver(rec%Bolo,Result)
    If (.Not.Result) Then
       Call displayBackend
       Call displayBackend2
    End If
    !
    If (.Not.ERROR) Then
       GV%notReadyRXafterBE = .False.
    End If
    !D    Write (6,*) "   GV%notReadyRXafterBE: ", GV%notReadyRXafterBE
    !
    ! *** list backends in command line window ***
    !
    If (.Not.error) Then
       !
       If (iBack.Ge.1 .And. iBack.Le.nDimBackends) Then
          backendCommand(iBack) = line(1:lenc(line))
       End If
       !
       countBE = 0
       Do jj = 1,nDimBackends,1
          Do ii = 1,nDimParts,1
             l1 = lenc(listBe(jj,ii)%name)
             l2 = lenc(listBe(jj,ii)%receiverName)
             !
             If (listBe(jj,ii)%isConnected.Or.listBe(jj,ii)%wasConnected) Then
                If (listBe(jj,ii)%isConnected) Then                                  !   2011-10-20
                   countBE = countBE+1 
                End If
                !
                Write   (messageText,                                            &
                     &       '(" ",                       A10,                   & 
                     &         " ",                       I3,                    &  
                     &         " ",                       F10.3,                 &
                     &         " ",                       F10.1,                 &
                     &         " ",                       F10.1,                 &
                     &         " ",                       A5,                    &   
                     &         " ")'                                             &
                     &  )                                                        &
                     &        listBe(jj,ii)%name,                                &   !   1  A10,   
                     &        listBe(jj,ii)%nPart,                               &   !   2  I3,    
                     &        listBe(jj,ii)%resolution,                          &   !   3  F10.3, 
                     &        listBe(jj,ii)%bandwidth,                           &   !   4  F10.1, 
                     &        listBe(jj,ii)%fShift,                              &   !   5  F10.3, 
                     &        listBe(jj,ii)%receiverName                         !   !   6  A5,    
                !
                length = Len_trim(messageText)
                !
                !D  Write (6,*) " messageText(1:length) -->", messageText(1:length), "<--"
                !
                !  ** EMIR
                If (        listBe(jj,ii)%receiverName .Eq. rec%E090             &
                     & .Or. listBe(jj,ii)%receiverName .Eq. rec%E150             &
                     & .Or. listBe(jj,ii)%receiverName .Eq. rec%E230             &
                     & .Or. listBe(jj,ii)%receiverName .Eq. rec%E300 ) Then      !
                   Write   (messageText(length+2:),                              &
                        &       '(" ",                       A3,                 &   
                        &         " ",                       A5,                 &   
                        &         " ")'                                          &
                        &  )                                                     &
                        &        listBe(jj,ii)%polarization,                     &   !   7  A3,    
                        &        listBe(jj,ii)%subband                           !   !   8  A5,    
                   !
                End If
                length = Len_trim(messageText)
                !
                If (jj.eq.iVESPA .And. listBe(jj,ii)%mode.Ne.GPnone) Then
                   !
                   Write   (messageText(length+2:),                              &
                        &       '(" /mod ",                      A4,             & 
                        &         " ")'                                          &
                        &  )                                                     &
                        &        listBe(jj,ii)%mode                              !
                   !
                End If
                length = Len_trim(messageText)
                !
!!OLD                      If (jj.eq.iVESPA) Then
                If (listBe(jj,ii)%percentage.Lt.100.0) Then
                   !
                   Write   (messageText(length+2:),                              &
                        &       '(" /perc ",                     F5.1,           &
                        &         " ")'                                          &
                        &  )                                                     &
                        &        listBe(jj,ii)%percentage                        !
                   !
                End If
                length = Len_trim(messageText)
                !
                If (listBe(jj,ii)%lineName.Ne.GPnone) Then
                   !
                   Write   (messageText(length+2:),                              &
                        &       '(" /lineName ",                 A12,            & 
                        &         " ")'                                          &
                        &  )                                                     &
                        &        listBe(jj,ii)%lineName                          !
                   !
                End If
                length = Len_trim(messageText)
                !
                If (    .Not.listBe(jj,ii)%isConnected                           &
                     &  .And.listBe(jj,ii)%wasConnected) Then                    !
                   !
                   Write   (messageText(length+2:),                              &
                        &       '(" DISCONNECTED ",                              & 
                        &         " ")'                                          &
                        &  )                                                     !
                   !
                End If
                length = Len_trim(messageText)
                !
                Call pakoMessage(priorityI+1,severityI,command,messageText)
                !
             End If
             !
          End Do   !!   ii = 1,nDimParts,1
          !
          If ( vars(iValue,jj)%samplesIsSet ) Then
             Write   (messageText,                                            &
                  &       '(" "                       A10,                    &
                  &         "   /nSamples ",           I6,                    &  
                  &         " ")'                                             &
                  &  )                                                        &
                  &    backendChoices(jj),                                    &
                  &    vars(iValue,jj)%nSamples                               !  I6
             !
             length = Len_trim(messageText)
             !
             !D              Write (6,*) " messageText(1:length) -->", messageText(1:length), "<--"
             Call pakoMessage(priorityI+1,severityI,command,messageText)          
             !
          End If
          !
       End Do   !!   jj = 1,nDimBackends,1
       !
       GV%backendSet       = countBE .Ge. 1
       GV%backendNumberOf  = countBE
       !
       !D             Write (6,*) "      GV%backendSet:      ",  GV%backendSet  
       !D             Write (6,*) "      GV%backendNumberOf: ",  GV%backendNumberOf
       !
    End If   !!   (.Not.error)
    !
    !D     Write (6,*) "                                 "
    !D     Write (6,*) " BBC    samples ", vars(  :   ,iBBC)%nSamples,   vars(  :   ,iBBC)%samplesIsSet 
    !D     Write (6,*) " VESPA  samples ", vars(  :   ,iVESPA)%nSamples, vars(  :   ,iVESPA)%samplesIsSet 
    !D     Write (6,*) " WILMA  samples ", vars(  :   ,iWILMA)%nSamples, vars(  :   ,iWILMA)%samplesIsSet 
    !D     Write (6,*) "                                 "
    !D     Write (6,*) " BBC    samples ", vars(iValue,iBBC)%nSamples,   vars(iValue,iBBC)%samplesIsSet 
    !D     Write (6,*) " VESPA  samples ", vars(iValue,iVESPA)%nSamples, vars(iValue,iVESPA)%samplesIsSet 
    !D     Write (6,*) " WILMA  samples ", vars(iValue,iWILMA)%nSamples, vars(iValue,iWILMA)%samplesIsSet 
    !D     Write (6,*) "                                 "
    !D     Write (6,*) " GV%pulsarMode: ", GV%pulsarMode
    !D     Write (6,*) "                                 "
    !D     !
    !D     Write (6,*) " module backend <--- SR: backend "
    !D     Write (6,*) "                                 "
    !
    Call pako_message(seve%t,programName,                                        &
         &          " module Backend                   <--- SR: Backend ")       ! this allows to trace execution
    !
    Return
  End Subroutine Backend                                                         
!!!
!!!
  Subroutine displayBackend
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Character (len=lenVar)  ::  displayLine   = GPnone
    !
    Include 'inc/display/commandDisplayBackend.inc'
    !
  End Subroutine displayBackend
!!!
!!!
  Subroutine displayBackend2
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Character (len=lenVar)  ::  displayLine   = GPnone
    !
    Include 'inc/display/commandDisplayBackend2.inc'
    !
  End Subroutine displayBackend2
!!!
!!!
  Subroutine saveBackend(programName,LINE,commandToSave,iUnit, ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical :: isEMIR, isAC
    Logical :: receiverIsBolo
    Character (len=lenCh) :: bolometerName
    !
    Integer                :: ii, jj
    Character(len=lenLine) :: messageText
    !
    Call pako_message(seve%t,"paKo backend",                                     &
         &                      "    --> SR: saveBackend , v 1.3.0 2017-08-31")  !
    !
    ERROR = .False.
    !
    B = "\"   ! "
    S = " "
    CMD =  programName//B//"BACKEND"
    lCMD = lenc(CMD)
    !
    ERROR = .False.
    !
    contC = contNN
    !
    Write (iUnit,*) "! "
    Write (iUnit,*) "! ", CMD(1:lCMD)
    !
    Call queryReceiver(rec%bolo, receiverIsBolo,                                 &
         &       bolometerName = bolometerName)                                  !
    !
    !D     Write (6,*) "     bolometerName  ", bolometerName
    !
    If ( receiverIsBolo .And. bolometerName.Eq.bolo%NIKA ) Then
       !
       messageText = " nothing to save with receiver " // bolo%NIKA
       Call pakoMessage(priorityI,severityI,"BACKEND",messageText)
       !
    Else
       !
       Write (iUnit,*) CMD(1:lCMD), " /clear"
       !
    End If
    !
    If (.Not.receiverIsBolo) Then
       !
       backends: Do jj = 1,nDimBackends,1
          parts: Do ii = 1,nDimParts,1
             isConnected: If (listBe(jj,ii)%isConnected) Then
                !
                isAC   =      listBe(jj,ii)%name.Eq.bac%VESPA                    &
                     &   .Or. listBe(jj,ii)%name.Eq.bac%WILMA                    !
                !
                isEMIR =      listBe(jj,ii)%receiverName.Eq.rec%E090             &
                     &   .Or. listBe(jj,ii)%receiverName.Eq.rec%E150             &
                     &   .Or. listBe(jj,ii)%receiverName.Eq.rec%E230             &
                     &   .Or. listBe(jj,ii)%receiverName.Eq.rec%E300             !
                !
                autocorr: If (isAC) Then                                         !! autocorrelator: VESPA or WILMA
                   !
                   contC = contNC
                   Include 'inc/parameters/saveBackend.inc'
                   contC = contCC
                   Include 'inc/parameters/saveBackendPart.inc'
                   Include 'inc/parameters/saveBackendResolution.inc'
                   Include 'inc/parameters/saveBackendBandwidth.inc'
                   Include 'inc/parameters/saveBackendFshift.inc'
                   !
                   If (isEMIR) Then                                              !! EMIR
                      Include 'inc/parameters/saveBackendReceiverEMIR.inc'
                      If  ( listBe(jj,ii)%lineNameIsSet ) Then
                         Include 'inc/options/saveBElineName.inc'
                      End If
                   Else                                                          !! not EMIR
                      Include 'inc/parameters/saveBackendReceiver.inc'
                   End If                                                        !! isEMIR
                   !
                   Include 'inc/options/saveBEmode.inc'
                   contC = contCN
                   Include 'inc/options/savePercentage.inc'
                   !
                Else autocorr                                                    !! NOT autocorrelator
                   !
                   contC = contNC
                   Include 'inc/parameters/saveBackend.inc'
                   contC = contCC
                   Include 'inc/parameters/saveBackendPart.inc'
                   Include 'inc/parameters/saveBackendResolution.inc'
                   Include 'inc/parameters/saveBackendBandwidth.inc'
                   Include 'inc/parameters/saveBackendFshift.inc'
                   !
                   If (isEMIR) Then                                              !! is EMIR
                      If  ( listBe(jj,ii)%lineNameIsSet ) Then
                         Include 'inc/parameters/saveBackendReceiverEMIR.inc'
                         contC = contCN
                         Include 'inc/options/saveBElineName.inc'
                      Else                                   
                         contC = contCN
                         Include 'inc/parameters/saveBackendReceiverEMIR.inc'
                      End If
                   Else                                                          !! not EMIR
                      If  ( listBe(jj,ii)%lineNameIsSet ) Then
                         Include 'inc/parameters/saveBackendReceiver.inc'
                         contC = contCN
                         Include 'inc/options/saveBElineName.inc'
                      Else
                         contC = contCN
                         Include 'inc/parameters/saveBackendReceiver.inc'
                      End If
                   End If                                                        !! isEMIR
                   !
                End If autocorr                                                  !! isAC
                !
             End If isConnected
          End Do parts   !!   ii = 1,nDimParts,1 
          !
          If ( jj.Eq.iBBC .And. vars(iValue,iBBC)%isConnected                    &
               &          .And. vars(iValue,iBBC)%samplesIsSet  ) Then           !
             !D  Write (6,*) "     vars(iValue,iBBC) :   ", vars(iValue,iBBC)
             Include 'inc/options/saveBEnSamples.inc'
          End If
          If ( jj.Eq.iVESPA .And. vars(iValue,iVESPA)%isConnected                &
               &            .And. vars(iValue,iVESPA)%samplesIsSet  ) Then       !
             !D  Write (6,*) "     vars(iValue,iVESPA) : ", vars(iValue,iVESPA) 
             Include 'inc/options/saveBEnSamples.inc'
          End If
          If ( jj.Eq.iWILMA .And. vars(iValue,iWILMA)%isConnected                &
               &            .And. vars(iValue,iWILMA)%samplesIsSet  ) Then       !
             !D  Write (6,*) "     vars(iValue,iWILMA) : ", vars(iValue,iWILMA) 
             Include 'inc/options/saveBEnSamples.inc'
          End If
          !
       End Do backends   !!   Do jj = 1,nDimBackends,1
       !
    End If
    !
    Write (iUnit,*) "! "
    !
    Return
  End Subroutine saveBackend
!!!
!!!
  Subroutine writeXMLbackend(programName,LINE,commandToSave,iUnit, ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Logical :: errorXML
    Logical :: receiverIsBolo
    Logical :: receiverIsEMIR
    Logical :: receiverIsHolo
    Character (len=lenCh) :: bolometerName
    !
    Integer :: ii, jj
    Character (len=24) :: valueC
    Character (len=48) :: valueComment
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,"    --> SR: writeXMLbackend ")  
    !
    !D    Write (6,*)  "      moduleBackend --> SR: writeXMLbackend "
    !
    Include 'inc/startXML/backend.inc'
    !
    Return
  End Subroutine writeXMLbackend
!!!
!!!
  Subroutine checkContinuum (listRX, listContinuum,                              &
       &                 error,  errorCode, percentUsed)                         !
    !
    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
         &               listRX             !! list of all Receivers             !
    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
         &               listContinuum      !! list of all Continuum parts       !
    !
    Logical,                Intent(OUT)            ::  error
    Character(len=*),       Intent(OUT), Optional  ::  errorCode
    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
    !
    Integer :: lBoundRX, uBoundRX
    Integer :: lBoundBE, uBoundBE
    Integer :: ii, jj, l
    !
    Integer :: countParts
    !
    Logical :: receiverIsEMIR
    !
    Real    :: fShiftMin, fShiftMax
    Character(len=lenVar)  :: limitCode
    !
    Call pako_message(seve%t,"paKo backend",                                     &
         &                      "    --> SR: checkContinuum (NBC)")              !
    !
    error        = .False.
    percentUsed  = 0.0
    !
    countParts   = 0
    !
    Call queryReceiver("EMIR", receiverIsEMIR)
    !
    If (Len(errorCode).Ge.2) Then
       errorCode = ""
    End If
    !
    lBoundRX = Lbound(listRX,1)
    uBoundRX = Ubound(listRX,1)
    !
    lBoundBE = Lbound(listContinuum,1)
    uBoundBE = Ubound(listContinuum,1)
    !
    jj = 0
    Do ii = lBoundBE,uBoundBE,1
       If (listContinuum(ii)%isConnected) Then
          jj = jj+1
          countParts = countParts+1
          !
          !  **  EMIR
          !
          If (receiverIsEMIR) Then
             !
             If    (      listContinuum(ii)%receiverName .Eq. rec%E090) Then
                If (      listContinuum(ii)%subband      .Eq. esb%lsb            &
                   & .Or. listContinuum(ii)%subband      .Eq. esb%usb ) Then     !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+30) Then
                      errorCode = errorCode(1:l)//                               &
                           &      listContinuum(ii)%subband//" not possible"     !
                   End If
                End If
             End If
             !
             !! **   EMIR: fShift depending on EMIR sub band
             !! TBD: abtract the following checks on fShift into a Subroutine
             !!      compare checkContinuum, checkWILMA, checkFB4MHz, checkFB1MHz
             !
             If (listContinuum(ii)%subBand .Eq. esb%lo) Then
                !
                fShiftMin = Min ( fRangeSky(iContinuum,iLO,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iLO,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iContinuum,iLO,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iLO,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
                !
             Else If (listContinuum(ii)%subBand .Eq. esb%li) Then
                !
                fShiftMin = Min ( fRangeSky(iContinuum,iLI,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iLI,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iContinuum,iLI,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iLI,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
                !
             Else If (listContinuum(ii)%subBand .Eq. esb%ui) Then
                !
                fShiftMin = Min ( fRangeSky(iContinuum,iUI,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iUI,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iContinuum,iUI,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iUI,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
                !
             Else If (listContinuum(ii)%subBand .Eq. esb%uo) Then
                !
                fShiftMin = Min ( fRangeSky(iContinuum,iUO,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iUO,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iContinuum,iUO,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iUO,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
                !
             End If
             !
             If (        listContinuum(ii)%fShift.LT.fShiftMin                   &
                  & .Or. listContinuum(ii)%fShift.GT.fShiftMax  )   Then         !
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" invalid fShift "
                End If
                Write (limitCode,'(F8.1," out of range ",F8.1," to ",F8.1)')     &
                     &            listContinuum(ii)%fShift, fShiftMin, fShiftMax !
                l  = Len_trim(errorCode)
                l2 = Len_trim(limitCode)
                If ( Len(errorCode) .Ge. (l+l2) ) Then
                   errorCode = errorCode(1:l)//limitCode(1:l2)
                End If
             End If
             !
             If (.Not. error) Then
                percentUsed = percentUsed                                        &
                     &        +100.0*listContinuum(ii)%bandwidth/(1000.0*4)      !
             End If
             !
          Else  !!  not EMIR
             !
             If      (listContinuum(ii)%receiverName .Eq. rec%HERA1) Then
                percentUsed = percentUsed+50.0
             Else If (listContinuum(ii)%receiverName .Eq. rec%HERA2) Then
                percentUsed = percentUsed+50.0
             Else If (listContinuum(ii)%receiverName .Eq. rec%HERA) Then
                percentUsed = percentUsed+100.0
             Else
                percentUsed = percentUsed                                        &
                     &        +100.0*listContinuum(ii)%bandwidth/(1000.0*4)      !
             End If
             !
          End If
          !
          If (.Not. ( Abs(listContinuum(ii)%bandWidth-1000.0) .Lt. 0.001         &
               &    ) ) Then                                                     !
             error = .True.
             l = Len_trim(errorCode)
             If (Len(errorCode).Ge.l+30) Then
                errorCode = errorCode(1:l)//" wrong bandwidth"
             End If
          End If
          !
       End If
    End Do
    !
    If (countParts .Gt. 4) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many parts"
       End If
    End If
    !
    If (percentUsed .Gt. 100.) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many channels"
       End If
    End If
    !
    If (.Not. ERROR) Then
       If (Len(errorCode).Ge.2) Then
          errorCode = "OK"
       End If
    End If
    !
    Return
    !
  End Subroutine checkContinuum
!!!
!!!
  Subroutine checkBBC (listRX, listBBC,                                          &
       &                 error,  errorCode, percentUsed)                         !
    !
    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
         &               listRX    !! list of all Receivers                      !
    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
         &               listBBC   !! list of all BBC parts                      !
    !
    Logical,                Intent(OUT)            ::  error
    Character(len=*),       Intent(OUT), Optional  ::  errorCode
    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
    !
    Integer :: lBoundRX, uBoundRX
    Integer :: lBoundBE, uBoundBE
    Integer :: ii, jj, kk, l
    !
    Integer :: countParts
    !
    Logical :: receiverIsEMIR
    !
    Real    :: fShiftMin, fShiftMax
    Real(Kind=kindSingle)  :: delta, impliedValue
    Character(len=lenVar)  :: limitCode
    !
    Call pako_message(seve%t,"paKo backend","    --> SR: checkBBC ")  
    !
    error        = .False.
    percentUsed  = 0.0
    !
    countParts   = 0
    !
    Call queryReceiver("EMIR", receiverIsEMIR)
    !
    If (Len(errorCode).Ge.2) Then
       errorCode = ""
    End If
    !
    lBoundRX = Lbound(listRX,1)
    uBoundRX = Ubound(listRX,1)
    !
    lBoundBE = Lbound(listBBC,1)
    uBoundBE = Ubound(listBBC,1)
    !
    jj = 0
    Do ii = lBoundBE,uBoundBE,1
       !
       If (listBBC(ii)%isConnected) Then
          !
          jj = jj+1
          countParts = countParts+1
          !
          !  **  EMIR
          !
          If (.Not. receiverIsEMIR) Then
             !
             error = .True.                                                                                                        
             l = Len_trim(errorCode)                                                                                               
             If (Len(errorCode).Ge.l+30) Then                                                                                      
                errorCode = errorCode(1:l)//                                     &                                                       
                     &      bac%BBC//" works only with EMIR "                    !
             End If
             !
          Else                               !!  receiver is EMIR
             !
             If (ii.LT.uBoundBE) Then
                Do kk = ii+1, uBoundBE, 1
                   If (         listBBC(ii)%receiverName.Eq.listBBC(kk)%receiverName  &
                        & .And. listBBC(ii)%polarization.Eq.listBBC(kk)%polarization  &
                        & .And. listBBC(ii)%subband.Eq.listBBC(kk)%subband ) Then     !
                      error = .True.
                      l = Len_trim(errorCode)
                      If (Len(errorCode).Ge.l+80) Then
                         errorCode = errorCode(1:l)//                            &
                              &    " parts must be on different EMIR sub bands " &
                              &  //" or side bands."                             !
                      End If
                   End If
                End Do
             End If
             !
             delta = 0.1
             !
             impliedValue = 8000.0
!!!
!!!             obsolete with EMIR E150 upgrade 2013-09:
!!$             If (listBBC(ii)%receiverName .Eq. rec%E150) Then
!!$                impliedValue = 4000.0
!!$             Else
!!$                impliedValue = 8000.0
!!$             End If
             !
             If (Abs(listBBC(ii)%resolution-impliedValue) .Ge. delta) Then
                error = .True.                                                                                                        
                l = Len_trim(errorCode)                                                                                               
                If (Len(errorCode).Ge.l+30) Then                                                                                      
                   Write(errorCode,'(a,a,a,F11.1,a)')                            &
                        &      errorCode(1:l),                                   &
                        &      listBBC(ii)%receiverName,                         &
                        &    " implies resolution ", impliedValue, ". "          !
                End If
             End If
             !
             If (Abs(listBBC(ii)%bandWidth-impliedValue) .Ge. delta) Then
                error = .True.                                                                                                        
                l = Len_trim(errorCode)                                                                                               
                If (Len(errorCode).Ge.l+30) Then                                                                                      
                   Write(errorCode,'(a,a,a,F11.1,a)')                            &
                        &      errorCode(1:l),                                   &
                        &      listBBC(ii)%receiverName,                         &
                        &    " implies bandWidth ", impliedValue, ". "           !
                End If
             End If
             !
             If     (        listBBC(ii)%subband.Eq.esb%lo                       &
                  &     .Or. listBBC(ii)%subband.Eq.esb%uo                       &
                  & ) Then                                                       !
                error = .True.                                                                                                        
                l = Len_trim(errorCode)                                                                                               
                If (Len(errorCode).Ge.l+30) Then                                                                                      
                   errorCode = errorCode(1:l)//                                  &
                        &      bac%BBC//" cannot connect to "                    &
                        &      //listBBC(ii)%subband//". "                       !
                End If
             End If
!!!
!!!             obsolete with EMIR E150 upgrade 2013-09:
!!$             If     (       listBBC(ii)%receiverName .Ne. rec%E150               &
!!$                  &   .And. listBBC(ii)%subband.Ne.esb%lsb                       &
!!$                  &   .And. listBBC(ii)%subband.Ne.esb%usb                       &
!!$                  & ) Then                                                       !
             !
             If     (       listBBC(ii)%subband.Ne.esb%lsb                       &
                  &   .And. listBBC(ii)%subband.Ne.esb%usb                       &
                  & ) Then                                                       !
                error = .True.                                                                                                        
                l = Len_trim(errorCode)                                                                                               
                If (Len(errorCode).Ge.l+80) Then                                                                                      
                   errorCode = errorCode(1:l)//                                  &
                        &      " On "//listBBC(ii)%receiverName//" "//           &
                        &      " use "                                           &
                        &      //esb%lsb//" or "//esb%usb//" (8 GHz wide). "     !
                End If
             End If
             !
             !! **   EMIR: fShift depending on EMIR sub band
             !! TBD: abstract the following checks on fShift into a Subroutine
             !!      compare checkContinuum, checkWILMA, checkFB4MHz, checkFB1MHz
             !
             If (listBBC(ii)%subBand .Eq. esb%lo) Then
                !
                fShiftMin = Min ( fRangeSky(iContinuum,iLO,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iLO,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iContinuum,iLO,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iLO,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
                !
             Else If (listBBC(ii)%subBand .Eq. esb%li) Then
                !
                fShiftMin = Min ( fRangeSky(iContinuum,iLI,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iLI,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iContinuum,iLI,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iLI,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
                !
             Else If (listBBC(ii)%subBand .Eq. esb%ui) Then
                !
                fShiftMin = Min ( fRangeSky(iContinuum,iUI,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iUI,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iContinuum,iUI,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iUI,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
                !
             Else If (listBBC(ii)%subBand .Eq. esb%uo) Then
                !
                fShiftMin = Min ( fRangeSky(iContinuum,iUO,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iUO,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iContinuum,iUO,iCenterFrom),         &
                     &            fRangeSky(iContinuum,iUO,iCenterTo)    )       &
                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
                !
             Else
                !
                fShiftMin = 0.0
                fShiftMax = 0.0
                !
             End If
             !
             If (        listBBC(ii)%fShift.LT.fShiftMin                         &
                  & .Or. listBBC(ii)%fShift.GT.fShiftMax  )   Then               !
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" invalid fShift "
                End If
                Write (limitCode,'(F8.1," out of range ",F8.1," to ",F8.1)')     &
                     &            listBBC(ii)%fShift, fShiftMin, fShiftMax       !
                l  = Len_trim(errorCode)
                l2 = Len_trim(limitCode)
                If ( Len(errorCode) .Ge. (l+l2) ) Then
                   errorCode = errorCode(1:l)//limitCode(1:l2)
                End If
             End If
             !

             If (.Not. error) Then
                countParts  = countParts  + 1
                percentUsed = percentUsed + 100.0*1/16
             End If
             !
          End If                             !!  receiver is EMIR
          !
       End If                                !!  listBBC(ii)%isConnected
       !
    End Do                                   !!  loop over backend parts
    !
    If (countParts .Gt. 16) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many parts"
       End If
    End If
    !
    If (percentUsed .Gt. 100.) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many channels"
       End If
    End If
    !
    If (.Not. ERROR) Then
       If (Len(errorCode).Ge.2) Then
          errorCode = "OK"
       End If
    End If
    !
    Return
    !
  End Subroutine checkBBC
!!!
!!!
  Subroutine checkFB4Mhz (listRX, listFB4MHz,                                    &
       &                 error,  errorCode, percentUsed)                         !
    !
    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
         &               listRX          !! list of all Receivers                !
    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
         &               listFB4MHz      !! list of all FB4MHz parts             !
    !
    Logical,                Intent(OUT)            ::  error
    Character(len=*),       Intent(OUT), Optional  ::  errorCode
    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
    !
    Integer :: lBoundRX, uBoundRX
    Integer :: lBoundBE, uBoundBE
    Integer :: ii, jj, l
    !
    Integer :: countParts
    !
    Logical :: receiverIsEMIR
    !
    Real    :: fShiftMin, fShiftMax
    Character(len=lenVar)  :: limitCode
    !
    Logical, Dimension(nDimReceiverChoices) :: usesRX
    Character(len=lenCh)                    :: RXname
    Integer                                 :: iMatch, nMatch
    Logical                                 :: errorC
    !
    Call pako_message(seve%t,"paKo backend",                                     &
         &                      "    --> SR: checkFB4Mhz")                       !
    !
    error        = .False.
    percentUsed  = 0.0
    !
    countParts   = 0
    !
    Call queryReceiver("EMIR", receiverIsEMIR)
    !
    usesRX(:) = .False.
    !
    If (Len(errorCode).Ge.2) Then
       errorCode = ""
    End If
    !
    lBoundRX = Lbound(listRX,1)
    uBoundRX = Ubound(listRX,1)
    !
    lBoundBE = Lbound(listFB4MHz,1)
    uBoundBE = Ubound(listFB4MHz,1)
    !
    jj = 0
    Do ii = lBoundBE,uBoundBE,1
       If (listFB4MHz(ii)%isConnected) Then
          jj = jj+1
          !
          !  **  EMIR
          !
          If (receiverIsEMIR) Then
             !
             If (ii.Gt.2) Then
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" maximum 2 parts with EMIR"
                End If
             End If
             !
             If     (           listFB4Mhz(ii)%receiverName .Eq. rec%E090        &
                  & .And. (     listFB4Mhz(ii)%subband      .Eq. esb%lsb         &
                  &        .Or. listFB4Mhz(ii)%subband      .Eq. esb%usb )       &
                  & ) Then                                                       !
                !
                If (.Not. ( Abs(listFB4Mhz(ii)%bandWidth-                        &
                     &          stdBandWidth (iFB4MHz,iLSB)) .Lt. 50.0           &
                     &    ) ) Then                                               !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+30) Then
                      errorCode = errorCode(1:l)//" wrong bandwidth"
                   End If
                End If
                If (.Not. error) Then
                   countParts = countParts+1
                   percentUsed = percentUsed+100.0
                End If
                !
             Else
                !
                If (.Not. ( Abs(listFB4Mhz(ii)%bandWidth-                        &
                     &          stdBandWidth (iFB4MHz,iLO)) .Lt. 50.0            &
                     &    ) ) Then                                               !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+30) Then
                      errorCode = errorCode(1:l)//" wrong bandwidth"
                   End If
                End If
                If (.Not. error) Then
                   countParts = countParts+1
                   percentUsed = percentUsed+50.0
                End If
                !
             End If
             !
             !! **   EMIR: fShift depending on EMIR sub band
             !! TBD: abtract the following checks on fShift into a Subroutine
             !!      compare checkContinuum, checkWILMA, checkFB4MHz, checkFB1MHz
             !
             If (listFB4MHz(ii)%subBand .Eq. esb%lo) Then
                !
                fShiftMin = Min ( fRangeSky(iFB4MHz,iLO,iCenterFrom),            &
                     &            fRangeSky(iFB4MHz,iLO,iCenterTo)    )          &
                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iFB4MHz,iLO,iCenterFrom),            &
                     &            fRangeSky(iFB4MHz,iLO,iCenterTo)    )          &
                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
                !
             Else If (listFB4MHz(ii)%subBand .Eq. esb%li) Then
                !
                fShiftMin = Min ( fRangeSky(iFB4MHz,iLI,iCenterFrom),            &
                     &            fRangeSky(iFB4MHz,iLI,iCenterTo)    )          &
                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iFB4MHz,iLI,iCenterFrom),            &
                     &            fRangeSky(iFB4MHz,iLI,iCenterTo)    )          &
                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
                !
             Else If (listFB4MHz(ii)%subBand .Eq. esb%ui) Then
                !
                fShiftMin = Min ( fRangeSky(iFB4MHz,iUI,iCenterFrom),            &
                     &            fRangeSky(iFB4MHz,iUI,iCenterTo)    )          &
                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iFB4MHz,iUI,iCenterFrom),            &
                     &            fRangeSky(iFB4MHz,iUI,iCenterTo)    )          &
                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
                !
             Else If (listFB4MHz(ii)%subBand .Eq. esb%uo) Then
                !
                fShiftMin = Min ( fRangeSky(iFB4MHz,iUO,iCenterFrom),            &
                     &            fRangeSky(iFB4MHz,iUO,iCenterTo)    )          &
                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iFB4MHz,iUO,iCenterFrom),            &
                     &            fRangeSky(iFB4MHz,iUO,iCenterTo)    )          &
                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
                !
             End If
             !
             If (        listFB4MHz(ii)%fShift.LT.fShiftMin                      &
                  & .Or. listFB4MHz(ii)%fShift.GT.fShiftMax  )   Then            !
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" invalid fShift "
                End If
                Write (limitCode,'(F8.1," out of range ",F8.1," to ",F8.1)')     &
                     &            listFB4MHz(ii)%fShift, fShiftMin, fShiftMax    !
                l  = Len_trim(errorCode)
                l2 = Len_trim(limitCode)
                If ( Len(errorCode) .Ge. (l+l2) ) Then
                   errorCode = errorCode(1:l)//limitCode(1:l2)
                End If
             End If
             !
          Else  !!  not EMIR
             !
             countParts = countParts+1
             !
             RXname = listFB4MHz(ii)%receiverName 
             Call pakoUmatchKey (                                                &
               &              keys=receiverChoices,                              &
               &              key=RXname,                                        &
               &              command='BACKEND',                                 &
               &              howto='Start Upper',                               &
               &              iMatch=iMatch,                                     &
               &              nMatch=nMatch,                                     &
               &              error=errorC,                                      &
               &              errorCode=errorCode                                &
               &             )                                                   !
             !
             If (iMatch.Ge.1 .And. iMatch.Le.nDimReceiverChoices) Then
                If (.Not.usesRX(iMatch)) Then
                   usesRX(iMatch) = .True.
                Else
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+40) Then
                      errorCode = errorCode(1:l)//                               &
                           &   " can connect only once to receiver "//RXname     !
                   End If
                End If
             End If
             If      (listFB4MHz(ii)%receiverName .Eq. rec%HERA1) Then
                percentUsed = percentUsed+100.0
             Else If (listFB4MHz(ii)%receiverName .Eq. rec%HERA2) Then
                percentUsed = percentUsed+100.0
             Else If (listFB4MHz(ii)%receiverName .Eq. rec%HERA) Then
                percentUsed = percentUsed+200.0
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" cannot use 4MHz with "//rec%HERA
                End If
             Else
                percentUsed = percentUsed                                        &
                     &        +100.0*listFB4MHz(ii)%bandwidth/(1024.0*18)        !
             End If
             If (.Not. ( Abs(listFB4MHz(ii)%bandWidth-1024.0) .Lt. 0.001         &
                  &    ) ) Then                                                  !
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" wrong bandwidth"
                End If
             End If
             !
          End If
          !
       End If
    End Do
    !
    If (countParts.Gt.4 .Or. (receiverIsEMIR.And.countParts.Gt.2)) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many parts"
       End If
    End If
    !
    If (percentUsed .Gt. 100.) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many channels"
       End If
    End If
    !
    If (.Not. ERROR) Then
       If (Len(errorCode).Ge.2) Then
          errorCode = "OK"
       End If
    End If
    !
    Return
    !
  End Subroutine checkFB4Mhz
!!!
!!!
  Subroutine checkFTS (listRX, listFTS,                                          &
       &                 error,  errorCode, percentUsed)                         !
    !
    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
         &               listRX                                                  !   !! list of all Receivers
    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
         &               listFTS                                                 !   !! list of all FTS parts    
    !
    Logical,                Intent(OUT)            ::  error
    Character(len=*),       Intent(OUT), Optional  ::  errorCode
    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
    !
    Integer :: lBoundRX, uBoundRX
    Integer :: lBoundBE, uBoundBE
    Integer :: ii, jj, kk, l
    !
    Integer :: countParts
    !
    Logical :: receiverIsEMIR, receiverIsHERA
    !
    Real    :: fDelta
    Real    :: fShiftMin, fShiftMax
    Character(len=lenVar)  :: limitCode
    !
    Logical, Dimension(nDimReceiverChoices) :: usesRX
    !
    Call pako_message(seve%t,"paKo backend",                                     &
         &                      "    --> SR: checkFTS")                          !
    !
    error        = .False.
    percentUsed  = 0.0
    !
    countParts   = 0
    !
    Call queryReceiver("EMIR", receiverIsEMIR)
    Call queryReceiver("HERA", receiverIsHERA)
    !
    usesRX(:) = .False.
    !
    If (Len(errorCode).Ge.2) Then
       errorCode = ""
    End If
    !
    lBoundRX = Lbound(listRX,1)
    uBoundRX = Ubound(listRX,1)
    !
    lBoundBE = Lbound(listFTS,1)
    uBoundBE = Ubound(listFTS,1)
    !
    !     NOTE: 
    !           Character(len=lenVar)   ::  errorCode      in calling SR (Backend)
    !           Character(len=lenVar)   ::  limitCode      in this SR, see above
    !           Integer, Parameter      ::  lenVar = 128   in sizes.inc
    !
    jj = 0
    Do ii = lBoundBE,uBoundBE,1
       If (listFTS(ii)%isConnected) Then
          jj = jj+1
          !
          !  **  EMIR
          !
          If (receiverIsEMIR) Then
             !
             !   *   maximum bandwidth for fine resolution
             !
             !! TBD: here and below:
             !!      general mechanism to safely add text to errorCode:
             !!              directly by addinf strings
             !!              by a Write(errorCode, ...
             !!              through an auxiliary variable, e.g., limitCode
             !
             IF (Abs(listFTS(ii)%resolution-FTSres%fine).Le.0.002) Then
                !
                IF ((listFTS(ii)%bandwidth-FTSbw%fine).Ge.0.001) Then
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+80) Then
                      Write (limitCode,'(A,F8.3,A,F8.1,a)')                      &
                           &            " with resolution ",  FTSres%fine,       &
                           &            " max bandWidth is",  FTSbw%fine,        &
                           &            "."                                      !
                      l  = Len_trim(errorCode)
                      l2 = Len_trim(limitCode)
                      If ( Len(errorCode) .Ge. (l+l2) ) Then
                         errorCode = errorCode(1:l)//limitCode(1:l2)
                      End If
                   End If
                End If
             End If
             !
             If (ii.LT.uBoundBE) Then
                !
                !   *   all parts must have same resolution
                !
                Do kk = ii+1,  uBoundBE, 1
                   !
                   If (listFTS(kk)%isConnected) Then
                      !
                      If (Abs(listFTS(ii)%resolution-listFTS(kk)%resolution)     &
                           & .Gt.0.02) Then                                      !
                         error = .True.
                         l = Len_trim(errorCode)
                         If (Len(errorCode).Ge.l+80) Then
                            errorCode = errorCode(1:l)//" all parts "            &
                                 &  //" must have same resolution. "             !
                         End If
                      End If
                   End If
                   !
                End Do
                !
                !   *   parts 1 to 4 must be on 4 different EMIR sub bands
                !
                Do kk = ii+1, 4, 1
                   !
                   If (listFTS(kk)%isConnected) Then
                      !
                      If (             listFTS(ii)%receiverName                  &
                           &       .Eq.listFTS(kk)%receiverName                  &
                           & .And.     listFTS(ii)%polarization                  &
                           &       .Eq.listFTS(kk)%polarization                  &
                           & .And.     listFTS(ii)%subband                       &
                           &       .Eq.listFTS(kk)%subband ) Then                !
                         error = .True.
                         l = Len_trim(errorCode)
                         If (Len(errorCode).Ge.l+80) Then
                            errorCode = errorCode(1:l)//" parts 1 to 4 must be " &
                                 &  //" on 4 different EMIR sub bands. "         !
                         End If
                      End If
                   End If
                   !
                End Do
                !
             End If
             !
             !   *   parts 5 to 8 must be on E090 sub bands Hor UO, Hor LO, Ver UO, Ver LO
             !
             If (ii.Gt.4 .And. ii.LT.uBoundBE) Then
                Do kk = ii+1, uBoundBE, 1
                   !
                   If (listFTS(kk)%isConnected) Then
                      !
                      If (         listFTS(ii)%receiverName.Eq.listFTS(kk)%receiverName  &
                           & .And. listFTS(ii)%polarization.Eq.listFTS(kk)%polarization  &
                           & .And. listFTS(ii)%subband.Eq.listFTS(kk)%subband ) Then     !
                         error = .True.
                         l = Len_trim(errorCode)
                         If (Len(errorCode).Ge.l+90) Then
                            errorCode = errorCode(1:l)                           &
                                 &  //" parts 5 to 8 must be"                    &
                                 &  //" on 4 different E090 sub bands:"          &
                                 &  //" Hor UO, Hor LO, Ver UO, Ver LO."         !
                            !          123456789012345678901234567890
                         End If
                      End If
                   End If
                   !
                End Do
             End If
             !
             If (ii.Gt.4 .And. ii.LT.uBoundBE) Then
                !
!!!
!!!             obsolete with EMIR E150 upgrade 2013-09:
!!$                If     (             listFTS(ii)%receiverName.Eq.rec%E150        &
!!$                     &   .Or. (      listFTS(ii)%subband.Ne.esb%lo               &
!!$                     &         .And. listFTS(ii)%subband.Ne.esb%uo )             &
!!$                     & ) Then                                                    !
!
                If     (             listFTS(ii)%subband.Ne.esb%lo               &
                     &         .And. listFTS(ii)%subband.Ne.esb%uo               &
                     & ) Then                                                    !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+90) Then
                      errorCode = errorCode(1:l)                                 &
                           &  //" parts 5 to 8 must be"                          &
                           &  //" connected the 4 Outer sub bands "              &
                           &  //" on Coax 5 to 8 ."                              !
                      !          123456789012345678901234567890
                   End If
                   !
                End If
                !
             End If
             !
             !   *   maximum 8 FTS parts with EMIR
             !
             If (ii.Gt.8) Then
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" maximum 8 parts with EMIR."
                End If
             End If
             !
             !       count parts and percentUsed
             !
             If     (           listFTS(ii)%receiverName .Eq. rec%E090           &
                  & .And. (     listFTS(ii)%subband      .Eq. esb%lsb            &
                  &        .Or. listFTS(ii)%subband      .Eq. esb%usb )          &
                  & ) Then                                                       !
                !
                If (.Not. error) Then
                   countParts = countParts+1
                   percentUsed = percentUsed+25.0
                End If
                !
             Else
                !
                If (.Not. error) Then
                   countParts = countParts+1
                   percentUsed = percentUsed+12.5
                End If
                !
             End If
             !
             !! **   EMIR: fShift depending on EMIR sub band
             !! TBD: abtract the following checks on fShift into a Subroutine
             !!      compare checkContinuum, checkWILMA, checkFTS, checkFB1MHz
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "          ii:                           ", ii
                Write (6,*) "          listFTS(ii)%resolution:       ", listFTS(ii)%resolution
                Write (6,*) "          listFTS(ii)%bandWidth:        ", listFTS(ii)%bandWidth
                Write (6,*) "          listFTS(ii)%fShift:           ", listFTS(ii)%fShift
                Write (6,*) "          listFTS(ii)%receiverName:     ", listFTS(ii)%receiverName
                Write (6,*) "          listFTS(ii)%polarization:     ", listFTS(ii)%polarization
                Write (6,*) "          listFTS(ii)%subBand:          ", listFTS(ii)%subBand
             End If       
             !
             IF (Abs(listFTS(ii)%resolution-FTSres%wide).Le.0.002) Then
                !
                If (listFTS(ii)%subBand .Eq. esb%lo) Then
                   !
                   fShiftMin = Min ( fRangeSky(iFTS,iLO,iCenterFrom),            &
                        &            fRangeSky(iFTS,iLO,iCenterTo)    )          &
                        &       -    fRangeSky(iVESPA,iLO,iCenter)               !
                   !
                   fShiftMax = Max ( fRangeSky(iFTS,iLO,iCenterFrom),            &
                        &            fRangeSky(iFTS,iLO,iCenterTo)    )          &
                        &       -    fRangeSky(iVESPA,iLO,iCenter)               !
                   !
                Else If (listFTS(ii)%subBand .Eq. esb%li) Then
                   !
                   fShiftMin = Min ( fRangeSky(iFTS,iLI,iCenterFrom),            &
                        &            fRangeSky(iFTS,iLI,iCenterTo)    )          &
                        &       -    fRangeSky(iVESPA,iLI,iCenter)               !
                   !
                   fShiftMax = Max ( fRangeSky(iFTS,iLI,iCenterFrom),            &
                        &            fRangeSky(iFTS,iLI,iCenterTo)    )          &
                        &       -    fRangeSky(iVESPA,iLI,iCenter)               !
                   !
                Else If (listFTS(ii)%subBand .Eq. esb%ui) Then
                   !
                   fShiftMin = Min ( fRangeSky(iFTS,iUI,iCenterFrom),            &
                        &            fRangeSky(iFTS,iUI,iCenterTo)    )          &
                        &       -    fRangeSky(iVESPA,iUI,iCenter)               !
                   !
                   fShiftMax = Max ( fRangeSky(iFTS,iUI,iCenterFrom),            &
                        &            fRangeSky(iFTS,iUI,iCenterTo)    )          &
                        &       -    fRangeSky(iVESPA,iUI,iCenter)               !
                   !
                Else If (listFTS(ii)%subBand .Eq. esb%uo) Then
                   !
                   fShiftMin = Min ( fRangeSky(iFTS,iUO,iCenterFrom),            &
                        &            fRangeSky(iFTS,iUO,iCenterTo)    )          &
                        &       -    fRangeSky(iVESPA,iUO,iCenter)               !
                   !
                   fShiftMax = Max ( fRangeSky(iFTS,iUO,iCenterFrom),            &
                        &            fRangeSky(iFTS,iUO,iCenterTo)    )          &
                        &       -    fRangeSky(iVESPA,iUO,iCenter)               !
                   !
                End If
                !
             End IF
             !
             IF (Abs(listFTS(ii)%resolution-FTSres%fine).Le.0.002) Then
                !
                If (listFTS(ii)%subBand .Eq. esb%lo) Then
                   !
                   fShiftMin = Min ( fRangeSkyFTSfine(iLO,iCenterFrom),          &
                        &            fRangeSkyFTSfine(iLO,iCenterTo)    )        &
                        &       -    fRangeSky(iVESPA,iLO,iCenter)               !
                   !
                   fShiftMax = Max ( fRangeSkyFTSfine(iLO,iCenterFrom),          &
                        &            fRangeSkyFTSfine(iLO,iCenterTo)    )        &
                        &       -    fRangeSky(iVESPA,iLO,iCenter)               !
                   !
                Else If (listFTS(ii)%subBand .Eq. esb%li) Then
                   !
                   fShiftMin = Min ( fRangeSkyFTSfine(iLI,iCenterFrom),          &
                        &            fRangeSkyFTSfine(iLI,iCenterTo)    )        &
                        &       -    fRangeSky(iVESPA,iLI,iCenter)               !
                   !
                   fShiftMax = Max ( fRangeSkyFTSfine(iLI,iCenterFrom),          &
                        &            fRangeSkyFTSfine(iLI,iCenterTo)    )        &
                        &       -    fRangeSky(iVESPA,iLI,iCenter)               !
                   !
                Else If (listFTS(ii)%subBand .Eq. esb%ui) Then
                   !
                   fShiftMin = Min ( fRangeSkyFTSfine(iUI,iCenterFrom),          &
                        &            fRangeSkyFTSfine(iUI,iCenterTo)    )        &
                        &       -    fRangeSky(iVESPA,iUI,iCenter)               !
                   !
                   fShiftMax = Max ( fRangeSkyFTSfine(iUI,iCenterFrom),          &
                        &            fRangeSkyFTSfine(iUI,iCenterTo)    )        &
                        &       -    fRangeSky(iVESPA,iUI,iCenter)               !
                   !
                Else If (listFTS(ii)%subBand .Eq. esb%uo) Then
                   !
                   fShiftMin = Min ( fRangeSkyFTSfine(iUO,iCenterFrom),          &
                        &            fRangeSkyFTSfine(iUO,iCenterTo)    )        &
                        &       -    fRangeSky(iVESPA,iUO,iCenter)               !
                   !
                   fShiftMax = Max ( fRangeSkyFTSfine(iUO,iCenterFrom),          &
                        &            fRangeSkyFTSfine(iUO,iCenterTo)    )        &
                        &       -    fRangeSky(iVESPA,iUO,iCenter)               !
                   !
                End If
                !
             End IF
             !
             fShiftMin = fShiftMin+0.5*listFTS(ii)%bandWidth
             fShiftMax = fShiftMax-0.5*listFTS(ii)%bandWidth
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "          ... +/- 1/2 bandWidth:"
                Write (6,*) "          fShiftMin:   ", fShiftMin
                Write (6,*) "          fShiftMax:   ", fShiftMax
             End If
             !
             If (        listFTS(ii)%fShift.LT.fShiftMin                         &
                  & .Or. listFTS(ii)%fShift.GT.fShiftMax  )   Then               !
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" fShift "
                End If
                Write (limitCode,'(F8.1,3(A,F8.1),A)')                           &
                     &            listFTS(ii)%fShift,                            &
                     &            " out of range",  fShiftMin,                   &
                     &            " to",            fShiftMax,                   &
                     &            " for bandWidth", listFTS(ii)%bandWidth,       &
                     &            "."                                            !
                l  = Len_trim(errorCode)
                l2 = Len_trim(limitCode)
                If ( Len(errorCode) .Ge. (l+l2) ) Then
                   errorCode = errorCode(1:l)//limitCode(1:l2)
                End If
             End If
             !
             !  **  HERA
             !
          Else  If (receiverIsHERA) Then
             !
             fDelta = 0.1
             !
!!OLD           
!!OLD          the following restrictions disabled 2011-07-22 following 
!!OLD          request by GP in meeting 2011-07-20
!!OLD
!!OLD             If (abs(listFTS(ii)%resolution-FTSres%fine).Le.0.01) Then
!!OLD                !
!!OLD                !   *   for /fine resolution HERA must have /width narrow
!!OLD                !
!!OLD                If (          .Not.listRX(iHERA1)%width.Eq.width%narrow          &
!!OLD                     &   .Or. .Not.listRX(iHERA2)%width.Eq.width%narrow          &
!!OLD                     &   ) Then                                                  !
!!OLD                   !
!!OLD                   error = .True.
!!OLD                   l = Len_trim(errorCode)
!!OLD                   If (Len(errorCode).Ge.l+80) Then
!!OLD                      Write (errorCode,'(A, F8.3, A, A, A)')                     & 
!!OLD                           &  " for /fine resolution",                           &
!!OLD                           &   FTSres%fine,                                      &
!!OLD                           &  ": HERA must have /width ",                        &
!!OLD                           &   width%narrow,                                     &
!!OLD                           &  "."                                                !
!!OLD                   End If
!!OLD                   !
!!OLD                End If
!!OLD                !
!!OLD                !   *   for /fine resolution bandwidth must be (512)
!!OLD                !
!!OLD                bwHERA = FTSbw%fineHERA
!!OLD                !
!!OLD                If (abs(listFTS(ii)%bandWidth-bwHERA).Gt.fDelta) Then
!!OLD                   error = .True.
!!OLD                   l = Len_trim(errorCode)
!!OLD                   If (Len(errorCode).Ge.l+80) Then
!!OLD                      Write (errorCode,'(A, F8.3, A, F8.1, A)')                  & 
!!OLD                           &  " for resolution ",                                &
!!OLD                           &   FTSres%fine,                                      &
!!OLD                           &  " on HERA: bandwidth must be ",                    &
!!OLD                           &   bwHERA,                                           &
!!OLD                           &  "."                                                !
!!OLD                   End If
!!OLD                End If
!!OLD                !
!!OLD             Else
!!OLD                !
!!OLD                !   *   for wide bandwidth HERA must have /width wide
!!OLD                !
!!OLD                If (          .Not.listRX(iHERA1)%width.Eq.width%wide            &
!!OLD                     &   .Or. .Not.listRX(iHERA2)%width.Eq.width%wide            &
!!OLD                     &   ) Then                                                  !
!!OLD                   !
!!OLD                   error = .True.
!!OLD                   l = Len_trim(errorCode)
!!OLD                   If (Len(errorCode).Ge.l+80) Then
!!OLD                      Write (errorCode,'(A, F8.3, A, A, A)')                     & 
!!OLD                           &  " for resolution ",                                &
!!OLD                           &   FTSres%wide,                                      &
!!OLD                           &  ": HERA must have /width ",                        &
!!OLD                           &   width%wide,                                       &
!!OLD                           &  "."                                                !
!!OLD                   End If
!!OLD                   !
!!OLD                End If
!!OLD                !
!!OLD                !   *   for not /fine resolution bandwidth must be (1024)
!!OLD                !
!!OLD                bwHERA = stdBandWidthHERA (iFTS)
!!OLD                !
!!OLD                If (abs(listFTS(ii)%bandWidth-bwHERA).Gt.fDelta) Then
!!OLD                   error = .True.
!!OLD                   l = Len_trim(errorCode)
!!OLD                   If (Len(errorCode).Ge.l+80) Then
!!OLD                      Write (errorCode,'(A, F8.3, A, F8.1, A)')                  & 
!!OLD                           &  " for resolution ",                                &
!!OLD                           &   FTSres%wide,                                      &
!!OLD                           &  " on HERA: bandwidth must be ",                    &
!!OLD                           &   bwHERA,                                           &
!!OLD                           &  "."                                                !
!!OLD                   End If
!!OLD                End If
!!OLD                !
!!OLD             End If
             !
             !   *   maximum bandwidth of FTS on HERA (GP 2011-07-21)
             !
             fDelta = 0.01
             !
             !       maxBandWidthHeraFTSfine
             !
             If (abs(listFTS(ii)%resolution-FTSres%fine).Le.0.01) Then
                !
                If (        listFTS(ii)%bandWidth-maxBandWidthHeraFTSfine        &
                     & .Gt. fDelta) Then                                         !
                   !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+80) Then
                      Write (errorCode,'(A, F8.3, A, F8.3, A)')                  & 
                           &  " for /fine resolution",                           &
                           &   FTSres%fine,                                      &
                           &  " on HERA max. width is ",                         &
                           &   maxBandWidthHeraFTSfine,                          &
                           &  "."                                                !
                   End If
                   !
                End If
                !
             End If
             !
             !       maxBandWidthHeraFTSwide
             !
             If (abs(listFTS(ii)%resolution-FTSres%wide).Le.0.01) Then
                !
                If (        listFTS(ii)%bandWidth-maxBandWidthHeraFTSwide        &
                     & .Gt. fDelta) Then                                         !
                   !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+80) Then
                      Write (errorCode,'(A, F8.3, A, F8.3, A)')                  & 
                           &  " for resolution",                                 &
                           &   FTSres%wide,                                      &
                           &  " on HERA max. width is ",                         &
                           &   maxBandWidthHeraFTSwide,                          &
                           &  "."                                                !
                   End If
                   !
                End If
                !
             End If
             !
             !   *   all parts must have same resolution
             !
             Do kk = ii+1, 2, 1          
                !
                If (listFTS(kk)%isConnected) Then
                   !
                   If (Abs(listFTS(ii)%resolution-listFTS(kk)%resolution)        &
                        & .Gt.0.02) Then                                         !
                      error = .True.
                      l = Len_trim(errorCode)
                      If (Len(errorCode).Ge.l+80) Then
                         errorCode = errorCode(1:l)//" all parts"                &
                              &  //" must have same resolution."                 !
                      End If
                   End If
                End If
                !
             End Do
                !
             If (.Not. error) Then
                countParts = countParts+1
                percentUsed = percentUsed+50.0
             End If
             !
          Else     !!  not EMIR nor HERA
             !
             error = .True.
             l = Len_trim(errorCode)
             If (Len(errorCode).Ge.l+30) Then
                errorCode = errorCode(1:l)//" works only with EMIR or HERA"
             End If
             !
          End If   !!  If EMIR Else If HERA or Else
          !
       End If
    End Do
    !
    !  **   HERA
    !   *   FTS parts 1 and 2 can no be on the same HERA (1,2)
    !
    If (receiverIsHERA) Then    
       !
       If (listFTS(1)%isConnected.And.listFTS(2)%isConnected) Then
          !
          If (             listFTS(1)%receiverName                               &
               &       .Eq.listFTS(2)%receiverName) Then                         !
             error = .True.
             l = Len_trim(errorCode)
             If (Len(errorCode).Ge.l+80) Then
                errorCode = errorCode(1:l)                                       &
                     &  //" parts 1 and 2 can not both be on "                   &
                     &  //listFTS(1)%receiverName                                &
                     &  //"."                                                    !
             End If
          End If
          !
       End If
       !
    End If
    !
    If (           countParts.Ge.1  ) Then
       If (GV%switchingMode.Ne.GPnone .And. GV%tPhase.Le.0.1-0.001) Then
          error = .True.
          l = Len_trim(errorCode)
          If (Len(errorCode).Ge.l+80) Then
             Write (errorCode(l+1:Len(errorCode)), '(a,F8.2,a,a,a,a,a)')         &
                  &   " /tPhase ",            GV%tPhase,                         &
                  &   " in ",                 GV%switchingMode,                  &
                  &   " too small for ",      bac%FTS,                           &
                  &   "."                                                        !
          End If
       End If
    End If
    !
    If (           countParts.Gt.8                                               &
         &   .Or. (receiverIsEMIR.And.countParts.Gt.8)                           &
         &   .Or. (receiverIsHERA.And.countParts.Gt.2)                           &
         &   ) Then                                                              !
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many parts."
       End If
    End If
    !
    If (percentUsed .Gt. 100.) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many channels."
       End If
    End If
    !
    If (.Not. ERROR) Then
       If (Len(errorCode).Ge.2) Then
          errorCode = "OK"
       End If
    End If
    !
    GV%backendFTS = .Not.ERROR .And. countParts.Ge.1
    !
    Return
    !
  End Subroutine checkFTS
!!!
!!!
  Subroutine checkUSB (listRX, listUSB,                                          &
       &                 error,  errorCode, percentUsed)                         !
    !
    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
         &               listRX         !! list of all Receivers                 !
    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
         &               listUSB        !! list of all USB parts                 !
    !
    Logical,                Intent(OUT)            ::  error
    Character(len=*),       Intent(OUT), Optional  ::  errorCode
    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
    !
    Integer :: lBoundRX, uBoundRX
    Integer :: lBoundBE, uBoundBE
    Integer :: ii, jj, l
    !
    Integer :: countParts
    !
    Call pako_message(seve%t,"paKo backend",                                     &
         &                      "    --> SR: checkUSB")                          !
    !
    error        = .False.
    percentUsed  = 0.0
    !
    countParts   = 0
    !
    If (Len(errorCode).Ge.2) Then
       errorCode = ""
    End If
    !
    lBoundRX = Lbound(listRX,1)
    uBoundRX = Ubound(listRX,1)
    !
    lBoundBE = Lbound(listUSB,1)
    uBoundBE = Ubound(listUSB,1)
    !
    jj = 0
    Do ii = lBoundBE,uBoundBE,1
       If (listUSB(ii)%isConnected) Then
          jj = jj+1
          countParts = countParts+1
          percentUsed = percentUsed+100.0/nDimUSB
          If (listUSB(ii)%resolution .Gt. listUSB(ii)%bandWidth ) Then
             error = .True.
             l = Len_trim(errorCode)
             If (Len(errorCode).Ge.l+30) Then
                errorCode = errorCode(1:l)//" resolution > bandwidth"
             End If
          End If
       End If
    End Do
    !
    If (countParts .Gt. nDimUSB) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many parts"
       End If
    End If
    !
    If (percentUsed .Gt. 100.001) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many channels"
       End If
    End If
    !
    If (.Not. ERROR) Then
       If (Len(errorCode).Ge.2) Then
          errorCode = "OK"
       End If
    End If
    !
    Return
    !
  End Subroutine checkUSB
!!!
!!!
  Subroutine checkWILMA (listRX, listWILMA,                                      &
       &                 error,  errorCode, percentUsed)                         !
    !
    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
         &               listRX         !! list of all Receivers                 !
    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
         &               listWILMA      !! list of all WILMA parts               !
    !
    Logical,                Intent(OUT)            ::  error
    Character(len=*),       Intent(OUT), Optional  ::  errorCode
    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
    !
    Integer :: lBoundRX, uBoundRX
    Integer :: lBoundBE, uBoundBE
    Integer :: ii, jj, kk, l, l2
    !
    Integer :: countParts
    !
    Logical :: receiverIsEMIR
    !
    Real    :: fShiftMin, fShiftMax
    Character(len=lenVar)  :: limitCode
    !
    Call pako_message(seve%t,"paKo backend",                                     &
         &                      "    --> SR: checkWILMA")                        !
    !
    error        = .False.
    percentUsed  = 0.0
    !
    countParts   = 0
    !
    Call queryReceiver("EMIR", receiverIsEMIR)
    !
    If (Len(errorCode).Ge.2) Then
       errorCode = ""
    End If
    !
    lBoundRX = Lbound(listRX,1)
    uBoundRX = Ubound(listRX,1)
    !
    !D    Write (6,*) "      lBoundRX ", lBoundRX
    !D    Write (6,*) "      uBoundRX ", uBoundRX
    !
    !
    lBoundBE = Lbound(listWILMA,1)
    uBoundBE = Ubound(listWILMA,1)
    !
    !D     Write (6,*) "      lBoundBE ", lBoundBE
    !D     Write (6,*) "      uBoundBE ", uBoundBE
    !
    jj = 0
    Do ii = lBoundBE,uBoundBE,1
       If (listWILMA(ii)%isConnected) Then
          !
          !  **  EMIR
          !
          If (receiverIsEMIR) Then
             !
             jj = jj+1
             !
             If (ii.LT.uBoundBE) Then
                Do kk = ii+1, uBoundBE, 1
                   If (         listWILMA(ii)%receiverName.Eq.listWILMA(kk)%receiverName  &
                        & .And. listWILMA(ii)%polarization.Eq.listWILMA(kk)%polarization  &
                        & .And. listWILMA(ii)%subband.Eq.listWILMA(kk)%subband ) Then     !
                      error = .True.
                      l = Len_trim(errorCode)
                      If (Len(errorCode).Ge.l+30) Then
                         errorCode = errorCode(1:l)//                            &
                              &    " parts must be on different EMIR sub bands." !
                      End If
                   End If
                End Do
             End If
             !
             If (jj.Gt.4) Then
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" maximum 4 parts with EMIR."
                End If
             End If
             !
             If     (           listWILMA(ii)%receiverName .Eq. rec%E090         &
                  & .And. (     listWILMA(ii)%subband      .Eq. esb%lsb          &
                  &        .Or. listWILMA(ii)%subband      .Eq. esb%usb )        &
                  & ) Then                                                       !
                !
                If (.Not. ( Abs(listWILMA(ii)%bandWidth-                         &
                     &          stdBandWidth (iWILMA,iLSB)) .Lt. 50.0            &
                     &    ) ) Then                                               !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+30) Then
                      errorCode = errorCode(1:l)//" wrong bandwidth."
                   End If
                End If
                If (.Not. error) Then
                   countParts = countParts+1
                   percentUsed = percentUsed+50.0
                End If
                !
             Else
                !
                If (.Not. ( Abs(listWILMA(ii)%bandWidth-                         &
                     &          stdBandWidth (iWILMA,iLO)) .Lt. 50.0             &
                     &    ) ) Then                                               !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+30) Then
                      errorCode = errorCode(1:l)//" wrong bandwidth."
                   End If
                End If
                If (.Not. error) Then
                   countParts = countParts+1
                   percentUsed = percentUsed+25.0
                End If
                !
             End If
             !
             !! **   EMIR: fShift depending on EMIR sub band
             !! TBD: abtract the following checks on fShift into a Subroutine
             !!      compare checkContinuum, checkWILMA, checkFB4MHz, checkFB1MHz
             !
             If (listWILMA(ii)%subBand .Eq. esb%lo) Then
                !
                fShiftMin = Min ( fRangeSky(iWILMA,iLO,iCenterFrom),             &
                     &            fRangeSky(iWILMA,iLO,iCenterTo)    )           &
                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iWILMA,iLO,iCenterFrom),             &
                     &            fRangeSky(iWILMA,iLO,iCenterTo)    )           &
                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
                !
             Else If (listWILMA(ii)%subBand .Eq. esb%li) Then
                !
                fShiftMin = Min ( fRangeSky(iWILMA,iLI,iCenterFrom),             &
                     &            fRangeSky(iWILMA,iLI,iCenterTo)    )           &
                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iWILMA,iLI,iCenterFrom),             &
                     &            fRangeSky(iWILMA,iLI,iCenterTo)    )           &
                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
                !
             Else If (listWILMA(ii)%subBand .Eq. esb%ui) Then
                !
                fShiftMin = Min ( fRangeSky(iWILMA,iUI,iCenterFrom),             &
                     &            fRangeSky(iWILMA,iUI,iCenterTo)    )           &
                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iWILMA,iUI,iCenterFrom),             &
                     &            fRangeSky(iWILMA,iUI,iCenterTo)    )           &
                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
                !
             Else If (listWILMA(ii)%subBand .Eq. esb%uo) Then
                !
                fShiftMin = Min ( fRangeSky(iWILMA,iUO,iCenterFrom),             &
                     &            fRangeSky(iWILMA,iUO,iCenterTo)    )           &
                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
                !
                fShiftMax = Max ( fRangeSky(iWILMA,iUO,iCenterFrom),             &
                     &            fRangeSky(iWILMA,iUO,iCenterTo)    )           &
                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
                !
             End If
             !
             If (        listWILMA(ii)%fShift.LT.fShiftMin                       &
                  & .Or. listWILMA(ii)%fShift.GT.fShiftMax  )   Then             !
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" invalid fShift "
                End If
                Write (limitCode,'(F8.1," out of range ",F8.1," to ",F8.1)')     &
                     &            listWILMA(ii)%fShift, fShiftMin, fShiftMax     !
                l  = Len_trim(errorCode)
                l2 = Len_trim(limitCode)
                If ( Len(errorCode) .Ge. (l+l2) ) Then
                   errorCode = errorCode(1:l)//limitCode(1:l2)
                End If
             End If
             !
          Else  !!  not EMIR
             !
             If (        listWILMA(ii)%receiverName.Eq.rec%Hera1                 &
                  & .Or. listWILMA(ii)%receiverName.Eq.rec%Hera2) Then
                jj = jj+1
                countParts = countParts+1
                percentUsed = percentUsed+50.0
             Else
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" wrong receiver"
                End If
             End If
             If (.Not. ( Abs(listWILMA(ii)%bandWidth-1024.0) .Lt. 0.001          &
                  &    ) ) Then
                error = .True.
                l = Len_trim(errorCode)
                If (Len(errorCode).Ge.l+30) Then
                   errorCode = errorCode(1:l)//" wrong bandwidth"
                End If
             End If
             !
          End If
          !
       End If
       !
    End Do
    !
    If (countParts.Gt.4 .Or. (.Not.receiverIsEMIR.And.countParts.Gt.2)) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many parts"
       End If
    End If
    !
    If (percentUsed .Gt. 100.) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many channels"
       End If
    End If
    !
    If (.Not. ERROR) Then
       If (Len(errorCode).Ge.2) Then
          errorCode = "OK"
       End If
    End If
    !
    Return
    !
  End Subroutine checkWILMA
!!!
!!!
  Subroutine checkVespaEMIR (listRX, listVESPA,                                  &
       &                 error,  errorCode, percentUsed)                         !
    !
    Type (varReceiver),  Dimension(:), Intent(IN)  ::  listRX                    ! !! list of all Receivers
    Type (varBackend),   Dimension(:), Intent(IN)  ::  listVESPA                 ! !! list of all VESPA parts    
    !
    Logical,                Intent(OUT)            ::  error
    Character(len=*),       Intent(OUT), Optional  ::  errorCode
    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
    !
    Integer :: lBoundRX, uBoundRX
    Integer :: lBoundBE, uBoundBE
    Integer :: ii, jj, l
    !
    Integer :: countParts
    !
    Logical :: receiverIsEMIR, isConnectedRX
    !
    Character(len=lenCh)   ::  otherPolarization     =  GPnone         
    !
    Call pako_message(seve%t,"paKo backend",                                     &
         &     "    --> SR: checkVespaEMIR v 1.2.3  2013-02-27")                 !
    !
    error        = .False.
    percentUsed  = 0.0
    !
    countParts   = 0
    !
    Call queryReceiver("EMIR", receiverIsEMIR)
    !
    If (Len(errorCode).Ge.2) Then
       errorCode = ""
    End If
    !
    lBoundRX = Lbound(listRX,1)
    uBoundRX = Ubound(listRX,1)
    !
    lBoundBE = Lbound(listVESPA,1)
    uBoundBE = Ubound(listVESPA,1)
    !
    jj = 0
    !
    ! FIXME: we have to match from EMIRsubBands
    Do ii = lBoundBE,uBoundBE,1
       !
       If (listVESPA(ii)%isConnected) Then
          jj = jj+1
          countParts = countParts+1
          !          
          !  **  EMIR
          !
          If (receiverIsEMIR) Then
             !
             If    (      listVESPA(ii)%receiverName .Eq. rec%E090) Then
                If (      listVESPA(ii)%subband      .Eq. esb%lsb                &
                   & .Or. listVESPA(ii)%subband      .Eq. esb%usb ) Then         !
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+30) Then
                      errorCode = errorCode(1:l)//                               &
                           &      listVESPA(ii)%subband//" not possible"         !
                   End If
                End If
             End If
             !
             If    (      listVESPA(ii)%mode .Eq. BEmode%pola                    &
                  &  .Or. listVESPA(ii)%mode .Eq. BEmode%para  ) Then            !
                !
                If      (listVESPA(ii)%polarization .Eq. pol%hor) Then
                   otherPolarization = pol%ver
                Else If (listVESPA(ii)%polarization .Eq. pol%ver) Then
                   otherPolarization = pol%hor
                End If
                !
                Call queryReceiver(               listVESPA(ii)%receiverName,    &
                     &             IsConnected  = IsConnectedRX,                 &
                     &             polarization = otherPolarization,             &
                     &             subband      = listVESPA(ii)%subband     )    !
                !
                If (GV%doDebugMessages) Then
                   !
                   Write (6,*)  " "
                   Write (6,*)  "      listVESPA(ii)%mode: ", listVESPA(ii)%mode
                   Write (6,*)  "      POLA"
                   Write (6,*)  "      listVESPA(ii)%fShift       : ", listVESPA(ii)%fShift      
                   Write (6,*)  "      listVESPA(ii)%receiverName : ", listVESPA(ii)%receiverName
                   Write (6,*)  "      listVESPA(ii)%polarization : ", listVESPA(ii)%polarization
                   Write (6,*)  "      listVESPA(ii)%subBand      : ", listVESPA(ii)%subBand
                   Write (6,*)  "      otherPolarization          : ", otherPolarization
                   Write (6,*)  "      IsConnectedRX              : ", IsConnectedRX
                   !
                End If
                !                
             End If
             !
             If    (      listVESPA(ii)%mode .Eq. BEmode%pola  ) Then
                !
                If (.Not. IsConnectedRX) Then
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+30) Then
                      errorCode = errorCode(1:l)                                 &
                           &   // listVESPA(ii)%mode                             &
                           &   // " requires RECEIVER "                          &
                           &   // listVESPA(ii)%receiverName                     &
                           &   // "/"//otherPolarization                         &
                           &   // " "//listVESPA(ii)%subband                     !
                   End If
                End If
                !
             End If
             !
             If    (      listVESPA(ii)%mode .Eq. BEmode%para  ) Then
                !
                If (.Not. IsConnectedRX) Then
                   error = .True.
                   l = Len_trim(errorCode)
                   If (Len(errorCode).Ge.l+30) Then
                      errorCode = errorCode(1:l)                                 &
                           &   // "/"//listVESPA(ii)%mode                        &
                           &   // " requires RECEIVER "                          &
                           &   // listVESPA(ii)%receiverName                     &
                           &   // "/"//otherPolarization                         &
                           &   // " "//listVESPA(ii)%subband                     !
                   End If
                End If
                !
             End If
             !
          End If
          !
       End If
       !
    End Do
    !
    If (countParts .Gt. 12) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many parts"
       End If
    End If
    !
    If (percentUsed .Gt. 100.) Then
       error = .True.
       l = Len_trim(errorCode)
       If (Len(errorCode).Ge.l+30) Then
          errorCode = errorCode(1:l)//" too many channels"
       End If
    End If
    !
    If (.Not. ERROR) Then
       If (Len(errorCode).Ge.2) Then
          errorCode = "OK"
       End If
    End If
    !
    Return
    !
  End Subroutine checkVespaEMIR
!!!
!!!                                                                              ! !! findEsb is a utility for the
!!!                                                                              ! !! following checkVESPA (by GP)
  Subroutine findEsb(backend, sb1, sb2)
    Type (varBackend), Intent(IN) :: backend
    Integer, Intent(OUT)          :: sb1, sb2

    Integer:: i

    sb1 = 0
    sb2 = 0

    Do i = 1, nesbIF
       If (EMIRsubBands(i)%isRequested &
         & .and. (EMIRsubBands(i)%bandName .eq. backend%receiverName) &
         & .and. (EMIRsubBands(i)%subband .eq. backend%subband)) Then
          If (EMIRsubBands(i)%polarization .eq. backend%polarization) Then
             sb1 = i
          Else
             sb2 = i
          End If
       End If
    End Do
  End Subroutine findEsb
!!!
!!!
  Subroutine checkVespa (listRX, listVESPA,                                      &
       &                 error,  errorCode, percentUsed)
    !
    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
         &               listRX         !! list of all Receivers
    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
         &               listVESPA      !! list of all VESPA parts    
    !
    Logical,                Intent(OUT)            ::  error
    Character(len=*),       Intent(OUT), Optional  ::  errorCode
    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
    !
    ! Actually 19 is not used, it was foreseen for 20kHz polarimetry but
    ! implementing it would require pervasive changes through the system.
    Integer, Parameter :: NumModes = 24

    Interface 
       Function CheckSigList(SigList)
         Integer, Dimension(12), Intent(In):: SigList
         Integer:: CheckSigList
       End Function CheckSigList
    End Interface

    ! There can only be 12 different Vespa bands.
    Integer, Parameter :: MaxActive = 12

    ! Step and limits for the synthesizers (after LO4 shift)
    Real(Kind=kindSingle), Parameter:: &
         &    stepSyn = 0.625,              &
         &    minSyn  = 105.0,              &
         &    maxSyn  = 600.0

    ! Low and upper frequency limits in IF2
    Real(Kind=kindSingle), Parameter:: &
         &    minIF = 80.0
    Real(Kind=kindSingle), Parameter:: &
         &    maxIF = 647.0

    Integer, Dimension(NumModes), Parameter :: &
         &   sigBases=(/7,  7,  7, 11, 11, 15, 19, 19, &
         &             23, 23, 23, 29, 29,             &
         &             35, 35, 35, 41, 47, 53,         &
         &              1,  1,  1,  1,  3/)

    Integer, Parameter:: SIG_UNUSED = 59

    Integer, Dimension(NumModes), Parameter :: &
         &   cost=(/1, 1, 1, 1, 1, 1, 2, 2, &
         &          1, 1, 1, 1, 1,          &
         &          1, 1, 1, 1, 2, 4,       &
         &          3, 3, 3, 3, 6/)

    Logical, Dimension(NumModes), Parameter :: &
         &   uumode =(/.False., .False., .False., .False.,                   &
         &                               .False., .False., .False., .True.,  &
         &             .False., .False., .False., .False., .False.,          & 
         &             .True.,  .True.,  .True.,  .False., .False., .False., &
         &             .False., .False., .False., .False., .False./)

    Integer, Dimension(NumModes), Parameter :: &
         &   dropped = (/0, 0, 0, 0, 1, 2, 2, 3,    &
         &               0, 0, 0, 0, 1,             &
         &               1, 1, 1, 1, 1, 1,          &
         &               0, 0, 0, 1, 1/)

    ! Number of channels per band
    Integer, Dimension(NumModes), Parameter :: &
         &   bchans =(/128,  256,  512, 1024, 1024, 2048, 3072, 3072, &
         &             128,  256,  512, 1024, 1024,                   &
         &              32,   64,  128,  256,  512, 1024,             &
         &             128,  256,  512,  512, 1024/)

    ! Number of frequency domain channels in the raw data
    Integer, Dimension(NumModes), Parameter :: &
         &   fchans =(/128,  256,  512, 1024, 1024, 2048, 3072, 3072, &
         &             256,  512, 1024, 2048, 2048,                   &
         &             128,  256,  512, 1024, 2048, 4096,             &
         &            1152, 2304, 4608, 4608, 9216/)

    ! Number of time domain channels 
    Integer, Dimension(NumModes), Parameter :: &
         &   tchans =(/512,  512,  512, 1024, 1024, 2048, 3072, 3072, &
         &            1024, 1024, 1024, 2048, 2048,                   &
         &             512,  512,  512, 1024, 2048, 4096,             &
         &            4608, 4608, 4608, 4608, 9216/)

    ! These are the rounded values for the user interface
    !Real(kind=kindSingle), Dimension(NumModes), Parameter ::        &
    !&   resolutions = (/1250., 320.,  80., 40., 20., 10., 6.6, 3.3, &
    !&                   1250., 320.,  80., 40., 20.,                &
    !&                   2500., 640., 160., 80., 40., 20.,           &
    !&                   1250., 320.,  80., 40., 20./)

    ! These are the rounded values for the user interface
    Real(kind=kindSingle), Dimension(NumModes), Parameter ::             &
         &   minRes = (/1.2, 0.31, 0.07, 0.038, 0.019, 0.009, 0.0065, 0.0032, &
         &              1.2, 0.31, 0.07, 0.038, 0.019,                        &
         &              2.4, 0.62, 0.15, 0.070, 0.038, 0.019,                 &
         &              1.2, 0.31, 0.07, 0.038, 0.019/)

    ! These are the rounded values for the user interface
    Real(kind=kindSingle), Dimension(NumModes), Parameter ::             &
         &   maxRes = (/1.3, 0.33, 0.09, 0.042, 0.021, 0.011, 0.0067, 0.0034, &
         &              1.3, 0.33, 0.09, 0.042, 0.021,                        &
         &              2.6, 0.65, 0.17, 0.090, 0.042, 0.021,                 &
         &              2.4, 0.33, 0.09, 0.042, 0.021/)

    ! and these are exact values of channels per 5MHz for frequency checks.
    Integer, Dimension(NumModes), Parameter ::              &
         &   chansPer5M = (/4, 16, 64, 128, 256, 512, 768, 1536, &
         &                  4, 16, 64, 128, 256,                 &
         &                  2,  8, 32,  64, 128, 256,            &
         &                  4, 16, 64, 128, 256/)

    Integer, Dimension(NumModes), Parameter :: &
         &   bwMin =(/160, 80, 40, 40, 20, 20, 20, 10, &
         &            160, 80, 40, 40, 20,             &
         &             80, 40, 20, 20, 20, 20,         &
         &            160, 80, 40, 20, 20/)

    Integer, Dimension(NumModes), Parameter :: &
         &   bwMax =(/640, 640, 480, 480, 240, 120, 120, 60, &
         &            640, 640, 480, 360, 180,               &
         &            640, 480, 240, 240, 120,  60,          &
         &            640, 320, 160,  80, 40/)

    ! In this table 64 means invalid entry.
    Integer, Dimension(4,4), Parameter:: &
         &   r2code = reshape((/64, 0,  1, 2,   &
         &                       0, 64, 3, 4,   &
         &                       1, 3, 64, 5,   &
         &                       2, 4, 5, 64/), &
         &                    (/4, 4/))

    Integer, Dimension(4), Parameter:: &
         &    ModeStart =(/1,  9, 14, 20/), &
         &    ModeEnd   =(/8, 13, 18, 24/)

    Type:: VespaBand
       Integer               :: Origin
       Integer               :: Ident ! May turn out to be useless
       Integer               :: Mode
       Integer               :: RX1
       Integer               :: input1
       Integer               :: input2
       Real(kind=kindSingle) :: percentage
       Real(kind=kindSingle) :: fShift
       Integer               :: nBands
       Integer               :: kind
       Integer               :: Signature
       Logical               :: Flipping
    End Type VespaBand

    Type(VespaBand), Dimension(MaxActive) :: Bands
    !
    Integer :: lBoundRX, uBoundRX
    Integer :: lBoundBE, uBoundBE
    Integer :: ii, jj, nActive, nr1, nOrig, iMode, bw
    Integer :: totcost, nDP4, iSig, tmpSig
    Integer :: nUsed
    Logical :: valid, Flipping
    Logical :: useEMIR
    Integer, Dimension(MaxActive) :: sigList
    Real(kind=kindSingle) :: res, deltaSyn, xFreq
    Real(kind=kindSingle) :: lowSyn, highSyn, lowFreq, highFreq
    Real(kind=kindSingle) :: lowShift, highShift
    !
    Call pako_message(seve%t,"paKo backend",                                     &
         &     "    --> SR: checkVespa v 1.2.3  2013-03-01 "                     &
         &               //  " like <= v 1.1.14 2012-11-30 ")                    !
    !
    error        = .False.
    errorCode    = "OK"
    percentUsed  = 0.0
    Call queryReceiver("EMIR", useEMIR)
    !
    lBoundRX = Lbound(listRX,1)
    uBoundRX = Ubound(listRX,1)
    !
    !D    Write (6,*) "      lBoundRX ", lBoundRX
    !D    Write (6,*) "      uBoundRX ", uBoundRX
    !
    !
    lBoundBE = Lbound(listVESPA,1)
    uBoundBE = Ubound(listVESPA,1)

    ! FIXME! Problem with initial conditions: if no receiver 
    ! command has been entered, all receivers have name "none" 
    ! and also are disconnected. This plays havoc with the name 
    ! matching done a bit later, so we exit early. There is anyway
    ! no point in trying to configure Vespa under these conditions.
    ! But of course this code should not complain if a BACK/CLEAR
    ! command comes before any receiver definition, so first
    ! check that we are not called for an empty configuration,
    ! which happens to be always valid.

    valid = .False.
    Do ii = lBoundBE, uBoundBE
       valid = valid .Or. listVespa(ii)%isConnected
    End Do
    If (.Not. valid) Return

    valid = .False.
    Do ii = lBoundRX, uBoundRX
       valid = valid .Or. listRX(ii)%isConnected
       !print *, "Receiver ", ii, " has ", listRX(ii)%nPixels, " pixels."
    End Do

    If (.Not. valid) Then
       error = .True.
       errorCode = "No receiver configured"
       Return
    End If

    nActive = 0
    Do ii = lBoundBE, uBoundBE
       If (listVESPA(ii)%isConnected) Then
          If (nActive.Eq.12) Then
             error = .True.
             errorCode = "Vespa can have at most 12 active parts"
             Return
          End If
          If (useEMIR) Then
             !
             If    (      listVESPA(ii)%receiverName .Eq. rec%E090) Then
                If (      listVESPA(ii)%subband      .Eq. esb%lsb                &
                   & .Or. listVESPA(ii)%subband      .Eq. esb%usb ) Then         !
                   error = .True.
                   errorCode = "Subband " // listVESPA(ii)%subband // &
                        & " not possible for Vespa"         !
                   Return
                End If
             End If
          End If
          nActive = nActive+1
          Bands(nActive)%Origin = ii
          Bands(nActive)%Ident = listVespa(ii)%nPart
          Bands(nActive)%percentage = listVespa(ii)%percentage
          Bands(nActive)%fShift = listVespa(ii)%fShift
          ! listVespa(ii)%Mode is often "none", let us default to "simple"
          Bands(nActive)%Mode = iSimp
          Do jj = 1, nDimBEmodeChoices 
             If (listVespa(ii)%mode .Eq. BEmodeChoices(jj)) Then
                Bands(nActive)%Mode = jj 
             End If
          End Do
          Flipping = listVespa(ii)%subband .eq. esb%usb &
               & .or. listVespa(ii)%subband .eq. esb%ui &
               & .or. listVespa(ii)%subband .eq. esb%lo
          Bands(ii)%Flipping = Flipping

          Bands(nActive)%RX1 = lBoundRX-1
          ! FIXME: here we need an IF cable equivalent, even if it is
          ! arbitrary, EMIRsubBands should be the right band to test
          Do jj = lBoundRX, uBoundRX
             If (listVespa(ii)%receiverName .Eq. listRX(jj)%name) Then  
                Bands(nActive)%RX1 = jj
                If (useEMIR) Then
                   call findEsb(listVespa(ii), Bands(nActive)%input1, &
                        &       Bands(nActive)%input2)
                Else
                   Bands(nActive)%input1 = listRX(jj)%disBoxInput
                End If
             End If
          End Do
       End If
    End Do

    totcost = 0
    nDP4 = 0
    Do ii=1,nActive
       ! Receiver verifications
       nr1 = Bands(ii)%RX1
       If (nr1 .Eq. lBoundRx-1) Then
          error = .True.
          errorCode = "No receiver specified"
          Return
       End If
       If (.Not.(listRX(nr1)%isConnected)) Then
          error = .True.
          errorCode = "Attempt to use a disabled receiver"
          Return
       End If
       If (Bands(ii)%input1 .eq. 0) Then
          error = .True.
          errorCode = "Attempt to use an unconnected subband"
          Return
       End If
       If (Bands(ii)%Mode .Ne. iSimp) Then
          If (listRX(nr1)%nPixels .Ne. 1) Then
             error = .True.
             errorCode = "Parallel and polarization modes are only available" &
                  //" with single pixel receivers"
             Return
          End If
          If (Bands(ii)%input2 .eq.0) Then
             error = .True.
             errorCode = "Parallel and polarization modes need two identical" &
                  // "subbands from H and V mixers"
             Return
          End If
       End If

       ! Take receiver setup into account to transform frequency offset
       ! into IF frequency.
       ! Some compilers accept .XOR. for .NEQV., but sadly not all!

       iMode = Bands(ii)%Mode
       If (listRX(nr1)%nPixels .Eq. 9) Then
          iMode= 4 ! We know that it was 1
       Else If (listRX(nr1)%nPixels .Ne. 1) Then
          error = .True.
          errorCode = "Vespa only accepts receivers with 1 or 9 pixels"
          Return
       End If
       nOrig = Bands(ii)%Origin


       jj = ModeStart(iMode)
       res = listVespa(nOrig)%resolution
       Do While((res .Lt. minRes(jj)) .And. (jj.Ne.ModeEnd(iMode)))
          jj = jj+1
       End Do

       If ((res .Lt. minRes(jj)) .Or. (res.Gt. maxRes(jj))) Then
          error = .True.
          errorCode = "Invalid resolution (type it in MHz)"
          Return
       End If

       ! FIXME: it would be better to put the values back in place in
       ! listVespa since after this step the system should only see
       ! canonical values for resolution and bandwidth 
       ! (within round-off errors of course).
       Bands(ii)%kind=jj
       ! Now fill the signature field, by far the most important item 
       ! in the whole Vespa configuration rigamarole
       If (Bands(ii)%Mode .Eq. iSimp) Then
          Bands(ii)%Signature = sigBases(jj) + Bands(ii)%input1-1
       Else
          Bands(ii)%Signature = sigBases(jj) +  &
               r2code(Bands(ii)%input1, Bands(ii)%input2)
       End If

       bw = Nint(listVespa(nOrig)%bandWidth)/bwMin(jj)*bwMin(jj)
       If (Abs(bw-listVespa(nOrig)%bandWidth) .Gt. 0.1) Then
          error = .True.
          Write (errorCode, '(A, I3, A)') &
               "Bandwidth must be a multiple of ", bwmin(jj), "MHz"
       End If
       If (bw .Gt. bwMax(jj)) Then
          error = .True. 
          errorcode = "Requested bandwidth is too large"
          Return
       End If
       Bands(ii)%nBands = bw/bwMin(jj)
       totcost = totcost + Bands(ii)%nBands * cost(jj)
       If (sigBases(jj).Eq.29) Then
          nDP4 = nDP4 + Bands(ii)%nBands
       End If
       !D       print *, "jj res bw signature", jj, res, bw, Bands(ii)%Signature
    End Do

    ! Now evaluate the total cost and exit early if it turns out to be 
    ! impossible. DP4 (20 or 40 kHz resolution in parallel mode) bands 
    ! are special, the first 6 are cheap, although they may constrain
    ! distribution box setup, the last 3 are more expensive.
    If (nDP4 .Gt. 6) Then
       totcost = totcost + nDP4 - 6
    End If

    ! This estimate of percentUsed is correct when only Simple mode
    ! with resolutions between 20kHz and 1.25Mhz are used. As soon
    ! as parallel, polarimetry or ultra-high resolution (3.3, 6.6,
    ! and 10kHz) modes are used, this becomes an approximation. 
    percentUsed = totcost*(100./12.)

    If (totcost .Gt. 12) Then
       error = .True.
       errorCode = "Too many Vespa resources requested"
       Return
    End If

    iSig = 0
    Do ii = 1, nActive
       Do jj = 1, Bands(ii)%nBands
          iSig = iSig + 1
          sigList(iSig) = Bands(ii)%Signature
       End Do
    End Do

    Do ii = iSig+1, MaxActive
       sigList(ii) = SIG_UNUSED
    End Do

    ! Now sort sigList. The array is really small, so use a stupid method. 
    Do ii = 1, iSig-1
       Do jj = ii+1, iSig
          If (sigList(ii) .Gt. sigList(jj)) Then
             tmpSig = sigList(ii)
             sigList(ii) = sigList(jj)
             sigList(jj) = tmpSig
          End If
       End Do
    End Do
    !print *, "sigList", sigList

    ! At this point a configuration is possible if and only if
    ! siglist can be built from a list of 3 signature lists for
    ! a pair of units. 
    jj = CheckSigList(sigList)
    !print *, "CheckSigList result", jj
    If (jj.Ne.0) Then
       error = .True.
       errorCode = "The requested Vespa configuration is impossible"
       Return
    End If

    ! Now try to compute the frequencies of the synthesizers and see if they
    ! are in the allowed range. The arithmetic has to be done very carefully.
    Do ii = 1, nActive

       nr1 = Bands(ii)%RX1

       jj = Bands(ii)%kind
       ! Compute difference between succesive synthesizer frequencies
       ! rounded down do the maximum of synthesizer resolution and
       ! spectral resolution for this part.
       deltaSyn = bwMin(jj)*Bands(ii)%percentage/100
       res = Max(5.0/chansPer5M(jj), stepSyn)
       ! Difference between first and last synthesizer
       deltaSyn = res * Int(deltaSyn/res) * (Bands(ii)%nBands-1)
       ! Now the real resolution
       res = 5.0/chansPer5M(jj)

       ! Compute limits: lowSyn is the lowest possible frequency of
       ! the first synthesizer and highSyn the highest possible frequency
       ! of the last synthesizer. lowFreq and highFreq are the smallest
       ! and largest frequencies of the center of the part in the IF.

       ! There are 3 cases:
       !
       ! 1) dual sideband modes, in which both the L and U bands of
       ! an IRM are used. In these modes the number of dropped channels
       ! is zero. These are the lowest resolution simple and parallel 
       ! modes (80, 320, and 1250 kHz) as well as 40kHz resolution on
       ! single pixel receivers.
       !
       ! 2) upper side band mode:  in which only the U output of an IRM
       ! can be used. These are the 3.3 kHz resolution mode and the
       ! polarimetry modes at 160, 640, and 2500 kHz resolution.
       !
       ! 3) single side band modes, in which we either use the lower of
       ! the upper output of an IRM (but never mix them up). This is the 
       ! case for the 6.6, 10, and 20 kHz resolution modes on single pixel
       ! receiver (for 20kHz this alsmo includes parallel mode), the 20 and
       ! 40kHz resolution modes for multi-beam receivers, and the 40 and 80kHz
       ! resolution polarimetry modes.
       If (dropped(jj).Eq.0) Then
          nUsed = Int(bchans(jj)*Bands(ii)%percentage/100)/2 + 1
          xFreq = deltaSyn/2 + (nUsed-1)*res

          lowSyn = Ceiling(Max(minSyn, minIF+(nUsed-1)*res)/stepSyn)*stepSyn
          lowFreq = lowSyn + deltasyn/2
          highSyn = Floor(Min(maxSyn, maxIF-(nUsed-1)*res)/stepSyn)*stepSyn
          highFreq = highSyn - deltasyn/2
       Else
          nUsed = Int(bchans(jj)*Bands(ii)%percentage/100)

          xFreq =  (res*(nUsed+2*dropped(jj)-1) - deltasyn)/2

          highSyn = Floor(Min(maxSyn, &
               maxIF- (nUsed+dropped(jj)-1)*res)/stepSyn) &
               *stepSyn
          highFreq = highSyn + xFreq
          If (uumode(jj)) Then 
             lowSyn = minSyn
             lowFreq = minSyn + deltaSyn + xFreq
          Else
             lowSyn = Ceiling(Max(minSyn, &
                  minIF+(nUsed+dropped(jj)-1)*res)/stepSyn) &
                  *stepSyn
             lowFreq = lowSyn - xFreq
          End If
       End If
       !D       print *, "deltaSyn, xFreq", deltaSyn, xFreq
       !D       print *, "low and high syn and freq"
       !D       print *, lowSyn, highSyn, lowFreq, highFreq

       ! Convert highFreq and lowFreq to on sky frequency shifts

       xFreq = listRX(nr1)%IF2*1000
       If (Bands(ii)%Flipping) Then
          lowShift  = xFreq - highFreq
          highShift = xFreq - lowFreq
       Else
          lowShift  = lowFreq  - xFreq
          highShift = highFreq - xFreq
       End If

       If (lowShift .Gt. highShift) Then
          error = .True.
          errorCode = "Reduce the bandwidth or use the /PERCENT option"
          Return
       End If

       ! Round to the next 0.1 MHz step either way for the display
       ! in case the requested shift is out of bounds.
       lowShift = Floor(lowShift*10)/10.0
       highShift = Ceiling(highShift*10)/10.0
       !D       print *, "shift limits:", lowShift, highShift

       ! And even tolerate another 50kHz in case the observer believes
       ! in typing the tens of kHz, despite the fact that the synthesizers
       ! have a step of 625 kHz.
       If ((Bands(ii)%fShift .Lt. lowShift-0.05) .Or. &
            &   (Bands(ii)%fshift .Gt. highShift+0.05)) Then
          error = .True.
          Write (errorCode, '(A, 2F7.1)') "Frequency shift outside limits:", &
               lowShift, highShift
          Return
       End If
    End Do

    jj = 0
    Do ii = lBoundRX,uBoundRX,1
       If (listRX(ii)%isConnected) Then
          !D          Write (6,*) " ii ", ii
          l1 = Len_trim(listRX(ii)%name)
          !D          Write (6,*)                                                                 & 
          !D               &          listRX(ii)%name(1:l1)," ",                                  &
          !D               &          listRX(ii)%lineName(1:Len_trim(listRX(ii)%lineName))," ",   &
          !D               &          listRX(ii)%frequency%value,                                 &
          !D               &          listRX(ii)%offset%value,                                    &
          !D               &          listRX(ii)%sideBand(1:Len_trim(listRX(ii)%sideBand))," ",   &
          !D               &          listRX(ii)%frequency%doppler (1:Len_trim(listRX(ii)%frequency%doppler)), " ",   &
          !D               &          listRX(ii)%width(1:Len_trim(listRX(ii)%width))," ",         &
          !D               &          listRX(ii)%gainImage%value,                                 &
          !D               &          listRX(ii)%tempCold,                                        & 
          !D               &          listRX(ii)%tempAmbient,                                     &
          !D               &          listRX(ii)%effForward,                                      &
          !D               &          listRX(ii)%effBeam,                                         &
          !D               &          listRX(ii)%scale(1:Len_trim(listRX(ii)%scale))," ",         &
          !D               &          listRX(ii)%iPixel,                                          &
          !D               &          listRX(ii)%nPixels,                                         &
          !D               &          listRX(ii)%centerIf,                                        &
          !D               &          listRX(ii)%bandWidth,                                       &
          !D               &          listRX(ii)%disBoxInput,                                     &
          !D               &          listRX(ii)%IF2,                                             &
          !D               &          listRX(ii)%isFlippingIF2,                                   &
          !D               &          listRX(ii)%polarization(1:len_trim(listRX(ii)%polarization))," ",  &
          !D               &          listRX(ii)%useSpecialLO
       End If
    End Do
    !
    !D  jj = 0
    !D  Do ii = lBoundBE,uBoundBE,1
    !D     If (listVESPA(ii)%isConnected) Then
    !D          Write (6,*) " ii ", ii
    !D        jj = jj+1
    !D        l1 = Len_trim(listVESPA(ii)%name)
    !D        l2 = Len_trim(listVESPA(ii)%receiverName)
    !D          Write (6,*)                                                 &
    !D               &          listVESPA(ii)%name(1:l1)," ",               &
    !D               &          listVESPA(ii)%nPart,                        &
    !D               &          listVESPA(ii)%resolution,                   &
    !D               &          listVESPA(ii)%bandwidth,                    &
    !D               &          listVESPA(ii)%fShift,                       &
    !D               &     " ", listVESPA(ii)%receiverName(1:l2)," ",       &
    !D               &          listVESPA(ii)%receiverName2," ",            &
    !D               &          listVESPA(ii)%mode," ",                     &
    !D               &          listVESPA(ii)%percentage,                   &
    !D               &          " "
    !D     End If
    !D  End Do
    !
    Return
    !
  End Subroutine checkVespa
!!!
!!!
End Module modulePakoBackend
!!!
!!!  ************************
!!!  ************************
!!!  *****  END OF CODE *****
!!!  ************************
!!!  ************************
!!!                                                                              ! !! REVIEWED TO HERE 2013-02-27



!!OLDWrite (6,*) "   ii, listFB1MHz(ii)%receiverName, listFB1MHz(ii)%bandWidth, listFB1MHz(ii)%fShift ",  &
!!OLD     &          ii, listFB1MHz(ii)%receiverName, listFB1MHz(ii)%bandWidth, listFB1MHz(ii)%fShift     !
!!OLD!

!!OLD                            errorCode = "123456789A123456789B123456789C123456789D" &
!!OLD                                 &    //"123456789E123456789F123456789G123456789H" &
!!OLD                                 &    //"123456789I123456789J123456789K123456789L" &
!!OLD                                 &    //"123456789M123456789N123456789O123456789P" !

!!OLD
!!OLD       Write (6,*) "          Len(errorCode):    ", Len(errorCode)
!!OLD       Write (6,*) "       Len_trim(errorCode):  ", Len_trim(errorCode)
!!OLD       Write (6,*) "       length:               ", length
!!OLD       Write (6,*) "       Len(messageText):     ", Len(messageText)
!!OLD
!!OLD       length = Min (length,70)
!!OLD       Write (6,*) "      Len_trim(messageText):   ", Len_trim(messageText)
!!OLD

                      !D                       Write (6,*) " kk: ", kk, listFTS(kk)%receiverName,         &
                      !D                            &       listFTS(kk)%polarization, listFTS(kk)%subband !
                      !D                       Write (6,*) " kk: ", kk, listFTS(kk)%receiverName,         &
                      !D                            &       listFTS(kk)%polarization, listFTS(kk)%subband !
                      !
             !
!!OLD                   If (jj.eq.iVESPA) Then
!!OLD                      Write   (messageText,                                         &
!!OLD                           &    '(A10,I3,F10.3,F10.1,F10.3,                         &
!!OLD                           &    3(" ",A5)," /mode ",A12," /perc ",F10.1," /line ",A)'     &
!!OLD                           &  )                                                     & 
!!OLD                           &        listBe(jj,ii)%name,                             &
!!OLD                           &        listBe(jj,ii)%nPart,                            &
!!OLD                           &        listBe(jj,ii)%resolution,                       &
!!OLD                           &        listBe(jj,ii)%bandwidth,                        &
!!OLD                           &        listBe(jj,ii)%fShift,                           &
!!OLD                           &        listBe(jj,ii)%receiverName,                     &
!!OLD                           &        listBe(jj,ii)%polarization,                     &
!!OLD                           &        listBe(jj,ii)%subband,                          &
!!OLD                           &        listBe(jj,ii)%mode,                             &
!!OLD                           &        listBe(jj,ii)%percentage,                       &
!!OLD                           &        listBe(jj,ii)%lineName                          !
!!OLD                   Else 
!!OLD
!!OLD                      Write   (messageText,                                         &
!!OLD                           &    '(A10,I3,F10.3,F10.1,F10.3,                         &
!!OLD                           &    3(" ",A5)," /perc ",F10.1," /line ",A)'             &
!!OLD                           &  )                                                     & 
!!OLD                           &        listBe(jj,ii)%name,                             &
!!OLD                           &        listBe(jj,ii)%nPart,                            &
!!OLD                           &        listBe(jj,ii)%resolution,                       &
!!OLD                           &        listBe(jj,ii)%bandwidth,                        &
!!OLD                           &        listBe(jj,ii)%fShift,                           &
!!OLD                           &        listBe(jj,ii)%receiverName,                     &
!!OLD                           &        listBe(jj,ii)%polarization,                     &
!!OLD                           &        listBe(jj,ii)%subband,                          &
!!OLD                           &        listBe(jj,ii)%percentage,                       &
!!OLD                           &        listBe(jj,ii)%lineName                          !
!!OLD                !D                   Write (6,*) "      messageText: -->", messageText, "<--"
!!OLD
!!OLD             Else If (listBe(jj,ii)%wasConnected) Then
!!OLD                !!   countBE = countBE+1 
!!OLD                Write   (messageText,                                         &
!!OLD                     &    '(A10,I3,F10.3,F10.1,F10.3,                         &
!!OLD                     &  A,3(" ",A5)," ",A12,F10.1," ",A)'                     &
!!OLD                     &  )                                                     & 
!!OLD                     &        listBe(jj,ii)%name,                             &
!!OLD                     &        listBe(jj,ii)%nPart,                            &
!!OLD                     &        listBe(jj,ii)%resolution,                       &
!!OLD                     &        listBe(jj,ii)%bandwidth,                        &
!!OLD                     &        listBe(jj,ii)%fShift,                           &
!!OLD                     &        " DISCONNECTED FROM ",                          &
!!OLD                     &        listBe(jj,ii)%receiverName,                     &
!!OLD                     &        listBe(jj,ii)%polarization,                     &
!!OLD                     &        listBe(jj,ii)%subband,                          &
!!OLD                     &        listBe(jj,ii)%mode,                             &
!!OLD                     &        listBe(jj,ii)%percentage,                       &
!!OLD                     &        listBe(jj,ii)%lineName                          !
!!OLD                Call pakoMessage(priorityI+1,severityI,command,messageText)
!!OLD             End If
!!OLD             Else
!!OLD                If (listBe(jj,ii)%isConnected) Then
!!OLD                   countBE = countBE+1 
!!OLD                   Write (messageText, '(A10,I,3F10.3,3(" ",A10),F10.1)' )          & 
!!OLD                        &        listBe(jj,ii)%name,                                &
!!OLD                        &        listBe(jj,ii)%nPart,                               &
!!OLD                        &        listBe(jj,ii)%resolution,                          &
!!OLD                        &        listBe(jj,ii)%bandwidth,                           &
!!OLD                        &        listBe(jj,ii)%fShift,                              &
!!OLD                        &        listBe(jj,ii)%receiverName,                        &
!!OLD                        &        listBe(jj,ii)%receiverName2,                       &
!!OLD                        &        listBe(jj,ii)%mode,                                &
!!OLD                        &        listBe(jj,ii)%percentage
!!OLD                   Call pakoMessage(priorityI,severityI,command,messageText)
!!OLD                Else If (listBe(jj,ii)%wasConnected) Then
!!OLD                   !!   countBE = countBE+1 
!!OLD                   Write (messageText, '(A10,I,3F10.3,4A10,F10.1)' )                & 
!!OLD                        &        listBe(jj,ii)%name,                                &
!!OLD                        &        listBe(jj,ii)%nPart,                               &
!!OLD                        &        listBe(jj,ii)%resolution,                          &
!!OLD                        &        listBe(jj,ii)%bandwidth,                           &
!!OLD                        &        listBe(jj,ii)%fShift,                              &
!!OLD                        &        " DISCONNECTED FROM ",                             &
!!OLD                        &        listBe(jj,ii)%receiverName,                        &
!!OLD                        &        listBe(jj,ii)%receiverName2,                       &
!!OLD                        &        listBe(jj,ii)%mode,                                &
!!OLD                        &        listBe(jj,ii)%percentage
!!OLD                   Call pakoMessage(priorityI,severityI,command,messageText)
!!OLD                End If
!!OLD             End If
             !




!!$!!!
!!$  Subroutine checkFB100kHz (listRX, listFB100kHz,                                &   !!   OBSOLETE
!!$       &                 error,  errorCode, percentUsed)
!!$    !
!!$    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
!!$         &               listRX            !! list of all Receivers
!!$    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
!!$         &               listFB100kHz      !! list of all FB100kHz parts    
!!$    !
!!$    Logical,                Intent(OUT)            ::  error
!!$    Character(len=*),       Intent(OUT), Optional  ::  errorCode
!!$    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
!!$    !
!!$    Integer :: lBoundRX, uBoundRX
!!$    Integer :: lBoundBE, uBoundBE
!!$    Integer :: ii, jj, ll, l
!!$    !
!!$    Integer :: countParts
!!$    !
!!$    ! * limits on fShift:
!!$    Real(Kind=kindSingle),  Parameter  ::  fMinN128 = -250.0  ! receiver Narrow
!!$    Real(Kind=kindSingle),  Parameter  ::  fMaxN128 =  250.0  ! 12.6 band
!!$    Real(Kind=kindSingle),  Parameter  ::  fMinN253 = -245.0  ! 25.3 band
!!$    Real(Kind=kindSingle),  Parameter  ::  fMaxN253 =  245.0  ! 25.3 band
!!$    Real(Kind=kindSingle),  Parameter  ::  fMinW128 = -506.0  ! receiver Wide
!!$    Real(Kind=kindSingle),  Parameter  ::  fMaxW128 =   -6.0  ! 12.6 band
!!$    Real(Kind=kindSingle),  Parameter  ::  fMinW253 = -501.0  ! 25.3 band
!!$    Real(Kind=kindSingle),  Parameter  ::  fMaxW253 =  -11.0  ! 25.3 band
!!$    Real(Kind=kindSingle)              ::  fMin, fMax
!!$    !
!!$    Character(len=20)  ::  limitCode
!!$    !
!!$    !D    Write (6,*) "   --> check100kHz "
!!$    !
!!$    error        = .False.
!!$    percentUsed  = 0.0
!!$    !
!!$    countParts   = 0
!!$    !
!!$    If (Len(errorCode).Ge.2) Then
!!$       errorCode = ""
!!$    End If
!!$    !
!!$    lBoundRX = Lbound(listRX,1)
!!$    uBoundRX = Ubound(listRX,1)
!!$    !
!!$    lBoundBE = Lbound(listFB100kHz,1)
!!$    uBoundBE = Ubound(listFB100kHz,1)
!!$    !
!!$!!OLD    jj = 0
!!$!!OLD    Do ii = lBoundRX,uBoundRX,1
!!$!!OLD       If (listRX(ii)%isConnected) Then
!!$!!OLD          !
!!$!!OLD       End If
!!$!!OLD    End Do
!!$    !
!!$    jj = 0
!!$    Do ii = lBoundBE,uBoundBE,1
!!$       If (listFB100kHz(ii)%isConnected) Then
!!$          error = .True.
!!$          l = Len_trim(errorCode)
!!$          If (Len(errorCode).Ge.l+40) Then
!!$             errorCode = errorCode(1:l)//" 100 kHz Filterbank decommissioned 2007-09-12"
!!$          End If
!!$          !
!!$          jj = jj+1
!!$          countParts = countParts+1
!!$          If      (Abs(listFB100kHz(ii)%bandWidth-25.6) .Lt. 0.001) Then
!!$             percentUsed = percentUsed +100.0
!!$          Else If (Abs(listFB100kHz(ii)%bandWidth-25.3) .Lt. 0.001) Then
!!$             percentUsed = percentUsed +100.0
!!$          Else If (Abs(listFB100kHz(ii)%bandWidth-12.8) .Lt. 0.001) Then
!!$             percentUsed = percentUsed  +50.0
!!$          Else
!!$             error = .True.
!!$             l = Len_trim(errorCode)
!!$             If (Len(errorCode).Ge.l+30) Then
!!$                errorCode = errorCode(1:l)//" wrong bandwidth"
!!$             End If
!!$          End If
!!$          !
!!$          If (.Not. error) Then
!!$             Do ll = lBoundRX, uBoundRX, 1
!!$                If (listRX(ll)%isConnected .And.                                 &
!!$                     & listFB100kHz(ii)%receiverName.Eq.listRX(ll)%name) Then
!!$                   !
!!$                   If (listRX(ll)%width.Eq.width%narrow) Then
!!$                      If (      listFB100kHz(ii)%bandWidth.Lt.13.0 ) Then
!!$                         fMin = fMinN128
!!$                         fMax = fMaxN128
!!$                      Else
!!$                         fMin = fMinN253
!!$                         fMax = fMaxN253
!!$                      End If
!!$                   End If
!!$                   !
!!$                   If (listRX(ll)%width.Eq.width%wide) Then
!!$                      error = .True.
!!$                      l = Len_trim(errorCode)
!!$                      If (Len(errorCode).Ge.l+40) Then
!!$                         errorCode = errorCode(1:l)//" doesn't work with RECEIVER /WIDTH wide."
!!$                      End If
!!$                      If (      listFB100kHz(ii)%bandWidth.Lt.13.0 ) Then
!!$                         fMin = fMinW128
!!$                         fMax = fMaxW128
!!$                      Else
!!$                         fMin = fMinW253
!!$                         fMax = fMaxW253
!!$                      End If
!!$                   End If
!!$                   !
!!$                   If (   listFB100kHz(ii)%fShift.Lt.fMin .Or.                   &
!!$                        & listFB100kHz(ii)%fShift.Gt.fMax) Then
!!$                      error = .True.
!!$                      Write (limitCode,'(2F6.1)') fMin, fMax
!!$                      l = Len_trim(errorCode)
!!$                      If (Len(errorCode).Ge.l+55) Then
!!$                         errorCode = errorCode(1:l)//                            &
!!$                              &   " Frequency shift outside limits."//           &
!!$                              &   limitCode
!!$                      End If
!!$                   End If
!!$                   !
!!$                End If
!!$             End Do      !!  receivers
!!$          End If      !! not error
!!$       End If      !!  backend conected
!!$    End Do      !!  backends
!!$    !
!!$    If (countParts .Gt. 2) Then
!!$       error = .True.
!!$       l = Len_trim(errorCode)
!!$       If (Len(errorCode).Ge.l+30) Then
!!$          errorCode = errorCode(1:l)//" too many parts"
!!$       End If
!!$    End If
!!$    !
!!$    If (percentUsed .Gt. 100.) Then
!!$       error = .True.
!!$       l = Len_trim(errorCode)
!!$       If (Len(errorCode).Ge.l+30) Then
!!$          errorCode = errorCode(1:l)//" too many channels"
!!$       End If
!!$    End If
!!$    !
!!$    If (.Not. ERROR) Then
!!$       If (Len(errorCode).Ge.2) Then
!!$          errorCode = "OK"
!!$       End If
!!$    End If
!!$    !
!!$    Return
!!$    !
!!$  End Subroutine checkFB100kHz
!!$!!!
!!$!!!
!!$  Subroutine checkFB1Mhz (listRX, listFB1MHz,                                    &   !!   OBSOLETE
!!$       &                 error,  errorCode, percentUsed)
!!$    !
!!$    Type (varReceiver),        Dimension(:), Intent(IN)  ::                      &
!!$         &               listRX          !! list of all Receivers
!!$    Type (varBackend),         Dimension(:), Intent(IN)  ::                      &
!!$         &               listFB1MHz      !! list of all FB1MHz parts    
!!$    !
!!$    Logical,                Intent(OUT)            ::  error
!!$    Character(len=*),       Intent(OUT), Optional  ::  errorCode
!!$    Real(Kind=kindSingle),  Intent(OUT), Optional  ::  percentUsed
!!$    !
!!$    Integer :: lBoundRX, uBoundRX
!!$    Integer :: lBoundBE, uBoundBE
!!$    Integer :: ii, jj, iSB, l
!!$    !
!!$    Integer :: countParts
!!$    !
!!$    Logical :: receiverIsEMIR
!!$    !
!!$    Real    :: fShiftMin, fShiftMax
!!$    Character(len=lenVar)  :: limitCode
!!$    !
!!$    !D    Write (6,*) "   --> checkFB1Mhz "
!!$    !
!!$    error        = .False.
!!$    percentUsed  = 0.0
!!$    !
!!$    countParts   = 0
!!$    !
!!$    Call queryReceiver("EMIR", receiverIsEMIR)
!!$    !
!!$    If (Len(errorCode).Ge.2) Then
!!$       errorCode = ""
!!$    End If
!!$    !
!!$    lBoundRX = Lbound(listRX,1)
!!$    uBoundRX = Ubound(listRX,1)
!!$    !
!!$    lBoundBE = Lbound(listFB1MHz,1)
!!$    uBoundBE = Ubound(listFB1MHz,1)
!!$    !
!!$    jj = 0
!!$    Do ii = lBoundBE,uBoundBE,1
!!$       !
!!$       If (listFB1MHz(ii)%isConnected) Then
!!$          jj = jj+1
!!$          countParts = countParts+1
!!$          percentUsed = percentUsed+100.0*listFB1MHz(ii)%bandwidth/1024.0
!!$          If (.Not. ( Abs(listFB1MHz(ii)%bandWidth-256.0)  .Lt. 0.001            &
!!$               & .Or. Abs(listFB1MHz(ii)%bandWidth-512.0)  .Lt. 0.001            &
!!$               & .Or. Abs(listFB1MHz(ii)%bandWidth-768.0)  .Lt. 0.001            &
!!$               & .Or. Abs(listFB1MHz(ii)%bandWidth-1024.0) .Lt. 0.001            &
!!$               &    ) ) Then
!!$             error = .True.
!!$             l = Len_trim(errorCode)
!!$             If (Len(errorCode).Ge.l+30) Then
!!$                errorCode = errorCode(1:l)//" wrong bandwidth"
!!$             End If
!!$          End If
!!$          !
!!$          !  **  not possible on HERA !
!!$          !
!!$          If      (      listFB1MHz(ii)%receiverName .Eq. rec%HERA               &
!!$               & .Or.    listFB1MHz(ii)%receiverName .Eq. rec%HERA1              &
!!$               & .Or.    listFB1MHz(ii)%receiverName .Eq. rec%HERA2              &
!!$               &  )  Then
!!$             error = .True.
!!$             l = Len_trim(errorCode)
!!$             If (Len(errorCode).Ge.l+30) Then
!!$                errorCode = errorCode(1:l)                //                     &
!!$                     &      " not possible on "           //                     &
!!$                     &      listFB1MHz(ii)%receiverName                          !
!!$             End If
!!$          End If
!!$          !          
!!$          !  **  EMIR
!!$          !
!!$          If (receiverIsEMIR) Then
!!$             !
!!$             If    (      listFB1MHz(ii)%receiverName .Eq. rec%E090) Then
!!$                If (      listFB1MHz(ii)%subband      .Eq. esb%lsb               &
!!$                   & .Or. listFB1MHz(ii)%subband      .Eq. esb%usb ) Then        !
!!$                   error = .True.
!!$                   l = Len_trim(errorCode)
!!$                   If (Len(errorCode).Ge.l+30) Then
!!$                      errorCode = errorCode(1:l)//                               &
!!$                           &      listFB1MHz(ii)%subband//" not possible"        !
!!$                   End If
!!$                End If
!!$             End If
!!$             !
!!$             !! **   EMIR: fShift depending on EMIR sub band
!!$             !! check that shifted band fits in range
!!$             !! this is essential for 1MHz with bandwidth /channels 512 and 768
!!$             !
!!$             If      (listFB1MHz(ii)%subBand .Eq. esb%lo) Then
!!$                iSB = iLO
!!$             Else If (listFB1MHz(ii)%subBand .Eq. esb%li) Then
!!$                iSB = iLI
!!$             Else If (listFB1MHz(ii)%subBand .Eq. esb%ui) Then
!!$                iSB = iUI
!!$             Else If (listFB1MHz(ii)%subBand .Eq. esb%uo) Then
!!$                iSB = iUO
!!$             End If
!!$             !
!!$             fShiftMin = Min ( fRangeSky(iFB1MHz,iSB,iBandFrom),                 &
!!$                  &            fRangeSky(iFB1MHz,iSB,iBandTo)    )               &
!!$                  &    + 0.5 * listFB1MHz(ii)%bandWidth                          &
!!$                  &       -    fRangeSky(iVESPA,iSB,iCenter)                     !
!!$             !
!!$             fShiftMax = Max ( fRangeSky(iFB1MHz,iSB,iBandFrom),                 &
!!$                  &            fRangeSky(iFB1MHz,iSB,iBandTo)    )               &
!!$                  &    - 0.5 * listFB1MHz(ii)%bandWidth                          &
!!$                  &       -    fRangeSky(iVESPA,iSB,iCenter)                     !
!!$             !
!!$             !D              Write (6,*) "   iSB, fRangeSky(iFB1MHz,iSB,iBandFrom)   ",         &
!!$             !D                   &          iSB, fRangeSky(iFB1MHz,iSB,iBandFrom)              !
!!$             !D              Write (6,*) "   iSB, fRangeSky(iFB1MHz,iSB,iBandTo)     ",         &
!!$             !D                   &          iSB, fRangeSky(iFB1MHz,iSB,iBandTo)                !
!!$             !D 
!!$             !D              Write (6,*) "   fShiftMin:   ", fShiftMin
!!$             !D              Write (6,*) "   fShiftMax:   ", fShiftMax
!!$             !
!!$             If (        listFB1MHz(ii)%fShift.LT.fShiftMin                      &
!!$                  & .Or. listFB1MHz(ii)%fShift.GT.fShiftMax  )   Then            !
!!$                error = .True.
!!$                l = Len_trim(errorCode)
!!$                If (Len(errorCode).Ge.l+30) Then
!!$                   errorCode = errorCode(1:l)//" invalid fShift "
!!$                End If
!!$                Write (limitCode,'(F8.1," out of range ",F8.1," to ",F8.1)')     &
!!$                     &            listFB1MHz(ii)%fShift, fShiftMin, fShiftMax    !
!!$                l  = Len_trim(errorCode)
!!$                l2 = Len_trim(limitCode)
!!$                If ( Len(errorCode) .Ge. (l+l2) ) Then
!!$                   errorCode = errorCode(1:l)//limitCode(1:l2)
!!$                End If
!!$             End If
!!$             !
!!$             !! **   EMIR: fShift depending on EMIR sub band
!!$             !! TBD: abtract the following checks on fShift into a Subroutine
!!$             !!      compare checkContinuum, checkWILMA, checkFB4MHz, checkFB1MHz
!!$             !
!!$             !D             Write (6,*) "   listFB1MHz(ii)%fShift:  ", listFB1MHz(ii)%fShift
!!$             !D             Write (6,*) "   listFB1MHz(ii)%subBand: ", listFB1MHz(ii)%subBand
!!$             !
!!$             If (listFB1MHz(ii)%subBand .Eq. esb%lo) Then
!!$                !
!!$                fShiftMin = Min ( fRangeSky(iFB1MHz,iLO,iCenterFrom),            &
!!$                     &            fRangeSky(iFB1MHz,iLO,iCenterTo)    )          &
!!$                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
!!$                !
!!$                fShiftMax = Max ( fRangeSky(iFB1MHz,iLO,iCenterFrom),            &
!!$                     &            fRangeSky(iFB1MHz,iLO,iCenterTo)    )          &
!!$                     &       -    fRangeSky(iVESPA,iLO,iCenter)                  !
!!$                !
!!$             Else If (listFB1MHz(ii)%subBand .Eq. esb%li) Then
!!$                !
!!$                fShiftMin = Min ( fRangeSky(iFB1MHz,iLI,iCenterFrom),            &
!!$                     &            fRangeSky(iFB1MHz,iLI,iCenterTo)    )          &
!!$                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
!!$                !
!!$                fShiftMax = Max ( fRangeSky(iFB1MHz,iLI,iCenterFrom),            &
!!$                     &            fRangeSky(iFB1MHz,iLI,iCenterTo)    )          &
!!$                     &       -    fRangeSky(iVESPA,iLI,iCenter)                  !
!!$                !
!!$             Else If (listFB1MHz(ii)%subBand .Eq. esb%ui) Then
!!$                !
!!$                fShiftMin = Min ( fRangeSky(iFB1MHz,iUI,iCenterFrom),            &
!!$                     &            fRangeSky(iFB1MHz,iUI,iCenterTo)    )          &
!!$                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
!!$                !
!!$                fShiftMax = Max ( fRangeSky(iFB1MHz,iUI,iCenterFrom),            &
!!$                     &            fRangeSky(iFB1MHz,iUI,iCenterTo)    )          &
!!$                     &       -    fRangeSky(iVESPA,iUI,iCenter)                  !
!!$                !
!!$             Else If (listFB1MHz(ii)%subBand .Eq. esb%uo) Then
!!$                !
!!$                fShiftMin = Min ( fRangeSky(iFB1MHz,iUO,iCenterFrom),            &
!!$                     &            fRangeSky(iFB1MHz,iUO,iCenterTo)    )          &
!!$                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
!!$                !
!!$                fShiftMax = Max ( fRangeSky(iFB1MHz,iUO,iCenterFrom),            &
!!$                     &            fRangeSky(iFB1MHz,iUO,iCenterTo)    )          &
!!$                     &       -    fRangeSky(iVESPA,iUO,iCenter)                  !
!!$                !
!!$             End If
!!$             !
!!$             !D             Write (6,*) "   fShiftMin:   ", fShiftMin
!!$             !D             Write (6,*) "   fShiftMax:   ", fShiftMax
!!$             !
!!$             If (        listFB1MHz(ii)%fShift.LT.fShiftMin                      &
!!$                  & .Or. listFB1MHz(ii)%fShift.GT.fShiftMax  )   Then            !
!!$                error = .True.
!!$                l = Len_trim(errorCode)
!!$                If (Len(errorCode).Ge.l+30) Then
!!$                   errorCode = errorCode(1:l)//" invalid fShift "
!!$                End If
!!$                Write (limitCode,'(F8.1," out of range ",F8.1," to ",F8.1)')     &
!!$                     &            listFB1MHz(ii)%fShift, fShiftMin, fShiftMax    !
!!$                l  = Len_trim(errorCode)
!!$                l2 = Len_trim(limitCode)
!!$                If ( Len(errorCode) .Ge. (l+l2) ) Then
!!$                   errorCode = errorCode(1:l)//limitCode(1:l2)
!!$                End If
!!$             End If
!!$             !
!!$             !!
!!$          End If
!!$          !
!!$       End If
!!$       !
!!$    End Do
!!$    !
!!$!!OLD             If (Abs(listFB1MHz(ii)%bandWidth-768.0) .Lt. 0.001) Then
!!$!!OLD                If (Abs(listFB1MHz(ii)%fShift+128.0) .Gt. 0.001) Then
!!$!!OLD                   error = .True.
!!$!!OLD                   l = Len_trim(errorCode)
!!$!!OLD                   If (Len(errorCode).Ge.l+30) Then
!!$!!OLD                      errorCode = errorCode(1:l)//" fShift must be -128.0 "
!!$!!OLD                   End If
!!$!!OLD                End If
!!$!!OLD             End If
!!$!!OLD             !
!!$!!OLD             If (Abs(listFB1MHz(ii)%bandWidth-1024.0) .Lt. 0.001) Then
!!$!!OLD                If (Abs(listFB1MHz(ii)%fShift +256.0) .Gt. 0.001) Then
!!$!!OLD                   error = .True.
!!$!!OLD                   l = Len_trim(errorCode)
!!$!!OLD                   If (Len(errorCode).Ge.l+30) Then
!!$!!OLD                      errorCode = errorCode(1:l)//" fShift must be -256.0 "
!!$!!OLD                   End If
!!$!!OLD                End If
!!$!!OLD             End If
!!$             !
!!$             !
!!$    If (countParts .Gt. 4) Then
!!$       error = .True.
!!$       l = Len_trim(errorCode)
!!$       If (Len(errorCode).Ge.l+30) Then
!!$          errorCode = errorCode(1:l)//" too many parts"
!!$       End If
!!$    End If
!!$    !
!!$    If (percentUsed .Gt. 100.) Then
!!$       error = .True.
!!$       l = Len_trim(errorCode)
!!$       If (Len(errorCode).Ge.l+30) Then
!!$          errorCode = errorCode(1:l)//" too many channels"
!!$       End If
!!$    End If
!!$    !
!!$    If (.Not. ERROR) Then
!!$       If (Len(errorCode).Ge.2) Then
!!$          errorCode = "OK"
!!$       End If
!!$    End If
!!$    !
!!$    Return
!!$    !
!!$  End Subroutine checkFB1Mhz

      SUBROUTINE INIT_ORBIT()
C-------------------------------------------------------------------
C ORBIT initialization routine:
C 	SIC is loaded with the ORBIT language,
C	plot library is initialized, and SIC variables are defined.
C-------------------------------------------------------------------
      USE GILDAS_DEF
      USE GKERNEL_INTERFACES
*
*	ORBIT vocabulary
*
      INTEGER MCOM
      PARAMETER (MCOM=33)
      CHARACTER*12 VOCAB(MCOM)
      CHARACTER*20 VERSION
*
      logical error
!
      EXTERNAL RUN_ORBIT
*
      INCLUDE 'constant.inc'
      INCLUDE 'elements.inc'
      INCLUDE  'control.inc'
*

      DATA VOCAB / 
     +     ' ADJUST','/ALL','/VISUAL','/SB1','/SB2',
     +     ' CURSOR',
     +     ' FIT', 
     +     ' FIX', '/ALL',
     +     ' GLIESE',
     +     ' IGNORE',
     +     ' LIST', '/OUTPUT', '/MONTECARLO',
     +     '/SELECT',
     +     ' OPTIMISE', '/TIME', '/SB1', '/SB2', '/XY', 
     +     '/OUTPUT',  '/STORE',
     +     ' PERIODOGRAM',
     +     ' READ' , '/APPEND', '/OLD_FORMAT',
     +     ' SAVE',
     +     ' USE',
     +     ' VISU', '/ORBIT' , '/VELOCITY' , '/VISUAL',
     +              '/CORRELATION'
     +     /
* Code
      ERROR = GTERRTST()
*
      VERSION = '2.0 15-JUL-2007'
*
      CALL SIC_BEGIN('ORBIT','gag_help_orbit',MCOM,VOCAB,
     &VERSION//'  T.F..',run_orbit,gterrtst)
      CALL GTERFLAG(.TRUE.)
*
* Initialize some internal commons
      ERROR = .FALSE.
      CALL SETUP_ELEMENTS(ERROR)
      IF (ERROR) STOP 'E-ORBIT,  Error initializing elements'
*
* Define SIC user variables
      METHOD = 'DIAGONALISE'
      CALL SIC_DEF_CHAR('METHOD',METHOD,.FALSE.,ERROR)
      PROFILE_METHOD = 'RAW'
      CALL SIC_DEF_CHAR('PROFILE_METHOD',PROFILE_METHOD,.FALSE.,ERROR)
      CALL SIC_DEF_INTE('D_UT',D_UT,1,1,.FALSE.,ERROR)
!
      END

!-----------------------------------------------------------------------
! Basic GDF_READ / WRIT routines
! ---
! OBSOLESCENT: DO NOT USE FOR ANY NEW CODE!
!-----------------------------------------------------------------------
subroutine gdf_read(x,islo,error)
  use gio_interfaces, only : gio_read_header 
  use gildas_def
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !  Can not use 'gdf_read_header' since it allocates an image slot
  ! while the caller to the present routine have done this by itself
  ! (and from time to time X image is mixed with a Y slot...)
  ! Use GIO_READ_HEADER to do this now...
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x      !
  integer,      intent(in)    :: islo   !
  logical,      intent(inout) :: error  !
  !
  call gio_read_header(x,islo,error)
end subroutine gdf_read
!
subroutine gdf_writ(x,islo,error)
  use gio_interfaces, only : gio_write_header
  use gildas_def
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x      !
  integer,      intent(in)    :: islo   !
  logical,      intent(inout) :: error  !
  !
  call gio_write_header(x,islo,error)
end subroutine gdf_writ
!
subroutine gdf_ch(input,output)
  use gio_interfaces, only : gio_init_gildas, gdf_copy_gil
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  ! Copy Header IN into OUT
  !---------------------------------------------------------------------
  type(gildas), target, intent(inout) :: input 
  type(gildas), target, intent(inout) :: output 
  !
  logical :: error
  ! Check %ref Pointers
  call gio_init_gildas(input, 'GDF_CH') 
  call gio_init_gildas(output, 'GDF_CH') 
  output%file = input%file
  output%char = input%char
  output%loca = input%loca
  error = .false.
  call gdf_copy_gil (input,output, error)
end subroutine gdf_ch

subroutine clic_check (line,error)
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  real :: step
  !
  step = 5.0
  call sic_r4(line,0,1,step,.false.,error)
  if (error) goto 99
  call clic_check_contin (step,error)
  return
99 error = .true.
end subroutine clic_check
!
subroutine clic_check_contin (step,error)
  use classic_api
  use clic_rdata
  real :: step                      !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  !------------------------------------------------------------------------
  ! Code:
  call sub_continuum (r_nsb, r_nband, r_nbas, r_lntch,   &
    datac, datal, passc, passl, step,error)
  if (error) goto 999
  error = .false.
  return
999 error = .true.
  return
end subroutine clic_check_contin
!
subroutine sub_continuum (qsb, qband, qbas, qntch,   &
    data_c, data_l, pass_c, pass_l, step,error)
  use gildas_def
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! Check continuum correlator stability on current scan
  !
  ! Call Tree
  !	CLIC_CHECK
  !---------------------------------------------------------------------
  integer :: qsb                     !
  integer :: qband                   !
  integer :: qbas                    !
  integer :: qntch                   !
  complex :: data_c(qsb,qband,qbas)  !
  complex :: data_l(qntch,qsb,qbas)  !
  complex :: pass_c(qsb,qband,qbas)  !
  complex :: pass_l(qntch,qsb,qbas)  !
  real :: step                       !
  logical :: error                   !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  ! Local
  logical :: down_channel
  integer :: ib, is, isb 
  real :: afac,rmss
  complex :: zz(10),mean
  logical :: bad(mnbas,10)
  character(len=60) :: chain
  !------------------------------------------------------------------------
  ! Code:
  call set_scaling(error)
  do ib=1, mnbas
    do is = 1, r_nband
      bad(ib, is) = down_channel (ib, is)
    enddo
    do isb = 1,2
      mean = 0
      rmss = 0
      do is = 1, r_nband
        if (.not.bad(ib,is)) then
          zz(is) = data_c(isb,is,ib)
          if (do_pass) then
            zz(is) = zz(is)*pass_c(isb,is,ib)
          endif
          call scaling (is,isb,ib,zz(is),afac,error)
          if (.not.error) then
            mean = mean+zz(is)
            rmss = rmss+real(zz(is))**2+aimag(zz(is))**2
          endif
        endif
      enddo
      !
      mean = mean/r_nband
      rmss = rmss/r_nband-real(mean)**2-aimag(mean)**2
      rmss = sqrt(rmss)*step
      !
      do is = 1,r_nband
        if (.not.bad(ib,is) .and.   &
          abs(zz(is)-mean).gt.rmss) then
          write (chain,100) is,cband(isb),cbas(ib)
          call message(6,2,'CONTINUUM',chain)
        endif
      enddo
    enddo
  enddo
100 format('Bad subband C',i2.2,1x,a,' Baseline ',a)
  return
error = .true.
  return
end subroutine sub_continuum

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_kernel
  use cubetools_parameters
  use cubemain_messaging
  !
  public :: kernel_t
  public :: cubemain_kernel_allocate,cubemain_kernel_free
  private
  !
  type kernel_t
     real(kind=coor_k) :: inc  = 0d0 ! [rad] 
     real(kind=coor_k) :: val  = 0d0 ! [rad] 
     real(kind=coor_k) :: ref  = 0d0 ! [rad] 
     real(kind=coor_k) :: zero = 0d0 ! [rad] i0 = ref - val/inc
     real(kind=coor_k) :: fac  = 0d0 ! [rad] 1/inc
     real(kind=coor_k) :: min  = 0d0 ! [rad] 
     real(kind=coor_k) :: max  = 0d0 ! [rad] 
     real(kind=sign_k),   pointer :: fn(:) => null()
     integer(kind=chan_k) :: n = 0
  end type kernel_t
  !
contains
  !
  subroutine cubemain_kernel_allocate(n,kern,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=index_length), intent(in)    :: n
    type(kernel_t),             intent(inout) :: kern
    logical,                    intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='KERNEL>ALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (n.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of elements')
       error = .true.
       return
    endif
    ! Allocate
    allocate(kern%fn(n),stat=ier)
    if (failed_allocate(rname,'kernel',ier,error)) return
    ! Allocation success => kern%n may be updated
    kern%n = n
  end subroutine cubemain_kernel_allocate
  !
  subroutine cubemain_kernel_free(kern,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(kernel_t), intent(inout) :: kern
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='KERNEL>FREE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    kern%zero = 0
    kern%fac = 0
    kern%min = 0
    kern%max = 0
    kern%n = 0
    if (associated(kern%fn)) deallocate(kern%fn)
  end subroutine cubemain_kernel_free
end module cubemain_kernel
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine solve_flux(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! 	Calculate the flux of sources in the current index,
  !	or the efficiency (JY_TO_KEL) if the flux is known
  !       /RESET : reset all unknown fluxes to zero.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  ! Local
  character(len=6) :: ch
  character(len=80) :: snam,filnam
  logical :: new, output, iznogoud, usereal
  integer :: iband, iant, ix, iy, jw1, jw2, old_base, p_lun, ipol, kb, kif
  integer :: i, ia, ns,  if, is, if1, ier, nch, ir, ignored
  real :: frtol
  integer :: dtol
  parameter (frtol=1e3, dtol=7)    ! 1 GHz ... 1 week ...
  real :: visi(mnant,m_flux), wisi(mnant,m_flux),solflux(mnant,m_flux)
  real :: eff_in(mnant,m_flux)
  real :: aflux, sflux(m_flux), weff(mnant), seff(mnant), wflux
  real :: fff(mnant), wfff(mnant), factor
  real :: vsflux, wsflux, vt(4,3), wt(4,3), fflux(m_flux), ff, fi, fl, efl
  logical :: end, do_phcorr, reset
  logical :: do_reference, checked
  character(len=132) :: chain
  character(len=12) :: argum, sname(m_flux), tsource, rf_chain
  integer(kind=address_length) :: k, ipk, ipkc, ipkl, data_in, kin
  integer(kind=data_length)    :: ldata_in, h_offset, c_offset, l_offset
  integer :: sdate(m_flux), iv, im, n_best, ind(mnant), iscan
  integer(kind=index_length) :: dim(4)
  !
  integer :: mvoc1, mvoc2, nkey
  parameter (mvoc1=6, mvoc2=3)
  character(len=12) :: kw, voc1(mvoc1), voc2(mvoc2)
  data voc1/'CORRECTED','UNCORRECTED','REFERENCED',   &
    'NOREFERENCED','BEST','REAL'/
  data voc2/'OLD','NEW','FLUX'/
  !
  common /theflux/  seff, sflux, ns
  save /theflux/
  save sname
  !------------------------------------------------------------------------
  ! Code:
  ipol = 1 ! Dummy
  kb = 1   
  kif =1 
  checked = .false.
  save_scale = do_scale
  ! Verify if any input file
  call check_input_file(error)
  if (error) return
  !
  call check_index(error)
  if (error) return
  !
  output = .false.
  do_phcorr = .false.
  do_reference = .true.
  n_best = 3
  usereal = .false.
  if (sic_narg(0).ge.2) then
    i = 2
    do while (i.le.sic_narg(0))
      argum = 'UNCORRECTED'
      call sic_ke(line,0,i,argum,nch,.false.,error)
      i = i+1
      if (error) goto 999
      call sic_ambigs('SOLVE FLUX',argum,kw,nkey,voc1,mvoc1,error)
      if (error) goto 999
      if (kw.eq.'CORRECTED') then
        do_phcorr = .true.
      elseif (kw.eq.'UNCORRECTED') then
        do_phcorr = .false.
      elseif (kw.eq.'REFERENCED') then
        do_reference = .true.
      elseif (kw.eq.'NOREFERENCED') then
        do_reference = .false.
      elseif (kw.eq.'BEST') then
        call sic_i4(line,0,i,n_best,.true.,error)
        i = i+1
      elseif (kw.eq.'REAL') then
        usereal = .true.
        write (chain,'(a,i1,a)') 'Using visibility real part'   &
          //' instead of amplitude'
        call message(8,2,'SOLVE_FLUX',chain(1:lenc(chain)))
      endif
    enddo
  endif
  write (chain,'(a,i0,a)') 'Average fluxes will use the best ',   &
    n_best,' antennas'
  call message(8,1,'SOLVE_FLUX',chain(1:lenc(chain)))
  !
  reset = sic_present(4,0)
  !
  output = sic_present(3,0)
  if (output) then
    call sic_ch(line,3,1,snam,nch,.true.,error)
    if (error) goto 999
    new = .false.
    i = 2
    do while (i.le.sic_narg(3))
      call sic_ke(line,3,i,ch,nch,.true.,error)
      if (error) goto 999
      call sic_ambigs('SOLVE_FLUX',ch,kw,nkey,voc2,mvoc2,error)
      if (error) goto 999
      new = new.or.(kw.eq.'NEW')
      i = i+1
    enddo
    call sic_parsef(snam,filnam,' ','.int')
    ier = sic_getlun(p_lun)
    if (new) then
      ier = sic_open (p_lun,filnam,'NEW',.false.)
      if (ier.eq.0) then
        call user_info(snam)
        write(p_lun,2001) '! '
        write(p_lun,2001) '! CLIC\SOLVE FLUX /OUT '   &
          //filnam(1:lenc(filnam))//   ' FLUX NEW '
        write(p_lun,2001) '! '//snam(1:70)
        write(p_lun,2010)
      endif
    else
      ier = sic_open (p_lun,filnam,'APPEND',.false.)
    endif
    if (ier.ne.0) then
      call message(6,3,'SOLVE_FLUX','Cannot open file '//filnam)
      call messios(6,3,'SOLVE_FLUX',ier)
      error = .true.
      call sic_frelun(p_lun)
      return
    endif
  endif
  !
  if (reset) then
    k = 1
    do i=1, n_flux
      if (f_flux(i)) then
        f_flux(k) = .true.
        flux(k) = flux(i)
        c_flux(k) = c_flux(i)
        freq_flux(k) = freq_flux(i)
        date_flux(k) = date_flux(i)
        k = k+1
      endif
    enddo
    n_flux = k-1
  endif
  ! check if flux list contains a reference flux
  if (do_reference) then
    k = 0
    do i=1, n_flux
      if (f_flux(i)) then
        k = k+1
      endif
    enddo
    if (k.eq.0) then
      call message(6,3,'SOLVE_FLUX',   &
        'No source of known flux in flux list')
      error = .true.
      return
    endif
  else
    call message(4,1,'SOLVE_FLUX',   &
      'Using stored efficiencies to compute fluxes')
  endif
  jw1 = iw1(k_subb(1))
  jw2 = iw2(k_subb(1))
  !
  ! Select either real part (IY=3) or amplitude (IY=1, default)
  ix = 10
  iy = 1
  if (usereal) then
    iy = 3
  endif
  iband = i_band(k_band(1))
  ignored = 0
  !
  do_scale = .true.
  do_amplitude = .false.
  do_flux = .false.
  call show_general('AMPLITUDE',.false.,line,error)
  if (error) goto 999
  !
  old_base = i_base(1)
  if (i_base(1).gt.0) call switch_antenna
  call set_display(error)
  !
  ! Count sources in current index, store known fluxes and visibilities
  call get_first(.true.,error)
  if (error) goto 999
  call check_subb(1,.true.,error)
  if (error) goto 999
  ns = 0
  tsource = ' '
  end = .false.
  do while (.not. end)
    is = 0
    if (ns.ge.1) then
      do i=1, ns
        if (r_sourc.eq.sname(i)   &
          .and. abs(r_restf-fflux(i)).lt.frtol) then
          is = i
        endif
      enddo
    endif
    if (is.eq.0) then
      ns = ns + 1
      sname(ns) = r_sourc
      fflux(ns) = r_restf
      sdate(ns) = r_dobs
      if (r_flux.eq.0) then
        sflux(ns) = -1.0
      else
        sflux(ns) = -abs(r_flux)
      endif
      !
      ! Check if by chance flux is already known
      do if = 1, n_flux
        if (f_flux(if) .and. c_flux(if).eq.sname(ns) .and.   &
          ((freq_flux(if).le.0)  .or.   &
          (abs(fflux(ns)-freq_flux(if)).lt.frtol)) .and.   &
          ((date_flux(if).lt.-100000)   &
          .or. (abs(date_flux(if)-sdate(ns)).le.dtol))) then
          sflux(ns) = flux(if)
        endif
      enddo
      do ia = 1, r_nant
        visi(ia,ns) = 0
        wisi(ia,ns) = 0
        !cc NGRX: Use the efficience for Polarization 1 !!!
        eff_in(ia,ns) = r_jykel(1,ia)
      enddo
      is = ns
    endif
    ! Check subband group is OK
    call check_subb(1,.true.,error)
    if (error) goto 200
    if (do_pass.and..not.do_pass_memory) then
      if (do_pass_spectrum.and..not.checked) then
        iscan = 0
        call get_pass_scan(rf_chain,iscan,error)
        if (error) then
          call message(8,2,'SOLVE_FLUX','No BANDPASS scan found')
          ignored = ignored + 1
          goto 200
        endif
        checked = .true.
      else
        if (do_pass_antenna .and. r_abpc.eq.0) then
          call message(6,2,'SOLVE_FLUX',   &
            'No Antenna RF Passband Calibration, data ignored')
          ignored = ignored + 1
          goto 200
        elseif (.not.do_pass_antenna .and. r_bpc.eq.0) then
          call message(6,2,'SOLVE_FLUX',   &
            'No Baseline RF Passband Calibration, data ignored')
          ignored = ignored + 1
          goto 200
        endif
      endif
    endif
    if (r_lmode.gt.1) then
      call message(6,2,'SOLVE_FLUX',   &
        'Autocorrelation scan ignored.')
      ignored = ignored + 1
      goto 200
    endif
    call get_data (ldata_in,data_in,error)
    if (error) goto 200
    if (do_pass) then
      call set_pass(r_nsb,r_nband,r_nbas+r_ntri,   &
        r_lntch, passc, passl, error)
      if (error) goto 200
    endif
    call set_corr(error)
    !
    ! Do not loop on records : use average for scan
    !
    call spectral_dump(ir,0,0)
    kin = gag_pointer(data_in,memory)
    ipk = kin  + h_offset(ir)
    call decode_header(memory(ipk))
    call set_scaling (error)
    if (error) return
    !
    ff = r_restf*1e-3
    fi = (r_restf-2*r_isb*r_fif1)*1e-3
    do ia = 1, n_base
      iant = -i_base(ia)
      call spectral_dump(ir,iant,0)
      ipkc = kin + c_offset(ir)
      ipkl = kin + l_offset(ir)
      do iv=1,4
        do im=1,3
          vt(iv,im) = 0
          wt(iv,im) = 0
        enddo
      enddo
      call arecord (r_nsb, r_nband, r_nbas, r_lntch,   &
        memory(ipkc),memory(ipkl),   &
        passc, passl, iant, iband, ipol, kb, kif, l_subb(1), i_subb(1,1),   &
        jw1,jw2,ix,iy, vt, wt, do_phcorr,error)
      if (error) goto 999
      visi(ia,is) = visi(ia,is) + vt(2,2)
      wisi(ia,is) = wisi(ia,is) + wt(2,2)
      !
      ! For flux output : printout 2 lines for each scan, and each antenna
      ! (compatibility with CLASS printouts)
      if (output.and.wt(2,2).gt.0) then
        call datec (r_dobs,chain,error)
        fl = vt(2,2)/wt(2,2)*abs(sflux(is))
        efl = abs(sflux(is))*1e-3/sqrt(wt(2,2))
        !cc NGRX: Give the efficiency for Polar 1 !!!!!!!!!!!!!!!
        do k=1,0,-1
          write(p_lun,2011) r_num, r_scan, k, 0d0, 0d0, 0d0,   &
            0.0, 0.0, iant, 1.0, 0.0, fl, efl,   &
            r_gim(1,iant), ff, fi, sname(is),chain(1:11)
        enddo
      endif
    enddo
200 error = .false.
    call get_next(end,error)
    if (error) goto 999
    if (sic_ctrlc()) then
      error = .true.
      goto 900
    endif
  enddo
  if (ignored.gt.0) then
    write(chain,'(i6,a)') ignored, ' ignored scans.'
    call message(6,2,'SOLVE_FLUX',chain(1:lenc(chain)))
  endif
  !
2011 format(1x,i8,i6,i3,3(1x,f8.3),1x,   &
    f9.2,1x,f8.2,1x,i2,1x,f9.2,1x,f8.2,1x,   &
    1pg10.3,1x,1pg10.3,1x,0pf6.2,2(1x,f8.3),1x,'''',a,'''',   &
    1x,'''',a,'''')
  do i = 1, ns
    do ia = 1, n_base
      if (wisi(ia,i).ne.0) then
        visi(ia,i) = visi(ia,i)/wisi(ia,i)
      elseif (sflux(i).gt.0) then
        write(chain,'(a,i2,a)') sname(i)//' antenna ',ia,   &
          ' cannot be used'
        call message(4,2,'SOLVE_FLUX',chain(1:lenc(chain)))
      endif
    enddo
  enddo
  !
  ! Get efficiencies (for sources with known flux)
  if (do_reference) then
    call sic_delvariable ('JY_PER_K',.false.,error)
    call sic_def_real ('JY_PER_K',seff,1,n_base,.false.,error)
    do ia = 1, n_base
      weff(ia) = 0
      seff(ia) = 0
    enddo
    if (do_phcorr) call message(6,1,'SOLVE_FLUX',   &
      'Amplitudes are corrected for r.m.s. phase errors')
    call message(6,1,'SOLVE_FLUX','Reference sources:')
    !
    ! Compute efficiencies
    do i=1, ns
      if (sflux(i).gt.0) then
        write(chain,1000) sname(i),sflux(i)
        call message(6,1,'SOLVE_FLUX',chain(1:lenc(chain)))
        ! Original formula  [ (visi/flux)*(wisi*flux**2) ]
        ! and in Scaled mode [ Scale*wisi ]
        do ia=1, n_base
          seff(ia) = seff(ia) + visi(ia,i)*wisi(ia,i)
          weff(ia) = weff(ia) + wisi(ia,i)
        enddo
      endif
    enddo
    !
    ! Check if any good efficiency:
    iznogoud = .true.
    do ia=1, n_base
      iznogoud = iznogoud .and. weff(ia).le.0
    enddo
    if (iznogoud) then
      call message(8,3,'SOLVE_FLUX',   &
        'No usable data with known flux')
      error = .true.
      if (output) then
        close (unit=p_lun)
        call sic_frelun(p_lun)
      endif
      do_scale = save_scale
      return
    endif
    call message(6,1,'SOLVE_FLUX','Average efficiencies:')
    !c NGRX: Use the efficiency for polar 1 !!!!!!
    do ia=1, n_base
      if (weff(ia).gt.0) then
        iant = -i_base(ia)
        seff(ia) = weff(ia)/seff(ia)
        write(chain,1001,iostat=ier)   &
          iant, seff(ia),1e-3/sqrt(weff(ia))*seff(ia)**2,   &
          r_jykel(1,ia)/seff(ia)
        call message(6,1,'SOLVE_FLUX',chain(1:lenc(chain)))
      else
        seff(ia) = 0
        write(chain,'(a,i2,a)') 'Efficiency for antenna ',ia,   &
          ' cannot be computed'
        call message(6,2,'SOLVE_FLUX',chain(1:lenc(chain)))
      endif
    enddo
  endif
  !
  ! Get fluxes (for other sources)
  call message(6,1,'SOLVE_FLUX','Sources, Fluxes and errors : ')
  do is=1, ns
    aflux = 0
    wflux = 0
    do ia=1, n_base
      iant = -i_base(ia)
      if (do_reference) then
        if (seff(ia).gt.0) then
          eff_in(ia,is) = seff(ia)
        else
          eff_in(ia,is) = 1000
        endif
      endif
      factor = eff_in(ia,is)*abs(sflux(is))
      vsflux = visi(ia,is)*factor
      wsflux = wisi(ia,is)/factor**2
      if (wsflux.ne.0) then
        write(chain,1004,iostat=ier) sname(is), iant,   &
          vsflux, 1e-3/sqrt(wsflux)
        call message(6,1,'SOLVE_FLUX',chain(1:lenc(chain)))
      endif
      fff(ia) = vsflux
      solflux(ia,is)= vsflux
      wfff(ia) = wsflux
    enddo
    !         CALL GR4_TRIE(FFF,IND,N_BASE,ERROR)
    call gr4_trie(eff_in(:,is),ind,n_base,error)
    !         DO IA= N_BASE, MAX(1,N_BASE-N_BEST+1), -1
    if (is.eq.1) then
      write(chain,'(i0,a,5(i0," "))') n_best," best antennas are ", ind(1:n_best)                    
      call message(6,1,'SOLVE_FLUX',chain(1:lenc(chain)))
    endif
    do ia= 1, n_best           !N_BASE, MAX(1,N_BASE-N_BEST+1), -1
      i = ind(ia)
      !            AFLUX = AFLUX + FFF(IA)*WFFF(I)
      aflux = aflux + fff(i)*wfff(i)
      wflux = wflux + wfff(i)
      if (wfff(i).eq.0) then
        write(chain,'(a,i0,a)') "Antenna ",i," was ignored"                    
        call message(6,1,'SOLVE_FLUX',chain(1:lenc(chain)))
      endif
    enddo
    if (wflux.ne.0) then
      aflux = aflux / wflux
      write(chain,1003,iostat=ier)   &
        sname(is), aflux, 1e-3/sqrt(wflux)
      call message(6,1,'SOLVE_FLUX',chain(1:lenc(chain)))
    endif
    !
    ! Compute the new fluxes for "free" sources
    if (sflux(is).le.0) then
      sflux(is) = aflux
      if1 = 0
      do if = 1, n_flux
        if (.not.f_flux(if) .and. c_flux(if).eq.sname(is)   &
          .and. (freq_flux(if).le.0 .or.   &
          (abs(freq_flux(if)-fflux(is)).lt.frtol))) then
          flux(if) = sflux(is)
          if (freq_flux(if).le.0) freq_flux(if) = fflux(is)
          date_flux(if) = sdate(is)
          f_flux(if) = .false.
          if1 = if
        endif
      enddo
      if (if1.le.0 .and. n_flux.lt.m_flux) then
        n_flux = n_flux+1
        f_flux(n_flux) = .false.
        flux(n_flux) = sflux(is)
        freq_flux(n_flux) = fflux(is)
        c_flux(n_flux) = sname(is)
        date_flux(if) = sdate(is)
      endif
    endif
  enddo
  !
  ! Keep the results in variables for calibration procedures.
  call sic_delvariable ('SOLVED',.false.,error)
  call sic_delvariable ('N_SOLVED',.false.,error)
  call sic_delvariable ('F_SOLVED',.false.,error)
  call sic_delvariable ('AF_SOLVED',.false.,error)
  call sic_def_inte    ('N_SOLVED',ns,0,0,.false.,error)
  call sic_def_charn   ('SOLVED',sname,1,ns,.false.,error)
  call sic_def_real    ('F_SOLVED',sflux,1,ns,.false.,error)
  dim(2) = ns
  dim(1) = mnant
  call sic_def_real    ('AF_SOLVED',solflux,2,dim,.false.,error)
  call sort_fluxes(error)
  do i=1, n_base
    iant = -i_base(i)
    jy_to_kel(iant) = eff_in(iant,is)
  enddo
  !
900 if (old_base.gt.0) call switch_baseline
  call set_display(error)
  if (output) then
    close (unit=p_lun)
    call sic_frelun(p_lun)
  endif
  do_scale = save_scale
  return
  !
999 error = .true.
  goto 900
  !
1000 format(1x,a,1x,'Flux = ',f8.4,' Jy')
1001 format(1x,'Ant. ',i0,2x,f7.3,' +- ',f5.3,' Jy/K  (',f5.2,')')
1003 format(1x,a,' Aver.',1x,f8.4,' +- ',f5.4)
1004 format(1x,a,' Ant ',i0,1x,f8.4,' +- ',f5.4)
2010 format(   &
    '!   Obs.#  Scan Code Azimuth   Elevation  Time  ',   &
    '     Position  ..  A#     Width      ..     Intensity',   &
    '     ..  Gain   Fsignal  Fimage Source  Date')
2001 format(a)
end subroutine solve_flux

program uv_flag
  use gildas_def
  use gkernel_interfaces
  use image_def
  !---------------------------------------------------------------------
  ! GILDAS
  !	FLAG data in input UV table
  !---------------------------------------------------------------------
  real(8), parameter :: pi=3.14159265358979323846d0
  ! Local
  type(gildas) :: x
  character(len=80) :: uvdata,name, ut_start, ut_end, date_start, baseline
  character(len=80) :: date_end, chain
  integer :: n,nx,nc(2), i, ibase, larg, ier, iant, jant
  real(8) :: ut1, ut2, tt
  real(4) :: riant, rjant, rflag
  logical :: error, flag
  !
  !------------------------------------------------------------------------
  ! Code:
  call gildas_open
  call gildas_char('UVDATA$',uvdata)
  !
  call gildas_char('DATE_START$',date_start)
  larg = len_trim(date_start)
  call gag_fromdate(date_start(1:larg),i,error)
  if (error) then
    write(6,*) 'F-UV_FLAG, error converting ',date_start(1:larg)
    goto 999
  endif
  ut1 = i
  !
  call gildas_char('UT_START$',ut_start)
  larg = len_trim(ut_start)
  call sic_decode(ut_start,tt,24,error)    ! TT in RADIANS
  if (error) goto 999
  ut1 = ut1 + tt/2d0/pi
  !
  call gildas_char('DATE_END$',date_end)
  larg = len_trim(date_end)
  call gag_fromdate(date_end(1:larg),i,error)
  if (error) then
    write(6,*) 'F-UV_FLAG, error converting ',date_end(1:larg)
    goto 999
  endif
  ut2 = i
  !
  call gildas_char('UT_END$',ut_end)
  larg = len_trim(ut_end)
  call sic_decode(ut_end,tt,24,error)  ! TT in RADIANS
  if (error) goto 999
  ut2 = ut2 + tt/2d0/pi
  !
  call gildas_char('BASELINE$',baseline)
  call sic_upper(baseline)
  if (baseline.eq."ALL") then
    ibase = 0
  else
    read(baseline,*,iostat=ier) riant,rjant
    if (ier.ne.0) goto 999
    ibase = basant(riant,rjant)
    iant = 0
    jant = 0
  endif
  !
  call gildas_logi('FLAG$',flag,1)
  if (flag) then
    rflag = -1
  else
    rflag = 1
  endif
  !
  call gildas_char('ANTENNA$',chain)
  read(chain,'(i12)',iostat=ier) iant
  if (ier.ne.0) goto 999
  !
  call gildas_inte('CHANNELS$',nc,2)
  call gildas_close
  !
  ! Input file
  n = len_trim(uvdata)
  if (n.le.0) goto 999
  call gildas_null(x, type = 'UVT')
  call gdf_read_gildas(x, uvdata, '.uvt', error)
  if (error) then
    write(6,100) 'F-UV_FLAG,  Cannot read input UV table'
    goto 999
  endif
  !
  ier = gdf_range(nc,x%gil%nchan)
  call doflag (x%r2d,x%gil%dim(1),x%gil%dim(2),ut1, ut2, ibase,   &
     &    iant, nc, rflag)
  call gdf_write_data(x, x%r2d, error)
  call gagout('S-UV_FLAG,  Successful completion')
  call sysexi(1)
  !
  98    call gagout('F-UV_FLAG, error converting UT string')
  999   call sysexi(fatale)
  100   format(1x,a)
contains
!
subroutine doflag (out,nx,nv,ut1, ut2, ibase, iant, nc, rflag)
  use gildas_def
  !---------------------------------------------------------------------
  ! Conditionally change sign of weights according to RFLAG
  !---------------------------------------------------------------------
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: nv                     !
  real :: out(nx,nv)                !
  real(8) :: ut1                     !
  real(8) :: ut2                     !
  integer :: ibase                  !
  integer :: iant
  integer :: nc(2)                  !
  real :: rflag                  !
  ! Local
  integer :: i,j, i1, i2, ib
  real(8) :: t
  !------------------------------------------------------------------------
  ! Code:
  !
  if (iant.ne.0) then
    do j=1,nv
      t = out(4,j)+out(5,j)/86400d0
      i1 = nint(out(6,j))
      i2 = nint(out(7,j))
      if (t.gt.ut1 .and. t.lt.ut2 .and.   &
       &      (i1.eq.iant .or. i2.eq.iant)) then
        do i = 3*nc(1), 3*nc(2), 3
          out(i+7,j) = sign(out(i+7,j),rflag)
        enddo
      endif
    enddo
  else  
    do j=1,nv
      t = out(4,j)+out(5,j)/86400d0
      ib = basant(out(6,j),out(7,j))
      if (t.gt.ut1 .and. t.lt.ut2 .and.   &
       &      (ibase.le.0 .or. ib.eq.ibase)) then
        do i = 3*nc(1), 3*nc(2), 3
          out(i+7,j) = sign(out(i+7,j),rflag)
        enddo
      endif
    enddo
  endif
end subroutine 
!
integer function basant(ri,rj)
  real, intent(in) :: ri,rj
  !
  integer k,l
  if (ri.gt.rj) then
    basant = 256*nint(rj)+nint(ri)
  else
    basant = 256*nint(ri)+nint(rj)
  endif
end function basant
!
end program uv_flag

subroutine selimx(obs,xc1,xc2,xv1,xv2,xf1,xf2,xfo,xi1,xi2,xio)
  use gildas_def
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS	Internal routine
  !	Defines the four coordinates systems
  !---------------------------------------------------------------------
  type (observation),     intent(inout) :: obs      !
  real(kind=plot_length), intent(in)    :: xc1,xc2  ! Channel limits
  real(kind=plot_length), intent(in)    :: xv1,xv2  ! Velocity limits
  real(kind=plot_length), intent(in)    :: xf1,xf2  ! Rest frequency limits
  real(kind=8),           intent(in)    :: xfo      ! Rest frequency offset
  real(kind=plot_length), intent(in)    :: xi1,xi2  ! Image frequency limits
  real(kind=8),           intent(in)    :: xio      ! Image frequency offset
  !
  call get_box(gx1,gx2,gy1,gy2)
  gcx1 = xc1
  gcx2 = xc2
  gvx1 = xv1
  gvx2 = xv2
  gfx1 = xf1
  gfx2 = xf2
  gfxo = xfo
  gix1 = xi1
  gix2 = xi2
  gixo = xio
  gcx  = (gx2-gx1)/(gcx2-gcx1)
  gvx  = (gx2-gx1)/(gvx2-gvx1)
  gfx  = (gx2-gx1)/(gfx2-gfx1)
  gix  = (gx2-gx1)/(gix2-gix1)
  !
  ! Initialize cimin,cimax
  call obs_limits(obs)
end subroutine selimx
!
subroutine obs_limits(obs)
  use gildas_def
  use class_types
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  !  Defines the Min Max range of the channels to be plotted. Note that
  ! this range is also used for BASElining, be careful...
  !---------------------------------------------------------------------
  type (observation), intent(inout) :: obs
  !
  ! - gcx1 and gcx2 are the range of channels to be selected, in
  !   NON-integer (floating point) channel unit. We apply the following
  !   rule: if less* than 1/2 channel is considered, it is not selected.
  ! * "Less than" or "less or equal"? The method should accomodate exact
  !   channel range selection by the user, e.g. 1.000 to 10.000 should
  !   include those boundaries. CEILING and FLOOR functions are perfect
  !   for this.
  ! - Also remember that because of its width, the channel #N runs from
  !   N-0.5 to N+0.5
  !
  if (gcx1.lt.gcx2) then
    obs%cimin = max(ceiling(gcx1),1)
    obs%cimax = min(floor(gcx2),obs%cnchan)
  else
    obs%cimin = max(ceiling(gcx2),1)
    obs%cimax = min(floor(gcx1),obs%cnchan)
  endif
end subroutine obs_limits
!
subroutine seunitx(set,r,unit_low,unit_up,error)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>seunitx
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Change the current unit and modifies all parameters accordingly.
  ! If no R buffer is loaded, no error is raised.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set       !
  type(observation),   intent(inout) :: r         !
  character(len=*),    intent(in)    :: unit_low  ! Lower axis unit
  character(len=*),    intent(in)    :: unit_up   ! Upper axis unit
  logical,             intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UNIT'
  character(len=1) :: unitx_old(2)
  !
  unitx_old(:) = set%unitx(:)  ! Save previous value in case of error
  !
  set%unitx(2) = unit_up
  if (unit_low(1:1).eq.set%unitx(1))  return
  !
  ! New lower unit
  if (unit_low(1:1).ne.'C' .and. unit_low(1:1).ne.'V' .and.   &
      unit_low(1:1).ne.'F' .and. unit_low(1:1).ne.'I' .and.   &
      unit_low(1:1).ne.'A' .and. unit_low(1:1).ne.'T') then
    call class_message(seve%e,rname,'Invalid X unit type '//unit_low(1:1))
    error = .true.
    return
  endif
  !
  set%unitx(1) = unit_low(1:1)
  !
  if (r%head%xnum.eq.0) then
    ! No spectrum in memory. This is not an error, but since we do not
    ! know any abscissa conversion, we reset some global parameters:
    if (set%nwind.gt.0) then
      set%nwind = 0
      call class_message(seve%w,rname,  &
        'No R spectrum in memory: SET WINDOW reset to NO window')
    endif
    if (set%nmask.gt.0) then
      set%nmask = 0
      call class_message(seve%w,rname,  &
        'No R spectrum in memory: SET MASK reset to NO mask')
    endif
    if (set%modex.eq.'F') then
      set%modex = 'A'
      call class_message(seve%w,rname,  &
        'No R spectrum in memory: SET MODE X reset to Automatic')
    endif
    return
    !
  endif
  !
  if (r%head%gen%kind.eq.kind_spec   .and.  &
      r%head%spe%image.eq.image_null .and.  &
      any(set%unitx.eq.'I')) then
    ! SET UNIT I invalid in this case
    call class_message(seve%e,rname,'Spectrum has no image band defined')
    error = .true.
    set%unitx(:) = unitx_old(:)
    return
  endif
  !
  ! Reset SET WIND and SET MASK values
  call seunitx_wind_mask(set,r,unitx_old(1),set%unitx(1),error)
  ! if (error) continue?
  !
  ! Reset the unit-depending elements of the R% Fortran structure,
  ! reset the unit-depending elements of the R% Sic structure,
  ! reset the plotting limits according to SET MODE X:
  call newdat(set,r,error)
  !
end subroutine seunitx
!
subroutine seunitx_wind_mask(set,r,old,new,error)
  use gbl_message
  use classcore_interfaces, except_this=>seunitx_wind_mask
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Update the SET WINDOW and SET MASK values according to the old and
  ! new units. Take Doppler factor correctly into account, i.e. use
  ! 'abscissa' subroutines.
  ! NB: if you plan to support irregularly spaced data, you should merge
  ! with abscissa_any2chan()
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  type(observation),   intent(inout) :: r      !
  character(len=*),    intent(in)    :: old    ! Old unit for values
  character(len=*),    intent(in)    :: new    ! New unit for values
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UNIT'
  integer(kind=4) :: i
  real(kind=4) :: val
  !
  ! 1) Convert temporarily the SET WINDOW and SET MASK to channel units:
  if (old.eq.'C') then
    ! Already in channels, pass
    continue
  elseif (old.eq.'V') then
    do i=1,set%nwind
      call abscissa_velo2chan(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_velo2chan(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_velo2chan(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_velo2chan(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  elseif (old.eq.'F') then  ! Offset signal frequencies
    do i=1,set%nwind
      call abscissa_sigoff2chan(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_sigoff2chan(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_sigoff2chan(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_sigoff2chan(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  elseif (old.eq.'I') then  ! Offset image frequencies
    do i=1,set%nwind
      call abscissa_imaoff2chan(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_imaoff2chan(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_imaoff2chan(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_imaoff2chan(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  elseif (old.eq.'A') then
    do i=1,set%nwind
      call abscissa_angl2chan(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_angl2chan(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_angl2chan(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_angl2chan(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  elseif (old.eq.'T') then
    do i=1,set%nwind
      call abscissa_time2chan(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_time2chan(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_time2chan(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_time2chan(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  else
    call class_message(seve%e,rname,'Unit '//old//' not recognized')
    error = .true.
    return
  endif
  !
  ! 2) Convert SET WINDOW and SET MASK to target units:
  if (new.eq.'C') then
    ! Already in channels, pass
    continue
  elseif (new.eq.'V') then
    do i=1,set%nwind
      call abscissa_chan2velo(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_chan2velo(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_chan2velo(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_chan2velo(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  elseif (new.eq.'F') then  ! Offset signal frequencies
    do i=1,set%nwind
      call abscissa_chan2sigoff(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_chan2sigoff(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_chan2sigoff(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_chan2sigoff(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  elseif (new.eq.'I') then  ! Offset image frequencies
    do i=1,set%nwind
      call abscissa_chan2imaoff(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_chan2imaoff(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_chan2imaoff(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_chan2imaoff(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  elseif (new.eq.'A') then
    do i=1,set%nwind
      call abscissa_chan2angl(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_chan2angl(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_chan2angl(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_chan2angl(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  elseif (new.eq.'T') then
    do i=1,set%nwind
      call abscissa_chan2time(r%head,set%wind1(i),val)
      set%wind1(i) = val
      call abscissa_chan2time(r%head,set%wind2(i),val)
      set%wind2(i) = val
    enddo
    do i=1,set%nmask
      call abscissa_chan2time(r%head,set%mask1(i),val)
      set%mask1(i) = val
      call abscissa_chan2time(r%head,set%mask2(i),val)
      set%mask1(i) = val
    enddo
  else
    call class_message(seve%e,rname,'Unit '//new//' not recognized')
    error = .true.
    return
  endif
  !
end subroutine seunitx_wind_mask
!
subroutine gelimx(x0,x1,x2,dx,unit)
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  !  Return current limits and conversion factor in given X unit
  !---------------------------------------------------------------------
  real(kind=8),           intent(out) :: x0     ! Offset, if any
  real(kind=plot_length), intent(out) :: x1,x2  ! Range
  real(kind=plot_length), intent(out) :: dx     ! Conversion factors
  character(len=*),       intent(in)  :: unit   ! X unit
  !
  x0 = 0.d0
  select case (unit)
  case ('C')
     x1 = gcx1
     x2 = gcx2
  case ('V')
     x1 = gvx1
     x2 = gvx2
  case ('F')
     x0 = gfxo
     x1 = gfx1
     x2 = gfx2
  case ('I')
     x0 = gixo
     x1 = gix1
     x2 = gix2
  case ('T')
     x1 = gfx1
     x2 = gfx2
  case ('A')
     x1 = gvx1
     x2 = gvx2
  end select
  dx = (gx2-gx1)/(x2-x1)
end subroutine gelimx
!
subroutine geunit(set,head,unit,unit_up)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return the current units
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set      !
  type(header),        intent(in)  :: head     !
  character(len=*),    intent(out) :: unit     ! X unit
  character(len=*),    intent(out) :: unit_up  ! X unit
  !
  unit = set%unitx(1)
  if (head%presec(class_sec_xcoo_id)) then
     unit_up = ' '
  else
     unit_up = set%unitx(2)
  endif
end subroutine geunit
!
subroutine gulimx(x1,x2,dx)
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS	Internal routine
  !	Return the current limits in current unit
  !---------------------------------------------------------------------
  real(kind=plot_length), intent(out) ::  x1,x2  ! Conversion factors
  real(kind=plot_length), intent(out) ::  dx     ! Conversion factors
  !
  x1 = gux1
  x2 = gux2
  gux = (gx2-gx1)/(gux2-gux1)
  dx = gux
end subroutine gulimx
!
subroutine get_box(ax1,ax2,ay1,ay2)
  use gbl_message
  use classcore_interfaces, except_this=>get_box
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  ! Get box position from GreG
  !---------------------------------------------------------------------
  real(kind=plot_length), intent(out) :: ax1,ax2  !
  real(kind=plot_length), intent(out) :: ay1,ay2  !
  ! Local
  logical :: error
  !
  if (plot_length.eq.8) then
     call class_message(seve%e,'GET_BOX','PROGRAMMING ERROR: update needed')
     ! call sic_get_dble('BOX_XMIN',ax1,error)
     ! call sic_get_dble('BOX_XMAX',ax2,error)
     ! call sic_get_dble('BOX_YMIN',ay1,error)
     ! call sic_get_dble('BOX_YMAX',ay2,error)
  else
     call sic_get_real('BOX_XMIN',ax1,error)
     call sic_get_real('BOX_XMAX',ax2,error)
     call sic_get_real('BOX_YMIN',ay1,error)
     call sic_get_real('BOX_YMAX',ay2,error)
  endif
end subroutine get_box

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_one2two_image_template
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubetemplate_messaging
  !
  public :: one2two_image_comm_t,one2two_image_user_t,one2two_image_prog_t
  private
  !
  type one2two_image_comm_t
     type(option_t), pointer :: comm
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube1
     type(cube_prod_t),  pointer :: oucube2
     procedure(cubetemplate_one2two_image_prog_act), pointer, nopass, public :: act => null()
   contains
     procedure, public :: register_syntax => cubetemplate_one2two_image_register_syntax
     procedure, public :: register_act    => cubetemplate_one2two_image_register_act
     procedure, public :: parse           => cubetemplate_one2two_image_parse
     procedure, public :: main            => cubetemplate_one2two_image_main
  end type one2two_image_comm_t
  !
  type one2two_image_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubetemplate_one2two_image_user_toprog
  end type one2two_image_user_t
  !
  type one2two_image_prog_t
     type(cuberegion_prog_t) :: region
     type(cube_t), pointer :: incube
     type(cube_t), pointer :: oucube1
     type(cube_t), pointer :: oucube2
     procedure(cubetemplate_one2two_image_prog_act), pointer, public :: act => null()
   contains
     procedure, private :: header => cubetemplate_one2two_image_prog_header
     procedure, private :: data   => cubetemplate_one2two_image_prog_data
     procedure, private :: loop   => cubetemplate_one2two_image_prog_loop
  end type one2two_image_prog_t
  !
contains
  !
  subroutine cubetemplate_one2two_image_register_syntax(comm,&
       opername,inid,inhelp,inflags,opercomm,&
       ou1name,ou1flags,ou2name,ou2flags,error,&
       comm_abstract,comm_help,incube_help,ou1help,ou2help)
    use gkernel_interfaces, only: sic_upper
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_image_comm_t), intent(inout)    :: comm
    character(len=*),            intent(in)       :: opername
    character(len=*),            intent(in)       :: inid
    character(len=*),            intent(in)       :: inhelp
    type(flag_t),                intent(in)       :: inflags(:)
    external                                      :: opercomm
    character(len=*),            intent(in)       :: ou1name
    type(flag_t),                intent(in)       :: ou1flags(:)
    character(len=*),            intent(in)       :: ou2name
    type(flag_t),                intent(in)       :: ou2flags(:)
    logical,                     intent(inout)    :: error
    character(len=*),            intent(in), optional :: comm_abstract
    character(len=*),            intent(in), optional :: comm_help
    character(len=*),            intent(in), optional :: incube_help
    character(len=*),            intent(in), optional :: ou1help
    character(len=*),            intent(in), optional :: ou2help
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=argu_l) :: myinid
    character(len=:), allocatable :: my_comm_abstract
    character(len=:), allocatable :: my_comm_help
    character(len=:), allocatable :: my_incube_help
    character(len=:), allocatable :: my_ou1help
    character(len=:), allocatable :: my_ou2help
    character(len=*), parameter :: rname='ONE2TWO>IMAGE>REGISTER>SYNTAX'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! Syntax
    my_comm_abstract = 'Compute the '//trim(opername)//' image or image of a '//&
         trim(inhelp)
    if (present(comm_abstract)) then
       my_comm_abstract = comm_abstract
    endif
    my_comm_help = 'Input/output cubes must/will be real.'
    if (present(comm_help)) then
       my_comm_help = comm_help
    endif
    call cubetools_register_command(&
         opername,inid,&
         my_comm_abstract,&
         my_comm_help,&
         opercomm,&
         comm%comm,error)
    if (error) return
    myinid = inid
    call sic_upper(myinid)
    my_incube_help = strg_emp
    if (present(incube_help)) then
       my_incube_help = incube_help
    endif
    call incube%register(&
         myinid,&
         inhelp,&
         my_incube_help,&
         code_arg_optional,&
         inflags,&
         code_read,&
         code_access_imaset,&
         comm%incube,&
         error)
    if (error) return
    !
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    my_ou1help = trim(ou1name)//' output'
    if (present(ou1help)) then
       my_ou1help = ou1help
    endif
    call oucube%register(&
         ou1name,&
         my_ou1help,&
         strg_emp,&
         ou1flags,&
         comm%oucube1,&
         error)
    if (error)  return
    my_ou2help = trim(ou2name)//' output'
    if (present(ou2help)) then
       my_ou2help = ou2help
    endif
    call oucube%register(&
         ou2name,&
         my_ou2help,&
         strg_emp,&
         ou2flags,&
         comm%oucube2,&
         error)
    if (error)  return
  end subroutine cubetemplate_one2two_image_register_syntax
  !
  subroutine cubetemplate_one2two_image_register_act(comm,act,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_image_comm_t),     intent(inout) :: comm
    procedure(cubetemplate_one2two_image_prog_act) :: act
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='ONE2TWO>IMAGE>REGISTER>ACT'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    comm%act => act
  end subroutine cubetemplate_one2two_image_register_act
  !
  subroutine cubetemplate_one2two_image_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! ONE2TWO cubeid
    ! /SIZE sx [sy]
    ! /CENTER xcen ycen
    ! /RANGE zfirst zlast
    !----------------------------------------------------------------------
    class(one2two_image_comm_t), intent(in)    :: comm
    character(len=*),            intent(in)    :: line
    type(one2two_image_user_t),  intent(out)   :: user
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='ONE2TWO>IMAGE>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubetemplate_one2two_image_parse
  !
  subroutine cubetemplate_one2two_image_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_image_comm_t), intent(in)    :: comm
    type(one2two_image_user_t),  intent(inout) :: user
    logical,                     intent(inout) :: error
    !
    type(one2two_image_prog_t) :: prog
    character(len=*), parameter :: rname='ONE2TWO>IMAGE>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_one2two_image_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_one2two_image_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(one2two_image_user_t), intent(in)    :: user
    type(one2two_image_comm_t),  intent(in)    :: comm
    type(one2two_image_prog_t),  intent(out)   :: prog
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='ONE2TWO>IMAGE>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call user%region%toprog(prog%incube,prog%region,error)
    if (error) return
    call prog%region%list(error)
    if (error) return
    !
    prog%act => comm%act
  end subroutine cubetemplate_one2two_image_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_one2two_image_prog_header(prog,comm,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_image_prog_t), intent(inout) :: prog
    type(one2two_image_comm_t),  intent(in)    :: comm
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='ONE2TWO>IMAGE>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call one_header(comm%oucube1,prog%incube,prog%region,prog%oucube1,error)
    if (error) return
    call one_header(comm%oucube2,prog%incube,prog%region,prog%oucube2,error)
    if (error) return
    !
  contains
    !
    subroutine one_header(oucomm,incube,region,oucube,error)
      use cubeadm_clone
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      type(cube_prod_t),       intent(in)    :: oucomm
      type(cube_t), pointer,   intent(in)    :: incube
      type(cuberegion_prog_t), intent(inout) :: region
      type(cube_t), pointer,   intent(inout) :: oucube
      logical,                 intent(inout) :: error
      !
      character(len=unit_l) :: unit
      integer(kind=chan_k), parameter :: one=1
      !
      call cubeadm_clone_header_with_region(oucomm,incube,region,oucube,error)
      if (error) return
    end subroutine one_header
  end subroutine cubetemplate_one2two_image_prog_header
  !
  subroutine cubetemplate_one2two_image_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(one2two_image_prog_t), intent(inout) :: prog
    logical,                     intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='ONE2TWO>IMAGE>PROG>DATA'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubetemplate_one2two_image_prog_data
  !   
  subroutine cubetemplate_one2two_image_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_image_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),    intent(inout) :: iter
    logical,                     intent(inout) :: error
    !
    type(image_t) :: ima,out1,out2
    character(len=*), parameter :: rname='ONE2TWO>IMAGE>PROG>LOOP'
    !
    call ima%associate('input',prog%incube,iter,error)
    if (error) return
    call out1%allocate('output #1',prog%oucube1,iter,error)
    if (error) return
    call out2%allocate('output #2',prog%oucube2,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%act(iter%ie,ima,out1,out2,error)
       if (error) return
    enddo ! ie
  end subroutine cubetemplate_one2two_image_prog_loop
  !
  subroutine cubetemplate_one2two_image_prog_act(prog,ie,ima,out1,out2,error)
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_image_prog_t), intent(inout) :: prog
    integer(kind=entr_k),        intent(in)    :: ie
    type(image_t),               intent(inout) :: ima
    type(image_t),               intent(inout) :: out1
    type(image_t),               intent(inout) :: out2
    logical,                     intent(inout) :: error
  end subroutine cubetemplate_one2two_image_prog_act
end module cubetemplate_one2two_image_template
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage MAPPING messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module map_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: map_message_id = gpack_global_id  ! Default value for startup message
  !
end module map_message_private
!
subroutine map_message_set_id(id)
  use map_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  map_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',map_message_id
  call map_message(seve%d,'map_message_set_id',mess)
  !
end subroutine map_message_set_id
!
subroutine map_message(mkind,procname,message)
  use gkernel_interfaces
  use map_message_private
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Messaging facility for the current library. Calls the low-level
  !   (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(map_message_id,mkind,procname,message)
  !
end subroutine map_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK DINTP
      SUBROUTINE DINTP (X, Y, XOUT, YOUT, YPOUT, NEQN, KOLD, PHI, IVC,
     +   IV, KGI, GI, ALPHA, OG, OW, OX, OY)
C***BEGIN PROLOGUE  DINTP
C***PURPOSE  Approximate the solution at XOUT by evaluating the
C            polynomial computed in DSTEPS at XOUT.  Must be used in
C            conjunction with DSTEPS.
C***LIBRARY   SLATEC (DEPAC)
C***CATEGORY  I1A1B
C***TYPE      DOUBLE PRECISION (SINTRP-S, DINTP-D)
C***KEYWORDS  ADAMS METHOD, DEPAC, INITIAL VALUE PROBLEMS, ODE,
C             ORDINARY DIFFERENTIAL EQUATIONS, PREDICTOR-CORRECTOR,
C             SMOOTH INTERPOLANT
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   The methods in subroutine  DSTEPS  approximate the solution near  X
C   by a polynomial.  Subroutine  DINTP  approximates the solution at
C   XOUT  by evaluating the polynomial there.  Information defining this
C   polynomial is passed from  DSTEPS  so  DINTP  cannot be used alone.
C
C   Subroutine DSTEPS is completely explained and documented in the text
C   "Computer Solution of Ordinary Differential Equations, the Initial
C   Value Problem"  by L. F. Shampine and M. K. Gordon.
C
C   Input to DINTP --
C
C   The user provides storage in the calling program for the arrays in
C   the call list
C      DIMENSION Y(NEQN),YOUT(NEQN),YPOUT(NEQN),PHI(NEQN,16),OY(NEQN)
C                AND ALPHA(12),OG(13),OW(12),GI(11),IV(10)
C   and defines
C      XOUT -- point at which solution is desired.
C   The remaining parameters are defined in  DSTEPS  and passed to
C   DINTP  from that subroutine
C
C   Output from  DINTP --
C
C      YOUT(*) -- solution at  XOUT
C      YPOUT(*) -- derivative of solution at  XOUT
C   The remaining parameters are returned unaltered from their input
C   values.  Integration with  DSTEPS  may be continued.
C
C***REFERENCES  H. A. Watts, A smoother interpolant for DE/STEP, INTRP
C                 II, Report SAND84-0293, Sandia Laboratories, 1984.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   840201  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DINTP
C
      INTEGER I, IQ, IV, IVC, IW, J, JQ, KGI, KOLD, KP1, KP2,
     1        L, M, NEQN
      DOUBLE PRECISION ALP, ALPHA, C, G, GDI, GDIF, GI, GAMMA, H, HI,
     1       HMU, OG, OW, OX, OY, PHI, RMU, SIGMA, TEMP1, TEMP2, TEMP3,
     2       W, X, XI, XIM1, XIQ, XOUT, Y, YOUT, YPOUT
C
      DIMENSION Y(*),YOUT(*),YPOUT(*),PHI(NEQN,16),OY(*)
      DIMENSION G(13),C(13),W(13),OG(13),OW(12),ALPHA(12),GI(11),IV(10)
C
C***FIRST EXECUTABLE STATEMENT  DINTP
      KP1 = KOLD + 1
      KP2 = KOLD + 2
C
      HI = XOUT - OX
      H = X - OX
      XI = HI/H
      XIM1 = XI - 1.D0
C
C   INITIALIZE W(*) FOR COMPUTING G(*)
C
      XIQ = XI
      DO 10 IQ = 1,KP1
        XIQ = XI*XIQ
        TEMP1 = IQ*(IQ+1)
 10     W(IQ) = XIQ/TEMP1
C
C   COMPUTE THE DOUBLE INTEGRAL TERM GDI
C
      IF (KOLD .LE. KGI) GO TO 50
      IF (IVC .GT. 0) GO TO 20
      GDI = 1.0D0/TEMP1
      M = 2
      GO TO 30
 20   IW = IV(IVC)
      GDI = OW(IW)
      M = KOLD - IW + 3
 30   IF (M .GT. KOLD) GO TO 60
      DO 40 I = M,KOLD
 40     GDI = OW(KP2-I) - ALPHA(I)*GDI
      GO TO 60
 50   GDI = GI(KOLD)
C
C   COMPUTE G(*) AND C(*)
C
 60   G(1) = XI
      G(2) = 0.5D0*XI*XI
      C(1) = 1.0D0
      C(2) = XI
      IF (KOLD .LT. 2) GO TO 90
      DO 80 I = 2,KOLD
        ALP = ALPHA(I)
        GAMMA = 1.0D0 + XIM1*ALP
        L = KP2 - I
        DO 70 JQ = 1,L
 70       W(JQ) = GAMMA*W(JQ) - ALP*W(JQ+1)
        G(I+1) = W(1)
 80     C(I+1) = GAMMA*C(I)
C
C   DEFINE INTERPOLATION PARAMETERS
C
 90   SIGMA = (W(2) - XIM1*W(1))/GDI
      RMU = XIM1*C(KP1)/GDI
      HMU = RMU/H
C
C   INTERPOLATE FOR THE SOLUTION -- YOUT
C   AND FOR THE DERIVATIVE OF THE SOLUTION -- YPOUT
C
      DO 100 L = 1,NEQN
        YOUT(L) = 0.0D0
 100    YPOUT(L) = 0.0D0
      DO 120 J = 1,KOLD
        I = KP2 - J
        GDIF = OG(I) - OG(I-1)
        TEMP2 = (G(I) - G(I-1)) - SIGMA*GDIF
        TEMP3 = (C(I) - C(I-1)) + RMU*GDIF
        DO 110 L = 1,NEQN
          YOUT(L) = YOUT(L) + TEMP2*PHI(L,I)
 110      YPOUT(L) = YPOUT(L) + TEMP3*PHI(L,I)
 120    CONTINUE
      DO 130 L = 1,NEQN
        YOUT(L) = ((1.0D0 - SIGMA)*OY(L) + SIGMA*Y(L)) +
     1             H*(YOUT(L) + (G(1) - SIGMA*OG(1))*PHI(L,1))
 130    YPOUT(L) = HMU*(OY(L) - Y(L)) +
     1                (YPOUT(L) + (C(1) + RMU*OG(1))*PHI(L,1))
C
      RETURN
      END
*DECK DINTRV
      SUBROUTINE DINTRV (XT, LXT, X, ILO, ILEFT, MFLAG)
C***BEGIN PROLOGUE  DINTRV
C***PURPOSE  Compute the largest integer ILEFT in 1 .LE. ILEFT .LE. LXT
C            such that XT(ILEFT) .LE. X where XT(*) is a subdivision of
C            the X interval.
C***LIBRARY   SLATEC
C***CATEGORY  E3, K6
C***TYPE      DOUBLE PRECISION (INTRV-S, DINTRV-D)
C***KEYWORDS  B-SPLINE, DATA FITTING, INTERPOLATION, SPLINES
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C     Written by Carl de Boor and modified by D. E. Amos
C
C     Abstract    **** a double precision routine ****
C         DINTRV is the INTERV routine of the reference.
C
C         DINTRV computes the largest integer ILEFT in 1 .LE. ILEFT .LE.
C         LXT such that XT(ILEFT) .LE. X where XT(*) is a subdivision of
C         the X interval.  Precisely,
C
C                      X .LT. XT(1)                1         -1
C         if  XT(I) .LE. X .LT. XT(I+1)  then  ILEFT=I  , MFLAG=0
C           XT(LXT) .LE. X                         LXT        1,
C
C         That is, when multiplicities are present in the break point
C         to the left of X, the largest index is taken for ILEFT.
C
C     Description of Arguments
C
C         Input      XT,X are double precision
C          XT      - XT is a knot or break point vector of length LXT
C          LXT     - length of the XT vector
C          X       - argument
C          ILO     - an initialization parameter which must be set
C                    to 1 the first time the spline array XT is
C                    processed by DINTRV.
C
C         Output
C          ILO     - ILO contains information for efficient process-
C                    ing after the initial call and ILO must not be
C                    changed by the user.  Distinct splines require
C                    distinct ILO parameters.
C          ILEFT   - largest integer satisfying XT(ILEFT) .LE. X
C          MFLAG   - signals when X lies out of bounds
C
C     Error Conditions
C         None
C
C***REFERENCES  Carl de Boor, Package for calculating with B-splines,
C                 SIAM Journal on Numerical Analysis 14, 3 (June 1977),
C                 pp. 441-472.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   800901  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DINTRV
C
      INTEGER IHI, ILEFT, ILO, ISTEP, LXT, MFLAG, MIDDLE
      DOUBLE PRECISION X, XT
      DIMENSION XT(*)
C***FIRST EXECUTABLE STATEMENT  DINTRV
      IHI = ILO + 1
      IF (IHI.LT.LXT) GO TO 10
      IF (X.GE.XT(LXT)) GO TO 110
      IF (LXT.LE.1) GO TO 90
      ILO = LXT - 1
      IHI = LXT
C
   10 IF (X.GE.XT(IHI)) GO TO 40
      IF (X.GE.XT(ILO)) GO TO 100
C
C *** NOW X .LT. XT(IHI) . FIND LOWER BOUND
      ISTEP = 1
   20 IHI = ILO
      ILO = IHI - ISTEP
      IF (ILO.LE.1) GO TO 30
      IF (X.GE.XT(ILO)) GO TO 70
      ISTEP = ISTEP*2
      GO TO 20
   30 ILO = 1
      IF (X.LT.XT(1)) GO TO 90
      GO TO 70
C *** NOW X .GE. XT(ILO) . FIND UPPER BOUND
   40 ISTEP = 1
   50 ILO = IHI
      IHI = ILO + ISTEP
      IF (IHI.GE.LXT) GO TO 60
      IF (X.LT.XT(IHI)) GO TO 70
      ISTEP = ISTEP*2
      GO TO 50
   60 IF (X.GE.XT(LXT)) GO TO 110
      IHI = LXT
C
C *** NOW XT(ILO) .LE. X .LT. XT(IHI) . NARROW THE INTERVAL
   70 MIDDLE = (ILO+IHI)/2
      IF (MIDDLE.EQ.ILO) GO TO 100
C     NOTE. IT IS ASSUMED THAT MIDDLE = ILO IN CASE IHI = ILO+1
      IF (X.LT.XT(MIDDLE)) GO TO 80
      ILO = MIDDLE
      GO TO 70
   80 IHI = MIDDLE
      GO TO 70
C *** SET OUTPUT AND RETURN
   90 MFLAG = -1
      ILEFT = 1
      RETURN
  100 MFLAG = 0
      ILEFT = ILO
      RETURN
  110 MFLAG = 1
      ILEFT = LXT
      RETURN
      END
*DECK DINTYD
      SUBROUTINE DINTYD (T, K, YH, NYH, DKY, IFLAG)
C***BEGIN PROLOGUE  DINTYD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DDEBDF
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (INTYD-S, DINTYD-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   DINTYD approximates the solution and derivatives at T by polynomial
C   interpolation. Must be used in conjunction with the integrator
C   package DDEBDF.
C ----------------------------------------------------------------------
C DINTYD computes interpolated values of the K-th derivative of the
C dependent variable vector Y, and stores it in DKY.
C This routine is called by DDEBDF with K = 0,1 and T = TOUT, but may
C also be called by the user for any K up to the current order.
C (see detailed instructions in LSODE usage documentation.)
C ----------------------------------------------------------------------
C The computed values in DKY are gotten by interpolation using the
C Nordsieck history array YH.  This array corresponds uniquely to a
C vector-valued polynomial of degree NQCUR or less, and DKY is set
C to the K-th derivative of this polynomial at T.
C The formula for DKY is..
C              Q
C  DKY(I)  =  Sum  C(J,K) * (T - TN)**(J-K) * H**(-J) * YH(I,J+1)
C             J=K
C where  C(J,K) = J*(J-1)*...*(J-K+1), Q = NQCUR, TN = TCUR, H = HCUR.
C The quantities  NQ = NQCUR, L = NQ+1, N = NEQ, TN, and H are
C communicated by common.  The above sum is done in reverse order.
C IFLAG is returned negative if either K or T is out of bounds.
C ----------------------------------------------------------------------
C
C***SEE ALSO  DDEBDF
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    DDEBD1
C***REVISION HISTORY  (YYMMDD)
C   820301  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DINTYD
C
      INTEGER I, IC, IER, IFLAG, IOWND, IOWNS, J, JB, JB2, JJ, JJ1,
     1      JP1, JSTART, K, KFLAG, L, MAXORD, METH, MITER, N, NFE,
     2      NJE, NQ, NQU, NST, NYH
      DOUBLE PRECISION C, DKY, EL0, H, HMIN, HMXI, HU, R, ROWND,
     1      ROWNS, S, T, TN, TP, UROUND, YH
      DIMENSION YH(NYH,*),DKY(*)
      COMMON /DDEBD1/ ROWND,ROWNS(210),EL0,H,HMIN,HMXI,HU,TN,UROUND,
     1                IOWND(14),IOWNS(6),IER,JSTART,KFLAG,L,METH,MITER,
     2                MAXORD,N,NQ,NST,NFE,NJE,NQU
C
C     BEGIN BLOCK PERMITTING ...EXITS TO 130
C***FIRST EXECUTABLE STATEMENT  DINTYD
         IFLAG = 0
         IF (K .LT. 0 .OR. K .GT. NQ) GO TO 110
            TP = TN - HU*(1.0D0 + 100.0D0*UROUND)
            IF ((T - TP)*(T - TN) .LE. 0.0D0) GO TO 10
               IFLAG = -2
C     .........EXIT
               GO TO 130
   10       CONTINUE
C
            S = (T - TN)/H
            IC = 1
            IF (K .EQ. 0) GO TO 30
               JJ1 = L - K
               DO 20 JJ = JJ1, NQ
                  IC = IC*JJ
   20          CONTINUE
   30       CONTINUE
            C = IC
            DO 40 I = 1, N
               DKY(I) = C*YH(I,L)
   40       CONTINUE
            IF (K .EQ. NQ) GO TO 90
               JB2 = NQ - K
               DO 80 JB = 1, JB2
                  J = NQ - JB
                  JP1 = J + 1
                  IC = 1
                  IF (K .EQ. 0) GO TO 60
                     JJ1 = JP1 - K
                     DO 50 JJ = JJ1, J
                        IC = IC*JJ
   50                CONTINUE
   60             CONTINUE
                  C = IC
                  DO 70 I = 1, N
                     DKY(I) = C*YH(I,JP1) + S*DKY(I)
   70             CONTINUE
   80          CONTINUE
C     .........EXIT
               IF (K .EQ. 0) GO TO 130
   90       CONTINUE
            R = H**(-K)
            DO 100 I = 1, N
               DKY(I) = R*DKY(I)
  100       CONTINUE
         GO TO 120
  110    CONTINUE
C
            IFLAG = -1
  120    CONTINUE
  130 CONTINUE
      RETURN
C     ----------------------- END OF SUBROUTINE DINTYD
C     -----------------------
      END
*DECK DIR
      SUBROUTINE DIR (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     +   IWORK)
C***BEGIN PROLOGUE  DIR
C***PURPOSE  Preconditioned Iterative Refinement Sparse Ax = b Solver.
C            Routine to solve a general linear system  Ax = b  using
C            iterative refinement with a matrix splitting.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      DOUBLE PRECISION (SIR-S, DIR-D)
C***KEYWORDS  ITERATIVE PRECONDITION, LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N, NELT, IA(NELT), JA(NELT), ISYM, ITOL, ITMAX
C     INTEGER  ITER, IERR, IUNIT, IWORK(USER DEFINED)
C     DOUBLE PRECISION B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N), DZ(N)
C     DOUBLE PRECISION RWORK(USER DEFINED)
C     EXTERNAL MATVEC, MSOLVE
C
C     CALL DIR(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE, ITOL,
C    $     TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer.
C         Order of the Matrix.
C B      :IN       Double Precision B(N).
C         Right-hand side vector.
C X      :INOUT    Double Precision X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Double Precision A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below,
C         for more details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         Y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X
C         upon return, X is an input vector, NELT is the number of
C         non-zeros in the SLAP IA, JA, A storage for the matrix A.
C         ISYM is a flag which, if non-zero, denotes that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R for
C         Z given R with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays).  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a double precision array
C         that can be used to pass necessary preconditioning information
C         and/or workspace to MSOLVE.  IWORK is an integer work array
C         for the same purpose as RWORK.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /DSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /DSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Double Precision.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Double Precision.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*D1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Matrix A is not positive definite.  (p,Ap) < 0.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Double Precision R(N).
C Z      :WORK     Double Precision Z(N).
C DZ     :WORK     Double Precision DZ(N).
C         Double Precision arrays used for workspace.
C RWORK  :WORK     Double Precision RWORK(USER DEFINED).
C         Double Precision array that can be used by  MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used by  MSOLVE.
C
C *Description:
C       The basic algorithm for iterative refinement (also known as
C       iterative improvement) is:
C
C            n+1    n    -1       n
C           X    = X  + M  (B - AX  ).
C
C           -1   -1
C       If M =  A then this  is the  standard  iterative  refinement
C       algorithm and the "subtraction" in the  residual calculation
C       should be done in double precision (which it is  not in this
C       routine).
C       If M = DIAG(A), the diagonal of A, then iterative refinement
C       is  known  as  Jacobi's  method.   The  SLAP  routine  DSJAC
C       implements this iterative strategy.
C       If M = L, the lower triangle of A, then iterative refinement
C       is known as Gauss-Seidel.   The SLAP routine DSGS implements
C       this iterative strategy.
C
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK)  in  some fashion.   The SLAP
C       routines DSJAC and DSGS are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first  in each "column") and are  stored in the  double pre-
C       cision array  A. In  other  words,  for each  column  in the
C       matrix  first put  the diagonal entry in A.  Then put in the
C       other non-zero  elements going  down the column  (except the
C       diagonal)  in order.  The IA array  holds the  row index for
C       each non-zero.  The JA array  holds the offsets into the IA,
C       A  arrays  for  the  beginning  of  each  column.  That  is,
C       IA(JA(ICOL)),A(JA(ICOL)) are the first elements of the ICOL-
C       th column in IA and A, and IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)
C       are  the last elements of the ICOL-th column.   Note that we
C       always have JA(N+1)=NELT+1, where N is the number of columns
C       in the matrix  and NELT  is the number  of non-zeros  in the
C       matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Examples:
C       See the SLAP routines DSJAC, DSGS
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  DSJAC, DSGS
C***REFERENCES  1. Gene Golub and Charles Van Loan, Matrix Computations,
C                  Johns Hopkins University Press, Baltimore, Maryland,
C                  1983.
C               2. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  D1MACH, ISDIR
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC and MSOLVE from ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed DSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of references.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C***END PROLOGUE  DIR
C     .. Scalar Arguments ..
      DOUBLE PRECISION ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT
C     .. Array Arguments ..
      DOUBLE PRECISION A(NELT), B(N), DZ(N), R(N), RWORK(*), X(N), Z(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      DOUBLE PRECISION BNRM, SOLNRM, TOLMIN
      INTEGER I, K
C     .. External Functions ..
      DOUBLE PRECISION D1MACH
      INTEGER ISDIR
      EXTERNAL D1MACH, ISDIR
C***FIRST EXECUTABLE STATEMENT  DIR
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      TOLMIN = 500*D1MACH(3)
      IF( TOL.LT.TOLMIN ) THEN
         TOL = TOLMIN
         IERR = 4
      ENDIF
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I) = B(I) - R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISDIR(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $     ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     $     IWORK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C         ***** iteration loop *****
C
      DO 100 K=1,ITMAX
         ITER = K
C
C         Calculate new iterate x, new residual r, and new
C         pseudo-residual z.
         DO 20 I = 1, N
            X(I) = X(I) + Z(I)
 20      CONTINUE
         CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
         DO 30 I = 1, N
            R(I) = B(I) - R(I)
 30      CONTINUE
         CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
C         check stopping criterion.
         IF( ISDIR(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $        ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     $        IWORK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C         Stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
C
 200  RETURN
C------------- LAST LINE OF DIR FOLLOWS -------------------------------
      END

program interpol
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	Interpolate (linearly) first axis of a cube onto another grid
  ! T.Forveille 30-June-1986
  !---------------------------------------------------------------------
  ! Local
  real, parameter :: eps=1.e-7
  !
  character(len=filename_length) :: namex,namey
  integer :: n, j,k,l,ier,new_size
  real(8) :: new_val,new_ref,new_inc
  real :: pix1,pixn
  logical :: error
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_inte('NX$',new_size,1)
  call gildas_dble('REFERENCE$',new_ref,1)
  call gildas_dble('VALUE$',new_val,1)
  call gildas_dble('INCREMENT$',new_inc,1)
  call gildas_close
  !
  n = len_trim(namey)
  if (n.eq.0) goto 100
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error, data=.false.)
  !
  ! Create Output file
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  n = len_trim(namex)
  if (n.eq.0) goto 100
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  x%gil%blan_words = 2
  !
  x%gil%dim(1) = new_size
  x%gil%inc(1) = new_inc
  x%gil%ref(1) = new_ref
  x%gil%val(1) = new_val
  !
  ! Adapt also x%gil%fres and x%gil%vres if needed.
  if (x%char%code(1).eq.'VELOCITY') then
    x%gil%vres=x%gil%inc(1)
    x%gil%voff=x%gil%val(1)
    x%gil%fres=-x%gil%inc(1)*x%gil%freq/299792.458d0
  endif
  !
  ! Check limits
  pix1 = y%gil%ref(1) + (x%gil%val(1) +   &
     &    (1.d0-x%gil%ref(1))*x%gil%inc(1) - y%gil%val(1))/y%gil%inc(1)
  pixn = y%gil%ref(1) + (x%gil%val(1) +   &
     &    (x%gil%dim(1)-x%gil%ref(1))*x%gil%inc(1) - y%gil%val(1))/y%gil%inc(1)
  if ( (pix1+eps).lt.1. .or. (pix1-eps).gt.y%gil%dim(1) .or.   &
     &    (pixn+eps).lt.1. .or. (pixn-eps).gt.y%gil%dim(1) ) then
    write(6,*) 'F-INTERPOLATE,  Extrapolation is forbidden'
    goto 100
  endif
  !
  call gdf_create_image(x,error)
  !
  if (error) then
    write(6,*) 'F-INTERPOLATE,  Cannot create output image'
    goto 100
  endif
  !
  allocate(x%r2d(x%gil%dim(1),x%gil%dim(2)), y%r2d(y%gil%dim(1),y%gil%dim(2)), stat=ier)
  !
  do l=1,x%gil%dim(4)
    x%blc(4) = l
    x%trc(4) = l
    do k=1,x%gil%dim(3)
      x%blc(3) = k
      x%trc(3) = k
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,y%r2d,error)
      do j=1,x%gil%dim(2)
        call interpolate(   &
     &          x%r2d(:,j),x%gil%dim(1),x%gil%inc(1),x%gil%ref(1),x%gil%val(1),   &
     &          y%r2d(:,j),y%gil%dim(1),y%gil%inc(1),y%gil%ref(1),y%gil%val(1))
      enddo
      call gdf_write_data(x,x%r2d,error)
    enddo
  enddo
  !
  call gagout('S-INTERPOLATE,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program interpol
!
subroutine interpolate(x,xdim,xinc,xref,xval,   &
     &    y,ydim,yinc,yref,yval)
  use gildas_def
  !---------------------------------------------------------------------
  ! LAS	Internal routine
  !	Performs the linear interpolation/integration
  ! Arguments:
  !	X	R*4(*)	Output spectrum
  !	XDIM	I*4	Output pixel number
  !	XINC	R*8	Output first axis increment
  !	XREF	R*8	Output first axis reference pixel
  !	XVAL	R*8	Output first axis value at reference pixel
  ! 	Y	R*4(*)	Input spectrum
  !  15-nov-1990 Correction R.L.
  !   (ne marchait pas dans le cas de l'interpolation ..)
  !---------------------------------------------------------------------
  integer(kind=index_length) :: xdim                   !
  real :: x(xdim)                   !
  real(8) :: xinc                    !
  real(8) :: xref                    !
  real(8) :: xval                    !
  integer(kind=index_length) :: ydim                   !
  real :: y(ydim)                   !
  real(8) :: yinc                    !
  real(8) :: yref                    !
  real(8) :: yval                    !
  ! Local
  integer :: i,imax,imin, j
  real(8) :: minpix, maxpix, pix, val, expand, ymax, ymin
  real :: scale
  !
  expand = abs(xinc/yinc)
  scale  = 1.0d0/(2.0d0*expand)
  do i = 1, xdim
    !
    ! Compute interval
    val = xval + (i-xref)*xinc
    pix = (val-yval)/yinc + yref
    maxpix = pix + 0.5d0*expand
    minpix = pix - 0.5d0*expand
    imin = int(minpix+1.0d0)
    imax = int(maxpix)
    if (imax.ge.imin) then
      ymin = y(imin-1)*(imin-minpix)+y(imin)*(minpix-imin+1)
      x(i) = (imin-minpix)*(ymin+y(imin))
      if (imax.gt.imin) then
        do j=imin, imax-1
          x(i) = x(i) + y(j)+y(j+1)
        enddo
      endif
      ymax = y(imax+1)*(maxpix-imax)+y(imax)*(imax+1-maxpix)
      x(i) = x(i) + (maxpix-imax)*(ymax+y(imax))
      x(i) = x(i)*scale
    else
      x(i) = y(imin-1)*(imin-pix) + y(imin)*(pix-imin+1)
    endif
  enddo
end subroutine interpolate

module ast_ephem
  !  Ephemeride computations, global parameters
  real(kind=8), parameter :: aukm=1.49597870d8   ! astronomical units to km conversion, IAU 1976
  real(kind=8), parameter :: mlt = 0.01230002d0  ! moon over earth mass ratio, IAU 1976 constant
  real(kind=8), parameter :: scale=1.D0/(1.d0+1D0/mlt)     ! 1 / (1+mt/ml)
  !
  !  Vector integration memory, defined in EPHSTA routine
  integer(kind=4), parameter :: ivect_out=0 ! out of Solar System
  integer(kind=4), parameter :: ivect_moon=1 ! MOON
  integer(kind=4), parameter :: ivect_sun=2 ! SUN
  integer(kind=4), parameter :: ivect_pla=3 ! PLANET
  !
  integer(kind=4) :: mvect, nvect         ! maximum number of component vectors
  parameter (mvect=4)          !
  logical :: vecdly(mvect)        ! indicate vector is computed at t-tau
  integer(kind=4) :: vecnum(mvect)        ! vector identification number in file
  real(kind=8) :: vecmul(mvect)         ! weight of each vector
  !!      common /vector/ vecmul, vecnum, vecdly, nvect
  !!      save /vector/
  !
  ! Stuff concerning the file vsop87.dat
  !
  integer(kind=4), parameter :: mfr=10000
  integer(kind=4), parameter :: mterm=8000
  integer(kind=4), parameter :: mbodies=10
  integer(kind=4), parameter :: mcoord=3
  integer(kind=4), parameter :: malpha=5
  integer(kind=4) ::  n_freq ! number of frequencies
  integer(kind=4) ::  n_term(mbodies,mcoord,0:malpha), i_rec_n_term ! number of terms for each series, and pointer
  integer(kind=4) ::  i_rec(mbodies,mcoord,0:malpha), i_rec_i_rec ! record number for each series, and pointer
  integer(kind=4) ::   i_rec_fr      ! record number for the list of frequencies
  integer(kind=4) ::   i_freq(mterm) ! frequency pointer for each term
  integer(kind=4) ::   elun=0   ! Logical unit number
  real(kind=8) :: efr(mfr)   ! frequencies
  real(kind=8) :: f(mterm), g(mterm), cs(mterm), ss(mterm)  ! cosine and sine term for each term
  !
  real(kind=8) :: oldtjj=-1.d30 ! A very old date to get started with...
  !
  !!      common /vsop/ fr, f, g, cs, ss, oldtjj,                                &
  !!     & n_freq,n_term,i_rec,i_rec_fr,i_freq,                                  &
  !!     & i_rec_i_rec, i_rec_n_term, lun
  !!      save /vsop/
end module ast_ephem
!
subroutine ephini(error)
  use gildas_def
  use gbl_format
  use gbl_message
  use gkernel_interfaces
  use ast_ephem
  !---------------------------------------------------------------------
  ! @ public
  ! Open direct access file of VSOP87 ephemeris.
  ! R. Lucas 29-apr-1994
  !---------------------------------------------------------------------
  logical, intent(out) :: error     !
  ! Local
  character(len=4) :: cfile
  character(len=256) :: file
  integer(kind=4) :: ier, irecord, nf, init(5)
  !
  if (elun.ne.0) return  ! Already done
  !
  error = sic_getlun (elun).ne.1
  if (error) return
  if (.not.sic_query_file('gag_ephemeris','data#dir:','',file)) then
    call astro_message(seve%f,'EPHINI','gag_ephemeris not found')
    error = .true.
    return
  endif
  nf = lenc(file)
  open(unit=elun,file=file(1:nf),form='unformatted', status='old',  &
       access='direct', recl=128*facunf, iostat = ier, action = 'read')
  if (ier.ne.0) then
    call sic_frelun(elun)
    call putios('F-VSOP87,  ',ier)
    error = .true.
    return
  endif
  read(elun,rec=1) cfile
  !
  call eph_convert (cfile)
  !
  irecord = 1
  ! one reads 5 numbers now ...
  call readi4(elun,irecord,5,init,error)
  if (error) return
  i_rec_n_term = init(2)
  i_rec_i_rec = init(3)
  i_rec_fr = init(4)
  n_freq = init(5)
  irecord = i_rec_n_term
  call readi4(elun,irecord,180,n_term,error)
  if (error) return
  irecord = i_rec_i_rec
  call readi4(elun,irecord,180,i_rec,error)
  if (error) return
  irecord = i_rec_fr
  call readr8(elun,irecord,n_freq,efr,error)
end subroutine ephini
!
subroutine ephclose(error)
  use gkernel_interfaces
  use ast_ephem
  !---------------------------------------------------------------------
  ! @ public
  ! Close the ephemeris file and free its logical unit
  !---------------------------------------------------------------------
  logical, intent(inout) :: error   !
  ! Local
  integer(kind=4) :: ier
  !
  close(unit=elun,iostat=ier)
  if (ier.ne.0)  error = .true.
  !
  ier = gag_frelun(elun)
  if (ier.ne.0)  error = .true.
  !
end subroutine ephclose
!
subroutine vsop87(tjj,ico,ider,prec,r,error)
  use gildas_def
  use gbl_message
  use ast_ephem
  !---------------------------------------------------------------------
  ! @ private
  ! Compute object position and velocities from VSOP87 ephemeris.
  !
  ! ICO    1 - 8 = Mercury to Neptune, relative to Sun
  !            9 = Earth/Moon barycenter, relative to Sun
  !           10 = Sun, relative to Solar system barycenter
  ! R(3,0:IDER) position (1-3) vector and derivatives (in au, au/day, au/day**2)
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: tjj          ! Julian date
  integer(kind=4), intent(in)    :: ico          ! Body identifier
  integer(kind=4), intent(in)    :: ider         ! Number of derivatives to compute (0 to 2)
  real(kind=8),    intent(in)    :: prec         ! Precision 0 to 0.01; 0 is maximal precision
  real(kind=8),    intent(out)   :: r(3,0:ider)  ! Position vector and derivatives
  logical,         intent(inout) :: error        !
  ! Local
  character(len=*), parameter :: rname='VSOP'
  character(len=filename_length) :: vsopname
  character(len=message_length) :: mess
  real(kind=8) :: dga(mbodies), t(-2:5), t2000, a1000, q, a, p, f0, f1
  integer(kind=4) :: i, iv, it, ntt, irecord, if, id, j
  ! Data
  data dga/0.3871d0, 0.7233d0, 1.d0, 1.5237d0, 5.2026d0, 9.5547d0,  &
           19.2181d0, 30.1096d0, 0.01d0, 1.d0/
  data t /2*0.d0, 1.d0, 5*0.d0/
  data t2000 /2451545.d0/
  data a1000 /365250.d0/
  !
  ! Sanity check
  if (ico.lt.0 .or. ico.gt.mbodies) then
    write(mess,'(a,i0)')  'Invalid body id. #',ico
    call astro_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Reset the cosines if time has changed.
  if (oldtjj.ne.tjj) then
    do i=1, mterm
      cs(i) = 3.
    enddo
    oldtjj = tjj
  endif
  id = max(0,min(2,ider))
  !
  do i=1, 3
    do j= 0, id
      r(i,j) = 0
    enddo
  enddo
  t(1) = (tjj - t2000) / a1000
  do it=2, 5
    t(it) = t(1)*t(it-1)
  enddo
  if (prec.lt.0.d0 .or. prec.gt.1d-2) then
    error = .true.
    return
  endif
  q = max(3.d0,-log10(prec+1d-50))
  !
  do iv=1, 3
    do it = 0, 5
      p = prec*dga(ico)/10.d0/(q-2)/  &
          (abs(t(it))+it*abs(t(it-1))*1.d-4+1.d-50)
      ntt = n_term(ico,iv,it)
      if (ntt.gt.0) then
        irecord = i_rec(ico,iv,it)
        call readi4(elun,irecord,ntt,i_freq,error)
        if (error) then
          inquire(unit=elun,name=vsopname)
          write (mess,'(a,1x,a,1x,i0,1x,i0)') 'Error reading',trim(vsopname),irecord,ntt
          call astro_message(seve%e,rname,mess)
          return
        endif
        call readr8(elun,irecord,ntt,f,error)
        if (error) then
          inquire(unit=elun,name=vsopname)
          write (mess,'(a,1x,a,1x,i0,1x,i0)') 'Error reading',trim(vsopname),irecord,ntt
          call astro_message(seve%e,rname,mess)
          return
        endif
        call readr8(elun,irecord,ntt,g,error)
        if (error) then
          inquire(unit=elun,name=vsopname)
          write (mess,'(a,1x,a,1x,i0,1x,i0)') 'Error reading',trim(vsopname),irecord,ntt
          call astro_message(seve%e,rname,mess)
          return
        endif
        p = p*p
        a = 2*p
        i = 1
        do while (i.le.ntt .and. a.ge.p)
          a = f(i)**2+g(i)**2
          if = i_freq(i)
          if (cs(if).gt.2) then
            cs(if) = cos(efr(if)*t(1))
            ss(if) = sin(efr(if)*t(1))
          endif
          f0 = f(i)*cs(if)+g(i)*ss(if)
          r(iv,0) = r(iv,0) + f0*t(it)
          if (id.ge.1) then
            f1 = -f(i)*ss(if)+g(i)*cs(if)
            r(iv,1) = r(iv,1) + f0*it*t(it-1) + f1*efr(if)*t(it)
          endif
          if (id.ge.2) then
            r(iv,2) = r(iv,2) + f0*(it*(it-1)*t(it-2)-efr(if)**2 *t(it)) +  &
            2*f1*efr(if)*it*t(it-1)
          endif
          i = i+1
        enddo
      endif
    enddo
  enddo
  if (id.eq.0) return
  do j=1,id
    do i=1,3
      r(i,j) = r(i,j) /a1000**j
    enddo
  enddo
end subroutine vsop87
!
subroutine readr8(lun,irecord,nw,w,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Read NW words starting at direct access record IRECORD on file LUN
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun
  integer(kind=4), intent(inout) :: irecord
  integer(kind=4), intent(in)    :: nw
  real(kind=8),    intent(out)   :: w(nw)
  logical,         intent(inout) :: error
  ! Local
  real(kind=8) :: buffer(64)
  integer(kind=4) :: iw, nrec, i, ier
  !
  iw = 1
  nrec = nw/64
  if (nrec.ge.1) then
    do i=1, nrec
      read(lun,rec=irecord,err=999,iostat=ier) buffer
      irecord = irecord+1
      call eph_convert_r8 (buffer,w(iw),64)
      iw = iw + 64
    enddo
  endif
  read(lun,rec=irecord,err=999,iostat=ier) buffer
  irecord = irecord+1
  call eph_convert_r8 (buffer,w(iw),nw-iw+1)
  return
  !
  999   call putios('F-VSOP87,  ',ier)
  error = .true.
end subroutine readr8
!
subroutine readi4(lun,irecord,nw,w,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Read NW words starting at direct access record IRECORD on file LUN
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun
  integer(kind=4), intent(inout) :: irecord
  integer(kind=4), intent(in)    :: nw
  integer(kind=4), intent(out)   :: w(nw)
  logical,         intent(inout) :: error
  ! Local
  integer(kind=4) :: buffer(128), iw, nrec, i, ier
  !
  iw = 1
  nrec = nw/128
  if (nrec.ge.1) then
    do i=1, nrec
      read(lun,rec=irecord,err=999,iostat=ier) buffer
      irecord = irecord+1
      call eph_convert_i4 (buffer,w(iw),128)
      iw = iw + 128
    enddo
  endif
  read(lun,rec=irecord,err=999,iostat=ier) buffer
  irecord = irecord+1
  call eph_convert_i4 (buffer,w(iw),nw-iw+1)
  return
  !
  999   call putios('F-VSOP87,  ',ier)
  error = .true.
end subroutine readi4
!
subroutine eph_convert(cfile)
  use gkernel_interfaces
  use gbl_convert
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: cfile          !
  ! Local
  character(len=4) :: csyst
  integer(kind=4) :: nw, w(*), buffer(*)
  !
  integer(kind=4) :: conve
  !
  save conve
  !
  call gdf_getcod  (csyst)
  call gdf_convcod (cfile,csyst,conve)
  return
  !
entry eph_convert_i4 (buffer,w,nw)
  !
  if (conve.eq.vax_to_ieee .or. conve.eq.vax_fr_ieee) then
    call r4tor4(buffer,w,nw)
  elseif (conve.eq.ieee_to_vax .or. conve.eq.ieee_fr_vax) then
    call r4tor4(buffer,w,nw)
  elseif (conve.eq.vax_to_eeei .or. conve.eq.vax_fr_eeei) then
    call vai4ei(buffer,w,nw)
  elseif (conve.eq.ieee_to_eeei .or. conve.eq.ieee_fr_eeei) then
    call iei4ei(buffer,w,nw)
  elseif (conve.eq.eeei_to_vax .or. conve.eq.eeei_fr_vax) then
    call eii4va(buffer,w,nw)
  elseif (conve.eq.eeei_to_ieee .or. conve.eq.eeei_fr_ieee) then
    call eii4ie(buffer,w,nw)
  else
    call r4tor4(buffer,w,nw)
  endif
  return
  !
entry eph_convert_r8 (buffer,w,nw)
  if (conve.eq.vax_to_ieee .or. conve.eq.vax_fr_ieee) then
    call var8ie(buffer,w,nw)
  elseif (conve.eq.ieee_to_vax .or. conve.eq.ieee_fr_vax) then
    call ier8va(buffer,w,nw)
  elseif (conve.eq.vax_to_eeei .or. conve.eq.vax_fr_eeei) then
    call var8ei(buffer,w,nw)
  elseif (conve.eq.ieee_to_eeei .or. conve.eq.ieee_fr_eeei) then
    call ier8ei(buffer,w,nw)
  elseif (conve.eq.eeei_to_vax .or. conve.eq.eeei_fr_vax) then
    call eir8va(buffer,w,nw)
  elseif (conve.eq.eeei_to_ieee .or. conve.eq.eeei_fr_ieee) then
    call eir8ie(buffer,w,nw)
  else
    call r8tor8(buffer,w,nw)
  endif
  return
end subroutine eph_convert
!
subroutine ephsta (vector,planet,error)
  use gildas_def
  use gbl_message
  use ast_ephem
  !---------------------------------------------------------------------
  ! @ private
  !  Define vector to compute
  ! two separate calls EPHSTA and EPHVEC are kept for compatibility.
  !---------------------------------------------------------------------
  integer(kind=4) :: vector         ! vector description code
  integer(kind=4) :: planet         ! object identification
  logical :: error                  !
  ! Local
  integer(kind=4) :: i
  integer(kind=4) :: object_vsop(9)
  character(len=message_length) :: mess
  !  Planets are strangely numbered in AstrO ...
  data object_vsop /0,0,1,2,4,5,6,7,8/
  !
  !  here S, T, P, B, and G are the Sun, Earth, Planet, Earth-Moon Barycenter
  !     and The Solar System Barycenter.
  !  We have available in VSOP87, the vectors ST, SP... , SB, and GS
  !  ' means argument is t-tau
  !  Case 0 (Object out of the solar system, assumed distance : infinite)
  !       Vector = -GS-ST		     Earth - Sun - Solar System Barycenter
  !  Case 1 (Object = Moon)
  !  	Vector = (SB-ST)*(1+mT/mM)   Earth - Moon
  ! Note : moon is approximate: errors mult. by approx 100.
  !  Case 2 (Object = Sun)
  !  	Vector = GS'-GS-ST                 Earth - Sun
  !  Case 3 (Object = Planet)
  !  	Vector = GS'+SP'-GS-ST               Earth - Sun - Planet
  !  Computation of vectors (unit = km), using BDL82 ephemerides
  !      TB = TL / (1+MT/ML)
  !      BS = -SB
  !----------------------------------------------------------------------
  !  Initialize memories
  do i = 1, mvect
    vecnum(i) = 0
    vecmul(i) = 0.d0
    vecdly(i) = .false.
  enddo
  !  Set weights and indices according to object
  if (vector.eq.ivect_out) then        ! Object out of solar system
    nvect = 2
    vecnum(1) = 10             ! -GS
    vecmul(1) = -1.d0
    vecnum(2) = 3              ! -ST
    vecmul(2) = -1.d0
  elseif (vector.eq.ivect_moon) then
    nvect = 2
    vecnum(1) = 9              ! SB*(1+ml/mt)
    vecmul(1) = 1.d0/scale
    vecnum(2) = 3              ! -ST*(1+ml/mt)
    vecmul(2) = -1d0/scale
  elseif (vector.eq.ivect_sun) then
    nvect = 3
    vecnum(1) = 10             ! GS'
    vecmul(1) = 1.d0
    vecdly(1) = .true.
    vecnum(2) = 10             ! -GS
    vecmul(2) = -1.d0
    vecnum(3) = 3              ! -ST
    vecmul(3) = -1.d0
  elseif (vector.eq.ivect_pla) then
    nvect = 4
    vecnum(1) = object_vsop(planet)    ! SP'
    vecmul(1) = 1.d0
    vecdly(1) = .true.
    vecnum(2) = 10             ! GS'
    vecmul(2) = 1.d0
    vecdly(2) = .true.
    vecnum(3) = 10             ! -GS
    vecmul(3) = -1.d0
    vecnum(4) = 3              ! -ST
    vecmul(4) = -1.d0
  else
    write(mess,*) 'Invalid vector ',vector
    call astro_message(seve%e,'EPHSTA',mess)
    error = .true.
    return
  endif
end subroutine ephsta
!
subroutine ephvec (jdate,deriv,rvec,error)
  use gildas_def
  use gbl_message
  use ast_ephem
  !---------------------------------------------------------------------
  ! @ private
  !  Compute position vector and derivatives at given date
  !---------------------------------------------------------------------
  real(kind=8)           :: jdate            ! julian date of computation
  integer(kind=4)        :: deriv            ! number of derivatives needed (if position only, DERIV = 0)
  real(kind=8)           :: rvec(3,0:deriv)  ! resulting vectors
  logical, intent(inout) :: error            !
  ! Local
  integer(kind=4) :: i,j,k                ! indexes
  real(kind=8) :: val(3,0:2), rtim(3,0:2), rdel(3,0:2), tau, tau1, dtau, c
  parameter (c=299792.458d0)
  logical :: delay
  character(len=message_length) :: mess
  !----------------------------------------------------------------------
  !  Initialization
  if (deriv.lt.0 .or. deriv.gt.2) then
    write(mess,*) 'DERIV out of range ',deriv
    call astro_message(seve%e,'EPHVEC',mess)
    error = .true.
    return
  endif
  do j=0,2
    do i=1,3
      rtim(i,j) = 0.d0
      rdel(i,j) = 0.d0
    enddo
  enddo
  !
  ! start with undelayed vector
  delay = .false.
  do k=1,nvect
    call vsop87(jdate,vecnum(k),2,0d0,val,error)
    if (error) return
    do j=0, 2
      do i=1,3
        val(i,j) = val(i,j)*aukm/86400d0**j
        if (vecdly(k)) then
          rdel(i,j) = rdel(i,j)+val(i,j)*vecmul(k)
          delay = .true.
        else
          rtim(i,j) = rtim(i,j)+val(i,j)*vecmul(k)
        endif
      enddo
    enddo
  enddo
  !
  ! Compute delay = tau, not tested ...
  delay = .false.
  if (delay) then
    tau = 0
    dtau = 1e35
    do while (dtau.gt.1d-8)
      tau1 = 0
      do i=1,3
        rvec(i,0) = rtim(i,0)+rdel(i,0) - tau*rdel(i,1) + tau**2/2.d0*rdel(i,2)
        tau1 = tau1 + rvec(i,0)**2
      enddo
      tau1 = sqrt(tau1)/c
      dtau = abs(tau1-tau)
      tau = tau1
      write(6,*) 'tau, dtau'
      write(6,*) tau, dtau
    enddo
    do i=1, 3
      if (deriv.ge.1) then
        rvec(i,1) = rtim(i,1) + rdel(i,1)-tau*rdel(i,2)
      endif
      if (deriv.ge.2) then
        rvec(i,2) = rtim(i,2) + rdel(i,2)
      endif
    enddo
  else
    do j=0, deriv
      do i=1, 3
        rvec(i,j) = rtim(i,j) + rdel(i,j)
      enddo
    enddo
  endif
  error = .false.
end subroutine ephvec

subroutine greg_point(line,error)
  use greg_dependencies_interfaces, no_interface1=>gr8_minmax
  use greg_interfaces, except_this=>greg_point,  &
                       no_interface2=>find_blank8
  use gildas_def
  use sic_types
  use greg_kernel
  use greg_xyz
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    POINTS [Array__X Array__Y]
  ! 1    [/BLANKING [Bval [Eval]]]
  ! 2    [/SIZE MaxVal [Array__Z [Expo]]]
  ! 3    [/MARKER]
  !
  !  Draw markers of current style and size. If MaxVal is given, draws
  ! symbols of current style but of size proportional to Z value at
  ! positions (X,Y). The current marker size corresponds to points with
  ! value MaxVal.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='POINTS'
  real(kind=8) :: zmax,zmin,bval,eval
  real(kind=4) :: zfact,expo
  integer(kind=address_length) :: xaddr,yaddr,zaddr,nsi_addr,ist_addr
  type(sic_descriptor_t) :: xinca,yinca,zinca,nsi_inca,ist_inca
  integer(kind=4) :: form,narg
  integer(kind=size_length) :: ixy,is,ne,in,nmin,nmax
  logical :: same_marker,optsize
  !
  save xinca,yinca,zinca,nsi_inca,ist_inca
  !
  ! Initialise
  ixy = 0
  !
  ! Blanking ?
  eval = eblank
  call sic_r8 (line,1,2,eval,.false.,error)
  if (error) return
  bval = cblank
  call sic_r8 (line,1,1,bval,.false.,error)
  if (error) return
  !
  ! Z scaling ?
  optsize = sic_present(2,0)
  if (optsize) then
    call sic_r4 (line,2,1,zfact,.true.,error)
    if (error) return
  else
    zfact = -1.0
  endif
  expo = 0.5
  call sic_r4 (line,2,3,expo,.false.,error)
  if (error) return
  !
  ! Check on which variable
  narg = sic_narg(0)
  if (narg.eq.2 .or. narg.eq.0) then
    form = fmt_r8
    call get_incarnation('POINTS',line,form,ixy,xinca,yinca,error)
    if (error) return
    xaddr = gag_pointer(xinca%addr,memory)
    yaddr = gag_pointer(yinca%addr,memory)
    if (optsize) then
      if (sic_present(2,2)) then
        call get_same_inca ('POINTS',line,2,2,form,ixy,zinca,error)
      else
        call greg_message(seve%w,rname,'Using Z array')
        call get_greg_inca ('POINTS','Z',form,ixy,zinca,error)
      endif
      if (error) then
        call sic_volatile(xinca)
        call sic_volatile(yinca)
        return
      endif
      zaddr = gag_pointer(zinca%addr,memory)
    endif
  else
    call greg_message(seve%e,rname,'Two arguments or none')
    error = .true.
    return
  endif
  !
  ! If no points, exit
  if (ixy.lt.1) goto 10
  !
  ! Variable marker style?
  if (sic_present(3,0)) then
    narg = sic_narg(3)
    if (narg.eq.2) then
      form = fmt_i4
      call get_same_inca ('POINTS',line,3,1,form,ixy,nsi_inca,error)
      call get_same_inca ('POINTS',line,3,2,form,ixy,ist_inca,error)
      if (error) then
        call sic_volatile(xinca)
        call sic_volatile(yinca)
        call sic_volatile(zinca)
        call sic_volatile(nsi_inca)
        return
      endif
      nsi_addr = gag_pointer(nsi_inca%addr,memory)
      ist_addr = gag_pointer(ist_inca%addr,memory)
    else
      call greg_message(seve%e,rname,'Two arguments required for option '//  &
      '/MARKER')
      error = .true.
      return
    endif
    same_marker = .false.
  else
    nsi_addr = gag_pointer(locwrd(nsides),memory)
    ist_addr = gag_pointer(locwrd(istyle),memory)
    same_marker = .true.
  endif
  !
  ! Scale marker size
  if (optsize) then
    if (zfact.eq.0.) then
      call gr8_minmax (ixy,memory(zaddr),0.d0,-1.d0,zmin,zmax,nmin,nmax)
      zfact = max(abs(zmax),abs(zmin))
    endif
    zfact = abs (csymb / zfact**expo)
  endif
  !
  if (eval.lt.0.0d0) then
    ! Blanking is off if eval is negative (i.e. blanking is disabled)
    call points(memory(nsi_addr),memory(ist_addr),zfact,expo,memory(xaddr),  &
      memory(yaddr),memory(zaddr),ixy,same_marker)
    !
  else
    ! With blanking, applied to Y or Z array
    in = 1
    do while (in.ne.0)
      if (optsize) then
        call find_blank8(memory(zaddr),bval,eval,ixy,is,ne,in)
      else
        call find_blank8(memory(yaddr),bval,eval,ixy,is,ne,in)
      endif
      if (ne.gt.0)  &
        call points(memory(nsi_addr),memory(ist_addr),zfact,expo,  &
          memory(xaddr+2*(is-1)),memory(yaddr+2*(is-1)),memory(zaddr+2*(is-1)),  &
          ne,same_marker)
    enddo
  endif
  !
10 continue
  call sic_volatile(xinca)
  call sic_volatile(yinca)
  if (zfact.ge.0) call sic_volatile(zinca)
end subroutine greg_point

subroutine run_flux (line,comm,error)
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  !
  if (comm.eq.'FILE') then
    call flux_file (line,error)
  elseif (comm.eq.'READ') then
    call flux_read (line,error)
  elseif (comm.eq.'SOLVE') then
    call flux_solve (line,error)
  elseif (comm.eq.'PRINT') then
    call flux_print (line,error)
  elseif (comm.eq.'INDEX') then
    call flux_index (line,error)
  else
    write(6,*) 'E-FLUX,  No code for ',comm
  endif
end subroutine run_flux
!
subroutine load_flux
  ! Global
  external :: run_flux
  logical, external :: gr_error
  ! Local
  integer :: mflux
  parameter (mflux=6)
  character(len=12) :: cflux(mflux)
  logical :: error
  data cflux/   &
     &    ' FILE', ' INDEX', '/OUTPUT',   &
     &    ' PRINT', ' READ', ' SOLVE'/
  !
  error = gr_error()
  call sic_begin('FLUX','GAG_HELP_FLUX',mflux,cflux,   &
     &    '1.1-00  20-FEB-1995  A.Dutrey',run_flux,gr_error)
end subroutine load_flux

subroutine fits_gildas(line,error)
  use gildas_def
  use image_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fits_gildas
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command
  !   FITS File.fits FROM File.gdf /STYLE [/HDU Number] /CHECK /OVERWRITE
  !   FITS File.fits TO File.gdf   /STYLE /BITS /BLC /TRC /OVERWRITE
  !
  ! Internal FITS_GILDAS or GILDAS_FITS conversion.
  ! Allow unrecognized FITS keyword handling, either by Symbol translation
  ! or by user input.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=filename_length) :: gildas_file,fits_file
  character(len=12) :: key,style
  character(len=80) :: chain
  integer(kind=index_length) :: blc(gdf_maxdims),trc(gdf_maxdims)
  integer(kind=4) :: ng,nh,nc,nbit,ncom,ikey,hdunum
  logical :: check,overwrite
  character(len=16) :: argum,comm
  integer(kind=4), parameter :: nbit_def=-32  ! Default BITPIX
  integer(kind=4), parameter :: mway=2,mstyle=5
  character(len=4), parameter :: ways(mway) = (/ 'TO  ','FROM' /)
  character(len=15), parameter :: styles(mstyle) =  (/ 'STANDARD       ',  &
    'UVFITS         ','AIPSFITS       ', 'SORTED_AIPSFITS','CASA_UVFITS    ' /)
  ! Options to command:
  integer(kind=4), parameter :: optbits=1
  integer(kind=4), parameter :: optstyl=2
  integer(kind=4), parameter :: opthdu =3
  integer(kind=4), parameter :: optchec=4
  integer(kind=4), parameter :: optblc =5
  integer(kind=4), parameter :: opttrc =6
  integer(kind=4), parameter :: optover=7
  !
  ! Arguments
  call sic_ch(line,0,1,fits_file,nh,.true.,error)
  if (error) return
  if (sic_narg(0).eq.1) then
    ! Only a FITS file name as argument: list its contents and leave
    call gfits_list_hdus(fits_file,error)
    return  ! Always
  endif
  call sic_ke(line,0,2,argum,nc,.true.,error)
  if (error) return
  call sic_ambigs(rname,argum,key,ikey,ways,mway,error)
  if (error) return
  call sic_ch(line,0,3,gildas_file,ng,.true.,error)
  if (error) return
  !
  ! Options
  check = sic_present(optchec,0)
  overwrite = sic_present(optover,0)
  !
  style = ' '  ! Empty means guess style
  if (sic_present(optstyl,1)) then
    call sic_ke(line,optstyl,1,argum,nc,.true.,error)
    if (error)  return
    call sic_ambigs(rname,argum,comm,ncom,styles,mstyle,error)
    if (error) return
    style = comm
  endif
  !
  select case (key)
  case ('TO')  ! FITS --> GILDAS
    ! BLC/TRC
    call parse_blctrc('BLC',optblc,blc,error)
    if (error)  return
    call parse_blctrc('TRC',opttrc,trc,error)
    if (error)  return
    !
    ! /HDU
    hdunum = 1  ! Primary by default
    call sic_i4(line,opthdu,1,hdunum,.false.,error)
    if (error)  return
    !
    call fits_gildas_sub(fits_file,gildas_file,style,blc,trc,hdunum,check,  &
      overwrite,error,sic_getsymbol,sic_wpr)
    !
  case ('FROM')  ! GILDAS --> FITS
    if (sic_present(optblc,0) .or. sic_present(opttrc,0)) then
      chain = 'Options /BLC or /TRC not supported in this direction'
      call sic_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    if (sic_present(opthdu,0)) then
      chain = 'Option /HDU not supported in this direction'
      call sic_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    nbit = nbit_def
    call sic_i4(line,optbits,1,nbit,.false.,error)
    if (error)  return
    if (nbit.ne.16 .and. nbit.ne.32 .and. nbit.ne.-32 .and. nbit.ne.-64) then
      write(chain,'(A,I0)') 'Invalid number of bits ',nbit
      call sic_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    !
    call gildas_fits_sub(gildas_file,fits_file,style,nbit,overwrite,error)
  end select
  !
contains
  subroutine parse_blctrc(what,optnum,corn,error)
    character(len=*),           intent(in)    :: what
    integer(kind=4),            intent(in)    :: optnum
    integer(kind=index_length), intent(out)   :: corn(:)
    logical,                    intent(inout) :: error
    ! Local
    integer(kind=4) :: i,n
    !
    corn(:) = 0
    if (.not.sic_present(optnum,0))  return
    !
    n = sic_narg(optnum)
    if (n.gt.gdf_maxdims) then
      write(chain,'(A,A,2X,I0,A,I0)')  &
        'Too many values for ',what,n,' > ',gdf_maxdims
      call sic_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    do i=1,n
      call sic_i0(line,optnum,i,corn(i),.true.,error)
      if (error) return
    enddo
  end subroutine parse_blctrc
  !
end subroutine fits_gildas

!-----------------------------------------------------------------------
! API to plot/list NOEMA/POLYFIX frequency coverage from outside ASTRO
! 3 subroutines must be called 
! The first 2 fill in the astro_noemasetup_t structure (define in astro/lib/types.f90)
!       astro_noemasetup_receiver() to transfer tuning and some source information (1 call)
!                                   (fills astro_noemareceiver_t)
!       astro_noemasetup_spw() to transfer polyfix configuration (1 call / SPW) 
!                              (fills astro_noemaspw_t)
! The last procedure can be:
! astro_noemasetup_plot() to do the plot (arguments can be used to customize the layout, see below)
! OR
! astro_noemasetup_list() to do the list ast LIST command in ASTRO
!-----------------------------------------------------------------------
!
subroutine astro_noemasetup_plot(rname,isetup,iplotmode,iupperaxis,showlines,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_noemasetup_plot
  use astro_noema_type
  !-----------------------------------------------------------------------
  ! @ public
  ! Plot a NOEMA receiver\backend setup as done in ASTRO
  !
  ! input:
  ! isetup: import structure filled in by 2 public subroutines:
  !       astro_noemasetup_receiver to transfer tuning/source information (1 call)
  !       astro_noemasetup_spw to transfer polyfix configuration (1 call / SPW)
  !
  ! Plot can be configured with:
  ! plotmode (integer*4):  pm+* defined in astro_types module
  !    pm_basebands=1= BASEBANDS = 4 boxes (H/V)LO, (H/V)LI, (H/V)UI, (H/V)UO
  !                               chunk limits are drawn
  !    pm_receiver=2= RECEIVER = 3 boxes (H/V)-USB, (H/V)-LSB, Global receiver band
  !                               chunk limits are not drawn
  ! iupperaxis (integer*4): choice for upper axis (lower axis is always REST)
  !     freqax_* defined in astro_types
  !     freqax_rest,freqax_rf, _lsr, _if1, _if2,_chunks,_imrest, _imrf, _imrf,_imlsr, _null
  !
  ! showline (logical): if .true. the catalog lines are indicated on the plot
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemasetup_t), intent(in) :: isetup    ! import structure
  integer(kind=4), intent(in) :: iplotmode     ! BASEBANDS or RECEIVER
  integer(kind=4), intent(in) :: iupperaxis
  logical, intent(in) :: showlines
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: noemamode='ONLINE'
  type(noema_t) :: lnoema
  type(plot_molecules_t) :: molecules
  type(current_boxes_t) :: cplot
  type(frequency_axis_t) :: freq_axis
  integer(kind=4) :: userns,useris,i
  real(kind=4) :: usersize
  !
  !Define receiver parameters
  call rec_define_noema(lnoema%recdesc,noemamode,error)
  if (error) return
  !Reset tuning parameters
  lnoema%cfebe%defined=.false.
  lnoema%cfebe%rectune%name = ''
  lnoema%cfebe%rectune%iband = 0
  lnoema%cfebe%rectune%flo1 = 0
  lnoema%cfebe%rectune%flotune = 0
  lnoema%cfebe%rectune%frest = 0
  lnoema%cfebe%rectune%frf = 0
  lnoema%cfebe%rectune%flsr = 0
  lnoema%cfebe%rectune%fcent = 0
  lnoema%cfebe%rectune%label = ''
  lnoema%cfebe%rectune%ongrid = .false.
  lnoema%recdesc%redshift = .false. ! does NOT takes into accound source redshift (call from the OBS)
  ! As a result the LO check must take into account the 100MHz tolerance (for doppler)
  do i=1,lnoema%recdesc%n_rbands
    lnoema%recdesc%lolim(1,i)=lnoema%recdesc%lolim(1,i)-lnoema%recdesc%lotol
    lnoema%recdesc%lolim(2,i)=lnoema%recdesc%lolim(2,i)+lnoema%recdesc%lotol
  enddo
  !
  call rec_define_noema_ifproc(lnoema%cfebe%i_f%ifproc,error)
  if (error) return
  !
  ! Tuning and source information
  call noema_external_tuning(rname,isetup%rec,lnoema,error)
  if (error) return
  !
  !SPW configuration
  call noema_external_spw(rname,isetup%spw,lnoema,error)
  if (error) return
  !
  freq_axis%main=trim(freqax_names(freqax_rest))
  if (iupperaxis.le.0.or.iupperaxis.gt.m_freqax) then
    call astro_message(seve%e,rname,'Problem with decoding frequency axis')
    error=.true.
    return
  endif
  freq_axis%second=trim(freqax_names(iupperaxis))
  molecules%doplot=showlines
  molecules%catalog='gag_data:molecules.dat'
  !
  ! Get current marker characteristiacs
  call gr_get_marker(userns,useris,usersize)
  ! Do the PLOT
  if (iplotmode.eq.pm_basebands) then
    call noema_plot_selpfx(rname,lnoema,cplot,molecules,freq_axis,error)
    if (error) return
  else if (iplotmode.eq.pm_receiver) then
    call rec_plot_sidebands(lnoema%recdesc,lnoema%source,lnoema%cfebe%rectune & 
                            ,cplot,molecules,freq_axis,error)
    if (error) return
    call noema_draw_summary(lnoema,cplot,molecules,freq_axis,error)
    if (error) return
  else
    call astro_message(seve%e,rname,'Plot mode not understood')
    error = .true.
    return
  endif
  !
  ! Set marker characteristics as they were:
  call gr_set_marker(userns,useris,usersize)
  !
end subroutine astro_noemasetup_plot
!
subroutine astro_noemasetup_list(rname,isetup,doindex,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_noemasetup_list
  use astro_noema_type
  !-----------------------------------------------------------------------
  ! @ public
  ! Plot/List a NOEMA receiver\backend setup as done in ASTRO
  !
  ! input:
  ! isetup: import structure filled in by 2 public subroutines:
  !       astro_noemasetup_receiver to transfer tuning/source information (1 call)
  !       astro_noemasetup_spw to transfer polyfix configuration (1 call / SPW)
  ! doindex .true. to list SPW according to their number in the data instead of frequency
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemasetup_t), intent(in) :: isetup    ! import structure
  logical, intent(in) :: doindex
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: noemamode='ONLINE'
  type(noema_t) :: lnoema
  type(frequency_axis_t) :: freq_axis
  logical :: doconflict
  integer(kind=4) :: is1, is2
  !
  !Define receiver parameters
  call rec_define_noema(lnoema%recdesc,noemamode,error)
  if (error) return
  !Reset tuning parameters
  lnoema%cfebe%defined=.false.
  lnoema%cfebe%rectune%name = ''
  lnoema%cfebe%rectune%iband = 0
  lnoema%cfebe%rectune%flo1 = 0
  lnoema%cfebe%rectune%flotune = 0
  lnoema%cfebe%rectune%frest = 0
  lnoema%cfebe%rectune%frf = 0
  lnoema%cfebe%rectune%flsr = 0
  lnoema%cfebe%rectune%fcent = 0
  lnoema%cfebe%rectune%label = ''
  lnoema%cfebe%rectune%ongrid = .false.
  lnoema%recdesc%redshift = .false. ! does NOT takes into accound source redshift (call from the OBS)
  !
  call rec_define_noema_ifproc(lnoema%cfebe%i_f%ifproc,error)
  if (error) return
  !
  ! Tuning and source information
  call noema_external_tuning(rname,isetup%rec,lnoema,error)
  if (error) return
  !
  !SPW configuration
  call noema_external_spw(rname,isetup%spw,lnoema,error)
  if (error) return
  !
  freq_axis%main=trim(freqax_names(freqax_rest))
  !
  ! Do the list
  doconflict=.false.
  is1=1
  is2=lnoema%cfebe%spw%out%n_spw
  call noema_list_spw(rname,lnoema%cfebe%spw%out,freq_axis%main,lnoema%source,doindex,doconflict,is1,is2,error)
  !
end subroutine astro_noemasetup_list
!
subroutine astro_noemasetup_receiver(rname,irec,flo1,fcent,sb,tuningname,sourcename,doppler,error)
  use gbl_message
  use astro_interfaces, except_this=>astro_noemasetup_receiver
  use astro_types
  !-----------------------------------------------------------------------
  ! @ public
  ! API to fill in receiver section of the ASTRO import structure
  ! irec = isetup%rec ! irec = astro_noemareceiver_t
  !        isetup = astro_noemasetup
  ! flo1 (real*8) = LO1 tuning frequency (REST frame) in MHz
  ! fcent (real*8) = IF1 center frequency in MHz
  ! sb (integer*4) = sideband code where the tuning frequency is placed (1=USB,2=LSB)
  ! tuning name (character*12) = name of the LINE command at the observatory
  ! source name (character*128) = name of the source
  ! doppler (real*8) = doppler of the observation
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemareceiver_t), intent(inout) :: irec
  real(kind=8), intent(in)  :: flo1   ! MHz, rest
  real(kind=8), intent(in)  :: fcent    !MHz, if1
  integer(kind=4), intent(in) :: sb ! sideband
  character(len=*), intent(in) :: tuningname ! tuning name
  character(len=*), intent(in) :: sourcename ! source name
  real(kind=8), intent(in)  :: doppler    ! as defined in obs/clic
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: noemamode='ONLINE'
  type(receiver_desc_t) :: rdesc
  !
  call rec_define_noema(rdesc,noemamode,error)
  if (error) return
  !
  irec%flo1=flo1
  !
  if (fcent.lt.rdesc%iflim(1).or.fcent.gt.rdesc%iflim(2)) then
    call astro_message(seve%e,rname,'Wrong IF frequency')
    error=.true.
    return
  endif
  irec%fcent=fcent
  if (sb.le.0.or.sb.gt.m_sideband) then
    call astro_message(seve%e,rname,'Problem with sideband')
    error=.true.
    return
  endif
  irec%sbcode=sb
  if (tuningname.eq.'') then
    call astro_message(seve%e,rname,'Missing tuning name')
    error=.true.
    return
  endif
  irec%tuningname=tuningname
  !
  if (sourcename.eq.'') then
    call astro_message(seve%e,rname,'Missing source name')
    error=.true.
    return
  endif
  irec%sourcename=sourcename

  !
  irec%obsdoppler=doppler
  !
end subroutine astro_noemasetup_receiver
!
subroutine astro_noemasetup_spw_bychunk(rname,ispw,ch1,ch2,resol,label,user_label,corrmode,error)
  use gbl_message
  use astro_interfaces, except_this=>astro_noemasetup_spw_bychunk
  use astro_types
  !-----------------------------------------------------------------------
  ! @ public-generic astro_noemasetup_spw
  ! API to fill in SPW section of the ASTRO import structure 
  ! 1 call per SPW: the list of SPW is incremented internally
  !
  ! Definition by chunk:
  ! For each spectral window input is:
  ! ch1 (integer*4) = 1st chunk of the SPW
  ! ch2 (integer*4) = last chunk of the SPW
  ! real (real*8) = resolution of the SPW (in MHz)
  ! label (character*3) = label to identify the baseband where the SPW is placed. Format: HLO
  ! user_label (character*32) = in case the used attached a name to the SPW
  ! corrmode (integer*4) = correlator mode used for the baseband
  !
  ! NB: When a HighResolution SPW is defined, the Low SPW of the current baseband is
  ! also defined if it does not exist yet
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemaspw_t), intent(inout) :: ispw
  integer(kind=4), intent(in) :: ch1
  integer(kind=4), intent(in) :: ch2
  real(kind=8), intent(in)  :: resol
  character(len=*), intent(in) :: label
  character(len=*), intent(in) :: user_label
  integer(kind=4), intent(in) :: corrmode
  logical, intent(inout) :: error
  !
  integer(kind=4) :: iw,chmax,it,ic2
  type(pfx_t) :: pfx
  logical :: gotres
  integer(kind=4), parameter :: lenlabel=3
  character(len=128) :: mess
  !
  ispw%n_spw=ispw%n_spw+1
  iw=ispw%n_spw
  !
  call noema_define_pfx(pfx,error)
  if (error) return
  !
  if (corrmode.le.0) then
    call astro_message(seve%e,rname,'Correlator mode undefined')
    error=.true.
    return
  endif
  ispw%corrmode(iw)=corrmode
  !
  chmax=0
  gotres=.false.
  do it=1,pfx%unit(1)%mode(corrmode)%n_types
    if (pfx%unit(1)%mode(corrmode)%chtype(it)%df_chunks.eq.resol) gotres=.true.
    if (pfx%unit(1)%mode(corrmode)%chtype(it)%n_chunks.le.chmax) cycle
    chmax=pfx%unit(1)%mode(corrmode)%chtype(it)%n_chunks
  enddo
  if (.not.gotres) then
    call astro_message(seve%e,rname,'Problem with SPW resolution')
    error=.true.
    return
  endif
  ispw%resol(iw)=resol
  !
  if (ch1.le.0) then
    call astro_message(seve%e,rname,'Chunk 1 undefined')
    error=.true.
    return
  endif
  ispw%chunkmin(iw)=ch1
  if (ch2.le.0) then
    call astro_message(seve%e,rname,'Chunk 2 undefined')
    error=.true.
    return
  endif
  if (ch2.gt.chmax) then
    if (ch2.gt.64) then
      ! patch to be used as long as there is a discrepancy between observed data and astro definitions
      ! (problem of the last 3 chunks)
      call astro_message(seve%e,rname,'Chunk 2 does not exist')
      error=.true.
      return
    endif
    ic2=chmax
    write (mess,'(a,i0,a,1x,i0)') 'Chunk 2 (',ch2,') sent back to',chmax
    call astro_message(seve%w,rname,mess)
  else
    ic2=ch2
  endif
  ispw%chunkmax(iw)=ic2
  if (len_trim(label).ne.lenlabel) then
    call astro_message(seve%e,rname,'Problem with label format (expect 5 characters)')
    error=.true.
    return
  endif
  ispw%label(iw)=label
  !
  ispw%user_label(iw)=user_label
  !
end subroutine astro_noemasetup_spw_bychunk
!
subroutine astro_noemasetup_spw_byfreq(rname,ispw,f1,f2,resol,label,user_label,corrmode,error)
  use gbl_message
  use astro_interfaces, except_this=>astro_noemasetup_spw_byfreq
  use astro_types
  !-----------------------------------------------------------------------
  ! @ public-generic astro_noemasetup_spw
  ! API to fill in SPW section of the ASTRO import structure 
  ! 1 call per SPW: the list of SPW is incremented internally
  !
  ! Definition by frequency:
  ! For each spectral window input is:
  ! f1 (real*8) = IF2 min of the SPW
  ! f2 (real*8) = IF2 max of the SPW
  ! real (real*8) = resolution of the SPW (in MHz)
  ! label (character*3) = label to identify the baseband where the SPW is placed. Format: HLO
  ! user_label (character*32) = in case the used attached a name to the SPW
  ! corrmode (integer*4) = correlator mode used for the baseband
  !
  ! NB: When a HighResolution SPW is defined, the Low SPW of the current baseband is
  ! also defined if it does not exist yet
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemaspw_t), intent(inout) :: ispw
  real(kind=8), intent(in) :: f1
  real(kind=8), intent(in) :: f2
  real(kind=8), intent(in)  :: resol
  character(len=*), intent(in) :: label
  character(len=*), intent(in) :: user_label
  integer(kind=4), intent(in) :: corrmode
  logical, intent(inout) :: error
  !
  integer(kind=4) :: it,itype,ic1,ic2
  type(pfx_t) :: pfx
  logical :: gotres
  integer(kind=4), parameter :: lenlabel=3
  !
  !
  call noema_define_pfx(pfx,error)
  if (error) return
  !
  if (corrmode.le.0) then
    call astro_message(seve%e,rname,'Correlator mode undefined')
    error=.true.
    return
  endif
  gotres=.false.
  do it=1,pfx%unit(1)%mode(corrmode)%n_types
    if (pfx%unit(1)%mode(corrmode)%chtype(it)%df_chunks.eq.resol) gotres=.true.
    itype=it
  enddo
  if (.not.gotres) then
    call astro_message(seve%e,rname,'Problem with SPW resolution')
    error=.true.
    return
  endif
  !
  if (f1.lt.pfx%if2lim(1)) then
    call astro_message(seve%e,rname,'Problem with IF2 min')
    error=.true.
    return
  endif
  !
  if (f2.le.pfx%if2lim(1)) then
    call astro_message(seve%e,rname,'Problem with IF2 max')
    error=.true.
    return
  endif
  !
  ! Convert if2 into chunk number
  call if2tochunk(rname,pfx%unit(1)%mode(corrmode)%chtype(itype),f1,.true.,ic1,error)
  if (error) return
  call if2tochunk(rname,pfx%unit(1)%mode(corrmode)%chtype(itype),f2,.false.,ic2,error)
  if (error) return
  !
  call astro_noemasetup_spw_bychunk(rname,ispw,ic1,ic2,resol,label,user_label,corrmode,error)
  if (error) return
  !
end subroutine astro_noemasetup_spw_byfreq

module clic_rdata
      complex(kind=4), allocatable :: datac(:), datal(:)
      complex(kind=4), allocatable :: passc(:), passl(:)
      complex(kind=4), allocatable :: factc(:), factl(:)
      complex(kind=4), allocatable :: spidc(:), spidl(:)
      real(kind=4), allocatable    :: campmaxu(:),lampmaxu(:), &
                                      campmaxl(:),lampmaxl(:), &
                                      campminu(:),lampminu(:), &
                                      campminl(:),lampminl(:), &
                                      ampfacu(:),ampfacl(:)
      complex(kind=4), allocatable :: gainc(:,:,:), gainl(:,:,:)
      real(kind=4), allocatable    :: wgainc(:,:,:), wgainl(:,:,:)
      integer(kind=4) :: gnumc, gdumpc, gnuml, gdumpl
end module

subroutine map_resample_comm(line,comm,error)
  use phys_const
  use gbl_message
  use image_def
  use gkernel_interfaces
  use mapping_interfaces, except_this=>map_resample_comm
  use mapping_read, only: out_range
  use clean_types
  use file_buffers
  use uvmap_buffers
  use clean_buffers
  use primary_buffers
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Resample in velocity the Images, or Compress them 
  !   Support for commands
  !     MAP_RESAMPLE WhichOne NC [Ref Val Inc]
  !     MAP_COMPRESS WhichOne NC
  !     MAP_INTEGRATE WhichOne Rmin Rmax RType
  !
  ! WhichOne    Name of map to be processed
  !             Allowed values are DIRTY, CLEAN, SKY
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  character(len=*), intent(in)    :: comm
  logical,          intent(inout) :: error
  !
  character(len=80) :: chain
  real(8) :: convert(3)
  integer :: nc
  type (gildas) :: mapout, mapin
  integer :: ier
  logical :: do_sky, do_clean, do_dirty
  character(len=12) :: iname
  ! For RESAMPLE
  integer(kind=index_length) :: ipix1,ipixn
  integer(kind=size_length) :: isize
  integer, allocatable :: ipi(:,:)
  real, allocatable :: ipr (:,:)
  real, allocatable :: din(:,:,:)
  real :: pix1,pixn
  ! For COMPRESS
  integer :: ifi, ic, k, kc
  integer :: istart
  ! For INTEGRATE
  real(4) :: dv=1.0
  real(8) :: drange(2),xposi,yposi
  character(len=12) :: csort
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort),mysort
  integer :: mc(2), naver, isort
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  error = .false.
  !
  call sic_ke(line,0,1,iname,nc,.true.,error)
  if (error) return
  call gildas_null(mapout, type = 'IMAGE')
  call gildas_null(mapin, type = 'IMAGE')
  !
  isize = 0
  do_clean = .false.
  do_sky   = .false.
  do_dirty = .false.
  !
  select case(iname)
  case('DIRTY')
    isize = dirty%head%loca%size
    call gdf_copy_header(dirty%head,mapin,error)
    do_dirty = .true.
  case('CLEAN')
    isize = clean%head%loca%size
    call gdf_copy_header(clean%head,mapin,error)
    do_clean = .true.
  case('SKY')
    isize = sky%head%loca%size
    call gdf_copy_header(sky%head,mapin,error)
    do_sky = .true.
  case('*') 
    if (clean%head%loca%size.ne.0) then
      do_clean = .true.
      isize = clean%head%loca%size
      if (sky%head%loca%size .ne. 0) then
        if (sky%head%loca%size .ne. isize) then
          call map_message(seve%e,comm,'CLEAN and SKY do not match')
          error = .true.
          return
        endif
        do_sky = .true.
      endif
      call gdf_copy_header(clean%head,mapin,error)
    else if (sky%head%loca%size .ne. 0) then
      isize = sky%head%loca%size
      call gdf_copy_header(sky%head,mapin,error)
      do_sky = .true.
    endif
  case default
    call map_message(seve%e,comm,'Invalid data name '//trim(iname))
    error = .true.
    return
  end select
  if (isize.eq.0) then
    call map_message(seve%e,comm,'Specified data '//trim(iname)//' is not allocated')
    error = .true.
    return
  endif
  !
  allocate(din(mapin%gil%dim(1),mapin%gil%dim(2),mapin%gil%dim(3)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,comm,'Memory allocation failure')
    error = .true.
    return  
  endif
  !
  call gdf_copy_header(mapin,mapout,error)
  if (error) return  
  !
  ! FInd out action and parameters
  select case (comm)
  case ('MAP_RESAMPLE')
    call sic_i4(line,0,2,nc,.true.,error)
    if (error) return
    if (nc.gt.mapin%gil%dim(3)) nc = mapin%gil%dim(3)
    ! Set default resampling
    convert = mapin%gil%convert(:,3)
    !
    call sic_r8(line,0,3,convert(1),.false.,error)
    if (error) return
    call sic_r8(line,0,4,convert(2),.false.,error)
    if (error) return
    call sic_r8(line,0,5,convert(3),.false.,error)
    if (error) return
    ! Convert(3) is initially on a Velocity Scale.
    mapout%gil%voff = convert(2)
    mapout%gil%vres = convert(3)
    mapout%gil%fres = - mapout%gil%vres * 1d3 / clight * mapout%gil%freq
    mapout%gil%convert(:,3) = convert
    mapout%gil%dim(3) = nc
    !
    !
    ! Check limits
    pix1 = mapout%gil%ref(3) + ( mapin%gil%val(3) + (1.d0-mapin%gil%ref(3))  &
        & *mapin%gil%inc(3) - mapout%gil%val(3) )/mapout%gil%inc(3)
    pixn = mapout%gil%ref(3) + ( mapin%gil%val(3) + (mapin%gil%dim(3)-mapin%gil%ref(3))  &
        & *mapin%gil%inc(3) - mapout%gil%val(3) )/mapout%gil%inc(3)
    if (pix1.lt.pixn) then
      ipix1 = int(pix1)
      if (ipix1.ne.pix1) ipix1 = ipix1+1
      ipix1 = max(ipix1,1)
      ipixn = min(int(pixn),mapout%gil%dim(3))
    else
      ipixn = min(int(pix1),mapout%gil%dim(3))
      ipix1 = int(pixn)
      if (ipix1.ne.pixn) ipix1 = ipix1+1
      ipix1 = max(ipix1,1)
    endif
    !
    allocate (ipi(2,mapout%gil%dim(3)), ipr(4,mapout%gil%dim(3)), stat=ier)
    !
  case ('MAP_COMPRESS') 
    call sic_i4(line,0,2,nc,.true.,error)
    if (error) return
    if (nc.gt.mapin%gil%dim(3)) nc = mapin%gil%dim(3)
    !
    ! Set offset channel
    istart = 1
    call sic_i4(line,0,3,istart,.false.,error)
    if (error) return
    if (istart.lt.1 .or. istart.gt.nc) then
      print *,'IStart ',istart,nc
      call map_message(seve%e,comm,'Offset channel out of range')
      error = .true.
      return
    endif
    write(chain,'(A,I6,A)') 'Averaging by chunks of ',nc,' channels'
    call map_message(seve%i,comm,chain)
    !
    mapout%gil%inc(3) = mapin%gil%inc(3)*nc
    mapout%gil%ref(3) = (2.0*mapin%gil%ref(3)+nc-1.0)/2/nc
    mapout%gil%vres = nc*mapin%gil%vres
    mapout%gil%fres = nc*mapin%gil%fres
    ! Change the number of channels
    mapout%gil%dim(3) = (mapin%gil%dim(3)+1-istart)/nc
    if (mapout%gil%dim(3).lt.1) then
      call map_message(seve%e,comm,'Not enough channels')
      error = .true.
      return
    endif
    !
  case ('MAP_INTEGRATE') 
    call sic_r8 (line,0,2,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,0,3,drange(2),.true.,error)
    if (error) return
    csort = mapin%char%code(3)
    call sic_ke (line,0,4,csort,nc,.false.,error)
    if (error) return
    error = .false.
    call sic_ambigs(comm,csort,mysort,isort,types,msort,error)
    if (error)  return
    !
    ! Define number of channels
    call out_range(comm,csort,drange,mc,mapin,error)
    if (error) return
    ier = gdf_range (mc, mapin%gil%dim(3))
    naver = mc(2)-mc(1)+1
    !
    ! Build a pseudo axis aligned on the input one:
    !  - Number of channels set to 1,
    !  - Increment set to the extracted range,
    !  - Value at reference unchanged (same spectroscopic axis, e.g. regarding
    !    associated Rest Freq),
    !  - Center of averaged range (old axis) is aligned on the center of the
    !    output channel #1 (new axis)
    ! This writes as:
    mapout%gil%ndim = 2
    mapout%gil%dim(3) = 1
    ! mapout%gil%val(3) = unchanged
    yposi = (mc(1)+mc(2))*0.5d0
    xposi = 1.d0
    mapout%gil%inc(3) = mapin%gil%inc(3)*naver
    mapout%gil%ref(3) = xposi - (yposi-mapin%gil%ref(3))/naver
    ! Do not forget the SPECTRO section
    mapout%gil%vres = mapin%gil%vres*naver
    mapout%gil%fres = mapin%gil%fres*naver
    ! mapout%gil%voff = unchanged
    ! mapout%gil%freq = unchanged
    ! mapout%gil%fima = unchanged
    !
    mapout%loca%size = mapout%gil%dim(1)*mapout%gil%dim(2)
    if (mapin%char%code(3).eq.'VELOCITY') then
      mapout%char%unit = trim(mapin%char%unit)//'.km/s'
    elseif (mapin%char%code(3).eq.'FREQUENCY') then
      mapout%char%unit = trim(mapin%char%unit)//'.MHz'
    else
      mapout%char%unit = 'UNKNOWN'
    endif
    mapout%gil%extr_words = 0
    mapout%gil%blan_words = 2
    mapout%gil%bval = 0.
    mapout%gil%eval = 0.    
    dv = abs(mapout%gil%inc(3))
  end select
  !
  ! Now do the job
  if (do_clean) then
    din(:,:,:) = clean%data
    deallocate(clean%data)
    call sic_delvariable ('CLEAN',.false.,error)
    !
    allocate (clean%data(mapout%gil%dim(1),mapout%gil%dim(2),mapout%gil%dim(3)) ,stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,comm,'CLEAN Memory allocation failure')
      error = .true.
      return  
    endif
    if (comm.eq.'MAP_RESAMPLE') then
      call all_inter(mapout%gil%dim(1)*mapout%gil%dim(2),ipix1,ipixn, &
        & clean%data,mapout%gil%dim(3),mapout%gil%inc(3),mapout%gil%ref(3),mapout%gil%val(3), &
        & din,mapin%gil%dim(3),mapin%gil%inc(3),mapin%gil%ref(3),mapin%gil%val(3), &
        & ipi, ipr) 
    else if (comm.eq.'MAP_COMPRESS') then
      ifi = istart
      do ic=1,mapout%gil%dim(3)
        do k=ifi,min(ifi+nc-1,mapin%gil%dim(3))
          clean%data(:,:,ic) = clean%data(:,:,ic) + din(:,:,k)
        enddo
        kc = min(ifi+nc-1,mapin%gil%dim(3))-ifi+1
        clean%data(:,:,ic) = clean%data(:,:,ic)/kc
        ifi = ifi+nc
      enddo
    else if (comm.eq.'MAP_INTEGRATE') then          
      clean%data(:,:,1) = din(:,:,mc(1))
      do ic=mc(1)+1,mc(2)
        clean%data(:,:,1) = clean%data(:,:,1) + din(:,:,ic)
      enddo
      clean%data = clean%data*dv
    endif
    call gdf_copy_header(mapout,clean%head,error)
    clean%head%loca%size = clean%head%gil%dim(1)*clean%head%gil%dim(2)
    !
    ! Set "new" internal flag 
    save_data(code_save_clean) = .true.
    optimize(code_save_clean)%change = 2  ! Data has been changed, and no Buffer 
    call sic_mapgildas ('CLEAN',clean%head,error,clean%data)
  endif
  !
  if (do_sky) then
    din(:,:,:) = sky%data
    deallocate(sky%data)
    call sic_delvariable ('SKY',.false.,error)
    allocate (sky%data(mapout%gil%dim(1),mapout%gil%dim(2),mapout%gil%dim(3)) ,stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,comm,'SKY Memory allocation failure')
      error = .true.
      return  
    endif
    if (comm.eq.'MAP_RESAMPLE') then
      call all_inter(mapout%gil%dim(1)*mapout%gil%dim(2),ipix1,ipixn, &
        & sky%data,mapout%gil%dim(3),mapout%gil%inc(3),mapout%gil%ref(3),mapout%gil%val(3), &
        & din,mapin%gil%dim(3),mapin%gil%inc(3),mapin%gil%ref(3),mapin%gil%val(3), &
        & ipi, ipr) 
    else if (comm.eq.'MAP_COMPRESS') then
      ifi = istart
      do ic=1,mapout%gil%dim(3)
        do k=ifi,min(ifi+nc-1,mapin%gil%dim(3))
          sky%data(:,:,ic) = sky%data(:,:,ic) + din(:,:,k)
        enddo
        kc = min(ifi+nc-1,mapin%gil%dim(3))-ifi+1
        sky%data(:,:,ic) = sky%data(:,:,ic)/kc
        !
        ifi = ifi+nc
      enddo
    else if (comm.eq.'MAP_INTEGRATE') then          
      sky%data(:,:,1) = din(:,:,mc(1))
      do ic=mc(1)+1,mc(2)
        sky%data(:,:,1) = sky%data(:,:,1) + din(:,:,ic)
      enddo
      sky%data = sky%data*dv
    endif
    call gdf_copy_header(mapout,sky%head,error)
    sky%head%loca%size = sky%head%gil%dim(1)*sky%head%gil%dim(2)*sky%head%gil%dim(3)
    !
    ! Set "new" internal flag 
    save_data(code_save_sky) = .true.
    optimize(code_save_sky)%change = 2  ! Data has been changed, and no Buffer 
    call sic_mapgildas ('SKY',sky%head,error,sky%data)
  endif
  !
  if (do_dirty) then
    din(:,:,:) = dirty%data
    deallocate(dirty%data)
    call sic_delvariable ('DIRTY',.false.,error)
    allocate (dirty%data(mapout%gil%dim(1),mapout%gil%dim(2),mapout%gil%dim(3)) ,stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,comm,'DIRTY Memory allocation failure')
      error = .true.
      return  
    endif
    !
    if (comm.eq.'MAP_RESAMPLE') then
      call all_inter(mapout%gil%dim(1)*mapout%gil%dim(2),ipix1,ipixn, &
        & dirty%data,mapout%gil%dim(3),mapout%gil%inc(3),mapout%gil%ref(3),mapout%gil%val(3), &
        & din,mapin%gil%dim(3),mapin%gil%inc(3),mapin%gil%ref(3),mapin%gil%val(3), &
        & ipi, ipr) 
    else if (comm.eq.'MAP_COMPRESS') then
      ifi = istart
      do ic=1,mapout%gil%dim(3)
        do k=ifi,min(ifi+nc-1,mapin%gil%dim(3))
          dirty%data(:,:,ic) = dirty%data(:,:,ic) + din(:,:,k)
        enddo
        kc = min(ifi+nc-1,mapin%gil%dim(3))-ifi+1
        dirty%data(:,:,ic) = dirty%data(:,:,ic)/kc
        !
        ifi = ifi+nc
      enddo
      dirty%data = dirty%data/nc
    else if (comm.eq.'MAP_INTEGRATE') then          
      dirty%data(:,:,1) = din(:,:,mc(1))
      do ic=mc(1)+1,mc(2)
        dirty%data(:,:,1) = dirty%data(:,:,1) + din(:,:,ic)
      enddo
      dirty%data = dirty%data*dv
    endif
    call gdf_copy_header(mapout,dirty%head,error)
    dirty%head%loca%size = dirty%head%gil%dim(1)*dirty%head%gil%dim(2)*dirty%head%gil%dim(3)
    !
    ! Set "new" internal flag 
    save_data(code_save_dirty) = .true.
    optimize(code_save_dirty)%change = 2  ! Data has been changed, and no Buffer 
    !
    dirty%head%gil%reso_words = 3
    dirty%head%gil%majo= 0.0
    dirty%head%gil%mino= 0.0
    dirty%head%gil%posa = 0.0
    call sic_mapgildas('DIRTY',dirty%head,error,dirty%data)
  endif
  !
  return
  !
contains
  !
  subroutine all_inter (n,ic1,icn,x,xdim,xinc,xref,xval,y,ydim,yinc,yref,yval,iwork,rwork)
    !---------------------------------------------------------------------
    ! LAS	Internal routine
    !	Performs the linear interpolation/integration
    ! Arguments:
    !	X	R*4(*)	Output spectrum
    !	N	I*4	Map size
    !	XDIM	I*4	Output pixel number
    !	XINC	R*8	Output first axis increment
    !	XREF	R*8	Output first axis reference pixel
    !	XVAL	R*8	Output first axis value at reference pixel
    ! 	Y	R*4(*)	Input spectrum
    !---------------------------------------------------------------------
    integer(kind=index_length) :: n
    integer(kind=index_length) :: ic1
    integer(kind=index_length) :: icn
    integer(kind=index_length) :: xdim
    real :: x(n,xdim)
    real(8) :: xinc
    real(8) :: xref
    real(8) :: xval
    integer(kind=index_length) :: ydim
    real :: y(n,ydim)
    real(8) :: yinc
    real(8) :: yref
    real(8) :: yval
    integer :: iwork(2,xdim) ! iwork = imin,imax
    real :: rwork(4,xdim)    ! rwork = rmin_1, rmin, rmax, rmax_1
    !
    integer :: i,imax,imin,j,k
    real(8) :: minpix,maxpix,pix,val,expand
    real :: rmin_1,rmin,rmax_1,rmax,smin,smax
    real :: scale
    !
    ! Special case: output axis = input axis
    if ((xdim.eq.ydim).and.(xref.eq.yref).and.(xval.eq.yval).and.(xinc.eq.yinc)) then
      x = y
      return
    endif
    !
    x = 0
    !
    expand = abs(xinc/yinc)
    scale  = 1.d0/expand
    do i = ic1, icn
      !
      ! Compute interval
      !
      val = xval + (i-xref)*xinc
      pix = (val-yval)/yinc + yref
      maxpix = pix + 0.5d0*expand
      minpix = pix - 0.5d0*expand
      imin = int(minpix+1.0d0)
      imax = int(maxpix)
      iwork(1,i) = imin
      iwork(2,i) = imax
      if (imax.ge.imin) then
        if (imin.gt.1) then
          !
          ! Lower end
          !
          ! YMIN = Y(IMIN-1)*(IMIN-MINPIX)+Y(IMIN)*(MINPIX-IMIN+1)
          !     and
          ! X(I) = X(I) + 0.5 * ( (IMIN-MINPIX)*(YMIN+Y(IMIN)) )
          !   
          ! Coefficient de IMIN-1: RMIN_1 = 0.5 * (IMIN-MINPIX)*(IMIN-MINPIX)
          ! Coefficient de IMIN:   RMIN   = 0.5 * (MINPIX-IMIN+2)*(IMIN-MINPIX)
          !
          smin = imin-minpix
          rwork(1,i) = 0.5*smin*smin
          rwork(2,i) = smin-rwork(1,i)
        else
          ! Coefficient de IMIN:      RMIN   = (IMIN-MINPIX)
          ! Coefficient de IMIN-1:    RMIN_1 = 0
          rwork(1,i) = 0.0
          rwork(2,i) = imin-minpix
        endif
        if (imax.lt.ydim) then
          ! Upper end
          smax = maxpix-imax
          rwork(4,i) = 0.5*smax*smax
          rwork(3,i) = smax-rwork(4,i)
        else
          rwork(3,i) = maxpix-imax
          rwork(4,i) = 0.0
        endif
        if (imax.eq.imin) then
          ! Point Case
          rwork(2,i) = rwork(2,i)+rwork(3,i)
          rwork(3,i) = 0.0
        else
          ! General Case: Add 1/2 of IMIN & IMAX + 1 of all intermediate
          ! channels
          rwork(2,i) = rwork(2,i)+0.5
          rwork(3,i) = rwork(3,i)+0.5
        endif
      else
        if (imin.gt.1) then
          rwork(1,i) = (imin-pix)
          rwork(2,i) = (pix+1-imin)
        else
          rwork(1,i) = 0.0
          rwork(2,i) = 1.0
        endif
      endif
    enddo
    !
    ! OK, now do it...
    do i = ic1, icn
      imin = iwork(1,i)
      imax = iwork(2,i)
      rmin_1 = rwork(1,i)
      rmin   = rwork(2,i)
      rmax   = rwork(3,i)
      rmax_1 = rwork(4,i)
      !
      if (imax.ge.imin) then
        ! General Trapezium integration
        if (imin.gt.1) then
          do j=1,n
            x(j,i) = y(j,imin-1)*rmin_1
          enddo
          do j=1,n
            x(j,i) = x(j,i) + y(j,imin)*rmin
          enddo
        else
          do j=1,n
            x(j,i) = y(j,imin)*rmin
          enddo
        endif
        if (imax.gt.imin) then
          do k = imin+1,imax-1
            do j=1,n
              x(j,i) = x(j,i) + y(j,k)
            enddo
          enddo
          do j=1,n
            x(j,i) = x(j,i) + y(j,imax)*rmax
          enddo
        endif
        if (imax.lt.ydim) then
          do j=1,n
            x(j,i) = x(j,i) + y(j,imax+1)*rmax_1
          enddo
        endif
        ! Normalise
        do j=1,n
          x(j,i) = x(j,i)*scale
        enddo
        !
      else
        ! Interpolation
        if (imin.gt.1) then
          do j=1,n
            x(j,i) = y(j,imin-1)*rmin_1
          enddo
          do j=1,n
            x(j,i) = x(j,i) + y(j,imin)*rmin
          enddo
        else
          do j=1,n
            x(j,i) = y(j,imin)
          enddo
        endif
      endif
    enddo
    !
  end subroutine all_inter
end subroutine map_resample_comm

subroutine clic_flag(line,error)
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC	Command CLIC\FLAG f1 f2 ... [/ANTENNA a1 a2 ... ]
  !		[/BASELINE b1 b2 ...] [/RESET]
  ! changes the flags in the observation and record currently in memory
  ! (to be used in a MODIFY DATA_HEADER procedure)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_dheader.inc'
  include 'clic_par.inc'
  include 'clic_flags.inc'
  ! Local
  integer :: i, j, afl(mnant), bfl(mnbas)
  logical :: saf(2*mbands,mnant), sbf(2*mbands,mnbas)
  logical :: reset
  character(len=132) :: out
  character(len=164) :: ch
  !------------------------------------------------------------------------
  ! Code:
  ! Reset all COMMAND flags: otherwise the system has memory !
  error = .false.
  do i=1, r_nant
    afl(i) = 0
    saf(:,i) = .false.
  enddo
  do i=1, r_nbas
    bfl(i) = 0
    sbf(:,i) = .false.
  enddo
  call get_flags(line,1,1,2,3,-1,-1,afl,bfl,saf,sbf,reset,error)
  if (error) return
  !
  ! Loop on antennas
  do i=1, r_nant
    if (afl(i).ne.0) then
      if (reset) then
        dh_aflag(i) = iand(dh_aflag(i),not(afl(i)))
      else
        dh_aflag(i) = ior(dh_aflag(i),afl(i))
      endif
      r_dmaflag(i) = dh_aflag(i)
      r_presec(modify_sec) = .true.
    endif
    do j=1, 2*mbands
      if (saf(j,i)) then
        if (reset) then
          dh_saflag(j,i) = .false.
        else 
          dh_saflag(j,i) = .true.
        endif
!!      r_dmaflag(i) = dh_aflag(i)
!!      r_presec(modify_sec) = .true.
      endif 
    enddo
  enddo
  !
  ! Baselines
  do i=1, r_nbas
    if (bfl(i).ne.0) then
      if (reset) then
        dh_bflag(i) = iand(dh_bflag(i),not(bfl(i)))
      else
        dh_bflag(i) = ior(dh_bflag(i),bfl(i))
      endif
      r_dmbflag(i) = dh_bflag(i)
      r_presec(modify_sec) = .true.
    endif
    do j=1, 2*mbands
      if (sbf(j,i)) then
        if (reset) then
          dh_sbflag(j,i) = .false.
        else
          dh_sbflag(j,i) = .true.
        endif   
!!      r_dmbflag(i) = dh_bflag(i)
!!      r_presec(modify_sec) = .true.
      endif
    enddo 
  enddo
  !
  call list_flags(r_nant, r_nbas, dh_aflag, dh_bflag, &
    dh_saflag, dh_sbflag, out)
  write(ch,1000) r_scan, dh_dump, out(1:lenc(out))
  call message(6,1,'CLIC_FLAG',ch(1:lenc(ch)))
  return
  !
error = .true.
  return
1000 format(' Scan ',i4,' record ',i3,' - ',a)
end subroutine clic_flag
!
subroutine get_flags(line,iarg,iao,ibo,iro,ilo,iso,afl,bfl,saf,sbf, &
    reset, error)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  character(len=*) :: line          !
  integer :: iarg                   !
  integer :: iao                    !
  integer :: ibo                    !
  integer :: iro                    !
  integer :: ilo                    !
  integer :: iso                    !
  integer :: afl(mnant)             !
  integer :: bfl(mnbas)             !
  logical :: saf(2*mbands,mnant)             !
  logical :: sbf(2*mbands,mnbas)             ! 
  logical :: reset                  !
  logical :: error                  !
  ! Global
  include 'clic_display.inc'
  include 'clic_flags.inc'
  ! Local
  integer :: n, i, j, ib(mnbas), nb, narg, mask, nch, k
  logical :: antenna, baseline, spectral, unspectral, all, allspectral
  logical :: smask(2*mbands), ssmask
  character(len=3) :: arg
  character(len=12) :: arg1
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  spectral = .false.
  unspectral  = .false.
  do i=1, mnant
    afl(i) = 0
    saf(:,i) = .false.
  enddo
  do i=1, mnbas
    bfl(i) = 0
    sbf(:,i) = .false.
  enddo
  mask = 0
  smask = .false.
  baseline = sic_present(ibo,0)
  antenna = sic_present(iao,0)
  if (sic_narg(0).ge.iarg) then
    do i=iarg, sic_narg(0)
      arg1 = '*'
      if (antenna) then
        call clic_kw(line,0,i,arg1,n,af,maf,.false.,error,.false.)
      elseif (baseline) then
        call clic_kw(line,0,i,arg1,n,bf,mbf,.false.,error,.false.)
      endif
      if (error) then
        call clic_kw(line,0,i,arg1,n,sf,msf,.true.,error,.true.)
        if (error) return
        spectral = .true.
        smask(n) = .true.
      else
        unspectral = .true.
        mask = ior(mask,ishft(1,n-1))
      endif
    enddo
  endif
  reset = sic_present(iro,0)
  all = sic_present(ilo,0)
  if (all) then
    spectral = .true.
    unspectral = .true.
    do i=1, 32
      mask = ibset(mask,i)
    enddo
    do i=1, 2*mbands
      smask(i) = .true.
    enddo
    ssmask = .true.
  endif
  allspectral = sic_present(iso,0)
  if (allspectral) then
    spectral = .true.
    do i=1, 2*mbands
      smask(i) = .true.
    enddo
    ssmask = .true.
  endif
  !
  ! Antenna
  if (antenna) then
    !
    ! Get antenna(s)
    narg = sic_narg(iao)
    call sic_ke(line,iao,1,arg,nch,.true.,error)
    if (error) return
    if (arg(1:3).eq.'ALL') then
      nb = mnant
      do i=1, mnant
        ib(i) = i
      enddo
    else
      nb = narg
      do i=1, narg
        call sic_i4(line,iao,i,n,.false.,error)
        if (error) return
        if (n.lt.1 .or. n.gt.mnant) then
          call message(6,3,'CLIC_FLAG','Invalid antenna')
          error = .true.
          return
        endif
        ib(i) = n
      enddo
    endif
    !
    ! Loop on antennas
    do j=1, nb
      i = ib(j)
      if (spectral) then
        do k=1, 2*mbands
          saf(k,i) = smask(k)
        enddo
      endif
      if (unspectral) then
        afl(i) = mask
      endif
    enddo
  !
  ! Baselines
  elseif (baseline) then
    !
    ! Get baseline(s)
    narg = sic_narg(ibo)
    call sic_ke(line,ibo,1,arg,nch,.true.,error)
    if (error) return
    if (arg(1:3).eq.'ALL') then
      nb = mnbas
      do i=1, mnbas
        ib(i) = i
      enddo
    else
      nb = narg
      do i=1, narg
        arg1 = '*'
        call clic_kw(line,ibo,i,arg1,n,cbas,mnbas,.false.,error,.true.)
        if (error) return
        ib(i) = n
      enddo
    endif
    !
    ! Loop on baselines
    do j=1, nb
      i = ib(j)
      if (spectral) then
        do k=1, 2*mbands
          sbf(k,i) = smask(k)
        enddo
      endif
      if (unspectral) then
        bfl(i) = mask
      endif
    enddo
  elseif (mask.ne.0.or..not.(ssmask)) then
    call message(6,3,'CLIC_FLAG','/ANTENNA or /BASELINE')
    error = .true.
    return
  endif
  !
  return
end subroutine get_flags
!
subroutine get_ant_mask(chain,mask,error)
  use gkernel_interfaces
  character(len=*) :: chain         !
  integer :: mask                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_flags.inc'
  ! Local
  integer :: i, n, lpar, lc
  character(len=6) :: kw,par
  !------------------------------------------------------------------------
  ! Code:
  i = 1
  mask = 0
  lc = lenc(chain)
  do while (i.le.lc)
    lpar = 6
    call sic_next(chain(i:),par,lpar,i)
    if (lpar.gt.0) then
      call sic_upper(par(1:lpar))
      call sic_ambigs('GET_ANT_MASK',par(1:lpar),kw,n,af,maf,   &
        error)
      if (error) return
      mask = ior(mask,ishft(1,n-1))
    else
      return
    endif
  enddo
  return
end subroutine get_ant_mask
!
subroutine get_base_mask(chain,mask,error)
  use gkernel_interfaces
  character(len=*) :: chain         !
  integer :: mask                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_flags.inc'
  ! Local
  integer :: i, n, lpar, lc
  character(len=6) :: kw,par
  !------------------------------------------------------------------------
  ! Code:
  i = 1
  mask = 0
  lc = lenc(chain)
  do while (i.le.lc)
    lpar = 6
    call sic_next(chain(i:),par,lpar,i)
    if (lpar.gt.0) then
      call sic_upper(par(1:lpar))
      call sic_ambigs('GET_BASE_MASK',par(1:lpar),kw,n,bf,mbf,   &
        error)
      if (error) return
      mask = ior(mask,ishft(1,n-1))
    else
      return
    endif
  enddo
end subroutine get_base_mask
!
function down_baseline (ib)
  use classic_api
  use clic_index
  logical :: down_baseline          !
  integer :: ib                     !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_flags.inc'
  include 'clic_clic.inc'
  include 'clic_number.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  integer ::  ia, ja, ibf, iaf, jaf, it, i, k, ib1, ffc00000
  data ffc00000/z'FFC00000'/
  !------------------------------------------------------------------------
  ! Code:
  if (ib.le.mnbas) then
    ibf = ior(ior(iand(dh_bflag(ib),not(bas_mask(ib))), bas_kill(ib)),&
              ix_bflag(ib,r_xnum))
    ia = r_iant(ib)
    ja = r_jant(ib)
    if (ia.gt.mnant .or. ja.gt.mnant .or. ib.gt.mnbas   &
      .or. ia.lt.1 .or. ib.lt.1 .or. ja.lt.1) then
      write(*,*) 'down_baseline ib, ia, ja ',ib,ia,ja
    endif
    iaf = ior(ior(iand(dh_aflag(ia),not(ant_mask(ia))), ant_kill(ia)), &
              ix_aflag(ia,r_xnum))
    jaf = ior(ior(iand(dh_aflag(ja),not(ant_mask(ja))), ant_kill(ja)), &
              ix_aflag(ja,r_xnum))
    k = ior(ibf,ior(iaf,jaf))
  else
    ! Triangle ...
    it = ib-mnbas
    k = 0
    do i = 1, 3
      ia = anttri(i,it)
      iaf = ior(iand(dh_aflag(ia),not(ant_mask(ia))),   &
        ant_kill(ia))
      k = ior(k,iaf)
      ib1 = bastri(i,it)
      ibf = ior(iand(dh_aflag(ib1),not(ant_mask(ib1))),   &
        ant_kill(ib1))
      k = ior(k,ibf)
    enddo
  endif
  down_baseline = iand(ffc00000,k).ne.0
end function down_baseline
!
function down_antenna (iant)
  use classic_api
  use clic_index
  !---------------------------------------------------------------------
  ! Is ANTENNA Iant Flagged ?
  !---------------------------------------------------------------------
  logical :: down_antenna           !
  integer :: iant                   !
  ! Global
  logical :: down_baseline
  include 'clic_parameter.inc'
  include 'clic_flags.inc'
  include 'clic_clic.inc'
  include 'clic_number.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  integer :: iaf, ffc00000, i, ibase
  logical :: all_down
  data ffc00000/z'FFC00000'/
  !
  iaf = ior(ior(iand(dh_aflag(iant),not(ant_mask(iant))),   &
    ant_kill(iant)),ix_aflag(iant,r_xnum))
  down_antenna = iand(ffc00000,iaf).ne.0
  if (r_nant.gt.1) then
    ! Antenna is also down is all baselines connected to it are down;
    ! this is not tested for a singtle antenna... RL
    all_down = .true.
    !
    do i = 1, r_nant
      if (i.lt.iant) then
        ibase = basant(i,iant)
        all_down = down_baseline(ibase).and.all_down
      elseif(i.gt.iant) then
        ibase = basant(iant,i)
        all_down = down_baseline(ibase).and.all_down
      endif
    enddo
    down_antenna = down_antenna.or.all_down
  endif
end function down_antenna
!
function down_channel (ib,ic)
  use classic_api
  !---------------------------------------------------------------------
  ! Is ANTENNA Iant Flagged ?
  !---------------------------------------------------------------------
  logical :: down_channel           !
  integer :: ib                     !
  integer :: ic                     !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_flags.inc'
  include 'clic_clic.inc'
  include 'clic_number.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  integer :: it,i,ia,ib1,ja
  logical :: ibf, iaf, jaf, k
  !
  if (ib.gt.mnbas) then
    it = ib-mnbas
    k = 0
    do i = 1, 3
      ia = anttri(i,it)
      iaf = (dh_saflag(ic,ia).and..not.san_mask(ic,ib)).or.san_kill(ic,ia)
      ib1 = bastri(i,it)
      ibf = (dh_sbflag(ic,ib1).and..not.sba_mask(ic,ib1)).or.sba_kill(ic,ib1)
      k = iaf.or.ibf
    enddo
  else
    ia = r_iant(ib)
    ja = r_jant(ib)
    ibf = (dh_sbflag(ic,ib).and..not.sba_mask(ic,ib)).or.sba_kill(ic,ib)
    iaf = (dh_saflag(ic,ia).and..not.san_mask(ic,ia)).or.san_kill(ic,ia)
    jaf = (dh_saflag(ic,ja).and..not.san_mask(ic,ja)).or.san_kill(ic,ja)
    k = ibf.or.iaf.or.jaf
  endif
  down_channel = k
end function down_channel

subroutine mrtindex_find_comm(line,ix,cx,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_find_comm
  use mrtindex_parse_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Support routine for command:
  !   MFIND
  ! Read the index file
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: line   ! Input command line
  type(mrtindex_optimize_t), intent(in)    :: ix
  type(mrtindex_optimize_t), intent(inout) :: cx
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND'
  character(len=message_length) :: mess
  type(user_calib_t) :: fuser
  integer(kind=entry_length) :: i,j
  character(len=11) :: date
  !
  if (ix%next.eq.1)  call mrtindex_message(seve%w,rname,'Input index is empty')
  !
  ! --- Fill CX from selection criteria --------------------------------
  call mrtindex_find_parse(line,fuser,error)
  if (error)  return
  !
  call mrtindex_find(fuser,ix,cx,error)
  if (error)  return
  !
  ! Check if there is no identical versions of the same entry. This
  ! works since we ensured that CX is sorted regarding those criterions
  do i=2,cx%next-1
    j = i-1
    if (cx%dobs(i)   .eq.cx%dobs(j)    .and.  &
        cx%scan(i)   .eq.cx%scan(j)    .and.  &
        cx%backend(i).eq.cx%backend(j) .and.  &
        cx%version(i).eq.cx%version(j)) then
      call gag_todate(cx%dobs(i),date,error)
      write(mess,'(A,I0,A,I0,A,A,A,I0,A,A,A,I0)')           &
        'Entry numbers ',j,' and ',i,                       &
        ' are identical: Date=',trim(date),                 &
        ', Scan=',cx%scan(i),                               &
        ', Backend=',trim(backends_mrtcal(cx%backend(i))),  &
        ', Version=',cx%version(i)
      call mrtindex_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  enddo
  !
  ! *** JP Is it the right place?
  call mrtindex_cx2sic(cx,error)
  if (error) return
  !
  write(mess,'(I0,A)')  cx%next-1,' entries in Current indeX'
  call mrtindex_message(seve%i,rname,mess)
  !
end subroutine mrtindex_find_comm
!
subroutine mrtindex_find_parse(line,fuser,error)
  use imbfits_parameters
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_find_parse
  use mrtindex_parse_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Parse the fuser input for selection criteria
  !---------------------------------------------------------------------
  character(len=*),   intent(in)    :: line   !
  type(user_calib_t), intent(out)   :: fuser   !
  logical,            intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FIND>PARSE'
  integer(kind=4), parameter :: optdate=1  ! Match the order in 'mrtcal_load'
  integer(kind=4), parameter :: optscan=2
  integer(kind=4), parameter :: optback=3
  integer(kind=4), parameter :: optobst=4
  integer(kind=4), parameter :: optsour=5
  integer(kind=4), parameter :: optproj=6
  integer(kind=4), parameter :: optcomp=7
  integer(kind=4), parameter :: optcali=8
  integer(kind=4), parameter :: optsolv=9
  integer(kind=4), parameter :: optswit=10
  integer(kind=4), parameter :: optfron=11
  integer(kind=4), parameter :: optpola=12
  integer(kind=4) :: nchar,i1,iarg
  !
  ! /DATE [date|*]
  fuser%cdate = '*'
  if (sic_narg(optdate).ge.1) then
    ! Get the option arguments, and convert them to gag_dates on-the-fly
    ! (this conversion is much easier here because we still have the
    ! argument limits made by Sic).
    call sic_ke(line,optdate,1,fuser%cdate,nchar,.true.,error)
    if (error)  return
    if (fuser%cdate.ne.'*') then
      ! ZZZ There should be a Sic API which extracts the correct portion
      ! of the command line! (same in astro/lib/astro_uv.f90)
      call datelist_decode(line,optdate,fuser%cdate,error)
      if (error)  return
    endif
  endif
  !
  ! /SCAN [iscan|*]
  fuser%cscan = '*'
  i1 = 1
  do iarg=1,sic_narg(optscan)
    ! Translate the arguments (as string, because of "TO" in "12 TO 34") and
    ! save them in a string
    call sic_ke(line,optscan,iarg,fuser%cscan(i1:),nchar,.true.,error)
    if (error)  return
    i1 = i1+nchar+1
  enddo
  !
  ! /BACKEND [backname|*]
  fuser%cback = '*'
  i1 = 1
  do iarg=1,sic_narg(optback)
    ! Translate the arguments and save them in a string
    call sic_ke(line,optback,iarg,fuser%cback(i1:),nchar,.true.,error)
    if (error)  return
    i1 = i1+nchar+1
  enddo
  !
  ! /OBSTYPE [List|*]
  fuser%cobst = '*'
  i1 = 1
  do iarg=1,sic_narg(optobst)
    ! Translate the arguments and save them in a string
    call sic_ke(line,optobst,iarg,fuser%cobst(i1:),nchar,.true.,error)
    if (error)  return
    i1 = i1+nchar+1
  enddo
  !
  ! /SWITCHMODE [List|*]
  fuser%cswit = '*'
  i1 = 1
  do iarg=1,sic_narg(optswit)
    ! Translate the arguments and save them in a string
    call sic_ke(line,optswit,iarg,fuser%cswit(i1:),nchar,.true.,error)
    if (error)  return
    i1 = i1+nchar+1
  enddo
  !
  ! /POLARIMETRY [YES|NO|*]
  fuser%cpola = '*'
  call sic_ke(line,optpola,1,fuser%cpola,nchar,.false.,error)
  if (error)  return
  !
  ! /SOURCE [sourcename|*]
  fuser%csour = '*'
  call sic_ke(line,optsour,1,fuser%csour,nchar,.false.,error)
  if (error)  return
  !
  ! /PROJID [projectid|*]
  fuser%cproj = '*'
  call sic_ch(line,optproj,1,fuser%cproj,nchar,.false.,error)
  if (error)  return
  !
  ! /FRONTEND [List|* *&*]
  fuser%cfron = user_find_allfront
  i1 = 1
  do iarg=1,sic_narg(optfron)
    ! Translate the arguments and save them in a string
    call sic_ch(line,optfron,iarg,fuser%cfron(i1:),nchar,.true.,error)
    if (error)  return
    i1 = i1+nchar+1
  enddo
  call sic_upper(fuser%cfron)
  !
  ! /COMPLETE [UNREADABLE|READABLE|NO|YES|*]
  fuser%ccomp = '*'
  call sic_ke(line,optcomp,1,fuser%ccomp,nchar,.false.,error)
  if (error)  return
  !
  ! /CALIBRATED [List|*]
  fuser%ccali = '*'
  i1 = 1
  do iarg=1,sic_narg(optcali)
    ! Translate the arguments and save them in a string
    call sic_ke(line,optcali,iarg,fuser%ccali(i1:),nchar,.true.,error)
    if (error)  return
    i1 = i1+nchar+1
  enddo
  !
  ! /SOLVED [List|*]
  fuser%csolv = '*'
  i1 = 1
  do iarg=1,sic_narg(optsolv)
    ! Translate the arguments and save them in a string
    call sic_ke(line,optsolv,iarg,fuser%csolv(i1:),nchar,.true.,error)
    if (error)  return
    i1 = i1+nchar+1
  enddo
  !
end subroutine mrtindex_find_parse
!
subroutine mrtindex_find_criter(user,criter,error)
  use gbl_message
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_interfaces, except_this=>mrtindex_find_criter
  use mrtindex_parse_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Convert the user inputs into selection criteria
  !---------------------------------------------------------------------
  type(user_calib_t),  intent(in)    :: user    !
  type(mrtindex_find_t), intent(out)   :: criter  !
  logical,             intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='FIND>CRITER'
  character(len=24) :: key
  character(len=obstype_length) :: myobst
  character(len=calstatus_length) :: mycali
  character(len=solstatus_length) :: mysolv
  character(len=backname_length) :: myback
  character(len=16) :: myfron
  character(len=3) :: myswit
  integer(kind=4) :: next,ipar,nc,ikey
  integer(kind=4), parameter :: mlist=10
  character(len=10) :: completeness(4)
  ! Data
  data completeness / 'UNREADABLE','READABLE','NO','YES' /
  !
  ! VERSION: not customizable
  criter%llast = .true.  ! Select last version only
  !
  ! /DATE [date|*]
  criter%ldate = user%cdate.ne.'*'
  if (criter%ldate) then
    call sic_parse_listi4(rname,user%cdate,criter%idate,mlist,error)
    if (error)  return
    if (any(criter%idate%i3(1:criter%idate%nlist).ne.1)) then
      call mrtindex_message(seve%e,rname,  &
        'Step other than 1 in /DATE list(s) not implemented')
      error = .true.
      return
    endif
  endif
  !
  ! /SCAN [iscan|*]
  criter%lscan = user%cscan.ne.'*'
  if (criter%lscan) then
    call sic_parse_listi4(rname,user%cscan,criter%iscan,mlist,error)
    if (error)  return
    if (any(criter%iscan%i3(1:criter%iscan%nlist).ne.1)) then
      call mrtindex_message(seve%e,rname,  &
        'Step other than 1 in /SCAN list(s) not implemented')
      error = .true.
      return
    endif
    ! Think twice if we support step lower or greater than 0
  endif
  !
  ! /BACKEND [backname|*]
  criter%lback = user%cback.ne.'*'
  if (criter%lback) then
    criter%iback(:) = -1  ! Means not set
    ipar = 0
    next = 1
    do
      call sic_next(user%cback(next:),myback,nc,next)
      if (nc.eq.0)  exit
      ipar = ipar+1
      call sic_ambigs(rname,myback,key,criter%iback(ipar),backends_mrtcal,  &
        nbackends_mrtcal+1,error)
      if (error)  return
      criter%iback(ipar) = criter%iback(ipar)-1  ! Because 'backends_mrtcal'
                                                 ! numbering starts at 0
      if (ipar.eq.nbackends_mrtcal)  exit
    enddo
  endif
  !
  ! /OBSTYPE [List|*]
  criter%lobst = user%cobst.ne.'*'
  if (criter%lobst) then
    criter%iobst(:) = -1  ! Means not set
    ipar = 0
    next = 1
    do
      call sic_next(user%cobst(next:),myobst,nc,next)
      if (nc.eq.0)  exit
      ipar = ipar+1
      call sic_ambigs(rname,myobst,key,criter%iobst(ipar),obstypes_mrtcal,  &
        nobstypes_mrtcal+1,error)
      if (error)  return
      criter%iobst(ipar) = criter%iobst(ipar)-1  ! Because 'obstypes_mrtcal'
                                                 ! numbering starts at 0
      if (ipar.eq.nobstypes_mrtcal)  exit
    enddo
  endif
  !
  ! /SWITCHMODE [List|*]
  criter%lswit = user%cswit.ne.'*'
  if (criter%lswit) then
    criter%iswit(:) = -1  ! Means not set
    ipar = 0
    next = 1
    do
      call sic_next(user%cswit(next:),myswit,nc,next)
      if (nc.eq.0)  exit
      ipar = ipar+1
      call sic_ambigs(rname,myswit,key,criter%iswit(ipar),switchmodes_mrtcal,  &
        nswitchmodes+1,error)
      if (error)  return
      criter%iswit(ipar) = criter%iswit(ipar)-1  ! Because 'switchmodes_mrtcal'
                                                 ! numbering starts at 0
      if (ipar.eq.nswitchmodes)  exit
    enddo
  endif
  !
  ! /POLARIMETRY [YES|NO|*]
  criter%lpola = user%cpola.ne.'*'
  if (criter%lpola) then
    call sic_ambigs(rname,user%cpola,key,ikey,polstatus,npolstatus,error)
    if (error)  return
    criter%ipola = ikey-1  ! Because 'polstatus' numbering starts at 0
  endif
  !
  ! /SOURCE [sourcename|*]
  criter%lsour = user%csour.ne.'*'
  if (criter%lsour) then
    criter%csour = user%csour
  endif
  !
  ! /PROJID [pojectid|*]
  criter%lproj = user%cproj.ne.'*'
  if (criter%lproj) then
    criter%cproj = user%cproj
  endif
  !
  ! /FRONTEND [recname|*]
  criter%lfron = user%cfron.ne.user_find_allfront
  if (criter%lfron) then
    criter%cfron(:) = ''  ! Means not set
    ipar = 0
    next = 1
    do
      call sic_next(user%cfron(next:),myfron,nc,next)
      if (nc.eq.0)  exit
      ipar = ipar+1
      criter%cfron(ipar) = myfron
      if (ipar.eq.mrtcal_indx_mfrontend)  exit
    enddo
  endif
  !
  ! /COMPLETE [UNREADABLE|READABLE|NO|YES|*]
  criter%lcomp = user%ccomp.ne.'*'
  if (criter%lcomp) then
    call sic_ambigs(rname,user%ccomp,key,ikey,completeness,4,error)
    if (error)  return
    !  UNREADABLE: complete_unreadable + complete_empty
    !  READABLE:   complete_partial + complete_full
    !  NO:         complete_unreadable + complete_empty + complete_partial
    !  YES:        complete_full
    ! Let's encode this as bits
    criter%icomp = 0  ! Fill with zeroes
    if (ikey.eq.1) then
      criter%icomp = ibset(criter%icomp,complete_unreadable)
      criter%icomp = ibset(criter%icomp,complete_empty)
    elseif (ikey.eq.2) then
      criter%icomp = ibset(criter%icomp,complete_partial)
      criter%icomp = ibset(criter%icomp,complete_full)
    elseif (ikey.eq.3) then
      criter%icomp = ibset(criter%icomp,complete_unreadable)
      criter%icomp = ibset(criter%icomp,complete_empty)
      criter%icomp = ibset(criter%icomp,complete_partial)
    elseif (ikey.eq.4) then
      criter%icomp = ibset(criter%icomp,complete_full)
    endif
  endif
  !
  ! /CALIBRATED [List|*]
  criter%lcali = user%ccali.ne.'*'
  if (criter%lcali) then
    criter%icali(:) = -1  ! Means not set
    ipar = 0
    next = 1
    do
      call sic_next(user%ccali(next:),mycali,nc,next)
      if (nc.eq.0)  exit
      ipar = ipar+1
      call sic_ambigs(rname,mycali,key,criter%icali(ipar),calstatus,  &
        ncalstatus,error)
      if (error)  return
      if (ipar.eq.ncalstatus)  exit
    enddo
  endif
  !
  ! /SOLVED [List|*]
  criter%lsolv = user%csolv.ne.'*'
  if (criter%lsolv) then
    criter%isolv(:) = -1  ! Means not set
    ipar = 0
    next = 1
    do
      call sic_next(user%csolv(next:),mysolv,nc,next)
      if (nc.eq.0)  exit
      ipar = ipar+1
      call sic_ambigs(rname,mysolv,key,criter%isolv(ipar),solstatus,  &
        nsolstatus,error)
      if (error)  return
      if (ipar.eq.nsolstatus)  exit
    enddo
  endif
  !
end subroutine mrtindex_find_criter
!
subroutine mrtindex_find(fuser,in,out,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_find
  use mrtindex_types
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ public
  !  Fill OUT index from IN index according to the user inputs
  !---------------------------------------------------------------------
  type(user_calib_t),      intent(in)    :: fuser   !
  type(mrtindex_optimize_t), intent(in)    :: in     !
  type(mrtindex_optimize_t), intent(inout) :: out    !
  logical,                 intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=entry_length) :: ient,jent,nfound,ielem
  type(mrtindex_find_t) :: criter
  integer(kind=4) :: list(in%next-1) ! Automatic array (assume in%next>1)
  integer(kind=4) :: is
  logical :: found
  !
  call mrtindex_find_criter(fuser,criter,error)
  if (error)  return
  !
  nfound = 0
  do jent=1,in%next-1
    ient = in%sort(jent)
    if (criter%llast) then
      if (.not.in%islast(ient))  cycle
    endif
    if (criter%lsour) then
      if (.not.match_string(in%source(ient),criter%csour)) cycle
    endif
    if (criter%lproj) then
      if (.not.match_string(in%projid(ient),criter%cproj)) cycle
    endif
    if (criter%lcomp) then
      if (.not.btest(criter%icomp,in%filstatus(ient)))  cycle
    endif
    if (criter%lpola) then
      if (in%polstatus(ient).ne.criter%ipola)  cycle
    endif
    ! /BACKEND: more complicated, comes after
    if (criter%lback) then
      found = .false.
      do is=1,nbackends_mrtcal
        if (criter%iback(is).lt.0)  exit  ! No more backends set
        if (in%backend(ient).eq.criter%iback(is)) then
          found = .true.
          exit
        endif
      enddo
      if (.not.found)  cycle
    endif
    ! /FRONTEND: less efficient, comes after
    if (criter%lfron) then
      if (.not.mrtindex_find_byfrontend(in%frontend(:,ient),criter%cfron))  cycle
      if (error)  return
    endif
    ! /OBSTYPE: more complicated, comes after
    if (criter%lobst) then
      found = .false.
      do is=1,nobstypes_mrtcal
        if (criter%iobst(is).lt.0)  exit  ! No more obstypes set
        if (in%obstype(ient).eq.criter%iobst(is)) then
          found = .true.
          exit
        endif
      enddo
      if (.not.found)  cycle
    endif
    ! /CALIBRATED: same
    if (criter%lcali) then
      found = .false.
      do is=1,ncalstatus
        if (criter%icali(is).lt.0)  exit  ! No more calibration statuses set
        if (in%calstatus(ient).eq.criter%icali(is)) then
          found = .true.
          exit
        endif
      enddo
      if (.not.found)  cycle
    endif
    ! /SOLVED: same
    if (criter%lsolv) then
      found = .false.
      do is=1,nsolstatus
        if (criter%isolv(is).lt.0)  exit  ! No more calibration statuses set
        if (in%solstatus(ient).eq.criter%isolv(is)) then
          found = .true.
          exit
        endif
      enddo
      if (.not.found)  cycle
    endif
    ! /SWITCHMODE: same
    if (criter%lswit) then
      found = .false.
      do is=1,nswitchmodes
        if (criter%iswit(is).lt.0)  exit  ! No more switchmodes set
        if (in%switchmode(ient).eq.criter%iswit(is)) then
          found = .true.
          exit
        endif
      enddo
      if (.not.found)  cycle
    endif
    ! /DATE: more complicated, comes last
    if (criter%ldate) then
      found = .false.
      do is=1,criter%idate%nlist
        if (in%dobs(ient).ge.criter%idate%i1(is) .and.  &
            in%dobs(ient).le.criter%idate%i2(is)) then
          found = .true.
          exit
        endif
      enddo
      if (.not.found)  cycle
    endif
    ! /SCAN: more complicated, comes last
    if (criter%lscan) then
      found = .false.
      do is=1,criter%iscan%nlist
        if (in%scan(ient).ge.criter%iscan%i1(is) .and.  &
            in%scan(ient).le.criter%iscan%i2(is)) then
          found = .true.
          exit
        endif
      enddo
      if (.not.found)  cycle
    endif
    !
    nfound = nfound+1
    list(nfound) = ient
  enddo
  !
  call reallocate_mrtoptimize(out,nfound,.false.,error)
  if (error)  return
  !
  out%next = 1
  do ient=1,nfound
    ielem = list(ient)
    call mrtindex_optimize_to_optimize(in,ielem,out,error)
    if (error)  exit
  enddo
  !
contains
  !
  function mrtindex_find_byfrontend(frontend,pattern) result(found)
    !-------------------------------------------------------------------
    ! Return true if the frontend list matches the list of patterns.
    ! See HELP MFIND /FRONTEND for details
    !-------------------------------------------------------------------
    logical :: found
    character(len=*), intent(in) :: frontend(:)
    character(len=*), intent(in) :: pattern(:)
    !
    integer(kind=4) :: ipattern,iampe,ipipe
    !
    found = .false.
    do ipattern=1,size(pattern)
      ! 3 main cases:
      ! - single band e.g. E090
      ! - dual band   e.g. E090&E230
      ! - dual band   e.g. E090|E230
      iampe = index(pattern(ipattern),'&')
      ipipe = index(pattern(ipattern),'|')
      if (iampe.gt.0) then
        found = mrtindex_find_byfrontend_dual(frontend,  &
                                              pattern(ipattern)(1:iampe-1),  &
                                              pattern(ipattern)(iampe+1:),  &
                                              .true.)
      elseif (ipipe.gt.0) then
        found = mrtindex_find_byfrontend_dual(frontend,  &
                                              pattern(ipattern)(1:ipipe-1),  &
                                              pattern(ipattern)(ipipe+1:),  &
                                              .false.)
      else
        found = mrtindex_find_byfrontend_single(frontend,  &
                                                pattern(ipattern))
      endif
      if (error)  return
      if (found)  return
    enddo
  end function mrtindex_find_byfrontend
  !
  function mrtindex_find_byfrontend_dual(frontend,pattern1,pattern2,  &
    land) result(found)
    !-------------------------------------------------------------------
    ! Return true if the frontend list is dual band and matches the 2
    ! pattern.
    !-------------------------------------------------------------------
    logical :: found
    character(len=*), intent(in) :: frontend(:)
    character(len=*), intent(in) :: pattern1
    character(len=*), intent(in) :: pattern2
    logical,          intent(in) :: land        ! Logical and, or logical or?
    !
    integer(kind=4) :: ifront,nfront
    logical :: found1,found2
    !
    nfront = 0
    found = .false.
    found1 = .false.
    found2 = .false.
    do ifront=1,size(frontend)
      if (frontend(ifront).eq.'')  exit
      nfront = nfront+1
      if (match_string(frontend(ifront),pattern1))  found1 = .true.
      if (match_string(frontend(ifront),pattern2))  found2 = .true.
    enddo
    if (nfront.ne.2) then
      found = .false.
    elseif (land) then  ! Logical and
      found = found1.and.found2
    else  ! Logical or
      found = found1.or.found2
    endif
  end function mrtindex_find_byfrontend_dual
  !
  function mrtindex_find_byfrontend_single(frontend,pattern) result(found)
    !-------------------------------------------------------------------
    ! Return true if the frontend list is single band and matches the
    ! pattern.
    !-------------------------------------------------------------------
    logical :: found
    character(len=*), intent(in) :: frontend(:)
    character(len=*), intent(in) :: pattern
    !
    integer(kind=4) :: ifront,nfront
    !
    nfront = 0
    found = .false.
    do ifront=1,size(frontend)
      if (frontend(ifront).eq.'')  exit
      nfront = nfront+1
      if (match_string(frontend(ifront),pattern))  found = .true.
    enddo
    if (nfront.ne.1)  found = .false.
  end function mrtindex_find_byfrontend_single
  !
end subroutine mrtindex_find

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_mfs
  use gbl_message
  !
  public :: mfs_comm
  private
  !
contains
  !
  subroutine mfs_comm(line,error)
    use image_def
    use gkernel_interfaces
    use file_buffers
    use uv_buffers
    use clean_buffers, only: clean_user,clean_prog
    !-----------------------------------------------
    !
    !-----------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: ixoff,iyoff
    !
    ! Get a default spectral index?
    call sic_i4(line,0,1,ixoff,.false.,error)
    iyoff = ixoff
    !
    call clean_user%copyto(clean_prog)
    call mfs_main(ixoff,iyoff,error)
    print *,'Mask off ',ixoff,iyoff
    !
    save_data(code_save_clean) = .true.
  end subroutine mfs_comm
  !
  subroutine mfs_main(ixoff,iyoff,error)
    use phys_const
    use image_def
    use gkernel_interfaces
    use mapping_interfaces
    use mapping_gaussian_tool
    use clean_beam_tool, only: init_convolve,convolve
    use cct_types
    use uv_buffers
    use uvmap_buffers
    use clean_buffers
    !-----------------------------------------------
    !
    !-----------------------------------------------
    integer, intent(inout) :: ixoff, iyoff
    logical, intent(inout) :: error
    !
    logical :: ok
    integer :: ier,ic
    integer :: i,j,k,l
    integer :: nx,ny,nc
    integer :: niter,miter
    integer :: ixb,jyb,ix,jy,ii(2),dim(2),ndim
    real :: mres,gain
    real(4) :: fact,xinc,yinc
    real(8) :: nu_0,nu_i
    real :: a_0,a_1,rval_0,rval_1,maxv,swc,tmp,area
    real :: a_00_p,a_11_p,a_01_p,a_10_p,delta
    real, allocatable :: local_wfft(:)
    real, allocatable :: idirty(:,:),aprime(:,:),rmask(:,:)
    real, allocatable :: b_0(:,:),b_1(:,:),tb(:,:)
    real, allocatable :: r_0(:,:),r_1(:,:),a_00(:,:),a_01(:,:),a_10(:,:),a_11(:,:)
    real, allocatable :: r_max(:,:),wc(:)
    complex, allocatable :: ftb_0(:,:),ftb_1(:,:),ft(:,:),tfb_0(:,:),tfb_1(:,:)
    type(cct_par), allocatable :: mycct(:)
    character(len=*), parameter :: rname='MFS>MAIN'
    !
    ! 3) The "flat" spectrum intensity is such that it has
    !  been observed with
    !  B_0 = TF [ sum_i ( s(u,v,nu_i) ) ]
    !
    ! 4)  The first order Taylor expansion indicates it has
    !  been observed with
    !  B_1 = TF [ sum_i ( (nu_i-nu_0)/nu_i) s(u,v,nu_i) ) ]
    !
    ! 5) higher (n-th) order terms have an exponent n
    !  (see Conway et al 1990 MNRAS 246, 490)
    !
    if (hbeam%loca%size.eq.0) then
       call map_message(seve%e,rname,'Beam not computed')
       error = .true.
       return
    endif
    !
    if (hbeam%gil%dim(3).ne.huv%gil%nchan) then
       call map_message(seve%e,rname,'Beam has not one plane per channel')
       error = .true.
       return
    endif
    !
    allocate(mycct(miter),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Cannot allocate Clean Component')
       error = .true.
       return
    endif
    !
    nx = hbeam%gil%dim(1)
    ny = hbeam%gil%dim(2)
    nc = hbeam%gil%dim(3)
    xinc = clean%head%gil%convert(3,1)
    yinc = clean%head%gil%convert(3,2)
    !
    allocate(b_0(nx,ny),b_1(nx,ny),idirty(nx,ny),aprime(nx,ny),&
         & rmask(nx,ny),tb(nx,ny),wc(nc),stat=ier)
    if (ier.ne.0) then
       print *,' NX NY ',nx,ny
       call map_message(seve%e,rname,'Beam memory allocation error')
       error = .true.
       return
    endif
    !
    ! Default mask
    rmask = 0.0
    ixoff = min(ixoff,nx/2)
    iyoff = min(iyoff,ny/2)
    do j=ny/2+1-iyoff,ny/2+iyoff
       do i=nx/2+1-ixoff,ny/2+ixoff
          rmask(i,j) = 1.0
       enddo
    enddo
    !
    nu_0 = gdf_uv_frequency(huv)
    b_0 = 0.0
    do ic=1,nc
       wc(ic) = maxval(hbeam%r3d(:,:,ic))
    enddo
    do ic=1,nc
       b_0 = b_0 + hbeam%r3d(:,:,ic)
    enddo
    swc = sum(wc)
    b_0 = b_0 / swc
    !
    b_1 = 0.0
    tmp = 0
    do ic=1,nc
       nu_i = gdf_uv_frequency(huv,dble(ic))
       print *,'NU ',nu_i,nu_0,(nu_i-nu_0)/nu_0
       b_1 = b_1 + (nu_i-nu_0)/nu_0 * hbeam%r3d(:,:,ic)
       tmp = tmp + wc(ic)*((nu_i-nu_0)/nu_0)**2
    enddo
    b_1 = b_1 / swc
    maxv = maxval(b_1)
    print *,'B_1 max ',maxv,' Guess ',tmp/2.0/swc
    !
    do ic=1,nc
       idirty(:,:) = idirty(:,:) + dirty%head%r3d(:,:,ic)
    enddo
    idirty = idirty / swc
    !
    ! Cleaning parameters
    if (clean_prog%ares.eq.0) then
       maxv = maxval(idirty)
       mres = clean_prog%fres * maxv
    else
       mres = clean_prog%ares
    endif
    !
    ! Get beam parameters
    call clean_prog%fit_beam(hbeam,b_0,error)
    if (error) return
    miter = clean_prog%m_iter
    gain  = clean_prog%gain
    !
    aprime = 0.0
    !
    ii = maxloc(b_0)
    ixb = ii(1)
    jyb = ii(2)
    print *,'IXB JYB ',ixb,jyb,b_0(ixb,jyb)
    print *,swc,'  WC ',wc
    !
    ! What are the beam and image normalisation ?
    !
    ! 6) for power laws spectral index, the scaling
    ! factor of each order is
    !
    !  I times prod_k(1 to n) (a'+k-1)
    !
    ! where a' = a-a_0,  a_0 being the "mean spectral index"
    ! and a' is the spatially dependent spectral index...
    !
    ! we thus have for order 1
    !   I times a'
    !
    ! B) Deconvolution: see Sault & Wieringa 1994, A&ASS 108, 585
    !
    ! Once we have B_0 and B_1, it involves several
    ! intermediate images
    ! R_0 = I ** B_0    (this not the "normal" iterated
    !  dirty image, but this image convolved by the
    !  "normal" dirty beam)
    ! R_1 = I ** B_1
    ! A_00 = B_0 ** B_0
    ! A_01 = B_0 ** B_1
    ! A_10 = B_1 ** B_0
    ! A_11 = B_1 ** B_1
    !
    ! Locate "j" which maximizes
    ! R_0(j)^2 A_11 + R_1(j)^2 A_00 - 2 R_0(j) R_1(j) A_01
    !
    ! Delta = A_00 A_11 - A_01 A_10 at beam center (pixel "0")
    !
    ! a_0 = (A_11(0) R_0(j) - A_01(0) R_1(j) ) / Delta
    ! a_1 = (A_00(0) R_1(j) - A_01(0) R_0(j) ) / Delta
    !
    !   and update I with shifted beams and coefficients
    ! a_0 g  and a_1 g where "g" is the loop gain.
    !   to find the next iterate I
    !
    allocate(r_0(nx,ny),r_1(nx,ny),a_00(nx,ny),a_01(nx,ny),&
         a_10(nx,ny),a_11(nx,ny), r_max(nx,ny), stat=ier)
    if (ier.ne.0) then
       print *,'NX NY ',nx,ny
       call map_message(seve%e,rname,'Aij memory allocation error')
       error = .true.
       return
    endif
    !
    allocate (ftb_0(nx,ny),ftb_1(nx,ny),ft(nx,ny),&
         tfb_0(nx,ny), tfb_1(nx,ny), local_wfft(2*max(nx,ny)),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'TF memory allocation error')
       error = .true.
       return
    endif
    !
    dim = [nx,ny]
    ndim = 2
    ! call convolve(a_00,b_0,b_0)
    ftb_0 = cmplx(b_0,0.0)
    call fourt(ftb_0,dim,ndim,-1,0,local_wfft)
    ftb_1 = cmplx(b_1,0.0)
    call fourt(ftb_1,dim,ndim,-1,0,local_wfft)
    ! Truncated beam TFs
    tb = b_0 * rmask
    call init_convolve (ixb,jyb,nx,ny,tb,tfb_0,area,local_wfft)
    tb = b_1 * rmask
    call init_convolve (ixb,jyb,nx,ny,tb,tfb_1,area,local_wfft)
    !
    call convolve (b_0,a_00,nx,ny,tfb_0,ft,local_wfft)
    print *,' a_00 ',a_00(ixb,jyb),maxval(a_00)
    !
    call convolve (b_0,a_01,nx,ny,tfb_1,ft,local_wfft)
    call convolve (b_1,a_10,nx,ny,tfb_0,ft,local_wfft)
    call convolve (b_1,a_11,nx,ny,tfb_1,ft,local_wfft)
    !
    !  Delta = A_00(ixb,jyb) * A_11(ixb,jyb) - A_01(ixb,jyb) * A_10(ixb,jyb)
    a_11_p = a_11(ixb,jyb)
    a_01_p = a_01(ixb,jyb)
    a_10_p = a_10(ixb,jyb)
    a_00_p = a_00(ixb,jyb)
    !
    Delta = A_00_P * A_11_P - A_01_P * A_10_P
    print *,'Terms in IXB, JYB ',ixb,jyb
    print *,'A_ij ',a_00_p,a_11_p, a_01_p,a_10_p
    print *,'Delta ', delta
    if (delta.eq.0.0) then
       call map_message(seve%e,rname,'Delta is NULL')
       error = .true.
       return
    endif
    !
    ! R_0 = I ** B_0
    call convolve (idirty,r_0,nx,ny,tfb_0,ft,local_wfft)
    ! R_1 = I ** B_1
    call convolve (idirty,r_1,nx,ny,tfb_1,ft,local_wfft)
    !
    ! LOOP HERE FOR NEXT ITERATION
    ok = .true.
    niter = 0
    !
    print *,'niter,  a_0,   a_1,  ix,   jy,  rval_0, rval_1 '
    do while (ok)
       ! Locate "ix,jy" which maximizes
       ! R_0(j)^2 A_11 + R_1(j)^2 A_00 - 2 R_0(j) R_1(j) A_01
       !
       ! We can put a MASK here if needed, or make
       ! an explicit loop over some "cleaning box" area
       r_max = r_0**2 * A_11_P + r_1**2 * A_00_P - 2 * r_0 * r_1 * A_01_P
       !
       ii = maxloc(r_max)
       ix = ii(1)
       jy = ii(2)
       rval_0 = r_0(ix,jy)
       rval_1 = r_1(ix,jy)
       ! a_0 = (A_11(0) R_0(j) - A_01(0) R_1(j) ) / Delta
       ! a_1 = (A_00(0) R_1(j) - A_01(0) R_0(j) ) / Delta
       a_0 = (a_11_p * rval_0 - a_01_p * rval_1 ) / Delta
       a_1 = (a_00_p * rval_1 - a_01_p * rval_0 ) / Delta
       print *,niter,a_0,a_1,ix,jy,rval_0,rval_1
       !
       ! Update I with a_0*g and a' = a-a_ref with a_1*g
       ! which is equivalent to
       !
       ! r_0(i) <-- r_0(i) - g * (a_0 * a_00(i-j) - a_1 * a_10(i-j))
       ! r_1(i) <-- r_1(i) - g * (a_0 * a_01(i-j) - a_1 * a_11(i-j))
       !
       do j=1,ny
          !
          ! Proceed Row by Row
          l = j-jy+jyb
          if (l.ge.1 .and. l.le.ny) then
             !
             ! Along that row, subtract clean component if in beam
             do i = 1,nx
                k = i-ix+ixb
                if (k.ge.1 .and. k.le.nx) then
                   r_0(i,j) = r_0(i,j) - gain * (a_0 * a_00(k,l) - a_1 * a_10(k,l))
                   r_1(i,j) = r_1(i,j) - gain * (a_0 * a_01(k,l) - a_1 * a_11(k,l))
                endif
             enddo
          endif
       enddo
       !
       ! Propagate the component list
       niter = niter+1
       mycct(niter)%value = gain * a_0       ! Store as fractions of beam max
       mycct(niter)%ix = ix
       mycct(niter)%iy = jy
       mycct(niter)%influx = gain * a_1      ! Use that as temporary storage for this type of Clean
       !
       ok = abs(a_0).gt.mres .and. niter.lt.miter
       print *,'OK ',niter,miter, abs(a_0), mres
    enddo
    !
    ! Now restore each of the two images
    call gildas_null(clean%head)
    call gdf_copy_header(dirty%head,clean%head,error)
  !
    clean%head%char%code(3) = 'INDEX'
    clean%head%gil%dim(3) = 2
    clean%head%gil%ref(3) = 1.d0
    clean%head%gil%val(3) = 0.d0
    clean%head%gil%inc(3) = 1.d0
    !
    allocate (clean%data(nx,ny,2),stat=ier)
    !
    ! Beam Area = PI * BMAJ * BMIN / (4 * LOG(2) ) for flux density
    ! normalisation
    fact = clean_prog%major*clean_prog%minor*pi/(4.0*log(2.0))   &
         &    /abs(xinc*yinc)/(nx*ny)
    !
    ! 1) Normal Clean Image
    ft = cmplx(0.0,0.0)
    do ic=1,niter
       ix = mycct(ic)%ix
       jy = mycct(ic)%iy
       ft(ix,jy) = ft(ix,jy) + mycct(ic)%value
    enddo
    call fourt(ft,dim,ndim,-1,0,local_wfft)
    call mulgau(ft,nx,ny,&
         clean_prog%major,clean_prog%minor,clean_prog%angle,&
         fact,xinc,yinc)
    call fourt(ft,dim,ndim,1,1,local_wfft)
    clean%data(:,:,1) = real(ft) ! Extract real part
    !
    ! 2) Pseudo-Spectral Index Map
    ft = cmplx(0.0,0.0)
    do ic=1,niter
       ix = mycct(ic)%ix
       jy = mycct(ic)%iy
       ft(ix,jy) = ft(ix,jy) + mycct(ic)%influx
    enddo
    call fourt(ft,dim,ndim,-1,0,local_wfft)
    call mulgau(ft,nx,ny,   &
         &    clean_prog%major,clean_prog%minor,clean_prog%angle,   &
         &    fact,xinc,yinc)
    call fourt(ft,dim,ndim,1,1,local_wfft)
    clean%data(:,:,2) = real(ft)
    !
    ! Done...
    clean%head%gil%extr_words = 0
    ! Specify clean beam parameters
    clean%head%gil%reso_words = 3
    clean%head%gil%majo = clean_prog%major
    clean%head%gil%mino = clean_prog%minor
    clean%head%gil%posa = pi*clean_prog%angle/180.0
    clean%head%r3d => clean%data
    !
    clean_prog%n_iter = niter
  end subroutine mfs_main
end module clean_mfs
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE SETUP_ELEMENTS(ERROR)
C------------------------------------------------------------------------------
C   Initialize the element's internal common
C------------------------------------------------------------------------------
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
      INCLUDE 'elements.inc'
*
      INTEGER I,IELM,IORB
*
* Initialize the description of the orbit setup for the various supported
* hierarchical multiple  configurations
* Position of the elements of each orbit in global element array
      DO I=1,MORBIT
         ELINDX(I) = 7+(11+4*MVREF)*(I-1) 
      ENDDO
* Orbit names
      ORBNAME(IORB0) = ' ' ! Outer orbit is unnamed
      ORBNAME(IORB1) = '_1'
      ORBNAME(IORB2) = '_2'
* Orbit list for each configuration
      LISTORB0(1) = IORB0
      LISTORB1(1) = IORB0
      LISTORB1(2) = IORB1
      LISTORB2(1) = IORB0
      LISTORB2(2) = IORB2
      LISTORBALL(1) = IORB0
      LISTORBALL(2) = IORB1
      LISTORBALL(3) = IORB2
* Names of points for which a velocity can be measured
      COMPNAME(1,IORB0) = '1'
      COMPNAME(2,IORB0) = '2'
      COMPNAME(1,IORB1) = '11'
      COMPNAME(2,IORB1) = '12'
      COMPNAME(1,IORB2) = '21'
      COMPNAME(2,IORB2) = '22'
      COMPONENTS(1,IORB0) = 1
      COMPONENTS(2,IORB0) = 2
      COMPONENTS(1,IORB1) = 11
      COMPONENTS(2,IORB1) = 12
      COMPONENTS(1,IORB2) = 21
      COMPONENTS(2,IORB2) = 22
      LISTCOMPALL(1) = 1
      LISTCOMPALL(2) = 2
      LISTCOMPALL(3) = 11
      LISTCOMPALL(4) = 12
      LISTCOMPALL(5) = 21
      LISTCOMPALL(6) = 22
* Define elements' names and display formats. 
      DO I=1,MORBIT
         IORB = LISTORBALL(I)
*
         IELM = I_PERIOD+ELINDX(IORB)
         ELFMT(IELM) = 'F10.5'
         NAMEL(IELM) =  'P'//ORBNAME(IORB)
         IELM = I_T0+ELINDX(IORB)
         ELFMT(IELM) = 'F10.3'
         NAMEL(IELM) = 'T0'//ORBNAME(IORB)
         IELM = I_Ecc+ELINDX(IORB)    
         ELFMT(IELM) = 'F10.3'
         NAMEL(IELM) = 'Ecc'//ORBNAME(IORB)
         IELM = I_as+ELINDX(IORB)
         ELFMT(IELM) = 'F10.3'
         NAMEL(IELM) = 'as'//ORBNAME(IORB)
         IELM = I_OMEGA_U+ELINDX(IORB)
         NAMEL(IELM) = 'OM'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.2'  
         IELM = I_OMEGA_L+ELINDX(IORB)
         NAMEL(IELM) = 'om'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.2'  
         IELM = I_i+ELINDX(IORB)
         NAMEL(IELM) = 'i'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.2'  
         IELM = I_K1+ELINDX(IORB)
         NAMEL(IELM) = 'K1'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.3'  
         IELM = I_K2+ELINDX(IORB)
         NAMEL(IELM) = 'K2'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.3' 
         IELM = I_DELTV1+ELINDX(IORB)
         NAMEL(IELM) = 'DELTV1'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.3'  ! 
         IELM = I_DELTV2+ELINDX(IORB)
         NAMEL(IELM) = 'DELTV2'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.3'  ! 
         IELM = I_W1+ELINDX(IORB)
         NAMEL(IELM) = 'W1'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.2'  ! Should be replaced
         IELM = I_W2+ELINDX(IORB)
         NAMEL(IELM) = 'W2'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.2'  ! Should be replaced
         IELM = I_EW1+ELINDX(IORB)
         NAMEL(IELM) = 'EW1'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.2'  ! Should be replaced
         IELM = I_EW2+ELINDX(IORB)
         NAMEL(IELM) = 'EW2'//ORBNAME(IORB)
         ELFMT(IELM) = 'F10.2'  ! Should be replaced
*
      ENDDO
      DO I = MELEM+1, MELEM+MVREF-1
      ENDDO
      NAMEL(I_V0) = 'V0 '
      NAMEL(I_X0) = 'X0 '
      NAMEL(I_Y0) = 'Y0 '
      NAMEL(I_MuX) = 'muX '
      NAMEL(I_MuY) = 'muY '
      NAMEL(I_EPOCH) = 'EPOCH '
      DO I=MELEM+1,MELEM+MVREF-1
         NAMEL(I) = ' '
         ELFMT(I) = 'F10.4'
      ENDDO
*
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_twosubc2onesubc
  use cubetools_structure
  use cubetemplate_two2one_template
  use cubetemplate_twosubc2onesubc_template
  use cubetemplate_factor_types
  use cubetopology_cuberegion_types
  use cubetemplate_messaging
  !
  public :: twosubc2onesubc
  private
  !
  type, extends(twosubc2onesubc_comm_t) :: ext_twosubc2onesubc_comm_t
     type(factor_comm_t)     :: factor
     type(cuberegion_comm_t) :: region
   contains
     procedure, public :: register => cubetemplate_ext_twosubc2onesubc_comm_register
     procedure, public :: parse    => cubetemplate_ext_twosubc2onesubc_comm_parse
  end type ext_twosubc2onesubc_comm_t
  type(ext_twosubc2onesubc_comm_t) :: twosubc2onesubc
  !
  type, extends(twosubc2onesubc_user_t) :: ext_twosubc2onesubc_user_t
     type(factor_user_t)     :: factor
     type(cuberegion_user_t) :: region
   contains
     procedure, public :: toprog => cubetemplate_ext_twosubc2onesubc_user_toprog
  end type ext_twosubc2onesubc_user_t
  !
  type, extends(twosubc2onesubc_prog_t) :: ext_twosubc2onesubc_prog_t
     type(cuberegion_prog_t) :: region
     type(factor_prog_t)     :: factor
   contains
     procedure, private :: act => cubetemplate_ext_twosubc2onesubc_prog_act
  end type ext_twosubc2onesubc_prog_t
  !
contains
  !
  subroutine cubetemplate_twosubc2onesubc_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(ext_twosubc2onesubc_user_t) :: user
    type(ext_twosubc2onesubc_prog_t) :: prog
    character(len=*), parameter :: rname='TWOSUBC2ONESUBC>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call twosubc2onesubc%command(line,user,prog,error)
    if (error) return
  end subroutine cubetemplate_twosubc2onesubc_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_twosubc2onesubc_comm_register(comm,error)
    use cubedag_allflags
    use cubeadm_cubeid_types
    use cubeadm_cubeprod_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_twosubc2onesubc_comm_t), intent(inout) :: comm
    logical,                           intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: comm_abstract = 'Template command to access input/output data per subcubes'
    character(len=*), parameter :: comm_help = 'Input and output cubes are real'
    character(len=*), parameter :: rname='TWOSUBC2ONESUBC>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'TWOSUBC2ONESUBC','[cube1] [cube2]',&
         comm_abstract,&
         comm_help,&
         cubetemplate_twosubc2onesubc_command,&
         comm%comm,error)
    if (error) return
    call incube%register(&
         'FIRST',&
         'First cube',&
         strg_id,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         comm%incube1,&
         error)
    if (error) return
    call incube%register(&
         'SECOND',&
         'Second cube',&
         strg_id,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         comm%incube2,&
         error)
    if (error) return
    call comm%factor%register(error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(  &
         'OUTPUT',  &
         'The result of the command',  &
         strg_id,  &
         [flag_template],  &
         comm%oucube,  &
         error)
    if (error)  return
  end subroutine cubetemplate_ext_twosubc2onesubc_comm_register
  !
  subroutine cubetemplate_ext_twosubc2onesubc_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! TWOSUBC2ONESUBC [cubeid1] [cubeid2]
    !----------------------------------------------------------------------
    class(ext_twosubc2onesubc_comm_t), intent(in)    :: comm
    character(len=*),                  intent(in)    :: line
    class(two2one_user_t),             intent(out)   :: user
    logical,                           intent(inout) :: error
    !
    type(ext_twosubc2onesubc_user_t), pointer :: iuser
    character(len=*), parameter :: rname='EXT>TWOSUBC2ONESUBC>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    iuser => ext_twosubc2onesubc_user_ptr(user,error)
    if (error)  return
    call comm%two2one_comm_t%parse(line,iuser,error)
    if (error) return
    call comm%region%parse(line,iuser%region,error)
    if (error) return
    call comm%factor%parse(line,iuser%factor,error)
    if (error) return
  end subroutine cubetemplate_ext_twosubc2onesubc_comm_parse
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_twosubc2onesubc_user_toprog(user,comm,prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_twosubc2onesubc_user_t), intent(in)    :: user
    class(two2one_comm_t),             intent(in)    :: comm
    class(two2one_prog_t),             intent(inout) :: prog
    logical,                           intent(inout) :: error
    !
    type(ext_twosubc2onesubc_prog_t), pointer :: iprog
    character(len=*), parameter :: rname='TWOSUBC2ONESUBC>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%two2one_user_t%toprog(comm,prog,error)
    if (error) return
    !
    iprog => ext_twosubc2onesubc_prog_ptr(prog,error)
    if (error)  return
    call user%factor%toprog(iprog%factor,error)
    if (error) return
    call user%region%toprog(iprog%incube1,iprog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call iprog%factor%list(error)
    if (error) return
    call iprog%region%list(error)
    if (error) return
  end subroutine cubetemplate_ext_twosubc2onesubc_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_twosubc2onesubc_prog_act(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_twosubc2onesubc_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),          intent(in)    :: iter
    logical,                           intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    type(subcube_t) :: insub1,insub2,ousub
    character(len=*), parameter :: rname='TWOSUBC2ONESUBC>PROG>ACT'
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube to another.
    call insub1%associate('insub1',prog%incube1,iter,error)
    if (error) return
    call insub2%associate('insub2',prog%incube2,iter,error)
    if (error) return
    call ousub%allocate('ousub',prog%oucube,iter,error)
    if (error) return
    !
    call insub1%get(error)
    if (error) return
    call insub2%get(error)
    if (error) return
    do iz=1,insub1%nz
       do iy=1,insub1%ny
          do ix=1,insub1%nx
             ousub%val(ix,iy,iz) = prog%factor%val*insub1%val(ix,iy,iz)+insub2%val(ix,iy,iz)
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call ousub%put(error)
    if (error) return
  end subroutine cubetemplate_ext_twosubc2onesubc_prog_act
  !
  !----------------------------------------------------------------------
  !
  function ext_twosubc2onesubc_user_ptr(user,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(ext_twosubc2onesubc_user_t), and
    ! return a pointer to it if yes.
    !-------------------------------------------------------------------
    type(ext_twosubc2onesubc_user_t), pointer       :: ext_twosubc2onesubc_user_ptr
    class(two2one_user_t),            target        :: user
    logical,                          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXT>TWOSUBC2ONESUBC>USER>PTR'
    !
    select type(user)
    type is (ext_twosubc2onesubc_user_t)
      ext_twosubc2onesubc_user_ptr => user
    class default
      ext_twosubc2onesubc_user_ptr => null()
      call cubetemplate_message(seve%e,rname,  &
        'Internal error: object is not a ext_twosubc2onesubc_user_t type')
      error = .true.
      return
    end select
  end function ext_twosubc2onesubc_user_ptr
  !
  function ext_twosubc2onesubc_prog_ptr(prog,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(ext_twosubc2onesubc_prog_t), and
    ! return a pointer to it if yes.
    !-------------------------------------------------------------------
    type(ext_twosubc2onesubc_prog_t), pointer       :: ext_twosubc2onesubc_prog_ptr
    class(two2one_prog_t),            target        :: prog
    logical,                          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXT>TWOSUBC2ONESUBC>PROG>PTR'
    !
    select type(prog)
    type is (ext_twosubc2onesubc_prog_t)
      ext_twosubc2onesubc_prog_ptr => prog
    class default
      ext_twosubc2onesubc_prog_ptr => null()
      call cubetemplate_message(seve%e,rname,  &
        'Internal error: object is not a ext_twosubc2onesubc_prog_t type')
      error = .true.
      return
    end select
  end function ext_twosubc2onesubc_prog_ptr
end module cubetemplate_twosubc2onesubc
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_language
  use cubetools_parameters
  use cubetools_structure
  use cubego_messaging
  use cubego_bit
  use cubego_hyperbit
  use cubego_browse
  use cubego_load
  use cubego_oldload
  use cubego_show
  use cubego_spectrum
  use cubego_topology
  use cubego_view
  use cubego_hyperview
  !
  public :: cubego_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubego_register_language(error)
    !----------------------------------------------------------------------
    ! Register the GO\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'GO',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Commands to visualize or interact with a cube',&
         'GO provides inspection and visualization commands for cubes.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- VIEW and HYPERVIEW display cubes with iterator-aware navigation.'//strg_cr//&
         '- BIT and HYPERBIT render channel-map mosaics.'//strg_cr//&
         '- BROWSE and SPECTRUM inspect spectral content.'//strg_cr//&
         '- LOAD and OLDLOAD copy data/header values into SIC variables.'//strg_cr//&
         '- SHOW and TOPOLOGY summarize cube families and region structure.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> GO\VIEW mycube'//strg_cr//&
         'CUBE> GO\SPECTRUM mycube'//strg_cr//&
         'CUBE> GO\TOPOLOGY mycube'//strg_bl//&
         'Note:'//strg_cr//&
         'GO commands use defaults configured by SET when options are omitted.',&
         'gag_doc:hlp/cube-help-go.hlp',&
         cubego_execute_command,&
         langid,&
         error)
    if (error) return
    call bit%register(error)
    if (error) return
    call hyperbit%register(error)
    if (error) return
    call browse%register(error)
    if (error) return
    call load%register(error)
    if (error) return
    call cubego_oldload_register(error)
    if (error) return
    call show%register(error)
    if (error) return
    call spectrum%register(error)
    if (error) return
    call topology%register(error)
    if (error) return
    call view%register(error)
    if (error) return
    call hyperview%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubego_register_language
  !
  subroutine cubego_execute_command(line,comm,error)
    use cubetools_parameters
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the GO\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'GO?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubeadm_finish_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
       if (error) return
    endif
  end subroutine cubego_execute_command
end module cubego_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesimulate_observatory
  use phys_const
  use cubetools_parameters
  use cubetools_structure
  use cubetools_obstel_prog_types
  use cubesyntax_keyval_types
  use cubesimulate_messaging
  !
  public :: observatory_comm_t,observatory_prog_t
  public :: observatory_comm,observatory_prog
  private
  !
  type :: observatory_comm_t
     type(option_t), pointer      :: comm
     type(keyval_strg_comm_t)     :: name
     type(keyvalunit_real_comm_t) :: horizon
   contains
     procedure, public  :: register => cubesimulate_observatory_comm_register
     procedure, private :: parse    => cubesimulate_observatory_comm_parse
     procedure, private :: main     => cubesimulate_observatory_comm_main
  end type observatory_comm_t
  type(observatory_comm_t), target :: observatory_comm
  !
  type observatory_user_t
     logical :: dolist = .false.
     type(keyval_strg_user_t) :: name
     type(keyvalunit_real_user_t) :: horizon
   contains
     procedure, private :: toprog => cubesimulate_observatory_user_toprog
  end type observatory_user_t
  !
  type :: observatory_prog_t
     character(len=tele_l) :: name = 'NOEMA'
     type(obstel_prog_t)   :: tel
     real(kind=real_k) :: horizon = 20d0*rad_per_deg ! [rad] Horizon (i.e. minimum elevation)
     real(kind=coor_k) :: matrix(9) = 0d0            ! [---] Matrix from Hr/Dec to Az/El
   contains
     procedure, public  :: list   => cubesimulate_observatory_prog_list
     procedure, private :: header => cubesimulate_observatory_prog_header
  end type observatory_prog_t
  type(observatory_prog_t), target :: observatory_prog
  !
contains
  !
  subroutine cubesimulate_observatory_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(observatory_user_t) :: user
    character(len=*), parameter :: rname='OBSERVATORY>COMMAND'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call observatory_comm%parse(line,user,error)
    if (error) return
    call observatory_comm%main(user,observatory_prog,error)
    if (error) continue
  end subroutine cubesimulate_observatory_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubesimulate_observatory_comm_register(comm,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(observatory_comm_t), intent(inout) :: comm
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>COMM>REGISTER'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'OBSERVATORY','',&
         'Set or list the observatory setup',&
         'Without options, list the current observatory name, telescope&
         & metadata, and horizon. /NAME and /HORIZON update the shared&
         & observatory setup used by simulate commands. /HORIZON must stay&
         & within [3,90] degree after unit conversion.',&
         cubesimulate_observatory_command,&
         comm%comm,&
         error)
    if (error) return
    call comm%name%register(&
         'NAME',&
         'Observatory name to load',&
         strg_emp,&
         observatory_prog%name,&
         'Observatory name. Default is NOEMA. Unknown names are&
         & accepted, but telescope coordinates can remain undefined (NaN).',&
         error)
    if (error) return
    call comm%horizon%register(&
         'HORIZON',&
         'Minimum elevation cutoff',&
         strg_emp,&
         observatory_prog%horizon,&
         code_unit_pang,&
         'Use "*" to keep the default value (20 degree). The horizon&
         & must be in [3,90] degree after unit conversion.',&
         error)
    if (error) return
  end subroutine cubesimulate_observatory_comm_register
  !
  subroutine cubesimulate_observatory_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! OBSERVATORY /NAME name
    !----------------------------------------------------------------------
    class(observatory_comm_t), intent(in)    :: comm
    character(len=*),          intent(in)    :: line
    type(observatory_user_t),  intent(out)   :: user
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>COMM>PARSE'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    if (cubetools_nopt().eq.0) then
       user%dolist = .true.
    else
       user%dolist = .false.
       call comm%name%parse(line,user%name,error)
       if (error) return
       call comm%horizon%parse(line,user%horizon,error)
       if (error) return
    endif
  end subroutine cubesimulate_observatory_comm_parse
  !
  subroutine cubesimulate_observatory_comm_main(comm,user,prog,error) 
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(observatory_comm_t), intent(in)    :: comm
    type(observatory_user_t),  intent(inout) :: user
    type(observatory_prog_t),  intent(inout) :: prog
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>COMM>MAIN'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    if (user%dolist) then
       call prog%header(comm,error)
       if (error) return
       call prog%list(comm,error)
       if (error) return
    else
       call user%toprog(comm,prog,error)
       if (error) return
       call prog%header(comm,error)
       if (error) return
    endif
  end subroutine cubesimulate_observatory_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_observatory_user_toprog(user,comm,prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(observatory_user_t), intent(in)    :: user
    type(observatory_comm_t),  intent(in)    :: comm    
    type(observatory_prog_t),  intent(out)   :: prog
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>USER>TOPROG'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call user%name%toprog(comm%name,prog%name,error)
    if (error) return
    call user%horizon%toprog(comm%horizon,prog%horizon,error)
    if (error) return
  end subroutine cubesimulate_observatory_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_observatory_prog_header(prog,comm,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(observatory_prog_t), intent(inout) :: prog
    type(observatory_comm_t),  intent(in)    :: comm
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>PROG>HEADER'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call prog%tel%create_from_name(prog%name,error)
    if (error) return
    prog%matrix = hrdec2azel_matrix(prog%tel%lat)
    call check_horizon(prog%horizon*deg_per_rad,error)
    if (error) return
    !
  contains
    !
    function hrdec2azel_matrix(latitude) result(matrix)
      !---------------------------------------------------------------------
      ! Define the matrix to translate from Hr/Dec to Az/El
      !---------------------------------------------------------------------
      real(kind=coor_k), intent(in) :: latitude
      real(kind=coor_k)             :: matrix(9)  ! intent(out)
      !
      real(kind=coor_k) :: sinlat,coslat
      !
      sinlat=dsin(latitude)
      coslat=dcos(latitude)
      matrix(1)=-sinlat
      matrix(2)=0.d0
      matrix(3)=coslat
      matrix(4)=0.d0
      matrix(5)=-1.d0
      matrix(6)=0.d0
      matrix(7)=coslat
      matrix(8)=0.d0
      matrix(9)=sinlat
    end function hrdec2azel_matrix
    !
    subroutine check_horizon(horizon,error)
      real(kind=coor_k), intent(in)    :: horizon
      logical,           intent(inout) :: error
      !
      if (horizon.lt.3d0) then
         ! Too low
         call cubesimulate_message(seve%e,rname,'Observatory horizon lower than 3 deg')
         error = .true.
         return
      else if (horizon.gt.90d0) then
         ! Too high
         call cubesimulate_message(seve%e,rname,'Observatory horizon larger than 90 deg')
         error = .true.
         return
      endif
    end subroutine check_horizon
  end subroutine cubesimulate_observatory_prog_header
  !
  subroutine cubesimulate_observatory_prog_list(prog,comm,error)
    use cubetools_unit
    use cubesyntax_keyvalunit_list_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(observatory_prog_t), intent(inout) :: prog
    type(observatory_comm_t),  intent(in)    :: comm
    logical,                   intent(inout) :: error
    !
    type(keyvalunit_real_prog_t) :: keyvalunit_real
    character(len=*), parameter :: rname='OBSERVATORY>PROG>LIST'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call cubesimulate_message(seve%r,rname,blankstr)
    call cubesimulate_message(seve%r,rname,'Observatory')
    !
    call prog%tel%list(error)
    if (error) return
    call keyvalunit_real%list(comm%horizon,prog%horizon,error)
    if (error) return
  end subroutine cubesimulate_observatory_prog_list
end module cubesimulate_observatory
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gsys_interfaces_public
  interface
    subroutine sic_ambigs(prog,line,comm,ncom,vocab,nv,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Resolves command abbreviations and check for ambiguities
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: prog       ! Message prefix
      character(len=*), intent(in)    :: line       ! Abbreviation to be analysed
      character(len=*), intent(out)   :: comm       ! Command found
      integer(kind=4),  intent(out)   :: ncom       ! Command number
      integer(kind=4),  intent(in)    :: nv         ! List of commands
      character(len=*), intent(in)    :: vocab(nv)  ! Number of command
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine sic_ambigs
  end interface
  !
  interface
    subroutine sic_ambigs_sub(prog,line,comm,ncom,vocab,nv,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Still to be renamed
      ! Same as 'sic_ambigs' but:
      !  - do not recognize "?" which can be used to list all the
      !    possible values,
      !  - do not raise an error if no known keyword is found.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: prog       ! Message prefix
      character(len=*), intent(in)    :: line       ! Abbreviation to be analysed
      character(len=*), intent(out)   :: comm       ! Command found
      integer(kind=4),  intent(out)   :: ncom       ! Command number
      integer(kind=4),  intent(in)    :: nv         ! List of commands
      character(len=*), intent(in)    :: vocab(nv)  ! Number of command
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine sic_ambigs_sub
  end interface
  !
  interface
    subroutine sic_ambigs_list(caller,sever,message,vocab,ikeys,first,last)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Display an ambiguity list
      !---------------------------------------------------------------------
      character(len=*), intent(in)                   :: caller    ! Calling routine name
      integer(kind=4),  intent(in)                   :: sever     ! Severity of header message
      character(len=*), intent(in)                   :: message   ! Header message before list
      character(len=*), intent(in)                   :: vocab(:)  ! List of keywords
      integer(kind=4),  intent(in), optional, target :: ikeys(:)  ! Restrict to these keys?
      integer(kind=4),  intent(in), optional         :: first     ! Truncate start of string?
      integer(kind=4),  intent(in), optional         :: last      ! Truncate or force to this length?
    end subroutine sic_ambigs_list
  end interface
  !
  interface gag_infini
    subroutine gag_infini4(anum,string,ndg)
      !---------------------------------------------------------------------
      ! @ public-generic gag_infini
      ! Format Invalid Numbers (single precision version)
      !---------------------------------------------------------------------
      real(kind=4),     intent(in)  :: anum    ! Number
      character(len=*), intent(out) :: string  ! Representation
      integer(kind=4),  intent(out) :: ndg     ! Length of string
    end subroutine gag_infini4
    subroutine gag_infini8(anum,string,ndg)
      !---------------------------------------------------------------------
      ! @ public-generic gag_infini
      ! Format Invalid Numbers (double precision version)
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)  :: anum    ! Number
      character(len=*), intent(out) :: string  ! Representation
      integer(kind=4),  intent(out) :: ndg     ! Length of string
    end subroutine gag_infini8
  end interface gag_infini
  !
  interface gag_notanum
    subroutine gag_notanum4(notanum)
      !---------------------------------------------------------------------
      ! @ public-generic gag_notanum
      ! Return the value of NaN (R*4 version)]
      !  An IEEE signaling NaN is represented by any bit pattern
      !    between X'7F80 0001' and X'7FBF FFFF', or
      !    between X'FF80 0001' and X'FFBF FFFF'.
      !  An IEEE quiet NaN is represented by any bit pattern
      !    between X'7FC0 0000' and X'7FFF FFFF', or
      !    between X'FFC0 0000' and X'FFFF FFFF'.
      !---------------------------------------------------------------------
      real(kind=4), intent(out) :: notanum  ! NaN value
    end subroutine gag_notanum4
    subroutine gag_notanum8(notanum)
      !---------------------------------------------------------------------
      ! @ public-generic gag_notanum
      ! Return the value of NaN (R*8 version)
      !  An IEEE signaling NaN is represented by any bit pattern
      !    between X'7FF00000 00000001' and X'7FF7FFFF FFFFFFFF', or
      !    between X'FFF00000 00000001' and X'FFF7FFFF FFFFFFFF'.
      !  An IEEE quiet NaN is represented by any bit pattern
      !    between X'7FF80000 00000000' and X'7FFFFFFF FFFFFFFF', or
      !    between X'FFF80000 00000000' and X'FFFFFFFF FFFFFFFF'.
      !---------------------------------------------------------------------
      real(kind=8), intent(out) :: notanum  ! NaN value
    end subroutine gag_notanum8
  end interface gag_notanum
  !
  interface
    function sic_ctrlc()
      use gsys_variables
      !---------------------------------------------------------------------
      ! @ public
      ! Return .TRUE. if ^C has been pressed, and restore CONTROLC flag to
      ! .FALSE.
      !---------------------------------------------------------------------
      logical :: sic_ctrlc  ! Function value on return
    end function sic_ctrlc
  end interface
  !
  interface
    function sic_ctrlc_status()
      use gsys_variables
      !---------------------------------------------------------------------
      ! @ public
      ! Return .TRUE. if ^C has been pressed but do *not* restore CONTROLC
      ! flag to .FALSE.
      !---------------------------------------------------------------------
      logical :: sic_ctrlc_status  ! Function value on return
    end function sic_ctrlc_status
  end interface
  !
  interface
    subroutine gag_fromdate(date,idate,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Converts the date '01-JAN-1984' in internal code
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: date   ! String date
      integer(kind=4),  intent(out)   :: idate  ! Internal coded date value
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_fromdate
  end interface
  !
  interface
    subroutine gag_todate(idate,date,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Converts the internal code to formatted date
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: idate  ! Internal coded date value
      character(len=*), intent(out)   :: date   ! String date
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_todate
  end interface
  !
  interface
    subroutine gag_fromyyyymmdd(string,dobs,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Decode a string date in the format "YYYYMMDD" into a gag date
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: string  !
      integer(kind=4),  intent(out)   :: dobs    !
      logical,          intent(inout) :: error   !
    end subroutine gag_fromyyyymmdd
  end interface
  !
  interface
    subroutine gag_toyyyymmdd(dobs,string,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Encode a gag date to a string date in the format "YYYYMMDD"
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: dobs    !
      character(len=*), intent(out)   :: string  !
      logical,          intent(inout) :: error   !
    end subroutine gag_toyyyymmdd
  end interface
  !
  interface
    subroutine gag_isodate(date,idate,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Converts the ISO #8601 date '1996-10-14T10:34:55.345' in internal
      ! code.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: date   ! String date
      integer(kind=4),  intent(out)   :: idate  ! Internal coded date value
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_isodate
  end interface
  !
  interface
    subroutine gag_toisodate(idate,date,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Converts the internal code to ISO formatted date
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: idate  ! Internal coded date value
      character(len=*), intent(out)   :: date   ! String date
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_toisodate
  end interface
  !
  interface
    subroutine isodate_to_gagdate(date,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Converts an ISO date representation to a GAG (DD-Monthname-YY) date
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: date   ! String date
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine isodate_to_gagdate
  end interface
  !
  interface
    subroutine gagdate_to_isodate(date,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Converts an ISO date representation to a GAG (DD-Monthname-YY) date
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: date   ! String date
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gagdate_to_isodate
  end interface
  !
  interface
    subroutine gag_datj(id,im,iy,jour)
      !---------------------------------------------------------------------
      ! @ public
      !   Convert a date (id/im/iy) in number of days till the 01/01/1984
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: id    ! Day number
      integer(kind=4), intent(in)  :: im    ! Month number
      integer(kind=4), intent(in)  :: iy    ! Year number
      integer(kind=4), intent(out) :: jour  ! Elapsed day count
    end subroutine gag_datj
  end interface
  !
  interface
    subroutine gag_jdat(jour,id,im,iy)
      !---------------------------------------------------------------------
      ! @ public
      ! Reverse conversion
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: jour  ! Elapsed day count
      integer(kind=4), intent(out) :: id    ! Day number
      integer(kind=4), intent(out) :: im    ! Month number
      integer(kind=4), intent(out) :: iy    ! Year number
    end subroutine gag_jdat
  end interface
  !
  interface
    subroutine gag_isodate2mjd(timestring,mjd,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Convert an ISO #8601 date string of the form:
      !   2015-01-09T08:58:19.230000
      ! into a Modified Julian Date value.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: timestring
      real(kind=8),     intent(out)   :: mjd
      logical,          intent(inout) :: error
    end subroutine gag_isodate2mjd
  end interface
  !
  interface
    subroutine gag_mjd2isodate(mjd,timestring,error)
      use phys_const
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Convert a Modified Julian Date value to an ISO #8601 date string
      ! of the form:
      !   2015-01-09T08:58:19.230000
      !   123456789 123456789 123456
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)    :: mjd
      character(len=*), intent(out)   :: timestring
      logical,          intent(inout) :: error
    end subroutine gag_mjd2isodate
  end interface
  !
  interface
    subroutine gag_gagut2mjd(date,ut,mjd,error)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Convert a GAG_DATE + UT into a MJD date
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: date   ! [gag]
      real(kind=8),    intent(in)    :: ut     ! [rad] Day starts at 0 radians
      real(kind=8),    intent(out)   :: mjd    !
      logical,         intent(inout) :: error  !
    end subroutine gag_gagut2mjd
  end interface
  !
  interface
    subroutine gag_mjd2gagut(mjd,date,ut,error)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Convert a MJD date into GAG_DATE + UT
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)    :: mjd
      integer(kind=4), intent(out)   :: date
      real(kind=8),    intent(out)   :: ut
      logical,         intent(inout) :: error
    end subroutine gag_mjd2gagut
  end interface
  !
  interface
    subroutine sic_date(datetime)
      !---------------------------------------------------------------------
      ! @ public
      !  Return the current date-time in Gildas format
      !     DD-MMM-YYYY hh:mm:ss.ss
      !     123456789 123456789 123
      ! Use 23 character strings for full date-time, or shorter strings
      ! for truncated values.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: datetime
    end subroutine sic_date
  end interface
  !
  interface
    subroutine sic_isodate(datetime)
      !---------------------------------------------------------------------
      ! @ public
      !  Return the current date-time in ISO #8601:
      !     1996-10-14T10:34:55.345
      !     123456789 123456789 123
      ! Use 23 character strings for full date-time, or shorter strings
      ! for truncated values.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: datetime
    end subroutine sic_isodate
  end interface
  !
  interface
    subroutine sic_gagdate(gagdate)
      !---------------------------------------------------------------------
      ! @ public
      !  Return the current UTC date in GAG_DATE format
      !---------------------------------------------------------------------
      integer(kind=4), intent(out) :: gagdate
    end subroutine sic_gagdate
  end interface
  !
  interface
    subroutine sic_decode(chain,value,ndiv,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Decode a sexagesimal character string into angle value in radians.
      ! Formats can be:
      !       61.5000000      or      161
      !       61:30.0000      or      161:40
      !       61:45:50.9      or      161:40:50
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: chain  ! Character string
      real(kind=8),     intent(out)   :: value  ! Value of angle
      integer(kind=4),  intent(in)    :: ndiv   ! 360/24
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine sic_decode
  end interface
  !
  interface
    subroutine sic_lower(c)
      !---------------------------------------------------------------------
      ! @ public
      !  Converts a character string to lowercase.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string
    end subroutine sic_lower
  end interface
  !
  interface
    subroutine sic_upper(c)
      !---------------------------------------------------------------------
      ! @ public
      !  Converts a character string to uppercase.
      !  Slow if called frequently to convert a single character.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string
    end subroutine sic_upper
  end interface
  !
  interface
    function lenc(c)
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the location of the last non-blank character in a string.
      !---------------------------------------------------------------------
      integer(kind=4) :: lenc  ! Function value on return
      character(len=*), intent(in) :: c  ! Character string
    end function lenc
  end interface
  !
  interface
    subroutine sic_blanc(c,n)
      !---------------------------------------------------------------------
      ! @ public
      !   Reduce the character string C to the standard SIC internal syntax.
      !   Suppress all unecessary separators.
      !   Character strings "abcd... " are not modified.
      !   Convert to upper case all characters.
      !   Ignores and destroys comments.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string to be formatted
      integer(kind=4),  intent(inout) :: n  ! Length of C
    end subroutine sic_blanc
  end interface
  !
  interface
    subroutine sic_next(line,par,lpar,npar,dotab)
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the next "word" of the command line. Words are separated
      ! by blanks, but also optionally by tabulations.
      !---------------------------------------------------------------------
      character(len=*),  intent(in)    :: line   ! Line to be analysed
      character(len=*),  intent(out)   :: par    ! Next word found
      integer(kind=4),   intent(out)   :: lpar   ! Length of word found
      integer(kind=4),   intent(inout) :: npar   ! Start point for analysis, updated for subsequent call
      logical, optional, intent(in)    :: dotab  ! Take also tabulations as separator?
    end subroutine sic_next
  end interface
  !
  interface
    subroutine sic_noir(cin,np)
      !---------------------------------------------------------------------
      ! @ public
      !  Reduce all separators to one.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: cin  ! Character string
      integer(kind=4),  intent(out)   :: np   ! Length of string
    end subroutine sic_noir
  end interface
  !
  interface
    subroutine sic_black(cin,np)
      !---------------------------------------------------------------------
      ! @ public
      !   Suppress all separators
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: cin  ! Character string
      integer(kind=4),  intent(out)   :: np   ! Length of string
    end subroutine sic_black
  end interface
  !
  interface
    subroutine sic_upcase(c,n)
      !---------------------------------------------------------------------
      ! @ public
      !   Reduce the character string C to the standard SIC internal syntax.
      !   Suppress all unecessary separators.
      !   Character strings "abcd... " are not modified.
      !   Convert to upper case all characters.
      !   Ignores and destroys comments.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string to be formatted
      integer(kind=4),  intent(inout) :: n  ! Length of string
    end subroutine sic_upcase
  end interface
  !
  interface
    subroutine sic_separ(separ,line,par,lpar,npar)
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the next "word" of the command line
      !---------------------------------------------------------------------
      character(len=1), intent(in)    :: separ  !
      character(len=*), intent(in)    :: line   !
      character(len=*), intent(out)   :: par    !
      integer(kind=4),  intent(out)   :: lpar   !
      integer(kind=4),  intent(inout) :: npar   !
    end subroutine sic_separ
  end interface
  !
  interface
    subroutine gagout (mess)
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: mess  !
    end subroutine gagout
  end interface
  !
  interface
    function sic_get_arg_count()
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_get_arg_count  !  Function value on return
    end function sic_get_arg_count
  end interface
  !
  interface
    subroutine sic_get_arg(n,arg)
      !---------------------------------------------------------------------
      ! @ public
      !   This machine dependent function retrieves the Nth argument of
      ! command line.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)  :: n    ! Argument index
      character(len=*), intent(out) :: arg  ! Argument value
    end subroutine sic_get_arg
  end interface
  !
  interface
    subroutine gmessage_init(logname,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Initialization routine for gmessage facility:
      !  - close previously opened message file (useful to change the file
      !    during a session)
      !  - open the (new) message file
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: logname
      logical,          intent(inout) :: error
    end subroutine gmessage_init
  end interface
  !
  interface
    subroutine gmessage_parse_and_set(inid,infilter,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter the message filters for input package. Inputs are:
      ! 1) The package id,
      ! 2) The alteration rule, as used in SIC command line, e.g. "s-dtu",
      !    "l=fewri", ...
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: inid      ! Package id
      character(len=*), intent(in)    :: infilter  ! Filter rule
      logical,          intent(inout) :: error     ! Error flag
    end subroutine gmessage_parse_and_set
  end interface
  !
  interface
    subroutine gmessage_parse_and_set_all(infilter,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Updates all filters for all packages (excluding "Global" ones),
      ! given the input alteration rule
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: infilter  ! Filter rule
      logical,          intent(inout) :: error     ! Error flag
    end subroutine gmessage_parse_and_set_all
  end interface
  !
  interface
    subroutine gmessage_print_active(sev,error)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public
      ! Prints all filters for all ACTIVE packages (i.e. "Global" or "per
      ! package")
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: sev    ! Severity used to write output
      logical,         intent(inout) :: error  ! Error flag
    end subroutine gmessage_print_active
  end interface
  !
  interface
    subroutine gmessage_print_all(sev,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Prints filters for all packages (excluding "Global" ones)
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: sev    ! Severity used to write output
      logical,         intent(inout) :: error  ! Error flag
    end subroutine gmessage_print_all
  end interface
  !
  interface
    subroutine gmessage_print_id(id,sev,error)
      use gpack_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Prints filters for the input package. Input is the package id.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: id     ! Package id
      integer(kind=4), intent(in)    :: sev    ! Severity used to write output
      logical,         intent(inout) :: error  ! Error flag
    end subroutine gmessage_print_id
  end interface
  !
  interface
    subroutine gmessage_print(packname,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Prints filters for the input package. Input is the package name.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: packname  ! Package name
      logical,          intent(inout) :: error     ! Error flag
    end subroutine gmessage_print
  end interface
  !
  interface
    subroutine gmessage_translate(seve_leve,seve_code,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Translate a message severity letter into its corresponding integer
      ! code, as a call to gmessage_write needs.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: seve_leve  ! Input severity letter
      integer(kind=4),  intent(out)   :: seve_code  ! Translated code
      logical,          intent(inout) :: error      ! Error flag
    end subroutine gmessage_translate
  end interface
  !
  interface
    subroutine gmessage_log_append(flag)
      !---------------------------------------------------------------------
      ! @ public
      ! Message file will be appended if already existing. Must be called
      ! before opening the message file.
      !---------------------------------------------------------------------
      logical, intent(in) :: flag
    end subroutine gmessage_log_append
  end interface
  !
  interface
    subroutine gmessage_close(error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Closes message file and reset its logical unit for a clean handling
      ! of very last messages. Do not produce an error if no message file
      ! is opened.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error    ! Error flag
    end subroutine gmessage_close
  end interface
  !
  interface
    subroutine gmessage_write(id,mkind,procname,message)
      use gpack_def
      use gbl_message
      use gbl_ansicodes
      !---------------------------------------------------------------------
      ! @ public
      ! Output procname and message, with severity kind "mkind", according
      ! to current messaging filters of input package.
      !  - input id is the identifier given to the package when it
      !    registered, or the one from another package if current package
      !    wants to appear as an other into the message file (e.g. 'gio'
      !    messages appear as 'sic' messages in message file).
      !  - mkind is an integer which should be set with the severity
      !    structure provided by gbl_message module.
      !  Although this routine is public, you should call it only once (with
      !  the 4 arguments) in your <packname>-message routine, and then call
      !  everywhere in your package your <packname>-message routine with
      !  3 arguments. Your package id should be known only in the
      ! <packname>-message routine.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: id        ! Package id
      integer(kind=4),  intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gmessage_write
  end interface
  !
  interface
    subroutine gmessage_write_in_mesfile(id,mkind,procname,message)
      use gpack_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public TEMPORARY FOR CLIC ONLY (SB, 02-jun-2008)
      ! Rewrite of gmessage_write. It writes to mesfile only and ignores
      ! filters.
      !---------------------------------------------------------------------
      ! Output procname and message, with severity kind "mkind", according
      ! to current messaging filters of input package.
      !  - input id is the identifier given to the package when it
      !    registered, or the one from another package if current package
      !    wants to appear as an other into the message file (e.g. 'gio'
      !    messages appear as 'sic' messages in message file).
      !  - mkind is an integer which should be set with the severity
      !    structure provided by gbl_message module.
      !  Although this routine is public, you should call it only once (with
      !  the 4 arguments) in your <packname>-message routine, and then call
      !  everywhere in your package your <packname>-message routine with
      !  3 arguments. Your package id should be known only in the
      ! <packname>-message routine.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: id        ! Package id
      integer(kind=4),  intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gmessage_write_in_mesfile
  end interface
  !
  interface
    subroutine gag_message(mkind,procname,message)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public (obsolete)
      ! Outputs procname and message, with severity kind "mkind", according
      ! to current GLOBAL messaging filters. mkind is an integer which
      ! should be set with the severity structure provided by gbl_message
      ! module.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gag_message
  end interface
  !
  interface
    subroutine gmessage_use_gbl_rules(flag)
      !---------------------------------------------------------------------
      ! @ public
      ! Activates or deactivates use of global messaging filters instead of
      ! local (per package) ones.
      !---------------------------------------------------------------------
      logical, intent(in) :: flag  ! Activate if .true.
    end subroutine gmessage_use_gbl_rules
  end interface
  !
  interface
    subroutine gmessage_log_date(flag)
      !---------------------------------------------------------------------
      ! @ public
      ! Activates or deactivates printing date-time in message file.
      !---------------------------------------------------------------------
      logical, intent(in) :: flag  ! Activate if .true.
    end subroutine gmessage_log_date
  end interface
  !
  interface
    subroutine gmessage_quiet
      !---------------------------------------------------------------------
      ! @ public
      ! Ensure almost-quiet messaging mode to Screen.
      ! This is done by setting Global onscreen filter to FE------, and
      ! using Global filters.
      !---------------------------------------------------------------------
      !
    end subroutine gmessage_quiet
  end interface
  !
  interface
    subroutine gmessage_standard
      !---------------------------------------------------------------------
      ! @ public
      ! Restore normal verbosity.
      ! This is done by stopping using Global filters.
      !---------------------------------------------------------------------
      !
    end subroutine gmessage_standard
  end interface
  !
  interface
    subroutine gmessage_verbose
      !---------------------------------------------------------------------
      ! @ public
      ! Provide a maximal verbose messaging mode for Screen and Message
      ! file.
      ! This is done by turning on all the kind of messages, to both Screen
      ! and Message file.
      !---------------------------------------------------------------------
      !
    end subroutine gmessage_verbose
  end interface
  !
  interface
    subroutine gmessage_debug_swap
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Provide a maximal verbose messaging mode for Screen and Message
      ! file.
      ! This is done by turning on all the kind of messages, to both Screen
      ! and Message file.
      !---------------------------------------------------------------------
      ! Local
    end subroutine gmessage_debug_swap
  end interface
  !
  interface
    subroutine gmessage_print_colors(error)
      !---------------------------------------------------------------------
      ! @ public
      ! Show the current status of message colors
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine gmessage_print_colors
  end interface
  !
  interface
    subroutine gmessage_colors_swap(flag)
      !---------------------------------------------------------------------
      ! @ public
      ! Enable or disable the message coloring
      !---------------------------------------------------------------------
      logical, intent(in) :: flag
    end subroutine gmessage_colors_swap
  end interface
  !
  interface
    subroutine gmessage_colors_parse(argum,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Parse argument for changing a message kind color
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: argum
      logical,          intent(inout) :: error
    end subroutine gmessage_colors_parse
  end interface
  !
  interface
    function gpack_get_count()
      !---------------------------------------------------------------------
      ! @ public
      ! Return number of registered packages
      !---------------------------------------------------------------------
      integer(kind=4) :: gpack_get_count
    end function gpack_get_count
  end interface
  !
  interface
    function gpack_get_info(ipack)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public
      ! Return package information structure
      !---------------------------------------------------------------------
      type(gpack_info_t) :: gpack_get_info
      integer(kind=4), intent(in) :: ipack
    end function gpack_get_info
  end interface
  !
  interface
    function gpack_get_id(gpack_name,present,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Private function to get the package id from the package name
      !---------------------------------------------------------------------
      integer(kind=4)  :: gpack_get_id ! Returned package id
      character(len=*), intent(in)    :: gpack_name   ! Package name
      logical,          intent(in)    :: present      ! Must the package be already registered?
      logical,          intent(inout) :: error        ! Error flag
    end function gpack_get_id
  end interface
  !
  interface
    subroutine gpack_resolve(packname,found,error)
      use gbl_message
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public
      ! Resolve packname string ambiguities
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: packname  ! Package name
      logical,          intent(out)   :: found     ! Found package?
      logical,          intent(inout) :: error     ! Error flag
    end subroutine gpack_resolve
  end interface
  !
  interface
    function gpack_is_registered(gpack_name)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Check registration status of a package
      !---------------------------------------------------------------------
      logical                      :: gpack_is_registered  ! Package registration status
      character(len=*), intent(in) :: gpack_name           ! Package name
    end function gpack_is_registered
  end interface
  !
  interface
    function gpack_build(pack_set,already_registered,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Builds a package and its dependencies, returns package registration
      ! id
      !---------------------------------------------------------------------
      integer(kind=4) :: gpack_build
      external               :: pack_set
      logical, intent(out)   :: already_registered
      logical, intent(inout) :: error
    end function gpack_build
  end interface
  !
  interface
    subroutine gsys_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: id
    end subroutine gsys_message_set_id
  end interface
  !
  interface
    function sic_ramlog(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Decode a Sic logical as a RAM space, computed in MiB. 3 syntaxes
      ! are allowed:
      !
      ! No unit: default MiB
      !   SPACE_GILDAS  256    ! [MiB] Absolute value
      !
      ! Explicit unit:
      !   SPACE_GILDAS  256MB  ! Supported units: TB GB MB kB TiB GiB MiB kiB
      !
      ! Percent of total RAM:
      !   SPACE_GILDAS  50%    ! [  ] Relative value in fraction of the total
      !                              RAM size
      !
      ! The value can be integer or floating point. The unit or percent can
      ! be separated from the value by 0 or more blanks.
      !
      ! Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_ramlog  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      real(kind=4),     intent(inout) :: trans  ! Output value
    end function sic_ramlog
  end interface
  !
  interface
    function sic_setlog(name,trans)
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_setlog
      character(len=*), intent(in) :: name   !
      character(len=*), intent(in) :: trans  !
    end function sic_setlog
  end interface
  !
  interface
    function dictname(dtype,file)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! This system dependent routine returns the full names (including
      ! path) of the (internal) logical name definition files.
      ! Known dictionary types as input are 'GLOBAL', 'LOCAL', or 'USER'.
      ! Any other kind raises an error.
      !
      ! This version for Unix.
      !---------------------------------------------------------------------
      integer(kind=4) :: dictname             !
      character(len=*), intent(in)  :: dtype  ! Dictionary type
      character(len=*), intent(out) :: file   ! Associated file
    end function dictname
  end interface
  !
  interface
    subroutine gag_separ(ins,ous,dis)
      !---------------------------------------------------------------------
      ! @ public
      !     Returns the characters used as Separators in path names.
      !     This allows multi-OS support where the directory names are separated
      !     by either / (Unix), \ (Windows), or : (MAC-OS)
      !---------------------------------------------------------------------
      character(len=1), intent(out) :: ins         !
      character(len=1), intent(out) :: ous         !
      character(len=1), intent(out) :: dis         !
    end subroutine gag_separ
  end interface
  !
  interface
    subroutine gag_release(ostring)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Return a string with the release name, date, system, and branch.
      ! Read the string in GAG_VERSION symbol, and optionally replace the
      ! release date by the calling executable date if in HEAD version.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: ostring  ! Output string
    end subroutine gag_release
  end interface
  !
  interface sic_getlog
    function sic_getlog_i4(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  I*4 version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_i4  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      integer(kind=4),  intent(inout) :: trans  ! Output value
    end function sic_getlog_i4
    function sic_getlog_i8(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  I*8 version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_i8  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      integer(kind=8),  intent(inout) :: trans  ! Output value
    end function sic_getlog_i8
    function sic_getlog_r4(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  R*4 version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_r4  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      real(kind=4),     intent(inout) :: trans  ! Output value
    end function sic_getlog_r4
    function sic_getlog_r8(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  R*8 version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_r8  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      real(kind=8),     intent(inout) :: trans  ! Output value
    end function sic_getlog_r8
    function sic_getlog_l(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  Logical (boolean) version. Supported keywords are (case-
      ! insensitive): YES, Y, NO, N
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_l  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      logical,          intent(inout) :: trans  ! Output value
    end function sic_getlog_l
    function sic_getlog_ch(name,trans)
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated ('trans' modified in return)
      !    1 if not found            ('trans' not modified in return)
      ! ---
      !  C*(*) version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_ch  ! Function value on return
      character(len=*), intent(in)    :: name   ! Logical name
      character(len=*), intent(inout) :: trans  ! Output value
    end function sic_getlog_ch
    function sic_getlog_inplace(name)
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated ('name' modified in return)
      !    1 if not found            ('name' not modified in return)
      !  OBSOLESCENT, USE 2 ARGUMENTS INSTEAD  !!!
      ! ---
      !  C*(*) version, obsolescent calling sequence which replaces the
      ! value in place.
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_inplace
      character(len=*), intent(inout) :: name  ! Output value
    end function sic_getlog_inplace
  end interface sic_getlog
  !
  interface
    function gag_hasins(mdim,pf,pn,dict,name,in)
      !---------------------------------------------------------------------
      ! @ public
      !  *** This version for dictionaries as character string arrays ***
      !       Insert a new name or replace an existing name
      !       in a dictionnary using a hashing structure
      !       and a list of pointers.
      !
      !       GAG_HASINS      0       E  Invalid name
      !                       1       S  Successfully inserted
      !                       2       E  Too many names
      !                       3       S  Successfully replaced
      !
      !       PF      I(0:27) PF(J) Address of first name beginning
      !                       with CHAR(J-ICHAR('A')) in dictionnary.
      !                       PF(26) is the address of the first
      !                       available place.                        Input/Output
      !                       PF(27) is the number of symbols
      !       PN      I(MDIM) Address of next name with same first
      !                       letter. If PN(J)=0, no more such name.  Input/Output
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_hasins  ! Function value on return
      integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
      integer(kind=4),  intent(inout) :: pf(0:27)    !
      integer(kind=4),  intent(inout) :: pn(mdim)    !
      character(len=*), intent(inout) :: dict(mdim)  ! Dictionnary array of size MDIM
      character(len=*), intent(inout) :: name        ! Name to be inserted
      integer(kind=4),  intent(out)   :: in          ! Address of this name
    end function gag_hasins
  end interface
  !
  interface
    subroutine gag_hasini(mdim,pf,pn)
      !---------------------------------------------------------------------
      ! @ public
      ! SIC   Internal routine
      !  *** This version for all kind of dictionaries ***
      !       Initialise a hashing structure for a possible dictionnary.
      ! Arguments :
      !       MDIM    I       Size of dictionnary
      !       PF      I(0:27) PF(J) Address of first name beginning
      !                       with CHAR(J-ICHAR('A')) in dictionnary.
      !                       PF(26) is the address of the first
      !                       available place.
      !                       PF(27) the number of symbol
      !       PN      I(MDIM) Address of next name with same first
      !                       letter. If PN(J)=0, no more such name.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: mdim      !
      integer(kind=4), intent(out) :: pf(0:27)  !
      integer(kind=4), intent(out) :: pn(mdim)  !
    end subroutine gag_hasini
  end interface
  !
  interface
    function gag_hasdel(mdim,pf,pn,dict,name)
      !---------------------------------------------------------------------
      ! @ public
      !  *** This version for dictionaries as character string arrays ***
      !       Delete a name in a dictionnary using a hashing structure
      !       and a list of pointers.
      !
      !       GAG_HASDEL      1       Name deleted
      !                       3       Name does not exist
      !
      !       PF      I(0:27) PF(J) Address of first name beginning
      !                       with CHAR(J-ICHAR('A')) in dictionnary.
      !                       PF(26) is the address of the first
      !                       available place.                        Input/Output
      !                       PF(27) is the number of symbols
      !       PN      I(MDIM) Address of next name with same first
      !                       letter. If PN(J)=0, no more such name.  Input/Output
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_hasdel  ! Function value on return
      integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
      integer(kind=4),  intent(inout) :: pf(0:27)    !
      integer(kind=4),  intent(inout) :: pn(mdim)    !
      character(len=*), intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
      character(len=*), intent(inout) :: name        ! Name to be deleted
    end function gag_hasdel
  end interface
  !
  interface
    function gag_hasfin(mdim,pf,pn,dict,name,in)
      !---------------------------------------------------------------------
      ! @ public
      !  *** This version for dictionaries as character string arrays ***
      !       Find a name in a dictionnary using a hashing structure
      !       and a list of pointers.
      !
      !       GAG_HASFIN      0       No such name
      !                       1       Name found
      !       PF      I(0:27) PF(J) Address of first name beginning
      !                       with CHAR(J-ICHAR('A')) in dictionnary.
      !                       PF(26) is the address of the first
      !                       available place.                        Input
      !       PN      I(MDIM) Address of next name with same first
      !                       letter. If PN(J)=0, no more such name.  Input
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_hasfin  ! Function value on return
      integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
      integer(kind=4),  intent(in)    :: pf(0:27)    !
      integer(kind=4),  intent(in)    :: pn(mdim)    !
      character(len=*), intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
      character(len=*), intent(inout) :: name        ! Name to be found
      integer(kind=4),  intent(out)   :: in          ! Address of this name
    end function gag_hasfin
  end interface
  !
  interface
    subroutine gag_haslis(mdim,pf,pn,list,leng)
      !---------------------------------------------------------------------
      ! @ public
      !  *** This version for all kind of dictionaries ***
      !
      !  List a dictionnary using a hashing structure and a list of pointers.
      ! This routine just builds the list of pointers to current entries.
      !
      ! THERE IS NO WARRANTY THE OUTPUT LIST IS SORTED ALPHABETICALLY.
      ! Actually with the current hashing method, the output list is sorted
      ! by first letter only. Use subroutine gag_hassort for a fully sorted
      ! list.
      !
      !   PF(0:27)   PF(0:25) Address of first name beginning with
      !                       CHAR(J-ICHAR('A')) in dictionnary.
      !              PF(26)   is the address of the first available place.
      !              PF(27)   the number of symbols
      !   PN(MDIM)            Address of next name with same first letter.
      !                       If PN(J)=0, no more such name.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: mdim        ! Size of dictionnary
      integer(kind=4), intent(in)  :: pf(0:27)    !
      integer(kind=4), intent(in)  :: pn(mdim)    !
      integer(kind=4), intent(out) :: list(mdim)  ! List of entries in dictionnary
      integer(kind=4), intent(out) :: leng        ! Current number of entries
    end subroutine gag_haslis
  end interface
  !
  interface
    function sic_open(unit,file,status,readonly)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function opens a formatted file, and returns an
      ! error code. This Unix version simulates version numbers by renaming
      ! any existing file to a ~appended name.
      !
      ! Possible statuses are:
      !  - NEW: rename previous version with ~ appended (GILDAS special
      !         feature) and create a new file (only write mode makes sense)
      !  - REPLACE: overwrite an OLD file (if any) and create a new file
      !         (only write mode makes sense)
      !  - APPEND: open an OLD file in read-write mode (always), ready for
      !         writing at end of file.
      !  - OLD: reopen an old file in read-only or read-write mode (as
      !         desired)
      !  - other Fortran standard keywords
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_open  ! Return value
      integer(kind=4),  intent(in) :: unit      ! Fortran logical unit
      character(len=*), intent(in) :: file      ! File name
      character(len=*), intent(in) :: status    ! File status ('NEW', or 'OLD', or...)
      logical,          intent(in) :: readonly  ! Open as write protected?
    end function sic_open
  end interface
  !
  interface
    function sic_flush(unit)
      !---------------------------------------------------------------------
      ! @ public
      ! This function flushes file buffer onto disk, and returns an error
      ! code.
      !---------------------------------------------------------------------
      integer(kind=4)             :: sic_flush  ! Flush status (0=success)
      integer(kind=4), intent(in) :: unit       ! Logical unit
    end function sic_flush
  end interface
  !
  interface
    function sic_close(unit)
      !---------------------------------------------------------------------
      ! @ public
      ! This function closes a formatted file, and returns an error code.
      ! Following the Fortran norm, default closing STATUS:
      ! - is DELETE if unit has been opened with STATUS=SCRATCH,
      ! - is KEEP if unit has been opened with any other STATUS.
      ! Use unit=0 to close all units.
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_close  ! Close status (0=success)
      integer(kind=4), intent(in) :: unit  ! Logical unit to close
    end function sic_close
  end interface
  !
  interface
    subroutine sic_frelun(unit)
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function frees a Fortran logical unit obtained
      ! through a call to SIC_GETLUN. Error on close can not be retrieved,
      ! use GAG_FRELUN to do so.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: unit  ! Fortran logical unit to close
    end subroutine sic_frelun
  end interface
  !
  interface
    function sic_getlun(unit)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function returns a free Fortran logical unit in
      ! UNIT. The function value is an error code. For safe operation, all
      ! logical units used by the program should be obtained through calls to
      ! SIC_GETLUN. This portable version reserves all units between STALUN+1
      ! and STALUN+MAXLUN, which may interfere with the calling program. Safer
      ! equivalents can usually be obtained through system calls.
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlun  ! Function value on return
      integer(kind=4), intent(out) :: unit  ! Unit obtained on return
    end function sic_getlun
  end interface
  !
  interface
    function gag_frelun(unit)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function frees a Fortran logical unit obtained
      ! through a call to SIC_GETLUN. The function value is an error code.
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_frelun  ! Function value on return
      integer(kind=4), intent(in) :: unit  ! Logical unit to close
    end function gag_frelun
  end interface
  !
  interface
    function gag_stalun(unit)
      !---------------------------------------------------------------------
      ! @ public
      ! Stat input lun (or all if lun=0) and print out status of lun(s)
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_stalun  ! Function value on return
      integer(kind=4), intent(in) :: unit  ! Unit to stat
    end function gag_stalun
  end interface
  !
  interface
    function sic_purge(file,keep)
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function deletes all versions of a file except
      ! for the KEEP last ones, KEEP=0 being a supported case. The function
      ! value is an error code. This dummy version does nothing and should be
      ! replaced by an EMACS-like behaviour (using numbered backup files).
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_purge  ! Return value
      character(len=*), intent(in) :: file       ! File name
      integer(kind=4),  intent(in) :: keep       ! Number of versions that should be kept
    end function sic_purge
  end interface
  !
  interface
    subroutine sic_resolve_log(chain)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Resolve logical variables recursively
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: chain  !
    end subroutine sic_resolve_log
  end interface
  !
  interface
    subroutine sic_parse_file(name,dir,ext,file)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Adds the directory DIR and extension EXT if necessary to the file
      ! name NAME to form FILE. In addition, logical name are translated to
      ! obtain the intrinsic "physical" names.
      !
      ! For UNIX purposes: (a logical name is somestring finished with ":")
      !      a) converts "\" to "/"
      !      b) converts ~ to $HOME
      !
      ! if first character is "!" or "/"
      !     1) TRANSLATES LOGICAL NAMES
      !     2) Does not add extension
      !     3) is respectful of upper/lowercases
      ! if not :
      !     1) converts to lowercase
      !     2) TRANSLATES LOGICAL NAMES
      !     3) Does add extension, in lowercase
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name  ! File name
      character(len=*), intent(in)  :: dir   ! Default directory
      character(len=*), intent(in)  :: ext   ! Default extension
      character(len=*), intent(out) :: file  ! Fully extended file name
    end subroutine sic_parse_file
  end interface
  !
  interface
    subroutine sic_parsef(name,file,dir,ext)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Same as SIC_PARSE_FILE +
      !  at return, NAME is the file named stripped from directory and
      !  extension
      ! ---
      !  Obsolete: use SIC_PARSE_FILE and/or SIC_PARSE_NAME instead
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: name  ! File name
      character(len=*), intent(out)   :: file  ! Fully extended file name
      character(len=*), intent(in)    :: dir   ! Default directory
      character(len=*), intent(in)    :: ext   ! Default extension
    end subroutine sic_parsef
  end interface
  !
  interface
    function sic_query_file (name,path,ext,file)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Same as sic_findfile but avoid modifying input 'name'
      !---------------------------------------------------------------------
      logical :: sic_query_file              ! Function value on return
      character(len=*), intent(in)  :: name  ! File name
      character(len=*), intent(in)  :: path  ! Search path
      character(len=*), intent(in)  :: ext   ! Default extension
      character(len=*), intent(out) :: file  ! Fully extended file name
    end function sic_query_file
  end interface
  !
  interface
    function sic_findfile(name,file,path,ext)
      !---------------------------------------------------------------------
      ! @ public
      !  Search on the path PATH and with extension EXT if necessary the
      ! file name NAME to find FILE. At return, NAME is the file named
      ! stripped from these extensions. In addition, logical name are
      ! translated to obtain the intrinsic "physical" names.
      !---------------------------------------------------------------------
      logical :: sic_findfile                  ! Function value on return
      character(len=*), intent(inout) :: name  ! File name
      character(len=*), intent(out)   :: file  ! Fully extended file name
      character(len=*), intent(in)    :: path  ! Search Path
      character(len=*), intent(in)    :: ext   ! Default extension
    end function sic_findfile
  end interface
  !
  interface
    subroutine sic_parse_name(iname,ofile,oext,odir)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !  Split an input file name as:
      !  - its basename (no extension),
      !  - its extension,
      !  - its dirname.
      ! Sic logicals are resolved in the the input file name before parsing
      !---------------------------------------------------------------------
      character(len=*), intent(in)            :: iname
      character(len=*), intent(out)           :: ofile
      character(len=*), intent(out), optional :: oext
      character(len=*), intent(out), optional :: odir
    end subroutine sic_parse_name
  end interface
  !
  interface
    subroutine gag_iostat (msg,ier)
      !---------------------------------------------------------------------
      ! @ public
      ! Return system message corresponding to IO error code IER
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: msg  ! Returned message
      integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
    end subroutine gag_iostat
  end interface
  !
  interface
    function failed_allocate(rname,array,ier,error)
      use gbl_message
      !-------------------------------------------------------------------
      ! @ public
      ! Check allocation status and display a message if error
      !-------------------------------------------------------------------
      logical :: failed_allocate  ! Function value on return
      character(len=*), intent(in)    :: rname  ! Calling routine name
      character(len=*), intent(in)    :: array  ! Name of allocated array
      integer(kind=4),  intent(in)    :: ier    ! Allocation status
      logical,          intent(inout) :: error  ! Logical error flag
    end function failed_allocate
  end interface
  !
  interface putios
    subroutine putios_write (name,ier)
      !---------------------------------------------------------------------
      ! @ public-generic putios
      ! Print system message corresponding to IO error code IER
      ! ---
      ! This version writes directly the message to STDOUT
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: name  ! Facility name
      integer(kind=4),  intent(in) :: ier   ! 32-bit system message code
    end subroutine putios_write
    subroutine putios_message (mseve,procname,ier)
      !---------------------------------------------------------------------
      ! @ public-generic putios
      ! Print system message corresponding to IO error code IER
      ! ---
      ! This version creates a standard message
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: mseve     ! Message severity
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      integer(kind=4),  intent(in) :: ier       ! 32-bit system message code
    end subroutine putios_message
  end interface putios
  !
  interface
    subroutine sexag(ch,rr8,ndiv)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public (obsolescent since 19-mar-2015, use rad2sexa instead)
      !  Writes an angle in sexagesimal notation. The number of characters
      ! updated are limited to 13.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: ch    ! Formatted string
      real(kind=8),     intent(in)  :: rr8   ! Angle in radians
      integer(kind=4),  intent(in)  :: ndiv  ! Number of divisions per turn (24/360)
    end subroutine sexag
  end interface
  !
  interface
    subroutine deg2sexa(d8,ndiv,ch,ndig,left)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Write an angle (degrees) in sexagesimal notation.
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)           :: d8    ! [Deg] Angle
      integer(kind=4),  intent(in)           :: ndiv  ! [   ] Number of div. per turn (24/360)
      character(len=*), intent(out)          :: ch    ! [   ] Formatted string
      integer(kind=4),  intent(in), optional :: ndig  ! [   ] Number of digits desired
      logical,          intent(in), optional :: left  ! [   ] Left justify the output string?
    end subroutine deg2sexa
  end interface
  !
  interface
    subroutine rad2sexa(rr8,ndiv,ch,ndig,left)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Write an angle (radians) in sexagesimal notation.
      !  The number of digits in the fractional part is controled by 'ndig'.
      ! If absent, the string will be filled with as many digits as
      ! possible, for example if you want a 3 digits fractional part, use
      !  -DDD:MM:SS.SSS = 14 characters (360 divisions per turn)
      !  -HH:MM:SS.SSS = 13 characters (24 divisions per turn)
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)           :: rr8   ! [Rad] Angle
      integer(kind=4),  intent(in)           :: ndiv  ! [   ] Number of div. per turn (24/360)
      character(len=*), intent(out)          :: ch    ! [   ] Formatted string
      integer(kind=4),  intent(in), optional :: ndig  ! [   ] Number of digits desired
      logical,          intent(in), optional :: left  ! [   ] Left justify the output string?
    end subroutine rad2sexa
  end interface
  !
  interface
    subroutine deg2dms(r8,d,m,s)
      !---------------------------------------------------------------------
      ! @ public
      !  Split a floating point value in degreee-minute-seconds numerical
      ! values. No assumption on the input value unit.
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)  :: r8
      integer(kind=4), intent(out) :: d
      integer(kind=4), intent(out) :: m
      real(kind=8),    intent(out) :: s
    end subroutine deg2dms
  end interface
  !
  interface
    subroutine ctodes(string,nc,addr)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Copy at address the value of 'string'. nc is the maximum length
      ! (number of bytes) of the string to copy.
      !---------------------------------------------------------------------
      character(len=*),             intent(in) :: string  !
      integer(kind=4),              intent(in) :: nc      !
      integer(kind=address_length), intent(in) :: addr    ! Address is not modified
    end subroutine ctodes
  end interface
  !
  interface
    subroutine destoc(nc,addr,string)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Copy in 'string' the value referenced at address 'addr'. nc
      ! is the maximum length (number of bytes) of the string to copy.
      !---------------------------------------------------------------------
      integer(kind=4),              intent(in)  :: nc      !
      integer(kind=address_length), intent(in)  :: addr    !
      character(len=*),             intent(out) :: string  !
    end subroutine destoc
  end interface
  !
  interface
    function match_string(string,pattern)
      !---------------------------------------------------------------------
      ! @ public
      ! Basic function for regular expression matching. Only '*' is
      ! currently recognized as a special character.
      !  * : matches 0 or more characters
      ! By construction, tolerate contiguous stars e.g. 'AB***CD'. Matching
      ! is case-sensitive.
      !---------------------------------------------------------------------
      logical                      :: match_string  ! Return value
      character(len=*), intent(in) :: string        ! String to test
      character(len=*), intent(in) :: pattern       ! Pattern to match
    end function match_string
  end interface
  !
  interface
    subroutine sic_terminal(name)
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the name of the terminal.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: name  ! Terminal name
    end subroutine sic_terminal
  end interface
  !
  interface
    subroutine sysexi(code)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: code  ! Input terminating code
    end subroutine sysexi
  end interface
  !
  interface
    subroutine gag_os(os)
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: os  !
    end subroutine gag_os
  end interface
  !
  interface
    subroutine gag_mkdir(dir,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: dir    !
      logical,          intent(out) :: error  !
    end subroutine gag_mkdir
  end interface
  !
  interface
    subroutine gag_directory_num(dirstring,num,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Return the number of standard files in a directory. Nice to be
      ! called before 'gag_directory' so that the filename(:) array can be
      ! allocated to an appropriate size.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: dirstring  !
      integer(kind=4),  intent(out)   :: num        ! Number of standard files
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine gag_directory_num
  end interface
  !
  interface
    subroutine gag_directory(dirstring,filestring,filename,nfile,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Return the actual files that match a given string (with *'s)
      ! inside a given directory (no *'s). Note that nothing forbids the
      ! file pattern to ask for subdirectories (e.g. */foo*.dat). The short
      ! filenames are returned (without directory path).
      !   In return, the list of files is stored in an array provided by the
      ! caller. This array MUST be allocatable. The subroutine will
      ! reallocate it to the appropriate size.
      !---------------------------------------------------------------------
      character(len=*), intent(in)               :: dirstring    ! input directory
      character(len=*), intent(in)               :: filestring   ! input file string
      character(len=*), intent(out), allocatable :: filename(:)  ! char array filled in
      integer(kind=4),  intent(out)              :: nfile        ! number of files
      logical,          intent(inout)            :: error        !
    end subroutine gag_directory
  end interface
  !
  interface
    subroutine sic_username(name)
      !---------------------------------------------------------------------
      ! @ public
      ! Return user name from:
      ! 1) $USER environment variable, else
      ! 2) $LOGNAME environment variable, else
      ! 3) use string "Gildas"
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: name  ! Output string
    end subroutine sic_username
  end interface
  !
  interface
    subroutine sic_hostname(node)
      !---------------------------------------------------------------------
      ! @ public
      ! Return host name from:
      ! 1) $HOST environment variable, else
      ! 2) $HOSTNAME environment variable, else
      ! 3) non-standard subroutine HOSTNM (standard alternative could be
      !    execute_command_line("hostname",node), else
      ! 4) blank string
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: node  ! Output string
    end subroutine sic_hostname
  end interface
  !
  interface
    subroutine sic_setdir(direc,nc,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! SIC   Machine specific routine that changes and/or returns the
      !       default directory.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: direc  ! Name of default directory
      integer(kind=4),  intent(inout) :: nc     ! Length of directory name
      logical,          intent(inout) :: error  ! Error flag
    end subroutine sic_setdir
  end interface
  !
  interface
    subroutine gag_cpu(arg)
      !---------------------------------------------------------------------
      ! @ public
      ! All compilers are assumed to be Fortran 1995 compatible now
      !---------------------------------------------------------------------
      real(kind=4), intent(out) :: arg  !
    end subroutine gag_cpu
  end interface
  !
  interface
    subroutine gag_delete(fich)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: fich  !
    end subroutine gag_delete
  end interface
  !
  interface
    function gag_which(name,dirlist,full)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !   Find which file is invoked, given its name. Input name may
      ! include:
      !   - an absolute path,
      !   - a relative path,
      !   - only the file name, in which case it is searched in the
      !     input list of directories (might be an environment variable).
      !     This list is ignored in the 2 above cases.
      ! Output is a valid path to the file from current working directory.
      ! It is legal to search for a file which does not exist. The (or a)
      ! full path will be built, but the function value will be false on
      ! return.
      !   This function does the same as 'which' system command if input
      ! name is searched in '$PATH'
      !---------------------------------------------------------------------
      logical :: gag_which                      ! .true. on return if found
      character(len=*), intent(in)  :: name     ! File name to search
      character(len=*), intent(in)  :: dirlist  ! List of directories to search in (optional)
      character(len=*), intent(out) :: full     ! Return the path in this variable
    end function gag_which
  end interface
  !
  interface
    function gag_mtime(file,nanosec)
      !---------------------------------------------------------------------
      ! @ public
      ! Return the last modification time in nanoseconds since 01-jan-1970
      ! The file can be a regular file or a directory. If file is a symlink,
      ! evaluation is made on its target.
      ! Max value is 2**63-1 ns = (2**63-1)/1e9/86400/365 = 292 years
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_mtime  ! Function value on return (0 for success)
      character(len=*), intent(in)  :: file     ! File name
      integer(kind=8),  intent(out) :: nanosec  !
    end function gag_mtime
  end interface
  !
  interface
    function gag_time(nanosec)
      !---------------------------------------------------------------------
      ! @ public
      ! Return the current time in nanoseconds since 01-jan-1970
      ! Max value is 2**63-1 ns = (2**63-1)/1e9/86400/365 = 292 years
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_time  ! Function value on return (0 for success)
      integer(kind=8), intent(out) :: nanosec  !
    end function gag_time
  end interface
  !
  interface
    subroutine gag_filmodif(file,modif,error)
      use gbl_message
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public
      !  (re)compute the 'modified' structure and evaluate if the file
      ! was 'probably' modified since last evaluation. The file can be
      ! a regular file or a directory. If file is a symlink, evaluation is
      ! made on its target.
      !   NB: modif%modified is NOT modified if there is an ambiguity.
      ! It is up to the caller to set it to its best default according to
      ! the context.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: file   ! File name
      type(mfile_t),    intent(inout) :: modif  !
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_filmodif
  end interface
  !
  interface
    subroutine gag_fillines(file,doblank,nlines,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Count the number of lines in a FORMATTED file. More precisely, it
      ! counts the number of carriage returns (same as Linux shell "wc -l").
      ! Be careful of missing carriage return at the end of your files.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: file     !
      logical,          intent(in)    :: doblank  ! Ignore blank lines?
      integer(kind=4),  intent(out)   :: nlines   !
      logical,          intent(inout) :: error    !
    end subroutine gag_fillines
  end interface
  !
  interface
    function gag_filsame(file1,file2)
      !---------------------------------------------------------------------
      ! @ public
      ! Check if 2 files are identical or not.
      ! This is based by comparing the devices hosting the files and the
      ! inodes on the devices.
      !---------------------------------------------------------------------
      logical :: gag_filsame
      character(len=*), intent(in) :: file1,file2
    end function gag_filsame
  end interface
  !
  interface
    function gag_memsize_format(nbytes) result(result)
      !---------------------------------------------------------------------
      ! @ public
      ! Format a memory size in a human readable form, with appropriate
      ! units.
      !---------------------------------------------------------------------
      character(len=8)            :: result
      integer(kind=8), intent(in) :: nbytes ! [Bytes]
    end function gag_memsize_format
  end interface
  !
  interface
    subroutine gag_cputime_init(time)
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(cputime_t), intent(inout) :: time  !
    end subroutine gag_cputime_init
  end interface
  !
  interface
    subroutine gag_cputime_get(time)
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(cputime_t), intent(inout) :: time  !
    end subroutine gag_cputime_get
  end interface
  !
  interface
    subroutine gtime_current(time)
      use gbl_message
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public
      ! Display the timing statistics and projections
      !---------------------------------------------------------------------
      type(time_t), intent(inout) :: time
    end subroutine gtime_current
  end interface
  !
  interface gtime_init
    subroutine gtime_init4(time,nloop,error)
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public-generic gtime_init
      ! Init the timing structure (INTEGER*4 nloop)
      !---------------------------------------------------------------------
      type(time_t),    intent(out)   :: time
      integer(kind=4), intent(in)    :: nloop
      logical,         intent(inout) :: error
    end subroutine gtime_init4
    subroutine gtime_init8(time,nloop,error)
      use gbl_message
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public-generic gtime_init
      ! Init the timing structure (INTEGER*8 nloop)
      !---------------------------------------------------------------------
      type(time_t),    intent(out)   :: time
      integer(kind=8), intent(in)    :: nloop
      logical,         intent(inout) :: error
    end subroutine gtime_init8
  end interface gtime_init
  !
end module gsys_interfaces_public

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_free
  use cubedag_messaging
  use cubetools_structure
  !
  public :: free
  public :: free_prog_t
  private
  !
  type :: free_comm_t
    type(option_t), pointer :: comm
  contains
    procedure, public  :: register => cubedag_free_register
    procedure, private :: parse    => cubedag_free_parse
    procedure, private :: main     => cubedag_free_main
  end type free_comm_t
  type(free_comm_t) :: free
  !
  type :: free_user_t
    ! No customization yet
  contains
    procedure, private :: toprog => cubedag_free_user_toprog
  end type free_user_t
  !
  type :: free_prog_t
    ! No customization yet
  contains
    procedure, public :: do => cubedag_free_do
  end type free_prog_t
  !
contains
  !
  subroutine cubedag_free_command(line,error)
    !-------------------------------------------------------------------
    ! Support for command
    !  ADM\FREE
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(free_user_t) :: user
    character(len=*), parameter :: rname='FREE>COMMAND'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call free%parse(line,user,error)
    if (error) return
    call free%main(user,error)
    if (error) return
  end subroutine cubedag_free_command
  !
  !---------------------------------------------------------------------
  !
  subroutine cubedag_free_register(free,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(free_comm_t), intent(inout) :: free
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FREE>REGISTER'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'FREE','',&
         'Free the current DAG',&
         'Free the DAG, i.e. delete all the cube and history&
         & structures. Beware memory-only objects are lost during&
         & this operation (use command SNAPSHOT to save them for&
         & possible later reuse). In return the DAG is ready for use&
         & as if starting from scratch.',&
         cubedag_free_command,&
         free%comm,error)
    if (error) return
  end subroutine cubedag_free_register
  !
  subroutine cubedag_free_parse(free,line,user,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(free_comm_t), intent(inout) :: free
    character(len=*),   intent(in)    :: line
    type(free_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FREE>PARSE'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
  end subroutine cubedag_free_parse
  !
  subroutine cubedag_free_main(free,user,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(free_comm_t), intent(in)    :: free
    type(free_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(free_prog_t) :: prog
    character(len=*), parameter :: rname='FREE>MAIN'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubedag_free_main
  !
  subroutine cubedag_free_user_toprog(user,prog,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(free_user_t), intent(in)    :: user
    type(free_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FREE>USER>TOPROG'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
  end subroutine cubedag_free_user_toprog
  !
  subroutine cubedag_free_do(prog,error)
    use cubedag_repositories
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(free_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    call cubedag_repositories_free(error)
    if (error) continue
    call cubedag_repositories_init(error)
    if (error) return
  end subroutine cubedag_free_do
  !
end module cubedag_free
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gtx_plot(out,x,y,jmode)
  use gildas_def
  use gtv_types
  use gtv_graphic
  use gtv_interfaces, except_this=>gtx_plot
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !  This is a PLOT routine, simulating the calcomp PLOT routine, X,Y
  ! are the co-ordinates (World units) of a plotter point, and
  !    MODE=3 means plot a dark vector (pen up) to X,Y
  !    MODE=2 means plot a real vector (pen down) to X,Y
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! Input gt_display
  real*4,           intent(in)    :: x,y    ! World units
  integer,          intent(in)    :: jmode  !
  ! Local
  integer*4 :: ixc,iyc
  !
  if (.not.awake .or. error_condition) return
  !
  if (out%dev%protocol.eq.p_null)  then
    ! No device selected.
    return
    !
  elseif (out%dev%protocol.eq.p_postscript) then
    ! Plot a dark vector
    if (jmode.eq.3) then
      call ps_moveto(x,y)
    elseif (jmode.eq.2) then
      call ps_lineto(x,y)
    endif
    return
    !
  elseif (out%dev%protocol.eq.p_svg) then
    ! Plot a dark vector
    if (jmode.eq.3) then
      call svg_moveto(out,x,y,.false.)
    elseif (jmode.eq.2) then
      call svg_lineto(out,x,y)
    endif
    return
    !
  elseif (out%dev%protocol.eq.p_png) then
    ! Plot a dark vector
    if (jmode.eq.3) then
      call png_moveto(out,x,y)
    elseif (jmode.eq.2) then
      call png_lineto(out,x,y)
    endif
    return
  endif
  !
  call world_to_pixel(out,x,y,ixc,iyc)
  !
  ! Plot a dark vector
  if (jmode.eq.3) then
    if (out%dev%protocol.eq.p_x) then
      call x_movp1(out%x%graph_env,ixc,iyc)
    endif
    !
    !  In mode 3, a dark vector, always set the full address into the
    !  buffer.  Strictly, this is not always necessary, but play safe.
    !
    ! Plot a light vector
  elseif (jmode.eq.2) then
    !
    if (out%dev%protocol.eq.p_x) then
      call x_movp2(out%x%graph_env,ixc,iyc)
    endif
    !
  endif
  !
end subroutine gtx_plot

!
!----------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoTip">
!   <VERSION>
!                Id: modulePakoTip.f90,v 1.3.0 2017-10-05 Hans Ungerechts  !!  obsolete setPrivilege%GISMO
!                Id: modulePakoTip.f90,v 1.2.5 2016-06-08 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.4 2016-02-15 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.4 2016-01-28 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.4 2015-05-28 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.3 2015-02-12 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.3 2014-10-27 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.3 2014-06-25 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.3 2014-05-29 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.3 2014-02-10 Hans Ungerechts
!                Id: modulePakoTip.f90,v 1.2.3 2014-02-03 Hans Ungerechts
!                                      v 1.2.1 2013-04-08 Hans Ungerechts
!                incorporating
!                Id: modulePakoTip.f90,v 1.1.12.2  2013-03-26  Hans Ungerechts
!
!                Id: modulePakoTip.f90,v 1.2.0 2012-08-20 Hans Ungerechtsts
!                based on
!                Id: modulePakoTip.f90,v 1.1.5 2011-03-17 Hans Ungerechts
!   </VERSION>
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>
!                Calibrate
!                Focus
!                OnOff
!                OtfMap
!                Pointing
!                Tip
!                Track
!                VLBI
!   </SIBLINGS>        
!
!   Pako module for command: TIP
!
! </DOCUMENTATION> <!-- name="modulePakoTip" -->
!
!----------------------------------------------------------------------
!
!
!     Id: modulePakoTip.f90,v 1.1.5 2011-03-17 Hans Ungerechts
!     
!     Family:   OBSERVING MODES
!     Siblings: moduleTip.f90
!
!----------------------------------------------------------------------
!     PAKO module for TIP
!
Module modulePakoTip
  !
  Use modulePakoTypes
  Use modulePakoMessages
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  !! TBD 2.0:   Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  Public :: Tip
  Public :: displayTip
  Public :: saveTip
  Public :: startTip
!!$  Public :: tip, displayTip, saveTip, startTip
  !     
  ! *** Variables for tip ***
  Include 'inc/variables/variablesTip.inc'
!!!   
Contains
!!!
!!!
  Subroutine Tip( programName, line, command, error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer   ::  ia1, ia2, ia3, iiMax
    Real      ::  aFirst, aLast, eBot, eTop, speed, speedMax, timeMin
    !
    Logical   ::  isConnected
    !
    Include 'inc/ranges/rangesTip.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Tip, v 1.2.5 2016-06-08 ---> SR: Tip ")                     ! trace execution
    !
    ! *** initialize ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    !     read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    Call checkNofParameters(command,                                             &
         &     0, 1,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/parameters/parametersAzimuth.inc'
       Include 'inc/options/readOptionsTip.inc'
    End If
    !
    ! *** set defaults ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          Include 'inc/variables/setDefaults.inc'
       Endif
    Endif
    !
    ! *** read Parameters, Options (again, after defaults!) ***
    !     and check for validity and ranges 
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/parameters/parametersAzimuth.inc'
       Include 'inc/options/readOptionsTip.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.error) Then
       !
       errorInconsistent = .False.
       !
       aFirst = vars(iIn)%airmass%from
       aLast  = vars(iIn)%airmass%to
       !
       If (.Not. vars(iIn)%doSlew) Then
          If (aFirst .Gt. aLast) Then
             errorInconsistent = .True.
             Write (messageText,*) " from larger airmass ", aFirst,              &
                  &                " to smaller airmass ",  aLast,               &
                  &                " is only supported with option /Slew "       ! 
             Call pakoMessage(priorityE,severityE,"TIP ",messageText)
             Write (messageText,*) " up in elevation ",                          &
                  &                " is only supported with option /Slew "       ! 
             Call pakoMessage(priorityW,severityW,"TIP ",messageText)
          End If
       End If
       !
       Call queryReceiver(rec%Bolo, isConnected)
       !
       !D       Write (6,*) "   GV%privilege:   ", GV%privilege
       !
!!$       If      ( .Not. (     GV%privilege.Eq.setPrivilege%GISMO                  &
!!$            &           .Or. GV%privilege.Eq.setPrivilege%ncsTeam                &
       If      ( .Not. (     GV%privilege.Eq.setPrivilege%ncsTeam                &
            &          )     ) Then                                              !
          !
          If (.Not.isConnected .And. vars(iIn)%doSlew) Then
             errorInconsistent = .True.
             Write (messageText,*) "only supported with MAMBO bolometer"
             Call pakoMessage(priorityE,severityE,"TIP /Slew",messageText)
          End If
          !
       End If
       !
       If (vars(iIn)%doSlew) Then
!!OLD !!$          aFirst = Min (vars(iIn)%airmass%from, vars(iIn)%airmass%to)
!!OLD !!$          aLast  = Max (vars(iIn)%airmass%from, vars(iIn)%airmass%to)
          aFirst = vars(iIn)%airmass%from
          aLast  = vars(iIn)%airmass%to
          eTop     = Asin(1.0/aFirst)/deg
          eBot     = Asin(1.0/aLast)/deg
          speed    = Abs(eTop-eBot)/vars(iIn)%tSubscan
!!OLD !!$       speedMax = 30.0/60.0  !! JP: maximum  0.5 deg/sec                    !! 2007-01-23
!!OLD !!$                             !!            =  30 deg/min 
!!OLD !!$                             !!            = 360 deg / 12 min 
          speedMax = 22.5/60.0  !!     maximum  22.5 deg/min                   !! 2010-11-16 
                                !!            =              0.375 deg/sec 
                                !!            =  50% (JP) of 45    deg/min     !! 50% of Verstellbetrieb El (Brandt & Gatzlaff, 1981)
                                !!            =              360 deg / 16 min 
          timeMin  = Abs(eTop-eBot)/speedMax
          If (speed.Gt.speedMax) Then
             errorInconsistent = .True.
             Write (messageText,*) " implied speed ",                            &
                  &                speed,    " [deg/s] ",                        &
                  &                " is larger than limit ",                     &
                  &                speedMax, " [deg/s] "                         !
             Call pakoMessage(priorityE,severityE,"TIP ",messageText)
             Write (messageText,*) "use longer time, at least /tSubscan ",       &
                  &                timeMin,  " [s] "                             !
             Call pakoMessage(priorityI,severityI,"TIP ",messageText)
          End If
          If (Abs(eTop-eBot).Lt.40.0) Then
             Write (messageText,*) "small range in elevation ", Abs(eTop-eBot)
             Call pakoMessage(priorityW,severityW,"TIP ",messageText)
          End If
       End If
       !
       If (.Not. errorInconsistent) Then
          vars(iTemp) = vars(iIn)
       End If
       !
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue) = vars(iTemp)
    End If
    !
    ! *** display values ***
    If (.Not.ERROR) Then
       Call displayTip
    End If
    !
    ! *** set "selected" observing mode & plot ***
    If (.Not.error) Then
       GV%observingMode              =  OM%Tip
       GV%observingModePako          =  OMpako%Tip
       GV%omSystemName               =  GPnone
       GV%notReadyRXafterTip         =  .False.
       GV%notReadySWafterOM          =  .False.
       GV%notReadySecondaryRafterOM  =  .False.
       tipCommand                    =  line(1:lenc(line))
       Call analyzeTip (programName, errorA)
!!$       !TBD Call listSegmentList (errorA)
!!$       !TBD Call plotTip (errorP)
    End If
    !
    Return
  End Subroutine Tip
!!!
!!!
  Subroutine displayTip
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical            :: isConnected
    Character(len=24)  :: command
    Character(len=36)  :: valueText36
    !
    Call queryReceiver(rec%Bolo, isConnected)
    !
    Include 'inc/display/commandDisplayTip.inc'
    !
  End Subroutine displayTip
!!!
!!!
  Subroutine analyzeTip (programName, errorA)
    !
    Character(len=*),   Intent(in)   :: programName
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer              :: nScan 
    Character (len=12)   :: aUnit, sUnit
    Integer              :: iSS           = 0     ! counts subcans/segment
    Integer              :: nSS           = 1
    Real                 :: aa            = 1.0
    Real                 :: aFirst        = 1.0
    Real                 :: aLast         = 1.0
    Real                 :: aStep         = 1.0
    Real                 :: ee            = 10.0
    Real                 :: eFirst        = 10.0
    Real                 :: eLast         = 10.0
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Tip, v 1.2.5 2016-06-08 ---> SR: analyzeTip ")              ! trace execution
    !
    !D     Write (6,*) "      vars(iValue)%nAir:       ", vars(iValue)%nAir
    !D     Write (6,*) "      vars(iValue)%doTune:     ", vars(iValue)%doTune
    !D     Write (6,*) "      vars(iValue)%tTune:      ", vars(iValue)%tTune
    !
    errorA = .False.
    iSS    = 0
    nScan     = 1111
    aUnit     = au%degree                            ! TIP is in degree
    sUnit     = su%degree                            !     and   degree /second
    !
    ! TBD: info messages about number of subscans and elevations!
    !
!!OLD !!$    aFirst = Min (vars(iValue)%airmass%from, vars(iValue)%airmass%to)
!!OLD !!$    aLast  = Max (vars(iValue)%airmass%from, vars(iValue)%airmass%to)
    aFirst = vars(iValue)%airmass%from
    aLast  = vars(iValue)%airmass%to
    aStep  = Abs (vars(iValue)%airmass%by)
    eFirst = Asin(1.0/aFirst)/deg
    eLast  = Asin(1.0/aLast)/deg
    !
    If (.Not. vars(iValue)%doSlew) Then
       !
       nSS    = Int(Abs(aLast-aFirst)/aStep)+1
       aLast  = aFirst+(nSS-1)*aStep
       eLast  = Asin(1.0/aLast)/deg
       !
    End If
    !
    vars(iValue)%elevation = eLast
    !
    If (GV%doDebugMessages) Then
       Write (6,*) "    aFirst:            ", aFirst
       Write (6,*) "    Asin(1.0/aFirst):  ", Asin(1.0/aFirst)
       Write (6,*) "    eFirst:            ", eFirst
       Write (6,*) "    aLast:             ", aLast
       Write (6,*) "    Asin(1.0/aLast):   ", Asin(1.0/aLast)
       Write (6,*) "    eLast:             ", eLast
       Write (6,*) "    vars(iValue)%elevation: ", vars(iValue)%elevation
    End If
    !
    !                                                                            ! !! alternative versions of TIP /airmass
!!$    If ( vars(iValue)%nAir.Ge.6 ) Then                                        ! !! list of airmasses
    If ( vars(iValue)%hasAirmassList ) Then                                      ! !! list of airmasses
       !
       aLast = vars(iValue)%airmassList(vars(iValue)%nAir)
       eLast  = Asin(1.0/aLast)/deg
       vars(iValue)%elevation = eLast
       !
       If (GV%doDebugMessages) Then
          Write (6,*) "   --> list of Airmasses"
          Write (6,*) "    aLast:                    ", aLast
          Write (6,*) "    Asin(1.0/aLast):          ", Asin(1.0/aLast)
          Write (6,*) "    eLast:                    ", eLast
          Write (6,*) "    vars(iValue)%elevation:   ", vars(iValue)%elevation
       End If
       !
       Do ii = 1, vars(iValue)%nAir, 1                                           ! !! loop over list of airmasses
          !
          aa = vars(iValue)%airmassList(ii)
          ee = Asin(1.0/aa)/deg
          !
          If ( vars(iValue)%doTune ) Then                                        ! !! insert tune subscan
             !
             iSS = iSS+1
             !
             segList(iSS)            =  segDefault
             segList(iSS)%newSubscan =  .True.
             segList(iSS)%scanNumber =  nScan
             segList(iSS)%ssNumber   =  iSS
             segList(iSS)%segNumber  =  1
             segList(iSS)%ssType     =  ss%tune
             segList(iSS)%segType    =  seg%track
             segList(iSS)%angleUnit  =  aUnit
             segList(iSS)%speedUnit  =  sUnit
             segList(iSS)%flagOn     =  .True.
             segList(iSS)%flagRef    =  .False.
             segList(iSS)%pStart%x   =  0.0
             segList(iSS)%pStart%y   =  ee-eLast                                
             segList(iSS)%pEnd       =  segList(iSS)%pStart
             segList(iSS)%speedStart =  0.0
             segList(iSS)%speedEnd   =  0.0
             segList(iSS)%systemName =  'horizontal'
             segList(iSS)%altOption  =  'tSegment'
             segList(iSS)%tSegment   =  vars(iValue)%tTune
             segList(iSS)%tRecord    =  0.1
             !
             Write (messageText,'( A10,I4,A,A, A,F6.2, A,F6.2,A, A,F6.2,A )')    &
                  &                "subscan #:", iSS, " ", segList(iSS)%ssType,  &
                  &                " at airmass ", aa,                           &
                  &                " Elevation ", ee, " [deg]",                  &
                  &                " time ", segList(iSS)%tSegment, " [sec]"     !
             Call pakoMessage(priorityI,severityI,"TIP "//" Analyze",messageText)
             !D              Write (6,*) "      segList(iSS)%segType:   ", segList(iSS)%segType
             !D              Write (6,*) "      segList(iSS)%flagOn:    ", segList(iSS)%flagOn
             !D              Write (6,*) "      segList(iSS)%flagRef:   ", segList(iSS)%flagRef
             !
          End If   !!   ( vars(iValue)%doTune )
          !
          iSS = iSS+1                                                            ! !! track subscan
          !
          segList(iSS)            =  segDefault
          segList(iSS)%newSubscan =  .True.
          segList(iSS)%scanNumber =  nScan
          segList(iSS)%ssNumber   =  iSS
          segList(iSS)%segNumber  =  1
!!$       segList(iSS)%ssType     =  ss%track                                    ! !! standard track subscan (test) 2014-06-25
          segList(iSS)%ssType     =  ss%am                                       ! !! airmass subscan (special handling in execution!)
          segList(iSS)%segType    =  seg%track
          segList(iSS)%angleUnit  =  aUnit
          segList(iSS)%speedUnit  =  sUnit
          segList(iSS)%flagOn     =  .True.
          segList(iSS)%flagRef    =  .False.
          segList(iSS)%pStart%x   =  0.0
          segList(iSS)%pStart%y   =  ee-eLast
          segList(iSS)%pEnd       =  segList(iSS)%pStart
          segList(iSS)%speedStart =  0.0
          segList(iSS)%speedEnd   =  0.0
          segList(iSS)%systemName =  'horizontal'
          segList(iSS)%altOption  =  'tSegment'
          segList(iSS)%tSegment   =  vars(iValue)%tSubscan
          segList(iSS)%tRecord    =  0.1
          !
          Write (messageText,'( A10,I4,A,A, A,F6.2, A,F6.2,A, A,F6.2,A )')       &
               &                "subscan #:", iSS, " ", segList(iSS)%ssType,     &
               &                " at airmass ", aa,                              &
               &                " Elevation ", ee, " [deg]",                     &
               &                " time ", segList(iSS)%tSegment, " [sec]"        !
          Call pakoMessage(priorityI,severityI,"TIP "//" Analyze",messageText)
          !D           Write (6,*) "      segList(iSS)%segType:   ", segList(iSS)%segType
          !D           Write (6,*) "      segList(iSS)%flagOn:    ", segList(iSS)%flagOn
          !D           Write (6,*) "      segList(iSS)%flagRef:   ", segList(iSS)%flagRef
          !
!!$          Write (messageText,*) "subscan #:", iSS, " ", segList(iSS)%ssType,  &
!!$               &                " at airmass ", aa,                           &
!!$               &                " Elevation ", ee, " [deg]",                  &
!!$               &                " time ", segList(iSS)%tSegment, " [sec]"     !
!!$          Call pakoMessage(priorityI,severityI,"TIP "//" Analyze",messageText)
          !
       End Do   !!   ii = 1, vars(iValue)%nAir, 1  !! loop over list of airmasses
       !
    Else If (vars(iValue)%doSlew) Then                                           ! !! slew tip
       !
       iSS = 1
       !
          segList(iSS)            =  segDefault
          segList(iSS)%newSubscan =  .True.
          segList(iSS)%scanNumber =  nScan
          segList(iSS)%ssNumber   =  iSS
          segList(iSS)%segNumber  =  1
          segList(iSS)%ssType     =  ss%se
          segList(iSS)%segType    =  GPnone
          segList(iSS)%angleUnit  =  aUnit
          segList(iSS)%speedUnit  =  sUnit
          segList(iSS)%flagOn     =  .False.
          segList(iSS)%flagRef    =  .False.
          segList(iSS)%pStart%x   =  vars(iValue)%azimuth
          segList(iSS)%pStart%y   =  eFirst
          segList(iSS)%pEnd%x     =  vars(iValue)%azimuth
          segList(iSS)%pEnd%y     =  eLast
          segList(iSS)%speedStart =  Abs(eFirst-eLast)/vars(iValue)%tSubscan
          segList(iSS)%speedEnd   =  segList(iSS)%speedStart 
          segList(iSS)%systemName =  'horizontal'
          segList(iSS)%altOption  =  'tSegment'
          segList(iSS)%tSegment   =  vars(iValue)%tSubscan
          segList(iSS)%tRecord    =  0.1
          Write (messageText,*) "subscan #:", iSS, " ", segList(iSS)%ssType,     &
               &                        segList(iSS)%pStart%y,                   &
               &                " to ", segList(iSS)%pEnd%y  ,                   &
               &                " [deg] with speed ", segList(iSS)%speedStart    !
          Call pakoMessage(priorityI,severityI,"TIP "//" Analyze",messageText)
          !
    Else                                                                         ! !! from-to-by loop of airmasses
       !
       Do ii = 1, nSS, 1                                                         ! !! loop over airmasses
          !
          aa = aFirst + (ii-1)*aStep
          ee = Asin(1.0/aa)/deg
          !
          iSS = iSS+1
          segList(iSS)            =  segDefault
          segList(iSS)%newSubscan =  .True.
          segList(iSS)%scanNumber =  nScan
          segList(iSS)%ssNumber   =  iSS
          segList(iSS)%segNumber  =  1
          segList(iSS)%ssType     =  ss%am
          segList(iSS)%segType    =  seg%track
          segList(iSS)%angleUnit  =  aUnit
          segList(iSS)%speedUnit  =  sUnit
          segList(iSS)%flagOn     =  .False.
          segList(iSS)%flagRef    =  .False.
          segList(iSS)%pStart%x   =  0.0
          segList(iSS)%pStart%y   =  ee-eLast
          segList(iSS)%pEnd       =  segList(iSS)%pStart
          segList(iSS)%speedStart =  0.0
          segList(iSS)%speedEnd   =  0.0
          segList(iSS)%systemName =  'horizontal'
          segList(iSS)%altOption  =  'tSegment'
          segList(iSS)%tSegment   =  vars(iValue)%tSubscan
          segList(iSS)%tRecord    =  0.1
          !
          Write (messageText,*) "subscan #:", iSS, " ", segList(iSS)%ssType,     &
               &                " at airmass ", aa,                              &
               &                " Elevation ", ee, " [deg]",                     &
               &                " time ", segList(iSS)%tSegment, " [sec]"        !
          Call pakoMessage(priorityI,severityI,"TIP "//" Analyze",messageText)
          !
       End Do   !!   ii = 1, nSS, 1  !! loop over airmasses 
       !
    End If   !!  ( vars(iValue)%nAir.Ge.6 )  alternative versions of TIP /airmass
    !                                                     
    nSegments = iSS
    !
    Return 
    !
  End Subroutine analyzeTip
!!!
!!!
  Subroutine saveTip(programName,LINE,commandToSave,                             &
       &         iUnit, ERROR)                                                   !
    !
    !**   Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    Integer    ::  jj
    !
    contC = contNN
    Include 'inc/commands/saveCommand.inc'
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Tip, v 1.2.4 2015-05-27 --> SR: saveTip ")                  ! trace execution
    !
    contC = contCC
    Include 'inc/options/saveAirmass.inc'
    Include 'inc/options/saveSlew.inc'
!!$    Include 'inc/options/saveTpaddle.inc'
    !
    If (.Not. vars(iValue)%doTune) Then
       doContinue = .False.
       contC = contCN
    End If
    Include 'inc/options/saveTsubscan.inc'
    !
    If (vars(iValue)%doTune) Then
       Include 'inc/options/saveTune.inc'
       doContinue = .False.
       contC = contCN
       Include 'inc/options/saveTuneTime.inc'
    End If
    !
    ! NB: parameter Azimuth gets saved last
    !     because TIP without argument has special meaning:
    !     "current azimuth"
    contC = contNN
    Include 'inc/parameters/saveAzimuth.inc'
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveTip
!!!
!!!
  Subroutine startTip(programName,LINE,commandToSave,                            &
       &         iUnit, ERROR)                                                   !
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: ii
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: valueComment
    Logical                 :: errorL, errorXML
    !
    Character(len=lenLine)  ::  messageText
    !
    ! TBD: tip for heterodyne receivers
    !
    !D      Write (6,*) "  --> module moduleTip: SR startTip "
    ! 
    If (vars(iValue)%doCurrentAzimuth) Then
       Write (messageText,*)  " will be done at current azimuth "
       Call pakoMessage(priorityI,severityI,OM%tip(1:12),messageText)
    End If
    !
    Call pakoXMLsetOutputUnit(iunit=iunit)
    Call pakoXMLsetIndent(iIndent=2)
    !
    Include 'inc/startXML/generalHead.inc'
    !
    Call writeXMLset(programName,LINE,commandToSave,                             &
         &         iUnit, ERROR)                                                 !
    !
    Call pakoXMLwriteStartElement("RESOURCE","pakoScript",                       &
         &                         comment="save from pako",                     &
         &                         error=errorXML)                               !
    Call pakoXMLwriteStartElement("DESCRIPTION",                                 &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/savePakoScriptFirst.inc'
    !
    Call saveTip          (programName,LINE,commandToSave, iUnit, errorL)
    !                                                                       
    Call pakoXMLwriteEndElement("DESCRIPTION",                                   &
         &      error=errorXML)                                             
    Call pakoXMLwriteEndElement("RESOURCE", "pakoScript",                        &
         &      error=errorXML)                                                  !
    !
    Call writeXMLantenna(programName,LINE,commandToSave,                         &
         &         iUnit, ERROR)                                                 !
    !
    Call writeXMLreceiver(programName,LINE,commandToSave,                        &
         &         iUnit, ERROR)                                                 !
    !
    Call writeXMLbackend(programName,LINE,commandToSave,                         &
         &        iUnit, ERROR)                                                  !
    !
    Include 'inc/startXML/swTipXML.inc'
    !
    Include 'inc/startXML/sourceTip.inc'
    !
    Include 'inc/startXML/generalScanHead.inc'
    !
    ! **  Observing Mode to XML
    If (gv%doXMLobservingMode) Then
       messageText = "writing observing mode in XML format"
       Call PakoMessage(priorityI,severityI,                                     &
               &           commandToSave,messageText)                            !
       Call writeXMLtip(programName,LINE,commandToSave,                          &
         &         iUnit, ERROR)                                                 !
    End If
    !
    ! **  subscan list to XML
    Include 'inc/startXML/tipSubscansXML.inc'
    !   
    Include 'inc/startXML/generalTail.inc'
    !
    Return
  End Subroutine startTip
!!!
!!!
  Subroutine writeXMLtip(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: ii, len1, len2
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: valueComment
    Logical                 :: errorXML
    !
    Call pako_message(seve%t,"PAKO",                                             &
         &  " module Tip, v 1.2.4  --> SR: writeXMLTip 2015-05-28")              ! trace execution
    !
    ERROR = .False.
    !
    !D Write (6,*) "   --> writeXMLtip "
    !
    Call pakoXMLwriteStartElement("RESOURCE","observingMode",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    valueC = GV%observingMode
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         error=errorXML)                               ! 
    !
    Include 'inc/startXML/parametersAzimuthXML.inc'
    !
    Include 'inc/startXML/optionAirmassXML.inc'
    Include 'inc/startXML/optionSlewXML.inc'
    Include 'inc/startXML/optionTsubscanXML.inc'
!!$    Include 'inc/startXML/optionTpaddleXML.inc'
    Include 'inc/startXML/optionTune.inc'
    Include 'inc/startXML/optionTtune.inc'
    !
    Include 'inc/startXML/annotationsXML.inc'
    !
    Call pakoXMLwriteEndElement("RESOURCE","observingMode",                      &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLtip
!!!
!!!
End Module modulePakoTip

program minimize
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Main program for finding best linear combination
  !		X(i,j) = A*Y(i,j) + B
  ! Subroutines
  !	GDF100
  !---------------------------------------------------------------------
  ! Global
  ! Local
  character(len=filename_length) :: namey,namex
  logical :: error
  real :: a,b
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_close
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error,rank=0)
  if (error) goto 100
  !
  call gildas_null(x)
  call gdf_read_gildas(x,namex,'.gdf',error,rank=0)
  if (error) goto 100
  !
  call gdf100(x%loca%size,   &
     &    y%r1d,y%gil%bval,y%gil%eval,   &
     &    x%r1d,x%gil%bval,x%gil%eval,   &
     &    a,b)
  write(6,*) ' X = ',a,' * Y + ',b
  call gagout('I-MINI,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program minimize
!
subroutine gdf100(n, y,ybv,yev, x,xbv,xev, a,b)
  use gildas_def
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Find Linear combination of input arrays
  !	X = A*Y + B
  ! Arguments
  !	Y	R*4(*)	Input array
  !	X	R*4(*)	Output array
  !	N	I	Dimensions of arrays
  !	BVAL	R*4	Blanking values
  !	EVAL	R*4	Tolerance on blanking
  !	A	R*4	Multiplicative factor of array Y
  !	B	R*4	Additive constant
  !---------------------------------------------------------------------
  integer(kind=size_length) :: n                   !
  real :: y(n)                      !
  real :: ybv                       !
  real :: yev                       !
  real :: x(n)                      !
  real :: xbv                       !
  real :: xev                       !
  real :: a                         !
  real :: b                         !
  ! Local
  integer :: i,np
  real :: xm,ym,xym,y2m,r
  !
  np = 0
  xm = 0.
  ym = 0.
  xym = 0.
  y2m = 0.
  do i=1,n
    if (abs(x(i)-xbv).gt.xev .and.   &
     &      abs(y(i)-ybv).gt.yev) then
      np = np+1
      xm = xm + x(i)
      ym = ym + y(i)
      y2m = y2m + y(i)**2
      xym = xym + x(i)*y(i)
    endif
  enddo
  r = np*y2m - ym**2
  a = (np*xym - xm*ym) / r
  b = (xm*y2m - ym*xym) / r
  write(6,*) 'Number of pixels         ',n
  write(6,*) 'Number of blanked pixels ',n-np,   &
     &    float(n-np)/float(n)*100.,' %'
end subroutine gdf100

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetopology_spapos_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_axis_types
  use cubetools_spapro_types
  use cubetools_keywordlist_types
  use cubetopology_messaging
  !
  public :: spapos_comm_t,spapos_user_t,spapos_prog_t
  private
  !
  ! Coordinate types
  character(len=8), parameter :: ctypes(3) = [strg_star//'       ','relative','absolute']
  !
  type spapos_comm_t
     type(option_t),           pointer, private :: comm
     type(keywordlist_comm_t), pointer, private :: ctype
   contains
     procedure, public :: register => cubetopology_spapos_comm_register
     procedure, public :: parse    => cubetopology_spapos_comm_parse
  end type spapos_comm_t
  !
  type spapos_user_t
     logical,               public  :: present = .false. ! Present or absent?
     character(len=argu_l), private :: x = strg_star     ! Position along x-axis
     character(len=argu_l), private :: y = strg_star     ! Position along y-axis
     character(len=argu_l), private :: type = strg_star  ! Absolute or relative coordinates?
     character(len=argu_l), private :: unit = strg_star  ! Position unit, context dependent
   contains
     procedure, public  :: init   => cubetopology_spapos_user_init
     procedure, public  :: toprog => cubetopology_spapos_user_toprog
     procedure, public  :: list   => cubetopology_spapos_user_list
  end type spapos_user_t
  !
  !***JP: This could be a generic pixel_t
  type spapos_prog_t
     type(spapro_t), pointer, private :: spapro => null() ! Cube spatial projection
     type(axis_t),   pointer, private :: xaxis  => null() ! Cube X axis
     type(axis_t),   pointer, private :: yaxis  => null() ! Cube Y axis
     real(kind=coor_k),       public  :: p(2) = 0d0       ! [pix|chan] Values
   contains
     procedure, public :: nearest_pixel      => cubetopology_spapos_prog_nearest_pixel
     procedure, public :: nearest_entry      => cubetopology_spapos_prog_nearest_entry
     procedure, public :: offset             => cubetopology_spapos_prog_offset
     procedure, public :: absolute           => cubetopology_spapos_prog_absolute
     procedure, public :: axes_are_projected => cubetopology_spapos_prog_axes_are_projected
     procedure, public :: list               => cubetopology_spapos_prog_list
     procedure, public :: userstruct         => cubetopology_spapos_prog_userstruct
  end type spapos_prog_t
  !
contains
  !
  subroutine cubetopology_spapos_comm_register(comm,name,abstract,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(spapos_comm_t), intent(out)   :: comm
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: abstract
    logical,              intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: wordlistarg
    character(len=*), parameter :: rname='SPAPOS>COMM>REGISTER'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'xpos ypos type [unit]',&
         abstract,&
         'Describe a position in terms of relative or absolute&
         & coordinates. In case of relative coordinates they are&
         & relative to the current projection center, the possible&
         & units for a relative position are FOV units. Absolute&
         & positions can be given in three possible units: Equatorial&
         & (sexagesimal strings in the current spatial frame), Radian&
         & or Degree.',&
         comm%comm,&
         error)
    if (error) return
    call stdarg%register(&
         'xpos',&
         'Position along the X coordinate',&
         '"*" uses projection-center coordinate for absolute coordinates, ie,&
         & x = 0 for relative coordinates.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'ypos',&
         'Position along the Y coordinate',&
         '"*" uses projection-center coordinate for absolute coordinates, ie,&
         & y = 0 for relative coordinates.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call wordlistarg%register(&
         'type',&
         'Coordinate type',&
         '"*", "relative", or "absolute" are accepted tokens. "*" is equivalent to&
         & relative coordinates.',&
         code_arg_mandatory,&
         ctypes,&
         .not.flexible,&
         comm%ctype,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'Unit for xpos and ypos',&
         'Available units depend on the coordinate type:'//strg_cr//&
         '- FOV units for relative coordinates,'//strg_cr//&
         '- equatorial (i.e. sexagesimal hour angles and degrees if&
         & equatorial system, both sexagesimal degrees if galactic system),&
         & degrees or radians for absolute coordinates.',&
         code_arg_optional,&
         error)
    if (error) return
  end subroutine cubetopology_spapos_comm_register
  !
  subroutine cubetopology_spapos_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! /POS x y type [unit]
    !----------------------------------------------------------------------
    class(spapos_comm_t), intent(in)    :: comm
    character(len=*),     intent(in)    :: line
    type(spapos_user_t),  intent(out)   :: user  ! intent(out) => Initialized
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPAPOS>PARSE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call comm%comm%present(line,user%present,error)
    if (error) return
    if (user%present) then
       call cubetools_getarg(line,comm%comm,1,user%x,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%comm,2,user%y,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%comm,3,user%type,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%comm,4,user%unit,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubetopology_spapos_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetopology_spapos_user_init(user,error)
    !----------------------------------------------------------------------
    ! Initialize by setting the intent of user to out
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(out)   :: user 
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPAPOS>USER>INIT'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
  end subroutine cubetopology_spapos_user_init
  !
  subroutine cubetopology_spapos_user_toprog(user,cube,prog,error)
    use cubetuple_format_class
    use cubetools_header_methods
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(in)    :: user
    class(format_t),      intent(in)    :: cube
    type(spapos_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: ikey
    character(len=12) :: type
    character(len=*), parameter :: rname='SPAPOS>USER>TOPROG'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetools_header_point2spapro(cube%head,prog%spapro,error)
    if (error) return
    call cubetools_header_point2axis(cube%head%set%il,cube%head,prog%xaxis,error)
    if (error) return
    call cubetools_header_point2axis(cube%head%set%im,cube%head,prog%yaxis,error)
    if (error) return
    !
    call cubetools_disambiguate_strict(user%type,ctypes,ikey,type,error)
    if (error) return
    select case(type)
    case (strg_star,'RELATIVE')
       call user_toprog_relative(user,prog,error)
       if (error) return
    case ('ABSOLUTE')
       call user_toprog_absolute(user,prog,error)
       if (error) return
    case default
       call cubetopology_message(seve%e,rname,'Unknown coordinate type: '//trim(type))
       error = .true.
       return
    end select
    !
  contains
    !
    subroutine user_toprog_absolute(user,prog,error)
      use gkernel_interfaces
      use cubetools_user2prog
      use cubetools_unit
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      type(spapos_user_t), intent(in)    :: user
      type(spapos_prog_t), intent(inout) :: prog
      logical,             intent(inout) :: error
      !
      integer(kind=4) :: ival
      real(kind=coor_k) :: absolute(2),offset(2)
      type(unit_user_t) :: userunit
      character(len=unit_l) :: unit
      character(len=*), parameter :: units(4)=&
           [strg_star//'         ','equatorial','radian    ','degree    ']
      integer(kind=ndim_k), parameter :: ix=1,iy=2
      character(len=*), parameter :: rname='USER>TOPROG>ABSOLUTE'
      !
      call cubetopology_message(toposeve%trace,rname,'Welcome')
      !
      ! Get absolute position
      call cubetools_disambiguate_strict(user%unit,units,ival,unit,error)
      if (error) return
      select case(unit)
      case(strg_star,'EQUATORIAL')
         call sic_decode(user%x,absolute(ix),24,error)
         if (error) return
         call sic_decode(user%y,absolute(iy),360,error)
         if (error) return
      case('RADIAN','DEGREE')
         ! Unit is pang because we need either radian or degree
         call userunit%get_from_name_for_code(unit,code_unit_pang,error)
         if (error) return
         call cubetools_user2prog_resolve_star(user%x,userunit,prog%spapro%l0,absolute(ix),error)
         if (error) return
         call cubetools_user2prog_resolve_star(user%y,userunit,prog%spapro%m0,absolute(iy),error)
         if (error) return      
      case default
         call cubetopology_message(seve%e,rname,'Unknown unit type: '//trim(unit))
         error = .true.
         return
      end select
      ! From absolute to fractional pixel
      call prog%spapro%absolute2offset(absolute,offset,error)
      if (error) return
      call prog%xaxis%offset2pixel(offset(ix),prog%p(ix),error)
      if (error) return
      call prog%yaxis%offset2pixel(offset(iy),prog%p(iy),error)
      if (error) return
    end subroutine user_toprog_absolute
    !
    subroutine user_toprog_relative(user,prog,error)
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      type(spapos_user_t), intent(in)    :: user
      type(spapos_prog_t), intent(inout) :: prog
      logical,             intent(inout) :: error
      !
      integer(kind=ndim_k), parameter :: ix=1,iy=2
      character(len=*), parameter :: rname='USER>TOPROG>RELATIVE'
      !
      call cubetopology_message(toposeve%trace,rname,'Welcome')
      !
      call user_toprog_relative_for_axis(prog%xaxis,user%unit,user%x,prog%p(ix),error)
      if (error) return
      call user_toprog_relative_for_axis(prog%yaxis,user%unit,user%y,prog%p(iy),error)
      if (error) return
    end subroutine user_toprog_relative
    !
    subroutine user_toprog_relative_for_axis(axis,userunit,userval,progpix,error)
      use cubetools_unit
      use cubetools_user2prog
      use cubetools_axis_types
      !----------------------------------------------------------------------
      ! If it is covered by the cube, default position is the reference pixel.
      ! Else default position is the center of the axis
      !----------------------------------------------------------------------
      type(axis_t),      intent(inout) :: axis
      character(len=*),  intent(in)    :: userunit      
      character(len=*),  intent(in)    :: userval
      real(kind=coor_k), intent(out)   :: progpix
      logical,           intent(inout) :: error
      !
      type(unit_user_t) :: default_unit,user_unit
      real(kind=coor_k) :: default,offset
      !
      ! Default value
      if (axis%inside(0.d0)) then
         ! Reference pixel when inside
         default = axis%ref
      else
         ! Axis center else
         default = 0.5d0*axis%n
      endif
      !
      !***JP: This code block is identical to the one in cubetopology_sperange_user_toprog
      ! Default unit will depend on the axis kind
      call default_unit%get_from_code(axis%kind,error)
      if (error) return
      ! Get user unit from user input
      call user_unit%get_from_name(userunit,error)
      if (error) return
      !
      select case(user_unit%kind%code)
      case(code_unit_chan,code_unit_pixe)
         ! Directly resolve
         call cubetools_user2prog_resolve_star(userval,user_unit,default,progpix,error)
         if (error) return
      case(code_unit_unk)
         ! Use default axis unit
         ! 1. Convert default values from pixel to offset
         call cubetools_axis_pixel2offset(axis,default,default,error)
         if (error) return
         ! 2. Resolve between user and default values taking into account the user2prog unit conversion
         call cubetools_user2prog_resolve_star(userval,default_unit,default,offset,error)
         if (error) return
         ! 3. Convert back from offset to pixel
         call cubetools_axis_offset2pixel(axis,offset,progpix,error)
         if (error) return
      case default
         ! Check whether user and default units are consistent
         call user_unit%is_consistent_with(default_unit,error)
         if (error) return
         ! If yes, use them
         ! 1. Convert default values from pixel to offset
         call cubetools_axis_pixel2offset(axis,default,default,error)
         if (error) return
         ! 2. Resolve between user and default values taking into account the user2prog unit conversion
         call cubetools_user2prog_resolve_star(userval,user_unit,default,offset,error)
         if (error) return
         ! Convert back from offset to pixel
         call cubetools_axis_offset2pixel(axis,offset,progpix,error)
         if (error) return
      end select
      !***JP: This code block is identical to the one in cubetopology_sperange_user_toprog       
    end subroutine user_toprog_relative_for_axis
  end subroutine cubetopology_spapos_user_toprog
  !
  subroutine cubetopology_spapos_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(in)    :: user 
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPAPOS>USER>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    write(mess,'(6a,x,a)') &
         'Position  : (',trim(user%x),',',trim(user%y),') ',&
         trim(user%type),trim(user%unit)
    call cubetopology_message(seve%r,rname,mess)
  end subroutine cubetopology_spapos_user_list
  !
  !------------------------------------------------------------------------
  !
  function cubetopology_spapos_prog_nearest_pixel(prog) result(pixel)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spapos_prog_t), intent(in) :: prog
    integer(kind=pixe_k)             :: pixel(2) ! intent(out)
    !
    !***JP: Is there something cleverer in the axis type?
    pixel = nint(prog%p)
  end function cubetopology_spapos_prog_nearest_pixel
  !
  function cubetopology_spapos_prog_nearest_entry(prog) result(ie)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spapos_prog_t), intent(in) :: prog
    integer(kind=entr_k)             :: ie   ! intent(out)
    !
    integer(kind=pixe_k) :: pix,piy
    integer(kind=ndim_k), parameter :: ix=1,iy=2
    !
    pix = nint(prog%p(ix))
    piy = nint(prog%p(iy))
    if ( (pix.lt.1).or.(pix.gt.prog%xaxis%n).or. &
         (piy.lt.1).or.(piy.gt.prog%yaxis%n) ) then
       ie = 0
    else
       ie = pix + (piy-1)*prog%xaxis%n
    endif    
  end function cubetopology_spapos_prog_nearest_entry
  !
  subroutine cubetopology_spapos_prog_offset(prog,offset,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spapos_prog_t), intent(in)    :: prog
    real(kind=coor_k),    intent(out)   :: offset(2) ! [rad]
    logical,              intent(inout) :: error
    !
    integer(kind=ndim_k), parameter :: ix=1,iy=2
    !
    call cubetools_axis_pixel2offset(prog%xaxis,prog%p(ix),offset(ix),error)
    if (error) return
    call cubetools_axis_pixel2offset(prog%yaxis,prog%p(iy),offset(iy),error)
    if (error) return
  end subroutine cubetopology_spapos_prog_offset
  !
  subroutine cubetopology_spapos_prog_absolute(prog,absolute,error)
    !----------------------------------------------------------------------
    ! Convert to absolute coordinates when possible
    !----------------------------------------------------------------------
    class(spapos_prog_t), intent(in)    :: prog
    real(kind=coor_k),    intent(out)   :: absolute(2) ! [rad]
    logical,              intent(inout) :: error
    !
    integer(kind=ndim_k), parameter :: ix=1,iy=2
    character(len=*), parameter :: rname='SPAPOS>PROG>ABSOLUTE'
    !
    if ((prog%p(ix).eq.prog%xaxis%ref).and.(prog%p(iy).eq.prog%yaxis%ref)) then
       ! Straightforward, and support any projection including non
       ! supported ones, or NONE.
       absolute(ix) = prog%spapro%l0
       absolute(iy) = prog%spapro%m0
    else
       call prog%spapro%offset2absolute(prog%p,absolute,error)
       if (error) return
    endif
  end subroutine cubetopology_spapos_prog_absolute
  !
  function cubetopology_spapos_prog_axes_are_projected(prog,severity) result(projected)
    use cubetools_unit, only: code_unit_fov
    !----------------------------------------------------------------------
    ! Check whether X and Y axes are genuinely projected axes.
    !----------------------------------------------------------------------
    class(spapos_prog_t), intent(in) :: prog
    integer(kind=code_k), intent(in) :: severity
    logical                          :: projected ! intent(out)
    !
    character(len=*), parameter :: rname='SPAPOS>PROG>ABSOLUTE'
    !
    projected = (prog%xaxis%kind.eq.code_unit_fov).and.(prog%yaxis%kind.eq.code_unit_fov)
    if (.not.projected) call cubetopology_message(severity,rname,&
         'Spatial axes are not projected => absolute coordinates are unavailable')
  end function cubetopology_spapos_prog_axes_are_projected
  !
  subroutine cubetopology_spapos_prog_list(prog,error)
    use cubetools_unit
    use cubetools_format
    !----------------------------------------------------------------------
    ! User feedback
    !----------------------------------------------------------------------
    class(spapos_prog_t), intent(in)    :: prog 
    logical,              intent(inout) :: error
    !
    type(unit_user_t) :: unit
    real(kind=coor_k) :: offset(2),absolute(2)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPAPOS>PROG>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    if (prog%axes_are_projected(seve%d)) then
       call prog%absolute(absolute,error)
       if (error) return
       call cubetools_format_radec(absolute,mess,error)
       if (error) return
       call cubetopology_message(seve%r,rname,mess)
    else
       !***JP: The following is not generic enough. We should take into account
       !***JP: the axis unit in case it's not a fov!
       call unit%get_from_code(code_unit_fov,error)
       if (error) return
       call prog%offset(offset,error)
       if (error) return
       offset = offset*unit%user_per_prog    
       call cubetools_format_offset(offset,unit%name,mess,error)
       if (error) return
       call cubetopology_message(seve%r,rname,mess)
    endif
  end subroutine cubetopology_spapos_prog_list
  !
    subroutine cubetopology_spapos_prog_userstruct(prog,name,error)
    use cubetools_unit
    use cubetools_userspace
    use cubetools_userstruct
    !---------------------------------------------------------------------
    !***JP: The following is not generic enough. We should take into account
    !***JP: the axis unit in case it's not a fov!
    !---------------------------------------------------------------------
    class(spapos_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: name
    logical,              intent(inout) :: error
    !
    real(kind=coor_k) :: offset(2)
    type(unit_user_t) :: unit
    type(userstruct_t) :: userstruct
    integer(kind=ndim_k), parameter :: ix=1
    integer(kind=ndim_k), parameter :: iy=2
    character(len=*), parameter :: rname='SPAPOS>PROG>USERSTRUCT'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call unit%get_from_code(code_unit_fov,error)
    if (error) return
    call prog%offset(offset,error)
    if (error) return
    offset = offset*unit%user_per_prog
    call userstruct%create(name,global,overwrite_prog,error)
    if (error) return
    call userstruct%set_member('x',offset(ix),error)
    if (error) return
    call userstruct%set_member('y',offset(iy),error)
    if (error) return
    call userstruct%set_member('type','relative',error)
    if (error) return
    call userstruct%set_member('unit',unit%name,error)
    if (error) return
  end subroutine cubetopology_spapos_prog_userstruct
end module cubetopology_spapos_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeio_range
  use cubetools_parameters
  !---------------------------------------------------------------------
  ! Type used to describe (and access) a subset of the data
  !---------------------------------------------------------------------

  type cubeio_range_t
    integer(kind=indx_k) :: blc(maxdim)
    integer(kind=indx_k) :: trc(maxdim)
  end type cubeio_range_t

  public :: cubeio_range_t
  private

end module cubeio_range

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubestatistics_median
  use cubetemplate_one2two_real_template
  use cubestatistics_messaging
  !
  public :: cubestatistics_median_register
  private
  !
  type(one2two_real_comm_t) :: median
  !
contains
  !
  subroutine cubestatistics_median_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEDIAN>REGISTER'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call median%register_syntax(&
         'MEDIAN','cubeid','3D cube',[flag_any],cubestatistics_median_command,&
         'median',[flag_median,flag_image],&
         'mad',   [flag_mad   ,flag_image],&
         error)
    if (error) return
    call median%register_act(cubestatistics_median_prog_act,error)
    if (error) return
  end subroutine cubestatistics_median_register
  !
  subroutine cubestatistics_median_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(one2two_real_user_t) :: user
    character(len=*), parameter :: rname='MEDIAN>COMMAND'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call median%parse(line,user,error)
    if (error) return
    call median%main(user,error)
    if (error) continue
  end subroutine cubestatistics_median_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubestatistics_median_prog_act(prog,ie,spec,good,med,mad,error)
    use cubetools_parameters
    use cubeadm_spectrum_types
    use cubemain_statistics_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_real_prog_t), intent(inout) :: prog
    integer(kind=entr_k),       intent(in)    :: ie
    type(spectrum_t),           intent(inout) :: spec
    type(spectrum_t),           intent(inout) :: good
    type(spectrum_t),           intent(inout) :: med
    type(spectrum_t),           intent(inout) :: mad
    logical,                    intent(inout) :: error
    !
    type(spectrum_t) :: line
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='MEDIAN>PROG>ACT'
    !
    call spec%get(ie,error)
    if (error) return
    call line%point_to(spec,prog%region%iz%first,prog%region%iz%last,1.0,error)
    if (error) return
    call good%unblank(line,error)
    if (error) return
    !
    med%y%val(one) = statistics%median(good%y%val,good%n)
    call med%put(ie,error)
    if (error) return
    !
    mad%y%val(one) = statistics%mad(good%y%val,good%n,med%y%val(one))
    call mad%put(ie,error)
    if (error) return
  end subroutine cubestatistics_median_prog_act
end module cubestatistics_median
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine to_imfits(fits,check,error)
  use gildas_def
  use phys_const
  use gbl_message
  use image_def
  use gio_dependencies_interfaces, no_interface=>gr4_extrema
  use gio_interfaces, except_this=>to_imfits
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! FITS
  !       Write a GDF-image onto FITS tape
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: fits   !
  logical,      intent(in)    :: check  ! Verbose flag
  logical,      intent(inout) :: error  ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=80) :: line
  character(len=12) :: specsyscode
  character(len=23) :: date
  real(kind=8) :: altrval, altrpix
  integer(kind=4) :: i, fits_naxis, velrefcode
  integer(kind=size_length) :: imin,imax,nfill
  integer(kind=address_length) :: ip
  !
  ip = gag_pointer(fits%loca%addr,memory)
  !
  !                    123456789012345678901234567890
  fd%nb = 0
  call gfits_put('SIMPLE  =                    T         /',check,error)
  if (error) goto 99
  write (line,10) 'BITPIX  =           ',fd%snbit
  call gfits_put(line,check,error)
  if (error) goto 99
  !
  ! Define the axes
  fits_naxis = fits%gil%ndim
  write(line,10) 'NAXIS   =           ',fits_naxis
  call gfits_put(line,check,error)
  if (error) goto 99
  do i=1,fits_naxis
    write (line,11) 'NAXIS',i,'  =           ',fits%gil%dim(i)
    call gfits_put(line,check,error)
    if (error) goto 99
  enddo
  !
  ! Compute extrema: if missing section, or if section present but
  ! its values are obviously wrong (unset)
  if (fits%gil%extr_words.eq.0 .or.  &
     (fits%gil%extr_words.ne.0 .and.  &
        (any(fits%gil%minloc(1:fits%gil%ndim).eq.0) .or.  &
         any(fits%gil%maxloc(1:fits%gil%ndim).eq.0) ))) then
    if (fits%gil%blan_words.eq.0) fits%gil%eval = -1.0
    call gr4_extrema(fits%loca%size,memory(ip),fits%gil%bval,fits%gil%eval, &
                     fits%gil%rmin,fits%gil%rmax,imin,imax)
  endif
  if (fd%snbit.gt.0) then
    if (fd%snbit.eq.16) then
      fd%bscal = (fits%gil%rmax - fits%gil%rmin) / 65534.0
      if (fd%bscal.eq.0.0) fd%bscal = 1.0
      fd%bzero = fits%gil%rmin + fd%bscal * 32768.0
    elseif (fd%snbit.eq.32) then
      fd%bscal = (fits%gil%rmax - fits%gil%rmin) / 4294967294.
      fd%bscal = fd%bscal * (1.0+2.0*epsilon(1.0))  ! Allow some room for roundoff
      if (fd%bscal.eq.0.0) fd%bscal = 1.0
      fd%bzero = fits%gil%rmin + fd%bscal * 2147483648.
    endif
    write (line,20) 'BSCALE  = ',fd%bscal
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'BZERO   = ',fd%bzero
    call gfits_put(line,check,error)
    if (error) goto 99
    if (fd%snbit.eq.16) then
      write (line,10) 'BLANK   =           ',32767,'Blanking value'
      call gfits_put(line,check,error)
      if (error) goto 99
    elseif (fd%snbit.eq.32) then
      write (line,10) 'BLANK   =           ',2147483647,'Blanking value'
      call gfits_put(line,check,error)
      if (error) goto 99
    endif
  endif
  write (line,20) 'DATAMIN = ',fits%gil%rmin
  call gfits_put(line,check,error)
  if (error) goto 99
  write (line,20) 'DATAMAX = ',fits%gil%rmax
  call gfits_put(line,check,error)
  if (error) goto 99
  if (lenc(fits%char%unit).gt.0) then
    call gfits_put('BUNIT   = '''//fits%char%unit//'''               /',check,error)
  else
    call gfits_put('BUNIT   = '''//'UNKNOWN     '//'''               /',check,  &
    error)
  endif
  if (error) goto 99
  !
  ! NOISE
  if (fits%gil%nois_words.gt.0) then
    write (line,20) 'NOISETHE= ',fits%gil%noise,'Theoretical noise'
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'NOISEMEA= ',fits%gil%rms,'Measured noise'
    call gfits_put(line,check,error)
    if (error) goto 99
  endif
  !
  ! Axis
  if (fits%gil%desc_words.eq.0) then  ! Protection against junk...
    do i=1,gdf_maxdims
      fits%char%code(i) = 'UNKNOWN'
    enddo
    fits%char%syst = 'UNKNOWN'
    fits%char%unit = 'UNKNOWN'
  endif
  do i=1,fits_naxis 
    call write_axis(fits,i,check,error)
    if (error) goto 99
  enddo
  ! Divers
  call gfits_put('OBJECT  = '''//fits%char%name//'''               /',check,error)
  if (error) goto 99
  if (fits%char%syst.eq.'GALACTIC') then
    write (line,20) 'GLAT    = ',180.d0*fits%gil%lii/pi,'Galactic latitude'
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'GLON    = ',180.d0*fits%gil%bii/pi,'Galactic longitude'
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'EQUINOX = ',fits%gil%epoc
    call gfits_put(line,check,error)
    if (error) goto 99
  elseif (fits%char%syst.eq.'EQUATORIAL') then
    if (nearly_equal(fits%gil%epoc,2000.,1e-6)) then
      write (line,13) 'RADESYS = ','FK5','Coordinate system'
      call gfits_put(line,check,error)
      if (error) goto 99
    endif
    write (line,20) 'RA      = ',180.d0*fits%gil%ra/pi,'Right Ascension'
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'DEC     = ',180.d0*fits%gil%dec/pi,'Declination'
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'EQUINOX = ',fits%gil%epoc
    call gfits_put(line,check,error)
    if (error) goto 99
  elseif (fits%char%syst.eq.'ICRS') then
    write (line,13) 'RADESYS = ','ICRS','Coordinate system'
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'RA      = ',180.d0*fits%gil%ra/pi,'Right Ascension'
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'DEC     = ',180.d0*fits%gil%dec/pi,'Declination'
    call gfits_put(line,check,error)
    if (error) goto 99
  elseif (fits%gil%ptyp.ne.p_none) then
    write (line,40) 'COMMENT Unknown coordinate system'
    call gfits_put(line,check,error)
    if (error) goto 99
  endif
  !
  ! Frequency / Velocity axis
  if (fits%gil%spec_words.ne.0) then
    write (line,40) 'LINE    = '''//fits%char%line//'''               /'
    call gfits_put(line,check,error)
    if (fits%gil%faxi.eq.0) then
      call gio_message(seve%w,'TO_IMFITS','No frequency axis')
    else
      altrpix = fits%gil%convert(1,fits%gil%faxi)
      write(line,20) 'ALTRPIX = ',altrpix    ! Ref. pixel from header
      call gfits_put(line,check,error)
      if (fits%char%code(fits%gil%faxi).eq.'FREQUENCY') then 
        altrval = fits%gil%convert(2,fits%gil%faxi)  ! Freq. at ref. pixel   
        altrval = 299792.458d0*(1d0-altrval/fits%gil%freq)  ! Velocity  = c*(1-z) 
        altrval = fits%gil%voff*1d3              ! km/s to m/s        
      else
        altrval = fits%gil%convert(2,fits%gil%faxi) ! Velocity at ref. pixel 
        altrval = (fits%gil%freq-altrval*fits%gil%freq/299792.458d0)  ! Freq. at ref. pixel
        altrval = altrval*1d6  ! GHz to Hz
      endif
      write(line,20) 'ALTRVAL = ',altrval ! Freq. at ref. pixel
      call gfits_put(line,check,error)
      write(line,20) 'RESTFREQ= ',fits%gil%freq*1d6 ! Rest frequency
      call gfits_put(line,check,error)
      if (fits%gil%fima.gt.0.d0) then
        write(line,20) 'IMAGFREQ= ',fits%gil%fima*1d6 ! Image frequency
        call gfits_put(line,check,error)
      endif
      ! Do not write anymore...
      !!    write(line,20) 'VELREF  = ',fits%gil%voff*1d5  ! km/s to cm/s unfortunately
      !!    call gfits_put(line,check,error)
      ! Use a more proper keyword instead
      !   convention AIPS: velref = 0 ==> none, 1 2 3 = LSR, Sun, Obs +256 if radio
      if (fits%gil%vtyp.eq.vel_lsr) then
        write(line,20) 'VELO-LSR= ',fits%gil%voff*1d3  ! km/s to m/s
        call gfits_put(line,check,error)
        velrefcode = 257  ! code for LSR velocities
        specsyscode = 'LSRK'
      elseif (fits%gil%vtyp.eq.vel_hel) then
        write(line,20) 'VELO-HEL= ',fits%gil%voff*1d3  ! km/s to m/s
        call gfits_put(line,check,error)
        velrefcode = 258  ! code for Heliocentric velocities
        specsyscode = 'BARYCENT'
      elseif (fits%gil%vtyp.eq.vel_obs) then
        write(line,20) 'VELO-OBS= ',fits%gil%voff*1d3  ! km/s to m/s
        call gfits_put(line,check,error)
        velrefcode = 259  ! code for Observatory 
        specsyscode = 'TOPOCENT'
      else
        write(line,20) 'VELOCITY= ',fits%gil%voff*1d3  ! km/s to m/s
        call gfits_put(line,check,error)
        velrefcode = 0  
        specsyscode = ' '
      endif
      write(line,10) 'VELREF  =           ', velrefcode
      call gfits_put(line,check,error)
      write(line,40) 'SPECSYS = '''//specsyscode//'''               /'
      call gfits_put(line,check,error)
    endif
  endif
  !
  if (fits%gil%reso_words.ne.0) then
    write (line,20) 'BMAJ    = ',fits%gil%majo*180.0/pi
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'BMIN    = ',fits%gil%mino*180.0/pi
    call gfits_put(line,check,error)
    if (error) goto 99
    write (line,20) 'BPA     = ',fits%gil%posa*180.0/pi
    call gfits_put(line,check,error)
    if (error) goto 99
  endif
  !
  ! Miscellaneous
  call gfits_put('ORIGIN  = ''GILDAS Consortium  ''        /',check,error)
  if (error) goto 99
  ! New ISO Date Format
  call sic_isodate(date)
  write (line,13) 'DATE    = ',trim(date),'Date written'
  call gfits_put(line,check,error)
  if (error) goto 99
  !
  ! Finish Header, Write data
  call gfits_put('END                         ',check,error)
  if (error) goto 99
  call gfits_flush_header(error)
  if (error) goto 99
  call write_all(fd,memory(ip),fits%loca%size,nfill,fits%gil%bval,fits%gil%eval,error)
  call gfits_flush_data(error)
  if (error) goto 99
  return
  !
99 error = .true.
  return
  !
10 format(a,i10,'         / ',a)
11 format(a,i1,a,i10,'         / ',a)
13 format(a,'''',a,'''',t40,'/ ',a)
20 format(a,e20.13,'         / ',a)
40 format(a)
end subroutine to_imfits
!
subroutine write_axis(fits,axis_number,check,error)
  use phys_const
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>write_axis
  !---------------------------------------------------------------------
  ! @ private
  ! FITS
  ! Try to write a sensible output axis name and units, according to
  ! standard FITS (stupid) conventions which requires degrees instead
  ! of Radians...
  !---------------------------------------------------------------------
  type(gildas),    intent(in)    :: fits         !
  integer(kind=4), intent(in)    :: axis_number  ! Axis number
  logical,         intent(in)    :: check        ! Verbose flag
  logical,         intent(inout) :: error        ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=11) :: line1,line6
  character(len=10) :: line2,line3,line4,line5
  real(kind=8) :: val,inc,ref,rota
  character(len=80) :: line
  character(len=12) :: code, unit
  logical :: projected
  integer(kind=4) :: l
  logical, parameter :: export_radio_as_sfl=.true.
  !
  write(line1,101) axis_number
  write(line2,102) axis_number
  write(line3,103) axis_number
  write(line4,104) axis_number
  write(line5,105) axis_number
  write(line6,106) axis_number
  !
101 format ('CTYPE',i1,'  = ''')
102 format ('CRVAL',i1,'  = ')
103 format ('CDELT',i1,'  = ')
104 format ('CRPIX',i1,'  = ')
105 format ('CROTA',i1,'  = ')
106 format ('CUNIT',i1,'  = ''')
  !
  if (fits%gil%ptyp.ne.p_none) then
    projected = (axis_number.eq.fits%gil%xaxi .or. axis_number.eq.fits%gil%yaxi)
  else
    projected = .false.
  endif
  !
  ! Recognised codes should be
  !       RA      DEC
  !       L       B       or      GLAT    GLON
  !       FREQUENCY
  !       VELOCITY
  !
  ref = fits%gil%ref(axis_number)
  val = fits%gil%val(axis_number)
  inc = fits%gil%inc(axis_number)
  code = fits%char%code(axis_number)
  rota = 0.d0
  !
  if (code.eq.'L'.or.code.eq.'LII') then
    code = 'GLON'
  elseif (code.eq.'B'.or.code.eq.'BII') then
    code = 'GLAT'
  endif
  !
  if (projected) then
    l = lenc(code)+1
    code(l:8) = '------------'
    if (fits%gil%ptyp.eq.p_gnomonic) then
      code(6:8) = 'TAN'
    elseif (fits%gil%ptyp.eq.p_ortho) then
      code(6:8) = 'SIN'
    elseif (fits%gil%ptyp.eq.p_azimuthal) then
      code(6:8) = 'ARC'
    elseif (fits%gil%ptyp.eq.p_stereo) then
      code(6:8) = 'STG'
    elseif (fits%gil%ptyp.eq.p_aitoff) then
      code(6:8) = 'AIT'
    elseif (fits%gil%ptyp.eq.p_sfl) then
      code(6:8) = 'SFL'
    elseif (fits%gil%ptyp.eq.p_radio) then
      ! See related IRAM Memo
      if (export_radio_as_sfl) then
        code(6:8) = 'SFL'
      else
        code(6:8) = 'GLS'
      endif
    else
      code(6:8) = '   '
    endif
    !
    ! Compute reference pixel so that VAL(REF) = 0
    ref = ref - val/inc
    if (fits%gil%xaxi.eq.axis_number) then  ! X axis
      val = fits%gil%a0
    else  ! Y axis
      if (fits%gil%ptyp.eq.p_radio .and. export_radio_as_sfl) then
        ! GLS is the same as SFL projection with reference declination
        ! 0 and appropriate shift of the reference pixel
        call gio_message(seve%w,rname,'Projection kind converted from radio to SFL')
        ref = ref-fits%gil%d0/inc
        val = 0.d0
      elseif (fits%gil%ptyp.eq.p_aitoff) then
        ! Because GILDAS support for Aitoff projection implements equations
        ! ignoring the d0 reference value (i.e. it is forced on the Equator).
        val = 0.d0
      else
        val = fits%gil%d0
      endif
    endif
    val = val*180.d0/pi
    inc = inc*180.d0/pi
    rota = 180.d0/pi*fits%gil%pang
    unit = 'deg'
  elseif (code.eq.'RA'   .or. code.eq.'L'    .or. code.eq.'DEC' .or.  &
          code.eq.'B'    .or. code.eq.'LII'  .or. code.eq.'BII' .or.  &
          code.eq.'GLAT' .or. code.eq.'GLON' .or. code.eq.'LAT' .or.  &
          code.eq.'LON') then
    val = val*180.d0/pi
    inc = inc*180.d0/pi
  elseif (code.eq.'FREQUENCY') then
    val = val*1.0d6            ! MHz to Hz
    inc = inc*1.0d6
    unit = 'Hz'
  elseif (code.eq.'VELOCITY') then
    code = 'VRAD'              ! force VRAD instead of VELOCITY for CASA
    val = val*1.0d3            ! km/s to m/s
    inc = inc*1.0d3
    unit = 'm/s'
  else
    l = lenc(code)+1
    code(l:12) = '            '    ! fills with blanks code.
    unit = ' '
  endif
  !
  call gfits_put(line1//code//'''               /',check,error)
  if (error) goto 99
  write (line,20) line2,val
  call gfits_put(line,check,error)
  if (error) goto 99
  if (inc.eq.0.0d0) inc = 1.0d0
  write (line,20) line3,inc
  call gfits_put(line,check,error)
  if (error) goto 99
  write (line,20) line4,ref
  call gfits_put(line,check,error)
  if (error) goto 99
  write (line,20) line5,rota
  call gfits_put(line,check,error)
  if (error) goto 99
  call gfits_put(line6//unit//'''               /',check,error)
  return
99 return
20 format(a,e20.13,'         / ',a)
end subroutine write_axis

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_allocate_fft_wifi(ispace,wifi,fft,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_allocate_fft_wifi
  use wifisyn_cube_types
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  integer,              intent(in)    :: ispace
  type(wifi_t), target, intent(in)    :: wifi
  type(fft_t),          intent(out)   :: fft
  logical,              intent(inout) :: error
  !
  integer :: nx,ny
  character(len=*), parameter :: rname='ALLOCATE/FFT/WIFI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(wifi%cub%val)) then
     call wifisyn_message(seve%t,rname,'Unallocated wifi%cub')
     error = .true.
     return
  endif
  fft%wifi => wifi%cub
  if (ispace.eq.code_space_uv) then
     nx = wifi%cub%nu
     ny = wifi%cub%nv
     fft%datakind => wifi%uvkind
  else if (ispace.eq.code_space_xy) then
     nx = wifi%cub%nx
     ny = wifi%cub%ny
     fft%datakind => wifi%xykind
  else
     call wifisyn_message(seve%e,rname,'Unknown plane')
     error = .true.
     return
  endif
  call wifisyn_allocate_complex_2d("fft plane",nx,ny,fft%plane,error)
  if (error) return
  call wifisyn_allocate_complex_1d("fft work space",max(nx,ny),fft%work,error)
  if (error) return
  !
end subroutine wifisyn_allocate_fft_wifi
!
subroutine wifisyn_allocate_fft_visi(visi,fft,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_allocate_fft_visi
  use wifisyn_cube_types
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(visi_t), target, intent(in)    :: visi
  type(fft_t),          intent(out)   :: fft
  logical,              intent(inout) :: error
  !
  integer :: nx,ny
  character(len=*), parameter :: rname='ALLOCATE/FFT/VISI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(visi%cub%val)) then
     call wifisyn_message(seve%t,rname,'Unallocated visicub')
     error = .true.
     return
  endif
  fft%datakind => visi%uvkind
  fft%visi => visi%cub
  nx = visi%cub%nx
  ny = visi%cub%ny
  call wifisyn_allocate_complex_2d("fft plane",nx,ny,fft%plane,error)
  if (error) return
  call wifisyn_allocate_complex_1d("fft work space",max(nx,ny),fft%work,error)
  if (error) return
  !
end subroutine wifisyn_allocate_fft_visi
!
subroutine wifisyn_free_fft(fft,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_free_fft
  use wifisyn_transform_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(fft_t), intent(inout) :: fft
  logical,     intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE/FFT'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nullify(fft%wifi)
  nullify(fft%visi)
  call wifisyn_free_complex_2d(fft%plane,error)
  if (error) return
  call wifisyn_free_complex_1d(fft%work,error)
  if (error) return
  !
end subroutine wifisyn_free_fft
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_fft_command(line,error)
  use gbl_message
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_fft_command
  use wifisyn_sic_buffer
  use wifisyn_cube_buffer
  use wifisyn_transform_types
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !     FFT WIFI|VISI
  !       1 /DIRECT
  !       2 /INVERSE
  !       3 /UV
  !       4 /XY
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  type(action_t) :: do
  character(len=*), parameter :: rname='FFT/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_parse_transform(line,do,error)
  if (error) return
  if (do%cube.eq.code_cube_visi) then
     call wifisyn_fft_visi(do%dire,progmap%win%cur(1),visi,error)
     if (error) return
  else if (do%cube.eq.code_cube_wifi) then
     call wifisyn_fft_wifi(do%dire,do%space,progmap%win%cur(1),wifi,error)
     if (error) return
  else
     call wifisyn_message(seve%e,rname,'Unknown cube kind')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_fft_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_fft_wifi(idir,ispace,win,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_wifi
  use wifisyn_gridding_types
  use wifisyn_cube_types
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  integer,        intent(in)    :: ispace
  type(window_t), intent(in)    :: win
  type(wifi_t),   intent(inout) :: wifi
  logical,        intent(inout) :: error
  !
  type(fft_t) :: fft
  character(len=*), parameter :: rname='FFT/WIFI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_allocate_fft_wifi(ispace,wifi,fft,error)
  if (error) return
  if (ispace.eq.code_space_uv) then
     call wifisyn_fft_wifi_uv(idir,win,fft,error)
     if (error) return
  else if (ispace.eq.code_space_xy) then
     call wifisyn_fft_wifi_xy(idir,win,fft,error)
     if (error) return
  else
     call wifisyn_message(seve%e,rname,'Unknown plane')
     error = .true.
     return
  endif
  call wifisyn_free_fft(fft,error)
  if (error) return
  !
end subroutine wifisyn_fft_wifi
!
subroutine wifisyn_fft_wifi_xy(idir,win,fft,error)
  use gbl_message
  use gkernel_interfaces, nointerface=>fourt
  use gkernel_types
  use wifisyn_interfaces, except_this=>wifisyn_fft_wifi_xy
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  type(window_t), intent(in)    :: win
  type(fft_t),    intent(inout) :: fft
  logical,        intent(inout) :: error
  !
  integer :: iu,iv,ic,dim(2)
  type(time_t) :: time
  character(len=*), parameter :: rname='FFT/WIFI/XY'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  if (idir.eq.code_direct) then
     call wifisyn_message(seve%i,rname,'WIFI XY direct FFT')
  else
     call wifisyn_message(seve%i,rname,'WIFI XY inverse FFT')
  endif
  !
  dim = (/ fft%wifi%nx,fft%wifi%ny/)
  call gtime_init(time,fft%wifi%nv*fft%wifi%nu*win%nchan,error)
  do iv=1,fft%wifi%nv
     do iu=1,fft%wifi%nu
        do ic=win%first,win%last
           call gtime_current(time)
           call wifisyn_fft_xyuv2xy(ic,iu,iv,fft)
           call fourt(fft%plane%val,dim,2,idir,code_type_complex,fft%work%val)
           call wifisyn_fft_xy2xyuv(ic,iu,iv,fft)
        enddo ! ic
     enddo ! iu
  enddo !iv
  fft%datakind = .not.fft%datakind
  !
end subroutine wifisyn_fft_wifi_xy
!
subroutine wifisyn_fft_xyuv2xy(ic,iu,iv,fft)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_xyuv2xy
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  integer,     intent(in)    :: iu
  integer,     intent(in)    :: iv
  type(fft_t), intent(inout) :: fft
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='FFT/XYUV2XY'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = fft%plane%nx/2
  my = fft%plane%ny/2
  do iy=1,my
     ! xy bottom, left quarter
     do ix=1,mx
        fft%plane%val(ix,iy) = fft%wifi%val(ic,ix+mx,iy+my,iu,iv)
     enddo
     ! xy bottom, right quarter
     do ix=1,mx
        fft%plane%val(ix+mx,iy) = fft%wifi%val(ic,ix,iy+my,iu,iv)
     enddo
  enddo
  do iy=1,my
     ! xy top, left quarter
     do ix=1,mx
        fft%plane%val(ix,iy+my) = fft%wifi%val(ic,ix+mx,iy,iu,iv)
     enddo
     ! xy top, right quarter
     do ix=1,mx
        fft%plane%val(ix+mx,iy+my) = fft%wifi%val(ic,ix,iy,iu,iv)
     enddo
  enddo
  !
end subroutine wifisyn_fft_xyuv2xy
!
subroutine wifisyn_fft_xy2xyuv(ic,iu,iv,fft)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_fft_xy2xyuv
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  integer,     intent(in)    :: iu
  integer,     intent(in)    :: iv
  type(fft_t), intent(inout) :: fft
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='FFT/XY2XYUV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = fft%plane%nx/2
  my = fft%plane%ny/2
  do iy=1,my
     ! xy bottom, left quarter
     do ix=1,mx
        fft%wifi%val(ic,ix+mx,iy+my,iu,iv) = fft%plane%val(ix,iy)
     enddo
     ! xy bottom, right quarter
     do ix=1,mx
        fft%wifi%val(ic,ix,iy+my,iu,iv) = fft%plane%val(ix+mx,iy)
     enddo
  enddo
  do iy=1,my
     ! xy top, left quarter
     do ix=1,mx
        fft%wifi%val(ic,ix+mx,iy,iu,iv) = fft%plane%val(ix,iy+my)
     enddo
     ! xy top, right quarter
     do ix=1,mx
        fft%wifi%val(ic,ix,iy,iu,iv) = fft%plane%val(ix+mx,iy+my)
     enddo
  enddo
  !
end subroutine wifisyn_fft_xy2xyuv
!
subroutine wifisyn_fft_wifi_uv(idir,win,fft,error)
  use gbl_message
  use gkernel_interfaces, nointerface=>fourt
  use gkernel_types
  use wifisyn_interfaces, except_this=>wifisyn_fft_wifi_uv
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  type(window_t), intent(in)    :: win
  type(fft_t),    intent(inout) :: fft
  logical,        intent(inout) :: error
  !
  integer :: ix,iy,ic,dim(2)
  type(time_t) :: time
  character(len=*), parameter :: rname='FFT/WIFI/UV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  if (idir.eq.code_direct) then
     call wifisyn_message(seve%i,rname,'WIFI UV direct FFT')
  else
     call wifisyn_message(seve%i,rname,'WIFI UV inverse FFT')
  endif
  !
  dim = (/ fft%wifi%nu,fft%wifi%nv/)
  call gtime_init(time,fft%wifi%nx*fft%wifi%ny*win%nchan,error)
  do iy=1,fft%wifi%ny
     do ix=1,fft%wifi%nx
        do ic=win%first,win%last
           call gtime_current(time)
           call wifisyn_fft_xyuv2uv(ic,ix,iy,fft)
           call fourt(fft%plane%val,dim,2,idir,code_type_complex,fft%work%val)
           call wifisyn_fft_uv2xyuv(ic,ix,iy,fft)
        enddo ! ic
     enddo ! ix
  enddo !iy
  fft%datakind = .not.fft%datakind
  !
end subroutine wifisyn_fft_wifi_uv
!
subroutine wifisyn_fft_xyuv2uv(ic,ix,iy,fft)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_xyuv2uv
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  integer,     intent(in)    :: ix
  integer,     intent(in)    :: iy
  type(fft_t), intent(inout) :: fft
  !
  integer :: iu,mu
  integer :: iv,mv
  character(len=*), parameter :: rname='FFT/XYUV2UV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mu = fft%plane%nx/2
  mv = fft%plane%ny/2
  do iv=1,mv
     ! uv bottom, left quarter
     do iu=1,mu
        fft%plane%val(iu,iv) = fft%wifi%val(ic,ix,iy,iu+mu,iv+mv)
     enddo
     ! uv bottom, right quarter
     do iu=1,mu
        fft%plane%val(iu+mu,iv) = fft%wifi%val(ic,ix,iy,iu,iv+mv)
     enddo
  enddo
  do iv=1,mv
     ! uv top, left quarter
     do iu=1,mu
        fft%plane%val(iu,iv+mv) = fft%wifi%val(ic,ix,iy,iu+mu,iv)
     enddo
     ! uv top, right quarter
     do iu=1,mu
        fft%plane%val(iu+mu,iv+mv) = fft%wifi%val(ic,ix,iy,iu,iv)
     enddo
  enddo
  !
end subroutine wifisyn_fft_xyuv2uv
!
subroutine wifisyn_fft_uv2xyuv(ic,ix,iy,fft)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_fft_uv2xyuv
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  integer,     intent(in)    :: ix
  integer,     intent(in)    :: iy
  type(fft_t), intent(inout) :: fft
  !
  integer :: iu,mu
  integer :: iv,mv
  character(len=*), parameter :: rname='FFT/UV2XYUV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mu = fft%plane%nx/2
  mv = fft%plane%ny/2
  do iv=1,mv
     ! uv bottom, left quarter
     do iu=1,mu
        fft%wifi%val(ic,ix,iy,iu+mu,iv+mv) = fft%plane%val(iu,iv)
     enddo
     ! uv bottom, right quarter
     do iu=1,mu
        fft%wifi%val(ic,ix,iy,iu,iv+mv) = fft%plane%val(iu+mu,iv)
     enddo
  enddo
  do iv=1,mv
     ! uv top, left quarter
     do iu=1,mu
        fft%wifi%val(ic,ix,iy,iu+mu,iv) = fft%plane%val(iu,iv+mv)
     enddo
     ! uv top, right quarter
     do iu=1,mu
        fft%wifi%val(ic,ix,iy,iu,iv) = fft%plane%val(iu+mu,iv+mv)
     enddo
  enddo
  !
end subroutine wifisyn_fft_uv2xyuv
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_fft_visi(idir,win,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_visi
  use wifisyn_gridding_types
  use wifisyn_cube_types
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  type(window_t), intent(in)    :: win
  type(visi_t),   intent(inout) :: visi
  logical,        intent(inout) :: error
  !
  type(fft_t) :: fft
  character(len=*), parameter :: rname='FFT/VISI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_allocate_fft_visi(visi,fft,error)
  if (error) return
  call wifisyn_fft_visi_uv(idir,win,fft,error)
  if (error) return
  call wifisyn_free_fft(fft,error)
  if (error) return
  !
end subroutine wifisyn_fft_visi
!
subroutine wifisyn_fft_visi_uv(idir,win,fft,error)
  use gbl_message
  use gkernel_interfaces, nointerface=>fourt
  use gkernel_types
  use wifisyn_interfaces, except_this=>wifisyn_fft_visi_uv
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  type(window_t), intent(in)    :: win
  type(fft_t),    intent(inout) :: fft
  logical,        intent(inout) :: error
  !
  integer :: ic,dim(2)
  type(time_t) :: time
  character(len=*), parameter :: rname='FFT/VISI/UV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  if (idir.eq.code_direct) then
     call wifisyn_message(seve%i,rname,'VISI direct FFT')
  else
     call wifisyn_message(seve%i,rname,'VISI inverse FFT')
  endif
  !
  dim = (/ fft%visi%nx,fft%visi%ny/)
  call gtime_init(time,win%nchan,error)
  do ic=win%first,win%last
     call gtime_current(time)
     call wifisyn_fft_visi2plane(ic,fft)
     call fourt(fft%plane%val,dim,2,idir,code_type_complex,fft%work%val)
     call wifisyn_fft_plane2visi(ic,fft)
  enddo ! ic
  fft%datakind = .not.fft%datakind
  !
end subroutine wifisyn_fft_visi_uv
!
subroutine wifisyn_fft_visi2plane(ic,fft)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_visi2plane
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  type(fft_t), intent(inout) :: fft
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='FFT/VISI2PLANE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = fft%plane%nx/2
  my = fft%plane%ny/2
  do iy=1,my
     ! Plane bottom, left quarter
     do ix=1,mx
        fft%plane%val(ix,iy) = fft%visi%val(ix+mx,iy+my,ic)
     enddo
     ! Plane bottom, right quarter
     do ix=1,mx
        fft%plane%val(ix+mx,iy) = fft%visi%val(ix,iy+my,ic)
     enddo
  enddo
  do iy=1,my
     ! Plane top, left quarter
     do ix=1,mx
        fft%plane%val(ix,iy+my) = fft%visi%val(ix+mx,iy,ic)
     enddo
     ! Plane top, right quarter
     do ix=1,mx
        fft%plane%val(ix+mx,iy+my) = fft%visi%val(ix,iy,ic)
     enddo
  enddo
  !
end subroutine wifisyn_fft_visi2plane
!
subroutine wifisyn_fft_plane2visi(ic,fft)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_fft_plane2visi
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  type(fft_t), intent(inout) :: fft
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='FFT/PLANE2VISI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = fft%plane%nx/2
  my = fft%plane%ny/2
  do iy=1,my
     ! Plane bottom, left quarter
     do ix=1,mx
        fft%visi%val(ix+mx,iy+my,ic) = fft%plane%val(ix,iy)
     enddo
     ! Plane bottom, right quarter
     do ix=1,mx
        fft%visi%val(ix,iy+my,ic) = fft%plane%val(ix+mx,iy)
     enddo
  enddo
  do iy=1,my
     ! Plane top, left quarter
     do ix=1,mx
        fft%visi%val(ix+mx,iy,ic) = fft%plane%val(ix,iy+my)
     enddo
     ! Plane top, right quarter
     do ix=1,mx
        fft%visi%val(ix,iy,ic) = fft%plane%val(ix+mx,iy+my)
     enddo
  enddo
  !
end subroutine wifisyn_fft_plane2visi
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_userspace
  use gkernel_interfaces
  use gkernel_types
  use cubesyntax_messaging
  use cubetools_parameters
  use cubetools_structure
  use cubelist_types
  !
  public :: userspace_opt_t,userspace_user_t,userspace_t
  public :: cubetools_userspace_array_remove,cubetools_userspace_array_update
  public :: cubetools_userspace_get,cubetools_userspace_query
  public :: overwrite_no,overwrite_user,overwrite_prog
  private
  !
  integer(kind=4), parameter  :: nforbid = 2
  character(len=*), parameter :: forbidden(2) = [strg_star,strg_equal]
  !
  ! Overwriting modes
  integer(kind=4), parameter :: overwrite_no  =100  ! Attempt to overwrite raises an error
  integer(kind=4), parameter :: overwrite_user=101  ! Overwriting a user-defined variable is allowed
  integer(kind=4), parameter :: overwrite_prog=102  ! Overwriting a user or program-defined variable is allowed
  !
  type userspace_opt_t
     type(option_t),      pointer :: opt
     type(keywordlist_comm_t), pointer :: scope
     type(keywordlist_comm_t), pointer :: overwrite
   contains
     procedure :: register  => cubetools_userspace_register
     procedure :: parse     => cubetools_userspace_parse
     procedure :: user2prog => cubetools_userspace_user2prog
  end type userspace_opt_t
  !
  type userspace_user_t
     logical               :: do        = .false.
     character(len=varn_l) :: name      = strg_unk
     character(len=argu_l) :: scope     = strg_unk
     character(len=argu_l) :: overwrite = strg_unk
  end type userspace_user_t
  !
  type, extends(list_object_t) :: userspace_t
     character(len=varn_l)  :: name
     logical                :: scope
     integer(kind=code_k)   :: overwrite
     type(sic_descriptor_t) :: desc ! sic descriptor
   contains
     procedure, private :: copy => cubetools_userspace_copy
     generic, public    :: assignment(=) => copy
     procedure :: delete      => cubetools_sicdef_delete
     procedure :: fetch_desc  => cubetools_sicdef_fetch_descriptor
     procedure :: has_changed => cubetools_sicdef_desc_changed
     procedure, public :: final => cubetools_userspace_final
  end type userspace_t
  !
contains
  !
  subroutine cubetools_userspace_register(opt,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(userspace_opt_t), intent(out)   :: opt
    logical,                intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: scope(2) = ['GLOBAL','LOCAL ']
    character(len=*), parameter :: yesno(2) = ['YES','NO ']
    character(len=*), parameter :: rname='USERSPACE>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'INTO','varname [scope [overwrite]]',&
         'Define the SIC variable name and its status',&
         strg_emp,&
         opt%opt,error)
    if (error) return
    call stdarg%register( &
         'varname',  &
         'Variable name', &
         strg_emp,&
         code_arg_mandatory, &
         error)
    if (error) return
    call keyarg%register( &
         'scope',  &
         'Variable is global or local', &
         'Default is global',&
         code_arg_optional, &
         scope, &
         .not.flexible, &
         opt%scope, &
         error)
    if (error) return
    call keyarg%register( &
         'overwrite',  &
         'Overwrite previous variable of same name', &
         'Default is yes',&
         code_arg_optional, &
         yesno, &
         .not.flexible, &
         opt%overwrite, &
         error)
    if (error) return
  end subroutine cubetools_userspace_register
  !
  subroutine cubetools_userspace_parse(opt,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(userspace_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    type(userspace_user_t), intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='USERSPACE>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,opt%opt,1,user%name,mandatory,error)
       if (error) return
       user%scope = 'LOCAL'
       call cubetools_getarg(line,opt%opt,2,user%scope,.not.mandatory,error)
       if (error) return
       user%overwrite = 'YES'
       call cubetools_getarg(line,opt%opt,3,user%overwrite,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubetools_userspace_parse
  !
  subroutine cubetools_userspace_user2prog(opt,user,prog,error)
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(userspace_opt_t), intent(in)    :: opt
    type(userspace_user_t), intent(in)    :: user
    class(userspace_t),     intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    character(len=argu_l) :: scope,overwrite
    integer(kind=4) :: ikey,iforbid
    character(len=*), parameter :: rname='USERSPACE>USER2PROG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    do iforbid=1,nforbid
       if (user%name.eq.forbidden(iforbid)) then
          call cubesyntax_message(seve%e,rname,'The name '//trim(user%name)//&
               ' is protected and cannot be used')
          error = .true.
          return
       endif
    enddo
    call cubetools_disambiguate_toupper(user%name,prog%name,error)
    if (error) return
    call cubetools_keywordlist_user2prog(opt%scope,user%scope,ikey,scope,error)
    if (error) return
    prog%scope = scope.eq.'GLOBAL'
    call cubetools_keywordlist_user2prog(opt%overwrite,user%overwrite,ikey,overwrite,error)
    if (error) return
    if (overwrite.eq.'YES') then
      ! NB: user has no access to overwrite_prog (avoid LOAD /INTO PI)
      prog%overwrite = overwrite_user
    else
      prog%overwrite = overwrite_no
    endif
  end subroutine cubetools_userspace_user2prog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_userspace_get(name,userspace,error)
    !----------------------------------------------------------------------
    ! Get a userspace element from a name and a type
    !----------------------------------------------------------------------
    character(len=*),   intent(in)    :: name
    class(userspace_t), intent(out)   :: userspace
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='USERSPACE>GET'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (.not.sic_varexist(name)) then
      call cubesyntax_message(seve%e,rname,'Variable '//trim(name)//' does not exist')
      error = .true.
      return
    endif
    !
    userspace%name = name
    call userspace%fetch_desc(error)
    if (error) return
    if (userspace%desc%readonly) then
      userspace%overwrite = overwrite_no
    else
      userspace%overwrite = overwrite_user
    endif
    userspace%scope = sic_level(name).eq.0
  end subroutine cubetools_userspace_get
  !
  function cubetools_userspace_query(name)
    !----------------------------------------------------------------------
    ! Tests if a variable with name exists in userspace
    !----------------------------------------------------------------------
    logical :: cubetools_userspace_query
    character(len=*), intent(in) :: name
    !
    cubetools_userspace_query = sic_varexist(name)
  end function cubetools_userspace_query
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_delete(userspace,error)
    !------------------------------------------------------------------------
    ! Tests if a sic object with that name exists:
    ! - if it does not, simply return
    ! - if it does and overwrite is forbidden, raise an error
    ! - if it does and overwrite is allowed, delete the variable
    !------------------------------------------------------------------------
    class(userspace_t), intent(in)    :: userspace
    logical,            intent(inout) :: error
    !
    logical :: found,user_request
    type(sic_descriptor_t) :: desc
    character(len=*), parameter :: rname='SICDEF>DELETE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    found = .false.
    call sic_descriptor(trim(userspace%name),desc,found)
    !
    if (.not.found)  return
    !
    if (userspace%overwrite.eq.overwrite_no) then
      call cubesyntax_message(seve%e,rname,'Variable '//trim(userspace%name)//' already exists')
      error = .true.
      return
    endif
    !
    ! Important: SIC variables must be deleted (sic_delvariable) with
    ! the proper 'user request' flag matching its internal status,
    ! otherwise this messes up the internal list of variables.
    if (desc%status.eq.program_defined) then
      if (userspace%overwrite.eq.overwrite_prog) then
        ! CUBE allows this program-defined variable to be deleted
        user_request = .false.
      else
        ! Any other program-defined variable is protected (e.g. PI)
        user_request = .true.
      endif
    else
      user_request = .true.
    endif
    call cubesyntax_message(syntaxseve%others,rname,trim(userspace%name)//' exists, overwriting it')
    call sic_delvariable(trim(userspace%name),user_request,error)
    if (error) return
  end subroutine cubetools_sicdef_delete
  !
  subroutine cubetools_sicdef_fetch_descriptor(userspace,error)
    !------------------------------------------------------------------------
    ! Fetch sic descriptor for the userspace item
    !------------------------------------------------------------------------
    class(userspace_t), intent(inout) :: userspace
    logical,            intent(inout) :: error
    !
    logical :: found
    character(len=*), parameter :: rname='SICDEF>FETCH>DESCRIPTOR'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    found = .false.
    call sic_descriptor(userspace%name,userspace%desc,found)
    if (.not.found) then
       call cubesyntax_message(seve%e,rname,'User space item does not exist')
       error = .true.
       return
    endif
  end subroutine cubetools_sicdef_fetch_descriptor
  !
  function cubetools_sicdef_desc_changed(userspace) result(changed)
    !------------------------------------------------------------------------
    ! Checks if descriptor for a userspace object exists, and if it
    ! has changed since created
    !------------------------------------------------------------------------
    class(userspace_t), intent(in) :: userspace
    logical                        :: changed   
    !
    logical :: found
    type(sic_descriptor_t) :: mydesc
    character(len=*), parameter :: rname='SICDEF>DESCRIPTOR>CHANGED'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_descriptor(userspace%name,mydesc,found)
    if (.not.found) then
       changed = .true.
       return
    else
       changed = sic_notsamedesc(userspace%desc,mydesc)
    endif
  end function cubetools_sicdef_desc_changed
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_userspace_array_remove(arr,uspace,error)
    !-------------------------------------------------------------------
    ! Clean out from the list elements which are "identical" to the
    ! given userspace. This is intended to be used before inserting such
    ! a userspace, i.e. to avoid conflicts.
    !-------------------------------------------------------------------
    type(list_t),       intent(inout) :: arr
    class(userspace_t), intent(in)    :: uspace
    logical,            intent(inout) :: error
    ! Local
    integer(kind=list_k) :: obuf
    class(userspace_t), pointer :: lspace
    !
    obuf = 1
    do while (obuf.le.arr%n)  ! NB: arr%n is expected to change during loop execution
      lspace => cubetools_userspace_ptr(arr%list(obuf)%p,error)
      if (error) return
      if (lspace%name.eq.uspace%name .and.  &
          (lspace%scope.eqv.uspace%scope)) then
        call arr%pop(obuf,error)
        if (error) return
      else
        obuf = obuf+1
      endif
    enddo
  end subroutine cubetools_userspace_array_remove
  !
  subroutine cubetools_userspace_array_update(arr,error)
    !------------------------------------------------------------------------
    ! Update the array list, i.e. check for buffers removed by some
    ! external mean (e.g. user DELETE /VAR) and compress the list
    ! accordingly
    !------------------------------------------------------------------------
    type(list_t), intent(inout) :: arr
    logical,      intent(inout) :: error
    !
    class(userspace_t), pointer :: uspace
    integer(kind=4) :: oldn,newn,obuf
    character(len=*), parameter :: rname='USERSPACE>ARRAY>UPDATE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'welcome')
    !
    if (arr%n.le.0)  return
    !
    oldn = arr%n
    newn = 0
    do obuf=1,oldn
      uspace => cubetools_userspace_ptr(arr%list(obuf)%p,error)
      if (error) return
      if (uspace%has_changed()) then
        ! Ideally we should use arr%pop(), but I would like
        ! to avoid compressing the list several times, as several
        ! buffers migth be removed here
        if (arr%list(obuf)%code_pointer.eq.code_pointer_allocated)  &
          deallocate(uspace)
      else
        newn = newn+1
        arr%list(newn)%p => uspace
        arr%list(newn)%code_pointer = arr%list(obuf)%code_pointer
      endif
    enddo
    !
    ! There might be unused elements at the end of the list
    do obuf=newn+1,oldn
      arr%list(obuf)%p => null()
      arr%list(obuf)%code_pointer = code_pointer_null
    enddo
    !
    ! Update array size
    arr%n = newn
    !
    if (newn.eq.0) then
      call arr%final(error)
      if (error) return
    endif
  end subroutine cubetools_userspace_array_update
  !
  function cubetools_userspace_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(userspace_t), and return a
    ! pointer to it if relevant.
    !-------------------------------------------------------------------
    class(userspace_t), pointer :: cubetools_userspace_ptr  ! Function value on return
    class(list_object_t), pointer       :: tot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='USERSPACE>PTR'
    !
    select type(tot)
    class is (userspace_t)
      cubetools_userspace_ptr => tot
    class default
      cubetools_userspace_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a userspace_t class')
      error = .true.
      return
    end select
  end function cubetools_userspace_ptr
  !
  subroutine cubetools_userspace_copy(o,i)
    !-------------------------------------------------------------------
    ! Copy one userspace_t CLASS to another CLASS
    !-------------------------------------------------------------------
    class(userspace_t), intent(inout) :: o
    class(userspace_t), intent(in)    :: i
    !
   !o%list_object_t = i%list_object_t
    o%name          = i%name
    o%scope         = i%scope
    o%overwrite     = i%overwrite
    o%desc          = i%desc
  end subroutine cubetools_userspace_copy
  !
  subroutine cubetools_userspace_final(obj,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(userspace_t), intent(inout) :: obj
    logical,            intent(inout) :: error
  end subroutine cubetools_userspace_final
  !
end module cubetools_userspace
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine open_procedure(line,error)
  use sic_interfaces, except_this=>open_procedure
  use gildas_def
  use sic_structures
  use sic_interactions
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='BEGIN'
  character(len=filename_length) :: file
  character(len=procname_length) :: name
  integer :: i,nc,ier
  !
  if (nproc.eq.maxpro) then
    call sic_message(seve%e,rname,'Too many procedures')
    error = .true.
    return
  endif
  !
  if (proced) then
    call sic_message(seve%e,rname,'Missing END command')
    error = .true.
    return
  endif
  !
  call sic_ch (line,0,2,name,nc,.true.,error)
  if (error) return
  if (nc.gt.procname_length) then
    call sic_message(seve%e,rname,'Procedure name too long')
    error = .true.
    return
  endif
  !
  call sic_parsef (name,file,'GAG_PROC:',sicext(1)(1:lext(1)))
  ier = sic_open(luntem,file,'UNKNOWN',.false.)
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Cannot open file for procedure')
    call putios('E-BEGIN,  ',ier)
    error = .true.
    return
  endif
  !
  proced = .true.
  if (sic_lire().eq.0) then
    ! Modify the prompt base to procedure name (without modifying the
    ! "master" prompt)
    gprompt_nlire_old = -10    ! Enforce next rebuild of the prompt
    call gprompt_base_set(name)
  endif
  !
  do i=1,nproc
    if (name.eq.proc_name(i)) then
      call sic_message(seve%d,rname,'Re-defining '//name)
      if (proc_file(i).ne.file) then
        call gag_filrm(proc_file(i))
        proc_file(i) = file
      endif
      iproc = i
      return
    endif
  enddo
  nproc = nproc+1
  proc_name(nproc) = name
  proc_file(nproc) = file
  iproc = nproc
  call sic_message(seve%d,rname,'Defining '//name)
  call sic_message(seve%d,rname,'on '//file)
end subroutine open_procedure
!
subroutine write_procedure(com,line,nline,error)
  use sic_interfaces, except_this=>write_procedure
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*)                :: com    !
  character(len=*)                :: line   !
  integer                         :: nline  !
  logical,          intent(inout) :: error  !
  ! Local
  integer :: ier
  !
  ! Any command
  write(luntem,'(A)',iostat=ier) line(1:nline)
  if (ier.ne.0) error = .true.
end subroutine write_procedure
!
subroutine close_procedure(com,line,nline,error)
  use sic_interfaces, except_this=>close_procedure
  use sic_structures
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*)                :: com    !
  character(len=*)                :: line   !
  integer                         :: nline  !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='END'
  character(len=procname_length) :: name
  integer :: nc
  !
  if (.not.proced) then
    call sic_message(seve%e,rname,'Missing BEGIN command')
    error = .true.
    return
  endif
  !
  ! Check consistency
  name = ' '
  call sic_ch (line,0,2,name,nc,.false.,error)
  if (error)  return
  if (name.ne.' ' .and. name.ne.proc_name(iproc)) then
    call sic_message(seve%e,rname,'Mismatched BEGIN / END PROCEDURE pair')
    call sic_message(seve%e,rname,'Expected "'//trim(proc_name(iproc))//  &
    '", typed "'//trim(name)//'"')
    error = .true.
    return
  endif
  !
  ! Close the procedure
  close(unit=luntem)
  proced = .false.
  if (sic_lire().eq.0) then
    ! Revert the prompt base to the "master" prompt
    gprompt_nlire_old = -10    ! Enforce next rebuild of the prompt
    call gprompt_base_set(gprompt_master)
  endif
  !
end subroutine close_procedure
!
subroutine end_procedure
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>end_procedure
  use gildas_def
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: file
  integer :: i,ier
  !
  do i=1,nproc
    file = proc_file(i)
    call sic_message(seve%d,'SIC','Deleting '//file)
    call gag_filrm(file)
  enddo
  nproc = 0
  !
  ! Remove the directory
  file = 'GAG_PROC:'
  i = sic_getlog(file)
  if (file.eq.gag_proc) then
    ier = gag_rmdir(file)
    if (ier.ne.0)  &
      call sic_message(seve%w,'PROCEDURE','Error removing directory: '//file)
  else
    call sic_message(seve%e,'PROCEDURE','Unexpected change of GAG_PROC:')
    call sic_message(seve%e,'PROCEDURE','Expected '//gag_proc)
    call sic_message(seve%e,'PROCEDURE','Found    '//file)
  endif
end subroutine end_procedure
!
subroutine find_procedure(name,file,found)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>find_procedure
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the procedure file name (path+name+extension) given the
  ! input name ([path+]name[+extension])
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   ! Name to be resolved
  character(len=*), intent(out)   :: file   ! Path to the file
  logical,          intent(inout) :: found  ! Found a procedure or not?
  ! Local
  integer(kind=4) :: i,lastdot,lastsep
  character(len=1) :: insep,ousep,disep
  !
  found = .true.
  do i=1,nproc
    if (proc_name(i).eq.name) then
      !! Print *,'NAME ',trim(name),' File ',trim(file)
      file = proc_file(i)
      return
    endif
  enddo
  !
  call gag_separ(insep,ousep,disep)
  lastdot = index(name,'.',.true.)
  lastsep = index(name,disep,.true.)  ! Can be zero
  !
  if (lastdot.ne.0 .and. lastdot.gt.lastsep) then
    ! 'name' is something like "../a/./foo.bar" => an extension is provided,
    ! do not scan the extensions list
    if (find_procedure_ext(name,'',file))  return
  else
    ! No extension: loop on list of known extensions
    do i=1,maxext
      if (lext(i).eq.0) exit
      if (find_procedure_ext(name,sicext(i)(1:lext(i)),file))  return
    enddo
  endif
  !
  ! Macro not found
  found = .false.
  !
contains
  function find_procedure_ext(name,ext,file)
    use sic_dependencies_interfaces
    use sic_interfaces
    logical :: find_procedure_ext
    character(len=*), intent(in)  :: name
    character(len=*), intent(in)  :: ext
    character(len=*), intent(out) :: file
    ! Local
    logical :: exist
    !
    find_procedure_ext = .true.
    if (sic_query_file(name,'MACRO#DIR:',ext,file)) then
      ! Try first in MACRO#DIR:
      !! Print *,'Found File ',trim(name),' - ',trim(file)
      return
      !
    else
      ! If not found, try a normal path (absolute or relative)
      call sic_parse_file(name,' ',ext,file)
      inquire (file=file,exist=exist)
      if (exist) return
    endif
    find_procedure_ext = .false.
  end function find_procedure_ext
  !
end subroutine find_procedure
!
subroutine begin_area(line,error)
  use sic_interfaces, except_this=>begin_area
  use gildas_def
  use sic_structures
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='BEGIN'
  character(len=filename_length) :: name,file
  character(len=256) :: string
  integer, parameter :: mvoc=3
  character(len=16) :: vocab(mvoc),keywor
  integer :: nc,ier,iunit,nkey
  logical :: ok
  data vocab/'PROCEDURE','HELP','DATA'/
  !
  call sic_ke (line,0,1,name,nc,.true.,error)
  if (error) return
  !
  call sic_ambigs('BEGIN',name,keywor,nkey,vocab,mvoc,error)
  if (error) return
  !
  ! New Procedure
  if (keywor.eq.'PROCEDURE') then
    call open_procedure(line,error)
    if (.not.error) sic_quiet = .true.
    !
    ! New help file
  elseif (keywor.eq.'HELP') then
    !
    ! Only valid within macro file
    if (mlire(nlire).le.0) then
      call sic_message(seve%e,rname,'Command only valid within macros')
      error = .true.
      return
    endif
    call sic_ch (line,0,2,name,nc,.true.,error)
    if (error) return
    ier = index(name(1:nc),'.')
    if (ier.ne.0) nc = ier-1
    if (nc.gt.len(proc_name(1))) then
      call sic_message(seve%e,rname,'Help file name too long')
      error = .true.
      return
    endif
    !
    call sic_parsef (name,file,'GAG_PROC:','.hlp')
    ier = sic_open(luntem,file,'UNKNOWN',.false.)
    if (ier.ne.0) then
      call sic_message(seve%e,rname,'Cannot open help file')
      call putios('E-BEGIN,  ',ier)
      error = .true.
      return
    endif
    ok = .true.
    string = '1 '//name
    call sic_upper(string)       ! ?
    do while (ok)
      write(luntem,'(A)') trim(string)
      read(lunmac(nmacro),'(A)',iostat=ier) string
      if (ier.ne.0) then
        ok = .false.
        call sic_message(seve%e,rname,'Missing END HELP keyword')
      elseif (sic_eqchain(string(1:8),'END HELP')) then
        ok = .false.
      endif
    enddo
    close(unit=luntem)
    !
    ! New data file
  else
    call sic_ch (line,0,2,name,nc,.true.,error)
    if (error) return
    call sic_parsef (name,file,' ','.dat')
    ier = sic_open(luntem,file,'NEW',.false.)
    if (ier.ne.0) then
      call sic_message(seve%e,rname,'Cannot open new data file')
      call putios('E-BEGIN,  ',ier)
      error = .true.
      return
    endif
    !
    if (mlire(nlire).eq.0) then   ! Read on keyboard (from STDIN or redirected with <)
      iunit = 5
    elseif (mlire(nlire).gt.0) then  ! Else read in macro file
      iunit = lunmac(nmacro)
    else
      call sic_message(seve%e,rname,'Command invalid in this context')
      error = .true.
      return
    endif
    !
    ok = .true.
    do while (ok)
      if (mlire(nlire).eq.0 .and. sic_inter_state(0)) then
        call sic_wprn('DATA> ',string,nc)
      else
        read(iunit,'(A)',iostat=ier) string
      endif
      if (ier.ne.0) then
        ok = .false.
        call sic_message(seve%e,rname,'Missing END DATA keyword')
      elseif (sic_eqchain(string(1:8),'END DATA')) then
        ok = .false.
      else
        write(luntem,'(A)') trim(string)
      endif
    enddo
    close(unit=luntem)
  endif
end subroutine begin_area

program uv_proper_motion
  use gkernel_interfaces
  !------------------------------------------------------------------------
  ! TASK  Apply specified proper motion to an input UV Table
  !
  ! input :
  ! a uv table
  ! output :
  ! a uv table
  !------------------------------------------------------------------------
  character(len=filename_length) :: input,output
  real(8) :: proper(2)
  logical error
  !
  ! Input parameters
  call gildas_open
  call gildas_char('UV_INPUT$',input)
  call gildas_char('UV_OUTPUT$', output)
  call gildas_dble('PROPER$',proper,2)
  call gildas_close
  call sub_uv_proper_motion (input, output, proper, error)
  if (error) call sysexi(fatale)
end program uv_proper_motion
!
subroutine sub_uv_proper_motion (cuvin, cuvou, proper, error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  !      Apply specified proper motion to an input UV Table
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cuvin
  character(len=*), intent(in) :: cuvou
  real(8), intent(in) :: proper(2)
  logical, intent(out) :: error
  !
  ! Local variables
  character(len=*), parameter :: rname='UV_PROPER_MOTION'
  character(len=80)  :: mess
  type (gildas) :: uvin
  type (gildas) :: uvou
  integer :: ier, nblock, ib, nvisi
  !
  ! Simple checks
  error = len_trim(cuvin).eq.0
  if (error) then
    call map_message(seve%e,rname,'No input UV table name')
    return
  endif
  !
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, cuvin, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  !
  ! Here modify the header of the output UV table according
  ! to the desired goal
  !
  call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_copy_header(uvin,uvou,error)
  call sic_parse_file(cuvou,' ','.uvt',uvou%file)
  !
  uvou%gil%astr_words = def_astr_words ! 3
  uvou%gil%mura = proper(1)
  uvou%gil%mudec = proper(2)
  uvou%gil%parallax = 0.0
  !
  ! create the image
  call gdf_create_image(uvou,error)
  if (error) return
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvin%gil%dim(2))
  ! Allocate respective space for each file
  allocate (uvin%r2d(uvin%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',uvin%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Loop over line table - The example assumes the same
  ! number of visibilities in Input and Output, which may not
  ! be true...
  uvin%blc = 0
  uvin%trc = 0
  uvou%blc = 0
  uvou%trc = 0
  do ib = 1,uvin%gil%dim(2),nblock
    write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
    call map_message(seve%i,rname,mess)
    uvin%blc(2) = ib
    uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
    uvou%blc(2) = ib
    uvou%trc(2) = uvin%trc(2)
    call gdf_read_data(uvin,uvin%r2d,error)
    !
    ! Here do the job
    !
    nvisi = uvou%trc(2)-uvou%blc(2)+1
    !
    ! Note that we use UVIN to have the old proper motion...
    call proper_motion (proper,uvin,nvisi,uvin%r2d)
    !
    call gdf_write_data (uvou,uvin%r2d,error)
    if (error) return
  enddo
  !
  ! Finalize the image
  call gdf_close_image(uvin,error)
  call gdf_close_image(uvou,error)
  if (error) return
  !
  call map_message(seve%i,rname,'Successful completion')
  return
end subroutine sub_uv_proper_motion
!
subroutine proper_motion (mu,huv,nvisi,visi)
  use gkernel_interfaces
  use image_def
  real(8), intent(in) :: mu(2)
  type (gildas), intent(in) :: huv
  integer, intent(in) :: nvisi
  real(4), intent(inout) :: visi(huv%gil%dim(1),nvisi)
  !
  integer j2000
  real(8) :: dzero,murad(2),pos(2),freq
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  character(len=11) date
  integer :: i, ix, iu, iv, id
  real(4) :: reel, imag
  real(8) :: uu, vv, phi, sphi, cphi, d, dyear
  logical :: error, uv8
  !
  ! Subtract existing proper motion
  murad(1) = mu(1)-huv%gil%mura
  murad(2) = mu(2)-huv%gil%mudec
  !
  ! Get proper motion in Rad/year
  murad = murad*1d-3*pi/180D0/3600d0 ! Radians / year
  !
  ! Get J2000 in CLASS date
  !
  date = '01-JAN-2000'
  call gag_fromdate(date,j2000,error)
  !
  ! Use the Equinox of the coordinates
  dzero = dble(huv%gil%epoc)-2000.0d0
  !
  ! Get observing frequency
  freq = gdf_uv_frequency(huv)
  !
  uv8 = huv%gil%column_size(code_uvt_u).ne.1
  !
  iu = huv%gil%column_pointer(code_uvt_u)
  iv = huv%gil%column_pointer(code_uvt_v)
  id = huv%gil%column_pointer(code_uvt_date)
  if (uv8) print *,'UV8 ',uv8,iu,iv,id
  !
  do i = 1,nvisi
    if (uv8) then
      call r4tor4 (visi(iu,i),uu,2)   ! Avoid r8tor8 for alignment problems
      call r4tor4 (visi(iv,i),vv,2)
    else
      uu = visi(iu,i)                 ! Implicit Real(4) -> Real(8) conversion
      vv = visi(iv,i)
    endif
    !
    ! Get date in CLASS Days
    d = visi(id,i)
    ! Get time increment in years
    dyear = (d-j2000)/365.25d0 - dzero
    ! Position at this date
    pos = murad*dyear
    !!print *,i,d,j2000,dyear,pos
    !
    ! compute new phase center in wavelengths
    pos = - freq * f_to_k * pos
    phi = pos(1)*uu + pos(2)*vv
    cphi = cos(phi)
    sphi = sin(phi)
    do ix = huv%gil%fcol, huv%gil%lcol, huv%gil%natom
      reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
      imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
      visi(ix,i) = reel
      visi(ix+1,i) = imag
    enddo
  enddo
end subroutine proper_motion

*DECK DX
      SUBROUTINE DX (U, IDMN, I, J, UXXX, UXXXX)
C***BEGIN PROLOGUE  DX
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPELI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (DX-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This program computes second order finite difference
C     approximations to the third and fourth X
C     partial derivatives of U at the (I,J) mesh point.
C
C***SEE ALSO  SEPELI
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    SPLPCM
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  DX
C
      COMMON /SPLPCM/ KSWX       ,KSWY       ,K          ,L          ,
     1                AIT        ,BIT        ,CIT        ,DIT        ,
     2                MIT        ,NIT        ,IS         ,MS         ,
     3                JS         ,NS         ,DLX        ,DLY        ,
     4                TDLX3      ,TDLY3      ,DLX4       ,DLY4
      DIMENSION       U(IDMN,*)
C***FIRST EXECUTABLE STATEMENT  DX
      IF (I.GT.2 .AND. I.LT.(K-1)) GO TO  50
      IF (I .EQ. 1) GO TO  10
      IF (I .EQ. 2) GO TO  30
      IF (I .EQ. K-1) GO TO  60
      IF (I .EQ. K) GO TO  80
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT X=A
C
   10 IF (KSWX .EQ. 1) GO TO  20
      UXXX = (-5.0*U(1,J)+18.0*U(2,J)-24.0*U(3,J)+14.0*U(4,J)-
     1                                               3.0*U(5,J))/(TDLX3)
      UXXXX = (3.0*U(1,J)-14.0*U(2,J)+26.0*U(3,J)-24.0*U(4,J)+
     1                                      11.0*U(5,J)-2.0*U(6,J))/DLX4
      RETURN
C
C     PERIODIC AT X=A
C
   20 UXXX = (-U(K-2,J)+2.0*U(K-1,J)-2.0*U(2,J)+U(3,J))/(TDLX3)
      UXXXX = (U(K-2,J)-4.0*U(K-1,J)+6.0*U(1,J)-4.0*U(2,J)+U(3,J))/DLX4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT X=A+DLX
C
   30 IF (KSWX .EQ. 1) GO TO  40
      UXXX = (-3.0*U(1,J)+10.0*U(2,J)-12.0*U(3,J)+6.0*U(4,J)-U(5,J))/
     1       TDLX3
      UXXXX = (2.0*U(1,J)-9.0*U(2,J)+16.0*U(3,J)-14.0*U(4,J)+6.0*U(5,J)-
     1                                                      U(6,J))/DLX4
      RETURN
C
C     PERIODIC AT X=A+DLX
C
   40 UXXX = (-U(K-1,J)+2.0*U(1,J)-2.0*U(3,J)+U(4,J))/(TDLX3)
      UXXXX = (U(K-1,J)-4.0*U(1,J)+6.0*U(2,J)-4.0*U(3,J)+U(4,J))/DLX4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS ON THE INTERIOR
C
   50 CONTINUE
      UXXX = (-U(I-2,J)+2.0*U(I-1,J)-2.0*U(I+1,J)+U(I+2,J))/TDLX3
      UXXXX = (U(I-2,J)-4.0*U(I-1,J)+6.0*U(I,J)-4.0*U(I+1,J)+U(I+2,J))/
     1        DLX4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT X=B-DLX
C
   60 IF (KSWX .EQ. 1) GO TO  70
      UXXX = (U(K-4,J)-6.0*U(K-3,J)+12.0*U(K-2,J)-10.0*U(K-1,J)+
     1                                                 3.0*U(K,J))/TDLX3
      UXXXX = (-U(K-5,J)+6.0*U(K-4,J)-14.0*U(K-3,J)+16.0*U(K-2,J)-
     1                                     9.0*U(K-1,J)+2.0*U(K,J))/DLX4
      RETURN
C
C     PERIODIC AT X=B-DLX
C
   70 UXXX = (-U(K-3,J)+2.0*U(K-2,J)-2.0*U(1,J)+U(2,J))/TDLX3
      UXXXX = (U(K-3,J)-4.0*U(K-2,J)+6.0*U(K-1,J)-4.0*U(1,J)+U(2,J))/
     1        DLX4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT X=B
C
   80 UXXX = -(3.0*U(K-4,J)-14.0*U(K-3,J)+24.0*U(K-2,J)-18.0*U(K-1,J)+
     1                                                 5.0*U(K,J))/TDLX3
      UXXXX = (-2.0*U(K-5,J)+11.0*U(K-4,J)-24.0*U(K-3,J)+26.0*U(K-2,J)-
     1                                    14.0*U(K-1,J)+3.0*U(K,J))/DLX4
      RETURN
      END
*DECK DX4
      SUBROUTINE DX4 (U, IDMN, I, J, UXXX, UXXXX)
C***BEGIN PROLOGUE  DX4
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPX4
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (DX4-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This program computes second order finite difference
C     approximations to the third and fourth X
C     partial derivatives of U at the (I,J) mesh point.
C
C***SEE ALSO  SEPX4
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    SPL4
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  DX4
C
      COMMON /SPL4/   KSWX       ,KSWY       ,K          ,L          ,
     1                AIT        ,BIT        ,CIT        ,DIT        ,
     2                MIT        ,NIT        ,IS         ,MS         ,
     3                JS         ,NS         ,DLX        ,DLY        ,
     4                TDLX3      ,TDLY3      ,DLX4       ,DLY4
      DIMENSION       U(IDMN,*)
C***FIRST EXECUTABLE STATEMENT  DX4
      IF (I.GT.2 .AND. I.LT.(K-1)) GO TO  50
      IF (I .EQ. 1) GO TO  10
      IF (I .EQ. 2) GO TO  30
      IF (I .EQ. K-1) GO TO  60
      IF (I .EQ. K) GO TO  80
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT X=A
C
   10 IF (KSWX .EQ. 1) GO TO  20
      UXXX = (-5.0*U(1,J)+18.0*U(2,J)-24.0*U(3,J)+14.0*U(4,J)-
     1                                               3.0*U(5,J))/(TDLX3)
      UXXXX = (3.0*U(1,J)-14.0*U(2,J)+26.0*U(3,J)-24.0*U(4,J)+
     1                                      11.0*U(5,J)-2.0*U(6,J))/DLX4
      RETURN
C
C     PERIODIC AT X=A
C
   20 UXXX = (-U(K-2,J)+2.0*U(K-1,J)-2.0*U(2,J)+U(3,J))/(TDLX3)
      UXXXX = (U(K-2,J)-4.0*U(K-1,J)+6.0*U(1,J)-4.0*U(2,J)+U(3,J))/DLX4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT X=A+DLX
C
   30 IF (KSWX .EQ. 1) GO TO  40
      UXXX = (-3.0*U(1,J)+10.0*U(2,J)-12.0*U(3,J)+6.0*U(4,J)-U(5,J))/
     1       TDLX3
      UXXXX = (2.0*U(1,J)-9.0*U(2,J)+16.0*U(3,J)-14.0*U(4,J)+6.0*U(5,J)-
     1                                                      U(6,J))/DLX4
      RETURN
C
C     PERIODIC AT X=A+DLX
C
   40 UXXX = (-U(K-1,J)+2.0*U(1,J)-2.0*U(3,J)+U(4,J))/(TDLX3)
      UXXXX = (U(K-1,J)-4.0*U(1,J)+6.0*U(2,J)-4.0*U(3,J)+U(4,J))/DLX4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS ON THE INTERIOR
C
   50 CONTINUE
      UXXX = (-U(I-2,J)+2.0*U(I-1,J)-2.0*U(I+1,J)+U(I+2,J))/TDLX3
      UXXXX = (U(I-2,J)-4.0*U(I-1,J)+6.0*U(I,J)-4.0*U(I+1,J)+U(I+2,J))/
     1        DLX4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT X=B-DLX
C
   60 IF (KSWX .EQ. 1) GO TO  70
      UXXX = (U(K-4,J)-6.0*U(K-3,J)+12.0*U(K-2,J)-10.0*U(K-1,J)+
     1                                                 3.0*U(K,J))/TDLX3
      UXXXX = (-U(K-5,J)+6.0*U(K-4,J)-14.0*U(K-3,J)+16.0*U(K-2,J)-
     1                                     9.0*U(K-1,J)+2.0*U(K,J))/DLX4
      RETURN
C
C     PERIODIC AT X=B-DLX
C
   70 UXXX = (-U(K-3,J)+2.0*U(K-2,J)-2.0*U(1,J)+U(2,J))/TDLX3
      UXXXX = (U(K-3,J)-4.0*U(K-2,J)+6.0*U(K-1,J)-4.0*U(1,J)+U(2,J))/
     1        DLX4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT X=B
C
   80 UXXX = -(3.0*U(K-4,J)-14.0*U(K-3,J)+24.0*U(K-2,J)-18.0*U(K-1,J)+
     1                                                 5.0*U(K,J))/TDLX3
      UXXXX = (-2.0*U(K-5,J)+11.0*U(K-4,J)-24.0*U(K-3,J)+26.0*U(K-2,J)-
     1                                    14.0*U(K-1,J)+3.0*U(K,J))/DLX4
      RETURN
      END
*DECK DXADD
      SUBROUTINE DXADD (X, IX, Y, IY, Z, IZ, IERROR)
C***BEGIN PROLOGUE  DXADD
C***PURPOSE  To provide double-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      DOUBLE PRECISION (XADD-S, DXADD-D)
C***KEYWORDS  EXTENDED-RANGE DOUBLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     DOUBLE PRECISION X, Y, Z
C     INTEGER IX, IY, IZ
C
C                  FORMS THE EXTENDED-RANGE SUM  (Z,IZ) =
C                  (X,IX) + (Y,IY).  (Z,IZ) IS ADJUSTED
C                  BEFORE RETURNING. THE INPUT OPERANDS
C                  NEED NOT BE IN ADJUSTED FORM, BUT THEIR
C                  PRINCIPAL PARTS MUST SATISFY
C                  RADIX**(-2L).LE.ABS(X).LE.RADIX**(2L),
C                  RADIX**(-2L).LE.ABS(Y).LE.RADIX**(2L).
C
C***SEE ALSO  DXSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DXADJ
C***COMMON BLOCKS    DXBLK2
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXADD
      DOUBLE PRECISION X, Y, Z
      INTEGER IX, IY, IZ
      DOUBLE PRECISION RADIX, RADIXL, RAD2L, DLG10R
      INTEGER L, L2, KMAX
      COMMON /DXBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /DXBLK2/
      DOUBLE PRECISION S, T
C
C   THE CONDITIONS IMPOSED ON L AND KMAX BY THIS SUBROUTINE
C ARE
C     (1) 1 .LT. L .LE. 0.5D0*LOGR(0.5D0*DZERO)
C
C     (2) NRADPL .LT. L .LE. KMAX/6
C
C     (3) KMAX .LE. (2**NBITS - 4*L - 1)/2
C
C THESE CONDITIONS MUST BE MET BY APPROPRIATE CODING
C IN SUBROUTINE DXSET.
C
C***FIRST EXECUTABLE STATEMENT  DXADD
      IERROR=0
      IF (X.NE.0.0D0) GO TO 10
      Z = Y
      IZ = IY
      GO TO 220
   10 IF (Y.NE.0.0D0) GO TO 20
      Z = X
      IZ = IX
      GO TO 220
   20 CONTINUE
      IF (IX.GE.0 .AND. IY.GE.0) GO TO 40
      IF (IX.LT.0 .AND. IY.LT.0) GO TO 40
      IF (ABS(IX).LE.6*L .AND. ABS(IY).LE.6*L) GO TO 40
      IF (IX.GE.0) GO TO 30
      Z = Y
      IZ = IY
      GO TO 220
   30 CONTINUE
      Z = X
      IZ = IX
      GO TO 220
   40 I = IX - IY
      IF (I) 80, 50, 90
   50 IF (ABS(X).GT.1.0D0 .AND. ABS(Y).GT.1.0D0) GO TO 60
      IF (ABS(X).LT.1.0D0 .AND. ABS(Y).LT.1.0D0) GO TO 70
      Z = X + Y
      IZ = IX
      GO TO 220
   60 S = X/RADIXL
      T = Y/RADIXL
      Z = S + T
      IZ = IX + L
      GO TO 220
   70 S = X*RADIXL
      T = Y*RADIXL
      Z = S + T
      IZ = IX - L
      GO TO 220
   80 S = Y
      IS = IY
      T = X
      GO TO 100
   90 S = X
      IS = IX
      T = Y
  100 CONTINUE
C
C  AT THIS POINT, THE ONE OF (X,IX) OR (Y,IY) THAT HAS THE
C LARGER AUXILIARY INDEX IS STORED IN (S,IS). THE PRINCIPAL
C PART OF THE OTHER INPUT IS STORED IN T.
C
      I1 = ABS(I)/L
      I2 = MOD(ABS(I),L)
      IF (ABS(T).GE.RADIXL) GO TO 130
      IF (ABS(T).GE.1.0D0) GO TO 120
      IF (RADIXL*ABS(T).GE.1.0D0) GO TO 110
      J = I1 + 1
      T = T*RADIX**(L-I2)
      GO TO 140
  110 J = I1
      T = T*RADIX**(-I2)
      GO TO 140
  120 J = I1 - 1
      IF (J.LT.0) GO TO 110
      T = T*RADIX**(-I2)/RADIXL
      GO TO 140
  130 J = I1 - 2
      IF (J.LT.0) GO TO 120
      T = T*RADIX**(-I2)/RAD2L
  140 CONTINUE
C
C  AT THIS POINT, SOME OR ALL OF THE DIFFERENCE IN THE
C AUXILIARY INDICES HAS BEEN USED TO EFFECT A LEFT SHIFT
C OF T.  THE SHIFTED VALUE OF T SATISFIES
C
C       RADIX**(-2*L) .LE. ABS(T) .LE. 1.0D0
C
C AND, IF J=0, NO FURTHER SHIFTING REMAINS TO BE DONE.
C
      IF (J.EQ.0) GO TO 190
      IF (ABS(S).GE.RADIXL .OR. J.GT.3) GO TO 150
      IF (ABS(S).GE.1.0D0) GO TO (180, 150, 150), J
      IF (RADIXL*ABS(S).GE.1.0D0) GO TO (180, 170, 150), J
      GO TO (180, 170, 160), J
  150 Z = S
      IZ = IS
      GO TO 220
  160 S = S*RADIXL
  170 S = S*RADIXL
  180 S = S*RADIXL
  190 CONTINUE
C
C   AT THIS POINT, THE REMAINING DIFFERENCE IN THE
C AUXILIARY INDICES HAS BEEN USED TO EFFECT A RIGHT SHIFT
C OF S.  IF THE SHIFTED VALUE OF S WOULD HAVE EXCEEDED
C RADIX**L, THEN (S,IS) IS RETURNED AS THE VALUE OF THE
C SUM.
C
      IF (ABS(S).GT.1.0D0 .AND. ABS(T).GT.1.0D0) GO TO 200
      IF (ABS(S).LT.1.0D0 .AND. ABS(T).LT.1.0D0) GO TO 210
      Z = S + T
      IZ = IS - J*L
      GO TO 220
  200 S = S/RADIXL
      T = T/RADIXL
      Z = S + T
      IZ = IS - J*L + L
      GO TO 220
  210 S = S*RADIXL
      T = T*RADIXL
      Z = S + T
      IZ = IS - J*L - L
  220 CALL DXADJ(Z, IZ,IERROR)
      RETURN
      END
*DECK DXADJ
      SUBROUTINE DXADJ (X, IX, IERROR)
C***BEGIN PROLOGUE  DXADJ
C***PURPOSE  To provide double-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      DOUBLE PRECISION (XADJ-S, DXADJ-D)
C***KEYWORDS  EXTENDED-RANGE DOUBLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     DOUBLE PRECISION X
C     INTEGER IX
C
C                  TRANSFORMS (X,IX) SO THAT
C                  RADIX**(-L) .LE. ABS(X) .LT. RADIX**L.
C                  ON MOST COMPUTERS THIS TRANSFORMATION DOES
C                  NOT CHANGE THE MANTISSA OF X PROVIDED RADIX IS
C                  THE NUMBER BASE OF DOUBLE-PRECISION ARITHMETIC.
C
C***SEE ALSO  DXSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERMSG
C***COMMON BLOCKS    DXBLK2
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXADJ
      DOUBLE PRECISION X
      INTEGER IX
      DOUBLE PRECISION RADIX, RADIXL, RAD2L, DLG10R
      INTEGER L, L2, KMAX
      COMMON /DXBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /DXBLK2/
C
C   THE CONDITION IMPOSED ON L AND KMAX BY THIS SUBROUTINE
C IS
C     2*L .LE. KMAX
C
C THIS CONDITION MUST BE MET BY APPROPRIATE CODING
C IN SUBROUTINE DXSET.
C
C***FIRST EXECUTABLE STATEMENT  DXADJ
      IERROR=0
      IF (X.EQ.0.0D0) GO TO 50
      IF (ABS(X).GE.1.0D0) GO TO 20
      IF (RADIXL*ABS(X).GE.1.0D0) GO TO 60
      X = X*RAD2L
      IF (IX.LT.0) GO TO 10
      IX = IX - L2
      GO TO 70
   10 IF (IX.LT.-KMAX+L2) GO TO 40
      IX = IX - L2
      GO TO 70
   20 IF (ABS(X).LT.RADIXL) GO TO 60
      X = X/RAD2L
      IF (IX.GT.0) GO TO 30
      IX = IX + L2
      GO TO 70
   30 IF (IX.GT.KMAX-L2) GO TO 40
      IX = IX + L2
      GO TO 70
   40 CALL XERMSG ('SLATEC', 'DXADJ', 'overflow in auxiliary index',
     +             207, 1)
      IERROR=207
      RETURN
   50 IX = 0
   60 IF (ABS(IX).GT.KMAX) GO TO 40
   70 RETURN
      END
*DECK DXC210
      SUBROUTINE DXC210 (K, Z, J, IERROR)
C***BEGIN PROLOGUE  DXC210
C***PURPOSE  To provide double-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      DOUBLE PRECISION (XC210-S, DXC210-D)
C***KEYWORDS  EXTENDED-RANGE DOUBLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     INTEGER K, J
C     DOUBLE PRECISION Z
C
C                  GIVEN K THIS SUBROUTINE COMPUTES J AND Z
C                  SUCH THAT  RADIX**K = Z*10**J, WHERE Z IS IN
C                  THE RANGE 1/10 .LE. Z .LT. 1.
C                  THE VALUE OF Z WILL BE ACCURATE TO FULL
C                  DOUBLE-PRECISION PROVIDED THE NUMBER
C                  OF DECIMAL PLACES IN THE LARGEST
C                  INTEGER PLUS THE NUMBER OF DECIMAL
C                  PLACES CARRIED IN DOUBLE-PRECISION DOES NOT
C                  EXCEED 60. DXC210 IS CALLED BY SUBROUTINE
C                  DXCON WHEN NECESSARY. THE USER SHOULD
C                  NEVER NEED TO CALL DXC210 DIRECTLY.
C
C***SEE ALSO  DXSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERMSG
C***COMMON BLOCKS    DXBLK3
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXC210
      DOUBLE PRECISION Z
      INTEGER K, J
      INTEGER NLG102, MLG102, LG102
      COMMON /DXBLK3/ NLG102, MLG102, LG102(21)
      SAVE /DXBLK3/
C
C   THE CONDITIONS IMPOSED ON NLG102, MLG102, AND LG102 BY
C THIS SUBROUTINE ARE
C
C     (1) NLG102 .GE. 2
C
C     (2) MLG102 .GE. 1
C
C     (3) 2*MLG102*(MLG102 - 1) .LE. 2**NBITS - 1
C
C THESE CONDITIONS MUST BE MET BY APPROPRIATE CODING
C IN SUBROUTINE DXSET.
C
C***FIRST EXECUTABLE STATEMENT  DXC210
      IERROR=0
      IF (K.EQ.0) GO TO 70
      M = MLG102
      KA = ABS(K)
      KA1 = KA/M
      KA2 = MOD(KA,M)
      IF (KA1.GE.M) GO TO 60
      NM1 = NLG102 - 1
      NP1 = NLG102 + 1
      IT = KA2*LG102(NP1)
      IC = IT/M
      ID = MOD(IT,M)
      Z = ID
      IF (KA1.GT.0) GO TO 20
      DO 10 II=1,NM1
        I = NP1 - II
        IT = KA2*LG102(I) + IC
        IC = IT/M
        ID = MOD(IT,M)
        Z = Z/M + ID
   10 CONTINUE
      JA = KA*LG102(1) + IC
      GO TO 40
   20 CONTINUE
      DO 30 II=1,NM1
        I = NP1 - II
        IT = KA2*LG102(I) + KA1*LG102(I+1) + IC
        IC = IT/M
        ID = MOD(IT,M)
        Z = Z/M + ID
   30 CONTINUE
      JA = KA*LG102(1) + KA1*LG102(2) + IC
   40 CONTINUE
      Z = Z/M
      IF (K.GT.0) GO TO 50
      J = -JA
      Z = 10.0D0**(-Z)
      GO TO 80
   50 CONTINUE
      J = JA + 1
      Z = 10.0D0**(Z-1.0D0)
      GO TO 80
   60 CONTINUE
C   THIS ERROR OCCURS IF K EXCEEDS  MLG102**2 - 1  IN MAGNITUDE.
C
      CALL XERMSG ('SLATEC', 'DXC210', 'K too large', 208, 1)
      IERROR=208
      RETURN
   70 CONTINUE
      J = 0
      Z = 1.0D0
   80 RETURN
      END
*DECK DXCON
      SUBROUTINE DXCON (X, IX, IERROR)
C***BEGIN PROLOGUE  DXCON
C***PURPOSE  To provide double-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      DOUBLE PRECISION (XCON-S, DXCON-D)
C***KEYWORDS  EXTENDED-RANGE DOUBLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     DOUBLE PRECISION X
C     INTEGER IX
C
C                  CONVERTS (X,IX) = X*RADIX**IX
C                  TO DECIMAL FORM IN PREPARATION FOR
C                  PRINTING, SO THAT (X,IX) = X*10**IX
C                  WHERE 1/10 .LE. ABS(X) .LT. 1
C                  IS RETURNED, EXCEPT THAT IF
C                  (ABS(X),IX) IS BETWEEN RADIX**(-2L)
C                  AND RADIX**(2L) THEN THE REDUCED
C                  FORM WITH IX = 0 IS RETURNED.
C
C***SEE ALSO  DXSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DXADJ, DXC210, DXRED
C***COMMON BLOCKS    DXBLK2
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXCON
      DOUBLE PRECISION X
      INTEGER IX
C
C   THE CONDITIONS IMPOSED ON L AND KMAX BY THIS SUBROUTINE
C ARE
C    (1) 4 .LE. L .LE. 2**NBITS - 1 - KMAX
C
C    (2) KMAX .LE. ((2**NBITS)-2)/LOG10R - L
C
C THESE CONDITIONS MUST BE MET BY APPROPRIATE CODING
C IN SUBROUTINE DXSET.
C
      DOUBLE PRECISION RADIX, RADIXL, RAD2L, DLG10R
      INTEGER L, L2, KMAX
      COMMON /DXBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /DXBLK2/, ISPACE
C
      DOUBLE PRECISION A, B, Z
C
      DATA ISPACE /1/
C   THE PARAMETER ISPACE IS THE INCREMENT USED IN FORM-
C ING THE AUXILIARY INDEX OF THE DECIMAL EXTENDED-RANGE
C FORM. THE RETURNED VALUE OF IX WILL BE AN INTEGER MULT-
C IPLE OF ISPACE. ISPACE MUST SATISFY 1 .LE. ISPACE .LE.
C L/2. IF A VALUE GREATER THAN 1 IS TAKEN, THE RETURNED
C VALUE OF X WILL SATISFY 10**(-ISPACE) .LE. ABS(X) .LE. 1
C WHEN (ABS(X),IX) .LT. RADIX**(-2L), AND 1/10 .LE. ABS(X)
C .LT. 10**(ISPACE-1) WHEN (ABS(X),IX) .GT. RADIX**(2L).
C
C***FIRST EXECUTABLE STATEMENT  DXCON
      IERROR=0
      CALL DXRED(X, IX,IERROR)
      IF (IERROR.NE.0) RETURN
      IF (IX.EQ.0) GO TO 150
      CALL DXADJ(X, IX,IERROR)
      IF (IERROR.NE.0) RETURN
C
C CASE 1 IS WHEN (X,IX) IS LESS THAN RADIX**(-2L) IN MAGNITUDE,
C CASE 2 IS WHEN (X,IX) IS GREATER THAN RADIX**(2L) IN MAGNITUDE.
      ITEMP = 1
      ICASE = (3+SIGN(ITEMP,IX))/2
      GO TO (10, 20), ICASE
   10 IF (ABS(X).LT.1.0D0) GO TO 30
      X = X/RADIXL
      IX = IX + L
      GO TO 30
   20 IF (ABS(X).GE.1.0D0) GO TO 30
      X = X*RADIXL
      IX = IX - L
   30 CONTINUE
C
C AT THIS POINT, RADIX**(-L) .LE. ABS(X) .LT. 1.0D0     IN CASE 1,
C                      1.0D0 .LE. ABS(X) .LT. RADIX**L  IN CASE 2.
      I = LOG10(ABS(X))/DLG10R
      A = RADIX**I
      GO TO (40, 60), ICASE
   40 IF (A.LE.RADIX*ABS(X)) GO TO 50
      I = I - 1
      A = A/RADIX
      GO TO 40
   50 IF (ABS(X).LT.A) GO TO 80
      I = I + 1
      A = A*RADIX
      GO TO 50
   60 IF (A.LE.ABS(X)) GO TO 70
      I = I - 1
      A = A/RADIX
      GO TO 60
   70 IF (ABS(X).LT.RADIX*A) GO TO 80
      I = I + 1
      A = A*RADIX
      GO TO 70
   80 CONTINUE
C
C AT THIS POINT I IS SUCH THAT
C RADIX**(I-1) .LE. ABS(X) .LT. RADIX**I      IN CASE 1,
C     RADIX**I .LE. ABS(X) .LT. RADIX**(I+1)  IN CASE 2.
      ITEMP = ISPACE/DLG10R
      A = RADIX**ITEMP
      B = 10.0D0**ISPACE
   90 IF (A.LE.B) GO TO 100
      ITEMP = ITEMP - 1
      A = A/RADIX
      GO TO 90
  100 IF (B.LT.A*RADIX) GO TO 110
      ITEMP = ITEMP + 1
      A = A*RADIX
      GO TO 100
  110 CONTINUE
C
C AT THIS POINT ITEMP IS SUCH THAT
C RADIX**ITEMP .LE. 10**ISPACE .LT. RADIX**(ITEMP+1).
      IF (ITEMP.GT.0) GO TO 120
C ITEMP = 0 IF, AND ONLY IF, ISPACE = 1 AND RADIX = 16.0D0
      X = X*RADIX**(-I)
      IX = IX + I
      CALL DXC210(IX, Z, J,IERROR)
      IF (IERROR.NE.0) RETURN
      X = X*Z
      IX = J
      GO TO (130, 140), ICASE
  120 CONTINUE
      I1 = I/ITEMP
      X = X*RADIX**(-I1*ITEMP)
      IX = IX + I1*ITEMP
C
C AT THIS POINT,
C RADIX**(-ITEMP) .LE. ABS(X) .LT. 1.0D0        IN CASE 1,
C           1.0D0 .LE. ABS(X) .LT. RADIX**ITEMP IN CASE 2.
      CALL DXC210(IX, Z, J,IERROR)
      IF (IERROR.NE.0) RETURN
      J1 = J/ISPACE
      J2 = J - J1*ISPACE
      X = X*Z*10.0D0**J2
      IX = J1*ISPACE
C
C AT THIS POINT,
C  10.0D0**(-2*ISPACE) .LE. ABS(X) .LT. 1.0D0                IN CASE 1,
C           10.0D0**-1 .LE. ABS(X) .LT. 10.0D0**(2*ISPACE-1) IN CASE 2.
      GO TO (130, 140), ICASE
  130 IF (B*ABS(X).GE.1.0D0) GO TO 150
      X = X*B
      IX = IX - ISPACE
      GO TO 130
  140 IF (10.0D0*ABS(X).LT.B) GO TO 150
      X = X/B
      IX = IX + ISPACE
      GO TO 140
  150 RETURN
      END
*DECK DXLCAL
      SUBROUTINE DXLCAL (N, LGMR, X, XL, ZL, HES, MAXLP1, Q, V, R0NRM,
     +   WK, SZ, JSCAL, JPRE, MSOLVE, NMSL, RPAR, IPAR, NELT, IA, JA, A,
     +   ISYM)
C***BEGIN PROLOGUE  DXLCAL
C***SUBSIDIARY
C***PURPOSE  Internal routine for DGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      DOUBLE PRECISION (SXLCAL-S, DXLCAL-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This  routine computes the solution  XL,  the current DGMRES
C        iterate, given the  V(I)'s and  the  QR factorization of the
C        Hessenberg  matrix HES.   This routine  is  only called when
C        ITOL=11.
C
C *Usage:
C      INTEGER N, LGMR, MAXLP1, JSCAL, JPRE, NMSL, IPAR(USER DEFINED)
C      INTEGER NELT, IA(NELT), JA(NELT), ISYM
C      DOUBLE PRECISION X(N), XL(N), ZL(N), HES(MAXLP1,MAXL), Q(2*MAXL),
C     $                 V(N,MAXLP1), R0NRM, WK(N), SZ(N),
C     $                 RPAR(USER DEFINED), A(NELT)
C      EXTERNAL MSOLVE
C
C      CALL DXLCAL(N, LGMR, X, XL, ZL, HES, MAXLP1, Q, V, R0NRM,
C     $     WK, SZ, JSCAL, JPRE, MSOLVE, NMSL, RPAR, IPAR,
C     $     NELT, IA, JA, A, ISYM)
C
C *Arguments:
C N      :IN       Integer
C         The order of the matrix A, and the lengths
C         of the vectors SR, SZ, R0 and Z.
C LGMR   :IN       Integer
C         The number of iterations performed and
C         the current order of the upper Hessenberg
C         matrix HES.
C X      :IN       Double Precision X(N)
C         The current approximate solution as of the last restart.
C XL     :OUT      Double Precision XL(N)
C         An array of length N used to hold the approximate
C         solution X(L).
C         Warning: XL and ZL are the same array in the calling routine.
C ZL     :IN       Double Precision ZL(N)
C         An array of length N used to hold the approximate
C         solution Z(L).
C HES    :IN       Double Precision HES(MAXLP1,MAXL)
C         The upper triangular factor of the QR decomposition
C         of the (LGMR+1) by LGMR upper Hessenberg matrix whose
C         entries are the scaled inner-products of A*V(*,i) and V(*,k).
C MAXLP1 :IN       Integer
C         MAXLP1 = MAXL + 1, used for dynamic dimensioning of HES.
C         MAXL is the maximum allowable order of the matrix HES.
C Q      :IN       Double Precision Q(2*MAXL)
C         A double precision array of length 2*MAXL containing the
C         components of the Givens rotations used in the QR
C         decomposition of HES.  It is loaded in DHEQR.
C V      :IN       Double Precision V(N,MAXLP1)
C         The N by(LGMR+1) array containing the LGMR
C         orthogonal vectors V(*,1) to V(*,LGMR).
C R0NRM  :IN       Double Precision
C         The scaled norm of the initial residual for the
C         current call to DPIGMR.
C WK     :IN       Double Precision WK(N)
C         A double precision work array of length N.
C SZ     :IN       Double Precision SZ(N)
C         A vector of length N containing the non-zero
C         elements of the diagonal scaling matrix for Z.
C JSCAL  :IN       Integer
C         A flag indicating whether arrays SR and SZ are used.
C         JSCAL=0 means SR and SZ are not used and the
C                 algorithm will perform as if all
C                 SR(i) = 1 and SZ(i) = 1.
C         JSCAL=1 means only SZ is used, and the algorithm
C                 performs as if all SR(i) = 1.
C         JSCAL=2 means only SR is used, and the algorithm
C                 performs as if all SZ(i) = 1.
C         JSCAL=3 means both SR and SZ are used.
C JPRE   :IN       Integer
C         The preconditioner type flag.
C MSOLVE :EXT      External.
C         Name of the routine which solves a linear system Mz = r for
C         z given r with the preconditioning matrix M (M is supplied via
C         RPAR and IPAR arrays.  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RPAR, IPAR)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as below.  RPAR is a double precision array
C         that can be used to pass necessary preconditioning information
C         and/or workspace to MSOLVE.  IPAR is an integer work array
C         for the same purpose as RPAR.
C NMSL   :IN       Integer
C         The number of calls to MSOLVE.
C RPAR   :IN       Double Precision RPAR(USER DEFINED)
C         Double Precision workspace passed directly to the MSOLVE
C         routine.
C IPAR   :IN       Integer IPAR(USER DEFINED)
C         Integer workspace passed directly to the MSOLVE routine.
C NELT   :IN       Integer
C         The length of arrays IA, JA and A.
C IA     :IN       Integer IA(NELT)
C         An integer array of length NELT containing matrix data.
C         It is passed directly to the MATVEC and MSOLVE routines.
C JA     :IN       Integer JA(NELT)
C         An integer array of length NELT containing matrix data.
C         It is passed directly to the MATVEC and MSOLVE routines.
C A      :IN       Double Precision A(NELT)
C         A double precision array of length NELT containing matrix
C         data.
C         It is passed directly to the MATVEC and MSOLVE routines.
C ISYM   :IN       Integer
C         A flag to indicate symmetric matrix storage.
C         If ISYM=0, all non-zero entries of the matrix are
C         stored.  If ISYM=1, the matrix is symmetric and
C         only the upper or lower triangular part is stored.
C
C***SEE ALSO  DGMRES
C***ROUTINES CALLED  DAXPY, DCOPY, DHELS
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MSOLVE from ROUTINES CALLED list.  (FNF)
C   910506  Made subsidiary to DGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  DXLCAL
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      DOUBLE PRECISION R0NRM
      INTEGER ISYM, JPRE, JSCAL, LGMR, MAXLP1, N, NELT, NMSL
C     .. Array Arguments ..
      DOUBLE PRECISION A(NELT), HES(MAXLP1,*), Q(*), RPAR(*), SZ(*),
     +                 V(N,*), WK(N), X(N), XL(N), ZL(N)
      INTEGER IA(NELT), IPAR(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MSOLVE
C     .. Local Scalars ..
      INTEGER I, K, LL, LLP1
C     .. External Subroutines ..
      EXTERNAL DAXPY, DCOPY, DHELS
C***FIRST EXECUTABLE STATEMENT  DXLCAL
      LL = LGMR
      LLP1 = LL + 1
      DO 10 K = 1,LLP1
         WK(K) = 0
 10   CONTINUE
      WK(1) = R0NRM
      CALL DHELS(HES, MAXLP1, LL, Q, WK)
      DO 20 K = 1,N
         ZL(K) = 0
 20   CONTINUE
      DO 30 I = 1,LL
         CALL DAXPY(N, WK(I), V(1,I), 1, ZL, 1)
 30   CONTINUE
      IF ((JSCAL .EQ. 1) .OR.(JSCAL .EQ. 3)) THEN
         DO 40 K = 1,N
            ZL(K) = ZL(K)/SZ(K)
 40      CONTINUE
      ENDIF
      IF (JPRE .GT. 0) THEN
         CALL DCOPY(N, ZL, 1, WK, 1)
         CALL MSOLVE(N, WK, ZL, NELT, IA, JA, A, ISYM, RPAR, IPAR)
         NMSL = NMSL + 1
      ENDIF
C         calculate XL from X and ZL.
      DO 50 K = 1,N
         XL(K) = X(K) + ZL(K)
 50   CONTINUE
      RETURN
C------------- LAST LINE OF DXLCAL FOLLOWS ----------------------------
      END
*DECK DXLEGF
      SUBROUTINE DXLEGF (DNU1, NUDIFF, MU1, MU2, THETA, ID, PQA, IPQA,
     1   IERROR)
C***BEGIN PROLOGUE  DXLEGF
C***PURPOSE  Compute normalized Legendre polynomials and associated
C            Legendre functions.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      DOUBLE PRECISION (XLEGF-S, DXLEGF-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C
C   DXLEGF: Extended-range Double-precision Legendre Functions
C
C   A feature of the DXLEGF subroutine for Legendre functions is
C the use of extended-range arithmetic, a software extension of
C ordinary floating-point arithmetic that greatly increases the
C exponent range of the representable numbers. This avoids the
C need for scaling the solutions to lie within the exponent range
C of the most restrictive manufacturer's hardware. The increased
C exponent range is achieved by allocating an integer storage
C location together with each floating-point storage location.
C
C   The interpretation of the pair (X,I) where X is floating-point
C and I is integer is X*(IR**I) where IR is the internal radix of
C the computer arithmetic.
C
C   This subroutine computes one of the following vectors:
C
C 1. Legendre function of the first kind of negative order, either
C    a. P(-MU1,NU,X), P(-MU1-1,NU,X), ..., P(-MU2,NU,X) or
C    b. P(-MU,NU1,X), P(-MU,NU1+1,X), ..., P(-MU,NU2,X)
C 2. Legendre function of the second kind, either
C    a. Q(MU1,NU,X), Q(MU1+1,NU,X), ..., Q(MU2,NU,X) or
C    b. Q(MU,NU1,X), Q(MU,NU1+1,X), ..., Q(MU,NU2,X)
C 3. Legendre function of the first kind of positive order, either
C    a. P(MU1,NU,X), P(MU1+1,NU,X), ..., P(MU2,NU,X) or
C    b. P(MU,NU1,X), P(MU,NU1+1,X), ..., P(MU,NU2,X)
C 4. Normalized Legendre polynomials, either
C    a. PN(MU1,NU,X), PN(MU1+1,NU,X), ..., PN(MU2,NU,X) or
C    b. PN(MU,NU1,X), PN(MU,NU1+1,X), ..., PN(MU,NU2,X)
C
C where X = COS(THETA).
C
C   The input values to DXLEGF are DNU1, NUDIFF, MU1, MU2, THETA,
C and ID. These must satisfy
C
C    DNU1 is DOUBLE PRECISION and greater than or equal to -0.5;
C    NUDIFF is INTEGER and non-negative;
C    MU1 is INTEGER and non-negative;
C    MU2 is INTEGER and greater than or equal to MU1;
C    THETA is DOUBLE PRECISION and in the half-open interval (0,PI/2];
C    ID is INTEGER and equal to 1, 2, 3 or 4;
C
C and  additionally either NUDIFF = 0 or MU2 = MU1.
C
C   If ID=1 and NUDIFF=0, a vector of type 1a above is computed
C with NU=DNU1.
C
C   If ID=1 and MU1=MU2, a vector of type 1b above is computed
C with NU1=DNU1, NU2=DNU1+NUDIFF and MU=MU1.
C
C   If ID=2 and NUDIFF=0, a vector of type 2a above is computed
C with NU=DNU1.
C
C   If ID=2 and MU1=MU2, a vector of type 2b above is computed
C with NU1=DNU1, NU2=DNU1+NUDIFF and MU=MU1.
C
C   If ID=3 and NUDIFF=0, a vector of type 3a above is computed
C with NU=DNU1.
C
C   If ID=3 and MU1=MU2, a vector of type 3b above is computed
C with NU1=DNU1, NU2=DNU1+NUDIFF and MU=MU1.
C
C   If ID=4 and NUDIFF=0, a vector of type 4a above is computed
C with NU=DNU1.
C
C   If ID=4 and MU1=MU2, a vector of type 4b above is computed
C with NU1=DNU1, NU2=DNU1+NUDIFF and MU=MU1.
C
C   In each case the vector of computed Legendre function values
C is returned in the extended-range vector (PQA(I),IPQA(I)). The
C length of this vector is either MU2-MU1+1 or NUDIFF+1.
C
C   Where possible, DXLEGF returns IPQA(I) as zero. In this case the
C value of the Legendre function is contained entirely in PQA(I),
C so it can be used in subsequent computations without further
C consideration of extended-range arithmetic. If IPQA(I) is nonzero,
C then the value of the Legendre function is not representable in
C floating-point because of underflow or overflow. The program that
C calls DXLEGF must test IPQA(I) to ensure correct usage.
C
C   IERROR is an error indicator. If no errors are detected, IERROR=0
C when control returns to the calling routine. If an error is detected,
C IERROR is returned as nonzero. The calling routine must check the
C value of IERROR.
C
C   If IERROR=210 or 211, invalid input was provided to DXLEGF.
C   If IERROR=201,202,203, or 204, invalid input was provided to DXSET.
C   If IERROR=205 or 206, an internal consistency error occurred in
C DXSET (probably due to a software malfunction in the library routine
C I1MACH).
C   If IERROR=207, an overflow or underflow of an extended-range number
C was detected in DXADJ.
C   If IERROR=208, an overflow or underflow of an extended-range number
C was detected in DXC210.
C
C***SEE ALSO  DXSET
C***REFERENCES  Olver and Smith, Associated Legendre Functions on the
C                 Cut, J Comp Phys, v 51, n 3, Sept 1983, pp 502--518.
C               Smith, Olver and Lozier, Extended-Range Arithmetic and
C                 Normalized Legendre Polynomials, ACM Trans on Math
C                 Softw, v 7, n 1, March 1981, pp 93--105.
C***ROUTINES CALLED  DXPMU, DXPMUP, DXPNRM, DXPQNU, DXQMU, DXQNU, DXRED,
C                    DXSET, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXLEGF
      DOUBLE PRECISION PQA,DNU1,DNU2,SX,THETA,X,PI2
      DIMENSION PQA(*),IPQA(*)
C
C***FIRST EXECUTABLE STATEMENT  DXLEGF
      IERROR=0
      CALL DXSET (0, 0, 0.0D0, 0,IERROR)
      IF (IERROR.NE.0) RETURN
      PI2=2.D0*ATAN(1.D0)
C
C        ZERO OUTPUT ARRAYS
C
      L=(MU2-MU1)+NUDIFF+1
      DO 290 I=1,L
      PQA(I)=0.D0
  290 IPQA(I)=0
C
C        CHECK FOR VALID INPUT VALUES
C
      IF(NUDIFF.LT.0) GO TO 400
      IF(DNU1.LT.-.5D0) GO TO 400
      IF(MU2.LT.MU1) GO TO 400
      IF(MU1.LT.0) GO TO 400
      IF(THETA.LE.0.D0.OR.THETA.GT.PI2) GO TO 420
      IF(ID.LT.1.OR.ID.GT.4) GO TO 400
      IF((MU1.NE.MU2).AND.(NUDIFF.GT.0)) GO TO 400
C
C        IF DNU1 IS NOT AN INTEGER, NORMALIZED P(MU,DNU,X)
C        CANNOT BE CALCULATED.  IF DNU1 IS AN INTEGER AND
C        MU1.GT.DNU2 THEN ALL VALUES OF P(+MU,DNU,X) AND
C        NORMALIZED P(MU,NU,X) WILL BE ZERO.
C
      DNU2=DNU1+NUDIFF
      IF((ID.EQ.3).AND.(MOD(DNU1,1.D0).NE.0.D0)) GO TO 295
      IF((ID.EQ.4).AND.(MOD(DNU1,1.D0).NE.0.D0)) GO TO 400
      IF((ID.EQ.3.OR.ID.EQ.4).AND.MU1.GT.DNU2) RETURN
  295 CONTINUE
C
      X=COS(THETA)
      SX=1.D0/SIN(THETA)
      IF(ID.EQ.2) GO TO 300
      IF(MU2-MU1.LE.0) GO TO 360
C
C        FIXED NU, VARIABLE MU
C        CALL DXPMU TO CALCULATE P(-MU1,NU,X),....,P(-MU2,NU,X)
C
      CALL DXPMU(DNU1,DNU2,MU1,MU2,THETA,X,SX,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 380
C
  300 IF(MU2.EQ.MU1) GO TO 320
C
C        FIXED NU, VARIABLE MU
C        CALL DXQMU TO CALCULATE Q(MU1,NU,X),....,Q(MU2,NU,X)
C
      CALL DXQMU(DNU1,DNU2,MU1,MU2,THETA,X,SX,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 390
C
C        FIXED MU, VARIABLE NU
C        CALL DXQNU TO CALCULATE Q(MU,DNU1,X),....,Q(MU,DNU2,X)
C
  320 CALL DXQNU(DNU1,DNU2,MU1,THETA,X,SX,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 390
C
C        FIXED MU, VARIABLE NU
C        CALL DXPQNU TO CALCULATE P(-MU,DNU1,X),....,P(-MU,DNU2,X)
C
  360 CALL DXPQNU(DNU1,DNU2,MU1,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
C
C        IF ID = 3, TRANSFORM P(-MU,NU,X) VECTOR INTO
C        P(MU,NU,X) VECTOR.
C
  380 IF(ID.EQ.3) CALL DXPMUP(DNU1,DNU2,MU1,MU2,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
C
C        IF ID = 4, TRANSFORM P(-MU,NU,X) VECTOR INTO
C        NORMALIZED P(MU,NU,X) VECTOR.
C
      IF(ID.EQ.4) CALL DXPNRM(DNU1,DNU2,MU1,MU2,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
C
C        PLACE RESULTS IN REDUCED FORM IF POSSIBLE
C        AND RETURN TO MAIN PROGRAM.
C
  390 DO 395 I=1,L
      CALL DXRED(PQA(I),IPQA(I),IERROR)
      IF (IERROR.NE.0) RETURN
  395 CONTINUE
      RETURN
C
C        *****     ERROR TERMINATION     *****
C
  400 CALL XERMSG ('SLATEC', 'DXLEGF',
     +             'DNU1, NUDIFF, MU1, MU2, or ID not valid', 210, 1)
      IERROR=210
      RETURN
  420 CALL XERMSG ('SLATEC', 'DXLEGF', 'THETA out of range', 211, 1)
      IERROR=211
      RETURN
      END
*DECK DXNRMP
      SUBROUTINE DXNRMP (NU, MU1, MU2, DARG, MODE, DPN, IPN, ISIG,
     1   IERROR)
C***BEGIN PROLOGUE  DXNRMP
C***PURPOSE  Compute normalized Legendre polynomials.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      DOUBLE PRECISION (XNRMP-S, DXNRMP-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C
C        SUBROUTINE TO CALCULATE NORMALIZED LEGENDRE POLYNOMIALS
C        (XNRMP is single-precision version)
C        DXNRMP calculates normalized Legendre polynomials of varying
C        order and fixed argument and degree. The order MU and degree
C        NU are non-negative integers and the argument is real. Because
C        the algorithm requires the use of numbers outside the normal
C        machine range, this subroutine employs a special arithmetic
C        called extended-range arithmetic. See J.M. Smith, F.W.J. Olver,
C        and D.W. Lozier, Extended-Range Arithmetic and Normalized
C        Legendre Polynomials, ACM Transactions on Mathematical Soft-
C        ware, 93-105, March 1981, for a complete description of the
C        algorithm and special arithmetic. Also see program comments
C        in DXSET.
C
C        The normalized Legendre polynomials are multiples of the
C        associated Legendre polynomials of the first kind where the
C        normalizing coefficients are chosen so as to make the integral
C        from -1 to 1 of the square of each function equal to 1. See
C        E. Jahnke, F. Emde and F. Losch, Tables of Higher Functions,
C        McGraw-Hill, New York, 1960, p. 121.
C
C        The input values to DXNRMP are NU, MU1, MU2, DARG, and MODE.
C        These must satisfy
C          1. NU .GE. 0 specifies the degree of the normalized Legendre
C             polynomial that is wanted.
C          2. MU1 .GE. 0 specifies the lowest-order normalized Legendre
C             polynomial that is wanted.
C          3. MU2 .GE. MU1 specifies the highest-order normalized Leg-
C             endre polynomial that is wanted.
C         4a. MODE = 1 and -1.0D0 .LE. DARG .LE. 1.0D0 specifies that
C             Normalized Legendre(NU, MU, DARG) is wanted for MU = MU1,
C             MU1 + 1, ..., MU2.
C         4b. MODE = 2 and -3.14159... .LT. DARG .LT. 3.14159... spec-
C             ifies that Normalized Legendre(NU, MU, COS(DARG)) is
C             wanted for MU = MU1, MU1 + 1, ..., MU2.
C
C        The output of DXNRMP consists of the two vectors DPN and IPN
C        and the error estimate ISIG. The computed values are stored as
C        extended-range numbers such that
C             (DPN(1),IPN(1))=NORMALIZED LEGENDRE(NU,MU1,DX)
C             (DPN(2),IPN(2))=NORMALIZED LEGENDRE(NU,MU1+1,DX)
C                .
C                .
C             (DPN(K),IPN(K))=NORMALIZED LEGENDRE(NU,MU2,DX)
C        where K = MU2 - MU1 + 1 and DX = DARG or COS(DARG) according
C        to whether MODE = 1 or 2. Finally, ISIG is an estimate of the
C        number of decimal digits lost through rounding errors in the
C        computation. For example if DARG is accurate to 12 significant
C        decimals, then the computed function values are accurate to
C        12 - ISIG significant decimals (except in neighborhoods of
C        zeros).
C
C        The interpretation of (DPN(I),IPN(I)) is DPN(I)*(IR**IPN(I))
C        where IR is the internal radix of the computer arithmetic. When
C        IPN(I) = 0 the value of the normalized Legendre polynomial is
C        contained entirely in DPN(I) and subsequent double-precision
C        computations can be performed without further consideration of
C        extended-range arithmetic. However, if IPN(I) .NE. 0 the corre-
C        sponding value of the normalized Legendre polynomial cannot be
C        represented in double-precision because of overflow or under-
C        flow. THE USER MUST TEST IPN(I) IN HIS/HER PROGRAM. In the case
C        that IPN(I) is nonzero, the user could rewrite his/her program
C        to use extended range arithmetic.
C
C
C
C        The interpretation of (DPN(I),IPN(I)) can be changed to
C        DPN(I)*(10**IPN(I)) by calling the extended-range subroutine
C        DXCON. This should be done before printing the computed values.
C        As an example of usage, the Fortran coding
C              J = K
C              DO 20 I = 1, K
C              CALL DXCON(DPN(I), IPN(I),IERROR)
C              IF (IERROR.NE.0) RETURN
C              PRINT 10, DPN(I), IPN(I)
C           10 FORMAT(1X, D30.18 , I15)
C              IF ((IPN(I) .EQ. 0) .OR. (J .LT. K)) GO TO 20
C              J = I - 1
C           20 CONTINUE
C        will print all computed values and determine the largest J
C        such that IPN(1) = IPN(2) = ... = IPN(J) = 0. Because of the
C        change of representation caused by calling DXCON, (DPN(I),
C        IPN(I)) for I = J+1, J+2, ... cannot be used in subsequent
C        extended-range computations.
C
C        IERROR is an error indicator. If no errors are detected,
C        IERROR=0 when control returns to the calling routine. If
C        an error is detected, IERROR is returned as nonzero. The
C        calling routine must check the value of IERROR.
C
C        If IERROR=212 or 213, invalid input was provided to DXNRMP.
C        If IERROR=201,202,203, or 204, invalid input was provided
C        to DXSET.
C        If IERROR=205 or 206, an internal consistency error occurred
C        in DXSET (probably due to a software malfunction in the
C        library routine I1MACH).
C        If IERROR=207, an overflow or underflow of an extended-range
C        number was detected in DXADJ.
C        If IERROR=208, an overflow or underflow of an extended-range
C        number was detected in DXC210.
C
C***SEE ALSO  DXSET
C***REFERENCES  Smith, Olver and Lozier, Extended-Range Arithmetic and
C                 Normalized Legendre Polynomials, ACM Trans on Math
C                 Softw, v 7, n 1, March 1981, pp 93--105.
C***ROUTINES CALLED  DXADD, DXADJ, DXRED, DXSET, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXNRMP
      INTEGER NU, MU1, MU2, MODE, IPN, ISIG
      DOUBLE PRECISION DARG, DPN
      DIMENSION DPN(*), IPN(*)
      DOUBLE PRECISION C1,C2,P,P1,P2,P3,S,SX,T,TX,X,DK
C CALL DXSET TO INITIALIZE EXTENDED-RANGE ARITHMETIC (SEE DXSET
C LISTING FOR DETAILS)
C***FIRST EXECUTABLE STATEMENT  DXNRMP
      IERROR=0
      CALL DXSET (0, 0, 0.0D0, 0,IERROR)
      IF (IERROR.NE.0) RETURN
C
C        TEST FOR PROPER INPUT VALUES.
C
      IF (NU.LT.0) GO TO 110
      IF (MU1.LT.0) GO TO 110
      IF (MU1.GT.MU2) GO TO 110
      IF (NU.EQ.0) GO TO 90
      IF (MODE.LT.1 .OR. MODE.GT.2) GO TO 110
      GO TO (10, 20), MODE
   10 IF (ABS(DARG).GT.1.0D0) GO TO 120
      IF (ABS(DARG).EQ.1.0D0) GO TO 90
      X = DARG
      SX = SQRT((1.0D0+ABS(X))*((0.5D0-ABS(X))+0.5D0))
      TX = X/SX
      ISIG = LOG10(2.0D0*NU*(5.0D0+TX**2))
      GO TO 30
   20 IF (ABS(DARG).GT.4.0D0*ATAN(1.0D0)) GO TO 120
      IF (DARG.EQ.0.0D0) GO TO 90
      X = COS(DARG)
      SX = ABS(SIN(DARG))
      TX = X/SX
      ISIG = LOG10(2.0D0*NU*(5.0D0+ABS(DARG*TX)))
C
C        BEGIN CALCULATION
C
   30 MU = MU2
      I = MU2 - MU1 + 1
C
C        IF MU.GT.NU, NORMALIZED LEGENDRE(NU,MU,X)=0.
C
   40 IF (MU.LE.NU) GO TO 50
      DPN(I) = 0.0D0
      IPN(I) = 0
      I = I - 1
      MU = MU - 1
      IF (I .GT. 0) GO TO 40
      ISIG = 0
      GO TO 160
   50 MU = NU
C
C        P1 = 0. = NORMALIZED LEGENDRE(NU,NU+1,X)
C
      P1 = 0.0D0
      IP1 = 0
C
C        CALCULATE P2 = NORMALIZED LEGENDRE(NU,NU,X)
C
      P2 = 1.0D0
      IP2 = 0
      P3 = 0.5D0
      DK = 2.0D0
      DO 60 J=1,NU
        P3 = ((DK+1.0D0)/DK)*P3
        P2 = P2*SX
        CALL DXADJ(P2, IP2,IERROR)
        IF (IERROR.NE.0) RETURN
        DK = DK + 2.0D0
   60 CONTINUE
      P2 = P2*SQRT(P3)
      CALL DXADJ(P2, IP2,IERROR)
      IF (IERROR.NE.0) RETURN
      S = 2.0D0*TX
      T = 1.0D0/NU
      IF (MU2.LT.NU) GO TO 70
      DPN(I) = P2
      IPN(I) = IP2
      I = I - 1
      IF (I .EQ. 0) GO TO 140
C
C        RECURRENCE PROCESS
C
   70 P = MU*T
      C1 = 1.0D0/SQRT((1.0D0-P+T)*(1.0D0+P))
      C2 = S*P*C1*P2
      C1 = -SQRT((1.0D0+P+T)*(1.0D0-P))*C1*P1
      CALL DXADD(C2, IP2, C1, IP1, P, IP,IERROR)
      IF (IERROR.NE.0) RETURN
      MU = MU - 1
      IF (MU.GT.MU2) GO TO 80
C
C        STORE IN ARRAY DPN FOR RETURN TO CALLING ROUTINE.
C
      DPN(I) = P
      IPN(I) = IP
      I = I - 1
      IF (I .EQ. 0) GO TO 140
   80 P1 = P2
      IP1 = IP2
      P2 = P
      IP2 = IP
      IF (MU.LE.MU1) GO TO 140
      GO TO 70
C
C        SPECIAL CASE WHEN X=-1 OR +1, OR NU=0.
C
   90 K = MU2 - MU1 + 1
      DO 100 I=1,K
        DPN(I) = 0.0D0
        IPN(I) = 0
  100 CONTINUE
      ISIG = 0
      IF (MU1.GT.0) GO TO 160
      ISIG = 1
      DPN(1) = SQRT(NU+0.5D0)
      IPN(1) = 0
      IF (MOD(NU,2).EQ.0) GO TO 160
      IF (MODE.EQ.1 .AND. DARG.EQ.1.0D0) GO TO 160
      IF (MODE.EQ.2) GO TO 160
      DPN(1) = -DPN(1)
      GO TO 160
C
C          ERROR PRINTOUTS AND TERMINATION.
C
  110 CALL XERMSG ('SLATEC', 'DXNRMP', 'NU, MU1, MU2 or MODE not valid',
     +             212, 1)
      IERROR=212
      RETURN
  120 CALL XERMSG ('SLATEC', 'DXNRMP', 'DARG out of range', 213, 1)
      IERROR=213
      RETURN
C
C        RETURN TO CALLING PROGRAM
C
  140 K = MU2 - MU1 + 1
      DO 150 I=1,K
        CALL DXRED(DPN(I),IPN(I),IERROR)
        IF (IERROR.NE.0) RETURN
  150 CONTINUE
  160 RETURN
      END
*DECK DXPMU
      SUBROUTINE DXPMU (NU1, NU2, MU1, MU2, THETA, X, SX, ID, PQA, IPQA,
     1   IERROR)
C***BEGIN PROLOGUE  DXPMU
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for DXLEGF.
C            Method: backward mu-wise recurrence for P(-MU,NU,X) for
C            fixed nu to obtain P(-MU2,NU1,X), P(-(MU2-1),NU1,X), ...,
C            P(-MU1,NU1,X) and store in ascending mu order.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      DOUBLE PRECISION (XPMU-S, DXPMU-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  DXADD, DXADJ, DXPQNU
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXPMU
      DOUBLE PRECISION PQA,NU1,NU2,P0,X,SX,THETA,X1,X2
      DIMENSION PQA(*),IPQA(*)
C
C        CALL DXPQNU TO OBTAIN P(-MU2,NU,X)
C
C***FIRST EXECUTABLE STATEMENT  DXPMU
      IERROR=0
      CALL DXPQNU(NU1,NU2,MU2,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      P0=PQA(1)
      IP0=IPQA(1)
      MU=MU2-1
C
C        CALL DXPQNU TO OBTAIN P(-MU2-1,NU,X)
C
      CALL DXPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      N=MU2-MU1+1
      PQA(N)=P0
      IPQA(N)=IP0
      IF(N.EQ.1) GO TO 300
      PQA(N-1)=PQA(1)
      IPQA(N-1)=IPQA(1)
      IF(N.EQ.2) GO TO 300
      J=N-2
  290 CONTINUE
C
C        BACKWARD RECURRENCE IN MU TO OBTAIN
C              P(-MU2,NU1,X),P(-(MU2-1),NU1,X),....P(-MU1,NU1,X)
C              USING
C              (NU-MU)*(NU+MU+1.)*P(-(MU+1),NU,X)=
C                2.*MU*X*SQRT((1./(1.-X**2))*P(-MU,NU,X)-P(-(MU-1),NU,X)
C
      X1=2.D0*MU*X*SX*PQA(J+1)
      X2=-(NU1-MU)*(NU1+MU+1.D0)*PQA(J+2)
      CALL DXADD(X1,IPQA(J+1),X2,IPQA(J+2),PQA(J),IPQA(J),IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADJ(PQA(J),IPQA(J),IERROR)
      IF (IERROR.NE.0) RETURN
      IF(J.EQ.1) GO TO 300
      J=J-1
      MU=MU-1
      GO TO 290
  300 RETURN
      END
*DECK DXPMUP
      SUBROUTINE DXPMUP (NU1, NU2, MU1, MU2, PQA, IPQA, IERROR)
C***BEGIN PROLOGUE  DXPMUP
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for DXLEGF.
C            This subroutine transforms an array of Legendre functions
C            of the first kind of negative order stored in array PQA
C            into Legendre functions of the first kind of positive
C            order stored in array PQA. The original array is destroyed.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      DOUBLE PRECISION (XPMUP-S, DXPMUP-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  DXADJ
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXPMUP
      DOUBLE PRECISION DMU,NU,NU1,NU2,PQA,PROD
      DIMENSION PQA(*),IPQA(*)
C***FIRST EXECUTABLE STATEMENT  DXPMUP
      IERROR=0
      NU=NU1
      MU=MU1
      DMU=MU
      N=INT(NU2-NU1+.1D0)+(MU2-MU1)+1
      J=1
      IF(MOD(REAL(NU),1.).NE.0.) GO TO 210
  200 IF(DMU.LT.NU+1.D0) GO TO 210
      PQA(J)=0.D0
      IPQA(J)=0
      J=J+1
      IF(J.GT.N) RETURN
C        INCREMENT EITHER MU OR NU AS APPROPRIATE.
      IF(NU2-NU1.GT..5D0) NU=NU+1.D0
      IF(MU2.GT.MU1) MU=MU+1
      GO TO 200
C
C        TRANSFORM P(-MU,NU,X) TO P(MU,NU,X) USING
C        P(MU,NU,X)=(NU-MU+1)*(NU-MU+2)*...*(NU+MU)*P(-MU,NU,X)*(-1)**MU
C
  210 PROD=1.D0
      IPROD=0
      K=2*MU
      IF(K.EQ.0) GO TO 222
      DO 220 L=1,K
      PROD=PROD*(DMU-NU-L)
  220 CALL DXADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
  222 CONTINUE
      DO 240 I=J,N
      IF(MU.EQ.0) GO TO 225
      PQA(I)=PQA(I)*PROD*(-1)**MU
      IPQA(I)=IPQA(I)+IPROD
      CALL DXADJ(PQA(I),IPQA(I),IERROR)
      IF (IERROR.NE.0) RETURN
  225 IF(NU2-NU1.GT..5D0) GO TO 230
      PROD=(DMU-NU)*PROD*(-DMU-NU-1.D0)
      CALL DXADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
      MU=MU+1
      DMU=DMU+1.D0
      GO TO 240
  230 PROD=PROD*(-DMU-NU-1.D0)/(DMU-NU-1.D0)
      CALL DXADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
      NU=NU+1.D0
  240 CONTINUE
      RETURN
      END
*DECK DXPNRM
      SUBROUTINE DXPNRM (NU1, NU2, MU1, MU2, PQA, IPQA, IERROR)
C***BEGIN PROLOGUE  DXPNRM
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for DXLEGF.
C            This subroutine transforms an array of Legendre functions
C            of the first kind of negative order stored in array PQA
C            into normalized Legendre polynomials stored in array PQA.
C            The original array is destroyed.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      DOUBLE PRECISION (XPNRM-S, DXPNRM-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  DXADJ
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXPNRM
      DOUBLE PRECISION C1,DMU,NU,NU1,NU2,PQA,PROD
      DIMENSION PQA(*),IPQA(*)
C***FIRST EXECUTABLE STATEMENT  DXPNRM
      IERROR=0
      L=(MU2-MU1)+(NU2-NU1+1.5D0)
      MU=MU1
      DMU=MU1
      NU=NU1
C
C         IF MU .GT.NU, NORM P =0.
C
      J=1
  500 IF(DMU.LE.NU) GO TO 505
      PQA(J)=0.D0
      IPQA(J)=0
      J=J+1
      IF(J.GT.L) RETURN
C
C        INCREMENT EITHER MU OR NU AS APPROPRIATE.
C
      IF(MU2.GT.MU1) DMU=DMU+1.D0
      IF(NU2-NU1.GT..5D0) NU=NU+1.D0
      GO TO 500
C
C         TRANSFORM P(-MU,NU,X) INTO NORMALIZED P(MU,NU,X) USING
C              NORM P(MU,NU,X)=
C                 SQRT((NU+.5)*FACTORIAL(NU+MU)/FACTORIAL(NU-MU))
C                              *P(-MU,NU,X)
C
  505 PROD=1.D0
      IPROD=0
      K=2*MU
      IF(K.LE.0) GO TO 520
      DO 510 I=1,K
      PROD=PROD*SQRT(NU+DMU+1.D0-I)
  510 CALL DXADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
  520 DO 540 I=J,L
      C1=PROD*SQRT(NU+.5D0)
      PQA(I)=PQA(I)*C1
      IPQA(I)=IPQA(I)+IPROD
      CALL DXADJ(PQA(I),IPQA(I),IERROR)
      IF (IERROR.NE.0) RETURN
      IF(NU2-NU1.GT..5D0) GO TO 530
      IF(DMU.GE.NU) GO TO 525
      PROD=SQRT(NU+DMU+1.D0)*PROD
      IF(NU.GT.DMU) PROD=PROD*SQRT(NU-DMU)
      CALL DXADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
      MU=MU+1
      DMU=DMU+1.D0
      GO TO 540
  525 PROD=0.D0
      IPROD=0
      MU=MU+1
      DMU=DMU+1.D0
      GO TO 540
  530 PROD=SQRT(NU+DMU+1.D0)*PROD
      IF(NU.NE.DMU-1.D0) PROD=PROD/SQRT(NU-DMU+1.D0)
      CALL DXADJ(PROD,IPROD,IERROR)
      IF (IERROR.NE.0) RETURN
      NU=NU+1.D0
  540 CONTINUE
      RETURN
      END
*DECK DXPQNU
      SUBROUTINE DXPQNU (NU1, NU2, MU, THETA, ID, PQA, IPQA, IERROR)
C***BEGIN PROLOGUE  DXPQNU
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for DXLEGF.
C            This subroutine calculates initial values of P or Q using
C            power series, then performs forward nu-wise recurrence to
C            obtain P(-MU,NU,X), Q(0,NU,X), or Q(1,NU,X). The nu-wise
C            recurrence is stable for P for all mu and for Q for mu=0,1.
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      DOUBLE PRECISION (XPQNU-S, DXPQNU-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  DXADD, DXADJ, DXPSI
C***COMMON BLOCKS    DXBLK1
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXPQNU
      DOUBLE PRECISION A,NU,NU1,NU2,PQ,PQA,DXPSI,R,THETA,W,X,X1,X2,XS,
     1 Y,Z
      DOUBLE PRECISION DI,DMU,PQ1,PQ2,FACTMU,FLOK
      DIMENSION PQA(*),IPQA(*)
      COMMON /DXBLK1/ NBITSF
      SAVE /DXBLK1/
C
C        J0, IPSIK, AND IPSIX ARE INITIALIZED IN THIS SUBROUTINE.
C        J0 IS THE NUMBER OF TERMS USED IN SERIES EXPANSION
C        IN SUBROUTINE DXPQNU.
C        IPSIK, IPSIX ARE VALUES OF K AND X RESPECTIVELY
C        USED IN THE CALCULATION OF THE DXPSI FUNCTION.
C
C***FIRST EXECUTABLE STATEMENT  DXPQNU
      IERROR=0
      J0=NBITSF
      IPSIK=1+(NBITSF/10)
      IPSIX=5*IPSIK
      IPQ=0
C        FIND NU IN INTERVAL [-.5,.5) IF ID=2  ( CALCULATION OF Q )
      NU=MOD(NU1,1.D0)
      IF(NU.GE..5D0) NU=NU-1.D0
C        FIND NU IN INTERVAL (-1.5,-.5] IF ID=1,3, OR 4  ( CALC. OF P )
      IF(ID.NE.2.AND.NU.GT.-.5D0) NU=NU-1.D0
C        CALCULATE MU FACTORIAL
      K=MU
      DMU=MU
      IF(MU.LE.0) GO TO 60
      FACTMU=1.D0
      IF=0
      DO 50 I=1,K
      FACTMU=FACTMU*I
   50 CALL DXADJ(FACTMU,IF,IERROR)
      IF (IERROR.NE.0) RETURN
   60 IF(K.EQ.0) FACTMU=1.D0
      IF(K.EQ.0) IF=0
C
C        X=COS(THETA)
C        Y=SIN(THETA/2)**2=(1-X)/2=.5-.5*X
C        R=TAN(THETA/2)=SQRT((1-X)/(1+X)
C
      X=COS(THETA)
      Y=SIN(THETA/2.D0)**2
      R=TAN(THETA/2.D0)
C
C        USE ASCENDING SERIES TO CALCULATE TWO VALUES OF P OR Q
C        FOR USE AS STARTING VALUES IN RECURRENCE RELATION.
C
      PQ2=0.0D0
      DO 100 J=1,2
      IPQ1=0
      IF(ID.EQ.2) GO TO 80
C
C        SERIES FOR P ( ID = 1, 3, OR 4 )
C        P(-MU,NU,X)=1./FACTORIAL(MU)*SQRT(((1.-X)/(1.+X))**MU)
C                *SUM(FROM 0 TO J0-1)A(J)*(.5-.5*X)**J
C
      IPQ=0
      PQ=1.D0
      A=1.D0
      IA=0
      DO 65 I=2,J0
      DI=I
      A=A*Y*(DI-2.D0-NU)*(DI-1.D0+NU)/((DI-1.D0+DMU)*(DI-1.D0))
      CALL DXADJ(A,IA,IERROR)
      IF (IERROR.NE.0) RETURN
      IF(A.EQ.0.D0) GO TO 66
      CALL DXADD(PQ,IPQ,A,IA,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
   65 CONTINUE
   66 CONTINUE
      IF(MU.LE.0) GO TO 90
      X2=R
      X1=PQ
      K=MU
      DO 77 I=1,K
      X1=X1*X2
   77 CALL DXADJ(X1,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ=X1/FACTMU
      IPQ=IPQ-IF
      CALL DXADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 90
C
C        Z=-LN(R)=.5*LN((1+X)/(1-X))
C
   80 Z=-LOG(R)
      W=DXPSI(NU+1.D0,IPSIK,IPSIX)
      XS=1.D0/SIN(THETA)
C
C        SERIES SUMMATION FOR Q ( ID = 2 )
C        Q(0,NU,X)=SUM(FROM 0 TO J0-1)((.5*LN((1+X)/(1-X))
C    +DXPSI(J+1,IPSIK,IPSIX)-DXPSI(NU+1,IPSIK,IPSIX)))*A(J)*(.5-.5*X)**J
C
C        Q(1,NU,X)=-SQRT(1./(1.-X**2))+SQRT((1-X)/(1+X))
C             *SUM(FROM 0 T0 J0-1)(-NU*(NU+1)/2*LN((1+X)/(1-X))
C                 +(J-NU)*(J+NU+1)/(2*(J+1))+NU*(NU+1)*
C     (DXPSI(NU+1,IPSIK,IPSIX)-DXPSI(J+1,IPSIK,IPSIX))*A(J)*(.5-.5*X)**J
C
C        NOTE, IN THIS LOOP K=J+1
C
      PQ=0.D0
      IPQ=0
      IA=0
      A=1.D0
      DO 85 K=1,J0
      FLOK=K
      IF(K.EQ.1) GO TO 81
      A=A*Y*(FLOK-2.D0-NU)*(FLOK-1.D0+NU)/((FLOK-1.D0+DMU)*(FLOK-1.D0))
      CALL DXADJ(A,IA,IERROR)
      IF (IERROR.NE.0) RETURN
   81 CONTINUE
      IF(MU.GE.1) GO TO 83
      X1=(DXPSI(FLOK,IPSIK,IPSIX)-W+Z)*A
      IX1=IA
      CALL DXADD(PQ,IPQ,X1,IX1,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      GO TO 85
   83 X1=(NU*(NU+1.D0)*(Z-W+DXPSI(FLOK,IPSIK,IPSIX))+(NU-FLOK+1.D0)
     1  *(NU+FLOK)/(2.D0*FLOK))*A
      IX1=IA
      CALL DXADD(PQ,IPQ,X1,IX1,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
   85 CONTINUE
      IF(MU.GE.1) PQ=-R*PQ
      IXS=0
      IF(MU.GE.1) CALL DXADD(PQ,IPQ,-XS,IXS,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      IF(J.EQ.2) MU=-MU
      IF(J.EQ.2) DMU=-DMU
   90 IF(J.EQ.1) PQ2=PQ
      IF(J.EQ.1) IPQ2=IPQ
      NU=NU+1.D0
  100 CONTINUE
      K=0
      IF(NU-1.5D0.LT.NU1) GO TO 120
      K=K+1
      PQA(K)=PQ2
      IPQA(K)=IPQ2
      IF(NU.GT.NU2+.5D0) RETURN
  120 PQ1=PQ
      IPQ1=IPQ
      IF(NU.LT.NU1+.5D0) GO TO 130
      K=K+1
      PQA(K)=PQ
      IPQA(K)=IPQ
      IF(NU.GT.NU2+.5D0) RETURN
C
C        FORWARD NU-WISE RECURRENCE FOR F(MU,NU,X) FOR FIXED MU
C        USING
C        (NU+MU+1)*F(MU,NU,X)=(2.*NU+1)*F(MU,NU,X)-(NU-MU)*F(MU,NU-1,X)
C        WHERE F(MU,NU,X) MAY BE P(-MU,NU,X) OR IF MU IS REPLACED
C        BY -MU THEN F(MU,NU,X) MAY BE Q(MU,NU,X).
C        NOTE, IN THIS LOOP, NU=NU+1
C
  130 X1=(2.D0*NU-1.D0)/(NU+DMU)*X*PQ1
      X2=(NU-1.D0-DMU)/(NU+DMU)*PQ2
      CALL DXADD(X1,IPQ1,-X2,IPQ2,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      NU=NU+1.D0
      PQ2=PQ1
      IPQ2=IPQ1
      GO TO 120
C
      END
*DECK DXPSI
      DOUBLE PRECISION FUNCTION DXPSI (A, IPSIK, IPSIX)
C***BEGIN PROLOGUE  DXPSI
C***SUBSIDIARY
C***PURPOSE  To compute values of the Psi function for DXLEGF.
C***LIBRARY   SLATEC
C***CATEGORY  C7C
C***TYPE      DOUBLE PRECISION (XPSI-S, DXPSI-D)
C***KEYWORDS  PSI FUNCTION
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXPSI
      DOUBLE PRECISION A,B,C,CNUM,CDENOM
      DIMENSION CNUM(12),CDENOM(12)
      SAVE CNUM, CDENOM
C
C        CNUM(I) AND CDENOM(I) ARE THE ( REDUCED ) NUMERATOR
C        AND 2*I*DENOMINATOR RESPECTIVELY OF THE 2*I TH BERNOULLI
C        NUMBER.
C
      DATA CNUM(1),CNUM(2),CNUM(3),CNUM(4),CNUM(5),CNUM(6),CNUM(7),
     1CNUM(8),CNUM(9),CNUM(10),CNUM(11),CNUM(12)
     2    / 1.D0,     -1.D0,    1.D0,     -1.D0, 1.D0,
     3   -691.D0,  1.D0,     -3617.D0, 43867.D0, -174611.D0, 77683.D0,
     4   -236364091.D0/
      DATA CDENOM(1),CDENOM(2),CDENOM(3),CDENOM(4),CDENOM(5),CDENOM(6),
     1 CDENOM(7),CDENOM(8),CDENOM(9),CDENOM(10),CDENOM(11),CDENOM(12)
     2/12.D0,120.D0,   252.D0,   240.D0,132.D0,
     3  32760.D0, 12.D0,  8160.D0, 14364.D0, 6600.D0, 276.D0, 65520.D0/
C***FIRST EXECUTABLE STATEMENT  DXPSI
      N=MAX(0,IPSIX-INT(A))
      B=N+A
      K1=IPSIK-1
C
C        SERIES EXPANSION FOR A .GT. IPSIX USING IPSIK-1 TERMS.
C
      C=0.D0
      DO 12 I=1,K1
      K=IPSIK-I
   12 C=(C+CNUM(K)/CDENOM(K))/B**2
      DXPSI=LOG(B)-(C+.5D0/B)
      IF(N.EQ.0) GO TO 20
      B=0.D0
C
C        RECURRENCE FOR A .LE. IPSIX.
C
      DO 15 M=1,N
   15 B=B+1.D0/(N-M+A)
      DXPSI=DXPSI-B
   20 RETURN
      END
*DECK DXQMU
      SUBROUTINE DXQMU (NU1, NU2, MU1, MU2, THETA, X, SX, ID, PQA, IPQA,
     1   IERROR)
C***BEGIN PROLOGUE  DXQMU
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for DXLEGF.
C            Method: forward mu-wise recurrence for Q(MU,NU,X) for fixed
C            nu to obtain Q(MU1,NU,X), Q(MU1+1,NU,X), ..., Q(MU2,NU,X).
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      DOUBLE PRECISION (XQMU-S, DXQMU-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  DXADD, DXADJ, DXPQNU
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXQMU
      DIMENSION PQA(*),IPQA(*)
      DOUBLE PRECISION DMU,NU,NU1,NU2,PQ,PQA,PQ1,PQ2,SX,X,X1,X2
      DOUBLE PRECISION THETA
C***FIRST EXECUTABLE STATEMENT  DXQMU
      IERROR=0
      MU=0
C
C        CALL DXPQNU TO OBTAIN Q(0.,NU1,X)
C
      CALL DXPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ2=PQA(1)
      IPQ2=IPQA(1)
      MU=1
C
C        CALL DXPQNU TO OBTAIN Q(1.,NU1,X)
C
      CALL DXPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      NU=NU1
      K=0
      MU=1
      DMU=1.D0
      PQ1=PQA(1)
      IPQ1=IPQA(1)
      IF(MU1.GT.0) GO TO 310
      K=K+1
      PQA(K)=PQ2
      IPQA(K)=IPQ2
      IF(MU2.LT.1) GO TO 330
  310 IF(MU1.GT.1) GO TO 320
      K=K+1
      PQA(K)=PQ1
      IPQA(K)=IPQ1
      IF(MU2.LE.1) GO TO 330
  320 CONTINUE
C
C        FORWARD RECURRENCE IN MU TO OBTAIN
C                  Q(MU1,NU,X),Q(MU1+1,NU,X),....,Q(MU2,NU,X) USING
C             Q(MU+1,NU,X)=-2.*MU*X*SQRT(1./(1.-X**2))*Q(MU,NU,X)
C                               -(NU+MU)*(NU-MU+1.)*Q(MU-1,NU,X)
C
      X1=-2.D0*DMU*X*SX*PQ1
      X2=(NU+DMU)*(NU-DMU+1.D0)*PQ2
      CALL DXADD(X1,IPQ1,-X2,IPQ2,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ2=PQ1
      IPQ2=IPQ1
      PQ1=PQ
      IPQ1=IPQ
      MU=MU+1
      DMU=DMU+1.D0
      IF(MU.LT.MU1) GO TO 320
      K=K+1
      PQA(K)=PQ
      IPQA(K)=IPQ
      IF(MU2.GT.MU) GO TO 320
  330 RETURN
      END
*DECK DXQNU
      SUBROUTINE DXQNU (NU1, NU2, MU1, THETA, X, SX, ID, PQA, IPQA,
     1   IERROR)
C***BEGIN PROLOGUE  DXQNU
C***SUBSIDIARY
C***PURPOSE  To compute the values of Legendre functions for DXLEGF.
C            Method: backward nu-wise recurrence for Q(MU,NU,X) for
C            fixed mu to obtain Q(MU1,NU1,X), Q(MU1,NU1+1,X), ...,
C            Q(MU1,NU2,X).
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      DOUBLE PRECISION (XQNU-S, DXQNU-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  Smith, John M., (NBS and George Mason University)
C***ROUTINES CALLED  DXADD, DXADJ, DXPQNU
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXQNU
      DIMENSION PQA(*),IPQA(*)
      DOUBLE PRECISION DMU,NU,NU1,NU2,PQ,PQA,PQ1,PQ2,SX,X,X1,X2
      DOUBLE PRECISION THETA,PQL1,PQL2
C***FIRST EXECUTABLE STATEMENT  DXQNU
      IERROR=0
      K=0
      PQ2=0.0D0
      IPQ2=0
      PQL2=0.0D0
      IPQL2=0
      IF(MU1.EQ.1) GO TO 290
      MU=0
C
C        CALL DXPQNU TO OBTAIN Q(0.,NU2,X) AND Q(0.,NU2-1,X)
C
      CALL DXPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      IF(MU1.EQ.0) RETURN
      K=(NU2-NU1+1.5D0)
      PQ2=PQA(K)
      IPQ2=IPQA(K)
      PQL2=PQA(K-1)
      IPQL2=IPQA(K-1)
  290 MU=1
C
C        CALL DXPQNU TO OBTAIN Q(1.,NU2,X) AND Q(1.,NU2-1,X)
C
      CALL DXPQNU(NU1,NU2,MU,THETA,ID,PQA,IPQA,IERROR)
      IF (IERROR.NE.0) RETURN
      IF(MU1.EQ.1) RETURN
      NU=NU2
      PQ1=PQA(K)
      IPQ1=IPQA(K)
      PQL1=PQA(K-1)
      IPQL1=IPQA(K-1)
  300 MU=1
      DMU=1.D0
  320 CONTINUE
C
C        FORWARD RECURRENCE IN MU TO OBTAIN Q(MU1,NU2,X) AND
C              Q(MU1,NU2-1,X) USING
C              Q(MU+1,NU,X)=-2.*MU*X*SQRT(1./(1.-X**2))*Q(MU,NU,X)
C                   -(NU+MU)*(NU-MU+1.)*Q(MU-1,NU,X)
C
C              FIRST FOR NU=NU2
C
      X1=-2.D0*DMU*X*SX*PQ1
      X2=(NU+DMU)*(NU-DMU+1.D0)*PQ2
      CALL DXADD(X1,IPQ1,-X2,IPQ2,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ2=PQ1
      IPQ2=IPQ1
      PQ1=PQ
      IPQ1=IPQ
      MU=MU+1
      DMU=DMU+1.D0
      IF(MU.LT.MU1) GO TO 320
      PQA(K)=PQ
      IPQA(K)=IPQ
      IF(K.EQ.1) RETURN
      IF(NU.LT.NU2) GO TO 340
C
C              THEN FOR NU=NU2-1
C
      NU=NU-1.D0
      PQ2=PQL2
      IPQ2=IPQL2
      PQ1=PQL1
      IPQ1=IPQL1
      K=K-1
      GO TO 300
C
C         BACKWARD RECURRENCE IN NU TO OBTAIN
C              Q(MU1,NU1,X),Q(MU1,NU1+1,X),....,Q(MU1,NU2,X)
C              USING
C              (NU-MU+1.)*Q(MU,NU+1,X)=
C                       (2.*NU+1.)*X*Q(MU,NU,X)-(NU+MU)*Q(MU,NU-1,X)
C
  340 PQ1=PQA(K)
      IPQ1=IPQA(K)
      PQ2=PQA(K+1)
      IPQ2=IPQA(K+1)
  350 IF(NU.LE.NU1) RETURN
      K=K-1
      X1=(2.D0*NU+1.D0)*X*PQ1/(NU+DMU)
      X2=-(NU-DMU+1.D0)*PQ2/(NU+DMU)
      CALL DXADD(X1,IPQ1,X2,IPQ2,PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADJ(PQ,IPQ,IERROR)
      IF (IERROR.NE.0) RETURN
      PQ2=PQ1
      IPQ2=IPQ1
      PQ1=PQ
      IPQ1=IPQ
      PQA(K)=PQ
      IPQA(K)=IPQ
      NU=NU-1.D0
      GO TO 350
      END
*DECK DXRED
      SUBROUTINE DXRED (X, IX, IERROR)
C***BEGIN PROLOGUE  DXRED
C***PURPOSE  To provide double-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      DOUBLE PRECISION (XRED-S, DXRED-D)
C***KEYWORDS  EXTENDED-RANGE DOUBLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C     DOUBLE PRECISION X
C     INTEGER IX
C
C                  IF
C                  RADIX**(-2L) .LE. (ABS(X),IX) .LE. RADIX**(2L)
C                  THEN DXRED TRANSFORMS (X,IX) SO THAT IX=0.
C                  IF (X,IX) IS OUTSIDE THE ABOVE RANGE,
C                  THEN DXRED TAKES NO ACTION.
C                  THIS SUBROUTINE IS USEFUL IF THE
C                  RESULTS OF EXTENDED-RANGE CALCULATIONS
C                  ARE TO BE USED IN SUBSEQUENT ORDINARY
C                  DOUBLE-PRECISION CALCULATIONS.
C
C***SEE ALSO  DXSET
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    DXBLK2
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXRED
      DOUBLE PRECISION X
      INTEGER IX
      DOUBLE PRECISION RADIX, RADIXL, RAD2L, DLG10R, XA
      INTEGER L, L2, KMAX
      COMMON /DXBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /DXBLK2/
C
C***FIRST EXECUTABLE STATEMENT  DXRED
      IERROR=0
      IF (X.EQ.0.0D0) GO TO 90
      XA = ABS(X)
      IF (IX.EQ.0) GO TO 70
      IXA = ABS(IX)
      IXA1 = IXA/L2
      IXA2 = MOD(IXA,L2)
      IF (IX.GT.0) GO TO 40
   10 CONTINUE
      IF (XA.GT.1.0D0) GO TO 20
      XA = XA*RAD2L
      IXA1 = IXA1 + 1
      GO TO 10
   20 XA = XA/RADIX**IXA2
      IF (IXA1.EQ.0) GO TO 70
      DO 30 I=1,IXA1
        IF (XA.LT.1.0D0) GO TO 100
        XA = XA/RAD2L
   30 CONTINUE
      GO TO 70
C
   40 CONTINUE
      IF (XA.LT.1.0D0) GO TO 50
      XA = XA/RAD2L
      IXA1 = IXA1 + 1
      GO TO 40
   50 XA = XA*RADIX**IXA2
      IF (IXA1.EQ.0) GO TO 70
      DO 60 I=1,IXA1
        IF (XA.GT.1.0D0) GO TO 100
        XA = XA*RAD2L
   60 CONTINUE
   70 IF (XA.GT.RAD2L) GO TO 100
      IF (XA.GT.1.0D0) GO TO 80
      IF (RAD2L*XA.LT.1.0D0) GO TO 100
   80 X = SIGN(XA,X)
   90 IX = 0
  100 RETURN
      END
*DECK DXSET
      SUBROUTINE DXSET (IRAD, NRADPL, DZERO, NBITS, IERROR)
C***BEGIN PROLOGUE  DXSET
C***PURPOSE  To provide double-precision floating-point arithmetic
C            with an extended exponent range.
C***LIBRARY   SLATEC
C***CATEGORY  A3D
C***TYPE      DOUBLE PRECISION (XSET-S, DXSET-D)
C***KEYWORDS  EXTENDED-RANGE DOUBLE-PRECISION ARITHMETIC
C***AUTHOR  Lozier, Daniel W., (National Bureau of Standards)
C           Smith, John M., (NBS and George Mason University)
C***DESCRIPTION
C
C   SUBROUTINE  DXSET  MUST BE CALLED PRIOR TO CALLING ANY OTHER
C EXTENDED-RANGE SUBROUTINE. IT CALCULATES AND STORES SEVERAL
C MACHINE-DEPENDENT CONSTANTS IN COMMON BLOCKS. THE USER MUST
C SUPPLY FOUR CONSTANTS THAT PERTAIN TO HIS PARTICULAR COMPUTER.
C THE CONSTANTS ARE
C
C          IRAD = THE INTERNAL BASE OF DOUBLE-PRECISION
C                 ARITHMETIC IN THE COMPUTER.
C        NRADPL = THE NUMBER OF RADIX PLACES CARRIED IN
C                 THE DOUBLE-PRECISION REPRESENTATION.
C         DZERO = THE SMALLEST OF 1/DMIN, DMAX, DMAXLN WHERE
C                 DMIN = THE SMALLEST POSITIVE DOUBLE-PRECISION
C                 NUMBER OR AN UPPER BOUND TO THIS NUMBER,
C                 DMAX = THE LARGEST DOUBLE-PRECISION NUMBER
C                 OR A LOWER BOUND TO THIS NUMBER,
C                 DMAXLN = THE LARGEST DOUBLE-PRECISION NUMBER
C                 SUCH THAT LOG10(DMAXLN) CAN BE COMPUTED BY THE
C                 FORTRAN SYSTEM (ON MOST SYSTEMS DMAXLN = DMAX).
C         NBITS = THE NUMBER OF BITS (EXCLUSIVE OF SIGN) IN
C                 AN INTEGER COMPUTER WORD.
C
C ALTERNATIVELY, ANY OR ALL OF THE CONSTANTS CAN BE GIVEN
C THE VALUE 0 (0.0D0 FOR DZERO). IF A CONSTANT IS ZERO, DXSET TRIES
C TO ASSIGN AN APPROPRIATE VALUE BY CALLING I1MACH
C (SEE P.A.FOX, A.D.HALL, N.L.SCHRYER, ALGORITHM 528 FRAMEWORK
C FOR A PORTABLE LIBRARY, ACM TRANSACTIONS ON MATH SOFTWARE,
C V.4, NO.2, JUNE 1978, 177-188).
C
C   THIS IS THE SETTING-UP SUBROUTINE FOR A PACKAGE OF SUBROUTINES
C THAT FACILITATE THE USE OF EXTENDED-RANGE ARITHMETIC. EXTENDED-RANGE
C ARITHMETIC ON A PARTICULAR COMPUTER IS DEFINED ON THE SET OF NUMBERS
C OF THE FORM
C
C               (X,IX) = X*RADIX**IX
C
C WHERE X IS A DOUBLE-PRECISION NUMBER CALLED THE PRINCIPAL PART,
C IX IS AN INTEGER CALLED THE AUXILIARY INDEX, AND RADIX IS THE
C INTERNAL BASE OF THE DOUBLE-PRECISION ARITHMETIC.  OBVIOUSLY,
C EACH REAL NUMBER IS REPRESENTABLE WITHOUT ERROR BY MORE THAN ONE
C EXTENDED-RANGE FORM.  CONVERSIONS BETWEEN  DIFFERENT FORMS ARE
C ESSENTIAL IN CARRYING OUT ARITHMETIC OPERATIONS.  WITH THE CHOICE
C OF RADIX WE HAVE MADE, AND THE SUBROUTINES WE HAVE WRITTEN, THESE
C CONVERSIONS ARE PERFORMED WITHOUT ERROR (AT LEAST ON MOST COMPUTERS).
C (SEE SMITH, J.M., OLVER, F.W.J., AND LOZIER, D.W., EXTENDED-RANGE
C ARITHMETIC AND NORMALIZED LEGENDRE POLYNOMIALS, ACM TRANSACTIONS ON
C MATHEMATICAL SOFTWARE, MARCH 1981).
C
C   AN EXTENDED-RANGE NUMBER  (X,IX)  IS SAID TO BE IN ADJUSTED FORM IF
C X AND IX ARE ZERO OR
C
C           RADIX**(-L) .LE. ABS(X) .LT. RADIX**L
C
C IS SATISFIED, WHERE L IS A COMPUTER-DEPENDENT INTEGER DEFINED IN THIS
C SUBROUTINE. TWO EXTENDED-RANGE NUMBERS IN ADJUSTED FORM CAN BE ADDED,
C SUBTRACTED, MULTIPLIED OR DIVIDED (IF THE DIVISOR IS NONZERO) WITHOUT
C CAUSING OVERFLOW OR UNDERFLOW IN THE PRINCIPAL PART OF THE RESULT.
C WITH PROPER USE OF THE EXTENDED-RANGE SUBROUTINES, THE ONLY OVERFLOW
C THAT CAN OCCUR IS INTEGER OVERFLOW IN THE AUXILIARY INDEX. IF THIS
C IS DETECTED, THE SOFTWARE CALLS XERROR (A GENERAL ERROR-HANDLING
C FORTRAN SUBROUTINE PACKAGE).
C
C   MULTIPLICATION AND DIVISION IS PERFORMED BY SETTING
C
C                 (X,IX)*(Y,IY) = (X*Y,IX+IY)
C OR
C                 (X,IX)/(Y,IY) = (X/Y,IX-IY).
C
C PRE-ADJUSTMENT OF THE OPERANDS IS ESSENTIAL TO AVOID
C OVERFLOW OR  UNDERFLOW OF THE PRINCIPAL PART. SUBROUTINE
C DXADJ (SEE BELOW) MAY BE CALLED TO TRANSFORM ANY EXTENDED-
C RANGE NUMBER INTO ADJUSTED FORM.
C
C   ADDITION AND SUBTRACTION REQUIRE THE USE OF SUBROUTINE DXADD
C (SEE BELOW).  THE INPUT OPERANDS NEED NOT BE IN ADJUSTED FORM.
C HOWEVER, THE RESULT OF ADDITION OR SUBTRACTION IS RETURNED
C IN ADJUSTED FORM.  THUS, FOR EXAMPLE, IF (X,IX),(Y,IY),
C (U,IU),  AND (V,IV) ARE IN ADJUSTED FORM, THEN
C
C                 (X,IX)*(Y,IY) + (U,IU)*(V,IV)
C
C CAN BE COMPUTED AND STORED IN ADJUSTED FORM WITH NO EXPLICIT
C CALLS TO DXADJ.
C
C   WHEN AN EXTENDED-RANGE NUMBER IS TO BE PRINTED, IT MUST BE
C CONVERTED TO AN EXTENDED-RANGE FORM WITH DECIMAL RADIX.  SUBROUTINE
C DXCON IS PROVIDED FOR THIS PURPOSE.
C
C   THE SUBROUTINES CONTAINED IN THIS PACKAGE ARE
C
C     SUBROUTINE DXADD
C USAGE
C                  CALL DXADD(X,IX,Y,IY,Z,IZ,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  FORMS THE EXTENDED-RANGE SUM  (Z,IZ) =
C                  (X,IX) + (Y,IY).  (Z,IZ) IS ADJUSTED
C                  BEFORE RETURNING. THE INPUT OPERANDS
C                  NEED NOT BE IN ADJUSTED FORM, BUT THEIR
C                  PRINCIPAL PARTS MUST SATISFY
C                  RADIX**(-2L).LE.ABS(X).LE.RADIX**(2L),
C                  RADIX**(-2L).LE.ABS(Y).LE.RADIX**(2L).
C
C     SUBROUTINE DXADJ
C USAGE
C                  CALL DXADJ(X,IX,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  TRANSFORMS (X,IX) SO THAT
C                  RADIX**(-L) .LE. ABS(X) .LT. RADIX**L.
C                  ON MOST COMPUTERS THIS TRANSFORMATION DOES
C                  NOT CHANGE THE MANTISSA OF X PROVIDED RADIX IS
C                  THE NUMBER BASE OF DOUBLE-PRECISION ARITHMETIC.
C
C     SUBROUTINE DXC210
C USAGE
C                  CALL DXC210(K,Z,J,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  GIVEN K THIS SUBROUTINE COMPUTES J AND Z
C                  SUCH THAT  RADIX**K = Z*10**J, WHERE Z IS IN
C                  THE RANGE 1/10 .LE. Z .LT. 1.
C                  THE VALUE OF Z WILL BE ACCURATE TO FULL
C                  DOUBLE-PRECISION PROVIDED THE NUMBER
C                  OF DECIMAL PLACES IN THE LARGEST
C                  INTEGER PLUS THE NUMBER OF DECIMAL
C                  PLACES CARRIED IN DOUBLE-PRECISION DOES NOT
C                  EXCEED 60. DXC210 IS CALLED BY SUBROUTINE
C                  DXCON WHEN NECESSARY. THE USER SHOULD
C                  NEVER NEED TO CALL DXC210 DIRECTLY.
C
C     SUBROUTINE DXCON
C USAGE
C                  CALL DXCON(X,IX,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  CONVERTS (X,IX) = X*RADIX**IX
C                  TO DECIMAL FORM IN PREPARATION FOR
C                  PRINTING, SO THAT (X,IX) = X*10**IX
C                  WHERE 1/10 .LE. ABS(X) .LT. 1
C                  IS RETURNED, EXCEPT THAT IF
C                  (ABS(X),IX) IS BETWEEN RADIX**(-2L)
C                  AND RADIX**(2L) THEN THE REDUCED
C                  FORM WITH IX = 0 IS RETURNED.
C
C     SUBROUTINE DXRED
C USAGE
C                  CALL DXRED(X,IX,IERROR)
C                  IF (IERROR.NE.0) RETURN
C DESCRIPTION
C                  IF
C                  RADIX**(-2L) .LE. (ABS(X),IX) .LE. RADIX**(2L)
C                  THEN DXRED TRANSFORMS (X,IX) SO THAT IX=0.
C                  IF (X,IX) IS OUTSIDE THE ABOVE RANGE,
C                  THEN DXRED TAKES NO ACTION.
C                  THIS SUBROUTINE IS USEFUL IF THE
C                  RESULTS OF EXTENDED-RANGE CALCULATIONS
C                  ARE TO BE USED IN SUBSEQUENT ORDINARY
C                  DOUBLE-PRECISION CALCULATIONS.
C
C***REFERENCES  Smith, Olver and Lozier, Extended-Range Arithmetic and
C                 Normalized Legendre Polynomials, ACM Trans on Math
C                 Softw, v 7, n 1, March 1981, pp 93--105.
C***ROUTINES CALLED  I1MACH, XERMSG
C***COMMON BLOCKS    DXBLK1, DXBLK2, DXBLK3
C***REVISION HISTORY  (YYMMDD)
C   820712  DATE WRITTEN
C   881020  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C           Corrected order of sections in prologue and added TYPE
C           section.  (WRB)
C           CALLs to XERROR changed to CALLs to XERMSG.  (WRB)
C   920127  Revised PURPOSE section of prologue.  (DWL)
C***END PROLOGUE  DXSET
      INTEGER IRAD, NRADPL, NBITS
      DOUBLE PRECISION DZERO, DZEROX
      COMMON /DXBLK1/ NBITSF
      SAVE /DXBLK1/
      DOUBLE PRECISION RADIX, RADIXL, RAD2L, DLG10R
      INTEGER L, L2, KMAX
      COMMON /DXBLK2/ RADIX, RADIXL, RAD2L, DLG10R, L, L2, KMAX
      SAVE /DXBLK2/
      INTEGER NLG102, MLG102, LG102
      COMMON /DXBLK3/ NLG102, MLG102, LG102(21)
      SAVE /DXBLK3/
      INTEGER IFLAG
      SAVE IFLAG
C
      DIMENSION LOG102(20), LGTEMP(20)
      SAVE LOG102
C
C   LOG102 CONTAINS THE FIRST 60 DIGITS OF LOG10(2) FOR USE IN
C CONVERSION OF EXTENDED-RANGE NUMBERS TO BASE 10 .
      DATA LOG102 /301,029,995,663,981,195,213,738,894,724,493,026,768,
     * 189,881,462,108,541,310,428/
C
C FOLLOWING CODING PREVENTS DXSET FROM BEING EXECUTED MORE THAN ONCE.
C THIS IS IMPORTANT BECAUSE SOME SUBROUTINES (SUCH AS DXNRMP AND
C DXLEGF) CALL DXSET TO MAKE SURE EXTENDED-RANGE ARITHMETIC HAS
C BEEN INITIALIZED. THE USER MAY WANT TO PRE-EMPT THIS CALL, FOR
C EXAMPLE WHEN I1MACH IS NOT AVAILABLE. SEE CODING BELOW.
      DATA IFLAG /0/
C***FIRST EXECUTABLE STATEMENT  DXSET
      IERROR=0
      IF (IFLAG .NE. 0) RETURN
      IRADX = IRAD
      NRDPLC = NRADPL
      DZEROX = DZERO
      IMINEX = 0
      IMAXEX = 0
      NBITSX = NBITS
C FOLLOWING 5 STATEMENTS SHOULD BE DELETED IF I1MACH IS
C NOT AVAILABLE OR NOT CONFIGURED TO RETURN THE CORRECT
C MACHINE-DEPENDENT VALUES.
      IF (IRADX .EQ. 0) IRADX = I1MACH (10)
      IF (NRDPLC .EQ. 0) NRDPLC = I1MACH (14)
      IF (DZEROX .EQ. 0.0D0) IMINEX = I1MACH (15)
      IF (DZEROX .EQ. 0.0D0) IMAXEX = I1MACH (16)
      IF (NBITSX .EQ. 0) NBITSX = I1MACH (8)
      IF (IRADX.EQ.2) GO TO 10
      IF (IRADX.EQ.4) GO TO 10
      IF (IRADX.EQ.8) GO TO 10
      IF (IRADX.EQ.16) GO TO 10
      CALL XERMSG ('SLATEC', 'DXSET', 'IMPROPER VALUE OF IRAD', 201, 1)
      IERROR=201
      RETURN
   10 CONTINUE
      LOG2R=0
      IF (IRADX.EQ.2) LOG2R = 1
      IF (IRADX.EQ.4) LOG2R = 2
      IF (IRADX.EQ.8) LOG2R = 3
      IF (IRADX.EQ.16) LOG2R = 4
      NBITSF=LOG2R*NRDPLC
      RADIX = IRADX
      DLG10R = LOG10(RADIX)
      IF (DZEROX .NE. 0.0D0) GO TO 14
      LX = MIN ((1-IMINEX)/2, (IMAXEX-1)/2)
      GO TO 16
   14 LX = 0.5D0*LOG10(DZEROX)/DLG10R
C RADIX**(2*L) SHOULD NOT OVERFLOW, BUT REDUCE L BY 1 FOR FURTHER
C PROTECTION.
      LX=LX-1
   16 L2 = 2*LX
      IF (LX.GE.4) GO TO 20
      CALL XERMSG ('SLATEC', 'DXSET', 'IMPROPER VALUE OF DZERO', 202, 1)
      IERROR=202
      RETURN
   20 L = LX
      RADIXL = RADIX**L
      RAD2L = RADIXL**2
C    IT IS NECESSARY TO RESTRICT NBITS (OR NBITSX) TO BE LESS THAN SOME
C UPPER LIMIT BECAUSE OF BINARY-TO-DECIMAL CONVERSION. SUCH CONVERSION
C IS DONE BY DXC210 AND REQUIRES A CONSTANT THAT IS STORED TO SOME FIXED
C PRECISION. THE STORED CONSTANT (LOG102 IN THIS ROUTINE) PROVIDES
C FOR CONVERSIONS ACCURATE TO THE LAST DECIMAL DIGIT WHEN THE INTEGER
C WORD LENGTH DOES NOT EXCEED 63. A LOWER LIMIT OF 15 BITS IS IMPOSED
C BECAUSE THE SOFTWARE IS DESIGNED TO RUN ON COMPUTERS WITH INTEGER WORD
C LENGTH OF AT LEAST 16 BITS.
      IF (15.LE.NBITSX .AND. NBITSX.LE.63) GO TO 30
      CALL XERMSG ('SLATEC', 'DXSET', 'IMPROPER VALUE OF NBITS', 203, 1)
      IERROR=203
      RETURN
   30 CONTINUE
      KMAX = 2**(NBITSX-1) - L2
      NB = (NBITSX-1)/2
      MLG102 = 2**NB
      IF (1.LE.NRDPLC*LOG2R .AND. NRDPLC*LOG2R.LE.120) GO TO 40
      CALL XERMSG ('SLATEC', 'DXSET', 'IMPROPER VALUE OF NRADPL', 204,
     +             1)
      IERROR=204
      RETURN
   40 CONTINUE
      NLG102 = NRDPLC*LOG2R/NB + 3
      NP1 = NLG102 + 1
C
C   AFTER COMPLETION OF THE FOLLOWING LOOP, IC CONTAINS
C THE INTEGER PART AND LGTEMP CONTAINS THE FRACTIONAL PART
C OF LOG10(IRADX) IN RADIX 1000.
      IC = 0
      DO 50 II=1,20
        I = 21 - II
        IT = LOG2R*LOG102(I) + IC
        IC = IT/1000
        LGTEMP(I) = MOD(IT,1000)
   50 CONTINUE
C
C   AFTER COMPLETION OF THE FOLLOWING LOOP, LG102 CONTAINS
C LOG10(IRADX) IN RADIX MLG102. THE RADIX POINT IS
C BETWEEN LG102(1) AND LG102(2).
      LG102(1) = IC
      DO 80 I=2,NP1
        LG102X = 0
        DO 70 J=1,NB
          IC = 0
          DO 60 KK=1,20
            K = 21 - KK
            IT = 2*LGTEMP(K) + IC
            IC = IT/1000
            LGTEMP(K) = MOD(IT,1000)
   60     CONTINUE
          LG102X = 2*LG102X + IC
   70   CONTINUE
        LG102(I) = LG102X
   80 CONTINUE
C
C CHECK SPECIAL CONDITIONS REQUIRED BY SUBROUTINES...
      IF (NRDPLC.LT.L) GO TO 90
      CALL XERMSG ('SLATEC', 'DXSET', 'NRADPL .GE. L', 205, 1)
      IERROR=205
      RETURN
   90 IF (6*L.LE.KMAX) GO TO 100
      CALL XERMSG ('SLATEC', 'DXSET', '6*L .GT. KMAX', 206, 1)
      IERROR=206
      RETURN
  100 CONTINUE
      IFLAG = 1
      RETURN
      END
*DECK DY
      SUBROUTINE DY (U, IDMN, I, J, UYYY, UYYYY)
C***BEGIN PROLOGUE  DY
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPELI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (DY-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This program computes second order finite difference
C     approximations to the third and fourth Y
C     partial derivatives of U at the (I,J) mesh point.
C
C***SEE ALSO  SEPELI
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    SPLPCM
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  DY
C
      COMMON /SPLPCM/ KSWX       ,KSWY       ,K          ,L          ,
     1                AIT        ,BIT        ,CIT        ,DIT        ,
     2                MIT        ,NIT        ,IS         ,MS         ,
     3                JS         ,NS         ,DLX        ,DLY        ,
     4                TDLX3      ,TDLY3      ,DLX4       ,DLY4
      DIMENSION       U(IDMN,*)
C***FIRST EXECUTABLE STATEMENT  DY
      IF (J.GT.2 .AND. J.LT.(L-1)) GO TO  50
      IF (J .EQ. 1) GO TO  10
      IF (J .EQ. 2) GO TO  30
      IF (J .EQ. L-1) GO TO  60
      IF (J .EQ. L) GO TO  80
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT Y=C
C
   10 IF (KSWY .EQ. 1) GO TO  20
      UYYY = (-5.0*U(I,1)+18.0*U(I,2)-24.0*U(I,3)+14.0*U(I,4)-
     1                                                 3.0*U(I,5))/TDLY3
      UYYYY = (3.0*U(I,1)-14.0*U(I,2)+26.0*U(I,3)-24.0*U(I,4)+
     1                                      11.0*U(I,5)-2.0*U(I,6))/DLY4
      RETURN
C
C     PERIODIC AT X=A
C
   20 UYYY = (-U(I,L-2)+2.0*U(I,L-1)-2.0*U(I,2)+U(I,3))/TDLY3
      UYYYY = (U(I,L-2)-4.0*U(I,L-1)+6.0*U(I,1)-4.0*U(I,2)+U(I,3))/DLY4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT Y=C+DLY
C
   30 IF (KSWY .EQ. 1) GO TO  40
      UYYY = (-3.0*U(I,1)+10.0*U(I,2)-12.0*U(I,3)+6.0*U(I,4)-U(I,5))/
     1       TDLY3
      UYYYY = (2.0*U(I,1)-9.0*U(I,2)+16.0*U(I,3)-14.0*U(I,4)+6.0*U(I,5)-
     1                                                      U(I,6))/DLY4
      RETURN
C
C     PERIODIC AT Y=C+DLY
C
   40 UYYY = (-U(I,L-1)+2.0*U(I,1)-2.0*U(I,3)+U(I,4))/TDLY3
      UYYYY = (U(I,L-1)-4.0*U(I,1)+6.0*U(I,2)-4.0*U(I,3)+U(I,4))/DLY4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS ON THE INTERIOR
C
   50 CONTINUE
      UYYY = (-U(I,J-2)+2.0*U(I,J-1)-2.0*U(I,J+1)+U(I,J+2))/TDLY3
      UYYYY = (U(I,J-2)-4.0*U(I,J-1)+6.0*U(I,J)-4.0*U(I,J+1)+U(I,J+2))/
     1        DLY4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT Y=D-DLY
C
   60 IF (KSWY .EQ. 1) GO TO  70
      UYYY = (U(I,L-4)-6.0*U(I,L-3)+12.0*U(I,L-2)-10.0*U(I,L-1)+
     1                                                 3.0*U(I,L))/TDLY3
      UYYYY = (-U(I,L-5)+6.0*U(I,L-4)-14.0*U(I,L-3)+16.0*U(I,L-2)-
     1                                     9.0*U(I,L-1)+2.0*U(I,L))/DLY4
      RETURN
C
C     PERIODIC AT Y=D-DLY
C
   70 CONTINUE
      UYYY = (-U(I,L-3)+2.0*U(I,L-2)-2.0*U(I,1)+U(I,2))/TDLY3
      UYYYY = (U(I,L-3)-4.0*U(I,L-2)+6.0*U(I,L-1)-4.0*U(I,1)+U(I,2))/
     1        DLY4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT Y=D
C
   80 UYYY = -(3.0*U(I,L-4)-14.0*U(I,L-3)+24.0*U(I,L-2)-18.0*U(I,L-1)+
     1                                                 5.0*U(I,L))/TDLY3
      UYYYY = (-2.0*U(I,L-5)+11.0*U(I,L-4)-24.0*U(I,L-3)+26.0*U(I,L-2)-
     1                                    14.0*U(I,L-1)+3.0*U(I,L))/DLY4
      RETURN
      END
*DECK DY4
      SUBROUTINE DY4 (U, IDMN, I, J, UYYY, UYYYY)
C***BEGIN PROLOGUE  DY4
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPX4
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (DY4-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This program computes second order finite difference
C     approximations to the third and fourth Y
C     partial derivatives of U at the (I,J) mesh point.
C
C***SEE ALSO  SEPX4
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    SPL4
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  DY4
C
      COMMON /SPL4/   KSWX       ,KSWY       ,K          ,L          ,
     1                AIT        ,BIT        ,CIT        ,DIT        ,
     2                MIT        ,NIT        ,IS         ,MS         ,
     3                JS         ,NS         ,DLX        ,DLY        ,
     4                TDLX3      ,TDLY3      ,DLX4       ,DLY4
      DIMENSION       U(IDMN,*)
C***FIRST EXECUTABLE STATEMENT  DY4
      IF (J.GT.2 .AND. J.LT.(L-1)) GO TO  50
      IF (J .EQ. 1) GO TO  10
      IF (J .EQ. 2) GO TO  30
      IF (J .EQ. L-1) GO TO  60
      IF (J .EQ. L) GO TO  80
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT Y=C
C
   10 IF (KSWY .EQ. 1) GO TO  20
      UYYY = (-5.0*U(I,1)+18.0*U(I,2)-24.0*U(I,3)+14.0*U(I,4)-
     1                                                 3.0*U(I,5))/TDLY3
      UYYYY = (3.0*U(I,1)-14.0*U(I,2)+26.0*U(I,3)-24.0*U(I,4)+
     1                                      11.0*U(I,5)-2.0*U(I,6))/DLY4
      RETURN
C
C     PERIODIC AT X=A
C
   20 UYYY = (-U(I,L-2)+2.0*U(I,L-1)-2.0*U(I,2)+U(I,3))/TDLY3
      UYYYY = (U(I,L-2)-4.0*U(I,L-1)+6.0*U(I,1)-4.0*U(I,2)+U(I,3))/DLY4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT Y=C+DLY
C
   30 IF (KSWY .EQ. 1) GO TO  40
      UYYY = (-3.0*U(I,1)+10.0*U(I,2)-12.0*U(I,3)+6.0*U(I,4)-U(I,5))/
     1       TDLY3
      UYYYY = (2.0*U(I,1)-9.0*U(I,2)+16.0*U(I,3)-14.0*U(I,4)+6.0*U(I,5)-
     1                                                      U(I,6))/DLY4
      RETURN
C
C     PERIODIC AT Y=C+DLY
C
   40 UYYY = (-U(I,L-1)+2.0*U(I,1)-2.0*U(I,3)+U(I,4))/TDLY3
      UYYYY = (U(I,L-1)-4.0*U(I,1)+6.0*U(I,2)-4.0*U(I,3)+U(I,4))/DLY4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS ON THE INTERIOR
C
   50 CONTINUE
      UYYY = (-U(I,J-2)+2.0*U(I,J-1)-2.0*U(I,J+1)+U(I,J+2))/TDLY3
      UYYYY = (U(I,J-2)-4.0*U(I,J-1)+6.0*U(I,J)-4.0*U(I,J+1)+U(I,J+2))/
     1        DLY4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT Y=D-DLY
C
   60 IF (KSWY .EQ. 1) GO TO  70
      UYYY = (U(I,L-4)-6.0*U(I,L-3)+12.0*U(I,L-2)-10.0*U(I,L-1)+
     1                                                 3.0*U(I,L))/TDLY3
      UYYYY = (-U(I,L-5)+6.0*U(I,L-4)-14.0*U(I,L-3)+16.0*U(I,L-2)-
     1                                     9.0*U(I,L-1)+2.0*U(I,L))/DLY4
      RETURN
C
C     PERIODIC AT Y=D-DLY
C
   70 CONTINUE
      UYYY = (-U(I,L-3)+2.0*U(I,L-2)-2.0*U(I,1)+U(I,2))/TDLY3
      UYYYY = (U(I,L-3)-4.0*U(I,L-2)+6.0*U(I,L-1)-4.0*U(I,1)+U(I,2))/
     1        DLY4
      RETURN
C
C     COMPUTE PARTIAL DERIVATIVE APPROXIMATIONS AT Y=D
C
   80 UYYY = -(3.0*U(I,L-4)-14.0*U(I,L-3)+24.0*U(I,L-2)-18.0*U(I,L-1)+
     1                                                 5.0*U(I,L))/TDLY3
      UYYYY = (-2.0*U(I,L-5)+11.0*U(I,L-4)-24.0*U(I,L-3)+26.0*U(I,L-2)-
     1                                    14.0*U(I,L-1)+3.0*U(I,L))/DLY4
      RETURN
      END
*DECK DYAIRY
      SUBROUTINE DYAIRY (X, RX, C, BI, DBI)
C***BEGIN PROLOGUE  DYAIRY
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBESJ and DBESY
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (YAIRY-S, DYAIRY-D)
C***AUTHOR  Amos, D. E., (SNLA)
C           Daniel, S. L., (SNLA)
C***DESCRIPTION
C
C                  DYAIRY computes the Airy function BI(X)
C                   and its derivative DBI(X) for DASYJY
C
C                                     INPUT
C
C         X  - Argument, computed by DASYJY, X unrestricted
C        RX  - RX=SQRT(ABS(X)), computed by DASYJY
C         C  - C=2.*(ABS(X)**1.5)/3., computed by DASYJY
C
C                                    OUTPUT
C        BI  - Value of function BI(X)
C       DBI  - Value of the derivative DBI(X)
C
C***SEE ALSO  DBESJ, DBESY
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR section.  (WRB)
C***END PROLOGUE  DYAIRY
C
      INTEGER I, J, M1, M1D, M2, M2D, M3, M3D, M4D, N1, N1D, N2, N2D,
     1 N3, N3D, N4D
      DOUBLE PRECISION AA,AX,BB,BI,BJN,BJP,BK1,BK2,BK3,BK4,C,CON1,CON2,
     1 CON3, CV, DAA, DBB, DBI, DBJN, DBJP, DBK1, DBK2, DBK3, DBK4, D1,
     2 D2, EX, E1, E2, FPI12, F1, F2, RTRX, RX, SPI12, S1, S2, T, TC,
     3 TEMP1, TEMP2, TT, X
      DIMENSION BK1(20), BK2(20), BK3(20), BK4(14)
      DIMENSION BJP(19), BJN(19), AA(14), BB(14)
      DIMENSION DBK1(21), DBK2(20), DBK3(20), DBK4(14)
      DIMENSION DBJP(19), DBJN(19), DAA(14), DBB(14)
      SAVE N1, N2, N3, M1, M2, M3, N1D, N2D, N3D, N4D,
     1 M1D, M2D, M3D, M4D, FPI12, SPI12, CON1, CON2, CON3,
     2 BK1, BK2, BK3, BK4, BJN, BJP, AA, BB, DBK1, DBK2, DBK3, DBK4,
     3 DBJP, DBJN, DAA, DBB
      DATA N1,N2,N3/20,19,14/
      DATA M1,M2,M3/18,17,12/
      DATA N1D,N2D,N3D,N4D/21,20,19,14/
      DATA M1D,M2D,M3D,M4D/19,18,17,12/
      DATA FPI12,SPI12,CON1,CON2,CON3/
     1 1.30899693899575D+00, 1.83259571459405D+00, 6.66666666666667D-01,
     2 7.74148278841779D+00, 3.64766105490356D-01/
      DATA BK1(1),  BK1(2),  BK1(3),  BK1(4),  BK1(5),  BK1(6),
     1     BK1(7),  BK1(8),  BK1(9),  BK1(10), BK1(11), BK1(12),
     2     BK1(13), BK1(14), BK1(15), BK1(16), BK1(17), BK1(18),
     3     BK1(19), BK1(20)/ 2.43202846447449D+00, 2.57132009754685D+00,
     4 1.02802341258616D+00, 3.41958178205872D-01, 8.41978629889284D-02,
     5 1.93877282587962D-02, 3.92687837130335D-03, 6.83302689948043D-04,
     6 1.14611403991141D-04, 1.74195138337086D-05, 2.41223620956355D-06,
     7 3.24525591983273D-07, 4.03509798540183D-08, 4.70875059642296D-09,
     8 5.35367432585889D-10, 5.70606721846334D-11, 5.80526363709933D-12,
     9 5.76338988616388D-13, 5.42103834518071D-14, 4.91857330301677D-15/
      DATA BK2(1),  BK2(2),  BK2(3),  BK2(4),  BK2(5),  BK2(6),
     1     BK2(7),  BK2(8),  BK2(9),  BK2(10), BK2(11), BK2(12),
     2     BK2(13), BK2(14), BK2(15), BK2(16), BK2(17), BK2(18),
     3     BK2(19), BK2(20)/ 5.74830555784088D-01,-6.91648648376891D-03,
     4 1.97460263052093D-03,-5.24043043868823D-04, 1.22965147239661D-04,
     5-2.27059514462173D-05, 2.23575555008526D-06, 4.15174955023899D-07,
     6-2.84985752198231D-07, 8.50187174775435D-08,-1.70400826891326D-08,
     7 2.25479746746889D-09,-1.09524166577443D-10,-3.41063845099711D-11,
     8 1.11262893886662D-11,-1.75542944241734D-12, 1.36298600401767D-13,
     9 8.76342105755664D-15,-4.64063099157041D-15, 7.78772758732960D-16/
      DATA BK3(1),  BK3(2),  BK3(3),  BK3(4),  BK3(5),  BK3(6),
     1     BK3(7),  BK3(8),  BK3(9),  BK3(10), BK3(11), BK3(12),
     2     BK3(13), BK3(14), BK3(15), BK3(16), BK3(17), BK3(18),
     3     BK3(19), BK3(20)/ 5.66777053506912D-01, 2.63672828349579D-03,
     4 5.12303351473130D-05, 2.10229231564492D-06, 1.42217095113890D-07,
     5 1.28534295891264D-08, 7.28556219407507D-10,-3.45236157301011D-10,
     6-2.11919115912724D-10,-6.56803892922376D-11,-8.14873160315074D-12,
     7 3.03177845632183D-12, 1.73447220554115D-12, 1.67935548701554D-13,
     8-1.49622868806719D-13,-5.15470458953407D-14, 8.75741841857830D-15,
     9 7.96735553525720D-15,-1.29566137861742D-16,-1.11878794417520D-15/
      DATA BK4(1),  BK4(2),  BK4(3),  BK4(4),  BK4(5),  BK4(6),
     1     BK4(7),  BK4(8),  BK4(9),  BK4(10), BK4(11), BK4(12),
     2     BK4(13), BK4(14)/ 4.85444386705114D-01,-3.08525088408463D-03,
     3 6.98748404837928D-05,-2.82757234179768D-06, 1.59553313064138D-07,
     4-1.12980692144601D-08, 9.47671515498754D-10,-9.08301736026423D-11,
     5 9.70776206450724D-12,-1.13687527254574D-12, 1.43982917533415D-13,
     6-1.95211019558815D-14, 2.81056379909357D-15,-4.26916444775176D-16/
      DATA BJP(1),  BJP(2),  BJP(3),  BJP(4),  BJP(5),  BJP(6),
     1     BJP(7),  BJP(8),  BJP(9),  BJP(10), BJP(11), BJP(12),
     2     BJP(13), BJP(14), BJP(15), BJP(16), BJP(17), BJP(18),
     3     BJP(19)         / 1.34918611457638D-01,-3.19314588205813D-01,
     4 5.22061946276114D-02, 5.28869112170312D-02,-8.58100756077350D-03,
     5-2.99211002025555D-03, 4.21126741969759D-04, 8.73931830369273D-05,
     6-1.06749163477533D-05,-1.56575097259349D-06, 1.68051151983999D-07,
     7 1.89901103638691D-08,-1.81374004961922D-09,-1.66339134593739D-10,
     8 1.42956335780810D-11, 1.10179811626595D-12,-8.60187724192263D-14,
     9-5.71248177285064D-15, 4.08414552853803D-16/
      DATA BJN(1),  BJN(2),  BJN(3),  BJN(4),  BJN(5),  BJN(6),
     1     BJN(7),  BJN(8),  BJN(9),  BJN(10), BJN(11), BJN(12),
     2     BJN(13), BJN(14), BJN(15), BJN(16), BJN(17), BJN(18),
     3     BJN(19)         / 6.59041673525697D-02,-4.24905910566004D-01,
     4 2.87209745195830D-01, 1.29787771099606D-01,-4.56354317590358D-02,
     5-1.02630175982540D-02, 2.50704671521101D-03, 3.78127183743483D-04,
     6-7.11287583284084D-05,-8.08651210688923D-06, 1.23879531273285D-06,
     7 1.13096815867279D-07,-1.46234283176310D-08,-1.11576315688077D-09,
     8 1.24846618243897D-10, 8.18334132555274D-12,-8.07174877048484D-13,
     9-4.63778618766425D-14, 4.09043399081631D-15/
      DATA AA(1),   AA(2),   AA(3),   AA(4),   AA(5),   AA(6),
     1     AA(7),   AA(8),   AA(9),   AA(10),  AA(11),  AA(12),
     2     AA(13),  AA(14) /-2.78593552803079D-01, 3.52915691882584D-03,
     3 2.31149677384994D-05,-4.71317842263560D-06, 1.12415907931333D-07,
     4 2.00100301184339D-08,-2.60948075302193D-09, 3.55098136101216D-11,
     5 3.50849978423875D-11,-5.83007187954202D-12, 2.04644828753326D-13,
     6 1.10529179476742D-13,-2.87724778038775D-14, 2.88205111009939D-15/
      DATA BB(1),   BB(2),   BB(3),   BB(4),   BB(5),   BB(6),
     1     BB(7),   BB(8),   BB(9),   BB(10),  BB(11),  BB(12),
     2     BB(13),  BB(14) /-4.90275424742791D-01,-1.57647277946204D-03,
     3 9.66195963140306D-05,-1.35916080268815D-07,-2.98157342654859D-07,
     4 1.86824767559979D-08, 1.03685737667141D-09,-3.28660818434328D-10,
     5 2.57091410632780D-11, 2.32357655300677D-12,-9.57523279048255D-13,
     6 1.20340828049719D-13, 2.90907716770715D-15,-4.55656454580149D-15/
      DATA DBK1(1), DBK1(2), DBK1(3), DBK1(4), DBK1(5), DBK1(6),
     1     DBK1(7), DBK1(8), DBK1(9), DBK1(10),DBK1(11),DBK1(12),
     2     DBK1(13),DBK1(14),DBK1(15),DBK1(16),DBK1(17),DBK1(18),
     3     DBK1(19),DBK1(20),
     4     DBK1(21)        / 2.95926143981893D+00, 3.86774568440103D+00,
     5 1.80441072356289D+00, 5.78070764125328D-01, 1.63011468174708D-01,
     6 3.92044409961855D-02, 7.90964210433812D-03, 1.50640863167338D-03,
     7 2.56651976920042D-04, 3.93826605867715D-05, 5.81097771463818D-06,
     8 7.86881233754659D-07, 9.93272957325739D-08, 1.21424205575107D-08,
     9 1.38528332697707D-09, 1.50190067586758D-10, 1.58271945457594D-11,
     1 1.57531847699042D-12, 1.50774055398181D-13, 1.40594335806564D-14,
     2 1.24942698777218D-15/
      DATA DBK2(1), DBK2(2), DBK2(3), DBK2(4), DBK2(5), DBK2(6),
     1     DBK2(7), DBK2(8), DBK2(9), DBK2(10),DBK2(11),DBK2(12),
     2     DBK2(13),DBK2(14),DBK2(15),DBK2(16),DBK2(17),DBK2(18),
     3    DBK2(19),DBK2(20)/ 5.49756809432471D-01, 9.13556983276901D-03,
     4-2.53635048605507D-03, 6.60423795342054D-04,-1.55217243135416D-04,
     5 3.00090325448633D-05,-3.76454339467348D-06,-1.33291331611616D-07,
     6 2.42587371049013D-07,-8.07861075240228D-08, 1.71092818861193D-08,
     7-2.41087357570599D-09, 1.53910848162371D-10, 2.56465373190630D-11,
     8-9.88581911653212D-12, 1.60877986412631D-12,-1.20952524741739D-13,
     9-1.06978278410820D-14, 5.02478557067561D-15,-8.68986130935886D-16/
      DATA DBK3(1), DBK3(2), DBK3(3), DBK3(4), DBK3(5), DBK3(6),
     1     DBK3(7), DBK3(8), DBK3(9), DBK3(10),DBK3(11),DBK3(12),
     2     DBK3(13),DBK3(14),DBK3(15),DBK3(16),DBK3(17),DBK3(18),
     3    DBK3(19),DBK3(20)/ 5.60598509354302D-01,-3.64870013248135D-03,
     4-5.98147152307417D-05,-2.33611595253625D-06,-1.64571516521436D-07,
     5-2.06333012920569D-08,-4.27745431573110D-09,-1.08494137799276D-09,
     6-2.37207188872763D-10,-2.22132920864966D-11, 1.07238008032138D-11,
     7 5.71954845245808D-12, 7.51102737777835D-13,-3.81912369483793D-13,
     8-1.75870057119257D-13, 6.69641694419084D-15, 2.26866724792055D-14,
     9 2.69898141356743D-15,-2.67133612397359D-15,-6.54121403165269D-16/
      DATA DBK4(1), DBK4(2), DBK4(3), DBK4(4), DBK4(5), DBK4(6),
     1     DBK4(7), DBK4(8), DBK4(9), DBK4(10),DBK4(11),DBK4(12),
     2    DBK4(13),DBK4(14)/ 4.93072999188036D-01, 4.38335419803815D-03,
     3-8.37413882246205D-05, 3.20268810484632D-06,-1.75661979548270D-07,
     4 1.22269906524508D-08,-1.01381314366052D-09, 9.63639784237475D-11,
     5-1.02344993379648D-11, 1.19264576554355D-12,-1.50443899103287D-13,
     6 2.03299052379349D-14,-2.91890652008292D-15, 4.42322081975475D-16/
      DATA DBJP(1), DBJP(2), DBJP(3), DBJP(4), DBJP(5), DBJP(6),
     1     DBJP(7), DBJP(8), DBJP(9), DBJP(10),DBJP(11),DBJP(12),
     2     DBJP(13),DBJP(14),DBJP(15),DBJP(16),DBJP(17),DBJP(18),
     3     DBJP(19)        / 1.13140872390745D-01,-2.08301511416328D-01,
     4 1.69396341953138D-02, 2.90895212478621D-02,-3.41467131311549D-03,
     5-1.46455339197417D-03, 1.63313272898517D-04, 3.91145328922162D-05,
     6-3.96757190808119D-06,-6.51846913772395D-07, 5.98707495269280D-08,
     7 7.44108654536549D-09,-6.21241056522632D-10,-6.18768017313526D-11,
     8 4.72323484752324D-12, 3.91652459802532D-13,-2.74985937845226D-14,
     9-1.95036497762750D-15, 1.26669643809444D-16/
      DATA DBJN(1), DBJN(2), DBJN(3), DBJN(4), DBJN(5), DBJN(6),
     1     DBJN(7), DBJN(8), DBJN(9), DBJN(10),DBJN(11),DBJN(12),
     2     DBJN(13),DBJN(14),DBJN(15),DBJN(16),DBJN(17),DBJN(18),
     3     DBJN(19)        /-1.88091260068850D-02,-1.47798180826140D-01,
     4 5.46075900433171D-01, 1.52146932663116D-01,-9.58260412266886D-02,
     5-1.63102731696130D-02, 5.75364806680105D-03, 7.12145408252655D-04,
     6-1.75452116846724D-04,-1.71063171685128D-05, 3.24435580631680D-06,
     7 2.61190663932884D-07,-4.03026865912779D-08,-2.76435165853895D-09,
     8 3.59687929062312D-10, 2.14953308456051D-11,-2.41849311903901D-12,
     9-1.28068004920751D-13, 1.26939834401773D-14/
      DATA DAA(1),  DAA(2),  DAA(3),  DAA(4),  DAA(5),  DAA(6),
     1     DAA(7),  DAA(8),  DAA(9),  DAA(10), DAA(11), DAA(12),
     2     DAA(13), DAA(14)/ 2.77571356944231D-01,-4.44212833419920D-03,
     3 8.42328522190089D-05, 2.58040318418710D-06,-3.42389720217621D-07,
     4 6.24286894709776D-09, 2.36377836844577D-09,-3.16991042656673D-10,
     5 4.40995691658191D-12, 5.18674221093575D-12,-9.64874015137022D-13,
     6 4.90190576608710D-14, 1.77253430678112D-14,-5.55950610442662D-15/
      DATA DBB(1),  DBB(2),  DBB(3),  DBB(4),  DBB(5),  DBB(6),
     1     DBB(7),  DBB(8),  DBB(9),  DBB(10), DBB(11), DBB(12),
     2     DBB(13), DBB(14)/ 4.91627321104601D-01, 3.11164930427489D-03,
     3 8.23140762854081D-05,-4.61769776172142D-06,-6.13158880534626D-08,
     4 2.87295804656520D-08,-1.81959715372117D-09,-1.44752826642035D-10,
     5 4.53724043420422D-11,-3.99655065847223D-12,-3.24089119830323D-13,
     6 1.62098952568741D-13,-2.40765247974057D-14, 1.69384811284491D-16/
C***FIRST EXECUTABLE STATEMENT  DYAIRY
      AX = ABS(X)
      RX = SQRT(AX)
      C = CON1*AX*RX
      IF (X.LT.0.0D0) GO TO 120
      IF (C.GT.8.0D0) GO TO 60
      IF (X.GT.2.5D0) GO TO 30
      T = (X+X-2.5D0)*0.4D0
      TT = T + T
      J = N1
      F1 = BK1(J)
      F2 = 0.0D0
      DO 10 I=1,M1
        J = J - 1
        TEMP1 = F1
        F1 = TT*F1 - F2 + BK1(J)
        F2 = TEMP1
   10 CONTINUE
      BI = T*F1 - F2 + BK1(1)
      J = N1D
      F1 = DBK1(J)
      F2 = 0.0D0
      DO 20 I=1,M1D
        J = J - 1
        TEMP1 = F1
        F1 = TT*F1 - F2 + DBK1(J)
        F2 = TEMP1
   20 CONTINUE
      DBI = T*F1 - F2 + DBK1(1)
      RETURN
   30 CONTINUE
      RTRX = SQRT(RX)
      T = (X+X-CON2)*CON3
      TT = T + T
      J = N1
      F1 = BK2(J)
      F2 = 0.0D0
      DO 40 I=1,M1
        J = J - 1
        TEMP1 = F1
        F1 = TT*F1 - F2 + BK2(J)
        F2 = TEMP1
   40 CONTINUE
      BI = (T*F1-F2+BK2(1))/RTRX
      EX = EXP(C)
      BI = BI*EX
      J = N2D
      F1 = DBK2(J)
      F2 = 0.0D0
      DO 50 I=1,M2D
        J = J - 1
        TEMP1 = F1
        F1 = TT*F1 - F2 + DBK2(J)
        F2 = TEMP1
   50 CONTINUE
      DBI = (T*F1-F2+DBK2(1))*RTRX
      DBI = DBI*EX
      RETURN
C
   60 CONTINUE
      RTRX = SQRT(RX)
      T = 16.0D0/C - 1.0D0
      TT = T + T
      J = N1
      F1 = BK3(J)
      F2 = 0.0D0
      DO 70 I=1,M1
        J = J - 1
        TEMP1 = F1
        F1 = TT*F1 - F2 + BK3(J)
        F2 = TEMP1
   70 CONTINUE
      S1 = T*F1 - F2 + BK3(1)
      J = N2D
      F1 = DBK3(J)
      F2 = 0.0D0
      DO 80 I=1,M2D
        J = J - 1
        TEMP1 = F1
        F1 = TT*F1 - F2 + DBK3(J)
        F2 = TEMP1
   80 CONTINUE
      D1 = T*F1 - F2 + DBK3(1)
      TC = C + C
      EX = EXP(C)
      IF (TC.GT.35.0D0) GO TO 110
      T = 10.0D0/C - 1.0D0
      TT = T + T
      J = N3
      F1 = BK4(J)
      F2 = 0.0D0
      DO 90 I=1,M3
        J = J - 1
        TEMP1 = F1
        F1 = TT*F1 - F2 + BK4(J)
        F2 = TEMP1
   90 CONTINUE
      S2 = T*F1 - F2 + BK4(1)
      BI = (S1+EXP(-TC)*S2)/RTRX
      BI = BI*EX
      J = N4D
      F1 = DBK4(J)
      F2 = 0.0D0
      DO 100 I=1,M4D
        J = J - 1
        TEMP1 = F1
        F1 = TT*F1 - F2 + DBK4(J)
        F2 = TEMP1
  100 CONTINUE
      D2 = T*F1 - F2 + DBK4(1)
      DBI = RTRX*(D1+EXP(-TC)*D2)
      DBI = DBI*EX
      RETURN
  110 BI = EX*S1/RTRX
      DBI = EX*RTRX*D1
      RETURN
C
  120 CONTINUE
      IF (C.GT.5.0D0) GO TO 150
      T = 0.4D0*C - 1.0D0
      TT = T + T
      J = N2
      F1 = BJP(J)
      E1 = BJN(J)
      F2 = 0.0D0
      E2 = 0.0D0
      DO 130 I=1,M2
        J = J - 1
        TEMP1 = F1
        TEMP2 = E1
        F1 = TT*F1 - F2 + BJP(J)
        E1 = TT*E1 - E2 + BJN(J)
        F2 = TEMP1
        E2 = TEMP2
  130 CONTINUE
      BI = (T*E1-E2+BJN(1)) - AX*(T*F1-F2+BJP(1))
      J = N3D
      F1 = DBJP(J)
      E1 = DBJN(J)
      F2 = 0.0D0
      E2 = 0.0D0
      DO 140 I=1,M3D
        J = J - 1
        TEMP1 = F1
        TEMP2 = E1
        F1 = TT*F1 - F2 + DBJP(J)
        E1 = TT*E1 - E2 + DBJN(J)
        F2 = TEMP1
        E2 = TEMP2
  140 CONTINUE
      DBI = X*X*(T*F1-F2+DBJP(1)) + (T*E1-E2+DBJN(1))
      RETURN
C
  150 CONTINUE
      RTRX = SQRT(RX)
      T = 10.0D0/C - 1.0D0
      TT = T + T
      J = N3
      F1 = AA(J)
      E1 = BB(J)
      F2 = 0.0D0
      E2 = 0.0D0
      DO 160 I=1,M3
        J = J - 1
        TEMP1 = F1
        TEMP2 = E1
        F1 = TT*F1 - F2 + AA(J)
        E1 = TT*E1 - E2 + BB(J)
        F2 = TEMP1
        E2 = TEMP2
  160 CONTINUE
      TEMP1 = T*F1 - F2 + AA(1)
      TEMP2 = T*E1 - E2 + BB(1)
      CV = C - FPI12
      BI = (TEMP1*COS(CV)+TEMP2*SIN(CV))/RTRX
      J = N4D
      F1 = DAA(J)
      E1 = DBB(J)
      F2 = 0.0D0
      E2 = 0.0D0
      DO 170 I=1,M4D
        J = J - 1
        TEMP1 = F1
        TEMP2 = E1
        F1 = TT*F1 - F2 + DAA(J)
        E1 = TT*E1 - E2 + DBB(J)
        F2 = TEMP1
        E2 = TEMP2
  170 CONTINUE
      TEMP1 = T*F1 - F2 + DAA(1)
      TEMP2 = T*E1 - E2 + DBB(1)
      CV = C - SPI12
      DBI = (TEMP1*COS(CV)-TEMP2*SIN(CV))*RTRX
      RETURN
      END

subroutine midsinus(obs,fit,ifatal,liter)
  use gildas_def
  use sinus_parameter
  use class_data
  use gkernel_interfaces
  use fit_minuit
  !-------------------------------------------------------------------
  ! @ private
  ! Start a BASE SINUS fit by building the par array and internal
  ! variable used by minuit
  ! IFATAL basically not used
  !-------------------------------------------------------------------
  type(observation) , intent(in)    :: obs    !
  type(fit_minuit_t), intent(inout) :: fit    ! Fitting variables
  logical,            intent(in)    :: liter  ! Iterate a fit
  integer(kind=4),    intent(out)   :: ifatal ! Number of fatal errors
  ! Local
  integer(kind=4) :: i,k
  real(kind=8) :: sav,sav2,vplu,vminu
  !
  fit%isw    = 0
  fit%sigma  = 0.d0
  fit%npfix  = 0
  fit%nu     = 0
  fit%npar   = 0
  ifatal = 0
  do i= 1, fit%maxext
     fit%u(i)       = 0.0d0
     fit%lcode(i)   = 0
     fit%lcorsp (i) = 0
  enddo
  fit%isw(5) = 1
  fit%data = locwrd(obs)
  !
  ! Output initial guesses
  if (fit%verbose) then
     write(6,1000) par(1),par(2),par(3)
  endif
  !
  ! set up parameters for major variables
  !
  ! amplitude
  fit%u(1)    = par(1)
  fit%alim(1) = 0.0d0
  fit%blim(1) = 1.0d10
  fit%werr(1) = 0.2*sigbas
  fit%lcode(1) = 4
  !
  ! period
  fit%u(2)    = par(2)
  fit%alim(2) = deltav
  fit%blim(2) = max(float(4*obs%cnchan)*deltav,par(2))
  fit%werr(2) = sqrt(float(obs%cnchan))*deltav
  fit%lcode(2) = 4
  !
  ! phase
  fit%u(3)    = par(3)
  fit%alim(3) = 0.0d0
  fit%blim(3) = max(fit%blim(2),dble(par(3)))
  fit%werr(3) = fit%werr(2)
  fit%lcode(3) = 4
  !
  ! slope
  fit%u(4) = par(4)
  fit%werr(4) = sigbas/(obs%cnchan*deltav)
  fit%lcode(4) = 1
  !
  ! offset
  fit%u(5) = par(5)
  fit%werr(5) = sigbas
  fit%lcode(5) = 1
  !
  ! o.k. start
  ! calculate step sizes dirin
  fit%npar = 0
  fit%nu = 5
  do k= 1, fit%nu
     if (fit%lcode(k) .gt. 0)  then
        fit%npar = fit%npar + 1
        fit%lcorsp(k) = fit%npar
        sav = fit%u(k)
        fit%x(fit%npar) = pintf(fit,sav,k)
        fit%xt(fit%npar) = fit%x(fit%npar)
        sav2 = sav + fit%werr(k)
        vplu = pintf(fit,sav2,k) - fit%x(fit%npar)
        sav2 = sav - fit%werr(k)
        vminu = pintf(fit,sav2,k) - fit%x(fit%npar)
        fit%dirin(fit%npar) = 0.5d0 * (abs(vplu) +abs(vminu))
     endif
  enddo
  !
1000 format(' Input parameters :  ',f8.3,'    ',f8.3,'    ',f8.3)
end subroutine midsinus

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_pixprop_types
  use cubetools_parameters
  use cubefield_messaging
  !
  public :: pixcoor_t,pixprop_t
  private
  !
  type pixcoor_t
     real(kind=coor_k) :: x = 0.0
     real(kind=coor_k) :: y = 0.0
  end type pixcoor_t
  !
  type :: pixprop_t
     integer(kind=pixe_k), public :: ix = 0
     integer(kind=pixe_k), public :: iy = 0
   contains
     generic,   public  :: list       => list_short,list_long
     procedure, private :: list_short => pixprop_list_short
     procedure, private :: list_long  => pixprop_list_long
  end type pixprop_t
  !
contains
  !
  subroutine pixprop_list_short(pix,error)
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    class(pixprop_t), intent(in)    :: pix
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='PIXPROP>LIST>SHORT'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    print *,pix%ix,pix%iy
  end subroutine pixprop_list_short
  !
  subroutine pixprop_list_long(pix,name,image,error)
    use phys_const
    use cubeadm_image_types
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    class(pixprop_t), intent(in)    :: pix
    character(len=*), intent(in)    :: name
    type(image_t),    intent(in)    :: image
    logical,          intent(inout) :: error
    !
    real(kind=coor_k) :: x,y
    character(len=*), parameter :: rname='PIXPROP>LIST>LONG'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call image%x%pixel2offset(pix%ix,x,error)
    if (error) return
    call image%y%pixel2offset(pix%iy,y,error)
    if (error) return
    print *,trim(name),pix%ix,x*sec_per_rad,pix%iy,y*sec_per_rad
  end subroutine pixprop_list_long
end module cubefield_pixprop_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_pixlist_types
  use cubetools_parameters
  use cubetools_array_types
  use cubeadm_image_types
  use cubefield_messaging
  use cubefield_pixprop_types
  !
  public :: pixlist_t
  private
  !
  type :: pixlist_t
     character(len=name_l),  private :: name = strg_unk               ! List name
     integer(kind=indx_k),   public  :: m = 0                         ! Allocated number of list items 
     integer(kind=indx_k),   public  :: n = 0                         ! Current   number of list items 
     type(pixprop_t),        public, pointer :: prop(:) => null()     ! List address
     integer(kind=code_k),   private :: pointeris = code_pointer_null ! Null, allocated, or associated?
     type(image_t), pointer, private :: image => null()               ! Associated image
     type(long_2d_t),        private :: ilist                         ! ilist(ix,iy)
   contains
     procedure, public :: init          => pixlist_init
     procedure, public :: enlarge       => pixlist_enlarge
     procedure, public :: reallocate    => pixlist_reallocate
     procedure, public :: free          => pixlist_free
     final             :: pixlist_final
     !
     procedure, public :: get_next_from           => pixlist_get_next_from
     procedure, public :: put_label_into_image    => pixlist_put_label_into_image
     procedure, public :: get_good_from_image     => pixlist_get_good_from_image
     procedure, public :: check_all_are_good      => pixlist_check_all_are_good
     procedure, public :: pixel_already_processed => pixlist_pixel_already_processed
     procedure, public :: mark_pixel_as_processed => pixlist_mark_pixel_as_processed
     procedure, public :: max                     => pixlist_max
     procedure, public :: list                    => pixlist_list
  end type pixlist_t
  !
contains
  !
  subroutine pixlist_init(list,name,image,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(pixlist_t), intent(out)   :: list
    character(len=*), intent(in)    :: name
    type(image_t),    intent(in)    :: image
    logical,          intent(inout) :: error
    !
    integer(kind=indx_k), parameter :: ninit = 128
    character(len=*), parameter :: rname='PIXLIST>INIT'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    if (list%pointeris.eq.code_pointer_null) then
       call list%reallocate(name,ninit,image,error)
       if (error) return
    else if (list%pointeris.ne.code_pointer_associated) then
       call cubefield_message(seve%e,rname,'Unallocated pointer => Can not use it for a growing list!')
       error = .true.
       return
    endif
    list%n = 0
  end subroutine pixlist_init
  !
  subroutine pixlist_enlarge(list,error)
    use gkernel_interfaces
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    class(pixlist_t), intent(inout) :: list
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=indx_k) :: mold,mnew
    type(pixprop_t), allocatable :: tmp(:)
    character(len=*), parameter :: rname='PIXLIST>ENLARGE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    ! Sanity checks
    if (list%pointeris.ne.code_pointer_allocated) then
       call cubefield_message(seve%e,rname,'Unallocated pointer => Can not enlarge it!')
       error = .true.
       return
    endif
    mold = list%m
    mnew = 2*mold
    if (mold.le.0) then
       call cubefield_message(seve%e,rname,'Negative or zero number of list items => Can not enlarge it!')
       error = .true.
      return
    endif
    !
    allocate(tmp(mold),stat=ier)
    if (failed_allocate(rname,'tmp',ier,error)) return
    tmp(1:mold) = list%prop(1:mold)
    !
    if (associated(list%prop)) deallocate(list%prop)
    allocate(list%prop(mnew),stat=ier)
    if (failed_allocate(rname,trim(list%name)//' pixlist',ier,error)) return
    list%m = mnew
    !
    list%prop(1:mold) = tmp(1:mold)
  end subroutine pixlist_enlarge
  !
  subroutine pixlist_reallocate(list,name,m,image,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(pixlist_t),      intent(inout) :: list
    character(len=*),      intent(in)    :: name
    integer(kind=indx_k),  intent(in)    :: m
    type(image_t), target, intent(in)    :: image
    logical,               intent(inout) :: error
    !
    logical :: alloc
    integer(kind=4) :: ier
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PIXLIST>REALLOCATE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (m.le.0) then
       call cubefield_message(seve%e,rname,'Negative or zero number of list items')
       error = .true.
      return
    endif
    !
    if (list%pointeris.eq.code_pointer_allocated) then
       ! The request is to get an allocated pointer
       if (list%m.eq.m) then
          write(mess,'(a,a,i0)')  &
               name,' pixlist already allocated at the right size: ',m
          call cubefield_message(fieldseve%alloc,rname,mess)
          alloc = .false.
       else
          write(mess,'(a,a,a)') 'Pointer ',name,  &
               ' pixlist already allocated but with a different size => Freeing it first'
          call cubefield_message(fieldseve%alloc,rname,mess)
          call pixlist_free(list)
          alloc = .true.
       endif
    else
       ! list%prop is either null or associated => need to allocate it anyway
       alloc = .true.
    endif
    if (alloc) then
       allocate(list%prop(m),stat=ier)
       if (failed_allocate(rname,trim(name)//' pixlist',ier,error)) return
    endif
    ! Allocation success => list%pointeris may be updated
    list%pointeris = code_pointer_allocated
    list%m = m
    list%n = m
    ! Complete with image related array
    list%image => image
    call list%ilist%reallocate(trim(name)//' ilist',image%nx,image%ny,error)
    if (error) return
  end subroutine pixlist_reallocate
  !
  subroutine pixlist_prepare_association(list,name,m,error)
    !----------------------------------------------------------------------
    ! Prepare for the next reassociation
    !----------------------------------------------------------------------
    class(pixlist_t),     intent(inout) :: list
    character(len=*),     intent(in)    :: name
    integer(kind=indx_k), intent(in)    :: m
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PIXLIST>PREPARE>ASSOCIATION'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (m.le.0) then
       call cubefield_message(seve%e,rname,'Negative or zero number of pixels')
       error = .true.
      return
    endif
    !
    ! The request is to get a null pointer without memory leak => Free when needed.
    call list%free()
    ! Association success => list%code_pointer may be updated
    list%name = name
    list%m = m
    list%n = m
    list%pointeris = code_pointer_null
  end subroutine pixlist_prepare_association
  !
  subroutine pixlist_free(list)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(pixlist_t), intent(inout) :: list
    !
    character(len=*), parameter :: rname='PIXLIST>FREE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    if (list%pointeris.eq.code_pointer_allocated) then
       if (associated(list%prop)) deallocate(list%prop)
    else
       list%prop => null()
    endif
    list%name = strg_unk
    list%m = 0
    list%n = 0
    list%pointeris = code_pointer_null
    list%image => null()
  end subroutine pixlist_free
  !
  subroutine pixlist_final(list)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(pixlist_t), intent(inout) :: list
    !
    call pixlist_free(list)
  end subroutine pixlist_final
  !
  !------------------------------------------------------------------------
  !
  subroutine pixlist_get_next_from(list,prop,error)
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    class(pixlist_t), intent(inout) :: list
    type(pixprop_t),  intent(in)    :: prop
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='PIXLIST>GET>NEXT>FROM'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    list%n = list%n+1
    if (list%n.gt.list%m) then
       call list%enlarge(error)
       if (error) return
    endif
    list%prop(list%n) = prop
  end subroutine pixlist_get_next_from
  !
  subroutine pixlist_get_good_from_image(list,image,error)
    use cubetools_nan
    !---------------------------------------------------------------------
    ! Go from a 2D image to a 1D list of good pixels
    !---------------------------------------------------------------------
    class(pixlist_t), intent(inout) :: list
    type(image_t),    intent(in)    :: image
    logical,          intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    integer(kind=indx_k) :: ngood,ilist
    character(len=*), parameter :: rname='PIXLIST>GET>GOOD>FROM>IMAGE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call image%ngood(ngood,error)
    if (error) return
    call list%reallocate('good pixel',ngood,image,error)
    if (error) return
    call list%ilist%set(0_8,error)
    if (error) return
    !
    ilist = 0
    do iy=1,image%ny
       do ix=1,image%nx
          if (isnan(image%val(ix,iy))) cycle
          ilist = ilist+1
          if (ilist.le.list%n) then
             list%prop(ilist)%ix = ix
             list%prop(ilist)%iy = iy
             list%ilist%val(ix,iy) = ilist
          else
             call cubefield_message(seve%e,rname,'Internal error: ilist > list%n')
             print *,ilist,list%n
             error = .true.
             return
          endif
       enddo ! ix
    enddo ! iy
    ! Sanity check
    if (ilist.ne.list%n) then
       call cubefield_message(seve%e,rname,'Internal error: ilist /= list%n')
       print *,ilist,list%n
       error = .true.
       return
    endif
  end subroutine pixlist_get_good_from_image
  !
  subroutine pixlist_put_label_into_image(list,label,image,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(pixlist_t), target, intent(in)    :: list
    real(kind=sign_k),        intent(in)    :: label
    type(image_t),            intent(inout) :: image
    logical,                  intent(inout) :: error
    !
    integer(kind=indx_k) :: ilist
    integer(kind=pixe_k), pointer :: ix,iy
    character(len=*), parameter :: rname='PIXLIST>PUT>LABEL>INTO>IMAGE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    do ilist=1,list%n
       ix => list%prop(ilist)%ix
       iy => list%prop(ilist)%iy
       if (image%contain(ix,iy)) then
          image%val(ix,iy) = label
       else
          call cubefield_message(seve%e,rname,'Pixel outside image!')
          call list%prop(ilist)%list(error)
          error = .true.
          return
       endif
    enddo ! ilist
  end subroutine pixlist_put_label_into_image
  !
  subroutine pixlist_check_all_are_good(list,error)
    use cubetools_nan
    !---------------------------------------------------------------------
    ! Sanity check to debug!
    !---------------------------------------------------------------------
    class(pixlist_t), intent(in)    :: list
    logical,          intent(inout) :: error
    !
    integer(kind=indx_k) :: ilist
    integer(kind=pixe_k), pointer :: ix,iy
    real(kind=sign_k), pointer :: val
    character(len=*), parameter :: rname='PIXLIST>CHECK>ALL>ARE>GOOD'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    do ilist=1,list%n
       ix => list%prop(ilist)%ix
       iy => list%prop(ilist)%iy
       val => list%image%val(ix,iy)
       if (isnan(val)) then
          print *,"Inconsitent pixel list at: ",ilist,list%n,list%m,ix,iy,val
          error = .true.
          return
       endif
    enddo ! ilist
  end subroutine pixlist_check_all_are_good
  !
  subroutine pixlist_mark_pixel_as_processed(list,pix,error)
    !---------------------------------------------------------------------
    ! Replace the item associated with pixel (ix,iy) by the last one,
    ! update the associated ilist backpointer, and decrease the number of items
    ! by one. Updating the image associated to the list is *not* part of
    ! the job of this subroutine!
    !---------------------------------------------------------------------
    class(pixlist_t), intent(inout) :: list
    type(pixprop_t),  intent(in)    :: pix
    logical,          intent(inout) :: error
    !
    integer(kind=indx_k), pointer :: ilist
    character(len=*), parameter :: rname='PIXLIST>MARK>PIXEL>AS>PROCESSED'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    ilist => list%ilist%val(pix%ix,pix%iy)
    if (ilist.le.list%n) then
       ! Replacement by last list item required
       list%prop(ilist)%ix = list%prop(list%n)%ix
       list%prop(ilist)%iy = list%prop(list%n)%iy
       list%ilist%val(list%prop(ilist)%ix,list%prop(ilist)%iy) = ilist
       ! Remove pixel from active part of list
       list%prop(list%n)%ix = pix%ix
       list%prop(list%n)%iy = pix%iy
       list%ilist%val(pix%ix,pix%iy) = list%n
       list%n = list%n-1
    endif
  end subroutine pixlist_mark_pixel_as_processed
  !
  function pixlist_pixel_already_processed(list,pix) result(processed)
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    class(pixlist_t), intent(in) :: list
    type(pixprop_t),  intent(in) :: pix
    logical                      :: processed ! intent(out)
    !
    character(len=*), parameter :: rname='PIXLIST>PIXEL>ALREADY>PROCESSED'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    processed = list%ilist%val(pix%ix,pix%iy).gt.list%n    
  end function pixlist_pixel_already_processed
  !
  subroutine pixlist_max(list,ixmax,iymax,valmax,found)
    !---------------------------------------------------------------------
    ! Find position of image maximum in the list of selected pixels
    !---------------------------------------------------------------------
    class(pixlist_t),     intent(in)  :: list
    integer(kind=pixe_k), intent(out) :: ixmax
    integer(kind=pixe_k), intent(out) :: iymax
    real(kind=sign_k),    intent(out) :: valmax
    logical,              intent(out) :: found
    !
    integer(kind=indx_k) :: ilist,ilistmax
    real(kind=sign_k), pointer :: val
    character(len=*), parameter :: rname='PIXLIST>MAX'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    valmax = -huge(valmax)
    do ilist=1,list%n
       val => list%image%val(list%prop(ilist)%ix,list%prop(ilist)%iy)
       if (val.gt.valmax) then
          valmax = val
          ilistmax = ilist
          endif
    enddo ! ilist
    found = valmax.ne.-huge(valmax)
    if (found) then
       ixmax = list%prop(ilistmax)%ix
       iymax = list%prop(ilistmax)%iy
    else
       ixmax = 0
       iymax = 0
    endif
  end subroutine pixlist_max
  !
  subroutine pixlist_list(list,error)
    !------------------------------------------------------------------
    !
    !------------------------------------------------------------------
    class(pixlist_t), intent(inout) :: list
    logical,          intent(inout) :: error
    !
    integer(kind=indx_k) :: ilist
    character(len=mess_l) :: name
    character(len=*), parameter :: rname='PIXLIST>LIST'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    do ilist=1,list%n
       write(name,'(i0)') ilist
       call list%prop(ilist)%list(name,list%image,error)
       if (error) return
    enddo ! ipix
  end subroutine pixlist_list
end module cubefield_pixlist_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_pixel_types
  use cubefield_pixprop_types
  use cubefield_pixlist_types
  !
  public :: pixcoor_t,pixprop_t,pixlist_t
  private
end module cubefield_pixel_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!***JP: The cubeset_plot_tool module should probably be moved into a
!***JP: specific core/plot library that deals with the interface with
!***JP: outside plotting libraries.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_plot_tool
  use cubetools_parameters
  use cubeset_messaging
  !
  public :: pane_k
  public :: code_x,code_y
  public :: plot
  private 
  !
  integer(kind=4), parameter :: pane_k = 4
  !-------------------------------------------------------------------
  integer(kind=code_k), parameter :: code_x = 1
  integer(kind=code_k), parameter :: code_y = 2
  !-------------------------------------------------------------------
  !
  type plot_prog_t
   contains
     procedure, public :: togreg               => cubeset_plot_prog_togreg !***JP: Temporarily put it public
     procedure, public :: get_pagesize         => cubeset_plot_prog_get_pagesize
     procedure, public :: put_image_into_rg    => cubeset_plot_prog_put_image_into_rg
     procedure, public :: put_spectrum_into_xy => cubeset_plot_prog_put_spectrum_into_xy
     procedure, public :: box                  => cubeset_plot_prog_box
     procedure, public :: viewport             => cubeset_plot_prog_set_viewport
  end type plot_prog_t
  type(plot_prog_t) :: plot
  !
contains
  !
  subroutine cubeset_plot_prog_togreg(prog,commline,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Spawn a GREG command and return the error status
    !-------------------------------------------------------------------
    class(plot_prog_t), intent(in)    :: prog
    character(len=*),   intent(in)    :: commline
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='PLOT>PROG>TOGREG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call gr_exec(commline)
    error = gr_error()
    if (error) then
       call cubeset_message(seve%e,rname,'Error when spawning the GREG command:')
       call cubeset_message(seve%e,rname,commline)
       return
    endif
  end subroutine cubeset_plot_prog_togreg
  !
  subroutine cubeset_plot_prog_get_pagesize(prog,size)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Get page geometry from GREG
    !-------------------------------------------------------------------
    class(plot_prog_t), intent(in)  :: prog
    real(kind=pane_k),  intent(out) :: size(2)
    !
    character(len=*), parameter :: rname='PLOT>PROG>GET>PAGESIZE'
    ! 
    call gr_get_physical(size(code_x),size(code_y))
  end subroutine cubeset_plot_prog_get_pagesize
  !
  subroutine cubeset_plot_prog_put_image_into_rg(prog,head,data,error)
    use gkernel_interfaces
    use cubetools_unit
    use cubetools_axis_types
    use cubetools_header_types
    use cubetools_header_methods
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(plot_prog_t),  intent(in)    :: prog
    type(cube_header_t), intent(in)    :: head
    real(kind=sign_k),   intent(in)    :: data(:,:)
    logical,             intent(inout) :: error
    !
    logical :: iswcs 
    integer(kind=4) :: nx,ny ! Here nx and ny are int*4 because of the interfaces with gkernel
    real(kind=coor_k) :: conv(6),proj(3)
    type(axis_t) :: axis
    character(len=*), parameter :: rname='PLOT>PROG>PUT>IMAGE>INTO>RG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    ! Give data to RG
    call cubetools_header_get_axis_head_l(head,axis,error)
    if (error) return
    iswcs = axis%kind.eq.code_unit_fov
    nx = axis%n
    conv(1:3) = axis%conv
    call cubetools_header_get_axis_head_m(head,axis,error)
    if (error) return    
    iswcs = iswcs.and.(axis%kind.eq.code_unit_fov)
    ny = axis%n
    conv(4:6) = axis%conv
    call gr4_tgive(nx,ny,conv,data)
    !
    ! Define blanking, since now we use NaNs bval=0 and eval=-1
    call gr8_blanking(0.d0,-1.d0)
    !
    if (iswcs) then
       ! Pass coordinate System
       call gr8_system(head%spa%fra%code,error,head%spa%fra%equinox)
       ! Pass projection
       proj(1) = head%spa%pro%l0
       proj(2) = head%spa%pro%m0
       proj(3) = head%spa%pro%pa
       call greg_projec(head%spa%pro%code,proj)
    else
       continue
    endif
  end subroutine cubeset_plot_prog_put_image_into_rg
  !
  subroutine cubeset_plot_prog_put_spectrum_into_xy(prog,head,data,error)
    use cubetools_header_types
    use cubetools_header_methods
    use cubetools_axis_types
    use cubetools_userspace
    use cubetools_uservar
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(plot_prog_t),  intent(in)    :: prog
    type(cube_header_t), intent(in)    :: head
    real(kind=sign_k),   intent(in)    :: data(:)
    logical,             intent(inout) :: error
    !
    type(axis_t) :: caxis
    type(uservar_t) :: xbuff,ybuff
    logical, parameter :: global = .true.
    logical, parameter :: overwrite = .true.
    character(len=*), parameter :: rname='PLOT>PROG>PUT>SPECTRUM>INTO>XY'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_axis_head_c(head,caxis,error)
    if (error) return
    call xbuff%create('x',global,overwrite_prog,error)
    if (error) return
    call ybuff%create('y',global,overwrite_prog,error)
    if (error) return
    !
    call xbuff%set(caxis%coord,error)
    if (error) return
    call ybuff%set(data,error)
    if (error) return    
  end subroutine cubeset_plot_prog_put_spectrum_into_xy
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeset_plot_prog_box(prog,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(plot_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='PLOT>PROG>BOX'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call plot%togreg('box n n n',error)
    if (error) return
  end subroutine cubeset_plot_prog_box
  !
  subroutine cubeset_plot_prog_set_viewport(prog,min,max,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(plot_prog_t), intent(in)    :: prog
    real(kind=pane_k),  intent(in)    :: min(2)
    real(kind=pane_k),  intent(in)    :: max(2)
    logical,            intent(inout) :: error
    !
    character(len=clin_l) :: commline
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PLOT>PROG>SET>VIEWPORT'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (any(min.lt.0.0).or.any(max.gt.1.0)) then
       write(mess,'(a,4f5.1)') 'Desired viewport is set beyond bounds: ',&
            min(code_x),max(code_x),min(code_y),max(code_y)
       call cubeset_message(seve%e,rname,mess)
       call cubeset_message(seve%e,rname,'Limits are: 0.0 1.0 0.0 1.0')
       error = .true.
       return
    endif
    write(commline,'(A,4(1X,1PG14.7))')&
         'SET VIEWPORT',&
         min(code_x),max(code_x),&
         min(code_y),max(code_y)
    call plot%togreg(commline,error)
    if (error) return
  end subroutine cubeset_plot_prog_set_viewport
end module cubeset_plot_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_plot_page_tool
  use cubetools_parameters
  use cubeset_messaging
  use cubeset_plot_tool
  !
  public :: plot_page_geometry_user_t
  private
  !
  integer(kind=code_k), parameter :: code_page_landscape = 1
  integer(kind=code_k), parameter :: code_page_portrait  = 2
  !
  type plot_page_geometry_user_t
     integer(kind=code_k), public :: geo = code_page_landscape ! By default page is in landscape
     real(kind=pane_k),    public :: size(2) = 0.0             !
     real(kind=pane_k),    public :: aspect = 0.0              ! 
   contains
     procedure, public :: get_geometry => cubeset_plot_page_user_get_geometry
  end type plot_page_geometry_user_t
  !
contains
  !
  subroutine cubeset_plot_page_user_get_geometry(user,error)
    !-------------------------------------------------------------------
    ! Get page geometry
    !-------------------------------------------------------------------
    class(plot_page_geometry_user_t), intent(inout) :: user
    logical,                          intent(inout) :: error
    !
    character(len=mess_l) :: mess
    real(kind=pane_k), parameter :: ga4landscape = 1.42857146  ! GILDAS A4 landscape
    real(kind=pane_k), parameter :: ga4portrait  = 0.699999988 ! GILDAS A4 portrait
    character(len=*),  parameter :: rname='PLOT>PAGE>USER>GET>GEOMETRY'
    !
    call plot%get_pagesize(user%size)
    !
    user%aspect = user%size(code_x)/user%size(code_y)
    if (user%aspect.le.0) then
       call cubeset_message(seve%e,rname,' Page Aspect is zero or negative')
       error = .true.
       return
    else if (user%aspect.ge.1) then
       ! This case includes the square case
       user%geo = code_page_landscape
    else if (user%aspect.lt.1) then
       user%geo = code_page_portrait
    else ! user%aspect .eq. NAN +-inf
       write(mess,'(a,f8.3,a,f8.3)') 'Nonsense page size: ',user%size(code_x),'x',user%size(code_y)
       call cubeset_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    if (user%aspect.ne.ga4landscape.and.user%aspect.ne.ga4portrait) then
       write(mess,'(a,f8.3,a,f8.3,a)') 'Page size: ',user%size(code_x),'x',user%size(code_y),&
            ' is not 21x30 or 30x21, plots may set out of bounds'
       call cubeset_message(seve%w,rname,mess)
    endif
  end subroutine cubeset_plot_page_user_get_geometry  
end module cubeset_plot_page_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine popup(set,line,error,user_function)
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>popup
  use class_parameter
  use class_popup
  use class_data
  use class_setup_new
  use class_types
  !----------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  ! POPUP [Number | OffX OffY]
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set           !
  character(len=*),    intent(in)  :: line          ! Input command line
  logical,             intent(out) :: error         ! Logical error flag
  logical,             external    :: user_function !
  ! Local
  character(len=*), parameter :: rname='POPUP'
  integer(kind=obsnum_length) :: jpop
  integer(kind=entry_length) :: kpop,i,imin(1)
  integer(kind=4) :: nc,nx,ny,jx,iy,ier
  real(kind=4) :: off1,off2,x,y
  real(kind=4), allocatable :: dist(:)
  character(len=60) :: argum
  character(len=1) :: ch
  character(len=80) :: chain
  !
  if (sic_narg(0).eq.1) then
     ! Popup with observation number as argument (any observation from IX)
     call sic_i8 (line,0,1,jpop,.true.,error)
     if (error) return
     call popup_full(set,jpop,user_function,error)
     if (error) return
     !
  elseif (sic_narg(0).eq.2 .and. cpop.eq.cpop_map) then
     ! Popup after a MAP /GRID command, with offset in command line
     call sic_ch(line,0,1,argum,nc,.true.,error)
     if (error) return
     call coffse(set,rname,argum,' ',off1,error)  ! NB: no syntax for custom angle unit
     if (error) return
     call sic_ch(line,0,2,argum,nc,.false.,error)
     if (error) return
     call coffse(set,rname,argum,' ',off2,error)
     if (error) return
     do i=1,npop
        if (abs(off1-xpop(i)).lt.set%tole .and.abs(off2-ypop(i)).lt.set%tole) then
           call popup_full(set,ipop(i),user_function,error)
           if (error) return
           return
        endif
     enddo
     call class_message(seve%e,rname,'No observation in range')
     error = .true.
     return
     !
  elseif (.not.gtg_curs()) then
     call class_message(seve%e,rname,'No cursor available')
     error = .true.
     return
     !
  elseif (cpop.eq.cpop_stamp) then
     ! Popup after a STAMP command: Get box number from the cursor
     ch = 'H'
     do
        if (ch.eq.'H') then
          call class_message(seve%i,rname,'Interactions with the STAMP plot:')
          call popup_usage('Observation number')
        endif
        call gtcurs(x,y,ch,error)
        if (error)  return
        call sic_upper(ch)
        nx = nint(pux2-pux1)
        ny = nint(puy2-puy1)
        x = (x-pgx1)*(pux2-pux1)/(pgx2-pgx1)+pux1
        y = (y-pgy1)*(puy2-puy1)/(pgy2-pgy1)+puy1
        jx = nint(x)
        iy = nint(y)
        kpop = jx+(iy-1)*nx
        if (ch.eq.'E' .or. ch.eq.'*') then
           exit
        elseif (jx.lt.1 .or. jx.gt.nx .or.  &
                iy.lt.1 .or. iy.gt.ny .or.  &
                kpop.gt.npop) then
           call class_message(seve%w,rname,'No spectrum here')
        elseif (ch.eq.'P' .or. ch.eq.'&') then
           call popup_full(set,ipop(kpop),user_function,error)
           if (error) return
        else
           write(chain,'(a,i0)') 'Observation # ',ipop(kpop)
           call class_message(seve%i,rname,chain)
        endif
     enddo
     !
  elseif (cpop.eq.cpop_plotindex) then
     ! Popup after a PLOT /INDEX command: Get spectrum number from the cursor
     ch = 'H'
     do
        if (ch.eq.'H') then
          call class_message(seve%i,rname,'Interactions with the PLOT /INDEX:')
          call popup_usage('Observation number')
        endif
        call gtcurs(x,y,ch,error)
        if (error)  return
        call sic_upper(ch)
        y = (y-pgz1)*(puz2-puz1)/(pgz2-pgz1)
        kpop = nint(y+puz1)  ! Entry number in the current index
        if (ch.eq.'E' .or. ch.eq.'*') then
           exit
        elseif (kpop.lt.1 .or. kpop.gt.npop) then
           call class_message(seve%w,rname,'No spectrum here')
        elseif (ch.eq.'P' .or. ch.eq.'&') then
           call popup_full(set,ipop(kpop),user_function,error)
           if (error) return
        elseif (ch.ne.'H') then
           write(chain,'(a,i0)') 'Observation # ',ipop(kpop)
           call class_message(seve%i,rname,chain)
        endif
     enddo
     !
  elseif (cpop.eq.cpop_map) then
     ! Popup after a MAP command: Get offset from the cursor
     ch = 'H'
     do
        if (ch.eq.'H') then
          call class_message(seve%i,rname,'Interactions with the MAP plot:')
          call popup_usage('Cursor position and nearest observation')
        endif
        call gtcurs(x,y,ch,error)
        if (error)  return
        call sic_upper(ch)
        nx = nint(pux2-pux1)
        ny = nint(puy2-puy1)
        off1 = (x-pgx1)*(pux2-pux1)/(pgx2-pgx1)+pux1
        off2 = (y-pgy1)*(puy2-puy1)/(pgy2-pgy1)+puy1
        write(chain,'(a,f9.2,f9.2)') 'Offsets ',off1*class_setup_get_fangle(),  &
                                                off2*class_setup_get_fangle()
        call class_message(seve%i,rname,chain)
        allocate(dist(npop),stat=ier)
        if (failed_allocate(rname,'dist array',ier,error))  return
        do i=1,npop
           dist(i) = (off1-xpop(i))**2 +  (off2-ypop(i))**2
        enddo
        imin = minloc(dist)
        deallocate(dist)
        i = imin(1)
        if (ch.eq.'E' .or. ch.eq.'*') then
           exit
        elseif (ch.eq.'P' .or. ch.eq.'&') then
           call popup_full(set,ipop(i),user_function,error)
           if (error) return
        else
           write(chain,'(a,f9.2,f9.2)') &
                'Nearest observation at ',xpop(i)*class_setup_get_fangle(),  &
                                          ypop(i)*class_setup_get_fangle()
           call class_message(seve%i,rname,chain)
        endif
     enddo
  else
     call class_message(seve%e,rname,  &
       'Invalid number of arguments or no previous PLOT /INDEX, STAMP, or MAP')
     error = .true.
     return
  endif
  !
contains
  subroutine popup_usage(anykey)
    character(len=*), intent(in) :: anykey
    call class_message(seve%r,rname,'   Left   click :  Observation number')
    call class_message(seve%r,rname,'   Middle click :  Popup window')
    call class_message(seve%r,rname,'   Right  click :  Exit')
    call class_message(seve%r,rname,'   Press any key:  '//anykey)
    call class_message(seve%r,rname,'   Press P key  :  Popup window')
    call class_message(seve%r,rname,'   Press H key  :  Display this help')
    call class_message(seve%r,rname,'   Press E key  :  Exit')
  end subroutine popup_usage
  !
end subroutine popup
!
subroutine popup_full(set,this_one,user_function,error)
  use gildas_def
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>popup_full
  use class_types
  use plot_formula
  !----------------------------------------------------------------------
  ! @ private
  !  Plot one observation in the <POPUP window
  !----------------------------------------------------------------------
  type(class_setup_t),         intent(in)    :: set            !
  integer(kind=obsnum_length), intent(in)    :: this_one       ! Obs. number
  logical,                     external      :: user_function  !
  logical,                     intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='POPUP'
  type(observation) :: obs
  character(len=80) :: cdir
  real(kind=4) :: x,y,expa,cdef,lx2,ly2
  !
  call init_obs(obs)
  call get_num(set,obs,this_one,0,user_function,error)
  if (error) return
  call abscissa(set,obs,error)
  if (error) return
  !
  call newlim(set,obs,error)
  if (error) return
  call get_box(gx1,gx2,gy1,gy2)
  !
  cdir(1:5) = 'GTVL'//char(92)
  if (.not.gtexist('<POPUP')) then
     cdir(6:) = 'CREATE DIRECTORY <POPUP'
     call exec_command(cdir,error)
     cdir(6:) = 'CHANGE DIRECTORY <POPUP'
     call exec_command(cdir,error)
     cdir(6:) = 'CHANGE POSITION 7'
     call exec_command(cdir,error)
  else
     cdir(6:) = 'CHANGE DIRECTORY <POPUP'
     call exec_command(cdir,error)
  endif
  cdir(6:) = 'CLEAR DIRECTORY'
  call exec_command(cdir,error)
  !
  ! Spectrum
  call spectr1d(rname,set,obs,error)
  if (error)  return
  !
  ! Box
  call class_box_default(set,.false.,obs,'Y',error)
  if (error)  return
  !
  ! Title
  call sic_get_real('PAGE_X',lx2,error)
  call sic_get_real('PAGE_Y',ly2,error)
  call sic_get_real('CHARACTER_SIZE',cdef,error)
  expa = 1.0
  x = lx2/2.0
  y = ly2-cdef*0.575*expa
  call out0('Graphic',x,y,error)
  call titout(set,obs%head,set%heade,'O')
  !
  cdir(6:) = 'CHANGE DIRECTORY <GREG'
  call exec_command(cdir,error)
  !
  call free_obs(obs)
end subroutine popup_full

subroutine class_minmax_r4_1d(rmin,rmax,a,na,rbad)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-generic class_minmax
  ! Compute MIN and MAX from a (section of) given array taking into
  ! account blanking values and NaN
  ! ---
  ! R*4 1D version
  !---------------------------------------------------------------------
  real(kind=4),    intent(out) :: rmin   ! Min value plus lower margin
  real(kind=4),    intent(out) :: rmax   ! Max value plus upper margin
  integer(kind=4), intent(in)  :: na     ! Number of values
  real(kind=4),    intent(in)  :: a(na)  ! Input array
  real(kind=4),    intent(in)  :: rbad   ! Bad channel value
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  real(kind=4) :: adiff
  integer(kind=4) :: j,jstart
  real(kind=4), parameter :: margin=0.05
  !
  rmin = 1.
  rmax = -1.
  !
  if (na.ge.1) then
    do j = 1,na
      if (a(j).eq.a(j) .and. a(j).ne.rbad) then
        rmin = a(j)
        rmax = a(j)
        exit
      endif
    enddo
    !
    jstart = j+1
    do j = jstart,na
      if (a(j).eq.a(j) .and. a(j).ne.rbad) then
        rmin = min(rmin,a(j))
        rmax = max(rmax,a(j))
      endif
    enddo
  endif
  !
  if (rmin.gt.rmax) then
    call class_message(seve%w,rname,  &
      'No valid data found in the current X range (SET MODE X). Min-Max set to 0.')
    rmin = 0.
    rmax = 0.
  endif
  !
  adiff = rmax - rmin
  if (adiff.eq.0.) adiff = max(abs(rmin),0.1)
  rmin = rmin - margin*adiff
  rmax = rmax + margin*adiff
  !
end subroutine class_minmax_r4_1d
!
subroutine class_minmax_i4_1d(rmin,rmax,a,na,ibad)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-generic class_minmax
  ! Compute MIN and MAX from a (section of) given array taking into
  ! account blanking values
  ! ---
  ! I*4 1D version
  !---------------------------------------------------------------------
  real(kind=4),    intent(out) :: rmin   ! Min value plus lower margin
  real(kind=4),    intent(out) :: rmax   ! Max value plus upper margin
  integer(kind=4), intent(in)  :: na     ! Number of values
  integer(kind=4), intent(in)  :: a(na)  ! Input array
  integer(kind=4), intent(in)  :: ibad   ! Bad channel value
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=4) :: j,jstart,imin,imax,adiff
  real(kind=4), parameter :: margin=0.05
  !
  imin = 1
  imax = -1
  !
  if (na.ge.1) then
    do j = 1,na
      if (a(j).ne.ibad) then
        imin = a(j)
        imax = a(j)
        exit
      endif
    enddo
    !
    jstart = j+1
    do j = jstart,na
      if (a(j).ne.ibad) then
        imin = min(imin,a(j))
        imax = max(imax,a(j))
      endif
    enddo
  endif
  !
  if (imin.gt.imax) then
    call class_message(seve%w,rname,  &
      'No valid data found in the current X range (SET MODE X). Min-Max set to 0')
    imin = 0
    imax = 0
  endif
  !
  adiff = imax - imin
  if (adiff.eq.0) adiff = max(abs(imin),1)
  rmin = imin - margin*adiff
  rmax = imax + margin*adiff
  !
end subroutine class_minmax_i4_1d
!
subroutine class_minmax_r4_2d(rmin,rmax,a,n1,n2,rbad)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-generic class_minmax
  ! Compute MIN and MAX from a (section of) given array taking into
  ! account blanking values and NaN
  ! ---
  ! R*4 2D version
  !---------------------------------------------------------------------
  real(kind=4),    intent(out) :: rmin      ! Min value plus lower margin
  real(kind=4),    intent(out) :: rmax      ! Max value plus upper margin
  integer(kind=4), intent(in)  :: n1,n2     ! Number of values
  real(kind=4),    intent(in)  :: a(n1,n2)  ! Input array
  real(kind=4),    intent(in)  :: rbad      ! Bad channel value
  !
  call class_minmax_r4_1d(rmin,rmax,a,n1*n2,rbad)
  !
end subroutine class_minmax_r4_2d

module cubeedit_entry
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubeedit_messaging
  !
  public :: entry_opt_t,entry_user_t
  private
  !
  type entry_opt_t
     type(option_t),      pointer :: opt
     type(keywordlist_comm_t), pointer :: access
     logical                      :: fixed
   contains
     procedure :: register  => cubeedit_entry_register
     procedure :: parse     => cubeedit_entry_parse
     procedure :: user2prog => cubeedit_entry_user2prog
  end type entry_opt_t
  !
  type entry_user_t
     integer(kind=entr_k)  :: ientry
     character(len=argu_l) :: access
     logical               :: do
  end type entry_user_t
  !
contains
  subroutine cubeedit_entry_register(entry,abstract,fixed,error)
    !----------------------------------------------------------------------
    ! Register a /ENTRY options
    !----------------------------------------------------------------------
    class(entry_opt_t), intent(out)   :: entry
    character(len=*),   intent(in)    :: abstract
    logical,            intent(in)    :: fixed
    logical,            intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t) :: keyarg
    character(len=64) :: help,syntax
    character(len=*), parameter :: accesses(2) = ['IMAGE   ','SPECTRUM']
    character(len=*), parameter :: rname='ENTRY>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    entry%fixed = fixed
    if (fixed) then
       syntax = 'ientry'
       help   = 'Access is fixed when opening the cube for editing'
    else
       help   = 'Default access is IMAGE'
       syntax = 'ientry [access]'
    endif
    call cubetools_register_option(&
         'ENTRY',syntax,&
         abstract,&
         help,&
         entry%opt,error)
    if (error) return
    call stdarg%register(&
         'ientry',&
         'Entry number to be gotten',&
         strg_emp,&
         code_arg_mandatory,error)
    if (error) return
    if (.not.fixed) then
       call keyarg%register( &
            'Access',  &
            'In which order the cube should be accessed', &
            strg_emp, &
            code_arg_optional, &
            accesses, &
            .not.flexible, &
            entry%access, &
            error)
       if (error) return
    endif
  end subroutine cubeedit_entry_register
  !
  subroutine cubeedit_entry_parse(entry,line,user,error)
    !----------------------------------------------------------------------
    ! Parse /ENTRY ient [access]
    !----------------------------------------------------------------------
    class(entry_opt_t), intent(in)    :: entry
    character(len=*),   intent(in)    :: line
    type(entry_user_t), intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ENTRY>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call entry%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,entry%opt,1,user%ientry,mandatory,error)
       if (error) return
       if (.not.entry%fixed) then
          user%access = 'IMAGE'
          call cubetools_getarg(line,entry%opt,2,user%access,.not.mandatory,error)
          if (error) return
       else
          user%access = strg_unk
       endif
    endif
  end subroutine cubeedit_entry_parse
  !
  subroutine cubeedit_entry_user2prog(entry,user,doaccess,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(entry_opt_t),    intent(in)    :: entry
    type(entry_user_t),    intent(in)    :: user
    integer(kind=code_k),  intent(out)   :: doaccess
    logical,               intent(inout) :: error
    !
    character(len=8) :: access
    integer(kind=4) :: ikey
    character(len=*), parameter :: rname='ENTRY>USER2PROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_keywordlist_user2prog(entry%access,user%access,ikey,access,error)
    if (error) return
    !
    select case (access)
    case('IMAGE')
      doaccess = code_access_imaset
    case('SPECTRUM')
      doaccess = code_access_speset
    case default
      call cubeedit_message(seve%e,rname,'Unsupported access mode: '//trim(user%access))
      error = .true.
      return
    end select
  end subroutine cubeedit_entry_user2prog
end module cubeedit_entry

subroutine mira_chopper(search,fixOpacity,opac,fixPWV,pwv0,tel,nfreq,freqs, &
&                       loads,recs,atms,tcals,tsyss,quiet,errors)
!
! Called by MIRA subroutine do_tcal (in mira/lib/calibrate.f90).
! Replaces telcal's subroutine chopper. Calls gildas interface
! to ATM at packages/atm (which in turn calls legacy/atm/lib).
!
!
  use chopper_def
  type (chop_mode), intent(in)    :: search        ! search criteria
  type (telescope), intent(in)    :: tel           ! telescope data
  integer,          intent(in)    :: nfreq         ! number of frequency points
  type (dsb_value), intent(in)    :: freqs(nfreq)  ! signa/image frequencies
  type (chop_meas), intent(in)    :: loads(nfreq)  ! cal counts (sky,hot,cold)
  type (mixer),     intent(inout) :: recs(nfreq)   ! rx efficiencies and gains
  type (atm_prop),  intent(inout) :: atms(nfreq)   ! atmspheric data
  type (dsb_value), intent(out)   :: tcals(nfreq)  ! calibration temperatures
  type (dsb_value), intent(out)   :: tsyss(nfreq)  ! system temperatures
  logical,          intent(out)   :: errors(nfreq) ! error flags
  logical,          intent(in)    :: quiet         ! suppress verbose output
  logical,          intent(in)    :: fixOpacity    ! if fixOpacity: no iterations, but
                                                   ! get Tcal,Tsys for fixed opacity
  real(8),          intent(in)    :: opac          ! value of that opacity
  logical,          intent(in)    :: fixPWV        ! if fixPWD: no iterations, but
                                                   ! get Tcal,Tsys, and taus for fixed pwv 
  real(8),          intent(in)    :: pwv0          ! value of that pwv 

  !
  ! Local variables
  type (dsb_value) :: tcal,tsys,attenuation
  type (chop_load) :: cold,hot
  logical :: error
  integer :: ifreq,ier
  real(8) :: dark_count,sky_count,mira_airmass,tsky0,tsky,temi
  !
  ! variables for interface to mnbrak & brent (numerical recipes)
  !
  integer kiter
  real(8)            :: wLower,wMin,wResult,wUpper,fa,fb,fc,chiSquared
  real(8)            :: brent,chiSquaredAtm,chiSquaredTau,tbg0
  real(8), parameter :: tol = 1.d-6, tbg = 2.73
  real(8), parameter :: hp = 6.62620d-27, kb = 1.38062d-16, &
 &                      clight = 2.9979247d+10    
  real(8), parameter :: hoverk = hp/kb*1d9 !! in K/GHz
  real(8), parameter :: planck = 2.*hp*1.d27/clight**2  ! in c.g.s / GHz^3
  external chiSquaredAtm, chiSquaredTau
  !
  character (len=4)  :: atmVersion
  character (len=34) :: mess(3)
  !
  data mess &
       /'zero atmospheric opacity', &
        'no oxygen in atmosphere', &
        'precipitable water vapour very low'/
  !
  errors = .false.
  call sic_get_char('atmVersion',atmVersion,ier,error)
  call atm_setup(atmVersion,error)
  if (error) then
    if (.not.quiet) call message(8,3,'ATM',                       &
                    'ATM version '//atmVersion//' does not exist.')
    errors = .true.
    return
  endif
  !
  atms%airmass = mira_airmass(tel%elev,quiet,error)
  if (error) then
     if (.not.quiet) call message (8,3,'CHOPPER','Elevation is not available')
     errors = .true.
     return
  endif
  !
  if (fixOpacity) tau0 = opac
  !
  call atm_atmosp(real(tel%tout),real(tel%pres),real(tel%alti))
  !
  do ifreq = 1, nfreq
     !
     error = .false.
     !
     rec  = recs(ifreq)
     atm  = atms(ifreq)
     freq = freqs(ifreq)
     tcal = tcals(ifreq)
     tsys = tsyss(ifreq)
     !
     dark_count = loads(ifreq)%dark_count
     sky_count  = loads(ifreq)%sky_count
     hot        = loads(ifreq)%hot
     cold       = loads(ifreq)%cold
     !
     ! Sanity checks
     if (sky_count.ge.hot%count) then
        if (.not.quiet) call message (8,3,'CHOPPER','Signal stronger on SKY than on HOT load => Bad atmosphere')
        error = .true.
        return
     endif
     if (cold%count.ge.hot%count) then
        if (.not.quiet) call message (8,3,'CHOPPER','Signal stronger on COLD than on HOT load')
        error = .true.
        return
     endif
     !
     ! Initialize the ATM status
     ier = 0
     !
     ! Search for water vapor content when asked
     if (search%water.and..not.error) then
        !
        ! Local estimation Trec if needed
        ! This computation does *not* take the cold and hot coupling into account.
        !
        tsky0 = ((hot%ceff*hot%temp + rec%temp) * sky_count        &
     &          / hot%count - rec%temp)                           &
     &        / (1. - sky_count * (1.-hot%ceff) / hot%count)
        temi0 = (tsky0 - (1.-rec%feff) * tel%tcab) / rec%feff
        !
        atm%h2omm = 1.d-10 
        call mira_atm_dsb_transmission(tel,ier)
        temi = (atm%temi%s + atm%temi%i*rec%sbgr) / (1.+rec%sbgr)
        if (temi.lt.temi0) then
           telNumRec = tel
           wLower = 10.d0
           wMin = 9.9d0
           call mnbrak(wLower,wMin,wUpper,fa,fb,fc,chiSquaredAtm)
           chiSquared = brent(wLower,wMin,wUpper,chiSquaredAtm,tol,wResult,error)
           if (error) then
              errors = .true.
              return
           endif
           atm%h2omm = wResult
        endif
        !
     else if (fixOpacity) then
        telNumRec = tel
        wLower = 10.d0
        wMin = 9.9d0
        call mnbrak(wLower,wMin,wUpper,fa,fb,fc,chiSquaredTau)
        chiSquared = brent(wLower,wMin,wUpper,chiSquaredTau,tol,wResult,error)
        atm%h2omm = wResult
        tsky0 = ((hot%ceff*hot%temp + rec%temp) * sky_count        &
     &          / hot%count - rec%temp)                           &
     &        / (1. - sky_count * (1.-hot%ceff) / hot%count)
        temi0 = (tsky0 - (1.-rec%feff) * tel%tcab) / rec%feff
        !
     else if (fixPWV) then
        atm%h2omm = pwv0 
        tsky0 = ((hot%ceff*hot%temp + rec%temp) * sky_count        &
     &          / hot%count - rec%temp)                           &
     &        / (1. - sky_count * (1.-hot%ceff) / hot%count)
        temi0 = (tsky0 - (1.-rec%feff) * tel%tcab) / rec%feff
        !
     endif
     !
     ! Compute atmosphere transmission when asked or needed
     if ((search%atm.or.search%water).and.(.not.error)) then
        ! Atmospheric parameters are recomputed from water, airmass and frequency
        !   => The water vapor content is assumed to be known
        call mira_atm_dsb_transmission(tel,ier)
        if (atm%h2omm.eq.1.d-10) ier = 3
        if (ier.eq.3.and..not.quiet) then
           call gagout('W-CHOPPER: '//mess(ier))
        else if (ier.ne.0.and..not.quiet) then
           call gagout('E-CHOPPER: '//mess(ier))
           error = .true.
        endif        
     else
        ! Atmospheric parameters are assumed to be known
        atm%temi%s = atm%temp%s*(1.-exp(-atm%taus%tot*atm%airmass))
        atm%temi%i = atm%temp%i*(1.-exp(-atm%taui%tot*atm%airmass))
     endif
     !
     ! Compute sky temperatures at signal and image frequency
     temi = (atm%temi%s + atm%temi%i*rec%sbgr) / (1.+rec%sbgr)
     !tsky = temi*rec%feff + tel%tout*(1.-rec%feff)
     tsky = temi*rec%feff + tel%tcab*(1.-rec%feff)
     !
     ! Compute Trec when asked
     if (search%trec.and.(.not.error)) then
        rec%temp = (tsky * (sky_count*(1-hot%ceff) - hot%count) + sky_count * hot%ceff*hot%temp) &
             / (hot%count-sky_count)
     endif
     !
     ! Compute Tcal at zenith when asked
     if (search%tcal.and.(.not.error)) then
        tcal%s = (hot%temp-tsky0)*(1.+rec%sbgr) / rec%beff*hot%ceff
        tcal%i = (hot%temp-tsky0)*(1.+1./rec%sbgr) / rec%beff*hot%ceff
     endif
     !
     ! Compute Tsys at current elevation when asked
     if (search%tsys.and.(.not.error)) then
        attenuation%s = exp(-atm%taus%tot*atm%airmass)
        attenuation%i = exp(-atm%taui%tot*atm%airmass)
        if (attenuation%s.ne.0) then
           tsys%s = tcal%s*sky_count / (hot%count-sky_count) / attenuation%s
        endif
        if (attenuation%i.ne.0) then
           tsys%i = tcal%i*sky_count / (hot%count-sky_count) / attenuation%i
        endif
        tsys%s = max(min(1d10,tsys%s),0.d0)
        tsys%i = max(min(1d10,tsys%i),0.d0)
     endif
     !
!print '(5(a,f7.4))',                   'chopper: rec%beff', rec%beff, ' rec%feff', rec%feff, ' rec%sbgr', rec%sbgr, ' rec%fOut', rec%fOut, ' rec%fCab', rec%fCab
!print '(a,f5.2,3(a,f10.2),2(a,f7.4))', 'chopper: dark_count', dark_count, ' sky_count', sky_count, ' hot%count', hot%count, ' cold%count', cold%count, ' hot%ceff', hot%ceff, ' cold%ceff', cold%ceff
!print '(2(a,f9.4),4(a,f9.3))',         'chopper: freq%s', freq%s, ' freq%i', freq%i, ' hot%temp', hot%temp, ' cold%temp', cold%temp, ' tCal%s', tCal%s, ' tCal%i', tCal%i
!write(2,'(5(a,f7.4))')                   'chopper: rec%beff', rec%beff, ' rec%feff', rec%feff, ' rec%sbgr', rec%sbgr, ' rec%fOut', rec%fOut, ' rec%fCab', rec%fCab
!write(2,'(a,f5.2,3(a,f10.2),2(a,f7.4))') 'chopper: dark_count', dark_count, ' sky_count', sky_count, ' hot%count', hot%count, ' cold%count', cold%count, ' hot%ceff', hot%ceff, ' cold%ceff', cold%ceff
!write(2,'(2(a,f9.4),4(a,f9.3))')         'chopper: freq%s', freq%s, ' freq%i', freq%i, ' hot%temp', hot%temp, ' cold%temp', cold%temp, ' tCal%s', tCal%s, ' tCal%i', tCal%i
     recs(ifreq)   = rec
     atms(ifreq)   = atm
     tcals(ifreq)  = tcal
     tsyss(ifreq)  = tsys
     errors(ifreq) = error
     !
  enddo
  !
  ! Should average water vapor contents here!...
  !
end subroutine mira_chopper
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
function mira_airmass(el,quiet,error)
  ! EXPORT
  !----------------------------------------------------------------------
  ! Compute airmass number corresponding to elevation EL
  ! Use a curved atmosphere, equivalent height 5.5 km
  !----------------------------------------------------------------------
  real(8), intent(in)  :: el      ! Elevation [radian]
  logical, intent(out) :: error   ! Error flag
  logical, intent(in)  :: quiet   ! suppresses error messages
  real(8)              :: mira_airmass ! Airmass
  !
  ! Local variables
  real(8) :: r0,h0,delev,eps,gamma,hz
  parameter (h0=5.5d0,r0=6370.d0)
  !
  error = .false.
  if (el.eq.0.) then
     if (.not.quiet) call message(6,2,'AIRMASS','Elevation is zero-valued')
     error = .true.
     return
  endif
  delev = el
  eps= asin(r0/(r0+h0)*cos(delev))
  gamma= delev + eps
  hz = r0*r0 + (r0+h0)**2 - 2.d0*r0*(r0+h0)*sin(gamma)
  hz = sqrt (max(h0**2,hz))
  hz = hz/h0
  hz = min (hz, 20.d0)
  mira_airmass = hz
end function mira_airmass
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mira_atm_dsb_transmission(tel,ier)
  ! EXPORT
  use atm_interfaces_public
  use chopper_def
  !----------------------------------------------------------------------
  !
  !----------------------------------------------------------------------
  type (telescope), intent(in)    :: tel  !
  integer,          intent(inout) :: ier  ! Error flag
  character(len=4)                :: atmVersion
  logical                         :: error
  !
  ! Local variables
  real :: temi,tatm,tau_wat,tau_oth,tau_tot
  !
  ! Signal frequency
  call sic_get_char('atmVersion',atmVersion,ier,error)
  call atm_setup(atmVersion,error)
  call atm_transm( & 
       real(atm%h2omm), &
       real(atm%airmass), &
       real(freq%s), &
       temi,tatm, &
       tau_oth,tau_wat,tau_tot, &
       ier)
  ! Implicit casting from real to double
  atm%temi%s = temi
  atm%temp%s = tatm
  atm%taus%wat = tau_wat
  atm%taus%oth = tau_oth
  atm%taus%tot = tau_tot
  !
  ! Image frequency
  call atm_transm( & 
       real(atm%h2omm), &
       real(atm%airmass), &
       real(freq%i), &
       temi,tatm, &
       tau_oth,tau_wat,tau_tot, &
       ier)
  ! Implicit casting from real to double
  atm%temi%i = temi
  atm%temp%i = tatm
  atm%taui%wat = tau_wat
  atm%taui%oth = tau_oth
  atm%taui%tot = tau_tot
  !
end subroutine mira_atm_dsb_transmission
!
      SUBROUTINE mnbrak(ax,bx,cx,fa,fb,fc,func)
!
! Subroutine from Numerical Recipes for bracketing
! a minimum using the golde rule.
!
! Input:
!
      implicit none
      REAL*8 ax,bx,cx,fa,fb,fc,func,GOLD,GLIMIT,TINY
      EXTERNAL func
      PARAMETER (GOLD=1.618034, GLIMIT=100., TINY=1.e-20)
      REAL*8 dum,fu,q,r,u,ulim
      fa=func(ax)
      fb=func(bx)
      if(fb.gt.fa)then
        dum=ax
        ax=bx
        bx=dum
        dum=fb
        fb=fa
        fa=dum
      endif
      cx=bx+GOLD*(bx-ax)
      fc=func(cx)
1     if(fb.ge.fc)then
        r=(bx-ax)*(fb-fc)
        q=(bx-cx)*(fb-fa)
        u=bx-((bx-cx)*q-(bx-ax)*r)/(2.*sign(max(abs(q-r),TINY),q-r))
        ulim=bx+GLIMIT*(cx-bx)
        if((bx-u)*(u-cx).gt.0.)then
          fu=func(u)
          if(fu.lt.fc)then
            ax=bx
            fa=fb
            bx=u
            fb=fu
            return
          else if(fu.gt.fb)then
            cx=u
            fc=fu
            return
          endif
          u=cx+GOLD*(cx-bx)
          fu=func(u)
        else if((cx-u)*(u-ulim).gt.0.)then
          fu=func(u)
          if(fu.lt.fc)then
            bx=cx
            cx=u
            u=cx+GOLD*(cx-bx)
            fb=fc
            fc=fu
            fu=func(u)
          endif
        else if((u-ulim)*(ulim-cx).ge.0.)then
          u=ulim
          fu=func(u)
        else
          u=cx+GOLD*(cx-bx)
          fu=func(u)
        endif
        ax=bx
        bx=cx
        cx=u
        fa=fb
        fb=fc
        fc=fu
        goto 1
      endif
      return
      end subroutine mnbrak

      FUNCTION brent(ax,bx,cx,f,tol,xmin,error)
      implicit none
      INTEGER ITMAX
      REAL*8 brent,ax,bx,cx,tol,xmin,f,CGOLD,ZEPS
      EXTERNAL f
      PARAMETER (ITMAX=100,CGOLD=.3819660,ZEPS=1.0e-10)
      INTEGER iter
      REAL*8 a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm
      LOGICAL error
      a=min(ax,cx)
      b=max(ax,cx)
      v=bx
      w=v
      x=v
      e=0.
      fx=f(x)
      fv=fx
      fw=fx
      do 11 iter=1,ITMAX
        xm=0.5*(a+b)
        tol1=tol*abs(x)+ZEPS
        tol2=2.*tol1
        if(abs(x-xm).le.(tol2-.5*(b-a))) goto 3
        if(abs(e).gt.tol1) then
          r=(x-w)*(fx-fv)
          q=(x-v)*(fx-fw)
          p=(x-v)*q-(x-w)*r
          q=2.*(q-r)
          if(q.gt.0.) p=-p
          q=abs(q)
          etemp=e
          e=d
          if(abs(p).ge.abs(.5*q*etemp).or.p.le.q*(a-x).or.p.ge.q*(b-x)) goto 1
          d=p/q
          u=x+d
          if(u-a.lt.tol2 .or. b-u.lt.tol2) d=sign(tol1,xm-x)
          goto 2
        endif
1       if(x.ge.xm) then
          e=a-x
        else
          e=b-x
        endif
        d=CGOLD*e
2       if(abs(d).ge.tol1) then
          u=x+d
        else
          u=x+sign(tol1,d)
        endif
        fu=f(u)
        if(fu.le.fx) then
          if(u.ge.x) then
            a=x
          else
            b=x
          endif
          v=w
          fv=fw
          w=x
          fw=fx
          x=u
          fx=fu
        else
          if(u.lt.x) then
            a=u
          else
            b=u
          endif
          if(fu.le.fw .or. w.eq.x) then
            v=w
            fv=fw
            w=u
            fw=fu
          else if(fu.le.fv .or. v.eq.x .or. v.eq.w) then
            v=u
            fv=fu
          endif
        endif
11    continue
      call gagout('E-CHOPPER: BRENT: number of maximum iterations exceeded.')
      error = .true.
      return
3     xmin=x
      brent=fx
      return
      end function brent


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      FUNCTION chiSquaredAtm(pwv)

      use chopper_def
 
      real(8), intent(in) :: pwv

      integer :: ier
      real(8) :: chiSquaredAtm, temi

      atm%h2omm = pwv
      call mira_atm_dsb_transmission(telNumRec,ier)
      temi = (atm%temi%s + atm%temi%i*rec%sbgr) / (1.+rec%sbgr)
      chiSquaredAtm = (temi-temi0)**2
      return

      END FUNCTION chiSquaredAtm


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      FUNCTION chiSquaredTau(pwv)

      use chopper_def
 
      real(8), intent(in) :: pwv

      integer :: ier
      real(8) :: chiSquaredTau, tau

      atm%h2omm = pwv
      call mira_atm_dsb_transmission(telNumRec,ier)
      chiSquaredTau = (atm%taus%tot-tau0)**2
      return

      END FUNCTION chiSquaredTau

subroutine solve(line,comm,error)
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  logical :: sic_present
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: niter,num,l,naz,nel,i
  character(len=2) :: arg
  real*8 :: eps, funpnl, sigm
  logical :: bavard
  real*8 :: pi,fac,sfac,rts
  parameter (pi=3.14159265358979323846d0)
  !
  sfac = pi/180d0/3600d0
  fac  = 180d0/pi
  rts  = 1.d0/sfac
  !
  bavard = sic_present(0,1)
  eps = 1d-2
  niter=15
  !
  call get_good (npt,kp)
  arg = ' '
  call sic_ke (line,0,1,arg,i,.false.,error)
  if (error) return
  if (arg.eq.'EL') then
    do i=1,ndata
      if (good(i)) then
        good(i) = .false.
        kp = kp-1
      endif
    enddo
  elseif (arg.eq.'AZ') then
    do i=ndata,npt
      if (good(i)) then
        good(i) = .false.
        kp = kp-1
      endif
    enddo
  endif
  write(6,'(A,I4,A,I4)') ' I-POINTING, ',kp,   &
     &    ' good points among ',npt
  if (kp.le.npf) then
    write(6,*) 'E-POINTING,  Not enough data points'
    error = .true.
    return
  endif
  !
  sigco(3) = sigco(3)*cos(coef(3))
  coef(3)  = sin(coef(3))
  valpre(3)= sin(valpre(3))
  if (npf.ne.0) then
    write(6,*) 'I-POINTING,  Calling FITPNL'
    call fitpnl(x,fobs,npt,npf,ipar,coef,niter,num,ffit,   &
     &      sigm,sigco,eps,bavard,good)
    sigma = sigm
  else
    write(6,*) 'I-POINTING,  No variable parameter'
  endif
  !
  do l=1,npt
    ffit(l)=funpnl(x(1,l),coef)
    resd(l)=fobs(l)-ffit(l)
  enddo
  !
  sigma_az = 0
  sigma_el = 0
  naz = 0
  nel = 0
  do l=1,ndata
    fitaz(l)=ffit(l)*rts
    resaz(l)=resd(l)*rts
    fitel(l)=ffit(ndata+l)*rts
    resel(l)=resd(ndata+l)*rts
    if (good(l)) then
      naz = naz+1
      sigma_az = sigma_az+resaz(l)**2
    endif
    if (good(ndata+l)) then
      sigma_el = sigma_el+resel(l)**2
      nel = nel+1
    endif
  enddo
  sigma = sigma_az+sigma_el
  sigma = sqrt(2.0*sigma/max(1,(naz+nel-npf)))
  sigma_az = sqrt(sigma_az/max(1,(naz-npf)))
  sigma_el = sqrt(sigma_el/max(1,(nel-npf)))
  write(6,'(1X,A,F8.2,A,F8.2,A,F8.2,A)')   &
     &    'I-POINTING,  Sigma ',sigma,'  ( Azimuth',sigma_az   &
     &    ,'  Elevation',sigma_el,' ) '
  fitted = .true.
  coef(3)  = asin(coef(3))
  sigco(3) = sigco(3)/cos(coef(3))
  valpre(3)= asin(valpre(3))
end
!<FF>
subroutine print (line,comm,error)
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  integer :: lenc,sic_open
  logical :: sic_present
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: lun,l,kk,i
  character(len=80) :: ofile,name
  real*8 :: pi,fac,sfac,rts
  parameter (pi=3.14159265358979323846d0)
  character(len=42) :: par30m(mvar)
  integer :: signe(mvar),ier
  !
  data par30m/   &
     &    'P1      Zero azimuth (-IAZ or NULA)',   &
     &    'P7      Zero elevation (-IEL-COV or NULE)',   &
     &    'P2      Azimuth collimation (-COH or COL*)',   &
     &    'P4      East Inclination (-MVE)',   &
     &    'P5      North Inclination (MVN)',   &
     &    'P3      Non perpendicularity (NPE)',   &
     &    'REF1    1st order refraction',   &
     &    'REF2    2nd order refraction',   &
     &    'ELES    grav.+exc. coder ele. (sin)',   &
     &    'ELEC    grav.+exc. coder ele. (cos)',   &
     &    'AZES    excen. coder az. (sin)',   &
     &    'AZEC    excen. coder az. (cos)',   &
     &    'incl. coder az. (sin)',   &
     &    'incl. coder az. (cos)',   &
     &    'incl. coder ele. (sin)',   &
     &    'incl. coder ele. (cos)'/
  data signe/-1,-1,-1,-1,1,1,4*1,1,1,4*1/
  !
  if (.not.fitted) then
    write(6,*) 'E-PRINT,  No fit done'
    error = .true.
    return
  endif
  sfac = pi/180d0/3600d0
  fac  = 180d0/pi
  rts  = 1.d0/sfac
  !
  lun = 6
  if (sic_present(1,0)) then
    call sic_ch (line,1,1,ofile,i,.true.,error)
    if (error) return
    lun = 1
    name = ofile
    call sic_parsef(name,ofile,' ','.result')
    ier = sic_open (lun,ofile,'NEW',.false.)
  endif
  !
  if (sic_present(2,0)) then
    write(lun,100)
    do l=1,kvar
      if (free(l)) then
        write(lun,101) l,valpre(l)/sfac,nompar(l)
      else
        write(lun,102) l,valpre(l)/sfac,coef(l)/sfac,nompar(l)
      endif
    enddo
    write(lun,'(/)')
  endif
  write(lun,'(1X,A,A)') 'POINTING results for file ',   &
     &    cfile(1:lenc(cfile))
  write(lun,'(1X,A,A)') '   ',stat_ant
  write(lun,'(1X,A,I4,A,I4,A)') '  Number of points used ',kp,   &
     &    ', among ',npt,' data points'
  write(lun,103)   &
     &    '  Sigma ',sigma,'  ( Azimuth',sigma_az   &
     &    ,'  Elevation',sigma_el,' ) '
  !
  ! If no 30-m Format
  if (.not.sic_present(3,0)) then
    do l=1,npf
      kk=ipar(l)
      write(lun,104) kk,nompar(kk),coef(kk)/sfac,sigco(l)/sfac
    enddo
  else
    do l=1,npf
      kk=ipar(l)
      write(lun,104) kk,par30m(kk),signe(kk)*coef(kk)/sfac,   &
     &        sigco(l)/sfac
    enddo
  endif
  !
  if (lun.ne.6) close(unit=lun)
  !
  100   format(/,' Par.   Previous',23x,'Name')
  101   format(1x,i3,2x,f10.2,'   ** Variable **   ',3x,a,a)
  102   format(1x,i3,2x,f10.2,' Fixed at ',f10.2,3x,a,a)
  103   format(1x,a,f8.2,a,f8.2,a,f8.2,a,/)
  104   format(1x,i4,1x,a,1x,f12.2,' +/- ',f6.2)
end

module cubedag_history_buffer
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_node_class
  use cubedag_link_type
  use cubedag_history_types
  !---------------------------------------------------------------------
  ! Support module for the history buffer, and subroutines to interact
  ! with it
  !---------------------------------------------------------------------

  type(cubedag_history_list_t) :: hx  ! History index

  public :: hx

  public :: cubedag_history_get_object
  public :: cubedag_history_add_tohx
  public :: cubedag_history_list_hx
  public :: cubedag_history_entrynum_hx
  public :: cubedag_history_tostr
  public :: cubedag_history_removenode,cubedag_history_removecommand
  public :: cubedag_history_destroy
  private

contains

  subroutine cubedag_history_get_object(hid,hobj,error)
    !-------------------------------------------------------------------
    ! Given the history identifier, find the associated object in HX
    ! and return a pointer to it
    !-------------------------------------------------------------------
    integer(kind=iden_l),    intent(in)    :: hid
    type(cubedag_history_t), pointer       :: hobj
    logical,                 intent(inout) :: error
    !
    integer(kind=entr_k) :: ihist
    !
    ihist = hx%entrynum(hid,error)
    if (error)  return
    hobj => cubedag_history_ptr(hx%list(ihist)%p,error)
    if (error)  return
  end subroutine cubedag_history_get_object

  subroutine cubedag_history_add_tohx(command,line,inputs,outputs,hid,error)
    !-------------------------------------------------------------------
    ! Add a new command in the HISTORY index. Return the associated
    ! history identifier.
    !-------------------------------------------------------------------
    character(len=*),     intent(in)    :: command
    character(len=*),     intent(in)    :: line
    type(cubedag_link_t), intent(in)    :: inputs
    type(cubedag_link_t), intent(in)    :: outputs
    integer(kind=entr_k), intent(out)   :: hid
    logical,              intent(inout) :: error
    !
    if (outputs%n.le.0) then
      ! The commands which do not create an output cube are not
      ! registered in history
      hid = 0
      return
    endif
    !
    call hx%add(command,line,inputs,outputs,hid,error)
    if (error)  return
  end subroutine cubedag_history_add_tohx

  subroutine cubedag_history_list_hx(error)
    !-------------------------------------------------------------------
    ! List the history index
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call hx%liste(error)
    if (error)  return
  end subroutine cubedag_history_list_hx

  function cubedag_history_entrynum_hx(hid,error)
    !-------------------------------------------------------------------
    ! Return the entry number in in HX corresponding to entry ID
    !-------------------------------------------------------------------
    integer(kind=entr_k) :: cubedag_history_entrynum_hx
    integer(kind=iden_l), intent(in)    :: hid
    logical,              intent(inout) :: error
    !
    cubedag_history_entrynum_hx = hx%entrynum(hid,error)
    if (error)  return
  end function cubedag_history_entrynum_hx

  subroutine cubedag_history_tostr(hid,str,error)
    !-------------------------------------------------------------------
    ! Translate the history identifier to the form "ID (NAME)" (e.g.
    ! "12 (NOISE)"
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: hid
    character(len=*),     intent(out)   :: str
    logical,              intent(inout) :: error
    ! Local
    integer(kind=4) :: ni,nc
    integer(kind=entr_k) :: ient
    type(cubedag_history_t), pointer :: hist
    !
    if (hid.eq.code_history_notyetdefined) then
      str = '-- (NOT-YET-DEFINED)'
      return
    endif
    !
    ient = hx%entrynum(hid,error)
    if (error)  return
    hist => cubedag_history_ptr(hx%list(ient)%p,error)
    if (error)  return
    !
    write(str,'(I0)') hid
    if (ient.le.0) then
      ! Valid: root has no history
      return
    elseif (ient.le.hx%n) then
      ni = len_trim(str)
      nc = min(len_trim(hist%command),len(str)-ni-3)
      write(str(ni+1:),'(3A)')  ' (',hist%command(1:nc),')'
    else
      ni = len_trim(str)
      nc = min(7,len(str)-ni-3)
      write(str(ni+1:),'(3A)')  ' (','UNKNOWN',')'
    endif
    !
  end subroutine cubedag_history_tostr

  subroutine cubedag_history_removenode(id,error)
    use cubelist_types
    use cubedag_dag_buffer
    !-------------------------------------------------------------------
    ! Properly remove a DAG node from the history.
    ! This might leave some commands without inputs or without outputs
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: id  ! Node identifier
    logical,              intent(inout) :: error
    ! Local
    class(cubedag_node_object_t), pointer :: object
    class(list_object_t), pointer :: tot
    integer(kind=entr_k) :: ihist
    type(cubedag_history_t), pointer :: hobj
    !
    ! Get the DAG node pointer
    call cubedag_dag_get_object(id,object,error)
    if (error)  return
    tot => object
    !
    ! Get the history node pointer
    ihist = object%node%history
    hobj => cubedag_history_ptr(hx%list(ihist)%p,error)
    if (error)  return
    !
    ! Remove from command which created it
    call hobj%links%outputs%dissociate(tot,error)
    if (error)  return
    !
    ! Remove from commands which used it as input. As of today, there
    ! is no backpointer to these commands (is this really desired?).
    ! Loop inefficiently on all commands:
    do ihist=1,hx%n
      hobj => cubedag_history_ptr(hx%list(ihist)%p,error)
      if (error)  return
      call hobj%links%inputs%dissociate(tot,error)
      if (error)  return
    enddo
    !
  end subroutine cubedag_history_removenode

  subroutine cubedag_history_removecommand(hid,error)
    use cubelist_types
    use cubedag_dag_buffer
    !-------------------------------------------------------------------
    ! Properly a command from the history.
    ! This might leave other commands without inputs and/or without
    ! outputs
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: hid  ! History identifier
    logical,              intent(inout) :: error
    ! Local
    class(cubedag_node_object_t), pointer :: object
    class(list_object_t), pointer :: tot
    integer(kind=entr_k) :: ihist,inode,jhist
    integer(kind=iden_l) :: nodeid
    character(len=mess_l) :: mess
    type(cubedag_history_t), pointer :: hobj,jobj
    character(len=*), parameter :: rname='HISTORY>REMOVECOMMAND'
    !
    ihist = hx%entrynum(hid,error)
    if (error)  return
    hobj => cubedag_history_ptr(hx%list(ihist)%p,error)
    if (error)  return
    write(mess,'(a,i0,3a)')  'Undo command #',ihist,' (',trim(hobj%command),')'
    call cubedag_message(seve%i,rname,mess)
    !
    do inode=1,hobj%links%outputs%n
      object => cubedag_node_ptr(hobj%links%outputs%list(inode)%p,error)
      if (error)  return
      nodeid = object%node%id
      tot => object
      !
      ! Remove from commands which used it as input. As of today, there
      ! is no backpointer to these commands (is this really desired?).
      ! Loop inefficiently on all commands:
      do jhist=1,hx%n
        jobj => cubedag_history_ptr(hx%list(jhist)%p,error)
        if (error)  return
        call jobj%links%inputs%dissociate(tot,error)
        if (error)  return
      enddo
      !
      ! Actually remove the node from DAG
      call cubedag_dag_removenode(nodeid,error)
      if (error)  return
    enddo
    !
    ! Now remove the command from history index
    call hx%pop(ihist,error)
    if (error)  return
  end subroutine cubedag_history_removecommand

  subroutine cubedag_history_destroy(error)
    !-------------------------------------------------------------------
    ! Brute-force destroy the whole HISTORY
    ! No care of the backpointer links to the cubes in the DAG
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call hx%final(error)
    if (error)  continue
  end subroutine cubedag_history_destroy

end module cubedag_history_buffer

module cubedag_walker_types
  use cubedag_messaging
  use cubedag_parameters
  use cubedag_dag_buffer
  use cubedag_link_type
  use cubedag_node_class
  !
  public :: parentwalker_t,childwalker_t
  public :: cubedag_walker_null
  private
  !
  integer(kind=1), parameter :: topomarker_null=0
  integer(kind=1), parameter :: topomarker_done=1
  !
  type, abstract :: walker_t
    integer(kind=1), allocatable :: topomarker(:)  !
    type(cubedag_link_t)         :: link           ! List of collected objects
    integer(kind=entr_k)         :: current        ! Index in iterated list
  contains
    procedure,                              public  :: reset => cubedag_walker_reset
    procedure(getlink_interface), deferred, private :: getlink
    procedure,                              public  :: next  => cubedag_walker_next
  end type walker_t
  !
  type, extends(walker_t) :: parentwalker_t
  contains
    procedure, private :: getlink => cubedag_parentwalker_getlink
  end type parentwalker_t
  !
  type, extends(walker_t) :: childwalker_t
  contains
    procedure, private :: getlink => cubedag_childwalker_getlink
  end type childwalker_t
  !
  abstract interface
    subroutine callback_interface(par,chi,error)
      import cubedag_node_object_t
      class(cubedag_node_object_t), intent(in)    :: par
      class(cubedag_node_object_t), intent(in)    :: chi
      logical,                      intent(inout) :: error
    end subroutine callback_interface
    recursive subroutine getlink_interface(walker,obj,callback,error)
      import walker_t,cubedag_node_object_t,callback_interface
      class(walker_t),              intent(inout) :: walker
      class(cubedag_node_object_t), intent(in)    :: obj
      procedure(callback_interface)               :: callback
      logical,                      intent(inout) :: error
    end subroutine getlink_interface
  end interface
  !
contains
  !
  subroutine cubedag_walker_reset(walker,start,callback,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Set the current walker in memory to start from given commit
    ! The callback is called at load time, on each parent-child pair,
    ! with the signature:
    !    call callback(pid,cid,error)
    ! If the callback raises an error, the load stops and
    ! cubedag_walker_reset returns an error
    !-------------------------------------------------------------------
    class(walker_t),              intent(inout)      :: walker
    procedure(callback_interface)                    :: callback
    class(cubedag_node_object_t), intent(in), target :: start
    logical,                      intent(inout)      :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='WALKER>RESET'
    !
    ! ZZZ Unclear if collection should be done here or at first
    !     cubedag_walker_next
    !
    ! Prepare topomarkers
    allocate(walker%topomarker(ix%n),stat=ier)
    if (failed_allocate(rname,'topomarker array',ier,error)) return
    walker%topomarker(:) = topomarker_null
    !
    ! Insert start point
    call walker%link%final(error)
    if (error)  return
    call walker%link%associate(start,error)
    if (error)  return
    !
    ! ZZZ Might implement several sorting modes (like git_revwalk_sorting)
    call walker%getlink(start,callback,error)
    if (error)  return
    !
    walker%current = 0
  end subroutine cubedag_walker_reset
  !
  recursive subroutine cubedag_childwalker_getlink(walker,obj,callback,error)
    !---------------------------------------------------------------------
    ! Recursive childwalking
    !---------------------------------------------------------------------
    class(childwalker_t),         intent(inout) :: walker
    class(cubedag_node_object_t), intent(in)    :: obj       ! Starting point (already in list)
    procedure(callback_interface)               :: callback
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='WALKER>GETCHILDREN'
    integer(kind=entr_k) :: first,last,ilist,cent
    class(cubedag_node_object_t), pointer :: chi
    !
    first = walker%link%n+1
    do ilist=1,obj%node%links%children%n
      chi => cubedag_node_ptr(obj%node%links%children%list(ilist)%p,error)
      if (error)  return
      !
      call callback(obj,chi,error)
      if (error)  return
      !
      cent = chi%node%ient
      if (walker%topomarker(cent).eq.topomarker_done)  cycle  ! Do not store duplicate nodes
      call walker%link%associate(chi,error)
      if (error)  return
      walker%topomarker(cent) = topomarker_done
    enddo
    last = walker%link%n
    !
    do ilist=first,last
      chi => cubedag_node_ptr(walker%link%list(ilist)%p,error)
      if (error)  return
      call cubedag_childwalker_getlink(walker,chi,callback,error)
      if (error)  return
    enddo
  end subroutine cubedag_childwalker_getlink
  !
  recursive subroutine cubedag_parentwalker_getlink(walker,obj,callback,error)
    !---------------------------------------------------------------------
    ! Recursive parentwalking
    !---------------------------------------------------------------------
    class(parentwalker_t),        intent(inout) :: walker
    class(cubedag_node_object_t), intent(in)    :: obj       ! Starting point (already in list)
    procedure(callback_interface)               :: callback
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='WALKER>GETPARENT'
    integer(kind=entr_k) :: first,last,ilist,pent
    class(cubedag_node_object_t), pointer :: par
    !
    first = walker%link%n+1
    do ilist=1,obj%node%links%parents%n
      par => cubedag_node_ptr(obj%node%links%parents%list(ilist)%p,error)
      if (error)  return
      !
      call callback(par,obj,error)
      if (error)  return
      !
      pent = par%node%ient
      if (walker%topomarker(pent).eq.topomarker_done)  cycle  ! Do not store duplicate nodes
      call walker%link%associate(par,error)
      if (error)  return
      walker%topomarker(pent) = topomarker_done
    enddo
    last = walker%link%n
    !
    do ilist=first,last
      par => cubedag_node_ptr(walker%link%list(ilist)%p,error)
      if (error)  return
      call cubedag_parentwalker_getlink(walker,par,callback,error)
      if (error)  return
    enddo
  end subroutine cubedag_parentwalker_getlink
  !
  function cubedag_walker_next(walker,next)
    !-------------------------------------------------------------------
    ! Get the next commit ID. Evaluate to .false. if all done.
    !-------------------------------------------------------------------
    logical :: cubedag_walker_next
    class(walker_t),              intent(inout) :: walker
    class(cubedag_node_object_t), pointer       :: next
    ! Local
    logical :: error
    !
    if (walker%current.ge.walker%link%n) then
      cubedag_walker_next = .false.
      next => null()
      return
    endif
    cubedag_walker_next = .true.
    walker%current = walker%current+1
    error = .false.
    next => cubedag_node_ptr(walker%link%list(walker%current)%p,error)
  end function cubedag_walker_next
  !
  subroutine cubedag_walker_null(par,obj,error)
    !-------------------------------------------------------------------
    ! Does nothing. Can be used as neutral callback function.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: par
    class(cubedag_node_object_t), intent(in)    :: obj
    logical,                      intent(inout) :: error
    !
    return
  end subroutine cubedag_walker_null
  !
end module cubedag_walker_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_selection
  use cubefit_parameters
  use cubefit_messaging
  use cubetools_structure
  use cubetools_keywordlist_types
  !
  public :: selection_opt_t, selection_user_t, selection_prog_t
  private
  !
  type selection_opt_t
     type(option_t),      pointer :: opt
     type(keywordlist_comm_t), pointer :: meth_arg
   contains
     procedure :: register  => cubefit_selection_register
     procedure :: parse     => cubefit_selection_parse
     procedure :: user2prog => cubefit_selection_user2prog
  end type selection_opt_t
  !
  type selection_user_t
     character(len=argu_l) :: meth
     character(len=argu_l) :: ifunc
     logical               :: do
  end type selection_user_t
  !
  type selection_prog_t
     character(len=meth_l) :: meth
     integer(kind=code_k)  :: imeth
     integer(kind=func_k)  :: ifunc
  end type selection_prog_t
  !
contains
  !
  subroutine cubefit_selection_register(sel,error)
    !----------------------------------------------------------------------
    ! Register a /SELECTION option 
    ! ----------------------------------------------------------------------
    class(selection_opt_t), intent(out)   :: sel
    logical,                intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    !
    character(len=*), parameter :: rname='SELECTION>REGISTER'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'SELECT','method [ifunc]',&
         'Choose which fitted method/component to keep',&
         'Use /SELECT to keep either all fitted components or one chosen&
         & method/component in the output. If ifunc is omitted, 0, or "*",&
         & all components of the selected method are kept.',&
         sel%opt,error)
    if (error) return
    call keyarg%register(&
         'method',&
         'Fit family to keep',&
         'Use * to keep all fitted methods.',&
         code_arg_mandatory,&
         methnames,&
         .not.flexible,&
         sel%meth_arg,&
         error)
    if (error) return
    call stdarg%register(&
         'ifunc',&
         'Component number to keep',&
         'Use 0 or * to keep all components of the selected method. Use a&
         & positive integer to isolate one component.',&
         code_arg_optional,&
         error)
    if (error) return
  end subroutine cubefit_selection_register
  !
  subroutine cubefit_selection_parse(sel,line,user,error)
    !----------------------------------------------------------------------
    ! /SELECTION method [ifunc]
    !----------------------------------------------------------------------
    class(selection_opt_t), intent(in)    :: sel
    character(len=*),       intent(in)    :: line
    type(selection_user_t), intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter     :: rname='SELECTION>PARSE'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call sel%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,sel%opt,1,user%meth,mandatory,error)
       if (error) return
       user%ifunc = strg_star
       call cubetools_getarg(line,sel%opt,2,user%ifunc,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubefit_selection_parse
  !
  subroutine cubefit_selection_user2prog(sel,user,prog,error)
    use cubetools_user2prog
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(selection_opt_t), intent(in)    :: sel
    type(selection_user_t), intent(in)    :: user
    type(selection_prog_t), intent(out)   :: prog
    logical,                intent(inout) :: error
    !
    character(len=mess_l) :: mess
    integer(kind=func_k), parameter :: defifunc = 0
    character(len=*), parameter :: rname='SELECTION>USER2PROG'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    if (user%do) then
       if (user%meth.eq.strg_star) then
          prog%imeth = code_method_all
          prog%meth  = "All"
       else
          call cubetools_keywordlist_user2prog(sel%meth_arg,user%meth,prog%imeth,prog%meth,error)
          if (error) return
       endif
       call cubetools_user2prog_resolve_star(user%ifunc,defifunc,prog%ifunc,error)
       if (error) return
       if (prog%ifunc.lt.0) then
          call cubefit_message(seve%e,rname,"Selected line must be positive")
          error = .true.
          return
       endif
    else
       prog%imeth = code_method_all
       prog%meth  = "All"
       prog%ifunc = 0
    endif
    !
    ! User feedback
    select case(prog%ifunc)
    case (0)
       write (mess,'(a)') 'Selected all lines'
    case default
       write (mess,'(a,i0,a)') 'Selected ',prog%ifunc,'-th line'
    end select
    if (prog%imeth.eq.0) then
       write (mess,'(2a)') trim(mess),' for all methods'
    else
       write (mess,'(4a)') trim(mess),' of the ',trim(prog%meth),' method'
    endif
    call cubefit_message(seve%i,rname,mess)
  end subroutine cubefit_selection_user2prog
end module cubefit_selection

program uv_ref_model
  use gildas_def
  use gkernel_interfaces
  use mapping_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! TASK  Self-Calibration relative to a uv model
  !	Applies "Self-Calibration" results to a CLIC UV table.
  ! Input :
  !	TABLE$	The UV table to be self-calibrated
  !	SELF$	The "gain" table, i.e. a UV table used as phase reference
  !       UVMODEL$  The UV model table
  !	DTIME$	The smoothing time constant
  !       WCOL$   The reference channel
  !	TYPE$	Type of self-cal, Ampli, Phase or Both
  !	SUBT$	Subtract point source model from data
  ! R.Moreno 17-Jun-1999
  !---------------------------------------------------------------------
  ! Local
  type(gildas) :: x,y,z
  character(len=filename_length) :: uv_table,self_name,model_name,name
  character(len=8) :: type
  real*8 :: time,stime,dtime
  integer :: wcol,itype
  !
  complex(4) :: model,  resul, self
  real(8), allocatable :: ipw(:)
  integer, allocatable :: ipi(:)
  integer :: sblock=1000
  integer :: i,nvs,nvi,kvs,kvi,nsc,nc,n,j, ier, k, wrange(2), mrange(2)
  real :: factor,rbase(2),reel,imgi,uv(2)
  real :: kilow,weight
  logical :: error
  real(8) :: freq
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 1.d0/299792458.d-6
  !
  call gildas_open
  call gildas_char('UV_TABLE$',uv_table)
  call gildas_char('SELF$',self_name)
  call gildas_char('UVMODEL$',model_name)
  call gildas_dble('DTIME$',dtime,1)
  call gildas_inte('WCOL$',wcol,1)
  call gildas_char('TYPE$',type)
  call gildas_real('SUB$',factor,1)
  call gildas_close
  !
  self = cmplx(1.0,0.0)
  if (type.eq.'BOTH') then
    itype = 0
  elseif (type.eq.'AMPLI') then
    itype = -1
  elseif (type.eq.'PHASE') then
    itype = 1
  elseif (type.eq.'NONE') then
    itype = 2
    weight = 1.0
  endif
  dtime = 0.5d0*dtime
  mrange(1:2) = 1
  !
  ! Open continuum table
  n = lenc(self_name)
  if (n.le.0) goto 999
  name = self_name(1:n)
  !
  ! Open continuum table
  n = lenc(self_name)
  if (n.le.0) goto 999
  name = self_name(1:n)
  call gildas_null (y, type = 'UVT')
  call gdf_read_gildas(y, name, '.uvt', error)
  if (error) then
    call gagout('F-SELF_CAL,  Cannot read input UV table')
    goto 999
  endif
  nsc = y%gil%nchan 
  freq = y%gil%val(1)+y%gil%fres*(y%gil%val(1)/y%gil%freq)*((nsc+1)*0.5-y%gil%ref(1))
  kilow = freq*f_to_k
  wcol = max(1,wcol)
  wcol = min(wcol,nsc)
  wrange(1:2) = wcol
  !
  ! Load time variable and sort by time order
  nvs = y%gil%dim(1)
  nvi = y%gil%dim(2)
  allocate (ipw(nvi), ipi(nvi), stat=ier)
  !
  ! Open Model table : in Z slot
  n = lenc(model_name)
  if (n.le.0) goto 999
  name = model_name(1:n)
  call gildas_null (z, type = 'UVT')
  call gdf_read_gildas(z, name, '.uvt', error)
  if (error) then
    call gagout('F-SELF_CAL,  Cannot read input UV model')
    goto 999
  endif
  !
  ! Open line table
  n = lenc(uv_table)
  if (n.le.0) goto 999
  name = uv_table(1:n)
  call sic_parsef(name,x%file,' ','.uvt')
  call gildas_null(x, type = 'UVT')
  call gdf_read_gildas(x, name, '.uvt', error, data=.false.)
  if (error) then
    call gagout ('F-SELF_CAL,  Cannot read input/output UV table')
    goto 999
  endif
  nc = x%gil%nchan 
  !
  ! Sort self-cal table
  call dotime (nvs, nvi, y%r2d, ipw, ipi, stime)
  allocate (x%r2d(x%gil%dim(1), sblock), stat=ier)
  kvs = z%gil%dim(1)
  kvi = z%gil%dim(2)
  !
  ! Loop over line table
  do i=1,x%gil%dim(2),sblock
    x%blc(2) = i
    x%trc(2) = min(x%gil%dim(2),i-1+sblock)
    call gdf_read_data(x,x%r2d,error)
    k = 0
    do j=x%blc(2),x%trc(2)
      k = k+1
      call getiba (x%r2d(:,k),stime,time,rbase,uv)
      !
      ! Compute the observed reference visibility for that baseline
      call geself (nvs,nvi,wrange,y%r2d,   &
     &        time,dtime,ipw,ipi,   &
     &        rbase,resul,uv)
      !
      ! No data: flag
      if (resul.eq.cmplx(0.,0.)) then
        call doflag (nc,x%r2d(:,k)) 
      else
        !
        ! Compute the model visibility
        call geself (kvs,kvi,mrange,z%r2d,  &
     &          time,dtime,ipw,ipi,  &
     &          rbase,model,uv)
        ! Compute self-cal correction
        if (itype.ne.2) then
          call doself  (model,resul,itype,self,weight)
        endif
        ! Compute fraction of source to remove
        reel = factor*real(model)
        imgi = factor*imag(model)
        ! Apply self-cal and remove source
        call doscal (nc,x%r2d(:,k),real(self),imag(self), &
        &       reel,imgi,weight)
      endif
    enddo
    call gdf_write_data(x, x%r2d, error)
  enddo
  ! end loop
  call gdf_close_image(x,error)
  call gdf_close_image(y,error)
  call gdf_close_image(z,error)
  call gagout('S-UV_REF_MODEL,  Successful completion')
  call sysexi(1)
  999   call sysexi(fatale)
end program uv_ref_model

subroutine run_mira(line,comm,error)
   !
   use mira
   !
   implicit none
   !
   character*(*) line, comm
   logical error, sic_present
   !
   if (comm.eq.'SCAN') then
      call getmira(line,error)
   else if (comm.eq.'SHOW') then
      call show(line,error)
   else if (comm.eq.'CAL') then
      call calibrate(line,error)
   else if (comm.eq.'DESPIKE') then
      call despike(line,error)
   else if (comm.eq.'FILE') then
      call directory(line,error)
   else if (comm.eq.'FIND') then
      call findmira(line,error)
   else if (comm.eq.'FLAG') then
      call flagdata(line,error)
   else if (comm.eq.'VIEW') then
      call plot(line,error)
   else if (comm.eq.'LIST') then
      call mira_list(line,error)
   else if (comm.eq.'WRITE') then
      call mira_write(line,error)
   else if (comm.eq.'VARIABLE') then
      call mira_variable(line,error)
   else if (comm.eq.'SOLVE') then
      call solve(line,error)
   else if (comm.eq.'OVERRIDE') then
      call override(line,error)
   else
      call gagout ('E-MIRA, unsupported command')
   endif
!
end subroutine run_mira

subroutine store_cal(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  !	Stores a calibration curve, in the source observations,
  !	assumed to be in the current index.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  include 'clic_xy_code.inc'
  ! Local
  logical :: end, store_amp, store_phase
  logical :: self, do_it
  integer(kind=address_length) :: kh, data_in, kin
  integer(kind=data_length)    :: ldata_in, h_offset
  integer :: ib, isb, iy, oscan, nch, ipola
  integer :: ibmin(2), ibmax(2)
  integer :: spline(2,2,2,-mnant:mnbas), pol(2,2,2,-mnant:mnbas)
  integer :: kslot(2,2,2,-mnant:mnbas),pola(2,2,2,-mnant:mnbas)
  integer :: iy1, iy2, ksb, kpol
  integer :: lb, jw1, jw2, i, l, nc1, nc2, irec, jsb, krec
  integer :: kr, ks
  real :: xx, yy(4), coef(0:3), ww
  real :: y2(2,2,2,-mnant:mnbas)
  real :: w2(2,2,2,-mnant:mnbas)
  real*8 :: uvm,snu
  character(len=80) :: ch2,ch1
  character(len=12) :: argum
  integer :: ic_yes, ic_int, ic_intlast, ic_ext, ic_extlast
  integer :: ic_phalast, ic_amplast
  parameter (ic_yes=1, ic_amplast=2, ic_phalast=4,   &
    ic_int=8, ic_intlast=16,   &
    ic_ext=64, ic_extlast=128)
  !
  ! vocabulary
  integer :: mvx, mvoc1,mvoc2, nkey
  parameter (mvx=2, mvoc1=6, mvoc2 = 3)
  character(len=12) :: vx(mvx), kw, voc1(mvoc1), voc2(mvoc2)
  !
  data vx /'AMPLITUDE','PHASE'/
  data voc1/'AVERAGE','DSB','LOWER','LSB','UPPER','USB'/
  data voc2/'HORIZONTAL','VERTICAL','BOTH'/
  data coef/1.,1.,0.5,0.166666667/
  save end
  !------------------------------------------------------------------------
  ! Code:
  ! Y Faut initialiser SNU a zero DANS TOUS LES CAS !!!!!!!!!!!!!
  snu = 0d0
  self = sic_present(5,0)
  lb = l_subb(1)
  jw1 = iw1(1)
  jw2 = iw2(1)
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  call get_first(.false.,error)    ! to initialise ...
  if (error) goto 999
  call check_output_file(error)
  if (error) goto 999
  call check_equal_file(error)
  if (error) goto 999
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) goto 999
  call sic_ke(line,0,1,argum,nch,.false.,error)
  if (error) goto 999
  call sic_ambigs('STORE_CAL',argum,kw,nkey,vx,mvx,error)
  if (error) goto 999
  store_amp = .false.
  store_phase= .false.
  do i=1, 2
    call sic_ke(line,0,i,argum,nch,.false.,error)
    if (error) goto 999
    call sic_ambigs('STORE_CAL',argum,kw,nkey,vx,mvx,error)
    if (error) goto 999
    store_amp = store_amp .or. (kw.eq.'AMPLITUDE')
    store_phase = store_phase  .or. (kw.eq.'PHASE')
  enddo
  if (store_amp .and. store_phase) then
    call message(4,1,'STORE_CAL',   &
      'Storing amplitude and phase calibration curves')
    iy1 = 1
    iy2 = 2
  elseif (store_amp) then
    call message(4,1,'STORE_CAL',   &
      'Storing amplitude calibration curves')
    iy1 = 1
    iy2 = 1
  elseif (store_phase) then
    call message(4,1,'STORE_CAL',   &
      'Storing phase calibration curves')
    iy1 = 2
    iy2 = 2
  endif
  ! Store /receiver krec
  krec = 0
  if (sic_present(6,0)) then
    call sic_i4(line,6,1,krec,.true.,error)
    if (error) goto 999
    if (krec.gt.mnrec .or. krec.lt.1) then
      call message(8,4,'STORE_CAL','Invalid receiver')
      goto 999
    endif
    write(argum(1:2),'(i2)') krec
    call message(6,1,'STORE_CAL',   &
      'Using calibration curves from receiver '//argum(1:2))
  endif
  ! Store /polar kpolar
  kpol = 0
  if (sic_present(7,0).and..not.self) then
    call sic_ke(line,7,1,argum,nch,.true.,error)
    if (error) goto 999
    call sic_ambigs('STORE CAL /POLARISATION',argum,kw,nkey,voc2,   &
      mvoc2,error)
    if (error) goto 999
    if (kw.eq.'HORIZONTAL') then
      kpol = 1
    elseif (kw.eq.'VERTICAL') then
      kpol = 2
    elseif (kw.eq.'BOTH') then
      kpol = 3
    else
      call message(6,3,'STORE_CAL','Invalid polarisation '//argum)
      error = .true.
      return
    endif
    call message(6,1,'STORE_CAL','Using '//cpol(kpol)   &
      //' calibration curves for both polarisation')
  else
    if (new_receivers.and..not.self) then
      call message(6,1,'STORE_CAL',   &
        'Using a specific calibration curve for each polarisation')
    endif
  endif
  !
  ! Stores horizontal polarisation for old receivers
  if (.not.new_receivers) then
    call message(6,1,'STORE_CAL',   &
      'Patching data for old receivers')
    kpol = 1
  endif
  !
  ! Store /band ksb
  ksb = 0
  if (sic_present(1,0)) then
    call sic_ke(line,1,1,argum,nch,.true.,error)
    if (error) goto 999
    call sic_ambigs('STORE CAL /BAND',argum,kw,nkey,voc1,mvoc1,   &
      error)
    if (error) goto 999
    if (kw.eq.'USB' .or. kw.eq.'UPPER') then
      ksb = 1
    elseif (kw.eq.'LSB'.or. kw.eq.'LOWER') then
      ksb = 2
    elseif (kw.eq.'AVERAGE' .or. kw.eq.'DSB') then
      ksb = 3
    else
      call message(6,3,'STORE_CAL','Invalid sideband '//argum)
      error = .true.
      return
    endif
    call message(6,1,'STORE_CAL','Using '//cband(ksb)   &
      //' calibration curves for both sidebands')
  else
    call message(6,1,'STORE_CAL',   &
      'Using a specific calibration curve for each sideband')
  endif
  !
  if (do_amplitude_antenna) then
    ibmin(1) = -r_nant
    ibmax(1) = -1
  else
    ibmin(1) = 1
    ibmax(1) = r_nbas
  endif
  !
  if (do_phase_antenna) then
    ibmin(2) = -r_nant
    ibmax(2) = -1
  else
    ibmin(2) = 1
    ibmax(2) = r_nbas
  endif
  ! current (default) receiver
  irec = r_nrec
  if (krec.ne.0) irec = krec
  !
  !     Check for presence of calibration curve
  do_it = .false.
  if (.not.self) then
    do iy = iy1, iy2
      nc1 = lenc(clab(iy))
      ch1 = 'No '//clab(iy)(1:nc1)//' calibration for '
      nc1 = lenc(ch1)+1
      do ib = ibmin(iy), ibmax(iy)
        if (ib.gt.0) then
          ch2 = ', Baseline '//cbas(ib)
        else
          ch2 = ', Antenna '//char(-ib+ichar('0'))
        endif
        ! (1) one sideband, one polar
        if (ksb.ne.0) then
          if (kpol.ne.0) then
            if (f_spline(iy,ksb,kpol,ib,irec).gt.0) then
              do isb=1,2
                do ipola=1,2
                  spline(iy,isb,ipola,ib) = ksb
                  pol (iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = kpol
                  kslot(iy,isb,ipola,ib) =   &
                    f_spline(iy,ksb,kpol,ib,irec)-1
                enddo
              enddo
              do_it = .true.
            elseif (f_pol(iy,ksb,kpol,ib,irec).gt.0) then
              do isb=1,2
                do ipola=1,2
                  pol (iy,isb,ipola,ib) = ksb
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = kpol
                  kslot(iy,isb,ipola,ib) =   &
                    f_pol(iy,ksb,kpol,ib,irec)-1
                enddo
              enddo
              do_it = .true.
            else
              do isb=1,2
                do ipola=1,2
                  pol (iy,isb,ipola,ib) = 0
                  spline(iy,isb,ipola,ib) = 0
                  kslot(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = 0
                enddo
              enddo
              nc2 = lenc(cband(ksb))
              call message(4,2,'STORE_CAL',ch1(1:nc1)   &
                //cband(ksb)(1:nc2)//ch2 )
            endif
          else
            ! (2) one sideband, two polars
            do ipola=1,2
              if (f_spline(iy,ksb,ipola,ib,irec).gt.0) then
                do isb=1,2
                  spline(iy,isb,ipola,ib) = ksb
                  pol (iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = ipola
                  kslot(iy,isb,ipola,ib) =   &
                    f_spline(iy,ksb,ipola,ib,irec)-1
                enddo
                do_it = .true.
              elseif (f_pol(iy,ksb,ipola,ib,irec).gt.0) then
                do isb=1,2
                  pol (iy,isb,ipola,ib) = ksb
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = ipola
                  kslot(iy,isb,ipola,ib) =   &
                    f_pol(iy,ksb,ipola,ib,irec)-1
                enddo
                do_it = .true.
              else
                do isb=1,2
                  pol (iy,isb,ipola,ib) = 0
                  spline(iy,isb,ipola,ib) = 0
                  kslot(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = 0
                enddo
                nc2 = lenc(cband(ksb))
                call message(4,2,'STORE_CAL',ch1(1:nc1)   &
                  //cband(ksb)(1:nc2)//ch2 )
              endif
            enddo
          endif
        else
          ! (3) two sidebands, one polar
          if (kpol.ne.0) then
            do ipola=1,2
              do isb= 1,2
                if (f_spline(iy,isb,kpol,ib,irec).gt.0) then
                  spline(iy,isb,ipola,ib) = isb
                  pol (iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = kpol
                  kslot(iy,isb,ipola,ib) =   &
                    f_spline(iy,isb,kpol,ib,irec)-1
                  do_it = .true.
                elseif (f_pol(iy,isb,kpol,ib,irec).gt.0) then
                  pol (iy,isb,ipola,ib) = isb
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = kpol
                  kslot(iy,isb,ipola,ib) =   &
                    f_pol(iy,isb,kpol,ib,irec)-1
                  do_it = .true.
                else
                  pol (iy,isb,ipola,ib) = 0
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = 0
                  nc2 = lenc(cband(isb))
                  kslot(iy,isb,ipola,ib) = 0
                  call message(4,2,'STORE_CAL',ch1(1:nc1)   &
                    //cband(isb)(1:nc2)//ch2 )
                endif
              enddo
            enddo
          else
            ! (4) two sidebands, two polars (we should not get in that mode)
            do ipola=1,2
              do isb= 1,2
                if (f_spline(iy,isb,ipola,ib,irec).gt.0) then
                  spline(iy,isb,ipola,ib) = isb
                  pol (iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = ipola
                  kslot(iy,isb,ipola,ib) =   &
                    f_spline(iy,isb,ipola,ib,irec)-1
                  do_it = .true.
                elseif (f_pol(iy,isb,ipola,ib,irec).gt.0) then
                  pol (iy,isb,ipola,ib) = isb
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = ipola
                  kslot(iy,isb,ipola,ib) =   &
                    f_pol(iy,isb,ipola,ib,irec)-1
                  do_it = .true.
                else
                  pol (iy,isb,ipola,ib) = 0
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = 0
                  nc2 = lenc(cband(isb))
                  kslot(iy,isb,ipola,ib) = 0
                  call message(4,2,'STORE_CAL',ch1(1:nc1)   &
                    //cband(isb)(1:nc2)//ch2 )
                endif
              enddo
            enddo
          endif
        endif
      enddo
    enddo
  else
    ! Self calibration
    do_it = .true.
    ch2 = ' '
    l = 1
    do i=1,l_subb(1)
      ch2 = ch2(1:l)//csub(i_subb(i,1))//' '
      l = l+4
    enddo
    l = lenc(ch2)
    call message(2,1,'STORE_CAL',   &
      'Self calibrating from '//ch2(1:l))
    save_scale = do_scale
    save_flux = do_flux
    save_amplitude = do_amplitude
    save_phase = do_phase
    if (store_amp .and. (do_amplitude .or. .not.do_scale   &
      .or. do_flux)) then
      do_scale = .true.
      do_amplitude = .false.
      do_flux = .false.
    endif
    if (store_phase .and. do_phase) then
      do_phase = .false.
    endif
  endif
  if (.not.do_it) then
    call message (8,4,'STORE_CAL','No calibration curve to store')
    print *,"KSB",ksb,"KPOL",kpol
    goto 999
  endif
  !
  ! Loop on current index
  end = .false.
  oscan = 0
  do while (.not.end)
    !
    ! Check for autocorrelation scans
    if (r_proc.eq.p_pass .or. r_proc.eq.p_skydip   &
      .or. r_proc.eq.p_sky .or. r_proc.eq.p_cal   &
      .or. r_proc.eq.p_onoff .or. r_proc.eq.p_pseudo) goto 98
    !
    ! Store calibration curves
    if (krec.ne.0 .and. krec.ne.r_nrec) then
      irec = krec
    else
      irec = r_nrec
    endif
    call set_corr(error)
    if (error) goto 999
    !
    ! Get data if data is present in file.
    ! [r_ut is not accurate in old data; is patched by COPY; therefore it is
    ! safe to assume that it is OK if COPY HEADERS was done.]
    if (.not.r_presec(file_sec)) then
      call get_data (ldata_in,data_in,error)
      if (error) goto 999
      kin = gag_pointer(data_in,memory)
      kr = r_ndump + 1
      kh = kin + h_offset(kr)
      call decode_header (memory(kh))
      xx = dh_utc/3600.   &
        +(mod(dh_obs+32768,65536)-mod(dobs_0+32768,65536))*24.
    else
      xx = (r_ut/2d0/pi   &
        +(mod(r_dobs+32768,65536)-mod(dobs_0+32768,65536)))*24.
    endif
    !
    ! Get self calibration (possibly from other receiver).
    if (self) then
      call get_self_cal(krec,iy1,iy2,ibmin,ibmax,ksb,y2,w2,error)
      if (error) goto 999
    endif
    !
    do iy = iy1, iy2
      do ib = ibmin(iy), ibmax(iy)
        do isb= 1,2
          do ipola= 1,2
            !
            ks = 0
            ! self calibration: use the first subband set as a reference
            ! works only for the same band
            if (self) then
              if (iy.eq.2) then
                if (irec.ne.r_nrec) then
                  ks = 1
                else
                  ks = 0
                endif
              else
                ks = 0
              endif
              ww = w2(iy,isb,ipola,ib)
              yy(1) = y2(iy,isb,ipola,ib)
              ! Planet Jupiter
              if (planet_model.eq.-3) then
                uvm = sqrt(dh_uvm(1,ib)**2+dh_uvm(2,ib)**2)
                call get_fluxspl(uvm,snu)
              else
                snu = 0.0
              endif
              ! End patch
              do i=2,4
                yy(i) = 0
              enddo
            ! Not Self Calibration
            else
              ww = 1.
              call get_cal(iy,irec,isb,ib,spline(iy,isb,ipola,ib)   &
                ,pol(iy,isb,ipola,ib),pola(iy,isb,ipola,ib),   &
                xx,yy,oscan,error)
              if (error) return
              if (iy.eq.2) then
                if (irec.ne.r_nrec) then
                  ks = 1
                else
                  ks = kslot(iy,isb,ipola,ib)
                endif
              else
                ks = 0
              endif
            endif
            ! baseline based:
            if (iy.eq.1 .and. .not.do_amplitude_antenna) then
              r_aic = iand(r_aic,not(ic_amplast))
              r_ic = ior(r_ic,ic_amplast)
              r_icamp(ipola,isb,ib,ks) = yy(1)*coef(0)
              ! I'm not sure why the following line was omitted, it is needed to use
              ! baseline amp  and antenna phase together.
              r_ic = ior(r_ic,ic_yes)
              r_icdeg = 3
              r_presec(ical_sec)=.true.
            elseif (iy.eq.2 .and. .not.do_phase_antenna) then
              r_aic = iand(r_aic,not(ic_phalast))
              r_ic = ior(r_ic,ic_phalast)
              r_icpha(ipola,isb,ib,ks) = yy(1)*coef(0)
              if (ks.eq.0) then
                r_ic = ior(r_ic,ic_yes+ic_int+ic_intlast)
                r_ic = iand(r_ic,not(ic_extlast))
              else
                r_ic = ior(r_ic,ic_yes+ic_ext+ic_extlast)
                r_ic = iand(r_ic,not(ic_intlast))
              endif
              r_icdeg = 3
              r_presec(ical_sec)=.true.
              !
              ! Jupiter patch
              if (snu.lt.0) then
                r_icpha(ipola,isb,ib,0) = r_icpha(ipola,   &
                  isb,ib,0)+pi
              endif
            endif
            ! Antenna  based:
            if (iy.eq.1 .and. do_amplitude_antenna   &
              .and. ww.gt.0) then
              r_ic = iand(r_ic,not(ic_amplast))
              r_aic = ior(r_aic,ic_amplast)
              ! I'm not sure why the following line was omitted, it is needed to use
              ! baseline amp  and antenna phase together.
              r_aic = ior(r_aic,ic_yes)
              r_aicamp(ipola,isb,-ib,ks) = yy(1)*coef(0)
              r_aicdeg = 3
              r_presec(aical_sec)=.true.
            elseif (iy.eq.2 .and. do_phase_antenna   &
              .and. ww.gt.0) then
              r_ic = iand(r_ic,not(ic_phalast))
              r_aic = ior(r_aic,ic_phalast)
              if (ks.eq.0) then
                r_aic = ior(r_aic,ic_yes+ic_int+ic_intlast)
                r_aic = iand(r_aic,not(ic_extlast))
              else
                r_aic = ior(r_aic,ic_yes+ic_ext+ic_extlast)
                r_aic = iand(r_aic,not(ic_intlast))
              endif
              r_aicpha(ipola,isb,-ib,ks) = yy(1)*coef(0)
              r_aicdeg = 3
              r_presec(aical_sec)=.true.
            endif
          enddo
        enddo
      ! end loop on 'baselines'
      enddo
      ! get rms: loop on TRUE baselines
      do ib = 1, r_nbas
        do isb = 1, 2
          ! forced side band
          if (ksb.ne.0) then
            jsb = ksb
          else
            jsb = isb
          endif
          do ipola = 1, 2
            if (do_amplitude_antenna .or.   &
              do_phase_antenna) then
              if (f_spline(iy,jsb,ipola,-r_iant(ib),irec)   &
                .gt.0) then
                r_aicrms(ipola,isb,ib,iy) =   &
                  rms_spline_ant(iy,jsb,ipola,ib,irec)
              elseif (f_pol(iy,jsb,ipola,-r_iant(ib),irec)   &
                .gt.0) then
                r_aicrms(ipola,isb,ib,iy) =   &
                  rms_pol_ant(iy,jsb,ipola,ib,irec)
              endif
            endif
            if (.not.do_amplitude_antenna .or.   &
              .not.do_phase_antenna) then
              if (f_spline(iy,jsb,ipola,ib,irec).gt.0) then
                r_icrms(ipola,isb,ib,iy) =   &
                  rms_spline_bas(iy,jsb,ipola,ib,irec)
              elseif (f_pol(iy,jsb,ipola,ib,irec).gt.0) then
                r_icrms(ipola,isb,ib,iy) =   &
                  rms_pol_bas(iy,jsb,ipola,ib,irec)
              endif
            endif
          enddo
        enddo
      enddo
    ! end loop on amp, phas
    enddo
    !
    ! Update  scan
    call write_scan (.false.,error)
    if (error) goto 999
    !
    ! Next observation
98  if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) goto 999
  enddo
  do_scale = save_scale
  do_flux = save_flux
  do_amplitude = save_amplitude
  do_phase = save_phase
  return
  !
999 error = .true.
  return
end subroutine store_cal
!
subroutine get_cal(iy,ir,isb,ib,ispline,ipol,pola,x,y,oscan,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  !---------------------------------------------------------------------
  ! Returns in Y the value and derivatives of the calibration curve
  ! at time X,
  ! for baseline IB, side band ISB.
  ! IX = 1 for amplitude and 2 for phase
  !---------------------------------------------------------------------
  integer :: iy                     !
  integer :: ir                     !
  integer :: isb                    !
  integer :: ib                     !
  integer :: ispline                !
  integer :: ipol                   !
  integer :: pola                   !
  real :: x                         !
  real :: y(4)                      !
  integer :: oscan                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! INCLUDE 'clic_dheader.inc'
  ! Local
  real*8 :: xx, yy(4), aa(m_pol)
  integer :: jsb, ifail, nk, i
  character(len=80) :: ch
  real :: factor_i, factor_j
  real :: phmul
  !------------------------------------------------------------------------
  ! Code:
  xx = x
  error = .false.
  !
  ! Polarisation
  if (pola.lt.1.or.pola.gt.3) then
    call message (4,3,'GET_CAL','No such polarisation curve stored in memory')
    error = .true.
    return
  endif
  !
  ! Spline
  if (ispline.ne.0) then
    jsb = ispline
  elseif (ipol.ne.0) then
    jsb = ipol
  else
    call message(8,4,'GET_CAL','No calibration for '//cband(isb))
    error = .true.
    return
  endif
  !
  ! Convert from one receiver to the other:
  ! Normally one should also correct for the varying path as a fonction of freq,
  !
  if (iy.eq.2 .and. ir.ne.r_nrec) then
    if (ph_fac(jsb,pola,ib,ir).ne.0) then
      if (jsb.eq.1) then
        phmul = (r_flo1+r_fif1)/ph_fac(jsb,pola,ib,ir)
      elseif (jsb.eq.2) then
        phmul = (r_flo1-r_fif1)/ph_fac(jsb,pola,ib,ir)
      elseif (jsb.eq.3) then
        phmul = r_flo1/ph_fac(jsb,pola,ib,ir)
      endif
    else
      write(ch,'(i1)') ir
      call message(8,4,'GET_CAL',   &
        'Please do a RF passband for receiver '//ch(1:1))
      error = .true.
      return
    endif
  else
    phmul = 1.0
  endif
  !
  ! convert from one sideband to another:
  factor_i = 0.0
  factor_j = 0.0
  if (iy.eq.2 .and. jsb.ne.0 .and. .not. do_phase_ext) then
    if (jsb.ne.isb .or. ir.ne.r_nrec) then
      ! FACTOR_I from average band to target band ISB (current target receiver):
      call band_factor(ib,isb,r_nrec,factor_i,error)
      !
      ! FACTOR_J from average band to origin band JSB (origin receiver IR)
      call band_factor(ib,jsb,ir,factor_j,error)
    endif
  endif
  !
  ! Splines
  if (ispline.ne.0) then
    ifail = 1
    nk = n_knots(iy,jsb,pola,ib,ir)
    if (xx.lt.k_spline(4,iy,jsb,pola,ib,ir)) then
      if (k_spline(4,iy,jsb,pola,ib,ir)-xx .gt. 0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' below limit (',   &
            k_spline(4,iy,jsb,pola,ib,ir),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = k_spline(4,iy,jsb,pola,ib,ir)
    elseif (xx.gt.k_spline(nk+5,iy,jsb,pola,ib,ir)) then
      if (xx-k_spline(nk+5,iy,jsb,pola,ib,ir).gt.0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' above limit (',   &
            k_spline(nk+5,iy,jsb,pola,ib,ir),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = k_spline(nk+5,iy,jsb,pola,ib,ir)
    endif
    !
    ! Get spline and derivatives
    call mth_getspd('GET_CAL',nk+8, k_spline(1,iy,jsb,pola,ib,ir),   &
      c_spline(1,iy,jsb,pola,ib,ir), xx, 0, yy, error)
    if (error) return
    yy(2) = 0
    yy(3) = 0
    yy(4) = 0
  !
  ! Polynomials
  elseif (ipol.ne.0) then
    ifail = 1
    if (xx.lt.t_pol(1,iy,jsb,pola,ib,ir)) then
      if (t_pol(1,iy,jsb,pola,ib,ir)-xx .gt. 0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' below limit (',   &
            t_pol(1,iy,jsb,pola,ib,ir),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = t_pol(1,iy,jsb,pola,ib,ir)
    elseif (xx.gt.t_pol(2,iy,jsb,pola,ib,ir)) then
      if (xx-t_pol(2,iy,jsb,pola,ib,ir).gt.0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' above limit (',   &
            t_pol(2,iy,jsb,pola,ib,ir),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = t_pol(2,iy,jsb,pola,ib,ir)
    endif
    do i=1, n_pol(iy,jsb,pola,ib,ir)
      aa(i) = c_pol(i,iy,jsb,pola,ib,ir)
    enddo
    xx = ((xx-t_pol(1,iy,jsb,pola,ib,ir))   &
      -(t_pol(2,iy,jsb,pola,ib,ir)-xx))   &
      /(t_pol(2,iy,jsb,pola,ib,ir)-t_pol(1,iy,jsb,pola,ib,ir))
    xx = max(xx,-1d0)
    xx = min(xx,1d0)
    call mth_getpol ('GET_CAL',n_pol(iy,jsb,pola,ib,ir),   &
      aa,xx,yy,error)
    if (error) return
    yy(2) = 0
    yy(3) = 0
    yy(4) = 0
  else
    yy(1) = 0.
    yy(2) = 0
    yy(3) = 0
    yy(4) = 0
  endif
  if (iy.eq.2) then
    yy(1) = (mod((yy(1)-factor_j)+11*pi,2*pi)-pi)*phmul   &
      + factor_i
  endif
  do i=1, 4
    y(i) = yy(i)
  enddo
end subroutine get_cal
!
subroutine band_factor(ib,isb,ir,factor,error)
  use classic_api  
  !---------------------------------------------------------------------
  ! Compute the phase conversion factor (Complex) from band ISB to
  ! Average band, for receiver IR, baseline IB (or antenna -IB)
  ! _ if IR is the current one (IR=R_NREC) then one takes the bandpass data
  !   of the observation;
  ! _ if not, then the bandpass for receiver IR must be in program memory,
  !   or an error occurs.
  !---------------------------------------------------------------------
  integer :: ib                     !
  integer :: isb                    !
  integer :: ir                     !
  real :: factor                    !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  integer :: ia, ja, i
  complex :: z(mnbas), zant(mnant)
  real :: w(mnbas), want(mnant)
  real :: faz
  !-----------------------------------------------------------------------
  !
  if (isb.gt.2) then
    factor = 0.0
  elseif (ir.eq.r_nrec) then
    if (ib.gt.0 .and. r_bpc.ne.0) then
      factor = faz(r_bpcsba(1,isb,ib))
    elseif (ib.gt.0 .and. r_abpc.ne.0) then
      ia = r_iant(ib)
      ja = r_jant(ib)
      factor = faz(r_abpcsba(1,isb,ja)/r_abpcsba(1,isb,ia))
    elseif (ib.lt.0 .and. r_abpc.ne.0) then
      factor = faz(r_abpcsba(1,isb,-ib))
    elseif (ib.lt.0 .and. r_bpc.ne.0) then
      do i=1,r_nbas
        z(i) = r_bpcsba(1,isb,i)
        w(i) = 1.
      enddo
      call antgain(z,w,zant,want)
      factor = faz(zant(-ib))
    !
    ! Note: we assume that if we calibrate phase with no RF done and needed,
    ! the image side band is useless.
    elseif (.not.do_pass) then
      call message(4,1,'GET_CAL','No RF Passband available')
      factor = 1.0
    else
      call message(8,3,'GET_CAL','No RF Passband available')
      error = .true.
      return
    endif
  else
    ! should be the SBA used for the phase calibration
    factor = faz(icsba(isb,ib,ir))
  endif
  return
end subroutine band_factor
!
subroutine get_self_cal(krec,iy1,iy2,ibmin,ibmax,jsb,y2,w2,   &
    error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_find
  use clic_rdata
  !---------------------------------------------------------------------
  ! Get self calibration values (from current receiver or receiver krec)
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  integer :: krec                   !
  integer :: iy1                    !
  integer :: iy2                    !
  integer :: ibmin(2)               !
  integer :: ibmax(2)               !
  integer :: jsb                    !
  real :: y2(2,2,2,-mnant:mnbas)    !
  real :: w2(2,2,2,-mnant:mnbas)    !
  logical :: error                  !
  ! Global
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: kb, kif
  integer(kind=address_length) :: data_in, kin
  integer(kind=address_length) :: kh, kl, kc
  integer(kind=data_length)    :: ldata_in, h_offset, l_offset, c_offset
  integer ::  ib, isb, iy, kr, isb1, isb2
  integer ::  iv, im, nff, jw1, jw2, ix, ir, ia, ja, i, ipola
  integer ::  js, isub, jspw, spw_pol
  integer ::  lb_sel(3,2), i_subsel(mrlband,3,2)
  integer(kind=entry_length) :: iff(2),kx,kxsave
  real :: wt(4,3), vt(4,3), phmul, factor_i, factor_j
  complex :: z(mnbas), zant(mnant)
  real :: w(mnbas), want(mnant)
  character(len=80) :: ch
  real :: y1(2,3,2,-mnant:mnbas)
  real :: w1(2,3,2,-mnant:mnbas)
  logical :: zero_average
  save kxsave
  !-----------------------------------------------------------------------
  ix = xy_time
  jw1 = iw1(1)
  jw2 = iw2(1)
  y1 = 0.
  w1 = 0.
  y2 = 0.
  w2 = 0.
  lb_sel = 0
  i_subsel = 0
  !
  ! patch
  kb = 1
  kif = 1
  if (r_lnsb.eq.1) then
    ib = i_subb(1,1)
    if (ib.gt.mbands) ib = ib-mbands
    isb1 = r_lsband(1,ib)
    isb2 = isb1
  else 
    isb1 = 1
    isb2 = 3
  endif
  isb1=1
  isb2=2
  !
  ! Need to spy the other receiver?
  kxsave = r_xnum
  if (krec.ne.0 .and. krec.ne.r_nrec) then
    !
    nff = 2
    fnum = .false.
    xscan(1) = r_scan
    yscan(1) = r_scan
    xnscan = 1
    fscan = .true.
    xrecei = krec
    call fix(nff,iff,.false.,.false.,error)
    error = .false.
    if (nff.lt.1) then
      call message(4,2,'GET_SELF_CAL',   &
        'Only one receiver available')
      error = .true.
      return
    endif
    kx = iff(1)
    call get_it(kx,error)
    if (error) return
    ir = krec
  else
    ir = r_nrec
  endif
  !
  if (do_pass) then
    if (r_bpc.eq.0.and..not.do_pass_memory   &
      .and. .not.do_pass_antenna.and..not.do_pass_spectrum) then
      call message(6,2,'GET_SELF_CAL',   &
        'No Baseline RF Passband Calibration, data ignored')
      error = .true.
      return
    endif
    if (r_abpc.eq.0.and..not.do_pass_memory   &
      .and. do_pass_antenna.and..not.do_pass_spectrum) then
      call message(6,2,'GET_SELF_CAL',   &
        'No Antenna RF Passband Calibration, data ignored')
      error = .true.
      return
    endif
    call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, passc, passl, error)
    if (error) return
  endif
  if (do_spidx) then
    call set_spidx(r_nsb,r_nband,r_nbas+r_ntri, &
     r_lntch,spidc,spidl,r_spidx,error)
    if (error) return
  endif
  if (do_pass) then
    if (do_spidx) then
      where (passc.ne.blankc)
        factc = passc * spidc
      else where
        factc = blankc
      end where
      where (passl.ne.blankc)
        factl = passl * spidl
      else where
        factl = blankc
      end where
    else
      factc = passc
      factl = passl
    endif
  elseif (do_spidx) then
    factc = spidc
    factl = spidl
  endif
  !
  call get_data (ldata_in,data_in,error)
  if (error) return
  !
  ! Average record only
  kin = gag_pointer(data_in,memory)
  call spectral_dump(kr,0,0)
  kh = kin + h_offset(kr)
  call decode_header (memory(kh))
  call set_scaling(error)
  if (error) return
  !
  ! Build the SPW list to use for each sideband and polarisation.
  ! The /SELF solution is still derived per record, but each call to
  ! ARECORD/BRECORD must see only the SPWs relevant to the requested
  ! sideband and polarisation.
  do js = 1, r_nbb
    jspw = js
    if (jspw.gt.mbands) jspw = jspw-mbands
    if (jspw.le.0 .or. jspw.gt.r_lband) cycle
    do ipola = 1, 2
      if (new_receivers .and. r_lpolmode(jspw).eq.1) then
        spw_pol = r_lpolentry(1,jspw)
        if (spw_pol.ge.1 .and. spw_pol.le.2) then
          if (spw_pol.ne.ipola) cycle
        endif
      endif
      lb_sel(3,ipola) = lb_sel(3,ipola) + 1
      i_subsel(lb_sel(3,ipola),3,ipola) = jspw
      isb = (3-r_sb(jspw))/2
      if (isb.ge.1 .and. isb.le.2) then
        lb_sel(isb,ipola) = lb_sel(isb,ipola) + 1
        i_subsel(lb_sel(isb,ipola),isb,ipola) = jspw
      endif
    enddo
  enddo
  if (r_lmode.eq.1) then       ! correlation only ...
    zero_average = .true.
    if (k_average.eq.1) then
      call line_average (r_lntch,r_nbas,r_lnsb,data_in,   &
        spidl,zero_average,error)
    else
      call cont_average (r_nband,r_nbas,data_in,   &
        spidc,zero_average,error)
    endif
    if (error) return
  endif
  !
  do iy = iy1, iy2
    do ib = ibmin(iy), ibmax(iy)
      if (new_receivers) then
        do ipola=1,2
          !NGRx: need the new parameters in data header (discussed with FG)
          ph_fac(1,ipola,ib,r_nrec) = r_flo1+r_fif1
          ph_fac(2,ipola,ib,r_nrec) = r_flo1-r_fif1
          ph_fac(3,ipola,ib,r_nrec) = r_flo1
        enddo
      else
        do ipola=1,2
          ph_fac(1,ipola,ib,r_nrec) = r_flo1+r_fif1
          ph_fac(2,ipola,ib,r_nrec) = r_flo1-r_fif1
          ph_fac(3,ipola,ib,r_nrec) = r_flo1
        enddo
      endif
      do isb= isb1, isb2
        do ipola=1,2
          if (lb_sel(isb,ipola).le.0) cycle
          do iv=1,4
            do im=1,3
              vt(iv,im) = 0
              wt(iv,im) = 0
            enddo
          enddo
          if (ib.lt.0) then
            call spectral_dump(kr,-ib,0)
            kl = kin + l_offset(kr)
            kc = kin + c_offset(kr)
            call arecord (   &
              r_nsb, r_nband, r_nbas, r_lntch,   &
              memory(kc), memory(kl), factc, factl,   &
              -ib,isb,ipola,kb, kif,lb_sel(isb,ipola),   &
              i_subsel(1,isb,ipola),jw1,jw2,ix,iy,   &
              vt,wt,.false.,error)
            if (error) return
            w1(iy,isb,ipola,ib) = wt(2,2)
            if (iy.eq.1) then
              if (wt(2,2).le.0) then
                y1(iy,isb,ipola,ib) = 0
              else
                y1(iy,isb,ipola,ib) = log(sqrt(vt(2,2)/wt(2,2)))
              endif
            elseif (iy.eq.2) then
              if (wt(2,2).le.0) then
                y1(iy,isb,ipola,ib) = 0
              else
                y1(iy,isb,ipola,ib) = vt(2,2)/wt(2,2)
              endif
            endif
            ! Not needed if JSB is zero (no band-to-band or rec-to-rec conversion)
            if (jsb.gt.0) then
              if (isb.gt.2) then
                icsba(isb,ib,r_nrec) = 1.0
              elseif (do_pass_memory) then
                icsba(isb,ib,r_nrec) = sba(isb,ib,r_nrec)
              elseif (r_abpc.ne.0) then
                icsba(isb,ib,r_nrec) = r_abpcsba(1,isb,-ib)
              elseif (r_bpc.ne.0) then
                do i=1,r_nbas
                  z(i) = r_bpcsba(1,isb,i)
                  w(i) = 1.
                enddo
                call antgain(z,w,zant,want)
                icsba(isb,ib,r_nrec) = zant(-ib)
              else
                call message(8,2,'GET_SELF_CAL',   &
                  'No RF Passband available')
              endif
            endif
          else
            call spectral_dump(kr,0,ib)
            kl = kin + l_offset(kr)
            kc = kin + c_offset(kr)
            call brecord (   &
              r_nsb, r_nband, r_nbas+r_ntri, r_lntch,   &
              memory(kc), memory(kl), factc, factl,   &
              ib,isb,ipola,kb,kif,lb_sel(isb,ipola),   &
              i_subsel(1,isb,ipola),jw1,jw2,ix,iy,   &
              vt,wt,error)
            if (error) return
            w1(iy,isb,ipola,ib) = wt(2,2)
            if (wt(2,2).le.0) then
              y1(iy,isb,ipola,ib) = 0
            else
              y1(iy,isb,ipola,ib) = vt(2,2)/wt(2,2)
            endif
            ! side band averages
            ! Not needed if JSB is zero (no band-to-band or rec-to-rec conversion)
            if (jsb.gt.0) then
              if (isb.gt.2) then
                icsba(isb,ib,r_nrec) = 1.0
              elseif (do_pass_memory) then
                icsba(isb,ib,r_nrec) = sba(isb,ib,r_nrec)
              elseif (r_bpc.ne.0) then
                icsba(isb,ib,r_nrec) = r_bpcsba(1,isb,ib)
              elseif (r_abpc.ne.0) then
                ia = r_iant(ib)
                ja = r_jant(ib)
                icsba(isb,ib,r_nrec) =   &
                  r_abpcsba(1,isb,ja)/r_abpcsba(1,isb,ia)
              else
                call message(8,2,'GET_SELF_CAL',   &
                  'No RF Passband available')
              endif
            endif
          endif
        enddo
      enddo
    enddo
  enddo
  !
  if (r_xnum.ne.kxsave) then
    call get_it(kxsave,error)
  endif
  !
  ! Phase (Iy=2) specifics:
  ! Convert from one receiver to the other (IR = origin receiver):
  ! Normally one should also correct for the varying path as a fonction of freq,
  !
  do iy=iy1, iy2
    if (iy.eq.1) then
      do ib = ibmin(iy), ibmax(iy)
        do isb= 1,2
          do ipola=1,2
            w2(1,isb,ipola,ib) = w1(1,isb,ipola,ib)
            y2(1,isb,ipola,ib) = y1(1,isb,ipola,ib)
          enddo
        enddo
      enddo
    else
      do ib = ibmin(iy), ibmax(iy)
        if (new_receivers) then
          do ipola=1,2
            !     Need the new parameters in data header (discussed with FG)
            ph_fac(1,ipola,ib,r_nrec) = r_flo1+r_fif1
            ph_fac(2,ipola,ib,r_nrec) = r_flo1-r_fif1
            ph_fac(3,ipola,ib,r_nrec) = r_flo1
          enddo
        else
          do ipola=1,2
            ph_fac(1,ipola,ib,r_nrec) = r_flo1+r_fif1
            ph_fac(2,ipola,ib,r_nrec) = r_flo1-r_fif1
            ph_fac(3,ipola,ib,r_nrec) = r_flo1
          enddo
        endif
        do isb= 1,2
          do ipola=1,2
            !
            ! in that case, JSB must not be Zero...
            if (ir.ne.r_nrec) then
              if (ph_fac(jsb,ipola,ib,ir).ne.0) then
                phmul = ph_fac(isb,ipola,ib,r_nrec)/   &
                  ph_fac(jsb,ipola,ib,ir)
              else
                write(ch,'(i1)') ir
                call message(8,4,'GET_SELF_CAL',   &
                  'Please do a RF passband for receiver '   &
                  //ch(1:1))
                error = .true.
                return
              endif
            else
              phmul = 1.0
            endif
            !
            ! convert from one sideband to another:
            factor_i = 0.0
            factor_j = 0.0
            if (jsb.ne.0 .and. .not. do_phase_ext) then
              if (jsb.ne.isb .or. ir.ne.r_nrec) then
                ! FACTOR_I from average band to target band ISB (current target receiver):
                call band_factor(ib,isb,r_nrec,factor_i,error)
                !
                ! FACTOR_J from average band to origin band JSB (origin receiver IR)
                call band_factor(ib,jsb,ir,factor_j,error)
              endif
              y2(2,isb,ipola,ib) =   &
                (mod(y1(2,jsb,ipola,ib)-factor_j+11*pi,2*pi)-pi)   &
                *phmul + factor_i
            else
              y2(2,isb,ipola,ib) = y1(2,isb,ipola,ib)
            endif
            w2(2,isb,ipola,ib) = w1(2,isb,ipola,ib)
          enddo
        enddo
      enddo
    endif
  enddo
  return
end subroutine get_self_cal

subroutine syncDataNew(ifb,nfb,subscanRange,error)
!
! Called by subroutines getfits and getfitsNew.
! Interpolates antenna and subreflector data at backend timestamp
! (linear between preceeding and following antenna and subreflector dump).
! Results are written into Mira structures DATA(ifb) (where ifb is the frontend-
! backend number).
!
! Unlike subroutine syncData, does not apply any timing check.
!

  use mira
  use gildas_def

  implicit none

  integer :: ifb, nfb
  integer, dimension(2) :: subscanRange 
  logical :: error

  integer :: i, ibd, ier, ilo, isub, iup, i1, i2, i3, i4, j, k, l,          &
     &       locate, nbd, nchan, newchan, nfebe, nphases, npix 
  integer :: ndumpAntenna, ndumpAntennaNew, ndumpAntennaFast,               &
     &       ndumpAntennaFastNew, ndumpBackend, ndumpBackendNew,            &
     &       ndumpCryo, ndumpFrontend, ndumpSubref, ndumpSubrefNew
  real*4  :: meanCounts
  real*8  :: dTime1, dTime2, gainMax1, gainMax2, slope, trackingCutoff
 
  real*8, dimension(nsubscan)       :: subScanEnd, subScanStart

  integer(kind=address_length),dimension(9) :: desc
  integer, dimension(:), allocatable   :: indxFast, indxSlow, indxSubref
  character(len=20)                    :: tmpScanType, tmpSwitchMode
  character(len=32)                    :: tmpFrontend
  logical                              :: doShift, exist, scanStart, trackFlag
  logical, dimension(:,:), allocatable :: mask,tmpMask
  logical, dimension(:), allocatable   :: maskFSW,tmpMaskFSW
  logical, dimension(:), allocatable   :: subScanFastMask, subScanMask,    &
      &                                   subScanSubrefMask

!
!
!
  trackingCutoff = raw(1)%antenna(ifb)%trackingError
  ndumpBackend = size(dt(ifb)%data%mjd)
  ndumpAntenna = size(mnt(ifb)%data%lst,1)
  ndumpAntennaFast = size(mnt(ifb)%data%encoder_az_el,1)
  ndumpSubref = size(mnt(ifb)%data%focus_x_y_z,1)
  ndumpFrontend = size(mnt(ifb)%data%tamb_p_humid,1)
!
  nfebe = scan%header%nfebe
  nbd = febe(ifb)%header%febeband
  nchan = ar(ifb)%header(1)%channels 
  newchan = dt(ifb)%header%channels
  npix = febe(ifb)%header%febefeed
  nphases = febe(ifb)%header%nphases
!
!
!
  do isub = 1, nsubscan
     subScanStart(isub) = raw(isub)%antenna(ifb)%subScanStart
     subScanEnd(isub)   = raw(isub)%antenna(ifb)%subScanEnd
  enddo
!
  do i = 1, ndumpAntenna
     do isub = subscanRange(1), subscanRange(2)
        i1 = isub-subscanRange(1)+1
        if (mnt(ifb)%data%mjd(i).ge.subScanStart(i1).and. &
            mnt(ifb)%data%mjd(i).le.subScanEnd(i1)) then
            mnt(ifb)%data%subScan(i) = isub
            exit
        else
            cycle
        endif
     enddo
  enddo
!
  do i = 1, ndumpAntennaFast
     do isub = subscanRange(1), subscanRange(2)
        i1 = isub-subscanRange(1)+1
        if (mnt(ifb)%data%encoder_az_el(i,3).ge.subScanStart(i1).and.    &
 &          mnt(ifb)%data%encoder_az_el(i,3).le.subScanEnd(i1)) then
           mnt(ifb)%data%subScanFast(i) = isub
           exit
        else
           cycle
        endif
     enddo
  enddo
!
  do i = 1, ndumpSubref
     do isub = 1, nsubscan
        i1 = isub-subscanRange(1)+1
        if (mnt(ifb)%data%focus_x_y_z(i,4).ge.subScanStart(i1).and.    &
 &          mnt(ifb)%data%focus_x_y_z(i,4).le.subScanEnd(i1)) then
           mnt(ifb)%data%subScanSubref(i) = isub
           exit
        else
           cycle
        endif
     enddo
  enddo
!
  tmpScanType = scan%header%scantype
  call sic_upper(tmpScanType)
  dt(ifb)%data%subScan(1:ndumpBackend) = 0
  do i = 1, ndumpBackend
     do isub = subscanRange(1), subscanRange(2)
        i1 = isub-subscanRange(1)+1 
        if (dt(ifb)%data%mjd(i)-dt(ifb)%data%integtim(i)*sec2day.ge.    &
 &         subScanStart(i1).and.dt(ifb)%data%mjd(i).le.subScanEnd(i1)) then
           dt(ifb)%data%subScan(i) = isub
           if (nphases.eq.1.and.tmpscantype.eq.'ONTHEFLYMAP') then
              do j=1, nbd
                 if (raw(i1)%antenna(j)%subscantype.eq.'track') then
                    ar(ifb)%data(j)%iswitch(i,1) = 'OFF'
                 else if (raw(i1)%antenna(j)%subscantype &
 &                        .eq.'onTheFly') then
                    ar(ifb)%data(j)%iswitch(i,1) = 'ON'
                 else
                    ar(ifb)%data(j)%iswitch(i,1) = 'NONE'
                 endif
              enddo
           endif
           exit
        else
           cycle
        endif
!
! The above IF condition may have to be relaxed. Here I only accept backend
! dumps during which no subScanStart or subScanEnd timestamps occur.
!

     enddo
  enddo
  do i = 2, ndumpBackend
     if (dt(ifb)%data%mjd(i).eq.dt(ifb)%data%mjd(i-1)) &
 &      dt(ifb)%data%subscan(i) = 0
  enddo
!
  if (allocated(indxSlow)) deallocate(indxSlow,stat=ier)
  allocate(indxSlow(ndumpAntenna),stat=ier)
  call indexx(ndumpAntenna,mnt(ifb)%data%mjd,indxSlow)
!
  ndumpAntennaNew = 1 
  do i = 1, ndumpAntenna-1
     if (mnt(ifb)%data%mjd(indxSlow(i+1)).ne.                     &
 &       mnt(ifb)%data%mjd(indxSlow(i)))                          &
 &      ndumpAntennaNew = ndumpAntennaNew+1
  enddo
!
  if (allocated(indxFast)) deallocate(indxFast,stat=ier)
  allocate(indxFast(ndumpAntennaFast),stat=ier)
  call indexx(ndumpAntennaFast,mnt(ifb)%data%encoder_az_el(:,3),indxFast)
!
  ndumpAntennaFastNew = 1 
  do i = 1, ndumpAntennaFast-1
     if (mnt(ifb)%data%encoder_az_el(indxFast(i+1),3).ne.          &
         mnt(ifb)%data%encoder_az_el(indxFast(i),3))               &
 &      ndumpAntennaFastNew = ndumpAntennaFastNew+1
  enddo
!
  if (allocated(indxSubref)) deallocate(indxSubref,stat=ier)
  allocate(indxSubref(ndumpSubref),stat=ier)
  call indexx(ndumpSubref,mnt(ifb)%data%focus_x_y_z(:,4),indxSubref)
!
  ndumpSubrefNew = 1
  do i = 1, ndumpSubref-1
     if (mnt(ifb)%data%focus_x_y_z(indxSubref(i+1),4).ne.           &
 &       mnt(ifb)%data%focus_x_y_z(indxSubref(i),4))                &
 &      ndumpSubrefNew = ndumpSubrefNew+1
  enddo
!
  ndumpBackendNew = 0
  do i = 1, ndumpBackend
     if (dt(ifb)%data%subscan(i).ne.0)                   &
 &      ndumpBackendNew = ndumpBackendNew+1
  enddo
!
!
!
  if (ifb.eq.1) allocate(monBuf(nfebe))
  monBuf(ifb)%header = mnt(ifb)%header
!
  allocate(monBuf(ifb)%data%subScan(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%subScanFast(ndumpAntennaFastNew),      &
     &     monBuf(ifb)%data%subScanSubref(ndumpSubrefNew),         &
     &     monBuf(ifb)%data%mjd(ndumpAntennaNew),                  &
     &     monBuf(ifb)%data%lst(ndumpAntennaNew),                  &
     &     monBuf(ifb)%data%encoder_az_el(ndumpAntennaFastNew,3),  &
     &     monBuf(ifb)%data%tracking_az_el(ndumpAntennaFastNew,2), &
     &     monBuf(ifb)%data%longoff(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%latoff(ndumpAntennaNew),               &
     &     monBuf(ifb)%data%baslong(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%baslat(ndumpAntennaNew),               &
     &     monBuf(ifb)%data%parangle(ndumpAntennaNew),             &
     &     monBuf(ifb)%data%antenna_az_el(2),                      &
     &     monBuf(ifb)%data%tamb_p_humid(ndumpFrontend,3),         &
     &     monBuf(ifb)%data%wind_dir_vavg_vmax(ndumpFrontend,3),   &
     &     monBuf(ifb)%data%thotcold(ndumpFrontend,2),             &
     &     monBuf(ifb)%data%refractio(ndumpFrontend),              &
     &     monBuf(ifb)%data%focus_x_y_z(ndumpSubrefNew,4),         &
     &     monBuf(ifb)%data%dfocus_x_y_z(ndumpSubrefNew,3),        &
     &     monBuf(ifb)%data%phi_x_y_z(ndumpSubrefNew,3),           &
     &     monBuf(ifb)%data%dphi_x_y_z(ndumpSubrefNew,3),          &
     &     stat = ier)
  allocate(subScanSubrefMask(ndumpSubrefNew),                 &
     &     subScanMask(ndumpAntenna),                         &
     &     subScanFastMask(ndumpAntennaFastNew),stat = ier)
  monBuf(ifb)%data%antenna_az_el = mnt(ifb)%data%antenna_az_el
  monBuf(ifb)%data%tamb_p_humid = mnt(ifb)%data%tamb_p_humid
  monBuf(ifb)%data%wind_dir_vavg_vmax = mnt(ifb)%data%wind_dir_vavg_vmax
  monBuf(ifb)%data%thotcold  = mnt(ifb)%data%thotcold
!
  ilo = 1
  i1  = indxSlow(1)
  monBuf(ifb)%data%subScan(1) = mnt(ifb)%data%subScan(i1)
  monBuf(ifb)%data%mjd(1) = mnt(ifb)%data%mjd(i1)
  monBuf(ifb)%data%lst(1) = mnt(ifb)%data%lst(i1)
  monBuf(ifb)%data%longoff(1) = mnt(ifb)%data%longoff(i1)
  monBuf(ifb)%data%latoff(1) =  mnt(ifb)%data%latoff(i1)
  monBuf(ifb)%data%baslong(1) = mnt(ifb)%data%baslong(i1)
  monBuf(ifb)%data%baslat(1) = mnt(ifb)%data%baslat(i1)
  monBuf(ifb)%data%parangle(1) = mnt(ifb)%data%parangle(i1)
  do i = 1, ndumpAntenna-1
     i1 = indxSlow(i)
     i2 = indxSlow(i+1)

     if (mnt(ifb)%data%mjd(i2).ne.mnt(ifb)%data%mjd(i1)) then
        ilo = ilo+1
        monBuf(ifb)%data%subScan(ilo) = mnt(ifb)%data%subScan(i2)
        monBuf(ifb)%data%mjd(ilo) = mnt(ifb)%data%mjd(i2)
        monBuf(ifb)%data%lst(ilo) = mnt(ifb)%data%lst(i2)
        monBuf(ifb)%data%longoff(ilo) = mnt(ifb)%data%longoff(i2)
        monBuf(ifb)%data%latoff(ilo) =  mnt(ifb)%data%latoff(i2)
        monBuf(ifb)%data%baslong(ilo) = mnt(ifb)%data%baslong(i2)
        monBuf(ifb)%data%baslat(ilo) = mnt(ifb)%data%baslat(i2)
        monBuf(ifb)%data%parangle(ilo) = mnt(ifb)%data%parangle(i2)
     endif
  enddo
!
  ilo = 1
  i1 = indxFast(1)
  monBuf(ifb)%data%subScanFast(1) = mnt(ifb)%data%subScanFast(i1)
  monBuf(ifb)%data%encoder_az_el(1,1:3) = mnt(ifb)%data%encoder_az_el(i1,1:3)
  monBuf(ifb)%data%tracking_az_el(1,1:2) = mnt(ifb)%data%tracking_az_el(i1,1:2)
  do i = 1, ndumpAntennaFast-1
     i1 = indxFast(i)
     i2 = indxFast(i+1)
     if (mnt(ifb)%data%encoder_az_el(i2,3).ne.                          &
 &       mnt(ifb)%data%encoder_az_el(i1,3)) then
        ilo = ilo+1
        monBuf(ifb)%data%subScanFast(ilo) = mnt(ifb)%data%subScanFast(i2)
        monBuf(ifb)%data%encoder_az_el(ilo,1:3)                          &
 &      = mnt(ifb)%data%encoder_az_el(i2,1:3)
        monBuf(ifb)%data%tracking_az_el(ilo,1:2)                         &
 &      = mnt(ifb)%data%tracking_az_el(i2,1:2)
     endif
  enddo
!
  i1 = indxSubref(1)
  monBuf(ifb)%data%subScanSubref(1)   = mnt(ifb)%data%subScanSubref(i1)
  monBuf(ifb)%data%focus_x_y_z(1,1:4) = mnt(ifb)%data%focus_x_y_z(i1,1:4)
  monBuf(ifb)%data%dfocus_x_y_z(1,1:3)= mnt(ifb)%data%dfocus_x_y_z(i1,1:3)
  monBuf(ifb)%data%phi_x_y_z(1,1:3)   = mnt(ifb)%data%phi_x_y_z(i1,1:3)
  monBuf(ifb)%data%dphi_x_y_z(1,1:3)  = mnt(ifb)%data%dphi_x_y_z(i1,1:3)
  ilo = 1
  do i = 1, ndumpSubref-1
     i1 = indxSubref(i)
     i2 = indxSubref(i+1)
     if (mnt(ifb)%data%focus_x_y_z(i2,4).ne.mnt(ifb)%data%focus_x_y_z(i1,4)) then
        ilo = ilo+1
        monBuf(ifb)%data%subScanSubref(ilo)   = mnt(ifb)%data%subScanSubref(i2)
        monBuf(ifb)%data%focus_x_y_z(ilo,1:4) = mnt(ifb)%data%focus_x_y_z(i2,1:4)
        monBuf(ifb)%data%dfocus_x_y_z(ilo,1:3)= mnt(ifb)%data%dfocus_x_y_z(i2,1:3)
        monBuf(ifb)%data%phi_x_y_z(ilo,1:3)   = mnt(ifb)%data%phi_x_y_z(i2,1:3)
        monBuf(ifb)%data%dphi_x_y_z(ilo,1:3)  = mnt(ifb)%data%dphi_x_y_z(i2,1:3)
     endif
  enddo
!
  ndumpAntenna = ndumpAntennaNew
  ndumpAntennaFast = ndumpAntennaFastNew
  ndumpSubref = ndumpSubrefNew
!
!
!
  if (ifb.eq.1) allocate(dataBuf(nfebe),stat=ier)
  dataBuf(ifb)%header = dt(ifb)%header
  allocate(dataBuf(ifb)%data%subscan(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mjd(ndumpBackendNew),                    &
  &        dataBuf(ifb)%data%integnum(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%nints(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%lst(ndumpBackendNew),                    &
  &        dataBuf(ifb)%data%midtime(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%integtim(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%longoff(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%latoff(ndumpBackendNew),                 &
  &        dataBuf(ifb)%data%azimuth(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%elevatio(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%cbaslong(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%cbaslat(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%baslong(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%baslat(ndumpBackendNew),                 &
  &        dataBuf(ifb)%data%parangle(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%pc_11(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_12(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_21(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_22(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%mcrval1(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mcrval2(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mlonpole(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%mlatpole(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%dfocus_x_y_z(ndumpBackendNew,3),         &
  &        dataBuf(ifb)%data%focus_x_y_z(ndumpBackendNew,3),          &
  &        dataBuf(ifb)%data%dphi_x_y_z(ndumpBackendNew,3),           &
  &        dataBuf(ifb)%data%phi_x_y_z(ndumpBackendNew,3),            &
  &        dataBuf(ifb)%data%otfdata(npix,newchan,ndumpBackendNew),   &    
  &        dataBuf(ifb)%data%rdata(npix,newchan),                     &
  &        dataBuf(ifb)%data%cr4K1(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%cr4K2(ndumpBackendNew),                  &
  &        stat = ier)
  if (ifb.eq.1) allocate(arrayBuf(nfebe),stat=ier)
  allocate(arrayBuf(ifb)%data(nbd),arrayBuf(ifb)%header(nbd),stat=ier)
  arrayBuf(ifb)%header(1:nbd) = ar(ifb)%header(1:nbd)
  do i = 1, nbd
     allocate(arrayBuf(ifb)%data(i)%data(npix,nchan,ndumpBackendNew,nphases), &
  &           arrayBuf(ifb)%data(i)%iswitch(ndumpBackendNew,nphases),         &
  &           arrayBuf(ifb)%data(i)%mjd(ndumpBackendNew*nphases),             &
  &           arrayBuf(ifb)%data(i)%integtim(ndumpBackendNew*nphases),        &
  &           stat=ier)
  enddo
  !
  ilo = 0
  do i = 1, ndumpBackend
     if (dt(ifb)%data%subscan(i).ne.0) then
        ilo = ilo+1
        dataBuf(ifb)%data%subscan(ilo) = dt(ifb)%data%subscan(i)
        dataBuf(ifb)%data%mjd(ilo) = dt(ifb)%data%mjd(i)
        dataBuf(ifb)%data%integnum(ilo) = ilo
        dataBuf(ifb)%data%nints(ilo) = dt(ifb)%data%nints(i)
        dataBuf(ifb)%data%lst(ilo) = dt(ifb)%data%lst(i)
        dataBuf(ifb)%data%midtime(ilo) = dt(ifb)%data%midtime(i)
        dataBuf(ifb)%data%integtim(ilo) = dt(ifb)%data%integtim(i)
        dataBuf(ifb)%data%longoff(ilo) = dt(ifb)%data%longoff(i)
        dataBuf(ifb)%data%latoff(ilo) = dt(ifb)%data%latoff(i)
        dataBuf(ifb)%data%azimuth(ilo) = dt(ifb)%data%azimuth(i)
        dataBuf(ifb)%data%elevatio(ilo) = dt(ifb)%data%elevatio(i)
        dataBuf(ifb)%data%cbaslong(ilo) = dt(ifb)%data%cbaslong(i)
        dataBuf(ifb)%data%cbaslat(ilo) = dt(ifb)%data%cbaslat(i)
        dataBuf(ifb)%data%baslong(ilo) = dt(ifb)%data%baslong(i)
        dataBuf(ifb)%data%baslat(ilo) = dt(ifb)%data%baslat(i)
        dataBuf(ifb)%data%parangle(ilo) = dt(ifb)%data%parangle(i)
        dataBuf(ifb)%data%pc_11(ilo) = dt(ifb)%data%pc_11(i)
        dataBuf(ifb)%data%pc_12(ilo) = dt(ifb)%data%pc_12(i)
        dataBuf(ifb)%data%pc_21(ilo) = dt(ifb)%data%pc_21(i)
        dataBuf(ifb)%data%pc_22(ilo) = dt(ifb)%data%pc_22(i)
        dataBuf(ifb)%data%cr4K1(ilo) = dt(ifb)%data%cr4K1(i)
        dataBuf(ifb)%data%cr4K2(ilo) = dt(ifb)%data%cr4K2(i)
        dataBuf(ifb)%data%mcrval1(ilo) = dt(ifb)%data%mcrval1(i)
        dataBuf(ifb)%data%mcrval2(ilo) = dt(ifb)%data%mcrval2(i)
        dataBuf(ifb)%data%mlonpole(ilo) = dt(ifb)%data%mlonpole(i)
        dataBuf(ifb)%data%mlatpole(ilo) = dt(ifb)%data%mlatpole(i)
        dataBuf(ifb)%data%otfdata(npix,1:newchan,ilo)                 &
 &      = dt(ifb)%data%otfdata(npix,1:newchan,i)
        dataBuf(ifb)%data%rdata(npix,1:newchan)                       &
 &      = dt(ifb)%data%rdata(npix,1:newchan) 
        i1 = (ilo-1)*nphases+1
        i2 = ilo*nphases
        i3 = (i-1)*nphases+1
        i4 = i*nphases
        do j = 1, nbd
           arrayBuf(ifb)%data(j)%data(1:npix,1:nchan,ilo,1:nphases)    &
 &         = ar(ifb)%data(j)%data(1:npix,1:nchan,i,1:nphases)
           arrayBuf(ifb)%data(j)%iswitch(ilo,1:nphases)     &
 &         = ar(ifb)%data(j)%iswitch(i,1:nphases)
           arrayBuf(ifb)%data(j)%mjd(i1:i2) = ar(ifb)%data(j)%mjd(i3:i4)
           arrayBuf(ifb)%data(j)%integtim(i1:i2) = ar(ifb)%data(j)%integtim(i3:i4)
        enddo
     endif
  enddo

  ndumpBackend = ndumpBackendNew
! 
! now interpolate monitor data at sampling of backend data
!
  do i = 1, ndumpBackend
     
     ilo = locate(monBuf(ifb)%data%mjd,dataBuf(ifb)%data%midtime(i),ndumpAntenna)

     extrapolateSlowTrace: if (.not.traceExtrapolation.and. &
                               (ilo.eq.0.or.ilo.eq.ndumpAntenna)) then
        dataBuf(ifb)%data%lst(i)      = 0.d0
        dataBuf(ifb)%data%longoff(i)  = 0.d0
        dataBuf(ifb)%data%latoff(i)   = 0.d0
        dataBuf(ifb)%data%baslong(i)  = 0.d0
        dataBuf(ifb)%data%baslat(i)   = 0.d0
        dataBuf(ifb)%data%parangle(i) = 0.d0
        do ibd=1,nbd
           arrayBuf(ifb)%data(ibd)%data(1:npix,1:nchan,i,1:nphases) = blankingRaw
        enddo
     else
        if (ilo.eq.0) then
           ilo = 1
        else if (ilo.eq.ndumpAntenna) then
           ilo = ndumpAntenna-1
        endif
        iup = ilo+1

        dTime1 = monBuf(ifb)%data%mjd(iup)-monBuf(ifb)%data%mjd(ilo)
        dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%mjd(ilo)

        slope = (monBuf(ifb)%data%lst(iup)-monBuf(ifb)%data%lst(ilo))/dTime1 
        dataBuf(ifb)%data%lst(i) = monBuf(ifb)%data%lst(ilo)+dTime2*slope
 
        slope = (monBuf(ifb)%data%longoff(iup)-monBuf(ifb)%data%longoff(ilo))/dTime1 
        dataBuf(ifb)%data%longoff(i) = monBuf(ifb)%data%longoff(ilo)+dTime2*slope

        slope = (monBuf(ifb)%data%latoff(iup)-monBuf(ifb)%data%latoff(ilo))/dTime1 
        dataBuf(ifb)%data%latoff(i) = monBuf(ifb)%data%latoff(ilo)+dTime2*slope

        slope = (monBuf(ifb)%data%baslong(iup)-monBuf(ifb)%data%baslong(ilo))/dTime1 
        dataBuf(ifb)%data%baslong(i) = monBuf(ifb)%data%baslong(ilo)+dTime2*slope

        slope = (monBuf(ifb)%data%baslat(iup)-monBuf(ifb)%data%baslat(ilo))/dTime1 
        dataBuf(ifb)%data%baslat(i) = monBuf(ifb)%data%baslat(ilo)+dTime2*slope

        slope = (monBuf(ifb)%data%parangle(iup)-monBuf(ifb)%data%parangle(ilo))/dTime1 
        dataBuf(ifb)%data%parangle(i) = monBuf(ifb)%data%parangle(ilo)+dTime2*slope

     endif extrapolateSlowTrace

     ilo = locate(monBuf(ifb)%data%encoder_az_el(1:ndumpAntennaFast,3),          &
   &              dataBuf(ifb)%data%midtime(i),ndumpAntennaFast)

     extrapolateFastTrace: if (.not.traceExtrapolation.and. &
                               (ilo.eq.0.or.ilo.eq.ndumpAntennaFast)) then

        dataBuf(ifb)%data%azimuth(i)  = 0.d0
        dataBuf(ifb)%data%elevatio(i) = 0.d0
        do ibd=1,nbd
           arrayBuf(ifb)%data(ibd)%data(1:npix,1:nchan,i,1:nphases) = blankingRaw
        enddo

     else

        if (ilo.eq.0) then
           ilo = 1
        else if (ilo.eq.ndumpAntennaFast) then
           ilo = ndumpAntennaFast-1
        endif

        dTime1 = monBuf(ifb)%data%encoder_az_el(iup,3)                            &
 &               -monBuf(ifb)%data%encoder_az_el(ilo,3)
        dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%encoder_az_el(ilo,3)

        slope = (monBuf(ifb)%data%encoder_az_el(iup,1)                            &
 &              -monBuf(ifb)%data%encoder_az_el(ilo,1))                           &
 &              /dTime1 
        dataBuf(ifb)%data%azimuth(i) = monBuf(ifb)%data%encoder_az_el(ilo,1)+dTime2*slope

        slope = (monBuf(ifb)%data%encoder_az_el(iup,2)                            &
 &               -monBuf(ifb)%data%encoder_az_el(ilo,2))                          &
 &             /dTime1 
        dataBuf(ifb)%data%elevatio(i) = monBuf(ifb)%data%encoder_az_el(ilo,2)     &
 &                                   +dTime2*slope


     endif extrapolateFastTrace

     if (associated(cryo)) then
        ndumpCryo = size(cryo%mjd)
        if (ndumpCryo.gt.1) then
           ilo = locate(                                                     &
   &                    cryo%mjd(1:ndumpCryo),dataBuf(ifb)%data%midtime(i),     &
   &                    ndumpCryo)
           if (ilo.eq.0) ilo = 1
           if (ilo.lt.ndumpCryo) then
               iup = ilo+1
           else
               iup = ilo
           endif
        else
           ilo = 1
           iup = 1
        endif
        if (ilo.eq.iup) then
           dataBuf(ifb)%data%cr4K1(i) = cryo%cr4K1(ilo)
           dataBuf(ifb)%data%cr4K2(i) = cryo%cr4K2(ilo)
        else
           dTime2 = dataBuf(ifb)%data%midtime(i)-cryo%mjd(ilo)
           dTime1 = cryo%mjd(iup)-cryo%mjd(ilo)
           slope = (cryo%cr4K1(iup)-cryo%cr4K1(ilo))/dTime1 
           dataBuf(ifb)%data%cr4K1(i) = cryo%cr4K1(ilo)+dTime2*slope
           slope = (cryo%cr4K2(iup)-cryo%cr4K2(ilo))/dTime1 
           dataBuf(ifb)%data%cr4K2(i) = cryo%cr4K2(ilo)+dTime2*slope
        endif
     endif

     trackFlag = .false.
     if (abs(monBuf(ifb)%data%antenna_az_el(1)-130.5).lt.1.0.and.                &
   &     mod(3.6d+2,monBuf(ifb)%data%antenna_az_el(2)).lt.1.0) then
        trackFlag = .false.  ! use data with crazy tracking errors if antenna in stow position
     else if (abs(monBuf(ifb)%data%tracking_az_el(ilo,1)).gt.trackingCutoff.or.  &
   &     abs(monBuf(ifb)%data%tracking_az_el(ilo,2)).gt.trackingCutoff.or.       &
   &     abs(monBuf(ifb)%data%tracking_az_el(iup,1)).gt.trackingCutoff.or.       &
   &     abs(monBuf(ifb)%data%tracking_az_el(iup,2)).gt.trackingCutoff) then
         do j = 1, nbd
            i1 = (i-1)*nphases+1
            i2 = i*nphases
            arrayBuf(ifb)%data(j)%data(1:npix,1:nchan,i1:i2,1:nphases) =blankingRaw
            trackFlag = .true.
         enddo
     endif
     if (trackFlag) call gagout('W-SYNC: Data flagged due to large tracking errors.')
     if (ndumpSubref.gt.1) then 
        ilo = locate(monBuf(ifb)%data%focus_x_y_z(1:ndumpSubref,4),              &
   &                 dataBuf(ifb)%data%midtime(i),ndumpSubref)

        if (ilo.eq.0) then
           ilo = 1
        else if (ilo.eq.ndumpSubref) then
           ilo = ndumpSubref-1
        endif

        iup = ilo+1

        if (monBuf(ifb)%data%subScanSubref(ilo)                                 &
   &        .ne.monBuf(ifb)%data%subScanSubref(iup)) then
           if (dataBuf(ifb)%data%subscan(i).eq.monBuf(ifb)%data%subScanSubref(ilo)) &
   &       then
              ilo = ilo-1
              iup = iup-1
           else
              ilo = ilo+1
              iup = iup+1
           endif
        endif

        dTime1 = monBuf(ifb)%data%focus_x_y_z(iup,4)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,4)
        dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%focus_x_y_z(ilo,4)

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,1)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,1))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,1) = monBuf(ifb)%data%focus_x_y_z(ilo,1)  &
   &                                      +dTime2*slope

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,2)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,2))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,2) = monBuf(ifb)%data%focus_x_y_z(ilo,2)  &
   &                                      +dTime2*slope

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,3)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,3))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,3) = monBuf(ifb)%data%focus_x_y_z(ilo,3)  &
   &                                      +dTime2*slope

        dataBuf(ifb)%data%dfocus_x_y_z(i,1)=monBuf(ifb)%data%dfocus_x_y_z(ilo,1)
        dataBuf(ifb)%data%dfocus_x_y_z(i,2)=monBuf(ifb)%data%dfocus_x_y_z(ilo,2)
        dataBuf(ifb)%data%dfocus_x_y_z(i,3)=monBuf(ifb)%data%dfocus_x_y_z(ilo,3)

        slope = (monBuf(ifb)%data%phi_x_y_z(iup,3)                            &
   &             -monBuf(ifb)%data%phi_x_y_z(ilo,3))                          &
   &            /dTime1 
        dataBuf(ifb)%data%phi_x_y_z(i,3) = monBuf(ifb)%data%phi_x_y_z(ilo,3)     &
   &                                    +dTime2*slope
     else
        dataBuf(ifb)%data%focus_x_y_z(i,1:3)=monBuf(ifb)%data%focus_x_y_z(1,1:3)
        dataBuf(ifb)%data%dfocus_x_y_z(i,3) = monBuf(ifb)%data%dfocus_x_y_z(1,3)
        dataBuf(ifb)%data%phi_x_y_z(i,3) = monBuf(ifb)%data%phi_x_y_z(1,3)
     endif
  enddo

  tmpSwitchMode = febe(ifb)%header%swtchmod
  call sic_upper(tmpSwitchMode)

  if (index(tmpScanType,'CAL').ne.0.and.index(tmpSwitchMode,'FREQ').eq.0) then

     gn(ifb)%psky(:,:,:) = blankingRaw
     gn(ifb)%phot(:,:,:) = blankingRaw
     gn(ifb)%pcold(:,:,:) = blankingRaw

     if (allocated(mask)) deallocate(mask,stat=ier)
     allocate(mask(ndumpBackend,nphases),stat=ier)
     if (allocated(tmpMask)) deallocate(tmpMask,stat=ier)
     allocate(tmpMask(ndumpBackend,nphases),stat=ier)

     do i = subscanRange(1), subscanRange(2)
        i1 = i-subscanRange(1)+1
        do j = 1, nphases
          mask(1:ndumpBackend,j) = dataBuf(ifb)%data%subscan.eq.i
        enddo
        if (index(raw(i1)%antenna(ifb)%subScanType,'Sky').ne.0.or.              &
   &        index(raw(i1)%subRef(ifb)%subScanType,'Sky').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan 
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%psky(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%psky(j,k,:))/nchan
                 where(gn(ifb)%psky(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%psky(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%psky(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Ambient').ne.0.or.     &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Ambient').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%phot(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%phot(j,k,:))/nchan
                 where(gn(ifb)%phot(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%phot(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%phot(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Cold').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Cold').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%pcold(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%pcold(j,k,:))/nchan
                 where(gn(ifb)%pcold(j,k,:).lt.meanCounts/badLevel.or.         &
   &                   gn(ifb)%pcold(j,k,:).gt.meanCounts*badLevel)            &
   &                   gn(ifb)%pcold(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Grid').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Grid').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%pgrid(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = abs(sum(gn(ifb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.    &
   &                   abs(gn(ifb)%pgrid(j,k,:)).gt.meanCounts*badLevel)       &
   &                   gn(ifb)%pgrid(j,k,:) = blankingRaw
              enddo
           enddo

        else 
           
           call gagout('W-SYNC: Subscan type unknown. Cannot attribute '       &
   &                   //' mean calibration counts.')

        endif

     enddo

 
     tmpFrontend = febe(ifb)%header%febe
     call sic_upper(tmpFrontend)
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        where (gn(ifb)%phot.ne.blankingRaw.and.gn(ifb)%psky.ne.blankingRaw)
           gn(ifb)%gainarray = gn(ifb)%phot-gn(ifb)%psky
        else where
           gn(ifb)%gainarray = blankingRaw 
        end where
     endif

  else if (index(tmpScanType,'CAL').ne.0.and.index(tmpSwitchMode,'FREQ').ne.0) &
 &then

     gn(ifb)%psky(:,:,:) = blankingRaw
     gn(ifb)%phot(:,:,:) = blankingRaw
     gn(ifb)%pcold(:,:,:) = blankingRaw
     gn(ifb+nfb)%psky(:,:,:) = blankingRaw
     gn(ifb+nfb)%phot(:,:,:) = blankingRaw
     gn(ifb+nfb)%pcold(:,:,:) = blankingRaw

     if (allocated(maskFSW)) deallocate(maskFSW,stat=ier)
     allocate(maskFSW(ndumpBackend),stat=ier)
     if (allocated(tmpMaskFSW)) deallocate(tmpMaskFSW,stat=ier)
     allocate(tmpMaskFSW(ndumpBackend),stat=ier)

     do i = subscanRange(1), subscanRange(2)
        i1 = i-subscanRange(1)+1
        maskFSW(1:ndumpBackend) = dataBuf(ifb)%data%subscan.eq.i

        if (index(raw(i1)%antenna(ifb)%subScanType,'Sky').ne.0.or.              &
   &        index(raw(i1)%subRef(ifb)%subScanType,'Sky').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan 
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%psky(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%psky(j,k,l)                                    &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%psky(j,k,:))/nchan
                 where(gn(ifb)%psky(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%psky(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%psky(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%psky(j,k,:))/nchan
                 where(gn(ifb+nfb)%psky(j,k,:).lt.meanCounts/badLevel.or.      &
   &                   gn(ifb+nfb)%psky(j,k,:).gt.meanCounts*badLevel)         &
   &                   gn(ifb+nfb)%psky(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Ambient').ne.0.or.     &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Ambient').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%phot(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%phot(j,k,l)                                    &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%phot(j,k,:))/nchan
                 where(gn(ifb)%phot(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%phot(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%phot(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%phot(j,k,:))/nchan
                 where(gn(ifb+nfb)%phot(j,k,:).lt.meanCounts/badLevel.or.      &
   &                   gn(ifb+nfb)%phot(j,k,:).gt.meanCounts*badLevel)         &
   &                   gn(ifb+nfb)%phot(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Cold').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Cold').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%pcold(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%pcold(j,k,l)                                   &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%pcold(j,k,:))/nchan
                 where(gn(ifb)%pcold(j,k,:).lt.meanCounts/badLevel.or.         &
   &                   gn(ifb)%pcold(j,k,:).gt.meanCounts*badLevel)            &
   &                   gn(ifb)%pcold(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%pcold(j,k,:))/nchan
                 where(gn(ifb+nfb)%pcold(j,k,:).lt.meanCounts/badLevel.or.     &
   &                   gn(ifb+nfb)%pcold(j,k,:).gt.meanCounts*badLevel)        &
   &                   gn(ifb+nfb)%pcold(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Grid').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Grid').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%pgrid(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%pgrid(j,k,l)                                   &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = abs(sum(gn(ifb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.    &
   &                   abs(gn(ifb)%pgrid(j,k,:)).gt.meanCounts*badLevel)       &
   &                   gn(ifb)%pgrid(j,k,:) = blankingRaw
                 meanCounts = abs(sum(gn(ifb+nfb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb+nfb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.&
   &                   abs(gn(ifb+nfb)%pgrid(j,k,:)).gt.meanCounts*badLevel)   &
   &                   gn(ifb+nfb)%pgrid(j,k,:) = blankingRaw
              enddo
           enddo

        else 
           
           call gagout('W-SYNC: Subscan type unknown. Cannot attribute '       &
   &                   //' mean calibration counts.')

        endif

     enddo
 
     tmpFrontend = febe(ifb)%header%febe
     call sic_upper(tmpFrontend)
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        where (gn(ifb)%phot.ne.blankingRaw.and.gn(ifb)%psky.ne.blankingRaw)
           gn(ifb)%gainarray = gn(ifb)%phot-gn(ifb)%psky
        else where
           gn(ifb)%gainarray = blankingRaw 
        end where
     endif
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        
        where (gn(ifb+nfb)%phot.ne.blankingRaw.and.gn(ifb+nfb)%psky.ne.       &
  &            blankingRaw)
           gn(ifb+nfb)%gainarray = gn(ifb+nfb)%phot-gn(ifb+nfb)%psky
        else where
           gn(ifb+nfb)%gainarray = blankingRaw 
        end where
     endif
    
  endif

  if (index(tmpSwitchMode,'WOB').ne.0.and.index(tmpScantype,'POINT').eq.0) then
     do i = 1, ndumpBackend
        isub = dataBuf(ifb)%data%subscan(i)
        if (raw(isub)%antenna(ifb)%subScanXOff.lt.0) then
          dataBuf(ifb)%data%longoff(i) = dataBuf(ifb)%data%longoff(i)      &
 &                                 +0.5*scan%header%wobthrow
        else
          dataBuf(ifb)%data%longoff(i) = dataBuf(ifb)%data%longoff(i)      &
 &                                 -0.5*scan%header%wobthrow
        endif
     enddo
  endif

  deallocate(indxSlow,indxFast,indxSubref,stat=ier)

end subroutine syncDataNew

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_otf_psw(mrtset,backcal,backsci,filebuf,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_otf_psw
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: ion,non
  character(len=*), parameter :: rname='CALIB>OTF>PSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_init_onloop(backsci,non,error)
  if (error) return
  do ion=1,non
     call mrtcal_get_nexton(backsci,error)
     if (error) return
     call mrtcal_otf_psw_prepare_nextoff(mrtset,filebuf,backsci,error)
     if (error) return
     call mrtcal_init_dumpcycle_loop('onTheFly',mrtset,filebuf,backsci,error)
     if (error) return
     do while (backsci%switch%book%idump.lt.backsci%switch%book%ndump)
        call mrtcal_get_next_otfpsw_cycle(mrtset,filebuf,backsci,error)
        if (error) return
        if (backsci%switch%book%found) then
           call mrtcal_on_minus_off(isotfmap,notfsw,backsci,error)
           if (error) return
           call mrtcal_tscale_computation(backcal,backsci,error)
           if (error) return
           call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
           if (error) return
           call mrtcal_write_toclass(backsci%diff,mrtset%out,backsci%nobs,error)
           if (error) return
        endif
     enddo ! switch%book%idump
     call mrtcal_switch_book_list(backsci%switch%book,error)
     if (error) return
     ! User can interrupt the pipeline
     if (sic_ctrlc_status()) then
        error = .true.
        exit
     endif
  enddo !ion
  !
end subroutine mrtcal_calib_otf_psw
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_get_next_otfpsw_cycle(mrtset,filebuf,backsci,error)
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_get_next_otfpsw_cycle
  !---------------------------------------------------------------------
  ! @ private
  ! OTF PSW is an hybrid case between tracked PSW that only deals with
  ! subscan cycles and (WSW and FSW) that only deal with dump cycle. In
  ! OTF PSW, the ON is delivered as a dump, but the OFF is typically
  ! interpolated between two OFF subscans.
  !
  ! So here, we first read the current ON dump and put it in the
  ! cycle%data(1) structure, we then compute the OFF "phase" from one or
  ! two OFF subscans and put it in the cycle%data(2) structure. We can then
  ! fill the switching sections based on the cycle%desc structure.
  ! ---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  type(science_backend_t), intent(inout) :: backsci
  logical,                 intent(inout) :: error
  !
  character(len=*), parameter :: rname='GET>NEXT>OTFPSW>CYCLE'
  !
  call mrtcal_find_next_dumpcycle(&
       filebuf%subscanbuf%subscan%backdata,&
       backsci%switch%book,error)
  if (error) return
  call mrtcal_read_next_dumpcycle(mrtset,&
       filebuf%imbf,&
       filebuf%subscanbuf%subscan,&
       filebuf%subscanbuf%databuf,&
       backsci%switch,&
       error)
  if (error) return
  if (backsci%switch%book%found) then
     ! *** JP *** Is this the right code?
     call backsci%on%curr%reassociate(backsci%switch%cycle%data(backsci%switch%cycle%on%i(1)),error)
     ! *** JP *** Is this the right code?
     if (error) return
     call mrtcal_otf_psw_select_off(mrtset,backsci,error)
     if (error) return
     ! *** JP *** Is this the right code?
     backsci%off%curr => backsci%switch%cycle%data(backsci%switch%cycle%off%i(1))
     ! *** JP *** Is this the right code?
     call mrtcal_fill_switch_section(backsci%switch%cycle,error)
     if (error) return
  endif
  !
end subroutine mrtcal_get_next_otfpsw_cycle
!
subroutine mrtcal_otf_psw_read_surrounding_offs(mrtset,imbf,subscanbuf,backsci,error)
  use gkernel_types
  use mrtcal_dependencies_interfaces
  use mrtcal_buffer_types
  use mrtcal_messaging
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_otf_psw_read_surrounding_offs
  !---------------------------------------------------------------------
  ! @ private
  ! Get in the current list of subscans the number of the previous and 
  ! the next OFF subscans, read them, average them in time, and store 
  ! them into backsci%off
  !
  ! That's a stack. The code must start the previous OFF subscan, because 
  ! it probably is the current next OFF subscan, as the subscans are 
  ! ordered by increasing time. This saves data reading. Setting the 
  ! subscan number to zero means that we did not find either the previous 
  ! or the next off
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),            intent(in)    :: mrtset
  type(imbfits_t),                 intent(in)    :: imbf
  type(subscan_buffer_t),          intent(inout) :: subscanbuf
  type(science_backend_t), target, intent(inout) :: backsci
  logical,                         intent(inout) :: error
  ! Local
  logical, parameter :: iscal = .false.
  logical :: found
  integer(kind=4) :: ioff,iprev,inext
  type(chunkset_2d_t), pointer :: altoff
  character(len=*), parameter :: rname='OTF>PSW>READ>SURROUNDING>OFFS'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Stack previous off
  ioff = backsci%on%curr%isub
  call eclass_getprev(backsci%list%onoff,backsci%list%off,ioff,found,error)
  if (error) return
  if (found) then
     iprev = backsci%list%isub(ioff)
     if (backsci%off%prev%isub.eq.iprev) then
        ! Nothing to be done...
     else if (backsci%off%next%isub.eq.iprev) then
        altoff => backsci%off%prev
        backsci%off%prev => backsci%off%next
        backsci%off%next => altoff
     else
        call mrtcal_average_times(mrtset,iscal,backsci%list%isub(ioff),'track',imbf,subscanbuf,backsci%off%prev,error)
        if (failed_calibrate(rname,backsci%list%isub(ioff),error))  return
     endif
  else
     backsci%off%prev%isub = 0 ! Nevertheless, leave the type allocated
  endif
  ! Stack next off
  ioff = backsci%on%curr%isub
  call eclass_getnext(backsci%list%onoff,backsci%list%off,ioff,found,error)
  if (error) return
  if (found) then
     inext = backsci%list%isub(ioff)
     if (backsci%off%prev%isub.eq.inext) then
        altoff => backsci%off%next
        backsci%off%next => backsci%off%prev
        backsci%off%prev => altoff
     else if (backsci%off%next%isub.eq.inext) then
        ! Nothing to be done...
     else
        call mrtcal_average_times(mrtset,iscal,backsci%list%isub(ioff),'track',imbf,subscanbuf,backsci%off%next,error)
        if (error)  return
     endif
  else
     backsci%off%next%isub = 0 ! Nevertheless, leave the type allocated
  endif
  !
end subroutine mrtcal_otf_psw_read_surrounding_offs
!
subroutine mrtcal_otf_psw_interpolate_off_init(off,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_otf_psw_interpolate_off_init
  !---------------------------------------------------------------------
  ! @ private
  ! *** JP In output, interp%isub = prev%isub or interp%isub = next%isub
  ! *** JP It would be better to have the averaged value stored as a real
  ! *** JP If this subscan number is used at read time, some additional
  ! *** JP protection would be needed.
  !---------------------------------------------------------------------
  type(off_stack_t), target, intent(inout) :: off
  logical,                   intent(inout) :: error
  ! Local
  type(chunkset_2d_t), pointer :: prev,next,offset,slope,interp
  character(len=*), parameter :: rname='OTF>PSW>INTERPOLATE>OFF>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  prev => off%prev
  next => off%next
  slope  => off%slope
  offset => off%offset
  interp => off%computed
  !
  if ((prev%isub.gt.0).and.(next%isub.gt.0)) then
     ! Both are there => Interpolation possible
     call mrtcal_chunkset_2d_interpolate_init(prev,next,slope,offset,interp,error)
     if (error) return
  else if ((prev%isub.le.0).and.(next%isub.le.0)) then
     ! Both are missing => Something wrong
     call mrtcal_message(seve%e,rname,'No subscans associated to previous and next OFF')
     error = .true.
     return
  else
     ! Only one is missing => Use the other one
     if (error) return
     if (prev%isub.le.0) then
        ! Previous is missing, just use the next one
        call mrtcal_chunkset_2d_interpolate_init_as_ref(next,slope,offset,interp,error)
        if (error) return
        call mrtcal_chunkset_2d_copy_data(next,offset,error)
        if (error) return
     endif
     if (next%isub.le.0) then
        ! Next is missing, just use the previous one
        call mrtcal_chunkset_2d_interpolate_init_as_ref(prev,slope,offset,interp,error)
        if (error) return
        call mrtcal_chunkset_2d_copy_data(prev,offset,error)
        if (error) return
     endif
     ! Set slope to zero (This ones must come after the header copy)
     call slope%init_data(0.,0.,0.,error)
  endif
  off%curr => off%computed
  !
end subroutine mrtcal_otf_psw_interpolate_off_init
!
subroutine mrtcal_otf_psw_prepare_nextoff(mrtset,filebuf,backsci,error)
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_otf_psw_prepare_nextoff
  !---------------------------------------------------------------------
  ! @ private
  ! Read the OFF subscans surrounding the current ON subscan and prepare
  ! the linear interpolation in time, i.e., compute the segment slope and
  ! constant
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  type(science_backend_t), intent(inout) :: backsci
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='OTF>PSW>PREPARE>NEXTOFF'
  !
  call mrtcal_otf_psw_read_surrounding_offs(mrtset,&
       filebuf%imbf,&
       filebuf%subscanbuf,&
       backsci,error)
  if (error) return
  call mrtcal_otf_psw_interpolate_off_init(backsci%off,error)
  if (error) return
  !
end subroutine mrtcal_otf_psw_prepare_nextoff
!
subroutine mrtcal_otf_psw_select_off(mrtset,backsci,error)
  use mrtcal_interfaces, except_this=>mrtcal_otf_psw_select_off
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  ! Select the OFF subscan to be used. It can be either a linear
  ! interpolation of the previous and next OFF or the nearest neighbour
  ! in time. That's MRTSET%CAL%INTERPOFF that switches the behavior.
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),            intent(in)    :: mrtset
  type(science_backend_t), target, intent(inout) :: backsci
  logical,                         intent(inout) :: error
  ! Local
  integer(kind=4) :: idata
  real(kind=8) :: dist_onprev,dist_onnext
  real(kind=8), parameter :: mjd_tol = 1d0/(24d0*3600d0) ! 1 sec in mjd
  character(len=*), parameter :: rname='OTF>PSW>SELECT>OFF'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  idata = backsci%switch%cycle%ndata+1
  if (idata.gt.backsci%switch%cycle%npha) then
     call mrtcal_message(seve%e,rname,'Trying to fill more data than allocated memory in the OTFPSW cycle')
     error = .true.
     return
  endif
  ! *** JP This is checked for each dump. It would be more efficiency
  ! *** JP to have the address of the right subroutine decided earlier
  ! *** JP and passed here. Is it needed?
  select case(mrtset%cal%interpoff)
  case (interp_linear)
     ! Interpolate
     call mrtcal_chunkset_2d_interpolate_do(&
          backsci%on%curr%mjd%med,&
          backsci%off%slope,&
          backsci%off%offset,&
          backsci%off%computed,&
          error)
     call backsci%switch%cycle%data(idata)%reassociate(backsci%off%computed,error)
     if (error) return
  case (interp_nearest)
     ! Use off nearest in time
     if ((backsci%off%prev%isub.gt.0).and.(backsci%off%next%isub.gt.0)) then
        dist_onprev = backsci%on%curr%mjd%beg-backsci%off%prev%mjd%end
        dist_onnext = backsci%off%next%mjd%beg-backsci%on%curr%mjd%end
        ! *** JP The MJD tolerance was fixed when this routine was also
        ! *** JP used for PSW tracked. Should it be set to 0 sec for OTF?
        if (dist_onprev-dist_onnext.le.mjd_tol) then
           call mrtcal_message(mseve%calib%book,rname,'Using previous OFF')
           call backsci%switch%cycle%data(idata)%reassociate(backsci%off%prev,error)
           if (error) return
        else
           call mrtcal_message(mseve%calib%book,rname,'Using next OFF')
           call backsci%switch%cycle%data(idata)%reassociate(backsci%off%next,error)
           if (error) return
        endif
     else if (backsci%off%prev%isub.gt.0) then
        call mrtcal_message(mseve%calib%book,rname,'Only previous OFF available')
        call backsci%switch%cycle%data(idata)%reassociate(backsci%off%prev,error)
        if (error) return
     else if (backsci%off%next%isub.gt.0) then
        call mrtcal_message(mseve%calib%book,rname,'Only next OFF available')
        call backsci%switch%cycle%data(idata)%reassociate(backsci%off%next,error)
        if (error) return
     else
        call mrtcal_message(seve%e,rname,'No subscans associated to previous nor to next OFF')
        error = .true.
        return
     endif
  case default
     call mrtcal_message(seve%e,rname,'Interpolation mode not implemented')
     error = .true.
     return
  end select
  ! Success => Increase the backsci%switch%cycle%ndata counter accordingly
  backsci%switch%cycle%ndata = backsci%switch%cycle%ndata+1
  !
end subroutine mrtcal_otf_psw_select_off
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! Three different baselining methods are offered with slightly different
! syntax. To ease the support, each baselining method is coded into its own
! file (command-baseline-*.f90) and associated module. However, the
! definition of the syntax and its parsing must be implemented here because
! the syntax of the main command and of the lineregion (lineset_or_mask)
! must be defined only once even though it is meaningful for the polynomial
! and median baselining. Once the parsing is done, the different
! combination of options is checked and then the execution is switched to
! the right file and module that contains all the details associated to
! each method.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_baseline
  use cubetools_parameters
  use cubetools_structure
  use cubemain_messaging
  use cubemain_baseline_cubes_types
  use cubemain_lineset_or_mask_types
  use cubemain_baseline_median
  use cubemain_baseline_chebyshev
  use cubemain_baseline_wavelet
  !
  public :: baseline
  private
  !
  integer(kind=code_k), parameter :: code_base_median  = 1
  integer(kind=code_k), parameter :: code_base_poly    = 2
  integer(kind=code_k), parameter :: code_base_wavelet = 3
  !
  type :: baseline_comm_t
     type(baseline_cubes_comm_t)     :: cubes
     type(lineset_or_mask_comm_t)    :: lineregion
     type(baseline_median_comm_t)    :: median
     type(baseline_chebyshev_comm_t) :: poly
     type(baseline_wavelet_comm_t)   :: wavelet
   contains
     procedure, public  :: register => cubemain_baseline_comm_register
     procedure, private :: parse    => cubemain_baseline_comm_parse
     procedure, private :: main     => cubemain_baseline_comm_main
  end type baseline_comm_t
  type(baseline_comm_t) :: baseline
  !
  type baseline_user_t
     integer(kind=code_k)            :: method  ! Baselining method
     type(baseline_median_user_t)    :: median  ! Median filtering parameters
     type(baseline_chebyshev_user_t) :: poly    ! Polynomial parameters
     type(baseline_wavelet_user_t)   :: wavelet ! Wavelet filtering parameters
  end type baseline_user_t
  !
contains
  !
  subroutine cubemain_baseline_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(baseline_user_t) :: user
    character(len=*), parameter :: rname='BASELINE>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call baseline%parse(line,user,error)
    if (error) return
    call baseline%main(user,error)
    if (error) return
  end subroutine cubemain_baseline_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_baseline_comm_register(comm,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(baseline_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='BASELINE>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call comm%cubes%register(cubemain_baseline_command,error)
    if (error) return
    call comm%median%register(error)
    if (error) return
    call comm%poly%register(error)
    if (error) return
    call comm%wavelet%register(error)
    if (error) return
    call comm%lineregion%register(error)
    if (error) return
  end subroutine cubemain_baseline_comm_register
  !
  subroutine cubemain_baseline_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(baseline_comm_t), intent(inout) :: comm
    character(len=*),       intent(in)    :: line
    type(baseline_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    logical :: combined
    character(len=*), parameter :: rname='BASELINE>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Parse the method
    call comm%median%parse_key(line,user%median,error)
    if (error) return
    call comm%poly%parse_key(line,user%poly,error)
    if (error) return
    call comm%wavelet%parse_key(line,user%wavelet,error)
    if (error) return
    ! Sanity check: Are more than one method called?
    combined = (&
         (user%median%present.and.user%poly%present).or.&
         (user%median%present.and.user%wavelet%present).or.&
           (user%poly%present.and.user%wavelet%present))
    if (combined) then
       call cubemain_message(seve%e,rname,'The /MEDIAN, /WAVELET, or /POLYNOMIAL baselining method are exclusive from each other')
       call cubemain_message(seve%e,rname,'   => Choose only one of them')
       error = .true.
       return
    endif
    !
    ! Parse the reminder of the command line depending on the use case
    if (user%median%present) then
       user%method = code_base_median
       call comm%median%parse_others(comm%cubes,comm%lineregion,line,user%median,error)
       if (error) return
    else if (user%poly%present) then
       user%method = code_base_poly
       call comm%poly%parse_others(comm%cubes,comm%lineregion,line,user%poly,error)
       if (error) return
    else if (user%wavelet%present) then
       user%method = code_base_wavelet
       call comm%wavelet%parse_others(comm%cubes,line,user%wavelet,error)
       if (error) return
    else
       ! Default to median filter
       user%method = code_base_median
       call comm%median%parse_others(comm%cubes,comm%lineregion,line,user%median,error)
       if (error) return
    endif
  end subroutine cubemain_baseline_comm_parse
  !
  subroutine cubemain_baseline_comm_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(baseline_comm_t), intent(in)    :: comm
    type(baseline_user_t),  intent(inout) :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='BASELINE>COMM>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    select case (user%method)
    case (code_base_median)
       call comm%median%main(user%median,error)
       if (error) return
    case (code_base_poly)
       call comm%poly%main(user%poly,error)
       if (error) return
    case (code_base_wavelet)
       call comm%wavelet%main(user%wavelet,error)
       if (error) return
    case default
       call cubemain_message(seve%e,rname,'Unknown baselining method code')
       error = .true.
       return
    end select

  end subroutine cubemain_baseline_comm_main
end module cubemain_baseline
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program grid_project
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Stand alone program
  !	Resample an input CLASS grid to a different projection system
  ! Subroutines
  !	(IMAGE),(SIC)
  !---------------------------------------------------------------------
  ! Global
  character(len=*), parameter :: pname = 'GRID_PROJECT'
  ! Local
  real(8), parameter :: pi=3.141592653589793d0
  !
  character(len=80) :: namex,namey,center_1,center_2
  logical :: error
  integer :: nkey,sys_code,ier
  integer, parameter :: mvoc=8
  character(len=16) :: vocab(mvoc),key,system,proj
  type(gildas) :: x,y
  !
  integer :: n
  real(8) :: center(2),angle,aproj(3),bproj(3)
  real(8), allocatable :: xwork(:), ywork(:)
  !
  data vocab/'NONE','GNOMONIC','ORTHOGRAPHIC','AZIMUTHAL',   &
     &    'STEREOGRAPHIC','LAMBERT','AITOFF','RADIO'/
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_char('PROJECTION$',proj)
  call gildas_char('SYSTEM$',system)
  call gildas_char('CENTER_1$',center_1)
  call gildas_char('CENTER_2$',center_2)
  call gildas_dble('ANGLE$',angle,1)
  call gildas_close
  !
   ! Input file
  call gildas_null(y)
  y%loca%read = .false.
  y%gil%form = fmt_r4
  y%gil%ndim = 2 ! This is a table in fact
  call gdf_read_gildas(y,namey,'.tab',error,data=.true.)
  if (error) then
    call gagout('F-'//pname//',  Cannot read input file')
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  !
  ! Now define output
  call sic_parsef(namex,x%file,' ','.tab')
  if (proj.ne.'UNCHANGED') then
    call sic_upper(proj)
    n = len_trim(proj)
    if (n.ne.0) then
      call sic_ambigs('PROJECTION',proj,key,nkey,vocab,mvoc,error)
      if (error) then
        write(6,1000)  'F-'//pname//',  Invalid projection system'
        goto 100
      endif
      x%gil%ptyp = nkey-1
    endif
  endif
  !
  ! Coordinate system
  call get_conv_code(y%char%syst,system,sys_code,error)
  if (error)  goto 100
  if (sys_code.ne.0) then
    x%char%syst = system
    write(6,1000)  'E-'//pname//',  System change not yet supported'
    goto 100
  endif
  !
  if (x%char%syst.eq.'EQUATORIAL' .or. x%char%syst.eq.'ICRS') then
    call sic_decode(center_1,center(1),24,error)
  else
    call sic_decode(center_1,center(1),360,error)
  endif
  if (error) goto 101
  call sic_decode(center_2,center(2),360,error)
  if (error) goto 101
  x%gil%a0 = center(1)
  x%gil%d0 = center(2)
  if (x%gil%ptyp.eq.p_radio .and. angle.ne.0.0) then
    write(6,1000)  'F-'//pname//',  Angle ignored in Radio projection'
    goto 100
  elseif (x%gil%ptyp.eq.p_aitoff .and. angle.ne.0.0) then
    write(6,1000)  'F-'//pname//',  Angle ignored in Aitoff projection'
    goto 100
  endif
  x%gil%pang = angle*pi/180.0d0
  !
  ! Create output image
  call gdf_create_image(x,error)
  if (error) then
    write(6,1000) 'F-'//pname//',  Cannot create X file'
    write(6,1000) x%file
    goto 100
  endif
  !
  ! Get some work space for X,Y
  allocate (xwork(x%gil%dim(2)),ywork(x%gil%dim(2)), &
    & x%r2d(x%gil%dim(1), x%gil%dim(2)), stat=ier)
  if (ier.ne.0) goto 100
  !
  x%r2d = y%r2d
  aproj = [y%gil%a0,y%gil%d0,y%gil%pang]
  bproj = [x%gil%a0,x%gil%d0,x%gil%pang]
  call regrid (y%r2d,y%gil%dim(1),y%gil%dim(2),   &
     &    y%gil%ptyp,aproj,x%r2d,x%gil%ptyp,bproj,   &
     &    sys_code,xwork,ywork,1,2)
  call gdf_write_data(x,x%r2d,error)
  !
  call gagout('S-'//pname//',  Successful completion')
  call sysexi(1)
  !
101 call gagout('F-'//pname//',  Bad syntax in center coordinates')
100 call sysexi (fatale)
  !
1000 format(a,a)
end program grid_project
!
subroutine get_conv_code(oldsys,newsys,code,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: oldsys
  character(len=*), intent(inout) :: newsys
  integer(kind=4),  intent(out)   :: code
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: pname='GRID_PROJECT'
  !
  call sic_upper(newsys)
  !
  ! Unchanged
  if (newsys.eq.'UNCHANGED') then
    code = 0
    newsys = oldsys
    return
  endif
  !
  ! Same system
  if (oldsys.eq.newsys) then
    code = 0
    return
  endif
  !
  ! Supported conversions
  if (newsys.eq.'GALACTIC' .and. oldsys.eq.'EQUATORIAL') then
    code = 1
    return
  elseif (newsys.eq.'EQUATORIAL' .and. oldsys.eq.'GALACTIC') then
    code = -1
    return
  endif
  !
  ! Unsupported conversions
  code = 0
  write(6,'(6A)') 'F-',pname,',  Cannot convert from ',oldsys,' to ',newsys
  error = .true.
  !
end subroutine get_conv_code
!
subroutine regrid(a,mc,mv,atype,aproj,   &
     &    b,btype,bproj,code,xb,yb,ix,iy)
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  ! GREG	Stand alone subroutine
  !	Regrid an input map in a given projection to
  !	an output map in another projection
  ! Arguments
  !	A	R*4(*)	Input GRID of dimensions MC MV
  !	MC,MV   I	Size of A
  !	ATYPE	I	Type of projection
  !	APROJ	R*8(3)	Projection constants
  !			PROJ(1) = A0,	PROJ(2)=D0,	PROJ(3)=Angle
  !	B	R*4(*)	Output map of dimensions MC MV
  !	BTYPE	I
  !	BPROJ	R*8(3)
  !	CODE	I	Galactic to Equatorial (-1)
  !			or Equatorial to Galactic (1)
  !	XB,YB	R*8	Work arrays of dimension MV
  !       IX,IY   I       Pointer to columns of X and Y
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mc                     !
  integer(kind=index_length) :: mv                     !
  real*4 :: a(mc,mv)                !
  integer :: atype                  !
  real*8 :: aproj(3)                !
  real*4 :: b(mc,mv)                !
  integer :: btype                  !
  real*8 :: bproj(3)                !
  integer :: code                   !
  real*8 :: xb(mc)                  !
  real*8 :: yb(mc)                  !
  integer :: ix                     !
  integer :: iy                     !
  ! Local
  integer :: i,ier
  type(projection_t) :: proj
  logical :: error
  real(kind=8), allocatable :: axb(:),ayb(:)
  !
  ! Setup Input projection
  error = .false.
  call gwcs_projec(aproj(1),aproj(2),aproj(3),atype,proj,error)
  allocate(axb(mv),ayb(mv),stat=ier)
  !
  ! Convert Output projection to Absolute coordinates
  do i=1,mv
    xb(i) = a(ix,i)
    yb(i) = a(iy,i)
  enddo
  call rel_to_abs(proj,xb,yb,axb,ayb,mv)
  !      do i=1,10
  !         type *,i,xb(i),yb(I)
  !      ENDDO
  !
  ! Change coordinate system - not coded...
  if (code.eq.-1) then
    ! call gal_equ (xb,yb,xb,yb,mv,error)
  elseif (code.eq.1) then
    ! call equ_gal (xb,yb,xb,yb,mv,error)
  endif
  !
  ! Setup Output projection
  call gwcs_projec(bproj(1),bproj(2),bproj(3),btype,proj,error)
  !
  ! Convert Absolute coordinates to input projection
  call abs_to_rel(proj,axb,ayb,xb,yb,mv)
  !      do i=1,10
  !         type *,i,xb(i),yb(I)
  !      ENDDO
  do i=1,mv
    b(ix,i) = xb(i)
    b(iy,i) = yb(i)
  enddo
end subroutine regrid

subroutine pdbi_plot_line(error)
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ public
  ! Main entry for plotting
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='PDBI_PLOT'
  logical :: ok
  integer(kind=4) :: i, nch
  real(kind=4) :: df, dv
  real(kind=8) :: f
  character(len=6) :: input1(4), input2(4)
  character(len=10) :: dsb
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  character(len=message_length) :: mess
  !
  if (flo1.eq.0) then
     call astro_message(seve%e,rname,'LINE command not yet executed')
     error = .true.
     return
  endif
  !
  if (plot_mode.eq.1) then
     call astro_message(seve%i,rname,'Plotting mode: LINE coverage')
     call pdbi_plot_full
  elseif ((plot_mode.eq.2).and.(narrow_def)) then
     call astro_message(seve%i,rname,'Plotting mode: NARROW correlator')
     call pdbi_plot_narrow
  elseif (plot_mode.eq.3) then
     call astro_message(seve%i,rname,'Plotting mode: WIDEX correlator')
     call pdbi_plot_widex
  else
    call astro_message(seve%e,rname,'Initilization problem')
    return
  endif
  !
  ! Spurious message on spurious lines
  ! Message is here so that it is output with PLOT command *and*
  ! with LINE/NARROW/SPECTRAL
  !
  if (do_spurious) then
     write(mess,'(A,F8.2,A)') 'Plotting possible spurious lines '// &
             ' (FLO1REF = ',flo1ref,' MHz)'
     call astro_message(seve%i,'PDBI_PLOT',trim(mess))
  endif
  !
  ! Print receiver and correlator setups
  !
  ! call astro_message(seve%i,rname,'Receiver tuning:')
  ! call astro_message(seve%r,rname,' '//label)
  !
  if (narrow_def) then
    call astro_message(seve%r,rname,'')
    call astro_message(seve%i,rname,'Current narrow-band correlator setup:')
    call astro_message(seve%r,rname,' Entry 1: '//input1(narrow_input(1)))
    call astro_message(seve%r,rname,' Entry 2: '//input2(narrow_input(2)))
    ok = .false.
    do i=1,nunit
      ok = ok.or.unit_def(i)
    enddo
    if (ok) then
      do i=1,nunit
        if (unit_def(i)) then
          !
          ! Compute Nchannel, df, dv
          !
          if (unit_band(i).eq.20) nch = 512    ! SSB mode
          if (unit_band(i).eq.40) nch = 512    ! SSB mode
          if (unit_band(i).eq.80) then
            if (unit_bmode(i).le.3) nch = 256  ! SSB mode
            if (unit_bmode(i).gt.3) nch = 512  ! DSB mode
          endif
          if (unit_band(i).eq.160) then
            if (unit_bmode(i).le.3) nch = 128  ! SSB mode
            if (unit_bmode(i).gt.3) nch = 256  ! DSB mode
          endif
          if (unit_band(i).eq.320) nch = 128   ! DSB mode
          if (unit_bmode(i).le.3) then
            dsb = '(SSB mode)'
          else
            dsb = '(DSB mode)'
          endif
          df = float(unit_band(i))/float(nch)
          call find_rffreq(i,f)  ! RF frequency at center of subband i
          dv = df/f*299792.458
          !
          ! Ouptut message
          !
          write(mess,1010) i,unit_band(i),unit_cent(i),unit_wind(i), nch,  &
            df, dv, dsb
        else
          !
          ! Unit not defined
          !
          write(mess,1020) i
        endif
        call astro_message(seve%r,rname,mess)
      enddo
    else
      call astro_message(seve%r,rname,' No spectral units defined')
    endif
    call astro_message(seve%r,rname,'')
  else
     ! call astro_message(seve%i,rname,'Narrow-band correlator setup: '// &
     !     'not yet defined')
  endif
  1010 format('  Unit ',i1,i4,f8.2,' on entry ',i1,' -- ',i3,' ch. of ',f5.3,  &
              ' MHz = ',f4.2,' km/s ',a)
  1020 format('  Unit ',i1,' OFF')
end subroutine pdbi_plot_line
!
! ------------------------------------------------------------------------
!
subroutine pdbi_plot_full
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot of USB + LSB, as produced by the LINE command
  !---------------------------------------------------------------------
  real(kind=8) :: bandwidth, center
  real(kind=8) :: f1, f2, u1, u2
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=132) :: chain, limi
  !
  call gr_exec('CLEAR DIRECTORY')
  call gr_exec1('SET PLOT LANDSCAPE')
  !
  ! IF1 bandwidth
  !
  bandwidth = abs(userlim(2)-userlim(1))/1000.
  center = userlim(1)+(userlim(2)-userlim(1))/2.
  write(limi,1040) userlim(1), userlim(2)
  !
  ! SIGNAL plot ------------------------------------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('PEN 0')
  call gr_exec1('SET BOX 3 29 9 17')
  !
  ! USB or LSB?
  !
  if (sky.eq.1) then ! Signal = USB, IMAGE = LSB
     f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
     f2 = f1+bandwidth
     u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
     u2 = u1-bandwidth
  else               ! Signal = LSB, IMAGE = USB
     f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
     f2 = f1-bandwidth
     u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
     u2 = u1+bandwidth
  endif
  !
  ! RF axis
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  if (sky.eq.1) then
    call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz)    USB - Signal" /BOX 8')
  else
    call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz)    LSB - Signal" /BOX 8')
  endif
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,200)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! Indicate requested tuning frequency
  !
  call gr_exec1('PEN 6')
  write(chain,1090) freq, 0.
  call gr_exec1(chain)
  write(chain,1100) freq, 1.5
  call gr_exec1(chain)
  call gr_exec1('PEN 0')
  !
  ! IF1 axis
  !
  call gr_exec1(limi)
  call gr_exec1('AXIS XL')
  call gr_exec1('DRAW TEXT 0 -1.5 "Intermediate frequency IF1 (MHz)" 5 /BOX 2')
  !
  ! Y axis (dash on user limits, then continuous on hard limits)
  !
  call gr_exec1('PEN /DASH 3')
  write (chain,1050) userlim(1)
  call gr_exec1(chain)
  write (chain,1060) userlim(1)
  call gr_exec1(chain)
  write (chain,1050) userlim(2)
  call gr_exec1(chain)
  write (chain,1060) userlim(2)
  call gr_exec1(chain)
  call gr_exec1('PEN /DASH 1')
  write (chain,1050) iflim(1)
  call gr_exec1(chain)
  write (chain,1060) iflim(1)
  call gr_exec1(chain)
  write (chain,1050) iflim(2)
  call gr_exec1(chain)
  write (chain,1060) iflim(2)
  call gr_exec1(chain)
  !
  ! Spurious lines
  !
  if (do_spurious) then
     call pdbi_line_spurious
  endif
  !
  ! Plot correlator quarters (narrow-band and widex)
  !
  call pdbi_plot_full_corr
  !
  ! Label = LINE command
  !
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1('DRAW TEXT 0 3 "'//trim(label)//'" 5 /BOX 8')
  !
  ! IMAGE plot -----------------------------------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('PEN 14 /COL 14')
  call gr_exec1('SET BOX 3 29 3 6')
  !
  ! USB or LSB?
  !
  if (sky.eq.-1) then ! IMAGE = USB
     f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
     f2 = f1+bandwidth
     u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
     u2 = u1-bandwidth
  else                ! IMAGE = LSB
     f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
     f2 = f1-bandwidth
     u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
     u2 = u1+bandwidth
  endif
  !
  ! RF axis
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  if (sky.eq.-1) then
    call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)    USB - Image" /BOX 2')
  else
    call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)    LSB - Image" /BOX 2')
  endif
  !
  ! Plot atmospheric transmission
  !
  ! if (do_atmplot) then
  !   call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  ! endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF axis
  !
  call gr_exec1(limi)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  !
  ! Y axis (dash on user limits, then continuous on hard limits)
  !
  call gr_exec1('PEN /DASH 3')
  write (chain,1050) userlim(1)
  call gr_exec1(chain)
  write (chain,1060) userlim(1)
  call gr_exec1(chain)
  write (chain,1050) userlim(2)
  call gr_exec1(chain)
  write (chain,1060) userlim(2)
  call gr_exec1(chain)
  call gr_exec1('PEN /DASH 1')
  write (chain,1050) iflim(1)
  call gr_exec1(chain)
  write (chain,1060) iflim(1)
  call gr_exec1(chain)
  write (chain,1050) iflim(2)
  call gr_exec1(chain)
  write (chain,1060) iflim(2)
  call gr_exec1(chain)
  !
  ! Spurious lines -- REMOVED
  !
  ! if (do_spurious) then
  !   call pdbi_line_spurious
  ! endif
  !
  ! Plot correlator quarters -- REMOVED
  !
  ! call pdbi_plot_full_corr
  !
  call gr_exec1('PEN 0')
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1050 format('DRAW RELOCATE ',f10.2,' 0 /USER')
  1060 format('DRAW LINE ',f10.2,' 5 /USER')
  1090 format('DRAW RELOCATE ',f15.6,' ',f15.6,' /USER')
  1100 format('DRAW LINE ',f15.6,' ',f15.6,' /USER')
  !
end subroutine pdbi_plot_full
!
! -----------------------------------------------------------------------
!
subroutine pdbi_plot_full_corr
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot the correlator bands onto the DSB plot
  !---------------------------------------------------------------------
  integer(kind=4) :: i
  character(len=14) :: colortext(4)
  !
  ! Color for the four quarters
  !
  do i = 1,4
     if (narrow_def) then
        if (narrow_input(1).eq.i) then
           colortext(i) = 'PEN 1'  ! NARROW 1 in red
        elseif (narrow_input(2).eq.i) then
           colortext(i) = 'PEN 3'  ! NARROW 2 in blue
        else
           colortext(i) = 'PEN 14 /COL 14'  ! Not used
        endif
     else
        colortext(i) = 'PEN 14 /COL 14'  ! No NARROW defined yet
     endif
  enddo
  !
  ! Plot the NARROW quarters
  !
  call gr_exec1(colortext(1))
  call gr_exec1('DRAW TEXT 4700 0.7 "Q1" 5 /USER /CLIP')
  call gr_exec1(colortext(1)//' /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 4760 0.7 /USER /CLIP')
  call gr_exec1('DRAW ARROW 5200 0.7 /USER /CLIP')
  call gr_exec1('DRAW RELOCATE 4635 0.7 /USER /CLIP')
  call gr_exec1('DRAW ARROW 4200 0.7 /USER /CLIP')
  call gr_exec1(colortext(1)//' /WEIGHT 1')
  !
  call gr_exec1(colortext(2))
  call gr_exec1('DRAW TEXT 5500 1.1 "Q2" 5 /USER /CLIP ')
  call gr_exec1(colortext(2)//' /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 5560 1.1 /USER /CLIP')
  call gr_exec1('DRAW ARROW 6000 1.1 /USER /CLIP ')
  call gr_exec1('DRAW RELOCATE 5435 1.1 /USER /CLIP')
  call gr_exec1('DRAW ARROW 5000 1.1 /USER /CLIP ')
  call gr_exec1(colortext(2)//' /WEIGHT 1')
  !
  call gr_exec1(colortext(3))
  call gr_exec1('DRAW TEXT 6500 0.7 "Q3" 5 /USER /CLIP ')
  call gr_exec1(colortext(3)//' /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 6565 0.7 /USER /CLIP ')
  call gr_exec1('DRAW ARROW 7000 0.7 /USER /CLIP ')
  call gr_exec1('DRAW RELOCATE 6435 0.7 /USER /CLIP ')
  call gr_exec1('DRAW ARROW 6000 0.7 /USER /CLIP ')
  call gr_exec1(colortext(3)//' /WEIGHT 1')
  !
  call gr_exec1(colortext(4))
  call gr_exec1('DRAW TEXT 7300 1.1 "Q4" 5 /USER /CLIP')
  call gr_exec1(colortext(4)//' /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 7365 1.1 /USER /CLIP')
  call gr_exec1('DRAW ARROW 7800 1.1 /USER /CLIP')
  call gr_exec1('DRAW RELOCATE 7235 1.1 /USER /CLIP')
  call gr_exec1('DRAW ARROW 6800 1.1 /USER /CLIP')
  call gr_exec1(colortext(4)//' /WEIGHT 1')
  !
  ! Now draw the WIDEX coverage
  !
  call gr_exec1('PEN 0 /WEIGHT 1')
  call gr_exec1('DRAW TEXT 5100 0.3 "WIDEX LOW" 5 /USER /CLIP')
  call gr_exec1('PEN 0 /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 5350 0.3 /USER /CLIP')
  call gr_exec1('DRAW ARROW 6000 0.3 /USER /CLIP')
  call gr_exec1('DRAW RELOCATE 4850 0.3 /USER /CLIP')
  call gr_exec1('DRAW ARROW 4200 0.3 /USER /CLIP')
  !
  call gr_exec1('PEN 0 /WEIGHT 1')
  call gr_exec1('DRAW TEXT 6900 0.3 "WIDEX HIGH" 5 /USER /CLIP')
  call gr_exec1('PEN 0 /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 7165 0.3 /USER /CLIP')
  call gr_exec1('DRAW ARROW 7800 0.3 /USER /CLIP')
  call gr_exec1('DRAW RELOCATE 6635 0.3 /USER /CLIP')
  call gr_exec1('DRAW ARROW 6000 0.3 /USER /CLIP')
  !
  call gr_exec1('PEN 0 /WEIGHT 1')
  !
end subroutine pdbi_plot_full_corr
!
! -----------------------------------------------------------------------
!
subroutine pdbi_plot_narrow
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot of the NARROW-BAND correlator
  !---------------------------------------------------------------------
  ! Global
  logical :: gr_error
  ! Local
  real(kind=8) :: bandwidth, center, ifmin, ifmax, tmp
  real(kind=8) :: f1, f2, u1, u2
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=3) :: band
  character(len=132) :: chain, limi
  !
  character(len=6) :: input1(4), input2(4)
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  real(kind=4) :: qlim(2,4)
  data qlim/4200,5200,5000,6000,6000,7000,6800,7800/
  !
  ! ------------------------------------------------------------------------
  !
  call gr_exec('CLEAR DIRECTORY')
  call gr_exec1('PEN 0')
  !
  ! NARROW 1 ---------------------------------------------------------------
  !
  ! IF1 limits
  !
  ifmin = qlim(1,narrow_input(1))
  ifmax = qlim(2,narrow_input(1))
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.
  !
  ! Box
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('SET BOX 4 29 11.5 17')
  call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  ! USB or LSB?
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif
  ! IF in Q2 and Q4 is flipped wrt the RF frequency
  if ((narrow_input(1).eq.2).or.(narrow_input(1).eq.4)) then
    tmp = f1
    f1 = f2
    f2 = tmp
	tmp = u1
	u1 = u2
	u2 = tmp
  endif
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('PEN /DASH 1')
  ! call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz) - '//band //'" /BOX 8')
  call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz)" /BOX 8')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF axis at correlator entry (100-1100 MHz)
  !
  call gr_exec1('LIMITS 100 1100 0 5')
  call gr_exec1('AXIS XL')
  call gr_exec1('DRAW TEXT 0 -1.5 "Intermediate frequency at correlator '//  &
  'input (MHz)" 5 /BOX 2')
  !
  ! Label (correlator input)
  !
  call gr_exec1('PEN 1')
  call gr_exec1('DRAW TEXT -2 0 "NARROW 1 = '//input1(narrow_input(1)) //'" 5 90 '//  &
  '/BOX 4')
  write(chain,1070) ifmin/1e3, ifmax/1e3
  call gr_exec1('DRAW TEXT -1 0 "'//trim(chain)//'" 5 90 /BOX 4')
  call gr_exec1('BOX N N N')
  !
  ! Spectral units
  !
  call pdbi_plot_spectral(1,0)
  !
  ! Spurious lines (need to switch to IF1 limits)
  !
  if (do_spurious) then
     if ((narrow_input(1).eq.1).or.(narrow_input(1).eq.3)) then
        write(limi,1040) ifmin, ifmax
        call gr_exec1(limi)
     else
        write(limi,1040) ifmax, ifmin  ! Q2 and Q4 are flipped
        call gr_exec1(limi)
     endif
     call pdbi_line_spurious
  endif
  call gr_exec1('PEN 0')
  !
  ! Label (LINE command)  -------------------------------------------------
  !
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1('DRAW TEXT 0 3 "'//trim(label)//'" 5 /BOX 8')
  !
  ! NARROW 2 --------------------------------------------------------------
  !
  ! IF1 limits
  !
  ifmin = qlim(1,narrow_input(2))
  ifmax = qlim(2,narrow_input(2))
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.

  !
  write(limi,1040) ifmin, ifmax
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('SET BOX 4 29 3 8.5')
  call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif

  ! IF in Q2 and Q4 is flipped wrt the RF frequency
  if ((narrow_input(2).eq.2).or.(narrow_input(2).eq.4)) then
    tmp = f1
    f1 = f2
    f2 = tmp
	tmp = u1
	u1 = u2
	u2 = tmp
  endif
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  call gr_exec('PEN /DASH 1')
  ! call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz) - '//band //'" /BOX 2')
  call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)" /BOX 2')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF axis at correlator entry (100-1100 MHz)
  !
  call gr_exec1('LIMITS 100 1100 0 5')
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  ! call gr_exec1('DRAW TEXT 0 1.5 "Intermediate frequency at correlator '//  &
  ! 'input (MHz)" 5 /BOX 8')
  !
  ! Label (correlator input)
  !
  call gr_exec1('PEN 3')
  call gr_exec1('DRAW TEXT -2 0 "NARROW 2 = '//input2(narrow_input(2))//'" 5 90 '//  &
  '/BOX 4')
  write(chain,1070) ifmin/1e3, ifmax/1e3
  call gr_exec1('DRAW TEXT -1 0 "'//trim(chain)//'" 5 90 '//  &
  '/BOX 4')
  call gr_exec1('BOX N N N')
  !
  ! Spectral units
  !
  call pdbi_plot_spectral(2,0)
  !
  ! Spurious lines
  !
  if (do_spurious) then
     if ((narrow_input(2).eq.1).or.(narrow_input(2).eq.3)) then
        write(limi,1040) ifmin, ifmax
        call gr_exec1(limi)
     else
        write(limi,1040) ifmax, ifmin  ! Q2 and Q4 are flipped
        call gr_exec1(limi)
     endif
     call pdbi_line_spurious
  endif
  call gr_exec1('PEN 0')
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1070 format('IF1 = ',f3.1,' to ',f3.1,' GHz')
  !
end subroutine pdbi_plot_narrow
!
! -----------------------------------------------------------------------
!
subroutine pdbi_plot_widex
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot of WIDEX
  !---------------------------------------------------------------------
  ! Global
  logical :: gr_error
  ! Local
  real(kind=8) :: bandwidth, center, ifmin, ifmax
  real(kind=8) :: f1, f2, u1, u2
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=3) :: band
  character(len=132) :: chain, limi
  integer(kind=4) :: lowband, highband
  data lowband/1/
  data highband/2/
  !
  ! ------------------------------------------------------------------------
  !
  call gr_exec('CLEAR DIRECTORY')
  call gr_exec1('PEN 0')
  !
  ! WIDEX LOW -------------------------------------------------------------
  !
  ! IF1 limits
  !
  ifmin = 4200
  ifmax = 6000
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.
  !
  write(limi,1040) ifmin, ifmax
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('SET BOX 4 29 11.5 17')
  call gr_exec1('PEN 0')
  ! call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('PEN /DASH 1')
  ! call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz) - '//band //'" /BOX 8')
  call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz)" /BOX 8')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF1 axis
  !
  write(chain,1040) ifmin, ifmax
  call gr_exec1(chain)
  call gr_exec1('AXIS XL')
  call gr_exec1('AXIS YL /TICK NO')
  call gr_exec1('PEN 0 /DASH 3')
  call gr_exec1('DRAW RELOCATE 6000 0 /USER')
  call gr_exec1('DRAW LINE 6000 5 /USER')
  call gr_exec1('PEN 0 /DASH 1')
  call gr_exec1('DRAW TEXT 0 -1.5 "Intermediate frequency IF1 (MHz)" 5 /BOX 2')
  !
  ! Spectral units
  !
  call pdbi_plot_narrow_widex(lowband)
  !
  ! Spurious lines
  !
  if (do_spurious) then
     call pdbi_line_spurious
  endif
  !
  ! Label
  !
  call gr_exec1('PEN 0')
  call gr_exec1('DRAW TEXT -2 0 "WIDEX LOW" 5 90 /BOX 4')
  write(chain,1080) ifmin/1e3, ifmax/1e3
  call gr_exec1('DRAW TEXT -1 0 "'//trim(chain)//'" 5 90 '//  &
  '/BOX 4')
  call gr_exec1('LIMITS 100 1900 0 5')
  ! call gr_exec1('BOX N N N')
  !
  ! Label (LINE command)  -------------------------------------------------
  !
  call gr_exec1('PEN 0')
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1('DRAW TEXT 0 3 "'//trim(label)//'" 5 /BOX 8')
  !
  ! WIDEX HIGH -------------------------------------------------------------
  !
  ! IF1 limits
  !
  ifmin = 6000
  ifmax = 7800
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.
  !
  ! Box
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('SET BOX 4 29 3 8.5')
  call gr_exec1('PEN 0')
  ! call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  call gr_exec('PEN /DASH 1')
  ! call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz) - '//band //'" /BOX 2')
  call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)" /BOX 2')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF1 axis
  !
  write (chain,1040) ifmin, ifmax
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('AXIS YR /TICK NO')
  call gr_exec1('PEN 0 /DASH 3')
  call gr_exec1('DRAW RELOCATE 6000 0 /USER')
  call gr_exec1('DRAW LINE 6000 5 /USER')
  call gr_exec1('PEN 0 /DASH 1')
  !
  ! Narrow-band correlator
  !
  call pdbi_plot_narrow_widex(highband)
  !
  ! Spurious lines
  !
  if (do_spurious) then
     call pdbi_line_spurious
  endif
  !
  ! Label
  !
  call gr_exec1('PEN 0')
  call gr_exec1('DRAW TEXT -2 0 "WIDEX HIGH" 5 90 /BOX 4')
  write(chain,1080) ifmin/1e3, ifmax/1e3
  call gr_exec1('DRAW TEXT -1 0 "'//trim(chain)//'" 5 90 '//  &
  '/BOX 4')
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1080 format('IF1 = ',f3.1,' to ',f3.1,' GHz')
  !
end subroutine pdbi_plot_widex
!
subroutine pdbi_plot_narrow_widex(wideband)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot the narrow band correlator setup on the WIDEX plot
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: wideband  ! Widex Band indicator
  ! Local
  integer(kind=4) :: i, old_pen, gr_spen, xoffset(5)
  real(kind=4) :: yoffset
  logical :: doplot
  character(len=132) :: chain, iflimits
  character(len=17) :: drawtext, colortext
  character(len=6) :: input1(4), input2(4)
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  real(kind=4) :: qlim(2,4)
  data qlim/4200,5200,5000,6000,6000,7000,6800,7800/
  !
  if (narrow_def) then
     !
     do i = 1,2
        !
        doplot = .false.
        !
        ! Loop on narrow band entries.
        !
        if (i.eq.1) then
           colortext = 'PEN 1'   ! narrow 1 in red
           drawtext = 'NARROW 1 = '//input1(narrow_input(1))
           yoffset = 0.7
        else
           colortext = 'PEN 3'   ! narrow 2 in blue
           drawtext = 'NARROW 2 = '//input2(narrow_input(2))
           yoffset = 1.1
        endif
        if (narrow_input(i).eq.1 .and. wideband.eq.1) then ! Q1 in WIDEX LOW
           xoffset(1) = 4200
           xoffset(2) = 4470
           xoffset(3) = 4930
           xoffset(4) = 5200
           xoffset(5) = 4700
           iflimits = 'LIMITS 100 1900 0 5' ! Q1 in WIDEX LOW
           doplot = .true.
        elseif (narrow_input(i).eq.2 .and. wideband.eq.1) then ! Q2 in WIDEX LOW
           xoffset(1) = 5000
           xoffset(2) = 5270
           xoffset(3) = 5730
           xoffset(4) = 6000
           xoffset(5) = 5500
           iflimits = 'LIMITS 1900 100 0 5' ! Q2 in WIDEX LOW
           doplot = .true.
        elseif(narrow_input(i).eq.3 .and. wideband.eq.2) then ! Q3 in WIDEX HIGH
           xoffset(1) = 6000
           xoffset(2) = 6270
           xoffset(3) = 6730
           xoffset(4) = 7000
           xoffset(5) = 6500
           iflimits = 'LIMITS 100 1900 0 5' ! Q3 in WIDEX HIGH
           doplot = .true.
        elseif (narrow_input(i).eq.4 .and. wideband.eq.2) then ! Q4 in WIDEX HIGH
           xoffset(1) = 6800
           xoffset(2) = 7070
           xoffset(3) = 7530
           xoffset(4) = 7800
           xoffset(5) = 7300
           iflimits = 'LIMITS 1900 100 0 5' ! Q4 in WIDEX HIGH
           doplot = .true.
        endif
        !
        ! Draw arrows & text
        !
        if (doplot) then
           call gr_exec1(colortext//' /WEIGHT 5')
           write(chain,1050) xoffset(3), yoffset
           call gr_exec1(chain)
           write(chain,1060) xoffset(4), yoffset
           call gr_exec1(chain)
           write(chain,1050) xoffset(2), yoffset
           call gr_exec1(chain)
           write(chain,1060) xoffset(1), yoffset
           call gr_exec1(chain)
           call gr_exec1(colortext//' /WEIGHT 1 /DASH 1')
           write(chain,1070) xoffset(5), yoffset, trim(drawtext)
           call gr_exec1(chain)
           !
           ! Plot narrow band spectral units
           !
           call gr_exec1(iflimits)
           call gr_exec1(colortext//' /WEIGHT 1 /DASH 1')
           old_pen = gr_spen(1)        ! --
           old_pen = gr_spen(old_pen)  ! select current pen
           call pdbi_plot_spectral(wideband,0)
           call gr_exec1(colortext//' /WEIGHT 1 /DASH 1')
           !
           ! Back to the IF1 limits
           !
           if (wideband.eq.1) then
              call gr_exec1('LIMITS 4200 6000 0 5')
           else
              call gr_exec1('LIMITS 6000 7800 0 5')
           endif
        endif
     enddo
  else
     call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
     !
     if (wideband.eq.1) then ! WIDEX LOW: Q1 and Q2
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
        call gr_exec1('DRAW TEXT 4700 0.7 "Q1" 5 /USER /CLIP')
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 5')
        call gr_exec1('DRAW RELOCATE 4760 0.7 /USER /CLIP')
        call gr_exec1('DRAW ARROW 5200 0.7 /USER /CLIP')
        call gr_exec1('DRAW RELOCATE 4635 0.7 /USER /CLIP')
        call gr_exec1('DRAW ARROW 4200 0.7 /USER /CLIP')
        !
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
        call gr_exec1('DRAW TEXT 5500 1.1 "Q2" 5 /USER /CLIP ')
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 5')
        call gr_exec1('DRAW RELOCATE 5560 1.1 /USER /CLIP')
        call gr_exec1('DRAW ARROW 6000 1.1 /USER /CLIP ')
        call gr_exec1('DRAW RELOCATE 5435 1.1 /USER /CLIP')
        call gr_exec1('DRAW ARROW 5000 1.1 /USER /CLIP ')
        !
     else ! WIDEX HIGH: Q3 and Q4
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
	call gr_exec1('DRAW TEXT 6500 0.7 "Q3" 5 /USER /CLIP ')
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 5')
        call gr_exec1('DRAW RELOCATE 6565 0.7 /USER /CLIP ')
        call gr_exec1('DRAW ARROW 7000 0.7 /USER /CLIP ')
        call gr_exec1('DRAW RELOCATE 6435 0.7 /USER /CLIP ')
        call gr_exec1('DRAW ARROW 6000 0.7 /USER /CLIP ')
        !
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
        call gr_exec1('DRAW TEXT 7300 1.1 "Q4" 5 /USER /CLIP')
        call gr_exec1('PEN 14 /COl 14 /WEIGHT 5')
        call gr_exec1('DRAW RELOCATE 7365 1.1 /USER /CLIP')
        call gr_exec1('DRAW ARROW 7800 1.1 /USER /CLIP')
        call gr_exec1('DRAW RELOCATE 7235 1.1 /USER /CLIP')
        call gr_exec1('DRAW ARROW 6800 1.1 /USER /CLIP')
     endif
  endif
  1050 format('DRAW RELOCATE ',i8, f10.2,' /USER /CLIP')
  1060 format('DRAW ARROW ',i8, f10.2,' /USER /CLIP')
  1070 format('DRAW TEXT 'i8, f10.2,' "',a,'" 5 /USER /CLIP')
end subroutine pdbi_plot_narrow_widex
!
subroutine pdbi_line_molecules(fmin,fmax)
  use ast_line
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Plot the molecular lines
  !---------------------------------------------------------------------
  real(kind=8) :: fmin              !
  real(kind=8) :: fmax              !
  ! Local
  logical :: error
  real(kind=8) :: fw
  integer(kind=4) :: i
  real(kind=4) :: afreq
  character(len=132) :: chain
  character(len=20) :: aname
  !
  fw=max(fmin,fmax)              ! Make sure Fmin<Fmax (depends on LSB
  fmin=min(fmin,fmax)            ! or USB)
  fmax=fw
  call gr_exec1 ('SET ORIEN 50')
  ! call gr_exec1 ('SET EXPAND 0.7')
  aname = ' '
  afreq = 0.0
  do i=1, nmol
     if (molfreq(i).ge.fmin .and. molfreq(i).le.fmax) then
        if (molname(i).ne.aname .or. abs(afreq-molfreq(i)).gt.40e-3) then
           write(chain,1000) 'DRAW TEXT ',molfreq(i),' 4. "' //  &
                trim(molname(i))//'" 5 /USER'
           aname = molname(i)
           afreq = molfreq(i)
           call gr_exec1(trim(chain))
        endif
        call gr_segm('LINE',error)
        if (width.eq.0) then
           call relocate (molfreq(i),3.d0)
           call draw (molfreq(i),2.0d0)
        else
           fw = width*molfreq(i)/299792.458
           call relocate (molfreq(i)-fw/2.,2.d0)
           call draw(molfreq(i),3.d0)
           call draw(molfreq(i)+fw/2.,2.d0)
        endif
        call gr_segm_close(error)
     endif
  enddo
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1 ('SET EXPAND 1')
  !
  1000 format(a,g14.7,a)
end subroutine pdbi_line_molecules
!
subroutine pdbi_line_atmos(fmin,fmax,umin,umax,wat,npoints)
  use gbl_message
  use gkernel_types
  use gkernel_interfaces
  use atm_interfaces_public
  use astro_interfaces, except_this=>pdbi_line_atmos
  use atm_params
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot atmospheric transmission
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: fmin        ! Signal frequency range
  real(kind=8), intent(in) :: fmax        ! Signal frequency range
  real(kind=8), intent(in) :: umin        ! Image frequency range
  real(kind=8), intent(in) :: umax        ! Image frequency range
  real(kind=4), intent(in) :: wat         ! Water vapor content
  integer(kind=4), intent(in) :: npoints  ! Number of points in the curve
  ! Local
  character(len=*), parameter :: rname='PDBI_LINE_ATMOS'
  logical :: error
  integer(kind=4) :: i, ier, old_pen
  character(len=message_length) :: mess
  real(kind=8) :: ff(npoints), transmi(npoints), tsystem(npoints)
  real(kind=8) :: tsysmax
  type(polygon_drawing_t) :: histo
  integer(kind=size_length), parameter :: nbase=1
  real(kind=8) :: base(nbase)
  !
  water = wat      ! user defined water, 1 mm as default
!!  freqs = fmin     ! frequency
  !
  ! Why, ???... does not match Umin Umax either
!  fw=max(fmin,fmax)              ! Make sure Fmin<Fmax (depends on LSB
!  fmin=min(fmin,fmax)            ! or USB)
!  fmax=fw
  !
  ! Do the job, just like a call to ATM command (cf astro_atm.f90)
  !
  do i=1,npoints
     ff(i) = fmin + (fmax-fmin)*(i-1)/(npoints-1)
     freqs = ff(i)
     call atm_transm(water,1.0,freqs,temis,tatms,tauox,tauw,taut,ier)
     transmi(i) = 5*(1-taut) ! factor 5 to use plot Y limits = [0,5]
	 freqi = (umax-umin)*(freqs-fmin)/(fmax-fmin) + umin
     call atm_transm(water,airmass,freqi,temii,tatmi,tauox,tauw,taut,ier)
     call atm_transm(water,airmass,freqs,temis,tatms,tauox,tauw,taut,ier)
     !
     ! Compute Tsys
     !
     tsystem(i) = exp(taut*airmass) * (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
           (feff*temis+(1.0-feff)*t0 + trec) ) / feff
  enddo
  tsysmax = 1.1d0*maxval(tsystem)
  tsysmax = nint(tsysmax)
  tsystem = 5D0*tsystem/tsysmax
  !
  ! Plot atmosphere
  !
  call gr_exec('PEN 10 /COL 10')
  old_pen = gr_spen(10) ! select pen 10
  call gr_segm('ATMOSFILL',error)
  ! Set up the polygon description
  histo%contoured = .false.  ! Contour will be done with another color hereafter
  histo%hatched = .false.
  histo%filled = .true.
  base(:) = 4.98d0
  call gr8_histo_hatchfill(int(npoints,kind=size_length),ff,transmi,  &
                           nbase,base,0.d0,-1.d0,histo,error)
  call gr_segm_close(error)
  !
  call gr_exec('PEN 0 /COL 0 /DASH 3')
  old_pen = gr_spen(0) ! select pen 0
  call gr_segm('ATMOS',error)
  call gr8_connect(npoints,ff,transmi,0.0,-1.0)
  call gr_segm_close(error)
  !
  ! Plot Tsys
  !
  call gr_exec1('PEN 3 /COL 3 /DASH 1')
  i = gr_spen(3)   ! Select pen 3 (blue)
  call gr_segm('TSYS',error)
  call gr8_connect(npoints,ff,tsystem,0.0,-1.0)
  call gr_segm_close(error)
  write(mess,*) tsysmax
  call gr_exec('AXIS YL 0 '//trim(mess))
  call gr_exec('DRAW TEXT -2 0 "T\\dsys\\u (K)" 5 90 /BOX 4')
  ! call gr_exec('LABEL "T\\dsys\\u (K)" /Y')
  !
  ! Back to old pen
  !
  call gr_exec('PEN 0 /COL 0 /DASH 1')
  i = gr_spen(old_pen)
  !
end subroutine pdbi_line_atmos
!
subroutine pdbi_line_spurious
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot spurious lines. Box must be in IF1 limits.
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=132) :: chain
  ! character(len=message_length) :: mess
  !
  ! write(mess,'(A,F6.1,A)') 'Plotting possible spurious lines '// &
  !     ' (FLO1REF = ',flo1ref,' MHz)'
  ! call astro_message(seve%i,rname,mess)
  !
  call gr_exec1('PEN 2 /DASH 3')
  write(chain,1050) 3*flo1ref
  call gr_exec1(chain)
  write(chain,1060) 3*flo1ref
  call gr_exec1(chain)
  write(chain,1080) 3*flo1ref, '3*FLO1REF'
  call gr_exec1(chain)
  write(chain,1050) 4*flo1ref
  call gr_exec1(chain)
  write(chain,1060) 4*flo1ref
  call gr_exec1(chain)
  write(chain,1080) 4*flo1ref, '4*FLO1REF'
  call gr_exec1(chain)
  write(chain,1050) 6300.
  call gr_exec1(chain)
  write(chain,1060) 6300.
  call gr_exec1(chain)
  write(chain,1080) 6300., '"6300 MHz"'
  call gr_exec1(chain)
  write(chain,1050) 4500.
  call gr_exec1(chain)
  write(chain,1060) 4500.
  call gr_exec1(chain)
  write(chain,1080) 4500., '"4500 MHz"'
  call gr_exec1(chain)
  call gr_exec1('PEN 0')
  1050 format('DRAW RELOCATE ',f10.2,' 0 /USER')
  1060 format('DRAW LINE ',f10.2,' 5 /USER /CLIP')
  1080 format('DRAW TEXT 'f10.2,' 2.5 ',a,' 8 90 /USER /CLIP')
end subroutine pdbi_line_spurious

subroutine dotape (jc,nv,visi,jx,jy,taper,we)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING  Support for UV_MAP
  !     Apply taper to the weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) :: nv          ! number of values
  integer, intent(in) :: jc          ! Size of a visibility
  integer, intent(in) :: jx          ! X coord location in VISI
  integer, intent(in) :: jy          ! Y coord location in VISI
  real, intent(in) :: visi(jc,nv)    ! Visibilities
  real, intent(in) :: taper(4)       ! Taper definition
  real, intent(inout) :: we(nv)      ! Weights
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  integer iv
  real staper,etaper
  real u,v
  real cx,cy,sx,sy
  !
  if (taper(1).eq.0. .and. taper(2).eq.0.) return
  !
  staper = taper(3)*pi/180.0
  if (taper(1).ne.0) then
    cx = cos(staper)/taper(1)
    sy = sin(staper)/taper(1)
  else
    cx = 0.0
    sy = 0.0
  endif
  if (taper(2).ne.0) then
    cy = cos(staper)/taper(2)
    sx = sin(staper)/taper(2)
  else
    cy = 0.0
    sx = 0.0
  endif
  if (taper(4).ne.0.) then
    etaper = taper(4)/2.0
  else
    etaper = 1
  endif
  !
  do iv=1,nv
    u = visi(jx,iv)
    v = visi(jy,iv)
    !
    staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
    if (etaper.ne.1) staper = staper**etaper
    if (staper.gt.64.0) then
      staper = 0.0
    else
      staper = exp(-staper)
    endif
    we(iv) = we(iv)*staper
  enddo
end subroutine dotape
!
subroutine doweig (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
  use gildas_def
  use gkernel_interfaces
  use mapping_interfaces, except_this => doweig
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! MAPPING   Support for UV_MAP
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          ! number of values
  integer, intent(in) ::  jc          ! Number of "visibilities"
  integer, intent(in) ::  jx          ! X coord location in VISI
  integer, intent(in) ::  jy          ! Y coord location in VISI
  integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    ! Visibilities
  real, intent(in) ::  unif           ! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      ! Weight array
  real, intent(in) ::  wm             ! on input: % of uniformity
  real, intent(in) ::  vv(nv)         ! V values, pre-sorted
  logical, intent(inout) :: error
  integer, intent(in), optional :: code
  !
  integer i,iw
  real umin,umax,vmin,vmax,vstep,vimin,vimax
  real vcmin, vcmax
  integer nbcv, ivmin, ivmax, icv, nbv, new, nflag
  integer ier, icode
  character(len=message_length) :: chain
  !
  real my_wm
  real, allocatable :: my_we(:)
  !
  ! Natural weight
  nflag = 0
  if (unif.le.0.0 .or. wm.le.0.0) then
    if (jw.gt.0) then
      iw =7+3*jw
      do i=1,nv
        if (visi(iw,i).gt.0.0) then
          we(i) = visi(iw,i)
        else
          nflag = nflag+1
          we(i) = 0.0
        endif
      enddo
    else
      do i=1,nv
        we(i) = 1.0
      enddo
    endif
    if (nflag.ne.0) then
      write(chain,'(I12,A)') nflag,' flagged visibilities ignored'
      call map_message(seve%i,'DOWEIG',chain)
    endif
    return
  endif
  !
  if (present(code)) then
    icode = code
  else
    icode = -1
  endif
  !
  if (icode.ge.0) then
    iw = 7+3*jw
    !
    my_wm = wm
    allocate(my_we(nv),stat=ier)
    my_we = we(:)
    call doweig_sph (jc,nv,visi,jx,jy,iw,unif,my_we,my_wm,vv,error,code)
    we = my_we(:)
  else
    !
    ! Uniform weight
    !
    ! 1) Compute VMIN, VMAX, UMIN, UMAX
    vmin = visi(jy,1)
    vmax = visi(jy,nv)
    umin = 0.0
    umax = 0.0
    do i=1,nv
      if (visi(jx,i).lt.umin) then
        umin = visi(jx,i)
      elseif  (visi(jx,i).gt.umax) then
        umax = visi(jx,i)
      endif
    enddo
    !
    ! Symmetry ?...
    if (-umin.gt.umax) then
      umax = -umin
    else
      umin = -umax
    endif
    vmin = 1.001*vmin            ! Allow small margin
    umax = 1.001*umax
    umin = 1.001*umin
    !
    ! Some speed up factor
    nbcv = 128
    vstep = -vmin/nbcv
    !
    ! Adjust the number of cells. A cell must be > 2*UNIF, and > 4*UNIF is more
    ! than sufficient to get speed up.
    !
    if (vstep.lt.4*unif) then
      nbcv = int(-vmin/(4*unif))
!!      print *,'Vmin ',vmin,'Unif ',unif,' NBCV ',nbcv
      if (mod(nbcv,2).ne.0) nbcv = nbcv-1
      nbcv = max(1,nbcv)
      vstep = -vmin/nbcv
    endif
    !
    ! Loop on U,V cells
    nbv = 0
    ivmin = 1
    do icv = 1,nbcv
      vcmin = (icv-1)*vstep+vmin
      vimin = vcmin-unif
      vcmax = icv*vstep+vmin
      vimax = vcmax+unif
      call findp (nv,vv,vimin,ivmin)
      ivmax = ivmin
      call findp (nv,vv,vimax,ivmax)
      ivmax = min(nv,ivmax+1)
      new = ivmax-ivmin+1
      if (icv.eq.nbcv) then
        vimin = -unif
        call findp (nv,vv,vimin,ivmin)
        new = new + (nv-ivmin+1)
      endif
      nbv = max(new,nbv)
    enddo
    !
    !!print *,'OLD before Unif ',unif,' WM ',wm
    call doweig_quick (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,nbv,   &
       &    umin,umax,vmin,vmax,nbcv)
    !!print *,'OLD after Unif ',unif,' WM ',wm
  endif
  !
end subroutine doweig
!
subroutine doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
  use gildas_def
  use gkernel_interfaces
  use mapping_interfaces, except_this => doweig_sph
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   Support for UV_MAP
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          ! number of values
  integer, intent(in) ::  jc          ! Number of "visibilities"
  integer, intent(in) ::  jx          ! X coord location in VISI
  integer, intent(in) ::  jy          ! Y coord location in VISI
  integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    ! Visibilities
  real, intent(in) ::  unif           ! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      ! Weight array
  real, intent(in) ::  wm             ! on input: % of uniformity
  real, intent(in) ::  vv(nv)         ! V values, pre-sorted
  logical, intent(inout) :: error
  integer, intent(in), optional :: code  ! Number of sub-cells per UV uniform cell size
  !
  real, allocatable :: suu(:), svv(:), sww(:), swe(:)
  real :: weight, wmin, wmax, umin, umax, vmin, vmax
  real :: sizecell
  integer :: ier, mv, nbv, i, ivmin, icode
  character(len=120) :: mess
  character(len=*), parameter :: rname='DOWEIG'
  !
  ! For tests only
  logical :: briggs=.false.
  real :: s2
  !
  ! Find the location of -unif
  ivmin = 1
  call findp (nv,vv,-unif,ivmin)
  !
  mv = 2*nv-ivmin+1
  allocate(suu(mv),svv(mv),sww(mv),swe(mv),stat=ier)
  !
  suu(1:nv) = visi(jx,:)
  svv(1:nv) = visi(jy,:)
  sww(1:nv) = max(visi(jw,:),0.0)    
  !
  ! Find out extrema
  vmin = svv(1)
  vmax = unif
  umin = minval(suu(1:nv))
  umax = maxval(suu(1:nv))
  !
  ! Brutally apply Hermiticity
  nbv = nv
  do i=ivmin,nv
    nbv = nbv+1
    suu(nbv) = -visi(jx,i)
    svv(nbv) = -visi(jy,i)
    sww(nbv) = max(visi(jw,i),0.0)   
  enddo
  !
  ! Sub-divide the uniform cell size into sub-cells for speed
  ! The optimal depends on the density of UV points.
  ! In principle, it would depend on umin,umax, vmin,vmax and the
  ! number of points.  Use a stupid rule-of-thumb for now.
  !
  if (present(code).and.code.gt.0) then
    icode = max(2,code)
  else
    if (mv.le.2e5) then
      icode = 3
    else if (mv.le.1e6) then
      icode = 7
    else if (mv.le.5e6) then
      icode = 15
    else
      icode = 20
    endif
  endif
  sizecell = unif/icode
  !
  write(mess,'(A,I0,F6.1,F6.1)') "Gridding for ", mv, sizecell, unif
  call map_message(seve%i,rname,mess)
  write(mess,'(A,4F8.1)') "  and UV range ", umin, umax, vmin, vmax
  call map_message(seve%i,rname,mess)
  !
  call gridless_density(mv,sizecell,unif,suu,svv,sww,swe, &
    umin,umax,vmin,vmax,error)
  if (error) return
  !
  we(:) = swe(1:nv)
  !
  weight = 0.0
  wmax = 0.0
  wmin = 1.e36
  do i=1,nv
    if (we(i).gt.0.0) then
      wmin = min(we(i),wmin)
      wmax = max(we(i),wmax)
    endif
  enddo
  weight = sqrt(wmin*wmax)
  write(mess,'(A,2(1PG11.3,1X))') 'Relative Weight range ',wmin/weight,wmax/weight
  call map_message(seve%i,rname,mess)
  !
  if (briggs) then
    !
    ! Briggs Solution
    ! s = 5*10^(-Briggs)  with (typically) -2 < Briggs < 2
    !
    ! Experimentally, not as flexible as our default solution
    s2 = 5*10**(-wm)    ! s^2
    s2 = s2*s2
    do i=1,nv
      if (visi(jw,i).gt.0) then
        we(i) = visi(jw,i)/(s2*we(i)/weight+1.0)
      else
        we(i) = 0.0
      endif
    enddo
  else
    !
    ! S.Guilloteau solution
    weight = wm*weight
    do i=1,nv
      if (visi(jw,i).gt.0.0) then
        if (we(i).gt.weight) then
          we(i) = visi(jw,i)/we(i)*weight
        else
          we(i) = visi(jw,i)
        endif
      else
        we(i) = 0.0
      endif
    enddo
  endif
  !
end subroutine doweig_sph
!
subroutine gridless_density (npts,sizecell,distmax,evex,evey,eveweight,&
  & evesumweight,xmin,xmax,ymin,ymax,error)
  use gildas_def
  use mapping_interfaces, except_this => gridless_density
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support routine for Robust weighting
  !
  ! Stephane Paulin   OASU CNRS / U.Bordeaux  2016
  !
  ! Algorithm to compute the weighted neighborhood of each point in a large
  ! catalog. This algorithm was described, among other sources, by Daniel Briggs in
  ! his thesis. The idea is to avoid npts**2 calculations of the distance between
  ! each pair of points (npts is the # points). For that, one defines a grid only used
  ! to speed-up computation (result is independent of the grid).
  ! Step 1: In a given cell of the grid, all events are linked and the total weight
  !   of the cell is computed and kept in memory.
  ! Step 2: a pattern is computed, that is the same all over the field, whose radius
  !   is the maximum distance. Grid boxes can have 3 states: entirely inside the
  !   maximum distance, entirely outside, or in between (boxes noted 'intermediate'
  !   or 'mixed').
  ! The idea is to compute the distances only for events in these intermediate boxes.
  ! For other events, or the total weight of the box is added (if the box is inside),
  ! or the box is ignored (if outside). Next, the main loop consists on a loop on every
  ! event. For a given event, all boxes in the pattern are checked and treated accordingly.
  ! With this algorithm, one can have CPU times prop. to factor*npts*log(npts) with
  ! factor~2 (ie. when npts is multiplied by 10, the CPU is multiplied by ~45-50)

  ! Remarks/notes:
  ! - this is a preliminary approach for testing, where symmetries are not
  !   taken into account !!! ==> a given couple of coordinates (evex,evey) corresponds
  !   to one event
  !
  !----------------------------------------------------------------------
  real, intent(in) :: sizecell                ! size of a cell.
  ! this is a control parameter that does not change the result but
  ! change the calculation time: to minimize the CPU, the larger the
  ! event density, the smaller sizecell. ex: sizecell~20 (10, 5 resp.)
  ! for a catalog of 10**5 (10**6, 3x10**7) events
  integer, intent(in) :: npts                 ! total # of events
  real, intent(in) :: distmax                 ! maximum distance
  real(kind=4), intent(in) :: evex(npts)      ! X coordinates
  real(kind=4), intent(in) :: evey(npts)      ! Y coordinates
  real(kind=4), intent(in) :: eveweight(npts) ! Weight of event
  real(kind=4), intent(out) :: evesumweight(npts) ! Sum of the weights of all
  ! the events closer nearer than the maximum distance from the current event.
  real(kind=4), intent(in) :: xmin,ymin,xmax,ymax ! Min Max
  logical, intent(out) :: error               ! Error flag
  !
  ! Local
  integer(kind=4) :: nbboxx,nbboxy,nbbox,i,j,indice1,indice2
  integer :: xbox_cur,ybox_cur,nbcellmaxx,nbcellmaxy
  integer :: nbcellx,nbcelly,nbcellquartx,nbcellquarty
  real :: distmaxsq,temp
  real(kind=4) :: llx_cur,lly_cur,urx_cur,ury_cur,ulx_cen
  real(kind=4) :: llx_cen,lly_cen,lrx_cen,lry_cen,urx_cen,ury_cen,uly_cen
  real(kind=4) :: longest,shortest
  integer :: ier
  !
  ! Dynamic variables used by the gridless algorithm:
  ! each analysis has given # of events (npts) & size of the grid (sizecell==>nbbox)
  !
  real(kind=4), allocatable :: boxx(:),boxy(:)    ! Coordinates along box axis
  real, allocatable :: boxtotweight(:,:)          ! Total weight in boxes
  integer(kind=4), allocatable :: nextevent(:)    ! Chained pointer
  integer(kind=4), allocatable :: eveindx(:)      ! why not kind=8 ? if very large grid
  integer(kind=4), allocatable :: eveindy(:)      ! why not kind=8 ? if very large grid
  integer(kind=4), allocatable :: last(:,:)       ! Work array
  integer(kind=4), allocatable :: firstevent(:,:) ! First pointer of box
  integer(kind=4), allocatable :: boxnbevent(:,:) ! Number of events in box
  integer(kind=4), allocatable :: statebox(:,:)   ! Box status
  !
  error = .false.
  !
  distmaxsq = distmax*distmax
  evesumweight = 0
  !
  nbboxx = ceiling( (xmax-xmin) / sizecell)
  nbboxy = ceiling( (ymax-ymin) / sizecell)
  nbbox = nbboxx * nbboxy
  !
  ! Required elements
  error = .true.
  allocate(boxx(nbboxx),boxy(nbboxy),boxtotweight(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
  allocate(firstevent(nbboxx,nbboxy),nextevent(npts),stat=ier)
  if (ier.ne.0) return
  ! Potentially avoidable arrays
  allocate(eveindx(npts),eveindy(npts),boxnbevent(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
  ! Work array
  allocate(last(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
  error = .false.
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! basic initialisations
  do i = 1, nbboxy
    boxy(i) = (i-0.5)*sizecell + ymin
  enddo
  do i = 1, nbboxx
    boxx(i) = (i-0.5)*sizecell + xmin
  enddo
  boxnbevent = 0
  boxtotweight = 0
  last = 0
  !
  ! chaining the events
  eveindx = INT((evex-xmin)/sizecell) + 1  ! could be optimised/avoided, 
  ! but convenient in this preliminary version
  eveindy = INT((evey-ymin)/sizecell) + 1  ! idem
  !
  do i = 1, npts
    !
    ! could be optimised/avoided, but convenient in this preliminary version
    boxnbevent(eveindx(i),eveindy(i)) = boxnbevent(eveindx(i),eveindy(i)) + 1
    if (eveweight(i).gt.0) boxtotweight(eveindx(i),eveindy(i)) &
      & = boxtotweight(eveindx(i),eveindy(i)) + eveweight(i)
    !
    if (last(eveindx(i),eveindy(i)).EQ.0) then
      firstevent(eveindx(i),eveindy(i)) = i
    else
      nextevent(last(eveindx(i),eveindy(i))) = i
    endif
    last(eveindx(i),eveindy(i)) = i
  enddo
  deallocate(last)
  !
  ! defining the pattern
  !
  ! nbcellquart is the integer # of boxes in a quadrant excluding the axes
  temp = distmax / sizecell
  nbcellquartx = ceiling(temp)
  nbcellquarty = nbcellquartx ! working assumption: symmetry ==>
  ! in this preliminary version, only euclidian distances with 
  ! x<==>y (no ellipse but this would very simple to add this feature)
  !
  !nbcellmax is the maximum distance tolerated from 0, expressed in integer # of boxes
  nbcellmaxx = nbcellquartx
  nbcellmaxy = nbcellquarty
  !
  !nbcell is the # of boxes in the pattern
  nbcellx = nbcellmaxx*2
  nbcelly = nbcellmaxy*2
  !
  ! statebox specifies the status of a box : 1 <==> good ; 2 <==> mixed ; 3 <==> bad
  allocate(statebox(nbcellmaxx,nbcellmaxy))
  statebox = 0
  statebox(1,1) = 1

  ! Assumption: symmetry. For the moment we will assume all quarters are equivalent.
  ! Historically, the distance tests are performed considering the lower-left corner
  ! (so are the coordinates llx, lly, urx, ury... of the 'cur' pixel)
  ! but in the arrays indice 1 corresponds to the center and indice max corresponds
  ! to the outside, like an upper-right corner
  !
  llx_cen = 0
  lly_cen = 0
  urx_cen = sizecell
  ury_cen = sizecell
  lrx_cen = urx_cen
  lry_cen = lly_cen
  ulx_cen = llx_cen
  uly_cen = ury_cen
  !
  do indice1=1,nbcellquartx
    do indice2=1,nbcellquarty
      if (indice1.NE.1 .OR. indice2.NE.1) then
        ! there must be 2 loops:
        ! with indice2==1 & indice1>1 and shortest computed according to lr_cen ;
        ! with indice2>1 and shortest computed according to ur_cen
        !
        ! here the central pixel is refered with the suffix 'cen' while
        ! the floating pixel is refered by 'cur'
        !update 161017 cen is the upper-right pixel touching 0
        !
        urx_cur = indice1*sizecell
        ury_cur = indice2*sizecell
        !
        longest = calcdistsq(llx_cen,urx_cur,lly_cen,ury_cur)
        !
        if (longest.LE.distmaxsq) then
          statebox(indice1,indice2) = 1 ! reminder: 1 <==> good ; 2 <==> mixed ; 3 <==> bad
        else
          llx_cur = urx_cur - sizecell
          lly_cur = ury_cur - sizecell
          if (indice2.EQ.1) then
            shortest = calcdistsq(lrx_cen,llx_cur,lry_cen,lly_cur)
          else if (indice1.EQ.1) then
            shortest = calcdistsq(ulx_cen,llx_cur,uly_cen,lly_cur)
          else
            shortest = calcdistsq(urx_cen,llx_cur,ury_cen,lly_cur)
          endif
          if (shortest.LT.distmaxsq) then
            statebox(indice1,indice2) = 2
        !2 following lines are only for debugging (useless and slowing down the process)
        !else
        !  statebox(indice1,indice2) = 3 ! useless, was used for debugging but could be
          endif
        endif
      endif
    enddo
  enddo
  !
  ! main loop
  !
  ! For OMP programming, only evesumweight is updated here, so
  ! each Thread may get a copy, and we sum them later.
  ! All the rest can be shared arrays on input, and local variables
  ! for the loop indices or dependent intermediate variables
  !
  do i = 1, nbboxx
    do j = 1, nbboxy
      if (boxnbevent(i,j).GT.0) then
        call linkidenticalbox(boxnbevent(i,j),firstevent(i,j),boxtotweight(i,j), &
        & evesumweight,nextevent)
        do indice1 = 1, nbcellmaxx
          do indice2 = 1, nbcellmaxy
            if (indice1.NE.1 .OR. indice2.NE.1) then
              xbox_cur = i-1+indice1
              ybox_cur = j-1+indice2
              if (xbox_cur.GT.0 .AND. ybox_cur.GT.0 .AND. xbox_cur.LE.nbboxx &
              & .AND.ybox_cur.LE.nbboxy) then
                if (boxnbevent(xbox_cur,ybox_cur).GT.0) then
                  if (statebox(indice1,indice2).EQ.1) then
                    call linkgoodbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                      & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                      & boxtotweight(i,j),boxtotweight(xbox_cur,ybox_cur), &
                      & evesumweight,nextevent)
                  else if (statebox(indice1,indice2).EQ.2) then
                    call linkmixedbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                      & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                      & evesumweight, eveweight, evex, evey, nextevent, &
                      & distmax, distmaxsq)
                  endif
                endif
              endif
            endif
            !
            if (indice1.LT.nbcellmaxx .AND. indice2.GT.1) then
              ! warning: left side of the horizontal line is excluded
              xbox_cur = i-indice1 ! warning: symmetry broken since the pattern is not centered
              ybox_cur = j-1+indice2
              if (xbox_cur.GT.0 .AND. ybox_cur.GT.0 .AND. &
                  xbox_cur.LE.nbboxx .AND. ybox_cur.LE.nbboxy) then
                if (boxnbevent(xbox_cur,ybox_cur).GT.0) then
                  if (statebox(indice1+1,indice2).EQ.1) then
                    call linkgoodbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                      & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                      & boxtotweight(i,j),boxtotweight(xbox_cur,ybox_cur), &
                      & evesumweight,nextevent)
                  else if (statebox(indice1+1,indice2).EQ.2) then
                    call linkmixedbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                      & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                      & evesumweight, eveweight, evex, evey, nextevent, &
                      & distmax, distmaxsq)
                  endif
                endif
              endif
            endif
          enddo
        enddo
      endif
    enddo
  enddo
  !
  deallocate(statebox)
  deallocate(boxx,boxy,boxtotweight)
  deallocate(firstevent,nextevent)
  deallocate(eveindx,eveindy,boxnbevent)
  !
end subroutine gridless_density
!
function calcdistsq(x1,x2,y1,y2)
  ! @ private
  real(kind=4) calcdistsq ! intent(out)
  real(kind=4), intent(in) :: x1,y1,x2,y2
  !
  calcdistsq = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)
end function calcdistsq
!
!
subroutine linkidenticalbox(nb, ind_init, boxtotweight, evesumweight, nextevent)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support routine for Robust Weighting
  !
  !   Build the chain list of pixels in the same cell with
  !   the same status
  !
  real, intent(in) :: boxtotweight                    ! Box total weight
  integer(kind=4), intent(in) :: nb                   ! Size of chain
  integer(kind=4), intent(in) :: ind_init             ! Starting index in each box
  real(kind=4), intent(inout) :: evesumweight(:)      ! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         ! Chained pointers
  !
  integer(kind=4) :: ind, i
  !
  ! reminder: at the beginning, ind==firstevent of the box
  ind = ind_init
  do i = 1, nb
    evesumweight(ind) = evesumweight(ind) + boxtotweight
    ind = nextevent(ind)
  enddo
end subroutine linkidenticalbox
!
subroutine linkgoodbox(nb1, nb2, ind1_init, ind2_init, &
  & boxtotweight1, boxtotweight2, evesumweight, nextevent)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support routine for Robust Weighting
  !
  !   Build the chain list of pixels in the same cell with
  !   the same status
  !
  !----------------------------------------------------------------------
  real, intent(in) :: boxtotweight1, boxtotweight2    ! Total weight of each box
  integer(kind=4), intent(in) :: nb1, nb2             ! Box sizes
  integer(kind=4), intent(in) :: ind1_init, ind2_init ! Starting index in each box
  real(kind=4), intent(inout) :: evesumweight(:)      ! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         ! Chained pointers
  !
  integer(kind=4) :: ind1, ind2, i
  !
  ! reminder: at the beginning, ind==firstevent of the box
  ind1 = ind1_init
  ind2 = ind2_init
  !
  do i = 1, nb1
    evesumweight(ind1) = evesumweight(ind1) + boxtotweight2
    ind1 = nextevent(ind1)
  enddo
  do i = 1, nb2
    evesumweight(ind2) = evesumweight(ind2) + boxtotweight1
    ind2 = nextevent(ind2)
  enddo
  !
end subroutine linkgoodbox
!
subroutine linkmixedbox(nb1, nb2, ind1_init, ind2_init, evesumweight, &
  & eveweight, evex, evey, nextevent, distmax, distmaxsq)
  use gildas_def
  use mapping_interfaces, only : calcdistsq
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support routine for Robust Weighting
  !
  !   Build chain list of different types
  !
  !----------------------------------------------------------------------
  integer(kind=4), intent(in) :: nb1, nb2             ! Box sizes
  integer(kind=4), intent(in) :: ind1_init, ind2_init ! Starting index in each box
  real, intent(in) :: distmax, distmaxsq              ! Averaging radius
  real(4), intent(in) :: eveweight(:)                 ! Initial weights
  real(4), intent(in) :: evex(:)                      ! Event X coordinates
  real(4), intent(in) :: evey(:)                      ! Event Y coordinates
  real(kind=4), intent(inout) :: evesumweight(:)      ! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         ! Chained pointers
  !
  integer(kind=4) :: ind1, ind2, i, j
  !
  ind1 = ind1_init
  ind2 = ind2_init
  !
  do i =1,nb1
    do j = 1,nb2
      if (abs(evex(ind1)-evex(ind2)).LE.distmax) then
        if (abs(evey(ind1)-evey(ind2)).LE.distmax) then
          if (calcdistsq(evex(ind1),evex(ind2),evey(ind1),evey(ind2)).LE.distmaxsq) then
            evesumweight(ind1) = evesumweight(ind1) + eveweight(ind2)
            evesumweight(ind2) = evesumweight(ind2) + eveweight(ind1)
          endif
        endif
      endif
      ind2 = nextevent(ind2)
    enddo
    ind1 = nextevent(ind1)
    ind2 = ind2_init
  enddo
  !
end subroutine linkmixedbox
!
subroutine scawei (nv,uni,ori,wall)
  !---------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Scale the weights
  !---------------------------------------------------------
  integer, intent(in) :: nv     ! Number of visibilities
  real, intent(out) :: uni(nv)  ! Re-weighted weights
  real, intent(in)  :: ori(nv)  ! Original weights
  real, intent(out) :: wall     ! Sum of weights
  !
  integer i
  real(kind=8) a, s, s2
  !
  s = 0   ! Sum of scaling factors
  s2 = 0  ! Sum of square of scaling factors
  do i=1,nv
    if (uni(i).gt.0) then
      a = uni(i)/ori(i)
      s = s+uni(i)        ! s+a
      s2 = s2+uni(i)*a    ! s2+a*a
    endif
  enddo
  !
  ! Like UV_STAT, better result
  a = s / s2
  uni(1:nv) = uni(1:nv)*a
  wall = a*s
end subroutine scawei
!
subroutine chkfft (a,nx,ny,error)
  !---------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Check if FFT is centered...
  !---------------------------------------------------------
  integer, intent(in)  ::  nx,ny   ! X,Y size
  logical, intent(out)  ::  error  ! Error flag
  real, intent(in)  ::  a(nx,ny)   ! Array
  !
  error = a(nx/2+1,ny/2+1).eq.0.0
end subroutine chkfft
!
subroutine doweig_quick (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,mv, &
     &     umin,umax,vmin,vmax,nbcv)
  use gkernel_interfaces
  use gildas_def
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          ! number of values
  integer, intent(in) ::  jc          ! Number of "visibilities"
  integer, intent(in) ::  jx          ! X coord location in VISI
  integer, intent(in) ::  jy          ! Y coord location in VISI
  integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
  integer, intent(in) ::  mv          ! Size of work arrays
  integer, intent(in) ::  nbcv        ! Buffering factor
  real, intent(in) ::  visi(jc,nv)    ! Visibilities
  real, intent(in) ::  unif           ! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      ! Weight array
  real, intent(in) ::  wm             ! on input: % of uniformity
  real, intent(in) ::  vv(nv)         ! V values, pre-sorted
  real, intent(out) :: umin,umax,vmin,vmax
  !
  ! Automatic arrays
  integer, allocatable :: ipv(:)
  real, allocatable :: utmp(:), vtmp(:), wtmp(:), rtmp(:)
  !
  integer i,iw
  real u,v,weight,wmax,wmin
  !
  real vstep,ustep,vimin,vimax,uimin,uimax
  real ucmin, ucmax, vcmin, vcmax
  integer nbcu, ivmin, ivmax, icu, icv, nbv, isub, ier
  character(len=message_length) :: chain
  character(len=*), parameter :: rname='DOWEIG'
  !
  allocate (utmp(mv), vtmp(mv), wtmp(mv), rtmp(mv), ipv(mv), stat=ier)
  !
  we(1:nv) = -1.0
  isub = 0
  !
  ! Some speed up factor
  nbcu = 2*nbcv
  vstep = -vmin/nbcv
  ustep = (umax-umin)/nbcu
  !
  ! Adjust the number of cells. A cell must be > 2*UNIF, and > 4*UNIF is more
  ! than sufficient to get speed up.  -- Current coding guarantees the
  ! situation below never happens in GILDAS, so allow a fatal crash
  ! in case somebody else breaks the rule...
  if (vstep.lt.4*unif) then
    write (chain,*) 'Vstep is too small',vstep,unif,vmin,nbcv
    call map_message(seve%w,rname,chain)
    if (nbcv.ne.1) call sysexi(fatale)
  endif
  !
  ! There is a weight column
  if (jw.gt.0) then
    iw = 7+3*jw
    !
    ! Loop on U,V cells
    do icv = nbcv,1,-1
      vcmin = (icv-1)*vstep+vmin
      vimin = vcmin-unif
      vcmax = icv*vstep+vmin
      vimax = vcmax+unif
      !
      ivmin = 1
      ivmax = nv
      call findp (nv,vv,vimin,ivmin)
      ivmax = ivmin
      call findp (nv,vv,vimax,ivmax)
      ivmax = min(nv,ivmax+1)
      !
      do icu = 1,nbcu
        ucmin = (icu-1)*ustep+umin
        uimin = ucmin-unif
        ucmax = icu*ustep+umin
        uimax = ucmax+unif
        !
        ! Select valid visibilities
        nbv = 0
        do i=ivmin,ivmax
          ! Note that V stays ordered by increasing values
          u = visi(jx,i)
          v = visi(jy,i)
          !
          ! Normal case only...
          if ((v.ge.vimin).and.(v.le.vimax)) then
            if ((u.ge.uimin).and.(u.le.uimax)) then
              nbv = nbv+1
              ipv(nbv) = i
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= visi(iw,i)
            endif
          endif
          !
          ! Limiting case near V=0, inverse the U test...
          if (-v.le.unif) then
            if ((u.lt.-uimin).and.(u.gt.-uimax)) then
              nbv = nbv+1
              ipv(nbv) = 0
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= visi(iw,i)
            endif
          endif
        enddo
        !
        ! Compute the weights
        if (nbv.gt.0) then
          isub = isub+1
          call doweig_sub (nbv,utmp,vtmp,wtmp, rtmp, unif)
          !
          ! IPV is a back pointer
          do i=1,nbv
            if ( (utmp(i).gt.ucmin.and.utmp(i).le.ucmax)   &
     &              .and. (vtmp(i).gt.vcmin.and.vtmp(i).le.vcmax) )   &
     &              then
              if (ipv(i).ne.0) then
                if (we(ipv(i)).ne.-1.0) then
                  print *,'Computed ',i,ipv(i),we(ipv(i)),rtmp(i)
                endif
                we(ipv(i)) = rtmp(i)
              endif
            endif
          enddo
        endif
        !
      enddo
      if (icv.eq.nbcv) call map_message(seve%i,rname,'Done boundary cells')
    enddo
    !
    ! All weights are computed now, normalize them
    weight = 0.0
    wmax = 0.0
    wmin = 1.e36
    do i=1,nv
      wmax = max(we(i),wmax)
      if (we(i).gt.0.0) wmin = min(we(i),wmin)
      weight = weight+we(i)
    enddo
    weight = weight/nv
    !!write(6,*) 'Raw Weights ',weight,wmax,wmin,sqrt(wmin*wmax)*wm
    weight = wm*sqrt(wmin*wmax)
    !!write(6,*) 'Renormalized Weights ',wmax/weight,wmin/weight
    do i=1,nv
      if (we(i).gt.weight) then
        we(i) = visi(iw,i)/we(i)*weight
      elseif (we(i).gt.0.0) then
        we(i) = visi(iw,i)
      endif
    enddo
  else
    !
    ! No weighting column
    !
    ! Loop on U,V cells
    do icv = 1,nbcv
      vimin = (icv-1)*vstep+vmin-unif
      vimax = vimin+vstep+unif
      !
      ivmin = 1
      ivmax = nv
      call findp (nv,vv,vimin,ivmin)
      call findp (nv,vv,vimax,ivmax)
      !
      do icu = 1,nbcu
        uimin = (icu-1)*ustep+umin-unif
        uimax = uimin+ustep+unif
        !
        ! Select valid visibilities
        nbv = 0
        do i=ivmin,ivmax
          u = visi(jx,i)
          v = visi(jy,i)
          !
          ! Normal case only...
          if ((v.gt.vimin).and.(v.lt.vimax)) then
            if ((u.gt.uimin).and.(u.gt.uimax)) then
              nbv = nbv+1
              ipv(nbv) = i
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= 1.0   ! No weight channel
            endif
          endif
          !
          ! Limiting case near V=0, inverse the U test...
          if (-v.le.unif) then
            if ((u.lt.-uimin).and.(u.gt.-uimax)) then
              nbv = nbv+1
              ipv(nbv) = 0
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= 1.0   ! No weight channel
            endif
          endif
        enddo
        !
        ! Compute the weight density
        if (nbv.gt.0) then
          call doweig_sub (nbv,utmp,vtmp,wtmp, rtmp, unif)
          !
          ! IPV is a back pointer
          do i=1,nbv
            if (ipv(i).ne.0) we(ipv(i)) = rtmp(i)
          enddo
        endif
        !
      enddo
    enddo
    !
    weight = 0.0
    wmax = 0.0
    wmin = 1.e36
    do i=1,nv
      wmax = max(we(i),wmax)
      if (we(i).gt.0.0) wmin = min(we(i),wmin)
      weight = weight+we(i)
    enddo
    weight = weight/nv
    !!write(6,*) 'Raw Weights ',weight,wmax,wmin,sqrt(wmin*wmax)*wm
    weight = wm*sqrt(wmin*wmax)
    !!write(6,*) 'Renormalized Weights ',wmax/weight,wmin/weight
    do i=1,nv
      if (we(i).gt.weight) then
        we(i) = 1.0/we(i)
      elseif (we(i).gt.0.0) then
        we(i) = 1.0/weight
      endif
    enddo
  endif
end subroutine doweig_quick
!
subroutine doweig_sub (nv,uu,vv,ww,we,unif)
  !$ use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) :: nv          ! number of values
  real, intent(in) ::  uu(nv)        ! U coordinates
  real, intent(in) ::  vv(nv)        ! V coordinates
  real, intent(in) ::  ww(nv)        ! Input Weights
  real, intent(out) ::  we(nv)       ! Output weights
  real, intent(in) ::  unif          ! Cell size
  !
  integer i,j
  real u,v,weight,v_aux
  integer :: ithread, mthread
  !
  ! Uniform weights only
  mthread = 1
  !$  mthread = omp_get_max_threads()
  !!$  print *,'OMP Already parallel ',omp_in_parallel(),' Nesting ',omp_get_nested(), mthread
  !$OMP PARALLEL &
  !$OMP &   SHARED(ww,uu,vv),  &
  !$OMP &   PRIVATE(ithread,i,j,weight,u,v,v_aux)
  !
  !$OMP DO
  do i=1,nv
    if (ww(i).le.0.0) then
      we(i) = 0.0
    else
      weight = ww(i)
      u = uu(i)
      v = vv(i)
      j = i-1
      v_aux = v-unif
      do while (j.gt.0 .and. vv(j).gt.v_aux)
        if (abs(u-uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j-1
      enddo
      j = i+1
      v_aux = v+unif
      do while (j.le.nv .and. vv(j).lt.v_aux)
        if (abs(u-uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j+1
      enddo
      !
      ! Close to (U,V) = (0,0), take symmetry into account
      j = nv
      v_aux = -(v+unif)
      do while (j.gt.0 .and. vv(j).gt.v_aux)
        if (abs(u+uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j-1
      enddo
      we(i) = weight
    endif
  enddo
  !$OMP END DO
  !$OMP FLUSH
  !$OMP END PARALLEL
end subroutine doweig_sub
!
subroutine doweig_slow (jc,nv,visi,jx,jy,jw,unif,we,wm)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          ! number of values
  integer, intent(in) ::  jc          ! Number of "visibilities"
  integer, intent(in) ::  jx          ! X coord location in VISI
  integer, intent(in) ::  jy          ! Y coord location in VISI
  integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    ! Visibilities
  real, intent(in) ::  unif           ! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      ! Weight array
  real, intent(in) ::  wm             ! on input: % of uniformity
  !
  integer i,j,iw
  real u,v,weight,wmax,wmin,v_aux
  !
  ! There is a weight column
  if (jw.gt.0) then
    iw = 7+3*jw
    !
    ! Uniform weights
    if (unif.gt.0) then
      do i=1,nv
        if (visi(iw,i).le.0.0) then
          we(i) = 0.0
        else
          weight = visi(iw,i)
          v = visi(jy,i)
          u = visi(jx,i)
          j = i-1
          v_aux = v-unif
          do while (j.gt.0 .and. visi(jy,j).gt.v_aux)
            ! unoptimized
            !                  do while (j.gt.0 .and. (v-visi(jy,j)).lt.unif)
            if (abs(u-visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.0)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j-1
          enddo
          j = i+1
          v_aux = v+unif
          do while (j.le.nv .and. visi(jy,j).lt.v_aux)
            ! unoptimized
            !                  do while (j.le.nv .and. (visi(jy,j)-v).lt.unif)
            if (abs(u-visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.0)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j+1
          enddo
          !
          ! Close to (U,V) = (0,0), take symmetry into account
          j = nv
          v_aux = -(v+unif)
          do while (j.gt.0 .and. visi(jy,j).gt.v_aux)
            ! unoptimized
            !                  do while (j.gt.0 .and. (-visi(jy,j)-v).lt.unif)
            if (abs(u+visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j-1
          enddo
          we(i) = weight
        endif
      enddo
      !
      weight = 0.0
      wmax = 0.0
      wmin = 1.e36
      do i=1,nv
        wmax = max(we(i),wmax)
        if (we(i).gt.0.0) wmin = min(we(i),wmin)
        weight = weight+we(i)
      enddo
      weight = weight/nv
      write(6,*) 'Weights ',weight,wmax,wmin,   &
     &        sqrt(wmin*wmax)*wm
      weight = wm*sqrt(wmin*wmax)
      do i=1,nv
        if (we(i).gt.weight) then
          we(i) = visi(iw,i)/we(i)*weight
        elseif (we(i).gt.0.0) then
          we(i) = visi(iw,i)
        endif
      enddo
    else
      !
      ! Natural weights
      do i=1,nv
        if (visi(iw,i).gt.0.0) then
          we(i) = visi(iw,i)
        else
          we(i) = 0.0
        endif
      enddo
    endif
  else
    !
    ! No weighting column
    if (unif.ge.0) then
      !
      ! Uniform weights
      do i=1,nv
        weight = 1
        v = visi(jy,i)
        u = visi(jx,i)
        j = i-1
        do while (j.gt.0 .and. (u-visi(jy,j)).lt.unif)
          if (abs(u-visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j-1
        enddo
        j = i+1
        do while (j.le.nv .and. (visi(jy,j)-v).lt.unif)
          if (abs(u-visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j+1
        enddo
        j = nv
        do while (j.ge.1 .and. (-visi(jy,j)-v).lt.unif)
          if (abs(u+visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j-1
        enddo
        we(i) = weight
      enddo
      !
      weight = 0.0
      wmax = 0.0
      wmin = 1.e36
      do i=1,nv
        wmax = max(we(i),wmax)
        if (we(i).gt.0.0) wmin = min(we(i),wmin)
        weight = weight+we(i)
      enddo
      weight = weight/nv
      write(6,*) 'Weights ',weight,wmax,wmin,   &
     &        sqrt(wmin*wmax)*wm
      weight = wm*sqrt(wmin*wmax)
      do i=1,nv
        if (we(i).gt.weight) then
          we(i) = 1.0/we(i)
        elseif (we(i).gt.0.0) then
          we(i) = 1.0/weight
        endif
      enddo
    else
      !
      ! Natural weighting
      do i=1,nv
        we(i) = 1.0
      enddo
    endif
  endif
end subroutine doweig_slow

subroutine display(set,line,obs,error)
  use gbl_message
  use classfit_dependencies_interfaces
  use classfit_interfaces, except_this=>display
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! FIT support routine for command DISPLAY for spectroscopic data
  ! DISPLAY [YOFF]
  ! 1       [/NOPLOT]
  ! 2       [/METHOD]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  type(observation),   intent(in)    :: obs    !
  logical,             intent(inout) :: error  ! Flag
  ! Local
  character(len=*), parameter :: rname='DISPLAY'
  integer(kind=4) :: nkey,nc
  real(kind=4) :: yoff
  character(len=80) :: chain
  logical :: doplot,domethod
  integer(kind=4), parameter :: nvocab=6
  character(len=10) :: argum,keyword
  character(len=10) :: vocab(nvocab)
  data vocab /'GAUSS','NH3','HFS','ABSORPTION','SHELL','CONTINUUM'/
  !
  yoff = 0.
  if (sic_present(0,1)) then
    call sic_r4(line,0,1,yoff,.false.,error)
    if (error)  return
  endif
  doplot = .not.sic_present(1,0)
  domethod = sic_present(2,0)
  if (domethod) then
     call sic_ke(line,2,1,argum,nc,.true.,error)
     call sic_ambigs(rname,argum,keyword,nkey,vocab,nvocab,error)
     if (error) return
  else
     keyword = set%method
  endif
  select case (keyword)
  case ('GAUSS')
     call disgau(set,obs%head,class_setup_get_fangle(),yoff,doplot,error)
  case ('NH3')
     call disnh3(set,obs%head,yoff,doplot,error)
  case ('HFS')
     call disnh3(set,obs%head,yoff,doplot,error)
  case ('ABSORPTION')
     call disabs(set,obs%head,yoff,doplot,error)
  case ('SHELL')
     call dishel(set,obs%head,yoff,doplot,error)
  case ('CONTINUUM','BASECONT')
     call dispoi(set,obs%head,class_setup_get_fangle(),yoff,doplot,error)
  end select
  !
  if (error) then
     write(chain,*) "No ",keyword," fit for observation ",obs%head%gen%num
     call class_message(seve%w,rname,chain)
  endif
  !
end subroutine display
!
subroutine disgau(set,obs,fangle,yoff,doplot,error)
  use gbl_constant
  use gbl_message
  use classfit_interfaces, except_this=>disgau
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   DISPLAY for GAUSS
  ! Retrieves and writes gauss fit results for current observation
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set     !
  type(header),        intent(in)    :: obs     ! Observation header
  real(kind=8),        intent(in)    :: fangle  !
  real(kind=4),        intent(in)    :: yoff    ! Optionnal Y offset
  logical,             intent(in)    :: doplot  ! on the graphic device
  logical,             intent(inout) :: error   ! Flag
  ! Local
  character(len=*), parameter :: rname='DISPLAY'
  character(len=message_length) :: chain
  integer(kind=4) :: k,k1,k2,i,lc
  real(kind=8) :: ang
  !
  if (.not.obs%presec(class_sec_gau_id)) then
     error = .true.
     return
  endif
  !
  ! Print the results
  call class_message(seve%r,rname,'')
  write(chain,1001)  obs%gen%num,obs%gau%sigba,obs%gau%sigra
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  if (obs%gau%sigba.gt.1.5*obs%gau%sigra) then
     write(chain,'(10X,A)')  'Optimistic fit'
  else if (obs%gau%sigba.lt.obs%gau%sigra/1.5) then
     write(chain,'(10X,A)')  'Bad fit'
  else
     write(chain,'(10X,A)')  'Fit results'
  endif
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  !
  k=1
  if (obs%gen%kind.eq.kind_spec) then ! Spectroscopic type
     ang = 1.d0
  else                                ! Continuum drift
     ang = fangle
  endif
  !
  write(chain,1000)
  call class_message(seve%r,rname,chain)
  do i=1,max(obs%gau%nline,1)
     k1=k+1
     k2=k+2
     if (obs%gau%nfit(k2).ne.0.0) then
        ! Width.ne.0 : compute peak temperature (4th param.)
        write (chain,1004) i,&
             obs%gau%nfit(k) *ang,obs%gau%nerr(k) *ang,   &
             obs%gau%nfit(k1)*ang,obs%gau%nerr(k1)*ang,   &
             obs%gau%nfit(k2)*ang,obs%gau%nerr(k2)*ang,   &
             obs%gau%nfit(k)/obs%gau%nfit(k2)/1.064467
     else
        ! Width.eq.0 : peak temperature set to '****'
        write (chain,1005) i,&
             obs%gau%nfit(k) *ang,obs%gau%nerr(k) *ang,   &
             obs%gau%nfit(k1)*ang,obs%gau%nerr(k1)*ang,   &
             obs%gau%nfit(k2)*ang,obs%gau%nerr(k2)*ang
     endif
     lc = len_trim(chain)
     call class_message(seve%r,rname,chain)
     if (doplot) call displo(set,obs,chain,lc,i,yoff)
     k=k+3
  enddo
  !
1001 format (1x,'Observation ',i0,' RMS of Residuals :  Base = ',1pg9.2,'  Line = ',1pg9.2)
1000 format (' Line',8x,'Area',19x,'Position',12x,'Width',13x,'Tpeak')
1004 format (i2,3x,1pg12.5,' (',1pg9.3,')',2(1x,0pf9.3,' (',0pf7.3,')'),1x,1pg12.5)
1005 format (i5,3x,1pg12.5,' (',1pg9.3,')',2(1x,0pf9.3,' (',0pf7.3,')'),1x,'  ****')
end subroutine disgau
!
subroutine disnh3(set,obs,yoff,doplot,error)
  use gbl_message
  use classfit_interfaces, except_this=>disnh3
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   DISPLAY for NH3
  ! Retrieves and writes line fit results for NH3
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set     !
  type(header),        intent(in)    :: obs     ! Observation header
  real(kind=4),        intent(in)    :: yoff    ! Optionnal Y offset
  logical,             intent(in)    :: doplot  ! on the graphic device
  logical,             intent(inout) :: error   ! Flag
  ! Local
  character(len=*), parameter :: rname='DISPLAY'
  character(len=message_length) :: chain
  integer(kind=4) :: k,i,lc
  !
  if (.not.obs%presec(class_sec_hfs_id)) then
     error = .true.
     return
  endif
  !
  ! Print the results
  call class_message(seve%r,rname,'')
  write(chain,1001)  obs%gen%num,obs%hfs%sigba,obs%hfs%sigra
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  if (obs%hfs%sigba.gt.1.5*obs%hfs%sigra) then
     write(chain,'(10X,A)')  'Optimistic fit'
  else if (obs%hfs%sigba.lt.obs%hfs%sigra/1.5) then
     write(chain,'(10X,A)')  'Bad fit'
  else
     write(chain,'(10X,A)')  'Fit results'
  endif
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  !
  write(chain,1000)
  call class_message(seve%r,rname,chain)
  k=1
  do i=1,max(obs%hfs%nline,1)
     write (chain,1004) i, &
          obs%hfs%nfit(k),  obs%hfs%nerr(k),   &
          obs%hfs%nfit(k+1),obs%hfs%nerr(k+1), &
          obs%hfs%nfit(k+2),obs%hfs%nerr(k+2), &
          obs%hfs%nfit(k+3),obs%hfs%nerr(k+3)
     k=k+4
     lc = len_trim(chain)
     call class_message(seve%r,rname,chain)
     if (doplot)  call displo(set,obs,chain,lc,i,yoff)
  enddo
  !
1001 format (1x,'Observation ',i0,' RMS of Residuals :  Base = ',1pg9.2,'  Line = ',1pg9.2)
1000 format (' Line     T ant * Tau           V lsr          delta V            Tau main')
1004 format (i3,4(2x,1pg8.3e1,'(',g8.3e1,')'))
! 1004 format (i3,4(2x,f8.3,' (',f6.3,')'))
end subroutine disnh3
!
subroutine disabs(set,obs,yoff,doplot,error)
  use gbl_message
  use classfit_interfaces, except_this=>disabs
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   DISPLAY for ABS
  ! Retrieves and writes line fit results for ABS
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set     !
  type(header),        intent(in)    :: obs     ! Observation header
  real(kind=4),        intent(in)    :: yoff    ! Optionnal Y offset
  logical,             intent(in)    :: doplot  ! on the graphic device
  logical,             intent(inout) :: error   ! Flag
  ! Local
  character(len=*), parameter :: rname='DISPLAY'
  character(len=message_length) :: chain
  integer(kind=4) :: k,i,lc
  !
  if (.not.obs%presec(class_sec_abs_id)) then
     error = .true.
     return
  endif
  !
  ! Print the results
  call class_message(seve%r,rname,'')
  write(chain,1001)  obs%gen%num,obs%abs%sigba,obs%abs%sigra
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  if (obs%abs%sigba.gt.1.5*obs%abs%sigra) then
     write(chain,'(10X,A)')  'Optimistic fit'
  else if (obs%abs%sigba.lt.obs%abs%sigra/1.5) then
     write(chain,'(10X,A)')  'Bad fit'
  else
     write(chain,'(10X,A)')  'Fit results'
  endif
  call class_message(seve%r,rname,chain)
  write(chain,1010)  obs%abs%nfit(1),obs%abs%nerr(1)
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  !
  write(chain,1000)
  call class_message(seve%r,rname,chain)
  k=2
  do i=1,max(obs%abs%nline,1)
     write (chain,1004) i,&
          obs%abs%nfit(k),  obs%abs%nerr(k),     &
          obs%abs%nfit(k+1),obs%abs%nerr(k+1),   &
          obs%abs%nfit(k+2),obs%abs%nerr(k+2)
     k=k+3
     lc = len_trim(chain)
     call class_message(seve%r,rname,chain)
     if (doplot) call displo(set,obs,chain,lc,i,yoff)
  enddo
  !
1001 format (1x,'Observation ',i0,' RMS of Residuals :  Base = ',1pg9.2,'  Line = ',1pg9.2)
1000 format (' Line',t15,'Tau',t34,'V lsr',t53,'Delta V ')
1004 format ('   ',i1,3(2x,f7.3,' (',f6.3,')'))
1010 format (' Continuum ',f7.3,' (',f6.3,')')
end subroutine disabs
!
subroutine dishel(set,obs,yoff,doplot,error)
  use phys_const
  use gbl_message
  use classfit_interfaces, except_this=>dishel
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   DISPLAY for SHELL
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set     !
  type(header),        intent(in)    :: obs     ! Observation header
  real(kind=4),        intent(in)    :: yoff    ! Optionnal Y offset
  logical,             intent(in)    :: doplot  ! on the graphic device
  logical,             intent(inout) :: error   ! Flag
  ! Local
  character(len=*), parameter :: rname='DISPLAY'
  character(len=message_length) :: chain
  integer(kind=4) :: k,i,lc
  real(kind=8) :: f,fi
  real(kind=4) :: d,ed,x
  !
  if (.not.obs%presec(class_sec_she_id)) then
     error = .true.
     return
  endif
  !
  ! Print the results
  call class_message(seve%r,rname,'')
  write(chain,1001)  obs%gen%num,obs%she%sigba,obs%she%sigra
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  if (obs%she%sigba.gt.1.5*obs%she%sigra) then
     write(chain,'(10X,A)')  'Optimistic fit'
  elseif (obs%she%sigba.lt.obs%she%sigra/1.5) then
     write(chain,'(10X,A)')  'Bad fit'
  else
     write(chain,'(10X,A)')  'Fit results'
  endif
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  !
  write(chain,1000)
  call class_message(seve%r,rname,chain)
  k = 1
  do i=1,max(obs%she%nline,1)
     f = obs%she%nfit(k+1)+obs%spe%restf
     fi=-obs%she%nfit(k+1)+obs%spe%image
     d = obs%she%nfit(k+2)*clight_kms/obs%spe%restf
     ed= obs%she%nerr(k+2)*clight_kms/obs%spe%restf
     x = 1.5*obs%she%nfit(k)/obs%she%nfit(k+2)/(3.0+obs%she%nfit(k+3))
     call class_message(seve%r,rname,'')
     write (chain,1003)  i,obs%she%nfit(k),f,fi,d,obs%she%nfit(k+3),x
     call class_message(seve%r,rname,chain)
     write(chain,1004)  obs%she%nerr(k),obs%she%nerr(k+1),obs%she%nerr(k+1),ed,obs%she%nerr(k+3)
     call class_message(seve%r,rname,chain)
     if (doplot) then
        write (chain,1005) i                  &
             ,obs%she%nfit(k),obs%she%nerr(k),f,&
             obs%she%nerr(k+1),fi,obs%she%nerr(k+1),d,ed,obs%she%nfit(k+3),obs%she%nerr(k+3),x
        lc = len_trim(chain)
        call displo(set,obs,chain(1:lc),lc,i,yoff)
     endif
     !
     k=k+4
  enddo
  !
1001 format (1x,'Observation ',i0,' RMS of Residuals :  Base = ',1pg9.2,'  Line = ',1pg9.2)
1000 format (' Line',3x,'Area K.MHz',4x,'Sig Freq',5x,'Im Freq',6x,'Vexp',1x,'Horn/Center',6x,'Temp')
1003 format (' Line',i2,f11.3,2f12.3,f10.3,f12.3,f10.3)
1004 format (' Errors',1pg11.3,0p,2f12.3,f10.3,f12.3)
! 1000 format (1x,'Line',5x,'Area K.MHz',5x,'Sig Freq',12x,'Im Freq',14x,'Vexp',11x,'Horn/Center',4x,'Temp')
1005 format (i1,1pg8.3e1,'(',1pg7.2e1,0p,')',f12.3,'(',1pg7.2e1,0p,')', &
             f12.3,'(',1pg7.2e1,0p,')',f8.2,'(',f5.2,')',f7.2,'(',f4.2,')',f8.1)
end subroutine dishel
!
subroutine dispoi(set,obs,fangle,yoff,doplot,error)
  use gbl_constant
  use gbl_message
  use classfit_interfaces, except_this=>dispoi
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Retrieves and writes gauss fit results for current observation
  ! Continuum method
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set     !
  type(header),        intent(in)    :: obs     ! Observation header
  real(kind=8),        intent(in)    :: fangle  !
  real(kind=4),        intent(in)    :: yoff    ! Optionnal Y offset
  logical,             intent(in)    :: doplot  ! also on X device
  logical,             intent(inout) :: error   ! Flag
  ! Local
  character(len=*), parameter :: rname='DISPLAY'
  character(len=message_length) :: chain
  integer(kind=4) :: k,i,lc
  real(kind=4) :: ang
  !
  if (.not.obs%presec(class_sec_poi_id)) then
     error = .true.
     return
  endif
  !
  ! Print the results
  call class_message(seve%r,rname,'')
  write(chain,100)  obs%gen%num,obs%poi%sigba,obs%poi%sigra
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  if (obs%poi%sigba.gt.1.5*obs%poi%sigra) then
     write(chain,'(10X,A)')  'Optimistic fit'
  else if (obs%poi%sigba.lt.obs%poi%sigra/1.5) then
     write(chain,'(10X,A)')  'Bad fit'
  else
     write(chain,'(10X,A)')  'Fit results'
  endif
  call class_message(seve%r,rname,chain)
  call class_message(seve%r,rname,'')
  !
  if (obs%gen%kind.eq.kind_spec) then ! Spectroscopic type
     ang = 1.d0
  else                                ! Continuum drift
     ang = fangle
  endif
  !
  ! Offset + slope
  write(chain,101)
  call class_message(seve%r,rname,chain)
  write(chain,909) obs%poi%nfit(1),    obs%poi%nerr(1),  &
                   obs%poi%nfit(2)/ang,obs%poi%nerr(2)/ang
  call class_message(seve%r,rname,chain)
  !
  ! Gaussians
  k=3
  write(chain,102)
  call class_message(seve%r,rname,chain)
  do i=1,max(obs%poi%nline,1)
     if (obs%poi%nfit(k+2).ne.0.0) then
        write (chain,910) i,  &
             obs%poi%nfit(k)  *ang,obs%poi%nerr(k)  *ang,&
             obs%poi%nfit(k+1)*ang,obs%poi%nerr(k+1)*ang,&
             obs%poi%nfit(k+2)*ang,obs%poi%nerr(k+2)*ang,&
             obs%poi%nfit(k)/obs%poi%nfit(k+2)/1.064467
        call class_message(seve%r,rname,chain)
        lc = len_trim(chain)
        if (doplot) call displo(set,obs,chain,lc,i,yoff)
     else
        write (chain,920) i,&
             obs%poi%nfit(k)  *ang,obs%poi%nerr(k)  *ang,&
             obs%poi%nfit(k+1)*ang,obs%poi%nerr(k+1)*ang,&
             obs%poi%nfit(k+2)*ang,obs%poi%nerr(k+2)*ang
        call class_message(seve%r,rname,chain)
     endif
     k=k+3
  enddo
  !
100 format (1x,'Observation ',i0,' RMS of Residuals :  Base = ',1pg10.3,'  Source = ',1pg10.3)
101 format (4x,'Offset',18x,'Slope')
909 format (1x,2(1pg14.5,' (',0pg8.3,')'))
102 format (1x,' Line',6x,'Area',19x,'Position',12x,'Width'13x,'Tpeak')
910 format (i5,3x,1pg12.5,' (',0pg8.3,')',2(1x,0pf8.3,' (',0pf7.3,')'),1x,1pg12.5)
920 format (i5,3x,1pg12.5,' (',0pg8.3,')',2(1x,0pf8.3,' (',0pf7.3,')'),1x,'  ****')
end subroutine dispoi
!
subroutine displo(set,head,text,ltext,ifit,yoff)
  use gbl_message
  use classfit_dependencies_interfaces
  use classfit_interfaces, except_this=>displo
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !    DISPLAY
  ! Writes the output fit results in the PLOT window, for ONE line
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set    !
  type(header),        intent(in) :: head   !
  character(len=*),    intent(in) :: text   ! Text to draw
  integer(kind=4),     intent(in) :: ltext  ! Length of text
  integer(kind=4),     intent(in) :: ifit   ! Line number
  real(kind=4),        intent(in) :: yoff   ! Optionnal Y offset
  ! Local
  real(kind=4) :: cdef,expa,yoff_loc
  character(len=135) :: ch
  character(len=1) :: unit_up,unit_low
  logical :: error
  !
  if (ltext+35.gt.135) then
     call class_message(seve%e,'DISPLAY','String too long')
     return
  endif
  !
  call sic_get_real('CHARACTER_SIZE',cdef,error)
  expa = 1.0
  !
  !  Adapt the absolute positioning depending if the upper axis is
  ! labeled or not:
  call geunit(set,head,unit_low,unit_up)
  if (unit_low.eq.unit_up) then
    yoff_loc = -cdef*expa/2.
  else
    yoff_loc =  cdef*expa/2.
  endif
  !
  write(ch,'(A,F4.1,A2,A,A)')  &
    'DRAW TEXT 0 ',yoff_loc+yoff+ifit*cdef*expa,' "',text(1:ltext),'" 8 0 /BOX 8'
  call gr_exec(ch)
  error=gr_error()
  !
end subroutine displo

subroutine sic_format(c,n)
  use sic_interfaces, except_this=>sic_format
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*) :: c             !
  integer :: n                      !
  ! Local
  integer :: ier
  logical :: suite
  !
  suite = .false.
  call sblanc(c,n,suite,ier)
end subroutine sic_format
!
subroutine sblanc(c,n,suite,ier)
  use sic_interfaces, except_this=>sblanc
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Reduce the character string C to the standard SIC internal syntax:
  !  - Suppress all unecessary separators.
  !  - Character strings "abcd... " are not modified.
  !  - Reject blanks in single quote expressions e.g. '1 + 2 3' (same
  !    behaviour as LET A 1 + 2 3)
  !  - Ignores and destroys comments.
  !  - Take care of continuations lines
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: c      ! Character string to be formatted
  integer(kind=4),  intent(inout) :: n      ! Length of C
  logical,          intent(inout) :: suite  ! Indicates continuation
  integer(kind=4),  intent(out)   :: ier    ! Error return code
  ! Local
  character(len=*), parameter :: rname='FORME'
  logical :: lo,li,chaine,math,some,slo,more
  integer(kind=4) :: i,m,nl
  character(len=1), parameter :: quote="'"
  character(len=1) :: b,p
  save chaine,math,lo,li
  !
  data chaine/.false./, math/.false./
  !
  ier = 1
  if (n.eq.0) return
  m = len(c)
  !
  if (.not.suite) then
    lo = .true.                ! Leading blanks should be removed
    slo = lo
    chaine=.false.             ! Reset string indicator
    math  =.false.
  else
    slo = lo
  endif
  some = .false.
  nl = n
  n  = 0
  !
  i = 1
  more = i.le.nl
  do while(more)
    !
    ! Toggle character string indicator
    if (c(i:i).eq.'"') then
      if (chaine) then
        b = c(i+1:i+1)         ! End of chain
        p = ')'
      else
        b = c(n:n)             ! Last character before Start of chain
        p = '('
      endif
      ! Start/End of chain can only be preceded/followed by
      !     Double quote 
      !     Simple quote 
      !     Back quote `
      !     Dot . (in logical expressions)
      !     Comma (e.g. func("a",1))
      !     Parenthesis ( preceding, ) following (in logical expressions)
      !     Space or tab
      if (b.ne.quote   .and. b.ne.'"' .and. b.ne.'.' .and. b.ne.' ' .and.  &
          b.ne.char(9) .and. b.ne.p   .and. b.ne.'`' .and. b.ne.',') then
        n = n+1
        c(n:n) = '"'
        call sic_message(seve%e,rname,'Syntax error at or near :')
        call sic_message(seve%e,rname,c(1:n))
        ier = 0
        return
      endif
      chaine=.not.chaine
    endif
    !
    ! Skip character strings
    if (chaine) then
      n = n+1
      if (i.ne.n) c(n:n)=c(i:i)
      if (i.gt.n) c(i:i)=' '
    else
      !
      ! Suppress redondant separators
      li=.false.
      !
      ! Space separator
      if (c(i:i).eq.' ' .or. c(i:i).eq.char(9)) then
        if (math) then
          call sic_message(seve%e,rname,'Spaces not allowed in single quote expressions')
          ier = 0
          return
        else
          li=.true.
          ! First one
          if (.not.lo) then
            c(i:i) = ' '
            n = n+1
            if (i.ne.n) c(n:n)=c(i:i)
            if (i.gt.n) c(i:i)=' '
          endif
        endif
        !
        ! Skip comment area
      elseif (c(i:i).eq.'!') then
        some = .true.
        more = .false.
        !
        ! Otherwise just increment
      else
        if (c(i:i).eq.quote) then
          math = .not.math
        endif
        n=n+1
        if (i.ne.n) c(n:n)=c(i:i)
        if (i.gt.n) c(i:i)=' '
      endif
    endif
    !
    ! End of loop
    if (more) then
      lo = li
      i = i+1
      more = i.le.nl
    endif
  enddo
  !
  ! Clean up end of line
  if (n.eq.0) then             ! No significant character
    if (suite) then
      if (slo) then
        n = -1
      else
        n = 0
      endif
    elseif (some) then
      n = 1
      c(n:n) = ' '
    endif
  else
    if (.not.chaine .and. c(n:n).eq.' ') then
      n = n-1
    endif
  endif
  !
  ! Take care of continuation line
  if (n.lt.1) then
    suite = .false.
  elseif (c(n:n).ne.'-') then
    suite = .false.
  else
    suite = .true.
  endif
  if (.not.suite) then
    if (chaine) then
      call sic_message(seve%e,rname,'Unbalanced quote count')
      ier = 0
      return
    endif
  else
    c(n:n) = ' '
    n = n-1
    if (c(n:n).eq.' ') lo=.true.
  endif
  if (n.lt.m) c(n+1:) = ' '
end subroutine sblanc
!
function sic_eqchain(a,b)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical :: sic_eqchain            !
  character(len=*) :: a             !
  character(len=*) :: b             !
  ! Local
  character(len=1) :: ca,cb
  integer :: i,ic,la,lb
  !
  sic_eqchain = .false.
  la = len_trim(a)
  lb = len_trim(b)
  if (la.ne.lb) return
  !
  do i=1,la
    ca = a(i:i)
    cb = b(i:i)
    if (ca.ne.cb) then
      if (ca.ge.'a' .and. ca.le.'z') then
        ic=ichar(ca)+ichar('A')-ichar('a')
        ca=char(ic)
        if (ca.ne.cb) return
      elseif  (cb.ge.'a' .and. cb.le.'z') then
        ic=ichar(cb)+ichar('A')-ichar('a')
        cb=char(ic)
        if (ca.ne.cb) return
      else
        return
      endif
    endif
  enddo
  sic_eqchain = .true.
end function sic_eqchain

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_interpolate_spectrum_tool
  use cubetools_parameters
  use cubetools_array_types
  use cubemain_messaging
  !
  public :: interpolate_spectrum_prog_t
  private
  !
  type interpolate_spectrum_prog_t
     logical :: equal = .false.
     type(long_1d_t) :: ic     ! [---] Input axis channel number that corresponds to the output axis one
     type(dble_1d_t) :: xratio ! [---]
   contains
     procedure, public :: init     => cubemain_interpolate_spectrum_prog_init
     procedure, public :: spectrum => cubemain_interpolate_spectrum_prog_compute
  end type interpolate_spectrum_prog_t
  !
contains
  !
  subroutine cubemain_interpolate_spectrum_prog_init(interp,in,ou,error)
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! Initialize linear interpolation using the following formula
    !     you(oc) = yin(ic) + xratio*(yin(ic+1)-yin(ic))
    ! We compute xratio in double precision to avoid rounding errors as the
    ! other computations are done in single precision
    !----------------------------------------------------------------------
    class(interpolate_spectrum_prog_t), intent(inout) :: interp
    type(spectrum_t),                   intent(in)    :: in
    type(spectrum_t),                   intent(in)    :: ou
    logical,                            intent(inout) :: error
    !
    integer(kind=chan_k) :: oc ! Output channel number
    real(kind=coor_k)    :: ic ! Corresponding channel number in input axis 
    real(kind=coor_k) :: inc_ratio,ref_distance
    character(len=*), parameter :: rname='INTERPOLATE>SPECTRUM>PROG>INIT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Special case: output axis = input axis
    if ((ou%n.eq.in%n).and.(ou%ref.eq.in%ref).and.(ou%val.eq.in%val).and.(ou%inc.eq.in%inc)) then
       interp%equal = .true.
    else
       interp%equal = .false.
    endif
    ! Sanity check
    if ((in%inc.eq.0.d0).or.(ou%inc.eq.0.d0)) then
       call cubemain_message(seve%e,rname,'Zero valued input or output increment')
       error = .true.
       return
    endif
    ! Initialization
    call interp%ic%reallocate('interpolate ic',ou%n,error)
    if (error) return
    call interp%xratio%reallocate('interpolate xratio',ou%n,error)
    if (error) return
    inc_ratio = ou%inc/in%inc
    ref_distance = (in%ref-ou%ref*inc_ratio) + (ou%val-in%val)/in%inc
    ! Loop on out channels
    do oc=1,ou%n
       ic = oc*inc_ratio + ref_distance
       if (ic.lt.1) then
          ! Lower end => extrapolation
          interp%ic%val(oc) = 1
          interp%xratio%val(oc) = 0
       else if (ic.gt.in%n) then
          ! Upper end => extrapolation
          interp%ic%val(oc) = in%n
          interp%xratio%val(oc) = 0          
       else
          ! Interpolation
          interp%ic%val(oc) = floor(ic)
          interp%xratio%val(oc) = (ic-floor(ic))
       endif
    enddo ! oc
  end subroutine cubemain_interpolate_spectrum_prog_init
  !
  subroutine cubemain_interpolate_spectrum_prog_compute(interp,in,ou,error)
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! Apply the linear interpolation using the following formula
    !     you(oc) = yin(ic) + xratio*(yin(ic+1)-yin(ic))
    ! We compute xratio in double precision to avoid rounding errors as the
    ! other computations are done in single precision
    !----------------------------------------------------------------------
    class(interpolate_spectrum_prog_t), target, intent(in)    :: interp
    type(spectrum_t),                   target, intent(in)    :: in
    type(spectrum_t),                   target, intent(inout) :: ou
    logical,                                    intent(inout) :: error
    !
    integer(kind=chan_k) :: oc
    integer(kind=chan_k), pointer :: ic
    real(kind=coor_k), pointer :: xratio
    real(kind=sign_k), pointer :: yin(:),you(:)
    character(len=*), parameter :: rname='INTERPOLATE>SPECTRUM>PROG>COMPUTE'
    !
    if (interp%equal) then
       ou%y%val(:) = in%y%val(:)
    else
       yin => in%y%val(:)
       you => ou%y%val(:)
       do oc=1,ou%n
          ic => interp%ic%val(oc)
          xratio => interp%xratio%val(oc)
          if (ic+1.le.in%n) then
             ! Interpolation
             you(oc) = yin(ic) + xratio*(yin(ic+1)-yin(ic))
          else
             ! Extrapolation
             you(oc) = yin(ic)
          endif
       enddo ! oc
    endif
  end subroutine cubemain_interpolate_spectrum_prog_compute
end module cubemain_interpolate_spectrum_tool
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cfitsio_interfaces
  use cfitsio_messaging
  !---------------------------------------------------------------------
  ! Fortran interfaces to the CFITSIO library. Use module 'cfitsio_api'
  ! in your programs.
  !---------------------------------------------------------------------
  !
  interface
    subroutine ftvers(version)
    !-------------------------------------------------------------------
    !  Return the current version number of the fitsio library. The
    ! version number will be incremented with each new release of
    ! CFITSIO.
    !-------------------------------------------------------------------
    real(kind=4), intent(out) :: version
    end subroutine ftvers
    !
    subroutine ftopen(iunit,name,rwmode,block,status)
    !-------------------------------------------------------------------
    ! Open an existing FITS file with readonly or read/write access
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: name    ! Name of file to be opened
    integer(kind=4)                 :: rwmode  ! File access mode: 0 = readonly; else = read and write
    integer(kind=4),  intent(out)   :: block   ! Returned record length blocking factor
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftopen
    !
    subroutine ftinit(iunit,filename,blocksize,status)
    !-------------------------------------------------------------------
    ! Close a FITS file that was previously opened with ftopen or ftinit
    !------------------------------------------ -------------------------
    integer(kind=4),  intent(in)    :: iunit      ! Fortran I/O unit number
    character(len=*), intent(in)    :: filename   ! Name of file to be initialized
    integer(kind=4),  intent(in)    :: blocksize  ! Block size (ignored?)
    integer(kind=4),  intent(inout) :: status     ! Returned error status (0=ok)
    end subroutine ftinit
    !
    subroutine ftclos(iunit,status)
    !-------------------------------------------------------------------
    ! Close a FITS file that was previously opened with ftopen or ftinit
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit   ! Fortran I/O unit number
    integer(kind=4), intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftclos
    !
    subroutine ftrprt(stream,status)
    !-------------------------------------------------------------------
    ! Display the error status message and flush the error stack
    !-------------------------------------------------------------------
    character(len=*), intent(in) :: stream  ! 'STDOUT' or 'STDERR'
    integer(kind=4),  intent(in) :: status  ! Error status
    end subroutine ftrprt
    !
    subroutine ftcmsg
    !-------------------------------------------------------------------
    ! Clear the error message stack
    !-------------------------------------------------------------------
    end subroutine ftcmsg
    !
    subroutine ftgerr(status,errtext)
    !-------------------------------------------------------------------
    !  Return the descriptive text string corresponding to a FITSIO
    ! error status code. The 30-character length string contains a brief
    ! description of the cause of the error.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)  :: status
    character(len=*), intent(out) :: errtext
    end subroutine ftgerr
    !
    subroutine ftflus(iunit,status)
    !-------------------------------------------------------------------
    ! Flush internal buffers of data to the output FITS file previously
    ! opened with ftopen or ftinit.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit   ! Fortran I/O unit number
    integer(kind=4), intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftflus
    !
    subroutine ftphps(iunit,bitpix,naxis,naxes,status)
    !-------------------------------------------------------------------
    ! Put the primary header or IMAGE extension keywords into the CHU.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit         ! Fortran I/O unit number
    integer(kind=4), intent(in)    :: bitpix        ! Number of bits per value
    integer(kind=4), intent(in)    :: naxis         ! Number of dimensions
    integer(kind=4), intent(in)    :: naxes(naxis)  ! Dimensions
    integer(kind=4), intent(inout) :: status        ! Returned error status (0=ok)
    end subroutine ftphps
    !
    subroutine ftthdu(iunit,nhdu,status)
    !-------------------------------------------------------------------
    ! Return the total number of HDUs in the FITS file. The CHDU
    ! remains unchanged.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit   ! Fortran I/O unit number
    integer(kind=4), intent(out)   :: nhdu    !
    integer(kind=4), intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftthdu
    !
    subroutine ftgkyd(iunit,keywrd,dval,comm,status)
    !-------------------------------------------------------------------
    ! Read a double precision value and comment string from a header
    ! record
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    real(kind=8),     intent(out)   :: dval    ! Output keyword value
    character(len=*), intent(out)   :: comm    ! Output keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftgkyd
    !
    subroutine ftgkyj(iunit,keywrd,intval,comm,status)
    !-------------------------------------------------------------------
    ! Read an integer value and the comment string from a header record
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    integer(kind=4),  intent(out)   :: intval  ! Output keyword value
    character(len=*), intent(out)   :: comm    ! Output keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftgkyj
    !
    subroutine ftgkyl(iunit,keywrd,logval,comm,status)
    !-------------------------------------------------------------------
    ! Read a logical value and the comment string from a header record
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    logical,          intent(out)   :: logval  ! Output keyword value
    character(len=*), intent(out)   :: comm    ! Output keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftgkyl
    !
    subroutine ftgkys(iunit,keywrd,strval,comm,status)
    !-------------------------------------------------------------------
    ! Read a character string value and comment string from a header
    ! record
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    character(len=*), intent(out)   :: strval  ! Output keyword value
    character(len=*), intent(out)   :: comm    ! Output keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftgkys
    !
    subroutine ftmahd(iunit,extno,xtend,status)
    !-------------------------------------------------------------------
    ! Move to Absolute Header Data unit
    ! Move the i/o pointer to the specified HDU and initialize all the
    ! common block parameters which describe the extension
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit   ! Fortran I/O unit number
    integer(kind=4), intent(in)    :: extno   ! Number of the extension to point to
    integer(kind=4), intent(out)   :: xtend   ! Returned type of extension
    integer(kind=4), intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftmahd
    !
    subroutine ftmnhd(iunit,hdutype,extname,extver,status)
    !-------------------------------------------------------------------
    ! Move to the (first) HDU which has the specified extension type and
    ! EXTNAME (or HDUNAME) and EXTVER keyword values. The hdutype
    ! parameter may have a value of IMAGE_HDU (0), ASCII_TBL (1),
    ! BINARY_TBL (2), or ANY_HDU (-1) where ANY_HDU means that only the
    ! extname and extver values will be used to locate the correct
    ! extension. If the input value of extver is 0 then the EXTVER
    ! keyword is ignored and the first HDU with a matching EXTNAME (or
    ! HDUNAME) keyword will be found. If no matching HDU is found in the
    ! file then the current HDU will remain unchanged and a status =
    ! BAD_HDU_NUM (301) will be returned.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit    ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: hdutype  !
    character(len=*), intent(in)    :: extname  !
    integer(kind=4),  intent(in)    :: extver   !
    integer(kind=4),  intent(inout) :: status   ! Returned error status (0=ok)
    end subroutine ftmnhd
    !
    subroutine ftgcno(iunit,casesn,templt,colnum,status)
    !-------------------------------------------------------------------
    ! Determine the column number corresponding to an input column name.
    ! This supports the * and ? wild cards in the input template.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran i/o unit number
    logical,          intent(in)    :: casesn  ! .true. if an exact case match of the names is required
    character(len=*), intent(in)    :: templt  ! Name of column as specified in a TTYPE keyword
    integer(kind=4),  intent(out)   :: colnum  ! Number of the column (first column = 1, a value of 0 is returned if the column is not found)
    integer(kind=4),  intent(inout) :: status  ! Returned error status
    end subroutine ftgcno
    !
    subroutine ftgcfe(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of R*4 values from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4), intent(in)    :: frow       ! First row to read
    integer(kind=4), intent(in)    :: felem      ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem      ! Number of elements to read
    real(kind=4),    intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,         intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,         intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftgcfe
    !
    subroutine ftgcfd(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of R*8 values from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4), intent(in)    :: frow       ! First row to read
    integer(kind=4), intent(in)    :: felem      ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem      ! Number of elements to read
    real(kind=8),    intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,         intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,         intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftgcfd
    !
    subroutine ftgcfj(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of I*4 values from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4), intent(in)    :: frow       ! First row to read
    integer(kind=4), intent(in)    :: felem      ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem      ! Number of elements to read
    integer(kind=4), intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,         intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,         intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftgcfj
    !
    subroutine ftgcfs(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of character strings from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4),  intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4),  intent(in)    :: frow       ! First row to read
    integer(kind=4),  intent(in)    :: felem      ! First element within the row to read
    integer(kind=4),  intent(in)    :: nelem      ! Number of elements to read
    character(len=*), intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,          intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,          intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4),  intent(inout) :: status     ! Returned error status
    end subroutine ftgcfs
    !
    subroutine ftgcfl(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of logical values from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4), intent(in)    :: frow       ! First row to read
    integer(kind=4), intent(in)    :: felem      ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem      ! Number of elements to read
    logical,         intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,         intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,         intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftgcfl
    !
    subroutine ftgcvd(iunit,colnum,frow,felem,nelem,nulval,array,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of real*8 values from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4), intent(in)    :: frow      ! First row to read
    integer(kind=4), intent(in)    :: felem     ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem     ! Number of elements to read
    real(kind=8),    intent(in)    :: nulval    ! Value that undefined pixels will be set to
    real(kind=8),    intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,         intent(inout) :: anynul    ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status    ! Returned error status
    end subroutine ftgcvd
    !
    subroutine ftgcve(iunit,colnum,frow,felem,nelem,nulval,array,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of real*4 values from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4), intent(in)    :: frow      ! First row to read
    integer(kind=4), intent(in)    :: felem     ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem     ! Number of elements to read
    real(kind=4),    intent(in)    :: nulval    ! Value that undefined pixels will be set to
    real(kind=4),    intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,         intent(inout) :: anynul    ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status    ! Returned error status
    end subroutine ftgcve
    !
    subroutine ftgcvj(iunit,colnum,frow,felem,nelem,nulval,array,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of integer*4 values from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4), intent(in)    :: frow      ! First row to read
    integer(kind=4), intent(in)    :: felem     ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem     ! Number of elements to read
    integer(kind=4), intent(in)    :: nulval    ! Value that undefined pixels will be set to
    integer(kind=4), intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,         intent(inout) :: anynul    ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status    ! Returned error status
    end subroutine ftgcvj
    !
    subroutine ftgcvs(iunit,colnum,frow,felem,nelem,nulval,array,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of character strings from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4),  intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4),  intent(in)    :: frow      ! First row to read
    integer(kind=4),  intent(in)    :: felem     ! First element within the row to read
    integer(kind=4),  intent(in)    :: nelem     ! Number of elements to read
    character(len=*), intent(in)    :: nulval    ! Value that undefined pixels will be set to
    character(len=*), intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,          intent(inout) :: anynul    ! Set to .true. if any of the returned values are undefined
    integer(kind=4),  intent(inout) :: status    ! Returned error status
    end subroutine ftgcvs
    !
    subroutine ftgcl(iunit,colnum,frow,felem,nelem,array,status)
    !-------------------------------------------------------------------
    ! Read an array of logical values from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4),  intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4),  intent(in)    :: frow      ! First row to read
    integer(kind=4),  intent(in)    :: felem     ! First element within the row to read
    integer(kind=4),  intent(in)    :: nelem     ! Number of elements to read
    logical,          intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    integer(kind=4),  intent(inout) :: status    ! Returned error status
    end subroutine ftgcl
    !
    subroutine ftghps(iunit,keysexist,key_no,status)
    !-------------------------------------------------------------------
    ! Return the number of keywords in the header and the current
    ! position in the header. This returns the number of the keyword
    ! record that will be read next (or one greater than the position of
    ! the last keyword that was read or written). A value of 1 is
    ! returned if the pointer is positioned at the beginning of the
    ! header.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran I/O unit number
    integer(kind=4), intent(out)   :: keysexist  ! Number of available keys
    integer(kind=4), intent(out)   :: key_no     ! Next key to read
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftghps
    !
    subroutine ftgkyn(iunit,key_no,keyword,value,comment,status)
    !-------------------------------------------------------------------
    ! Get the name, value (as a string), and comment of the nth keyword
    ! in CHU. This routine also checks that the returned keyword name
    ! (KEYWORD) contains only legal ASCII characters. Call FTGREC and
    ! FTPSVC to bypass this error check.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit    ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: key_no   ! The key number
    character(len=*), intent(out)   :: keyword  !
    character(len=*), intent(out)   :: value    !
    character(len=*), intent(out)   :: comment  !
    integer(kind=4),  intent(inout) :: status   ! Returned error status
    end subroutine ftgkyn
    !
    subroutine ftukys(iunit,keywrd,strval,comm,status)
    !-------------------------------------------------------------------
    ! Update the value and comment fields of a keyword in the CHU.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    character(len=*), intent(in)    :: strval  ! Keyword value
    character(len=*), intent(in)    :: comm    ! Keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftukys
    !
    subroutine ftukyj(iunit,keywrd,intval,comm,status)
    !-------------------------------------------------------------------
    ! Update the value and comment fields of a keyword in the CHU.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    integer(kind=4),  intent(in)    :: intval  ! Keyword value
    character(len=*), intent(in)    :: comm    ! Keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftukyj
    !
    subroutine ftgsfe(iunit,group,naxis,naxes,fpixels,lpixels,incs, &
                      array,flagvals,anyf,status)
    !-------------------------------------------------------------------
    ! Get an arbitrary data subsection from the data array. Any
    ! Undefined pixels in the array will have the corresponding
    ! 'flagvals' element set equal to .TRUE.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit        ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: group        !
    integer(kind=4),  intent(in)    :: naxis        ! Number of axes
    integer(kind=4),  intent(in)    :: naxes(*)     ! Axes length
    integer(kind=4),  intent(in)    :: fpixels(*)   ! BLC
    integer(kind=4),  intent(in)    :: lpixels(*)   ! TRC
    integer(kind=4),  intent(in)    :: incs(*)      ! Step in each dimension
    real(kind=4),     intent(out)   :: array(*)     ! Data array to read
    logical,          intent(out)   :: flagvals(*)  ! NULL flag for each value
    logical,          intent(out)   :: anyf         ! At least one NULL value?
    integer(kind=4),  intent(inout) :: status     ! Returned error status (0=ok)
    end subroutine ftgsfe
    !
    subroutine ftppre(iunit,group,fpixel,nelements,values,status)
    !-------------------------------------------------------------------
    ! Put elements into the data array
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit      ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: group      !
    integer(kind=4),  intent(in)    :: fpixel     ! Position within the 1-D array of the first pixel to write
    integer(kind=4),  intent(in)    :: nelements  ! Number of elements to write
    real(kind=4),     intent(in)    :: values(*)  ! Data array to write
    integer(kind=4),  intent(inout) :: status     ! Returned error status (0=ok)
    end subroutine ftppre
    !
    subroutine ftpsse(iunit,group,naxis,naxes,fpixels,lpixels,array,status)
    !-------------------------------------------------------------------
    ! Put an arbitrary data subsection into the data array
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit      ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: group      !
    integer(kind=4),  intent(in)    :: naxis      ! Number of axes
    integer(kind=4),  intent(in)    :: naxes(*)   ! Axes length
    integer(kind=4),  intent(in)    :: fpixels(*) ! BLC
    integer(kind=4),  intent(in)    :: lpixels(*) ! TRC
    real(kind=4),     intent(in)    :: array(*)   ! Data array to write
    integer(kind=4),  intent(inout) :: status     ! Returned error status (0=ok)
    end subroutine ftpsse
    !
    function fits_read_col_flt(fptr,colnum,firstrow,firstelem,nelem,  &
                               nulval,array,anynul,status)  &
             bind(c,name='ffgcve')
    use, intrinsic :: iso_c_binding, only : c_float,c_int,c_long_long,c_ptr
    !-------------------------------------------------------------------
    ! Get elements from an ASCII or binary table column (in the CDU).
    ! These routines return the values of the table column array
    ! elements. Undefined array elements will be returned with a value =
    ! nullval, unless nullval = 0 in which case no checking for
    ! undefined values will be performed. The anynul parameter is set to
    ! true if any of the returned elements are undefined.
    ! ---
    ! C interface to the CFITSIO routine FFGCVE (modern name
    ! fits_read_col_flt). This routine accepts c_long_long (I*8 values)
    ! while FTGCVE or FTGCVELL (Fortran API) accept only I*4 for nelem.
    !-------------------------------------------------------------------
    integer(c_int) :: fits_read_col_flt  ! Function value on return
    type(c_ptr),          value         :: fptr
    integer(c_int),       value         :: colnum
    integer(c_long_long), value         :: firstrow
    integer(c_long_long), value         :: firstelem
    integer(c_long_long), value         :: nelem
    real(c_float),        value         :: nulval
    real(c_float),        intent(out)   :: array(*)
    integer(c_int),       intent(inout) :: anynul
    integer(c_int),       intent(inout) :: status
    end function fits_read_col_flt
    !
    function cunit2fits(unit) bind(c,name='CUnit2FITS') result(fptr)
    use, intrinsic :: iso_c_binding, only : c_int,c_ptr
    !-------------------------------------------------------------------
    ! Convert a Fortran CFITSIO unit number into the corresponding
    ! C 'fitsfile*' pointer for mixed-language calls.
    !-------------------------------------------------------------------
    integer(c_int), value :: unit
    type(c_ptr) :: fptr
    end function cunit2fits
    !
  end interface
  !
contains
  !
  subroutine cfitsio_file_cptr(unit,cptr,error)
    use, intrinsic :: iso_c_binding, only : c_associated,c_int,c_null_ptr,c_ptr
    !---------------------------------------------------------------------
    ! Return the C 'fitsfile*' pointer associated with a Fortran CFITSIO
    ! unit number and flag whether the conversion failed.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in)    :: unit
    type(c_ptr),     intent(out)   :: cptr
    logical,         intent(inout) :: error
    !
    cptr = cunit2fits(int(unit,kind=c_int))
    if (.not.c_associated(cptr)) then
      write(*,'(a)') 'E-CFITSIO,  Error while converting Fortran FITS unit to C fitsfile pointer'
      error = .true.
      cptr = c_null_ptr
      return
    endif
  end subroutine cfitsio_file_cptr
  !
end module cfitsio_interfaces

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module omp_buffers
  !------------------------------------------------------------------------
  ! OPEN-MP control parameters
  !------------------------------------------------------------------------
  !
  public :: omp
  private
  !
  type omp_buffer_user_t
     logical, public  :: debug = .false.
     integer, public  :: grid = 0
     logical, public  :: uvmap_lock = .false.
     integer, public  :: single_beam = 0
   contains
     procedure, public :: init   => omp_buffer_user_init
     procedure, public :: sicdef => omp_buffer_user_sicdef
  end type omp_buffer_user_t
  type(omp_buffer_user_t) :: omp
  !
contains
  !
  subroutine omp_buffer_user_init(user,error)
    !-----------------------------------------------------------------------
    ! Initialize by setting the intent to out
    !-----------------------------------------------------------------------
    class(omp_buffer_user_t), intent(out)   :: user
    logical,                  intent(inout) :: error
  end subroutine omp_buffer_user_init
  !
  subroutine omp_buffer_user_sicdef(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! OMP variables
    !----------------------------------------------------------------------
    class(omp_buffer_user_t), intent(out)   :: user
    logical,                  intent(inout) :: error
    !
    call sic_defstructure('OMP_MAP',.true.,error)
    if (error) return
    call sic_def_logi('OMP_MAP%DEBUG',omp%debug,.false.,error)
    if (error) return
    call sic_def_inte('OMP_MAP%GRID',omp%grid,0,0,.false.,error)
    if (error) return
    call sic_def_logi('OMP_MAP%UV_MAP_LOCK',omp%uvmap_lock,.false.,error)
    if (error) return
    call sic_def_inte('OMP_MAP%SINGLE_BEAM_CODE',omp%single_beam,0,0,.false.,error)
    if (error) return
  end subroutine omp_buffer_user_sicdef
end module omp_buffers
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_AlmaRadiometer(error)
  !---------------------------------------------------------------------
  ! Write the CorrelatorMode SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_AlmaRadiometer
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (AlmaRadiometerKey) :: arKey
  type (AlmaRadiometerRow) :: arRow
  character sdmTable*20
  parameter (sdmTable='AlmaRadiometer')
  integer i
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !arOpt%numAntenna = r_nant
  !call  allocAlmaRadiometerOpt(arRow, arOpt, error)
  !if (error) return
  !do i=1, r_nant
  !  arOpt%spectralWindowId(i) = radiometerSpw_Id(i)
  !enddo
  call addAlmaRadiometerRow(arKey, arRow, error)
  if (error) return
  !
  ! was not changed...
  almaRadiometer_Id = arKey%almaRadiometerId
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_AlmaRadiometer
!---------------------------------------------------------------------
! get routine TBW
!---------------------------------------------------------------------

recursive subroutine build_tree(formula,n,operand,tree,last_node,  &
  max_level,min_level,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>build_tree
  use sic_expressions
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Formula interpretation.
  ! Transforms formula into its tree equivalent. Each node of the tree
  ! contains:
  !       - level of the node
  !       - code of operator
  !       - pointer to previous node
  !       - pointer to next node
  !       - number of associated operands
  !       - for each operand, a pointer to operand
  !  Recursive for e.g. evaluating ANY(A.EQ.1). The function ANY invokes
  ! its own build_tree to compute the array 'A.EQ.1'.
  !---------------------------------------------------------------------
  character(len=*),   intent(in)  :: formula                 ! The line to be analysed
  integer(kind=4),    intent(in)  :: n                       ! Length of line
  type(sic_descriptor_t)          :: operand(0:maxoper)      ! List of operands (output)
  integer(kind=4)                 :: tree(formula_length*2)  ! Tree structure (output)
  integer(kind=4),    intent(out) :: last_node               ! Pointer to last node in tree
  integer(kind=4),    intent(out) :: max_level               ! Maximum parenthesis level
  integer(kind=4),    intent(out) :: min_level               !
  logical,            intent(out) :: error                   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=4) :: level(formula_length),coma(formula_length)
  integer(kind=4) :: missing_operand(maxpar)  ! Pointers to previous missing operands
  integer(kind=4) :: sleep_missing(maxpar)    ! Pointers to sleeping missing operands
  integer(kind=4) :: nmiss                    ! Number of active missing operands
  integer(kind=4) :: nsleep                   ! Number of sleeping missing operands
  integer(kind=4) :: iprev_node               ! Pointer to previous node
  integer(kind=4) :: lev                      ! Current level
  integer(kind=4) :: left_space
  integer(kind=4) :: preced                   ! Precedence level of operator
  integer(kind=4) :: ip                       ! Pointer to current character in line
  character(len=80) :: chain
  integer(kind=4) :: i,i_deb,i_fin,code,itree,i_operand
  integer(kind=4) :: n_operand(2),i_oper,next,prev_code,funcode,n_operand_actual
  integer(kind=4) :: ip0,i_beg
  ! Data
  data level/formula_length*0/, coma/formula_length*0/
  !
  if (n.gt.formula_length) then
    call sic_message(seve%e,rname,'Formula is too long')
    error = .true.
    return
  endif
  error = .false.
  funcode = code_nop
  !
  ! Get parenthesis levels.
  ! This routine is both inefficient and inelegant. Doing the corresponding
  ! work in FIND_OPERAND would save both CPU time and memory space.
  ! This is easy for level (just count parentheses, and add their number to
  ! current number), but not so simple for coma. I see no efficient way of doing
  ! it without one more pointer level. The best is probably to reserve the space
  ! for two operands in all cases where their number is unknown. The cost is
  ! at most one word per node, which is more than offset by suppressing LEVEL
  ! and COMA. In practice, this number is known for all operators, except
  ! MAX and MIN. Would fixing it to 2 be considered a limitation?
  !
  ! NO: Now fixed to 2 for some cases (optimized formulas)
  !
  call get_level(formula,n,level,coma,error)
  if (error) return
  !
  ! Initialise various pointers
  ip=1
  itree = 1
  last_node = 1
  i_operand = 1
  nmiss = 0
  nsleep = 0
  max_level = 0
  min_level = 32767
  lev = 0
  iprev_node = 0
  prev_code = code_nop
  code = code_nop              ! new
  n_operand(:) = 0
  n_operand_actual = 0
  do i = 1,maxoper
    operand(i)%status = empty_operand
  enddo
  missing_operand(:) = 0
  sleep_missing(:) = 0
  !
  ! Start the analysis
  do while (ip.le.n)
    ! Check for tree buffer space. Two operand nodes have length 7, so checking
    ! with 7 will do for all cases,
    left_space = maxtree-itree+1
    if (left_space.lt.7) then
      call sic_message(seve%e,rname,'Arithmetic expression is too complex')
      goto 99
      ! Check for operand buffer space
    elseif (i_operand.gt.maxoper) then
      call sic_message(seve%e,rname,'Arithmetic expression is too complex')
      goto 99
    endif
    ! Look for next operator in line
    call find_operator(formula(ip:n),n-ip+1,i_deb,i_fin,i_oper,code,preced,  &
    n_operand,next,error)
    if (error) then
      call sic_message(seve%e,rname,'Error in FIND_OPERATOR')
      goto 99
    endif
    !
    ! Avoid false positive operator names in variable name, file name, or
    ! expression
    if (funcode.eq.code_exist .or.  &
        funcode.eq.code_file  .or.  &
        funcode.eq.code_all   .or.  &  ! e.g. ALL(A.eq.1)
        funcode.eq.code_any   .or.  &
        funcode.eq.code_symbol) then
      ip0   = ip
      i_beg = i_deb
      do while (code.gt.code_not)
        ip = ip+next-1
        call find_operator(formula(ip:n),n-ip+1,i_deb,i_fin,i_oper,code,  &
        preced,n_operand,next,error)
      enddo
      ! Recompute offset from inital IP
      next = next + ip - ip0
      i_fin = i_fin + ip - ip0
      i_deb = i_beg
      ip = ip0
    endif
    !
    ! If we found a function operator, keep track of it. Some of them
    ! need a special processing when we will parse its operand
    if (code.eq.code_exist    .or.  &
        code.eq.code_typeof   .or.  &
        code.eq.code_rank     .or.  &
        code.eq.code_file     .or.  &
        code.eq.code_function .or.  &
        code.eq.code_len      .or.  &
        code.eq.code_len_trim .or.  &
        code.eq.code_all      .or.  &
        code.eq.code_any      .or.  &
        code.eq.code_isnan    .or.  &
        code.eq.code_isnum    .or.  &
        code.eq.code_symbol) then
      funcode = code
    endif
    !
    if (code.eq.code_coma) then
      !
      ! A coma has been encountered.
      if (prev_code.eq.code_nop) then
        call sic_message(seve%e,rname,'Invalid arithmetic formula '//formula)
        goto 99
      endif
      ! Read operand at address I_OPERAND.
      call read_operand(formula(ip+i_deb-1:ip+i_fin-1),i_fin-i_deb+1,  &
        operand(i_operand),error)
      if (error) then
        call sic_message(seve%e,rname,'Error in READ_OPERAND')
        goto 99
      endif
      ! Fill all pending missing operand requests with I_OPERAND
      do i= 1, nmiss
        tree(missing_operand(i)) = i_operand
      enddo
      i_operand = i_operand + 1
      ! Unstack top sleeping request.
      if (nsleep.gt.0) then
        missing_operand(1) = sleep_missing(nsleep)
        nsleep = nsleep - 1
        nmiss  = 1
      else
        nmiss = 0
      endif
      !
      ! One real operator found
    elseif (code.ne.code_nop) then
      !                  sic_quiet = quiet
      lev = 10*level(ip+i_oper-1) + preced
      if ( (code.eq.code_uminus.or.code.eq.code_uplus) .and.  &
            prev_code.eq.code_power) then
        lev = lev+1
      endif
      prev_code = code
      max_level = max(max_level,lev)
      min_level = min(min_level,lev)
      !
      tree(itree)   = lev
      tree(itree+1) = code
      tree(itree+2) = iprev_node
      ! This is a function call
      if (code.ge.min_code_func) then
        ! Check number of arguments
        n_operand_actual = 1+coma(ip+i_oper-1)
        if (n_operand_actual.lt.n_operand(1) .or. &
            n_operand_actual.gt.n_operand(2)) then
          if (code.ne.code_pyfunc) then
            chain = 'Invalid number of arguments in call to '//  &
                    formula(ip:ip+i_oper-1)
            call sic_message(seve%e,rname,chain)
            goto 99
          endif
        endif
        ! One missing operand request for each argument. Put the first one in
        ! active scope
        nmiss = nmiss + 1
        if (nmiss.gt.maxpar) then
          call sic_message(seve%e,rname,'Arithmetic expression is too complex')
          goto 99
        endif
        missing_operand(nmiss) = itree + 5
        ! Stack all others in sleeping scope.
        do i=n_operand_actual,2,-1
          nsleep = nsleep + 1
          if (nsleep.gt.maxpar) then
            call sic_message(seve%e,rname,'Arithmetic expression is too '//  &
            'complex')
            goto 99
          endif
          sleep_missing(nsleep) = itree + 4 + i
        enddo
        !
      elseif (code.eq.code_uplus .or. code.eq.code_uminus .or.  &
              code.eq.code_not) then  ! Unary + and -, .NOT.
        ! Queue a missing operand request
        nmiss = nmiss + 1
        if (nmiss.gt.maxpar) then
          call sic_message(seve%e,rname,'Arithmetic expression is too complex')
          goto 99
        endif
        missing_operand(nmiss) = itree + 5
        n_operand_actual = n_operand(1)  ! Probably does not make sense to "get" the
                                         ! actual number of arguments to these operators
        !
      else
        ! Arithmetic and logical binary operators
        call read_operand_byfunc(funcode,formula(ip+i_deb-1:ip+i_fin-1),  &
            i_fin-i_deb+1,operand(i_operand),error)
        if (error)  goto 99
        ! Fill all pending missing operand requests with I_OPERAND
        tree(itree+5) = i_operand
        do i= 1, nmiss
          tree(missing_operand(i)) = i_operand
        enddo
        i_operand = i_operand + 1
        ! Queue one missing operand request for second operand
        nmiss = 1
        missing_operand(nmiss) = itree + 6
        n_operand_actual = n_operand(1)  ! Can we know (and check?) the number of
                                         ! arguments in this case?
      endif
      ! Fill up the node
      iprev_node = itree
      tree(itree+3) = itree + 5 + n_operand_actual
      tree(itree+4) = n_operand_actual
      last_node = itree
      itree = itree + 5 + n_operand_actual
      !
    else  ! code.eq.code_nop
      ! End of line reached: process last operand
      call read_operand_byfunc(funcode,formula(ip+i_deb-1:ip+i_fin-1),  &
        i_fin-i_deb+1,operand(i_operand),error)
      if (error)  goto 99
      ! Fill all pending missing operand requests.
      do i= 1, nmiss
        tree(missing_operand(i)) = i_operand
      enddo
      if (nsleep.gt.0) then
        chain = 'Missing operand in formula '//formula(1:n)
        call sic_message(seve%w,rname,chain)
      else
        nmiss = 0
      endif
      ! No operator at all: create a dummy node with NOP as operator
      if (itree.eq.1) then
        tree(itree)   = 0
        tree(itree+1) = code_nop
        tree(itree+2) = iprev_node
        tree(itree+3) = 0
        tree(itree+4) = 1
        tree(itree+5) = i_operand
        last_node = itree
      else
        tree(iprev_node+3) = 0
      endif
    endif
    ! Update line pointer
    ip = ip + next - 1
  enddo
  if (nmiss.gt.0) then
    chain = 'Missing operand in formula '//formula(1:n)
    call sic_message(seve%w,rname,chain)
    error = .true.
  endif
  return
  !
  ! Error return
99 error = .true.
  !
  ! Free everything (in principle, no free status is present)
  do i=1,maxoper
    if (operand(i)%status.eq.free_operand) then
      call sic_message(seve%w,rname,'Free operand in BUILD_TREE')
      call free_vm (operand(i)%size,operand(i)%addr)
    elseif (operand(i)%status.eq.scratch_operand) then
      call free_vm (operand(i)%size,operand(i)%addr)
    endif
    operand(i)%status = empty_operand
  enddo
end subroutine build_tree
!
subroutine read_operand(chain,nch,descr,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interactions
  use sic_interfaces, except_this=>read_operand
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !  Decode operands
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  type(sic_descriptor_t)              :: descr  ! Operand descriptor  Output
  logical,                intent(out) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt
  integer(kind=4) :: ip,ier
  logical :: found
  real(kind=4) :: r4
  real(kind=8) :: r8
  integer(kind=8) :: i8
  real(kind=8) :: value  ! Used as an untyped buffer
  !
  error = .false.
  if (nch.eq.0) then
    error = .true.
    return
  endif
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or. chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  if (ip.eq.0) then           ! Empty string after parenthesis stripp
    descr%type = 0            ! Undefined type
    descr%readonly = .false.  !
    descr%addr = 0            ! Null address
    descr%ndim = 0            ! Zero dimension
    descr%size = 0            ! Total size is zero
    descr%status = scratch_operand
    return
  endif
  ! Check for variables
  if (chain(1:1).lt.'A') then
    if (chain(1:1).ne.'"') then
      ! First try a logical
      if (chain(1:ip).eq.'.TRUE.') then
        call l4tol4(.true.,value,1)
        descr%type = fmt_l
        descr%readonly = .false.
        descr%size = 1
      elseif (chain(1:ip).eq.'.FALSE.') then
        call l4tol4(.false.,value,1)
        descr%type = fmt_l
        descr%readonly = .false.
        descr%size = 1
      else
        ! Second try a plain real number
        read (chain(1:ip),'(F30.0)',iostat=ier)  r8
        if (ier.ne.0) then
          error = .true.
          return
        endif
        if (sicprecis.eq.fmt_r8) then
          call r8tor8(r8,value,1)
          descr%type = fmt_r8
          descr%readonly = .false.
          descr%size = 2
        elseif (sicprecis.eq.fmt_r4) then
          r4 = sngl(r8)
          call r4tor4(r4,value,1)
          descr%type = fmt_r4
          descr%readonly = .false.
          descr%size = 1
        elseif (sicprecis.eq.fmt_i8) then
          i8 = nint(r8,kind=8)
          call i8toi8(i8,value,1)
          descr%type = fmt_i8
          descr%readonly = .false.
          descr%size = 2
        else  ! Use double precision for automatic sc
          call r8tor8(r8,value,1)
          descr%type = fmt_r8
          descr%readonly = .false.
          descr%size = 2
        endif
      endif
      ier = sic_getvm (descr%size,descr%addr)
      if (ier.ne.1) then
        call sic_message(seve%e,rname,'Memory allocation failure')
        error = .true.
        return
      endif
      ipnt = gag_pointer(descr%addr,memory)
      call w4tow4_sl(value,memory(ipnt),descr%size)
      descr%ndim = 0
      descr%status = scratch_operand
    else
      ! Starts with a double quote so it must be a character string.
      ! Build a descriptor
      if (chain(ip:ip).ne.'"' .or. ip.le.2) then
        error=.true.
        call sic_message(seve%e,rname,'Invalid character string '//chain(1:ip))
        return
      endif
      descr%type = ip-2
      descr%readonly = .false.
      descr%addr = locstr(chain)+1
      descr%ndim = 0
      descr%size = 1
      descr%status = readonly_operand
    endif
  else
    ! It must be a variable.
    found = .true.
    call sic_materialize (chain(1:ip),descr,found) ! Checked
    if (.not.found) then
      call sic_message(seve%e,rname,'Unknown variable '//chain(1:ip))
      error = .true.
    else
      ! Get a SICPRECIS incarnation of numerical variables. Moved
      ! to an evaluation routine for AUTOMATIC precision to work correctly.
      descr%readonly = .false.
      ! returned operand may be scratch because of a transposition!
      if (descr%status.ne.scratch_operand) descr%status = readonly_operand
      ! if (descr%type.ne.fmt_l.and.descr%type.le.0) then
      !   call sic_incarnate(sicprecis,descr,descr,error)
      ! endif
    endif
  endif
end subroutine read_operand
!
subroutine find_operator(line,nline,i_deb,i_fin,i_oper,code,preced,nfunarg,  &
  next,error)
  use sic_interfaces, except_this=>find_operator
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Search for first operator in line
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line        ! The line to be analysed
  integer(kind=4),  intent(in)  :: nline       ! Length of line
  integer(kind=4),  intent(out) :: i_deb       ! Start of operand if any
  integer(kind=4),  intent(out) :: i_fin       ! End of operand if any
  integer(kind=4),  intent(out) :: i_oper      ! End of operator
  integer(kind=4),  intent(out) :: code        ! Code of operator
  integer(kind=4),  intent(out) :: preced      ! Precedence of operator
  integer(kind=4),  intent(out) :: nfunarg(2)  ! Min-max number of arguments
  integer(kind=4),  intent(out) :: next        ! Start of non analysed part
  logical,          intent(out) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=4) :: i,n,is,ip
  logical :: finished,number,in_chain,inchain
  !
  ! Various initialisations
  code = code_nop
  i_deb = 0
  i_fin = 0
  n = nline
  finished = .false.
  error = .false.
  in_chain = .false.
  inchain = .false.  ! For function start_operator
  !
  ! Remove opening parenthesis. Quite unefficient...
  do i=1,nline
    if (line(i:i).ne.'('.and.line(i:i).ne.' ') then
      is = i
      goto 1
    endif
  enddo
  ! Generate an error if line only contains opening parenthesis. Should not
  ! occur with present logic, but let us play safe.
  call sic_message(seve%e,rname,'Invalid syntax')
  error = .true.
  return
  !
1 continue
  !
  ! Check for unary + and -
  if ( (line(is:is).eq.'+'.or.line(is:is).eq.'-')) then
    ! + or - in front of a letter: real unary operator
    ! + or - in front of a number: part of the number or operator? Unclear
    !                              because true for -2+2 but false for -2**2
    ! => always assume unary operator
    if (line(is:is).eq.'+') then
      code = code_uplus
    elseif (line(is:is).eq.'-') then
      code = code_uminus
    else
      call sic_message(seve%e,rname,  &
        'Internal logic error, sign is '//line(is:is))
      goto 99
    endif
    preced = 5
    nfunarg = 1
    next = is+1
    i_oper = is
    return
  else  ! Line does not start on a + or -
    if ( (line(is:is).gt.'9'.or.line(is:is).lt.'0') .and.  &
          line(is:is).ne.'.') then
      number = .false.
    else
      number = .true.
    endif
    ip = is
  endif
  !
  ! Now, starts looking for real operators (others than unary + and -)
  do while(.not.finished)
    i_oper = start_operator(line,is,nline,inchain,error)
    if (error) goto 99
    if (i_oper.eq.0.or.i_oper.eq.nline) then
      ! No operator in LINE. There is an operand
      i_deb = ip
      i_fin = nline
      code  = code_nop
      nfunarg  = 0
      next  = nline + 1
      finished = .true.
      preced = 0
    else
      ! One possible operator was found
      if (line(i_oper:i_oper).eq.'"') then
        in_chain = .not.in_chain
        is = i_oper + 1
      elseif (in_chain) then
        is = i_oper + 1
      else
        !
        ! '*', '**' or '^', and '/' or '|' cannot be part of a number.
        if ( line(i_oper:i_oper).eq.'*' ) then
          finished = .true.
          i_deb = ip
          i_fin = i_oper-1
          if (line(i_oper+1:i_oper+1).eq.'*') then
            next = i_oper+2
            i_oper = i_oper + 1
            code = code_power
            preced = 6
          else
            next = i_oper+1
            code = code_mul
            preced = 5
          endif
          nfunarg = 2
        elseif (line(i_oper:i_oper).eq.'^') then
          finished = .true.
          i_deb = ip
          i_fin = i_oper-1
          next  = i_oper+1
          code = code_power
          preced = 6
          nfunarg = 2
        elseif (line(i_oper:i_oper).eq.'/' .or.  &
                line(i_oper:i_oper).eq.'|') then
          finished = .true.
          i_deb = ip
          i_fin = i_oper-1
          next  = i_oper+1
          code = code_div
          preced = 5
          nfunarg = 2
          !
          ! '+' and '-' could be part of a number
        elseif (line(i_oper:i_oper).eq.'+' .or.  &
                line(i_oper:i_oper).eq.'-') then
          ! In a number after 'E' and 'D': this is 1.D-8 or so. Ignore it
          if (number .and. (line(i_oper-1:i_oper-1).eq.'E' .or.  &
                            line(i_oper-1:i_oper-1).eq.'D')) then
            is = i_oper + 1
            ! Otherwise, this is a binary + or -
          else
            finished = .true.
            i_deb = ip
            i_fin = i_oper-1
            next  = i_oper+1
            if (line(i_oper:i_oper).eq.'+') code = code_bplus
            if (line(i_oper:i_oper).eq.'-') code = code_bminus
            preced = 4
            nfunarg = 2
          endif
          !
          ! This is a function call, NOT an array element !...
        elseif (line(i_oper:i_oper).eq.'(') then
          call get_funcode(line(ip:i_oper-1),code,nfunarg,error)
          if (error) goto 99
          finished = .true.
          i_deb = 0
          i_fin = 0
          preced = 8
          next = i_oper+1
        elseif (line(i_oper:i_oper).eq.',') then
          code = code_coma
          nfunarg = 0
          finished = .true.
          i_deb = ip
          i_fin = i_oper-1
          preced = 0
          next = i_oper+1
        elseif (line(i_oper:i_oper).eq.'.') then
          ! Found a dot: this could be the start of a logical or relational
          ! operator, but also part of a number
          !   or even worse, in some cases, part of a name to be tested
          !   as a variable name...
          i = start_operator(line,i_oper+1,n,inchain,error)
          if (error) goto 99
          if (i.le.(i_oper+2)) then
            ! No operator found (i==0) after the dot, or found a candidate
            ! at i_oper+1 or i_oper+2 => current dot is part of a number
            is = i_oper + 1
          elseif (line(i:i).ne.'.') then
            ! Next operator is not a dot: this is not a logical operator
            is = i_oper + 1
            ! #1 12-May-1988 S.G.
          elseif (line(i_oper+1:i_oper+1).ge.'0' .and.  &
                  line(i_oper+1:i_oper+1).le.'9' ) then
            ! Mantissa
            is = i_oper + 1
          elseif (line(i_oper+1:i_oper+1).eq.'D') then
            ! Part of exponent D something
            is = i_oper + 1
          elseif (line(i_oper+1:i_oper+1).eq.'E' .and.  &
                  line(i_oper+2:i_oper+2).ne.'Q') then
            ! Part of exponent E something
            is = i_oper + 1
            ! #1 End
          elseif (line(i_oper+1:i_oper+1).ne.'T' .and.  &
                  line(i_oper+1:i_oper+1).ne.'F' ) then
            ! The above test is presumably to check for .TRUE. or .FALSE.
            ! but why not also avoid other cases ?
            call get_logcode(line(i_oper+1:i-1),code,nfunarg,error)
            if (error) goto 99
            finished = .true.
            i_deb = ip
            i_fin = i_oper-1
            if (code.ge.code_ne) then
              preced = 3
            elseif (code.eq.code_not) then
              preced = 2
            else
              preced = 1
            endif
            next = i+1
          else
            is = i_oper + 1
          endif
          ! Do nothing for closing parenthesis and spaces
        else
          is = i_oper + 1
        endif
      endif
    endif
  enddo
  return
  !
99 error = .true.
  return
  !
contains
  !
  function start_operator(line,is,n,inchain,error)
    !---------------------------------------------------------------------
    !  Returns index of first character in line which could be part of an
    ! operator field. Return 0 if no candidate is found.
    !---------------------------------------------------------------------
    integer(kind=4) :: start_operator  ! Function value on return
    character(len=*), intent(in)    :: line     ! Character string to be formatted
    integer(kind=4),  intent(in)    :: is       ! Index of first character in line
    integer(kind=4),  intent(in)    :: n        ! Length of C
    logical,          intent(inout) :: inchain  !
    logical,          intent(out)   :: error    !
    ! Local
    integer(kind=4) :: i
    logical :: array,separator
    !
    error = .false.
    array = .false.
    separator = .false.
    start_operator = 0
    do i = is,n
      ! ( ) * + , - . / are contiguous in ASCII
      if (line(i:i).eq.'"') then
        ! Like e.g. in:  SAY 'GILDAS_NODE.eq."A/B"'
        ! The / is not an operator because it is in a string.
        start_operator = i
        inchain = .not.inchain
        return
      elseif (.not.inchain) then
        if (array) then
          if (line(i:i).eq.']') then
            array = .false.
            separator = .true.
          endif
        elseif (line(i:i).eq.'[') then
          array = .true.
        elseif (line(i:i).eq.']') then
          call sic_message(seve%e,rname,'Unmatch Closing bracket')
          error = .true.
          return
        elseif (line(i:i).ge.'('.and.line(i:i).le.'/') then
          ! For optimisation, use the fact that most possible operators are
          ! contiguous in the ASCII character set. Should be changed on a
          ! non-ASCII machine. Characters are ( ) + - * , . /
          start_operator = i
          return
        elseif (line(i:i).eq.'|') then
          start_operator = i
          return
        elseif (line(i:i).eq.'^') then
          start_operator = i
          return
        elseif (line(i:i).eq.' ') then
          start_operator = i
          return
        elseif (separator) then
          call sic_message(seve%e,rname,'Missing operator after closing bracket')
          error = .true.
          return
        endif
      endif
    enddo
  end function start_operator
  !
end subroutine find_operator
!
subroutine get_logcode(chain,i_code,nfunarg,error)
  use sic_interfaces, except_this=>get_logcode
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Sends back a code for the logical or relational operator contained
  ! in CHAIN
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: chain       ! The line to be analysed
  integer(kind=4),  intent(out) :: i_code      ! Code for operator
  integer(kind=4),  intent(out) :: nfunarg(2)  ! Min-max number of arguments
  logical,          intent(out) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  !
  ! Logical operators
  error = .false.
  nfunarg = 2
  select case (chain)
  case ('OR')
    i_code = code_or
  case ('AND')
    i_code = code_and
  case ('NOT')
    i_code = code_not
    nfunarg = 1
  !
  ! Relational operators
  case ('NE')
    i_code = code_ne
  case ('EQ')
    i_code = code_eq
  case ('LE')
    i_code = code_le
  case ('LT')
    i_code = code_lt
  case ('GE')
    i_code = code_ge
  case ('GT')
    i_code = code_gt
  case default
    call sic_message(seve%e,rname,  &
      'Unknown logical or relational operator .'//chain//'.')
    error = .true.
  end select
end subroutine get_logcode
!
subroutine get_level(line,n,level,coma,error)
  use sic_interfaces, except_this=>get_level
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Could be done while removing blanks and tabs...
  ! Determines the parenthesis level for each character of string LINE.
  !    LEVEL(I) is the level of LINE(I:I)
  ! Parenthesis themselves are stored at the level below their contents. 
  ! Comas are also stored one level below their surroundings.
  !    COMA(I) is defined for opening parenthesis as the number of comas
  ! at their level before drop to lower levels. For a function call, it
  ! should correspond to the number of arguments minus 1.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line      ! The line to be analysed
  integer(kind=4),  intent(in)  :: n         ! Length of LINE
  integer(kind=4)               :: level(n)  ! Parenthesis level array
  integer(kind=4)               :: coma(n)   !
  logical,          intent(out) :: error     !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: prev_opening(maxpar+1)
  integer(kind=4) :: i,curr_level
  logical :: array
  !
  error = .false.
  curr_level = 0
  array = .false.
  do i=1,n
    if (line(i:i).eq.'[') then
      array = .true.
    elseif (array) then
      if (line(i:i).eq.']') array = .false.
    elseif (line(i:i).eq.'(') then
      level(i) = curr_level
      curr_level = curr_level+1
      prev_opening(curr_level) = i
      coma(i) = 0
    elseif (line(i:i).eq.')') then
      curr_level = curr_level-1
      if (curr_level.lt.0) then
        call sic_message(seve%e,rname,'Unmatched closing parenthesis')
        goto 99
      endif
      level(i) = curr_level
    elseif (line(i:i).eq.',') then
      if (curr_level.le.0) then
        call sic_message(seve%e,rname,'Extra coma, check syntax')
        goto 99
      endif
      level(i) = curr_level-1
      coma(prev_opening(curr_level)) = coma(prev_opening(curr_level)) + 1
    else
      level(i) = curr_level
    endif
  enddo
  if (curr_level.gt.0) then
    call sic_message(seve%e,'SIC','Unmatched opening parenthesis')
    goto 99
  endif
  return
  !
  ! Error return
99 error = .true.
end subroutine get_level

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_rotate
  use cubetools_structure
  use cubetools_spatial_types
  use cubemain_messaging
  use cubemain_reproject
  !
  public :: rotate
  private
  !
  type, extends(reproject_comm_t) :: rotate_comm_t
     ! No difference (only a subset actually used here)
  contains
     ! Important: overload these 2
     procedure, public  :: register => cubemain_rotate_register
     procedure, private :: parse    => cubemain_rotate_parse
  end type rotate_comm_t
  type(rotate_comm_t) :: rotate
  !
contains
  !
  subroutine cubemain_rotate_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(reproject_user_t) :: user
    character(len=*), parameter :: rname='ROTATE>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call rotate%parse(line,user,error)
    if (error) return
    call rotate%main(user,error)
    if (error) continue
  end subroutine cubemain_rotate_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_rotate_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(rotate_comm_t), intent(inout) :: comm
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='ROTATE>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call comm%comm%register(&
         'ROTATE',&
         'Rotate a cube around a center',&
         strg_emp,&
         cubemain_rotate_command,&
         'Rotated',&
         flag_rotated,&
         error)
    if (error)  return
    call comm%pcenter%register(&
         'CENTER',&
         'Define the center about which to rotate',&
         error)
    if (error) return
    call comm%pangle%register(&
         'ANGLE',&
         'Define the new projection angle',&
         error)
    if (error) return
  end subroutine cubemain_rotate_register
  !
  subroutine cubemain_rotate_parse(comm,line,user,error)
    use cubeadm_cubeid_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(rotate_comm_t),   intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(reproject_user_t), intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='ROTATE>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%init(error)
    if (error) return
    call comm%comm%parse(line,user%comm,error)
    if (error) return
    call comm%pcenter%parse(line,user%pcenter,error)
    if (error) return
    call comm%pangle%parse(line,user%pangle,error)
    if (error) return 
  end subroutine cubemain_rotate_parse
end module cubemain_rotate
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeuv_language
  use cubetools_parameters
  use cubetools_structure
  use cubeuv_messaging
  !
  use cubeuv_table2image
  !
  public :: cubeuv_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubeuv_register_language(error)
    !----------------------------------------------------------------------
    ! Register the UV\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'UV',&
         'J.Pety, S.Bardeau',&
         'Commands to work on uv tables',&
         'UV converts remapped UV-table payloads into image products.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- TABLE2IMAGE transfers UV-table weights or intensities into&
         & one IMAGE product.'//strg_cr//&
         '- The input UV table must be remapped with IX=1 and IY=2&
         & before execution.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> UV\TABLE2IMAGE [uvtid]',&
         'gag_doc:hlp/cube-help-ima.hlp',& !***JP: Shall it be a different name
         cubeuv_execute_command,&
         langid,&
         error)
    if (error) return
    !
    call table2image%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubeuv_register_language
  !
  subroutine cubeuv_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the UV\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'UV?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to finalize_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubeuv_execute_command
end module cubeuv_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine conmap(line,error)
  use gbl_message
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>conmap
  use greg_contours
  use greg_kernel
  use greg_pen
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !     RGMAP
  !   1     /ABSOLUTE aval
  !   2     /PERCENT  pval
  !   3     /KEEP filename [blank]
  !   4     /BLANKING bval Eval
  !   5     /GREY First nstep
  !   6     /PENS pos neg
  !   7     /ONLY Positive|Negative 
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='RGMAP'
  character(len=40) :: name
  character(len=80) :: chain
  real(kind=4) :: spval,epsval,alev,plev,zmin,zmax
  real(kind=4), pointer :: sub(:,:)
  integer(kind=4), allocatable :: iwork(:)
  real(kind=4), allocatable :: swork(:)
  integer(kind=4) :: nx_old,ny_old,kx,ky,minx,maxx,miny,maxy,n1,n2
  integer(kind=4) :: ipen_old,n,nc,jlev
  logical :: subset,fastmode
  real(kind=8) :: xref_old,yref_old
  integer(kind=size_length), parameter :: nsummits=5
  real(kind=4) :: boxx(nsummits),boxy(nsummits)
  integer(kind=4) :: basecolo,colid,ier
  integer, parameter :: max_gzmin=100
  real(kind=4) :: buf_gzmin(max_gzmin)
  integer(kind=4) :: ibuf_gz
  integer(kind=4) :: kchunk,chunky,nchunk,rchunk,chumin,chumax,mychunk
  !
  integer :: my_ncl, the_ncl, klev
  real :: my_cl(maxl), the_cl(maxl)
  real :: s, sign_only
  character(len=12) :: positive='POSITIVE'
  character(len=12) :: negative='NEGATIVE' 
  character(len=12) :: fast='FAST'
  character(len=12) :: quiet='QUIET'
  ! Saved variables
  save alev,plev
  !
  ! Check if something to do
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%e,rname,'No map loaded')
    error = .true.
    return
  endif
  alev=1.0
  plev=1.0
  fastmode=.false.
  chunkpatch=.false.
  quietmode = sic_present(0,1)
  if (quietmode) then
    call sic_ke (line,0,1,name,nc,.true.,error)
    if (error) return
    nc = min(nc,12)
    fastmode=(name(1:nc).eq.fast(1:nc))
    quietmode=(name(1:nc).eq.quiet(1:nc))
  endif
  ! Grey scale and Chunks...
  mychunk=chunksize
  !
  ipen_old = cpen
  !
  ! Blanking Value ?
  if (sic_present(4,0)) then  ! /BLANKING
    call sic_r4 (line,4,1,spval,.true.,error)
    if (error) goto 999
    epsval = 0.  ! And not 'eblank' which can be negative <=> no blanking.
    call sic_r4 (line,4,2,epsval,.false.,error)
    if (error) goto 999
  else
    spval = cblank
    epsval = eblank
  endif
  if (sic_present(5,0)) then  ! /GREY
    ! Fill contours do not support BLANKING at all..
    call conblk(.false.,spval,epsval)
  elseif (epsval.ge.0.e0) then
    call conblk(.true.,spval,epsval)
    if (.not.quietmode) then
      write(chain,'(A,1PG13.6)') 'Contouring checks the blanking value ',spval
      call greg_message(seve%i,rname,chain)
    endif
  else
    call conblk(.false.,spval,epsval)
    if (.not.quietmode)  &
      call greg_message(seve%i,rname,'Contouring checks no blanking value')
  endif
  !
  ! Set contour factor
  if (sic_present(1,0)) then   ! Absolute
    if (sic_present(2,0)) then
      call greg_message(seve%e,rname,'Conflicting options : /ABSOLUTE and '//  &
      '/PERCENT')
      goto 999
    endif
    call sic_r4 (line,1,1,alev,.false.,error)
    if (error) goto 999
    qlev = alev
  elseif (sic_present(2,0)) then   ! Percent factor
    call sic_r4 (line,2,1,plev,.false.,error)
    if (error) goto 999
    call rgextr(0,zmin,zmax,rg%data,spval,epsval,.false.)
    qlev = plev*max(abs(zmin),abs(zmax))*0.01
  else                         ! No factor
    qlev = 1.
  endif
  !
  ! Select pens used for positive and negative contours
  ipen_pos = 0                 ! Default as requested by Steph...
  ipen_neg = 15
  if (sic_present(6,0)) then
    ipen_pos = cpen
    call sic_i4 (line,6,1,ipen_pos,.false.,error)
    if (error) goto 999
    ipen_neg = ipen_pos
    call sic_i4 (line,6,2,ipen_neg,.false.,error)
    if (error) goto 999
  endif
  if (.not.quietmode.and..not.sic_present(5,0)) then
    write(chain,'(A,I3,A,I3,A)') 'Pens',ipen_pos,' &',ipen_neg,  &
    ' used for positive & negative levels'
    call greg_message(seve%i,rname,chain)
  endif
  !
  ! Select levels to be processed through the /ONLY option
  sign_only = 0
  if (sic_present(7,0)) then
    call sic_ke (line,7,1,name,nc,.true.,error)
    if (name(1:nc).eq.positive(1:nc)) then
      sign_only = 1
    else if (name(1:nc).eq.negative(1:nc)) then
      sign_only = -1
    endif
  endif
  !
  if (sign_only.eq.0) then
    call conlev(qlev,cl,ncl)
    my_ncl = 0
  else 
    my_ncl = 0
    do jlev=1,ncl
      if (sign_only*cl(jlev).gt.0) then
        my_ncl = my_ncl+1
        my_cl(my_ncl) = cl(jlev)
      endif
    enddo
    if (my_ncl.eq.0) then
      call greg_message(seve%e,rname,'/ONLY: no valid level')
      goto 999
    endif
    call conlev(qlev,my_cl,my_ncl)
  endif
  !
  ! Keep contour on a formatted file ?
  if (sic_present(3,0)) then
    lout = .false.             ! Until OPEN
    if (eblank.lt.0) then
      call sic_r4 (line,3,2,blankfk,.true.,error)
      if (error) goto 999
    else
      blankfk = cblank
      call sic_r4 (line,3,2,blankfk,.false.,error)
      if (error) goto 999
    endif
    call sic_ch (line,3,1,name,nc,.true.,error)
    write(chain,'(A,1PG13.6)') '/KEEP writes the blanking value',blankfk
    call greg_message(seve%i,rname,chain)
    call sic_parsef (name,chain,' ','.dat')
    name=chain
    open(unit=jtmp,file=name,status='NEW',err=995)
    lout = .true.
  else
    lout = .false.
  endif
  !
  ! Check that map is visible, compute size of subset that can eventually been
  ! loaded:
  n1 = (gux1 - rg%xval)/rg%xinc + rg%xref
  n2 = (gux2 - rg%xval)/rg%xinc + rg%xref
  minx = min(n1,n2)-1
  maxx = max(n1,n2)+1
  if (maxx.lt.1 .or. minx.gt.rg%nx) then
    call greg_message(seve%w,rname,'Map is not visible')
    if (lout) close(unit=jtmp,status='DELETE')
    return
  endif
  n1 = (guy1 - rg%yval)/rg%yinc + rg%yref
  n2 = (guy2 - rg%yval)/rg%yinc + rg%yref
  miny = min(n1,n2)-1
  maxy = max(n1,n2)+1
  if (maxy.lt.1 .or. miny.gt.rg%ny) then
    call greg_message(seve%w,rname,'Map is not visible')
    if (lout) close(unit=jtmp,status='DELETE')
    return
  endif
  minx = max(1,minx)
  maxx = min(rg%nx,maxx)
  maxy = min(rg%ny,maxy)
  miny = max(1,miny)
  kx = maxx-minx+1
  ky = maxy-miny+1
  if (kx*ky.le.0) then
    call greg_message(seve%w,rname,'Map is not visible')
    if (lout) close(unit=jtmp,status='DELETE')
    return
  endif
  !
  if (sic_present(5,0)) then
    if (sic_present(3,0)) then
      call greg_message(seve%e,rname,'Conflicting options : /GREY and /KEEP')
      goto 999
    endif
    if (sic_present(4,0)) then
      call greg_message(seve%w,rname,'BLANKING ignored in Filled contour mode')
    endif
    lgrey = .true.
    ! Test a user-supplied Chunksize
    if (sic_present(0,1).and..not.quietmode.and..not.fastmode) then
      mychunk=chunksize
      call sic_i4(line,0,1,mychunk,.false.,error)
      error=.false.
    endif
    if (sic_present(5,1)) then
      call sic_i4 (line,5,1,ncolo,.false.,error)
      if (error) goto 999
      ncolo = max(1,min(ncolo,16))+7   ! intervalle 8-23
      if (sic_present(5,3)) then  ! RGMAP /GREY background
        call gtv_pencol_num2id(rname,ncolo,colid,error)
        if (error) goto 999
        call gr_segm('GREYBOX',error)
        call setcol(colid)
        boxx(1) = gx1
        boxy(1) = gy1
        boxx(2) = gx1
        boxy(2) = gy2
        boxx(3) = gx2
        boxy(3) = gy2
        boxx(4) = gx2
        boxy(4) = gy1
        boxx(5) = gx1
        boxy(5) = gy1
        call gr_fillpoly(nsummits,boxx,boxy)
        call gtsegm_close(error)
        ncolo=ncolo+1
        ncolo=mod((ncolo-9),16)+8
        ! ZZZ use parameters
      endif
      nstep = 1
      call sic_i4 (line,5,2,nstep,.false.,error)
      if (error) goto 999
      basecolo = ncolo
    else
      ncolo = 8
      nstep = 1
      basecolo = ncolo
    endif
  else
    lgrey = .false.
  endif
  !
  ! Test validity of "MYCHUNK" :
  ! do not perform contours on strips thinner than 4 pixels..
  if (mychunk.lt.kx*4) then
    mychunk=chunksize
    call greg_message(seve%w,rname,'Too small Chunk, using default value')
  endif
  !
  ! Optimize subset of "large" maps : load subset into work area;
  ! for grey contours, to maintain a reasonable size of the contour tree,
  ! we cut the map in chunks of CHUNKSIZE pixels and perform contour filling
  ! on these submaps. Hey, this should be done also for normal contours, as long
  ! as nobody asks for a printout. (or could be a "fast" option).
  if (.not.lgrey.and..not.fastmode) then
    subset = .false.
    sub => rg%data
    if (rg%nx*rg%ny.ge.mychunk) then
      if (1.5*kx*ky.lt.1.*rg%nx*rg%ny) then
        allocate(sub(kx,ky),stat=ier)
        if (ier.ne.0) goto 994
        subset = .true.
        ! Save old values
        nx_old = rg%nx
        ny_old = rg%ny
        rg%nx = kx
        rg%ny = ky
        xref_old = rg%xref
        yref_old = rg%yref
        rg%xref = xref_old + 1 - minx
        rg%yref = yref_old + 1 - miny
        call ext001 (rg%data,nx_old,ny_old,sub,rg%nx,rg%ny,minx,maxx,miny,maxy)
      endif
    endif
    ! Get work space for contours
994 n = max(rg%nx*rg%ny/5,1024)
    allocate(iwork(n),stat=ier)
    if (failed_allocate(rname,'iwork array',ier,error))  goto 998
    ilev = 0
    ! Contouring
    call conreg (rg%nx,rg%ny,sub,frstd,vectd,lastd,contd,iwork,n,error)
    deallocate(iwork)
    ! Reset pen and set last contoured map
    if (lout) close(unit=jtmp)
    cpen = ipen_old
    penupd = .true.
    if (subset) then
      deallocate(sub)
      rg%nx = nx_old
      rg%xref = xref_old
      rg%ny = ny_old
      rg%yref = yref_old
      subset = .false.
    endif
    return
  elseif (kx*ky.le.mychunk) then
    ! grey: subset of size =< MYCHUNK does not need to be cut in chunks.
    ! If NX*NY is =< MYCHUNK, it is even better (no subset extraction needed).
    ! Serves also for "fast" mode (which is able to contour ANY map).
    subset = .false.
    sub => rg%data
    if (rg%nx*rg%ny.gt.mychunk) then
      allocate(sub(kx,ky),stat=ier)
      if (ier.ne.0) goto 993
      subset = .true.
      ! Save old values
      nx_old = rg%nx
      ny_old = rg%ny
      rg%nx = kx
      rg%ny = ky
      xref_old = rg%xref
      yref_old = rg%yref
      rg%xref = xref_old + 1 - minx
      rg%yref = yref_old + 1 - miny
      call ext001(rg%data,nx_old,ny_old,sub,rg%nx,rg%ny,minx,maxx,miny,maxy)
    else
      !SG! PRINT *,'No truncation '
    endif
    !     Get work space for contours
993 n = max(rg%nx*rg%ny*2,1000)
    allocate(iwork(n),stat=ier)
    if (failed_allocate(rname,'iwork buffer',ier,error))  goto 998
    ilev = 0
    ! Contouring
    if (lgrey) then
      ! Remember the default Level list, because HIGHWATER
      ! assumes the list starts from 1 and is identical to that 
      ! loaded to conlev.
      the_ncl = ncl
      the_cl = cl
      if (my_ncl.ne.0) cl = my_cl
      ! Compute subset extrema to insure correct filling for adjacent patches
      ! by correct estimate of HIGHWATER. No, GZMIN is .NOT..EQ.RGMIN, and
      ! we have to recompute it (this because RGMIN is for a whole cube,
      ! or because we look only at a subset of the map).
      if (subset) then
!         This is incorrect, and overrides the current RG data extrema
!           call rgextr(0,gzmin,gzmax,sub,spval,epsval,.true.)
!         The generic code works...
        call gr4_sub_extrema(sub,rg%nx,rg%ny,spval,epsval,gzmin,gzmax, &
          & 1,rg%nx,1,rg%ny) 
      else
        call gr4_sub_extrema(sub,rg%nx,rg%ny,spval,epsval,gzmin,gzmax, &
          & minx,maxx, miny,maxy)
      endif
      call conreg(rg%nx,rg%ny,sub,frstg,vectg,lastg,contg,iwork,n,error)
      !
      ! Restore the default Level list
      cl = the_cl
      ncl = the_ncl
    else
      call conreg(rg%nx,rg%ny,sub,frstd,vectd,lastd,contd,iwork,n,error)
    endif
    deallocate(iwork)
    ! Reset pen and set last contoured map
    cpen = ipen_old
    penupd = .true.
    if (subset) then
      deallocate(sub)
      rg%nx = nx_old
      rg%xref = xref_old
      rg%ny = ny_old
      rg%yref = yref_old
      subset = .false.
    endif
    return
  else
    ! Grey: subset of size < MYCHUNK is cut in chunks (lines)
    ! compute subsets sizes:
    n = mychunk*2
    allocate(swork(mychunk),iwork(n),stat=ier)
    if (failed_allocate(rname,'swork and iwork arrays',ier,error))  goto 999
    ! Save old values
    nx_old = rg%nx
    ny_old = rg%ny
    xref_old = rg%xref
    yref_old = rg%yref
    rg%nx = kx
    chunky=mychunk/kx          !nb of lines in chunk
    nchunk=ky/chunky           !nb of submaps of KX*CHUNKY
    rchunk=ky-nchunk*chunky+nchunk-1   !1 pixel overlap
    do while (rchunk.ge.chunky)
      nchunk=nchunk+1
      rchunk=rchunk-chunky
    enddo
    rchunk=max(rchunk,0)
    if (rchunk.gt.0) nchunk=nchunk+1
    ncolo = basecolo
    chunkpatch=.true.
    !
    klev = 0
    do jlev=1,ncl     
      !
      ! Select only the requested Sign
      s = sign(1.0,cl(jlev))
      if (s*sign_only.lt.0) cycle
      if (klev.eq.0) klev = jlev  ! First level
      !
      rg%xref = xref_old+1-minx
      chumin = miny
      if (lgrey) then
        call gtv_pencol_num2id(rname,ncolo,colid,error)
        if (error) goto 999
        call gr_segm('GREY',error)
        call setcol(colid)
      else
        call gr_segm('CONTOUR',error)
        if (cl(jlev).lt.0.0) then
          call setpen(ipen_neg)
        else
          call setpen(ipen_pos)
        endif
      endif
      do kchunk=1,nchunk
        chumax=min((chumin+chunky-1),maxy)
        rg%ny =chumax-chumin+1
        rg%yref = yref_old+1-chumin
        call ext001(rg%data,nx_old,ny_old,swork,rg%nx,rg%ny,minx,maxx,  &
          chumin,chumax)
        call conlev(qlev,cl(jlev),1)
        ! Ilev is incremented by conreg
        ilev = jlev-1
        if (lgrey) then
          ! Compute subset extrema to insure correct filling for adjacent patches
          ! by correct estimate of HIGHWATER. note that here GZMIN is buffered.
          ibuf_gz = min(kchunk,max_gzmin)
          if (klev.eq.1.or.kchunk.ge.max_gzmin) then
            ! This would overwrite the RG extrema          
            !   call rgextr(0,buf_gzmin(ibuf_gz),gzmax,swork,spval,epsval,.true.)
            call gr4_sub_extrema(swork,rg%nx,rg%ny,spval,epsval,buf_gzmin(ibuf_gz),gzmax, &
              &   1,rg%nx,1,rg%ny)
          endif
! This looks incorrect and can overflow buf_gzmin
!          gzmin=buf_gzmin(kchunk)
! Use this instead
          gzmin = buf_gzmin(ibuf_gz)
          call conreg (rg%nx,rg%ny,swork,frstg,vectg,lastg,contg,iwork,n,error)
        else
          call conreg (rg%nx,rg%ny,swork,frstd,vectd,lastd,contd,iwork,n,error)
        endif
        if (error) then
          if (lgrey) then
            call greg_message(seve%i,rname,'Try a smaller ChunkSize (see HELP)')
          endif
          goto 992
        endif
        chumin = chumax
        cpen   = ipen_old
        penupd = .true.
      enddo
      if (lgrey) then
        ncolo = ncolo+nstep    ! another one
        ncolo=mod((ncolo-8),16)+8  ! pen [8-23]
      endif
      call gtsegm_close(error)
      if (error)  return
    enddo
992 continue
    !
    deallocate(iwork,swork)
    rg%nx = nx_old
    rg%xref = xref_old
    rg%ny = ny_old
    rg%yref = yref_old
    cpen = ipen_old
    penupd = .true.
    return
  endif
  !
995 call greg_message(seve%e,rname,'Cannot open the file requested by /KEEP')
  goto 999
998 continue
  if (subset) then
    deallocate(sub)
    rg%nx = nx_old
    rg%xref = xref_old
    rg%ny = ny_old
    rg%yref = yref_old
    subset = .false.
  endif
999 error=.true.
  if (lout) close(unit=jtmp,status='DELETE')
  cpen = ipen_old
  penupd = .true.
end subroutine conmap
!
subroutine ext001(a,nx,ny,b,kx,ky,minx,maxx,miny,maxy)
  use greg_interfaces, except_this=>ext001
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nx        !
  integer(kind=4), intent(in) :: ny        !
  real(kind=4),    intent(in) :: a(nx,ny)  !
  integer(kind=4), intent(in) :: kx        !
  integer(kind=4), intent(in) :: ky        !
  real(kind=4)                :: b(kx,ky)  ! inout?
  integer(kind=4), intent(in) :: minx      !
  integer(kind=4), intent(in) :: maxx      !
  integer(kind=4), intent(in) :: miny      !
  integer(kind=4), intent(in) :: maxy      !
  ! Local
  integer(kind=4) :: ja,jb
  integer(kind=4) :: px
  !
  px = min(maxx-minx+1,kx)
  do ja = miny,min(maxy,ky+miny-1)
    jb = ja - miny + 1
    call r4tor4(a(minx,ja),b(1,jb),px)
  enddo
end subroutine ext001
!
subroutine frstd (icode,error)
  use gbl_message
  use greg_interfaces, except_this=>frstd
  use greg_contours
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  For each contour level, puts (X,Y) Coordinates of contour into
  ! arrays XU,YU. Then plots the contour line using CONNECT
  !  Take care of grey scale contouring on SECAPA.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: icode  !
  logical,         intent(inout) :: error  !
  ! Local
  real(kind=4) :: cv
  character(len=message_length) :: chain
  !
  ! Beginning of new contour operation. Reset buffer and level counter.
  !
  ldd  = 0
  if (.not.chunkpatch) then
    if (icode.eq.2) then
      call gr_segm('CONTOUR',error)
      call setpen(ipen_neg)
    else
      call gr_segm('CONTOUR',error)
      call setpen(ipen_pos)
    endif
  endif
  mxu = maxu
  ilev = ilev+1
  cv=cl(ilev)*qlev
  if (.not.quietmode) then
    write(chain,'(A,I3,1X,1PG13.6)') 'Contour ',ilev,cv
    call greg_message(seve%i,'RGMAP',chain)
  endif
  if (lout) write(jtmp,*) blankfk,blankfk,'  Start contour ',ilev,cv
  link = .false.
end subroutine frstd
!
subroutine vectd(x,y,error)
  use greg_interfaces, except_this=>vectd
  use greg_contours
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  For each contour level, puts (X,Y) Coordinates of contour into
  ! arrays XU,YU. Then plots the contour line using CONNECT
  !  Middle of contour line; Convert to user coordinates
  !  Return if still some place left in buffer
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: x      !
  real(kind=4), intent(in)    :: y      !
  logical,      intent(inout) :: error  !
  !
  ldd=ldd+1
  xu(ldd) = (x-rg%xref)*rg%xinc + rg%xval
  yu(ldd) = (y-rg%yref)*rg%yinc + rg%yval
  if (ldd.lt.mxu) return
  !
  ! Flush buffer if full or if end of contour line
  !
  link = .true.
  call lastd(error)
end subroutine vectd
!
subroutine lastd(error)
  use gildas_def
  use greg_interfaces, except_this=>lastd
  use greg_contours
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  End of contour line; Plots the contour line using CONNECT.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  integer(kind=size_length) :: k
  !
  call press_ctrlc(error)
  if (error) return
  ! Simple contour drawing
  call gr4_connect(ldd,xu,yu,0.e0,-1.e0)
  if (lout) then
    do k=1,ldd
      write(jtmp,*) xu(k),yu(k)
    enddo
    if (.not.link) then
      write(jtmp,*) blankfk,blankfk,'  End of part of contour ',ilev
    endif
  endif
  !
  ! Prepare buffer if linked contours;
  if (link) then
    xu(1) = xu(ldd)
    yu(1) = yu(ldd)
    ldd = 1
    link = .false.
  else
    ldd = 0
  endif
end subroutine lastd
!
subroutine contd(error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>contd
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  End of contour line; Show it
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  !
  call press_ctrlc(error)
  if (error) return
  !
  if (.not.chunkpatch)  call gtsegm_close(error)
  !
end subroutine contd
!
subroutine frstg(icode,error)
  use gildas_def
  use gbl_message
  use greg_interfaces, except_this=>frstg
  use greg_contours
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !   For each contour level, puts (X,Y) Coordinates of contour into
  ! arrays XU,YU. For Grey-scale.
  !   Call INIT_TREE to reset the filling capability
  !---------------------------------------------------------------------
  integer(kind=4)                :: icode  ! Unused
  logical,         intent(inout) :: error  !
  ! Local
  character(len=60) :: chain
  real :: cv
  !
  ! Beginning of new contour operation. Reset buffer and level counter.
  !
  ldd = 0
  mxu = 0
  call init_tree(icode,noclip_gris,error)
  if (error) return
  noclip_gris = .not.noclip_gris
  if (.not.quietmode.and..not.chunkpatch) then
    write(chain,'(A,I3,1X,1PG13.6)') 'Filling Contour ',ilev,cl(ilev)*qlev
    call greg_message(seve%i,'RGMAP',chain)
  endif
  ! Highwater is used to tell whether a void contour (at some level), should be
  ! filled anyway (to the extent of the map). This because contours BELOW the
  ! threshold should appear (as pixels below threshold appear on the pixel image:
  ! this capacity is needed when contouring several planes in a cube),
  ! and because, when a map is divided in chunks, some contours may not be drawn
  ! on a certain chunk just because all the pixels in the chunk would be above
  ! that contour level.
  cv=cl(ilev)*qlev
  highwater = cv.le.gzmin   !!  and NOT cl(ilev).le.gzmin
  !
end subroutine frstg
!
subroutine vectg(x,y,error)
  use gildas_def
  use gbl_message
  use greg_interfaces, except_this=>vectg
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Middle of contour line; Convert to user coordinates.
  !  We should also clip here... If clipping applies, then a pseudo-end
  ! of contour appears
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: x      !
  real(kind=4), intent(in) :: y      !
  logical                  :: error  !
  ! Local
  character(len=*), parameter :: rname='VECTG'
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  integer(kind=4), allocatable :: tmpx(:),tmpy(:)
  !
  if (mxu.eq.0) then
    mxu = maxu
    allocate(ixu(mxu),iyu(mxu),stat=ier)
    if (ier.ne.0)  goto 10
    !
  elseif (ldd.ge.mxu) then
    write(mess,'(A,I0)') 'Reallocating virtual memory to ',mxu
    call greg_message(seve%d,rname,mess)
    !
    allocate(tmpx(mxu),tmpy(mxu),stat=ier)
    if (ier.ne.0)  goto 10
    tmpx(:) = ixu(:)
    tmpy(:) = iyu(:)
    !
    deallocate(ixu,iyu,stat=ier)
    if (ier.ne.0)  goto 10
    allocate(ixu(2*mxu),iyu(2*mxu),stat=ier)
    if (ier.ne.0)  goto 10
    ixu(1:mxu) = tmpx(:)
    iyu(1:mxu) = tmpy(:)
    deallocate(tmpx,tmpy,stat=ier)
    if (ier.ne.0)  goto 10
    !
    mxu = 2*mxu
  endif
  ldd = ldd+1
  ixu(ldd) = nint(x*1e4)  ! Real centimeters to integer microns
  iyu(ldd) = nint(y*1e4)  ! Real centimeters to integer microns
  return
  !
  ! Allocation error
10 continue
  call greg_message(seve%e,rname,'Error allocating/deallocating arrays')
  error = .true.
  return
end subroutine vectg
!
subroutine lastg(error)
  use gildas_def
  use greg_interfaces, except_this=>lastg
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  End of contour line; Plots the contour line using FILL_VECT (to
  ! put a vector) and FILL_CONT (to end a contour)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  integer(kind=4) :: c,c0,c1
  integer(kind=4) :: jx,jy,jx0,jy0,jx1,jy1,jxu,jyu,jxd,jyd
  logical :: up,down
  integer(kind=size_length) :: i,ndd
  !
  call press_ctrlc (error)
  if (error) return
  !
  ndd = ldd
  ldd = 0
  up = .true.
  down = .false.
  !
  ! Reset pen position
  jxu = ixu(1)
  jyu = iyu(1)
  !
  do i=1,ndd
    if (noclip_gris) then
      jx = ixu(i)
      jy = iyu(i)
      call fill_vect(jx,jy,error)
      if (error) return
    else
      if (up) then
        ! If down, flush previous contour
        if (down) then
          call fill_cont(error)
          if (error) return
        endif
      endif
      !
      ! Clip line jxu,jyu --> jxd,jyd
      jxd = ixu(i)
      jyd = iyu(i)
      jx0 = jxu
      jy0 = jyu
      jx1 = jxd
      jy1 = jyd
      jxu = jxd
      jyu = jyd
      !
      ! Change the end-points of the line (X0,Y0) - (X1,Y1)
      ! to clip the line at the window boundary.
      ! The algorithm is that of Cohen and Sutherland (ref: Newman & Sproull)
      !
      call grisclip(jx0,jy0,c0)
      call grisclip(jx1,jy1,c1)
      !
      do while (c0.ne.0 .or. c1.ne.0)
        if (iand(c0,c1).ne.0)  goto 10 ! line is invisible
        !
        c = c0
        if (c.eq.0) c = c1
        if (iand(c,1).ne.0) then   ! crosses XXBOX1
          jy = jy0 + 0.5 + float(jy1-jy0)*float(xxbox1-jx0)/float(jx1-jx0)
          jx = xxbox1
        elseif (iand(c,2).ne.0) then   ! crosses XXBOX2
          jy = jy0 + 0.5 + float(jy1-jy0)*float(xxbox2-jx0)/float(jx1-jx0)
          jx = xxbox2
        elseif (iand(c,4).ne.0) then   ! crosses YYBOX1
          jx = jx0 + 0.5 + float(jx1-jx0)*float(yybox1-jy0)/float(jy1-jy0)
          jy = yybox1
        elseif (iand(c,8).ne.0) then   ! crosses YYBOX2
          jx = jx0 + 0.5 + float(jx1-jx0)*float(yybox2-jy0)/float(jy1-jy0)
          jy = yybox2
        endif
        if (c.eq.c0) then
          jx0 = jx
          jy0 = jy
          call grisclip(jx,jy,c0)
        else
          jx1 = jx
          jy1 = jy
          call grisclip(jx,jy,c1)
        endif
      enddo
      !
      if (up) then
        call fill_vect(jx0,jy0,error)
        if (error) return
        up = .false.
      endif
      call fill_vect(jx1,jy1,error)
      if (error) return
      down = .true.
      up = (jx1.ne.jxu).or.(jy1.ne.jyu)
    endif
10  continue
  enddo  ! I
  !
  call fill_cont(error)
  !
end subroutine lastg
!
subroutine contg(error)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>contg
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! End of contour line; Show it using FLUSH_TREE
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  !
  call flush_tree(error)
  if (.not.chunkpatch)  call gtsegm_close(error)
  !
  if (allocated(ixu))  deallocate(ixu)
  if (allocated(iyu))  deallocate(iyu)
  call press_ctrlc (error)
  !
end subroutine contg
!
subroutine press_ctrlc(error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>press_ctrlc
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  logical :: ok
  character(len=1) :: answer
  !
  ok = sic_ctrlc()
  do while (ok)
    call sic_wpr('W-RGMAP, ^C pressed, Type C to continue, Q to QUIT',answer)
    if (answer.eq.'Q' .or. answer.eq.'q') then
      error = .true.
      return
    elseif (answer.eq.'C' .or. answer.eq.'c') then
      ok = .false.
    endif
  enddo
end subroutine press_ctrlc
!
subroutine grisclip(x,y,c)
  use greg_interfaces, except_this=>grisclip
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for the clipping algorithm ; called from DRAW and
  ! GRPOLY only. C is a 4 bit code indicating the relationship between
  ! point (X,Y) and the window boundaries ; 0 implies the point is
  ! within the window.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: x  ! Position of point
  integer(kind=4), intent(in)  :: y  ! Position of point
  integer(kind=4), intent(out) :: c  ! Code
  !
  c = 0
  if (x.lt.xxbox1) then
    c = 1
  elseif (x.gt.xxbox2) then
    c = 2
  endif
  if (y.lt.yybox1) then
    c = c+4
  elseif (y.gt.yybox2) then
    c = c+8
  endif
end subroutine grisclip

subroutine fitgauss (fcn,liter,ier)
  !---------------------------------------------------------------------
  ! SAS	Internal routine
  !	Setup and starts a GAUSS fit minimisation using MINUIT
  ! Arguments :
  !	FCN	Ext.	Function to be mininized	Input
  !	LITER	L	Logical of iterate fit		Input
  !	IER	I	error code 			Output
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  external :: fcn                   !
  logical :: liter                  !
  integer :: ier                    !
  ! Global
  integer :: lenc
  include 'clic_fit.inc'
  include 'clic_gauss.inc'
  include 'clic_gaussdata.inc'
  ! Local
  integer :: i,k,l,k1,k2
  logical :: first
  real*8 :: dx, al, ba, du1, du2
  real :: x1, x2
  character(len=80) :: ch
  !
  ! Added error Patch for Initialisation
  ngline= nline
  maxext=ntot
  maxint=nvar
  !
  ! Initialise values
  k = max(1,ndata/4)
  x1 = 1e20
  do i=1, ndata
    if (rdatax(i).lt.x1) x1 = rdatax(i)
  enddo
  deltav = 1e20
  do i=1, ndata
    x2 = rdatax(i)-x1
    if ((x2.gt.0.01).and.(x2.lt.deltav)) deltav = x2
  enddo
  call midgauss (ier,liter)
  if (ier.ne.0) return
  call clic_intoex(x)
  up = 0.5*(sigbas**2+sigrai**2)
  nfcnmx  = 1000
  epsi  = 0.1d0 * up
  newmin  = 0
  itaur  = 0
  isw(1)  = 0
  isw(3)  = 1
  nfcn = 1
  vtest  = 0.04
  call fcn(npar,g,amin,u,1)
  !
  ! Simplex Minimization
  if (.not.liter) then
    call clic_simplx(fcn,ier)
    if (ier.ne.0) return
    k=1
    do i=1,max(nline,1)
      par(k)  =u(k+3)*u(1)*1.7724538
      par(k+1)=u(k+4)+u(2)
      par(k+2)=u(k+5)*1.665109*u(3)
      k=k+3
    enddo
  endif
  !
  ! Gradient Minimization
  first = .false.
10 first = .not.first
  call clic_intoex(x)
  call fcn(npar,g,amin,u,3)
  write(ch,1002) sigbas,sigrai
  call message(4,1,'FITGAUSS',ch(1:lenc(ch)))
  up = sigbas**2
  epsi  = 0.1d0 * up
  apsi  = epsi
  call clic_hesse(fcn)
  call clic_migrad(fcn,ier)
  if (ier.eq.3 .and. first) goto 10
  !
  if (ier.eq.1) then
    call clic_hesse(fcn)
    ier = 0
  endif
  !
  ! Print Results
  k=1
  do i=1,max(nline,1)
    par(k)  =u(k+3)*u(1)*1.7724538
    par(k+1)=u(k+4)+u(2)
    par(k+2)=u(k+5)*u(3)*1.665109
    k=k+3
  enddo
  call clic_intoex(x)
  call fcn(npar,g,amin,u,3)
  write(ch,1002) sigbas,sigrai
  call message(4,1,'MIDGAUSS',ch(1:lenc(ch)))
  up  = sigbas**2
  !
  ! Calculate External Errors
  do i=1,nu
    l  = lcorsp(i)
    if (l .eq. 0)  then
      werr(i)=0.
    else
      if (isw(2) .ge. 1)  then
        dx = dsqrt(dabs(v(l,l)*up))
        if (lcode(i) .gt. 1) then
          al = alim(i)
          ba = blim(i) - al
          du1 = al + 0.5d0 *(dsin(x(l)+dx) +1.0d0) * ba - u(i)
          du2 = al + 0.5d0 *(dsin(x(l)-dx) +1.0d0) * ba - u(i)
          if (dx .gt. 1.0d0)  du1 = ba
          dx = 0.5d0 * (dabs(du1) + dabs(du2))
        endif
        werr(i) = dx
      endif
    endif
  enddo
  !
  k=1
  do i=1,max(nline,1)
    k1=k+1
    k2=k+2
    err(k)=werr(k+3)
    if (i.eq.kt0) err(k)=werr(1)
    err(k1)=werr(k1+3)
    if (i.eq.kv0) err(k1)=werr(2)
    err(k2)=werr(k2+3)
    if (i.eq.kd0) err(k2)=werr(3)
    k=k+3
  enddo
  return
  !
1002 format ('RMS of Residuals :  Base = ',1pg9.2,   &
    '  Line = ',1pg9.2)
end subroutine fitgauss
!
subroutine itegauss (ier)
  !---------------------------------------------------------------------
  ! LAS	Support routine for command
  !	ITERATE
  !	Case of gaussian profiles
  !---------------------------------------------------------------------
  integer :: ier                    !
  ! Global
  external :: mingauss
  include 'clic_gauss.inc'
  ! Local
  integer :: kt(5),kv(5),kd(5),i,j,i1
  real*4 :: zpar(15)
  equivalence (kt(1),kt1), (kv(1),kv1), (kd(1),kd1)
  !
  i1=nline
  if (nline.eq.-1) then
    nline = ngline
  endif
  nline=max(nline,1)
  j=1
  ! Save Last Parameters
  do i=1,15
    zpar(i)=spar(i)
  enddo
  !
  ! Retrieve Last Fit
  do i=1,nline
    if (par(j+2).ne.0.0) then
      spar(j) = par(j)/par(j+2)/1.064467
    else
      ier = -1
      call message(8,3,'ITERA','Bad input parameters')
      goto 99
    endif
    if (kt(i).eq.3) spar(j)=par(j)/par(3*kt0-2)
    j=j+1
    spar(j)=par(j)
    if (kv(i).eq.3) spar(j)=par(j)-par(3*kv0-1)
    j=j+1
    spar(j)=par(j)
    if (kd(i).eq.3) spar(j)=par(j)/par(3*kd0)
    j=j+1
  enddo
  call fitgauss (mingauss,.true.,ier)
  nline=i1
  !
  ! Restore Last Parameters
99 do i=1,15
    spar(i)=zpar(i)
  enddo
end subroutine itegauss
!
subroutine midgauss (ifatal,liter)
  !---------------------------------------------------------------------
  ! ANALYSE	Internal routine
  !	Start a gaussian fit by building the PAR array and internal
  !	variable used by Minuit
  ! Arguments
  !	IFATAL	I	Number of fatal errors		Output
  !	LITER	L	Iterate a fit			Input
  !---------------------------------------------------------------------
  integer :: ifatal                 !
  logical :: liter                  !
  ! Global
  integer :: lenc
  include 'clic_fit.inc'
  include 'clic_gauss.inc'
  include 'clic_gaussdata.inc'
  ! Local
  integer :: kt(5),kv(5),kd(5),i, ninte, k, j
  equivalence (kt(1),kt1), (kv(1),kv1), (kd(1),kd1)
  real*8 :: sav, clic_pintf, sav2, vplu, vminu, asign
  character(len=80) :: ch
  !
  isyswr=6
  do i= 1, 7
    isw(i) = 0
  enddo
  sigma = 0.d0
  npfix = 0
  ninte = 0
  nu = 0
  npar = 0
  ifatal = 0
  do i= 1, maxext
    u(i) = 0.0d0
    lcode(i) = 0
    lcorsp (i) = 0
  enddo
  isw(5) = 1
  !
  ! Starting values
  !
  if (nline.eq.0) then
    nu=3
  else
    !
    ! Take initial guesses in SPAR
    nu=3*nline
    j=1
    do i=1,nline
      !
      ! That is quite tricky, since the area is the product of the original
      ! intensity by the width. But for dependant gaussian, it is more subtle
      if (kt(i).eq.3) then
        par(j) = spar(j)
      elseif (kd(i).eq.3) then
        par(j) = spar(j)*spar(j+2)*1.064467    ! Area
        par(j) = par(j)*spar(3*kd0)    !
      else
        par(j) = spar(j)*spar(j+2)*1.064467    ! Area
      endif
      par(j+1) = spar(j+1)     ! Position
      par(j+2) = spar(j+2)     ! Width
      j=j+3
    enddo
  endif
  !
  ! Type initial guesses
  nu=nu+3
  write(ch,1001) 'Guesses: ',par(1),par(2),par(3)
  call message(2,1,'MIDGAUSS',ch(1:lenc(ch)))
  k = 4
  do i=2,max(nline,1)
    write (ch,1001) '         ',par(k),par(k+1),par(k+2)
    call message(2,1,'MIDGAUSS',ch(1:lenc(ch)))
    k=k+3
  enddo
  !
  ! Set up Parameters for Major Variables
  !
  ! Velocities
  if (kv0.eq.0) then
    u(2)=0.
    werr(2)=0.
  else
    u(2)=par(3*kv0-1)
    if (kv(kv0).eq.4) then
      werr(2)=0.
    else
      werr(2)=deltav
      if (liter.and.err(3*kv0-1).ne.0) werr(2)=err(3*kv0-1)
      alim(2)=u(2)-0.15*ndata*deltav
      blim(2)=u(2)+0.15*ndata*deltav
    endif
  endif
  !
  ! Line Widths
  if (kd0.eq.0) then
    u(3)=1./1.665109           ! 1 / (2*SQRT(LN(2)))
    werr(3)=0.
  else
    u(3)=abs(par(3*kd0))/1.665109
    if (kd(kd0).eq.4) then
      werr(3)=0.
    else
      werr(3)=deltav
      if (liter.and.err(3*kd0).ne.0) werr(3)=err(3*kd0)
      alim(3)=0.25*deltav
      blim(3)=0.75*ndata*deltav
    endif
  endif
  !
  ! Areas
  if (kt0.eq.0) then
    u(1)=0.564189584           ! 1 / SQRT(PI)
    werr(1)=0.
  else
    u(1)=par(3*kt0-2)
    if (kt(kt0).eq.4) then
      werr(1)=0.
    else
      werr(1)=sigbas*deltav
      if (liter.and.err(3*kt0-2).ne.0) werr(1)=err(3*kt0-2)
      if (u(1).ne.0.) then
        alim(1)=dmin1(0.d0,10*u(1))
        blim(1)=dmax1(0.d0,10*u(1))
      else
        lcode(1)=1
      endif
    endif
  endif
  !
  ! Set up parameters for Secondary Variables
  !
  k=4
  do i=1,max(nline,1)
    ! Area
    u(k)=par(k-3)
    if (kt(i).eq.0 .or. nline.eq.0) then
      werr(k)  =  max(sigbas,sigrai)*deltav
      if (liter.and.err(k-3).ne.0) werr(k)=err(k-3)
      if (u(k).ne.0.) then
        alim(k)=dmin1(0.d0,10*u(k))
        blim(k)=dmax1(0.d0,10*u(k))
      else
        lcode(k)=1             ! No Boundaries if U(k)=0.
      endif
    else
      werr(k)=0.
      if (i.eq.kt0) then
        u(k)=0.564189584
      else
        u(k)=u(k)*0.564189584
      endif
    endif
    k=k+1
    !
    ! Velocity
    u(k)=par(k-3)
    if (kv(i).eq.0 .or. nline.eq.0) then
      werr(k)=deltav
      if (liter.and.err(k-3).ne.0) werr(k)=err(k-3)
      alim(k)=u(k)-0.15*ndata*deltav
      blim(k)=u(k)+0.15*ndata*deltav
    else
      werr(k)=0.
      if (i.eq.kv0) u(k)=0.
    endif
    k=k+1
    !
    ! Line Width
    u(k)=abs(par(k-3))
    if (kd(i).eq.0 .or. nline.eq.0) then
      werr(k)=deltav
      if (liter.and.err(k-3).ne.0) werr(k)=err(k-3)
      !		ALIM(K)=DELTAV
      alim(k)=0.25*deltav
      blim(k)=0.75*ndata*deltav
    else
      werr(k)=0.
      if (i.eq.kd0) u(k)=1.
    endif
    k=k+1
  enddo
  !
  ! Various checks
  do 200 k= 1, nu
    if (k.gt.maxext) then
      ifatal = ifatal+1
      goto 200
    endif
    if (werr(k).le.0.0d0) then
      lcode(k) = 0
      if (k.gt.3) then
        write(ch,1010)  k-3,' is fixed'
        call message(4,2,'MIDGAUSS',ch(1:lenc(ch)))
      endif
      goto 200
    endif
    ninte = ninte+1
    if (lcode(k).ne.1) then
      lcode(k) = 4
      asign = (blim(k)-u(k))*(u(k)-alim(k))
      if (asign.lt.0) then
        ifatal = ifatal+1
        write(ch,1011)  k-3,alim(k),u(k),blim(k)
        call message(4,2,'MIDGAUSS',ch(1:lenc(ch)))
      elseif (asign.eq.0) then
        if (k.gt.3) then
          write(ch,1010) k-3,' is at limit'
          call message(4,2,'MIDGAUSS',ch(1:lenc(ch)))
        endif
      endif
    endif
200 continue
  !
  ! End parameter cards
  ! Stop if fatal error
  if (ninte .gt. maxint)  then
    write (ch,1008)  ninte,maxint
    call message(6,4,'MIDGAUSS',ch(1:lenc(ch)))
    ifatal = ifatal + 1
  endif
  if (ninte .eq. 0) then
    call message(6,4,'MIDGAUSS','All input parameters are fixed')
    ifatal = ifatal + 1
  endif
  if (ifatal .gt. 0)  then
    ifatal = -ifatal
    return
  endif
  !
  ! O.K. Start
  ! Calculate step sizes DIRIN
  npar = 0
  do k= 1, nu
    if (lcode(k) .gt. 0)  then
      npar = npar + 1
      lcorsp(k) = npar
      sav = u(k)
      x(npar) = clic_pintf(sav,k)
      xt(npar) = x(npar)
      sav2 = sav + werr(k)
      vplu = clic_pintf(sav2,k) - x(npar)
      sav2 = sav - werr(k)
      vminu = clic_pintf(sav2,k) - x(npar)
      dirin(npar) = 0.5d0 * (dabs(vplu) +dabs(vminu))
    endif
  enddo
  return
  !
1001 format(a,1pg10.3,'    ',1pg10.3,'    ',1pg10.3)
1008 format ('Too many variable parameters.  You request ',i5/,   &
    ' This version of MINUIT is only dimensioned for ',i4)
1010 format ('Parameter ',i2,' ',a)
1011 format ('Parameter ',i2,' outside limits ', 3(1pg11.3))
end subroutine midgauss
!
subroutine mingauss (npar,g,f,x,iflag)
  !---------------------------------------------------------------------
  ! LAS	Internal routine
  !	Function to be minimized in the gaussian fit.
  !	By using 3 hidden parameters, the method allows dependent
  !	and independent gaussians to be fitted. The computation is
  !	highly optimised, but take care of R*4 and R*8 values !...
  !	Basic parameters are Area, Position and Width.
  ! Arguments :
  !	NPAR	I	Number of parameters		Input
  !	G	R*8(1)	Array of derivatives		Output
  !	F	R*8	Function value			Output
  !	X	R*8(1)	Parameter values		Input
  !	IFLAG	I	Code operation			Input
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  integer :: npar                   !
  real*8 :: g(*)                    !
  real*8 :: f                       !
  real*8 :: x(*)                    !
  integer :: iflag                  !
  ! Global
  real :: progauss
  include 'clic_gauss.inc'
  include 'clic_gaussdata.inc'
  ! Local
  logical :: dograd
  real :: tt,vv,dd,gt,gv,gd,ff
  real :: t1,v1,d1,t2,v2,d2,t3,v3,d3,t4,v4,d4,t5,v5,d5
  real :: g1,g2,g3,g4,g5,g6,g7,g8,g9,g10,g11,g12,g13,g14,g15
  real :: xvel,arg1,arg2,arg3,arg4,arg5,f1,f2,f3,f4,f5,arg
  real :: seuil,ta,ybas,yrai,kbas,krai
  integer :: i
  !
  ! Final computations
  if (iflag.eq.3) goto 20
  dograd = iflag.eq.2
  !
  f=0.
  tt=x(1)
  vv=x(2)
  dd=x(3)
  gt=0.
  gv=0.
  gd=0.
  t1=x(4)*tt
  v1=x(5)+vv
  d1=x(6)*dd
  goto (1,2,3,4,5) nline
  goto 1
5 t5=x(16)*tt
  v5=x(17)+vv
  d5=x(18)*dd
  g13=0.
  g14=0.
  g15=0.
  !
4 t4=x(13)*tt
  v4=x(14)+vv
  d4=x(15)*dd
  g10=0.
  g11=0.
  g12=0.
  !
3 t3=x(10)*tt
  v3=x(11)+vv
  d3=x(12)*dd
  g7=0.
  g8=0.
  g9=0.
  !
2 t2=x(7)*tt
  v2=x(8)+vv
  d2=x(9)*dd
  g4=0.
  g5=0.
  g6=0.
  !
1 g1=0.
  g2=0.
  g3=0.
  !
  !	g1 derivee / aire
  !	g2 derivee / vlsr
  !	g3 derivee / delt
  !
  ! Compute gaussians
  do 600 i=1,ndata
    if (wfit(i).eq.0.0) goto 600
    xvel = rdatax(i)
    ! First
    arg1 = (xvel - v1) / d1
    if (abs(arg1).gt.4.) then
      f1 = 0.
      ff = 0.
    else
      f1 = exp(-arg1**2)
      ff = f1 * t1 / d1
    endif
    if (nline.le.1) goto 610
    ! Second
    arg2 = (xvel - v2) / d2
    if (abs(arg2).gt.4.) then
      f2=0.
    else
      f2 = exp(-arg2**2)
      ff = ff + f2 * t2 / d2
    endif
    if (nline.le.2) goto 610
    ! Third
    arg3 = (xvel - v3) / d3
    if (abs(arg3).gt.4.) then
      f3=0.
    else
      f3 = exp(-arg3**2)
      ff = ff + f3 * t3 / d3
    endif
    if (nline.le.3) goto 610
    ! Fourth
    arg4 = (xvel - v4) / d4
    if (abs(arg4).gt.4.) then
      f4=0.
    else
      f4 = exp(-arg4**2)
      ff = ff + f4 * t4 / d4
    endif
    if (nline.le.4) goto 610
    ! Fifth
    arg5 = (xvel - v5) / d5
    if (abs(arg5).gt.4.) then
      f5=0.
    else
      f5 = exp(-arg5**2)
      ff = ff + f5 * t5 / d5
    endif
    !
610 continue
    !
    ! Compute Chi-2 with ponderation
    ff =  wfit(i) * (ff - rdatay(i))
    f = f + ff**2
    !
    ! Compute Gradients
    if (.not.dograd) goto 620
    ff = 2.*ff
    ! First
    if (f1.ne.0.) then
      arg = f1*ff/d1
      g1  = g1 + arg
      gt  = gt + arg*t1
      arg = t1/d1*arg
      g3  = g3 - arg
      gd  = gd - arg*d1
      arg = arg*arg1*2.
      g2  = g2 + arg
      gv  = gv + arg
      g3  = g3 + arg*arg1
      gd  = gd + arg*arg1*d1
    endif
    if (nline.le.1) goto 620
    ! Second
    if (f2.ne.0.) then
      arg = f2*ff/d2
      g4  = g4 + arg
      gt  = gt + arg*t2
      arg = arg*t2/d2
      g6  = g6 - arg
      gd  = gd - arg*d2
      arg = arg*arg2*2.
      g5  = g5 + arg
      gv  = gv + arg
      g6  = g6 + arg*arg2
      gd  = gd + arg*arg2*d2
    endif
    if (nline.le.2) goto 620
    ! Third
    if (f3.ne.0.) then
      arg = f3*ff/d3
      g7  = g7 + arg
      gt  = gt + arg*t3
      arg = arg*t3/d3
      g9  = g9 - arg
      gd  = gd - arg*d3
      arg = arg*arg3*2.
      g8  = g8 + arg
      gv  = gv + arg
      g9  = g9 + arg*arg3
      gd  = gd + arg*arg3*d3
    endif
    if (nline.le.3) goto 620
    ! Fourth
    if (f4.ne.0.) then
      arg = f4*ff/d4
      g10 = g10 + arg
      gt  = gt + arg*t4
      arg = arg*t4/d4
      g12 = g12 - arg
      gd  = gd - arg*d4
      arg = arg*arg4*2.
      g11 = g11 + arg
      gv  = gv + arg
      g12 = g12 + arg*arg4
      gd  = gd + arg*arg4*d4
    endif
    if (nline.le.4) goto 620
    ! Fifth
    if (f5.ne.0.) then
      arg = f5*ff/d5
      g13 = g13 + arg
      gt  = gt  + arg*t5
      arg = arg*t5/d5
      g15 = g15 - arg
      gd  = gd - arg*d5
      arg = arg*arg5*2.
      g14 = g14 + arg
      gv  = gv  + arg
      g15 = g15 + arg*arg5
      gd  = gd  + arg*arg5*d5
    endif
620 continue
  !
600 continue
  !
  ! Setup values and return
  f = f
  g(1)=gt/tt
  g(2)=gv
  g(3)=gd/dd
  !
  g(4)=g1*tt
  g(5)=g2
  g(6)=g3*dd
  goto (701,702,703,704,705) nline
701 return
705 g(16)=g13*tt
  g(17)=g14
  g(18)=g15*dd
704 g(13)=g10*tt
  g(14)=g11
  g(15)=g12*dd
703 g(10)=g7*tt
  g(11)=g8
  g(12)=g9*dd
702 g(7)=g4*tt
  g(8)=g5
  g(9)=g6*dd
  return
  !
  ! Compute Sigma after Minimisation
20 kbas=0.
  ybas=0.
  krai=0.
  yrai=0.
  seuil= sigbas/3.
  !
  do i=1,ndata
    if (wfit(i).ne.0.0) then
      ta = progauss (rdatax(i),0)
      if (abs(ta).lt.seuil) then
        kbas=kbas+wfit(i)
        ybas=ybas+wfit(i)*rdatay(i)**2
      else
        krai=krai+wfit(i)
        yrai=yrai+wfit(i)*(ta-rdatay(i))**2
      endif
    endif
  enddo
  if (kbas.gt.2.0) then
    sigbas = sqrt(ybas/kbas)
  else
    sigbas=0.d0
  endif
  if (krai.ne.0.0) then
    sigrai=sqrt(yrai/krai)
  else
    sigrai=sigbas
  endif
  if (sigbas.eq.0.0) sigbas = sigrai
  return
end subroutine mingauss
!
function progauss (a,m)
  !---------------------------------------------------------------------
  ! ANALYSE	(Internal routine)
  !	M = 0
  ! 	Computes the composite profile from sum of all gaussians.
  !	M # 0
  !	Computes the profile from gaussian number M
  !
  ! S. Guilloteau 19-Dec-1984
  !---------------------------------------------------------------------
  real*4 :: progauss                !
  real*4 :: a                       !
  integer :: m                      !
  ! Global
  include 'clic_gauss.inc'
  ! Local
  real*4 :: arg
  !
  progauss=0.
  arg=0.
  goto (1,2,3,4,5) m
  !
1 if (par(1).ne.0 .and. par(3).ne.0.) then
    arg = abs((a - par(2)) / par(3)*1.665109)
    if (arg.lt.4.) then
      progauss = exp(-arg**2)*par(1)/par(3)/1.064467
    endif
  endif
  if (ngline.le.1 .or. m.eq.1) return
  !
2 if (par(4).ne.0 .and. par(6).ne.0.) then
    arg = abs((a - par(5)) / par(6)*1.665109)
    if (arg.lt.4.) then
      progauss = progauss + exp(-arg**2)*par(4)/par(6)/1.064467
    endif
  endif
  if (ngline.le.2 .or. m.eq.2) return
  !
3 if (par(7).ne.0 .and. par(9).ne.0.) then
    arg = abs((a - par(8)) / par(9)*1.665109)
    if (arg.lt.4.) then
      progauss = progauss + exp(-arg**2)*par(7)/par(9)/1.064467
    endif
  endif
  if (ngline.le.3 .or. m.eq.3) return
  !
4 if (par(10).ne.0. .and. par(12).ne.0.) then
    arg = abs((a - par(11)) / par(12)*1.665109)
    if (arg.lt.4.) then
      progauss = progauss + exp(-arg**2)*par(10)/par(12)/1.064467
    endif
  endif
  if (ngline.le.4 .or. m.eq.4) return
  !
5 if (par(13).ne.0. .and. par(15).ne.0.) then
    arg = abs((a - par(14)) / par(15)*1.665109)
    if (arg.lt.4.) then
      progauss = progauss + exp(-arg**2)*par(13)/par(15)/1.064467
    endif
  endif
end function progauss
!
subroutine inigauss
  !---------------------------------------------------------------------
  ! CLIC 	Internal routine
  !	Start a gaussian fit by building the PAR array
  !---------------------------------------------------------------------
  ! Global
  external :: progauss
  real :: progauss
  include 'clic_gauss.inc'
  include 'clic_gaussdata.inc'
  ! Local
  real :: ybas
  real :: sym, ym, swy, swxy, swx2y
  integer :: i, kbas
  !
  ! Starting values : Automatic guess
  ! works also if several points coincide in x (focus scans).
  sym = 0
  ym = 0
  swxy = 0
  swx2y = 0
  swy = 0
  do i=1, ndata
    swy = swy + wfit(i)*rdatay(i)
    swxy = swxy + wfit(i)*rdatax(i)*rdatay(i)
    swx2y = swx2y + wfit(i)*rdatax(i)**2*rdatay(i)
  enddo
  if (swy.ne.0) then
    swxy = swxy / swy
    swx2y = sqrt(8*log(2.) * abs(swx2y / swy - swxy**2))
  endif
  do i=1, ndata
    if (abs(rdatax(i)-swxy).le.swx2y) then
      ym = ym+rdatay(i)*wfit(i)
      sym = sym+wfit(i)
    endif
  enddo
  if (sym.ne.0) then
    ym = ym/sym
  endif
  swy = 2 * ym * swx2y
  par(1) = swy
  par(2) = swxy
  par(3) = swx2y
  !
  ! Compute sigmas
  kbas=0
  ybas=0.
  do i=1,ndata
    if (wfit(i).ne.0.0) then
      ybas = ybas + (rdatay(i)-progauss(rdatax(i),0))**2
      kbas = kbas+1
    endif
  enddo
  if (kbas.gt.0) then
    sigbas=sqrt(ybas/kbas)
  else
    sigbas = 0
  endif
  sigrai=sigbas
end subroutine inigauss

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_obsolete_opt
  use cubetools_parameters
  use cubesyntax_messaging
  use cubetools_primitive_opt
  use cubetools_structure_main
  !
  public :: obsolete_opt_t
  public :: cubetools_register_obsolete_opt
  private
  !
  type, extends(primitive_opt_t) :: obsolete_opt_t
    character(len=11) :: date  ! Obsolescence date e.g. 01-JAN-1970
  contains
    procedure :: register => cubetools_register_obsolete_opt
  end type obsolete_opt_t
  !
contains
  !
  subroutine cubetools_register_obsolete_opt(template,name,help,date,error)
    !----------------------------------------------------------------------
    ! Register an option of exact type obsolete_opt_t in the global 'pack'
    !----------------------------------------------------------------------
    class(obsolete_opt_t), intent(in)    :: template
    character(len=*),      intent(in)    :: name
    character(len=*),      intent(in)    :: help
    character(len=*),      intent(in)    :: date
    logical,               intent(inout) :: error
    !
    class(primitive_opt_t), pointer :: actualopt
    type(obsolete_opt_t), pointer :: oopt
    !
    ! Note: the pointer to the option is not returned to the caller as
    ! there is no need to use it for parsing
    call cubetools_register_primitive_opt(template,name,strg_emp,strg_emp,  &
      help,actualopt,error)
    if (error)  return
    oopt => cubetools_obsolete_opt_ptr(actualopt,error)
    if (error)  return
    !
    oopt%date           =  date
    oopt%check          => cubetools_option_check_execute
    oopt%build_syntax   => cubetools_option_build_syntax
    oopt%print_abstract => cubetools_option_print_abstract
  end subroutine cubetools_register_obsolete_opt
  !
  function cubetools_obsolete_opt_ptr(pot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(obsolete_opt_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    type(obsolete_opt_t), pointer :: cubetools_obsolete_opt_ptr  ! Function value on return
    class(primitive_opt_t), target, intent(in)    :: pot
    logical,                        intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>PTR'
    !
    select type(pot)
    type is (obsolete_opt_t)
      cubetools_obsolete_opt_ptr => pot
    class default
      cubetools_obsolete_opt_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a obsolete_opt_t type')
      error = .true.
      return
    end select
  end function cubetools_obsolete_opt_ptr
  !
  subroutine cubetools_option_check_execute(opt,command,line,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Obsolete option must not be present on the command line. If yes,
    ! raise an error with appropriate message.
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)   :: opt
    character(len=*),       intent(in)    :: command  ! Command name (for proper feedback)
    character(len=*),       intent(in)    :: line
    logical,                intent(inout) :: error
    !
    logical :: present
    type(obsolete_opt_t), pointer :: oopt
    character(len=*), parameter :: rname='OPTION>CHECK>EXECUTE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%present(line,present,error)
    if (error) return
    if (.not.present)  return
    !
    oopt => cubetools_obsolete_opt_ptr(opt,error)
    if (error)  return
    !
    call cubesyntax_message(seve%e,rname,  &
      '/'//trim(opt%name)//' is obsolete since '//oopt%date)
    call oopt%help(error)
    if (error)  return
    !
    ! Raise error to stop parsing
    error = .true.
    return
  end subroutine cubetools_option_check_execute
  !
  subroutine cubetools_option_build_syntax(opt,syntax,lprint,lnoprint,error)
    !-------------------------------------------------------------------
    !  Return empty (=> invisible) syntax for obsolete option
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(out)   :: syntax
    integer(kind=4),        intent(out)   :: lprint    ! Number of printable characters
    integer(kind=4),        intent(out)   :: lnoprint  ! Number of non-printable characters
    logical,                intent(inout) :: error
    !
    syntax = ' '
    lprint = 0
    lnoprint = 0
  end subroutine cubetools_option_build_syntax
  !
  subroutine cubetools_option_print_abstract(opt,error)
    !----------------------------------------------------------------------
    !  Print nothing for an obsolete option
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    return
  end subroutine cubetools_option_print_abstract
end module cubetools_obsolete_opt
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK PIMACH
      FUNCTION PIMACH (DUM)
C***BEGIN PROLOGUE  PIMACH
C***SUBSIDIARY
C***PURPOSE  Subsidiary to HSTCSP, HSTSSP and HWSCSP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (PIMACH-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subprogram supplies the value of the constant PI correct to
C     machine precision where
C
C     PI=3.1415926535897932384626433832795028841971693993751058209749446
C
C***SEE ALSO  HSTCSP, HSTSSP, HWSCSP
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  PIMACH
C
C***FIRST EXECUTABLE STATEMENT  PIMACH
      PIMACH = 3.14159265358979
      RETURN
      END

function gag_hasins(mdim,pf,pn,dict,name,in)
  use gsys_interfaces, except_this=>gag_hasins
  !---------------------------------------------------------------------
  ! @ public
  !  *** This version for dictionaries as character string arrays ***
  !       Insert a new name or replace an existing name
  !       in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       GAG_HASINS      0       E  Invalid name
  !                       1       S  Successfully inserted
  !                       2       E  Too many names
  !                       3       S  Successfully replaced
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_hasins  ! Function value on return
  integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),  intent(inout) :: pf(0:27)    !
  integer(kind=4),  intent(inout) :: pn(mdim)    !
  character(len=*), intent(inout) :: dict(mdim)  ! Dictionnary array of size MDIM
  character(len=*), intent(inout) :: name        ! Name to be inserted
  integer(kind=4),  intent(out)   :: in          ! Address of this name
  ! Local
  integer(kind=4) :: j,k
  !
  in = 0
  gag_hasins = 0
  !
  ! Find the place in PF
  call sic_upper(name)
  j = ichar(name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Find if it exits already
  k = pf(j)
  do while(k.gt.0)
    if (name.eq.dict(k)) then
      in = k
      gag_hasins = 3
      return
    endif
    k = pn(k)
  enddo
  !
  ! Find if place left
  if (pf(26).eq.0) then
    gag_hasins = 2
  else
    !
    ! Insert NAME in place and set pointers
    k = pf(26)
    pf(26) = pn(k)
    pn(k) = pf(j)
    pf(j) = k
    dict(k) = name
    in = k
    pf(27) = pf(27)+1
    gag_hasins = 1
  endif
end function gag_hasins
!
subroutine gag_hasini(mdim,pf,pn)
  !---------------------------------------------------------------------
  ! @ public
  ! SIC   Internal routine
  !  *** This version for all kind of dictionaries ***
  !       Initialise a hashing structure for a possible dictionnary.
  ! Arguments :
  !       MDIM    I       Size of dictionnary
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.
  !                       PF(27) the number of symbol
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: mdim      !
  integer(kind=4), intent(out) :: pf(0:27)  !
  integer(kind=4), intent(out) :: pn(mdim)  !
  ! Local
  integer(kind=4) :: i
  !
  do i=0,25
    pf(i) = 0
  enddo
  pf(26) = 1
  pf(27) = 0
  do i=1,mdim-1
    pn(i) = i+1
  enddo
  pn(mdim) = 0
end subroutine gag_hasini
!
function gag_hasdel(mdim,pf,pn,dict,name)
  use gsys_interfaces, except_this=>gag_hasdel
  !---------------------------------------------------------------------
  ! @ public
  !  *** This version for dictionaries as character string arrays ***
  !       Delete a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       GAG_HASDEL      1       Name deleted
  !                       3       Name does not exist
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_hasdel  ! Function value on return
  integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),  intent(inout) :: pf(0:27)    !
  integer(kind=4),  intent(inout) :: pn(mdim)    !
  character(len=*), intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  character(len=*), intent(inout) :: name        ! Name to be deleted
  ! Local
  integer(kind=4) :: j,kl,k
  !
  gag_hasdel = 3
  ! Find the place in PF
  call sic_upper(name)
  j = ichar(name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine if it is a known symbol
  kl = 0
  k = pf(j)
10 if (k.eq.0) return
  if (name.ne.dict(k)) then
    kl = k
    k = pn(k)
    goto 10
  endif
  !
  ! Now delete it
  gag_hasdel = 1
  if (kl.ne.0) then
    pn(kl) = pn(k)
  else
    pf(j) = pn(k)
  endif
  pn(k) = pf(26)
  pf(26) = k
  pf(27) = pf(27)-1
end function gag_hasdel
!
function gag_hasfin(mdim,pf,pn,dict,name,in)
  use gsys_interfaces, except_this=>gag_hasfin
  !---------------------------------------------------------------------
  ! @ public
  !  *** This version for dictionaries as character string arrays ***
  !       Find a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       GAG_HASFIN      0       No such name
  !                       1       Name found
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_hasfin  ! Function value on return
  integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),  intent(in)    :: pf(0:27)    !
  integer(kind=4),  intent(in)    :: pn(mdim)    !
  character(len=*), intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  character(len=*), intent(inout) :: name        ! Name to be found
  integer(kind=4),  intent(out)   :: in          ! Address of this name
  ! Local
  integer(kind=4) :: j
  !
  ! If no symbol return
  in = 0
  gag_hasfin = 0
  if (pf(27).eq.0) return
  !
  ! Find the place in PF
  call sic_upper(name)
  j = ichar(name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine the chained structure from this point
  j = pf(j)
10 if (j.eq.0) return
  if (name.eq.dict(j)) then
    in = j
    gag_hasfin = 1
    return
  endif
  j = pn(j)
  goto 10
end function gag_hasfin
!
subroutine gag_haslis(mdim,pf,pn,list,leng)
  !---------------------------------------------------------------------
  ! @ public
  !  *** This version for all kind of dictionaries ***
  !
  !  List a dictionnary using a hashing structure and a list of pointers.
  ! This routine just builds the list of pointers to current entries.
  !
  ! THERE IS NO WARRANTY THE OUTPUT LIST IS SORTED ALPHABETICALLY.
  ! Actually with the current hashing method, the output list is sorted
  ! by first letter only. Use subroutine gag_hassort for a fully sorted
  ! list.
  !
  !   PF(0:27)   PF(0:25) Address of first name beginning with
  !                       CHAR(J-ICHAR('A')) in dictionnary.
  !              PF(26)   is the address of the first available place.
  !              PF(27)   the number of symbols
  !   PN(MDIM)            Address of next name with same first letter.
  !                       If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: mdim        ! Size of dictionnary
  integer(kind=4), intent(in)  :: pf(0:27)    !
  integer(kind=4), intent(in)  :: pn(mdim)    !
  integer(kind=4), intent(out) :: list(mdim)  ! List of entries in dictionnary
  integer(kind=4), intent(out) :: leng        ! Current number of entries
  ! Local
  integer(kind=4) :: i,j
  !
  leng = 0
  if (pf(27).eq.0) return
  do i=0,25
    if (pf(i).le.0)  cycle
    j = pf(i)
    leng = leng+1
    list(leng) = j
    do while (pn(j).gt.0)
      j = pn(j)
      leng = leng+1
      list(leng) = j
    enddo
  enddo
end subroutine gag_haslis

program histo_table
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Main program for making a cross Histogram from two columns of a
  ! table
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='HISTO_TABLE'
  character(len=filename_length) :: namey,namex
  logical :: error
  real(kind=4) :: hzmin,hzmax,hzstep, hymin,hymax,hystep
  integer(kind=4) :: n,nhz,nhy,nco(2),ier
  real(kind=4), allocatable :: xdata(:,:), yd1(:), yd2(:)
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_inte('Y_COLUMNS$',nco,2)
  call gildas_inte('BINS1$',nhz,1)
  call gildas_real('MIN1$',hzmin,1)
  call gildas_real('MAX1$',hzmax,1)
  call gildas_inte('BINS2$',nhy,1)
  call gildas_real('MIN2$',hymin,1)
  call gildas_real('MAX2$',hymax,1)
  call gildas_char('X_NAME$',namex)
  call gildas_close
  !
  ! Map input table
  call gildas_null(y)
  y%gil%ndim = 2
  call sic_parse_file(namey,' ','.tab',y%file)
  call gdf_read_header(y,error)
  if (error) goto 100
  if (nco(1).lt.1 .or. nco(1).gt.y%gil%dim(2) .or.  &
      nco(2).lt.1 .or. nco(2).gt.y%gil%dim(2)) then
    write(6,*) 'Input columns out of range 1 -',y%gil%dim(2)
    goto 100
  endif
  !
  ! Define output histogram
  call gildas_null(x)
  n = len_trim(namex)
  if (n.eq.0) goto 100
  call sic_parse_file(namex(1:n),' ','.gdf',x%file)
  hzstep = (hzmax-hzmin)/(nhz-1)
  hystep = (hymax-hymin)/(nhy-1)
  !
  x%gil%ndim = 2
  x%gil%dim(1) = nhz
  x%gil%dim(2) = nhy
  x%gil%dim(3) = 1
  x%gil%dim(4) = 1
  x%gil%coor_words = 6*gdf_maxdims
  x%gil%convert(1,1) = 1.0
  x%gil%convert(2,1) = hzmin
  x%gil%convert(3,1) = hzstep
  x%gil%convert(1,2) = 1.0
  x%gil%convert(2,2) = hymin
  x%gil%convert(3,2) = hystep
  x%gil%extr_words = 0
  x%gil%spec_words = 0
  x%gil%blan_words = 2
  x%gil%desc_words = def_desc_words
  x%gil%proj_words = 0
  x%gil%bval = 0.d0
  x%gil%eval = -1.d0
  x%char%code(1) = 'UNKNOWN     '
  x%char%code(2) = 'UNKNOWN     '
  x%char%code(3) = 'UNKNOWN     '
  x%char%code(4) = 'UNKNOWN     '
  x%char%unit    = 'PIXELS      '
  !
  ! Change boundaries
  hzmin = hzmin - 0.5*hzstep
  hzmax = hzmax + 0.5*hzstep
  hymin = hymin - 0.5*hystep
  hymax = hymax + 0.5*hystep
  allocate(xdata(x%gil%dim(1),x%gil%dim(2)),stat=ier)
  if (failed_allocate(rname,'output buffer',ier,error))  goto 100
  allocate(yd1(y%gil%dim(1)),yd2(y%gil%dim(1)),stat=ier)
  if (failed_allocate(rname,'input buffers',ier,error))  goto 100
  !
  y%blc(2) = nco(1)
  y%trc(2) = nco(1) 
  call gdf_read_data(y,yd1,error)
  if (error)  goto 100
  !
  y%blc(2) = nco(2)
  y%trc(2) = nco(2)
  call gdf_read_data(y,yd2,error)
  if (error)  goto 100
  !
  call histo004(yd1,yd2,y%gil%dim(1),0.0,-1.0,hzmin,hzstep,hzmax,hymin,  &
    hystep,hymax,x%gil%dim(1),x%gil%dim(2),xdata)
  !
  call gdf_write_image(x,xdata,error)
  if (error)  goto 100
  call gagout('S-HISTO_TABLE,  Successful completion')
  call sysexi(1)
  !
100 call sysexi(fatale)
end program histo_table
!
subroutine histo004(z,y,nl,bval,eval,pzmin,pzstep,pzmax,pymin,pystep,  &
  pymax,nhz,nhy,h)
  use gildas_def
  !---------------------------------------------------------------------
  ! Compute the crossed histogram map of two columns of a table.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nl          ! Number of lines
  real(kind=4),               intent(in)  :: z(nl)       ! First input column address
  real(kind=4),               intent(in)  :: y(nl)       ! Second input column address
  real(kind=4),               intent(in)  :: bval        ! Blanking value
  real(kind=4),               intent(in)  :: eval        ! Tolerance on blanking
  real(kind=4),               intent(in)  :: pzmin       ! Low threshold for Z input array
  real(kind=4),               intent(in)  :: pzstep      ! Histogram step for Z input array
  real(kind=4),               intent(in)  :: pzmax       !
  real(kind=4),               intent(in)  :: pymin       ! Low threshold for Y input array
  real(kind=4),               intent(in)  :: pystep      ! Histogram step for Y input array
  real(kind=4),               intent(in)  :: pymax       !
  integer(kind=index_length), intent(in)  :: nhz         ! First dimension for histogram array
  integer(kind=index_length), intent(in)  :: nhy         ! Second dimension for histogram array
  real(kind=4),               intent(out) :: h(nhz,nhy)  ! Histogram array
  ! Local
  integer(kind=index_length) :: i
  integer(kind=4) :: iz,jy,nin,nout,nblank,ntot
  !
  h = 0.0
  nin = 0
  nout = 0
  nblank = 0
  !
  if (eval.ge.0.0) then
    !
    do i=1,nl
      if (abs(z(i)-bval).gt.eval .and.   &
          abs(y(i)-bval).gt.eval) then
        if (z(i).ge.pzmin .and. z(i).lt.pzmax) then
          iz = int((z(i)-pzmin)/pzstep) + 1
          if (y(i).ge.pymin .and. y(i).lt.pymax) then
            jy = int((y(i)-pymin)/pystep) + 1
            h(iz,jy) = h(iz,jy)+1.0
            nin = nin+1
          else
            nout = nout+1
          endif
        else
          nout = nout+1
        endif
      else
        nblank = nblank+1
      endif
    enddo
    !
  else
    !
    do i=1,nl
      if (z(i).ge.pzmin .and. z(i).lt.pzmax) then
        iz = int((z(i)-pzmin)/pzstep) + 1
        if (y(i).ge.pymin .and. y(i).le.pymax) then
          jy = int((y(i)-pymin)/pystep) + 1
          h(iz,jy) = h(iz,jy)+1.0
          nin = nin+1
        else
          nout = nout+1
        endif
      else
        nout = nout+1
      endif
    enddo
    !
  endif
  !
  ntot = nin+nout+nblank
  write(6,100) nin,float(nin)/float(ntot)*1.e2,   &
               nout,float(nout)/float(ntot)*1.e2,   &
               nblank,float(nblank)/float(ntot)*1.e2,   &
               ntot
100 format(1x,'Number of points in histogram ',i12,4x,f5.1,' %',   &
            /,'  "    "    "    out of  "    ',i12,4x,f5.1,' %',  &
            /,'  "    "    "    blanked      ',i12,4x,f5.1,' %',  &
            /,'                 Total      = ',i12)
end subroutine histo004

!     
!     $Id$
!    
! <DOCUMENTATION name="modulePakoXML">
!  This module implements a simple interface to write information
!  to a VOTable XML file.  It is in particular adapted for pako
!  (the observer's user interface to the NCS). pako uses it to
!  write XML files for the Queue and Coordinator. 
!  Data processing software can use it to write results XML files
!  for pako.
! </DOCUMENTATION>
!
! <DEV> 
! TBD: - more documentation
!      - more elaborate error handling
!          - parameter "error" (error flag) should be Optional
!            in all routines
!          - general error codes per Character variable errorC
!            are foreseen, but only in a few cases implemented,
!             e.g., in pakoXMLdictionaryAdd pakoXMLpush pakoXMLpop
!      - use linked lists for lists
!      - more fundamental "abstract" routines independant
!        of VOTable XML
!      - ...
! <\DEV> 
!
Module modulePakoXML
  !     
  Use modulePakoMessages
!
  Implicit None
  Save
  Private
  !
  ! *** Subroutines
  !
  Public :: pakoXMLsetOutputUnit
  Public :: pakoXMLsetIndent
  !
  Public :: pakoXMLwriteStartXML
  Public :: pakoXMLwriteStartElement
  Public :: pakoXMLwriteEndElement
  Public :: pakoXMLwriteElement
  !
  Public :: pakoXMLcase
  Public :: pakoXMLupper
  !     
  ! *** values representing "not set":
  !
  !
  Character(len=8),  Parameter  :: cNone = 'none'
  Integer,           Parameter  :: iNone = 0
  Real,              Parameter  :: rNone = 0.0
  Real(Kind=8),      Parameter  :: dNone = 0.0D0
  !
  ! *** Variables  for XML ***
  !
  Integer :: outputUnitXML = iNone
  Integer :: levelXML      = iNone
  Integer :: indentXML     = iNone
  !
  Integer, Parameter  :: lWord    = 128
  Integer, Parameter  :: lPhrase  = 256
  Integer, Parameter  :: lLine    = 512
  Integer, Parameter  :: lLineOut = 1024
  Character(len=lWord)    :: word    = cNone
  Character(len=lPhrase)  :: phrase  = cNone
  Character(len=lLine)    :: line    = cNone
  Character(len=lLine)    :: line2   = cNone
  Character(len=lLineOut) :: lineOut = cNone
  !
  ! *** dictionary for mixedCase keyword values:
  ! TBD: turn this into a linked list
  !
  Integer, Parameter  :: lDict   = 12
  !
  Type :: pakoXMLdictionaryT
     Character(len=ldict) :: key     = cNone
     Character(len=lDict) :: value   = cNone
  End Type pakoXMLdictionaryT
  !
  Integer, Parameter  :: nDimDict = 999
  Integer             :: nDict    = iNone
  Type (pakoXMLdictionaryT), Dimension(nDimDict) :: pakoDict
  !
  ! *** working variables and constants ***
  !     standard constants
  Real,    Parameter  :: Pi=3.141592653589793
  Real,    Parameter  :: degs=Pi/180.0
  !
  ! *** "stack" of elements
  ! TBD:  in future: replace this by a linked list!
  !
  Integer, Parameter  :: lEl   =  24
  Integer, Parameter  :: lText = 256
  !
  Type :: pakoXMLelementT
     Character(len=lEl)   ::  element  = cNone
     Character(len=lEl)   ::  name     = cNone
     Character(len=lEl)   ::  comment  = cNone
     Logical              ::  doCdata  = .False.
     Character(len=lEl)   ::  space    = cNone
     Character(len=lEl)   ::  value    = cNone
     Character(len=lEl)   ::  unit     = cNone
     Character(len=lEl)   ::  dataType = cNone
     Character(len=lText) ::  text     = cNone
  End Type pakoXMLelementT
  !
  Integer, Parameter :: nDimStack = 99
  Integer            :: nStack    = iNone
  Type (pakoXMLelementT), Dimension(nDimStack) :: stack
  Type (pakoXMLelementT)                       :: elementNone
  !
  ! *** for error messages:
  !
  Integer, Parameter :: severityI = 1
  Integer, Parameter :: severityW = 2
  Integer, Parameter :: severityE = 3
  Integer, Parameter :: severityF = 4
  !
  Integer, Parameter :: priorityI = severityI*2
  Integer, Parameter :: priorityW = severityW*2
  Integer, Parameter :: priorityE = severityE*2
  Integer, Parameter :: priorityF = severityF*2
  !
Contains
!!!     
!!!
  Subroutine pakoXMLsetOutputUnit(iUnit, error)
    Integer,  Intent(IN),  Optional :: iUnit
    Logical,  Intent(OUT), Optional :: error              ! errorFlag
    ! <DOCUMENTATION name="pakoXMLsetOutputUnit">
    ! set unit number for XML output.
    ! all XML output will be written to the file attached to iUnit
    ! </DOCUMENTATION>
    !
    if (Present(error)) error = .False.
    !
    If (Present(iUnit)) Then
       outputUnitXML = iUnit
    Else
       outputUnitXML = 11
    End If
    !
  End Subroutine pakoXMLsetOutputUnit
!!!
!!!
  Subroutine pakoXMLsetIndent(iIndent, error)
    Integer, Intent(IN),  Optional :: iIndent
    Logical, Intent(OUT), Optional :: error              ! errorFlag
    ! <DOCUMENTATION name="pakoXMLsetIndent">
    ! set indent for XML output.
    ! each nesting level of the XML hierarchy 
    ! will be indented by iIndent characters
    ! </DOCUMENTATION>
    !
    if (Present(error)) error = .False.
    !
    If (Present(iIndent)) Then
       indentXML = iIndent
    Else
       indentXML = 1
    End If
    !
  End Subroutine pakoXMLsetIndent
!!!
!!!
  Subroutine pakoXMLsetLevel(iLevel)
    Integer, Intent(IN) :: iLevel
    ! <DOCUMENTATION name="pakoXMLsetLevel">
    ! internal pakoXML routine
    ! set level of XML nesting to iLevel
    ! </DOCUMENTATION>
    !
    If (iLevel.Ge.1) Then
       levelXML = iLevel
    End If
    !
  End Subroutine pakoXMLsetLevel
!!!
!!!
  Subroutine pakoXMLwriteStartXML(                                &
       &                                       xmlVersionNum,     &
       &                                       docTypeName,       &
       &                                       dtdFile,           &
       &                                       dtdVersion,        &
       &                                       comment,           &
       &                                       space,             &
       &                                       error,             &
       &                                       errorC             &
       &                         )
    !
    Character(len=*), Intent(IN),  Optional :: xmlVersionNum      ! XML Version Number
    Character(len=*), Intent(IN)            :: docTypeName        ! document Type
    Character(len=*), Intent(IN)            :: dtdFile            ! DTD file
    Character(len=*), Intent(IN)            :: dtdVersion         ! DTD version
    Character(len=*), Intent(IN),  Optional :: comment            ! XML comment
    Character(len=*), Intent(IN),  Optional :: space              ! add space before or after
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLwriteStartXML">
    ! Write start of XML file
    ! </DOCUMENTATION>
    !     
    Type (pakoXMLelementT) :: elementToStack
    !    
    error = .False.
    If(Present(errorC)) errorC="OK"
    !
    elementToStack = elementNone
    !
    Call pakoXMLdictionaryInit(error)
    Call pakoXMLsetLevel(1)
    !
    If (Present(xmlVersionNum)) Then
       line = '<?xml version="'//                                 &
            &     xmlVersionNum(1:Len_trim(xmlVersionNum))//'"?>'
    Else
       line = '<?xml version="1.0"?>'
    End If
    Call pakoXMLwriteLine(line,error)
    !
    line = '<!DOCTYPE '//                                         &
         &     docTypeName(1:Len_trim(docTypeName))//' '//        &
         &     'SYSTEM "'//dtdFile(1:Len_trim(dtdFile))//'">'
    Call pakoXMLwriteLine(line,error)
    !
    elementToStack%element  = docTypeName(1:Len_trim(docTypeName))
    line = '<'//docTypeName(1:Len_trim(docTypeName))//' '//       &
         &   'version="'//dtdVersion(1:Len_trim(dtdVersion))//'">'
    Call pakoXMLwriteLine(line,error)
    !
    If (Present(comment)) Then
       line = '<!-- '//comment(1:Len_trim(comment))//' -->'
       Call pakoXMLwriteLine(line,error)
    End If
    !
    lineOut = ''
    Write (outputUnitXML,'(A)') lineOut(1:Len_trim(lineOut))        
    !
    Call pakoXMLpush(elementToStack,pushError=error)
    !
    Return
    !
  End Subroutine pakoXMLwriteStartXML
!!!
!!!
  Subroutine pakoXMLwriteStartElement(                            &
       &                                       element,           &
       &                                       name,              &
       &                                       comment,           &
       &                                       doCdata,           &
       &                                       doSpace,           &
       &                                       space,             &
       &                                       error,             &
       &                                       errorC             &
       &                             )
    !
    Character(len=*), Intent(IN)            :: element            ! XML element
    Character(len=*), Intent(IN),  Optional :: name               ! attribute "name"
    Character(len=*), Intent(IN),  Optional :: comment            ! XML comment
    Logical,          Intent(IN),  Optional :: doCdata            ! add start of CDATA
    Logical,          Intent(IN),  Optional :: doSpace            ! !obsolete!
    Character(len=*), Intent(IN),  Optional :: space              ! add space before or after
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLwriteStartElement">
    ! write start tag of an XML element that will have several lines
    ! of content, maybe including nested elements;
    ! information about this element is pushed on the stack.
    ! </DOCUMENTATION>
    !
    Type (pakoXMLelementT) :: elementToStack
    !    
    error  = .False.
    If(Present(errorC)) errorc="OK"
    !
    elementToStack          = elementNone
    elementToStack%element  = element
    !
    Call pakoXMLsetLevel(levelXML+1)
    !
    If (Present(space).And.                                       &
         &        index(space,'before').Ge.1) Then
       elementToStack%space = space
       Write (outputUnitXML,'(A)') ''
    End If
    !
    line = '<'//element(1:Len_trim(element))
    If (Present(name)) Then
       elementToStack%name  = name
       line = line(1:Len_trim(line))//                            &
            &      ' name="'//name   (1:Len_trim(name  ))//'"'
    End If
    line = line(1:Len_trim(line))//'>'
    If (Present(comment)) Then
       elementToStack%comment = comment
       line = line(1:Len_trim(line))//                            &
            &      ' <!-- '//comment(1:Len_trim(comment))//' -->'
    End If
    Call pakoXMLwriteLine(line,error)
    !
    If (Present(doSpace)) Then
       if(doSpace) then
          Write (outputUnitXML,'(A)') ''
       End If
    End If
    !
    If (Present(space).And.                                       &
         &        index(space,'after').Ge.1) Then
       elementToStack%space = space
       Write (outputUnitXML,'(A)') ''
    End If
    !
    If (Present(doCdata)) Then
       if (doCdata) then
          elementToStack%doCData = doCData
          Write (outputUnitXML,*) '<![CDATA['
       End If
    End If   
    !
    Call pakoXMLpush(elementToStack,pushError=error)
    !
    Return
    !
  End Subroutine pakoXMLwriteStartElement
!!!
!!!
  Subroutine pakoXMLwriteEndElement(                              &
       &                                       element,           &
       &                                       name,              &
       &                                       doCdata,           &
       &                                       doSpace,           &
       &                                       space,             &
       &                                       error,             &
       &                                       errorC             &
       &                            )
    !
    Character(len=*), Intent(IN),  Optional :: element            ! XML element
    Character(len=*), Intent(IN),  Optional :: name               ! attribute "name"
    Logical,          Intent(IN),  Optional :: doCdata            ! add end of CDATA
    Logical,          Intent(IN),  Optional :: doSpace            ! !Obsolete!
    Character(len=*), Intent(IN),  Optional :: space              ! add space before or after
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLwriteEndElement">
    ! write end of an element
    !   element and name are optional and used for a consistency
    !   check against the information poped from the stack; if they 
    !   don't match, warning messages are generated; anyhow, the 
    !   information FROM THE STACK is used to write XML
    ! </DOCUMENTATION>
    !
    Character(len=128) :: errorM
    !
    Integer :: length
    !     
    Type (pakoXMLelementT) :: eFS                                 ! element From Stack
    !    
    error  = .False.
    errorM = 'OK'
    !
    eFS  = elementNone
    Call pakoXMLpop(eFS,popError=error)
    !
    If (Present(element)) Then
       If (element   (1:Len_trim(element))      .Ne.              &
            &          eFS%element(1:Len_trim(eFS%element))) Then
          error  = .True.
          errorM = 'EndElement. inconsistent element: "'          &
               &    //element(1:Len_trim(element))                &
               &    //'". I expected: "'                          &
               &    //eFS%element(1:Len_trim(eFS%element))//'"'
          Call PakoMessage(priorityE,severityE,                       &
               &                      'XMLwrite',errorM)
       End If
       If (Present(name).And.                                     &
            &           name    (1:Len_trim(name))      .Ne.      &
            &           eFS%name(1:Len_trim(eFS%name))) Then
          error  = .True.
          errorM = 'EndElement. inconsistent name: "'             &
               &    //name(1:Len_trim(name))                      &
               &    //'". I expected: "'                          & 
               &    //eFS%name(1:Len_trim(eFS%name))//'"'
          Call PakoMessage(priorityE,severityE,                       &
               &                      'XMLwrite',errorM)
       End If
    End If
    !
    If (eFS%doCdata) Then
       Write (outputUnitXML,*) ']]>'
    End If
    !
    If (Present(space).And.                                       &
         &        index(space,'before').Ge.1) Then
       Write (outputUnitXML,'(A)') ''
    End If
    !
    line = '</'//eFS%element(1:Len_trim(eFS%element))//'>'
    If (eFS%name.Ne.elementNone%name) Then
       line = line(1:Len_trim(line))//                            &
            &      ' <!-- name="'                                 &
            & //eFS%name(1:Len_trim((eFS%name)))//'" -->'
    End If
    Call pakoXMLwriteLine(line,error)
    !
    If (index(eFS%space,'after') .Ge. 1) Then
       Write (outputUnitXML,'(A)') ''
    End If
    !
    If (Present(space).And.                                       &
         &        index(space,'after').Ge.1) Then
       Write (outputUnitXML,'(A)') ''
    End If
    !
    Call pakoXMLsetLevel(levelXML-1)
    !
    If (Present(errorC)) Then
       length = Min(Len(errorM),Len(errorC))
       errorC(1:length) = errorM(1:length)
    End If
    !
    Return
    !
  End Subroutine pakoXMLwriteEndElement
!!!
!!!
  Subroutine pakoXMLwriteElement(                                 &
       &                                       element,           &
       &                                       name,              &
       &                                       value,             &
       &                                       unit,              &
       &                                       dataType,          &
       &                                       comment,           &
       &                                       text,              &
       &                                       content,           &
       &                                       space,             &
       &                                       error,             &
       &                                       errorC             &
       &                        )
    !
    Character(len=*), Intent(IN)            :: element            ! XML element
    Character(len=*), Intent(IN),  Optional :: name               ! attribute "name"
    Character(len=*), Intent(IN),  Optional :: value              ! attribute "value"
    Character(len=*), Intent(IN),  Optional :: unit               ! attribute "unit"
    Character(len=*), Intent(IN),  Optional :: dataType           ! attribute "dataType"
    Character(len=*), Intent(IN),  Optional :: comment            ! XML comment
    Character(len=*), Intent(IN),  Optional :: text               ! !OBSOLETE!
    Character(len=*), Intent(IN),  Optional :: content            ! content of element
    Character(len=*), Intent(IN),  Optional :: space              ! add space before or after
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLwriteElement">
    ! write an element that fits in one line
    ! </DOCUMENTATION>
    !
    Integer :: length
    !     
    error = .False.
    If(Present(errorC)) errorc="OK"
    !
    Call pakoXMLsetLevel(levelXML+1)
    !
    If (Present(space).And.                                       &
         &        index(space,'before').Ge.1) Then
       lineOut = ''
       Write (outputUnitXML,'(A)') lineOut(1:Len_trim(lineOut))        
    End If
    !
    line = '<'//element(1:Len_trim(element))
    !
    If (Present(name)) Then
       line = line(1:Len_trim(line))//                            &
            &               ' name="'//name(1:Len_trim(name))//'"'   
    End If
    !
    If (Present(value)) Then
       word = Adjustl(value)
       line = line(1:Len_trim(line))//                            &
            &              ' value="'//word(1:Len_trim(word))//'"'   
    End If
    !
    If (Present(unit)) Then
       line = line(1:Len_trim(line))//                            &
            &              ' unit="'//unit(1:Len_trim(unit))//'"'
    End If
    !
    If (Present(dataType)) Then
       line = line(1:Len_trim(line))//                            &
            & ' datatype="'//dataType(1:Len_trim(dataType))//'"'
    End If
    !
    line = line(1:Len_trim(line))//'>'
    !
    If (Present(content)) Then
       phrase = Adjustl(content)
       line = line(1:Len_trim(line))//phrase(1:Len_trim(phrase))
    End If
    !
    If (Present(text)) Then
       phrase = Adjustl(text)
       line = line(1:Len_trim(line))//phrase(1:Len_trim(phrase))
    End If
    !
    line = line(1:Len_trim(line))//                               &
         &           '</'//element(1:Len_trim(element))//'>'
    !
    If (Present(comment)) Then
       phrase = Adjustl(comment)
       Call pakoXMLnoir(phrase,length)
       line = line(1:Len_trim(line))//                            &
            &    ' <!-- '//phrase(1:Len_trim(phrase))//' -->'
    End If
    !
    line2 = Adjustl(line)
    !
    Call pakoXMLwriteLine(line2,error)
    !
    If (Present(space).And.                                       &
         &        index(space,'after').Ge.1) Then
       Write (outputUnitXML,'(A)') ''
    End If
    !
    Call pakoXMLsetLevel(levelXML-1)
    !
    Return
    !
  End Subroutine pakoXMLwriteElement
!!!
!!!
  Subroutine pakoXMLcase(              text,                      &
       &                               error)
    !
    Character(len=*), Intent(INOUT) :: text
    Logical,          Intent(OUT)   :: error
    !
    ! <DOCUMENTATION name="pakoXMLcase">
    ! special routine to be used by paKo:
    ! convert a keyword to mixed case according to
    ! key/value pairs in the "dictionary" pakoDict
    ! </DOCUMENTATION>
    !
    Integer :: length
    Integer :: ii
    !
    error = .False.
    !
    length = Min(Len(text),Len(word))
    word   = text(1:length)
    word   = Adjustl(text)
    Call pakoXMLupper(word)
    !
    Do ii = 1, nDict, 1
       If (word.Eq.pakoDict(ii)%key) Then
          word = pakoDict(ii)%value
          text = word
       End If
    End Do
    !
    Return
    !
  End Subroutine pakoXMLcase
!!!
!!!
  Subroutine pakoXMLdictionaryInit(                               &
       &                                       error,             &
       &                                       errorC             &
       &                          )
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLdictionaryInit">
    ! intitialize the "dictionary" pakoDict
    ! </DOCUMENTATION>
    !
    error = .False.
    If (Present(errorC)) errorC  = "OK"
    !
    nDict = 1
    !
    If (.Not.error) Call pakoXMLdictionaryAdd( 'ANTENNA'    , 'antenna'     , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'BASIS'      , 'basis'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'CALIBRATE'  , 'calibrate'   , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'CIRCLE'     , 'circle'      , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'CONTINUUM'  , 'Continuum'   , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'DESCRIPTIVE', 'descriptive' , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'DOPPLER'    , 'Doppler'     , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'EQUATORIAL' , 'equatorial'  , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'FIXED'      , 'fixed'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'FOCUS'      , 'focus'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'HADEC'      , 'haDec'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'HIGH'       , 'high'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'HORIZON'    , 'horizontal'  , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'HORIZONTAL' , 'horizontal'  , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'LINEAR'     , 'linear'      , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'LOW'        , 'low'         , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'NARROW'     , 'narrow'      , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'NASMYTH'    , 'Nasmyth'     , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'NONE'       , 'none'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'ONOFF'      , 'onOff'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'OTF'        , 'onTheFly'    , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'ONTHEFLY'   , 'onTheFly'    , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'OTFMAP'     , 'onTheFlyMap' , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'POINTING'   , 'pointing'    , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'PROJECTION' , 'projection'  , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'RADIO'      , 'radio'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'TIP'        , 'tip'         , error)
!TBD: maybe should allow longer keywords, e.g., horizontalTrue
    If (.Not.error) Call pakoXMLdictionaryAdd( 'TRUEHORIZON', 'horizontalT' , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'WIDE'       , 'wide'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( '1MHZ'       , '1MHz'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( '4MHZ'       , '4MHz'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( '100KHZ'     , '100kHz'      , error)
    !
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'MERCURY'    , 'Mercury'     , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'VENUS'      , 'Venus'       , error)
!!$    !
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'MARS'       , 'Mars'        , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'JUPITER'    , 'Jupiter'     , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'SATURN'     , 'Saturn'      , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'URANUS'     , 'Uranus'      , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'NEPTUNE'    , 'Neptune'     , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'PLUTO'      , 'Pluto'       , error)
    !
  End Subroutine pakoXMLdictionaryInit
!!!
!!!
  Subroutine pakoXMLdictionaryAdd(                                &
       &                                       key,               &
       &                                       value,             &
       &                                       error,             &
       &                                       errorC             &
       &                         )
    !
    Character(len=*), Intent(IN)            :: key                ! key to add
    Character(len=*), Intent(IN)            :: value              ! value to add
    !                 
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLdictionaryAdd">
    ! add a key-value pair to "dictionary" pakoDict
    ! </DOCUMENTATION>
    !
    Integer lKey, lValue
    !
    error = .False.
    If (Present(errorC)) errorC  = "OK"
    !
    lKey   = Min(Len_trim(key),   lDict)
    lValue = Min(Len_trim(value), lDict)
    !
    If (nDict .Le. nDimDict) Then
       pakoDict(ndict) =                                          &
            &    pakoXMLdictionaryT(key(1:lKey),value(1:lValue))
       If (nDict .Lt. nDimDict) Then
          nDict = nDict+1
       End If
    Else
       error  = .True.
       If (Present(errorC)) errorC = "dictionary full"
    End If
    !
  End Subroutine pakoXMLdictionaryAdd
!!!
!!!
  Subroutine pakoXMLpush(                                         &
       &                                             element,     &
       &                                             pushError,   &
       &                                             pushErrorC   &
       &                )
    !
    Type (pakoXMLelementT), Intent(IN)            :: element      ! element to push on stack
    Logical,                Intent(OUT), Optional :: pushError    ! errorFlag
    Character(len=*),       Intent(OUT), Optional :: pushErrorC   ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLpush">
    ! push information about an element on the "stack" 
    ! </DOCUMENTATION>
    !
    pushError = .False.
    If (Present(pushErrorC)) pushErrorC  = "OK"
    !
    If (nStack.Lt.nDimStack) Then
       !
       nStack = nStack+1
       stack(nStack) = elementNone
       stack(nStack) = element
       !
    Else
       !
       pushError = .True.
       If (Present(pushErrorC)) pushErrorC  = "stack full"
       !
    End If
    !
    Return 
    !
  End Subroutine pakoXMLpush
!!!
!!!
  Subroutine pakoXMLpop(                                          &
       &                                             element,     &
       &                                             popError,    &
       &                                             popErrorC    &
       &               )
    !
    Type (pakoXMLelementT), Intent(OUT)           :: element      ! element to pop from stack
    Logical,                Intent(OUT)           :: popError     ! errorFlag
    Character(len=*),       Intent(OUT), Optional :: popErrorC    ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLpop">
    ! pop information about an element from the "stack"
    ! </DOCUMENTATION>
    !
    popError = .False.
    If (Present(popErrorC)) popErrorC  = "OK"
    !
    element = elementNone
    !
    If (nStack.Ge.1) Then
       !
       element = stack(nStack)
       nStack = nStack -1
       !
    Else
       !
       popError = .True.
       If (Present(popErrorC)) popErrorC  = "stack empty"
       !
    End If
    !
    Return 
    !
  End Subroutine pakoXMLpop
!!!
!!!
  Subroutine pakoXMLwriteLine(                 line,              &
       &                                       error)
    !
    Character(len=*), Intent(INOUT)         :: line               ! XML line to write 
    Logical,          Intent(OUT)           :: error              ! errorFlag
    !
    ! <DOCUMENTATION name="pakoXMLwriteLine">
    ! write one line with theproper indent to the XML output 
    ! </DOCUMENTATION>
    !
    Integer :: ii
    !
    error = .False.
    !
    lineOut = 'x'
    Do ii = 1, (levelXMl-1)*indentXML, 1
       lineOut = lineOut(1:Len_trim(lineOut)-1)//' x'
    End Do
    lineOut = lineOut(1:Len_trim(lineOut)-1)//line(1:lLine)
    !
    Write (outputUnitXML,'(A)') lineOut(1:Len_trim(lineOut))       
    !
    Return
    !
  End Subroutine pakoXMLwriteLine
!!!
!!!
  Subroutine pakoXMLnoir (CIN,NP)
    !
    ! <DOCUMENTATION name="pakoXMLnoir">
    ! eliminate unnecessary spaces. derivative of sic_noir
    ! </DOCUMENTATION>
    !
    Character(len=*) CIN
    Integer NP
    !
    Integer N,NI,I
    Logical LO,LI
    !
    LO = .False.
    NI = Len_trim(CIN)
    N  = 0
    Do I=1,NI
       LI=.True.
       If (CIN(I:I).Ne.' ' .And. CIN(I:I).Ne.'	') Then
          N = N+1
          CIN(N:N) = CIN(I:I)
       Else
          LI=.False.
          If (LO) Then
             N = N+1
             CIN(N:N) = ' '
          Endif
       Endif
       LO = LI
    End Do
    CIN(N+1:)=' '
    NP = N
    !
  End Subroutine pakoXMLnoir
!!!
!!!
  Subroutine pakoXMLupper(C)
    !
    ! <DOCUMENTATION name="pakoXMLupper">
    ! convert to upper case. derivative of sic_upper
    ! </DOCUMENTATION>
    !
    Character(len=*) C
    Integer I,IC
    !
    Do I=1,Len(C)
       If (C(I:I).Ge.'a' .And. C(I:I).Le.'z') Then
          IC=Ichar(C(I:I))+Ichar('A')-Ichar('a')
          C(I:I)=Char(IC)
       Endif
    Enddo
    !
  End Subroutine pakoXMLupper
!!!
!!!
End Module modulePakoXML

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_sort
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  use cubetopology_sperange_types
  !
  public :: sort 
  private
  !
  type :: sort_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(sperange_opt_t)        :: range
     type(cube_prod_t),  pointer :: sorted
   contains
     procedure, public  :: register => cubemain_sort_register
     procedure, private :: parse    => cubemain_sort_parse
     procedure, private :: main     => cubemain_sort_main
  end type sort_comm_t
  type(sort_comm_t) :: sort
  !
  type sort_user_t 
     type(cubeid_user_t)   :: cubeids
     type(sperange_user_t) :: range
   contains
     procedure, private :: toprog => cubemain_sort_user_toprog
  end type sort_user_t
  type sort_prog_t
     type(sperange_prog_t) :: range  ! Range to be sorted
     type(cube_t), pointer :: cube   ! Input cube
     type(cube_t), pointer :: sorted ! Sorted cube
     integer(kind=chan_k)  :: fc,lc  ! First and last channels
   contains
     procedure, private :: header   => cubemain_sort_prog_header
     procedure, private :: data     => cubemain_sort_prog_data
     procedure, private :: loop     => cubemain_sort_prog_loop
     procedure, private :: spectrum => cubemain_sort_prog_spectrum
  end type sort_prog_t
  !
contains
  !
  subroutine cubemain_sort_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(sort_user_t) :: user
    character(len=*), parameter :: rname='SORT>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    call sort%parse(line,user,error)
    if (error) return
    call sort%main(user,error)
    if (error) return
  end subroutine cubemain_sort_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_sort_register(sort,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sort_comm_t), intent(inout) :: sort
    logical,            intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='SORT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'SORT','[cubeid]',&
         'Sort the intensities of each spectrum of a cube',&
         'SORT reorders channels in each spectrum by decreasing&
         & brightness around the peak channel.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- The command identifies the maximum-brightness channel in each spectrum.'//strg_cr//&
         '- It then sorts contiguous channels around that peak by decreasing brightness.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> SORT mycube'//strg_cr//&
         'CUBE> SORT mycube /RANGE -20 20 km/s',&
         cubemain_sort_command,&
         sort%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         sort%cube,&
         error)
    if (error) return
    call sort%range%register(&
         'RANGE',&
         'Define the velocity range over which to sort',&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'SORTED',&
         'Sorted cube',&
         strg_emp,&
         [flag_sort],&
         sort%sorted,&
         error)
    if (error) return
  end subroutine cubemain_sort_register
  !
  subroutine cubemain_sort_parse(sort,line,user,error)
    !----------------------------------------------------------------------
    ! SORT [cubeid]
    ! /RANGE first last [unit]
    !----------------------------------------------------------------------
    class(sort_comm_t), intent(in)    :: sort
    character(len=*),   intent(in)    :: line
    type(sort_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='SORT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,sort%comm,user%cubeids,error)
    if (error) return
    call sort%range%parse(line,user%range,error)
    if (error) return
  end subroutine cubemain_sort_parse
  !
  subroutine cubemain_sort_main(sort,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sort_comm_t), intent(in)    :: sort
    type(sort_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(sort_prog_t) :: prog
    character(len=*), parameter :: rname='SORT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%header(sort,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_sort_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_sort_user_toprog(user,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sort_user_t), intent(in)    :: user
    type(sort_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    integer(chan_k) :: stride
    character(len=*), parameter :: rname='SORT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(sort%cube,user%cubeids,prog%cube,error)
    if (error) return
    call user%range%toprog(prog%cube,code_sperange_truncated,prog%range,error)
    if (error) return
    call prog%range%to_chan_k(prog%fc,prog%lc,stride,error)
    if (error) return
  end subroutine cubemain_sort_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_sort_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(sort_prog_t), intent(inout) :: prog
    type(sort_comm_t),  intent(in)    :: comm
    logical,            intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='SORT>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%sorted,prog%cube,prog%sorted,error)
    if (error) return
    call cubetools_header_get_axis_head_c(prog%sorted%head,axis,error)
    if (error) return
    axis%name = 'Sorted '//trim(axis%name)
    axis%n = prog%lc-prog%fc+1
    axis%ref = 1d0
    axis%val = 0d0
    call cubetools_header_update_axset_c(axis,prog%sorted%head,error)
    if (error) return
    !
  end subroutine cubemain_sort_prog_header
  !
  subroutine cubemain_sort_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(sort_prog_t), target, intent(inout) :: prog
    logical,                    intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='SORT>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
            call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! ie
    !$OMP END SINGLE
    !$OMP END PARALLEL
    !
  end subroutine cubemain_sort_prog_data
  !
  subroutine cubemain_sort_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(sort_prog_t), target, intent(inout) :: prog
    type(cubeadm_iterator_t),   intent(inout) :: iter
    logical,                    intent(inout) :: error
    !
    integer(kind=chan_k) :: nchan
    type(spectrum_t) :: spec,good,sorted
    character(len=*), parameter :: rname='SORT>PROG>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    nchan = prog%lc-prog%fc+1
    call good%reallocate('good',nchan,iter,error)
    if (error) return
    call sorted%reallocate('sorted',nchan,iter,error)
    if (error) return
    call spec%reassociate_and_init(prog%cube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%spectrum(iter%ie,spec,good,sorted,error)
       if (error) return
    enddo
  end subroutine cubemain_sort_prog_loop
  !
  subroutine cubemain_sort_prog_spectrum(prog,ie,spec,good,sorted,error)
    use cubemain_spectrum_real
    use cubemain_spectrum_blanking
    use cubemain_spectrum_moment_tool
    use cubemain_spectrum_operations
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(sort_prog_t), target, intent(inout) :: prog
    integer(kind=entr_k),       intent(in)    :: ie
    type(spectrum_t),           intent(inout) :: spec
    type(spectrum_t),           intent(inout) :: good
    type(spectrum_t),           intent(inout) :: sorted
    logical,                    intent(inout) :: error
    !
    type(spectrum_tpeak_t) :: tpeak
    type(spectrum_t) :: line
    character(len=*), parameter :: rname='SORT>PROG>SPECTRUM'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%get(prog%cube,ie,error)
    if (error) return
    call line%point_to(spec,prog%fc,prog%lc,1.0,error)
    if (error) return
    call cubemain_spectrum_unblank(line,good,error)
    if (error) return
    if (good%n.gt.0) then
       call tpeak%compute(good,error)
       if (error) return
       call cubemain_spectrum_sort(tpeak%ic,good,sorted,error)
       if (error) return
       call sorted%put(prog%sorted,ie,error)
       if (error) return
    endif
  end subroutine cubemain_sort_prog_spectrum
end module cubemain_sort
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBE TUPLE messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetuple_messaging
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: tupleseve
  public :: cubetuple_message_set_id,cubetuple_message
  public :: cubetuple_message_set_trans
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubetuple_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubetuple_messaging_debug_t
    integer(kind=code_k) :: trans = seve%d
  end type cubetuple_messaging_debug_t
  type(cubetuple_messaging_debug_t) :: tupleseve
  !
contains
  !
  subroutine cubetuple_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubetuple_message_id = id
    write (mess,'(A,I3)') 'Now use id #',cubetuple_message_id
    call cubetuple_message(seve%d,rname,mess)
  end subroutine cubetuple_message_set_id
  !
  subroutine cubetuple_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubetuple_message_id,mkind,'TUPLE>'//procname,message)
  end subroutine cubetuple_message
  !
  subroutine cubetuple_message_set_trans(on)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    logical, intent(in) :: on
    if (on) then
       tupleseve%trans = seve%i
    else
       tupleseve%trans = seve%d
    endif
  end subroutine cubetuple_message_set_trans
  !
end module cubetuple_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
! Support file for IEEE/EEEI/VAX arithmetics
! Should use Fortran 2003 IEEE_ARITHMETIC module at some point!
!-----------------------------------------------------------------------
subroutine gag_notanum4(notanum)
  !---------------------------------------------------------------------
  ! @ public-generic gag_notanum
  ! Return the value of NaN (R*4 version)]
  !  An IEEE signaling NaN is represented by any bit pattern
  !    between X'7F80 0001' and X'7FBF FFFF', or
  !    between X'FF80 0001' and X'FFBF FFFF'.
  !  An IEEE quiet NaN is represented by any bit pattern
  !    between X'7FC0 0000' and X'7FFF FFFF', or
  !    between X'FFC0 0000' and X'FFFF FFFF'.
  !---------------------------------------------------------------------
  real(kind=4), intent(out) :: notanum  ! NaN value
  ! Local
  real(kind=4) :: nan
#if defined(EEEI)
  data nan /Z'7FA00000'/
#endif
#if defined(IEEE)
  data nan /Z'FFC00000'/
#endif
#if defined(VAX)
  data nan /-1e38/               ! Not supported by VAX, so arbitrary
#endif
  notanum=nan
end subroutine gag_notanum4
!
subroutine gag_notanum8(notanum)
  !---------------------------------------------------------------------
  ! @ public-generic gag_notanum
  ! Return the value of NaN (R*8 version)
  !  An IEEE signaling NaN is represented by any bit pattern
  !    between X'7FF00000 00000001' and X'7FF7FFFF FFFFFFFF', or
  !    between X'FFF00000 00000001' and X'FFF7FFFF FFFFFFFF'.
  !  An IEEE quiet NaN is represented by any bit pattern
  !    between X'7FF80000 00000000' and X'7FFFFFFF FFFFFFFF', or
  !    between X'FFF80000 00000000' and X'FFFFFFFF FFFFFFFF'.
  !---------------------------------------------------------------------
  real(kind=8), intent(out) :: notanum  ! NaN value
  ! Local
  real(kind=8) :: nan
#if defined(EEEI)
  data nan /Z'7FA00000'/         ! Unknown !?
#endif
#if defined(IEEE)
  data nan /Z'7FF8000000000000'/
#endif
#if defined(VAX)
  data nan /-1d38/               ! Not supported by VAX, so arbitrary
#endif
  notanum=nan
end subroutine gag_notanum8
!
function gag_isreal (anum)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Return 0 if the number is a Real number,
  ! 1 if +Inf, 2 if -Inf, 3 if NaN
  ! An IEEE positive infinity is represented by the bit pattern X'7F80 0000'.
  ! An IEEE negative infinity is represented by the bit pattern X'FF80 0000'.
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_isreal           ! intent(out)
  integer(kind=4), intent(in) :: anum     ! Place Holder for Real(4) number
  ! Local
  integer(kind=4) :: pinf,minf,nan,expo
  ! Datas.
#if defined(EEEI)
  data nan /Z'7FA00000'/
#endif
#if defined(IEEE)
  data nan /Z'FFC00000'/
#endif
  data pinf /Z'7F800000'/
  data minf /Z'FF800000'/
  !
  gag_isreal = 0
  if (anum.eq.pinf) then
    gag_isreal = 1
  elseif (anum.eq.minf) then
    gag_isreal = 2
  else
    expo = iand(anum,nan)
    if (expo.eq.nan) then
      gag_isreal = 3
    else
      gag_isreal = 0
    endif
  endif
end function gag_isreal
!
function gag_isdble (anum)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Return 0 if the number is a Dble number,
  ! 1 if +Inf, 2 if -Inf, 3 if NaN
  ! An IEEE positive infinity is represented by the bit pattern X'7FF00000 00000000'.
  ! An IEEE negative infinity is represented by the bit pattern X'FFF00000 00000000'.
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_isdble           ! intent(out)
  integer(kind=4), intent(in) :: anum(2)  ! Place holder for Real*8 number
  ! Local
  integer(kind=4) :: pinf(2),minf(2),nan,expo,imant
  !
  ! Note: Fortran-95 norm says a BOZ constant is an INTEGER*8,
  ! and only valid in a data statement for an integer, but
  ! INTEGER*8 is not supported by every compiler/system...
#if defined(EEEI)
  ! HP-Like
  data nan /Z'7FF00000'/       ! not 7FF4000, at least on IEEE
  data imant /1/
  data pinf /Z'7FF00000',0/
  data minf /Z'FFF00000',0/
#endif
#if defined(IEEE)
  ! Intel-Like FULLY FUNCTIONAL (like PCs)
  data nan /Z'7FF00000'/       ! not 7FF4000 ...
  data imant /2/
  data pinf /0,Z'7FF00000'/
  data minf /0,Z'FFF00000'/
#endif
  !
  if (anum(1).eq.pinf(1).and.anum(2).eq.pinf(2)) then
    gag_isdble = 1
  elseif (anum(1).eq.minf(1).and.anum(2).eq.minf(2)) then
    gag_isdble = 2
  else
    expo = iand(anum(imant),nan)
    !!!         write(6,'(1x,Z8.8,1x,Z8.8)') expo,nan
    if (expo.eq.nan) then
      gag_isdble = 3
    else
      gag_isdble = 0
    endif
  endif
end function gag_isdble
!
subroutine gag_infini4(anum,string,ndg)
  use gsys_interfaces, except_this=>gag_infini4
  !---------------------------------------------------------------------
  ! @ public-generic gag_infini
  ! Format Invalid Numbers (single precision version)
  !---------------------------------------------------------------------
  real(kind=4),     intent(in)  :: anum    ! Number
  character(len=*), intent(out) :: string  ! Representation
  integer(kind=4),  intent(out) :: ndg     ! Length of string
  ! Local
  integer(kind=4) :: i
  integer(kind=4), parameter :: lc(0:3) = (/ 0,4,4,3 /)
  character(len=4), parameter :: chain(0:3) = (/ '    ','+Inf','-Inf','NaN ' /)
  !
  i = gag_isreal(anum)
  string = chain(i)
  ndg = lc(i)
end subroutine gag_infini4
!
subroutine gag_infini8(anum,string,ndg)
  use gsys_interfaces, except_this=>gag_infini8
  !---------------------------------------------------------------------
  ! @ public-generic gag_infini
  ! Format Invalid Numbers (double precision version)
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)  :: anum    ! Number
  character(len=*), intent(out) :: string  ! Representation
  integer(kind=4),  intent(out) :: ndg     ! Length of string
  ! Local
  integer(kind=4) :: i
  integer(kind=4), parameter :: lc(0:3) = (/ 0,4,4,3 /)
  character(len=4), parameter :: chain(0:3) = (/ '    ','+Inf','-Inf','NaN ' /)
  !
  i = gag_isdble(anum)
  string = chain(i)
  ndg = lc(i)
end subroutine gag_infini8

subroutine gwcs_observatory_internal(arg,lonlat,altitude,slimit,diam,found)
  use gwcs_interfaces, except_this=>gwcs_observatory_internal
  !---------------------------------------------------------------------
  ! @ private
  !  Internal subroutine, do not call directly! Use generic API
  ! 'gwcs_observatory' to retrieve a known observatory parameters, or
  ! use 'gwcs_observatory_exists' to check if it is known here.
  ! ---
  !  Return the observatory parameters given its name, with a flag
  ! 'found' if it was found or not.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: arg        ! Telescope name
  real(kind=8),     intent(inout) :: lonlat(2)  !
  real(kind=8),     intent(inout) :: altitude   !
  real(kind=8),     intent(inout) :: slimit     !
  real(kind=4),     intent(inout) :: diam       !
  logical,          intent(out)   :: found      !
  ! Local
  character(len=4) :: teles  ! Comparison is based on 4 characters
                             ! Hide this "detail" here
  logical :: error
  !
  teles = arg  ! arg can be smaller or larger than 4 characters!
  !
  lonlat(:) = 0.d0
  altitude = 0.d0
  slimit = 0.d0
  diam  = 0.
  found = .true.
  error = .false.
  !
  select case (teles)
  !
  ! IRAM instruments
  case ('BURE','PDBI','NOEM')
    ! Interferometer array center S.Guilloteau 06-SEP-1989
    call gwcs_sexa ('05:54:28.5',lonlat(1),error)
    call gwcs_sexa ('44:38:02.0',lonlat(2),error)
    altitude = 2.560d0  ! Elevation axis of antennas...
    slimit = 32.d0 ! was 45 deg. until Jul 2009, then 35 until 12 Nov 2014.
    diam = 15
  case ('PICO','30M ','VELE')
! From IRAM Website - Wikipedia is incorrect
    call gwcs_sexa ('-03:23:55.51',lonlat(1),error)
    call gwcs_sexa ('37:04:06.29',lonlat(2),error)
! Before 1-Mar-2016
!    call gwcs_sexa ('-03:23:58.1',11,lonlat(1),error)
!    call gwcs_sexa ('37:04:05.6',10,lonlat(2),error)
    altitude = 2.850d0
    slimit = 1.d0  ! was 2 deg. until Oct 2009
    diam = 30
  !
  ! submm/mm instruments
  case ('ALMA')
    call gwcs_sexa ('-67:45:11.6',lonlat(1),error)
    call gwcs_sexa ('-23:01:11.7',lonlat(2),error)
    altitude = 5.0d0
    slimit = 0.d0                 ! Sun can be observed ...
    diam = 12
  case ('ACA ')
    call gwcs_sexa ('-67:45:11.6',lonlat(1),error)
    call gwcs_sexa ('-23:01:11.7',lonlat(2),error)
    altitude = 5.0d0
    slimit = 0.d0                 ! Sun can be observed ...
    diam = 7
  case ('APEX')
    call gwcs_sexa ('-67:45:32.9',lonlat(1),error)   ! -67 45 32.90350
    call gwcs_sexa ('-23:00:20.8',lonlat(2),error)   !  23 00 20.80366
    altitude = 5.104d0                              ! 5104.4706
    slimit = 30.d0                ! From D.Muders 19.05.2011
    diam = 12
  case ('ATF ')
    call gwcs_sexa ('-107:37:10.02',lonlat(1),error)
    call gwcs_sexa ('34:04:29.8',lonlat(2),error)
    altitude = 2.13542d0
    slimit = 0.d0
    diam = 12
  case ('CARM')
    ! Rough values -118.1 37.3
    call gwcs_sexa ('-118:06:00.00',lonlat(1),error)
    call gwcs_sexa ('37:33:00.0',lonlat(2),error)
    altitude = 2.200d0
    slimit = 30.d0                ! ?
    diam = 10.4
  case ('CSO ')
    ! Values from University Hawaii web-site
    call gwcs_sexa ('-155:28:31.78954',lonlat(1),error)
    call gwcs_sexa ('19:49:20.77658',lonlat(2),error)
    altitude = 4.200d0
    slimit = 30.d0                ! ?
    diam = 10.4
  case ('FCRA')
    ! Rough values
    call gwcs_sexa ('-72:21:00.0',lonlat(1),error)
    call gwcs_sexa ('42:23:24.0',lonlat(2),error)
    altitude = 0.0d0             ! guess
    slimit = 0.d0
    diam = 15
  case ('GLT ')  ! GreenLand Telescope
    call gwcs_sexa ('-68:41:06.0',lonlat(1),error)
    call gwcs_sexa ('76:32:06.0',lonlat(2),error)
    altitude = 0.1d0
    slimit = 0.d0
    diam = 12
  case ('HAYS')  ! MIT Haystack
    call gwcs_sexa ('-71:29:18.636',lonlat(1),error)
    call gwcs_sexa ('42:37:22.944',lonlat(2),error)
    altitude = 0.125d0
    slimit = 0.d0
    diam = 36.6
  case ('JCMT')
    ! Values from University Hawaii web-site
    call gwcs_sexa ('-155:28:37.20394',lonlat(1),error)
    call gwcs_sexa ('19:49:22.10741',lonlat(2),error)
    altitude = 4.111d0
    slimit = 30.d0
    diam = 15
  case ('KITT')
    ! Values from email exchange with Remo Tilanus in Sept. 2025
    call gwcs_sexa ('-111:36:53.475',lonlat(1),error)
    call gwcs_sexa ('31:57:12.000',lonlat(2),error)
    altitude = 1.914d0
    slimit = 30.d0
    diam = 12
  case ('KOSM')
    call gwcs_sexa ('07:47:02.4',lonlat(1),error)
    call gwcs_sexa ('45:59:02.4',lonlat(2),error)
    altitude = 3.089d0
    slimit = 30.d0
    diam = 3.0
  case ('LMT')
    ! Rough values from website
    call gwcs_sexa ('-97:18:53',lonlat(1),error)
    call gwcs_sexa ('18:59:06',lonlat(2),error)
    altitude = 4.600d0
    slimit = 0.d0  ! Unknown
    diam = 50.0
  case ('MRO ')  ! Metsähovi Radio Observatory
    call gwcs_sexa ('24:23:35.19791',lonlat(1),error)
    call gwcs_sexa ('60:13:04.11295',lonlat(2),error)
    altitude = 0.0603d0
    slimit = 0.d0
    diam = 13.7
  case ('NOBE','NRO ')
    call gwcs_sexa ('138:28:33.0',lonlat(1),error)
    call gwcs_sexa ('35:56:30.0',lonlat(2),error)
    altitude = 1.350d0
    slimit = 30.d0
    diam = 10.0
  case ('NOTO')  ! Noto Radio Observatory
    call gwcs_sexa ('14:59:20.22',lonlat(1),error)
    call gwcs_sexa ('36:52:34.86',lonlat(2),error)
    altitude = 0.032d0
    slimit = 0.d0
    diam = 32.0
  case ('OSO')  ! Onsala Space Observatory 20m
    call gwcs_sexa ('11:55:34.8719',lonlat(1),error)
    call gwcs_sexa ('57:23:45.0046',lonlat(2),error)
    altitude = 0.022758d0
    slimit = 0.d0  ! Radome
    diam = 20.0
  case ('SEST')
    ! Rough value ?
    call gwcs_sexa ('-70:43:48',lonlat(1),error)
    call gwcs_sexa ('-29:15:24',lonlat(2),error)
    altitude = 2.347d0
    slimit = 60.d0
    diam = 15.0
  case ('SMA ')
    ! Array reference position - M. Gurwell communication - Sep 2019 
    call gwcs_sexa ('-155:28:39.08',lonlat(1),error)
    call gwcs_sexa ('19:49:27.14',lonlat(2),error)
    altitude = 4.108d0  ! radius: 6382.248km
    slimit = 25.d0
    diam = 6.0
  case ('SMT ','HHT ')
    ! GPS result from VLBI according to Dirk Muders.
    call gwcs_sexa ('-109:53:28.48',lonlat(1),error)
    call gwcs_sexa ('32:42:05.8',lonlat(2),error)
    altitude = 3.1860d0
    slimit = 30.d0
    diam = 10.0
  case ('SPT ')
    ! From J.E.Carlstrom et al. 2011
    ! Publications of the Astronomical Society of the Pacific, Vol. 123, No. 903 (May 2011), pp. 568-581
    call gwcs_sexa ('00:00:00',lonlat(1),error)
    call gwcs_sexa ('-90:00:00',lonlat(2),error)
    altitude = 2.800d0
    slimit = 0.d0
    diam = 10.0
  case ('SRT ')  ! Sardinia Radio Telescope
    call gwcs_sexa ('9:14:42.5764',lonlat(1),error)
    call gwcs_sexa ('39:29:34.93742',lonlat(2),error)
    altitude = 0.6d0
    slimit = 0.d0  ! Unknown
    diam = 64.0
  case ('TRAO')  ! Taeduk Radio Astronomy Observatory (South Korea)
    call gwcs_sexa ('127:22:30.591',lonlat(1),error)
    call gwcs_sexa ('36:23:51.162',lonlat(2),error)
    altitude = 0.144d0
    slimit = 0.d0  ! Under a radome
    diam = 13.716
  case ('WEST')  ! MIT Westford
    call gwcs_sexa ('-71:29:38.328',lonlat(1),error)
    call gwcs_sexa ('42:36:46.512',lonlat(2),error)
    altitude = 0.100d0
    slimit = 0.d0
    diam = 18.3
  case ('YEBE')
    call gwcs_sexa ('-3:05:12.71',lonlat(1),error)
    call gwcs_sexa ('40:31:28.78',lonlat(2),error)
    altitude = 0.99d0
    slimit = 2.d0
    diam = 40.0
  !
  ! cm instruments
  case ('EFFE')
    call gwcs_sexa ('06:53:02',lonlat(1),error)
    call gwcs_sexa ('50:31:29',lonlat(2),error)
    altitude = 0.360d0
    slimit = 20.d0
    diam = 100.0
  case ('GBT')
    call gwcs_sexa ('-79:50:23.406',lonlat(1),error)
    call gwcs_sexa ('38:25:59.236',lonlat(2),error)
    altitude = 0.80743d0
    slimit = 0.d0
    diam = 100.0
  case ('VLA ','EVLA','JVLA')
    call gwcs_sexa ('-107:37:06',lonlat(1),error)
    call gwcs_sexa ('34:04:42',lonlat(2),error)
    altitude = 2.124d0
    slimit = 0.d0
    diam = 25.0
  case ('MEDI')  ! Medicina Radio Observatory
    call gwcs_sexa ('11:38:48.9',lonlat(1),error)
    call gwcs_sexa ('44:31:13.8',lonlat(2),error)
    altitude = 0.025d0
    slimit = 0.d0
    diam = 32.0
  !
  ! other instruments
  case ('LASI')
    call gwcs_sexa ('-70:43:48',lonlat(1),error)
    call gwcs_sexa ('-29:15:24',lonlat(2),error)
    altitude = 2.347d0
    slimit = 60.d0
  case ('MAUN')
    call gwcs_sexa ('-155:28:18',lonlat(1),error)
    call gwcs_sexa ('19:46:36',lonlat(2),error)
    altitude = 4.200d0
    slimit = 60.d0
  case ('PARA','VLT ','VLTI')
    ! Exact value taken from the Officials Documents as of 10/14/97 GD
    call gwcs_sexa ('-70:24:11.642',lonlat(1),error)
    call gwcs_sexa ('-24:37:33.117',lonlat(2),error)
    altitude = 2.636d0
    slimit = 60.d0
  case ('IOTA')
    call gwcs_sexa ('-110:53:05',lonlat(1),error)
    call gwcs_sexa ('31:14:11',lonlat(2),error)
    altitude = 2.608d0
    slimit = 60.d0
  case ('PTI ')
    call gwcs_sexa ('-116:51:47.88',lonlat(1),error)
    call gwcs_sexa ('33:21:24.12',lonlat(2),error)
    altitude = 1.687d0
    slimit = 60.d0
  case ('GI2T')
    call gwcs_sexa ('06:55:36',lonlat(1),error)
    call gwcs_sexa ('43:44:56',lonlat(2),error)
    altitude = 1.270d0
  case ('FAST')
    call gwcs_sexa ('106:51:24.0',lonlat(1),error)
    call gwcs_sexa ('25:39:10.6',lonlat(2),error)
    altitude = 1.1100288
    slimit = 5.d0
    diam = 300.d0  ! Illuminated diameter 300m over 500m
  case default
    found = .false.
  end select
  !
end subroutine gwcs_observatory_internal
!
function gwcs_observatory_exists(arg)
  !---------------------------------------------------------------------
  ! @ public
  ! Function evaluates as true if the named observatory is known here
  !---------------------------------------------------------------------
  logical :: gwcs_observatory_exists
  character(len=*), intent(in) :: arg ! Telescope name
  ! Local
  real(kind=8) :: lonlat(2),altitude,slimit
  real(kind=4) :: diam
  !
  ! Retrieving all the parameters is useless but this avoids duplicating
  ! the list of supported observatories
  call gwcs_observatory_internal(arg,lonlat,altitude,slimit,diam,gwcs_observatory_exists)
  !
end function gwcs_observatory_exists
!
subroutine gwcs_observatory_parameters(arg,lonlat,altitude,slimit,diam,error)
  use gbl_message
  use gwcs_interfaces, except_this=>gwcs_observatory_parameters
  !---------------------------------------------------------------------
  ! @ public-generic gwcs_observatory
  !  Return the observatory parameters given its name, raise an error
  ! if not found
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: arg        ! Telescope name
  real(kind=8),     intent(inout) :: lonlat(2)  !
  real(kind=8),     intent(inout) :: altitude   !
  real(kind=8),     intent(inout) :: slimit     !
  real(kind=4),     intent(inout) :: diam       !
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='OBSERVATORY'
  logical :: found
  !
  call gwcs_observatory_internal(arg,lonlat,altitude,slimit,diam,found)
  if (.not.found) then
    call gwcs_message(seve%e,rname,'Unknown telescope name '//arg)
    error = .true.
    return
  endif
  !
end subroutine gwcs_observatory_parameters
!
subroutine gwcs_observatory_telesco(arg,telescope,error)
  use gbl_message
  use image_def
  use gwcs_interfaces, except_this=>gwcs_observatory_telesco
  !---------------------------------------------------------------------
  ! @ public-generic gwcs_observatory
  !  Return the observatory parameters in the 'telesco' structure given
  ! its name.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: arg        ! Telescope name
  type(telesco),    intent(out)   :: telescope  ! Telescope structure
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  ! real(kind=8) :: xyz(3)
  real(kind=8) :: lonlat(2)
  real(kind=8) :: altitude
  real(kind=8) :: slimit
  real(kind=4) :: diam
  !
  call gwcs_observatory_parameters(arg,lonlat,altitude,slimit,diam,error)
  if (error)  return
  !
  telescope%ctele = arg
  telescope%lon = lonlat(1)
  telescope%lat = lonlat(2)
  telescope%alt = altitude*1d3
  telescope%diam = diam
  !
  ! Debugging:
  ! call gwcs_lonlat2geo(lonlat(1),lonlat(2),altitude,xyz)
  ! print *,'Telescope ',telescope%ctele
  ! print *,'Lon Lat ',lonlat,' Alt ',telescope%alt
  ! print *,'XYZ ',xyz
end subroutine gwcs_observatory_telesco
!
subroutine gwcs_print_telescope(teles,line)
  use image_def
  use gwcs_dependencies_interfaces
  use gwcs_interfaces, except_this=>gwcs_print_telescope
  !---------------------------------------------------------------------
  ! @ public
  ! Build a one-line description of a type 'telesco'. This line is well
  ! suited for command V\HEADER.
  !---------------------------------------------------------------------
  type(telesco),    intent(in)  :: teles
  character(len=*), intent(out) :: line
  ! Local
  character(len=13) :: chlon,chlat
  !
  call deg2sexa(teles%lon,360,chlon,2)
  call deg2sexa(teles%lat,360,chlat,1)
  line = 'Tel: '//teles%ctele//chlon//chlat//' Alt.          Diam '
  write(line(52:58),'(F6.1)') teles%alt
  write(line(65:71),'(F5.1)') teles%diam
  !
end subroutine gwcs_print_telescope
!
subroutine gwcs_sexa(line,value,error)
  use gbl_message
  use gwcs_interfaces, except_this=>gwcs_sexa
  !---------------------------------------------------------------------
  ! @ public
  !  Decode a sexagesimal notation
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  real(kind=8),     intent(out)   :: value  !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='SEXA'
  real(8) :: value1,sign
  integer :: nf,nl,nc, nline
  character(len=64) :: chain
  integer :: ier
  !
  ! First, get the real string to be decoded:
  nline = len_trim(line)
  nl = index(line(1:nline),':')
  if (nl.eq.0) then
    read(line(1:nline),*,iostat=ier) value
    error = ier.ne.0
    return
  else
    chain = line(1:nline)
    nc = nline
  endif
  !
  ! Then, start decoding
  if (nl.eq.1 .or. nl.eq.nc) then
    call gwcs_message(seve%e,rname,'Syntax error')
    error = .true.
    return
  endif
  !
  ! Decode HOURS/DEGREES
  read(chain(1:nl-1),*,iostat=ier) value
  error = ier.ne.0
  if (error) return
  if (value.gt.0d0) then
    sign = 1.0d0
  elseif (value.lt.0d0) then
    sign = -1.0d0
    value = -value
  else
    if (chain(1:1).eq.'-') then
      sign = -1.0d0
    else
      sign = 1.0d0
    endif
  endif
  !
  ! Decode MINUTES
  nf = nl+1
  nl = index(chain(nf:nc),':')
  if (nl.eq.1 .or. nl+nf-1.eq.nc) then
    call gwcs_message(seve%e,rname,'Syntax error')
    error = .true.
    return
  endif
  if (nl.eq.0) then
    read(chain(nf:nc),*,iostat=ier) value1
    error = ier.ne.0
    if (error) return
  else
    read(chain(nf:nf+nl-2),*,iostat=ier) value1
  endif
  error = ier.ne.0
  if (error) return
  if (value1.lt.0.d0 .or. value1.ge.60.d0) then
    call gwcs_message(seve%e,rname,'Invalid minute field in '//chain)
    error = .true.
    return
  endif
  value = value + value1/60.d0
  if (nl.eq.0) then
    ! No SECONDS field: return now
    value = sign * value
    return
  endif
  !
  ! Decode SECONDS
  nf = nf+nl
  read(chain(nf:nc),*,iostat=ier) value1
  error = ier.ne.0
  if (error) return
  if (value1.lt.0.d0 .or. value1.ge.60.d0) then
    call gwcs_message(seve%e,rname,'Invalid second field in '//chain)
    error = .true.
    return
  endif
  value = sign * (value + value1/3600.d0)
  !
end subroutine gwcs_sexa
!
subroutine gwcs_geo2lonlat(xyz,clon,clat,alt)
  use gwcs_interfaces, except_this=>gwcs_geo2lonlat
  !----------------------------------------------------
  ! @ public
  !   GWCS
  !   Convert XYZ to Longitude, Latitude, Altitude
  !----------------------------------------------------
  real(8), intent(in) :: xyz(3)
  character(len=*), intent(out) :: clon  ! In degree, sexagesimal
  character(len=*), intent(out) :: clat  ! In degree, sexagesimal
  real(8), intent(out) :: alt

  !ASTRO ! real(8), parameter :: a_earth =6367435d0      ! earth radius in meters
  real(8), parameter :: bovera=0.99664719d+00        ! earth b/a
  real(8), parameter :: a_earth=6378140d+00          ! (m) earth radius
  real(8), parameter :: flatten=1.d0-bovera          ! Earth flattening
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  real(8) :: plh(3)
  !
  call gwcs_xyz2lla(xyz,plh, a_earth, flatten)
  if (plh(1).gt.pi) plh(1) = plh(1)-2.d0*pi
  call sexag(clon,plh(1),360)
  call sexag(clat,plh(2),360)
  alt = plh(3)
  !
end subroutine gwcs_geo2lonlat
!
subroutine gwcs_lonlat2geo(clon,clat,alt,xyz)
  use gwcs_interfaces, except_this=>gwcs_lonlat2geo
  !----------------------------------------------------
  ! @ public
  !
  !----------------------------------------------------
  real(8), intent(out) :: xyz(3)
  real(8), intent(in) :: clon  ! Degree
  real(8), intent(in) :: clat  ! Degree
  real(8), intent(in) :: alt   ! km

  !ASTRO ! real(8), parameter :: a_earth =6367435d0      ! earth radius in meters
  real(8), parameter :: bovera=0.99664719d+00        ! earth b/a
  real(8), parameter :: a_earth=6378140d+00          ! (m) earth radius
  real(8), parameter :: flatten=1.d0-bovera          ! Earth flattening
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  real(8) :: plh(3)
  !
  plh(1) = clon*pi/180d0
  if (plh(1).lt.0) plh(1) = plh(1)+2.d0*pi
  plh(2) = clat*pi/180d0
  plh(3) = alt*1d3
  call gwcs_lla2xyz (plh, xyz, a_earth, flatten)
  !
end subroutine gwcs_lonlat2geo
!
subroutine gwcs_xyz2lla(xyz, plh, a, fl)
  !------------------------------------------------------------
  ! @ public
  !
  ! Convert XYZ to Longitude, Latitude, Altitude
  ! for a given ellipsoid specified by A and FL
  !
  ! Longitude is East of Greenwich
  !
  ! References:
  ! Borkowski, K. M. (1989).  "Accurate algorithms to transform geocentric
  ! to geodetic coordinates", *Bulletin Geodesique*, v. 63, pp. 50-56.
  ! Borkowski, K. M. (1987).  "Transformation of geocentric to geodetic
  ! coordinates without approximations", *Astrophysics and Space Science*,
  ! v. 139, n. 1, pp. 1-4.  Correction in (1988), v. 146, n. 1, p. 201.
  !
  ! An equivalent formulation is recommended in the IERS Standards
  ! (1995), draft.
  !-------------------------------------------------------------------------
  real(8), intent(in) :: xyz(3)  ! XYZ coordinates (in units of distance)
  real(8), intent(out) :: plh(3) ! Longitude, Latitude (in radians) and height (in unit of distance)
  real(8), intent(in) :: a       ! semi-major axis of ellipsoid (in units are of distance)
  real(8), intent(in) :: fl      ! flattening of ellipsoid [unitless]
  !
  ! Global
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  ! Local
  real(8) :: B ! Semi-minor axis of ellipsoid
  real(8) :: x,y,z
  real(8) :: r,e,f
  real(8) :: p,q,d
  real(8) :: g,t,v
  real(8) :: lon, lat, alt
  !
  x = xyz(1)
  y = xyz(2)
  z = xyz(3)
  !
  ! Compute semi-minor axis with sign
  B = A * (1.d0 - FL)
  if (z.lt.0.0d0) B = -B
  !
  ! Searching for latitude
  r = sqrt( x*x + y*y )
  e = ( B*z - (A*A - B*B) ) / ( A*r )
  f = ( B*z + (A*A - B*B) ) / ( A*r )
  !
  ! Solution to
  !     t^4 + 2*E*t^3 + 2*F*t - 1 = 0
  p = (4.d0 / 3.d0) * (e*f + 1.d0)
  q = 2.d0 * (e*e - f*f)
  d = p*p*p + q*q
  if (d.ge.0.d0) then
    v = (sqrt(d)-q)**(1.d0/3.d0) - (sqrt(d)+q)**(1.d0/3.d0)
  else
    v = 2.0 * sqrt(-p) * cos(acos(q/(p*sqrt(-p)))/3.d0)
  endif
  !
  ! Improve v near poles
  if ( v*v.lt.abs(p)) then
    v = -(v*v*v + 2.d0*q) / (3.d0*p)
  endif
  g = (sqrt(e*e + v ) + e) / 2.d0
  t = sqrt( g*g  + (f - v*g)/(2.d0*g - e) ) - g
  !
  ! Here is the latitude, the most complex issue
  lat = atan( (A*(1.d0 - t*t)) / (2.d0*B*t) )
  !
  ! The comes height
  alt = (r - A*t)*cos(lat) + (z - B)*sin(lat)
  !
  ! And finally, the obvious, the longitude
  lon = atan2 (y,x)
  if (lon.lt.0.d0 ) then
    lon = lon+2.d0*pi
  endif
  !
  ! Now return
  plh(1) = lon
  plh(2) = lat
  plh(3) = alt
end subroutine gwcs_xyz2lla
!
subroutine gwcs_lla2xyz (plh, xyz, A, FL)
  !---------------------------------------------------------------------
  ! @ public
  ! Converts elliptic Longitude, Latitude and Height to geocentric X,Y,Z
  !
  ! references:
  ! Escobal, "Methods of Orbit Determination", 1965, Wiley & Sons, Inc.,
  ! pp. 27-29.
  !---------------------------------------------------------------------
  real(8), intent(in) :: plh(3)  ! Longitude, Latitude (in radians) and height (in unit of distance)
  real(8), intent(out) :: xyz(3) ! XYZ coordinates (in units of distance)
  real(8), intent(in) :: a       ! semi-major axis of ellipsoid (in units are of distance)
  real(8), intent(in) :: fl      ! flattening of ellipsoid [unitless]
  !
  ! Local
  real(8) :: flatfn, funsq
  real(8) :: lon,lat,alt
  real(8) :: slat, g1,g2
  real(8) :: x,y,z
  !
  flatfn = (2.d0-fl)*fl
  funsq = (1.d0-fl)**2
  !
  lon = plh(1)
  lat = plh(2)
  alt = plh(3)
  !
  slat = sin(lat)
  g1 = A / sqrt(1.d0 - flatfn*slat**2)
  g2 = g1*funsq + alt
  g1 = g1 + alt
  !
  x = g1 * cos(lat)
  y = x * sin(lon)
  x = x * cos(lon)
  z = g2 * slat
  !
  xyz(1) = x
  xyz(2) = y
  xyz(3) = z
end subroutine gwcs_lla2xyz
!
subroutine gwcs_azel2pa(lat,az,el,parang)
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the parallactic angle from az/el and latitude of
  ! observation. Azimuth convention must be South at 180 degrees.
  ! If using azimuth South at 0 degrees, sinAz and cosAz sign should be
  ! swapped.
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: lat     ! [rad]
  real(kind=8), intent(in)  :: az,el   ! [rad]
  real(kind=8), intent(out) :: parang  ! [rad]
  ! Local
  real(kind=8) :: cosLat,sinLat
  real(kind=8) :: cosAz,sinAz
  real(kind=8) :: cosEl,sinEl
  real(kind=8) :: dec,cosDec,sinDec
  real(kind=8) :: cosParallactic,sinParallactic
  !
  sinLat = sin(lat)
  cosLat = cos(lat)
  !
  sinAz = sin(az)
  cosAz = cos(az)
  !
  sinEl = sin(el)
  cosEl = cos(el)
  !
  sinDec = sinLat * sinEl + cosLat * cosEl * cosAz
  dec = asin(sinDec)  ! [rad]
  cosDec = cos(dec)
  !
  sinParallactic = - cosLat * sinAz / cosDec
  cosParallactic = (sinLat - sinDec * sinEl) / cosDec / cosEl
  parang = atan2(sinParallactic,cosParallactic)  ! [rad]
end subroutine gwcs_azel2pa

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uvmosaic_tool
  use gbl_message
  !
  public :: uvmosaic_main,mosaic_sort,loadfiuv
  public :: many_beams_para
  private
  !
contains
  !
  subroutine uvmosaic_main(rname,line,error)
    use phys_const, only: pi
    use image_def
    use gkernel_types, only: projection_t
    use gkernel_interfaces
    use mapping_types, only: map_minmax
    use mapping_list_tool
    use mapping_primary, only: get_bsize
    use mapping_mosaic, only: mosaic_main
    use uv_continuum, only: map_beams,map_parameters
    use uv_shift, only: map_get_radecang
    use uvmap_tool, only: map_prepare,new_dirty_beam
    use clean_beam_tool, only: beam_for_channel
    use clean_types
    use file_buffers
    use uv_buffers
    use uvmap_buffers
    use clean_buffers
    !------------------------------------------------------------------------
    ! Compute a Mosaic from a CLIC UV Table with pointing offset information.
    !
    ! Input :
    !     a UV table with pointing offset information
    !
    ! Ouput
    !   NX NY are the image sizes
    !   NC is the number of channels
    !   NF is the number of different frequencies
    !   NP is the number of pointing centers
    !
    ! 'NAME'.LMV  a 3-d cube containing the uniform noise
    !     combined mosaic, i.e. the sum of the product
    !     of the fields by the primary beam. (NX,NY,NC)
    ! 'NAME'.LOBE the primary beams pseudo-cube (NP,NX,NY,NB)
    ! 'NAME'.WEIGHT the sum of the square of the primary beams (NX,NY,NB)
    ! 'NAME'.BEAM a 4-d cube where each cube contains the synthesised
    !     beam for one field (NX,NY,NB,NP)
    !
    ! All images have the same X,Y sizes
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname ! Caller (MOSAIC)
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
    !
    logical :: debug
    logical :: found(3)
    logical :: one,sorted,shift
    !
    integer :: ier
    integer :: nx,ny,nu,nv,nc,np,mp
    integer :: wcol,mcol(2),nfft,sblock
    integer :: ifield,jfield,ic,j,fstart,fend
    integer :: ib,nb,old_ib
    integer, allocatable :: voff(:)
    integer(kind=index_length) :: dim(4)
    real :: cpu0, cpu1
    real :: beamx,beamy
    real :: thre,btrunc,bsize ! To be initialized
    real :: offx,offy,factory,xm,xp,off_range(2)
    real(4) :: rmega,uvmax,uvmin,uvma
    real(8) :: freq
    real(8) :: new(3)
    real(8) :: pos(2)
    real, allocatable :: fft(:)
    real, allocatable :: noises(:)
    real, allocatable :: w_mapu(:),w_mapv(:),w_grid(:,:)
    real, allocatable, target :: dmap(:,:,:),dtmp(:,:,:,:)
    real, allocatable :: dweight(:,:)
    real, allocatable :: dtrunc(:,:)
    real, allocatable :: doff(:,:)
    real, pointer :: my_dirty(:,:,:)
    real, allocatable :: factorx(:)
    logical, parameter :: fromressection=.true.
    integer, parameter :: o_trunc=1
    integer, parameter :: o_field=2
    character(len=message_length) :: chain
    type(projection_t) :: proj
    !
    debug = sic_present(0,2) 
    !
    ! Get beam size from data or command line
    if (sic_present(o_trunc,0)) then
       call get_bsize(huv,rname,line,fromressection,bsize,error,OTRUNC=o_trunc,BTRUNC=btrunc)
    else
       call get_bsize(huv,rname,line,fromressection,bsize,error,BTRUNC=btrunc)
    endif
    if (error) return
    write(chain,'(a,f10.2,a,f6.0,a)') 'Correcting for a beam size of ',&
         & bsize/pi*180*3600,'" down to ',100*btrunc,'% '
    call map_message(seve%i,rname,chain)
    !
    call map_prepare(rname,uvmap_prog,error)
    if (error) return
    ! Temporary patch as mosaics + several beams does not give satisfying
    ! results (e.g. the BEAM% buffer will have only 3 dimensions)
    if (uvmap_prog%beam.eq.-1) then  ! MAP_BEAM_STEP mode
       ! Turn it to mode 0, i.e. force 1 beam for all channels
       uvmap_prog%beam = 0
       call map_message(seve%w,rname,  &
            'MAP_BEAM_STEP mode -1 is not yet implemented for mosaics: fallback to mode 0')
    endif
    !
    one = .true.
    call sic_get_inte('WCOL',wcol,error)
    call sic_get_inte('MCOL[1]',mcol(1),error)
    call sic_get_inte('MCOL[2]',mcol(2),error)
    !
    call sic_get_logi('UV_SHIFT',shift,error)
    if (shift) then
       call map_get_radecang(rname,found,new,error)
       if (error)  return
       if (.not.all(found)) then
          call map_message(seve%e,rname,'MAP_RA and MAP_DEC must be defined')
          error = .true.
          return
       endif
    else
       new(:) = 0.d0
    endif
    !
    ! First sort the input UV Table, leaving UV Table in UV_*
    !
    ! Note: the sorting should have FIELD ID as primary (slowest varying) key
    ! It needs a mandatory interface for Doffx & Doffy
    ! It may be better to have a separate counting of NP before, as
    ! such a thing would anyway be needed by UV_STAT
    !
    call gag_cpu(cpu0)
    call mosaic_sort(error,sorted,shift,new,uvmax,uvmin, &
         & huv%gil%column_pointer(code_uvt_xoff), &
         & huv%gil%column_pointer(code_uvt_yoff), &
         & mp,doff,voff)
    if (error) return
    !
    xm = minval(doff(1,1:mp))
    xp = maxval(doff(1,1:mp))
    off_range(1) = xp-xm
    xm = minval(doff(2,1:mp))
    xp = maxval(doff(2,1:mp))
    off_range(2) = xp-xm
    !
    if (.not.sorted) then
       !! print *,'Done mosaic_sort UV range ',uvmin,uvmax,' sorted ',sorted
       !! call uv_dump_buffers('UV_MOSAIC')
       ! Redefine SIC variables (mandatory)
       call sic_delvariable ('UV',.false.,error)
       call sic_mapgildas ('UV',huv,error,duv)
    else
       !! print *,'Mosaic was sorted ',uvmin,uvmax,' sorted ',sorted
    endif
    call gag_cpu(cpu1)
    write(chain,102) 'Finished sorting ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
    !
    ! This may need to be revised 
    call map_parameters(rname,uvmap_prog,freq,uvmax,uvmin,error)
    if (error) return
    uvma = uvmax/(freq*f_to_k)
    !
    uvmap_prog%xycell = uvmap_prog%xycell*pi/180.0/3600.0
    !
    ! Get work space, ideally before mapping first image, for
    ! memory contiguity reasons.
    !
    nx = uvmap_prog%size(1)
    ny = uvmap_prog%size(2)
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    nc = huv%gil%nchan
    !
    allocate(w_mapu(nx),w_mapv(ny),w_grid(nx,ny),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Gridding allocation error')
       goto 98
    endif
    !
    do_weig = .true.
    if (do_weig) then
       call map_message(seve%i,rname,'Computing weights ')
       if (allocated(g_weight)) deallocate(g_weight)
       if (allocated(g_v)) deallocate(g_v)
       allocate(g_weight(nv),g_v(nv),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Weight allocation error')
          goto 98
       endif
    else
       call map_message(seve%i,rname,'Re-using weights')
    endif
    nfft = 2*max(nx,ny)
    allocate(fft(nfft),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'FFT allocation error')
       goto 98
    endif
    !
    rmega = 8.0
    ier = sic_ramlog('SPACE_MAPPING',rmega)
    sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
    !
    ! New Beam place
    if (allocated(dbeam)) then
       call sic_delvariable ('BEAM',.false.,error)
       deallocate(dbeam)
    endif
    call gildas_null(hbeam)
    !
    ! New dirty image
    if (rname.ne.'MOSAIC_RESTORE') then 
       if (allocated(dirty%data)) then
          call sic_delvariable ('DIRTY',.false.,error)
          deallocate(dirty%data)
       endif
       allocate(dirty%data(nx,ny,nc),dmap(nx,ny,nc),dtrunc(nx,ny),stat=ier)
       my_dirty => dirty%data
    else
       if (allocated(resid%data)) then
          call sic_delvariable ('RESIDUAL',.false.,error)
          deallocate(resid%data)
       endif
       allocate(resid%data(nx,ny,nc),dmap(nx,ny,nc),dtrunc(nx,ny),stat=ier)
       my_dirty => resid%data
    endif
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Map allocation error')
       goto 98
    endif
    !
    call gildas_null(dirty%head)
    dirty%head%gil%ndim = 3
    dirty%head%gil%dim(1:3) = (/nx,ny,nc/)
    !
    ! Compute the primary beams and weight image
    call gildas_null(primbeam%head)
    if (allocated(primbeam%data)) then
       call sic_delvariable ('PRIMARY',.false.,error)
       deallocate(primbeam%data)
    endif
    if (allocated(fields%data)) then
       deallocate(fields%data)
    endif
    !
    ! Find out how many beams are required
    call map_beams(rname,uvmap_prog%beam,huv,nx,ny,nb,nc)
    !
    !!print *,'Done MAP_BEAMS ',uvmap_prog%beam,nb
    !
    call sic_delvariable('FIELDS%N_SELECT',.false.,error)
    call sic_delvariable('FIELDS%SELECTED',.false.,error)
    error = .false.
    !
    ! Get the field lists from the /FIELD option if any
    if (sic_present(o_field,0)) then
       np = 0
       call get_i4list_fromsic(rname,line,o_field,np,selected_fields,error)  
       if (np.gt.mp) then
          call map_message(seve%e,rname,'More selected fields than available')
          error = .true.
       else 
          do jfield=1,np
             ifield = selected_fields(jfield)
             if (ifield.le.0 .or. ifield.gt.mp) then
                write(chain,'(A,I0,I0,A,I0,A)') 'Selected field ',jfield,& 
                     & ifield,' out of range [1,',mp,']'
                call map_message(seve%e,rname,chain)
                error = .true.
             endif
          enddo
       endif
       if (error) return
       selected_fieldsize = np
       write(chain,'(I0,A,I0,A)') np,' fields selected:' 
       call map_message(seve%i,rname,chain)
       write(*,'(10X,6(2X,I0))') selected_fields(1:np)
       !
       call sic_def_inte('FIELDS%N_SELECT',selected_fieldsize,0,0,.true.,error)
       dim(1) = selected_fieldsize
       call sic_def_inte('FIELDS%SELECTED',selected_fields,1,dim,.true.,error)    
    else
       np = mp
       if (allocated(selected_fields))  deallocate(selected_fields)
       allocate(selected_fields(mp),stat=ier)
       do jfield=1,np
          selected_fields(jfield) = jfield
       enddo
       selected_fieldsize = 0    ! Means all
    endif
    !
    ! An issue is that the map characteristics are defined
    ! in "one_beam". We need to call the proper routines before...
    call map_headers(rname,uvmap_prog,huv,hbeam,dirty%head,primbeam%head,nb,np,mcol)
    !
    !!print *,'Done MAP_HEADERS '
    !
    ! Define the projection about the Phase center
    call gwcs_projec(huv%gil%a0,huv%gil%d0,-huv%gil%pang,huv%gil%ptyp,proj,error)
    ! POS is here the Offset of the Pointing center relative to the Phase center
    call abs_to_rel(proj,huv%gil%ra,huv%gil%dec,pos(1),pos(2),1)
    !
    !***JP: Here was the old code for mosaics. Look in the
    !***JP: obsolete/tool-uvmosaic.f90 file if needed.
    !
    !!print *,'Using untested code, use MAP_BEAM_STEP = -2 if failed'
    !
    ! Code ready but only tested for one Beam for all Frequencies.
    hbeam%gil%ndim = 4
    hbeam%gil%dim(1:4)=(/nx,ny,nb,np/)
    allocate(dbeam(nx,ny,nb,np),stat=ier)
    !
    allocate (primbeam%data(np,nx,ny,nb),dweight(nx,ny),&
          dtmp(nx,ny,nb,1),factorx(nx),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Primary beam allocation error')
       goto 98
    endif
    primbeam%head%r4d => primbeam%data
    !
    ! Create the primary beams, lobe and weight images
    do jfield = 1,np
       ifield = jfield
       if (selected_fieldsize.ne.0) ifield = selected_fields(jfield)    
       ! bsize is Frequency dependent TBC
       !
       do ib=1,nb
          beamx = primbeam%head%gil%inc(2)/bsize*2.0*sqrt(log(2.0))
          beamy = primbeam%head%gil%inc(3)/bsize*2.0*sqrt(log(2.0))
          offx = (doff(1,ifield)+pos(1))/primbeam%head%gil%inc(2)
          offy = (doff(2,ifield)+pos(2))/primbeam%head%gil%inc(3)
          !
          do j=1,nx
             factorx(j) = exp(-((j-primbeam%head%gil%ref(2)-offx)*beamx)**2)
          enddo
          do j=1,ny
             factory = exp(-((j-primbeam%head%gil%ref(3)-offy)*beamy)**2)
             primbeam%data(jfield,:,j,ib) = factorx(:) * factory
          enddo
       enddo
    enddo
    deallocate (factorx)
    !
    ! Loop on fields for imaging
    ! Use Dtmp and Dmap as work arrays for beam and image
    hbeam%r3d => dtmp(:,:,:,1)
    hbeam%gil%dim(4) = 1
    !
    ! Y a un os pour le mode parallele
    dirty%head%r3d => dmap
    !
    my_dirty = 0
    dbeam = 0
    allocate(noises(np))  ! To remember the noise
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP   & SHARED(np,debug,rname,uvmap_prog,huv,primbeam,dbeam,my_dirty) & 
    !$OMP   & FIRSTPRIVATE(dirty,hbeam) &
    !$OMP   & SHARED(voff, selected_fields, noises) &
    !$OMP   & SHARED(nx,ny,nu,nc,duv,wcol,mcol,sblock,cpu0,uvma,btrunc) &
    !$OMP   & PRIVATE(g_weight,g_v,ifield,jfield) &
    !$OMP   & PRIVATE(fstart,fend,nv,do_weig,error,chain) &
    !$OMP   & PRIVATE(old_ib,ic,ib,dtrunc,dmap,dtmp)
    !
    !$OMP DO
    do jfield = np,1,-1
       ifield = selected_fields(jfield)
       ! Pour le mode parallele
       dirty%head%r3d => dmap
       hbeam%r3d => dtmp(:,:,:,1)
       !
       do_weig = .true.
       fstart = voff(ifield)      ! Starting Visibility of field
       fend   = voff(ifield+1)-1  ! Ending Visibility of field
       nv = fend-fstart+1
       if (debug) then
          print *,'Ifield ',ifield,fstart,fend
          print *,'Cols ',wcol,mcol
          print *,'Sizes ',nx,ny,nu,nv,np,nc
          print *,'Calling many_beams_para with SBLOCK ',sblock
       endif
       call many_beams_para (rname,uvmap_prog, huv, hbeam, dirty%head,   &
            &    nx,ny,nu,nv, duv(:,fstart:fend),   &
            &    g_weight, g_v, do_weig,  &
            &    wcol,mcol,sblock,cpu0,error,uvma,ifield)
       noises(jfield) = dirty%head%gil%noise  ! Remember the noise
       !
       old_ib = 0
       !
       do ic=1,nc
          ib = beam_for_channel(ic,dirty%head,hbeam)
          if (debug) print *,'Selected beam ',ib
          ! Add it to the "mosaic dirty" image, by multiplying by
          ! the truncated primary beam
          if (ib.ne.old_ib) then
             dtrunc(:,:) = primbeam%data(jfield,:,:,ib)
             if (debug) print *,'Set DTRUNC ',ib,' # ',old_ib
             where (dtrunc.lt.btrunc) dtrunc = 0
             old_ib = ib
          endif
          !$OMP CRITICAL
          my_dirty(:,:,ic) = my_dirty(:,:,ic) + dmap(:,:,ic)*dtrunc(:,:)
          !$OMP END CRITICAL
       enddo
       !
       ! Save the beam - Transposition could be done here if needed
       dbeam(:,:,:,jfield) = dtmp(:,:,:,1)
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    dirty%head%gil%noise = sum(noises)/np
    !
    hbeam%r4d => dbeam
    !
    ! What about the weights here ?
    if (nb.eq.1) then
       dweight = 0
       call mos_addsq (nx*ny,np,dweight,primbeam%data)
       thre = btrunc**2
       call mos_inverse (nx*ny,dweight,thre)
       if (debug) print *,'Done MOS_INVERSE'
       !
       ! Repack the Beam to 3-Dimensions only
       hbeam%gil%dim(1:4) = [nx,ny,np,1]
       hbeam%gil%convert(:,3) = 1.d0
       hbeam%char%code(3) = 'FIELD'
       hbeam%gil%ndim = 3
    else
       call map_message(seve%e,rname,'More than one beam per field - Weights not computed')
    endif
    !
    call sic_mapgildas('BEAM',hbeam,error,dbeam)
    !
    ! OK we are done (apart from details like Extrema)
    if (.not.error) call map_message(seve%i,rname,'Successful completion')
    primbeam%head%gil%inc(1) = btrunc  ! Convention to store the truncation level
    call sic_mapgildas('PRIMARY',primbeam%head,error,primbeam%data)
    !
    ! Reset the Dirty pointer
    dirty%head%r3d => my_dirty
    ! Correct the noise for the approximate gain at mosaic center
    ! for HWHM hexagonal spacing (normally it is sqrt(1+6/4)) 
    dirty%head%gil%noise = dirty%head%gil%noise/1.5
    if (rname.ne.'MOSAIC_RESTORE') then 
       call sic_mapgildas('DIRTY',dirty%head,error,dirty%data)
       !
       save_data(code_save_beam) = .true.
       save_data(code_save_dirty) = .true.
       save_data(code_save_primary) = .true.
       save_data(code_save_fields) = .true.
       !
       call new_dirty_beam(error)
       if (error) return
       !
       ! Define Min Max
       call map_minmax(dirty%head)
       !
       d_max = dirty%head%gil%rmax
       if (dirty%head%gil%rmin.eq.0) then
          d_min = -0.03*dirty%head%gil%rmax
       else
          d_min = dirty%head%gil%rmin
       endif
    else
       ! Restore the DIRTY image pointer
       dirty%head%r3d => dirty%data
       call map_minmax(dirty%head)
       ! And define the RESIDUAL
       call gdf_copy_header(dirty%head,resid%head,error)
       resid%head%r3d => resid%data
       call map_minmax(resid%head)
       call sic_mapgildas('RESIDUAL',resid%head,error,resid%data)
    endif
    !
    error = .false.
    !
    ! Backward compatibility with previous methods
    clean_user%trunca = btrunc ! By convention ***JP: bizarre to have this here
    primbeam%head%gil%convert(3,4) = bsize ! Primary beam size convention
    call mosaic_main('ON',error)
    !
    if (allocated(w_mapu)) deallocate(w_mapu)
    if (allocated(w_mapv)) deallocate(w_mapv)
    if (allocated(w_grid)) deallocate(w_grid)
    if (allocated(fft)) deallocate(fft)
    return
    !
98  call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
    !
102 format(a,f9.2)
  end subroutine uvmosaic_main
  !
  subroutine map_headers(rname,map,huv,hbeam,hdirty,hprim,nb,nf,mcol)
    use image_def
    use gkernel_interfaces
    use uvmap_types
    !------------------------------------------------------------------------
    ! Define the image headers
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type (uvmap_par), intent(inout) :: map
    type (gildas),    intent(inout) :: huv
    type (gildas),    intent(inout) :: hbeam
    type (gildas),    intent(inout) :: hdirty
    type (gildas),    intent(inout) :: hprim
    integer,          intent(in)    :: nb      ! Number of beams per field
    integer,          intent(in)    :: nf      ! Number of fields
    integer,          intent(inout) :: mcol(2) ! First and last channel
    !
    real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
    !
    type(gildas) :: htmp
    integer :: nx   ! X size
    integer :: ny   ! Y size
    integer :: nc   ! Number of channels
    integer lcol,fcol
    real vref,voff,vinc,schunk
    real(kind=4) :: loff,boff
    logical :: error
    character(len=4) :: code
    !
    nx = map%size(1)
    ny = map%size(2)
    !
    vref = huv%gil%ref(1)
    voff = huv%gil%voff
    vinc = huv%gil%vres
    !
    nc = huv%gil%nchan
    if (mcol(1).eq.0) then
       mcol(1) = 1
    else
       mcol(1) = max(1,min(mcol(1),nc))
    endif
    if (mcol(2).eq.0) then
       mcol(2) = nc
    else
       mcol(2) = max(1,min(mcol(2),nc))
    endif
    fcol = min(mcol(1),mcol(2))
    lcol = max(mcol(1),mcol(2))
    nc = lcol-fcol+1
    !
    ! Make beam, not normalized
    call gdf_copy_header(huv,hbeam,error)
    hbeam%gil%dopp = 0.0 ! Nullify the Doppler factor
    !
    ! Is that right ?
    schunk = nc/nb
    !
    hbeam%gil%ndim = 4
    hbeam%gil%dim(1) = nx
    hbeam%gil%dim(2) = ny
    hbeam%gil%dim(3) = nb
    hbeam%gil%dim(4) = nf
    hbeam%gil%convert(1,1) = nx/2+1
    hbeam%gil%convert(1,2) = ny/2+1
    hbeam%gil%convert(2,1) = 0
    hbeam%gil%convert(2,2) = 0
    hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
    hbeam%gil%convert(3,2) = map%xycell(2)
    hbeam%gil%convert(1,3) = (2.d0*(vref-fcol)+schunk+1.d0)/2/schunk ! Correct
    hbeam%gil%convert(2,3) = voff
    hbeam%gil%convert(:,4) = 1.d0
    hbeam%gil%proj_words = 0
    hbeam%gil%extr_words = 0
    hbeam%gil%reso_words = 0
    hbeam%gil%uvda_words = 0
    hbeam%gil%type_gdf = code_gdf_image
    !
    hbeam%char%code(1) = 'ANGLE'
    hbeam%char%code(2) = 'ANGLE'
    hbeam%char%code(3) = 'VELOCITY'
    hbeam%char%code(4) = 'FIELD'
    hbeam%gil%majo = 0.0
    hbeam%loca%size = nx*ny*nb*nf
    !
    ! Prepare the dirty map header
    call gdf_copy_header(hbeam,hdirty,error)
    hdirty%gil%ndim = 3
    hdirty%gil%dim(1) = nx
    hdirty%gil%dim(2) = ny
    hdirty%gil%dim(3) = nc
    hdirty%gil%dim(4) = 1
    hdirty%gil%convert(1,3) = vref-fcol+1
    hdirty%gil%convert(2,3) = voff
    hdirty%gil%convert(3,3) = vinc
    hdirty%gil%proj_words = def_proj_words
    hdirty%gil%uvda_words = 0
    hdirty%gil%type_gdf = code_gdf_image
    hdirty%char%code(1) = 'RA'
    hdirty%char%code(2) = 'DEC'
    hdirty%char%code(3) = 'VELOCITY'
    call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
         hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
    if (huv%gil%ptyp.eq.p_none) then
       hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
       hdirty%gil%pang = 0.d0     ! Defined in table.
       hdirty%gil%a0 = hdirty%gil%ra
       hdirty%gil%d0 = hdirty%gil%dec
    else
       hdirty%gil%ptyp = p_azimuthal
       hdirty%gil%pang = huv%gil%pang ! Defined in table.
       hdirty%gil%a0 = huv%gil%a0
       hdirty%gil%d0 = huv%gil%d0
    endif
    hdirty%char%syst = 'EQUATORIAL'
    hdirty%gil%xaxi = 1
    hdirty%gil%yaxi = 2
    hdirty%gil%faxi = 3
    hdirty%gil%extr_words = 0          ! extrema not computed
    hdirty%gil%reso_words = 0          ! no beam defined
    hdirty%gil%nois_words = 2
    hdirty%gil%majo = 0
    hdirty%char%unit = 'Jy/beam'
    hdirty%loca%size = nx*ny*nc
    !
    call gildas_null(hprim)
    if (nf.ge.1) then
       call gildas_null(htmp)
       ! Prepare the primary beam cube header
       call gdf_copy_header(hdirty,htmp,error)
       htmp%gil%dim(4) = nf
       htmp%gil%convert(:,4) = 1.d0
       htmp%char%unit = ' '
       htmp%char%code(4) = 'FIELD'
       ! Also reset the Number of Beams in Frequency
       htmp%gil%dim(3) = nb
       code = '4123'
       call gdf_transpose_header(htmp,hprim,code,error)    
    endif
  end subroutine map_headers
  !
  subroutine mosaic_sort(error,sorted,shift,new,uvmax,uvmin,ixoff,iyoff,nf,doff,voff)
    use phys_const, only: pi
    use image_def
    use gkernel_interfaces
    use uv_buffers, only: uv_find_buffers,uv_clean_buffers
    use uv_shift, only: uv_shift_header
    use clean_types
    use uv_buffers
    !----------------------------------------------------------------------
    ! Sort the input UV table
    !----------------------------------------------------------------------
    logical,              intent(inout) :: sorted       ! Is table sorted ?
    logical,              intent(inout) :: shift        ! Do we shift phase center ?
    real(kind=8),         intent(inout) :: new(3)       ! New phase center and PA
    real,                 intent(out)   :: uvmin        ! Min baseline
    real,                 intent(out)   :: uvmax        ! Max baseline
    integer,              intent(in)    :: ixoff,iyoff  ! Offset pointers
    integer,              intent(out)   :: nf           ! Number of fields
    real,    allocatable, intent(out)   :: doff(:,:)    ! Field offsets
    integer, allocatable                :: voff(:)      ! Field visibility offsets
    logical,              intent(inout) :: error
    !
    real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
    real(kind=8) :: freq,off(3)
    real :: pos(2),cs(2)
    integer :: nu,nv
    real, pointer :: duv_previous(:,:),duv_next(:,:)
    !
    ! The UV table is available in HUV%
    if (huv%loca%size.eq.0) then
       call map_message(seve%e,'UV_MAP','No UV data loaded')
       error = .true.
       return
    endif
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    !
    ! Correct for new phase center if required
    if (shift) then
       if (huv%gil%ptyp.eq.p_none) then
          call map_message(seve%w,'SHIFT','No previous phase center info')
          huv%gil%a0 = huv%gil%ra
          huv%gil%d0 = huv%gil%dec
          huv%gil%pang = 0.d0
          huv%gil%ptyp = p_azimuthal
       elseif (huv%gil%ptyp.ne.p_azimuthal) then
          call map_message(seve%w,'SHIFT','Previous projection type not SIN')
          huv%gil%ptyp = p_azimuthal
       endif
       call uv_shift_header(new,huv%gil%a0,huv%gil%d0,huv%gil%pang,off,shift)
       huv%gil%posi_words = def_posi_words
       huv%gil%proj_words = def_proj_words
    endif
    !
    sorted = .false.
    if (.not.shift) then
       call check_order_mosaic(duv,nu,nv,ixoff,iyoff,sorted)
    endif
    !
    ! Get center frequency
    freq = gdf_uv_frequency(huv,huv%gil%ref(1))
    !
    if (sorted) then
       ! If already sorted, use it
       call map_message(seve%i,'UV_MOSAIC','UV table is already sorted')
       !
       ! Load Field coordinates and compute UVMAX
       call mosaic_loadfield(duv,nu,nv,ixoff,iyoff,nf,doff,voff,uvmax,uvmin)
    else
       ! Else, create another copy
       call map_message(seve%i,'UV_MOSAIC','Sorting UV table...')
       !
       ! Compute observing frequency, and new phase center in wavelengths
       if (shift) then
          huv%gil%a0 = new(1)
          huv%gil%d0 = new(2)
          huv%gil%pang = new(3)
          cs(1)  =  cos(off(3))
          cs(2)  = -sin(off(3))
          ! Note that the new phase center is counter-rotated because rotations
          ! are applied before phase shift.
          pos(1) = - freq * f_to_k * ( off(1)*cs(1) - off(2)*cs(2) )
          pos(2) = - freq * f_to_k * ( off(2)*cs(1) + off(1)*cs(2) )
       else
          pos(1) = 0.0
          pos(2) = 0.0
          cs(1) = 1.0
          cs(2) = 0.0
       endif
       !
       ! OK, rotate, shift, sort and copy...
       !
       nullify (duv_previous, duv_next)
       !
       call uv_find_buffers('UV_MOSAIC',nu,nv,duv_previous,duv_next,error)
       if (error) return
       !! call uv_dump_buffers ('UV_MOSAIC - After Find')
       !
       call mosaic_sortuv(nu,nv,huv%gil%ntrail,duv_previous,duv_next,   &
            &        pos,cs,uvmax,uvmin,error,ixoff,iyoff,nf,doff,voff)
       call uv_clean_buffers(duv_previous, duv_next, error)
       if (error) return
       !! call uv_dump_buffers ('UV_MOSAIC- After Clean')
    endif
    !
    ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
    uvmax = uvmax*freq*f_to_k
    uvmin = uvmin*freq*f_to_k
    error = .false.
  end subroutine mosaic_sort
  !
  subroutine mosaic_sortuv(np,nv,ntrail,vin,vout,xy,cs,uvmax,uvmin,&
       error,ixoff,iyoff,nf,doff,voff)
    use phys_const
    use gildas_def
    use gkernel_interfaces
    use uv_rotate_shift_and_sort_tool, only: loaduv,sortuv
    !---------------------------------------------------------------------
    ! Sort a UV table by fields
    ! Rotate, Shift and Sort a UV table for map making
    ! Differential precession should have been applied before.
    !---------------------------------------------------------------------
    integer,              intent(in)    :: np          ! Size of a visibility
    integer,              intent(in)    :: nv          ! Number of visibilities
    integer,              intent(in)    :: ntrail      ! Number of trailing daps
    real,                 intent(in)    :: vin(np,nv)  ! Input visibilities
    real,                 intent(out)   :: vout(np,nv) ! Output visibilities
    real,                 intent(in)    :: xy(2)       ! Phase shift
    real,                 intent(in)    :: cs(2)       ! Frame Rotation
    real,                 intent(out)   :: uvmax       ! Max UV value
    real,                 intent(out)   :: uvmin       ! Min UV value
    integer,              intent(in)    :: ixoff,iyoff
    integer,              intent(out)   :: nf
    real,    allocatable, intent(out)   :: doff(:,:)
    integer, allocatable, intent(out)   :: voff(:)
    logical,              intent(inout) :: error
    !
    logical :: sorted
    integer :: ier,ifi,iv
    integer, allocatable :: ipi(:)       ! Index
    real, allocatable :: rpu(:),rpv(:)   ! U,V coordinates
    real, allocatable :: spv(:)          ! Sorted V coordinates
    real(8), allocatable :: dtr(:)       ! Sorting number
    logical, allocatable :: ips(:)       ! Sign of visibility
    !
    ! Load U,V coordinates, applying possible rotation (CS),
    ! and making all V negative
    allocate (ips(nv),rpu(nv),rpv(nv),ipi(nv),dtr(nv),stat=ier)
    if (ier.ne.0) then
       error = .true.
       return
    endif
    call loaduv(vin,np,nv,cs,rpu,rpv,ips,uvmax,uvmin)
    !!print *,'UVMIN ',uvmin,' UVMAX ',uvmax,' NP ',np,' NV ',nv
    !
    ! Modify the uv coordinates to minimize
    ! the projection errors ... See Sault et al 1996 Appendix 1
    ! Key question here
    ! - modification must be done before sorting
    ! - but should we use the modified or intrinsic UV coordinates ?
    !
    ! For the rotation above, it does not matter, actually: the
    ! matrix commutes (I think so - That can be check later...)
    !
    !  call remapuv(nv,cs,rpu,rpv,ixoff,iyoff,uvmax,uvmin)
    !
    ! Identify number of fields
    call loadfiuv(vin,np,nv,dtr,ipi,sorted,ixoff,iyoff,rpv,nf,doff)
    !
    ! Sort by fields (major number) then V (fractionary part)
    if (.not.sorted) then
       !!print *,'Sorting UV data '
       call gr8_trie(dtr,ipi,nv,error)
       if (error) return
       deallocate (dtr,stat=ier)
       allocate (spv(nv),stat=ier)
       !
       ! One must sort RPV here to use SORTUV later...
       do iv=1,nv
          spv(iv) = rpv(ipi(iv))
       enddo
       rpv(:) = spv(:)
       deallocate (spv,stat=ier)
    else
       deallocate (dtr,stat=ier)
       !!print *,'UV Data is already sorted '
    endif
    !!Read(5,*) ifi
    !
    ! Apply phase shift and copy to output visibilities
    call sortuv(vin,vout,np,nv,ntrail,xy,rpu,rpv,ips,ipi)
    !
    ! Compute start & end of fields
    allocate(voff(nf+1),stat=ier)
    ifi = 1
    voff(ifi) = 1
    do iv=1,nv
       if ( (doff(1,ifi).ne.vout(ixoff,iv)) .or. &
            &  (doff(2,ifi).ne.vout(iyoff,iv)) ) then
          ifi = ifi+1
          voff(ifi) = iv
       endif
    enddo
    voff(nf+1) = nv+1
    !
    !!print *,'XOFF ',ixoff,' YOFF ',iyoff
    do ifi=1,min(nf,20)
       write(*,'(I4,A,2F12.4,2I10)') ifi,' DOFF ', &
            & doff(1,ifi)*180.*3600./pi, &
            & doff(2,ifi)*180.*3600./pi, &
            & voff(ifi), voff(ifi+1)-1
    enddo
  end subroutine mosaic_sortuv
  !
  subroutine check_order_mosaic(visi,np,nv,ixoff,iyoff,sorted)
    !----------------------------------------------------------
    ! Check if visibilites are sorted.
    ! Chksuv does a similar job, but using V values and an index.
    !----------------------------------------------------------
    integer, intent(in) :: np          ! Size of a visibility
    integer, intent(in) :: nv          ! Number of visibilities
    real,    intent(in) :: visi(np,nv) ! Visibilities
    integer, intent(in) :: ixoff       ! X pointing column
    integer, intent(in) :: iyoff       ! Y pointing column
    logical, intent(out) :: sorted
    !
    integer :: iv
    real :: vmax,xoff,yoff
    !
    vmax = visi(2,1)
    xoff = visi(ixoff,1)
    yoff = visi(iyoff,1)
    !
    do iv=2,nv
       if (visi(2,iv).lt.vmax) then
          if (visi(ixoff,iv).eq.xoff .and. visi(iyoff,iv).eq.yoff) then
             !!print *,'Unsorted V at ',iv,visi(2,iv),vmax
             sorted = .false.
             return
          endif
          ! else, this is a new offset
          xoff = visi(ixoff,iv)
          yoff = visi(iyoff,iv)
       else if (visi(ixoff,iv).eq.xoff .and. visi(iyoff,iv).eq.yoff) then
          ! ok, things progress normally
          continue
       else
          ! Unsorted offset
          !!print *,'Unsorted Position offset at ',iv
          sorted = .false.
          return
       endif
       vmax = visi(2,iv)
    enddo
    sorted = .true.
  end subroutine check_order_mosaic
  !
  subroutine loadfiuv(visi,np,nv,dtr,it,sorted,ixoff,iyoff,rpv,nf,doff)
    !----------------------------------------------------------------------
    ! Load field numbers into work arrays for sorting.
    !----------------------------------------------------------------------
    integer,                   intent(in)  :: np          ! Size of a visibility
    integer,                   intent(in)  :: nv          ! Number of visibilities
    real,                      intent(in)  :: visi(np,nv) ! Input visibilities
    real(8),                   intent(out) :: dtr(nv)     ! Output field number
    integer,                   intent(out) :: it(nv)      ! Indexes
    logical,                   intent(out) :: sorted      !
    integer,                   intent(in)  :: ixoff       ! X pointer
    integer,                   intent(in)  :: iyoff       ! Y pointer
    real(4),                   intent(in)  :: rpv(nv)     ! V Values
    integer,                   intent(out) :: nf          ! Number of fields
    real(kind=4), allocatable, intent(out) :: doff(:,:)   ! Fields offsets
    !
    integer :: iv,ifi,mfi,kfi,nfi,ier
    real(8) :: vmax
    real(kind=4), allocatable :: dtmp(:,:)
    !
    ! Scan how many fields
    nfi = 1
    mfi = 100
    !
    ! V are negative values, so this 1 + max(abs(V))
    vmax = 1.0d0-minval(rpv)
    !
    allocate(dtmp(2,mfi),stat=ier)
    dtmp(1,1) = visi(ixoff,1)
    dtmp(2,1) = visi(iyoff,1)
    dtr(1) = 1.d0+rpv(1)/vmax ! We have here 0 =< dtr < 1
    !
    do iv=2,nv
       kfi = 0
       do ifi=1,nfi
          if (visi(ixoff,iv).eq.dtmp(1,ifi) .and. &
               & visi(iyoff,iv).eq.dtmp(2,ifi) ) then
             dtr(iv) = dble(ifi)+rpv(iv)/vmax
             kfi = ifi
             exit
          endif
       enddo
       !
       ! New field
       if (kfi.eq.0) then
          if (nfi.eq.mfi) then
             allocate(doff(2,mfi),stat=ier)
             doff(:,:) = dtmp(:,:)
             deallocate(dtmp)
             allocate(dtmp(2,2*mfi),stat=ier)
             dtmp(:,1:mfi) = doff
             deallocate(doff)
             mfi = 2*mfi
          endif
          nfi = nfi+1
          dtmp(1,nfi) = visi(ixoff,iv)
          dtmp(2,nfi) = visi(iyoff,iv)
          dtr(iv) = dble(nfi)+rpv(iv)/vmax   ! nfi-1 =< dtr < nfi
       endif
    enddo
    !
    nf = nfi
    allocate(doff(2,nfi),stat=ier)
    doff(1:2,:) = dtmp(1:2,1:nfi)
    !
    do iv=1,nv
       it(iv) = iv
    enddo
    !
    ! DTR must in the end be ordered and increasing.
    vmax = dtr(1)
    do iv = 1,nv
       if (dtr(iv).lt.vmax) then
          sorted = .false.
          return
       endif
       vmax = dtr(iv)
    enddo
    sorted = .true.
  end subroutine loadfiuv
  !
  subroutine many_beams_para(rname,map,huv,hbeam,hdirty,&
       nx,ny,nu,nv,uvdata,&
       r_weight,w_v,do_weig,&
       wcol,mcol,sblock,cpu0,error,uvmax,jfield)
    use image_def
    use gkernel_interfaces
    use mapping_interfaces, only: grdflt,convfn,docoor,grdtab,doweig,dotape,dofft
    use mapping_interfaces, only: sump
    use gridding_types
    use uvmap_types
    use uvstat_tool, only: prnoise
    !$ use omp_lib
    !------------------------------------------------------------------------
    ! Compute a map from a CLIC UV Sorted Table
    ! by Gridding and Fast Fourier Transform, with
    ! a different beam per channel.
    !
    ! Input:
    !    a precessed UV table, sorted in V, ordered in
    !    (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    ! Output:
    !    a beam image
    !    a VLM cube
    ! Work space:
    !    a  VLM complex Fourier cube (first V value is for beam)
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname         ! Calling Task name
    type (uvmap_par), intent(inout) :: map           ! Mapping parameters
    type (gildas),    intent(inout) :: huv           ! UV data set
    type (gildas),    intent(inout) :: hbeam         ! Dirty beam data set
    type (gildas),    intent(inout) :: hdirty        ! Dirty image data set
    integer,          intent(in)    :: nx            ! X size
    integer,          intent(in)    :: ny            ! Y size
    integer,          intent(in)    :: nu            ! Size of a visibilities
    integer,          intent(in)    :: nv            ! Number of visibilities
    real,             intent(inout) :: uvdata(nu,nv)
    real, target,     intent(inout) :: r_weight(nv)  ! Weight of visibilities
    real,             intent(inout) :: w_v(nv)       ! V values
    logical,          intent(inout) :: do_weig
    integer,          intent(in)    :: jfield        ! Field number (for mosaic)
    real,             intent(inout) :: cpu0          ! CPU
    real,             intent(inout) :: uvmax         ! Maximum baseline
    integer,          intent(inout) :: sblock        ! Blocking factor
    integer,          intent(inout) :: wcol          ! Weight channel
    integer,          intent(inout) :: mcol(2)       ! First and last channel
    logical,          intent(inout) :: error
    !
    real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
    !
    type (gridding) :: conv
    !
    logical :: local_error
    integer :: nc   ! Number of channels
    integer :: nd   ! Size of data
    integer :: nb   ! Number of beams
    integer :: ns   ! Number of channels per single beam
    integer :: ier
    integer :: ctypx,ctypy
    integer :: lcol,fcol
    integer :: ndim,nn(2),lx,ly,kz1
    integer :: kz,iz,ic,kc,kb,jc,lc
    real :: rmi,rma,wall,cpu1
    real :: xparm(10),yparm(10)
    real :: rms,null_taper(4),wold
    real :: uvcell(2)
    real :: support(2)
    real(kind=4) :: loff,boff
    real(8) :: vref,voff,vinc
    real(8) local_freq
    real(kind=8) :: freq
    real, allocatable :: w_xgrid(:),w_ygrid(:),w_w(:),w_grid(:,:),walls(:)
    real, allocatable :: w_weight(:)
    real, allocatable :: beam(:,:)
    real, allocatable :: w_mapu(:), w_mapv(:)
    real, allocatable :: local_wfft(:)
    complex, allocatable :: ftbeam(:,:)
    complex, allocatable :: tfgrid(:,:,:)
    !
    integer :: ithread,othread,nthread
    real(8) :: elapsed_s,elapsed_e,elapsed
    real :: toto
    character(len=message_length) :: mess
    !
    error = .false.
    nd = nx*ny
    nc = huv%gil%nchan
    nb = hbeam%gil%dim(3)
    !
    ns = map%beam
    null_taper = 0
    !
    if (ns.ne.1 .and. nb.gt.1) then
       write(mess,'(a,i6,a)') 'Processing ',ns,' channels per beam'
       call map_message(seve%w,rname,mess)
    endif
    !
    ! Reset the parameters
    xparm = 0.0
    yparm = 0.0
    !
    vref = huv%gil%ref(1)
    voff = huv%gil%voff
    vinc = huv%gil%vres
    if (mcol(1).eq.0) then
       mcol(1) = 1
    else
       mcol(1) = max(1,min(mcol(1),nc))
    endif
    if (mcol(2).eq.0) then
       mcol(2) = nc
    else
       mcol(2) = max(1,min(mcol(2),nc))
    endif
    fcol = min(mcol(1),mcol(2))
    lcol = max(mcol(1),mcol(2))
    if (wcol.eq.0) then
       wcol = (fcol+lcol)/3
    endif
    wcol = max(1,wcol)
    wcol = min(wcol,nc)
    nc = lcol-fcol+1
    !
    ! Compute observing sky frequency for U,V cell size
    freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
    !
    ! Compute gridding function
    ctypx = map%ctype
    ctypy = map%ctype
    call grdflt (ctypx, ctypy, xparm, yparm)
    call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
    call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
    map%uvcell = clight/freq/(map%xycell*map%size)
    map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
    map%support(2) = yparm(1)*map%uvcell(2)
    !
    ! Process sorted UV Table according to the type of beam produced
    !
    allocate (w_w(nv),w_weight(nv),walls(nb),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Cannot allocate Weight arrays')
       error = .true.
       return
    endif
    w_v(:) = uvdata(2,1:nv)
    !
    lx = (uvmax+map%support(1))/map%uvcell(1) + 2
    ly = (uvmax+map%support(2))/map%uvcell(2) + 2
    lx = 2*lx
    ly = 2*ly
    if (ly.gt.ny) then
       write(mess,'(A,A,F8.3)') 'Map cell is too large ',   &
            ' Undersampling ratio ',float(ly)/float(ny)
       call map_message(seve%e,rname,mess)
       ly = min(ly,ny)
       lx = min(lx,nx)
    endif
    !
    ! Get FFT's and beam work spaces
    allocate (tfgrid(ns+1,lx,ly),ftbeam(nx,ny),beam(nx,ny),&
         & w_mapu(lx),w_mapv(ly),local_wfft(2*max(nx,ny)), &
         & w_xgrid(nx),w_ygrid(ny),w_grid(nx,ny),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Cannot allocate TF arrays')
       error = .true.
       return
    endif
    !
    call docoor(lx,-map%uvcell(1),w_mapu)
    call docoor(ly,map%uvcell(2),w_mapv)
    !
    ndim = 2
    nn(1) = nx
    nn(2) = ny
    call fourt_plan(ftbeam,nn,ndim,-1,1)
    !
    ! Prepare grid correction,
    call grdtab(ny, conv%vbuff, conv%vbias, w_ygrid)
    call grdtab(nx, conv%ubuff, conv%ubias, w_xgrid)
    !
    ! Make beam, not normalized
    call gdf_copy_header(huv,hbeam,error)
    hbeam%gil%dopp = 0    ! Nullify the Doppler factor
    !
    hbeam%gil%ndim = 3
    hbeam%gil%dim(1) = nx
    hbeam%gil%dim(2) = ny
    hbeam%gil%dim(3) = nb
    hbeam%gil%dim(4) = 1
    hbeam%gil%convert(1,1) = nx/2+1
    hbeam%gil%convert(1,2) = ny/2+1
    hbeam%gil%convert(2,1) = 0
    hbeam%gil%convert(2,2) = 0
    hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
    hbeam%gil%convert(3,2) = map%xycell(2)
    !    hbeam%gil%convert(1,3) = vref-fcol+1     ! for 1 per channel
    ! From UV_COMPRESS
    !    uvout%gil%inc(1) = uvout%gil%inc(1)*nc
    !    uvout%gil%ref(1) = (2.0*uvout%gil%ref(1)+nc-1.0)/2/nc
    !    uvout%gil%vres = nc*uvout%gil%vres
    !    uvout%gil%fres = nc*uvout%gil%fres
    !
    hbeam%gil%convert(1,3) = (2.d0*(vref-fcol)+ns+1.d0)/2/ns ! Correct
    hbeam%gil%convert(2,3) = voff
    hbeam%gil%proj_words = 0
    hbeam%gil%extr_words = 0
    hbeam%gil%reso_words = 0
    hbeam%gil%uvda_words = 0
    hbeam%gil%type_gdf = code_gdf_image
    !
    hbeam%char%code(1) = 'ANGLE'
    hbeam%char%code(2) = 'ANGLE'
    hbeam%char%code(3) = 'VELOCITY'
    hbeam%gil%xaxi = 1
    hbeam%gil%yaxi = 2
    hbeam%gil%faxi = 3
    hbeam%gil%majo = 0.0
    hbeam%loca%size = nx*ny*nb
    !
    ! Prepare the dirty map header
    call gdf_copy_header(hbeam,hdirty,error)
    hdirty%gil%ndim = 3
    hdirty%gil%dim(1) = nx
    hdirty%gil%dim(2) = ny
    hdirty%gil%dim(3) = nc
    hdirty%gil%dim(4) = 1
    hdirty%gil%convert(1,3) = vref-fcol+1
    hdirty%gil%convert(2,3) = voff
    hdirty%gil%convert(3,3) = vinc
    hdirty%gil%proj_words = def_proj_words
    hdirty%gil%uvda_words = 0
    hdirty%gil%type_gdf = code_gdf_image
    hdirty%char%code(1) = 'RA'
    hdirty%char%code(2) = 'DEC'
    hdirty%char%code(3) = 'VELOCITY'
    call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
         hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
    if (huv%gil%ptyp.eq.p_none) then
       hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
       hdirty%gil%pang = 0.d0     ! Defined in table.
       hdirty%gil%a0 = hdirty%gil%ra
       hdirty%gil%d0 = hdirty%gil%dec
    else
       hdirty%gil%ptyp = p_azimuthal
       hdirty%gil%pang = huv%gil%pang ! Defined in table.
       hdirty%gil%a0 = huv%gil%a0
       hdirty%gil%d0 = huv%gil%d0
    endif
    hdirty%char%syst = 'EQUATORIAL'
    hdirty%gil%xaxi = 1
    hdirty%gil%yaxi = 2
    hdirty%gil%faxi = 3
    hdirty%gil%extr_words = 0          ! extrema not computed
    hdirty%gil%reso_words = 0          ! no beam defined
    hdirty%gil%nois_words = 2
    hdirty%gil%majo = 0
    hdirty%char%unit = 'Jy/beam'
    hdirty%loca%size = nx*ny*nc
    !
    ! Smooth the beam
    hbeam%gil%convert(3,3) = vinc*ns
    hbeam%gil%vres = ns*vinc
    hbeam%gil%fres = ns*hbeam%gil%fres
    !
    error = .false.
    if (nb.gt.1) then
       !$ othread = omp_get_max_threads()
       !$ nthread = min(othread,nb)
       !$ call omp_set_num_threads(nthread)
    else
       nthread = 1
    endif
    !
    ! Loop over blocks
    !
    !$OMP PARALLEL IF (nb.gt.1) DEFAULT(none) &
    !$OMP PRIVATE(tfgrid,ftbeam,beam,w_weight,w_w) &  ! Big arrays
    !$OMP PRIVATE(w_mapu,w_mapv,w_grid) &
    !$OMP PRIVATE(local_wfft,mess) &
    !$OMP PRIVATE(local_freq,support,wall,wold,rms,uvcell,local_error) &
    !$OMP PRIVATE(kz,kb,kc,iz,ic, kz1, toto, jc,lc) &
    !$OMP SHARED(walls,ns,nb) &
    !$OMP SHARED(nu,nv,nx,ny,nc,nd,fcol,lcol,lx,ly, nthread) &
    !$OMP SHARED(map,null_taper,error) &
    !$OMP SHARED(conv,freq,do_weig, r_weight) &
    !$OMP SHARED(nn,ndim,huv,hbeam,hdirty,rname) &
    !$OMP SHARED(w_xgrid,w_ygrid,w_v,uvdata) &
    !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread)
    !
    kz = 1 ! test for bug below
    !
    ! print *,'KZ ',kz,' NC ',nc,' nd ',nd
    !$OMP DO
    do ic = fcol,lcol,ns ! ,ns or ,1
       kz = min(ns,lcol-ic+1)
       jc = min(huv%gil%nchan,ic+ns/3)   ! The default weight channel here...
       !!print *,'IC ',ic,' JC ',jc,'MCOL ',fcol,lcol,' NS ',ns
       ithread = 1
       !$ elapsed_s = omp_get_wtime()
       !$ ithread = omp_get_thread_num()+1
       !print *,'Thread ',ithread,' IC ',ic,', KZ ',kz,', NS ',ns
       !
       kb = (ic-fcol)/ns+1
       if (kb.gt.nb .or. kb.lt.1) then
          print *,'Programming error, expected 0 < ',kb,' < ',nb+1
          kb = nb
       endif
       !
       w_w(:) = uvdata(7+3*jc,:)
       wold = sump(nv,w_w)
       !
       ! Search for a non empty weight channel
       if (wold.eq.0) then
          do lc=ic,min(ic+ns,lcol) ! not  ,huv%gil%nchan)
             if (lc.ne.jc) then
                w_w(:) = uvdata(7+3*lc,:)
                wold = sump(nv,w_w)
                if (wold.ne.0) then
                   jc = lc
                   exit
                endif
             endif
          enddo
       endif
       !
       if (wold.eq.0) then
          write(mess,'(A,I6,A)') 'Channel ',jc, ' has zero weight'
          hbeam%r3d(:,:,kb) = 0
          hdirty%r3d(:,:,kb) = 0
          walls(kb) = 0.0
          if (nb.eq.1) then
             call map_message(seve%e,rname,mess)
             error = .true.
          else
             call map_message(seve%w,rname,mess)
          endif
          cycle
       else
          wall = 1e-3/sqrt(wold)
          !!write(mess,'(a,i6,a)') 'Plane ',ic,' Natural '
          !!call prnoise('UV_MAP',trim(mess),wall,rms)
          walls(kb) = wall
       endif
       !
       ! Compute the weights from this
       if (do_weig) then
          local_error = .false.
          call doweig(nu,nv,   &
               &    uvdata,   &          ! Visibilities
               &    1,2,    &            ! U, V pointers
               &    jc,     &            ! Weight channel
               &    map%uniform(1),   &  ! Uniform UV cell size
               &    w_weight,   &        ! Weight array
               &    map%uniform(2),   &  ! Fraction of weight
               &    w_v,              &  ! V values
               &    local_error)
          if (local_error)  then
             error = .true.
             cycle
          endif
          !    print *,ic,'doweig',w_v
          !    read(5,*) toto
          !
          ! Should also plug the TAPER here, rather than in DOFFT later  !
          call dotape(nu,nv,   &
               &    uvdata,   &          ! Visibilities
               &    1,2,   &             ! U, V pointers
               &    map%taper,  &        ! Taper
               &    w_weight)            ! Weight array
          !!print *,ic,'dotape'
       else
          call map_message(seve%i,rname,'Reusing weights')
          w_weight = r_weight
       endif
       !
       ! Re-normalize the weights and re-count the noise
       wall = sump(nv,w_weight)
       if (wall.ne.wold) then
          call scawei (nv,w_weight,w_w,wall)
          wall = 1e-3/sqrt(wall)
          !!write(mess,'(a,i6,a)') 'Plane ',ic,' Expected '
          !!call prnoise('UV_MAP',trim(mess),wall,rms)
          walls(kb) = wall
       endif
       !
       ! Then compute the Dirty Beam
       local_freq = gdf_uv_frequency(huv, dble(ic))
       uvcell = map%uvcell * (freq / local_freq)
       support = map%support * (freq / local_freq)
       call docoor(lx,-uvcell(1),w_mapu)
       call docoor(ly,uvcell(2),w_mapv)
       !!print *,ic,'docoor'
       !
       ! Compute FFT's
       call dofft(nu,nv,          &   ! Size of visibility array
            &    uvdata,           &   ! Visibilities
            &    1,2,              &   ! U, V pointers
            &    ic,               &   ! First channel to map
            &    kz,lx,ly,         &   ! Cube size
            &    tfgrid,           &   ! FFT cube
            &    w_mapu,w_mapv,    &   ! U and V grid coordinates
            &    support,uvcell,null_taper, &  ! Gridding parameters
            &    w_weight,w_v,     &    ! Weight array + V Visibilities
            &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
       !!print *,ic,'dofft'
       !
       kz1 = kz+1
       call extracs(kz1,nx,ny,kz1,tfgrid,ftbeam,lx,ly)
       call fourt  (ftbeam, nn,ndim,-1,1,local_wfft)
       beam = 0.0
       call cmtore (ftbeam, beam ,nx,ny)
       call chkfft (beam, nx,ny, error)
       !!   print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1)
       !!print *,'NU,NV ',nu,nv
       !!print *,'IC ',ic
       !!print *,'KZ,LX,LY ',kz,lx,ly
       !!print *,'support ',support,' uvcell ',uvcell, ' null_taper ',null_taper
       !!print *,'conv%ubias,conv%vbias,map%ctype ',conv%ubias,conv%vbias,map%ctype
       !!print *, ' '
       if (error) then
          print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1)
          print *,'Local freq ',local_freq
          print *,'KZ, LX, LY ', kz,lx,ly, ' nx,ny ',nx,ny, ' NS ',ns
          call gagout('E-UV_MAP,  Inconsistent pixel size')
          !      read(5,*) ians
          !      if (ians.eq.1) then
          !        print *,tfgrid(kz+1,:,ly/2)
          !      endif
          cycle
       endif
       !
       ! Compute grid correction,
       ! Normalization factor is applied to grid correction, for further
       ! use on channel maps.
       !
       ! Make beam, not normalized
       call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,beam)  ! grid correction
       !
       ! Normalize and Free beam
       call docorr (beam,w_grid,nx*ny)
       !!print *,ic,'docorr'
       !
       ! Write beam
       hbeam%r3d(:,:,kb) = beam
       !!print *,ic,'Done Beam ',kc,nc
       ! --- Done beam
       !
       ! Now extracts the Image planes...
       do iz=1,kz
          call extracs(kz+1,nx,ny,iz,tfgrid,ftbeam,lx,ly)
          call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
          call cmtore (ftbeam,beam,nx,ny)
          call docorr (beam,w_grid,nd)
          ! Write the subset
          kc = ic-fcol+iz
          hdirty%r3d(:,:,kc) = beam
       enddo
       !
       !$  elapsed_e = omp_get_wtime()
       elapsed = elapsed_e - elapsed_s
       write(mess,103) 'End plane ',kc,' Time ',elapsed &
            & ,' Thread ',ithread
       call map_message(seve%d,rname,mess)
       if (do_weig .and. nb.eq.1) then
          do_weig = .false.
          r_weight = w_weight
       endif
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !$ if (nb.gt.1) call omp_set_num_threads(othread)
    if (error) return
    !
    call gag_cpu(cpu1)
    if (jfield.eq.0) then
       write(mess,102) 'Finished maps ',cpu1-cpu0
       call map_message(seve%i,rname,mess)
    endif
    !
    hdirty%gil%extr_words = def_extr_words  ! extrema computed
    hdirty%gil%minloc = 1
    hdirty%gil%maxloc = 1
    hdirty%gil%minloc(1:3) = minloc(hdirty%r3d)
    hdirty%gil%maxloc(1:3) = maxloc(hdirty%r3d)
    rma = hdirty%r3d(hdirty%gil%maxloc(1),hdirty%gil%maxloc(2),hdirty%gil%maxloc(3))
    rmi = hdirty%r3d(hdirty%gil%minloc(1),hdirty%gil%minloc(2),hdirty%gil%minloc(3))
    hdirty%gil%rmax = rma
    hdirty%gil%rmin = rmi
    !
    wall = maxval(walls(1:nb))
    if (jfield.eq.0) then
       mess = 'Expected'
    else
       write(mess,'(A,I0,A)') 'Field ',jfield,'; Expected'
    endif
    call prnoise(rname,trim(mess),wall,rms)
    hdirty%gil%noise = wall
    !
    ! Delete scratch space
    error = .false.
    if (nb.ne.1)  deallocate(w_grid)
    if (allocated(tfgrid)) deallocate(tfgrid)
    if (allocated(ftbeam)) deallocate(ftbeam)
    if (allocated(w_xgrid)) deallocate(w_xgrid)
    if (allocated(w_ygrid)) deallocate(w_ygrid)
    !
    return
    !
102 format(a,f9.2)
103 format(a,i5,a,f9.2,a,i2,a,i2)
  end subroutine many_beams_para
  !
subroutine mos_inverse(n,weight,thre)
  !----------------------------------------------------------------------
  !
  !----------------------------------------------------------------------
  integer, intent(in) :: n
  real, intent(inout) :: weight(n)
  real, intent(in) :: thre
  !
  integer :: i
  !
  do i=1,n
    if (weight(i).ge.thre) then
      weight(i) = 1.0/weight(i)
    else
      weight(i) = 10.0
    endif
  enddo
end subroutine mos_inverse
!
subroutine mos_addsq(n,nf,weight,lobe)
  !----------------------------------------------------------------------
  !
  !----------------------------------------------------------------------
  integer, intent(in) :: n                      ! Size of arrays
  integer, intent(in) :: nf                     ! Number of fields
  real, intent(inout) :: weight(n)              ! Total weight
  real, intent(in) :: lobe(nf,n)                ! Primary beam array
  !
  integer :: i,if
  !
  do i=1,n
    do if=1,nf
      weight(i) = weight(i)+lobe(if,i)*lobe(if,i)
    enddo
  enddo
end subroutine mos_addsq
!
subroutine mosaic_loadfield(visi,np,nv,ixoff,iyoff,nf,doff,voff,uvmax,uvmin)
  !----------------------------------------------------------------------
  ! Load field coordinates into work arrays after sorting.
  !----------------------------------------------------------------------
  integer, intent(in)  :: np                   ! Size of a visibility
  integer, intent(in)  :: nv                   ! Number of visibilities
  real, intent(in) :: visi(np,nv)              ! Input visibilities
  integer, intent(in)  :: ixoff                ! X pointer
  integer, intent(in)  :: iyoff                ! Y pointer
  integer, intent(out) :: nf                   ! Number of fields
  real(kind=4), intent(out), allocatable :: doff(:,:)  ! Fields offsets
  integer, intent(out), allocatable :: voff(:)  ! Fields visibility offsets
  real, intent(inout) :: uvmax    ! Maximum length
  real, intent(inout) :: uvmin    ! Minimum baseline
  !
  integer :: iv, mfi, nfi, ier
  real(4) :: uv
  real(kind=4), allocatable :: dtmp(:,:)
  integer, allocatable :: vtmp(:)
  !
  ! Scan how many fields
  nfi = 1
  mfi = 100
  uvmax = 0
  uvmin = 1e36
  !
  allocate(dtmp(2,mfi),vtmp(mfi),stat=ier)
  dtmp(1,1) = visi(ixoff,1)
  dtmp(2,1) = visi(iyoff,1)
  vtmp(1) = 1
  nfi = 1
  !
  ! Fields are ordered here, so any change is a new one
  do iv=2,nv
    if (visi(ixoff,iv).ne.dtmp(1,nfi) .or. &
      & visi(iyoff,iv).ne.dtmp(2,nfi) ) then
      !
      ! New field
      if (nfi.eq.mfi) then
        allocate(doff(2,nfi),voff(nfi),stat=ier)
        doff(:,:) = dtmp(:,:)
        voff(:) = vtmp(:)
        deallocate(dtmp,vtmp)
        mfi = 2*mfi
        allocate(dtmp(2,mfi),vtmp(mfi),stat=ier)
        dtmp(:,1:nfi) = doff(:,:)
        vtmp(1:nfi) = voff
        deallocate(doff,voff)
      endif
      !
      nfi = nfi+1
      dtmp(1,nfi) = visi(ixoff,iv)
      dtmp(2,nfi) = visi(iyoff,iv)
      vtmp(nfi) = iv
    endif
    !
    uv = visi(1,iv)**2 + visi(2,iv)**2
    if (uv.ne.0) then
      uvmax = max(uv,uvmax)
      uvmin = min(uv,uvmin)
    endif
    !
  enddo
  !
  ! And put everything in place
  nf = nfi
  allocate(doff(2,nf),voff(nf+1),stat=ier)
  doff(:,:) = dtmp(:,1:nfi)
  voff(1:nfi) = vtmp(1:nfi)
  ! And set the last one
  voff(nfi+1) = nv+1
  deallocate(dtmp)
  !
  uvmax = sqrt(uvmax)
  uvmin = sqrt(uvmin)
end subroutine mosaic_loadfield
end module uvmosaic_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine solve_pass(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  use clic_bpc
  !---------------------------------------------------------------------
  !     +	' SOLVE',	'/PLOT',	'/WEIGHT',	'/OUTPUT',
  !     +	'/RESET',	'/OFFSET',	'/COMPRESS',	'/SEARCH',
  !     +	'/BREAK',	'/POLYNOMIAL',
  !	Computes a passband based on the passband calibrator
  !	assumed to be in the current index.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: isb, iba, lb, kb, ib, i, nd, ndeg, ipol
  integer :: ic, i1,  ndeg1, ndeg2, iy, ix, inbc, ip
  logical :: plot, reset, ok, skip(mbox),spectrum
  character(len=132) :: chain
  integer :: m_pass, old_pen
  integer(kind=address_length) :: ipx,ipy,ipz,ipw,ipp,data_pass
  integer(kind=address_length) :: iwx,iwy,iww,iwi,iwk
  integer :: ir
  real*4 :: rms_err(mbox)
  !
  data m_pass /0/
  save m_pass, data_pass
  !------------------------------------------------------------------------
  spectrum = .false.
  nd = 0
  if (sic_present(14,0)) spectrum = .true.
  call check_index(error)
  if (error) return
  call sic_delvariable ('RMS_ERR',.false.,error)
  call sic_def_real ('RMS_ERR',rms_err,1,n_boxes,.false.,error)
  !
  ! Selecting correlator input
  !
  if (.not.new_receivers) then
    inbc = 1
  else
    if (.not.bb_select.or.n_baseband.ne.1.or.l_baseband(1).ne.1) then
      call show_display('BBAND',.false.,error)
      write(chain,'(A)')   &
        'Select a single baseband using SET BBAND command'
      call message(6,3,'SOLVE_RF',chain)
      error = .true.
      return
    else
      inbc = i_baseband(1,1)
       write(chain,'(A,I1)')   &
            'Calibrating baseband ',inbc
       call message(6,1,'SOLVE_RF',chain)
    endif
  endif
  ! Code:
  ir=r_nrec
  if (sic_present(2,0) .or. sic_present(3,0) .or.   &
    sic_present(5,0) .or. sic_present(6,0) .or. sic_present(7,0) .or.   &
    sic_present(8,0) .or. sic_present(9,0)) then
    call message(6,3,'SOLVE_RF','Option invalid in this context')
    error = .true.
  endif
  if (i_base(1).gt.mnbas) then
    call message(8,4,'SOLVE_RF','Triangle mode not supported')
    error = .true.
  endif
  ! Check plot mode: loop on boxes
  ok = .false.
  do ib = 1, n_boxes
    isb = i_band(k_band(ib))
    iba = i_base(k_base(ib))
    kb = k_subb(ib)
    iy = i_y(k_y(ib))
    ix = i_x(k_x(ib))
    lb = l_subb(kb)
    if (isb.gt.2) then
      call message(4,2,'SOLVE_PASS','Band should be USB or LSB')
      skip(ib) = .true.
    elseif (iy.gt.xy_phase) then
      call message(4,2,'SOLVE_PASS',   &
        'Y axis should be Amplitude or Phase')
      skip(ib) = .true.
    elseif (ix.ne.xy_i_fre .and. do_pass_freq) then
      call message(4,2,'SOLVE_PASS',   &
        'X axis should be I_Freq. for frequency-based mode')
      skip(ib) = .true.
    elseif (ix.lt.xy_chann .or. ix.gt.xy_sky_f) then
      call message(4,2,'SOLVE_PASS',   &
        'X axis should be frequency-like for channel-based mode')
      skip(ib) = .true.
    elseif ((lb.ne.1) .and. (i_subb(1,kb).gt.mbands)   &
      .and. (.not. do_pass_freq)) then
      call message(8,4,'SOLVE_PASS',   &
        'Process line subbands separately in channel mode')
      skip(ib) = .true.
    else
      ok = .true.
      skip(ib)=.false.
    endif
    if (n_data(ib).gt.nd) nd = n_data(ib)
  enddo
if (.not.ok) then
    error = .true.
    return
  endif
  ! Reset option
  reset = sic_present(4,0)
  if (reset) then
    do ir=1, mnrec
      do iba = -mnant, mnbas
        do ip = 1,mnbb            ! Basebands 
          do isb = 1,2
            if (do_pass_freq) then
              bpf_deg(isb,ip,iba,ir) = 10
              fbp_famp(isb,ip,iba,ir) = .false.
              fbp_fpha(isb,ip,iba,ir) = .false.
              do i=1, bpf_deg(isb,ip,iba,ir)
                bp_famp(isb,ip,iba,i,ir)=0
                bp_fpha(isb,ip,iba,i,ir)=0
              enddo
            else
              bpc_band = 0
              do ic=1, mrlband
                bpc_deg(isb,ip,iba,ic,ir) = 4
                fbp_camp(isb,ip,iba,ir) = .false.
                fbp_cpha(isb,ip,iba,ir) = .false.
                fbp_lamp(isb,ip,iba,ic,ir) = .false.
                fbp_lpha(isb,ip,iba,ic,ir) = .false.
                do i=1, bpc_deg(isb,ip,iba,ic,ir)
                  bp_lamp(isb,ip,iba,ic,i,ir)=0
                  bp_lpha(isb,ip,iba,ic,i,ir)=0
                enddo
              enddo
            endif
            do ipol=1,3
              ph_fac(isb,ipol,iba,ir) = 0
            enddo
          enddo
        enddo
      enddo
    enddo
    bp_nant(:) = 0
    bp_ant(:,:) = 0
    bp_phys(:,:) = 0
    change_display = .true.
  endif
  if (do_pass) then
    call message(8,2,'SOLVE_RF','SET RF_PASSBAND reset to OFF')
    do_pass = .false.
    change_display = .true.
  endif
  !
  ! Remember antennas 
  bp_nant(inbc) = r_nant
  do i=1, r_nant
    bp_ant(i,inbc) = i
    bp_phys(i,inbc) = r_kant(i)
  enddo
  !
  ndeg1 = -1
  call sic_i4(line,0,2,ndeg1,.false.,error)
  if (error) goto 999
  if (ndeg1.gt.mbpcdeg) then
    write(chain,'(i3)') mbpcdeg
    call message(6,2,'SOLVE_RF','Degree reset to '//chain(1:3))
  endif
  ndeg1 = min(ndeg1,mbpcdeg)
  ndeg2 = ndeg1
  call sic_i4(line,0,3,ndeg2,.false.,error)
  if (error) goto 999
  if (ndeg2.gt.mbpcdeg) then
    write(chain,'(i3)') mbpcdeg
    call message(6,2,'SOLVE_RF','Degree reset to '//chain(1:3))
  endif
  ndeg2 = min(ndeg2,mbpcdeg)
  if (ndeg1.lt.0) ndeg1 = 0
  if (ndeg2.lt.0) ndeg2 = 1
  ndeg = max(ndeg1,ndeg2)
  if (change_display) then
    call read_spec('ALL',.true.,error) ! all scans in index
    plotted = .false.
    if (error) return
    change_display = .false.
  else
    plotted = .true.
  endif
  plot = sic_present(1,0)
  old_pen = -1
  if (plot) then
    clear = .true.
    if (.not. plotted) call sub_plot('A',.false.,.false.,0,error)
    if (error) return
    plotted = .true.
    old_pen = gr_spen(1)
    call gr_segm('FIT',error)
  endif
  !
  ! save the side band averages in complex array sba
  call save_averages(sba,error)
  if (error) goto 999
  !
  ! Loop on boxes
  ipx = gag_pointer(data_x,memory)
  ipy = gag_pointer(data_y,memory)
  ipz = gag_pointer(data_z,memory)
  ipw = gag_pointer(data_w,memory)
  ir=r_nrec
  if (spectrum) then
    !
    ! Get auxiliary storage
    if (nd*(2*r_nbas+3)*2.gt.m_pass) then
      if (m_pass .gt.0) then
        call free_vm(m_pass,data_pass)
      endif
      m_pass = nd*(2*r_nbas+3)*2
      error = sic_getvm(m_pass,data_pass).ne.1
      if (error) goto 999
    endif
    iwx = gag_pointer(data_pass,memory)
    iww = iwx + 2*nd
    iwy = iww + 2*nd*r_nbas
    iwk = iwy + 2*nd*r_nbas
    iwi = iwk + 2*nd           ! This one is INTEGER only ..
    !
    call solve_pass_spectrum(xy_ampli, m_data, m_boxes, &
      memory(ipx), memory(ipy), memory(ipw), &
      nd, r_nbas, r_nant, memory(iwx), memory(iwy),memory(iww), &
      memory(iwi),memory(iwk),plot,skip,error)

    if (error) goto 999
    call solve_pass_spectrum(xy_phase, m_data, m_boxes, &
      memory(ipx), memory(ipy), memory(ipw), &
      nd, r_nbas, r_nant, memory(iwx), memory(iwy),memory(iww), &
      memory(iwi),memory(iwk),plot,skip,error)
    if (error) goto 999
    isb = r_sb(inbc)
    if (isb.eq.-1) isb = 2
    call set_pass_spectrum(isb,inbc,r_nband,r_nsb,r_nbas+r_ntri,r_lntch,&
                           specc,specl,error)
  else
    do ib = 1, n_boxes
      isb = i_band(k_band(ib))
      iba = i_base(k_base(ib))
      kb = k_subb(ib)
      iy = i_y(k_y(ib))
      ix = i_x(k_x(ib))
      if (skip(ib)) goto 100
      if (sba(isb,iba,ir).eq.0 .and. iba.gt.0) then
        call message(4,2,'SOLVE_PASS',   &
          'No continuum reference for Bas '//cbas(iba)   &
          //' '//cband(isb))
        goto 100
      endif
      nd = n_data(ib)
      if (nd.eq.0) then
        call message(6,3,'SOLVE_PASS','No valid data point in reference box')
        error = .true.
        return
      endif
      i1 = i_subb(1,kb)
      lb = l_subb(kb)
      !
      ! Frequency-dependent passband:
      ! do a polynomial fit, as a function of IF frequency ...
      if (do_pass_freq) then
        if (iy.eq.xy_ampli) then
          ndeg = ndeg1
        elseif (iy.eq.xy_phase) then
          ndeg = ndeg2
        endif
        !
        ! Get auxiliary storage
        if (nd*12.gt.m_pass) then
          if (m_pass .gt.0) then
            call free_vm(m_pass,data_pass)
          endif
          m_pass = nd*12
          error = sic_getvm(m_pass,data_pass).ne.1
          if (error) goto 999
        endif
        ipp = gag_pointer(data_pass,memory)
        ! Do fit and plot
        call fit_polyc(m_data, m_boxes, ib, inbc, nd,   &
          memory(ipx), memory(ipy), memory(ipw), memory(ipz),   &
          memory(ipp), memory(ipp+6*nd),   &
          memory(ipp+8*nd), memory(ipp+10*nd),   &
          memory(ipp+2*nd), plot, ndeg, rms_err(ib), error)
        if (error) goto 999
      !
      ! Channel-based Continuum :
      elseif (i1.le.mbands) then
        if (ix.ne.xy_chann) then
          call message(4,2,'SOLVE_PASS',   &
            'X axis should Channel number, for continuum subbands')
          goto 100
        endif
        call channel_cont(m_data, m_boxes, ib, inbc, nd,   &
          memory(ipx), memory(ipy), memory(ipw), memory(ipz))
        rms_err(ib) = 0
      !
      ! Channel-based line : do polynomial fit
      else
        bpc_band = r_lband
        if (iy.eq.xy_ampli) then
          ndeg = ndeg1
        elseif (iy.eq.xy_phase) then
          ndeg = ndeg2
        endif
        !
        ! Get auxiliary storage
        if (nd*12.gt.m_pass) then
          if (m_pass .gt.0) then
            call free_vm(m_pass,data_pass)
          endif
          m_pass = nd*12
          error = sic_getvm(m_pass,data_pass).ne.1
          if (error) goto 999
        endif
        ipp = gag_pointer(data_pass,memory)
        ! Do fit and plot
        call fit_poly(m_data, m_boxes, ib, inbc, nd,   &
          memory(ipx), memory(ipy), memory(ipw), memory(ipz),   &
          memory(ipp), memory(ipp+6*nd),   &
          memory(ipp+8*nd),   &
          memory(ipp+10*nd), plot, ndeg, rms_err(ib), error)
        if (error) goto 999
      endif
100   continue
    enddo
  endif
998 continue
  if (old_pen.ge.0) then
    call gr_segm_close(error)
    i = gr_spen(old_pen)
  endif
  bp_source = r_sourc
  return
999 error = .true.
  goto 998
end subroutine solve_pass
!
subroutine channel_cont(md, mb, ib, inbc, nd,   &
    x_data, y_data, w_data, z_data)
  use gildas_def
  use classic_api  
  use clic_bpc
  !---------------------------------------------------------------------
  ! CLIC: passband calibration.
  ! store values as channel-by channel for continuum
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  integer :: ib                     !
  integer :: inbc                   !
  integer :: nd                     !
  real :: x_data(md, mb)            !
  real :: y_data(md, mb)            !
  real :: w_data(md, mb)            !
  complex :: z_data(md, mb)         !
  ! Global
  real :: fillin
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: isb, iba, i, ic, iy, ix, ir
  real :: ynorm, data(mcch), faz, pha
  !------------------------------------------------------------------------
  ! Code:
  ! Just store data, normalize amplitudes and phases
  ir = r_nrec
  isb = i_band(k_band(ib))
  iba = i_base(k_base(ib))
  iy = i_y(k_y(ib))
  ix = i_x(k_x(ib))
  !      CALL GETXVALC(IX,ISB,XR,XV,XD)
  if (iy.le.xy_phase) then
    do i=1, r_nband
      data(i) = blank4
    enddo
    do i=1, n_data(ib)
      if (y_data(i,ib).ne.blank4) then
        ic = nint(x_data(i,ib))    ! channel number
        data(ic) = y_data(i,ib)
      endif
    enddo
  endif
  if (iy.eq.xy_ampli) then
    ynorm = abs(zrsba(inbc,isb,iba)/wrsba(inbc,isb,iba))
    do i=1, r_nband
      if (data(i).ne.blank4) then
        bp_camp(isb,inbc,iba,i,ir) = data(i)/ynorm
      else
        data(i) = fillin(data,i,1,r_nband,blank4)
        bp_camp(isb,inbc,iba,i,ir) = data(i)/ynorm
      endif
      !
      if (iba.lt.0) then
        bp_camp(isb,inbc,iba,i,ir) =   &
          sqrt(bp_camp(isb,inbc,iba,i,ir))
      endif
    !
    enddo
    do i=1, n_data(ib)
      ic = nint(x_data(i,ib))  ! channel number
      y_data(i,ib) = data(ic)
    enddo
    fbp_camp(isb,inbc,iba,ir) = sba(isb,iba,ir).ne.0
  elseif (iy.eq.xy_phase) then
    ynorm = faz(zrsba(inbc,isb,iba))
    do i=1, r_nband
      if (data(i).ne.blank4) then
        bp_cpha(isb,inbc,iba,i,ir) = data(i)
      else
        data(i) = fillin(data,i,1,r_nband,blank4)
        bp_cpha(isb,inbc,iba,i,ir) = data(i)
      endif
    enddo
    do i=1, n_data(ib)
      ic = nint(x_data(i,ib))  ! channel number
      y_data(i,ib) = data(ic)
    enddo
    do ic = 1, r_nband
      pha = bp_cpha(isb,inbc,iba,ic,ir)
      if (degrees) then
        pha = pha*pi/180.
      endif
      bp_cpha(isb,inbc,iba,ic,ir) = pha - ynorm
    enddo
    fbp_cpha(isb,inbc,iba,ir) = sba(isb,iba,ir).ne.0
  endif
  return
end subroutine channel_cont
!
subroutine fit_polyc (md,mb,ib,inbc,nd,x_data,y_data,w_data,   &
    z_data,work1,xx,yy,ww,ind,plot,ndeg,rss,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  use clic_bpc
  !---------------------------------------------------------------------
  ! CLIC routine: Passband calibration
  !     Fit polynomial as a function of I_F frequency
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  integer :: ib                     !
  integer :: inbc                   !
  integer :: nd                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  complex :: z_data(md,mb)          !
  real*8 :: work1(3*nd)             !
  real*8 :: xx(nd)                  !
  real*8 :: yy(nd)                  !
  real*8 :: ww(nd)                  !
  integer :: ind(nd)                !
  logical :: plot                   !
  integer :: ndeg                   !
  real :: rss                       !
  logical :: error                  !
  ! Global
  logical :: gr8_random
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: isb, iba, i, l, l1, l2, l3, iy, ix, ir
  real*8 :: a(0:mbpcdeg,0:mbpcdeg), s(0:mbpcdeg)
  real*8 :: work2(2*(mbpcdeg+1)), aa(0:mbpcdeg), x0, x1, x2
  real :: wnorm, faz, pha, ynorm
  character(len=132) :: chain
  !------------------------------------------------------------------------
  ! Code:
  isb = i_band(k_band(ib))
  iba = i_base(k_base(ib))
  iy = i_y(k_y(ib))
  ix = i_x(k_x(ib))
  ir = r_nrec
  !
  wnorm = 0.0                  ! SG was missing...
  if (iy.eq.xy_ampli) then
    !
    ! zrsba contains the associated weights
    ynorm = abs(zrsba(inbc,isb,iba)/wrsba(inbc,isb,iba))
  elseif (iy.eq.xy_phase) then
    ynorm = faz(zrsba(inbc,isb,iba))
  endif
  do i=1, nd
    xx(i) = x_data(i,ib)       ! Inter. freq.
    yy(i) = y_data(i,ib)
    ww(i) = w_data(i,ib)
    if (ww(i).le.0 .or. (abs(yy(i)-blank4).le.d_blank4) ) then
      ww(i) = 1d-10
      yy(i) = 0
    endif
    if (iy.eq.xy_ampli) then
      yy(i) = yy(i)/ynorm
      if (iba.lt.0) then
        yy(i) = sqrt(yy(i))
      endif
    elseif (iy.eq.xy_phase) then
      if (degrees) then
        yy(i) = pi/180.*yy(i)-ynorm
      else
        yy(i) = yy(i)-ynorm
      endif
    endif
    wnorm = wnorm + ww(i)**2
  enddo
  ! Sort if required
  if (gr8_random(xx,nd)) then
    call gr8_trie(xx,ind,nd,error)
    if (error) goto 999
    call gr8_sort(yy,work1,ind,nd)
    call gr8_sort(ww,work1,ind,nd)
  endif
  wnorm = sqrt(wnorm/nd)
  do i=1, nd
    ww(i) = ww(i)/wnorm
  enddo
  call mth_fitpol ('FIT_POLYC',nd,ndeg+1,mbpcdeg+1,xx,yy,ww,   &
    work1,work2,a,s,error)
  if (error) goto 999
  bp_flim(isb,inbc,iba,1,ir) = xx(1)
  bp_flim(isb,inbc,iba,2,ir) = xx(nd)
  if (iy.eq.xy_ampli) then
    do i = 0, ndeg
      bp_famp(isb,inbc,iba,i,ir)=a(ndeg,i)
    enddo
    if (ndeg.lt.bpf_deg(isb,inbc,iba,ir)) then
      do i=ndeg+1, bpf_deg(isb,inbc,iba,ir)
        bp_famp(isb,inbc,iba,i,ir) = 0
      enddo
    endif
    fbp_famp(isb,inbc,iba,ir) = .true.
  elseif (iy.eq.xy_phase) then
    do i=0, ndeg
      pha = a(ndeg,i)
      bp_fpha(isb,inbc,iba,i,ir) = pha
    enddo
    if (ndeg.lt.bpf_deg(isb,inbc,iba,ir)) then
      do i=ndeg+1, bpf_deg(isb,inbc,iba,ir)
        bp_fpha(isb,inbc,iba,i,ir) = 0
      enddo
    endif
    bpf_deg(isb,inbc,iba,ir) = ndeg
    fbp_fpha(isb,inbc,iba,ir) = .true.
  endif
  rss = s(ndeg)
  if (iy.eq.xy_phase .and. degrees) rss = rss*180.0/pi
  ! display results
  l = lenc(y_label(ib))
  l1 = max(3,lenc(header_1(ib)))   ! saves space on listing
  l2 = lenc(header_2(ib))
  l3 = lenc(header_3(ib))
  !
  write(chain,1000) y_label(ib)(1:3), header_1(ib)(1:l1),   &
    header_2(ib)(1:l2), header_3(ib)(1:l3), rss
1000 format(a,'. ',a,1x,' ',a,' ',a,' rms: ',1pg11.4)
  call message(6,1,'SOLVE_RF',chain(1:lenc(chain)))
  !
  if (plot) then
    do i=0, ndeg
      aa(i) = a(ndeg,i)
    enddo
    x0 = xx(1)
    x1 = xx(nd)
    do i=1, nd
      x2 = min(1d0,max(-1d0,(2d0*i-1d0-nd)/(nd-1d0)))
      call mth_getpol('FIT_POLYC',   &
        ndeg+1, aa, x2, yy(i), error)
      if (error) goto 999
      xx(i) = (x0*(1-x2)+x1*(1+x2))/2
      if (iy.eq.xy_ampli) then
        if (iba.lt.0) then
          yy(i) = yy(i)**2
        endif
        yy(i) = yy(i)*ynorm
      elseif (iy.eq.xy_phase) then
        yy(i) = yy(i) + ynorm
        if (degrees) then
          yy(i) = yy(i)*180./pi
        endif
      endif
    enddo
    write(chain,'(I4.4)') ib
    call gr_execl('CHANGE DIRECTORY BOX'//chain)
    error = gr_error()
    if (error) goto 999
    call gr8_connect (nd,xx,yy,0.0d0,-1.0d0)
    call gr_execl('CHANGE DIRECTORY')
  endif
  return
999 error = .true.
  return
end subroutine fit_polyc
!
subroutine fit_poly (md,mb,ib,inbc,nd,x_data,y_data,w_data,z_data,   &
    work1,xx,yy,ww,plot,ndeg,rss,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  use clic_bpc
  !---------------------------------------------------------------------
  ! CLIC routine: Passband calibration
  !     Fit polynomial as a function frequency-like variable in an individual
  !     line subband.
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  integer :: ib                     !
  integer :: inbc                   !
  integer :: nd                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  complex :: z_data(md,mb)          !
  real*8 :: work1(3*nd)             !
  real*8 :: xx(nd)                  !
  real*8 :: yy(nd)                  !
  real*8 :: ww(nd)                  !
  logical :: plot                   !
  integer :: ndeg                   !
  real :: rss                       !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: isb, iba, i, l, l1, l2, l3, ic, iy, ix, ir
  real*8 :: a(0:mbpcdeg,0:mbpcdeg), s(0:mbpcdeg)
  real*8 :: work2(2*(mbpcdeg+1)), aa(0:mbpcdeg), x0, x1, x2
  real :: wnorm, faz, pha, xr, xv, xd, ynorm
  character(len=132) :: chain
  !------------------------------------------------------------------------
  ! Code:
  isb = i_band(k_band(ib))
  iba = i_base(k_base(ib))
  ic = i_subb(1,k_subb(ib))-mbands
  iy = i_y(k_y(ib))
  ix = i_x(k_x(ib))
  ir = r_nrec
  !
  wnorm = 0.0                  ! SG was missing...
  if (iy.eq.xy_ampli) then
    !*!         YNORM = ABS(ZRSBA(ISB,IBA))
    ynorm = abs(zrsba(inbc,isb,iba)/wrsba(inbc,isb,iba))
  elseif (iy.eq.xy_phase) then
    ynorm = faz(zrsba(inbc,isb,iba))
  endif
  call getxvall(ix,isb,ic,xr,xv,xd)
  do i=1, nd
    xx(i) = nint((x_data(i,ib)-xv)/xd+xr)+r_lich(ic)   ! channel number
    yy(i) = y_data(i,ib)
    ww(i) = w_data(i,ib)
    if (i.eq.1 .or. i.gt.nd-2 .or. ww(i).le.0   &
      .or. (abs(yy(i)-blank4).le.d_blank4) ) then
      ww(i) = 1d-10
      yy(i) = 0
    endif
    wnorm = wnorm + ww(i)      !**2   (?)
    if (iy.eq.xy_ampli) then
      yy(i) = yy(i)/ynorm
      if (iba.lt.0) then
        yy(i) = sqrt(yy(i))
      endif
    elseif (iy.eq.xy_phase) then
      if (degrees) then
        yy(i) = pi/180.*yy(i)-ynorm
      else
        yy(i) = yy(i)-ynorm
      endif
    endif
  enddo
  wnorm = wnorm/nd             ! SG itou
  do i=1, nd
    ww(i) = ww(i)/wnorm        !	/sqrt(wnorm)
  enddo
  call mth_fitpol('FIT_POLY',nd,ndeg+1,mbpcdeg+1,xx,yy,ww,   &
    work1,work2,a,s,error)
  if (error) goto 999
  if (iy.eq.xy_ampli) then
    do i = 0, ndeg
      bp_lamp(isb,inbc,iba,ic,i,ir)=a(ndeg,i)
    enddo
    if (ndeg.lt.bpc_deg(isb,inbc,iba,ic,ir)) then
      do i=ndeg+1, bpc_deg(isb,inbc,iba,ic,ir)
        bp_lamp(isb,inbc,iba,ic,i,ir) = 0
      enddo
    endif
    fbp_lamp(isb,inbc,iba,ic,ir) = .true.
  elseif (iy.eq.xy_phase) then
    do i=0, ndeg
      pha = a(ndeg,i)
      bp_lpha(isb,inbc,iba,ic,i,ir) = pha
    enddo
    if (ndeg.lt.bpc_deg(isb,inbc,iba,ic,ir)) then
      do i=ndeg+1, bpc_deg(isb,inbc,iba,ic,ir)
        bp_lpha(isb,inbc,iba,ic,i,ir) = 0
      enddo
    endif
    bpc_deg(isb,inbc,iba,ic,ir) = ndeg
    fbp_lpha(isb,inbc,iba,ic,ir) = .true.
  endif
  rss = s(ndeg)
  ! display results
  l = lenc(y_label(ib))
  l1 = lenc(header_1(ib))
  l2 = lenc(header_2(ib))
  l3 = lenc(header_3(ib))
  !
  write(chain,1000) y_label(ib)(1:3), header_1(ib)(1:l1),   &
    header_2(ib)(1:l2), header_3(ib)(1:l3), rss
1000 format(a,'. ',a,1x,' ',a,' ',a,' rms: ',1pg11.4)
  call message(6,1,'SOLVE_RF',chain(1:lenc(chain)))
  !
  if (plot) then
    do i=0, ndeg
      aa(i) = a(ndeg,i)
    enddo
    x0 = xx(1)
    x1 = xx(nd)
    do i=1, nd
      x2 = ((xx(i)-x0)-(x1-xx(i)))/(x1-x0)
      call mth_getpol('FIT_POLY',   &
        ndeg+1, aa, x2, yy(i), error)
      if (error) goto 999
      xx(i) = x_data(i,ib)
      if (iy.eq.xy_ampli) then
        if (iba.lt.0) then
          yy(i) = yy(i)**2
        endif
        yy(i) = yy(i)*ynorm
      elseif (iy.eq.xy_phase) then
        yy(i) = yy(i) + ynorm
        if (degrees) then
          yy(i) = yy(i)*180./pi
        endif
      endif
    enddo
    write(chain,'(I4.4)') ib
    call gr_execl('CHANGE DIRECTORY BOX'//chain)
    error = gr_error()
    if (error) goto 999
    call gr8_connect (nd,xx,yy,0.0d0,-1.0d0)
    call gr_execl('CHANGE DIRECTORY')
  endif
  return
999 error = .true.
  return
end subroutine fit_poly
!
subroutine getxvall(ix,isb,ic,xr,xv,xd)
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !	Return conversion formula for the X axis of type IX
  !	Valid for spectral correlator
  ! Input:
  !	IX	Integer	Type of data (Chann, Veloc, I_fre, Sky_f)
  !	ISB	Integer	Sideband
  !	IC	Integer SubBand
  ! Output:
  !	XR	Real	Reference point
  !	XV	Real	Value at reference point
  !	XD	Real	Increment per point
  !---------------------------------------------------------------------
  integer :: ix                     !
  integer :: isb                    !
  integer :: ic                     !
  real :: xr                        !
  real :: xv                        !
  real :: xd                        !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  !------------------------------------------------------------------------
  ! Code:
  if (ix.eq.xy_chann) then
    xr = 0
    xv = 0
    xd = 1
  elseif (ix.eq.xy_veloc) then
    xr = r_lrch(isb,ic)
    xv = r_lvoff(isb,ic)
    xd = r_lvres(isb,ic)
  elseif (ix.eq.xy_i_fre) then
    xr = r_lcench(ic)
    xv = r_lfcen(ic)
    xd = r_lfres(ic)
  elseif (ix.eq.xy_sky_f) then
    xr = r_lrch(isb,ic)
    xv = r_lrfoff(isb,ic)
    xd = r_lrfres(isb,ic)
  endif
end subroutine getxvall
!
subroutine getxvalc(ix,isb,xr,xv,xd)
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !	Return conversion formula for the X axis of type IX
  !	Valid for continuum correlator (old model)
  ! Input:
  !	IX	Integer	Type of data (Chann, Veloc, I_fre, Sky_f)
  !	ISB	Integer	Sideband
  ! Output:
  !	XR	Real	Reference point
  !	XV	Real	Value at reference point
  !	XD	Real	Increment per point
  !---------------------------------------------------------------------
  integer :: ix                     !
  integer :: isb                    !
  real :: xr                        !
  real :: xv                        !
  real :: xd                        !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  !------------------------------------------------------------------------
  !
  ! Channel number
  if (ix.eq.xy_chann) then
    xr = 0
    xv = 0
    xd = 1
  ! Velocity
  elseif (ix.eq.xy_veloc) then
    xr = r_crch(isb)
    xv = r_cvoff(isb)
    xd = r_cvres(isb)
  ! IF frequency
  elseif (ix.eq.xy_i_fre) then
    xr = 0.
    xv = 75.
    xd = 50.
  ! Sky Frequency
  elseif (ix.eq.xy_sky_f) then
    xr = r_crch(isb)
    xv = r_crfoff(isb)
    xd = r_crfres(isb)
  endif
end subroutine getxvalc
!
!
function fillin(r,ival,imin,imax,bad)
  !---------------------------------------------------------------------
  ! SAS	Internal routine
  !	Interpolate bad channel (if possible)
  ! Arguments
  !	R	R*4(*)	Array to be interpolated
  !	IVAL	I	Pixel to be interpolated
  !	IMIN	I	First pixel in array
  !	IMAX	I	Last pixel in array
  !	BAD	R*4	Blanking value
  ! Created	21-Mar-1986	S.Guilloteau
  !---------------------------------------------------------------------
  real :: fillin                    !
  integer :: imax                   !
  real :: r(imax)                   !
  integer :: ival                   !
  integer :: imin                   !
  real :: bad                       !
  ! Local
  integer :: i,if,il
  !
  do i=ival-1,imin,-1
    if (r(i).ne.bad) goto 10
  enddo
  !
  ! Rien en dessous, tout au dessus
  do i=ival+1,imax-1
    if (r(i).ne.bad) goto 10
  enddo
  !
  ! Tout mauvais, sauf peut-etre
  fillin = r(imax)
  return
  !
  ! Un bon au dessus ou au dessous
10 if = i
  do i=max(if+1,ival+1),imax
    if (r(i).ne.bad) goto 20
  enddo
  ! Un seul bon
  if (if.gt.ival .or. if.eq.imin) then
    fillin = r(if)
    return
  endif
  do i=if-1,imin,-1
    if (r(i).ne.bad) goto 20
  enddo
  fillin = r(if)
  return
  !
  ! Deux bons
20 il = i
  fillin = ( (ival-if)*r(il) + (il-ival)*r(if) ) / float(il-if)
end function fillin
!
subroutine solve_pass_spectrum(ly,md,mb,x_data,y_data,w_data,   &
    nd, dbas,nant,xx,yy,ww,ind,wk,plot,skip,error)
  use gildas_def
  use gkernel_interfaces
  use clic_bpc
  !---------------------------------------------------------------------
  ! CLIC routine: Passband calibration
  !     Derive antenna gain, that will be interpolated later
  !---------------------------------------------------------------------
  integer :: ly                     !
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  integer :: nd                     !
  integer :: dbas                   !
  integer :: nant                   !
  real*8 :: xx(nd)                  !
  real*8 :: yy(dbas,nd)             !
  real*8 :: ww(dbas,nd)             !
  integer :: ind(nd)                !
  real*8 :: wk(nd)                  !
  logical :: plot
  logical :: skip(mb)
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  ! Local
  logical :: my_do_rf, counting
  integer :: ib
  integer :: isb, iba, i, iy, ix, ia, ja
  integer :: j, mad, mad2, ibb, ibas, nbas, mynd
  parameter (mad=mnant*(mbpcdeg+1),mad2=mad**2)
  real*8 ::  yy1,yyy(m_data),xxx(m_data)
  integer :: iant(mnbas),jant(mnbas), ibsl(mnbas)
  !
  integer :: subtract, nhole, ifirst(mmask), ilast(mmask)
  real :: wnorm, faz, ynorm(mbox), turn
  real :: yp,ym, delta
  real*8 :: xcurs,ycurs
  character(len=132) :: chain
  !
  !------------------------------------------------------------------------
  !------------------------------------------------------------------------
  !
  ! Correlator input
  ! Selecting correlator input
  !
  if (.not.new_receivers) then
    ibb = 1
  else
    ibb = i_baseband(1,1)
  endif
  iba = 0
  !
  ! Loop on boxes to load data from plot buffers.
  wnorm = 0.0
  do ib = 1, n_boxes
    iy = i_y(k_y(ib))
    if (iy.eq.ly.and..not.skip(ib)) then
      ix = i_x(k_x(ib))
      isb = i_band(k_band(ib))
      ibas = i_base(k_base(ib))
      !
      ! Deal with ignored antennas
      ia = r_iant(ibas)
      ja = r_jant(ibas)
      if (my_do_rf(ia,ibb).and.my_do_rf(ja,ibb)) then
        iba = iba+1
        ibsl(ibas) = iba
        subtract = 0
        do i = 1, ia
          if (.not.my_do_rf(i,ibb)) subtract = subtract + 1
        enddo
        ia = ia-subtract
        subtract = 0
        do i = 1, ja
          if (.not.my_do_rf(i,ibb)) subtract = subtract + 1
        enddo
        ja = ja-subtract
        iant(iba) = ia
        jant(iba) = ja
      else
        cycle
      endif
      !
!      nd = n_data(ib)
      wnorm = 0.0
      if (zrsba(ibb,isb,ibas).ne.0) then
        if (iy.eq.xy_ampli) then
          ynorm(ib) =   &
            log(abs(zrsba(ibb,isb,ibas))/wrsba(ibb,isb,ibas))
        elseif (iy.eq.xy_phase) then
          ynorm(ib) = faz(zrsba(ibb,isb,ibas))
        endif
      else
        ynorm(ib) = -2.
      endif
      do i=1, nd
        xx(i) = x_data(i,ib)
        if (w_data(i,ib).gt.0) then
          if (iy.eq.xy_ampli.and.y_data(i,ib).gt.0) then
            yy(iba,i) = log(dble(y_data(i,ib)))
          elseif (iy.eq.xy_phase .and. degrees) then
            yy(iba,i) = y_data(i,ib)*pi/180d0
          else
            yy(iba,i) = y_data(i,ib)
          endif
          if (iy.eq.xy_ampli) then
            ww(iba,i) = w_data(i,ib)*y_data(i,ib)**2
            if (ww(iba,i).lt.2e-6) then
              ww(iba,i) = ww(iba,i)/100.
            endif
            yy(iba,i) = yy(iba,i)-ynorm(ib)
          else
            ww(iba,i) = w_data(i,ib)
            yy(iba,i) = yy(iba,i)-ynorm(ib)
          endif
          wnorm = wnorm + ww(i,iba)
        else
          ww(iba,i) = 0
          if (iy.eq.xy_ampli) then
            yy(iba,i) = blank4
          elseif (iy.eq.xy_phase) then
            yy(iba,i) = 0
          endif
        endif
      enddo
      wnorm = wnorm/nd
    endif
  enddo
  nbas = iba
  ! no amplitude or no phase
  if (wnorm.le.0) return
  ! Sort if required:
!! if needed, do it before transposition
!!  if (gr8_random(xx,nd)) then
!!    call gr8_trie(xx,ind,nd,error)
!!    if (error) goto 999
!!    do iba=1,nbas
!!      call gr8_sort(yy(1,iba),wk,ind,nd)
!!      call gr8_sort(ww(1,iba),wk,ind,nd)
!!    enddo
!!  endif
  !
  do ia =1,  nbas
    iba = ibsl(ia)
    if (ly.eq.xy_ampli) then
      do i = 1, nd
        if (yy(ia,i).eq.blank4) then
          bp_samp(isb,ibb,iba,i) = 0
        else
          bp_samp(isb,ibb,iba,i) = yy(ia,i)
        endif
      enddo
      fbp_samp(isb,ibb,iba) = .true.
    elseif (ly.eq.xy_phase) then
      do i = 1, nd
        bp_spha(isb,ibb,iba,i) = yy(ia,i)
      enddo
      fbp_spha(isb,ibb,iba) = .true.
    endif
  enddo
  ! Set number of points and frequencies
  ! Compute "holes" in spectrum and interpolate
  nhole = 0
  counting = .false.
  if (ly.eq.xy_ampli) then
    do i=1,nd
      bp_fsamp(isb,ibb,i) = xx(i)
      if (.not.counting) then
        if (bp_samp(isb,ibb,1,i).eq.0) then
          nhole = nhole + 1
          ifirst(nhole) = i
          counting  = .true.
        endif
      else
        if (bp_samp(isb,ibb,1,i).ne.0) then
          counting  = .false.
          ilast(nhole) = i-1
        endif
      endif
    enddo
    if (counting) ilast(nhole)=nd
    do i=1, nhole
      do ia =1, nbas
        iba = ibsl(ia)
        ym = 0
        yp = 0
        if (ifirst(i).gt.1) then
          ym=bp_samp(isb,ibb,iba,ifirst(i)-1)
        endif
        if (ilast(i).lt.nd) then
          yp=bp_samp(isb,ibb,iba,ilast(i)+1)
        endif
        if (ilast(i).ne.(ifirst(i)-2)) then
          delta = (yp-ym)/(ilast(i)-ifirst(i)+2)
        endif
        if (yp.ne.0.and.ym.ne.0) then
          do j=ifirst(i),ilast(i)
            if (imask.eq.1) then
              bp_samp(isb,ibb,iba,j) = bp_samp(isb,ibb,iba,ifirst(i)-1) &
                                     +(j-ifirst(i)+1)*delta
            else
              bp_samp(isb,ibb,iba,j) = blank4
            endif
          enddo
        endif
      enddo
    enddo
    !
    ! Add an extra extrapolated point
    mynd = nd+1
    bp_fsamp(isb,ibb,mynd) = 2*bp_fsamp(isb,ibb,mynd-1) &
                               -bp_fsamp(isb,ibb,mynd-2)
    do ia =1, nbas
      iba = ibsl(ia)
      if (bp_samp(isb,ibb,iba,mynd-1).ne.blank4.and. &
          bp_samp(isb,ibb,iba,mynd-2).ne.blank4) then
        bp_samp(isb,ibb,iba,mynd) = 2*bp_samp(isb,ibb,iba,mynd-1) &
                                    - bp_samp(isb,ibb,iba,mynd-2)
      else
        bp_samp(isb,ibb,iba,mynd) = blank4
      endif
    enddo
    !
    ! And set number of points
    nbp_samp(isb,ibb) = mynd
  elseif(ly.eq.xy_phase) then
    do i=1,nd
      bp_fspha(isb,ibb,i) = xx(i)
      if (.not.counting) then
        if (bp_spha(isb,ibb,1,i).eq.0) then
          nhole = nhole + 1
          ifirst(nhole) = i
          counting  = .true.
        endif
      else
        if (bp_spha(isb,ibb,1,i).ne.0) then
          counting  = .false.
          ilast(nhole) = i-1
        endif
      endif
    enddo
   if (counting) ilast(nhole)=nd
   do i=1, nhole
      do ia =1, nant
        iba = ibsl(ia)
        ym = 0
        yp = 0
        if (ifirst(i).gt.1) then
          ym=bp_spha(isb,ibb,iba,ifirst(i)-1)
        endif
        if (ilast(i).lt.nd) then
          yp=bp_spha(isb,ibb,iba,ilast(i)+1)
        endif
        if (ilast(i).ne.(ifirst(i)-2)) then
          delta = (yp-ym)/(ilast(i)-ifirst(i)+2)
        endif
        if (yp.ne.0.and.ym.ne.0) then
          do j=ifirst(i),ilast(i)
            if (imask.eq.1) then
              bp_spha(isb,ibb,iba,j) = bp_spha(isb,ibb,iba,ifirst(i)-1) &
                                     +(j-ifirst(i)+1)*delta
            else
              bp_spha(isb,ibb,iba,j) = blank4
            endif
          enddo
        endif
      enddo
    enddo
    !
    ! Add an extra extrapolated point
    mynd = nd+1
    bp_fspha(isb,ibb,mynd) = 2*bp_fspha(isb,ibb,mynd-1) &
                              -bp_fspha(isb,ibb,mynd-2)
    do ia =1, nbas
      iba = ibsl(ia)
      if (bp_spha(isb,ibb,iba,mynd-1).ne.blank4.and. &
          bp_spha(isb,ibb,iba,mynd-2).ne.blank4) then
        bp_spha(isb,ibb,iba,mynd) = 2*bp_spha(isb,ibb,iba,mynd-1) &
                                    - bp_spha(isb,ibb,iba,mynd-2)
      else
        bp_spha(isb,ibb,iba,mynd) = blank4
      endif
    enddo
    !
    ! And set number of points
    nbp_spha(isb,ibb) = mynd
  endif
  !
  if (plot) then
    do ib=1, n_boxes
      iy = i_y(k_y(ib))
      yyy = 0
      if (iy.eq.ly.and..not.skip(ib)) then
        iba = i_base(k_base(ib))
        isb = i_band(k_band(ib))
        ia = r_iant(iba)
        ja = r_jant(iba)
        if (my_do_rf(ia,ibb).and.my_do_rf(ja,ibb)) then
           do i=1, mynd
            if (ly.eq.xy_ampli) then
              yy1 = dble(bp_samp(isb,ibb,iba,i))
              if (yy1.eq.dble(blank4)) then
                yyy(i) = blank8
              else
                yyy(i) = exp(yy1+ynorm(ib))
              endif
              xxx(i) = bp_fsamp(isb,ibb,i)
            elseif (ly.eq.xy_phase) then
              yy1 = dble(bp_spha(isb,ibb,iba,i))
              if (yy1.eq.dble(blank4)) then
                yyy(i) = blank8
              else
                yyy(i) =yy1+ynorm(ib)
              endif
              if (degrees.and.yyy(i).ne.blank8) then
                yyy(i) = yyy(i)*180d0/pi
              endif
              xxx(i) = bp_fspha(isb,ibb,i)
            endif
          enddo
          write(chain,'(I4.4)') ib
          call gr_execl('CHANGE DIRECTORY BOX'//chain)
          error = gr_error()
          if (error) goto 999
          if (ly.eq.xy_phase) then
            turn = 2d0*pi
            if (degrees) turn = 360d0
            call phi_plot(gb1_y(ib),gb2_y(ib),   &
              mynd,xxx,yyy, turn)
          else
            call gr8_connect (mynd,xxx,yyy,blank8,1.0d0)
          endif
          call gr_execl('CHANGE DIRECTORY')
        else
          write(chain,'(I4.4)') ib
          call gr_execl('CHANGE DIRECTORY BOX'//chain)
          xcurs = 0.5*(gb2_x(ib)+gb1_x(ib))
          ycurs = 0.5*(gb2_y(ib)+gb1_y(ib))
          call relocate(xcurs,ycurs)
!          call putlabel(7,"IGNORED",5)
          call gr_execl('CHANGE DIRECTORY')
        endif
      endif
    enddo
  endif
  !
  bp_spectrum_memory = .false.
  return
  !
999 error = .true.
  return
end subroutine solve_pass_spectrum

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_keywordlist_types
  !----------------------------------------------------------------------
  ! Implement the parsing and resolution of keyword argument from a
  ! predefined list
  !    COMMAND Key
  !----------------------------------------------------------------------
  use cubetools_parameters
  use cubesyntax_messaging
  use cubetools_primitive_arg
  use cubetools_structure_main
  !
  public :: keywordlist_comm_t,cubetools_keywordlist_user2prog
  private
  !
  type, extends(primitive_arg_t) :: keywordlist_comm_t
     integer(kind=4)               :: nkey
     character(len=:), allocatable :: keys(:)
     logical                       :: flexible
  contains
     procedure :: register => cubetools_keywordlist_comm_register
     procedure :: print_abstract => cubetools_keywordlist_comm_list  ! Overloading. ZZZ Should be renamed 'list'
  end type keywordlist_comm_t
  !
contains
  !
  subroutine cubetools_keywordlist_comm_allocate_and_init(lkey,nkey,arg,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=4),          intent(in)    :: lkey
    integer(kind=4),          intent(in)    :: nkey
    type(keywordlist_comm_t), intent(inout) :: arg
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='KEYWORDLIST>COMM>ALLOCATE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (allocated(arg%keys)) then
      call cubesyntax_message(syntaxseve%alloc,rname,'List array already allocated, deallocating')
      deallocate(arg%keys)
    endif
    !
    allocate(character(len=lkey)::arg%keys(nkey),stat=ier)
    if (failed_allocate(rname,'list array',ier,error)) return
    arg%nkey = nkey
    arg%keys(:) = strg_unk
    arg%flexible = .not.flexible
  end subroutine cubetools_keywordlist_comm_allocate_and_init
  !
  subroutine cubetools_keywordlist_comm_put(list,flexibl,arg,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: list(:)
    logical,                  intent(in)    :: flexibl
    type(keywordlist_comm_t), intent(inout) :: arg
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: lkey,nkey
    character(len=*), parameter :: rname='KEYWORDLIST>COMM>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    lkey = len(list)
    nkey = size(list)
    call cubetools_keywordlist_comm_allocate_and_init(lkey,nkey,arg,error)
    if (error) return
    !
    arg%keys(:) = list(:)
    arg%flexible = flexibl
  end subroutine cubetools_keywordlist_comm_put
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_keywordlist_comm_register(templatearg,name,abstract,&
       help,mandat,list,flexibl,keyarg,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keywordlist_comm_t), intent(in)    :: templatearg  ! Template
    character(len=*),          intent(in)    :: name
    character(len=*),          intent(in)    :: abstract
    character(len=*),          intent(in)    :: help
    integer(kind=code_k),      intent(in)    :: mandat
    character(len=*),          intent(in)    :: list(:)
    logical,                   intent(in)    :: flexibl
    type(keywordlist_comm_t),  pointer       :: keyarg !***JP: Which intent?
    logical,                   intent(inout) :: error
    !
    class(primitive_arg_t), pointer :: actualarg
    character(len=*), parameter :: rname='KEYWORDLIST>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! Register the primitive parts, and get pointer to the actual object
    ! saved in the parsing structure
    call cubetools_register_primitive_arg(templatearg,name,abstract,help,mandat,actualarg,error)
    if (error) return
    !
    ! Register the extended parts
    select type (actualarg)
    type is (keywordlist_comm_t)
      keyarg => actualarg
      call cubetools_keywordlist_comm_put(list,flexibl,keyarg,error)
      if (error) return
    class default
      call cubesyntax_message(seve%e,rname,'Internal error: argument has wrong type')
      error = .true.
      return
    end select
  end subroutine cubetools_keywordlist_comm_register
  !
  subroutine cubetools_keywordlist_comm_list(arg,iarg,error)
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    ! Dedicated subroutine for custom display of keywordlist_comm_t argument
    ! abstract in help (as displayed with question mark)
    !-------------------------------------------------------------------
    class(keywordlist_comm_t), intent(in)    :: arg
    integer(kind=narg_k),      intent(in)    :: iarg
    logical,                   intent(inout) :: error
    !
    character(len=mess_l) :: mess
    integer(kind=4) :: ikey
    character(len=*), parameter :: tab = '     '
    character(len=*), parameter :: comma = ','
    logical :: linehead
    character(len=*), parameter :: rname='KEYWORDLIST>COMM>LIST'
    !
    ! One line for the generic help:
    call arg%primitive_arg_t%print_abstract(iarg,error)
    if (error) return
    !
    ! One more line for the specific help:
    if (arg%flexible) then
       mess = tab//'Possible values: '//trim(arg%name)//comma
    else
       mess = tab//'Possible values: '
    endif
    do ikey=1,arg%nkey
       if (len_trim(mess)+len_trim(arg%keys(ikey)).gt.terminal%width()) then
          call cubesyntax_message(syntaxseve%help,rname,mess)
          linehead = .true.
       else
          linehead = .false.
       endif
       if (linehead) then
          write(mess,'(2a)') tab,arg%keys(ikey)
       else
          write(mess,'(A,1X,A)')  trim(mess),arg%keys(ikey)
       endif
       if (ikey.le.arg%nkey-2) write(mess,'(2a)') trim(mess),comma
       if (ikey.eq.arg%nkey-1) write(mess,'(2a)') trim(mess),' or'
    enddo
    call cubesyntax_message(syntaxseve%help,rname,mess)
  end subroutine cubetools_keywordlist_comm_list
  !
  subroutine cubetools_keywordlist_user2prog(arg,ichain,okey,ochain,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    ! Disambiguate a user input from the list of authorized keywords
    !-------------------------------------------------------------------
    type(keywordlist_comm_t), intent(in)    :: arg
    character(len=*),         intent(in)    :: ichain
    integer(kind=code_k),     intent(out)   :: okey
    character(len=*),         intent(out)   :: ochain
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYWORDLIST>USER2PROG'
    !
    if (arg%flexible) then
      call cubetools_disambiguate_flexible(ichain,arg%keys,okey,ochain,error)
      if (error) return
    else
      call cubetools_disambiguate_strict(ichain,arg%keys,okey,ochain,error)
      if (error) return
    endif
  end subroutine cubetools_keywordlist_user2prog
end module cubetools_keywordlist_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sub_alma_ter (   &
     &    l_method,l_hdirty,l_hresid,l_hclean,   &
     &    l_hbeam,l_hprim,l_tfbeam,l_list,   &
     &    c_method,c_hdirty,c_hresid,c_hclean,   &
     &    c_hbeam,c_hprim,c_tfbeam,c_list,   &
     &    error,tcc)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_alma_ter
  use clean_def
  use image_def
  use gbl_message
  !--------------------------------------------------------------
  ! @ private
  !
  ! Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the Multi Resolution which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: l_method, c_method
  type (gildas), intent(inout) :: l_hdirty, l_hbeam, l_hresid, l_hprim
  type (gildas), intent(inout) :: l_hclean
  type (gildas), intent(inout) :: c_hdirty, c_hbeam, c_hresid, c_hprim
  type (gildas), intent(inout) :: c_hclean
  real, intent(inout) :: l_tfbeam(l_hbeam%gil%dim(2),l_hbeam%gil%dim(3),l_hbeam%gil%dim(1))
  real, intent(inout) :: c_tfbeam(c_hbeam%gil%dim(2),c_hbeam%gil%dim(3),c_hbeam%gil%dim(1))
  logical, intent(inout) :: error
  type (cct_par), intent(inout) :: tcc(l_method%m_iter)
  integer, intent(in) :: l_list(:)
  integer, intent(in) :: c_list(:)
  !
  real, pointer :: c_dirty(:,:)    ! Dirty map
  real, pointer :: c_resid(:,:)    ! Iterated residual
  real, pointer :: c_clean(:,:)    ! Clean Map
  real, pointer :: c_dprim(:,:,:)  ! Primary beam
  real, pointer :: c_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: c_weight(:,:)
  !
  real, pointer :: l_dirty(:,:)    ! Dirty map
  real, pointer :: l_resid(:,:)    ! Iterated residual
  real, pointer :: l_clean(:,:)    ! Clean Map
  real, pointer :: l_beam(:,:) ! Beam for fit
  real, pointer :: l_dprim(:,:,:)  ! Primary beam
  real, pointer :: l_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: l_weight(:,:)
  !
  real, allocatable :: w_fft(:) ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  complex, allocatable :: c_work(:,:)  ! Expansion of residual
  real, allocatable :: r_work(:,:) ! Expansion of residual
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable :: w_resid(:,:)
  !
  integer iplane,ibeam
  integer nx,ny,np,mx,my,mp,nc
  integer ier, ix, iy, jx, jy
  real l_max, c_max
  logical do_fft, ok
  character(len=message_length) :: chain
  character(len=7) :: rname = 'COMPACT'
  character(len=2) ans
  integer nker,mker
  parameter (mker=12)
  real smooth
  real, allocatable :: kernel(:,:)
  integer, allocatable :: xcoord(:), ycoord(:)
  integer, allocatable :: labelo(:,:)
  type(cct_par), allocatable :: wcl(:)
  type(cct_par) :: cct_null
  real noise,scale,fhat,long,compact, factor, thre
  real time_begin, time_end
  integer n_extended, kx, ky, kf, n_areas
  integer i, first, last
  logical do_long, more
  integer n_long, n_compact    ! Number of cycles of each type
  integer type_long, type_compact,last_type
  parameter (type_long=1)
  parameter (type_compact=2)
  !
  cct_null%value = 0.0
  cct_null%ix = 0
  cct_null%iy = 0
  !
  error = .false.
  do_fft = .true.
  factor = 0.0
  print *,'Into SUB_ALMA_TER '
  !
  ! Local variables
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  np = l_hprim%gil%dim(1)
  mx = c_hbeam%gil%dim(1)
  my = c_hbeam%gil%dim(2)
  mp = c_hprim%gil%dim(1)
  nc = nx*ny
  !
  allocate (w_work(nx,ny),stat=ier)
  allocate (r_work(nx,ny),stat=ier)
  allocate (c_work(mx,my),stat=ier)
  allocate (w_fft(2*max(nx,ny)),stat=ier)
  allocate (w_comp(nc),stat=ier)
  !
  ! Global residuals
  allocate (w_resid(nx,ny),stat=ier)
  !
  ! Some global pointers
  l_dprim => l_hprim%r3d
  l_dbeam => l_hbeam%r3d
  l_weight=> l_method%weight(:,:,1)
  c_dprim => c_hprim%r3d
  c_dbeam => c_hbeam%r3d
  c_weight=> c_method%weight(:,:,1)
  !
  ! Relative noise contributions
  long = 1.0/l_hdirty%gil%noise**2
  compact = 1.0/c_hdirty%gil%noise**2
  noise = sqrt(long/compact)   ! Mean noise RATIO
  scale = long+compact
  long = long/scale
  compact = compact/scale
  !
  ! Initialize the kernel
  smooth = c_method%smooth
  smooth = 0.0
  if (smooth.eq.0) then
    nker = 4                   ! *** Must compute the true pixel ratio of ACA / ALMA
    nker = nint (c_hdirty%gil%convert(3,2) / l_hdirty%gil%convert(3,2))
    print *,'Nker ',nker
  elseif  (smooth.lt.4) then
    nker = 8
  else
    nker = mker
  endif
  !
  allocate(kernel(nker,nker),stat=ier)
  call init_kernel(kernel,nker,nker,smooth)
  !
  kx = mx/2
  ky = my/2
  kf = kx*ky
  allocate (labelo(kx,ky),stat=ier)
  allocate (wcl(kf),xcoord(kf),ycoord(kf),stat=ier)
  !
  do_long = c_method%n_major.gt.0
  last_type = type_long
  tcc%type = 1
  !
  ! Loop here if needed
  do iplane = l_method%first, l_method%last
     call gag_cpu (time_begin)
     print *,'Starting loop ',iplane
     l_method%flux = 0.0
     c_method%flux = 0.0
     l_method%n_iter= 0
     c_method%n_iter= 0
     !
     l_method%iplane = iplane
     c_method%iplane = iplane
     call beam_plane(l_method,l_hbeam,l_hdirty)
     ibeam = l_method%ibeam
     !
     ! Local aliases
     l_dirty => l_hdirty%r3d(:,:,iplane)
     l_resid => l_hresid%r3d(:,:,iplane)
     l_clean => l_hclean%r3d(:,:,iplane)
     l_beam  => l_hbeam%r3d(:,:,ibeam)
     !
     c_dirty => c_hdirty%r3d(:,:,iplane)
     c_resid => c_hresid%r3d(:,:,iplane)
     c_clean => c_hclean%r3d(:,:,iplane)
     !
     ! Initialize to Dirty map
     l_resid = l_dirty
     c_resid = c_dirty
     !
     ! Prepare beam parameters
     call get_clean (l_method, l_hbeam, l_beam, error)
     if (error) return
     call get_beam (l_method,l_hbeam,l_hresid,l_hprim,   &
          &        l_tfbeam,w_work,w_fft,fhat,error)
     if (error) return
     !
     call get_beam (c_method,c_hbeam,c_hresid,c_hprim,   &
          &        c_tfbeam,w_work,w_fft,fhat,error)
     if (error) return
     !            PRINT *,'Beam gains ',L_METHOD%BGAIN,C_METHOD%BGAIN
     !            L_METHOD%BGAIN = SQRT(L_METHOD%BGAIN*C_METHOD%BGAIN)
     l_resid = l_resid * l_weight
     c_resid = c_resid * c_weight
     !
     ! Performs decomposition into components:
     ! Only one major cycle per iteration, with a limited number
     ! of components ?
     !
     l_method%ngoal = 1000
     n_long = 0
     n_compact = 0
     !
     ! Locate the maximum of the Compact & Normal images
     l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
     c_max = imaxlst (c_method,c_list,c_resid,mx,my,jx,jy)
     ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
     do while (ok)
        !
        ! Plot for debug
        if (l_method%pcycle) then
           call mrc_clear
           call mrc_plot(c_resid,mx,my,2,'Compact')
           call mrc_plot(l_resid,nx,ny,3,'Long')
        endif
        !
        ! NOISE is the Noise RATIO (mean value over the beams)
        !
        if (l_max.gt.c_max/noise .or. do_long) then
           last_type = type_long  ! Use LONG baselines
        else
           ! May be using Compact baselines only. Check sign however
           l_max = l_resid(ix,iy)
           c_max = c_resid(jx,jy)
           thre = min(0.3,c_method%bgain)
           if (c_max*l_max .gt. 0) then
              ! Same sign, use Compact
              last_type = type_compact
           else
              ! Use higher threshold
              last_type = type_compact
              thre = max(0.7,c_method%bgain)
           endif
        endif
        !
        if (last_type.eq.type_long) then
           l_max = abs(l_max)
           print *,'Using LONG baselines ',l_max,c_max/noise
           if (l_method%qcycle) then
              call sic_wpr('WAIT ? ',ans)
           endif
           !
           ! Find components in LONG baseline image
           call one_cycle90 (l_method,l_hclean,   &   !
                &          l_clean,   &   ! Final CLEAN image
                &          l_dbeam,   &   ! Dirty beams
                &          l_resid,nx,ny,   & ! Residual and size
                &          l_tfbeam, w_work,   &  ! FT of dirty beam + Work area
                &          w_comp, nc,         &    ! Component storage + Size
                &          l_method%beam0(1),l_method%beam0(2),   &   ! Beam center
                &          l_method%patch(1),l_method%patch(2),   &
                &          l_method%bgain,l_method%box,   &
                &          w_fft,   &     ! Work space for FFTs
                &          tcc,   &       ! Component table
                &          l_list, l_method%nlist,   & ! Search list
                &          np,   &        ! Number of fields
                &          l_dprim,   &   ! Primary beams
                &          l_weight,   &  ! Weight
                &          l_max)
           !
           ! Define component type
           tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
           ! Remove from COMPACT baselines
           call remove_incompact(c_method,c_resid,mx,my,   &
                &          c_tfbeam, w_fft, mp,c_dprim,c_weight,   &
                &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny)
           ! Define number of iterations and type
           tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
           c_method%n_iter = l_method%n_iter
           c_method%flux = l_method%flux
           do_long = .false.
           n_long = n_long + 1
           ! Test SG
           factor = 0
        else
           print *,'Using COMPACT baselines ',l_max,c_max/noise
           if (l_method%qcycle) then
              call sic_wpr('WAIT ? ',ans)
           endif
           !
           ! Select extended area around this maximum
           thre = thre * c_max
           more = .true.
           do while (more)
              wcl = cct_null
              labelo = 0
              call threshold (c_resid,mx,my,   &   ! Initial image and size
                   &            c_method%blc,c_method%trc,   &   ! Image area
                   &            labelo,kx,ky,   &    ! Subset Image of area numbers
                   &            n_areas,   & ! Number of areas
                   &            xcoord,   &  ! Work space for area numbers
                   &            ycoord,kf,   &   ! Area numbers
                   &            thre,0.0,-1.0)
              !
              if ( (l_method%m_iter-l_method%n_iter).lt.   &
                   &            20*nker**2) then
                 c_method%ngoal = 10
              else
                 c_method%ngoal = min (c_method%ngoal,   &
                      &              (l_method%m_iter-l_method%n_iter)/nker**2)
              endif
              print *,'Threshold ',thre,c_method%ngoal
              call load_cct (c_resid,mx,my,   &
                   &            c_method%blc,c_method%trc,   &   ! Image area
                   &            labelo,kx,ky,   &    ! Subset Image of area numbers
                   &            n_extended,wcl,jx,jy,   &
                   &            c_method%gain,thre,c_method%ngoal)
              !
              write(chain,'(A,I6,A,1pg10.3)')   &
                   &  'Selected ',n_extended,' components above ',thre
              call map_message(seve%i,rname,chain)
              if (n_extended*nker**2+l_method%n_iter .le.   &
                   &            l_method%m_iter) then
                 more = .false.
              else
                 print *,'Stopping '
                 ok = .false.
                 more = .false.
                 do_long = .true.
              endif
           enddo
           !
           if (.not.do_long) then
              !
              ! Compute the scale factor
              if (factor.eq.0) then
                 call normal (   &
                      &              w_work,   &    ! Work space for Component TF
                      &              c_tfbeam,   &  ! Beam TF
                      &              mx,my,   & ! image size
                      &              wcl,     &    ! Selected candidate components
                      &              n_extended,   &    ! Selected Number of components
                      &              w_fft,   & ! FFT work space
                      &              factor)    ! Normalisation factor
                 factor = c_method%gain*abs(c_max)/factor
                 print *,'New factor ',factor
              endif
              !
              ! Expand the components on the fine grid.
              first = c_method%n_iter+1
              do i=1,n_extended
                 ix = wcl(i)%ix
                 iy = wcl(i)%iy
                 c_max = wcl(i)%value * factor
                 !
                 ! Define the corresponding component list AND value
                 call expand_kernel(c_method,mx,my,ix,iy,c_max,   &
                      &              tcc,first,last,nx,ny,   &
                      &              kernel, nker)
                 first = last+1
              enddo
              l_method%n_iter = last
              !
              ! Remove List in Compact Baselines
              call remove_incompact(c_method,c_resid,mx,my,   &
                   &            c_tfbeam, w_fft, mp,c_dprim,c_weight,   &
                   &            tcc,c_method%n_iter+1,l_method%n_iter,nx,ny)
              !
              ! Remove List in Long Baselines
              call remove_inlong(l_method,l_resid,nx,ny,   &
                   &            l_tfbeam, w_fft, np,l_dprim,l_weight,   &
                   &            tcc,c_method%n_iter+1,l_method%n_iter)
              !
              ! Define number of components
              c_method%n_iter = l_method%n_iter
              l_method%flux = c_method%flux
              write(chain,'(A,1PG11.4,A,I6,A)')  'Cleaned ',c_method%flux,  &
                     &  ' Jy in ',c_method%n_iter,' components'
              call map_message(seve%i,rname,chain)
              n_compact = n_compact + 1
           endif
        endif
        ! Stop if done
        l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
        c_max = imaxlst (c_method,c_list,c_resid,mx,my,jx,jy)
        ok = ok .and. (l_max.gt.l_method%ares   &
             &        .or. c_max.gt.c_method%ares)
        if (l_method%n_iter.ge.l_method%m_iter) ok = .false.
        if (sic_ctrlc()) ok = .false.
        ! Continue with ALMA only if not enough components yet
        if (l_method%n_iter .lt. c_method%n_major)   &
             &        do_long = .true.
     enddo
     !
     ! Add clean components and residuals to produce clean map
     ! Note that the Kernel is still scaled in the same way as before
     if (l_method%n_iter.ne.0) then
        call alma_make (l_method, l_hclean, tcc)
     else
        l_clean = 0
     endif
     !
     ! Which residual should be added ?...
     ! We don't want to add noise, but to combine it properly...
     ! We may need to go to the full combined gridding business here...
     l_clean = l_clean + l_resid * l_weight * long
     c_clean = c_resid * c_weight * compact
     call expand (nx,ny,r_work,w_work,mx,my,c_clean,c_work,w_fft)
     where (l_weight.lt.l_method%trunca)
        r_work = 0
     end where
     l_clean = l_clean + r_work
     !
     call gag_cpu (time_end)
     write(chain,*) n_long,' Long baselines cycles'
     call map_message(seve%i,'ALMA',chain)
     write(chain,*) n_compact,' Compact array cycles'
     call map_message(seve%i,'ALMA',chain)
     write(chain,*) time_end-time_begin,' CPU'
     call map_message(seve%i,'ALMA',chain)
  enddo
  !
  ! Cleanup
  deallocate (w_work,r_work,c_work)
  deallocate (w_fft,w_comp,w_resid)
  deallocate (kernel)
  deallocate (labelo,wcl,xcoord,ycoord)
end subroutine sub_alma_ter
!
subroutine load_cct (image,nx,ny,blc,trc,label,mx,my,   &
     &    nv,wcl,ix,iy,gain,tmax,ngoal)
  use clean_def
  ! @ private
  integer, intent(in) :: nx,ny,mx,my,blc(2),trc(2)
  integer, intent(out) :: nv
  integer, intent(in) :: ix,iy
  real(4), intent(in) :: image(nx,ny)
  integer, intent(inout) :: label(mx,my)
  type(cct_par), intent(inout) :: wcl(mx*my)
  integer, intent(in) :: ngoal
  real, intent(in) :: gain
  real, intent(out) :: tmax
  !
  integer i,j,ii,jj,label0, jx,jy, nc
  logical ok
  real rmax
  !
  nv = 0
  nc = 0
  jx = ix-blc(1)+1
  jy = iy-blc(2)+1
  ok = .true.
  do while (ok)
     !
     label0 = label(jx,jy)
     !
     ! First pass to find the max of the omitted values
     rmax = 0.0
     do j=1,my
        do i=1,mx
           if (label(i,j).ne.label0 .and. label(i,j).ne.0) then
              ii = blc(1)+i-1
              jj = blc(2)+j-1
              if (abs(image(ii,jj)).gt.rmax) then
                 rmax = abs(image(ii,jj))
                 jx = i
                 jy = j
              endif
           endif
        enddo
     enddo
     !
     ! Not good ...
     !         RMAX = (1.0-GAIN) * RMAX
     !
     do j=1,my
        do i=1,mx
           if (label(i,j).eq.label0) then
              ii = blc(1)+i-1
              jj = blc(2)+j-1
              if (abs(image(ii,jj)).gt.rmax) then
                 nv = nv+1
                 wcl(nv)%influx = image(ii,jj)
                 wcl(nv)%ix = ii
                 wcl(nv)%iy = jj
                 label (i,j) = 0
              endif
           endif
        enddo
     enddo
     if (rmax.eq.0) return
     tmax = rmax
     nc = nc+1
     !
     ! Selectionner au moins NGOAL, en au plus NC=10 ilots
     if (nv.lt.ngoal .and. nc.lt.10) then
        ok = .true.
     else
        ok = .false.
     endif
  enddo
end subroutine load_cct

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! TELCAL routines related to atmospheric calibration
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine telcal_chopper(chopper,error)
  use gbl_message
  use telcal_interfaces, except_this=>telcal_chopper
  use chopper_definitions
  !----------------------------------------------------------------------
  ! @ public
  !
  ! Compute Trec, Tcal, Tsys from the chop and atm values observed
  ! according to the usual chopper method (ulich and haas) Double side band
  ! operation.
  !
  ! Note that each for each frequency, an error status is set in
  ! chopper%errors(ifreq). It indicates if the operation could be performed
  ! or not. It is the responsibility of the caller to check them or not,
  ! e.g.
  !
  !   call telcal_chopper(chopper,error)
  !   if (error .or. any(chopper%errors(:))  return
  !
  ! If the error status of a given frequency is set to .true., the output
  ! parameters are also nullified to the value chopper%bad, so that the
  ! caller can identify them as bad values.
  ! ----------------------------------------------------------------------
  type(chopper_t), intent(inout) :: chopper
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHOPPER'
  type(dsb_value) :: freq,attenuation
  type(dsb_value) :: tcal,atsys,tsys
  type(chop_load) :: cold,hot
  type(atm_prop) :: atm
  type(mixer)     :: rec
  integer(kind=4) :: ifreq,ier
  real(kind=8) :: sky_count,tsky,temi
  character(len=25) :: atm_mess(3)
  character(len=message_length) :: mess
  integer(kind=4) :: flags(chopper%n) ! Automatic array
  !
  data atm_mess &
       /'zero atmospheric opacity', &
        'no oxygen in atmosphere', &
        'no water in atmosphere'/
  !
  ! Sanity check
  if (chopper%n.le.0) then
     call telcal_message(seve%e,rname,'The chopper type is not allocated')
     error = .true.
     return
  endif
  !
  ! First: Frequency independent stuffs
  flags(:) = flag_valid
  chopper%errors(:) = .true.  ! Default is error .true., kept in case on early exit
  ! 1. Compute air mass number
  chopper%atms%airmass = airmass(chopper%tel%elev,error)
  if (error) then
     call telcal_message(seve%e,rname,'Elevation is not available')
     return
  endif
  ! 2. Initialize atmospheric model
  !    This may be not used in some rare case (e.g. MANUAL mode)
  call atm_atmosp(real(chopper%tel%tout),real(chopper%tel%pres),real(chopper%tel%alti))
  !
  ! Second: Frequency dependent stuffs
  do ifreq = 1,chopper%n
    !
    freq      = chopper%freqs(ifreq)
    sky_count = chopper%loads(ifreq)%sky_count
    hot       = chopper%loads(ifreq)%hot
    cold      = chopper%loads(ifreq)%cold
    !
    if (sky_count.eq.chopper%bad) then
      flags(ifreq) = flag_nosky
      !
    else
      ! Sanity checks
      if (sky_count.ge.hot%count) then
        write(mess,'(A,F0.4,A)') 'Signal stronger on SKY than on HOT load at ', &
            freq%s,' GHz => Bad atmosphere'
        call telcal_message(seve%w,rname,mess)
        flags(ifreq) = flag_badatm
      endif
      if (cold%count.ge.hot%count) then
        write(mess,'(A,F0.4,A)') 'Signal stronger on COLD than on HOT load at ', &
            freq%s,' GHz'
        call telcal_message(seve%w,rname,mess)
        flags(ifreq) = flag_badatm
      endif
    endif
    !
  enddo
  !
  ! Search for water vapor content when asked
  if (chopper%search%water.eq.chopper_water_elem) then
    ! One water vapor amount per frequency
    call telcal_chopper_NwaterN(chopper%search,chopper%tel,chopper%n,  &
      chopper%freqs,chopper%loads,chopper%recs,chopper%atms,flags)
  elseif (chopper%search%water.eq.chopper_water_set) then
    ! One water vapor amount for all frequencies
    call telcal_chopper_1waterN(chopper%search,chopper%tel,chopper%n,  &
      chopper%freqs,chopper%loads,chopper%recs,chopper%atms,flags)
  endif
  !
  !
  do ifreq=1,chopper%n
    !
    if (flags(ifreq).eq.flag_nosky) then
      ! No sky data
      ! Simple receiver temperature computation assuming 100% coupling efficiency of
      ! the hot and cold load. All other output parameters have no meaning.
      !
      rec = chopper%recs(ifreq)
      hot = chopper%loads(ifreq)%hot
      cold = chopper%loads(ifreq)%cold
      call telcal_chopper_nullify(chopper,ifreq)
      !
      rec%temp = (cold%temp*hot%count - hot%temp*cold%count) / (cold%count - hot%count)
      chopper%recs(ifreq)   = rec
      chopper%errors(ifreq) = .false.
      !
    elseif (flags(ifreq).ge.flag_badatm .and. chopper%search%strict) then
      call telcal_chopper_nullify(chopper,ifreq)
      chopper%errors(ifreq) = .true.
      !
    else
      rec   = chopper%recs(ifreq)
      atm   = chopper%atms(ifreq)
      freq  = chopper%freqs(ifreq)
      tcal  = chopper%tcals(ifreq)
      atsys = chopper%atsyss(ifreq)
      tsys  = chopper%tsyss(ifreq)
      !
      sky_count = chopper%loads(ifreq)%sky_count
      hot       = chopper%loads(ifreq)%hot
      !
      ! Compute atmosphere transmission when asked or needed
      if (chopper%search%atm .or. chopper%search%water.ne.chopper_water_fixed) then
        ! Atmospheric parameters are recomputed from water, airmass and frequency
        !   => The water vapor content is assumed to be known
        ier = 0
        call atm_dsb_transmission(freq,atm,ier)
        if (ier.ne.0 .and. atm%h2omm.gt.0.d0) then
          call telcal_message(seve%w,rname,'Calibration problem '//atm_mess(ier))
          if (chopper%search%strict) then
            call telcal_chopper_nullify(chopper,ifreq)
            cycle
          else
            flags(ifreq) = flag_calfailed
          endif
        endif
        ! Compute atmospheric attenuation
        attenuation%s = exp(-atm%taus%tot*atm%airmass)
        attenuation%i = exp(-atm%taui%tot*atm%airmass)
      else
        ! Atmospheric parameters are assumed to be known
        ! => Compute atmospheric attenuation and emission
        attenuation%s = exp(-atm%taus%tot*atm%airmass)
        attenuation%i = exp(-atm%taui%tot*atm%airmass)
        atm%temi%s = atm%temp%s*(1.-attenuation%s)
        atm%temi%i = atm%temp%i*(1.-attenuation%i)
      endif
      !
      ! Compute sky temperatures at signal and image frequency
      temi = (atm%temi%s + atm%temi%i*rec%sbgr) / (1.+rec%sbgr)
      tsky = temi*rec%feff + chopper%tel%tcab*(1.-rec%feff)
      !
      ! Compute Trec when asked
      if (chopper%search%trec) then
        rec%temp = (tsky * (sky_count*(1-hot%ceff) - hot%count) + sky_count * hot%ceff*hot%temp) &
              / (hot%count-sky_count)
      endif
      !
      ! Compute Tcal at zenith and at current elevation when asked
      if (chopper%search%tcal) then
        tcal%s = (hot%temp-tsky)*(1.+rec%sbgr) / rec%beff*hot%ceff
        tcal%i = (hot%temp-tsky)*(1.+1./rec%sbgr) / rec%beff*hot%ceff
      endif
      !
      ! Compute Tsys at zenith and at current elevation when asked
      if (chopper%search%tsys) then
        atsys%s = tcal%s*sky_count / (hot%count-sky_count)
        atsys%i = tcal%i*sky_count / (hot%count-sky_count)
        atsys%s = max(min(1d10,atsys%s),0.d0)
        atsys%i = max(min(1d10,atsys%i),0.d0)
        if (attenuation%s.ne.0.d0) then
           tsys%s = atsys%s / attenuation%s
           tsys%s = max(min(1d10,tsys%s),0.d0)
        endif
        if (attenuation%i.ne.0.d0) then
           tsys%i = atsys%i / attenuation%i
           tsys%i = max(min(1d10,tsys%i),0.d0)
        endif
      endif
      !
      ! Fill back the output structure
      chopper%recs(ifreq)   = rec
      chopper%atms(ifreq)   = atm
      chopper%tcals(ifreq)  = tcal
      chopper%atsyss(ifreq) = atsys
      chopper%tsyss(ifreq)  = tsys
      chopper%errors(ifreq) = flags(ifreq).ge.flag_badatm
    endif
    !
  enddo ! ifreq
  !
end subroutine telcal_chopper
!
subroutine telcal_chopper_NwaterN(search,tel,nfreq,freqs,loads,recs,atms,flags)
  use atm_interfaces_public
  use telcal_interfaces, except_this=>telcal_chopper_NwaterN
  use chopper_definitions
  !---------------------------------------------------------------------
  ! @ private
  ! Compute N independent water vapor amounts for the N frequencies
  !---------------------------------------------------------------------
  type(chop_mode), intent(in)    :: search
  type(telescope), intent(in)    :: tel
  integer(kind=4), intent(in)    :: nfreq
  type(dsb_value), intent(in)    :: freqs(nfreq)
  type(chop_meas), intent(in)    :: loads(nfreq)
  type(mixer),     intent(inout) :: recs(nfreq)
  type(atm_prop),  intent(inout) :: atms(nfreq)
  integer(kind=4), intent(inout) :: flags(nfreq)
  ! Local
  integer(kind=4) :: ifreq
  logical :: use_parallel
  !
  ! Independent search for each frequency
  use_parallel = atm_get_version().eq.'2009'
  !$OMP PARALLEL DO IF (use_parallel) PRIVATE(ifreq)
  do ifreq=1,nfreq
    call telcal_chopper_1water1(search,tel,freqs(ifreq),loads(ifreq),  &
      recs(ifreq),atms(ifreq),flags(ifreq))
  enddo
  !$OMP END PARALLEL DO
  !
end subroutine telcal_chopper_NwaterN
!
subroutine telcal_chopper_1water1(search,tel,freq,load,rec,atm,flag)
  use gbl_message
  use telcal_interfaces, except_this=>telcal_chopper_1water1
  use chopper_definitions
  !---------------------------------------------------------------------
  ! @ private
  ! Compute 1 water vapor amount for 1 frequency
  !---------------------------------------------------------------------
  type(chop_mode), intent(in)    :: search
  type(telescope), intent(in)    :: tel
  type(dsb_value), intent(in)    :: freq
  type(chop_meas), intent(in)    :: load
  type(mixer),     intent(inout) :: rec
  type(atm_prop),  intent(inout) :: atm
  integer(kind=4), intent(inout) :: flag
  ! Local
  character(len=*), parameter :: rname='CHOPPER'
  integer(kind=4) :: kiter,ier
  real(kind=8) :: water,dwater,delta_water
  real(kind=8) :: temi0,temi,dtemi,delta_temi
  character(len=message_length) :: mess
  real(kind=8), parameter :: minwater=1d-6  ! [mm] 1 nm of water vapour. This almost
                                            ! nullifies water opacity even at 183 GHz
  !
  if (flag.eq.flag_nosky)  return
  if (flag.eq.flag_badatm .and. search%strict)  return
  !
  ! Compute rec%temp and temi0
  call telcal_chopper_temperatures(tel,load,search%trec,rec,temi0)
  !
  ! Initialize chopper%search parameters
  ier = 0
  water = min(10.d0,max(0.5d0,atm%h2omm)) ! [mm] Water vapor content (Use previous value if available and reasonable)
  dwater = .02                            ! [mm] Water vapor content offset used to determine the slope of the function: temi(water)
  !
  ! Iterate at most 20 times.
  do kiter=1,20
    !
    ! Atmospheric model 1
    atm%h2omm = water
    call atm_dsb_transmission(freq,atm,ier)
    temi = (atm%temi%s + atm%temi%i*rec%sbgr) / (1.+rec%sbgr)
    delta_temi = temi-temi0
    !
    ! Atmospheric model 2 (for derivation)
    atm%h2omm = water+dwater
    call atm_dsb_transmission(freq,atm,ier)
    dtemi = (atm%temi%s + atm%temi%i*rec%sbgr) / (1.+rec%sbgr) - temi
    !
    ! Exit condition?
    if (water.le.minwater) then
      ! At lower limit
      call telcal_message(seve%d,rname,'Precipitable water vapour very low')
      ! No flag raised = valid anyway
      exit
      !
    elseif (dtemi.eq.0.d0) then
      ! Local minimum => exit
      call telcal_message(seve%w,rname,'Blocked in a local minimum')
      flag = flag_calfailed
      if (search%strict)  exit
      !
    elseif (abs(delta_temi).lt.0.1) then
      ! Reached convergence => exit
      exit
      !
    elseif (kiter.eq.20) then
      ! Too many iterations and total opacity at signal frequency is
      ! large enough to be a real problem => exit
      write(mess,'(A,F0.4,A)')  &
        'Did not converge after 20 iterations at freq ',freq%s,' GHz'
      call telcal_message(seve%w,rname,mess)
      flag = flag_calfailed
      !
    else
      ! Not enough converged. Prepare new iteration:
      !  1. Compute value of water increment
      delta_water = (dwater/dtemi)*delta_temi
      !  2. Compute new water value
      if ((water-delta_water).gt.0) then
        ! New water value is positive => Limit optical depth to about 20. This assumes that: tau propto water
        water = min(water-delta_water,20.*water/(atm%taus%tot)/atm%airmass)
        ! water = min(water-delta_water,20.*water/max(atm%taus%tot,atm%taui%tot)/atm%airmass)
        !  3. Adapt water offset to compute derivative
        if (abs(dwater).ge.abs(delta_water/10.)) dwater = delta_water/10.
      else
        ! New water value would be negative:
        ! water = water-delta_water
        ! However, ATM2009/2016 returns NaN if this happens... Use a lower
        ! (positive) limit and exit right after
        water = minwater
        dwater = 0.d0
      endif
      !
    endif
    !
  enddo  ! kiter
  !
  ! Update structure whatever the result
  atm%h2omm = water
  !
end subroutine telcal_chopper_1water1
!
subroutine telcal_chopper_1waterN(search,tel,nfreq,freqs,loads,recs,atms,flags)
  use gbl_message
  use telcal_interfaces, except_this=>telcal_chopper_1waterN
  use chopper_definitions
  !---------------------------------------------------------------------
  ! @ private
  ! Compute 1 water vapor amount for the N frequencies
  !---------------------------------------------------------------------
  type(chop_mode), intent(in)    :: search
  type(telescope), intent(in)    :: tel
  integer(kind=4), intent(in)    :: nfreq
  type(dsb_value), intent(in)    :: freqs(nfreq)
  type(chop_meas), intent(in)    :: loads(nfreq)
  type(mixer),     intent(inout) :: recs(nfreq)
  type(atm_prop),  intent(inout) :: atms(nfreq)
  integer(kind=4), intent(inout) :: flags(nfreq)
  ! Local
  character(len=*), parameter :: rname='CHOPPER'
  integer(kind=4) :: ifreq,ier,kiter,nvalid
  real(kind=8) :: water,dwater,delta_water
  real(kind=8) :: temi,dtemi,delta_temi
  real(kind=8) :: mean_dtemi,mean_delta_temi,mean_taus,mean_airmass
  ! Automatic arrays
  real(kind=8) :: temi0(nfreq)
  !
  nvalid = 0
  water = 0.d0
  do ifreq=1,nfreq
    !
    if (flags(ifreq).eq.flag_nosky)  cycle
    if (flags(ifreq).ge.flag_badatm .and. search%strict)  cycle
    !
    ! Compute rec%temp and temi0
    call telcal_chopper_temperatures(tel,loads(ifreq),search%trec,recs(ifreq),temi0(ifreq))
    !
    nvalid = nvalid+1
    water = water + atms(ifreq)%h2omm
  enddo
  if (nvalid.eq.0)  return
  water = water/nvalid  ! Mean water guess
  !
  ! Initialize search parameters
  ier = 0
  water = min(10.d0,max(0.5d0,water)) ! [mm] Water vapor content
  dwater = .02                        ! [mm] Water vapor content offset used to determine the slope of the function: temi(water)
  !
  ! Iterate at most 20 times.
  do kiter = 1,20
    !
    nvalid = 0
    mean_delta_temi = 0.d0  ! [ K] Difference between predicted and measured sky emission temperature
    mean_dtemi      = 0.d0
    mean_taus       = 0.d0
    mean_airmass    = 0.d0
    !
    do ifreq=1,nfreq
      !
      if (flags(ifreq).eq.flag_nosky)  cycle
      if (flags(ifreq).ge.flag_badatm .and. search%strict)  cycle
      !
      ! Atmospheric model 1
      atms(ifreq)%h2omm = water
      call atm_dsb_transmission(freqs(ifreq),atms(ifreq),ier)
      temi = (atms(ifreq)%temi%s + atms(ifreq)%temi%i*recs(ifreq)%sbgr) / (1.+recs(ifreq)%sbgr)
      delta_temi = temi - temi0(ifreq)
      !
      ! Atmospheric model 2 (for derivation)
      atms(ifreq)%h2omm = water+dwater
      call atm_dsb_transmission(freqs(ifreq),atms(ifreq),ier)
      dtemi = (atms(ifreq)%temi%s + atms(ifreq)%temi%i*recs(ifreq)%sbgr) / (1.+recs(ifreq)%sbgr) - temi
      !
      ! Exit condition?
      if (dtemi.eq.0.d0) then
        ! Local minimum => exit
        call telcal_message(seve%w,rname,'Blocked in a local minimum')
        flags(ifreq) = flag_calfailed
        if (search%strict)  cycle
      endif
      !
      nvalid = nvalid + 1
      mean_delta_temi = mean_delta_temi + delta_temi
      mean_dtemi = mean_dtemi + dtemi
      mean_taus = mean_taus + atms(ifreq)%taus%tot
      mean_airmass = mean_airmass + atms(ifreq)%airmass
      !
    enddo  ! ifreq
    !
    if (nvalid.eq.0) then
      ! Not a single valid chunk remains (they are all flagged)... nothing more
      ! to be minimized
      exit
    endif
    !
    mean_delta_temi = mean_delta_temi/nvalid
    mean_dtemi = mean_dtemi/nvalid
    mean_taus = mean_taus/nvalid
    mean_airmass = mean_airmass/nvalid
    !
    ! Convergence or not?
    if (abs(mean_delta_temi).lt.0.1) then
      ! delta_temi is less than 0.1 K on average on all considered frequencies
      ! Reached convergence => exit
      exit  ! kiter
      !
    elseif (kiter.eq.20) then
      ! Too many iterations and total opacity at signal frequency is
      ! large enough to be a real problem => exit
      call telcal_message(seve%w,rname,'Did not converge after 20 iterations')
      where (flags.eq.flag_valid)
        flags(:) = flag_calfailed
      end where
      !
    else
      ! Not enough converged. Prepare new iteration:
      !  1. Compute value of water increment
      delta_water = (dwater/mean_dtemi)*mean_delta_temi
      !  2. Compute new water value
      if ((water-delta_water).gt.0) then
        ! New water value is positive => Limit optical depth to about 20. This assumes that: tau propto water
        water = min( water-delta_water,  &
                     20.*water/(mean_taus)/mean_airmass)
        ! water = min(water-delta_water,20.*water/max(atm%taus%tot,atm%taui%tot)/atm%airmass)
      else
        ! New water value is negative
        water = water-delta_water
      endif
      !  3. Adapt water offset to compute derivative
      if (abs(dwater).ge.abs(delta_water/10.)) dwater = delta_water/10.
      !
    endif
    !
  enddo  ! kiter
  !
  ! Update structure whatever the result
  atms(:)%h2omm = water

end subroutine telcal_chopper_1waterN
!
subroutine telcal_chopper_temperatures(tel,load,dotrec,rec,temi0)
  use chopper_definitions
  !---------------------------------------------------------------------
  ! @ private
  !  Compute:
  !   - Trec (if enabled)
  !   - Temi0
  !---------------------------------------------------------------------
  type(telescope), intent(in)    :: tel
  type(chop_meas), intent(in)    :: load
  logical,         intent(in)    :: dotrec
  type(mixer),     intent(inout) :: rec
  real(kind=8),    intent(out)   :: temi0
  ! Local
  real(kind=8) :: tsky
  !
  ! Local estimation Trec if needed
  ! This computation does *not* take the cold and hot coupling into account.
  if (dotrec) then
    rec%temp = (load%cold%temp*load%hot%count - load%hot%temp*load%cold%count) / &
               (load%cold%count - load%hot%count)
  endif
  !
  ! Now we are able to compute the sky emission temperature from sky and hot
  ! load measures. This value will be compared with the emission temperature
  ! predicted by ATM with different water vapor content.
  ! This computation takes into account the hot coupling. So there is
  ! some sort of inconsistency with above.
  tsky = ((load%hot%ceff*load%hot%temp + rec%temp) * load%sky_count / load%hot%count - rec%temp) &
               /  &
         (1. - load%sky_count * (1.-load%hot%ceff) / load%hot%count)
  !
  temi0 = (tsky - (1.-rec%feff) * tel%tcab) / rec%feff
  !
end subroutine telcal_chopper_temperatures
!
subroutine telcal_chopper_nullify(chopper,ifreq)
  use chopper_definitions
  !---------------------------------------------------------------------
  ! @ public
  !  Nullify the chopper results (only the outputs, not the inputs) e.g.
  ! in case of error
  !---------------------------------------------------------------------
  type(chopper_t), intent(inout) :: chopper
  integer(kind=4) :: ifreq
  !
  chopper%recs(ifreq)%temp = chopper%bad
  !
  chopper%atms(ifreq)%h2omm  = chopper%bad
  chopper%atms(ifreq)%temi%s = chopper%bad
  chopper%atms(ifreq)%temi%i = chopper%bad
  chopper%atms(ifreq)%temp%s = chopper%bad
  chopper%atms(ifreq)%temp%i = chopper%bad
  chopper%atms(ifreq)%taus%wat = chopper%bad
  chopper%atms(ifreq)%taus%oth = chopper%bad
  chopper%atms(ifreq)%taus%tot = chopper%bad
  chopper%atms(ifreq)%taui%wat = chopper%bad
  chopper%atms(ifreq)%taui%oth = chopper%bad
  chopper%atms(ifreq)%taui%tot = chopper%bad
  !
  chopper%tcals(ifreq)%s  = chopper%bad
  chopper%tcals(ifreq)%i  = chopper%bad
  chopper%atsyss(ifreq)%s = chopper%bad
  chopper%atsyss(ifreq)%i = chopper%bad
  chopper%tsyss(ifreq)%s  = chopper%bad
  chopper%tsyss(ifreq)%i  = chopper%bad
  !
end subroutine telcal_chopper_nullify
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
function airmass(el,error)
  use gbl_message
  use telcal_interfaces, except_this=>airmass
  !----------------------------------------------------------------------
  ! @ public
  ! Compute airmass number corresponding to elevation EL
  ! Use a curved atmosphere, equivalent height 5.5 km
  !----------------------------------------------------------------------
  real(8), intent(in)  :: el      ! Elevation [radian]
  logical, intent(out) :: error   ! Error flag
  real(8)              :: airmass ! Airmass
  !
  ! Local variables
  real(8) :: r0,h0,delev,eps,gamma,hz
  parameter (h0=5.5d0,r0=6370.d0)
  !
  error = .false.
  if (el.eq.0.) then
     call telcal_message(seve%e,'AIRMASS','Elevation is zero-valued')
     error = .true.
     return
  endif
  delev = el
  eps= asin(r0/(r0+h0)*cos(delev))
  gamma= delev + eps
  hz = r0*r0 + (r0+h0)**2 - 2.d0*r0*(r0+h0)*sin(gamma)
  hz = sqrt (max(h0**2,hz)) ! Avoid less than one airmass
  hz = hz/h0
  hz = min (hz, 20.d0)
  airmass = hz
end function airmass
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine atm_dsb_transmission(freq,atm,ier)
  use atm_interfaces_public
  use telcal_interfaces, except_this=>atm_dsb_transmission
  use chopper_definitions
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type (dsb_value), intent(in)    :: freq !
  type (atm_prop),  intent(inout) :: atm  ! Atm%h2omm and others must be defined
  integer,          intent(inout) :: ier  ! Error flag
  !
  ! Local variables
  real :: temi,tatm,tau_wat,tau_oth,tau_tot
  !
  ! Signal frequency
  call atm_transm( &
       real(atm%h2omm), &
       real(atm%airmass), &
       real(freq%s), &
       temi,tatm, &
       tau_oth,tau_wat,tau_tot, &
       ier)
  ! Implicit casting from real to double
  atm%temi%s = temi
  atm%temp%s = tatm
  atm%taus%wat = tau_wat
  atm%taus%oth = tau_oth
  atm%taus%tot = tau_tot
  !
  ! Image frequency
  call atm_transm( &
       real(atm%h2omm), &
       real(atm%airmass), &
       real(freq%i), &
       temi,tatm, &
       tau_oth,tau_wat,tau_tot, &
       ier)
  ! Implicit casting from real to double
  atm%temi%i = temi
  atm%temp%i = tatm
  atm%taui%wat = tau_wat
  atm%taui%oth = tau_oth
  atm%taui%tot = tau_tot
  !
end subroutine atm_dsb_transmission
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mapping_interfaces
  !---------------------------------------------------------------------
  ! MAPPING interfaces, all kinds (private or public).
  !---------------------------------------------------------------------
  !
  use mapping_interfaces_public
  use mapping_interfaces_private
  !
end module mapping_interfaces
!
module mapping_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! MAPPING dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use gkernel_interfaces
  use astro_interfaces_public
end module mapping_dependencies_interfaces

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_index_iterator_tool
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_node_class
  use cubedag_link_type
  use cubedag_dag_buffer

  public :: code_iter_unknown,ncode_iter,iter_names,iter_abstracts
  public :: index_iterator_t
  private
  !
  ! --- Public iteration codes -----------------------------------------
  integer(kind=code_k), parameter :: code_iter_unknown     = 0
  integer(kind=code_k), parameter :: code_iter_current     = 1
  integer(kind=code_k), parameter :: code_iter_next        = 2
  integer(kind=code_k), parameter :: code_iter_previous    = 3
  integer(kind=code_k), parameter :: code_iter_first       = 4
  integer(kind=code_k), parameter :: code_iter_last        = 5
  integer(kind=code_k), parameter :: code_iter_beforefirst = 6
  integer(kind=code_k), parameter :: code_iter_afterlast   = 7
  integer(kind=code_k), parameter :: ncode_iter = code_iter_afterlast
  !
  character(len=*), parameter :: iter_names(ncode_iter) = [&
       'CURRENT    ',&
       'NEXT       ','PREVIOUS   ',&
       'FIRST      ','LAST       ',&
       'BEFOREFIRST','AFTERLAST  ']
  !
  character(len=*), parameter :: iter_abstracts(ncode_iter) = [&
       'current     ',&
       'next        ','previous    ',&
       'first       ','last        ',&
       'before first','afterlast   ']
  ! --------------------------------------------------------------------

  integer(kind=code_k), parameter :: start_noninitialized=1
  integer(kind=code_k), parameter :: start_before=2
  integer(kind=code_k), parameter :: start_current=3
  integer(kind=code_k), parameter :: start_after=4

  ! Private type which saves the iterator status
  type :: index_internal_t
    type(cubedag_link_t), pointer, private :: optx
    integer(kind=code_k),          private :: start = start_noninitialized
    integer(kind=iden_l),          private :: current_id
  contains
    procedure, private :: current_num => index_iterator_current_num
  end type index_internal_t
  ! Keep the iterator status in a private instance
  type(index_internal_t) :: gbl_iter

  ! Public methods to which interact with the internal iterator
  type :: index_iterator_t
  contains
    procedure, nopass, public :: get        => index_iterator_get
    procedure, nopass, public :: put        => index_iterator_put
    procedure, nopass, public :: is_current => index_iterator_is_current
  end type index_iterator_t

contains

  subroutine index_iterator_get(what,out,error)
    !-------------------------------------------------------------------
    ! Return the identifier suited for the given "what" code
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: what
    integer(kind=iden_l), intent(out)   :: out
    logical,              intent(inout) :: error
    !
    integer(kind=entr_k), parameter :: entry_none=-1
    integer(kind=entr_k), parameter :: entry_first=2  ! Skip root
    integer(kind=entr_k) :: newent
    character(len=mess_l) :: mess
    class(cubedag_node_object_t), pointer :: obj
    character(len=*), parameter :: rname='GET>CURRENT'
    !
    ! call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    if (.false.) then  ! ZZZ Need a way to customize the target
      gbl_iter%optx => cx
    else
      gbl_iter%optx => ix
    endif
    !
    select case (what)
    case (code_iter_beforefirst)
      gbl_iter%start = start_before
      newent = entry_none
    case (code_iter_afterlast)
      gbl_iter%start = start_after
      newent = entry_none
    case (code_iter_current)
      call gbl_iter%current_num(newent,error)
      if (error)  return
    case (code_iter_first)
      newent = entry_first
    case (code_iter_last)
      newent = gbl_iter%optx%n
    case (code_iter_next)
      if (gbl_iter%start.eq.start_noninitialized .or.  &
          gbl_iter%start.eq.start_before) then
        newent = entry_first
      else
        call gbl_iter%current_num(newent,error)
        if (error)  return
        newent = newent+1
      endif
      if (newent.gt.gbl_iter%optx%n) then  ! ZZZ Loop mode?
        call cubedag_message(seve%e,rname,'Reached end of index')
        error = .true.
        return
      endif
    case (code_iter_previous)
      if (gbl_iter%start.eq.start_noninitialized .or.  &
          gbl_iter%start.eq.start_after) then
        newent = gbl_iter%optx%n
      else
        call gbl_iter%current_num(newent,error)
        if (error)  return
        newent = newent-1
      endif
      if (newent.lt.entry_first) then  ! ZZZ Loop mode?
        call cubedag_message(seve%e,rname,'Reached start of index')
        error = .true.
        return
      endif
    case default
      call cubedag_message(seve%e,rname,'Unexpected iterator code')
      error = .true.
      return
    end select
    !
    if (newent.eq.entry_none) then
      call cubedag_message(seve%d,rname,'No entry to get here')
      out = code_null
    elseif (newent.lt.entry_first .or. newent.gt.gbl_iter%optx%n) then
      ! Should not happen
      write(mess,'(a,i0,a)')  'No entry number ',newent,' in index'
      call cubedag_message(seve%e,rname,mess)
      error = .true.
      return
    else
      write(mess,'(a,i0)')  'Getting entry number ',newent
      call cubedag_message(seve%d,rname,mess)
      obj => cubedag_node_ptr(gbl_iter%optx%list(newent)%p,error)
      if (error)  return
      out = obj%get_id()
      call index_iterator_put(out,error)
      if (error)  return
    endif
  end subroutine index_iterator_get
  !
  subroutine index_iterator_put(id,error)
    !-------------------------------------------------------------------
    ! Set the current identifier in the iterator
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: id
    logical,              intent(inout) :: error
    !
    gbl_iter%current_id = id
    gbl_iter%start = start_current  ! A valid current ID is now defined
  end subroutine index_iterator_put
  !
  subroutine index_iterator_current_num(iter,num,error)
    !-------------------------------------------------------------------
    ! Dynamically get the entry number from the current ID, as the entry
    ! number in the index might change if e.g. other nodes are removed.
    ! This assumes the identifiers in the index are numerically sorted.
    !-------------------------------------------------------------------
    class(index_internal_t), intent(inout) :: iter
    integer(kind=entr_k),    intent(out)   :: num
    logical,                 intent(inout) :: error
    !
    integer(kind=iden_l) :: found_id
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='ITERATOR>CURRENT>NUM'
    !
    num = 0
    !
    if (iter%start.ne.start_current) then
      call cubedag_message(seve%e,rname,'No current entry defined')
      error = .true.
      return
    endif
    !
    call iter%optx%entrynum(iter%current_id,found_id,num,error)
    if (error)  return
    !
    if (found_id.ne.iter%current_id) then
      ! It may have disappeared e.g. after an UNDO
      write(mess,'(3(a,i0))')  &
        'Current entry id. ',iter%current_id, &
        ' not found in index, using entry id. ',found_id,' as fallback'
      call cubedag_message(seve%w,rname,mess)
    endif
  end subroutine index_iterator_current_num

  function index_iterator_is_current(id)
    !-------------------------------------------------------------------
    ! Return .true. if the passed ID matches the gbl_iter current ID.
    !-------------------------------------------------------------------
    logical :: index_iterator_is_current
    integer(kind=iden_l), intent(in) :: id
    !
    index_iterator_is_current = gbl_iter%start.eq.start_current .and. &
                                gbl_iter%current_id.eq.id
  end function index_iterator_is_current

end module cubedag_index_iterator_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBE FITSIO messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefitsio_messaging
  use cfitsio_api
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: seve,fitsioseve,mess_l
  public :: cubefitsio_message_set_id,cubefitsio_message,cubefitsio_error
  public :: cubefitsio_message_set_trace,cubefitsio_message_get_trace
  public :: cubefitsio_message_set_others,cubefitsio_message_get_others
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubefitsio_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubefitsio_messaging_debug_t
     integer(kind=code_k) :: trace = seve%t
     integer(kind=code_k) :: others = seve%d
  end type cubefitsio_messaging_debug_t
  type(cubefitsio_messaging_debug_t) :: fitsioseve
  !
contains
  !
  subroutine cubefitsio_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubefitsio_message_id = id
    write (mess,'(A,I0)') 'Now use id #',cubefitsio_message_id
    call cubefitsio_message(seve%d,rname,mess)
  end subroutine cubefitsio_message_set_id
  !
  subroutine cubefitsio_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubefitsio_message_id,mkind,'FITSIO>'//procname,message)
  end subroutine cubefitsio_message
  !
  function cubefitsio_error(procname,status,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefitsio_error  ! Function value on return
    character(len=*), intent(in)    :: procname
    integer(kind=4),  intent(in)    :: status
    logical,          intent(inout) :: error
    ! Local
    character(len=message_length) :: mess
    !
    cubefitsio_error = status.ne.0
    if (cubefitsio_error) then
      error = .true.
      call ftgerr(status,mess)
      call cubefitsio_message(seve%e,procname,mess)
    endif
    !
  end function cubefitsio_error
  !
  subroutine cubefitsio_message_set_trace(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitsioseve%trace = seve%i
    else
       fitsioseve%trace = seve%t
    endif
  end subroutine cubefitsio_message_set_trace
  !
  subroutine cubefitsio_message_set_others(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitsioseve%others = seve%i
    else
       fitsioseve%others = seve%d
    endif
  end subroutine cubefitsio_message_set_others
  !
  function cubefitsio_message_get_trace()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefitsio_message_get_trace
    !
    cubefitsio_message_get_trace = fitsioseve%trace.eq.seve%i
    !
  end function cubefitsio_message_get_trace
  !
  function cubefitsio_message_get_others()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefitsio_message_get_others
    !
    cubefitsio_message_get_others = fitsioseve%others.eq.seve%i
    !
  end function cubefitsio_message_get_others
  !
end module cubefitsio_messaging
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine solve_skydip(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !	Support routine for command
  !	SOLVE SKYDIP [TREC|EFF] [/PLOT] [/OUTPUT File [NEW]]
  !	[/Store /Reset /Offset /Closure /Search] Not relevant here
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  include 'clic_skydip.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: plot, output, end
  character(len=132) :: ch, chain
  character(len=80) :: snam,filnam
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length)    :: ldata_in
  integer :: p_lun, ier, j, nsky, nch
  real :: c_cal(mnant),c_sky(mnant,mp), elev(mp), elcal
  real :: c_chop(mnant)
  character(len=2) :: argum
  integer(kind=entry_length) :: sky_num
  integer :: p_skydip, sky_scan
  parameter (p_skydip=6)
  save sky_num, sky_scan
  !
  integer :: mvoc2,  mvoc1, nkey, iinput, ninput
  parameter (mvoc1=2, mvoc2=2)
  character(len=12) :: kw, voc1(mvoc1), voc2(mvoc2)
  data voc1/'NEW','OLD'/
  data voc2/'EFFICIENCY','TREC'/
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  plot = sic_present(1,0)
  output = sic_present(3,0)
  if (output) then
    call sic_ch(line,3,1,snam,nch,.true.,error)
    if (error) goto 999
    ch = 'NEW'
    call sic_ke(line,3,2,ch,nch,.false.,error)
    if (error) goto 999
    call sic_ambigs('SOLVE SKYDIP',ch,kw,nkey,voc1,mvoc1,error)
    if (error) goto 999
    call sic_parsef(snam,filnam,' ','.lis')
    ier = sic_getlun (p_lun)
    if (kw.eq.'NEW') then
      ier = sic_open (p_lun,filnam,'NEW',.false.)
    else
      ier = sic_open (p_lun,filnam,'UNKNOWN',.false.)
    endif
    if (ier.ne.0) then
      call message(6,3,'SOLVE_SKYDIP',   &
        'Cannot open file '//filnam)
      call putios ('        ',ier)
      error = .true.
      call sic_frelun(p_lun)
      return
    endif
    call message(8,2,'SOLVE_SKYDIP',   &
      'Option /OUTPUT not implemented')
  endif
  !
  ! Get mode (solve for TREC or EFF)
  argum = 'EFF'
  call sic_ke(line,0,2,argum,nch,.false.,error)
  if (error) goto 999
  call sic_ambigs('SOLVE SKYDIP',argum,kw,nkey,voc2,mvoc2,error)
  if (error) goto 999
  if (kw.eq. 'TREC') then
    trec_mode   = .true.
  elseif (kw.eq. 'EFFICIENCY') then
    trec_mode = .false.
  endif
  !
  call get_first(.true.,error)
  ninput = r_nbb
  if (error) goto 999
  !
  ! Check if a valid narrow input has been selected
  if (.not.bb_select.and.n_baseband.ne.1.and.l_baseband(1).ne.1) then
    call show_display('BBAND',.false.,error)
    write(chain,'(A)')   &
      'Select a single baseband using SET BBAND command'
    call message(6,3,'SOLVE_RF',chain)
    error = .true.
    return
  else
    iinput = i_baseband(1,1)
  endif
  end = .false.
  nsky = 0                     ! number of sky measurements
  elcal = 0                    ! no cal yet
  do while (.not.end)
    error = .false.
    if (r_proc.ne.p_skydip) then
      call message(8,2,'SOLVE_SKYDIP', 'Scan ignored')
    !
    ! Calibration Scan
    elseif (r_scaty.eq.4) then ! Calibration
      call get_data (ldata_in,data_in,error)
      if (error) goto 200
      kin = gag_pointer(data_in,memory) + r_ndump*r_ldump
      call decode_header (memory(kin))
      kin = kin + r_ldpar
      call load_auto (memory(kin), c_cal(1), iinput, error)
      if (error) goto 200
      elcal = r_el*180./pi +dh_offbet(1)/3600.
    !
    ! Sky scan
    elseif (r_scaty.eq.5 .and. elcal.gt.0) then
      call get_data (ldata_in,data_in,error)
      if (error) goto 200
      nsky = nsky + 1
      kin = gag_pointer(data_in,memory) + r_ndump*r_ldump
      call decode_header (memory(kin))
      kin = kin + r_ldpar
      call load_auto (memory(kin), c_sky(1,nsky), iinput, error)
      if (error) goto 200
      elev(nsky) = 180.*r_el/pi+dh_offbet(1)/3600.
      if (abs(elcal-elev(nsky)) .lt. 0.1) then
        do j = 1, r_nant
          if (r_ceff(iinput,j).gt.0.) then
            c_chop(j) = (c_cal(j)-(1-r_ceff(iinput,j))*c_sky(j   &
              ,nsky))/ r_ceff(iinput,j)
          else
            c_chop(j) = c_cal(j)
          endif
        enddo
      endif
      do j=1, r_nant
        if (trec_mode) then
          c_sky(j,nsky) = (c_sky(j,nsky)-c_chop(j))/c_chop(j)
        else
          c_sky(j,nsky) = (r_tchop(iinput,j)+r_trec(iinput,j))   &
            *c_sky(j,nsky)/c_chop(j) - r_trec(iinput,j)
        endif
      enddo
    endif
    !
    ! Save header here
    sky_num = r_xnum
    sky_scan = r_scan
200 error = .false.
    call get_next(end, error)
    if (error) goto 999
    ! If scan changed, move
    if ((end.or.sky_scan.ne.r_scan) .and. nsky.gt.4) then
      call get_num(sky_num,error)
      call sub_skydip (plot,output,p_lun,nsky,c_sky,elev,iinput,error)
      if (error) goto 999
      nsky = 0                 ! number of sky measurements
      elcal = 0                ! no cal yet
    endif
  enddo
  goto 998
  !
999 error = .true.
998 if (output) then
    close(unit=p_lun)
    call sic_frelun(p_lun)
  endif
end subroutine solve_skydip
!
subroutine load_auto (data, auto_data, iinput, error)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC 	read a data record for SKYDIP
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  real :: data(*)                   !
  real :: auto_data(mnant)          !
  integer :: iinput                 !
  logical :: error                  !
  ! Global
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: ia, ic, iy, k, jc
  real :: w, my_total2
  !------------------------------------------------------------------------
  ! Code:
  call check_subb(1,.true.,error)
  if (error) goto 999
  iy = i_y(1)
  k = 1
  if (iy.eq.79) then           ! continuum detectors ...
    ! we take ther requested total power...
    do ia=1, r_nant
      auto_data(ia) = my_total2(iinput,ia,error)   !! DH_TOTAL(IA)
    enddo
  else                         ! (auto) correlators  ...
    do ia=1, r_nant
      auto_data(ia) = 0
      w = 0
      do jc = 1, k_subb(1)
        ic = i_subb(jc,1)
        auto_data(ia) = auto_data(ia) + data(k)*r_cfwid(ic)
        w = w + r_cfwid(ic)
        k = k + 1
      enddo
      auto_data(ia) = auto_data(ia) / w
    enddo
  endif
  return
999 error = .true.
  return
end subroutine load_auto
!
subroutine sub_skydip (plot,out,iout,nel,c_sky,c_el,iinput,error)
  use gkernel_interfaces
  use atm_interfaces_public
  use classic_api
  !---------------------------------------------------------------------
  ! Call Tree
  !	SOLVE_SKYDIP
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  logical :: plot                   !
  logical :: out                    !
  integer :: iout                   !
  integer :: nel                    !
  real :: c_sky(mnant,nel)          !
  real :: c_el(nel)                 !
  integer :: iinput
  logical :: error                  !
  ! Global
  include 'clic_par.inc'
  include 'clic_skydip.inc'
  include 'gbl_pi.inc'
  include 'clic_clic.inc'
  include 'clic_fit.inc'
  ! Local
  real :: temi, freqsi, freqim, err1(mnant),err2(mnant)
  integer :: ier, i, j, n
  external :: minsky
  character(len=1) :: answer
  character(len=132) :: ch
  character(len=28) :: mess(3)
  character(len=64) :: cbox(mnant)
  integer :: dummy
  ! Data
  data mess /'Zero atmospheric opacity',   &
    'No oxygen in atmosphere',   &
    'No water in atmosphere'/
  !------------------------------------------------------------------------
  ! Code:
  !
  if (atm_interpolate) then
    call atm_atmosp_i (r_tamb,r_pamb,r_alti)   ! press at ALTI
  else
    call atm_atmosp (r_tamb,r_pamb,r_alti)   ! press at ALTI
  endif
  freqsi = 1d-3*(r_flo1 + r_isb*r_fif1)    ! signal side band
  freqim = 1d-3*(r_flo1 - r_isb*r_fif1)    ! image side band
  if (plot) then
    call gtclear
    call skydip_boxes(r_nant,cbox,error)
    write (ch,1002) r_scan, freqsi, freqim,   &
      r_az*180.d0/pi,'" 8 /BOX 8'
    call gr_exec(ch(1:lenc(ch)))
  endif
  do j=1, r_nant
    tausig = r_taus(iinput,j)
    atmsig = r_tatms(iinput,j)
    tauima = r_taui(iinput,j)
    atmima = r_tatmi(iinput,j)
    if (atm_interpolate) then
      call atm_transm_i (r_h2omm(iinput,j),1.,freqsi,temi,atmsig,   &
        tauoxs,tauws,tausig,ier)
      if (ier.ne.0) call message   &
        (6,3,'SUB_SKYDIP','Stupid calibration '//mess(ier))
      call atm_transm_i (r_h2omm(iinput,j),1.,freqim,temi,atmima,   &
        tauoxi,tauwi,tauima,ier)
      if (ier.ne.0) call message   &
        (6,3,'SUB_SKYDIP','Stupid calibration '//mess(ier))
    else
      call atm_transm (r_h2omm(iinput,j),1.,freqsi,temi,atmsig,   &
        tauoxs,tauws,tausig,ier)
      if (ier.ne.0) call message   &
        (6,3,'SUB_SKYDIP','Stupid calibration '//mess(ier))
      call atm_transm (r_h2omm(iinput,j),1.,freqim,temi,atmima,   &
        tauoxi,tauwi,tauima,ier)
      if (ier.ne.0) call message   &
        (6,3,'SUB_SKYDIP','Stupid calibration '//mess(ier))
    endif
    !
    tamb   = r_tamb
    tchop  = r_tchop(iinput,j)
    feff   = r_feff(iinput,j)
    gainim = r_gim(iinput,j)
    np = nel
    do i=1, nel
      sky(i) = c_sky(j,i)
      el(i) = c_el(i)*pi/180.
    enddo
    if (trec_mode) then
      par(1) = 1./(0.9*r_trec(iinput,j)   &
        +r_tchop(iinput,j))
    endif
    !
    ! Minimize
    call fitsky(minsky,.false.,ier,1.)
    if (ier.ne.0) call message   &
      (6,2,'SUB_SKYDIP','Solution not converged')
    !
    ! Store results
    if (trec_mode) then
      r_trec(iinput,j) = par(1)
    else
      r_feff(iinput,j) = par(1)
    endif
    err1(j) = werr(1)
    err2(j) = werr(2)
    r_h2omm(iinput,j) = par(2)
    ! more accurate when other stuff is included
    ! (do not assume there is only water and oxygen)
    !
    r_taus(iinput,j) = tausig-tauws  +   &
      r_h2omm(iinput,j) * tauws
    r_taui(iinput,j) = tauima-tauwi  +   &
      r_h2omm(iinput,j) * tauwi
    r_tatms(iinput,j) = atmsig
    r_tatmi(iinput,j) = atmima
    ! Display results
    write(ch,*) 'Antenna ',r_kant(j) ,' results :'
    call message(6,1,'SOLVE_SKYDIP',ch(1:lenc(ch)))
    call message(6,1,'SOLVE_SKYDIP',   &
      ' Trec       Tchopper     Tcold')
    write(ch,'(3F10.1)') r_trec(iinput,j),   &
      r_tchop(iinput,j), r_tcold(iinput,j)
    call message(6,1,'SOLVE_SKYDIP',ch(1:lenc(ch)))
    call message(6,1,'SOLVE_SKYDIP',   &
      '   Az      Tamb    Pamb    Humidity '   &
      //'Water  Feff    Rms(K)')
    write(ch,'(7f8.2)') r_az*180./pi, r_tamb,   &
      r_pamb, r_humid, r_h2omm(iinput,j),   &
      r_feff(iinput,j), sigrms
    call message(6,1,'SOLVE_SKYDIP',ch(1:lenc(ch)))
    call message(6,1,'SOLVE_SKYDIP',   &
      '                  '//   &
      'Freq     Tau      O2       H2O      Tatm')
    write(ch,'(a,4F9.3,f9.2)') 'Signal band: ',   &
      freqsi, r_taus(iinput,j), tauoxs,   &
      tauws*r_h2omm(iinput,j), r_tatms(iinput,j)
    call message(6,1,'SOLVE_SKYDIP',ch(1:lenc(ch)))
    write(ch,'(a,4F9.3,f9.2)') ' Image band: ',   &
      freqim, r_taui(iinput,j), tauoxi,   &
      tauwi*r_h2omm(iinput,j), r_tatmi(iinput,j)
    call message(6,1,'SOLVE_SKYDIP',ch(1:lenc(ch)))
    !
    if (plot) then
      call gr_exec(cbox(j))
      call plot_skydip(r_kant(j),r_trec(iinput,j),   &
        r_h2omm(iinput,j), r_feff(iinput,j))
    endif
  enddo
  ! Return error bars on parameter in SIC variables
  if (trec_mode) then
    call sic_delvariable('ERR_TREC',.false.,error)
    call sic_def_real('ERR_TREC',err1,1,r_nant,   &
      .false.,error)
  else
    call sic_delvariable('ERR_FEFF',.false.,error)
    call sic_def_real('ERR_FEFF',err1,1,r_nant,   &
      .false.,error)
  endif
  call sic_delvariable('ERR_H2O',.false.,error)
  call sic_def_real('ERR_H2O',err2,1,r_nant,.false.,error)
  !
  if (plot) then
    if (sic_inter_state(dummy)) then
      answer = ' '
      call sic_wprn('W-SOLVE_SKYDIP, '//   &
        'Press H for Hardcopy, Return to continue',   &
        answer,n)
      call sic_blanc(answer,n)
      if (answer(1:1) .eq. 'H')   &
        call gr_exec( 'HARDCOPY /PRINT')
    endif
  endif
  return
  !
error = .true.
  return
1002 format('DRAW TEXT 0 0 "',i4,'; Signal ',f10.3,   &
    '; Image ',f10.3,' Azimut ',f6.1,a)
end subroutine sub_skydip
!
subroutine plot_skydip(iant,trec,h2o,f_eff)
  use gkernel_interfaces
  integer :: iant                   !
  real :: trec                      !
  real :: h2o                       !
  real :: f_eff                     !
  ! Global
  include 'clic_skydip.inc'
  include 'gbl_pi.inc'
  ! Local
  character(len=80) :: chain
  real :: eps, gamma, hz, ts, tsi, tss, etss, etsi
  real :: xxx, xx(100), yy(100), xxmin, xxmax
  real :: h0,r0
  parameter (h0=5.5,r0=6370.0)
  integer :: i
  logical :: err
  !------------------------------------------------------------------------
  ! Code:
  err = .false.
  xxmin = 100
  xxmax = -100
  do i=1, np
    xxx = el(i)                ! Elevation in radians
    eps = asin(r0/(r0+h0)*cos(xxx))
    gamma = 0.5*pi-xxx-eps
    hz = r0*r0 + (r0+h0)**2 - 2.*r0*(r0+h0)*cos(gamma)
    hz = sqrt(max(hz,h0**2))   ! Avoid floating point errors
    xx(i) = hz/h0              ! the air mass content
    xxmin = min(xxmin,xx(i))
    xxmax = max(xxmax,xx(i))
    if (trec_mode) then
      yy(i) = tchop*(sky(i)+1)
    else
      yy(i) = sky(i)
    endif
  enddo
  call gr4_give('X',np,xx)
  call gr4_give('Y',np,yy)
  call gr_exec1('LIMITS')
  call gr_exec1('BOX')
  call gr_exec1('POINTS')
  call gr_segm ('FIT',err)
  ! Plot fitted curve
  do i=1,100
    xx(i) = xxmin+(i-5.)*(xxmax-xxmin)/90.
    etss = exp(-xx(i)*(par(2)*tauws + tausig-tauws))
    tss = atmsig * (1. - etss)
    etsi = exp(-xx(i)*(par(2)*tauwi + tauima-tauwi))
    tsi = atmima * (1. - etsi)
    ts  = (tss + tsi*gainim) / (1. + gainim)
    if (trec_mode) then
      yy(i) =  tchop/(par(1)+tchop) *   &
        (tamb +par(1) + feff*(ts-tamb))
    else
      yy(i)  = par(1)*ts + (1.-par(1)) * tamb
    endif
  enddo
  call gr4_connect (100,xx,yy,0.0,-1.0)
  call gr_segm_close(err)
  call gr_exec1('LABEL "Air masses" /X')
  call gr_exec1('DRAW TEXT -4 0 "Emission" 5 90 /CHAR 4')
  write(chain,'(A,I2,A,F7.2)') 'Antenna ',iant,   &
    ' : H'//char(92)//'d2O ',h2o
  call gr_exec1('DRAW TEXT  1 -1.5 "'   &
    //chain(1:lenc(chain))//'" 9 /CHAR 7')
  write(chain,'(A,F6.1,A,F6.3)') 'Trec ',trec,';  Feff ',f_eff
  call gr_exec1('DRAW TEXT -1 1.5 "'   &
    //chain(1:lenc(chain))//'" 7 /CHAR 3')
  return
end subroutine plot_skydip
!
subroutine fitsky (fcn,liter,ier,meancho)
  !---------------------------------------------------------------------
  ! RED	Internal routine
  !	Setup and starts a SKYDIP fit minimisation using MINUIT
  ! Arguments :
  !	FCN	Ext.	Function to be mininized	Input
  !	LITER	L	Logical of iterate fit		Input
  !	IER	L	Logical error flag		Output
  ! Created	S.Guilloteau 	5-Nov-1986
  !---------------------------------------------------------------------
  external :: fcn                   !
  logical :: liter                  !
  integer :: ier                    !
  real :: meancho                   !
  ! Global
  include 'clic_fit.inc'
  include 'clic_skydip.inc'
  ! Local
  integer :: i,l
  real :: tau,a1,ap,a2
  real*8 :: dx, al, ba, du1, du2
  ! Code	----------------------------------------------------------------------
  !
  ! Added error Patch for Initialisation
  ier = 0
  isysrd=5
  isyswr=6
  isyspu=7
  maxext=ntot
  maxint=nvar
  !
  ! Initialise values
  ! Note : should put TCABIN instead of OBsTAM...
  a1 = 1./sin(el(1))
  a2 = 1./sin(el(2))
  ap = 1./sin(el(np))
  if (trec_mode) then
    tau = (sky(2)-sky(1))/par(1)/(a2-a1)/(atmsig+gainim*atmima)   &
      * (1+gainim)
    par(2) = max( (tau-tausig+tauws)/tauws,   &
      (tau-tauima+tauwi)/tauwi )
    par(2) = min(20.,max(0.,par(2)))
  else
    par(1) = 1. - (a1*sky(2) - a2*sky(1))/tamb/(a1-a2)
    par(1) = min(1.,max(0.,par(1)))
    tau = (sky(2)-sky(1))/par(1)/(a2-a1)/(atmsig+gainim*atmima)   &
      * (1+gainim)
    par(2) = max( (tau-tausig+tauws)/tauws,   &
      (tau-tauima+tauwi)/tauwi )
    par(2) = min(20.,max(0.,par(2)))
  endif
  par(2) = max(1.0,par(2))
  !
  call midsky (ier,liter)
  if (ier.ne.0) return
  call clic_intoex(x)
  nfcnmx  = 10000
  newmin  = 0
  itaur  = 0
  isw(1)  = 0
  isw(3)  = 1
  nfcn = 1
  vtest  = 0.04
  call fcn(npar,g,amin,u,1)
  sigrms = sqrt(amin/np)
  up = sigrms**2
  epsi  = 0.1d0 * up
  !
  ! Simplex Minimization
  if (.not.liter) then
    call clic_simplx(fcn,ier)
    par(1) = u(1)
    par(2) = u(2)
    if (ier.ne.0) return
  endif
  !
  ! Gradient Minimization
  call clic_intoex(x)
  call fcn(npar,g,amin,u,3)
  sigrms  = sqrt(amin/np)
  write(isyswr,1002) sigrms
  up = sigrms**2
  epsi  = 0.1d0 * up
  apsi  = epsi
  call clic_hesse(fcn)
  call clic_migrad(fcn,ier)
  call clic_intoex(x)
  call fcn(npar,g,amin,u,3)
  sigrms  = sqrt(amin/np)
  up = sigrms**2
  epsi  = 0.1d0 * up
  apsi  = epsi
  ier = 0
  call clic_migrad(fcn,ier)
  !
  ! Iterate once if not converged
  if (ier.eq.3) then
    ier = 0
    call clic_migrad(fcn,ier)
  endif
  !
  ! Compute covariance matrix if bad
  if (ier.eq.1) then
    call clic_hesse(fcn)
    ier = 0
  endif
  !
  ! Print Results
  call clic_intoex(x)
  call fcn(npar,g,amin,u,3)
  sigrms = sqrt(amin/np)
  write(isyswr,1002) sigrms
  up  = sigrms**2
  !
  ! Calculate External Errors
  do 10 i=1,nu
    l  = lcorsp(i)
    if (l .eq. 0)  then
      werr(i)=0.
    else
      if (isw(2) .ge. 1)  then
        dx = dsqrt(dabs(v(l,l)*up))
        if (lcode(i) .gt. 1) then
          al = alim(i)
          ba = blim(i) - al
          du1 = al + 0.5d0 *(dsin(x(l)+dx) +1.0d0) * ba - u(i)
          du2 = al + 0.5d0 *(dsin(x(l)-dx) +1.0d0) * ba - u(i)
          if (dx .gt. 1.0d0)  du1 = ba
          dx = 0.5d0 * (dabs(du1) + dabs(du2))
        endif
        werr(i) = dx
      endif
    endif
10 continue
  !
  par(1) = u(1)
  par(2) = u(2)
  if (trec_mode) then
    werr(1) = werr(1)/par(1)**2*meancho
    par(1) = meancho/par(1) - tchop
    write (isyswr,1004)
    write (isyswr,1003) par(1),werr(1),par(2),werr(2)
  else
    write (isyswr,1001)
    write (isyswr,1000) par(1),werr(1),par(2),werr(2)
  endif
  return
  !
1000 format (4x,f9.3,' (',f8.3,')    ',f10.3,' (',f8.3,')')
1001 format (/,'	SKYDIP Fit Results   ',//,   &
    ' Forward Efficiency        Water vapor (mm) ')
1002 format (' RMS of Residuals : ',1pg10.3)
1003 format (4x,f9.2,' (',f8.2,')    ',f10.3,' (',f8.3,')')
1004 format (/,'	SKYDIP Fit Results   ',//,   &
    ' Trec                      Water vapor (mm) ')
end subroutine fitsky
!
subroutine midsky (ier,liter)
  !---------------------------------------------------------------------
  ! RED	Internal routine
  !	Start a SKYDIP fit by building the PAR array and internal
  !	variable used by Minuit.
  ! 	Parameters are
  !	PAR(1)	= RFOEFF	Forward efficiency
  !	or	  RTREC		Receiver temperature
  !	PAR(2)	= RH2OMM	Water vapor amount (mm)
  !
  ! Arguments
  !	IER	I	Error code 			Output
  !	LITER	L	Iterate a fit			Input
  !
  ! S.Guilloteau 16-Feb-1987
  !---------------------------------------------------------------------
  integer :: ier                    !
  logical :: liter                  !
  ! Global
  include 'clic_fit.inc'
  include 'clic_skydip.inc'
  ! Local
  integer :: ifatal
  integer :: i, ninte, k
  real*8 :: sav, clic_pintf, sav2, vplu, vminu, value
  ! Code	----------------------------------------------------------------------
  ier = 0
  do 10 i= 1, 7
    isw(i) = 0
10 continue
  npfix = 0
  ninte = 0
  nu = 2
  npar = 0
  ifatal = 0
  do 20 i= 1, maxext
    u(i) = 0.0d0
    lcode(i) = 0
    lcorsp (i) = 0
20 continue
  isw(5) = 1
  !
  ! Set up Parameters
  nu=2
  !
  ! Forward Efficiency
  u(1) = par(1)
  if (trec_mode) then
    werr(1) = abs(0.2*par(1))
    lcode(1) = 1
  else
    werr(1) = 0.1              ! 0.04
    alim(1) = 0.45             ! 0.60
    blim(1) = 1.00
    lcode(1) = 0
  endif
  !
  ! Water Vapor
  u(2) = par(2)
  werr(2) = max(2.0,0.2*par(2))
  alim(2) = 0.0                ! No water
  blim(2) = 30.0               ! in mm...
  lcode(2) = 0
  !
  ! Various checks
  do 30 k=1,nu
    if (k.gt.maxext)  then
      ifatal = ifatal + 1
      goto 30
    endif
    ! Fixed parameter
    if (werr(k) .le. 0.0d0)  then
      lcode(k) = 0
      write(6,1010) k,' is fixed'
      goto 30
    endif
    ! Variable parameter
    ninte = ninte + 1
    if (lcode(k).eq.1) goto 30
    lcode(k) = 4
    value = (blim(k)-u(k))*(u(k)-alim(k))
    if (value.lt.0.0d0) then
      ifatal = ifatal+1
      write (isyswr,1011) k
    elseif (value.eq.0.0d0) then
      write(6,1010) k,' is at limit'
    endif
30 continue
  !
  ! End parameter cards
  ! Stop if fatal error
  if (ninte .gt. maxint)  then
    write (isyswr,1008)  ninte,maxint
    ifatal = ifatal + 1
  endif
  if (ninte .eq. 0) then
    write (isyswr,1009)
    ifatal = ifatal + 1
  endif
  if (ifatal .gt. 0)  then
    write (isyswr,1013)  ifatal
    ier = 2
    return
  endif
  !
  ! O.K. Start
  ! Calculate step sizes DIRIN
  npar = 0
  do 40 k= 1, nu
    if (lcode(k) .gt. 0)  then
      npar = npar + 1
      lcorsp(k) = npar
      sav = u(k)
      x(npar) = clic_pintf(sav,k)
      xt(npar) = x(npar)
      sav2 = sav + werr(k)
      vplu = clic_pintf(sav2,k) - x(npar)
      sav2 = sav - werr(k)
      vminu = clic_pintf(sav2,k) - x(npar)
      dirin(npar) = 0.5d0 * (dabs(vplu) +dabs(vminu))
    endif
40 continue
  return
  !
1008 format (' Too many variable parameters.  You request ',i5/,   &
    ' This version of MINUIT is only dimensioned for ',i4)
1009 format (' All input parameters are fixed')
1010 format (' Warning - Parameter ',i2,' ',a)
1011 format (' Error - Parameter ',i2,' outside limits')
1013 format (1x,i3,' Errors on input parameters. ABORT.')
end subroutine midsky
!
subroutine minsky (npar,g,f,x,iflag)
  !---------------------------------------------------------------------
  ! RED	Internal routine
  !	Function to be minimized in the SKYDIP.
  ! Arguments :
  !	NPAR	I	Number of parameters		Input (2)
  !	G	R*8(1)	Array of derivatives		Output
  !	F	R*8	Function value			Output
  !	X	R*8(1)	Parameter values		Input
  !	IFLAG	I	Code operation			Input
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  integer :: npar                   !
  real*8 :: g(*)                    !
  real*8 :: f                       !
  real*8 :: x(*)                    !
  integer :: iflag                  !
  ! Global
  include 'clic_skydip.inc'
  ! Local
  real :: pi
  parameter (pi=3.141592653)
  real :: eps, gamma, hz, ts, tsi, tss, etss, etsi, dwtss, dwtsi
  real :: dwts, dwyy, deyy, dwf, def, elev, xx, yy, ff, zz, h0, r0, fs
  real :: xh2o, xeff
  parameter (h0= 5.5,r0= 6370.0)
  logical :: dograd
  integer :: i
  !
  ! Code	----------------------------------------------------------------------
  fs = 0.0
  dwf = 0.0
  def = 0.0
  dograd = iflag.eq.2
  xh2o = x(2)
  xeff = x(1)
  !
  ! Compute function and derivative
  do i=1,np
    elev = el(i)               ! Elevation
    !
    !  Curved atmosphere, equivalent height 5.5 KM
    eps = asin(r0/(r0+h0)*cos(elev))
    gamma = 0.5*pi-elev-eps
    hz = r0*r0 + (r0+h0)**2 - 2.*r0*(r0+h0)*cos(gamma)
    hz = sqrt(max(hz,h0**2))   ! Avoid floating point errors
    xx = hz/h0                 ! the air mass content
    !
    etss = exp(-xx*(xh2o*tauws + tausig-tauws))
    tss = atmsig * (1. - etss)
    etsi = exp(-xx*(xh2o*tauwi + tauima-tauwi))
    tsi = atmima * (1. - etsi)
    ts  = (tss + tsi*gainim) / (1. + gainim)
    if (trec_mode) then
      zz = tamb-tchop + feff*(ts-tamb)
      yy = x(1)*zz
    else
      yy  = xeff*ts + (1.-xeff) * tamb
    endif
    !
    ! Compute CHI**2
    ff = yy - sky(i)
    fs = fs + ff*ff
    if (dograd) then
      !
      ! Compute Gradients
      dwtss = atmsig * tauws * etss * xx
      dwtsi = atmima * tauwi * etsi * xx
      dwts = (dwtss + dwtsi*gainim) / (1.+gainim)
      dwyy = xeff * dwts
      if (trec_mode) then
        dwyy = dwyy*feff
        deyy = zz
      else
        deyy = ts - tamb
      endif
      dwf = dwf + 2.0*ff*dwyy
      def = def + 2.0*ff*deyy
    endif
  !
  enddo
  !
  ! Setup values and return
  f = fs
  g(1) = def
  g(2) = dwf
end subroutine minsky
!
subroutine skydip_boxes(n_boxes,c_setbox,error)
  use gkernel_interfaces
  integer :: n_boxes                     !
  character(len=*) :: c_setbox(n_boxes)  !
  logical :: error                       !
  ! Local
  integer :: m, n, j, k, i
  real*4 :: xmax, ymax, ar1, ar2, gx1, gx2, gy1, gy2, bratio, aratio
  !-----------------------------------------------------------------------
  aratio = 2.0
  !
  ! Deal with Title
  call gr_exec('SET VIEWPORT /DEF')
  call sic_get_real('PAGE_X',xmax,error)
  call sic_get_real('PAGE_Y',ymax,error)
  ! Leave a header space of aspect ratio (.08,1)
  ymax = ymax-xmax*.08
  error = .false.
  bratio = abs(aratio)*0.8
  m = min(n_boxes,max(1,nint(sqrt(n_boxes/bratio*xmax/ymax))))
  n = n_boxes/m
  do while (m*n .lt. n_boxes)
    ar1 = (xmax/float(m+1))/(ymax /float(n))
    ar2 = (xmax/float(m))/(ymax /float(n+1))
    if (abs(ar1-bratio).lt.abs(ar2-bratio)) then
      m = m+1
    else
      n = n+1
    endif
  enddo
  k = 0
  xmax = xmax/m
  ymax = ymax/n
  if (aratio.gt.0) then
    if (ymax.gt.xmax/aratio/0.8) then
      ymax = xmax/aratio/0.8
    else
      xmax = ymax*aratio*0.8
    endif
  endif
  do j=1, n
    do i=1, m
      k = k+1
      gx1 = (i-1)*xmax + xmax*.15
      gx2 = i*xmax - xmax*.05
      gy1 = (n-j)*ymax + ymax*.20
      gy2 = (n-j+1)*ymax - ymax*.16
      c_setbox(k) = ' '
      write(c_setbox(k),'(a,4(1x,f7.2))') 'SET BOX',   &
        gx1 ,gx2 ,gy1 ,gy2
    enddo
  enddo
end subroutine skydip_boxes

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_image2image
  use cubetools_structure
  use cubetemplate_one2one_template
  use cubetemplate_sperange_types
  use cubetemplate_image2image_template
  use cubetemplate_messaging
  !
  public :: image2image
  private
  !
  type, extends(image2image_comm_t) :: ext_image2image_comm_t
     type(option_t), pointer :: factor
     type(sperange_opt_t)    :: range
   contains
     procedure, public :: register => cubetemplate_ext_image2image_register
     procedure, public :: parse    => cubetemplate_ext_image2image_parse
  end type ext_image2image_comm_t
  type(ext_image2image_comm_t) :: image2image
  !
  type, extends(image2image_user_t) :: ext_image2image_user_t
     character(len=argu_l) :: factor
     type(sperange_user_t) :: range
   contains
     procedure, public :: toprog => cubetemplate_ext_image2image_user_toprog
  end type ext_image2image_user_t
  !
  type, extends(image2image_prog_t) :: ext_image2image_prog_t
     real(kind=sign_k)     :: factor
     type(sperange_prog_t) :: range
   contains
     procedure, private :: act    => cubetemplate_ext_image2image_prog_act
  end type ext_image2image_prog_t
  !
contains
  !
  subroutine cubetemplate_image2image_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(ext_image2image_user_t) :: user
    type(ext_image2image_prog_t) :: prog
    character(len=*), parameter :: rname='IMAGE2IMAGE>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call image2image%command(line,user,prog,error)
    if (error) return
  end subroutine cubetemplate_image2image_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_image2image_register(comm,error)
    use cubedag_allflags
    use cubeadm_cubeid_types
    use cubeadm_cubeprod_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_image2image_comm_t), intent(inout) :: comm
    logical,                       intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(standard_arg_t) :: stdarg
    type(cube_prod_t) :: cubeprod
    character(len=*), parameter :: comm_abstract='Template to access input/output data per image'
    character(len=*), parameter :: comm_help='Input and output cubes are real'
    character(len=*), parameter :: rname='EXT>IMAGE2IMAGE>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'IMAGE2IMAGE','[cube]',&
         comm_abstract,&
         comm_help,&
         cubetemplate_image2image_command,&
         comm%comm,&
         error)
    if (error) return
    call cubearg%register(&
         'CUBE',&
         'Signal cube',&
         strg_id,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset,&
         comm%incube,&
         error)
    if (error) return
    !
    call comm%range%register(&
         'RANGE',&
         'Define velocity range(s)',&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'FACTOR','factor',&
         'Multiply data by a factor',&
         strg_id,&
         comm%factor,&
         error)
    if (error) return
    call stdarg%register(&
         'factor',&
         'Multiplicative factor',&
         'Default to 1',&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    ! Products
    call cubeprod%register(  &
         'CUBE',  &
         'The result of the command',  &
         strg_id,  &
         [flag_template],  &
         comm%oucube,  &
         error)
    if (error)  return
  end subroutine cubetemplate_ext_image2image_register
  !
  subroutine cubetemplate_ext_image2image_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! IMAGE2IMAGE cubname
    ! /RANGE vfirst vlast
    ! /FACTOR factor
    !----------------------------------------------------------------------
    class(ext_image2image_comm_t), intent(in)    :: comm
    character(len=*),              intent(in)    :: line
    class(one2one_user_t),         intent(out)   :: user
    logical,                       intent(inout) :: error
    !
    type(ext_image2image_user_t), pointer :: iuser
    character(len=*), parameter :: rname='EXT>IMAGE2IMAGE>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    iuser => ext_image2image_user_ptr(user,error)
    if (error)  return
    call comm%one2one_comm_t%parse(line,iuser,error)
    if (error) return
    call comm%range%parse(line,iuser%range,error)
    if (error) return
    call cubetemplate_ext_image2image_parse_factor(line,comm%factor,iuser%factor,error)
    if (error) return
  end subroutine cubetemplate_ext_image2image_parse
  !
  subroutine cubetemplate_ext_image2image_parse_factor(line,opt,user,error)
    !----------------------------------------------------------------------
    ! /FACTOR factor
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    type(option_t),   intent(in)    :: opt
    character(len=*), intent(out)   :: user
    logical,          intent(inout) :: error
    !
    logical :: present
    integer(kind=4), parameter :: iarg=1
    character(len=*), parameter :: rname='EXT>IMAGE2IMAGE>PARSE>FACTOR'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call opt%present(line,present,error)
    if (error) return
    if (present) then
       call cubetools_getarg(line,opt,iarg,user,mandatory,error)
       if (error) return
    else
       user = strg_star
    endif
  end subroutine cubetemplate_ext_image2image_parse_factor
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_image2image_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    use cubetools_unit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_image2image_user_t), intent(in)    :: user
    class(one2one_comm_t),         intent(in)    :: comm
    class(one2one_prog_t),         intent(inout) :: prog
    logical,                       intent(inout) :: error
    !
    type(unit_user_t) :: nounit
    real(kind=sign_k), parameter :: default=1.0
    type(ext_image2image_prog_t), pointer :: iprog
    character(len=*), parameter :: rname='EXT>IMAGE2IMAGE>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%one2one_user_t%toprog(comm,prog,error)
    if (error) return
    !
    iprog => ext_image2image_prog_ptr(prog,error)
    if (error)  return
    call user%range%toprog(iprog%incube,iprog%range,error)
    if (error) return
    call nounit%get(strg_star,code_unit_unk,error)
    if (error) return
    call cubetools_user2prog_resolve_star(user%factor,nounit,default,iprog%factor,error)
    if (error) return
  end subroutine cubetemplate_ext_image2image_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_image2image_prog_act(prog,ie,input,output,error)
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_image2image_prog_t), intent(inout) :: prog
    integer(kind=entr_k),          intent(in)    :: ie
    type(image_t),                 intent(inout) :: input
    type(image_t),                 intent(inout) :: output
    logical,                       intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    character(len=*), parameter :: rname='EXT>IMAGE2IMAGE>PROG>ACT'
    !
    call input%get(ie,error)
    if (error) return
    do iy=1,input%ny
       do ix=1,input%nx
          output%val(ix,iy) = prog%factor*input%val(ix,iy)
       enddo ! ix
    enddo ! iy
    call output%put(ie,error)
    if (error) return
  end subroutine cubetemplate_ext_image2image_prog_act
  !
  !----------------------------------------------------------------------
  !
  function ext_image2image_user_ptr(user,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(ext_image2image_user_t), and
    ! return a pointer to it if yes.
    !-------------------------------------------------------------------
    type(ext_image2image_user_t), pointer       :: ext_image2image_user_ptr
    class(one2one_user_t),        target        :: user
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXT>IMAGE2IMAGE>USER>PTR'
    !
    select type(user)
    type is (ext_image2image_user_t)
      ext_image2image_user_ptr => user
    class default
      ext_image2image_user_ptr => null()
      call cubetemplate_message(seve%e,rname,  &
        'Internal error: object is not a ext_image2image_user_t type')
      error = .true.
      return
    end select
  end function ext_image2image_user_ptr
  !
  function ext_image2image_prog_ptr(prog,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(ext_image2image_prog_t), and
    ! return a pointer to it if yes.
    !-------------------------------------------------------------------
    type(ext_image2image_prog_t), pointer       :: ext_image2image_prog_ptr
    class(one2one_prog_t),        target        :: prog
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXT>IMAGE2IMAGE>PROG>PTR'
    !
    select type(prog)
    type is (ext_image2image_prog_t)
      ext_image2image_prog_ptr => prog
    class default
      ext_image2image_prog_ptr => null()
      call cubetemplate_message(seve%e,rname,  &
        'Internal error: object is not a ext_image2image_prog_t type')
      error = .true.
      return
    end select
  end function ext_image2image_prog_ptr
  !
end module cubetemplate_image2image
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module xymap_types
  !
  use image_def
  use gkernel_types
  !
  integer(kind=4), parameter :: ctype_pill_box    = 1
  integer(kind=4), parameter :: ctype_exponential = 2
  integer(kind=4), parameter :: ctype_sinc        = 3
  integer(kind=4), parameter :: ctype_exp_x_sinc  = 4
  integer(kind=4), parameter :: ctype_spheroidal  = 5
  integer(kind=4), parameter :: ctype_gaussian    = 6
  !
  ! Support type for user inputs in the Sic structure MAP%
  type :: xymap_user_t
     !
     integer(kind=4) :: xcol        ! [] Column of X coordinates
     integer(kind=4) :: ycol        ! [] Column of Y coordinates
     integer(kind=4) :: wcol        ! [] Column of weights
     integer(kind=4) :: col(2)      ! [] Range of columns to grid
     !
     integer(kind=4)    :: size(2)  ! [pixel ] Map size
     real(kind=4)       :: cell(2)  ! [arcsec] Pixel size
     real(kind=4)       :: reso(2)  ! [arcsec] Map resolution
     real(kind=4)       :: tole     ! [arcsec] Position tolerance
     logical            :: shift    ! [      ] Shift and/or Rotate grid?
     integer(kind=4)    :: ptype    ! [code  ] Projection kind
     real(kind=8)       :: pang     ! [degree] Grid position angle
   ! real(kind=8)       :: lii      ! [radian]
   ! real(kind=8)       :: bii      ! [radian]
     character(len=16)  :: ra       ! [  HH:MM:SS]
     character(len=16)  :: dec      ! [+DDD:MM:SS]
     character(len=256) :: like     ! [] Name of reference data cube used as an
                                    !    external data cube as reference for the
                                    !    spatial sampling
     !
     character(len=12) :: tele  ! [] Telescope name
     real(kind=4)      :: diam  ! [m] Antenna diameter
     real(kind=4)      :: beam  ! [arcsec] Beam FWHM
     !
     integer(kind=4)  :: ctype       ! []       Convolution kernel type
     real(kind=4)     :: support(2)  ! [arcsec] Convolution kernel support
     !
     character(len=8) :: wmode  ! Weighting mode (NAtural or UNiform)
     !
  end type xymap_user_t
  !
  ! Table description
  type :: xymap_tab_t
    !
    ! Disk description
    type(gildas) :: hdisk      ! Table header (on disk)
    logical      :: velofirst  ! Is the table VELO-POSI?
    integer(kind=index_length) :: ndata  ! Size of table (X, Y, W, VELO)
    integer(kind=index_length) :: nposi  ! Size of table
    !
    ! Memory description (in memory, the working table is always
    ! [VELOCITY,POSITION])
    type(gildas) :: hmem                 ! Table header (in memory)
    integer(kind=index_length) :: nchan  ! Number of channels in buffer
    real(kind=4), allocatable  :: data(:,:)  ! Actual data
    real(kind=4), allocatable  :: buff(:,:)  ! Transposing and sorting buffer
    !
    integer(kind=index_length) :: xcol  ! [] Column of X coordinates
    integer(kind=index_length) :: ycol  ! [] Column of Y coordinates
    integer(kind=index_length) :: wcol  ! [] Column of weights
    real(kind=4), allocatable  :: x(:)  ! X coordinates
    real(kind=4), allocatable  :: y(:)  ! Y coordinates
    real(kind=4), allocatable  :: w(:)  ! Weights
    !
    logical :: dosort  ! Is data sorting needed?
    integer(kind=4), allocatable :: sort(:)  ! Sorting array
    !
  end type xymap_tab_t
  !
  ! Data cube and weight image description
  type :: xymap_cub_t
    !
    ! Disk description / final cube
    type(gildas) :: hout  ! Cube header description
    type(gildas) :: hwei  ! Weight image description
    logical      :: velofirst  ! Is the cube VELO-POSI-POSI (vlm)?
    integer(kind=index_length) :: nx           ! Size of final cube
    integer(kind=index_length) :: ny           !        "
    integer(kind=index_length) :: nc           !        "
    real(kind=4), allocatable  :: dout(:,:,:)  ! Final cube, optionally allocated
    real(kind=4), allocatable  :: dwei(:,:)    ! Weight image
    !
    ! Memory description (in memory, the working cube is always
    ! [VELOCITY,POSITION,POSITION]) / per-block buffers
    integer(kind=index_length) :: nchan  ! Number of channels in buffer
    real(kind=4), allocatable  :: data(:,:,:)  ! Actual data
    real(kind=4), allocatable  :: buff(:,:,:)  ! Transposing buffer
    !
  end type xymap_cub_t
  !
  type :: xymap_conv1d_t
    integer(kind=4) :: ctype  ! Function kind
    real(kind=4) :: parm(10)  ! Function parameters
    real(kind=4) :: bias
    real(kind=4), allocatable :: buff(:)
  end type xymap_conv1d_t
  !
  type :: xymap_conv2d_t
    type(xymap_conv1d_t) :: x
    type(xymap_conv1d_t) :: y
  end type xymap_conv2d_t
  !
  ! Type for measuring time spent in some pieces of the code
  type :: xymap_time_t
    type(cputime_t) :: total
    type(cputime_t) :: xyw   ! Reading the X Y W columns
    type(cputime_t) :: read  ! Reading (pieces of) the table
    type(cputime_t) :: sort  ! Sorting (pieces of) the table
    type(cputime_t) :: tran  ! Transposing (pieces of) the table or the cube
    type(cputime_t) :: conv  ! Convolving or placing
    type(cputime_t) :: writ  ! Writing (pieces of) the cube
  end type xymap_time_t
  !
  type :: xymap_prog_t
    type(xymap_tab_t) :: tab
    type(xymap_cub_t) :: cub
    !
    integer(kind=4) :: col(2)    ! [] Range of columns to grid
    !
    real(kind=8)    :: xconv(3)  !
    real(kind=8)    :: yconv(3)  !
    real(kind=8)    :: vconv(3)  !
    real(kind=4)    :: tole      ! [radian] Position tolerance
    !
    real(kind=4)      :: diam         ! [m]
    real(kind=4)      :: beam         ! [radian] Beam FWHM
    character(len=12) :: beam_origin  ! Table header or MAP% variables
    !
    integer(kind=4) :: ptyp  ! [code]   Type of projection
    real(kind=8)    :: a0    ! [radian] Projection center (lambda)
    real(kind=8)    :: d0    ! [radian] Projection center (beta)
    real(kind=8)    :: pang  ! [radian] Grid position angle
    !
    real(kind=4) :: reso(2)     ! [radian] Map resolution
    real(kind=4) :: cell(2)     ! [radian] Pixel size
    real(kind=4) :: support(2)  ! [radian] Support of convolution function
    !
    character(len=8) :: wmode  ! Weighting mode (NAtural or UNiform)
    !
    type(xymap_conv2d_t) :: conv  ! Convolution buffer
    !
    type(xymap_time_t) :: time
    !
  end type xymap_prog_t
  !
end module xymap_types
!
module xymap_def
  use xymap_types
  !
  type(xymap_user_t), save :: sic_xymap_user
  !
end module xymap_def
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mrtindex_sec_pointing
  use gbl_message
  use gkernel_interfaces
  use classcore_interfaces_public
  use class_types
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! Support module for pointing section in MRTCAL index
  !---------------------------------------------------------------------

  public :: drift_book_t

  public :: sec_pointing_id
  public :: sec_pointing_nsol_def,sec_pointing_nkey_def
  public :: sec_pointing_t
  public :: sec_pointing_array_t
  !
  public :: pointing_fit_offset,pointing_fit_slope
  public :: pointing_fit_area1,pointing_fit_posi1,pointing_fit_fwhm1
  public :: pointing_fit_area2,pointing_fit_posi2,pointing_fit_fwhm2
  !
  ! Extra utilities
  public :: code_pointing_azimuth,code_pointing_elevation,code_pointing_unknown
  public :: pointing_direction
  public :: pointing_collimation
  !
  private
  !
  integer(kind=4), parameter :: code_pointing_unknown=0
  integer(kind=4), parameter :: code_pointing_azimuth=1
  integer(kind=4), parameter :: code_pointing_elevation=2
  !
  ! Write/read the MRTCAL section as a collection of CLASS sections
  ! with format V2:
  integer(kind=4), parameter :: obs_version=2

  ! Fitted parameter positions as per the CLASS Data Format in section
  ! class_pointing_t, arrays nfit(:) and nerr(:)
  integer(kind=4), parameter :: pointing_fit_offset=1
  integer(kind=4), parameter :: pointing_fit_slope=2
  integer(kind=4), parameter :: pointing_fit_area1=3
  integer(kind=4), parameter :: pointing_fit_posi1=4
  integer(kind=4), parameter :: pointing_fit_fwhm1=5
  integer(kind=4), parameter :: pointing_fit_area2=6
  integer(kind=4), parameter :: pointing_fit_posi2=7
  integer(kind=4), parameter :: pointing_fit_fwhm2=8

  ! Section Pointing: only for pointing scans.
  integer(kind=4), parameter :: sec_pointing_id=4
  integer(kind=4), parameter :: sec_pointing_nkey_def=2   ! Default for pre-allocations, can be changed
  integer(kind=4), parameter :: sec_pointing_nsol_def=16  ! Default for pre-allocations, can be changed
  !
  ! Variable buffers: the problem is that the Fortran section is an
  ! array of structures. We need to convert it to a structure of arrays.
  type sec_pointing_var_t
    integer(kind=4), allocatable :: poinline(:)
    real(kind=4),    allocatable :: poisigba(:)
    real(kind=4),    allocatable :: poisigra(:)
    real(kind=4),    allocatable :: poinfit(:,:)
    real(kind=4),    allocatable :: poinerr(:,:)
    !
    real(kind=8),    allocatable :: drifreq(:)
    real(kind=4),    allocatable :: driwidth(:)
    integer(kind=4), allocatable :: drinpoin(:)
    real(kind=4),    allocatable :: drirpoin(:)
    real(kind=4),    allocatable :: dritref(:)
    real(kind=4),    allocatable :: driaref(:)
    real(kind=4),    allocatable :: driapos(:)
    real(kind=4),    allocatable :: dritres(:)
    real(kind=4),    allocatable :: driares(:)
    integer(kind=4), allocatable :: drictype(:)
  end type sec_pointing_var_t
  !
  type sec_pointing_array_t
    integer(kind=4)              :: msol            ! Strict size of allocation on 'sol' dimension
    integer(kind=4)              :: nent            ! Used size of 'ent' dimension (allocation may be larger)
    integer(kind=4), allocatable :: nsol(:)         ! [nent]
    !
    integer(kind=4), allocatable :: poinline(:,:)   ! [msol,nent]
    real(kind=4),    allocatable :: poisigba(:,:)   ! [msol,nent]
    real(kind=4),    allocatable :: poisigra(:,:)   ! [msol,nent]
    real(kind=4),    allocatable :: poinfit(:,:,:)  ! [nfit,msol,nent]
    real(kind=4),    allocatable :: poinerr(:,:,:)  ! [nfit,msol,nent]
    !
    real(kind=8),    allocatable :: drifreq(:,:)    ! [msol,nent]
    real(kind=4),    allocatable :: driwidth(:,:)   ! [msol,nent]
    integer(kind=4), allocatable :: drinpoin(:,:)   ! [msol,nent]
    real(kind=4),    allocatable :: drirpoin(:,:)   ! [msol,nent]
    real(kind=4),    allocatable :: dritref(:,:)    ! [msol,nent]
    real(kind=4),    allocatable :: driaref(:,:)    ! [msol,nent]
    real(kind=4),    allocatable :: driapos(:,:)    ! [msol,nent]
    real(kind=4),    allocatable :: dritres(:,:)    ! [msol,nent]
    real(kind=4),    allocatable :: driares(:,:)    ! [msol,nent]
    integer(kind=4), allocatable :: drictype(:,:)   ! [msol,nent]
  contains
    procedure, public :: reallocate => pointing_array_reallocate
    procedure, public :: set        => pointing_array_set
    procedure, public :: variable   => pointing_array_variable
  end type sec_pointing_array_t
  !
  ! Type which describes how drift were equivalenced and combined.
  ! Note this is generic enough to be used in more cases.
  integer(kind=4), parameter :: mkeys=4  ! Could be more
  integer(kind=4), parameter :: drift_book_len_max=2+(4+8)*mkeys
  type drift_book_t
    integer(kind=4)   :: nkey=0         ! Number of keys-values used for this equivalence class
    integer(kind=4)   :: nobs=0         ! Number of observations mixed in this class
    integer(kind=4)   :: keys(mkeys)    ! List of key identifiers
    character(len=32) :: values(mkeys)  ! Values of each key for this class
  end type drift_book_t
  !
  type sec_pointing_sub_t
    type(drift_book_t)     :: book  ! Bookkeeping of each solution
    type(class_general_t)  :: gen   ! General description
    type(class_position_t) :: pos   ! Position description
    type(class_res_t)      :: res   ! Resolution description
    type(class_calib_t)    :: cal   ! Calibration description
    type(class_drift_t)    :: dri   ! Drift description
    type(class_pointing_t) :: poi   ! Pointing solutions
  end type sec_pointing_sub_t
  !
  type sec_pointing_t
    ! How the pointings were grouped before minimization. This follows CLASS
    ! LIST /TOC nomenclature.
    ! - Example 1 (individual fit):
    !     nkey=1, key(:) = ['NUMBER'],
    ! - Example 2 (grouped by unique telescope and unique angle):
    !     nkey=2, key(:) = ['TELESCOPE','DRIFT']
   !integer(kind=4)                       :: nkey    ! [---] Number of pair of key-value describing each pointing
    integer(kind=4)                       :: nsol    ! [---] Number of solutions
    type(sec_pointing_sub_t), allocatable :: sol(:)  ! [---] Solutions
    type(sec_pointing_var_t), private     :: var     ! Support for SIC variables
  contains
    generic,   public  :: reallocate  => reallocate4,reallocate8
    procedure, private :: reallocate4 => pointing_reallocate4
    procedure, private :: reallocate8 => pointing_reallocate8
    procedure, public  :: free        => pointing_free
    procedure, public  :: size        => pointing_size
    procedure, public  :: zero        => pointing_zero
    procedure, public  :: copy        => pointing_copy
    procedure, public  :: debug       => pointing_debug
    procedure, public  :: fromobs     => pointing_from_obs
    procedure, public  :: read        => pointing_read
    procedure, public  :: write       => pointing_write
    procedure, public  :: variable    => pointing_variable
    procedure, public  :: list_register_columns => pointing_list_register_columns
    procedure, public  :: list        => pointing_list
  end type sec_pointing_t

contains

  subroutine pointing_reallocate4(poi,msol,error)
    !-------------------------------------------------------------------
    ! Reallocate the section to hold at most 'msol' solutions
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(inout) :: poi
    integer(kind=4),       intent(in)    :: msol
    logical,               intent(inout) :: error
    !
    call pointing_reallocate8(poi,int(msol,kind=8),error)
    if (error)  return
  end subroutine pointing_reallocate4
  !
  subroutine pointing_reallocate8(poi,msol,error)
    !-------------------------------------------------------------------
    ! Reallocate the section to hold at most 'msol' solutions
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(inout) :: poi
    integer(kind=8),       intent(in)    :: msol
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='REALLOCATE>POINTING'
    logical :: dealloc,alloc
    integer(kind=4) :: ier
    !
    dealloc = .false.
    alloc = .false.
    if (allocated(poi%sol)) then
      if (size(poi%sol).ne.msol)  dealloc = .true.
    else
      alloc = .true.
    endif
    !
    if (dealloc) then
      call poi%free(error)
      if (error)  return
      alloc = .true.
    endif
    !
    if (alloc) then
      allocate(poi%sol(msol),stat=ier)
      if (failed_allocate(rname,'sol',ier,error))  return
    endif
  end subroutine pointing_reallocate8
  !
  subroutine pointing_free(poi,error)
    !-------------------------------------------------------------------
    ! Free properly the section and subsections
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(inout) :: poi
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FREE>POINTING'
   !integer(kind=4) :: isol
    !
   !if (allocated(poi%key)) deallocate(poi%key)
    if (allocated(poi%sol)) then
   !  do isol=1,size(poi%sol)
   !    if (allocated(poi%sol(isol)%val))  deallocate(poi%sol(isol)%val)
   !  enddo
      deallocate(poi%sol)
    endif
  end subroutine pointing_free
  !
  function pointing_size(poi)
    !-------------------------------------------------------------------
    ! Return the max size (in 4 bytes words) of the section
    !-------------------------------------------------------------------
    integer(kind=4) :: pointing_size
    class(sec_pointing_t), intent(in) :: poi
    pointing_size = 0
    pointing_size = pointing_size + drift_book_len_max      ! Max size
    pointing_size = pointing_size + class_sec_gen_len_full  ! General subsection
    pointing_size = pointing_size + class_sec_pos_len_v2    ! Position subsection
    pointing_size = pointing_size + class_sec_res_len       ! Resolution subsection
    pointing_size = pointing_size + class_sec_cal_len       ! Calibration subsection
    pointing_size = pointing_size + class_sec_dri_len       ! Drift subsection
    pointing_size = pointing_size + class_sec_poi_len       ! Pointing subsection
    pointing_size = 1 + poi%nsol * pointing_size            ! For all solutions
  end function pointing_size
  !
  subroutine pointing_zero(poi,error)
    !---------------------------------------------------------------------
    !  Zero-ify a 'sec_pointing_t' structure
    !---------------------------------------------------------------------
    class(sec_pointing_t), intent(inout) :: poi
    logical,               intent(inout) :: error
    !
    poi%nsol = 0
  end subroutine pointing_zero
  !
  subroutine pointing_copy(i,o,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(in)    :: i
    type(sec_pointing_t),  intent(inout) :: o
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: isol
    !
    call o%reallocate(i%nsol,error)
    if (error)  return
    o%nsol = i%nsol
    do isol=1,i%nsol
      o%sol(isol) = i%sol(isol)  ! Section to section
    enddo
  end subroutine pointing_copy
  !
  subroutine pointing_from_obs(poi,isol,book,obs,error)
    use class_types
    !---------------------------------------------------------------------
    ! Add a new solution to the pointing section
    !---------------------------------------------------------------------
    class(sec_pointing_t), intent(inout) :: poi
    integer(kind=4),       intent(in)    :: isol
    type(drift_book_t),    intent(in)    :: book
    type(observation),     intent(in)    :: obs
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='POINTING>FROM>OBS'
    !
    if (isol.gt.size(poi%sol)) then
      ! See pre-allocation of this section in mrtcal_calib_or_solve_init
      call mrtindex_message(seve%e,rname,'Not enough room to store all the pointing results')
      error = .true.
      return
    endif
    !
    poi%sol(isol)%book = book
    poi%sol(isol)%gen  = obs%head%gen
    poi%sol(isol)%pos  = obs%head%pos
    poi%sol(isol)%res  = obs%head%res
    poi%sol(isol)%cal  = obs%head%cal
    poi%sol(isol)%dri  = obs%head%dri
    poi%sol(isol)%poi  = obs%head%poi
    ! call poi%debug()
  end subroutine pointing_from_obs
  !
  subroutine pointing_debug(p)
    !-------------------------------------------------------------------
    ! List the section contents (debug mode)
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(in) :: p
    !
    integer(kind=4) :: isol,ikey,nc
    character(len=256) :: c
    !
    print *,''
    print *,"nsol = ",p%nsol
    do isol=1,p%nsol
      print *,"solution #",isol
      print *,"nkey, nobs = ",p%sol(isol)%book%nkey,p%sol(isol)%book%nobs
      c = "keys:values ="
      nc = len_trim(c)
      do ikey=1,p%sol(isol)%book%nkey
        write(c(nc+2:),'(i0,a,a)')  &
          p%sol(isol)%book%keys(ikey),  &
          ':',  &
          trim(p%sol(isol)%book%values(ikey))
        nc = len_trim(c)
      enddo
      print *,c(1:nc)
      ! General subsection
      print *,"teles = ",p%sol(isol)%gen%teles
      ! Drift subsection
      print *,"freq = ",p%sol(isol)%dri%freq
      print *,"apos = ",p%sol(isol)%dri%apos
      ! Pointing subsection
      print *,"fit = ",p%sol(isol)%poi%nfit(:)
      print *,"error = ",p%sol(isol)%poi%nerr(:)
    enddo
  end subroutine pointing_debug
  !
  subroutine pointing_read(poi,filein,iwork,error)
    !-------------------------------------------------------------------
    ! Read the MRTCAL pointing section from buffer
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(inout) :: poi
    type(classic_file_t),  intent(in)    :: filein
    integer(kind=4),       intent(in)    :: iwork(:)
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='POINTING>READ'
    integer(kind=4) :: isol,ikey
    integer(kind=data_length) :: addr,slen
    !
    call filein%conv%read%i4(iwork(1),poi%nsol,1)
    call poi%reallocate(poi%nsol,error)
    if (error)  return
    addr = 2
    do isol=1,poi%nsol
      ! Bookkeeping
      call filein%conv%read%i4(iwork(addr),  poi%sol(isol)%book%nkey,1)
      call filein%conv%read%i4(iwork(addr+1),poi%sol(isol)%book%nobs,1)
      call filein%conv%read%i4(iwork(addr+2),poi%sol(isol)%book%keys,poi%sol(isol)%book%nkey)
      addr = addr+2+poi%sol(isol)%book%nkey
      do ikey=1,poi%sol(isol)%book%nkey
        call filein%conv%read%cc(iwork(addr),poi%sol(isol)%book%values(ikey),8)  ! 32 chars = 8 words
        addr = addr+8
      enddo
      ! General
      slen = class_sec_gen_len_full  ! Ad-hoc format for this section
      call class_read_general_full(poi%sol(isol)%gen,filein%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Position
      slen = class_sec_pos_len_v2    ! For obs_version=2
      call class_read_position(poi%sol(isol)%pos,filein%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Resolution
      slen = class_sec_res_len
      call class_read_resolution(poi%sol(isol)%res,filein%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Calibration
      slen = class_sec_cal_len
      call class_read_calibration(poi%sol(isol)%cal,filein%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Drift
      slen = class_sec_dri_len  ! For obs_version=2
      call class_read_drift(poi%sol(isol)%dri,filein%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Pointing
      slen = class_sec_poi_len  ! For obs_version=2
      call class_read_pointing(poi%sol(isol)%poi,filein%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
    enddo
    ! Debug:
    ! call poi%debug()
  end subroutine pointing_read
  !
  subroutine pointing_write(poi,fileout,iwork,seclen,error)
    !-------------------------------------------------------------------
    ! Write the MRTCAL pointing section to buffer
    !-------------------------------------------------------------------
    class(sec_pointing_t),     intent(in)    :: poi
    type(classic_file_t),      intent(in)    :: fileout
    integer(kind=4),           allocatable   :: iwork(:)
    integer(kind=data_length), intent(out)   :: seclen
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='POINTING>WRITE'
    integer(kind=4) :: ier,isol,ikey
    integer(kind=data_length) :: addr,slen
    !
    seclen = 0
    !
    allocate(iwork(poi%size()),stat=ier)
    if (failed_allocate(rname,'iwork',ier,error))  return
    !
    call fileout%conv%writ%i4(poi%nsol,iwork(1),1)
    addr = 2
    do isol=1,poi%nsol
      ! Bookkeeping
      call fileout%conv%writ%i4(poi%sol(isol)%book%nkey,iwork(addr),  1)
      call fileout%conv%writ%i4(poi%sol(isol)%book%nobs,iwork(addr+1),1)
      call fileout%conv%writ%i4(poi%sol(isol)%book%keys,iwork(addr+2),poi%sol(isol)%book%nkey)
      addr = addr+2+poi%sol(isol)%book%nkey
      do ikey=1,poi%sol(isol)%book%nkey
        call fileout%conv%writ%cc(poi%sol(isol)%book%values(ikey),iwork(addr),8)  ! 32 chars = 8 words
        addr = addr+8
      enddo
      ! General
      call class_write_general_full(poi%sol(isol)%gen,fileout%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Position
      call class_write_position(poi%sol(isol)%pos,fileout%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Resolution
      call class_write_resolution(poi%sol(isol)%res,fileout%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Calibration
      call class_write_calibration(poi%sol(isol)%cal,fileout%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Drift
      call class_write_drift(poi%sol(isol)%dri,fileout%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
      ! Pointing
      call class_write_pointing(poi%sol(isol)%poi,fileout%conv,obs_version,iwork(addr:),slen,error)
      if (error)  return
      addr = addr+slen
    enddo
    seclen = addr-1
  end subroutine pointing_write
  !
  subroutine pointing_variable(sec,struct,ro,error)
    !-------------------------------------------------------------------
    ! Create the SIC variables pointing to the structure
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(inout) :: sec     !
    character(len=*),      intent(in)    :: struct  ! Structure name
    logical,               intent(in)    :: ro      ! Read-Only?
    logical,               intent(inout) :: error   ! Logical error flag
    !
    logical :: userreq
    character(len=32) :: str,strpoi,strdri
    integer(kind=4) :: isol
    integer(kind=index_length) :: dims(sic_maxdims)
    !
    userreq = .false.
    str = trim(struct)//'%POI'
    !
    call sic_delvariable(str,userreq,error)
    call sic_defstructure(str,.true.,error)
    if (error)  return
    !
    call sic_def_inte(trim(str)//'%N',sec%nsol,0,0,ro,error)
    if (error)  return
    !
    if (sec%nsol.eq.0)  return
    !
    ! ------------------------------------------------------------------
    !
    ! Allocate buffers ZZZ we should have variable_reallocate procedure
    if (allocated(sec%var%poinline))  deallocate(sec%var%poinline)
    if (allocated(sec%var%poisigba))  deallocate(sec%var%poisigba)
    if (allocated(sec%var%poisigra))  deallocate(sec%var%poisigra)
    if (allocated(sec%var%poinfit))   deallocate(sec%var%poinfit)
    if (allocated(sec%var%poinerr))   deallocate(sec%var%poinerr)
    allocate(sec%var%poinline(sec%nsol))
    allocate(sec%var%poisigba(sec%nsol))
    allocate(sec%var%poisigra(sec%nsol))
    allocate(sec%var%poinfit(mpoifit,sec%nsol))
    allocate(sec%var%poinerr(mpoifit,sec%nsol))
    !
    ! Fill buffers
    do isol=1,sec%nsol
      sec%var%poinline(isol)  = sec%sol(isol)%poi%nline
      sec%var%poisigba(isol)  = sec%sol(isol)%poi%sigba
      sec%var%poisigra(isol)  = sec%sol(isol)%poi%sigra
      sec%var%poinfit(:,isol) = sec%sol(isol)%poi%nfit(:)
      sec%var%poinerr(:,isol) = sec%sol(isol)%poi%nerr(:)
    enddo
    !
    ! Map buffers. NB: use same names as CLASS
    strpoi = trim(str)//'%POI'
    call sic_defstructure(strpoi,.true.,error)
    if (error)  return
    !
    dims(1) = sec%nsol
    call sic_def_inte(trim(strpoi)//'%NLINE',   sec%var%poinline,1,dims,ro,error)
    call sic_def_real(trim(strpoi)//'%RMS_BASE',sec%var%poisigba,1,dims,ro,error)
    call sic_def_real(trim(strpoi)//'%RMS_LINE',sec%var%poisigra,1,dims,ro,error)
    if (error)  return
    !
    dims(1) = mpoifit
    dims(2) = sec%nsol
    call sic_def_real(trim(strpoi)//'%RESULT',sec%var%poinfit,2,dims,ro,error)
    call sic_def_real(trim(strpoi)//'%ERROR', sec%var%poinerr,2,dims,ro,error)
    if (error)  return
    !
    ! ------------------------------------------------------------------
    ! Drift buffers
    !
    ! Allocate buffers
    if (allocated(sec%var%drifreq))   deallocate(sec%var%drifreq)
    if (allocated(sec%var%driwidth))  deallocate(sec%var%driwidth)
    if (allocated(sec%var%drinpoin))  deallocate(sec%var%drinpoin)
    if (allocated(sec%var%drirpoin))  deallocate(sec%var%drirpoin)
    if (allocated(sec%var%dritref))   deallocate(sec%var%dritref)
    if (allocated(sec%var%driaref))   deallocate(sec%var%driaref)
    if (allocated(sec%var%driapos))   deallocate(sec%var%driapos)
    if (allocated(sec%var%dritres))   deallocate(sec%var%dritres)
    if (allocated(sec%var%driares))   deallocate(sec%var%driares)
    if (allocated(sec%var%drictype))  deallocate(sec%var%drictype)
    allocate(sec%var%drifreq(sec%nsol))
    allocate(sec%var%driwidth(sec%nsol))
    allocate(sec%var%drinpoin(sec%nsol))
    allocate(sec%var%drirpoin(sec%nsol))
    allocate(sec%var%dritref(sec%nsol))
    allocate(sec%var%driaref(sec%nsol))
    allocate(sec%var%driapos(sec%nsol))
    allocate(sec%var%dritres(sec%nsol))
    allocate(sec%var%driares(sec%nsol))
    allocate(sec%var%drictype(sec%nsol))
    !
    ! Fill buffers
    do isol=1,sec%nsol
      sec%var%drifreq(isol)  = sec%sol(isol)%dri%freq
      sec%var%driwidth(isol) = sec%sol(isol)%dri%width
      sec%var%drinpoin(isol) = sec%sol(isol)%dri%npoin
      sec%var%drirpoin(isol) = sec%sol(isol)%dri%rpoin
      sec%var%dritref(isol)  = sec%sol(isol)%dri%tref
      sec%var%driaref(isol)  = sec%sol(isol)%dri%aref
      sec%var%driapos(isol)  = sec%sol(isol)%dri%apos
      sec%var%dritres(isol)  = sec%sol(isol)%dri%tres
      sec%var%driares(isol)  = sec%sol(isol)%dri%ares
      sec%var%drictype(isol) = sec%sol(isol)%dri%ctype
    enddo
    !
    ! Map buffers. NB: use same names as CLASS
    strdri = trim(str)//'%DRI'
    call sic_defstructure(strdri,.true.,error)
    if (error)  return
    !
    dims(1) = sec%nsol
    call sic_def_dble(trim(strdri)//'%FREQ', sec%var%drifreq, 1,dims,ro,error)
    call sic_def_real(trim(strdri)//'%WIDTH',sec%var%driwidth,1,dims,ro,error)
    call sic_def_inte(trim(strdri)//'%NPOIN',sec%var%drinpoin,1,dims,ro,error)
    call sic_def_real(trim(strdri)//'%RPOIN',sec%var%drirpoin,1,dims,ro,error)
    call sic_def_real(trim(strdri)//'%TREF', sec%var%dritref, 1,dims,ro,error)
    call sic_def_real(trim(strdri)//'%AREF', sec%var%driaref, 1,dims,ro,error)
    call sic_def_real(trim(strdri)//'%APOS', sec%var%driapos, 1,dims,ro,error)
    call sic_def_real(trim(strdri)//'%TRES', sec%var%dritres, 1,dims,ro,error)
    call sic_def_real(trim(strdri)//'%ARES', sec%var%driares, 1,dims,ro,error)
    call sic_def_inte(trim(strdri)//'%CTYPE',sec%var%drictype,1,dims,ro,error)
    if (error)  return
    ! ------------------------------------------------------------------
  end subroutine pointing_variable
  !
  subroutine pointing_array_reallocate(poi,msol,nent,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(sec_pointing_array_t), intent(inout) :: poi
    integer(kind=4),             intent(in)    :: msol
    integer(kind=8),             intent(in)    :: nent
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='VARIABLE'
    logical :: realloc
    integer(kind=4) :: ier
    !
    poi%msol = msol
    poi%nent = nent
    !
    if (allocated(poi%poinline)) then
      ! Strict equality on msol dimension, otherwise this means troubles when mapping SIC variables
      ! Lower than is fine for trailing dimension
      realloc = ubound(poi%poinline,1).ne.poi%msol .or.  &
                ubound(poi%poinline,2).lt.poi%nent
      if (poi%nent.le.0 .or. realloc) then
        deallocate(poi%nsol)
        !
        deallocate(poi%poinline,poi%poisigba,poi%poisigra)
        deallocate(poi%poinfit, poi%poinerr)
        !
        deallocate(poi%drifreq, poi%driwidth,poi%drinpoin)
        deallocate(poi%drirpoin,poi%dritref, poi%driaref)
        deallocate(poi%driapos, poi%dritres, poi%driares)
        deallocate(poi%drictype)
      endif
    else
      realloc = poi%nent.gt.0
    endif
    !
    if (realloc) then
      allocate(poi%nsol(poi%nent),stat=ier)
      !
      allocate(poi%poinline(poi%msol,poi%nent),poi%poisigba(poi%msol,poi%nent),stat=ier)
      allocate(poi%poisigra(poi%msol,poi%nent),                                stat=ier)
      allocate(poi%poinfit(mpoifit,poi%msol,poi%nent),                         stat=ier)
      allocate(poi%poinerr(mpoifit,poi%msol,poi%nent),                         stat=ier)
      !
      allocate(poi%drifreq(poi%msol,poi%nent), poi%driwidth(poi%msol,poi%nent),stat=ier)
      allocate(poi%drinpoin(poi%msol,poi%nent),poi%drirpoin(poi%msol,poi%nent),stat=ier)
      allocate(poi%dritref(poi%msol,poi%nent), poi%driaref(poi%msol,poi%nent), stat=ier)
      allocate(poi%driapos(poi%msol,poi%nent), poi%dritres(poi%msol,poi%nent), stat=ier)
      allocate(poi%driares(poi%msol,poi%nent), poi%drictype(poi%msol,poi%nent),stat=ier)
      if (failed_allocate(rname,'MDX%HEAD%POI arrays',ier,error))  return
    endif
  end subroutine pointing_array_reallocate
  !
  subroutine pointing_array_set(varpoi,ient,sec,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(sec_pointing_array_t), intent(inout) :: varpoi
    integer(kind=8),             intent(in)    :: ient
    type(sec_pointing_t),        intent(in)    :: sec
    logical,                     intent(inout) :: error
    !
    integer(kind=4) :: isol
    !
    varpoi%nsol(ient) = sec%nsol
    do isol=1,sec%nsol
      varpoi%poinline(isol,ient)  = sec%sol(isol)%poi%nline
      varpoi%poisigba(isol,ient)  = sec%sol(isol)%poi%sigba
      varpoi%poisigra(isol,ient)  = sec%sol(isol)%poi%sigra
      varpoi%poinfit(:,isol,ient) = sec%sol(isol)%poi%nfit(:)
      varpoi%poinerr(:,isol,ient) = sec%sol(isol)%poi%nerr(:)
      !
      varpoi%drifreq(isol,ient)  = sec%sol(isol)%dri%freq
      varpoi%driwidth(isol,ient) = sec%sol(isol)%dri%width
      varpoi%drinpoin(isol,ient) = sec%sol(isol)%dri%npoin
      varpoi%drirpoin(isol,ient) = sec%sol(isol)%dri%rpoin
      varpoi%dritref(isol,ient)  = sec%sol(isol)%dri%tref
      varpoi%driaref(isol,ient)  = sec%sol(isol)%dri%aref
      varpoi%driapos(isol,ient)  = sec%sol(isol)%dri%apos
      varpoi%dritres(isol,ient)  = sec%sol(isol)%dri%tres
      varpoi%driares(isol,ient)  = sec%sol(isol)%dri%ares
      varpoi%drictype(isol,ient) = sec%sol(isol)%dri%ctype
    enddo
    !
    ! Nullify the unused parts
    do isol=sec%nsol+1,varpoi%msol
      varpoi%poinline(isol,ient)  = 0
      varpoi%poisigba(isol,ient)  = 0.
      varpoi%poisigra(isol,ient)  = 0.
      varpoi%poinfit(:,isol,ient) = 0.
      varpoi%poinerr(:,isol,ient) = 0.
      !
      varpoi%drifreq(isol,ient)  = 0.d0
      varpoi%driwidth(isol,ient) = 0.
      varpoi%drinpoin(isol,ient) = 0
      varpoi%drirpoin(isol,ient) = 0.
      varpoi%dritref(isol,ient)  = 0.
      varpoi%driaref(isol,ient)  = 0.
      varpoi%driapos(isol,ient)  = 0.
      varpoi%dritres(isol,ient)  = 0.
      varpoi%driares(isol,ient)  = 0.
      varpoi%drictype(isol,ient) = 0
    enddo
  end subroutine pointing_array_set
  !
  subroutine pointing_array_variable(poi,str,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(sec_pointing_array_t), intent(in)    :: poi
    character(len=*),            intent(in)    :: str
    logical,                     intent(inout) :: error
    !
    character(len=32) :: topstr,strpoi,strdri
    integer(kind=index_length) :: dims(sic_maxdims)
    !
    topstr = trim(str)//'%POI'
    call sic_defstructure(topstr,.true.,error)
    if (error)  return
    dims(1) = poi%nent
    call sic_def_inte(trim(topstr)//'%N',poi%nsol,1,dims,.true.,error)
    if (error)  return
    !
    ! --- Pointing subsection ------------------------------------------
    !
    strpoi = trim(topstr)//'%POI'
    call sic_defstructure(strpoi,.true.,error)
    if (error)  return
    !
    dims(1) = poi%msol
    dims(2) = poi%nent
    call sic_def_inte(trim(strpoi)//'%NLINE',   poi%poinline,2,dims,.true.,error)
    call sic_def_real(trim(strpoi)//'%RMS_BASE',poi%poisigba,2,dims,.true.,error)
    call sic_def_real(trim(strpoi)//'%RMS_LINE',poi%poisigra,2,dims,.true.,error)
    if (error)  return
    dims(1) = mpoifit
    dims(2) = poi%msol
    dims(3) = poi%nent
    call sic_def_real(trim(strpoi)//'%RESULT',poi%poinfit,3,dims,.true.,error)
    call sic_def_real(trim(strpoi)//'%ERROR', poi%poinerr,3,dims,.true.,error)
    if (error)  return
    !
    ! --- Drift subsection ---------------------------------------------
    !
    strdri = trim(topstr)//'%DRI'
    call sic_defstructure(strdri,.true.,error)
    if (error)  return
    !
    dims(1) = poi%msol
    dims(2) = poi%nent
    call sic_def_dble(trim(strdri)//'%FREQ', poi%drifreq, 2,dims,.true.,error)
    call sic_def_real(trim(strdri)//'%WIDTH',poi%driwidth,2,dims,.true.,error)
    call sic_def_inte(trim(strdri)//'%NPOIN',poi%drinpoin,2,dims,.true.,error)
    call sic_def_real(trim(strdri)//'%RPOIN',poi%drirpoin,2,dims,.true.,error)
    call sic_def_real(trim(strdri)//'%TREF', poi%dritref, 2,dims,.true.,error)
    call sic_def_real(trim(strdri)//'%AREF', poi%driaref, 2,dims,.true.,error)
    call sic_def_real(trim(strdri)//'%APOS', poi%driapos, 2,dims,.true.,error)
    call sic_def_real(trim(strdri)//'%TRES', poi%dritres, 2,dims,.true.,error)
    call sic_def_real(trim(strdri)//'%ARES', poi%driares, 2,dims,.true.,error)
    call sic_def_inte(trim(strdri)//'%CTYPE',poi%drictype,2,dims,.true.,error)
    if (error)  return
  end subroutine pointing_array_variable
  !
  subroutine pointing_list_register_columns(sec,tab,error)
    use mrtindex_table
    !-------------------------------------------------------------------
    ! List the header of the columns displayed by pointing_list
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(in)    :: sec
    type(table_t),         intent(inout) :: tab
    logical,               intent(inout) :: error
    !
    call tab%register_column('Ndr',       '',           3,'(i3)',error)
    if (error)  return
    call tab%register_column('Subscan',   '',           3,'(i3)',error)
    if (error)  return
    call tab%register_column('Time',      '[day]',     11,'(f11.9)',error)
    if (error)  return
    call tab%register_column('Source',    '',          14,'(a)',error)
    if (error)  return
    call tab%register_column('Azimuth',   '[deg]',      8,'(f8.3)',error)
    if (error)  return
    call tab%register_column('Elevation', '[deg]',      7,'(f7.3)',error)
    if (error)  return
    call tab%register_column('idFe',      '',           5,'(a5)',error)
    if (error)  return
    call tab%register_column('Freq',      '[GHz]',      8,'(f8.4)',error)
    if (error)  return
    call tab%register_column('Angle',     '[deg]',      7,'(f7.2)',error)
    if (error)  return
    call tab%register_column('Modulo',    '[deg]',      7,'(f7.2)',error)
    if (error)  return
    call tab%register_column('Correction','[arcsec]',  12,'(1pg12.5)',error)
    if (error)  return
    call tab%register_column('Position',  '[arcsec]',  12,'(1pg12.5)',error)
    if (error)  return
    call tab%register_column('ErrPos',    '[arcsec]',  11,'(1pg11.5)',error)
    if (error)  return
    call tab%register_column('FWHM',      '[arcsec]',  12,'(1pg12.5)',error)
    if (error)  return
    call tab%register_column('ErrFWHM',   '[arcsec]',  11,'(1pg11.5)',error)
    if (error)  return
    call tab%register_column('Area',      '[K.arcsec]',12,'(1pg12.5)',error)
    if (error)  return
    call tab%register_column('ErrArea',   '[K.arcsec]',11,'(1pg11.5)',error)
    if (error)  return
    call tab%register_column('Offset',    '[K]',       12,'(1pg12.5)',error)
    if (error)  return
    call tab%register_column('ErrOffset', '[K]',       11,'(1pg11.5)',error)
    if (error)  return
    call tab%register_column('Slope',     '[K/arcsec]',12,'(1pg12.5)',error)
    if (error)  return
    call tab%register_column('ErrSlope',  '[K/arcsec]',11,'(1pg11.5)',error)
    if (error)  return
    call tab%register_column('RMS',       '[K]',       12,'(1pg12.5)',error)
    if (error)  return
  end subroutine pointing_list_register_columns
  !
  subroutine pointing_list(sec,tab,line,backid,olun,error)
    use phys_const
    use mrtindex_table
    !-------------------------------------------------------------------
    ! List the pointing section under specific format
    !-------------------------------------------------------------------
    class(sec_pointing_t), intent(in)    :: sec
    type(table_t),         intent(in)    :: tab
    type(line_t),          intent(in)    :: line
    integer(kind=4),       intent(in)    :: backid
    integer(kind=4),       intent(in)    :: olun
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: isol
    type(line_t) :: lline  ! Local line copy
    real(kind=4) :: corr,posi1
    !
    do isol=1,sec%nsol
      lline = line
      !
      call lline%new_value(tab,sec%sol(isol)%book%nobs,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%gen%subscan,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%gen%ut/twopi,error)  ! [day] Time in range [0:1] day
      if (error)  return
      call lline%new_value(tab,"'"//trim(sec%sol(isol)%pos%sourc)//"'",error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%gen%az*deg_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%gen%el*deg_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%gen%teles(4:8),error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%dri%freq/1.d3,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%dri%apos*deg_per_rad,error)
      if (error)  return
      call lline%new_value(tab,class_toc_drift_modulo(  &
                               sec%sol(isol)%book%keys(1:sec%sol(isol)%book%nkey))*deg_per_rad,  &
                               error)
      if (error)  return
      corr = pointing_collimation(sec%sol(isol)%dri)
      posi1 = sec%sol(isol)%poi%nfit(pointing_fit_posi1)*sec_per_rad
      if (corr.ne.sec%sol(isol)%dri%bad)  corr = corr*sec_per_rad+posi1
      call lline%new_value(tab,corr,error)
      if (error)  return
      call lline%new_value(tab,posi1,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nerr(pointing_fit_posi1)*sec_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nfit(pointing_fit_fwhm1)*sec_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nerr(pointing_fit_fwhm1)*sec_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nfit(pointing_fit_area1)*sec_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nerr(pointing_fit_area1)*sec_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nfit(pointing_fit_offset),error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nerr(pointing_fit_offset),error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nfit(pointing_fit_slope)/sec_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%nerr(pointing_fit_slope)/sec_per_rad,error)
      if (error)  return
      call lline%new_value(tab,sec%sol(isol)%poi%sigba,error)
      if (error)  return
      !
      call lline%list(olun,error)
      if (error)  return
    enddo
  end subroutine pointing_list
  !
  ! --- Extra utilities ------------------------------------------------
  !
  function pointing_direction(apos) result(code)
    use phys_const
    !-------------------------------------------------------------------
    ! Return the drift direction (as a code) from the drift angle.
    !-------------------------------------------------------------------
    integer(kind=4) :: code
    real(kind=4), intent(in) :: apos  ! [rad]
    !
    ! Because of the possible 0+-epsilon issues, modulo() is not reliable
    if (nearly_equal(apos,  0.,1.e-3) .or. &
        nearly_equal(apos,+pis,1.e-3) .or. &
        nearly_equal(apos,-pis,1.e-3)) then
      ! An azimuth drift
      code = code_pointing_azimuth
    elseif (nearly_equal(apos,+pis/2.,1.e-3) .or. &
            nearly_equal(apos,-pis/2.,1.e-3)) then
      ! An elevation drift
      code = code_pointing_elevation
    else
      ! Something else, could we derive it from colla/colle and the drift angle?
      code = code_pointing_unknown
    endif
  end function pointing_direction
  !
  function pointing_collimation(dri) result(colla)
    !-------------------------------------------------------------------
    ! Return the collimation angle from the drift section.
    !-------------------------------------------------------------------
    real(kind=4) :: colla  ! [rad]
    type(class_drift_t), intent(in) :: dri
    !
    select case (pointing_direction(dri%apos))
    case (code_pointing_azimuth)
      colla = dri%colla
    case (code_pointing_elevation)
      colla = dri%colle
    case default
      ! Something else, could we derive it from colla/colle and the drift angle?
      colla = dri%bad
    end select
  end function pointing_collimation
end module mrtindex_sec_pointing

subroutine write_fits_holodata (unit, iband, ntch, ib, ldata,   &
    data ,error)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Write the HOLO DATA  fits table, from CLIC continuum band iband
  ! it has three  columns.
  ! Assume one polarization, two sidebands.
  ! ibas is the baseline number used
  !---------------------------------------------------------------------
  integer :: unit                   !
  integer :: iband                  !
  integer :: ntch                   !
  integer :: ib                     !
  integer :: ldata                  !
  real :: data(ldata)               !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: nch, itable
  integer :: k, mf, status, nrows, tfields, varidat, ir, h_offset
  integer :: krow, isb, mdigit1, mdigit2, r_npol, r_nside
  integer :: ich, k0, c_offset, nsb, kd
  parameter(r_npol = 1, r_nside=2, mdigit2=13, mdigit1=8)
  parameter (mf = 7)
  character(len=16) :: ttype(mf),tform(mf),tunit(mf), extname
  data ttype/     'INTEGNUM',   &
    'HOLOSS', 'HOLORR', 'HOLOQQ', 'HOLOSR', 'HOLOSQ', 'HOLOQR'/
  data tform/     '1J',   &
    '1E',      '1E',      '1E',      '1E',      '1E',      '1E'/
  data tunit/     ' ',   &
    ' ',       ' ',        ' ',       ' ',       ' ',       ' '/
  !---------------------------------------------------------------------
  !
  !  Append/create a new empty HDU onto the end of the file and move to it.
  status = 0
  call ftcrhd(unit,status)
  !
  !  Define parameters for the binary table (see the above data statements)
  !
  nrows = r_ndump
  nch = 1
  ich = 1
  nsb = 2
  itable = 1
  tfields = mf
  if (r_lmode.ne.1) then
    write (6,*) 'programming error, should be correlation ... '
    error = .true.
    return
  endif
  extname = 'HOLODATA-ALMATI'
  varidat = 0
  !
  call ftphbn(unit,nrows,tfields,ttype,tform,tunit,   &
    extname,varidat,status)
  ! Other header keywords
  call ftpkys(unit,'TABLEREV','v1.0 2001-07-03',   &
    extname//' release',status)
  if (status .gt. 0) goto 99
  call write_fits_dobs(unit,error)
  if (error) return
  !      CALL FTPKYJ(UNIT,'SCAN-NUM',R_SCAN,'Scan number',STATUS)
  !      IF (STATUS .GT. 0) GOTO 99
  !      CALL FTPKYJ(UNIT,'OBS-NUM',R_NUM,'Observation number',STATUS)
  !      IF (STATUS .GT. 0) GOTO 99
  call ftpkyj(unit,'NO_POL',1,'Number of pols.',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'CHANNELS',1,   &
    'number of channels in baseband',status)
  call ftpkyj(unit,'BASEBAND',1,'Baseband number',status)
  call ftpkyj(unit,'TABLEID',1,'Baseband table number ',status)
  if (status .gt. 0) goto 99
  call ftpkye(unit,'TRANDIST',300.,mdigit1,   &
    'Transmitter Distance (m)',status)
  call ftpkyd(unit,'TRANFREQ',r_restf*1d6,mdigit2,   &
    'Transmitter Frequency (Hz)',status)
  call ftpkye(unit,'TRANFOCU',0.10123,mdigit1,   &
    'Focus Offset (m)',status)
  if (r_flux.ne.0) then
    call ftpkye(unit,'IFLUX',r_flux,mdigit1,'Flux in I (Jy)',   &
      status)
  endif
  ! loop on table rows
  krow = 0
  do ir=1, nrows
    k = 1 + h_offset(ir)
    call decode_header (data(k))
    k0 = 1 + c_offset(ir)
    krow = krow+1
    !
    ! Fill in the columns:
    ! INTEGNUM
    call ftpclj(unit,1,krow,1,1,dh_dump,status)
    isb = (1-r_isb)/2+1
    kd = k0 + (ich+(isb-1+(ib-1)*nsb)*ntch)*2
    ! col 2: s*s
    call ftpcle(unit,2,krow,1,1,sqrt(data(kd)**2+data(kd+1)**2),   &
      status)
    ! col 3: r*r
    call ftpcle(unit,3,krow,1,1,1.0,status)
    ! col 4: s*s
    call ftpcle(unit,4,krow,1,1,1.0,status)
    ! col 5: s*r
    call ftpcle(unit,5,krow,1,1,data(kd),status)
    ! col 6: s*q
    call ftpcle(unit,6,krow,1,1,data(kd+1),status)
    ! col 7: q*r
    call ftpcle(unit,7,krow,1,1,0.0,status)
  enddo
  if (status .gt. 0) goto 99
  return
  ! Error return
99 call printerror('WRITE_FITS_HOLODATA',status)
  error = .true.
end subroutine write_fits_holodata

subroutine class_copy(set,line,error,user_function)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_copy
  use class_index
  use class_common
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS support routine for command
  !   COPY
  ! 1    [/SORTED]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Command line
  logical,             intent(inout) :: error          ! Logical error flag
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='COPY'
  character(len=message_length) :: mess
  integer(kind=entry_length) :: ientry,nentry
  type(observation) :: obs
  type(time_t) :: time
  !
  ! Parse input line for /SORTED option
  if (.not.sic_present(1,0)) then
     if (set%sort_name.ne."NONE") then
        write(mess,*) 'Copying a sorted index often is inefficient'
        call class_message(seve%e,rname,mess)
        write(mess,*) 'Reform the index with SET SORT NONE or confirm the sorting with the /SORTED option'
        call class_message(seve%e,rname,mess)
        error = .true.
        return
     endif
  endif
  !
  ! Sanity checks: I. Files
  if (.not.filein_opened(rname,error))  return
  if (.not.fileout_opened(rname,error))  return
  if (filein_is_fileout()) then
     call class_message(seve%w,rname,'Input file = output file => Nothing to be done')
     return
  endif
  !
  ! Sanity checks: II. Index
  if (cx%next.le.1) then
     call class_message(seve%e,rname,'Index is empty')
     error = .true.
     return
  endif
  !
  call init_obs(obs)
  !
  ! Get number of entries in index
  nentry = cx%next-1
  !
  call gtime_init(time,nentry,error)
  if (error)  return
  !
  ! Loop on entries
  do ientry=1,nentry
    call gtime_current(time)
    !
    ! Exit when asked by user
    call class_controlc(rname,error)
    if (error)  exit
    !
    ! Read header and data sections into obs buffer from input file
    call get_it(set,obs,cx%ind(ientry),user_function,error)
    if (error)  exit
    !
    ! Output file is multiple: keep the observation number. If same
    !        number already exists, a new version will be written.
    ! Output file is single: set obs number to 0, class_write() will
    !        assign a new one automatically.
    if (fileout%desc%single)  obs%head%gen%num = 0
    !
    ! Write header and data sections from obs buffer to output file
    call class_write(set,obs,error,user_function)
    if (error)  exit
    !
  enddo
  !
  if (error) then
    write (mess,'(A,I0,A,I0,A)')  &
      'Incomplete output (stopped at ',ientry,'-th observation over ',  &
      nentry,' in index)'
    call class_message(seve%e,rname,mess)
  endif
  !
  call free_obs(obs)  ! MUST be done
  !
  call classcore_fileout_flush(error)
  !
end subroutine class_copy

program xview_main
  use gildas_def
  use gbl_format
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  ! X-Window viewer for GILDAS images
  !     F.Badia - F.Viallefond - S.Guilloteau
  !---------------------------------------------------------------------
  ! Global
  integer :: lenc
  integer(kind=address_length) :: gag_pointer
  include 'gbl_xpar.inc'
  include 'gbl_memory.inc'
  include 'mview.inc'
  ! Local
  character(len=80) :: namex
  character(len=256) :: helpfile,helptxt
  integer*4 :: blc(4), trc(4), pids(3)
  integer :: i,form,n
  real :: blank(2)
  logical :: error
  type(projection_t) :: proj
  external :: user_coord
  !
  data blc /4*0/, trc /4*0/
  !
  write(6,*) 'F-XVIEW,  Tasks has not yet been ported to support large data sets'
  ! In particular blc and trc must be integer(kind=index_length)
  call sysexi(fatale)
  !
  call gildas_open
  call gildas_char('X_NAME$',namex)
  call gildas_inte('BLC$',blc,4)
  call gildas_inte('TRC$',trc,4)
  call gildas_inte('PROCESS_IDS$',pids,3)
  call gildas_close
  !
  call sic_parsef(namex,x_file,' ','.gdf')
  call gdf_geis (x_islo,error)
  if (.not.error) call   &
     &    gdf_reis (x_islo,x_type,x_file,x_form,x_size,error)
  if (error) then
    write(6,*) 'F-XVIEW,  Cannot read input file'
    call sysexi(fatale)
  endif
  call gdf_readx (x_islo,error)
  !
  ! Define projection and axis types.
  if (x_proj.ne.0 .and. x_ptyp.ne.0) then
    if (x_xaxi.eq.0.and.x_yaxi.eq.0) then
      x_xaxi = 1
      x_yaxi = 2
    endif
    call gwcs_projec(x_a0,x_d0,x_pang,x_ptyp,proj,error)
  else
    x_xaxi = 1
    x_yaxi = 2
    call gwcs_projec(x_a0,x_d0,x_pang,0,proj,error)
  endif
  if (x_faxi.eq.0) then
    do i=1,3
      if (i.ne.x_xaxi .and. i.ne.x_yaxi) x_faxi = i
    enddo
  endif
  !
  ! Blanking
  if (x_blan.eq.0) then
    x_bval = 0.0
    x_eval = -1.0
  endif
  !
  ! Define and load subset
  do i=1,4
    blc(i) = max(1,min(blc(i),x_dim(i)))
    if (trc(i).eq.0) then
      trc(i) = x_dim(i)
    else
      trc(i) = min(x_dim(i),trc(i))
    endif
    dim(i) = trc(i)-blc(i)+1
  enddo
  ox = blc(1)
  oy = blc(2)
  oz = blc(3)
  form = fmt_r4
  call gdf_gems (x_mslo,x_islo,blc,trc,x_addr,form,error)
  ipx = gag_pointer(x_addr,memory)
  !
  ! Give to MVIEW
  n = lenc(x_file)+1
  x_file(n:n) = char(0)
  helpfile='mview'
  if (sic_findfile(helpfile,helptxt,'TASK#DIR:','.hlp')) then
    n = lenc(helptxt)
    n = n+1
    helptxt(n:n) = char(0)
  else
    helptxt(n:n) = char(0)
  endif
  blank(1) = x_bval
  blank(2) = x_eval
  call mview (x_file,memory(ipx),dim, user_coord,   &
     &    helptxt,pids,blank)
  call gdf_fris (x_islo,error)
  !
end program xview_main
!
subroutine user_coord(ix,jy,kz,u,chainx,chainy,chainz,chainv)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! Return User coordinates corresponding to one pixel, and the
  ! associated pixel value, as well as formatted strings to display
  ! the result
  !---------------------------------------------------------------------
  integer, intent(in) ::  ix                 ! Pixel number
  integer, intent(in) ::  jy                 ! Pixel number
  integer, intent(in) ::  kz                 ! Pixel number
  real(kind=8), intent(out) :: u(3)          ! User coordinates
  character(len=80) , intent(out) :: chainx  ! X string
  character(len=80) , intent(out) :: chainy  ! Y string
  character(len=80) , intent(out) :: chainz  ! Z string
  character(len=80) , intent(out) :: chainv  ! Value string
  ! Global
  integer(kind=address_length) :: gag_pointer
  real*4 :: value
  include 'gbl_xpar.inc'
  include 'gbl_memory.inc'
  include 'mview.inc'
  ! Local
  real*8 :: ux,vy,wz,aux,avy
  real*4 :: r
  character(len=80) :: chain(3)
  !
  data chain/' ',' ',' '/
  !
  ! Get value first
  ipx = gag_pointer(x_addr,memory)
  r = value (memory(ipx),dim(1),dim(2),dim(3),ix,jy,kz)
  write(chainv,'(1PG11.3)') r
  chainv(13:) = x_unit
  !
  ! Convert to original pixels
  u(1) = (dble(ix+ox-1)-x_ref1)*x_inc1+x_val1
  u(2) = (dble(jy+oy-1)-x_ref2)*x_inc2+x_val2
  u(3) = (dble(kz+oz-1)-x_ref3)*x_inc3+x_val3
  !
  ! Compute the various permutations...
  ux = u(x_xaxi)
  vy = u(x_yaxi)
  wz = u(x_faxi)
  !
  ! ZZZ This must be the 'proj' set by gwcs_setproj
  call rel_to_abs (proj,ux, vy, aux, avy, 1)
  !
  call sexag(chain(x_xaxi),aux,24)
  call sexag(chain(x_yaxi),avy,360)
  write(chain(x_faxi),'(F12.3)') wz
  !
  ! Inverse permutation
  chainx = trim(chain(1))//char(0)
  chainy = trim(chain(2))//char(0)
  chainz = trim(chain(3))//char(0)
end subroutine user_coord
!
function value(z,nx,ny,nz,ix,iy,iz)
  real :: value                     !
  integer :: nx                     !
  integer :: ny                     !
  integer :: nz                     !
  real :: z(nx,ny,nz)               !
  integer :: ix                     !
  integer :: iy                     !
  integer :: iz                     !
  value = z(ix,iy,iz)
end function value
!
subroutine spectre(np,poly,s1)
  use gkernel_interfaces
  use gildas_def
  integer :: np                     !
  real :: poly(2,np)                !
  real :: s1(*)                     !
  ! Global
  real*4 :: value
  integer(kind=address_length) :: gag_pointer
  include 'gbl_xpar.inc'
  include 'gbl_memory.inc'
  include 'mview.inc'
  ! Local
  integer(kind=address_length) :: addr, ipa
  integer :: mp, ier
  integer :: imin,imax,jmin,jmax,i,j,k
  real*8 :: x,y,bound(5)
  real*4 :: val, bb, eb
  integer, allocatable :: s0(:)
  !
  allocate (s0(dim(3)),stat=ier)
  do i=1,dim(3)
    s0(i) = 0
    s1(i) = 0.
  enddo
  mp = np+1
  ier = sic_getvm(8*mp,addr)
  ipa = gag_pointer(addr,memory)
  call define_poly(poly,np,mp,memory(ipa),bound)
  !
  ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
  imin = max (1, int(bound(2)) )
  imax = min (dim(1),int(bound(3))+1 )
  jmin = max (1, int(bound(4)) )
  jmax = min (dim(2),int(bound(5))+1 )
  !
  ! Now explore a reasonable part of the map
  ipx = gag_pointer(x_addr,memory)
  if (x_eval.lt.0.0) then
    do j=jmin,jmax
      do i=imin,imax
        x = dble(i)
        y = dble(j)
        if (gr8_in(x,y,np,memory(ipa),bound)) then
          do k=1,dim(3)
            s0(k) = s0(k) + 1
            s1(k) = s1(k) + value (memory(ipx),   &
     &              dim(1),dim(2),dim(3),   &
     &              i,j,k)
          enddo
        endif
      enddo
    enddo
  else
    eb = x_eval
    bb = x_bval
    do j=jmin,jmax
      do i=imin,imax
        x = dble(i)
        y = dble(j)
        if (gr8_in(x,y,np,memory(ipa),bound)) then
          do k=1,dim(3)
            val = value (memory(ipx),   &
     &              dim(1),dim(2),dim(3),   &
     &              i,j,k)
            if (abs(val-bb).gt.eb) then
              s0(k) = s0(k) + 1
              s1(k) = s1(k) + val
            endif
          enddo
        endif
      enddo
    enddo
  endif
  !
  x = abs(x_inc1*x_inc2)
  do k=1,dim(3)
    if (s0(k).ne.0) then
      s1(k) = s1(k) / float(s0(k)) * x
    endif
  enddo
  deallocate (s0)
end subroutine spectre
!
subroutine define_poly (poly,np,mp,gons,bound)
  integer :: np                     !
  real*4 :: poly(2,np)              !
  integer :: mp                     !
  real*8 :: gons(mp,4)              !
  real*8 :: bound(5)                !
  ! Local
  integer :: i,ngon
  real*8 :: xgon1,xgon2,ygon1,ygon2
  !
  ! Setup the polygon data structure
  ngon = np
  do i=1,ngon
    gons(i,1) = poly(1,i)
    gons(i,2) = poly(2,i)
  enddo
  !
  gons(ngon+1,1) = gons(1,1)
  gons(ngon+1,2) = gons(1,2)
  xgon1 = gons(1,1)
  xgon2 = gons(1,1)
  ygon1 = gons(1,2)
  ygon2 = gons(1,2)
  do i=1,ngon
    gons(i,3) = gons(i+1,1)-gons(i,1)
    if (gons(i+1,1).lt.xgon1) then
      xgon1 = gons(i+1,1)
    elseif (gons(i+1,1).gt.xgon2) then
      xgon2 = gons(i+1,1)
    endif
    gons(i,4) = gons(i+1,2)-gons(i,2)
    if (gons(i+1,2).lt.ygon1) then
      ygon1 = gons(i+1,2)
    elseif (gons(i+1,2).gt.ygon2) then
      ygon2 = gons(i+1,2)
    endif
  enddo
  bound(1) = xgon1-0.01*(xgon2-xgon1)
  bound(2) = xgon1
  bound(3) = xgon2
  bound(4) = ygon1
  bound(5) = ygon2
end subroutine define_poly

*DECK DRC
      DOUBLE PRECISION FUNCTION DRC (X, Y, IER)
C***BEGIN PROLOGUE  DRC
C***PURPOSE  Calculate a double precision approximation to
C             DRC(X,Y) = Integral from zero to infinity of
C                              -1/2     -1
C                    (1/2)(t+X)    (t+Y)  dt,
C            where X is nonnegative and Y is positive.
C***LIBRARY   SLATEC
C***CATEGORY  C14
C***TYPE      DOUBLE PRECISION (RC-S, DRC-D)
C***KEYWORDS  DUPLICATION THEOREM, ELEMENTARY FUNCTIONS,
C             ELLIPTIC INTEGRAL, TAYLOR SERIES
C***AUTHOR  Carlson, B. C.
C             Ames Laboratory-DOE
C             Iowa State University
C             Ames, IA  50011
C           Notis, E. M.
C             Ames Laboratory-DOE
C             Iowa State University
C             Ames, IA  50011
C           Pexton, R. L.
C             Lawrence Livermore National Laboratory
C             Livermore, CA  94550
C***DESCRIPTION
C
C   1.     DRC
C          Standard FORTRAN function routine
C          Double precision version
C          The routine calculates an approximation result to
C          DRC(X,Y) = integral from zero to infinity of
C
C                              -1/2     -1
C                    (1/2)(t+X)    (t+Y)  dt,
C
C          where X is nonnegative and Y is positive.  The duplication
C          theorem is iterated until the variables are nearly equal,
C          and the function is then expanded in Taylor series to fifth
C          order.  Logarithmic, inverse circular, and inverse hyper-
C          bolic functions can be expressed in terms of DRC.
C
C   2.     Calling Sequence
C          DRC( X, Y, IER )
C
C          Parameters On Entry
C          Values assigned by the calling routine
C
C          X      - Double precision, nonnegative variable
C
C          Y      - Double precision, positive variable
C
C
C
C          On Return  (values assigned by the DRC routine)
C
C          DRC    - Double precision approximation to the integral
C
C          IER    - Integer to indicate normal or abnormal termination.
C
C                     IER = 0 Normal and reliable termination of the
C                             routine.  It is assumed that the requested
C                             accuracy has been achieved.
C
C                     IER > 0 Abnormal termination of the routine
C
C          X and Y are unaltered.
C
C   3.    Error messages
C
C         Value of IER assigned by the DRC routine
C
C                  Value assigned         Error message printed
C                  IER = 1                X.LT.0.0D0.OR.Y.LE.0.0D0
C                      = 2                X+Y.LT.LOLIM
C                      = 3                MAX(X,Y) .GT. UPLIM
C
C   4.     Control parameters
C
C                  Values of LOLIM, UPLIM, and ERRTOL are set by the
C                  routine.
C
C          LOLIM and UPLIM determine the valid range of X and Y
C
C          LOLIM  - Lower limit of valid arguments
C
C                   Not less  than 5 * (machine minimum)  .
C
C          UPLIM  - Upper limit of valid arguments
C
C                   Not greater than (machine maximum) / 5 .
C
C
C                     Acceptable values for:   LOLIM       UPLIM
C                     IBM 360/370 SERIES   :   3.0D-78     1.0D+75
C                     CDC 6000/7000 SERIES :   1.0D-292    1.0D+321
C                     UNIVAC 1100 SERIES   :   1.0D-307    1.0D+307
C                     CRAY                 :   2.3D-2466   1.0D+2465
C                     VAX 11 SERIES        :   1.5D-38     3.0D+37
C
C          ERRTOL determines the accuracy of the answer
C
C                 The value assigned by the routine will result
C                 in solution precision within 1-2 decimals of
C                 "machine precision".
C
C
C          ERRTOL  - relative error due to truncation is less than
C                    16 * ERRTOL ** 6 / (1 - 2 * ERRTOL).
C
C
C              The accuracy of the computed approximation to the inte-
C              gral can be controlled by choosing the value of ERRTOL.
C              Truncation of a Taylor series after terms of fifth order
C              introduces an error less than the amount shown in the
C              second column of the following table for each value of
C              ERRTOL in the first column.  In addition to the trunca-
C              tion error there will be round-off error, but in prac-
C              tice the total error from both sources is usually less
C              than the amount given in the table.
C
C
C
C          Sample choices:  ERRTOL   Relative truncation
C                                    error less than
C                           1.0D-3    2.0D-17
C                           3.0D-3    2.0D-14
C                           1.0D-2    2.0D-11
C                           3.0D-2    2.0D-8
C                           1.0D-1    2.0D-5
C
C
C                    Decreasing ERRTOL by a factor of 10 yields six more
C                    decimal digits of accuracy at the expense of one or
C                    two more iterations of the duplication theorem.
C
C *Long Description:
C
C   DRC special comments
C
C
C
C
C                  Check: DRC(X,X+Z) + DRC(Y,Y+Z) = DRC(0,Z)
C
C                  where X, Y, and Z are positive and X * Y = Z * Z
C
C
C          On Input:
C
C          X, and Y are the variables in the integral DRC(X,Y).
C
C          On Output:
C
C          X and Y are unaltered.
C
C
C
C                    DRC(0,1/4)=DRC(1/16,1/8)=PI=3.14159...
C
C                    DRC(9/4,2)=LN(2)
C
C
C
C          ********************************************************
C
C          WARNING: Changes in the program may improve speed at the
C                   expense of robustness.
C
C
C   --------------------------------------------------------------------
C
C   Special functions via DRC
C
C
C
C                  LN X                X .GT. 0
C
C                                             2
C                  LN(X) = (X-1) DRC(((1+X)/2)  , X )
C
C
C   --------------------------------------------------------------------
C
C                  ARCSIN X            -1 .LE. X .LE. 1
C
C                                       2
C                  ARCSIN X = X DRC (1-X  ,1 )
C
C   --------------------------------------------------------------------
C
C                  ARCCOS X            0 .LE. X .LE. 1
C
C
C                                     2       2
C                  ARCCOS X = SQRT(1-X ) DRC(X  ,1 )
C
C   --------------------------------------------------------------------
C
C                  ARCTAN X            -INF .LT. X .LT. +INF
C
C                                        2
C                  ARCTAN X = X DRC(1,1+X  )
C
C   --------------------------------------------------------------------
C
C                  ARCCOT X            0 .LE. X .LT. INF
C
C                                  2   2
C                  ARCCOT X = DRC(X  ,X +1 )
C
C   --------------------------------------------------------------------
C
C                  ARCSINH X           -INF .LT. X .LT. +INF
C
C                                       2
C                  ARCSINH X = X DRC(1+X  ,1 )
C
C   --------------------------------------------------------------------
C
C                  ARCCOSH X           X .GE. 1
C
C                                    2         2
C                  ARCCOSH X = SQRT(X -1) DRC(X  ,1 )
C
C   --------------------------------------------------------------------
C
C                  ARCTANH X           -1 .LT. X .LT. 1
C
C                                         2
C                  ARCTANH X = X DRC(1,1-X  )
C
C   --------------------------------------------------------------------
C
C                  ARCCOTH X           X .GT. 1
C
C                                   2   2
C                  ARCCOTH X = DRC(X  ,X -1 )
C
C   --------------------------------------------------------------------
C
C***REFERENCES  B. C. Carlson and E. M. Notis, Algorithms for incomplete
C                 elliptic integrals, ACM Transactions on Mathematical
C                 Software 7, 3 (September 1981), pp. 398-403.
C               B. C. Carlson, Computing elliptic integrals by
C                 duplication, Numerische Mathematik 33, (1979),
C                 pp. 1-16.
C               B. C. Carlson, Elliptic integrals of the first kind,
C                 SIAM Journal of Mathematical Analysis 8, (1977),
C                 pp. 231-242.
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891009  Removed unreferenced statement labels.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900510  Changed calls to XERMSG to standard form, and some
C           editorial changes.  (RWC))
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DRC
      CHARACTER*16 XERN3, XERN4, XERN5
      INTEGER IER
      DOUBLE PRECISION C1, C2, ERRTOL, LAMDA, LOLIM, D1MACH
      DOUBLE PRECISION MU, S, SN, UPLIM, X, XN, Y, YN
      LOGICAL FIRST
      SAVE ERRTOL,LOLIM,UPLIM,C1,C2,FIRST
      DATA FIRST /.TRUE./
C
C***FIRST EXECUTABLE STATEMENT  DRC
      IF (FIRST) THEN
         ERRTOL = (D1MACH(3)/16.0D0)**(1.0D0/6.0D0)
         LOLIM  = 5.0D0 * D1MACH(1)
         UPLIM  = D1MACH(2) / 5.0D0
C
         C1 = 1.0D0/7.0D0
         C2 = 9.0D0/22.0D0
      ENDIF
      FIRST = .FALSE.
C
C         CALL ERROR HANDLER IF NECESSARY.
C
      DRC = 0.0D0
      IF (X.LT.0.0D0.OR.Y.LE.0.0D0) THEN
         IER = 1
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         CALL XERMSG ('SLATEC', 'DRC',
     *      'X.LT.0 .OR. Y.LE.0 WHERE X = ' // XERN3 // ' AND Y = ' //
     *      XERN4, 1, 1)
         RETURN
      ENDIF
C
      IF (MAX(X,Y).GT.UPLIM) THEN
         IER = 3
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') UPLIM
         CALL XERMSG ('SLATEC', 'DRC',
     *      'MAX(X,Y).GT.UPLIM WHERE X = '  // XERN3 // ' Y = ' //
     *      XERN4 // ' AND UPLIM = ' // XERN5, 3, 1)
         RETURN
      ENDIF
C
      IF (X+Y.LT.LOLIM) THEN
         IER = 2
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') LOLIM
         CALL XERMSG ('SLATEC', 'DRC',
     *      'X+Y.LT.LOLIM WHERE X = ' // XERN3 // ' Y = ' // XERN4 //
     *      ' AND LOLIM = ' // XERN5, 2, 1)
         RETURN
      ENDIF
C
      IER = 0
      XN = X
      YN = Y
C
   30 MU = (XN+YN+YN)/3.0D0
      SN = (YN+MU)/MU - 2.0D0
      IF (ABS(SN).LT.ERRTOL) GO TO 40
      LAMDA = 2.0D0*SQRT(XN)*SQRT(YN) + YN
      XN = (XN+LAMDA)*0.250D0
      YN = (YN+LAMDA)*0.250D0
      GO TO 30
C
   40 S = SN*SN*(0.30D0+SN*(C1+SN*(0.3750D0+SN*C2)))
      DRC = (1.0D0+S)/SQRT(MU)
      RETURN
      END
*DECK DRC3JJ
      SUBROUTINE DRC3JJ (L2, L3, M2, M3, L1MIN, L1MAX, THRCOF, NDIM,
     +   IER)
C***BEGIN PROLOGUE  DRC3JJ
C***PURPOSE  Evaluate the 3j symbol f(L1) = (  L1   L2 L3)
C                                           (-M2-M3 M2 M3)
C            for all allowed values of L1, the other parameters
C            being held fixed.
C***LIBRARY   SLATEC
C***CATEGORY  C19
C***TYPE      DOUBLE PRECISION (RC3JJ-S, DRC3JJ-D)
C***KEYWORDS  3J COEFFICIENTS, 3J SYMBOLS, CLEBSCH-GORDAN COEFFICIENTS,
C             RACAH COEFFICIENTS, VECTOR ADDITION COEFFICIENTS,
C             WIGNER COEFFICIENTS
C***AUTHOR  Gordon, R. G., Harvard University
C           Schulten, K., Max Planck Institute
C***DESCRIPTION
C
C *Usage:
C
C        DOUBLE PRECISION L2, L3, M2, M3, L1MIN, L1MAX, THRCOF(NDIM)
C        INTEGER NDIM, IER
C
C        CALL DRC3JJ (L2, L3, M2, M3, L1MIN, L1MAX, THRCOF, NDIM, IER)
C
C *Arguments:
C
C     L2 :IN      Parameter in 3j symbol.
C
C     L3 :IN      Parameter in 3j symbol.
C
C     M2 :IN      Parameter in 3j symbol.
C
C     M3 :IN      Parameter in 3j symbol.
C
C     L1MIN :OUT  Smallest allowable L1 in 3j symbol.
C
C     L1MAX :OUT  Largest allowable L1 in 3j symbol.
C
C     THRCOF :OUT Set of 3j coefficients generated by evaluating the
C                 3j symbol for all allowed values of L1.  THRCOF(I)
C                 will contain f(L1MIN+I-1), I=1,2,...,L1MAX+L1MIN+1.
C
C     NDIM :IN    Declared length of THRCOF in calling program.
C
C     IER :OUT    Error flag.
C                 IER=0 No errors.
C                 IER=1 Either L2.LT.ABS(M2) or L3.LT.ABS(M3).
C                 IER=2 Either L2+ABS(M2) or L3+ABS(M3) non-integer.
C                 IER=3 L1MAX-L1MIN not an integer.
C                 IER=4 L1MAX less than L1MIN.
C                 IER=5 NDIM less than L1MAX-L1MIN+1.
C
C *Description:
C
C     Although conventionally the parameters of the vector addition
C  coefficients satisfy certain restrictions, such as being integers
C  or integers plus 1/2, the restrictions imposed on input to this
C  subroutine are somewhat weaker. See, for example, Section 27.9 of
C  Abramowitz and Stegun or Appendix C of Volume II of A. Messiah.
C  The restrictions imposed by this subroutine are
C       1. L2 .GE. ABS(M2) and L3 .GE. ABS(M3);
C       2. L2+ABS(M2) and L3+ABS(M3) must be integers;
C       3. L1MAX-L1MIN must be a non-negative integer, where
C          L1MAX=L2+L3 and L1MIN=MAX(ABS(L2-L3),ABS(M2+M3)).
C  If the conventional restrictions are satisfied, then these
C  restrictions are met.
C
C     The user should be cautious in using input parameters that do
C  not satisfy the conventional restrictions. For example, the
C  the subroutine produces values of
C       f(L1) = ( L1  2.5  5.8)
C               (-0.3 1.5 -1.2)
C  for L1=3.3,4.3,...,8.3 but none of the symmetry properties of the 3j
C  symbol, set forth on page 1056 of Messiah, is satisfied.
C
C     The subroutine generates f(L1MIN), f(L1MIN+1), ..., f(L1MAX)
C  where L1MIN and L1MAX are defined above. The sequence f(L1) is
C  generated by a three-term recurrence algorithm with scaling to
C  control overflow. Both backward and forward recurrence are used to
C  maintain numerical stability. The two recurrence sequences are
C  matched at an interior point and are normalized from the unitary
C  property of 3j coefficients and Wigner's phase convention.
C
C    The algorithm is suited to applications in which large quantum
C  numbers arise, such as in molecular dynamics.
C
C***REFERENCES  1. Abramowitz, M., and Stegun, I. A., Eds., Handbook
C                  of Mathematical Functions with Formulas, Graphs
C                  and Mathematical Tables, NBS Applied Mathematics
C                  Series 55, June 1964 and subsequent printings.
C               2. Messiah, Albert., Quantum Mechanics, Volume II,
C                  North-Holland Publishing Company, 1963.
C               3. Schulten, Klaus and Gordon, Roy G., Exact recursive
C                  evaluation of 3j and 6j coefficients for quantum-
C                  mechanical coupling of angular momenta, J Math
C                  Phys, v 16, no. 10, October 1975, pp. 1961-1970.
C               4. Schulten, Klaus and Gordon, Roy G., Semiclassical
C                  approximations to 3j  and 6j coefficients for
C                  quantum-mechanical coupling of angular momenta,
C                  J Math Phys, v 16, no. 10, October 1975,
C                  pp. 1971-1988.
C               5. Schulten, Klaus and Gordon, Roy G., Recursive
C                  evaluation of 3j and 6j coefficients, Computer
C                  Phys Comm, v 11, 1976, pp. 269-278.
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   880515  SLATEC prologue added by G. C. Nielson, NBS; parameters
C           HUGE and TINY revised to depend on D1MACH.
C   891229  Prologue description rewritten; other prologue sections
C           revised; LMATCH (location of match point for recurrences)
C           removed from argument list; argument IER changed to serve
C           only as an error flag (previously, in cases without error,
C           it returned the number of scalings); number of error codes
C           increased to provide more precise error information;
C           program comments revised; SLATEC error handler calls
C           introduced to enable printing of error messages to meet
C           SLATEC standards. These changes were done by D. W. Lozier,
C           M. A. McClain and J. M. Smith of the National Institute
C           of Standards and Technology, formerly NBS.
C   910415  Mixed type expressions eliminated; variable C1 initialized;
C           description of THRCOF expanded. These changes were done by
C           D. W. Lozier.
C***END PROLOGUE  DRC3JJ
C
      INTEGER NDIM, IER
      DOUBLE PRECISION L2, L3, M2, M3, L1MIN, L1MAX, THRCOF(NDIM)
C
      INTEGER I, INDEX, LSTEP, N, NFIN, NFINP1, NFINP2, NFINP3, NLIM,
     +        NSTEP2
      DOUBLE PRECISION A1, A1S, A2, A2S, C1, C1OLD, C2, CNORM, D1MACH,
     +                 DENOM, DV, EPS, HUGE, L1, M1, NEWFAC, OLDFAC,
     +                 ONE, RATIO, SIGN1, SIGN2, SRHUGE, SRTINY, SUM1,
     +                 SUM2, SUMBAC, SUMFOR, SUMUNI, THREE, THRESH,
     +                 TINY, TWO, X, X1, X2, X3, Y, Y1, Y2, Y3, ZERO
C
      DATA  ZERO,EPS,ONE,TWO,THREE /0.0D0,0.01D0,1.0D0,2.0D0,3.0D0/
C
C***FIRST EXECUTABLE STATEMENT  DRC3JJ
      IER=0
C  HUGE is the square root of one twentieth of the largest floating
C  point number, approximately.
      HUGE = SQRT(D1MACH(2)/20.0D0)
      SRHUGE = SQRT(HUGE)
      TINY = 1.0D0/HUGE
      SRTINY = 1.0D0/SRHUGE
C
C     LMATCH = ZERO
      M1 = - M2 - M3
C
C  Check error conditions 1 and 2.
      IF((L2-ABS(M2)+EPS.LT.ZERO).OR.
     +   (L3-ABS(M3)+EPS.LT.ZERO))THEN
         IER=1
         CALL XERMSG('SLATEC','DRC3JJ','L2-ABS(M2) or L3-ABS(M3) '//
     +      'less than zero.',IER,1)
         RETURN
      ELSEIF((MOD(L2+ABS(M2)+EPS,ONE).GE.EPS+EPS).OR.
     +   (MOD(L3+ABS(M3)+EPS,ONE).GE.EPS+EPS))THEN
         IER=2
         CALL XERMSG('SLATEC','DRC3JJ','L2+ABS(M2) or L3+ABS(M3) '//
     +      'not integer.',IER,1)
         RETURN
      ENDIF
C
C
C
C  Limits for L1
C
      L1MIN = MAX(ABS(L2-L3),ABS(M1))
      L1MAX = L2 + L3
C
C  Check error condition 3.
      IF(MOD(L1MAX-L1MIN+EPS,ONE).GE.EPS+EPS)THEN
         IER=3
         CALL XERMSG('SLATEC','DRC3JJ','L1MAX-L1MIN not integer.',IER,1)
         RETURN
      ENDIF
      IF(L1MIN.LT.L1MAX-EPS)   GO TO 20
      IF(L1MIN.LT.L1MAX+EPS)   GO TO 10
C
C  Check error condition 4.
      IER=4
      CALL XERMSG('SLATEC','DRC3JJ','L1MIN greater than L1MAX.',IER,1)
      RETURN
C
C  This is reached in case that L1 can take only one value,
C  i.e. L1MIN = L1MAX
C
   10 CONTINUE
C     LSCALE = 0
      THRCOF(1) = (-ONE) ** INT(ABS(L2+M2-L3+M3)+EPS) /
     1 SQRT(L1MIN + L2 + L3 + ONE)
      RETURN
C
C  This is reached in case that L1 takes more than one value,
C  i.e. L1MIN < L1MAX.
C
   20 CONTINUE
C     LSCALE = 0
      NFIN = INT(L1MAX-L1MIN+ONE+EPS)
      IF(NDIM-NFIN)  21, 23, 23
C
C  Check error condition 5.
   21 IER = 5
      CALL XERMSG('SLATEC','DRC3JJ','Dimension of result array for '//
     +            '3j coefficients too small.',IER,1)
      RETURN
C
C
C  Starting forward recursion from L1MIN taking NSTEP1 steps
C
   23 L1 = L1MIN
      NEWFAC = 0.0D0
      C1 = 0.0D0
      THRCOF(1) = SRTINY
      SUM1 = (L1+L1+ONE) * TINY
C
C
      LSTEP = 1
   30 LSTEP = LSTEP + 1
      L1 = L1 + ONE
C
C
      OLDFAC = NEWFAC
      A1 = (L1+L2+L3+ONE) * (L1-L2+L3) * (L1+L2-L3) * (-L1+L2+L3+ONE)
      A2 = (L1+M1) * (L1-M1)
      NEWFAC = SQRT(A1*A2)
      IF(L1.LT.ONE+EPS)   GO TO 40
C
C
      DV = - L2*(L2+ONE) * M1 + L3*(L3+ONE) * M1 + L1*(L1-ONE) * (M3-M2)
      DENOM = (L1-ONE) * NEWFAC
C
      IF(LSTEP-2)  32, 32, 31
C
   31 C1OLD = ABS(C1)
   32 C1 = - (L1+L1-ONE) * DV / DENOM
      GO TO 50
C
C  If L1 = 1, (L1-1) has to be factored out of DV, hence
C
   40 C1 = - (L1+L1-ONE) * L1 * (M3-M2) / NEWFAC
C
   50 IF(LSTEP.GT.2)   GO TO 60
C
C
C  If L1 = L1MIN + 1, the third term in the recursion equation vanishes,
C  hence
      X = SRTINY * C1
      THRCOF(2) = X
      SUM1 = SUM1 + TINY * (L1+L1+ONE) * C1*C1
      IF(LSTEP.EQ.NFIN)   GO TO 220
      GO TO 30
C
C
   60 C2 = - L1 * OLDFAC / DENOM
C
C  Recursion to the next 3j coefficient X
C
      X = C1 * THRCOF(LSTEP-1) + C2 * THRCOF(LSTEP-2)
      THRCOF(LSTEP) = X
      SUMFOR = SUM1
      SUM1 = SUM1 + (L1+L1+ONE) * X*X
      IF(LSTEP.EQ.NFIN)   GO TO 100
C
C  See if last unnormalized 3j coefficient exceeds SRHUGE
C
      IF(ABS(X).LT.SRHUGE)   GO TO 80
C
C  This is reached if last 3j coefficient larger than SRHUGE,
C  so that the recursion series THRCOF(1), ... , THRCOF(LSTEP)
C  has to be rescaled to prevent overflow
C
C     LSCALE = LSCALE + 1
      DO 70 I=1,LSTEP
      IF(ABS(THRCOF(I)).LT.SRTINY)   THRCOF(I) = ZERO
   70 THRCOF(I) = THRCOF(I) / SRHUGE
      SUM1 = SUM1 / HUGE
      SUMFOR = SUMFOR / HUGE
      X = X / SRHUGE
C
C  As long as ABS(C1) is decreasing, the recursion proceeds towards
C  increasing 3j values and, hence, is numerically stable.  Once
C  an increase of ABS(C1) is detected, the recursion direction is
C  reversed.
C
   80 IF(C1OLD-ABS(C1))   100, 100, 30
C
C
C  Keep three 3j coefficients around LMATCH for comparison with
C  backward recursion.
C
  100 CONTINUE
C     LMATCH = L1 - 1
      X1 = X
      X2 = THRCOF(LSTEP-1)
      X3 = THRCOF(LSTEP-2)
      NSTEP2 = NFIN - LSTEP + 3
C
C
C
C
C  Starting backward recursion from L1MAX taking NSTEP2 steps, so
C  that forward and backward recursion overlap at three points
C  L1 = LMATCH+1, LMATCH, LMATCH-1.
C
      NFINP1 = NFIN + 1
      NFINP2 = NFIN + 2
      NFINP3 = NFIN + 3
      L1 = L1MAX
      THRCOF(NFIN) = SRTINY
      SUM2 = TINY * (L1+L1+ONE)
C
      L1 = L1 + TWO
      LSTEP = 1
  110 LSTEP = LSTEP + 1
      L1 = L1 - ONE
C
      OLDFAC = NEWFAC
      A1S = (L1+L2+L3)*(L1-L2+L3-ONE)*(L1+L2-L3-ONE)*(-L1+L2+L3+TWO)
      A2S = (L1+M1-ONE) * (L1-M1-ONE)
      NEWFAC = SQRT(A1S*A2S)
C
      DV = - L2*(L2+ONE) * M1 + L3*(L3+ONE) * M1 + L1*(L1-ONE) * (M3-M2)
C
      DENOM = L1 * NEWFAC
      C1 = - (L1+L1-ONE) * DV / DENOM
      IF(LSTEP.GT.2)   GO TO 120
C
C  If L1 = L1MAX + 1, the third term in the recursion formula vanishes
C
      Y = SRTINY * C1
      THRCOF(NFIN-1) = Y
      SUMBAC = SUM2
      SUM2 = SUM2 + TINY * (L1+L1-THREE) * C1*C1
C
      GO TO 110
C
C
  120 C2 = - (L1 - ONE) * OLDFAC / DENOM
C
C  Recursion to the next 3j coefficient Y
C
      Y = C1 * THRCOF(NFINP2-LSTEP) + C2 * THRCOF(NFINP3-LSTEP)
C
      IF(LSTEP.EQ.NSTEP2)   GO TO 200
C
      THRCOF(NFINP1-LSTEP) = Y
      SUMBAC = SUM2
      SUM2 = SUM2 + (L1+L1-THREE) * Y*Y
C
C  See if last unnormalized 3j coefficient exceeds SRHUGE
C
      IF(ABS(Y).LT.SRHUGE)   GO TO 110
C
C  This is reached if last 3j coefficient larger than SRHUGE,
C  so that the recursion series THRCOF(NFIN), ... ,THRCOF(NFIN-LSTEP+1)
C  has to be rescaled to prevent overflow
C
C     LSCALE = LSCALE + 1
      DO 130 I=1,LSTEP
      INDEX = NFIN - I + 1
      IF(ABS(THRCOF(INDEX)).LT.SRTINY)   THRCOF(INDEX) = ZERO
  130 THRCOF(INDEX) = THRCOF(INDEX) / SRHUGE
      SUM2 = SUM2 / HUGE
      SUMBAC = SUMBAC / HUGE
C
C
      GO TO 110
C
C
C  The forward recursion 3j coefficients X1, X2, X3 are to be matched
C  with the corresponding backward recursion values Y1, Y2, Y3.
C
  200 Y3 = Y
      Y2 = THRCOF(NFINP2-LSTEP)
      Y1 = THRCOF(NFINP3-LSTEP)
C
C
C  Determine now RATIO such that YI = RATIO * XI  (I=1,2,3) holds
C  with minimal error.
C
      RATIO = ( X1*Y1 + X2*Y2 + X3*Y3 ) / ( X1*X1 + X2*X2 + X3*X3 )
      NLIM = NFIN - NSTEP2 + 1
C
      IF(ABS(RATIO).LT.ONE)   GO TO 211
C
      DO 210 N=1,NLIM
  210 THRCOF(N) = RATIO * THRCOF(N)
      SUMUNI = RATIO * RATIO * SUMFOR + SUMBAC
      GO TO 230
C
  211 NLIM = NLIM + 1
      RATIO = ONE / RATIO
      DO 212 N=NLIM,NFIN
  212 THRCOF(N) = RATIO * THRCOF(N)
      SUMUNI = SUMFOR + RATIO*RATIO*SUMBAC
      GO TO 230
C
  220 SUMUNI = SUM1
C
C
C  Normalize 3j coefficients
C
  230 CNORM = ONE / SQRT(SUMUNI)
C
C  Sign convention for last 3j coefficient determines overall phase
C
      SIGN1 = SIGN(ONE,THRCOF(NFIN))
      SIGN2 = (-ONE) ** INT(ABS(L2+M2-L3+M3)+EPS)
      IF(SIGN1*SIGN2) 235,235,236
  235 CNORM = - CNORM
C
  236 IF(ABS(CNORM).LT.ONE)   GO TO 250
C
      DO 240 N=1,NFIN
  240 THRCOF(N) = CNORM * THRCOF(N)
      RETURN
C
  250 THRESH = TINY / ABS(CNORM)
      DO 251 N=1,NFIN
      IF(ABS(THRCOF(N)).LT.THRESH)   THRCOF(N) = ZERO
  251 THRCOF(N) = CNORM * THRCOF(N)
C
      RETURN
      END
*DECK DRC3JM
      SUBROUTINE DRC3JM (L1, L2, L3, M1, M2MIN, M2MAX, THRCOF, NDIM,
     +   IER)
C***BEGIN PROLOGUE  DRC3JM
C***PURPOSE  Evaluate the 3j symbol g(M2) = (L1 L2   L3  )
C                                           (M1 M2 -M1-M2)
C            for all allowed values of M2, the other parameters
C            being held fixed.
C***LIBRARY   SLATEC
C***CATEGORY  C19
C***TYPE      DOUBLE PRECISION (RC3JM-S, DRC3JM-D)
C***KEYWORDS  3J COEFFICIENTS, 3J SYMBOLS, CLEBSCH-GORDAN COEFFICIENTS,
C             RACAH COEFFICIENTS, VECTOR ADDITION COEFFICIENTS,
C             WIGNER COEFFICIENTS
C***AUTHOR  Gordon, R. G., Harvard University
C           Schulten, K., Max Planck Institute
C***DESCRIPTION
C
C *Usage:
C
C        DOUBLE PRECISION L1, L2, L3, M1, M2MIN, M2MAX, THRCOF(NDIM)
C        INTEGER NDIM, IER
C
C        CALL DRC3JM (L1, L2, L3, M1, M2MIN, M2MAX, THRCOF, NDIM, IER)
C
C *Arguments:
C
C     L1 :IN      Parameter in 3j symbol.
C
C     L2 :IN      Parameter in 3j symbol.
C
C     L3 :IN      Parameter in 3j symbol.
C
C     M1 :IN      Parameter in 3j symbol.
C
C     M2MIN :OUT  Smallest allowable M2 in 3j symbol.
C
C     M2MAX :OUT  Largest allowable M2 in 3j symbol.
C
C     THRCOF :OUT Set of 3j coefficients generated by evaluating the
C                 3j symbol for all allowed values of M2.  THRCOF(I)
C                 will contain g(M2MIN+I-1), I=1,2,...,M2MAX-M2MIN+1.
C
C     NDIM :IN    Declared length of THRCOF in calling program.
C
C     IER :OUT    Error flag.
C                 IER=0 No errors.
C                 IER=1 Either L1.LT.ABS(M1) or L1+ABS(M1) non-integer.
C                 IER=2 ABS(L1-L2).LE.L3.LE.L1+L2 not satisfied.
C                 IER=3 L1+L2+L3 not an integer.
C                 IER=4 M2MAX-M2MIN not an integer.
C                 IER=5 M2MAX less than M2MIN.
C                 IER=6 NDIM less than M2MAX-M2MIN+1.
C
C *Description:
C
C     Although conventionally the parameters of the vector addition
C  coefficients satisfy certain restrictions, such as being integers
C  or integers plus 1/2, the restrictions imposed on input to this
C  subroutine are somewhat weaker. See, for example, Section 27.9 of
C  Abramowitz and Stegun or Appendix C of Volume II of A. Messiah.
C  The restrictions imposed by this subroutine are
C       1. L1.GE.ABS(M1) and L1+ABS(M1) must be an integer;
C       2. ABS(L1-L2).LE.L3.LE.L1+L2;
C       3. L1+L2+L3 must be an integer;
C       4. M2MAX-M2MIN must be an integer, where
C          M2MAX=MIN(L2,L3-M1) and M2MIN=MAX(-L2,-L3-M1).
C  If the conventional restrictions are satisfied, then these
C  restrictions are met.
C
C     The user should be cautious in using input parameters that do
C  not satisfy the conventional restrictions. For example, the
C  the subroutine produces values of
C       g(M2) = (0.75 1.50   1.75  )
C               (0.25  M2  -0.25-M2)
C  for M2=-1.5,-0.5,0.5,1.5 but none of the symmetry properties of the
C  3j symbol, set forth on page 1056 of Messiah, is satisfied.
C
C     The subroutine generates g(M2MIN), g(M2MIN+1), ..., g(M2MAX)
C  where M2MIN and M2MAX are defined above. The sequence g(M2) is
C  generated by a three-term recurrence algorithm with scaling to
C  control overflow. Both backward and forward recurrence are used to
C  maintain numerical stability. The two recurrence sequences are
C  matched at an interior point and are normalized from the unitary
C  property of 3j coefficients and Wigner's phase convention.
C
C    The algorithm is suited to applications in which large quantum
C  numbers arise, such as in molecular dynamics.
C
C***REFERENCES  1. Abramowitz, M., and Stegun, I. A., Eds., Handbook
C                  of Mathematical Functions with Formulas, Graphs
C                  and Mathematical Tables, NBS Applied Mathematics
C                  Series 55, June 1964 and subsequent printings.
C               2. Messiah, Albert., Quantum Mechanics, Volume II,
C                  North-Holland Publishing Company, 1963.
C               3. Schulten, Klaus and Gordon, Roy G., Exact recursive
C                  evaluation of 3j and 6j coefficients for quantum-
C                  mechanical coupling of angular momenta, J Math
C                  Phys, v 16, no. 10, October 1975, pp. 1961-1970.
C               4. Schulten, Klaus and Gordon, Roy G., Semiclassical
C                  approximations to 3j and 6j coefficients for
C                  quantum-mechanical coupling of angular momenta,
C                  J Math Phys, v 16, no. 10, October 1975,
C                  pp. 1971-1988.
C               5. Schulten, Klaus and Gordon, Roy G., Recursive
C                  evaluation of 3j and 6j coefficients, Computer
C                  Phys Comm, v 11, 1976, pp. 269-278.
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   880515  SLATEC prologue added by G. C. Nielson, NBS; parameters
C           HUGE and TINY revised to depend on D1MACH.
C   891229  Prologue description rewritten; other prologue sections
C           revised; MMATCH (location of match point for recurrences)
C           removed from argument list; argument IER changed to serve
C           only as an error flag (previously, in cases without error,
C           it returned the number of scalings); number of error codes
C           increased to provide more precise error information;
C           program comments revised; SLATEC error handler calls
C           introduced to enable printing of error messages to meet
C           SLATEC standards. These changes were done by D. W. Lozier,
C           M. A. McClain and J. M. Smith of the National Institute
C           of Standards and Technology, formerly NBS.
C   910415  Mixed type expressions eliminated; variable C1 initialized;
C           description of THRCOF expanded. These changes were done by
C           D. W. Lozier.
C***END PROLOGUE  DRC3JM
C
      INTEGER NDIM, IER
      DOUBLE PRECISION L1, L2, L3, M1, M2MIN, M2MAX, THRCOF(NDIM)
C
      INTEGER I, INDEX, LSTEP, N, NFIN, NFINP1, NFINP2, NFINP3, NLIM,
     +        NSTEP2
      DOUBLE PRECISION A1, A1S, C1, C1OLD, C2, CNORM, D1MACH, DV, EPS,
     +                 HUGE, M2, M3, NEWFAC, OLDFAC, ONE, RATIO, SIGN1,
     +                 SIGN2, SRHUGE, SRTINY, SUM1, SUM2, SUMBAC,
     +                 SUMFOR, SUMUNI, THRESH, TINY, TWO, X, X1, X2, X3,
     +                 Y, Y1, Y2, Y3, ZERO
C
      DATA  ZERO,EPS,ONE,TWO /0.0D0,0.01D0,1.0D0,2.0D0/
C
C***FIRST EXECUTABLE STATEMENT  DRC3JM
      IER=0
C  HUGE is the square root of one twentieth of the largest floating
C  point number, approximately.
      HUGE = SQRT(D1MACH(2)/20.0D0)
      SRHUGE = SQRT(HUGE)
      TINY = 1.0D0/HUGE
      SRTINY = 1.0D0/SRHUGE
C
C     MMATCH = ZERO
C
C
C  Check error conditions 1, 2, and 3.
      IF((L1-ABS(M1)+EPS.LT.ZERO).OR.
     +   (MOD(L1+ABS(M1)+EPS,ONE).GE.EPS+EPS))THEN
         IER=1
         CALL XERMSG('SLATEC','DRC3JM','L1-ABS(M1) less than zero or '//
     +      'L1+ABS(M1) not integer.',IER,1)
         RETURN
      ELSEIF((L1+L2-L3.LT.-EPS).OR.(L1-L2+L3.LT.-EPS).OR.
     +   (-L1+L2+L3.LT.-EPS))THEN
         IER=2
         CALL XERMSG('SLATEC','DRC3JM','L1, L2, L3 do not satisfy '//
     +      'triangular condition.',IER,1)
         RETURN
      ELSEIF(MOD(L1+L2+L3+EPS,ONE).GE.EPS+EPS)THEN
         IER=3
         CALL XERMSG('SLATEC','DRC3JM','L1+L2+L3 not integer.',IER,1)
         RETURN
      ENDIF
C
C
C  Limits for M2
      M2MIN = MAX(-L2,-L3-M1)
      M2MAX = MIN(L2,L3-M1)
C
C  Check error condition 4.
      IF(MOD(M2MAX-M2MIN+EPS,ONE).GE.EPS+EPS)THEN
         IER=4
         CALL XERMSG('SLATEC','DRC3JM','M2MAX-M2MIN not integer.',IER,1)
         RETURN
      ENDIF
      IF(M2MIN.LT.M2MAX-EPS)   GO TO 20
      IF(M2MIN.LT.M2MAX+EPS)   GO TO 10
C
C  Check error condition 5.
      IER=5
      CALL XERMSG('SLATEC','DRC3JM','M2MIN greater than M2MAX.',IER,1)
      RETURN
C
C
C  This is reached in case that M2 and M3 can take only one value.
   10 CONTINUE
C     MSCALE = 0
      THRCOF(1) = (-ONE) ** INT(ABS(L2-L3-M1)+EPS) /
     1 SQRT(L1+L2+L3+ONE)
      RETURN
C
C  This is reached in case that M1 and M2 take more than one value.
   20 CONTINUE
C     MSCALE = 0
      NFIN = INT(M2MAX-M2MIN+ONE+EPS)
      IF(NDIM-NFIN)   21, 23, 23
C
C  Check error condition 6.
   21 IER = 6
      CALL XERMSG('SLATEC','DRC3JM','Dimension of result array for '//
     +            '3j coefficients too small.',IER,1)
      RETURN
C
C
C
C  Start of forward recursion from M2 = M2MIN
C
   23 M2 = M2MIN
      THRCOF(1) = SRTINY
      NEWFAC = 0.0D0
      C1 = 0.0D0
      SUM1 = TINY
C
C
      LSTEP = 1
   30 LSTEP = LSTEP + 1
      M2 = M2 + ONE
      M3 = - M1 - M2
C
C
      OLDFAC = NEWFAC
      A1 = (L2-M2+ONE) * (L2+M2) * (L3+M3+ONE) * (L3-M3)
      NEWFAC = SQRT(A1)
C
C
      DV = (L1+L2+L3+ONE)*(L2+L3-L1) - (L2-M2+ONE)*(L3+M3+ONE)
     1                               - (L2+M2-ONE)*(L3-M3-ONE)
C
      IF(LSTEP-2)  32, 32, 31
C
   31 C1OLD = ABS(C1)
   32 C1 = - DV / NEWFAC
C
      IF(LSTEP.GT.2)   GO TO 60
C
C
C  If M2 = M2MIN + 1, the third term in the recursion equation vanishes,
C  hence
C
      X = SRTINY * C1
      THRCOF(2) = X
      SUM1 = SUM1 + TINY * C1*C1
      IF(LSTEP.EQ.NFIN)   GO TO 220
      GO TO 30
C
C
   60 C2 = - OLDFAC / NEWFAC
C
C  Recursion to the next 3j coefficient
      X = C1 * THRCOF(LSTEP-1) + C2 * THRCOF(LSTEP-2)
      THRCOF(LSTEP) = X
      SUMFOR = SUM1
      SUM1 = SUM1 + X*X
      IF(LSTEP.EQ.NFIN)   GO TO 100
C
C  See if last unnormalized 3j coefficient exceeds SRHUGE
C
      IF(ABS(X).LT.SRHUGE)   GO TO 80
C
C  This is reached if last 3j coefficient larger than SRHUGE,
C  so that the recursion series THRCOF(1), ... , THRCOF(LSTEP)
C  has to be rescaled to prevent overflow
C
C     MSCALE = MSCALE + 1
      DO 70 I=1,LSTEP
      IF(ABS(THRCOF(I)).LT.SRTINY)   THRCOF(I) = ZERO
   70 THRCOF(I) = THRCOF(I) / SRHUGE
      SUM1 = SUM1 / HUGE
      SUMFOR = SUMFOR / HUGE
      X = X / SRHUGE
C
C
C  As long as ABS(C1) is decreasing, the recursion proceeds towards
C  increasing 3j values and, hence, is numerically stable.  Once
C  an increase of ABS(C1) is detected, the recursion direction is
C  reversed.
C
   80 IF(C1OLD-ABS(C1))   100, 100, 30
C
C
C  Keep three 3j coefficients around MMATCH for comparison later
C  with backward recursion values.
C
  100 CONTINUE
C     MMATCH = M2 - 1
      NSTEP2 = NFIN - LSTEP + 3
      X1 = X
      X2 = THRCOF(LSTEP-1)
      X3 = THRCOF(LSTEP-2)
C
C  Starting backward recursion from M2MAX taking NSTEP2 steps, so
C  that forwards and backwards recursion overlap at the three points
C  M2 = MMATCH+1, MMATCH, MMATCH-1.
C
      NFINP1 = NFIN + 1
      NFINP2 = NFIN + 2
      NFINP3 = NFIN + 3
      THRCOF(NFIN) = SRTINY
      SUM2 = TINY
C
C
C
      M2 = M2MAX + TWO
      LSTEP = 1
  110 LSTEP = LSTEP + 1
      M2 = M2 - ONE
      M3 = - M1 - M2
      OLDFAC = NEWFAC
      A1S = (L2-M2+TWO) * (L2+M2-ONE) * (L3+M3+TWO) * (L3-M3-ONE)
      NEWFAC = SQRT(A1S)
      DV = (L1+L2+L3+ONE)*(L2+L3-L1) - (L2-M2+ONE)*(L3+M3+ONE)
     1                               - (L2+M2-ONE)*(L3-M3-ONE)
      C1 = - DV / NEWFAC
      IF(LSTEP.GT.2)   GO TO 120
C
C  If M2 = M2MAX + 1 the third term in the recursion equation vanishes
C
      Y = SRTINY * C1
      THRCOF(NFIN-1) = Y
      IF(LSTEP.EQ.NSTEP2)   GO TO 200
      SUMBAC = SUM2
      SUM2 = SUM2 + Y*Y
      GO TO 110
C
  120 C2 = - OLDFAC / NEWFAC
C
C  Recursion to the next 3j coefficient
C
      Y = C1 * THRCOF(NFINP2-LSTEP) + C2 * THRCOF(NFINP3-LSTEP)
C
      IF(LSTEP.EQ.NSTEP2)   GO TO 200
C
      THRCOF(NFINP1-LSTEP) = Y
      SUMBAC = SUM2
      SUM2 = SUM2 + Y*Y
C
C
C  See if last 3j coefficient exceeds SRHUGE
C
      IF(ABS(Y).LT.SRHUGE)   GO TO 110
C
C  This is reached if last 3j coefficient larger than SRHUGE,
C  so that the recursion series THRCOF(NFIN), ... , THRCOF(NFIN-LSTEP+1)
C  has to be rescaled to prevent overflow.
C
C     MSCALE = MSCALE + 1
      DO 111 I=1,LSTEP
      INDEX = NFIN - I + 1
      IF(ABS(THRCOF(INDEX)).LT.SRTINY)
     1  THRCOF(INDEX) = ZERO
  111 THRCOF(INDEX) = THRCOF(INDEX) / SRHUGE
      SUM2 = SUM2 / HUGE
      SUMBAC = SUMBAC / HUGE
C
      GO TO 110
C
C
C
C  The forward recursion 3j coefficients X1, X2, X3 are to be matched
C  with the corresponding backward recursion values Y1, Y2, Y3.
C
  200 Y3 = Y
      Y2 = THRCOF(NFINP2-LSTEP)
      Y1 = THRCOF(NFINP3-LSTEP)
C
C
C  Determine now RATIO such that YI = RATIO * XI  (I=1,2,3) holds
C  with minimal error.
C
      RATIO = ( X1*Y1 + X2*Y2 + X3*Y3 ) / ( X1*X1 + X2*X2 + X3*X3 )
      NLIM = NFIN - NSTEP2 + 1
C
      IF(ABS(RATIO).LT.ONE)   GO TO 211
C
      DO 210 N=1,NLIM
  210 THRCOF(N) = RATIO * THRCOF(N)
      SUMUNI = RATIO * RATIO * SUMFOR + SUMBAC
      GO TO 230
C
  211 NLIM = NLIM + 1
      RATIO = ONE / RATIO
      DO 212 N=NLIM,NFIN
  212 THRCOF(N) = RATIO * THRCOF(N)
      SUMUNI = SUMFOR + RATIO*RATIO*SUMBAC
      GO TO 230
C
  220 SUMUNI = SUM1
C
C
C  Normalize 3j coefficients
C
  230 CNORM = ONE / SQRT((L1+L1+ONE) * SUMUNI)
C
C  Sign convention for last 3j coefficient determines overall phase
C
      SIGN1 = SIGN(ONE,THRCOF(NFIN))
      SIGN2 = (-ONE) ** INT(ABS(L2-L3-M1)+EPS)
      IF(SIGN1*SIGN2)  235,235,236
  235 CNORM = - CNORM
C
  236 IF(ABS(CNORM).LT.ONE)   GO TO 250
C
      DO 240 N=1,NFIN
  240 THRCOF(N) = CNORM * THRCOF(N)
      RETURN
C
  250 THRESH = TINY / ABS(CNORM)
      DO 251 N=1,NFIN
      IF(ABS(THRCOF(N)).LT.THRESH)   THRCOF(N) = ZERO
  251 THRCOF(N) = CNORM * THRCOF(N)
C
C
C
      RETURN
      END
*DECK DRC6J
      SUBROUTINE DRC6J (L2, L3, L4, L5, L6, L1MIN, L1MAX, SIXCOF, NDIM,
     +   IER)
C***BEGIN PROLOGUE  DRC6J
C***PURPOSE  Evaluate the 6j symbol h(L1) = {L1 L2 L3}
C                                           {L4 L5 L6}
C            for all allowed values of L1, the other parameters
C            being held fixed.
C***LIBRARY   SLATEC
C***CATEGORY  C19
C***TYPE      DOUBLE PRECISION (RC6J-S, DRC6J-D)
C***KEYWORDS  6J COEFFICIENTS, 6J SYMBOLS, CLEBSCH-GORDAN COEFFICIENTS,
C             RACAH COEFFICIENTS, VECTOR ADDITION COEFFICIENTS,
C             WIGNER COEFFICIENTS
C***AUTHOR  Gordon, R. G., Harvard University
C           Schulten, K., Max Planck Institute
C***DESCRIPTION
C
C *Usage:
C
C        DOUBLE PRECISION L2, L3, L4, L5, L6, L1MIN, L1MAX, SIXCOF(NDIM)
C        INTEGER NDIM, IER
C
C        CALL DRC6J(L2, L3, L4, L5, L6, L1MIN, L1MAX, SIXCOF, NDIM, IER)
C
C *Arguments:
C
C     L2 :IN      Parameter in 6j symbol.
C
C     L3 :IN      Parameter in 6j symbol.
C
C     L4 :IN      Parameter in 6j symbol.
C
C     L5 :IN      Parameter in 6j symbol.
C
C     L6 :IN      Parameter in 6j symbol.
C
C     L1MIN :OUT  Smallest allowable L1 in 6j symbol.
C
C     L1MAX :OUT  Largest allowable L1 in 6j symbol.
C
C     SIXCOF :OUT Set of 6j coefficients generated by evaluating the
C                 6j symbol for all allowed values of L1.  SIXCOF(I)
C                 will contain h(L1MIN+I-1), I=1,2,...,L1MAX-L1MIN+1.
C
C     NDIM :IN    Declared length of SIXCOF in calling program.
C
C     IER :OUT    Error flag.
C                 IER=0 No errors.
C                 IER=1 L2+L3+L5+L6 or L4+L2+L6 not an integer.
C                 IER=2 L4, L2, L6 triangular condition not satisfied.
C                 IER=3 L4, L5, L3 triangular condition not satisfied.
C                 IER=4 L1MAX-L1MIN not an integer.
C                 IER=5 L1MAX less than L1MIN.
C                 IER=6 NDIM less than L1MAX-L1MIN+1.
C
C *Description:
C
C     The definition and properties of 6j symbols can be found, for
C  example, in Appendix C of Volume II of A. Messiah. Although the
C  parameters of the vector addition coefficients satisfy certain
C  conventional restrictions, the restriction that they be non-negative
C  integers or non-negative integers plus 1/2 is not imposed on input
C  to this subroutine. The restrictions imposed are
C       1. L2+L3+L5+L6 and L2+L4+L6 must be integers;
C       2. ABS(L2-L4).LE.L6.LE.L2+L4 must be satisfied;
C       3. ABS(L4-L5).LE.L3.LE.L4+L5 must be satisfied;
C       4. L1MAX-L1MIN must be a non-negative integer, where
C          L1MAX=MIN(L2+L3,L5+L6) and L1MIN=MAX(ABS(L2-L3),ABS(L5-L6)).
C  If all the conventional restrictions are satisfied, then these
C  restrictions are met. Conversely, if input to this subroutine meets
C  all of these restrictions and the conventional restriction stated
C  above, then all the conventional restrictions are satisfied.
C
C     The user should be cautious in using input parameters that do
C  not satisfy the conventional restrictions. For example, the
C  the subroutine produces values of
C       h(L1) = { L1 2/3  1 }
C               {2/3 2/3 2/3}
C  for L1=1/3 and 4/3 but none of the symmetry properties of the 6j
C  symbol, set forth on pages 1063 and 1064 of Messiah, is satisfied.
C
C     The subroutine generates h(L1MIN), h(L1MIN+1), ..., h(L1MAX)
C  where L1MIN and L1MAX are defined above. The sequence h(L1) is
C  generated by a three-term recurrence algorithm with scaling to
C  control overflow. Both backward and forward recurrence are used to
C  maintain numerical stability. The two recurrence sequences are
C  matched at an interior point and are normalized from the unitary
C  property of 6j coefficients and Wigner's phase convention.
C
C    The algorithm is suited to applications in which large quantum
C  numbers arise, such as in molecular dynamics.
C
C***REFERENCES  1. Messiah, Albert., Quantum Mechanics, Volume II,
C                  North-Holland Publishing Company, 1963.
C               2. Schulten, Klaus and Gordon, Roy G., Exact recursive
C                  evaluation of 3j and 6j coefficients for quantum-
C                  mechanical coupling of angular momenta, J Math
C                  Phys, v 16, no. 10, October 1975, pp. 1961-1970.
C               3. Schulten, Klaus and Gordon, Roy G., Semiclassical
C                  approximations to 3j and 6j coefficients for
C                  quantum-mechanical coupling of angular momenta,
C                  J Math Phys, v 16, no. 10, October 1975,
C                  pp. 1971-1988.
C               4. Schulten, Klaus and Gordon, Roy G., Recursive
C                  evaluation of 3j and 6j coefficients, Computer
C                  Phys Comm, v 11, 1976, pp. 269-278.
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   880515  SLATEC prologue added by G. C. Nielson, NBS; parameters
C           HUGE and TINY revised to depend on D1MACH.
C   891229  Prologue description rewritten; other prologue sections
C           revised; LMATCH (location of match point for recurrences)
C           removed from argument list; argument IER changed to serve
C           only as an error flag (previously, in cases without error,
C           it returned the number of scalings); number of error codes
C           increased to provide more precise error information;
C           program comments revised; SLATEC error handler calls
C           introduced to enable printing of error messages to meet
C           SLATEC standards. These changes were done by D. W. Lozier,
C           M. A. McClain and J. M. Smith of the National Institute
C           of Standards and Technology, formerly NBS.
C   910415  Mixed type expressions eliminated; variable C1 initialized;
C           description of SIXCOF expanded. These changes were done by
C           D. W. Lozier.
C***END PROLOGUE  DRC6J
C
      INTEGER NDIM, IER
      DOUBLE PRECISION L2, L3, L4, L5, L6, L1MIN, L1MAX, SIXCOF(NDIM)
C
      INTEGER I, INDEX, LSTEP, N, NFIN, NFINP1, NFINP2, NFINP3, NLIM,
     +        NSTEP2
      DOUBLE PRECISION A1, A1S, A2, A2S, C1, C1OLD, C2, CNORM, D1MACH,
     +                 DENOM, DV, EPS, HUGE, L1, NEWFAC, OLDFAC, ONE,
     +                 RATIO, SIGN1, SIGN2, SRHUGE, SRTINY, SUM1, SUM2,
     +                 SUMBAC, SUMFOR, SUMUNI, THREE, THRESH, TINY, TWO,
     +                 X, X1, X2, X3, Y, Y1, Y2, Y3, ZERO
C
      DATA  ZERO,EPS,ONE,TWO,THREE /0.0D0,0.01D0,1.0D0,2.0D0,3.0D0/
C
C***FIRST EXECUTABLE STATEMENT  DRC6J
      IER=0
C  HUGE is the square root of one twentieth of the largest floating
C  point number, approximately.
      HUGE = SQRT(D1MACH(2)/20.0D0)
      SRHUGE = SQRT(HUGE)
      TINY = 1.0D0/HUGE
      SRTINY = 1.0D0/SRHUGE
C
C     LMATCH = ZERO
C
C  Check error conditions 1, 2, and 3.
      IF((MOD(L2+L3+L5+L6+EPS,ONE).GE.EPS+EPS).OR.
     +   (MOD(L4+L2+L6+EPS,ONE).GE.EPS+EPS))THEN
         IER=1
         CALL XERMSG('SLATEC','DRC6J','L2+L3+L5+L6 or L4+L2+L6 not '//
     +      'integer.',IER,1)
         RETURN
      ELSEIF((L4+L2-L6.LT.ZERO).OR.(L4-L2+L6.LT.ZERO).OR.
     +   (-L4+L2+L6.LT.ZERO))THEN
         IER=2
         CALL XERMSG('SLATEC','DRC6J','L4, L2, L6 triangular '//
     +      'condition not satisfied.',IER,1)
         RETURN
      ELSEIF((L4-L5+L3.LT.ZERO).OR.(L4+L5-L3.LT.ZERO).OR.
     +   (-L4+L5+L3.LT.ZERO))THEN
         IER=3
         CALL XERMSG('SLATEC','DRC6J','L4, L5, L3 triangular '//
     +      'condition not satisfied.',IER,1)
         RETURN
      ENDIF
C
C  Limits for L1
C
      L1MIN = MAX(ABS(L2-L3),ABS(L5-L6))
      L1MAX = MIN(L2+L3,L5+L6)
C
C  Check error condition 4.
      IF(MOD(L1MAX-L1MIN+EPS,ONE).GE.EPS+EPS)THEN
         IER=4
         CALL XERMSG('SLATEC','DRC6J','L1MAX-L1MIN not integer.',IER,1)
         RETURN
      ENDIF
      IF(L1MIN.LT.L1MAX-EPS)   GO TO 20
      IF(L1MIN.LT.L1MAX+EPS)   GO TO 10
C
C  Check error condition 5.
      IER=5
      CALL XERMSG('SLATEC','DRC6J','L1MIN greater than L1MAX.',IER,1)
      RETURN
C
C
C  This is reached in case that L1 can take only one value
C
   10 CONTINUE
C     LSCALE = 0
      SIXCOF(1) = (-ONE) ** INT(L2+L3+L5+L6+EPS) /
     1            SQRT((L1MIN+L1MIN+ONE)*(L4+L4+ONE))
      RETURN
C
C
C  This is reached in case that L1 can take more than one value.
C
   20 CONTINUE
C     LSCALE = 0
      NFIN = INT(L1MAX-L1MIN+ONE+EPS)
      IF(NDIM-NFIN)   21, 23, 23
C
C  Check error condition 6.
   21 IER = 6
      CALL XERMSG('SLATEC','DRC6J','Dimension of result array for 6j '//
     +            'coefficients too small.',IER,1)
      RETURN
C
C
C  Start of forward recursion
C
   23 L1 = L1MIN
      NEWFAC = 0.0D0
      C1 = 0.0D0
      SIXCOF(1) = SRTINY
      SUM1 = (L1+L1+ONE) * TINY
C
      LSTEP = 1
   30 LSTEP = LSTEP + 1
      L1 = L1 + ONE
C
      OLDFAC = NEWFAC
      A1 = (L1+L2+L3+ONE) * (L1-L2+L3) * (L1+L2-L3) * (-L1+L2+L3+ONE)
      A2 = (L1+L5+L6+ONE) * (L1-L5+L6) * (L1+L5-L6) * (-L1+L5+L6+ONE)
      NEWFAC = SQRT(A1*A2)
C
      IF(L1.LT.ONE+EPS)   GO TO 40
C
      DV = TWO * ( L2*(L2+ONE)*L5*(L5+ONE) + L3*(L3+ONE)*L6*(L6+ONE)
     1           - L1*(L1-ONE)*L4*(L4+ONE) )
     2                   - (L2*(L2+ONE) + L3*(L3+ONE) - L1*(L1-ONE))
     3                   * (L5*(L5+ONE) + L6*(L6+ONE) - L1*(L1-ONE))
C
      DENOM = (L1-ONE) * NEWFAC
C
      IF(LSTEP-2)  32, 32, 31
C
   31 C1OLD = ABS(C1)
   32 C1 = - (L1+L1-ONE) * DV / DENOM
      GO TO 50
C
C  If L1 = 1, (L1 - 1) has to be factored out of DV, hence
C
   40 C1 = - TWO * ( L2*(L2+ONE) + L5*(L5+ONE) - L4*(L4+ONE) )
     1 / NEWFAC
C
   50 IF(LSTEP.GT.2)   GO TO 60
C
C  If L1 = L1MIN + 1, the third term in recursion equation vanishes
C
      X = SRTINY * C1
      SIXCOF(2) = X
      SUM1 = SUM1 + TINY * (L1+L1+ONE) * C1 * C1
C
      IF(LSTEP.EQ.NFIN)   GO TO 220
      GO TO 30
C
C
   60 C2 = - L1 * OLDFAC / DENOM
C
C  Recursion to the next 6j coefficient X
C
      X = C1 * SIXCOF(LSTEP-1) + C2 * SIXCOF(LSTEP-2)
      SIXCOF(LSTEP) = X
C
      SUMFOR = SUM1
      SUM1 = SUM1 + (L1+L1+ONE) * X * X
      IF(LSTEP.EQ.NFIN)   GO TO 100
C
C  See if last unnormalized 6j coefficient exceeds SRHUGE
C
      IF(ABS(X).LT.SRHUGE)   GO TO 80
C
C  This is reached if last 6j coefficient larger than SRHUGE,
C  so that the recursion series SIXCOF(1), ... ,SIXCOF(LSTEP)
C  has to be rescaled to prevent overflow
C
C     LSCALE = LSCALE + 1
      DO 70 I=1,LSTEP
      IF(ABS(SIXCOF(I)).LT.SRTINY)   SIXCOF(I) = ZERO
   70 SIXCOF(I) = SIXCOF(I) / SRHUGE
      SUM1 = SUM1 / HUGE
      SUMFOR = SUMFOR / HUGE
      X = X / SRHUGE
C
C
C  As long as the coefficient ABS(C1) is decreasing, the recursion
C  proceeds towards increasing 6j values and, hence, is numerically
C  stable.  Once an increase of ABS(C1) is detected, the recursion
C  direction is reversed.
C
   80 IF(C1OLD-ABS(C1))   100, 100, 30
C
C
C  Keep three 6j coefficients around LMATCH for comparison later
C  with backward recursion.
C
  100 CONTINUE
C     LMATCH = L1 - 1
      X1 = X
      X2 = SIXCOF(LSTEP-1)
      X3 = SIXCOF(LSTEP-2)
C
C
C
C  Starting backward recursion from L1MAX taking NSTEP2 steps, so
C  that forward and backward recursion overlap at the three points
C  L1 = LMATCH+1, LMATCH, LMATCH-1.
C
      NFINP1 = NFIN + 1
      NFINP2 = NFIN + 2
      NFINP3 = NFIN + 3
      NSTEP2 = NFIN - LSTEP + 3
      L1 = L1MAX
C
      SIXCOF(NFIN) = SRTINY
      SUM2 = (L1+L1+ONE) * TINY
C
C
      L1 = L1 + TWO
      LSTEP = 1
  110 LSTEP = LSTEP + 1
      L1 = L1 - ONE
C
      OLDFAC = NEWFAC
      A1S = (L1+L2+L3)*(L1-L2+L3-ONE)*(L1+L2-L3-ONE)*(-L1+L2+L3+TWO)
      A2S = (L1+L5+L6)*(L1-L5+L6-ONE)*(L1+L5-L6-ONE)*(-L1+L5+L6+TWO)
      NEWFAC = SQRT(A1S*A2S)
C
      DV = TWO * ( L2*(L2+ONE)*L5*(L5+ONE) + L3*(L3+ONE)*L6*(L6+ONE)
     1           - L1*(L1-ONE)*L4*(L4+ONE) )
     2                   - (L2*(L2+ONE) + L3*(L3+ONE) - L1*(L1-ONE))
     3                   * (L5*(L5+ONE) + L6*(L6+ONE) - L1*(L1-ONE))
C
      DENOM = L1 * NEWFAC
      C1 = - (L1+L1-ONE) * DV / DENOM
      IF(LSTEP.GT.2)   GO TO 120
C
C  If L1 = L1MAX + 1 the third term in the recursion equation vanishes
C
      Y = SRTINY * C1
      SIXCOF(NFIN-1) = Y
      IF(LSTEP.EQ.NSTEP2)   GO TO 200
      SUMBAC = SUM2
      SUM2 = SUM2 + (L1+L1-THREE) * C1 * C1 * TINY
      GO TO 110
C
C
  120 C2 = - (L1-ONE) * OLDFAC / DENOM
C
C  Recursion to the next 6j coefficient Y
C
      Y = C1 * SIXCOF(NFINP2-LSTEP) + C2 * SIXCOF(NFINP3-LSTEP)
      IF(LSTEP.EQ.NSTEP2)   GO TO 200
      SIXCOF(NFINP1-LSTEP) = Y
      SUMBAC = SUM2
      SUM2 = SUM2 + (L1+L1-THREE) * Y * Y
C
C  See if last unnormalized 6j coefficient exceeds SRHUGE
C
      IF(ABS(Y).LT.SRHUGE)   GO TO 110
C
C  This is reached if last 6j coefficient larger than SRHUGE,
C  so that the recursion series SIXCOF(NFIN), ... ,SIXCOF(NFIN-LSTEP+1)
C  has to be rescaled to prevent overflow
C
C     LSCALE = LSCALE + 1
      DO 130 I=1,LSTEP
      INDEX = NFIN-I+1
      IF(ABS(SIXCOF(INDEX)).LT.SRTINY)   SIXCOF(INDEX) = ZERO
  130 SIXCOF(INDEX) = SIXCOF(INDEX) / SRHUGE
      SUMBAC = SUMBAC / HUGE
      SUM2 = SUM2 / HUGE
C
      GO TO 110
C
C
C  The forward recursion 6j coefficients X1, X2, X3 are to be matched
C  with the corresponding backward recursion values Y1, Y2, Y3.
C
  200 Y3 = Y
      Y2 = SIXCOF(NFINP2-LSTEP)
      Y1 = SIXCOF(NFINP3-LSTEP)
C
C
C  Determine now RATIO such that YI = RATIO * XI  (I=1,2,3) holds
C  with minimal error.
C
      RATIO = ( X1*Y1 + X2*Y2 + X3*Y3 ) / ( X1*X1 + X2*X2 + X3*X3 )
      NLIM = NFIN - NSTEP2 + 1
C
      IF(ABS(RATIO).LT.ONE)   GO TO 211
C
      DO 210 N=1,NLIM
  210 SIXCOF(N) = RATIO * SIXCOF(N)
      SUMUNI = RATIO * RATIO * SUMFOR + SUMBAC
      GO TO 230
C
  211 NLIM = NLIM + 1
      RATIO = ONE / RATIO
      DO 212 N=NLIM,NFIN
  212 SIXCOF(N) = RATIO * SIXCOF(N)
      SUMUNI = SUMFOR + RATIO*RATIO*SUMBAC
      GO TO 230
C
  220 SUMUNI = SUM1
C
C
C  Normalize 6j coefficients
C
  230 CNORM = ONE / SQRT((L4+L4+ONE)*SUMUNI)
C
C  Sign convention for last 6j coefficient determines overall phase
C
      SIGN1 = SIGN(ONE,SIXCOF(NFIN))
      SIGN2 = (-ONE) ** INT(L2+L3+L5+L6+EPS)
      IF(SIGN1*SIGN2) 235,235,236
  235 CNORM = - CNORM
C
  236 IF(ABS(CNORM).LT.ONE)   GO TO 250
C
      DO 240 N=1,NFIN
  240 SIXCOF(N) = CNORM * SIXCOF(N)
      RETURN
C
  250 THRESH = TINY / ABS(CNORM)
      DO 251 N=1,NFIN
      IF(ABS(SIXCOF(N)).LT.THRESH)   SIXCOF(N) = ZERO
  251 SIXCOF(N) = CNORM * SIXCOF(N)
C
      RETURN
      END
*DECK DRD
      DOUBLE PRECISION FUNCTION DRD (X, Y, Z, IER)
C***BEGIN PROLOGUE  DRD
C***PURPOSE  Compute the incomplete or complete elliptic integral of
C            the 2nd kind. For X and Y nonnegative, X+Y and Z positive,
C            DRD(X,Y,Z) = Integral from zero to infinity of
C                                -1/2     -1/2     -3/2
C                      (3/2)(t+X)    (t+Y)    (t+Z)    dt.
C            If X or Y is zero, the integral is complete.
C***LIBRARY   SLATEC
C***CATEGORY  C14
C***TYPE      DOUBLE PRECISION (RD-S, DRD-D)
C***KEYWORDS  COMPLETE ELLIPTIC INTEGRAL, DUPLICATION THEOREM,
C             INCOMPLETE ELLIPTIC INTEGRAL, INTEGRAL OF THE SECOND KIND,
C             TAYLOR SERIES
C***AUTHOR  Carlson, B. C.
C             Ames Laboratory-DOE
C             Iowa State University
C             Ames, IA  50011
C           Notis, E. M.
C             Ames Laboratory-DOE
C             Iowa State University
C             Ames, IA  50011
C           Pexton, R. L.
C             Lawrence Livermore National Laboratory
C             Livermore, CA  94550
C***DESCRIPTION
C
C   1.     DRD
C          Evaluate an INCOMPLETE (or COMPLETE) ELLIPTIC INTEGRAL
C          of the second kind
C          Standard FORTRAN function routine
C          Double precision version
C          The routine calculates an approximation result to
C          DRD(X,Y,Z) = Integral from zero to infinity of
C                              -1/2     -1/2     -3/2
C                    (3/2)(t+X)    (t+Y)    (t+Z)    dt,
C          where X and Y are nonnegative, X + Y is positive, and Z is
C          positive.  If X or Y is zero, the integral is COMPLETE.
C          The duplication theorem is iterated until the variables are
C          nearly equal, and the function is then expanded in Taylor
C          series to fifth order.
C
C   2.     Calling Sequence
C
C          DRD( X, Y, Z, IER )
C
C          Parameters On Entry
C          Values assigned by the calling routine
C
C          X      - Double precision, nonnegative variable
C
C          Y      - Double precision, nonnegative variable
C
C                   X + Y is positive
C
C          Z      - Double precision, positive variable
C
C
C
C          On Return    (values assigned by the DRD routine)
C
C          DRD     - Double precision approximation to the integral
C
C
C          IER    - Integer
C
C                   IER = 0 Normal and reliable termination of the
C                           routine. It is assumed that the requested
C                           accuracy has been achieved.
C
C                   IER >  0 Abnormal termination of the routine
C
C
C          X, Y, Z are unaltered.
C
C   3.    Error Messages
C
C         Value of IER assigned by the DRD routine
C
C                  Value assigned         Error message printed
C                  IER = 1                MIN(X,Y) .LT. 0.0D0
C                      = 2                MIN(X + Y, Z ) .LT. LOLIM
C                      = 3                MAX(X,Y,Z) .GT. UPLIM
C
C
C   4.     Control Parameters
C
C                  Values of LOLIM, UPLIM, and ERRTOL are set by the
C                  routine.
C
C          LOLIM and UPLIM determine the valid range of X, Y, and Z
C
C          LOLIM  - Lower limit of valid arguments
C
C                    Not less  than 2 / (machine maximum) ** (2/3).
C
C          UPLIM  - Upper limit of valid arguments
C
C                 Not greater than (0.1D0 * ERRTOL / machine
C                 minimum) ** (2/3), where ERRTOL is described below.
C                 In the following table it is assumed that ERRTOL will
C                 never be chosen smaller than 1.0D-5.
C
C
C                    Acceptable values for:   LOLIM      UPLIM
C                    IBM 360/370 SERIES   :   6.0D-51     1.0D+48
C                    CDC 6000/7000 SERIES :   5.0D-215    2.0D+191
C                    UNIVAC 1100 SERIES   :   1.0D-205    2.0D+201
C                    CRAY                 :   3.0D-1644   1.69D+1640
C                    VAX 11 SERIES        :   1.0D-25     4.5D+21
C
C
C          ERRTOL determines the accuracy of the answer
C
C                 The value assigned by the routine will result
C                 in solution precision within 1-2 decimals of
C                 "machine precision".
C
C          ERRTOL    Relative error due to truncation is less than
C                    3 * ERRTOL ** 6 / (1-ERRTOL) ** 3/2.
C
C
C
C        The accuracy of the computed approximation to the integral
C        can be controlled by choosing the value of ERRTOL.
C        Truncation of a Taylor series after terms of fifth order
C        introduces an error less than the amount shown in the
C        second column of the following table for each value of
C        ERRTOL in the first column.  In addition to the truncation
C        error there will be round-off error, but in practice the
C        total error from both sources is usually less than the
C        amount given in the table.
C
C
C
C
C          Sample choices:  ERRTOL   Relative truncation
C                                    error less than
C                           1.0D-3    4.0D-18
C                           3.0D-3    3.0D-15
C                           1.0D-2    4.0D-12
C                           3.0D-2    3.0D-9
C                           1.0D-1    4.0D-6
C
C
C                    Decreasing ERRTOL by a factor of 10 yields six more
C                    decimal digits of accuracy at the expense of one or
C                    two more iterations of the duplication theorem.
C
C *Long Description:
C
C   DRD Special Comments
C
C
C
C          Check: DRD(X,Y,Z) + DRD(Y,Z,X) + DRD(Z,X,Y)
C          = 3 / SQRT(X * Y * Z), where X, Y, and Z are positive.
C
C
C          On Input:
C
C          X, Y, and Z are the variables in the integral DRD(X,Y,Z).
C
C
C          On Output:
C
C
C          X, Y, Z are unaltered.
C
C
C
C          ********************************************************
C
C          WARNING: Changes in the program may improve speed at the
C                   expense of robustness.
C
C
C
C    -------------------------------------------------------------------
C
C
C   Special double precision functions via DRD and DRF
C
C
C                  Legendre form of ELLIPTIC INTEGRAL of 2nd kind
C
C                  -----------------------------------------
C
C
C                                             2         2   2
C                  E(PHI,K) = SIN(PHI) DRF(COS (PHI),1-K SIN (PHI),1) -
C
C                     2      3             2         2   2
C                  -(K/3) SIN (PHI) DRD(COS (PHI),1-K SIN (PHI),1)
C
C
C                                  2        2            2
C                  E(K) = DRF(0,1-K ,1) - (K/3) DRD(0,1-K ,1)
C
C                         PI/2     2   2      1/2
C                       = INT  (1-K SIN (PHI) )  D PHI
C                          0
C
C                  Bulirsch form of ELLIPTIC INTEGRAL of 2nd kind
C
C                  -----------------------------------------
C
C                                               2 2    2
C                  EL2(X,KC,A,B) = AX DRF(1,1+KC X ,1+X ) +
C
C                                              3          2 2    2
C                                 +(1/3)(B-A) X DRD(1,1+KC X ,1+X )
C
C
C
C
C                  Legendre form of alternative ELLIPTIC INTEGRAL
C                  of 2nd kind
C
C                  -----------------------------------------
C
C
C
C                            Q     2       2   2  -1/2
C                  D(Q,K) = INT SIN P  (1-K SIN P)     DP
C                            0
C
C
C
C                                     3          2     2   2
C                  D(Q,K) = (1/3) (SIN Q) DRD(COS Q,1-K SIN Q,1)
C
C
C
C
C                  Lemniscate constant  B
C
C                  -----------------------------------------
C
C
C
C
C                       1    2    4 -1/2
C                  B = INT  S (1-S )    DS
C                       0
C
C
C                  B = (1/3) DRD (0,2,1)
C
C
C                  Heuman's LAMBDA function
C
C                  -----------------------------------------
C
C
C
C                  (PI/2) LAMBDA0(A,B) =
C
C                                    2                2
C                 = SIN(B) (DRF(0,COS (A),1)-(1/3) SIN (A) *
C
C                            2               2         2       2
C                  *DRD(0,COS (A),1)) DRF(COS (B),1-COS (A) SIN (B),1)
C
C                            2       3             2
C                  -(1/3) COS (A) SIN (B) DRF(0,COS (A),1) *
C
C                           2         2       2
C                   *DRD(COS (B),1-COS (A) SIN (B),1)
C
C
C
C                  Jacobi ZETA function
C
C                  -----------------------------------------
C
C                             2                 2       2   2
C                  Z(B,K) = (K/3) SIN(B) DRF(COS (B),1-K SIN (B),1)
C
C
C                                       2             2
C                             *DRD(0,1-K ,1)/DRF(0,1-K ,1)
C
C                               2       3           2       2   2
C                            -(K /3) SIN (B) DRD(COS (B),1-K SIN (B),1)
C
C
C ---------------------------------------------------------------------
C
C***REFERENCES  B. C. Carlson and E. M. Notis, Algorithms for incomplete
C                 elliptic integrals, ACM Transactions on Mathematical
C                 Software 7, 3 (September 1981), pp. 398-403.
C               B. C. Carlson, Computing elliptic integrals by
C                 duplication, Numerische Mathematik 33, (1979),
C                 pp. 1-16.
C               B. C. Carlson, Elliptic integrals of the first kind,
C                 SIAM Journal of Mathematical Analysis 8, (1977),
C                 pp. 231-242.
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900510  Modify calls to XERMSG to put in standard form.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DRD
      CHARACTER*16 XERN3, XERN4, XERN5, XERN6
      INTEGER IER
      DOUBLE PRECISION LOLIM, TUPLIM, UPLIM, EPSLON, ERRTOL, D1MACH
      DOUBLE PRECISION C1, C2, C3, C4, EA, EB, EC, ED, EF, LAMDA
      DOUBLE PRECISION MU, POWER4, SIGMA, S1, S2, X, XN, XNDEV
      DOUBLE PRECISION XNROOT, Y, YN, YNDEV, YNROOT, Z, ZN, ZNDEV,
     * ZNROOT
      LOGICAL FIRST
      SAVE ERRTOL, LOLIM, UPLIM, C1, C2, C3, C4, FIRST
      DATA FIRST /.TRUE./
C
C***FIRST EXECUTABLE STATEMENT  DRD
      IF (FIRST) THEN
         ERRTOL = (D1MACH(3)/3.0D0)**(1.0D0/6.0D0)
         LOLIM  = 2.0D0/(D1MACH(2))**(2.0D0/3.0D0)
         TUPLIM = D1MACH(1)**(1.0E0/3.0E0)
         TUPLIM = (0.10D0*ERRTOL)**(1.0E0/3.0E0)/TUPLIM
         UPLIM  = TUPLIM**2.0D0
C
         C1 = 3.0D0/14.0D0
         C2 = 1.0D0/6.0D0
         C3 = 9.0D0/22.0D0
         C4 = 3.0D0/26.0D0
      ENDIF
      FIRST = .FALSE.
C
C         CALL ERROR HANDLER IF NECESSARY.
C
      DRD = 0.0D0
      IF( MIN(X,Y).LT.0.0D0) THEN
         IER = 1
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         CALL XERMSG ('SLATEC', 'DRD',
     *      'MIN(X,Y).LT.0 WHERE X = ' // XERN3 // ' AND Y = ' //
     *      XERN4, 1, 1)
         RETURN
      ENDIF
C
      IF (MAX(X,Y,Z).GT.UPLIM) THEN
         IER = 3
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') Z
         WRITE (XERN6, '(1PE15.6)') UPLIM
         CALL XERMSG ('SLATEC', 'DRD',
     *      'MAX(X,Y,Z).GT.UPLIM WHERE X = ' // XERN3 // ' Y = ' //
     *      XERN4 // ' Z = ' // XERN5 // ' AND UPLIM = ' // XERN6,
     *      3, 1)
         RETURN
      ENDIF
C
      IF (MIN(X+Y,Z).LT.LOLIM) THEN
         IER = 2
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') Z
         WRITE (XERN6, '(1PE15.6)') LOLIM
         CALL XERMSG ('SLATEC', 'DRD',
     *      'MIN(X+Y,Z).LT.LOLIM WHERE X = ' // XERN3 // ' Y = ' //
     *      XERN4 // ' Z = ' // XERN5 // ' AND LOLIM = ' // XERN6,
     *      2, 1)
         RETURN
      ENDIF
C
      IER = 0
      XN = X
      YN = Y
      ZN = Z
      SIGMA = 0.0D0
      POWER4 = 1.0D0
C
   30 MU = (XN+YN+3.0D0*ZN)*0.20D0
      XNDEV = (MU-XN)/MU
      YNDEV = (MU-YN)/MU
      ZNDEV = (MU-ZN)/MU
      EPSLON = MAX(ABS(XNDEV), ABS(YNDEV), ABS(ZNDEV))
      IF (EPSLON.LT.ERRTOL) GO TO 40
      XNROOT = SQRT(XN)
      YNROOT = SQRT(YN)
      ZNROOT = SQRT(ZN)
      LAMDA = XNROOT*(YNROOT+ZNROOT) + YNROOT*ZNROOT
      SIGMA = SIGMA + POWER4/(ZNROOT*(ZN+LAMDA))
      POWER4 = POWER4*0.250D0
      XN = (XN+LAMDA)*0.250D0
      YN = (YN+LAMDA)*0.250D0
      ZN = (ZN+LAMDA)*0.250D0
      GO TO 30
C
   40 EA = XNDEV*YNDEV
      EB = ZNDEV*ZNDEV
      EC = EA - EB
      ED = EA - 6.0D0*EB
      EF = ED + EC + EC
      S1 = ED*(-C1+0.250D0*C3*ED-1.50D0*C4*ZNDEV*EF)
      S2 = ZNDEV*(C2*EF+ZNDEV*(-C3*EC+ZNDEV*C4*EA))
      DRD = 3.0D0*SIGMA + POWER4*(1.0D0+S1+S2)/(MU*SQRT(MU))
C
      RETURN
      END
*DECK DREADP
      SUBROUTINE DREADP (IPAGE, LIST, RLIST, LPAGE, IREC)
C***BEGIN PROLOGUE  DREADP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DSPLP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SREADP-S, DREADP-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     READ RECORD NUMBER IRECN, OF LENGTH LPG, FROM UNIT
C     NUMBER IPAGEF INTO THE STORAGE ARRAY, LIST(*).
C     READ RECORD  IRECN+1, OF LENGTH LPG, FROM UNIT NUMBER
C     IPAGEF INTO THE STORAGE ARRAY RLIST(*).
C
C     TO CONVERT THIS PROGRAM UNIT TO DOUBLE PRECISION CHANGE
C     /REAL (12 BLANKS)/ TO /DOUBLE PRECISION/.
C
C***SEE ALSO  DSPLP
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890605  Corrected references to XERRWV.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  DREADP
      INTEGER LIST(*)
      DOUBLE PRECISION RLIST(*)
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  DREADP
      IPAGEF=IPAGE
      LPG   =LPAGE
      IRECN=IREC
      READ(IPAGEF,REC=IRECN,ERR=100)(LIST(I),I=1,LPG)
      READ(IPAGEF,REC=IRECN+1,ERR=100)(RLIST(I),I=1,LPG)
      RETURN
C
  100 WRITE (XERN1, '(I8)') LPG
      WRITE (XERN2, '(I8)') IRECN
      CALL XERMSG ('SLATEC', 'DREADP', 'IN DSPLP, LPG = ' // XERN1 //
     *   ' IRECN = ' // XERN2, 100, 1)
      RETURN
      END
*DECK DREORT
      SUBROUTINE DREORT (NCOMP, Y, YP, YHP, NIV, W, S, P, IP, STOWA,
     +   IFLAG)
C***BEGIN PROLOGUE  DREORT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBVSUP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (REORT-S, DREORT-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C **********************************************************************
C   INPUT
C *********
C     Y, YP and YHP = homogeneous solution matrix and particular
C                     solution vector to be orthonormalized.
C     IFLAG = 1 --  store YHP into Y and YP, test for
C                   reorthonormalization, orthonormalize if needed,
C                   save restart data.
C             2 --  store YHP into Y and YP, reorthonormalization,
C                   no restarts.
C                   (preset orthonormalization mode)
C             3 --  store YHP into Y and YP, reorthonormalization
C                   (when INHOMO=3 and X=XEND).
C **********************************************************************
C   OUTPUT
C *********
C     Y, YP = orthonormalized solutions.
C     NIV = number of independent vectors returned from DMGSBV.
C     IFLAG = 0 --  reorthonormalization was performed.
C            10 --  solution process must be restarted at the last
C                   orthonormalization point.
C            30 --  solutions are linearly dependent, problem must
C                   be restarted from the beginning.
C     W, P, IP = orthonormalization information.
C **********************************************************************
C
C***SEE ALSO  DBVSUP
C***ROUTINES CALLED  DDOT, DMGSBV, DSTOR1, DSTWAY
C***COMMON BLOCKS    DML15T, DML18J, DML8SZ
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DREORT
C
      DOUBLE PRECISION DDOT
      INTEGER ICOCO, IFLAG, IGOFX, IJK, INDPVT, INFO, INHOMO, INTEG,
     1     IP(*), ISTKOP, IVP, J, K, KK, KNSWOT, KOP, L, LOTJP, MFLAG,
     2     MNSWOT, MXNON, NCOMP, NCOMPD, NDISK, NEQ, NEQIVP, NFC,
     3     NFCC, NFCP, NIC, NIV, NOPG, NPS, NSWOT, NTAPE, NTP, NUMORT,
     4     NXPTS
      DOUBLE PRECISION AE, C, DND, DNDT, DX, P(*), PWCND, PX, RE, S(*),
     1     SRP, STOWA(*), TND, TOL, VNORM, W(*), WCND, X, XBEG, XEND,
     2     XOP, XOT, XSAV, Y(NCOMP,*), YHP(NCOMP,*), YP(*), YPNM
C
C     ******************************************************************
C
      COMMON /DML8SZ/ C,XSAV,IGOFX,INHOMO,IVP,NCOMPD,NFC
      COMMON /DML15T/ PX,PWCND,TND,X,XBEG,XEND,XOT,XOP,INFO(15),ISTKOP,
     1                KNSWOT,KOP,LOTJP,MNSWOT,NSWOT
      COMMON /DML18J/ AE,RE,TOL,NXPTS,NIC,NOPG,MXNON,NDISK,NTAPE,NEQ,
     1                INDPVT,INTEG,NPS,NTP,NEQIVP,NUMORT,NFCC,
     2                ICOCO
C
C **********************************************************************
C     BEGIN BLOCK PERMITTING ...EXITS TO 210
C        BEGIN BLOCK PERMITTING ...EXITS TO 10
C***FIRST EXECUTABLE STATEMENT  DREORT
            NFCP = NFC + 1
C
C           CHECK TO SEE IF ORTHONORMALIZATION TEST IS TO BE PERFORMED
C
C        ...EXIT
            IF (IFLAG .NE. 1) GO TO 10
            KNSWOT = KNSWOT + 1
C        ...EXIT
            IF (KNSWOT .GE. NSWOT) GO TO 10
C     ......EXIT
            IF ((XEND - X)*(X - XOT) .LT. 0.0D0) GO TO 210
   10    CONTINUE
         CALL DSTOR1(Y,YHP,YP,YHP(1,NFCP),1,0,0)
C
C        ***************************************************************
C
C        ORTHOGONALIZE THE HOMOGENEOUS SOLUTIONS Y
C        AND PARTICULAR SOLUTION YP.
C
         NIV = NFC
         CALL DMGSBV(NCOMP,NFC,Y,NCOMP,NIV,MFLAG,S,P,IP,INHOMO,YP,W,
     1               WCND)
C
C           ************************************************************
C
C        CHECK FOR LINEAR DEPENDENCE OF THE SOLUTIONS.
C
         IF (MFLAG .EQ. 0) GO TO 50
C           BEGIN BLOCK PERMITTING ...EXITS TO 40
               IF (IFLAG .EQ. 2) GO TO 30
                  IF (NSWOT .LE. 1 .AND. LOTJP .NE. 0) GO TO 20
C
C                    RETRIEVE DATA FOR A RESTART AT LAST
C                    ORTHONORMALIZATION POINT
C
                     CALL DSTWAY(Y,YP,YHP,1,STOWA)
                     LOTJP = 1
                     NSWOT = 1
                     KNSWOT = 0
                     MNSWOT = MNSWOT/2
                     TND = TND + 1.0D0
                     IFLAG = 10
C           .........EXIT
                     GO TO 40
   20             CONTINUE
   30          CONTINUE
               IFLAG = 30
   40       CONTINUE
         GO TO 200
   50    CONTINUE
C           BEGIN BLOCK PERMITTING ...EXITS TO 190
C              BEGIN BLOCK PERMITTING ...EXITS TO 110
C
C                 ******************************************************
C
C              ...EXIT
                  IF (IFLAG .NE. 1) GO TO 110
C
C                 TEST FOR ORTHONORMALIZATION
C
C              ...EXIT
                  IF (WCND .LT. 50.0D0*TOL) GO TO 110
                  DO 60 IJK = 1, NFCP
C              ......EXIT
                     IF (S(IJK) .GT. 1.0D20) GO TO 110
   60             CONTINUE
C
C                 USE LINEAR EXTRAPOLATION ON LOGARITHMIC VALUES OF THE
C                 NORM DECREMENTS TO DETERMINE NEXT ORTHONORMALIZATION
C                 CHECKPOINT.  OTHER CONTROLS ON THE NUMBER OF STEPS TO
C                 THE NEXT CHECKPOINT ARE ADDED FOR SAFETY PURPOSES.
C
                  NSWOT = KNSWOT
                  KNSWOT = 0
                  LOTJP = 0
                  WCND = LOG10(WCND)
                  IF (WCND .GT. TND + 3.0D0) NSWOT = 2*NSWOT
                  IF (WCND .LT. PWCND) GO TO 70
                     XOT = XEND
                     NSWOT = MIN(MNSWOT,NSWOT)
                     PWCND = WCND
                     PX = X
                  GO TO 100
   70             CONTINUE
                     DX = X - PX
                     DND = PWCND - WCND
                     IF (DND .GE. 4) NSWOT = NSWOT/2
                     DNDT = WCND - TND
                     IF (ABS(DX*DNDT) .LE. DND*ABS(XEND-X)) GO TO 80
                        XOT = XEND
                        NSWOT = MIN(MNSWOT,NSWOT)
                        PWCND = WCND
                        PX = X
                     GO TO 90
   80                CONTINUE
                        XOT = X + DX*DNDT/DND
                        NSWOT = MIN(MNSWOT,NSWOT)
                        PWCND = WCND
                        PX = X
   90                CONTINUE
  100             CONTINUE
C           ......EXIT
                  GO TO 190
  110          CONTINUE
C
C              *********************************************************
C
C              ORTHONORMALIZATION NECESSARY SO WE NORMALIZE THE
C              HOMOGENEOUS SOLUTION VECTORS AND CHANGE W ACCORDINGLY.
C
               NSWOT = 1
               KNSWOT = 0
               LOTJP = 1
               KK = 1
               L = 1
               DO 150 K = 1, NFCC
C                 BEGIN BLOCK PERMITTING ...EXITS TO 140
                     SRP = SQRT(P(KK))
                     IF (INHOMO .EQ. 1) W(K) = SRP*W(K)
                     VNORM = 1.0D0/SRP
                     P(KK) = VNORM
                     KK = KK + NFCC + 1 - K
                     IF (NFC .EQ. NFCC) GO TO 120
C                 ......EXIT
                        IF (L .NE. K/2) GO TO 140
  120                CONTINUE
                     DO 130 J = 1, NCOMP
                        Y(J,L) = Y(J,L)*VNORM
  130                CONTINUE
                     L = L + 1
  140             CONTINUE
  150          CONTINUE
C
               IF (INHOMO .NE. 1 .OR. NPS .EQ. 1) GO TO 180
C
C                 NORMALIZE THE PARTICULAR SOLUTION
C
                  YPNM = DDOT(NCOMP,YP,1,YP,1)
                  IF (YPNM .EQ. 0.0D0) YPNM = 1.0D0
                  YPNM = SQRT(YPNM)
                  S(NFCP) = YPNM
                  DO 160 J = 1, NCOMP
                     YP(J) = YP(J)/YPNM
  160             CONTINUE
                  DO 170 J = 1, NFCC
                     W(J) = C*W(J)
  170             CONTINUE
  180          CONTINUE
C
               IF (IFLAG .EQ. 1) CALL DSTWAY(Y,YP,YHP,0,STOWA)
               IFLAG = 0
  190       CONTINUE
  200    CONTINUE
  210 CONTINUE
      RETURN
      END
*DECK DRF
      DOUBLE PRECISION FUNCTION DRF (X, Y, Z, IER)
C***BEGIN PROLOGUE  DRF
C***PURPOSE  Compute the incomplete or complete elliptic integral of the
C            1st kind.  For X, Y, and Z non-negative and at most one of
C            them zero, RF(X,Y,Z) = Integral from zero to infinity of
C                                -1/2     -1/2     -1/2
C                      (1/2)(t+X)    (t+Y)    (t+Z)    dt.
C            If X, Y or Z is zero, the integral is complete.
C***LIBRARY   SLATEC
C***CATEGORY  C14
C***TYPE      DOUBLE PRECISION (RF-S, DRF-D)
C***KEYWORDS  COMPLETE ELLIPTIC INTEGRAL, DUPLICATION THEOREM,
C             INCOMPLETE ELLIPTIC INTEGRAL, INTEGRAL OF THE FIRST KIND,
C             TAYLOR SERIES
C***AUTHOR  Carlson, B. C.
C             Ames Laboratory-DOE
C             Iowa State University
C             Ames, IA  50011
C           Notis, E. M.
C             Ames Laboratory-DOE
C             Iowa State University
C             Ames, IA  50011
C           Pexton, R. L.
C             Lawrence Livermore National Laboratory
C             Livermore, CA  94550
C***DESCRIPTION
C
C   1.     DRF
C          Evaluate an INCOMPLETE (or COMPLETE) ELLIPTIC INTEGRAL
C          of the first kind
C          Standard FORTRAN function routine
C          Double precision version
C          The routine calculates an approximation result to
C          DRF(X,Y,Z) = Integral from zero to infinity of
C
C                               -1/2     -1/2     -1/2
C                     (1/2)(t+X)    (t+Y)    (t+Z)    dt,
C
C          where X, Y, and Z are nonnegative and at most one of them
C          is zero.  If one of them  is zero, the integral is COMPLETE.
C          The duplication theorem is iterated until the variables are
C          nearly equal, and the function is then expanded in Taylor
C          series to fifth order.
C
C   2.     Calling sequence
C          DRF( X, Y, Z, IER )
C
C          Parameters On entry
C          Values assigned by the calling routine
C
C          X      - Double precision, nonnegative variable
C
C          Y      - Double precision, nonnegative variable
C
C          Z      - Double precision, nonnegative variable
C
C
C
C          On Return    (values assigned by the DRF routine)
C
C          DRF     - Double precision approximation to the integral
C
C          IER    - Integer
C
C                   IER = 0 Normal and reliable termination of the
C                           routine. It is assumed that the requested
C                           accuracy has been achieved.
C
C                   IER >  0 Abnormal termination of the routine
C
C          X, Y, Z are unaltered.
C
C
C   3.    Error Messages
C
C
C         Value of IER assigned by the DRF routine
C
C                  Value assigned         Error Message Printed
C                  IER = 1                MIN(X,Y,Z) .LT. 0.0D0
C                      = 2                MIN(X+Y,X+Z,Y+Z) .LT. LOLIM
C                      = 3                MAX(X,Y,Z) .GT. UPLIM
C
C
C
C   4.     Control Parameters
C
C                  Values of LOLIM, UPLIM, and ERRTOL are set by the
C                  routine.
C
C          LOLIM and UPLIM determine the valid range of X, Y and Z
C
C          LOLIM  - Lower limit of valid arguments
C
C                   Not less than 5 * (machine minimum).
C
C          UPLIM  - Upper limit of valid arguments
C
C                   Not greater than (machine maximum) / 5.
C
C
C                     Acceptable values for:   LOLIM      UPLIM
C                     IBM 360/370 SERIES   :   3.0D-78     1.0D+75
C                     CDC 6000/7000 SERIES :   1.0D-292    1.0D+321
C                     UNIVAC 1100 SERIES   :   1.0D-307    1.0D+307
C                     CRAY                 :   2.3D-2466   1.09D+2465
C                     VAX 11 SERIES        :   1.5D-38     3.0D+37
C
C
C
C          ERRTOL determines the accuracy of the answer
C
C                 The value assigned by the routine will result
C                 in solution precision within 1-2 decimals of
C                 "machine precision".
C
C
C
C          ERRTOL - Relative error due to truncation is less than
C                   ERRTOL ** 6 / (4 * (1-ERRTOL)  .
C
C
C
C        The accuracy of the computed approximation to the integral
C        can be controlled by choosing the value of ERRTOL.
C        Truncation of a Taylor series after terms of fifth order
C        introduces an error less than the amount shown in the
C        second column of the following table for each value of
C        ERRTOL in the first column.  In addition to the truncation
C        error there will be round-off error, but in practice the
C        total error from both sources is usually less than the
C        amount given in the table.
C
C
C
C
C
C          Sample choices:  ERRTOL   Relative Truncation
C                                    error less than
C                           1.0D-3    3.0D-19
C                           3.0D-3    2.0D-16
C                           1.0D-2    3.0D-13
C                           3.0D-2    2.0D-10
C                           1.0D-1    3.0D-7
C
C
C                    Decreasing ERRTOL by a factor of 10 yields six more
C                    decimal digits of accuracy at the expense of one or
C                    two more iterations of the duplication theorem.
C
C *Long Description:
C
C   DRF Special Comments
C
C
C
C          Check by addition theorem: DRF(X,X+Z,X+W) + DRF(Y,Y+Z,Y+W)
C          = DRF(0,Z,W), where X,Y,Z,W are positive and X * Y = Z * W.
C
C
C          On Input:
C
C          X, Y, and Z are the variables in the integral DRF(X,Y,Z).
C
C
C          On Output:
C
C
C          X, Y, Z are unaltered.
C
C
C
C          ********************************************************
C
C          WARNING: Changes in the program may improve speed at the
C                   expense of robustness.
C
C
C
C   Special double precision functions via DRF
C
C
C
C
C                  Legendre form of ELLIPTIC INTEGRAL of 1st kind
C
C                  -----------------------------------------
C
C
C
C                                             2         2   2
C                  F(PHI,K) = SIN(PHI) DRF(COS (PHI),1-K SIN (PHI),1)
C
C
C                                  2
C                  K(K) = DRF(0,1-K ,1)
C
C
C                         PI/2     2   2      -1/2
C                       = INT  (1-K SIN (PHI) )   D PHI
C                          0
C
C
C
C                  Bulirsch form of ELLIPTIC INTEGRAL of 1st kind
C
C                  -----------------------------------------
C
C
C                                          2 2    2
C                  EL1(X,KC) = X DRF(1,1+KC X ,1+X )
C
C
C                  Lemniscate constant A
C
C                  -----------------------------------------
C
C
C                       1      4 -1/2
C                  A = INT (1-S )    DS = DRF(0,1,2) = DRF(0,2,1)
C                       0
C
C
C
C    -------------------------------------------------------------------
C
C***REFERENCES  B. C. Carlson and E. M. Notis, Algorithms for incomplete
C                 elliptic integrals, ACM Transactions on Mathematical
C                 Software 7, 3 (September 1981), pp. 398-403.
C               B. C. Carlson, Computing elliptic integrals by
C                 duplication, Numerische Mathematik 33, (1979),
C                 pp. 1-16.
C               B. C. Carlson, Elliptic integrals of the first kind,
C                 SIAM Journal of Mathematical Analysis 8, (1977),
C                 pp. 231-242.
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891009  Removed unreferenced statement labels.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900510  Changed calls to XERMSG to standard form, and some
C           editorial changes.  (RWC))
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DRF
      CHARACTER*16 XERN3, XERN4, XERN5, XERN6
      INTEGER IER
      DOUBLE PRECISION LOLIM, UPLIM, EPSLON, ERRTOL, D1MACH
      DOUBLE PRECISION C1, C2, C3, E2, E3, LAMDA
      DOUBLE PRECISION MU, S, X, XN, XNDEV
      DOUBLE PRECISION XNROOT, Y, YN, YNDEV, YNROOT, Z, ZN, ZNDEV,
     * ZNROOT
      LOGICAL FIRST
      SAVE ERRTOL,LOLIM,UPLIM,C1,C2,C3,FIRST
      DATA FIRST /.TRUE./
C
C***FIRST EXECUTABLE STATEMENT  DRF
C
      IF (FIRST) THEN
         ERRTOL = (4.0D0*D1MACH(3))**(1.0D0/6.0D0)
         LOLIM  = 5.0D0 * D1MACH(1)
         UPLIM  = D1MACH(2)/5.0D0
C
         C1 = 1.0D0/24.0D0
         C2 = 3.0D0/44.0D0
         C3 = 1.0D0/14.0D0
      ENDIF
      FIRST = .FALSE.
C
C         CALL ERROR HANDLER IF NECESSARY.
C
      DRF = 0.0D0
      IF (MIN(X,Y,Z).LT.0.0D0) THEN
         IER = 1
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') Z
         CALL XERMSG ('SLATEC', 'DRF',
     *      'MIN(X,Y,Z).LT.0 WHERE X = ' // XERN3 // ' Y = ' // XERN4 //
     *      ' AND Z = ' // XERN5, 1, 1)
         RETURN
      ENDIF
C
      IF (MAX(X,Y,Z).GT.UPLIM) THEN
         IER = 3
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') Z
         WRITE (XERN6, '(1PE15.6)') UPLIM
         CALL XERMSG ('SLATEC', 'DRF',
     *      'MAX(X,Y,Z).GT.UPLIM WHERE X = '  // XERN3 // ' Y = ' //
     *      XERN4 // ' Z = ' // XERN5 // ' AND UPLIM = ' // XERN6, 3, 1)
         RETURN
      ENDIF
C
      IF (MIN(X+Y,X+Z,Y+Z).LT.LOLIM) THEN
         IER = 2
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') Z
         WRITE (XERN6, '(1PE15.6)') LOLIM
         CALL XERMSG ('SLATEC', 'DRF',
     *      'MIN(X+Y,X+Z,Y+Z).LT.LOLIM WHERE X = ' // XERN3 //
     *      ' Y = ' // XERN4 // ' Z = ' // XERN5 // ' AND LOLIM = ' //
     *      XERN6, 2, 1)
         RETURN
      ENDIF
C
      IER = 0
      XN = X
      YN = Y
      ZN = Z
C
   30 MU = (XN+YN+ZN)/3.0D0
      XNDEV = 2.0D0 - (MU+XN)/MU
      YNDEV = 2.0D0 - (MU+YN)/MU
      ZNDEV = 2.0D0 - (MU+ZN)/MU
      EPSLON = MAX(ABS(XNDEV),ABS(YNDEV),ABS(ZNDEV))
      IF (EPSLON.LT.ERRTOL) GO TO 40
      XNROOT = SQRT(XN)
      YNROOT = SQRT(YN)
      ZNROOT = SQRT(ZN)
      LAMDA = XNROOT*(YNROOT+ZNROOT) + YNROOT*ZNROOT
      XN = (XN+LAMDA)*0.250D0
      YN = (YN+LAMDA)*0.250D0
      ZN = (ZN+LAMDA)*0.250D0
      GO TO 30
C
   40 E2 = XNDEV*YNDEV - ZNDEV*ZNDEV
      E3 = XNDEV*YNDEV*ZNDEV
      S  = 1.0D0 + (C1*E2-0.10D0-C2*E3)*E2 + C3*E3
      DRF = S/SQRT(MU)
C
      RETURN
      END
*DECK DRJ
      DOUBLE PRECISION FUNCTION DRJ (X, Y, Z, P, IER)
C***BEGIN PROLOGUE  DRJ
C***PURPOSE  Compute the incomplete or complete (X or Y or Z is zero)
C            elliptic integral of the 3rd kind.  For X, Y, and Z non-
C            negative, at most one of them zero, and P positive,
C             RJ(X,Y,Z,P) = Integral from zero to infinity of
C                              -1/2     -1/2     -1/2     -1
C                    (3/2)(t+X)    (t+Y)    (t+Z)    (t+P)  dt.
C***LIBRARY   SLATEC
C***CATEGORY  C14
C***TYPE      DOUBLE PRECISION (RJ-S, DRJ-D)
C***KEYWORDS  COMPLETE ELLIPTIC INTEGRAL, DUPLICATION THEOREM,
C             INCOMPLETE ELLIPTIC INTEGRAL, INTEGRAL OF THE THIRD KIND,
C             TAYLOR SERIES
C***AUTHOR  Carlson, B. C.
C             Ames Laboratory-DOE
C             Iowa State University
C             Ames, IA  50011
C           Notis, E. M.
C             Ames Laboratory-DOE
C             Iowa State University
C             Ames, IA  50011
C           Pexton, R. L.
C             Lawrence Livermore National Laboratory
C             Livermore, CA  94550
C***DESCRIPTION
C
C   1.     DRJ
C          Standard FORTRAN function routine
C          Double precision version
C          The routine calculates an approximation result to
C          DRJ(X,Y,Z,P) = Integral from zero to infinity of
C
C                                -1/2     -1/2     -1/2     -1
C                      (3/2)(t+X)    (t+Y)    (t+Z)    (t+P)  dt,
C
C          where X, Y, and Z are nonnegative, at most one of them is
C          zero, and P is positive.  If X or Y or Z is zero, the
C          integral is COMPLETE.  The duplication theorem is iterated
C          until the variables are nearly equal, and the function is
C          then expanded in Taylor series to fifth order.
C
C
C   2.     Calling Sequence
C          DRJ( X, Y, Z, P, IER )
C
C          Parameters on Entry
C          Values assigned by the calling routine
C
C          X      - Double precision, nonnegative variable
C
C          Y      - Double precision, nonnegative variable
C
C          Z      - Double precision, nonnegative variable
C
C          P      - Double precision, positive variable
C
C
C          On  Return    (values assigned by the DRJ routine)
C
C          DRJ     - Double precision approximation to the integral
C
C          IER    - Integer
C
C                   IER = 0 Normal and reliable termination of the
C                           routine. It is assumed that the requested
C                           accuracy has been achieved.
C
C                   IER >  0 Abnormal termination of the routine
C
C
C          X, Y, Z, P are unaltered.
C
C
C   3.    Error Messages
C
C         Value of IER assigned by the DRJ routine
C
C              Value assigned         Error Message printed
C              IER = 1                MIN(X,Y,Z) .LT. 0.0D0
C                  = 2                MIN(X+Y,X+Z,Y+Z,P) .LT. LOLIM
C                  = 3                MAX(X,Y,Z,P) .GT. UPLIM
C
C
C
C   4.     Control Parameters
C
C                  Values of LOLIM, UPLIM, and ERRTOL are set by the
C                  routine.
C
C
C          LOLIM and UPLIM determine the valid range of X, Y, Z, and P
C
C          LOLIM is not less than the cube root of the value
C          of LOLIM used in the routine for DRC.
C
C          UPLIM is not greater than 0.3 times the cube root of
C          the value of UPLIM used in the routine for DRC.
C
C
C                     Acceptable values for:   LOLIM      UPLIM
C                     IBM 360/370 SERIES   :   2.0D-26     3.0D+24
C                     CDC 6000/7000 SERIES :   5.0D-98     3.0D+106
C                     UNIVAC 1100 SERIES   :   5.0D-103    6.0D+101
C                     CRAY                 :   1.32D-822   1.4D+821
C                     VAX 11 SERIES        :   2.5D-13     9.0D+11
C
C
C
C          ERRTOL determines the accuracy of the answer
C
C                 the value assigned by the routine will result
C                 in solution precision within 1-2 decimals of
C                 "machine precision".
C
C
C
C
C          Relative error due to truncation of the series for DRJ
C          is less than 3 * ERRTOL ** 6 / (1 - ERRTOL) ** 3/2.
C
C
C
C        The accuracy of the computed approximation to the integral
C        can be controlled by choosing the value of ERRTOL.
C        Truncation of a Taylor series after terms of fifth order
C        introduces an error less than the amount shown in the
C        second column of the following table for each value of
C        ERRTOL in the first column.  In addition to the truncation
C        error there will be round-off error, but in practice the
C        total error from both sources is usually less than the
C        amount given in the table.
C
C
C
C          Sample choices:  ERRTOL   Relative truncation
C                                    error less than
C                           1.0D-3    4.0D-18
C                           3.0D-3    3.0D-15
C                           1.0D-2    4.0D-12
C                           3.0D-2    3.0D-9
C                           1.0D-1    4.0D-6
C
C                    Decreasing ERRTOL by a factor of 10 yields six more
C                    decimal digits of accuracy at the expense of one or
C                    two more iterations of the duplication theorem.
C
C *Long Description:
C
C   DRJ Special Comments
C
C
C     Check by addition theorem: DRJ(X,X+Z,X+W,X+P)
C     + DRJ(Y,Y+Z,Y+W,Y+P) + (A-B) * DRJ(A,B,B,A) + 3.0D0 / SQRT(A)
C     = DRJ(0,Z,W,P), where X,Y,Z,W,P are positive and X * Y
C     = Z * W,  A = P * P * (X+Y+Z+W),  B = P * (P+X) * (P+Y),
C     and B - A = P * (P-Z) * (P-W).  The sum of the third and
C     fourth terms on the left side is 3.0D0 * DRC(A,B).
C
C
C          On Input:
C
C     X, Y, Z, and P are the variables in the integral DRJ(X,Y,Z,P).
C
C
C          On Output:
C
C
C          X, Y, Z, P are unaltered.
C
C          ********************************************************
C
C          WARNING: Changes in the program may improve speed at the
C                   expense of robustness.
C
C    -------------------------------------------------------------------
C
C
C   Special double precision functions via DRJ and DRF
C
C
C                  Legendre form of ELLIPTIC INTEGRAL of 3rd kind
C                  -----------------------------------------
C
C
C                          PHI         2         -1
C             P(PHI,K,N) = INT (1+N SIN (THETA) )   *
C                           0
C
C
C                                  2    2         -1/2
C                             *(1-K  SIN (THETA) )     D THETA
C
C
C                                           2          2   2
C                        = SIN (PHI) DRF(COS (PHI), 1-K SIN (PHI),1)
C
C                                   3             2         2   2
C                         -(N/3) SIN (PHI) DRJ(COS (PHI),1-K SIN (PHI),
C
C                                  2
C                         1,1+N SIN (PHI))
C
C
C
C                  Bulirsch form of ELLIPTIC INTEGRAL of 3rd kind
C                  -----------------------------------------
C
C
C                                            2 2    2
C                  EL3(X,KC,P) = X DRF(1,1+KC X ,1+X ) +
C
C                                            3           2 2    2     2
C                               +(1/3)(1-P) X  DRJ(1,1+KC X ,1+X ,1+PX )
C
C
C                                           2
C                  CEL(KC,P,A,B) = A RF(0,KC ,1) +
C
C
C                                                      2
C                                 +(1/3)(B-PA) DRJ(0,KC ,1,P)
C
C
C                  Heuman's LAMBDA function
C                  -----------------------------------------
C
C
C                                2                      2      2    1/2
C                  L(A,B,P) =(COS (A)SIN(B)COS(B)/(1-COS (A)SIN (B))   )
C
C                                            2         2       2
C                            *(SIN(P) DRF(COS (P),1-SIN (A) SIN (P),1)
C
C                                 2       3            2       2
C                            +(SIN (A) SIN (P)/(3(1-COS (A) SIN (B))))
C
C                                    2         2       2
C                            *DRJ(COS (P),1-SIN (A) SIN (P),1,1-
C
C                                2       2          2       2
C                            -SIN (A) SIN (P)/(1-COS (A) SIN (B))))
C
C
C
C                  (PI/2) LAMBDA0(A,B) =L(A,B,PI/2) =
C
C                   2                         2       2    -1/2
C              = COS (A)  SIN(B) COS(B) (1-COS (A) SIN (B))
C
C                           2                  2       2
C                 *DRF(0,COS (A),1) + (1/3) SIN (A) COS (A)
C
C                                      2       2    -3/2
C                 *SIN(B) COS(B) (1-COS (A) SIN (B))
C
C                           2         2       2          2       2
C                 *DRJ(0,COS (A),1,COS (A) COS (B)/(1-COS (A) SIN (B)))
C
C
C                  Jacobi ZETA function
C                  -----------------------------------------
C
C                        2                     2   2    1/2
C             Z(B,K) = (K/3) SIN(B) COS(B) (1-K SIN (B))
C
C
C                                  2      2   2                 2
C                        *DRJ(0,1-K ,1,1-K SIN (B)) / DRF (0,1-K ,1)
C
C
C  ---------------------------------------------------------------------
C
C***REFERENCES  B. C. Carlson and E. M. Notis, Algorithms for incomplete
C                 elliptic integrals, ACM Transactions on Mathematical
C                 Software 7, 3 (September 1981), pp. 398-403.
C               B. C. Carlson, Computing elliptic integrals by
C                 duplication, Numerische Mathematik 33, (1979),
C                 pp. 1-16.
C               B. C. Carlson, Elliptic integrals of the first kind,
C                 SIAM Journal of Mathematical Analysis 8, (1977),
C                 pp. 231-242.
C***ROUTINES CALLED  D1MACH, DRC, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891009  Removed unreferenced statement labels.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900510  Changed calls to XERMSG to standard form, and some
C           editorial changes.  (RWC)).
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DRJ
      INTEGER IER
      CHARACTER*16 XERN3, XERN4, XERN5, XERN6, XERN7
      DOUBLE PRECISION ALFA, BETA, C1, C2, C3, C4, EA, EB, EC, E2, E3
      DOUBLE PRECISION LOLIM, UPLIM, EPSLON, ERRTOL, D1MACH
      DOUBLE PRECISION LAMDA, MU, P, PN, PNDEV
      DOUBLE PRECISION POWER4, DRC, SIGMA, S1, S2, S3, X, XN, XNDEV
      DOUBLE PRECISION XNROOT, Y, YN, YNDEV, YNROOT, Z, ZN, ZNDEV,
     * ZNROOT
      LOGICAL FIRST
      SAVE ERRTOL,LOLIM,UPLIM,C1,C2,C3,C4,FIRST
      DATA FIRST /.TRUE./
C
C***FIRST EXECUTABLE STATEMENT  DRJ
      IF (FIRST) THEN
         ERRTOL = (D1MACH(3)/3.0D0)**(1.0D0/6.0D0)
         LOLIM  = (5.0D0 * D1MACH(1))**(1.0D0/3.0D0)
         UPLIM  = 0.30D0*( D1MACH(2) / 5.0D0)**(1.0D0/3.0D0)
C
         C1 = 3.0D0/14.0D0
         C2 = 1.0D0/3.0D0
         C3 = 3.0D0/22.0D0
         C4 = 3.0D0/26.0D0
      ENDIF
      FIRST = .FALSE.
C
C         CALL ERROR HANDLER IF NECESSARY.
C
      DRJ = 0.0D0
      IF (MIN(X,Y,Z).LT.0.0D0) THEN
         IER = 1
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') Z
         CALL XERMSG ('SLATEC', 'DRJ',
     *      'MIN(X,Y,Z).LT.0 WHERE X = ' // XERN3 // ' Y = ' // XERN4 //
     *      ' AND Z = ' // XERN5, 1, 1)
         RETURN
      ENDIF
C
      IF (MAX(X,Y,Z,P).GT.UPLIM) THEN
         IER = 3
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') Z
         WRITE (XERN6, '(1PE15.6)') P
         WRITE (XERN7, '(1PE15.6)') UPLIM
         CALL XERMSG ('SLATEC', 'DRJ',
     *      'MAX(X,Y,Z,P).GT.UPLIM WHERE X = ' // XERN3 // ' Y = ' //
     *      XERN4 // ' Z = ' // XERN5 // ' P = ' // XERN6 //
     *      ' AND UPLIM = ' // XERN7, 3, 1)
         RETURN
      ENDIF
C
      IF (MIN(X+Y,X+Z,Y+Z,P).LT.LOLIM) THEN
         IER = 2
         WRITE (XERN3, '(1PE15.6)') X
         WRITE (XERN4, '(1PE15.6)') Y
         WRITE (XERN5, '(1PE15.6)') Z
         WRITE (XERN6, '(1PE15.6)') P
         WRITE (XERN7, '(1PE15.6)') LOLIM
         CALL XERMSG ('SLATEC', 'RJ',
     *      'MIN(X+Y,X+Z,Y+Z,P).LT.LOLIM WHERE X = ' // XERN3 //
     *      ' Y = ' // XERN4 // ' Z = '  // XERN5 // ' P = ' // XERN6 //
     *      ' AND LOLIM = ', 2, 1)
         RETURN
      ENDIF
C
      IER = 0
      XN = X
      YN = Y
      ZN = Z
      PN = P
      SIGMA = 0.0D0
      POWER4 = 1.0D0
C
   30 MU = (XN+YN+ZN+PN+PN)*0.20D0
      XNDEV = (MU-XN)/MU
      YNDEV = (MU-YN)/MU
      ZNDEV = (MU-ZN)/MU
      PNDEV = (MU-PN)/MU
      EPSLON = MAX(ABS(XNDEV), ABS(YNDEV), ABS(ZNDEV), ABS(PNDEV))
      IF (EPSLON.LT.ERRTOL) GO TO 40
      XNROOT =  SQRT(XN)
      YNROOT =  SQRT(YN)
      ZNROOT =  SQRT(ZN)
      LAMDA = XNROOT*(YNROOT+ZNROOT) + YNROOT*ZNROOT
      ALFA = PN*(XNROOT+YNROOT+ZNROOT) + XNROOT*YNROOT*ZNROOT
      ALFA = ALFA*ALFA
      BETA = PN*(PN+LAMDA)*(PN+LAMDA)
      SIGMA = SIGMA + POWER4*DRC(ALFA,BETA,IER)
      POWER4 = POWER4*0.250D0
      XN = (XN+LAMDA)*0.250D0
      YN = (YN+LAMDA)*0.250D0
      ZN = (ZN+LAMDA)*0.250D0
      PN = (PN+LAMDA)*0.250D0
      GO TO 30
C
   40 EA = XNDEV*(YNDEV+ZNDEV) + YNDEV*ZNDEV
      EB = XNDEV*YNDEV*ZNDEV
      EC = PNDEV*PNDEV
      E2 = EA - 3.0D0*EC
      E3 = EB + 2.0D0*PNDEV*(EA-EC)
      S1 = 1.0D0 + E2*(-C1+0.750D0*C3*E2-1.50D0*C4*E3)
      S2 = EB*(0.50D0*C2+PNDEV*(-C3-C3+PNDEV*C4))
      S3 = PNDEV*EA*(C2-PNDEV*C3) - C2*PNDEV*EC
      DRJ = 3.0D0*SIGMA + POWER4*(S1+S2+S3)/(MU* SQRT(MU))
      RETURN
      END
*DECK DRKFAB
      SUBROUTINE DRKFAB (NCOMP, XPTS, NXPTS, NFC, IFLAG, Z, MXNON, P,
     +   NTP, IP, YHP, NIV, U, V, W, S, STOWA, G, WORK, IWORK, NFCC)
C***BEGIN PROLOGUE  DRKFAB
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBVSUP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (RKFAB-S, DRKFAB-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C **********************************************************************
C
C     Subroutine DRKFAB integrates the initial value equations using
C     the variable-step Runge-Kutta-Fehlberg integration scheme or
C     the variable-order Adams method and orthonormalization
C     determined by a linear dependence test.
C
C **********************************************************************
C
C***SEE ALSO  DBVSUP
C***ROUTINES CALLED  DBVDER, DDEABM, DDERKF, DREORT, DSTOR1
C***COMMON BLOCKS    DML15T, DML17B, DML18J, DML8SZ
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DRKFAB
C
      INTEGER ICOCO, IDID, IFLAG, IGOFX, INDPVT, INFO, INHOMO, INTEG,
     1     IPAR, ISTKOP, IVP, J, JFLAG, JON,
     2     K1, K10, K11, K2, K3, K4, K5, K6, K7, K8, K9, KKKINT,
     3     KKKZPW, KNSWOT, KOD, KOP, KOPP, L1, L2, LLLINT, LOTJP,
     4     MNSWOT, MXNON, MXNOND, NCOMP, NCOMPD, NDISK, NEEDIW, NEEDW,
     5     NEQ, NEQIVP, NFC, NFCC, NFCCD, NFCD, NFCP1, NIC, NIV, NON,
     6     NOPG, NPS, NSWOT, NTAPE, NTP, NTPD, NUMORT, NXPTS, NXPTSD,
     7     IP(NFCC,*), IWORK(*)
      DOUBLE PRECISION AE, C, G(*), P(NTP,*), PWCND, PX, RE,
     1     S(*), STOWA(*), TND, TOL, U(NCOMP,NFC,*),
     2     V(NCOMP,*), W(NFCC,*), WORK(*), X, XBEG, XEND, XOP,
     3     XOT, XPTS(*), XSAV, XXOP, YHP(NCOMP,*), Z(*)
C
C     ******************************************************************
C
      COMMON /DML8SZ/ C,XSAV,IGOFX,INHOMO,IVP,NCOMPD,NFCD
      COMMON /DML15T/ PX,PWCND,TND,X,XBEG,XEND,XOT,XOP,INFO(15),ISTKOP,
     1                KNSWOT,KOP,LOTJP,MNSWOT,NSWOT
      COMMON /DML18J/ AE,RE,TOL,NXPTSD,NIC,NOPG,MXNOND,NDISK,NTAPE,NEQ,
     1                INDPVT,INTEG,NPS,NTPD,NEQIVP,NUMORT,NFCCD,
     2                ICOCO
      COMMON /DML17B/ KKKZPW,NEEDW,NEEDIW,K1,K2,K3,K4,K5,K6,K7,K8,K9,
     1                K10,K11,L1,L2,KKKINT,LLLINT
C
      EXTERNAL DBVDER
C
C      *****************************************************************
C       INITIALIZATION OF COUNTERS AND VARIABLES.
C
C     BEGIN BLOCK PERMITTING ...EXITS TO 220
C        BEGIN BLOCK PERMITTING ...EXITS TO 10
C***FIRST EXECUTABLE STATEMENT  DRKFAB
            KOD = 1
            NON = 1
            X = XBEG
            JON = 1
            INFO(1) = 0
            INFO(2) = 0
            INFO(3) = 1
            INFO(4) = 1
            WORK(1) = XEND
C        ...EXIT
            IF (NOPG .EQ. 0) GO TO 10
            INFO(3) = 0
            IF (X .EQ. Z(1)) JON = 2
   10    CONTINUE
         NFCP1 = NFC + 1
C
C        ***************************************************************
C        *****BEGINNING OF INTEGRATION LOOP AT OUTPUT
C        POINTS.******************
C        ***************************************************************
C
         DO 210 KOPP = 2, NXPTS
            KOP = KOPP
            XOP = XPTS(KOP)
            IF (NDISK .EQ. 0) KOD = KOP
C
   20       CONTINUE
C
C              STEP BY STEP INTEGRATION LOOP BETWEEN OUTPUT POINTS.
C
C              BEGIN BLOCK PERMITTING ...EXITS TO 190
C                 BEGIN BLOCK PERMITTING ...EXITS TO 30
                     XXOP = XOP
C                 ...EXIT
                     IF (NOPG .EQ. 0) GO TO 30
                     IF (XEND .GT. XBEG .AND. XOP .GT. Z(JON))
     1                  XXOP = Z(JON)
                     IF (XEND .LT. XBEG .AND. XOP .LT. Z(JON))
     1                  XXOP = Z(JON)
   30             CONTINUE
C
C                 ******************************************************
   40             CONTINUE
C                    BEGIN BLOCK PERMITTING ...EXITS TO 170
                        GO TO (50,60), INTEG
C                       DDERKF INTEGRATOR
C
   50                   CONTINUE
                           CALL DDERKF(DBVDER,NEQ,X,YHP,XXOP,INFO,RE,AE,
     1                                 IDID,WORK,KKKINT,IWORK,LLLINT,G,
     2                                 IPAR)
                        GO TO 70
C                       DDEABM INTEGRATOR
C
   60                   CONTINUE
                           CALL DDEABM(DBVDER,NEQ,X,YHP,XXOP,INFO,RE,AE,
     1                                 IDID,WORK,KKKINT,IWORK,LLLINT,G,
     2                                 IPAR)
   70                   CONTINUE
                        IF (IDID .GE. 1) GO TO 80
                           INFO(1) = 1
C                    ......EXIT
                           IF (IDID .EQ. -1) GO TO 170
                           IFLAG = 20 - IDID
C     .....................EXIT
                           GO TO 220
   80                   CONTINUE
C
C                       ************************************************
C                           GRAM-SCHMIDT ORTHOGONALIZATION TEST FOR
C                           ORTHONORMALIZATION (TEMPORARILY USING U AND
C                           V IN THE TEST)
C
                        IF (NOPG .EQ. 0) GO TO 100
                           IF (XXOP .EQ. Z(JON)) GO TO 90
C
C                             ******************************************
C                                 CONTINUE INTEGRATION IF WE ARE NOT AT
C                                 AN OUTPUT POINT.
C
C           ..................EXIT
                              IF (IDID .NE. 1) GO TO 200
C                    .........EXIT
                              GO TO 170
   90                      CONTINUE
                           JFLAG = 2
                        GO TO 110
  100                   CONTINUE
                           JFLAG = 1
                           IF (INHOMO .EQ. 3 .AND. X .EQ. XEND)
     1                        JFLAG = 3
  110                   CONTINUE
C
                        IF (NDISK .EQ. 0) NON = NUMORT + 1
                        CALL DREORT(NCOMP,U(1,1,KOD),V(1,KOD),YHP,NIV,
     1                              W(1,NON),S,P(1,NON),IP(1,NON),STOWA,
     2                              JFLAG)
C
                        IF (JFLAG .NE. 30) GO TO 120
                           IFLAG = 30
C     .....................EXIT
                           GO TO 220
  120                   CONTINUE
C
                        IF (JFLAG .NE. 10) GO TO 130
                           XOP = XPTS(KOP)
                           IF (NDISK .EQ. 0) KOD = KOP
C              ............EXIT
                           GO TO 190
  130                   CONTINUE
C
                        IF (JFLAG .EQ. 0) GO TO 140
C
C                          *********************************************
C                              CONTINUE INTEGRATION IF WE ARE NOT AT AN
C                              OUTPUT POINT.
C
C           ...............EXIT
                           IF (IDID .NE. 1) GO TO 200
C                    ......EXIT
                           GO TO 170
  140                   CONTINUE
C
C                       ************************************************
C                           STORE ORTHONORMALIZED VECTORS INTO SOLUTION
C                           VECTORS.
C
                        IF (NUMORT .LT. MXNON) GO TO 150
                        IF (X .EQ. XEND) GO TO 150
                           IFLAG = 13
C     .....................EXIT
                           GO TO 220
  150                   CONTINUE
C
                        NUMORT = NUMORT + 1
                        CALL DSTOR1(YHP,U(1,1,KOD),YHP(1,NFCP1),
     1                              V(1,KOD),1,NDISK,NTAPE)
C
C                       ************************************************
C                           STORE ORTHONORMALIZATION INFORMATION,
C                           INITIALIZE INTEGRATION FLAG, AND CONTINUE
C                           INTEGRATION TO THE NEXT ORTHONORMALIZATION
C                           POINT OR OUTPUT POINT.
C
                        Z(NUMORT) = X
                        IF (INHOMO .EQ. 1 .AND. NPS .EQ. 0)
     1                     C = S(NFCP1)*C
                        IF (NDISK .EQ. 0) GO TO 160
                           IF (INHOMO .EQ. 1)
     1                        WRITE (NTAPE) (W(J,1), J = 1, NFCC)
                           WRITE (NTAPE)
     1                           (IP(J,1), J = 1, NFCC),
     2                           (P(J,1), J = 1, NTP)
  160                   CONTINUE
                        INFO(1) = 0
                        JON = JON + 1
C                 ......EXIT
                        IF (NOPG .EQ. 1 .AND. X .NE. XOP) GO TO 180
C
C                       ************************************************
C                           CONTINUE INTEGRATION IF WE ARE NOT AT AN
C                           OUTPUT POINT.
C
C           ............EXIT
                        IF (IDID .NE. 1) GO TO 200
  170                CONTINUE
                  GO TO 40
  180             CONTINUE
  190          CONTINUE
            GO TO 20
  200       CONTINUE
C
C           STORAGE OF HOMOGENEOUS SOLUTIONS IN U AND THE PARTICULAR
C           SOLUTION IN V AT THE OUTPUT POINTS.
C
            CALL DSTOR1(U(1,1,KOD),YHP,V(1,KOD),YHP(1,NFCP1),0,NDISK,
     1                  NTAPE)
  210    CONTINUE
C        ***************************************************************
C        ***************************************************************
C
         IFLAG = 0
  220 CONTINUE
      RETURN
      END
*DECK DRKFS
      SUBROUTINE DRKFS (DF, NEQ, T, Y, TOUT, INFO, RTOL, ATOL, IDID, H,
     +   TOLFAC, YP, F1, F2, F3, F4, F5, YS, TOLD, DTSIGN, U26, RER,
     +   INIT, KSTEPS, KOP, IQUIT, STIFF, NONSTF, NTSTEP, NSTIFS, RPAR,
     +   IPAR)
C***BEGIN PROLOGUE  DRKFS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DDERKF
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (DERKFS-S, DRKFS-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     Fehlberg Fourth-Fifth Order Runge-Kutta Method
C **********************************************************************
C
C     DRKFS integrates a system of first order ordinary differential
C     equations as described in the comments for DDERKF .
C
C     The arrays YP,F1,F2,F3,F4,F5,and YS  (of length at least NEQ)
C     appear in the call list for variable dimensioning purposes.
C
C     The variables H,TOLFAC,TOLD,DTSIGN,U26,RER,INIT,KSTEPS,KOP,IQUIT,
C     STIFF,NONSTF,NTSTEP, and NSTIFS are used internally by the code
C     and appear in the call list to eliminate local retention of
C     variables between calls. Accordingly, these variables and the
C     array YP should not be altered.
C     Items of possible interest are
C         H  - An appropriate step size to be used for the next step
C         TOLFAC - Factor of change in the tolerances
C         YP - Derivative of solution vector at T
C         KSTEPS - Counter on the number of steps attempted
C
C **********************************************************************
C
C***SEE ALSO  DDERKF
C***ROUTINES CALLED  D1MACH, DFEHL, DHSTRT, DHVNRM, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   820301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891024  Changed references from DVNORM to DHVNRM.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls, change GOTOs to
C           IF-THEN-ELSEs.  (RWC)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DRKFS
C
      INTEGER IDID, INFO, INIT, IPAR, IQUIT, K, KOP, KSTEPS, KTOL,
     1      MXKOP, MXSTEP, NATOLP, NEQ, NRTOLP, NSTIFS, NTSTEP
      DOUBLE PRECISION A, ATOL, BIG, D1MACH,
     1      DT, DTSIGN, DHVNRM, DY, EE, EEOET, ES, ESTIFF,
     2      ESTTOL, ET, F1, F2, F3, F4, F5, H, HMIN, REMIN, RER, RPAR,
     3      RTOL, S, T, TOL, TOLD, TOLFAC, TOUT, U, U26, UTE, Y, YAVG,
     4      YP, YS
      LOGICAL HFAILD,OUTPUT,STIFF,NONSTF
      CHARACTER*8 XERN1
      CHARACTER*16 XERN3, XERN4
C
      DIMENSION Y(*),YP(*),F1(*),F2(*),F3(*),F4(*),F5(*),
     1          YS(*),INFO(15),RTOL(*),ATOL(*),RPAR(*),IPAR(*)
C
      EXTERNAL DF
C
C     ..................................................................
C
C       A FIFTH ORDER METHOD WILL GENERALLY NOT BE CAPABLE OF DELIVERING
C       ACCURACIES NEAR LIMITING PRECISION ON COMPUTERS WITH LONG
C       WORDLENGTHS. TO PROTECT AGAINST LIMITING PRECISION DIFFICULTIES
C       ARISING FROM UNREASONABLE ACCURACY REQUESTS, AN APPROPRIATE
C       TOLERANCE THRESHOLD REMIN IS ASSIGNED FOR THIS METHOD. THIS
C       VALUE SHOULD NOT BE CHANGED ACROSS DIFFERENT MACHINES.
C
      SAVE REMIN, MXSTEP, MXKOP
      DATA REMIN /1.0D-12/
C
C     ..................................................................
C
C       THE EXPENSE OF SOLVING THE PROBLEM IS MONITORED BY COUNTING THE
C       NUMBER OF  STEPS ATTEMPTED. WHEN THIS EXCEEDS  MXSTEP, THE
C       COUNTER IS RESET TO ZERO AND THE USER IS INFORMED ABOUT POSSIBLE
C       EXCESSIVE WORK.
C
      DATA MXSTEP /500/
C
C     ..................................................................
C
C       INEFFICIENCY CAUSED BY TOO FREQUENT OUTPUT IS MONITORED BY
C       COUNTING THE NUMBER OF STEP SIZES WHICH ARE SEVERELY SHORTENED
C       DUE SOLELY TO THE CHOICE OF OUTPUT POINTS. WHEN THE NUMBER OF
C       ABUSES EXCEED MXKOP, THE COUNTER IS RESET TO ZERO AND THE USER
C       IS INFORMED ABOUT POSSIBLE MISUSE OF THE CODE.
C
      DATA MXKOP /100/
C
C     ..................................................................
C
C***FIRST EXECUTABLE STATEMENT  DRKFS
      IF (INFO(1) .EQ. 0) THEN
C
C ON THE FIRST CALL , PERFORM INITIALIZATION --
C        DEFINE THE MACHINE UNIT ROUNDOFF QUANTITY  U  BY CALLING THE
C        FUNCTION ROUTINE  D1MACH. THE USER MUST MAKE SURE THAT THE
C        VALUES SET IN D1MACH ARE RELEVANT TO THE COMPUTER BEING USED.
C
         U = D1MACH(4)
C                       -- SET ASSOCIATED MACHINE DEPENDENT PARAMETERS
         U26 = 26.0D0*U
         RER = 2.0D0*U + REMIN
C                       -- SET TERMINATION FLAG
         IQUIT = 0
C                       -- SET INITIALIZATION INDICATOR
         INIT = 0
C                       -- SET COUNTER FOR IMPACT OF OUTPUT POINTS
         KOP = 0
C                       -- SET COUNTER FOR ATTEMPTED STEPS
         KSTEPS = 0
C                       -- SET INDICATORS FOR STIFFNESS DETECTION
         STIFF = .FALSE.
         NONSTF = .FALSE.
C                       -- SET STEP COUNTERS FOR STIFFNESS DETECTION
         NTSTEP = 0
         NSTIFS = 0
C                       -- RESET INFO(1) FOR SUBSEQUENT CALLS
         INFO(1) = 1
      ENDIF
C
C.......................................................................
C
C        CHECK VALIDITY OF INPUT PARAMETERS ON EACH ENTRY
C
      IF (INFO(1) .NE. 0 .AND. INFO(1) .NE. 1) THEN
         WRITE (XERN1, '(I8)') INFO(1)
         CALL XERMSG ('SLATEC', 'DRKFS',
     *      'IN DDERKF, INFO(1) MUST BE SET TO 0 ' //
     *      'FOR THE START OF A NEW PROBLEM, AND MUST BE SET TO 1 ' //
     *      'FOLLOWING AN INTERRUPTED TASK.  YOU ARE ATTEMPTING TO ' //
     *      'CONTINUE THE INTEGRATION ILLEGALLY BY CALLING THE CODE ' //
     *      'WITH  INFO(1) = ' // XERN1, 3, 1)
         IDID = -33
      ENDIF
C
      IF (INFO(2) .NE. 0 .AND. INFO(2) .NE. 1) THEN
         WRITE (XERN1, '(I8)') INFO(2)
         CALL XERMSG ('SLATEC', 'DRKFS',
     *      'IN DDERKF, INFO(2) MUST BE 0 OR 1 ' //
     *      'INDICATING SCALAR AND VECTOR ERROR TOLERANCES, ' //
     *      'RESPECTIVELY.  YOU HAVE CALLED THE CODE WITH INFO(2) = ' //
     *      XERN1, 4, 1)
         IDID = -33
      ENDIF
C
      IF (INFO(3) .NE. 0 .AND. INFO(3) .NE. 1) THEN
         WRITE (XERN1, '(I8)') INFO(3)
         CALL XERMSG ('SLATEC', 'DRKFS',
     *      'IN DDERKF, INFO(3) MUST BE 0 OR 1 ' //
     *      'INDICATING THE INTERVAL OR INTERMEDIATE-OUTPUT MODE OF ' //
     *      'INTEGRATION, RESPECTIVELY.  YOU HAVE CALLED THE CODE ' //
     *      'WITH  INFO(3) = ' // XERN1, 5, 1)
         IDID = -33
      ENDIF
C
      IF (NEQ .LT. 1) THEN
         WRITE (XERN1, '(I8)') NEQ
         CALL XERMSG ('SLATEC', 'DRKFS',
     *      'IN DDERKF, THE NUMBER OF EQUATIONS ' //
     *      'NEQ MUST BE A POSITIVE INTEGER.  YOU HAVE CALLED THE ' //
     *      'CODE WITH NEQ = ' // XERN1, 6, 1)
         IDID = -33
      ENDIF
C
      NRTOLP = 0
      NATOLP = 0
      DO 10 K=1,NEQ
         IF (NRTOLP .EQ. 0 .AND. RTOL(K) .LT. 0.D0) THEN
            WRITE (XERN1, '(I8)') K
            WRITE (XERN3, '(1PE15.6)') RTOL(K)
            CALL XERMSG ('SLATEC', 'DRKFS',
     *         'IN DDERKF, THE RELATIVE ERROR ' //
     *         'TOLERANCES RTOL MUST BE NON-NEGATIVE.  YOU HAVE ' //
     *         'CALLED THE CODE WITH  RTOL(' // XERN1 // ') = ' //
     *         XERN3 // '.  IN THE CASE OF VECTOR ERROR TOLERANCES, ' //
     *         'NO FURTHER CHECKING OF RTOL COMPONENTS IS DONE.', 7, 1)
            IDID = -33
            NRTOLP = 1
         ENDIF
C
         IF (NATOLP .EQ. 0 .AND. ATOL(K) .LT. 0.D0) THEN
            WRITE (XERN1, '(I8)') K
            WRITE (XERN3, '(1PE15.6)') ATOL(K)
            CALL XERMSG ('SLATEC', 'DRKFS',
     *         'IN DDERKF, THE ABSOLUTE ERROR ' //
     *         'TOLERANCES ATOL MUST BE NON-NEGATIVE.  YOU HAVE ' //
     *         'CALLED THE CODE WITH  ATOL(' // XERN1 // ') = ' //
     *         XERN3 // '.  IN THE CASE OF VECTOR ERROR TOLERANCES, ' //
     *         'NO FURTHER CHECKING OF ATOL COMPONENTS IS DONE.', 8, 1)
            IDID = -33
            NATOLP = 1
         ENDIF
C
         IF (INFO(2) .EQ. 0) GO TO 20
         IF (NATOLP.GT.0 .AND. NRTOLP.GT.0) GO TO 20
   10 CONTINUE
C
C
C     CHECK SOME CONTINUATION POSSIBILITIES
C
   20 IF (INIT .NE. 0) THEN
         IF (T .EQ. TOUT) THEN
            WRITE (XERN3, '(1PE15.6)') T
            CALL XERMSG ('SLATEC', 'DRKFS',
     *         'IN DDERKF, YOU HAVE CALLED THE ' //
     *         'CODE WITH  T = TOUT = ' // XERN3 // '$$THIS IS NOT ' //
     *         'ALLOWED ON CONTINUATION CALLS.', 9, 1)
            IDID=-33
         ENDIF
C
         IF (T .NE. TOLD) THEN
            WRITE (XERN3, '(1PE15.6)') TOLD
            WRITE (XERN4, '(1PE15.6)') T
            CALL XERMSG ('SLATEC', 'DRKFS',
     *         'IN DDERKF, YOU HAVE CHANGED THE ' //
     *         'VALUE OF T FROM ' // XERN3 // ' TO ' // XERN4 //
     *         '$$THIS IS NOT ALLOWED ON CONTINUATION CALLS.', 10, 1)
            IDID=-33
         ENDIF
C
         IF (INIT .NE. 1) THEN
            IF (DTSIGN*(TOUT-T) .LT. 0.D0) THEN
               WRITE (XERN3, '(1PE15.6)') TOUT
               CALL XERMSG ('SLATEC', 'DRKFS',
     *            'IN DDERKF, BY CALLING THE CODE WITH TOUT = ' //
     *            XERN3 // ' YOU ARE ATTEMPTING TO CHANGE THE ' //
     *            'DIRECTION OF INTEGRATION.$$THIS IS NOT ALLOWED ' //
     *            'WITHOUT RESTARTING.', 11, 1)
               IDID=-33
            ENDIF
         ENDIF
      ENDIF
C
C     INVALID INPUT DETECTED
C
      IF (IDID .EQ. (-33)) THEN
         IF (IQUIT .NE. (-33)) THEN
            IQUIT = -33
            GOTO 540
         ELSE
            CALL XERMSG ('SLATEC', 'DRKFS',
     *         'IN DDERKF, INVALID INPUT WAS ' //
     *         'DETECTED ON SUCCESSIVE ENTRIES.  IT IS IMPOSSIBLE ' //
     *         'TO PROCEED BECAUSE YOU HAVE NOT CORRECTED THE ' //
     *         'PROBLEM, SO EXECUTION IS BEING TERMINATED.', 12, 2)
            RETURN
         ENDIF
      ENDIF
C
C           ............................................................
C
C                RTOL = ATOL = 0. IS ALLOWED AS VALID INPUT AND
C                INTERPRETED AS ASKING FOR THE MOST ACCURATE SOLUTION
C                POSSIBLE. IN THIS CASE, THE RELATIVE ERROR TOLERANCE
C                RTOL IS RESET TO THE SMALLEST VALUE RER WHICH IS LIKELY
C                TO BE REASONABLE FOR THIS METHOD AND MACHINE.
C
            DO 190 K = 1, NEQ
               IF (RTOL(K) + ATOL(K) .GT. 0.0D0) GO TO 180
                  RTOL(K) = RER
                  IDID = -2
  180          CONTINUE
C           ...EXIT
               IF (INFO(2) .EQ. 0) GO TO 200
  190       CONTINUE
  200       CONTINUE
C
            IF (IDID .NE. (-2)) GO TO 210
C
C              RTOL=ATOL=0 ON INPUT, SO RTOL WAS CHANGED TO A
C                                       SMALL POSITIVE VALUE
               TOLFAC = 1.0D0
            GO TO 530
  210       CONTINUE
C
C                       BRANCH ON STATUS OF INITIALIZATION INDICATOR
C                              INIT=0 MEANS INITIAL DERIVATIVES AND
C                              STARTING STEP SIZE
C                                     NOT YET COMPUTED
C                              INIT=1 MEANS STARTING STEP SIZE NOT YET
C                              COMPUTED INIT=2 MEANS NO FURTHER
C                              INITIALIZATION REQUIRED
C
                        IF (INIT .EQ. 0) GO TO 220
C                    ......EXIT
                           IF (INIT .EQ. 1) GO TO 240
C                 .........EXIT
                           GO TO 260
  220                   CONTINUE
C
C                       ................................................
C
C                            MORE INITIALIZATION --
C                                                -- EVALUATE INITIAL
C                                                DERIVATIVES
C
                        INIT = 1
                        A = T
                        CALL DF(A,Y,YP,RPAR,IPAR)
                        IF (T .NE. TOUT) GO TO 230
C
C                          INTERVAL MODE
                           IDID = 2
                           T = TOUT
                           TOLD = T
C     .....................EXIT
                           GO TO 560
  230                   CONTINUE
  240                CONTINUE
C
C                    -- SET SIGN OF INTEGRATION DIRECTION  AND
C                    -- ESTIMATE STARTING STEP SIZE
C
                     INIT = 2
                     DTSIGN = SIGN(1.0D0,TOUT-T)
                     U = D1MACH(4)
                     BIG = SQRT(D1MACH(2))
                     UTE = U**0.375D0
                     DY = UTE*DHVNRM(Y,NEQ)
                     IF (DY .EQ. 0.0D0) DY = UTE
                     KTOL = 1
                     DO 250 K = 1, NEQ
                        IF (INFO(2) .EQ. 1) KTOL = K
                        TOL = RTOL(KTOL)*ABS(Y(K)) + ATOL(KTOL)
                        IF (TOL .EQ. 0.0D0) TOL = DY*RTOL(KTOL)
                        F1(K) = TOL
  250                CONTINUE
C
                     CALL DHSTRT(DF,NEQ,T,TOUT,Y,YP,F1,4,U,BIG,F2,F3,F4,
     1                           F5,RPAR,IPAR,H)
  260             CONTINUE
C
C                 ......................................................
C
C                      SET STEP SIZE FOR INTEGRATION IN THE DIRECTION
C                      FROM T TO TOUT AND SET OUTPUT POINT INDICATOR
C
                  DT = TOUT - T
                  H = SIGN(H,DT)
                  OUTPUT = .FALSE.
C
C                 TEST TO SEE IF DDERKF IS BEING SEVERELY IMPACTED BY
C                 TOO MANY OUTPUT POINTS
C
                  IF (ABS(H) .GE. 2.0D0*ABS(DT)) KOP = KOP + 1
                  IF (KOP .LE. MXKOP) GO TO 270
C
C                    UNNECESSARY FREQUENCY OF OUTPUT IS RESTRICTING
C                                              THE STEP SIZE CHOICE
                     IDID = -5
                     KOP = 0
                  GO TO 510
  270             CONTINUE
C
                     IF (ABS(DT) .GT. U26*ABS(T)) GO TO 290
C
C                       IF TOO CLOSE TO OUTPUT POINT,EXTRAPOLATE AND
C                       RETURN
C
                        DO 280 K = 1, NEQ
                           Y(K) = Y(K) + DT*YP(K)
  280                   CONTINUE
                        A = TOUT
                        CALL DF(A,Y,YP,RPAR,IPAR)
                        KSTEPS = KSTEPS + 1
                     GO TO 500
  290                CONTINUE
C                       BEGIN BLOCK PERMITTING ...EXITS TO 490
C
C                          *********************************************
C                          *********************************************
C                               STEP BY STEP INTEGRATION
C
  300                      CONTINUE
C                             BEGIN BLOCK PERMITTING ...EXITS TO 480
                                 HFAILD = .FALSE.
C
C                                TO PROTECT AGAINST IMPOSSIBLE ACCURACY
C                                REQUESTS, COMPUTE A TOLERANCE FACTOR
C                                BASED ON THE REQUESTED ERROR TOLERANCE
C                                AND A LEVEL OF ACCURACY ACHIEVABLE AT
C                                LIMITING PRECISION
C
                                 TOLFAC = 0.0D0
                                 KTOL = 1
                                 DO 330 K = 1, NEQ
                                    IF (INFO(2) .EQ. 1) KTOL = K
                                    ET = RTOL(KTOL)*ABS(Y(K))
     1                                   + ATOL(KTOL)
                                    IF (ET .GT. 0.0D0) GO TO 310
                                       TOLFAC = MAX(TOLFAC,
     1                                                RER/RTOL(KTOL))
                                    GO TO 320
  310                               CONTINUE
                                       TOLFAC = MAX(TOLFAC,
     1                                                ABS(Y(K))
     2                                                *(RER/ET))
  320                               CONTINUE
  330                            CONTINUE
                                 IF (TOLFAC .LE. 1.0D0) GO TO 340
C
C                          REQUESTED ERROR UNATTAINABLE DUE TO LIMITED
C                                                  PRECISION AVAILABLE
                                    TOLFAC = 2.0D0*TOLFAC
                                    IDID = -2
C              .....................EXIT
                                    GO TO 520
  340                            CONTINUE
C
C                                SET SMALLEST ALLOWABLE STEP SIZE
C
                                 HMIN = U26*ABS(T)
C
C                                ADJUST STEP SIZE IF NECESSARY TO HIT
C                                THE OUTPUT POINT -- LOOK AHEAD TWO
C                                STEPS TO AVOID DRASTIC CHANGES IN THE
C                                STEP SIZE AND THUS LESSEN THE IMPACT OF
C                                OUTPUT POINTS ON THE CODE.  STRETCH THE
C                                STEP SIZE BY, AT MOST, AN AMOUNT EQUAL
C                                TO THE SAFETY FACTOR OF 9/10.
C
                                 DT = TOUT - T
                                 IF (ABS(DT) .GE. 2.0D0*ABS(H))
     1                              GO TO 370
                                    IF (ABS(DT) .GT. ABS(H)/0.9D0)
     1                                 GO TO 350
C
C                                      THE NEXT STEP, IF SUCCESSFUL,
C                                      WILL COMPLETE THE INTEGRATION TO
C                                      THE OUTPUT POINT
C
                                       OUTPUT = .TRUE.
                                       H = DT
                                    GO TO 360
  350                               CONTINUE
C
                                       H = 0.5D0*DT
  360                               CONTINUE
  370                            CONTINUE
C
C
C                                ***************************************
C                                     CORE INTEGRATOR FOR TAKING A
C                                     SINGLE STEP
C                                ***************************************
C                                     TO AVOID PROBLEMS WITH ZERO
C                                     CROSSINGS, RELATIVE ERROR IS
C                                     MEASURED USING THE AVERAGE OF THE
C                                     MAGNITUDES OF THE SOLUTION AT THE
C                                     BEGINNING AND END OF A STEP.
C                                     THE ERROR ESTIMATE FORMULA HAS
C                                     BEEN GROUPED TO CONTROL LOSS OF
C                                     SIGNIFICANCE.
C                                     LOCAL ERROR ESTIMATES FOR A FIRST
C                                     ORDER METHOD USING THE SAME
C                                     STEP SIZE AS THE FEHLBERG METHOD
C                                     ARE CALCULATED AS PART OF THE
C                                     TEST FOR STIFFNESS.
C                                     TO DISTINGUISH THE VARIOUS
C                                     ARGUMENTS, H IS NOT PERMITTED
C                                     TO BECOME SMALLER THAN 26 UNITS OF
C                                     ROUNDOFF IN T.  PRACTICAL LIMITS
C                                     ON THE CHANGE IN THE STEP SIZE ARE
C                                     ENFORCED TO SMOOTH THE STEP SIZE
C                                     SELECTION PROCESS AND TO AVOID
C                                     EXCESSIVE CHATTERING ON PROBLEMS
C                                     HAVING DISCONTINUITIES.  TO
C                                     PREVENT UNNECESSARY FAILURES, THE
C                                     CODE USES 9/10 THE STEP SIZE
C                                     IT ESTIMATES WILL SUCCEED.
C                                     AFTER A STEP FAILURE, THE STEP
C                                     SIZE IS NOT ALLOWED TO INCREASE
C                                     FOR THE NEXT ATTEMPTED STEP. THIS
C                                     MAKES THE CODE MORE EFFICIENT ON
C                                     PROBLEMS HAVING DISCONTINUITIES
C                                     AND MORE EFFECTIVE IN GENERAL
C                                     SINCE LOCAL EXTRAPOLATION IS BEING
C                                     USED AND EXTRA CAUTION SEEMS
C                                     WARRANTED.
C                                .......................................
C
C                                     MONITOR NUMBER OF STEPS ATTEMPTED
C
  380                            CONTINUE
                                    IF (KSTEPS .LE. MXSTEP) GO TO 390
C
C                                      A SIGNIFICANT AMOUNT OF WORK HAS
C                                      BEEN EXPENDED
                                       IDID = -1
                                       KSTEPS = 0
C              ........................EXIT
                                       IF (.NOT.STIFF) GO TO 520
C
C                                      PROBLEM APPEARS TO BE STIFF
                                       IDID = -4
                                       STIFF = .FALSE.
                                       NONSTF = .FALSE.
                                       NTSTEP = 0
                                       NSTIFS = 0
C              ........................EXIT
                                       GO TO 520
  390                               CONTINUE
C
C                                   ADVANCE AN APPROXIMATE SOLUTION OVER
C                                   ONE STEP OF LENGTH H
C
                                    CALL DFEHL(DF,NEQ,T,Y,H,YP,F1,F2,F3,
     1                                         F4,F5,YS,RPAR,IPAR)
                                    KSTEPS = KSTEPS + 1
C
C                                   ....................................
C
C                                        COMPUTE AND TEST ALLOWABLE
C                                        TOLERANCES VERSUS LOCAL ERROR
C                                        ESTIMATES.  NOTE THAT RELATIVE
C                                        ERROR IS MEASURED WITH RESPECT
C                                        TO THE AVERAGE OF THE
C                                        MAGNITUDES OF THE SOLUTION AT
C                                        THE BEGINNING AND END OF THE
C                                        STEP.  LOCAL ERROR ESTIMATES
C                                        FOR A SPECIAL FIRST ORDER
C                                        METHOD ARE CALCULATED ONLY WHEN
C                                        THE STIFFNESS DETECTION IS
C                                        TURNED ON.
C
                                    EEOET = 0.0D0
                                    ESTIFF = 0.0D0
                                    KTOL = 1
                                    DO 420 K = 1, NEQ
                                       YAVG = 0.5D0
     1                                        *(ABS(Y(K))
     2                                          + ABS(YS(K)))
                                       IF (INFO(2) .EQ. 1) KTOL = K
                                       ET = RTOL(KTOL)*YAVG + ATOL(KTOL)
                                       IF (ET .GT. 0.0D0) GO TO 400
C
C           PURE RELATIVE ERROR INAPPROPRIATE WHEN SOLUTION
C                                                  VANISHES
                                          IDID = -3
C              ...........................EXIT
                                          GO TO 520
  400                                  CONTINUE
C
                                       EE = ABS((-2090.0D0*YP(K)
     1                                            +(21970.0D0*F3(K)
     2                                              -15048.0D0*F4(K)))
     3                                           +(22528.0D0*F2(K)
     4                                             -27360.0D0*F5(K)))
                                       IF (STIFF .OR. NONSTF) GO TO 410
                                          ES = ABS(H
     1                                              *(0.055455D0*YP(K)
     2                                                -0.035493D0*F1(K)
     3                                                -0.036571D0*F2(K)
     4                                                +0.023107D0*F3(K)
     5                                                -0.009515D0*F4(K)
     6                                                +0.003017D0*F5(K))
     7                                                )
                                          ESTIFF = MAX(ESTIFF,ES/ET)
  410                                  CONTINUE
                                       EEOET = MAX(EEOET,EE/ET)
  420                               CONTINUE
C
                                    ESTTOL = ABS(H)*EEOET/752400.0D0
C
C                                ...EXIT
                                    IF (ESTTOL .LE. 1.0D0) GO TO 440
C
C                                   ....................................
C
C                                        UNSUCCESSFUL STEP
C
                                    IF (ABS(H) .GT. HMIN) GO TO 430
C
C                             REQUESTED ERROR UNATTAINABLE AT SMALLEST
C                                                  ALLOWABLE STEP SIZE
                                       TOLFAC = 1.69D0*ESTTOL
                                       IDID = -2
C              ........................EXIT
                                       GO TO 520
  430                               CONTINUE
C
C                                   REDUCE THE STEP SIZE , TRY AGAIN
C                                   THE DECREASE IS LIMITED TO A FACTOR
C                                   OF 1/10
C
                                    HFAILD = .TRUE.
                                    OUTPUT = .FALSE.
                                    S = 0.1D0
                                    IF (ESTTOL .LT. 59049.0D0)
     1                                 S = 0.9D0/ESTTOL**0.2D0
                                    H = SIGN(MAX(S*ABS(H),HMIN),H)
                                 GO TO 380
  440                            CONTINUE
C
C                                .......................................
C
C                                SUCCESSFUL STEP
C                                                  STORE SOLUTION AT T+H
C                                                  AND EVALUATE
C                                                  DERIVATIVES THERE
C
                                 T = T + H
                                 DO 450 K = 1, NEQ
                                    Y(K) = YS(K)
  450                            CONTINUE
                                 A = T
                                 CALL DF(A,Y,YP,RPAR,IPAR)
C
C                                CHOOSE NEXT STEP SIZE
C                                THE INCREASE IS LIMITED TO A FACTOR OF
C                                5 IF STEP FAILURE HAS JUST OCCURRED,
C                                NEXT
C                                   STEP SIZE IS NOT ALLOWED TO INCREASE
C
                                 S = 5.0D0
                                 IF (ESTTOL .GT. 1.889568D-4)
     1                              S = 0.9D0/ESTTOL**0.2D0
                                 IF (HFAILD) S = MIN(S,1.0D0)
                                 H = SIGN(MAX(S*ABS(H),HMIN),H)
C
C                                .......................................
C
C                                     CHECK FOR STIFFNESS (IF NOT
C                                     ALREADY DETECTED)
C
C                                     IN A SEQUENCE OF 50 SUCCESSFUL
C                                     STEPS BY THE FEHLBERG METHOD, 25
C                                     SUCCESSFUL STEPS BY THE FIRST
C                                     ORDER METHOD INDICATES STIFFNESS
C                                     AND TURNS THE TEST OFF. IF 26
C                                     FAILURES BY THE FIRST ORDER METHOD
C                                     OCCUR, THE TEST IS TURNED OFF
C                                     UNTIL THIS SEQUENCE OF 50 STEPS BY
C                                     THE FEHLBERG METHOD IS COMPLETED.
C
C                             ...EXIT
                                 IF (STIFF) GO TO 480
                                 NTSTEP = MOD(NTSTEP+1,50)
                                 IF (NTSTEP .EQ. 1) NONSTF = .FALSE.
C                             ...EXIT
                                 IF (NONSTF) GO TO 480
                                 IF (ESTIFF .GT. 1.0D0) GO TO 460
C
C                                   SUCCESSFUL STEP WITH FIRST ORDER
C                                   METHOD
                                    NSTIFS = NSTIFS + 1
C                                   TURN TEST OFF AFTER 25 INDICATIONS
C                                   OF STIFFNESS
                                    IF (NSTIFS .EQ. 25) STIFF = .TRUE.
                                 GO TO 470
  460                            CONTINUE
C
C                                UNSUCCESSFUL STEP WITH FIRST ORDER
C                                METHOD
                                 IF (NTSTEP - NSTIFS .LE. 25) GO TO 470
C               TURN STIFFNESS DETECTION OFF FOR THIS BLOCK OF
C                                                  FIFTY STEPS
                                    NONSTF = .TRUE.
C                                   RESET STIFF STEP COUNTER
                                    NSTIFS = 0
  470                            CONTINUE
  480                         CONTINUE
C
C                             ******************************************
C                                  END OF CORE INTEGRATOR
C                             ******************************************
C
C
C                                  SHOULD WE TAKE ANOTHER STEP
C
C                       ......EXIT
                              IF (OUTPUT) GO TO 490
                           IF (INFO(3) .EQ. 0) GO TO 300
C
C                          *********************************************
C                          *********************************************
C
C                               INTEGRATION SUCCESSFULLY COMPLETED
C
C                                           ONE-STEP MODE
                           IDID = 1
                           TOLD = T
C     .....................EXIT
                           GO TO 560
  490                   CONTINUE
  500                CONTINUE
C
C                    INTERVAL MODE
                     IDID = 2
                     T = TOUT
                     TOLD = T
C     ...............EXIT
                     GO TO 560
  510             CONTINUE
  520          CONTINUE
  530       CONTINUE
  540    CONTINUE
C
C        INTEGRATION TASK INTERRUPTED
C
         INFO(1) = -1
         TOLD = T
C     ...EXIT
         IF (IDID .NE. (-2)) GO TO 560
C
C        THE ERROR TOLERANCES ARE INCREASED TO VALUES
C                WHICH ARE APPROPRIATE FOR CONTINUING
         RTOL(1) = TOLFAC*RTOL(1)
         ATOL(1) = TOLFAC*ATOL(1)
C     ...EXIT
         IF (INFO(2) .EQ. 0) GO TO 560
         DO 550 K = 2, NEQ
            RTOL(K) = TOLFAC*RTOL(K)
            ATOL(K) = TOLFAC*ATOL(K)
  550    CONTINUE
  560 CONTINUE
      RETURN
      END
*DECK DRLCAL
      SUBROUTINE DRLCAL (N, KMP, LL, MAXL, V, Q, RL, SNORMW, PROD,
     +   R0NRM)
C***BEGIN PROLOGUE  DRLCAL
C***SUBSIDIARY
C***PURPOSE  Internal routine for DGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      DOUBLE PRECISION (SRLCAL-S, DRLCAL-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C         This routine calculates the scaled residual RL from the
C         V(I)'s.
C *Usage:
C      INTEGER N, KMP, LL, MAXL
C      DOUBLE PRECISION V(N,LL), Q(2*MAXL), RL(N), SNORMW, PROD, R0NORM
C
C      CALL DRLCAL(N, KMP, LL, MAXL, V, Q, RL, SNORMW, PROD, R0NRM)
C
C *Arguments:
C N      :IN       Integer
C         The order of the matrix A, and the lengths
C         of the vectors SR, SZ, R0 and Z.
C KMP    :IN       Integer
C         The number of previous V vectors the new vector VNEW
C         must be made orthogonal to. (KMP .le. MAXL)
C LL     :IN       Integer
C         The current dimension of the Krylov subspace.
C MAXL   :IN       Integer
C         The maximum dimension of the Krylov subspace.
C V      :IN       Double Precision V(N,LL)
C         The N x LL array containing the orthogonal vectors
C         V(*,1) to V(*,LL).
C Q      :IN       Double Precision Q(2*MAXL)
C         A double precision array of length 2*MAXL containing the
C         components of the Givens rotations used in the QR
C         decomposition of HES.  It is loaded in DHEQR and used in
C         DHELS.
C RL     :OUT      Double Precision RL(N)
C         The residual vector RL.  This is either SB*(B-A*XL) if
C         not preconditioning or preconditioning on the right,
C         or SB*(M-inverse)*(B-A*XL) if preconditioning on the
C         left.
C SNORMW :IN       Double Precision
C         Scale factor.
C PROD   :IN       Double Precision
C         The product s1*s2*...*sl = the product of the sines of the
C         Givens rotations used in the QR factorization of
C         the Hessenberg matrix HES.
C R0NRM  :IN       Double Precision
C         The scaled norm of initial residual R0.
C
C***SEE ALSO  DGMRES
C***ROUTINES CALLED  DCOPY, DSCAL
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910506  Made subsidiary to DGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  DRLCAL
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      DOUBLE PRECISION PROD, R0NRM, SNORMW
      INTEGER KMP, LL, MAXL, N
C     .. Array Arguments ..
      DOUBLE PRECISION Q(*), RL(N), V(N,*)
C     .. Local Scalars ..
      DOUBLE PRECISION C, S, TEM
      INTEGER I, I2, IP1, K, LLM1, LLP1
C     .. External Subroutines ..
      EXTERNAL DCOPY, DSCAL
C***FIRST EXECUTABLE STATEMENT  DRLCAL
      IF (KMP .EQ. MAXL) THEN
C
C         calculate RL.  Start by copying V(*,1) into RL.
C
         CALL DCOPY(N, V(1,1), 1, RL, 1)
         LLM1 = LL - 1
         DO 20 I = 1,LLM1
            IP1 = I + 1
            I2 = I*2
            S = Q(I2)
            C = Q(I2-1)
            DO 10 K = 1,N
               RL(K) = S*RL(K) + C*V(K,IP1)
 10         CONTINUE
 20      CONTINUE
         S = Q(2*LL)
         C = Q(2*LL-1)/SNORMW
         LLP1 = LL + 1
         DO 30 K = 1,N
            RL(K) = S*RL(K) + C*V(K,LLP1)
 30      CONTINUE
      ENDIF
C
C         When KMP < MAXL, RL vector already partially calculated.
C         Scale RL by R0NRM*PROD to obtain the residual RL.
C
      TEM = R0NRM*PROD
      CALL DSCAL(N, TEM, RL, 1)
      RETURN
C------------- LAST LINE OF DRLCAL FOLLOWS ----------------------------
      END
*DECK DRSCO
      SUBROUTINE DRSCO (RSAV, ISAV)
C***BEGIN PROLOGUE  DRSCO
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DDEBDF
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (RSCO-S, DRSCO-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   DRSCO transfers data from arrays to a common block within the
C   integrator package DDEBDF.
C
C***SEE ALSO  DDEBDF
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    DDEBD1
C***REVISION HISTORY  (YYMMDD)
C   820301  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DRSCO
C-----------------------------------------------------------------------
C THIS ROUTINE RESTORES FROM RSAV AND ISAV THE CONTENTS OF COMMON
C BLOCK DDEBD1  , WHICH IS USED INTERNALLY IN THE DDEBDF
C PACKAGE.  THIS PRESUMES THAT RSAV AND ISAV WERE LOADED BY MEANS
C OF SUBROUTINE DSVCO OR THE EQUIVALENT.
C-----------------------------------------------------------------------
C
      INTEGER I, ILS, ISAV, LENILS, LENRLS
      DOUBLE PRECISION RLS, RSAV
      DIMENSION RSAV(*),ISAV(*)
      SAVE LENRLS, LENILS
      COMMON /DDEBD1/ RLS(218),ILS(33)
      DATA LENRLS /218/, LENILS /33/
C
C***FIRST EXECUTABLE STATEMENT  DRSCO
      DO 10 I = 1, LENRLS
         RLS(I) = RSAV(I)
   10 CONTINUE
      DO 20 I = 1, LENILS
         ILS(I) = ISAV(I)
   20 CONTINUE
      RETURN
C     ----------------------- END OF SUBROUTINE DRSCO
C     -----------------------
      END

!  Support file for any Entry Index (Class, Clic, ...). The Entry Index
! provides a short summary of a given observation.
!
subroutine classic_entryindex_read(file,entry_num,data,buf,error)
  use gkernel_interfaces
  use classic_interfaces, except_this=>classic_entryindex_read
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Read an entry in the given file, and return its Entry Index in the
  ! 'data(*)' buffer
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(in)    :: file       !
  integer(kind=entry_length), intent(in)    :: entry_num  ! Entry number
  integer(kind=4),            intent(out)   :: data(*)    !
  type(classic_recordbuf_t),  intent(inout) :: buf        ! Working buffer
  logical,                    intent(inout) :: error      ! Logical errror flag
  ! Local
  integer(kind=data_length) :: lind
  !
  ! Read the record in 'buf'
  call entryindex_readrec(file,entry_num,buf,error)
  if (error)  return
  !
  ! Now fill the 'data' array. NB: recordbuf_read is optimized to avoid
  ! re-reading the buffer if it is already in the 'buf' buffer.
  lind = file%desc%lind
  call recordbuf_read(1_8,lind,data,buf,error)
  if (error)  return
  !
end subroutine classic_entryindex_read
!
subroutine entryindex_new(file,entry_num,full,error)
  use gbl_message
  use classic_interfaces, except_this=>entryindex_new
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  !   Allocate room (i.e. a new extension index), if needed, for the
  ! entry 'entry_num'.
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(inout) :: file       !
  integer(kind=entry_length), intent(in)    :: entry_num  ! Entry number
  logical,                    intent(out)   :: full       ! Index is full?
  logical,                    intent(inout) :: error      ! Logical errror flag
  ! Local
  character(len=*), parameter :: rname='INDEX'
  !
  full = .false.
  if (file%lun.le.0) then
    call classic_message(seve%e,rname,'File not opened')
    error = .true.
    return
  endif
  !
  ! Do we need a new extension?
  if (entry_num.gt.file%desc%lexn(file%desc%nex)) then
    !
    ! Allocate one new Extension in file
    call filedesc_incr(file%lun,file%desc,full,error)
    if (error) return
    !
    ! Check again now that 'nex' has been increased
    if (entry_num.gt.file%desc%lexn(file%desc%nex)) then
      ! More than 1 new extension needed for 1 new entry!? Should never happen!
      call classic_message(seve%e,rname,  &
        'Internal logic error: more than 1 new extension needed for 1 new entry!')
      error = .true.
      return
    endif
  endif
  !
  if (file%desc%version.eq.1 .and. file%desc%nextword.ne.1) then
    ! V1 file: entries must always start at beginning of next available record
    call classic_message(seve%e,rname,  &
      'Internal error: V1 entries must start at beginning of records')
    error = .true.
    return
  endif
  !
end subroutine entryindex_new
!
subroutine classic_entryindex_write(file,entry_num,data,buf,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_entryindex_write
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !   Write the given Entry Index ('data(*)' buffer) for the given entry
  ! in the given file. There must be room already provisioned for the
  ! entry in the Extension Index.
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(in)    :: file       !
  integer(kind=entry_length), intent(in)    :: entry_num  ! Entry number
  integer(kind=4),            intent(in)    :: data(*)    !
  type(classic_recordbuf_t),  intent(inout) :: buf        ! Working buffer
  logical,                    intent(inout) :: error      ! Logical errror flag
  ! Local
  character(len=*), parameter :: rname='INDEX'
  character(len=message_length) :: mess
  integer(kind=data_length) :: lind
  !
  ! Safeguard: ensure that the programmer has allocated a new Extension
  ! Index for this entry (if needed)
  if (entry_num.gt.file%desc%lexn(file%desc%nex)) then
    write(mess,'(A,I0)')  &
      'Programming error: no room allocated for entry index #',entry_num
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! First read the record, which can contain other entry indexes
  call entryindex_readrec(file,entry_num,buf,error)
  if (error)  return
  !
  ! Now write the 'data' array. NB: recordbuf_write is optimized to avoid
  ! re-reading the buffer if it is already in the 'buf' buffer.
  lind = file%desc%lind
  call recordbuf_write(1_8,lind,data,buf,error)
  if (error)  return
  !
  ! Flush the buffer, always, because the whole file must be consistant
  ! in particular if file%desc%xnext has been updated in the file descriptor.
  call recordbuf_close(buf,error)
  if (error)  return
  !
end subroutine classic_entryindex_write
!
subroutine entryindex_readrec(file,entry_num,buf,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>entryindex_readrec
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  !   Read the record where the entry index 'entry_num' starts. Return
  ! this record in the given buffer. This subroutine has 2 goals:
  !  - from 'entry_num' find in which extension the entry is, and in
  !    which record its index is found,
  !  - set up the 'buffer' type correctly i.e. description and buffer.
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(in)    :: file       !
  integer(kind=entry_length), intent(in)    :: entry_num  !
  type(classic_recordbuf_t),  intent(inout) :: buf        !
  logical,                    intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='READ'
  integer(kind=8) :: ken,kb,kbl
  integer(kind=4) :: k
  integer(kind=size_length) :: nex,kex
  character(len=message_length) :: mess
  !
  if (file%lun.le.0) then
    call classic_message(seve%e,rname,'File not opened')
    error = .true.
    return
  endif
  if (entry_num.le.0 .or. entry_num.gt.file%desc%xnext) then
    write(mess,'(A,I0)') 'Wrong index address ',entry_num
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Find kex (the extension where the entry goes).
  if (file%desc%gex.eq.10) then
    ! Linear growth (historical). For efficiency purpose, do not use
    ! the generic code
    kex = (entry_num-1)/file%desc%lex1 + 1
  else
    ! Generic for any extension growth (including gex==10)
    nex = file%desc%nex+1  ! lexn(:) numbering starts at 0!
    call gi8_dicho(nex,file%desc%lexn,entry_num,.true.,kex,error)
    if (error)  return
    kex = kex-1  ! lexn(:) numbering starts at 0!
  endif
  !
  ! Find ken (relative entry number in the extension, starts from 1)
  ken = entry_num - file%desc%lexn(kex-1)
  !
  kb = ((ken-1)*file%desc%lind)/file%desc%reclen  ! In the extension, the
      ! relative record position (as an offset, starts from 0) where the
      ! Entry Index starts. NB: there can be a non-integer number of Entry
      ! Indexes per record
  kbl = file%desc%aex(kex)+kb  ! The absolute record number where the Entry Index goes
  !
  k = mod((ken-1)*file%desc%lind,file%desc%reclen)+1  ! = in the record, the
    ! first word of the Entry Index of the entry number 'entry_num'
  !
  ! Declare the buffer to be used for this index. NB: classic_recordbuf_open
  ! is optimized so that it does not re-read the needed record if it is
  ! already in memory
  call classic_recordbuf_open(file,kbl,k,buf,error)
  if (error)  return
  if (k+file%desc%lind-1.gt.file%desc%reclen) then
    ! This entry index overlaps 2 records. Ensure that recordbuf_read won't
    ! complain.
    buf%nrec = 2
  else
    ! Usually the entry index uses a part of a single record
    buf%nrec = 1
  endif
  !
end subroutine entryindex_readrec
!
subroutine indexaddr_frombuf_v1(data,ind,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_types
  use classic_interfaces, except_this=>indexaddr_frombuf_v1
  !---------------------------------------------------------------------
  ! @ private
  !  Read the Index previously loaded in buf%data, position k
  !  This routine is generic and do not know the details about the
  ! Index, so it reads only the first element: in File Version 1 it
  ! must be the Entry Address coded as an Integer*4 (returned in addr8)
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: data(*)  !
  type(indx_basic_v2_t),    intent(out)   :: ind      !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  integer(kind=4) :: addr4
  !
  call conv%read%i4(data(1),addr4,1)
  !
  ! V1 to V2
  ind%rec = addr4
  ind%word = 1
  !
end subroutine indexaddr_frombuf_v1
!
subroutine indexaddr_frombuf_v2(data,ind,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_types
  use classic_interfaces, except_this=>indexaddr_frombuf_v2
  !---------------------------------------------------------------------
  ! @ private
  !  Read the Index previously loaded in buf%data, position k
  !  This routine is generic and do not know the details about the
  ! Index, so it reads only the 2 first elements: in File Version 2 it
  ! must be the Entry Address (record and word)
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: data(*)  !
  type(indx_basic_v2_t),    intent(out)   :: ind      !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  !
  call conv%read%i8(data(1),ind%rec,1)
  call conv%read%i4(data(3),ind%word,1)
  !
end subroutine indexaddr_frombuf_v2

module imbfits_column_types
  use gbl_message
  use gkernel_types
  use cfitsio_api
  use imbfits_file_type
  !
  public :: imbfits_read_column
  public :: imbfits_dump_column
  private
  !
  interface imbfits_read_column
    module procedure imbfits_read_logi_1d
    module procedure imbfits_read_inte_1d
    module procedure imbfits_read_real_1d
    module procedure imbfits_read_dble_1d
    module procedure imbfits_read_char_1d
    module procedure imbfits_read_dble_2d_into_1d
  end interface imbfits_read_column
  !
  interface imbfits_dump_column
    module procedure imbfits_dump_inte_1d
    module procedure imbfits_dump_real_1d
    module procedure imbfits_dump_dble_1d
    module procedure imbfits_dump_char_1d
    module procedure imbfits_dump_logi_1d
  end interface imbfits_dump_column
  !
contains
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Reading routines (1D)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine imbfits_read_logi_1d(caller,file,key,n,logi,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: n
    type(fits_logi_1d_t), intent(inout) :: logi    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>LOGI>1D'
    integer(kind=4) :: colnum,status
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_logi_1d(key,n,logi,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,logi%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    if (tval.ne.'L' .and. tval.ne.'1L') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ''',trim(key),''' (type ',trim(tval),') in a logical*4 vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,logi%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    call ftgcl(file%unit,colnum,1,1,n,logi%val,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
            'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
  end subroutine imbfits_read_logi_1d
  !
  subroutine imbfits_read_inte_1d(caller,file,key,n,inte,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: n
    type(fits_inte_1d_t), intent(inout) :: inte    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>INTE>1D'
    integer(kind=4) :: colnum,status
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_inte_1d(key,n,inte,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,inte%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    if (tval.ne.'J' .and. tval.ne.'1J') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ',trim(key),' (type ',trim(tval),') in an integer*4 vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,inte%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    anynull = .false.
    call ftgcvj(file%unit,colnum,1,1,n,-1,inte%val,anynull,status)
    if (anynull .or. status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
            'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_errormsg(status)
      endif
      error = .true.
      return
    endif
  end subroutine imbfits_read_inte_1d
  !
  subroutine imbfits_read_real_1d(caller,file,key,n,real,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: n
    type(fits_real_1d_t), intent(inout) :: real    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>REAL>1D'
    integer(kind=4) :: colnum,status
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_real_1d(key,n,real,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,real%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    if (tval.ne.'E' .and. tval.ne.'1E') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*4 vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,real%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    anynull = .false.
    call ftgcve(file%unit,colnum,1,1,n,-1.e0,real%val,anynull,status)
    if (anynull .or. status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
      'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_errormsg(status)
      endif
      error = .true.
      return
    endif
  end subroutine imbfits_read_real_1d
  !
  subroutine imbfits_read_dble_1d(caller,file,key,n,dble,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: n
    type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>DBLE>1D'
    integer(kind=4) :: colnum,status
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_dble_1d(key,n,dble,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,dble%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    if (tval.ne.'D' .and. tval.ne.'1D') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*8 vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,dble%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    anynull = .false.
    call ftgcvd(file%unit,colnum,1,1,n,-1.d0,dble%val,anynull,status)
    if (anynull .or. status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
            'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_errormsg(status)
      endif
      error = .true.
      return
    endif
  end subroutine imbfits_read_dble_1d
  !
  subroutine imbfits_read_char_1d(caller,file,key,n,char,error,default)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)           :: caller
    type(imbfits_file_t), intent(in)           :: file
    character(len=*),     intent(in)           :: key
    integer(kind=4),      intent(in)           :: n
    type(fits_char_1d_t), intent(inout)        :: char    ! INOUT: keep allocation status
    logical,              intent(inout)        :: error
    character(len=*),     intent(in), optional :: default  ! If absent column or NULL values in column
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>CHAR>1D'
    integer(kind=4) :: colnum,status,nc
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    character(len=char1d_length) :: defstring
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_char_1d(key,n,char,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,char%key,colnum,status)
    if (status.gt.0) then
      ! Error, probably no such column
      if (present(default)) then
        char%val(:) = default
        char%comment = 'WARNING! Column not found in table'
        return
        else
        call imbfits_message(seve%e,caller,'Error')
        call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
        call cfitsio_errormsg(status)
        error = .true.
        return
      endif
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    nc = len_trim(tval)
    if (tval(nc:nc).ne.'A') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ',trim(key),' (type ',trim(tval),') in a character vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,char%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    if (present(default)) then
        defstring = default
    else
        defstring = 'NULL'
    endif
    anynull = .false.
    call ftgcvs(file%unit,colnum,1,1,n,defstring,char%val,anynull,status)
    if (anynull .or. status.gt.0) then
      if (status.eq.0 .and. anynull .and. present(default)) then
        ! Caller gave a default in case of undefined values. Not an error
        continue
      else
        call imbfits_message(seve%e,caller,'Error')
        write(mess,'(A,I0,A,A,A,I0)')  &
              'Error while reading column #',colnum,' (',trim(key),'), row #',1
        call imbfits_message(seve%e,rname,mess)
        if (anynull) then
          call imbfits_message(seve%e,rname,'Some null values found')
        else
          call cfitsio_errormsg(status)
        endif
        error = .true.
        return
      endif
    endif
  end subroutine imbfits_read_char_1d
  !
  subroutine imbfits_read_dble_2d_into_1d(caller,file,key,nrow,ncol,dble,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: nrow
    integer(kind=4),      intent(in)    :: ncol
    type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>DBLE>2D>INTO>1D'
    integer(kind=4) :: colnum,status,nelem
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    ! *** JP Next block should be factorized
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_dble_1d(key,nrow*ncol,dble,error)
    if (error)  return
    !
    ! *** JP Next two blocks should be factorized
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,dble%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    ! ZZZ Some clever check here!
    !   if (tval.ne.'E') then
    !     write(mess,'(A,A,A,A,A)')  &
    !       'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*8 array'
    !     call imbfits_message(seve%w,rname,mess)
    !   endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,dble%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    nelem = nrow*ncol
    anynull = .false.
    call ftgcvd(file%unit,colnum,1,1,nelem,-1.d0,dble%val,anynull,status)
    ! *** JP Next block could be factorized
    if (anynull .or. status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
            'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_errormsg(status)
      endif
      error = .true.
      return
    endif
  end subroutine imbfits_read_dble_2d_into_1d
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Dumping routines (1D)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine imbfits_dump_inte_1d(inte,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_inte_1d_t), intent(in)    :: inte
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = inte%key
    call sic_upper(key)
    if (.not.associated(inte%val)) then
      write(olun,100)  key,trim(inte%comment)
    elseif (dofull) then
      write(olun,'(4A,I0)')  &
        trim(key),' (',trim(inte%comment),') is an integer column of dimensions ',inte%n
      call i4_type(inte%n,inte%val)
    elseif (inte%n.ge.3) then
      write(olun,103)  key,inte%val(1),inte%val(inte%n),trim(inte%comment)
    elseif (inte%n.eq.2) then
      write(olun,102)  key,inte%val(1:2),trim(inte%comment)
    else  ! 1 value
      write(olun,101)  key,inte%val(1),trim(inte%comment)
    endif
    !
    100 format(A8,' (I4) = NO DATA ASSOCIATED!',              T64,'/ ',A)
    101 format(A8,' (I4) =',1(1X,I14),                        T64,'/ ',A)
    102 format(A8,' (I4) =',2(1X,I14),                        T64,'/ ',A)
    103 format(A8,' (I4) =',1(1X,I14),'      ...     ',1X,I14,T64,'/ ',A)
  end subroutine imbfits_dump_inte_1d
  !
  subroutine imbfits_dump_real_1d(real,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_real_1d_t), intent(in)    :: real
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = real%key
    call sic_upper(key)
    if (.not.associated(real%val)) then
      write(olun,100)  key,trim(real%comment)
    elseif (dofull) then
      write(olun,'(4A,I0)')  &
        trim(key),' (',trim(real%comment),') is a real column of dimensions ',real%n
      call r4_type(real%n,real%val)
    elseif (real%n.ge.3) then
      write(olun,103)  key,real%val(1),real%val(real%n),trim(real%comment)
    elseif (real%n.eq.2) then
      write(olun,102)  key,real%val(1:2),trim(real%comment)
    else
      write(olun,101)  key,real%val(1),trim(real%comment)
    endif
    !
    ! Single precision floats: precision is 7.22 decimal digits
    100 format(A8,' (R4) = NO DATA ASSOCIATED!',                         T64,'/ ',A)
    101 format(A8,' (R4) =',1(1X,1PG14.7),                               T64,'/ ',A)
    102 format(A8,' (R4) =',2(1X,1PG14.7),                               T64,'/ ',A)
    103 format(A8,' (R4) =',1(1X,1PG14.7),'      ...     ',1(1X,1PG14.7),T64,'/ ',A)
  end subroutine imbfits_dump_real_1d
  !
  subroutine imbfits_dump_dble_1d(dble,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_dble_1d_t), intent(in)    :: dble
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = dble%key
    call sic_upper(key)
    if (.not.associated(dble%val)) then
      write(olun,100)  key,trim(dble%comment)
    elseif (dofull) then
      write(olun,'(4A,I0)')  &
        trim(key),' (',trim(dble%comment),') is a double column of dimensions ',dble%n
      call r8_type(dble%n,dble%val)
    elseif (dble%n.ge.3) then
      write(olun,103)  key,dble%val(1),dble%val(dble%n),trim(dble%comment)
    elseif (dble%n.eq.2) then
      write(olun,102)  key,dble%val(1:2),trim(dble%comment)
    else
      write(olun,101)  key,dble%val(1),trim(dble%comment)
    endif
    !
    ! Double precision floats: precision is 15.95 decimal digits (using
    ! more than 15 digits can make appear roundoff problems because of
    ! precision is not exactly 16).
    100 format(A8,' (R8) = NO DATA ASSOCIATED!',                  T64,'/ ',A)
    101 format(A8,' (R8) =',1(1X,1PG22.15),                       T64,'/ ',A)
    102 format(A8,' (R8) =',2(1X,1PG22.15),                       T64,'/ ',A)
    103 format(A8,' (R8) =',1(1X,1PG22.15),' ... ',1(1X,1PG22.15),T64,'/ ',A)
  end subroutine imbfits_dump_dble_1d
  !
  subroutine imbfits_dump_char_1d(char,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_char_1d_t), intent(in)    :: char
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = char%key
    call sic_upper(key)
    if (.not.associated(char%val)) then
      write(olun,100)  key,trim(char%comment)
    elseif (dofull) then
      write(olun,'(4A,I0,A,I0)')  &
        trim(key),' (',trim(char%comment),') is a character*',len(char%val(1)),' column of dimensions ',char%n
      call ch_type(char%n,char%val,len(char%val(1)))
    elseif (char%n.ge.3) then
      write(olun,103)  key,char%val(1),char%val(char%n),trim(char%comment)
    elseif (char%n.eq.2) then
      write(olun,102)  key,char%val(1:2),trim(char%comment)
    else
      write(olun,101)  key,char%val(1),trim(char%comment)
    endif
    !
    100 format(A8,' (C)  = NO DATA ASSOCIATED!',                 T64,'/ ',A)
    101 format(A8,' (C)  =',1(1X,A14),                           T64,'/ ',A)
    102 format(A8,' (C)  =',2(1X,A14),                           T64,'/ ',A)
    103 format(A8,' (C)  =',1(1X,A14),'      ...     ',1(1X,A14),T64,'/ ',A)
  end subroutine imbfits_dump_char_1d
  !
  subroutine imbfits_dump_logi_1d(logi,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_logi_1d_t), intent(in)    :: logi
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = logi%key
    call sic_upper(key)
    if (.not.associated(logi%val)) then
      write(olun,100)  key,trim(logi%comment)
    elseif (dofull) then
      write(olun,'(4A,I0)')  &
        trim(key),' (',trim(logi%comment),') is a logical column of dimensions ',logi%n
      call l_type(logi%n,logi%val)
    elseif (logi%n.ge.3) then
      write(olun,103)  key,logi%val(1),logi%val(logi%n),trim(logi%comment)
    elseif (logi%n.eq.2) then
      write(olun,102)  key,logi%val(1:2),trim(logi%comment)
    else
      write(olun,101)  key,logi%val(1),trim(logi%comment)
    endif
    !
    100 format(A8,' (L)  = NO DATA ASSOCIATED!',         T64,'/ ',A)
    101 format(A8,' (L)  =',1(1X,L8),                    T64,'/ ',A)
    102 format(A8,' (L)  =',2(1X,L8),                    T64,'/ ',A)
    103 format(A8,' (L)  =',1(1X,L8),'   ...  ',1(1X,L8),T64,'/ ',A)
  end subroutine imbfits_dump_logi_1d
  !
end module imbfits_column_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_primitive_arg
  use cubetools_parameters
  use cubelist_types
  use cubetools_terminal_tool
  use cubesyntax_messaging
  !
  public :: primitive_arg_t,narg_k
  public :: cubetools_primitive_arg_ptr
  private
  !
  integer(kind=4), parameter :: narg_k = 4
  integer(kind=4), parameter :: abst_l = 80
  !
  type, extends(list_object_t) :: primitive_arg_t
     integer(kind=narg_k)          :: inum = code_abs       ! Argument number in option
     character(len=argu_l)         :: name = strg_unk
     character(len=abst_l)         :: abstract = strg_emp   ! One-line abstract help
     character(len=:), allocatable :: help_strg             ! Long/multiline help
     integer(kind=code_k)          :: mandatory = code_arg_mandatory
   contains
     ! General
     procedure :: init  => cubetools_primitive_arg_init
     procedure :: final => cubetools_primitive_arg_final
     !
     ! Registering
     procedure :: put   => cubetools_primitive_arg_put
     !
     ! Printing and Help
     procedure :: print_abstract => cubetools_primitive_arg_abstract  ! ZZZ Should be renamed 'list'
     procedure :: summary        => cubetools_primitive_arg_summary
     procedure :: help           => cubetools_primitive_arg_help
  end type primitive_arg_t
  !
contains
  !
  !---General------------------------------------------------------------
  !
  subroutine cubetools_primitive_arg_init(arg,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_arg_t), intent(out)   :: arg
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARGUMENT>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_primitive_arg_init
  !
  subroutine cubetools_primitive_arg_final(obj,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_arg_t), intent(inout) :: obj
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARGUMENT>FINAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_primitive_arg_final
  !
  function cubetools_primitive_arg_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(primitive_arg_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(primitive_arg_t), pointer :: cubetools_primitive_arg_ptr  ! Function value on return
    class(list_object_t),  pointer       :: tot
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARGUMENT>PTR'
    !
    select type(tot)
    class is (primitive_arg_t)
      cubetools_primitive_arg_ptr => tot
    class default
      cubetools_primitive_arg_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a primitive_arg_t class')
      error = .true.
      return
    end select
  end function cubetools_primitive_arg_ptr
  !
  !---Registering----------------------------------------------------------
  !
  subroutine cubetools_primitive_arg_put(arg,inum,name,abstract,help,mandat,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_arg_t), intent(inout) :: arg
    integer(kind=narg_k),   intent(in)    :: inum
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    integer(kind=code_k),   intent(in)    :: mandat
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARGUMENT>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_primitive_arg_final(arg,error)
    if (error) return
    call cubetools_primitive_arg_init(arg,error)
    if (error) return
    arg%inum      = inum
    arg%name      = name
    arg%abstract  = abstract
    arg%help_strg = help
    arg%mandatory = mandat
  end subroutine cubetools_primitive_arg_put
  !
  !---Printing-and-Help--------------------------------------------------
  !
  subroutine cubetools_primitive_arg_abstract(arg,iarg,error)
    use gkernel_interfaces
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_arg_t), intent(in)    :: arg
    integer(kind=narg_k),   intent(in)    :: iarg
    logical,                intent(inout) :: error
    !
    character(len=mess_l) :: name,mess
    character(len=*), parameter :: rname='ARGUMENT>ABSTRACT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if ((iarg.lt.1).or.(9.lt.iarg)) then
       call cubesyntax_message(seve%e,rname,'Argument number out of authorized range: [1-9]')
       error = .true.
       return
    endif
    name = arg%name
    call sic_upper(name)
    write(mess,'(a1,i1,1x,3a,1x,a)')   &
      '#',iarg,'(',trim(arg_status(arg%mandatory)),')',trim(name)
    mess = '  '//cubetools_format_stdkey_boldval(mess,arg%abstract,terminal%width())
    call cubesyntax_message(syntaxseve%help,rname,mess)
  end subroutine cubetools_primitive_arg_abstract
  !
  subroutine cubetools_primitive_arg_help(arg,error)
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    ! Print option help from arg%help_strg
    !-------------------------------------------------------------------
    class(primitive_arg_t), intent(in)    :: arg
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARGUMENT>HELP'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    if (.not.allocated(arg%help_strg)) return
    if (len_trim(arg%help_strg).le.0) return
    if (arg%help_strg.eq.strg_emp) return
    !
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    call terminal%print_strg(syntaxseve%help,arg%help_strg)
  end subroutine cubetools_primitive_arg_help
  !
  subroutine cubetools_primitive_arg_summary(arg,error)
    !-------------------------------------------------------------------
    ! Short option summary
    !-------------------------------------------------------------------
    class(primitive_arg_t), intent(in)    :: arg
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARGUMENT>SUMMARY'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! No syntax for arguments?
    ! call arg%print_syntax(error)
    ! if (error) return
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    call arg%print_abstract(arg%inum,error)
    if (error) return
    call arg%help(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_primitive_arg_summary
end module cubetools_primitive_arg
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine greg_variables
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_variables
  use greg_contours
  use greg_kernel
  use greg_rg
  use greg_wcs
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  ! Local
  logical :: error
  integer :: dim1
  !
  error = .false.
  !
  dim1 = 0  ! if ndim==0, dim1 is ignored
  call sic_def_inte('NXY',           nxy,     0,dim1,.true., error)
  ! Pen position
  call sic_def_real('X_PEN',         xp,      0,dim1,.true., error)
  call sic_def_real('Y_PEN',         yp,      0,dim1,.true., error)
  ! Page size
  call sic_def_real('PAGE_X',        lx2,     0,dim1,.true., error)
  call sic_def_real('PAGE_Y',        ly2,     0,dim1,.true., error)
  ! Box position
  call sic_def_real('BOX_XMIN',      gx1,     0,dim1,.true., error)
  call sic_def_real('BOX_XMAX',      gx2,     0,dim1,.true., error)
  call sic_def_real('BOX_YMIN',      gy1,     0,dim1,.true., error)
  call sic_def_real('BOX_YMAX',      gy2,     0,dim1,.true., error)
  ! User limits
  call sic_def_dble('USER_XMIN',     gux1,    0,dim1,.true., error)
  call sic_def_dble('USER_XMAX',     gux2,    0,dim1,.true., error)
  call sic_def_dble('USER_YMIN',     guy1,    0,dim1,.true., error)
  call sic_def_dble('USER_YMAX',     guy2,    0,dim1,.true., error)
  ! Projection
  call sic_def_dble('LAMBDA_PROJ',   gproj%a0,   0,dim1,.true., error)
  call sic_def_dble('BETA_PROJ',     gproj%d0,   0,dim1,.true., error)
  call sic_def_dble('ANGLE_PROJ',    gproj%angle,0,dim1,.true., error)
  call sic_def_dble('LAMBDA_MIN',    ramin,      0,dim1,.true., error)
  call sic_def_dble('LAMBDA_MAX',    ramax,      0,dim1,.true., error)
  call sic_def_dble('BETA_MIN',      decmin,     0,dim1,.true., error)
  call sic_def_dble('BETA_MAX',      decmax,     0,dim1,.true., error)
  call sic_def_inte('COORD_SYSTEM',  i_system,   0,dim1,.true., error)
  ! Marker
  call sic_def_inte('MARKER_SIDES',   nsides,  0,dim1,.false.,error)
  call sic_def_inte('MARKER_STYLE',   istyle,  0,dim1,.false.,error)
  call sic_def_real('MARKER_SIZE',    csymb,   0,dim1,.false.,error)
  call sic_def_dble('MARKER_ANGLE',   sangle,  0,dim1,.false.,error)
  call sic_def_real('CHARACTER_SIZE', cdef,    0,dim1,.false.,error)
  call sic_def_dble('CHARACTER_ANGLE',tangle,  0,dim1,.false.,error)
  call sic_def_real('TICK_SIZE',      ctick,   0,dim1,.false.,error)
  ! Levels
  call sic_defstructure('GREG%',.true.,error)
  call sic_def_inte('GREG%NLEVEL',   ncl,     0,dim1,.true.,error)
  ! Units
  call sic_def_inte('U_ANGLE',u_angle, 0,1,.true.,error)
  !
  dim1 = 2
  ! Blanking (cblank and eblank are contiguous in memory)
  call sic_def_dble('BLANKING',      cblank,  1,dim1,.false.,error)
  ! Cursor position (xcurse and ycurse are contiguous in memory)
  call sic_def_real('PHY_CURS',      xcurse,  1,dim1,.false.,error)
  call sic_def_dble('USE_CURS',      ucurse,  1,dim1,.false.,error)
  call sic_def_inte('PIX_CURS',      pixcurse,1,dim1,.false.,error)
  call sic_def_char('CURSOR_CODE',   cursor_code,    .false.,error)
  !
  ! Polygon
  call sic_defstructure('POLY%',.true.,error)
  if (error)  return
  !
  ! Set variables
  call sic_defstructure('SET%',.true.,error)
  call greg_set_structure(error)
  if (error)  return
  !
end subroutine greg_variables
!
subroutine greg_set_structure(error)
  use greg_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Create the structure SET%GREG and fill it.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: struct='SET%GREG'
  !
  call sic_defstructure(struct,.true.,error)
  if (error) return
  !
end subroutine greg_set_structure

module cubedag_object_class
  use cubelist_types
  use cubedag_parameters
  use cubedag_messaging
  !---------------------------------------------------------------------
  ! Abstract base class to be used in cubedag_link_t type. This allows
  ! to break the circular dependency between cubedag_link_t and
  ! cubedag_node_object_t type.
  !---------------------------------------------------------------------
  !
  public :: dag_object_t
  public :: cubedag_object_ptr
  private
  !
  type, abstract, extends(list_object_advanced_t) :: dag_object_t
  contains
    procedure(get_id_interface), deferred :: get_id
  end type dag_object_t
  !
  abstract interface
    function get_id_interface(obj)
      import iden_l,dag_object_t
      integer(kind=iden_l) :: get_id_interface
      class(dag_object_t), intent(in) :: obj
    end function get_id_interface
  end interface
  !
contains
  !
  function cubedag_object_ptr(lot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is a 'dag_object_t', and return a pointer
    ! to it if relevant.
    !-------------------------------------------------------------------
    class(dag_object_t),  pointer :: cubedag_object_ptr  ! Function value on return
    class(list_object_t), pointer       :: lot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBJECT>PTR'
    !
    select type(lot)
    class is (dag_object_t)
      cubedag_object_ptr => lot
    class default
      cubedag_object_ptr => null()
      call cubedag_message(seve%e,rname,'Internal error: object is not a dag_object_t')
      error = .true.
      return
    end select
  end function cubedag_object_ptr
  !
end module cubedag_object_class

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module file_buffers
  use gbl_message
  use gkernel_types, only: mfile_t
  !
  public :: code_save_model
  public :: code_save_uv
  public :: code_save_beam,code_save_dirty,code_save_primary,code_save_fields
  public :: code_save_mask,code_save_support
  public :: code_save_clean,code_save_resid,code_save_cct
  public :: code_save_sky
  !
  public :: readop_t
  !
  public :: file_buffer
  public :: etype,mtype,mtype_read,vtype
  public :: save_data,optimize,rw_optimize
  private
  !
  integer, parameter :: code_save_uv=1
  integer, parameter :: code_save_beam=2
  integer, parameter :: code_save_dirty=3
  integer, parameter :: code_save_clean=4
  integer, parameter :: code_save_primary=5
  integer, parameter :: code_save_resid=6
  integer, parameter :: code_save_mask=7
  integer, parameter :: code_save_support=8
  integer, parameter :: code_save_cct=9
  integer, parameter :: code_save_model=10
  integer, parameter :: code_save_sky=11
  integer, parameter :: code_save_fields=12
  !
  integer(kind=4), parameter :: mtype=13
  integer(kind=4), parameter :: mtype_read=11  ! Command READ can not read FIELDS nor COVERAGE
  character(len=12) :: vtype(1:mtype) = (/ &
       'UV          ',  &
       'BEAM        ',  &
       'DIRTY       ',  &
       'CLEAN       ',  &
       'PRIMARY     ',  &
       'RESIDUAL    ',  &
       'MASK        ',  &
       'SUPPORT     ',  &
       'CCT         ',  &
       'MODEL       ',  &
       'SKY         ',  &
       'FIELDS      ',  &
       'COVERAGE    ' /)   ! Support keyword for SHOW COVERAGE (no associated buffer)
  !
  character(len=12) :: etype(1:mtype) = (/ &
       '.uvt        ',  &
       '.beam       ',  &
       '.lmv        ',  &
       '.lmv-clean  ',  &
       '.lobe       ',  &
       '.lmv-res    ',  &
       '.msk        ',  &
       '.pol        ',  &
       '.cct        ',  &
       '.uvt        ',  &
       '.lmv-sky    ',  &
       '.fields     ',  &
       '.uvt        ' /)   ! Irrelevant for COVERAGE
  !
  character(len=12) :: ctype ! Mapped to the SIC TYPE variable ***JP: Could be confused with the convolution kernel!
  logical :: save_data(mtype)
  !
  ! Read/Write optimization
  type readop_t
     type(mfile_t) :: modif
     integer :: lastnc(2) = 0
     integer :: change = 0
  end type readop_t
  !
  type (readop_t), save :: optimize(mtype)
  integer :: rw_optimize = 0
  !
  type file_buffer_user_t
   contains
     procedure, public :: init   => file_buffer_user_init
     procedure, public :: sicdef => file_buffer_user_sicdef
     procedure, public :: save   => file_buffer_user_save
  end type file_buffer_user_t
  type(file_buffer_user_t) :: file_buffer
  !
contains
  !
  subroutine file_buffer_user_init(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(file_buffer_user_t), intent(out)   :: user
    logical,                   intent(inout) :: error
    !
    integer :: ier
    !
    ctype = ' '
    rw_optimize = 0
    ier = sic_getlog('MAPPING_OPTIMIZE',rw_optimize)
  end subroutine file_buffer_user_init
  !
  subroutine file_buffer_user_sicdef(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(file_buffer_user_t), intent(inout) :: user
    logical,                   intent(inout) :: error
    !
    logical :: warning
    integer(kind=index_length) :: dim(4) = 0
    !
    dim(1) = mtype
    call sic_def_charn('FILE_TYPE',vtype,1,dim,.true.,error)
    if (error) return
    call sic_def_charn('FILE_EXT',etype,1,dim,.false.,error)
    if (error) return
    !
    ! Delete the TYPE variable defined by define.greg and recreate it
    ! such as it maps 'ctype'
    call sic_delvariable('TYPE',.true.,warning)
    if (error) return
    dim(1) = 0
    call sic_def_char('TYPE',ctype,.false.,error)
    if (error) return
    !
    call sic_def_inte('MAPPING_OPTIMIZE',rw_optimize,0,0,.false.,error)
    if (error) return
  end subroutine file_buffer_user_sicdef
  !
  subroutine file_buffer_user_save(user,error)
    use gildas_def
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(file_buffer_user_t), intent(inout) :: user
    logical,                   intent(inout) :: error    
    !
    logical :: do_write,noprompt
    integer :: n,itype
    character(len=filename_length) :: answer
    character(len=filename_length) :: autosave='autosave'  ! Default name when saving
    character(len=commandline_length) line
    character(len=message_length) :: chain
    character(len=*), parameter :: rname='BUFFER>USER>SAVE'
    !
    answer = ' '
    error = .false.
    do_write = .false.
    call gmaster_get_exitnoprompt(noprompt)  ! Check for SIC\EXIT /NOPROMPT
    !
    if (any(save_data) .and. .not.noprompt) then
       call map_message(seve%w,rname,'There are unsaved data, should we save them?')
       do while (.true.)
          call sic_wprn('Y)es, N)o, C)ancel exit (default No): ',answer,n)
          call sic_upper(answer)
          if (answer(1:1).eq.'C') then
             error = .true.
             return
          elseif (answer(1:1).eq.'N' .or. answer(1:1).eq.' ') then
             do_write = .false.
          elseif (answer(1:1).ne.'Y') then
             call map_message(seve%e,rname,'Unrecognized answer '//answer)
             cycle
          else 
             do_write = .true.
          endif
          exit
       enddo
    endif
    !
    call sic_delvariable('DIRTY',.false.,error)
    call sic_delvariable('CLEAN',.false.,error)
    call sic_delvariable('RESIDUAL',.false.,error)
    call sic_delvariable('PRIMARY',.false.,error)
    call sic_delvariable('SKY',.false.,error)
    if (.not.do_write) return
    !
    do itype=1,mtype
       answer = ' '
       error = .false.
       do while (save_data(itype))
          write(chain,100) vtype(itype)
          call sic_wprn(trim(chain)//' ',answer,n)
          if (answer.eq.' ') answer = autosave
          line = 'CLEAN'//char(92)//'WRITE '//vtype(itype)//' "'//trim(answer)//'"'
          call exec_command(line,error)
       enddo
    enddo
    !
100 format('Enter a filename for ',a,' (default ''autosave''): ')
  end subroutine file_buffer_user_save
end module file_buffers
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine spanum_to_greg(string,nchar,doexpo)
  use greg_interfaces, except_this=>spanum_to_greg
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   This subroutine converts a floating point number produced by
  ! SPANUM such as 1.234E+07 or 1.E+12 in a string of characters
  ! allowing usual exponential notation with GREG e.g.
  !                              7
  !     1.2345E+07 -->  1.2345 10
  !
  !                       12
  !     1.E+12  ----->  10
  !
  !                         -8
  !     2.E-08  ----->  2 10
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: string  ! Character string to convert
  integer(kind=4),  intent(inout) :: nchar   ! Length of string
  logical,          intent(in)    :: doexpo  ! Prefer exponential notation when possible?
  ! Local
  character(len=80) :: chain
  logical :: first
  integer :: i,j,n,expo,ival
  real(kind=8) :: value
  character(len=1), parameter :: backslash=char(92)
  !
  i = index(string,'E')
  if (i.eq.0) return
  !
  if (.not.doexpo) then
    ! Analyze if an integer format would do it
    read(string(i+1:nchar),'(I6)') expo
    if (expo.ge.0 .and. expo.lt.6) then ! An integer may fit...
      if (i.le.expo+3) then
        read(string(1:nchar),*) value
        ival = nint(value)
        ! print *,'String ',string(i+1:nchar),'Expo ',expo,' Value ',value,ival
        write(chain,'(I6)') ival
        string = chain
        nchar = 6
        return
      endif
    endif
  endif
  !
  ! mantissa analysis
  if (i.eq.3) then
    if (string(1:2).eq.'1.') then
      chain = '10'//backslash//backslash//'U'
      n = 5
    else
      chain = string(1:1)//' 10'//backslash//backslash//'U'
      n = 7
    endif
  else
    chain = string(1:i-1)//' 10'//backslash//backslash//'U'
    n = 5+i
  endif
  !
  ! Exponant analysis
  first = .true.
  do j=i+1,nchar
    if (string(j:j).eq.'+') cycle
    if (string(j:j).eq.'0' .and. first) cycle
    n = n+1
    chain(n:n) = string(j:j)
    if (string(j:j).ne.'-') first=.false.
  enddo
  !
  ! FIRST indicates no significant exponant (E+00)
  if (first) then
    if (string(i-1:i-1).ne.'.') then
      chain = string(1:i-1)
      n=i-1
    else
      chain = string(1:i-2)
      n=i-2
    endif
  else
    chain(n+1:) = backslash//backslash//'D'
    n = n+3
  endif
  !
  string = chain
  nchar  = n
  if (nchar.gt.len(string)) then
    call greg_message(seve%w,'CONVER','Label too long, truncated')
    nchar=len(string)
  endif
end subroutine spanum_to_greg
!
subroutine gag_cflabh(chrstr,x,w,d,type,short)
  !---------------------------------------------------------------------
  ! @ private
  !  Convert floating point value to a display of the form of the
  ! "Babylonian" ddd mm ss.s, where each field represents a sexagesimal
  ! increment over its successor. The value X must be in the units of
  ! the rightmost field. For instance, X must be in seconds of time for
  ! hours, minutes, seconds
  !
  ! This routine insert the proper labelling in GreG style display.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: chrstr  ! Formatted string
  real(kind=8),     intent(in)  :: x       ! Input number
  integer(kind=4),  intent(out) :: w       ! Length of string
  integer(kind=4),  intent(in)  :: d       ! Number of decimals
  integer(kind=4),  intent(in)  :: type    ! Type of label (None/Hour/Degree)
  logical,          intent(in)  :: short   ! Drop off zero-leading fields?
  ! Local
  real(kind=8) :: y
  integer(kind=4) :: h, m, s, f
  integer(kind=4) :: lh, lm, ls, dd, fd, lt(3), l
  character(len=20) :: th,ts  ! These may be large
  character(len=2) :: tm  ! This one is always 2 digits
  character(len=4) :: hour(3),minu(3),seco(3)
  character(len=1), parameter :: backslash=char(92)
  !
  data hour/' ',' uh','^'/
  data minu/' ',' um',''''/
  data seco/' ',' us','`'/
  data lt/1,3,1/
  !
  if (type.eq.2) then  ! format_sexage_hour
    hour(2)(1:1)=backslash
    minu(2)(1:1)=backslash
    seco(2)(1:1)=backslash
  endif
  !
  y = abs (x)       ! Positive computations
  h = y
  h = h / 3600      ! Hours
  y = y - (3600*h)
  m = y
  m = m / 60        ! Minutes
  y = y - (60*m)
  s = y             ! Seconds
  y = y - s
  dd = max(0,d)
  fd = 10**dd
  f = fd*y + 0.5d0  ! Fraction of seconds
  if (f.ge.fd) then
    f = f - fd
    s = s + 1
  endif
  if (s.gt.59) then
    s = 0
    m = m + 1
  endif
  if (m.gt.59) then
    m = 0
    h = h + 1
  endif
  !
  ! Initialize the output string, format the sign field
  if (x.lt.0.d0) then
    chrstr = '-'
    w = 1
  else
    chrstr = ''
    w = 0
  endif
  !
  ! Format the hours field
  if (h.eq.0) then
    if (short) then
      lh = 0
    else
      th = '00'
      lh = 2
    endif
  else
    lh = ceiling(log10(h+.1))  ! 1<=h<=9 => lh=1
    if (lh.eq.1) then
      write(th,121) h
    elseif (lh.eq.2) then
      write(th,122) h
    elseif (lh.eq.3) then
      write(th,123) h
    elseif (lh.eq.4) then
      write(th,124) h
    else
      write(th,120) h
    endif
  endif
  ! Concatenate
  l = lt(type)
  if (lh.gt.0) then
    if (w.eq.0) then
      chrstr = th(1:lh)//hour(type)(1:l)
      w = lh+l
    else
      chrstr = chrstr(1:w)//th(1:lh)//hour(type)(1:l)
      w = w+lh+l
    endif
  endif
  !
  ! Format the minutes field
  if (short .and. h.eq.0 .and. m.eq.0) then
    lm = 0
  else
    write(tm,112) m
    lm = 2
  endif
  ! Concatenate
  if (lm.gt.0) then
    if (w.eq.0) then
      chrstr = tm(1:lm)//minu(type)(1:l)
      w = lm+l
    else
      chrstr = chrstr(1:w)//tm(1:lm)//minu(type)(1:l)
      w = w+lm+l
    endif
  endif
  !
  ! Format the seconds field
  write(ts,112) s
  ls = 2
  ! Second units
  ts(ls+1:) = seco(type)(1:l)
  ls=ls+l
  ! Add the fraction of seconds
  if (dd.gt.0) then
    ! Add a dot
    ts(ls+1:) = backslash
    ts(ls+2:) = 'b.'
    ls=ls+3
    ! Add the fraction value
    if (dd.eq.1) then
      write(ts(ls+1:),111) f
    elseif (dd.eq.2) then
      write(ts(ls+1:),112) f
    elseif (dd.eq.3) then
      write(ts(ls+1:),113) f
    elseif (dd.eq.4) then
      write(ts(ls+1:),114) f
    else
      write(ts(ls+1:),115) f
      dd = 5
    endif
    ls=ls+dd
  endif
  ! Concatenate
  if (w.eq.0) then
    chrstr = ts(1:ls)
    w = ls
  else
    chrstr = chrstr(1:w)//ts(1:ls)
    w = w+ls
  endif
  !
111 format(i1.1)
112 format(i2.2)
113 format(i3.3)
114 format(i4.4)
115 format(i5.5)
  !
120 format (i10)
121 format (i1)
122 format (i2)
123 format (i3)
124 format (i4)
end subroutine gag_cflabh

program grid_extend
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! TASK  Compute a map from a Sorted Table by Gridding .
  !
  ! Input :
  !	a sorted table, ordered with Y increasing.
  ! Output :
  !	a VLM cube
  !---------------------------------------------------------------------
  ! Global
  character(len=*), parameter :: pname = 'GRID_EXTEND'
  real :: ubias,vbias,ubuff(4096),vbuff(4096)
  common /conv/ ubias,vbias,ubuff,vbuff
  !
  ! Local
  type(gildas) :: x,y
  ! PI is defined with more digits than necessary to avoid losing
  ! the last few bits in the decimal to binary conversion
  real(8), parameter :: pi=3.14159265358979323846d0
  integer :: nx,ny,nc,np,nd,nxmore,nymore
  integer :: ctypx,ctypy, i, ier
  real(4), allocatable :: ipxc(:), ipyc(:)
  real(4), allocatable :: ipw(:), ipra(:,:,:), ipwe(:)
  integer :: xcol,ycol,mcol(2),ocol,lcol,wcol
  real(8) :: xconv(3),yconv(3)
  real :: xmin,xmax,ymin,ymax,xinc,yinc,tole,beam,smooth
  real :: xparm(10),yparm(10),support(2),cell(2),space
  real :: wmax
  logical :: error
  character(len=80) :: table, map_name, name
  character(len=2) :: weight_mode
  character(len=12) :: ctype(5)
  data ctype /'BOX','EXP','SINC','EXP*SINC','SPHEROIDAL'/
  !------------------------------------------------------------------------
  ! Code:
  xconv = 0.d0
  yconv = 0.d0
  call gildas_open
  call gildas_char('TABLE$',table)
  call gildas_char('MAP$',map_name)
  call gildas_inte('XCOL$',xcol,1)
  call gildas_inte('YCOL$',ycol,1)
  call gildas_inte('WCOL$',wcol,1)
  call gildas_inte('MCOL$',mcol,2)
  call gildas_char('WEIGHT_MODE$',weight_mode)
  call gildas_real('TOLE$',tole,1)
  call gildas_real('BEAM$',beam,1)
  call gildas_real('SPACING$',space,1)
  call gildas_close
  xconv(3) = -space
  yconv(3) =  space
  !
  ! Input file
  call gildas_null(y)
  y%loca%read = .false.
  y%gil%form = fmt_r4
  call gdf_read_gildas(y,table,'.tab',error,rank=0,data=.true.)
  if (error) then
    call gagout('F-'//pname//',  Cannot read input file')
    goto 999
  endif
  if (xcol.gt.y%gil%dim(1) .or. ycol.gt.y%gil%dim(1)) then
    write(6,*) 'F-'//pname//',  X or Y column does not exist'
    goto 999
  endif
  nd = y%gil%dim(1)
  np = y%gil%dim(2)
  !
  ! Check order
  allocate (ipw(max(nd,np)), stat=ier)
  if (ier.ne.0) goto 999
  call dosor (y%r1d,nd,np,ipw,ycol)
  !
  ! Compute weights
  call dowei (y%r1d,nd,np,ipw,wcol) 
  !
  ! Compute extrema
  call finsiz (y%r1d,nd,np,xcol,ycol,ipw,   &
     &    xmin,xmax,ymin,ymax)
  !
  ! Find increment if required
  if (xconv(3).eq.0 .or. yconv(3).eq.0) then
    xinc = xmax-xmin
    yinc = ymax-ymin
    call fininc (y%r1d,nd,np,xcol,ycol,ipw,   &
     &      xinc,yinc,tole)
    if (xconv(3).eq.0) xconv(3) = -xinc
    if (yconv(3).eq.0) yconv(3) = +yinc
  endif
  !
  ! Find size
  nx = nint ( (xmax-xmin)/abs(xconv(3))) + 1
  ny = nint ( (ymax-ymin)/abs(yconv(3))) + 1
  nxmore = nint(3*beam/abs(xconv(3)))+1
  nx = nx+2*nxmore
  nymore = nint(3*beam/abs(yconv(3)))+1
  ny = ny+2*nymore
  !
  ! Extend to nearest power of two
  i = 4
  do while(2**i.lt.nx)
    i = i+1
  enddo
  nx = 2**i
  i = 4
  do while(2**i.lt.ny)
    i = i+1
  enddo
  ny = 2**i
  xconv(1) = nx/2+1-(xmin+xmax)/2/xconv(3)
  xconv(2) = 0.0
  yconv(1) = ny/2+1-(ymin+ymax)/2/yconv(3)
  yconv(2) = 0.0
  !
  write(6,*) 'Creating a cube with ',nx,' by ',ny,' pixels'
  write(6,*) 'Increment ',nint(yconv(3)*180*3600/pi)
  !
  ! Warn for big images
  if (nx.gt.4096 .or. ny.ge.4096) then
    write(6,*) 'W-'//pname//',  More than 4096 pixels in X or Y'
    goto 999
  elseif (nx.gt.512 .or. ny.gt.512) then
    write(6,*) 'W-'//pname//',  More than 512 pixels in X or Y'
  endif
  if (mcol(2).eq.0) mcol(2) = nd
  mcol(1) = max(1,min(mcol(1),nd))
  mcol(2) = max(1,min(mcol(2),nd))
  ocol = min(mcol(1),mcol(2))-1
  lcol = max(mcol(1),mcol(2))
  !
  ! Push in stack
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  nc = lcol-ocol
  write(6,*) ' Creating ',nc,' Channels from ',mcol
  !
  ! Compute gridding function
  smooth = beam/4.0
  ctypx = 2
  ctypy = 2
  support(1) = 5*smooth        ! Go far enough...
  support(2) = 5*smooth
  xparm(1) = support(1)/abs(xconv(3))
  yparm(1) = support(2)/abs(yconv(3))
  xparm(2) = smooth/(2*sqrt(log(2.0)))/abs(xconv(3))
  yparm(2) = smooth/(2*sqrt(log(2.0)))/abs(yconv(3))
  xparm(3) = 2
  yparm(3) = 2
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, ubuff, ubias)
  call convfn (ctypy, yparm, vbuff, vbias)
  cell(1) = xconv(3)
  cell(2) = yconv(3)
  !
  ! Create image (in order v l m )
  name = map_name
  call sic_parsef(name,x%file,' ','.vlm')
  write(6,*) 'I-'//pname//',  Creating map file '//trim(x%file)
  x%gil%ndim = 3
  x%gil%dim(1) = nc
  x%gil%dim(2) = nx
  x%gil%dim(3) = ny
  x%gil%dim(4) = 1
  x%gil%ref(1) = y%gil%ref(1)-ocol
  x%gil%val(1) = x%gil%voff
  x%gil%inc(1) = x%gil%vres
  x%gil%convert(:,2) = xconv
  x%gil%convert(:,3) = yconv
  x%gil%coor_words = 6*gdf_maxdims ! Not a table
  x%gil%extr_words = 0             ! extrema not computed
  x%gil%xaxi = 2                   ! Reset projected axis
  x%gil%yaxi = 3                   !
  !
  !
  call gdf_create_image(x,error)
  if (error) then
    call gagout('F-'//pname//',  Cannot create output LMV image')
    goto 999
  endif
  !
  ! Convolve or grid
  allocate (ipxc(nx), ipyc(ny), x%r3d(nc,nx,ny), stat=ier)
  if (ier.ne.0) goto 999
  call docoor (nx,x%gil%ref(2),x%gil%val(2),x%gil%inc(2),ipxc)
  call docoor (ny,x%gil%ref(3),x%gil%val(3),x%gil%inc(3),ipyc)
  !
  ! Get the workspace for intermediate smoothing
  allocate (ipra(nc,nx,ny), ipwe(nx*ny), stat=ier)
  if (ier.ne.0) goto 999
  !
  call doconv (     &
     &    nd,np,    &     ! Number of input points
     &    y%r1d,    &     ! Input Values
     &    xcol,ycol,ocol,   &  ! Pointers to special values
     &    ipw,      &     ! Weights
     &    ipwe,     &     ! Gridded weights
     &    nc,nx,ny, &     ! Cube size
     &    ipra,     &     ! RAW Cube
     &    ipxc,ipyc,&     ! Cube coordinates
     &    support,cell)
  write(6,*) 'I-'//pname//',  Finished gridding'
  !
  ! Compute smoothing function
  ctypx = 2
  ctypy = 2
  xparm(1) = 3*beam/abs(xconv(3))
  yparm(1) = 3*beam/abs(yconv(3))
  xparm(2) = beam/(2*sqrt(log(2.0)))/abs(xconv(3))
  yparm(2) = beam/(2*sqrt(log(2.0)))/abs(yconv(3))
  xparm(3) = 2
  yparm(3) = 2
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, ubuff, ubias)
  call convfn (ctypy, yparm, vbuff, vbias)
  support(1) = 3*beam
  support(2) = 3*beam
  cell(1) = xconv(3)
  cell(2) = yconv(3)
  !
  ! Free input grid and Create output map
  deallocate(y%r1d)
  !
  allocate (x%r3d(nc,nx,ny), stat=ier)
  if (ier.ne.0) goto 999
  !
  ! Smooth
  write(6,*) 'I-'//pname//',  Starting smoothing'
  call dosmoo (     &
     &    ipra,     &    ! RAW gridded Values
     &    ipwe,     &    ! Gridded weights
     &    nc,nx,ny, &        ! Cube size
     &    x%r3d,    &     ! Smoothed Cube
     &    ipxc,ipyc,&   ! Cube coordinates
     &    support,cell)
  write(6,*) 'I-'//pname//',  Finished smoothing'
  !
  ! Get maximum weight
  wmax = maxval (ipwe) 
  !
  ! Multiply by the gaussian truncation and replace by "raw" map.
  call doapod (xmin,xmax,ymin,ymax,tole,beam,   &
     &    nc,nx,ny,x%r1d,ipra,   &
     &    ipxc,ipyc,   &   ! Cube coordinates
     &    ipwe,wmax)
  write(6,*) 'I-'//pname//',  Finished apodizing'
  !
  call gdf_write_data(x,x%r3d,error)
  if (error) goto 999
  call gagout('S-'//pname//',  Successful completion')
  call sysexi(1)
  !
999 call sysexi (fatale)
end program grid_extend
!
subroutine docoor (n,xref,xval,xinc,x)
  integer :: n                      !
  real*8 :: xref                    !
  real*8 :: xval                    !
  real*8 :: xinc                    !
  real :: x(n)                      !
  ! Local
  integer :: i
  do i=1,n
    x(i) = (dble(i)-xref)*xinc+xval
  enddo
end subroutine docoor
!
subroutine doconv (nd,np,visi,jx,jy,jo,we,gwe,   &
     &    nc,nx,ny,map,mapx,mapy,sup,cell)
  integer :: nd                     ! Number of "visibilities"
  integer :: np                     ! number of values
  real :: visi(nd,np)               ! values
  integer :: jx                     ! X coord, Y coord location in VISI
  integer :: jy                     ! X coord, Y coord location in VISI
  integer :: jo                     ! offset for data in VISI
  real :: we(np)                    ! Weights
  integer :: nx                     ! map size
  integer :: ny                     ! map size
  real :: gwe(nx,ny)                ! gridded weights
  integer :: nc                     ! number of channels
  real :: map(nc,nx,ny)             ! gridded values
  real :: mapx(nx)                  ! Coordinates of grid
  real :: mapy(ny)                  ! Coordinates of grid
  real :: sup(2)                    ! Support of convolving function in User Units
  real :: cell(2)                   ! cell size in User Units
  ! Local
  integer :: ifirs,ilast          ! Range to be considered
  integer :: ix,iy,ic,i
  real :: result,weight
  real :: u,v,du,dv,um,up,vm,vp
  !
  ! Loop on Y rows
  ifirs = 1
  do iy=1,ny
    v = mapy(iy)
    vm = v-sup(2)
    vp = v+sup(2)
    !
    ! Optimized dichotomic search, taking into account the fact that
    !	MAPY is an ordered array
    !
    call findr (np,nd,jy,visi,vm,ifirs)
    ilast = ifirs
    call findr (np,nd,jy,visi,vp,ilast)
    ilast = ilast-1
    !
    ! Initialize X column
    do ix=1,nx
      do ic=1,nc
        map(ic,ix,iy) = 0.0
      enddo
    enddo
    do ix=1,nx
      gwe(ix,iy) = 0.0
    enddo
    !
    ! Loop on X cells
    if (ilast.ge.ifirs) then
      do ix=1,nx
        u = mapx(ix)
        um = u-sup(1)
        up = u+sup(1)
        weight = 0.0
        !
        ! Do while in X cell
        do i=ifirs,ilast
          if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
            du = (u-visi(jx,i))/cell(1)
            dv = (v-visi(jy,i))/cell(2)
            call convol (du,dv,result)
            if (result.ne.0.) then
              result = result*we(i)
              weight = weight + result
              do ic=1,nc
                map (ic,ix,iy) = map (ic,ix,iy) +   &
     &                  visi(ic+jo,i)*result
              enddo
            endif
          endif
        enddo
        !
        ! Normalize weight only in cells where some data exists...
        gwe(ix,iy) = weight
        if (weight.ne.0) then
          weight = 1.0/weight
          do ic=1,nc
            map (ic,ix,iy) = map(ic,ix,iy)*weight
          enddo
        endif
      enddo
    endif
  enddo
end subroutine doconv
!
subroutine dosmoo (raw,we,nc,nx,ny,map,mapx,mapy,sup,cell)
  !---------------------------------------------------------------------
  ! Smooth an input data cube in VLM along L and M by convolution
  ! by a gaussian...
  !---------------------------------------------------------------------
  integer :: nc                     ! map size
  integer :: nx                     ! map size
  integer :: ny                     ! map size
  real :: raw(nc,nx,ny)             ! Raw map
  real :: we(nx,ny)                 ! Weights
  real :: map(nc,nx,ny)             ! Smoothed map
  real :: mapx(nx)                  ! Coordinates of grid
  real :: mapy(ny)                  ! Coordinates of grid
  real :: sup(2)                    ! Support of convolving function in User Units
  real :: cell(2)                   ! cell size in User Units
  ! Local
  integer :: yfirs,ylast          ! Range to be considered
  integer :: xfirs,xlast          ! Range to be considered
  integer :: ix,iy,ic
  integer :: jx,jy                ! X coord, Y coord location in RAW
  real :: result,weight
  real :: u,v,du,dv,dx,dy
  !
  dx = abs(mapx(2)-mapx(1))
  dy = abs(mapy(2)-mapy(1))
  !
  ! Loop on Y rows
  do iy=1,ny
    v = mapy(iy)
    yfirs = max(1,nint((iy-sup(2)/dy)))
    ylast = min(ny,nint((iy+sup(2)/dy)))
    !
    ! Initialize X column
    do ix=1,nx
      do ic=1,nc
        map(ic,ix,iy) = 0.0
      enddo
    enddo
    !
    ! Loop on X cells
    if (yfirs.le.ylast) then
      do ix=1,nx
        u = mapx(ix)
        weight = 0.0
        xfirs = max(1,nint(ix-sup(1)/dx))
        xlast = min(nx,nint(ix+sup(1)/dx))
        !
        ! Do while in X cell
        if (xfirs.le.xlast) then
          do jy=yfirs,ylast
            dv = (v-mapy(jy))/cell(2)
            do jx=xfirs,xlast
              du = (u-mapx(jx))/cell(1)
              call convol (du,dv,result)
              ! No weight normalization
              !                       result = result*we(jx,jy)
              if (result.ne.0.0) then
                weight = weight + result
                do ic=1,nc
                  map (ic,ix,iy) = map (ic,ix,iy) +   &
     &                    raw(ic,jx,jy)*result
                enddo
              endif
            enddo
          enddo
          !
          ! Normalize weight only in cells where some data exists...
          if (weight.ne.0) then
            weight = 1.0/weight
            do ic=1,nc
              map (ic,ix,iy) = map(ic,ix,iy)*weight
            enddo
          endif
        endif
      enddo
    endif
  enddo
end subroutine dosmoo
!
subroutine dowei (visi,nd,np,we,iw)
  integer :: nd                     !
  integer :: np                     !
  real :: visi(nd,np)               !
  real :: we(np)                    !
  integer :: iw                     !
  ! Local
  integer :: i
  if (iw.le.0 .or. iw.gt.nd) then
    do i=1,np
      we(i) = 1.0
    enddo
  else
    do i=1,np
      we(i) = visi(iw,i)
    enddo
  endif
end subroutine dowei
!
subroutine findr (nv,nc,ic,xx,xlim,nlim)
  !---------------------------------------------------------------------
  ! GILDAS	Internal routine
  !	Find NLIM such as
  !	 	XX(IC,NLIM-1) < XLIM < XX(IC,NLIM)
  !	for input data ordered, retrieved from memory
  !	Assumes NLIM already preset so that XX(IC,NLIM-1) < XLIM
  !---------------------------------------------------------------------
  integer :: nv                     !
  integer :: nc                     !
  integer :: ic                     !
  real :: xx(nc,nv)                 !
  real :: xlim                      !
  integer :: nlim                   !
  ! Local
  integer :: ninf,nsup,nmid
  !
  if (nlim.gt.nv) return
  if (xx(ic,nlim).gt.xlim) then
    return
  elseif (xx(ic,nv).lt.xlim) then
    nlim = nv+1
    return
  endif
  !
  ninf = nlim
  nsup = nv
  do while(nsup.gt.ninf+1)
    nmid = (nsup + ninf)/2
    if (xx(ic,nmid).lt.xlim) then
      ninf = nmid
    else
      nsup = nmid
    endif
  enddo
  nlim = nsup
end subroutine findr
!
subroutine convol (du,dv,resu)
  real :: du                        !
  real :: dv                        !
  real :: resu                      !
  ! Local
  real :: ubias,vbias,ubuff(4096),vbuff(4096)
  common /conv/ ubias,vbias,ubuff,vbuff
  integer :: iu,iv
  !
  iu = nint(100.0*du+ubias)
  iv = nint(100.0*dv+vbias)
  resu = ubuff(iu)*vbuff(iv)
  if (resu.lt.1e-10) resu = 0.0
end subroutine convol
!
subroutine convfn (type, parm, buffer, bias)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! 	CONVFN computes the convolving functions and stores them in
  !   	the supplied buffer. Values are tabulated every 1/100 cell.
  ! Arguments :
  !	TYPE		I*4	Convolving function type
  ! 	PARM(10)        R*4  	Convolving function parameters.
  !				PARM(1) = radius of support in cells
  !	BUFFER(4096)	R*4  	Work buffer.
  !	BIAS		R*4	Center of convolution
  !---------------------------------------------------------------------
  integer :: type                   !
  real*4 ::  parm(10)               !
  real*4 ::  buffer(4096)           !
  real*4 ::  bias                   !
  ! Local
  integer :: lim, i, im, ialf, ier, ibias
  real*4 ::  pi, p1, p2, u, umax, absu, eta, psi
  data pi /3.1415926536/
  !
  ! Number of rows
  i = max (parm(1) , 1.0)
  i = i * 2 + 1
  lim = i * 100 + 1
  if (lim.gt.1.5*4096) then
    write(6,*) 'E-GRID,  Work buffer insufficient ',lim
    call sysexi(fatale)
  elseif (lim.gt.4096) then
    lim = 4096
    bias = 2049
  else
    bias = 50.0 * i + 1.0
  endif
  umax = parm(1)
  !                                       Check function types.
  goto (100,200,300,400,500) type
  !
  ! Type defaulted or not implemented, use Default = EXP * SINC
  type = 4
  parm(1) = 3.0
  parm(2) = 1.55
  parm(3) = 2.52
  parm(4) = 2.00
  goto 400
  !
  ! Pill box
100 continue
  do i = 1,lim
    u = (i-bias) * 0.01
    absu = abs (u)
    if (absu.lt.umax) then
      buffer(i) = 1.0
    elseif (absu.eq.umax) then
      buffer(i) = 0.5
    else
      buffer(i) = 0.0
    endif
  enddo
  return
  !
  ! Exponential function.
200 continue
  p1 = 1.0 / parm(2)
  do i = 1,lim
    u = (i-bias) * 0.01
    absu = abs (u)
    if (absu.gt.umax) then
      buffer(i) = 0.0
    else
      buffer(i) = exp (-((p1*absu) ** parm(3)))
    endif
  enddo
  return
  !
  ! Sinc function.
300 continue
  p1 = pi / parm(2)
  do i = 1,lim
    u = (i-bias)*0.01
    absu = abs (u)
    if (absu.gt.umax) then
      buffer(i) = 0.0
    elseif (absu.eq.0.0) then
      buffer(i) = 1.0
    else
      buffer(i) = sin (p1*absu) / (p1*absu)
    endif
  enddo
  return
  !
  ! EXP * SINC convolving function
400 continue
  p1 = pi / parm(2)
  p2 = 1.0 / parm(3)
  do i = 1,lim
    ! Cannot see why different from others ?
    !	    u = (i - lim/2 - 1) * 0.01
    u = (i-bias)*0.01
    absu = abs (u)
    if (absu.gt.umax) then
      buffer(i) = 0.0
    elseif (absu.lt.0.01) then
      buffer(i) = 1.0
    else
      buffer(i) = sin(u*p1) / (u*p1) *   &
     &        exp (-((absu * p2) ** parm(4)))
    endif
  enddo
  return
  !
500 continue
  do i = 1,lim
    buffer(i) = 0.0
  enddo
  ialf = 2.0 * parm(2) + 1.1
  im = 2.0 * parm(1) + 0.1
  ialf = max (1, min (5, ialf))
  im = max (4, min (8, im))
  lim = parm(1) * 100.0 + 0.1
  ibias = bias
  do i = 1,lim
    eta = float (i-1) / float (lim-1)
    call sphfn (ialf, im, 0, eta, psi, ier)
    buffer(ibias+i-1) = psi
  enddo
  lim = ibias-1
  do i = 1,lim
    buffer(ibias-i) = buffer(ibias+i)
  enddo
  return
  !
end subroutine convfn
!
subroutine sphfn (ialf, im, iflag, eta, psi, ier)
  !---------------------------------------------------------------------
  !     SPHFN is a subroutine to evaluate rational approximations to se-
  !  lected zero-order spheroidal functions, psi(c,eta), which are, in a
  !  sense defined in VLA Scientific Memorandum No. 132, optimal for
  !  gridding interferometer data.  The approximations are taken from
  !  VLA Computer Memorandum No. 156.  The parameter c is related to the
  !  support width, m, of the convoluting function according to c=
  !  pi*m/2.  The parameter alpha determines a weight function in the
  !  definition of the criterion by which the function is optimal.
  !  SPHFN incorporates approximations to 25 of the spheroidal func-
  !  tions, corresponding to 5 choices of m (4, 5, 6, 7, or 8 cells)
  !  and 5 choices of the weighting exponent (0, 1/2, 1, 3/2, or 2).
  !
  !  Input:
  !    IALF    I*4   Selects the weighting exponent, alpha.  IALF =
  !                  1, 2, 3, 4, and 5 correspond, respectively, to
  !                  alpha = 0, 1/2, 1, 3/2, and 2.
  !    IM      I*4   Selects the support width m, (=IM) and, correspond-
  !                  ingly, the parameter c of the spheroidal function.
  !                  Only the choices 4, 5, 6, 7, and 8 are allowed.
  !    IFLAG   I*4   Chooses whether the spheroidal function itself, or
  !                  its Fourier transform, is to be approximated.  The
  !                  latter is appropriate for gridding, and the former
  !                  for the u-v plane convolution.  The two differ on-
  !                  by a factor (1-eta**2)**alpha.  IFLAG less than or
  !                  equal to zero chooses the function appropriate for
  !                  gridding, and IFLAG positive chooses its F.T.
  !    ETA     R*4   Eta, as the argument of the spheroidal function, is
  !                  a variable which ranges from 0 at the center of the
  !                  convoluting function to 1 at its edge (also from 0
  !                  at the center of the gridding correction function
  !                  to unity at the edge of the map).
  !
  !  Output:
  !    PSI      R*4  The function value which, on entry to the subrou-
  !                  tine, was to have been computed.
  !    IER      I*4  An error flag whose meaning is as follows:
  !                     IER = 0  =>  No evident problem.
  !                           1  =>  IALF is outside the allowed range.
  !                           2  =>  IM is outside of the allowed range.
  !                           3  =>  ETA is larger than 1 in absolute
  !                                     value.
  !                          12  =>  IALF and IM are out of bounds.
  !                          13  =>  IALF and ETA are both illegal.
  !                          23  =>  IM and ETA are both illegal.
  !                         123  =>  IALF, IM, and ETA all are illegal.
  !---------------------------------------------------------------------
  integer*4 :: ialf                 !
  integer*4 :: im                   !
  integer*4 :: iflag                !
  real*4 :: eta                     !
  real*4 :: psi                     !
  integer*4 :: ier                  !
  ! Local
  integer*4 :: j
  real*4 :: alpha(5), eta2, x
  real*4 :: p4(5,5), q4(2,5), p5(7,5), q5(5), p6l(5,5), q6l(2,5)
  real*4 :: p6u(5,5), q6u(2,5), p7l(5,5), q7l(2,5), p7u(5,5)
  real*4 :: q7u(2,5), p8l(6,5), q8l(2,5), p8u(6,5), q8u(2,5)
  data alpha / 0., .5, 1., 1.5, 2. /
  data p4 /   &
     &    1.584774e-2, -1.269612e-1,  2.333851e-1, -1.636744e-1,   &
     &    5.014648e-2,  3.101855e-2, -1.641253e-1,  2.385500e-1,   &
     &    -1.417069e-1,  3.773226e-2,  5.007900e-2, -1.971357e-1,   &
     &    2.363775e-1, -1.215569e-1,  2.853104e-2,  7.201260e-2,   &
     &    -2.251580e-1,  2.293715e-1, -1.038359e-1,  2.174211e-2,   &
     &    9.585932e-2, -2.481381e-1,  2.194469e-1, -8.862132e-2,   &
     &    1.672243e-2 /
  data q4 /   &
     &    4.845581e-1,  7.457381e-2,  4.514531e-1,  6.458640e-2,   &
     &    4.228767e-1,  5.655715e-2,  3.978515e-1,  4.997164e-2,   &
     &    3.756999e-1,  4.448800e-2 /
  data p5 /   &
     &    3.722238e-3, -4.991683e-2,  1.658905e-1, -2.387240e-1,   &
     &    1.877469e-1, -8.159855e-2,  3.051959e-2,  8.182649e-3,   &
     &    -7.325459e-2,  1.945697e-1, -2.396387e-1,  1.667832e-1,   &
     &    -6.620786e-2,  2.224041e-2,  1.466325e-2, -9.858686e-2,   &
     &    2.180684e-1, -2.347118e-1,  1.464354e-1, -5.350728e-2,   &
     &    1.624782e-2,  2.314317e-2, -1.246383e-1,  2.362036e-1,   &
     &    -2.257366e-1,  1.275895e-1, -4.317874e-2,  1.193168e-2,   &
     &    3.346886e-2, -1.503778e-1,  2.492826e-1, -2.142055e-1,   &
     &    1.106482e-1, -3.486024e-2,  8.821107e-3 /
  data q5 /   &
     &    2.418820e-1,  2.291233e-1,  2.177793e-1,  2.075784e-1,   &
     &    1.983358e-1 /
  data p6l /   &
     &    5.613913e-2, -3.019847e-1,  6.256387e-1, -6.324887e-1,   &
     &    3.303194e-1,  6.843713e-2, -3.342119e-1,  6.302307e-1,   &
     &    -5.829747e-1,  2.765700e-1,  8.203343e-2, -3.644705e-1,   &
     &    6.278660e-1, -5.335581e-1,  2.312756e-1,  9.675562e-2,   &
     &    -3.922489e-1,  6.197133e-1, -4.857470e-1,  1.934013e-1,   &
     &    1.124069e-1, -4.172349e-1,  6.069622e-1, -4.405326e-1,   &
     &    1.618978e-1 /
  data q6l /   &
     &    9.077644e-1,  2.535284e-1,  8.626056e-1,  2.291400e-1,   &
     &    8.212018e-1,  2.078043e-1,  7.831755e-1,  1.890848e-1,   &
     &    7.481828e-1,  1.726085e-1 /
  data p6u /   &
     &    8.531865e-4, -1.616105e-2,  6.888533e-2, -1.109391e-1,   &
     &    7.747182e-2,  2.060760e-3, -2.558954e-2,  8.595213e-2,   &
     &    -1.170228e-1,  7.094106e-2,  4.028559e-3, -3.697768e-2,   &
     &    1.021332e-1, -1.201436e-1,  6.412774e-2,  6.887946e-3,   &
     &    -4.994202e-2,  1.168451e-1, -1.207733e-1,  5.744210e-2,   &
     &    1.071895e-2, -6.404749e-2,  1.297386e-1, -1.194208e-1,   &
     &    5.112822e-2 /
  data q6u /   &
     &    1.101270e+0,  3.858544e-1,  1.025431e+0,  3.337648e-1,   &
     &    9.599102e-1,  2.918724e-1,  9.025276e-1,  2.575336e-1,   &
     &    8.517470e-1,  2.289667e-1 /
  data p7l /   &
     &    2.460495e-2, -1.640964e-1,  4.340110e-1, -5.705516e-1,   &
     &    4.418614e-1,  3.070261e-2, -1.879546e-1,  4.565902e-1,   &
     &    -5.544891e-1,  3.892790e-1,  3.770526e-2, -2.121608e-1,   &
     &    4.746423e-1, -5.338058e-1,  3.417026e-1,  4.559398e-2,   &
     &    -2.362670e-1,  4.881998e-1, -5.098448e-1,  2.991635e-1,   &
     &    5.432500e-2, -2.598752e-1,  4.974791e-1, -4.837861e-1,   &
     &    2.614838e-1 /
  data q7l /   &
     &    1.124957e+0,  3.784976e-1,  1.075420e+0,  3.466086e-1,   &
     &    1.029374e+0,  3.181219e-1,  9.865496e-1,  2.926441e-1,   &
     &    9.466891e-1,  2.698218e-1 /
  data p7u /   &
     &    1.924318e-4, -5.044864e-3,  2.979803e-2, -6.660688e-2,   &
     &    6.792268e-2,  5.030909e-4, -8.639332e-3,  4.018472e-2,   &
     &    -7.595456e-2,  6.696215e-2,  1.059406e-3, -1.343605e-2,   &
     &    5.135360e-2, -8.386588e-2,  6.484517e-2,  1.941904e-3,   &
     &    -1.943727e-2,  6.288221e-2, -9.021607e-2,  6.193000e-2,   &
     &    3.224785e-3, -2.657664e-2,  7.438627e-2, -9.500554e-2,   &
     &    5.850884e-2 /
  data q7u /   &
     &    1.450730e+0,  6.578685e-1,  1.353872e+0,  5.724332e-1,   &
     &    1.269924e+0,  5.032139e-1,  1.196177e+0,  4.460948e-1,   &
     &    1.130719e+0,  3.982785e-1 /
  data p8l /   &
     &    1.378030e-2, -1.097846e-1,  3.625283e-1, -6.522477e-1,   &
     &    6.684458e-1, -4.703556e-1,  1.721632e-2, -1.274981e-1,   &
     &    3.917226e-1, -6.562264e-1,  6.305859e-1, -4.067119e-1,   &
     &    2.121871e-2, -1.461891e-1,  4.185427e-1, -6.543539e-1,   &
     &    5.904660e-1, -3.507098e-1,  2.580565e-2, -1.656048e-1,   &
     &    4.426283e-1, -6.473472e-1,  5.494752e-1, -3.018936e-1,   &
     &    3.098251e-2, -1.854823e-1,  4.637398e-1, -6.359482e-1,   &
     &    5.086794e-1, -2.595588e-1 /
  data q8l /   &
     &    1.076975e+0,  3.394154e-1,  1.036132e+0,  3.145673e-1,   &
     &    9.978025e-1,  2.920529e-1,  9.617584e-1,  2.715949e-1,   &
     &    9.278774e-1,  2.530051e-1 /
  data p8u /   &
     &    4.290460e-5, -1.508077e-3,  1.233763e-2, -4.091270e-2,   &
     &    6.547454e-2, -5.664203e-2,  1.201008e-4, -2.778372e-3,   &
     &    1.797999e-2, -5.055048e-2,  7.125083e-2, -5.469912e-2,   &
     &    2.698511e-4, -4.628815e-3,  2.470890e-2, -6.017759e-2,   &
     &    7.566434e-2, -5.202678e-2,  5.259595e-4, -7.144198e-3,   &
     &    3.238633e-2, -6.946769e-2,  7.873067e-2, -4.889490e-2,   &
     &    9.255826e-4, -1.038126e-2,  4.083176e-2, -7.815954e-2,   &
     &    8.054087e-2, -4.552077e-2 /
  data q8u /   &
     &    1.379457e+0,  5.786953e-1,  1.300303e+0,  5.135748e-1,   &
     &    1.230436e+0,  4.593779e-1,  1.168075e+0,  4.135871e-1,   &
     &    1.111893e+0,  3.744076e-1 /
  !
  ! Code
  ier = 0
  if (ialf.lt.1 .or. ialf.gt.5) ier = 1
  if (im.lt.4 .or. im.gt.8) ier = 2+10*ier
  if (abs(eta).gt.1.) ier = 3+10*ier
  if (ier.ne.0) then
    write(6,*) 'E-SPHEROIDAL,  Error ',ier
    return
  endif
  eta2 = eta**2
  j = ialf
  !
  ! Support width = 4 cells:
  if (im.eq.4) then
    x = eta2-1.
    psi = (p4(1,j)+x*(p4(2,j)+x*(p4(3,j)+x*(p4(4,j)+x*p4(5,j)))))   &
     &      / (1.+x*(q4(1,j)+x*q4(2,j)))
    !
    ! Support width = 5 cells:
  elseif (im.eq.5) then
    x = eta2-1.
    psi = (p5(1,j)+x*(p5(2,j)+x*(p5(3,j)+x*(p5(4,j)+x*(p5(5,j)   &
     &      +x*(p5(6,j)+x*p5(7,j)))))))   &
     &      / (1.+x*q5(j))
    !
    ! Support width = 6 cells:
  elseif (im.eq.6) then
    if (abs(eta).le..75) then
      x = eta2-.5625
      psi = (p6l(1,j)+x*(p6l(2,j)+x*(p6l(3,j)+x*(p6l(4,j)   &
     &        +x*p6l(5,j))))) / (1.+x*(q6l(1,j)+x*q6l(2,j)))
    else
      x = eta2-1.
      psi = (p6u(1,j)+x*(p6u(2,j)+x*(p6u(3,j)+x*(p6u(4,j)   &
     &        +x*p6u(5,j))))) / (1.+x*(q6u(1,j)+x*q6u(2,j)))
    endif
    !
    ! Support width = 7 cells:
  elseif (im.eq.7) then
    if (abs(eta).le..775) then
      x = eta2-.600625
      psi = (p7l(1,j)+x*(p7l(2,j)+x*(p7l(3,j)+x*(p7l(4,j)   &
     &        +x*p7l(5,j))))) / (1.+x*(q7l(1,j)+x*q7l(2,j)))
    else
      x = eta2-1.
      psi = (p7u(1,j)+x*(p7u(2,j)+x*(p7u(3,j)+x*(p7u(4,j)   &
     &        +x*p7u(5,j))))) / (1.+x*(q7u(1,j)+x*q7u(2,j)))
    endif
    !
    ! Support width = 8 cells:
  elseif (im.eq.8) then
    if (abs(eta).le..775) then
      x = eta2-.600625
      psi = (p8l(1,j)+x*(p8l(2,j)+x*(p8l(3,j)+x*(p8l(4,j)   &
     &        +x*(p8l(5,j)+x*p8l(6,j)))))) / (1.+x*(q8l(1,j)+x*q8l(2,j)))
    else
      x = eta2-1.
      psi = (p8u(1,j)+x*(p8u(2,j)+x*(p8u(3,j)+x*(p8u(4,j)   &
     &        +x*(p8u(5,j)+x*p8u(6,j)))))) / (1.+x*(q8u(1,j)+x*q8u(2,j)))
    endif
  endif
  !
  ! Normal return:
  if (iflag.gt.0 .or. ialf.eq.1 .or. eta.eq.0.) return
  if (abs(eta).eq.1.) then
    psi = 0.0
  else
    psi = (1.-eta2)**alpha(ialf)*psi
  endif
end subroutine sphfn
!
subroutine grdflt (ctypx, ctypy, xparm, yparm)
  !---------------------------------------------------------------------
  !     GRDFLT determines default parameters for the convolution functions
  !     If no convolving type is chosen, an Spheroidal is picked.
  !     Otherwise any unspecified values ( = 0.0) will be set to some
  !     value.
  ! Arguments:
  !     CTYPX,CTYPY           I  Convolution types for X and Y direction
  !                                1 = pill box
  !                                2 = exponential
  !                                3 = sinc
  !                                4 = expontntial * sinc
  !                                5 = spheroidal function
  !     XPARM(10),YPARM(10)   R*4  Parameters for the convolution fns.
  !                                (1) = support radius (cells)
  !---------------------------------------------------------------------
  integer :: ctypx                  !
  integer :: ctypy                  !
  real*4 ::    xparm(10)            !
  real*4 ::    yparm(10)            !
  ! Local
  character(len=12) :: chtyps(5)
  integer :: numprm(5), i, k
  data numprm /1, 3, 2, 4, 2/
  data chtyps /'Pillbox','Exponential','Sin(X)/(X)',   &
     &    'Exp*Sinc','Spheroidal'/
  !
  ! Default = type 5
  if ((ctypx.le.0) .or. (ctypx.gt.5)) ctypx = 5
  goto (110,120,130,140,150) ctypx
  !
  ! Pillbox
110 continue
  if (xparm(1).le.0.0) xparm(1) = 0.5
  go to 500
  ! Exponential.
120 continue
  if (xparm(1).le.0.0) xparm(1) = 3.0
  if (xparm(2).le.0.0) xparm(2) = 1.00
  if (xparm(3).le.0.0) xparm(3) = 2.00
  go to 500
  ! Sinc.
130 continue
  if (xparm(1).le.0.0) xparm(1) = 3.0
  if (xparm(2).le.0.0) xparm(2) = 1.14
  go to 500
  ! Exponential * sinc
140 continue
  if (xparm(1).le.0.0) xparm(1) = 3.0
  if (xparm(2).le.0.0) xparm(2) = 1.55
  if (xparm(3).le.0.0) xparm(3) = 2.52
  if (xparm(4).le.0.0) xparm(4) = 2.00
  go to 500
  ! Spheroidal function
150 continue
  if (xparm(1).le.0.0) xparm(1) = 3.0
  if (xparm(2).le.0.0) xparm(2) = 1.0
  go to 500
  !
  ! Put default cheking here for further function types
500 continue
  ! Check Y convolution defaults
  if ((ctypy.gt.0) .and. (ctypy.le.5)) go to (610,620,630,   &
     &    640,650) ctypy
  ! Use X values
  ctypy = ctypx
  do i = 1,10
    yparm(i) = xparm(i)
  enddo
  goto 900
  ! Pillbox
610 continue
  if (yparm(1).le.0.0) yparm(1) = 0.5
  go to 900
  ! Exponential
620 continue
  if (yparm(1).le.0.0) yparm(1) = 3.0
  if (yparm(2).le.0.0) yparm(2) = 1.0
  if (yparm(3).le.0.0) yparm(3) = 2.0
  go to 900
  ! Sinc
630 continue
  if (yparm(1).le.0.0) yparm(1) = 3.0
  if (yparm(2).le.0.0) yparm(2) = 1.14
  go to 900
  ! Exponential * sinc
640 continue
  if (yparm(1).le.0.0) yparm(1) = 3.0
  if (yparm(2).le.0.0) yparm(2) = 1.55
  if (yparm(3).le.0.0) yparm(3) = 2.52
  if (yparm(4).le.0.0) yparm(4) = 2.00
  go to 900
  ! Spheroidal function
650 continue
  if (yparm(1).le.0.0) yparm(1) = 3.0
  if (yparm(2).le.0.0) yparm(2) = 1.0
  go to 900
  !
  ! Put default checking for new types here.
  ! Print parameters chosen.
900 continue
  write(6,1001) 'X',chtyps(ctypx),(xparm(k),k=1,numprm(ctypx))
  write(6,1001) 'Y',chtyps(ctypy),(yparm(k),k=1,numprm(ctypy))
1001 format(1x,a,' Convolution ',a,' Par.=',5f8.4)
end subroutine grdflt
!
subroutine finsiz (x,nd,np,ix,iy,we,xmin,xmax,ymin,ymax)
  integer :: nd                     !
  integer :: np                     !
  real :: x(nd,np)                  !
  integer :: ix                     !
  integer :: iy                     !
  real :: we(np)                    !
  real :: xmin                      !
  real :: xmax                      !
  real :: ymin                      !
  real :: ymax                      !
  ! Local
  integer :: i,j
  !
  i = 1
  do while (we(i).eq.0)
    i = i+1
  enddo
  xmin = x(ix,i)
  xmax = x(ix,i)
  ymin = x(iy,i)
  i = i+1
  do j=i,np
    if (we(j).ne.0) then
      if (x(ix,j).lt.xmin) then
        xmin = x(ix,j)
      elseif (x(ix,j).gt.xmax) then
        xmax = x(ix,j)
      endif
    endif
  enddo
  i = np
  do while (we(i).eq.0)
    i = i-1
  enddo
  ymax = x(iy,i)
end subroutine finsiz
!
subroutine finsiy (x,nd,np,iy,we,ymin,ymax)
  integer :: nd                     !
  integer :: np                     !
  real :: x(nd,np)                  !
  integer :: iy                     !
  real :: we(np)                    !
  real :: ymin                      !
  real :: ymax                      !
  ! Local
  integer :: i
  !
  i = 1
  do while (we(i).eq.0)
    i = i+1
  enddo
  ymin = x(iy,i)
  i = np
  do while (we(i).eq.0)
    i = i-1
  enddo
  ymax = x(iy,i)
end subroutine finsiy
!
subroutine fininc (x,nd,np,ix,iy,we,xinc,yinc,tole)
  integer :: nd                     !
  integer :: np                     !
  real :: x(nd,np)                  !
  integer :: ix                     !
  integer :: iy                     !
  real :: we(np)                    !
  real :: xinc                      !
  real :: yinc                      !
  real :: tole                      !
  ! Local
  integer :: i,j
  real :: dist
  !
  do i=1,np-1
    if (we(i).ne.0) then
      do j=i+1,np
        if (we(j).ne.0) then
          dist = abs(x(ix,j)-x(ix,i))
          if (dist.gt.tole .and. dist.lt.xinc) xinc = dist
          dist = x(iy,j)-x(iy,i)
          if (dist.gt.tole .and. dist.lt.yinc) yinc = dist
        endif
      enddo
    endif
  enddo
end subroutine fininc
!
subroutine dosor  (visi,nd,np,we,iy)
  use gkernel_interfaces
  use gildas_def
  integer :: nd                     !
  integer :: np                     !
  real :: visi(nd,np)               !
  real :: we(nd)                    !
  integer :: iy                     !
  ! Global
  integer :: trione
  ! Local
  integer :: i,ier
  do i=1,np-1
    if (visi(iy,i).gt.visi(iy,i+1)) then
      write(6,*) 'I-GRID,  Sorting input table'
      ier = trione (visi,nd,np,iy,we)
      if (ier.ne.1) call sysexi (fatale)
      return
    endif
  enddo
end subroutine dosor
!
function trione (x,nd,n,ix,work)
  !---------------------------------------------------------------------
  ! 	Sorting program that uses a quicksort algorithm.
  !	Sort on one row
  !	X	R*4(*)	Unsorted array				Input
  !	ND	I	First dimension of X 			Input
  !	N	I	Second dimension of X			Input
  !	IX	I	X(IX,*) is the key for sorting		Input
  !	WORK	R*4(ND)	Work space for exchange			Input
  !---------------------------------------------------------------------
  integer :: trione                 !
  integer :: nd                     !
  integer :: n                      !
  real*4 :: x(nd,n)                 !
  integer :: ix                     !
  real*4 :: work(nd)                !
  ! Local
  integer :: maxstack,nstop
  parameter (maxstack=1000,nstop=15)
  integer*4 :: i, j, k, l1, r1
  integer*4 :: l, r, m, lstack(maxstack), rstack(maxstack), sp
  real*4 :: key
  logical :: mgtl, lgtr, rgtm
  !
  trione = 1
  if (n.le.nstop) goto 50
  sp = 0
  sp = sp + 1
  lstack(sp) = 1
  rstack(sp) = n
  !
  ! Sort a subrecord off the stack
  ! Set KEY = median of X(L), X(M), X(R)
  ! No! This is not reasonable, as systematic very inequal partitioning will
  ! occur in some cases (especially for nearly already sorted files)
  ! To fix this problem, I found (but I cannot prove it) that it is best to
  ! select the estimation of the median value from intermediate records. P.V.
1 l = lstack(sp)
  r = rstack(sp)
  sp = sp - 1
  m = (l + r) / 2
  l1=(2*l+r)/3
  r1=(l+2*r)/3
  !
  mgtl = x(ix,m) .gt. x(ix,l)
  rgtm = x(ix,r) .gt. x(ix,m)
  !
  ! Algorithm to select the median key. The original one from MONGO
  ! was completely wrong. P. Valiron, 24-Jan-84 .
  !
  !		   	MGTL	RGTM	LGTR	MGTL.EQV.LGTR	MEDIAN_KEY
  !
  !	KL < KM < KR	T	T	*	*		KM
  !	KL > KM > KR	F	F	*	*		KM
  !
  !	KL < KM > KR	T	F	F	F		KR
  !	KL < KM > KR	T	F	T	T		KL
  !
  !	KL > KM < KR	F	T	F	T		KL
  !	KL > KM < KR	F	T	T	F		KR
  !
  if (mgtl .eqv. rgtm) then
    key = x(ix,m)
  else
    lgtr = x(ix,l) .gt. x(ix,r)
    if (mgtl .eqv. lgtr) then
      key = x(ix,l)
    else
      key = x(ix,r)
    endif
  endif
  i = l
  j = r
  !
  ! Find a big record on the left
10 if (x(ix,i).ge.key) goto 11
  i = i + 1
  goto 10
11 continue
  ! Find a small record on the right
20 if (x(ix,j).le.key) goto 21
  j = j - 1
  goto 20
21 continue
  if (i.ge.j) goto 2
  !
  ! Exchange records
  call r4tor4 (x(1,i),work,nd)
  call r4tor4 (x(1,j),x(1,i),nd)
  call r4tor4 (work,x(1,j),nd)
  i = i + 1
  j = j - 1
  goto 10
  !
  ! Subfile is partitioned into two halves, left .le. right
  ! Push the two halves on the stack
2 continue
  if (j-l+1 .gt. nstop) then
    sp = sp + 1
    if (sp.gt.maxstack) then
      write(6,*) 'E-SORT,  Stack overflow ',sp
      trione = 0
      return
    endif
    lstack(sp) = l
    rstack(sp) = j
  endif
  if (r-j .gt. nstop) then
    sp = sp + 1
    if (sp.gt.maxstack) then
      write(6,*) 'E-SORT,  Stack overflow ',sp
      trione = 0
      return
    endif
    lstack(sp) = j+1
    rstack(sp) = r
  endif
  !
  ! Anything left to process?
  if (sp.gt.0) goto 1
  !
50 continue
  !
  do j=n-1,1,-1
    k = j
    do i = j+1,n
      if (x(ix,j).le.x(ix,i)) exit ! I
      k = i
    enddo
    if (k.eq.j) cycle          ! J
    call r4tor4 (x(1,j),work,nd)
    do i = j+1,k
      call r4tor4 (x(1,i),x(1,i-1),nd)
    enddo
    call r4tor4 (work,x(1,k),nd)
  enddo                        ! J
end function trione
!
subroutine doapod (xmin,xmax,ymin,ymax,tole,beam,   &
     &    nc,nx,ny,map,raw,mapx,mapy, weight,wmax)
  real :: xmin                      !
  real :: xmax                      !
  real :: ymin                      !
  real :: ymax                      !
  real :: tole                      !
  real :: beam                      !
  integer :: nc                     !
  integer :: nx                     !
  integer :: ny                     !
  real :: map(nc,nx,ny)             !
  real :: raw(nc,nx,ny)             !
  real :: mapx(nx)                  !
  real :: mapy(ny)                  !
  real :: weight(nx,ny)             !
  real :: wmax                      !
  ! Local
  integer :: ic,ix,iy
  real :: lobe,apod,disty,distx,pi,wmin
  wmin = 0.02 * wmax
  !
  pi = acos(-1.0)
  write(6,*) 'Min-Max ',xmin,xmax,ymin,ymax
  write(6,*) 'Beam et Inc ',beam*180*3600/pi,tole*180*3600/pi   &
     &    ,(mapx(1)-mapx(2))*180*3600/pi
  ! Use a beam size twice larger
  lobe = log(2.0)/beam**2
  do iy=1,ny
    if (mapy(iy).le.ymin-tole) then
      disty = ymin-mapy(iy)
    elseif (mapy(iy).ge.ymax+tole) then
      disty = mapy(iy)-ymax
    else
      disty = 0.0
    endif
    do ix=1,nx
      if (mapx(ix).le.xmin-tole) then
        distx = xmin-mapx(ix)
      elseif (mapx(ix).ge.xmax+tole) then
        distx = mapx(ix)-xmax
      else
        distx = 0.0
      endif
      apod = (distx**2+disty**2)*lobe
      if (apod.ne.0.0) then
        apod = exp(-apod)
        do ic=1,nc
          map(ic,ix,iy) = map(ic,ix,iy)*apod
        enddo
      else
        if (weight(ix,iy).gt.wmin) then
          do ic=1,nc
            map(ic,ix,iy) = raw(ic,ix,iy)
          enddo
        endif
      endif
    enddo
  enddo
end subroutine doapod
!
function maxvec(a,n)
  real :: maxvec                    !
  real :: a(*)                      !
  integer :: n                      !
  ! Local
  real :: r
  integer :: i
  !
  r = 0.0
  do i =1,n
    r = max(r,a(i))
  enddo
  maxvec = r
end function maxvec

subroutine clic_clone(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! Command COPY = MODIFY NOTHING
  !     well not so simple
  ! COPY DATA|HEADERS [ANT | NOANT] [BASE | NOBASE]
  ! 1:
  !     DATA     data and headers are copied
  !     HEADERS  headers only
  ! 2 and/or 3:
  !     ANT      Antenna calibration section created
  !     BASE     Baseline calibration section created
  !     NOANT    Antenna calibration sections  NOT created
  !     NOBASE   Baseline calibration sections NOT created
  ! otherwise sections are copied if and only if present.
  ! default is "ANT"
  ! Bure copy Job does "NOANT NOBASE"
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_number.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: end, check
  integer(kind=address_length) :: data_in, ip_data
  integer(kind=address_length) :: addrnewdata, ipnewdata
  integer(kind=data_length) :: ndata, mnewdata, nnewdata
  integer :: i, t_nant
  integer :: l, ipol
  integer :: t_nbas, t_ldpar, t_ldump, t_ldatl, t_ldatc, j
  real*8 :: theta, r, rmin
  character(len=80) :: chain
  character(len=7) :: done
  logical :: do_write_saved, acopy, askip
  integer :: mvoc1, mvoc2
  parameter (mvoc1=4, mvoc2=5)
  character(len=12) :: voc1(mvoc1), voc2(mvoc2)
  save addrnewdata, mnewdata
  data voc1/'HEADERS','NOHEADERS','DATA','NODATA'/
  data voc2/'ANTENNA','NOANTENNA','BASELINE','NOBASELINE','NOCHECK'/
  data mnewdata/0/
  !------------------------------------------------------------------------
  ! Code:
  do_write_saved = do_write_data
  ! input needed:  number of antennas and their positions
  !     ARGUM = 'HEADERS'
  !     CALL CLIC_KW(LINE,0,1,ARGUM,NARG,VOC1,MVOC1,.TRUE.,ERROR)
  t_nant = mnant
  call sic_i4(line,0,1,t_nant,.false.,error)
  if (error) return
  do_write_data = .true.
  acopy = .true.
  askip = .false.
  check = .true.
  !
  call check_input_file(error)
  if (error) goto 99
  call check_index(error)
  if (error) goto 99
  call check_output_file(error)
  if (error) goto 99
  call check_different_file(error)
  if (error) goto 99
  call show_general('MODEL',.false.,line,error)
  if (error) goto 99
  !
  ! Loop on current index
call get_first(.true.,error)
  if (error) goto 99
  end = .false.
  do while (.not.end)
    ! Get storage and data
    call get_data (ndata,data_in,error)
    if (error) goto 99
    ip_data = gag_pointer(data_in,memory)
    !         print *, 'GET_DATA , ndata , ip_data ', ndata ,ip_data
    ! this is the only reason to acess tha data itself.
    ! Only needed for data older than 11 feb 1997.
    ! Sould be tested.
    ! For time consistency
    r_ut = dh_utc*2*pi/86400.
    r_dobs = dh_obs
    !
    ! Reserve space for ANTENNA based sections only by default.
    r_bpcdeg = 20
    r_abpcdeg = 20
    r_icdeg = 3
    r_aicdeg = 3
    r_presec(bpcal_sec) = .false.
    r_presec(ical_sec) =  .false.
    r_presec(abpcal_sec) =  .true.
    r_presec(aical_sec) =  .true.
    !
    ! Fill in header variables r_xxx:
    t_nbas = max(t_nant*(t_nant-1)/2,1)
    do i=1, t_nbas
      r_iant(i) = antbas(1,i)
      r_jant(i) = antbas(2,i)
    enddo
    t_ldpar = 21 + 27*t_nant + 11*t_nbas
    if (r_lmode.eq.2) then
      t_ldatc = r_nband*t_nant
      t_ldatl = r_lntch*t_nant
    elseif (r_lmode.eq.1) then
      t_ldatc = 2*r_nband*r_nsb*t_nbas
      t_ldatl = 2*r_lntch*r_lnsb*t_nbas
    endif
    !         print *, 'r_ndump, r_ldpar, r_ldump, r_ldatc, r_ldatl'
    !         print *, r_ndump, r_ldpar, r_ldump, r_ldatc, r_ldatl
    t_ldump = t_ldpar+t_ldatc
    !         print *, 'r_ndump, t_ldpar, t_ldump, t_ldatc, t_ldatl'
    !         print *, r_ndump, t_ldpar, t_ldump, t_ldatc, t_ldatl
    !
    ! new coordinates for all antennas
    ! minimum distance is 24 meters.
    !
    do i = 1, t_nant
      rmin = 0.
      do while (rmin.lt.24)
        r_istat(i) = 100+i
        r = min(s_noise(50.),150.)
        theta = s_random(2.*pis)
        r_ant(1,i) = -r*cos(theta)*sin(44.63389d0)
        r_ant(2,i) =  r*sin(theta)
        r_ant(3,i) =  r*cos(theta)*cos(44.63389d0)
        if (i.gt.1) then
          rmin = 9999.
          do j = 1, i-1
            r = sqrt((r_ant(1,i)-r_ant(1,j))**2   &
              + (r_ant(2,i)-r_ant(2,j))**2   &
              + (r_ant(3,i)-r_ant(3,j))**2)
            rmin = min(rmin,r)
          enddo
        else
          rmin = 9999.
        endif
      enddo
    enddo
    do i=1, t_nbas
      do l=1, 3
        r_bas(l,i) = r_ant(l,r_jant(i)) - r_ant(l,r_iant(i))
      enddo
    enddo
    ! new antennas:
    do i = r_nant+1, t_nant
      j = mod(i-1,r_nant)+1
      r_kant(i) = i            !r_kant(j)
      r_kent(i) = i            !r_kent(j)
      r_axes(i) = r_axes(j)
      r_phlo1(i) = r_phlo1(j)
      r_phlo3(i) = r_phlo3(j)
      do l=1, r_lband
        r_lilevu(l,i) = r_lilevu(l,j)
        r_lilevl(l,i) = r_lilevl(l,j)
        r_ldeloff(i,l) = r_ldeloff(j,l)
      enddo
      r_mobil(i) = r_mobil(j)
      r_collaz(i) = r_collaz(j)
      r_collel(i) = r_collel(j)
      r_corfoc(i) = r_corfoc(j)
      do ipol =1, r_npol_rec
        r_h2omm(ipol,i) = r_h2omm(ipol,j)  !! R_CORFOC(J)
        r_tatms(ipol,i) = r_tatms( ipol,j)
        r_tatmi(ipol,i) = r_tatmi(ipol,j)
        r_taus(ipol,i) = r_taus(ipol,j)
        r_taui(ipol,i) = r_taui(ipol,j)
        r_beef(ipol,i) = r_beef(ipol,j)
        r_feff(ipol,i) = r_feff(ipol,j)
        r_tchop(ipol,i) = r_tchop(ipol,j)
        r_tcold(ipol,i) = r_tcold(ipol,j)
        r_trec(ipol,i) = r_trec(ipol,j)
        r_gim(ipol,i) = r_gim(ipol,j)
        r_csky(ipol,i) = r_csky(ipol,j)
        r_cchop(ipol,i) = r_cchop(ipol,j)
        r_ccold(ipol,i) = r_ccold(ipol,j)
        r_tsyss(ipol,i) = r_tsyss(ipol,j)
        r_tsysi(ipol,i) = r_tsysi(ipol,j)
        r_ceff(ipol,i) = r_ceff(ipol,j)
        r_cmode(ipol,i) = r_cmode(ipol,j)
        r_jykel(ipol,i) = r_jykel(ipol,j)
      enddo
      r_tcabin(i) = r_tcabin(j)
      do l=1, 3
        r_tdewar(l,i) = r_tdewar(l,j)
      enddo
      r_h2o_mon(i) =  r_h2o_mon(j)
      r_tatms_mon(i) =  r_tatms_mon(j)
      r_tatmi_mon(i) =  r_tatmi_mon(j)
      r_taus_mon(i) =  r_taus_mon(j)
      r_taui_mon(i) =  r_taui_mon(j)
      r_feff_mon(i) =  r_feff_mon(j)
      r_tchop_mon(i) =  r_tchop_mon(j)
      r_tcold_mon(i) =  r_tcold_mon(j)
      r_trec_mon(i) =  r_trec_mon(j)
      r_gim_mon(i) =  r_gim_mon(j)
      r_csky_mon(i) =  r_csky_mon(j)
      r_cchop_mon(i) =  r_cchop_mon(j)
      r_ccold_mon(i) =  r_ccold_mon(j)
      r_tsys_mon(i) =  r_tsys_mon(j)
      r_cmode_mon(i) =  r_cmode_mon(j)
      r_path_mon(i) =  r_path_mon(j)
      r_tem_mon(i) =  r_tem_mon(j)
      r_dpath_mon(i) =  r_dpath_mon(j)
      r_ok_mon(i) =  r_ok_mon(j)
      !-- ignore ???
      !            do l=0, MBBPCDEG
      !               R_AICPHA(1,i,l) = R_AICPHA(1,j,l)
      !               R_AICAMP(1,i,l) = R_AICAMP(1,j,l)
      !               R_AICPHA(2,i,l) = R_AICPHA(2,j,l)
      !               R_AICAMP(2,i,l) = R_AICAMP(2,j,l)
      !            enddo
      !            do m = 1, 2
      !               r_abpcsba(m,i) =  r_abpcsba(m,j) !
      !               do l=0, mbpccdeg
      !                  do n = 1, r_lband
      !                     r_abpclamp(m,i,n,l) = r_abpclamp(m,j,n,l)
      !                     r_abpclpha(m,i,n,l) = r_abpclpha(m,j,n,l)
      !                  enddo
      !                  r_abpfamp(m,i,l) = r_abpfamp(m,j,l)
      !                  r_abpfpha(m,i,l) = r_abpfpha(m,j,l)
      !               enddo
      !            enddo
      !--
      !            R_DMAFLAG(i) = R_DMAFLAG(j)
      !            R_DMATFAC(1,i) = R_DMATFAC(1,j)
      !            R_DMATFAC(2,i) = R_DMATFAC(2,j)
      !            R_DMDELAY(i) = R_DMDELAY(j)
      !            R_WVRNCH(i) = 0
    enddo
    !
    ! Get necessary memory for data section (pointer IPNEWDATA)
    nnewdata = r_ndump * t_ldump +   &
      max(1,r_ndatl) * (t_ldump+t_ldatl)
    if (mnewdata.lt.nnewdata) then
      if (mnewdata.gt.0) call free_vm(mnewdata,addrnewdata)
      mnewdata = nnewdata
      !            print *, 'sic_getvm, mnewdata ', mnewdata
      if (sic_getvm(mnewdata,addrnewdata).ne.1) goto 99
    endif
    ipnewdata = gag_pointer(addrnewdata,memory)
    !
    ! In subroutine loop on records to fill in data section
    !         print *, 'call fill_data,  t_nbas ', t_nbas
    call fill_data(ndata, memory(ip_data),   &
      t_nant, t_nbas, t_ldpar, t_ldatc, t_ldump,   &
      nnewdata, memory(ipnewdata))
    !
    r_nant = t_nant
    r_nbas = t_nbas
    r_ldpar = t_ldpar
    r_ldatc = t_ldatc
    r_ldatl = t_ldatl
    r_ldump = t_ldump
    ndata = nnewdata
    call ipb_write(write_mode,check,error)
    if (.not.error) then
      call wdata (nnewdata,memory(ipnewdata),.true.,error)
      if (error) goto 99
      call ipb_close(error)
      if (error) goto 99
      write(chain,'(a,i6,a,i6,a)') 'Observation ',r_num,   &
        ' '//done(write_mode)//' (',r_ndump,' records)'
      call message(4,1,'CLIC_MODEL',chain(1:50))
    endif
if (sic_ctrlc()) then
      error = .true.
      goto 99
    endif
    call get_next(end,error)
    if (error) goto 99
  enddo
99 do_write_data = do_write_saved
  return
end subroutine clic_clone
!*<FF>
subroutine fill_data(ndata, data,   &
    t_nant, t_nbas, t_ldpar, t_ldatc, t_ldump,   &
    nnewdata, newdata)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! create a data section with nant antennas (nant > r_nant)
  !---------------------------------------------------------------------
  integer(kind=data_length) :: ndata                  !
  real :: data(ndata)               !
  integer :: t_nant                 !
  integer :: t_nbas                 !
  integer :: t_ldpar                !
  integer :: t_ldatc                !
  integer :: t_ldump                !
  integer(kind=data_length) :: nnewdata               !
  real :: newdata(nnewdata)         !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_number.inc'
  include 'clic_dheader.inc'
  !      INCLUDE 'clic_clic.inc'
  !      INCLUDE 'clic_proc_par.inc'
  !      INCLUDE 'gbl_memory.inc'
  !      INCLUDE 'gbl_pi.inc'
  ! Local
  real :: ampli, noise, tsys(2)
  integer :: s_nant, s_nbas, s_ldpar, s_ldatc, s_ldump, i, j
  integer :: kin, kout, is, l, ig, im, ir, ia, ja, ib, ic, isb
  real*8 :: sind, cosd, sinh, cosh
  !
  ! Loop on records to process the data headers and continuum data
  s_nant = r_nant
  s_nbas = r_nbas
  s_ldpar = r_ldpar
  s_ldatc = r_ldatc
  s_ldump = r_ldump
  kin = 1
  kout = 1
  if (r_isb.eq.1) then
    ig = 1                     ! upper sideband
    im = 2
  else
    ig = 2                     ! lower sideband
    im = 1
  endif
  do ir=1, r_ndump+r_ndatl
    r_nant = s_nant
    r_nbas = s_nbas
    call decode_header (data(kin))
    !         print *,'dh_dump, dh_integ, dh_utc ', dh_dump, dh_integ, dh_utc
    do i = r_nant+1, t_nant
      j = mod(i-1,r_nant)+1
      dh_aflag(i) = dh_aflag(j)
      do l=1, mnbb
        dh_total(l,i) = dh_total(l,j)
        dh_atfac(l,1,i) = dh_atfac(l,1,j)
        dh_atfac(l,2,i) = dh_atfac(l,2,j)
      enddo
      dh_delcon(i) = dh_delcon(j)
      do l=1,mnbb ! number of bband
         dh_dellin(l,i) = dh_dellin(l,j)
         dh_delay(l,i) = dh_delay(l,j)
      enddo
      dh_delayc(i) = dh_delayc(j)
      dh_phasec(i) = dh_phasec(j)
      dh_phase(i) = dh_phase(j)
      dh_ratec(i) = dh_ratec(j)
      dh_cable(i) = dh_cable(j)
      dh_gamme(i) = dh_gamme(j)
      do l=1, 5
        dh_test1(l,i) = dh_test1(l,j)
      enddo
      dh_offfoc(i) = dh_offfoc(j)
      dh_offlam(i) = dh_offlam(j)
      dh_offbet(i) = dh_offbet(j)
      do l=1, mwvrch
        dh_wvr(l,i) = dh_wvr(l,j)
      enddo
      dh_wvrstat(i) = dh_wvrstat(j)
    enddo
    ! baselines ???
    do ib = 1, t_nbas
      ia = r_iant(ib)
      ja = r_jant(ib)
      ! some baselines will get e.g. basant(i,i) -> ???
      ! should rather recompute dh_uvb and ignore the rest...
      !            jb = basant(mod(ia-1,nant_in)+1, mod(ja-1,nant_in)+1)
      !            do l=1, 2
      !               dh_rmsamp(l,ib) = dh_rmsamp(l,jb)
      !               dh_rmspha(l,ib) = dh_rmsamp(l,jb)
      !               dh_uvm(l,ib) = dh_uvm(l,jb)
      !            enddo
      !            dh_BFLAG(ib) = dh_BFLAG(jb)
      sind = dh_svec(3)
      cosd = sqrt(1.d0-sind**2)
      sinh = -dh_svec(2) / cosd
      cosh = dh_svec(1) / cosd
      dh_uvm(1,ib) = (r_bas(1,ib)*sinh + r_bas(2,ib)*cosh)
      dh_uvm(2,ib) = (-r_bas(1,ib)*cosh + r_bas(2,ib)*sinh)*sind
    enddo
    r_nant = t_nant
    r_nbas = t_nbas
    !         print *,'dh_dump, dh_integ, dh_utc ', dh_dump, dh_integ, dh_utc
    call encode_header (newdata(kout))
    kin = kin + r_ldpar
    kout = kout + t_ldpar
    r_nant = s_nant
    r_nbas = s_nbas
    !
    ! Continuum data: Auto Correlation
    if (r_lmode.eq.2) then
      do i = 1, t_nant
        j = mod(i-1,r_nant)+1
        do is = 1, r_nband
          !                  print *, kin + is-1 +(j-1)*r_nband,
          !     &                 kout + is-1 + (i-1)*r_nband
          newdata(kout + is-1 + (i-1)*r_nband)   &
            = data (kin + is-1 +(j-1)*r_nband)
        enddo
      enddo
    !
    ! Continuum data: Cross Correlation
    elseif (r_lmode.eq.1) then
      do ib = 1, t_nbas
        ia = r_iant(i)
        ja = r_jant(i)
        ampli = r_flux/sqrt(r_jykel(1,ia)*r_jykel(1,ja))
        tsys(im) = r_tsysi(1,ia)*r_tsysi(1,ja)
        tsys(ig) = r_tsyss(1,ia)*r_tsyss(1,ja)
        do isb = 1, 2
          do is = 1, r_nband
            noise = sqrt(tsys(isb)   &
              /(2*r_cfwid(is)*dh_integ*1e6))
            ! rangau ...
            newdata(kout) = ampli+s_noise(noise)
            newdata(kout+1) = s_noise(noise)
            kout = kout + 2
          enddo
        enddo
      enddo
    endif
    kin = kin + r_ldatc
    !
    if (ir.gt.r_ndump) then
      ! Spectral data: Auto Correlation
      if (r_lmode.eq.2) then
        do i = 1, t_nant
          j = mod(i-1,r_nant)+1
          do is = 1, r_lntch
            newdata(kout + is-1 + (i-1)*r_lntch)   &
              = data (kin + is-1 +(j-1)*r_lntch)
          enddo
        enddo
        kout = kout + r_lntch*t_nant
      !
      ! Spectral data: Cross Correlation
      elseif (r_lmode.eq.1) then
        do i = 1, t_nbas
          ia = r_iant(i)
          ja = r_jant(i)
          ampli = r_flux/sqrt(r_jykel(1,ia)*r_jykel(1,ja))
          tsys(im) = r_tsysi(1,ia)*r_tsysi(1,ja)
          tsys(ig) = r_tsyss(1,ia)*r_tsyss(1,ja)
          do isb = 1, 2
            do is = 1, r_lband
              do ic = r_lich(is)+1, r_lich(is)+r_lnch(is)
                noise = sqrt(tsys(isb)   &
                  /(2*r_lfres(is)*dh_integ*1e6))
                !     rangau ...
                newdata(kout) = ampli+s_noise(noise)
                newdata(kout+1) = s_noise(noise)
                kout = kout + 2
              enddo
            enddo
          enddo
        enddo
      endif
      kin = kin + r_ldatl
    endif
  enddo
  !      print *, 'kin, ndata, kout, nnewdata'
  !      print *, kin, ndata, kout, nnewdata
  return
end subroutine fill_data

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage GCFITSIO messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cfitsio_messaging
  use gbl_message
  use gpack_def
  !
  public :: cfitsio_message_set_id
  public :: cfitsio_message
  public :: seve,message_length  ! For convenience
  private  
  !
  ! Identifier used for message identification.
  integer :: cfitsio_message_id = gpack_global_id  ! Default value for startup message
  !
contains
  !
  subroutine cfitsio_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    ! Local
    character(len=message_length) :: mess
    !
    cfitsio_message_id = id
    !
    write (mess,'(A,I3)') 'Now use id #',cfitsio_message_id
    call cfitsio_message(seve%d,'cfitsio_message_set_id',mess)
  end subroutine cfitsio_message_set_id
  !
  subroutine cfitsio_message(mkind,procname,message)
    !---------------------------------------------------------------------
    ! @ private
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call gmessage_write(cfitsio_message_id,mkind,procname,message)
  end subroutine cfitsio_message
end module cfitsio_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

function gr_error ()
  use greg_error
  !---------------------------------------------------------------------
  ! @ public
  !	Check GREG library error status
  !---------------------------------------------------------------------
  logical :: gr_error               !
  !
  gr_error = errorg
  errorg = .false.
end function gr_error
!
subroutine gr_exec(buffer)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_exec
  use greg_error
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  !	Execute a single GREG command
  ! Arguments :
  !	BUFFER	C*(*)	The command line		Input
  ! Subroutines :
  !	(SIC)
  !	RUN_GREG1, RUN_GREG2
  !---------------------------------------------------------------------
  character(len=*) :: buffer        !
  ! Local
  integer :: nl, nh
  character(len=255) :: line
  character(len=12) :: lang
  character(len=12) :: comm
  character(len=12) :: header
  character(len=1), parameter :: backslash=char(92)
  !
  save nh, nl, header, line
  !
  ! Analyse line
  header = 'G'//backslash
  nh = 2
  goto 10
  !
entry gr_exec1(buffer)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  header = 'GREG1'//backslash
  nh = 6
  goto 10
  !
entry gr_exec2(buffer)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  header = 'GREG2'//backslash
  nh = 6
  goto 10
  !
entry gr_execl(buffer)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  header = 'GTVL'//backslash
  nh = 5
  goto 10
  !
  ! Check error status
10 continue
  if (errorg) then
    call gagout (message)
    call gagout (line(1:nl))
    call sysexi (fatale)
  endif
  line  = header(1:nh)//buffer
  nl = 255
  !
  ! Analyse line
  call sic_blanc(line,nl)
  call sic_analyse(comm,line,nl,errorg)
  if (errorg) then
    message = 'F-GREG,  Error interpreting line'
    return
  endif
  call sic_lang(lang)
  !
  ! Execute line
  if (lang.eq.'GREG1') then
    call run_greg1(line,comm,errorg)
  elseif (lang.eq.'GREG2') then
    call run_greg2(line,comm,errorg)
  elseif (lang.eq.'GTVL') then
    call run_gtvl(line,comm,errorg)
    if (comm.eq.'CLEAR') call greset
  else
    message = 'F-GREG,  Unexpected language '//lang
    errorg = .true.
    return
  endif
  if (errorg) then
    message = 'F-GREG,  Error executing line'
    return
  endif
end subroutine gr_exec

!-----------------------------------------------------------------------
!  Find below the generic routines which can work on any kind of output
! and any instance, e.g. X-Windows, PS hardcopy, or SVG "interactive"
! device.
!-----------------------------------------------------------------------
module gtview_modes
  !---------------------------------------------------------------------
  ! Support module for GTVIEW. Store here variables shared by routines
  ! in this file and only this file.
  !---------------------------------------------------------------------
  ! GTVIEW modes:
  integer, parameter :: rewind =  0
  integer, parameter :: append = -1
  integer, parameter :: update = -2
  integer, parameter :: purge  = -3  ! Obsolete, to be removed
  integer, parameter :: delete = -4  ! Obsolete, to be removed
  integer, parameter :: zap    = -5  ! Obsolete, to be removed
  integer, parameter :: limits = -6  ! Obsolete, to be removed
  integer, parameter :: color  = -7
  !
end module gtview_modes
!
subroutine gtview(acha)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtview
  use gtv_protocol
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Plot to the interactive graphic device
  !
  ! 'Append'   Plot from last vector drawn
  ! 'Rewind'   Clear the screen, and plot from first vector
  ! 'Update'   Update the screens (Clear + Redraw)
  ! 'Color'    Update the screens (Redraw only)
  !
  ! Does not modify the virtuel pen position and the immediate pen
  ! position. P. Valiron
  !
  ! Modifiee pour parcourir une arborescence par R.Gras. (Octobre 1992)
  ! Modifiee par S.Guilloteau pour tracer les images AVANT les
  ! segments graphiques en cas de Rewind. Bigrement modifiee par GD, pendant
  ! qu'on y est...
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: acha  ! Key character of the required mode
  ! Local
  character(len=*), parameter :: rname='GTVIEW'
  integer :: sever
  character(len=1) :: opt
  logical :: error
  !
  opt = acha(1:1)
  call sic_upper(opt)
  !
  if (.not.awake .or. error_condition) return
  !
  if (opt.eq.'S') then
    if (strict2011) then
      sever = seve%e
    else
      sever = seve%w
    endif
    call gtv_message(sever,rname,'Sleep mode is obsolete. GTVirt is always awake.')
    if (strict2011)  return
    !
    return
  elseif (opt.eq.'W') then
    if (strict2011) then
      sever = seve%e
    else
      sever = seve%w
    endif
    call gtv_message(sever,rname,'Wake-Up mode is obsolete. GTVirt is always awake.')
    if (strict2011)  return
    !
    opt = 'A'
  endif
  !
  ! Draw if needed
  if (cw_output%dev%protocol.eq.p_null)  return
  !
  error = .false.
  call gtview_sub(cw_output,opt,error)
  !
end subroutine gtview
!
subroutine gtview_sub(output,chara,error)
  use gtv_types
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtview_sub
  use gtv_tree
  use gtv_types
  use gtview_modes
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Plot to the output graphic device given as argument
  !
  ! 'Append'   Plot from last vector drawn
  ! 'Rewind'   Clear the screen, and plot from first vector
  ! 'Update'   Update the screens (Clear + Redraw)
  ! 'Color'    Update the screens (Redraw only)
  !
  ! Does not modify the virtuel pen position and the immediate pen
  ! position. P. Valiron
  ! Modifiee pour parcourir une arborescence par R.Gras. (Octobre 1992)
  !---------------------------------------------------------------------
  type(gt_display)                :: output  ! Output instance
  character(len=*), intent(in)    :: chara   ! Key character of the required mode
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTVIEW'
  character(len=1) :: opt
  !
  opt = chara(1:1)
  call sic_upper(opt)
  !
  ! Do NOT close the current segment. It should have been explicitely
  ! closed by the programmer. Furthermore, 'gtsegm_close' implicitely
  ! appends the segment being closed.
  ! Only flush the internal buffers, in case we will have to plot
  ! a segment which is not yet closed (this is valid since it can be under
  ! construction but we want to see it during its build).
  call gtsegm_flush(error)
  if (error)  return
  !
  select case (opt)
  case ('R')
    ! --- Rewind ---
    ! Called after a change of segment properties, will redraw the CURRENT
    ! window ONLY, at all levels. Obsolete at MODE=0 (Rewind), see Update below.
    call gtview_rewind(output,cw_directory)  ! ZZZ Global dependency here!
    !
  case ('A')
    ! --- Append ---
    ! Called after a creation of new segment.
    ! Explore all the arborescence, and draws on concerned windows (the windows at
    ! directory levels BELOW the one at which the append is done)
    !
    ! Nothing to do if there is no segment opened (e.g. a directory
    ! has just been created)
    if (.not.associated(co_segment))  return
    call gtview_append(co_segment,error)
    !
  case ('U')
    ! --- Update ---
    ! Called after a change of segment properties, will explore all the
    ! arborescence, and redraw concerned windows (the windows at a directory
    ! level BELOW the one at which the change was made). Update all the
    ! windows: start from root
    call gtview_update(root,error)
    !
  case ('C')
    ! --- Update ---
    ! Called after a change of LUT, will explore all the arborescence, and
    ! redraw concerned windows (the windows at a directory level BELOW the
    ! one at which the change was made). Update all the windows: start from
    ! root
    call gtview_color(root,error)
    !
  case default
    call gtv_message(seve%e,rname,'Unknown code '//opt)
    return
    !
  end select
  !
end subroutine gtview_sub
!
subroutine gtview_rewind(output,dir)
  use gtv_interfaces, except_this=>gtview_rewind
  use gtv_protocol
  use gtv_types
  use gtview_modes
  !---------------------------------------------------------------------
  ! @ private
  ! Deuxieme mode de parcours de l'arbre, correspond a gtview('Rewind')
  ! Update is made in the output device given in the calling sequence
  ! SOLELY, for all the depth in correct order.
  !---------------------------------------------------------------------
  type(gt_display)   :: output  ! Output instance
  type(gt_directory) :: dir     ! Starting directory
  !
  if (output%dev%protocol.eq.p_x) then
    if (x_refresh_genv(dir,rewind,output%x%graph_env)) then
      call gtview_work_recursdir(output,dir,rewind)
    endif
  else
    call gtview_work_recursdir(output,dir,rewind)
  endif
  !
end subroutine gtview_rewind
!
subroutine gtview_update(dir_start,error)
  use gtv_interfaces, except_this=>gtview_update
  use gtv_types
  use gtview_modes
  !---------------------------------------------------------------------
  ! @ private
  ! gtview('Update')
  ! Redraw completely all the windows attached to dir_start and its
  ! subdirectories.
  !---------------------------------------------------------------------
  type(gt_directory)                :: dir_start  ! Starting directory
  logical,            intent(inout) :: error      ! Logical error flag
  !
  call win_gtview_work_allwin_recurs(dir_start,update,error)
  !
end subroutine gtview_update
!
subroutine gtview_color(dir_start,error)
  use gtv_interfaces, except_this=>gtview_color
  use gtv_types
  use gtview_modes
  !---------------------------------------------------------------------
  ! @ private
  ! gtview('Update')
  ! Redraw completely all the windows attached to dir_start and its
  ! subdirectories.
  !---------------------------------------------------------------------
  type(gt_directory)                :: dir_start  ! Starting directory
  logical,            intent(inout) :: error      ! Logical error flag
  !
  call win_gtview_work_allwin_recurs(dir_start,color,error)
  !
end subroutine gtview_color
!
subroutine gtview_append(seg_start,error)
  use gtv_interfaces, except_this=>gtview_append
  use gildas_def
  use gtv_types
  use gtview_modes
  !---------------------------------------------------------------------
  ! @ private
  ! gtview('Append')
  !---------------------------------------------------------------------
  type(gt_segment)                :: seg_start  ! Starting segment
  logical,          intent(inout) :: error      ! Logical error flag
  !
  call win_gtview_work_allwin_updir(seg_start,append,error)
  !
end subroutine gtview_append
!
recursive subroutine gtview_work_recursdir(out,dir,mode)
  use gtv_buffers
  use gtv_interfaces, except_this=>gtview_work_recursdir
  use gtv_types
  use gtview_modes
  !---------------------------------------------------------------------
  ! @ private
  !  Work (draw, update, clean...) in the input 'gt_display' instance,
  ! reading the tree 'dir', and recursively in its subdirectories.
  !---------------------------------------------------------------------
  type(gt_display),   intent(inout) :: out   ! Input gt_display
  type(gt_directory)                :: dir   ! Starting directory
  integer(kind=4),    intent(in)    :: mode  !
  ! Local
  type(gt_directory), pointer :: son
  !
  ! 1) Segments in subdirectories first
  son => dir%son_first
  do while (associated(son))
    call gtview_work_recursdir(out,son,mode)
    son => son%brother
  enddo
  !
  ! 2) Segments in current directory last
  call gtview_work_1dir(out,dir,mode)
  !
end subroutine gtview_work_recursdir
!
subroutine gtview_work_1dir(out,dir,mode)
  use gtv_interfaces, except_this=>gtview_work_1dir
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  use gtv_segatt
  use gtv_types
  use gtview_modes
  !---------------------------------------------------------------------
  ! @ private
  !  Work (draw, update, clean...) in the input 'gt_display' instance,
  ! reading the tree @ ad_start (only). No recursion here!
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out   ! Input gt_display
  type(gt_directory)              :: dir   ! Starting directory
  integer,          intent(in)    :: mode  !
  ! Local
  integer(kind=4) :: vis_mode
  integer :: idep
  !
  if (mode.eq.update .or. mode.eq.rewind .or. mode.eq.color) then
    ! We need to traverse the tree but layer by layer
    do idep=cdepth,1,-1
      vis_mode = idep
      if (.not.vdepth(vis_mode))  cycle  ! Nothing to draw at this depth
      !
      call affich_dir(out,dir,vis_mode)
    enddo
    !
  else
    ! Other modes
    call affich_dir(out,dir,mode)
  endif
  !
  ! We may need to flush the input X window (if any)
  if (out%dev%protocol.eq.p_x .and. out%x%graph_env.ne.0)  &
    call x_flush_points(out%x%graph_env)
  !
end subroutine gtview_work_1dir
!
subroutine gtview_work_1seg(out,leaf,mode)
  use gtv_interfaces, except_this=>gtview_work_1seg
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Work (draw, update, clean...) in the input 'gt_display' instance,
  ! reading the input elemental segment only.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out   ! Input gt_display
  type(gt_segment)                :: leaf  ! Leaf instance
  integer,          intent(in)    :: mode  !
  ! Local
  logical :: plot_leaf
  !
  ! Check if it should be plotted
  call lect_descr(out,leaf,mode,plot_leaf)
  !
  if (plot_leaf)  &
    call traite_codeop(out,leaf)
  !
  ! We may need to flush the input X window (if any)
  if (out%dev%protocol.eq.p_x .and. out%x%graph_env.ne.0)  &
    call x_flush_points(out%x%graph_env)
  !
end subroutine gtview_work_1seg
!
subroutine affich_dir(out,dir,mode)
  use gtview_modes
  use gtv_buffers
  use gtv_interfaces, except_this=>affich_dir
  use gtv_protocol
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Procedure de parcours des feuilles d'un repertoire.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out   ! Input gt_display
  type(gt_directory)              :: dir   ! Starting leaf
  integer,          intent(in)    :: mode  !
  ! Local
  logical :: plot_leaf
  type(gt_segment), pointer :: leaf
  !
  leaf => dir%leaf_first
  ! Loop on all leaves
  do while (associated(leaf))
    ! Check if it should be plotted
    call lect_descr(out,leaf,mode,plot_leaf)
    if (plot_leaf)  &
      call traite_codeop(out,leaf)
    !
    leaf => leaf%nextseg
  enddo
  !
end subroutine affich_dir
!
subroutine lect_descr(output,segm,mode,plot_segment)
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>lect_descr
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gtview_modes
  !---------------------------------------------------------------------
  ! @ private
  ! Read the input segment and check if we have to plot it or not.
  !---------------------------------------------------------------------
  type(gt_display)     :: output        ! Output instance
  type(gt_segment)     :: segm          ! Address of the descriptor to analyse
  integer, intent(in)  :: mode          ! Plot mode
  logical, intent(out) :: plot_segment  ! Need to plot the segment?
  !
  if (.not.segm%head%gen%visible) then
    plot_segment = .false.
    !
  elseif (segm%head%gen%minmax(1).ge.output%gx2 .or.  &
          segm%head%gen%minmax(2).le.output%gx1 .or.  &
          segm%head%gen%minmax(3).ge.output%gy2 .or.  &
          segm%head%gen%minmax(4).le.output%gy1) then
    ! Segment is out of the plotting area
    plot_segment = .false.
    !
  elseif (mode.gt.0) then
    ! 'mode' is a depth
    plot_segment = segm%head%attr%depth.eq.mode
    !
  elseif (mode.eq.rewind) then
    plot_segment = .true.
    !
  else
    ! Can this happen?
    plot_segment = .true.
  endif
  !
  if (plot_segment) then
    ! Travaillons avec tous les attributs, ne nous contentons pas de la couleur
    call set_attributs(output,segm%head%attr)
    !
    ! Selon les protocoles, le travail est different.
    ! Il y a les protocoles intelligent capables de faire du dash et des
    ! largeurs de trait et les autres. Pour les premiers, les parametres
    ! de dash et largeur ont deja ete fixe au moment du set_attributs(...)
    ! une ligne simple suffira dans tous les cas.
    !
    if (output%dev%protocol.eq.p_x) then
      ! Nothing to do, dash problems solved in set_dash
    elseif (output%dev%protocol.eq.p_svg) then
      ! output%dev%hardw_line_weig&dash = svg_hard(output%iweigh,output%idashe)
    elseif (output%dev%protocol.eq.p_postscript) then
      call ps_hard(output)
    elseif (output%dev%protocol.eq.p_png) then
      call png_hard(output)
    else
      output%dev%hardw_line_weig = output%iweigh.le.graisse(1)
      output%dev%hardw_line_dash = output%idashe.eq.1
    endif
    !
  endif
  !
end subroutine lect_descr
!
subroutine traite_codeop(out,leaf)
  use gtv_interfaces, except_this=>traite_codeop
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Elemental procedure which draws a graphic segment into the
  ! 'output' device. Read from the standard GTV buffer ('cw_buffer').
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out   ! Input gt_display
  type(gt_segment)                :: leaf  ! Segment instance
  ! Local
  type(gt_segment_data), pointer :: segdata
  !
  call gti_trace(out,"Here starts segment "//leaf%head%gen%name)
  !
  ! Follow the linked list of data
  segdata => leaf%data
  do while (associated(segdata))
    select case (segdata%kind)
    case (seg_points)
      call gti_points(out,segdata%poly)
    case (seg_poly)
      call gt_polyl(out,segdata%poly)
    case (seg_hfpoly)
      call gti_fillpoly(out,segdata%poly,.false.)
    case (seg_vfpoly)
      call gti_fillpoly(out,segdata%poly,.true.)
    case (seg_pencol)
      call gti_penlut(out,segdata%lut)
    case (seg_lutcol)
      call gti_lut(out,segdata%lut)
    case (seg_image)
      call gti_image(out,segdata%image)
    end select
    !
    segdata => segdata%nextdata
  enddo
  !
  call gti_trace(out,"Here ends segment "//leaf%head%gen%name)
  !
end subroutine traite_codeop
!
!-----------------------------------------------------------------------
!  Find below the specific routines which can work on X-Windows
!-----------------------------------------------------------------------
subroutine win_gtview_work_allwin_updir(segm,mode,error)
  use gtv_interfaces, except_this=>win_gtview_work_allwin_updir
  use gtv_buffers
  use gtv_protocol
  use gtv_types
  use gtview_modes
  !---------------------------------------------------------------------
  ! @ private
  ! Work on:
  !  - all windows which see 'segm'
  !  - a single leaf 'segm'
  !---------------------------------------------------------------------
  type(gt_segment)                :: segm   ! Leaf to work on
  integer(kind=4),  intent(in)    :: mode   ! Working mode
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_directory), pointer :: dir
  !
  dir => segm%father
  !
  do while (associated(dir))
    call win_gtview_work_allwin_1seg(dir,segm,mode,error)
    if (error)  return
    !
    dir => dir%father  ! Next parent
  enddo
  !
end subroutine win_gtview_work_allwin_updir
!
subroutine win_gtview_work_allwin_1seg(dir_win,segm,mode,error)
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>win_gtview_work_allwin_1seg
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Work on:
  !  - all windows of 1 directory (and only this directory)
  !  - 1 segment (not a directory)
  !---------------------------------------------------------------------
  type(gt_directory)                :: dir_win  ! The directory to which the windows are attached
  type(gt_segment)                  :: segm     ! The segment we work on
  integer(kind=4),    intent(in)    :: mode     ! What to do?
  logical,            intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WIN_GTVIEW_WORK_ALLWIN_1SEG'
  integer*4 :: iwin
  logical :: found
  type(gt_display), pointer :: output
  integer(kind=address_length) :: allgenv(0:mwindows-1)
  character(len=message_length) :: mess
  !
  if (dir_win%x%nbwin.le.0)  return
  !
  ! This subroutine will draw 1 segment in several windows (this is the purpose
  ! of the 2nd loop after). BUT, looping from 0 to dir_win%x%nbwin-1 can be a
  ! problem since a window can disappear (typically, the lens) while we were
  ! drawing in another one. So, let's protect this.
  ! 1) Keep memory of all the genvs when entering. This is safer: the other
  !    arrays are compressed when destroying a window, we could be lost.
  do iwin=0,dir_win%x%nbwin-1
    allgenv(iwin) = c_get_win_genv(dir_win%x%genv_array,iwin)
  enddo
  !
  ! 2) Then, draw in all known genvs. Since a window/genv can be destroyed
  !    at any time, 'get_slot_output_by_genv' is called in tolerant mode
  !    (present=.false.) so that we only jump to the next window without
  !    complaining.
  do iwin=0,dir_win%x%nbwin-1
    call get_slot_output_by_genv(allgenv(iwin),output,.false.,found,error)
    if (.not.found) then
      cycle
    elseif (error) then
      write(mess,*) 'Internal error: lost window #',iwin,', genv #',allgenv(iwin)
      call gtv_message(seve%e,rname,mess)
      return
    endif
    !
    if (x_refresh_genv(segm,mode,output%x%graph_env)) then
      call x_open_window(output%x%graph_env,mode)
      call gtview_work_1seg(output,segm,mode)
      call x_close_window(output%x%graph_env,mode)
    endif
  enddo
  !
end subroutine win_gtview_work_allwin_1seg
!
recursive subroutine win_gtview_work_allwin_recurs(dir,mode,error)
  use gtv_buffers
  use gtv_interfaces, except_this=>win_gtview_work_allwin_recurs
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Work on:
  !  - all windows of all directories starting from ad_start
  !  - the directory each window is attached on, recursively
  !---------------------------------------------------------------------
  type(gt_directory)                :: dir    ! The directory we will work on
  integer(kind=4),    intent(in)    :: mode   ! What to do?
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_directory), pointer :: son
  !
  ! 1) Windows attached to current directory
  call win_gtview_work_1dir(dir,mode,error)
  if (error)  return
  !
  ! 2) Windows attached to subdirectories
  son => dir%son_first
  do while (associated(son))
    call win_gtview_work_allwin_recurs(son,mode,error)
    if (error)  return
    son => son%brother
  enddo
  !
end subroutine win_gtview_work_allwin_recurs
!
subroutine win_gtview_work_1dir(dir,mode,error)
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>win_gtview_work_1dir
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Work on:
  !  - all windows of 1 directory (and only this directory)
  !  - the directory the windows are attached on, recursively
  !---------------------------------------------------------------------
  type(gt_directory)                :: dir    ! The directory to which the windows are attached
  integer(kind=4),    intent(in)    :: mode   ! What to do?
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='WIN_GTVIEW_WORK_1DIR'
  integer*4 :: iwin
  logical :: found
  type(gt_display), pointer :: output
  integer(kind=address_length) :: allgenv(0:mwindows-1)
  character(len=message_length) :: mess
  !
  if (dir%x%nbwin.le.0)  return
  !
  ! This subroutine will draw in several windows (this is the purpose
  ! of the 2nd loop after). BUT, looping from 0 to dir_win%x%nbwin-1 can be a
  ! problem since a window can disappear (typically, the lens) while we were
  ! drawing in another one. So, let's protect this.
  ! 1) Keep memory of all the genvs when entering. This is safer: the other
  !    arrays are compressed when destroying a window, we could be lost.
  do iwin=0,dir%x%nbwin-1
    allgenv(iwin) = c_get_win_genv(dir%x%genv_array,iwin)
  enddo
  !
  ! 2) Then, draw in all known genvs. Since a window/genv can be destroyed
  !    at any time, 'get_slot_output_by_genv' is called in tolerant mode
  !    (present=.false.) so that we only jump to the next window without
  !    complaining.
  do iwin=0,dir%x%nbwin-1
    call get_slot_output_by_genv(allgenv(iwin),output,.false.,found,error)
    if (.not.found) then
      cycle
    elseif (error) then
      write(mess,*) 'Internal error: lost window #',iwin,', genv #',allgenv(iwin)
      call gtv_message(seve%e,rname,mess)
      return
    endif
    !
    if (x_refresh_genv(dir,mode,output%x%graph_env)) then
      call x_open_window(output%x%graph_env,mode)
      call gtview_work_recursdir(output,dir,mode)
      call x_close_window(output%x%graph_env,mode)
    endif
  enddo
  !
end subroutine win_gtview_work_1dir
!
subroutine win_gtview_work_recursdir(dir,win_num,mode,error)
  use gtv_protocol
  use gtv_interfaces, except_this=>win_gtview_work_recursdir
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Work on:
  !  - 1 window of 1 directory
  !  - the directory the window is attached on, recursively
  !---------------------------------------------------------------------
  type(gt_directory)             :: dir      ! Directory to start from
  integer(kind=4), intent(in)    :: win_num  ! Window to draw in
  integer(kind=4), intent(in)    :: mode     ! Drawing mode
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  type(gt_display), pointer :: output
  !
  call get_slot_output_by_num(dir,win_num,output,error)
  if (error) return
  !
  call gtview_work_recursdir(output,dir,mode)
  !
end subroutine win_gtview_work_recursdir
!
subroutine win_gtview_work_1seg(dir,win_num,segm,mode,error)
  use gtv_protocol
  use gtv_interfaces, except_this=>win_gtview_work_1seg
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Work on:
  !  - 1 window of 1 directory
  !  - the directory the window is attached on, recursively
  !---------------------------------------------------------------------
  type(gt_directory)             :: dir      ! Directory the window is attached on
  integer(kind=4), intent(in)    :: win_num  ! The window number in the directory
  type(gt_segment)               :: segm     ! The segment to draw
  integer(kind=4), intent(in)    :: mode     ! Drawing mode
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  type(gt_display), pointer :: output
  !
  call get_slot_output_by_num(dir,win_num,output,error)
  if (error)  return
  !
  call gtview_work_1seg(output,segm,mode)
  !
end subroutine win_gtview_work_1seg

subroutine robs(ix,error)
  use classic_api
  use clic_file 
  use clic_title
  use clic_index
  !---------------------------------------------------------------------
  ! Read entry descriptor, then title and copy title into r_ structure
  !---------------------------------------------------------------------
  integer(kind=entry_length) :: ix                     !
  logical         :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  include 'clic_clic.inc'
  ! Local
  character(len=10) :: nombre
  !------------------------------------------------------------------------
  modify = .false.
  error = .false.
  !
  if (ix.le.0 .or. ix.ge.i%desc%xnext .or. ix.gt.m_ix) then
    error = .true.
    write(nombre,'(I10)') ix
    call message(8,3,'ROBS','Non-existant index entry '//nombre)
    return
  endif
  !
  ! Initialize Observation buffer
  call classic_recordbuf_open(i,ix_bloc(ix),ix_word(ix),ibuff,error)
  if (error) return
  !
  ! Then read entry descriptor
  call classic_entrydesc_read(i,ibuff,e,error)
  if (error) return
  !
  ! Check observation version
  if (e%version.lt.1.or.e%version.gt.version_last) then
    call message(8,3,'ROBS','Observation version not supported ')
    call message(8,1,'ROBS','Use a more recent CLIC version')
    error = .true.
    return
  endif
  !
  ! Duplicate index information
  call rix(ix,error)
  if (error) return
  r_num   = title%num
  r_ver   = title%ver
  r_dobs  = title%dobs
  r_dred  = title%dred
  r_typec = title%typec
  r_kind  = title%kind
  if (r_kind.ge.5) then
    new_receivers = .true.
  else
    new_receivers = .false.
  endif
  r_qual  = title%qual
  r_scan  = title%scan
  r_nrec  = title%recei
  call bytoch(title%project,r_project,8)
  call bytoch(title%teles,r_teles,12)
end subroutine robs
!
subroutine xobs (error)
  use classic_api
  use clic_file
  use clic_index
  !---------------------------------------------------------------------
  !	Opens an output observation in the output file to extend it.
  !	This works only if this obs. is the last in the file
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer(kind=entry_length) :: ix,inum
  integer :: iver
  ! Code:
  if (r_ver.lt.0) then
    call message(8,3,'XOBS','Can only extend last versions')
    error = .true.
    return
  endif
  ix = o%desc%xnext-1
  inum = ox_num(ix)
  iver = ox_ver(ix)
  if (iver.lt.0 .or. inum.ne.r_num) then
    call message(4,2,'XOBS',   &
      'Observation not found or may not be extended')
    error = .true.
    return
  endif
  !
  ! Initialize Observation buffer
  call classic_recordbuf_open(o,ox_bloc(ix),ox_word(ix),obuff,error)
  if (error) return
  !
  ! Then read entry descriptor
  call classic_entrydesc_read(o,obuff,e,error)
  if (error) return
  !
  ! Check observation version
  if (e%version.lt.1.or.e%version.gt.version_last) then
    call message(8,3,'XOBS','Observation version not supported ')
    error = .true.
    return
  endif
  ! 
  ! Observation is opened for modification
  modify = .true.
end subroutine xobs
!
subroutine mobs (error)
  use classic_api
  use clic_file
  use clic_index
  use clic_find
  !---------------------------------------------------------------------
  !	Open an observation of the output file to modify it.
  !	The length of each section modified must be smaller
  !	than the length of the corresponding section already present.
  !
  !	Find the latest version of this obs. in this file
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: nf
  integer(kind=entry_length) :: ix, ifind(10)
  !
  if (r_ver.lt.0) then
    call message(8,3,'UPDATE','Can only update last versions')
    error = .true.
    return
  endif
  !
  ! Find latest observation version
  fver =.false.
  fnum =.true.
  xnum =r_num
  ynum =r_num
  fscan = .false.
  xrecei = -1
  fut = .false.
  last =.true.
  nf = 1
  call fox(nf,ifind,error)
  if (error) return
  if (nf.eq.0) then
    error = .true.
    call message(8,4,'MOBS',   &
      'Observation to be modified was not found')
    return
  endif
  !
  ! Process last version of the observation
  ix = ifind(1)
  !
  ! Initialize Observation buffer
  call classic_recordbuf_open(o,ox_bloc(ix),ox_word(ix),obuff,error)
  if (error) return
  !
  ! Then read entry descriptor
  call classic_entrydesc_read(o,obuff,e,error)
  if (error) return
  !
  ! Check observation version
  if (e%version.lt.1.or.e%version.gt.version_last) then
    call message(8,3,'MOBS','Observation version not supported ')
    error = .true.
    return
  endif
  !
  ! Observation opened for modify
  modify = .true.
end subroutine mobs
!
subroutine cobs(ltype,error)
  use gkernel_interfaces
  use classic_api
  use clic_file
  use clic_title
  use clic_index
  use clic_find
  !---------------------------------------------------------------------
  !	Ends the writing of the output observation.
  !---------------------------------------------------------------------
  integer :: ltype                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: nf,hver
  integer(kind=entry_length) :: ifind(10),jx
  !
  if (obuff%lun.ne.o%lun) then
    error = .true.
    call message(8,4,'COBS',   &
      'Observation not open for write nor modify')
    return
  endif
  !
  hver = 0
  if (.not.modify) then
    if (o%lun.ne.i%lun) then         ! Write on a new file:
      r_num = o%desc%xnext           ! Guarantee increase
    endif
    fver=.false.
    fnum=.true.
    xnum=r_num
    ynum=r_num
    last=.true.
    nf = 1
    fscan = .false.
    xrecei = -1
    fut = .false.
    call fox(nf,ifind,error)
    if (error) return
    if (nf.ne.0) then
      hver = ox_ver(ifind(1))
      if (hver.ge.0) ox_ver(ifind(1)) = -hver
      call rox(ifind(1),error)
      if (error) return
      title%ver = ox_ver(ifind(1))
      call mox(ifind(1),error)
      if (hver.lt.0) hver = -hver
      if (error) return
    else
      hver = 0
    endif
  endif
  !
  title%typec = ltype
  title%off1  = r_lamof
  title%off2  = r_betof
  ! Interferometer specific
  title%proc  = r_proc
  title%itype = r_itype
  title%houra = r_houra
  title%ut    = r_ut
  title%recei = r_nrec
  call chtoby(r_project,title%project,8)
  title%bpc   = r_bpc
  if (r_ic.ne.0) then
    title%ic  = r_ic
  else
    title%ic  = 0
  endif
  !
  ! Write the index entry
  ! The version number must increase
  !
  title%bloc = obuff%rstart
  title%word = obuff%wstart
  title%num  = r_num
  
  title%kind = r_kind
  title%qual = r_qual
  r_ver      = abs(r_ver)
  title%ver  = max(r_ver,hver)+1
  if (title%ver.gt.99) title%ver=11
  title%scan = r_scan
  call chtoby (r_sourc,title%sourc,12)
  call chtoby (r_line,title%line,12)
  call chtoby (r_teles,title%teles,12)
  title%dobs = r_dobs
  call sic_date (r_cdred)
  call cdate (r_cdred,r_dred,error)
  title%dred = r_dred
  if (modify) then
    ! Caution, if error before classic_entry_write, last buffer not written
    jx = e%xnum
    call mox(jx,error)
  else
    call wox(error)
  endif
  if (error) return
  !
  ! Write the observation header
  call classic_entrydesc_write(o,obuff,e,error)
  if (error) return
  !
  ! And close the entry
  call classic_entry_close(o,obuff,error)
  !
  ! File both: nullify input file record buffer, as it may have changed on disk
  if (i%lun.eq.o%lun) then
    call classic_recordbuf_nullify(ibuff)
  endif
  !
  ! Update the file header
  call cox(error)
end subroutine cobs
!
subroutine iobs(n,ix,check,error)
  use gkernel_interfaces
  use classic_api
  use clic_file
  use clic_title
  use clic_find
  !---------------------------------------------------------------------
  ! RW	Internal routine
  !	Starts the writing of an observation.
  ! Arguments :
  !	N 	I	maximum # of sections to be written
  !			(in addition of the data section)
  !	IX 	I	returns the index number of the observation
  !			in the output file
  !      CHECK    L       .true., check that observation is not a diplicate.
  !---------------------------------------------------------------------
  integer         :: n                      !
  integer(kind=entry_length) :: ix                     !
  logical         :: check                  !
  logical         :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  logical :: err, full
  integer :: ier, nff, lch, version
  integer(kind=entry_length) :: iff(100)
  character(len=80) :: ch
  !
  if (o%lun.eq.0) then
    call message(8,4,'IOBS','No output file opened')
    error=.true.
    return
  endif
  !
  ! Check if scan was written previously (with same receiver and UT time)
  ! Nevertheless, authorize writing if same scan number and not check
  !
  if (o%desc%xnext.gt.1) then
    !
    nff = 100
    fnum = .false.
    fver = .false.
    xscan(1) = r_scan
    yscan(1) = r_scan
    xnscan = 1
    fscan = .true.
    xrecei = r_nrec
    xut = real(r_ut,kind=4) ! Patch: r_ut is kind=8, but title%ut is kind=4
    yut = real(r_ut,kind=4) ! Patch: r_ut is kind=8, but title%ut is kind=4
    fut = .true.
    call fox(nff,iff,error)
    if (nff.ge.1) then
      write (ch,'(a,i5,a,i2,a)') 'Observation ',r_scan,   &
        ' receiver ',r_nrec, ' already written'
      lch = lenc(ch)
      call message(8,2,'IOBS',ch(1:lch))
      if (check) then
        error = .true.
        return
      endif
    endif
  endif
  !
  ! Proceed
20 continue
  call classic_filedesc_read(o,err)
  if (err) then
    if (error) then
      call message(8,3,'IOBS','Read error in file descriptor')
      call messios(8,3,'IOBS',ier)
      return
    else
      error = .true.
      call sic_wait(1.0)
      goto 20
    endif
  endif
  error = .false.
  !
  ! Add index extension if required before preparing the observation
  ! And initialize entry descriptor
  modify = .false.
  ix = o%desc%xnext
  if (o%desc%version.eq.1) then     ! CLASSIC V1
    version = classic_vobs_v1       !   Observation version v1
  elseif(o%desc%version.eq.2) then  ! CLASSIC V2
    version = version_current       !   Desired version
  endif
  call classic_entry_init(o,ix,n,version,full,e,error)
  if (full) call message(8,3,'IOBS','Output index is full')
  if (error) return
  !
  ! And initialize output buffer
  call classic_recordbuf_open(o,o%desc%nextrec,o%desc%nextword,obuff,error)
  if (error) return
  !
end subroutine iobs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_polar
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubetopology_spapos_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: polar
  private
  !
  type :: polar_comm_t
     type(option_t),     pointer :: comm
     type(spapos_comm_t)         :: center
     type(cubeid_arg_t), pointer :: cartesian
     type(cube_prod_t),  pointer :: polar
   contains
     procedure, public  :: register => cubemain_polar_register
     procedure, private :: parse    => cubemain_polar_parse
     procedure, private :: main     => cubemain_polar_main
  end type polar_comm_t
  type(polar_comm_t) :: polar
  !
  type polar_user_t
     type(cubeid_user_t) :: cubeids
     type(spapos_user_t) :: center
   contains
     procedure, private :: toprog => cubemain_polar_user_toprog
  end type polar_user_t
  !
  type polar_prog_t
     type(cube_t), pointer     :: cartesian
     type(cube_t), pointer     :: polar
     type(spapos_prog_t)       :: center
     integer(kind=pixe_k)      :: nx = 0          ! # of x pixels
     integer(kind=pixe_k)      :: ny = 0          ! # of y pixels
     integer(kind=pixe_k)      :: nr = 0          ! # of radii
     integer(kind=pixe_k)      :: na = 0          ! # of angles
     real(kind=4), allocatable :: rindices(:,:,:) ! 
     real(kind=4), allocatable :: aindices(:,:,:) ! 
   contains
     procedure, private :: indices => cubemain_polar_prog_indices
     procedure, private :: header  => cubemain_polar_prog_header
     procedure, private :: data    => cubemain_polar_prog_data
     procedure, private :: loop    => cubemain_polar_prog_loop
     procedure, private :: act     => cubemain_polar_prog_act
  end type polar_prog_t
  !
contains
  !
  subroutine cubemain_polar_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(polar_user_t) :: user
    character(len=*), parameter :: rname='POLAR>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call polar%parse(line,user,error)
    if (error) return
    call polar%main(user,error)
    if (error) continue
  end subroutine cubemain_polar_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_polar_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(polar_comm_t), intent(inout) :: comm
    logical,             intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='POLAR>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'POLAR','[cubeid]',&
         'Reproject data on polar spatial coordinates',&
         strg_emp,&
         cubemain_polar_command,&
         polar%comm,error)
    if (error) return
    call incube%register(&
         'CUBEID',&
         'Signal cube',&
         'If omitted, use the last matching cube (any family/flags) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset,&
         comm%cartesian,&
         error)
    if (error) return
    !
    call polar%center%register('CENTER',&
         'Center of the polar coordinate system',&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'POLAR',&
         'The polar coordinates cube',&
         strg_emp,&
         [flag_polar],&
         comm%polar,&
         error)
    if (error) return
  end subroutine cubemain_polar_register
  !
  subroutine cubemain_polar_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! POLAR [cubeid]
    ! /CENTER xpos ypos type [unit]
    !----------------------------------------------------------------------
    class(polar_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(polar_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='POLAR>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%center%parse(line,user%center,error)
    if (error) return
  end subroutine cubemain_polar_parse
  !
  subroutine cubemain_polar_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(polar_comm_t), intent(in)    :: comm
    type(polar_user_t),  intent(inout) :: user
    logical,             intent(inout) :: error
    !
    type(polar_prog_t) :: prog
    character(len=*), parameter :: rname='POLAR>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_polar_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_polar_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    use cubetools_unit
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(polar_user_t), intent(in)    :: user
    type(polar_comm_t),  intent(in)    :: comm
    type(polar_prog_t),  intent(out)   :: prog
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='POLAR>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cartesian,user%cubeids,prog%cartesian,error)
    if (error) return
    call user%center%toprog(prog%cartesian,prog%center,error)
    if (error) return
  end subroutine cubemain_polar_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_polar_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(polar_prog_t), intent(inout) :: prog
    type(polar_comm_t),  intent(in)    :: comm
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='POLAR>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%polar,prog%cartesian,prog%polar,error)
    if (error) return
    call prog%indices(error)
    if (error) return
  end subroutine cubemain_polar_prog_header
  !
  subroutine cubemain_polar_prog_indices(prog,error)
    use gkernel_interfaces
    use cubetools_axis_types
    use cubetools_header_methods
    use cubetools_header_types
    use cubetools_format
    use cubetools_unit
    !----------------------------------------------------------------------
    ! For each pixel of the original image compute the associated polar
    ! coordinates
    !----------------------------------------------------------------------
    class(polar_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    integer(kind=4) :: ier
    type(axis_t) :: xaxis,yaxis
    type(axis_t) :: raxis,aaxis
    real(kind=coor_k) :: xval,yval,rval,aval
    real(kind=coor_k) :: centeroffset(2),dist(4),angle,dangle(2),rdcorners(2,4)
    integer(kind=pixe_k) :: ix,iy
    integer(kind=pixe_k) :: irmin,irmax
    integer(kind=pixe_k) :: iamin,iamax
    integer(kind=pixe_k) :: ic,icmax
    integer(kind=pixe_k) :: icorners(2,4),idcorners(2,4)
    character(len=*), parameter :: rname='POLAR>PROG>INDICES'
    !
    call cubetools_header_get_axis_head_l(prog%cartesian%head,xaxis,error)
    if (error) return
    call cubetools_header_get_axis_head_m(prog%cartesian%head,yaxis,error)
    if (error) return
    call cubetools_axis_copy(xaxis,raxis,error)
    if (error) return
    call cubetools_axis_copy(yaxis,aaxis,error)
    if (error) return
    !
    prog%nx = xaxis%n
    prog%ny = yaxis%n
    call prog%center%offset(centeroffset,error)
    if (error) return
    xaxis%val = centeroffset(1)
    yaxis%val = centeroffset(2)
    !
    ! Compute minimum angle variation from four image corners
    icorners(:,1) = [1,1]
!!$    icorners(:,2) = [1,prog%ny]
!!$    icorners(:,3) = [prog%nx,prog%ny]
!!$    icorners(:,4) = [prog%nx,1]
    icorners(1,2) = 1
    icorners(2,2) = prog%ny
    icorners(1,3) = prog%nx
    icorners(2,3) = prog%ny
    icorners(1,4) = prog%nx
    icorners(2,4) = 1
    idcorners(:,1) = [+1,+1]
    idcorners(:,2) = [+1,-1]
    idcorners(:,3) = [-1,-1]
    idcorners(:,4) = [-1,+1]
    do ic=1,4
       dist(ic) = mydist(icorners(1,ic),icorners(2,ic))
    enddo ! ic
    icmax = maxloc(dist,1)
    rval = dist(icmax)
    if (rval.eq.0d0) then
       call cubemain_message(seve%e,rname,'Image size is zero!')
       error = .true.
       return
    endif
    angle = myangle(icorners(1,icmax),icorners(2,icmax))
    dangle(1) = angle-myangle(icorners(1,icmax)+idcorners(1,icmax),icorners(2,icmax))
    dangle(2) = angle-myangle(icorners(1,icmax)                   ,icorners(2,icmax)+idcorners(2,icmax))
    aaxis%inc = minval(abs(dangle))
    !
    raxis%inc = sqrt(abs(xaxis%inc*yaxis%inc))
    !
    allocate(prog%rindices(2,prog%nx,prog%ny),prog%aindices(2,prog%nx,prog%ny),stat=ier)
    if (failed_allocate(rname,'indices',ier,error)) return
    !
    rdcorners(:,1) = [+0.5,+0.5]
    rdcorners(:,2) = [+0.5,-0.5]
    rdcorners(:,3) = [-0.5,-0.5]
    rdcorners(:,4) = [-0.5,+0.5]
    rdcorners(1,:) = rdcorners(1,:)*xaxis%inc
    rdcorners(2,:) = rdcorners(2,:)*yaxis%inc
    !
    do iy=1,prog%ny
       yval = (iy-yaxis%ref)*yaxis%inc+yaxis%val
       do ix=1,prog%nx
          xval = (ix-xaxis%ref)*xaxis%inc+xaxis%val
          irmax = -huge(irmax)
          irmin = +huge(irmin)
          iamax = -huge(iamax)
          iamin = +huge(iamin)
          if (((xval+0.5*xaxis%inc)*(xval-0.5*xaxis%inc).le.0d0).and.(yval.gt.yaxis%inc)) then
             if (xval+0.5*xaxis%inc.ge.0.0) then
                call cart2polar(xval+0.5*xaxis%inc,yval-0.5*yaxis%inc,&
                     irmin,irmax,iamin,iamax)
                call cart2polar(xval+0.5*xaxis%inc,yval+0.5*yaxis%inc,&
                     irmin,irmax,iamin,iamax)
             else
                call cart2polar(xval-0.5*xaxis%inc,yval-0.5*yaxis%inc,&
                     irmin,irmax,iamin,iamax)
                call cart2polar(xval-0.5*xaxis%inc,yval+0.5*yaxis%inc,&
                     irmin,irmax,iamin,iamax)
             endif
             call cart2polar(0d0,yval+0.5*yaxis%inc,&
                  irmin,irmax,iamin,iamax)
!             print *,ix,iy,iamin,iamax
          else
             do ic=1,4
                call cart2polar(xval+rdcorners(1,ic),yval+rdcorners(2,ic),&
                     irmin,irmax,iamin,iamax)
             enddo ! ic
          endif
          prog%rindices(1,ix,iy) = irmin
          prog%rindices(2,ix,iy) = irmax
          prog%aindices(1,ix,iy) = iamin
          prog%aindices(2,ix,iy) = iamax
       enddo ! ix
    enddo ! iy
    !
    iamin = minval(prog%aindices)
    iamax = maxval(prog%aindices)
    prog%aindices(:,:,:) = prog%aindices(:,:,:)-iamin+1
    !
    aaxis%n   = iamax-iamin+1
    aaxis%ref = 1
    aaxis%val = 0
    aaxis%name = "THETA"
    aaxis%kind = code_unit_pang
    !
    raxis%n = maxval(prog%rindices)
    raxis%ref = 1
    raxis%val = 0
    raxis%name = "RADIUS"
    !
    prog%nr = raxis%n
    prog%na = aaxis%n
    !
    call cubetools_header_update_axset_l(aaxis,prog%polar%head,error)
    if (error) return
    call cubetools_header_update_axset_m(raxis,prog%polar%head,error)
    if (error) return
    !
  contains
    !
    function mydist(ix,iy)
      real(kind=coor_k)                :: mydist
      integer(kind=pixe_k), intent(in) :: ix
      integer(kind=pixe_k), intent(in) :: iy
      !
      xval = (ix-xaxis%ref)*xaxis%inc+xaxis%val
      yval = (iy-yaxis%ref)*yaxis%inc+yaxis%val
      mydist = sqrt(xval**2+yval**2)
    end function mydist
    !
    function myangle(ix,iy)
      real(kind=coor_k)                :: myangle
      integer(kind=pixe_k), intent(in) :: ix
      integer(kind=pixe_k), intent(in) :: iy
      !
      rval = mydist(ix,iy)
      myangle = atan2(yval/rval,xval/rval)
    end function myangle
    !
    subroutine cart2polar(xval,yval,jrmin,jrmax,jamin,jamax)
      real(kind=coor_k),    intent(in)    :: xval
      real(kind=coor_k),    intent(in)    :: yval
      integer(kind=pixe_k), intent(inout) :: jrmin
      integer(kind=pixe_k), intent(inout) :: jrmax
      integer(kind=pixe_k), intent(inout) :: jamin
      integer(kind=pixe_k), intent(inout) :: jamax
      !
      integer(kind=pixe_k) :: jr,ja
      !
      rval = sqrt(xval**2+yval**2)
      if (rval.ne.0d0) then
         ! Formula to get a position angle from North to East
         aval = atan2(-xval/rval,-yval/rval)
      else
         aval = 0d0
      endif
      jr = nint(rval/raxis%inc)+1 ! jr = 1 when rval = 0
      jrmin = min(jrmin,jr)
      jrmax = max(jrmax,jr)
      ja = nint(aval/aaxis%inc)
      jamin = min(jamin,ja)
      jamax = max(jamax,ja)
    end subroutine cart2polar
  end subroutine cubemain_polar_prog_indices
  !
  subroutine cubemain_polar_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(polar_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='POLAR>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_polar_prog_data
  !   
  subroutine cubemain_polar_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(polar_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: cartesian,polar
    character(len=*), parameter :: rname='POLAR>PROG>LOOP'
    !
    call cartesian%associate('cartesian',prog%cartesian,iter,error)
    if (error) return
    call polar%allocate('polar',prog%polar,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,cartesian,polar,error)
      if (error) return
    enddo ! ie
  end subroutine cubemain_polar_prog_loop
  !   
  subroutine cubemain_polar_prog_act(prog,ie,cartesian,polar,error)
    use cubeadm_image_types
    use cubetools_nan
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(polar_prog_t),  intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(image_t),        intent(inout) :: cartesian
    type(image_t),        intent(inout) :: polar
    logical,              intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy,ir,ia
    character(len=*), parameter :: rname='POLAR>PROG>ACT'
    !
    call cartesian%get(ie,error)
    if (error) return
    polar%val = gr4nan
    do iy=1,cartesian%ny
       do ix=1,cartesian%nx
          do ir=prog%rindices(1,ix,iy),prog%rindices(2,ix,iy)
             do ia=prog%aindices(1,ix,iy),prog%aindices(2,ix,iy)
                polar%val(ia,ir) = cartesian%val(ix,iy)
             enddo ! ia
          enddo ! ir
       enddo ! ix
    enddo ! iy
    call polar%put(ie,error)
    if (error) return
  end subroutine cubemain_polar_prog_act
end module cubemain_polar
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_header_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_header_interface
  use cubetools_axset_types
  use cubetools_header_array_types
  use cubetools_spectral_prog_types
  use cubetools_spectral_consistency_types
  use cubetools_spatial_types
  use cubetools_observatory_types
  !
  public :: cube_header_t,cube_header_cons_t
  public :: cubetools_header_import_and_derive,cubetools_header_export
  public :: cubetools_header_rederive,cubetools_header_final
  public :: cubetools_header_sicdef,cubetools_header_copy
  public :: cubetools_header_consistency_init,cubetools_header_consistency_final
  public :: cubetools_header_consistency_check,cubetools_header_consistency_list
  public :: cubetools_header_consistency_set_tol
  public :: cubetools_header_modify ! *** JP: Should be part of the spectral type
  private
  !
  logical, parameter :: genuine = .true.
  !
  type cube_header_t
     type(axset_t)         :: set ! Description of all available data axes
     type(array_t)         :: arr ! Description of data array
     type(spectral_prog_t) :: spe ! Description of the spectral axis when available
     type(spatial_t)       :: spa ! Description of the spatial  axes when available
     type(observatory_t)   :: obs ! Description of the (virtual) observatory
   contains
     procedure, public :: init => cubetools_header_init
     procedure, public :: list => cubetools_header_list
  end type cube_header_t
  !
  type cube_header_cons_t
     logical                  :: prob =.false. ! Is there a problem
     logical                  :: mess =.true.  ! Output message for the consistency
     type(axset_cons_t)       :: set ! Consistency of the axset
     type(array_cons_t)       :: arr ! Consistency of the data array
     type(spatial_cons_t)     :: spa ! Consistency of the spatial section
     type(spectral_cons_t)    :: spe ! Consistency of the spectral section
     type(observatory_cons_t) :: obs ! Consistency of the observatory section
  end type cube_header_cons_t
  !
contains
  !
  subroutine cubetools_header_init(head,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(cube_header_t), intent(inout) :: head
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_axset_init(head%set,error)
    if (error) return
    call cubetools_array_init(head%arr,error)
    if (error) return
    call cubetools_spatial_init(head%spa,error)
    if (error) return
    call head%spe%init(error)
    if (error) return
    call cubetools_observatory_init(head%obs,error)
    if (error) return
  end subroutine cubetools_header_init
  !
  subroutine cubetools_header_import_and_derive(in,head,error)
    use cubetools_unit
    use cubetools_header_interface
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cube_header_interface_t), intent(in)    :: in
    type(cube_header_t),           intent(inout) :: head
    logical,                       intent(inout) :: error
    !
    integer(kind=ndim_k) :: ix,iy,ic,idim,ndim
    integer(kind=data_k) :: nx,ny,nc
    real(kind=coor_k) :: channel
    !
    logical :: axset_genuine(maxdim)
    real(kind=coor_k) :: convert(3,maxdim)
    integer(kind=code_k) :: kind(maxdim)
    integer(kind=data_k) :: dim(maxdim)
    character(len=unit_l) :: name(maxdim),unit(maxdim)
    !
    character(len=*), parameter :: rname='HEADER>IMPORT>AND>DERIVE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
!!$ JP: for debugging
!!$    call in%list(error)
!!$    if (error) return
    !
    ! Sanity
    call in%sanity_xyc(error)
    if (error)  return
    !
    ! A bit of preparation
    if (in%axset_ndim.le.maxdim) then
       ndim = in%axset_ndim
    else
       call cubeheader_message(headseve%others,rname,'Larger number of dimensions than room to store it! => Truncating')
       ndim = maxdim
    endif
    dim = 0
    dim(1:ndim) = in%axset_dim(1:ndim)
    do idim = 1,maxdim
       if (idim.le.ndim) then
          convert(:,idim) = in%axset_convert(:,idim)
       else
          convert(:,idim) = [0d0,0d0,1d0]  ! For derived dimensions, if any
       endif
    enddo ! idim
    name = strg_unk  ! For derived dimensions, if any
    name(1:ndim) = in%axset_name(1:ndim)
    unit = strg_unk  ! For derived dimensions, if any
    unit(1:ndim) = in%axset_unit(1:ndim)
    kind = code_unit_unk  ! For derived dimensions, if any
    kind(1:ndim) = in%axset_kind(1:ndim)
    axset_genuine = .not.genuine  ! For derived dimensions, if any
    axset_genuine(1:ndim) = genuine
    ! Add derived dimensions if needed:
    call in%derive_xyc(ix,nx,iy,ny,ic,nc,ndim,dim,name,unit,kind,error)
    if (error)  return
    channel = convert(1,ic)
    nc = dim(ic)
    !
    call cubetools_axset_put_and_derive(axset_genuine,&
         name,unit,kind,ndim,dim,convert,ix,iy,ic,&
         head%set,error)
    if (error) return
    ! *** JP: Unclear to me whether we should use in%array_unit or unit?
    call cubetools_array_put_and_derive(&
         in%array_type,in%array_unit,&
         in%axset_ndim,in%axset_dim,&
         nx,ny,nc,&
         in%array_minval,in%array_minloc,&
         in%array_maxval,in%array_maxloc,&
         in%array_noise,in%array_rms,&
!        in%array_nan,&
         head%arr,error)
    if (error) return
    call head%arr%min%associate(head%set%il,head%set%im,head%set%ic,error)
    if (error)  return
    call head%arr%max%associate(head%set%il,head%set%im,head%set%ic,error)
    if (error)  return
    !
    call cubetools_spatial_put_and_derive(&
         in%spatial_source,in%spatial_frame_code,in%spatial_frame_equinox,&
         in%spatial_projection_code,in%spatial_projection_l0,in%spatial_projection_m0,in%spatial_projection_pa,&
         in%spatial_beam_major,in%spatial_beam_minor,in%spatial_beam_pa,&
         head%set%axis(ix),head%set%axis(iy),&
         head%spa,error)
    if (error) return
    call head%spe%put_and_derive(axset_genuine(ic),&
         in%spectral_frame_code,in%spectral_convention,&
         in%spectral_line,nc,channel,&
         in%spectral_code,in%spectral_increment_value,in%spectral_signal_value,in%spectral_image_value,&
         in%spectral_systemic_code,in%spectral_systemic_value,&
         error)
    if (error) return
    call cubetools_observatory_put_and_derive(in%obs,head%obs,error)
    if (error) return
  end subroutine cubetools_header_import_and_derive
  !
  subroutine cubetools_header_export(head,out,error)
    use cubetools_unit
    use cubetools_header_interface
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cube_header_t),           intent(in)    :: head
    type(cube_header_interface_t), intent(inout) :: out
    logical,                       intent(inout) :: error
    !
    integer(kind=ndim_k) :: idim,jdim,ndim
    integer(kind=data_k) :: nx,ny,nc
    !
    logical :: axset_genuine(maxdim)
    real(kind=coor_k) :: convert(3,maxdim)
    integer(kind=code_k) :: kind(maxdim)
    integer(kind=data_k) :: dim(maxdim),minloc(maxdim),maxloc(maxdim)
    character(len=unit_l) :: name(maxdim),unit(maxdim)
    !
    character(len=*), parameter :: rname='HEADER>EXPORT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_axset_get(head%set,&
         axset_genuine,name,unit,kind,&
         ndim,dim,convert,&
         out%axset_ix,out%axset_iy,out%axset_ic,&
         error)
    if (error) return
    jdim = 0
    do idim = 1,ndim
       if (axset_genuine(idim)) then
          jdim = jdim+1
          out%axset_name(jdim) = name(idim)
          out%axset_unit(jdim) = unit(idim)
          out%axset_kind(jdim) = kind(idim)
          out%axset_dim(jdim) = dim(idim)
          out%axset_convert(:,jdim) = convert(:,idim)
       else
          ! Non-genuine dimensions are not exported to the interface
          ! (operation opposite to cubetools_header_interface_derive_xyc)
          ! => take care of ix/iy/ic
          ! 1) Neutralize current dimension
          if (out%axset_ix.eq.idim)  out%axset_ix = 0
          if (out%axset_iy.eq.idim)  out%axset_iy = 0
          if (out%axset_ic.eq.idim)  out%axset_ic = 0
          ! 2) Shift upper dimension
          if (out%axset_ix.gt.idim)  out%axset_ix = out%axset_ix-1
          if (out%axset_iy.gt.idim)  out%axset_iy = out%axset_iy-1
          if (out%axset_ic.gt.idim)  out%axset_ic = out%axset_ic-1
       endif
    enddo ! idim
    out%axset_ndim = jdim
    do idim = jdim+1,maxdim
       out%axset_name(idim) = strg_unk
       out%axset_unit(idim) = strg_unk
       out%axset_kind(idim) = code_unit_unk
       out%axset_dim(idim)  = 0
       out%axset_convert(:,idim) = [0d0,0d0,1d0]
    enddo ! idim
    if (out%axset_ix.gt.out%axset_ndim) out%axset_ix = 0
    if (out%axset_iy.gt.out%axset_ndim) out%axset_iy = 0
    if (out%axset_ic.gt.out%axset_ndim) out%axset_ic = 0
    !
    call cubetools_array_get(head%arr,&
         out%array_type,out%array_unit,&
         ndim,dim,&
         nx,ny,nc,&
         out%array_minval,minloc,&
         out%array_maxval,maxloc,&
         out%array_noise,out%array_rms,&
!        out%array_nan,&
         error)
    ! maxloc and minloc are truncating when needed
    out%array_minloc = 0
    out%array_maxloc = 0
    out%array_minloc(1:ndim) = minloc(1:ndim)
    out%array_maxloc(1:ndim) = maxloc(1:ndim)
    call cubetools_spatial_get(head%spa,&
         out%spatial_source,out%spatial_frame_code,out%spatial_frame_equinox,&
         out%spatial_projection_code,out%spatial_projection_l0,out%spatial_projection_m0,out%spatial_projection_pa,&
         out%spatial_beam_major,out%spatial_beam_minor,out%spatial_beam_pa,&
         error)
    if (error) return
    call head%spe%get(&
         out%spectral_frame_code,out%spectral_convention,&
         out%spectral_line,&
         out%spectral_code,out%spectral_increment_value,out%spectral_signal_value,out%spectral_image_value,&
         out%spectral_systemic_code,out%spectral_systemic_value,&
         error)
    if (error) return
    call cubetools_observatory_get(head%obs,out%obs,error)
    if (error) return
!!$    !
!!$    call out%list(error)
!!$    if (error) return
  end subroutine cubetools_header_export
  !
  subroutine cubetools_header_final(head,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cube_header_t), intent(inout) :: head
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_axset_final(head%set,error)
    if (error) return
    call cubetools_array_final(head%arr,error)
    if (error) return
    call cubetools_spatial_final(head%spa,error)
    if (error) return
    call head%spe%final(error)
    if (error) return
    call cubetools_observatory_final(head%obs,error)
    if (error) return
  end subroutine cubetools_header_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_header_rederive(head,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(cube_header_t), intent(inout) :: head
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>REDERIVE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_axset_rederive(head%set,error)
    if (error) return
!!$    call cubetools_array_rederive(head%arr,error)
!!$    if (error) return
!!$    call cubetools_spatial_rederive(head%spa,error)
!!$    if (error) return
    call head%spe%rederive(error)
    if (error) return
!!$    call cubetools_observatory_rederive(head%obs,error)
!!$    if (error) return
  end subroutine cubetools_header_rederive
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_header_list(head,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(cube_header_t), intent(in)    :: head
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_axset_list(head%set,error)
    if (error) return
    call cubetools_array_list(head%arr,error)
    if (error) return
    call head%spe%list(error)
    if (error) return
    call cubetools_spatial_list(head%spa,error)
    if (error) return
    call cubetools_observatory_list(head%obs,error)
    if (error) return
  end subroutine cubetools_header_list
  !
  subroutine cubetools_header_sicdef(name,head,readonly,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*),    intent(in)    :: name
    type(cube_header_t), intent(in)    :: head
    logical,             intent(in)    :: readonly
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>SICDEF'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call sic_defstructure(name,global,error)
    if (error) return
    call cubetools_axset_sicdef(trim(name)//'%set',head%set,readonly,error)
    if (error) return
    call cubetools_array_sicdef(trim(name)//'%arr',head%arr,readonly,error)
    if (error) return
    call head%spe%obsolete_sicdef(trim(name)//'%spe',readonly,error)
    if (error) return
    call cubetools_spatial_sicdef(trim(name)//'%spa',head%spa,readonly,error)
    if (error) return
    call cubetools_observatory_sicdef(trim(name)//'%obs',head%obs,readonly,error)
    if (error) return
  end subroutine cubetools_header_sicdef
  !
  subroutine cubetools_header_copy(in,ou,error)
    !----------------------------------------------------------------------
    ! Copies one Header into another and properly initializes the
    ! second header
    !----------------------------------------------------------------------
    type(cube_header_t), intent(in)    :: in
    type(cube_header_t), intent(inout) :: ou
    logical,             intent(inout) :: error
    !
    integer(kind=ndim_k) :: il,im
    character(len=*), parameter :: rname='HEADER>COPY'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_axset_copy(in%set,ou%set,error)
    if (error) return
    call cubetools_array_copy(in%arr,ou%arr,error)
    if (error) return
    call in%spe%copyto(ou%spe,error)
    if (error) return
    il = in%set%il
    im = in%set%im
    call cubetools_spatial_copy(ou%set%axis(il),ou%set%axis(im),in%spa,ou%spa,error)
    if (error) return
    call cubetools_observatory_copy(in%obs,ou%obs,error)
    if (error) return
  end subroutine cubetools_header_copy
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_header_consistency_init(cons,error)
    !-------------------------------------------------------------------
    ! Initializes a header consistency object to intelligent defaults
    !-------------------------------------------------------------------
    type(cube_header_cons_t), intent(out)   :: cons
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>CONSISTENCY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_array_consistency_init(cons%arr,error)
    if (error) return
    call cubetools_axset_consistency_init(cons%set,error)
    if (error) return
    call cubetools_spatial_consistency_init(cons%spa,error)
    if (error) return
    call cons%spe%init(error)
    if (error) return
    call cubetools_observatory_consistency_init(cons%obs,error)
    if (error) return
    !
  end subroutine cubetools_header_consistency_init
  !
  subroutine cubetools_header_consistency_set_tol(spatol,beatol,spetol,cons,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    real(kind=tole_k),        intent(in)    :: spatol
    real(kind=tole_k),        intent(in)    :: beatol
    real(kind=tole_k),        intent(in)    :: spetol
    type(cube_header_cons_t), intent(inout) :: cons
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>CONSISTENCY>SET>TOL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_spatial_consistency_set_tol(spatol,beatol,cons%spa,error)
    if (error) return
    call cons%spe%set_tol(spetol,error)
    if (error) return
  end subroutine cubetools_header_consistency_set_tol
  !
  subroutine cubetools_header_consistency_check(cons,head1,head2,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cube_header_cons_t), intent(inout) :: cons
    type(cube_header_t),      intent(in)    :: head1
    type(cube_header_t),      intent(in)    :: head2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>CONSISTENCY>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !    
    cons%prob=.false.
    call cubetools_array_consistency_check(cons%arr,head1%arr,head2%arr,error)
    if (error) return
    call cubetools_axset_consistency_check(cons%set,head1%set,head2%set,error)
    if (error) return
    call cubetools_spatial_consistency_check(cons%spa,head1%spa,head2%spa,error)
    if (error) return
    call cons%spe%check(head1%spe,head2%spe,error)
    if (error) return
    call cubetools_observatory_consistency_check(cons%obs,head1%obs,head2%obs,error)
    if (error) return
    !
    cons%prob = cons%arr%prob.or.cons%set%prob.or.cons%spa%prob.or.cons%spe%prob.or.cons%obs%prob
    !
  end subroutine cubetools_header_consistency_check
  !
  subroutine cubetools_header_consistency_list(cons,head1,head2,error)
    use cubetools_consistency_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cube_header_cons_t), intent(in)    :: cons
    type(cube_header_t),      intent(in)    :: head1
    type(cube_header_t),      intent(in)    :: head2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>CONSISTENCY>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%mess) return
    !
    call cubetools_consistency_title('Headers',1,.true.,cons%prob,error)
    if (error) return
    if (cons%prob) then
       call cubetools_array_consistency_list(cons%arr,head1%arr,head2%arr,error)
       if (error) return
       call cubetools_axset_consistency_list(cons%set,head1%set,head2%set,error)
       if (error) return
       call cubetools_spatial_consistency_list(cons%spa,head1%spa,head2%spa,error)
       if (error) return
       call cons%spe%list(head1%spe,head2%spe,error)
       if (error) return
       call cubetools_observatory_consistency_list(cons%obs,head1%obs,head2%obs,error)
    if (error) return
    endif
  end subroutine cubetools_header_consistency_list
  !
  subroutine cubetools_header_consistency_final(cons,error)
    !-------------------------------------------------------------------
    ! Finalizes a header consistency object
    !-------------------------------------------------------------------
    type(cube_header_cons_t), intent(out)   :: cons
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>CONSISTENCY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_array_consistency_final(cons%arr,error)
    if (error) return
    call cubetools_axset_consistency_final(cons%set,error)
    if (error) return
    call cubetools_spatial_consistency_final(cons%spa,error)
    if (error) return
    call cons%spe%final(error)
    if (error) return
    call cubetools_observatory_consistency_final(cons%obs,error)
    if (error) return
  end subroutine cubetools_header_consistency_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_header_modify(head,voff,freq,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_header_t), intent(inout) :: head
    real(kind=coor_k),   intent(in)    :: voff
    real(kind=coor_k),   intent(in)    :: freq
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>MODIFY'
    !
    call cubeheader_message(seve%e,rname,'Not working anymore')
    error = .true.
    return
  end subroutine cubetools_header_modify  
end module cubetools_header_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_speelt_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_consistency_types
  !
  public :: speelt_t, speelt_cons_t
  public :: cubetools_speelt_init,cubetools_speelt_get_and_derive
  public :: cubetools_speelt_final,cubetools_speelt_put
  public :: cubetools_speelt_list,cubetools_speelt_sicdef,cubetools_speelt_copy
  public :: cubetools_speelt_consistency_check,cubetools_speelt_consistency_list
  public :: cubetools_speelt_consistency_init,cubetools_speelt_consistency_final
  public :: cubetools_speelt_consistency_set_tol
  private
  !
  type speelt_t
     real(kind=coor_k) :: c = 0d0 ! [----] Channel
     real(kind=coor_k) :: f = 0d0 ! [ MHz] Signal frequency
     real(kind=coor_k) :: i = 0d0 ! [ MHz] Image frequency
     real(kind=coor_k) :: l = 0d0 ! [ mum] Wavelength
     real(kind=coor_k) :: v = 0d0 ! [km/s] Systemic velocity
     real(kind=coor_k) :: z = 0d0 ! [----] Systemic redshift
  end type speelt_t
  !
  type speelt_cons_t
     logical                    :: check=.true.  ! Check the section
     logical                    :: prob =.false. ! Is there a problem
     logical                    :: mess =.true.  ! Output message for this section?
     type(consistency_desc_t)   :: c  ! Channel consistency          
     type(consistency_desc_t)   :: f  ! Frequency consisntency
     type(consistency_desc_t)   :: i  ! Image frequency consistency
     type(consistency_desc_t)   :: l  ! Wavelength consistency
     type(consistency_desc_t)   :: v  ! Velocity consistency
     type(consistency_desc_t)   :: z  ! Redshift consistency
  end type speelt_cons_t
  !
contains
  !
  subroutine cubetools_speelt_init(speelt,error)
    !-------------------------------------------------------------------
    ! Just initialize the type, ie, set it intent(out)
    !-------------------------------------------------------------------
    type(speelt_t), intent(out)   :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_speelt_init
  !
  subroutine cubetools_speelt_get_and_derive(speelt,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(speelt_t), intent(inout) :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>GET>AND>DERIVE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
!!$    speelt%l => lval
!!$    speelt%m => mval
  end subroutine cubetools_speelt_get_and_derive
  !
  subroutine cubetools_speelt_put(speelt,error)
    !-------------------------------------------------------------------
    ! Empty method on purpose as speelt is a pointer set
    !-------------------------------------------------------------------
    type(speelt_t), intent(in)    :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>PUT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_speelt_put
  !
  subroutine cubetools_speelt_final(speelt,error)
    !-------------------------------------------------------------------
    ! Just reinitialize the type, ie, set it intent(out)
    !-------------------------------------------------------------------
    type(speelt_t), intent(out)   :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_speelt_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_speelt_list(speelt,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! Empty method until there is a clear usecase
    !-------------------------------------------------------------------
    type(speelt_t), intent(in)    :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_speelt_list
  !
  subroutine cubetools_speelt_sicdef(name,elt,readonly,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    type(speelt_t),   intent(in)    :: elt
    logical,          intent(in)    :: readonly
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>SICDEF'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call sic_defstructure(name,global,error)
    if (error) return 
    call sic_def_dble(trim(name)//'%C',elt%c,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%F',elt%f,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%I',elt%i,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%L',elt%l,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%V',elt%v,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%Z',elt%z,0,0,readonly,error)
    if (error) return
  end subroutine cubetools_speelt_sicdef
  !
  subroutine cubetools_speelt_copy(in,ou,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(speelt_t), intent(in)    :: in
    type(speelt_t), intent(out)   :: ou
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>COPY'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    ou = in
  end subroutine cubetools_speelt_copy
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_speelt_consistency_init(cons,error)
    !----------------------------------------------------------------------
    ! Init spectral element consistency
    !----------------------------------------------------------------------
    type(speelt_cons_t), intent(inout) :: cons
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_init(strict,check,mess,cons%c,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%f,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%i,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%l,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%v,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%z,error)
    if (error) return
  end subroutine cubetools_speelt_consistency_init
  !
  subroutine cubetools_speelt_consistency_set_tol(elttol,cons,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    real(kind=tole_k),   intent(in)    :: elttol
    type(speelt_cons_t), intent(inout) :: cons
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>SET>TOL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    cons%c%tol = elttol
    cons%f%tol = elttol
    cons%i%tol = elttol
    cons%l%tol = elttol
    cons%v%tol = elttol
    cons%z%tol = elttol
  end subroutine cubetools_speelt_consistency_set_tol
  !
  subroutine cubetools_speelt_consistency_check(cons,inc1,ref1,inc2,ref2,error)
    !----------------------------------------------------------------------
    ! Check spectral element consistency
    !----------------------------------------------------------------------
    type(speelt_cons_t), intent(inout) :: cons
    type(speelt_t),      intent(in)    :: inc1
    type(speelt_t),      intent(in)    :: ref1
    type(speelt_t),      intent(in)    :: inc2
    type(speelt_t),      intent(in)    :: ref2
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    call cubetools_consistency_real_relative_check(cons%c,inc1%c,ref1%c,inc2%c,ref2%c,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%f,inc1%f,ref1%f,inc2%f,ref2%f,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%i,inc1%i,ref1%i,inc2%i,ref2%i,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%l,inc1%l,ref1%l,inc2%l,ref2%l,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%v,inc1%v,ref1%v,inc2%v,ref2%v,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%z,inc1%z,ref1%z,inc2%z,ref2%z,error)
    if (error) return
    !
    cons%prob = cons%c%prob.or.cons%f%prob.or.cons%i%prob.or.cons%l%prob.or.cons%v%prob.or.cons%z%prob
  end subroutine cubetools_speelt_consistency_check
  !
  subroutine cubetools_speelt_consistency_list(cons,ref1,ref2,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    ! Print spectral element consistency
    !----------------------------------------------------------------------
    type(speelt_cons_t), intent(in)    :: cons
    type(speelt_t),      intent(in)    :: ref1
    type(speelt_t),      intent(in)    :: ref2
    logical,             intent(inout) :: error
    !
    type(unit_user_t) :: unitfreq,unitvelo
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%mess) return
    !
    call cubetools_consistency_title('spectral references',3,cons%check,cons%prob,error)
    if (error) return
    if (cons%check.and.cons%prob) then
       call unitfreq%get_from_code(code_unit_freq,error)
       if (error) return
       call unitvelo%get_from_code(code_unit_velo,error)
       if (error) return
       call cubetools_consistency_real_print('Channel',cons%c,ref1%c,ref2%c,error)
       if (error) return
       call cubetools_consistency_real_print('Rest frequency',unitfreq%name,cons%f,&
            ref1%f*unitfreq%user_per_prog,ref2%f*unitfreq%user_per_prog,error)
       if (error) return
       call cubetools_consistency_real_print('Image frequency',unitfreq%name,cons%i,&
            ref1%i*unitfreq%user_per_prog,ref2%i*unitfreq%user_per_prog,error)
       if (error) return
       call cubetools_consistency_real_print('Wavelength','mum',cons%l,ref1%l,ref2%l,error)
       if (error) return
       call cubetools_consistency_real_print('Velocity',unitvelo%name,cons%v,ref1%v*unitvelo%user_per_prog,&
            ref2%v*unitvelo%user_per_prog,error)
       if (error) return
       call cubetools_consistency_real_print('Redshift',cons%z,ref1%z,ref2%z,error)
       if (error) return
    endif
    call cubeheader_message(seve%r,rname,'')
  end subroutine cubetools_speelt_consistency_list
  !
  subroutine cubetools_speelt_consistency_final(cons,error)
    !----------------------------------------------------------------------
    ! Final spectral element consistency
    !----------------------------------------------------------------------
    type(speelt_cons_t), intent(inout) :: cons
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_final(cons%c,error)
    if (error) return
    call cubetools_consistency_final(cons%f,error)
    if (error) return
    call cubetools_consistency_final(cons%i,error)
    if (error) return
    call cubetools_consistency_final(cons%l,error)
    if (error) return
    call cubetools_consistency_final(cons%v,error)
    if (error) return
    call cubetools_consistency_final(cons%z,error)
    if (error) return
  end subroutine cubetools_speelt_consistency_final
end module cubetools_speelt_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_operdir_types
  use cubetools_parameters
  use cubesyntax_key_types
  use cubecompute_messaging
  !
  public :: code_operdir_direct,code_operdir_inverse,code_operdir_default
  public :: operdir_comm_t,operdir_user_t,operdir_prog_t
  private
  !
  integer(kind=code_k), parameter :: code_operdir_direct  = +1 ! To be compatible with fourt
  integer(kind=code_k), parameter :: code_operdir_inverse = -1 ! To be compatible with fourt
  integer(kind=code_k), parameter :: code_operdir_default =  0 ! Results will depend on context
  !  
  type operdir_comm_t
     type(key_comm_t), private :: direct
     type(key_comm_t), private :: inverse
   contains
     procedure, public :: register => cubecompute_operdir_comm_register
     procedure, public :: parse    => cubecompute_operdir_comm_parse
  end type operdir_comm_t
  !
  type operdir_user_t
     type(key_user_t), private :: direct
     type(key_user_t), private :: inverse
   contains
     procedure, public :: toprog => cubecompute_operdir_user_toprog
     procedure, public :: list   => cubecompute_operdir_user_list
  end type operdir_user_t
  !
  type operdir_prog_t
     integer(kind=code_k) :: code = code_operdir_default
   contains
     procedure, public :: list => cubecompute_operdir_prog_list
  end type operdir_prog_t
  !
contains
  !
  subroutine cubecompute_operdir_comm_register(comm,dabstract,iabstract,error)
    use cubetools_flag_types
    !----------------------------------------------------------------------
    ! Register "[ /DIRECT | /INVERSE ]" key pair
    !----------------------------------------------------------------------
    class(operdir_comm_t), intent(inout) :: comm
    character(len=*),      intent(in)    :: dabstract
    character(len=*),      intent(in)    :: iabstract
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPERDIR>COMM>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call comm%direct%register(&
         'DIRECT',&
         dabstract,&
         strg_emp,&
         error)
    if (error) return
    call comm%inverse%register(&
         'INVERSE',&
         iabstract,&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubecompute_operdir_comm_register
  !
  subroutine cubecompute_operdir_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(operdir_comm_t), intent(in)    :: comm
    character(len=*),      intent(in)    :: line
    class(operdir_user_t), intent(inout) :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPERDIR>COMM>PARSE'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call comm%direct%parse(line,user%direct,error)
    if (error) return
    call comm%inverse%parse(line,user%inverse,error)
    if (error) return
  end subroutine cubecompute_operdir_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubecompute_operdir_user_toprog(user,comm,prog,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(operdir_user_t), intent(in)    :: user
    class(operdir_comm_t), intent(in)    :: comm
    class(operdir_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(key_prog_t) :: direct,inverse
    character(len=*), parameter :: rname='OPERDIR>USER>TOPROG'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call user%direct%toprog(comm%direct,direct,error)
    if (error) return
    call user%inverse%toprog(comm%inverse,inverse,error)
    if (error) return
    if (direct%act.and.inverse%act) then
       call cubecompute_message(seve%e,rname,'DIRECT and INVERSE keys are mutually exclusive')
       error = .true.
       return
    else if ((.not.direct%act).and.(.not.inverse%act)) then
       prog%code = code_operdir_default
    else
       if (direct%act) then
          prog%code = code_operdir_direct
       else
          prog%code = code_operdir_inverse
       endif
    endif
  end subroutine cubecompute_operdir_user_toprog
  !
  subroutine cubecompute_operdir_user_list(user,error)
    !----------------------------------------------------------------------
    ! For debugging purposes
    !----------------------------------------------------------------------
    class(operdir_user_t), intent(in)    :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPERDIR>USER>LIST'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    ! ***JP: to be written
  end subroutine cubecompute_operdir_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubecompute_operdir_prog_list(prog,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(operdir_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPERDIR>PROG>LIST'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    select case (prog%code)
    case (code_operdir_direct)
       call cubecompute_message(computeseve%trace,rname,'Direct operation')
    case (code_operdir_inverse)
       call cubecompute_message(computeseve%trace,rname,'Inverse operation')
    case (code_operdir_default)
       call cubecompute_message(computeseve%trace,rname,'Default operation')
    case default
       call cubecompute_message(seve%e,rname,'Unknown operdir direction')
       error = .true.
       return
    end select
  end subroutine cubecompute_operdir_prog_list
end module cubecompute_operdir_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gfits_interfaces_public
#if defined(VAX)
  interface
    subroutine gdf_setblnk4(bval)
      !---------------------------------------------------------------------
      ! @ public
      !   Set the blanking for automatic conversions
      !---------------------------------------------------------------------
      real(4), intent(in) :: bval
    end subroutine gdf_setblnk4
  end interface
  !
  interface
    subroutine gdf_setblnk8(bval)
      !---------------------------------------------------------------------
      ! @ public
      !   Set the blanking for automatic conversions
      !---------------------------------------------------------------------
      real(8), intent(in) :: bval
    end subroutine gdf_setblnk8
  end interface
  !
#endif
#if defined(EEEI)
  interface
    subroutine gdf_setblnk4(bval)
      !---------------------------------------------------------------------
      ! @ public
      !   Set the blanking for automatic conversions
      !---------------------------------------------------------------------
      real(4), intent(in) :: bval
    end subroutine gdf_setblnk4
  end interface
  !
#endif
  interface
    subroutine fitreal(fd,ndat,array,scale,zero,error)
      use gbl_message
      use gfits_buf
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Write NDAT data values in FITS data area,
      ! with scaling SCALE and offset ZERO
      !---------------------------------------------------------------------
      type(gfits_hdesc_t), intent(inout) :: fd           !
      integer(kind=4),     intent(in)    :: ndat         ! Number of data elements
      real(kind=4),        intent(in)    :: array(ndat)  ! Data array
      real(kind=4),        intent(in)    :: scale        ! Scaling factor
      real(kind=4),        intent(in)    :: zero         ! Zero offset
      logical,             intent(inout) :: error        ! Error flag
    end subroutine fitreal
  end interface
  !
  interface
    subroutine fitreal_end(fd,error)
      use gfits_buf
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(gfits_hdesc_t), intent(inout) :: fd     !
      logical,             intent(inout) :: error  ! Error flag
    end subroutine fitreal_end
  end interface
  !
  interface
    subroutine gfits_getreal(fd,ndat,array,scal,zero,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read NDAT data values from FITS data area, with scaling SCALE and
      ! offset ZERO
      !---------------------------------------------------------------------
      type(gfits_hdesc_t),       intent(in)    :: fd           !
      integer(kind=size_length), intent(in)    :: ndat         ! Number of desired data values
      real(kind=4),              intent(inout) :: array(ndat)  ! Data values
      real(kind=4),              intent(in)    :: scal         ! Scale factor
      real(kind=4),              intent(in)    :: zero         ! Offset
      logical,                   intent(inout) :: error        ! Error flag
    end subroutine gfits_getreal
  end interface
  !
  interface
    subroutine gfits_putbuf(int1,nr,error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Write one row of a binary table to a FITS logical record
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: nr        ! Length of buffer
      integer(kind=1), intent(in)    :: int1(nr)  ! Buffer
      logical,         intent(inout) :: error     ! Error flag
    end subroutine gfits_putbuf
  end interface
  !
  interface
    subroutine gfits_getbuf(int1,nr,error)
      use gildas_def
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public-mandatory
      ! Get one row of a binary table from a FITS logical record
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: nr        ! Length of buffer
      integer(kind=1),           intent(inout) :: int1(nr)  ! Buffer
      logical,                   intent(inout) :: error     ! Error flag
    end subroutine gfits_getbuf
  end interface
  !
  interface
    subroutine gfits_skibuf(nb,error)
      use gildas_def
      use gfits_buf
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Skip NB bytes on input file
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: nb     ! Bytes to skip
      logical,                   intent(inout) :: error  ! Error flag
    end subroutine gfits_skibuf
  end interface
  !
  interface
    subroutine gfits_skidat(fd,ndat,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Skip NDAT data values from FITS data area,
      !---------------------------------------------------------------------
      type(gfits_hdesc_t),       intent(in)    :: fd     !
      integer(kind=size_length), intent(in)    :: ndat   ! Number of desired data values
      logical,                   intent(inout) :: error  ! Error flag
    end subroutine gfits_skidat
  end interface
  !
  interface
    subroutine gfits_goto_hdu(fd,khdu,error)
      use gildas_def
      use gbl_message
      use gfits_types
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Go to the requested HDU
      !---------------------------------------------------------------------
      type(gfits_hdesc_t), intent(inout) :: fd     !
      integer(kind=4),     intent(in)    :: khdu   ! Requested HDU (1=Primary)
      logical,             intent(inout) :: error  ! Error flag
    end subroutine gfits_goto_hdu
  end interface
  !
  interface
    subroutine gfits_list_hdus(name,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Go to the requested HDU
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: name   ! File name
      logical,          intent(inout) :: error  ! Error flag
    end subroutine gfits_list_hdus
  end interface
  !
  interface
    subroutine gfits_get(comm,argu,check,error,quiet,continue,comment,eof)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      !  Retrieve the next line of the FITS header
      !---------------------------------------------------------------------
      character(len=*), intent(out)           :: comm      ! Returned FITS keyword
      character(len=*), intent(out)           :: argu      ! Returned keyword value
      logical,          intent(in)            :: check     ! Printout FITS card
      logical,          intent(out)           :: error     ! Logical error flag
      logical,          intent(in),  optional :: quiet     ! Verbosity flag
      logical,          intent(in),  optional :: continue  ! Merge CONTINUE'd lines?
      character(len=*), intent(out), optional :: comment   !
      logical,          intent(out), optional :: eof       !
    end subroutine gfits_get
  end interface
  !
  interface
    subroutine gfits_put(line,check,error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      !       Write a FITS line of the header
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! FITS card image
      logical,          intent(in)    :: check  ! Verbose flag
      logical,          intent(inout) :: error  ! Error flag
    end subroutine gfits_put
  end interface
  !
  interface
    subroutine gfits_flush_data(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Write current FITS buffer to disk. It the buffer is not full, DATA
      ! is padded with ZEROES (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      ! ---
      ! Can be called in an error recovery context.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine gfits_flush_data
  end interface
  !
  interface
    subroutine gfits_flush_header(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Write current FITS buffer to disk. It the buffer is not full, HEADER
      ! is padded with BLANKS (Wells et al, A&A Sup. Ser 44, P.365, line 57)
      !---------------------------------------------------------------------
      logical, intent(out) :: error                 ! Error flag
    end subroutine gfits_flush_header
  end interface
  !
  interface
    subroutine gfits_hierarch(key,value,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Decode the 'value' as 'key' + new 'value' if input 'key' is
      ! HIERARCH.
      ! ---
      !  HIERARCH keyword convention is described here:
      !    http://fits.gsfc.nasa.gov/registry/hierarch_keyword.html
      !  Note that this is only a convention.
      !---------------------------------------------------------------------
      character(len=*), intent(out)   :: key    ! Output key
      character(len=*), intent(inout) :: value  ! Input/Output value
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gfits_hierarch
  end interface
  !
  interface
    function gfits_unquote(value)
      !---------------------------------------------------------------------
      ! @ public
      !  Unquote the input string (if any quotes) and return the value.
      ! Useful in the context of FITS headers where the strings are often
      ! single-quoted.
      !---------------------------------------------------------------------
      character(len=80) :: gfits_unquote  ! Function value on return
      character(len=*), intent(in) :: value
    end function gfits_unquote
  end interface
  !
  interface
    subroutine gfits_load_header(hdict,check,getsymbol,error)
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Load the FITS header in the dictionary structure.
      !  COMMENT lines are ignored
      !  HISTORY lines are ignored
      !  HIERARCH lines are interpreted as appropriate
      ! This could be customized
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(out)   :: hdict      !
      logical,             intent(in)    :: check      !
      external                           :: getsymbol  ! Symbol translation routine
      logical,             intent(inout) :: error      !
    end subroutine gfits_load_header
  end interface
  !
  interface
    subroutine gfits_check_simple(card,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Sanity check of the SIMPLE card in FITS header. This is generic for
      ! any FITS file.
      !---------------------------------------------------------------------
      type(fits_unkn_0d_t), intent(in)    :: card   !
      logical,              intent(inout) :: error  !
    end subroutine gfits_check_simple
  end interface
  !
  interface
    subroutine gfits_check_xtension(card,error,xkind)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Sanity check of the XTENSION card in FITS header. This is generic
      ! for any FITS file. Optionally check for the XTENSION kind.
      !---------------------------------------------------------------------
      type(fits_unkn_0d_t),       intent(in)    :: card   !
      logical,                    intent(inout) :: error  !
      character(len=*), optional, intent(in)    :: xkind  ! Desired XTENSION kind
    end subroutine gfits_check_xtension
  end interface
  !
  interface
    subroutine gfits_check_format(card,nbit,fmt,error)
      use gbl_format
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Translate BITPIX to internal format code. This is generic for any
      ! FITS file.
      !---------------------------------------------------------------------
      type(fits_unkn_0d_t), intent(in)    :: card   !
      integer(kind=4),      intent(out)   :: nbit   !
      integer(kind=4),      intent(out)   :: fmt    !
      logical,              intent(inout) :: error  !
    end subroutine gfits_check_format
  end interface
  !
  interface
    subroutine gfits_check_naxis(card,naxis,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Translate NAXIS. This is generic for any FITS extension.
      !---------------------------------------------------------------------
      type(fits_unkn_0d_t), intent(in)    :: card   !
      integer(kind=4),      intent(out)   :: naxis  !
      logical,              intent(inout) :: error  !
    end subroutine gfits_check_naxis
  end interface
  !
  interface
    subroutine gfits_check_naxisi(fhdict,dims,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Translate all the NAXISi. This is generic for any FITS extension.
      !---------------------------------------------------------------------
      type(gfits_hdict_t),        intent(in)    :: fhdict   !
      integer(kind=index_length), intent(out)   :: dims(:)  !
      logical,                    intent(inout) :: error    !
    end subroutine gfits_check_naxisi
  end interface
  !
  interface
    subroutine gfits_getnosymbol(symb,tran,error)
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      ! No symbol translation. 2 main use cases:
      ! - no symbol dictionary available in the current context, or
      ! - user should not be able to modify the critical elements (e.g.
      !   NAXIS*) needed in the context
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: symb   ! Symbol name
      character(len=*), intent(in)  :: tran   ! Symbol translation
      logical,          intent(out) :: error  ! Logical error flag
    end subroutine gfits_getnosymbol
  end interface
  !
  interface gfits_get_value
    subroutine gfits_get_char(fh,key,found,value,error)
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as character string. Quotes are removed if any. The output value is
      ! not modified if its key is not found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      character(len=*),    intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_char
    subroutine gfits_get_inte(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as an integer. The output value is not modified if its key is not
      ! found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      integer(kind=4),     intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_inte
    subroutine gfits_get_long(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as long integer. The output value is not modified if its key is not
      ! found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      integer(kind=8),     intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_long
    subroutine gfits_get_real(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as single precision float. The output value is not modified if its
      ! key is not found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      real(kind=4),        intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_real
    subroutine gfits_get_dble(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as double precision float. The output value is not modified if its
      ! key is not found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      real(kind=8),        intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_dble
    subroutine gfits_get_logi(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as a logical. The output value is not modified if its key is not
      ! found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      logical,             intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_logi
  end interface gfits_get_value
  !
  interface
    subroutine gfits_open(file,status,error,overwrite)
      use gfits_buf
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      ! FITS API routine
      !       Connect with a FITS file on disk.
      !---------------------------------------------------------------------
      character(len=*),  intent(in)    :: file       ! FITS file name
      character(len=*),  intent(in)    :: status     ! Read (IN) or Write (OUT) status
      logical,           intent(inout) :: error      ! Error flag
      logical, optional, intent(in)    :: overwrite  ! Overwrite in case of OUT status?
    end subroutine gfits_open
  end interface
  !
  interface
    subroutine gfits_close(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS API routine
      !       Disconnect from a FITS file, after flushing the data if needed
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Error flag
    end subroutine gfits_close
  end interface
  !
  interface
    subroutine gfits_skirec(nrec,error)
      use gildas_def
      use gfits_buf
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !       Skips a (positive or negative) number of FITS logical records
      !---------------------------------------------------------------------
      integer(kind=record_length), intent(in)    :: nrec   ! Number of records to skip
      logical,                     intent(inout) :: error  ! Error flag
    end subroutine gfits_skirec
  end interface
  !
  interface
    subroutine gfits_getrecnum(irecnum)
      use gildas_def
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !       Returns the number of the present FITS 2880-bytes record.
      !---------------------------------------------------------------------
      integer(kind=record_length), intent(out) :: irecnum  ! Current record number
    end subroutine gfits_getrecnum
  end interface
  !
  interface
    subroutine gfits_setrecnum(irecnum)
      use gildas_def
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API Routine
      !       Sets the number of the FITS 2880-bytes record.
      !---------------------------------------------------------------------
      integer(kind=record_length), intent(in) :: irecnum  ! Current record number
    end subroutine gfits_setrecnum
  end interface
  !
  interface
    subroutine gfits_getrecoffset(ioffset)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !       Returns the offset (in bytes) of the next data to be read
      !       inside the present 2880-bytes record.
      !---------------------------------------------------------------------
      integer(kind=4), intent(out) :: ioffset        ! Offset in current record
    end subroutine gfits_getrecoffset
  end interface
  !
  interface
    subroutine gfits_setrecoffset(ioffset)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !       Sets the offset (in bytes) of the next data to be read inside
      !       the present 2880-bytes record.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: ioffset          ! Offset in current record
    end subroutine gfits_setrecoffset
  end interface
  !
  interface
    subroutine gfits_getstdrec(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !     Get the next buffer internally
      !     Only used by CLASS 3dfits.f90
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Error flag
    end subroutine gfits_getstdrec
  end interface
  !
  interface
    function gfits_iseof()
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS API routine
      !     Tells if the FITS file has reached EOF
      !---------------------------------------------------------------------
      logical :: gfits_iseof                 ! intent(out)
    end function gfits_iseof
  end interface
  !
  interface
    subroutine gfits_rewind_file(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Rewind the pointers to start of file
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine gfits_rewind_file
  end interface
  !
  interface
    subroutine gfits_rewind_hdu(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Rewind the pointers to start of current HDU
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine gfits_rewind_hdu
  end interface
  !
  interface
    subroutine gfits_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gfits_message_set_id
  end interface
  !
end module gfits_interfaces_public

subroutine write_sdm_SourceParameter(error)
  !---------------------------------------------------------------------
  ! Write the SourceParameter SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_SourceParameter
  use sdm_Source
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type(SourceParameterRow) :: spRow
  type(SourceParameterKey) :: spKey
  type(SourceOpt) :: sOpt
  type(SourceKey) :: sKey
  integer :: ic, isb, ilc, numFreq, numStokes, numDep
  character sdmTable*16
  parameter (sdmTable='SourceParameter')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  spRow%numFreq = 1
  spRow%numStokes = 1
  !!spRow%numDep = 1
  call allocSourceParameterRow(spRow, error)
  spRow%flux = r_flux
  spRow%fluxErr = 0
  spRow%frequency = r_restf * 1d6
  ! need to be refined at some point
  spRow%frequencyInterval = 500d6
  spRow%stokesParameter = 0
  ! OPTIONAL IN SS2 ...      spRow%size = 0
  ! OPTIONAL IN SS2 ...      spRow%sizeErr = 0
  ! OPTIONAL IN SS2 ...      spRow%positionAngle = 0
  ! OPTIONAL IN SS2 ...      spRow%positionAngleErr = 0
  ! OPTIONAL IN SS2 ...      spRow%depSourceParameterId = -1
  !
  spKey%sourceId = source_Id
  spKey%timeInterval = ArrayTimeInterval(time_interval(1)   &
    ,time_interval(2))
  call addSourceParameterRow(spKey, spRow, error)
  if (error) return
  SourceParameter_Id  = spKey%sourceParameterId
  !
  ! Add this in SOurce Table
  !
  do ic = 1, r_lband
    do isb = 1, 2
      do ilc = 1, 2
        sKey%sourceId = source_Id
        sKey%spectralWindowId = spectralWindow_Id(isb,ic,ilc)
        !
        ! Use time_start for SOurce rows (to avoid writing unnecesasary rows)
        sKey%timeInterval = ArrayTimeInterval(time_start(1),   &
          time_start(2))
        sOpt%sourceParameterId = sourceParameter_Id
        call addSourceSourceParameterId(sKey, sOpt, error)
        if (error) return
      enddo
    enddo
  enddo
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_SourceParameter
!---------------------------------------------------------------------
!!! subroutine allocSourceParameterRow(row, numFreq, numStokes,   &
!!!     numDep, error)
!!!   !---------------------------------------------------------------------
!!!   !     integer, allocatable :: stokesParameter(:)
!!!   !     real*8, allocatable :: flux(:,:)
!!!   !     real*8, allocatable :: size(:,:)
!!!   !     real*8, allocatable :: positionAngle(:)
!!!   !     real*8, allocatable :: frequency(:)
!!!   !     real*8, allocatable :: frequencyInterval(:)
!!!   !     real*8, allocatable :: fluxErr(:,:)
!!!   !     real*8, allocatable :: sizeErr(:,:)
!!!   !     real*8, allocatable :: positionAngleErr(:)
!!!   !     integer, allocatable :: depSourceParameterId(:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_SourceParameter
!!!   type(SourceParameterRow) :: row
!!!   integer :: ier, numFreq, numStokes, numDep
!!!   logical :: error
!!!   character, parameter :: sdmTable*16 = 'SourceParameter'
!!!   !
!!!   ! stokeParameter(numStokes)
!!!   if (allocated(row%stokesParameter)) then
!!!     deallocate(row%stokesParameter, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%stokesParameter(numStokes), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! flux(numStokes, numFreq)
!!!   if (allocated(row%flux)) then
!!!     deallocate(row%flux, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%flux(numStokes, numFreq), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! size(2, numFreq)
!!!   ! OPTIONAL IN SS2 ...      if (allocated(row%size)) then
!!!   ! OPTIONAL IN SS2 ...         deallocate(row%size, stat=ier)
!!!   ! OPTIONAL IN SS2 ...         if (ier.ne.0) goto 98
!!!   ! OPTIONAL IN SS2 ...      endif
!!!   ! OPTIONAL IN SS2 ...      allocate(row%size(2, numFreq), stat=ier)
!!!   ! OPTIONAL IN SS2 ...      if (ier.ne.0) goto 99
!!!   !
!!!   ! positionAngle(numFreq)
!!!   ! OPTIONAL IN SS2 ...      if (allocated(row%positionAngle)) then
!!!   ! OPTIONAL IN SS2 ...         deallocate(row%positionAngle, stat=ier)
!!!   ! OPTIONAL IN SS2 ...         if (ier.ne.0) goto 98
!!!   ! OPTIONAL IN SS2 ...      endif
!!!   ! OPTIONAL IN SS2 ...      allocate(row%positionAngle(numFreq), stat=ier)
!!!   ! OPTIONAL IN SS2 ...      if (ier.ne.0) goto 99
!!!   !
!!!   ! frequency(numFreq)
!!!   if (allocated(row%frequency)) then
!!!     deallocate(row%frequency, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%frequency(numFreq), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! frequencyInterval(numFreq)
!!!   if (allocated(row%frequencyInterval)) then
!!!     deallocate(row%frequencyInterval, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%frequencyInterval(numFreq), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! fluxErr(numStokes, numFreq)
!!!   if (allocated(row%fluxErr)) then
!!!     deallocate(row%fluxErr, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%fluxErr(numStokes, numFreq), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! sizeErr(2, numFreq)
!!!   ! OPTIONAL IN SS2 ...      if (allocated(row%sizeErr)) then
!!!   ! OPTIONAL IN SS2 ...         deallocate(row%sizeErr, stat=ier)
!!!   ! OPTIONAL IN SS2 ...         if (ier.ne.0) goto 98
!!!   ! OPTIONAL IN SS2 ...      endif
!!!   ! OPTIONAL IN SS2 ...      allocate(row%sizeErr(2, numFreq), stat=ier)
!!!   ! OPTIONAL IN SS2 ...      if (ier.ne.0) goto 99
!!!   !
!!!   ! positionAngleErr(numFreq)
!!!   ! OPTIONAL IN SS2 ...      if (allocated(row%positionAngleErr)) then
!!!   ! OPTIONAL IN SS2 ...         deallocate(row%positionAngleErr, stat=ier)
!!!   ! OPTIONAL IN SS2 ...         if (ier.ne.0) goto 98
!!!   ! OPTIONAL IN SS2 ...      endif
!!!   ! OPTIONAL IN SS2 ...      allocate(row%positionAngleErr(numFreq), stat=ier)
!!!   ! OPTIONAL IN SS2 ...      if (ier.ne.0) goto 99
!!!   !
!!!   ! depSourceParameterId(numDep)
!!!   ! OPTIONAL IN SS2 ...      if (allocated(row%depSourceParameterId)) then
!!!   ! OPTIONAL IN SS2 ...         deallocate(row%depSourceParameterId, stat=ier)
!!!   ! OPTIONAL IN SS2 ...         if (ier.ne.0) goto 98
!!!   ! OPTIONAL IN SS2 ...      endif
!!!   ! OPTIONAL IN SS2 ...      allocate(row%depSourceParameterId(numDep), stat=ier)
!!!   ! OPTIONAL IN SS2 ...      if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!!! !---------------------------------------------------------------------

module clic_interfaces_public
  !-------------------------------------------------------------------------
  !  CLIC public interfaces (used by MRTHOLO), generated once since CLIC
  ! does not yet generates automatically its interfaces
  !-------------------------------------------------------------------------
  !
  interface
    subroutine ipb_write(chain,check,error)
      use classic_api
      !---------------------------------------------------------------------
      ! @ public
      !  Write a scan
      ! Argument:
      ! CHAIN   C*(*)   Write status ('NEW', 'EXTEND', 'UPDATE'
      !       CHECK     L       Check for duplicate write
      ! ERROR   L       Error return
      !---------------------------------------------------------------------
      character(len=*) :: chain         !
      logical :: check                  !
      logical :: error                  !
    end subroutine ipb_write
  end interface
  !
  interface
    subroutine ipb_close(error)
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      !         Close an observation. Reopens the output file.
      !---------------------------------------------------------------------
      logical :: error                  !
    end subroutine ipb_close
  end interface
  !
  interface
    subroutine convert_dhsub(iwin,nw,nant,nbas,nband,npol,r4,r8,i4,cc)
      use classic_api
      !---------------------------------------------------------------------
      ! @ public
      ! Convert data header IWIN using conversion code CONVE,
      ! assuming NW is the length of the data header.
      ! Arguments
      ! IWIN    I(*)    Array containing data header to be converted
      ! NW      I       Size of IWIN
      ! CONVE   I       Conversion code
      ! NANT    I       Number of antennas
      ! NBAS    I       Number of baselines
      !---------------------------------------------------------------------
      integer :: iwin(*)                !
      integer(kind=data_length) :: nw                     !
      integer :: nant                   !
      integer :: nbas                   !
      integer :: nband                  !
      integer :: npol                   !
      external :: r4                    !
      external :: r8                    !
      external :: i4                    !
      external :: cc                    !
    end subroutine convert_dhsub
  end interface
  !
  interface
    subroutine wdata (ndata,data,copy_data,error)
      use classic_api
      !---------------------------------------------------------------------
      ! @ public
      ! write the data section
      !---------------------------------------------------------------------
      integer(kind=data_length):: ndata      ! Data length (number of "words")
      integer                  :: data(*)    ! Data array
      logical                  :: copy_data  ! Use do_write_data to write data ?
      logical                  :: error      ! Logical error flag
    end subroutine wdata
  end interface
  !
end module clic_interfaces_public
!
module mrtholo_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! MRTHOLO dependencies public interfaces. Do not use out of the
  ! library.
  !---------------------------------------------------------------------
  use gkernel_interfaces
  use class_interfaces_public
  use imbfits_interfaces_public
  use mrtcal_interfaces_public
  use clic_interfaces_public
end module mrtholo_dependencies_interfaces
!
module mrtholo_interfaces
  use mrtholo_interfaces_private
  use mrtholo_interfaces_public
end module mrtholo_interfaces

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_gradient
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubefield_messaging
  ! 
  public :: gradient
  private
  !
  type :: gradient_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: field
     type(cube_prod_t),  pointer :: df_dx
     type(cube_prod_t),  pointer :: df_dy
     type(cube_prod_t),  pointer :: amp
     type(cube_prod_t),  pointer :: ang
   contains
     procedure, public  :: register => cubefield_gradient_register
     procedure, private :: parse    => cubefield_gradient_parse
     procedure, private :: main     => cubefield_gradient_main
  end type gradient_comm_t
  type(gradient_comm_t) :: gradient
  !
  type gradient_user_t
     type(cubeid_user_t)   :: cubeids
   contains
     procedure, private :: toprog => cubefield_gradient_user_toprog
  end type gradient_user_t
  !
  type gradient_prog_t
     type(cube_t), pointer :: field
     type(cube_t), pointer :: df_dx
     type(cube_t), pointer :: df_dy
     type(cube_t), pointer :: amp
     type(cube_t), pointer :: ang
     integer(kind=pixe_k)  :: nx = 0
     integer(kind=pixe_k)  :: idx = 0
     real(kind=coor_k)     :: dx = 0d0
     integer(kind=pixe_k)  :: ny = 0
     integer(kind=pixe_k)  :: idy = 0
     real(kind=coor_k)     :: dy = 0d0
   contains
     procedure, private :: header => cubefield_gradient_prog_header
     procedure, private :: data   => cubefield_gradient_prog_data
     procedure, private :: loop   => cubefield_gradient_prog_loop
     procedure, private :: act    => cubefield_gradient_prog_act
  end type gradient_prog_t
  !
contains
  !
  subroutine cubefield_gradient_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(gradient_user_t) :: user
    character(len=*), parameter :: rname='GRADIENT>COMMAND'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call gradient%parse(line,user,error)
    if (error) return
    call gradient%main(user,error)
    if (error) continue
  end subroutine cubefield_gradient_command
  !
  subroutine cubefield_gradient_register(gradient,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradient_comm_t), intent(inout) :: gradient
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='GRADIENT>REGISTER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'GRADIENT','[fieldid]',&
         'Compute the gradient of a field',&
         'Compute 2D spatial gradients from the input field cube. The&
         & command writes DF_DX, DF_DY, AMPLITUDE, and ANGLE outputs.&
         & Border pixels remain blank because only interior pixels are&
         & evaluated.',&
         cubefield_gradient_command,&
         gradient%comm,error)
    if (error) return
    call incube%register(&
         'FIELDID',&
         'Cube identifier of a 2D field',&
         'Use the input field cube. If omitted, use the last matching&
         & cube (any family/flags) in the default index (DAG by default;&
         & see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset,&
         gradient%field,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'DF_DX',&
         'Cube of X gradient',&
         strg_emp,&
         [flag_gradient,flag_dx],&
         gradient%df_dx,&
         error)
    if (error) return
    call oucube%register(&
         'DF_DY',&
         'Cube of Y gradient',&
         strg_emp,&
         [flag_gradient,flag_dy],&
         gradient%df_dy,&
         error)
    if (error) return
    call oucube%register(&
         'AMPLITUDE',&
         'Cube of gradient amplitude',&
         strg_emp,&
         [flag_gradient,flag_amplitude],&
         gradient%amp,&
         error)
    if (error) return
    call oucube%register(&
         'ANGLE',&
         'Cube of gradient angle',&
         strg_emp,&
         [flag_gradient,flag_angle],&
         gradient%ang,&
         error)
    if (error) return
  end subroutine cubefield_gradient_register
  !
  subroutine cubefield_gradient_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! GRADIENT fieldid
    !----------------------------------------------------------------------
    class(gradient_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(gradient_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GRADIENT>PARSE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubefield_gradient_parse
  !
  subroutine cubefield_gradient_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradient_comm_t), intent(in)    :: comm
    type(gradient_user_t),  intent(inout) :: user
    logical,                intent(inout) :: error
    !
    type(gradient_prog_t) :: prog
    character(len=*), parameter :: rname='GRADIENT>MAIN'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubefield_gradient_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubefield_gradient_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradient_user_t), intent(in)    :: user
    type(gradient_comm_t),  intent(in)    :: comm
    type(gradient_prog_t),  intent(out)   :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GRADIENT>USER>TOPROG'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%field,user%cubeids,prog%field,error)
    if (error) return
  end subroutine cubefield_gradient_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubefield_gradient_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradient_prog_t), intent(inout) :: prog
    type(gradient_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GRADIENT>PROG>HEADER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubefield_gradient_prog_header_one(prog%df_dx,prog%field,&
         comm%df_dx,prog%field%head%set%il,prog%nx,prog%idx,prog%dx,&
         error)
    if (error) return
    call cubefield_gradient_prog_header_one(prog%df_dy,prog%field,&
         comm%df_dy,prog%field%head%set%im,prog%ny,prog%idy,prog%dy,&
         error)
    if (error) return
    !
    call cubeadm_clone_header(comm%amp,prog%field,prog%amp,error)
    if (error) return
    call cubeadm_clone_header(comm%ang,prog%field,prog%ang,error)
    if (error) return
  end subroutine cubefield_gradient_prog_header
  !
  subroutine cubefield_gradient_prog_header_one(ou,in,prod,iaxis,&
       nx,idx,dx,error)
    use phys_const
    use cubetools_axis_types
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: ou
    type(cube_t), pointer, intent(inout) :: in
    type(cube_prod_t),     intent(in)    :: prod
    integer(kind=ndim_k),  intent(in)    :: iaxis
    integer(kind=pixe_k),  intent(inout) :: nx
    integer(kind=pixe_k),  intent(inout) :: idx
    real(kind=coor_k),     intent(inout) :: dx
    logical,               intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='GRADIENT>PROG>HEADER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(prod,in,ou,error)
    if (error) return
    call cubetools_header_get_axis_head(iaxis,ou%head,axis,error)
    if (error) return
    nx = axis%n
    idx = 1 ! *** JP: should be customizable depending on the angular resolution
    dx = (2*idx)*axis%inc
    dx = dx*sec_per_rad ! *** JP: should use the current angle unit
  end subroutine cubefield_gradient_prog_header_one
  !
  subroutine cubefield_gradient_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(gradient_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='GRADIENT>PROG>DATA'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubefield_gradient_prog_data
  !
  subroutine cubefield_gradient_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradient_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: field,df_dx,df_dy,amp,ang
    character(len=*), parameter :: rname='GRADIENT>PROG>LOOP'
    !
    call field%associate('field',prog%field,iter,error)
    if (error) return
    call df_dx%allocate('df_dx',prog%df_dx,iter,error)
    if (error) return
    call df_dy%allocate('df_dy',prog%df_dy,iter,error)
    if (error) return
    call amp%allocate('amp',prog%amp,iter,error)
    if (error) return
    call ang%allocate('ang',prog%ang,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,field,df_dx,df_dy,amp,ang,error)
      if (error) return
    enddo ! ie
  end subroutine cubefield_gradient_prog_loop
  !   
  subroutine cubefield_gradient_prog_act(prog,ie,field,df_dx,df_dy,amp,ang,error)
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradient_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(image_t),          intent(inout) :: field
    type(image_t),          intent(inout) :: df_dx
    type(image_t),          intent(inout) :: df_dy
    type(image_t),          intent(inout) :: amp
    type(image_t),          intent(inout) :: ang
    logical,                intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    character(len=*), parameter :: rname='GRADIENT>PROG>ACT'
    !
    !
    call field%get(ie,error)
    if (error) return
    call df_dx%set_frame(prog%idx,prog%idy,gr4nan,error)
    if (error) return
    call df_dy%set_frame(prog%idx,prog%idy,gr4nan,error)
    if (error) return
    call amp%set_frame(prog%idx,prog%idy,gr4nan,error)
    if (error) return
    call ang%set_frame(prog%idx,prog%idy,gr4nan,error)
    if (error) return
    do iy=prog%idy+1,prog%ny-prog%idy
       do ix=prog%idx+1,prog%nx-prog%idx
          df_dx%val(ix,iy) = (field%val(ix+prog%idx,iy)-field%val(ix-prog%idx,iy))/prog%dx
          df_dy%val(ix,iy) = (field%val(ix,iy+prog%idy)-field%val(ix,iy-prog%idy))/prog%dy
          amp%val(ix,iy) = sqrt(df_dx%val(ix,iy)**2+df_dy%val(ix,iy)**2)
          ang%val(ix,iy) = atan2(df_dy%val(ix,iy),df_dx%val(ix,iy))
       enddo ! ix
    enddo ! iy
    call df_dx%put(ie,error)
    if (error) return
    call df_dy%put(ie,error)
    if (error) return
    call amp%put(ie,error)
    if (error) return
    call ang%put(ie,error)
    if (error) return
  end subroutine cubefield_gradient_prog_act
end module cubefield_gradient
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sic_modify(line,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_modify
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    SIC\MODIFY  VarName|GDFName
  ! 1  /FREQUENCY Linename RestFreq
  ! 2  /VELOCITY Velocity
  ! 3  /SPECUNIT Unit
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  character(len=filename_length) :: name
  integer(kind=4) :: nc,ier,in
  type(sic_identifier_t) :: var
  !
  ! Command argument
  call sic_ch(line,0,1,name,nc,.true.,error)
  if (error) return
  !
  ! Guess if a Variable or a File
  var%name = name
  var%lname = len_trim(name)
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  endif
  if (ier.eq.1) then
    ! Found a variable
    call sic_modify_variable(line,dicvar(in)%desc,error)
  else
    ! Assume a file, error will be raised if not
    call sic_modify_file(line,name,error)
  endif
  if (error)  return
  !
end subroutine sic_modify
!
subroutine sic_modify_variable(cline,desc,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_modify_variable
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    SIC\MODIFY VarName
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: cline  !
  type(sic_descriptor_t), intent(inout) :: desc   !
  logical,                intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  !
  if (desc%readonly) then
    call sic_message(seve%e,rname,'Can not modify read-only variables')
    error = .true.
    return
  elseif (desc%status.le.0) then
    call sic_message(seve%e,rname,'Can only modify image variables')
    error = .true.
    return
  endif
  !
  call sic_modify_header(cline,desc%head,error)
  if (error)  return
  !
end subroutine sic_modify_variable
!
subroutine sic_modify_file(cline,filename,error)
  use image_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_modify_file
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    SIC\MODIFY GDFName
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: cline     !
  character(len=*), intent(in)    :: filename  !
  logical,          intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  type(gildas) :: x
  logical :: error2
  !
  call gildas_null(x)
  x%file = filename
  !
  call gdf_read_header(x,error)
  if (error)  return
  !
  call sic_modify_header(cline,x,error)
  if (error)  goto 100
  !
  call gdf_update_header(x,error)
  if (error)  goto 100
  !
100 continue
  error2 = .false.
  call gdf_close_image(x,error2)
  if (error2)  error = .true.
  !
end subroutine sic_modify_file
!
subroutine sic_modify_header(cline,x,error)
  use image_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_modify_header
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Modify consistently:
  !   - the line name
  !   - the rest frequency
  !   - the velocity
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: cline  !
  type(gildas),     intent(inout) :: x      !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  integer(kind=4), parameter :: optfreq=1
  integer(kind=4), parameter :: optvelo=2
  integer(kind=4), parameter :: optunit=3
  integer(kind=4) :: nc,iunit
  character(len=12) :: new_linename,argum,new_unit
  real(kind=8) :: new_restf
  real(kind=4) :: new_velo
  integer(kind=4), parameter :: nunit=2
  character(len=9), parameter :: unit(nunit) = (/ 'FREQUENCY','VELOCITY ' /)
  !
  ! /FREQUENCY arguments
  new_linename = x%char%line
  call sic_ch(cline,optfreq,1,new_linename,nc,.false.,error)
  if (error)  return
  new_restf = x%gil%freq
  call sic_r8(cline,optfreq,2,new_restf,.false.,error)
  if (error)  return
  !
  ! /VELOCITY arguments
  new_velo = x%gil%voff
  call sic_r4(cline,optvelo,1,new_velo,.false.,error)
  if (error)  return
  !
  ! /SPECUNIT. Default is unchanged unit.
  if (sic_present(optunit,0)) then
    if (x%gil%faxi.gt.0) then
      argum = x%char%code(x%gil%faxi)
    else
      ! No faxi will be rejected anyway by gdf_modify. Use any value
      argum = 'VELOCITY'
    endif
    call sic_ke(cline,optunit,1,argum,nc,.false.,error)
    if (error)  return
    call sic_ambigs(rname,argum,new_unit,iunit,unit,nunit,error)
    if (error)  return
    !
    call gdf_modify(x,new_velo,new_restf,new_unit,error)
    if (error)  return
  else
    call gdf_modify(x,new_velo,new_restf,error=error)
  endif
  ! New line name
  x%char%line = new_linename
  !
end subroutine sic_modify_header

subroutine sic_delete(line,error)
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_interfaces, except_this=>sic_delete
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Support for commands
  !	DELETE/VARIABLE and DELETE/SYMBOL and DELETE/FUNCTION
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='DELETE'
  integer :: i,nl,ndelarg
  character(len=varname_length) :: name
  !
  ! Protection against order mismatch
  if (sic_present(0,1)) then
    call sic_message(seve%e,rname,'Delete arguments must come after the '//  &
    'option')
  endif
  !
  if (sic_present(1,0)) then
    ! DELETE /SYMBOL
    if (sic_present(2,0).or.sic_present(3,0)) then
      call sic_message(seve%e,rname,'Incompatible options')
      error = .true.
      return
    endif
    ndelarg = sic_narg(1)
    do i=1,ndelarg
      call sic_ke (line,1,i,name,nl,.true.,error)
      if (error) return
      call sic_delsymbol(name(1:nl),error)
      if (error) then
        call sic_message(seve%e,rname,'Symbol '//name(1:nl)//' not deleted')
        return
      endif
    enddo
    !
  elseif (sic_present(2,0)) then
    ! DELETE /VARIABLE
    if (sic_present(3,0)) then
      call sic_message(seve%e,rname,'Incompatible options')
      error = .true.
      return
    endif
    ndelarg = sic_narg(2)
    do i=1,ndelarg
      call sic_ch (line,2,i,name,nl,.true.,error)
      if (error) return
      call sic_delvariable(name(1:nl),.true.,error)
      if (error) then
        call sic_message(seve%e,rname,'Variable '//name(1:nl)//' not deleted')
        return
      endif
    enddo
    !
  elseif (sic_present(3,0)) then
    ! DELETE /FUNCTION
    ndelarg = sic_narg(3)
    do i=1,ndelarg
      call sic_ke(line,3,i,name,nl,.true.,error)
      if (error) return
      call sic_del_expr(name,nl,error)
      if (error)  return
    enddo
  else
    call sic_message(seve%e,rname,'Missing option')
    error = .true.
  endif
  !
end subroutine sic_delete

subroutine gdf_geih(is,p,error)
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, only : gio_message
  use gio_image
  !---------------------------------------------------------------------
  ! @ public
  ! GDF   GEt a pointer to Image Header
  !       Return the image header for further use
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: is     ! Image Slot
  type(gildas),    pointer       :: p      ! Pointer to header
  logical,         intent(inout) :: error  ! Error flag
  !
  if (islot(is).eq.code_gio_empty .or. islot(is).eq.code_gio_full) then
    call gio_message(seve%e,'GEIH','Image slot is not mapped')
    p => null()
    error = .true.
    return
  endif
  p => gheads(is)
end subroutine gdf_geih
!
subroutine gdf_flih (is,check,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_flih
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! GDF   FLush Image Header
  !       FLush an image header
  !---------------------------------------------------------------------
  integer, intent(in) :: is                        ! Image Slot
  logical, intent(in) :: check                     ! Check if slot is writeable
  logical, intent(out) :: error                    ! Error flag
  ! Local
  integer(kind=record_length) :: nvb
  character(len=*), parameter :: rname='FLIH'
  integer(kind=4) :: form, ier
  integer(kind=record_length) :: js
  character(len=12) :: gtype
  !
  ! Check frame is OK
  error = .false.
  if (ichan(is).eq.0) return   ! This is Memory Frame
  !
  if (islot(is).ne.code_gio_write .and.islot(is).ne.code_gio_dumpe ) then
    if (check) then
      call gio_message(seve%e,rname,'Image slot is not Writeable')
      error = .true.
      return
    endif
  endif
  open(unit=iunit(is),file=cname(is),status='OLD',access='DIRECT',  &
       form='UNFORMATTED',action='READWRITE',recl=lenbuf*facunf,iostat=ier)
  if (ier.ne.0) then
    call putios(seve%e,'FLIH(Open)',ier)
    call gio_message(seve%e,rname,'Error opening '//trim(cname(is)))
    goto 100
  endif
  read (unit=iunit(is),rec=1,iostat=ier) gdfbuf
  if (ier.ne.0) then
    call putios(seve%e,'FLIH(Read)',ier)
    goto 99
  endif
  ier = gio_eih (is,gtype,form,nvb)
  if (ier.ne.1) then
    call gio_message(seve%e,rname,'File is not a GILDAS Data Frame')
    goto 99
  endif
  !
  ! Update Header
  !! Print *,'Calling GIO_WIH from gdf_flih ',nvb,istbl(is)
  ier = gio_wih (is,gtype,iform(is),nvb)
  if (ier.eq.0) goto 99
  do js=1,istbl(is)
    write (unit=iunit(is),rec=js,iostat=ier) gdfbig(:,js)
    if (ier.ne.0) then
      call putios(seve%e,'FLIH(Write)',ier)
      goto 99
    endif
  enddo
  !
  ! On LINUX with a Readonly file, the error may happen at the CLOSE
  ! rather than during the WRITE. This is redundant with the OPEN
  ! statement check with ACTION='READWRITE', but does not harm.
  close (unit=iunit(is),iostat=ier)
  if (ier.ne.0) then
    call putios(seve%e,'FLIH(Close)',ier)
    error = .true.
  endif
  !!write(99,*) 'Tested GDF_FLIH'
  return
  !
99 close (unit=iunit(is),iostat=ier)
100 error = .true.
end subroutine gdf_flih

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtindex_types
  use gkernel_types
  use classic_api
  use mrtindex_parameters
  use mrtindex_sec_calibration
  use mrtindex_sec_science
  use mrtindex_sec_pointing
  !
  ! Here: only elements on which we will makes searches
  integer(kind=4), parameter :: mrtindex_indx_length=51
  ! Index version:
  ! * 1 never => can not be 1 in Classic V2 files
  ! * 2 on 09-JAN-2017 (going officially online @ Pico)
  ! * 3 on 01-OCT-2024 (introduce solstatus at position 39)
  ! Note that numbers 2 to 11 were used during the development phase of
  ! Mrtcal (2013 to 2016); in particular 11 was used during all year 2016.
  integer(kind=4), parameter :: mrtcal_indx_version=3
  integer(kind=4), parameter :: mrtcal_indx_mfrontend=4  ! Warning: used in data format
  type mrtindex_indx_t
    sequence
    integer(kind=8)   :: bloc                   !  1- 2: [record] Entry address
    integer(kind=4)   :: word                   !     3: [word] Position in this record
    integer(kind=4)   :: version                !     4: [---] Entry version
    integer(kind=4)   :: telescope              !     5: [code] Telescope
    character(len=12) :: source                 !  6- 8: [---] Source name
    character(len=8)  :: projid                 !  9-10: [---] Project Id
    real(kind=8)      :: ut                     ! 11-12: [rad] Observation time
    real(kind=8)      :: lst                    ! 13-14: [sec] Local Sidereal Time
    real(kind=4)      :: az                     !    15: [rad] Azimuth
    real(kind=4)      :: el                     !    16: [rad] Elevation
    real(kind=8)      :: lon                    ! 17-18: [rad] Longitude
    real(kind=8)      :: lat                    ! 19-20: [rad] Latitude
    integer(kind=4)   :: system                 !    21: [code] System of coordinates for lon-lat
    real(kind=4)      :: equinox                !    22: [year] Equinox if system is equatorial
    character(len=8)  :: frontend(mrtcal_indx_mfrontend)  ! 23-30: [char] Receiver name(s)
    integer(kind=4)   :: dobs                   !    31: [gag_date] Observation date
    integer(kind=4)   :: scan                   !    32: [---] Scan number
    integer(kind=4)   :: backend                !    33: [code] Backend
    integer(kind=4)   :: obstype                !    34: [code] Observation type
    integer(kind=4)   :: switchmode             !    35: [code] Switching mode
    integer(kind=4)   :: polstatus              !    36: [0|1] Polarimetry?
    integer(kind=4)   :: filstatus              !    37: Can read file or not?
    integer(kind=4)   :: calstatus              !    38: [code] Calibration status
    integer(kind=4)   :: solstatus              !    39: [code] Solve status
    integer(kind=4)   :: pad                    !               Memory padding
    character(len=fitsname_length) :: filename  ! 40-49: [char] File name (no directory)
    integer(kind=8)   :: itime                  ! 50-51: [usec] Last indexing time
  end type mrtindex_indx_t
  !
  ! "Section key" (copy of index, always present)
  integer(kind=4), parameter :: sec_key_id=0  ! Not a real section in file
  type mrtindex_key_t
    integer(kind=4)                :: version      ! [     ---] Entry version
    integer(kind=4)                :: telescope    ! [    code] Telescope
    character(len=8)               :: projid       ! [     ---] Project Id
    character(len=12)              :: source       ! [     ---] Source name
    integer(kind=4)                :: dobs         ! [gag_date] Observation date
    real(kind=8)                   :: ut           ! [     rad] Observation time
    real(kind=8)                   :: lst          ! [     sec] Local Sideral Time
    real(kind=4)                   :: az           ! [     rad] Azimuth
    real(kind=4)                   :: el           ! [     rad] Elevation
    real(kind=8)                   :: lon          ! [     rad] Longitude
    real(kind=8)                   :: lat          ! [     rad] Latitude
    integer(kind=4)                :: system       ! [    code] System of coordinates for lon-lat
    real(kind=4)                   :: equinox      ! [    year] Equinox if system is equatorial
    character(len=8)  :: frontend(mrtcal_indx_mfrontend)  ! [char] Receiver name(s)
    integer(kind=4)                :: scan         ! [     ---] Scan number
    integer(kind=4)                :: backend      ! [    code] Backend
    integer(kind=4)                :: obstype      ! [    code] Observation type
    integer(kind=4)                :: switchmode   ! [    code] Switching mode
    integer(kind=4)                :: polstatus    ! [     0|1] Polarimetry?
    integer(kind=4)                :: filstatus    ! [    code] Can read file or not?
    integer(kind=4)                :: calstatus    ! [    code] Calibration status
    integer(kind=4)                :: solstatus    ! [    code] Solve status
    character(len=fitsname_length) :: filename     ! [  string] File name (no directory)
  end type mrtindex_key_t
  !
  ! Section "primary" (IMBFITS primary header)
  integer(kind=4), parameter :: sec_prim_id=1
  integer(kind=8), parameter :: sec_prim_len=1_8
  type sec_primary_t
     real(kind=4)      :: imbfvers ! 1 [---] IMBFITS version
   ! real(kind=8)      :: timegoal !   [sec] Integration time declared
   ! integer(kind=4)   :: nsubgoal !   [---] Number of subscans declared
   ! integer(kind=4)   :: nsub     !   [---] Number of subscans present
  end type sec_primary_t
  !
  ! Section Tuning: for both calibration and science scans. Save the
  ! relevant tunings which were used for calibration.
  integer(kind=4), parameter :: sec_tuning_id=5
  integer(kind=8), parameter :: sec_tuning_len=0
  ! TO BE DONE
  !
  ! Header
  integer(kind=4), parameter :: mrtcal_maxsec=4  ! Maximum number of known sections
  type mrtindex_header_t
    logical               :: presec(mrtcal_maxsec) ! Which section are presents
    type(mrtindex_key_t)  :: key                   ! ~ duplicate of index
    type(sec_primary_t)   :: pri                   !
    type(sec_calib_t)     :: cal                   !
    type(sec_science_t)   :: sci                   !
    type(sec_pointing_t)  :: poi                   !
  end type mrtindex_header_t
  !
  type mrtindex_entry_t
    type(mrtindex_indx_t)       :: indx  ! The entry indx
    type(classic_entrydesc_t) :: desc  ! The entry descriptor
    type(mrtindex_header_t)     :: head  ! The entry header
  end type mrtindex_entry_t
  !
  type mrtindex_optimize_t
    integer(kind=entry_length) :: next=1  ! Number of observations in index + 1
    integer(kind=8),                pointer :: bloc(:)        =>null()  ! Bloc numbers
    integer(kind=4),                pointer :: word(:)        =>null()  ! Position in record
    integer(kind=4),                pointer :: version(:)     =>null()  ! Entry version
    integer(kind=4),                pointer :: telescope(:)   =>null()  ! Telescope code
    character(len=8),               pointer :: projid(:)      =>null()  ! Project Id
    character(len=12),              pointer :: source(:)      =>null()  ! Source name
    integer(kind=4),                pointer :: dobs(:)        =>null()  ! Observation date
    real(kind=8),                   pointer :: ut(:)          =>null()  ! Observation time
    real(kind=8),                   pointer :: lst(:)         =>null()  ! Local Sidereal time
    real(kind=4),                   pointer :: az(:)          =>null()  ! Azimuth
    real(kind=4),                   pointer :: el(:)          =>null()  ! Elevation
    real(kind=8),                   pointer :: lon(:)         =>null()  ! Longitude
    real(kind=8),                   pointer :: lat(:)         =>null()  ! Latitude
    integer(kind=4),                pointer :: system(:)      =>null()  ! System of coordinates for lon-lat
    real(kind=4),                   pointer :: equinox(:)     =>null()  ! Equinox if system is equatorial
    character(len=8),               pointer :: frontend(:,:)  =>null()  ! Receiver name(s)
    integer(kind=4),                pointer :: scan(:)        =>null()  ! Scan number
    integer(kind=4),                pointer :: backend(:)     =>null()  ! Backend code
    integer(kind=4),                pointer :: obstype(:)     =>null()  ! Obstype code
    integer(kind=4),                pointer :: switchmode(:)  =>null()  ! Switching mode
    integer(kind=4),                pointer :: polstatus(:)   =>null()  ! Polarimetry
    integer(kind=4),                pointer :: filstatus(:)   =>null()  ! File completeness
    integer(kind=4),                pointer :: calstatus(:)   =>null()  ! Calibration status
    integer(kind=4),                pointer :: solstatus(:)   =>null()  ! Solve status
    character(len=fitsname_length), pointer :: filename(:)    =>null()  ! File name (no directory)
    integer(kind=8),                pointer :: itime(:)       =>null()  ! Last indexing time
    ! Not in data
    integer(kind=entry_length),     pointer :: num(:)         =>null()  ! "Observation" number
    integer(kind=entry_length),     pointer :: mnum(:)        =>null()  ! Entry number in IX (memory)
    integer(kind=entry_length),     pointer :: fnum(:)        =>null()  ! Entry number in file
    integer(kind=entry_length),     pointer :: sort(:)        =>null()  ! Sorting list
    integer(kind=4),                pointer :: idir(:)        =>null()  ! Host directory identifier
    logical,                        pointer :: islast(:)      =>null()  ! Is this the obs. last version?
  end type mrtindex_optimize_t
  !
  type :: mrtindex_find_t
    logical            :: llast  ! Selection of last version only enabled?
    !
    logical            :: ldate  ! Selection by date enabled?
    type(sic_listi4_t) :: idate  ! Desired scan list(s), if relevant
    !
    logical            :: lscan  ! Selection by iscan enabled?
    type(sic_listi4_t) :: iscan  ! Desired scan list(s), if relevant
    !
    logical            :: lback  ! Selection by backend enabled?
    integer(kind=4)    :: iback(nbackends_mrtcal)  ! Desired backend code(s), if relevant
    !
    logical            :: lobst  ! Selection by observation type enabled?
    integer(kind=4)    :: iobst(nobstypes_mrtcal)  ! Desired obstype code(s), if relevant
    !
    logical            :: lswit  ! Selection by switching mode enabled?
    integer(kind=4)    :: iswit(nswitchmodes)  ! Desired switchmode code(s), if relevant
    !
    logical            :: lpola  ! Selection by cpola enabled?
    integer(kind=4)    :: ipola  ! Desired polarimetry status, if relevant
    !
    logical            :: lsour  ! Selection by csour enabled?
    character(len=12)  :: csour  ! Desired source name, if relevant
    !
    logical            :: lproj  ! Selection by cproj enabled?
    character(len=8)   :: cproj  ! Desired project id, if relevant
    !
    logical            :: lfron                         ! Selection by cfron enabled?
    character(len=16)  :: cfron(mrtcal_indx_mfrontend)  ! Desired frontend(s), if relevant
    !
    logical            :: lcomp  ! Selection by file completeness enabled?
    integer(kind=4)    :: icomp  ! Desired readability, if relevant
    !
    logical            :: lcali  ! Selection by calibration status enabled?
    integer(kind=4)    :: icali(ncalstatus)  ! Desired calibration status(es), if relevant
    !
    logical            :: lsolv  ! Selection by solve status enabled?
    integer(kind=4)    :: isolv(nsolstatus)  ! Desired solve status(es), if relevant
  end type mrtindex_find_t
end module mrtindex_types
!
module mrtindex_array_types
  use mrtindex_parameters
  use mrtindex_sec_calibration
  use mrtindex_sec_science
  use mrtindex_sec_pointing
  !---------------------------------------------------------------------
  ! This module provide array-ified headers, which can be used to load
  ! a collection of headers in memory. Typically needed by command
  ! VARIABLE /INDEX
  !---------------------------------------------------------------------

  type mrtindex_key_arr_t
    integer(kind=4),                allocatable :: version(:)
    integer(kind=4),                allocatable :: telescope(:)
    character(len=8),               allocatable :: projid(:)
    character(len=12),              allocatable :: source(:)
    integer(kind=4),                allocatable :: dobs(:)
    real(kind=8),                   allocatable :: ut(:)
    real(kind=8),                   allocatable :: lst(:)
    real(kind=4),                   allocatable :: az(:)
    real(kind=4),                   allocatable :: el(:)
    real(kind=8),                   allocatable :: lon(:)
    real(kind=8),                   allocatable :: lat(:)
    integer(kind=4),                allocatable :: system(:)
    real(kind=4),                   allocatable :: equinox(:)
    character(len=8),               allocatable :: frontend(:,:)
    integer(kind=4),                allocatable :: scan(:)
    integer(kind=4),                allocatable :: backend(:)
    integer(kind=4),                allocatable :: obstype(:)
    integer(kind=4),                allocatable :: switchmode(:)
    integer(kind=4),                allocatable :: polstatus(:)
    integer(kind=4),                allocatable :: filstatus(:)
    integer(kind=4),                allocatable :: calstatus(:)
    integer(kind=4),                allocatable :: solstatus(:)
    character(len=fitsname_length), allocatable :: filename(:)
  end type mrtindex_key_arr_t

  ! Header (array)
  type mrtindex_header_arr_t
    type(mrtindex_key_arr_t)   :: key
    type(sec_calib_array_t)    :: cal
    type(sec_science_array_t)  :: sci
    type(sec_pointing_array_t) :: poi
  end type mrtindex_header_arr_t

  ! Support variable for command "VARIABLE /INDEX"
  type(mrtindex_header_arr_t), save :: mdxhead

end module mrtindex_array_types
!
module mrtindex_parse_types
  use gildas_def
  use gkernel_types
  use mrtindex_parameters
  !
  character(len=*), parameter :: user_find_allfront='* *&*'  ! Find all single-band and all dual-band
  type user_calib_t
     ! Type used for parsing CALIBRATE or FIND options. Get arguments
     ! as character strings (because '*' is often accepted), interpret
     ! them elsewhere
     character(len=128)                 :: cscan = '*'  ! Scan number (or list)
     character(len=128)                 :: cback = '*'  ! Backend string (or list)
     character(len=128)                 :: cdate = '*'  ! Date string (or list)
     character(len=128)                 :: cobst = '*'  ! Obstype (or list)
     character(len=128)                 :: cswit = '*'  ! Switchmode (or list)
     character(len=8)                   :: cpola = '*'  ! Polarimetry
     character(len=12)                  :: csour = '*'  ! Source name
     character(len=8)                   :: cproj = '*'  ! Project name
     character(len=128)  :: cfron = user_find_allfront  ! Frontend (receiver) name (or list)
     character(len=completeness_length) :: ccomp = '*'  ! File completeness
     character(len=128)                 :: ccali = '*'  ! Calibration status (or list)
     character(len=128)                 :: csolv = '*'  ! Solve status (or list)
  end type user_calib_t
  !
  type user_find_t
     ! Support for LAS\FIND hook on Mrtcal User Section. Selection criteria
     logical :: ltypes(0:nobstypes_mrtcal)  ! Obs. Types selected
  end type user_find_t
  !
  integer(kind=4), parameter :: imbfits_pattern_length=64
  type user_pattern_t
     ! Support for INDEX /PATTERN or /DATE
     logical :: bylist
     character(len=imbfits_pattern_length) :: custom    ! By user custom pattern
     type(sic_listi4_t)                    :: datelist  ! By list of dates
  end type user_pattern_t
  !
  type backend_list_t
     integer(kind=4) :: n = 0 ! Number of backends available in current scan
     integer(kind=4),                pointer :: backcode(:) => null() ! Backend code
     character(len=filename_length), pointer :: file(:)     => null() ! Associated file name
  end type backend_list_t
end module mrtindex_parse_types
!
module mrtindex_vars
  use gildas_def
  use classic_api
  use mrtindex_types
  use mrtindex_parse_types
  !
  ! ZZZ One set of buffers per file?
  type(classic_recordbuf_t) :: obufbi
  type(classic_recordbuf_t) :: obufobs
  type(classic_recordbuf_t) :: ibufbi
  type(classic_recordbuf_t) :: ibufobs
  !
  ! IX index files
  integer(kind=4) :: ix_ndir    ! Current number of index files loaded in IX
  integer(kind=4) :: ix_opened  ! Identifier of the one which is currently Fortran-opened
  character(len=filename_length), allocatable :: ix_dirs(:)   ! Directories
  type(classic_file_t),           allocatable :: ix_files(:)  ! Index files
  integer(kind=4) :: ox_fileid=0  ! Output index file (identifier)
  !
  ! Pre-reserved logical units for index files
  integer(kind=4) :: ix_lun,ox_lun
  !
end module mrtindex_vars
!
module mrtindex_messaging
  use gbl_message
  !
  type :: mrtindex_debug_message_t
    integer(kind=4) :: alloc   ! Support for MSET DEBUG INDEX ALLOCATION
    integer(kind=4) :: others  ! Support for MSET DEBUG INDEX OTHERS
  end type mrtindex_debug_message_t
  !
  ! Set the default at startup:
  !  iseve%alloc = seve%d
  !  iseve%others = seve%d
  type(mrtindex_debug_message_t) :: iseve = mrtindex_debug_message_t(seve%d,seve%d)
  !
end module mrtindex_messaging

subroutine write_fits_data (unit, iband, cmode, nsubant, subant,   &
    ldata, data , switch, error)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Write the CORRDATA  fits table.
  ! it has four columns.
  ! Assume one polarization, two sidebands.
  !---------------------------------------------------------------------
  integer :: unit                   !
  integer :: iband                  !
  character(len=*) :: cmode         !
  integer :: nsubant                !
  integer :: subant(nsubant)        ! selected antennas in table
  integer :: ldata                  !
  integer :: data(1)                !
  logical :: switch                 !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_number.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: nch, itable
  integer :: k, mf, status, nrows, tfields, varidat, ir, h_offset
  integer :: naxis, naxes(4), nvector, krow, l_offset, ib, isb, ksb
  integer :: mdigit1, mdigit2, r_npol, r_nside, k1
  integer :: ntch, ich, k0, c_offset, nsb, kd, ia, ja, ncoldata, icol
  integer :: nsubbas, subbas(mnbas), isub, i, nswitch, jr, isw
  parameter(r_npol = 1, r_nside=2, mdigit2=13, mdigit1=8)
  real*8 :: fobs, ifval
  real :: ifinc, ifref, df, af
  parameter (mf = 5)
  character(len=16) :: ttype(mf),tform(mf),tunit(mf), extname
  character(len=1) :: ccol(2),c
  character(len=2) :: c2col(2),cc
  data ttype/     'INTEGNUM', 'STARTANT', 'ENDANT',  'DATA', 'DATA'/
  data tform/     '1J',       '1J',      '1J',       '1E',   '1E'/
  data tunit/     ' ',        ' ',       ' ',     ' ',     ' '/
  data ccol/'4','5'/, c2col/'4A','5B'/
  !---------------------------------------------------------------------
  ! nutator switch simulation (switch = .true.)
  if (switch) then
    nswitch = 2
  else
    nswitch = 1
  endif
  ! the baselines in subarray subant
  nsubbas = nsubant*(nsubant-1)/2
  do i = 1, nsubbas
    subbas(i) = basant(subant(antbas(1,i)), subant(antbas(2,i)))
  enddo
  !
  !  Append/create a new empty HDU onto the end of the file and move to it.
  status = 0
  call ftcrhd(unit,status)
  !
  !  Define parameters for the binary table (see the above data statements)
  !
  ! Continuum Temporal data
  if (cmode(1:2).eq.'CT') then
    !c         NROWS = R_NDUMP
    nrows = nswitch*r_ndump
    nch = 1
    ntch = r_nband
    ich = iband-1
    nsb = r_nsb
    ifref = 1d0
    ifval = r_cfcen(iband)*1e6
    ifinc = r_cfwid(iband)*1e6
    itable = 1
  ! Continuum Average data
  elseif (cmode(1:2).eq.'CA') then
    nrows = 1
    nch = 1
    ntch = r_nband
    ich = iband-1
    nsb = r_nsb
    ifref = 1d0
    ifval = r_cfcen(iband)*1e6
    ifinc = r_cfwid(iband)*1e6
    itable = 3
  ! Spectral Average data
  else
    nrows = 1                  ! r_nldump
    nch = r_lnch(iband)
    ntch = r_lntch
    ich = r_lich(iband)
    nsb = r_lnsb
    ifref = r_lcench(iband)
    ifval = r_lfcen(iband)*1e6
    ifinc = r_lfres(iband)*1e6
    itable = 2
  endif
  !      print *, 'cmode, nch ', cmode, nch
  tfields = mf
  if (r_lmode.eq.1) then
    extname = 'CORRDATA-ALMATI'
    naxes(1) = 2
    naxes(2) = nch
    naxes(3) = r_npol
    ! phase corrected / uncorrected
    if (r_ndatl.eq.2 .and. cmode(1:2).ne.'CT') then
      naxes(4) = r_ndatl
      naxis = 4
    ! only uncorrected
    else
      naxes(4) = 1
      naxis = 3
    endif
    ttype(2) = 'STARTANT'
    tform(2) = '1J'
    ttype(3) = 'ENDANT'
    tform(3) = '1J'
    ttype(4) = 'DATAUSB1'
    nvector = naxes(1) * naxes(2) * naxes(3) * naxes(4)
    ncoldata = 4
    call f_tform(tform(ncoldata),nvector,'E')
    ttype(5) = 'DATALSB1'
    nvector = naxes(1) * naxes(2) * naxes(3) * naxes(4)
    tfields = 5
    call f_tform(tform(ncoldata+1),nvector,'E')
    varidat = 0
    !
    call ftphbn(unit,nrows,tfields,ttype,tform,tunit,   &
      extname,varidat,status)
    call ftptdm(unit, ncoldata, naxis, naxes, status)
    call ftptdm(unit, ncoldata+1, naxis, naxes, status)
  else
    extname = 'AUTODATA-ALMATI'
    naxes(1) = nch
    naxes(2) = r_npol
    naxis = 2
    ttype(2) = 'ANTENNA'
    tform(2) = '1J'
    ttype(3) = 'DATA'
    nvector = naxes(1) * naxes(2)
    ncoldata = 3
    tfields = 3
    call f_tform(tform(ncoldata),nvector,'E')
    varidat = 0
    !
    call ftphbn(unit,nrows,tfields,ttype,tform,tunit,   &
      extname,varidat,status)
    call ftptdm(unit, ncoldata, naxis, naxes, status)
  endif
  ! Other header keywords
  call ftpkys(unit,'TABLEREV','v1.0 2001-07-03',   &
    extname//' release',status)
  if (status .gt. 0) goto 99
  call write_fits_dobs(unit,error)
  if (error) return
  call ftpkyj(unit,'NO_POL',r_npol,'Number of pols.',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'NO_SIDE',r_nside,'Number of side bands',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'NO_LO',2,'Number of LO''s',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'NO_PHCOR',r_ndatl,'Number of phase corr. data',   &
    status)
  call ftpkyj(unit,'CHANNELS',nch,   &
    'number of channels in baseband',status)
  call ftpkyj(unit,'BASEBAND',iband,'Baseband number',status)
  call ftpkyj(unit,'TABLEID',itable,'Baseband table number ',status)
  !
  call ftpkys(unit,'TRANSITA',r_lnam(1,iband),   &
    'Line Transition A',status)
  call ftpkyd(unit,'RESTFREA',r_lrfoff(1,iband)*1d6,mdigit2,   &
    'Rest  Freq. A (Hz) at reference channel',status)
  call ftpkys(unit,'TRANSITB',r_lnam(2,iband),   &
    'Line Transition B',status)
  call ftpkyd(unit,'RESTFREB',r_lrfoff(2,iband)*1d6,mdigit2,   &
    'Rest  Freq. B (Hz) at reference channel',status)
  !      FIMAGE = R_LRFOFF(ISB,IBAND)
  !     $+(2*ISB-3)*2/(1+R_DOPPL)
  !     $*(R_FLO2-R_LFCEN(IBAND)
  !     $-(R_LRCH(ISB,IBAND)-R_LCENCH(IBAND))*R_LFRES(IBAND))
  !      CALL FTPKYD(UNIT,'IMAGFREQ',FIMAGE*1D6,MDIGIT2,
  !     $'Image Freq. (Hz) at reference channel',STATUS)
  !      call ftpkyd(unit,'IF_REF',ifref,mdigit2,
  !     &     'Reference channel',status)
  call ftpkyd(unit,'INTERFRE',ifval,mdigit2,   &
    'Intermediate Freq. (Hz) at reference channel',status)
  !      call ftpkyd(unit,'IFINC',ifinc,mdigit2,
  !     &     'IF Value at Reference channel',status)
  call ftpkyd(unit,'FREQLO1',r_flo1*1d6,mdigit2,   &
    'Local Oscillator 1',status)
  call ftpkyj(unit,'SIDEBLO1',r_isb,   &
    'Side Band LO 1',status)
  call ftpkyd(unit,'FREQLO2',r_flo1_ref*1d6,mdigit2,   &
    'Local Oscillator 2',status)
  call ftpkyj(unit,'SIDEBLO2',-1,   &
    'Side Band LO 2',status)
  if (r_flux.ne.0) then
    call ftpkye(unit,'IFLUX',r_flux,mdigit1,'Flux in I (Jy)',   &
      status)
  endif
  if (r_lmode.eq.1) then
    ! Column 4, First data axis
    do isb=1, 2
      c = ccol(isb)
      cc = c2col(isb)
      call ftpkys(unit,'1CTYP'//c,'COMPLEX','Complex axis',status)
      call ftpkye(unit,'1CRPX'//c,1.0,mdigit1,' ',status)
      call ftpkye(unit,'1CRVL'//c,1.0,mdigit1,' ',status)
      call ftpkye(unit,'11CD'//c,1.0,mdigit1,' ',status)
      ! Second data axis: frequency.
      call ftpkys(unit,'2CTYP'//c,'FREQ-FRQ',   &
        'Observed Frequency axis',status)
      call ftpkye(unit,'2CRPX'//c,ifref,mdigit1,   &
        'reference pixel',status)
      ksb = 3-2*isb
      fobs = (r_flo1+ksb*(r_flo1_ref-r_lfcen(iband)))*1d6
      df = -ifinc*ksb
      call ftpkyd(unit,'2CRVL'//c,fobs,mdigit2,   &
        'Observed Freq.(Hz) at ref. pixel in Hz ',status)
      call ftpkye(unit,'22CD'//c,df,mdigit1,   &
        'Channel separation in Hz ',status)
      ! Second data axis: velocity.
      if (nch.gt.1) then
        call ftpkys(unit,'2CTYP'//cc,'VRAD-FRQ',   &
          'Velocity axis',status)
        call ftpkye(unit,'2CRPX'//cc,r_lrch(isb,iband),mdigit1,   &
          'reference pixel',status)
        call ftpkyd(unit,'2CRVL'//cc,r_lvoff(isb,iband)*1d3,   &
          mdigit2,'Velocity (m/s)  at reference channel',   &
          status)
        call ftpkye(unit,'22CD'//cc,r_lvres(isb,iband)*1e3,   &
          mdigit2,'Channel spacing in velocity (m/s)',status)
        call ftpkys(unit,'2CUNI'//cc,'m/s',   &
          'Velocity unit axis',status)
        call ftpkyd(unit,'2VSOU'//cc,r_lvoff(isb,iband)*1d3,   &
          mdigit2,'Source Velocity (m/s)',status)
        call ftpkys(unit,'2SPEC'//cc,'LSRK-TOP',   &
          'Velocity System',status)
      endif
      ! Third data axis: Stokes parameters
      call ftpkys(unit,'3CTYP'//c,'STOKES','Stokes axis',status)
      call ftpkye(unit,'3CRPX'//c,1.0,mdigit1,' ',status)
      call ftpkye(unit,'3CRVL'//c,-5.0,mdigit1,' ',status)
      call ftpkye(unit,'33CD'//c,-1.0,mdigit1,' ',status)
      ! Fourth data axis: Phase correction
      if (naxis.gt.3) then
        c = ccol(isb)
        cc = c2col(isb)
        call ftpkys(unit,'4CTYP'//c,'PHASCORR',   &
          'Phase Correction',status)
        call ftpkye(unit,'4CRPX'//c,1.0,mdigit1,' ',status)
        call ftpkye(unit,'4CRVL'//c,0.0,mdigit1,' ',status)
        call ftpkye(unit,'44CD'//c,1.0,mdigit1,' ',status)
      endif
    enddo
  else
    ! Autocorrelation ...
    ! First data axis: frequency.
    call ftpkys(unit,'1CTYP3','FREQ-FRQ',   &
      'Observed Frequency axis',status)
    call ftpkye(unit,'1CRPX3',ifref,mdigit1,   &
      'reference pixel',status)
    ksb = r_isb
    fobs = (r_flo1+ksb*(r_flo1_ref-r_lfcen(iband)))*1d6
    df = -ifinc*ksb
    call ftpkyd(unit,'1CRVL3',fobs,mdigit2,   &
      'Observed Freq.(Hz) at ref. pixel in Hz ',status)
    call ftpkye(unit,'11CD3',df,mdigit1,   &
      'Channel separation in Hz ',status)
    !  First data axis: velocity
    if (nch.gt.1) then
      isb = (3-r_isb)/2
      call ftpkys(unit,'1CTYP3A','VRAD-FRQ',   &
        'Velocity axis',status)
      call ftpkye(unit,'1CRPX3A',r_lrch(isb,iband),mdigit1,   &
        'reference pixel',status)
      call ftpkyd(unit,'1CRVL3A',r_lvoff(isb,iband)*1d3,mdigit2,   &
        'Velocity (m/s)  at reference channel',status)
      call ftpkye(unit,'11CD3A',r_lvres(isb,iband)*1e3,mdigit2,   &
        'Channel spacing in velocity (m/s)',status)
      call ftpkys(unit,'1CUNI3A','m/s',   &
        'Velocity unit axis',status)
      call ftpkyd(unit,'1VSOU3A',r_lvoff(isb,iband)*1d3,mdigit2,   &
        'Source Velocity (m/s)',status)
      call ftpkys(unit,'1SPEC3A','LSRK-TOP','Velocity System',   &
        status)
    endif
    ! Third data axis: Stokes parameters
    call ftpkys(unit,'2CTYP3','STOKES','Stokes axis',status)
    call ftpkye(unit,'2CRPX3',1.0,mdigit1,' ',status)
    call ftpkye(unit,'2CRVL3',-5.0,mdigit1,' ',status)
    call ftpkye(unit,'22CD3',-1.0,mdigit1,' ',status)
  endif
  if (status .gt. 0) goto 99
  ! loop on table rows
  krow = 0
  do ir=1, nrows
    ! when simulating switching, use the same data for ON and OFF starts
    ! of one cycle.
    if (switch) then
      jr = (ir+1)/2
      isw = ir+2-2*jr
    else
      jr = ir
      isw = 0
    endif
    k = 1+ h_offset(jr)
    !c         K = 1 + H_OFFSET(IR)
    call decode_header (data(k))
    ! Continuum Temporal data
    if (cmode(1:2).eq.'CT') then
      k0 = 1 + c_offset(jr)
    ! The average data does not reflect simulated switching (for now)
    ! Continuum Average data (opt. including corrected data)
    elseif (cmode(1:2).eq.'CA') then
      k0 = 1 + c_offset(r_ndump+1)
      if (r_ndatl.eq.2) then
        k1 = 1 + c_offset(r_ndump+2)
      endif
    ! Spectral Average data (opt. including corrected data)
    else
      k0 = 1 + l_offset(r_ndump+1)
      if (r_ndatl.eq.2) then
        k1 = 1 + l_offset(r_ndump+2)
      endif
    endif
    if (r_lmode.eq.1) then
      ! Correlation: Loop on baselines
      do isub=1, nsubbas
        ib = subbas(isub)
        !
        krow = krow+1
        !
        ! Fill in the columns:
        ! INTEGNUM
        call ftpclj(unit,1,krow,1,1,dh_dump,status)
        ia = r_iant(ib)
        ja = r_jant(ib)
        ! STARTANT
        call ftpclj(unit,2,krow,1,1,antbas(1,isub),status)
        ! ENDANTEN
        call ftpclj(unit,3,krow,1,1,antbas(2,isub),status)
        ! DATA
        ! Loop on  sidebands
        icol = ncoldata
        do isb = 1, r_nside
          if (r_lcal) then
            af = sqrt(dh_atfac(1,isb,ia)*dh_atfac(1,isb,ja))
          else
            af = 1.0
          endif
          ! phase uncorrected
          kd = k0   &
            + (ich+(isb-1+(ib-1)*nsb)*ntch)*2
          call rescale(2*nch,data(kd),af)
          call ftpcle(unit,icol,krow,1,2*nch,   &
            data(kd),status)
          ! phase corrected, for averaged data only.
          if (r_ndatl.eq.2 .and. cmode(1:2).ne.'CT') then
            kd = k1   &
              + (ich+(isb-1+(ib-1)*nsb)*ntch)*2
            call rescale(2*nch,data(kd),af)
            call ftpcle(unit,icol,krow,1+2*nch,2*nch,   &
              data(kd),status)
          endif
          icol = icol+1
        enddo
      enddo
    else
      ! AutoCorrelation Loop on antennas
      do isub=1, nsubant
        ia = subant(isub)
        krow = krow+1
        !
        ! Fill in the columns:
        ! INTEGNUM
        call ftpclj(unit,1,krow,1,1,dh_dump,status)
        ! ANTENNA
        call ftpclj(unit,2,krow,1,1,isub,status)
        ! DATA
        if (r_lcal) then
          af = dh_atfac(1,1,ia)
        else
          af = 1.0
        endif
        kd = k0 + ich+(ia-1)*ntch
        call rescale(nch,data(kd),af)
        call ftpcle(unit,ncoldata,krow,1,nch,   &
          data(kd),status)
      enddo
    endif
  enddo
  if (status .gt. 0) goto 99
  return
  ! Error return
99 call printerror('WRITE_FITS_DATA',status)
  error = .true.
end subroutine write_fits_data

program spectrum
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gkernel_types
  ! Local
  character(len=filename_length) :: mapdata,mapsort
  character(len=80) :: abscoord
  logical :: error
  integer(kind=size_length) :: ix, iy, n
  real*8 :: abs1, abs2, user1,user2
  character(len=24) :: ra, dec
  type(gildas) :: x,y
  integer :: ier
  type(projection_t) :: proj
  !
  call gildas_open
  call gildas_char('IN$',mapdata)
  call gildas_char('OUT$',mapsort)
  call gildas_char('COORD$',abscoord)
  call gildas_close
  !
  ! Echo the input values
  write(6,*) 'Input file: ',trim(mapdata)
  write(6,*) 'Output file: ',trim(mapsort)
  write(6,*) 'Coordinates (absolute): ',trim(abscoord)
  !
  ! Input file
  if (len_trim(mapdata).eq.0) goto 999
  call gildas_null(y)
  y%gil%ndim = 3 ! Must be a data cube
  call gdf_read_gildas(y,mapdata,'.lmv',error)
  if (error) then
    call gagout('F-SPECTRUM,  Cannot read input cube')
    goto 999
  endif
  !
  call gwcs_projec(y%gil%a0,y%gil%d0,y%gil%pang,y%gil%ptyp,proj,error)
  if (error)  goto 999
  abscoord = adjustl(abscoord)  ! Remove leading blanks to ease parsing
  n = len_trim(abscoord)
  ra = abscoord(1:index(abscoord, ' '))
  dec = abscoord(index(abscoord, ' ')+1:n)
  call sic_decode(ra,abs1,24,error)
  if (error) then
    call gagout('F-SPECTRUM,  error in SIC_DECODE')
    goto 999
  endif
  call sic_decode(dec,abs2,360,error)
  if (error) then
    call gagout('F-SPECTRUM,  error in SIC_DECODE')
    goto 999
  endif
  call abs_to_rel(proj,abs1, abs2, user1, user2, 1)
  ix = nint((user1 - y%gil%val(1))/y%gil%inc(1) + y%gil%ref(1))
  iy = nint((user2 - y%gil%val(2))/y%gil%inc(2) + y%gil%ref(2))
  write(6,*) 'Coordinates (pixels): ',ix,iy
  if (ix.le.0 .or. ix.gt.y%gil%dim(1) .or.  &
      iy.le.0 .or. iy.gt.y%gil%dim(2)) then
    write(6,*) 'F-SPECTRUM, Coordinates are off the cube'
    goto 999
  endif
  !
  ! Output file is a Table
  call gildas_null(x, type = 'TABLE')
  call sic_parsef(mapsort,x%file,' ','.tab')
  !
  ! Reset axes definitions
  x%gil%ndim = 2
  x%gil%dim(1) = y%gil%dim(3)
  x%gil%dim(2) = 2
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)), stat=ier)
  !
  ! Velocity values
  do n=1,x%gil%dim(1) 
    x%r2d(n,1) = (dble(n)-y%gil%ref(3))*y%gil%inc(3)+y%gil%val(3)
  enddo
  !
  ! Intensity values
  do n=1,x%gil%dim(1)
    x%r2d(n,2) = y%r3d(ix,iy,n)
  enddo
  !
  call gdf_write_image(x,x%r2d,error)
  call gagout('S-SPECTRUM,  Successful completion')
  call sysexi(1)  ! Success
  !
999 call sysexi(fatale)  ! Error
end program spectrum

subroutine sic_execute(line,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>sic_execute
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    SIC\EXECUTE "Command arg /option arg"
  !    SIC\EXECUTE 'stringvar'
  !  Execute a command line from a string or from a string variable.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='EXECUTE'
  character(len=commandline_length) :: command
  integer(kind=4) :: nc
  !
  if (sic_narg(0).gt.1) then
    call sic_message(seve%e,rname,  &
      'Trailing arguments. Command expects a single string.')
    error = .true.
    return
  endif
  !
  call sic_ch(line,0,1,command,nc,.true.,error)
  if (error)  return
  !
  if (command(1:1).eq.'@') then
    call exec_program(command)
  else
    call exec_command(command,error)
    if (error)  return
  endif
  !
end subroutine sic_execute

      SUBROUTINE PERIODOGRAM(LINE,ERROR)
C----------------------------------------------------------------------
C ORBIT	Support routine for command
C	PERIODOGRAM
C	Compute a Scargle periodogram (as described in ApJ 263, 835)
C Arguments :
C	LINE	C*(*)	Command line		Input
C	ERROR	L	Logical error flag	Output
C----------------------------------------------------------------------
      CHARACTER*(*) LINE
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
      INCLUDE 'pi.inc'
      INCLUDE 'data.inc'
*
      INTEGER NX
      REAL XREF,XVAL,XINC,XMIN,XMAX
      INTEGER I,J
      REAL CI,SI
      REAL CIA,SIA,CI2A,SI2A,CIB,SIB,CI2B,SI2B
      REAL PERIOD(MFREQ),POWER(MFREQ)
      REAL OM,TAU
*
      CALL SIC_R4(LINE,0,1,XMIN,.TRUE.,ERROR)
      IF (ERROR) RETURN
      CALL SIC_R4(LINE,0,2,XMAX,.TRUE.,ERROR)
      IF (ERROR) RETURN
      CALL SIC_I4(LINE,0,3,NX,.TRUE.,ERROR)
      IF (ERROR) RETURN
      IF (NX.GT.MFREQ) THEN
         WRITE(6,*) 'E-PERIODOGRAM,  Too many frequency points.',
     +        'Maximum is ',MFREQ
         ERROR=.TRUE.
         RETURN
      ENDIF
      NX = MAX(NX,2)
*
      XREF = 1
      XVAL = XMIN
      XINC = (XMAX-XMIN)/(NX-1)
*
      CI = 0
      SI = 0
      DO I=1,NX
         PERIOD(I) = XVAL+(I-XREF)*XINC
         IF (PERIOD(I).LE.0) THEN
            POWER(I) = 0
         ELSE
            OM = 2*PI/PERIOD(I)
            DO J=1,NVR
               CI = CI+COS(2*OM*VR(J,I_TIME))
               SI = SI+SIN(2*OM*VR(J,I_TIME))
            ENDDO
            TAU=ATAN2(SI,CI)/(2*OM)
*     
            CIA = 0
            SIA = 0
            CI2A = 0
            SI2A = 0
            CIB = 0
            SIB = 0
            CI2B = 0
            SI2B = 0
            DO J=1,NVR
               IF (STATVR(J).EQ.'OK') THEN
                  IF (CVR(J).EQ.'1') THEN
                     CIA = CIA+VR(J,I_VR)*COS(OM*(VR(J,I_TIME)-TAU))
                     SIA = SIA+VR(J,I_VR)*SIN(OM*(VR(J,I_TIME)-TAU))
                     CI2A = CI2A+COS(OM*(VR(J,I_TIME)-TAU))**2
                     SI2A = SI2A+SIN(OM*(VR(J,I_TIME)-TAU))**2
                  ELSEIF (CVR(J).EQ.'2') THEN
                     CIB = CIB+VR(J,I_VR)*COS(OM*(VR(J,I_TIME)-TAU))
                     SIB = SIB+VR(J,I_VR)*SIN(OM*(VR(J,I_TIME)-TAU))
                     CI2B = CI2B+COS(OM*(VR(J,I_TIME)-TAU))**2
                     SI2B = SI2B+SIN(OM*(VR(J,I_TIME)-TAU))**2
                  ELSE
                     WRITE(6,*) 'E-PERIODOGRAM,  Unknown velocity',
     +                    ' type',CVR(J)
                  ENDIF
               ENDIF
            ENDDO
            POWER(I) = 0
            IF (CI2A.GT.0) POWER(I) = POWER(I)+(CIA**2/CI2A)/2
            IF (SI2A.GT.0) POWER(I) = POWER(I)+(SIA**2/SI2A)/2
            IF (CI2B.GT.0) POWER(I) = POWER(I)+(CIB**2/CI2B)/2
            IF (SI2B.GT.0) POWER(I) = POWER(I)+(SIB**2/SI2B)/2
         ENDIF
      ENDDO
* Display computed periodogram
      CALL GR_EXEC('CLEAR PLOT')
      CALL GR4_GIVE('X',NX,PERIOD)
      CALL GR4_GIVE('Y',NX,POWER)
      CALL GR_EXEC('LIMITS  ')
      CALL GR_EXEC('SET BOX LANDSCAPE')
      CALL GR_EXEC('BOX')
      CALL GR_EXEC('HISTO')
*
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END

subroutine gr8_give(name,n,a)
  use greg_dependencies_interfaces
  use greg_interfaces
  use gildas_def
  use greg_error
  use greg_xyz
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  !---------------------------------------------------------------------
  character(len=*) :: name          !
  integer(kind=4) :: n                      !
  real(kind=8) :: a(*)                    !
  ! Local
  character(len=60) :: chain
  logical :: doit,error
  real(kind=8), pointer :: mycolumn(:)
  !
  error = .false.
  if (n.gt.maxxy) then
    call delete_xyz (.true.,error)
    call more_xyz(n,error)
  endif
  if (name.ne.'X' .and. name.ne.'Y' .and. name.ne.'Z') then
    chain = 'Unknown array '//name
    call greg_message(seve%w,'GR8_GIVE',chain)
    return
  endif
  doit = n.ne.nxy
  call delete_xyz (doit,errorg)
  if (errorg) return           ! don't exit, leave user time to call GR_ERROR
  if (name.eq.'X') then
    mycolumn => column_x
  elseif (name.eq.'Y') then
    mycolumn => column_y
  elseif (name.eq.'Z') then
    if (.not.associated(column_z)) then
      doit = .true.
      call delete_xyz (doit,error)
      column_z => column_xyz(:,3)
    endif
    mycolumn => column_z
  endif
  call r8tor8(a,mycolumn,n)
  nxy = n
  if (doit) call create_xyz(error)
end subroutine gr8_give
!
subroutine gr4_give(name,n,a)
  use greg_dependencies_interfaces
  use greg_interfaces
  use gildas_def
  use greg_error
  use greg_xyz
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  !---------------------------------------------------------------------
  character(len=*) :: name          !
  integer(kind=4) :: n                      !
  real(kind=4) :: a(*)                    !
  ! Local
  character(len=60) :: chain
  logical :: doit,error
  real(kind=8), pointer :: mycolumn(:)
  !
  error = .false.
  if (n.gt.maxxy) then
    call delete_xyz (.true.,error)
    call more_xyz(n,error)
  endif
  if (name.ne.'X' .and. name.ne.'Y' .and. name.ne.'Z') then
    chain = 'Unknown array '//name
    call greg_message(seve%w,'GR4_GIVE',chain)
    return
  endif
  doit = n.ne.nxy
  call delete_xyz (doit,errorg)
  if (errorg) return           ! don't exit, leave user time to call GR_ERROR
  if (name.eq.'X') then
    mycolumn => column_x
  elseif (name.eq.'Y') then
    mycolumn => column_y
  elseif (name.eq.'Z') then
    if (.not.associated(column_z)) then
      doit = .true.
      call delete_xyz (doit,error)
      column_z => column_xyz(:,3)
    endif
    mycolumn => column_z
  endif
  call r4tor8(a,mycolumn,n)
  nxy = n
  if (doit) call create_xyz(error)
end subroutine gr4_give
!
subroutine gr8_get(name,n,a)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr8_get
  use gildas_def
  use greg_error
  use greg_xyz
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*) :: name          !
  integer(kind=4) :: n                      !
  real(kind=8) :: a(*)                    !
  ! Local
  character(len=60) :: chain
  integer(kind=4) :: i
  real(kind=8), pointer :: mycolumn(:)
  !
  if (nxy.gt.n) then
    call greg_message(seve%e,'GR8_GET','Too many values in X, Y or Z array')
    errorg = .true.
    return                     ! don't exit, leave user time to call GR_ERROR
  endif
  if (name.ne.'X' .and. name.ne.'Y' .and. name.ne.'Z') then
    chain = 'Unknown array '//name
    call greg_message(seve%w,'GR8_GET',chain)
    return
  endif
  if (name.eq.'X') then
    mycolumn => column_x
  elseif (name.eq.'Y') then
    mycolumn => column_y
  elseif (name.eq.'Z') then
    if (.not.associated(column_z)) then
      do i=1,nxy
        a(i)=0.
      enddo
      mycolumn => null()
    else
      mycolumn => column_z
    endif
  endif
  if (associated(mycolumn)) call r8tor8(mycolumn,a,nxy)
  n = nxy
end subroutine gr8_get
!
subroutine gr4_get(name,n,a)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr4_get
  use gildas_def
  use greg_error
  use greg_xyz
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*) :: name          !
  integer(kind=4) :: n                      !
  real(kind=4) :: a(*)                    !
  ! Local
  character(len=60) :: chain
  integer(kind=4) :: i
  real(kind=8), pointer :: mycolumn(:)
  !
  if (nxy.gt.n) then
    call greg_message(seve%e,'GR4_SET','Too many values in X, Y or Z array')
    errorg = .true.
    return                     ! don't exit, leave user time to call GR_ERROR
  endif
  if (name.ne.'X' .and. name.ne.'Y' .and. name.ne.'Z') then
    chain = 'Unknown array '//name
    call greg_message(seve%w,'GR4_GET',chain)
    return
  endif
  if (name.eq.'X') then
    mycolumn => column_x
  elseif (name.eq.'Y') then
    mycolumn => column_y
  elseif (name.eq.'Z') then
    if (.not.associated(column_z)) then
      do i=1,nxy
        a(i)=0.
      enddo
      mycolumn => null()
    else
      mycolumn => column_z
    endif
  endif
  if (associated(mycolumn)) call r8tor4(mycolumn,a,nxy)
  n = nxy
end subroutine gr4_get
!
subroutine gr8_tgive(ix,iy,conv,zdata)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_error
  use greg_rg
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  ! (re)define the RG, NXRG and NYRG variable with the (Temporary) input
  ! Fortran array. This array is duplicated the internal Greg buffer
  ! associated to the RG.
  !---------------------------------------------------------------------
  integer(kind=4) :: ix                   !
  integer(kind=4) :: iy                   !
  real(kind=8) :: conv(6)                 !
  real(kind=8) :: zdata(*)                !
  ! Local
  character(len=*), parameter :: rname='GR8_TGIVE'
  character(len=256) :: chain
  !
  if (ix.le.1 .or. iy.le.1) then
    if (locwrd(zdata).eq.0) then
      call greg_message(seve%w,rname,'Regular grid array unloaded')
      call rg%deallocate(errorg)
      return
    elseif (ix.lt.1 .or. iy.lt.1) then
      write(chain,'(A,I6,A,I6)') 'Dimension error NX ',ix,' NY ',iy
      call greg_message(seve%e,rname,chain)
      errorg = .true.
      return
    endif
  endif
  !
  call reallocate_rgdata(ix,iy,errorg)
  if (errorg)  return
  !
  call r8tor4(zdata,rg%data,ix*iy)
  rg%xref = conv(1)
  rg%xval = conv(2)
  rg%xinc = conv(3)
  rg%yref = conv(4)
  rg%yval = conv(5)
  rg%yinc = conv(6)
  !
end subroutine gr8_tgive
!
subroutine gr4_tgive(ix,iy,conv,zdata)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_error
  use greg_rg
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  ! (re)define the RG, NXRG and NYRG variable with the (Temporary) input
  ! Fortran array. This array is duplicated the internal Greg buffer
  ! associated to the RG.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: ix        ! X size of array
  integer(kind=4), intent(in) :: iy        ! Y size of array
  real(kind=8),    intent(in) :: conv(6)   ! Axes definition
  real(kind=4),    intent(in) :: zdata(*)  ! Array values ix*iy
  ! Local
  character(len=*), parameter :: rname='GR4_TGIVE'
  character(len=256) :: chain
  !
  if (ix.le.1 .or. iy.le.1) then
    if (locwrd(zdata).eq.0) then
      call greg_message(seve%w,rname,'Regular grid array unloaded')
      call rg%deallocate(errorg)
      return
    elseif (ix.lt.1 .or. iy.lt.1) then
      write(chain,'(A,I6,A,I6)') 'Dimension error NX ',ix,' NY ',iy
      call greg_message(seve%e,rname,chain)
      errorg = .true.
      return
    endif
  endif
  !
  call reallocate_rgdata(ix,iy,errorg)
  if (errorg) return
  !
  call r4tor4(zdata,rg%data,ix*iy)
  rg%xref = conv(1)
  rg%xval = conv(2)
  rg%xinc = conv(3)
  rg%yref = conv(4)
  rg%yval = conv(5)
  rg%yinc = conv(6)
end subroutine gr4_tgive
!
subroutine gi4_tgive(ix,iy,conv,zdata)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_error
  use greg_rg
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  ! (re)define the RG, NXRG and NYRG variable with the (Temporary) input
  ! Fortran array. This array is duplicated the internal Greg buffer
  ! associated to the RG.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: ix        ! X size of array
  integer(kind=4), intent(in) :: iy        ! Y size of array
  real(kind=8),    intent(in) :: conv(6)   ! Axes definition
  integer(kind=4), intent(in) :: zdata(*)  ! Array values ix*iy
  ! Local
  character(len=*), parameter :: rname='GI4_TGIVE'
  character(len=256) :: chain
  !
  if (ix.le.1 .or. iy.le.1) then
    if (locwrd(zdata).eq.0) then
      call greg_message(seve%w,rname,'Regular grid array unloaded')
      call rg%deallocate(errorg)
      return
    elseif (ix.lt.1 .or. iy.lt.1) then
      write(chain,'(A,I6,A,I6)') 'Dimension error NX ',ix,' NY ',iy
      call greg_message(seve%e,rname,chain)
      errorg = .true.
      return
    endif
  endif
  !
  call reallocate_rgdata(ix,iy,errorg)
  if (errorg) return
  !
  call i4tor4(zdata,rg%data,ix*iy)
  rg%xref = conv(1)
  rg%xval = conv(2)
  rg%xinc = conv(3)
  rg%yref = conv(4)
  rg%yval = conv(5)
  rg%yinc = conv(6)
end subroutine gi4_tgive
!
subroutine gi8_tgive(ix,iy,conv,zdata)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_error
  use greg_rg
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  ! (re)define the RG, NXRG and NYRG variable with the (Temporary) input
  ! Fortran array. This array is duplicated the internal Greg buffer
  ! associated to the RG.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: ix        ! X size of array
  integer(kind=4), intent(in) :: iy        ! Y size of array
  real(kind=8),    intent(in) :: conv(6)   ! Axes definition
  integer(kind=8), intent(in) :: zdata(*)  ! Array values ix*iy
  ! Local
  character(len=*), parameter :: rname='GI8_TGIVE'
  character(len=256) :: chain
  !
  if (ix.le.1 .or. iy.le.1) then
    if (locwrd(zdata).eq.0) then
      call greg_message(seve%w,rname,'Regular grid array unloaded')
      call rg%deallocate(errorg)
      return
    elseif (ix.lt.1 .or. iy.lt.1) then
      write(chain,'(A,I6,A,I6)') 'Dimension error NX ',ix,' NY ',iy
      call greg_message(seve%e,rname,chain)
      errorg = .true.
      return
    endif
  endif
  !
  call reallocate_rgdata(ix,iy,errorg)
  if (errorg) return
  !
  call i8tor4(zdata,rg%data,ix*iy)
  rg%xref = conv(1)
  rg%xval = conv(2)
  rg%xinc = conv(3)
  rg%yref = conv(4)
  rg%yval = conv(5)
  rg%yinc = conv(6)
end subroutine gi8_tgive
!
subroutine gr4_rgive(ix,iy,conv,zdata)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_error
  use greg_rg
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  ! (re)define the RG, NXRG and NYRG variable with the input Fortran
  ! array. This array is refered as the new RG array (pointer), which
  ! means that the calling routine must NOT delete it as long as
  ! the RG variable exists.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: ix            ! X size of array
  integer(kind=4), intent(in) :: iy            ! Y size of array
  real(kind=8),    intent(in) :: conv(6)       ! Axes definition
  real(kind=4),    intent(in) :: zdata(ix,iy)  ! Array values ix*iy
  ! Local
  character(len=*), parameter :: rname='GR4_RGIVE'
  character(len=256) :: chain
  !
  if (ix.le.1 .or. iy.le.1) then
    if (locwrd(zdata).eq.0) then
      call greg_message(seve%w,rname,'Regular grid array unloaded')
      call rg%deallocate(errorg)
      return
    elseif (ix.lt.1 .or. iy.lt.1) then
      write(chain,'(A,I6,A,I6)') 'Dimension error NX ',ix,' NY ',iy
      call greg_message(seve%e,rname,chain)
      errorg = .true.
      return
    endif
  endif
  !
  call reassociate_rgdata(zdata,ix,iy,errorg)
  if (errorg)  return
  !
  rg%xref = conv(1)
  rg%xval = conv(2)
  rg%xinc = conv(3)
  rg%yref = conv(4)
  rg%yval = conv(5)
  rg%yinc = conv(6)
end subroutine gr4_rgive
!
subroutine gr8_tgivesub(kx,ky,conv,zdata,nx1,nx2,ny1,ny2)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_error
  use greg_rg
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: kx  !
  integer(kind=index_length), intent(in) :: ky  !
  real(kind=8) :: conv(6)                 !
  real(kind=8) :: zdata(*)                !
  integer(kind=4) :: nx1                  !
  integer(kind=4) :: nx2                  !
  integer(kind=4) :: ny1                  !
  integer(kind=4) :: ny2                  !
  ! Local
  integer(kind=4) :: ix,iy
  integer(kind=index_length) :: infx,supx,infy,supy
  !
  infx = min(nx1,nx2)
  infy = min(ny1,ny2)
  supx = max(nx1,nx2)
  supy = max(ny1,ny2)
  if (infx.lt.1 .or. supx.gt.kx .or. infy.lt.1 .or. supy.gt.ky) then
    call greg_message(seve%e,'RGDATA','Map subset does not lie in the map')
    errorg = .true.
    return
  endif
  ix = supx-infx+1
  iy = supy-infy+1
  !
  call reallocate_rgdata(ix,iy,errorg)
  if (errorg)  return
  !
  call subset8(zdata,kx,ky,rg%data,ix,iy,infx,supx,infy,supy)
  rg%xref = conv(1)+(1-infx)
  rg%yref = conv(4)+(1-infy)
  rg%xval = conv(2)
  rg%xinc = conv(3)
  rg%yval = conv(5)
  rg%yinc = conv(6)
end subroutine gr8_tgivesub
!
subroutine gr4_rgivesub(kx,ky,conv,zdata,nx1,nx2,ny1,ny2)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_error
  use greg_rg
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  ! Note that the name is Rgivesub since we always allocate memory for the
  ! subset.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: kx  !
  integer(kind=index_length), intent(in) :: ky  !
  real(kind=8) :: conv(6)                 !
  real(kind=4) :: zdata(*)                !
  integer(kind=4) :: nx1                  !
  integer(kind=4) :: nx2                  !
  integer(kind=4) :: ny1                  !
  integer(kind=4) :: ny2                  !
  ! Local
  integer(kind=4) :: ix,iy
  integer(kind=index_length) :: infx,supx,infy,supy
  !
  infx = min(nx1,nx2)
  infy = min(ny1,ny2)
  supx = max(nx1,nx2)
  supy = max(ny1,ny2)
  if (infx.lt.1 .or. supx.gt.kx .or. infy.lt.1 .or. supy.gt.ky) then
    call greg_message(seve%e,'RGDATA','Map subset does not lie in the map')
    errorg = .true.
    return
  endif
  ix = supx-infx+1
  iy = supy-infy+1
  !
  call reallocate_rgdata(ix,iy,errorg)
  if (errorg) return
  !
  call subset4(zdata,kx,ky,rg%data,ix,iy,infx,supx,infy,supy)
  rg%xref = conv(1)+(1-infx)
  rg%yref = conv(4)+(1-infy)
  rg%xval = conv(2)
  rg%xinc = conv(3)
  rg%yval = conv(5)
  rg%yinc = conv(6)
end subroutine gr4_rgivesub
!
subroutine greg_projec(pcode,proj)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_error
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch: a0,d0,pang in sequence)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: pcode    ! Projection code
  real(kind=8),    intent(in) :: proj(3)  ! a0,d0,pang
  ! Local
  logical :: error
  !
  error = .false.
  call gwcs_projec(proj(1),proj(2),proj(3),pcode,gproj,error)
  call setrem
end subroutine greg_projec
!
subroutine greg_projec_get(proj)
  use gwcs_types
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ public (for Astro)
  !  Return the current projection status in Greg
  !---------------------------------------------------------------------
  type(projection_t), intent(out) :: proj
  proj = gproj
end subroutine greg_projec_get
!
subroutine gr8_system(icode,error,equinox)
  use gbl_constant
  use gbl_message
  use greg_interfaces, except_this=>gr8_system
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)           :: icode    !
  logical,         intent(inout)        :: error    !
  real(kind=4),    intent(in), optional :: equinox  !
  !
  select case (icode)
  case (type_un,type_eq,type_ga,type_ic)
    continue
  case default
    call greg_message(seve%e,'GR8_SYSTEM','Coordinate system is not supported')
    error = .true.
    return
  end select
  !
  if (present(equinox)) then
    call setsys(icode,equinox)
  else
    call setsys(icode)
  endif
end subroutine gr8_system
!
subroutine gr8_blanking (xbval,xeval)
  use greg_interfaces, except_this=>gr8_blanking
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  real(kind=8) :: xbval                   !
  real(kind=8) :: xeval                   !
  call setbla(xbval,xeval)
end subroutine gr8_blanking
!
subroutine gr4_sub_extrema(z,n,m,bval,eval,zmin,zmax,i1,i2,j1,j2)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr4_sub_extrema
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: n                      !
  integer(kind=4) :: m                      !
  real(kind=4) :: z(n,m)                  !
  real(kind=4) :: bval                    !
  real(kind=4) :: eval                    !
  real(kind=4) :: zmin                    !
  real(kind=4) :: zmax                    !
  integer(kind=4) :: i1                     !
  integer(kind=4) :: i2                     !
  integer(kind=4) :: j1                     !
  integer(kind=4) :: j2                     !
  ! Local
  integer(kind=4) :: i,j,k
  !
  !     Protect against NaN and INFs even without blanking. Silent.
  !
  zmin=0.0
  zmax=0.0
  do j=j1,j2
    do i=i1,i2
      if (sic_fini4(z(i,j)).and.(abs(z(i,j)-bval).gt.eval))then
        zmin = z(i,j)
        zmax = z(i,j)
        goto 10
      endif
    enddo
  enddo
  !
10 continue
  do i=j,j2
    do k=i1,i2
      if (sic_fini4(z(k,i)) .and. (abs(z(k,i)-bval).gt.eval)) then
        if (z(k,i).lt.zmin) then
          zmin = z(k,i)
        elseif (z(k,i).gt.zmax) then
          zmax = z(k,i)
        endif
      endif
    enddo
  enddo
end subroutine gr4_sub_extrema
!
subroutine subset4 (x,nx,ny,y,mx,my,i1,i2,j1,j2)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS Internal routine
  ! Extract a two dimensional subset from a two dimensional image
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nx,ny     ! Dimensions of X
  real(kind=4),               intent(in)  :: x(nx,ny)  ! Input array
  integer(kind=4),            intent(in)  :: mx,my     ! Dimensions of Y
  real(kind=4),               intent(out) :: y(mx,my)  ! Output subset
  integer(kind=index_length), intent(in)  :: i1,i2     ! Min and Max pixels along first axis
  integer(kind=index_length), intent(in)  :: j1,j2     ! Min and Max pixels along second axis
  ! Local
  integer(kind=index_length) :: i,j,k,l
  !
  l = 0
  do j = j1,j2
    l = l+1
    k = 0
    do i=i1,i2
      k = k+1
      y(k,l) = x(i,j)
    enddo
  enddo
end subroutine subset4
!
subroutine subset8(x,nx,ny,y,mx,my,i1,i2,j1,j2)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS Internal routine
  ! Extract a two dimensional subset from a two dimensional image
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nx,ny     ! Dimensions of X
  real(kind=8),               intent(in)  :: x(nx,ny)  ! Input array
  integer(kind=4),            intent(in)  :: mx,my     ! Dimensions of Y
  real(kind=4),               intent(out) :: y(mx,my)  ! Output subset
  integer(kind=index_length), intent(in)  :: i1,i2     ! Min and Max pixels along first axis
  integer(kind=index_length), intent(in)  :: j1,j2     ! Min and Max pixels along second axis
  ! Local
  integer(kind=index_length) :: i,j,k,l
  !
  l = 0
  do j = j1,j2
    l = l+1
    k = 0
    do i=i1,i2
      k = k+1
      y(k,l) = x(i,j)
    enddo
  enddo
end subroutine subset8

!
subroutine f_tform(ch,i,code)
  implicit none
  character(len=*) :: ch            !
  integer :: i                      !
  character(len=1) :: code          !
  ! Local
  character(len=10) :: c10
  integer :: k
  !
  write(c10,'(i10)') i
  k = 1
  do while (index(c10(k:10),' ').ne.0)
    k = k+1
  enddo
  ch = c10(k:10)//code//char(0)
end subroutine f_tform

module yesnopi
  use gbl_format
  !---------------------------------------------------------------------
  ! Support module for SIC variables which are mapped on Fortran ones.
  !---------------------------------------------------------------------
  real(kind=8),    save :: pi=3.14159265358979323846d0
  logical,         save :: yes=.true.
  logical,         save :: no=.false.
  real(kind=4),    save :: nan
  integer(kind=4), save :: type_real=fmt_r4
  integer(kind=4), save :: type_inte=fmt_i4
  integer(kind=4), save :: type_long=fmt_i8
  integer(kind=4), save :: type_dble=fmt_r8
  integer(kind=4), save :: type_logi=fmt_l
  !
end module yesnopi
!
subroutine sic_opt(pr,log,mem)
  use sic_dependencies_interfaces
  use gpack_def
  use sic_interfaces, except_this=>sic_opt
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public (but obsolete in the context of new inits (at least since
  !   2008-04-11))
  ! Please use instead:
  !  - gprompt_set(pr): to set/modify the prompt
  !  - sic_open_log(log,error): to open the log file
  !  - no routine provided to turn ON|OFF the memory stack (default ON
  !    at startup, then user can call SIC\SIC MEMORY ON|OFF
  !---------------------------------------------------------------------
  ! SIC   External routine
  !       Modify the prompt and logfile logical name and status of stack
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: pr   ! The prompt
  character(len=*), intent(in) :: log  ! The log file name
  logical,          intent(in) :: mem  ! Status of stack editor
  ! Local
  logical :: error
  !
  error = .false.
  !
  call gprompt_set(pr)
  logbuf = mem
  !
  if (loaded) return
  !
  ! Set default message filter for packages without specific message routine
  call gmessage_parse_and_set(gpack_global_id,'s=fewriu',error)
  !
  ! Check the gag environment is present
  call sic_build_environment
  !
  call sic_open_log(log,error)
  if (error) return
  !
  ! Initialize widget library
#if defined(GAG_USE_STATICLINK)
  call init_gui
#endif
  !
  call sense_inter_state  ! Selects the state (Interactive or not)
  call sic_build
  !
end subroutine sic_opt
!
subroutine sic_open_log(logf,error)
  use sic_interfaces, except_this=>sic_open_log
  use sic_structures
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Open the LOG file
  !---------------------------------------------------------------------
  character(len=*) :: logf       ! The log file name
  logical :: error               ! Logical error flag
  ! Local
  integer :: status
  character(len=filename_length) :: logfile
  !
  if (lunlog.ne.0)  return
  !
  if (logf.eq.' ')  return
  !
  status = sic_getlun(lunlog)
  if (mod(status,2).eq.0) call sysexi(status)
  call sic_parse_file(logf,'GAG_LOG:','.LOG',logfile)
  status = sic_open (lunlog,logfile,'NEW',.false.)
  if (status.ne.0) then
    call sic_message(seve%e,'SIC_OPEN_LOG','Error opening '//logf)
    call putios('E-SIC,  ',status)
    error = .true.
    call sic_frelun(lunlog)
    lunlog = 0
  endif
  !
end subroutine sic_open_log
!
subroutine sic_flush_log(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_flush_log
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Flush the LOG file buffer onto disk
  ! Arguments :
  !       ERROR   L       Error returned
  !---------------------------------------------------------------------
  logical :: error                  ! INTENT(INOUT)
  ! Local
  integer :: status
  !
  if (lunlog.eq.0) return
  status = sic_flush(lunlog)
  if (status.ne.0) then
    error = .true.
    call sic_message(seve%e,'SIC_FLUSH_LOG','Error flushing log file '//  &
    'buffer onto disk')
  endif
end subroutine sic_flush_log
!
subroutine sic_close_log(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_close_log
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Close the LOG file and free its unit
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SIC_CLOSE_LOG'
  integer(kind=4) :: status
  !
  if (lunlog.eq.0) return
  !
  status = sic_close(lunlog)
  if (status.ne.0)  error = .true.
  !
  call sic_frelun(lunlog)
  !
  lunlog = 0
  if (error) then
    call sic_message(seve%d,rname,"ERROR")
  else
    call sic_message(seve%d,rname,"SUCCESS")
  endif
  !
end subroutine sic_close_log
!
subroutine sic_build
  use ieee_arithmetic
  use gbl_message
  use sic_dependencies_interfaces
  use sic_dictionaries
  use sic_interactions
  use sic_interfaces
  use sic_structures
  use yesnopi
  !---------------------------------------------------------------------
  ! SIC   External routine
  !       Initialize SIC
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer :: i,code,timer,ier,stbl
  logical :: error
  character(len=12) :: command
  character(len=60) :: name
  character(len=1), parameter :: backslash=char(92)
  ! SIC language
  integer, parameter :: sic_commands=98
  character(len=12) :: sic_vocab(sic_commands)
  data sic_vocab/            &
    '-@',                    &  !  1
    ' BEGIN',                &  !  2
    ' BREAK',                &  !  3
    ' CONTINUE',             &  !  4
    ' EDIT',                 &  !  5
    ' ELSE',                 &  !  6
    ' EXIT', '/NOPROMPT',    &  !  7- 8
    ' END',                  &  !  9
    ' FOR', '/IN','/WHILE',  &  ! 10-12
    '-HELP',                 &  ! 13
    '-IF',                   &  ! 14
    ' NEXT',                 &  ! 15
    '-ON',                   &  ! 16
    ' PAUSE',                &  ! 17
    '-PYTHON',               &  ! 18
    '#QUIT',                 &  ! 19
    ' RETURN',               &  ! 20
    ' TYPE', '/OUTPUT',      &  ! 21-22=mbuilt_sic_inter (update if this changes)
    ! Beyond this point, elemental commands which can not alter the
    ! standard flow of commands in the SIC interpreter
    ' ACCEPT',   '/ARRAY','/BINARY','/COLUMN','/FORMAT','/LINE',        &  ! 23-28
    ' COMPUTE',  '/BLANKING',                                           &  ! 29-30
    ' DATETIME', '/FROM','/TO',                                         &  ! 31-33
    ' DEFINE',   '/GLOBAL','/LIKE','/TRIM',                             &  ! 34-37
    ' DELETE',   '/SYMBOL','/VARIABLE','/FUNCTION',                     &  ! 38-41
    ' DIFF',                                                            &  ! 42-
    ' EXAMINE',  '/GLOBAL','/FUNCTION','/HEADER','/ADDRESS','/ALIAS',   &  ! 43-
                 '/PAGE','/SAVE',                                       &  !   -50
    ' EXECUTE',                                                         &  ! 51
    ' IMPORT',   '/DEBUG',                                              &  ! 52-53
    ! The LET option order is alphabetic, and symbolic names are given in
    ! dedicated module 'let_options'
    ' LET',      '/CHOICE','/FILE','/FORMAT','/FORMULA','/INDEX',       &  ! 54-
                 '/LOWER','/NEW','/NOQUOTE','/PROMPT','/RANGE',         &  !
                 '/REPLACE','/RESIZE','/SEXAGESIMAL','/STATUS',         &
                 '/UPPER','/WHERE',                                     &  !   -70
    ' MESSAGE',  '/FORMAT',                                             &  ! 71-72
    ' MFIT',     '/START','/STEP','/WEIGHTS','/EPSILON','/METHOD',      &  ! 73-
                 '/ITERATIONS','/QUIET','/BOUNDS',                      &  !   -81
    ' MODIFY',   '/FREQUENCY','/VELOCITY','/SPECUNIT',                  &  ! 82-85
    '-PARSE',                                                           &  ! 86
    ' RECALL',                                                          &  ! 87
    ' SAY',      '/FORMAT','/NOADVANCE',                                &  ! 88-90
    ' SIC',      '/COLOR',                                              &  ! 91-92
    ' SORT',                                                            &  ! 93
    ' SYMBOL',   '/INQUIRE',                                            &  ! 94-95
    ' SYSTEM',                                                          &  ! 96
    ' TIMER',    '/COMMAND' /                                              ! 97-98
  ! GUI language
  integer, parameter :: ngui=15
  character(len=12) :: cgui(ngui)
  data cgui/                              &
    ' BUTTON',                            &
    ' URI',                               &
    ' END',                               &
    ' ERASE',                             &
    ' GO',                                &
    ' PANEL', '/CLOSE','/DETACH','/LOG',  &
    ' MENU', '/CLOSE','/CHOICES',         &
    ' SUBMENU', '/CLOSE',                 &
    ' WAIT'/
  !
  error = .false.
  !
  ! Loaded : return
  if (loaded) return
  loaded = .true.
  !
  ! Set environment variable $GAG_PROGRAM. It is only visible to the
  ! current process and its child processes (e.g. SYSTEM command
  ! sub-shell)
  ier = sic_setenv('GAG_PROGRAM',gprompt_master)
  !
  sicinteger = fmt_i4
  sicsystemerror = .true.  ! Error from command SIC\SYSTEM ignored or not?
  nan = ieee_value(0.,ieee_quiet_nan)
  !
  ! Initialize the stack
  call init_stack
  !
  ! Initialize the loops
  bulend = 1
  !
  ! Initialize error recovery
  nerr  (0) = e_pause
  errcom(0) = 'SIC'//backslash//'PAUSE'
  !
  ! Initialize the IF blocks
  do i=1,mcif
    if_finished(i) = .true.
    if_active(i) = .false.
    if_elsefound(i) = .false.
  enddo
  if_depth(1) = 1
  if_current = 0
  nlire = 0
  ! Initialize vocabulary and help
  nlang = 0
  klang(1) = 0
  call sic_load('SIC','GAG_HELP_SIC',sic_commands,sic_vocab,'9.3    10-Apr-2016')
  ! Take the associated name help_file in the files names dictionary
  ier = sic_getlog (languages(1)%help)
  !
  ! Action related to the inter_state mode (see sense_inter_state)
  if (edit_mode) then
    tt_edit = 'GAG_HELP_MODE'
    ier = sic_getlog (tt_edit)
    help_mode = help_page
    if (tt_edit.eq.'HTML') then
      help_mode = help_html
    elseif (tt_edit.eq.'SCROLL') then
      help_mode = help_scroll
    endif
  else
    help_mode = help_scroll
  endif
  call trap_ctrlc
  !
  ! Selects logical units for HELP and macros
  call sic_lunmac_init(error)
  if (error)  return
  sicext(1) = '.pro'
  lext(1) = 4
  do i=2,maxext
    lext(i) = 0
  enddo
  !
  ! Setup the symbol and variable tables
  call sic_inisymbol(error)
  if (error)  return
  call sic_inivariable
  call sic_inifunction
  ! Setup predefined symbols
  command = 'SIC'//backslash//'SYSTEM'
  call sic_setsymbol ('SHELL',command,error)
  command = 'SIC'//backslash//'end if'
  call sic_setsymbol ('ENDIF',command,error)
  call sic_setsymbol ('SIC'//backslash//'ENDIF',command,error)
  !
  i = 0
  cur_dir = ' '
  call sic_setdir(cur_dir,i,error)
  !
  sic_precis = 'DOUBLE'
  sicprecis = fmt_r8
  !
  ! Defines standard variables
  call sic_variables(error)
  if (error) call sic_message(seve%e,rname,'Error in variables definition')
  !
  ! Defines random functions
  call sic_def_func('GAUSSIAN1D',s_gaussian1d,d_gaussian1d,3,error,hlpfile='GAG_HELP_FUNC_SIC')
  call sic_def_func('NORMAL1D',s_normal1d,d_normal1d,3,error,hlpfile='GAG_HELP_FUNC_SIC')
  call sic_def_func('NOISE',s_noise,d_noise,1,error,hlpfile='GAG_HELP_FUNC_SIC')
  call sic_def_func('RANDOM',s_random,d_random,1,error,hlpfile='GAG_HELP_FUNC_SIC')
  if (error) call sic_message(seve%e,rname,'Error in function definition')
  !
  ! Define the default syntax
  name = 'FREE'
  ier = sic_getlog('GAG_SYNTAX',name)
  if (name.eq.'FIXED') then
    lsynt = 1
  else
    lsynt = 2
  endif
  !
  ! Define the default editor
  tt_edit = 'GAG_EDIT'
  ier = sic_getlog (tt_edit)
  !
  ! Activate X-Window mode if needed
  if (.not.inter_state)  sic_window = .false.
  !
  call search_clients(code)    ! Search for existing clients, launch keyboard
  if (code.eq.-1)  sic_window = .false.
  !
  ! These variables are already tested by gmaster. Just here for
  ! retrocompatibility with old programs.
  if (sic_window) then
    name = 'NONE'
    ier = sic_getlog('GAG_WIDGETS',name)
    sic_window = name.ne.'NONE'
  endif
  !
#ifndef WIN32
  if (sic_window) then
    name = ''
    ier = sic_getlog ('$DISPLAY',name)  ! sic_getenv???
    sic_window = ier.eq.0
  endif
#endif
  !
  if (sic_window) then
    ier = sic_getlog('SIC_TIMER',timer)  ! Hour units
    if (ier.eq.0)  call xgag_settimer(timer*3600)
  endif
  !
  if (edit_mode.and.inter_state .and. gmaster_get_ismaster().eq.1) then
    ! Start keyboard thread loop:
    !  - only if interactive mode (i.e. we need a prompt)
    !  - only if Gildas is master (if Gildas is slave, sic_python.c will
    !    start a keyboard by itself).
    call prompt_loop(code)
    if (code.eq.-1)  sic_window = .false.
  endif
  !
  if (sic_window) then
    call sic_message(seve%d,rname,'X-Window mode active')
    call sic_begin('GUI','GAG_HELP_GUI',-ngui,cgui,'1.2    10-Sep-2003',  &
      run_gui,err_gui)
  else
    call sic_message(seve%d,rname,'Normal keyboard mode')
  endif
  !
  call load_vector             ! Test
  call init_mfit
  call init_adjust
  !
  ! Remember the GAG_PROC: directory (to be sure to remove it, and not another one)
  ier = sic_getlog('GAG_PROC:',gag_proc)
  !
  ! Set default GILDAS Data format
  stbl = 2
  ier = sic_getlog('GILDAS_HEADERS',stbl)
  call gdf_stbl(stbl,error)
  !
end subroutine sic_build
!
subroutine make_gag_magic(gag_logical)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>make_gag_magic
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Get a Gildas logical name and:
  !  1) append a magic (unique) number
  !  2) create the resulting directory
  !  3) update the value in the dictionnary
  ! Any error raised here is FATAL.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: gag_logical
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=filename_length) :: message,file
  integer(kind=4) :: ier,ln,i,magicnum
  logical :: error
  character(len=message_length) :: mess
  !
  ! 1) Append a magic number
  call sic_parse_file(gag_logical,'','',message)
  ln = len_trim(message)+1
  if (ln.gt.len(message)-10) then
    write(mess,'(A,A,I0,A)')  &
      gag_logical,' translation longer than ',len(message),' characters'
    call sic_message(seve%f,rname,mess)
    call sysexi(fatale)
  endif
  magicnum = gag_getpid()
  write(message(ln:),'(I0)')  magicnum
  ln = len_trim(message)
  !
  ! 2) Create the directory, append a letter in case of error
  error = .false.
  call gag_mkdir(message(1:ln),error)
  i = 0
  do while (error)
    message(ln:ln) = char(i+ichar('A'))
    call gag_mkdir(message(1:ln),error)
    i = i+1
    if (i.gt.26) then
      call sic_message(seve%f,rname,'Cannot create '//gag_logical//' after 26 attempts')
      call sysexi(fatale)
    endif
  enddo
  !
  ! 3) Update the dictionnary value
  ln = ln+1
  message(ln:ln) = '/'
  ier = sic_setlog(gag_logical,message(1:ln))
  file = gag_logical
  ier = sic_getlog(file)
  !
end subroutine make_gag_magic
!
subroutine make_gag(logdir)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>make_gag
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Creates input directory if it does not exist. Input must be a
  !       symbolic name.
  ! Arguments :
  !       LOGDIR     C*(*)       Symbolic name      Input
  !---------------------------------------------------------------------
  character(len=*) :: logdir        !
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=1), parameter :: backslash=char(92)
  character(len=filename_length) :: dir
  integer :: nl,nd
  logical :: exist,error
  !
  ! First, check if input in a symbolic name for a path (i.e. it ends
  ! with a ":")
  nl = len_trim(logdir)
  if (logdir(nl:nl).ne.':') then
    call sic_message(seve%e,rname,'"'//logdir(1:nl)//'" is not a symbolic '//  &
    'name')
    goto 100
  endif
  !
  ! Parse symbolic name
  call sic_parse_file(logdir,'','',dir)
  nd = len_trim(dir)
  if (dir(nd:nd).eq.'/'.or.dir(nd:nd).eq.backslash) nd=nd-1   ! Strip last slash as inquire does not like it!
  !
  ! Check if symbolic name was successfully parsed
  if (logdir(nl:nl).eq.dir(nd:nd)) then
    call sic_message(seve%e,rname,'Could not parse "'//logdir(1:nl)//'"')
    goto 100
  endif
  !
  ! Check if translation is empty
  if (dir(1:nd).eq.'') then
    call sic_message(seve%e,rname,'"'//logdir(1:nl)//'" is defined but provides empty translation')
    goto 100
  endif
  !
  ! Check if directory already exists
  inquire(file=dir(1:nd),exist=exist)
  if (.not.exist) then
    error = .false.
    call gag_mkpath(dir(1:nd),error)
    if (error) then
      call sic_message(seve%e,rname,'Cannot create directory "'//dir(1:nd)//'"')
      goto 100
    endif
  endif
  !
  ! Success
  return
  !
  ! Fatal error
100 call sic_message(seve%f,rname,'Cannot create "'//logdir(1:nl)//  &
        '" directory')
  call sysexi(fatale)
  !
end subroutine make_gag
!
subroutine sic_build_environment
  use sic_interfaces, except_this=>sic_build_environment
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Set the log file
  !---------------------------------------------------------------------
  call make_gag("gag_gag:")
  call make_gag("gag_log:")
  call make_gag("gag_scratch:")
  call make_gag("gag_init:")
  call make_gag("gag_tmp:")
  call make_gag("gag_proc:")
  !
  ! Magic ones (unique per session)
  call make_gag_magic('GAG_SCRATCH:')
  call make_gag_magic('GAG_PROC:')
  !
end subroutine sic_build_environment
!
subroutine sic_variables(error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use sic_define_status
  use sic_interactions
  use sic_python
  use sic_structures
  use yesnopi
  !---------------------------------------------------------------------
  ! @ no-interface (problem with private module sic_define_status)
  !  Define SIC variables (i.e. Sic variables owned by the SIC package)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=12), save :: prognam
  !
  call sic_def_dble ('PI',pi,0,0,.true.,error)
  call sic_def_logi ('YES',yes,.true.,error)
  call sic_def_logi ('NO',no,.true.,error)
  call sic_def_real ('NAN',nan,0,0,.true.,error)
  call sic_def_inte ('TYPE_INTE',type_inte,0,0,.true.,error)
  call sic_def_inte ('TYPE_LONG',type_long,0,0,.true.,error)
  call sic_def_inte ('TYPE_REAL',type_real,0,0,.true.,error)
  call sic_def_inte ('TYPE_DBLE',type_dble,0,0,.true.,error)
  call sic_def_inte ('TYPE_LOGI',type_logi,0,0,.true.,error)
  !
  call sic_defstructure('SIC',.true.,error)
  call sic_def_logi ('SIC%VERIFY',lverif,.false.,error)
  call sic_def_logi ('SIC%EXIST',lexist,.true.,error)
  call sic_def_logi ('SIC%INTERACTIVE',inter_state,.true.,error)
  call sic_def_inte ('SIC%CHECK_MACRO',sic_stepin,0,0,.false.,error)
  call sic_def_logi ('SIC%DEFINE_STRICT',strict_define,.false.,error)
  call sic_def_char ('SIC%EDITOR',tt_edit,.true.,error)
  call sic_def_char ('SIC%DIRECTORY',cur_dir,.true.,error)
  call sic_def_char ('SIC%PRECISION',sic_precis,.true.,error)
  call sic_def_logi ('SIC%INITWINDOW',sic_initwindow,.false.,error)
  call sic_def_logi ('SIC%ERROR',sicvar_error,.true.,error)
  call sic_def_logi ('SIC%SYSTEMERROR',sicsystemerror,.false.,error)
  !
  ! Program name
  prognam = gprompt_master
  call sic_lower (prognam)
  call sic_def_char ('SIC%PROGRAM',prognam,.true.,error)
  !
  ! Define SIC%WINDOW in a protected mode if it could not be activated
  ! automatically. Allow the User to change the mode otherwise.
  if (sic_window) then
    call sic_def_logi ('SIC%WINDOW',sic_window,.false.,error)
  else
    call sic_def_logi ('SIC%WINDOW',sic_window,.true.,error)
  endif
  !
  call sic_variables_system(error)
  if (error)  return
  call sic_variables_openmp(error)
  if (error)  return
  call sic_variables_python(error)
  if (error)  return
  call sic_variables_codes('SIC',error)
  if (error)  return
  call sic_ansi_termcodes(error)
  if (error)  return
end subroutine sic_variables
!
subroutine sic_variables_system(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_variables_system
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Define system-related variables in the SIC% structure
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=index_length) :: dims(sic_maxdims)
  integer(kind=4) :: ib
  ! Support variables
  character(len=20), save :: architecture
  character(len=36), save :: system
  character(len=12), save :: revision_name
  character(len=12), save :: revision_commit
  character(len=25), save :: revision_date
  character(len=8),  save :: compiler_kind
  character(len=12), save :: compiler_name
  integer(kind=4),   save :: compiler_version
  character(len=8),  save :: os_kind
  character(len=8),  save :: os_name
  character(len=8),  save :: os_version
  character(len=20), save :: version
  character(len=20), save :: usernam
  character(len=20), save :: hostnam
  !
  architecture = ARCH  ! Replaced by CPP
  call sic_def_char ('SIC%ARCHITECTURE',architecture,.true.,error)
  if (error)  return
  system = SYSTEM  ! Replaced by CPP
  call sic_def_char ('SIC%SYSTEM',system,.true.,error)
  if (error)  return
  !
  ! GILDAS version
  call sic_defstructure('SIC%REVISION',.true.,error)
  if (error)  return
  revision_commit = REV_COMMIT  ! Replaced by CPP
  revision_name = REV_NAME  ! Replaced by CPP
  ib = index(revision_name,' ')
  if (ib.gt.0)  revision_name(ib:) = ' '  ! Drop refined date, if any
  revision_date = REV_DATE  ! Replaced by CPP
  call sic_def_char ('SIC%REVISION%COMMIT',revision_commit,.true.,error)
  if (error)  return
  call sic_def_char ('SIC%REVISION%NAME',revision_name,.true.,error)
  if (error)  return
  call sic_def_char ('SIC%REVISION%DATE',revision_date,.true.,error)
  if (error)  return
  !
  ! Compiler description
  call sic_defstructure('SIC%COMPILER',.true.,error)
  if (error)  return
  compiler_name = COMP_NAME  ! Replaced by CPP
#if defined(GFORTRAN)
  ! compiler_name = executable name e.g. gfortran132
  compiler_kind = 'gfortran'
  compiler_version = GFORTRAN_VERSION  ! Replaced by CPP
#elif defined(IFORT)
  ! compiler_name = executable name
  compiler_kind = 'ifort'
  compiler_version = IFORT_VERSION  ! Replaced by CPP
#endif
  call sic_def_char('SIC%COMPILER%KIND',compiler_kind,.true.,error)
  if (error)  return
  call sic_def_char('SIC%COMPILER%NAME',compiler_name,.true.,error)
  if (error)  return
  call sic_def_inte('SIC%COMPILER%VERSION',compiler_version,0,0,.true.,error)
  if (error)  return
  !
  ! OS description
  call sic_defstructure('SIC%OS',.true.,error)
  if (error)  return
  os_kind = OS_KIND  ! Replaced by CPP
  os_name = OS_NAME  ! Replaced by CPP
  os_version = OS_VERSION  ! Replaced by CPP
  call sic_def_char('SIC%OS%KIND',os_kind,.true.,error)
  if (error)  return
  call sic_def_char('SIC%OS%NAME',os_name,.true.,error)
  if (error)  return
  call sic_def_char('SIC%OS%VERSION',os_version,.true.,error)
  if (error)  return
  !
#if defined(WIN32)
  version = 'MS-Windows'
#else
  version = 'Generic-Unix'
#endif
  call sic_def_char ('SIC%VERSION',version,.true.,error)
  if (error)  return
  !
  call sic_username(usernam)
  call sic_def_char ('SIC%USER',usernam,.true.,error)
  if (error)  return
  call sic_hostname(hostnam)
  call sic_def_char ('SIC%HOST',hostnam,.true.,error)
  if (error)  return
  !
  ! Total RAM size (MB)
  call gag_ramsize(sic_ramsize)
  call sic_def_long ('SIC%RAMSIZE',sic_ramsize,0,0,.true.,error)
  if (error)  return
  !
  ! CPU caches size (kiB)
  dims(:) = 0
  dims(1) = 4
  call gag_cachesize(sic_cachel(1),sic_cachel(2),sic_cachel(3),sic_cachel(4))
  call sic_def_long ('SIC%CACHEL',sic_cachel,1,dims,.true.,error)
  if (error)  return
  !
end subroutine sic_variables_system
!
subroutine sic_variables_openmp(error)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_variables_openmp
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Define OpenMP-related variables in the SIC% structure
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: ier,nt,ns
  !
  call sic_defstructure('SIC%OPENMP',.true.,error)
  if (error) return
  sic_omp_compiled = .false.
  !$ sic_omp_compiled = .true.
  call sic_def_logi ('SIC%OPENMP%ACTIVE',sic_omp_compiled,.true.,error)
  if (error)  return
  sic_omp_ncores = 1
  call sic_def_inte ('SIC%OPENMP%NCORES',sic_omp_ncores,0,0,.true.,error)
  if (error)  return
  sic_omp_mthreads = 1
  call sic_def_inte ('SIC%OPENMP%MTHREADS',sic_omp_mthreads,0,0,.true.,error)
  if (error)  return
  sic_omp_nthreads = 1
  call sic_def_inte ('SIC%OPENMP%NTHREADS',sic_omp_nthreads,0,0,.true.,error)
  if (error)  return
  !
  !$ sic_omp_ncores = omp_get_num_procs()       ! Logical Cores in general
  !$ nt = 0
  !$ ier = sic_getlog('$OMP_NUM_THREADS',nt)
  !$ if (nt.ne.0) then
  !$    sic_omp_mthreads = min(nt,sic_omp_ncores)  ! Maximum reasonable number...
  !$ else
  !$    sic_omp_mthreads = sic_omp_ncores          ! Maximum 1 per logical core
  !$ endif
  !$ sic_omp_ncores = sic_omp_ncores/2             ! Assume Hyper Threading
  !$ ns = 0
  !$ ier = sic_getlog('$SLURM_CPUS_PER_TASK',ns)
  !$ if (ns.ne.0) sic_omp_mthreads = min(ns,sic_omp_mthreads)
  !$
  !$ sic_omp_nthreads = sic_omp_ncores             ! Default 1 per physical core
  !$ call omp_set_num_threads(sic_omp_nthreads)
  !
end subroutine sic_variables_openmp
!
subroutine sic_variables_python(error)
  use sic_interfaces, except_this=>sic_variables_python
  use sic_interactions
  use sic_python
  !---------------------------------------------------------------------
  ! @ private
  ! Define Gildas-Python related variables in the SIC% structure
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  logical,          save :: python_active   ! Support for SIC%PYTHON%ACTIVE
  character(len=8), save :: python_version  ! Support for SIC%PYTHON%VERSION
  logical,          save :: python_master   ! Support for SIC%PYTHON%MASTER
  !
  call sic_defstructure('SIC%PYTHON',.true.,error)
  if (error) return
  !
#if defined(GAG_USE_PYTHON)
  python_active = .true.
  python_version = PYTHON_VERSION  ! Replaced by CPP
  python_master = .not.gildas_ismaster
#else
  python_active = .false.
  python_version = ''
  python_master = .false.
#endif
  call sic_def_logi('SIC%PYTHON%ACTIVE',python_active,.true.,error)
  if (error)  return
  call sic_def_char('SIC%PYTHON%VERSION',python_version,.true.,error)
  if (error)  return
  call sic_def_logi('SIC%PYTHON%MASTER',python_master,.true.,error)
  if (error)  return
  !
  ! Old parameter for GILDAS-master
  call sic_def_logi ('SIC%MASTER',gildas_ismaster,.true.,error)
  if (error)  return
end subroutine sic_variables_python
!
subroutine sic_variables_codes(parent,error)
  use gbl_constant
  use sic_interfaces, except_this=>sic_variables_codes
  !---------------------------------------------------------------------
  ! @ private
  !  Define SIC variables providing various codes
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: parent  ! Parent structure name
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=32) :: str
  ! PROJECTION
  integer(kind=4), save :: sic_p_none=p_none
  integer(kind=4), save :: sic_p_gnomonic=p_gnomonic
  integer(kind=4), save :: sic_p_ortho=p_ortho
  integer(kind=4), save :: sic_p_azimuthal=p_azimuthal
  integer(kind=4), save :: sic_p_stereo=p_stereo
  integer(kind=4), save :: sic_p_lambert=p_lambert
  integer(kind=4), save :: sic_p_aitoff=p_aitoff
  integer(kind=4), save :: sic_p_radio=p_radio
  integer(kind=4), save :: sic_p_sfl=p_sfl
  integer(kind=4), save :: sic_p_mollweide=p_mollweide
  integer(kind=4), save :: sic_p_ncp=p_ncp
  integer(kind=4), save :: sic_p_cartesian=p_cartesian
  ! COORDINATES
  integer(kind=4), save :: sic_coord_un=type_un
  integer(kind=4), save :: sic_coord_eq=type_eq
  integer(kind=4), save :: sic_coord_ga=type_ga
  integer(kind=4), save :: sic_coord_ho=type_ho
  integer(kind=4), save :: sic_coord_ic=type_ic
  ! VELOCITY TYPES
  integer(kind=4), save :: sic_vel_unk=vel_unk
  integer(kind=4), save :: sic_vel_lsr=vel_lsr
  integer(kind=4), save :: sic_vel_hel=vel_hel
  integer(kind=4), save :: sic_vel_obs=vel_obs
  integer(kind=4), save :: sic_vel_ear=vel_ear
  integer(kind=4), save :: sic_vel_aut=vel_aut
  ! VELOCITY CONVENTIONS
  integer(kind=4), save :: sic_vconv_unk=vconv_unk
  integer(kind=4), save :: sic_vconv_rad=vconv_rad
  integer(kind=4), save :: sic_vconv_opt=vconv_opt
  integer(kind=4), save :: sic_vconv_30m=vconv_30m
  ! DATA KIND
  integer(kind=4), save :: sic_kind_spec=kind_spec
  integer(kind=4), save :: sic_kind_cont=kind_cont
  integer(kind=4), save :: sic_kind_sky=kind_sky
  integer(kind=4), save :: sic_kind_onoff=kind_onoff
  integer(kind=4), save :: sic_kind_focus=kind_focus
  ! X UNIT
  integer(kind=4), save :: sic_a_velo=a_velo
  integer(kind=4), save :: sic_a_freq=a_freq
  integer(kind=4), save :: sic_a_wave=a_wave
  ! SWITCH
  integer(kind=4), save :: sic_mod_unkn=mod_unk
  integer(kind=4), save :: sic_mod_freq=mod_freq
  integer(kind=4), save :: sic_mod_posi=mod_pos
  integer(kind=4), save :: sic_mod_fold=mod_fold
  integer(kind=4), save :: sic_mod_wobb=mod_wob
  integer(kind=4), save :: sic_mod_mixe=mod_mix
  !
  str = trim(parent)//'%CODE'
  call sic_defstructure(str,.true.,error)
  if (error) return
  !
  ! PROJECTION
  call sic_defstructure(trim(str)//'%PROJ',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%PROJ%NONE',     sic_p_none,     0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%GNOMONIC', sic_p_gnomonic, 0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%ORTHO',    sic_p_ortho,    0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%AZIMUTHAL',sic_p_azimuthal,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%STEREO',   sic_p_stereo,   0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%LAMBERT',  sic_p_lambert,  0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%AITOFF',   sic_p_aitoff,   0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%RADIO',    sic_p_radio,    0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%SFL',      sic_p_sfl,      0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%MOLLWEIDE',sic_p_mollweide,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%NCP',      sic_p_ncp,      0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%CARTESIAN',sic_p_cartesian,0,0,.true.,error)
  if (error)  return
  !
  ! COORDINATES
  call sic_defstructure(trim(str)//'%COORD',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%COORD%UNK', sic_coord_un,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%COORD%EQU', sic_coord_eq,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%COORD%GAL', sic_coord_ga,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%COORD%HOR', sic_coord_ho,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%COORD%ICRS',sic_coord_ic,0,0,.true.,error)
  if (error)  return
  !
  ! VELOCITY TYPES
  call sic_defstructure(trim(str)//'%VELO',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%VELO%UNK',  sic_vel_unk,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%LSR',  sic_vel_lsr,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%HELIO',sic_vel_hel,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%OBS',  sic_vel_obs,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%EARTH',sic_vel_ear,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%AUTO', sic_vel_aut,0,0,.true.,error)
  if (error)  return
  !
  ! VELOCITY CONVENTION
  call sic_defstructure(trim(str)//'%CONV',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%CONV%UNK',sic_vconv_unk,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%CONV%RAD',sic_vconv_rad,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%CONV%OPT',sic_vconv_opt,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%CONV%30M',sic_vconv_30m,0,0,.true.,error)
  !
  ! DATA KIND
  call sic_defstructure(trim(str)//'%KIND',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%KIND%SPEC', sic_kind_spec, 0,0,.true.,error)
  call sic_def_inte(trim(str)//'%KIND%CONT', sic_kind_cont, 0,0,.true.,error)
  call sic_def_inte(trim(str)//'%KIND%SKY',  sic_kind_sky,  0,0,.true.,error)
  call sic_def_inte(trim(str)//'%KIND%ONOFF',sic_kind_onoff,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%KIND%FOCUS',sic_kind_focus,0,0,.true.,error)
  if (error)  return
  !
  ! X UNIT
  call sic_defstructure(trim(str)//'%XUNIT',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%XUNIT%VELO',sic_a_velo,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%XUNIT%FREQ',sic_a_freq,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%XUNIT%WAVE',sic_a_wave,0,0,.true.,error)
  if (error)  return
  !
  ! SWITCH
  call sic_defstructure(trim(str)//'%SWITCH',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%SWITCH%UNKNOWN',sic_mod_unkn,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%FREQ',   sic_mod_freq,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%POSI',   sic_mod_posi,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%FOLD',   sic_mod_fold,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%WOBBLER',sic_mod_wobb,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%MIXED',  sic_mod_mixe,0,0,.true.,error)
  if (error)  return
  !
end subroutine sic_variables_codes
!
subroutine sic_ansi_termcodes(error)
  use sic_interfaces, except_this=>sic_ansi_termcodes
  use gbl_ansicodes
  !---------------------------------------------------------------------
  ! @ private
  ! Define and populate the ANSI% structure
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Support variables for the ANSI% variables
  character(len=5), save :: sic_ansi_black=c_black
  character(len=5), save :: sic_ansi_red=c_red
  character(len=5), save :: sic_ansi_green=c_green
  character(len=5), save :: sic_ansi_yellow=c_yellow
  character(len=11), save :: sic_ansi_orange=c_orange
  character(len=5), save :: sic_ansi_blue=c_blue
  character(len=5), save :: sic_ansi_magenta=c_magenta
  character(len=5), save :: sic_ansi_cyan=c_cyan
  character(len=5), save :: sic_ansi_white=c_white
  character(len=4), save :: sic_ansi_clear=c_clear
  character(len=4), save :: sic_ansi_bold=c_bold
  character(len=4), save :: sic_ansi_under=c_under
  character(len=4), save :: sic_ansi_reverse=c_reverse
  character(len=4), save :: sic_ansi_blink=c_blink
  !
  call sic_defstructure('ANSI',.true.,error)
  if (error)  return
  call sic_def_char('ANSI%RED',sic_ansi_red,.true.,error)
  call sic_def_char('ANSI%GREEN',sic_ansi_green,.true.,error)
  call sic_def_char('ANSI%YELLOW',sic_ansi_yellow,.true.,error)
  call sic_def_char('ANSI%ORANGE',sic_ansi_orange,.true.,error)
  call sic_def_char('ANSI%BLUE',sic_ansi_blue,.true.,error)
  call sic_def_char('ANSI%MAGENTA',sic_ansi_magenta,.true.,error)
  call sic_def_char('ANSI%CYAN',sic_ansi_cyan,.true.,error)
  call sic_def_char('ANSI%WHITE',sic_ansi_white,.true.,error)
  call sic_def_char('ANSI%BLACK',sic_ansi_black,.true.,error)
  call sic_def_char('ANSI%NONE',sic_ansi_clear,.true.,error)
  call sic_def_char('ANSI%BOLD',sic_ansi_bold,.true.,error)
  call sic_def_char('ANSI%UNDERLINE',sic_ansi_under,.true.,error)
  call sic_def_char('ANSI%REVERSE',sic_ansi_reverse,.true.,error)
  call sic_def_char('ANSI%BLINK',sic_ansi_blink,.true.,error)
  ! Clear is duplicated under %ZERO so that it comes last when
  ! typing EXA ANSI. This leaves the terminal in default mode.
  call sic_def_char('ANSI%ZERO',sic_ansi_clear,.true.,error)
  if (error)  return
  !
end subroutine sic_ansi_termcodes

subroutine write_sdm_squareLawDetector(holodata, error)
  !---------------------------------------------------------------------
  ! Write the AlmaCorrelatorMode SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_squareLawDetector
  use sdm_Enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error, holodata
  ! Local
  type (SquareLawDetectorKey) :: sldKey
  type (SquareLawDetectorRow) :: sldRow
  character sdmTable*20
  parameter (sdmTable='SquareLawDetector')
  integer ier, i
  !---------------------------------------------------------------------
  ier = 0
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! very much *TBD* at this stage. Think of better filling this in...
  sldRow%numBand = r_lband
  if (holodata) then
    sldRow%bandType = DetectorBandType_HOLOGRAPHY_RECEIVER
  else
    sldRow%bandType = DetectorBandType_SUBBAND
  endif
  if (error) return
  call addSquareLawDetectorRow(sldKey, sldRow, error)
  if (error) return
  !
  squareLawDetector_Id = sldKey%squareLawDetectorId
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_squareLawDetector
!---------------------------------------------------------------------
subroutine get_sdm_squareLawDetector(error)
  !---------------------------------------------------------------------
  ! Get the AlmaCorrelatorMode SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_squareLawDetector
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (SquareLawDetectorKey) :: sldKey
  type (SquareLawDetectorRow) :: sldRow
  !$$$      integer ier
  !$$$      integer, parameter :: maxBaseband = 8
  character  :: sdmTable*20
  parameter (sdmTable='SquareLawDetector')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! very much *TBD* at this stage. Think of better filling this in...
  !$$$      print *, 'CorrelatorMode_Id ', CorrelatorMode_Id
  !$$$      call  allocSquareLawDetectorRow(sldRow, maxBaseband, error
  !$$$     &     )
  !$$$      if (error) return
  sldKey%squareLawDetectorId  = correlatorMode_Id
  !$$$      print *, 'sldKey%modeId ',sldKey%modeId
  call getSquareLawDetectorRow(sldKey, sldRow, error)
  if (error) return
  if (sldRow%numband.gt.mrlband) then
    call sdmMessageI(8,3,sdmTable   &
      ,'Wrong numBaseband',sldRow%numband)
    goto 99
  endif
  r_lband = sldRow%numband
  !
  !
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_squareLawDetector
!$$$C---------------------------------------------------------------------
!$$$      subroutine allocAlmaCorrelatorModeRow(row, numBaseband, error)
!$$$C---------------------------------------------------------------------
!$$$c$$$    integer, allocatable :: basebandIndex(:)
!$$$c$$$    integer, allocatable :: basebandConfig(:)
!$$$c$$$    integer, allocatable :: axesOrderArray(:)
!$$$C---------------------------------------------------------------------
!$$$      use sdm_AlmaCorrelatorMode
!$$$      type(AlmaCorrelatorModeRow) :: row
!$$$      integer :: numBaseband, ier
!$$$      logical :: error
!$$$      character, parameter :: sdmTable*8 = 'calReduction'
!$$$c
!$$$c basebandIndex
!$$$      if (allocated(row%basebandIndex)) then
!$$$         deallocate(row%basebandIndex, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(row%basebandIndex(numBaseband), stat=ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$c basebandConfig
!$$$      if (allocated(row%basebandConfig)) then
!$$$         deallocate(row%basebandConfig, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(row%basebandConfig(numBaseband), stat=ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$c axesOrderArray (dimension???)
!$$$      if (allocated(row%axesOrderArray)) then
!$$$         deallocate(row%axesOrderArray, stat=ier)
!$$$         if (ier.ne.0) goto 98
!$$$      endif
!$$$      allocate(row%axesOrderArray(numBaseband), stat=ier)
!$$$      if (ier.ne.0) goto 99
!$$$c
!$$$      return
!$$$c
!$$$ 98   call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!$$$      error = .true.
!$$$      return
!$$$c
!$$$ 99   call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!$$$      error = .true.
!$$$      return
!$$$      end

!
subroutine convert_dh (iwin,nw,conve,nant,nbas,nband,npol)
  use gbl_convert
  use classic_api
  !---------------------------------------------------------------------
  !	Convert data header IWIN using conversion code CONVE,
  !	assuming NW is the length of the data header.
  ! Arguments
  !	IWIN	I(*)	Array containing data header to be converted
  !	NW	I	Size of IWIN
  !	CONVE	I	Conversion code
  !	NANT	I	Number of antennas
  !	NBAS	I	Number of baselines
  !---------------------------------------------------------------------
  integer :: iwin(*)                !
  integer(kind=data_length) :: nw                     !
  integer :: conve                  !
  integer :: nant                   !
  integer :: nbas                   !
  integer :: nband                  !
  integer :: npol                   !
  ! Global
  external :: r4tor4,r8tor8
  external :: ier4va,eir4va,eir4ie,ier4ei,var4ie,var4ei
  external :: ier8va,eir8va,eir8ie,ier8ei,var8ie,var8ei
  external ::        eii4va,eii4ie,iei4ei       ,vai4ei
  include 'clic_parameter.inc'
  !
  !------------------------------------------------------------------------
  ! Code:
  ! test the conversion works
  if (conve.eq.0) then
    return
  ! test it works ...
  !$$$         CALL CONVERT_DHSUB (IWIN,NW,NANT,NBAS,NBAND,NPOL,
  !$$$     &   R4TOR4,R8TOR8,R4TOR4,R4TOR4)
  elseif (conve.eq.vax_to_ieee .or. conve.eq.vax_fr_ieee) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      var4ie,var8ie,r4tor4,r4tor4)
  elseif (conve.eq.ieee_to_vax .or. conve.eq.ieee_fr_vax) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      ier4va,ier8va,r4tor4,r4tor4)
  elseif (conve.eq.vax_to_eeei .or. conve.eq.vax_fr_eeei) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      var4ei,var8ei,vai4ei,r4tor4)
  elseif (conve.eq.ieee_to_eeei .or. conve.eq.ieee_fr_eeei) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      ier4ei,ier8ei,iei4ei,r4tor4)
  elseif (conve.eq.eeei_to_vax .or. conve.eq.eeei_fr_vax) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      eir4va,eir8va,eii4va,r4tor4)
  elseif (conve.eq.eeei_to_ieee .or. conve.eq.eeei_fr_ieee) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      eir4ie,eir8ie,eii4ie,r4tor4)
  endif
end subroutine convert_dh
!
subroutine convert_dhsub(iwin,nw,nant,nbas,nband,npol,r4,r8,i4,cc)
  use classic_api
  use clic_file
  !---------------------------------------------------------------------
  !	Convert data header IWIN using conversion code CONVE,
  !	assuming NW is the length of the data header.
  ! Arguments
  !	IWIN	I(*)	Array containing data header to be converted
  !	NW	I	Size of IWIN
  !	CONVE	I	Conversion code
  !	NANT	I	Number of antennas
  !	NBAS	I	Number of baselines
  !---------------------------------------------------------------------
  integer :: iwin(*)                !
  integer(kind=data_length) :: nw                     !
  integer :: nant                   !
  integer :: nbas                   !
  integer :: nband                  !
  integer :: npol                   !
  external :: r4                    !
  external :: r8                    !
  external :: i4                    !
  external :: cc                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_dheader.inc'
  ! Local
  integer :: k, temp_dim, natfac
  real*8 ::  rtmp(8)
  !------------------------------------------------------------------------
  ! Code:
  !$$$      print *, 'CONVERT_DHSUB , NW,NANT,NBAS,NBAND,NPOL'
  !$$$      print *, NW,NANT,NBAS,NBAND,NPOL
  call i4 (iwin(1),iwin(1),2)  ! Dump + obs MJ date
  call r4 (iwin(3),iwin(3),1)  ! Integ
  !
  !      CALL R8 (IWIN(4),IWIN(4),8) ! UTC + Svec(3)
  call r4tor4(iwin(4),rtmp,16) ! Alignment problems
  call r8 (rtmp,rtmp,8)
  call r4tor4(rtmp,iwin(4),8)
  !
  if (de%version.le.2) then
    call r4 (iwin(12),iwin(12),10)   ! Test0
    k = 22
  else
    call r4 (iwin(12),iwin(12),10)   ! Test0
    k = 32
  endif
  call i4 (iwin(22),iwin(22),nant) ! A Flag
  k = k+nant
  if (new_receivers) then
    if (r_dobs.lt.(-6406)) then    ! changed the 13/02/2007
      temp_dim = npol
    else
      temp_dim = 2
    endif
    call r4 (iwin(k),iwin(k), temp_dim*nant)   ! Total
    k = k+npol*nant
  else
    call r4 (iwin(k),iwin(k),nant) ! Total
    k = k+nant
  endif
  if (new_receivers) then
    natfac = max(npol,nband)
    call r4 (iwin(k),iwin(k),2*natfac*nant)    ! atfac
    k = k+2*natfac*nant
  else
    call r4 (iwin(k),iwin(k),2*nant)   ! atfac
    k = k+2*nant
  endif
  call r4 (iwin(k),iwin(k),2*nant) ! rmspe 
  k = k+2*nant
  if (de%version.le.2) then
    call r4 (iwin(k),iwin(k),nant) !  delcon
    k = k+nant
  endif
  if (new_receivers) then
    call r4 (iwin(k),iwin(k),npol*nant)    ! dellin
    k = k+npol*nant
  else
    call r4 (iwin(k),iwin(k),nant) ! dellin
    k = k+nant
  endif
  call r4 (iwin(k),iwin(k),nant)   ! delayc
  k = k+nant
  if (new_receivers) then
    call r4 (iwin(k),iwin(k),npol*nant)    ! delay
    k = k+npol*nant
  else
    !ccc         CALL R4 (IWIN(K),IWIN(K),NPOL*NANT) ! delay
    call r4 (iwin(k),iwin(k),nant) ! delay
    k = k+nant
  endif
  call r4 (iwin(k),iwin(k),4*nant) ! phasec to cable
  k = k+4*nant
  if (de%version.le.2) then
    call i4 (iwin(k),iwin(k),nant)   ! Gamme
    k = k + nant
  endif
  if (de%version.le.2) then
    call r4 (iwin(k),iwin(k),5*nant) ! Test1
    k = k + 5*nant
  else
    call r4 (iwin(k),iwin(k),20*nant) ! Test1
    k = k + 20*nant
  endif
  if (new_receivers) then
    call r4 (iwin(k),iwin(k),4*npol*nbas)  ! RMS Amp & Pha
    k = k + 4*npol*nbas
  else
    call r4 (iwin(k),iwin(k),4*nbas)   ! RMS Amp & Pha
    k = k + 4*nbas
  endif
  call r4 (iwin(k),iwin(k),3*nant) ! Offsets (Foc,Lam,Bet)
  k = k + 3*nant
  call i4 (iwin(k),iwin(k),nbas)   ! B Flag
  k = k + nbas
  call r4 (iwin(k),iwin(k),2*nbas) ! UV 
  k = k + 2*nbas
  if (de%version.le.2) then
    call r4 (iwin(k),iwin(k),4*nbas) ! Infac
    k = k + 4*nbas
  endif
  if (k.lt.nw) then
    call r4 (iwin(k),iwin(k),mwvrch*nant)  ! DH_wvr
    k = k + mwvrch*nant
    call i4 (iwin(k),iwin(k),nant) ! DH_wvrstat
    k = k + nant
  endif
  if (k.lt.nw) then
    call r4 (iwin(k),iwin(k),npol*nant*nband)  ! DH_ACTP
    k = k + 2*nant*nband
    call r4 (iwin(k),iwin(k),2*nant)   ! DH_ANTP
    k = k + 2*nant
  endif
  if (r_nband_widex.ne.0) then
    call r4 (iwin(k),iwin(k),nant)     ! dh_sflag
    k = k + nant
    call r4 (iwin(k),iwin(k),nbas)     ! dh_sbflag
    k = k + nbas
  endif
  if (de%version.ge.3) then
    call r4 (iwin(k),iwin(k),nant)     ! dh_cable_alternate
    k = k + nant
    call r4 (iwin(k),iwin(k),1)        ! dh_ntime
    dh_ntime = iwin(k)
    k = k + 1
    if (dh_ntime.gt.0) then
      call r4 (iwin(k),iwin(k),dh_ntime)     ! dh_time
      k = k + dh_ntime
    endif
    call r4 (iwin(k),iwin(k),3*nant)     ! incli, incli_temp
    k = k + 3* nant
    call r4 (iwin(k),iwin(k),5*nant)     ! tilfoc,offfoc
    k = k + 5* nant
  endif
  ! trick to get the size (for data fillers).
  if (nw .gt. 999999) then
    nw = k-1
  !
  elseif (k.gt.nw+1) then      ! R_LDPAR is actually more (142) ...
    write(6,*) 'CONVERT_DHSUB: Wrong data record K,NANT,NBAS,NW'
    write(6,*) k,nant,nbas,nw
  endif
end subroutine convert_dhsub
!
subroutine convert_data (ndata,data,jconve)
  use gbl_convert
  integer :: ndata                  !
  integer :: data(*)                !
  integer :: jconve                 !
  ! Global
  !
  if (jconve.eq.0) then
    return
  elseif (jconve.eq.vax_to_ieee .or. jconve.eq.vax_fr_ieee) then
    call var4ie (data,data,ndata)
  elseif (jconve.eq.ieee_to_vax .or. jconve.eq.ieee_fr_vax) then
    call ier4va (data,data,ndata)
  elseif (jconve.eq.vax_to_eeei .or. jconve.eq.vax_fr_eeei) then
    call var4ei (data,data,ndata)
  elseif (jconve.eq.ieee_to_eeei .or. jconve.eq.ieee_fr_eeei) then
    call ier4ei (data,data,ndata)
  elseif (jconve.eq.eeei_to_vax .or. jconve.eq.eeei_fr_vax) then
    call eir4va (data,data,ndata)
  elseif (jconve.eq.eeei_to_ieee .or. jconve.eq.eeei_fr_ieee) then
    call eir4ie (data,data,ndata)
  else
    return
  endif
end subroutine convert_data

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_header
  use cubetools_parameters
  use cubetools_structure
  use cubeio_dataformat_types
  use cubetuple_format_class
  use cubeadm_cubeid_types
  use cubemain_messaging
  !
  public :: header
  private
  !
  type :: header_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(dataformat_opt_t)      :: format
     type(datadescr_opt_t)       :: descr
     type(option_t),     pointer :: history
   contains
     procedure, public  :: register => cubemain_header_register
     procedure, private :: parse    => cubemain_header_parse
     procedure, private :: main     => cubemain_header_main
  end type header_comm_t
  type(header_comm_t) :: header
  !
  type header_user_t
     type(cubeid_user_t)  :: cubeids
     integer(kind=code_k) :: format = code_dataformat_cube
     integer(kind=code_k) :: descr  = code_dataformat_none
     logical              :: dohistory = .false.
   contains
     procedure, private :: toprog => cubemain_header_user_toprog
  end type header_user_t
  !
  type header_prog_t
     class(format_t), pointer :: cube
     integer(kind=code_k) :: format
     integer(kind=code_k) :: descr
     logical              :: dohistory = .false.
   contains
     procedure, private :: list => cubemain_header_prog_list
  end type header_prog_t
  !
contains
  !
  subroutine cubemain_header_command(line,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(header_user_t) :: user
    character(len=*), parameter :: rname='HEADER>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call header%parse(line,user,error)
    if (error) return
    call header%main(user,error)
    if (error) return
  end subroutine cubemain_header_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_header_register(header,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(header_comm_t), intent(inout) :: header
    logical,              intent(inout) :: error
    !
    !
    type(cubeid_arg_t) :: cubearg
    character(len=*), parameter :: rname='HEADER>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'HEADER','[cubeid]',&
         'List the cube header',&
         'The header can be shown in different formats by using&
         & option /FORMAT',&
         cubemain_header_command,&
         header%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Input cube identifier',&
         'If omitted, use the last matching cube (any family/flags) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read_head,&
         code_access_any,&
         header%cube,&
         error)
    if (error) return
    call header%format%register(error)
    if (error) return
    call header%descr%register(error)
    if (error) return
    call cubetools_register_option(&
         'HISTORY','',&
         'Also display the cube ancestors in addition to the header',&
         strg_emp,&
         header%history,&
         error)
    if (error) return
  end subroutine cubemain_header_register
  !
  subroutine cubemain_header_parse(header,line,user,error)
    !-------------------------------------------------------------------
    ! Parsing facility for command
    !   HEADER [cube]
    !   /FORMAT format
    !   /DESCR format
    !   /HISTORY
    !-------------------------------------------------------------------
    class(header_comm_t), intent(in)    :: header
    character(len=*),     intent(in)    :: line
    type(header_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,header%comm,user%cubeids,error)
    if (error) return
    !
    call header%format%parse(line,user%format,error)
    if (error) return
    call header%descr%parse(line,user%descr,error)
    if (error) return
    call header%history%present(line,user%dohistory,error)
    if (error) return
  end subroutine cubemain_header_parse
  !
  subroutine cubemain_header_main(header,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(header_comm_t), intent(in)    :: header
    type(header_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(header_prog_t) :: prog
    character(len=*), parameter :: rname='HEADER>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%list(error)
    if (error) return
  end subroutine cubemain_header_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_header_user_toprog(user,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(header_user_t), intent(in)    :: user
    type(header_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    prog%format = user%format
    prog%descr = user%descr
    prog%dohistory = user%dohistory
    !
    if (prog%descr.eq.code_dataformat_none) then
      ! /DESCR was omitted => /FORMAT invoked or implicit => need a cube header
      call cubeadm_get_fheader(header%cube,user%cubeids,prog%cube,error)
      if (error) return
    endif
  end subroutine cubemain_header_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_header_prog_list(prog,error)
    use cubetools_header_vo
    use cubedag_history, only: cubedag_history_docube
    use cubedag_tuple
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(header_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>PROG>LIST'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (prog%descr.ne.code_dataformat_none) then
      ! /DESCR invoked
      select case (prog%descr)
      case (code_dataformat_vo)
        call cubetools_header_vodesc_list(error)
        if (error)  return
      case default
        call cubemain_message(seve%w,rname,'Description is not available for this format')
      end select
      return  ! Always
    endif
    !
    if (prog%format.ne.code_dataformat_vo) then
      call prog%cube%node%tuple%list(prog%cube%node%id,prog%cube%node%family,&
          prog%cube%node%flag,error)
      if (error) return
    endif
    call prog%cube%list(prog%format,error)
    if (error) return
    if (prog%dohistory) then
      call cubemain_message(seve%r,rname,blankstr)
      call cubedag_history_docube(prog%cube%get_id(),error)
      if (error) return
    endif
  end subroutine cubemain_header_prog_list
  !
end module cubemain_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program slice
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  ! GILDAS
  !     Arbitray slice in a 3-D data set, using bilinear interpolation
  ! F.Badia
  !---------------------------------------------------------------------
  ! Global
  integer, external :: pix_axis
  ! Local
  character(len=filename_length) :: mapdata,mapsort
  character(len=80) :: radec_start,radec_end
  integer :: axe,n,ier
  logical :: error
  real(4), allocatable :: lgu(:), mgu(:)
  integer :: istart(2), iend(2), ispace
  integer :: npoints
  real(8) :: dstart(2), dend(2), dl, dm, dx, dy,ang
  real(8) :: user1,user2
  character(len=24) :: ra_start, dec_start, ra_end, dec_end
  real(8) :: ustart(2), uend(2)
  type(gildas) :: x,y
  type(projection_t) :: proj
  !
  ! Code:
  call gildas_open
  call gildas_char('INPUT_MAP$',mapdata)
  call gildas_char('OUTPUT_MAP$',mapsort)
  call gildas_char('START$',radec_start)
  call gildas_char('END$',radec_end)
  call gildas_close
  !
  ! Input file
  n = len_trim(mapdata)
  if (n.le.0) goto 999
  call gildas_null(y)
  y%gil%ndim = 3
  call gdf_read_gildas(y,mapdata,'.lmv',error, data=.false.)
  if (error) then
    call gagout('F-SLICE,  Cannot read input data cube')
    goto 999
  endif
  !
  call gwcs_projec(y%gil%a0,y%gil%d0,y%gil%pang,y%gil%ptyp,proj,error)
  if (error)  goto 999
  n = len_trim(radec_start)
  ispace = index(radec_start, ' ')
  ra_start = radec_start(1:ispace)
  dec_start = radec_start(ispace+1:n)
  n = len_trim(radec_end)
  ispace = index(radec_end, ' ')
  ra_end = radec_end(1:ispace)
  dec_end = radec_end(ispace+1:n)
  call sic_decode(ra_start,ustart(1),24,error)
  if (error) then
    call gagout('F-SLICE,  Error in SIC_DECODE')
    goto 999
  endif
  call sic_decode(dec_start,ustart(2),360,error)
  if (error) then
    call gagout('F-SLICE,  Error in SIC_DECODE')
    goto 999
  endif
  call sic_decode(ra_end,uend(1),24,error)
  if (error) then
    call gagout('F-SLICE,  Error in SIC_DECODE')
    goto 999
  endif
  call sic_decode(dec_end,uend(2),360,error)
  if (error) then
    call gagout('F-SLICE,  Error in SIC_DECODE')
    goto 999
  endif
  call abs_to_rel(proj,ustart(1), ustart(2), user1, user2, 1)
  istart(1) = pix_axis(y,user1,1)
  istart(2) = pix_axis(y,user2,2)
  call abs_to_rel(proj,uend(1), uend(2), user1, user2, 1)
  iend(1) = pix_axis(y,user1,1)
  iend(2) = pix_axis(y,user2,2)
  !
  n = len_trim(mapsort)
  if (n.le.0) goto 999
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  !
  call sic_parsef(mapsort,x%file,' ','.lmv')
  dstart(1) = dble(istart(1))
  dstart(2) = dble(istart(2))
  dend(1) = dble(iend(1))
  dend(2) = dble(iend(2))
  !
  ! Define number of points
  if (dstart(1).eq.dend(1)) then
    axe = 2
    dx = 0.
    dy = 1.
    npoints = dabs(dend(2) - dstart(2)) + 1.
  elseif (dstart(2).eq.dend(2)) then
    axe = 1
    dx = 1.
    dy = 0.
    npoints = dabs(dend(1) - dstart(1)) + 1.
  else
    axe = 0
    dl = dabs(dend(1)-dstart(1)) + 1.
    dm = dabs(dend(2)-dstart(2)) + 1.
    npoints = sqrt(dl*dl + dm*dm)
    dx = dl/dble(npoints)
    dy = dm/dble(npoints)
    ang = atan2(dx*y%gil%inc(1),dy*y%gil%inc(2))
  endif
  !
  allocate (lgu(npoints), mgu(npoints), stat=ier)
  if (ier.ne.0) goto 999
  if (dend(1).lt.dstart(1)) then
    dx = -dx
  endif
  if (dend(2).lt.dstart(2)) then
    dy = -dy
  endif
  !
  !     Allocate arrays for slice coordinates
  call fill_gu(lgu, dstart(1), dx, npoints)
  call fill_gu(mgu, dstart(2), dy, npoints)
  !
  allocate(y%r3d(y%gil%dim(1),y%gil%dim(2),y%gil%dim(3)), stat=ier)
  call gdf_read_data(y,y%r3d,error)
  if (error) goto 999
  !
  x%gil%dim(1) = npoints
  x%gil%dim(2) = y%gil%dim(3)
  x%gil%dim(3) = 1
  x%gil%ndim = 2
  x%loca%size = x%gil%dim(1)*x%gil%dim(2)
  x%char%code(2) = y%char%code(3)
  x%gil%yaxi = 3
  x%gil%faxi = 2
  x%char%code(3) = 'UNKNOWN'
  !
  x%gil%convert(:,2) = y%gil%convert(:,3)
  x%gil%convert(1,1) = 1.D0
  x%gil%convert(2,1) = 0.D0
  if (axe.ne.0) then
    x%char%code(1) = y%char%code(axe)
    x%gil%inc(1) =  y%gil%inc(axe)
    x%gil%xaxi = y%gil%xaxi
  else
    x%char%code(1) = 'ANGLE'
    x%gil%xaxi = 1
    x%gil%pang = ang
    x%gil%inc(1) = sqrt((dx*y%gil%inc(1))**2 + (dy*y%gil%inc(2))**2)
  endif
  x%gil%ref(1) = 1.
  x%gil%val(1) = 0.
  x%gil%extr_words = 0
  !
  user1 = (lgu(1)-y%gil%ref(1))*y%gil%inc(1) + y%gil%val(1)
  user2 = (mgu(1)-y%gil%ref(2))*y%gil%inc(2) + y%gil%val(2)
  call rel_to_abs(proj,user1, user2, x%gil%a0, x%gil%d0, 1)
  x%gil%convert(:,3) = 1.0d0
  !
  call gdf_create_image(x,error)
  if (error) goto 999
  allocate(x%r2d(x%gil%dim(1),x%gil%dim(2)), stat=ier)
  !
  if (y%gil%eval.eq.-1) then
    call do_slice(y%r3d, y%gil%dim(1), y%gil%dim(2), y%gil%dim(3),   &
     &      lgu, mgu,   &
     &      x%r2d, npoints, x%gil%bval)
  else
    write (6,*) 'with blanks'
    call do_sliceb(y%r3d, y%gil%dim(1), y%gil%dim(2), y%gil%dim(3),   &
     &      lgu, mgu,   &
     &      x%r2d, npoints, x%gil%bval)
  endif
  !
  print *,'BLC ',x%blc
  print *,'TRC ',x%trc
  call gdf_write_data(x,x%r2d,error)
  call gagout('S-SLICE,  Successful completion')
  call sysexi(1)
999 call sysexi(fatale)
end program slice
!
subroutine do_slice(in, nx, ny, nc, x, y, out, np, blank)
  use gildas_def
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: ny                     !
  integer(kind=index_length) :: nc                     !
  real :: in(nx,ny,nc)              !
  integer :: np                     !
  real :: x(np)                     !
  real :: y(np)                     !
  real :: out(np,nc)                !
  real :: blank                     !
  ! Local
  real :: dx,dy
  integer :: ic,n,i,j
  !
  do ic=1,nc
    do n=1,np
      i = int(x(n))
      j = int(y(n))
      dx = x(n) - float(i)
      dy = y(n) - float(j)
      if((i.lt.1).or.(j.lt.1).or.(i.ge.nx).or.(j.ge.ny))then
        !              Interpolated point outside input image
        out(n, ic) = blank
      else
        out(n,ic) = dx * dy * in(i+1, j+1, ic)   &
     &          + (1.0 - dx) * dy * in(i, j+1, ic)   &
     &          + (1.0 - dx) * (1.0 - dy) * in(i, j, ic)   &
     &          + dx * (1.0 - dy) * in(i+1, j, ic)
      endif
    enddo
  enddo
end subroutine do_slice
!
subroutine do_sliceb(in, nx, ny, nc, x, y, out, np, blank)
  use gildas_def
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: ny                     !
  integer(kind=index_length) :: nc                     !
  real :: in(nx,ny,nc)              !
  integer :: np                     !
  real :: x(np)                     !
  real :: y(np)                     !
  real :: out(np,nc)                !
  real :: blank                     !
  ! Local
  real :: dx,dy,coeff(4)
  integer :: ic,n,i,j,k
  !
  do ic=1,nc
    do n=1,np
      i = int(x(n))
      j = int(y(n))
      dx = x(n) - float(i)
      dy = y(n) - float(j)
      if((i.lt.1).or.(j.lt.1).or.(i.ge.nx).or.(j.ge.ny))then
        !             Interpolated point outside input image'
        out(n, ic) = blank
        continue
      else
        do k = 1, 4
          coeff(k) = 1.0
        enddo
        if (in(i, j, ic).eq.blank) then
          if ((dx.le.0.5).and.(dy.le.0.5)) then
            out(n, ic) = blank
            continue
          else
            coeff(1) = 0.
          endif
        endif
        if (in(i+1, j, ic).eq.blank) then
          if ((dx.gt.0.5).and.(dy.le.0.5)) then
            out(n, ic) = blank
            continue
          else
            coeff(2) = 0.
          endif
        endif
        if (in(i, j+1, ic).eq.blank) then
          if ((dx.le.0.5).and.(dy.gt.0.5)) then
            out(n, ic) = blank
            continue
          else
            coeff(3) = 0.
          endif
        endif
        if (in(i+1, j+1, ic).eq.blank) then
          if ((dx.gt.0.5).and.(dy.gt.0.5)) then
            out(n, ic) = blank
            continue
          else
            coeff(4) = 0.
          endif
        endif
        out(n,ic) =   &
     &          (1.0 - dx) * (1.0 - dy) * coeff(1) * in(i, j, ic)   &
     &          + dx * (1.0 - dy) * coeff(2) * in(i+1, j, ic)   &
     &          + (1.0 - dx) * dy * coeff(3) * in(i, j+1, ic)   &
     &          + dx * dy * coeff(4) * in(i+1, j+1, ic)
      endif
    enddo
  enddo
end subroutine do_sliceb
!
subroutine fill_gu(ipgu, ds, dt, np)
  integer :: np                     !
  real :: ipgu(np)                  !
  real(8) :: ds                      !
  real(8) :: dt                      !
  ! Local
  integer :: n
  real(8) :: t
  !
  t = ds
  do n=1,np
    ipgu(n) = t
    t = t + dt
  enddo
end subroutine fill_gu
!
function pix_axis (head, user, iaxis)
  use image_def
  real(8), intent(in) :: user       ! User coordinates
  type(gildas), intent(in) :: head  ! Image header
  integer, intent(in) :: iaxis      ! Axis
  integer :: pix_axis ! intent(out) ! corresponding pixel 
  !
  ! Test error...
  if (iaxis.gt.gdf_maxdims) then
    pix_axis = 0
    return
  endif
  pix_axis = nint( (user - head%gil%val(iaxis)) /  &
        head%gil%inc(iaxis) + head%gil%ref(iaxis) )
end function pix_axis

subroutine solve_focus(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  ! CLIC
  !	Support routine for command
  !	SOLVE FOCUS [/PLOT] [/OUTPUT File [NEW]] [/COMPRESS time_max]
  !	[/Store /Reset /Offset /Search] Not relevant here
  !       [/PRINT]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_point.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: plot, output, end, flu
  real :: lo1, time_max, bsize, beam
  character(len=132) :: filnam,snam
  integer :: p_lun, q_lun, ier
  integer :: icount, naddr, nant, icount_previous
  integer(kind=address_length) :: data_in, ip_data, iaddr
  integer(kind=data_length)    :: ldata_in
  data p_lun, q_lun/0,0/
  data flu/.false./
  data bsize /0./
  !------------------------------------------------------------------------
  ! Code:
  iproc = 1
  !
  ! Get beam size
  beam = -1.0                  ! fix to frequency dep. value
  call sic_r4(line,0,2,beam,.false.,error)
  if (error) goto 999
  !
  ! /COMPRESS TIME_MAX option
  time_max = 5.0
  call sic_r4(line,6,1,time_max,.false.,error)
  if (error) goto 999
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  plot = sic_present(1,0)
  !
  ! /PRINT option
  if (sic_present(10,0)) then
    ier = sic_getlun(q_lun)
    filnam = 'focus'
    snam = filnam
    call sic_parsef(snam,filnam,'INTER_OBS:','.obs')
    ier = sic_open (q_lun,filnam(1:lenc(filnam)),'NEW',.false.)
    if (ier.ne.0) then
      call message(6,3,'SOLVE_FOCUS',   &
        'Cannot open INTER_OBS:focus.obs')
      call messios(6,3,'SOLVE_FOCUS',ier)
      goto 999
    endif
  else
    q_lun = 0
  endif
  !
  ! /OUTPUT option
  if (sic_present(3,0)) then
    call output_file('SOLVE_FOCUS',line,3,p_lun,'.lis',   &
      '!   Obs.#   Scan Code Azimuth   Elevation   Time  '//   &
      '     Position  ..        Width      ..     Intensity'//   &
      '     Sigma    Source', error)
    if (error) goto 999
    output = .true.
  else
    output = .false.
  endif
  if (plot) call gr_exec1('TICKSPACE 0 0 0 0')
  !
  ! Get  a first one
  call get_first(.true.,error)
  if (error) goto 999
  end = .false.
  call check_focus (error)
  do while (error .and. .not.end)
    call get_next(end,error)
    if (error) goto 999
    if (.not.end) call check_focus(error)
  enddo
  if (error) goto 999
  icount = 0
  call get_data (ldata_in,data_in,error)
  if (error) goto 999
  ip_data = gag_pointer(data_in,memory)
  call load_point (memory(ip_data),   &
    icount,iaddr,naddr,error,lo1,nant,time_max)
    
  if (error) goto 999
  call load_focw  (beam,bsize,lo1,nant)
  !
  ! Get next ones alike
  call get_next(end,error)
  if (error) goto 999
  do while (.not.end)
    call check_focus(error)
    if (error) then
      if (icount.gt.1) then
        call sub_point (plot,output,p_lun,iaddr,naddr,q_lun,   &
          error,bsize,flu,end)
        call free_vm(naddr,iaddr)
        icount = 0
        if (error) goto 998
      endif
    elseif (icount.eq.0) then
      call get_data (ldata_in,data_in,error)
      if (error) goto 999
      ip_data = gag_pointer(data_in,memory)
      call load_point (memory(ip_data),   &
        icount,iaddr,naddr,error,lo1,nant,time_max)
      if (error) goto 998
    else
      call get_data (ldata_in,data_in,error)
      if (error) goto 999
      ip_data = gag_pointer(data_in,memory)
      icount_previous = icount
      call load_point (memory(ip_data),   &
        icount,iaddr,naddr,error,lo1,nant,time_max)
      call load_focw  (beam,bsize,lo1,nant)
      if (icount.eq.0.and.icount_previous.gt.1) then
        call sub_point (plot,output,p_lun,iaddr,naddr,q_lun,   &
          error,bsize,flu,end)
        call free_vm(naddr,iaddr)
        if (error) goto 998
        call load_point (memory(ip_data),   &
          icount,iaddr,naddr,error,lo1,nant,time_max)
        if (error) goto 998
      endif
    endif
    call get_next(end,error)
    if (error) goto 999
    if (sic_ctrlc()) goto 999
  enddo
  !
  if (icount.gt.1) then
    call sub_point (plot,output,p_lun,iaddr,naddr,q_lun,   &
      error,bsize,flu,end)
    call free_vm(naddr,iaddr)
  endif
  !
  goto 998
  !
999 error = .true.
998 if (output) then
    close(unit=p_lun)
    call sic_frelun(p_lun)
  endif
  if (q_lun.ne.0) then
    close (unit=q_lun)
    call sic_frelun(q_lun)
  endif
end subroutine solve_focus
!
subroutine check_focus(error)
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !	Check if data is a pointing scan
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Code:
  if (.not. r_presec(scanning_sec) .or. r_scaty.ne.1) then
    call message(6,3,'CHECK_FOCUS',   &
      'Scan is not a focus measurement')
    error = .true.
    return
  endif
end subroutine check_focus
!
subroutine output_file(caller,line,iopt,lun,ext,header,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Open output file for logging
  !---------------------------------------------------------------------
  character(len=*) :: caller        !
  character(len=*) :: line          !
  integer :: iopt                   !
  integer :: lun                    !
  character(len=*) :: ext           !
  character(len=*) :: header        !
  logical :: error                  !
  ! Local
  character(len=6) :: ch
  character(len=80) :: snam,filnam
  integer :: ier, nch
  !
  integer :: mvoc1, nkey
  parameter (mvoc1=2)
  character(len=6) :: kw, voc1(2)
  data voc1/'NEW','OLD'/
  !------------------------------------------------------------------------
  ! Code:
  call sic_ch(line,iopt,1,snam,nch,.true.,error)
  if (error) return
  ch = 'OLD'
  call sic_ke(line,iopt,2,ch,nch,.false.,error)
  if (error) return
  call sic_ambigs('SOLVE FOCUS',ch,kw,nkey,voc1,mvoc1,error)
  if (error) return
  call sic_parsef(snam,filnam,' ',ext)
  ier = sic_getlun(lun)
  if (kw.eq.'NEW') then
    ier = sic_open (lun,filnam,'NEW',.false.)
    if (ier.eq.0) write(lun,'(a)') header
  elseif (kw.eq.'OLD') then
    ier = sic_open (lun,filnam,'APPEND',.false.)
  endif
  if (ier.ne.0) then
    call message(6,3,caller,'Cannot open file '//filnam)
    call messios(6,3,caller,ier)
    call sic_frelun(lun)
    error = .true.
    return
  endif
end subroutine output_file
!
!
subroutine load_focw (beam, bsize, lo1, nant)
  use gildas_def
  use classic_api  
  real :: beam                      !
  real :: bsize                     !
  real :: lo1                       !
  integer :: nant                   !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  ! Local
  real*4 :: freq
  !
  if (beam.lt.0.0) then
    if (n_band.eq.0 .or. i_band(1).eq.3) then
      freq = lo1               ! Sideband average
    elseif (i_band(1).eq.1) then
      freq = lo1+r_fif1      ! Upper sideband
    else
      freq = lo1-r_fif1      ! Lower sideband
    endif
    !         BSIZE = 2.8*115.0E3/FREQ       ! In mm
    bsize = 3.0*115.0e3/freq   ! In mm
    if (nant.lt.3) bsize = bsize*sqrt(2.0)
  elseif (beam.eq.0.0) then
    bsize = 0.0
  else
    bsize = beam
    if (nant.lt.3) bsize = bsize*sqrt(2.0)
  endif
end subroutine load_focw

module gchar_interfaces
  !---------------------------------------------------------------------
  ! GCHAR interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use gchar_interfaces_public
  use gchar_interfaces_private
  !
end module gchar_interfaces
!
module gchar_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GCHAR dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  use gio_interfaces_public
end module gchar_dependencies_interfaces

module imbfits_interfaces_public
  interface
    subroutine imbfits_dump_summary(imbf,olun,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Support routine for command:
      !   DUMP SUMMARY
      !---------------------------------------------------------------------
      type(imbfits_t), intent(in)    :: imbf
      integer(kind=4), intent(in)    :: olun   ! Output LUN
      logical,         intent(inout) :: error
    end subroutine imbfits_dump_summary
  end interface
  !
  interface
    subroutine imbfits_dump_subscans(imbf,olun,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Support routine for command:
      !   DUMP SUBSCANS
      ! The subroutine reopens the input file in its own structure to avoid
      ! messing up the global instances
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout) :: imbf
      integer(kind=4), intent(in)    :: olun   ! Output LUN
      logical,         intent(inout) :: error
    end subroutine imbfits_dump_subscans
  end interface
  !
  interface
    subroutine imbfits_dump_primary(primary,short,olun,error)
      use gbl_message
      use gildas_def
      use imbfits_types
      use imbfits_key_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_primary_t), intent(in)    :: primary
      logical,                 intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),         intent(in)    :: olun     ! Output LUN
      logical,                 intent(inout) :: error
    end subroutine imbfits_dump_primary
  end interface
  !
  interface
    subroutine imbfits_dump_scan(scan,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_scan_t), intent(in)    :: scan
      character(len=*),     intent(in)    :: column  ! Optional column name
      logical,              intent(in)    :: short   ! Short or verbose output?
      integer(kind=4),      intent(in)    :: olun    ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_scan
  end interface
  !
  interface
    subroutine imbfits_dump_frontend(front,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_front_t), intent(in)    :: front
      character(len=*),      intent(in)    :: column  ! Optional column name
      logical,               intent(in)    :: short   ! Short or verbose output?
      integer(kind=4),       intent(in)    :: olun    ! Output LUN
      logical,               intent(inout) :: error
    end subroutine imbfits_dump_frontend
  end interface
  !
  interface
    subroutine imbfits_dump_backend(back,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_back_t), intent(in)    :: back
      character(len=*),     intent(in)    :: column  ! Optional column name
      logical,              intent(in)    :: short   ! Short or verbose output?
      integer(kind=4),      intent(in)    :: olun    ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_backend
  end interface
  !
  interface
    subroutine imbfits_dump_antslow(isub,antslow,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4),         intent(in)    :: isub     ! Subscan number
      type(imbfits_antslow_t), intent(in)    :: antslow
      character(len=*),        intent(in)    :: column   ! Optional column name
      logical,                 intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),         intent(in)    :: olun     ! Output LUN
      logical,                 intent(inout) :: error
    end subroutine imbfits_dump_antslow
  end interface
  !
  interface
    subroutine imbfits_dump_antfast(isub,antfast,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4),         intent(in)    :: isub     ! Subscan number
      type(imbfits_antfast_t), intent(in)    :: antfast
      character(len=*),        intent(in)    :: column   ! Optional column name
      logical,                 intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),         intent(in)    :: olun     ! Output LUN
      logical,                 intent(inout) :: error
    end subroutine imbfits_dump_antfast
  end interface
  !
  interface
    subroutine imbfits_dump_derot(derot,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_derot_t), intent(in)    :: derot
      character(len=*),      intent(in)    :: column   ! Optional column name
      logical,               intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),       intent(in)    :: olun     ! Output LUN
      logical,               intent(inout) :: error
    end subroutine imbfits_dump_derot
  end interface
  !
  interface
    subroutine imbfits_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine imbfits_message_set_id
  end interface
  !
  interface
    subroutine imbfits_message_debug(doalloc,alloc,doother,other,error)
      use imbfits_messaging
      !---------------------------------------------------------------------
      ! @ public
      !  Alter the imbfits specific severities. You can switch them to
      ! seve%d and seve%i only!
      !---------------------------------------------------------------------
      logical,         intent(in)    :: doalloc  !
      integer(kind=4), intent(in)    :: alloc    ! For iseve%alloc
      logical,         intent(in)    :: doother  !
      integer(kind=4), intent(in)    :: other    ! For iseve%other
      logical,         intent(inout) :: error    ! Logical error flag
    end subroutine imbfits_message_debug
  end interface
  !
  interface
    subroutine imbfits_read_header(filename,imbf,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Open the file, read the leading HDUs, and build the list
      ! (equivalence classes) of subscans.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: filename
      type(imbfits_t),  intent(inout) :: imbf
      logical,          intent(inout) :: error
    end subroutine imbfits_read_header
  end interface
  !
  interface
    subroutine imbfits_open_file(filename,file,hdus,error)
      use gbl_message
      use gildas_def
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: filename
      type(imbfits_file_t), intent(out)   :: file
      type(imbfits_hdus_t), intent(out)   :: hdus
      logical,              intent(inout) :: error
    end subroutine imbfits_open_file
  end interface
  !
  interface
    subroutine imbfits_read_leadhdus(imbf,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read the 4 first leading HDUs
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout) :: imbf
      logical,         intent(inout) :: error
    end subroutine imbfits_read_leadhdus
  end interface
  !
  interface
    subroutine imbfits_close_file(file,error)
      use gbl_message
      use gildas_def
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_file_t), intent(inout) :: file
      logical,              intent(inout) :: error
    end subroutine imbfits_close_file
  end interface
  !
  interface
    subroutine imbfits_free_leadhdus(imbf,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Free the leading HDUs. Can be called in an error recovery context
      ! i.e. with error .true. as input.
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout) :: imbf      !
      logical,         intent(inout) :: error     !
    end subroutine imbfits_free_leadhdus
  end interface
  !
  interface
    subroutine imbfits_read_header_antslow(imbf,isub,mjd_shift,antslow,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      use imbfits_parameters
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read the IMBF-antenna HDU
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: imbf       !
      integer(kind=4),         intent(in)    :: isub       ! Subscan number
      real(kind=8),            intent(in)    :: mjd_shift  ! [sec]
      type(imbfits_antslow_t), intent(inout) :: antslow    !
      logical,                 intent(inout) :: error      !
    end subroutine imbfits_read_header_antslow
  end interface
  !
  interface
    subroutine imbfits_read_header_derot(imbf,derot,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read the IMBF-derot HDU
      !---------------------------------------------------------------------
      type(imbfits_t),       intent(in)    :: imbf   !
      type(imbfits_derot_t), intent(inout) :: derot  !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_derot
  end interface
  !
  interface
    subroutine imbfits_read_header_derot_onehdu(imbf,derot,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      use imbfits_parameters
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read the IMBF-derot HDU
      !---------------------------------------------------------------------
      type(imbfits_t),       intent(in)    :: imbf   !
      type(imbfits_derot_t), intent(inout) :: derot  !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_derot_onehdu
  end interface
  !
  interface
    subroutine imbfits_read_header_derot_allinone(imbf,allderot,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      use imbfits_parameters
      !---------------------------------------------------------------------
      ! @ public
      !   Read all the IMBF-derot HDUs (for all subscans) concatenated as a
      ! single pseudo HDU. This subroutine makes sense only for pre-v2
      ! IMB-FITS.
      !   Note that this code assumes:
      !  1) that the subscans are ordered by time, and
      !  2) that the derotator tables are ordered by time.
      ! Possible overlap of the individual tables is correctly accounted
      ! for (duplicates are discarded).
      !---------------------------------------------------------------------
      type(imbfits_t),       intent(in)    :: imbf      !
      type(imbfits_derot_t), intent(inout) :: allderot  !
      logical,               intent(inout) :: error     !
    end subroutine imbfits_read_header_derot_allinone
  end interface
  !
  interface
    function imbfits_subscan_exists(imbf,sname,iclass)
      use imbfits_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Return .true. if the subscan class 'sname' exists. Optionally
      ! return the equivalence class number.
      !---------------------------------------------------------------------
      logical :: imbfits_subscan_exists
      type(imbfits_t),            intent(in)  :: imbf    !
      character(len=*),           intent(in)  :: sname   ! Subscan eclass name
      integer(kind=4),  optional, intent(out) :: iclass  ! Subscan eclass number
    end function imbfits_subscan_exists
  end interface
  !
  interface
    subroutine imbfits_read_subscan_header(imbf,sname,snum,goodonly,mjdinter,  &
      mjd_shift,subs,error)
      use imbfits_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Given a subscan name and relative number, move to the HDU and read
      ! the subscan headers from file.
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: imbf
      character(len=*),        intent(in)    :: sname      ! Subscan name
      integer(kind=4),         intent(in)    :: snum       ! Subscan number
      logical,                 intent(in)    :: goodonly   ! Ignore bad data?
      logical,                 intent(in)    :: mjdinter   ! Compute MJD intersection?
      real(kind=8),            intent(in)    :: mjd_shift  ! [sec]
      type(imbfits_subscan_t), intent(inout) :: subs
      logical,                 intent(inout) :: error
    end subroutine imbfits_read_subscan_header
  end interface
  !
  interface
    subroutine imbfits_read_subscan_header_bynum(imbf,isub,goodonly,mjdinter,  &
      mjd_shift,subs,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Given a subscan absolute number, move the HDU and read the subscan
      ! headers from file. On return let the CFITSIO pointer to the
      ! IMBF-backdataXXX HDU, such as its DATA column can be read right
      ! after.
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: imbf
      integer(kind=4),         intent(in)    :: isub
      logical,                 intent(in)    :: goodonly   ! Ignore bad data?
      logical,                 intent(in)    :: mjdinter   ! Compute MJD intersection?
      real(kind=8),            intent(in)    :: mjd_shift  ! [sec] Antslow MJD shift
      type(imbfits_subscan_t), intent(inout) :: subs
      logical,                 intent(inout) :: error
    end subroutine imbfits_read_subscan_header_bynum
  end interface
  !
  interface
    subroutine imbfits_free_header_antslow(antslow,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Free the IMBF-antenna HDU
      !---------------------------------------------------------------------
      type(imbfits_antslow_t), intent(inout) :: antslow  !
      logical,                 intent(inout) :: error    !
    end subroutine imbfits_free_header_antslow
  end interface
  !
  interface
    subroutine imbfits_free_subscan_header(subs,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Free subscan data (except DATA column)
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(inout) :: subs
      logical,                 intent(inout) :: error
    end subroutine imbfits_free_subscan_header
  end interface
  !
  interface
    subroutine imbfits_read_data(caller,file,nchan,npix,ftime,ntime,  &
      imbdata,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Reading subroutine specific to the 'DATA' column
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: caller   ! Name of calling subroutine
      type(imbfits_file_t), intent(in)    :: file     !
      integer(kind=4),      intent(in)    :: nchan    !
      integer(kind=4),      intent(in)    :: npix     !
      integer(kind=4),      intent(in)    :: ftime    ! First 'time' row read
      integer(kind=4),      intent(in)    :: ntime    ! Number of 'time' rows read
      type(imbfits_data_t), intent(inout) :: imbdata  !
      logical,              intent(inout) :: error    !
    end subroutine imbfits_read_data
  end interface
  !
  interface
    subroutine imbfits_free_data(imbdata,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Freeing subroutine specific to the 'DATA' column
      !---------------------------------------------------------------------
      type(imbfits_data_t), intent(inout) :: imbdata  !
      logical,              intent(inout) :: error    !
    end subroutine imbfits_free_data
  end interface
  !
  interface
    subroutine imbfits_dump_imbfdata(imbf,olun,error)
      use gbl_message
      use imbfits_types
      use ram_sizes
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_data_t), intent(in)    :: imbf
      integer(kind=4),      intent(in)    :: olun   ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_imbfdata
  end interface
  !
  interface
    subroutine imbfits_mvhdu_subscan(isub,hduid,imbf,error)
      use imbfits_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Move to appropriate HDU for the isub-th subscan
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: isub   ! Subscan number
      integer(kind=4), intent(in)    :: hduid  ! HDU identifier
      type(imbfits_t), intent(in)    :: imbf   !
      logical,         intent(inout) :: error  !
    end subroutine imbfits_mvhdu_subscan
  end interface
  !
  interface
    subroutine imbfits_copy_back_chunks(ichunks,ochunks,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(in)    :: ichunks
      type(imbfits_back_chunks_t), intent(inout) :: ochunks
      logical,                     intent(inout) :: error
    end subroutine imbfits_copy_back_chunks
  end interface
  !
  interface
    subroutine imbfits_free_back_chunks(chunks,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(inout) :: chunks
      logical,                     intent(inout) :: error
    end subroutine imbfits_free_back_chunks
  end interface
  !
  interface
    subroutine imbfits_init_stokesloop(book,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Initialize the stokesset_book_t for later use by
      ! imbfits_get_next_stokesset
      !---------------------------------------------------------------------
      type(stokesset_book_t), intent(inout) :: book
      logical,                intent(inout) :: error
    end subroutine imbfits_init_stokesloop
  end interface
  !
  interface
    subroutine imbfits_get_next_stokesset(cdesc,book,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Get the next stokeset. As of today a stokeset can be:
      !  - A unique NONE chunkset (no polarimetry)
      !  - A collection AXISH+AXISV+REAL+IMAG (polarimetric chunksets)
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(in)    :: cdesc  ! Chunks description
      type(stokesset_book_t),      intent(inout) :: book   !
      logical,                     intent(inout) :: error  !
    end subroutine imbfits_get_next_stokesset
  end interface
  !
  interface
    subroutine imbfits_count_polar_stokesset(cdesc,nset,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Count the number POLARIMETRIC stokesets that would be found when
      ! iterating with imbfits_get_next_stokesset
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(in)    :: cdesc  ! Chunks description
      integer(kind=4),             intent(out)   :: nset   ! Number of stokesset
      logical,                     intent(inout) :: error  ! Logical error flag
    end subroutine imbfits_count_polar_stokesset
  end interface
  !
  interface
    subroutine imbfits_upcase_column(char,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(fits_char_1d_t), intent(inout) :: char
      logical,              intent(inout) :: error
    end subroutine imbfits_upcase_column
  end interface
  !
  interface imbfits_free_column
    subroutine imbfits_free_logi_1d(logi,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_logi_1d_t), intent(inout) :: logi    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_logi_1d
    subroutine imbfits_free_inte_1d(inte,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_inte_1d_t), intent(inout) :: inte    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_inte_1d
    subroutine imbfits_free_real_1d(real,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_real_1d_t), intent(inout) :: real    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_real_1d
    subroutine imbfits_free_dble_1d(dble,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_dble_1d
    subroutine imbfits_free_char_1d(char,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_char_1d_t), intent(inout) :: char    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_char_1d
  end interface imbfits_free_column
  !
  interface
    subroutine imbfits_variable_imbfits(struct,imbf,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Create or recreate Sic variables mapping a imbfits_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: struct  ! Parent structure name
      type(imbfits_t),  intent(in)    :: imbf    !
      logical,          intent(in)    :: ro      ! Read-Only
      logical,          intent(inout) :: error   !
    end subroutine imbfits_variable_imbfits
  end interface
  !
  interface
    subroutine imbfits_variable_subscan(struct,subs,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Create or recreate Sic variables mapping a imbfits_subscan_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: struct  ! Parent structure name
      type(imbfits_subscan_t), intent(in)    :: subs    !
      logical,                 intent(in)    :: ro      ! Read-Only
      logical,                 intent(inout) :: error   !
    end subroutine imbfits_variable_subscan
  end interface
  !
  interface
    subroutine imbfits_variable_imbfdata(struct,imbf,ro,error)
      use gildas_def
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Create or recreate Sic variables mapping a imbfits_data_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: struct  ! Parent structure name
      type(imbfits_data_t), intent(in)    :: imbf    !
      logical,              intent(in)    :: ro      ! Read-Only
      logical,              intent(inout) :: error   !
    end subroutine imbfits_variable_imbfdata
  end interface
  !
end module imbfits_interfaces_public

module gwcs_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GWCS interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use gwcs_interfaces_public
  use gwcs_interfaces_private
  !
end module gwcs_interfaces
!
module gwcs_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GWCS dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  !
end module gwcs_dependencies_interfaces

subroutine mira_variable(line,error)
!
! Called by MIRA command VARIABLE (see online help and users' manual
! for options). Calling subroutine mira_to_sic.
!
! Input:  line      character      command line from interactive MIRA session
! Output: error    logical        error flag
!
   use mira
   !
   implicit none
   !
   integer               :: ifb, lc
   character(len = *)    :: line
   character(len = 80)   :: section
   character(len = 5)    :: access
   logical error, readonly, sic_present
   !
   call sic_ch(line,0,1,section,lc,.false.,error)
   !
   if (.not.sic_present(0,1)) then
      call gagout('E-VARIABLE, need a section name or *.')
      error = .true.
      return
   endif
   !
   if (sic_present(0,2)) then
      call sic_ch(line,0,2,access,lc,.false.,error)
      if (index(access,'W').ne.0.or.index(access,'w').ne.0) then
         readonly = .false.
      else
         readonly = .true.
      endif
   else
      readonly = .true.
   endif
   !
   if (trim(section).eq.'*') then
      call prim_to_sic(readonly,error)
      if (error) return
      call scan_to_sic(readonly,error)
      if (error) return
      call febe_to_sic(readonly,error)
      if (error) return
      call array_to_sic(readonly,error)
      if (error) return
      call data_to_sic(readonly,error)
      if (error) return
      call mon_to_sic(readonly,error)
      if (error) return
      call gains_to_sic(readonly,error)
      if (error) return
      call choice_to_sic(readonly,error)
      if (error) return
      call reduce_to_sic(readonly,error)
      if (error) return
      call raw_to_sic(readonly,error)
      if (error) return
      call cryo_to_sic(readonly,error)
      if (error) return
      call derot_to_sic(readonly,error)
      if (error) return
      call list_to_sic(readonly,error)
      if (error) return
   else if (index(section,'PR').ne.0.or.   &
            index(section,'pr').ne.0.or.   &
            index(section,'Pr').ne.0) then
      call prim_to_sic(readonly,error)
      if (error) return
   else if (index(section,'SC').ne.0.or.   &
            index(section,'sc').ne.0.or.   &
            index(section,'Sc').ne.0) then
      call scan_to_sic(readonly,error)
      if (error) return
   else if (index(section,'FE').ne.0.or.   &
            index(section,'fe').ne.0.or.   &
            index(section,'Fe').ne.0) then
      call febe_to_sic(readonly,error)
      if (error) return
   else if (index(section,'AR').ne.0.or.   &
            index(section,'ar').ne.0.or.   &
            index(section,'Ar').ne.0) then
      call array_to_sic(readonly,error)
      if (error) return
   else if (index(section,'DA').ne.0.or.   &
            index(section,'da').ne.0.or.   &
            index(section,'Da').ne.0) then
      call data_to_sic(readonly,error)
      if (error) return
   else if (index(section,'MO').ne.0.or.   &
            index(section,'mo').ne.0.or.   &
            index(section,'Mo').ne.0) then
      call mon_to_sic(readonly,error)
      if (error) return
   else if (index(section,'GA').ne.0.or.   &
            index(section,'ga').ne.0.or.   &
            index(section,'Ga').ne.0) then
      call gains_to_sic(readonly,error)
      if (error) return
   else if (index(section,'CH').ne.0.or.   &
            index(section,'ch').ne.0.or.   &
            index(section,'Ch').ne.0) then
      call choice_to_sic(readonly,error)
      if (error) return
   else if (index(section,'RE').ne.0.or.   &
            index(section,'re').ne.0.or.   &
            index(section,'Re').ne.0) then
      call reduce_to_sic(readonly,error)
      if (error) return
   else if (index(section,'RA').ne.0.or.   &
            index(section,'ra').ne.0.or.   &
            index(section,'Ra').ne.0) then
      call raw_to_sic(readonly,error)
      if (error) return
   else if (index(section,'CR').ne.0.or.   &
            index(section,'cr').ne.0.or.   &
            index(section,'Cr').ne.0) then
      call cryo_to_sic(readonly,error)
      if (error) return
   else if (index(section,'DE').ne.0.or.   &
            index(section,'de').ne.0.or.   &
            index(section,'De').ne.0) then
      call derot_to_sic(readonly,error)
      if (error) return
   else if (index(section,'LI').ne.0.or.   &
            index(section,'li').ne.0.or.   &
            index(section,'Li').ne.0) then
      call list_to_sic(readonly,error)
      if (error) return
   else
      call gagout('E-VARIABLE, no such section.')
      error = .true.
   endif
   !
   return
end subroutine mira_variable
!
subroutine mira_to_sic
!
! Contains the following entries:
! prim_to_sic, scan_to_sic, febe_to_sic, data_to_sic, array_to_sic,
! mon_to_sic, gains_to_sic, choice_to_sic, reduce_to_sic, raw_to_sic,
! cryo_to_sic, derot_to_sic, list_to_sic.
!
! Called by the following subroutines:
!
! subroutine            comments
! calibrate             if SIC structure GAINS or REDUCE already declared
! despike               if SIC structure REDUCE already declared
! findmira              if SIC structures CHOICE and LIST already declared
! getmira               for update of already declared SIC structures
!
! Note: the subroutine pointing_to_sic (source code in mira/lib/solve.f90) for declaring
! and attributing the SIC structure PNT for coadded pointing subscans is called
! by solve_pointing_mira.
!
   use mira
   use gildas_def
   use gkernel_types
   use gkernel_interfaces
   !
   implicit none
   !
   integer                                    :: ifb
   integer, save                              :: found
   integer                                    :: i,ier,j,k,l,nbd,   &
                                                 nfast,nfb,   &
                                                 noffsets, npix,   &
                                                 nphases,nrecord,   &
                                                 nslow, nsubref
   type(sic_descriptor_t)                     :: desc
   integer, dimension(18)                     :: idpol
   integer, dimension(100)                    :: idbe, idfe
   integer(kind=index_length), dimension(4)   :: dim=0, dim1=0,  &
                                                 dim2=0, dim3=0
   character                                  :: name1*20,name2*20
   character(len =32)                         :: tmpbackend
   character(len=32), dimension(:), allocatable :: tmpfebe
   character(len=20), parameter :: nullstring='                    '
   logical error, exist, readonly
   !
   entry prim_to_sic(readonly,error)
   !
   if (.not.associated(prim)) then
      call gagout('E-VAR: no PRIMARY section in MIRA.')
      error = .true.
      return
   endif
   !
   call sic_descriptor('PRIM',desc,exist)
   if (exist) call sic_delvariable('PRIM',.false.,error)
   !
   call sic_defstructure('PRIM',.true.,error)
   call sic_defstructure('PRIM%HEADER',.true.,error)
   call sic_defstructure('PRIM%DATA',.true.,error)
   !
   call sic_def_inte('PRIM%HEADER%NAXIS',prim%header%naxis,0,0,   &
                     readonly,error)
   call sic_def_logi('PRIM%HEADER%SIMPLE',prim%header%simple,   &
                     readonly,error)
   call sic_def_inte('PRIM%HEADER%BITPIX',prim%header%bitpix,0,0,   &
                     readonly,error)
   call sic_def_logi('PRIM%HEADER%EXTEND',prim%header%extend,   &
                     readonly,error)
   call sic_def_char('PRIM%HEADER%TELESCOP',prim%header%telescop,   &
                     readonly,error)
   call sic_def_char('PRIM%HEADER%ORIGIN',prim%header%origin,   &
                     readonly,error)
   call sic_def_char('PRIM%HEADER%CREATOR',prim%header%creator,   &
                     readonly,error)
   call sic_def_char('PRIM%HEADER%MBFTSVER',prim%header%mbftsver,   &
                     readonly,error)
   !
   return
   !
   entry scan_to_sic(readonly,error)
   !
   if (.not.associated(scan)) then
      call gagout('E-VAR: no SCAN section in MIRA.')
      error = .true.
      return
   endif
   !
   call sic_descriptor('blankingRaw',desc,exist)
   if (.not.exist)   &
     call sic_def_real('blankingRaw',blankingraw,0,0,readonly,error)
   call sic_descriptor('blankingRed',desc,exist)
   if (.not.exist)   &
     call sic_def_real('blankingRed',blankingred,0,0,readonly,error)
   !
   call sic_descriptor('SCAN',desc,exist)
   if (exist) call sic_delvariable('SCAN',.false.,error)
   !
   call sic_defstructure('SCAN',.true.,error)
   call sic_defstructure('SCAN%HEADER',.true.,error)
   call sic_defstructure('SCAN%DATA',.true.,error)
   !
   call sic_def_char('SCAN%HEADER%TELESCOP',scan%header%telescop,   &
                     readonly,error)
   call sic_def_dble('SCAN%HEADER%SITELONG',scan%header%sitelong,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SITELAT',scan%header%sitelat,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%SITEELEV',scan%header%siteelev,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%PROJID',scan%header%projid,   &
                     readonly,error)
   call sic_def_char('SCAN%HEADER%OBSID',scan%header%obsid,   &
                     readonly,error)
   call sic_def_inte('SCAN%HEADER%SCANNUM',scan%header%scannum,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%DATE_OBS',scan%header%date_obs,   &
                     readonly,error)
   call sic_def_dble('SCAN%HEADER%MJD',scan%header%mjd,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%LST',scan%header%lst,   &
                     0,0,readonly,error)
   call sic_def_inte('SCAN%HEADER%NOBS',scan%header%nobs,   &
                     0,0,readonly,error)
   call sic_def_inte('SCAN%HEADER%NOBSTOTAL',scan%header%nobstotal,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%UT1UTC',scan%header%ut1utc,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%TAIUTC',scan%header%taiutc,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%ETUTC',scan%header%etutc,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%GPSTAI',scan%header%gpstai,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%CTYPE1',scan%header%ctype1,   &
                     readonly,error)
   call sic_def_char('SCAN%HEADER%CTYPE2',scan%header%ctype2,   &
                     readonly,error)
   call sic_def_char('SCAN%HEADER%RADECSYS',scan%header%radecsys,   &
                     readonly,error)
   call sic_def_real('SCAN%HEADER%EQUINOX',scan%header%equinox,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%CRVAL1',scan%header%crval1,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%CRVAL2',scan%header%crval2,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%LONPOLE',scan%header%lonpole,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%LATPOLE',scan%header%latpole,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%OBJECT',scan%header%object,   &
                     readonly,error)
   call sic_def_dble('SCAN%HEADER%LONGOBJ',scan%header%longobj,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%LATOBJ',scan%header%latobj,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%LONGOFF',scan%header%longoff,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%LATOFF',scan%header%latoff,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%CALCODE',scan%header%calcode,   &
                     readonly,error)
   call sic_def_logi('SCAN%HEADER%MOVEFRAM',scan%header%movefram,   &
                     readonly,error)
   call sic_def_dble('SCAN%HEADER%PERIDATE',scan%header%peridate,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%PERIDIST',scan%header%peridist,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%LONGASC',scan%header%longasc,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%OMEGA',scan%header%omega,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%INCLINAT',scan%header%inclinat,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%ECCENTR',scan%header%eccentr,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%ORBEPOCH',scan%header%orbepoch,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%ORBEQUNX',scan%header%orbeqnox,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%DISTANCE',scan%header%distance,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%SCANTYPE',scan%header%scantype,   &
                     readonly,error)
   call sic_def_char('SCAN%HEADER%SCANMODE',scan%header%scanmode,   &
                     readonly,error)
   call sic_def_char('SCAN%HEADER%SCANGEOM',scan%header%scangeom,   &
                     readonly,error)
   call sic_def_char('SCAN%HEADER%SCANDIR',scan%header%scandir,   &
                     readonly,error)
   call sic_def_inte('SCAN%HEADER%SCANLINE',scan%header%scanline,   &
                     0,0,readonly,error)
   call sic_def_inte('SCAN%HEADER%SCANRPTS',scan%header%scanrpts,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SCANLEN',scan%header%scanlen,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SCANXVEL',scan%header%scanxvel,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SCANTIME',scan%header%scantime,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SCANXSPC',scan%header%scanxspc,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SCANYSPC',scan%header%scanyspc,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SCANSKEW',scan%header%scanskew,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SCANPAR1',scan%header%scanpar1,   &
                     0,0,readonly,error)
   call sic_def_dble('SCAN%HEADER%SCANPAR2',scan%header%scanpar2,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%CROCYCLE',scan%header%crocycle,   &
                     readonly,error)
   call sic_def_logi('SCAN%HEADER%ZIGZAG',scan%header%zigzag,   &
                     readonly,error)
   call sic_def_inte('SCAN%HEADER%TRANDIST',scan%header%trandist,   &
                     0,0,readonly,error)
   call sic_def_inte('SCAN%HEADER%TRANFREQ',scan%header%tranfreq,   &
                     0,0,readonly,error)
   call sic_def_inte('SCAN%HEADER%TRANFOCU',scan%header%tranfocu,   &
                     0,0,readonly,error)
   call sic_def_logi('SCAN%HEADER%WOBUSED',scan%header%wobused,   &
                     readonly,error)
   call sic_def_dble('SCAN%HEADER%WOBTHROW',scan%header%wobthrow,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%WOBDIR',scan%header%wobdir,   &
                     readonly,error)
   call sic_def_real('SCAN%HEADER%WOBCYCLE',scan%header%wobcycle,   &
                     0,0,readonly,error)
   call sic_def_char('SCAN%HEADER%WOBMODE',scan%header%wobmode,   &
                     readonly,error)
   call sic_def_inte('SCAN%HEADER%NFEBE',scan%header%nfebe,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%IA',scan%header%ia,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%CA',scan%header%ca,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%NPAE',scan%header%npae,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%AN',scan%header%an,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%AW',scan%header%aw,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%IE',scan%header%ie,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%ECEC',scan%header%ecec,   &
                     0,0,readonly,error)
   call sic_def_real('SCAN%HEADER%ZFLX',scan%header%zflx,   &
                     0,0,readonly,error)
   !
   nfb = scan%header%nfebe
   if (allocated(tmpfebe)) deallocate(tmpfebe)
   allocate(tmpfebe(nfb),stat=ier)
   do i = 1, nfb
      tmpfebe(i) = scan%data%febe(i)
      call sic_upper(tmpfebe(i))
   enddo
   !
   where (index(tmpfebe,'CONT').ne.0)
      idbe(1:nfb) = 10
   else where (index(tmpfebe,'BBC').ne.0)
      idbe(1:nfb) = 11
   else where (index(tmpfebe,'NBC').ne.0)
      idbe(1:nfb) = 12
   else where (index(tmpfebe,'100K').ne.0)
      idbe(1:nfb) = 20
   else where (index(tmpfebe,'1MHZ').ne.0)
      idbe(1:nfb) = 30
   else where (index(tmpfebe,'VESPA').ne.0)
      idbe(1:nfb) = 40
   else where (index(tmpfebe,'WILMA').ne.0)
      idbe(1:nfb) = 60
   else where (index(tmpfebe,'4MHZ').ne.0)
      idbe(1:nfb) = 70
   else where (index(tmpfebe,'FTS').ne.0)
      idbe(1:nfb) = 80
   else where (index(tmpfebe,'ABBA').ne.0)
      idbe(1:nfb) = 90
   else where
      idbe(1:nfb) = 0
   end where
   !
!! temporary disabled
!   do i = 1, nfb
!      tmpbackend = tmpfebe(i)
!      j = index(tmpbackend,'/')
!      if (j.ne.0) then
!         read(tmpbackend(j+1:j+2),'(I2)') k
!         idbe(i) = idbe(i)+k
!      endif
!   enddo
   !
   where (index(tmpfebe,'100').eq.2)
      idfe(1:nfb) = 10
   else where (index(tmpfebe,'150').ne.0)
      idfe(1:nfb) = 20
   else where (index(tmpfebe,'230').ne.0)
      idfe(1:nfb) = 30
   else where (index(tmpfebe,'270').ne.0)
      idfe(1:nfb) = 40
   else where (index(tmpfebe,'HERA1').ne.0)
      idfe(1:nfb) = 50
   else where (index(tmpfebe,'HERA2').ne.0)
      idfe(1:nfb) = 60
   else where (index(tmpfebe,'MAMBO').ne.0)
      idfe(1:nfb) = 70
   else where (index(tmpfebe,'90').ne.0)
      idfe(1:nfb) = 80
   else where (index(tmpfebe,'E0').eq.1)
      idfe(1:nfb) = 1000
   else where (index(tmpfebe,'E1').eq.1)
      idfe(1:nfb) = 2000
   else where (index(tmpfebe,'E2').eq.1)
      idfe(1:nfb) = 3000
   else where (index(tmpfebe,'E3').eq.1)
      idfe(1:nfb) = 4000
   else where
      idfe(1:nfb) = 0
   end where
   !
   where (index(tmpfebe,'A').eq.1)
      idfe(1:nfb) = idfe(1:nfb)+1
   else where (index(tmpfebe,'B').eq.1)
      idfe(1:nfb) = idfe(1:nfb)+2
   else where (index(tmpfebe,'C').eq.1)
      idfe(1:nfb) = idfe(1:nfb)+3
   else where (index(tmpfebe,'D').eq.1)
      idfe(1:nfb) = idfe(1:nfb)+4
   else where (index(tmpfebe,'H').eq.1.and.index(tmpfebe,'HER').eq.0)
      idfe(1:nfb) = idfe(1:nfb)+5
   else where (index(tmpfebe,'V').eq.1)
      idfe(1:nfb) = idfe(1:nfb)+6
   else where (index(tmpfebe,'R').eq.1)
      idfe(1:nfb) = idfe(1:nfb)+7
   else where (index(tmpfebe,'I').eq.1)
      idfe(1:nfb) = idfe(1:nfb)+8
   end where
   !
   ! EMIR cases
   !
   where (index(tmpfebe,'H').eq.3)
      idfe(1:nfb) = idfe(1:nfb)+100
   else where (index(tmpfebe,'V').eq.3)
      idfe(1:nfb) = idfe(1:nfb)+200
   else where (index(tmpfebe,'R').eq.3.and.index(tmpfebe,'HER').eq.0)
      idfe(1:nfb) = idfe(1:nfb)+300
   else where (index(tmpfebe,'I').eq.3)
      idfe(1:nfb) = idfe(1:nfb)+400
   end where
   where (index(tmpfebe,'L').eq.4)
      idfe(1:nfb) = idfe(1:nfb)+10
   else where (index(tmpfebe,'U').eq.4)
      idfe(1:nfb) = idfe(1:nfb)+20
   end where
   where (index(tmpfebe,'LI').eq.4.or.index(tmpfebe,'UI').eq.4)
      idfe(1:nfb) = idfe(1:nfb)+1
   else where (index(tmpfebe,'LO').eq.4.or.index(tmpfebe,'UO').eq.4)
      idfe(1:nfb) = idfe(1:nfb)+2
   end where
   !
   call sic_def_inte('SCAN%DATA%BE',idbe(1:nfb),1,nfb,readonly,error)
   call sic_def_inte('SCAN%DATA%FE',idfe(1:nfb),1,nfb,readonly,error)
   !
   call sic_descriptor('SCAN%DATA%LONGOFF',desc,exist)
   if (exist) call sic_delvariable('SCAN%DATA%LONGOFF',.false.,error)
   call sic_descriptor('SCAN%DATA%LATOFF',desc,exist)
   if (exist) call sic_delvariable('SCAN%DATA%LATOFF',.false.,error)
   !
   if (associated(scan%data%longoff)) then
      noffsets = size(scan%data%longoff,1)
      call sic_def_dble('SCAN%DATA%LONGOFF',scan%data%longoff,1,   &
                        noffsets,readonly,error)
      call sic_def_dble('SCAN%DATA%LATOFF',scan%data%latoff,1,   &
                        noffsets,readonly,error)
   endif
   !
   return
   !
   entry febe_to_sic(readonly,error)
   !
   if (.not.associated(febe)) then
      call gagout('E-VAR: no FEBE section in MIRA.')
      error = .true.
      return
   endif
   !
   npix = febe(1)%header%nusefeed
   call sic_descriptor('xHera',desc,exist)
   if (exist) call sic_delvariable('xHera',.false.,error)
   call sic_def_dble('xHera',xhera,1,npix,.true.,error)
   call sic_descriptor('yHera',desc,exist)
   if (exist) call sic_delvariable('yHera',.false.,error)
   call sic_def_dble('yHera',yhera,1,npix,.true.,error)
   !
   nfb = scan%header%nfebe
   !
   febe_loop1: do i = 1, nfb
      name1 = nullstring
      write(name1,'(A4,I0)') 'FEBE',i
      call sic_descriptor(trim(name1),desc,exist)
      if (exist) call sic_delvariable(trim(name1),.false.,error)
      call sic_defstructure(trim(name1),.true.,error)
      !
      name2 = nullstring
      write(name2,'(A)') trim(name1)//'%HEADER'
      call sic_defstructure(trim(name2),.true.,error)
      call sic_def_char(trim(name2)//'%FEBE',   &
                        febe(i)%header%febe,readonly,error)
      call sic_def_inte(trim(name2)//'%SCANNUM',   &
                        febe(i)%header%scannum,0,0,readonly,error)
      call sic_def_char(trim(name2)//'%DATE_OBS',   &
                        febe(i)%header%date_obs,readonly,error)
      call sic_def_char(trim(name2)//'%DEWRTMOD',   &
                        febe(i)%header%dewrtmod,readonly,error)
      call sic_def_real(trim(name2)//'%DEWANG',   &
                        febe(i)%header%dewang,0,0,readonly,error)
      call sic_def_char(trim(name2)//'%DEWCABIN',   &
                        febe(i)%header%dewcabin,readonly,error)
      call sic_def_inte(trim(name2)//'%FEBEBAND',   &
                        febe(i)%header%febeband,0,0,readonly,error)
      call sic_def_inte(trim(name2)//'%FEBEFEED',   &
                        febe(i)%header%febefeed,0,0,readonly,error)
      call sic_def_inte(trim(name2)//'%NUSEFEED',   &
                        febe(i)%header%nusefeed,0,0,readonly,error)
      call sic_def_char(trim(name2)//'%SWTCHMOD',   &
                        febe(i)%header%swtchmod,readonly,error)
      call sic_def_char(trim(name2)//'%VELOCONV',   &
                        febe(i)%header%veloconv,readonly,error)
      call sic_def_inte(trim(name2)//'%NPHASES',   &
                        febe(i)%header%nphases,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%FRQOFF1',   &
                        febe(i)%header%frqoff1,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%FRQOFF2',   &
                        febe(i)%header%frqoff2,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%FRQTHROW',   &
                        febe(i)%header%frqthrow,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%IARX',   &
                        febe(i)%header%iarx,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%CARX',   &
                        febe(i)%header%carx,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%IERX',   &
                        febe(i)%header%ierx,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%ECECRX',   &
                        febe(i)%header%ececrx,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%ZFLXRX',   &
                        febe(i)%header%zflxrx,0,0,readonly,error)
      call sic_def_real(trim(name2)//'%IFCENTER',   &
                        febe(i)%header%ifcenter,0,0,readonly,error)
      !
      name2 = nullstring
      write(name2,'(A)') trim(name1)//'%DATA'
      call sic_defstructure(trim(name2),.true.,error)
      !
      nbd = febe(i)%header%febeband
      npix = febe(i)%header%nusefeed
      dim(1) = npix
      dim(2) = nbd
      !
      call sic_def_inte(trim(name2)//'%USEFEED',   &
                        febe(i)%data%usefeed,1,npix,readonly,error)
      call sic_def_char(trim(name2)//'%FEEDTYPE','H',readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%FEEDOFFX',   &
                        febe(i)%data%feedoffx,1,npix,readonly,error)
      call sic_def_dble(trim(name2)//'%FEEDOFFY',   &
                        febe(i)%data%feedoffy,1,npix,readonly,error)
      call sic_def_inte(trim(name2)//'%REFFEED',   &
                        febe(i)%data%reffeed,0,0,readonly,error)
      !         DO J = 1, NPIX
      !            IF (INDEX(FEBE(I)%DATA%POLTY(J),'x').NE.0.OR.
      !     &          INDEX(FEBE(I)%DATA%POLTY(J),'X').NE.0) THEN
      !                IDPOL(J) = 1
      !            ELSE IF (INDEX(FEBE(I)%DATA%POLTY(J),'y').NE.0.OR.
      !     &          INDEX(FEBE(I)%DATA%POLTY(J),'Y').NE.0) THEN
      !                IDPOL(J) = 2
      !            ELSE IF (INDEX(FEBE(I)%DATA%POLTY(J),'l').NE.0.OR.
      !     &          INDEX(FEBE(I)%DATA%POLTY(J),'L').NE.0) THEN
      !                IDPOL(J) = 3
      !            ELSE IF (INDEX(FEBE(I)%DATA%POLTY(J),'r').NE.0.OR.
      !     &          INDEX(FEBE(I)%DATA%POLTY(J),'R').NE.0) THEN
      !                IDPOL(J) = 4
      !            ENDIF
      !         ENDDO
      name2 = nullstring
      write(name2,'(A)') trim(name1)//'%DATA'
      call sic_def_char(trim(name2)//'%POLTY',febe(i)%data%polty(1),   &
                        readonly,error)
      call sic_def_real(trim(name2)//'%POLA',   &
                        febe(i)%data%pola,1,npix,readonly,error)
      call sic_def_real(trim(name2)//'%APEREFF',   &
                        febe(i)%data%apereff,2,dim,readonly,error)
      call sic_def_real(trim(name2)//'%BEAMEFF',   &
                        febe(i)%data%beameff,2,dim,readonly,error)
      call sic_def_real(trim(name2)//'%ETAFSS',   &
                        febe(i)%data%etafss,2,dim,readonly,error)
      call sic_def_real(trim(name2)//'%HPBW',   &
                        febe(i)%data%hpbw,2,dim,readonly,error)
      call sic_def_real(trim(name2)//'%ANTGAIN',   &
                        febe(i)%data%antgain,2,dim,readonly,error)
      call sic_def_real(trim(name2)//'%BOLCALFC',   &
                        febe(i)%data%bolcalfc,1,npix,readonly,error)
      call sic_def_real(trim(name2)//'%FLATFIEL',   &
                        febe(i)%data%flatfiel,2,dim,readonly,error)
      call sic_def_real(trim(name2)//'%GAINIMAG',   &
                        febe(i)%data%gainimag,2,dim,readonly,error)
      call sic_def_real(trim(name2)//'%GAINELE1',   &
                        febe(i)%data%gainele1,1,npix,readonly,error)
      call sic_def_real(trim(name2)//'%GAINELE2',   &
                        febe(i)%data%gainele2,1,npix,readonly,error)
   !
   enddo febe_loop1
   !
   return
   !
   entry data_to_sic(readonly,error)
   !
   if (.not.associated(data)) then
      call gagout('E-VAR: no DATA section in MIRA.')
      error = .true.
      return
   endif
   !
   nfb = scan%header%nfebe
   !
   febe_loop2: do i = 1, nfb
      name1 = nullstring
      write(name1,'(A4,I0)') 'DATA',i
      call sic_descriptor(trim(name1),desc,exist)
      if (exist) then
         call sic_delvariable(trim(name1),.false.,error)
      endif
      call sic_defstructure(trim(name1),.true.,error)
      name2 = nullstring
      write(name2,'(A)') trim(name1)//'%HEADER'
      call sic_defstructure(trim(name2),.true.,error)
      !
      call sic_def_char(trim(name2)//'%FEBE',   &
                        data(i)%header%febe,   &
                        readonly,error)
      call sic_def_inte(trim(name2)//'%SCANNUM',   &
                        data(i)%header%scannum,   &
                        0,0,readonly,error)
      call sic_def_inte(trim(name2)//'%OBSNUM',   &
                        data(i)%header%obsnum,   &
                        0,0,readonly,error)
      call sic_def_char(trim(name2)//'%DATE_OBS',   &
                        data(i)%header%date_obs,   &
                        readonly,error)
      call sic_def_dble(trim(name2)//'%LST',   &
                        data(i)%header%lst,   &
                        0,0,readonly,error)
      call sic_def_char(trim(name2)//'%OBSTYPE',   &
                        data(i)%header%obstype,   &
                        readonly,error)
      call sic_def_logi(trim(name2)//'%DPBLOCK',   &
                        data(i)%header%dpblock,   &
                        readonly,error)
      call sic_def_char(trim(name2)//'%OBSTATUS',   &
                        data(i)%header%obstatus,   &
                        readonly,error)
      call sic_def_inte(trim(name2)//'%CHANNELS',   &
                        data(i)%header%channels,   &
                        0,0,readonly,error)
      call sic_def_real(trim(name2)//'%CRPX4F_2',   &
                        data(i)%header%crpx4f_2,   &
                        0,0,readonly,error)
      call sic_def_real(trim(name2)//'%CRPX4R_2',   &
                        data(i)%header%crpx4r_2,   &
                        0,0,readonly,error)
      call sic_def_dble(trim(name2)//'%CRVL4F_2',   &
                        data(i)%header%crvl4f_2,   &
                        0,0,readonly,error)
      call sic_def_dble(trim(name2)//'%CRVL4R_2',   &
                        data(i)%header%crvl4r_2,   &
                        0,0,readonly,error)
      call sic_def_dble(trim(name2)//'%CD4F_21',   &
                        data(i)%header%cd4f_21,   &
                        0,0,readonly,error)
      call sic_def_dble(trim(name2)//'%CD4R_21',   &
                        data(i)%header%cd4r_21,   &
                        0,0,readonly,error)
      name2 = nullstring
      write(name2,'(A)') trim(name1)//'%DATA'
      call sic_defstructure(trim(name2),.true.,error)
      !
      nrecord = maxval(data(i)%data%integnum)
      dim(1)   = nrecord
      call sic_def_dble(trim(name2)//'%LONGOFF',data(i)%data%longoff,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%LATOFF', data(i)%data%latoff,   &
                        1,dim,readonly,error)
      call sic_def_inte(trim(name2)//'%INTEGNUM',   &
                        data(i)%data%integnum,   &
                        1,dim,readonly,error)
      call sic_def_inte(trim(name2)//'%SUBSCAN',   &
                        data(i)%data%subscan,   &
                        1,dim,readonly,error)
      call sic_def_inte(trim(name2)//'%NINTS',   &
                        data(i)%data%nints,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%MJD',   &
                        data(i)%data%mjd,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%LST',   &
                        data(i)%data%lst,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%MIDTIME',   &
                        data(i)%data%midtime,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%INTEGTIM',   &
                        data(i)%data%integtim,   &
                        1,dim,readonly,error)
      dim(1) = febe(i)%header%febefeed
      dim(2) = data(i)%header%channels
      dim(3) = nrecord
      !
      call sic_def_real(trim(name2)//'%RDATA',   &
                        data(i)%data%rdata,   &
                        2,dim,readonly,error)
      call sic_def_real(trim(name2)//'%OTFDATA',   &
                        data(i)%data%otfdata,   &
                        3,dim,readonly,error)
      !
      name1 = nullstring
      write(name1,'(A4,I0)') 'DATA',i
      write(name2,'(A)') trim(name1)//'%DATA'
      dim(1) = nrecord
      dim(2) = 3
      !
      call sic_def_dble(trim(name2)//'%AZIMUTH',data(i)%data%azimuth,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%ELEVATIO',   &
                        data(i)%data%elevatio,1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%CBASLONG',   &
                        data(i)%data%cbaslong,1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%CBASLAT',data(i)%data%cbaslat,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%BASLONG',data(i)%data%baslong,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%BASLAT',data(i)%data%baslat,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%PARANGLE',   &
                        data(i)%data%parangle,1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%PC_11',data(i)%data%pc_11,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%PC_12',data(i)%data%pc_12,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%PC_21',data(i)%data%pc_21,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%PC_22',data(i)%data%pc_22,   &
                        1,dim,readonly,error)
      call sic_def_real(trim(name2)//'%CR4K1',data(i)%data%cr4k1,   &
                        1,dim,readonly,error)
      call sic_def_real(trim(name2)//'%CR4K2',data(i)%data%cr4k2,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%MCRVAL1',data(i)%data%mcrval1,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%MCRVAL2',data(i)%data%mcrval2,   &
                        1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%MLONPOLE',   &
                        data(i)%data%mlonpole,1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%MLATPOLE',   &
                        data(i)%data%mlatpole,1,dim,readonly,error)
      call sic_def_dble(trim(name2)//'%FOCUS_X_Y_Z',   &
                        data(i)%data%focus_x_y_z,2,dim,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%DFOCUS_X_Y_Z',   &
                        data(i)%data%dfocus_x_y_z,2,dim,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%PHI_X_Y_Z',   &
                        data(i)%data%phi_x_y_z,2,dim,readonly,   &
                        error)
   !
   enddo febe_loop2
   !
   return
   !
   entry array_to_sic(readonly,error)
   !
   if (.not.associated(array)) then
      call gagout('E-VAR: no ARRAY section in MIRA.')
      error = .true.
      return
   endif
   !
   if (allocated(integtyp)) then
      do i = 1, size(integtyp)
         deallocate(integtyp(i)%switch,stat=ier)
      enddo
      deallocate(integtyp,stat=ier)
   endif
   allocate(integtyp(scan%header%nfebe),stat=ier)
   !
   febe_loop3: do i = 1, scan%header%nfebe
      !
      nrecord = size(array(i)%data(1)%data,3)
      nphases = size(array(i)%data(1)%data,4)
      allocate(integtyp(i)%switch(nrecord,nphases),stat=ier)
      !
      name1 = nullstring
      write(name1,'(A5,I0)') 'ARRAY',i
      call sic_descriptor(trim(name1),desc,exist)
      if (exist) call sic_delvariable(trim(name1),.false.,error)
      call sic_defstructure(trim(name1),.true.,error)
      nbd = febe(i)%header%febeband
      baseband_loop: do j = 1, nbd
         !
         name2 = nullstring
         if (i.lt.10) then
            write(name2,'(A6,A7,I0)') trim(name1),'%HEADER',j
         else
            write(name2,'(A7,A7,I0)') trim(name1),'%HEADER',j
         endif
         call sic_descriptor(trim(name2),desc,exist)
         if (exist) call sic_delvariable(trim(name2),.false.,error)
         call sic_defstructure(trim(name2),.true.,error)
         !
         call sic_def_char(trim(name2)//'%FEBE',   &
                           array(i)%header(j)%febe,   &
                           readonly,error)
         call sic_def_inte(trim(name2)//'%BASEBAND',   &
                           array(i)%header(j)%baseband,   &
                           0,0,readonly,error)
         call sic_def_inte(trim(name2)//'%SCANNUM',   &
                           array(i)%header(j)%scannum,   &
                           0,0,readonly,error)
         call sic_def_inte(trim(name2)//'%OBSNUM',   &
                           array(i)%header(j)%obsnum,   &
                           0,0,readonly,error)
         call sic_def_char(trim(name2)//'%DATE_OBS',   &
                           array(i)%header(j)%date_obs,   &
                           readonly,error)
         call sic_def_inte(trim(name2)//'%CHANNELS',   &
                           array(i)%header(j)%channels,   &
                           0,0,readonly,error)
         call sic_def_inte(trim(name2)//'%USEDCHAN',   &
                           array(i)%header(j)%usedchan,   &
                           0,0,readonly,error)
         call sic_def_inte(trim(name2)//'%DROPCHAN',   &
                           array(i)%header(j)%dropchan,   &
                           0,0,readonly,error)
         call sic_def_dble(trim(name2)//'%FREQRES',   &
                           array(i)%header(j)%freqres,   &
                           0,0,readonly,error)
         call sic_def_dble(trim(name2)//'%BANDWID',   &
                           array(i)%header(j)%bandwid,   &
                           0,0,readonly,error)
         call sic_def_char(trim(name2)//'%MOLECULE',   &
                           array(i)%header(j)%molecule,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%TRANSITI',   &
                           array(i)%header(j)%transiti,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%RESTFREQ',   &
                           array(i)%header(j)%restfreq,   &
                           0,0,readonly,error)
         call sic_def_char(trim(name2)//'%SIDEBAND',   &
                           array(i)%header(j)%sideband,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SBSEP',   &
                           array(i)%header(j)%sbsep,   &
                           0,0,readonly,error)
         call sic_def_char(trim(name2)//'%CTYP4_1',   &
                           array(i)%header(j)%ctyp4_1,   &
                           readonly,error)
         call sic_def_inte(trim(name2)//'%CRPX4_1',   &
                           array(i)%header(j)%crpx4_1,   &
                           0,0,readonly,error)
         call sic_def_inte(trim(name2)//'%CRVL4_1',   &
                           array(i)%header(j)%crvl4_1,   &
                           0,0,readonly,error)
         call sic_def_inte(trim(name2)//'%CD3A_11',   &
                           array(i)%header(j)%cd3a_11,   &
                           0,0,readonly,error)
         call sic_def_char(trim(name2)//'%WCSNM4F',   &
                           array(i)%header(j)%wcsnm4f,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%CTYP4F_2',   &
                           array(i)%header(j)%ctyp4f_2,   &
                           readonly,error)
         call sic_def_real(trim(name2)//'%CRPX4F_2',   &
                           array(i)%header(j)%crpx4f_2,   &
                           0,0,readonly,error)
         call sic_def_dble(trim(name2)//'%CRVL4F_2',   &
                           array(i)%header(j)%crvl4f_2,   &
                           0,0,readonly,error)
         call sic_def_dble(trim(name2)//'%CD4F_21',   &
                           array(i)%header(j)%cd4f_21,   &
                           0,0,readonly,error)
         call sic_def_char(trim(name2)//'%CUNI4F_2',   &
                           array(i)%header(j)%cuni4f_2,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%SPEC4F_2',   &
                           array(i)%header(j)%spec4f_2,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%SOBS4F_2',   &
                           array(i)%header(j)%sobs4f_2,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%WCSNM4R',   &
                           array(i)%header(j)%wcsnm4r,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%CTYP4R_2',   &
                           array(i)%header(j)%ctyp4r_2,   &
                           readonly,error)
         call sic_def_real(trim(name2)//'%CRPX4R_2',   &
                           array(i)%header(j)%crpx4r_2,   &
                           0,0,readonly,error)
         call sic_def_dble(trim(name2)//'%CRVL4R_2',   &
                           array(i)%header(j)%crvl4r_2,   &
                           0,0,readonly,error)
         call sic_def_dble(trim(name2)//'%CD4R_21',   &
                           array(i)%header(j)%cd4r_21,   &
                           0,0,readonly,error)
         call sic_def_char(trim(name2)//'%CUNI4R_2',   &
                           array(i)%header(j)%cuni4r_2,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%SPEC4R_2',   &
                           array(i)%header(j)%spec4r_2,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%SOBS4R_2',   &
                           array(i)%header(j)%sobs4r_2,   &
                           readonly,error)
         call sic_def_real(trim(name2)//'%VSOU4R_2',   &
                           array(i)%header(j)%vsou4r_2,   &
                           0,0,readonly,error)
         call sic_def_real(trim(name2)//'%VSYS4R_2',   &
                           array(i)%header(j)%vsys4r_2,   &
                           0,0,readonly,error)
         !
         name2 = nullstring
         if (i.lt.10) then
            write(name2,'(A6,A5,I0)') trim(name1),'%DATA',j
         else
            write(name2,'(A7,A5,I0)') trim(name1),'%DATA',j
         endif
         call sic_descriptor(trim(name2),desc,exist)
         if (exist) call sic_delvariable(trim(name2),.false.,error)
         call sic_defstructure(trim(name2),.true.,error)
         !
         nrecord = size(array(i)%data(j)%data,3)
         nphases = size(array(i)%data(j)%data,4)
         !
         integtyp(i)%switch = array(i)%data(j)%iswitch
         !
         dim(1) = nrecord
         dim(2) = nphases
         dim(3) = 0
         dim(4) = 0
         call sic_def_charn(trim(name2)//'%ISWITCH',   &
                            integtyp(i)%switch,2,   &
                            dim,readonly,error)
         !
         dim(1) = size(array(i)%data(j)%data,1)
         dim(2) = size(array(i)%data(j)%data,2)
         dim(3) = size(array(i)%data(j)%data,3)
         dim(4) = size(array(i)%data(j)%data,4)
         call sic_def_dble(trim(name2)//'%DATA',   &
                           array(i)%data(j)%data,   &
                           4,dim,readonly,error)
         !
         dim(1) = nrecord*nphases
         dim(2:4) = 0
         call sic_def_dble(trim(name2)//'%MJD',   &
                           array(i)%data(j)%mjd,   &
                           1,dim,readonly,error)
         call sic_def_dble(trim(name2)//'%INTEGTIM',   &
                           array(i)%data(j)%integtim,   &
                           1,dim,readonly,error)
         !
      !
      enddo baseband_loop
   !
   enddo febe_loop3
   !
   return
   !
   entry mon_to_sic(readonly,error)
   !
   if (.not.associated(mon)) then
      call gagout('E-VAR: no MONITOR section in MIRA.')
      error = .true.
      return
   endif
   !
   nfb = scan%header%nfebe
   !
   call sic_descriptor('ANTENNA',desc,exist)
   if (exist) call sic_delvariable('ANTENNA',.false.,error)
   call sic_defstructure('ANTENNA',.true.,error)
   nslow = size(antdata%slowtrace,1)
   dim1(1) = nslow
   dim1(2) = 3
   call sic_def_dble('ANTENNA%SLOWTRACE',antdata%slowtrace,   &
                     2,dim1,readonly,error)
   nfast = size(antdata%tracking_az_el,1)
   dim1(1) = nfast
   dim1(2) = 3
   dim2(1) = nfast
   dim2(2) = 2
   call sic_def_dble('ANTENNA%ENCODER_AZ_EL',antdata%encoder_az_el,   &
                     2,dim1,readonly,error)
   call sic_def_dble('ANTENNA%TRACKING_AZ_EL',antdata%tracking_az_el,   &
                     2,dim2,readonly,error)
   !
   febe_loop4: do i = 1, nfb
      name1 = nullstring
      write(name1,'(A3,I0)') 'MON',i
      call sic_descriptor(trim(name1),desc,exist)
      if (exist) call sic_delvariable(trim(name1),.false.,error)
      call sic_defstructure(trim(name1),.true.,error)
      name2 = nullstring
      write(name2,'(A)') trim(name1)//'%HEADER'
      call sic_defstructure(name2,.true.,error)
      !
      nrecord = size(mon(i)%data%mjd)
      nfast = size(mon(i)%data%tracking_az_el,1)
      nsubref = size(mon(i)%data%focus_x_y_z,1)
      dim1(1) = nfast
      dim1(2) = 2
      dim2(1) = nfast
      dim2(2) = 3
      dim3(1) = nsubref
      dim3(2) = 4
      !
      call sic_def_inte(trim(name2)//'%SCANNUM',   &
                        mon(i)%header%scannum,0,0,readonly,error)
      call sic_def_inte(trim(name2)//'%OBSNUM',mon(i)%header%obsnum,   &
                        0,0,readonly,error)
      call sic_def_dble(trim(name2)//'%IAOBS_CAOBS_IEOBS',   &
                        mon(i)%header%iaobs_caobs_ieobs,   &
                        1,3,readonly,error)
      call sic_def_dble(trim(name2)//'%FOCOBS_X_Y_Z',   &
                        mon(i)%header%focobs_x_y_z,   &
                        1,3,readonly,error)
      call sic_def_char(trim(name2)//'%DATE_OBS',   &
                        mon(i)%header%date_obs,readonly,error)

      name2 = nullstring
      write(name2,'(A)') trim(name1)//'%DATA'
      call sic_defstructure(trim(name2),.true.,error)

      call sic_def_dble(trim(name2)//'%MJD',mon(i)%data%mjd,   &
                        1,nrecord,readonly,error)
      call sic_def_inte(trim(name2)//'%SUBSCAN',mon(i)%data%subscan,   &
                        1,nrecord,readonly,error)
      call sic_def_inte(trim(name2)//'%SUBSCANFAST',   &
                        mon(i)%data%subscanfast,1,nfast,readonly,   &
                        error)
      call sic_def_inte(trim(name2)//'%SUBSCANSUBREF',   &
                        mon(i)%data%subscansubref,1,nsubref,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%LST',mon(i)%data%lst,   &
                        1,nrecord,readonly,error)
      call sic_def_dble(trim(name2)//'%ENCODER_AZ_EL',   &
                        mon(i)%data%encoder_az_el,2,dim2,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%TRACKING_AZ_EL',   &
                        mon(i)%data%tracking_az_el,2,dim1,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%DFOCUS_X_Y_Z',   &
                        mon(i)%data%dfocus_x_y_z,2,dim3,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%FOCUS_X_Y_Z',   &
                        mon(i)%data%focus_x_y_z,2,dim3,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%PHI_X_Y_Z',   &
                        mon(i)%data%phi_x_y_z,2,dim3,readonly,error)
      call sic_def_dble(trim(name2)//'%PARANGLE',   &
                        mon(i)%data%parangle,1,nrecord,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%BASLONG',mon(i)%data%baslong,   &
                        1,nrecord,readonly,error)
      call sic_def_dble(trim(name2)//'%BASLAT',mon(i)%data%baslat,   &
                        1,nrecord,readonly,error)
      call sic_def_dble(trim(name2)//'%LONGOFF',mon(i)%data%longoff,   &
                        1,nrecord,readonly,error)
      call sic_def_dble(trim(name2)//'%LATOFF',mon(i)%data%latoff,   &
                        1,nrecord,readonly,error)
      call sic_def_dble(trim(name2)//'%ANTENNA_AZ_EL',   &
                        mon(i)%data%antenna_az_el,1,2,readonly,error)
      dim1(1) = size(mon(i)%data%tamb_p_humid,1)
      dim1(2) = 3
      call sic_def_dble(trim(name2)//'%TAMB_P_HUMID',   &
                        mon(i)%data%tamb_p_humid,2,dim1,readonly,   &
                        error)
      call sic_def_dble(trim(name2)//'%WIND_DIR_VAVG_VMAX',   &
                        mon(i)%data%wind_dir_vavg_vmax,2,dim1,   &
                        readonly,error)
      dim1(2) = 2
      call sic_def_dble(trim(name2)//'%REFRACTIO',   &
                        mon(i)%data%refractio,1,dim1,readonly,   &
                        error)
      dim1(1) = size(mon(i)%data%thotcold,1)
      dim1(2) = 2
      call sic_def_dble(trim(name2)//'%THOTCOLD',   &
                        mon(i)%data%thotcold,2,dim1,readonly,error)
   !
   !
   enddo febe_loop4
   !
   !
   return
   !
   entry gains_to_sic(readonly,error)
   !
   if (.not.associated(gains)) then
      call gagout('E-VAR: no CALIBRATION section in MIRA.')
      error = .true.
      return
   endif
   !
   nfb = size(gains)
   do i = 1, nfb
      name1 = nullstring
      write(name1,'(A5,I0)') 'GAINS',i
      call sic_descriptor(trim(name1),desc,exist)
      if (exist) call sic_delvariable(trim(name1),.false.,error)
      if (.not.associated(gains(i)%gainarray)) then
         call gagout('W-VARIABLE: No calibration available for '   &
                     //scan%data%febe(i))
      else
         dim2(1) = size(gains(i)%gainarray,1)
         dim2(2) = size(gains(i)%gainarray,2)
         dim2(3) = size(gains(i)%gainarray,3)
         dim3(1:2) = dim2(1:2)
         dim3(3) = size(gains(i)%trx,3)
         call sic_defstructure(trim(name1),.true.,error)
         call sic_def_char(trim(name1)//'%FEBE',gains(i)%febe,   &
                           readonly,error)
         call sic_def_dble(trim(name1)//'%GAINARRAY',   &
                           gains(i)%gainarray,   &
                           3,dim2,readonly,error)
         call sic_def_dble(trim(name1)//'%GAINIMAGE',   &
                           gains(i)%gainimage,   &
                           3,dim2,readonly,error)
         if (associated(gains(i)%phasearray))   &
           call sic_def_dble(trim(name1)//'%PHASEARRAY',   &
                             gains(i)%phasearray,   &
                             3,dim2,readonly,error)
         call sic_def_dble(trim(name1)//'%CRVL4F_2',   &
                           gains(i)%crvl4f_2,1,dim2,readonly,error)
         call sic_def_inte(trim(name1)//'%CHANNELS',   &
                           gains(i)%channels,1,dim2,readonly,error)
         call sic_def_dble(trim(name1)//'%CD4F_21',   &
                           gains(i)%cd4f_21,1,dim2,readonly,error)
         call sic_def_dble(trim(name1)//'%PSKY',gains(i)%psky,   &
                           3,dim2,readonly,error)
         call sic_def_dble(trim(name1)//'%PHOT',gains(i)%phot,   &
                           3,dim2,readonly,error)
         call sic_def_dble(trim(name1)//'%PCOLD',gains(i)%pcold,   &
                           3,dim2,readonly,error)
         if (associated(gains(i)%pgrid))   &
           call sic_def_dble(trim(name1)//'%PGRID',gains(i)%pgrid,   &
                           3,dim2,readonly,error)
         call sic_def_dble(trim(name1)//'%TAUZEN',gains(i)%tauzen,   &
                           3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TAUZENDRY',   &
                           gains(i)%tauzendry,3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TAUZENWET',   &
                           gains(i)%tauzenwet,3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TAUZENIMAGE',  &
                           gains(i)%tauzenimage,3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TAUZENIMAGEDRY',   &
                           gains(i)%tauzenimagedry,3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TAUZENIMAGEWET',   &
                           gains(i)%tauzenimagewet,3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TATMS',gains(i)%tatms,   &
                           3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TATMI',gains(i)%tatmi,   &
                           3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TEMIS',gains(i)%temis,   &
                           3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TEMII',gains(i)%temii,   &
                           3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%H2OMM',gains(i)%h2omm,   &
                           3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%LCALOF',gains(i)%lcalof,   &
                           0,0,readonly,error)
         call sic_def_dble(trim(name1)//'%BCALOF',gains(i)%bcalof,   &
                           0,0,readonly,error)
         call sic_def_dble(trim(name1)//'%TCAL',gains(i)%tcal,   &
                           3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TSYS',gains(i)%tsys,   &
                           3,dim3,readonly,error)
         call sic_def_dble(trim(name1)//'%TRX',gains(i)%trx,   &
                           3,dim3,readonly,error)
      endif
   enddo
   !
   return
   !
   entry choice_to_sic(readonly,error)
   !
   call sic_descriptor('CHOICE',desc,exist)
   if (exist) call sic_delvariable('CHOICE',.false.,error)
   call sic_defstructure('CHOICE',.true.,error)
   if (allocated(choice%backend)) then
      do i = 1, size(choice%backend)
         name1 = nullstring
         write(name1,'(A14,I0)') 'CHOICE%BACKEND',i
         call sic_def_char(trim(name1),choice%backend(i),   &
                           .true.,error)
      enddo
   endif
   if (allocated(choice%frontend)) then
      do i = 1, size(choice%frontend)
         name1 = nullstring
         write(name1,'(A15,I0)') 'CHOICE%FRONTEND',i
         call sic_def_char(trim(name1),choice%frontend(i),   &
                           .true.,error)
      enddo
   endif
   if (allocated(choice%transition)) then
      do i = 1, size(choice%transition)
         name1 = nullstring
         write(name1,'(A17,I0)') 'CHOICE%TRANSITION',i
         call sic_def_char(trim(name1),choice%transition(i),   &
                           .true.,error)
      enddo
   endif
   call sic_def_char('CHOICE%DATE_OBS1',choice%date_obs(1),   &
                     .true.,error)
   call sic_def_char('CHOICE%DATE_OBS2',choice%date_obs(2),   &
                     .true.,error)
   if (allocated(choice%procedure)) then
      do i = 1, size(choice%procedure)
         name1 = nullstring
         write(name1,'(A16,I0)') 'CHOICE%PROCEDURE',i
         call sic_def_char(trim(name1),choice%procedure(i),   &
                           .true.,error)
      enddo
   endif
   if (allocated(choice%switchmode)) then
      do i = 1, size(choice%switchmode)
         name1 = nullstring
         write(name1,'(A17,I0)') 'CHOICE%SWITCHMODE',i
         call sic_def_char(trim(name1),choice%switchmode(i),   &
                           .true.,error)
      enddo
   endif
   call sic_def_char('CHOICE%SCAN1',choice%scan(1),   &
                     .true.,error)
   call sic_def_char('CHOICE%SCAN2',choice%scan(2),   &
                     .true.,error)
   if (allocated(choice%object)) then
      do i = 1, size(choice%object)
         name1 = nullstring
         write(name1,'(A13,I0)') 'CHOICE%OBJECT',i
         call sic_def_char(trim(name1),choice%object(i),.true.,error)
      enddo
   endif
   if (allocated(choice%telescope)) then
      do i = 1, size(choice%telescope)
         name1 = nullstring
         write(name1,'(A16,I0)') 'CHOICE%TELESCOPE',i
         call sic_def_char(trim(name1),choice%telescope(i),   &
                           .true.,error)
      enddo
   endif
   if (allocated(choice%project)) then
      do i = 1, size(choice%project)
         name1 = nullstring
         write(name1,'(A16,I0)') 'CHOICE%PROJECT',i
         call sic_def_char(trim(name1),choice%project(i),   &
                           .true.,error)
      enddo
   endif
   !
   return
   !
   entry reduce_to_sic(readonly,error)
   !
   if (allocated(iflag)) deallocate(iflag,stat=ier)
   allocate(iflag(5,scan%header%nfebe),stat=ier)
   do i = 1, scan%header%nfebe
      name1 = 'NULLSTRING'
      write(name1,'(A6,I0)') 'REDUCE',i
      call sic_descriptor(trim(name1),desc,exist)
      if (exist) call sic_delvariable(trim(name1),.false.,error)
      call sic_defstructure(trim(name1),.true.,error)
      where (reduce(i)%calibration_done(1:5))
         iflag(1:5,i) = 1
      elsewhere
         iflag(1:5,i) = 0
      end where
      call sic_def_inte(trim(name1)//'%CALIBRATION_DONE',   &
                        iflag(1:5,i),1,5,readonly,error)
      call sic_def_logi(trim(name1)//'%BASE_DONE',   &
                        reduce(i)%base_done,readonly,error)
      call sic_def_logi(trim(name1)//'%DESPIKE_DONE',   &
                        reduce(i)%despike_done,readonly,error)
   enddo
   !
   return
   !
   entry raw_to_sic(readonly,error)
   !
   nfb = scan%header%nfebe
   subscanloop: do i = 1, size(raw)
      name1 = nullstring
      write(name1,'(A3,I0)') 'RAW',i
      call sic_descriptor(trim(name1),desc,exist)
      if (exist) call sic_delvariable(trim(name1),.false.,error)
      call sic_defstructure(trim(name1),.true.,error)
      febeloop: do j = 1, nfb
         name2 = nullstring
         if (i.lt.10) then
            write(name2,'(A4,A8,I0)') trim(name1),'%ANTENNA',j
         else if (i.lt.100) then
            write(name2,'(A5,A8,I0)') trim(name1),'%ANTENNA',j
         else
            write(name2,'(A6,A8,I0)') trim(name1),'%ANTENNA',j
         endif
         call sic_defstructure(trim(name2),.true.,error)
         call sic_def_char(trim(name2)//'%SYSTEMOFF',   &
                           raw(i)%antenna(j)%systemoff,.true.,error)
         call sic_def_dble(trim(name2)//'%SUBSCANSTART',   &
                           raw(i)%antenna(j)%subscanstart,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SUBSCANEND',   &
                           raw(i)%antenna(j)%subscanend,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%dateObs',   &
                           raw(i)%antenna(j)%dateObs,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%dateEnd',   &
                           raw(i)%antenna(j)%dateEnd,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SEGMENTXSTART',   &
                           raw(i)%antenna(j)%segmentxstart,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SEGMENTXEND',   &
                           raw(i)%antenna(j)%segmentxend,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SEGMENTYSTART',   &
                           raw(i)%antenna(j)%segmentystart,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SEGMENTYEND',   &
                           raw(i)%antenna(j)%segmentyend,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%TRACKINGERROR',   &
                           raw(i)%antenna(j)%trackingerror,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%DOPPLERCORR',   &
                           raw(i)%antenna(j)%dopplercorr,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%OBSVELRF',   &
                           raw(i)%antenna(j)%obsvelrf,0,0,   &
                           readonly,error)
         call sic_def_char(trim(name2)//'%SBCALREC',   &
                           raw(i)%antenna(j)%sbcalrec,   &
                           readonly,error)
         name2 = nullstring
         if (i.lt.10) then
            write(name2,'(A4,A7,I0)') trim(name1),'%SUBREF',j
         else if (i.lt.100) then
            write(name2,'(A5,A7,I0)') trim(name1),'%SUBREF',j
         else
            write(name2,'(A6,A7,I0)') trim(name1),'%SUBREF',j
         endif
         call sic_defstructure(trim(name2),.true.,error)
         call sic_def_char(trim(name2)//'%FOCUSTRANSL',   &
                           raw(i)%subref(j)%focustransl,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SUBSCANSTART',   &
                           raw(i)%subref(j)%subscanstart,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SUBSCANEND',   &
                           raw(i)%subref(j)%subscanend,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SEGMENTXSTART',   &
                           raw(i)%subref(j)%segmentxstart,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SEGMENTXEND',   &
                           raw(i)%subref(j)%segmentxend,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SEGMENTYSTART',   &
                           raw(i)%subref(j)%segmentystart,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SEGMENTYEND',   &
                           raw(i)%subref(j)%segmentyend,0,0,   &
                           readonly,error)

         name2 = nullstring
         if (i.lt.10) then
            write(name2,'(A4,A8,I0)') trim(name1),'%BACKEND',j
         else if (i.lt.100) then
            write(name2,'(A5,A8,I0)') trim(name1),'%BACKEND',j
         else
            write(name2,'(A6,A8,I0)') trim(name1),'%BACKEND',j
         endif
         call sic_defstructure(trim(name2),.true.,error)
         call sic_def_dble(trim(name2)//'%SUBSCANSTART',   &
                           raw(i)%backend(j)%subscanstart,0,0,   &
                           readonly,error)
         call sic_def_dble(trim(name2)//'%SUBSCANEND',   &
                           raw(i)%backend(j)%subscanend,0,0,   &
                           readonly,error)
      enddo febeloop
   enddo subscanloop
   !
   return
   !
   entry cryo_to_sic(readonly,error)
   !
   if (associated(cryo)) then
      !
      call sic_descriptor('CRYO',desc,exist)
      if (exist) call sic_delvariable('CRYO',.false.,error)
      call sic_defstructure('CRYO',.true.,error)
      dim1(1) = size(cryo%cr4k1)
      call sic_def_real('CRYO%CR4K1',cryo%cr4k1,1,dim1,   &
                        readonly,error)
      call sic_def_real('CRYO%CR4K2',cryo%cr4k2,1,dim1,   &
                        readonly,error)
      call sic_def_dble('CRYO%MJD',cryo%mjd,1,dim1,readonly,error)
   !
   endif
   !
   return
   !
   entry derot_to_sic(readonly,error)
   !
   if (associated(derot)) then
      !
      call sic_descriptor('DEROT',desc,exist)
      if (exist) call sic_delvariable('DEROT',.false.,error)
      call sic_defstructure('DEROT',.true.,error)
      dim1(1) = size(derot%actframe)
      call sic_def_real('DEROT%ACTFRAME',derot%actframe,1,dim1,   &
                        readonly,error)
      call sic_def_dble('DEROT%MJD',derot%mjd,1,dim1,readonly,error)
   !
   endif
   !
   return
   !
   !
   entry list_to_sic(readonly,error)
   !
   if (.not.associated(list)) then
      call gagout('W-VARIABLE: Cannot create SIC structure LIST.')
      return
   endif
   call sic_descriptor('LIST',desc,exist)
   if (exist) call sic_delvariable('LIST',.false.,error)
   call sic_defstructure('LIST',.true.,error)
   found = size(list)
   call sic_def_inte('LIST%FOUND',found,0,0,readonly,error)
   !
   do i = 1, size(list)
      write(name1,'(A4,I0)') 'LIST',i
      call sic_descriptor(trim(name1),desc,exist)
      if (exist) call sic_delvariable(trim(name1),.false.,error)
      call sic_defstructure(trim(name1),.true.,error)
      call sic_def_inte(trim(name1)//'%INDX',list(i)%indx,   &
                        0,0,readonly,error)
      call sic_def_inte(trim(name1)//'%SCAN',list(i)%scan,   &
                        0,0,readonly,error)
      call sic_def_char(trim(name1)//'%OBJECT',   &
                        list(i)%object,.true.,error)
      call sic_def_char(trim(name1)//'%TELESCOPE',   &
                        list(i)%telescope,.true.,error)
      call sic_def_char(trim(name1)//'%PROCEDURE',   &
                        list(i)%procedure,.true.,error)
      call sic_def_char(trim(name1)//'%SWITCHMODE',   &
                        list(i)%switchmode,.true.,error)
      call sic_def_char(trim(name1)//'%BACKEND',   &
                        list(i)%backend(1),.true.,error)
      call sic_def_char(trim(name1)//'%dateOBS',   &
                        list(i)%dateobs,.true.,error)
      call sic_def_inte(trim(name1)//'%NCFE',list(i)%ncfe,   &
                        0,0,readonly,error)
   enddo
   !
   return
!
end subroutine mira_to_sic

subroutine read_data(arg,sort,init,error)
  use gildas_def
  use gkernel_interfaces, no_interface1=>gr4_trie_i4,  &
                          no_interface2=>gr4_sort
  use classic_api
  use clic_rdata
  use gio_params
  !---------------------------------------------------------------------
  ! CLIC
  !	Fill in the display data buffers from current index.
  !	arg : 'A' all scans in current index
  !	      'N' next scan in current index
  !---------------------------------------------------------------------
  character(len=*) :: arg           !
  logical :: sort                   !
  logical :: init                   !
  logical :: error                  !
  ! Global
  include 'clic_constant.inc'
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: end, corr, auto, flag, noloop, ant_present
  integer :: i, ib, ix, iy, ibase, iband, ipol, istokes, jb, ja
  integer :: ir, jw1, jw2,  nnn, k_ident
  integer :: nfl, itri, iant, kb, lb
  real*4 :: vtemp(4,3,mbox), wtemp(4,3,mbox), time_max
  real*4 :: vtemp_stokes(4,3,4,mbox), wtemp_stokes(4,3,4,mbox)
  character(len=80) :: ch
  integer :: i_loop
  integer :: r_pol, code_stokes_1, code_stokes_2, pol_scan
  logical :: stokes_required, stokes_computed, needed, stokes_correct
  logical :: pol_linear, pol_antenna, direct
  real*4  :: fw(mnbas,mbox),w(mnbas,mbox),wp
  complex :: z(mnbas,mbox),idx,idy,jdx,jdy
  ! Function
  logical :: down_antenna, down_baseline, down_channel, doit
  logical :: auto_data, corr_data, zero_average, unused, skip
  logical :: do_get_data, header_data, any_corr, any_auto
  !
  integer(kind=address_length) :: ko, kw,  data_in, ipr
  integer(kind=address_length) :: ip0, ipk, ipkc, ipkl, ipx, ipy, ipw, ipu, ips, ipi, kin, kr
  integer(kind=address_length) :: ip_data
  integer(kind=data_length)    :: ldata_in,  h_offset, c_offset, l_offset
  integer :: ignored(0:2)
  integer :: iv, im, is, mdump, nout, iseq, ibb
  integer :: iaver, naver
  logical :: proceed
  !------------------------------------------------------------------------
  !     Code:
  iseq = 0 
  naver = 0
  flag = .false.
  !
  ! Verify if any input file
  call check_input_file(error)
  if (error) return
  !
  call check_index(error)
  if (error) return
  !
  ! Loop on current index
  end = .false.
  skip = .false.
  time_max = 0.
  !
  if (arg.eq.'COMPRESS') then
    time_max = -1.
  endif
  if (arg.eq.'NEXT') then
    call get_next(end,error)
    if (error) return
    if (end) then
      call message(8,3,'READ_DATA','End of current index')
      return
    endif
    goto 100
  elseif (arg.eq.'CURRENT') then
    call get_num(r_xnum,error)
    if (error) return
    end = .false.
    goto 100
  elseif (arg.ne.'ALL' .and. arg.ne.'COMPRESS'   &
    .and. arg.ne.'FIRST') then
    read(arg(1:lenc(arg)),*,err=999) nnn
    call get_sub(nnn,0,error)
    if (error) return
    end = .false.
    goto 100
  endif
  if (do_spec.or.s_average.gt.1.or. &
     (i_stokes(1).ne.code_stokes_none.and.&
      (i_base(1).lt.0.or.do_corrected))) then
    call get_first(.true.,error)
  else
    call get_first(.false.,error)
  endif
  if (error) return
  if (arg.eq.'FIRST') end = .false.
  !
100 continue
  !
  ! Initialize
  if (init) then
    ip0 = gag_pointer(data_x,memory)
    call init_data(m_data*m_boxes,memory(ip0),0)
    ip0 = gag_pointer(data_y,memory)
    call init_data(m_data*m_boxes,memory(ip0),blank4)
    ip0 = gag_pointer(data_w,memory)
    call init_data(m_data*m_boxes,memory(ip0),0)
    ip0 = gag_pointer(data_i,memory)
    call init_data(m_data*m_boxes,memory(ip0),0)
    ip0 = gag_pointer(data_u,memory)
    call init_data(m_data*m_boxes,memory(ip0),0)
    ip0 = gag_pointer(data_r,memory)
    call init_data(m_data*m_boxes,memory(ip0),0)
    do_get_data = .false.
    any_corr = .false.
    any_auto = .false.
    do i = 1, n_boxes
      n_data(i) = 0
      do iv=1,4
        do im=1,3
          wtemp(iv,im,i) = 0
          vtemp(iv,im,i) = 0
          do is=1,4
            wtemp_stokes(iv,im,is,i) = 0
            vtemp_stokes(iv,im,is,i) = 0
          enddo
        enddo
      enddo
      f_sres(i) = .false.
      f_bres(i) = .false.
      ix = i_x(k_x(i))
      iy = i_y(k_y(i))
      do_get_data = do_get_data   &
        .or.(.not.header_data(ix))   &
        .or.(.not.header_data(iy))
      any_corr = any_corr &
        .or.corr_data(ix,iy)
      any_auto = any_auto &
        .or.auto_data(ix,iy)
    enddo
    do  i=1, m_ident
      ch_ident (i) = ' '
    enddo
    n_ident = 0
    k_ident = 0
    zero_average = .true.
    do i=0,2
      ignored(i) = 0
    enddo
  endif
  !
  ! Do not use logics provided by "do_get_data" anymore, ie always access IPB file
  ! even to plot variables stored in the HPB file -- because the flags are in the
  ! IPB! 05-05-2004
  if (.not.skip_flag) do_get_data = .true.
  !
  ! Stokes parameter checks
  ! Observation frame deduced from first antenna first baseband
  ! Will not handle "mixed" cases. 
  stokes_required = .false.  
  stokes_computed = .false.
  stokes_correct = .false.
  if (n_stokes.gt.1.or.i_stokes(1).ne.code_stokes_none) then
    stokes_required = .true.
    call message(6,1,'READ_DATA','Stokes parameter required')
    !
    r_pol = r_mappol(1,1)
    if (r_pol.eq.code_polar_h.or.r_pol.eq.code_polar_v) then
      pol_linear = .true.
      pol_antenna = .true.
      code_stokes_1 = code_stokes_vh
      code_stokes_2 = code_stokes_hh
    elseif (r_pol.eq.code_polar_x.or.r_pol.eq.code_polar_x) then
      pol_linear = .true.
      pol_antenna = .false.
      code_stokes_1 = code_stokes_yx
      code_stokes_2 = code_stokes_xx
    elseif (r_pol.eq.code_polar_r.or.r_pol.eq.code_polar_l) then
      pol_linear = .false.
      pol_antenna = .true.
      code_stokes_1 = code_stokes_lr
      code_stokes_2 = code_stokes_rr
    elseif (r_pol.eq.code_polar_d.or.r_pol.eq.code_polar_s) then
      pol_linear = .false.
      pol_antenna = .false.
      code_stokes_1 = code_stokes_sd
      code_stokes_2 = code_stokes_dd
    endif 
!!   print *,"n_stokes",n_stokes,"i_stokes",i_stokes(1:n_stokes),"code_1",&
!!          code_stokes_1,"code_2",code_stokes_2 
   if (any((i_stokes(1:n_stokes).lt.code_stokes_1).or. &
           (i_stokes(1:n_stokes).gt.code_stokes_2)).or. &
           i_base(1).lt.0.or.do_corrected) then
      stokes_computed = .true.
      iseq = 0
      call message(6,1,'READ_DATA','Stokes parameter needs to be computed')
    else
      call message(6,1,'READ_DATA','Stokes parameter is native')
    endif
  endif
  if (stokes_required.or.do_leakage) then
     stokes_correct = .true.
  endif
  do while (.not.end)
    !
    ! Read data
    unused = .false.
    nfl = 0
    if (n_ident .eq. 0) then
      n_ident = 1
      ch_ident(n_ident) = r_sourc
      k_ident = 1
    elseif (ch_ident(k_ident) .ne. r_sourc) then
      k_ident = 0
      do i=1, n_ident
        if (ch_ident(i) .eq. r_sourc) then
          k_ident = i
        endif
      enddo
      if (k_ident.eq.0) then
        if (n_ident.lt.m_ident) then
          n_ident = n_ident+1
          ch_ident(n_ident) = r_sourc
          k_ident = n_ident
        else
          ch_ident(n_ident) = 'Other'
          k_ident = n_ident
        endif
      endif
    endif
    if (s_average.gt.1) then
      proceed = k_ident.ne.iaver.and.naver.gt.0
      if (proceed) then  
        do ib=1, n_boxes
          call aver(ib, vtemp(1,1,ib), wtemp(1,1,ib),   &
            k_ident, r_num, dh_dump, error)
          if (error) return
        enddo
        naver = 0
      endif
    endif
    if (do_get_data) call get_data (ldata_in,data_in,error)
    if (error) return
    !
    !
    !cc+ 2003-11-11
    if (time_max.lt.0) then
      ip_data = gag_pointer(data_in,memory)
      mdump = r_ndump
      call compress(time_max, 7.5, memory(ip_data),nout,error)
      if (error) goto 999
      r_ndump = nout
      call loose_data
    endif
    !cc- 2003-11-11
    call check_cal(skip)
    if (skip) then
      ignored(r_lmode) = ignored(r_lmode) + 1
      skip = .false.
      goto 180
    endif
    if (do_pass.and.any_corr) then
      call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
        r_lntch, passc, passl, error)
      if (error) return
    endif
    if (do_spidx.and.any_corr) then
      call set_spidx(r_nsb,r_nband,r_nbas+r_ntri,   &
        r_lntch, spidc, spidl, r_spidx, error)
    endif
    if (do_pass.and.any_corr) then
      if (do_spidx) then
        where (passc.ne.blankc)
          factc = passc * spidc
        else where
          factc = blankc
        end where
        where (passl.ne.blankc)
          factl = passl * spidl
        else where
          factl = blankc
        end where
      else
        factc = passc
        factl = passl
      endif
    elseif (do_spidx.and.any_corr) then
      factc = spidc
      factl = spidl
    endif
    if (r_presec(atmon_sec).and.any_corr) call set_corr(error)
    !
    ! Compute side band averages (for averaging sidebands), 
    ! using average record.
    ! Only if all switches are in direct mode
    direct = all(r_polswitch(1:r_nant,:).eq.0)
    if (do_get_data) then
      kin = gag_pointer(data_in,memory)
      call spectral_dump(kr,0,0)
      ipk = kin + h_offset(kr)
      call decode_header (memory(ipk))
      call set_scaling(error)
      if (error) return
      if (r_lmode.eq.1.and.any_corr.and.direct) then ! correlation only ...
        if (k_average.eq.1) then
          call line_average (r_lntch,r_nbas,r_lnsb,data_in,   &
                spidl,zero_average,error)
        else
          call cont_average (r_nband,r_nbas,data_in,   &
                spidc,zero_average,error)
        endif
        if (error) return
      endif
    endif
    !
    ! Check
    if (stokes_computed) then
      iseq = iseq+1
      if (iseq.eq.1) pol_scan=r_scan
      if (r_scan.ne.pol_scan.and.iseq.ne.16) then
        write(ch,'(a,i0,a,i0,a,i0,a)') 'Scan ',r_scan,' (num ',r_num,  &
                                ') does not match polarisation scan (',  &
                                pol_scan,')'
        call message(8,3,'READ_DATA',ch(1:lenc(ch)))
        error = .true.
        return
      endif
    endif
    !
    !
    ! Loop on Boxes
    do ib = 1, n_boxes
      ix = i_x(k_x(ib))
      iy = i_y(k_y(ib))
      corr = corr_data(ix,iy)
      auto = auto_data(ix,iy)
      if (auto.and.r_lmode.eq.1) then
        unused = .true.
        goto 150
      elseif (corr.and.r_lmode.eq.2) then
        unused = .true.
        goto 150
      endif
      ibase = i_base(k_base(ib))
      ipol = k_polar(ib)
      itri = ibase-mnbas
      iant = -ibase
      if (phys_base.and.skip_flag) iant = i_ant(k_base(ib))
      if (ibase.le.mnbas .and. ibase.gt.r_nbas) then
        call message(6,3,'READ_DATA',   &
          'Baseline '//cbas(ibase)//' not available in data')
        error = .true.
        return
      elseif (itri.gt.0 .and. itri.gt.r_ntri) then
        call message(6,3,'READ_DATA',   &
          'Triangle '//ctri(itri)//' not available in data')
        error = .true.
        return
      endif
      if (iant.gt.r_nant.and..not.phys_base) then
        write(ch,'(a,i0,a)') 'Antenna ',iant,   &
          ' not available in data'
        call message(6,3,'READ_DATA',ch(1:lenc(ch)))
        error = .true.
        return
      endif
      iband = i_band(k_band(ib))
      kb = k_subb(ib)
      lb = l_subb(kb)
      if (corr .or. auto) then
        jw1 = iw1(kb)
        jw2 = iw2(kb)
        ! one does not check  the bandwith changes ...
        call check_subb(n_subb,.true.,error)
        if (error) return
      endif
      !
      ! Check if data needed
      needed = .true.
      if (stokes_required.and..not.stokes_computed) then
        if (i_stokes(k_stokes(ib)).ne. &
            r_code_stokes(ibase,mod(i_subb(1,kb),mbands))) then
          needed = .false.
        endif
      endif
      !
      ! Loop on records
      noloop = .false.
      do i_loop = 1, n_loop
        do ir = rec_1(i_loop), min(r_ndump,rec_2(i_loop)),   &
            rec_3(i_loop)
          ! Read only the average record if needed
          if (noloop) goto 150
          noloop = ((corr.or.auto).and.(i_subb(1,kb).gt.mbands))   &
            .or. (i_average.eq.1) .or.stokes_computed  ! scan averaging
          if (do_get_data) then
            if (noloop) then
              call spectral_dump(kr,iant,ibase)
            else
              kr = ir
            endif
            ipk = kin + h_offset(kr)
            ipkc = kin + c_offset(kr)
            ipkl = kin + l_offset(kr)
            call decode_header (memory(ipk))
            flag = .false.
            ! count flagged records
            if (ibase.lt.0) then
              flag = flag .or. down_antenna(abs(ibase))
            else
              flag = flag .or. down_baseline(ibase)
              do i=1,lb
                flag = flag .or.   &
                  down_channel(ibase,i_subb(i,kb))
              enddo
            endif
          else
            dh_integ = max(r_time,1.)
            dh_obs = r_dobs
            dh_utc = r_ut/pi*43200.
            dh_dump = 1.0
          endif
          !
          ! Get the desired value
          if (needed) then
            if (stokes_computed.and.ibase.gt.0) then
              select case (r_code_stokes(ibase,mod(i_subb(1,kb),mbands))) 
              case (code_stokes_hh)
                istokes = 1
              case (code_stokes_vv)
                istokes = 2 
              case (code_stokes_hv)
                istokes = 3 
              case (code_stokes_vh)
                istokes = 4 
              end select
              call r4tor4(vtemp_stokes(1,1,istokes,ib),vtemp(1,1,ib),12)
              call r4tor4(wtemp_stokes(1,1,istokes,ib),wtemp(1,1,ib),12)
            endif
            if (ibase.lt.0) then
              if (stokes_computed) then
                do jb = 1, r_nbas
                  if ((.not.down_baseline(jb)) .and. &
                      (i_stokes(k_stokes(ib)).eq. &
                       r_code_stokes(jb,mod(i_subb(1,kb),mbands)))) then
                    call zrecord(   &
                      r_nsb, r_nband, r_nbas+r_ntri, r_lntch,   &
                      memory(ipkc), memory(ipkl), factc, factl, jb, iband,   &
                      lb, i_subb(1,kb), jw1, jw2, z(jb,ib),  &
                      fw(jb,ib), wp,error)
                    if (error) return
                    w(jb,ib) = fw(jb,ib)
                  endif
                enddo 
              else
                ant_present = .false.
                do ja=1, r_nant
                  if (r_kant(ja).eq.iant) ant_present =.true.
                enddo
                if (.not.skip_flag) ant_present = .true.
                if (ant_present) then
                  call arecord (   &
                    r_nsb, r_nband, r_nbas, r_lntch,   &
                    memory(ipkc), memory(ipkl), factc, factl,   &
                    -ibase,iband,ipol,k_baseband(ib),k_if(ib), &
                    lb,i_subb(1,kb),jw1,jw2,ix,iy,  &
                    vtemp(1,1,ib),wtemp(1,1,ib),.false.,error)
                else
                  wtemp(2,2,ib) = 0
                endif
              endif
            else
              call brecord (   &
                r_nsb, r_nband, r_nbas+r_ntri, r_lntch,   &
                memory(ipkc), memory(ipkl), factc, factl,   &
                ibase,iband,ipol,k_baseband(ib),k_if(ib), &
                lb,i_subb(1,kb),jw1,jw2,ix,iy,   &
                vtemp(1,1,ib),wtemp(1,1,ib),error)
              if (stokes_correct) then
                if (stokes_required) then
                  call correct_stokes(i_stokes(k_stokes(ib)), &
                                    vtemp(1,1,ib),wtemp(1,1,ib),error)
                else
                  call correct_stokes(r_code_stokes(mod(i_subb(1,kb),mbands),1), &
                                    vtemp(1,1,ib),wtemp(1,1,ib),error)
                endif
              endif
            endif
            if (stokes_computed.and.ibase.gt.0) then
              select case (r_code_stokes(ibase,mod(i_subb(1,kb),mbands))) 
              case (code_stokes_hh)
                istokes = 1
              case (code_stokes_vv)
                istokes = 2 
              case (code_stokes_hv)
                istokes = 3 
              case (code_stokes_vh)
                istokes = 4 
              end select
              call r4tor4(vtemp(1,1,ib),vtemp_stokes(1,1,istokes,ib),12)
              call r4tor4(wtemp(1,1,ib),wtemp_stokes(1,1,istokes,ib),12)
            endif
          endif
          if (error) return
          if (((i_average.eq.0) .or.   &
            (i_average.eq.2 .and. wtemp(3,1,ib).ge.t_average))   &
            .and. .not.stokes_computed)            &
            then
            call aver(ib, vtemp(1,1,ib), wtemp(1,1,ib),   &
              k_ident, r_num, dh_dump, error)
            if (error) return
          endif
        enddo
      enddo                    ! end loop on records
      if (flag) nfl = nfl + 1
150   continue
    enddo
    if (unused) ignored(r_lmode) = ignored(r_lmode) + 1
    ! End of scan
180 if (nfl.ne.0) then
      write(ch,'(i4,a)') nfl,' records flagged'
      call message(4,2,'READ_DATA',ch(1:lenc(ch)))
      nfl = 0
    endif
    ! Data ignored : check ^C and 'A' argument
    if (arg.ne.'ALL' .and. arg.ne.'COMPRESS') goto 200
    if (sic_ctrlc()) then
      error = .true.
      goto 200
    endif
    if (s_average.gt.1) then
      naver = naver+1
      if (naver.eq.1) then
        iaver = k_ident
      endif
      if (naver.ge.s_average) then  
        do ib=1, n_boxes
          call aver(ib, vtemp(1,1,ib), wtemp(1,1,ib),   &
            k_ident, r_num, dh_dump, error)
          if (error) return
        enddo
        naver = 0
      endif
    else
      if (stokes_computed) then
        doit = .false.
        if (iseq.eq.16) then
          !
          ! End of scan, compute required stokes parameter
          do ib=1, n_boxes
            ibase = i_base(k_base(ib))
            if (ibase.gt.0) then
              kb = k_subb(ib)
              lb = l_subb(kb)
              do is=1,lb
              ibb = r_bb(mod(i_subb(is,kb),mrlband))
              enddo
              idx=r_dx(r_iant(ibase),ibb)
              idy=r_dy(r_iant(ibase),ibb)
              jdx=r_dx(r_jant(ibase),ibb)
              jdy=r_dy(r_jant(ibase),ibb)
              call stokes_visi(i_stokes(k_stokes(ib)),&
                           idx,idy,jdx,jdy, &
                           vtemp_stokes(1,1,1,ib),wtemp_stokes(1,1,1,ib), &
                           vtemp(1,1,ib),wtemp(1,1,ib))
              ix = i_x(k_x(ib))
              iy = i_y(k_y(ib))
              !
              ! Reset stokes buffers
              do iv=1,4
                do im=1,3
                  do is=1,4
                    wtemp_stokes(iv,im,is,ib) = 0
                    vtemp_stokes(iv,im,is,ib) = 0
                  enddo
                enddo
              enddo
            else
              !
              ! Compute antenna gain
               call arecord_compute(z(1,ib),w(1,ib),    &
                 -ibase,iband,ipol,k_baseband(ib),k_if(ib), &
                 ix,iy,  &
                 vtemp(1,1,ib),wtemp(1,1,ib),error)
            endif
          enddo
          !
          ! Data are ready to be processed further
          doit = .true.
          iseq = 0
        endif
      else
        doit = .true.
      endif
      do ib=1, n_boxes
        if ((i_average.ne.0.and.doit) .and. wtemp(3,1,ib).gt.0) then
          call aver(ib, vtemp(1,1,ib), wtemp(1,1,ib),   &
            k_ident, r_num, dh_dump, error)
          if (error) return
        endif
      enddo
      if (i_average.eq.0.and.stokes_computed.and.doit) then
        do ib=1, n_boxes
          if (wtemp(3,1,ib).gt.0) then
            call aver(ib, vtemp(1,1,ib), wtemp(1,1,ib),   &
              k_ident, r_num, dh_dump, error)
            if (error) return
          endif
        enddo
      endif
    endif
    call get_next(end,error)
    if (error) return
  enddo
  !
  ! If multiple scan average, plot pending data
  if (s_average.gt.0.and.naver.ne.0) then
    do ib=1, n_boxes
      if (i_average.ne.0 .and. wtemp(3,1,ib).gt.0) then
        call aver(ib, vtemp(1,1,ib), wtemp(1,1,ib),   &
          k_ident, r_num, dh_dump, error)
        if (error) return
      endif
    enddo
  endif
  !
  ! Optionnally bin data
200 continue
  if (ignored(1).ne.0) then
    write(ch,'(i4,a)') ignored(1),' ignored correlations'
    call message(4,2,'READ_DATA',ch(1:lenc(ch)))
  endif
  if (ignored(2).ne.0) then
    write(ch,'(i4,a)') ignored(2),' ignored autocorrelations'
    call message(4,2,'READ_DATA',ch(1:lenc(ch)))
  endif
  if (do_bin) then
    call bin(error)
    if (error) return
  endif
  !
  ! Order data in each box according to x_data ...	! z_data not sorted
  if (sort) then
    kw = m_data
    ko = 0                     ! Was missing, presumably
    ipx = gag_pointer(data_x,memory)
    ipy = gag_pointer(data_y,memory)
    ipw = gag_pointer(data_w,memory)
    ipi = gag_pointer(data_i,memory)
    ipu = gag_pointer(data_u,memory)
    ipr = gag_pointer(data_r,memory)
    ips = gag_pointer(data_s,memory)
    do ib=1, n_boxes
      call gr4_trie_i4(memory(ipx+ko),memory(ips),   &
        n_data(ib),error)
      if (error) return
      call gr4_sort(memory(ipy+ko),memory(ips+kw),   &
        memory(ips),n_data(ib))
      call gr4_sort(memory(ipw+ko),memory(ips+kw),   &
        memory(ips),n_data(ib))
      call gr4_sort(memory(ipi+ko),memory(ips+kw),   &
        memory(ips),n_data(ib))
      call gr4_sort(memory(ipu+ko),memory(ips+kw),   &
        memory(ips),n_data(ib))
      call gr4_sort(memory(ipr+ko),memory(ips+kw),   &
        memory(ips),n_data(ib))
      ko = ko+kw               ! Was also missing, I presume
    enddo
    sorted = .true.
  else
    sorted = .false.
  endif
  !
  ! Process phases
  call reset_phases
  !
  ! Redimension variables
  call resetvar(error)
  return
  !
999 ch = 'Error decoding '//arg
  call message(8,3,'READ_DATA',ch)
  error = .true.
  return
end subroutine read_data
!
subroutine stokes_visi(istoke,idx,idy,jdx,jdy,vt_stokes,wt_stokes,vt,wt)
  use gkernel_interfaces
  use gio_params
  integer, intent(in)         :: istoke
  complex, intent(in)         :: idx
  complex, intent(in)         :: idy
  complex, intent(in)         :: jdx
  complex, intent(in)         :: jdy
  real(kind=4), intent(inout) :: vt_stokes(4,3,4)
  real(kind=4), intent(in)    :: wt_stokes(4,3,4)
  real(kind=4), intent(out)   :: vt(4,3)
  real(kind=4), intent(out)   :: wt(4,3)
  !
  include 'clic_xy_code.inc'
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  !
  ! Local
  logical :: error
  integer :: iv,im,is
  real    :: parangle,wv,sin2chi,cos2chi,s_i(4,3),w_i(4,3)
  complex :: dummy, est_i(3)
  ! Code
  ! 
  do iv=3,4
    do im=1,3
      do is=1,4
        if (wt_stokes(iv,im,is).gt.0) then
          vt_stokes(iv,im,is) = vt_stokes(iv,im,is)/wt_stokes(iv,im,is)
        endif
      enddo
    enddo
  enddo
  if (do_corrected) then
    ! Stokes I: [HH+VV]/2
    do iv=3,4
      do im=1,3
        s_i(iv,im)=(vt_stokes(iv,im,1)+vt_stokes(iv,im,2))/2
        w_i(iv,im)=(wt_stokes(iv,im,1)+wt_stokes(iv,im,2))/2
      enddo
    enddo
    do im=1,3
      est_i(im)=cmplx(s_i(3,im),s_i(4,im))
    enddo
  endif
  select case (istoke)
  case (code_stokes_ratio) 
    ! Stokes ratio: [HH-VV]/[HH+VV]
    do iv=1,2
      do im=1,3
        vt(iv,im)=(vt_stokes(iv,im,1)+vt_stokes(iv,im,2))/2
        wt(iv,im)=(wt_stokes(iv,im,1)+wt_stokes(iv,im,2))/2
      enddo
    enddo
    do iv=3,4
      do im=1,3
        vt(iv,im)=(abs(vt_stokes(iv,im,1))-abs(vt_stokes(iv,im,2))) / &
                  (abs(vt_stokes(iv,im,1))+abs(vt_stokes(iv,im,2)))
        wt(iv,im)=(wt_stokes(iv,im,1)+wt_stokes(iv,im,2))/2
      enddo
    enddo
  case (code_stokes_i) 
    ! Stokes I: [HH+VV]/2
    do iv=3,4
      do im=1,3
        vt(iv,im)=(vt_stokes(iv,im,1)+vt_stokes(iv,im,2))/2
        wt(iv,im)=(wt_stokes(iv,im,1)+wt_stokes(iv,im,2))/2
      enddo
    enddo
  case (code_stokes_q) 
    ! Stokes Q: [cos(2chi)HH -sin(2chi)HV-sin(2chi)VH-cos(2chi)VV]/2
    call value(xy_parang,dummy,1,1,1,1,1,parangle,wv,error)
    cos2chi = cos(2*parangle)
    sin2chi = -sin(2*parangle)
    do iv=1,1
      do im=1,3
        vt(iv,im)=(vt_stokes(iv,im,1)+vt_stokes(iv,im,2) &
                  +vt_stokes(iv,im,3)+vt_stokes(iv,im,4))/4
        wt(iv,im)=(wt_stokes(iv,im,1)+wt_stokes(iv,im,2) &
                  +wt_stokes(iv,im,3)+wt_stokes(iv,im,4))/4
      enddo
    enddo
    do iv=3,4
      do im=1,3
!        vt(iv,im)=(vt_stokes(iv,im,1)-vt_stokes(iv,im,2))/ &
!                  (vt_stokes(iv,im,1)+vt_stokes(iv,im,2))
        vt(iv,im)=(cos2chi*vt_stokes(iv,im,1)-cos2chi*vt_stokes(iv,im,2) &
                  -sin2chi*vt_stokes(iv,im,3)-sin2chi*vt_stokes(iv,im,4))/2
        wt(iv,im)=(cos2chi**2*wt_stokes(iv,im,1)+cos2chi**2*wt_stokes(iv,im,2) &
                  +sin2chi**2*wt_stokes(iv,im,3)+sin2chi**2*wt_stokes(iv,im,4))/2
      enddo
    enddo
  case (code_stokes_u)
    ! Stokes U: [sin(2chi)HH +cos(2chi)HV+cos(2chi)VH-sin(2chi)VV]/2
    call value(xy_parang,dummy,1,1,1,1,1,parangle,wv,error)
    sin2chi = sin(2*parangle)
    cos2chi = cos(2*parangle)
    do iv=1,2
      do im=1,3
        vt(iv,im)=(vt_stokes(iv,im,1)+vt_stokes(iv,im,2))/2
        wt(iv,im)=(wt_stokes(iv,im,1)+wt_stokes(iv,im,2))/2
      enddo
    enddo
    do iv=3,4
      do im=1,3
        vt(iv,im)=(sin2chi*vt_stokes(iv,im,1)-sin2chi*vt_stokes(iv,im,2) &
                  +cos2chi*vt_stokes(iv,im,3)+cos2chi*vt_stokes(iv,im,4))/2
        wt(iv,im)=(sin2chi**2*wt_stokes(iv,im,1)+sin2chi**2*wt_stokes(iv,im,2) &
                  +cos2chi**2*wt_stokes(iv,im,3)+cos2chi**2*wt_stokes(iv,im,4))/2
      enddo
    enddo
  case (code_stokes_v)
    ! Stokes V: [-iHV+iVH]
!!  case (code_stokes_leakage) 
    ! Leakage: HV+Qsin(2chi)-Ucos(2chi)-iV
    !          VH+Qsin(2chi)-Ucos(2chi)+iV
  case (code_stokes_hv)
    !
    if (do_leakage) then
      call value(xy_parang,dummy,1,1,1,1,1,parangle,wv,error)
      cos2chi = cos(2*parangle)
      sin2chi = sin(2*parangle)
      do iv=1,2
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,3) 
          wt(iv,im)=wt_stokes(iv,im,3)
        enddo
      enddo
      do iv=3,4
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,3) &
                   +r_stokes_q*cos2chi-r_stokes_u*sin2chi
          wt(iv,im)=wt_stokes(iv,im,3)
          if (r_stokes_i.ne.0) then
            vt(iv,im)=vt(iv,im)/r_stokes_i
            wt(iv,im)=wt(iv,im)/r_stokes_i
          endif
        enddo
      enddo
    endif
    if (do_corrected) then
      do iv=1,2
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,3) 
          wt(iv,im)=wt_stokes(iv,im,3)
        enddo
      enddo
      do iv=3,3
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,3) &
                   -(real(est_i(im)*(idy+conjg(jdx))))
          wt(iv,im)=wt_stokes(iv,im,3)+w_i(iv,im)*real(idy+jdx)
        enddo
      enddo
      do iv=4,4
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,3) &
                   -(aimag(est_i(im)*(idy+conjg(jdx))))
          wt(iv,im)=wt_stokes(iv,im,3)+w_i(iv,im)*aimag(idy-jdx)
        enddo
      enddo
    endif
  case (code_stokes_vh)
    !
    if (do_leakage) then
      call value(xy_parang,dummy,1,1,1,1,1,parangle,wv,error)
      cos2chi = cos(2*parangle)
      sin2chi = -sin(2*parangle)
      do iv=1,4
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,4) &
                   +r_stokes_q*cos2chi-r_stokes_u*sin2chi
          wt(iv,im)=wt_stokes(iv,im,4)
          if (r_stokes_i.ne.0) then
            vt(iv,im)=vt(iv,im)/r_stokes_i
            wt(iv,im)=wt(iv,im)/r_stokes_i
          endif
        enddo
      enddo
    endif
    if (do_corrected) then
      do iv=1,2
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,4) 
          wt(iv,im)=wt_stokes(iv,im,4)
        enddo
      enddo
      do iv=3,3
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,4) &
                   -(real(est_i(im)*(idx+conjg(jdy))))
          wt(iv,im)=wt_stokes(iv,im,4)+w_i(iv,im)*real(idx+jdy)
        enddo
      enddo
      do iv=4,4
        do im=1,3
          vt(iv,im)=vt_stokes(iv,im,4) &
                   -(aimag(est_i(im)*(idx+conjg(jdy))))
          wt(iv,im)=wt_stokes(iv,im,4)+w_i(iv,im)*aimag(idx-jdy)
        enddo
      enddo
    endif
  case default
  end select 
  do iv=3,4
    do im=1,3
      if (wt(iv,im).gt.0) then
       vt(iv,im) = vt(iv,im)*wt(iv,im)
      endif
    enddo
  enddo
  return
end subroutine stokes_visi
!
subroutine correct_stokes(istoke,vt,wt,error)
  use gkernel_interfaces
  use gio_params
  integer, intent(in)         :: istoke
  real(kind=4), intent(inout)   :: vt(4,3)
  real(kind=4), intent(inout)   :: wt(4,3)
  logical :: error
  !
  include 'clic_xy_code.inc'
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  !
  ! Local
  integer :: iv, im
  real    :: parangle,wv,sin2chi,cos2chi
  complex :: dummy
  !
  do iv=3,4
    do im=1,3
      if (wt(iv,im).gt.0) then
        vt(iv,im) = vt(iv,im)/wt(iv,im)
      endif
    enddo
  enddo
  if (do_leakage) then
    call value(xy_parang,dummy,1,1,1,1,1,parangle,wv,error)
    sin2chi = sin(2*parangle)
    cos2chi = cos(2*parangle)
  endif
  select case(istoke)
  case(code_stokes_vv)
    if (do_leakage) then
      do iv=3,4
        do im=1,3
          if (r_stokes_i.ne.0) &
          vt(iv,im)=vt(iv,im)/(1+cos2chi*r_stokes_q/r_stokes_i+sin2chi*r_stokes_u/r_stokes_i)
        enddo
      enddo
    endif
  case(code_stokes_hh)
    if (do_leakage) then
      do iv=3,4
        do im=1,3
          if (r_stokes_i.ne.0) &
          vt(iv,im)=vt(iv,im)/(1-cos2chi*r_stokes_q/r_stokes_i-sin2chi*r_stokes_u/r_stokes_i)
        enddo
      enddo
    endif
  case(code_stokes_vh)
    if (do_leakage) then
      do im=1,3
        if (r_stokes_i.ne.0) then
          vt(3,im)=(vt(3,im)+sin2chi*r_stokes_q-cos2chi*r_stokes_u)/r_stokes_i
          vt(4,im)=(vt(4,im))/r_stokes_i
          wt(2,im)=wt(2,im)*r_stokes_i**2 ! wt(2,2) used for plots
          wt(3,im)=wt(3,im)*r_stokes_i**2
          wt(4,im)=wt(4,im)*r_stokes_i**2
        endif
      enddo
    endif
  case(code_stokes_hv)
    if (do_leakage) then
      do im=1,3
        if (r_stokes_i.ne.0) then
          vt(3,im)=(vt(3,im)+sin2chi*r_stokes_q-cos2chi*r_stokes_u)/r_stokes_i
          vt(4,im)=(vt(4,im))/r_stokes_i
          wt(2,im)=wt(2,im)*r_stokes_i**2 ! wt(2,2) used for plots
          wt(3,im)=wt(3,im)*r_stokes_i**2
          wt(4,im)=wt(4,im)*r_stokes_i**2
        endif
      enddo
    endif
  case default
  end select
  do iv=3,4
    do im=1,3
      if (wt(iv,im).gt.0) then
        vt(iv,im) = vt(iv,im)*wt(iv,im)
      endif
    enddo
  enddo
  return
end subroutine correct_stokes
!
subroutine init_data(n,x,v)
  !---------------------------------------------------------------------
  ! CLIC
  !     Initialise array X(N) with variable V
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: x(n)                      !
  real :: v                         !
  ! Local
  integer :: i
  !------------------------------------------------------------------------
  ! Code:
  do i=1, n
    x(i) = v
  enddo
  return
end subroutine init_data
!
subroutine brecord (qsb, qband, qbt, qntch,   &
    datac, datal, passc, passl,   &
    ibase,iband,ipol,kbb,kif,nch,ich,jw1,jw2,ix,iy,vt,wt,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Get baseline-based parameters to be plotted as a function of
  !     a time-like variable
  !     QSB     INTEGER   Number of sidebands (2)
  !     QBAND   INTEGER   Number of temporal data
  !     QBT     INTEGER   Number of baseline+triangles
  !     QNTCH   INTEGER   Number of channels (in total per baseline)
  !     DATAC(QBAND,QSB,QBT)  COMPLEX  Temporal data
  !     DATAL(QNTCH,QSB,QBT)  COMPLEX  Spectral data
  !     PASSC(QBAND,QSB,QBT)  COMPLEX  PassBand of temporal data
  !     PASSL(QNTCH,QSB,QBT)  COMPLEX  PassBand of spectral data
  !     IBASE   INTEGER   Baseline number
  !     IBAND   INTEGER   Subband number
  !     ICH1    INTEGER   First subband
  !     ICH2    INTEGER   Last subband
  !     IX      INTEGER   X variable type
  !     IY      INTEGER   Y variable type
  !     JW1,JW2 INTEGER   Lowest and Highest channel in window subband
  !---------------------------------------------------------------------
  integer :: qsb                    !
  integer :: qband                  !
  integer :: qbt                    !
  integer :: qntch                  !
  complex :: datac(qband,qsb,qbt)   !
  complex :: datal(qntch,qsb,qbt)   !
  complex :: passc(qband,qsb,qbt)   !
  complex :: passl(qntch,qsb,qbt)   !
  integer :: ibase                  !
  integer :: iband                  !
  integer :: ipol                   ! Polarization
  integer :: kbb                    ! Baseband backpointer
  integer :: kif                    ! IF backpointer
  integer :: nch                    !
  integer :: ich(nch)               !
  integer :: jw1                    !
  integer :: jw2                    !
  integer :: ix                     !
  integer :: iy                     !
  real*4 :: vt(4,3)                 !
  real*4 :: wt(4,3)                 !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: iv, im
  real :: vadd(4), wadd(4), wmult(3), t
  ! Functions
  logical :: down_baseline, corr_data
  !------------------------------------------------------------------------
  ! Code:
  do im=1,3
    wmult(im) = 1.0
  enddo
  do iv=1,4
    vadd(iv) = 0.0
    wadd(iv) = 1.0
  enddo
  !
  ! Get data values if needed
  if (corr_data(ix,iy)) then
    wmult(2) = 0
    if (.not. down_baseline(ibase)) then
      call zrecord (   &
        r_nsb, r_nband, r_nbas+r_ntri, r_lntch,   &
        datac, datal, passc, passl, ibase, iband, &
        nch, ich, jw1, jw2, vadd(3), wmult(2), wmult(3), error)
      if (error) return
    endif
  endif
  call value(ix,vadd(3),ibase,iband,ipol,kbb,kif,vadd(1),wadd(1),error)
  call value(iy,vadd(3),ibase,iband,ipol,kbb,kif,vadd(2),wadd(2),error)
  t = dh_integ
  do im=1, 3
    do iv=1, 4
      vt(iv,im) = vt(iv,im) + vadd(iv)*wadd(iv)*wmult(im)*t
      wt(iv,im) = wt(iv,im) + wadd(iv)*wmult(im)*t
    enddo
  enddo
  return
end subroutine brecord
!
subroutine arecord (qsb, qband, qbas, qntch,   &
    datac, datal, passc, passl,   &
    iant, iband, ipol, kb, kif, nch, ich, jw1, jw2, ix, iy,   &
    vt, wt, phcorr,error)
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Get antenna-based parameters to be plotted from a record,
  !     as a function of a time-like variable.
  !     QSB     INTEGER   Number of sidebands (2)
  !     QBAND   INTEGER   Number of temporal data
  !     QBAS    INTEGER   Number of baselines
  !     QNTCH   INTEGER   Number of channels (in total per baseline)
  !     DATAC(QBAND,QSB,QBT)  COMPLEX  Temporal data
  !     DATAL(QNTCH,QSB,QBT)  COMPLEX  Spectral data
  !     PASSC(QBAND,QSB,QBT)  COMPLEX  PassBand of temporal data
  !     PASSL(QNTCH,QSB,QBT)  COMPLEX  PassBand of spectral data
  !     IANT    INTEGER   Antenna number
  !     IBAND   INTEGER   Subband number
  !     ICH1    INTEGER   First subband
  !     ICH2    INTEGER   Last subband
  !     IX      INTEGER   X variable type
  !     IY      INTEGER   Y variable type
  !     JW1,JW2 INTEGER   Lowest and Highest channel in window subband
  !     WPT     REAL      Positive weight
  !     WT      REAL      Total weight
  !     XT      REAL      X value
  !     YT      REAL      Y value
  !     TT      REAL      Signed integration time
  !     ZT      COMPLEX   Complex output
  !     PHCORR  LOGICAL   Correct amplitude for rms phase ?
  ! Call Tree
  !	SOLVE_POINT	...	FILL_VISI_POSI
  !	SOLVE_FOCUS	...	FILL_VISI_POSI
  !	...		READ_DATA
  !	SOLVE_FLUX
  !---------------------------------------------------------------------
  integer :: qsb                    !
  integer :: qband                  !
  integer :: qbas                   !
  integer :: qntch                  !
  complex :: datac(qband,qsb,qbas)  !
  complex :: datal(qntch,qsb,qbas)  !
  complex :: passc(qband,qsb,qbas)  !
  complex :: passl(qntch,qsb,qbas)  !
  integer :: iant                   !
  integer :: iband                  !
  integer :: ipol                   ! Polarization
  integer :: kb                     ! Baseband group
  integer :: kif                    ! IF group
  integer :: nch                    !
  integer :: ich(nch)               !
  integer :: jw1                    !
  integer :: jw2                    !
  integer :: ix                     !
  integer :: iy                     !
  real*4 :: vt(4,3)                 !
  real*4 :: wt(4,3)                 !
  logical :: phcorr                 !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  ! Functions
  logical :: down_antenna, down_baseline, auto_data, corr_data
  ! Local
  real*4 :: fw(mnbas), want(mnant)
  real*4 :: w(mnbas), copha, rms, wp, t
  complex :: z(mnbas), zant(mnant)
  integer :: ib, ibbb, iv, im
  real :: vadd(4), wadd(4), wmult(3)
  !------------------------------------------------------------------------
  ! Code:
  do im=1,3
    wmult(im) = 1.0
  enddo
  do iv=1,4
    vadd(iv) = 0.0
    wadd(iv) = 1.0
  enddo
  !
  ! Test for masks
  if (down_antenna(iant)) return
  !
  if (auto_data(ix,iy)) then
    call irecord (r_nband, r_nant, r_lntch, datac, datal,   &
      iant, iband, nch, ich, jw1, jw2, vadd(3),wmult(2),wmult(3))
  endif
  if (corr_data(ix,iy)) then
    do ib = 1, r_nbas
      if (down_baseline(ib)) then
        z(ib) = 0
        w(ib) = 0
      else
        call zrecord(   &
          r_nsb, r_nband, r_nbas+r_ntri, r_lntch,   &
          datac, datal, passc, passl, ib, iband,   &
          nch, ich, jw1, jw2, z(ib), fw(ib), wp,error)
        if (error) return
        if (phcorr) then
          ibbb = min(iband,2)
          rms = dh_rmspha(1,ibbb,ib)
          copha = exp(0.5*rms**2)
          z(ib) = z(ib)*copha
          fw(ib) = fw(ib)/copha**2
        endif
        w(ib) = fw(ib)
      endif
    enddo
    call antgain (z,w,zant,want)
    wmult(2) = want(iant)
    wmult(3) = want(iant)
    vadd(3) = real(zant(iant))
    vadd(4) = aimag(zant(iant))
  endif
  !
  call value(ix,vadd(3),-iant,iband,ipol,kb,kif,vadd(1),wadd(1),error)
  call value(iy,vadd(3),-iant,iband,ipol,kb,kif,vadd(2),wadd(2),error)
  if (error) return
  t = dh_integ
  do im=1, 3
    do iv=1, 4
      vt(iv,im) = vt(iv,im) + vadd(iv)*wadd(iv)*wmult(im)*t
      wt(iv,im) = wt(iv,im) + wadd(iv)*wmult(im)*t
    enddo
  enddo
  return
end subroutine arecord
!
subroutine arecord_compute (z,w,&
    iant, iband, ipol, kb, kif, ix, iy,   &
    vt, wt, error)
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Get antenna-based parameters to be plotted from a record,
  !     as a function of a time-like variable.
  !     IANT    INTEGER   Antenna number
  !     IBAND   INTEGER   Subband number
  !     ICH1    INTEGER   First subband
  !     ICH2    INTEGER   Last subband
  !     IX      INTEGER   X variable type
  !     IY      INTEGER   Y variable type
  !     JW1,JW2 INTEGER   Lowest and Highest channel in window subband
  !     WPT     REAL      Positive weight
  !     WT      REAL      Total weight
  !     XT      REAL      X value
  !     YT      REAL      Y value
  !     TT      REAL      Signed integration time
  !     ZT      COMPLEX   Complex output
  !     PHCORR  LOGICAL   Correct amplitude for rms phase ?
  ! Call Tree
  !	SOLVE_POINT	...	FILL_VISI_POSI
  !	SOLVE_FOCUS	...	FILL_VISI_POSI
  !	...		READ_DATA
  !	SOLVE_FLUX
  !---------------------------------------------------------------------
  ! Global
  include 'clic_parameter.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  ! Parameters
  complex :: z(mnbas)
  real*4  :: w(mnbas)
  integer :: iant                   !
  integer :: iband                  !
  integer :: ipol                   ! Polarization
  integer :: kb                     ! Baseband group
  integer :: kif                    ! IF group
  integer :: ix                     !
  integer :: iy                     !
  real*4 :: vt(4,3)                 !
  real*4 :: wt(4,3)                 !
  logical :: error                  !
  ! Functions
  logical :: down_antenna, corr_data
  ! Local
  real*4  :: want(mnant)
  real*4  :: t
  complex :: zant(mnant)
  integer :: iv, im
  real :: vadd(4), wadd(4), wmult(3)
  !------------------------------------------------------------------------
  ! Code:
  do im=1,3
    wmult(im) = 1.0
  enddo
  do iv=1,4
    vadd(iv) = 0.0
    wadd(iv) = 1.0
  enddo
  !
  ! Test for masks
  if (down_antenna(iant)) return
  !
  if (corr_data(ix,iy)) then
    call antgain (z,w,zant,want)
    wmult(2) = want(iant)
    wmult(3) = want(iant)
    vadd(3) = real(zant(iant))
    vadd(4) = aimag(zant(iant))
  endif
  !
  call value(ix,vadd(3),-iant,iband,ipol,kb,kif,vadd(1),wadd(1),error)
  call value(iy,vadd(3),-iant,iband,ipol,kb,kif,vadd(2),wadd(2),error)
  if (error) return
  t = dh_integ
  do im=1, 3
    do iv=1, 4
      vt(iv,im) = vt(iv,im) + vadd(iv)*wadd(iv)*wmult(im)*t
      wt(iv,im) = wt(iv,im) + wadd(iv)*wmult(im)*t
    enddo
  enddo
  return
end subroutine arecord_compute
!
subroutine check_cal(error)
  use classic_api
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: ic_yes, ic_int, ic_intlast, ic_ext, ic_extlast
  integer :: ic_phalast, ic_amplast, ic, pc_yes, pc_last, pc, ic2, pc2
  character(len=10) :: ch
  parameter (ic_yes=1, ic_amplast=2, ic_phalast=4,   &
    ic_int=8, ic_intlast=16,   &
    ic_ext=64, ic_extlast=128,   &
    pc_yes=1, pc_last=2)
  !-----------------------------------------------------------------------
  if (do_phase) then
    if (.not.do_phase_antenna) then
      ic = r_ic
      ic2 = r_aic
      ch = ' Baseline '
    else
      ic = r_aic
      ic2 = r_ic
      ch = ' Antenna '
    endif
    ! first check if calibration is stored
    if (iand(ic,ic_yes).eq.0) then
      call message(6,2,'CHECK_CAL',   &
        'No'//ch//'Phase Calibration, data ignored')
      error = .true.
    elseif (iand(ic2,ic_phalast).ne.0) then
      call message(6,1,'CHECK_CAL',   &
        'Is'//ch//'Phase Calibration really preferred?')
    ! internal or external stored ?
    !         ELSEIF (DO_PHASE_EXT.AND.(IAND(IC,IC_EXT).EQ.0)) THEN
    !            CALL MESSAGE(6,1,'CHECK_CAL',
    !     $      'No'//CH//'Ext. Phase Calibration?')
    !         ELSEIF (.NOT.DO_PHASE_EXT.AND.(IAND(IC,IC_INT).EQ.0)) THEN
    !            CALL MESSAGE(6,1,'CHECK_CAL',
    !     $      'No'//CH//'Int. Phase Calibration?')
    ! internal or external LAST stored ?
    elseif (do_phase_ext.and.(iand(ic,ic_intlast).ne.0)) then
      call message(6,1,'CHECK_CAL',   &
        'Is'//ch//'Ext. Phase Calibration really preferred?')
    elseif (.not.do_phase_ext.and.(iand(ic,ic_extlast).ne.0)) then
      call message(6,1,'CHECK_CAL',   &
        'Is'//ch//'Int. Phase Calibration really preferred?')
    endif
  endif
  !
  if (do_amplitude) then
    if (.not.do_amplitude_antenna) then
      ic = r_ic
      ic2 = r_aic
      ch = ' Baseline '
    else
      ic = r_aic
      ic2 = r_ic
      ch = ' Antenna '
    endif
    if (iand(ic,ic_yes).eq.0) then
      call message(6,2,'CHECK_CAL',   &
        'No'//ch//'Amplitude Calibration, data ignored')
      error = .true.
    elseif (iand(ic2,ic_amplast).ne.0) then
      call message(6,1,'CHECK_CAL',   &
        'Is'//ch//'Amplitude Calibration really preferred?')
    endif
  endif
  !
  if (do_scale .and. r_flux.eq.0) then
    call message(6,2,'CHECK_CAL',   &
      'No Flux in header, data ignored')
    error = .true.
  endif
  if (do_pass.and..not.do_pass_memory.and..not.do_pass_spectrum) then
    if (.not.do_pass_antenna) then
      pc = r_bpc
      pc2 = r_abpc
      ch = ' Baseline '
    else
      pc = r_abpc
      pc2 = r_bpc
      ch = ' Antenna '
    endif
    if (iand(pc,pc_yes).eq.0) then
      call message(6,2,'CHECK_CAL',   &
        'No'//ch//'RF Passband Calibration, data ignored')
      error = .true.
    elseif (iand(pc2,pc_last).ne.0) then
      call message(6,1,'CHECK_CAL',   &
        'Is'//ch//'RF Passband Calibration really preferred?')
    endif
  endif
  return
end subroutine check_cal
!
subroutine spectral_dump(kr,iant,ibase)
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Get the dump of spectral data. It depends on phase correction.
  !     iant.gt.0  -> antenna mode
  !     ibase.gt.0 -> baseline mode
  !---------------------------------------------------------------------
  integer :: kr                     !
  integer :: iant                   !
  integer :: ibase                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! Local
  logical :: ok(mnant)
  integer :: i
  !------------------------------------------------------------------------
  kr = r_ndump + 1
  if (r_ndatl.le.1) return
  !
  ! OK(i) means real-time phase correction wanted for antenna i
  ! --> read the phase-corrected dump
  !
  do i=1, mnant
    ok(i) = do_phase_atm(i).and.(r_ok_mon(i).or.do_phase_nofile)
  enddo
  !
  if (ibase.gt.0) then
    if (ok(r_iant(ibase)) .and. ok(r_jant(ibase))) then
      kr = r_ndump+2
    endif
  elseif (iant.gt.0) then
    if (ok(iant)) then
      kr = r_ndump+2
    endif
  endif
  return
end subroutine spectral_dump

program uv_pointing
  use gildas_def
  use image_def
  use gkernel_interfaces, no_interface=>fourt
  !---------------------------------------------------------------------
  ! Pointing Error Simulation
  !
  !     Fast pointing error simulation based on  gridded interpolation
  !     from the Fourier Transform of an image
  !
  !     H.Wiesemeyer S.Guilloteau
  !
  !----------------------------------------------------------------------
  !
  ! Expression of A
  !     A(x,y) = exp[-2ln(2)/Theta(i)^2 ((x-Dx(i))^2+(y-Dy(i))^2)]
  !            * exp[-2ln(2)/Theta(j)^2 ((x-Dx(j))^2+(y-Dy(j))^2)]
  !
  ! Expression of ThetB
  !     1/ThetB^2 = 1/2 (1/Theta(i)^2+1/Theta(j)^2)
  !
  ! Expression of FT(A)
  !
  !     FT(u,v) = pi ThetB^2 /(4 ln(2)) exp {-pi^2 ThetB^2 / (4 ln(2)) (u^2+v^2) }
  !       * exp{ -2 ln(2) [(Dx1^2_Dy1^2)/Theta1^2 + (Dx2^2_Dy2^2)/Theta2^2] }
  !       * exp{ ThetB^2 ln(2) [(Dx1/Theta1^2 + Dx2/Theta2^2)^2
  !                           + (Dy1/Theta1^2 + Dy2/Theta2^2)^2 ] }
  !       * exp{ -i pi ThetB^2 [(u Dx1 + v Dy1)/Theta1^2 + (u Dx2 + v Dy2)/Theta2^2 ] }
  !
  !
  ! Simplification in the case of identical antennas
  !
  !     FT(u,v) = pi Thet^2 /(4 ln(2)) exp {-pi^2 Thet^2 / (4 ln(2)) (u^2+v^2) }
  !       * exp{ -ln(2) / Thet^2 [(Dx1-Dx2)^2^ + (Dy1-Dy2)^2] }
  !       * exp{ -i pi [(u Dx1 + v Dy1) + (u Dx2 + v Dy2)] }
  !
  !
  ! Evaluation of disturbed visibility
  !      V(u_0,v_0) = FT(u-u_0,v-v_0,Dx(Iant),Dy(Iant) ** FTSKY(u,v)
  !
  ! Replaced by a simple sum of the nearest neighbours
  !     V(u_0,v_0) = SiSj
  !                FT(ui-u_0,vj-v_0,Dx(Iant),Dy(Iant) * FTSKY(ui,vj)
  !                Weight(ui-u_0,vj-v_0) * Du Dv
  !
  ! Note that this CONVOLUTION in Fourier Plane by a Weight(u,v) function
  ! is equivalent to a MULTIPLICATION in Image Plane by its Fourier Transform.
  !
  ! One could (in theory) correct for this gridding effect later.
  !---------------------------------------------------------------------
  ! Global
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  type(gildas) :: x,y,z
  real :: su,sv,suv,uvr,eps,frequency
  real*8 :: freq
  integer :: nx,ny,mx,my,nw,nv,ntt,na
  integer :: n,nn(2),ndim
  integer :: ier
  complex, allocatable :: ipft(:,:), wfft(:)
  integer, allocatable :: time_visi(:), visi_time(:), order(:)
  real(8), allocatable :: dt(:)
  real, allocatable :: perr(:,:,:)
!  integer(kind=address_length) :: addr,addr2
!  integer(kind=address_length) :: ipft, ipz, ipv
!  integer(kind=address_length) :: ipitt, ipord, ip1, ip2, iperr, ipw
  character(len=256) :: name, image, uvdata, uvmodel, pfile
  logical :: error, mosaic
  real :: sigma(2)
  real :: theta, pixel_area, lambda, factor
  integer :: icode, mtt, ma
  !
  ! Code:
  call gagout('I-UV_POINTING,  Version 1.1 20-Dec-2000')
  call gildas_open
  call gildas_char('UVSAMPLE$',uvdata)
  call gildas_char('IMAGE$',image)
  call gildas_char('UVMODEL$',uvmodel)
  call gildas_real('FREQUENCY$',frequency,1)
  call gildas_logi('MOSAIC$',mosaic,1)
  call gildas_inte('CODE$',icode,1)
  call gildas_char('POINTING$',pfile)
  call gildas_real('ERRORS$',sigma,2)
  call gildas_real('PRIMARY$',theta,1)
  call gildas_close
  !
  ! Get the model image
  n = lenc(image)
  if (n.le.0) goto 999
  name = image(1:n)
  call gildas_null(z)
  z%gil%ndim = 2
  call gdf_read_gildas(z, name, '.lmv', error)
  if (error) then
    call gagout ('F-UV_POINTING,  Cannot read input image')
    goto 999
  endif
  pixel_area = abs(z%gil%inc(1)*z%gil%inc(2))  ! in radian
  !
  ! Need to oversample in the UV plane, i.e. extend initial image,
  ! to avoid large gridding errors
  !
  nx = z%gil%dim(1)
  ny = z%gil%dim(2)
  mx = 8*nx
  my = 8*ny
  if (mx.gt.5000.or.my.gt.5000) then
    mx = 4*nx
    my = 4*ny
  endif
  !
  allocate (ipft(mx,my), stat=ier)
  call plunge_real (z%r2d,nx,ny,ipft,mx,my)
  !
  ! Original image no longer needed...
  deallocate (z%r2d)
  !
  ! Template UV data set
  n = lenc(uvdata)
  if (n.le.0) goto 999
  name = uvdata(1:n)
  call gildas_null (x, type = 'UVT')
  call gdf_read_gildas (x, name, '.uvt', error, data=.false.)
  if (error) then
    call gagout ('F-UV_POINTING,  Cannot read input table')
    goto 999
  endif
  !
  ! Create the model UV table (Y from X)
  call gildas_null (y, type = 'UVT')
  call gdf_copy_header (x,y,error)
  freq = z%gil%freq
  if (frequency.ne.0) then
    freq = frequency*1e3
  endif
  y%gil%freq = freq
  !
  print *,'freq ',y%gil%freq,freq
  ! Define scaling factor from Brightness to Flux (2 k B^2 / l^2)
  lambda = 299792.458e3/(freq*1e6) ! in meter
  ! 1.38E3 is the Boltzmann constant times 10^26 to give result in Jy
  factor = 2*1.38e3/lambda**2*pixel_area
  print *,'Factor ',factor,pixel_area
  if (factor.eq.0.0) factor = 1.0
  !
  n = lenc(uvmodel)
  if (n.le.0) goto 999
  name = uvmodel(1:n)
  call sic_parsef(name,y%file,' ','.uvt')
  call gdf_create_image (y, error)
  if (error) then
    call gagout ('F-UV_POINTING,  Cannot create output UV model')
    goto 999
  endif
  !
  call gdf_allocate(y,error)
  call gdf_read_data (x, y%r2d, error)
  nw = y%gil%dim(1)
  nv = y%gil%dim(2)
  !
  ! Template UV data set no longer needed
  call gdf_close_image(x, error)
  !
  ! Get the number of time samples
  allocate (visi_time(nv), dt(nv), time_visi(nv), stat=ier)
  call do_timelist (   &
     &    y%r2d,   &
     &    nw,nv,   &
     &    visi_time, &   ! Visibility --> Time
     &    dt,   &     ! Date + Time
     &    time_visi,   &     ! Time --> Visi
     &    ntt,na)
  !
  ! Get the index order...
  allocate (order(ntt), stat=ier)
  call gi4_trie(visi_time,order,ntt,error)
  deallocate (dt, time_visi, stat=ier)   !  call free_vm (3*nv,addr)
  !
  ! Pointing errors
  if ((icode.gt.5).or.(icode.lt.1)) then
    call gagout('F-UV_POINTING,  Pointing mode is 1..5')
    goto 999
  endif
  !
  ! Pointing error file: gdf table
  if (mosaic.or.(icode.eq.5)) then
    call gagout('I-UV_POINTING, Reading an external table')
    n = lenc(pfile)
    if (n.le.0) goto 999
    name = pfile(1:n)
    call gildas_null(x)
    call gdf_read_gildas (x, name, '.tab', error)
    if (error) then
      call gagout ('F-UV_POINTING, Cannot read error table')
      goto 999
    endif
    !
    ! Check dimension are ok
    ! We need dim(1) = number of visibilitiy dumps (NTT)
    !         dim(2) = number of antennas (NA)
    !         dim(3) = 2
    ! Table can be larger (the end won't be read)
    if ((x%gil%dim(1).lt.ntt).or.(x%gil%dim(2).lt.na).or.   &
     &      (x%gil%dim(3).ne.2)) then
      call gagout('W-UV_POINTING, Pointing error file too small')
      goto 999
    endif
    mtt = x%gil%dim(1)
    ma = x%gil%dim(2)
  endif
  !
  ! Now compute or read the errors
  sigma(1) = sigma(1)*pi/3600/180
  sigma(2) = sigma(2)*pi/3600/180
  print *,'Sigma ',sigma
  allocate (perr(2,ntt,na), stat=ier)
  call do_pointerr (   &
     &    order,    &   ! Ordering of times
     &    ntt,na,   &
     &    perr,     &   ! Pointing errors
     &    sigma,    &   ! For each direction
     &    mosaic,   &   ! Mosaic mode
     &    x%r3d,    &   ! Pointing error table (icode=5)
     &    mtt,ma,icode,error)
  if (error) call sysexi(fatale)
  !
  ! Free files
  if (mosaic.or.(icode.eq.5)) then
    deallocate (x%r3d, stat=ier)
    call gdf_close_image(x, error)
  endif
  !
  ! Get the model image Fourier Transform
  allocate (wfft(mx+my), stat=ier)
  nn(1) = mx
  nn(2) = my
  ndim = 2
  call fourt(ipft,nn,ndim,1,0,wfft) 
  ! Recenter it
  call recent(mx,my,ipft) 
  !
  su = 1.0/(mx*z%gil%inc(1))
  sv = 1.0/(my*z%gil%inc(2))
  theta = theta*pi/180.0/3600.0    ! In radians
  suv = max(-su,sv)
  eps = 1e-8
  uvr = suv * nint(2.*sqrt(-log(2.)*log(eps))/(pi*theta)/suv)
  print *,'UV cells ',uvr/suv,uvr,suv
  !
  ! Now to the job
  call do_model (   &
     &    y%r2d,    &
     &    nw,nv,    &
     &    visi_time,&
     &    na,ntt,   &
     &    perr,     &
     &    freq,     &
     &    ipft,     &    ! Fourier transform of sky brightness
     &    mx,my,    &
     &    wfft, wfft(mx+1),   &  ! Use for U,V coordinates of grid
     &    su,sv,theta,uvr,factor)
  !
  call gdf_write_data(y, y%r2d, error)
  call gdf_close_image(y, error)
  call sysexi(1)
  !
  999   call sysexi(fatale)
end program uv_pointing
!
!<FF>
subroutine plunge_real (r,nx,ny,c,mx,my)
  !---------------------------------------------------------------------
  !     Plunge a Real array into a larger Complex array
  !---------------------------------------------------------------------
  integer :: nx                     ! Size of input array
  integer :: ny                     ! Size of input array
  real :: r(nx,ny)                  ! Input real array
  integer :: mx                     ! Size of output array
  integer :: my                     ! Size of output array
  real :: c(2,mx,my)                ! Output complex array
  ! Local
  integer :: kx,ky,lx,ly
  integer :: i,j
  !
  kx = nx/2+1
  lx = mx/2+1
  ky = ny/2+1
  ly = my/2+1
  !
  do j=1,my
    do i=1,mx
      c(1,i,j) = 0.0
      c(2,i,j) = 0.0
    enddo
  enddo
  !
  do j=1,ny
    do i=1,nx
      c(1,i-kx+lx,j-ky+ly) = r(i,j)
    enddo
  enddo
end
!<FF>
subroutine do_timelist (visi,nw,nv,itt,dtt,vtt,ntt,na)
  !---------------------------------------------------------------------
  !     Build a list of times from the input visibilities
  !---------------------------------------------------------------------
  integer :: nw                     !
  integer :: nv                     !
  real :: visi(nw,nv)               ! Visibilities
  integer :: itt(nv)                ! Pointer from visibility to time
  real*8 :: dtt(nv)                 ! Date & Time of each time sample
  integer :: vtt(nv)                ! Pointer from time to visibility
  integer :: ntt                    !
  integer :: na                     !
  ! Local
  integer :: iv,jv,it,i,la
  real :: date,time
  logical :: goon
  !
  itt(1) = 1
  vtt(1) = 1
  ntt = 1
  date = visi(4,1)
  time = visi(5,1)
  dtt(ntt) = dble(date)*dble(24*3600)+dble(time)
  print *,'Found new time at visi ',1,dtt(ntt)
  na = max(visi(6,1),visi(7,1))
  !
  do iv=2,nv
    date = visi(4,iv)
    time = visi(5,iv)
    la = max(visi(6,iv),visi(7,iv))
    na = max(na,la)
    it = ntt
    goon = .true.
    do while (goon)
      jv = vtt(it)
      if (date.eq.visi(4,jv).and.   &
     &        time.eq.visi(5,jv)) then
        itt(iv) = it
        goon = .false.
      elseif  (it.eq.1) then
        ntt = ntt+1
        itt(iv) = ntt
        vtt(ntt) = iv
        dtt(ntt) = dble(date)*dble(24*3600)+dble(time)
        print *,'Found new time at visi ',iv,dtt(ntt)
        goon = .false.
      else
        it = it-1
      endif
    enddo
  enddo
  print *,'Found ',na,' different antennas'
  print *,'Found ',ntt,' different times'
  print *,'Times ',(dtt(i),i=1,ntt)
end
!<FF>
subroutine do_pointerr (order,ntt,na,err,sigma,mosaic,   &
     &    poinerr,mtt,ma,icode,error)
  !---------------------------------------------------------------------
  !     Generate the pointing errors
  !     5 Cases
  !     ICODE = 1       No error
  !     ICODE = 2       Fixed error (identical for all antennas)
  !     ICODE = 3       Purely random error
  !     ICODE = 4       Random per antenna, fixed in time
  !     ICODE = 5       Table driven error, gdf table
  !         Table dimension: NTT,NA,2
  !
  !     If MOSAIC is true, then read table (icode=5) and add errors
  !     (icode = 1 to 4)
  !---------------------------------------------------------------------
  integer :: ntt                    !
  integer :: order(ntt)             !
  integer :: na                     !
  real :: err(2,na,ntt)             !
  real :: sigma(2)                  !
  logical :: mosaic                 !
  integer :: mtt                    !
  integer :: ma                     !
  real :: poinerr(mtt,ma,2)         !
  integer :: icode                  !
  logical :: error                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real :: rangau
  real*8 :: sec
  integer :: ia,it,jt,kt
  !
  error = .false.
  !
  ! No error
  do it=1,ntt
    do ia=1,na
      err(1,ia,it) = 0.0
      err(2,ia,it) = 0.0
    enddo
  enddo
  ! Purely fixed
  if (icode.eq.2) then
    do it=1,ntt
      do ia=1,na
        err(1,ia,it) = sigma(1)
        err(2,ia,it) = sigma(2)
      enddo
    enddo
    ! Purely random
  elseif (icode.eq.3) then
    do it=1,ntt
      do ia=1,na
        err(1,ia,it) = rangau(sigma(1))
        err(2,ia,it) = rangau(sigma(2))
      enddo
    enddo
    ! Random for each antenna, but fixed in time
  elseif (icode.eq.4) then
    do ia=1,na
      err(1,ia,1) = rangau(sigma(1))
      err(2,ia,1) = rangau(sigma(2))
    enddo
    do it=2,ntt
      do ia=1,na
        err(1,ia,it) = err(1,ia,1)
        err(2,ia,it) = err(2,ia,1)
      enddo
    enddo
  endif
  !
  ! For a Mosaic add the Mosaic centers, from the external file
  if (mosaic.or.(icode.eq.5)) then
    ! External description: gdf file
    sec = pi/3600./180.
    do it=1,ntt
      jt = order(it)
      do ia=1,na
        err(1,ia,jt) = err(1,ia,jt)+poinerr(it,ia,1)*sec
        err(2,ia,jt) = err(2,ia,jt)+poinerr(it,ia,2)*sec
      enddo
    enddo
  endif
end
!<FF>
subroutine do_model (visi,nw,nv,itt,na,nt,err,freq,   &
     &    ftsky,mx,my,uval,vval,su,sv,thet,uvr,factor)
  integer :: nw                     !
  integer :: nv                     !
  real :: visi(nw,nv)               ! Visibilities
  integer :: itt(nv)                ! Pointer to times
  integer :: na                     ! Number of antennas
  integer :: nt                     ! Number of different times
  real :: err(2,na,nt)              ! Pointing error for each antenna / time
  real*8 :: freq                    ! Observing frequency
  integer :: mx                     !
  integer :: my                     !
  complex :: ftsky(mx,my)           ! Fourier Transform
  real :: uval(mx)                  ! u,v Values
  real :: vval(my)                  ! u,v Values
  real :: su                        ! Step of Fourier Transform
  real :: sv                        ! Step of Fourier Transform
  real :: thet                      ! Beam size (in radian)
  real :: uvr                       ! UV radius for convolution
  real :: factor                    ! Input map scaling factor
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 :: u,v,lambda,uu,vv
  real*8 :: us,vs
  real*8 :: dxi,dyi,dxj,dyj
  real*8 :: pithet,uvthet,lnthet
  complex*16 :: avis,tvis,cmp
  complex*8 :: svis
  real*8 :: arg,carg,sarg
  integer :: ia,ja,it
  integer :: lx,ly,ilo,iup,jlo,jup
  integer :: i,iv,ii,jj
  !
  lambda = 299792.458d3/(freq*1d6)
  pithet = pi**2*thet**2/(4.0*log(2.))
  uvthet = -pithet/pi*su*sv * factor
  lnthet = log(2d0)/thet**2
  lx = mx/2+1
  ly = my/2+1
  us = 1.0/su
  vs = 1.0/sv
  do i=1,mx
    uval(i) = (i-lx)*su
  enddo
  do i=1,my
    vval(i) = (i-ly)*sv
  enddo
  !
  do iv = 1,nv
    u = visi(1,iv)/lambda
    v = visi(2,iv)/lambda
    ia = visi(6,iv)
    ja = visi(7,iv)
    it = itt(iv)
    dxi = err(1,ia,it)
    dyi = err(2,ia,it)
    dxj = err(1,ja,it)
    dyj = err(2,ja,it)
    !
    !     FT(u,v) = pi Thet^2 /(4 ln(2)) exp {-pi^2 Thet^2 / (4 ln(2)) (u^2+v^2) }
    !       * exp{ -ln(2) / Thet^2 [(Dx1-Dx2)^2^ + (Dy1-Dy2)^2] }
    !       * exp{ -i pi [(u Dx1 + v Dy1) + (u Dx2 + v Dy2)] }
    !
    !  FT(u,v) = pi Thet^2 /(4 ln(2))                       ! Scale
    !  * exp{ -ln(2) / Thet^2 [(Dx1-Dx2)^2 + (Dy1-Dy2)^2] } ! Cross-pointing error
    !  * exp {-pi^2 Thet^2 / (4 ln(2)) u^2}                 ! U attenuation term
    !  * exp { -i pi [u Dx1) + u Dx2] }                     ! U phase term
    !  * exp {-pi^2 Thet^2 / (4 ln(2)) v^2 }                ! V attenuation term
    !  * exp{ -i pi [v Dy1 + v Dy2] }                       ! V phase term
    !
    ilo = nint((u+uvr)*us) + lx
    iup = nint((u-uvr)*us) + lx
    jlo = nint((v-uvr)*vs) + ly
    jup = nint((v+uvr)*vs) + ly
    ilo = max(1,ilo)
    iup = min(mx,iup)
    jlo = max(1,jlo)
    jup = min(my,jup)
    !
    avis = (0.,0.)
    do jj = jlo,jup
      tvis = (0.,0.)
      do ii = ilo,iup
        uu = uval(ii) - u
        arg = -pi*uu*(dxi+dxj)
        carg = cos(arg)
        sarg = sin(arg)
        cmp = cmplx(carg,sarg)
        arg = exp(-pithet*uu**2)
        tvis = tvis+cmp*ftsky(ii,jj)*arg
      enddo
      vv = vval(jj) - v
      arg = -pi*vv*(dyi+dyj)
      carg = cos(arg)
      sarg = sin(arg)
      cmp = cmplx(carg,sarg)
      arg = exp(-pithet*vv**2)
      avis = avis+cmp*tvis*arg
    enddo
    !
    ! FT(u,v) = pi Thet^2 /(4 ln(2))
    !   * exp{ -ln(2) / Thet^2 [(Dx1-Dx2)^2^ + (Dy1-Dy2)^2] }
    !   * su * sv
    !
    arg = uvthet*exp(-lnthet*((dxi-dxj)**2+(dyi-dyj)**2))
    avis = avis*arg
    !
    ! Done
    svis = avis
    visi(8,iv) =  real(svis)
    visi(9,iv) = aimag(svis)
  enddo
end
!<FF>
subroutine recent(nx,ny,z)
  !---------------------------------------------------------------------
  ! Recenters the Fourier Transform, for easier display. The present version
  ! will only work for even dimensions.
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  complex :: z(nx,ny)               !
  ! Local
  integer :: i, j
  complex :: tmp
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i+nx/2,j+ny/2)
      z(i+nx/2,j+ny/2) = z(i,j)
      z(i,j) = tmp
    enddo
  enddo
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i,j+ny/2)
      z(i,j+ny/2) = z(i+nx/2,j)
      z(i+nx/2,j) = tmp
    enddo
  enddo
  !
  do i=1,nx
    do j =1,ny
      if (mod(i+j,2).ne.0) then
        z(i,j) = -z(i,j)
      endif
    enddo
  enddo
end

subroutine write_sdm_observation(error)
  !---------------------------------------------------------------------
  ! Write the Source ExecBlock  table.
  ! Row Contents:
  ! observation table is *TBD*
  !
  ! calling:
  !
  !     int sdm_addObservationRow ()
  !
  !---------------------------------------------------------------------
  use gildas_def
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  integer sdm_addObservationRow, ireturn
  !---------------------------------------------------------------------
  ireturn = sdm_addObservationRow()
  if (ireturn .lt.0) then
    call message(8,3,'write_sdm_observation'   &
      ,'Error  in sdm_addObservationRow')
    goto 99
  else
    Observation_Id  = ireturn
  endif
  return
99 error = .true.
end subroutine write_sdm_observation
!---------------------------------------------------------------------
subroutine get_sdm_observation(error)
  !---------------------------------------------------------------------
  ! Read the Source ExecBlock  table.
  ! Row Contents:
  ! observation table is *TBD*
  !
  ! calling:
  !
  !     int sdm_addObservationRow ()
  !
  !---------------------------------------------------------------------
  use gildas_def
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  integer sdm_getObservationRow, ireturn
  !---------------------------------------------------------------------
  Observation_Id = 0
  ireturn = sdm_getObservationRow(Observation_Id)
  if (ireturn .lt.0) then
    call message(8,3,'get_sdm_observation'   &
      ,'Error  in sdm_getObservationRow')
    goto 99
  endif
  return
99 error = .true.
end subroutine get_sdm_observation
!---------------------------------------------------------------------

subroutine cwsec (scode,len,error)
  use gbl_constant
  use gbl_convert
  use clic_file
  !---------------------------------------------------------------------
  !	Convert section from System data type to File data type
  !---------------------------------------------------------------------
  integer         :: scode                  ! Section number
  integer(kind=8) :: len                    ! Section length
  logical         :: error                  ! Error flag
  ! Global
  external :: r4tor4,r8tor8,i8toi8
  external :: ier4va,eir4va,eir4ie,ier4ei,var4ie,var4ei
  external :: ier8va,eir8va,eir8ie,ier8ei,var8ie,var8ei
  external ::        eii4va,eii4ie,iei4ei       ,vai4ei
  external ::               eii8ie,iei8ei
  !
  if (error) return
  !
  if (o%conv%code.eq.0) then        ! No conversion
    call scwsec (scode,len,error,r4tor4,r8tor8,r4tor4,i8toi8,r4tor4)
  elseif (o%conv%code.eq.-ieee_fr_vax) then
    call scwsec (scode,len,error,ier4va,ier8va,r4tor4,i8toi8,r4tor4)
  elseif (o%conv%code.eq.-vax_fr_ieee) then
    call scwsec (scode,len,error,var4ie,var8ie,r4tor4,i8toi8,r4tor4)
  elseif (o%conv%code.eq.-eeei_fr_vax) then
    call scwsec (scode,len,error,eir4va,eir8va,eii4va,i8toi8,r4tor4)
  elseif (o%conv%code.eq.-eeei_fr_ieee) then
    call scwsec (scode,len,error,eir4ie,eir8ie,eii4ie,eii8ie,r4tor4)
  elseif (o%conv%code.eq.-vax_fr_eeei) then
    call scwsec (scode,len,error,var4ei,var8ei,vai4ei,i8toi8,r4tor4)
  elseif (o%conv%code.eq.-ieee_fr_eeei) then
    call scwsec (scode,len,error,ier4ei,ier8ei,iei4ei,iei8ei,r4tor4)
  endif
end subroutine cwsec
!
subroutine scwsec (scode,len,error,r4,r8,i4,i8,cc)
  use gkernel_interfaces
  use gbl_constant
  use clic_file
  !---------------------------------------------------------------------
  !	Convert section from System data type to File data type
  !---------------------------------------------------------------------
  integer        ,intent(in)    :: scode  ! Section number
  integer(kind=8),intent(inout) :: len    ! Section lenght (In/Out)
  logical        ,intent(out)   :: error  ! Error flag
  external                      :: r4     ! real*4 conversion routine
  external                      :: r8     ! real*8 conversion routine
  external                      :: i4     ! integer*4 conversion routine
  external                      :: i8     ! integer*8 conversion routine
  external                      :: cc     ! character conversion routine
  ! Global
  include 'clic_parameter.inc'
  include 'clic_work.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  real*4 :: ichain(64)
  integer(kind=8) :: k,lensec
  integer,parameter :: mlwork=4
  integer(kind=8) :: lwork(mlwork)
  integer,parameter :: mdwork=max(12,3*mnbas,3*mnant,2*mrlband,mbands)
  real*8 ::  dwork(mdwork)
  integer :: iwork(mdata),ii,j,l,m,n, kk, temp_dim, mask, temp_dim2,i4value
  integer :: dmsaflag(mnant), dmsbflag(mnbas), dummy, nword
  real    :: dmdelay(m_pol_rec,mnant),dmatfac(m_pol_rec,2,mnant)
  real    :: ifattn(2,mnant,mrlband)
  equivalence (iwork,data_buffer)
  logical :: test
  character(len=80) :: chain
  ! Code
  if (error) return
  !
  k = len+1
  !
  ! General Section
  if (scode.eq.gen_sec) then
    !         CALL R8 (R_UT,IWORK,2)
    call r8 (r_ut,dwork,2)
    call r4tor4(dwork,iwork,4)
    call r4 (r_az,iwork(5),5)
    call i4 (r_typof,iwork(10),2)
    if (r_kind.eq.5) then
      write (chain,'(A,I2)') 'New receiver data kind is ', r_kind
      l = lenc(chain)
    !           CALL MESSAGE(1,1,'WOBS',CHAIN(1:L))
    endif
  !
  ! Position Section
  elseif (scode.eq.pos_sec) then
    call chtoby(r_sourc,ichain,12) ! CHAIN = R_SOURC
    call cc (ichain,iwork,3)
    call r4 (r_epoch,iwork(4),1)
    !         CALL R8 (R_LAM,IWORK(5),2)
    call r8 (r_lam,dwork,2)
    call r4tor4(dwork,iwork(5),4)
    call r4 (r_lamof,iwork(9),5)
    call i4 (r_proj,iwork(11),1)
    k = 14
    if (e%version.gt.3) then
      call r4 (r_spidx,iwork(14),1)
      k = k + 1
    endif
    if (e%version.gt.5) then
      call r4 (r_stokes_i,iwork(15),8)
      k = k + 8
    endif
  !
  ! Spectral Setup Section: never used.
  !      ELSEIF (SCODE.EQ.SPEC_SEC) THEN
  !         CHAIN = R_SLINE
  !         CALL CC (ICHAIN,IWORK,3)
  !         CALL R8 (R_SRESTF,IWORK(4),1)
  !         CALL I4 (R_SNCHAN,IWORK(6),1)
  !         CALL R4 (R_SRCHAN,IWORK(7),6)
  !         CALL R8 (R_SIMAGE,IWORK(13),1)
  !         CALL I4 (R_SVTYPE,IWORK(15),1)
  !         CALL R8 (R_SFOBS,IWORK(16),1)
  !
  ! Interferometer Section
  elseif (scode.eq.interc_sec) then
    call i4 (r_nant,iwork,3)
    if (r_nant.le.0) then
      call message(8,4,'WINTERC','NANT should be positive')
      error = .true.
      return
    endif
    if (r_nbas.le.0) then
      call message(8,4,'WINTERC','NBAS should be positive')
      error = .true.
      return
    endif
    k = 5
    call r4 (r_houra,iwork(4),1)
    call i4 (r_kant,iwork(k),r_nant)
    k = k + r_nant
    call i4 (r_kent,iwork(k),r_nant)
    k = k + r_nant
    call i4 (r_istat,iwork(k),r_nant)
    k = k + r_nant
    call i4 (r_iant,iwork(k),r_nbas)
    k = k + r_nbas
    call i4 (r_jant,iwork(k),r_nbas)
    k = k + r_nbas
    !         CALL R8 (R_BAS,IWORK(K),3*R_NBAS)
    call r8 (r_bas,dwork,3*r_nbas)
    call r4tor4(dwork,iwork(k),2*3*r_nbas)
    k = k + 6*r_nbas
    ! It's better NOT to modify older observations, this can lead to
    ! unpredictable results, for instance with MODIFY AXES ...
    !         IF (.NOT.(MODIFY .AND. K.GT.LENSEC(INTERC_SEC))) THEN
    !         CALL R8 (R_ANT,IWORK(K),3*R_NANT)
    call r8 (r_ant,dwork,3*r_nant)
    call r4tor4(dwork,iwork(k),2*3*r_nant)
    k = k + 6*r_nant
    call i4 (r_ntri,iwork(k),1)
    k = k + 1
    if (r_ntri.gt.0) then
      call i4 (r_atri,iwork(k),3*r_ntri)
      k = k + 3*r_ntri
    endif
    !         ENDIF
    !         IF (.NOT.(MODIFY .AND. K.GT.LENSEC(INTERC_SEC))) THEN
    call r4 (r_axes,iwork(k),r_nant)
    k = k + r_nant
    !         ENDIF
    !         IF (.NOT.(MODIFY .AND. K.GT.LENSEC(INTERC_SEC))) THEN
    call r4 (r_phlo1,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_phlo3,iwork(k),r_nant)
    k = k + r_nant
    if (.not.modify .or. k.le.lensec(interc_sec)) then
      call i4 (r_nband_widex, iwork(k),1)
      k = k + 1
   endif
  !         ENDIF
  !
  ! RF Setup Section
  elseif (scode.eq.rfset_sec) then
    call chtoby(r_line,ichain,12)  ! CHAIN = R_LINE
    call cc (ichain,iwork,3)
    call i4 (r_isb,iwork(4),2)
    !         CALL R8 (R_RESTF,IWORK(6),4)
    call r8 (r_restf,dwork,4)
    call r4tor4(dwork,iwork(6),4*2)
    call r4 (r_veloc,iwork(14),1)
    call i4 (r_typev,iwork(15),1)
    call r4 (r_doppl,iwork(16),1)
    k = 17
    if (r_kind.eq.5) then
      call i4 (r_npol_rec,iwork(k),1)
      k = k + 1
      if (e%version.le.3) then
        call i4 (r_quarter,iwork(k),2)
        k = k + 2
      endif 
      call i4 (r_qwplate,iwork(k),r_nant)
      k = k + r_nant
      if (e%version.ge.4) then
        call i4(r_nif,iwork(k),1)
        k = k + 1
        do ii =1, r_nif
          call chtoby(r_ifname(ii),ichain,4)
          call cc(ichain,iwork(k),1)
          k = k + 1
        enddo
        call i4(r_kif,iwork(k),r_nif)
        k = k + r_nif
        do ii = 1, r_nif
          call r4(r_ifattn(1,ii),iwork(k),r_nant)
          k = k + r_nant
        enddo
        call i4(r_nbb,iwork(k),1)
        k = k + 1
        do ii=1, r_nbb
          call chtoby(r_bbname(ii),ichain,4)
          call cc(ichain,iwork(k),1)
          k = k + 1
        enddo
        call i4(r_kbb,iwork(k),r_nbb)
        k = k + r_nbb
        call i4(r_mapbb,iwork(k),r_nbb)
        k = k + r_nbb
        do ii = 1, r_nbb
          call i4(r_mappol(1,ii),iwork(k),r_nant)
          k = k + r_nant
        enddo
        call i4(r_nsubpower,iwork(k),1)
        k = k +1
        if (r_nsubpower.ne.0) then
          call r4(r_subpower_val,iwork(k),1)
          k = k + 1
          call i4(r_subpower_ref,iwork(k),1)
          k = k + 1
          call r4(r_subpower_inc,iwork(k),1)
          k = k + 1
        endif
      endif
      if (e%version.ge.5) then
        do ii = 1, mnsb
          call i4 (r_polswitch(1,ii),iwork(k),r_nant)
          k = k + r_nant
        enddo
      endif 
    !            DO I = 1, R_NPOL_REC
    !               CALL I4 (R_ATTCOM(1,I),IWORK(K),R_NANT)
    !               K = K + R_NANT
    !            ENDDO
    endif
  !
  ! Continuum Setup Section
  elseif (scode.eq.contset_sec) then
    call i4 (r_nsb,iwork,3)
    call r4 (r_crch,iwork(4),6)
    !         CALL R8 (R_CRFOFF,IWORK(10),2)
    call r8 (r_crfoff,dwork,2)
    call r4tor4(dwork,iwork(10),4)
    call r4 (r_crfres,iwork(14),2)
    call chtoby(r_cnam(1),ichain,12)
    call cc (ichain,iwork(16),3)
    call chtoby(r_cnam(2),ichain,12)
    call cc (ichain,iwork(19),3)
    !         CALL R8 (R_CFCEN,IWORK(22),MCCH)
    k = 22
    if (e%version.le.3) then
      if (r_nband_widex.eq.0) then
        temp_dim = 10
      else
        temp_dim = 12
      endif
    else
      temp_dim = r_nband
    endif
    call r8 (r_cfcen,dwork,temp_dim)
    call r4tor4(dwork,iwork(22),2*temp_dim)
    call r4 (r_cfwid,iwork(22+2*temp_dim),temp_dim)
    k = k + 3*temp_dim
    if (e%version.le.3) then
      call i4 (r_sband,iwork(22+3*temp_dim),2)
      k = k + 2
    else
      do ii=1, r_nband
        call i4 (r_sband(1,ii),iwork(k),2)
        k = k + 2
      enddo
    endif
  !
  ! Line Setup Section
  elseif (scode.eq.lineset_sec) then
    call i4 (r_lband,iwork,3)
    k = 4
    if (r_lband.gt.0) then
      call i4 (r_lnch,iwork(k),r_lband)
      k = k + r_lband
      call i4 (r_lich,iwork(k),r_lband)
      k = k + r_lband
      !            CALL R8 (R_LFCEN,IWORK(K),R_LBAND)
      call r8 (r_lfcen,dwork,r_lband)
      call r4tor4(dwork,iwork(k),2*r_lband)
      k = k + 2*r_lband
      call r4 (r_lfres,iwork(k),r_lband)
      k = k + r_lband
      call r4 (r_lrch,iwork(k),2*r_lband)
      k = k + 2*r_lband
      call r4 (r_lvoff,iwork(k),2*r_lband)
      k = k + 2*r_lband
      call r4 (r_lvres,iwork(k),2*r_lband)
      k = k + 2*r_lband
      !            CALL R8 (R_LRFOFF,IWORK(K),R_LBAND)
      call r8 (r_lrfoff,dwork,2*r_lband)
      call r4tor4(dwork,iwork(k),2*2*r_lband)
      k = k + 4*r_lband
      call r4 (r_lrfres,iwork(k),2*r_lband)
      k = k + 2*r_lband
      do ii=1,r_lband
        call chtoby(r_lnam(1,ii),ichain,12)
        call cc(ichain,iwork(k),3)
        k = k+3
        call chtoby(r_lnam(2,ii),ichain,12)
        call cc(ichain,iwork(k),3)
        k = k+3
      enddo
      do ii=1, r_nant
        call i4 (r_lilevu(1,ii),iwork(k),r_lband)
        k = k + r_lband
      enddo
    endif
    if (e%version.le.3) then
      call i4 (r_lnsb,iwork(k),4)
      k = k + 4
    else 
      call i4 (r_lnsb,iwork(k),1)
      k = k + 1
      do ii=1, r_lband
        call i4(r_lsband(1,ii),iwork(k),r_lnsb)
        k = k + r_lnsb
      enddo
    endif
    call r4(r_lcench,iwork(k),r_lband)
    k = k + r_lband
    do ii=1, r_nant
      call r4 (r_ldeloff(1,ii),iwork(k),r_lband)
      k = k + r_lband
    enddo
    call i4(r_lmode,iwork(k),1)
    k = k+1
    ! add r_lilevl and r_iunit 15-sep-1992 RL
    do ii=1, r_nant
      call i4 (r_lilevl(1,ii),iwork(k),r_lband)
      k = k + r_lband
    enddo
    call i4 (r_iunit(1),iwork(k),r_lband)
    k = k + r_lband
    ! add r_band4 if possible
    if (.not.modify .or. k.le.lensec(lineset_sec)) then
      call r4 (r_band4,iwork(k),r_lband)
      k = k + r_lband
    endif
    ! add r_phselect if possible
    if (.not.modify .or. k.le.lensec(lineset_sec)) then
      do ii=1, r_lband
        call i4 (r_phselect(1,ii),iwork(k),r_nant)
        k = k + r_nant
      enddo
    endif
    ! add new receivers parameters if possible
    if (.not.modify.or.k.le.lensec(lineset_sec)) then
      call r8(r_flo2,dwork,r_lband)
      call r4tor4 (dwork,iwork(k),2*r_lband)
      k = k + 2*r_lband
      if (e%version.gt.3) then
        call r4tor4 (r_band2,iwork(k),r_lband)
        k = k + r_lband
      endif
      call r8(r_flo2bis,dwork,r_lband)
      call r4tor4 (dwork,iwork(k),2*r_lband)
      k = k + 2*r_lband
      call i4(r_band2bis,iwork(k),r_lband)
      k = k + r_lband
      call r8(r_flo3,dwork,r_lband)
      call r4tor4 (dwork,iwork(k),2*r_lband)
      k = k + 2*r_lband
      call r8(r_flo4,dwork,r_lband)
      call r4tor4 (dwork,iwork(k),2*r_lband)
      k = k + 2*r_lband
      call i4(r_lpolmode,iwork(k),r_lband)
      k = k + r_lband
      do ii = 1, r_lband
        call i4 (r_lpolentry(1,ii), iwork(k), r_nant)
        k = k + r_nant
      enddo
      if (e%version.le.3) then
        do ii = 1, r_nant
          do j = 1, r_nif
            call r4(r_ifattn(ii,j),ifattn(j,ii,1),1)
          enddo
        enddo
        do ii = 1, r_lband
          call r4 (ifattn,iwork(k),2*r_nant)
          k = k + 2*r_nant
        enddo
      else
        call i4(r_bb,iwork(k),r_lband)
        k = k + r_lband
        call i4(r_if,iwork(k),r_lband)
        k = k + r_lband
        call i4(r_sb,iwork(k),r_lband)
        k = k + r_lband
        call i4(r_stachu,iwork(k),r_lband)
        k = k + r_lband
        call i4(r_nchu,iwork(k),r_lband)
        k = k + r_lband
      endif
      if (e%version.ge.6) then
        do ii = 1, r_lband
          call i4(r_code_stokes(1,ii),iwork(k),r_nbas)
          k = k + r_nbas
        enddo
      endif
    endif
  !
  ! Scanning Section
  elseif (scode.eq.scanning_sec) then
    call i4 (r_scaty,iwork,1)
    k = 2
    call i4 (r_mobil,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_collaz,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_collel,iwork(k),r_nant)
    k = k + r_nant
    !
    if (.not.modify .or. k.le.lensec(scanning_sec)) then
      call r4 (r_corfoc,iwork(k),r_nant)
      k = k + r_nant
    endif
    ! add Pointing Model if possible
    if (.not.modify .or. k.le.lensec(scanning_sec)) then
      call i4(r_pmodel,iwork(k),2) ! r_pmodel and r_npmodel
      k = k+2
      do ii=1, r_nant
        call i4 (r_cpmodel(1,ii),iwork(k),r_npmodel)
        k = k + r_npmodel
      enddo
    endif
    ! add Switching table if possible
    if (.not.modify .or. k.le.lensec(scanning_sec)) then
      call i4(r_nswitch,iwork(k),1)
      k = k + 1
      if (r_nswitch.gt.0) then
        call r4(r_wswitch,iwork(k),r_nswitch)
        k = k + r_nswitch
        call r4(r_pswitch,iwork(k),2*r_nswitch)
        k = k + 2*r_nswitch
      endif
    endif
  !
  ! Atmospheric Calibration Section
  elseif (scode.eq.atparm_sec) then
    call i4 (r_mode,iwork,2)
    call r4 (r_pamb,iwork(3),4)
    k = 7
    if (e%version.le.3) then
      if (r_dobs.lt.(-6406)) then
        temp_dim = r_npol_rec
      else
        temp_dim = mnbcinput + r_nband_widex
      endif
    else
      temp_dim = r_nbb
    endif
    do ii=1, r_nant
      call r4 (r_h2omm(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_tatms(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_tatmi(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_taus(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_taui(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_beef(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_feff(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    ! New generation receiver ipb files had twice feff before 21 Mar 2007
    if ((r_kind.eq.5).and.(r_dobs.lt.-6369)) then
      do ii=1, r_nant
        call r4 (r_feff(1,ii),iwork(k),temp_dim)
        k = k+temp_dim
      enddo
    endif
    do ii=1, r_nant
      call r4 (r_tchop(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_tcold(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_trec(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_gim(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_csky(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_cchop(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_ccold(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_tsyss(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_tsysi(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call r4 (r_ceff(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      call cc (r_cmode(1,ii),iwork(k),temp_dim)
      k = k+temp_dim
    enddo
    do ii=1, r_nant
      if (r_nband_widex.ne.0.or.e%version.gt.3) then
        call r4 (r_jykel(1,ii),iwork(k),temp_dim)
        k = k+temp_dim
      else
        call r4 (r_jykel(1,ii),iwork(k),r_npol_rec)
        k = k+r_npol_rec
      endif
    enddo
    !
    ! Addition aug. 1997
    if (.not.modify .or. k.le.lensec(atparm_sec)) then
      call r4 (r_avwind,iwork(k),4)
      k = k + 4
    endif
    ! 24-jan-1999 extension
    if (.not.modify .or. k.le.lensec(atparm_sec)) then
      call r4 (r_tcabin,iwork(k),r_nant)
      k = k+r_nant
      call r4 (r_tdewar,iwork(k),3*r_nant)
      k = k+3*r_nant
    endif
    ! 01-dec-2006 extension
    if (.not.modify .or. k.le.lensec(atparm_sec)) then
      ! Change of atmospheric calibration on 13-feb-2007
      if (e%version.le.3) then
        if (r_dobs.lt.(-6406)) then
          temp_dim = r_npol_rec
        else
          temp_dim = mnbcinput + r_nband_widex
        endif
      else
        temp_dim = r_nbb
      endif
      do ii=1, r_nant
        call r4 (r_totscale(1,ii),iwork(k),temp_dim)
        k = k+temp_dim
      enddo
    endif
  !
  ! Atmospheric Monitor Section
  elseif (scode.eq.atmon_sec) then
    call i4 (r_nrec_mon,iwork,1)
    call r4 (r_frs_mon,iwork(2),2)
    k = 4
    call r4 (r_h2o_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_tatms_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_tatmi_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_taus_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_taui_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_feff_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_tchop_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_tcold_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_trec_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_gim_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_csky_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_cchop_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_ccold_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_tsys_mon,iwork(k),r_nant)
    k = k + r_nant
    call cc (r_cmode_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_path_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_tem_mon,iwork(k),r_nant)
    k = k + r_nant
    call r4 (r_dpath_mon,iwork(k),r_nant)
    k = k + r_nant
    if (.not.modify .or. k.le.lensec(atmon_sec)) then
      call r4 (r_magic_mon,iwork(k),2)
      k = k + 2
    endif
    ! Addition 12-jan-1999
    if (.not.modify .or. k.le.lensec(atmon_sec)) then
      call i4 (r_ok_mon,iwork(k),r_nant)
      !c            CALL CC (R_OK_MON,IWORK(K),R_NANT)
      k = k + r_nant
    ! for old files, store correction the old way ...
    else
      test = .true.
      do ii=1, mnant
        test = test.and.(r_ok_mon(ii))
      enddo
      if (.not.test) then
        r_nrec_mon = - iabs(r_nrec_mon)
        call i4 (r_nrec_mon,iwork,1)
      endif
    endif
  !
  ! Bandpass Calibration Section
  elseif (scode.eq.bpcal_sec) then
    temp_dim = 1
    if (e%version.le.3) then
      if (new_receivers) then
        temp_dim = mnbcinput + r_nband_widex
      endif
      if (r_nband_widex.eq.0) then
        temp_dim2 = 10
      else
        temp_dim2 = 12
      endif
    else
      temp_dim = r_nbb
      temp_dim2 = r_nband
    endif
    call i4 (r_bpc,iwork,2)
    k = 3
    do ii=1,temp_dim2
      do j=1,r_nbas
        do l=1,2
          do m=1,temp_dim
            call r4 (r_bpccamp(m,l,j,ii),iwork(k),1)
            k = k + 1
          enddo
        enddo
      enddo
    enddo
    do ii=1,temp_dim2
      do j=1,r_nbas
        do l=1,2
          do m=1,temp_dim
            call r4 (r_bpccpha(m,l,j,ii),iwork(k),1)
            k = k+1
          enddo
        enddo
      enddo
    enddo
    do ii=0,r_bpcdeg
      do j=1,r_lband
        do l=1,r_nbas
          do m=1,2
            do n=1,temp_dim
              call r4 (r_bpclamp(n,m,l,j,ii),iwork(k),1)
              k = k+1
            enddo
          enddo
        enddo
      enddo
    enddo
    do ii=0,r_bpcdeg
      do j=1,r_lband
        do l=1,r_nbas
          do m=1,2
            do n=1,temp_dim
              call r4(r_bpclpha(n,m,l,j,ii),iwork(k),1)
              k = k+1
            enddo
          enddo
        enddo
      enddo
    enddo
    do ii=1,r_nbas
	do j = 1, 2
	   do l =1, temp_dim
	      call r4 (r_bpcsba(l,j,ii),iwork(k),2) ! complex
	      k = k + 2 
	   enddo
	enddo
    enddo
    if (r_bpfdeg.ge.0) then
      call i4 (r_bpfdeg,iwork(k),1)
      k = k+1
      do ii=1,temp_dim
        call r4 (r_bpflim(ii,1),iwork(k),1)
        k = k+1
        call r4 (r_bpflim(ii,2),iwork(k),1)
        k = k+1
      enddo
      do ii=0,r_bpfdeg
        do j=1,r_nbas
          do l=1,2
            do m=1,temp_dim
              call r4 (r_bpfamp(m,l,j,ii),iwork(k),1)
              k = k+1
            enddo
          enddo
        enddo
      enddo
      do ii=0,r_bpfdeg
        do j=1,r_nbas
          do l=1,2
            do m=1,temp_dim
              call r4 (r_bpfpha(m,l,j,ii),iwork(k),1)
              k = k+1
            enddo
          enddo
        enddo
      enddo
    endif
  !
  ! Antenna Bandpass Calibration Section
  elseif (scode.eq.abpcal_sec) then
    temp_dim = 1
    if (e%version.le.3) then
      if (new_receivers) then
        temp_dim = mnbcinput + r_nband_widex
      endif
      if (r_nband_widex.eq.0) then
        temp_dim2 = 10
      else
        temp_dim2 = 12
      endif
    else
      temp_dim = r_nbb
      temp_dim2 = r_nband
    endif
    call i4 (r_abpc,iwork,2)
    k = 3
    do ii=1,temp_dim2
      do j=1,r_nant
        do l=1,2
          do m=1,temp_dim
            call r4 (r_abpccamp(m,l,j,ii),iwork(k),1)
            k = k + 1
          enddo
        enddo
      enddo
    enddo
    do ii=1,temp_dim2
      do j=1,r_nant
        do l=1,2
          do m=1,temp_dim
            call r4 (r_abpccpha(m,l,j,ii),iwork(k),1)
            k = k+1
          enddo
        enddo
      enddo
    enddo
    do ii=0,r_abpcdeg
      do j=1,r_lband
        do l=1,r_nant
          do m=1,2
            do n=1,temp_dim
              call r4 (r_abpclamp(n,m,l,j,ii),iwork(k),1)
              k = k+1
            enddo
          enddo
        enddo
      enddo
    enddo
    do ii=0,r_abpcdeg
      do j=1,r_lband
        do l=1,r_nant
          do m=1,2
            do n=1,temp_dim
              call r4(r_abpclpha(n,m,l,j,ii),iwork(k),1)
              k = k+1
            enddo
          enddo
        enddo
      enddo
    enddo
    do ii=1,r_nant
	do j = 1, 2
	   do l =1, temp_dim
	      call r4 (r_abpcsba(l,j,ii),iwork(k),2) ! complex
	      k = k + 2 
	   enddo
	enddo
    enddo
    if (r_abpfdeg.ge.0) then
      call i4 (r_abpfdeg,iwork(k),1)
      k = k+1
      do ii=1,temp_dim
        call r4 (r_abpflim(ii,1),iwork(k),1)
        k = k+1
        call r4 (r_abpflim(ii,2),iwork(k),1)
        k = k+1
      enddo
      do ii=0,r_abpfdeg
        do j=1,r_nant
          do l=1,2
            do m=1,temp_dim
              call r4 (r_abpfamp(m,l,j,ii),iwork(k),1)
              k = k+1
            enddo
          enddo
        enddo
      enddo
      do ii=0,r_abpfdeg
        do j=1,r_nant
          do l=1,2
            do m=1,temp_dim
              call r4 (r_abpfpha(m,l,j,ii),iwork(k),1)
              k = k+1
            enddo
          enddo
        enddo
      enddo
    endif
  !
  ! "Instrumental" calibration section
 elseif (scode.eq.ical_sec) then
    call i4 (r_ic,iwork,2)
    k = 3
    if (new_receivers) then
       do ii=1,r_npol_rec
          do j=1,2
             do l=1,r_nbas
                do m=0,r_icdeg
                   call r4 (r_icamp(ii,j,l,m),iwork(k),1)
                   k = k + 1
                enddo
             enddo
          enddo
       enddo
    else
       do m=0,r_icdeg
          do l=1,r_nbas
             do j=1,2
                do ii=1,r_npol_rec
                   call r4 (r_icamp(ii,j,l,m),iwork(k),1)
                   k = k + 1
                enddo
             enddo
          enddo
       enddo
    endif
    if (new_receivers) then
       do ii=1,r_npol_rec
          do j=1,2
             do l=1,r_nbas
                do m=0,r_icdeg
                   call r4 (r_icpha(ii,j,l,m),iwork(k),1)
                   k = k + 1
                enddo
             enddo
          enddo
       enddo
    else
       do m=0,r_icdeg 
          do l=1,r_nbas 
             do j=1,2
                do ii=1,r_npol_rec
                   call r4 (r_icpha(ii,j,l,m),iwork(k),1)
                   k = k + 1
                enddo
             enddo
          enddo
       enddo
    endif
    if (new_receivers) then
       do ii=1,r_npol_rec
          do j=1,2
             do l=1,r_nbas
                call r4(r_icrms(ii,j,l,1),iwork(k),1)
                k = k + 1
                call r4(r_icrms(ii,j,l,2),iwork(k),1)
                k = k + 1
             enddo
          enddo
       enddo
    else
       do l=1,r_nbas
          do j=1,2
             do ii=1,r_npol_rec
                call r4(r_icrms(ii,j,l,1),iwork(k),1)
                k = k + 1
                call r4(r_icrms(ii,j,l,2),iwork(k),1)
                k = k + 1
             enddo
          enddo
       enddo
    endif
  !
  ! Antenna "Instrumental" Calibration Section
 elseif (scode.eq.aical_sec) then
    call i4 (r_aic,iwork,2)
    k = 3
    if (new_receivers) then
       do ii=1,r_npol_rec
          do j=1,2
             do l=1,r_nant
                do m=0,r_aicdeg
                   call r4 (r_aicamp(ii,j,l,m),iwork(k),1)
                   k = k + 1
                enddo
             enddo
          enddo
       enddo
    else
       do m=0,r_aicdeg
          do l=1,r_nant
             do j=1,2
                do ii=1,r_npol_rec
                   call r4 (r_aicamp(ii,j,l,m),iwork(k),1)
                   k = k + 1
                enddo
             enddo
          enddo
       enddo
    endif
    if (new_receivers) then
       do ii=1,r_npol_rec
          do j=1,2
             do l=1,r_nant
                do m=0,r_aicdeg
                   call r4 (r_aicpha(ii,j,l,m),iwork(k),1)
                   k = k + 1
                enddo
             enddo
          enddo
       enddo
    else
       do m=0,r_aicdeg
          do l=1,r_nant
             do j=1,2
                do ii=1,r_npol_rec
                   call r4 (r_aicpha(ii,j,l,m),iwork(k),1)
                   k = k + 1
                enddo
             enddo
          enddo
       enddo
    endif
    if (new_receivers) then
       do ii=1,r_npol_rec
          do j=1,2
             do l=1,r_nant
                call r4(r_aicrms(ii,j,l,1),iwork(k),1)
                k = k + 1
                call r4(r_aicrms(ii,j,l,2),iwork(k),1)
                k = k + 1
             enddo
          enddo
       enddo
    else
       do l=1,r_nant
          do j=1,2
             do ii=1,r_npol_rec
                call r4(r_aicrms(ii,j,l,1),iwork(k),1)
                k = k + 1
                call r4(r_aicrms(ii,j,l,2),iwork(k),1)
                k = k + 1
             enddo
          enddo
       enddo
    endif
    if (e%version.ge.5) then
      do ii=1, r_nbb
        call r4(r_dx(1,ii),iwork(k),2*r_nant)
        k = k + 2*r_nant
      enddo
      do ii=1, r_nbb
        call r4(r_dy(1,ii),iwork(k),2*r_nant)
        k = k + 2*r_nant
      enddo
    endif
  !
  ! Data description Section
  elseif (scode.eq.descr_sec) then
    if (e%version.eq.1) then
      ! r_ndump
      k = 1          
      call i4(r_ndump,iwork(k),1)
      ! r_ldpar
      call i8toi4_fini(r_ldpar,i4value,1,error)
      if (error) then
         write (chain, '(A,I0)') 'Header data length too large for '// &
           'v1: r_ldpar = ',r_ldpar
         l = lenc(chain)
         call message(8,3,'WSEC',chain(1:l))
         error = .true.
         return
      endif
      k = k+1
      call i4(i4value,iwork(k),1)
      ! r_ldatc
      call i8toi4_fini(r_ldatc,i4value,1,error)
      if (error) then
         write (chain, '(A,I0)') 'Continuum data length too large for '// &
           'v1: r_ldatc = ',r_ldatc
         l = lenc(chain)
         call message(8,3,'WSEC',chain(1:l))
         error = .true.
         return
      endif
      k = k+1
      call i4(i4value,iwork(k),1)
      ! r_ldatl
      call i8toi4_fini(r_ldatl,i4value,1,error)
      if (error) then
         write (chain, '(A,I0)') 'Header data length too large for '// &
           'v1: r_ldatl = ',r_ldatl
         l = lenc(chain)
         call message(8,3,'WSEC',chain(1:l))
         error = .true.
         return
      endif
      k = k+1
      call i4(i4value,iwork(k),1)
      ! r_ldump
      call i8toi4_fini(r_ldump,i4value,1,error)
      if (error) then
         write (chain, '(A,I0)') 'Header data length too large for v1: '// &
           'v1: r_ldump = ',r_ldump
         l = lenc(chain)
         call message(8,3,'WSEC',chain(1:l))
         error = .true.
         return
      endif
      k = k+1
      call i4(i4value,iwork(k),1)
      ! r_ndatl
      k = k+1
      call i4 (r_ndatl,iwork(k),1)    
      k = k+1
    elseif (e%version.ge.2) then
      call i4(r_ndump,iwork,2)
      call i8(r_ldpar,lwork,4)
      call w4tow4(lwork,iwork(3),8) 
    endif
  !
  ! Data modifier section
  elseif (scode.eq.modify_sec) then
    call r4(r_dmaflag,iwork,r_nant)
    k = 1+r_nant
    call r4(r_dmbflag,iwork(k),r_nbas)
    k = k+r_nbas
    ! r_dmatfac
    if (e%version.le.3) then
      do ii=1, r_nant
        do j=1, 2
          do l=1, r_nbb
            m = r_mapbb(l)
            n = r_mappol(ii,l)
            dmatfac(n,j,ii) = r_dmatfac(m,j,ii)
          enddo
          call r4 (dmatfac(1,j,ii),iwork(k),r_npol_rec)
          k = k + r_npol_rec
        enddo
      enddo
    else
      do ii=1, r_nant
        do j=1, 2
          call r4(r_dmatfac(1,j,ii),iwork(k),r_nbb)
          k = k + r_nbb
        enddo
      enddo
    endif
    ! r_dmdelay
    if (e%version.le.3) then
      do ii=1, r_nant
        do j=1, r_nbb
          m = r_mappol(ii,j)
          dmdelay(m,ii) = r_dmdelay(j,ii)
        enddo
        call r4 (dmdelay(1,ii),iwork(k),r_npol_rec)
        k = k + r_npol_rec
      enddo
    else
      do ii=1, r_nant
        call r4(r_dmdelay(1,ii),iwork(k),r_nbb)
        k = k + r_nbb
      enddo
    endif
    !
    do ii=1, r_nband
      call r4(r_dmcamp(1,1,ii),iwork(k),2*r_nbas)
      k = k+2*r_nbas
      call r4(r_dmcpha(1,1,ii),iwork(k),2*r_nbas)
      k = k+2*r_nbas
    enddo
    do ii=1, r_lband
      call r4(r_dmlamp(1,1,ii),iwork(k),2*r_nbas)
      k = k+2*r_nbas
      call r4(r_dmlpha(1,1,ii),iwork(k),2*r_nbas)
      k = k+2*r_nbas
      call r4(r_dmldph(1,1,ii),iwork(k),2*r_nbas)
      k = k+2*r_nbas
    enddo
    ! Apr-2010 extension
    if (e%version.le.3) then
      dmsaflag = 0
      do j= 1, r_nant
        do ii = 1, 16
           if (r_dmsaflag(ii,j))  dmsaflag(j)= ibset(dmsaflag(j),ii-1)
           if (r_dmsaflag(ii+mbands,j))  dmsaflag(j)= ibset(dmsaflag(j),ii+15)
        enddo
      enddo
      dmsbflag = 0
      do j = 1, r_nbas
        do ii = 1, 16
           if (r_dmsbflag(ii,j)) dmsbflag(j)= ibset(dmsbflag(j),ii-1)
           if (r_dmsbflag(ii+mbands,j)) dmsbflag(j)= ibset(dmsbflag(j),ii+15)
        enddo
      enddo
      if (.not.modify .or. k.le.lensec(modify_sec).and.r_nband_widex.ne.0) then
        call i4 (dmsaflag,iwork(k),r_nant)
        k = k + r_nant
        call i4 (dmsbflag,iwork(k),r_nbas)
        k = k + r_nbas
      else
        ! Copy spectral flags to r_dmaflag 
        do j = 1, r_nant
           do ii=1, 10 ! Ignore spectral flags greater than C10 (no room)
              mask = 0
              mask = iand(dmsaflag(j),ior(mask,ishft(1,ii-1)))
              if (mask.ne.0) then
                r_dmaflag(j) = ibset(r_dmaflag(j),ii-1)
                dmsaflag(j) = ibclr(dmsaflag(j),ii-1)
              endif
           enddo
           do ii=1,8 ! Ignore spectral flags greater than L08 (no room)
              mask = 0
              mask = iand(dmsaflag(j),ior(mask,ishft(1,ii-1+mbands)))
              if (mask.ne.0) then
                r_dmaflag(j) = ibset(r_dmaflag(j),ii+9)
                dmsaflag(j) = ibclr(dmsaflag(j),ii-1+mbands)
              endif
           enddo
        enddo
        call r4(r_dmaflag,iwork,r_nant)
        ! ... and the same for baselines.
        do j = 1, r_nbas
           do ii=1, 10
              mask = 0
              mask = iand(dmsbflag(j),ior(mask,ishft(1,ii-1)))
              if (mask.ne.0) then
                r_dmbflag(j) = ibset(r_dmbflag(j),ii-1)
                dmsbflag(j) = ibclr(dmsbflag(j),ii-1)
              endif
           enddo
           do ii=1,8
              mask = 0
              mask = iand(dmsbflag(j),ior(mask,ishft(1,ii-1+mbands)))
              if (mask.ne.0) then
                r_dmbflag(j) = ibset(r_dmbflag(j),ii+9)
                dmsbflag(j) = ibclr(dmsbflag(j),ii-1+mbands)
              endif
           enddo
        enddo
        call r4(r_dmbflag,iwork(1+r_nant),r_nbas)
      endif
    else
      nword= int(r_lband/32)+1
      do ii=1, r_nant
        l = 0
        do j=1, nword
          dummy = 0
          do m=1, 32
            l = l+1
            if (l.le.r_lband) then
              if (r_dmsaflag(l,ii)) dummy = ibset(dummy,m-1)
            endif
          enddo
          call i4(dummy,iwork(k),1)
          k = k+1
        enddo
      enddo
      do ii=1, r_nant
        l = 0
        do j=1, nword
          dummy = 0
          do m=1, 32
            l = l+1
            if (l.le.r_lband) then
              if (r_dmsaflag(l+mbands,ii)) dummy = ibset(dummy,m-1)
            endif
          enddo
          call i4(dummy,iwork(k),1)
          k = k+1
        enddo
      enddo
      do ii=1, r_nbas
        l = 0
        do j=1, nword
          dummy = 0
          do m=1, 32
            l = l+1
            if (l.le.r_lband) then
              if (r_dmsbflag(l,ii)) dummy = ibset(dummy,m-1)
            endif
          enddo
          call i4(dummy,iwork(k),1)
          k = k+1
        enddo
      enddo
      do ii=1, r_nbas
        l = 0
        do j=1, nword
          dummy = 0
          do m=1, 32
            l = l+1
            if (l.le.r_lband) then
              if (r_dmsbflag(l+mbands,ii)) dummy = ibset(dummy,m-1)
            endif
          enddo
          call i4(dummy,iwork(k),1)
          k = k+1
        enddo
      enddo
    endif
  !
  ! Data file section
  elseif (scode.eq.file_sec) then
    call i4(r_dxnum,iwork,1)
    k = 2
    kk= 32                     ! KK = LENC(R_DFILE)
    call chtoby(r_dfile,ichain,kk)
    kk= 8                      ! KK = INT(KK/4)+1   ! words
    call cc(ichain,iwork(k),kk)
    k = k+kk
  !
  ! Water vapor radiometer section
  elseif (scode.eq.wvr_sec) then
    call i4(r_wvrnch,iwork,r_nant)
    k = 1+r_nant
    do ii=1, r_nant
      call r4(r_wvrfreq(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrbw(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
    enddo
    call r4(r_wvrtamb,iwork(k),r_nant)
    k = k+r_nant
    call r4(r_wvrtpel,iwork(k),r_nant)
    k = k+r_nant
    do ii=1, r_nant
      call r4(r_wvrtcal(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrref(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvraver(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvramb(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrtrec(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrfeff(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      !*!
      call r4(r_wvrlabtcal(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrlabtrec(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrlabtdio(1,ii),iwork(k),mwvrch)
      k = k+mwvrch             !*!
    enddo
    call i4(r_wvrmode,iwork(k),r_nant)
    k = k+r_nant
    call r4(r_wvrh2o,iwork(k),r_nant)
    k = k+r_nant
    call r4(r_wvrpath,iwork(k),r_nant)
    k = k+r_nant
    do ii=1, r_nant
      call r4(r_wvrtsys(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrdpath(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrfpath(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      call r4(r_wvrliq(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
      !*!
      call r4(r_wvrdcloud(1,ii),iwork(k),mwvrch)
      k = k+mwvrch
    enddo
    call r4(r_wvrtatm,iwork(k),r_nant)
    k = k+r_nant
    call i4(r_wvrqual,iwork(k),r_nant)
    k = k+r_nant
    if (e%version.ge.3) then
      call i4(r_wvravertime,iwork(k),1)
      k = k+1
    endif
  !
  ! S.D.Holo. section
  elseif (scode.eq.alma_sec) then
    call r4 (r_trandist,iwork,2)
    k = 3
    call i4 (r_subscan,iwork(k),2)
    k = k+2
    call chtoby(r_execblock,ichain,256)
    call cc(ichain,iwork(k),64)
    k = k+64
    do ii=1, r_nant
      call chtoby(r_antennaname(ii),ichain,32)
      call cc(ichain,iwork(k),8)
      k = k+8
    enddo
    do ii=1, r_nant
      call chtoby(r_antennatype(ii),ichain,32)
      call cc(ichain,iwork(k),8)
      k = k+8
    enddo
    call r4tor4(r_dishdiameter,iwork(k),r_nant)
    k = k+r_nant
  elseif (scode.eq.monitor_sec) then
    k = 1
    do ii=1, 2
      call r4 (r_attenuation_hiq(1,ii), iwork(k), r_nant)
      k = k + r_nant
    enddo
    do ii=1, r_nif
      call r4 (r_laser_level(1,ii), iwork(k),  r_nant)
      k = k+r_nant
    enddo
    if (e%version.le.3) then
      call r4 (r_widex_temperature, iwork(k), 4)
      k = k+4
    endif
  elseif (scode.eq.status_sec) then
    k = 1
    call chtoby(r_status,ichain,12)
    call cc(ichain,iwork(k),3)
    k = k+3
    call chtoby(r_substatus,ichain,12)
    call cc(ichain,iwork(k),3)
    k = k+3
    call chtoby(r_comm,ichain,140)
    call cc(ichain,iwork(k),35)
    k = k+35
  elseif (scode.eq.vlbi_sec) then
    ! No observation version as version 5 was never written
    k = 1
    call i4 (r_refant,iwork(k),1)
    k = k+1
    call i4 (r_comparison_ant,iwork(k),1)
    k = k+1
    call i4 (r_nant_vlbi,iwork(k),1)
    k = k+1
    call r4 (r_maser_gps_diff,iwork(k),1)
    k = k+1
    call r4 (r_efftsys,iwork(k),r_nbb)
    k = k+r_nbb
    call i4 (r_antmask,iwork(k),r_nant_vlbi)
    k = k+r_nant_vlbi
  endif
  !
  ! Now write it
!  print *,"cwall section ",scode," section length ",k-1
  len = k-1
end subroutine scwsec

program histo_cross
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF
  ! Main program for making a cross histogram from two images/data cubes
  !---------------------------------------------------------------------
  ! Local
  type(gildas) :: in1,in2,out
  character(len=filename_length) :: namez,namey,namex
  logical :: error
  real(kind=4) :: hzmin,hzmax,hzstep, hymin,hymax,hystep
  integer(kind=4) :: n, nhz, nhy,ier
  integer(kind=index_length) :: i
  !
  error = .false.
  !
  call gildas_open
  call gildas_char('Z_NAME$',namez)
  call gildas_inte('Z_BINS$',nhz,1)
  call gildas_real('Z_MIN$',hzmin,1)
  call gildas_real('Z_MAX$',hzmax,1)
  call gildas_char('Y_NAME$',namey)
  call gildas_inte('Y_BINS$',nhy,1)
  call gildas_real('Y_MIN$',hymin,1)
  call gildas_real('Y_MAX$',hymax,1)
  call gildas_char('X_NAME$',namex)
  call gildas_close
  !
  ! Read input cubes
  !
  call gildas_null(in1)
  call gdf_read_gildas(in1,namez,'.gdf',error,rank=3)
  if (error) call sysexi(fatale)
  !
  call gildas_null(in2)
  call gdf_read_gildas(in2,namey,'.gdf',error,rank=3)
  if (error) call sysexi(fatale)
  !
  ! Define output histogram
  n = len_trim(namex)
  if (n.eq.0) call sysexi(fatale)
  call gildas_null(out)
  call gdf_copy_header(in1,out,error)
  call sic_parsef(namex(1:n),out%file,' ','.gdf')
  !
  ! Check 3rd axis: Both input cubes must match
  if (in1%gil%ndim.ne.in2%gil%ndim) then
     call gagout('E-HISTO_CROSS,  Input data cubes do not match')
     call sysexi(fatale)
  endif
  !
  ! Thresholds : Read or compute.
  !
  if (hzmin.eq.0. .and. hzmax.eq.0.) then
    call histo_cross_minmax(in1%r3d,in1%gil%dim(1),in1%gil%dim(2),in1%gil%dim(3),&
         in1%gil%bval,in1%gil%eval,hzmin,hzmax)
  endif
  if (hymin.eq.0. .and. hymax.eq.0.) then
    call histo_cross_minmax(in2%r3d,in2%gil%dim(1),in2%gil%dim(2),in2%gil%dim(3),&
         in2%gil%bval,in2%gil%eval,hymin,hymax)
  endif
  hzstep = (hzmax-hzmin)/(nhz-1)
  hystep = (hymax-hymin)/(nhy-1)
  !
  ! Initialize Header
  !
  out%gil%form    = fmt_r4
  out%gil%ndim    = in1%gil%ndim
  out%gil%dim(1)  = nhz
  out%gil%dim(2)  = nhy
  out%gil%dim(3)  = in1%gil%dim(3)
  out%gil%ref(1)  = 1.d0
  out%gil%val(1)  = hzmin
  out%gil%inc(1)  = hzstep
  out%gil%ref(2)  = 1.d0
  out%gil%val(2)  = hymin
  out%gil%inc(2)  = hystep
  out%gil%convert(:,3) = in1%gil%convert(:,3)
  ! EXTREMA
  out%gil%extr_words = 0  ! No more
  ! POSITION: nothing relevant except...
 !out%char%name   = kept from input for bookkeeping
  out%char%syst   = ' '
  out%gil%ra      = 0.d0
  out%gil%dec     = 0.d0
  out%gil%lii     = 0.d0
  out%gil%bii     = 0.d0
  out%gil%epoc    = 0.d0
  ! PROJECTION
  out%gil%proj_words = 0  ! No more
  ! SPECTROSCOPY
  out%gil%spec_words = 12
  out%gil%freq    = in1%gil%freq
  out%gil%voff    = in1%gil%voff
  out%gil%vres    = in1%gil%vres
  out%gil%fima    = in1%gil%fima
  out%gil%fres    = in1%gil%fres
  out%gil%faxi    = in1%gil%faxi
  out%gil%bval    = 0.d0
  out%gil%eval    = -1.d0
  ! DESCRIPTION
  out%char%code(1)= in1%char%unit     ! X axis covers the 1st input data scale
  out%char%code(2)= in2%char%unit     ! Y axis covers the 2nd input data scale
  out%char%code(3)= in1%char%code(3)  ! Same freq axis
  out%char%code(4)= 'UNKNOWN     '    ! Clean 4th axis
  out%char%unit   = 'pixels/bin  '    ! Data array unit
  !
  ! Change boundaries
  !
  hzmin = hzmin - 0.5*hzstep
  hzmax = hzmax + 0.5*hzstep
  hymin = hymin - 0.5*hystep
  hymax = hymax + 0.5*hystep
  !
  ! Zero projection information
  !
  allocate(out%r3d(nhz,nhy,out%gil%dim(3)),stat=ier)
  if (ier.ne.0) then
    call gagout('E-HISTO_CROSS, Memory allocation error')
    call sysexi(fatale)
  endif
  !
  ! Compute cross histogram for each plane
  !
  do i=1,out%gil%dim(3)
    call histo001(  &
        in1%r3d(:,:,i), in2%r3d(:,:,i),                       &
        in1%gil%dim(1),in1%gil%dim(2),                       &
        in1%gil%bval,in1%gil%eval,in2%gil%bval,in2%gil%eval, &
        hzmin,hzstep,hzmax,hymin,hystep,hymax,               &
        out%gil%dim(1),out%gil%dim(2),out%r3d(:,:,i))
  enddo
  !
  ! Write the output image
  !
  call gdf_write_image(out,out%r3d,error)
  if (error) then
    call gagout('E-HISTO_CROSS, Error writing output image')
    call sysexi(fatale)
  endif
  !
  ! Normal end
  !
  call gagout('S-HISTO_CROSS,  Successful completion')
  call sysexi (1)
  !
end program histo_cross
!
subroutine histo001 (z,y,nx,ny,zbval,zeval,ybval,yeval,  &
     pzmin,pzstep,pzmax,pymin,pystep,pymax,  &
     nhz,nhy,h)
  use gildas_def
  !---------------------------------------------------------------------
  ! GDF
  ! Computes the crossed histogram map of two images.
  !	Input images must have the same blanking value and
  !	be coincident. Histogram parameters must have been
  !	defined in a coherent way before.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nx          ! 1st dimension of input images
  integer(kind=index_length), intent(in)  :: ny          ! 2nd dimension of input images
  real(kind=4),               intent(in)  :: z(nx,ny)    ! first input image
  real(kind=4),               intent(in)  :: y(nx,ny)    ! second input image
  real(kind=4),               intent(in)  :: zbval       ! blanking value of 1st input image
  real(kind=4),               intent(in)  :: zeval       ! tolerance on blanking value
  real(kind=4),               intent(in)  :: ybval       ! blanking value of 2nd input image
  real(kind=4),               intent(in)  :: yeval       ! tolerance on blanking value
  real(kind=4),               intent(in)  :: pzmin       ! low threshold for z input array
  real(kind=4),               intent(in)  :: pzstep      ! histogram step for z input array
  real(kind=4),               intent(in)  :: pzmax       ! max threshold for z input array
  real(kind=4),               intent(in)  :: pymin       ! low threshold for y input array
  real(kind=4),               intent(in)  :: pystep      ! histogram step for y input array
  real(kind=4),               intent(in)  :: pymax       ! max threshold for y input array
  integer(kind=index_length), intent(in)  :: nhz         ! 1st dim of output image
  integer(kind=index_length), intent(in)  :: nhy         ! 2nd dim of output image
  real(kind=4),               intent(out) :: h(nhz,nhy)  ! histogram array
  ! Local
  integer(kind=index_length) :: i,j,iz,jy
  integer(kind=size_length) :: nin,nout,nblank,ntot
  !
  h(:,:) = 0.
  nin    = 0
  nout   = 0
  nblank = 0
  !
  if (zeval.ge.0.0 .and. yeval.ge.0) then
    !
    do j=1,ny
      do i=1,nx
        if (abs(z(i,j)-zbval).gt.zeval.and.abs(y(i,j)-ybval).gt.yeval) then
          if (z(i,j).ge.pzmin.and.z(i,j).lt.pzmax) then
            iz = int((z(i,j)-pzmin)/pzstep) + 1
            if (y(i,j).ge.pymin .and. y(i,j).lt.pymax) then
              jy = int((y(i,j)-pymin)/pystep) + 1
              h(iz,jy) = h(iz,jy)+1.0
              nin = nin+1
            else
              nout = nout+1
            endif
          else
            nout = nout+1
          endif
        else
          nblank = nblank+1
        endif
      enddo
    enddo
    !
  else
    !
    do j=1,ny
      do i=1,nx
        if (z(i,j).ge.pzmin .and. z(i,j).lt.pzmax) then
          iz = int((z(i,j)-pzmin)/pzstep) + 1
          if (y(i,j).ge.pymin .and. y(i,j).le.pymax) then
             jy = int((y(i,j)-pymin)/pystep) + 1
             h(iz,jy) = h(iz,jy)+1.0
             nin = nin+1
          else
             nout = nout+1
          endif
        else
          nout = nout+1
        endif
      enddo
    enddo
    !
  endif
  !
  ntot = nin+nout+nblank
  write(6,100) &
       nin,   float(nin)   /float(ntot)*1.e2,  &
       nout,  float(nout)  /float(ntot)*1.e2,  &
       nblank,float(nblank)/float(ntot)*1.e2,  &
       ntot
100 format(1x,'Number of points in histogram ',i8,4x,f5.1,' Z',  &
         /,'   "    "    "    out of  "    ',i8,4x,f5.1,' %',    &
         /,'   "    "    "    blanked      ',i8,4x,f5.1,' %',    &
         /,'                  Total      = ',i8)
end subroutine histo001
!
subroutine histo_cross_minmax(in,nx,ny,nz,bval,eval,low,high)
  use gildas_def
  !---------------------------------------------------------------------
  ! Computes the extrema of an 3D array
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nx            !
  integer(kind=index_length), intent(in)  :: ny            !
  integer(kind=index_length), intent(in)  :: nz            !
  real(kind=4),               intent(in)  :: in(nx,ny,nz)  !
  real(kind=4),               intent(in)  :: bval          !
  real(kind=4),               intent(in)  :: eval          !
  real(kind=4),               intent(out) :: low           !
  real(kind=4),               intent(out) :: high          !
  ! Local
  real(kind=4), dimension(nx,ny) :: wmin,wmax
  !
  if (eval.ge.0.) then
    wmin = minval(in,3,mask=(abs(in-bval).gt.eval))
    wmax = maxval(in,3,mask=(abs(in-bval).gt.eval))
    low  = minval(wmin)
    high = maxval(wmax)
  endif
end subroutine histo_cross_minmax

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_ancillary_refhead_types
  use cubemain_messaging
  use cubeadm_ancillary_cube_types
  !
  public :: ancillary_refhead_comm_t,ancillary_refhead_user_t,ancillary_refhead_prog_t
  private
  !
  type, extends(ancillary_cube_comm_t) :: ancillary_refhead_comm_t
   contains
     procedure, public :: register => cubemain_ancillary_refhead_comm_register
  end type ancillary_refhead_comm_t
  !
  type, extends(ancillary_cube_user_t) :: ancillary_refhead_user_t
     ! Empty for the moment
  end type ancillary_refhead_user_t
  !
  type, extends(ancillary_cube_prog_t) :: ancillary_refhead_prog_t
     ! Empty for the moment
  end type ancillary_refhead_prog_t
  !
contains
  !
  subroutine cubemain_ancillary_refhead_comm_register(key,commname,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! Register an optional "/LIKE [referenceid]" key
    ! ***JP: For the moment I register the key name as /LIKE to be compatible
    ! ***JP: with all the commands. But I suspect that getting a reference
    ! ***JP: refhead can be useful in other cases. That's why the module is
    ! ***JP: called cubemain_ancillary_refhead_types instead of
    ! ***JP: cubemain_ancillary_like_types
    !----------------------------------------------------------------------
    class(ancillary_refhead_comm_t), intent(inout) :: key
    character(len=*),                intent(in)    :: commname
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='ANCILLARY>REFHEAD>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call key%fully_register(&
         'LIKE','[referenceid]',&
         'Define a reference header for the '//trim(commname)//' command',&
         strg_emp,&
         'LIKE',&
         'Reference header',&
         [flag_any],&
         code_arg_mandatory,&
         code_read_head,&
         code_access_any,&  ! For a header only, any access is acceptable. Is
                            ! there any use case where we would like to force
                            ! it e.g. speset?
         error)
    if (error) return
  end subroutine cubemain_ancillary_refhead_comm_register
end module cubemain_ancillary_refhead_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

* DECK srscl.f
      SUBROUTINE SRSCL( N, SA, SX, INCX )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      REAL               SA
*     ..
*     .. Array Arguments ..
      REAL               SX( * )
*     ..
*
*  Purpose
*  =======
*
*  SRSCL multiplies an n-element real vector x by the real scalar 1/a.
*  This is done without overflow or underflow as long as
*  the final result x/a does not overflow or underflow.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of components of the vector x.
*
*  SA      (input) REAL
*          The scalar a which is used to divide each component of x.
*          SA must be >= 0, or the subroutine will divide by zero.
*
*  SX      (input/output) REAL array, dimension
*                         (1+(N-1)*abs(INCX))
*          The n-element vector x.
*
*  INCX    (input) INTEGER
*          The increment between successive values of the vector SX.
*          > 0:  SX(1) = X(1) and SX(1+(i-1)*INCX) = x(i),     1< i<= n
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            DONE
      REAL               BIGNUM, CDEN, CDEN1, CNUM, CNUM1, MUL, SMLNUM
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLABAD, SSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
*     Get machine parameters
*
      SMLNUM = SLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL SLABAD( SMLNUM, BIGNUM )
*
*     Initialize the denominator to SA and the numerator to 1.
*
      CDEN = SA
      CNUM = ONE
*
   10 CONTINUE
      CDEN1 = CDEN*SMLNUM
      CNUM1 = CNUM / BIGNUM
      IF( ABS( CDEN1 ).GT.ABS( CNUM ) .AND. CNUM.NE.ZERO ) THEN
*
*        Pre-multiply X by SMLNUM if CDEN is large compared to CNUM.
*
         MUL = SMLNUM
         DONE = .FALSE.
         CDEN = CDEN1
      ELSE IF( ABS( CNUM1 ).GT.ABS( CDEN ) ) THEN
*
*        Pre-multiply X by BIGNUM if CDEN is small compared to CNUM.
*
         MUL = BIGNUM
         DONE = .FALSE.
         CNUM = CNUM1
      ELSE
*
*        Multiply X by CNUM / CDEN and return.
*
         MUL = CNUM / CDEN
         DONE = .TRUE.
      END IF
*
*     Scale the vector X by MUL
*
      CALL SSCAL( N, MUL, SX, INCX )
*
      IF( .NOT.DONE )
     $   GO TO 10
*
      RETURN
*
*     End of SRSCL
*
      END

subroutine tofits(fits,check,error)
  use gbl_message
  use image_def
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>tofits
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! GFITS
  !     Write GILDAS data set to FITS tape
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: fits   !
  logical,      intent(in)    :: check  ! Verbose flag
  logical,      intent(out)   :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='UVFITS'
  character(len=message_length) :: mess
  !
  if (fd%snbit.ne.16 .and. fd%snbit.ne.32 .and. fd%snbit.ne.-32 .and. fd%snbit.ne.-64) then
    call gio_message(seve%e,rname,'Unsupported number of bits')
    error = .true.
    return
  endif
  !
  if (gdfname.ne.' ') then
    !
    ! If a file name is specified in GDFNAME common variable,  
    ! read the corresponding file into the "fits" Gildas header given as argument
    call gildas_null(fits)
    call sic_parsef(gdfname,fits%file,' ','.gdf')
    call gio_geis (fits%loca%islo,error)
    if (.not.error) call gio_reis (fits%loca%islo,fits%char%type,fits%file,fits%gil%form,fits%loca%size,error)
    if (error) return
    !
    if (a_style.ne.code_fits_uvfits.and.a_style.ne.code_fits_aips) then
      if (a_style.eq.0 .and. fits%char%type(1:9).eq.'GILDAS_UV') then
        call gio_message(seve%i,'UVFITS','Gildas file is a UV data set')
        call gio_read_header(fits,fits%loca%islo,error)
        if (fits%gil%type_gdf .ne. code_gdf_uvt) then
          write(mess,100) 'Wrong axis type or order',fits%char%code
          call gio_message(seve%e,rname,mess)
          error = .true.
          return
        endif
        call gio_gems (fits%loca%mslo,fits%loca%islo,fits%blc,fits%trc,fits%loca%addr,fits%gil%form,error)
        if (error) return
        call to_uvfits(fits,check,error)
      else if (fits%char%type.ne.'GILDAS_IMAGE') then
        call gio_message(seve%e,'IMFITS','Gildas file is not an image')
        error = .true.
        return
      else
        call gio_read_header(fits,fits%loca%islo,error)
        if (error) return
        call gio_gems(fits%loca%mslo,fits%loca%islo,fits%blc,fits%trc,fits%loca%addr,fits%gil%form,error)
        call to_imfits(fits,check,error)
      endif
    else
      if (fits%char%type(1:9).ne.'GILDAS_UV') then
        call gio_message(seve%e,rname,'Gildas file is not a raw UV data set')
        error = .true.
        return
      endif
      call gio_read_header(fits,fits%loca%islo,error)
      if (fits%char%code(1)(1:2).ne.'UV' .or. fits%char%code(2).ne.'RANDOM') then
        write(mess,100) 'Wrong axis type or order',fits%char%code
        call gio_message(seve%e,rname,mess)
        error = .true.
        return
      endif
      call gio_gems (fits%loca%mslo,fits%loca%islo,fits%blc,fits%trc,fits%loca%addr,fits%gil%form,error)
      if (error) return
      call to_uvfits(fits,check,error)
    endif
    call gio_fris (fits%loca%islo,error)
    ! 
  else
    !
    ! If no file name is present, the "fits" Gildas header already contains the data
    if (a_style.ne.code_fits_uvfits.and.a_style.ne.code_fits_aips) then
      if (a_style.eq.0 .and. fits%char%type(1:9).eq.'GILDAS_UV') then
        call gio_message(seve%i,'UVFITS','Gildas file is a UV data set')
        if (fits%gil%type_gdf .ne. code_gdf_uvt) then
          write(mess,100) 'Wrong axis type or order',fits%char%code
          call gio_message(seve%e,rname,mess)
          error = .true.
          return
        endif
        call to_uvfits(fits,check,error)
      else if (fits%char%type.ne.'GILDAS_IMAGE') then
        call gio_message(seve%e,'IMFITS','Gildas file is not an image')
        error = .true.
        return
      else
        call to_imfits(fits,check,error)
      endif
    else
      if (fits%char%type(1:9).ne.'GILDAS_UV') then
        call gio_message(seve%e,rname,'Gildas file is not a raw UV data set')
        error = .true.
        return
      endif
      call to_uvfits(fits,check,error)
    endif
  endif
  !
100 format(a,a)
end subroutine tofits

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_copy
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubesyntax_key_types
  use cubeadm_ancillary_cube_types
  use cubeedit_messaging
  !
  public :: copy
  private
  !
  type :: copy_comm_t
     type(option_t), pointer :: comm
     type(key_comm_t) :: all
     type(key_comm_t) :: head
     type(key_comm_t) :: data
     type(ancillary_cube_comm_t) :: from
   contains
     procedure, public  :: register => cubeedit_copy_comm_register
     procedure, private :: parse    => cubeedit_copy_comm_parse
     procedure, private :: main     => cubeedit_copy_comm_main
  end type copy_comm_t
  type(copy_comm_t) :: copy  
  !
  type copy_user_t
     character(len=argu_l)  :: id
     type(key_user_t) :: all
     type(key_user_t) :: head
     type(key_user_t) :: data
     type(ancillary_cube_user_t) :: from
   contains
     procedure, private :: toprog => cubeedit_copy_user_toprog
  end type copy_user_t
  !
  type copy_prog_t
     type(cube_t), pointer :: edited
     type(key_prog_t) :: all
     type(key_prog_t) :: head
     type(key_prog_t) :: data
     type(ancillary_cube_prog_t) :: from
   contains
     procedure, private :: header => cubeedit_copy_prog_header
  end type copy_prog_t
  !
contains
  !
  subroutine cubeedit_copy_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(copy_user_t) :: user
    character(len=*), parameter :: rname='COPY>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call copy%parse(line,user,error)
    if (error) return
    call copy%main(user,error)
    if (error) continue
  end subroutine cubeedit_copy_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_copy_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(copy_comm_t), intent(inout) :: comm
    logical,            intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='COPY>COMM>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'COPY','[bufferid]',&
         'Copy part of a cube header or data',&
         'Copy selected parts of a reference cube into an opened edited buffer.&
         & COPY is additive: nothing is copied unless at least one copy&
         & key is enabled.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- COPY resolves the edited buffer from bufferid (or the current&
         & edited buffer identifier) and uses /FROM INPUT as reference&
         & source.'//strg_cr//&
         '- COPY applies requested transfers to the edited buffer.&
         & The edited buffer is registered in the DAG only after CLOSE.'&
         //strg_cr//&
         '- Current implementation transfers header metadata only.&
         & Data-value transfer is not implemented yet.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- If no copy key is enabled, COPY performs no transfer.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> COPY myedit /FROM ref_cube /ALL'//strg_cr//&
         'CUBE> COPY myedit /FROM ref_cube /HEADER'//strg_cr//&
         'CUBE> COPY myedit /FROM ref_cube /DATA'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> OPEN myedit /LIKE ref_cube'//strg_cr//&
         'CUBE> COPY myedit /FROM ref_cube /HEADER'//strg_cr//&
         'CUBE> CLOSE myedit'//strg_bl//&
         'The edited buffer is registered in the DAG only after CLOSE.',&
         cubeedit_copy_command,&
         comm%comm,&
         error)
    if (error) return
    call stdarg%register(&
         'BUFFERID',&
         'Edited buffer identifier',&
         strg_emp,&
         code_arg_optional,&
         error)
    if (error) return    
    ! Action
    call comm%all%register(&
         'ALL',&
         'Request header and data copy',&
         'Enable both /HEADER and /DATA copy requests in one command.&
         & With current implementation, this yields header copy only&
         & because data-value transfer is not implemented.',&
         error)
    if (error) return
    call comm%head%register(&
         'HEADER',&
         'Request header copy',&
         'Copy header metadata from the /FROM reference cube into the&
         & opened edited buffer.',&
         error)
    if (error) return
    call comm%data%register(&
         'DATA',&
         'Request data copy',&
         'Request data-value copy from the /FROM reference cube. The key&
         & is accepted but current implementation does not transfer data&
         & values.',&
         error)
    if (error) return
    ! Input cube
    call comm%from%fully_register(&
         'FROM','[referenceid]',&
         'Select the reference cube to copy from',&
         strg_emp,&
         'INPUT',&
         'Reference cube id used as COPY source',&
         [flag_any],&
         code_arg_mandatory,&
         code_read,&
         code_access_any,& !***JP: For data it's not so simple!
         error)
    if (error) return
  end subroutine cubeedit_copy_comm_register
  !
  subroutine cubeedit_copy_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! COPY /HEADER /DATA
    !----------------------------------------------------------------------
    class(copy_comm_t), intent(in)    :: comm
    character(len=*),   intent(in)    :: line
    type(copy_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='COPY>COMM>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    user%id = strg_star
    call cubetools_getarg(line,comm%comm,1,user%id,.not.mandatory,error)
    if (error) return
    !
    call comm%all%parse(line,user%all,error)
    if (error) return
    call comm%head%parse(line,user%head,error)
    if (error) return
    call comm%data%parse(line,user%data,error)
    if (error) return
    call comm%from%parse(line,user%from,error)
    if (error) return
  end subroutine cubeedit_copy_comm_parse
  !
  subroutine cubeedit_copy_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(copy_comm_t), intent(in)    :: comm
    type(copy_user_t),  intent(inout) :: user
    logical,            intent(inout) :: error
    !
    type(copy_prog_t) :: prog
    character(len=*), parameter :: rname='COPY>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
  end subroutine cubeedit_copy_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_copy_user_toprog(user,comm,prog,error)
    use cubeedit_opened_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(copy_user_t), intent(in)    :: user
    type(copy_comm_t),  intent(in)    :: comm
    type(copy_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='COPY>USER>TOPROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%get_cube_pointer(user%id,prog%edited,error)
    if (error) return
    !
    call user%from%toprog(comm%from,prog%from,error)
    if (error) return
    call user%all%toprog(comm%all,prog%all,error)
    if (error) return
    call user%head%toprog(comm%head,prog%head,error)
    if (error) return
    call user%data%toprog(comm%data,prog%data,error)
    if (error) return
    ! Analyse user input
    if (prog%all%act) then
       prog%head%act = .true.
       prog%data%act = .true.
    endif
    ! User feedback about the interpretation of his command line
    if (prog%head%act) call cubeedit_message(seve%r,rname,'Copying header')
    if (prog%data%act) call cubeedit_message(seve%r,rname,'Copying data')
  end subroutine cubeedit_copy_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_copy_prog_header(prog,comm,error)
    use cubetools_header_types
    use cubetools_header_interface
    use cubetools_observatory_types
    !----------------------------------------------------------------------
    ! The array section of the header is only copied when the data is
    ! copied!
    !----------------------------------------------------------------------
    class(copy_prog_t), intent(inout) :: prog
    type(copy_comm_t),  intent(in)    :: comm
    logical,            intent(inout) :: error
    !
    type(cube_header_interface_t) :: inhead,ouhead
    character(len=*), parameter :: rname='COPY>PROG>HEADER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%head%act) then
       call cubetools_header_export(prog%from%cube%head,inhead,error)
       if (error) return
       call cubetools_header_export(prog%edited%head,ouhead,error)
       if (error) return
       call inhead%axset_copyto(ouhead,error)
       if (error) return
       call inhead%spatial_copyto(ouhead,error)
       if (error) return
       call inhead%spectral_copyto(ouhead,error)
       if (error) return
       call cubetools_observatory_copy(inhead%obs,ouhead%obs,error)
       if (error) return
       call cubetools_header_import_and_derive(ouhead,prog%edited%head,error)
       if (error) return
    endif
  end subroutine cubeedit_copy_prog_header
end module cubeedit_copy
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module atm_interfaces_none
  interface
    subroutine ase45(p,t,d,ha)
      ! J CERNICHARO
      !
      !	ATMOSFERA U.S. 1962 MES DE ENERO 45 GRADOS DE LATITUD NORTE
      !	HA ES LA ALTURA A LA QUE SE QUIEREN CALCULAR LA PRESION,
      !	(MILIBARES),LA TEMPERATURA (K) Y LA DENSIDAD (GR/M**3)
      !	HA DEBE ESTAR EN KM
      !
      !	P === PRESION
      !	T === TEMPERATURA
      !	D === DENSIDAD
      !
      real p,t,d,ha
    end subroutine ase45
  end interface
  !
  interface
    subroutine asj45(p,t,d,ha)
      ! J CERNICHARO
      !
      !	ATMOSFERA STANDARD U.S. 1962 MES DE JULIO 45 GRADOS LATITUD NORTE
      !	HA === ALTURA EN KM DONDE SE DESEA CALCULAR P,T,D
      !	P  === PRESION EN MILIBARES
      !	D  === DENSIDAD EN GR/M**3
      !	T  === TEMPERATURA EN K
      !
      real p,t,d,ha
    end subroutine asj45
  end interface
  !
  interface
    subroutine excess_path (f_ghz, p_atm, p_vap, t, dh,   &
         &    z, path, c_snell, n_index)
      !--------------------------------------------------------------------------
      !
      ! Calculation of the excess path length (path length difference between
      ! vacuum and atmospheric propagation) for a parallel medium of
      ! constant refraction index.
      ! Source for the path length formula: Thompson, Moran, Swenson (1986),
      !                     Interferometry and Synthesis in Radio Astronomy, p 407
      !
      ! Input:  real*4 f_ghz   frequency in GHz
      !                p_atm   total atmospherical pressure in millibar
      !                p_vap   partial pressure of water vapor in millibar
      !                t       temperature in kelvin
      !                z       Zenith distance angle (radians)
      ! Output: real*8 c_snell : Constant of Snell's law
      !                n_index : refraction index
      !         real*4 path    : path length difference in units of dh.
      !
      ! Author: 25-Jan-1994  Michael Bremer, IRAM
      !-------------------------------------------------------------------------
      real refract_total, f_ghz, p_atm, p_vap, t, dh, z, path, refr
      real*8 sin_z, cos_z,  c_snell, n_index
    end subroutine excess_path
  end interface
  !
  interface
    function refract_total (f_ghz, p_atm, p_vap, t )
      !-------------------------------------------------------------------
      !
      ! Calculation of the total atmospheric refractivity (dry component and
      ! water vapor), taking into account the dependences from
      ! frequency, pressure, temperature
      ! Source of formulae: Hill and Cliffort (1981), Radio Science 16, pp. 77-82
      !                and  Thompson, Moran, Swenson (1986),
      !                     Interferometry and Synthesis in Radio Astronomy, p 407
      !
      ! Input: real*4 f_ghz  frequency in GHz
      !               p_atm  total atmospherical pressure in millibar
      !               p_vap  partial pressure of water vapor in millibar
      !               t      temperature in kelvin
      !
      ! Author: 25-Jan-1994  Michael Bremer, IRAM
      !
      !-------------------------------------------------------------------
      real refract_total, f_ghz, p_atm, p_vap, t
      real ref_dry, ref_vap,  sc, refract_vapor
      !
      !--------------------------------------------
      !
      ! sc = scaling factor for the wavelenght dependent part of the wet refration
      ! (normal conditions 300K, 1013mbar, 80% humidity -> partial pressure of
      !  water vapor 28.2mbar ):
      !
    end function refract_total
  end interface
  !
  interface
    function refract_vapor (f_ghz)
      !-----------------------------------------------------------------------
      !
      ! Function to calculate the refractivity of water vapor 0-480 GHz, under
      ! conditions T=300K, P=1atm, 80% rel. humidity (i.e. partial pressure of
      ! water vapor 28.2 mbar).
      !
      ! Source: Hill and Clifford (1981), Radio Science 16, curve p. 80
      ! Method of digitalisation: zoomed copy to a transparency,
      !                           points read by cursor.
      !                           Approx. errors: F +-1.5 GHz, R +-0.1
      !
      ! Author: 24-Jan-1993 Michael Bremer, IRAM
      !------------------------------------------------------------------------
      real refract_vapor, f_ghz
    end function refract_vapor
  end interface
  !
  interface
    function flin(v,vl,dv)
      !----------------------------------------------------------------------
      ! J Cernicharo, Model atmosphere.
      !
      !	FORMA CINETICA DEL PERFIL
      !	V... FRECUENCIA
      !	VL.. FRECUENCIA DE LA LINEA
      !	DV.. ANCHURA DE LA LINEA
      !----------------------------------------------------------------------
      real flin,v,vl,dv,pi,v2
    end function flin
  end interface
  !
  interface
    function fvvw(v,vl,dv)
      !----------------------------------------------------------------------
      !	PERFIL DE VAN VLECK & WEISSKOPF
      !
      ! J CERNICHARO
      !----------------------------------------------------------------------
      real fvvw,v,dv,vl,pi,dv2,a1,a2
    end function fvvw
  end interface
  !
  interface
    function kh2o(rho,t,p,v,il)
      !----------------------------------------------------------------------
      !	COEFICIENTE DE ABSORCION DEL VAPOR DE AGUA ATMOSFERICO
      !	T ... ES LA TEMPERATURA (K)
      !	P ... ES LA PRESION EN MILIBARES
      !	RHO . ES LA CONCENTRACION DE VAPOR DE AGUA EN GR/M**3
      !	V ... ES LA FRECUENCIA EN GHZ
      !	KH2O . COEFICIENTE DE ABSORCION EN CM-1
      !	IL=0   PERFIL CINETICO
      !	IL=1   PERFIL DE VAN VLECK & WEISSKPOF
      !
      ! J.Cernicharo
      !----------------------------------------------------------------------
      real rho,t,p,v
      integer il
      real fre(19),gl(19),flm(19),el(19),dv0(19),dvlm(19),   &
      real kh2o,sum,ta,tkk,tk,som,dv,rd,rd0,tt,gg,pi,fv
    end function kh2o
  end interface
  !
  interface
    function ko2(t,p,v,il)
      !----------------------------------------------------------------------
      !	OPACIDAD DE LA ATMOSFERA DEBIDA AL OXIGENO (O2)
      !	T .... ES LA TEMPERATURA (K)
      !	P .... ES LA PRESION EN MILIBARES
      !	V .... ES LA FRECUENCIA A LA CUAL SE DESEA CALCULAR KO2
      !	IL ... =0  PERFIL CINETICO
      !	IL ... =1  PERFIL DE VAN VLECK & WEISSKOPF
      !	KO2 .. OPACIDAD EN CM-1
      !
      !	ANCHURA DE LAS RAYAS DE REBER... BUENA APROXIMACION EN LAS ALAS
      !
      ! J.Cernicharo
      !----------------------------------------------------------------------
      real ko2,t,p,v
      integer il,l,j
    end function ko2
  end interface
  !
  interface
    subroutine kvatm(np,p,t,rho,h,agu,oxi,v,temi,tatm,tag,tagu,tox,   &
         &    toxi,ilag,ilox,kvat,ama,ier)
      !----------------------------------------------------------------------
      !	opacidad de la atmosfera a la frecuencia 'v' debida al
      !	vapor de agua y al oxigeno.
      !
      !	np .... numero de capas
      !	h  .... espesor de las capas     (cm)
      !	p  .... presion (milibares)
      !	t  .... temperatura (k)
      !	rho ... cantidad de vapor de agua (gr/m**3)
      !	temi .. emisividad total de la atmosfera     (k)
      !	kvat .. opacidad total (nepers)
      !	tatm .. temperatura media de la atmosfera   (k)
      !	agu ... opacidad debida al vapor de agua (nepers)
      !	oxi ... opacidad debida al oxigeno       (   "  )
      !	tag ... emisividad debida al vapor de agua (atmosfera sin oxigeno)
      !	tox ... idem para el oxigeno (sin vapor de agua)
      !	tagu .. temperatura media de la capa de vapor de agua (k)
      !	toxi .. temperatura media de la capa de oxigeno (k)
      !
      ! J.Cernicharo
      !----------------------------------------------------------------------
      integer np,ilag,ilox,ier
      real agu,oxi,v,temi,tatm,tag,tagu,tox,toxi,kvat,ama
      real h(*),p(*),t(*),rho(*)
    end subroutine kvatm
  end interface
  !
  interface
    subroutine jnu(j,v,t)
      real j                       ! Rayleigh Jeans temperature
      real v                       ! Frequency in GHz
      real t                       ! Temperature
    end subroutine jnu
  end interface
  !
  interface
    subroutine poli2_4(x1,x2,x3,y1,y2,y3,a,b,c)
      !----------------------------------------------------------------------
      !	ESTA SUBRUTINA CALCULA LOS COEFICIENTES A,B,C DEL POLINOMIO DE
      !	SEGUNDO GRADO A+BX+CX**2, QUE PASA POR LOS PUNTOS (X1,Y1),
      !	(X2,Y2),(X3,Y3)
      ! J.Cernicharo
      !----------------------------------------------------------------------
      real x1,x2,x3,y1,y2,y3,a,b,c
    end subroutine poli2_4
  end interface
  !
  interface
    function pwat(t,u)
      !----------------------------------------------------------------------
      !	calculo de la presion parcial del vapor de agua
      !	t es la temperatura en grados kelvin
      !	p es la presion atmosferica total en milibares
      !	u es la humedad relativa
      !	pwat es la presion parcial del vapor de agua
      !
      !
      !	calculo de la presion de saturacion
      !
      ! J Cernicharo
      !----------------------------------------------------------------------
      real pwat,t,u
    end function pwat
  end interface
  !
end module atm_interfaces_none

subroutine rzero
  use classic_api  
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLASS	Internal routine
  !	Initialize the current observation (R)
  ! No subroutine
  !---------------------------------------------------------------------
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: i, ipol, isb, ic, j 
  !
  r_xnum=0
  r_lam=0
  r_bet=0
  r_nant_vlbi = 0
  r_lband = 0
  r_lntch = 0
  do i=-mnsec,0
    r_presec(i) = .false.
  enddo
  do i=1, r_nant
    r_dmaflag(i) = 0
    do j=1, 2*mbands
      r_dmsaflag(j,i) = .false.
    enddo
    do ipol = 1, mnbb
      r_dmatfac(ipol,1,i) = 0
      r_dmatfac(ipol,2,i) = 0
    enddo
    do ipol = 1, mnbb
      r_dmdelay(ipol,i) = 0
    enddo
  enddo
  do i=1, r_nbas
    r_dmbflag(i) = 0
    do j=1, 2*mbands
      r_dmsbflag(j,i) = .false.
    enddo
    do isb=1, 2
      do ic = 1, mcch
        r_dmcamp(isb,i,ic) = 1.0
        r_dmcpha(isb,i,ic) = 0.0
      enddo
      do ic = 1, mrlband
        r_dmlamp(isb,i,ic) = 1.0
        r_dmlpha(isb,i,ic) = 0.0
        r_dmldph(isb,i,ic) = 0.0
      enddo
    enddo
  enddo
end subroutine rzero

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module plot_buffers
  use image_def
  !------------------------------------------------------------------------
  ! Interface with user
  !------------------------------------------------------------------------
  !
  public :: plot_buffer
  public :: w_plot,b_plot
  private
  !
  type(gildas), save :: w_plot ! Header mapped on the SIC W     variable
  type(gildas), save :: b_plot ! Header mapped on the SIC BPLOT variable
  !
  type plot_buffer_user_t
   contains
     procedure, public :: init   => plot_buffer_user_init
     procedure, public :: sicdef => plot_buffer_user_sicdef
  end type plot_buffer_user_t
  type(plot_buffer_user_t) :: plot_buffer
  !
contains
  !
  subroutine plot_buffer_user_init(user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(plot_buffer_user_t), intent(out)   :: user
    logical,                   intent(inout) :: error
    !
    ! Placeholder => Do nothing for the moment
  end subroutine plot_buffer_user_init
  !
  subroutine plot_buffer_user_sicdef(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(plot_buffer_user_t), intent(inout) :: user
    logical,                   intent(inout) :: error
    !
    real :: wdata=0.0
    !
    ! Dummy definition of the variable for initialization purpose only
    call sic_def_real('W',wdata,0,0,.true.,error)
    if (error) return
    call sic_def_header('W',w_plot,.false.,error)
    if (error) return
  end subroutine plot_buffer_user_sicdef
end module plot_buffers
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine fits2gdf(name,error)
  use gbl_message
  use gio_params
  use gio_dependencies_interfaces
  use gio_interfaces, only: fits_gildas_sub, gio_message, fits2gdf_wpr
  !---------------------------------------------------------------------
  ! @ private
  ! Automatic FITS to GDF converion
  !---------------------------------------------------------------------
  character(len=*), intent(inout)  :: name       ! File name (modified)
  logical, intent(out) :: error                  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS2GDF'
  character(len=filename_length) :: iname,oname
  integer(kind=index_length) :: blc(gdf_maxdims),trc(gdf_maxdims)
  logical, parameter :: overwrite=.false.
  !
  call gio_message(seve%i,rname,'FITS-to-GDF automatic conversion, Version 1.1')
  !
  error=.false.
  blc = 0
  trc = 0
  !
  iname = name
  oname = trim(name)//'.gdf'
  name = oname
  !
  call fits_gildas_sub(iname,oname,' ',blc,trc,1,.false.,overwrite,error,  &
   gfits_getnosymbol,fits2gdf_wpr)
  if (error) then
    call gio_message(seve%e,rname,'Conversion failed')
    error=.true.
  else
    call gio_message(seve%i,rname,'Successful completion')
  endif
  !
end subroutine fits2gdf
!
subroutine fits2gdf_wpr(chain,answer)
  use gio_dependencies_interfaces
  use gio_interfaces, only : gio_message
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  character(len=*) :: chain         !
  character(len=*) :: answer        !
  call gio_message(seve%e,'FITS2GDF','Invalid call to SIC_WPR')
  call sysexi(fatale)
end subroutine fits2gdf_wpr
!
subroutine fitscube2gdf_header(file,ihdu,fd,ghead,getsymbol,error)
  use image_def
  use gbl_message
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_header
  !---------------------------------------------------------------------
  ! @ public
  ! Load the header of the extension currently opened in gfits and
  ! translate it as a GDF header. Suited for N-dimensional cubes only.
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: file       ! FITS file name
  integer(kind=4),     intent(in)    :: ihdu       ! HDU we are reading (1=Primary)
  type(gfits_hdesc_t), intent(inout) :: fd         !
  type(gildas),        intent(inout) :: ghead      ! Gildas header
  external                           :: getsymbol  ! Symbol translation routine
  logical,             intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: fmt
  type(gfits_hdict_t) :: fhdict
  real(kind=8) :: rota(gdf_maxdims)
  logical :: found
  character(len=12) :: unit(gdf_maxdims)
  !
  ! Try to load everything, no interpretation yet
  call gfits_load_header(fhdict,.false.,getsymbol,error)
  if (error)  return
  !
  ! Get (and check) cards with precise order and values expected
  ! SIMPLE
  if (ihdu.le.0) then
    call gio_message(seve%e,rname,'Invalid HDU number')
    error = .true.
    return
  elseif (ihdu.eq.1) then
    ! We are reading the Primary HDU
    call gfits_check_simple(fhdict%card(1),error)
    if (error)  return
  else
    ! We are reading an Xtension
    call gfits_check_xtension(fhdict%card(1),error,'IMAGE')
    if (error)  return
  endif
  ! BITPIX
  call gfits_check_format(fhdict%card(2),fd%nbit,fmt,error)
  if (error)  return
  ! NAXIS*
  call fitscube2gdf_check_naxis(fhdict,ihdu,ghead%gil%ndim,ghead%gil%dim,error)
  if (error)  return
  !
  ! More general elements
  ! Axes description
  call fitscube2gdf_check_convert(fhdict,ghead%gil%convert,rota,unit,error)
  if (error)  return
  ! CD Matrix ZZZ merge with fitscube2gdf_check_convert?
  call fitscube2gdf_check_cdmatrix(fhdict,ghead%gil%convert,rota,error)
  if (error)  return
  ! Extrema
  call fitscube2gdf_check_minmax(fhdict,ghead%gil%extr_words,ghead%gil%rmin,ghead%gil%rmax,error)
  if (error)  return
  ! Array description
  call fitscube2gdf_check_array(fhdict,fd,ghead,error)
  if (error)  return
  ! Coordinate system
  call fitscube2gdf_check_system(fhdict,rota,ghead,error)
  if (error)  return
  ! Spectroscopic axis
  call fitscube2gdf_check_spec(fhdict,unit,ghead,error)
  if (error)  return
  ! Resolution section
  call fitscube2gdf_check_resolution(fhdict,ghead,error)
  if (error)  return
  ! Telescope section
  call fitscube2gdf_check_telescope(fhdict,ghead,error)
  if (error)  return
  !
  ! Miscellaneous:
  ghead%file = file
  ! ZZZ to be merged in the related section!
  call gfits_get_value(fhdict,'OBJECT',found,ghead%char%name,error)
  if (error)  return
  call gfits_get_value(fhdict,'LINE',found,ghead%char%line,error)
  if (error)  return
  if (.not.found) then
    call gfits_get_value(fhdict,'LINENAME',found,ghead%char%line,error)
    if (error)  return
  endif
  !
end subroutine fitscube2gdf_header
!
subroutine fitscube2gdf_check_naxis(fhdict,ihdu,ndim,dims,error)
  use gildas_def
  use gbl_message
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_naxis
  !---------------------------------------------------------------------
  ! @ private
  ! Read and check the NAXIS* values
  !---------------------------------------------------------------------
  type(gfits_hdict_t),        intent(in)    :: fhdict   !
  integer(kind=4),            intent(in)    :: ihdu     !
  integer(kind=4),            intent(out)   :: ndim     !
  integer(kind=index_length), intent(out)   :: dims(:)  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=20) :: what
  !
  if (ihdu.eq.1) then
    what = 'Primary HDU'
  else
    write(what,'(A,I0)') 'HDU #',ihdu
  endif
  !
  ! NAXIS: always the 3rd card
  call gfits_check_naxis(fhdict%card(3),ndim,error)
  if (error)  return
  if (ndim.le.0) then
    call gio_message(seve%e,rname,'No image in '//what)
    error = .true.
    return
  endif
  !
  ! NAXISi
  call gfits_check_naxisi(fhdict,dims,error)
  if (error)  return
  if (any(dims(1:ndim).eq.0)) then
    call gio_message(seve%e,rname,'One or more dimensions are zero-sized in '//what)
    error = .true.
    return
  endif
  !
end subroutine fitscube2gdf_check_naxis
!
subroutine fitscube2gdf_check_convert(fhdict,convert,rota,unit,error)
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_convert
  !---------------------------------------------------------------------
  ! @ private
  ! Translate all the CRVALi, CRPIXi, CDELTi, CTYPEi, CROTAi
  !---------------------------------------------------------------------
  type(gfits_hdict_t),  intent(in)    :: fhdict        !
  real(kind=8),         intent(out)   :: convert(:,:)  !
  real(kind=8),         intent(out)   :: rota(:)       !
  character(len=*),     intent(out)   :: unit(:)       !
  logical,              intent(inout) :: error         !
  ! Local
  integer(kind=4) :: iaxis
  character(len=6) :: key
  logical :: found
  !
  ! Defaults
  convert(1,:) = 0.d0  ! Ref
  convert(2,:) = 0.d0  ! Val
  convert(3,:) = 1.d0  ! Inc
  rota(:) = 0.d0
  unit(:) = ''
  !
  do iaxis=1,gdf_maxdims
    write(key,'(A5,I1)')  'CRPIX',iaxis
    call gfits_get_value(fhdict,key,found,convert(1,iaxis),error)
    if (error)  return
    !
    write(key,'(A5,I1)')  'CRVAL',iaxis
    call gfits_get_value(fhdict,key,found,convert(2,iaxis),error)
    if (error)  return
    !
    write(key,'(A5,I1)')  'CDELT',iaxis
    call gfits_get_value(fhdict,key,found,convert(3,iaxis),error)
    if (error)  return
    !
    write(key,'(A5,I1)')  'CROTA',iaxis
    call gfits_get_value(fhdict,key,found,rota(iaxis),error)
    if (error)  return
    !
    write(key,'(A5,I1)')  'CUNIT',iaxis
    call gfits_get_value(fhdict,key,found,unit(iaxis),error)
    if (error)  return
  enddo
  !
end subroutine fitscube2gdf_check_convert
!
subroutine fitscube2gdf_check_cdmatrix(fhdict,convert,rota,error)
  use phys_const
  use gbl_message
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_cdmatrix
  !---------------------------------------------------------------------
  ! @ private
  ! Apply the CD or PC matrix to the convert/rota arrays
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict        !
  real(kind=8),        intent(inout) :: convert(:,:)  !
  real(kind=8),        intent(inout) :: rota(:)       !
  logical,             intent(inout) :: error         !
  ! Local
  character(len=*), parameter :: rname='FITS'
  real(kind=8) :: cd(2,2),pc(2,2),mat(2,2)
  character(len=2) :: matname
  integer(kind=4) :: numcd,numpc,num,pcstatus,cdstatus
  logical :: swapfirst,swapsecond
  real(kind=8) :: angle1,angle2
  integer(kind=4), parameter :: matrix_is_notdefined=1
  integer(kind=4), parameter :: matrix_is_reflection=2
  integer(kind=4), parameter :: matrix_is_rotation=3
  integer(kind=4), parameter :: matrix_is_skewed=4
  !
  ! Read CD and PC matrices (defaults as per Greisen & Calabretta paper I, section 2.1.2)
  cd(:,:) = 0.d0
  pc(1,1) = 1.d0  ! PC1_1
  pc(1,2) = 0.d0  ! PC1_2
  pc(2,1) = 0.d0  ! PC2_1
  pc(2,2) = 1.d0  ! PC2_2
  call read_matrix('CD',cd,numcd,error)
  if (error)  return
  call read_matrix('PC',pc,numpc,error)
  if (error)  return
  !
  if (numcd.gt.0 .and. numpc.gt.0) then
    ! Invalid as per the above named paper
    call gio_message(seve%w,rname,'Invalid mixture of CD and PC matrix')
    error = .true.
    return
  elseif (numcd.gt.0) then
    matname = 'CD'
    mat = cd
    num = numcd
    pcstatus = matrix_is_notdefined
  elseif (numpc.gt.0) then
    matname = 'PC'
    mat = pc
    num = numpc
    pcstatus = matrix_status(pc)
    ! Convert PC matrix to a CD matrix (i.e. also convey the increments).
    ! See Calabretta & Greisen Paper II, Eq. 1. This is important to take
    ! into account the CDELTi sign to compute the right angle (atan2 below),
    ! as the sign can be either stored in CDELTi or in the PC matrix
    ! coefficients.
    mat(1,1) = mat(1,1)*convert(3,1)  ! [FITS unit] CD1_1 = PC1_1 * CDELT1
    mat(1,2) = mat(1,2)*convert(3,1)  ! [FITS unit] CD1_2 = PC1_2 * CDELT1
    mat(2,1) = mat(2,1)*convert(3,2)  ! [FITS unit] CD2_1 = PC2_1 * CDELT2
    mat(2,2) = mat(2,2)*convert(3,2)  ! [FITS unit] CD2_2 = PC2_2 * CDELT2
  else ! Both are null: nothing to do
    return
  endif
  !
  ! CD matrix status
  cdstatus = matrix_status(mat)
  if (cdstatus.eq.matrix_is_skewed) then
    call gio_message(seve%e,rname,matname//'i_j matrix is skewed')
    error = .true.
    return
  endif
  if (num.eq.4) then
    call gio_message(seve%i,rname,'Using '//matname//' matrix')
  else
    call gio_message(seve%w,rname,'Using incomplete '//matname//' matrix')
  endif
  !
  ! CD matrix encodes both the increments and the rotation angle:
  ! reconstruct them
  !
  ! Guess axes orientation
  swapfirst = .false.
  swapsecond = .false.
  if (cdstatus.eq.matrix_is_reflection) then
    ! Reflections are not supported in GILDAS data format, but it can be
    ! converted to a rotation matrix by swapping one of the 2 axes:
    if (pcstatus.eq.matrix_is_rotation) then
      ! The PC matrix was defining a rotation, but CD is a reflection:
      ! swap one according to the original CDELTi
      swapfirst  = convert(3,1).lt.0.d0
      swapsecond = convert(3,2).lt.0.d0
    else
      ! In the other cases, there is an ambiguity. Assume the first axis
      ! is to be swapped (usually in astronomy, East is displayed to the
      ! left thanks to negative X axis)
      swapfirst = .true.
    endif
  else
    ! CD matrix is a rotation
    if (pcstatus.eq.matrix_is_rotation) then
      ! Swap 0 or 2 axes
      swapfirst  = convert(3,1).lt.0.d0
      swapsecond = convert(3,2).lt.0.d0
    endif
  endif
  !
  ! Reconstruct increments (absolute values)
  convert(3,1) = sqrt(mat(1,1)**2+mat(2,1)**2)
  convert(3,2) = sqrt(mat(1,2)**2+mat(2,2)**2)
  !
  ! Reconstruct increments (signs)
  if (swapfirst) then
    ! Swap the first axis and its coefficients
    mat(1,1) = -mat(1,1)
    mat(2,1) = -mat(2,1)
    convert(3,1) = -convert(3,1)
  endif
  if (swapsecond) then
    ! Swap the second axis and its coefficients
    mat(1,2) = -mat(1,2)
    mat(2,2) = -mat(2,2)
    convert(3,2) = -convert(3,2)
  endif
  !
  ! Reconstruct rotation angle
  angle1 = atan2(+mat(2,1),mat(1,1))
  angle2 = atan2(-mat(1,2),mat(2,2))
  rota(1) = angle1*180.0d0/pi
  rota(2) = angle2*180.0d0/pi  ! Must be in degree
  !
contains
  !
  function matrix_status(mat)
    !-------------------------------------------------------------------
    ! Return the matrix status according to its determinant:
    !  +1: rotation
    !  -1: reflection
    ! otherwise skewed. Note that the matrix coefficients can also
    ! contains an additional scaling factor (increments)
    !-------------------------------------------------------------------
    integer(kind=4) :: matrix_status
    real(kind=8), intent(in) :: mat(2,2)
    ! Local
    real(kind=4) :: ratio1,ratio2
    !
    ratio1 = mat(1,1)/mat(2,2)  ! Problem if mat(2,2) ~ 0 ?
    ratio2 = sqrt(mat(1,1)**2+mat(2,1)**2) / sqrt(mat(1,2)**2+mat(2,2)**2)
    if (.not.nearly_equal(abs(ratio1),ratio2,1e-4)) then
      ! This is not a rotation nor reflection, but a more complex matrix
      matrix_status = matrix_is_skewed
    elseif (ratio1.lt.0) then
      ! mat(1,1) and mat(2,2) are opposite sign: since the matrix is not
      ! skewed, this is a reflection matrix.
      matrix_status = matrix_is_reflection
    else
      matrix_status = matrix_is_rotation
    endif
!     det = pc(1,1)*pc(2,2)-pc(1,2)*pc(2,1)
!     if (nearly_equal(det,1d0,1d-4)) then
!       matrix_status = matrix_is_rotation
!     elseif (nearly_equal(det,-1d0,1d-4)) then
!       matrix_status = matrix_is_reflection
!     else
!       matrix_status = matrix_is_skewed
!     endif
  end function matrix_status
  !
  subroutine read_matrix(name,mat,num,error)
    !-------------------------------------------------------------------
    ! Read the named matrix in the mat(2,2) variable. For readability
    ! we store XXi_j into mat(i,j). The global matrix is:
    !           ( XX1_1  XX1_2 )
    !           ( XX2_1  XX2_2 )
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    real(kind=8),     intent(inout) :: mat(2,2)
    integer(kind=4),  intent(out)   :: num
    logical,          intent(inout) :: error
    !
    logical :: found
    !
    num = 0
    call gfits_get_value(fhdict,name//'1_1',found,mat(1,1),error)
    if (error)  return
    if (found)  num = num+1
    call gfits_get_value(fhdict,name//'1_2',found,mat(1,2),error)
    if (error)  return
    if (found)  num = num+1
    call gfits_get_value(fhdict,name//'2_1',found,mat(2,1),error)
    if (error)  return
    if (found)  num = num+1
    call gfits_get_value(fhdict,name//'2_2',found,mat(2,2),error)
    if (error)  return
    if (found)  num = num+1
  end subroutine read_matrix
  !
end subroutine fitscube2gdf_check_cdmatrix
!
subroutine fitscube2gdf_check_array(fhdict,fd,ghead,error)
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_array
  !---------------------------------------------------------------------
  ! @ private
  ! Get the binary array description
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict   !
  type(gfits_hdesc_t), intent(inout) :: fd       !
  type(gildas),        intent(inout) :: ghead    !
  logical,             intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='FITS'
  logical :: found
  character(len=32) :: chblank
  integer(kind=8) :: i8blank
  real(kind=8) :: r8blank
  logical, parameter :: doblank=.true.  ! Should be customizable
  character(len=message_length) :: mess
  real(kind=4) :: newbval
  character(len=12) :: tempscale
  real(kind=4), parameter :: defbval=-1000.  ! Default blanking value
  !
  call gfits_get_value(fhdict,'BUNIT',found,ghead%char%unit,error)
  if (error)  return
  !
  ghead%gil%noise = defbval
  call gfits_get_value(fhdict,'NOISETHE',found,ghead%gil%noise,error)
  if (error)  return
  ghead%gil%rms = defbval
  call gfits_get_value(fhdict,'NOISEMEA',found,ghead%gil%rms,error)
  if (error)  return
  if (ghead%gil%noise.ne.defbval .or. ghead%gil%rms.ne.defbval)  &
    ghead%gil%nois_words = 1  ! Activate the GDF section
  !
  tempscale = ''
  call gfits_get_value(fhdict,'TEMPSCAL',found,tempscale,error)
  if (error)  return
  if (tempscale.ne.'') then
    ! Try to format to the usual Gildas encoding e.g. "K (TA*)"
    ghead%char%unit = trim(ghead%char%unit)//' ('//trim(tempscale)//')'
  endif
  !
  fd%bscal = 1.0  ! Fallback if not found
  call gfits_get_value(fhdict,'BSCALE',found,fd%bscal,error)
  if (error)  return
  !
  fd%bzero = 0.0  ! Fallback if not found
  call gfits_get_value(fhdict,'BZERO',found,fd%bzero,error)
  if (error)  return
  !
  call gfits_get_value(fhdict,'BLANK',found,chblank,error)
  if (error)  return
  !
  if (found) then
    ! BLANK is defined
    if (fd%nbit.ge.0) then  ! Indexed values
      call gfits_get_value(fhdict,'BLANK',found,i8blank,error)
      if (error)  return
      ! Note that the blanking value can be surrounded by valid values
      ghead%gil%bval = i8blank*fd%bscal + fd%bzero
      ghead%gil%eval = 0.5*fd%bscal
      ghead%gil%blan_words = 2
    else  ! Floating point values
      ! Scaling is poor style for floats, but not strictly forbidden...
      call gfits_get_value(fhdict,'BLANK',found,r8blank,error)
      if (error)  return
      ghead%gil%bval = r8blank*fd%bscal + fd%bzero
      ghead%gil%eval = 0.
      ghead%gil%blan_words = 2
    endif
    fd%bval0 = ghead%gil%bval  ! Actual blanking value used by the data
  else
    ! BLANK is not defined
    if (fd%nbit.ge.0) then  ! Indexed values
      ghead%gil%blan_words = 0  ! No blanking in header => no blanking in data
      fd%bval0 = 0.  ! Unused
      return  ! Leave section disabled
    else  ! Floating point values
      ghead%gil%blan_words = 0  ! No blanking value, but maybe NaN to be patched
      call gag_notanum(fd%bval0)  ! Actual blanking value used by the data
    endif
  endif
  !
  if (.not.doblank)  return  ! Leave blank values in data "as is"
  !
  ! Try to define a cleverer blanking value.
  if (ghead%gil%rmin.lt.ghead%gil%rmax) then
    ! OK: DATAMIN and DATAMAX were defined. Select a round blanking value
    ! below DATAMIN
    if (ghead%gil%rmin.gt.defbval) then
      newbval = defbval
    else
      newbval = -10**ceiling(log10(-ghead%gil%rmin))
    endif
    write(mess,'(A,1X,F0.1)')  'Removing NaN with blanking value',newbval
    call gio_message(seve%w,rname,mess)
  else
    ! We should design the blanking value according to data min value, but
    ! this requires searching for the latter in first loop, and then patching
    ! NaN in a second loop. Cost is too large...
    call gio_message(seve%w,rname,'Removing NaN with default blanking value -1000.0')
    newbval = defbval
  endif
  !
  ! Define or update the blanking section
  ghead%gil%blan_words = 2
  ghead%gil%bval = newbval
  ghead%gil%eval = 0.
  !
  ! Noise values (if blank)
  if (ghead%gil%noise.eq.defbval)  ghead%gil%noise = newbval
  if (ghead%gil%rms.eq.defbval)    ghead%gil%rms = newbval
  !
end subroutine fitscube2gdf_check_array
!
subroutine fitscube2gdf_check_minmax(fhdict,nwords,datamin,datamax,error)
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_minmax
  !---------------------------------------------------------------------
  ! @ private
  ! Get the binary array description
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict    !
  integer(kind=4),     intent(out)   :: nwords    !
  real(kind=4),        intent(out)   :: datamin   !
  real(kind=4),        intent(out)   :: datamax   !
  logical,             intent(inout) :: error     !
  ! Local
  logical :: found
  !
  nwords = 0
  !
  call gfits_get_value(fhdict,'DATAMIN',found,datamin,error)
  if (error)  return
  if (found)  nwords = nwords+1
  !
  call gfits_get_value(fhdict,'DATAMAX',found,datamax,error)
  if (error)  return
  if (found)  nwords = nwords+1
  !
end subroutine fitscube2gdf_check_minmax
!
subroutine fitscube2gdf_check_system(fhdict,rota,ghead,error)
  use phys_const
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_system
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict    !
  real(kind=8),        intent(in)    :: rota(:)   !
  type(gildas),        intent(inout) :: ghead     !
  logical,             intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: iaxis,minus,ier
  character(len=6) :: key
  logical :: found
  character(len=12) :: rccode,suffix,pname
  character(len=80) :: value
  real(kind=4) :: xoff,yoff
  character(len=message_length) :: mess
  !
  ! Default equinox (NB: FITS says RADESYS defaults to FK5 is absent, i.e.
  ! there is a valid default system and equinox...)
  ghead%char%syst = ''
  ghead%gil%epoc = equinox_null
  !
  ! System and optionally equinox
  call gfits_get_value(fhdict,'RADESYS',found,value,error)
  if (error)  return
  if (.not.found) then  ! Try deprecated RADECSYS
    call gfits_get_value(fhdict,'RADECSYS',found,value,error)
    if (error)  return
  endif
  if (found) then
    ! From RADESYS
    if (value(1:8).eq.'FK4-NO-E') then
      ghead%char%syst = 'EQUATORIAL'
      ghead%gil%epoc = 1950.0
    elseif (value(1:3).eq.'FK4') then
      ghead%char%syst = 'EQUATORIAL'
      ghead%gil%epoc = 1950.0
    elseif (value(1:3).eq.'FK5') then
      ghead%char%syst = 'EQUATORIAL'
      ghead%gil%epoc = 2000.0
    elseif (value(1:4).eq.'ICRS') then
      ghead%char%syst = 'ICRS'
      ghead%gil%epoc = equinox_null  ! Irrelevant for ICRS
    endif
  endif
  !
  ! EQUINOX (or EPOCH)
  call gfits_get_value(fhdict,'EQUINOX',found,value,error)
  if (error)  return
  if (.not.found) then
    call gfits_get_value(fhdict,'EPOCH',found,value,error)
    if (error)  return
  endif
  if (found) then
    read(value,*,iostat=ier) ghead%gil%epoc
    if (ier.ne.0) then
      if (value(1:1).eq.'J') then
        read(value(2:),*,iostat=ier) ghead%gil%epoc
      elseif (value(1:1).eq.'B') then
        read(value(2:),*,iostat=ier) ghead%gil%epoc
      endif
      if (ier.ne.0) then
        call gio_message(seve%e,rname,'Undecipherable Equinox '//value)
        ghead%gil%epoc = equinox_null
      endif
    endif
  endif
  !
  ! System description
  pname = ' '
  ghead%gil%xaxi = 0
  ghead%gil%yaxi = 0
  do iaxis=1,ghead%gil%ndim
    !
    write(key,'(A5,I1)')  'CTYPE',iaxis
    call gfits_get_value(fhdict,key,found,rccode,error)
    if (error)  return
    if (.not.found) then
      write(mess,'(A,I0,3A)')  'File has ',ghead%gil%ndim,' dimensions but ',  &
        trim(key),' is not defined'
      call gio_message(seve%w,rname,mess)
      cycle
    endif
    !
    ! Split system and projection
    minus = index(rccode,'-',back=.true.)
    if (minus.eq.0) then
      suffix = ' '
    else
      suffix = rccode(minus+1:)
      minus = index(rccode,'-',back=.false.)
      rccode = rccode(:minus-1)
    endif
    !
    ! System
    select case (rccode)
    case ('RA')
      if (ghead%char%syst.eq.'') then
        ! RA is ambiguously used for EQUATORIAL or ICRS
        call gio_message(seve%w,rname,'Coordinate system assumed EQUATORIAL')
        ghead%char%syst      = 'EQUATORIAL'
      endif
      ghead%gil%xaxi         = iaxis
      ghead%char%code(iaxis) = 'RA'
      ghead%gil%ra           = ghead%gil%convert(2,iaxis)*rad_per_deg
      ghead%gil%a0           = ghead%gil%ra
      pname = suffix
    case ('DEC')
      if (ghead%char%syst.eq.'') then
        ! DEC is ambiguously used for EQUATORIAL or ICRS
        call gio_message(seve%w,rname,'Coordinate system assumed EQUATORIAL')
        ghead%char%syst      = 'EQUATORIAL'
      endif
      ghead%gil%yaxi         = iaxis
      ghead%char%code(iaxis) = 'DEC'
      ghead%gil%dec          = ghead%gil%convert(2,iaxis)*rad_per_deg
      ghead%gil%d0           = ghead%gil%dec
      pname = suffix
    case ('LON','GLON')
      ghead%char%syst        = 'GALACTIC'
      ghead%gil%xaxi         = iaxis
      ghead%char%code(iaxis) = 'LII'
      ghead%gil%lii          = ghead%gil%convert(2,iaxis)*rad_per_deg
      ghead%gil%a0           = ghead%gil%lii
      pname = suffix
    case ('LAT','GLAT')
      ghead%char%syst        = 'GALACTIC'
      ghead%gil%yaxi         = iaxis
      ghead%char%code(iaxis) = 'BII'
      ghead%gil%bii          = ghead%gil%convert(2,iaxis)*rad_per_deg
      ghead%gil%d0           = ghead%gil%bii
      pname = suffix
    case default
      cycle
    end select
    !
    ! Factorized for all of the 4 cases:
    ghead%gil%convert(2,iaxis) = 0.d0
    ghead%gil%convert(3,iaxis) = ghead%gil%convert(3,iaxis)*rad_per_deg
    ghead%gil%desc_words       = 1
    !
  enddo
  !
  ! Projection type
  select case (pname)
  case ('')
    ! Projection is not defined.
    if (ghead%gil%xaxi.ne.0 .or. ghead%gil%yaxi.ne.0) then
      ! Spatial axes are defined but not their projection. Quoting Greisen
      ! & Calabretta 2002: "CTYPEi values that are not in "4–3" form
      ! should be interpreted as linear axes."
      call gio_message(seve%w,rname,'Projection assumed CARTESIAN')
      ghead%gil%ptyp = p_cartesian
    else
      ! No spatial axes defined => no projection
      ghead%gil%ptyp = p_none
    endif
  case ('TAN')
    ghead%gil%ptyp = p_gnomonic
  case ('ATF','AIT')  ! Aitoff
    ghead%gil%ptyp = p_aitoff
    if (ghead%gil%d0.ne.0.d0) then
      ! GILDAS equations for Aitoff projection implement only reference
      ! on the Equator.
      call gio_message(seve%w,rname,  &
        'AITOFF with non-zero declination is not supported: expect incorrect coordinates')
    endif
  case ('SIN')
    ! Note that Gildas does not support extended SIN (Slant orthographic).
    ! See Calabretta & Greisen 2002, sections 5.1.5 and 6.1.1. We should
    ! reject the cases when PVi_j are defined and non-zero.
    ghead%gil%ptyp = p_ortho  ! Orthographic or Dixon
  case ('ARC')
    ghead%gil%ptyp = p_azimuthal  ! Schmidt or Azimuthal
  case ('STG')  ! Stereographic
    ghead%gil%ptyp = p_stereo
  case ('GLS')
    ghead%gil%ptyp = p_radio
  case ('CAR')  ! Cartesian
    ghead%gil%ptyp = p_cartesian
  case ('SFL')
    ghead%gil%ptyp = p_sfl
  case ('NCP')  ! North Celestial Pole
    ! Gildas offers native support. Note that according to Calabretta
    ! & Greisen 2002, NCP is obsolete and should be translated to
    ! (see section 6.1.2):
    !     SIN with PV2_1 = 0 and PV2_2 = 1/tan(d0)
    ! This defines an "extented" SIN projection (Slant orthographic, see
    ! section 5.1.5). However, Gildas supports only the (non-extended)
    ! orthographic projection with SIN with PV2_1 = PV2_2 = 0 (see section
    ! 6.1.1).
    ghead%gil%ptyp = p_ncp
  case default
    call gio_message(seve%w,rname,'Unrecognized projection '//pname)
    ghead%gil%ptyp = p_none
  end select
  ! Projection angle. Can be defined in CROTA2 but not CROTA1.
  if (ghead%gil%xaxi.ne.0 .and. rota(ghead%gil%xaxi).ne.0.d0) then
    ghead%gil%pang = rota(ghead%gil%xaxi)*rad_per_deg  ! From deg to internal rad
  elseif (ghead%gil%yaxi.ne.0 .and. rota(ghead%gil%yaxi).ne.0.d0) then
    ghead%gil%pang = rota(ghead%gil%yaxi)*rad_per_deg  ! From deg to internal rad
  else
    ghead%gil%pang = 0.d0
  endif
  !
  call fitscube2gdf_import_sfl_as_radio(fhdict,ghead,error)
  if (error)  return
  !
  ! Set the alternate system
  xoff = 0.
  yoff = 0.
  if (ghead%char%syst.eq.'EQUATORIAL') then
    if (ghead%gil%epoc.ne.equinox_null)  &
    call equ_to_gal(ghead%gil%ra,ghead%gil%dec,xoff,yoff,ghead%gil%epoc,  &
                    ghead%gil%lii,ghead%gil%bii,xoff,yoff,error)
  elseif (ghead%char%syst.eq.'GALACTIC') then
    if (ghead%gil%epoc.eq.equinox_null)  ghead%gil%epoc = 2000.0
    call gal_to_equ(ghead%gil%lii,ghead%gil%bii,xoff,yoff,  &
                    ghead%gil%ra,ghead%gil%dec,xoff,yoff,ghead%gil%epoc,error)
  elseif (ghead%char%syst.eq.'ICRS') then
    ! Converting from ICRS is not yet implemented
    ghead%gil%lii = 0.d0
    ghead%gil%bii = 0.d0
  endif
  !
end subroutine fitscube2gdf_check_system
!
subroutine fitscube2gdf_check_spec(fhdict,unit,ghead,error)
  use phys_const
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_spec
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict    !
  character(len=*),    intent(in)    :: unit(:)   !
  type(gildas),        intent(inout) :: ghead     !
  logical,             intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: iaxis,velref,minus
  character(len=6) :: key
  logical :: found
  character(len=12) :: value
  real(kind=8) :: altrpix,factor
  integer(kind=4), parameter :: iref=1,ival=2,iinc=3
  !
  ! Velocity type
  ! ghead%gil%vtyp = default set by gildas_null
  call gfits_get_value(fhdict,'SPECSYS',found,value,error)
  if (error)  return
  if (found) then
    select case (value)
    case ('LSRK')
      ghead%gil%vtyp = vel_lsr
    case ('HEL')
      ghead%gil%vtyp = vel_hel
    case ('TOPOCENT')
      ghead%gil%vtyp = vel_obs
    case default
      call gio_message(seve%w,rname,'SPECSYS '//trim(value)//' not understood')
    end select
  else
    ! VELREF: >256 RADIO, 1 LSR 2 HEL 3 OBS
    call gfits_get_value(fhdict,'VELREF',found,velref,error)
    if (error)  return
    if (found) then
      if (velref.gt.256)  velref = velref-256
      select case (velref)
      case (1)
        ghead%gil%vtyp = vel_lsr
      case (2)
        ghead%gil%vtyp = vel_hel
      case (3)
        ghead%gil%vtyp = vel_obs
      case default
        call gio_message(seve%w,rname,'Invalid VELREF, velocity type set to default')
      end select
    endif
  endif
  !
  ! System description
  ghead%gil%spec_words = 0
  ghead%gil%faxi = 0
  do iaxis=1,ghead%gil%ndim
    !
    write(key,'(A5,I1)')  'CTYPE',iaxis
    call gfits_get_value(fhdict,key,found,value,error)
    if (error)  return
    minus = index(value,'-')
    if (minus.ne.0)  value = value(1:minus-1)  ! e.g. VELO-LSR => VELO
    !
    select case (value)
    case ('VELOCITY','VELO','VRAD')
      ghead%char%code(iaxis) = 'VELOCITY'
      ghead%gil%faxi = iaxis
      ! Get scaling factor from 'unit' to m/s
      call unit_prefix_scale(unit(iaxis),'m/s',factor,error)
      if (error)  return
      ! Get scaling factor from m/s to Gildas internal unit (km/s)
      factor = factor*1.0d-3
      ghead%gil%convert(ival,iaxis) = ghead%gil%convert(ival,iaxis)*factor
      ghead%gil%convert(iinc,iaxis) = ghead%gil%convert(iinc,iaxis)*factor
      ghead%gil%vres = ghead%gil%convert(iinc,iaxis)
      ghead%gil%spec_words = 12
    case ('FREQUENCY','FREQ')
      ghead%char%code(iaxis) = 'FREQUENCY'
      ghead%gil%faxi = iaxis
      ! Get scaling factor from 'unit' to Hz
      call unit_prefix_scale(unit(iaxis),'Hz',factor,error)
      if (error)  return
      ! Get scaling factor from Hz to Gildas internal unit (MHz)
      factor = factor*1.0d-6
      ghead%gil%convert(ival,iaxis) = ghead%gil%convert(ival,iaxis)*factor
      ghead%gil%convert(iinc,iaxis) = ghead%gil%convert(iinc,iaxis)*factor
      ghead%gil%fres = ghead%gil%convert(iinc,iaxis)
      ghead%gil%spec_words = 12
      !
      ! Prepare the Freq value
      ghead%gil%freq = ghead%gil%convert(ival,iaxis)*1d6 ! In Hz, for further use below
    case ('LAMBDA')
      ghead%char%code(iaxis) = 'LAMBDA'
      ghead%gil%faxi = iaxis
      ghead%gil%spec_words = 12
    case ('STOKES')
      ghead%char%code(iaxis) = 'STOKES'
    end select
    !
  enddo
  !
  if (ghead%gil%spec_words.eq.0)  return
  !
  ! Velocity offset
  call gfits_get_value(fhdict,'VELO-LSR',found,ghead%gil%voff,error)
  if (error)  return
  if (found) then
    ! Up to now VELO-LSR has no known unit => assume m/s, convert to km/s
    ghead%gil%voff = ghead%gil%voff*1e-3
  else
    ! No VELO-LSR keyword
    if (ghead%char%code(ghead%gil%faxi).eq.'VELOCITY') then
      ghead%gil%voff = ghead%gil%convert(ival,ghead%gil%faxi)  ! Already in Gildas internal unit
    else
      ! No velocity axis nor velocity offset...
      call gio_message(seve%w,rname,'Missing velocity description')
    endif
  endif
  !
  ! Rest frequency
  call gfits_get_value(fhdict,'RESTFREQ',found,ghead%gil%freq,error)
  if (error)  return
  if (.not.found) then
    call gfits_get_value(fhdict,'RESTFRQ',found,ghead%gil%freq,error)
    if (error)  return
  endif
  if (.not.found .and. ghead%char%code(ghead%gil%faxi).eq.'VELOCITY') then
    ! Rest frequency not yet found, try to derive from ALTRVAL/ALTRPIX.
    ! Note: if RESTFREQ is already known (usual case), we should check the
    ! consistency between RESTFREQ, convert[*,faxi], and ALTRVAL/ALTRPIX
    call gio_message(seve%w,rname,'Deriving rest frequency from ALTRVAL/ALTRPIX')
    call gfits_get_value(fhdict,'ALTRVAL',found,ghead%gil%freq,error)
    if (error)  return
    call gfits_get_value(fhdict,'ALTRPIX',found,altrpix,error)
    if (error)  return
    if (found) then
      ! Frequency at ref. channel (in case it is different from ALTRPIX)
      ghead%gil%freq = ghead%gil%freq -  &
                       (altrpix-ghead%gil%convert(iref,ghead%gil%faxi)) *  &
                       ghead%gil%convert(iinc,ghead%gil%faxi) * ghead%gil%freq / clight_kms
      ! Rest frequency corresponds to velocity = 0 (LSR frame)
      ghead%gil%freq = ghead%gil%freq -  &
                       ghead%gil%convert(ival,ghead%gil%faxi) *  &
                       ghead%gil%convert(iinc,ghead%gil%faxi) * ghead%gil%freq / clight_kms
    endif
  endif
  ! Up to now RESTFREQ has no known unit => assume Hz, convert to MHz
  ghead%gil%freq = ghead%gil%freq*1d-6
  !
  ! Image frequency
  call gfits_get_value(fhdict,'IMAGFREQ',found,ghead%gil%fima,error)
  if (error)  return
  ghead%gil%fima = ghead%gil%fima*1d-6  ! Assume Hz, convert to MHz
  !
  ! Resolutions
  if (ghead%gil%vres.eq.0.)  ghead%gil%vres = - clight_kms * ghead%gil%fres / ghead%gil%freq
  if (ghead%gil%fres.eq.0.)  ghead%gil%fres = - ghead%gil%freq * ghead%gil%vres / clight_kms
  !
end subroutine fitscube2gdf_check_spec
!
subroutine fitscube2gdf_check_resolution(fhdict,ghead,error)
  use phys_const
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_resolution
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict  !
  type(gildas),        intent(inout) :: ghead   !
  logical,             intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='FITS'
  logical :: found
  !
  ghead%gil%majo = 0.
  call gfits_get_value(fhdict,'BMAJ',found,ghead%gil%majo,error)
  if (error)  return
  if (found) then
    ghead%gil%reso_words = 3
    ghead%gil%majo = ghead%gil%majo*rad_per_deg
  endif
  !
  ghead%gil%mino = 0.
  call gfits_get_value(fhdict,'BMIN',found,ghead%gil%mino,error)
  if (error)  return
  if (found) then
    ghead%gil%reso_words = 3
    ghead%gil%mino = ghead%gil%mino*rad_per_deg
  endif
  !
  ghead%gil%posa = 0.
  call gfits_get_value(fhdict,'BPA', found,ghead%gil%posa,error)
  if (error)  return
  if (found) then
    ghead%gil%reso_words = 3
    ghead%gil%posa = ghead%gil%posa*rad_per_deg
  endif
  !
end subroutine fitscube2gdf_check_resolution
!
subroutine fitscube2gdf_check_telescope(fhdict,ghead,error)
  use phys_const
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_telescope
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict  !
  type(gildas),        intent(inout) :: ghead   !
  logical,             intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='FITS'
  logical :: found
  character(len=12) :: telescope
  real(kind=8) :: dummy(3)
  !
  call gfits_get_value(fhdict,'TELESCOP',found,telescope,error)
  if (error)  return
  if (found) then
    call gdf_addteles(ghead,'TELE',telescope,dummy,error)
    if (error)  error = .false.  ! Most likely the telescope name was not found
  endif
  !
end subroutine fitscube2gdf_check_telescope
!
subroutine fitscube2gdf_patch_bval(fd,ghead,data,ndata,nblank,error)
  use gildas_def
  use image_def
  use gio_interfaces, except_this=>fitscube2gdf_patch_bval
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Patch blanking values to a better value in input data array
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),       intent(in)    :: fd           !
  type(gildas),              intent(in)    :: ghead        !
  integer(kind=size_length), intent(in)    :: ndata        !
  real(kind=4),              intent(inout) :: data(ndata)  !
  integer(kind=size_length), intent(inout) :: nblank       ! Updated in return
  logical,                   intent(inout) :: error        !
  ! Local
  integer(kind=size_length) :: i
  !
  ! If no blanking value was (re)defined in the header, there is nothing
  ! we can patch in the data:
  if (ghead%gil%blan_words.eq.0)  return
  !
  ! Patch the data
  if (fd%bval0.ne.fd%bval0) then
    ! Actual blanking value is NaN
    do i=1,ndata
      if (data(i).ne.data(i)) then
        nblank = nblank+1
        data(i) = ghead%gil%bval
      endif
    enddo
  elseif (fd%bval0.ne.ghead%gil%bval) then
    ! Actual blanking value is standard float
    do i=1,ndata
      if (data(i).eq.fd%bval0) then
        nblank = nblank+1
        data(i) = ghead%gil%bval
      endif
    enddo
  endif
  !
end subroutine fitscube2gdf_patch_bval
!
subroutine fits2gdf_guess_style(style,error)
  use gbl_message
  use gio_params
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fits2gdf_guess_style
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  !  Guess the style of the extension currently opened in GFITS
  !---------------------------------------------------------------------
  integer(kind=4), intent(out)   :: style
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FITS'
  type(gfits_hdict_t) :: fhdict
  logical :: groups,found
  !
  ! Load the whole header for simplicity. No symbol translation as
  ! there is no purpose user overrides the checks on NAXIS* in this
  ! subroutine.
  call gfits_load_header(fhdict,.false.,gfits_getnosymbol,error)
  if (error)  return
  !
  ! Minimum sanity checks: they will be the responsibility of the full filler
  groups = .false.
  call gfits_get_value(fhdict,'GROUPS',found,groups,error)
  if (error)  return
  !
  if (groups) then
    ! Rely on the GROUPS keyword. Checking if NAXIS1 is 0 is not 100%
    ! reliable as it can be 0 for exotic (but valid) data in other
    ! styles (e.g. zero-sized columns in a BINTABLE).
    call gio_message(seve%i,rname,'FITS file may be UVFITS, trying...')
    style = code_fits_uvfits
  else
    style = code_fits_standard
    call gio_message(seve%i,rname,'FITS file may be IMAGE, trying...')
  endif
  !
  ! Rewind position to start of current extension, so that the filler
  ! can read the header as it wants
  call gfits_rewind_hdu(error)
  if (error)  return
  !
end subroutine fits2gdf_guess_style
!
subroutine unit_prefix_scale(prefix,unit,scale,error)
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>unit_prefix_scale
  !---------------------------------------------------------------------
  ! @ public
  ! Find the scaling factor to go from 'unit' (e.g. 'Hz') to prefix
  ! (e.g. 'MHz').
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: prefix  ! Prefixed unit
  character(len=*), intent(in)    :: unit    ! Natural unit
  real(kind=8),     intent(out)   :: scale   ! Scaling factor
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: kunit
  character(len=12) :: u_unit
  character(len=24) :: u_prefix
  !
  scale = 1.d0
  !
  if (prefix.eq.' ') return  ! Empty assumes natural unit
  !
  u_prefix = prefix
  call sic_upper(u_prefix)
  u_unit = unit
  call sic_upper(u_unit)
  kunit = index(u_prefix,u_unit)
  !
  if (kunit.eq.0) then
    ! Unit recognized at all...
    call gio_message(seve%w,rname,'Non-supported unit '//prefix)
    return
  else if (kunit.eq.1) then
    ! No prefix multiplier
    return
  else if (u_prefix(kunit:).ne.u_unit) then
    ! Not a prefix multiplier
    return
  else if (kunit.gt.3)  then
    ! Prefix multiplier can only have 1 or 2 letters
    call gio_message(seve%w,rname,'Non-supported prefix in unit '//prefix)
    return
  else if (kunit.eq.3) then
    ! The only Prefix multiplier with 2 letters is "da" for "deca"
    if (prefix(1:2).eq.'da') then
      scale = 10.d0
    else
      call gio_message(seve%w,rname,'Non-supported prefix in unit '//prefix)
    endif
    return
  endif
  !
  ! NB: tests are done on non-upcased prefix
  select case (prefix(1:1))
  case ('d')
    scale = 1.d-1
  case ('c')
    scale = 1.d-2
  case ('m')
    scale = 1.d-3
  case ('u')
    scale = 1.d-6
  case ('n')
    scale = 1.d-9
  case ('p')
    scale = 1.d-12
  case ('f')
    scale = 1.d-15
  case ('a')
    scale = 1.d-18
  case ('z')
    scale = 1.d-21
  case ('y')
    scale = 1.d-24
  case ('h')
    scale = 1.d2
  case ('k')
    scale = 1.d3
  case ('M')
    scale = 1.d6
  case ('G')
    scale = 1.d9
  case ('T')
    scale = 1.d12
  case ('P')
    scale = 1.d15
  case ('E')
    scale = 1.d18
  case ('Z')
    scale = 1.d21
  case ('Y')
    scale = 1.d24
  case default
    call gio_message(seve%w,rname,'Non-supported prefix in unit '//prefix)
    scale = 1.d0
  end select
  !
end subroutine unit_prefix_scale
!
subroutine fitscube2gdf_import_sfl_as_radio(fhdict,ghead,error)
  use phys_const
  use gbl_constant
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_import_sfl_as_radio
  !---------------------------------------------------------------------
  ! @ private
  ! If possible, convert back the SFL projection to the usual radio
  ! projection. This patch is symetric to what is done at export time,
  ! but the export patch puts the reference on the Equator, which is a
  ! bit annoying.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict
  type(gildas),        intent(inout) :: ghead
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FITS'
  real(kind=8) :: dec
  logical :: found
  !
  if (ghead%gil%ptyp.ne.p_sfl)  return
  if (ghead%gil%yaxi.eq.0)      return
  if (ghead%gil%d0.ne.0.d0)     return
  !
  ! Get the source declination
  dec = 0.d0
  call gfits_get_value(fhdict,'DEC',found,dec,error)
  if (error)  return
  if (dec.eq.0.d0)  return
  dec = dec*rad_per_deg
  !
  ! Bring back reference point to the source declination
  call gio_message(seve%w,rname,'Projection kind converted from SFL to radio')
  ghead%gil%ptyp = p_radio
  ghead%gil%d0 = dec
  ghead%gil%dec = dec
  ghead%gil%ref(ghead%gil%yaxi) = ghead%gil%ref(ghead%gil%yaxi) + &
                                  dec/ghead%gil%inc(ghead%gil%yaxi)
  !
end subroutine fitscube2gdf_import_sfl_as_radio

!-----------------------------------------------------------------------
! General remark on several routines in that file:
!  - I do not understand why calls to GTX_PEN have been suppressed.
!    It may explain the problems mentionned elsewhere with the "Current
!    Pen" (S.Guilloteau 15-Oct-1992)
!-----------------------------------------------------------------------
subroutine gt_polyl(out,poly)
  use gtv_interfaces, except_this=>gt_polyl
  use gtv_protocol
  use gtv_graphic
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Generic routine: draw the input polyline in the display 'out',
  ! whereever this polyline comes from.
  !---------------------------------------------------------------------
  type(gt_display),  intent(inout) :: out   ! Input gt_display
  type(gt_polyline), intent(in)    :: poly  ! The polyline instance
  ! Local
  integer :: k,c0,c1,c,cold
  real :: x,y,x0,y0,x1,y1
  real*4 :: gx1,gx2,gy1,gy2
  ! Petite modif pour examiner avec dbx le contenu des tableaux
  logical :: up
  !
  if (.not.awake .or. error_condition) return
  ! call gtx_pen(out,ipenx_i)
  !
  ! No device selected
  if (out%dev%protocol.eq.p_null)  return
  !
  if (associated(poly%penlut)) then
    ! LUT STATIC:
    ! Load the appropriate pen into the device
    call gtx_pen(out,out%icolou,poly%penlut)
  endif
  !
  gx1 = out%gx1
  gx2 = out%gx2
  gy1 = out%gy1
  gy2 = out%gy2
  !
  ! End-points of line are (X0,Y0), (X1,Y1)
  x0 = poly%x(1)
  y0 = poly%y(1)
  call gtx_clip(out,x0,y0,c0)
  up = .true.
  !
  ! Loop on points
  ! Change the end-points of the line (X0,Y0) - (X1,Y1)
  ! to clip the line at the window boundary.
  ! The algorithm is that of Cohen and Sutherland (ref: Newman & Sproull)
  !
  do k=2,poly%n
    x1 = poly%x(k)
    y1 = poly%y(k)
    call gtx_clip(out,x1,y1,c1)
    cold = c1
    !
    do while (ior(c0,c1).ne.0)
      if (iand(c0,c1).ne.0) goto 100   ! line is invisible
      if (c0.eq.0) then
        c = c1
      else
        c = c0
      endif
      if (iand(c,1).ne.0) then ! crosses GX1
        y = y0 + (y1-y0)*(gx1-x0)/(x1-x0)
        x = gx1
      elseif (iand(c,2).ne.0) then ! crosses GX2
        y = y0 + (y1-y0)*(gx2-x0)/(x1-x0)
        x = gx2
      elseif (iand(c,4).ne.0) then ! crosses GY1
        x = x0 + (x1-x0)*(gy1-y0)/(y1-y0)
        y = gy1
      elseif (iand(c,8).ne.0) then ! crosses GY2
        x = x0 + (x1-x0)*(gy2-y0)/(y1-y0)
        y = gy2
      endif
      if (c.eq.c0) then
        x0 = x
        y0 = y
        call gtx_clip(out,x,y,c0)
      else
        x1 = x
        y1 = y
        call gtx_clip(out,x,y,c1)
      endif
    enddo
    !
    ! Selon les protocoles, le travail est different.
    ! Il y a les protocoles intelligent capables de faire du dash et des
    ! largeurs de trait et les autres. Pour les premiers, les parametres
    ! de dash et largeur ont deja ete fixe au moment du set_attributs(...)
    ! une ligne simple suffira dans tous les cas.
    !
    ! Plot the line : Pen up to X0,Y0 then pen down to X1,Y1
    !
    if (user_hardw_line .and.  &
      out%dev%hardw_line_weig .and. out%dev%hardw_line_dash) then
      ! No chopper needed, device knows how to produce width and dash
      if (up) then
        call gtx_plot(out,x0,y0,3)
        call gtx_plot(out,x1,y1,2)
      else
        call gtx_plot(out,x1,y1,2)
      endif
    else
      ! Simulate thickness and/or dash with several lines
      call gtx_chopper(out,x0,y0,x1,y1,up)
    endif
    !
    ! End of loop
100 c0 = cold
    x0 = poly%x(k)                 ! and not X1
    y0 = poly%y(k)                 ! and not Y1
    up = cold.ne.0
  enddo
  !
end subroutine gt_polyl
!
subroutine gtx_clip(out,x,y,c)
  use gtv_interfaces, except_this=>gtx_clip
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Routine for the clipping algorithm; called from GTI_CLIP only. C
  ! is a 4 bit code indicating the relationship between point (X,Y) and
  ! the window boundaries; 0 implies the point is within the window.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out  ! Input gt_display
  real*4,           intent(in)  :: x    !
  real*4,           intent(in)  :: y    !
  integer,          intent(out) :: c    !
  !
  c = 0
  if (x.lt.out%gx1) then
    c = 1
  elseif (x.gt.out%gx2) then
    c = 2
  endif
  if (y.lt.out%gy1) then
    c = c+4
  elseif (y.gt.out%gy2) then
    c = c+8
  endif
  !
end subroutine gtx_clip

subroutine class_print(set,line,error)
  use gildas_def
  use image_def
  use gbl_format
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_print
  use class_setup_new
  use class_types
  use class_common
  use class_index
  !----------------------------------------------------------------------
  ! @ public
  ! ANALYSE Support routine for command
  !	ANALYSE\PRINT   FIT   [/OUTPUT filename]
  !			AREA    [V1 [V2 [V3 [...]]]]
  !			MOMENT  [V1 V2 [V3 V4 [...]]]
  !			CHANNEL Liste
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  logical,             intent(inout) :: error  ! Output error flag
  ! Local
  character(len=*), parameter :: proc='PRINT'
  type(gildas) :: tbl
  real(kind=4), allocatable :: dtbl(:,:)
  logical :: table,file
  integer(kind=4), parameter :: maxarg=20
  integer(kind=entry_length) :: kx,kn,ksave
  integer(kind=4) :: i,jtmp,ido,ic,iv,nv,ndata
  real(kind=4) :: kanal(maxarg),rchan1,rchan2,frac1,frac2
  integer(kind=4) :: cl(maxarg),ier,nc,tbl_dim2,ichan1,ichan2,istart,iend
  character(len=message_length) ::  mess
  character(len=filename_length) :: fich,name,tempo
  real(kind=4) :: off1,off2,aa
  real(kind=4), allocatable :: value(:)
  real(kind=4) :: area(maxarg),vites(maxarg),s0(maxarg),s1(maxarg),s2(maxarg)
  character(len=9) :: what,argum
  type(observation) :: obs
  ! Actions
  integer(kind=4), parameter :: mact=6
  character(len=8) :: action(mact)
  data action/'FIT','AREA','CHANNEL','MOMENT','POINTING','FLUX'/
  integer(kind=4), parameter :: dofit=1
  integer(kind=4), parameter :: doarea=2  ! PRINT AREA V1 V2 ...
  integer(kind=4), parameter :: doareabase=-2  ! PRINT AREA (no arg)
  integer(kind=4), parameter :: dochannel=3
  integer(kind=4), parameter :: domoment=4
  integer(kind=4), parameter :: dopointing=5
  integer(kind=4), parameter :: doflux=6
  !
  ! Verify if any input file
  if (.not.filein_opened(proc,error))  return
  !
  ! What is to be printed ?
  !
  table = sic_present(2,0)
  file = sic_present(1,0)
  if (table.and.file) then
     call class_message(seve%e,proc,'Conflicting option /FILE and /TABLE')
     error = .true.
     return
  endif
  !
  argum = 'FIT'
  call sic_ke (line,0,1,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs('PRINT',argum,what,ido,action,mact,error)
  if (error) return
  !
  if (ido.eq.dofit .or. ido.ge.dopointing .or. ido.eq.doflux) then
     ! PRINT FIT|POINTING|FLUX
     if (table) then
        call class_message(seve%e,proc,  &
          'Option /TABLE is not available for PRINT '//action(ido))
        error = .true.
        return
     endif
  elseif (ido.eq.doarea) then
     ! PRINT AREA
     if (sic_narg(0).eq.1) then
        ! Baseline area
        ido = doareabase
        tbl_dim2 = 5
     elseif (sic_narg(0).eq.2) then
        call class_message(seve%e,proc,'At least 2 velocities needed (1 range)')
        error = .true.
        return
     else
        ! Decode area velocity list
        istart = sic_start(0,2)
        iend = sic_end(0,sic_narg(0))
        call sic_build_listr4(vites,nv,maxarg,line(istart:iend),proc,error)
        if (error) return
        tbl_dim2 = 3+nv-1  ! num + x + y + (nv-1) ranges
     endif
  elseif (ido.eq.dochannel) then
     ! PRINT CHANNEL: decode channel list
     if (sic_narg(0).le.1) then
        call class_message(seve%e,proc,'Missing channel list')
        error = .true.
        return
     endif
     istart = sic_start(0,2)
     iend = sic_end(0,sic_narg(0))
     call sic_build_listi4(cl,nv,maxarg,line(istart:iend),proc,error)
     if (error) return
     tbl_dim2 = 3+nv
  elseif (ido.eq.domoment) then
     ! PRINT MOMENT: decode moment velocity list
     if (sic_narg(0).le.2) then
        call class_message(seve%e,proc,'At least 2 velocities needed (1 range)')
        error = .true.
        return
     endif
     istart = sic_start(0,2)
     iend = sic_end(0,sic_narg(0))
     call sic_build_listr4(vites,nv,maxarg,line(istart:iend),proc,error)
     if (error) return
     nv = nv/2  ! Nv values => Nv pairs
     tbl_dim2 = 3+3*nv
  endif
  !
  ! Open output file if needed
  if (file) then
     call sic_ch (line,1,1,name,nc,.true.,error)
     if (error) return
     ier = sic_getlun(jtmp)
     if (ier.ne.1) then
        call class_message(seve%e,proc,'No logical unit left')
        error = .true.
        return
     endif
     call sic_parse_file(name,' ','.dat',fich)
     ier = sic_open(jtmp,fich,'NEW',.false.)
     if (ier.ne.0) then
        call class_message(seve%e,proc,'Unable to open file '//name)
        call putios ('          ',ier)
        error = .true.
        call sic_frelun(jtmp)
        return
     endif
     tempo = ' '
     call sic_date(tempo)
     write (jtmp,'("!",/,"! ",A)') trim(tempo)
     inquire (unit=filein%lun,name=tempo)
     write (jtmp,'("! Input file  : ",a)') trim(tempo)
     write (jtmp,'("! Input command: ",a,/,"!")') trim(line)
     !
  elseif (table) then
     ! TABLE output
     call sic_ch (line,2,1,name,nc,.true.,error)
     if (error) return
     mess = 'Creating Table '//name
     call class_message(seve%i,proc,mess)
     call gildas_null(tbl)
     tbl%file = name
     tbl%gil%dim(1) = cx%next-1
     tbl%gil%dim(2) = tbl_dim2
     tbl%gil%coor_words = 0
     tbl%gil%ndim = 2
     allocate(dtbl(tbl%gil%dim(1),tbl%gil%dim(2)),stat=ier)
  else
     ! STDOUT
     jtmp = 6
  endif
  !
  call init_obs(obs)
  !
  ! Call appropriate routine according to what to do
  if (ido.eq.dofit) then  ! PRINT FIT
     if (set%method.eq.'CONTINUUM' .or. set%method.eq.'BASECONT') then
        call pricont(set,jtmp)
     elseif (set%method.eq.'GAUSS') then
        call prigauss(set,jtmp)
     elseif (set%method.eq.'NH3'.or.set%method.eq.'HFS') then
        call prinh3(set,jtmp)
     elseif (set%method.eq.'ABSORPTION') then
        call priabs(set,jtmp)
     elseif (set%method.eq.'SHELL') then
        call prishell(set,jtmp)
     endif
  elseif (ido.eq.dopointing) then  ! PRINT POINTING
     call pripoint(set,jtmp)
  elseif (ido.eq.doflux) then  ! PRINT FLUX
     call priflux(set,jtmp)
  else
     !
     ksave = knext
     !
     do kn=1,cx%next-1
        kx = cx%ind(kn)
        !
        ! Read the observation into obs
        call robs(obs,kx,error)        ! read obs header
        if (sic_ctrlc() .and. jtmp.eq.6) exit
        if (error) exit
        call rgen(set,obs,error)           ! general informations
        error = .false.
        if (ido.eq.doareabase) then
           if (.not.obs%head%presec(class_sec_bas_id)) then
             write(mess,'(3(A,I0))')  'Observation ',obs%head%gen%num,';',  &
               obs%head%gen%ver,' has no BASE section. Skipping.'
             call class_message(seve%w,proc,mess)
             cycle
           endif
           call rbase(set,obs,error)
           if (error) then
              write(mess,1002) kx,obs%head%gen%num,obs%head%gen%ver
              call class_message(seve%w,proc,mess)
           elseif (table) then
              ! call cido00 (obs%head%gen%num,head%pos%lamof,head%pos%betof,  &
              !              obs%head%bas%aire,obs%head%bas%sigfi,              &
              !              kn,dtbl,tbl%gil%dim(1),tbl%gil%dim(2))
              dtbl(kn,1) = obs%head%gen%num
              dtbl(kn,2) = obs%head%pos%lamof
              dtbl(kn,3) = obs%head%pos%betof
              dtbl(kn,4) = obs%head%bas%aire
              dtbl(kn,5) = obs%head%bas%sigfi
           else
              off1 = obs%head%pos%lamof*class_setup_get_fangle()
              off2 = obs%head%pos%betof*class_setup_get_fangle()
              write (jtmp,1003) obs%head%gen%num,off1,off2,obs%head%bas%aire,obs%head%bas%sigfi
           endif
           !
           ! List of channels
        elseif (ido.eq.dochannel) then
           call rspec(set,obs,error)
           ndata = obs%head%spe%nchan
           call reallocate_obs(obs,ndata,error)
           if (error)  return
           call rdata(set,obs,ndata,obs%spectre,error)
           if (error)  return
           allocate(value(ndata))  ! Not very efficient, but Ndata can vary for
                                   ! each observation in the index
           do i=1,nv
              if (cl(i).ge.1 .and. cl(i).le.ndata) then
                 value(i) = obs%spectre( cl(i) )
              else
                 value(i) = obs%head%spe%bad
              endif
           enddo
           if (table) then
              ! call cido03 (obs%head%gen%num,obs%head%pos%lamof,obs%head%pos%betof,  &
              !              nv,value,kn,dtbl,tbl%gil%dim(1),tbl%gil%dim(2))
              dtbl(kn,1) = obs%head%gen%num
              dtbl(kn,2) = obs%head%pos%lamof
              dtbl(kn,3) = obs%head%pos%betof
              do iv=1,nv
                 dtbl(kn,3+iv) = value(iv)
              enddo
           else
              off1 = obs%head%pos%lamof*class_setup_get_fangle()
              off2 = obs%head%pos%betof*class_setup_get_fangle()
              write (jtmp,1005) obs%head%gen%num,off1,off2,(value(i),i=1,nv)
           endif
           deallocate(value)
           !
        elseif (ido.eq.domoment) then
           call rspec(set,obs,error)
           ndata = obs%head%spe%nchan
           call reallocate_obs(obs,ndata,error)
           if (error)  return
           call rdata(set,obs,ndata,obs%spectre,error)
           do iv = 1, nv
              call getmom(obs,vites(2*iv-1),vites(2*iv),s0(iv),s1(iv),s2(iv))
           enddo
           if (table) then
              ! call cido04(obs%head%gen%num,obs%head%pos%lamof,obs%head%pos%betof,  &
              !             nv,s0,s1,s2,kn,dtbl,tbl%gil%dim(1),tbl%gil%dim(2))
              dtbl(kn,1) = obs%head%gen%num
              dtbl(kn,2) = obs%head%pos%lamof
              dtbl(kn,3) = obs%head%pos%betof
              do iv=1,nv
                 dtbl(kn,3+iv) = s0(iv)
                 dtbl(kn,3+nv+iv) = s1(iv)
                 dtbl(kn,3+2*nv+iv) = s2(iv)
              enddo
           else
              off1 = obs%head%pos%lamof*class_setup_get_fangle()
              off2 = obs%head%pos%betof*class_setup_get_fangle()
              write (jtmp,1005) obs%head%gen%num,off1,off2, &
                   &          (s0(iv),s1(iv),s2(iv),iv=1,nv)
           endif
           !
           ! Area by velocity range
        elseif (ido.eq.doarea) then
           !
           ! Compute the boundary channels
           call rspec(set,obs,error)
           ndata = obs%head%spe%nchan
           call reallocate_obs(obs,ndata,error)
           if (error)  return
           call rdata(set,obs,ndata,obs%spectre,error)
           do iv=1,nv
             call abscissa_velo2chan(obs%head,vites(iv),kanal(iv))
           enddo
           !
           ! Compute the area
           do iv = 1,nv-1
              ! Channels (real values)
              if (kanal(iv).lt.kanal(iv+1)) then
                rchan1 = kanal(iv)
                rchan2 = kanal(iv+1)
              else
                rchan1 = kanal(iv+1)
                rchan2 = kanal(iv)
              endif
              !
              ! Protections
              if (rchan2.lt..5 .or. rchan1.gt.(ndata+.5)) then
                write(mess,*) 'Velocity range ',vites(iv),vites(iv+1),  &
                  ' is out of spectrum boundaries'
                call class_message(seve%e,proc,mess)
                error = .true.
                goto 10
              endif
              !
              ! Channels (integer values)
              ichan1 = nint(rchan1)  ! because e.g. channel #2 goes from 1.5 to 2.5
              ichan2 = nint(rchan2)
              !
              ! Protections
              if (rchan1.lt..5 .or. rchan2.gt.(ndata+.5)) then
                write(mess,*) 'Velocity range ',vites(iv),vites(iv+1),  &
                  ' intersects spectrum boundaries'
                call class_message(seve%w,proc,mess)
                if (rchan1.lt..5)  then
                  rchan1 = .5
                  ichan1 = 1
                endif
                if (rchan2.gt.(ndata+.5))  then
                  rchan2 = ndata+.5
                  ichan2 = ndata
                endif
              endif
              !
              ! Boundary channel fractions
              if (ichan1.eq.ichan2) then
                frac1 = rchan2-rchan1
                frac2 = 0.
              else
                frac1 = (real(ichan1)+.5)-rchan1
                frac2 = rchan2-(real(ichan2)-.5)
              endif
              !
              ! Integrate
              aa = frac1*obs_good(obs,ichan1)
              do ic=ichan1+1,ichan2-1
                aa = aa + obs_good(obs,ic)  ! 'obs_good' interpolates bad channels if any
              enddo
              aa = aa + frac2*obs_good(obs,ichan2)
              !
              area(iv) = aa*abs(obs%head%spe%vres)
           enddo
           !
           if (table) then
              ! call cido03(obs%head%gen%num,obs%head%pos%lamof,obs%head%pos%betof,  &
              !             nv,area,kn,dtbl,tbl%gil%dim(1),tbl%gil%dim(2))
              dtbl(kn,1) = obs%head%gen%num
              dtbl(kn,2) = obs%head%pos%lamof
              dtbl(kn,3) = obs%head%pos%betof
              do iv=1,nv-1
                 dtbl(kn,3+iv) = area(iv)
              enddo
           else
              off1 = obs%head%pos%lamof*class_setup_get_fangle()
              off2 = obs%head%pos%betof*class_setup_get_fangle()
              write (jtmp,1005) obs%head%gen%num,off1,off2,(area(i),i=1,nv-1)
           endif
        endif
        error = .false.
        !
        ! Loop over index
     enddo
     !
     knext = ksave
  endif
  !
  if (table)  call gdf_write_image(tbl,dtbl,error)
  !
10 continue  ! You can jump here in case of error
  !
  call free_obs(obs)
  if (table) then
     deallocate(dtbl,stat=ier)
  elseif (jtmp.ne.6) then
     close (jtmp)
     call sic_frelun(jtmp)
  endif
  return
  !
1002 format('At entry ',i0,' Scan ',i0,';',i0)
1003 format(1x,i0,2(2x,f9.3),2x,(f9.3,1x,f6.3))
! 1004 format(1x,i0,11(2x,f9.3))
1005 format(1x,i0,2(2x,f9.3),15(1x,1pg12.5))
end subroutine class_print
!
subroutine getmom(obs,v1,v2,aire,vit,del)
  use gildas_def
  use gbl_constant
  use classcore_interfaces, except_this=>getmom
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Computes moment of the data between V1 and V2
  ! Caution: V1 and V2 are rounded to the nearest channel
  !----------------------------------------------------------------------
  type(observation), intent(in)  :: obs   !
  real(kind=4),      intent(in)  :: v1    ! Lower bound
  real(kind=4),      intent(in)  :: v2    ! Upper bound
  real(kind=4),      intent(out) :: aire  ! Integrated area
  real(kind=4),      intent(out) :: vit   ! Central velocity
  real(kind=4),      intent(out) :: del   ! Line width
  ! Local
  real(kind=4) :: s0, s1, s2, value, s12, r1, r2
  integer(kind=4) :: i1, i2, nc, imin, imax, i
  !
  ! Compute the moment(s)
  if (obs%head%gen%kind.eq.kind_spec) then
    call abscissa_velo2chan(obs%head,v1,r1)
    call abscissa_velo2chan(obs%head,v2,r2)
    i1 = nint(r1)
    i2 = nint(r2)
    nc = obs%head%spe%nchan
  else
    call abscissa_angl2chan(obs%head,v1,r1)
    call abscissa_angl2chan(obs%head,v2,r2)
    i1 = nint(r1)
    i2 = nint(r2)
    nc = obs%head%dri%npoin
  endif
  imin = max(min(i1,i2),1)
  imax = min(max(i1,i2),nc)
  !
  s0 = 0.
  s1 = 0.
  s2 = 0.
  aire = 0.
  vit = 0.
  del = 0.
  do i=imin,imax
    value = obs_good(obs,i)
    s0 = s0+value
    s1 = s1+value*i
    s2 = s2+i*value*i
  enddo
  !
  ! Type out result according to Kind
  if (obs%head%gen%kind.eq.kind_spec) then
    if (s0.ne.0) then
      s1 = s1 / s0
      call abscissa_chan2velo(obs%head,s1,vit)
      s2 = s2 / s0
      s12 = s1**2
      if (s2.gt.s12)  del = abs(obs%head%spe%vres) * sqrt((s2-s12)*8.*log(2.))
    endif
    aire = s0 * abs(obs%head%spe%vres)
  else
    if (s0.ne.0) then
      s1 = s1 / s0
      call abscissa_chan2angl(obs%head,s1,vit)
      s2 = s2 / s0
      s12 = s1**2
      if (s2.gt.s12)  del = abs(obs%head%dri%ares) * sqrt((s2-s12)*8.*log(2.))
    endif
    aire = s0 * abs (obs%head%dri%ares)
  endif
end subroutine getmom
!
subroutine prigauss(set,jtmp)
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>prigauss
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Print the results of gaussfit to a listing file
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set   !
  integer(kind=4),     intent(in) :: jtmp  ! Logical unit number
  ! Local
  integer(kind=4) :: k,i
  integer(kind=entry_length) :: ksave,kn
  real(kind=4) :: off1,off2
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  ksave = knext
  !
  ! Loop over index
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     call rgen(set,obs,error)
     error=.false.
     call rgaus(set,obs,error)
     off1 = obs%head%pos%lamof*class_setup_get_fangle()
     off2 = obs%head%pos%betof*class_setup_get_fangle()
     !
     ! Write the information if present
     if (obs%head%gau%sigba.ne.0.0.and..not.error) then
        k=1
        if (obs%head%gen%kind.eq.kind_cont) then
           do i=1,max(obs%head%gau%nline,1)
              write (jtmp,1000)  &
                max(obs%head%gau%nline,1),obs%head%gen%num,  &
                off1,off2,                                   &
                obs%head%gau%nfit(k)*class_setup_get_fangle(),  &
                obs%head%gau%nerr(k)*class_setup_get_fangle(),  &
                obs%head%gau%nfit(k+1)*class_setup_get_fangle(),  &
                obs%head%gau%nerr(k+1)*class_setup_get_fangle(),  &
                obs%head%gau%nfit(k+2)*class_setup_get_fangle(),  &
                obs%head%gau%nerr(k+2)*class_setup_get_fangle(),  &
                obs%head%gau%nfit(k)/obs%head%gau%nfit(k+2)/1.064467,  &
                obs%head%gau%sigba,obs%head%gau%sigra
              k=k+3
           enddo
        else
           do i=1,max(obs%head%gau%nline,1)
              write (jtmp,1000) max(obs%head%gau%nline,1),             &
                obs%head%gen%num,off1,off2,                            &
                obs%head%gau%nfit(k),  obs%head%gau%nerr(k),           &
                obs%head%gau%nfit(k+1),obs%head%gau%nerr(k+1),         &
                obs%head%gau%nfit(k+2),obs%head%gau%nerr(k+2),         &
                obs%head%gau%nfit(k)/obs%head%gau%nfit(k+2)/1.064467,  &
                obs%head%gau%sigba,obs%head%gau%sigra
              k=k+3
           enddo
        endif
     else
        write(jtmp,1002) 0,obs%head%gen%num,off1,off2
     endif
     error = .false.
  enddo
  knext = ksave
  !
  call free_obs(obs)
  return
  !
1000 format(1x,i1,1x,i0,2(1x,g10.3),2x,   &
       &    3(1pg12.4,' ',1pg11.3,'   '),1pg11.3,2x,2(1pg11.3,2x))
! 1001 format(35x,   &
!        &    3(1pg12.4,' ',1pg11.3,'   '),1pg11.3,2x,2(1pg11.3,2x))
1002 format(1x,i1,1x,i0,2(2x,f8.3),2x,'/   No Fit ...')
end subroutine prigauss
!
subroutine priabs(set,jtmp)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>priabs
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Print the ABS fit results in a format suitable for GREG
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  integer(kind=4),     intent(in) :: jtmp
  ! Local
  integer(kind=4) :: k,i
  integer(kind=entry_length) :: ksave,kn
  real(kind=4) :: off1,off2
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write (jtmp,1003)
  ksave=knext
  !
  ! Loop over index entries
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     off1 = obs%head%pos%lamof*class_setup_get_fangle()
     off2 = obs%head%pos%betof*class_setup_get_fangle()
     if (obs%head%presec(class_sec_abs_id)) then
        call rgen(set,obs,error)
        error=.false.
        call rabs(set,obs,error)
        k=2
        do i=1,max(obs%head%abs%nline,1)
           write (jtmp,1000)                                 &
             max(obs%head%abs%nline,1),obs%head%gen%num,     &
             off1,off2,                                      &
             obs%head%abs%nfit(k),  obs%head%abs%nerr(k),    &
             obs%head%abs%nfit(k+1),obs%head%abs%nerr(k+1),  &
             obs%head%abs%nfit(k+2),obs%head%abs%nerr(k+2),  &
             obs%head%abs%sigba,    obs%head%abs%sigra
           k=k+3
        enddo
        error = .false.
     endif
  enddo
  knext=ksave
  !
  call free_obs(obs)
  return
  !
1000 format(1x,i1,1x,i0,2(2x,f8.3),2x,  &
            3(f8.3,' ',f7.3,'   '),2x,2(f6.3,2x))
1003 format('! Absorption fitting . . . . . . . . . .',  &
            'Opacity           Vlsr            Width ')
end subroutine priabs
!
subroutine prishell(set,jtmp)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>prishell
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Print the SHELL fit results in a format suitable for GREG
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set   !
  integer(kind=4),     intent(in) :: jtmp  ! Logical Unit number for message
  ! Local
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k,i
  real(kind=4) :: off1,off2, d, ed
  real(kind=8) :: f ,fi
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write (jtmp,1003)
  ksave=knext
  !
  ! Loop over index entries
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     off1 = obs%head%pos%lamof*class_setup_get_fangle()
     off2 = obs%head%pos%betof*class_setup_get_fangle()
     if (obs%head%presec(class_sec_she_id)) then
        call rgen(set,obs,error)
        error=.false.
        call rshel(set,obs,error)
        error=.false.
        call rspec(set,obs,error)
        k=1
        f = obs%head%she%nfit(k+1)+obs%head%spe%restf
        fi=-obs%head%she%nfit(k+1)+obs%head%spe%image
        d = obs%head%she%nfit(k+2)*clight_kms/obs%head%spe%restf
        ed= obs%head%she%nerr(k+2)*clight_kms/obs%head%spe%restf
        ! T = 1.5*obs%head%she%nfit(K)/obs%head%she%nfit(K+2)/(3.0+obs%head%she%nfit(K+3))
        write (jtmp,1000)  &
          max(obs%head%she%nline,1),obs%head%gen%num,off1,off2,            &
          obs%head%she%nfit(k), obs%head%she%nerr(k), f, fi,               &
          obs%head%she%nerr(k+1), d, ed,  obs%head%she%nfit(k+3),          &
          obs%head%she%nerr(k+3), obs%head%she%sigba, obs%head%she%sigra,  &
          obs%head%pos%sourc
        !
        ! Write the information if present
        do i=2,max(obs%head%she%nline,1)
           k=k+4
           f = obs%head%she%nfit(k+1)+obs%head%spe%restf
           fi=-obs%head%she%nfit(k+1)+obs%head%spe%image
           d = obs%head%she%nfit(k+2)*clight_kms/obs%head%spe%restf
           ed= obs%head%she%nerr(k+2)*clight_kms/obs%head%spe%restf
           write (jtmp,1001)  &
             obs%head%she%nfit(k),obs%head%she%nerr(k),  &
             f,fi,obs%head%she%nerr(k+1),                &
             d,ed,obs%head%she%nfit(k+3),obs%head%she%nerr(k+3)
        enddo
        error = .false.
     else
        write(jtmp,1002) 0,obs%head%gen%num,off1,off2,obs%head%pos%sourc
     endif
     !
  enddo
  knext=ksave
  !
  call free_obs(obs)
  return
  !
1003 format('! Shell Scan   Off1     Off2     Area     Da      ',   &
            'Freq.Sig.    Freq.Ima.    Df    Exp.Vel.   De  Horn/Center ',   &
            'DH/C  Sig.B.  Sig.R.')
1000 format (1x,i1,1x,i0,2(1x,f8.3),1x,   &
            f8.3,1x,f7.3,1x,2(f12.3,1x),f7.3,1x,   &
            2(f8.2,1x,f6.2,1x),2(f7.3,1x),'/',a)
1001 format (30x,   &
            f8.3,1x,f7.3,1x,2(f12.3,1x),f7.3,1x,   &
            2(f8.2,1x,f6.2,1x))
1002 format (1x,i1,1x,i0,2(2x,f8.3),2x,'/ ',a,' No Fit ...')
end subroutine prishell
!
subroutine prinh3(set,jtmp)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>prinh3
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Print the NH3 fit results in a format suitable for GREG
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  integer(kind=4),     intent(in) :: jtmp
  ! Local
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k,i
  real(kind=4) :: off1,off2
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write (jtmp,1003)
  ksave=knext
  !
  ! Loop over index entries
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     off1 = obs%head%pos%lamof*class_setup_get_fangle()
     off2 = obs%head%pos%betof*class_setup_get_fangle()
     if (obs%head%presec(class_sec_hfs_id)) then
        call rgen(set,obs,error)
        error=.false.
        call rnh3(set,obs,error)
        k=1
        do i=1,max(obs%head%hfs%nline,1)
           write (jtmp,1000)  &
             max(obs%head%hfs%nline,1),obs%head%gen%num,     &
             off1,off2,                                      &
             obs%head%hfs%nfit(k),  obs%head%hfs%nerr(k),    &
             obs%head%hfs%nfit(k+1),obs%head%hfs%nerr(k+1),  &
             obs%head%hfs%nfit(k+2),obs%head%hfs%nerr(k+2),  &
             obs%head%hfs%nfit(k+3),obs%head%hfs%nerr(k+3),  &
             obs%head%hfs%sigba,obs%head%hfs%sigra
           k=k+4
        enddo
        error = .false.
     endif
  enddo
  knext=ksave
  !
  call free_obs(obs)
  return
  !
1000 format(1x,i1,1x,i0,2(2x,f8.3),2x,  &
            4(f8.3,' ',f7.3,'   '),2x,2(f6.3,2x))
1003 format('! NH3 Hyperfine structure fitting . . . . . . . . . .',  &
            'Area           Vlsr            Width          Opacity')
end subroutine prinh3
!
subroutine pricont(set,jtmp)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>pricont
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Print the results of gaussfit to a listing file, for continuum data
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set   !
  integer(kind=4),     intent(in) :: jtmp  ! Logical unit number
  ! Local
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k
  real(kind=4) :: off1,off2
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write(jtmp,1001)
  ksave = knext
  !
  ! Loop over index
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     call rgen(set,obs,error)
     error=.false.
     call rpoint(set,obs,error)
     off1 = obs%head%gen%az*180.0d0/pi
     off2 = obs%head%gen%el*180.0d0/pi
     !
     ! Write the information if present
     if (obs%head%poi%sigba.ne.0.0 .and. .not.error) then
        k = 3
        write (jtmp,1000)                                   &
          obs%head%gen%num,                                 &
          off1,off2,                                        &
          obs%head%poi%nfit(k)*class_setup_get_fangle(),    &
          obs%head%poi%nerr(k)*class_setup_get_fangle(),    &
          obs%head%poi%nfit(k+1)*class_setup_get_fangle(),  &
          obs%head%poi%nerr(k+1)*class_setup_get_fangle(),  &
          obs%head%poi%nfit(k+2)*class_setup_get_fangle(),  &
          obs%head%poi%nerr(k+2)*class_setup_get_fangle(),  &
          obs%head%poi%nfit(k)/obs%head%poi%nfit(k+2)/1.064467,  &
          obs%head%poi%sigba,obs%head%poi%sigra,                 &
          obs%head%pos%sourc
     else
        write (jtmp,1002) obs%head%gen%num,off1,off2,obs%head%pos%sourc
     endif
     error = .false.
  enddo
  knext = ksave
  !
  call free_obs(obs)
  return
  !
1001 format('!   Obs.#     Azimuth   Elevation   Area     ..',   &
            '            Position  ..           Width     ..          Intensity',  &
            '         Sigmas ..     Source')
1000 format(1x,i10,2(2x,g9.3),2x,   &
            3(g9.3,' ',g9.3,'   '),g9.3,4x,2(g9.3,2x),'''',a,'''')
1002 format(1x,i10,2(2x,g9.3),2x,'/   No Fit ... for ',a)
end subroutine pricont
!
subroutine pripoint(set,jtmp)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>pripoint
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Print the results of gaussfit to a listing file, for pointing data
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  integer(kind=4),     intent(in) :: jtmp   ! Logical unit number
  ! Local
  real(kind=8) :: kangle
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k,iflag,iant,ista
  real(kind=4) :: az,el,time,offset
  logical :: error
  character(len=12) :: cteles
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write(jtmp,1001)
  ksave = knext
  kangle = 3600d0*180d0/pi
  !
  ! Loop over index
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     error=.false.
     call rgen(set,obs,error)
     error=.false.
     call rcont(set,obs,error)
     error = .false.
     call rpoint(set,obs,error)
     az  = obs%head%gen%az*180.0d0/pi
     el = obs%head%gen%el*180.0d0/pi
     time = obs%head%gen%st*12.d0/pi
     !
     cteles = obs%head%gen%teles
     if (cteles(1:3).eq.'BUR') then
        read(cteles(4:4),'(I1)') iant
        read(cteles(7:8),'(I2)') ista
        if (cteles(6:6).eq.'E') then
           ista = 300+ista
        elseif (cteles(6:6).eq.'W') then
           ista = 200+ista
        elseif (cteles(6:6).eq.'N') then
           ista = 100+ista
        endif
     else
        iant = 0
        ista = 0
     endif
     !
     ! Write the information if present
     if (obs%head%poi%sigba.ne.0.0.and..not.error) then
        k = 3
        if (mod(abs(obs%head%dri%apos+pis),pis).le.1e-3 .or.   &
            mod(abs(obs%head%dri%apos),pis).le.1e-3) then
           iflag = 0                ! 0 or PI: along elevation
           offset = obs%head%dri%colle+obs%head%poi%nfit(k+1)+obs%head%pos%betof
        elseif (abs(mod(obs%head%dri%apos,pis)-0.5*pis).le.1e-3 .or.  &
                abs(mod(obs%head%dri%apos,pis)+0.5*pis).le.1e-3) then
           iflag = 1                ! -PI/2 or +PI/2: along azimuth
           offset = obs%head%dri%colla+obs%head%poi%nfit(k+1)+obs%head%pos%lamof
        else
           iflag = -1               ! Unknown
           offset = obs%head%poi%nfit(k+1)
        endif
        write (jtmp,1000)                                               &
          obs%head%gen%num,obs%head%gen%scan,iflag,az,el,time,          &
          offset*kangle,obs%head%poi%nerr(k+1)*kangle,iant,ista,        &
          obs%head%poi%nfit(k+2)*kangle,obs%head%poi%nerr(k+2)*kangle,  &
          obs%head%poi%nfit(k)/obs%head%poi%nfit(k+2)/1.064467,         &
          obs%head%poi%sigra,                                           &
          obs%head%pos%sourc
     else
        write (jtmp,1002) obs%head%gen%num,obs%head%gen%scan,-1,az,el,  &
          time,obs%head%pos%sourc
     endif
     error = .false.
  enddo
  knext = ksave
  !
  call free_obs(obs)
  return
  !
1001 format('!   Obs.#     Scan Code Azimuth   Elevation   Time  ',  &
            '     Position  ..  A# Station   Width      ..     Intensity',  &
            '     Sigma    Source')
1000 format(1x,i8,1x,i8,i4,3(2x,f8.3),1x,  &
            f9.2,1x,f8.2,1x,i2,i4,1x,f9.2,1x,f8.2,1x,  &
            1pg10.3,2x,1pg10.3,2x,'''',a,'''')
1002 format(1x,i8,1x,i8,i4,3(2x,f8.3),2x,'/   No Fit ... for ',a)
end subroutine pripoint
!
subroutine priflux(set,jtmp)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>priflux
  use class_index
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  !  Print the results of gaussfit to a listing file, for FLUX data
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  integer(kind=4),     intent(in) :: jtmp   ! Logical unit number
  ! Local
  real(kind=8) :: kangle
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k,iflag,iant,ista
  real(kind=4) :: az,el,time,offset
  logical :: error
  character(len=12) :: cteles,ch
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write(jtmp,1001)
  ksave = knext
  kangle = 3600d0*180d0/pi
  !
  ! Loop over index
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     error=.false.
     call rgen(set,obs,error)
     error=.false.
     call rcont(set,obs,error)
     error = .false.
     call rcal(set,obs,error)
     error = .false.
     call rpoint(set,obs,error)
     error = .false.
     az  = obs%head%gen%az*180.0d0/pi
     el = obs%head%gen%el*180.0d0/pi
     time = obs%head%gen%st*12.d0/pi
     !
     cteles = obs%head%gen%teles
     if (cteles(1:3).eq.'BUR') then
        read(cteles(4:4),'(I1)') iant
     else
        iant = 0
        ista = 0
     endif
     !
     ! Write the information if present
     call gag_todate(obs%head%gen%dobs,ch,error)
     if (obs%head%poi%sigba.ne.0.0.and..not.error) then
        k = 3
        if (mod(abs(obs%head%dri%apos+pis),pis).le.1e-3 .or.   &
            mod(abs(obs%head%dri%apos),pis).le.1e-3) then
           iflag = 0                ! Elevation
           offset = obs%head%poi%nfit(k+1)+obs%head%pos%betof
        elseif (mod(abs(obs%head%dri%apos+0.5*pis),pis).le.1e-3) then
           iflag = 1                ! Azimuth
           offset = obs%head%poi%nfit(k+1)+obs%head%pos%lamof
        else
           iflag = -1               ! Unknown
           offset = obs%head%poi%nfit(k+1)
        endif
        write (jtmp,1000)                                               &
          obs%head%gen%num,obs%head%gen%scan,iflag,az,el,time,          &
          offset*kangle,obs%head%poi%nerr(k+1)*kangle,iant,             &
          obs%head%poi%nfit(k+2)*kangle,obs%head%poi%nerr(k+2)*kangle,  &
          obs%head%poi%nfit(k)/obs%head%poi%nfit(k+2)/1.064467,         &
          obs%head%poi%sigra,obs%head%cal%gaini,                        &
          obs%head%dri%freq*1e-3,obs%head%dri%cimag*1e-3,               &
          obs%head%pos%sourc,ch
     else
        write (jtmp,1000)  &
          obs%head%gen%num,obs%head%gen%scan,-1,az,el,time,obs%head%pos%sourc,ch
     endif
     error = .false.
  enddo
  knext = ksave
  !
  call free_obs(obs)
  return
  !
1001 format('!   Obs.#     Scan Code Azimuth   Elevation  Time  ',  &
            '     Position  ..  A#     Width      ..     Intensity',  &
            '     ..  Gain   Fsignal  Fimage Source  Date')
1000 format(1x,i8,1x,i8,i3,3(1x,f8.3),1x,  &
            f9.2,1x,f8.2,1x,i2,1x,f9.2,1x,f8.2,1x,  &
            1pg10.3,1x,1pg10.3,1x,0pf6.2,2(1x,f8.3),1x,'''',a,'''',  &
            1x,'''',a,'''')
end subroutine priflux
!
subroutine cido00 (num,off1,off2,aire,sigma,n,tab,nl,nc)
  !----------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  ! obsolete
  !----------------------------------------------------------------------
  integer, intent(in) :: num
  integer, intent(in) :: n
  integer, intent(in) :: nl
  integer, intent(in) :: nc
  real,    intent(in) :: off1
  real,    intent(in) :: off2
  real,    intent(in) :: aire
  real,    intent(in) :: sigma
  real,    intent(inout) :: tab(nl,nc)
  !
  if (n.gt.nl) return
  tab(n,1) = num
  tab(n,2) = off1
  tab(n,3) = off2
  tab(n,4) = aire
  tab(n,5) = sigma
end subroutine cido00
!
subroutine cido03 (num,off1,off2,nv,value,n,tab,nl,nc)
  !----------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  ! obsolete
  !----------------------------------------------------------------------
  integer num,n,nl,nc,nv,i
  real off1,off2,value(nv),tab(nl,nc)
  !
  if (n.gt.nl) return
  tab(n,1) = num
  tab(n,2) = off1
  tab(n,3) = off2
  do i=1,nv
     tab(n,3+i) = value(i)
  enddo
end subroutine cido03
!
subroutine cido04 (num,off1,off2,nv,val1,val2,val3,n,tab,nl,nc)
  !----------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  ! obsolete
  !----------------------------------------------------------------------
  integer num,n,nl,nc,nv,i
  real off1,off2,val1(nv),val2(nv),val3(nv),tab(nl,nc)
  if (n.gt.nl) return
  tab(n,1) = num
  tab(n,2) = off1
  tab(n,3) = off2
  do i=1,nv
     tab(n,3+i) = val1(i)
     tab(n,3+nv+i) = val2(i)
     tab(n,3+2*nv+i) = val3(i)
  enddo
end subroutine cido04

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!***JP: This one is a tentative code that did not converge. I leave it here
!***JP: for the moment. To be deleted on 2024-09-01 if nothing happened!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_correlation
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubetopology_cuberegion_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubecompute_messaging
  use cubecompute_correlate_spectrum_tool
  !
  public :: correlation
  private
  !
  type :: correlation_comm_t
     type(option_t), pointer :: comm
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: cube1
     type(cubeid_arg_t), pointer :: cube2
     type(cube_prod_t),  pointer :: correlated
   contains
     procedure, public  :: register => cubecompute_correlation_comm_register
     procedure, private :: parse    => cubecompute_correlation_comm_parse
     procedure, private :: main     => cubecompute_correlation_comm_main
  end type correlation_comm_t
  type(correlation_comm_t) :: correlation
  !
  type correlation_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubecompute_correlation_user_toprog
  end type correlation_user_t
  !
  type correlation_prog_t
     type(cuberegion_prog_t) :: region
     type(cube_t), pointer   :: cube1
     type(cube_t), pointer   :: cube2
     type(cube_t), pointer   :: correlated
     type(correlate_spectrum_prog_t) :: correl
   contains
     procedure, private :: header => cubecompute_correlation_prog_header
     procedure, private :: data   => cubecompute_correlation_prog_data
     procedure, private :: loop   => cubecompute_correlation_prog_loop
     procedure, private :: act    => cubecompute_correlation_prog_act
  end type correlation_prog_t
  !
contains
  !
  subroutine cubecompute_correlation_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(correlation_user_t) :: user
    character(len=*), parameter :: rname='CORRELATION>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call correlation%parse(line,user,error)
    if (error) return
    call correlation%main(user,error)
    if (error) continue
  end subroutine cubecompute_correlation_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_correlation_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_comm_t), intent(inout) :: comm
    logical,                   intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: correlated
    character(len=*), parameter :: rname='CORRELATION>COMM>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
        'CORRELATION','[cubeid1] [cubeid2]',&
         'Template to access input/output data per spectrum',&
         'Input and output cubes are real',&
         cubecompute_correlation_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'CUBE1',&
         'First cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_speset,&
         comm%cube1,&
         error)
    call incube%register(&
         'CUBE2',&
         'Second cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_speset,&
         comm%cube2,&
         error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call correlated%register(&
         'CORRELATION',&
         'Correlated cube',&
         strg_emp,&
         [flag_correlation],&
         comm%correlated,&
         error)
    if (error)  return
  end subroutine cubecompute_correlation_comm_register
  !
  subroutine cubecompute_correlation_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_comm_t), intent(in)    :: comm
    character(len=*),          intent(in)    :: line
    type(correlation_user_t),  intent(out)   :: user
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='CORRELATION>COMM>PARSE'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubecompute_correlation_comm_parse
  !
  subroutine cubecompute_correlation_comm_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_comm_t), intent(in)    :: comm
    type(correlation_user_t),  intent(inout) :: user
    logical,                   intent(inout) :: error
    !
    type(correlation_prog_t) :: prog
    character(len=*), parameter :: rname='CORRELATION>COMM>MAIN'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubecompute_correlation_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubecompute_correlation_user_toprog(user,comm,prog,error)
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_user_t), intent(in)    :: user
    type(correlation_comm_t),  intent(in)    :: comm    
    type(correlation_prog_t),  intent(out)   :: prog
    logical,                   intent(inout) :: error
    !
    logical :: conspb
    character(len=*), parameter :: rname='CORRELATION>USER>TOPROG'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube1,user%cubeids,prog%cube1,error)
    if (error) return
    call cubeadm_get_header(comm%cube2,user%cubeids,prog%cube2,error)
    if (error) return
    !
    ! ***JP: unclear whether the program should accept the case where the
    ! ***JP: subregions of two cubes are consistent
    conspb = .false.
    call cubetools_consistency_shape(&
         'Input cube #1',prog%cube1%head,&
         'Input cube #2',prog%cube2%head,&
         conspb,error)
    if (error) return
    if (cubetools_consistency_failed(rname,conspb,error)) return
    !    
    call user%region%toprog(prog%cube1,prog%region,error)
    if (error) return
    call user%region%toprog(prog%cube2,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%region%list(error)
    if (error) return
  end subroutine cubecompute_correlation_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubecompute_correlation_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_prog_t), intent(inout) :: prog
    type(correlation_comm_t),  intent(in)    :: comm
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='CORRELATION>PROG>HEADER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%correlated,prog%cube1,prog%correlated,error)
    if (error) return
    call prog%region%header(prog%correlated,error)
    if (error) return
  end subroutine cubecompute_correlation_prog_header
  !
  subroutine cubecompute_correlation_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(correlation_prog_t), intent(inout) :: prog
    logical,                   intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='CORRELATION>PROG>DATA'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubecompute_correlation_prog_data
  !   
  subroutine cubecompute_correlation_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),  intent(inout) :: iter
    logical,                   intent(inout) :: error
    !
    type(spectrum_t) :: spe1,spe2,correlated
    character(len=*), parameter :: rname='CORRELATION>PROG>LOOP'
    !
    call spe1%associate('spectrum #1',prog%cube1,iter,error)
    if (error) return
    call spe2%associate('spectrum #2',prog%cube2,iter,error)
    if (error) return
    call correlated%allocate('correlated spectrum',prog%correlated,iter,error)
    if (error) return
    call prog%correl%init(spe1,spe2,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,spe1,spe2,correlated,error)
      if (error) return
    enddo ! ie
  end subroutine cubecompute_correlation_prog_loop
  !   
  subroutine cubecompute_correlation_prog_act(prog,ie,spe1,spe2,correlated,error)
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_prog_t), intent(inout) :: prog
    integer(kind=entr_k),      intent(in)    :: ie
    type(spectrum_t),          intent(inout) :: spe1
    type(spectrum_t),          intent(inout) :: spe2
    type(spectrum_t),          intent(inout) :: correlated
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='CORRELATION>PROG>ACT'
    !
    call spe1%get(ie,error)
    if (error) return
    call spe2%get(ie,error)
    if (error) return
    call prog%correl%spectrum(spe1,spe2,correlated,error)
    if (error) return
    call correlated%put(ie,error)
    if (error) return
  end subroutine cubecompute_correlation_prog_act
end module cubecompute_correlation
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module datetime_params
  !
  ! Options description
  integer(kind=4), parameter :: optfrom=1
  integer(kind=4), parameter :: optto=2
  !
  ! Date and time formats
  integer(kind=4), parameter :: mformats=14
  character(len=11), parameter :: formats(mformats) =  &
    (/ 'YEAR       ','MONTH      ','DAY        ','HOUR       ','MINUTE     ',  &
       'SECONDS    ','JULIAN     ','MJD        ','ISO        ','GAG_DATE   ',  &
       'YYYYMMDD   ','DD-MMM-YYYY','RADIAN     ','SEXAGESIMAL' /)
  !
  integer(kind=4), parameter :: mfield=6  ! year, month, day, hour, minutes, seconds
  !
  ! The order of the 6 first matters
  integer(kind=4), parameter :: fmt_year       = 1
  integer(kind=4), parameter :: fmt_month      = 2
  integer(kind=4), parameter :: fmt_day        = 3
  integer(kind=4), parameter :: fmt_hour       = 4
  integer(kind=4), parameter :: fmt_minute     = 5
  integer(kind=4), parameter :: fmt_seconds    = 6
  integer(kind=4), parameter :: fmt_julian     = 7
  integer(kind=4), parameter :: fmt_mjd        = 8
  integer(kind=4), parameter :: fmt_iso        = 9
  integer(kind=4), parameter :: fmt_gagdate    = 10
  integer(kind=4), parameter :: fmt_yyyymmdd   = 11
  integer(kind=4), parameter :: fmt_ddmmmyyyy  = 12
  integer(kind=4), parameter :: fmt_radian     = 13
  integer(kind=4), parameter :: fmt_sexagesimal= 14
  !
end module datetime_params
!
subroutine sic_datetime(line,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_datetime
  use sic_types
  use datetime_params
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    DATETIME InValue1 [Invalue2] OutFormat Outvar1 [Outvar2]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  integer(kind=size_length) :: nelem
  ! /FROM: input variables
  integer(kind=4), parameter :: minput=mfield  ! By construction there are at most 6 input sources
  integer(kind=4) :: ninput
  type(datetime_spec_t) :: in(minput)
  ! /TO: output variables
  integer(kind=4), parameter :: moutput=mformats  ! Arbitrary (no limit in the
    ! design), use mformats so that we can test all output formats at once.
  integer(kind=4) :: noutput
  type(datetime_spec_t) :: out(moutput)
  !
  ninput = 0
  noutput = 0
  !
  call sic_datetime_parse(line,in,ninput,out,noutput,nelem,error)
  if (error)  goto 10
  !
  call sic_datetime_do(in,ninput,out,noutput,nelem,error)
  if (error)  goto 10
  !
10 continue
  call sic_datetime_clean(in,ninput,out,noutput,error)
  if (error)  return
  !
end subroutine sic_datetime
!
subroutine sic_datetime_parse(line,in,ninput,out,noutput,nelem,error)
  use gbl_format
  use phys_const
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_datetime_parse
  use sic_types
  use datetime_params
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: line     !
  type(datetime_spec_t),     intent(out)   :: in(:)    !
  integer(kind=4),           intent(inout) :: ninput   ! Useful size of in(:)
  type(datetime_spec_t),     intent(out)   :: out(:)   !
  integer(kind=4),           intent(inout) :: noutput  ! Useful size of out(:)
  integer(kind=size_length), intent(out)   :: nelem    ! Size of problem
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DATETIME'
  character(len=16) :: argum,forma
  integer(kind=4) :: nc,iforma,iarg
  integer(kind=4) :: i,shift(mfield)
  character(len=varname_length) :: varname
  integer(kind=size_length), parameter :: one=1_8
  logical :: got(mfield)
  integer(kind=4), parameter :: scratch=-1
  !
  ! Sanity checks
  if (.not.sic_present(optfrom,0) .or. .not.sic_present(optto,0)) then
    call sic_message(seve%e,rname,'Options /FROM and /TO must be present')
    error = .true.
    return
  endif
  !
  !---------------------------------------------------------------------
  ! /FROM
  !
  ninput = 0
  got(:) = .false.
  !
  ! 1st argument?
  call sic_ke(line,optfrom,1,argum,nc,.true.,error)
  if (error)  return
  !
  if (argum.eq.'NOW') then
    ! Get current date-time
    if (sic_present(optfrom,2)) then
      call sic_message(seve%e,rname,'No more arguments allowed after keyword "NOW"')
      error = .true.
      return
    endif
    shift(:) = 0
    call getnow(shift)
    !
  else
    !
    do iarg=1,sic_narg(optfrom),2
      call sic_ke(line,optfrom,iarg+1,argum,nc,.true.,error)
      if (error)  return
      call sic_ambigs(rname,argum,forma,iforma,formats,mformats,error)
      if (error)  return
      !
      ninput = ninput+1
      in(ninput)%isvar = .true.  ! Always for input
      in(ninput)%form = iforma
      !
      select case (forma)
      case ('YEAR')
        if (setgot_error(fmt_year,error)) return
        call sic_prevnexti4(iarg,fmt_year,in(ninput)%desc,error)
        if (error)  return
        !
      case ('MONTH')
        if (setgot_error(fmt_month,error)) return
        call sic_prevnexti4(iarg,fmt_month,in(ninput)%desc,error)
        if (error)  return
        !
      case ('DAY')
        if (setgot_error(fmt_day,error)) return
        call sic_prevnexti4(iarg,fmt_day,in(ninput)%desc,error)
        if (error)  return
        !
      case ('HOUR')
        if (setgot_error(fmt_hour,error)) return
        call sic_prevnexti4(iarg,fmt_hour,in(ninput)%desc,error)
        if (error)  return
        !
      case ('MINUTE')
        if (setgot_error(fmt_minute,error)) return
        call sic_prevnexti4(iarg,fmt_minute,in(ninput)%desc,error)
        if (error)  return
        !
      case ('SECONDS')
        if (setgot_error(fmt_seconds,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        !
      case ('JULIAN')
        if (setgot_error(fmt_year,error)) return
        if (setgot_error(fmt_month,error)) return
        if (setgot_error(fmt_day,error)) return
        if (setgot_error(fmt_hour,error)) return
        if (setgot_error(fmt_minute,error)) return
        if (setgot_error(fmt_seconds,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        !
      case ('MJD')
        if (setgot_error(fmt_year,error)) return
        if (setgot_error(fmt_month,error)) return
        if (setgot_error(fmt_day,error)) return
        if (setgot_error(fmt_hour,error)) return
        if (setgot_error(fmt_minute,error)) return
        if (setgot_error(fmt_seconds,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        !
      case ('ISO')
        if (setgot_error(fmt_year,error)) return
        if (setgot_error(fmt_month,error)) return
        if (setgot_error(fmt_day,error)) return
        if (setgot_error(fmt_hour,error)) return
        if (setgot_error(fmt_minute,error)) return
        if (setgot_error(fmt_seconds,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        if (in(ninput)%desc%type.le.0) then
          call sic_message(seve%e,rname,'/FROM ISO argument must be a character string')
          error = .true.
          return
        endif
        !
      case ('GAG_DATE')
        if (setgot_error(fmt_year,error)) return
        if (setgot_error(fmt_month,error)) return
        if (setgot_error(fmt_day,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        if (in(ninput)%desc%type.ne.fmt_i4 .and. in(ninput)%desc%type.ne.fmt_i8) then
          call sic_message(seve%e,rname,'/FROM GAG_DATE argument must be integer')
          error = .true.
          return
        endif
        !
      case ('YYYYMMDD')
        if (setgot_error(fmt_year,error)) return
        if (setgot_error(fmt_month,error)) return
        if (setgot_error(fmt_day,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        if (in(ninput)%desc%type.le.0) then
          call sic_message(seve%e,rname,'/FROM YYYYMMDD argument must be a character string')
          error = .true.
          return
        endif
        !
      case ('DD-MMM-YYYY')
        if (setgot_error(fmt_year,error)) return
        if (setgot_error(fmt_month,error)) return
        if (setgot_error(fmt_day,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        if (in(ninput)%desc%type.le.0) then
          call sic_message(seve%e,rname,'/FROM DD-MMM-YYYY argument must be a character string')
          error = .true.
          return
        endif
        !
      case ('RADIAN')
        if (setgot_error(fmt_hour,error)) return
        if (setgot_error(fmt_minute,error)) return
        if (setgot_error(fmt_seconds,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        !
      case ('SEXAGESIMAL')
        if (setgot_error(fmt_hour,error)) return
        if (setgot_error(fmt_minute,error)) return
        if (setgot_error(fmt_seconds,error)) return
        call sic_de(line,optfrom,iarg,in(ninput)%desc,.true.,error)
        if (error)  return
        if (in(ninput)%desc%type.le.0) then
          call sic_message(seve%e,rname,'/FROM SEXAGESIMAL argument must be a character string')
          error = .true.
          return
        endif
        !
      end select
      !
    enddo  ! iarg
  endif  ! Not NOW
  !
  nelem = one  ! Size of (vectorized) problem
  do i=1,ninput
    in(i)%nelem = desc_nelem(in(i)%desc)
    if (nelem.eq.1) then
      nelem = in(i)%nelem
    elseif (in(i)%nelem.eq.1) then
      ! Found a scalar variable: accepted for combination with array variables
      continue
    elseif (in(i)%nelem.ne.nelem) then
      call sic_message(seve%e,rname,'Input dimensions mismatch')
      error = .true.
      return
    endif
  enddo
  !
  !---------------------------------------------------------------------
  ! /TO
  !
  noutput = 0
  do iarg=1,sic_narg(optto),2
    call sic_ch(line,optto,iarg,varname,nc,.true.,error)
    if (error)  return
    call sic_ke(line,optto,iarg+1,argum,nc,.true.,error)
    if (error)  return
    call sic_ambigs(rname,argum,forma,iforma,formats,mformats,error)
    if (error)  return
    !
    noutput = noutput+1
    if (noutput.gt.size(out)) then
      call sic_message(seve%e,rname,'Too many output variables')
      error = .true.
      return
    endif
    out(noutput)%form = iforma
    !
    out(noutput)%isvar = varname.ne.'*'
    if (out(noutput)%isvar) then
      ! Store result in a variable
      call sic_de(line,optto,iarg,out(noutput)%desc,.true.,error)
      if (error)  return
      if (out(noutput)%desc%status.eq.scratch) then
        call sic_message(seve%e,rname,  &
          '/TO '//trim(forma)//': scratch variables are not allowed')
        error = .true.
        return
      endif
      if (out(noutput)%desc%readonly) then
        call sic_message(seve%e,rname,  &
          '/TO '//trim(forma)//': readonly variables can not be modified')
        error = .true.
        return
      endif
      !
      select case (iforma)
      case (fmt_year,fmt_month,fmt_day,fmt_hour,fmt_minute,fmt_gagdate)
        if (out(noutput)%desc%type.ne.fmt_i4 .and. out(noutput)%desc%type.ne.fmt_i8) then
          ! For symmetry with /FROM, see comments there.
          call sic_message(seve%e,rname,  &
            '/TO '//trim(forma)//' variable must be integer')
          error = .true.
          return
        endif
      case (fmt_iso,fmt_yyyymmdd,fmt_ddmmmyyyy,fmt_sexagesimal)
        if (out(noutput)%desc%type.le.0) then
          call sic_message(seve%e,rname,  &
            '/TO '//trim(forma)//' variable must be character string')
          error = .true.
          return
        endif
      end select
      !
    else
      ! Output is *, i.e. terminal, as many times as there are elements
      out(noutput)%desc%ndim = 1  ! For computing nelem below
      out(noutput)%desc%dims(1) = nelem
    endif
    !
    out(noutput)%nelem = desc_nelem(out(noutput)%desc)
    if (out(noutput)%nelem.ne.nelem) then
      call sic_message(seve%e,rname,'Input/output dimensions mismatch')
      error = .true.
      return
    endif
    !
  enddo
  !
contains
  !
  subroutine getnow(shift)
    !-------------------------------------------------------------------
    ! Create 6 scratch variables describing "now", more or less a shift
    ! on some fields
    !-------------------------------------------------------------------
    integer(kind=4), intent(in) :: shift(mfield)
    ! Global
    include 'gbl_memory.inc'
    ! Local
    integer(kind=4) :: values(6),i,i4
    real(kind=4) :: subsec
    real(kind=8) :: r8
    !
    call sic_c_idatetime(values,subsec)
    !
    ! Year, Month, Day, Hour, Minute are I*4
    do i=1,5
      in(i)%form = i
      i4 = values(i)+shift(i)
      call sic_incarnate(i4,in(i)%desc,error)
      if (error)  return
    enddo
    !
    ! Seconds is R*8
    in(6)%form = fmt_seconds
    r8 = values(6)+shift(6)+subsec
    call sic_incarnate(r8,in(6)%desc,error)
    if (error)  return
    !
    ninput = mfield
    got(:) = .true.
  end subroutine getnow
  !
  function setgot_error(igot,error)
    !-------------------------------------------------------------------
    ! Set got(igot) to .true., if not already .true.. Else return with
    ! error flag
    !-------------------------------------------------------------------
    logical :: setgot_error
    integer(kind=4), intent(in)    :: igot
    logical,         intent(inout) :: error
    if (got(igot)) then
      call sic_message(seve%e,rname,trim(formats(igot))//' is specified twice')
      error = .true.
    endif
    got(igot) = .true.
    setgot_error = error
  end function setgot_error
  !
  subroutine sic_prevnexti4(iarg,ifield,desc,error)
    !-------------------------------------------------------------------
    ! Decode PREVIOUS, NEXT, or integer value
    !-------------------------------------------------------------------
    integer(kind=4),        intent(in)    :: iarg    ! Position on command line
    integer(kind=4),        intent(in)    :: ifield  ! 1 year, 2 month, ...
    type(sic_descriptor_t), intent(out)   :: desc    !
    logical,                intent(inout) :: error   ! Logical error flag
    ! Local
    character(len=8), parameter :: prevnext(2) = (/ 'PREVIOUS','NEXT    ' /)
    integer(kind=4) :: ikey,nc
    character(len=16) :: argum
    character(len=8) :: key
    integer(kind=4) :: shift(mfield)
    !
    call sic_ke(line,optfrom,iarg,argum,nc,.true.,error)
    if (error)  return
    call sic_ambigs_sub(rname,argum,key,ikey,prevnext,2,error)
    if (error)  return
    !
    if (ikey.eq.0) then
      call sic_de(line,optfrom,iarg,desc,.true.,error)
      if (error)  return
      if (in(ninput)%desc%type.ne.fmt_i4 .and. in(ninput)%desc%type.ne.fmt_i8) then
        ! What would be the meaning of /FROM 2015.5 YEAR 6 MONTH ?
        ! + Beware of implicit rounding if we accept floats
        call sic_message(seve%e,rname,'/FROM '//trim(formats(ifield))//' argument must be integer')
        error = .true.
        return
      endif
    elseif (ikey.eq.1) then  ! PREVIOUS
      shift(:) = 0
      shift(ifield) = -1
      call getnow(shift)
    elseif (ikey.eq.2) then  ! NEXT
      shift(:) = 0
      shift(ifield) = +1
      call getnow(shift)
    endif
  end subroutine sic_prevnexti4
  !
end subroutine sic_datetime_parse
!
subroutine sic_datetime_do(in,ninput,out,noutput,nelem,error)
  use gbl_format
  use phys_const
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_datetime_do
  use sic_types
  use datetime_params
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(datetime_spec_t),     intent(in)    :: in(:)
  integer(kind=4),           intent(in)    :: ninput
  type(datetime_spec_t),     intent(in)    :: out(:)
  integer(kind=4),           intent(in)    :: noutput
  integer(kind=size_length), intent(in)    :: nelem
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DATETIME'
  character(len=80) :: strval
  integer(kind=4) :: ier,i,gagdate
  integer(kind=size_length) :: ielem,ival
  integer(kind=4) :: year,month,day,hour,minute
  real(kind=8) :: seconds,mjd,ut,r8
  character(len=message_length) :: mess
  !
  do ielem=1,nelem
    !
    ! Default. These defaults are important, e.g.
    !  /FROM 2016 YEAR         is understood as 2016-01-01 00:00:00.000
    !  /FROM 2016 YEAR 2 MONTH is understood as 2016-02-01 00:00:00.000
    !  /FROM 2016 YEAR 100 DAY is understood as 2016-04-09 00:00:00.000 (100th day of year)
    year = 1970
    month = 1
    day = 1
    hour = 0
    minute = 0
    seconds = 0.d0
    !
    ! /FROM
    !
    do i=1,ninput
      if (in(i)%nelem.eq.1) then
        ival = 1
      else
        ival = ielem
      endif
      !
      select case (in(i)%form)
      case (fmt_year)
        call sic_descriptor_getval(in(i)%desc,ival,year,error)
        if (error)  return
        !
      case (fmt_month)
        call sic_descriptor_getval(in(i)%desc,ival,month,error)
        if (error)  return
        !
      case (fmt_day)
        call sic_descriptor_getval(in(i)%desc,ival,day,error)
        if (error)  return
        !
      case (fmt_hour)
        call sic_descriptor_getval(in(i)%desc,ival,hour,error)
        if (error)  return
        !
      case (fmt_minute)
        call sic_descriptor_getval(in(i)%desc,ival,minute,error)
        if (error)  return
        !
      case (fmt_seconds)
        call sic_descriptor_getval(in(i)%desc,ival,seconds,error)
        if (error)  return
        !
      case (fmt_julian)
        call sic_descriptor_getval(in(i)%desc,ival,mjd,error)
        if (error)  return
        mjd = mjd - mjdzero_in_jd  ! From JD to MJD
        call gag_mjd2gregorian(mjd,year,month,day,error)
        if (error)  return
        call deg2dms((mjd-floor(mjd))*24.d0,hour,minute,seconds)
        !
      case (fmt_mjd)
        call sic_descriptor_getval(in(i)%desc,ival,mjd,error)
        if (error)  return
        call gag_mjd2gregorian(mjd,year,month,day,error)
        if (error)  return
        call deg2dms((mjd-floor(mjd))*24.d0,hour,minute,seconds)
        !
      case (fmt_iso)
        call sic_descriptor_getval(in(i)%desc,ival,strval,error)
        if (error)  return
        read(strval( 1: 4),'(i4)',iostat=ier)  year
        if (ier.ne.0) goto 100
        read(strval( 6: 7),'(i2)',iostat=ier)  month
        if (ier.ne.0) goto 100
        read(strval( 9:10),'(i2)',iostat=ier)  day
        if (ier.ne.0) goto 100
        read(strval(12:13),'(i2)',iostat=ier)  hour
        if (ier.ne.0) goto 100
        read(strval(15:16),'(i2)',iostat=ier)  minute
        if (ier.ne.0) goto 100
        read(strval(18:23),*,     iostat=ier)  seconds
        if (ier.ne.0) goto 100
        !
      case (fmt_gagdate)
        call sic_descriptor_getval(in(i)%desc,ival,gagdate,error)
        if (error)  return
        call gag_jdat(gagdate,day,month,year)
        !
      case (fmt_yyyymmdd)
        call sic_descriptor_getval(in(i)%desc,ival,strval,error)
        if (error)  return
        read(strval(1:4),'(i4)',iostat=ier)  year
        if (ier.ne.0) goto 100
        read(strval(5:6),'(i2)',iostat=ier)  month
        if (ier.ne.0) goto 100
        read(strval(7:8),'(i2)',iostat=ier)  day
        if (ier.ne.0) goto 100
        !
      case (fmt_ddmmmyyyy)
        call sic_descriptor_getval(in(i)%desc,ival,strval,error)
        if (error)  return
        call gag_fromdate(strval,gagdate,error)
        if (error) return
        call gag_jdat(gagdate,day,month,year)
        !
      case (fmt_radian)
        call sic_descriptor_getval(in(i)%desc,ival,r8,error)
        if (error)  return
        call deg2dms(r8*12.d0/pi,hour,minute,seconds)
        !
      case (fmt_sexagesimal)
        call sic_descriptor_getval(in(i)%desc,ival,strval,error)
        if (error)  return
        call sic_sexa(strval,len_trim(strval),r8,error)
        if (error) then
          call sic_message(seve%e,rname,  &
            'Invalid sexagesimal string "'//trim(strval)//'"')
          return
        endif
        call deg2dms(r8,hour,minute,seconds)
        !
      end select
    enddo  ! ninput
    !
    ! Merge year+month+day+hour+minute+seconds
    ! Because these quantities may be beyond their usual ranges, we add them
    ! crudely and go back:
    call gag_gregorian2mjd(year,month,1,mjd,ier)  ! Add year + month only (1st day)
    if (ier.ne.0) then
      call sic_message(seve%e,rname,'Error in year and/or month')
      error = .true.
      return
    endif
    mjd = mjd + day-1 + hour/24.d0 + minute/1440.d0 + seconds/86400.d0
    !
    ! /TO
    !
    if (.not.all(out(1:noutput)%isvar))  mess = ""
    do i=1,noutput
      !
      select case (out(i)%form)
      case (fmt_year)
        call gag_mjd2gregorian(mjd,year,month,day,error)
        if (error)  return
        call sic_datetime_setvalue(out(i),ielem,year,mess,error)
        if (error)  return
        !
      case (fmt_month)
        call gag_mjd2gregorian(mjd,year,month,day,error)
        if (error)  return
        call sic_datetime_setvalue(out(i),ielem,month,mess,error)
        if (error)  return
        !
      case (fmt_day)
        call gag_mjd2gregorian(mjd,year,month,day,error)
        if (error)  return
        call sic_datetime_setvalue(out(i),ielem,day,mess,error)
        if (error)  return
        !
      case (fmt_hour)
        call deg2dms((mjd-floor(mjd))*24.d0,hour,minute,seconds)
        call sic_datetime_setvalue(out(i),ielem,hour,mess,error)
        if (error)  return
        !
      case (fmt_minute)
        call deg2dms((mjd-floor(mjd))*24.d0,hour,minute,seconds)
        call sic_datetime_setvalue(out(i),ielem,minute,mess,error)
        if (error)  return
        !
      case (fmt_seconds)
        call deg2dms((mjd-floor(mjd))*24.d0,hour,minute,seconds)
        call sic_datetime_setvalue(out(i),ielem,seconds,mess,error)
        if (error)  return
        !
      case (fmt_mjd)
        call sic_datetime_setvalue(out(i),ielem,mjd,mess,error)
        if (error)  return
        !
      case (fmt_julian)
        call sic_datetime_setvalue(out(i),ielem,mjdzero_in_jd+mjd,mess,error)
        if (error)  return
        !
      case (fmt_iso)
        call gag_mjd2isodate(mjd,strval,error)
        if (error)  return
        call sic_datetime_setvalue(out(i),ielem,strval,mess,error)
        if (error)  return
        !
      case (fmt_gagdate)
        call gag_mjd2gagut(mjd,gagdate,ut,error)
        if (error)  return
        call sic_datetime_setvalue(out(i),ielem,gagdate,mess,error)
        if (error)  return
        !
      case (fmt_yyyymmdd)
        call gag_mjd2gagut(mjd,gagdate,ut,error)
        if (error)  return
        call gag_toyyyymmdd(gagdate,strval,error)
        if (error)  return
        call sic_datetime_setvalue(out(i),ielem,strval,mess,error)
        if (error)  return
        !
      case (fmt_ddmmmyyyy)
        call gag_mjd2gagut(mjd,gagdate,ut,error)
        if (error)  return
        call gag_todate(gagdate,strval,error)
        if (error)  return
        call sic_datetime_setvalue(out(i),ielem,strval,mess,error)
        if (error)  return
        !
      case (fmt_radian)
        call gag_mjd2gagut(mjd,gagdate,ut,error)
        if (error)  return
        call sic_datetime_setvalue(out(i),ielem,ut,mess,error)
        if (error)  return
        !
      case (fmt_sexagesimal)
        call gag_mjd2gagut(mjd,gagdate,ut,error)
        if (error)  return
        call rad2sexa(ut,24,strval,left=.true.)
        call sic_datetime_setvalue(out(i),ielem,strval,mess,error)
        if (error)  return
        !
      end select
    enddo  ! noutput
    !
    if (.not.all(out(1:noutput)%isvar))  call sic_message(seve%r,rname,mess)
    !
  enddo  ! nelem
  return
  !
  ! Read error
100 continue
  call sic_message(seve%e,rname,'Read error for value "'//trim(strval)//'"')
  error = .true.
  !
end subroutine sic_datetime_do
!
subroutine sic_datetime_setvalue_i4(out,ielem,i4,obuf,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_datetime_setvalue_i4
  use sic_types
  !---------------------------------------------------------------------
  ! @ private-generic sic_datetime_setvalue
  !---------------------------------------------------------------------
  type(datetime_spec_t),     intent(in)    :: out
  integer(kind=size_length), intent(in)    :: ielem
  integer(kind=4),           intent(in)    :: i4
  character(len=*),          intent(inout) :: obuf
  logical,                   intent(inout) :: error
  ! Local
  integer(kind=4) :: nc
  !
  if (out%isvar) then
    ! Write in out%desc
    call sic_descriptor_fill(out%desc,ielem,i4,error)
  else
    ! Write in obuf
    nc = len_trim(obuf)
    write(obuf(nc+2:),'(I0)') i4
  endif
end subroutine sic_datetime_setvalue_i4
!
subroutine sic_datetime_setvalue_r8(out,ielem,r8,obuf,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_datetime_setvalue_r8
  use sic_types
  !---------------------------------------------------------------------
  ! @ private-generic sic_datetime_setvalue
  !---------------------------------------------------------------------
  type(datetime_spec_t),     intent(in)    :: out
  integer(kind=size_length), intent(in)    :: ielem
  real(kind=8),              intent(in)    :: r8
  character(len=*),          intent(inout) :: obuf
  logical,                   intent(inout) :: error
  ! Local
  integer(kind=4) :: nc
  !
  if (out%isvar) then
    ! Write in out%desc
    call sic_descriptor_fill(out%desc,ielem,r8,error)
  else
    ! Write in obuf
    nc = len_trim(obuf)
    write(obuf(nc+2:),'(1PG25.16)') r8
  endif
end subroutine sic_datetime_setvalue_r8
!
subroutine sic_datetime_setvalue_ch(out,ielem,ch,obuf,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_datetime_setvalue_ch
  use sic_types
  !---------------------------------------------------------------------
  ! @ private-generic sic_datetime_setvalue
  !---------------------------------------------------------------------
  type(datetime_spec_t),     intent(in)    :: out
  integer(kind=size_length), intent(in)    :: ielem
  character(len=*),          intent(in)    :: ch
  character(len=*),          intent(inout) :: obuf
  logical,                   intent(inout) :: error
  ! Local
  integer(kind=4) :: nc
  !
  if (out%isvar) then
    ! Write in out%desc
    call sic_descriptor_fill(out%desc,ielem,ch,error)
  else
    ! Write in obuf
    nc = len_trim(obuf)
    write(obuf(nc+2:),'(A)') ch
  endif
end subroutine sic_datetime_setvalue_ch
!
subroutine sic_datetime_clean(in,ninput,out,noutput,error)
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Clean the temporaries created for command execution
  !---------------------------------------------------------------------
  type(datetime_spec_t), intent(inout) :: in(:)    !
  integer(kind=4),       intent(in)    :: ninput   ! Useful size of in(:)
  type(datetime_spec_t), intent(inout) :: out(:)   !
  integer(kind=4),       intent(in)    :: noutput  ! Useful size of out(:)
  logical,               intent(inout) :: error    !
  ! Local
  integer(kind=4) :: i
  !
  do i=1,ninput
    call sic_volatile(in(i)%desc)
  enddo
  !
  do i=1,noutput
    ! There can be scratch variable in case of user mistake, e.g. /TO 3.14 RADIAN
    call sic_volatile(out(i)%desc)
  enddo
  !
end subroutine sic_datetime_clean

module gio_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GIO interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use gio_interfaces_public
  use gio_interfaces_private
  !
end module gio_interfaces
!
module gio_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GIO dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use ginc_interfaces_public
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  use gmath_interfaces_public
  use gwcs_interfaces_public
  use gfits_interfaces_public
end module gio_dependencies_interfaces

*DECK DVECS
      SUBROUTINE DVECS (NCOMP, LNFC, YHP, WORK, IWORK, INHOMO, IFLAG)
C***BEGIN PROLOGUE  DVECS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBVSUP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SVECS-S, DVECS-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C  This subroutine is used for the special structure of COMPLEX*16
C  valued problems. DMGSBV is called upon to obtain LNFC vectors from an
C  original set of 2*LNFC independent vectors so that the resulting
C  LNFC vectors together with their imaginary product or mate vectors
C  form an independent set.
C
C***SEE ALSO  DBVSUP
C***ROUTINES CALLED  DMGSBV
C***COMMON BLOCKS    DML18J
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891009  Removed unreferenced statement label.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DVECS
C
      INTEGER ICOCO, IDP, IFLAG, INDPVT, INHOMO, INTEG, IWORK(*), K,
     1     KP, LNFC, LNFCC, MXNON, NCOMP, NDISK, NEQ, NEQIVP, NIC, NIV,
     2     NOPG, NPS, NTAPE, NTP, NUMORT, NXPTS
      DOUBLE PRECISION AE, DUM, RE, TOL, WORK(*), YHP(NCOMP,*)
      COMMON /DML18J/ AE,RE,TOL,NXPTS,NIC,NOPG,MXNON,NDISK,NTAPE,NEQ,
     1                INDPVT,INTEG,NPS,NTP,NEQIVP,NUMORT,LNFCC,
     2                ICOCO
C***FIRST EXECUTABLE STATEMENT  DVECS
         IF (LNFC .NE. 1) GO TO 20
            DO 10 K = 1, NCOMP
               YHP(K,LNFC+1) = YHP(K,LNFCC+1)
   10       CONTINUE
            IFLAG = 1
         GO TO 60
   20    CONTINUE
            NIV = LNFC
            LNFC = 2*LNFC
            LNFCC = 2*LNFCC
            KP = LNFC + 2 + LNFCC
            IDP = INDPVT
            INDPVT = 0
            CALL DMGSBV(NCOMP,LNFC,YHP,NCOMP,NIV,IFLAG,WORK(1),WORK(KP),
     1                  IWORK(1),INHOMO,YHP(1,LNFC+1),WORK(LNFC+2),DUM)
            LNFC = LNFC/2
            LNFCC = LNFCC/2
            INDPVT = IDP
            IF (IFLAG .NE. 0 .OR. NIV .NE. LNFC) GO TO 40
               DO 30 K = 1, NCOMP
                  YHP(K,LNFC+1) = YHP(K,LNFCC+1)
   30          CONTINUE
               IFLAG = 1
            GO TO 50
   40       CONTINUE
               IFLAG = 99
   50       CONTINUE
   60    CONTINUE
      CONTINUE
      RETURN
      END
*DECK DVNRMS
      DOUBLE PRECISION FUNCTION DVNRMS (N, V, W)
C***BEGIN PROLOGUE  DVNRMS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DDEBDF
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (VNWRMS-S, DVNRMS-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   DVNRMS computes a weighted root-mean-square vector norm for the
C   integrator package DDEBDF.
C
C***SEE ALSO  DDEBDF
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   820301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  DVNRMS
      INTEGER I, N
      DOUBLE PRECISION SUM, V, W
      DIMENSION V(*),W(*)
C***FIRST EXECUTABLE STATEMENT  DVNRMS
      SUM = 0.0D0
      DO 10 I = 1, N
         SUM = SUM + (V(I)/W(I))**2
   10 CONTINUE
      DVNRMS = SQRT(SUM/N)
      RETURN
C     ----------------------- END OF FUNCTION DVNRMS
C     ------------------------
      END
*DECK DVOUT
      SUBROUTINE DVOUT (N, DX, IFMT, IDIGIT)
C***BEGIN PROLOGUE  DVOUT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DSPLP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SVOUT-S, DVOUT-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION
C
C     DOUBLE PRECISION VECTOR OUTPUT ROUTINE.
C
C  INPUT..
C
C  N,DX(*) PRINT THE DOUBLE PRECISION ARRAY DX(I),I=1,...,N, ON
C          OUTPUT UNIT LOUT. THE HEADING IN THE FORTRAN FORMAT
C          STATEMENT IFMT(*), DESCRIBED BELOW, IS PRINTED AS A FIRST
C          STEP. THE COMPONENTS DX(I) ARE INDEXED, ON OUTPUT,
C          IN A PLEASANT FORMAT.
C  IFMT(*) A FORTRAN FORMAT STATEMENT. THIS IS PRINTED ON OUTPUT
C          UNIT LOUT WITH THE VARIABLE FORMAT FORTRAN STATEMENT
C                WRITE(LOUT,IFMT)
C  IDIGIT  PRINT AT LEAST ABS(IDIGIT) DECIMAL DIGITS PER NUMBER.
C          THE SUBPROGRAM WILL CHOOSE THAT INTEGER 4,6,10 OR 14
C          WHICH WILL PRINT AT LEAST ABS(IDIGIT) NUMBER OF
C          PLACES.  IF IDIGIT.LT.0, 72 PRINTING COLUMNS ARE UTILIZED
C          TO WRITE EACH LINE OF OUTPUT OF THE ARRAY DX(*). (THIS
C          CAN BE USED ON MOST TIME-SHARING TERMINALS). IF
C          IDIGIT.GE.0, 133 PRINTING COLUMNS ARE UTILIZED. (THIS CAN
C          BE USED ON MOST LINE PRINTERS).
C
C  EXAMPLE..
C
C  PRINT AN ARRAY CALLED (COSTS OF PURCHASES) OF LENGTH 100 SHOWING
C  6 DECIMAL DIGITS PER NUMBER. THE USER IS RUNNING ON A TIME-SHARING
C  SYSTEM WITH A 72 COLUMN OUTPUT DEVICE.
C
C     DOUBLE PRECISION COSTS(100)
C     N = 100
C     IDIGIT = -6
C     CALL DVOUT(N,COSTS,'(''1COSTS OF PURCHASES'')',IDIGIT)
C
C***SEE ALSO  DSPLP
C***ROUTINES CALLED  I1MACH
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891107  Added comma after 1P edit descriptor in FORMAT
C           statements.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910403  Updated AUTHOR section.  (WRB)
C***END PROLOGUE  DVOUT
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION DX(*)
      CHARACTER IFMT*(*)
C***FIRST EXECUTABLE STATEMENT  DVOUT
      LOUT=I1MACH(2)
      WRITE(LOUT,IFMT)
      IF(N.LE.0) RETURN
      NDIGIT = IDIGIT
      IF(IDIGIT.EQ.0) NDIGIT = 6
      IF(IDIGIT.GE.0) GO TO 80
C
      NDIGIT = -IDIGIT
      IF(NDIGIT.GT.6) GO TO 20
C
      DO 10 K1=1,N,4
      K2 = MIN(N,K1+3)
      WRITE(LOUT,1000) K1,K2,(DX(I),I = K1, K2)
   10 CONTINUE
      RETURN
C
   20 CONTINUE
      IF(NDIGIT.GT.14) GO TO 40
C
      DO 30 K1=1,N,2
      K2 = MIN(N,K1+1)
      WRITE(LOUT,1001) K1,K2,(DX(I),I = K1, K2)
   30 CONTINUE
      RETURN
C
   40 CONTINUE
      IF(NDIGIT.GT.20) GO TO 60
C
      DO 50 K1=1,N,2
      K2=MIN(N,K1+1)
      WRITE(LOUT,1002) K1,K2,(DX(I),I = K1, K2)
   50 CONTINUE
      RETURN
C
   60 CONTINUE
      DO 70 K1=1,N
      K2 = K1
      WRITE(LOUT,1003) K1,K2,(DX(I),I = K1, K2)
   70 CONTINUE
      RETURN
C
   80 CONTINUE
      IF(NDIGIT.GT.6) GO TO 100
C
      DO 90 K1=1,N,8
      K2 = MIN(N,K1+7)
      WRITE(LOUT,1000) K1,K2,(DX(I),I = K1, K2)
   90 CONTINUE
      RETURN
C
  100 CONTINUE
      IF(NDIGIT.GT.14) GO TO 120
C
      DO 110 K1=1,N,5
      K2 = MIN(N,K1+4)
      WRITE(LOUT,1001) K1,K2,(DX(I),I = K1, K2)
  110 CONTINUE
      RETURN
C
  120 CONTINUE
      IF(NDIGIT.GT.20) GO TO 140
C
      DO 130 K1=1,N,4
      K2 = MIN(N,K1+3)
      WRITE(LOUT,1002) K1,K2,(DX(I),I = K1, K2)
  130 CONTINUE
      RETURN
C
  140 CONTINUE
      DO 150 K1=1,N,3
      K2 = MIN(N,K1+2)
      WRITE(LOUT,1003) K1,K2,(DX(I),I = K1, K2)
  150 CONTINUE
      RETURN
 1000 FORMAT(1X,I4,' - ',I4,1X,1P,8D14.5)
 1001 FORMAT(1X,I4,' - ',I4,1X,1P,5D22.13)
 1002 FORMAT(1X,I4,' - ',I4,1X,1P,4D28.19)
 1003 FORMAT(1X,I4,' - ',I4,1X,1P,3D36.27)
      END

subroutine gtv_points(n,x,y,error)
  use gbl_message
  use gtv_interfaces, except_this=>gtv_points
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ public
  !  Store a list of dotted points in the GTV tree. For larger points,
  ! polylines (one per point) must be used.
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n      ! Number of points
  real(kind=4),    intent(in)    :: x(n)   !
  real(kind=4),    intent(in)    :: y(n)   !
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_POINT'
  integer(kind=4) :: ier
  !
  if (.not.awake .or. error_condition) return
  if (n.le.0)  return  ! No data
  !
  if (.not.associated(co_segment)) then
    call gtv_message(seve%e,rname,'Programming error: no segment opened')
    error = .true.
    return
  endif
  !
  ! First flush POLYL%X and POLYL%Y buffers if they are not empty
  call gtx_frxry(error)
  if (error) return
  !
  ! Do we need to save the current PENLUT in the metacode before starting
  ! to write the points?
  if (lut_static) then
    if (.not.associated(co_segment%head%lut)) then
      ! We have to save the current global PENLUT in the metacode
      call gt_penlut_segdata(error)  ! This sets co_segment%head%lut
      if (error)  return
    endif
  endif
  !
  ! Update minmax
  co_segment%head%gen%minmax(1) = min(minval(x),co_segment%head%gen%minmax(1))  ! xmin
  co_segment%head%gen%minmax(2) = max(maxval(x),co_segment%head%gen%minmax(2))  ! xmax
  co_segment%head%gen%minmax(3) = min(minval(y),co_segment%head%gen%minmax(3))  ! ymin
  co_segment%head%gen%minmax(4) = max(maxval(y),co_segment%head%gen%minmax(4))  ! ymax
  !
  call gtv_open_segments_for_writing_from_main()
  !
  if (.not.associated(co_segment_data)) then
    allocate(co_segment%data,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (1)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment%data
  else
    allocate(co_segment_data%nextdata,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (2)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment_data%nextdata
  endif
  co_segment_data%nextdata => null()
  !
  ! Store the data
  allocate(co_segment_data%poly%x(n),co_segment_data%poly%y(n),stat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Internal error: allocation failure (3)')
    error = .true.
    goto 10
  endif
  co_segment_data%kind = seg_points
  co_segment_data%poly%n = n
  co_segment_data%poly%x = x
  co_segment_data%poly%y = y
  co_segment_data%poly%penlut => co_segment%head%lut  ! Which can be null()
  !
10 continue
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gtv_points
!
subroutine gti_points(out,poly)
  use gtv_types
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>gti_points
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !  Draw a list of dot points
  !---------------------------------------------------------------------
  type(gt_display),  intent(inout) :: out   ! Input gt_display
  type(gt_polyline), intent(in)    :: poly  !
  ! Local
  integer(kind=4) :: i
  !
  if (.not.awake .or. error_condition) return
  ! call gtx_pen(out,ipenx_i)
  !
  ! No device selected
  if (out%dev%protocol.eq.p_null)  return
  !
  if (associated(poly%penlut)) then
    ! LUT STATIC:
    ! Load the appropriate pen into the device
    call gtx_pen(out,out%icolou,poly%penlut)
  endif
  !
  select case (out%dev%protocol)
  case(p_x)
    do i = 1,poly%n
      call gtx_plot(out,poly%x(i),poly%y(i),3)
    enddo
    !
  case(p_postscript)
    call ps_points(poly%n,poly%x,poly%y)
    !
  case(p_svg)
    call svg_points(out,poly%n,poly%x,poly%y)
    !
  case(p_png)
    call png_points(out,poly%n,poly%x,poly%y)
    !
  end select
  !
end subroutine gti_points

*DECK SEPELI
      SUBROUTINE SEPELI (INTL, IORDER, A, B, M, MBDCND, BDA, ALPHA, BDB,
     +   BETA, C, D, N, NBDCND, BDC, GAMA, BDD, XNU, COFX, COFY, GRHS,
     +   USOL, IDMN, W, PERTRB, IERROR)
C***BEGIN PROLOGUE  SEPELI
C***PURPOSE  Discretize and solve a second and, optionally, a fourth
C            order finite difference approximation on a uniform grid to
C            the general separable elliptic partial differential
C            equation on a rectangle with any combination of periodic or
C            mixed boundary conditions.
C***LIBRARY   SLATEC (FISHPACK)
C***CATEGORY  I2B1A2
C***TYPE      SINGLE PRECISION (SEPELI-S)
C***KEYWORDS  ELLIPTIC, FISHPACK, HELMHOLTZ, PDE, SEPARABLE
C***AUTHOR  Adams, J., (NCAR)
C           Swarztrauber, P. N., (NCAR)
C           Sweet, R., (NCAR)
C***DESCRIPTION
C
C Dimension of           BDA(N+1), BDB(N+1), BDC(M+1), BDD(M+1),
C Arguments              USOL(IDMN,N+1), GRHS(IDMN,N+1),
C                        W (see argument list)
C
C Latest Revision        March 1977
C
C Purpose                SEPELI solves for either the second-order
C                        finite difference approximation or a
C                        fourth-order approximation to a separable
C                        elliptic equation.
C
C                                    2    2
C                             AF(X)*d U/dX + BF(X)*dU/dX  + CF(X)*U +
C                                    2    2
C                             DF(Y)*d U/dY  + EF(Y)*dU/dY + FF(Y)*U
C
C                             = G(X,Y)
C
C                        on a rectangle (X greater than or equal to A
C                        and less than or equal to B; Y greater than
C                        or equal to C and less than or equal to D).
C                        Any combination of periodic or mixed boundary
C                        conditions is allowed.
C
C Purpose                The possible boundary conditions are:
C                        in the X-direction:
C                         (0) Periodic, U(X+B-A,Y)=U(X,Y) for all Y,X
C                         (1) U(A,Y), U(B,Y) are specified for all Y
C                         (2) U(A,Y), dU(B,Y)/dX+BETA*U(B,Y) are
C                             specified for all Y
C                         (3) dU(A,Y)/dX+ALPHA*U(A,Y),dU(B,Y)/dX+
C                             BETA*U(B,Y) are specified for all Y
C                         (4) dU(A,Y)/dX+ALPHA*U(A,Y),U(B,Y) are
C                             specified for all Y
C
C                        in the Y-direction:
C                         (0) Periodic, U(X,Y+D-C)=U(X,Y) for all X,Y
C                         (1) U(X,C),U(X,D) are specified for all X
C                         (2) U(X,C),dU(X,D)/dY+XNU*U(X,D) are specified
C                             for all X
C                         (3) dU(X,C)/dY+GAMA*U(X,C),dU(X,D)/dY+
C                             XNU*U(X,D) are specified for all X
C                         (4) dU(X,C)/dY+GAMA*U(X,C),U(X,D) are
C                             specified for all X
C
C Arguments
C
C On Input               INTL
C                          = 0 On initial entry to SEPELI or if any of
C                              the arguments C, D, N, NBDCND, COFY are
C                              changed from a previous call
C                          = 1 If C, D, N, NBDCND, COFY are unchanged
C                              from the previous call.
C
C                        IORDER
C                          = 2 If a second-order approximation is sought
C                          = 4 If a fourth-order approximation is sought
C
C                        A,B
C                          The range of the X-independent variable;
C                          i.e., X is greater than or equal to A and
C                          less than or equal to B.  A must be less than
C                          B.
C
C                        M
C                          The number of panels into which the interval
C                          [A,B] is subdivided.  Hence, there will be
C                          M+1 grid points in the X-direction given by
C                          XI=A+(I-1)*DLX for I=1,2,...,M+1 where
C                          DLX=(B-A)/M is the panel width.  M must be
C                          less than IDMN and greater than 5.
C
C                        MBDCND
C                          Indicates the type of boundary condition at
C                          X=A and X=B
C                          = 0 If the solution is periodic in X; i.e.,
C                              U(X+B-A,Y)=U(X,Y) for all Y,X
C                          = 1 If the solution is specified at X=A and
C                              X=B; i.e., U(A,Y) and U(B,Y) are
C                              specified for all Y
C                          = 2 If the solution is specified at X=A and
C                              the boundary condition is mixed at X=B;
C                              i.e., U(A,Y) and dU(B,Y)/dX+BETA*U(B,Y)
C                              are specified for all Y
C                          = 3 If the boundary conditions at X=A and X=B
C                              are mixed; i.e., dU(A,Y)/dX+ALPHA*U(A,Y)
C                              and dU(B,Y)/dX+BETA*U(B,Y) are specified
C                              for all Y
C                          = 4 If the boundary condition at X=A is mixed
C                              and the solution is specified at X=B;
C                              i.e., dU(A,Y)/dX+ALPHA*U(A,Y) and U(B,Y)
C                              are specified for all Y
C
C                        BDA
C                          A one-dimensional array of length N+1 that
C                          specifies the values of dU(A,Y)/dX+
C                          ALPHA*U(A,Y) at X=A, when MBDCND=3 or 4.
C                               BDA(J) = dU(A,YJ)/dX+ALPHA*U(A,YJ);
C                               J=1,2,...,N+1
C                          when MBDCND has any other value, BDA is a
C                          dummy parameter.
C
C On Input               ALPHA
C                          The scalar multiplying the solution in case
C                          of a mixed boundary condition at X=A (see
C                          argument BDA).  If MBDCND = 3,4 then ALPHA is
C                          a dummy parameter.
C
C                        BDB
C                          A one-dimensional array of length N+1 that
C                          specifies the values of dU(B,Y)/dX+
C                          BETA*U(B,Y) at X=B.  When MBDCND=2 or 3
C                               BDB(J) = dU(B,YJ)/dX+BETA*U(B,YJ);
C                               J=1,2,...,N+1
C                          When MBDCND has any other value, BDB is a
C                          dummy parameter.
C
C                        BETA
C                          The scalar multiplying the solution in case
C                          of a mixed boundary condition at X=B (see
C                          argument BDB).  If MBDCND=2,3 then BETA is a
C                          dummy parameter.
C
C                        C,D
C                          The range of the Y-independent variable;
C                          i.e., Y is greater than or equal to C and
C                          less than or equal to D.  C must be less than
C                          D.
C
C                        N
C                          The number of panels into which the interval
C                          [C,D] is subdivided.  Hence, there will be
C                          N+1 grid points in the Y-direction given by
C                          YJ=C+(J-1)*DLY for J=1,2,...,N+1 where
C                          DLY=(D-C)/N is the panel width.  In addition,
C                          N must be greater than 4.
C
C                        NBDCND
C                          Indicates the types of boundary conditions at
C                          Y=C and Y=D
C                          = 0 If the solution is periodic in Y; i.e.,
C                              U(X,Y+D-C)=U(X,Y) for all X,Y
C                          = 1 If the solution is specified at Y=C and
C                              Y = D, i.e., U(X,C) and U(X,D) are
C                              specified for all X
C                          = 2 If the solution is specified at Y=C and
C                              the boundary condition is mixed at Y=D;
C                              i.e., U(X,C) and dU(X,D)/dY+XNU*U(X,D)
C                              are specified for all X
C                          = 3 If the boundary conditions are mixed at
C                              Y=C and Y=D; i.e., dU(X,D)/dY+GAMA*U(X,C)
C                              and dU(X,D)/dY+XNU*U(X,D) are specified
C                              for all X
C                          = 4 If the boundary condition is mixed at Y=C
C                              and the solution is specified at Y=D;
C                              i.e. dU(X,C)/dY+GAMA*U(X,C) and U(X,D)
C                              are specified for all X
C
C                        BDC
C                          A one-dimensional array of length M+1 that
C                          specifies the value of dU(X,C)/dY+GAMA*U(X,C)
C                          at Y=C.  When NBDCND=3 or 4
C                             BDC(I) = dU(XI,C)/dY + GAMA*U(XI,C);
C                             I=1,2,...,M+1.
C                          When NBDCND has any other value, BDC is a
C                          dummy parameter.
C
C                        GAMA
C                          The scalar multiplying the solution in case
C                          of a mixed boundary condition at Y=C (see
C                          argument BDC).  If NBDCND=3,4 then GAMA is a
C                          dummy parameter.
C
C                        BDD
C                          A one-dimensional array of length M+1 that
C                          specifies the value of dU(X,D)/dY +
C                          XNU*U(X,D) at Y=C.  When NBDCND=2 or 3
C                            BDD(I) = dU(XI,D)/dY + XNU*U(XI,D);
C                            I=1,2,...,M+1.
C                          When NBDCND has any other value, BDD is a
C                          dummy parameter.
C
C                        XNU
C                          The scalar multiplying the solution in case
C                          of a mixed boundary condition at Y=D (see
C                          argument BDD).  If NBDCND=2 or 3 then XNU is
C                          a dummy parameter.
C
C                        COFX
C                          A user-supplied subprogram with
C                          parameters X, AFUN, BFUN, CFUN which
C                          returns the values of the X-dependent
C                          coefficients AF(X), BF(X), CF(X) in
C                          the elliptic equation at X.
C
C                        COFY
C                          A user-supplied subprogram with
C                          parameters Y, DFUN, EFUN, FFUN which
C                          returns the values of the Y-dependent
C                          coefficients DF(Y), EF(Y), FF(Y) in
C                          the elliptic equation at Y.
C
C                        NOTE:  COFX and COFY must be declared external
C                        in the calling routine.  The values returned in
C                        AFUN and DFUN must satisfy AFUN*DFUN greater
C                        than 0 for A less than X less than B,
C                        C less than Y less than D (see IERROR=10).
C                        The coefficients provided may lead to a matrix
C                        equation which is not diagonally dominant in
C                        which case solution may fail (see IERROR=4).
C
C                        GRHS
C                          A two-dimensional array that specifies the
C                          values of the right-hand side of the elliptic
C                          equation; i.e., GRHS(I,J)=G(XI,YI), for
C                          I=2,...,M; J=2,...,N.  At the boundaries,
C                          GRHS is defined by
C
C                          MBDCND   GRHS(1,J)   GRHS(M+1,J)
C                          ------   ---------   -----------
C                            0      G(A,YJ)     G(B,YJ)
C                            1         *           *
C                            2         *        G(B,YJ)  J=1,2,...,N+1
C                            3      G(A,YJ)     G(B,YJ)
C                            4      G(A,YJ)        *
C
C                          NBDCND   GRHS(I,1)   GRHS(I,N+1)
C                          ------   ---------   -----------
C                            0      G(XI,C)     G(XI,D)
C                            1         *           *
C                            2         *        G(XI,D)  I=1,2,...,M+1
C                            3      G(XI,C)     G(XI,D)
C                            4      G(XI,C)        *
C
C                          where * means these quantities are not used.
C                          GRHS should be dimensioned IDMN by at least
C                          N+1 in the calling routine.
C
C                        USOL
C                          A two-dimensional array that specifies the
C                          values of the solution along the boundaries.
C                          At the boundaries, USOL is defined by
C
C                          MBDCND   USOL(1,J)   USOL(M+1,J)
C                          ------   ---------   -----------
C                            0         *           *
C                            1      U(A,YJ)     U(B,YJ)
C                            2      U(A,YJ)        *     J=1,2,...,N+1
C                            3         *           *
C                            4         *        U(B,YJ)
C
C                          NBDCND   USOL(I,1)   USOL(I,N+1)
C                          ------   ---------   -----------
C                            0         *           *
C                            1      U(XI,C)     U(XI,D)
C                            2      U(XI,C)        *     I=1,2,...,M+1
C                            3         *           *
C                            4         *        U(XI,D)
C
C                          where * means the quantities are not used in
C                          the solution.
C
C                          If IORDER=2, the user may equivalence GRHS
C                          and USOL to save space.  Note that in this
C                          case the tables specifying the boundaries of
C                          the GRHS and USOL arrays determine the
C                          boundaries uniquely except at the corners.
C                          If the tables call for both G(X,Y) and
C                          U(X,Y) at a corner then the solution must be
C                          chosen.  For example, if MBDCND=2 and
C                          NBDCND=4, then U(A,C), U(A,D), U(B,D) must be
C                          chosen at the corners in addition to G(B,C).
C
C                          If IORDER=4, then the two arrays, USOL and
C                          GRHS, must be distinct.
C
C                          USOL should be dimensioned IDMN by at least
C                          N+1 in the calling routine.
C
C                        IDMN
C                          The row (or first) dimension of the arrays
C                          GRHS and USOL as it appears in the program
C                          calling SEPELI.  This parameter is used to
C                          specify the variable dimension of GRHS and
C                          USOL.  IDMN must be at least 7 and greater
C                          than or equal to M+1.
C
C                        W
C                          A one-dimensional array that must be provided
C                          by the user for work space.  Let
C                          K=INT(log2(N+1))+1 and set  L=2**(K+1).
C                          then (K-2)*L+K+10*N+12*M+27 will suffice
C                          as a length of W.  THE actual length of W in
C                          the calling routine must be set in W(1) (see
C                          IERROR=11).
C
C On Output              USOL
C                          Contains the approximate solution to the
C                          elliptic equation.  USOL(I,J) is the
C                          approximation to U(XI,YJ) for I=1,2...,M+1
C                          and J=1,2,...,N+1.  The approximation has
C                          error O(DLX**2+DLY**2) if called with
C                          IORDER=2 and O(DLX**4+DLY**4) if called with
C                          IORDER=4.
C
C                        W
C                          Contains intermediate values that must not be
C                          destroyed if SEPELI is called again with
C                          INTL=1.  In addition W(1) contains the exact
C                          minimal length (in floating point) required
C                          for the work space (see IERROR=11).
C
C                        PERTRB
C                          If a combination of periodic or derivative
C                          boundary conditions (i.e., ALPHA=BETA=0 if
C                          MBDCND=3; GAMA=XNU=0 if NBDCND=3) is
C                          specified and if the coefficients of U(X,Y)
C                          in the separable elliptic equation are zero
C                          (i.e., CF(X)=0 for X greater than or equal to
C                          A and less than or equal to B; FF(Y)=0 for
C                          Y greater than or equal to C and less than
C                          or equal to D) then a solution may not exist.
C                          PERTRB is a constant calculated and
C                          subtracted from the right-hand side of the
C                          matrix equations generated by SEPELI which
C                          insures that a solution exists.  SEPELI then
C                          computes this solution which is a weighted
C                          minimal least squares solution to the
C                          original problem.
C
C                        IERROR
C                          An error flag that indicates invalid input
C                          parameters or failure to find a solution
C                          = 0 No error
C                          = 1 If A greater than B or C greater than D
C                          = 2 If MBDCND less than 0 or MBDCND greater
C                              than 4
C                          = 3 If NBDCND less than 0 or NBDCND greater
C                              than 4
C                          = 4 If attempt to find a solution fails.
C                              (the linear system generated is not
C                              diagonally dominant.)
C                          = 5 If IDMN is too small (see discussion of
C                              IDMN)
C                          = 6 If M is too small or too large (see
C                              discussion of M)
C                          = 7 If N is too small (see discussion of N)
C                          = 8 If IORDER is not 2 or 4
C                          = 9 If INTL is not 0 or 1
C                          = 10 If AFUN*DFUN less than or equal to 0 for
C                               some interior mesh point (XI,YJ)
C                          = 11 If the work space length input in W(1)
C                               is less than the exact minimal work
C                               space length required output in W(1).
C
C                          NOTE (concerning IERROR=4):  for the
C                          coefficients input through COFX, COFY, the
C                          discretization may lead to a block
C                          tridiagonal linear system which is not
C                          diagonally dominant (for example, this
C                          happens if CFUN=0 and BFUN/(2.*DLX) greater
C                          than AFUN/DLX**2).  In this case solution may
C                          fail.  This cannot happen in the limit as
C                          DLX, DLY approach zero.  Hence, the condition
C                          may be remedied by taking larger values for M
C                          or N.
C
C Entry Points           SEPELI, SPELIP, CHKPRM, CHKSNG, ORTHOG, MINSOL,
C                        TRISP, DEFER, DX, DY, BLKTRI, BLKTR1, INDXB,
C                        INDXA, INDXC, PROD, PRODP, CPROD, CPRODP,
C                        PPADD, PSGF, BSRH, PPSGF, PPSPF, COMPB,
C                        TRUN1, STOR1, TQLRAT
C
C Special Conditions     NONE
C
C Common Blocks          SPLP, CBLKT
C
C I/O                    NONE
C
C Precision              Single
C
C Specialist             John C. Adams, NCAR, Boulder, Colorado  80307
C
C Language               FORTRAN
C
C History                Developed at NCAR during 1975-76.
C
C Algorithm              SEPELI automatically discretizes the separable
C                        elliptic equation which is then solved by a
C                        generalized cyclic reduction algorithm in the
C                        subroutine, BLKTRI.  The fourth-order solution
C                        is obtained using 'Deferred Corrections' which
C                        is described and referenced in sections,
C                        references and method.
C
C Space Required         14654 (octal) = 6572 (decimal)
C
C Accuracy and Timing    The following computational results were
C                        obtained by solving the sample problem at the
C                        end of this write-up on the Control Data 7600.
C                        The op count is proportional to M*N*log2(N).
C                        In contrast to the other routines in this
C                        chapter, accuracy is tested by computing and
C                        tabulating second- and fourth-order
C                        discretization errors.  Below is a table
C                        containing computational results.  The times
C                        given do not include initialization (i.e.,
C                        times are for INTL=1).  Note that the
C                        fourth-order accuracy is not realized until the
C                        mesh is sufficiently refined.
C
C              Second-order    Fourth-order   Second-order  Fourth-order
C    M    N   Execution Time  Execution Time    Error         Error
C               (M SEC)         (M SEC)
C     6    6         6              14          6.8E-1        1.2E0
C    14   14        23              58          1.4E-1        1.8E-1
C    30   30       100             247          3.2E-2        9.7E-3
C    62   62       445           1,091          7.5E-3        3.0E-4
C   126  126     2,002           4,772          1.8E-3        3.5E-6
C
C Portability            There are no machine-dependent constants.
C
C Required Resident      SQRT, ABS, LOG
C Routines
C
C References             Keller, H.B., 'Numerical Methods for Two-point
C                          Boundary-value Problems', Blaisdel (1968),
C                          Waltham, Mass.
C
C                        Swarztrauber, P., and R. Sweet (1975):
C                          'Efficient FORTRAN Subprograms for The
C                          Solution of Elliptic Partial Differential
C                          Equations'.  NCAR Technical Note
C                          NCAR-TN/IA-109, pp. 135-137.
C
C***REFERENCES  H. B. Keller, Numerical Methods for Two-point
C                 Boundary-value Problems, Blaisdel, Waltham, Mass.,
C                 1968.
C               P. N. Swarztrauber and R. Sweet, Efficient Fortran
C                 subprograms for the solution of elliptic equations,
C                 NCAR TN/IA-109, July 1975, 138 pp.
C***ROUTINES CALLED  CHKPRM, SPELIP
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SEPELI
C
      DIMENSION       GRHS(IDMN,*)           ,USOL(IDMN,*)
      DIMENSION       BDA(*)     ,BDB(*)     ,BDC(*)     ,BDD(*)     ,
     1                W(*)
      EXTERNAL        COFX       ,COFY
C***FIRST EXECUTABLE STATEMENT  SEPELI
      CALL CHKPRM (INTL,IORDER,A,B,M,MBDCND,C,D,N,NBDCND,COFX,COFY,
     1             IDMN,IERROR)
      IF (IERROR .NE. 0) RETURN
C
C     COMPUTE MINIMUM WORK SPACE AND CHECK WORK SPACE LENGTH INPUT
C
      L = N+1
      IF (NBDCND .EQ. 0) L = N
      LOGB2N = INT(LOG(L+0.5)/LOG(2.0))+1
      LL = 2**(LOGB2N+1)
      K = M+1
      L = N+1
      LENGTH = (LOGB2N-2)*LL+LOGB2N+MAX(2*L,6*K)+5
      IF (NBDCND .EQ. 0) LENGTH = LENGTH+2*L
      IERROR = 11
      LINPUT = INT(W(1)+0.5)
      LOUTPT = LENGTH+6*(K+L)+1
      W(1) = LOUTPT
      IF (LOUTPT .GT. LINPUT) RETURN
      IERROR = 0
C
C     SET WORK SPACE INDICES
C
      I1 = LENGTH+2
      I2 = I1+L
      I3 = I2+L
      I4 = I3+L
      I5 = I4+L
      I6 = I5+L
      I7 = I6+L
      I8 = I7+K
      I9 = I8+K
      I10 = I9+K
      I11 = I10+K
      I12 = I11+K
      I13 = 2
      CALL SPELIP (INTL,IORDER,A,B,M,MBDCND,BDA,ALPHA,BDB,BETA,C,D,N,
     1             NBDCND,BDC,GAMA,BDD,XNU,COFX,COFY,W(I1),W(I2),W(I3),
     2             W(I4),W(I5),W(I6),W(I7),W(I8),W(I9),W(I10),W(I11),
     3             W(I12),GRHS,USOL,IDMN,W(I13),PERTRB,IERROR)
      RETURN
      END
*DECK SEPX4
      SUBROUTINE SEPX4 (IORDER, A, B, M, MBDCND, BDA, ALPHA, BDB, BETA,
     +   C, D, N, NBDCND, BDC, BDD, COFX, GRHS, USOL, IDMN, W, PERTRB,
     +   IERROR)
C***BEGIN PROLOGUE  SEPX4
C***PURPOSE  Solve for either the second or fourth order finite
C            difference approximation to the solution of a separable
C            elliptic partial differential equation on a rectangle.
C            Any combination of periodic or mixed boundary conditions is
C            allowed.
C***LIBRARY   SLATEC (FISHPACK)
C***CATEGORY  I2B1A2
C***TYPE      SINGLE PRECISION (SEPX4-S)
C***KEYWORDS  ELLIPTIC, FISHPACK, HELMHOLTZ, PDE, SEPARABLE
C***AUTHOR  Adams, J., (NCAR)
C           Swarztrauber, P. N., (NCAR)
C           Sweet, R., (NCAR)
C***DESCRIPTION
C
C Purpose                SEPX4 solves for either the second-order
C                        finite difference approximation or a
C                        fourth-order approximation  to the
C                        solution of a separable elliptic equation
C                             AF(X)*UXX+BF(X)*UX+CF(X)*U+UYY = G(X,Y)
C
C                        on a rectangle (X greater than or equal to A
C                        and less than or equal to B; Y greater than
C                        or equal to C and less than or equal to D).
C                        Any combination of periodic or mixed boundary
C                        conditions is allowed.
C                        If boundary conditions in the X direction
C                        are periodic (see MBDCND=0 below) then the
C                        coefficients must satisfy
C                        AF(X)=C1,BF(X)=0,CF(X)=C2 for all X.
C                        Here C1,C2 are constants, C1.GT.0.
C
C                        The possible boundary conditions are
C                        in the X-direction:
C                         (0) Periodic, U(X+B-A,Y)=U(X,Y) for all Y,X
C                         (1) U(A,Y), U(B,Y) are specified for all Y
C                         (2) U(A,Y), dU(B,Y)/dX+BETA*U(B,Y) are
C                             specified for all Y
C                         (3) dU(A,Y)/dX+ALPHA*U(A,Y),dU(B,Y)/dX+
C                             BETA*U(B,Y) are specified for all Y
C                         (4) dU(A,Y)/dX+ALPHA*U(A,Y),U(B,Y) are
C                             specified for all Y
C
C                        In the Y-direction:
C                         (0) Periodic, U(X,Y+D-C)=U(X,Y) for all X,Y
C                         (1) U(X,C),U(X,D) are specified for all X
C                         (2) U(X,C),dU(X,D)/dY are specified for all X
C                         (3) dU(X,C)/DY,dU(X,D)/dY are specified for
C                            all X
C                        (4) dU(X,C)/DY,U(X,D) are specified for all X
C
C Usage                  Call SEPX4(IORDER,A,B,M,MBDCND,BDA,ALPHA,BDB,
C                                  BETA,C,D,N,NBDCND,BDC,BDD,COFX,
C                                  GRHS,USOL,IDMN,W,PERTRB,IERROR)
C
C Arguments
C
C                        IORDER
C                          = 2 If a second-order approximation is sought
C                          = 4 If a fourth-order approximation is sought
C
C                        A,B
C                          The range of the X-independent variable;
C                          i.e., X is greater than or equal to A and
C                          less than or equal to B.  A must be less than
C                          B.
C
C                        M
C                          The number of panels into which the interval
C                          [A,B] is subdivided.  Hence, there will be
C                          M+1 grid points in the X-direction given by
C                          XI=A+(I-1)*DLX for I=1,2,...,M+1 where
C                          DLX=(B-A)/M is the panel width.  M must be
C                          less than IDMN and greater than 5.
C
C                        MBDCND
C                          Indicates the type of boundary condition at
C                          X=A and X=B
C                          = 0 If the solution is periodic in X; i.e.,
C                              U(X+B-A,Y)=U(X,Y) for all Y,X
C                          = 1 If the solution is specified at X=A and
C                              X=B; i.e., U(A,Y) and U(B,Y) are
C                              specified for all Y
C                          = 2 If the solution is specified at X=A and
C                              the boundary condition is mixed at X=B;
C                              i.e., U(A,Y) and dU(B,Y)/dX+BETA*U(B,Y)
C                              are specified for all Y
C                          = 3 If the boundary conditions at X=A and X=B
C                              are mixed; i.e., dU(A,Y)/dX+ALPHA*U(A,Y)
C                              and dU(B,Y)/dX+BETA*U(B,Y) are specified
C                              for all Y
C                          = 4 If the boundary condition at X=A is mixed
C                              and the solution is specified at X=B;
C                              i.e., dU(A,Y)/dX+ALPHA*U(A,Y) and U(B,Y)
C                              are specified for all Y
C
C                        BDA
C                          A one-dimensional array of length N+1 that
C                          specifies the values of dU(A,Y)/dX+
C                          ALPHA*U(A,Y) at X=A, when MBDCND=3 or 4.
C                               BDA(J) = dU(A,YJ)/dX+ALPHA*U(A,YJ);
C                               J=1,2,...,N+1
C                          When MBDCND has any other value, BDA is a
C                          dummy parameter.
C
C On Input               ALPHA
C                          The scalar multiplying the solution in case
C                          of a mixed boundary condition AT X=A (see
C                          argument BDA).  If MBDCND = 3,4 then ALPHA is
C                          a dummy parameter.
C
C                        BDB
C                          A one-dimensional array of length N+1 that
C                          specifies the values of dU(B,Y)/dX+
C                          BETA*U(B,Y) at X=B.  when MBDCND=2 or 3
C                               BDB(J) = dU(B,YJ)/dX+BETA*U(B,YJ);
C                               J=1,2,...,N+1
C                          When MBDCND has any other value, BDB is a
C                          dummy parameter.
C
C                        BETA
C                          The scalar multiplying the solution in case
C                          of a mixed boundary condition at X=B (see
C                          argument BDB).  If MBDCND=2,3 then BETA is a
C                          dummy parameter.
C
C                        C,D
C                          The range of the Y-independent variable;
C                          i.e., Y is greater than or equal to C and
C                          less than or equal to D.  C must be less than
C                          D.
C
C                        N
C                          The number of panels into which the interval
C                          [C,D] is subdivided.  Hence, there will be
C                          N+1 grid points in the Y-direction given by
C                          YJ=C+(J-1)*DLY for J=1,2,...,N+1 where
C                          DLY=(D-C)/N is the panel width.  In addition,
C                          N must be greater than 4.
C
C                        NBDCND
C                          Indicates the types of boundary conditions at
C                          Y=C and Y=D
C                          = 0 If the solution is periodic in Y; i.e.,
C                              U(X,Y+D-C)=U(X,Y) for all X,Y
C                          = 1 If the solution is specified at Y=C and
C                              Y = D, i.e., U(X,C) and U(X,D) are
C                              specified for all X
C                          = 2 If the solution is specified at Y=C and
C                              the boundary condition is mixed at Y=D;
C                              i.e., dU(X,C)/dY and U(X,D)
C                              are specified for all X
C                          = 3 If the boundary conditions are mixed at
C                              Y= C and Y=D i.e., dU(X,D)/DY
C                              and dU(X,D)/dY are specified
C                              for all X
C                          = 4 If the boundary condition is mixed at Y=C
C                              and the solution is specified at Y=D;
C                              i.e. dU(X,C)/dY+GAMA*U(X,C) and U(X,D)
C                              are specified for all X
C
C                        BDC
C                          A one-dimensional array of length M+1 that
C                          specifies the value dU(X,C)/DY
C                          at Y=C.  When NBDCND=3 or 4
C                            BDC(I) = dU(XI,C)/DY
C                             I=1,2,...,M+1.
C                          When NBDCND has any other value, BDC is a
C                          dummy parameter.
C
C
C                        BDD
C                          A one-dimensional array of length M+1 that
C                          specifies the value of dU(X,D)/DY
C                          at Y=D.  When NBDCND=2 or 3
C                            BDD(I)=dU(XI,D)/DY
C                             I=1,2,...,M+1.
C                          When NBDCND has any other value, BDD is a
C                          dummy parameter.
C
C
C                        COFX
C                          A user-supplied subprogram with
C                          parameters X, AFUN, BFUN, CFUN which
C                          returns the values of the X-dependent
C                          coefficients AF(X), BF(X), CF(X) in
C                          the elliptic equation at X.
C                          If boundary conditions in the X direction
C                          are periodic then the coefficients
C                          must satisfy AF(X)=C1,BF(X)=0,CF(X)=C2 for
C                          all X.  Here C1.GT.0 and C2 are constants.
C
C                          Note that COFX must be declared external
C                          in the calling routine.
C
C                        GRHS
C                          A two-dimensional array that specifies the
C                          values of the right-hand side of the elliptic
C                          equation; i.e., GRHS(I,J)=G(XI,YI), for
C                          I=2,...,M; J=2,...,N.  At the boundaries,
C                          GRHS is defined by
C
C                          MBDCND   GRHS(1,J)   GRHS(M+1,J)
C                          ------   ---------   -----------
C                            0      G(A,YJ)     G(B,YJ)
C                            1         *           *
C                            2         *        G(B,YJ)  J=1,2,...,N+1
C                            3      G(A,YJ)     G(B,YJ)
C                            4      G(A,YJ)        *
C
C                          NBDCND   GRHS(I,1)   GRHS(I,N+1)
C                          ------   ---------   -----------
C                            0      G(XI,C)     G(XI,D)
C                            1         *           *
C                            2         *        G(XI,D)  I=1,2,...,M+1
C                            3      G(XI,C)     G(XI,D)
C                            4      G(XI,C)        *
C
C                          where * means these quantities are not used.
C                          GRHS should be dimensioned IDMN by at least
C                          N+1 in the calling routine.
C
C                        USOL
C                          A two-dimensional array that specifies the
C                          values of the solution along the boundaries.
C                          At the boundaries, USOL is defined by
C
C                          MBDCND   USOL(1,J)   USOL(M+1,J)
C                          ------   ---------   -----------
C                            0         *           *
C                            1      U(A,YJ)     U(B,YJ)
C                            2      U(A,YJ)        *     J=1,2,...,N+1
C                            3         *           *
C                            4         *        U(B,YJ)
C
C                          NBDCND   USOL(I,1)   USOL(I,N+1)
C                          ------   ---------   -----------
C                            0         *           *
C                            1      U(XI,C)     U(XI,D)
C                            2      U(XI,C)        *     I=1,2,...,M+1
C                            3         *           *
C                            4         *        U(XI,D)
C
C                          where * means the quantities are not used in
C                          the solution.
C
C                          If IORDER=2, the user may equivalence GRHS
C                          and USOL to save space.  Note that in this
C                          case the tables specifying the boundaries of
C                          the GRHS and USOL arrays determine the
C                          boundaries uniquely except at the corners.
C                          If the tables call for both G(X,Y) and
C                          U(X,Y) at a corner then the solution must be
C                          chosen.  For example, if MBDCND=2 and
C                          NBDCND=4, then U(A,C), U(A,D), U(B,D) must be
C                          chosen at the corners in addition to G(B,C).
C
C                          If IORDER=4, then the two arrays, USOL and
C                          GRHS, must be distinct.
C
C                          USOL should be dimensioned IDMN by at least
C                          N+1 in the calling routine.
C
C                        IDMN
C                          The row (or first) dimension of the arrays
C                          GRHS and USOL as it appears in the program
C                          calling SEPX4.  This parameter is used to
C                          specify the variable dimension of GRHS and
C                          USOL.  IDMN must be at least 7 and greater
C                          than or equal to M+1.
C
C                        W
C                          A one-dimensional array that must be provided
C                          by the user for work space.
C                          10*N+(16+INT(log2(N)))*(M+1)+23 will suffice
C                          as a length for W.  The actual length of
C                          W in the calling routine must be set in W(1)
C                          (see IERROR=11).
C
C On Output              USOL
C                          Contains the approximate solution to the
C                          elliptic equation.  USOL(I,J) is the
C                          approximation to U(XI,YJ) for I=1,2...,M+1
C                          and J=1,2,...,N+1.  The approximation has
C                          error O(DLX**2+DLY**2) if called with
C                          IORDER=2 and O(DLX**4+DLY**4) if called with
C                          IORDER=4.
C
C                        W
C                          W(1) contains the exact minimal length (in
C                          floating point) required for the work space
C                          (see IERROR=11).
C
C                        PERTRB
C                          If a combination of periodic or derivative
C                          boundary conditions (i.e., ALPHA=BETA=0 if
C                          MBDCND=3) is specified and if CF(X)=0 for all
C                          X, then a solution to the discretized matrix
C                          equation may not exist (reflecting the non-
C                          uniqueness of solutions to the PDE).  PERTRB
C                          is a constant calculated and subtracted from
C                          the right hand side of the matrix equation
C                          insuring the existence of a solution.
C                          SEPX4 computes this solution which is a
C                          weighted minimal least squares solution to
C                          the original problem.  If singularity is
C                          not detected PERTRB=0.0 is returned by
C                          SEPX4.
C
C                        IERROR
C                          An error flag that indicates invalid input
C                          parameters or failure to find a solution
C                          = 0  No error
C                          = 1  If A greater than B or C greater than D
C                          = 2  If MBDCND less than 0 or MBDCND greater
C                               than 4
C                          = 3  If NBDCND less than 0 or NBDCND greater
C                               than 4
C                          = 4  If attempt to find a solution fails.
C                               (the linear system generated is not
C                               diagonally dominant.)
C                          = 5  If IDMN is too small (see discussion of
C                               IDMN)
C                          = 6  If M is too small or too large (see
C                               discussion of M)
C                          = 7  If N is too small (see discussion of N)
C                          = 8  If IORDER is not 2 or 4
C                          = 10 If AFUN is less than or equal to zero
C                               for some interior mesh point XI
C                          = 11 If the work space length input in W(1)
C                               is less than the exact minimal work
C                               space length required output in W(1).
C                          = 12 If MBDCND=0 and AF(X)=CF(X)=constant
C                               or BF(X)=0 for all X is not true.
C
C *Long Description:
C
C Dimension of           BDA(N+1), BDB(N+1), BDC(M+1), BDD(M+1),
C Arguments              USOL(IDMN,N+1), GRHS(IDMN,N+1),
C                        W (see argument list)
C
C Latest Revision        October 1980
C
C Special Conditions     NONE
C
C Common Blocks          SPL4
C
C I/O                    NONE
C
C Precision              Single
C
C Required Library       NONE
C Files
C
C Specialist             John C. Adams, NCAR, Boulder, Colorado  80307
C
C Language               FORTRAN
C
C
C Entry Points           SEPX4,SPELI4,CHKPR4,CHKSN4,ORTHO4,MINSO4,TRIS4,
C                        DEFE4,DX4,DY4
C
C History                SEPX4 was developed by modifying the ULIB
C                        routine SEPELI during October 1978.
C                        It should be used instead of SEPELI whenever
C                        possible.  The increase in speed is at least
C                        a factor of three.
C
C Algorithm              SEPX4 automatically discretizes the separable
C                        elliptic equation which is then solved by a
C                        generalized cyclic reduction algorithm in the
C                        subroutine POIS.  The fourth order solution
C                        is obtained using the technique of
C                        deferred corrections referenced below.
C
C
C References             Keller, H.B., 'Numerical Methods for Two-point
C                          Boundary-value Problems', Blaisdel (1968),
C                          Waltham, Mass.
C
C                        Swarztrauber, P., and R. Sweet (1975):
C                          'Efficient FORTRAN Subprograms For The
C                          Solution of Elliptic Partial Differential
C                          Equations'.  NCAR Technical Note
C                          NCAR-TN/IA-109, pp. 135-137.
C
C***REFERENCES  H. B. Keller, Numerical Methods for Two-point
C                 Boundary-value Problems, Blaisdel, Waltham, Mass.,
C                 1968.
C               P. N. Swarztrauber and R. Sweet, Efficient Fortran
C                 subprograms for the solution of elliptic equations,
C                 NCAR TN/IA-109, July 1975, 138 pp.
C***ROUTINES CALLED  CHKPR4, SPELI4
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920122  Minor corrections and modifications to prologue.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SEPX4
C
      DIMENSION       GRHS(IDMN,*)           ,USOL(IDMN,*)
      DIMENSION       BDA(*)     ,BDB(*)     ,BDC(*)     ,BDD(*)     ,
     1                W(*)
      EXTERNAL COFX
C***FIRST EXECUTABLE STATEMENT  SEPX4
      CALL CHKPR4(IORDER,A,B,M,MBDCND,C,D,N,NBDCND,COFX,IDMN,IERROR)
      IF (IERROR .NE. 0) RETURN
C
C     COMPUTE MINIMUM WORK SPACE AND CHECK WORK SPACE LENGTH INPUT
C
      L = N+1
      IF (NBDCND .EQ. 0) L = N
      K = M+1
      L = N+1
C     ESTIMATE LOG BASE 2 OF N
      LOG2N=INT(LOG(REAL(N+1))/LOG(2.0)+0.5)
      LENGTH=4*(N+1)+(10+LOG2N)*(M+1)
      IERROR = 11
      LINPUT = INT(W(1)+0.5)
      LOUTPT = LENGTH+6*(K+L)+1
      W(1) = LOUTPT
      IF (LOUTPT .GT. LINPUT) RETURN
      IERROR = 0
C
C     SET WORK SPACE INDICES
C
      I1 = LENGTH+2
      I2 = I1+L
      I3 = I2+L
      I4 = I3+L
      I5 = I4+L
      I6 = I5+L
      I7 = I6+L
      I8 = I7+K
      I9 = I8+K
      I10 = I9+K
      I11 = I10+K
      I12 = I11+K
      I13 = 2
      CALL SPELI4(IORDER,A,B,M,MBDCND,BDA,ALPHA,BDB,BETA,C,D,N,
     1NBDCND,BDC,BDD,COFX,W(I1),W(I2),W(I3),
     2             W(I4),W(I5),W(I6),W(I7),W(I8),W(I9),W(I10),W(I11),
     3             W(I12),GRHS,USOL,IDMN,W(I13),PERTRB,IERROR)
      RETURN
      END

subroutine reduce (line,key,vblank8,eblank8,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>reduce
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   COMPUTE MAX|MIN|MEAN|RMS|SUM|PRODUCT|MEDIAN|QUANTILE
  ! (mathematical reduction functions)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     !
  character(len=*), intent(in)    :: key      !
  real(kind=8),     intent(in)    :: vblank8  !
  real(kind=8),     intent(in)    :: eblank8  !
  logical,          intent(inout) :: error    !
  ! Global
  external :: comp_r4_min,comp_r4_max,comp_r8_min,comp_r8_max
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='COMPUTE'
  character(len=80) :: varin,varout
  type(sic_descriptor_t) :: descin,descout,desccopy
  integer(kind=address_length) :: ipnta,ipntb
  logical :: found
  integer :: typein,typeout,nc
  integer(kind=index_length) :: ida(sic_maxdims),idb(sic_maxdims)
  integer :: ndim,i,nkeep
  integer(kind=size_length) :: nvec
  real(kind=4) :: vblank4,eblank4
  logical :: is_vector
  !
  call sic_ke (line,0,3,varin,nc,.true.,error)
  if (error) return
  call sic_ke (line,0,1,varout,nc,.true.,error)
  if (error) return
  !
  found = .true.
  call sic_materialize(varin,descin,found)
  if (.not.found) then
    call sic_message(seve%e,rname,'Input Variable Non Existent')
    error = .true.
    return
  endif
  call sic_descriptor(varout,descout,found)
  if (.not.found) then
    call sic_message(seve%e,rname,'Output Variable Non Existent')
    error = .true.
    call sic_volatile(descin)
    return
  elseif (descout%status.eq.scratch_operand) then
    call sic_message(seve%e,rname,'Non contiguous sub-array not supported '//  &
    'for the output variable')
    call sic_volatile(descin)
    call sic_volatile(descout)
    error = .true.
    return
  endif
  typeout = descout%type
  if (descout%readonly) then
    call sic_message(seve%e,rname,'Output variable cannot be written')
    call sic_volatile(descin)
    error = .true.
    return
  elseif (typeout.ne.fmt_r4 .and. typeout.ne.fmt_r8) then
    call sic_message(seve%e,rname,'Output variable must be Real')
    call sic_volatile(descin)
    error = .true.
    return
  endif
  !
  is_vector = key.eq.'QUANTILE'  ! The output is vector
  !
  ! Check dimensions. Allow scalar result
  if (is_vector) then
    if (descout%ndim.lt.1) then
      call sic_message(seve%e,rname,  &
        'Last OUT dimension must be positive for '//key)
      call sic_volatile(descin)
      error = .true.
      return
    endif
    nvec = descout%dims(descout%ndim)
    nkeep = descout%ndim-1
    if (nkeep.gt.descin%ndim) then
      call sic_message(seve%e,rname,  &
        'OUT dim must be at most IN dim plus '//trim(key)//' dim')
      call sic_volatile(descin)
      error = .true.
      return
    elseif (nkeep.eq.descin%ndim .and. descin%ndim.ne.0) then
      ! Allow Last dimension 1 ...
      descin%ndim = descin%ndim+1
      descin%dims(descin%ndim) = 1
    endif
    ndim = nkeep
    do i=1,ndim
      if (descout%dims(i).ne.descin%dims(i)) then
        call sic_message(seve%e,rname,'Common dimensions do not match')
        call sic_volatile(descin)
        error =.true.
        return
      endif
    enddo
  else
    if (descout%ndim.ge.descin%ndim .and. descin%ndim.ne.0) then
      ! Allow Last dimension 1 ...
      if (descout%ndim.eq.descin%ndim) then
        descin%ndim = descin%ndim+1
        descin%dims(descin%ndim) = 1
      else
        call sic_message(seve%e,rname,'OUT dim must be less than IN dim')
        call sic_volatile(descin)
        error =.true.
        return
      endif
    endif
    ndim=descout%ndim
    do i=1,ndim
      if (descout%dims(i).ne.descin%dims(i)) then
        call sic_message(seve%e,rname,'Common dimensions do not match')
        call sic_volatile(descin)
        error =.true.
        return
      endif
    enddo
    ! This will make things simpler in this case:
    if (ndim.le.1.and.descout%dims(1).le.1) ndim=0
  endif
  !
  typein = descin%type
  if (typein.ne.fmt_r4 .and. typein.ne.fmt_r8 .and.  &
      typein.ne.fmt_i4 .and. typein.ne.fmt_i8) then
    call sic_message(seve%e,rname,'Input variable must be Real or Integer')
    call sic_volatile(descin)
    error = .true.
    return
  endif
  !
  if (typein.eq.fmt_i4 .or. typein.eq.fmt_i8) then
    ! Cast the integer array in a real copy. Precision is controled by the
    ! output variable.
    call sic_incarnate(typeout,descin,desccopy,error)
    if (error)  return
    call sic_volatile(descin)  ! Suppress the original (i4/i8) materialization
    descin = desccopy          ! New descriptor takes place of the original one
    typein = typeout           ! in the subsequent computations
  endif
  !
  ipnta = gag_pointer(descin%addr,memory)
  ipntb = gag_pointer(descout%addr,memory)
  do i=1,sic_maxdims
    ida(i)=descin%dims(i)
    if (ida(i).le.0) ida(i)=1
    idb(i)=descout%dims(i)
    if (idb(i).le.0) idb(i)=1
  enddo
  !
  error = .false.
  vblank4 = vblank8
  eblank4 = eblank8
  if (typein.eq.fmt_r8) then
    if (typeout.eq.fmt_r8) then
      call reduce_r8tor8(key)
    else
      call reduce_r8tor4(key)
    endif
  else
    if (typeout.eq.fmt_r8) then
      call reduce_r4tor8(key)
    else
      call reduce_r4tor4(key)
    endif
  endif
  call sic_volatile(descin)
  return
  !
contains
  subroutine reduce_r8tor8(key)
    use sic_interfaces
    character(len=*), intent(in) :: key
    if (key.eq.'MEAN') then
      call comp_r8tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r8_mean,vblank8,eblank8,error)
    elseif (key.eq.'SUM') then
      call comp_r8tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r8_sum,vblank8,eblank8,error)
    elseif (key.eq.'MIN') then
      call comp_r8tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r8_min,vblank8,eblank8,error)
    elseif (key.eq.'MAX') then
      call comp_r8tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r8_max,vblank8,eblank8,error)
    elseif (key.eq.'RMS') then
      call comp_r8tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r8_rms,vblank8,eblank8,error)
    elseif (key.eq.'PRODUCT') then
      call comp_r8tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r8_prod,vblank8,eblank8,error)
    elseif (key.eq.'MEDIAN') then
      call comp_r8tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r8_median,vblank8,eblank8,error)
    elseif (key.eq.'QUANTILE') then
      call comp_r8tor8vec_all(ndim,key,memory(ipnta),ida,  &
      memory(ipntb),idb,nvec,comp_r8_quantile,vblank8,eblank8,error)
    endif
  end subroutine reduce_r8tor8
  !
  subroutine reduce_r8tor4(key)
    use sic_interfaces
    character(len=*), intent(in) :: key
    if (key.eq.'MEAN') then
      call comp_r8tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_mean,vblank4,eblank4,error)
    elseif (key.eq.'SUM') then
      call comp_r8tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_sum,vblank4,eblank4,error)
    elseif (key.eq.'MIN') then
      call comp_r8tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_min,vblank4,eblank4,error)
    elseif (key.eq.'MAX') then
      call comp_r8tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_max,vblank4,eblank4,error)
    elseif (key.eq.'RMS') then
      call comp_r8tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_rms,vblank4,eblank4,error)
    elseif (key.eq.'PRODUCT') then
      call comp_r8tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_prod,vblank4,eblank4,error)
    elseif (key.eq.'MEDIAN') then
      call comp_r8tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_median,vblank4,eblank4,error)
    elseif (key.eq.'QUANTILE') then
      call comp_r8tor4vec_all(ndim,key,memory(ipnta),ida,  &
      memory(ipntb),idb,nvec,comp_r4_quantile,vblank4,eblank4,error)
    endif
  end subroutine reduce_r8tor4
  !
  subroutine reduce_r4tor8(key)
    use sic_interfaces
    character(len=*), intent(in) :: key
    if (key.eq.'MEAN') then
      call comp_r4tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_mean,vblank4,eblank4,error)
    elseif (key.eq.'SUM') then
      call comp_r4tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_sum,vblank4,eblank4,error)
    elseif (key.eq.'MIN') then
      call comp_r4tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_min,vblank4,eblank4,error)
    elseif (key.eq.'MAX') then
      call comp_r4tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_max,vblank4,eblank4,error)
    elseif (key.eq.'RMS') then
      call comp_r4tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_rms,vblank4,eblank4,error)
    elseif (key.eq.'PRODUCT') then
      call comp_r4tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_prod,vblank4,eblank4,error)
    elseif (key.eq.'MEDIAN') then
      call comp_r4tor8_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_median,vblank4,eblank4,error)
    elseif (key.eq.'QUANTILE') then
      call comp_r4tor8vec_all(ndim,key,memory(ipnta),ida,  &
      memory(ipntb),idb,nvec,comp_r4_quantile,vblank4,eblank4,error)
    endif
  end subroutine reduce_r4tor8
  !
  subroutine reduce_r4tor4(key)
    use sic_interfaces
    character(len=*), intent(in) :: key
    if (key.eq.'MEAN') then
      call comp_r4tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_mean,vblank4,eblank4,error)
    elseif (key.eq.'SUM') then
      call comp_r4tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_sum,vblank4,eblank4,error)
    elseif (key.eq.'MIN') then
      call comp_r4tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_min,vblank4,eblank4,error)
    elseif (key.eq.'MAX') then
      call comp_r4tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_max,vblank4,eblank4,error)
    elseif (key.eq.'RMS') then
      call comp_r4tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_rms,vblank4,eblank4,error)
    elseif (key.eq.'PRODUCT') then
      call comp_r4tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_prod,vblank4,eblank4,error)
    elseif (key.eq.'MEDIAN') then
      call comp_r4tor4_all(ndim,key,memory(ipnta),ida,memory(ipntb),idb,  &
      comp_r4_median,vblank4,eblank4,error)
    elseif (key.eq.'QUANTILE') then
      call comp_r4tor4vec_all(ndim,key,memory(ipnta),ida,  &
      memory(ipntb),idb,nvec,comp_r4_quantile,vblank4,eblank4,error)
    endif
  end subroutine reduce_r4tor4
  !
end subroutine reduce
!
subroutine comp_r4tor4_all(ndim,key,a,na,b,nb,myfunc,vblank4,eblank4,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Compute the value for common leading dimensions, storing the result
  ! in a scalar value.
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndim     !
  character(len=*),           intent(in)    :: key      !
  real(kind=4),               intent(in)    :: a(*)     !
  integer(kind=index_length), intent(in)    :: na(7)    !
  real(kind=4),               intent(out)   :: b(*)     !
  integer(kind=index_length), intent(in)    :: nb(7)    !
  external                                  :: myfunc   !
  real(kind=4),               intent(in)    :: vblank4  !
  real(kind=4),               intent(in)    :: eblank4  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='COMP_R4TOR4_ALL'
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6
  integer(kind=size_length) :: ioff,dima
  real(kind=4), allocatable :: cwork(:)
  integer :: ier
  logical :: perror
  !
  i6 = 1
  i5 = 1
  i4 = 1
  i3 = 1
  i2 = 1
  i1 = 1
  !
  select case (ndim)
  case(1)
    dima=na(2)*na(3)*na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i2,i3,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(1)
      do i1=1,nb(1)
        ! Collect last dims of A in CWORK
        ioff = i1
        call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
          cwork,i1,i2,i3,i4,i5,i6)
        call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(2)
    dima=na(3)*na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i3,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(2)
      do i2=1,nb(2)
        do i1=1,nb(1)
          ! Collect last dims of A in CWORK
          ioff = (i2-1)*nb(1)+i1
          call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
            cwork,i1,i2,i3,i4,i5,i6)
          call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(3)
    dima=na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(3)
      do i3=1,nb(3)
        do i2=1,nb(2)
          do i1=1,nb(1)
            ! Collect last dims of A in CWORK
            ioff = (i3-1)*nb(1)*nb(2)+(i2-1)*nb(1)+i1
            call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
              cwork,i1,i2,i3,i4,i5,i6)
            call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(4)
    dima=na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(4)
      do i4=1,nb(4)
        do i3=1,nb(3)
          do i2=1,nb(2)
            do i1=1,nb(1)
              ! Collect last dims of A in CWORK
              ioff = (i4-1)*nb(1)*nb(2)*nb(3) +  &
                     (i3-1)*nb(1)*nb(2) +  &
                     (i2-1)*nb(1) + i1
              call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                cwork,i1,i2,i3,i4,i5,i6)
              call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(5)
    dima=na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,i5,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(5)
      do i5=1,nb(5)
        do i4=1,nb(4)
          do i3=1,nb(3)
            do i2=1,nb(2)
              do i1=1,nb(1)
                ! Collect last dims of A in CWORK
                ioff = (i5-1)*nb(1)*nb(2)*nb(3)*nb(4) +  &
                       (i4-1)*nb(1)*nb(2)*nb(3) +  &
                       (i3-1)*nb(1)*nb(2) +  &
                       (i2-1)*nb(1) + i1
                call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                  cwork,i1,i2,i3,i4,i5,i6)
                call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
              enddo
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(6)
    dima=na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,i5,i6,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(6)
      do i6=1,nb(6)
        do i5=1,nb(5)
          do i4=1,nb(4)
            do i3=1,nb(3)
              do i2=1,nb(2)
                do i1=1,nb(1)
                  ! Collect last dims of A in CWORK
                  ioff = (i6-1)*nb(1)*nb(2)*nb(3)*nb(4)*nb(5) +  &
                         (i5-1)*nb(1)*nb(2)*nb(3)*nb(4) +  &
                         (i4-1)*nb(1)*nb(2)*nb(3) +  &
                         (i3-1)*nb(1)*nb(2) +  &
                         (i2-1)*nb(1) + i1
                  call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                    cwork,i1,i2,i3,i4,i5,i6)
                  call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(0)
    ! The simplest case: collect all dims of A in B
    dima=na(1)*na(2)*na(3)*na(4)*na(5)*na(6)*na(7)
    call myfunc(a,dima,vblank4,eblank4,b)
    !
  case default
    call sic_message(seve%e,rname,'Internal error')
    error = .true.
    return
  end select
  !
end subroutine comp_r4tor4_all
!
subroutine comp_r8tor8_all(ndim,key,a,na,b,nb,myfunc,vblank8,eblank8,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Compute the value for common leading dimensions, storing the result
  ! in a scalar value.
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndim     !
  character(len=*),           intent(in)    :: key      !
  real(kind=8),               intent(in)    :: a(*)     !
  integer(kind=index_length), intent(in)    :: na(7)    !
  real(kind=8),               intent(out)   :: b(*)     !
  integer(kind=index_length), intent(in)    :: nb(7)    !
  external                                  :: myfunc   !
  real(kind=8),               intent(in)    :: vblank8  !
  real(kind=8),               intent(in)    :: eblank8  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='COMP_R8TOR8_ALL'
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6
  integer(kind=size_length) :: ioff,dima
  real(kind=8), allocatable :: cwork(:)
  integer :: ier
  logical :: perror
  !
  i6 = 1
  i5 = 1
  i4 = 1
  i3 = 1
  i2 = 1
  i1 = 1
  !
  select case (ndim)
  case(1)
    dima=na(2)*na(3)*na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank8,eblank8,i2,i3,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(1)
      do i1=1,nb(1)
        ! Collect last dims of A in CWORK
        ioff = i1
        call collect_w8tow8(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
          cwork,i1,i2,i3,i4,i5,i6)
        call myfunc(cwork,dima,vblank8,eblank8,b(ioff))
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(2)
    dima=na(3)*na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank8,eblank8,i3,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(2)
      do i2=1,nb(2)
        do i1=1,nb(1)
          ! Collect last dims of A in CWORK
          ioff = (i2-1)*nb(1)+i1
          call collect_w8tow8(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
            cwork,i1,i2,i3,i4,i5,i6)
          call myfunc(cwork,dima,vblank8,eblank8,b(ioff))
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(3)
    dima=na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank8,eblank8,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(3)
      do i3=1,nb(3)
        do i2=1,nb(2)
          do i1=1,nb(1)
            ! Collect last dims of A in CWORK
            ioff = (i3-1)*nb(1)*nb(2)+(i2-1)*nb(1)+i1
            call collect_w8tow8(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
              cwork,i1,i2,i3,i4,i5,i6)
            call myfunc(cwork,dima,vblank8,eblank8,b(ioff))
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(4)
    dima=na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank8,eblank8,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(4)
      do i4=1,nb(4)
        do i3=1,nb(3)
          do i2=1,nb(2)
            do i1=1,nb(1)
              ! Collect last dims of A in CWORK
              ioff = (i4-1)*nb(1)*nb(2)*nb(3) +  &
                     (i3-1)*nb(1)*nb(2) +  &
                     (i2-1)*nb(1) + i1
              call collect_w8tow8(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                cwork,i1,i2,i3,i4,i5,i6)
              call myfunc(cwork,dima,vblank8,eblank8,b(ioff))
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(5)
    dima=na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,i5,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank8,eblank8,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(5)
      do i5=1,nb(5)
        do i4=1,nb(4)
          do i3=1,nb(3)
            do i2=1,nb(2)
              do i1=1,nb(1)
                ! Collect last dims of A in CWORK
                ioff = (i5-1)*nb(1)*nb(2)*nb(3)*nb(4) +  &
                       (i4-1)*nb(1)*nb(2)*nb(3) +  &
                       (i3-1)*nb(1)*nb(2) +  &
                       (i2-1)*nb(1) + i1
                call collect_w8tow8(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                  cwork,i1,i2,i3,i4,i5,i6)
                call myfunc(cwork,dima,vblank8,eblank8,b(ioff))
              enddo
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(6)
    dima=na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,i5,i6,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank8,eblank8)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(6)
      do i6=1,nb(6)
        do i5=1,nb(5)
          do i4=1,nb(4)
            do i3=1,nb(3)
              do i2=1,nb(2)
                do i1=1,nb(1)
                  ! Collect last dims of A in CWORK
                  ioff = (i6-1)*nb(1)*nb(2)*nb(3)*nb(4)*nb(5) +  &
                         (i5-1)*nb(1)*nb(2)*nb(3)*nb(4) +  &
                         (i4-1)*nb(1)*nb(2)*nb(3) +  &
                         (i3-1)*nb(1)*nb(2) +  &
                         (i2-1)*nb(1) + i1
                  call collect_w8tow8(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                    cwork,i1,i2,i3,i4,i5,i6)
                  call myfunc(cwork,dima,vblank8,eblank8,b(ioff))
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(0)
    ! The simplest case: collect all dims of A in B
    dima=na(1)*na(2)*na(3)*na(4)*na(5)*na(6)*na(7)
    call myfunc(a,dima,vblank8,eblank8,b)
    !
  case default
    call sic_message(seve%e,rname,'Internal error')
    error = .true.
    return
  end select
  !
end subroutine comp_r8tor8_all
!
subroutine comp_r8tor4_all(ndim,key,a,na,b,nb,myfunc,vblank4,eblank4,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Compute the value for common leading dimensions, storing the result
  ! in a scalar value.
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndim     !
  character(len=*),           intent(in)    :: key      !
  real(kind=8),               intent(in)    :: a(*)     !
  integer(kind=index_length), intent(in)    :: na(7)    !
  real(kind=4),               intent(out)   :: b(*)     !
  integer(kind=index_length), intent(in)    :: nb(7)    !
  external                                  :: myfunc   !
  real(kind=4),               intent(in)    :: vblank4  !
  real(kind=4),               intent(in)    :: eblank4  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='COMP_R8TOR4_ALL'
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6
  integer(kind=size_length) :: ioff,dima
  real(kind=4), allocatable :: cwork(:)
  integer :: ier
  logical :: perror
  !
  i6 = 1
  i5 = 1
  i4 = 1
  i3 = 1
  i2 = 1
  i1 = 1
  !
  select case (ndim)
  case(1)
    dima=na(2)*na(3)*na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i2,i3,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(1)
      do i1=1,nb(1)
        ! Collect last dims of A in CWORK
        ioff = i1
        call collect_r8tor4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
          cwork,i1,i2,i3,i4,i5,i6)
        call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(2)
    dima=na(3)*na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i3,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(2)
      do i2=1,nb(2)
        do i1=1,nb(1)
          ! Collect last dims of A in CWORK
          ioff = (i2-1)*nb(1)+i1
          call collect_r8tor4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
            cwork,i1,i2,i3,i4,i5,i6)
          call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(3)
    dima=na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(3)
      do i3=1,nb(3)
        do i2=1,nb(2)
          do i1=1,nb(1)
            ! Collect last dims of A in CWORK
            ioff = (i3-1)*nb(1)*nb(2)+(i2-1)*nb(1)+i1
            call collect_r8tor4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
              cwork,i1,i2,i3,i4,i5,i6)
            call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(4)
    dima=na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(4)
      do i4=1,nb(4)
        do i3=1,nb(3)
          do i2=1,nb(2)
            do i1=1,nb(1)
              ! Collect last dims of A in CWORK
              ioff = (i4-1)*nb(1)*nb(2)*nb(3) +  &
                     (i3-1)*nb(1)*nb(2) +  &
                     (i2-1)*nb(1) + i1
              call collect_r8tor4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                cwork,i1,i2,i3,i4,i5,i6)
              call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(5)
    dima=na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,i5,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(5)
      do i5=1,nb(5)
        do i4=1,nb(4)
          do i3=1,nb(3)
            do i2=1,nb(2)
              do i1=1,nb(1)
                ! Collect last dims of A in CWORK
                ioff = (i5-1)*nb(1)*nb(2)*nb(3)*nb(4) +  &
                       (i4-1)*nb(1)*nb(2)*nb(3) +  &
                       (i3-1)*nb(1)*nb(2) +  &
                       (i2-1)*nb(1) + i1
                call collect_r8tor4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                  cwork,i1,i2,i3,i4,i5,i6)
                call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
              enddo
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(6)
    dima=na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,i5,i6,ioff,cwork,ier,perror) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(6)
      do i6=1,nb(6)
        do i5=1,nb(5)
          do i4=1,nb(4)
            do i3=1,nb(3)
              do i2=1,nb(2)
                do i1=1,nb(1)
                  ! Collect last dims of A in CWORK
                  ioff = (i6-1)*nb(1)*nb(2)*nb(3)*nb(4)*nb(5) +  &
                         (i5-1)*nb(1)*nb(2)*nb(3)*nb(4) +  &
                         (i4-1)*nb(1)*nb(2)*nb(3) +  &
                         (i3-1)*nb(1)*nb(2) +  &
                         (i2-1)*nb(1) + i1
                  call collect_r8tor4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                    cwork,i1,i2,i3,i4,i5,i6)
                  call myfunc(cwork,dima,vblank4,eblank4,b(ioff))
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(0)
    ! The simplest case: collect all dims of A in B
    dima=na(1)*na(2)*na(3)*na(4)*na(5)*na(6)*na(7)
    allocate(cwork(dima),stat=ier)
    if (failed_allocate(key,'cwork',ier,error))  return
    call r8tor4_sl(a,cwork,dima)
    call myfunc(cwork,dima,vblank4,eblank4,b)
    deallocate(cwork)
    !
  case default
    call sic_message(seve%e,rname,'Internal error')
    error = .true.
    return
  end select
  !
end subroutine comp_r8tor4_all
!
subroutine comp_r4tor8_all(ndim,key,a,na,b,nb,myfunc,vblank4,eblank4,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Compute the value for common leading dimensions, storing the result
  ! in a scalar value.
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndim     !
  character(len=*),           intent(in)    :: key      !
  real(kind=4),               intent(in)    :: a(*)     !
  integer(kind=index_length), intent(in)    :: na(7)    !
  real(kind=8),               intent(out)   :: b(*)     !
  integer(kind=index_length), intent(in)    :: nb(7)    !
  external                                  :: myfunc   !
  real(kind=4),               intent(in)    :: vblank4  !
  real(kind=4),               intent(in)    :: eblank4  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='COMP_R4TOR8_ALL'
  real :: res4               ! space optimisation
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6
  integer(kind=size_length) :: ioff,dima
  real(kind=4), allocatable :: cwork(:)
  integer :: ier
  logical :: perror
  !
  i6 = 1
  i5 = 1
  i4 = 1
  i3 = 1
  i2 = 1
  i1 = 1
  !
  select case(ndim)
  case(1)
    dima=na(2)*na(3)*na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,ioff,cwork,ier,perror,res4) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i2,i3,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(1)
      do i1=1,nb(1)
        ! Collect last dims of A in CWORK
        ioff = i1
        call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
          cwork,i1,i2,i3,i4,i5,i6)
        call myfunc(cwork,dima,vblank4,eblank4,res4)
        call r4tor8(res4,b(ioff),1)
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(2)
    dima=na(3)*na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,ioff,cwork,ier,perror,res4) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i3,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(2)
      do i2=1,nb(2)
        do i1=1,nb(1)
          ! Collect last dims of A in CWORK
          ioff = (i2-1)*nb(1)+i1
          call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
            cwork,i1,i2,i3,i4,i5,i6)
          call myfunc(cwork,dima,vblank4,eblank4,res4)
          call r4tor8(res4,b(ioff),1)
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(3)
    dima=na(4)*na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,ioff,cwork,ier,perror,res4) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(3)
      do i3=1,nb(3)
        do i2=1,nb(2)
          do i1=1,nb(1)
            ! Collect last dims of A in CWORK
            ioff = (i3-1)*nb(1)*nb(2)+(i2-1)*nb(1)+i1
            call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
              cwork,i1,i2,i3,i4,i5,i6)
            call myfunc(cwork,dima,vblank4,eblank4,res4)
            call r4tor8(res4,b(ioff),1)
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(4)
    dima=na(5)*na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,ioff,cwork,ier,perror,res4) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i5,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(4)
      do i4=1,nb(4)
        do i3=1,nb(3)
          do i2=1,nb(2)
            do i1=1,nb(1)
              ! Collect last dims of A in CWORK
              ioff = (i4-1)*nb(1)*nb(2)*nb(3) +  &
                     (i3-1)*nb(1)*nb(2) +  &
                     (i2-1)*nb(1) + i1
              call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                cwork,i1,i2,i3,i4,i5,i6)
              call myfunc(cwork,dima,vblank4,eblank4,res4)
              call r4tor8(res4,b(ioff),1)
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(5)
    dima=na(6)*na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,i5,ioff,cwork,ier,perror,res4) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4,i6)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(5)
      do i5=1,nb(5)
        do i4=1,nb(4)
          do i3=1,nb(3)
            do i2=1,nb(2)
              do i1=1,nb(1)
                ! Collect last dims of A in CWORK
                ioff = (i5-1)*nb(1)*nb(2)*nb(3)*nb(4) +  &
                       (i4-1)*nb(1)*nb(2)*nb(3) +  &
                       (i3-1)*nb(1)*nb(2) +  &
                       (i2-1)*nb(1) + i1
                call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                  cwork,i1,i2,i3,i4,i5,i6)
                call myfunc(cwork,dima,vblank4,eblank4,res4)
                call r4tor8(res4,b(ioff),1)
              enddo
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(6)
    dima=na(7)
    !$OMP PARALLEL &
    !$OMP DEFAULT(NONE) &
    !$OMP PRIVATE(i1,i2,i3,i4,i5,i6,ioff,cwork,ier,perror,res4) &
    !$OMP SHARED(key,error,ndim,a,na,dima,b,nb,vblank4,eblank4)
    allocate(cwork(dima),stat=ier)
    perror = .false.
    if (failed_allocate(key,'cwork',ier,perror)) then
      error = .true.
    else
      !$OMP DO COLLAPSE(6)
      do i6=1,nb(6)
        do i5=1,nb(5)
          do i4=1,nb(4)
            do i3=1,nb(3)
              do i2=1,nb(2)
                do i1=1,nb(1)
                  ! Collect last dims of A in CWORK
                  ioff = (i6-1)*nb(1)*nb(2)*nb(3)*nb(4)*nb(5) +  &
                         (i5-1)*nb(1)*nb(2)*nb(3)*nb(4) +  &
                         (i4-1)*nb(1)*nb(2)*nb(3) +  &
                         (i3-1)*nb(1)*nb(2) +  &
                         (i2-1)*nb(1) + i1
                  call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
                    cwork,i1,i2,i3,i4,i5,i6)
                  call myfunc(cwork,dima,vblank4,eblank4,res4)
                  call r4tor8(res4,b(ioff),1)
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      !$OMP END DO
      deallocate(cwork)
    endif
    !$OMP END PARALLEL
    if (error)  return
    !
  case(0)
    ! The simplest case: collect all dims of A in B
    dima=na(1)*na(2)*na(3)*na(4)*na(5)*na(6)*na(7)
    call myfunc(a,dima,vblank4,eblank4,res4)
    call r4tor8(res4,b,1)
    !
  case default
    call sic_message(seve%e,rname,'Internal error')
    error = .true.
    return
  end select
  !
end subroutine comp_r4tor8_all
!
subroutine comp_r4tor4vec_all(ndim,key,a,na,b,nb,nvec,myfunc,  &
                                vblank4,eblank4,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Compute the value for common leading dimensions, storing the result
  ! in a 1D vector.
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndim     !
  character(len=*),           intent(in)    :: key      !
  real(kind=4),               intent(in)    :: a(*)     !
  integer(kind=index_length), intent(in)    :: na(7)    !
  real(kind=4),               intent(out)   :: b(*)     !
  integer(kind=index_length), intent(in)    :: nb(7)    !
  integer(kind=size_length),  intent(in)    :: nvec     !
  external                                  :: myfunc   !
  real(kind=4),               intent(in)    :: vblank4  !
  real(kind=4),               intent(in)    :: eblank4  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='comp_r4tor4vec_all'
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6
  integer(kind=size_length) :: ioff,boff,dima,ncommon
  real(kind=4), allocatable :: cwork(:)
  real(kind=4), allocatable :: qwork(:)
  integer :: i,ier
  integer(kind=size_length) :: iq
  !
  if (ndim.lt.0 .or. ndim.gt.6) then
    call sic_message(seve%e,rname,'Internal error')
    error = .true.
    return
  endif
  ncommon = 1
  do i=1,ndim
    ncommon = ncommon*nb(i)
  enddo
  dima = 1
  do i=ndim+1,7
    dima = dima*na(i)
  enddo
  !
  allocate(qwork(nvec),stat=ier)
  if (failed_allocate(key,'qwork',ier,error))  return
  if (ndim.eq.0) then
    call myfunc(a,dima,vblank4,eblank4,qwork,nvec,error)
    if (error) then
      deallocate(qwork)
      return
    endif
    do iq=1,nvec
      b(iq) = qwork(iq)
    enddo
    deallocate(qwork)
    return
  endif
  !
  allocate(cwork(dima),stat=ier)
  if (failed_allocate(key,'cwork',ier,error)) then
    deallocate(qwork)
    return
  endif
  do ioff=1,ncommon
    call decode_reduce_indices(ndim,nb,ioff,i1,i2,i3,i4,i5,i6)
    call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
      cwork,i1,i2,i3,i4,i5,i6)
    call myfunc(cwork,dima,vblank4,eblank4,qwork,nvec,error)
    if (error)  exit
    do iq=1,nvec
      boff = ioff+(iq-1)*ncommon
      b(boff) = qwork(iq)
    enddo
  enddo
  deallocate(cwork)
  deallocate(qwork)
  !
end subroutine comp_r4tor4vec_all
!
subroutine comp_r8tor8vec_all(ndim,key,a,na,b,nb,nvec,myfunc,  &
                                vblank8,eblank8,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Compute the value for common leading dimensions, storing the result
  ! in a 1D vector.
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndim     !
  character(len=*),           intent(in)    :: key      !
  real(kind=8),               intent(in)    :: a(*)     !
  integer(kind=index_length), intent(in)    :: na(7)    !
  real(kind=8),               intent(out)   :: b(*)     !
  integer(kind=index_length), intent(in)    :: nb(7)    !
  integer(kind=size_length),  intent(in)    :: nvec   !
  external                                  :: myfunc   !
  real(kind=8),               intent(in)    :: vblank8  !
  real(kind=8),               intent(in)    :: eblank8  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='comp_r8tor8vec_all'
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6
  integer(kind=size_length) :: ioff,boff,dima,ncommon
  real(kind=8), allocatable :: cwork(:)
  real(kind=8), allocatable :: qwork(:)
  integer :: i,ier
  integer(kind=size_length) :: iq
  !
  if (ndim.lt.0 .or. ndim.gt.6) then
    call sic_message(seve%e,rname,'Internal error')
    error = .true.
    return
  endif
  ncommon = 1
  do i=1,ndim
    ncommon = ncommon*nb(i)
  enddo
  dima = 1
  do i=ndim+1,7
    dima = dima*na(i)
  enddo
  !
  allocate(qwork(nvec),stat=ier)
  if (failed_allocate(key,'qwork',ier,error))  return
  if (ndim.eq.0) then
    call myfunc(a,dima,vblank8,eblank8,qwork,nvec,error)
    if (error) then
      deallocate(qwork)
      return
    endif
    do iq=1,nvec
      b(iq) = qwork(iq)
    enddo
    deallocate(qwork)
    return
  endif
  !
  allocate(cwork(dima),stat=ier)
  if (failed_allocate(key,'cwork',ier,error)) then
    deallocate(qwork)
    return
  endif
  do ioff=1,ncommon
    call decode_reduce_indices(ndim,nb,ioff,i1,i2,i3,i4,i5,i6)
    call collect_w8tow8(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
      cwork,i1,i2,i3,i4,i5,i6)
    call myfunc(cwork,dima,vblank8,eblank8,qwork,nvec,error)
    if (error)  exit
    do iq=1,nvec
      boff = ioff+(iq-1)*ncommon
      b(boff) = qwork(iq)
    enddo
  enddo
  deallocate(cwork)
  deallocate(qwork)
  !
end subroutine comp_r8tor8vec_all
!
subroutine comp_r8tor4vec_all(ndim,key,a,na,b,nb,nvec,myfunc,  &
                                vblank4,eblank4,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Compute the value for common leading dimensions, storing the result
  ! in a 1D vector.
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndim     !
  character(len=*),           intent(in)    :: key      !
  real(kind=8),               intent(in)    :: a(*)     !
  integer(kind=index_length), intent(in)    :: na(7)    !
  real(kind=4),               intent(out)   :: b(*)     !
  integer(kind=index_length), intent(in)    :: nb(7)    !
  integer(kind=size_length),  intent(in)    :: nvec   !
  external                                  :: myfunc   !
  real(kind=4),               intent(in)    :: vblank4  !
  real(kind=4),               intent(in)    :: eblank4  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='comp_r8tor4vec_all'
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6
  integer(kind=size_length) :: ioff,boff,dima,ncommon
  real(kind=4), allocatable :: cwork(:)
  real(kind=4), allocatable :: qwork(:)
  integer :: i,ier
  integer(kind=size_length) :: iq
  !
  if (ndim.lt.0 .or. ndim.gt.6) then
    call sic_message(seve%e,rname,'Internal error')
    error = .true.
    return
  endif
  ncommon = 1
  do i=1,ndim
    ncommon = ncommon*nb(i)
  enddo
  dima = 1
  do i=ndim+1,7
    dima = dima*na(i)
  enddo
  !
  allocate(qwork(nvec),stat=ier)
  if (failed_allocate(key,'qwork',ier,error))  return
  allocate(cwork(dima),stat=ier)
  if (failed_allocate(key,'cwork',ier,error)) then
    deallocate(qwork)
    return
  endif
  if (ndim.eq.0) then
    call r8tor4_sl(a,cwork,dima)
    call myfunc(cwork,dima,vblank4,eblank4,qwork,nvec,error)
    if (.not.error) then
      do iq=1,nvec
        b(iq) = qwork(iq)
      enddo
    endif
    deallocate(cwork)
    deallocate(qwork)
    return
  endif
  !
  do ioff=1,ncommon
    call decode_reduce_indices(ndim,nb,ioff,i1,i2,i3,i4,i5,i6)
    call collect_r8tor4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
      cwork,i1,i2,i3,i4,i5,i6)
    call myfunc(cwork,dima,vblank4,eblank4,qwork,nvec,error)
    if (error)  exit
    do iq=1,nvec
      boff = ioff+(iq-1)*ncommon
      b(boff) = qwork(iq)
    enddo
  enddo
  deallocate(cwork)
  deallocate(qwork)
  !
end subroutine comp_r8tor4vec_all
!
subroutine comp_r4tor8vec_all(ndim,key,a,na,b,nb,nvec,myfunc,  &
                                vblank4,eblank4,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Compute the value for common leading dimensions, storing the result
  ! in a 1D vector.
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndim     !
  character(len=*),           intent(in)    :: key      !
  real(kind=4),               intent(in)    :: a(*)     !
  integer(kind=index_length), intent(in)    :: na(7)    !
  real(kind=8),               intent(out)   :: b(*)     !
  integer(kind=index_length), intent(in)    :: nb(7)    !
  integer(kind=size_length),  intent(in)    :: nvec   !
  external                                  :: myfunc   !
  real(kind=4),               intent(in)    :: vblank4  !
  real(kind=4),               intent(in)    :: eblank4  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='comp_r4tor8vec_all'
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6
  integer(kind=size_length) :: ioff,boff,dima,ncommon
  real(kind=4), allocatable :: cwork(:)
  real(kind=4), allocatable :: qwork(:)
  integer :: i,ier
  integer(kind=size_length) :: iq
  !
  if (ndim.lt.0 .or. ndim.gt.6) then
    call sic_message(seve%e,rname,'Internal error')
    error = .true.
    return
  endif
  ncommon = 1
  do i=1,ndim
    ncommon = ncommon*nb(i)
  enddo
  dima = 1
  do i=ndim+1,7
    dima = dima*na(i)
  enddo
  !
  allocate(qwork(nvec),stat=ier)
  if (failed_allocate(key,'qwork',ier,error))  return
  if (ndim.eq.0) then
    call myfunc(a,dima,vblank4,eblank4,qwork,nvec,error)
    if (error) then
      deallocate(qwork)
      return
    endif
    do iq=1,nvec
      call r4tor8(qwork(iq),b(iq),1)
    enddo
    deallocate(qwork)
    return
  endif
  !
  allocate(cwork(dima),stat=ier)
  if (failed_allocate(key,'cwork',ier,error)) then
    deallocate(qwork)
    return
  endif
  do ioff=1,ncommon
    call decode_reduce_indices(ndim,nb,ioff,i1,i2,i3,i4,i5,i6)
    call collect_w4tow4(ndim,a,na(1),na(2),na(3),na(4),na(5),na(6),na(7),  &
      cwork,i1,i2,i3,i4,i5,i6)
    call myfunc(cwork,dima,vblank4,eblank4,qwork,nvec,error)
    if (error)  exit
    do iq=1,nvec
      boff = ioff+(iq-1)*ncommon
      call r4tor8(qwork(iq),b(boff),1)
    enddo
  enddo
  deallocate(cwork)
  deallocate(qwork)
  !
end subroutine comp_r4tor8vec_all
!
subroutine decode_reduce_indices(ndim,nb,ioff,i1,i2,i3,i4,i5,i6)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Decode a 1-based linear offset in the common output dimensions.
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)  :: ndim
  integer(kind=index_length), intent(in)  :: nb(7)
  integer(kind=size_length),  intent(in)  :: ioff
  integer(kind=index_length), intent(out) :: i1,i2,i3,i4,i5,i6
  ! Local
  integer(kind=size_length) :: work,dim
  !
  i1 = 1
  i2 = 1
  i3 = 1
  i4 = 1
  i5 = 1
  i6 = 1
  work = ioff-1
  if (ndim.ge.1) then
    dim = nb(1)
    i1 = int(mod(work,dim),kind=index_length)+1
    work = work/dim
  endif
  if (ndim.ge.2) then
    dim = nb(2)
    i2 = int(mod(work,dim),kind=index_length)+1
    work = work/dim
  endif
  if (ndim.ge.3) then
    dim = nb(3)
    i3 = int(mod(work,dim),kind=index_length)+1
    work = work/dim
  endif
  if (ndim.ge.4) then
    dim = nb(4)
    i4 = int(mod(work,dim),kind=index_length)+1
    work = work/dim
  endif
  if (ndim.ge.5) then
    dim = nb(5)
    i5 = int(mod(work,dim),kind=index_length)+1
    work = work/dim
  endif
  if (ndim.ge.6) then
    dim = nb(6)
    i6 = int(mod(work,dim),kind=index_length)+1
  endif
  !
end subroutine decode_reduce_indices
!
subroutine collect_w4tow4(ndim,a,n1,n2,n3,n4,n5,n6,n7,w,j1,j2,j3,j4,j5,j6)
  use sic_interfaces, except_this=>collect_w4tow4
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !  Word-to-word collection of dimensions. Type is not relevant, use
  ! integer type (avoid IEEE floats because bits in NaN values may not
  ! preserved during copy)
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)  :: ndim
  integer(kind=index_length), intent(in)  :: n1,n2,n3,n4,n5,n6,n7
  real(kind=4),               intent(in)  :: a(n1,n2,n3,n4,n5,n6,n7)
  real(kind=4),               intent(out) :: w(*)
  integer(kind=index_length), intent(in)  :: j1,j2,j3,j4,j5,j6
  ! Local
  integer(kind=index_length) :: i2,i3,i4,i5,i6,i7
  integer(kind=size_length) :: ioff
  !
  if (ndim.eq.1) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            do i3=1,n3
              do i2=1,n2
                ioff = (i7-1)*n6*n5*n4*n3*n2 + &
                       (i6-1)*n5*n4*n3*n2 + &
                       (i5-1)*n4*n3*n2 + &
                       (i4-1)*n3*n2 +  &
                       (i3-1)*n2 + i2
                w(ioff)=a(j1,i2,i3,i4,i5,i6,i7)
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.2) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            do i3=1,n3
              ioff = (i7-1)*n6*n5*n4*n3 +  &
                     (i6-1)*n5*n4*n3 +  &
                     (i5-1)*n4*n3 +  &
                     (i4-1)*n3 + i3
              w(ioff)=a(j1,j2,i3,i4,i5,i6,i7)
            enddo
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.3) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            ioff = (i7-1)*n6*n5*n4 +  &
                   (i6-1)*n5*n4 +  &
                   (i5-1)*n4 + i4
            w(ioff)=a(j1,j2,j3,i4,i5,i6,i7)
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.4) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          ioff = (i7-1)*n6*n5 +  &
                 (i6-1)*n5 + i5
          w(ioff)=a(j1,j2,j3,j4,i5,i6,i7)
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.5) then
    do i7=1,n7
      do i6=1,n6
        ioff = (i7-1)*n6 + i6
        w(ioff)=a(j1,j2,j3,j4,j5,i6,i7)
      enddo
    enddo
    !
  elseif (ndim.eq.6) then
    do i7=1,n7
      ioff = i7
      w(ioff)=a(j1,j2,j3,j4,j5,j6,i7)
    enddo
    !
  endif
  !
end subroutine collect_w4tow4
!
subroutine collect_w8tow8(ndim,a,n1,n2,n3,n4,n5,n6,n7,w,j1,j2,j3,j4,j5,j6)
  use sic_interfaces, except_this=>collect_w8tow8
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !  Word-to-word collection of dimensions. Type is not relevant, use
  ! integer type (avoid IEEE floats because bits in NaN values may not
  ! preserved during copy)
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)  :: ndim
  integer(kind=index_length), intent(in)  :: n1,n2,n3,n4,n5,n6,n7
  real(kind=8),               intent(in)  :: a(n1,n2,n3,n4,n5,n6,n7)
  real(kind=8),               intent(out) :: w(*)
  integer(kind=index_length), intent(in)  :: j1,j2,j3,j4,j5,j6
  ! Local
  integer(kind=index_length) :: i2,i3,i4,i5,i6,i7
  integer(kind=size_length) :: ioff
  !
  if (ndim.eq.1) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            do i3=1,n3
              do i2=1,n2
                ioff = (i7-1)*n6*n5*n4*n3*n2 + &
                       (i6-1)*n5*n4*n3*n2 + &
                       (i5-1)*n4*n3*n2 + &
                       (i4-1)*n3*n2 +  &
                       (i3-1)*n2 + i2
                w(ioff)=a(j1,i2,i3,i4,i5,i6,i7)
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.2) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            do i3=1,n3
              ioff = (i7-1)*n6*n5*n4*n3 +  &
                     (i6-1)*n5*n4*n3 +  &
                     (i5-1)*n4*n3 +  &
                     (i4-1)*n3 + i3
              w(ioff)=a(j1,j2,i3,i4,i5,i6,i7)
            enddo
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.3) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            ioff = (i7-1)*n6*n5*n4 +  &
                   (i6-1)*n5*n4 +  &
                   (i5-1)*n4 + i4
            w(ioff)=a(j1,j2,j3,i4,i5,i6,i7)
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.4) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          ioff = (i7-1)*n6*n5 +  &
                 (i6-1)*n5 + i5
          w(ioff)=a(j1,j2,j3,j4,i5,i6,i7)
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.5) then
    do i7=1,n7
      do i6=1,n6
        ioff = (i7-1)*n6 + i6
        w(ioff)=a(j1,j2,j3,j4,j5,i6,i7)
      enddo
    enddo
    !
  elseif (ndim.eq.6) then
    do i7=1,n7
      ioff = i7
      w(ioff)=a(j1,j2,j3,j4,j5,j6,i7)
    enddo
    !
  endif
  !
end subroutine collect_w8tow8
!
subroutine collect_r8tor4(ndim,a,n1,n2,n3,n4,n5,n6,n7,w,j1,j2,j3,j4,j5,j6)
  use sic_interfaces, except_this=>collect_r8tor4
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !  real(kind=8)-to-real(kind=4) collection of dimensions (including float
  ! conversion at the same time).
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)  :: ndim
  integer(kind=index_length), intent(in)  :: n1,n2,n3,n4,n5,n6,n7
  real(kind=8),               intent(in)  :: a(n1,n2,n3,n4,n5,n6,n7)
  real(kind=4),               intent(out) :: w(*)
  integer(kind=index_length), intent(in)  :: j1,j2,j3,j4,j5,j6
  ! Local
  integer(kind=index_length) :: i2,i3,i4,i5,i6,i7
  integer(kind=size_length) :: ioff
  !
  if (ndim.eq.1) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            do i3=1,n3
              do i2=1,n2
                ioff = (i7-1)*n6*n5*n4*n3*n2 + &
                       (i6-1)*n5*n4*n3*n2 + &
                       (i5-1)*n4*n3*n2 + &
                       (i4-1)*n3*n2 +  &
                       (i3-1)*n2+i2
                w(ioff)=a(j1,i2,i3,i4,i5,i6,i7)
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.2) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            do i3=1,n3
              ioff = (i7-1)*n6*n5*n4*n3 +  &
                     (i6-1)*n5*n4*n3 +  &
                     (i5-1)*n4*n3 +  &
                     (i4-1)*n3 + i3
              w(ioff)=a(j1,j2,i3,i4,i5,i6,i7)
            enddo
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.3) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          do i4=1,n4
            ioff = (i7-1)*n6*n5*n4 +  &
                   (i6-1)*n5*n4 +  &
                   (i5-1)*n4 + i4
            w(ioff)=a(j1,j2,j3,i4,i5,i6,i7)
          enddo
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.4) then
    do i7=1,n7
      do i6=1,n6
        do i5=1,n5
          ioff = (i7-1)*n6*n5 +  &
                 (i6-1)*n5 + i5
          w(ioff)=a(j1,j2,j3,j4,i5,i6,i7)
        enddo
      enddo
    enddo
    !
  elseif (ndim.eq.5) then
    do i7=1,n7
      do i6=1,n6
        ioff = (i7-1)*n6 + i6
        w(ioff)=a(j1,j2,j3,j4,j5,i6,i7)
      enddo
    enddo
    !
  elseif (ndim.eq.6) then
    do i7=1,n7
      ioff = i7
      w(ioff)=a(j1,j2,j3,j4,j5,j6,i7)
    enddo
    !
  endif
  !
end subroutine collect_r8tor4
!
subroutine comp_r4_mean(x,n,vblank4,eblank4,out)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>comp_r4_mean
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar MEAN InVar  (single precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=4),              intent(in)  :: vblank4  !
  real(kind=4),              intent(in)  :: eblank4  !
  real(kind=4),              intent(out) :: out      ! Output scalar value
  !
  call gr4_mean(x,n,vblank4,eblank4,out)
end subroutine comp_r4_mean
!
subroutine comp_r4_sum(x,n,vblank4,eblank4,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>comp_r4_sum
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar SUM InVar  (single precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=4),              intent(in)  :: vblank4  !
  real(kind=4),              intent(in)  :: eblank4  !
  real(kind=4),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,count
  real(kind=4) :: nan
  real(kind=4) :: lastchanceretval
  real(kind=8) :: out8  ! Temporary real(kind=8) sum to avoid sum loss in real(kind=4)
  !
  if (eblank4.ge.0) then
    lastchanceretval=vblank4
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  out8 = 0.d0
  count = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(n,x,vblank4,eblank4,count,out8) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(+:out8) REDUCTION(+:count)
  do i=1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        out8 = out8 + x(i)
        count = count+1
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          out8 = out8 + x(i)
          count = count+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (count.le.0) then
    out = lastchanceretval
  else
    out = real(out8,kind=4)
  endif
end subroutine comp_r4_sum
!
subroutine comp_r4_prod(x,n,vblank4,eblank4,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>comp_r4_prod
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar PRODUCT InVar  (single precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=4),              intent(in)  :: vblank4  !
  real(kind=4),              intent(in)  :: eblank4  !
  real(kind=4),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,count
  real(kind=4) :: nan
  real(kind=4) :: lastchanceretval
  !
  if (eblank4.ge.0) then
    lastchanceretval=vblank4
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  if (x(1).eq.x(1)) then
    if (eblank4.lt.0) then
      out = x(1)
      count = 1
    else
      if (abs(x(1)-vblank4).gt.eblank4) then
        out = x(1)
        count = 1
      else
        out = 1.0              !Neutral Element for Prod...
        count = 0
      endif
    endif
  else
    out = 1.0                  !Neutral Element for Prod...
    count = 0
  endif
  !
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(n,x,vblank4,eblank4,count,out) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(*:out) REDUCTION(+:count)
  do i=2,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        out = out * x(i)
        count = count+1
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          out = out * x(i)
          count = count+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (count.le.0) then
    out = lastchanceretval
  endif
end subroutine comp_r4_prod
!
subroutine comp_r4_max(x,n,vblank4,eblank4,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Support routine for command
  !   COMPUTE OutVar MAX InVar  (single precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=4),              intent(in)  :: vblank4  !
  real(kind=4),              intent(in)  :: eblank4  !
  real(kind=4),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,j,count
  real(kind=4) :: nan
  real(kind=4) :: lastchanceretval
  !
  if (eblank4.ge.0) then
    lastchanceretval=vblank4
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  count = 0
  do i=1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        count = 1
        out = x(i)
        j = i
        goto 1
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          count = 1
          out = x(i)
          j = i
          goto 1
        endif
      endif
    endif
  enddo
1 continue
  if (count.le.0) then
    out = lastchanceretval
    return
  endif
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(j,n,x,vblank4,eblank4,out) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(MAX:out)
  do i=j+1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        out = max(out,x(i))
        ! count = count+1  (Unused)
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          out = max(out,x(i))
          ! count = count+1  (Unused)
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine comp_r4_max
!
subroutine comp_r4_min(x,n,vblank4,eblank4,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Support routine for command
  !   COMPUTE OutVar MIN InVar  (single precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=4),              intent(in)  :: vblank4  !
  real(kind=4),              intent(in)  :: eblank4  !
  real(kind=4),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,j,count
  real(kind=4) :: nan
  real(kind=4) :: lastchanceretval
  !
  if (eblank4.ge.0) then
    lastchanceretval=vblank4
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  count = 0
  do i=1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        count = 1
        out = x(i)
        j = i
        goto 1
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          count = 1
          out = x(i)
          j = i
          goto 1
        endif
      endif
    endif
  enddo
1 continue
  if (count.le.0) then
    out = lastchanceretval
    return
  endif
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(j,n,x,vblank4,eblank4,out) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(MIN:out)
  do i=j+1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        out = min(out,x(i))
        ! count = count+1  (Unused)
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          out = min(out,x(i))
          ! count = count+1  (Unused)
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine comp_r4_min
!
subroutine comp_r4_rms (x,n,vblank4,eblank4,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>comp_r4_rms
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar RMS InVar  (single precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=4),              intent(in)  :: vblank4  !
  real(kind=4),              intent(in)  :: eblank4  !
  real(kind=4),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,count
  real(kind=4) :: nan
  real(kind=4) :: s0,s1
  real(kind=8) :: s8  ! Temporary real(kind=8) sum to avoid sum loss in real(kind=4)
  real(kind=4) :: lastchanceretval
  !
  if (eblank4.ge.0) then
    lastchanceretval=vblank4
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  out = 0.0
  !
  s8 = 0.d0
  count = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(n,x,vblank4,eblank4,count,s8) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(+:s8) REDUCTION(+:count)
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank4.ge.0) then
        if (abs(x(i)-vblank4).gt.eblank4) then
          s8 = s8+x(i)
          count = count+1
        endif
      else
        s8 = s8+x(i)
        count = count+1
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (count.gt.0) then
    s0 = s8/dble(count)
  else
    out = lastchanceretval
    return
  endif
  !
  s1 = 0.
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(n,x,vblank4,eblank4,s0,s1) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(+:s1)
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        s1 = s1 + (x(i)-s0)**2
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          s1 = s1 + (x(i)-s0)**2
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  s1 = s1/dble(count)
  out = sqrt (s1)
end subroutine comp_r4_rms
!
subroutine comp_r4_median(x,n,vblank4,eblank4,out)
  use sic_interfaces, except_this=>comp_r4_median
  use gildas_def
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar MEDIAN InVar  (single precision)
  ! If Blanking enabled, will return blanking value if no valid result.
  ! If Blanking is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=4),              intent(in)  :: vblank4  !
  real(kind=4),              intent(in)  :: eblank4  !
  real(kind=4),              intent(out) :: out      ! Output scalar value
  ! Local
  real(kind=4) :: nan,lastchanceretval
  logical :: error
  !
  if (eblank4.ge.0.) then
    lastchanceretval=vblank4
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  error = .false.
  call gr4_median(x,n,vblank4,eblank4,out,error)
  !
end subroutine comp_r4_median
!
subroutine comp_r4_quantile(x,n,vblank4,eblank4,quant,nquant,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar QUANTILE InVar  (single precision)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: n              ! Number of values
  real(kind=4),              intent(in)    :: x(n)           ! Data values
  real(kind=4),              intent(in)    :: vblank4        !
  real(kind=4),              intent(in)    :: eblank4        !
  integer(kind=size_length), intent(in)    :: nquant         ! Number of quantiles
  real(kind=4),              intent(out)   :: quant(nquant)  ! Output values
  logical,                   intent(inout) :: error          !
  ! Local
  real(kind=4) :: nan,lastchanceretval
  !
  if (eblank4.ge.0.) then
    lastchanceretval = vblank4
  else
    call gag_notanum(nan)
    lastchanceretval = nan
  endif
  quant(:) = lastchanceretval
  !
  call gr4_quantile(x,n,vblank4,eblank4,quant,nquant,error)
  if (error)  return
end subroutine comp_r4_quantile
!
subroutine comp_r8_mean(x,n,vblank8,eblank8,out)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>comp_r8_mean
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar MEAN InVar  (double precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=8),              intent(in)  :: vblank8  !
  real(kind=8),              intent(in)  :: eblank8  !
  real(kind=8),              intent(out) :: out      ! Output scalar value
  !
  call gr8_mean(x,n,vblank8,eblank8,out)
end subroutine comp_r8_mean
!
subroutine comp_r8_sum(x,n,vblank8,eblank8,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>comp_r8_sum
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar SUM InVar  (double precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=8),              intent(in)  :: vblank8  !
  real(kind=8),              intent(in)  :: eblank8  !
  real(kind=8),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,count
  real(kind=4) :: nan
  real(kind=8) :: lastchanceretval
  !
  if (eblank8.ge.0) then
    lastchanceretval=vblank8
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  out = 0.0
  count = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(n,x,vblank8,eblank8,count,out) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(+:out) REDUCTION(+:count)
  do i=1,n
    if (x(i).eq.x(i)) then
      if (eblank8.lt.0) then
        out = out + x(i)
        count = count+1
      else
        if (abs(x(i)-vblank8).gt.eblank8) then
          out = out + x(i)
          count = count+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (count.le.0) then
    out = lastchanceretval
  endif
end subroutine comp_r8_sum
!
subroutine comp_r8_prod(x,n,vblank8,eblank8,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>comp_r8_prod
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar PRODUCT InVar  (double precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=8),              intent(in)  :: vblank8  !
  real(kind=8),              intent(in)  :: eblank8  !
  real(kind=8),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,count
  real(kind=4) :: nan
  real(kind=8) :: lastchanceretval
  !
  if (eblank8.ge.0) then
    lastchanceretval=vblank8
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  if (x(1).eq.x(1)) then
    if (eblank8.lt.0) then
      out = x(1)
      count = 1
    else
      if (abs(x(1)-vblank8).gt.eblank8) then
        out = x(1)
        count = 1
      else
        out = 1.0              !Neutral Element for Prod...
        count = 0
      endif
    endif
  else
    out = 1.0                  !Neutral Element for Prod...
    count = 0
  endif
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(n,x,vblank8,eblank8,count,out) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(*:out) REDUCTION(+:count)
  do i=2,n
    if (x(i).eq.x(i)) then
      if (eblank8.lt.0) then
        out = out * x(i)
        count = count+1
      else
        if (abs(x(i)-vblank8).gt.eblank8) then
          out = out * x(i)
          count = count+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (count.le.0) then
    out = lastchanceretval
  endif
end subroutine comp_r8_prod
!
subroutine comp_r8_max(x,n,vblank8,eblank8,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Support routine for command
  !   COMPUTE OutVar MAX InVar  (double precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=8),              intent(in)  :: vblank8  !
  real(kind=8),              intent(in)  :: eblank8  !
  real(kind=8),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,j,count
  real(kind=4) :: nan
  real(kind=8) :: lastchanceretval
  !
  if (eblank8.ge.0) then
    lastchanceretval=vblank8
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  count = 0
  do i=1,n
    if (x(i).eq.x(i)) then
      if (eblank8.lt.0) then
        count = 1
        out = x(i)
        j = i
        goto 1
      else
        if (abs(x(i)-vblank8).gt.eblank8) then
          count = 1
          out = x(i)
          j = i
          goto 1
        endif
      endif
    endif
  enddo
1 continue
  if (count.le.0) then
    out = lastchanceretval
    return
  endif
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(j,n,x,vblank8,eblank8,out) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(MAX:out)
  do i=j+1,n
    if (x(i).eq.x(i)) then
      if (eblank8.lt.0) then
        out = max(out,x(i))
        ! count = count+1  (Unused)
      else
        if (abs(x(i)-vblank8).gt.eblank8) then
          out = max(out,x(i))
          ! count = count+1  (Unused)
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine comp_r8_max
!
subroutine comp_r8_min (x,n,vblank8,eblank8,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Support routine for command
  !   COMPUTE OutVar MIN InVar  (double precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=8),              intent(in)  :: vblank8  !
  real(kind=8),              intent(in)  :: eblank8  !
  real(kind=8),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,j,count
  real(kind=4) :: nan
  real(kind=8) :: lastchanceretval
  !
  if (eblank8.ge.0) then
    lastchanceretval=vblank8
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  count = 0
  do i=1,n
    if (x(i).eq.x(i)) then
      if (eblank8.lt.0) then
        count = 1
        out = x(i)
        j = i
        goto 1
      else
        if (abs(x(i)-vblank8).gt.eblank8) then
          count = 1
          out = x(i)
          j = i
          goto 1
        endif
      endif
    endif
  enddo
1 continue
  if (count.le.0) then
    out = lastchanceretval
    return
  endif
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(j,n,x,vblank8,eblank8,out) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(MIN:out)
  do i=j+1,n
    if (x(i).eq.x(i)) then
      if (eblank8.lt.0) then
        out = min(out,x(i))
        ! count = count+1  (Unused)
      else
        if (abs(x(i)-vblank8).gt.eblank8) then
          out = min(out,x(i))
          ! count = count+1  (Unused)
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine comp_r8_min
!
subroutine comp_r8_rms (x,n,vblank8,eblank8,out)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>comp_r8_rms
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar RMS InVar  (double precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=8),              intent(in)  :: vblank8  !
  real(kind=8),              intent(in)  :: eblank8  !
  real(kind=8),              intent(out) :: out      ! Output scalar value
  ! Local
  integer(kind=size_length) :: i,count
  real(kind=4) :: nan
  real(kind=8) :: s0,s1
  real(kind=8) :: lastchanceretval
  !
  if (eblank8.ge.0) then
    lastchanceretval=vblank8
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  out = 0.0
  !
  s0 = 0.
  count = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(n,x,vblank8,eblank8,count,s0) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(+:s0) REDUCTION(+:count)
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank8.ge.0) then
        if (abs(x(i)-vblank8).gt.eblank8) then
          s0 = s0+x(i)
          count = count+1
        endif
      else
        s0 = s0+x(i)
        count = count+1
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (count.gt.0) then
    s0 = s0/dble(count)
  else
    out = lastchanceretval
    return
  endif
  !
  s1 = 0.
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(n,x,vblank8,eblank8,s0,s1) &
  !$OMP PRIVATE(i)
  !$OMP DO REDUCTION(+:s1)
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank8.lt.0) then
        s1 = s1 + (x(i)-s0)**2
      else
        if (abs(x(i)-vblank8).gt.eblank8) then
          s1 = s1 + (x(i)-s0)**2
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  s1 = s1/dble(count)
  out = sqrt (s1)
end subroutine comp_r8_rms
!
subroutine comp_r8_median(x,n,vblank8,eblank8,out)
  use sic_interfaces, except_this=>comp_r8_median
  use gildas_def
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar MEDIAN InVar  (double precision)
  ! If Blanking enabled, will return blanking value if no valid result.
  ! If Blanking is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: x(*)     ! Data values to compute
  integer(kind=size_length), intent(in)  :: n        ! Number of data values
  real(kind=8),              intent(in)  :: vblank8  !
  real(kind=8),              intent(in)  :: eblank8  !
  real(kind=8),              intent(out) :: out      ! Output scalar value
  ! Local
  real(kind=4) :: nan
  real(kind=8) :: lastchanceretval
  logical :: error
  !
  if (eblank8.ge.0.d0) then
    lastchanceretval=vblank8
  else
    call gag_notanum(nan)
    lastchanceretval=nan
  endif
  out = lastchanceretval
  if (n.lt.1) return
  !
  error = .false.
  call gr8_median(x,n,vblank8,eblank8,out,error)
  !
end subroutine comp_r8_median
!
subroutine comp_r8_quantile(x,n,vblank8,eblank8,quant,nquant,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar QUANTILE InVar  (double precision)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: n              ! Number of values
  real(kind=8),              intent(in)    :: x(n)           ! Data values
  real(kind=8),              intent(in)    :: vblank8        !
  real(kind=8),              intent(in)    :: eblank8        !
  integer(kind=size_length), intent(in)    :: nquant         ! Number of quantiles
  real(kind=8),              intent(out)   :: quant(nquant)  ! Output values
  logical,                   intent(inout) :: error          !
  ! Local
  real(kind=8) :: nan,lastchanceretval
  !
  if (eblank8.ge.0.) then
    lastchanceretval = vblank8
  else
    call gag_notanum(nan)
    lastchanceretval = nan
  endif
  quant(:) = lastchanceretval
  !
  call gr8_quantile(x,n,vblank8,eblank8,quant,nquant,error)
  if (error)  return
end subroutine comp_r8_quantile

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_truncate
  use gbl_message
  !
  public :: uv_truncate_comm
  private
  !
contains
  !
  subroutine uv_truncate_comm(line,error)
    use image_def
    use gkernel_interfaces
    use file_buffers
    use uv_buffers
    !---------------------------------------------------------------------
    ! Truncate a UV Table, by removing baselines out of
    ! a given range (Min and Max)
    !
    ! UV_TRUNCATE Max [Min]
    !
    ! Works on the "current" UV data set: Uses UVS or UVR as needed.
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    real(4) :: mymax, mymin, rmin, rmax, length
    integer :: iv, kv, ier
    integer :: nu, nv
    type (gildas) :: hcuv
    real, pointer :: duv_previous(:,:), duv_next(:,:)
    integer, allocatable :: point(:)
    character(len=80) :: mess
    character(len=*), parameter :: rname='UV_TRUNCATE'
    !
    call sic_r4(line,0,1,mymax,.true.,error)
    if (error) return
    !
    mymin = 0.
    call sic_r4(line,0,2,mymin,.false.,error)
    if (error) return
    !
    ! The UV table is available in HUV%
    if (huv%loca%size.eq.0) then
       call map_message(seve%e,rname,'No UV data loaded')
       error = .true.
       return
    endif
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    !
    ! Read the Baseline length information
    allocate (point(nv), stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error')
       error = .true.
       return
    endif
    !
    rmin = mymin**2
    rmax = mymax**2
    !
    kv = 0
    do iv = 1, nv
       length = duv(1,iv)**2 + duv(2,iv)**2
       if (length.ge.rmin .and. length.le.rmax) then
          kv = kv+1
          point(kv) = iv
       endif
    enddo
    !
    ! Prepare header and allocate buffers
    call gildas_null(hcuv,type='UVT')
    call gdf_copy_header(huv,hcuv,error)
    hcuv%gil%dim(2) = kv
    hcuv%gil%nvisi = kv
    nullify (duv_previous, duv_next)
    call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
    if (error) return
    !
    ! Now do the job
    do iv = 1,kv
       duv_next(:,iv) = duv(:,point(iv))
    enddo
    !
    ! Finalize the UV Table
    write(mess,'(i12,a,i12,a)') hcuv%gil%nvisi,' Visibilities created (', &
         & huv%gil%nvisi,' before)'
    call map_message(seve%i,rname,mess)
    call uv_clean_buffers (duv_previous, duv_next,error)
    if (error) return
    !
    ! Copy back to UV data set
    call gdf_copy_header(hcuv,huv,error)
    !
    ! Indicate Weights have changed, optimization and save status
    do_weig = .true.
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
    ! Redefine SIC variables (mandatory)
    call sic_delvariable ('UV',.false.,error)
    call sic_mapgildas ('UV',huv,error,duv)
  end subroutine uv_truncate_comm
end module uv_truncate
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module class_sort_types
  use gmath_dicho_types
  use class_types
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  ! Type for sorting an index by date, time, and telescope
  type, extends(gi8_dicho_t) :: class_sort_dtt_t
    type(optimize), pointer :: optx
    integer(kind=8) :: searched_entry = 0
  contains
    procedure, public :: compare       => class_sort_compare_dtt
    procedure, public :: compare_value => class_sort_compare_dtt_value
  end type class_sort_dtt_t
  !
contains
  !
  function class_sort_compare_dtt(self,m,l)
    !-------------------------------------------------------------------
    ! Compare first by DOBS, then by UT, then by TELES
    !-------------------------------------------------------------------
    integer(kind=4) :: class_sort_compare_dtt
    class(class_sort_dtt_t), intent(in) :: self
    integer(kind=8),         intent(in) :: m,l
    if (self%optx%dobs(m).ne.self%optx%dobs(l)) then
      if (self%optx%dobs(m).gt.self%optx%dobs(l)) then
        class_sort_compare_dtt = 1
      else
        class_sort_compare_dtt = -1
      endif
      return
    endif
    if (self%optx%ut(m).ne.self%optx%ut(l)) then
      if (self%optx%ut(m).gt.self%optx%ut(l)) then
        class_sort_compare_dtt = 1
      else
        class_sort_compare_dtt = -1
      endif
      return
    endif
    if (self%optx%ctele(m).eq.self%optx%ctele(l)) then
      class_sort_compare_dtt = 0
    elseif (lgt(self%optx%ctele(m),self%optx%ctele(l))) then
      class_sort_compare_dtt = 1
    else
      class_sort_compare_dtt = -1
    endif
  end function class_sort_compare_dtt
  !
  function class_sort_compare_dtt_value(self,m)
    !-------------------------------------------------------------------
    ! Compare the m-th entry to the searched entry
    !-------------------------------------------------------------------
    integer(kind=4) :: class_sort_compare_dtt_value
    class(class_sort_dtt_t), intent(in) :: self
    integer(kind=8),         intent(in) :: m
    class_sort_compare_dtt_value = self%compare(m,self%searched_entry)
  end function class_sort_compare_dtt_value
end module class_sort_types
!
subroutine fix(set,idx,lx,nfound,error,erange,more)
  use phys_const
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fix
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Search in the input index for entries matching the parameters in
  ! flg% and smin%/smax%. Selected entries are appended to the output
  ! index (it is the responsibility of the caller to check for
  ! duplicates between old and new entries).
  !---------------------------------------------------------------------
  type(class_setup_t),        intent(in)           :: set        !
  type(optimize),             intent(in)           :: idx        ! The index to search in
  type(optimize),             intent(inout)        :: lx         ! The optimize'd index to be updated
  integer(kind=entry_length), intent(out)          :: nfound     ! Number of observations actually found
  logical,                    intent(inout)        :: error      ! Error status
  integer(kind=entry_length), intent(in), optional :: erange(2)  ! Entry range to search in (default all)
  integer(kind=entry_length), intent(in), optional :: more       ! Size of allocation extension
  ! Local
  character(len=*), parameter :: rname='FIX'
  logical :: lire
  integer(kind=4) :: tver
  integer(kind=entry_length) :: iobs,inew,jnew,k,ient,extend
  real(kind=4) :: r,any
  type(observation) :: obs
  logical :: readsec(-mx_sec:0)  ! Which section are to be read
  logical :: readobs,readhead,found
  type(indx_t) :: ind
  type(time_t) :: time
  !
  ! Set the range of entries to search in
  if (present(erange)) then
    inew = erange(1)
    jnew = erange(2)
  else
    inew = 1
    jnew = idx%next-1
  endif
  !
  if (jnew.lt.inew) then
    ! Input index is empty (or erange has null size): nothing can be found.
    ! lx%next unmodified (caller could be working in append mode)
    nfound = 0
    return
  endif
  !
  ! Set the size of allocation extension.
  if (present(more)) then
    ! Caller thinks he knows how many entries will be found here
    extend = more
  else
    ! Default is to enlarge lx so that is can store all the range of
    ! entries
    extend = jnew-inew+1
  endif
  ! Enlarge lx size so that it can append all the found entries
  call reallocate_optimize(lx,lx%next-1+extend,.true.,.true.,error)
  if (error) return
  !
  call chtoby('ANY ',any,4)
  !
  k = 0
  lire = flg%dobs.or.flg%dred.or.flg%posa
! lire = flg%line.or.flg%sourc.or.flg%teles.or.flg%dobs.or.flg%dred   &
!    .or.flg%off1.or.flg%off2.or.flg%scan.or.flg%subscan.or.flg%posa
  !
  ! readhead: need to read the entry descriptor and header
  readhead = flg%freq .or. flg%user .or. flg%dopos .or.  &
             flg%doswitch .or. flg%dodri .or. flg%dodir
  ! readobs: need to read the entry descriptor
  readobs  = flg%sect .or. readhead
  if (readobs) then
    call init_obs(obs)
    if (readhead) then
      readsec(:) = .false.  ! Read none...
      readsec(class_sec_spe_id)  = flg%freq                  ! except spectroscopic section
      readsec(class_sec_pos_id)  = flg%dopos                 ! and position section
      readsec(class_sec_swi_id)  = flg%doswitch              ! and switching section
      readsec(class_sec_dri_id)  = flg%dodri .or. flg%dodir  ! and drift section
      readsec(class_sec_user_id) = flg%user                  ! and user section (if any)
    endif
  endif
  !
  ! Loop on entries
  call gtime_init(time,jnew-inew+1,error)
  if (error)  return
  do iobs = inew,jnew
     ient = idx%ind(iobs)
     if (sic_ctrlc()) then
       call class_message(seve%w,rname,'Aborted by ^C, index may be incomplete')
       exit
     endif
     if (lire .or. readobs) then
        ! In these cases the informations are not in the input index in memory
        ! * lire = information is the input index on disk (was not saved in
        !          memory),
        ! * readobs = information is in the entry descriptor or in the entry on
        !             disk.
        ! This takes much more time, let's give feedback.
        call gtime_current(time)
     endif
     !
     ! General search in memory
     call index_fromoptimize(idx,iobs,ind,error)
     if (error)  return
     !
     if (flg%kind) then
       if (ind%kind.ne.smin%kind) cycle
     endif
     if (ind%qual.gt.smin%qual) cycle
     if (flg%last) then
        if (ind%ver.lt.0) cycle
     endif
     if (flg%num) then
        if (ind%num.lt.smin%num .or. ind%num.gt.smax%num) cycle
     endif
     if (flg%ver) then
        tver = abs(ind%ver)
        if (tver.lt.smin%ver .or. tver.gt.smax%ver) cycle
     endif
     if (flg%sourc) then
        if (flg%isourc.ge.1) then  ! There is a '*' in the source name
           if (.not.match_string(ind%csour,smin%csour)) cycle
        else
           if (ind%csour.ne.smin%csour) cycle
        endif
     endif
     if (flg%line) then
        if (flg%iline.ge.1) then  ! There is a '*' in the line name
           if (.not.match_string(ind%cline,smin%cline)) cycle
        else
           if (ind%cline.ne.smin%cline) cycle
        endif
     endif
     if (flg%teles) then
        if (flg%iteles.ge.1) then  ! There is a '*' in the telescope name
           if (.not.match_string(ind%ctele,smin%ctele)) cycle
        else
           if (ind%ctele.ne.smin%ctele) cycle
        endif
     endif
     if (flg%off1) then
        if (ind%off1.lt.smin%off1 .and. smin%off1.ne.any) cycle
        if (ind%off1.gt.smax%off1 .and. smax%off1.ne.any) cycle
     endif
     if (flg%off2) then
        if (ind%off2.lt.smin%off2 .and. smin%off2.ne.any) cycle
        if (ind%off2.gt.smax%off2 .and. smax%off2.ne.any) cycle
     endif
     if (flg%scan) then
        if (ind%scan.lt.smin%scan .or. ind%scan.gt.smax%scan) cycle
     endif
     if (flg%subscan) then
        if (ind%subscan.lt.smin%subscan .or. ind%subscan.gt.smax%subscan) cycle
     endif
     if (flg%dobs) then
        if (ind%dobs.lt.smin%dobs .or. ind%dobs.gt.smax%dobs) cycle
     endif
     if (flg%domask) then
        if (.not.fix_by_mask(ind%off1,ind%off2,flg%mask))  cycle
     endif
     ! The next tests need to read more data in the observation header
     if (readobs) then
        call robs(obs,ient,error)
        if (error)  return
        if (readhead) then
          call rheader_sub(set,obs,readsec,error)
          if (error)  return
        endif
     endif
     if (flg%sect) then
       if (.not.obs%head%presec(flg%sectval))  cycle
     endif
     if (flg%freq) then
        if (.not.fix_by_freq(obs,flg%freqmin,flg%freqmax,flg%freqsig)) cycle
     endif
     if (flg%doswitch) then
        if (.not.fix_by_switch(obs,flg%switch)) cycle
     endif
     if (flg%dodri) then
        if (.not.fix_by_drift(obs,flg%driang,pis)) cycle
     endif
     if (flg%dodir) then
        if (.not.fix_by_drift(obs,flg%dirang,2.*pis)) cycle
     endif
     if (flg%dopos) then
        if (.not.fix_by_posi(obs,flg%poslam,flg%posbet,flg%possys,flg%posequ,set%tole)) cycle
     endif
     if (flg%user) then
        call user_sec_fix(obs,found,error)
        if (error)  return
        if (.not.found)  cycle
     endif
     !
     ! More restrictive search
     if (lire) then
        call rix(ient,ind,error)
        if (error) return
        if (flg%dred) then
           if (ind%dred.lt.smin%dred .or. ind%dred.gt.smax%dred) cycle
        endif
        if (flg%posa) then
           r = mod(ind%posa,pis)
           if (r.lt.smin%posa .or. r.gt.smax%posa) cycle
        endif
     endif
     k = k+1
     !
     ! Update the input index
     if (lx%next.gt.lx%mobs) then
        call class_message(seve%e,rname,'Current Index is full')
        error = .true.
        return
     endif
     call index_tooptimize(ind,ient,.true.,lx%next,lx,error)
     if (error)  return
     lx%next = lx%next + 1
  enddo
  !
  nfound = k
  !
  ! Reset search flags
  flg%last = .true.
  flg%num = .false.
  flg%ver = .false.
  flg%line = .false.
  flg%sourc = .false.
  flg%teles = .false.
  flg%dobs = .false.
  flg%dred = .false.
  flg%off1 = .false.
  flg%off2 = .false.
  flg%freq = .false.
  flg%dopos = .false.
  flg%sect = .false.
  flg%domask = .false.
  flg%doswitch = .false.
  !
end subroutine fix
!
function fix_by_freq(obs,fmin,fmax,fsig)
  use classcore_interfaces, except_this=>fix_by_freq
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  !  Return .true. if the input range intersects the frequency range
  ! of the input observation.
  !---------------------------------------------------------------------
  logical                       :: fix_by_freq  ! Function value on return
  type(observation), intent(in) :: obs          ! Input observation
  real(kind=8),      intent(in) :: fmin         ! Frequency range (min)
  real(kind=8),      intent(in) :: fmax         ! Frequency range (max)
  logical,           intent(in) :: fsig         ! Signal or image frequencies?
  ! Local
  real(kind=8) :: freqmin,freqmax
  !
  if (fsig) then
    ! Signal frequencies
    if (obs%head%spe%fres.gt.0.d0) then
      ! Left side of spectrum:
      call abscissa_sigabs_left(obs%head,freqmin)
      ! Right side of spectrum
      call abscissa_sigabs_right(obs%head,freqmax)
    else
      call abscissa_sigabs_right(obs%head,freqmin)
      call abscissa_sigabs_left(obs%head,freqmax)
    endif
  else
    ! Image frequencies
    if (obs%head%spe%fres.gt.0.d0) then
      call abscissa_imaabs_right(obs%head,freqmin)
      call abscissa_imaabs_left(obs%head,freqmax)
    else
      call abscissa_imaabs_left(obs%head,freqmin)
      call abscissa_imaabs_right(obs%head,freqmax)
    endif
  endif
  !
  if (fmax.lt.0.d0) then
    ! Select from fmin to infinite
    fix_by_freq = freqmax.ge.fmin
  elseif (fmin.lt.0.d0) then
    ! Select from 0 to fmax
    fix_by_freq = freqmin.le.fmax
  else
    ! Select from fmin to fmax (which may be equal)
    fix_by_freq = freqmin.le.fmax .and. freqmax.ge.fmin
  endif
  !
end function fix_by_freq
!
function fix_by_switch(obs,swmode)
  use classcore_interfaces, except_this=>fix_by_switch
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the observation matches the given switching mode
  !---------------------------------------------------------------------
  logical                       :: fix_by_switch ! Function value on return
  type(observation), intent(in) :: obs           ! Input observation
  integer(kind=4),   intent(in) :: swmode        ! Switching mode code
  !
  if (obs%head%presec(class_sec_swi_id)) then
    fix_by_switch = obs%head%swi%swmod.eq.swmode
  else
    fix_by_switch = swmode.eq.mod_unk
  endif
end function fix_by_switch
!
function fix_by_drift(obs,driang,modu)
  use phys_const
  use classcore_interfaces, except_this=>fix_by_drift
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the drift matches the required angle modulo some
  ! angle
  !---------------------------------------------------------------------
  logical                       :: fix_by_drift  ! Function value on return
  type(observation), intent(in) :: obs           ! Input observation
  real(kind=4),      intent(in) :: driang        ! [rad] Drift angle
  real(kind=4),      intent(in) :: modu          ! [rad] Modulo angle
  !
  real(kind=4) :: thisang
  real(kind=4), parameter :: tolerance=1.0*rad_per_min  ! [rad] 1 minute tolerance
  !
  if (obs%head%presec(class_sec_dri_id)) then
    thisang = obs%head%dri%apos
    ! Set angle in range [0,modu[
    do while (thisang.lt.0.)  ! Strictly lower than
      thisang = thisang+modu
    enddo
    do while (thisang.ge.modu)  ! Greater or equal to
      thisang = thisang-modu
    enddo
    fix_by_drift = abs(thisang-driang).le.tolerance
  else
    fix_by_drift = .false.
  endif
end function fix_by_drift
!
function fix_by_posi(obs,reflam,refbet,refsys,refequ,tole)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fix_by_posi
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  !  Return .true. if the observation position matches the reference
  ! position with the given tolerance
  !---------------------------------------------------------------------
  logical                          :: fix_by_posi  ! Function value on return
  type(observation), intent(inout) :: obs          ! Input observation
  real(kind=8),      intent(in)    :: reflam       ! [rad]  Reference lambda position
  real(kind=8),      intent(in)    :: refbet       ! [rad]  Reference beta position
  integer(kind=4),   intent(in)    :: refsys       ! [code] Reference system of coordinates
  real(kind=4),      intent(in)    :: refequ       ! [year] Reference equinox (if relevant)
  real(kind=4),      intent(in)    :: tole         ! [rad]  Tolerance
  ! Local
  character(len=*), parameter :: rname='FIND'
  type(projection_t) :: proj
  real(kind=8) :: rlam,rbet,rxoff,ryoff
  real(kind=4) :: rlamof,rbetof
  logical :: error
  !
  error = .false.
  fix_by_posi = .false.
  !
  ! 1) Convert reference position system to current observation system of
  ! coordinates. NB: conversion routines translate the old absolute reference
  ! to the new absolute reference, and the old offsets (from old reference) to
  ! new offsets (from new reference). If old offsets were 0 (i.e. considering
  ! only the reference position), they are also 0 in the new system! Which is
  ! our case here as we convert the reference position.
  select case (refsys)
  case (type_eq)
    if (obs%head%pos%system.eq.type_eq .and. obs%head%pos%equinox.eq.refequ) then  ! Same system
      rlam = reflam
      rbet = refbet
    elseif (obs%head%pos%system.eq.type_eq .and. obs%head%pos%equinox.ne.refequ) then
      call equ_to_equ(reflam,refbet,0.0,   0.0,   refequ,  &
                      rlam,  rbet,  rlamof,rbetof,obs%head%pos%equinox,error)
    elseif (obs%head%pos%system.eq.type_ga) then
      call equ_to_gal(reflam,refbet,0.0,   0.0,   refequ,  &
                      rlam,  rbet,  rlamof,rbetof,error)
    elseif (obs%head%pos%system.eq.type_ic) then
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and Equatorial system not implemented')
      error = .true.
    endif
  case (type_ga)
    if (obs%head%pos%system.eq.type_ga) then  ! Same system
      rlam = reflam
      rbet = refbet
    elseif (obs%head%pos%system.eq.type_eq) then
      call gal_to_equ(reflam,refbet,0.0,   0.0,  &
                      rlam,  rbet,  rlamof,rbetof,obs%head%pos%equinox,error)
    elseif (obs%head%pos%system.eq.type_ic) then
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and Equatorial system not implemented')
      error = .true.
    endif
  case (type_ic)
    if (obs%head%pos%system.eq.type_ic) then  ! Same system
      rlam = reflam
      rbet = refbet
    else
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and other system not implemented')
      error = .true.
    endif
  case default
    call class_message(seve%e,rname,'Coordinate system not supported')
    error = .true.
  end select
  if (error)  return
  !
  ! 2) Convert absolute reference position to relative position in current
  !    observation projection system
  call gwcs_projec(obs%head%pos%lam,obs%head%pos%bet,obs%head%pos%projang,  &
    obs%head%pos%proj,proj,error)
  if (error)  return
  call abs_to_rel(proj,rlam,rbet,rxoff,ryoff,1)
  !
  ! 3) Compare using tolerance. Same selection as FIND /OFFSET, i.e. selection
  ! in a square, not a circle.
  fix_by_posi = obs%head%pos%lamof.ge.rxoff-tole .and.  &
                obs%head%pos%lamof.le.rxoff+tole .and.  &
                obs%head%pos%betof.ge.ryoff-tole .and.  &
                obs%head%pos%betof.le.ryoff+tole
  !
end function fix_by_posi
!
function fix_by_mask(lamof,betof,mask)
  use image_def
  use classcore_interfaces, except_this=>fix_by_mask
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the observation is selected by the input
  ! position-position mask.
  !  Note there is no consistency checking with the center of
  ! projection, kind of projection, and projection angle. This is the
  ! same feature as FIND /RANGE
  !---------------------------------------------------------------------
  logical :: fix_by_mask  ! Function value on return
  real(kind=4), intent(in) :: lamof,betof  ! Offsets
  type(gildas), intent(in) :: mask         ! The GDF 2D mask
  ! Local
  integer(kind=index_length) :: xc,yc
  integer(kind=4) :: xaxi,yaxi
  !
  xaxi = mask%gil%xaxi
  yaxi = mask%gil%yaxi
  !
  xc = nint((lamof-mask%gil%val(xaxi))/mask%gil%inc(xaxi)+mask%gil%ref(xaxi),kind=8)
  yc = nint((betof-mask%gil%val(yaxi))/mask%gil%inc(yaxi)+mask%gil%ref(yaxi),kind=8)
  !
  ! Out of area = not selected
  ! Negative or null value = not selected
  ! Blank value = not selected
  fix_by_mask = xc.ge.1                   .and.  &
                xc.le.mask%gil%dim(xaxi)  .and.  &
                yc.ge.1                   .and.  &
                yc.le.mask%gil%dim(yaxi)  .and.  &
                mask%r2d(xc,yc).gt.0.     .and.  &
                abs(mask%r2d(xc,yc)-mask%gil%bval).gt.mask%gil%eval
  !
end function fix_by_mask
!
!-----------------------------------------------------------------------
! Tools for fast search in Output File
!-----------------------------------------------------------------------
!
subroutine ox_sort_reset(set,error)
  use classcore_interfaces, except_this=>ox_sort_reset
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Recompute the sorting arrays of the Output indeX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  logical,             intent(inout) :: error
  !
  call fox_reset
  if (set%uniqueness) then
    call optimize_sort_set_dtt(ox,error)
    if (error)  return
  endif
  !
end subroutine ox_sort_reset
!
subroutine ox_sort_add(set,obs,dupl,error)
  use gbl_message
  use classcore_interfaces, except_this=>ox_sort_add
  use class_common
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Add a new observation in the sorting arrays of the Output indeX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(in)    :: obs
  logical,             intent(out)   :: dupl
  logical,             intent(inout) :: error
  !
  dupl = .false.
  if (set%uniqueness) then
    if (fileout%desc%vind.ne.3) then
      call class_message(seve%w,'UNIQUENESS',  &
        'Not checked (index version in output file must be 3)')
      return
    elseif (.not.fileout%desc%single) then
      call class_message(seve%w,'UNIQUENESS',  &
        'Not checked (output file must be single)')
      return
    endif
    call optimize_sort_add_dtt(ox,obs,dupl,error)
    if (error)  return
  endif
  !
  ! Do it last so that this sorting array remains correct in case of
  ! error above
  call fox_add(obs%head%gen%num,fileout%desc%xnext-1)
  !
end subroutine ox_sort_add
!
subroutine fox(anum,ifound)
  use gbl_message
  use classcore_interfaces, except_this=>fox
  use class_parameter
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Search for observation number Anum (last version) in the sorted
  ! index.
  !----------------------------------------------------------------------
  integer(kind=obsnum_length), intent(in)  :: anum    ! Obs number being searched for
  integer(kind=entry_length),  intent(out) :: ifound  ! Corresponding Entry Number (0 if none)
  ! Local
  integer(kind=entry_length) :: jprev,jnext
  !
  ifound = 0
  if (ox%sort%nsort.eq.0) return
  call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
  !
  ! Not found
  if (ox%sort%number(jprev).eq.anum) then
    ifound = ox%sort%entry(jprev)
  else if (ox%sort%number(jnext).eq.anum) then
    ifound = ox%sort%entry(jnext)
  endif
  ! print *,'ox%sort%nsort ',ox%sort%nsort,jprev,jnext
end subroutine fox
!
subroutine fox_reset
  use gbl_message
  use classic_api
  use class_parameter
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Build up the Sorted Entry/Number list when opening an output file
  ! The Sorted list will then be kept up-to-date at each writing.
  !----------------------------------------------------------------------
  ! Local
  integer(kind=entry_length) :: iobs,j,ifound,jprev,jnext
  integer(kind=obsnum_length) :: anum
  !
  ox%sort%nsort = 0
  do iobs=1,ox%next-1
    if (ox%ver(iobs).lt.0) cycle ! Ignore "old" versions
    if (ox%sort%nsort.eq.0) then
      ox%sort%nsort = 1
      ox%sort%number(1) = ox%num(iobs)
      ox%sort%entry(1) = iobs
    else
      anum = ox%num(iobs)
      if (anum.gt.ox%sort%number(ox%sort%nsort)) then
        ox%sort%nsort = ox%sort%nsort+1
        ox%sort%number(ox%sort%nsort) = anum
        ox%sort%entry(ox%sort%nsort) = iobs
      else if (anum.lt.ox%sort%number(1)) then
        do j=ox%sort%nsort,1,-1
          ox%sort%number(j+1) = ox%sort%number(j)
          ox%sort%entry(j+1) = ox%sort%entry(j)
        enddo
        ox%sort%number(1) = anum
        ox%sort%entry(1) = iobs
        ox%sort%nsort = ox%sort%nsort+1
      else
        call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
        if (ox%sort%number(jprev).eq.anum) then
          ifound = ox%sort%entry(jprev)
        else if (ox%sort%number(jnext).eq.anum) then
          ifound = ox%sort%entry(jnext)
        else
          ! Insert between jprev and jnext
          do j=ox%sort%nsort,jnext,-1
            ox%sort%number(j+1) = ox%sort%number(j)
            ox%sort%entry(j+1) = ox%sort%entry(j)
          enddo
          ox%sort%number(jnext) = anum
          ox%sort%entry(jnext) = iobs
          ox%sort%nsort = ox%sort%nsort+1
        endif
      endif
    endif
  enddo
end subroutine fox_reset
!
subroutine fox_next(anum)
  use gbl_message
  use class_parameter
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! RW  Returns next available ObsNumber Anum (last version)
  !---------------------------------------------------------------------
  integer(kind=obsnum_length), intent(out) :: anum  !
  !
  if (ox%sort%nsort.eq.0) then
     anum = 1
  else
     anum = ox%sort%number(ox%sort%nsort)+1
  endif
end subroutine fox_next
!
subroutine fox_add (anum, entry)
  use gbl_message
  use classic_api
  use classcore_interfaces, except_this=>fox_add
  use class_parameter
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! RW  Search for ObsNumber Anum (last version)
  !---------------------------------------------------------------------
  integer(kind=obsnum_length), intent(in) :: anum   ! Obs number being searched for
  integer(kind=entry_length),  intent(in) :: entry  ! Corresponding Entry Number (0 if none)
  ! Local
  integer(kind=entry_length) :: j,jprev,jnext
  !
  if (ox%sort%nsort.eq.0) then
    ox%sort%nsort = 1
    ox%sort%number(1) = anum
    ox%sort%entry(1) = entry
  else
    if (anum.gt.ox%sort%number(ox%sort%nsort)) then
      ox%sort%nsort = ox%sort%nsort+1
      ox%sort%number(ox%sort%nsort) = anum
      ox%sort%entry(ox%sort%nsort) = entry
    else if (anum.lt.ox%sort%number(1)) then
      do j=ox%sort%nsort,1,-1
        ox%sort%number(j+1) = ox%sort%number(j)
        ox%sort%entry(j+1) = ox%sort%entry(j)
      enddo
      ox%sort%number(1) = anum
      ox%sort%entry(1) = entry
      ox%sort%nsort = ox%sort%nsort+1
    else
      call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
      if (ox%sort%number(jprev).eq.anum) then
        ox%sort%entry(jprev) = entry
      else if (ox%sort%number(jnext).eq.anum) then
        ox%sort%entry(jnext) = entry
      else
        ! Insert between jprev and jnext
        do j=ox%sort%nsort,jnext,-1
          ox%sort%number(j+1) = ox%sort%number(j)
          ox%sort%entry(j+1) = ox%sort%entry(j)
        enddo
        ox%sort%number(jnext) = anum
        ox%sort%entry(jnext) = entry
        ox%sort%nsort = ox%sort%nsort+1
      endif
    endif
  endif
end subroutine fox_add
!
subroutine locplus (x,np,xlim,nlim,mlim)
  use classic_api
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  !  Find NLIM and MLIM such as
  !      X(NLIM) < XLIM < X(MLIM)
  !  for input data ordered increasingly
  !  Use a dichotomic search for that
  !---------------------------------------------------------------------
  integer(kind=entry_length),  intent(in)  :: np     !
  integer(kind=obsnum_length), intent(in)  :: x(np)  !
  integer(kind=obsnum_length), intent(in)  :: xlim   !
  integer(kind=entry_length),  intent(out) :: nlim   !
  integer(kind=entry_length),  intent(out) :: mlim   !
  ! Local
  integer(kind=entry_length) :: ninf,nsup,nmid
  !
  if (x(1).gt.xlim) then
     nlim = 1
     mlim = 1
     return
  elseif (x(np).lt.xlim) then
     nlim = np
     mlim = np
     return
  endif
  ninf = 1
  nsup = np
  !
  do while(nsup.gt.ninf+1)
     nmid = (nsup + ninf)/2
     if (x(nmid).lt.xlim) then
        ninf = nmid
     else
        nsup = nmid
     endif
  enddo
  nlim = ninf
  mlim = nsup
end subroutine locplus
!
subroutine optimize_sort_set_dtt(in,error)
  use gbl_message
  use class_sort_types
  use classcore_dependencies_interfaces
  use classic_api
  use classcore_interfaces, except_this=>optimize_sort_set_dtt
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the date-time-telescope sorting list of the given index
  !---------------------------------------------------------------------
  type(optimize), target, intent(inout) :: in     !
  logical,                intent(inout) :: error  !
  ! Local
  integer(kind=entry_length) :: nelem,ielem
  type(class_sort_dtt_t) :: sortdtt
  !
  nelem = in%next-1
  !
  do ielem=1,nelem
    in%sort%dtt(ielem) = ielem
  enddo
  !
  sortdtt%optx => in
  call sortdtt%sort(in%sort%dtt,nelem,error)
  if (error)  return
end subroutine optimize_sort_set_dtt
!
subroutine optimize_sort_add_dtt(optx,obs,dupl,error)
  use gbl_message
  use class_sort_types
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>optimize_sort_add_dtt
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Add a new observation to the Date-Time-Telescope sorting list.
  ! Raise an error if this new observation is duplicate of a previous
  ! one.
  !---------------------------------------------------------------------
  type(optimize), target, intent(inout) :: optx   ! Index to search in
  type(observation),      intent(in)    :: obs    ! Observation to be added
  logical,                intent(out)   :: dupl   ! Observation is a duplicate?
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=entry_length) :: nelem,jent,kent
  integer(kind=entry_length), parameter :: first=1
  character(len=message_length) :: mess
  type(class_sort_dtt_t) :: sortdtt
  !
  dupl = .false.
  nelem = optx%next-2  ! Observation is already at last position in the index: skip last one
  sortdtt%optx => optx
  sortdtt%searched_entry = optx%next-1  ! Observation is at last position in the index
  !
  if (nelem.le.0) then
    optx%sort%dtt(1) = 1
    return
  elseif (sortdtt%compare_value(optx%sort%dtt(nelem)).lt.0) then
    optx%sort%dtt(nelem+1) = nelem+1
    return
  elseif (sortdtt%compare_value(optx%sort%dtt(first)).gt.0) then
    jent = 1
  else
    call sortdtt%dicho(optx%sort%dtt,nelem,.true.,jent)
  endif
  ! In return jent is the element lower or equal to the request
  ! in the sorting array (optx%sort%dtt)
  !
  ! Check uniqueness
  kent = optx%sort%dtt(jent)
  if (optx%dobs(kent).eq.obs%head%gen%dobs .and.  &
      optx%ut(kent).eq.obs%head%gen%ut     .and.  &
      optx%ctele(kent).eq.obs%head%gen%teles) then
    dupl = .true.
    write(mess,'(A,I0,A,I0,A,F0.8,A,A)')  &
      'Duplicate observation #',obs%head%gen%num,': DOBS=',  &
      obs%head%gen%dobs,', UT=',obs%head%gen%ut,', TELES=',obs%head%gen%teles
    call class_message(seve%e,'UNIQUENESS',mess)
    error = .true.
    return
  endif
  !
  ! Fine, insert the observation at position jent in the sorting array
  do kent=nelem,jent,-1
    optx%sort%dtt(kent+1) = optx%sort%dtt(kent)
  enddo
  optx%sort%dtt(jent) = optx%next-1
end subroutine optimize_sort_add_dtt

!-----------------------------------------------------------------------
! Generic routines to handle images before displaying them in the
! appropriate device. No device-specific code here!
!-----------------------------------------------------------------------
subroutine gti_image(output,image)
  use gtv_interfaces, except_this=>gti_image
  use gtv_types
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! Affichage d'une image a partir du descripteur lu dans le metacode
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! Input gt_display
  type(gt_image),   intent(in)    :: image   ! Image instance
  ! Local
  logical :: error
  !
  select case (output%dev%protocol)
  case(p_x)
    call gti_ximage(output,image)
  case(p_postscript)
    call gti_psimage(output,image)
  case(p_svg)
    error = .false.
    call gti_svgimage(output,image,error)
  case(p_png)
    call gti_pngimage(output,image)
  end select
  !
end subroutine gti_image
!
subroutine clip_image(output,nx,ny,conv,box,user,resample,resfact,  &
  visible,clip,window,trans)
  use gtv_interfaces, except_this=>clip_image
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Compute clipping box of an image
  !---------------------------------------------------------------------
  type(gt_display)                        :: output     ! Output instance
  integer(kind=index_length), intent(in)  :: nx,ny      ! Image size
  real(kind=4),               intent(in)  :: conv(6)    ! Image pixel to User coordinates
  real(kind=4),               intent(in)  :: box(4)     ! Paper coordinates of bounding box
  real(kind=4),               intent(in)  :: user(4)    ! User coordinates of bounding box
  logical,                    intent(in)  :: resample   ! Is resample desired?
  real(kind=4),               intent(in)  :: resfact    ! Resampling factor (see below)
  logical,                    intent(out) :: visible    ! Is the image visible?
  real(kind=4),               intent(out) :: clip(4)    ! Clipping box in Paper coordinates
  integer(kind=4),            intent(out) :: window(4)  ! Clipping box in Window coordinates
  real(kind=4),               intent(out) :: trans(4)   ! Image to Window conversion
  ! Local
  character(len=*), parameter :: rname='CLIP_IMAGE'
  real(kind=4) :: bux,ux1,bx1,bx2
  real(kind=4) :: buy,uy1,by1,by2
  real(kind=4) :: xref,xval,xinc,yref,yval,yinc
  real(kind=4) :: user_x1,user_x2,user_y1,user_y2
  real(kind=4) :: page_x1,page_x2,page_y1,page_y2
  real(kind=4) :: pagex1,pagex2,pagey1,pagey2
  real(kind=4) :: clip_x1,clip_x2,clip_y1,clip_y2
!   real(kind=4) :: window_x1,window_x2,window_y1,window_y2
!   integer(kind=4) :: window_x0,window_nx,window_y0,window_ny
  integer(kind=4) :: window_x0,window_x1,window_x2,window_nx
  integer(kind=4) :: window_y0,window_y1,window_y2,window_ny
  real(kind=4) :: wi_x,wi_x0,wi_y,wi_y0
  real(kind=4), parameter :: releps=1e-5
  real(kind=4) :: eps,myxfact,myyfact,mysclx,myscly
  real(kind=4) :: gsclx,gscly,pox,poy,gox,goy,p1,p2
  logical :: do_resample
  !
  ! Scaling transformations
  ! From paper (PX) to Window (WX)
  !      IWX = NINT((PX-GOX)*GSCLX + POX)
  !
  ! From Image IX to User UX (Ref, Val, Inc)
  !      UX (IX) = (IX-Xref)*Xinc + Xval
  !
  xref = conv(1)
  xval = conv(2)
  xinc = conv(3)
  yref = conv(4)
  yval = conv(5)
  yinc = conv(6)
  !
  ! From User to Paper:
  !     BX = (UX-UX1)*BUX + BX1
  !
  bx1 = box(1)
  bx2 = box(2)
  ux1 = user(1)
  bux = (box(2)-box(1))/(user(2)-user(1))
  by1 = box(3)
  by2 = box(4)
  uy1 = user(3)
  buy = (box(4)-box(3))/(user(4)-user(3))
  !
  ! Compute the boundaries of the image in Page Coordinates
  user_x1 = (0.5-xref)*xinc + xval
  user_x2 = (nx+0.5-xref)*xinc + xval
  user_y1 = (0.5-yref)*yinc + yval
  user_y2 = (ny+0.5-yref)*yinc + yval
  page_x1 = (user_x1-ux1)*bux + bx1
  page_x2 = (user_x2-ux1)*bux + bx1
  page_y1 = (user_y1-uy1)*buy + by1
  page_y2 = (user_y2-uy1)*buy + by1
  !
  ! Compute the effective clipping box in the window
  ! First with "BOX"
  clip_x1 = max(bx1,min(page_x1,page_x2))
  clip_x2 = min(bx2,max(page_x1,page_x2))
  clip_y1 = max(by1,min(page_y1,page_y2))
  clip_y2 = min(by2,max(page_y1,page_y2))
  ! Then with clipping window
  clip_x1 = max(clip_x1,min(output%gx1,output%gx2))
  clip_x2 = min(clip_x2,max(output%gx1,output%gx2))
  clip_y1 = max(clip_y1,min(output%gy1,output%gy2))
  clip_y2 = min(clip_y2,max(output%gy1,output%gy2))
  clip(1) = clip_x1
  clip(2) = clip_x2
  clip(3) = clip_y1
  clip(4) = clip_y2
  !
  ! Check visibility
  visible = clip_x2.gt.clip_x1 .and. clip_y2.gt.clip_y1
  if (.not.visible) return
  !
  pagex1 = min(page_x1,page_x2)
  pagex2 = max(page_x1,page_x2)
  pagey1 = min(page_y1,page_y2)
  pagey2 = max(page_y1,page_y2)
  eps = releps*max(pagex2-pagex1,pagey2-pagey1)
  !
  if (resample) then
    ! Always resample to output device pixels
    do_resample = .true.
    !
  else
    ! Do not resample, IF POSSIBLE
    !
    ! If clipped, must resample:
    do_resample = abs(clip_x1-pagex1).gt.eps .or.  &
                  abs(clip_x2-pagex2).gt.eps .or.  &
                  abs(clip_y1-pagey1).gt.eps .or.  &
                  abs(clip_y2-pagey2).gt.eps
  endif
  !
  ! Compute the bitmap limits in Window pixels
  !
  call get_scale_awd(output,gsclx,gscly)
  if (do_resample) then
    ! 1) Clipped image
    if (.false.) then
      ! Clipping + no resampling
      ! ZZZ have to find the correct criterium for this!
      ! call gtv_message(seve%d,rname,'Clipping image, no resampling...')
      myxfact = 1./(abs(gsclx)*bux*xinc)
      myyfact = 1./(abs(gscly)*buy*yinc)
    else
      ! Clipping + resampling
      ! call gtv_message(seve%d,rname,'Clipping and resampling image...')
      ! We can use an additional scale factor. Non-sense for pixel-based
      ! devices (i.e. X window and PNG should use 1), it can be useful to
      ! improve the resolution for "pseudo-pixel-based" device like PS
      ! where we have set an artificial dots-per-inch value. However, take
      ! care of the quality vs file weight in this case.
      myxfact = resfact
      myyfact = resfact
    endif
    ! Get and use the pixel-to-world factor to resample the image.
    mysclx = gsclx*myxfact
    myscly = gscly*myyfact
    !
    ! Duplicate of 'world_to_pixel', but with mysclx
    call get_central_pixel_awd(output,pox,poy)
    call get_central_clipping_awd(output,gox,goy)
    p1 = (clip_x1-gox)*mysclx
    p2 = (clip_x2-gox)*mysclx
    if (p1.lt.p2) then
      ! Most likely clip_x1 is not perfectly aligned on the left of the first
      ! output pixel. Truncate to avoid overflowing before the first pixel.
      ! Same in all other cases.
      window_x1 = ceiling(p1 + pox)
      window_x2 = floor(p2 + pox)
    else
      window_x1 = floor(p1 + pox)
      window_x2 = ceiling(p2 + pox)
    endif
    p1 = (clip_y1-goy)*myscly
    p2 = (clip_y2-goy)*myscly
    if (p1.lt.p2) then
      window_y1 = ceiling(p1 + poy)
      window_y2 = floor(p2 + poy)
    else
      window_y1 = floor(p1 + poy)
      window_y2 = ceiling(p2 + poy)
    endif
    window_x0 = min(window_x1,window_x2)
    window_y0 = min(window_y1,window_y2)
    !
    ! This is correct, to the required precision...
    window_nx = abs(window_x2-window_x1)+1
    window_ny = abs(window_y2-window_y1)+1
    window(1) = window_nx
    window(2) = window_ny
    window(3) = window_x0
    window(4) = window_y0
    !
    ! Compute the Window pixels to Image pixels coordinate formula:
    !     Image = int (Window*WI_X + WI_X0)
    !
    wi_x = 1.0 / (mysclx * bux * xinc)
    wi_y = 1.0 / (myscly * buy * yinc)
    !
    ! OK, here we are
    if (window_x0.eq.window_x1) then
      ! 1) Image to User conversion:
      !      Xuser = (Ximag-xref)*xinc + xval
      ! 2) Box to User conversion:
      !      Xuser = (Xbox - bx1)/bux + ux1
      ! 3) Bitmap to Image conversion:
      !      Ximag = wi_x0 + wi_x*Xbitmap
      ! We want to align clip_x1 on the left of the first pixel, i.e.
      !      Xbox    = clip_x1
      !      Xbitmap = 0.5      (left of 1st pixel)
      ! Solving (1) == (2) gives:
      wi_x0 = ( ( clip_x1-bx1 ) / bux + ux1 - xval ) / xinc + xref - wi_x*0.5
    else
      wi_x0 = ( ( clip_x2-bx1 ) / bux + ux1 - xval ) / xinc + xref - wi_x*0.5
    endif
    if (window_y0.eq.window_y1) then
      wi_y0 = ( ( clip_y1-by1 ) / buy + uy1 - yval ) / yinc + yref - wi_y*0.5
    else
      wi_y0 = ( ( clip_y2-by1 ) / buy + uy1 - yval ) / yinc + yref - wi_y*0.5
    endif
    !
  else
    ! 2) Full image: no expansion/compression required
    ! call gtv_message(seve%d,rname,'Writing full image, no resampling...')
    window_nx = nx
    window_ny = ny
    !
    if (gsclx*bux*xinc.gt.0.0) then
      wi_x = 1.0
      wi_x0 = 0.0
    else
      wi_x = -1.0
      wi_x0 = nx+1
    endif
    if (gscly*buy*yinc.gt.0.0) then
      wi_y = 1.0
      wi_y0 = 0.0
    else
      wi_y = -1.0
      wi_y0 = ny+1
    endif
    window(1) = window_nx
    window(2) = window_ny
    window(3) = 1
    window(4) = 1
    !
  endif
  !
  trans(1) = wi_x
  trans(2) = wi_x0
  trans(3) = wi_y
  trans(4) = wi_y0
end subroutine clip_image
!
subroutine gti_bitmap(image,output,bitmap)
  use gtv_interfaces, except_this=>gti_bitmap
  use gtv_bitmap
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_image),   intent(in)    :: image   ! The image to be displayed
  type(gt_display), intent(in)    :: output  ! gt_display instance
  type(gt_bitmap),  intent(inout) :: bitmap  !
  ! Local
  integer :: ncol,offset
  !
  ! Use colour MAP_SIZE for blanking, so there are MAP_SIZE-1 colour
  ! available, from 1 to MAP_SIZE-1...
  ncol = output%dev%map_size-1
  !
  if (ncol.le.2) then
    call gtv_message(seve%w,'PLOT','Trying dithering')
    ncol = 127
    offset = 0
  else
    offset = output%dev%map_offset
  endif
  !
  call compute_bitmap(image,bitmap,ncol,offset)
  !
end subroutine gti_bitmap
!
subroutine compute_bitmap(image,bitmap,ncol,offset)
  use gtv_interfaces, except_this=>compute_bitmap
  use gtv_bitmap
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Generic entry point which computes the bitmap(s) for indexed or
  ! RGB images, standard or Lupton scaling
  !---------------------------------------------------------------------
  type(gt_image),  intent(in)    :: image   ! The image to be displayed
  type(gt_bitmap), intent(inout) :: bitmap  !
  integer(kind=4), intent(in)    :: ncol    ! Number of color or intensities per plane
  integer(kind=4), intent(in)    :: offset  ! Device offset for these intensities
  !
  if (image%isrgb) then
    if (image%scaling.eq.scale_lup) then
      ! Non-independant planes
      call compute_bitmap_lupton(image%r,image%g,image%b,image%scaling_lup_b,  &
        bitmap,bitmap%irvalues,ncol,offset)
      call compute_bitmap_lupton(image%g,image%r,image%b,image%scaling_lup_b,  &
        bitmap,bitmap%igvalues,ncol,offset)
      call compute_bitmap_lupton(image%b,image%r,image%g,image%scaling_lup_b,  &
        bitmap,bitmap%ibvalues,ncol,offset)
    else
      call compute_bitmap_direct(image%r,image%scaling,bitmap,bitmap%irvalues,  &
        ncol,offset)
      call compute_bitmap_direct(image%g,image%scaling,bitmap,bitmap%igvalues,  &
        ncol,offset)
      call compute_bitmap_direct(image%b,image%scaling,bitmap,bitmap%ibvalues,  &
        ncol,offset)
    endif
  else
    call compute_bitmap_direct(image%r,image%scaling,bitmap,bitmap%irvalues,  &
      ncol,offset)
  endif
  !
end subroutine compute_bitmap
!
subroutine compute_bitmap_direct(data,scaling,bitmap,ivalues,ncol,offset)
  use gtv_interfaces, except_this=>compute_bitmap_direct
  use gildas_def
  use gbl_message
  use gtv_bitmap
  !---------------------------------------------------------------------
  ! @ private
  !  Rescales the R*4 array IMAGE into the bitmap array DISPLAY with
  ! care of BLANKING values (put at 0) and LIN or LOG treatment
  ! (SCALING_MODE)
  !
  !  The image is scaled between the values 1 and NCOL. The colormap
  ! offset, if any, is handled by the device driver itself (cf
  ! x_affiche_image() in xsub.c)
  !---------------------------------------------------------------------
  type(gt_image_data),        intent(in)    :: data          ! The instance describing the image
  integer(kind=4),            intent(in)    :: scaling       ! Scaling mode
  type(gt_bitmap),            intent(inout) :: bitmap        ! The instance describing the bitmap
  integer(kind=bitmap_depth), intent(out)   :: ivalues(:,:)  ! The integer values
  integer,                    intent(in)    :: ncol          ! Number of colours
  integer,                    intent(in)    :: offset        ! Number of colours
  ! Local
  character(len=*), parameter :: rname='COMPUTE_BITMAP'
  integer(kind=2*bitmap_depth) :: entier
  real :: factor,logmax,logmin,lrmin,lrmax
  integer(kind=index_length) :: ii,jj
  integer :: i,j
  !
  ! Device dependent version for "bitmap-depth"-bytes bitmap
  integer(kind=bitmap_depth) :: bitval
#if defined(VAX) || defined(IEEE)
  equivalence (entier,bitval)
#endif
#if defined(EEEI)
  integer(kind=bitmap_depth) bitarr(2)
  equivalence (entier,bitarr(1)),(bitarr(2),bitval)
#endif
  !
  ! Switch the min/max cuts if required
  if (data%cuts(1).le.data%cuts(2)) then
    lrmin=data%cuts(1)
    lrmax=data%cuts(2)
  else
    lrmin=data%cuts(2)
    lrmax=data%cuts(1)
  endif
  !
  if (scaling.eq.scale_lin) then
    ! nous avons [1--NCOL] couleurs pour des pixels qui existent, et le pixel
    ! NCOL+1 pour le blanking (puisque NCOL=MAP_SIZE-1). Je prends:
    ! * 1 pour les value <= LRMIN
    ! * 1 to NCOL for LRMIN < value < LRMAX
    ! * NCOL pour les value >= LRMAX
    ! * NCOL+1 pour les NANQ et autres blanquettes.
    ! Linear scaling
    if (lrmax.ne.lrmin) then
      factor = (ncol-1)/(lrmax-lrmin)
    else
      factor = 0.0
    endif
    if (data%blank(2).lt.0.e0) then
      do j = 1,bitmap%size(2)
        ! nint() because e.g. float coordinates 0.5 to 1.5 fall into pixel 1
        jj = nint(bitmap%trans(4) + bitmap%trans(3)*j)
        jj = max(1,min(jj,data%taille(2)))
        do i =1,bitmap%size(1)
          ii = nint(bitmap%trans(2) + bitmap%trans(1)*i)
          ii = max(1,min(ii,data%taille(1)))
          ! Support for NANQ images
          if (data%values(ii,jj).le.lrmin) then
            entier = 1
          elseif (data%values(ii,jj).lt.lrmax) then
            entier = 1 + nint(factor*(data%values(ii,jj)-lrmin))  ! Vary from 1 to Ncol
          elseif (data%values(ii,jj).eq.data%values(ii,jj)) then  ! .ge.LRMAX, not NaN
            entier = ncol
          else                                        ! NaN
            entier = ncol+1
          endif
          entier = entier + offset - 1  ! -1 for C indices which start at 0
          ivalues(i,j) = bitval
        enddo
      enddo
    else
      do j = 1,bitmap%size(2)
        jj = nint(bitmap%trans(4)+bitmap%trans(3)*j)
        jj = max(1,min(jj,data%taille(2)))
        do i =1,bitmap%size(1)
          ii = nint(bitmap%trans(2)+bitmap%trans(1)*i)
          ii = max(1,min(ii,data%taille(1)))
          if (abs(data%values(ii,jj)-data%blank(1)).le.data%blank(2)) then  ! Blank
            entier = ncol+1
          elseif (data%values(ii,jj).le.lrmin) then
            entier = 1
          elseif (data%values(ii,jj).lt.lrmax) then
            entier = 1 + nint(factor*(data%values(ii,jj)-lrmin))  ! Vary from 1 to Ncol
          elseif (data%values(ii,jj).eq.data%values(ii,jj)) then  ! .ge.LRMAX, not NaN
            entier = ncol
          else                                        ! NaN
            entier = ncol+1
          endif
          entier = entier + offset - 1  ! -1 for C indices which start at 0
          ivalues(i,j) = bitval
        enddo
      enddo
    endif
    !
  elseif (scaling.eq.scale_log) then
    ! Logarithmic
    logmin = log(lrmin)
    logmax = log(lrmax)
    factor = (ncol-1)/(logmax-logmin)
    if (data%blank(2).lt.0.e0) then
      do j = 1,bitmap%size(2)
        jj = nint(bitmap%trans(4) + bitmap%trans(3)*j)
        jj = max(1,min(jj,data%taille(2)))
        do i =1,bitmap%size(1)
          ii = nint(bitmap%trans(2) + bitmap%trans(1)*i)
          ii = max(1,min(ii,data%taille(1)))
          if (data%values(ii,jj).le.lrmin) then
            entier = 1
          elseif (data%values(ii,jj).lt.lrmax) then
            entier = 1 + nint(factor*(log(data%values(ii,jj))-logmin))  ! Vary from 1 to Ncol
          elseif (data%values(ii,jj).eq.data%values(ii,jj)) then  ! .ge.LRMAX, not NaN
            entier = ncol
          else                                        ! NaN
            entier = ncol+1
          endif
          entier = entier + offset - 1  ! -1 for C indices which start at 0
          ivalues(i,j) = bitval
        enddo
      enddo
    else
      ! With blanking
      do j = 1,bitmap%size(2)
        jj = nint(bitmap%trans(4) + bitmap%trans(3)*j)
        jj = max(1,min(jj,data%taille(2)))
        do i =1,bitmap%size(1)
          ii = nint(bitmap%trans(2) + bitmap%trans(1)*i)
          ii = max(1,min(ii,data%taille(1)))
          if (abs(data%values(ii,jj)-data%blank(1)).le.data%blank(2)) then  ! Blank
            entier = ncol+1
          elseif (data%values(ii,jj).le.lrmin) then
            entier = 1
          elseif (data%values(ii,jj).lt.lrmax) then
            entier = 1 + nint(factor*(log(data%values(ii,jj))-logmin))  ! Vary from 1 to Ncol
          elseif (data%values(ii,jj).eq.data%values(ii,jj)) then  ! .ge.LRMAX, not NaN
            entier = ncol
          else                                        ! NaN
            entier = ncol+1
          endif
          entier = entier + offset - 1  ! -1 for C indices which start at 0
          ivalues(i,j) = bitval
        enddo
      enddo
    endif
    !
  elseif (scaling.eq.scale_equ) then
    ! Equalisation mode
    if (.not.allocated(data%eqvalues)) then
      call gtv_message(seve%e,rname,  &
        'Internal error: image has not been equalized!')
      return
    endif
    !
    do j = 1,bitmap%size(2)
      jj = nint(bitmap%trans(4) + bitmap%trans(3)*j)
      jj = max(1,min(jj,data%taille(2)))
      do i =1,bitmap%size(1)
        ii = nint(bitmap%trans(2) + bitmap%trans(1)*i)
        ii = max(1,min(ii,data%taille(1)))
        entier = data%eqvalues(ii,jj) + offset - 1  ! -1 for C indices which start at 0
        ivalues(i,j) = bitval
      enddo
    enddo
  endif
  !
end subroutine compute_bitmap_direct
!
subroutine compute_bitmap_lupton(data1,data2,data3,beta,bitmap,ivalues,ncol,offset)
  use gtv_interfaces, except_this=>compute_bitmap_lupton
  use gildas_def
  use gbl_message
  use gtv_bitmap
  !---------------------------------------------------------------------
  ! @ private
  !  Rescales the R*4 array IMAGE into the bitmap array DISPLAY with
  ! care of BLANKING values (put at 0) and LIN or LOG treatment
  ! (SCALING_MODE)
  !
  !  The image is scaled between the values 1 and NCOL. The colormap
  ! offset, if any, is handled by the device driver itself (cf
  ! x_affiche_image() in xsub.c)
  !---------------------------------------------------------------------
  type(gt_image_data),        intent(in)    :: data1         ! The instance describing the image
  type(gt_image_data),        intent(in)    :: data2         ! One of the complementary color
  type(gt_image_data),        intent(in)    :: data3         ! The second complementary color
  real(kind=4),               intent(in)    :: beta          ! Beta parameter
  type(gt_bitmap),            intent(inout) :: bitmap        ! The instance describing the bitmap
  integer(kind=bitmap_depth), intent(out)   :: ivalues(:,:)  ! The integer values
  integer,                    intent(in)    :: ncol          ! Number of colours
  integer,                    intent(in)    :: offset        ! Number of colours
  ! Local
  character(len=*), parameter :: rname='COMPUTE_BITMAP'
  integer(kind=2*bitmap_depth) :: entier
  real(kind=4) :: val1,val2,val3
  real(kind=4) :: radius,val
  integer(kind=index_length) :: ii,jj
  integer(kind=4) :: ibit,jbit
  !
  ! Device dependent version for "bitmap-depth"-bytes bitmap
  integer(kind=bitmap_depth) :: bitval
#if defined(VAX) || defined(IEEE)
  equivalence (entier,bitval)
#endif
#if defined(EEEI)
  integer(kind=bitmap_depth) bitarr(2)
  equivalence (entier,bitarr(1)),(bitarr(2),bitval)
#endif
  !
  if (data1%blank(2).ge.0.e0 .or. data2%blank(2).ge.0.e0 .or. data3%blank(2).ge.0.e0) then
    ! With blanking
    do jbit = 1,bitmap%size(2)
      jj = nint(bitmap%trans(4) + bitmap%trans(3)*jbit)
      jj = max(1,min(jj,data1%taille(2)))
      do ibit =1,bitmap%size(1)
        ii = nint(bitmap%trans(2) + bitmap%trans(1)*ibit)
        ii = max(1,min(ii,data1%taille(1)))
        !
        if (abs(data1%values(ii,jj)-data1%blank(1)).le.data1%blank(2) .or.  &
            abs(data2%values(ii,jj)-data2%blank(1)).le.data2%blank(2) .or.  &
            abs(data3%values(ii,jj)-data3%blank(1)).le.data3%blank(2)) then
          ! Blanked value
          entier = ncol+1
          !
        else
          if (data1%values(ii,jj).lt.0.) then
            val1 = 0.
          else
            val1 = data1%values(ii,jj)
          endif
          if (data2%values(ii,jj).lt.0.) then
            val2 = 0.
          else
            val2 = data2%values(ii,jj)
          endif
          if (data3%values(ii,jj).lt.0.) then
            val3 = 0.
          else
            val3 = data3%values(ii,jj)
          endif
          radius = beta*(val1+val2+val3)
          !
          if (radius.ne.radius) then
            ! One of the R/G/B value is NaN
            entier = 1
          elseif (val1.le.0. .or. radius.eq.0.) then
            ! Truncate negative values
            entier = 1
          else
            ! Valid value
            val = val1*asinh(radius)/radius
            if (val.gt.1.0)  val = 1.0
            entier = 1+nint((ncol-1)*val)
          endif
        endif
        !
        entier = entier + offset - 1  ! -1 for C indices which start at 0
        ivalues(ibit,jbit) = bitval
      enddo
    enddo
    !
  else
    ! Without blanking
    do jbit = 1,bitmap%size(2)
      jj = nint(bitmap%trans(4) + bitmap%trans(3)*jbit)
      jj = max(1,min(jj,data1%taille(2)))
      do ibit =1,bitmap%size(1)
        ii = nint(bitmap%trans(2) + bitmap%trans(1)*ibit)
        ii = max(1,min(ii,data1%taille(1)))
        !
        if (data1%values(ii,jj).lt.0.) then
          val1 = 0.
        else
          val1 = data1%values(ii,jj)
        endif
        if (data2%values(ii,jj).lt.0.) then
          val2 = 0.
        else
          val2 = data2%values(ii,jj)
        endif
        if (data3%values(ii,jj).lt.0.) then
          val3 = 0.
        else
          val3 = data3%values(ii,jj)
        endif
        radius = beta*(val1+val2+val3)
        !
        if (radius.ne.radius) then
          ! One of the R/G/B value is NaN
          entier = 1
        elseif (val1.le.0. .or. radius.eq.0.) then
          ! Truncate negative values
          entier = 1
        else
          ! Valid value
          val = val1*asinh(radius)/radius
          if (val.gt.1.0)  val = 1.0
          entier = 1+nint((ncol-1)*val)
        endif
        !
        entier = entier + offset - 1  ! -1 for C indices which start at 0
        ivalues(ibit,jbit) = bitval
      enddo
    enddo
    !
  endif
  !
end subroutine compute_bitmap_lupton
!
subroutine protocol_image_inquire(dev)
  use gtv_interfaces, except_this=>protocol_image_inquire
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Inquire about device size and color map.
  ! Should be merged in the gtvdef definitions, since it is a property
  ! of the device.
  !---------------------------------------------------------------------
  type(gt_device), intent(inout) :: dev  ! Device to update
  ! Local
  integer :: ndisplay_x,ndisplay_y
  !
  if (dev%protocol.eq.p_x) then
    call ximage_inquire(dev%map_size,dev%map_offset,ndisplay_x,ndisplay_y,  &
      dev%map_color,dev%map_static)
    !
  elseif (dev%protocol.eq.p_postscript) then
    call ps_image_inquire(dev%map_size,dev%map_offset,dev%map_color,  &
      dev%map_static)
    !
  elseif (dev%protocol.eq.p_svg) then
    call svg_image_inquire(dev%map_size,dev%map_offset,dev%map_color,  &
      dev%map_static)
    !
  elseif (dev%protocol.eq.p_png) then
    call png_image_inquire(dev%map_size,dev%map_offset,dev%map_color,  &
      dev%map_static)
  endif
  !
end subroutine protocol_image_inquire

subroutine solve_panels(niter,gain,amp,phas,phfit,phres,nxap,   &
    rlam,xref,xval,xinc,nmode,kant,h1,h2,work1,work2,nxbeam,nybeam,   &
    plot,scale,lprint,rwork1,rwork2, npm, pm, numscrew, screwname,   &
    screwmotion, screwmotionerror, phasrms, threshold, error)
  use gildas_def
  use gkernel_interfaces
  use clic_xypar
  !---------------------------------------------------------------------
  !	from map of aperture phase distribution ,calculates 5 modes for
  !	each panel of 15m telescopes,then gives the screw adjustements.
  !
  !	return fitted aperture plane phase and residuals
  !
  !     niter   nombre d'iterations
  !     gain    gain
  !     rlam    wavelength (mm)
  !     xref    index of reference point in x
  !     xval    x coord of ref point (mm)
  !     xinc    sampling interval (mm)
  !     ( assumed the same for y coord)
  !---------------------------------------------------------------------
  integer :: niter                          !
  real :: gain                              !
  integer :: nxap                           !
  real :: amp(nxap,nxap)                    !
  real :: phas(nxap,nxap)                   !
  real :: phfit(nxap,nxap)                  !
  real :: phres(nxap,nxap)                  !
  real :: rlam                              !
  real :: xref                              !
  real :: xval                              !
  real :: xinc                              !
  integer :: nmode                          !
  integer :: kant                           !
  character(len=*) :: h1                    !
  character(len=*) :: h2                    !
  complex :: work1(nxap,nxap)               !
  complex :: work2(nxap,nxap)               !
  integer :: nxbeam                         !
  integer :: nybeam                         !
  ! logical :: plot, rigging, error                  !
  logical :: plot, error                  !
  real :: scale(3)                          !
  integer :: lprint                         !
  real :: rwork1(nxap,nxap)                 !
  real :: rwork2(nxap,nxap)                 !
  integer :: npm                            !
  character(len=5) :: pm(npm)               !
  integer :: numscrew                       !
  character(len=12) :: screwname(numscrew)  !
  real :: screwmotion(numscrew)             !
  real :: screwmotionerror(numscrew)        !
  real(kind=4), intent(out) :: phasrms      !
  real :: threshold(2)
  ! Global
  include 'gbl_pi.inc'
  include 'clic_panels.inc'
  ! Local
  !      equivalence (work1,rwork1), (work2,rwork2)
  logical :: mask
  external :: mask
  !
  real :: am(5,mring,mpan), dam(5,mring,mpan), ae(5,mring,mpan)
  real :: znrms, zarms, rmsres, r0, x, y
  integer :: i, j, iter, k, km
  !      CHARACTER CHAIN*10
  !---------------------------------------------------------------------
  !
  write(lprint,*) 'Output from CLIC\SOLVE HOLO ',nmode   &
    ,' panel modes. '
  write(lprint,*) h1(1:lenc(h1))
  write(lprint,*) h2(1:lenc(h2))
  if (kant.eq.3 .or. kant.eq.5) then
    c2 = 0.70
  else
    c2 = 0.50
  endif
  !
  ! Modes to zero:
  do i=1, nring
    do j=1, npan(i)
      do k=1, 5
        am(k,i,j) = 0
      enddo
    enddo
  enddo
  if (niter.eq.0) then
    !
    ! calculate modes
    r0 = 10.                   ! no windowing
    call mode(amp,phas,nxap,xref,xval,xinc,rlam,am,ae,nmode,r0)
    !     $        diameter,focus)
    !
    ! compute map of panel phases
    call modemap(phfit,nxap,rlam,xref,xval,xinc,am,ae,nmode)
    call resmap(phas,phfit,phres,nxap,rlam,   &
      xref,xval,xinc,znrms,zarms,rmsres,phasrms,   &
      amp,work1,work2,nxbeam,nybeam, npm, pm)
    !
    ! Substract fitted phases
    do j=1, nxap
      do i=1, nxap
        phas(i,j) = phas(i,j) - phfit(i,j)
      enddo
    enddo
    !
    ! update plots of panel map and residual map
    if (plot) then
      !            CALL PLOT_MAPS(PHFIT,PHAS,NXAP,SCALE,SCALE,DIAMETER)
      do j=1, nxap
        y = xval+xinc*(j-xref)
        do i=1, nxap
          x = xval+xinc*(i-xref)
          !
          ! get path errors in meters
          if (mask(x,y,.1,0,' ')) then
            rwork1(i,j) = yima%gil%bval
            rwork2(i,j) = yima%gil%bval
          else
            rwork1(i,j) = 1e6*rlam*0.125/pis*phfit(i,j)   &
              *sqrt(4.*focus**2+x**2+y**2)   &
              /focus
            rwork2(i,j) = 1e6*rlam*0.125/pis*phas(i,j)   &
              *sqrt(4.*focus**2+x**2+y**2)   &
              /focus
          endif
        enddo
      enddo
      !            print *, 32,64,PHFIT(32,64),rwork1(32,64),
      !     $           PHAS(32,64),rwork2(32,64)
      call plot_maps(rwork1,rwork2,nxap,scale,scale)
    endif
  else
    !
    ! Iterate
    do iter = 1, niter
      r0 = 2.0*iter
      !
      ! calculate incremental modes from PHAS (measured phases - already fitted)
      call mode(amp,phas,nxap,xref,xval,xinc,rlam,   &
        dam,ae,nmode,r0)
      !
      ! compute map of panel phases in incremental modes
      call modemap(phfit,nxap,rlam,xref,xval,xinc,dam,ae,nmode)
      call resmap(phas,phfit,phres,nxap,rlam,   &
        xref,xval,xinc,znrms,zarms,rmsres,phasrms,   &
        amp,work1,work2,nxbeam,nybeam, npm, pm)
      !
      ! Substract fitted phases
      do j=1, nxap
        do i=1, nxap
          phas(i,j) = phas(i,j) - gain * phres(i,j)
        enddo
      enddo
      !
      ! Increment modes
      do i=1, nring
        km = min(nmode, mmode(i))
        !               IF (I.GT.1) THEN
        !                  KM = MAX(NMODE,3)
        !               ELSE
        !                  KM = NMODE
        !               ENDIF
        do j=1, npan(i)
          do k=1, km
            am(k,i,j) = am(k,i,j)+gain*dam(k,i,j)
          enddo
        enddo
      enddo
      call modemap(phfit,nxap,rlam,xref,xval,xinc,am,ae,nmode)
      ! update plots of panel map and residual map
      if (plot) then
        do j=1, nxap
          y = xval+xinc*(j-xref)
          do i=1, nxap
            x = xval+xinc*(i-xref)
            !
            ! get path errors
            if (mask(x,y,.1,0,' ')) then
              rwork1(i,j) = yima%gil%bval
              rwork2(i,j) = yima%gil%bval
            else
              rwork1(i,j) = 1e6*rlam*0.125/pis*phfit(i,j)   &
                *sqrt(4.*focus**2+x**2+y**2)   &
                /focus
              rwork2(i,j) = 1e6*rlam*0.125/pis*phas(i,j)   &
                *sqrt(4.*focus**2+x**2+y**2)   &
                /focus
            endif
          enddo
        enddo
        !               print *, 32,64,PHFIT(32,64),rwork1(32,64),
        !     $              PHAS(32,64),rwork2(32,64)
        call plot_maps(rwork1,rwork2,nxap,scale,scale)
      !               CALL PLOT_MAPS(PHFIT,PHAS,NXAP,SCALE,SCALE)
      endif
    enddo
    !
    ! Substract fitted phases
    do j=1, nxap
      do i=1, nxap
        phres(i,j) = phas(i,j)
      enddo
    enddo
  endif
  !
  ! calculate screw settings and list results
  !
  call screws(am,ae,nmode,lprint, numscrew, screwname, screwmotion,   &
       screwmotionerror, threshold, error)
    ! screwmotionerror, rigging, elevation, riggingElevation, error)
!
end subroutine solve_panels
!
!
subroutine mode (amp,phas,nxap,xref,xval,xinc,rlam,   &
    am, ae, nmode, r0)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !	takes aperture phase distribution phas,interpolates values
  !	onto fine grid on actual aperture.those values falling on a
  !	particular panel are used in the cal of least squares sums
  !	for that panel.
  !	output are amplitudes of 5 modes per panel
  !
  !	phas	"map" of phase of aperture distribution
  !	nxap	nxap x nxap is dimension of phas
  !       xref    index of reference point in x
  !       xval    x coord of ref point (mm)
  !       xinc    sampling interval (mm)
  !       ( assumed the same for y coord)
  !	rlam	wavelength in mm
  !	ng2	ng2 x nxap is number of interpolated values across antenna
  !	mpan	max no of panels per ring (32 for 15m tel.)
  !	nr	no of rings (6 for 15m tel.)
  !	aa	array of "tilt" modal amplitudes in x direction
  !	bb	array of "tilt" modal amplitudes in y direction
  !	dd	array of "piston"  modal amplitudes
  !	tt	array of "torsion" modal amplitudes
  !	cc	array of "boss"    modal amplitudes (assumed spherical)
  !---------------------------------------------------------------------
  include 'clic_panels.inc'
  integer :: nxap                   !
  real :: amp(nxap,nxap)            !
  real :: phas(nxap,nxap)           !
  real :: xref                      !
  real :: xval                      !
  real :: xinc                      !
  real :: rlam                      !
  real :: am(mm,mring,mpan)         !
  real :: ae(mm,mring,mpan)         !
  integer :: nmode                  !
  real :: r0                        !
  ! Global
  real :: fmode
  include 'gbl_pi.inc'
  ! Local
  integer :: i, j, nd, k, ir, ip, im, ier
  integer :: npts(mring,mpan),mpts, nm
  parameter (mpts=1000)
  real :: y, x, phase, xx, yy, zz, rr2
  real :: wamp
!  real*8 :: a(mpts,mm,mring,mpan), b(mpts,mring,mpan)
  real*8,allocatable :: a(:,:,:,:), b(:,:,:)
  logical :: error
  logical :: mask
  external :: mask
  real*8 :: sig
  !----------------------------------------------------------------------
  !
  allocate(a(mpts,mm,mring,mpan),stat=ier)
  if (failed_allocate('SOLVE_PANELS','a',ier,error)) return
  allocate(b(mpts,mring,mpan),stat=ier)
  if (failed_allocate('SOLVE_PANELS','b',ier,error)) return
  do ir=1,mring
    do ip=1,npan(ir)
      npts(ir,ip) = 0
    enddo
  enddo
  !
  do j=1, nxap
    y = xval+xinc*(j-xref)
    do i=1, nxap
      x = xval+xinc*(i-xref)
      if (.not.mask(x,y,.1,0,' '))   &
        then
        !
        ! Get panel number and relative coordinates in panel
        call xypanel(x,y,ir,ip,xx,yy)
        if (npts(ir,ip).lt.mpts) then
          npts(ir,ip)=npts(ir,ip)+1
          k = npts(ir,ip)
          rr2 = xx**2+yy*2
          wamp = 10**(amp(i,j)/10.)*exp(-rr2/r0**2)
          do im=1, min(nmode,mmode(ir))
            a(k,im,ir,ip) = fmode(im,ir,xx,yy)*wamp
          enddo
          !
          ! Resolve path error perpendicular to surface
          ! Set in [-PI,PI[ range
          phase = sin(phas(i,j))
          !               phase = MOD(phase+21D0*PI,2D0*PI)-PI
          !               ZZ=RLAM*0.125/PIS*PHASE*SQRT(4.*FOYER*FOYER+X*X+Y*Y)
          !     $         /FOYER
          zz=rlam*0.125/pis*phase*sqrt(4.*focus**2+x**2+y**2)   &
            /focus
          b(k,ir,ip) = zz*wamp
        else
          print *, 'ignoring data in panel ',ir,ip
        endif
      endif
    enddo
  enddo
  !
  ! calculate modes
  !      print *, 'mm, mring, mpan'
  !      print *, mm, mring, mpan
  !      print *, 'mring, nring, (npan(ir),ir=1,nring)'
  !      print *, mring, nring, (npan(ir),ir=1,nring)
  !      PRINT *, 'IR, IP, K, AM(K,IR,IP), AE(K,IR,IP)'
  do ir=1, nring
    nm = min(nmode,mmode(ir))
    do ip=1, npan(ir)
      nd = npts(ir,ip)
      if (nd.ne.0) then
        call mth_fitlin ('MODE',nd,nm,   &
             a(1,1,ir,ip),b(1,ir,ip),mpts,sig)
        do k=1, nm
          am(k,ir,ip) = b(k,ir,ip)
          ! NOte : the errors are not the same under lapack and nag.
          ! should be looked into (actually works with nag, not lapack). RL.
          ae(k,ir,ip) = sqrt(abs(a(k,k,ir,ip)))
        enddo
      else
        write (6,*) 'No data for panel ',ip,' ring ',ir
      endif
    enddo
  enddo
!      print *, 'end mode'
end subroutine mode
!
function fmode(jm,ir,xx,yy)
  real :: fmode                     !
  integer :: jm, im                     !
  integer :: ir                     !
  real :: xx                        !
  real :: yy                        !
  ! Global
  include 'clic_panels.inc'
  !
  if (jm.gt.mmode(ir)) then
    fmode = 0
    return
  endif
  im = modes(jm,ir)
!  if (ir.eq.4 .or. ir.eq.2) then
!    if (im.eq.1) then
!      fmode = 1d0
!    elseif (im.eq.2) then
!      fmode = xx
!    elseif (im.eq.3) then
!      fmode = yy
!    elseif (im.eq.4) then
!      fmode = c2*(xx**2+yy**2) + (1-c2)*yy**2
!    endif
!    return
!  endif
  if (im.eq.1) then
    fmode = 1d0
  elseif (im.eq.2) then
    fmode = xx
  elseif (im.eq.3) then
    fmode = yy
  elseif (im.eq.4) then
    fmode = xx*yy
  elseif (im.eq.5) then
    fmode = c2*(xx**2+yy**2) + (1-c2)*yy**2
  endif
  return
end function fmode
!
subroutine screws(am,ae,nmode,lprint, numscrew, screwname,   &
     screwmotion, screwmotionerror, threshold, error)                          
     !    rigging, elevation, riggingElevation, error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     calculates screw adjustments for 15m telescope given 5 modes for
  !     each panel-- aa,bb,dd,tt,cc.
  !
  !     z=dd + aa*(x-xxm) + bb*y + tt*y*(x-xx2)
  !     + cc*[ c2*(x-xc)**2 + s2*y**2 - c2*xxm2 - s2*yy2 ]
  !
  !     calculation as for 30m telescope but screw nos changed for output
  !
  !     x local panel coord is directed radially outwards
  !     y local panel coord is directed in azimuth in direction of
  !     panel counting in each ring.
  !     xxm  mean x coord of panel
  !     xx2  rms  x coord of panel
  !     xc       x coord for "boss" calculation
  !     xxm2 mean square (x-xc)
  !     yy2  mean square y
  !     c2   cos(phi)**2 (0.5 as first approx.)
  !     s2   sin(phi)**2 (0.5 as first approx.)
  !     phi  angle specifying ratio of curvature of "boss" in x and y
  !     =45 degrees as first approximation
  !---------------------------------------------------------------------
  include 'clic_panels.inc'
  real :: am(mm,mring,mpan)                 !
  real :: ae(mm,mring,mpan)                 !
  integer :: nmode                          !
  integer :: lprint                         !
  integer :: numscrew                       ! screw results for CalDM
  character(len=12) :: screwname(numscrew)  !
  real :: screwmotion(numscrew)           !
  ! real :: screwmotion(numscrew), elevation, riggingElevation(2)             !
  real :: screwmotionerror(numscrew)
  real :: threshold(2)                      ! Threshold for listing
  logical error
  ! logical rigging, error
  !
  ! Global
  character(len=5) :: cpanel
  include 'gbl_pi.inc'
  ! Local
  integer :: iscrew
  !
  integer :: mlines, lines
  parameter (mlines=58)        ! 58 lines per page of listing
  integer :: it(mm), iet(mm)
  real :: total(mm), etotal(mm)
  character(len=1) :: apage
  character(len=5) :: chp
  character(len=100) :: chain
  character(len=11) :: blan11
  integer :: ir, ip, is, lc
  real :: x, y
  !
  lines = mlines-3
  iscrew = 0
  blan11 = "           "
  !if (rigging) then
  !  allocate(correction(mring, mpan, mm))
  !  call get_rigging(elevation, riggingElevation, correction, &
  !       error)
  !  if (error) then
  !    write(6,*) 'No gravitational deformation available.'
  !    return
  !  endif
  !  write(6,*) 'Found gravitational deformation data.'
  !endif
  do ir = 1,nring
    if (ant_type.eq.type_iram30m) then  ! special 30m case
      iscrew = 0
      if (npan(ir)+3.gt.lines) then
        apage = char(012)        ! new page
        lines = mlines
      else
        apage = ' '
      endif
      write(lprint,1003) apage, (ir-1)*2+1
1003  format(a1,/,'Screw ring n0. ',i2,':',   &
        /,' Screw     Screw settings  [mum]')
      do ip=1,npan(ir)           !LOOP AROUND A FRAME RING
        do is = 1, 2             !INNER SCREWS
          x = xscr(is,ir)
          y = yscr(is,ir)
          !
          ! (Do not apply gravitational corrections to screw settings)
          call zpanel(x,y,ir,ip,am,ae,total(is),etotal(is),   &
            nmode)
          ! correction now done before plotting ... in res_holo.
          !! if (rigging) total(is) = total(is)+correction(ir, ip, is)
          it(is) = nint(1e6*total(is))
          iet(is) = nint(1e6*etotal(is))
          ! now write results
          chp = cpanel(ir,ip)
          iscrew = iscrew+1
          if (abs(it(is)).gt.threshold(1).and. &
              abs(it(is)).gt.threshold(2)*iet(is)) then
            write(lprint,1002) (ir-1)*2+1,iscrew, it(is),iet(is)
          endif
1002      format(3x,i2,'.',i2.2,5x,i6,2x,'(',i3,')')
        enddo
      enddo
      iscrew = 0
      write(lprint,1003) apage, (ir-1)*2+2
      do ip=1,npan(ir)           !LOOP AROUND A FRAME RING
        do is = 3, nscr(ir)      !OUTER SCREWS
          x = xscr(is,ir)
          y = yscr(is,ir)
          !
          ! (Do not apply gravitational corrections to screw settings)
          call zpanel(x,y,ir,ip,am,ae,total(is),etotal(is),   &
            nmode)
          ! correction now done before plotting ... in res_holo.
          !! if (rigging) total(is) = total(is)+correction(ir, ip, is)
          it(is) = nint(1e6*total(is))
          iet(is) = nint(1e6*etotal(is))
          iscrew = iscrew+1
          if (abs(it(is)).gt.threshold(1).and. &
              abs(it(is)).gt.threshold(2)*iet(is)) then
            write(lprint,1002) (ir-1)*2+2,iscrew, it(is),iet(is)
          endif
        enddo
      enddo
    else
      if (npan(ir)+3.gt.lines) then
        apage = char(012)        ! new page
        lines = mlines
      else
        apage = ' '
      endif
      write(lprint,1001) apage, ir, nscr(ir)
1001  format(a1,/,'Panel ring n0. ',i2,':',   &
        /,' Sec/Pan     Screw settings (1-',i1,'), [mum]')
      lines = lines-3
      do ip=1,npan(ir)           !LOOP AROUND A RING
        lc = 0
        chain = ''
        do is = 1, nscr(ir)
          x = xscr(is,ir)
          y = yscr(is,ir)
          !
          ! (Do not apply gravitational corrections to screw settings)
          call zpanel(x,y,ir,ip,am,ae,total(is),etotal(is),   &
            nmode)
          ! correction now done before plotting ... in res_holo.
          !! if (rigging) total(is) = total(is)+correction(ir, ip, is)
          it(is) = nint(1e6*total(is))
          iet(is) = nint(1e6*etotal(is))
          if (abs(it(is)).gt.threshold(1).and. &
              abs(it(is)).gt.threshold(2)*iet(is)) then
            write(chain(lc+1:lc+12),1010) it(is), iet(is)
          else
            write(chain(lc+1:lc+12),1011) blan11
          endif
          lc = lc+11
1010  format(i6,'(',i3,')')
1011  format(a11)
        enddo
        ! now write results
        chp = cpanel(ir,ip)
        lc = lenc(chain)
        if (lc.gt.0) then
          write(lprint,1000) chp, chain(1:lc)
        endif
1000    format(3x,a5,5x,a)
        !
        ! Save screw results for CalDM:
        do is = 1, nscr(ir)
          iscrew = iscrew + 1
          write(screwname(iscrew),'(a5,2h-S,i1)')  chp, is
          screwmotion(iscrew) = total(is)
          screwmotionerror(iscrew) = etotal(is)
        !$$$               print *, ip, is, iscrew, screwName(iscrew),
        !$$$     &              screwMotion(iscrew), screwMotionError(iscrew)
        enddo
        lines = lines-1
      enddo
    endif
  enddo
  return
end subroutine screws
!
subroutine modemap(phfit,nxap,rlamda,   &
    xref, xval, xinc,am,ae,nmode)
  !---------------------------------------------------------------------
  !	makes an aperture plane map of 15m telescope using up to 5 modes
  !	makes residal map also,using phas map
  !
  !	fills a complex aperture array psi from data given by the modes
  !	am
  !	takes measured phases and makes a residual complex map
  !
  !	number of modes used defined by nmode 1,3,4,5
  !	wavelength rlamda,relative sampling interval relsampi and power
  !	taper is taperdb (+ve)
  !	returns rms deflection normally,and axially,and no points used
  !---------------------------------------------------------------------
  include 'clic_panels.inc'
  integer :: nxap                   !
  real :: phfit(nxap,nxap)          !
  real :: rlamda                    !
  real :: xref                      !
  real :: xval                      !
  real :: xinc                      !
  real :: am(5,mring,mpan)          !
  real :: ae(5,mring,mpan)          !
  integer :: nmode                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  !      REAL RMAX2,RMIN2, X, Y,RAD2,XPANEL,YPANEL,
  real ::  x, y,rad2,xpanel,ypanel
  real ::  cosa, zpan, epan
  integer :: m, n, ir, ip
  !
  logical :: mask
  external :: mask
  !----------------------------------------------------------------------
  !
  ! fill array point by point
  do  m = 1,nxap
    x = xval+xinc*(m-xref)
    do  n = 1,nxap
      y = xval+xinc*(n-xref)
      rad2 = x**2+y**2
      if (.not.mask(x,y,.1,0,' '))   &
        then
        ! Identify panel and local coords in this panel
        call xypanel(x,y,ir,ip,xpanel,ypanel)
        ! Calculate normal deflection
        call zpanel(xpanel,ypanel,ir,ip,am,ae,zpan,epan,   &
          nmode)
        cosa  =  1./sqrt(1.+rad2/4/focus**2)
        phfit(m,n) = 4.*pis*zpan*cosa/rlamda   !aperture phase
      else
        phfit(m,n) = 0
      endif
    enddo
  enddo
  return
end subroutine modemap
!
subroutine resmap(phas,phfit,phres,nxap,rlamda,   &
    xref, xval, xinc, znrms, zarms, rmsres, phasrms,   &
    amp,work1,work2,nxbeam,nybeam, npm, pm)
  !---------------------------------------------------------------------
  ! Using the phase of Fitted panels PHFIT, compute the residuals
  ! from the input phase map PHAS
  !---------------------------------------------------------------------
  integer :: nxap                   !
  real :: phas(nxap,nxap)           !
  real :: phfit(nxap,nxap)          !
  real :: phres(nxap,nxap)          !
  real :: rlamda                    !
  real :: xref                      !
  real :: xval                      !
  real :: xinc                      !
  real :: znrms                     !
  real :: zarms                     !
  real :: rmsres                    !
  real :: phasrms                   !
  real :: amp(nxap,nxap)            !
  complex :: work1(nxap,nxap)       !
  complex :: work2(nxap,nxap)       !
  integer :: nxbeam                 !
  integer :: nybeam                 !
  integer :: npm                    !
  character(len=5) :: pm(200)       !
  ! Global
  include 'clic_panels.inc'
  include 'gbl_pi.inc'
  ! Local
  integer :: npts
  real :: w, wamp, ptoz
  real :: resmean,res2,phasmean,phas2, x, y,rad2
  real :: cosa
  integer :: m, n
  logical :: mask
  external :: mask
  !----------------------------------------------------------------------
  !      foyer = focus*1000.
  !
  ! Compute true residuals (substitute panel fit to aperture phase, FFT back to
  ! beam map, cutoff, and recompute aperture phase)
  call fitres(phres,   &       !
    amp,   &                   ! input map amplitude
    phfit,   &                 ! phase of panel fit
    work1,   &                 ! complex work space
    work2,   &                 ! complex work space
    nxbeam,nybeam,   &         ! size of observed beam map
    nxap,nxap)                 ! size of aperture map.
  !
  ! calculate rms of screw deflections-rmss,no of screws-ntot
  ! zeroes for statistics
  !
  npts = 0                     !no points in aperture
  w = 0
  resmean = 0.
  res2 = 0.
  phasmean = 0.
  phas2 = 0.
  !      RMAX2 = (DIAM/2.)**2               !max radius (mm) squared
  !      RMIN2 = (DBLOCK/2.)**2             !min radius (mm) squared
  do  m = 1,nxap
    x = xval+xinc*(m-xref)
    do  n = 1,nxap
      y = xval+xinc*(n-xref)
      rad2 = x**2+y**2
      wamp = 10**(amp(m,n)/10.)
      !
      !            IF (.NOT. MASK(X,Y,.001,0,' '))
      if (.not. mask(x,y,.1,npm,pm))   &
        then
        cosa  =  1./sqrt(1.+rad2/4/focus**2)
        ! from radians to micrometers
        ptoz = rlamda/(4*pis*cosa)
        resmean = resmean+phres(m,n)*ptoz*wamp
        res2 = res2+(phres(m,n)*ptoz)**2*wamp
        phasmean = phasmean+phas(m,n)*ptoz*wamp
        phas2 = phas2+(phas(m,n)*ptoz)**2*wamp
        w = w+wamp
        npts = npts+1
      endif
    enddo
  enddo
  if (w.gt.0) then
    resmean = resmean/w
    rmsres =  sqrt((res2-w*resmean**2)/w)
    phasmean = phasmean/w
    phasrms = sqrt((phas2-w*phasmean**2)/w)
  endif
  write (6,'(a,f6.2,a,f6.2,a)') 'rms of res. map:', phasrms*1e6,   &
    ';  rms of fitted pan. ',rmsres*1e6,' mum'
  return
end subroutine resmap
!
!
subroutine xypanel(x,y,ir,ip,xpanel,ypanel)
  !---------------------------------------------------------------------
  !     takes x,y,coords in aperture (mm)  for each call
  !     identifies corresponding panel(i3,i1) and calculates
  !     local coords xpanel,ypanel
  !
  !     outside radius of rings (inner section being 0),and average
  !---------------------------------------------------------------------
  real :: x                         !
  real :: y                         !
  integer :: ir                     !
  integer :: ip                     !
  real :: xpanel                    !
  real :: ypanel                    !
  ! Global
  include 'clic_panels.inc'
  include 'gbl_pi.inc'
  ! Local
  real :: phi
  real :: dphi, r, r0, t0
  !
  !----------------------------------------------------------------------
  if (diameter.le.0 .or. focus.le.0) then
    print *, 'x,  y,diameter,focus'
    print *, x,y,diameter,focus
    stop
  endif
  ir = 0
  ip = 0
  !
  ! phi is used for counting panels,
  ! but we start from the left side of the antenna, as seen from back,
  ! and go clockwise.
  !
  if (x.eq.0..and.y.eq.0.) then
    phi = 0.
  else
    if (ant_type.ge.type_melco12m_1 .and. ant_type.le.type_melco12m_4) then
      phi = atan2(-x,y)
    elseif (ant_type.eq.type_iram30m) then
      phi = -atan2(x,y)
    else
      phi = atan2(x,y)+pi/2.
    endif
  endif
  r = sqrt(x**2+y**2)
  if (r.gt.ray(nring) .or. (r.lt.ray(0))) then
    return
  endif
  !
  !  find ring number
  ir = 1
  do while (r .gt. ray(ir))
    ir = ir + 1
  enddo
  phi = mod(phi+4*pi,2*pi)
  !
  ! loop around looking for azimuth
  !      ip = int(phi/2./pi*npan(ir)) !  0 to npan-1
  !      ip = mod(ip+npan(ir),,npan(ir))+1
  ip = mod(int(phi/2./pi*npan(ir)) + npan(ir),npan(ir)) + 1
  ! x referred to zero defined by mean slope alpham
  ! y referred to zero in panel center
  dphi =  phi-(ip-0.5)*2.*pi/npan(ir)
  r0 = (ray(ir-1)+ray(ir))/2.
  t0 = r0/2/focus
  xpanel = (r*cos(dphi)-r0+(r**2-r0**2)/4/focus*t0)   &
    /sqrt(1+t0**2)
  ypanel = r*sin(dphi)
  if (ant_type.ge.type_melco12m_1 .and. ant_type.le.type_melco12m_4) then
    ypanel = -ypanel
  endif
  !      if (ir.eq.3) then
  !         print '(4f7.3)', x, y, xpanel, ypanel
  !      endif
  return
end subroutine xypanel
!
function cpanel(ir,ip)
  character(len=5) :: cpanel        !
  integer :: ir                     !
  integer :: ip                     !
  ! Global
  include 'clic_panels.inc'
  ! Local
  integer :: nsector, ninsector, k
  ! Find sector number
  if (ant_type.ne.type_iram30m) then
    k = npan(ir) / npan(1)
    nsector = (ip-1)/k  + 1
    ninsector = ip - k*(nsector-1)
    write (cpanel,1000) nsector, ir, ninsector
1000 format(i2,'-',i1,i1)
  else
    write (cpanel,1001) ir,ip
1001 format(i2,'-',i2.2)
  endif
end function cpanel
!
!
subroutine zpanel(x,y,ir,ip,am,ae,zpan,epan,nmode)
  include 'clic_panels.inc'
  real :: x                         !
  real :: y                         !
  integer :: ir                     !
  integer :: ip                     !
  real :: am(mm,mring,mpan)         !
  real :: ae(mm,mring,mpan)         !
  real :: zpan                      !
  real :: epan                      !
  integer :: nmode                  !
  ! Global
  real :: fmode
  ! Local
  integer :: k, km
  !----------------------------------------------------------------------
  zpan = 0
  epan = 0
  km = min(nmode,mmode(ir))
  !      IF (IR.EQ.1) KM = MIN(3,NMODE)
  do k=1, km
    zpan = zpan + am(k,ir,ip)*fmode(k,ir,x,y)
    epan = epan + (ae(k,ir,ip)*fmode(k,ir,x,y))**2
  enddo
  epan = sqrt(epan)
  return
end subroutine zpanel
!
subroutine fitres(phres,am_obs,phfit,work,zap,   &
    nxbeam,nybeam,nxap,nyap)
  !---------------------------------------------------------------------
  ! compute the effect of fitted panels (phfit) on the observed phase
  ! phres is in fact the response to phfit by the observing process.
  ! one uses the observed amplitude as a weight.
  !---------------------------------------------------------------------
  integer :: nxap                   ! dimensions in aperture plane
  integer :: nyap                   ! dimensions in aperture plane
  real :: phres(nxap,nyap)          !
  real :: am_obs(nxap,nyap)         !
  real :: phfit(nxap,nyap)          !
  complex :: work(nxap,nyap)        !
  complex :: zap(nxap,nyap)         !
  integer :: nxbeam                 ! dimensions in beam map plane
  integer :: nybeam                 ! dimensions in beam map plane
  ! Local
  integer :: i,j,ii,jj, nn(2)
  real :: amp, faz, pha
  !-----------------------------------------------------------------------
  !
  ! Fill in zap with the panel fit phase ant the amplitudes
  do j=1, nyap
    do i=1, nxap
      amp = 10**(am_obs(i,j)/10.)
      zap(i,j) =   &
        cmplx(amp*cos(phfit(i,j)),amp*sin(phfit(i,j)))
    enddo
  enddo
  !
  ! FFT of zap
  nn(1) = nxap
  nn(2) = nyap
  call fourt(zap,nn,2,-1,1,work)
  !
  ! Cut off in beam map plane (ii and jj are the spatial offsets)
  do j=1, nyap
    jj = mod(j+nyap/2-1,nyap)-nyap/2
    do i=1, nxap
      ii = mod(i+nxap/2-1,nxap)-nxap/2
      if (ii.le.-nxbeam/2 .or. ii.ge.nxbeam/2 .or.   &
        jj.le.-nybeam/2 .or. jj.ge.nybeam/2) then
        zap(i,j) = 0
      endif
    enddo
  enddo
  !
  ! FFT back of zap
  call fourt(zap,nn,2,1,1,work)
  !
  ! get phases residuals
  do j=1, nyap
    do i=1, nxap
      zap(i,j) = zap(i,j)/nxap/nyap
      amp = abs(zap(i,j))
      if (amp.gt.0) then
        pha = faz(zap(i,j)/amp)
      else
        pha = 0
      endif
      phres(i,j) = pha
    enddo
  enddo
  return
end subroutine fitres
!
subroutine set_panels(type)
  !---------------------------------------------------------------------
  ! Set panels info according to antenna type
  !---------------------------------------------------------------------
  integer :: type                   !
  ! Global
  include 'clic_panels.inc'
  include 'gbl_pi.inc'
  ! Local
  integer :: i, is, ir, im
  real :: r1, r0, r, phi, t0
  !-------------------------------------------------------
  ! Bure screw positions (offset from nearest corner, in panel frame)
  ! (sign of offset indicates which is the corner)
  real :: xoscr(5,6), yoscr(5,6)
  data xoscr/   &
    0.071, -0.049, -0.049,  0.754, 0,   &
    0.049,  0.049, -0.049, -0.049, 0,   &
    0.049,  0.049, -0.049, -0.049, 0,   &
    0.049,  0.049, -0.049, -0.049, 0,   &
    0.049,  0.049, -0.049, -0.049, 0,   &
    0.049,  0.049, -0.049, -0.049, 0/
  data yoscr/   &
    0, -0.110,  0.110,      0, 0,   &
    0.110, -0.110, -0.110,  0.110, 0,   &
    0.110, -0.110, -0.110,  0.110, 0,   &
    0.110, -0.110, -0.110,  0.110, 0,   &
    0.110, -0.110, -0.110,  0.110, 0,   &
    0.110, -0.110, -0.110,  0.110, 0/
  ! 30-m screw positions 
  ! panel corners : 1, 2 inner; 3, 4 outer
!!!   DATA XP1/-1093.6,-1176.5,-1177.1,-1195.3,-1142.6,-1139.1,-1251.1/
!!!   DATA XP2/-1093.6,-1176.5,-1177.1,-1195.3,-1142.6,-1139.1,-1251.1/
!!!   DATA XP3/707.6,990.5,890.8,1114.7,1036.2,1008.7,1100.5/
!!!   DATA XP4/707.6,990.5,890.8,1114.7,1036.1,1008.7,1100.5/
!!!   DATA YP1/-309.0,-451.3,-788.4,-553.1,-722.6,-876.8,-1023.1/
!!!   DATA YP2/309.0,451.3,788.4,553.1,722.6,876.8,1023.1/
!!!   DATA YP3/-891.5,-788.4,-1102.9,-722.6,-876.8,-1023.1,-1176.9/
!!!   DATA YP4/891.5,788.4,1102.9,722.6,876.8,1023.1,1176.9/
!!!   ! delX, delY offsets from nearest corner
!!!   DATA DELX1/ 58., 37., 30., 31., 43., 32., 34./
!!!   DATA DELX2/ 58., 37., 30., 31., 43., 32., 34./
!!!   DATA DELX3/-61.,-35.,-34.,-43.,-44.,-34.,-67./
!!!   DATA DELX4/-61.,-35.,-34.,-43.,-44.,-34.,-67./
!!!   DATA DELY1/27.,  25., 43., 24., 31., 38., 45./
!!!   DATA DELY2/-27.,-25.,-43.,-24.,-31.,-38.,-45./
!!!   DATA DELY3/45.,  48., 58., 31., 38., 45., 51./
!!!   DATA DELY4/-45.,-48.,-58.,-31.,-38.,-45.,-51./
  ! 30m values 
  real :: xoscr30(5,7), yoscr30(5,7)
  data xoscr30/ &
       0.058, 0.058, -0.061, -0.061, -0.061, & ! Five screws in ring 1
       0.037, 0.037, -0.035, -0.035, 0., &
       0.030, 0.030, -0.034, -0.034, -0.034, & ! Five screws in ring 3
       0.031, 0.031, -0.043, -0.043, 0., &       
       0.043, 0.043, -0.044, -0.044, 0., &
       0.032, 0.032, -0.034, -0.034, 0., &
       0.034, 0.034, -0.067, -0.067, 0./
  data yoscr30/ &
       0.027, -0.027, 0.045,  0.,    -0.045, &
       0.025, -0.025, 0.048, -0.048, 0., &
       0.043, -0.043, 0.058,  0.,    -0.058, &
       0.024, -0.024, 0.031, -0.031, 0., &
       0.031, -0.031, 0.038, -0.038, 0., &
       0.038, -0.038, 0.045, -0.045, 0., &
       0.045, -0.045, 0.051, -0.051, 0./

  !-------------------------------------------------------
  ! Vertex screw positions (radius rscr in m,
  !                         angle tscr in radians, from panel edge)
  !     in projection on aperture, 8 panel types and 5 screws/panel)
  real :: rscr_vx(5,8), tscr_vx(5,8)
  data rscr_vx/   &
    0.53575, 0.53571, 1.19778, 1.19748, 0.91389,   &
    1.33569, 1.33558, 1.75305, 1.75236, 1.52073,   &
    1.88914, 1.88910, 2.53827, 2.53777, 2.22333,   &
    2.67233, 2.67224, 3.15428, 3.15358, 2.84699,   &
    3.28574, 3.28572, 3.97528, 3.97495, 3.64196,   &
    4.10355, 4.10351, 4.71701, 4.71656, 4.41408,   &
    4.84148, 4.84142, 5.37366, 5.37312, 5.10640,   &
    5.49460, 5.49453, 5.94013, 5.93954, 5.71265/
  data tscr_vx/   &
    0.393121, 0.131047, 0.465744, 0.059062, 0.339018,   &
    0.471476, 0.052519, 0.484501, 0.040838, 0.308473,   &
    0.224936, 0.037136, 0.235189, 0.028524, 0.131539,   &
    0.235820, 0.026304, 0.240634, 0.023193, 0.131440,   &
    0.109715, 0.021375, 0.114162, 0.018454, 0.065981,   &
    0.113972, 0.017143, 0.117015, 0.015770, 0.066018,   &
    0.116580, 0.014554, 0.118844, 0.013974, 0.066021,   &
    0.118303, 0.012843, 0.120040, 0.012685, 0.065991/
  ! Blockage due to feed legs, from ALMA Antenna Group Report #40 (2002-03-28)
  real :: rblock_vx(9), hblock_vx(9)
  data rblock_vx/   &
    0.3750, 3.8970, 4.1970, 4.4970, 4.7970,   &
    5.0970, 5.3970, 5.6970, 6.0000/
  data hblock_vx/   &
    0.0400, 0.0400, 0.0461, 0.0489, 0.0587,   &
    0.0608, 0.0665, 0.0724, 0.0783/
  ! Temperature coefficients. 
  ! nPol, mPol are the ZernikePolynomial indices; 
  ! coeffPol are the corresponding temperature coefficients in mum/K
  real :: coeffPol_vx(10)
  integer :: mPol_vx(10), nPol_vx(10)
  data nPol_vx / 2,  2,  3,  4,  4,  4,  5,  6,  6,  7/
  data mPol_vx / 2, -2,  3,  4,  2,  0, -1,  2,  0,  1/
  ! DV03 only
  !  data coeffPol_vx / -0.61186, -0.50031, -0.17588, -0.43920, 0.222851, & 
  !       0.353557, +0.1353, -0.1625, -0.17316/
  ! final 10-coefficient formula from Fred Schwab
  !  Note that odd-n terms have a reversed sign due to the different orientation 
  ! of axes in CLIC.
  data coeffPol_vx /-0.592547, -0.453756, -0.175091, -0.434967, 0.211509, & 
       0.353752, +0.122604, -0.172922, -0.176978, -0.0946602/
  
       
  !-------------------------------------------------------
  ! AEC screw positions (radius rscr in mm,
  !                         angle tscr in degrees, from panel edge)
  !     in projection on aperture, 5 panel types and 5 screws/panel)
  real :: rscr_aec(5,5), tscr_aec(5,5)
  data rscr_aec/   &
    558.6,    558.6,   1372.04,  1372.04,  1027.95,   &
    1674.97,  1674.97,  2478.96,  2478.96,  2107.97,   &
    2809.24,  2809.24,  3601.2,   3601.2,   3221.96,   &
    3939.14,  3939.14,  4724.21,  4724.21,  4356.03,   &
    5066.21,  5066.21,  5847.87,  5847.87,  5484.97/
  data tscr_aec/   &
    33.5414,  11.4586, 37.8486,  7.1516,  22.5000,   &
    19.9097,   2.5903, 19.5129,  2.9871,  11.2500,   &
    9.9589,   1.2911,  9.7972,  1.4527,   5.6250,   &
    9.7458,   1.5042,  9.6582,  1.5918,   5.6250,   &
    9.6333,   1.6167,  9.5780,  1.6720,   5.6250 /
  ! Blockage due to feed legs, from ALMA Antenna Group Report #40 (2002-03-28)
  ! Rather approximate
  ! updated for production antenna (Oct. 2010)
  real :: rblock_aec(2), hblock_aec(2)
  data rblock_aec/   &
    0.3750, 6.0000/
  data hblock_aec/   &
    0.04925, 0.04925/
  !-------------------------------------------------------
  ! MELCO screw positions (radius rscr in mm,
  !                         angle tscr in digree, from antenna center!!)
  !     in projection on aperture, 7 panel types and 4or5 screws/panel)
  real :: rscr_melco(5,7), tscr_melco(5,7)
  data rscr_melco/   &
    527.710,  683.622,  683.822,  471.728, 471.728,   &
    1255.335, 1545.837, 1545.837, 969.017, 0.0,   &
    2146.294, 2457.902, 2457.902, 1855.426, 1855.426,   &
    3066.465, 3366.928, 3366.928, 2766.561, 0.0,   &
    3951.072, 4244.137, 4244.137, 3663.266, 3663.266,   &
    4807.951, 5092.371, 5092.371, 4528.556, 4528.556,   &
    5626.556, 5895.681, 5895.681, 5365.692, 5365.692 /
  data tscr_melco/   &
    36.000,    63.154577, 8.845423, 16.173171, 55.826829,   &
    9.000000,  13.786896, 4.213104, 9.000000,  0.0,   &
    9.000000,  15.377019, 2.622981, 3.463847,  14.536153,   &
    4.500000,  7.121568,  1.878432, 4.500000,  0.0,   &
    4.500000,  7.457810,  1.542190,  1.777506, 7.222494,   &
    4.500000, 7.584345,  1.415655,  2.348636, 6.651364,   &
    4.500000, 7.562711,  1.437289,  1.572908, 7.427092 /
  ! Blockage due to feed legs, from ALMA Antenna Group Report #40 (2002-03-28)
  real :: rblock_melco(5), hblock_melco(5)
  data rblock_melco/   &
    0.375, 0.620, 0.625, 1.470, 6.000/
  data hblock_melco/   &
    0.0485, 0.0485, 0.0390, 0.0390, 0.0765/

  ! Temperature coefficients. 
  ! nPol, mPol are the ZernikePolynomial indices; 
  ! coeffPol are the corresponding temperature coefficients in mum/K
  integer :: mPol_melco(69), nPol_melco(69)
  data nPol_melco / &
       2,  2,  2, &
       3,  3,  3,  3, &
       4,  4,  4,  4,  4, &
       5,  5,  5,  5,  5,  5,  &
       6,  6,  6,  6,  6,  6,  6,  &
       7,  7,  7,  7,  7,  7,  7,  7,  &
       8,  8,  8,  8,  8,  8,  8,  8,  8,  &
       9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  &
      10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, &
      11, 11, 11, 11, 11, 11 /
  data mPol_melco / &
       2,  0, -2,  &
       3,  1, -1, -3, &
       4,  2,  0, -2, -4, &
       5,  3,  1, -1, -3, -5, &
       6,  4,  2,  0, -2, -4, -6, &
       7,  5,  3,  1, -1, -3, -5, -7, &
       8,  6,  4,  2,  0, -2, -4, -6, -8, &
       9,  7,  5,  3,  1, -1, -3, -5, -7, -9, &
       10, 8,  6,  4,  2,  0, -2, -4, -6, -8,-10, &
       11, 9,  7,  5,  3,  1 /
       
  !?  Note that odd-n terms have a reversed sign due to the different orientation 
  !? of axes in CLIC.
  real :: coeffPol_melco_1(33)
  data coeffPol_melco_1 / &
       0.06, -0.03, -0.06, &
       0.47, -0.01, -0.04, 0.65, &
       0.70, -0.04, 0.33, -0.50, 0.20, &
       0.13, -0.34, 0.03, 0.07, -0.20, -0.03, &
       0.05, -0.32, -0.13, 0.11, 0.32, -0.06, -0.03, &
       -0.08, -0.04, 0.02, 0.18, 0.17, -0.16, -0.17, 0.20 /
       
  real :: coeffPol_melco_2(69)
  data coeffPol_melco_2 / &
       0.29, -0.02, 0.59, &
       0.11, -0.04, -0.02, 0.35, &
       1.14, -0.11, -0.29, -0.09, -0.05, &
       -0.13, -0.19, 0.12, 0.02, -0.23, 0.18, &
       0.17, -0.66, 0.11, 0.21, -0.09, -0.01, 0.23, &
       -0.22, 0.03, 0.13, 0.06, 0.10, 0.18, -0.14, -0.25, &
       0.08, -0.04, -0.09, -0.11, -0.03, -0.02, 0.04, -0.12, 0.30, &
       0.05, 0.13, 0.10, 0.00, -0.09, -0.06, -0.17, -0.02, 0.08, 0.02, &
       0.25, -0.14, -0.10, -0.07, -0.05, 0.14, -0.10, 0.07, -0.07, -0.21, -0.10, &
       -0.08, -0.07, 0.03, 0.00, -0.08, -0.09 /
  real :: coeffPol_melco_3(33)
  data coeffPol_melco_3 / &
       -0.51, +0.03, -0.11,  &
       +0.15, -0.02, -0.01, +0.42, &
       +1.11, +0.17, -0.03, -0.08, +0.08, &
       +0.14, -0.07, +0.00, +0.28, -0.42, -0.01, &
       -0.02, -0.59, +0.06, +0.12, +0.31, +0.02, -0.18, &
       -0.21, -0.02, +0.01, +0.16, +0.10, +0.19, +0.05, -0.14 /
  !-----------------------------------------------------------
  !
  ant_type = type
  ! by default
  numPol = 0
  !
  ! Bure 15m antenna
  if ((ant_type.eq.type_bure).or.(ant_type.eq.type_bure2)) then
    diameter = 15.
    focus = 4.875
    nring = 6
    npan(1) = 16
    mmode(1) = 3
    if (ant_type.eq.type_bure2) then
       mmode(1) = 4   ! 4 screws on first ring
       call message(8,2,'SET PANELS','Using four screws on ring 1') 
    endif
    do i = 2, 6
      npan(i) = 32
      mmode(i) = 5
    enddo
    front_view = .false.
    ! external radius of each ring
    ray(0) = 0.744145782
    ray(1) = 1.971513790
    ray(2) = 3.169878381
    ray(3) = 4.326778338
    ray(4) = 5.435213519
    ray(5) = 6.492736021
    ray(6) = 7.500
    ! blockage
    nblock = 3
    rblock(1) = ray(0)
    rblock(2) = 5.3
    rblock(3) = 7.5
    hblock(1) = 0.040
    hblock(2) = 0.040
    hblock(3) = 0.200
    vblock = .false.           ! crossed (multiply shape) quadrupod.
    ! screws
    do ir = 1, nring
      nscr(ir) = mmode(ir)
      r1 = (ray(ir)-ray(ir-1))/2
      r0 = (ray(ir)+ray(ir-1))/2
      t0 = r0 / 2 / focus
      do is = 1, nscr(ir)
        ! coordinates of corner (or center if offset is zero)
        r = r0
        phi = 0
        if (xoscr(is,ir).lt.0) then
          r = ray(ir)
        elseif (xoscr(is,ir).gt.0) then
          r = ray(ir-1)
        endif
        if (yoscr(is,ir).lt.0) then
          phi = pi/npan(ir)
        elseif (yoscr(is,ir).gt.0) then
          phi = -pi/npan(ir)
        endif
        xscr(is,ir) = (r*cos(phi)-r0+(r**2-r0**2)/4/focus*t0)   &
          /sqrt(1+t0**2) + xoscr(is,ir)
        yscr(is,ir) = r*sin(phi) + yoscr(is,ir)
      enddo
    enddo
    ! no hole whatsoever
    nhole = 0
    do ir = 1, nring
       do im = 1, mmode(ir)
          modes(im,ir) = im
       enddo
    enddo
    if (ant_type.eq.type_bure2) then
       modes(4,1) = 5 ! ring1: use mode 5 instead of 4
    endif
  !
  ! IRAM 30m antenna
  elseif (ant_type.eq.type_iram30m) then
    diameter = 30.
    focus = 10.500 
    nring = 7
    npan(1) = 10
    mmode(1) = 5  ! Five screws in ring 1 
    npan(2) = 20
    mmode(2) = 4
    npan(3) = 20
    mmode(3) = 5  ! Five screws in ring 3
    do i = 4, 7
      npan(i) = 40
      mmode(i) = 4
    enddo
    front_view = .false.
    ! external radius of each ring
    ray(0) =  1.000
    ray(1) =  2.885
    ray(2) =  5.040
    ray(3) =  7.050
    ray(4) =  9.210
    ray(5) = 11.175
    ray(6) = 13.040
    ray(7) = 15.000
    ! blockage ## TBD ## : this is the 15m values multiplied by 2 (!).
    ! updated to follow Baars (2013: http://jacobbaars.de/Start/Welcome_files/BlockingPaper.pdf)
    nblock = 3
    rblock(1) = ray(0)
    rblock(2) = 10.
    rblock(3) = 15.
    hblock(1) = 0.20
    hblock(2) = 0.45
    hblock(3) = 2.00 ! 0.80
    vblock = .false.           ! crossed (multiply shape) quadrupod.
    ! screws
    do ir = 1, nring
      nscr(ir) = mmode(ir)
      r1 = (ray(ir)-ray(ir-1))/2
      r0 = (ray(ir)+ray(ir-1))/2
      t0 = r0 / 2 / focus
      do is = 1, nscr(ir)
        ! coordinates of corner (or center if offset is zero)
        r = r0
        phi = 0
        if (xoscr30(is,ir).lt.0) then
          r = ray(ir)
        elseif (xoscr30(is,ir).gt.0) then
          r = ray(ir-1)
        endif
        if (yoscr30(is,ir).lt.0) then
          phi = pi/npan(ir)
        elseif (yoscr30(is,ir).gt.0) then
          phi = -pi/npan(ir)
        endif
        xscr(is,ir) = (r*cos(phi)-r0+(r**2-r0**2)/4/focus*t0)   &
          /sqrt(1+t0**2) + xoscr30(is,ir)
        yscr(is,ir) = r*sin(phi) + yoscr30(is,ir)
      enddo
    enddo
    ! no hole whatsoever
    nhole = 0
    do ir = 1, nring
       do im = 1, mmode(ir)
          modes(im,ir) = im
       enddo
    enddo
  !
  ! ALMA Test Interferometer Vextex 12m antenna
  elseif (ant_type.eq.type_vx12m) then
    diameter = 12.
    focus = 4.8
    nring = 8
    do i=1, nring
      mmode(i) = 5
    enddo
    do i = 1, 2
      npan(i) = 12
    enddo
    do i = 3, 4
      npan(i) = 24
    enddo
    do i = 5, 8
      npan(i) = 48
    enddo
    ray(0) = 0.375
    ray(1) = 1.265
    ray(2) = 1.821
    ray(3) = 2.605
    ray(4) = 3.221
    ray(5) = 4.041
    ray(6) = 4.781
    ray(7) = 5.435
    ray(8) = 6.000
    front_view = .true.
    ! blockage
    nblock = 9
    do i=1, nblock
      rblock(i) = rblock_vx(i)
      hblock(i) = hblock_vx(i)
    enddo
    vblock = .true.            ! vertical (plus shape)  quadrupod.
    ! screws
    ! 5 screws, ar radius rscr_vx and angle tscr_vx
    do ir = 1, nring
      nscr(ir) = mmode(ir)
      r0 = (ray(ir)+ray(ir-1))/2
      t0 = r0 / 2 / focus
      do is = 1, nscr(ir)
        r = rscr_vx(is,ir)
        phi = tscr_vx(is,ir)-pi/npan(ir)
        xscr(is,ir) = (r*cos(phi)-r0+(r**2-r0**2)/4/focus*t0)   &
          /sqrt(1+t0**2)
        yscr(is,ir) = r*sin(phi)
      !               print 1999, '     xscr(',is,',',ir,')=',xscr(is,ir)
      !               print 1999, '     yscr(',is,',',ir,')=',yscr(is,ir)
      enddo
    enddo
    ! Hole for Optical Telescope
    nhole = 1
    ! for this one the hole in on the left side when looking at the surface.
    xhole(1) = 3.530
    yhole(1) = 0.290
    rhole(1) = 0.140
    do ir = 1, nring
      do im = 1, mmode(ir)
        modes(im,ir) = im
      enddo
    enddo
    ! temperature coefficients
    numPol = 10
    do i = 1, numPol
      mPol(i) = mpol_vx(i)
      nPol(i) = npol_vx(i)
      coeffPol(i) = coeffPol_vx(i)*1e-6 ! in meters/kelvin
    enddo
    ! test
    !numPol = 1
    !nPol(1) = 4
    !mPol(1) = 0
    !coeffPol(1) = 1.0e-6
  !
  ! ALMA Test Interferometer AEC 12m antenna
  elseif (ant_type.eq.type_aec12m) then
    diameter = 12.
    focus = 4.8
    nring = 5
    do i=1, nring
      mmode(i) = 5
    enddo
    npan(1) = 8
    npan(2) = 16
    do i = 3, 5
      npan(i) = 32
    enddo
    ! approximate values for now
    ray(0) = 0.37500
    ray(1) = 1.50626
    ray(2) = 2.63028
    ray(3) = 3.75430
    ray(4) = 4.87833
    ray(5) = 6.00000
    front_view = .true.
    ! blockage
    nblock = 2
    do i=1, nblock
      rblock(i) = rblock_aec(i)
      hblock(i) = hblock_aec(i)
    enddo
    vblock = .false.           ! crossed (multiply shape)  quadrupod.
    ! screws
    ! 5 screws, ar radius rscr_vx and angle tscr_vx
    do ir = 1, nring
      nscr(ir) = mmode(ir)
      r0 = (ray(ir)+ray(ir-1))/2
      t0 = r0 / 2 / focus
      do is = 1, nscr(ir)
        r = rscr_aec(is,ir)/1000.
        phi = (tscr_aec(is,ir)/180.-1./npan(ir))*pi
        xscr(is,ir) = (r*cos(phi)-r0+(r**2-r0**2)/4/focus*t0)   &
          /sqrt(1+t0**2)
        yscr(is,ir) = r*sin(phi)
      !               print 1999, '     xscr(',is,',',ir,')=',xscr(is,ir)
      !               print 1999, '     yscr(',is,',',ir,')=',yscr(is,ir)
      enddo
    enddo
    ! hole for optical telescope
    nhole = 1
    ! for this one the hole in on the right side when looking at the surface.
    xhole(1) = -3.46*cos((5.625-1.45)/180*pi)
    yhole(1) = 3.46*sin((5.625-1.45)/180*pi)
    rhole=0.145
    do ir = 1, nring
      do im = 1, mmode(ir)
        modes(im,ir) = im
      enddo
    enddo

  ! ALMA Test Interferometer MELCO 12m antenna
  elseif (ant_type.eq.type_melco12m_1 .or. ant_type.eq.type_melco12m_2 .or. &
       ant_type.eq.type_melco12m_3 .or. ant_type.eq.type_melco12m_4) then
    diameter = 12.
    focus = 4.8
    nring = 7
    !
    ray(0) = 0.375
    mmode(1) = 5
    npan(1) =  5
    ray(1) = 0.770582
    !
    mmode(2) = 4
    npan(2) =  20
    ray(2) = 1.715753
    !
    mmode(3) = 5
    npan(3) =  20
    ray(3) = 2.621734
    !
    mmode(4) = 4
    npan(4) =  40
    ray(4) = 3.521014
    !
    mmode(5) = 5
    npan(5) =  40
    ray(5) = 4.393722
    !
    mmode(6) = 5
    npan(6) =  40
    ray(6) = 5.237261
    !
    mmode(7) = 5
    npan(7) =  40
    ray(7) = 6.0000
    !
    ! do this for other types as well...
    do ir = 1, 7
      do im = 1, mmode(ir)
        modes(im,ir) = im
      enddo
      if (ir.eq.2 .or. ir.eq.4) then
        modes(4,ir) = 5
      endif    
    enddo
    !
    front_view = .true.
    ! blockage
    nblock = 5
    do i=1, nblock
      rblock(i) = rblock_melco(i)
      hblock(i) = hblock_melco(i)
    enddo
    vblock = .true.            ! vertical (plus shape)  quadrupod.
    ! screws
    ! 4 or 5 screws, ar radius rscr_vx and angle tscr_vx
    do ir = 1, nring
      nscr(ir) = mmode(ir)
      r0 = (ray(ir)+ray(ir-1))/2
      t0 = r0 / 2 / focus
      do is = 1, nscr(ir)
        r = rscr_melco(is,ir)/1000.
        phi = ( tscr_melco(is,ir)/180. -1./npan(ir) )*pi
        xscr(is,ir) = (r*cos(phi)-r0+(r**2-r0**2)/4/focus*t0)   &
          /sqrt(1+t0**2)
        yscr(is,ir) = r*sin(phi)
      !               print 1999, '     xscr(',is,',',ir,')=',xscr(is,ir)
      !               print 1999, '     yscr(',is,',',ir,')=',yscr(is,ir)
      enddo
    enddo
    ! Hole for Optical Telescope
    nhole = 1
    ! for this one the hole in on the left side when looking at the surface.
    xhole(1) = 3.572951*sin(85.5/180*pi)
    yhole(1) = 3.572951*cos(85.5/180*pi)
    rhole(1) = 0.145
    !
    ! temperature coefficients
    if (ant_type.eq.type_melco12m_1) then
      numPol = 33
      do i = 1, numPol
        mPol(i) = mpol_melco(i)
        nPol(i) = npol_melco(i)
        !!      coeffPol(i) = coeffPol_melco(i)*1e-6 ! in meters/kelvin
        ! there is an ad-hoc normalization factor (0.5) here to reproduce the melco results.
        coeffPol(i) = coeffPol_melco_1(i)*1e-6*0.5
      enddo
    elseif (ant_type.eq.type_melco12m_2) then
      numPol = 69
      do i = 1, numPol
        mPol(i) = mpol_melco(i)
        nPol(i) = npol_melco(i)
        !!      coeffPol(i) = coeffPol_melco(i)*1e-6 ! in meters/kelvin
        ! there is an ad-hoc normalization factor (0.5) here to reproduce the melco results.
        coeffPol(i) = coeffPol_melco_2(i)*1e-6*0.5
      enddo
    elseif (ant_type.eq.type_melco12m_3) then
      numPol = 33
      do i = 1, numPol
        mPol(i) = mpol_melco(i)
        nPol(i) = npol_melco(i)
        !!      coeffPol(i) = coeffPol_melco(i)*1e-6 ! in meters/kelvin
        ! there is an ad-hoc normalization factor (0.5) here to reproduce the melco results.
        coeffPol(i) = coeffPol_melco_3(i)*1e-6*0.5
      enddo
    endif
  endif
  return
end subroutine set_panels
!
subroutine get_rigging(elevation, riggingElevation, correction, error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  include 'clic_panels.inc'
  real :: elevation, riggingElevation(2), correction(mring, mpan, mm)
  logical error
  ! Global
  include 'gbl_pi.inc'
  ! Local
  integer :: lun, iring, ipanel, iscrew, i
  real :: def_bias, def_elev, dy, dz, x, y
  character :: infile*256, chain*256, file*256
  !
  error = sic_getlun(lun).ne.1
  if (error) then
    call message(8,4,'Get_rigging','No logical unit left')
    return
  endif
  ! get data from file
  if (ANT_TYPE.eq.TYPE_VX12M) then 
    infile = 'gravDef_VERTEX_12.dat'
  elseif (ANT_TYPE.eq.TYPE_AEC12M) then
    infile = 'gravDef_AEC_12.dat'
  elseif (ant_type.ge.type_melco12m_1 .and. ant_type.le.type_melco12m_4) then
    infile = 'gravDef_MITSUBISHI_12.dat'
  elseif (ant_type.eq.type_iram30m) then
    infile = 'gravDef_30m.dat'
  endif
  if (.not.sic_query_file(infile,'data#dir:','',file)) then
    call message(8,4,'Get_rigging','Deformation file not found')
    error = .true.
    return
  endif



  open (lun, file=file(1:lenc(file)), err=999)
  read(lun,'(a)', err=999) chain
  read(lun,'(a)', err=999) chain
  i = 1
10 read (lun, *, end=20, err=999) iring, ipanel, iscrew, x, y, dy, dz
  ! the deformation are tabulated in micrometers...
  dy = dy/1e6
  dz = dz/1e6
  
  ! deformation bias set to be:
  def_bias = dz*(sin(riggingElevation(1)) + sin(riggingElevation(2)))/2.   &
       + dy*(cos(riggingElevation(1)) + cos(riggingElevation(2)))/2.
          
  ! deformation at observed elevation:
  def_elev = (dz*sin (elevation) + dy*cos(elevation)) 
  ! compute correction in meters.
  ! The correction to be added to screw motions is the opposite of the
  ! differential gravitational deformation.
  correction(iring, ipanel, iscrew) = def_elev - def_bias

  i = i+1
  goto 10
20 close(lun)
  call sic_frelun(lun)
  return
999 error = .true.
  call message(8,4,'Get_rigging','No logical unit left')
  
  return


end subroutine get_rigging


subroutine rigging_mode(phas,nxap,xref,xval,xinc,rlam,   &
     elevation, riggingElevation, error)
  include 'clic_panels.inc'
  logical :: error
  integer :: nxap                   !
  real :: phas(nxap,nxap)           !
  real, allocatable :: correction(:,:,:)
  real :: xref                      !
  real :: xval                      !
  real :: xinc                      !
  real :: rlam, xx, yy, fmode                      !
  real :: am(mm,mring,mpan)         !
  real :: ae(mm,mring,mpan)         !
  real :: elevation, riggingElevation(2)             !  
  integer :: nmode 
  integer :: ir, ip, is, k, im, nm
  real*8 :: a(mm, mm), b(mm), sig

  allocate(correction(mring, mpan, mm))
  call get_rigging(elevation, riggingElevation, correction, &
       error)
  if (error) then
    write(6,*) 'No gravitational deformation available.'
    return
  endif
  write(6,*) 'Found gravitational deformation data.'
  do ir = 1, nring
    do ip=1,npan(ir)
      k = 0
      do is = 1, nscr(ir)
        xx = xscr(is,ir)
        yy = yscr(is,ir)
        nm = mmode(ir)
        do im=1, nm
          a(is,im) = fmode(im,ir,xx,yy)
        enddo
        b(is) = correction(ir, ip, is)
      enddo
      call mth_fitlin ('MODE',nscr(ir),nm,a,b,mm,sig)
      do k=1, nscr(ir)
        am(k,ir,ip) = b(k)
      enddo
    enddo
  enddo
  nmode = 5
  call modemap(phas,nxap,rlam, xref, xval, xinc, am, ae, nmode)
  ! 
  !print *, '*** rigging_mode OK ***'
      
end subroutine rigging_mode

subroutine temperature_mode(phTemp, nxap, xref, xval, xinc, rlam,   &
     temperature, biasTemperature, error)
  ! should we fit panbel shapes in the modeled temp deformation or use it
  !  directly...
  ! Global
  include 'gbl_pi.inc'
  include 'clic_panels.inc'
  logical :: error
  integer :: nxap                   !
  real :: phTemp(nxap,nxap)           !
  real :: xref, xval, xinc                      !
  real :: rlam, temperature, biasTemperature
 
  ! local variables:
  integer :: ix, iy, k
  real*8 :: x, y, phi, rad2, rho, zpol, apol, pol, cosa, radius
  !
  radius = diameter/2
  do  iy = 1, nxap
    y = xval+xinc*(iy-xref)
    do ix = 1, nxap
      x = xval+xinc*(ix-xref)
      phi = atan2(y, x)
      rad2 = x**2 + y**2
      rho = sqrt(rad2) /radius
      zpol = 0
      do k=1, numPol
        call zernike_poly ( abs(mPol(k)), nPol(k),  rho, apol )
        if (mPol(k).gt.0) then
          pol = apol*cos(mPol(k)*phi)* sqrt(2*(nPol(k)+1)/pis)
        elseif (mPol(k).lt.0) then
          pol = apol*sin(mPol(k)*phi)* sqrt(2*(nPol(k)+1)/pis)
        else
          pol = apol*sqrt((nPol(k)+1)/pis)
        endif
        zpol = zpol + pol * coeffpol(k) * (biasTemperature-temperature)
      enddo
      cosa  =  1./sqrt(1.+rad2/4/focus**2)
      ! they have defined the pol expansion in half pathlength, 
      ! not normal displacement.
      !! phTemp(ix,iy) = 4.*pis*zpol*cosa/rlam   !aperture phase
      phTemp(ix,iy) = 4.*pis*zpol/rlam   !aperture phase
      !! phTemp(ix,iy) = phTemp(ix,iy) * sqrt(pis) ! ad hoc ?
    enddo
  enddo
end subroutine temperature_mode

!------------------------------------------------------------------------- 
subroutine zernike_poly ( m, n, rho, z )

  !*****************************************************************************80
  !
  !! ZERNIKE_POLY evaluates a Zernike polynomial at RHO.
  !
  !  Discussion:
  !
  !    This routine uses the facts that:
  !
  !    *) R^M_N = 0 if M < 0, or N < 0, or N < M.
  !    *) R^M_M = RHO^M
  !    *) R^M_N = 0 if mod ( N - M ) = 1.
  !
  !    and the recursion:
  !
  !    R^M_(N+2) = A * [ ( B * RHO**2 - C ) * R^M_N - D * R^M_(N-2) ]
  !
  !    where 
  !
  !    A = ( N + 2 ) / ( ( N + 2 )**2 - M**2 )
  !    B = 4 * ( N + 1 )
  !    C = ( N + M )**2 / N + ( N - M + 2 )**2 / ( N + 2 )
  !    D = ( N**2 - M**2 ) / N
  !
  !    I wish I could clean up the recursion in the code, but for
  !    now, I have to treat the case M = 0 specially.
  !
  !  Licensing:
  !
  !    This code is distributed under the GNU LGPL license. 
  !
  !  Modified:
  !
  !    11 November 2005
  !
  !  Author:
  !
  !    John Burkardt
  !
  !  Reference:
  !
  !    Eric Weisstein,
  !    CRC Concise Encyclopedia of Mathematics,
  !    CRC Press, 2002,
  !    Second edition,
  !    ISBN: 1584883472,
  !    LC: QA5.W45
  !
  !  Parameters:
  !
  !    Input, integer ( kind = 4 ) M, the upper index.
  !
  !    Input, integer ( kind = 4 ) N, the lower index.
  !
  !    Input, real ( kind = 8 ) RHO, the radial coordinate.
  !
  !    Output, real ( kind = 8 ) Z, the value of the Zernike 
  !    polynomial R^M_N at the point RHO.
  !
  ! 
  implicit none

  real    ( kind = 8 ) a
  real    ( kind = 8 ) b
  real    ( kind = 8 ) c
  real    ( kind = 8 ) d
  integer ( kind = 4 ), parameter :: i4_2 = 2
  integer ( kind = 4 ) m
  integer ( kind = 4 ) n
  integer ( kind = 4 ) nn
  real    ( kind = 8 ) rho
  real    ( kind = 8 ) z
  real    ( kind = 8 ) zm2
  real    ( kind = 8 ) zp2
  !
  !  Do checks.
  !
  if ( m < 0 ) then
    z = 0.0D+00
    return
  end if

  if ( n < 0 ) then
    z = 0.0D+00
    return
  end if

  if ( n < m ) then
    z = 0.0D+00
    return
  end if

  if ( mod ( n - m, i4_2 ) == 1 ) then
    z = 0.0D+00
    return
  end if

  zm2 = 0.0D+00
  z = rho**m

  if ( m == 0 ) then

    if ( n == 0 ) then
      return
    end if

    zm2 = z
    z = 2.0D+00 * rho**2 - 1.0D+00

    do nn = m+2, n-2, 2

      a = real ( nn + 2, kind = 8 ) / real ( ( nn + 2 )**2 - m**2, kind = 8 )
      b = real ( 4 * ( nn + 1 ), kind = 8 )
      c = real ( ( nn + m )**2, kind = 8 ) / real ( nn, kind = 8 ) &
           + real ( ( nn - m + 2 )**2, kind = 8 ) / real ( nn + 2, kind = 8 )
      d = real ( nn**2 - m**2, kind = 8 ) / real ( nn, kind = 8 )

      zp2 = a * ( ( b * rho**2 - c ) * z - d * zm2 ) 
      zm2 = z
      z = zp2

    end do

    

  else

    do nn = m, n-2, 2

      a = real ( nn + 2, kind = 8 ) / real ( ( nn + 2 )**2 - m**2, kind = 8 )
      b = real ( 4 * ( nn + 1 ), kind = 8 )
      c = real ( ( nn + m )**2, kind = 8 ) / real ( nn, kind = 8 ) &
           + real ( ( nn - m + 2 )**2, kind = 8 ) / real ( nn + 2, kind = 8 )
      d = real ( nn**2 - m**2, kind = 8 ) / real ( nn, kind = 8 )

      zp2 = a * ( ( b * rho**2 - c ) * z - d * zm2 ) 
      zm2 = z
      z = zp2

    end do

  end if

  return
end subroutine zernike_poly

subroutine clic_grid_tp(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  use clic_xypar
  !---------------------------------------------------------------------
  ! CLIC
  ! GRID_TOTAL computes a total power map.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  include 'clic_panels.inc'
  include 'clic_proc_par.inc'
  ! Local
  logical :: plot, end
  integer :: ll
  integer :: iant, nx, ny, nd
  real :: dx, dy, vx, vy
  real :: rx, ry
  integer :: nvis, mvis
  integer :: ivis
  real :: beamsize
  integer(kind=address_length) :: ipx
  integer(kind=address_length) :: addrvis, ipvis
  real :: tmin, tmax, thres, fudge
  !
  real ::      lambda1, lambda2, beta1, beta2, msize
  save addrvis
  !
  !------------------------------------------------------------------------
  ! Code:
  plot = sic_present(1,0)
  tmin = 0.
  tmax = 0.
  if (plot) then
    call sic_r4(line,1,1,tmin,.false.,error)
    if (error) goto 999
    call sic_r4(line,1,2,tmax,.false.,error)
    if (error) goto 999
  endif
  ! size in arc seconds (for baseline)
  msize = 0.
  call sic_r4(line,0,1,msize,.false.,error)
  if (error) goto 999
  fudge = 0.
  call sic_r4(line,0,2,fudge,.false.,error)
  if (error) goto 999
  !
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  call get_first(.true.,error)
  if (error) goto 999
  call switch_antenna
  iant = -i_base(1)
  write(6,*) 'I-GRID_TOTAL, Using Antenna ', r_kant(iant)
  !
  ! Count measurement points (`visibilities')
  !
  nvis = 0
  call get_first(.true.,error)
  if (error) goto 999
  end = .false.
  do while (.not.end)
    nvis = nvis + r_ndump
    call get_next(end,error)
    if (error) goto 999
  enddo
  !
  ! Get memory for visibility table (4 columns: lam, beta, weight, tp)
  !
  if (mvis.lt.nvis*4) then
    if (mvis.gt.0) call free_vm(mvis,addrvis)
    mvis= 4*nvis
    if (sic_getvm(mvis,addrvis).ne.1) goto 999
  endif
  ipvis = gag_pointer(addrvis,memory)
  !
  ! Get the visibility table : pointer ipvis
  ! get also map limits
  !
  lambda1 = 1e10
  lambda2 = -1e10
  beta1 = 1e10
  beta2 = -1e10
  ivis = 0
  call get_first(.true.,error)
  if (error) goto 999
  end = .false.
  do while (.not.end)
    call load_tp(iant, nvis, ivis, memory(ipvis),   &
      lambda1, lambda2, beta1, beta2, msize, fudge, error)
    if (error) goto 999
    call get_next(end,error)
    if (error) goto 999
  enddo
  !
  ! Get map size
  if (r_teles.eq.'VTX-ALMATI') then
    write(6,*) 'I-GRID_TOTAL, ALMA Vertex 12m Antenna '
    call set_panels(type_vx12m)
  elseif (r_teles.eq.'AEC-ALMATI') then
    write(6,*) 'I-GRID_TOTAL, ALMA AEC 12m Antenna '
    call set_panels(type_aec12m)
  else
    write(6,*) 'I-GRID_TOTAL, IRAM/Bure 15-m Antenna '
    call set_panels(type_bure)
  endif
  ! this is the half power  beam size
  beamsize = 41*(115000./r_flo1)*(15./diameter)   &
    *pi/180/3600
  dx = beamsize/4.
  dy = beamsize/4.
  nx = (lambda2-lambda1)*pi/180/3600 /dx + 1
  ny = (beta2-beta1)*pi/180/3600  /dy + 1
  rx = (nx+1)/2
  ry = (ny+1)/2
  vx = lambda1*pi/180/3600 +(rx-1.)*dx
  vy = beta1*pi/180/3600 +(ry-1.)*dy
  !
  print 1000, 'I-GRID_TOTAL, Beamsize ',beamsize*180*3600/pi, '"'
1000 format(a,f8.1,a)
  print 1001, 'I-GRID_TOTAL, Map size ', nx,' x ', ny,   &
    '(',nx*dx*180*3600/pi, ' x ',ny*dy*180*3600/pi, '")'
1001 format(a,i3,a,i3,a,f8.1,a,f8.1,a)
  !
  !     Create map file
  call open_tpmap(nx, ny, rx, ry, vx, vy, dx, dy,   &
    r_kant(iant), error)
  if (error) goto 999
  ipx = gag_pointer(xima%loca%addr,memory)
  !
  ! Grid the visibility table into the visibility (beam) map (in X)
  !
  nd = 1+3
  ! Weight Threshold for blanking
  thres = 0.
  call sub_grid(nvis, memory(ipvis), beamsize, nd, thres, error)
  !
  ! formally transpose (note that xima%gil%dim(1) = 1 ...)
  xima%gil%dim(1) = xima%gil%dim(2)
  xima%gil%ref(1) = xima%gil%ref(2)
  xima%gil%val(1) = xima%gil%val(2)
  xima%gil%inc(1) = xima%gil%inc(2)
  xima%gil%dim(2) = xima%gil%dim(3)
  xima%gil%ref(2) = xima%gil%ref(3)
  xima%gil%val(2) = xima%gil%val(3)
  xima%gil%inc(2) = xima%gil%inc(3)
  xima%gil%dim(3) = 1
  xima%gil%ref(3) = 1.0
  xima%gil%val(3) = 0.0
  xima%gil%inc(3) = 1.0
  xima%char%code(1) = xima%char%code(2)
  xima%char%code(2) = xima%char%code(3)
  !
  ! Mask outper parts
  if (msize.gt.0) then
    call mask_tpmap(xima%gil%dim(1), xima%gil%dim(2), memory(ipx), msize)
  endif
  !
  ! Optionally plot
  if (plot) then
    call plot_tpmap(tmin, tmax, error)
  endif
  ll = lenc(line)
  !
  ! Close files and return
  ! call gdf_fris (xima%loca%islo,error)
  call gdf_write_data (xima, xima%r2d, error)
  call gdf_close_image (xima, error)
  return
  !
999 error = .true.
end subroutine clic_grid_tp
!
subroutine load_tp(iant,nvis,ivis,vis,   &
    lambda1, lambda2, beta1, beta2, msize, fudge, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_xypar
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC
  !	Support routine for GRID_TP
  ! Arguments:
  !	IANT	I	antenna used
  !       TIME_MAX R*4    Max. integration time (compression)
  !---------------------------------------------------------------------
  integer :: iant                   !
  integer :: nvis                   !
  integer :: ivis                   !
  real :: vis(4,nvis)               !
  real :: lambda1                   !
  real :: lambda2                   !
  real :: beta1                     !
  real :: beta2                     !
  real :: msize                     !
  real :: fudge                     !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_point.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  include 'clic_number.inc'
  include 'clic_proc_par.inc'
  ! Local
  real :: my_total
  !
  integer(kind=address_length) :: data_in, ipk
  integer(kind=address_length) :: addrvis2, ipvis2, iph
  integer(kind=data_length)    :: ldata_in, h_offset
  integer :: i_loop
  integer :: ir
  real :: p_tolerance, msrad
  real :: f
  integer :: pvis, kvis, mvis2, kfudge, i
  save mvis2, addrvis2
  data mvis2/0/
  !
  !------------------------------------------------------------------------
  !
  error = .false.
  p_tolerance=500
  !
  call get_data (ldata_in,data_in,error)
  if (error) goto 999
  !
  ! Loop on records
  print *, 'fudge ',fudge
  kvis = ivis
  ipk = gag_pointer(data_in,memory)
  do i_loop = 1, n_loop
    do ir = rec_1(i_loop), min(r_ndump,rec_2(i_loop)),   &
        rec_3(i_loop)
      iph = ipk + h_offset(ir)
      call decode_header (memory(iph))
      if (ivis.lt.nvis .and.   &
        (max(abs(dh_rmspe(1,iant)),   &
        abs(dh_rmspe(2,iant))).lt. p_tolerance) )   &
        then
        ivis = ivis + 1
        vis(1,ivis) = dh_offlam(iant)   &
          *pi/180/3600
        vis(2,ivis) = dh_offbet(iant)*pi/180/3600
        vis(3,ivis) = dh_integ ! as weight.
        !c               vis(4,ivis) = dh_total(iant)
        vis(4,ivis) = my_total(do_polar,iant)
        !
        lambda1 = min(dh_offlam(iant), lambda1)
        lambda2 = max(dh_offlam(iant), lambda2)
        beta1 = min(dh_offbet(iant), beta1)
        beta2 = max(dh_offbet(iant), beta2)
      endif
    enddo
  enddo
  !
  if (fudge.ne.0) then
    f = fudge*pi/180/3600
    if (abs(vis(1,ivis)-vis(1,kvis+1))   &
      .gt.abs(vis(2,ivis)-vis(2,kvis+1))) then
      kfudge = 1
    else
      kfudge = 2
    endif
    if (vis(kfudge,ivis).gt.vis(kfudge,kvis)) then
      do i = kvis+1, ivis
        vis(kfudge,i) =  vis(kfudge,i) + f
      enddo
    else
      do i = kvis+1, ivis
        vis(kfudge,i) =  vis(kfudge,i) - f
      enddo
    endif
  endif
  !
  if (msize .gt. 0) then
    pvis = ivis-kvis
    if (mvis2.lt.pvis*6) then
      if (mvis2.gt.0) call free_vm(mvis2, addrvis2)
      mvis2= pvis*6
      if (sic_getvm(mvis2,addrvis2) .ne. 1) goto 999
    endif
    ipvis2 = gag_pointer(addrvis2, memory)
    msrad = msize*pi/180/3600
    call do_baseline(pvis, vis(1,kvis+1), msrad,   &
      memory(ipvis2), memory(ipvis2+4*pvis),error)
  endif
  if (error) goto 999
  return
  !
999 error = .true.
  return
end subroutine load_tp
!
subroutine do_baseline(pvis, vis, msize, a, b, error)
  use gildas_def
  integer :: pvis                   !
  real :: vis(4,pvis)               !
  real :: msize                     !
  real*8 :: a(pvis,2)               !
  real*8 :: b(pvis)                 !
  logical :: error                  !
  ! Local
  integer :: nvar, i, k, ndd, kx
  real*8 :: sigma
  !
  nvar = 2
  i = 0
  if (abs(vis(1,pvis)-vis(1,1)).gt.(abs(vis(1,pvis)-vis(1,1)))) then
    kx = 1
  else
    kx = 2
  endif
  do k=1, pvis
    if ((abs(vis(1,k)).gt.msize/2)   &
      .or. (abs(vis(2,k)).gt.msize/2)) then
      i = i + 1
      a(i,1) = vis(kx,k)
      a(i,2) = 1
      b(i) = vis(4,k)
    endif
  enddo
  ndd = i
  if (ndd.lt.2) then
    call message(8,4,'DO_BASELINE','Too few baseline points')
    error = .true.
    return
  endif
  call mth_fitlin ('DO_BASELINE',ndd,nvar,a,b,pvis,sigma)
  do k=1, pvis
    vis(4,k) = vis(4,k) - b(1)*vis(kx,k) - b(2)
  enddo
end subroutine do_baseline
!
subroutine open_tpmap(nx,ny,rx,ry,vx,vy,dx,dy,iant,error)
  use gildas_def
  use gkernel_interfaces
  use gbl_format
  use classic_api  
  use clic_xypar
  !---------------------------------------------------------------------
  ! Open map GDF files
  ! input:
  !     NX, NY number of pixel on each axis for beam map
  !     DX, DY coordinate increments, in radians!
  !     RX, RY pixel numbers for center (0,0)
  !     IANT   physical number of antenna
  !     ERROR  error return
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real :: rx                        !
  real :: ry                        !
  real :: vx                        !
  real :: vy                        !
  real :: dx                        !
  real :: dy                        !
  integer :: iant                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  ! Local
  integer :: iband
!  integer(kind=index_length) :: blc(4),trc(4)
  integer :: i
  ! Data
!  data blc/4*0/, trc/4*0/
  !-----------------------------------------------------------------------
  error = .false.
  call gildas_null(xima)
  !
  write (xima%file(1:5),'(i4.0,a1)') r_scan,'-'
  call datec (r_dobs,xima%file(6:16),error)
  i = lenc(r_sourc)
  xima%file(17:) = '-'//r_sourc(1:i)//'-beam.tpm'
  i = lenc(xima%file)
  call sic_lower(xima%file(1:i))
  xima%gil%blan_words = 2
  xima%gil%extr_words = 6
  xima%gil%desc_words = 18
  xima%gil%posi_words = 12
  xima%gil%proj_words = 9
  xima%gil%spec_words = 12
  xima%gil%reso_words = 3
  xima%gil%bval = -1000.
  xima%gil%eval = 0.1
  !
  xima%gil%dim(1) = 1
  xima%gil%ref(1) = 1.0
  xima%gil%val(1) = 0.0
  xima%gil%inc(1) = 1.0
  xima%gil%dim(2) = nx
  xima%gil%ref(2) = rx
  xima%gil%val(2) = vx
  xima%gil%inc(2) = dx
  xima%gil%dim(3) = ny
  xima%gil%ref(3) = ry
  xima%gil%val(3) = vy
  xima%gil%inc(3) = dy
  xima%gil%dim(4) = 1
  xima%gil%ndim = 3
  ! Note: could not find the 'recommended' designations
  xima%char%code(2) = 'AZ'             !!!  'RA'
  xima%char%code(3) = 'EL'             !!! 'DEC'
  xima%char%unit = 'Jy'
  xima%char%syst = 'UNKNOWN'           !!! 'EQUATORIAL'
  xima%char%name = r_sourc
  xima%gil%ra = r_az
  xima%gil%dec = r_el
  xima%gil%epoc = r_epoch
  xima%gil%ptyp = p_azimuthal
  xima%gil%a0 = xima%gil%ra
  xima%gil%d0 = xima%gil%dec
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%char%line = r_line
  iband = i_band(1)
  if (iband.eq.1) then
    xima%gil%freq = r_flo1+r_fif1
  elseif (iband.eq.2) then
    xima%gil%freq = r_flo1-r_fif1
  else
    xima%gil%freq = r_flo1
  endif
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2) * xima%gil%dim(3)
  xima%gil%form = fmt_r4
  xima%char%type = 'GILDAS_IMAGE'
  !
!  call gdf_geis (xima%loca%islo,error)
!  if (error) return
!  call gdf_writ (xima,xima%loca%islo,error)
!  if (error) return
!  call gdf_cris (xima%loca%islo,xima%char%type,xima%file,xima%gil%form,xima%loca%size,error)
!  if (error) return
!  call gdf_gems (xima%loca%mslo,xima%loca%islo,blc,trc,xima%loca%addr,xima%gil%form,error)
!  if (error) return
  call gdf_create_image (xima, error)
  call gdf_allocate(xima, error)
  xima%loca%addr = locwrd (xima%r2d)
  !
  return
end subroutine open_tpmap
!
subroutine plot_tpmap(tmin, tmax, error)
  use gildas_def
  use gkernel_interfaces
  use clic_xypar
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  real :: tmin                      !
  real :: tmax                      !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer :: nx, ny, lch, nexpo, n1, n2
  integer(kind=address_length) :: ipx
  real :: range, am, sp
  real*8 :: conv(6)
  character(len=132) :: ch
  !---------------------------------------------------------------------
  nx = xima%gil%dim(1)
  conv(1:3) = xima%gil%convert(:,1)
  ny = xima%gil%dim(2)
  conv(4:6) = xima%gil%convert(:,2)
  ipx = gag_pointer(xima%loca%addr,memory)
  !      print *, 'nx, ny, conv, ipx'
  !      print *, nx, ny, conv, ipx
  if (nx.lt.2) then
    call message(8,3,'plot_tpmap','Only one pixel or less in X')
    error = .true.
    return
  endif
  if (ny.lt.2) then
    call message(8,3,'plot_tpmap','Only one pixel or less in Y')
    error = .true.
    return
  endif
  call gr4_rgive(nx, ny, conv, memory(ipx))
  call gr_exec('DESTROY ALL')
  !
  ! Box and image
  if (tmin.eq.tmax) then
    call t_extr(nx*ny, memory(ipx), xima%gil%bval, xima%gil%eval, tmin, tmax)
  endif
  if (tmin.eq.tmax) then
    error = .true.
    return
  endif
  call gr_exec('LIMITS /RG')
  call gr_exec('SHOW LIMITS')
  ! test limits
  call check_limits(error)
  if (error) return
  call gr_exec('SET BOX MATCH')
  write (ch,'(a, 2e12.4, a, 2e12.4)')   &
    'PLOT /SCALING LINEAR ',tmin, tmax,   &
    ' /BLANKING ',xima%gil%bval, xima%gil%eval
  lch = lenc(ch)
  call gr_exec(ch(1:lch))
  call gr_exec('WEDGE')
  call gr_exec('BOX /UNIT S')
  call gr_exec('LABEL "Az. Offset (`)" /X')
  call gr_exec('LABEL "El. Offset (`)" /Y')
  !
  ! Contours
  range = log10(abs(tmax-tmin))
  nexpo = int(20.+range)-21
  am = range-nexpo-1
  sp = 10.**(nexpo+1)
  if (am.lt.0.25) then
    sp = 2.*10.**nexpo
  elseif (am.lt.0.60) then
    sp = 5.*10.**nexpo
  elseif (am.lt.0.90) then
    sp = 10.*10.**nexpo
  else
    sp = 2.*10.**(nexpo+1)
  endif
  n1 = int(tmin/sp)
  n2 = int(tmax/sp)+1
  if (n1*n2 .gt.0) then
    write (ch,'(3(a,e10.3))') 'LEVEL ',n1*sp,   &
      ' to ',n2*sp,' by ',sp
  else
    write (ch,'(6(a,e10.3))') 'LEVEL ',n1*sp,' to ',-sp,   &
      ' by ',sp,' ',sp,' to ',n2*sp,' by ',sp
  endif
  lch = lenc(ch)
  call gr_exec(ch(1:lch))
  write (ch,'(a, 2e10.3)') 'RGMAP QUIET /BLANK ',   &
    xima%gil%bval, xima%gil%eval
  lch = lenc(ch)
  call gr_exec2(ch(1:lch))
  write (ch,'(a,g10.3)') 'Contour step ',sp
  lch = lenc(ch)
  call gr_exec('DRAW TEXT -0.1 -0.1 "'//ch(1:lch)//'" 1 /BOX 9')
  !
  call out0('Chain',1.,1.,error)
  call titout('Brief',error)
  call out2(ch,error)
  lch = lenc(ch)
  call gr_exec('DRAW TEXT 0. 0.1 "'//ch(1:lch)//'" 9 /BOX 7')
  !
  call gtclal
  call gr_execl('CHANGE DIRECTORY <GREG')
return
end subroutine plot_tpmap
!
subroutine t_extr(n, y, bval, eval, ymin, ymax)
  integer :: n                      !
  real :: y(n)                      !
  real :: bval                      !
  real :: eval                      !
  real :: ymin                      !
  real :: ymax                      !
  ! Local
  integer :: i
  !
  ymin = 1e30
  ymax = -1e30
  do i=1, n
    if (abs(y(i)-bval).gt.eval) then
      ymin = min (ymin, y(i))
      ymax = max (ymax, y(i))
    endif
  enddo
end subroutine t_extr
!
subroutine mask_tpmap(nx,ny, tp, size)
  use gildas_def
  use clic_xypar
  integer :: nx                     !
  integer :: ny                     !
  real :: tp(nx,ny)                 !
  real :: size                      !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real :: s
  integer :: i, j
  real :: x, y
  s = size*pi/180./3600./2.
  do j = 1,  ny
    y = (j-xima%gil%ref(2))*xima%gil%inc(2) + xima%gil%val(2)
    do i = 1, nx
      x = (i-xima%gil%ref(1))*xima%gil%inc(1) + xima%gil%val(1)
      if ((abs(y).gt.s).or.(abs(x).gt.s)) then
        tp(i,j) = xima%gil%bval
      endif
    enddo
  enddo
  return
end subroutine mask_tpmap
!
subroutine check_limits(error)
  use gkernel_interfaces
  logical :: error                  !
  ! Local
  real :: uxmin, uymin, uxmax, uymax, bxmin, bxmax, bymin, bymax
  !
  call sic_get_real('USER_XMIN',uxmin,error)
  call sic_get_real('USER_XMAX',uxmax,error)
  call sic_get_real('USER_YMIN',uymin,error)
  call sic_get_real('USER_YMAX',uymax,error)
  call sic_get_real('BOX_XMIN',bxmin,error)
  call sic_get_real('BOX_XMAX',bxmax,error)
  call sic_get_real('BOX_YMIN',bymin,error)
  call sic_get_real('BOX_YMAX',bymax,error)
  if (uxmin.eq.uxmax .or. uymin.eq.uymax) then
    call message(8,3,'CHECK_LIMITS', 'Invalid User limits')
    error = .true.
  endif
  if (bymin.eq.bymax .or. bymin.eq.bymax) then
    call message(8,3,'CHECK_LIMITS', 'Invalid Box limits')
    error = .true.
  endif
end subroutine check_limits

!
!--------------------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoSubscanList.f90">
!   <VERSION>
!              Id: modulePakoSubscanList.f90,v 1.2.3  2014-10-20 Hans Ungerechts
!              Id: modulePakoSubscanList.f90,v 1.2.3  2014-10-15 Hans Ungerechts
!              Id: modulePakoSubscanList.f90,v 1.2.3  2014-09-23 Hans Ungerechts
!              Id: modulePakoSubscanList.f90,v 1.2.2  2013-01-24 Hans Ungerechts
!              based on:
!              Id: modulePakoSubscanList.f90,v 1.1.13 2012-10-29 Hans Ungerechts
!   </VERSION>
!   <HISTORY>

!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                
!   </FAMILY>
!   <SIBLINGS>

!   </SIBLINGS>        
!
!   Pako module for subscan lists
!   <-- used by other modules, in particular observing modes and DIY
!   list of subscans and segments generated directly with user commands
!   or by the "analyze" subroutines of the observing modes
!
! </DOCUMENTATION> <!-- name="modulePakoSubscanList.f90" -->
!
!--------------------------------------------------------------------------------
!
!
Module modulePakoSubscanList
  !
  Use modulePakoMessages
  Use modulePakoTypes
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  !
  !
  Use gbl_message
  Implicit None
  Save
  Private
  !
  ! ***   data types and variables
  !
  Public  :: nSegments                 ! total number of segments -- DEPRECATED
  !
  ! *     points
  Public  :: pII
  !
  Public  :: dimensionList             ! dimension of segment list
  !
  ! *     subscans                     ! DEPRECATED
  Public  :: subscanType,     ssList,    ssDefault
  !
  ! *     segments
  Public  :: segmentType,     segList,   segDefault,  segOtfII
  !
  ! ***   subroutines
  Public  :: saveSubscanList            ! save into .pako script 
  Public  :: startSubscanList           ! write complete XML for start of subscan list
  Public  :: writeXMLsubscanList        ! write XML only for subscan list
  Public  :: getNumberSegments          ! get     number of segments
  Public  :: getCountSubscans           ! get     subscan counter
  Public  :: getCountSegments           ! get     segment    "
  Public  :: countSubscans              ! control subscan counter
  Public  :: countSegments              !         segment    "
  Public  :: listSegmentList            ! list  nicely   list of segments
  Public  :: plotSegmentList            ! plot           list of segments
  Public  :: printSegmentList           ! print detailed list of segments
  !
  ! ***   type for list of segments
  !
  Type    :: segmentType
     Logical           :: newSubscan     = .False. ! flag for start of new subscan
     Logical           :: updateDoppler  = .False. ! update Doppler correction
     Integer           :: scanNumber     = 0       ! scan number (dummy)
     Integer           :: ssNumber       = 0       ! subscan number
     Integer           :: segNumber      = 0       ! segment number
     Character(len=24) :: ssType         = "none"  ! subscan type
     Character(len=24) :: segType        = "none"  ! segment type
     Character(len=24) :: angleUnit      = "none"  
     Character(len=24) :: speedUnit      = "none" 
     Logical           :: flagOn         = .False. ! flag as On-source
     Logical           :: flagRef        = .False. ! flag as off-source REF
     Logical           :: flagDropin     = .False. ! flag as "Dropin" (inserted/added): do not SAVE
     Type(xyPointType) :: pStart                   ! start
     Type(xyPointType) :: pEnd                     ! end
     Type(xyPointType) :: pDoppler                 ! point/offsets for Doppler correction
     Real              :: lengthOtf      = 0.0     ! linear length
     Real              :: turnAngle      = 0.0     ! turn angle for circle segment
     Type(xyPointType) :: CPstart                  ! start and
     Type(xyPointType) :: CPend                    ! end for curve segment
     Character(len=24) :: systemName     = "none"  ! system of mapping offsets
     Character(len=24) :: altOption      = "none"  ! alternative speed or tSegment 
     Real              :: speedStart     = 0.0     
     Real              :: speedEnd       = 0.0
     Real              :: tSegment       = 0.0     ! time per segment
     Real              :: tRecord        = 0.0     ! time per record
     Real              :: focusOffset    = 0.0     ! focus offset
     Character(len=24) :: directionFocus = "none"  ! focus direction
     Character(len=24) :: sideBand       = GPnone  ! RX sideband (for calib.)
     !
     ! added for Lissajous:
     !
     Type(xyPointType) ::  pCenter        = xyPointType(GPnoneR,GPnoneR)   ! center --> xCenter yCenter
     Real              ::  xAmplitude     = GPnoneR                        ! amplitude
     Real              ::  yAmplitude     = GPnoneR                        !
     Real              ::  omegaX         = GPnoneR                        ! frequency
     Real              ::  omegaY         = GPnoneR                        !
     Real              ::  phiX           = GPnoneR                        ! phase
     Real              ::  phiY           = GPnoneR                        !
     !
     ! added for NIKA tune
     !
     Logical           ::  flagTune       = .False.                        ! make Track subscan sing NIKA Tune
     !
  End Type segmentType
  !
  !       NB: subscanType is deprecated
  Type    :: subscanType
     Integer           :: scanNumber  = 1       ! scan number
     Integer           :: ssNumber    = 1       ! subscan number
     Integer           :: segNumber   = 1       ! segment number
     Character(len=24) :: ssType      = "none"  ! subscan type
     Character(len=24) :: segType     = "none"  ! segment type
     Character(len=24) :: angleUnit   = "none"  
     Character(len=24) :: speedUnit   = "none"  
     Logical           :: flagOn      = .False. ! flag as On-source
     Logical           :: flagRef     = .False. ! flag as off-source REF
     Type(xyPointType) :: pStart 
     Type(xyPointType) :: pEnd
     ! TBD:     start & end are obsolete -- use pStart and pEnd !
     Type(xyPointType) :: start 
     Type(xyPointType) :: End
     Real              :: lengthOtf   = 0.0
     Real              :: turnAngle   = 0.0
     Type(xyPointType) :: CPstart 
     Type(xyPointType) :: CPend
     Character(len=24) :: altOption   = "none"  
     Real              :: speedStart  = 0.0
     Real              :: speedEnd    = 0.0
     Real              :: tSegment    = 0.0
     Real              :: tRecord     = 0.0
  End Type subscanType
  !
  Integer, Parameter   :: dimensionList = 999
  !
  Type (segmentType)                             :: segDefault
  Type (segmentType),  Dimension (dimensionList) :: segList
  !
  Type (segmentType)                             :: segOtfII
  !
  Type (xyPointType)                             :: pII
  !
  !       NB: subscanType is deprecated
  Type (subscanType)                             :: ssDefault
  Type (subscanType),  Dimension (dimensionList) :: ssList
  !
  Integer              :: iiSubscan   = 0       ! counter of subscans
  Integer              :: iiSegment   = 0       ! counter of segments
  Integer              :: nSegments   = 0       ! total number of segments
  !
!!!
!!!
Contains
!!!
!!!
  Subroutine saveSubscanList(programName,LINE,commandToSave,iUnit, ERROR)
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    !      
    Character(len=lenLine)             ::  messageText
    !
    ERROR = .False.
    !
    !D     Write (6,*) '      ---> SR: saveSubscanList using inc/commands/saveDIYlist.inc'
    Call pako_message(seve%t,programName,                                        &
         &    " module subscanList, 1.2.3 2014-10-15 ---> SR: saveSubscanList ") ! trace execution
    !
    Include 'inc/commands/saveDIYlist.inc'
    !
    Return
  End Subroutine SaveSubscanList
!!!
!!!
  Subroutine startSubscanList(programName,LINE,commandToSave, iUnit, ERROR)
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: valueComment
    Character (len=lenLine) :: messageText
    Logical                 :: errorL, errorXML
    !
    !D     Write (6,*) '   --> moduleSubscanList: SR startSubscanList '
    Call pako_message(seve%t,programName,                                        &
         &   " module subscanList, 1.2.3 2014-10-15 ---> SR: startSubscanList ") ! trace execution
    !
    Call pakoXMLsetOutputUnit(iunit=iunit)
    Call pakoXMLsetIndent(iIndent=2)
    !
    Include 'inc/startXML/generalHead.inc'
    !
    Call writeXMLset(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call pakoXMLwriteStartElement("RESOURCE","pakoScript",                       &
         &                         comment="save from pako",                     &
         &                         error=errorXML)                               !
    Call pakoXMLwriteStartElement("DESCRIPTION",                                 &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/savePakoScriptFirst.inc'
    !
    Call saveSubscanList (programName,LINE,commandToSave, iUnit, errorL)
    !                                                                       
    Call pakoXMLwriteEndElement("DESCRIPTION",                                   &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    Call pakoXMLwriteEndElement  ("RESOURCE","pakoScript",                       &
         &                         space="after",                                &
         &                         error=errorXML)                               !
    !
    Call writeXMLantenna(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call writeXMLreceiver(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call writeXMLbackend(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Include 'inc/startXML/switchingMode.inc'
    !
    Call writeXMLsource(programName,LINE,commandToSave,iUnit, ERROR)
    !
    ! TBD: Include 'inc/startXML/generalScanHead.inc' instead of the following:
    !
    Call pakoXMLwriteStartElement("RESOURCE","scans",                            &
         &                         comment="generated by paKo",                  &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    Call pakoXMLwriteStartElement("RESOURCE","scan",                             &
         &                         comment="generated by paKo",                  &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    ! **
    !       
    valueC = GV%observingMode 
    !
    Call pakoXMLcase(valueC,error=errorXML)
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    !
    ! **  TBD: Observing Mode to XML
    If (gv%doXMLobservingMode) Then
       messageText = "writing observing mode in XML format"
       Call PakoMessage(priorityI,severityI,                                     &
            &           commandToSave,messageText)                               !
       !
       Call writeXMLdiy(programName,LINE,commandToSave,                          &
         &         iUnit, ERROR)                                                 !
       !
    End If
    !
    If (GV%condElevation%isSet) Then
       !
       Call pakoXMLwriteStartElement("RESOURCE","conditions",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               ! 
       !
       Call pakoXMLwriteStartElement("RESOURCE","condition",                     &
            &                         error=errorXML)                            !   
       !
       valueC = GV%condElevation%parameter
       Call pakoXMLwriteElement("PARAM","parameter",valueC,                      &
            &                         dataType="char",                           &
            &                         error=errorXML)                            !
       !
       Write (valueC,*)       GV%condElevation%minimum
       Write (valueComment,'(F10.2,A,A)')                                        &
            &                 GV%condElevation%minimum/degree, " ", "degrees"    !
       !
       Call pakoXMLwriteElement("PARAM","minimum",valueC,                        &
            &                         unit=GV%condElevation%unit,                &
            &                         dataType="float",                          &
            &                         comment=valueComment,                      &
            &                         error=errorXML)                            !
       !
       Write (valueC,*)       GV%condElevation%maximum
       Write (valueComment,'(F10.2,A,A)')                                        &
            &                 GV%condElevation%maximum/degree, " ", "degrees"    !
       !
       Call pakoXMLwriteElement("PARAM","maximum",valueC,                        &
            &                         unit=GV%condElevation%unit,                &
            &                         dataType="float",                          &
            &                         comment=valueComment,                      &
            &                         error=errorXML)                            !
       !
       Call pakoXMLwriteEndElement("RESOURCE","condition",                       &
            &                         error=errorXML)                            !
       !
       Call pakoXMLwriteEndElement("RESOURCE","conditions",                      &
            &                         error=errorXML)                            !
       !
    End If
    !
    If (iiSegment.Ge.1) Then
       !
       ! **  subscan list to XML
       Call writeXMLsubscanList(programName,LINE,commandToSave,iUnit, ERROR)
       !   
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'START '//commandToSave,messageText)
       Write (messageText,*) '      -- specify at least 1 subscan and 1 segment!'
       Call PakoMessage(priorityW,severityW,'START '//commandToSave,messageText)
       !
    End If
    !
    Include 'inc/startXML/generalTail.inc'
    !
    Return
  End Subroutine startSubscanList
!!!
!!!
  Subroutine writeXMLdiy(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Character (len=lenCh)   :: valueC
    Logical                 :: errorXML
    !
    ERROR = .False.
    !
    !D     Write (6,*) "   --> writeXMLdiy "
    !D     Write (6,*) "   GV%purposeIsSet:   ", GV%purposeIsSet
    !D     Write (6,*) "   GV%purpose:      ->", GV%purpose, "<-"
    !
    !D Write (6,*) "       iUnit:    ", iUnit
    !
    Call pakoXMLwriteStartElement("RESOURCE","observingMode",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    valueC = GV%observingMode
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         error=errorXML)                               !
    !
!!OLD !!$    Include 'inc/startXML/optionSystemXML.inc'
    !
    If (GV%purposeIsSet) Then
       !
       Call pakoXMLwriteStartElement("RESOURCE","annotations",                   &
            &                         error=errorXML)                            !
       !
       valueC = GV%purpose
       Call pakoXMLwriteElement("PARAM","purpose",valueC,                        &
            &                         dataType="char",                           &
            &                         error=errorXML)                            !
       !
       Call pakoXMLwriteEndElement("RESOURCE","annotations",                     &
            &                         error=errorXML)                            !
       !
    End If
    !
    Call pakoXMLwriteEndElement("RESOURCE","observingMode",                      &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLdiy
!!!
!!!
  Subroutine writeXMLsubscanList(programName,LINE,commandToSave,                 &
       &        iUnit, ERROR)                                                    !
    !
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer            :: ii
    Character (len=24) :: valueC
    Character (len=48) :: valueComment
    Logical            :: errorXML
    ! 
    Character(len=128) :: messageText
    !
    Logical            :: inOtfSubscan
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,"SubscanList",                                      &
         &            " module SubscanList, v 1.2.3  2014-09-23 "                &
         &          //" --> SR: writeXMLsubscanList ")  ! trace execution        !
    !
    !D     Write (6,*) '       iiSegment:  ',  iiSegment
    !D     Write (6,*) '        nSegments: ',   nSegments
    !
    If (iiSegment.Ge.1) Then
       !
!!OLD !!$       Include 'inc/startXML/subScanListSubscansXML.inc'
       !
       !D       Write (6,*) "iiSegment:            ", iiSegment
       !D       Write (6,*) "number of segments:   ", nSegments
       !
       Call pakoXMLwriteStartElement("RESOURCE","subscans",                      &
            &                         comment="generated by paKo",               &
            &                         space ="before",                           &
            &                         error=errorXML)                            !
       !
       inOtfSubscan = .False.
       !
       Do ii = 1,nSegments, 1
          !
          !D           Write (6,*) ' '
          !D           Write (6,*) ' Segment #:           ', ii
          !D           Write (6,*) ' newsubscan:          ', segList(ii)%newSubscan
          !D           Write (6,*) ' segList(ii)%ssType:  ', segList(ii)%ssType
          !D           Write (6,*) ' segList(ii)%segType: ', segList(ii)%segType
          !
          If      (segList(ii)%ssType .Eq. ss%cc) Then
             Include 'inc/startXML/segCalColdXML.inc'
             !
          Else If (segList(ii)%ssType .Eq. ss%ca) Then
             Include 'inc/startXML/segCalAmbientXML.inc'
             !
          Else If (segList(ii)%ssType .Eq. ss%cg) Then
             Include 'inc/startXML/segCalGridXML.inc'
             !
          Else If (segList(ii)%ssType .Eq. ss%cs) Then
             Include 'inc/startXML/segCalSkyXML.inc'
             !
          Else If (segList(ii)%ssType.Eq.ss%on .And.                             &
               &       segList(ii)%segType.Eq.seg%track) Then                    !
             Include 'inc/startXML/trackXML.inc'
          Else If (segList(ii)%ssType.Eq.ss%ref .And.                            &
               &       segList(ii)%segType.Eq.seg%track) Then                    !
             Include 'inc/startXML/trackXML.inc'
          Else If (segList(ii)%ssType.Eq.ss%track .And.                          &
               &       segList(ii)%segType.Eq.seg%track) Then                    !
             Include 'inc/startXML/trackXML.inc'
          Else If (segList(ii)%ssType.Eq.ss%VLBI .And.                           &
               &       segList(ii)%segType.Eq.seg%track) Then                    !
             Include 'inc/startXML/vlbiTrackXML.inc'
          Else If (segList(ii)%ssType.Eq.ss%tune .And.                           &
               &       segList(ii)%segType.Eq.seg%track) Then                    !
             !D              Write (6,*) '      -> write tune subscan '
             Include 'inc/startXML/trackXML.inc'
          End If
          !
          ! ***    OTF subscan
          If (segList(ii)%ssType.Eq.ss%otf) Then
             !
             ! ***       start of OTF subscan
             If (segList(ii)%newSubscan) Then
                inOtfSubscan = .True.
                Call pakoXMLwriteStartElement("RESOURCE","subscan",              &
                     &                         comment="OTF",                    &
                     &                         error=errorXML)                   !
                valueC = segList(ii)%ssType
                Call pakoXMLcase(valueC,error=errorXML)
                If (valueC.Eq."OTF") valueC="onTheFly"
                Call pakoXMLwriteElement("PARAM","type",valueC,                  &
                     &                         dataType="char",                  &
                     &                         error=errorXML)                   !
                valueC = segList(ii)%systemName
                Call pakoXMLcase(valueC,error=errorXML)
                If (valueC.Eq."horizontalT") valueC="horizontalTrue"
                Call pakoXMLwriteElement("PARAM","systemOffset",valueC,          &
                     &                         dataType="char",                  &
                     &                         error=errorXML)                   !
                !
                Include 'inc/startXML/pOffsetDoppler.inc'
                !
                Call pakoXMLwriteStartElement("RESOURCE","segments",             &
                     &                         error=errorXML)                   !
             End If
             !
             ! ***       OTF segments
             If (segList(ii)%ssType.Eq.ss%otf .And.                              &
                  &       segList(ii)%segType.Eq.seg%track) Then                 !
                Include 'inc/startXML/segTrackXML.inc'
             End If
             !
             If (segList(ii)%ssType.Eq.ss%otf .And.                              &
                  &       segList(ii)%segType.Eq.seg%linear) Then                !
                Include 'inc/startXML/segLinearXML.inc'
             End If
             !
             If (segList(ii)%ssType.Eq.ss%otf .And.                              &
                  &       segList(ii)%segType.Eq.seg%circle) Then                !
                Include 'inc/startXML/segCircleXML.inc'
             End If
             !
             If (segList(ii)%ssType.Eq.ss%otf .And.                              &
                  &       segList(ii)%segType.Eq.seg%curve) Then                 !
                Include 'inc/startXML/segCurveXML.inc'
             End If
             !
             If (segList(ii)%ssType.Eq.ss%otf .And.                              &
                  &       segList(ii)%segType.Eq.seg%lissajous) Then             !
                Include 'inc/startXML/segLissajousXML.inc'
             End If
             !
             ! ***       end of OTF subscan
             If (ii.Eq.iiSegment .Or.                                            &
                  &  ii.Lt.iiSegment .And. segList(ii+1)%newSubscan) Then        !
                !
                Call pakoXMLwriteEndElement("RESOURCE","segments",               &
                     &                         error=errorXML)                   !
                !
                Call pakoXMLwriteEndElement("RESOURCE","subscan",                &
                     &                         error=errorXML)                   !
                inOtfSubscan = .False.
             End If
             !
          End If
          !
       End Do
       !
       Call pakoXMLwriteEndElement("RESOURCE","subscans",                        &
            &                         error=errorXML)                            !
       !
       !   
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'START '//commandToSave,messageText)
       !
    End If
    !
    Return
  End Subroutine writeXMLsubscanList
!!!
!!!
  Subroutine printSegmentList  (error)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical            :: error
    ! 
    !
    !D     Write (6,*) '   --> moduleSubscanList: SR printSegmentList '
    !D     Write (6,*) '       iiSegment: ', iiSegment
    !
    If (iiSegment.Ge.1) Then
       !
       Do ii = 1, iiSegment, 1
          Write (6,*) '  ii                ', ii
          Write (6,*) '     newSubscan     ', segList(ii)%newSubscan  
          Write (6,*) '     scanNumber     ', segList(ii)%scanNumber  
          Write (6,*) '     ssNumber       ', segList(ii)%ssNumber    
          Write (6,*) '     segNumber      ', segList(ii)%segNumber   
          Write (6,*) '     ssType         ', segList(ii)%ssType      
          Write (6,*) '     segType        ', segList(ii)%segType     
          Write (6,*) '     angleUnit      ', segList(ii)%angleUnit   
          Write (6,*) '     speedUnit      ', segList(ii)%speedUnit   
          Write (6,*) '     flagOn         ', segList(ii)%flagOn      
          Write (6,*) '     flagRef        ', segList(ii)%flagRef     
          Write (6,*) '     pStart         ', segList(ii)%pStart      
          Write (6,*) '     pEnd           ', segList(ii)%pEnd        
          Write (6,*) '     lengthOtf      ', segList(ii)%lengthOtf   
          Write (6,*) '     turnAngle      ', segList(ii)%turnAngle   
          Write (6,*) '     CPstart        ', segList(ii)%CPstart     
          Write (6,*) '     CPend          ', segList(ii)%CPend       
          Write (6,*) '     systemName     ', segList(ii)%systemName  
          Write (6,*) '     altOption      ', segList(ii)%altOption   
          Write (6,*) '     speedStart     ', segList(ii)%speedStart  
          Write (6,*) '     speedEnd       ', segList(ii)%speedEnd    
          Write (6,*) '     tSegment       ', segList(ii)%tSegment    
          Write (6,*) '     tRecord        ', segList(ii)%tRecord     
          Write (6,*) '     focusOffset    ', segList(ii)%focusOffset
          Write (6,*) '     directionFocus ', segList(ii)%directionFocus
       End Do
       !   
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'printSegmentList ',messageText)
       !
    End If
    !
    Return
  End Subroutine printSegmentList
!!!
!!!
  Subroutine listSegmentList  (error)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical            :: error
    Integer            :: ierr
    ! 
    !!    Call getCountSegments(nSegments)
    !
    Call pako_message(seve%t,'paKo',                                             &
         &    " module SubscanList, 1.2.3 2014-07-10 ---> SR: Subscanlist ")     ! !! Trace execution
    !
    !D     Write (6,*) '   --> moduleSubscanList: SR listSegmentList '
    !D     Write (6,*) '        nSegments: ',  nSegments
    !D     Write (6,*) '       iiSegment:  ', iiSegment
    !
    Write (messageText,*)  "  subscans #: 1 to ", nSegments
    l = Len_trim(GV%observingMode)
    Call pakoMESSAGE(priorityI,severityI,GV%observingMode(1:l),messageText)
    !
    If (iiSegment.Ge.1) Then
       !
       Do ii = 1, iiSegment, 1
          !
          If (segList(ii)%ssType .Eq. ss%otf) Then
             !
             Write (messageText, iostat=ierr, fmt =                              &
                     &  '(I3," ",  A, 2F9.1," to ", 2F9.1, " ", A," ",           &
                     &   A, F8.1," s")   '                                       &
                     &  )                                                        &
                  &  ii,                                                         &
                  &  segList(ii)%ssType,                                         &
                  &  segList(ii)%pStart%x/GV%angleFactorR,                       &
                  &  segList(ii)%pStart%y/GV%angleFactorR,                       &
                  &  segList(ii)%pEnd%x/GV%angleFactorR,                         &
                  &  segList(ii)%pEnd%y/GV%angleFactorR,                         &
                  &  GV%angleUnitSetC,                                           &
                  &  segList(ii)%systemName,                                     &
                  &  segList(ii)%tsegment                                        !
             If (ierr.Ne.0) Then
                Write (6,*) "         ierr:          ", ierr
                Write (6,*) "         messageText: ->", messageText, "<-"
                Write (messageText, *)                                           &
                  &  ii,                                                         &
                  &  segList(ii)%ssType,                                         &
                  &  segList(ii)%pStart%x/GV%angleFactorR,                       &
                  &  segList(ii)%pStart%y/GV%angleFactorR,                       &
                  &  segList(ii)%pEnd%x/GV%angleFactorR,                         &
                  &  segList(ii)%pEnd%y/GV%angleFactorR,                         &
                  &  GV%angleUnitSetC,                                           &
                  &  segList(ii)%systemName,                                     &
                  &  segList(ii)%tsegment                                        !
                Write (6,*) "         fallback * format:"
                Write (6,*) "         messageText: ->", messageText, "<-"
             End If                                        !
            !
          Else If (segList(ii)%ssType .Eq. ss%cs) Then
             Write (messageText,*)  "  subscan #:   ", ii," ",                   &
                  &  segList(ii)%ssType," ",                                     &
                  &  "at ",   segList(ii)%pStart%x/GV%angleFactorR," ",          &
                  &           segList(ii)%pStart%y/GV%angleFactorR," ",          &
                  &  GV%angleUnitSetC                                            !
             !
          Else If (segList(ii)%ssType.Eq.ss%ca .or.                              &
               &   segList(ii)%ssType .Eq. ss%cc) Then                           !
             If (segList(ii)%sideBand.Ne.GPnone) Then
                Write (messageText,*)  "  subscan #:   ", ii," ",                &
                     &  segList(ii)%ssType," ",                                  &
                     &  segList(ii)%sideBand                                     !
             Else
                Write (messageText,*)  "  subscan #:   ", ii," ",                &
                     &  segList(ii)%ssType                                       !
             End If
             !
          Else If (segList(ii)%ssType .Eq. ss%track) Then
             If (segList(ii)%flagOn) Then
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3," ", A,A, "at ",f9.1, f9.1," ", A," ",              &
                     &   A, F8.1," s")   '                                       &
                     &  )                                                        &
                     &           ii,                                             &
                     &           segList(ii)%ssType,traceflag%on,                &
                     &           segList(ii)%pStart%x/GV%angleFactorR,           &
                     &           segList(ii)%pStart%y/GV%angleFactorR,           &
                     &           GV%angleUnitSetC,                               &
                     &           segList(ii)%systemName,                         &
                     &           segList(ii)%tsegment                            !
             Else If (segList(ii)%flagRef) Then
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3," ", A,A, "at ",f9.1, f9.1," ", A," ",              &
                     &   A, F8.1," s")   '                                       &
                     &  )                                                        &
                     &           ii,                                             &
                     &           segList(ii)%ssType,traceflag%ref,               &
                     &           segList(ii)%pStart%x/GV%angleFactorR,           &
                     &           segList(ii)%pStart%y/GV%angleFactorR,           &
                     &           GV%angleUnitSetC,                               &
                     &           segList(ii)%systemName,                         &
                     &           segList(ii)%tsegment                            !
             End If
             !
          Else
             Write (messageText,*)  "  subscan #:   ", ii," ",                   &
                  &  segList(ii)%ssType                                          !
             !
          End If
          !
          l = Len_trim(GV%observingMode)
          Call pakoMESSAGE(priorityI,severityI,'Subscans',                       &
               &           messageText)                                          !
       End Do
       !
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'Subsans',messageText)
       !
    End If
    !
    Return
  End Subroutine listSegmentList
!!!
!!!
  Subroutine plotSegmentList  (error)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical            :: error
    ! 
    jj = 0             !   counts OTF segments
    !
    Call pako_message(seve%t,"",                                                 &
         &  " module SubscanList, v 1.2.3 2014-10-20 --> SR: plotSegmentList "   &
         &  //" DEPRECATED ")                                                    ! trace execution
    !
    Do ii = 1, nSegments, 1
       !
       !D        Write (6,*) ii, segList(ii)%ssType, segList(ii)%segType,                  &
       !D             &          segList(ii)%flagOn, segList(ii)%flagRef,                  &
       !D             &          segList(ii)%flagTune                                      !
       !
       If (         segList(ii)%ssType .Eq.ss%track                              &
            & .And. segList(ii)%segType.Eq.seg%track                             &
            & .And. segList(ii)%flagOn) Then                                     !   !!   Track On
          !
          Call plotTrackP( segList(ii)%pStart,                                   &
               &           errorP,                                               &
               &           number=segList(ii)%ssNumber,                          &
               &           Type=ss%on)                                           !
          !
       End If
       !
       If (         segList(ii)%ssType .Eq.ss%track                              &
            & .And. segList(ii)%segType.Eq.seg%track                             &
            & .And. segList(ii)%flagRef) Then                                    !   !!   Flag Ref
          !
          Call plotTrackP( segList(ii)%pStart,                                   &
               &           errorP,                                               &
               &           number=segList(ii)%ssNumber,                          &
               &           Type=ss%ref)                                          !
          !
       End If
       !
       If (         segList(ii)%ssType .Eq.ss%ref                                &
            & .And. segList(ii)%segType.Eq.seg%track) Then                       !   !!   Track Ref
          !
          Call plotTrackP( segList(ii)%pStart,                                   &
               &           errorP,                                               &
               &           number=segList(ii)%ssNumber,                          &
               &           Type=segList(ii)%ssType)                              !
          !
       End If
       !
       If (         segList(ii)%ssType .Eq.ss%otf                                &
            & .And. segList(ii)%segType.Eq.seg%linear) Then                      !   !!   OTF linear
          !
          jj = jj+1
          Call plotOtfLinearP(segList(ii)%pStart,                                &
               &             segList(ii)%pEnd,                                   &
               &             errorP,                                             &
               &             number=jj,                                          &
               &             Type='otfMap')                                      !
          !
       End If
       !
    End Do
    !
!! TBD   !
!! TBD   Call gr_exec(      'set character 0.6' )
!! TBD   Call gr_exec(      'pen 0'             )
!! TBD   !
    !
    error =  errorP 
    !
    Return
  End Subroutine plotSegmentList
!!!
!!!
  Subroutine getNumberSegments(ii)
    !
    Integer, Intent(out) :: ii
    !
    ii = iiSegment
    !
    Return
    !
  End Subroutine getNumberSegments
!!!
!!!
  Subroutine getCountSubscans(ii)
    !
    Integer, Intent(out) :: ii
    !
    ii = iiSubscan
    !
    Return
  End Subroutine getCountSubscans
!!!
!!!
  Subroutine getCountSegments(ii)
    !
    Integer, Intent(out) :: ii
    !
    ii = iiSegment
    !
    Return
  End Subroutine getCountSegments
!!!
!!!
  Subroutine countSubscans(ii,value)
    !
    Integer, Intent(in), Optional  :: value
    Integer, Intent(out), Optional :: ii
    !
    If (Present(value)) Then
       iiSubscan = value
    Else
       iiSubscan = iiSubscan+1
    End If
    !
    If (Present(ii)) Then
       ii = iiSubscan
    End If
    !
    Return
  End Subroutine countSubscans
!!!
!!!
  Subroutine countSegments(ii,value)
    !
    Integer, Intent(in), Optional  :: value
    Integer, Intent(out), Optional :: ii
    !
    If (Present(value)) Then
       iiSegment = value
    Else
       iiSegment = iiSegment+1
    End If
    !
    If (Present(ii)) Then
       ii = iiSegment
    End If
    !
    Return
  End Subroutine countSegments
!!!
!!!
End Module modulePakoSubscanList
!!!
!!!

subroutine line_auto(line,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  integer(kind=4) :: ier, sky, lck, harm, mult, i1, i2, ic, mline, nline
  integer(kind=4) :: ncont, lch, nc, i, mrec, isb, iend, isky(2), nb(2), j, nok, irec
  integer(kind=4) :: mspec, nspec, k, if1, if2, k1, k2, j1, j2, score, mcont
  integer(kind=4) :: scoremax, ibf, ibf2, band(5)
  parameter (mline=20, mcont=2, mrec=2, mspec=6)
  integer(kind=4) :: ncfr(mcont), itun(mrec), isb1(mrec), isb2(mrec)
  integer(kind=4) :: iband(mspec), krec(mspec)
  integer(kind=4) :: jsky(mrec), jharm(mrec), jmult(mrec), wifl(1000,5,mrec)
  integer(kind=4) :: jm, jmin(mrec), jmax(mrec), jrec
  logical :: first, bf10_done, filled, ok
  character(len=80) :: ch, linename(mline), linevelo, cline(mrec)
  character(len=80) :: contname(mline), contbands
  character(len=3) :: csb(-1:1), ctun(mrec), csky(mrec)
  real(kind=8) :: linefreq(mline), linevres(mline), linevmin(mline), linevmax(mline)
  real(kind=8) :: ftmin(2), ftmax(2), flo2(mrec), flo1, best, ft, clight
  real(kind=8) :: eps, fiend(2), ftunemin(2,2), ftunemax(2,2), f1, f2, ftrymin(2)
  real(kind=8) :: ftrymax(2), ftune(mrec), contfr(20,mcont), fif3, df, deltaf
  real(kind=8) :: flo3(mspec), ifstep, cent, bf, ftumin(mrec), ftumax(mrec), vc,velocity
  parameter (best=1875., clight=299792.458, ifstep=0.625)
  !!      PARAMETER (BEST=1875., CLIGHT=299792.458, IFSTEP=1.00)
  parameter (eps=(100d0+50d0/512d0))   !	MHz
  character*9 rname
  !
  data isky/1,-1/
  data fiend/100d0, 600d0/
  data csb /'LSB','DSB','USB'/
  data cent/350./
  data first /.true./
  data lck / -1/
  data band /160,80,40,20,10/
  data rname /'LINE_AUTO'/
  !
  ! resulting parameters accessed as variables:
  save cline, ftune, jsky, jharm, ctun, csky
  save nspec, krec, flo3, iband
  save first
  !-----------------------------------------------------------------------
  ! Get parameters from variables defined in project.pro
  call sic_get_inte('N_LINE',nline,error)
  call sic_get_inte('N_CONT',ncont,error)
  call sic_get_dble('VLSR_1',velocity,error)
  if (error) then
    call astro_message(seve%e,rname,'Variables not defined')
    return
  endif
  if (nline.gt.mline) then
    call astro_message(seve%f,rname,'Too many line tables')
    error = .true.
    return
  endif
  do irec=1, 2
    nb(irec) = 1
    do isb = 1, 2
      ftunemin(isb,irec) = 0
      ftunemax(isb,irec) = 1000000.
    enddo
    cline(irec)= '*'
    jmult(irec) = 1
    if (irec.eq.2) jmult(irec) = 3
    ftune(irec) = -1.
    ftumin(irec) = 0.
    ftumax(irec) = 100000000.
  enddo
  !
  ! Get parameters, and find out about USB or LSB or DSB:
  ! Line tables first:
  if (nline.gt.0) then
    do i=1, nline
      call name_it('LINENAME',i,ch,lch)
      call sic_get_char(ch(1:lch),linename(i),nc,error)
      call name_it('LINEVELO',i,ch,lch)
      call sic_get_char(ch(1:lch),linevelo,nc,error)
      read (linevelo(1:nc),*,err=900) linevmin(i), linevmax(i)
      call name_it('LINEFREQ',i,ch,lch)
      call sic_get_dble(ch(1:lch),linefreq(i),error)
      linefreq(i) = min(300.d3,max(70.d3,linefreq(i)))
      call name_it('LINEVRES',i,ch,lch)
      call sic_get_dble(ch(1:lch),linevres(i),error)
      if (error) return
      irec = nint(linefreq(i)/135000d0)
      ftumin(irec) = min(ftumin(irec),linefreq(i))
      ftumax(irec) = max(ftumax(irec),linefreq(i))
      if (cline(irec).eq.'*') then
        cline(irec) = linename(i)
        ftune(irec) = linefreq(i)
      endif
    enddo
  else
    call astro_message(seve%i,rname,'Continuum only')
  endif
  !
  ! Then continuum tables:
  if (ncont.gt.0) then
    do i=1, ncont
      call name_it('CONTTABLE',i,ch,lch)
      call sic_get_char(ch(1:lch),contname(i),nc,error)
      call name_it('CONTBANDS',i,ch,lch)
      call sic_get_char(ch(1:lch),contbands,nc,error)
      do j=1, 20
        contfr(j,i) = 0
      enddo
      read (contbands,*,iostat=ier) (contfr(k,i),k=1,20)
      ncfr(i) = 0
      do j=1, 20, 2
        if (contfr(j,i).gt.0) ncfr(i) = ncfr(i)+2
      enddo
      ! print *, 'i, NCFR(I), (CONTFR(J,I), j=1, NCFR(I))'
      ! print *, i, NCFR(I), (CONTFR(J,I), j=1, NCFR(I))
      ft = (contfr(1,i)+contfr(ncfr(i),i))/2.
      irec = nint(ft/135000d0)
      ftumin(irec) = min(ftumin(irec),contfr(1,i))
      ftumax(irec) = max(ftumax(irec),contfr(ncfr(i),i))
      if (cline(irec).eq.'*') then
        cline(irec) = contname(i)
        ftune(irec) = ft
      endif
      ! print *, 'irec, CLINE(IREC), FTUNE(IREC), FTUMIN(IREC), FTUMAX(IREC)'
      ! print *, irec, CLINE(IREC), FTUNE(IREC), FTUMIN(IREC), FTUMAX(IREC)
    enddo
  else
    call astro_message(seve%i,rname,'No Continuum')
  endif
  !
  ! Rec 1 must be tuned USB or LSB depending on line frequency:
  if (ftune(1).gt.112d3) then
    itun(1) = 1
    isb1(1) = 1
  else
    itun(1) = -1
    isb1(1) = 2
  endif
  jsky(1) = itun(1)
  isb2(1) = isb1(1)
  !
  ! Rec 2 is tuned DSB by default (we try line LSB or USB)
  itun(2) = 0
  if (ftumax(2)-ftumin(2).lt.fiend(2)-fiend(1)) then
    jsky(2) = -1
    isb1(2) = 2
    isb2(2) = 2
  elseif ((ftune(2)-ftumin(2)) .gt. (ftumax(2)-ftune(2))) then
    jsky(2) = -1
    isb1(2) = 1
    isb2(2) = 2
  else
    jsky(2) = 1
    isb1(2) = 1
    isb2(2) = 2
  endif
  !
  ! Now find the exact frequencies:
  call astro_message(seve%i,rname,'Getting line setup ...')
  if (nline.gt.0) then
    do i=1, nline
      irec = nint(linefreq(i)/135000d0)
      sky = jsky(irec)
      mult = jmult(irec)
      lck = -1
      ! PRINT *, 'i, irec, sky, mult, lck'
      ! PRINT *, I, IREC, SKY, MULT, LCK
      do isb = isb1(irec), isb2(irec)
        ftmin(isb) = 1e10
        ftmax(isb) = -1e10
        f2 = best
        do iend= 1, 2
          ft = linefreq(i)-isky(isb)*(f2-fiend(iend)) +sky*(f2-cent)
          harm =nint(((ft+lck*eps*mult+sky*cent)/best-sky)/mult)
          f2 = (ft + lck*eps*mult+sky*cent)/(mult*harm+sky)
          ft = linefreq(i)-isky(isb)*(f2-fiend(iend)) +sky*(f2-cent)
          ftmin(isb)=min(ftmin(isb), ft*(1.-(linevmin(i)-velocity)/clight))
          ftmax(isb)=max(ftmax(isb), ft*(1.-(linevmax(i)-velocity)/clight))
        enddo
      enddo
      nok = 0
      do j=1, nb(irec)
        ! PRINT *, 'FTUNEMIN(J,IREC), FTUNEMAX(J,IREC)'
        ! PRINT *, FTUNEMIN(J,IREC), FTUNEMAX(J,IREC)
        do isb = 1, 2
          f1 = max(ftunemin(j,irec),ftmin(isb))
          f2 = min(ftunemax(j,irec),ftmax(isb))
          if (f1.le.f2) then
            nok = nok+1
            ftrymin(nok) = f1
            ftrymax(nok) = f2
          endif
        enddo
      enddo
      if (nok.gt.0) then
        do j=1, nok
          ftunemin(j,irec) = ftrymin(j)
          ftunemax(j,irec) = ftrymax(j)
          nb(irec) = nok
        enddo
      else
        error = .true.
        call astro_message(seve%f,rname,linename(i)(1:nc)//' cannot be '//  &
        'observed.')
        return
      endif
    enddo
    !
    do irec=1, 2
      ! print *, 'irec, ftune(irec)'
      ! print *, irec, ftune(irec)
      ok = .false.
      do j=1, nb(irec)
        if (ftunemin(j,irec) .gt. 0) then
          if ( ftune(irec).ge.ftunemin(j,irec) .and.  &
               ftune(irec).le.ftunemax(j,irec) ) then
            ok = .true.
          else
            f1 = (ftunemin(j,irec)+ftunemax(j,irec))/2.
          endif
        endif
      enddo
      if (.not.ok)  ftune(irec)= f1
    enddo
  endif
  !
  ! If continuum only:
  if (ncont.gt.0) then
    do i=1, ncont
      ft = (contfr(1,i)+contfr(ncfr(i),i))/2.
      irec = nint(ft/135000d0)
      if (ftune(irec).lt.0.) then
        ftune(irec) = ft
      endif
    enddo
  endif
  !
  ! Print line setup
  do irec=1, 2
    ! print *, 'irec, ftune(irec)'
    ! print *, irec, ftune(irec)
    if (ftune(irec) .gt. 0) then
      sky = jsky(irec)
      mult = jmult(irec)
      ft = ftune(irec)
      ! print *, 'sky, mult, ft, lck, eps, best'
      ! print *, sky, mult, ft, lck, eps, best
      harm =nint(((ft+lck*eps*mult+sky*cent)/best-sky)/mult)
      f2 = (ft + lck*eps*mult+sky*cent)/(mult*harm+sky)
      jharm(irec) = harm
      flo2(irec) = f2
      csky(irec) = csb(jsky(irec))
      ctun(irec) = csb(itun(irec))
      print 1000, cline(irec), ft/1000., csky(irec), jharm(irec), irec
      1000 format(' LINE ',a12,' ',f13.6,' ',a3,' LOW 350 ',i5,' /RECEIVER ',i1)
    else
      ctun(irec) = 'UND'
      csky(irec) = 'UND'
    endif
  enddo
  !
  ! Get Spectral setup.
  ! attribute subbands to lines first:
  call astro_message(seve%i,rname,'Getting spectral setup ...')
  nspec = 0
  bf10_done = .false.
  j1 = nint(fiend(1)/ifstep)
  j2 = nint(fiend(2)/ifstep)
  do k= j1, j2
    do ibf=1, 5
      do irec=1, 2
        wifl(k,ibf, irec) = 0
      enddo
    enddo
  enddo
  if (nline.gt.0) then
    call astro_message(seve%i,rname,'Covering line tables ...')
    do i=1, nline
      irec = nint(linefreq(i)/135000d0)
      flo1 = ftune(irec)-jsky(irec)*(flo2(irec)-cent)
      vc = (linevmax(i)+linevmin(i))/2-velocity
      f1 = linefreq(i)*(1.-vc/clight)
      fif3 = flo2(irec)-abs(f1-flo1)
      df = linefreq(i) * linevres(i) / clight
      if (df.gt.2.4) then
        ibf = 1
      elseif (df.gt.0.62) then
        ibf = 2
      elseif (df.gt.0.155) then
        ibf = 3
      elseif (df.gt.0.077) then
        ibf = 4
      elseif (df.gt.0.037 .and. .not.bf10_done) then
        ibf = 5
        bf10_done = .true.
      else
        error = .true.
        call astro_message(seve%f,rname,'Resolution too high')
        return
      endif
      deltaf  = linefreq(i) * (linevmax(i)-linevmin(i)) / clight
      k1 = nint((fif3-deltaf/2)/ifstep)
      k2 = nint((fif3+deltaf/2)/ifstep)
      do k=k1, k2
        !               WIFL(K,IBF,IREC) = WIFL(K,IBF,IREC)+1000
        wifl(k,ibf,irec) = 1000
      enddo
      ! print *, 'i, irec, ibf, ifstep, k1, k2'
      ! print *, i, irec, ibf, ifstep, k1, k2
    enddo
  endif
  !
  ! Continuum
  i1 = nint(fiend(1)/ifstep)
  i2 = nint(fiend(2)/ifstep)
  ic = nint(cent/ifstep)
  do irec=1, 2
    do i= j1, j2
      wifl(i,1,irec) = wifl(i,1,irec)+abs(i2-i1)-abs(ic-i)
    enddo
  enddo
  if (ncont.gt.0) then
    call astro_message(seve%i,rname,'Covering continuum tables ...')
    do i=1, ncont
      irec = nint(contfr(1,i)/135000d0)
      flo1 = ftune(irec)-jsky(irec)*(flo2(irec)-cent)
      do j=1, ncfr(i), 2
        ! print *,'i, j, flo1, FLO2(IREC), CONTFR(J,I), CONTFR(J+1,I) '
        ! print *, i, j, flo1, FLO2(IREC), CONTFR(J,I), CONTFR(J+1,I)
        if (contfr(j,i).lt.flo1 .and. contfr(j+1,i).gt.flo1) then
          f2 = flo2(irec)
          f1 = max(0.d0, flo2(irec) -max(flo1-contfr(j,i),contfr(j+1,i)-flo1))
        else
          f1 = max(0.d0,flo2(irec) - abs(contfr(j,i)-flo1))
          f2 = max(0.d0,flo2(irec) - abs(contfr(j+1,i)-flo1))
        endif
        ! print *, 'cont i, irec, j, f1, f2 ', i, irec, j, f1, f2
        if1 = nint(f1/ifstep)
        if2 = nint(f2/ifstep)
        k1 = max(j1,min(if1,if2))
        k2 = min(j2,max(if1,if2))
        ! print *, 'cont i ,irec, k1, k2 ',  i ,irec, k1, k2
        do k= k1, k2
          !                  WIFL(K,1,IREC) = max(1000,WIFL(K,1,IREC)+1000)
          wifl(k,1,irec) = wifl(k,1,irec)+ 1000
        enddo
      enddo
    enddo
  endif
  !
  ! Now assign correlator units, dropping 10 % of bandwidths,
  ! starting from highest resolution.
  do ibf = 5, 1, -1
    bf = band(ibf)*0.90
    filled = .false.
    do while (.not.filled)
      scoremax = -1e8
      filled = .true.
      do irec=1, 2
        jmax(irec) = j1
        jmin(irec) = j2
        do j = j1, j2
          if (wifl(j,ibf,irec).gt.0) then
            jmax(irec)  = max(j,jmax(irec) )
            jmin(irec)  = min(j,jmin(irec) )
          endif
        enddo
        ! print *, ibf, irec, JMIN(irec), jmax(irec)
        ! in that case irec needs more units;
        if (jmin(irec).le.jmax(irec)) then
          filled = .false.
          do j = jmin(irec), jmax(irec)
            k1 = max(j1,j-nint(0.5*bf/ifstep))
            k2 = min(j2,j+nint(0.5*bf/ifstep))
            score = 0
            do k=k1, k2
              score=score+wifl(k,ibf,irec)
            enddo
            ! print *, 'j, score ', j, score
            if (score.gt.scoremax) then
              scoremax=score
              jm = j
              jrec = irec
            endif
          enddo
        endif
      enddo
      ! add one unit to receiver JREC at position JM if needed:
      if (.not.filled) then
        if (nspec.lt.mspec) then
          nspec = nspec+1
          iband(nspec) = band(ibf)
          flo3(nspec) = 0.625*nint(jm*ifstep/0.625)
          krec(nspec) = jrec
          k1 = max(j1,jm-nint(0.5*bf/ifstep))
          k2 = min(j2,jm+nint(0.5*bf/ifstep))
          do ibf2 = 1, 5
            do k=k1, k2
              wifl(k,ibf2,jrec) = 0    ! -10000
            enddo
          enddo
          print 1001, ' SPECTRAL ',nspec,iband(nspec),flo3(nspec),krec(nspec)
          1001 format(a10,i2,i4,f8.3,' /RECEIVER ',i2)
          ! we stop if no more units, with a warning.
        else
          call astro_message(seve%w,rname,'Not enough corr. units !')
          filled = .true.
        endif
      endif
    enddo
  enddo
  !
  ! 10 MHz check
  do i=1, mspec
    if (iband(i).eq.10 .and. i.ne.5) then
      k = iband(5)
      iband(5) = iband(i)
      iband(i) = k
      f1 = flo3(5)
      flo3(5) = flo3(i)
      flo3(i) = f1
      k = krec(5)
      krec(5) = krec(i)
      krec(i) = k
    endif
  enddo
  !
  if (first) then
    call sic_def_charn('LINE_C',cline,1,2,.false.,error)
    call sic_def_dble('LINE_F',ftune,1,2,.false.,error)
    call sic_def_charn('LINE_SB',csky,1,2,.false.,error)
    call sic_def_charn('LINE_TUN',ctun,1,2,.false.,error)
    call sic_def_inte('LINE_H',jharm,1,2,.false.,error)
    call sic_def_inte('SPEC_N',nspec,1,1,.false.,error)
    call sic_def_inte('SPEC_R',krec,1,mspec,.false.,error)
    call sic_def_inte('SPEC_B',iband,1,mspec,.false.,error)
    call sic_def_dble('SPEC_F',flo3,1,mspec,.false.,error)
    first = .false.
  endif
  return
  900   error = .true.
  call astro_message(seve%f,rname,'error reading frequencies')
  return
end subroutine line_auto
!
subroutine name_it(name,i,ch,lch)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: name           !
  integer(kind=4) :: i              !
  character(len=*):: ch             !
  integer(kind=4) :: lch            !
  ! Global
  integer(kind=4) :: lenc
  !
  lch = lenc(name)
  ch = name(1:lch)//'_'
  if (i.lt.10) then
    write(ch(lch+2:),'(i1)') i
  elseif (i.lt.100) then
    write(ch(lch+2:),'(i2)') i
  elseif (i.lt.1000) then
    write(ch(lch+2:),'(i3)') i
  endif
  lch = lenc(ch)
  return
end subroutine name_it

	subroutine iterate(image,nimage,imax,iclump,thresh,itmaxcl,
     &    iter,rms,sum,minsum)

        real*4  minsum
	integer(kind=4), intent(in) :: nimage
	real*4  image(nimage)
	logical iter
        save sum_thresh

	iter=.true.

        if (iclump.eq.1) sum_thresh = minsum*sum
	if (image(imax).lt.thresh/rms) then
		write (2,*) 
     &    'I-ITERATE, threshhold reached after ',iclump,' iterations '
		iter=.false.
	else if (iclump.gt.itmaxcl) then
		write (2,*)
     &          'I-ITERATE, maximum number of clumps; stop iterating '
		iter=.false.
        else if (sum.le.sum_thresh) then
		write (2,*)
     &          'I-ITERATE, integrated intensity lower than ',minsum,
     &          '% of start value after ',iclump,' iterations.' 
		iter=.false.
	endif

	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_types
  ! Types
  public :: clean_par
  ! Variables
  public :: clean_converge
  public :: major_sec,minor_sec
  ! Methods
  public :: beam_unit_conversion
  private
  !
  real :: major_sec
  real :: minor_sec
  integer :: clean_converge = 10 ! Cleaning convergence criterium
  !
  type clean_par
!     sequence !***JP: Why?
     integer(kind=4) :: first           ! First plane
     integer(kind=4) :: last            ! Last plane
     integer(kind=4) :: nlist           ! List size
     integer(kind=4) :: iplane          ! Current image plane
     integer(kind=4) :: ibeam           ! Current beam plane
     integer(kind=4) :: imask           ! Current mask plane 
     !
     real(kind=4) :: thresh             ! Threshold for beam fit
     real(kind=4) :: gain = 0.2         ! Loop gain
     real(kind=4) :: fres = 0.0         ! Fractional residual
     real(kind=4) :: ares = 0.0         ! Absolute residual
     real(kind=4) :: phat               ! Prussian hat
     real(kind=4) :: flux               ! Cleaned Flux
     !
     ! Mosaic
     real(kind=4) :: search = 0.2       ! Threshold for searching
     real(kind=4) :: restor = 0.2       ! Threshold for restoration
     real(kind=4) :: trunca             ! Beam truncation value
     !
     ! Clark
     real(kind=4) :: spexp = 1.0        ! Speed up factor
     !
     ! MRC
     real(kind=4) :: ratio = 0.0        ! Smoothing ratio
     !
     ! Multi-scale
     real(kind=4) :: smooth = sqrt(3.0)    ! Smoothing factor
     real(kind=4) :: worry                 ! Worry factor
     integer(kind=4) :: nker(3) = [1,7,11] ! Kernel
     real(kind=4) :: gains(3)              ! Clean gains
     integer(kind=4) :: ninflate = 20      ! Component "inflation" factor
                                           ! 20 is a decent value, sometimes too short
     !
     integer(kind=4) :: ngoal = 10000   ! Maximum number of minor cycle components
     logical :: keep = .true.           ! Convergence criterium 
     integer(kind=4) :: m_iter = 500    ! Maximum number of iterations
     integer(kind=4) :: n_iter = 0      ! Current number of iterations
     integer(kind=4) :: p_iter = 0      ! Positive number of iterations
     integer(kind=4) :: n_major = 50    ! Maximum number of major cycle
     !
     real(kind=4) :: major = 0.0        ! Major axis
     real(kind=4) :: minor = 0.0        ! Minor axis
     real(kind=4) :: angle = 0.0        ! Clean beam angle
     real(kind=4) :: beam_min           ! Beam minimum
     real(kind=4) :: beam_max           ! Beam maximum
     real(kind=4) :: bgain              ! Outer sidelobe
     !
     integer(kind=4) :: blc(2) = 0      ! Bottom Left Corner
     integer(kind=4) :: trc(2) = 0      ! Top Right Corner
     integer(kind=4) :: box(4)          ! Cleaning Box
     integer(kind=4) :: beam0(2)        ! Beam center X,Y
     integer(kind=4) :: patch(2) = 0    ! Beam patch sizes
     integer(kind=4) :: bzone(4)        ! Beam patch
     integer(kind=4) :: bshift(3)       ! Beam shift
     !
     logical :: mosaic = .false.        ! Mosaic flag
     logical :: pflux = .false.         ! Flux display
     logical :: pcycle = .false.        ! Residual display in cycle
     logical :: pmrc                    ! MRC display in cycle
     logical :: qcycle                  ! Query mode
     logical :: pclean                  ! Clean display in cycle
     logical :: do_mask = .true.        ! Re-compute the mask ?
     logical :: verbose = .false.       ! Lots of printout ?
     !
     character(len=12) :: method = 'HOGBOM' ! METHOD
     real(kind=4), pointer :: weight(:,:,:) ! Mosaic weights (as function of freq)
     !
     ! integer, pointer :: list(:)    ! List of selected pixels
     ! logical, pointer :: mask(:,:)  ! Selection mask
   contains
     procedure, public :: init     => clean_par_init
     procedure, public :: copyto   => clean_par_copyto
     procedure, public :: sicdef   => clean_par_sicdef
     procedure, public :: list     => clean_par_list
     procedure, public :: fit_beam => clean_par_fit_beam
  end type clean_par
  !
contains
  !
  subroutine clean_par_init(prog,error)
    !-----------------------------------------------------------------------
    ! Initialize by setting the intent to out
    !-----------------------------------------------------------------------
    class(clean_par), intent(out)   :: prog
    logical,          intent(inout) :: error
    !
    if (error) return
  end subroutine clean_par_init
  !
  subroutine clean_par_copyto(in,out)
    !----------------------------------------------------------------------
    ! Copy method
    !----------------------------------------------------------------------
    class(clean_par), intent(in)    ::  in
    type(clean_par),  intent(inout) ::  out
    !
    out%method = in%method
    out%verbose = in%verbose
    !
    out%gain = in%gain
    out%fres = in%fres
    out%ares = in%ares
    out%major = in%major
    out%minor = in%minor
    out%angle = in%angle
    out%ratio = in%ratio
    out%spexp = in%spexp
    out%phat = in%phat
    out%smooth = in%smooth
    out%keep = in%keep
    out%mosaic = in%mosaic
    out%search = in%search
    out%restor = in%restor
    out%trunca = in%trunca
    out%m_iter = in%m_iter
    out%p_iter = in%p_iter
    out%ngoal = in%ngoal
    out%n_major = in%n_major
    out%nker = in%nker
    out%ninflate = in%ninflate
    out%blc = in%blc
    out%trc = in%trc
    out%patch = in%patch
    out%do_mask = in%do_mask
    ! 
    ! Pointer issue
    out%weight => in%weight
    ! Consequences
    !     box, beam0, bzone, n_iter, bshift, beam_min, beam_max, bgain, flux
    ! Variables
    !     Major, Minor, Angle
    ! Temporary
    !     Pflux, Pcycle, Qcycle, Pmrc, Pclean,
    ! Return
    !     Do_beam, Do_mask
  end subroutine clean_par_copyto
  !
  subroutine clean_par_sicdef(prog,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! 
    !-----------------------------------------------------------------------
    class(clean_par), intent(out)   :: prog
    logical,          intent(inout) :: error
    !
    logical :: warning ! To avoid raising errors when deleting GREG variables
    integer(kind=index_length) :: dim(4) = 0
    !
    call sic_def_inte('NITER',prog%m_iter,0,0,.false.,error)
    if (error) return
    dim(1) = 2
    call sic_def_inte('BEAM_PATCH',prog%patch,1,dim,.false.,error)
    if (error) return
    dim(1) = 2
    call sic_def_inte('BLC',prog%blc,1,dim,.false.,error)
    if (error) return
    call sic_def_inte('TRC',prog%trc,1,dim,.false.,error)
    if (error) return
    call sic_def_inte('POSITIVE',prog%p_iter,0,0,.false.,error)
    if (error) return
    call sic_def_inte('NMAJOR',prog%n_major,0,0,.false.,error)
    if (error) return
    call sic_def_real('GAIN',prog%gain,0,0,.false.,error)
    if (error) return
    call sic_def_real('FRES',prog%fres,0,0,.false.,error)
    if (error) return
    call sic_def_real('ARES',prog%ares,0,0,.false.,error)
    if (error) return
    !
    call sic_def_real('MAJOR',major_sec,0,0,.false.,error)
    if (error) return
    call sic_def_real('MINOR',minor_sec,0,0,.false.,error)
    if (error) return
    ! Delete the ANGLE variable defined by define.greg and recreate it
    ! such as it maps 'prog%angle'
    call sic_delvariable('ANGLE',.true.,warning)
    call sic_def_real('ANGLE',prog%angle,0,0,.false.,error)
    if (error) return
    call sic_def_logi('KEEP',prog%keep,.false.,error)
    if (error) return
    call sic_def_real('SPEED',prog%spexp,0,0,.false.,error)
    if (error) return
    call sic_def_inte('NGOAL',prog%ngoal,0,0,.false.,error)
    if (error) return
    !
    ! MultiScale
    dim(1) = 3
    call sic_def_inte('KERNEL',prog%nker,1,dim,.false.,error)
    if (error) return
    call sic_def_inte('INFLATE',prog%ninflate,0,0,.false.,error)
    if (error) return
    call sic_def_real('SMOOTH',prog%smooth,0,0,.false.,error)
    if (error) return
    !
    ! MRC
    call sic_def_real('RATIO',prog%ratio,0,0,.false.,error)
    if (error) return
    !
    ! Mosaic mode
    ! Delete the MOSAIC variable defined by define.greg and recreate it
    ! such as it maps 'prog%mosaic'
    call sic_delvariable('MOSAIC',.true.,warning)
    if (error) return
    call sic_def_logi('MOSAIC',prog%mosaic,.false.,error)
    if (error) return
    call sic_def_real('SEARCH_W',prog%search,0,0,.false.,error)
    if (error) return
    call sic_def_real('RESTORE_W',prog%restor,0,0,.false.,error)
    if (error) return
    !
    call sic_def_logi('METHOD_DOMASK',prog%do_mask,.false.,error)
    if (error) return
    call sic_def_logi('VERBOSE',prog%verbose,.false.,error)
    if (error) return
    !
    call sic_def_inte('CLEAN_CONVERGE',clean_converge,0,0,.false.,error)
    if (error) return
  end subroutine clean_par_sicdef
  !
  subroutine clean_par_list(clean)
    !--------------------------------------------------------------------
    !
    !--------------------------------------------------------------------
    class(clean_par) :: clean
    !
    write(6,*) clean%gain,clean%fres,clean%ares,' Loop gain,Fres,Ares'
    write(6,*) clean%major,clean%minor,clean%angle,' Major/Minor/Angle axis'
    write(6,*) clean%beam_min,clean%beam_max,clean%bgain,' Beam Min/Max Sidelobe'
    write(6,*) clean%ratio,clean%spexp,clean%phat,clean%smooth,' MRC ratio,Speed,Phat,Multi ratio'
    write(6,*) clean%flux,clean%keep,' Cleaned Flux,Keep'
    write(6,*) clean%search,clean%restor,clean%trunca,' Threshold Search/Restore/Truncate'
    write(6,*) clean%blc,clean%trc,' BLC,TRC '
    write(6,*) clean%box,' Cleaning Box'
    write(6,*) clean%beam0,clean%patch,' Beam center X,Y,Patch size'
    write(6,*) clean%bzone,' Beam patch Zone'
    write(6,*) clean%m_iter,clean%p_iter,clean%n_iter,' Iterations Max/Pos/Actual'
    write(6,*) clean%ngoal,clean%n_major,' Max select,Max cycle'
    write(6,*) clean%bshift,' Beam shift'
    write(6,*) clean%nker,' Kernel for Multi-Scale clean'
    write(6,*) 'Mos. Flux,Cycle,Query,Mrc,Clean,Beam/Mask'
    write(6,*) clean%mosaic,clean%pflux,clean%pcycle ,clean%qcycle,clean%pmrc,clean%pclean,clean%do_mask
    write(6,*) clean%first,clean%last,clean%iplane,clean%ibeam,clean%nlist,' First/Last/Current  Beam List'
    write(6,*) clean%method,' METHOD'
  end subroutine clean_par_list
  !
  subroutine clean_par_fit_beam(method,hbeam,dbeam,error)
    use image_def
    use fit_beam_tool
    !----------------------------------------------------------------------
    ! Fit clean beam parameters
    !----------------------------------------------------------------------
    class(clean_par), intent(inout) :: method
    type(gildas),     intent(in)    :: hbeam
    real,             intent(in)    :: dbeam(hbeam%gil%dim(1),hbeam%gil%dim(2))
    logical,          intent(inout) :: error
    !
    integer :: nx,ny
    !
    ! Use beam patch to search for maximum
    error = .false.
    nx =  hbeam%gil%dim(1)
    ny =  hbeam%gil%dim(2)
    call fibeam('CLEAN',dbeam,nx,ny,&
         method%patch(1),method%patch(2),method%thresh,&
         method%major,method%minor,method%angle,&
         hbeam%gil%convert,error)
  end subroutine clean_par_fit_beam
  !
  subroutine beam_unit_conversion(prog)
    use phys_const
    !----------------------------------------------------------------------
    ! Major and minor SIC variables are in seconds but the method structure
    ! assumes that its major and minor fields are in radian. So we need
    ! a conversion...
    !----------------------------------------------------------------------
    type(clean_par) :: prog
    !
    prog%major = major_sec*rad_per_sec
    prog%minor = minor_sec*rad_per_sec
  end subroutine beam_unit_conversion
end module clean_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_language
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_messaging
  use cubeadm_checksum
  use cubeadm_directory
  use cubeadm_export
  use cubeadm_flag
  use cubeadm_import
  use cubeadm_touch
  use cubeadm_transpose
  use cubeadm_update
  use cubeadm_verify
  !
  public :: cubeadm_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubeadm_register_language(error)
    !----------------------------------------------------------------------
    ! Register the ADM\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'ADM',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Commands to manage list of cubes',&
         'ADM manages cube registration and metadata operations in the DAG.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- DIRECTORY defines raw/reduced/tmp search locations.'//strg_cr//&
         '- IMPORT reads files into the DAG and EXPORT writes DAG cubes to files.'//strg_cr//&
         '- UPDATE, FLAG, and VERIFY maintain or validate cube metadata.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> ADM\DIRECTORY /RAW ./raw /RED ./red'//strg_cr//&
         'CUBE> ADM\IMPORT'//strg_cr//&
         'CUBE> ADM\UPDATE mycube /FLAGS =science'//strg_cr//&
         'CUBE> ADM\EXPORT mycube /FORMAT FITS',&
         'gag_doc:hlp/cube-help-adm.hlp',&
         cubeadm_execute_command,&
         langid,&
         error)
    if (error) return
    !
    call checksum%register(error)
    if (error) return
    call directory%register(error)
    if (error) return
    call export%register(error)
    if (error) return
    call flag%register(error)
    if (error) return
    call import%register(error)
    if (error) return
    call update%register(error)
    if (error) return
    call verify%register(error)
    if (error) return
    if (cube_dev_mode()) then
      call touch%register(error)
      if (error) return
      call transpose%register(error)
      if (error) return
    endif
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubeadm_register_language
  !
  subroutine cubeadm_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the ADM\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'ADM?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubeadm_finish_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubeadm_execute_command
end module cubeadm_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sic_alias(line,rglobal,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_alias
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   DEFINE ALIAS AliasName Variable [/GLOBAL]
  !
  !   Create an alias, that is another name for the same variable.
  !---------------------------------------------------------------------
  character(len=*) , intent(in)    :: line     !
  logical,           intent(in)    :: rglobal  !
  logical,           intent(inout) :: error    !
  ! Local
  character(len=varname_length) :: name
  character(len=128) :: chain
  integer :: n
  !
  ! Get the alias
  call sic_ch(line,0,2,name,n,.true.,error)
  if (error)  return
  !
  ! Get the target
  call sic_ch(line,0,3,chain,n,.true.,error)
  if (error) return
  !
  call sic_def_alias(name,chain,rglobal,error)
  if (error)  return
  !
end subroutine sic_alias
!
subroutine sic_def_alias(aliasname,targetname,global,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_def_alias
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !
  ! An "alias" is a variable pointing towards an existing one
  ! It need a code under -5, and different from -999, and under the
  ! ReadOnly offset. Let say -6, and call it ALIAS_DEFINED
  !
  ! We have a list of "alias" as a separate table
  ! For each entry, this list contains
  !     - the variable number
  !     - the pointed variable number
  !
  ! In deleting a variable, one checks
  !     - whether it is an alias (code = ALIAS_DEFINED).
  !         - then deleted it from the list aliases
  !         - delete the variable number and name, but do not free memory
  !     - or not
  !         - then check if it has aliases in the alias list.
  !         - Delete all aliases first
  !         - delete variable only after...
  !
  ! Structure canNOT have aliases
  !
  ! A problem concerns aliases of Header variables... They must be deleted
  ! at the same time than the others. This is handled by having the pointee
  ! number being the variable number of the header. To do so, when defining
  ! an alias, we have to figure out if the variable it
  ! points to is an header/image...
  !
  ! Alias can points towards sub-arrays
  !
  ! Alias have the same level as there pointees.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: aliasname   ! Alias name
  character(len=*), intent(in)    :: targetname  ! Target name
  logical,          intent(in)    :: global      ! Is the target global?
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DEFINE'
  type(sic_identifier_t) :: aliasvar,targetvar,headvar
  integer :: level,in,jn,kn,ier,n
  type(sic_descriptor_t) :: desc
  type(sic_dimensions_t) :: spec
  logical :: lglobal,verbose
  !
  ! Modify here to support sub-array
  ! Parse name from dimensions...
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .true.   ! e.g. A[3:5] supported
  spec%do%subset   = .false.  ! e.g. A[2,] not supported
  spec%do%implicit = .false.  ! e.g. A[i] not allowed
  spec%do%twospec  = .true.   ! e.g. A[i][j:k] allowed
  verbose  = .true.
  call sic_parse_dim(targetname,targetvar,spec,verbose,error)
  if (error) return
  !
  lglobal = global
  if (lglobal) then
    level = 0
  else
    level = var_level
  endif
  targetvar%level = level
  !
  ! Find the variable
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,targetvar,jn)
  !
  ! Also check whether a Global variables fit when the request is Local
  if (ier.ne.1 .and. .not.lglobal) then
    level = 0
    targetvar%level = level
    lglobal = .true.
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,targetvar,jn)
  endif
  if (ier.ne.1) then
    call sic_message(seve%e,rname,  &
      'Pointee Variable '//trim(targetvar%name)//' does not exist')
    error = .true.
    return
  endif
  if (dicvar(jn)%desc%status.eq.alias_defined) then
    ! Forbidden, at least as long as the destruction of the target will
    ! not be able to destroy its aliases and aliases of aliases.
    call sic_message(seve%e,rname,'An alias can not point to another alias')
    error = .true.
    return
  endif
  !
  ! Alias can be a structure member under limited conditions
  if (sic_checkstruct(aliasname,lglobal).eq.0) then
    error = .true.
    return
  endif
  !
  ! It must be valid name
  call sic_validname(aliasname,error)
  if (error) then
    call sic_message(seve%e,rname,'Invalid variable name '//aliasname)
    return
  endif
  !
  ! It must not be already existing. Aliases have same level as Pointees.
  aliasvar%name = aliasname
  aliasvar%lname = len_trim(aliasname)
  aliasvar%level = level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,aliasvar,kn)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,  &
      'Variable '//trim(aliasname)//' already exists')
    error = .true.
    return
  endif
  !
  ! Insert it
  ier = sic_hasins(rname,maxvar,pfvar,pnvar,dicvar,aliasvar,in)
  if (ier.eq.0 .or. ier.eq.2) then
    error = .true.
    return
  endif
  !
  ! Set the back pointer. Aliases are always considered as user-defined (even
  ! if defined from program) because they can point either on user or program
  ! defined variables, and thus can be local "variables".
  if (lglobal) then
    var_g = var_g-1
    var_pointer (var_g) = in
  else
    var_n = var_n+1
    var_pointer (var_n) = in
  endif
  !
  ! Fill the descriptor
  ! Do not allow incarnation or transposition here
  call extract_descr(desc,dicvar(jn)%desc,spec%done,targetvar%name,.false.,0,error)
  if (error) return
  dicvar(in)%desc = desc
  dicvar(in)%desc%status = alias_defined
  !
  ! Add to the list of aliases
  nalias = nalias+1
  alias(nalias) = in
  !
  ! Check if pointee is part of an header
  n = index(dicvar(jn)%id%name,'%')
  if (n.ne.0) then
    n = n-1
    headvar%name = dicvar(jn)%id%name(1:n)
    headvar%lname = n
    headvar%level = level   ! As the Alias
    kn = jn
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,headvar,kn)
    if (dicvar(kn)%desc%status.gt.0) then    ! This is a header OR image
      jn = kn
    endif
  endif
  pointee(nalias) = jn
  targetvar%name = targetname
  call sic_upper(targetvar%name)
  targetvar%lname = len_trim(targetname)
  dicali(nalias) = targetvar
  !
#if defined(GAG_USE_PYTHON)
  call gpy_getvar(aliasvar%name,aliasvar%level)
#endif
  !
end subroutine sic_def_alias
!
subroutine zap_alias (in)
  use sic_interfaces, except_this=>zap_alias
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Delete an Alias from the list of aliases
  !---------------------------------------------------------------------
  integer,intent(in) :: in          ! Alias number
  ! Local
  integer :: i,j
  !
  j = 0
  do i=1,nalias
    if (alias(i).eq.in) then
      j = i
      exit
    endif
  enddo
  if (j.eq.0) then
    call sic_message(seve%e,'SIC','lost alias ...')
    return
  endif
  !
  nalias = nalias-1
  do i=j,nalias
    alias(i) = alias(i+1)
    pointee(i) = pointee(i+1)
    dicali(i) = dicali(i+1)
  enddo
  alias(nalias+1) = 0
  pointee(nalias+1) = 0
  dicali(nalias+1)%name = ' '
  dicali(nalias+1)%lname = 0
  dicali(nalias+1)%level = 0
end subroutine zap_alias
!
subroutine del_alias (in,local)
  use sic_interfaces, except_this=>del_alias
  use gildas_def
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Delete the aliases pointing (even partially) towards variable IN
  !---------------------------------------------------------------------
  integer, intent(in) :: in         ! Pointee number
  logical, intent(in) :: local      ! Local or Global status
  ! Local
  integer :: i,j
  logical :: error,user
  !
  error = .false.
  user = .true.  ! Aliases always considered as user-defined
  !
  i = 1
  do while (i.le.nalias)
    if (pointee(i).eq.in) then
      ! If this alias points on IN, delete it. This pushes down the list
      ! of aliases, so do not increment I
      j = alias(i)
#if defined(GAG_USE_PYTHON)
      ! The Jth element of DICALI is the alias target.
      ! The Jth element of DICVAR is the alias name.
      call gpy_delvar(dicvar(j)%id%name,dicvar(j)%id%level)
#endif
      call zap_alias(j)
      call sic_zapvariable(j,user,local,error)
    else
      ! Else, go to next name
      i = i+1
    endif
  enddo
end subroutine del_alias

      SUBROUTINE GLINSERT(LINE,ERROR)
      USE GKERNEL_INTERFACES
C insert data from the Gliese catalog
      CHARACTER LINE*(*)
      logical error
*
      INCLUDE 'pi.inc'
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
!      INCLUDE 'file.inc'
*
!      LOGICAL SIC_PRESENT
!      LOGICAL OPTION
      CHARACTER*20    GLNAME,NAME
      CHARACTER*80    FILE
      CHARACTER*183  STRING
      INTEGER LUN,STATUS
      INTEGER LG,LN
      INTEGER CODE,IER
      LOGICAL FOUND
*
      FOUND = .FALSE.
      FILE = 'GLIESE_CATALOG'
      IER = SIC_GETLOG(FILE)
      STATUS = SIC_GETLUN (LUN)
      OPEN(UNIT=LUN, FILE=FILE,STATUS='OLD',FORM='FORMATTED',ERR=99)
      GLNAME=object(1)
      write(*,11) GLNAME
 11   format (1x,a10)
      DO WHILE (.NOT.FOUND)
         read(lun,'(A183)',end=98) string
         name = string(1:10)
         LG = LEN(GLNAME)
         CALL NO_SPACE(GLNAME,LG)
         LN = LEN(NAME)
         CALL NO_SPACE(NAME,LN)
         write(6,*) name,glname
         IF (NAME.EQ.GLNAME) THEN
            STRING(15:15) = ':'
            STRING(18:18) = ':'
            CALL SIC_SEXA(STRING(13:20),8,RA,ERROR)
            IF (ERROR) THEN
               WRITE(6,*) 'Invalid RA string',STRING(13:20)
               GOTO 99
            ENDIF
            RA = RA*PI/12.
            STRING(25:25) = ':'
            CALL SIC_SEXA(STRING(22:29),8,DEC,ERROR)
            IF (ERROR) THEN
               WRITE(6,*) 'Invalid Dec string',STRING(22:29)
               GOTO 99
            ENDIF
            DEC = DEC*PI/180.
            EQUINOX=1950.0
            SPECTRAL_TYPE(1) = STRING(55:66)
* V magnitude
            CALL FIND_PHOT_CODE('V',CODE,ERROR)
            IF (.NOT.ERROR) THEN
               READ(STRING(68:73),'(F6.2)') MAGNITUDE(CODE)
            ENDIF
            NPARA =1
            READ(STRING(109:114),'(F6.1)') PARALLAX(NPARA)
            PARALLAX(NPARA)=PARALLAX(NPARA)*1E-3 ! Convert mas to arcseconds
            READ(STRING(115:119),'(F5.1)') PARERR(NPARA)
            PARERR(NPARA)=PARERR(NPARA)*1E-3 ! Convert mas to arcseconds
            write (*,102) PARALLAX(NPARA),PARERR(NPARA)
 102        format(1x,'parallax= ',f6.4,' +-',f5.4)
            FOUND=.TRUE.
         ENDIF
      ENDDO
      CLOSE(LUN)        
      RETURN
*

 98   WRITE (*,*) 'Star ',GLNAME,' not found in Gliese catalog'
      npara = 0
      RETURN
 99   WRITE (*,*) 'Error opening Gliese catalog ',FILE
      END

      SUBROUTINE MONTE_CARLO_ELEMENTS(NSAMPLE,ELEMENTS,ERROR)
C----------------------------------------------------------------------
C ORBIT 
C       Generate requested number of montecarlo orbital elements 
C Arguments :
C       NSAMPLE  I       Number of requested element sets      Input
C       ELEMENTS R*8(*)  Montecarlo orbital elements           Output
C       ERROR    L       Logical error flag                    Output
C-----------------------------------------------------------------------------
      INCLUDE 'constant.inc'
      INTEGER NSAMPLE
      REAL*8 ELEMENTS(MA,NSAMPLE)
      LOGICAL ERROR
*
      INCLUDE 'elements.inc'
      INCLUDE 'data.inc'
*
      REAL*8  EL_SAVE(MA)      ! Fitted values of elements
      INTEGER I,J,MITER
      LOGICAL QUIET,UPDATE,WARNING
      LOGICAL SIC_CTRLC
*
      QUIET  = .TRUE.
      UPDATE = .FALSE.
      MITER = 20
      CALL SAVE_DATA
      DO I=1,MA
         EL_SAVE(I) = EL(I)
      ENDDO
*
      DO J=1,NSAMPLE
         IF (SIC_CTRLC()) GOTO 99
* Refresh the internal set of orbital elements and generate montecarlo data
         CALL INIT_KEPLER(EL_SAVE,.FALSE.)
         CALL GENERATE_DATA(1,NVR,1,NVCORR,1,NN,1,NPARA,ERROR)
         IF (ERROR) GOTO 99
* Fit the new data
         DO I=1,MA
            ELEMENTS(I,J) = EL_SAVE(I)
         ENDDO
         CALL DO_FIT(MITER,ELEMENTS(1,J),UPDATE,QUIET,WARNING,ERROR)
         IF (ERROR) ERROR = .FALSE.  ! Some samplings may fail to converge
         IF (MOD(J,50).EQ.0)
     +        WRITE(6,*) J,' montecarlo samples generated'
      ENDDO
      CALL RESTORE_DATA
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END

      SUBROUTINE SAVE_DATA
C-------------------------------------------------------------------------
C ORBIT: Copy all data to an auxiliary array, so that the main data
C array can be used during the montecarlo error estimation
C-------------------------------------------------------------------------
*
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
*
      INTEGER I,J
* Radial velocities
      DO J=1,5
         DO I=1,NVR
            VR_SAVE(I,J) = VR(I,J)
         ENDDO
      ENDDO
* Visual orbit
      DO J=1,7
         DO I=1,NN
            OBS_SAVE(I,J) = OBS(I,J)
         ENDDO
      ENDDO
* Correlation profile
      DO J=1,MVCORR
         DO I=1,NVPNTS(J)
            VCORR_SAVE(I,J) = VCORR(I,J)
         ENDDO
      ENDDO
* Parallaxes
      DO I=1,NPARA
         PAR_SAVE(I) = PARALLAX(I)
      ENDDO
      RETURN
      END

      SUBROUTINE RESTORE_DATA
C-------------------------------------------------------------------------
C ORBIT: Restore all data from auxiliary arrays, after the main data
C array have been overwritten during the montecarlo error estimation
C-------------------------------------------------------------------------
*
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
*
      INTEGER I,J
* Radial velocities
      DO J=1,5
         DO I=1,NVR
            VR(I,J) = VR_SAVE(I,J) 
         ENDDO
      ENDDO
* Visual orbit
      DO J=1,7
         DO I=1,NN
            OBS(I,J) = OBS_SAVE(I,J) 
         ENDDO
      ENDDO
* Correlation profile
      DO J=1,MVCORR
         DO I=1,NVPNTS(J)
            VCORR(I,J) = VCORR_SAVE(I,J) 
         ENDDO
      ENDDO
* Parallaxes
      DO I=1,NPARA
         PARALLAX(I) = PAR_SAVE(I) 
      ENDDO
      RETURN
      END

      SUBROUTINE GENERATE_DATA(FIRST_VR,N_VR,FIRST_VCORR,
     +     N_VCORR,FIRST_VIS,N_VIS,FIRST_PARA,N_PARA,ERROR)
C-------------------------------------------------------------------------
C ORBIT: Generate trial data for one montecarlo step
C-------------------------------------------------------------------------
      INTEGER FIRST_VR,N_VR,FIRST_VCORR,N_VCORR,FIRST_VIS,
     +     N_VIS,FIRST_PARA,N_PARA
      LOGICAL ERROR
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
      INCLUDE 'elements.inc'
      INCLUDE 'pi.inc'
*
      INTEGER I
      REAL B(MA),V,PHASE,RHO,THETA,XX,YY,POS,CPOS,SPOS
      REAL PAR
      REAL RANGAU
*
* Radial velocity data
      DO I=FIRST_VR,FIRST_VR+N_VR-1
         CALL SET_TIME(1,IORB0,VR(I,I_TIME),PHASE)
         IF (CVR(I).EQ.'2') THEN
            CALL GRAD_V2(VREFCODE(I),V,B)
         ELSEIF (CVR(I).EQ.'1') THEN
            CALL GRAD_V1(VREFCODE(I),V,B)
            IF (V.NE.V) THEN
               write(6,*) 'Estimated Velocity ',V
            ENDIF
         ELSEIF (CVR(I).EQ.'11') THEN
            CALL GRAD_V11(VREFCODE(I),V,B)
         ELSEIF (CVR(I).EQ.'12') THEN
            CALL GRAD_V12(VREFCODE(I),V,B)
         ELSEIF (CVR(I).EQ.'21') THEN
            CALL GRAD_V21(VREFCODE(I),V,B)
         ELSEIF (CVR(I).EQ.'22') THEN
            CALL GRAD_V22(VREFCODE(I),V,B)
         ELSE
            WRITE(6,*) 'Unknown velocity type: ',CVR(I)
         ENDIF
         VR(I,I_VR) = V+SIG*RANGAU(SNGL(VR(I,I_S_VR)))
      ENDDO
* 
      DO I=FIRST_VCORR,FIRST_VCORR+N_VCORR-1
         CALL GENERATE_VCORR(I,ERROR)
         IF (ERROR) GOTO 99 
      ENDDO

      DO I=FIRST_VIS,FIRST_VIS+N_VIS-1
         CALL SET_TIME(1,IORB0,OBS(I,I_TIME),PHASE)
         IF (COBS(I).EQ.'rho-theta') THEN ! Rho+Theta pair
            CALL KEPLER_RHOTHETA(RHO,THETA)
            OBS(I,I_RHO)   = RHO+SIG*RANGAU(SNGL(OBS(I,I_S_RHO)))
            OBS(I,I_THETA) = THETA+SIG*RANGAU(SNGL(OBS(I,I_S_THETA)))
         ELSEIF (COBS(I).EQ.'PROJ') THEN ! Projected separation
            CALL KEPLER_XY(XX,YY)
            POS = (90-OBS(I,I_POSANG))/GR! Astro PA to trigonometric convention
            CPOS=COS(POS)
            SPOS=SIN(POS)
            OBS(I,I_PROJ) = XX*CPOS+YY*SPOS+
     +           SIG*RANGAU(SNGL(OBS(I,I_S_PROJ)))
         ELSEIF (COBS(I).EQ.'XY')  THEN ! X+Y pairs
            CALL KEPLER_XY(XX,YY)
            OBS(I,I_X) = XX+SIG*RANGAU(SNGL(OBS(I,I_S_X)))
            OBS(I,I_Y) = YY+SIG*RANGAU(SNGL(OBS(I,I_S_Y)))
         ELSEIF (COBS(I).EQ.'ZT') THEN
            CALL KEPLER_XY(XX,YY)
            OBS(I,I_Z) = (XX+YY)/SQRT(2.)+SIG*RANGAU(SNGL(OBS(I,I_S_Z)))
            OBS(I,I_T) = (YY-XX)/SQRT(2.)+SIG*RANGAU(SNGL(OBS(I,I_S_T)))
         ENDIF
      ENDDO
*
      DO I=FIRST_PARA,FIRST_PARA+N_PARA-1
         CALL GRAD_PARALLAX(PAR,B)
         PARALLAX(I) = PAR+SIG*RANGAU(PARERR(I))
      ENDDO

      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END


      SUBROUTINE GENERATE_VCORR(ICOR,ERROR)
      INTEGER ICOR
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
      INCLUDE 'elements.inc'
      INCLUDE 'control.inc'
*
      REAL RANGAU
      INTEGER J
*
* Request the model profile on observing date date of true profile ICOR, 
* with all components in,
* 
      CALL GET_MODEL_PROFILE(ICOR,1,0,.TRUE.,
     +     PROFILE_METHOD.EQ.'CORRECTED',
     +     NVPNTS(ICOR),
     +     COR_REFPIX(ICOR),COR_REFVAL(ICOR),COR_VSTEP(ICOR),
     +     VCORR(1,ICOR),ERROR)
* Add gaussian noise
      DO J=1,NVPNTS(ICOR)
         VCORR(J,ICOR) = VCORR(J,ICOR)+SIG*RANGAU(COR_SIGM(ICOR))
      ENDDO
      RETURN
      END

!-----------------------------------------------------------------------
! Support file for the File Descriptor
!-----------------------------------------------------------------------
subroutine classic_filedesc_init(file,fkind,lsingle,lsize,vind,lind,gex,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>classic_filedesc_init
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  !   Initialize a new File Descriptor.
  !   The following elements must have been set before:
  !       file%lun, file%spec, file%nspec
  !   On return, those are set:
  !       file%desc, file%conv
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(inout) :: file     !
  integer(kind=4),            intent(in)    :: fkind    ! File kind
  logical,                    intent(in)    :: lsingle  ! Single or multiple
  integer(kind=entry_length), intent(in)    :: lsize    ! Total number of entries (linear growth)
  integer(kind=4),            intent(in)    :: vind     ! Index version
  integer(kind=4),            intent(in)    :: lind     ! Index length (words)
  real(kind=4),               intent(in)    :: gex      ! Extension growth
  logical,                    intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE'
  !
  ! Set up the conversion routines
  file%conv%code = 0    ! New File = Native = No conversion
  call classic_conv(file%conv,error)
  if (error)  return
  !
  ! Set up the File Descriptor structure
  call filedesc_init_common(fkind,vind,lind,lsingle,gex,file%desc,error)
  if (error)  return
  if (file%desc%version.eq.1) then
    call filedesc_init_v1(file%desc,error)
  else
    call filedesc_init_v2(file%desc,error)
  endif
  if (error)  return
  call filedesc_init_lex1(lsize,file%desc,error)  ! Must come last
  if (error)  return
  !
  ! No need to set up the first extension: it will be done when writing
  ! the first entry (i.e. symmetric to what happens when setting any
  ! extension).
  !
  ! Write the File Descriptor to the file
  call classic_filedesc_write(file,error)
  if (error)  return
  !
  ! Flush first records
  call classic_file_fflush(file,error)
  if (error)  return
  !
end subroutine classic_filedesc_init
!
subroutine filedesc_init_common(fkind,vind,lind,lsingle,gex,fdesc,error)
  use gbl_message
  use classic_interfaces, except_this=>filedesc_init_common
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Initialize the common part of File Descriptor structure in memory
  ! (i.e. V2), suited for any File Version
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: fkind    ! File kind
  integer(kind=4),          intent(in)    :: vind     ! Index version
  integer(kind=4),          intent(in)    :: lind     ! Index length (words)
  logical,                  intent(in)    :: lsingle  ! Single or multiple?
  real(kind=4),             intent(in)    :: gex      ! Extension growth
  type(classic_filedesc_t), intent(inout) :: fdesc    ! File Descriptor
  logical,                  intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='FILE'
  character(len=message_length) :: mess
  integer(kind=4) :: gex10
  !
  if (fkind.ne.classic_kind_demo  .and.  &
      fkind.ne.classic_kind_class .and.  &
      fkind.ne.classic_kind_clic  .and.  &
      fkind.ne.classic_kind_mrtcal) then
    write(mess,'(A,I0)')  'Unknown File Kind #',fkind
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (lind.le.0) then
    write(mess,'(A,I0)')  'Programming error: illegal Entry Index length ',lind
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  gex10 = nint(10.0*gex)
  if (gex10.ne.10 .and. gex10.ne.20) then
    write(mess,'(A,F0.1)')  &
      'Programming error: unimplemented Extension Growth ',gex
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! fdesc%reclen has been set before
  fdesc%kind   = fkind    !
  fdesc%vind   = vind     !
  fdesc%lind   = lind     !
  fdesc%single = lsingle  !
  fdesc%flags  = 0        ! Set the 32 bits to 0
  if (fdesc%single)  fdesc%flags = ibset(fdesc%flags,0)  ! Set 1st bit
  fdesc%xnext  = 1        ! Next available entry number
  fdesc%nex    = 0        ! Current number of extensions used
  fdesc%gex    = gex10    ! 10*gex, rounded to nearest integer
  !
end subroutine filedesc_init_common
!
subroutine filedesc_init_v1(fdesc,error)
  use gbl_message
  use classic_interfaces, except_this=>filedesc_init_v1
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Initialize the File Descriptor structure in memory (i.e. V2),
  ! suited for Version 1 files
  !---------------------------------------------------------------------
  type(classic_filedesc_t), intent(inout) :: fdesc  ! File Descriptor
  logical,                  intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FILE'
  character(len=message_length) :: mess
  !
  if (fdesc%lind.ne.classic_lind_v1) then
    write(mess,'(A,I0,A,I0,A)')  &
      'Programming error: Index length must be ',classic_lind_v1,  &
      ' for Version 1 files (got ',fdesc%lind,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (fdesc%vind.ne.classic_vind_v1) then
    write(mess,'(A,I0,A,I0,A)')  &
      'Programming error: Index version must be ',classic_vind_v1,  &
      ' for Version 1 files (got ',fdesc%vind,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (fdesc%gex.ne.10) then
    write(mess,'(A,A,F0.1,A)')  &
      'Programming error: Extension Growth must be linear (1.0)',  &
      ' for Version 1 files (got ',fdesc%gex/10.,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  fdesc%version = 1
  !
  if (fdesc%single) then
    fdesc%code = code_file_v1_single
  else
    fdesc%code = code_file_v1_multiple
  endif
  fdesc%nextrec = 3   ! V1: the File Descriptor takes 2 records, next available is 3
  fdesc%nextword = 1
  !
  ! Set fdesc%mex and define fdesc%aex(:)
  call reallocate_aex(fdesc,mex_v1,error)
  if (error)  return
  !
end subroutine filedesc_init_v1
!
subroutine filedesc_init_v2(fdesc,error)
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>filedesc_init_v2
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Initialize the File Descriptor structure in memory (i.e. V2),
  ! suited for Version 2 files
  !---------------------------------------------------------------------
  type(classic_filedesc_t), intent(inout) :: fdesc  ! File Descriptor
  logical,                  intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FILE'
  character(len=message_length) :: mess
  integer(kind=4) :: reclenmin,mex
  !
  ! There should be room for at least 1 extension address in the file
  ! descriptor AND for at least 1 entry index in the 1st extension
  ! index (linear or exponential growth)
  reclenmin = max(filedescv2_nw1+2,fdesc%lind)
  !
  if (fdesc%reclen.lt.reclenmin) then
    write(mess,'(A,I0,A,I0,A)')  &
      'Programming error: record length must be at least ',reclenmin,  &
      ' for Version 2 files (got ',fdesc%reclen,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  fdesc%version = 2
  fdesc%code = code_file_v2
  fdesc%nextrec = 2  ! V2: the File Descriptor takes 1 record
  fdesc%nextword = 1
  !
  ! Set fdesc%mex and define fdesc%aex(:)
  mex = (fdesc%reclen-filedescv2_nw1)/2  ! Size of aex(:) (2 words per element)
  call reallocate_aex(fdesc,mex,error)
  if (error)  return
  !
end subroutine filedesc_init_v2
!
subroutine filedesc_init_lex1(lsize,fdesc,error)
  use gbl_message
  use classic_interfaces, except_this=>filedesc_init_lex1
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  !   Compute the extension length. mex, gex and several parameters must
  ! have already been set.
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)    :: lsize  ! Max number of entries in the file
  type(classic_filedesc_t),   intent(inout) :: fdesc  ! File Descriptor
  logical,                    intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FILE'
  integer(kind=entry_length), parameter :: maxi=2147483647
  character(len=message_length) :: mess
  integer(kind=8) :: lex1_e,lex1_r
  !
  if (fdesc%version.eq.1 .and. lsize.gt.maxi) then
    write(mess,'(A,I0,A)')  &
      'Version 1 files must not have more than 2147483647 entries (got ',lsize,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (fdesc%gex.eq.10) then
    ! Linear growth. Compute 'lex1' from 'lsize'. 'lex1' is the length of
    ! 1st (and all for linear growth) extension. Use up-rounding so that
    ! the index can hold at least 'lsize' entries.
    ! Desired number of entries per extension (up-rounded):
    lex1_e = (lsize-1)/fdesc%mex+1
    ! Desired number of records per extension (up-rounded):
    lex1_r = (lex1_e*fdesc%lind+fdesc%reclen-1)/fdesc%reclen
    ! NB: there can be a non-integer number of entry index per record
  else
    ! Exponential growth. There is currently no way to add a scaling factor:
    ! use the minimum possible i.e. 1 record fully devoted to the Index
    lex1_r = 1
  endif
  !  Compute number of entries in first extension. When creating new files,
  ! the libclassic uses at best the records devoted to the first extension
  ! index, for V1 and for V2.
  !  NB: other applications writing Classic files may not do this, so
  ! we can not assume this at re-read time.
  fdesc%lex1 = (lex1_r*fdesc%reclen)/fdesc%lind  ! Integer division
  !
end subroutine filedesc_init_lex1
!
subroutine filedesc_incr(lun,fdesc,full,error)
  use gbl_message
  use classic_interfaces, except_this=>filedesc_incr
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Increment the File Descriptor, i.e. add 1 new extension
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: lun    ! File logical unit
  type(classic_filedesc_t), intent(inout) :: fdesc  ! File Descriptor
  logical,                  intent(out)   :: full   ! Is the index full?
  logical,                  intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILEDESC'
  character(len=message_length) :: mess
  integer(kind=4) :: abuf(fdesc%reclen)  ! Automatic array. 'reclen' words = 1 record
  integer(kind=4) :: ier
  integer(kind=8) :: kbl,irec,nrec,nent
  !
  full = fdesc%nex.eq.fdesc%mex
  if (full) then
    ! All the 'mex' extensions have been filled
    write (mess,'(a,i0,a)')  &
      'File is full (index exhausted: ',fdesc%mex,' extensions filled)'
    call classic_message(seve%e,rname,mess)
    write (mess,'(a,i0,a)')  &
      'Attempt to write more than ',fdesc%lexn(fdesc%nex),' entries in file'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  fdesc%nex            = fdesc%nex+1  ! One more extension
  if (fdesc%nextword.ne.1) then
    ! Extensions always start at the beginning of a record
    fdesc%nextrec = fdesc%nextrec+1
    fdesc%nextword = 1
  endif
  fdesc%aex(fdesc%nex) = fdesc%nextrec   ! Address of the new extension
  if (fdesc%gex.eq.10) then
    ! Linear case
    nent = fdesc%lex1
  elseif (fdesc%gex.eq.20) then
    ! Exponential case. Only growth with mantissa 2.0 is supported
    nent = int(fdesc%lex1,kind=8) * 2_8**(fdesc%nex-1)
  else
    call classic_message(seve%e,rname,  &
      'Only growth modes gex==10 and gex==20 are supported')
    error = .true.
    return
  endif
  nrec = (nent*fdesc%lind-1)/fdesc%reclen+1  ! Number of records devoted to the
                                             ! Entry Indexes in this new extension
  fdesc%lexn(fdesc%nex) = fdesc%lexn(fdesc%nex-1) + nent
  !
  ! Fill Entry Indexes of the new extension with 0
  abuf(:) = 0
  !
  write(mess,'(4(A,I0),A)')  &
    'Expand Index to ',fdesc%nex,' at record ',fdesc%nextrec,', ',  &
    nent,' new Entry Indexes in index, ',nrec,' records'
  call classic_message(seve%d,rname,mess)
  !
  do irec=1,nrec
    kbl = fdesc%aex(fdesc%nex)+irec-1
    write(lun,rec=kbl,iostat=ier) abuf
    if (ier.ne.0) then
      write(mess,'(A,I0)') 'Write error record #',kbl
      call classic_message(seve%e,rname,mess)
      call classic_iostat(seve%e,rname,ier)
      error = .true.
      exit
    endif
  enddo
  !
  if (error) then
    ! Try to recover from error
    fdesc%aex(fdesc%nex) = 0
    fdesc%nex = fdesc%nex-1
  else
    fdesc%nextrec = fdesc%nextrec+nrec  ! Next available record after operation
    fdesc%nextword = 1
  endif
  !
end subroutine filedesc_incr
!
subroutine classic_filedesc_open(file,error)
  use gbl_message
  use classic_interfaces, except_this=>classic_filedesc_open
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  ! Open and read the File Descriptor, namely:
  ! - Get the File Code and set the File-Data-Type-to-System-Data-Type
  !   conversion code,
  ! - Read the File Descriptor from the file, and take care of the
  !   possible conversion.
  ! Fortran-open the file itself if needed.
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file   !
  logical,              intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE'
  integer(kind=4) :: ier
  logical :: lpdp11
  !
  error = .false.
  !
  read(file%lun,rec=1,iostat=ier) file%desc%code  ! Read only one word from the record
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Read error record 1')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    return
  endif
  !
  ! Set up the conversion routines
  call classic_convcod(file%desc%code,file%desc%version,file%desc%single,  &
    lpdp11,file%conv%code,error)
  if (error)  return
  if (file%conv%code.lt.0) then
    call classic_message(seve%e,rname,'Non-standard file')
    error = .true.
    return
  endif
  if (lpdp11) then
     call classic_message(seve%e,rname,'Old PDP 11 format not supported')
     error = .true.
     return
  endif
  call classic_conv(file%conv,error)
  if (error)  return
  !
  call classic_filedesc_read(file,error)
  if (error)  return
  !
end subroutine classic_filedesc_open
!
subroutine classic_filedesc_read(file,error)
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>classic_filedesc_read
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  !   Read the File Descriptor from the file, and take care of the
  ! possible conversion. The file itself must have been opened before.
  ! The conversion code is not reevaluated.
  !   It may be useful to re-read a File Descriptor because another
  ! program might have updated it since last classic_filedesc_open or
  ! classic_filedesc_read.
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file   !
  logical,              intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: ier
  integer(kind=8) :: descsize,filesize
  character(len=message_length) :: mess
  !
  if (file%desc%version.eq.1) then
    call filedesc_read_v1(file,error)
  else
    call filedesc_read_v2(file,error)
  endif
  !
  descsize = classic_file_size(file)
  ier = gag_filsize(file%spec,filesize)
  if (ier.ne.0)  return  ! Could not retrieve the file size on disk...
  !
  if (filesize.lt.descsize) then
    write(mess,'(3A,I0,3A,I0,3A)')  'File ',trim(file%spec),  &
      ' has wrong size: expected ',descsize,' bytes (', &
      trim(gag_memsize_format(descsize)),'), found ',&
      filesize,' (',trim(gag_memsize_format(filesize)),')'
    call classic_message(seve%w,'FILE',mess)
  endif
  !
end subroutine classic_filedesc_read
!
subroutine filedesc_read_v1(file,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>filedesc_read_v1
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Read the File Descriptor from the file, version 1 + conversion to
  ! structure in memory, version 2
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file   !
  logical,              intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE'
  integer(kind=4) :: abuf(classic_reclen_v1)  ! Automatic array
  integer(kind=4) :: ier
  type(filedesc_v1_t) :: fdesc
  !
  error = .false.
  !
  ! Record 1: fdesc%code, fdesc%next, fdesc%lex, fdesc%nex, fdesc%xnext, fdesc%aex(1:reclen-5)
  read(file%lun,rec=1,iostat=ier) abuf
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Read error record #1')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    return
  endif
  ! 1: fdesc%code (no conversion)
  fdesc%code = abuf(1)  ! File code bytes, in the File Data Type
  ! 2: fdesc%next, fdesc%lex, fdesc%nex, fdesc%xnext, fdesc%aex(1:reclen-5) (converted)
  call file%conv%read%i4(abuf(2),fdesc%next,classic_reclen_v1-1)
  !
  ! Record 2: fdesc%aex(:)  (continued)
  read(file%lun,rec=2,iostat=ier) abuf
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Read error record #2')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    return
  endif
  call file%conv%read%i4(abuf,fdesc%aex(classic_reclen_v1-4),classic_reclen_v1)
  !
  ! Fill the V2 memory structure
  call filedesc_v1tov2(fdesc,file%desc,error)
  if (error)  return
  !
end subroutine filedesc_read_v1
!
subroutine filedesc_v1tov2(fdesc1,fdesc2,error)
  use classic_interfaces, except_this=>filedesc_v1tov2
  use classic_params
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(filedesc_v1_t),      intent(in)    :: fdesc1  !
  type(classic_filedesc_t), intent(inout) :: fdesc2  ! INOUT because of allocatable AEX(:)
  logical,                  intent(inout) :: error   !
  ! Local
  integer(kind=4) :: iex
  !
  fdesc2%version  = 1
  fdesc2%code     = fdesc1%code
  fdesc2%reclen   = classic_reclen_v1
  fdesc2%kind     = classic_kind_unknown
  fdesc2%vind     = classic_vind_v1
  fdesc2%lind     = classic_lind_v1
  ! fdesc2%single = should come from the code above (on return of
  !   'classic_convcod'). Assume UNCHANGED (inout).
  fdesc2%flags    = 0        ! Set the 32 bits to 0
  if (fdesc2%single)  fdesc2%flags = ibset(fdesc2%flags,0)  ! Set 1st bit
  fdesc2%xnext    = fdesc1%xnext
  fdesc2%nextrec  = fdesc1%next
  fdesc2%nextword = 1
  fdesc2%lex1     = fdesc1%lex  ! in number of entries
  fdesc2%nex      = fdesc1%nex
  fdesc2%gex      = 10  ! Linear growth
  !
  call reallocate_aex(fdesc2,mex_v1,error)
  if (error)  return
  fdesc2%aex(:)  = fdesc1%aex(:)
  !
  ! Version 1 uses Extensions of same size (linear growth)
  fdesc2%lexn(0) = 0
  do iex=1,fdesc1%nex
    fdesc2%lexn(iex) = fdesc2%lexn(iex-1) + fdesc2%lex1
  enddo
  !
end subroutine filedesc_v1tov2
!
subroutine filedesc_read_v2(file,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>filedesc_read_v2
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Read the File Descriptor from the file, version 2
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file   !
  logical,              intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE'
  integer(kind=4), allocatable :: abuf(:)
  integer(kind=4) :: ier,iex,mex,code,reclen
  integer(kind=8) :: nent
  !
  error = .false.
  !
  ! Read the 2 first words in 1st record
  read(file%lun,rec=1,iostat=ier) code,reclen
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Read error record #1 (1)')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    return
  endif
  !
  ! code (no conversion)
  file%desc%code = code  ! File code bytes, in the File Data Type
  ! reclen
  call file%conv%read%i4(reclen,file%desc%reclen,1)
  !
  ! Check if the file is opened with correct record length
  inquire(unit=file%lun,recl=reclen,iostat=ier)
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'File access error')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    return
  endif
  if (reclen.ne.facunf*file%desc%reclen) then
    ! Reopen the file with correct record length
    call classic_file_fclose(file,error)
    if (error)  return
    call classic_file_fopen(file,'OLD',error)
    if (error)  return
  endif
  !
  allocate(abuf(file%desc%reclen),stat=ier)
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Error allocating buffer')
    error = .true.
    return
  endif
  !
  ! Now read all the first record
  read(file%lun,rec=1,iostat=ier) abuf
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Read error record #1 (2)')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    goto 99
  endif
  !
  call file%conv%read%i4(abuf(3), file%desc%kind,    1)
  call file%conv%read%i4(abuf(4), file%desc%vind,    1)
  call file%conv%read%i4(abuf(5), file%desc%lind,    1)
  call file%conv%read%i4(abuf(6), file%desc%flags,   1)
  call file%conv%read%i8(abuf(7), file%desc%xnext,   1)
  call file%conv%read%i8(abuf(9), file%desc%nextrec, 1)
  call file%conv%read%i4(abuf(11),file%desc%nextword,1)
  call file%conv%read%i4(abuf(12),file%desc%lex1,    1)
  call file%conv%read%i4(abuf(13),file%desc%nex,     1)
  call file%conv%read%i4(abuf(14),file%desc%gex,     1)
  ! Flags:
  file%desc%single = btest(file%desc%flags,0)  ! Test 1st bit
  !
  mex = (file%desc%reclen-filedescv2_nw1)/2
  call reallocate_aex(file%desc,mex,error)
  if (error)  goto 99
  !
  ! Read extension addresses
  call file%conv%read%i8(abuf(filedescv2_nw1+1),file%desc%aex(1),mex)
  !
  file%desc%lexn(0) = 0
  if (file%desc%gex.eq.10) then
    ! Linear growth
    do iex=1,file%desc%nex
      file%desc%lexn(iex) = file%desc%lexn(iex-1) + file%desc%lex1
    enddo
  else
    ! Exponential growth. Only growth with mantissa 2.0 is supported
    do iex=1,file%desc%nex
      nent = int(file%desc%lex1,kind=8) * 2_8**(iex-1)
      file%desc%lexn(iex) = file%desc%lexn(iex-1) + nent
    enddo
  endif
  !
99 continue
  deallocate(abuf)
  !
end subroutine filedesc_read_v2
!
subroutine classic_filedesc_write(file,error)
  use classic_interfaces, except_this=>classic_filedesc_write
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  ! Write the File Descriptor to the file.
  ! The file itself must have been opened before
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: file   !
  logical,              intent(inout) :: error  ! Logical error flag
  !
  if (file%desc%version.eq.1) then
    call filedesc_write_v1(file,error)
  else
    call filedesc_write_v2(file,error)
  endif
  !
end subroutine classic_filedesc_write
!
subroutine filedesc_write_v1(file,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>filedesc_write_v1
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Write the File Descriptor to the file, version 1.
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: file   !
  logical,              intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE'
  integer(kind=4) :: abuf(classic_reclen_v1)  ! Automatic array
  integer(kind=4) :: ier
  type(filedesc_v1_t) :: fdesc
  !
  call filedesc_v2tov1(file%desc,fdesc,error)
  if (error)  return
  !
  ! Record 1: fdesc%code, fdesc%next, fdesc%lex, fdesc%nex, fdesc%xnext, fdesc%aex(1:reclen-5)
  abuf(1) = fdesc%code
  call file%conv%writ%i4(fdesc%next,abuf(2),classic_reclen_v1-1)
  write(file%lun,rec=1,iostat=ier) abuf
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Write error record #1')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    return
  endif
  !
  ! Record 2: fdesc%aex(:)  (continued)
  call file%conv%writ%i4(fdesc%aex(classic_reclen_v1-4),abuf,classic_reclen_v1)
  write(file%lun,rec=2,iostat=ier) abuf
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Write error record #2')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    return
  endif
  !
end subroutine filedesc_write_v1
!
subroutine filedesc_v2tov1(fdesc2,fdesc1,error)
  use gbl_message
  use classic_interfaces, except_this=>filedesc_v2tov1
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(classic_filedesc_t), intent(in)    :: fdesc2  !
  type(filedesc_v1_t),      intent(out)   :: fdesc1  !
  logical,                  intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='V2TOV1'
  character(len=message_length) :: mess
  integer(kind=8) :: nperrec
  !
  if (fdesc2%version.ne.1) then
    call classic_message(seve%e,rname,  &
      'Internal error: attempt to write version 2 to a V1 file')
    error = .true.
    return
  endif
  !
  fdesc1%code = fdesc2%code
  call i8toi4_fini(fdesc2%nextrec,fdesc1%next,1,error)
  if (error)  return
  if (fdesc2%nextword.ne.1) then
    write(mess,'(A,I0,A)')  &
      'Internal error: next available word should be 1 for V1 file (got ',fdesc2%nextword,')'
    call classic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  nperrec = fdesc2%reclen/fdesc2%lind  ! Integer division
  fdesc1%lex  = fdesc2%lex1
  fdesc1%nex  = fdesc2%nex
  call i8toi4_fini(fdesc2%xnext,fdesc1%xnext,1,error)
  if (error)  return
  !
  if (fdesc2%nex.gt.mex_v1) then
    call classic_message(seve%e,rname,'Too many extensions')
    error = .true.
    return
  endif
  fdesc1%aex(1:fdesc2%nex) = fdesc2%aex(1:fdesc2%nex)
  fdesc1%aex(fdesc2%nex+1:mex_v1) = 0
  !
end subroutine filedesc_v2tov1
!
subroutine filedesc_write_v2(file,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>filedesc_write_v2
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Write the File Descriptor to the file, version 2.
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: file   !
  logical,              intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FILE'
  integer(kind=4) :: abuf(file%desc%reclen)  ! Automatic array. 'reclen' words = 1 record
  integer(kind=4) :: ier,mex
  !
  mex = (file%desc%reclen-filedescv2_nw1)/2
  !
  abuf(1) = file%desc%code  ! File code, no conversion
  !
  call file%conv%writ%i4(file%desc%reclen,  abuf(2), 1)
  call file%conv%writ%i4(file%desc%kind,    abuf(3), 1)
  call file%conv%writ%i4(file%desc%vind,    abuf(4), 1)
  call file%conv%writ%i4(file%desc%lind,    abuf(5), 1)
  call file%conv%writ%i4(file%desc%flags,   abuf(6), 1)
  call file%conv%writ%i8(file%desc%xnext,   abuf(7), 1)
  call file%conv%writ%i8(file%desc%nextrec, abuf(9), 1)
  call file%conv%writ%i4(file%desc%nextword,abuf(11),1)
  call file%conv%writ%i4(file%desc%lex1,    abuf(12),1)
  call file%conv%writ%i4(file%desc%nex,     abuf(13),1)
  call file%conv%writ%i4(file%desc%gex,     abuf(14),1)
  call file%conv%writ%i8(file%desc%aex(1),  abuf(filedescv2_nw1+1),mex)
  !
  write(file%lun,rec=1,iostat=ier) abuf
  if (ier.ne.0) then
    call classic_message(seve%e,rname,'Write error record #1')
    call classic_iostat(seve%e,rname,ier)
    error = .true.
    return
  endif
  !
end subroutine filedesc_write_v2
!
subroutine filedesc_update(buf,nword,fdesc,error)
  use classic_interfaces, except_this=>filedesc_update
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Update the file descriptor (nextrec, nextword) after a buffer has
  ! been written.
  !---------------------------------------------------------------------
  type(classic_recordbuf_t), intent(in)    :: buf    !
  integer(kind=data_length), intent(in)    :: nword  !
  type(classic_filedesc_t),  intent(inout) :: fdesc  !
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=8) :: newrec
  integer(kind=4) :: newword
  !
  ! Compute next rec and word after the buffer
  newrec  = buf%rstart+(buf%wstart-1+nword)/buf%len
  newword = mod(buf%wstart+nword-1,buf%len)+1
  !
  if (newrec.gt.fdesc%nextrec) then
    ! Buffer was used to write beyond the last used record
    fdesc%nextrec = newrec
    fdesc%nextword = newword
  elseif (newrec.eq.fdesc%nextrec) then
    ! Buffer was used to write in the last used record
    ! fdesc%nextrec = unchanged
    fdesc%nextword = max(fdesc%nextword,newword)
  else
    ! Buffer was used to write in records already used. No update needed.
  endif
  !
end subroutine filedesc_update
!
subroutine classic_filedesc_dump(fdesc,name)
  use gbl_message
  use classic_interfaces, except_this=>classic_filedesc_dump
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Dump the content of the File Descriptor
  !---------------------------------------------------------------------
  type(classic_filedesc_t), intent(in) :: fdesc  ! The File Descriptor
  character(len=*),         intent(in) :: name   ! The File Descriptor name (some prefix)
  ! Local
  character(len=*), parameter :: rname='DUMP'
  character(len=4) :: cfile
  character(len=12) :: ckind
  character(len=message_length) :: mess
  integer(kind=4) :: i,j
  !
  call bytoch(fdesc%code,cfile,4)
  select case (fdesc%kind)
  case (classic_kind_demo)
    ckind = 'DEMO'
  case (classic_kind_class)
    ckind = 'CLASS'
  case (classic_kind_clic)
    ckind = 'CLIC'
  case (classic_kind_mrtcal)
    ckind = 'MRTCAL'
  case default
    ckind = 'UNKNOWN'
  end select
  !
  write(mess,'(1X,(A,I0,A),2(A,I0,A,A,A))')  &
    name//'version = ',fdesc%version,', ',               &
    name//'code = ',   fdesc%code,' (''',cfile,'''), ',  &
    name//'kind = ',   fdesc%kind,' (',trim(ckind),')'
  call classic_message(seve%r,rname,mess)
  write(mess,'(1X,3(A,I0,A),(A,L,A),2(A,I0,A))')  &
    name//'reclen = ', fdesc%reclen, ', ',  &
    name//'vind = ',   fdesc%vind,   ', ',  &
    name//'lind = ',   fdesc%lind,   ', ',  &
    name//'single = ', fdesc%single, ', ',  &
    name//'xnext = ',  fdesc%xnext,  ', ',  &
    name//'nextrec = ',fdesc%nextrec
  call classic_message(seve%r,rname,mess)
  write(mess,'(1X,5(A,I0,A))')  &
    name//'nextword = ', fdesc%nextword, ', ',  &
    name//'lex1 = ',     fdesc%lex1,     ', ',  &
    name//'nex = ',      fdesc%nex,      ', ',  &
    name//'mex = ',      fdesc%mex,      ', ',  &
    name//'gex = ',      fdesc%gex
  call classic_message(seve%r,rname,mess)
  !
  write(mess,*) name//'aex(:) ='
  call classic_message(seve%r,rname,mess)
  do j=1,fdesc%nex/6
    write(mess,'(5X,6(I0,1X))') (fdesc%aex((j-1)*6+i),i=1,6)
    call classic_message(seve%r,rname,mess)
  enddo
  write(mess,'(5X,6(I0,1X))') (fdesc%aex(i),i=(fdesc%nex/6)*6+1,fdesc%nex)
  call classic_message(seve%r,rname,mess)
  !
  write(mess,*) name//'lexN(:) ='
  call classic_message(seve%r,rname,mess)
  do j=1,fdesc%nex/6
    write(mess,'(5X,6(I0,1X))') (fdesc%lexn((j-1)*6+i),i=1,6)
    call classic_message(seve%r,rname,mess)
  enddo
  write(mess,'(5X,6(I0,1X))') (fdesc%lexn(i),i=(fdesc%nex/6)*6+1,fdesc%nex)
  call classic_message(seve%r,rname,mess)
  !
end subroutine classic_filedesc_dump
!
subroutine reallocate_recordbuf(buf,len,error)
  use gbl_message
  use classic_types
  use classic_interfaces, except_this=>reallocate_recordbuf
  !---------------------------------------------------------------------
  ! @ public
  !  Allocate or reallocate the input working buffer
  !---------------------------------------------------------------------
  type(classic_recordbuf_t), intent(inout) :: buf    !
  integer(kind=4),           intent(in)    :: len    ! New length required
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RECORDBUF'
  logical :: alloc
  integer(kind=4) :: ier
  !
  if (len.le.0) then
    call classic_message(seve%e,rname,'Internal error: negative record size!')
    error = .true.
    return
  endif
  !
  alloc = .false.
  if (allocated(buf%data)) then
    if (size(buf%data).ne.len) then
      deallocate(buf%data)
      alloc = .true.
    endif
  else
    alloc = .true.
  endif
  !
  if (alloc) then
    allocate(buf%data(len),stat=ier)
    if (ier.ne.0) then
      call classic_iostat(seve%e,rname,ier)
      error = .true.
      return
    endif
  endif
  !
  call classic_recordbuf_nullify(buf)
  buf%len = len
  buf%data(:) = 0
  !
end subroutine reallocate_recordbuf
!
subroutine deallocate_recordbuf(buf,error)
  use classic_types
  use classic_interfaces, except_this=>deallocate_recordbuf
  !---------------------------------------------------------------------
  ! @ public
  !  Deallocate the input working buffer
  !---------------------------------------------------------------------
  type(classic_recordbuf_t), intent(inout) :: buf    !
  logical,                   intent(inout) :: error  ! Logical error flag
  !
  call classic_recordbuf_nullify(buf)
  buf%len = 0
  if (allocated(buf%data))  deallocate(buf%data)
  !
end subroutine deallocate_recordbuf
!
subroutine reallocate_aex(fdesc,len,error)
  use gbl_message
  use classic_types
  use classic_interfaces, except_this=>reallocate_aex
  !---------------------------------------------------------------------
  ! @ private
  !  (Re)allocate the fdesc%aex(:) and fdesc%lexn(:) arrays
  !---------------------------------------------------------------------
  type(classic_filedesc_t), intent(inout) :: fdesc  !
  integer(kind=4),          intent(in)    :: len    ! New length required
  logical,                  intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='EXTENSIONS'
  integer(kind=4) :: ier,olen
  !
  if (len.le.0) then
    call classic_message(seve%e,rname,'Internal error: negative record size!')
    error = .true.
    return
  endif
  !
  if (allocated(fdesc%aex)) then
    olen = size(fdesc%aex)
    ! Array is already allocated
    if (olen.gt.len) then
      ! Arrays is too large. Shrink and lose its data
      deallocate(fdesc%aex,fdesc%lexn)
      allocate(fdesc%aex(len),fdesc%lexn(0:len),stat=ier)
      if (ier.ne.0)  goto 10
      fdesc%aex(:) = 0
      fdesc%lexn(:) = 0  ! lexn(0) = 0 is required
      !
    elseif (olen.eq.len) then
      ! Array has correct size, leave unchanged
      continue
      ! fdesc%aex(:) = 0
      ! fdesc%lexn(:) = 0
      !
    else
      ! Array is too small but we don't care about data
      deallocate(fdesc%aex,fdesc%lexn)
      allocate(fdesc%aex(len),fdesc%lexn(0:len),stat=ier)
      if (ier.ne.0)  goto 10
      fdesc%aex(:) = 0
      fdesc%lexn(:) = 0  ! lexn(0) = 0 is required
      !
    endif
  else
    ! No previous allocation
    allocate(fdesc%aex(len),fdesc%lexn(0:len),stat=ier)
    if (ier.ne.0)  goto 10
    fdesc%aex(:) = 0
    fdesc%lexn(:) = 0  ! lexn(0) = 0 is required
  endif
  !
  fdesc%mex = len
  !
  return
  !
  ! Error
10 continue
  error = .true.
  call classic_iostat(seve%e,rname,ier)
  !
end subroutine reallocate_aex
!
subroutine deallocate_aex(fdesc,error)
  use gbl_message
  use classic_types
  use classic_interfaces, except_this=>deallocate_aex
  !---------------------------------------------------------------------
  ! @ private
  !  Deallocate (if needed) the fdesc%aex(:) and fdesc%lexn(:) arrays
  !---------------------------------------------------------------------
  type(classic_filedesc_t), intent(inout) :: fdesc  !
  logical,                  intent(inout) :: error  !
  !
  if (allocated(fdesc%aex))   deallocate(fdesc%aex)
  if (allocated(fdesc%lexn))  deallocate(fdesc%lexn)
  !
end subroutine deallocate_aex
!
subroutine classic_file_loss(file,unused,error)
  use classic_interfaces, except_this=>classic_file_loss
  use classic_types
  use classic_vars
  !---------------------------------------------------------------------
  ! @ public
  ! Parse the input file and search for unused (lost) bytes
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file    !
  integer(kind=4),      intent(in)    :: unused  ! Number of unused bytes per Index
  logical,              intent(inout) :: error   !
  !
  if (file%desc%version.eq.1) then
    call classic_file_loss_v1(file,unused,error)
  else
    call classic_file_loss_v2(file,unused,error)
  endif
  !
end subroutine classic_file_loss
!
subroutine classic_file_loss_v1(file,unused,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use classic_interfaces, except_this=>classic_file_loss_v1
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Parse the input file and search for unused (lost) bytes
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file    !
  integer(kind=4),      intent(in)    :: unused  ! Number of unused bytes per Index
  logical,              intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='FILELOSS'
  character(len=message_length) :: mess
  integer(kind=entry_length) :: ient,nent
  integer(kind=8) :: nf1,ni1,ne1,no1,nt1, nf2,ni2,ne2,no2,nt2, edend,nrec
  type(classic_entrydesc_t) :: ed
  type(classic_recordbuf_t) :: bufobs,bufind
  type(indx_basic_v2_t) :: ind
  type(time_t) :: time
  integer(kind=4) :: databi(file%desc%lind)  ! Automatic array
  !
  ! 1) Losses in file descriptor
  call filedesc_read_v1(file,error)
  if (error)  return
  nf1 = 4*(file%desc%mex-file%desc%nex)
  nf2 = 4*2*file%desc%reclen
  !
  ! 2) Losses in File Index
  call classic_file_loss_index(file%desc,unused,ni1,ni2)
  !
  ! 3) Losses in entries
  call reallocate_recordbuf(bufobs,file%desc%reclen,error)
  if (error)  return
  call reallocate_recordbuf(bufind,file%desc%reclen,error)
  if (error)  return
  !
  call classic_recordbuf_nullify(bufind)
  call classic_recordbuf_nullify(bufobs)
  ne1 = 0
  ne2 = 0
  no1 = 0
  no2 = 0
  nent = file%desc%xnext-1
  !
  call gtime_init(time,nent,error)
  if (error)  return
  !
  do ient=1,nent
    if (sic_ctrlc()) then  ! NB: initialization must have been done once with trap_ctrlc
      call classic_message(seve%w,rname,'CTRL-C trapped, incomplete entries analysis')
      exit
    endif
    !
    call gtime_current(time)
    !
    ! Where is the Entry (address = record and starting word)? It is found in the
    ! Index (1st and 2nd word). Use our generic reading subroutine which can read
    ! this element (only). Use buffer 'bufind' to read the Index.
    call classic_entryindex_read(file,ient,databi,bufind,error)
    if (error)  goto 100
    !
    call indexaddr_frombuf_v1(databi,ind,file%conv,error)
    if (error)  goto 100
    !
    ! Initialize the obs reading buffer
    call classic_recordbuf_open(file,ind%rec,ind%word,bufobs,error)
    if (error)  goto 100
    !
    ! Now read the Entry Header.
    call entrydesc_read_v1(file,bufobs,ed,error)
    if (error)  goto 100
    !
    ! Words lost in Entry Descriptor (because of space allocated for 'msec'
    ! sections). Should make this test more robust: what if data comes before
    ! 1st section?
    if (ed%nsec.le.0) then
      ! No section present. Ok, why not.
      edend = ed%nword
    else
      edend = ed%secaddr(1)-1        ! End of Entry Descriptor
    endif
    ne1 = ne1 + edend-(entrydescv1_nw1-2+entrydescv1_nw2*ed%nsec)  ! 2 words unused in entrydescv1_nw1
    ne2 = ne2 + edend
    ! Unused words lost at end of last record
    nrec = (ed%nword-1)/classic_reclen_v1+1
    no1 = no1 + nrec*file%desc%reclen-ed%nword
    no2 = no2 + nrec*file%desc%reclen-edend
  enddo
  ne1 = 4*ne1  ! Bytes
  ne2 = 4*ne2
  no1 = 4*no1
  no2 = 4*no2
  !
  ! Total
  nt1 = nf1+ni1+ne1+no1
  nt2 = classic_file_size(file)
  !
  ! Messages
  call classic_message(seve%r,rname,'Unused bytes in:')
  write(mess,200)  '  File Descriptor: ',  nf1,nf2,1e2*nf1/nf2
  call classic_message(seve%r,rname,mess)
  write(mess,200)  '  File Index: ',       ni1,ni2,1e2*ni1/ni2
  call classic_message(seve%r,rname,mess)
  write(mess,200)  '  Entry Descriptors: ',ne1,ne2,1e2*ne1/ne2
  call classic_message(seve%r,rname,mess)
  write(mess,200)  '  Entries: ',          no1,no2,1e2*no1/no2
  call classic_message(seve%r,rname,mess)
  write(mess,200)  '  Total: ',            nt1,nt2,1d2*nt1/nt2
  call classic_message(seve%r,rname,mess)
  !
100 continue
  call deallocate_recordbuf(bufobs,error)
  call deallocate_recordbuf(bufind,error)
  if (error) then
    write(mess,'(A,I0)')  'Error reading entry #',ient
    call classic_message(seve%e,rname,mess)
  endif
  !
200 format(A,T25,I12,' / ',I12,T54,'(',F0.1,'%)')
end subroutine classic_file_loss_v1
!
subroutine classic_file_loss_v2(file,unused,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use classic_interfaces, except_this=>classic_file_loss_v2
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Parse the input file and search for unused (lost) bytes
  !---------------------------------------------------------------------
  type(classic_file_t), intent(inout) :: file    !
  integer(kind=4),      intent(in)    :: unused  ! Number of unused bytes per Index
  logical,              intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='FILELOSS'
  character(len=message_length) :: mess
  integer(kind=entry_length) :: ient,nent
  integer(kind=8) :: nf1,ni1,ne1,no1,nt1, nf2,ni2,ne2,no2,nt2, edend
  type(classic_entrydesc_t) :: ed
  type(classic_recordbuf_t) :: bufobs,bufind
  type(indx_basic_v2_t) :: ind
  type(time_t) :: time
  integer(kind=4) :: databi(file%desc%lind)  ! Automatic array
  !
  ! 1) Losses in file descriptor
  call filedesc_read_v2(file,error)
  if (error)  return
  nf1 = 8*(file%desc%mex-file%desc%nex)
  nf2 = 4*file%desc%reclen
  !
  ! 2) Losses in File Index
  call classic_file_loss_index(file%desc,unused,ni1,ni2)
  !
  ! 3) Losses in entries
  call reallocate_recordbuf(bufobs,file%desc%reclen,error)
  if (error)  return
  call reallocate_recordbuf(bufind,file%desc%reclen,error)
  if (error)  return
  !
  call classic_recordbuf_nullify(bufind)
  call classic_recordbuf_nullify(bufobs)
  ne1 = 0
  ne2 = 0
  no1 = 0
  no2 = 0
  nent = file%desc%xnext-1
  !
  call gtime_init(time,nent,error)
  if (error)  return
  !
  do ient=1,nent
    if (sic_ctrlc()) then  ! NB: initialization must have been done once with trap_ctrlc
      call classic_message(seve%w,rname,'CTRL-C trapped, incomplete entries analysis')
      exit
    endif
    !
    call gtime_current(time)
    !
    ! Where is the Entry (address = record and starting word)? It is found in the
    ! Index (1st and 2nd word). Use our generic reading subroutine which can read
    ! this element (only). Use buffer 'bufind' to read the Index.
    call classic_entryindex_read(file,ient,databi,bufind,error)
    if (error)  goto 100
    !
    call indexaddr_frombuf_v2(databi,ind,file%conv,error)
    if (error)  goto 100
    !
    ! Initialize the obs reading buffer
    call classic_recordbuf_open(file,ind%rec,ind%word,bufobs,error)
    if (error)  goto 100
    !
    ! Now read the Entry Header.
    call entrydesc_read_v2(file,bufobs,ed,error)
    if (error)  goto 100
    !
    ! Words lost in Entry Descriptor (because of space allocated for 'msec'
    ! sections). Should make this test more robust: what if data comes before
    ! 1st section?
    if (ed%nsec.le.0) then
      ! No section present. Ok, why not.
      edend = ed%nword
    else
      edend = ed%secaddr(1)-1        ! End of Entry Descriptor
    endif
    ne1 = ne1 + edend-(entrydescv2_nw1+entrydescv2_nw2*ed%nsec)
    ne2 = ne2 + edend
    ! Unused words lost at end of last record: none (in theory, but can we make
    ! sure of that)?
    ! no1 = no1 + 0
    no2 = no2 + ed%nword-edend
  enddo
  ne1 = 4*ne1  ! Bytes
  ne2 = 4*ne2
  no1 = 4*no1
  no2 = 4*no2
  !
  ! Total
  nt1 = nf1+ni1+ne1+no1
  nt2 = classic_file_size(file)
  !
  ! Messages
  call classic_message(seve%r,rname,'Unused bytes in:')
  write(mess,200)  '  File Descriptor: ',  nf1,nf2,1e2*nf1/nf2
  call classic_message(seve%r,rname,mess)
  write(mess,200)  '  File Index: ',       ni1,ni2,1e2*ni1/ni2
  call classic_message(seve%r,rname,mess)
  write(mess,200)  '  Entry Descriptors: ',ne1,ne2,1e2*ne1/ne2
  call classic_message(seve%r,rname,mess)
  write(mess,200)  '  Entries: ',          no1,no2,1e2*no1/no2
  call classic_message(seve%r,rname,mess)
  write(mess,200)  '  Total: ',            nt1,nt2,1d2*nt1/nt2
  call classic_message(seve%r,rname,mess)
  !
100 continue
  call deallocate_recordbuf(bufobs,error)
  call deallocate_recordbuf(bufind,error)
  if (error) then
    write(mess,'(A,I0)')  'Error reading entry #',ient
    call classic_message(seve%e,rname,mess)
  endif
  !
200 format(A,T24,I13,' / ',I13,T54,'(',F0.1,'%)')
end subroutine classic_file_loss_v2
!
subroutine classic_file_loss_index(fdesc,unused,nlost,ntot)
  use gbl_message
  use classic_params
  use classic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the bytes lost in the File Index. This is a function of
  ! the Index growth, not of the File Version.
  !---------------------------------------------------------------------
  type(classic_filedesc_t), intent(in)    :: fdesc   ! The File Descriptor
  integer(kind=4),          intent(in)    :: unused  ! Number of unused bytes per Index
  integer(kind=8),          intent(out)   :: nlost   ! Number of bytes lost
  integer(kind=8),          intent(out)   :: ntot    ! Total number of bytes
  ! Local
  integer(kind=entry_length) :: maxent,nrec
  integer(kind=4) :: nentperrec
  !
  maxent = fdesc%lexn(fdesc%nex)  ! Total number of entries in the Index
  nentperrec = fdesc%reclen/fdesc%lind  ! Number of Entry Index per record (int division)
  nrec = maxent/nentperrec  ! Number of records devoted to the Index
  !
  ! Unused words in Entry Index:
  nlost = (fdesc%xnext-1)*unused
  ! + Unused Indexes in last extension
  nlost = nlost + (maxent-fdesc%xnext+1)*fdesc%lind
  ! + Unused bytes at end of records in the File Index
  nlost = nlost + (fdesc%reclen-nentperrec*fdesc%lind)*nrec
  !
  ntot = fdesc%reclen*nrec
  !
  nlost = 4*nlost  ! Convert words to bytes
  ntot  = 4*ntot
  !
end subroutine classic_file_loss_index
!
subroutine classic_file_copy(in,ou,error)
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Copy the input classic_file_t into the output one, taking care
  ! of some special elements like pointers and allocatables.
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: in     !
  type(classic_file_t), intent(inout) :: ou     !
  logical,              intent(inout) :: error  ! Logical error flag
  !
  ! First level elements
  ou%spec       = in%spec
  ou%nspec      = in%nspec
  ou%lun        = in%lun
  ou%readwrite  = in%readwrite
  ou%update     = in%update
  !
  ! File descriptor
  ou%desc%code     = in%desc%code
  ou%desc%reclen   = in%desc%reclen
  ou%desc%kind     = in%desc%kind
  ou%desc%vind     = in%desc%vind
  ou%desc%lind     = in%desc%lind
  ou%desc%flags    = in%desc%flags
  ou%desc%xnext    = in%desc%xnext
  ou%desc%nextrec  = in%desc%nextrec
  ou%desc%nextword = in%desc%nextword
  ou%desc%lex1     = in%desc%lex1
  ou%desc%nex      = in%desc%nex
  ou%desc%gex      = in%desc%gex
  ou%desc%version  = in%desc%version
  ou%desc%single   = in%desc%single
  ou%desc%mex      = in%desc%mex
  if (allocated(in%desc%aex)) then
    call reallocate_aex(ou%desc,in%desc%mex,error)
    if (error)  return
    ou%desc%aex(1:in%desc%mex)  = in%desc%aex(1:in%desc%mex)
    ou%desc%lexn(0:in%desc%mex) = in%desc%lexn(0:in%desc%mex)
  endif
  !
  ! File conversion
  ou%conv%code = in%conv%code
  ! NB: a simple ou%conv = in%conv is probably enough
  ou%conv%read%i4 => in%conv%read%i4
  ou%conv%read%i8 => in%conv%read%i8
  ou%conv%read%r4 => in%conv%read%r4
  ou%conv%read%r8 => in%conv%read%r8
  ou%conv%read%cc => in%conv%read%cc
  ou%conv%writ%i4 => in%conv%writ%i4
  ou%conv%writ%i8 => in%conv%writ%i8
  ou%conv%writ%r4 => in%conv%writ%r4
  ou%conv%writ%r8 => in%conv%writ%r8
  ou%conv%writ%cc => in%conv%writ%cc
  !
end subroutine classic_file_copy
!
function classic_file_size(file)
  use gildas_def
  use classic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Return the file size (according to its descriptor) in bytes
  !---------------------------------------------------------------------
  integer(kind=size_length) :: classic_file_size
  type(classic_file_t), intent(in) :: file
  !
  if (file%desc%nextword.eq.1) then
    classic_file_size = 4*(file%desc%nextrec-1)*file%desc%reclen
  else
    classic_file_size = 4*file%desc%nextrec*file%desc%reclen
  endif
  !
end function classic_file_size

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_identifier
  use cubetools_parameters
  use cubetools_flag_types
  use cubetools_structure
  use cubeadm_messaging
  !
  public :: identifier_opt_t, identifier_user_t, identifier_prog_t
  public :: changeflags
  private
  !
  logical, parameter :: changeflags = .true.
  !
  type identifier_opt_t
     logical                 :: doflags
     type(option_t), pointer :: opt
   contains
     procedure, public :: register => cubeadm_identifier_register
     procedure, public :: parse    => cubeadm_identifier_parse
  end type identifier_opt_t
  !
  type identifier_user_t
     logical               :: doflags
     logical               :: do
     character(len=base_l) :: identifier
   contains
     procedure, public :: toprog => cubeadm_identifier_user_toprog
  end type identifier_user_t
  !
  type identifier_prog_t
     logical                   :: doflags
     character(len=base_l)     :: family
     type(flag_t), allocatable :: flags(:)
   contains
     procedure, public :: apply => cubeadm_identifier_prog_apply
  end type identifier_prog_t
  !
contains
  !
  subroutine cubeadm_identifier_register(option,abstract,doflags,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(identifier_opt_t), intent(inout) :: option
    character(len=*),        intent(in)    :: abstract
    logical,                 intent(in)    :: doflags
    logical,                 intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='IDENTIFIER>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    option%doflags = doflags
    if (option%doflags) then
       call cubetools_register_option(&
            'AS','family[:flag1,...,flagn]',&
            abstract,&
            'Set the family name and optionally the flags of the output&
            & cube. To consult the list of all available flags consult&
            & ADM\FLAGLIST',&
            option%opt,error)
       if (error) return
    else
       call cubetools_register_option(&
            'FAMILY','name',&
            abstract,&
            strg_emp,&
            option%opt,error)
       if (error) return
    endif
    call stdarg%register(&
         'identifier', &
         'New identifier', &
         strg_emp,&
         code_arg_mandatory, error)
    if (error) return
  end subroutine cubeadm_identifier_register
  !
  subroutine cubeadm_identifier_parse(option,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(identifier_opt_t), intent(in)    :: option
    character(len=*),        intent(in)    :: line
    type(identifier_user_t), intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='IDENTIFIER>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    user%doflags = option%doflags
    call option%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,option%opt,1,user%identifier,mandatory,error)
       if (error) return
    endif
  end subroutine cubeadm_identifier_parse
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeadm_identifier_user_toprog(user,cube,prog,error)
    use cubetuple_format_class
    use cubetools_cubeid_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(identifier_user_t), intent(in)    :: user
    class(format_t),          intent(in)    :: cube
    type(identifier_prog_t),  intent(out)   :: prog
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='IDENTIFIER>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    prog%doflags = user%doflags
    if (user%do) then
       call cubetools_cubeid_string2familyflags(user%identifier,prog%family,prog%flags,error)
       if (error) return
       if (allocated(prog%flags).and..not.user%doflags) &
            call cubeadm_message(seve%w,rname,'Changing flags not allowed in this context, flags ignored')
    else
       prog%family = cube%node%family
    endif
  end subroutine cubeadm_identifier_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeadm_identifier_prog_apply(prog,cube,error)
    use cubetuple_format_class
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(identifier_prog_t), intent(in)    :: prog
    class(format_t),          intent(inout) :: cube
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='IDENTIFIER>PROG>APPLY'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cube%set_value('FAMILY',prog%family,error)
    if (error) return
    if (allocated(prog%flags).and.prog%doflags) then
       call cube%set_flags(prog%flags,error)
       if (error) return
    else
       ! Do nothing
    endif
  end subroutine cubeadm_identifier_prog_apply
end module cubeadm_identifier
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine vstrin(nchar,string,drawit,slengt,xp,yp,angle,ifont,size,  &
  doclip,gpoly_noclip,gpoly_clip)
  use gildas_def
  use phys_const
  use gchar_interfaces, except_this=>vstrin
  use gchar_variables
  !---------------------------------------------------------------------
  ! @ public
  !
  !	Interprets a string of character with escape sequences
  !	\P or \\P  and plots out the characters according to
  !	current font quality SIMPLEX or DUPLEX
  !
  !	If the shareable common is not initialised, VSTRING attempts
  !	to initialise it using VSINIT. Just do not forget to assign
  !	properly the CHAR_FONT logical name to your GREGFONT.BIN file
  !	when you run a non-shareable image.
  !
  !	The reference point is located at the left of the string, and
  !	at middle in height. To append a second string, just move the
  !	reference point as following before calling again VSTRING :
  !		...
  !		CO = COS(ANGLE*PI/180.)
  !		SI = SIN(ANGLE*PI/180.)
  !		CALL VSTRING (..., SLENGT, XP, YP, ANGLE, ...)
  !		XP = XP + CO*SLENGT
  !		YP = YP + SI*SLENGT
  !		CALL VSTRING (..., SLENGT, XP, YP, ANGLE, ...)
  !
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: nchar         ! String length
  character(len=*), intent(in)  :: string        ! String to be drawn
  logical,          intent(in)  :: drawit        ! Draw string or compute length ?
  real(kind=4),     intent(out) :: slengt        ! Length of string in centimeters
  real(kind=4),     intent(in)  :: xp            ! Abscissa of reference point
  real(kind=4),     intent(in)  :: yp            ! Ordinate of reference point
  real(kind=4),     intent(in)  :: angle         ! Angle (Degrees)
  integer(kind=4),  intent(in)  :: ifont         ! Quality 0=Simplex 1=Duplex
  real(kind=4),     intent(in)  :: size          ! Character size
  logical,          intent(in)  :: doclip        ! Clip with current Greg box?
  external                      :: gpoly_noclip  !
  external                      :: gpoly_clip    !
  ! Interfaces
  interface
    subroutine gpoly_noclip(n,vx,vy,error)
      integer, intent(in)    :: n      ! Number of points
      real*4,  intent(in)    :: vx(n)  ! Array of abscissae
      real*4,  intent(in)    :: vy(n)  ! Array of ordinates
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine gpoly_noclip
    subroutine gpoly_clip(nq,xq,yq)
      use gildas_def
      integer(kind=size_length), intent(in) :: nq     ! Number of points
      real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
      real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
    end subroutine gpoly_clip
  end interface
  ! Local
  integer(kind=4), parameter :: backsl=92
  logical :: relo, done
  real(kind=4) :: slant, supfra
  integer(kind=4) :: jchar,i,j,k, ix, iy, ix0
  integer(kind=4) :: isuper,ioffse,italic,ibase,icom
  integer(kind=4) :: jsuper,joffse,jtalic,jbase
  logical :: error
  !
  integer(kind=4) :: npoints
  integer(kind=size_length) :: nsl
  integer(kind=4), parameter :: mpoints=50
  real(kind=4) :: xpoints(mpoints),ypoints(mpoints)
  !
  real(kind=4) :: sufact ,sushif
  real(kind=4) :: tufact,tushif
  real(kind=4) :: x,y,xc,yc,x0,y0,co,si,xa,const
  integer(kind=1) :: abyte
  ! Data
  data slant /0.2/, supfra /0.7/, done /.false./
  save done
  !
  ! Check if the common has been initialised
  if (.not.done) then
    call vsinit (vstrsh1,nkpage)
    done = .true.
  endif
  !
  error = .false.
  !
  ! Set up constants
  !
  co = cos(angle*pi/180.)
  si = sin(angle*pi/180.)
  x0 = xp
  y0 = yp
  slengt = 0
  icom = 0
  ibase  = 300*ifont
  jbase  = 300*ifont
  italic = 0
  jtalic = 0
  ioffse = 0
  joffse = 0
  isuper = 0
  jsuper = 0
  sufact = 1.
  sushif = 0.
  tufact = 1.
  tushif = 0.
  !
  ! Pixel to centimeters conversion
  const = size/35.
  !-----------------------------------------------------------------------
  !
  ! 	\\X - set mode X
  ! 	\X  - set mode X for next chararacter only
  !	\1  - set font Simplex
  !	\2  - set font Duplex
  !	\N  - return to default character set
  ! 	\R  - roman font
  ! 	\G  - greek font
  ! 	\S  - script font
  ! 	\I  - toggle italics
  ! 	\U  - superscript
  ! 	\D  - subscript
  ! 	\B  - backspace
  !-----------------------------------------------------------------------
  !
  do j=1,nchar
    !
    abyte = ichar(string(j:j))
    if (abyte.eq.backsl) then
      icom = icom + 1
      cycle                    ! J
    elseif (abyte.lt.32) then
      abyte = ichar(' ')
    endif
    !
    ! Decode control sequence
    if (icom.gt.0) then
      if (abyte.eq.ichar('N').or.abyte.eq.ichar('n')) then
        ibase  = 300*ifont
      elseif (abyte.eq.ichar('1')) then
        ibase  = 0
      elseif (abyte.eq.ichar('2')) then
        ibase  = 300
      elseif (abyte.eq.ichar('R').or.abyte.eq.ichar('r')) then
        ioffse = 0
      elseif (abyte.eq.ichar('G').or.abyte.eq.ichar('g')) then
        ioffse = 100
      elseif (abyte.eq.ichar('S').or.abyte.eq.ichar('s')) then
        ioffse = 200
      elseif (abyte.eq.ichar('I').or.abyte.eq.ichar('i')) then
        italic = 1 - italic
      elseif (abyte.eq.ichar('U').or.abyte.eq.ichar('u')) then
        isuper = isuper + 1
        sushif = sushif + 16.*sufact
        sufact = supfra**iabs(isuper)
      elseif (abyte.eq.ichar('D').or.abyte.eq.ichar('d')) then
        isuper = isuper - 1
        sufact = supfra**iabs(isuper)
        sushif = sushif - 16.*sufact
      elseif (abyte.eq.ichar('B').or.abyte.eq.ichar('b')) then
        slengt = slengt - xa
        x0 = x0 - co*xa
        y0 = y0 - si*xa
      endif
      !
      if (icom.gt.1) then
        jbase = ibase
        jtalic = italic
        joffse = ioffse
        jsuper = isuper
        tufact = sufact
        tushif = sushif
      endif
      icom = 0
      cycle                    ! J
    endif
    !
    ! Address the correct character into the font
    jchar = abyte - 31 + ioffse + ibase
    !
    ! Check if Draw or evaluate length only
    if (drawit) then
      !
      ! Now draw the character
      relo = .true.
      npoints = 0
      i  = pointe(jchar)
      ix0 = ladj(jchar)
      do k = 0,nstrok(jchar)-1
        ix = font(i)
        iy = font(i+1)
        if (ix.eq.-64) then
          relo = .true.
        else
          x = ix - ix0
          if (italic.eq.1) x = x + slant*(iy+9)
          !
          ! Convert to centimeter size
          x = const * sufact * x
          y = const * (iy * sufact + sushif)
          xc = co*x - si*y + x0
          yc = si*x + co*y + y0
          if (relo) then
            relo = .false.
            if (doclip) then
              nsl = npoints
              call gpoly_clip(nsl,xpoints,ypoints)
            else
              call gpoly_noclip(npoints,xpoints,ypoints,error)
              if (error)  return
            endif
            npoints = 0
          endif
          npoints = npoints+1
          xpoints(npoints) = xc
          ypoints(npoints) = yc
        endif
        i = i+2
      enddo
      !
      ! Flush last polyline of current character
      if (doclip) then
        nsl = npoints
        call gpoly_clip(nsl,xpoints,ypoints)
      else
        call gpoly_noclip(npoints,xpoints,ypoints,error)
        if (error)  return
      endif
      !
    endif  ! Drawing or not the character
    !
    ! Compute spaced used by the character
    xa = const * (radj(jchar)-ladj(jchar)) * sufact
    slengt = slengt + xa
    x0 = x0 + co*xa
    y0 = y0 + si*xa
    italic = jtalic
    ioffse = joffse
    ibase  = jbase
    isuper = jsuper
    sufact = tufact
    sushif = tushif
    !
  enddo  ! J (next character)
  !
end subroutine vstrin
!
subroutine vsconv(ficode,sycode)
  use gchar_interfaces, except_this=>vsconv
  use gchar_variables
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*) :: ficode        !
  character(len=*) :: sycode        !
  !
  if (ficode.eq.'IEEE' .or. ficode.eq.'VAX_') then
    ! VAX_ and swapped IEEE I2 and I4 are identical
    if (sycode.eq.'EEEI') then
      call iei2ei (nstrok,nstrok,nkchar)   !     & NSTROK, ! INTEGER*2
      call iei2ei (ladj,ladj,nkchar)   !     & LADJ,   ! INTEGER*2
      call iei2ei (radj,radj,nkchar)   !     & RADJ,   ! INTEGER*2
      call iei4ei (pointe,pointe,nkchar)   !     & POINTE, ! INTEGER*4
    endif
  else
    ! FICODE = 'EEEI',  SYCODE = 'IEEE' or 'VAX_'
    call eii2ie (nstrok,nstrok,nkchar) !     & NSTROK, ! INTEGER*2
    call eii2ie (ladj,ladj,nkchar) !     & LADJ,   ! INTEGER*2
    call eii2ie (radj,radj,nkchar) !     & RADJ,   ! INTEGER*2
    call eii4ie (pointe,pointe,nkchar) !     & POINTE, ! INTEGER*4
  endif
  ! FONT is a Byte array, and does not require conversion
end subroutine vsconv

subroutine gfits_getreal(fd,ndat,array,scal,zero,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces, except_this=>gfits_getreal
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Read NDAT data values from FITS data area, with scaling SCALE and
  ! offset ZERO
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),       intent(in)    :: fd           !
  integer(kind=size_length), intent(in)    :: ndat         ! Number of desired data values
  real(kind=4),              intent(inout) :: array(ndat)  ! Data values
  real(kind=4),              intent(in)    :: scal         ! Scale factor
  real(kind=4),              intent(in)    :: zero         ! Offset
  logical,                   intent(inout) :: error        ! Error flag
  ! Local
  integer(kind=size_length) :: nsize,nfill,nbyt
  integer(kind=4) :: ier
  integer(kind=size_length), save :: mbyt=0
  integer(kind=1), allocatable, save :: mybuf(:)
  character(len=60) :: mess
  !
  select case (fd%nbit)
  case (8)
    nbyt = ndat
  case (16)
    nbyt = 2_8*ndat
  case (32,-32)
    nbyt = 4_8*ndat
  case (-64)
    nbyt = 8_8*ndat
  case default
    write(mess,*) 'BITPIX = ',fd%nbit,' not yet supported'
    call gfits_message(seve%e,'GETREAL',mess)
    error = .true.
    return
  end select
  !
  if (nbyt.gt.mbyt) then
    if (mbyt.ne.0) deallocate(mybuf)
    allocate (mybuf(nbyt),stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Allocation error ',ier,mbyt
      call gfits_message(seve%e,'GETREAL',mess)
      error = .true.
      return 
    endif
    mbyt = nbyt
  endif
  !
  call gfits_getbuf(mybuf,nbyt,error)
  if (error) return
  !
  nfill = 0
  nsize = ndat
  !
  select case (fd%nbit)
    case (8)
      call byte_to_real(mybuf,ndat,array,nsize,nfill,scal,zero)
    case (16)
      call int2_to_real(mybuf,ndat,array,nsize,nfill,scal,zero)
    case (32)
      call int4_to_real(mybuf,ndat,array,nsize,nfill,scal,zero)
    case (-32)
      call ieee32_to_real(mybuf,ndat,array,nsize,nfill,scal,zero,fd%bval0)
    case (-64)
      call ieee64_to_real(mybuf,ndat,array,nsize,nfill,scal,zero,fd%bval0)
  end select
end subroutine gfits_getreal
!
subroutine gfits_putbuf(int1,nr,error)
  use gfits_interfaces, except_this=>gfits_putbuf
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! Write one row of a binary table to a FITS logical record
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: nr        ! Length of buffer
  integer(kind=1), intent(in)    :: int1(nr)  ! Buffer
  logical,         intent(inout) :: error     ! Error flag
  ! Local
  integer(kind=4) :: j, kb
  !
  if ((nr+ib).lt.2880) then
    ! fits into current buffer
    call bytoby(int1,buffer(ib+1),nr)
    ib = ib+nr
  else
    ! Would overflow buffer: will have to write to disk or tape
    ! Fill in previous buffer, and dump it to physical medium
    if (ib.ne.0) then
      call bytoby(int1,buffer(ib+1),2880-ib)
      call gfits_putrec(buffer,error)
      kb = 2880-ib
    else
      call gfits_putrec(int1,error)
      kb = 2880
    endif
    if (error) return
    kb = kb+1
    ! Now dump full buffers (double buffering is useless here)
    do j = 2880-ib+1, nr-2880+1, 2880
      call gfits_putrec(int1(kb),error)
      if (error) return
      kb = kb + 2880
    enddo
    ! Store leftover bits
    ib = nr-kb+1
    if (ib.gt.0) call bytoby(int1(kb),buffer(1),ib)
  endif
end subroutine gfits_putbuf
!
subroutine gfits_getbuf(int1,nr,error)
  use gildas_def
  use gfits_interfaces, except_this=>gfits_getbuf
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public-mandatory
  ! Get one row of a binary table from a FITS logical record
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nr        ! Length of buffer
  integer(kind=1),           intent(inout) :: int1(nr)  ! Buffer
  logical,                   intent(inout) :: error     ! Error flag
  ! Local
  integer(kind=size_length) :: j,kb
  !
  if (nr+ib.le.2880) then
    ! Already in prefetch buffer
    call bytoby_sl(buffer(ib+1),int1,nr)
    ib = ib+nr
  else
    ! Will need to read from disk
    ! Empty previous buffer
    if (ib.lt.2880) then 
      call bytoby(buffer(ib+1),int1,2880-ib)
      kb = 2880-ib+1
    else
      kb = 1
    endif
    ! Now read full buffers from physical medium
    do j = 2880-ib+1, nr-2880, 2880
      call gfits_getrec(int1(kb:kb+2880-1),error)
      if (error) return
      kb = kb+2880
    enddo
    ! Read one more buffer, and move part of it.
    call gfits_getrec(buffer,error)
    if (error) return
    ib = nr-kb+1
    if (ib.gt.0) call bytoby(buffer(1),int1(kb),ib)
  endif
end subroutine gfits_getbuf
!
subroutine gfits_skibuf(nb,error)
  use gildas_def
  use gfits_interfaces, except_this=>gfits_skibuf
  use gfits_buf
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Skip NB bytes on input file
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nb     ! Bytes to skip
  logical,                   intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=record_length) :: nrec
  character(len=message_length) :: mess
  !
  if (nb+ib.le.2880) then
    ! Remains within current buffer
    ib = ib+nb
  else 
    ! Need to skip records on input medium
    nrec = ((nb+ib)/2880)-1
    ! Make sure we can read the last record here
    if (nrec*2880.ge.nb) nrec = nrec-1 ! In case IB = 2880 at start
    call gfits_skirec(nrec,error)
    if (error) return
    ! Read last record, and set pointer
    call gfits_getrec(buffer,error)
    if (error) return
    ib = nb+ib-(nrec+1)*2880
    if (ib.lt.1.or.ib.gt.2880) then
      write(mess,*) 'Internal logic error. ',ib,nrec
      call gfits_message(seve%e,'FSKIBUF',mess)
    endif
  endif
end subroutine gfits_skibuf
!
subroutine gfits_skidat(fd,ndat,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces, except_this=>gfits_skidat
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  !  Skip NDAT data values from FITS data area,
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),       intent(in)    :: fd     !
  integer(kind=size_length), intent(in)    :: ndat   ! Number of desired data values
  logical,                   intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=size_length) :: nbyt
  character(len=60) :: mess
  !
  select case (fd%nbit)
    case (8)
      nbyt = ndat
    case (16)
      nbyt = 2*ndat
    case (32,-32)
      nbyt = 4*ndat
    case (-64)
      nbyt = 8*ndat
    case default
      write(mess,*) 'BITPIX = ',fd%nbit,' not yet supported'
      call gfits_message(seve%e,'FSKIDAT',mess)
      error = .true.
      return
  end select
  !
  call gfits_skibuf(nbyt,error)
end subroutine gfits_skidat
!
subroutine gfits_skip_hdu(fd,ihdu,list,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces, except_this=>gfits_skip_hdu
  use gfits_types
  !---------------------------------------------------------------------
  ! @ private
  ! Skip entirely the current HDU. Optionaly list its contents.
  !---------------------------------------------------------------------
  type(gfits_hdesc_t), intent(inout) :: fd     !
  integer(kind=4),     intent(in)    :: ihdu   ! HDU we are skipping (1=Primary)
  logical,             intent(in)    :: list   !
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  type(gfits_hdict_t) :: fhdict
  integer(kind=size_length) :: ndat
  integer(kind=4) :: ndim,pcount,gcount
  integer(kind=index_length) :: dims(10)  ! Arbitrary number of dimensions
  character(len=message_length) :: mess
  logical :: groups
  !
  ! 1) Skip the header. As we need to get the data description, reading
  !    the entire header is the easiest
  call gfits_load_header(fhdict,.false.,gfits_getnosymbol,error)
  if (error)  return
  call gfits_flush_header(error)
  if (error)  return
  !
  ! 2) Compute the data size. Trickiest part...
  call gfits_compute_ndat(ndat,error)
  if (error)  return
  !
  ! 3) Skip the data
  call gfits_skidat(fd,ndat,error)
  if (error)  return
  call gfits_flush_data(error)
  if (error)  return
  !
  if (list) then
    call gfits_list_hdu(error)
    if (error)  return
  else
    ! Just some debugging
    write(mess,'(A,I0,A)')  'Skipped HDU of size ',ndat,' elements'
    call gfits_message(seve%d,rname,mess)
  endif
  !
contains
  subroutine gfits_compute_ndat(ndat,error)
    !-------------------------------------------------------------------
    ! Compute the data size in current HDU
    !-------------------------------------------------------------------
    integer(kind=size_length), intent(out)   :: ndat
    logical,                   intent(inout) :: error
    ! Local
    integer(kind=4) :: fmt
    logical :: found
    !
    if (ihdu.eq.1) then  ! We are skipping the Primary HDU
      call gfits_check_simple(fhdict%card(1),error)
      if (error)  return
    else    ! We are skipping an Xtension
      call gfits_check_xtension(fhdict%card(1),error)
      if (error)  return
    endif
    call gfits_check_format(fhdict%card(2),fd%nbit,fmt,error)
    if (error)  return
    call gfits_check_naxis(fhdict%card(3),ndim,error)
    if (error)  return
    call gfits_check_naxisi(fhdict,dims(:),error)
    if (error)  return
    !
    groups = .false.
    call gfits_get_value(fhdict,'GROUPS',found,groups,error)
    if (error)  return
    !
    if (groups) then
      ! Minimalist test. UVFITS readers should perform exhaustive tests.
      call gfits_get_value(fhdict,'GCOUNT',found,gcount,error)
      if (error)  return
      if (.not.found) then
        call gfits_message(seve%e,rname,'Missing keyword GCOUNT for Random Groups')
        error = .true.
        return
      endif
      call gfits_get_value(fhdict,'PCOUNT',found,pcount,error)
      if (error)  return
      if (.not.found) then
        call gfits_message(seve%e,rname,'Missing keyword PCOUNT for Random Groups')
        error = .true.
        return
      endif
      ndat = gcount * (pcount + product(dims(2:ndim)))
    elseif (ndim.eq.0) then
      ndat = 0
    else
      ndat = product(dims(1:ndim))
    endif
    !
  end subroutine gfits_compute_ndat
  !
  subroutine gfits_list_hdu(error)
    !-------------------------------------------------------------------
    ! Display a one-line description of the current HDU
    !-------------------------------------------------------------------
    logical, intent(inout) :: error  !
    ! Local
    character(len=16) :: extkind
    character(len=20) :: extname
    character(len=64) :: extdims
    integer(kind=4) :: tfields,nc,idime
    logical :: found,tfields_defined
    !
    tfields = 0
    call gfits_get_value(fhdict,'TFIELDS',tfields_defined,tfields,error)
    if (error)  return
    !
    if (ihdu.eq.1) then
      ! Primary HDU have no explicit kind. Have to guess what it is.
      if (groups) then  ! Already read by gfits_compute_ndat
        extkind = 'RANDOM GROUPS'
      elseif (tfields_defined) then
        extkind = 'BINTABLE'
      else
        extkind = 'IMAGE'
      endif
    else
      ! Rely on the XTENSION declaration
      extkind = '(UNKNOWN)'
      call gfits_get_value(fhdict,'XTENSION',found,extkind,error)
      if (error)  return
    endif
    !
    if (ihdu.eq.1) then
      extname = 'Primary'
    else
      extname = '(UNNAMED)'
      call gfits_get_value(fhdict,'EXTNAME',found,extname,error)
      if (error)  return
    endif
    !
    if (ndim.eq.0) then
      extdims = '0'
      !
    elseif (extkind.eq.'BINTABLE') then
      write(extdims,'(I0,A)')  tfields,' cols'
      do idime=2,ndim
        nc = len_trim(extdims)+2
        if (idime.eq.2) then
          write(extdims(nc:),'(A,I0,A)')  'x ',dims(idime),' rows'
        else
          write(extdims(nc:),'(A,I0)')    'x ',dims(idime)  ! More than 2 dims? Should not happen
        endif
      enddo
      !
    elseif (extkind.eq.'RANDOM GROUPS') then
      write(extdims,'(A,I0,A,I0)')  '(',pcount,' + ',dims(2)
      do idime=3,ndim
        nc = len_trim(extdims)+1
        write(extdims(nc:),'(A,I0)')  'x',dims(idime)
      enddo
      nc = len_trim(extdims)+1
      write(extdims(nc:),'(A,I0,A)')  ') x ',gcount,' visibilities'
      !
    else  ! Fallback for all others kinds (including IMAGE)
      write(extdims,'(I0)')  dims(1)
      do idime=2,ndim
        nc = len_trim(extdims)+2
        write(extdims(nc:),'(A,I0)')  'x ',dims(idime)
      enddo
    endif
    !
    write(mess,'(A,I0,T9,A,A,A)')  'HDU #',ihdu,extkind,extname,extdims
    call gfits_message(seve%r,rname,mess)
  end subroutine gfits_list_hdu
  !
end subroutine gfits_skip_hdu
!
subroutine gfits_goto_hdu(fd,khdu,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces, except_this=>gfits_goto_hdu
  use gfits_types
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! Go to the requested HDU
  !---------------------------------------------------------------------
  type(gfits_hdesc_t), intent(inout) :: fd     !
  integer(kind=4),     intent(in)    :: khdu   ! Requested HDU (1=Primary)
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: ihdu
  character(len=message_length) :: mess
  !
  if (khdu.le.0) then
    write(mess,'(A,I0)')  'Invalid HDU number ',khdu
    call gfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Rewind to start of file
  call gfits_rewind_file(error)
  if (error)  return
  !
  ! Skip undesired HDUs
  do ihdu=1,khdu-1
    call gfits_skip_hdu(fd,ihdu,.false.,error)
    if (error)  return
    if (gfits_iseof()) then
      write(mess,'(A,I0,A)') 'FITS file has only ',ihdu,' HDUs'
      call gfits_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  enddo
  !
  ! Set the starting record of current HDU
  hdurec = irec
  !
end subroutine gfits_goto_hdu
!
subroutine gfits_list_hdus(name,error)
  use gbl_message
  use gfits_interfaces, except_this=>gfits_list_hdus
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Go to the requested HDU
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   ! File name
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: ihdu
  type(gfits_hdesc_t) :: fd
  !
  call gfits_open(name,'IN',error)
  if (error)  return
  !
  ! Loop over HDUs
  ihdu = 0
  do
    ihdu = ihdu+1
    call gfits_skip_hdu(fd,ihdu,.true.,error)
    if (error)  exit  ! Need to close the file
    if (gfits_iseof())  exit  ! No more HDUs
  enddo
  !
  call gfits_close(error)
  !
end subroutine gfits_list_hdus

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mapping_list_tool
  use gbl_message
  use gbl_format
  use gkernel_types
  use gkernel_interfaces
  use mapping_interfaces, only : map_message
  !
  public :: get_i4list_fromsic
  public :: get_r4list_fromsic
  private
  !
contains
  !
  subroutine get_i4list_fromsic(rname,line,opt,nf,list,error)
    !------------------------------------------------------------------------
    ! Return in the allocatable array the content of the 1-D
    ! SIC variable given as argument of Option # opt.
    ! Return the size of the array in NF
    ! If NF is non zero on entry, the size must match and the
    ! array is pre-allocated.
    !------------------------------------------------------------------------
    character(len=*),     intent(in)    :: rname
    character(len=*),     intent(in)    :: line
    integer,              intent(in)    :: opt
    integer,              intent(inout) :: nf
    integer, allocatable, intent(inout) :: list(:)
    logical,              intent(inout) :: error
    !
    logical :: found
    integer :: na,ier
    integer(kind=address_length) :: jpd
    integer, save :: memory(2)
    character(len=64) :: listname
    type(sic_descriptor_t) :: desc
    !
    call sic_ch(line,opt,1,listname,na,.true.,error)
    if (error) return
    call sic_descriptor(listname,desc,found)
    if (.not.found) then
       call sic_i4(line,opt,1,na,.true.,error)
       if (error) then
          call map_message(seve%e,rname,'Variable '//trim(listname)//' does not exists.')
          return 
       endif
       if (nf.eq.0) then
          nf = 1
          allocate(list(nf),stat=ier)
       else if (nf.ne.1) then
          call map_message(seve%e,rname,'Number of elements mismatch in List')
          error = .true.
       else if (.not.allocated(list)) then
          call map_message(seve%e,rname,'List is not allocated')
          error = .true.
       endif
       if (error) return
       list(1:nf) = na
       return
    else if (desc%type.ne.fmt_i4) then
       call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
       error = .true.
       return
    endif
    if (desc%ndim.ne.1) then
       call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
       error = .true.
       return
    endif
    if (nf.eq.0) then
       nf = desc%dims(1)
       allocate(list(nf),stat=ier)
    else if (nf.ne.desc%dims(1)) then
       call map_message(seve%e,rname,'Number of elements mismatch in List')
       error = .true.
    else if (.not.allocated(list)) then
       call map_message(seve%e,rname,'List is not allocated')
       error = .true.
    endif
    if (error) return
    !
    jpd = gag_pointer(desc%addr,memory)
    call i4toi4(memory(jpd),list,nf)
  end subroutine get_i4list_fromsic
  !
  subroutine get_r4list_fromsic(rname,line,opt,nf,list,error)
    !------------------------------------------------------------------------
    ! Return in the allocatable array the content of the 1-D
    ! SIC variable given as argument of Option # opt.
    ! Return the size of the array in NF
    ! If NF is non zero on entry, the size must match and the
    ! array is pre-allocated.
    !------------------------------------------------------------------------
    character(len=*),  intent(in)    :: rname
    character(len=*),  intent(in)    :: line
    integer,           intent(in)    :: opt
    integer,           intent(inout) :: nf
    real, allocatable, intent(inout) :: list(:)
    logical,           intent(inout) :: error
    !
    logical :: found
    integer :: na,ier
    integer(kind=address_length) :: jpd
    integer, save :: memory(2)
    type(sic_descriptor_t) :: desc
    character(len=64) :: listname
    !
    call sic_ch(line,opt,1,listname,na,.true.,error)
    if (error) return
    call sic_descriptor(listname,desc,found)
    if (.not.found) then
       call sic_i4(line,opt,1,na,.true.,error)
       if (error) then
          call map_message(seve%e,rname,'Variable '//trim(listname)//' does not exists.')
          return 
       endif
       if (nf.eq.0) then
          nf = 1
          allocate(list(nf),stat=ier)
       else if (nf.ne.1) then
          call map_message(seve%e,rname,'Number of elements mismatch in List')
          error = .true.
       else if (.not.allocated(list)) then
          call map_message(seve%e,rname,'List is not allocated')
          error = .true.
       endif
       if (error) return
       list(1:nf) = na
       return
    else if (desc%type.ne.fmt_i4) then
       call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
       error = .true.
       return
    endif
    if (desc%ndim.ne.1) then
       call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
       error = .true.
       return
    endif
    if (nf.eq.0) then
       nf = desc%dims(1)
       allocate(list(nf),stat=ier)
    else if (nf.ne.desc%dims(1)) then
       call map_message(seve%e,rname,'Number of elements mismatch in List')
       error = .true.
    else if (.not.allocated(list)) then
       call map_message(seve%e,rname,'List is not allocated')
       error = .true.
    endif
    if (error) return
    !
    jpd = gag_pointer(desc%addr,memory)
    call r4tor4(memory(jpd),list,nf)
  end subroutine get_r4list_fromsic
end module mapping_list_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
! Common interfaces for the two ATM versions available:
!   ATM_1985  for the "Old" code
!   ATM_2009  for the latest code used starting from March 2009
!-----------------------------------------------------------------------
module atm_version
  !---------------------------------------------------------------------
  ! ATM parameters which are mapped on SIC variables.
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !---------------------------------------------------------------------
  character(len=4), save :: version='2009'  ! Default at startup
  !
  character(len=20), save :: ctype ! Atmosphere type as a string
  real(4), save :: humidity,wvsh,tlr,top,p_step,p_step_factor
  !
end module atm_version
!
subroutine atm_sicvariables(error)
  use gkernel_interfaces
  use atm_interfaces, except_this=>atm_sicvariables
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Instantiate SIC variables
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call sic_defstructure ('ATM',.true.,error)
  if (error) return
  call sic_defstructure ('ATM%MODEL',.true.,error)
  if (error) return
  call sic_defstructure ('ATM%MODEL%PROFILE',.true.,error)
  if (error) return
  !
  ! ATM internal values
  call sic_def_char ('ATM%MODEL%VERSION',version,.true.,error)
  if (error) return
  !
  ! Get internal default values of ATM library
  call atm_atmosp_variables_get(error)
  if (error) return
  call sic_def_char ('ATM%MODEL%PROFILE%TYPE',ctype,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%HUMIDITY',humidity,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%WVSH',wvsh,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%TLR',tlr,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%TOP',top,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%DP',p_step,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%DP_FACTOR',p_step_factor,0,1,.false.,error)
  if (error) return
  !
end subroutine atm_sicvariables
!
subroutine atm_print(error)
  use gbl_message
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Displays the values of ATM parameters
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=message_length) :: mess
  !
  write(mess,100) 'ATM%VERSION',version,'','Current version in use'
  call gagout(mess)
  !
  if (version.ne.'2009' .and. version.ne.'2016') return  ! Parameters below are used only in ATM 2009 or 2016
  !
  write(mess,100) 'ATM%PROFILE%TYPE',ctype,'','Atmospheric type'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%HUMIDITY',humidity,'[%]','Ground relative humidity (indication)'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%WVSH',wvsh,'[km]','Water vapor scale height'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%TLR',tlr,'[K/km]','Tropospheric lapse rate'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%TOP',top,'[km]','Upper atm. boundary for calculations'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%DP',p_step,'[hPa]','Primary pressure step'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%DP_FACTOR',p_step_factor,'[]','Pressure step ratio between two consecutive layers'
  call gagout(mess)
  !
100 format(A,T23,A12,  T36,A6,T43,A)
101 format(A,T23,F12.3,T36,A6,T43,A)
  !
end subroutine atm_print
!
subroutine atm_setup(inversion,error)
  use atm_version
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ public
  ! Set the ATM version to be used. Supported versions are 1985 and
  ! 2009. 'OLD' (resp. 'NEW') is an alias for 1985 (resp. 2009).
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: inversion  ! User input version
  logical,          intent(inout) :: error      ! Error flag
  ! Local
  character(len=4) :: versions(5)
  integer(kind=4) :: mversion,ikey
  character(len=5) :: key
  !
  mversion = 1
  versions(mversion) = 'OLD'
#if defined(ATM2009)
  mversion = mversion+1
  versions(mversion) = 'NEW'
#endif
  mversion = mversion+1
  versions(mversion) = '1985'
#if defined(ATM2009)
  mversion = mversion+1
  versions(mversion) = '2009'
#endif
#if defined(ATM2016)
  mversion = mversion+1
  versions(mversion) = '2016'
#endif
  !
  call sic_ambigs('ATM',inversion,key,ikey,versions,mversion,error)
  if (error)  return
  !
  if (key.eq.'OLD') then
    version = '1985'
  elseif (key.eq.'NEW') then
    version = '2009'
  else
    version = key
  endif
  !
end subroutine atm_setup
!
function atm_get_version()
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! get atm version
  !---------------------------------------------------------------------
  character(len=4) :: atm_get_version
  atm_get_version=version
end function atm_get_version
!
subroutine atm_atmosp(t0,p0,h0)
  use atm_interfaces, except_this=>atm_atmosp
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Setup the atmospheric structure
  !---------------------------------------------------------------------
  real, intent(in) :: t0  ! Ground temperature [K]
  real, intent(in) :: p0  ! Ground pressure [hPa]
  real, intent(in) :: h0  ! Altitude of the site [km]
  ! Local
  logical :: error
  !
  ! Update with (possibly) new values always before calling 'atm_atmosp'
  error = .false.
  call atm_atmosp_variables_set(error)
  if (error) return
  !
  select case (version)
  case('1985')
     call atm_1985_atmosp(t0,p0,h0)
  !
#if defined(ATM2009)
  case('2009')
     call atm_2009_atmosp(t0,p0,h0)
#endif
  !
#if defined(ATM2016)
  case('2016')
     call atm_2016_atmosp(t0,p0,h0)
#endif
  !
  case default
     call gagout('E-ATM_ATMOSP,  '//trim(version)//' version not available on this system')
  end select
  !
end subroutine atm_atmosp
!
subroutine atm_transm_0d(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
  use atm_interfaces, except_this=>atm_transm_0d
  use atm_version
  !---------------------------------------------------------------------
  ! @ public-generic atm_transm
  ! Return the atmospheric temperatures and opacities given the amount
  ! of water and the frequency, for current atmosphere previously set
  ! with 'atm_atmosp()'
  !---
  ! This version for scalar frequency as input
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: water    ! [mm]    Precipitable water vapo
  real(kind=4),    intent(in)  :: airmass  ! []      Number of air masses
  real(kind=4),    intent(in)  :: freq     ! [GHz]   Frequency
  real(kind=4),    intent(out) :: temi     ! [K]     Atmospheric emission
  real(kind=4),    intent(out) :: tatm     ! [K]     Mean temperature
  real(kind=4),    intent(out) :: tauox    ! [neper] Opacity (dry component)
  real(kind=4),    intent(out) :: tauw     ! [neper] Opacity (wet component)
  real(kind=4),    intent(out) :: taut     ! [neper] Total opacity
  integer(kind=4), intent(out) :: ier      ! []      Error status
  !
  select case (version)
  case('1985')
     call atm_1985_transm(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
  !
#if defined(ATM2009)
  case('2009')
     call atm_2009_transm(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
#endif
  !
#if defined(ATM2016)
  case('2016')
     call atm_2016_transm(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
#endif
  !
  case default
     call gagout('E-ATM_TRANSM,  '//trim(version)//' version not available on this system')
  end select
  !
end subroutine atm_transm_0d
!
subroutine atm_transm_1d(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
  use atm_interfaces, except_this=>atm_transm_1d
  use atm_version
  !---------------------------------------------------------------------
  ! @ public-generic atm_transm
  ! Return the atmospheric temperatures and opacities given the amount
  ! of water and the frequency, for current atmosphere previously set
  ! with 'atm_atmosp()'
  !---
  ! This version for vector frequency as input, and vector outputs
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: water     ! [mm]    Precipitable water vapor
  real(kind=4),    intent(in)  :: airmass   ! []      Number of air masses
  real(kind=4),    intent(in)  :: freq(:)   ! [GHz]   Frequency
  real(kind=4),    intent(out) :: temi(:)   ! [K]     Atmospheric emission
  real(kind=4),    intent(out) :: tatm(:)   ! [K]     Mean temperature
  real(kind=4),    intent(out) :: tauox(:)  ! [neper] Opacity (dry component)
  real(kind=4),    intent(out) :: tauw(:)   ! [neper] Opacity (wet component)
  real(kind=4),    intent(out) :: taut(:)   ! [neper] Total opacity
  integer(kind=4), intent(out) :: ier(:)    ! []      Error status
  ! Local
  integer(kind=4) :: ifreq,nfreq
  logical :: match
  !
  ! Sanity checks
  nfreq = size(freq)
  match = size(temi).eq.nfreq .and.  &
          size(tatm).eq.nfreq .and.  &
          size(tauox).eq.nfreq .and.  &
          size(tauw).eq.nfreq .and.  &
          size(taut).eq.nfreq .and.  &
          size(ier).eq.nfreq
  if (.not.match) then
    call gagout('E-ATM_TRANSM_1D,  Frequency array and output arrays do not match')
    ier(:) = 1  ! Not sure which output code should be used
    return
  endif
  !
  !*********************************************************************
  ! BEWARE! If you plan to parallelize this loop, beware there are
  ! global variables SAVE'd in atm_1985_transm. Have to check the other
  ! ATM versions too.
  !*********************************************************************
  !
  select case (version)
  case('1985')
    do ifreq=1,nfreq
      call atm_1985_transm(water,airmass,freq(ifreq),  &
        temi(ifreq),tatm(ifreq),tauox(ifreq),tauw(ifreq),taut(ifreq),ier(ifreq))
    enddo
  !
#if defined(ATM2009)
  case('2009')
    do ifreq=1,nfreq
      call atm_2009_transm(water,airmass,freq(ifreq),  &
        temi(ifreq),tatm(ifreq),tauox(ifreq),tauw(ifreq),taut(ifreq),ier(ifreq))
    enddo
#endif
  !
#if defined(ATM2016)
  case('2016')
    do ifreq=1,nfreq
      call atm_2016_transm(water,airmass,freq(ifreq),  &
        temi(ifreq),tatm(ifreq),tauox(ifreq),tauw(ifreq),taut(ifreq),ier(ifreq))
    enddo
#endif
  !
  case default
     call gagout('E-ATM_TRANSM,  '//trim(version)//' version not available on this system')
  end select
  !
end subroutine atm_transm_1d
!
subroutine atm_path(water,airmass,freq,path,ier)
  use atm_interfaces, except_this=>atm_path
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Integrated optical length of current atmosphere
  !---------------------------------------------------------------------
  real,    intent(in)  :: water    ! Precipitable water vapor [mm]
  real,    intent(in)  :: airmass  ! Number of air masses []
  real,    intent(in)  :: freq     ! Frequency [GHz]
  real,    intent(out) :: path     ! Optical length [cm]
  integer, intent(out) :: ier      ! Error status
  !
  ier = 0
  !
  select case (version)
  case('1985')
     call atm_1985_path(water,airmass,freq,path,ier)
  !
#if defined(ATM2009)
  case('2009')
     call atm_2009_path(water,airmass,freq,path,ier)
#endif
  !
#if defined(ATM2016)
  case('2016')
     call atm_2016_path(water,airmass,freq,path,ier)
#endif
  !
  case default
     call gagout('E-ATM_PATH,  '//trim(version)//' version not available on this system')
  end select
  !
end subroutine atm_path
!
subroutine atm_atmosp_get(ctype_out,humidity_out,wvsh_out,tlr_out,top_out,  &
  p_step_out,p_step_factor_out,error)
  use atm_interfaces, except_this=>atm_atmosp_get
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Public entry point to:
  !  1) get the C++ global variables into the Fortran-SIC ones,
  !  2) return these latter ones.
  ! Warning: these variables make sense only with ATM 2009 or 2016.
  ! Return ATM 2009 or 2016 values even if it is not currently used (not
  ! an error).
  !---------------------------------------------------------------------
  character(len=*), intent(out)    :: ctype_out          ! Atmospheric type (as a string)
  real(4),          intent(out)    :: humidity_out       ! [%]    Ground Relative Humidity (indication)
  real(4),          intent(out)    :: wvsh_out           ! [km]   Water vapor scale height
  real(4),          intent(out)    :: tlr_out            ! [K/km] Tropospheric lapse rate
  real(4),          intent(out)    :: top_out            ! [km]   Upper atm. boundary for calculations
  real(4),          intent(out)    :: p_step_out         ! [mb]   Primary pressure step
  real(4),          intent(out)    :: p_step_factor_out  ! []     Pressure step ratio between two consecutive layers
  logical,          intent(inout)  :: error              ! Logical error flag
  !
  ! 1) Get the C++ variables in the Fortran-SIC ones
  call atm_atmosp_variables_get(error)
  if (error)  return
  !
  ! 2) Return these values
  ctype_out         = ctype
  humidity_out      = humidity
  wvsh_out          = wvsh
  tlr_out           = tlr
  top_out           = top
  p_step_out        = p_step
  p_step_factor_out = p_step_factor
  !
end subroutine atm_atmosp_get
!
subroutine atm_atmosp_set(ctype_in,humidity_in,wvsh_in,tlr_in,top_in,  &
  p_step_in,p_step_factor_in,error)
  use atm_interfaces, except_this=>atm_atmosp_set
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Public entry point to:
  !  1) set the Fortran-SIC global variables values,
  !  2) set the C++ global variables from these values.
  ! Warning: these variables make sense only with ATM 2009 or 2016.
  ! Nothing will be done if ATM 2009 or 2016 is not the version in use
  ! (not an error). NB: 'ctype_in' is not case-sensitive, and can be
  ! shorten as long as it is not ambiguous.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: ctype_in          ! Atmospheric type (as a string)
  real(4),          intent(in)    :: humidity_in       ! [%]    Ground Relative Humidity (indication)
  real(4),          intent(in)    :: wvsh_in           ! [km]   Water vapor scale height
  real(4),          intent(in)    :: tlr_in            ! [K/km] Tropospheric lapse rate
  real(4),          intent(in)    :: top_in            ! [km]   Upper atm. boundary for calculations
  real(4),          intent(in)    :: p_step_in         ! [mb]   Primary pressure step
  real(4),          intent(in)    :: p_step_factor_in  ! []     Pressure step ratio between two consecutive layers
  logical,          intent(inout) :: error             ! Logical error flag
  !
  ! 1) Set the Fortran global values
  ctype         = ctype_in
  humidity      = humidity_in
  wvsh          = wvsh_in
  tlr           = tlr_in
  top           = top_in
  p_step        = p_step_in
  p_step_factor = p_step_factor_in
  !
  ! 2) Set the C++ global variables from the Fortran-SIC ones:
  call atm_atmosp_variables_set(error)
  if (error)  return
  !
end subroutine atm_atmosp_set
!
subroutine atm_atmosp_variables_get(error)
  use atm_interfaces, except_this=>atm_atmosp_variables_get
  use atm_version
  !---------------------------------------------------------------------
  ! @ private
  ! Get the atmospheric parameters currently in use in ATM, i.e. copy
  ! the C++ global variables in the Fortran-SIC global ones.
  ! Always get from 2009 to avoid mixing several set of parameters for
  ! each ATM version.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error         ! Logical error flag
  ! Local
  integer :: itype
  !
#if defined(ATM2009)
  call atm_2009_atmosp_get(itype,humidity,wvsh,tlr,top,p_step,p_step_factor)
  call atm_20XX_atmosp_type(itype,ctype,.true.,error)
  if (error) return
#endif
  !
#if defined(ATM2016)
  call atm_2016_atmosp_get(itype,humidity,wvsh,tlr,top,p_step,p_step_factor)
  call atm_20XX_atmosp_type(itype,ctype,.true.,error)
  if (error) return
#endif
  !
end subroutine atm_atmosp_variables_get
!
subroutine atm_atmosp_variables_set(error)
  use atm_interfaces, except_this=>atm_atmosp_variables_set
  use atm_version
  !---------------------------------------------------------------------
  ! @ private
  ! Set the atmospheric parameters to be used in ATM, i.e. copy the
  ! Fortran-SIC global variables in the C++ ones.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error         ! Logical error flag
  ! Local
  integer :: itype
  !
  select case (version)
  case('1985')
     continue
  !
#if defined(ATM2009)
  case('2009')
     call atm_20XX_atmosp_type(itype,ctype,.false.,error)
     if (error) return
     call atm_2009_atmosp_set(itype,humidity,wvsh,tlr,top,p_step,p_step_factor)
#endif
  !
#if defined(ATM2016)
  case('2016')
     call atm_20XX_atmosp_type(itype,ctype,.false.,error)
     if (error) return
     call atm_2016_atmosp_set(itype,humidity,wvsh,tlr,top,p_step,p_step_factor)
#endif
  !
  case default
     call gagout('E-ATM_ATMOSP_VARIABLES_SET,  '//trim(version)//' version not available on this system')
     ! error = .true.
  end select
  !
end subroutine atm_atmosp_variables_set
!
subroutine atm_20XX_atmosp_type(itype,ctype,int2str,error)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Translate the atmosphere type either from integer to string or from
  ! string to integer.
  !---------------------------------------------------------------------
  integer,          intent(inout) :: itype   ! Type as integer
  character(len=*), intent(inout) :: ctype   ! Type as string
  logical,          intent(in)    :: int2str ! Convert integer to string or vice-versa?
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ATM_ATMOSP'
  character(len=*), parameter :: echain='E-'//rname//',  '
  integer, parameter :: ntypes=5
  character(len=16), save :: ctypes(ntypes)
  data ctypes /'TROPICAL','MIDLATSUMMER','MIDLATWINTER','SUBARCTICSUMMER','SUBARCTICWINTER' /
  character(len=20) :: ctype_u,cfound
  character(len=message_length) :: mess
  !
  if (int2str) then
    ! Convert 'itype' into 'ctype'
    if (itype.le.0 .or. itype.gt.ntypes) then
      write(mess,'(A,I0)')  &
        echain//'Unrecognized atmosphere type ',itype
      call gagout(mess)
      error = .true.
      return
    endif
    ctype=ctypes(itype)
  !
  else
    ! Convert 'ctype' into 'itype'
    itype = 0
    ctype_u = ctype
    call sic_upper(ctype_u)
    call sic_ambigs(rname,ctype_u,cfound,itype,ctypes,ntypes,error)
    if (error)  call gagout(echain//  &
      'Unrecognized atmosphere type "'//trim(ctype)//'"')
  endif
  !
end subroutine atm_20XX_atmosp_type

subroutine gtv_image(nx,ny,data,location,limits,convert,scaling,cuts,extrema,  &
  blank,is_visible,is_curima,error)
  use gbl_message
  use gtv_bitmap
  use gtv_buffers
  use gtv_interfaces, except_this=>gtv_image
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Allocate a new GTVIRT image slot. Image numbers may not be
  ! continuous, search for one from start.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nx   ! Image size in X
  integer(kind=index_length), intent(in) :: ny   ! Image size in Y
  real(kind=4),    intent(in)    :: data(nx,ny)  ! Image values
  real(kind=4),    intent(in)    :: location(4)  ! Position in Paper coordinates
  real(kind=4),    intent(in)    :: limits(4)    ! User limits
  real(kind=4),    intent(in)    :: convert(6)   ! Image pixel to User conversion formula
  integer(kind=4), intent(in)    :: scaling      ! Scaling mode (1=Lin, 2=Log, 3=Equ)
  real(kind=4),    intent(in)    :: cuts(2)      ! Low and High cut
  real(kind=4),    intent(in)    :: extrema(2)   ! Low and High extrema
  real(kind=4),    intent(in)    :: blank(3)     ! Blanking value
  logical,         intent(in)    :: is_visible   ! Always Visible ?
  logical,         intent(in)    :: is_curima    ! Update the SIC structure CURIMA% ?
  logical,         intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PLOT'
  integer(kind=4) :: ier
  real(kind=4) :: rmin,rmax
  type(gt_image), pointer :: image
  character(len=message_length) :: mess
  !
  ! Allocate a new gt_image instance
  allocate(image,stat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Error allocating a new image')
    error = .true.
    return
  endif
  image%isrgb = .false.
  image%scaling = scaling
  image%lut => null()
  image%r%values => null()
  image%g%values => null()
  image%b%values => null()
  image%next => null()
  nb_image = nb_image+1
  !
  ! Do we need to save the current LUT in the metacode before starting
  ! to write the image?
  if (lut_static) then
    if (.not.associated(co_segment%head%lut)) then
      ! We have to save to current global LUT in the metacode
      call gt_lut_segdata(error)  ! This sets co_segment%head%lut
      if (error)  return
    endif
  endif
  !
  ! LUT
  image%lut => co_segment%head%lut  ! Which can be null()
  !
  ! NB: freeing 1 image slot is done by 'gtv_delimage'. Freeing ALL slots
  ! at once and resetting 'max_image_num' and 'nb_image' can not be done,
  ! since 'gtv_delimage' is put in the stack and we can not predict when
  ! it will be executed. This is not a problem since the image slot
  ! allocation/deallocation has no memory leak as long as the stack does
  ! its job regularly.
  !
  image%r%taille(1) = nx
  image%r%taille(2) = ny
  !
  ! Allocate virtual memory
  allocate(image%r%values(nx,ny),stat=ier)
  if (ier.ne.0) then
    ! error = .true.
    return
  endif
  !
  ! Copy the data
  image%r%values = data
  !
  image%r%blank = blank
  image%r%cuts = cuts
  image%r%extrema = extrema
  !
  if (cdepth.le.1)  cdepth = 2
  !
  select case (image%scaling)
  case (scale_equ)
    ! Compute the scaled image if scaling is EQUALIZATION
    call gtv_image_equalize(image%r,error)
    if (error)  return
  case (scale_log)
    ! Recompute the cuts for better ones if they are invalid
    if (any(cuts.le.0.)) then
      ! Patch (only) the invalid cut(s)
      call gtv_image_logcuts(data,nx*ny,blank(1:2),rmin,rmax)
      if (cuts(1).lt.cuts(2)) then
        if (cuts(1).lt.0.)  image%r%cuts(1) = rmin
        if (cuts(2).lt.0.)  image%r%cuts(2) = rmax
      else
        if (cuts(2).lt.0.)  image%r%cuts(2) = rmin
        if (cuts(1).lt.0.)  image%r%cuts(1) = rmax
      endif
      write(mess,'(3(A,1PG14.7))')  'Low and high cuts forced to ',  &
        image%r%cuts(1),' and ',image%r%cuts(2),' for logarithmic scaling'
      call gtv_message(seve%w,rname,mess)
    endif
  end select
  !
  ! Setup the remaining elements and attach the gt_image in the tree
  call gtv_image_segdata(image,location,limits,convert,is_visible,error)
  if (error)  return
  !
  if (is_curima) then
    call gtv_image_variables(image,.false.,error)
    if (error)  return
  endif
  !
end subroutine gtv_image
!
subroutine gtv_rgbimage(nx,ny,    &
    rdata,rblank,rcuts,rextrema,  &
    gdata,gblank,gcuts,gextrema,  &
    bdata,bblank,bcuts,bextrema,  &
    scaling,scaling_lup_b,        &
    location,limits,convert,is_visible,error)
  use gbl_message
  use gtv_bitmap
  use gtv_buffers
  use gtv_interfaces, except_this=>gtv_rgbimage
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Allocate a new GTVIRT image slot. Image numbers may not be
  ! continuous, search for one from start.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nx         ! RGB image size in X
  integer(kind=index_length), intent(in) :: ny         ! RGB image size in Y
  real(kind=4),    intent(in)    :: rdata(nx,ny)       ! R image values
  real(kind=4),    intent(in)    :: rblank(3)          ! R blanking value
  real(kind=4),    intent(in)    :: rcuts(2)           ! R low and high cut
  real(kind=4),    intent(in)    :: rextrema(2)        ! R low and high extrema
  real(kind=4),    intent(in)    :: gdata(nx,ny)       ! G image values
  real(kind=4),    intent(in)    :: gblank(3)          ! G blanking value
  real(kind=4),    intent(in)    :: gcuts(2)           ! G low and high cut
  real(kind=4),    intent(in)    :: gextrema(2)        ! G low and high extrema
  real(kind=4),    intent(in)    :: bdata(nx,ny)       ! B image values
  real(kind=4),    intent(in)    :: bblank(3)          ! B blanking value
  real(kind=4),    intent(in)    :: bcuts(2)           ! B low and high cut
  real(kind=4),    intent(in)    :: bextrema(2)        ! B low and ligh extrema
  integer(kind=4), intent(in)    :: scaling            ! RGB scaling mode
  real(kind=4),    intent(in)    :: scaling_lup_b      ! Beta parameter for Lupton scaling mode
  real(kind=4),    intent(in)    :: location(4)        ! Position in Paper coordinates
  real(kind=4),    intent(in)    :: limits(4)          ! User limits
  real(kind=4),    intent(in)    :: convert(6)         ! Image pixel to User conversion formula
  logical,         intent(in)    :: is_visible         ! Always Visible ?
  logical,         intent(inout) :: error              ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RGB_IMAGE'
  integer :: ier
  type(gt_image), pointer :: rgb
  !
  ! Allocate a new gt_rgb instance
  allocate(rgb,stat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Error allocating a new RGB image')
    error = .true.
    return
  endif
  rgb%isrgb = .true.
  rgb%scaling = scaling
  rgb%scaling_lup_b = scaling_lup_b
  rgb%lut => null()
  rgb%r%values => null()
  rgb%g%values => null()
  rgb%b%values => null()
  rgb%next => null()
  nb_image = nb_image+1
  !
  ! NB: freeing 1 image slot is done by 'gtv_delimage'. Freeing ALL slots
  ! at once and resetting 'max_image_num' and 'nb_image' can not be done,
  ! since 'gtv_delimage' is put in the stack and we can not predict when
  ! it will be executed. This is not a problem since the image slot
  ! allocation/deallocation has no memory leak as long as the stack does
  ! its job regularly.
  !
  rgb%r%taille(1) = nx
  rgb%r%taille(2) = ny
  rgb%g%taille(1) = nx
  rgb%g%taille(2) = ny
  rgb%b%taille(1) = nx
  rgb%b%taille(2) = ny
  !
  ! Allocate virtual memory
  allocate(rgb%r%values(nx,ny),rgb%g%values(nx,ny),rgb%b%values(nx,ny),stat=ier)
  if (ier.ne.0) then
    ! error = .true.
    return
  endif
  !
  ! Copy the data
  rgb%r%values = rdata
  rgb%r%blank = rblank
  rgb%r%cuts = rcuts
  rgb%r%extrema = rextrema
  !
  rgb%g%values = gdata
  rgb%g%blank = gblank
  rgb%g%cuts = gcuts
  rgb%g%extrema = gextrema
  !
  rgb%b%values = bdata
  rgb%b%blank = bblank
  rgb%b%cuts = bcuts
  rgb%b%extrema = bextrema
  !
  if (cdepth.le.1)  cdepth = 2
  !
  ! Compute the scaled image if scaling is EQUALIZATION
  if (rgb%scaling.eq.scale_equ) then
    call gtv_image_equalize(rgb%r,error)
    if (error)  return
    call gtv_image_equalize(rgb%g,error)
    if (error)  return
    call gtv_image_equalize(rgb%b,error)
    if (error)  return
  endif
  !
  ! Setup the remaining elements and attach the gt_image in the tree
  call gtv_image_segdata(rgb,location,limits,convert,is_visible,error)
  if (error)  return
  !
end subroutine gtv_rgbimage
!
subroutine gtv_image_segdata(ima,location,limits,convert,is_visible,error)
  use gtv_bitmap
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>gtv_image_segdata
  use gtv_plot
  use gtv_segatt
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Stores the image descriptor in the metacode, in the currently
  ! opened segment.
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  type(gt_image),  target        :: ima          ! Image instance
  real(kind=4),    intent(in)    :: location(4)  ! Position in Paper coordinates
  real(kind=4),    intent(in)    :: limits(4)    ! User limits
  real(kind=4),    intent(in)    :: convert(6)   ! Image pixel to User conversion formula
  logical,         intent(in)    :: is_visible   ! Always Visible ?
  logical,         intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_IMAGE'
  integer(kind=4) :: ier
  !
  call gtv_open_segments_for_writing_from_main()
  !
  ! Segment descriptor is created. Let's update the image location
  co_segment%head%gen%minmax(1) = location(1)  ! xmin
  co_segment%head%gen%minmax(2) = location(2)  ! xmax
  co_segment%head%gen%minmax(3) = location(3)  ! ymin
  co_segment%head%gen%minmax(4) = location(4)  ! ymax
  ! Update the extrema of the parent directory
  call dir_extrema(co_segment%father,co_segment%head%gen%minmax)
  !
  if (.not.associated(co_segment_data)) then
    allocate(co_segment%data,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (1)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment%data
  else
    allocate(co_segment_data%nextdata,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (2)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment_data%nextdata
  endif
  co_segment_data%nextdata => null()
  co_segment_data%kind = seg_image
  co_segment_data%image => ima
  !
  ! Image Position in Page
  ima%position = location
  ! Box User coordinates
  ima%limits = limits
  ! Pixel to User conversion
  ima%conv = convert
  !
  co_segment%head%attr%depth = cdepth
  vdepth(cdepth) = .true.
  !
10 continue
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gtv_image_segdata
!
subroutine gtv_delimage(image)
  use gtv_bitmap
  use gtv_interfaces, except_this=>gtv_delimage
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !   Delete a GTVIRT image structure.
  !---------------------------------------------------------------------
  type(gt_image), target :: image  ! Image slot to free
  ! Local
  type(gt_image), pointer :: image_p
  integer :: iout
  type(gt_bitmap), pointer :: xbitmap,prevbit
  !
  ! Original
  if (associated(image%r%values))   deallocate(image%r%values)
  if (associated(image%g%values))   deallocate(image%g%values)
  if (associated(image%b%values))   deallocate(image%b%values)
  if (allocated(image%r%eqvalues))  deallocate(image%r%eqvalues)
  if (allocated(image%g%eqvalues))  deallocate(image%g%eqvalues)
  if (allocated(image%b%eqvalues))  deallocate(image%b%eqvalues)
  !
  ! Resampled
  do iout=1,moutputs
    prevbit => null()
    xbitmap => all_outputs(iout)%x%bitmap_first
    do while (associated(xbitmap))
      !
      if (associated(xbitmap%image,image)) then
        ! Take care of the chain first
        if (.not.associated(prevbit)) then
          all_outputs(iout)%x%bitmap_first => xbitmap%next  ! ... which can be null()
        else
          prevbit%next => xbitmap%next  ! ... which can be null()
        endif
        if (associated(all_outputs(iout)%x%bitmap_last,xbitmap)) then
          all_outputs(iout)%x%bitmap_last => prevbit   ! ... which can be null()
        endif
        !
        call gt_bitmap_deallocate(xbitmap)
        !
        exit  ! Jump to next window
      endif
      !
      prevbit => xbitmap
      xbitmap => xbitmap%next
    enddo
  enddo
  !
  ! Deallocate the instance
  image_p => image
  deallocate(image_p)
  !
  nb_image = nb_image-1
  !
end subroutine gtv_delimage
!
subroutine gtv_image_variables(ima,update,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtv_image_variables
  use gbl_message
  use gtv_bitmap
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Update or define the SIC structure CURIMA% according to the input
  ! image instance
  !---------------------------------------------------------------------
  type(gt_image), pointer       :: ima     ! Image instance
  logical,        intent(in)    :: update  ! Update or define?
  logical,        intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_IMAGE'
  character(len=varname_length) :: varname
  ! Support variables
  type(gt_image), pointer, save :: curima
  integer(kind=4),         save :: curima_scaling
  real(kind=4),            save :: curima_scale(2)
  logical, save :: first_time
  ! Data
  data first_time /.true./
  !
  ! Nothing to do if we only want to update the image scaling, but input
  ! is not the one referenced by CURIMA%
  if (update) then
    if (.not.associated(ima,curima))  return
  endif
  !
  if (.not.associated(ima%r%values)) then
    call gtv_message(seve%e,rname,'Programming error: no such image')
    error = .true.
    return
  endif
  !
  if (first_time) then
    call sic_defstructure('CURIMA',.true.,error)
    !
    call sic_def_inte('CURIMA%SCALING',curima_scaling,0,0,.true.,error)
    call sic_def_real('CURIMA%SCALE',  curima_scale,  1,2,.true.,error)
    if (error)  return
    !
    first_time = .false.
  endif
  !
  curima => ima
  curima_scaling = ima%scaling
  curima_scale   = ima%r%cuts
  !
  ! Equalization levels
  varname = 'CURIMA%EQUAL%NLEV'
  !
  if (sic_varexist(varname)) then
    call sic_delvariable('CURIMA%EQUAL%NLEV',.false.,error)
    call sic_delvariable('CURIMA%EQUAL%LEV',.false.,error)
    call sic_delvariable('CURIMA%EQUAL%HIST',.false.,error)
    if (error)  return
  endif
  !
  if (ima%scaling.eq.scale_equ) then
    call sic_def_inte('CURIMA%EQUAL%NLEV',eqnlev,0,     1,.true.,error)
    call sic_def_real('CURIMA%EQUAL%LEV', eqlev, 1,eqnlev,.true.,error)
#if defined(BITS64)
    call sic_def_long('CURIMA%EQUAL%HIST',eqbin, 1,eqnlev,.true.,error)
#else
    call sic_def_inte('CURIMA%EQUAL%HIST',eqbin, 1,eqnlev,.true.,error)
#endif
    if (error)  return
  endif
  !
end subroutine gtv_image_variables
!
subroutine gtv_image_logcuts(data,nxy,blank,rmin,rmax)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the best extrema suited for LOG scaling
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)   :: nxy
  real(kind=4),              intent(in)   :: data(nxy)
  real(kind=4),              intent(in)   :: blank(2)
  real(kind=4),              intent(out)  :: rmin,rmax
  ! Local
  character(len=*), parameter :: rname='PLOT'
  integer(kind=size_length) :: ixy,first
  !
  ! First valid value
  first = 0
  do ixy=1,nxy
    if (abs(data(ixy)-blank(1)).le.blank(2))  cycle
    if (data(ixy).le.0.)  cycle
    first = ixy
    exit
  enddo
  if (first.eq.0) then
    call gtv_message(seve%w,rname,'No positive data found')
    rmin = 1.0
    rmax = 10.0
    return
  endif
  !
  ! Min value
  rmin = data(first)
  do ixy=first+1,nxy
    if (abs(data(ixy)-blank(1)).le.blank(2))  cycle
    if (data(ixy).le.0.)  cycle
    if (rmin.gt.data(ixy))  rmin = data(ixy)
  enddo
  !
  ! Max value
  rmax = data(first)
  do ixy=first+1,nxy
    if (abs(data(ixy)-blank(1)).le.blank(2))  cycle
    if (data(ixy).le.0.)  cycle
    if (rmax.lt.data(ixy))  rmax = data(ixy)
  enddo
  !
end subroutine gtv_image_logcuts
!
subroutine gtv_image_equalize(data,error)
  use gbl_message
  use gtv_interfaces, except_this=>gtv_image_equalize
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the scaled image if scaling is EQUALIZATION
  !---------------------------------------------------------------------
  type(gt_image_data), intent(inout) :: data   !
  logical,             intent(inout) :: error  !
  ! Local
  integer :: ier
  !
  if (.not.allocated(data%eqvalues)) then
    allocate(data%eqvalues(data%taille(1),data%taille(2)),stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,'EQUAL','Internal error: allocation failure')
      error = .true.
      return
    endif
  endif
  !
  call gt_image_equalize(data%values,                    &
                         data%eqvalues,                  &
                         data%taille(1),data%taille(2),  &
                         lut_size,                       &
                         data%cuts(1),data%cuts(2),      &
                         data%blank(1),data%blank(2),    &
                         error)
  if (error) then
    deallocate(data%eqvalues)
    return
  endif
  !
end subroutine gtv_image_equalize
!
subroutine gt_image_equalize(imagein,eqimage,nx,ny,ncol,rmin,rmax,  &
  bval,eval,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_image_equalize
  use gbl_message
  use gtv_bitmap
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=4),                 intent(in)    :: imagein(*)  ! Original image
  integer(kind=2*bitmap_depth), intent(inout) :: eqimage(*)  ! Scaled values
  integer(kind=index_length),   intent(in)    :: nx,ny       ! Size of image
  integer(kind=4),              intent(in)    :: ncol        ! Number of colours
  real(kind=4),                 intent(in)    :: rmin,rmax   ! Range
  real(kind=4),                 intent(in)    :: bval,eval   ! Blanking value
  logical,                      intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='EQUAL'
  real(kind=4), allocatable :: image(:)
  integer(kind=4), allocatable :: ist(:)
  integer(kind=2*bitmap_depth) :: entier
  integer :: ier
  !
  ! Device dependent. Version for 8-bit bitmap
  integer(kind=bitmap_depth) :: bitmap
#if defined(VAX) || defined(IEEE)
  equivalence (entier,bitmap)
#endif
#if defined(EEEI)
  integer(kind=bitmap_depth) bitarr(2)
  equivalence (entier,bitarr(1)),(bitarr(2),bitmap)
#endif
  logical :: doblank,hasblank
  integer :: level
  integer(kind=size_length) :: nduplicate,ngood,ipix,npixels,nblank,nreal,n
  real(kind=4) :: last_value,value,locbval,kase,iquota,color,colorinc
  !
  npixels = nx*ny
  !
  ! In order to save the contents of 'image', we need to work on a copy
  allocate(image(npixels),ist(npixels),stat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,  &
      'Allocation failure during equalization scaling')
    return
  endif
  !
  ! Copy
  doblank = eval.ge.0.
  hasblank = .false.
  locbval = rmax+1.  ! Reject blank values out of the [rmin--rmax] real values
  do ipix=1,npixels
    value = imagein(ipix)
    if (value.ne.value) then
      ! Patch for NaN
      hasblank = .true.
      image(ipix) = locbval
    elseif (doblank .and. abs(value-bval).le.eval) then
      hasblank = .true.
      image(ipix) = locbval
    elseif (value.le.rmin) then
      image(ipix) = rmin
    elseif (value.ge.rmax) then
      image(ipix) = rmax
    else
      image(ipix) = value
    endif
  enddo
  !
  ! Sort array
  call gr4_trie(image,ist,int(npixels,kind=4),error)
  if (error) then
    call gtv_message(seve%e,rname,'Error during pixel sorting')
    eqnlev=0
    return
  endif
  ! Now image is sorted and IST contains original offset
  !
  if (hasblank) then
    call gr4_dicho(npixels,image,locbval,nreal)  ! Returns index of first blank value
    nreal = nreal-1  ! Last real (i.e. non-blank) value
    nblank = npixels-nreal
  else
    nreal = npixels
    nblank = 0
  endif
  !
  ! Search for the number of real and non-duplicate values
  nduplicate = 0
  last_value = image(1)
  do ipix = 2,nreal
    value = image(ipix)
    if (value.eq.last_value) then
      nduplicate = nduplicate+1
    else
      last_value = value
    endif
  enddo
  !
  ngood = nreal-nduplicate
  if (ngood.ge.ncol) then
    iquota = float(ngood)/float(ncol)
    colorinc = 1.
  elseif (ngood.ne.0) then
    ! There is more colors than values
    iquota = 1.
    colorinc = float(ncol-1)/float(ngood)
  else
    ! No good value (all are blanked). Set dummy values
    iquota = 1.
    colorinc = 0.
  endif
  !
  ! Most images are from poorly digitized pixels. Often the number of different
  ! values is smaller than NCOL. This is not an EQUALIZATION mode, so we warn
  ! the user. To compensate for the small number of levels, we will start from
  ! the upper end of values when scaling to integers, so as to saturate the image
  !      IF (IQUOTA.LE.0.OR.IGOOD.LE.0.1*(IHAUT-IBAS+1)) THEN
  !         WRITE(CHAIN,'(A,I6,A)')
  !     &   'W-EQUAL,  Poorly digitized image: only ',IGOOD,
  !     &   ' DIFFERENT values in image.'
  !         CALL GAGOUT(CHAIN)
  !         WRITE(CHAIN,'(A,A)')
  !     &   '          Please inspect Histogram stored in variables',
  !     &   ' CURIMA%EQUAL%LEV and CURIMA%EQUAL%HIST'
  !         CALL GAGOUT(CHAIN)
  !      ENDIF
  !
  ! Compute values of the array EQLEV (impossible to do otherwise since we
  ! erase quasi-randomly IMAGE when rescaling on integer values). We keep the
  ! "breakpoints" in array EQBIN:
  !
  if (.not.allocated(eqlev)) then
    allocate(eqlev(bitmap_dynamic_max),eqbin(bitmap_dynamic_max),stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,  &
        'Internal error: failed to allocate equalization support variables')
      error = .true.
      return
    endif
  endif
  !
  if (ngood.gt.0) then
    last_value = image(1)
    level = 1
    eqnlev = 1
    eqlev(eqnlev) = last_value
    eqbin(eqnlev) = 1
    kase = 0.
    do n = 2,nreal
      value = image(n)
      if (value.ne.last_value) then
        last_value=value
        kase = kase+1.
      endif
      if (kase.ge.iquota) then
        level = level+1
        eqnlev = level
        eqlev(eqnlev) = value
        eqbin(eqnlev) = n
        kase = mod(kase,iquota)
      endif
    enddo
  else
    eqnlev = 0
  endif
  !
  ! Replaces the sorted IMAGE by a restricted range of integer values
  !
  ! KASE Compteur des pixels attribues a une kase de l'histogramme
  ! VALUE and LAST_VALUE: Check that we do no change color between two
  ! pixels having the same value . The program is now (?) protected against
  ! huge amounts of pixels having the same value.
  !
  level = 1
  color = 1.
  if (eqnlev.gt.1) then
    do ipix = 1,eqbin(eqnlev)-1
      if (ipix.ge.eqbin(level+1)) then
        level = level+1
        color = color+colorinc
      endif
      eqimage(ist(ipix)) = nint(color)
    enddo
    ! Last bin of real values
    color = color+colorinc
    do ipix = eqbin(eqnlev),nreal
      eqimage(ist(ipix)) = nint(color)
    enddo
  else
    ! Only 1 (or even 0, i.e. nreal==0) bin
    do ipix = 1,nreal
      eqimage(ist(ipix)) = nint(color)
    enddo
  endif
  ! Blanked bin
  if (hasblank) then
    do ipix=nreal+1,npixels
      eqimage(ist(ipix)) = ncol+1
    enddo
  endif
  !
  deallocate(image,ist)
  !
end subroutine gt_image_equalize
!
!-----------------------------------------------------------------------
! Beyond this point: generic routines traversing the tree searching
! for images.
!-----------------------------------------------------------------------
recursive subroutine exec_images_recurs(dir,execop)
  use gtv_buffers
  use gtv_interfaces, except_this=>exec_images_recurs
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Traverse all the leaves of the input directory and recursively in
  ! subdirectories and execute the input routine 'execop' on the GTV
  ! images it finds.
  !---------------------------------------------------------------------
  type(gt_directory) :: dir     ! Starting directory
  external           :: execop  !
  ! Local
  type(gt_segment), pointer :: leaf
  type(gt_directory), pointer :: son
  !
  ! 1) Search for all the leaves
  leaf => dir%leaf_first
  do while (associated(leaf))
    call image_codeop(leaf,execop)
    leaf => leaf%nextseg
  enddo
  !
  ! 2) Loop on all the subdirectories
  son => dir%son_first
  do while (associated(son))
    call exec_images_recurs(son,execop)
    son => son%brother
  enddo
  !
end subroutine exec_images_recurs
!
subroutine image_codeop(leaf,execop)
  use gtv_interfaces, except_this=>image_codeop
  use gtv_buffers
  use gtv_plot
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Generic entry point which reads the input 'leaf' and execute
  ! the input routine if it finds a the GTV image (and only a GTV
  ! image).
  !  'execop' takes the image address as unique argument
  !---------------------------------------------------------------------
  type(gt_segment), pointer :: leaf    ! Segment instance
  external                  :: execop  ! Routine to execute on the image
  ! Local
  type(gt_segment_data), pointer :: segdata
  logical :: error
  !
  if (lut_static) then
    ! Save the current global LUT as last data in this segment
    co_segment => leaf
    co_segment_data => null()
    segdata => leaf%data
    do while (associated(segdata))
      co_segment_data => segdata
      segdata => segdata%nextdata
    enddo
    error= .false.
    call gt_lut_segdata(error)
    co_segment => null()
    co_segment_data => null()
  else
    ! Unset the LUT to be used by the polylines. We should also remove its
    ! data (which is somewhere in the linked list of data)
    leaf%head%lut => null()
  endif
  !
  ! Follow the linked list of data
  segdata => leaf%data
  do while (associated(segdata))
    if (segdata%kind.eq.seg_image)  call execop(leaf%head,segdata%image)
    !
    segdata => segdata%nextdata
  enddo
  !
end subroutine image_codeop

module telcal_interfaces_public
  interface
    subroutine telcal_chopper(chopper,error)
      use gbl_message
      use chopper_definitions
      !----------------------------------------------------------------------
      ! @ public
      !
      ! Compute Trec, Tcal, Tsys from the chop and atm values observed
      ! according to the usual chopper method (ulich and haas) Double side band
      ! operation.
      !
      ! Note that each for each frequency, an error status is set in
      ! chopper%errors(ifreq). It indicates if the operation could be performed
      ! or not. It is the responsibility of the caller to check them or not,
      ! e.g.
      !
      !   call telcal_chopper(chopper,error)
      !   if (error .or. any(chopper%errors(:))  return
      !
      ! If the error status of a given frequency is set to .true., the output
      ! parameters are also nullified to the value chopper%bad, so that the
      ! caller can identify them as bad values.
      ! ----------------------------------------------------------------------
      type(chopper_t), intent(inout) :: chopper
      logical,         intent(inout) :: error
    end subroutine telcal_chopper
  end interface
  !
  interface
    subroutine telcal_chopper_nullify(chopper,ifreq)
      use chopper_definitions
      !---------------------------------------------------------------------
      ! @ public
      !  Nullify the chopper results (only the outputs, not the inputs) e.g.
      ! in case of error
      !---------------------------------------------------------------------
      type(chopper_t), intent(inout) :: chopper
      integer(kind=4) :: ifreq
    end subroutine telcal_chopper_nullify
  end interface
  !
  interface
    function airmass(el,error)
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      ! Compute airmass number corresponding to elevation EL
      ! Use a curved atmosphere, equivalent height 5.5 km
      !----------------------------------------------------------------------
      real(8), intent(in)  :: el      ! Elevation [radian]
      logical, intent(out) :: error   ! Error flag
      real(8)              :: airmass ! Airmass
    end function airmass
  end interface
  !
  interface
    subroutine fit_1d(dat,fun,verbose)
      use fit_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! General unidimensional fitting routine
      !----------------------------------------------------------------------
      type(simple_1d), intent(in)  :: dat ! Data vectors
      type(fit_fun), intent(inout) :: fun ! Fitting function description
      logical, intent(in)      :: verbose ! Verbose or quiet?
    end subroutine fit_1d
  end interface
  !
  interface
    subroutine null_simple_1d(dat)
      use fit_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine of its derived types
      ! Purpose: Initialize a simple precision data vector
      !----------------------------------------------------------------------
      type(simple_1d), intent(inout) :: dat ! Data vector
    end subroutine null_simple_1d
  end interface
  !
  interface
    subroutine null_parameter(par)
      use fit_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine of its derived types
      ! Purpose: Initialize a fitted parameter
      !----------------------------------------------------------------------
      type(fit_par), intent(inout) :: par ! Fitted parameter
    end subroutine null_parameter
  end interface
  !
  interface
    subroutine null_function(fun)
      use fit_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine of its derived types
      ! Purpose: Initialize a fitted function description
      !----------------------------------------------------------------------
      type(fit_fun), intent(inout) :: fun ! Description of the fitted function
    end subroutine null_function
  end interface
  !
  interface
    subroutine copy_simple_1d(in,out)
      use fit_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine of its derived types
      ! Purpose: Copy a simple precision data vector
      !----------------------------------------------------------------------
      type(simple_1d), intent(in)    :: in  ! Original vector
      type(simple_1d), intent(inout) :: out ! Copied vector
    end subroutine copy_simple_1d
  end interface
  !
  interface
    subroutine copy_function(in,out)
      use fit_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine of its derived types
      ! Purpose: Copy the description of a fitted function
      !----------------------------------------------------------------------
      type(fit_fun), intent(in)    :: in  ! Original function
      type(fit_fun), intent(inout) :: out ! Copied function
    end subroutine copy_function
  end interface
  !
  interface
    subroutine solve_focus(line,error)
      use fit_definitions
      use focus_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine for command
      !    FOCUS [Polynomial|Lorentzian|Gaussian]
      !----------------------------------------------------------------------
      character(*), intent(in)  :: line  ! Command line
      logical,      intent(out) :: error ! Error flag
    end subroutine solve_focus
  end interface
  !
  interface
    subroutine init_focus(ndat)
      use focus_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine for focus
      ! Purpose:
      !----------------------------------------------------------------------
      integer, intent(in) :: ndat ! Number of data points
    end subroutine init_focus
  end interface
  !
  interface
    subroutine load_telcal
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL Support routine
      ! Purpose: Language is loaded
      !----------------------------------------------------------------------
      ! Global
    end subroutine load_telcal
  end interface
  !
  interface
    subroutine run_telcal(line,comm,error)
      !----------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      ! TELCAL Main library entry point
      ! Purpose: Call appropriate subroutine according to COMM
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: line  ! Command line
      character(len=*), intent(in)    :: comm  ! Typed command
      logical,          intent(inout) :: error ! Error flag
    end subroutine run_telcal
  end interface
  !
  interface
    subroutine telcal_pack_set(pack)
      use gpack_def
      !----------------------------------------------------------------------
      ! @ public
      !----------------------------------------------------------------------
      type(gpack_info_t), intent(out) :: pack
    end subroutine telcal_pack_set
  end interface
  !
  interface
    subroutine default_pointing_guess(guess)
      use point_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine for pointing
      ! Purpose: Try to make clever guesses to prepare to solve for pointing
      !          parameters. A few comments:
      !            * It is safe to leave offset and slope values to zero as
      !              the fit easily find good values from those guesses
      !            * The initial guesses of area and position will anyway
      !              be changed in the solving process. They are present here
      !              for generality
      !            * The area_ratio and width_ratio guesses are quite easy.
      !            * Nevertheless, to obtain a robust fitting, it is mandatory
      !              that the user gives (outside this routine) useful guesses
      !              of the width (probably the beam FWHM) and the beam throw
      !          We have at most 8 parameters to fit. At high SNR, without bias
      !          this will be easy. However, this is rarely the case. Fixing
      !          the value of the area_ratio, beam_throw and width_ratio is a
      !          good way to obtain a robust value of the position (the goal).
      !          Indeed, it is easy to have good guesses for those values. While
      !          it is true that those guesses are not perfect, simulations
      !          show that this gives robust determination of the pointing
      !          error even when the fit looks biased.
      !----------------------------------------------------------------------
      type(point_guess_t), intent(out) :: guess ! User guesses from command line
    end subroutine default_pointing_guess
  end interface
  !
  interface
    subroutine init_pointing(ndat,nsol,psys,pdir,ptype,point,error)
      use point_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine for pointing
      ! Purpose: Free, reallocate and initialize the POINT structure
      !          according to user defined input. Data must be filled
      !          outside
      !----------------------------------------------------------------------
      integer, intent(in) :: ndat             ! Number of data points
      integer, intent(in) :: nsol             ! Number of solution points
      integer, intent(in) :: psys             ! Pointing coordinate system
      character(len=*), intent(in) :: pdir    ! Pointing direction in above system
      character(len=*), intent(in) :: ptype   ! Pointing type (SINGLE|DUAL)
      type(pointing_t), intent(out) :: point  ! Pointing structure
      logical, intent(out) :: error           ! Error flag
    end subroutine init_pointing
  end interface
  !
  interface
    subroutine solve_pointing(point,guess,verbose,error)
      use point_definitions
      use phys_const
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine for pointing
      ! Purpose: Find the first guesses, fit and compute profile of fit
      !          solution. The fit is iterated with position guess every half
      !          FWHM in the x coordinate range. The best fit is then selected.
      !          In real cases, this implies of the order of 20 fits if the width
      !          parameter. This scheme provides a very robust solution.
      !----------------------------------------------------------------------
      type(pointing_t), intent(inout) :: point ! FORTRAN 90 pointing structure
      type(point_guess_t), intent(in) :: guess ! User guesses from command line
      logical, intent(in)  :: verbose          ! Verbose or quiet solving?
      logical, intent(out) :: error            ! Error flag
    end subroutine solve_pointing
  end interface
  !
  interface
    subroutine free_pointing(point)
      use point_definitions
      !----------------------------------------------------------------------
      ! @ public
      ! TELCAL support routine for pointing
      ! Purpose: Free memory associated to the FORTRAN 90 pointing structure
      !----------------------------------------------------------------------
      type(pointing_t), intent(inout) :: point ! FORTRAN 90 pointing structure
    end subroutine free_pointing
  end interface
  !
end module telcal_interfaces_public

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_primitive_prod
  use cubetools_parameters
  use cubelist_types
  use cubesyntax_messaging
  use cubetools_terminal_tool
  !
  public :: primitive_prod_t,prod_k
  public :: cubetools_primitive_prod_ptr
  private
  !
  integer(kind=4), parameter :: prod_k = 4
  integer(kind=4), parameter :: abst_l = 80
  !
  type, extends(list_object_t) :: primitive_prod_t
     integer(kind=prod_k)          :: inum = code_abs       ! Product number in command
     character(len=argu_l)         :: name = strg_unk
     character(len=abst_l)         :: abstract = strg_emp   ! One-line abstract help
     character(len=:), allocatable :: help_strg             ! Long/multiline help
   contains
     ! General
     procedure :: init  => cubetools_primitive_prod_init
     procedure :: final => cubetools_primitive_prod_final
     !
     ! Registering
     procedure :: put   => cubetools_primitive_prod_put
     !
     ! Printing and Help
     procedure :: print_abstract => cubetools_primitive_prod_abstract
     procedure :: summary        => cubetools_primitive_prod_summary
     procedure :: help           => cubetools_primitive_prod_help
  end type primitive_prod_t
  !
contains
  !
  !---General------------------------------------------------------------
  !
  subroutine cubetools_primitive_prod_init(prod,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(out)   :: prod
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_primitive_prod_init
  !
  subroutine cubetools_primitive_prod_final(obj,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(inout) :: obj
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>FINAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_primitive_prod_final
  !
  function cubetools_primitive_prod_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(primitive_prod_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(primitive_prod_t), pointer :: cubetools_primitive_prod_ptr  ! Function value on return
    class(list_object_t), pointer       :: tot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>PTR'
    !
    select type(tot)
    class is (primitive_prod_t)
      cubetools_primitive_prod_ptr => tot
    class default
      cubetools_primitive_prod_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a primitive_prod_t class')
      error = .true.
      return
    end select
  end function cubetools_primitive_prod_ptr
  !
  !---Registering----------------------------------------------------------
  !
  subroutine cubetools_primitive_prod_put(prod,inum,name,abstract,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(inout) :: prod
    integer(kind=prod_k),    intent(in)    :: inum
    character(len=*),        intent(in)    :: name
    character(len=*),        intent(in)    :: abstract
    character(len=*),        intent(in)    :: help
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_primitive_prod_final(prod,error)
    if (error) return
    call cubetools_primitive_prod_init(prod,error)
    if (error) return
    prod%inum      = inum
    prod%name      = name
    prod%abstract  = abstract
    prod%help_strg = help
  end subroutine cubetools_primitive_prod_put
  !
  !---Printing-and-Help--------------------------------------------------
  !
  subroutine cubetools_primitive_prod_abstract(prod,iprod,error)
    use gkernel_interfaces
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(in)    :: prod
    integer(kind=prod_k),    intent(in)    :: iprod
    logical,                 intent(inout) :: error
    !
    character(len=mess_l) :: name,mess
    character(len=*), parameter :: rname='PRODUCT>ABSTRACT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if ((iprod.lt.1).or.(9.lt.iprod)) then
       ! ZZZ Does this makes sense for products?
       call cubesyntax_message(seve%e,rname,'Product number out of authorized range: [1-9]')
       error = .true.
       return
    endif
    name = prod%name
    call sic_upper(name)
    write(mess,'(a1,i1,1x,a)') '#',iprod,trim(name)
    mess = '  '//cubetools_format_stdkey_boldval(mess,prod%abstract,terminal%width())
    call cubesyntax_message(syntaxseve%help,rname,mess)
  end subroutine cubetools_primitive_prod_abstract
  !
  subroutine cubetools_primitive_prod_help(prod,error)
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    ! Print option help from prod%help_strg
    !-------------------------------------------------------------------
    class(primitive_prod_t), intent(in)    :: prod
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>HELP'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    if (.not.allocated(prod%help_strg)) return
    if (len_trim(prod%help_strg).le.0) return
    if (prod%help_strg.eq.strg_emp) return
    !
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    call terminal%print_strg(syntaxseve%help,prod%help_strg)
  end subroutine cubetools_primitive_prod_help
  !
  subroutine cubetools_primitive_prod_summary(prod,error)
    !-------------------------------------------------------------------
    ! Short option summary
    !-------------------------------------------------------------------
    class(primitive_prod_t), intent(in)    :: prod
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>SUMMARY'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    call prod%print_abstract(prod%inum,error)
    if (error) return
    call prod%help(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_primitive_prod_summary
end module cubetools_primitive_prod
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module greg_work
  use gildas_def
  !--------------------------------------------------------------------
  ! Working buffers.
  !--------------------------------------------------------------------
  real(kind=4), allocatable :: xwork(:), ywork(:)  ! Buffers for polyline...
  real(kind=4), allocatable :: xworu(:), yworu(:)  ! Buffers after clipping
end module greg_work
!
subroutine grfill(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>grfill
  use gildas_def
  use sic_types
  use greg_kernel
  use greg_xyz
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command FILL X Y
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='CONNECT'
  integer(kind=size_length) :: ixy
  integer(kind=4) :: form,narg,ncolo
  type(sic_descriptor_t) :: xinca,yinca
  integer(kind=address_length) :: ipx,ipy
  !
  save xinca,yinca
  !
  if (sic_present(2,1)) then
    ! ZZZ documenter
    call gtv_pencol_arg2id(rname,line,2,1,ncolo,error)
    if (error)  return
    call setcol(ncolo)
  endif
  !
  narg = sic_narg(0)
  if (narg.eq.0 .or. narg.eq.2) then
    form = 0
    call get_incarnation('FILL',line,form,ixy,xinca,yinca,error)
    if (error) return
    ipx = gag_pointer(xinca%addr,memory)
    ipy = gag_pointer(yinca%addr,memory)
    if (form.eq.fmt_r8) then
      call gr8_ufill(ixy,memory(ipx),memory(ipy))
    else
      call gr4_ufill(ixy,memory(ipx),memory(ipy))
    endif
    call sic_volatile(xinca)
    call sic_volatile(yinca)
  endif
end subroutine grfill
!
subroutine gr4_ufill(nxy,x,y)
  use gildas_def
  use greg_interfaces
  use greg_work
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! GREG Library routine
  !  Connect a Filled polyline (No BLANKING...)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy     ! Number of data points
  real(kind=4),              intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=4),              intent(in) :: y(nxy)  ! Array of Y coordinates
  ! Local
  integer(kind=size_length) :: np
  logical :: error
  !
  if (nxy.lt.2) return
  !
  error = .false.
  call reallocate_poly_buffers(nxy,error)
  if (error)  return
  !
  call us4_to_int(x,y,xwork,ywork,nxy)
  np = nxy+1
  xwork(np) = xwork(1)
  ywork(np) = ywork(1)
  call clip_poly(np,xwork,ywork,xworu,yworu)
  call gr_fillpoly(np,xworu,yworu)
end subroutine gr4_ufill
!
subroutine gr8_ufill(nxy,x,y)
  use gildas_def
  use greg_interfaces
  use greg_work
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! GREG Library routine
  !  Connect a Filled polyline (No BLANKING...)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy     ! Number of data points
  real(kind=8),              intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=8),              intent(in) :: y(nxy)  ! Array of Y coordinates
  ! Local
  integer(kind=size_length) :: np
  logical :: error
  !
  if (nxy.lt.2) return
  !
  error = .false.
  call reallocate_poly_buffers(nxy,error)
  if (error)  return
  !
  call us8_to_int(x,y,xwork,ywork,nxy)
  np = nxy+1
  xwork(np) = xwork(1)
  ywork(np) = ywork(1)
  call clip_poly(np,xwork,ywork,xworu,yworu)
  call gr_fillpoly(np,xworu,yworu)
end subroutine gr8_ufill
!
subroutine gr_fillpoly(n,x,y)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_fillpoly
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: n     !
  real(kind=4),              intent(in) :: x(*)  !
  real(kind=4),              intent(in) :: y(*)  !
  ! Local
  integer(kind=4) :: n4
  logical :: error
  !
  n4 = int(n,kind=4)
  error = .false.
  call gtv_fillpoly(n4,x,y,.false.,error)
end subroutine gr_fillpoly
!
subroutine parse_polygon_drawing(rname,line,optfill,opthatch,drawing,error)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>parse_polygon_drawing
  use greg_types
  use greg_pen
  !---------------------------------------------------------------------
  ! @ private
  ! Parse the following options in the command line:
  !   /FILL [Icolor]
  !   /HATCH [Ipen] [Angle] [Separ] [Phase]
  ! Defaults for the arguments are defined here.
  !---------------------------------------------------------------------
  character(len=*),        intent(in)    :: rname     !
  character(len=*),        intent(in)    :: line      !
  integer(kind=4),         intent(in)    :: optfill   ! Number of option /FILL
  integer(kind=4),         intent(in)    :: opthatch  ! Number of option /HATCH
  type(polygon_drawing_t), intent(out)   :: drawing   !
  logical,                 intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=message_length) :: mess
  !
  ! Contour (not parsed here)
  drawing%contoured = .false.
  call inqpen(drawing%cpen)  ! Default, even if not used
  !
  ! /FILL
  drawing%filled = sic_present(optfill,0)
  if (drawing%filled) then
    if (sic_present(optfill,1)) then
      call gtv_pencol_arg2id(rname,line,optfill,1,drawing%fcolor,error)
      if (error) return
    else
      call inqcol(drawing%fcolor)
    endif
  endif
  !
  ! /HATCH
  drawing%hatched = sic_present(opthatch,0)
  if (drawing%hatched) then
    call inqpen(drawing%hpen)
    call sic_i4(line,opthatch,1,drawing%hpen,.false.,error)
    if (error) return
    if (drawing%hpen.lt.0 .or. drawing%hpen.gt.maxpen) then
      write(mess,'(A,I0,A,I0)')  'Pen number ',drawing%hpen,' out of range 0-',maxpen
      call greg_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    drawing%hangle = 45.  ! Degrees
    call sic_r4(line,opthatch,2,drawing%hangle,.false.,error)
    if (error) return
    drawing%hangle = drawing%hangle*rad_per_deg  ! Radians
    !
    drawing%hsepar = .25  ! Physical units (cm)
    call sic_r4(line,opthatch,3,drawing%hsepar,.false.,error)
    if (error) return
    !
    drawing%hphase = .0  ! 0. to 1.
    call sic_r4(line,opthatch,4,drawing%hphase,.false.,error)
    if (error) return
    drawing%hphase = modulo(drawing%hphase,1.)  ! Between 0. to 1.
  endif
  !
end subroutine parse_polygon_drawing
!
subroutine reallocate_poly_buffers(npts,error)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_work
  !---------------------------------------------------------------------
  ! @ private
  ! 'npts' is the number of points of the input polygon
  ! This subroutine will allocate:
  ! - npts+1 values (so that the caller can close the polygon) for the
  !   unclipped buffer.
  ! - clipping buffer: npts*3/2+1, because clipping may add more
  !   summits, and this is the worst case.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: npts
  logical,                   intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  !
  alloc = .not.allocated(xwork)  ! Allocate if not yet allocated
  if (.not.alloc) then
    alloc = npts.gt.size(xwork)  ! Allocate of not large enough
    if (alloc)  deallocate(xwork,ywork,xworu,yworu)
  endif
  if (.not.alloc)  return  ! Nothing to do if large enough
  !
  allocate(xwork(npts+1),    ywork(npts+1),  &
           xworu(npts*3/2+1),yworu(npts*3/2+1),stat=ier)
  if (failed_allocate('POLY','buffers',ier,error))  return
  !
end subroutine reallocate_poly_buffers

subroutine clic_mask(line,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! CLIC	Command CLIC\MASK f1 f2 ... [/ANTENNA] [/BASELINE] [/RESET]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_flags.inc'
  ! Local
  integer :: i, j, am(mnant), bm(mnbas)
  logical :: sam(2*mbands,mnant), sbm(2*mbands,mnbas)
  logical :: reset
  character(len=1024) :: out
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  if (sic_narg(0).le.0.and.sic_narg(4).lt.0.and.sic_narg(5).lt.0) then
    call list_flags(mnant,mnbas,ant_mask,bas_mask,san_mask,sba_mask,out)
    call message(6,1,'CLIC_MASK','Masked '//out(1:lenc(out)))
    return
  endif
  call get_flags(line,1,1,2,3,4,5,am,bm,sam,sbm,reset,error)
  if (error) return
  do i=1, mnant
    if (am(i).ne.0) then
      if (reset) then
        ant_mask(i) = iand(ant_mask(i),not(am(i)))
      else
        ant_mask(i) = ior(ant_mask(i),am(i))
      endif
    endif
    do j=1, 2*mbands
      if (sam(j,i)) then
        if (reset) then
          san_mask(j,i) = .false.
        else
          san_mask(j,i) = .true.
        endif
      endif
    enddo
  enddo
  do i=1, mnbas
    if (bm(i).ne.0) then
      if (reset) then
        bas_mask(i) = iand(bas_mask(i),not(bm(i)))
      else
        bas_mask(i) = ior(bas_mask(i),bm(i))
      endif
    endif
    do j=1, 2*mbands
      if (sbm(j,i)) then
        if (reset) then
          sba_mask(j,i) = .false.
        else
          sba_mask(j,i) = .true.
        endif
      endif
    enddo
  enddo
  call list_flags(mnant,mnbas,ant_mask,bas_mask,san_mask,sba_mask,out)
  call message(6,1,'CLIC_MASK','Masked - '//out(1:lenc(out)))
  !
  return
end subroutine clic_mask

subroutine midgauss(obs,fit,ifatal,liter)
  use gildas_def
  use gbl_message
  use fit_minuit
  use classfit_dependencies_interfaces
  use classfit_interfaces, except_this=>midgauss
  use class_types
  use gauss_parameter
  !----------------------------------------------------------------------
  ! @ private
  !  Start a gaussian fit by building the PAR array and internal variable
  ! used by Minuit
  !----------------------------------------------------------------------
  type(observation),  intent(in)    :: obs    !
  type(fit_minuit_t), intent(inout) :: fit    ! Fitting variables
  integer(kind=4),    intent(out)   :: ifatal ! Number of fatal errors
  logical,            intent(in)    :: liter  ! Iterate a fit
  ! Local
  character(len=*), parameter :: rname='MIDGAUSS'
  integer(kind=4) :: i,ninte,k,j
  real(kind=4) :: ymax,ymin,aire,vsup,vinf,yy
  real(kind=8) :: sav,sav2,vplu,vminu
  character(len=80) :: mess
  !
  fit%isw(1:7) = 0
  fit%sigma  = 0.d0
  fit%npfix  = 0
  ninte  = 0
  fit%nu     = 0
  fit%npar   = 0
  ifatal = 0
  fit%u(1:fit%maxext)      = 0.0d0
  fit%lcode(1:fit%maxext)  = 0
  fit%lcorsp(1:fit%maxext) = 0
  fit%isw(5) = 1
  fit%data = locwrd(obs)
  !
  ! Starting values
  !
  if (nline.eq.0) then
     !
     ! Automatic guess if NLINE = 0
     ymax=0.
     ymin=0.
     aire=0.
     do i=obs%cimin+1,obs%cimax-1
        if (wfit(i).ne.0) then
           yy = ( obs%spectre(i) + wfit(i-1)*obs%spectre(i-1) +   &
                wfit(i+1)*obs%spectre(i+1) ) / (1+wfit(i-1)+wfit(i+1))
           if (yy.ge.ymax) then
              ymax = yy
              vsup = obs%datax(i)
           endif
           if (yy.le.ymin) then
              ymin = yy
              vinf = obs%datax(i)
           endif
           aire=aire+yy*abs((obs%datax(i+1)-obs%datax(i-1)))
        endif
     enddo
     aire = aire*0.5
     if (abs(ymin).lt.abs(ymax)) then
        par(2)=vsup
        par(1)=ymax
     else
        par(2)=vinf
        par(1)=ymin
     endif
     par(3)=abs(aire/par(1)/1.064467)
     par(1)=aire
     fit%nu=3
  else
     !
     ! Take initial guesses in SPAR
     fit%nu=3*nline
     j=1
     do i=1,nline
        !
        ! That is quite tricky, since the area is the product of the original
        ! intensity by the width. But for dependant gaussian, it is more subtle
        if (kt(i).eq.3) then
           par(j) = spar(j)
        elseif (kd(i).eq.3) then
           par(j) = spar(j)*spar(j+2)*1.064467    ! Area
           par(j) = par(j)*spar(3*kd0)    !
        else
           par(j) = spar(j)*spar(j+2)*1.064467    ! Area=amp*fwhm*sqrt(2pi/8log2)
        endif
        par(j+1) = spar(j+1)     ! Position
        par(j+2) = spar(j+2)     ! FWHM
        j=j+3
     enddo
  endif
  !
  ! Type initial guesses
  fit%nu=fit%nu+3
  call class_message(seve%i,rname,'Input Parameters:  Area Position Fwhm')
  k = 1
  do i=1,max(nline,1)
     write (mess,1002) par(k),par(k+1),par(k+2)
     call class_message(seve%i,rname,mess)
     k=k+3
  enddo
  !
  ! Set up Parameters for Major Variables
  !
  ! Velocities
  if (kv0.eq.0) then
     ! No reference velocity
     fit%u(2)=0.     ! Velocity offset set to 0
     fit%werr(2)=0.  ! Velocity offset not minimized
  else
     ! There is a reference velocity
     fit%u(2)=par(3*kv0-1)  ! Fetch its value
     if (kv(kv0).eq.4) then
        fit%werr(2)=0.  ! The reference velocity is fixed
     else
        fit%werr(2)=deltav  ! This reference velocity is variable
        if (liter.and.err(3*kv0-1).ne.0) fit%werr(2)=err(3*kv0-1)
        fit%alim(2)=fit%u(2)-0.15*obs%cnchan*deltav
        fit%blim(2)=fit%u(2)+0.15*obs%cnchan*deltav
     endif
  endif
  !
  ! Line Widths
  if (kd0.eq.0) then
     ! No reference line width
     fit%u(3)=1./1.665109  ! Line width set to 1/(2*SQRT(LN(2))) (factorize this factor out of the minimization)
     fit%werr(3)=0.        ! This factor is a parameter (i.e. not minimized)
  else
     ! There is a reference line width
     fit%u(3)=abs(par(3*kd0))/1.665109  ! Fetch its value (with factor)
     if (kd(kd0).eq.4) then
        fit%werr(3)=0.  ! The reference line width is fixed
     else
        fit%werr(3)=deltav  ! The reference line width is variable
        if (liter.and.err(3*kd0).ne.0) fit%werr(3)=err(3*kd0)
        fit%alim(3)=0.25*deltav
        fit%blim(3)=0.75*obs%cnchan*deltav
     endif
  endif
  !
  ! Areas
  if (kt0.eq.0) then
     ! No reference area
     fit%u(1)=0.564189584 ! Area set to 1/SQRT(PI) (factorize this factor out of the minimization
     fit%werr(1)=0.       ! This factor is a parameter (i.e. not minimized)
  else
     ! There is a reference area
     fit%u(1)=par(3*kt0-2)  ! Fetch its value
     if (kt(kt0).eq.4) then
        fit%werr(1)=0.  ! The reference area is fixed
     else
        fit%werr(1)=sigbas*deltav  ! The reference area is variable
        if (liter.and.err(3*kt0-2).ne.0) fit%werr(1)=err(3*kt0-2)
        if (fit%u(1).ne.0.) then
           fit%alim(1)=dmin1(0.d0,10*fit%u(1))
           fit%blim(1)=dmax1(0.d0,10*fit%u(1))
        else
           fit%lcode(1)=1
        endif
     endif
  endif
  !
  ! Set up parameters for Secondary Variables
  !
  k=4
  do i=1,max(nline,1)
     ! Area
     fit%u(k)=par(k-3)
     if (kt(i).eq.0 .or. nline.eq.0) then
        fit%werr(k)  =  max(sigbas,sigrai)*deltav
        if (liter.and.err(k-3).ne.0) fit%werr(k)=err(k-3)
        if (fit%u(k).ne.0.) then
           fit%alim(k)=dmin1(0.d0,10*fit%u(k))
           fit%blim(k)=dmax1(0.d0,10*fit%u(k))
        else
           fit%lcode(k)=1             ! No Boundaries if fit%u(k)=0.
        endif
     else
        fit%werr(k)=0.
        if (i.eq.kt0) then
           fit%u(k)=0.564189584
        else
           fit%u(k)=fit%u(k)*0.564189584
        endif
     endif
     k=k+1
     !
     ! Velocity
     fit%u(k)=par(k-3)
     if (kv(i).eq.0 .or. nline.eq.0) then
        fit%werr(k)=deltav
        if (liter.and.err(k-3).ne.0) fit%werr(k)=err(k-3)
        fit%alim(k)=fit%u(k)-0.15*obs%cnchan*deltav
        fit%blim(k)=fit%u(k)+0.15*obs%cnchan*deltav
     else
        fit%werr(k)=0.
        if (i.eq.kv0) fit%u(k)=0.
     endif
     k=k+1
     !
     ! Line Width
     fit%u(k)=abs(par(k-3))
     if (kd(i).eq.0 .or. nline.eq.0) then
        fit%werr(k)=deltav
        if (liter.and.err(k-3).ne.0) fit%werr(k)=err(k-3)
        fit%alim(k)=deltav
        fit%blim(k)=0.75*obs%cnchan*deltav
     else
        fit%werr(k)=0.
        if (i.eq.kd0) fit%u(k)=1.
     endif
     k=k+1
  enddo
  !
  ! Various checks
  do k= 1, fit%nu
     if (k .gt. fit%maxext) then
        ifatal = ifatal+1
     else if (fit%werr(k).le.0.d0) then
        ! Fixed parameter
        fit%lcode(k) = 0
        if (k.gt.3) then
           write(mess,'(a,i3,a)') "Parameter",k-3," is fixed"
           call class_message(seve%w,rname,mess)
        endif
     else
        ! Variable parameter
        ninte = ninte + 1
        ! Parameter with limits
        if (fit%lcode(k).ne.1) then
           fit%lcode(k) = 4
           sav = (fit%blim(k)-fit%u(k))*(fit%u(k)-fit%alim(k))
           if (sav.lt.0d0) then
              ifatal = ifatal + 1
              write(mess,'(a,i0,3(a,f0.3))')  &
                'Parameter #',k-3,' (',fit%u(k),') outside limits ',fit%alim(k),' to ',fit%blim(k)
              call class_message(seve%e,rname,mess)
           else if (sav.eq.0d0) then
              if (k.gt.3) then
                 write(mess,'(a,i3,a)') "Parameter",k-3," is at limit"
                 call class_message(seve%w,rname,mess)
              endif
           endif
        endif
     endif
  enddo
  !
  ! End parameter cards
  ! Stop if fatal error
  if (ninte .gt. fit%maxint)  then
     write(mess,1008) ninte,fit%maxint
     call class_message(seve%e,rname,mess)
     ifatal = ifatal + 1
  endif
  if (ninte .eq. 0) then
     call class_message(seve%i,rname,'All input parameters are fixed')
     ifatal = ifatal + 1
  endif
  if (ifatal.gt.0)  then
    write(mess,'(I0,A)')  ifatal,' errors on input parameters, abort.'
    call class_message(seve%e,rname,mess)
    return
  endif
  !
  ! O.K. Start
  ! Calculate step sizes DIRIN
  fit%npar = 0
  do k= 1, fit%nu
     if (fit%lcode(k) .gt. 0)  then
        fit%npar = fit%npar + 1
        fit%lcorsp(k) = fit%npar
        sav = fit%u(k)
        fit%x(fit%npar) = pintf(fit,sav,k)
        fit%xt(fit%npar) = fit%x(fit%npar)
        sav2 = sav + fit%werr(k)
        vplu = pintf(fit,sav2,k) - fit%x(fit%npar)
        sav2 = sav - fit%werr(k)
        vminu = pintf(fit,sav2,k) - fit%x(fit%npar)
        fit%dirin(fit%npar) = 0.5d0 * (dabs(vplu) +dabs(vminu))
     endif
  enddo
  return
  !
1002 format((3(1pg10.3)))
1008 format (' Too many variable parameters.  You request ',i5/,   &
       &    ' This version of MINUIT is only dimensioned for ',i4)
end subroutine midgauss

module cubecdf_image_utils
  use cubecdf_messaging
  use cubecdf_header
  !---------------------------------------------------------------------
  ! Support module for CDF 'images' (e.g. 2D images or 3D cubes)
  !---------------------------------------------------------------------

  public :: cubecdf_image_subset,cubecdf_image_close
  private

contains

  subroutine cubecdf_image_subset(hcdf,iblc,itrc,nelem_new,error)
    use cubetools_parameters
    !-------------------------------------------------------------------
    ! Convert a [BLC:TRC] range (multidimensional) into proper arguments
    ! for FTGSF* subroutines (i.e. I*4 arguments).
    !-------------------------------------------------------------------
    type(cdf_header_t),          intent(in)    :: hcdf
    integer(kind=index_length),  intent(in)    :: iblc(maxdim)
    integer(kind=index_length),  intent(in)    :: itrc(maxdim)
    integer(kind=size_length),   intent(out)   :: nelem_new
    logical,                     intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMAGE>SUBSET'
    integer(kind=4) :: ndim,idime,ier
    integer(kind=index_length) :: blc(maxdim),trc(maxdim),first,last
    integer(kind=size_length) :: nelements
    !
    ! Sanity
    if (any(hcdf%dim.gt.huge(1_4))) then
      call cubecdf_message(seve%e,rname,  &
        'Not implemented: one dimension is larger than 2**31')
      error = .true.
      return
    endif
    if (any(itrc.gt.huge(1_4))) then
      call cubecdf_message(seve%e,rname,  &
        'Not implemented: extracting more than 2**31 values in one dimension')
      error = .true.
      return
    endif
    !
    ! Convert automatic BLC/TRC
    blc(:) = iblc(:)
    trc(:) = itrc(:)
    do idime=1,hcdf%ndim
      if (iblc(idime).eq.0)  blc(idime) = 1
      if (itrc(idime).eq.0)  trc(idime) = hcdf%dim(idime)
    enddo
    !
    ! Sanity check: BLC/TRC should not request non-contiguous subsets
    ! 1) find last non-degenerate dimension
    ndim = 1
    do idime=hcdf%ndim,1,-1
      if (hcdf%dim(idime).gt.1) then
        ndim = idime
        exit
      endif
    enddo
    ! 2) check all but last dimension are completely used
    do idime=1,ndim-1
      if (blc(idime).ne.1 .or. trc(idime).ne.hcdf%dim(idime)) then
        ! NB: see CFITSIO subroutine FTPSSE to write non-contiguous subsets
        call cubecdf_message(seve%e,rname,  &
          'Not implemented: reading or writing a non-contiguous subset on first dimensions')
        error = .true.
        return
      endif
    enddo
    !
    ! Compute first record number and number of elements to write
    nelements = 1
    do idime=1,ndim-1
      nelements = nelements*hcdf%dim(idime)
    enddo
    first = blc(ndim)
    last = trc(ndim)
    !
    ! Note: we could use FSEEK to force going to the right position.
    ! But our use case is always (?) to read or write contiguously.
    if (first.eq.1) then
      call cubecdf_message(seve%d,rname,'Rewinding file')
      rewind(unit=hcdf%unit,iostat=ier)
      if (ier.ne.0) then
        call cubecdf_message(seve%e,rname,'Rewind error')
        error = .true.
        return
      endif
    endif
    !
    nelem_new = (last-first+1)*nelements
  end subroutine cubecdf_image_subset

  subroutine cubecdf_image_close(hcdf,error)
    !-------------------------------------------------------------------
    ! Close the currently opened image
    !-------------------------------------------------------------------
    type(cdf_header_t), intent(inout) :: hcdf
    logical,            intent(inout) :: error
    !
    call hcdf%close(error)
    if (error)  return
  end subroutine cubecdf_image_close

end module cubecdf_image_utils

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_support_tool
  use gbl_message
  use gkernel_types, only: polygon_t,varname_length
  !------------------------------------------------------------------------
  ! CLEAN\SUPPORT polygon, mapped on SUPPORT%
  !------------------------------------------------------------------------
  !
  public :: mask_clean,check_mask,get_maskplane,lmask_to_list
  !
  public :: supportpol,support_type
  public :: support_mask,support_poly,support_none
  public :: supportvar
  public :: clean_support
  private
  !
  integer, parameter :: support_mask = 1 
  integer, parameter :: support_poly = -1
  integer, parameter :: support_none = 0
  character(len=varname_length), parameter :: supportvar='SUPPORT'
  !
  integer, save :: support_type  
  type(polygon_t), save :: supportpol
  !
  type support_user_t
   contains
     procedure, public :: init   => clean_support_user_init
     procedure, public :: sicdef => clean_support_user_sicdef
  end type support_user_t
  type (support_user_t) :: clean_support
  !
contains
  !
  subroutine clean_support_user_init(user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(support_user_t), intent(out)   :: user
    logical,               intent(inout) :: error
    !
    ! Placeholder => Do nothing for the moment
  end subroutine clean_support_user_init
  !
  subroutine clean_support_user_sicdef(user,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(support_user_t), intent(inout) :: user
    logical,               intent(inout) :: error
    !
    call sic_defstructure(supportvar,.true.,error)
    if (error) return
  end subroutine clean_support_user_sicdef
  !
  !***JP: Unclear whether the mask-related routines should be in this module!
  !
  subroutine mask_clean(head,mask,data,raw,smo,length,margin,error) 
    use phys_const
    use image_def
    use gkernel_interfaces
    use mapping_gaussian_tool
    !----------------------------------------------------------------
    ! Build a Mask from a Threshold and Smoothing 
    !----------------------------------------------------------------
    type(gildas), intent(inout) :: head
    real, target, intent(out)   :: mask(head%gil%dim(1),head%gil%dim(2),head%gil%dim(3))
    real,         intent(in)    :: data (head%gil%dim(1),head%gil%dim(2),head%gil%dim(3))
    real,         intent(in)    :: raw
    real,         intent(in)    :: smo
    real,         intent(in)    :: length
    real,         intent(in)    :: margin
    logical,      intent(inout) :: error
    !
    integer :: nx,ny,nc,ix,iy,ic,jx,jy,ndim,dim(2),ier
    real :: xinc, yinc,fact
    real, allocatable :: wfft(:)
    real, pointer :: tmp(:,:)
    complex, allocatable :: ft(:,:)
    character(len=message_length) :: chain
    character(len=*), parameter :: rname='SUPPORT'
    !
    nx = head%gil%dim(1)
    ny = head%gil%dim(2)
    nc = head%gil%dim(3)
    allocate (wfft(2*max(nx,ny)),ft(nx,ny),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error in MASK_CLEAN')
       error = .true.
       return
    endif
    xinc = head%gil%convert(3,1)
    yinc = head%gil%convert(3,2)
    !
    dim(1) = nx
    dim(2) = ny
    ndim = 2
    jy = margin*ny
    jx = margin*nx
    !
    write(chain,'(A,1PG10.2,1PG10.2,A,0PF8.2,A,F6.2)') 'Threshold',raw,smo, &
         & ',  Smoothing ',length*180.*3600./pi,'", guard band ',margin
    call map_message(seve%i,rname,chain)
    !
    do ic=1,nc
       tmp => mask(:,:,ic)
       !
       ! Guard band of 1/8th of the image size on each edge to
       ! avoid aliased sidelobes
       tmp = 0.0
       if (head%gil%eval.ge.0.0) then
          do iy=jy+1,ny-jy
             do ix=jx+1,nx-jx
                if (abs(data(ix,iy,ic)-head%gil%bval).gt.head%gil%eval) then
                   if (data(ix,iy,ic).ge.raw) tmp(ix,iy) = data(ix,iy,ic)
                endif
             enddo
          enddo
       else
          do iy=jy+1,ny-jy
             do ix=jx+1,nx-jx
                if (data(ix,iy,ic).ge.raw) tmp(ix,iy) = data(ix,iy,ic)
             enddo
          enddo
       endif
       ft(:,:) = cmplx(tmp,0.0)
       !
       call fourt(ft,dim,ndim,-1,0,wfft)
       !
       ! Correct for Beam Area for flux density normalisation
       fact = length**2*pi/(4.0*log(2.0))/abs(xinc*yinc)/(nx*ny)
       call mulgau(ft,nx,ny,&
            length,length,0.0,&
            fact,xinc,yinc)
       call fourt(ft,dim,ndim,1,1,wfft)
       !
       ! Extract Real part
       tmp(:,:) = real(ft)
       where (tmp.lt.smo) tmp = 0.0
    enddo
    deallocate (wfft,ft)
  end subroutine mask_clean  
  !
  subroutine no_check_mask(method,head)
    use image_def
    use clean_types
    !--------------------------------------------------------------
    ! Do not check that the search mask is defined
    !--------------------------------------------------------------
    type(gildas),    intent(in)    :: head
    type(clean_par), intent(inout) :: method
    !
    print *,'Called check_mask'
  end subroutine no_check_mask
  !
  subroutine check_mask(amethod,head)
    use image_def
    use clean_types
    use clean_buffers
    !--------------------------------------------------------------
    ! Check that the search mask is defined
    !--------------------------------------------------------------
    type(gildas),    intent(in)    :: head
    type(clean_par), intent(inout) :: amethod
    !
    integer, save :: last_box(4) !***JP: Why save here?
    integer :: nx,ny
    character(len=10) :: rname='CHECK_MASK'
    !
    nx = head%gil%dim(1)
    ny = head%gil%dim(2)
    if (amethod%do_mask) then
       if (support_type.eq.support_mask) then
          if (mask%head%gil%dim(1).ne.nx .or. mask%head%gil%dim(2).ne.ny) then
             call map_message(seve%w,rname,'Mask size differ')
          endif
          !
          ! Setup the Logical mask from the Real mask and its bounding box
          call get_lmask (mask%head,mask%data(:,:,1),head,d_mask,amethod%box)
          call lmask_to_list(d_mask,nx*ny,d_list,amethod%nlist)
          amethod%imask = 1
       else
          ! Compute the logical mask from the bounding polygon
          call gr8_glmsk(supportpol,d_mask,nx,ny,&
               head%gil%convert(1,1),head%gil%convert(1,2),amethod%box)
          call lmask_to_list(d_mask,nx*ny,d_list,amethod%nlist)
          amethod%imask = -1
       endif
       amethod%do_mask = .false.
       last_box = amethod%box
    else
       amethod%box = last_box
    endif
  end subroutine check_mask
  !
  subroutine get_maskplane(amethod,hmask,hdirty,mask,list)
    use image_def
    use clean_types
    !----------------------------------------------------------------
    ! Define beam plane and check if fit is required
    !----------------------------------------------------------------
    type (clean_par), intent(inout) :: amethod
    type (gildas),    intent(in)    :: hmask
    type (gildas),    intent(in)    :: hdirty ! Used to figure out which plane
    logical,          intent(inout) :: mask(:,:)
    integer,          intent(inout) :: list(:)
    !
    integer :: iplane, nxy
    real(8) :: i_freq
    !
    ! Check if beam parameters must be recomputed
    if (support_type.ne.support_mask) return
    !
    if (hmask%gil%dim(3).le.1) then
       !!print *,'Only one mask Plane '
       amethod%imask = 1
       return ! 
    else 
       i_freq = (amethod%iplane-hdirty%gil%ref(3))*hdirty%gil%fres + hdirty%gil%freq
       iplane = nint((i_freq-hmask%gil%freq)/hmask%gil%fres + hmask%gil%ref(3))
       iplane = min(max(1,iplane),hmask%gil%dim(3)) ! Just  in case
       !!print *,'IPLANE ',iplane,' IMASK ',method%imask
       !
       ! Should also work in OMP mode...
       if (amethod%imask.ne.iplane) then
          !
          ! Optimize: only re-define if needed...
          nxy = hdirty%gil%dim(1)*hdirty%gil%dim(2)
          call get_lmask (hmask,hmask%r3d(:,:,iplane),hdirty,mask,amethod%box)
          call lmask_to_list(mask,nxy,list,amethod%nlist)
          amethod%imask = iplane
       endif
    endif
  end subroutine get_maskplane
  !
  subroutine get_rlist(rmsk,nx,ny,box,list,nl)
    !---------------------------------------------------------------------
    ! Return a LOGICAL mask from the a (0 - non zero) mask, and also
    ! compute its boundaries
    !---------------------------------------------------------------------
    integer,      intent(in)  :: nx          ! X size
    integer,      intent(in)  :: ny          ! Y size
    real(kind=4), intent(in)  :: rmsk(nx,ny) ! Real mask
    integer,      intent(out) :: box(4)      ! Mask Boundary
    integer,      intent(out) :: list(nx*ny) ! List of pixels in mask
    integer,      intent(out) :: nl
    !
    integer :: i,j,k,l
    !
    box(1) = nx
    box(2) = ny
    box(3) = 1
    box(4) = 1
    !
    l = 0
    k = 0
    do j=1,ny
       do i=1,nx
          k = k+1
          if (rmsk(i,j).ne.0) then
             box(1) = min(i,box(1))
             box(2) = min(j,box(2))
             box(3) = max(i,box(3))
             box(4) = max(j,box(4))
             l = l+1
             list(l) = k
          endif
       enddo
    enddo
    nl = l
  end subroutine get_rlist
  !
  subroutine gr4_slmsk (rmsk,lmsk,nx,ny,box)
    !---------------------------------------------------------------------
    ! Return a LOGICAL mask from the a (0 - non zero) mask, and also
    ! compute its boundaries
    !---------------------------------------------------------------------
    integer,      intent(in)  :: nx          ! X size
    integer,      intent(in)  :: ny          ! Y size
    real(kind=4), intent(in)  :: rmsk(nx,ny) ! Real mask
    logical,      intent(out) :: lmsk(nx,ny) ! Logical mask
    integer,      intent(out) :: box(4)      ! Mask boundary (xblc,yblc,xtrc,ytrc)
    !
    integer :: i,j
    !
    box(1) = nx
    box(2) = ny
    box(3) = 1
    box(4) = 1
    !
    do j=1,ny
       do i=1,nx
          if (rmsk(i,j).ne.0) then
             lmsk(i,j) = .true.
             box(1) = min(i,box(1))
             box(2) = min(j,box(2))
             box(3) = max(i,box(3))
             box(4) = max(j,box(4))
          else
             lmsk(i,j) = .false.
          endif
       enddo
    enddo
  end subroutine gr4_slmsk
  !
  subroutine get_lmask(hmask,rmask,hmap,lmask,box)
    use image_def
    !---------------------------------------------------------------------
    ! Return a LOGICAL mask from the a (0 - non zero) mask, and also compute
    ! its boundaries
    !---------------------------------------------------------------------
    type(gildas), intent(in)  :: hmask      ! Mask header
    type(gildas), intent(in)  :: hmap       ! Map header  
    real(kind=4), intent(in)  :: rmask(:,:) ! Real mask
    logical,      intent(out) :: lmask(:,:) ! Logical mask
    integer,      intent(out) :: box(4)     ! Mask boundary (xblc,yblc,xtrc,ytrc)
    !
    integer :: i,j,ier
    integer :: nx,ny
    integer, allocatable :: im(:),jm(:) ! Pixels in mask matching image pixels
    real(kind=8) :: r
    !
    nx = hmap%gil%dim(1)
    ny = hmap%gil%dim(2)
    !
    allocate(im(nx),jm(ny),stat=ier)
    !
    do i=1,nx
       r = (i-hmap%gil%ref(1))*hmap%gil%inc(1) + hmap%gil%val(1)
       im(i) = (r-hmask%gil%val(1))/hmask%gil%inc(1) + hmask%gil%ref(1)
       im(i) = max(1,im(i))
       im(i) = min(hmask%gil%dim(1),im(i))
    enddo
    !
    do i=1,ny
       r = (i-hmap%gil%ref(2))*hmap%gil%inc(2) + hmap%gil%val(2)
       jm(i) = (r-hmask%gil%val(2))/hmask%gil%inc(2) + hmask%gil%ref(2)
       jm(i) = max(1,jm(i))
       jm(i) = min(hmask%gil%dim(2),jm(i))
    enddo
    !
    box(1) = nx
    box(2) = ny
    box(3) = 1
    box(4) = 1
    !
    do j=1,ny
       do i=1,nx
          if (rmask(im(i),jm(j)).ne.0) then
             lmask(i,j) = .true.
             box(1) = min(i,box(1))
             box(2) = min(j,box(2))
             box(3) = max(i,box(3))
             box(4) = max(j,box(4))
          else
             lmask(i,j) = .false.
          endif
       enddo
    enddo
    deallocate(im,jm)
  end subroutine get_lmask
  !
  subroutine lmask_to_list(lmask,m,list,n)
    !---------------------------------------------------
    ! Get list of positions from a Logical mask.
    !---------------------------------------------------
    integer, intent(in)  :: m        ! Number of entries
    logical, intent(in)  :: lmask(m) ! Mask values
    integer, intent(out) :: n        ! Number of TRUE values
    integer, intent(out) :: list(m)  ! Position of entries 
    ! 
    integer :: i,j
    !
    j = 0
    do i=1,m
       if (lmask(i)) then
          j = j+1
          list(j) = i
       endif
    enddo
    n = j
    do i=n+1,m
       list(i) = 0
    enddo
  end subroutine lmask_to_list
  !
  !***JP: The following ones are unused. Keep them for reference.
  !
!!$  !
!!$  subroutine rmask_to_list(rmask,m,list,n)
!!$    !---------------------------------------------------
!!$    ! Get list of positions from a Real mask.
!!$    !---------------------------------------------------
!!$    integer, intent(in)  :: m        ! Number of entries
!!$    real,    intent(in)  :: rmask(m) ! Mask values
!!$    integer, intent(out) :: n        ! Number of TRUE values
!!$    integer, intent(out) :: list(m)  ! Position of entries 
!!$    ! 
!!$    integer :: i,j
!!$    !
!!$    j = 0
!!$    do i=1,m
!!$       if (rmask(i).gt.0) then
!!$          j = j+1
!!$          list(j) = i
!!$       endif
!!$    enddo
!!$    n = j
!!$    do i=n+1,m
!!$       list(i) = 0
!!$    enddo
!!$  end subroutine rmask_to_list
!!$  !
!!$  subroutine get_listsize (mask,m,n)
!!$    !---------------------------------------------------
!!$    ! Count number of TRUE values
!!$    !---------------------------------------------------
!!$    integer, intent(in)  :: m       ! Number of entries
!!$    integer, intent(out) :: n       ! Number of TRUE values
!!$    logical, intent(in)  :: mask(m) ! Mask values
!!$    !
!!$    integer :: i
!!$    !
!!$    n = 0
!!$    do i=1,m
!!$       if (mask(i)) n = n+1
!!$    enddo
!!$  end subroutine get_listsize
!!$  !
!!$  subroutine get_listindex(mask,m,list,n)
!!$    !---------------------------------------------------
!!$    ! Get list of positions in mask.
!!$    !---------------------------------------------------
!!$    integer, intent(in)  :: m       ! Number of entries
!!$    integer, intent(in)  :: n       ! Number of TRUE values
!!$    logical, intent(in)  :: mask(m) ! Mask values
!!$    integer, intent(out) :: list(n) ! Position of entries 
!!$    ! 
!!$    integer :: i,j
!!$    !
!!$    j = 0
!!$    do i=1,m
!!$       if (mask(i)) then
!!$          j = j+1
!!$          list(j) = i
!!$       endif
!!$    enddo
!!$    do i=j+1,n
!!$       list(i) = 0
!!$    enddo
!!$  end subroutine get_listindex
end module clean_support_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sic_r4 (line,iopt,iarg,rel,present,error)
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Retrieves the IARG-th argument of the IOPT-th option
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  real(kind=4),     intent(inout) :: rel      ! Argument value
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  !
  call sic_argument(line,iopt,iarg,present,error,oreal=rel)
end subroutine sic_r4
!
subroutine sic_r8 (line,iopt,iarg,dbl,present,error)
  use sic_interfaces, except_this=>sic_r8
  !---------------------------------------------------------------------
  ! @ public
  !  Retrieves the IARG-th argument of the IOPT-th option
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  real(kind=8),     intent(inout) :: dbl      ! Argument value
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  !
  call sic_argument(line,iopt,iarg,present,error,odble=dbl)
end subroutine sic_r8
!
subroutine sic_i8 (line,iopt,iarg,long,present,error)
  use sic_interfaces, except_this=>sic_i8
  !---------------------------------------------------------------------
  ! @ public-generic sic_i0
  !  Retrieves the IARG-th argument of the IOPT-th option
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  integer(kind=8),  intent(inout) :: long     ! Argument value
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  !
  call sic_argument(line,iopt,iarg,present,error,olong=long)
end subroutine sic_i8
!
subroutine sic_i4 (line,iopt,iarg,inte,present,error)
  use sic_interfaces, except_this=>sic_i4
  !---------------------------------------------------------------------
  ! @ public-generic sic_i0
  !  Retrieves the IARG-th argument of the IOPT-th option
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  integer(kind=4),  intent(inout) :: inte     ! Argument value
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  !
  call sic_argument(line,iopt,iarg,present,error,ointe=inte)
end subroutine sic_i4
!
subroutine sic_i2 (line,iopt,iarg,short,present,error)
  use sic_interfaces, except_this=>sic_i2
  !---------------------------------------------------------------------
  ! @ public-generic sic_i0
  !  Retrieves the IARG-th argument of the IOPT-th option
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  integer(kind=2),  intent(inout) :: short    ! Argument value
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  !
  call sic_argument(line,iopt,iarg,present,error,oshort=short)
end subroutine sic_i2
!
subroutine sic_l4 (line,iopt,iarg,logi,present,error)
  use sic_interfaces, except_this=>sic_l4
  !---------------------------------------------------------------------
  ! @ public
  !  Retrieves the IARG-th argument of the IOPT-th option
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  logical,          intent(inout) :: logi     ! Argument value
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  !
  call sic_argument(line,iopt,iarg,present,error,ologi=logi)
end subroutine sic_l4
!
subroutine sic_ch (line,iopt,iarg,argum,length,present,error)
  use sic_interfaces, except_this=>sic_ch
  !---------------------------------------------------------------------
  ! @ public
  !  Retrieves the IARG-th argument of the IOPT-th option
  !  Character string. Length returned.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  character(len=*), intent(inout) :: argum    ! Argument value
  integer(kind=4),  intent(out)   :: length   !
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  ! Local
  integer(kind=4) :: chtyp
  !
  chtyp = 0
  length = 0  ! Must be initialised if no argument present
  call sic_argument(line,iopt,iarg,present,error,  &
    chtyp=chtyp,ostring=argum,olen=length)
end subroutine sic_ch
!
subroutine sic_st (line,iopt,iarg,argum,length,present,error)
  use sic_interfaces, except_this=>sic_st
  !---------------------------------------------------------------------
  ! @ public
  !  Retrieves the IARG-th argument of the IOPT-th option
  !  Character string, with no formatting.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  character(len=*), intent(inout) :: argum    ! Argument value
  integer(kind=4),  intent(out)   :: length   !
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  ! Local
  integer(kind=4) :: chtyp
  !
  chtyp = 1
  length = 0  ! Must be initialised if no argument present
  call sic_argument(line,iopt,iarg,present,error,  &
    chtyp=chtyp,ostring=argum,olen=length)
end subroutine sic_st
!
subroutine sic_ke (line,iopt,iarg,argum,length,present,error)
  use sic_interfaces, except_this=>sic_ke
  !---------------------------------------------------------------------
  ! @ public
  !  Retrieves the IARG-th argument of the IOPT-th option
  !  Keyword: Expansion, Uppercase conversion
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  integer(kind=4),  intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),  intent(in)    :: iarg     ! Argument number (0=command)
  character(len=*), intent(inout) :: argum    ! Argument value
  integer(kind=4),  intent(out)   :: length   !
  logical,          intent(in)    :: present  ! Must the argument be present ?
  logical,          intent(inout) :: error    ! Error flag
  ! Local
  integer(kind=4) :: chtyp
  !
  chtyp = -1
  length = 0  ! Must be initialised if no argument present
  call sic_argument(line,iopt,iarg,present,error,  &
    chtyp=chtyp,ostring=argum,olen=length)
end subroutine sic_ke
!
subroutine sic_de(line,iopt,iarg,desc,present,error)
  use sic_interfaces, except_this=>sic_de
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Retrieves the descriptor of the IARG-th argument of the IOPT-th
  ! option.
  !
  !  - If argum is a variable name, return its descriptor
  !  - If argum is a variable non-contiguous subset, return the
  !    descriptor of its materialization
  !  - If argum is a scalar value (numeric, logical, or character),
  !    return the descriptor of its incarnation
  !
  ! IT IS THE RESPONSIBILITY OF THE CALLER TO FREE SCRATCH VARIABLES
  ! CREATED HERE: call sic_volatile(desc)
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: line     ! Command line
  integer(kind=4),        intent(in)    :: iopt     ! Option number (0=command)
  integer(kind=4),        intent(in)    :: iarg     ! Argument number (0=command)
  type(sic_descriptor_t), intent(inout) :: desc     !
  logical,                intent(in)    :: present  ! Must the argument be present ?
  logical,                intent(inout) :: error    ! Error flag
  !
  call sic_argument(line,iopt,iarg,present,error,odesc=desc)
end subroutine sic_de
!
subroutine sic_argument(line,iopt,iarg,presen,error,  &
    oreal,odble,olong,ointe,oshort,ologi,chtyp,ostring,olen,odesc)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_argument
  use sic_interactions
  use sic_dictionaries
  use sic_structures
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Retrieves the IARG-th argument of the IOPT-th option
  !  The type and kind of the output argument is ruled by the present
  ! argument.
  !---------------------------------------------------------------------
  character(len=*),       intent(in)              :: line    ! Command line
  integer(kind=4),        intent(in)              :: iopt    ! Option number (0=command)
  integer(kind=4),        intent(in)              :: iarg    ! Argument number (0=command)
  logical,                intent(in)              :: presen  ! Must the argument be present ?
  logical,                intent(out)             :: error   ! Error flag
  ! One of these output arguments will be filled. Unchanged if absent.
  ! Numerics or logical
  real(kind=4),           intent(inout), optional :: oreal   !
  real(kind=8),           intent(inout), optional :: odble   !
  integer(kind=8),        intent(inout), optional :: olong   !
  integer(kind=4),        intent(inout), optional :: ointe   !
  integer(kind=2),        intent(inout), optional :: oshort  !
  logical,                intent(inout), optional :: ologi   !
  ! Characters
  integer(kind=4),        intent(in),    optional :: chtyp   ! Which kind of character parsing?
  character(len=*),       intent(inout), optional :: ostring !
  integer(kind=4),        intent(inout), optional :: olen    !
  ! Descriptor
  type(sic_descriptor_t), intent(inout), optional :: odesc   !
  ! Local
  character(len=*), parameter :: rname='DECODE'
  integer(kind=4) :: ifirst,ilast,parg
  logical :: l
  real(kind=4) :: r4
  real(kind=8) :: r8
  integer(kind=4) :: i4
  integer(kind=8) :: i8
  character(len=argument_length) :: expr
  character(len=message_length) :: mess
  !
  ! Check if argument is present
  error = .true.
  if (iopt.gt.maxopt .or. iopt.lt.0 .or. iarg.lt.0) then
    write(mess,104) iopt,iarg
    call sic_message(seve%e,rname,mess)
    return
  endif
  if (locstr(line).ne.ccomm%aline) then
    call sic_message(seve%e,rname,'You have overwritten the command line pointers.')
    call sic_message(seve%e,rname,'The following command line can not be parsed anymore:')
    call sic_message(seve%e,rname,line)
    call sic_message(seve%e,rname,'because the command '//trim(ccomm%command)//  &
      ' was executed in the meantime.')
    return
  endif
  if (iarg.le.ccomm%narg(iopt)) then
    ! Requested argument is present
    parg = ccomm%popt(iopt)+iarg
    if (parg.gt.mword) then
      write(mess,104) iopt,iarg
      call sic_message(seve%e,rname,mess)
      return
    endif
    ifirst = ccomm%ibeg(parg)
    ilast  = ccomm%iend(parg)
  else
    ! Requested argument is absent
    if (presen) then
      ! It was mandatory
      if (iopt.eq.0) then
        write(mess,101) iarg,trim(ccomm%lang),char(92),vocab(ccomm%icom)(2:)
      else
        write(mess,102) iarg,vocab(ccomm%icom+iopt)(2:)
      endif
      call sic_message(seve%e,rname,mess)
    else
      ! It was optional
      error = .false.
      if (present(ostring))  olen = len_trim(ostring)  ! Reuse input string
    endif
    return
  endif
  error = .false.
  !
  ! True values: remove outer quotes
  ! if (chtyp.eq.2) then
  !    if (line(ifirst:ifirst).eq.quote .and. line(ilast:ilast).eq.quote) then
  !       ifirst = ifirst+1
  !       ilast  = ilast-1
  !    endif
  ! endif
  !
  if (present(odesc)) then
    call sic_argument_desc(line(ifirst:ilast),ilast-ifirst+1,odesc,error)
    if (error)  return
    !
  elseif (present(ostring)) then  ! Characters
    if (chtyp.gt.0) then
      call sic_shape(ostring,line,ifirst,ilast,parg,error)
    elseif (chtyp.eq.0) then
      call sic_expand(ostring,line,ifirst,ilast,parg,error)
      olen = parg   ! Even if error...
    else
      call sic_keyw(ostring,line,ifirst,ilast,parg,error)
    endif
    if (error) return
    olen = parg
    !
  else    ! Numerics or logicals
    call sic_shape(expr,line,ifirst,ilast,parg,error)
    !
    if (present(ologi)) then
      call sic_math_logi (expr,parg,l,error)
      if (error) return
      ologi = l
    elseif (present(oreal)) then
      call sic_math_real (expr,parg,r4,error)
      if (error) return
      oreal = r4
    elseif (present(odble)) then
      call sic_math_dble (expr,parg,r8,error)
      if (error) return
      odble = r8
    elseif (present(ointe)) then
      call sic_math_inte (expr,parg,i4,error)
      if (error) return
      ointe = i4
    elseif (present(olong)) then
      call sic_math_long (expr,parg,i8,error)
      if (error) return
      olong = i8
    elseif (present(oshort)) then
      call sic_math_inte (expr,parg,i4,error)
      if (error) return
      oshort = i4
    endif
  endif
  !
101 format('Missing argument number ',i3,' of Command ',a,a,a)
102 format('Missing argument number ',i3,' of Option ',a)
104 format('Option ',i3,' or argument ',i3,' out of bounds')
end subroutine sic_argument
!
subroutine sic_argument_desc(argum,larg,odesc,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_argument_desc
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Produce a valid descriptor describing the argument
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: argum  !
  integer(kind=4),        intent(in)    :: larg   ! Length of argum
  type(sic_descriptor_t), intent(out)   :: odesc
  logical,                intent(inout) :: error
  ! Local
  character(len=*), parameter ::rname='DESC'
  logical :: found,l4
  integer(kind=4) :: ier,lexpr
  character(len=argument_length) :: expr,ch
  real(kind=8) :: r8
  integer(kind=8) :: i8
  !
  found = .false.  ! Not verbose
  call sic_materialize(argum,odesc,found)
  if (found)  return
  !
  ! Any other argument which is not a variable name is expanded as
  ! SIC usually does. This includes:
  !  - single-quoted scalar variables (not trapped above),
  !  - single-quoted math expressions (non-quoted math expressions are NOT evaluated),
  !  - unquoted character strings,
  !  - explicit scalar values.
  ! All of these should evaluate as scalar.
  call sic_expand(expr,argum,1,larg,lexpr,error)
  if (error)  return
  !
  ! Try integer value
  read(expr,'(I20)',iostat=ier) i8
  if (ier.eq.0) then
    call sic_incarnate(i8,odesc,error)
    return
  endif
  !
  ! Try floating point value
  read(expr,'(F25.0)',iostat=ier) r8
  if (ier.eq.0) then
    call sic_incarnate(r8,odesc,error)
    return
  endif
  !
  ! Try logical value (SIC_EXPAND expands to YES or NO)
  if (expr.eq.'YES' .or. expr.eq.'NO') then
    l4 = expr.eq.'YES'
    call sic_incarnate(l4,odesc,error)
    return
  endif
  !
  ! Try character string as fallback
  read(expr,'(A)',iostat=ier) ch
  if (ier.eq.0) then
    call sic_incarnate(expr(1:lexpr),odesc,error)
    return
  endif
  !
  call sic_message(seve%e,rname,'Failed processing argument '//argum(1:larg))
  error = .true.
  return
  !
end subroutine sic_argument_desc
!
function sic_present(iopt,iarg)
  use sic_structures
  !---------------------------------------------------------------------
  ! @ public
  !  Is argument IARG of option IOPT present ?
  !---------------------------------------------------------------------
  logical :: sic_present  ! Function value on return
  integer(kind=4), intent(in) :: iopt  ! Option number (0=command)
  integer(kind=4), intent(in) :: iarg  ! Argument number (0=option)
  !
  sic_present=.false.
  if (iopt.gt.maxopt .or. iopt.lt.0 .or. iarg.lt.0) return
  if (iarg.gt.ccomm%narg(iopt)) return
  sic_present = ccomm%ibeg(ccomm%popt(iopt)+iarg).ne.0
end function sic_present
!
function sic_len(iopt,iarg)
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  ! Length (number of characters) of argument IARG of option IOPT
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_len  ! Function value on return
  integer(kind=4), intent(in) :: iopt  ! Argument number (0=option)
  integer(kind=4), intent(in) :: iarg  ! Option number (0=command
  ! Local
  integer(kind=4) :: parg
  !
  sic_len = 0
  if (iopt.gt.maxopt .or. iopt.lt.0 .or. iarg.lt.0) return
  if (iarg.gt.ccomm%narg(iopt)) return
  parg = ccomm%popt(iopt)+iarg
  sic_len = ccomm%iend(parg) - ccomm%ibeg(parg) + 1
end function sic_len
!
function sic_start(iopt,iarg)
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  !  Return the position (first character) of argument IARG of option
  ! IOPT
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_start  ! Function value on return
  integer(kind=4), intent(in) :: iopt  ! Argument number (0=option)
  integer(kind=4), intent(in) :: iarg  ! Option number (0=command)
  !
  sic_start = 0
  if (iopt.gt.maxopt .or. iopt.lt.0 .or. iarg.lt.0) return
  if (iarg.gt.ccomm%narg(iopt)) return
  sic_start = ccomm%ibeg(ccomm%popt(iopt)+iarg)
end function sic_start
!
function sic_end(iopt,iarg)
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  !  Return the position (last character) of argument IARG of option
  ! IOPT
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_end  ! Function value on return
  integer(kind=4), intent(in) :: iopt  ! Argument number (0=option)
  integer(kind=4), intent(in) :: iarg  ! Option number (0=command)
  !
  sic_end = 0
  if (iopt.gt.maxopt .or. iopt.lt.0 .or. iarg.lt.0) return
  if (iarg.gt.ccomm%narg(iopt)) return
  sic_end = ccomm%iend(ccomm%popt(iopt)+iarg)
end function sic_end
!
function sic_narg(iopt)
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  ! Return the number of arguments passed to the Ith option (0 ==
  ! command)
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_narg  ! Function value on return
  integer(kind=4), intent(in) :: iopt  !
  !
  sic_narg = 0
  if (iopt.lt.0 .or. iopt.gt.maxopt) return
  sic_narg = ccomm%narg(iopt)
end function sic_narg
!
function sic_nopt()
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  ! Return the number of options passed to the current command
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_nopt  ! Function value on return
  ! Local
  integer(kind=4) :: iopt
  !
  sic_nopt = 0
  do iopt=1,ccomm%mopt
    if (ccomm%popt(iopt).gt.0)  sic_nopt = sic_nopt+1
  enddo
end function sic_nopt
!
function sic_mopt()
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  ! Return the total number of known options to the current command
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_mopt  ! Function value on return
  !
  sic_mopt = ccomm%mopt
end function sic_mopt
!
function sic_lire()
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public
  ! To be checked and documented
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_lire  ! Function value on return
  !
  if (library_mode) then
    sic_lire = -10
  elseif (nlire.gt.0) then
    sic_lire = mlire(nlire)
  else
    sic_lire = -10
  endif
end function sic_lire
!
subroutine sic_expand(argum,line,ifirst,ilast,length,error)
  use sic_interfaces, except_this=>sic_expand
  use sic_structures
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Format an argument by expanding the variables, etc...
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: argum   ! Returned argument
  character(len=*), intent(in)    :: line    ! Command line
  integer(kind=4),  intent(in)    :: ifirst  ! Pointer to start
  integer(kind=4),  intent(in)    :: ilast   ! Pointer to end
  integer(kind=4),  intent(out)   :: length  ! Argument length
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SIC_CHAR'
  logical :: quiet,apos,found
  integer(kind=4) :: kstart,kapost
  integer(kind=4) :: iquote,jquote,kquote,kend
  character(len=1), parameter :: quote="'"
  character(len=1), parameter :: apost='"'
  real(kind=8) :: d
  logical :: dlogi
  equivalence (d,dlogi)
  !
  kend = len(argum)
  iquote = ifirst
  kquote = index(line(ifirst:ilast),quote)
  kapost = index(line(ifirst:ilast),apost)
  !
  if (kquote.eq.0) then
    apos = .true.
  elseif (kapost.ne.0) then
    apos = kquote.gt.kapost
  else
    apos = .false.
  endif
  if (apos) kquote = kapost
  kstart = 1
  quiet = sic_quiet
  sic_quiet = .true.
  !
  ! Loop on quoted expressions in command line
  do while (kquote.ne.0)
    if (kquote.gt.1) then
      argum(kstart:) = line(iquote:iquote+kquote-2)
      kstart = kstart+kquote-1
      if (kstart.gt.kend) goto 20
    endif
    kquote = kquote+iquote
    !
    ! Plain string within "double-quotes"
    if (apos) then
      jquote = index(line(kquote:ilast),apost)
      if (jquote.ne.0) then
        !
        ! Check double ""
        jquote = jquote+kquote-2
        if (line(jquote+2:jquote+2).eq.apost) then
          jquote = jquote+1
          argum(kstart:) = line(kquote:jquote)
          kstart = kstart+jquote-kquote+1
          jquote = jquote-1
        else
          argum(kstart:) = line(kquote:jquote)
          kstart = kstart+jquote-kquote+1
        endif
        ! End check
      else
        call sic_message(seve%e,rname,'No closing "')
        error = .true.
        !! goto 20 
        sic_quiet = quiet 
        length = 0
        return 
      endif
      iquote = jquote+2
      kquote = index(line(iquote:ilast),quote)
      kapost = index(line(iquote:ilast),apost)
    else
      jquote = index(line(kquote:ilast),quote)
      if (jquote.ne.0) then
        jquote = jquote+kquote-2
        call sic_expand_variable(line(kquote:jquote),argum(kstart:),found,error)
        if (error)  goto 20
        if (found) then
          kstart = kstart+len_trim(argum(kstart:))
        else
          ! Nothing valid, just 'sometext'
          !
          !   Either  return this text with the quotes
          ! argum(kstart:) = line(kquote-1:jquote+1)
          ! kstart = kstart+jquote-kquote+3         
          !   or without the quotes ?...
          ! argum(kstart:) = line(kquote:jquote)
          ! kstart = kstart+jquote-kquote+1
          !
          !   and proceed ?
          ! continue
          !
          ! or abort with an error.
          ! user can place the invalid text between double quote if needed
          error = .true.
          sic_quiet = quiet 
          length = 0
          return 
          !
          ! The initial code was just this: no error, nothing done...
          ! goto 20
        endif
        !
        ! Return error status ?
        iquote = jquote+2
        if (kstart.gt.kend) goto 20
        if (iquote.gt.ilast) then
          kquote = 0
          kapost = 0
        else
          kquote = index(line(iquote:ilast),quote)
          kapost = index(line(iquote:ilast),apost)
        endif
      else
        ! No closing quote: stop processing here
        call sic_message(seve%e,rname,"No closing '")
        error = .true.
!!      goto 20
        sic_quiet = quiet 
        length = 0
        return 
      endif
      !
    endif
    !
    if (kquote.eq.0) then
      apos = .true.
    elseif (kapost.ne.0) then
      apos = kquote.gt.kapost
    else
      apos = .false.
    endif
    if (apos) kquote = kapost
  enddo
  !
  ! Trailing arguments if any
  if (kstart.gt.kend) goto 20
  argum(kstart:) = line(iquote:ilast)
  !
  ! Restore quiet status and return
20 sic_quiet = quiet
  length = kstart+ilast-iquote
  if (length.gt.kend) then
    length = kend 
    call sic_message(seve%e,rname,  &
      "String '"//line(iquote:ilast)//"' too long for argument")
    error = .true.
  endif
end subroutine sic_expand
!
subroutine sic_real_to_string(num,string)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Format a single-precision float according to current SIC PRECISION
  !---------------------------------------------------------------------
  real(kind=4),     intent(in)  :: num     !
  character(len=*), intent(out) :: string  !
  !
  call sic_float_to_string(real(num,kind=8),fmt_r4,string)
  !
end subroutine sic_real_to_string
!
subroutine sic_dble_to_string(num,string)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_dble_to_string
  !---------------------------------------------------------------------
  ! @ private
  ! Format a double-precision float according to current SIC PRECISION
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)  :: num     !
  character(len=*), intent(out) :: string  !
  !
  call sic_float_to_string(num,fmt_r8,string)
  !
end subroutine sic_dble_to_string
!
subroutine sic_float_to_string(num,itype,string)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_float_to_string
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Format a float (single or double) according to current SIC
  ! PRECISION. This subroutine always receives a double-precision
  ! float as input, but its input type is taken into account.
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)  :: num     !
  integer(kind=4),  intent(in)  :: itype   !
  character(len=*), intent(out) :: string  !
  ! Local
  integer(kind=4) :: nf,ndec,ndigit,larg
  integer(kind=4) :: i4
  integer(kind=8) :: i8
  real(kind=4) :: r4
  real(kind=8), parameter :: maxi4=2147483647.d0
  real(kind=8), parameter :: maxi8=9223372036854775807.d0
  !
  if (sicprecis.eq.fmt_r8 .or. (itype.eq.fmt_r8.and.sicprecis.eq.0)) then
    if (abs(num).gt.maxi4) then
      ndec = 2
    else
      i4 = int(num)
      if (dble(i4).eq.num) then
        ndec = 16
      else
        ndec = 2
      endif
    endif
    ndigit = 16
    !
  elseif (sicprecis.eq.fmt_r4 .or. (itype.eq.fmt_r4.and.sicprecis.eq.0)) then
    if (abs(num).gt.maxi4) then
      ndec = 2
    else
      r4 = num
      i4 = int(r4)
      if (float(i4).eq.r4) then
        ndec = 7
      else
        ndec = 2
      endif
    endif
    ndigit = 7
    !
  elseif (sicprecis.eq.fmt_i8) then
    if (abs(num).gt.maxi8) then
      ndec = 2
    else
      i8 = int(num,8)
      if (dble(i8).eq.num) then
        ndec = 20
      else
        ndec = 2
      endif
    endif
    ndigit = 20
  endif
  !
  call sic_spanum(string,num,0,nf,larg,0.d0,ndigit,ndec)
  string(larg+1:) = ""
end subroutine sic_float_to_string
!
subroutine sic_long_to_string(i8,string)
  use gbl_message
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !   Does the same as 'sic_dble_to_string', but avoid rounding to
  ! a double precision float, which is not precise enough for (really)
  ! long integers.
  !---------------------------------------------------------------------
  integer(kind=8),  intent(in)  :: i8      !
  character(len=*), intent(out) :: string  !
  ! Local
  character(len=128) :: string2
  !
  ! 1) Get the value. Do this in a local copy since it is a fatal error
  !    in Fortran to write a value if the output string is too small.
  !    NB: subroutine sic_spanum also reads the value in a local buffer.
  write(string2,'(I0)') i8
  !
  ! 2) Copy the value.
  !    NB: subroutine sic_spanum can truncate the value and warns the
  !    user if so. Note that truncation can return incorrect values,
  !    both here and in sic_spanum
  if (len_trim(string2).gt.len(string)) then
    call sic_message(seve%w,'SPANUM',  &
      'String too short. Integer number has been truncated.')
  endif
  string = string2
  !
end subroutine sic_long_to_string
!
subroutine sic_logi_to_string(l,string)
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  logical :: l                      !
  character(len=*) :: string        !
  !
  if (l) then
    string = 'YES'
  else
    string = 'NO'
  endif
end subroutine sic_logi_to_string
!
subroutine sic_var_to_string(var,string)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_var_to_string
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(sic_descriptor_t) :: var     !
  character(len=*)       :: string  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: i,nc,ntype,narg
  integer(kind=address_length) :: ipnt
  real(kind=8) :: args(16)
  !
  narg = min(desc_nelem(var),16)
  ipnt = bytpnt(var%addr,membyt)
  !
  ntype = var%type
  if (ntype.eq.fmt_l) then
    ! Logical
    call l_type_to_string(narg,membyt(ipnt),string)
  elseif (ntype.gt.0) then
    ! Characters
    call destoc(var%type,var%addr,string)
  else
    if (ntype.eq.fmt_c4) then
      ! Complex
      ! call c4_type_to_string(narg,membyt(ipnt),string)
      call sic_message(seve%e,'LET','Complex not supported')
      string = '********'
    else
      ! Numeric values
      if (ntype.eq.fmt_r8) then
        call r8tor8(membyt(ipnt),args,narg)
      elseif (ntype.eq.fmt_r4) then
        call r4tor8(membyt(ipnt),args,narg)
      elseif (ntype.eq.fmt_i8) then
        call i8tor8(membyt(ipnt),args,narg)
      elseif (ntype.eq.fmt_i4) then
        call i4tor8(membyt(ipnt),args,narg)
      else
        narg = 0
        string = '<UNKNOWN TYPE>'
      endif
      nc = 1
      do i = 1,narg
        call sic_dble_to_string(args(i),string(nc:))
        nc = nc + len_trim(string(nc:))+ 1
      enddo
    endif
  endif
  nc = len_trim(string)+1
  string(nc:nc) = char(0)
end subroutine sic_var_to_string
!
subroutine sic_expand_variable(line,argum,found,error)
  use sic_interfaces, except_this=>sic_expand_variable
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !   Replace a variable name by its value
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  character(len=*), intent(out)   :: argum  ! Returned argument
  logical,          intent(out)   :: found  ! Variable has been resolved
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: larg
  integer(kind=4) :: icode
  real(kind=8) :: d  ! 2 words buffer for any kind of result
  !
  ! Try a character variable
  found = .true.
  call sic_get_char(line,argum,larg,error)
  if (.not.error)  return
  !
  ! Must be a mathematical expression. Try to decode, and then format.
  error = .false.
  call sic_math_auto (line,len_trim(line),d,icode,error)
  if (error)  return
  if (icode.eq.fmt_r8) then  ! Float expression
    call sic_dble_to_string(d,argum)
    !
  elseif (icode.eq.fmt_r4) then  ! Float expression
    call sic_real_to_string(d,argum)
    !
  elseif (icode.eq.fmt_i8) then  ! Integer expression
    call sic_long_to_string(d,argum)
    !
  elseif (icode.eq.fmt_l) then  ! Logical expression
    call sic_logi_to_string(d,argum)
    !
  else ! Nothing valid, just 'sometext'
    found = .false.
  endif
  !
end subroutine sic_expand_variable
!
subroutine sic_shape(argum,line,ifirst,ilast,length,error)
  use sic_interfaces, except_this=>sic_shape
  use sic_structures
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Format an argument
  !  Similar to SIC_EXPAND, but does not suppress double quotes
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: argum   ! Returned argument
  character(len=*), intent(in)    :: line    ! Command line
  integer(kind=4),  intent(in)    :: ifirst  ! Pointer to start
  integer(kind=4),  intent(in)    :: ilast   ! Pointer to end
  integer(kind=4),  intent(out)   :: length  ! Argument length
  logical,          intent(inout) :: error   ! Error flag
  ! Local
  character(len=*), parameter :: rname='SIC_CHAR'
  logical :: quiet,apos,found
  integer(kind=4) :: kstart,kapost
  integer(kind=4) :: iquote,jquote,kquote,kend
  character(len=1), parameter :: quote="'"
  character(len=1), parameter :: apost='"'
  real(kind=8) :: d
  logical :: dlogi
  equivalence (d,dlogi)
  !
  kend = len(argum)
  iquote = ifirst
  kquote = index(line(ifirst:ilast),quote)
  kapost = index(line(ifirst:ilast),apost)
  !
  if (kquote.eq.0) then
    apos = .true.
  elseif (kapost.ne.0) then
    apos = kquote.gt.kapost
  else
    apos = .false.
  endif
  if (apos) kquote = kapost
  kstart = 1
  quiet = sic_quiet
  sic_quiet = .true.
  !
  ! Loop on quoted expressions in command line
  do while (kquote.ne.0)
    if (kquote.gt.1) then
      argum(kstart:) = line(iquote:iquote+kquote-2)
      kstart = kstart+kquote-1
      if (kstart.gt.kend) goto 20
    endif
    kquote = kquote+iquote
    !
    ! Plain string within "double-quotes"
    if (apos) then
      jquote = index(line(kquote:ilast),apost)
      if (jquote.ne.0) then
        jquote = jquote+kquote
        argum(kstart:) = line(kquote-1:jquote)
        kstart = kstart+jquote-kquote+1
      else
        call sic_message(seve%e,rname,'No closing "')
        error = .true.
        goto 20
      endif
      iquote = jquote
      kquote = index(line(iquote:ilast),quote)
      kapost = index(line(iquote:ilast),apost)
    else
      jquote = index(line(kquote:ilast),quote)
      if (jquote.ne.0) then
        jquote = jquote+kquote-2
        call sic_expand_variable(line(kquote:jquote),argum(kstart:),found,error)
        if (error)  goto 20
        if (found) then
          kstart = kstart+len_trim(argum(kstart:))
        else
          ! Nothing valid, just 'sometext'
          argum(kstart:) = line(kquote-1:jquote+1)
          kstart = kstart+jquote-kquote+3
          if (kstart.gt.kend) goto 20
        endif
        !
        ! Return error status ?
        iquote = jquote+2
        if (kstart.gt.kend) goto 20
        if (iquote.gt.ilast) then
          kquote = 0
          kapost = 0
        else
          kquote = index(line(iquote:ilast),quote)
          kapost = index(line(iquote:ilast),apost)
        endif
      else
        ! No closing quote: stop processing here
        call sic_message(seve%e,rname,"No closing '")
        error = .true.
        goto 20
      endif
      !
    endif
    !
    if (kquote.eq.0) then
      apos = .true.
    elseif (kapost.ne.0) then
      apos = kquote.gt.kapost
    else
      apos = .false.
    endif
    if (apos) kquote = kapost
  enddo
  !
  ! Trailing arguments if any
  if (kstart.gt.kend) goto 20
  argum(kstart:) = line(iquote:ilast)
  !
  ! Restore quiet status and return
20 sic_quiet = quiet
  length = min(kend,kstart+ilast-iquote)
end subroutine sic_shape
!
subroutine sic_keyw(argum,line,ifirst,ilast,length,error)
  use sic_interfaces, except_this=>sic_keyw
  use sic_structures
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Format an argument
  !  Similar to SIC_EXPAND and SIC_SHAPE but check on syntax
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: argum   ! Returned argument
  character(len=*), intent(in)    :: line    ! Command line
  integer(kind=4),  intent(in)    :: ifirst  ! Pointer to start
  integer(kind=4),  intent(in)    :: ilast   ! Pointer to end
  integer(kind=4),  intent(out)   :: length  ! Argument length
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: quiet,apos,found
  integer(kind=4) :: kstart,kapost
  integer(kind=4) :: iquote,jquote,kquote,kend,i
  character(len=1), parameter :: quote="'"
  character(len=1), parameter :: apost='"'
  real(kind=8) :: d
  logical :: dlogi
  equivalence (d,dlogi)
  !
  kend = len(argum)
  iquote = ifirst
  kquote = index(line(ifirst:ilast),quote)
  kapost = index(line(ifirst:ilast),apost)
  !
  if (kquote.eq.0) then
    apos = .true.
  elseif (kapost.ne.0) then
    apos = kquote.gt.kapost
  else
    apos = .false.
  endif
  if (apos) kquote = kapost
  kstart = 1
  quiet = sic_quiet
  sic_quiet = .true.
  !
  ! Loop on quoted expressions in command line
  do while (kquote.ne.0)
    if (kquote.gt.1) then
      argum(kstart:) = line(iquote:iquote+kquote-2)
      kstart = kstart+kquote-1
      if (kstart.gt.kend) goto 20
    endif
    kquote = kquote+iquote
    !
    ! Plain string within "double-quotes"
    if (apos) then
      jquote = index(line(kquote:ilast),apost)
      if (jquote.ne.0) then
        jquote = jquote+kquote
        argum(kstart:) = line(kquote-1:jquote)
        kstart = kstart+jquote-kquote+1
      else
        call sic_message(seve%e,'SIC_CHAR','No closing "')
        error = .true.
        goto 20
      endif
      iquote = jquote
      kquote = index(line(iquote:ilast),quote)
      kapost = index(line(iquote:ilast),apost)
    else
      jquote = index(line(kquote:ilast),quote)
      if (jquote.ne.0) then
        jquote = jquote+kquote-2
        call sic_expand_variable(line(kquote:jquote),argum(kstart:),found,error)
        if (error)  goto 20
        if (found) then
          kstart = kstart+len_trim(argum(kstart:))
        else
          ! Nothing valid, just 'sometext'
          goto 20
        endif
        !
        ! Return error status ?
        iquote = jquote+2
        if (kstart.gt.kend) goto 20
        if (iquote.gt.ilast) then
          kquote = 0
          kapost = 0
        else
          kquote = index(line(iquote:ilast),quote)
          kapost = index(line(iquote:ilast),apost)
        endif
      else
        ! No closing quote: stop processing here
        call sic_message(seve%e,'SIC_CHAR',"No closing '")
        error = .true.
        goto 20
      endif
      !
    endif
    !
    if (kquote.eq.0) then
      apos = .true.
    elseif (kapost.ne.0) then
      apos = kquote.gt.kapost
    else
      apos = .false.
    endif
    if (apos) kquote = kapost
  enddo
  !
  ! Trailing arguments if any
  if (kstart.gt.kend) goto 20
  argum(kstart:) = line(iquote:ilast)
  !
  ! Restore quiet status and return
20 sic_quiet = quiet
  length = kstart+ilast-iquote
  !
  ! Bad programming in several areas MAY prevent this test to be used
  !!
  !! if (length.gt.kend) then
  !!  call sic_message(seve%e,'SIC_KE','Argument too long for keyword '//trim(argum))
  !!  error = .true.
  !!  return
  !! endif
  !
  do i=1,min(kend,length)
    if ( ichar(argum(i:i)).ge.ichar('a') .and.  &
         ichar(argum(i:i)).le.ichar('z') ) then
      argum(i:i) = char(ichar(argum(i:i))+ichar('A')-ichar('a'))
    endif
  enddo
end subroutine sic_keyw
!
subroutine sic_spanum(string,anum,nfx,nf,ndg,range,digit,ndc)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_spanum
  !---------------------------------------------------------------------
  ! @ public
  !   This routine is called for numbering. It translates a number into
  ! a character string.
  !
  !   Maximum number of significant digits is MXDIG0 or DIGIT if non
  ! zero. If your computer has a lower accuracy, you should accordingly
  ! decrease the value of MXDIG0 in order to get rid of round-off
  ! troubles.
  !
  !   NDC is the range in which fixed format is used.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: string  ! Formatted result
  real(kind=8),     intent(in)  :: anum    ! Number to be formatted
  integer(kind=4),  intent(in)  :: nfx     ! Desired format
  integer(kind=4),  intent(out) :: nf      ! Used format 1 fixed, 0 Integer, -1 Float
  integer(kind=4),  intent(out) :: ndg     ! Number of characters in STRING
  real(kind=8),     intent(in)  :: range   ! Reduce number of digits for smaller numbers
  integer(kind=4),  intent(in)  :: digit   ! Max number of digits
  integer(kind=4),  intent(in)  :: ndc     ! Max number of decimals
  ! Local
  integer(kind=4), parameter :: mxexp=3
#if defined(VAX)
  integer(kind=4), parameter :: mxdig0=16     ! Maximum number of significant digits
#else
  integer(kind=4), parameter :: mxdig0=14     ! Maximum number of significant digits
#endif
  integer(kind=4) :: mantis(mxdig0+1)         ! Allow one digit for round off
  integer(kind=4) :: itab  (mxdig0+5+mxexp)   !
  real(kind=8) :: sn,p10,tmp
  integer(kind=4) :: jtab,in(10),im,ip,ipnt,ie
  integer(kind=4) :: maxdig,lose,ip10,i,j,lgmant,m1,m2,imot,i1,j1,k1
  !
  !      data in/'0','1','2','3','4','5','6','7','8','9'/
  !      data im,ip,ipnt,ie /'-','+','.','E'/
  ! Standard syntax, in ASCII
  data in/48,49,50,51,52,53,54,55,56,57/
  data im,ip,ipnt,ie /45,43,46,69/
  !
  ! First check for IEEE special cases (NaN, +INF, -INF)
  call gag_infini (anum,string,ndg)
  if (ndg.ne.0) return
  !
  ! Compute MAXDIG = max. number of significant digits
  ! Compute mantissa in the range 0.1 thru 1.
  sn=dabs(anum)
  if (sn.eq.0.d0) goto 100
  maxdig=mxdig0
  if (digit.ne.0) maxdig = min(maxdig,digit)
  if (range.gt.0.d0) then
    tmp =sn/range
    tmp =dlog10(tmp)+0.5d0
    lose=floor(tmp)
    maxdig=min(maxdig,maxdig+lose)
    if (maxdig.le.0) goto 100
  endif
  p10=dlog10(sn)
  !
  ! Version to avoid overflows in the range MinReal, MaxReal
  ip10 = floor(p10)
  sn=sn/(10.d0**ip10)
  sn=sn/10.d0
  ip10 = ip10+1
  !
  mantis(1)=0
  do i=2,maxdig
    sn=10.d0*sn
    mantis(i)=floor(sn)
    sn=sn-dble(mantis(i))
  enddo
  tmp=10.d0*sn+0.5d0
  mantis(maxdig+1)=floor(tmp)
  !
  ! Propagate round-off digit
  ! Drop away right-hand zeros
  !
  j=maxdig+1
  m2=1
  do i=1,maxdig
    if (mantis(j).lt.10) then
      if (mantis(j).gt.0) m2=max(m2,j)
    else
      mantis(j)=0
      mantis(j-1)=mantis(j-1)+1
    endif
    j=j-1
  enddo
  ip10=ip10+mantis(1)
  m1=1
  if (mantis(1).eq.0 .and. m2.gt.1) m1=2
  !
  ! Convert array MANTIS to a character string of length LGMANT
  ! Truncate to MAXDIG digits
  j=0
  do i=m1,m2
    j=j+1
    mantis(j)=in(mantis(i)+1)
  enddo
  lgmant = min(j,maxdig)
  !
  ! Check for sign of ANUM
  if (anum.lt.0.d0) then
    ndg=1
    itab(1)=im
  endif
  !
  ! Select the format for output
200 continue
  if (nfx.lt.0 .or. ip10.lt.(1-ndc) .or. ip10.gt.(1+ndc)) then
    !
    ! Floating format
    ndg=ndg+2
    itab(ndg-1)=mantis(1)
    itab(ndg)=ipnt
    do i=2,lgmant
      ndg=ndg+1
      itab(ndg)=mantis(i)
    enddo
    !
    ! Compute and store exponent
    ip10=ip10-1
    !
    ! Store power of 10
    imot=ip
    if (ip10.lt.0) imot=im
    i1 = iabs(ip10)
    if (i1.lt.100) then
      ndg=ndg+4
      itab(ndg-3)=ie
      itab(ndg-2)=imot
      j1=i1/10
      k1=i1-j1*10
      itab(ndg-1)=in(j1+1)
      itab(ndg)  =in(k1+1)
    else
      ndg=ndg+5
      itab(ndg-4)=ie
      itab(ndg-3)=imot
      j1 = i1/100
      itab(ndg-2) = in(j1+1)
      k1 = i1-j1*100
      i1 = k1/10
      itab(ndg-1) = in(i1+1)
      j1 = k1-i1*10
      itab(ndg) = in(j1+1)
    endif
    nf=-1
    !
    ! Fixed format ( 1-NDC <= IP10 <=1+NDC )
    !
  elseif (ip10.le.0) then
    !
    ! Negative or null exponent: add zeroes to the left
    ndg=ndg+2
    itab(ndg-1)=in(1)
    itab(ndg)=ipnt
    if (ip10.ne.0) then
      ip10=-ip10
      do i=1,ip10
        ndg=ndg+1
        itab(ndg)=in(1)
      enddo
    endif
    !
    ! Copy mantissa
    do i=1,lgmant
      ndg=ndg+1
      itab(ndg)=mantis(i)
    enddo
    nf=1
    !
    ! Positive exponent : Store integer part
  else
    do i=1,ip10
      ndg=ndg+1
      itab(ndg)=in(1)
      if (i.le.lgmant) itab(ndg)=mantis(i)
    enddo
    !
    ! Non-integer: store point and fractional part
    if (ip10.lt.lgmant) then
      ndg=ndg+1
      itab(ndg)=ipnt
      do i=ip10+1,lgmant
        ndg=ndg+1
        itab(ndg)=mantis(i)
      enddo
      nf=1
      !
      ! Integer number: add optional decimal point and return.
    elseif (nfx.gt.0) then
      ndg=ndg+1
      itab(ndg)=ipnt
      nf=1
    else
      nf=0
    endif
  endif
  !
  ! Check for access violation
  if (ndg.gt.len(string)) then
    call sic_message(seve%w,'SPANUM',  &
      'String too short. Number has been truncated.')
    ndg = len(string)
  endif
  !
  ! Fill in the buffer STRING
  do i=1,ndg
    jtab = itab(i)
    string(i:i) = char(jtab)
  enddo
  return
  !
100 mantis(1) = in(1)
  lgmant=1
  ip10=1
  ndg=0
  goto 200
end subroutine sic_spanum

!
subroutine newuvt_close (xima)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Closes the output table.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima
  ! Local
  logical :: error
  !-----------------------------------------------------------------------
  if (xima%loca%islo.eq.0) return
  call gdf_close_image(xima,error)
end subroutine newuvt_close
!
subroutine newuvt_init (xima,name,nvis,scan,positions,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Creates the output table header in X (the significant header parameters
  ! have already been defned in clic_table)
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(in) :: scan           ! Use SCAN number
  logical, intent(in) :: positions      ! Add position information
  logical, intent(out) :: error         ! Error flag
  ! Local
  integer :: i, last
  ! for the Telescope section -- Assumes CLIC only handles NOEMA data here
  ! if not, the telescope name should be passed as an argument to newuvt_init
  character(len=8), parameter :: cteles='NOEMA   '
  real(8) :: value(3)
  ! Add section Telescope
  call gdf_addteles(xima,'TELE',cteles,value,error)
  !
  ! Do not nullify X header here: it has already been partly computed before.
  !
  error = .false.
  !
  xima%file = name
  xima%gil%blan_words = def_blan_words
  xima%gil%extr_words = 6
  xima%gil%desc_words = def_desc_words
  xima%gil%posi_words = def_posi_words
  xima%gil%proj_words = def_proj_words
  xima%gil%spec_words = def_spec_words
  xima%gil%reso_words = def_reso_words
  xima%gil%uvda_words = 2 ! Not Zero is enough
  !
  xima%gil%eval = 0.
  xima%gil%dim(2) = nvis              ! +1 ! = add the dummy uv = 7.5 m point
  xima%gil%ref(2) = 0.
  xima%gil%inc(2) = 1.                ! needed to avoid crash in GRAPHIC
  xima%gil%val(2) = 0.
  xima%gil%ndim = 2
  xima%char%unit = 'Jy'
  xima%char%syst = 'EQUATORIAL'
  xima%gil%ptyp = p_azimuthal
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%gil%faxi = 1
  xima%gil%form = fmt_r4
  !
  ! Here define the order in which you want the extra "columns"
  xima%gil%column_pointer = 0
  xima%gil%column_size = 0
  xima%gil%column_pointer(code_uvt_u) = 1
  xima%gil%column_pointer(code_uvt_v) = 2
  xima%gil%column_pointer(code_uvt_w) = 3
  xima%gil%column_pointer(code_uvt_date) = 4
  xima%gil%column_pointer(code_uvt_time) = 5
  xima%gil%column_pointer(code_uvt_anti) = 6
  xima%gil%column_pointer(code_uvt_antj) = 7
  xima%gil%natom = 3
  xima%gil%nstokes = 1
  xima%gil%fcol = 8
  last = xima%gil%fcol + xima%gil%natom * xima%gil%nchan - 1
!
! For the time being (1-Feb-2012), force SCAN information in place of W column
  if (scan) then
    xima%gil%column_pointer(code_uvt_w) = 0
    xima%gil%column_pointer(code_uvt_scan) = 3
! Normal code should use an extra column as below
!    last = last+1
!    xima%gil%column_pointer(code_uvt_scan) = last
  endif
!
  if (positions) then
    last = last+1
    xima%gil%column_pointer(code_uvt_loff) = last
    last = last+1
    xima%gil%column_pointer(code_uvt_moff) = last
  endif
  do i=1,code_uvt_last
    if (xima%gil%column_pointer(i).ne.0) xima%gil%column_size(i) = 1
  enddo
  !
  xima%gil%nvisi = nvis
  xima%gil%type_gdf = code_gdf_uvt
  ! CLIC is working in this version of the header
  ! Header will be updated at newuvt_cut stage.
  xima%gil%version_uv = code_version_uvt_freq
  call gdf_setuv (xima,error)
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2)
  !!print *, 'Into newuvt_init ',xima%gil%nvisi, xima%gil%nchan, xima%gil%dim(1:2)
  !!print *, 'Into newuvt_init UVDA_WORDS', xima%gil%uvda_words
  call gdf_create_image (xima,error)
  !!print *, 'Done newuvt_init '
end subroutine newuvt_init
!
subroutine newuvt_extend (xima,name,nvis,nn,ndobs,ndscan,error,lc)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Open a Table to extend it.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(out) :: error         ! Error flag
  integer, intent(in) :: nn             !
  integer, intent(in) :: ndobs(nn)      !
  integer, intent(in) :: ndscan(nn)     !
  logical, intent(in) :: lc             ! Check table before
  ! Local
  integer(kind=size_length) :: mvis
  integer :: ier
  character(len=60) :: chain
  real, allocatable :: old(:,:)
  !-----------------------------------------------------------------------
  !
  if (name.ne.xima%file) then
    call message(6,2,'EXTEND_TABLE', 'Unexpected file change')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) xima%gil%nvisi,nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call message(6,1,'TABLE',chain)
  !
  mvis = xima%gil%nvisi+nvis
  !
  !!print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  call gdf_extend_image (xima,mvis,error)
  !!print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  if (error) then
    call message(8,4,'EXTEND_TABLE','Table extension failed')
    return
  endif
  !
  ! Check old region
  xima%blc(1) = 1
  xima%blc(2) = 1
  xima%trc(1) = xima%gil%dim(1)
  xima%trc(2) = xima%gil%nvisi
  !
  if (xima%gil%version_gdf.lt.code_version_gdf_v20) then
  xima%gil%column_pointer(code_uvt_w) = 0
  xima%gil%column_pointer(code_uvt_scan) = 3
  xima%gil%column_size(code_uvt_w) = 0
  xima%gil%column_size(code_uvt_scan) = 1
  endif
  !
  if (lc.and.xima%gil%nvisi.gt.0) then
    allocate (old(xima%gil%dim(1),xima%trc(2)), stat=ier)
    error = ier.ne.0
    if (error) return
    call gdf_read_data(xima,old,error)
    !!Print *,'Done GDF_READ_DATA ', error
    if (.not.error) then
      !!Print *,'Doing CHECK_TABLE ', error
      call check_table(xima%gil%dim(1),xima%trc(2), old, nn,ndobs,ndscan,error)
    endif
    deallocate (old)
    if (error) return
  endif
  !
  ! Map only new region
  xima%blc(1) = 1
  xima%blc(2) = xima%gil%nvisi+1
  xima%trc(1) = xima%gil%dim(1)
  xima%trc(2) = xima%gil%dim(2)
  !!print *, 'Done newuvt_extend '
end subroutine newuvt_extend
!
subroutine newuvt_cut (xima,nvis,uv_version,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Update the number of visibilities
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: xima !
  integer, intent(in) :: nvis         ! True number of visibilities
  integer, intent(in) :: uv_version   ! Target image version 
  logical :: error                    !
  !
  ! Local
  character(len=80) :: chain
  !----------------------------------------------------------------------
  !
  write(chain,1001) xima%gil%dim(2), nvis
  call message(6,1,'TABLE',chain)
  xima%gil%dim(2) = nvis
  if (nvis.eq.0) xima%gil%dim(2) = 1
  xima%gil%nvisi = nvis
  !
  !! print *, 'Doing newuvt_cut ',xima%gil%nchan,xima%gil%nvisi , xima%gil%dim
  call gdf_uv_doppler(xima,uv_version)
  call gdf_update_header(xima,error)
  !! print *, 'Done newuvt_cut ',xima%gil%nchan
  !
1001 format('Old size ',i8,' New ',i8)
end subroutine newuvt_cut

subroutine newuvt_open (xima,name,uv_version,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Open an existing table, to get the header information
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: xima  ! Image header
  character(len=*), intent(in) :: name !
  integer,intent(out)          :: uv_version ! Image version 
  logical, intent(out) :: error        !
  ! Global
  !-----------------------------------------------------------------------
  !
  xima%file = name
  xima%loca%read = .false.
  !
  call gdf_read_gildas(xima,name,'.uvt',error, data=.false.)
  uv_version =  xima%gil%version_uv
  ! CLIC is working in this version of the header
  call gdf_uv_doppler(xima,code_version_uvt_freq)
  if (error) return
  !!print *, 'Done newuvt_open ',xima%gil%nchan
end subroutine newuvt_open
!
subroutine newuvt_addvisi (xima,visi,qsb,qband,qbas,qntch,qnchan,   &
    ibase,isb,inbc,frout,fres,datac,datal,passc,passl,   &
    ndrop, good, scan, width, shape, resample, fft, &
    positions, error)
  use image_def
  use phys_const
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! Called by CLIC_TABLE
  ! creates one visibility point (i.e. one baseline and one band for a
  ! given scan), but many channels if in line mode.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  !
  real, intent(out) :: visi(*)      ! Current visibility
  integer :: qsb                    !
  integer :: qband                  !
  integer :: qbas                   !
  integer :: qntch                  !
  integer :: qnchan                 !
  integer :: ibase                  !
  integer :: isb                    !
  integer :: inbc                   !
  real*8 :: frout                   !
  real*4 :: fres
  complex :: datac(qband,qsb,qbas)  !
  complex :: datal(qntch,qsb,qbas)  !
  complex :: passc(qband,qsb,qbas)  !
  complex :: passl(qntch,qsb,qbas)  !
!  real*4 :: daps(7)                 !
!  real*4 :: visi(3, qnchan)         !
!  real*4 :: offsets(2)              !
  integer :: ndrop(2)               !
  logical :: good                   !
  logical :: scan                   !
  real*4 :: width                   !
  character(len=*) :: shape         !
  logical :: resample               !
  logical :: fft                    !
  logical :: positions              !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  complex :: z, zz,  zscale
  complex, allocatable :: zin(:), zout(:)
  real, allocatable :: wout(:)
  real :: w, ww, tsys(2), ri, afac, factor, fr, save_res, rchan, fresf
  integer :: is, i, j, nw, k, ni, js, i1, i2, nd1, nd2, nch, iw
  integer :: ifirst, ilast, l, nchan, ipola, ia, ja
  integer, allocatable :: first_polar(:),second_polar(:)
  integer, allocatable :: first_tsys(:),second_tsys(:)
  integer, allocatable :: nfirst(:),nsecond(:)
  integer :: ier
  integer :: ibdata
  logical :: down_channel, ok
  real(8) :: f1, fn, fo1, fon, ff
  character(len=128) :: chain
  !
  integer ki
  !------------------------------------------------------------------------
  ! Code:
  is = isubb_out(1)
  if (is.gt.mbands) is = is-mbands
  if (qsb.eq.1) then ! Check available sideband
    if (r_sband(1,is).ne.isb) then
      call message(6,3,'TABLE','Sideband unavailable')
      error = .true.
      return
    endif
    ibdata = 1
  else
    ibdata = isb
  endif
  !
  rchan = xima%gil%ref(1)
  nchan = xima%gil%nchan
  !
  ! NGRX: This needs more work, if we have here polarizations with different tsys
  ! as a quick workaround, I use only tsys of the first polar.
  !
  ia = r_iant(ibase)
  ja = r_jant(ibase)
  if (weight_tsys) then
    if (inbc.le.r_mapbb(r_nbb)) then
      if (r_sb(is).eq.1) then
        tsys(1) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja)   &
          /dh_integ
        tsys(2) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja)   &
          /dh_integ
      else
        tsys(2) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja)   &
          /dh_integ
        tsys(1) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja)   &
          /dh_integ
      endif
    else
      call message(2,3,'SUB_TABLE',   &
        'Unknown correlator entry')
      error = .true.
      return
    endif
  else
    tsys(1) = 0
    tsys(2) = 0
  endif
  !
  allocate (first_polar(mrlband*mch),second_polar(mrlband*mch), &
    & first_tsys(mrlband*mch),second_tsys(mrlband*mch), & 
    & nfirst(mrlband*mch),nsecond(mrlband*mch),stat=ier)
  if (ier.ne.0) then
    call message(2,3,'SUB_TABLE',   &
      'Temporary arrays allocation failure')
    error = .true.
    return
  endif
  !
  allocate (zin(mlch),zout(mlch),wout(mlch),stat=ier)
  if (ier.ne.0) then
    call message(2,3,'SUB_TABLE',   &
      'Temporary arrays allocation failure')
    error = .true.
    return
  endif
  !
  !
  do i = 1, 2*mch
    first_polar(i) = 0
    second_polar(i) = 0
    nfirst(i) = 0
    nsecond(i) = 0
  enddo
  if (tsys(1).eq.0) then
    tsys(1) = 300.**2/dh_integ
  endif
  if (tsys(2).eq.0) then
    tsys(2) = 300.**2/dh_integ
  endif
  !
  if (dobs_0 .eq.0) then
    dobs_0 = mod(dh_obs+32768,65536)-32768
  endif
  ! In CONT mode, correct u and v in each sideband
  ! to the same frequency frout
  if (cont_select) then
    if (isb.eq.1) then
      factor = (r_flo1 + r_fif1)/frout
    elseif (isb.eq.2) then
      factor = (r_flo1 - r_fif1)/frout
    endif
  else
    factor = 1.0
  endif
  visi(xima%gil%column_pointer(code_uvt_u)) = dh_uvm(1,ibase)*factor
  visi(xima%gil%column_pointer(code_uvt_v)) = dh_uvm(2,ibase)*factor
!!  visi(xima%gil%column_pointer(code_uvt_w)) = 0
  if (xima%gil%column_pointer(code_uvt_scan).ne.0) visi(xima%gil%column_pointer(code_uvt_scan)) = r_scan
  visi(xima%gil%column_pointer(code_uvt_date)) = dh_obs
  visi(xima%gil%column_pointer(code_uvt_time)) = dh_utc
  if (phys_base) then
    visi(xima%gil%column_pointer(code_uvt_anti)) = r_kant(r_iant(ibase))
    visi(xima%gil%column_pointer(code_uvt_antj)) = r_kant(r_jant(ibase))
  else
    visi(xima%gil%column_pointer(code_uvt_anti)) = r_iant(ibase)
    visi(xima%gil%column_pointer(code_uvt_antj)) = r_jant(ibase)
  endif
  !
  if (positions) then
!
! There is an ambiguity in CLIC between Pointing and Phase center
! What happens in a MODIFY POSITION ?...
!
! But here, GILDAS assumes this is both the Pointing AND the Phase center
! Further uv_shift will modify the phase center to a common value.
!
! The following code handles both the OTF and the mosaic case.
! In case of pointed observations, dh_offlam is equal to r_lamof.
! For pointed positions NOEMA always uses the pointing center 
! as tracking center.
    if (xima%gil%column_pointer(code_uvt_loff).ne.0) visi(xima%gil%column_pointer(code_uvt_loff)) = dh_offlam(1)*rad_per_sec + &
              (r_lam-xima%gil%a0)
    if (xima%gil%column_pointer(code_uvt_moff).ne.0) visi(xima%gil%column_pointer(code_uvt_moff)) = dh_offbet(1)*rad_per_sec + &
              (r_bet-xima%gil%d0)
    if (xima%gil%column_pointer(code_uvt_xoff).ne.0) visi(xima%gil%column_pointer(code_uvt_xoff)) = dh_offlam(1)*rad_per_sec + &
              (r_lam-xima%gil%ra)
    if (xima%gil%column_pointer(code_uvt_yoff).ne.0) visi(xima%gil%column_pointer(code_uvt_yoff)) = dh_offbet(1)*rad_per_sec + &
              (r_bet-xima%gil%dec)
  endif
  !
  ! Other extra columns could be added here...
  !
  visi(xima%gil%fcol:xima%gil%lcol) = 0.0
  good = .false.
  !
  ! Continuum out
  if (cont_select) then
    zz = 0
    ww = 0
    !
    do js = 1, lsubb_out
      is = isubb_out(js)
      if (.not.down_channel(ibase,is)) then
        !
        ! Spectrum from continuum backend:
        if (is.le.r_nband) then
          afac = 1.
          zscale = 1.
          call scaling (is,isb,ibase,zscale,afac,   &
            error)
          z = datac(is,ibdata,ibase)
          w = 2./tsys(isb)*abs(r_cfwid(is))
          if (do_pass) then
            z = z*passc(is,isb,ibase)
          endif
          z = z * zscale
          if (weight_cal) then
            w = w/afac**2
          endif
          !
          zz = zz + z*w
          ww = ww + w
        !
        ! Continuum  from line  backend:
        elseif (is.gt.mbands .and. is.le.r_lband+mbands) then
          is = is - mbands
          afac = 1.
          zscale = 1.
          call scaling (is,isb,ibase,zscale,afac,   &
            error)
          nch = r_lnch(is)
          nd1 = max(ndrop(1),nint(fdrop(1)*nch))+1
          nd2 = nch-max(ndrop(2),nint(fdrop(2)*nch))
          !
          ! Avoid Gibbs-affected channels:
          if (ngibbs.gt.0 .and. abs(r_lfres(is)).gt.0.1) then
            i1 = nch/2-ngibbs
            i2 = nch/2+ngibbs+1
          else
            i1 = nch/2
            i2 = i1+1
          endif
          do i = nd1, nd2
            fr = r_lrfoff(isb,is)   &
              +(i-r_lrch(isb,is))*r_lrfres(isb,is)
            if (nwin_out.gt.0) then
              ok = .false.
              do iw = 1, nwin_out
                ok = ok .or. (fr.gt.window_out(1,iw).and.   &
                  fr.le.window_out(2,iw))
              enddo
            else
              ok = .true.
            endif
            ok = ok .and. (i.le.i1 .or. i.ge.i2)
            if (ok) then
              j = i+r_lich(is)
              z = datal(j,ibdata,ibase)  * zscale
              if (do_pass)then
                if (passl(j,isb,ibase).ne.blankc) then
                  z = z*passl(j,isb,ibase)
                else
                  z =0
                endif
              endif
              w = 2./tsys(isb)*abs(r_lfres(is))
              if (weight_cal) then
                w = w/afac**2
              endif
              zz = zz + z*w
              ww = ww + w
            endif
          enddo
        endif
      endif
    enddo
    ! Put the correct weights now
    if (new_receivers) then
      if (weight_cal) then
        w = 2./tsys(isb)/abs(zscale)**2 * abs(fres)
      else
        w = 2./tsys(isb) * abs(fres)
      endif
    else
       w = ww
    endif
    !
    if (ww.gt.0) then
      zz = zz / ww
      visi(xima%gil%fcol) = real(zz)
      visi(xima%gil%fcol+1) = aimag(zz)
      visi(xima%gil%fcol+2) = w
      good = .true.
    endif
  !
  ! Spectrum out
  else
    nw = 0
    !
    ! Spectrum from Continuum backend
    if (isubb_out(1).le.mbands) then
      !
      k = xima%gil%fcol
      do j = 1, lsubb_out
        i = isubb_out(j)
        afac = 1.
        zscale = 1.
        call scaling (i,isb,ibase,zscale,afac,   &
          error)
        if (.not.down_channel(ibase,i) .and.   &
          i.le.r_nband) then
          z = datac(i,ibdata,ibase) * zscale
          if (do_pass) then
            z = z * passc(i,isb,ibase)
          endif
          visi(k) = real(z)
          visi(k+1) = aimag(z)
          visi(k+2) = w
          good = .true.
        endif
        k = k + 3
      enddo
    !
    ! Spectrum from Line backend
    else
      save_res = xima%gil%fres
      do js = 1, lsubb_out
        is = isubb_out(js)-mbands
        ipola = r_lpolentry(1,is)
        inbc = r_bb(is)
        if (is.le.r_lband .and.   &
          .not.down_channel(ibase,is+mbands)) then

          afac = 1.
          zscale = 1.
          call scaling (is,isb,ibase,zscale,afac,   &
            error)
          fresf = r_lrfres(isb,is)/(1+r_doppl)
          nch = r_lnch(is)
          ! Drop edge channels and unnecessary channels.
          nd1 = max(ndrop(1),nint(fdrop(1)*nch))
          nd2 = max(ndrop(2),nint(fdrop(2)*nch))
          ff = r_lrfoff(isb,is)-xima%gil%freq   &
            -(r_lvoff(isb,is)-xima%gil%voff)/299792.d0*xima%gil%freq
          f1 = ff+(nd1+0.5-r_lrch(isb,is))*fresf
          fn = ff+(nch-nd2+0.5-r_lrch(isb,is))*fresf
          if (fft) then
            if (fresf*xima%gil%fres.gt.0) then
              ifirst = nint(f1/xima%gil%fres+rchan+1)
              ilast  = nint(fn/xima%gil%fres+rchan-1)
            else
              ilast = nint(f1/xima%gil%fres+rchan-1)
              ifirst  = nint(fn/xima%gil%fres+rchan+1)
            endif
            if ((ilast.lt.1) .or. (ifirst.gt.nchan)) then
              write(chain,2000) csub(is+mbands), ifirst, ilast
              l = lenc(chain)
              call message(6,3,'FILL_VISI',chain(1:l))
              goto 98
            endif
            ifirst = max(ifirst,1)
            ilast = min(ilast,nchan)
            fo1 = 1d-3*nint(1d3*   &
              (ifirst-0.5-rchan)*xima%gil%fres)
            fon = 1d-3*nint(1d3*   &
              (ilast+0.5-rchan)*xima%gil%fres)
            do while ((f1-fo1)*(f1-fon).gt.0 .and. nd1.lt.nch)
              f1 = f1+fresf
              nd1 = nd1 +1
            enddo
            ni = nint((ilast-ifirst+1)   &
              *abs(xima%gil%fres/fresf))
          else
            if (fresf*xima%gil%fres.gt.0) then
              ifirst = nint(f1/xima%gil%fres+rchan)
              ilast  = nint(fn/xima%gil%fres+rchan)
            else
              ilast = nint(f1/xima%gil%fres+rchan)
              ifirst  = nint(fn/xima%gil%fres+rchan)
            endif
            if ((ilast.lt.1) .or. (ifirst.gt.nchan)) then
              write(chain,2000) csub(is+mbands), ifirst, ilast
              l = lenc(chain)
              call message(6,3,'FILL_VISI',chain(1:l))
              goto 98
            endif
            ni = nch-nd1-nd2
            ifirst = max(ifirst,1)
            ilast = min(ilast,nchan)
            ilast = min(ilast,ifirst+ni-1)
          endif
          ri = r_lrch(isb,is)-nd1
          do i=1, ni
            j = i+r_lich(is)+nd1
            zin(i) = datal(j,ibdata,ibase)  * zscale
            if (do_pass) then
              if (passl(j,isb,ibase).eq.blankc) then
                zin(i) = 0
              else
                zin(i) = zin(i)*passl(j,isb,ibase)
              endif
            endif
          enddo
          !
          ! Interpolate Gibbs-affected channels:
          if (ngibbs.gt.0 .and. abs(r_lfres(is)).gt.0.1) then
            i1 = nch/2-ngibbs -nd1
            i2 = nch/2+ngibbs+1 -nd1
            do i=i1+1,i2-1
              zin(i) = (zin(i1)*(i2-i)+zin(i2)*(i-i1))/(i2-i1)
            enddo
          endif
          !
          ! Interpolate masked channels:
          if (nmask(is,ia).gt.0) then
            do i=1, nmask(is,ia)
              i1 = cmask(1,i,is,ia)
              i2 = cmask(2,i,is,ia)
              do j=i1,i2
                if (imask.eq.1) then
                  zin(j) = (zin(i1-1)*(i2+1-j)+zin(i2+1)*(j-i1+1))/(i2-i1+2)  
                else
                  zin(j) = 0.0
                endif
              enddo
            enddo
          endif
          if (nmask(is,ja).gt.0) then
            do i=1, nmask(is,ja)
              i1 = cmask(1,i,is,ja)
              i2 = cmask(2,i,is,ja)
              do j=i1,i2
                if (imask.eq.1) then
                  zin(j) = (zin(i1-1)*(i2+1-j)+zin(i2+1)*(j-i1+1))/(i2-i1+2)  
                else
                  zin(j) = 0.0
                endif
              enddo
            enddo
          endif
          !
          if (resample) then
            ff = (r_lvoff(isb,is)-xima%gil%voff)/299792.d0*xima%gil%freq
            if (ifirst.le.ilast-4 .and. fft) then
              call fft_interpolate (zout(ifirst),   &
                ilast-ifirst+1, xima%gil%fres,   &
                rchan-ifirst+1, xima%gil%freq+ff,   &
                width, shape,   &
                wout(ifirst), zin, ni, fresf,   &
                ri, r_lrfoff(isb,is),   &
                1., 'TPAR', error)
              if (error) goto 98
            else
              call interpolate_2 (zout(ifirst),   &
                ilast-ifirst+1, xima%gil%fres,   &
                rchan-ifirst+1, xima%gil%freq+ff,   &
                wout(ifirst), zin, ni, fresf,   &
                ri, r_lrfoff(isb,is))
            endif
          endif
          xima%gil%vres = -xima%gil%fres*299792.458/xima%gil%freq
          !
          if (resample) then
            do i=ifirst, ilast
              ki = xima%gil%fcol + xima%gil%natom*(i-1)
              if (zout(i).eq.(0.0,0.0)) wout(i) = 0.0
              visi(ki) =  visi(ki)+real(zout(i))*wout(i)
              visi(ki+1) = visi(ki+1)+aimag(zout(i))*wout(i)
              visi(ki+2) = visi(ki+2)+wout(i)
              if (first_polar(i).eq.0) then
                 first_polar(i) = ipola
                 if (isb.eq.(3-r_sb(is))/2) then
                    first_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                 else
                    first_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                 endif
                 nfirst(i) = 1
              elseif(ipola.eq.first_polar(i)) then
                 if (isb.eq.(3-r_sb(is))/2) then
                    first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                 else
                    first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                 endif
                 nfirst(i) = nfirst(i)+1
              elseif(second_polar(i).eq.0) then
                 second_polar(i) = ipola
                 if (isb.eq.(3-r_sb(is))/2) then
                    second_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                 else
                    second_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                 endif
                 nsecond(i) = 1
              elseif(ipola.eq.second_polar(i)) then
                 if (isb.eq.(3-r_sb(is))/2) then
                    second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                 else
                    second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                 endif
                 nsecond(i) = nsecond(i)+1
              endif
            enddo
          else
            k = 1
            if (fresf*xima%gil%fres.gt.0) then
              do i=ifirst, ilast
                w = 1.0
                ki = xima%gil%fcol + xima%gil%natom*(i-1)
                if (zin(k).eq.(0.0,0.0)) w = 0.0
                visi(ki) =  visi(ki)+real(zin(k))*w
                visi(ki+1) = visi(ki+1)+aimag(zin(k))*w
                visi(ki+2) = visi(ki+2)+w
                if (first_polar(i).eq.0) then
                   first_polar(i) = ipola
                   if (isb.eq.(3-r_sb(is))/2) then
                      first_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                   else
                      first_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                   endif
                   nfirst(i) = 1
                elseif(ipola.eq.first_polar(i)) then
                   if (isb.eq.(3-r_sb(is))/2) then
                      first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                   else
                      first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                   endif
                   nfirst(i) = nfirst(i)+1
                elseif(second_polar(i).eq.0) then
                   second_polar(i) = ipola
                   if (isb.eq.(3-r_sb(is))/2) then
                      second_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                   else
                      second_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                   endif
                   nsecond(i) = 1
                elseif(ipola.eq.second_polar(i)) then
                   if (isb.eq.(3-r_sb(is))/2) then
                      second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                   else
                      second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                   endif
                   nsecond(i) = nsecond(i)+1
                endif
                k = k+1
              enddo
            else
              do i= ilast, ifirst, -1
                ki = xima%gil%fcol + xima%gil%natom*(i-1)
                visi(ki) =  visi(ki)+real(zin(k))*w
                visi(ki+1) = visi(ki+1)+aimag(zin(k))*w
                visi(ki+2) = visi(ki+2)+w
                k = k+1
                if (first_polar(i).eq.0) then
                   first_polar(i) = ipola
                   if (isb.eq.(3-r_sb(is))/2) then
                      first_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                   else
                      first_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                   endif
                   nfirst(i) = 1
                elseif(ipola.eq.first_polar(i)) then
                   if (isb.eq.(3-r_sb(is))/2) then
                      first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                   else
                      first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                   endif
                   nfirst(i) = nfirst(i)+1
                elseif(second_polar(i).eq.0) then
                   second_polar(i) = ipola
                   if (isb.eq.(3-r_sb(is))/2) then
                      second_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                   else
                      second_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                   endif
                   nsecond(i) = 1
                elseif(ipola.eq.second_polar(i)) then
                   if (isb.eq.(3-r_sb(is))/2) then
                      second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                   else
                      second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                   endif
                   nsecond(i) = nsecond(i)+1
                endif
              enddo
            endif
          endif
98        error = .false.
          continue
        endif
      enddo
      !
      ! Set the proper channel width now
      if (weight_cal) then
        w = 2./abs(zscale)**2 * abs(xima%gil%fres)
      else
        w = 2. * abs(xima%gil%fres)
      endif
      do i=1, nchan
        ki = xima%gil%fcol + xima%gil%natom*(i-1)
        if (visi(ki+2).ne.0) then
          visi(ki) = visi(ki)/visi(ki+2)
          visi(ki+1) = visi(ki+1)/visi(ki+2)
          if (nfirst(i).ne.0) then
             first_tsys(i) = first_tsys(i)/nfirst(i)
             ww = w / first_tsys(i)
          endif
          if (nsecond(i).ne.0) then
             second_tsys(i) = second_tsys(i)/nsecond(i)
             ww = ww+ w / second_tsys(i)
          endif
          if (ww.ne.0) then
             visi(ki+2) = ww
          endif
          good = .true.
        endif
      enddo
      if (abs((save_res-xima%gil%fres)/xima%gil%fres).gt.1e-4) then
        write(chain,'(a,1pg13.6)')   &
          'Channel separation rounded to ',xima%gil%fres
        call message(4,1,'FILL_VISI',chain(1:lenc(chain)))
      endif
    endif
  endif
  return
2000 format('Subband ',a,' maps to output channels ',i9,' to ',i9)
end subroutine newuvt_addvisi

program uv_zero
  use gildas_def
  use gkernel_interfaces
  real :: weight, factor, flux
  character(len=filename_length) :: uv_table, greg_table
  logical :: error, do_spectrum
  !------------------------------------------------------------------------
  ! Code:
  call gildas_open
  call gildas_char( 'UV_TABLE$', uv_table)
  call gildas_real( 'FLUX$', flux, 1)
  call gildas_logi( 'DO_SPECTRUM$', do_spectrum, 1)
  call gildas_char( 'GREG_TABLE$', greg_table)
  call gildas_real( 'WEIGHT$', weight, 1)
  call gildas_real( 'FACTOR$', factor, 1)
  call gildas_close
  !
  call sub_uv_zero(uv_table,flux,do_spectrum,greg_table,weight,factor,error)
  if (error) call sysexi(fatale)
  !  
end program
!
subroutine sub_uv_zero(uv_table,flux,do_spectrum,greg_table,weight,factor,error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! UV_ZERO: Add zero spacing to a UV Table from a Single Dish Spectrum.
  ! Input :
  !	  a UV table
  !	  a GREG table built by the CLASS\GREG command
  ! Output :
  !	  the input UV table
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: uv_table
  character(len=*), intent(in) :: greg_table
  real, intent(in) :: weight
  real, intent(in) :: factor
  real, intent(in) :: flux
  logical, intent(in) :: do_spectrum
  logical, intent(out) :: error
  ! Local
  character(len=*), parameter :: rname='UV_ZERO'
  character(len=80) :: mess
  type(gildas) :: hin, htab
  integer :: n, ncol, nchan, nzero, nvisi, ier
  integer :: codes(2)
  integer(kind=index_length) :: mvis
  !
  error = .false.
  !
  ! Input GREG table (zero spacing spectrum)
  if (do_spectrum) then
    n = len_trim(greg_table)
    if (n.le.0) then
      call gag_message(seve%e,rname,'No input spectrum name')
      error = .true.
      return
    endif
    call gildas_null(htab)
    call gdf_read_gildas(htab,greg_table,'.tab',error)
    if (error) then
      call gag_message(seve%e,rname,'Cannot read input spectrum')
      return
    endif
    nchan = htab%gil%dim(1)
    ncol = htab%gil%dim(2)
  else
    nchan = 1
    ncol = 1
    allocate (htab%r2d(nchan,ncol), stat=ier)
  endif
  !
  ! Input file
  n = len_trim(uv_table)
  if (n.le.0) then
    call gag_message(seve%e,rname,'No input name')
    error = .true.
    return
  endif
  call gildas_null(hin, type = 'UVT')
  call gdf_read_gildas(hin, uv_table, '.uvt', error, data=.false.)
  if (error) then
    call gag_message(seve%e,rname,'Cannot read input UV Table')
    return
  endif
  allocate (hin%r2d(2,hin%gil%nvisi),stat=ier)
  codes(1:2) = [code_uvt_u,code_uvt_v] 
  call gdf_read_uvonly_codes(hin, hin%r2d, codes, 2, error)
  if (error) return
  !
  nvisi = hin%gil%dim(2)  ! Check up to available space
  call find_zero(hin%r2d,nvisi,nzero)
  if (nzero.ne.0) then
    write(mess,'(A,I0)') 'Zero visibility found at ',nzero
    call gag_message(seve%i,rname,mess)
  endif
  deallocate (hin%r2d)
  !
  ! Now only use the Zero spacing visibility, old or new
  allocate (hin%r2d(hin%gil%dim(1),1), stat=ier)
  !
  if (nzero.eq.0) then
    !
    call gdf_close_image(hin,error)
    mvis = hin%gil%dim(2)+1      ! Add one visibility
    call gdf_extend_image(hin,mvis,error)
    if (error) then
      call gag_message(seve%e,rname,'Table extension failed')
      return
    endif
    nzero = mvis
    hin%r2d = 0
    hin%blc(1) = 1
    hin%trc(1) = hin%gil%dim(1)
    hin%blc(2) = nzero 
    hin%trc(2) = nzero 
  else
    hin%blc(1) = 1
    hin%trc(1) = hin%gil%dim(1)
    hin%blc(2) = nzero 
    hin%trc(2) = nzero 
    call gdf_read_data(hin,hin%r2d,error)
  endif
  !
  call add_zero(hin,nchan,ncol,htab%r2d, hin%r2d,   &
     &    weight, factor, flux, do_spectrum, error)
  if (error) return
  call gdf_write_data (hin,hin%r2d,error)
  if (error) return
  call gdf_close_image(hin,error)
  call gag_message(seve%i,rname,'Successful completion')
  !
end subroutine sub_uv_zero
!
subroutine add_zero(hin,nchan,ncol,spec,vis, weight, factor,  &
  flux, do_spectrum, error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! Add on visibility for zero spacing.
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hin         ! UV table header
  integer,intent(in) :: nchan             ! Number of channels
  integer,intent(in) :: ncol              ! Number of values per channel
  real, intent(in) :: spec(nchan,ncol)    ! Spectrum
  real, intent(out) :: vis(*)             ! Visibility
  real, intent(in) :: weight              ! Weight value
  real, intent(in) :: factor              ! Scale factor
  real, intent(in) :: flux                ! Continuum flux
  logical, intent(in) :: do_spectrum      ! 
  logical, intent(out) :: error      ! Error flag
  !
  character(len=*), parameter :: rname='UV_ZERO'
  ! Local
  integer :: i, ifirst, ilast, ier, nc, gdate
  real(8) :: dchan, rchan
  real, allocatable :: rdata(:)
  !------------------------------------------------------------------------
  ! Code:
  nc = hin%gil%nchan 
  vis(1:3) = 0.0
  call sic_gagdate(gdate)
  vis(4) = gdate     ! Current date
  vis(5) = 0.0
  vis(6:7) = -1.0    ! Convention: Antenna # -1 for Short spacings
  !
  if (do_spectrum) then
    !
    allocate (rdata(nc), stat=ier)
    if (ier.ne.0) then
      call gag_message(seve%e,rname,'Memory allocation failure')
      error = .true.
      return
    endif
    rdata(:) = 0
    !
    ! Search for reference channel
    dchan = spec(2,5)-spec(1,5)
    rchan = (hin%gil%freq-spec(1,5)) / dchan + 1.
    !
    ! Check limits to be filled
    if (dchan*hin%gil%fres.gt.0) then
      ifirst = nint((1-rchan)*dchan/hin%gil%fres + hin%gil%ref(1))
      ilast  = nint((nchan-rchan)*dchan/hin%gil%fres + hin%gil%ref(1))
    else
      ifirst = nint((nchan-rchan)*dchan/hin%gil%fres + hin%gil%ref(1))
      ilast  = nint((1-rchan)*dchan/hin%gil%fres + hin%gil%ref(1))
    endif
    ifirst = max(ifirst,1)
    ilast = min(ilast,nc)
    if (ifirst.gt.nc .or. ilast.lt.1) then
      call gag_message(seve%e,rname,'Spectra do not intersect')
      error = .true.
      return
    endif
    !
    ! Resample new spectrum
    call interpolate(   &
     &      rdata(ifirst),ilast-ifirst+1,hin%gil%fres,   &
     &      hin%gil%ref(1)-ifirst+1,hin%gil%freq,   &
     &      spec,nc,dchan,rchan,hin%gil%freq)
    !
    do i=1, nc
      vis(5 + 3*i) = rdata(i) * factor + flux
      vis(6 + 3*i) = 0
      vis(7 + 3*i) = weight
    enddo
  else
    do i=1, nc
      vis(5 + 3*i) = flux
      vis(6 + 3*i) = 0
      vis(7 + 3*i) = weight
    enddo
  endif
end subroutine add_zero
!
subroutine find_zero(vis,nv,nzero)
  use gildas_def
  !---------------------------------------------------------------------
  ! Find zero spacing visibility
  !---------------------------------------------------------------------
  integer, intent(in) :: nv          !
  real, intent(in) :: vis(2,nv)      !
  integer, intent(out) :: nzero      !
  ! Local
  integer :: i
  !------------------------------------------------------------------------
  ! Code:
  nzero = 0
  do i=1, nv
    if (vis(1,i).eq.0 .and. vis(2,i).eq.0) then
      nzero = i
      exit
    endif
  enddo
end subroutine find_zero
!
subroutine interpolate (x,xdim,xinc,xref,xval, & !! w,   &
    y,ydim,yinc,yref,yval)
  !---------------------------------------------------------------------
  ! Cloned from CLIC interpolate_2 routine
  !	Performs the linear interpolation/integration
  !
  ! 1) if actual interpolation (XINC <= YINC)
  !     this is a 2-point linear interpolation formula.
  !     the data is untouched if the resolution is unchanged and the shift
  !     is an integer number of channels.
  !
  ! 2) if not (XINC > YINC)
  !     boxcar convolution (width xinc-yinc) followed by linear interpolation
  !
  !---------------------------------------------------------------------
  integer :: xdim                   !
  real :: x(xdim)                !
  real(8) :: xinc                    !
  real(8) :: xref                      !
  real(8) :: xval                    !
  !! real :: w(xdim)                   !
  integer :: ydim                   !
  real :: y(ydim)                !
  real(8) :: yinc                      !
  real(8) :: yref                      !
  real(8) :: yval                    !
  ! Local
  integer :: i,imax,imin, j
  real(8) :: pix, val, expand
  real :: scale, ww
  !-----------------------------------------------------------------------
  !
  expand = abs(xinc/yinc)
  do i = 1, xdim
    !
    ! Compute interval
    val = xval + (i-xref)*xinc
    pix = (val-yval)/yinc + yref
    if (expand.gt.1.) then
      imin = int(pix-expand/2d0+0.5d0)
      imax = int(pix+expand/2d0+0.5d0)
      ! This initial test was stupid.... It rejected ANY channel which did not match
      ! the exact final sampling...
      !      IF ((MIN(IMIN,IMAX).LT.1).OR.(MAX(IMIN,IMAX).GT.YDIM)) THEN
      !      print *,'Rejecting ',imin,imax,ydim
      !         W(I) = 0
      !         X(I) = 0
      ! We are here ADDING channels together to produce wider ones.
      ! Edge channels must be accounted for with their weight corresponding to the
      ! fraction of the final channel width covered by the initial sampling.
      !
      ! The band stitching will then be done properly in FILL_VISI, since this
      ! contribution  is added to the final visibility
      if (imin.lt.1) then
        imin = 1
        ww = 1.0               ! The whole channel is in...
      else
        ww = imin-(pix-expand/2d0-0.5d0)
      endif
      x(i) = y(imin)*ww
      scale = ww
      !
      if (imax.gt.ydim) then
        imax = ydim
        ww = 1.0
      else
        ww = pix+expand/2d0+0.5d0-imax
      endif
      x(i) = x(i) + y(imax)*ww
      scale = scale + ww
      !
      do j=imin+1, imax-1
        x(i) = x(i) + y(j)
        scale = scale+1.
      enddo
      ! Normalize
      !! w(i) = scale/expand      ! This is the fraction of channel covered
      x(i) = x(i)/scale
    else
      imin = int(pix)
      imax = imin+1
      if ((imin.lt.1).or.(imax.gt.ydim)) then
        !! w(i) = 0
        x(i) = 0
      else
        !! w(i) = 1
        x(i) = y(imin)*(imin+1-pix) + y(imin+1)*(pix-imin)
      endif
    endif
  enddo
end subroutine interpolate
!

#!/bin/bash

### Pre-processing #####################################################

# 'raw' measurements file:
inputfile=wind-plot.dat

# Parsed file:
tmpdir=tmp
mkdir -p $tmpdir
tmpfile=${tmpdir}/wind-plot.dat

# Generate file suited for Astro procedure
# NB: should protect against missing input file, which seems to appear
#     when it is downloaded from Bure
grep weather-logger $inputfile | tail -n 1000 | sed -e 's/.*weather-logger://' | grep -v -e repeated > $tmpfile

# PNG directory
pngdir=png
mkdir -p $pngdir

### Processing #########################################################

# Define input file and output directory for astro procedure
export GAG_WINDPLOT_INPUT=$tmpfile
export GAG_WINDPLOT_OUTPUT=$pngdir
export GAG_WINDPLOT_EXPERIMENTAL=yes  # Overplot the string "EXPERIMENTAL"

# astro -nl: No Log files will be added in $HOME/.gag/logs, even in case
#            of error or normal exit
# NB: if you want to avoid all logs, you can also consider redirecting STDOUT
#     to /dev/null...
nohup astro -nw -nl < wind-plot.astro > wind-plot.log 2>&1


### Post-processing ####################################################

rm -rf $tmpdir

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "go.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gaggo() {
    #
    # Variable and function definitions
    #
    GO_AUTHOR='J. Pety <pety@iram.fr>'
    GO_PROJECT='GILDAS <http://www.iram.fr/IRAMFR/GILDAS>'
    GO_PROGNAME='go.sh'
    #
    go_usage() {
	cat <<EOF 1>&2

Enable easy browsing through GILDAS sources, integration branch, or
executables by providing shortcuts. When browsing the sources, verify
whether others are already editing the target directory. The default
browsed GILDAS trees are defined by the \$gagsrcdir, \$gagintdir, and
\$gagexedir environment variables. The default behavior (ie neither
-e, -i or -s is set) is to browse the source tree as this facility is
intended first for developers.

  usage: source $GO_PROGNAME [options] [subdirectory-name]

options:
  -e          Browse executable  tree
  -i          Browse integration tree
  -s          Browse source      tree
  -h          Show this help page
  -v          Show version information

Examples:

  source $GO_PROGNAME home        -> Go to \$gaghome if this variable is set
  source $GO_PROGNAME gadm        -> Go to \$gaghome/gildas-admin if this directory exists
  source $GO_PROGNAME logs        -> Go to \$gaghome/logs if this directory exists
  source $GO_PROGNAME back or $GO_PROGNAME -  -> Go to the before last directory visited with the go command

  source $GO_PROGNAME -s          -> Go to \$gagsrcdir
  source $GO_PROGNAME -s packages -> Go to \$gagsrcdir/packages
  source $GO_PROGNAME -s greg     -> Go to \$gagsrcdir/kernel/lib/greg (ie the greg library)

  source $GO_PROGNAME -i          -> Go to \$gagintdir
  source $GO_PROGNAME -i pro      -> Go to \$gagintdir/pro
  source $GO_PROGNAME -i lib      -> Go to \$gagintdir/MACHINE-OS-COMPILER/lib
  source $GO_PROGNAME -i system   -> Go to \$gagintdir/MACHINE-OS-COMPILER

  source $GO_PROGNAME -e          -> Go to \$gagexedir
  source $GO_PROGNAME -e pro      -> Go to \$gagexedir/pro
  source $GO_PROGNAME -e lib      -> Go to \$gagexedir/MACHINE-OS-COMPILER/lib
  source $GO_PROGNAME -e system   -> Go to \$gagexedir/MACHINE-OS-COMPILER

EOF
	go_clean
    }
    #
    go_showversion() {
	echo "$GO_PROGNAME by $GO_AUTHOR"
	echo "Project: $GO_PROJECT"
	go_clean
    }
    #
    go_message() {
	echo "$1"
    }
    #
    go_error() {
	go_message "$GO_PROGNAME error: $1" 1>&2
    }
    #
    go_clean() {
	unset GO_PACKAGE GO_SUBDIR GO_DIR
	unset GO_AUTHOR GO_PROJECT GO_PROGNAME
	unset go_usage go_showversion go_message go_error go_clean
	unset tree
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    tree=1  # source tree = 1 (default), integration tree = 2, executable tree = 3
    temp=`getopt "hveis" "$@"`
    if [ $? -ne 0 ]; then go_usage; return 2; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
	case $1 in
	-e) tree=3 ;;
	-i) tree=2 ;;
	-s) tree=1 ;;
	-h) go_usage; set --; return 0 ;;
	-v) go_showversion; set --; return 0 ;;
	esac
	shift # Next flag
    done
    shift # Skip double dash
    case $# in
	0) GO_SUBDIR="" ;; # Default subdirectory (see below)!
	1) GO_SUBDIR=$1 ;;
	*) go_usage; set --; return 2 ;;
    esac
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    #######################################################################
    #
    # Verifies whether the $gagexedir, $gagintdir, or $gagsrcdir directory exists.
    #
    if [ $tree -eq 2 ]; then
	if [ "$gagintdir" = "" ]; then
	    go_error "\$gagintdir is not set"
	    go_error "Please define it by hand"
	    go_clean
	    return 1
	fi
	if [ ! -d $gagintdir ]; then
	    go_error "$gagintdir tree does not exist"
	    go_error "Please (re)define \$gagintdir by hand"
	    go_clean
	    return 1
	fi
    elif [ $tree -eq 3 ]; then
	if [ "$gagexedir" = "" ]; then
	    go_error "\$gagexedir is not set"
	    go_error "Please define it by hand or through the source-gag.sh script with -me options"
	    go_clean
	    return 1
	fi
	if [ ! -d $gagexedir ]; then
	    go_error "$gagexedir tree does not exist"
	    go_error "Please (re)define \$gagexedir by hand or through the source-gag.sh script with -me options"
	    go_clean
	    return 1
	fi
    else
	if [ "$gagsrcdir" = "" ]; then
	    go_error "\$gagsrcdir is not set"
	    go_error "Please define it by hand or through the source-gag.sh script with -ms options"
	    go_clean
	    return 1
	fi
	if [ ! -d $gagsrcdir ]; then
	    go_error "$gagsrcdir tree does not exist"
	    go_error "Please (re)define \$gagsrcdir by hand or through the source-gag.sh script with -ms options"
	    go_clean
	    return 1
	fi
    fi
    #
    #######################################################################
    #
    # Define full directory path from alias
    #
    if [ "$GO_SUBDIR" = "home" ]; then
	if [ -z "$gaghome" ]; then
	    go_error "\$gaghome is not set"
	    go_clean
	    return 1
	elif [ ! -d $gaghome ]; then
	    go_error "\$gaghome=$gaghome directory does not exist"
	    go_clean
	    return 1
	else
	    GO_DIR=$gaghome
	fi
    elif [ "$GO_SUBDIR" = "gadm" ]; then
	if [ -z "$gaghome" ]; then
	    go_error "\$gaghome is not set"
	    go_clean
	    return 1
	elif [ ! -d $gaghome/gildas-admin ]; then
	    go_error "$gaghome/gildas-admin directory does not exist"
	    go_clean
	    return 1
	else
	    GO_DIR=$gaghome/gildas-admin
	fi
    elif [ "$GO_SUBDIR" = "logs" ]; then
	if [ -z "$gaghome" ]; then
	    go_error "\$gaghome is not set"
	    go_clean
	    return 1
	elif [ ! -d $gaghome/logs ]; then
	    go_error "$gaghome/logs directory does not exist"
	    go_clean
	    return 1
	else
	    GO_DIR=$gaghome/logs
	fi
    elif [ $tree -eq 2 ] || [ $tree -eq 3 ]; then
	if [ $tree -eq 2 ]; then GO_TREE=$gagintdir; fi
	if [ $tree -eq 3 ]; then GO_TREE=$gagexedir; fi
	case $GO_SUBDIR in
	    demo|doc|etc|pro)
		GO_DIR=$GO_TREE/$GO_SUBDIR ;;
	    hlp|html|pdf)
	        GO_DIR=$GO_TREE/doc/$GO_SUBDIR ;;
	    bin|data|include|lib|python|tasks)
		GO_DIR=$GO_TREE/$GAG_EXEC_SYSTEM/$GO_SUBDIR ;;
	    system)
		GO_DIR=$GO_TREE/$GAG_EXEC_SYSTEM ;;
	    back|-)
		GO_DIR=$GO_OLDDIR ;;
	    *)
		GO_DIR=$GO_TREE/$GO_SUBDIR
	esac
    else
	GO_PACKAGE=`pwd | \sed "s%$gagsrcdir/packages/%%;s%/.*%%"`
	if [ "$GO_PACKAGE" = "" ]; then
	   GO_PACKAGE="kernel"
	else
	   GO_PACKAGE="packages/$GO_PACKAGE"
	fi
	case $GO_SUBDIR in
	    demo|doc|etc|lib|main|pro|tasks*)
		GO_DIR=$gagsrcdir/$GO_PACKAGE/$GO_SUBDIR ;;
	    blas|lapack|slatec|cfitsio)
		GO_DIR=$gagsrcdir/legacy/$GO_SUBDIR ;;
	    30m|gildas|pdbi)
		GO_DIR=$gagsrcdir/cookbooks/$GO_SUBDIR ;;
	    astro*|atm*|classic*|class*|mira*|clic*|cube*|flux*|gtemplate*|map*|mis*|mrtcal*|mrtholo*|nic*|obs*|pako*|point*|telcal*|wifisyn*|mywifisyn*|mymis*)
		GO_DIR=$gagsrcdir/packages/$GO_SUBDIR ;;
	    include|python)
		GO_DIR=$gagsrcdir/kernel/$GO_SUBDIR ;;
	    gchar|gcont|gcore|ggtk|ggui|gfits|gio|gmath|greg|gsys|gtv|gwcs|gwidget|gwindows|gx11|sic|gkernel|cfitsio)
		GO_DIR=$gagsrcdir/kernel/lib/$GO_SUBDIR ;;
	    binding*|linedb*)
		GO_DIR=$gagsrcdir/kernel/python/$GO_SUBDIR ;;
	    lut-desc|term-desc)
		GO_DIR=$gagsrcdir/kernel/setup/$GO_SUBDIR ;;
	    weeds*|imager*)
		GO_DIR=$gagsrcdir/contrib/$GO_SUBDIR ;;
	    imbfits)
	        GO_DIR=$gagsrcdir/packages/mrtcal/lib-imbfits ;;
	    back|-)
		GO_DIR=$GO_OLDDIR ;;
	    *)
		GO_DIR=$gagsrcdir/$GO_SUBDIR
	esac
    fi
    #
    #######################################################################
    #
    # Try to go there (and to see whether someone else is doing something
    # in this subdirectory when browsing the source tree)
    #
    if [ -d $GO_DIR ]; then
	echo
	go_message "Going to $GO_DIR"
	GO_OLDDIR=`pwd`
	export GO_OLDDIR
	cd $GO_DIR || return $?
	echo
	if [ $tree -eq 1 ]; then
	    if git rev-parse --git-dir > /dev/null 2>&1; then
		# These are GIT sources
		git status --short --branch .
	    fi
	fi
    else
	if [ $tree -eq 2 ]; then
	    go_error "$GO_SUBDIR directory does not exist in $gagintdir tree"
	elif [ $tree -eq 3 ]; then
	    go_error "$GO_SUBDIR directory does not exist in $gagexedir tree"
	else
	    go_error "$GO_SUBDIR directory does not exist in $gagsrcdir tree"
	fi
	go_clean
	return 1
    fi
    #
    #######################################################################
    #
    # Clean up
    #
    go_clean
}
#
###########################################################################
#
gaggo "$@"
set abc; shift # This line to avoid remanence effect in a portable way
#
###########################################################################

########################################################################
# This template script is sourced by /bin/sh when invoking the SYSTEM
# command (through the SIC logical GAG_PROCESS) at any GILDAS prompt.
# Because it is sourced, it must be POSIX-sh compliant for maximum
# portability.
#
# You could also choose to write it as a bash script (with specific bash
# syntax), insert the proper shebang on top (#!/bin/bash), make it
# executable, and execute it instead of sourcing it.
########################################################################

# Two goals must be achieved:
# 1/ open an interactive bash session
# 2/ customize the prompt (as SIC# or other)

# Naive version:
#   export PS1="SIC# "
#   bash  # Sub-shell should inherit PS1 exported in the current shell
# However this does not work if the user customizes its prompt in its
# init files (like .bashrc) but also on some OS (e.g. Debian 12) which
# overwrite inherited PS1 early at shell startup.

# Advanced version:
# This is not so obvious as bash can execute a script, it can open an
# interactive session, but it can not do both in a single call (!). The
# poor man solution is to open an interactive session with a custom init
# file (ensuring this custom init file does the usual init plus the
# custom commands like redefining PS1).

cat <<EOF 1>$GAG_GAG/tmp/gag-process.sh
  # Usual initializations
  if [ -e "$HOME/.bashrc" ]; then
    . $HOME/.bashrc
  fi
  # Custom PS1 prompt
  if [ -n "$GAG_PROGRAM" ]; then
    PS1="$GAG_PROGRAM# "
  else
    PS1="SIC# "
  fi
EOF

bash --init-file $GAG_GAG/tmp/gag-process.sh
rm $GAG_GAG/tmp/gag-process.sh

###########################################################################
#
# This file defines useful bash functions, environment variables and
# shortcuts for GILDAS/DEVELOPERS interaction.
#
###########################################################################
#
# This function loads your local GILDAS environment.
# It is compatible with the gagiram script.
# Type "gag -h" for more details.
# Make "dev" the default version (i.e. when gag is called without arguments)
#
function gag() {
     export GAG_COMM_TRACE=$HOME/.gag/logs/gag.log
     export gaghome=$HOME/gildas
     source $gaghome/gildas-admin/source-gag.sh -d dev "$@"
}
#
# This function enables easy browsing of the GILDAS source or executable 
# tree. $gagsrcdir and $gagexedir must be defined. You can use 
# "gag -ms" or "gag -me" to define them without changing the PATHs. 
# Type "go -h" for more details.
#
function go() {
     if [ -z "$gagadmdir" ]; then
         echo 'Please select first a GILDAS version using gag' 1>&2
     else
         source $gagadmdir/go.sh "$@"
     fi
}
#
export -f gag go
#
# Shortcuts
alias gags="gag -s"
alias gage="gag -e"
alias gos="go -s"
alias goi="go -i"
alias goe="go -e"
#
# The next command automatically loads the environment variables
# needed for the default GILDAS version (in this case your local version).
# Uncomment next line if this is really what you want. In any case, this
# is not recommended.
#
#gag > /dev/null 2>&1
#
###########################################################################

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "source-gag.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gagsou() {
    #
    # Variable and function definitions
    #
    GAGSOU_AUTHOR='J. Pety <pety@iram.fr>'
    GAGSOU_VERSION=`echo '$Revision$' | cut -d' ' -f2`
    GAGSOU_PROJECT='GILDAS  <http://www.iram.fr/IRAMFR/GILDAS>'
    GAGSOU_PROGNAME="gagsou"
    #
    gagsou_usage() {
	cat <<EOF 1>&2

Source the GILDAS environment of either the source tree (defined by
\$gagsrcdir) or the executable tree (defined by \$gagexedir). When the
\$gaghome enviroment variable exists, $GAGSOU_PROGNAME first defines the
\$gagsrcdir or the \$gagexedir using standard conventions (see build
script). Else $GAGSOU_PROGNAME assumes that \$gagsrcdir or \$gagexedir have
been defined elsewhere by the user. The default behavior (ie neither -e or
-s is set) is to source the executable tree as this facility is intended
first for users.

usage: $GAGSOU_PROGNAME [options] [version]

options:
  -h          Show this help page
  -v          Show version information
  -c compiler Replace default compiler by this one
  -o config   Add config to the config list
  -n config   Remove config from the default config list
  -u use-dir  Set gildas directory to use as a complement of local Gildas.
  -d version  On-the-fly selection of a default version. Useful in aliases.
  -e          Load executable tree environment
  -s          Load source     tree environment
  -m          Do not load environment (just define \$gagsrcdir and
		  \$gagexedir if needed)
  -l          List the available systems for the current version, and
              the available versions for the current \$GAG_EXEC_SYSTEM.

EOF
	gagsou_clean
    }
    #
    gagsou_showversion() {
	echo
	echo "$GAGSOU_PROGNAME version $GAGSOU_VERSION, by $GAGSOU_AUTHOR"
	echo "Project: $GAGSOU_PROJECT"
	echo
	gagsou_clean
    }
    #
    gagsou_message() {
	echo "$1"
    }
    #
    gagsou_error() {
	echo  1>&2
	echo "Error: $1" 1>&2
	echo  1>&2
	gagsou_clean
	return 1
    }
    #
    gagsou_exe_env_nohome() {
        if [ -d "$gagexedir/$GAG_EXEC_SYSTEM" ]; then
            if [ $dosource -eq 1 ]; then
                GAGRC=$gagexedir/etc/bash_profile
                if [ -e "$GAGRC" ]; then
                    source $GAGRC
                else
                    gagsou_error "Configuration file $GAGRC does not exist" || return $?
                fi
            fi
        else
            gagsou_error "No GILDAS version: $GAG_EXEC_SYSTEM in $gagexedir" || return $?
        fi
    }
    #
    gagsou_src_env_nohome() {
        if [ -d "$gagsrcdir" ]; then
            if [ $dosource -eq 1 ]; then
                source $gagadmdir/gildas-env.sh -c "$IN_COMPILER" $IN_CONFIG -u "$IN_USE" || return $?
            fi
        else
            gagsou_error "No GILDAS version in $gagsrcdir" || return $?
        fi
    }
    #
    gagsou_exe_env() {
        ogagexedir=$gagexedir
        if [ -h "$EXEDIR" ] && [ -e "$EXEDIR" ]; then
            gagexedir=`\dirname $EXEDIR`/`\readlink $EXEDIR`  # Translate e.g. gildas-exe-last symlink
        else
            gagexedir=$EXEDIR
        fi
        if [ -d "$gagexedir/$GAG_EXEC_SYSTEM" ]; then
            GAG_ROOT_DIR=$gagexedir
            if [ $dosource -eq 1 ]; then
                GAGRC=$gagexedir/etc/bash_profile
                if [ -e "$GAGRC" ]; then
                    source $GAGRC
                else
                    gagsou_error "Configuration file $GAGRC does not exist" || return $?
                fi
            fi
        else
            gagsou_error "No GILDAS version: $GAG_VERS ($GAG_EXEC_SYSTEM) in $gaghome" || return $?
        fi
    }
    #
    gagsou_src_env() {
        ogagsrcdir=$gagsrcdir
        if [ -h "$SRCDIR" ] && [ -e "$SRCDIR" ]; then
            gagsrcdir=`\dirname $SRCDIR`/`\readlink $SRCDIR`  # Translate e.g. gildas-src-last symlink
        else
            gagsrcdir=$SRCDIR
        fi
        if [ -d "$gagsrcdir" ]; then
            if [ $dosource -eq 1 ]; then
                source $gagadmdir/gildas-env.sh -c "$IN_COMPILER" $IN_CONFIG -u "$IN_USE" || return $?
            fi
        else
            gagsou_error "No GILDAS version: $GAG_VERS ($GAG_EXEC_SYSTEM) in $gaghome" || return $?
        fi
        export ogagsrcdir gagsrcdir
    }
    #
    gagsou_exe_list() {
        gagsou_system_list "$gaghome/gildas-exe-$GAG_VERS" || return $?
        gagsou_version_list "$gaghome/gildas-exe-*" "$GAG_EXEC_SYSTEM" || return $?
    }
    #
    gagsou_src_list() {
        gagsou_system_list "$gaghome/gildas-src-$GAG_VERS/integ" || return $?
        gagsou_version_list "$gaghome/gildas-src-*" "integ/$GAG_EXEC_SYSTEM" || return $?
    }
    #
    gagsou_system_list() {
        # $1: pattern for main directory
        found=0
        # List, ordered by time, newest first
        for x in `\ls -d $1/* 2> /dev/null`; do
            if [ ! -d "$x/bin" ]; then
              continue  # cycle loop
            fi
            if [ $found -eq 0 ]; then
                found=1
                gagsou_message "Available systems for $GAG_VERS version in $gaghome:"
            fi
            echo "    "`basename $x`
        done
        if [ $found -eq 0 ]; then
            gagsou_message "No available systems for $GAG_VERS in $gaghome"
        fi
    }
    #
    gagsou_version_list() {
        # $1: pattern for main directory
        # $2: subdirectory searched in matching directories
        found=0
        # List, ordered by time, newest first
        for x in `\ls -dt $1 2> /dev/null`; do
            if [ ! -d "$x/$2" ]; then
              continue  # cycle loop
            fi
            if [ $found -eq 0 ]; then
                found=1
                gagsou_message "Available versions for $GAG_EXEC_SYSTEM in $gaghome:"
            fi
            # Check if $x is a symlink to another version:
            y=`readlink $x`
            # Keep only the version name:
            x=`echo $x | perl -pe "s?$gaghome/gildas-\w+-(\w+).*?\1?"`
            # Feedback, with symlink translation if relevant
            if [ -z "$y" ]; then
                echo "    $x"
            else
                y=`echo $y | perl -pe "s?gildas-\w+-(\w+).*?\1?"`
                echo "    $x -> $y"
            fi
        done
        if [ $found -eq 0 ]; then
            gagsou_message "No GILDAS version for $GAG_EXEC_SYSTEM in $gaghome"
        fi
    }
    #
    gagsou_clean() {
	unset IN_COMPILER IN_CONFIG IN_USE IN_VERSION DEF_VERSION
	unset GAGSOU_AUTHOR GAGSOU_PROJECT GAGSOU_PROGNAME
	unset gagsou_usage gagsou_showversion gagsou_message gagsou_error
	unset gagsou_exe_env_nohome gagsou_src_env_nohome
	unset gagsou_exe_env        gagsou_src_env
	unset gagsou_exe_list       gagsou_src_list
	unset gagsou_system_list    gagsou_version_list
	unset dolist dosource executable
	unset gagsou_clean
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    IN_COMPILER="default" # Default compiler will be setup by gagdefsys
    IN_CONFIG=            # Default config will be setup by gagdefsys
    IN_USE="default"      # Default use-dir is empty
    DEF_VERSION="default" # Default version will be setup by gagdefver
    dolist=0              # Default is not to list the versions
    dosource=1            # Default is to source environment
    executable=1          # Default is to select the executable tree.
    temp=`getopt "hveslmc:o:n:u:d:" "$@"`
    if [ $? -ne 0 ]; then gagsou_usage; return 2; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
	case $1 in
	-c) IN_COMPILER=$2; shift ;;
	-o) IN_CONFIG="$IN_CONFIG -o $2"; shift;;
	-n) IN_CONFIG="$IN_CONFIG -n $2"; shift;;
	-u) IN_USE=$2; shift ;;
	-d) DEF_VERSION=$2; shift ;;
	-e) executable=1 ;;
	-s) executable=0 ;;
	-m) dosource=0 ;;
	-l) dolist=1 ;;
	-v) gagsou_showversion; return 0 ;;
	-h) gagsou_usage; return 0 ;;
	esac
	shift # Next flag
    done
    shift # Skip double dash
    case $# in
	0) IN_VERSION=$DEF_VERSION ;;
	1) IN_VERSION=$1 ;;
	*) gagsou_usage; return 2 ;;
    esac
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    #######################################################################
    #
    # Define gagadmdir
    #
    if [ -d "$gaghome/gildas-admin" ]; then
	gagadmdir=$gaghome/gildas-admin
    elif [ -d "$gagsrcdir/admin" ]; then
	gagadmdir=$gagsrcdir/admin
    else
	gagsou_error "Failed to define \$gagadmdir. Please define it by hand." || return $?
    fi
    export gagadmdir
    #
    # Define system in all cases
    #
    . $gagadmdir/define-system.sh                      # Load gagdefsys function
    if [ $executable -eq 1 ]; then
        gagdefsys -c $IN_COMPILER $IN_CONFIG || return $?  # Use it
    else
        gagdefsys -s -c $IN_COMPILER $IN_CONFIG || return $?  # Use it
    fi
    unset gagdefsys                                    # Remove gagdefsys function
    #
    # Define gagsrcdir, gagexedir and GAG_ROOT_DIR only when gaghome exists.
    # In all cases, try to source the environment.
    #
    if [ -z "$gaghome" ]; then
        #
        # No version definition: assume $gagsrcdir or $gagexedir are already set
	#
	# Setup environment or list
	#
	if [ $dolist -eq 1 ]; then
            gagsou_error "\$gaghome is unset: can not list versions" || return $?
	elif [ $executable -eq 1 ]; then
            gagsou_exe_env_nohome || return $?
	else
            gagsou_src_env_nohome || return $?
	fi
    else
	#
        # Setup environment or list
        #
        . $gagadmdir/define-version.sh  # Load gagdefver function
        gagdefver $IN_VERSION -n || return 1
        unset gagdefver
	if [ $dolist -eq 1 ]; then
            if [ $executable -eq 1 ]; then
                gagsou_exe_list || return 1
            else
                gagsou_src_list || return 1
            fi
	else
            if [ $executable -eq 1 ]; then
                gagsou_exe_env || return $?
            else
                gagsou_src_env || return $?
            fi
        fi
    fi
    #
    #######################################################################
    #
    # Cleaning
    #
    gagsou_clean
}
#
###########################################################################
#
gagsou $@
set abc; shift # This line to avoid remanence effect in a portable way
#
###########################################################################

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "define-version.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gagdefver() {
    #
    # Variable and function definitions
    #
    DEFVER_AUTHOR='J. Pety <pety@iram.fr>'
    DEFVER_PROJECT='GILDAS  <http://www.iram.fr/IRAMFR/GILDAS>'
    DEFVER_PROGNAME='gagdefver'
    DEFVER_REPOSITORY="git@git.iram.fr:scsf/gildas.git"
    DEFVER_MODULE=gildas
    #
    defver_usage() {
	cat <<EOF 1>&2

Define standard directory name conventions used by the "build" and
"source-gag.sh" scripts to enable easy coexistence of different GILDAS
version. To do this, define the following environment variables: 
   GAG_VERS: the Gildas version to be used, e.g. last, month, 31oct,
             nov18, etc...
   GAG_TAG:  the corresponding Git branch or tag, e.g. r18-nov
   SRCDIR:   the corresponding source directory
   EXEDIR:   the corresponding installation directory
   LOGDIR:   the corresponding log directory

usage: source $DEFVER_PROGNAME [version]

options:
  -d     Refine GAG_VERS with tag date if possible
  -n     Do not translate 'day' or 'month' to current day or month, but
         assume that directories (or symlinks to) exist with the input
         version name.
  -h     Show this help page
  -v     Show version information

EOF
	defver_clean
    }
    #
    defver_showversion() {
	echo "$DEFVER_PROGNAME, by $DEFVER_AUTHOR"
	echo "Project: $DEFVER_PROJECT"
	defver_clean
    }
    #
    defver_message() {
	echo "$DEFVER_PROGNAME: $1"
    }
    #
    defver_error() {
	echo 1>&2
	echo "$DEFVER_PROGNAME error: $1" 1>&2
	echo 1>&2
	defver_clean
    }
    #
    defver_clean() {
	unset defver_usage defver_showversion defver_message 
	unset defver_error defver_clean defver_clone
	unset defver_tagdate defver_date
	unset DEFVER_AUTHOR DEFVER_PROGNAME DEFVER_PROJECT
	unset DEFVER_INVERS DEFVER_OUTVERS  DEFVER_OUTTAG
	unset DEFVER_MODULE DEFVER_REPOSITORY
    }
    #
    defver_clone() {
        #
        # * Clone the repository in a temporary directory (env var $tmpdir
        #   is set in return). It is the responsibility of the caller to
        #   destroy this directory when it's done.
        # * Clone the branch named as argument. We perform here a
        #   MINIMALISTIC clone (as we are interested only in the latest
        #   change in a given branch):
        #     - only a bare repo (no need to checkout the files),
        #     - only single branch,
        #     - only last commit in this branch.
        #     - discard tags.
        # * In return the current working directory is the root of the
        #   cloned sources.
        #
        tmpdir=/tmp/$DEFVER_MODULE-$$
        mkdir -p $tmpdir
        \cd $tmpdir
        #
        git clone \
          --bare \
          --branch $1 --single-branch \
          --depth 1 \
          --no-tags \
          $DEFVER_REPOSITORY $DEFVER_MODULE 2> /dev/null || \
          defver_error "cloning branch '$1' from GIT"
        \cd $DEFVER_MODULE
        #
        export tmpdir
        #
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    temp=`getopt "dnhv" "$@"`
    if [ $? -ne 0 ]; then defver_usage; return 2; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
	case $1 in
	-d) defver_date=1 ;;
	-n) defver_not=1 ;;
	-v) defver_showversion; return 0 ;;
	-h) defver_usage; return 0 ;;
	esac
	shift # Next flag
    done
    shift # Skip double dash
    case $# in
	0) DEFVER_INVERS="default";; # Default version defined below!
	1) DEFVER_INVERS=$1;;
	*) defver_usage;  return 2 ;;
    esac
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    #######################################################################
    #
    # 'day' is an alias for the current day. $GAG_VERS has the form 'ddmmm'
    #
    # 'month' is an alias for the current month. $GAG_VERS has the form
    # 'mmmyy', $GAG_TAG has the form 'ryy-mmm'.
    #
    # 'dev' is equivalent to main trunk.
    #
    case $DEFVER_INVERS in
	day)     if [ "$defver_not" ]; then
                      DEFVER_OUTVERS=$DEFVER_INVERS;
                 else
                      DEFVER_OUTVERS=`date '+%d%b' | tr '[:upper:]' '[:lower:]'`;
                 fi;
                 DEFVER_OUTTAG=$DEFVER_INVERS ;;

	month)   if [ "$defver_not" ]; then
                      DEFVER_OUTVERS=$DEFVER_INVERS;
                 else
                      DEFVER_OUTVERS=`date '+%b%y' | tr '[:upper:]' '[:lower:]'`;
                 fi;
                 DEFVER_OUTTAG=`date '+r%y-%b' | tr '[:upper:]' '[:lower:]'` ;;

        dev)     DEFVER_OUTVERS="dev";
                 DEFVER_OUTTAG="master" ;;

        default) DEFVER_OUTVERS="last";
                 DEFVER_OUTTAG="last" ;;

        *)       if echo $DEFVER_INVERS | grep -q '^[a-z][a-z][a-z][0-9][0-9]$' ; then
                      # Parse e.g. "nov19" as "r19-nov": this adds support for
                      # monthly releases other than current month one.
                      myyear=`echo $DEFVER_INVERS | sed 's/[a-z][a-z][a-z]//'`;
                      mymonth=`echo $DEFVER_INVERS | sed 's/[0-9][0-9]//'`;
                      DEFVER_OUTVERS=$DEFVER_INVERS;
                      DEFVER_OUTTAG="r$myyear-$mymonth";
                      unset myyear mymonth
                 else
                      DEFVER_OUTVERS=$DEFVER_INVERS;
                      DEFVER_OUTTAG=$DEFVER_INVERS;
                 fi
    esac
    #
    #######################################################################
    #
    # Define $GAG_TAG.
    #
    export GAG_TAG=$DEFVER_OUTTAG
    #
    #######################################################################
    #
    # Define $GAG_VERS. Refine GAG_VERS with tag date when asked and
    # possible.
    #
    GAG_VERS=$DEFVER_OUTVERS
    if [ "$defver_date" ]; then
	# Can refine date only if branch already exists!
	if git ls-remote --heads --exit-code $DEFVER_REPOSITORY $GAG_TAG > /dev/null; then
	    curdir="$PWD"
	    defver_clone $GAG_TAG
	    defver_tagdate=`git log -1 --format=%ct $GAG_TAG`  # UNIX timestamp
	    # date -d is not portable: try GNU syntax, else BSD syntax
	    defver_date=$(date -d "@$defver_tagdate" "+%d%b%y %H:%M %Z" 2> /dev/null) || \
	    defver_date=$(date -j -f "%s" $defver_tagdate "+%d%b%y %H:%M %Z" )
	    defver_date=`echo $defver_date | tr '[:upper:]' '[:lower:]'`
	    GAG_VERS="${GAG_VERS} (${defver_date})"
	    \cd $curdir
	    \rm -rf $tmpdir
	    unset tmpdir
	fi
    fi
    export GAG_VERS
    #
    #######################################################################
    #
    if [ -z "$gaghome" ]; then
	gaghome=$HOME/gildas
    fi
    export gaghome
    #
    #######################################################################
    #
    SRCDIR=$gaghome/gildas-src-$DEFVER_OUTVERS
    EXEDIR=$gaghome/gildas-exe-$DEFVER_OUTVERS
    LOGDIR=$gaghome/logs/$DEFVER_OUTVERS
    export SRCDIR EXEDIR LOGDIR
    #
    #######################################################################
    #
    defver_clean
}
#
###########################################################################

# Installation Guidelines

## Table of contents

- [I - RELEASE NOTES](#i---release-notes)
- [II - DOWNLOAD](#ii---download)
  - [1 - Sources from homepage](#1---sources-from-gildas-homepage)
  - [2 - Sources from GIT repository](#2---sources-from-git-repository)
  - [3 - Documentation from homepage](#3---documentation-from-gildas-homepage)
- [III - REQUIREMENTS](#iii---requirements)
  - [1 - Supported systems](#1---supported-systems)
  - [2 - Material](#2---material)
  - [3 - Tools to build executables](#3---needed-tools-to-build-executables-from-sources)
  - [4 - Tools to build documentation](#4---needed-tools-to-build-the-documentation)
- [IV - INSTALL UNDER MACOS](#iv---install-under-macos)
  - [1 - Prerequisites](#1---prerequisites)
  - [2 - MacPorts package](#2---macports-package)
  - [3 - Installation from sources](#3---installation-from-sources)
  - [4 - Troubleshooting](#4---troubleshooting)
- [V - INSTALL UNDER LINUX](#v---install-under-linux)
  - [1 - Dependencies](#1---dependencies)
  - [2 - Compile and install (binaries)](#2---compile-and-install-binaries)
  - [3 - Post-installation (binaries)](#3---post-installation-binaries)
  - [4 - Compile/install documentation](#4---compile-andor-install-documentation)
  - [5 - Troubleshooting](#5---troubleshooting)
- [VI - INSTALL UNDER MS WINDOWS](#vi---install-under-ms-windows)
- [VII - UNINSTALL](#vii---uninstall)
  - [1 - Under Linux](#1---under-linux)
  - [2 - Under MacPorts](#2---under-macports)

---

## I - RELEASE NOTES

Release notes are available in NEWS.md

## II - DOWNLOAD

### 1 - Sources from GILDAS homepage

Linux/OSX versions of GILDAS are distributed only as sources because
binaries are not portable (due to the many different possible
combinations of processors, operating system and compilers). Fetch
the sources from the [download area](https://www.iram.fr/~gildas/dist/).
You have to pick a tarball named `gildas-src-mmmyyv.tar.xz`. Some
hints:

- **VERSION**: the basic rule to pick up a release is to download and
  install the latest monthly release available in this area. Daily
  releases are there just as a convenience for beta testers. We
  strongly discourage standard users to get them.
- **LABELLING**: the suffix `a`, `b`, `c` and so on indicates that an
  important bug fix or feature has been added during the month and
  this could not wait for the new release at the beginning of next
  month. Such new releases include only these modifications, and not
  all the on-going developments. Check the NEWS section for details on
  the augmented release.
- **STABILITY**: Developers usually stabilize (if needed) Gildas before
  each release. Nevertheless, some developments take time and in such a
  case monthly releases may be skipped. From time to time some releases
  are suffixed `beta`: this indicates that important developments were
  done and this version is a candidate for a stable release. It is
  "stable as far as we know", but not tested enough.
- **REFERENCE VERSION**: Finally, the may25 release (May 2025) is a
  particular version used at the telescopes. If a newer version is
  available, standard users should not install the may25 one, unless
  they have been told to. There are bug fixes, improvements, and
  features which have been added in the latest releases, but which
  won't be in the may25 release because they do not affect the
  operations at the telescopes.

### 2 - Sources from GIT repository

Get the last monthly version from the
[public GIT repository](https://git.iram.fr/gildas/gildas):

```
git clone \
  -b ryy-mmm https://git.iram.fr/gildas/gildas.git gildas-src-mmmyy
```

This command creates the sources of GILDAS in a new
`gildas-src-mmmyy` directory. The `-b ryy-mmm` switch enables you to
choose the monthly release you need. Be careful, you here need only the
3 first letters of the current month and the last two digits of the
current year. No letter is required: you will automatically end up with
the last bug fix of this monthly release.

In practice, if you want to fetch the December 2022 sources, just
type:

```
git clone \
  -b r22-dec https://git.iram.fr/gildas/gildas.git gildas-src-dec22
```

It is also possible to update this clone at any moment:

```
cd gildas-src-dec22
git pull  # Fetch the last commits in the current branch
```

If new monthly versions have been released, you should be able to check
them out after `git pull`, e.g.

```
git checkout r23-jan  # Fetch January 2023 release
```

Do not forget to completely clean and rebuild GILDAS after an update
(`make distclean && make`).

### 3 - Documentation from GILDAS homepage

Compiled documentation are also distributed as tarballs in the
[download area](https://www.iram.fr/~gildas/dist/). You have to
pick a tarball named `gildas-doc-mmmyy.tar.xz`.

## III - REQUIREMENTS

### 1 - Supported systems

GILDAS compiles successfully and is (at least minimally) tested on:

| Processor             | Operating system | Environment |
| --------------------- | ---------------- | ----------- |
| x86_64                | Linux            | Native      |
| x86_64 (Intel)        | macOS            | Native      |
| x86_64 (Intel)        | macOS            | MacPorts    |
| arm64 (Apple Silicon) | macOS            | Native      |
| arm64 (Apple Silicon) | macOS            | MacPorts    |

The reference system at IRAM is Debian 12 (x86_64) with Intel Fortran
2021 and gfortran 12.2.0.

### 2 - Material

- Building the GILDAS binaries under Linux or Mac OSX requires about
  300 MB of temporary disk space (compilation) and 100 MB of permanent
  disk space (installation).
- The gfortran compiler might require up to 5-6 GB of RAM when compiling
  GILDAS sources. At run time, GILDAS executables require about 1 MB at
  startup, but then consume as much memory as data created or loaded in
  memory.

### 3 - Needed tools to build executables from sources

Successful building of GILDAS binaries on a UNIX/Linux/OSX system
minimally requires:

- Bourne compatible shell (sh, ksh, bash, etc...) for build purpose
  only. The end-users can then use the GILDAS programs from csh-like or
  Bourne-like shells.
- NROFF for on-line help building.
- Perl for automatic interface extraction during compilation process.
- A C compiler (either GCC or the native C compiler).
- GNU make:
  The current building system is using the GNU make facility which has
  some desirable but non-portable features (i.e. including makefiles,
  conditions). This does not seem a strong limitation as it is easy to
  install GNU make for your system. In fact, GNU make is the default
  for linux boxes. For others OS, just try to type `gmake` instead of
  `make`: it is probably already installed.
- A FORTRAN 90/95/2003/2008/2013 compiler:
  Latest GNU Fortran (gfortran >= 9.0) and Intel Fortran Compiler
  (ifort > 11.1) are supported.
- GTK >= 3.24 development tools for graphic and widget support. GTK2
  support is obsolescent.
- Python >= 3.6 and its array module Numpy if you plan to use the
  Gildas-Python binding, including the Weeds package in CLASS.
- CFITSIO if you plan to use MRTCAL or CUBE.

### 4 - Needed tools to build the documentation

Successful building of PDF/HTML documentation minimally requires recent
versions of:

- ps2epsi
- epstopdf
- latex (version 2e with makeidx, graphicx and html package)
- latex2html
- pdflatex

For your convenience, we distribute compiled PDF/HTML documentation in
case you do not have those tools. See the distribution section of the
GILDAS web page:

`https://www.iram.fr/~gildas/dist/`

## IV - INSTALL UNDER MACOS

Gildas and its dependencies can be installed as a
[MacPorts](https://ports.macports.org/port/gildas/) package.

### 1 - Prerequisites

Both installation methods 2 and 3 below require the installation of:

- Xcode, needed by MacPorts. Get it from
  https://developer.apple.com/xcode/ with an Apple identifier (more
  than 1 GB to be downloaded from the app store). See e.g. the Xcode
  installation guidelines suited for MacPorts at
  www.macports.org/install.php
- Xquartz, needed for Gildas plots (www.xquartz.org). XQuartz is
  successfully installed if the command `xclock` is available and opens
  a clock in a small graphical window. If not, start Xquartz from
  Applications > Utilities > XQuartz.
- [MacPorts](https://www.macports.org), a package manager, is needed to
  retrieve and install transparently Gildas and its dependencies.
  Follow MacPorts
  [installation guidelines](https://www.macports.org/install.php).
  MacPorts is successfully installed when e.g. the command `port help`
  is available.

### 2 - MacPorts package

Gildas is available as a standard package in the MacPorts distribution.
Unless you are an advanced user (see below: Installation from sources),
this is the recommended way to install Gildas under Mac OS. Once
MacPorts and XQuartz are installed, Gildas installation is
straightforward. Type:

```
sudo port install gildas
```

The parallelization is enabled by default. The Gildas programs are
ready to use right after (type e.g. `greg` in a terminal prompt).
Usually the package is updated a few days after a source release (every
month), so that the latest enhancements or bug fixes in Gildas are
quickly available to Mac users. Updating to the newest release is done
with the command:

```
sudo port upgrade gildas
```

You might need to update MacPorts itself first:

```
sudo port selfupdate
```

### 3 - Installation from sources

As an alternate solution, it is possible to compile Gildas by yourself.
You have to use MacPorts to install first the Gildas dependencies.

- Installing the dependencies:

```
sudo port install gcc14
sudo port select gcc # show available arguments
sudo port select gcc mp-gcc14  # Choose the desired one
sudo port install gtk3
sudo port install pkgconfig
sudo port install groff
```

- CFITSIO is needed for CUBE (position-position-velocity cube analysis)
  and MRTCAL (the 30m calibration software). Have a look at:

```
sudo port variants cfitsio
```

Then install the correct "variant" e.g.

```
sudo port install cfitsio +gcc14
```

- Finally you can follow the standard Linux steps to compile Gildas
  from the sources (see below).

### 4 - Troubleshooting

- If you have problem with rsync when running `sudo port selfupdate`,
  you can modify the file
  `/opt/local/etc/macports/sources.conf` by replacing the line:

```
rsync://rsync.macports.org/release/ports/ [default]
```

with:

```
#rsync://rsync.macports.org/release/ports/ [default]
https://www.macports.org/files/ports.tar.gz [default]
```

and run `sudo port sync` instead of `sudo port selfupdate`.

```
sudo port install gcc14
sudo port install gtk3
sudo port select gcc # show available arguments
sudo port select gcc mp-gcc14
```

- Mac OSX 10.7 (Lion) users: if possible, try to avoid to install
  Python from MacPorts. If installed, you might experience this bug
  when the Gildas-Python binding is started at runtime. If so, you
  should configure your system to prefer the Apple-Python rather than
  the MacPorts-Python:

```
port select python python27-apple
```

However, note that this may break other Python-related applications
installed with MacPorts.

- If the Gildas installation fails and the log file shows the
  following error:

```
:info:build FATAL:/opt/local/bin/../libexec/as/x86_64/as:
I don't understand 'm' flag!
```

This problem is described here:
https://trac.macports.org/ticket/56919
In short, the assembler program (`as`) which is used is not the correct
one. Type:

```
sudo port install cctools +xcode
```

to switch to the correct version. Then you can resume the Gildas
installation.

- If the Gildas installation fails and the log file shows the
  following error:

```
:info:build ld: unexpected token: !tapi-tbd-v3 file
'/System/Library/Frameworks//CoreFoundation.framework/CoreFoundation.tbd'
for architecture x86_64
```

This problem is described here:
http://mac-os-forge.2317878.n4.nabble.com/linker-errors-ld-unexpected-token-tapi-tbd-v3-file-td363061.html#a363073
In short, you should type:

```
sudo port install ld64 +ld64_xcode
```

Then you should retry Gildas installation. You should clean the
previous attempt first:

```
sudo port clean gildas
```

Then proceed:

```
sudo port install gildas + any option if needed
```

- If the program won't open any graphical window and shows this
  warning instead:

```
Gtk-WARNING **: xx:xx:xx.xxx: cannot open display
```

check that XQuartz server is installed and running (see Prerequisites
section above).

- If you observe this message when opening a Gildas program, please
  see the same TROUBLESHOOTING section for Linux:

```
Gtk-WARNING **: Locale not supported by C library.
                Using the fallback 'C' locale.
```

- GREG hardcopies to PDF are ensured through system utilities ps2pdf
  and epstopdf. They can be installed thanks to the following ports:

```
sudo port install texlive-basic      # provides ps2pdf
sudo port install texlive-fontutils  # provides epstopdf
```

## V - INSTALL UNDER LINUX

### 1 - Dependencies

Linux version of GILDAS are distributed only as sources because binaries
are not portable (due to the many different possible combinations of
processors, operating system and compilers). We thus tried to ease
building as much as possible.

In addition to the standard developer tools (make, gcc, nroff, etc),
the following dependencies must be installed. Root privileges are
required here.

- Fedora 42 (or redhat-like distributions):
  - Required: `dnf install gcc-gfortran gcc-c++ gtk3-devel`
  - Recommended:
    `dnf install python-devel python-setuptools numpy \
                 libpng-devel cfitsio-devel openssl-devel \
                 texlive-epstopdf`
  - Optional: `dnf install fftw-devel`
  - Install: follow installation steps at paragraph 2

- Ubuntu 24.04 (or debian-like distributions):
  - Required: `sudo apt install gfortran g++ libgtk3.0-dev`
  - Recommended:
    `sudo apt install python3-dev python3-numpy python3-setuptools \
                     libcfitsio-dev libssl-dev texlive-font-utils`
    If you choose to install the package `python-is-python3` for your
    convenience, you have to install `python-dev-is-python3` for
    consistency.
  - Optional: `sudo apt install libfftw3-dev`
  - Install: follow installation steps at paragraph 2

### 2 - Compile and install (binaries)

Building the binaries should just need the following sequence of
commands. Gildas itself does not need root privileges for installation
and execution: it can be unzipped anywhere and installed by any user
for its own needs.

```
unxz gildas-src-mmmyya.tar.xz
tar -xf gildas-src-mmmyya.tar
```

or even simpler, let tar uncompress the archive by itself (automatic
detection from the file extension):

```
tar -xf gildas-src-mmmyya.tar.xz
cd gildas-src-mmmyya
```

At this stage, if you are not under a sh-compatible shell, you have to
switch to e.g. bash. Then load the compilation environment:

```
source admin/gildas-env.sh
```

You can optionally add the compiler to be used with the option `-c`
(e.g. `source admin/gildas-env.sh -c gfortran`). Read carefully the
messages and warnings returned by the command. If everything seem
correct, then compile and install Gildas:

```
make
make install
```

Finally, follow the instructions at the end of the `make install`
process. Installation is successful if you can start the programs
`greg` or `class` from a new terminal.

### 3 - Post-installation (binaries)

After the installation is successful, you can optionally remove the
sources and compilation directory (`gildas-src-mmmyy`). This is useful
only to save disk space. On the other hand, this means that in case of
update (e.g. for GIT-based downloads) you will have to recompile
everything again from scratch.

### 4 - Compile and/or install (documentation)

- From the tarball archive (easiest):

```
mv gildas-doc-mmmyya.tar.xz gildas-exe-mmmyya/
cd gildas-exe-mmmyya/
tar -xf gildas-doc-mmmyya.tar.xz
```

- Directly from the sources:
  Compilation of documentation is not done by default when compiling
  executables because: i) it requires special tools (see requirements)
  and ii) it takes time.
  To compile and install the PDF documentation, type:

```
make doc
make install-doc
```

To compile and install the HTML documentation, please type:

```
make html
make install-html
```

### 5 - Troubleshooting

- This message can be displayed when starting a Gildas program:

```
Gtk-WARNING **: Locale not supported by C library.
                Using the fallback 'C' locale
```

This is not a GILDAS issue. This means that your locale settings (type
`locale` in a terminal) indicate one or more locales that are not
installed on your system (type `locale -a` in a terminal for the full
list). You should fix your environment variables in order to use an
installed locale (e.g. `export LANG=en_US.utf8`, beware this may change
your programs behavior regarding language), or install the missing
locale(s).

- Conflict with Anaconda: when installed from the downloadable
  installer, Anaconda comes with a lot of development tools and
  libraries which override the default system ones, but not in a
  consistent way. This is proved to break software compilation and/or
  execution (Gildas and others). For example:

```
astro: /home/user/anaconda/lib/libstdc++.so.6: version
       `GLIBCXX_3.4.21' not found (required by /home/user/
       gildas-exe-jan17a/x86_64-ubuntu16.04-gfortran/lib/libatm.so)
```

This happens because Anaconda gives precedence to its own binaries and
include files (duplicate but different versions of system ones) in the
user's environment. There are several ways out of this issue:
  - a) Install Anaconda from your OS repositories (instead of custom
       installation in the user account). This way, there should be a
       correct integration of Anaconda within the OS.
  - b) Keep Anaconda in the user account, but "hide" it during Gildas
       installation and execution. In other words, you have to ensure
       that there is no reference to Anaconda installation paths in the
       environment variables `$PATH` and `$LD_LIBRARY_PATH`. You most
       likely have to edit your `~/.bashrc`. Once this is done recompile,
       install, and try executing Gildas. If it runs fine, a permanent
       solution could be to use a shell function which loads Anaconda
       environment only when needed, e.g.

```
function anaconda() {
    export PATH=...
    export LD_LIBRARY_PATH=...
    anaconda
}
```

  - c) The next time you install Anaconda, you should answer "No" to the
       question: "Do you wish the installer to prepend the
       Anaconda<2 or 3>install location to PATH...?". Then use a function
       like the above example to get it working
       ([reference](https://www.anaconda.com/docs/getting-started/working-with-conda/reference/faq#should-i-add-anaconda-to-the-macos-or-linux-path)).

## VI - INSTALL UNDER MS WINDOWS

MS Windows binaries are not available. If you need to run GILDAS under
a MS Windows computer, you can install a Linux virtual machine and
follow the installation instructions as explained in the previous
section.

## VII - UNINSTALL

### 1 - Under Linux

- Except if you want to save disk space, you have no need to uninstall
  any previous Gildas installation. Each version goes into its own
  `gildas-src-XXX` and `gildas-exe-XXX` directories. The default
  version used is ruled by the environment variable `$GAG_ROOT_DIR`
  that is set in user's `~/.bash_profile`. You can modify it as you
  want to point to the desired version.
- Remember to start a new terminal each time you modify your
  `~/.bash_profile`.
- For a complete uninstall of Gildas, just remove the directories
  `gildas-src-XXX` and `gildas-exe-XXX`, and suppress the lines related
  to Gildas in your `~/.bash_profile`.

### 2 - Under MacPorts

- MacPorts keeps older Gildas versions when you install a new one. At
  some point you might want to clean all the useless versions. You can
  check for all installed version with:

```
sudo port installed gildas
```

You will see a list of versions with a `@` name, e.g.

```
gildas @201808b_0+gcc7
gildas @201808b_0+gcc7+openmp
gildas @201809a_0+gcc7+openmp (active)
```

Uninstalling a single version can be done with e.g.

```
sudo port uninstall gildas @201808b_0+gcc7
```

Uninstalling several versions can be done with:

```
sudo port uninstall gildas
```

Answer at the prompt which versions are to be uninstalled.

- If you wish to completely uninstall MacPorts and Gildas, check
  [the MacPorts recommendations](https://guide.macports.org/chunked/installing.macports.uninstalling.html).

# Credits

## Institutes

GILDAS was initiated in 1983 at the Observatoire de Grenoble. It developed
as a collaboration between IPAG/Grenoble and IRAM. Some contributions were
developed by additional partners (LAB/Bordeaux and Obs. de Paris). Today,
the developments and maintenance is ensured by IRAM. ATM is developed and
maintained by IFF-CSIC.

Contributions from, and discussions with all GILDAS users are gratefully
acknowledged.

## Acknowledgment in publications

The GILDAS team welcomes an acknowledgment in publications using GILDAS
software to reduce and/or analyze data. Please use the
`https://www.iram.fr/IRAMFR/GILDAS/` and `https://ascl.net/1305.010`
references.

## Developers

- Infrastructure (building, distribution):
  - In charge:              S. Bardeau (IRAM)
  - Active developers:      J. Pety (IRAM/Obs. de Paris)
  - Main past contributors: E. Reynier (IRAM)

- Kernel (SIC and GREG):
  - In charge:              S. Bardeau (IRAM)
  - Active developers:      J. Pety (IRAM/Obs. de Paris)
  - Main past contributors: F. Badia, D. Broguière, G. Buisson, G. Duvert,
                            T. Forveille, R. Gras, S. Guilloteau, R. Lucas,
                            G. Mella, E. Reynier, P. Valiron

- CUBE:
  - In charge:              J. Pety (IRAM/Obs. de Paris), S. Bardeau (IRAM)
  - Main past contributors: V.deSouzaMagalhaes

- ASTRO:
  - In charge:              J. Boissier (IRAM)
  - Active developers:      J. Pety (IRAM/Obs. de Paris)
  - Main past contributors: G. Duvert, F. Gueth, S. Guilloteau, R. Lucas,
                            J.-M. Winters

- TELCAL:
  - In charge:              J. Pety (IRAM/Obs. de Paris)
  - Active developers:      S. Bardeau (IRAM)
  - Main past contributors: S. Guilloteau (LAB), H. Wiesemeyer (IRAM)

- MRTCAL:
  - In charge:              J. Pety (IRAM/Obs. de Paris)
  - Active developers:      S. Bardeau (IRAM), A. Sievers (IRAM)

- CLASS:
  - In charge:              S. Bardeau (IRAM)
  - Active developers:      J. Pety (IRAM/Obs. de Paris)
  - Main past contributors: B. Delforge, T. Forveille, S. Guilloteau
                            P. Hily-Blant, R. Lucas

- PIIC:
  - In charge:              S. Berta (IRAM)
  - Main past contributors: R. Zylka

- CLIC:
  - In charge:              V. Piétu (IRAM)
  - Main past contributors: F. Gueth, R. Lucas, R. Moreno, J.-M. Winters

- NOEMA science pipeline:
  - In charge:              A. Castro-Carrizo (IRAM)
  - Active developers:      R. Neri (IRAM), F. Alves (IRAM)
  - Main past contributors: S. Martin, V. Arumugam

- MAPPING:
  - In charge:              J. Pety (IRAM/Obs. de Paris)
  - Active developers:      S. Bardeau (IRAM)
  - Main past contributors: K. Bouyoucef, L. Desbats, F. Gueth, S. Guilloteau,
                            R. Lucas, N. Rodriguez-Fernandez, V.deSouzaMagalhaes

- MIRA:
  - In charge:              A. Sievers (IRAM)
  - Main past contributors: H. Wiesemeyer
